OpenMolcas
==========

OpenMolcas is a quantum chemistry software package developed by scientists
and intended to be used by scientists. It includes programs to apply many
different electronic structure methods to chemical systems, but its key
feature is the multiconfigurational approach, with methods like CASSCF and
CASPT2.

OpenMolcas is not a fork or reimplementation of
[Molcas](http://www.molcas.org), it *is* a large part of the Molcas codebase
that has been released as free and open-source software (FOSS) under the Lesser
General Public License (LGPL). Some parts of Molcas remain under a different
license by decision of their authors (or impossibility to reach them), and are
therefore not included in OpenMolcas.

**Latest references**:

* "OpenMolcas: From Source Code to Insight."
  *J. Chem. Theory Comput.* **15** (2019) 5925-5964.
  [doi:10.1021/acs.jctc.9b00532](https://doi.org/10.1021/acs.jctc.9b00532)

* "Modern quantum chemistry with [Open]Molcas."
  *J. Chem. Phys.* **152** (2020) 214117.
  [doi:10.1063/5.0004835](https://doi.org/10.1063/5.0004835)

Installation
------------

For more detailed information, please refer to the [wiki
pages](/../wikis/home).

OpenMolcas is configured with [CMake](https://cmake.org). A quick way to get it
up and running is the following:

1.  Clone the repository:

    ```
    git clone https://gitlab.com/Molcas/OpenMolcas.git
    ```

2.  Get the `lapack` submodule (only needed if you don't use another linear
    algebra library like MKL or OpenBLAS):

    ```
    cd OpenMolcas
    git submodule update --init External/lapack
    cd ..
    ```

3.  Create a new directory and run `cmake` from it:

    ```
    mkdir build
    cd build
    cmake ../OpenMolcas
    ```

4.  Compile with `make`:

    ```
    make
    ```

5.  Run the verification suite (failures in "grayzone" tests are expected):

    ```
    pymolcas verify
    ```

For running other calculations you should define the `MOLCAS` environment
variable to point to the `build` directory. Run `pymolcas --help` to see the
available options of the script. In particular it is recommended to run:
```
pymolcas -setup
```
for your first installation.

Documentation
-------------

The documentation can be found in the
[`doc`](https://gitlab.com/Molcas/OpenMolcas/tree/master/doc) directory, you
can read it in [HTML format](https://molcas.gitlab.io/OpenMolcas/sphinx/) or
[PDF format](https://molcas.gitlab.io/OpenMolcas/Manual.pdf). Note that most
of it precedes the creation of OpenMolcas and it is probably outdated in
several points. It may also mention features not available in OpenMolcas.

Help
----

OpenMolcas is a community-supported software and as such it doesn't have an
official technical support. If you have any problems or questions, you can use
the [Issues](/../issues) page or the [Molcas
forum](https://cobalt.itc.univie.ac.at/molcasforum/index.php), and hopefully
some other user or developer will be able to help you.

If you need technical support, you can acquire a [Molcas
license](http://www.molcas.org/order.html).

Contributing
------------

Since OpenMolcas is FOSS, you can download it, modify it and distribute it
freely (according to the terms of the LGPL). If you would like your
contributions to be included in the main repository, please contact one of the
developers, write a message in the
[forum](https://cobalt.itc.univie.ac.at/molcasforum/index.php) or submit a
[merge request](https://docs.gitlab.com/ee/gitlab-basics/README.html). We are
currently only accepting [Molcas
developers](http://www.molcas.org/cgi-bin/dev.plx) as members of the `Molcas`
group, but everyone is welcome to send patches, suggestions and bug reports. 

This directory contains different pieces of documentation.

The main part is the OpenMolcas documentation in
[reStructuredText](http://docutils.sourceforge.net/rst.html) markup format.
HTML and PDF versions can be generated with
[Sphinx](http://www.sphinx-doc.org). Note that most of this precedes the
creation of OpenMolcas and it is probably outdated in several points. It may
also mention features not available in OpenMolcas.

The `.rst` files contain embedded blocks that are used to generate command-line
help (accessed with `pymolcas help_doc`) and an XML input description for
MolGUI. These blocks use the `.. xmldoc::` directive and follow a format
described
[here](https://gitlab.com/Molcas/OpenMolcas/wikis/xml%20syntax%20documentation).

To build the documentation, after configuring OpenMolcas with `cmake`, run
`make doc_html` or `make doc_pdf`.

In addition, some subdirectories have other content:

`doxygen`

Configuration and auxiliary files to generate source code documentation with
[Doxygen](http://www.doxygen.org/). The documentation itself, where it exists,
is included in the source files.

To build the doxygen documentation just run `doxygen` inside this directory.

********************************************************************************
*                                                                              *
*                              Property utilities                              *
*                                                                              *
********************************************************************************

This directory contains utility routines for properties of various kinds. The
routines are named in a style resembling the linpack conventions: the first
letter denote the data type the routine process:

o i -- integer data type
o s -- real*4 data type
o d -- real*8 data type
o c -- complex*4 data type
o z -- complex*8 data type

The routines come in in two versions, one with a minimum of parameters and a
default behavior, one with return code and options added to the parameter list.
The latter is denoted with the letter x after the first type character, for
example dNuclearMass and dxNuclearMass do the same work but the latter gives
more control to the user.

--------------------------------------------------------------------------------

Real*8 Function dNuclearMass(Z,A)
Real*8 Function dxNuclearMass(Z,A,Rc,Opt)

This routine returns the nuclear mass of a given isotope number.

Parameters:
Z   - Integer, input. The charge of the nucleus, i.e. the number of protons.
A   - Integer, input. The mass number of the nucleus, i.e. the number of protons
      plus the number of neutrons.
Rc  - Integer, output. The return code. This is zero if successful and nonzero if
      not.
Opt - Integer, input. Options switch to modify the default behavior. Option 0
      (zero) gives default behavior.

This routine returns the nuclear mass of a given isotope number. The mass
is returned in atomic units (electron masses), not atomic mass units (1/12*C12
masses). Most isotopes have their masses tabulated, but a few exotic are not
due to lack of experimental data or other reasons. For such isotopes, the
semi-empirical mass formula is used and a warning is printed.

--------------------------------------------------------------------------------

Integer Function iMostAbundantIsotope(Z)
Integer Function ixMostAbundantIsotope(Z,Rc,Opt)

This routine returns the mass number of the most abundant isotope for a given
nuclear charge.

Parameters:
Z   - Integer, input. The charge of the nucleus, i.e. the number of protons.
Rc  - Integer, output. The return code. This is zero if successful and nonzero if
      not.
Opt - Integer, input. Options switch to modify the default behavior. Option 0
      (zero) gives default behavior.

This routine returns the mass number (number of protons plus neutrons) of the
most abundant isotope for a given nuclear charge. In the case of radioactive
isotopes with no natural occurance the most stable isotope is returned.

--------------------------------------------------------------------------------

Integer Function iNuclearChargeFromSymbol(Symbol)
Integer Function ixNuclearChargeFromSymbol(Symbol,Rc,Opt)

This routine returns the nuclear charge of an atom corresponding to the
chemical symbol.

Parameters:
Symbol - Character*(*), input. The chemical symbol of the atom for which you
         want the nuclear charge, 'H', 'He', 'Li', ...
Rc     - Integer, output. The return code. This is zero if successful and nonzero
         if not.
Opt    - Integer, input. Options switch to modify the default behavior. Option
         0 (zero) gives default behavior.

This routine returns the nuclear charge of an atom corresponding to the
chemical symbol. The case of the chemical symbol does not matter, 'He', 'he',
'HE' and 'hE' all return charge 2. All symbols up to 'Og' (118) are tabulated.

--------------------------------------------------------------------------------

This Molcas utility adds HDF5 functionality to Molcas.  In short, it
provides a runfile-like functionality, but for any number of files
(several HDF5 files can be active at the same time) and without the
need to pre-define the data that is in there.

This readme is intended to give a quick overview of the functionality
and reasons to use this library, but for the full information on HDF5
you can look here:

  https://www.hdfgroup.org/HDF5/


What exactly is HDF5?

HDF5 stands for Hierarchical Data Format, and is a format used to
store data in binary format in a portable way. The HDF5 library
provides I/O functionality for dealing with HDF5 files, and provides a
set of APIs for multiple programming languages. The library also comes
with several tools for manipulating and viewing the data.

Why choose HDF5?

The properties I was looking for were portability (being able to copy
binary files to any machine and use them with Molcas) and ease of
accessing the data from outside Molcas. The other candidate was
NetCDF, but since they have HDF5 anyway as a dependency, I chose to go
with the least amount of extra dependencies.

HDF5 has a Fortran 90 API, why not use those?

The Fortran 90 API for HDF5 has one big problem: it relies on the use
of Fortran modules. This means that in practice, a user would have to
compile the HDF5 library themselves with the same compiler (and
version) as they use for Molcas. Even on my own laptop, where HDF5
comes preinstalled, the package had been compiled with a slightly
older version of gfortran and resulted in a problem with the modules.

The general advice is to not use Fortran modules for external libraries,
but people at HDF5 apparently didn't know or bother with this. Even though
I found that on the computer clusters I used, HDF5 is compiled for each
available Fortran compiler, the need for maximum portability to user's
computers made me decide to use the C API, and write only Fortran wrappers
for the convenience functions used in Molcas

# GA4GUGA

A genetic algorithm (GA) for finding optimal orbital orderings that yield
compact wave function representations in GUGA bases.  The code reads an FCIDUMP
file, performs a GA simulation using diagonal-element information, and writes a
reordered FCIDUMP file using the best ordering found.  For details of the
algorithm, please see Section 2 of Reference [1].

## Quick Start

You can either directly execute `ga_driver.py` with input arguments, e.g.
```
# This is equivalent to `20site_Heisenberg_chain.py`.
ga_driver.py \
  --fcidump $path_to_extrafiles/FCIDUMP_20site_Heisenberg \
  --norb 20 \
  --fitness DIAG_ELEM_SMS_MAPPING \
  --sms-ref-csf "[1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2,1,2]" \
  --num-chroms 100 \
  --elite-size 10 \
  --mutation-rates "[0.01]" \
  --generations 1000 \
  --restricted-ordering-len 20 \
  --minimize
```
or install the package with `pip` (see **Installation** below).

Once installed, you can import the package with `import GA_mod.run_GA as ga`.
Then, a GA simulation can be performed with `ga.perform_GA`.
Example GA scripts are located in the `examples/` directory.
During the course of a GA simulation, the latest population (set of orderings)
are stored in `current_pop.log`.
Below is a brief description of each:

- `fast_20site_Heisenberg_chain.py`<br/>
    This example runs a GA simulation for a 20-site NN Heisenberg chain
    (Subsection 4.1 of Reference [1]) using the simplified fitness function
    with the S-Ms mapping. Only ordering-dependent terms of the CSF energy
    are evaluated for fitness measure.

- `20site_Heisenberg_chain.py`<br/>
    This example is the same as `fast_20site_Heisenberg_chain`, but evaluates
    the full CSF energies, thus slower than `fast_20site_Heisenberg_chain`.

- `P-cluster_48i40.py`<br/>
    This example runs a GA simulation for the CAS(48e,40o) P-cluster consisting
    of 8 Fe sites (Subsection 5.2.1 of Reference [1]). The fitness function 
    evaluates the CSF energives over the 14 collinear VVS CSFs and maximizes the
    highest and the lowest CSF energies.

- `restart.py`<br/>
    This example runs a GA simulation starting from `NN_Heisenberg_20chain.pop`.

### Checkpoint feature

```bash
touch WRITE_CHECKPOINT
```

During a GA run, creating this file triggers writing an FCIDUMP file with the
current best ordering.

## Installation

```bash
cd GA4GUGA
pip install -e .
```

This installs the package in editable mode.

### Verify installation

```bash
python test_installation.py
```


## Fitness Functions

**GA4GUGA** supports fitness functions using CSF energies of various CSFs (see
Section 3 of Reference [1] for details) and using only S-Ms consistent CSF
energies (Subsection 3.1 of Reference [1]).

-  `MIN_MAX_DIFF`<br/>
    Maximizes the difference between the highest and the lowest CSF energies
    of a given set of CSFs.

-  `MAX_DIAG_ELEM`<br/>
    Maximizes the highest CSF energies of a given set of CSFs.

-  `MIN_DIAG_ELEM`<br/>
    Minimizes the lowest CSF energies of a given set of CSFs.

-  `DIAG_ELEM_SMS_MAPPING`<br/>
    Maximizes or minimizes (depending on the option) the energy of the S-Ms
    consistent CSF.

-  `FAST_DIAG_MIN_OSONLY`<br/>
    Minimizes the energy of the S-Ms consistent CSF, but only evaluates ordering
    -dependent terms in the CSF energy evaluation, thus faster than
    `DIAG_ELEM_SMS_MAPPING`.

## Input arguments

Arguments for the `run_GA.ga.perform_GA` funtion are listed below.
CSFs are assumed to be in the step-vector notation where $0$, $1$, $2$, and $3$
represent empty, increasing intermediate spin by 1/2, decreasing by 1/2,
and doubly occupied orbital couplings, respectively.

### Required arguments

- **fitness_function** `measure_fitness.FitnessFunction.FITNESS_FUNCTION_NAME`<br/>
    Chooses the fitness function for the GA simulation.
    Fitness functions are implemented in `GA_mod.measure_fitness.FitnessFunction`.

- **co_function** `crossover.CO_FUNCTION_NAME`<br/>
    Chooses the crossover operator for the GA simulation.
    Crossover operators are defined in `GA_mod.crossover`
    `order_co` is the order crossover operator.

- **num_chroms** $n$(int)<br/>
    Population size (number of chromosomes).

- **elite_size** $n$(int)<br/>
    Number of elite chromosomes retained each generation.

- **mutation_rates** $mlist$(list[float])<br/>
    A list of mutation rates. If multiple rates are provided, the algorithm can
    cycle through them when progress stalls. Even if a single mutation rate is
    provided, it has to be in list format (e.g., `[0.001]`).

- **restricted_ordering_len** $n$(int)<br/>
    Length of the effective (restricted) ordering that the GA optimizes before
    expansion (see **Restricting orderings** below for ordering expansion).

- **generations** $n$(int)<br/>
    Number of generations to run.

- **fcidump** `PATH_TO_FCIDUMP`<br/>
    Path to the source FCIDUMP file.

- **norb** $n$(int)<br/>
    Total number of orbitals. Must satisfy the consistency check:
    `norb = num_prefix + num_suffix + restricted_ordering_len * len(on_site_permutation)`

### Optional arguments

- **cluster_period** $n$(int)<br/>
    Period of cluster shuffling replacing the crossover step.
    The default value is 5.

- **stagnation_limit** $n$(int)<br/>
    If the best fitness score does not evolve for $n$ generations, the mutation
    rate is updated to the next value specified in `mutation_rates`.
    The default value is 100.

#### Fitness-function specific arguments

##### Diagonal elements of given CSFs (`MIN_MAX_DIFF`, `MAX_DIAG_ELEM`, and `MIN_DIAG_ELEM`)

- **csf_list** `csf_list`(list[list[int]])<br/>
    Specifies the list of CSFs that are used for fitness score evaluation.

##### S-Ms mapping fitness functions (`DIAG_ELEM_SMS_MAPPING` and `FAST_DIAG_MIN_OSONLY`)

- **sms_ref_csf** $csf$(list[int])<br/>
    Defines the S-Ms consistent CSF in the natural ordering.
    For example, `sms_ref_csf = [1, 2, 1, 2]` maps
    `{orbital:coupling} = {1:1, 2:2, 3:1, 4:2}`.

- **tMinimize** $l$(bool)<br/>
    Only required for `DIAG_ELEM_SMS_MAPPING` fitness function.
    This booliean determins whether the GA maximizes (if false) or minimizes
    (if true) the fitness score.

#### Restricting orderings
If `norb = 10`, `num_prefix = 3`, `num_suffix = 2`, `restricted_ordering_len = 5`, and `on_site_permutation = (1,)` (default), the GA is performed only for the middle set `{4,5,6,7,8}`. Orderings maintain the structure `(1,2,3, {4,5,6,7,8}, 9,10)`, e.g., `(1,2,3,4,6,7,5,8,9,10)` or `(1,2,3,6,8,7,4,5,9,10)`.
If `norb = 10`, `num_prefix = 2`, `num_suffix = 2`, `restricted_ordering_len = 3`, and `on_site_permutation = (2,1)`, then orderings maintain the structure `(1,2, {(4,3), (6,5), (8,7)}, 9,10)`, e.g., `(1,2,5,6,4,3,8,7,9,10)`.

- **on_site_permutation** $perm$(tuple[int])<br/>
    Pattern applied to each gene (number in the ordering) when expanding the
    restricted ordering to the full ordering. Default: `(1,)`.

- **num_prefix** $n$(int)<br/>
    Number of leading orbitals that remain fixed (not optimized).
    Default: `0`.

- **num_suffix** $n$(int)<br/>
    Number of trailing orbitals that remain fixed (not optimized).
    Default: `0`.

#### Restart

- **restart_filename** `pop_filename`<br/>
    If provided, restart the GA from a saved population.

#### Logging arguments

- **checkpoint_trigger** n(str)<br/>
    File name whose presence triggers writing an FCIDUMP file of the current
    best ordering during the run.
    Default: `"WRITE_CHECKPOINT"`.

## Citation

If you cite this package, please cite:

[1] M. Song and G. Li Manni, A Genetic Algorithm Approach for Compact Wave Function Representations in Spin-Adapted Bases, J. Chem. Theory Comput. **XXX**, XXXX (2025), DOI: [10.1021/acs.jctc.5c01264](https://doi.org/10.1021/acs.jctc.5c01264)

This is the readme file for pymolcas
====================================


What is pymolcas?
-----------------

pymolcas is the working name (it can, and maybe it should be changed) of a
reimplementation of the main Molcas driver and EMIL interpreter. It is written
in python (2.7/3.4 or later), initially by Ignacio Fdez. Galván.


Why a new driver?
-----------------

1. To provide an independent (from the license manager) way to run Molcas
   without a license file (for the Molcas@UU distribution).

2. To better separate the driver from the EMIL parser, and allow an easier
   implementation of other scripting solutions for Molcas.

3. To overcome some limitations of the current driver and EMIL (e.g. nested
   loops).

4. To have fun, learn, and simply be able to tweak the driver.


How to use pymolcas?
--------------------

It is possible to run the "pymolcas.py" file directly, but then you need to have
all the additional *.py files in the same directory, and that's not very
convenient. The recommended way is first running:

  ./export.py

This will package all the necessary files in a single self-contained script,
called "pymolcas" (note: no extension). You can then place this file somewhere
in your PATH (e.g. $HOME/bin), and run "pymolcas" instead of "molcas", pymolcas
does the job of both the "molcas" script and the "molcas.exe" program.


How is pymolcas structured?
---------------------------

pymolcas.py
  Main script, parses command line, finds molcas installation, runs molcas.

molcas_wrapper.py
  Defines the Molcas class (main driver) and the Molcas_module class (to run a
  program). 

molcas_aux.py
simpleeval.py
tee.py
  Some auxiliary functions.

abstract_flow.py
  Defines some classes to run programs, including loops, conditional
  statements, etc. This is independent of any input "language".

emil_grammar.py
  Defines the EMIL grammar, so that input files can be parsed.

emil_parse.py
  Parses an EMIL input file into the classes of "abstract_flow.py".

python_parse.py
  Wraps an input python file in a class of "abstract_flow.py".

check_test.py
  Checks the results of a test file against the reference.

validate.py
  Validates input against the XML definitions.

export.py
pack.py
compile.sh
  Three different ways to create a single-file self-contained script. The
  recommended one is "export.py" (see above).


What can/cannot pymolcas do?
----------------------------

At the moment, pymolcas can run almost anything the current molcas driver can.
It supports most EMIL commands. It doesn't support (yet) the GEO module (or
rather the DO GEO command), and it hasn't been tested in parallel.

Significantly, "pymolcas verify" runs and passes all the tests as the current
driver does (except for GEO).


How can I help?
---------------

Try the script, report problems, suggest improvements, fix the code, implement
something new...

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2022, Roland Lindh                                     *
************************************************************************

Notes on the dft_util.

OpenMolcas is since January 2022 completely interfaced with LibXC.

Functionals are defined in data/functionals.txt (or .src) through their
unique name in LibXC and their associated coefficients.

The routine "driver" contains logic for the combinations of functionals that are
used in the orbital-free embedding implementation by Aquilante et al.

Note that "driver" should not be cloned ever. If new functionalities are to be
added these should be incoporated in this routine.

In the case of functionals not present in LibXC the corresponding subroutines
are placed in this directory. "driver" does support the use of external
functions in combinations with or without functionals of the LibXC library.

This directory contains two programs for converting runfiles.

rf2asc - converts a runfile from binary to ascii format
asc2rf - converts a runfile from ascii to binary format

Edit the makefile and change LIBS, INC, FC and FFLAGS to reflect your
installation of molcas.

### File description
In `src/`, you can find the following files.
- `GUGA_diag.py`: Evaluates the diagonal H matrix element of a CSF.
- `gen_spinfree_rdm.py`: Generates one- and two-body RDMs of a CSF.
- `IntegralClass.py`: Reads in an FCIDUMP file.
- `runmolcas.py`: Interfaces to run CSF-ROHF using OpenMolcas RASSCF module.
- **`settings.py`: To run `runmolcas.py`, you need to set your OpenMolcas build directory in this file.**

### Set OpenMolcas build directory
To use the interface, you need to set your OpenMolcas build directory in `settings.py`.

### Tutorial: SSG-CSF-ROHF Optimized Orbitals

This tutorial provides a step-by-step guide to obtaining SSG-CSF-ROHF optimized orbitals using the Fe dimer example from Reference [1].

Using the Python interface in this repository requires:
- [OpenMolcas](https://gitlab.com/Molcas/OpenMolcas) for orbital optimization  
- [NECI](https://github.com/fkfest/NECI_STABLE) for PT2-RDM generation using the stochastic SplitGAS (SSG) strategy [2].

> **Note:** The SSG method [2] is currently only available in an internal development version of NECI. Please contact us to request access.

All files used in this tutorial are located in `example/SSG-CSF-ROHF_tutorial`.

---
We begin with a set of localized and sorted high-spin ROHF orbitals `Fe2S2.SortOrb`.
The Fe 3d orbitals are site-separated: the first five orbitals belong to Fe 1 and
the last five orbitals belong to Fe 2.
Step 3 for PT2-RDMs generation is done with the SSG implementation [2] in NECI and
the other steps are done with OpenMolccas.

#### Step 1: CSF-ROHF Orbital Optimization  
Directory: `1_CSF-ROHF/`

Run:
```bash
python ../../../src/runmolcas.py Fe2S2 1 1 1 1 1 2 2 2 2 2
```
`Fe2S2` is the input file name without extension.
The integers define the step-vector elements of the target CSF (|uuuuu ddddd>).
This command executes an OpenMolcas calculation via the Python interface and
it produces single-CSF-SCF variationally optimized orbitals.
For subsequent steps (2 and 4), we use the optimized orbitals from the final iteration before
canonicalization (`Fe2S2.IterOrb.25`).

#### Step 2: FCIDUMP Generation
Directory: `2_dumpgen/`

Run an OpenMolcas calculation using `Fe2S2.inp`.
The integral file is fed into NECI for PT2-RDM generation (step 3).

#### Step 3: PT2-RDM Generation
Directory: `3_RDMgen/`

Run NECI with the replica trick (`dneci`) using `input`.
`p1.list` defines the P space of the SSG calculation.
This tep creates PT2-RDM files (`DMAT.1`, `PSMAT.1`, and `PAMAT.1`) that are used
in the next step.

> **Note:** This step requires the internal development version of NECI with SSG support.

#### Step 4: SSG-CSF-ROHF Orbital Optimization
Directory: `4_SSG-CSF-ROHF/`

Run:
```bash
python ../../../src/runmolcas.py -u Fe2S2 1 1 1 1 1 2 2 2 2 2
```

The `-u` flag instructs the script to use RDM files from the working directory.
This produces SSG-CSF-ROHF orbitals and energy: `RASSCF energy for state  1 -5092.73230830`.
The energy is found in Table 3 of Reference [1].

> **Note:** The Python script supplies a fake energy to OpenMolcas to allow the iteration to proceed when the `-u` flag is used. This value appears in the output but should not be used for analysis.

### Other Example
Go to `example/` and `$ python ../src/runmolcas.py N2 1 1 1 2 2 2`.
`N2` is the Molcas input filenmae without extension, `1 1 1 2 2 2` is the CSF
you use for the ROHF optimization in the step-vector format.
This executes Molcas with `N2.inp` and feed RDMs and the RDM energy to Molcas
for every RASSCF iteration.

### Output
The python interface creates additional output files:
- `.pylog` logs the input parameters and the activites the interface does during the SCF iterations.
- `.iterdata` contains only the SCF iteration data of the calculation, as the OpenMolcas output contains additional information when
external RDMs are used (e.g., "echo $your_RDM_Energy ..." in between every iteration).

> **Note:** For SSG-CSF-ROHF calculations (Step 4 of the tutorial above), please only use `RASSCF_energy` (5th column) for the energy of the calculation.
`RDM_Energy` (last column) prints fake energies fed into OpenMolcas just to proceed iterations with the external RDM mode.

### References
- [1] Maru Song, Luca Bonfirraro, Ignacio Fdez. Galván, Roland Lindh, and Giovanni Li Manni,
"Spin-Adapted Restricted Open-Shell Hartree-Fock and Its Dynamic Correlation Extension",
Accepted for publication in J. Chem. Theory Comput. 2026,
https://doi.org/10.1021/acs.jctc.6c00379
- [2] Luca Bonfirraro, Oskar Weser, Maru Song, and Giovanni Li Manni,
"Stochastic-SplitGAS: A Quantum Monte Carlo Multi-Reference Perturbation Theory Based on the Imaginary-Time Evolution of Effective Hamiltonians",
J. Chem. Theory Comput. 2025, 21, 24, 12523–12544,
https://doi.org/10.1021/acs.jctc.5c01270

This is the readme file for auger-OCA

Contact person: Bruno Tenorio
b.nunes.bruno@gmail.com

Use
```
pip install auger-oca
```
to install the auger-oca packages.
 `OCA` stands for One-Center Approximation. It is a simple way to get Auger intensities bypassing the
 calculation of continuum wave function.
 
 Auger-OCA is a collection of python scripts (programs) to post-process a collection
 of 2-el reduced transition density matrices (also called Auger densities) generated 
 by the `RASSI` module of OpenMolcas. It also requires the `$Project.rassi.h5` file in the background.

 The keyword `TDYS` must be used together with `DYSON` in your `RASSI` input calculation (see example below
 for C 1s edge).

```
&RASSI
 Nrof JobIphs =  5 all
 CIprint
 Ejob
 TDYS
 1
 C 1s
 Dyson
```

Check `auger_examples/` folder for complete examples.

It simply runs as:

 for RAES (resonant Auger):
```
 python3 $MOLCAS/Tools/AugerOca/auger_main.py -d $WorkDir --raes --spec &
```
 If non-resonant Auger (AES) of singlet final states:
```
 python3 $MOLCAS/Tools/AugerOca/auger_main.py -d $WorkDir --aes --s --spec &
```
 If non-resonant Auger (AES) of triplet final states:
```
 python3 $MOLCAS/Tools/AugerOca/auger_main.py -d $WorkDir --aes --t --spec &
```

++ See also
```
 python3 $MOLCAS/Tools/AugerOca/auger_main.py -h
```
 for more info and usage. 

+Important:

- `auger_main.py` reads a file `$project.rassi.h5` in the background. You must execute `auger_main.py`
 from any directory where you have your `$project.rassi.h5` file (either `$CurrDir` or `$WorkDir` work).
- `auger_main.py` will create a directory `auger_outputs/` containing a collection of
 `[Auger_OCA.r2TM_XXX_YYY_ZZZ.out,...]` files. The binding energy and Auger intensities (plus other info)
 are writen on each of these files.
- `--spec` is optional. One can also use a bash script (`oca.spectrum.sh` on `auger_test` folder) to collect the Auger {energy,intensity}
 from those `[Auger_OCA.r2TM_XXX_YYY_ZZZ.out,...]` files -> in a file `spectrum.out`.
- Again, don't forget to install the Auger OCA packages with `pip install auger-oca`

The CIsandbox is a collection of subroutines to operate on CI spaces.  In
second_quantization.f90, methods for creation/annihilation operators are
implemented that use bitwise operators on integers, i.e. the determinants
represented as bit-strings. In wavefunction.f, a derived type is used to
represent Full-CI wavefunctions. In density.f, examples of computing the 1-el
and 2-el density matrices are provided. The rest of the files deal with Fock
matrices, orbitals and integrals.

The code was mainly written to explore the CASPT2 UDL decomposition method for
direct CASPT2, but the basic subroutines are general enough to use as a sandbox
for other CI-like codes. An example Full-CI code is included as well. The
required integrals for those calculations were obtained from Molcas.

Most routines have their own documentation, so it should be fairly
straithforward to figure out how to use them.

Steven Vancoillie, December 2013, Lund

Vim setup
=========
Place the files 'emil.vim' and 'molcasoutput.vim' in your ~/.vim/syntax
directory. Paste the contents of 'molcasvimrc' in your ~/.vimrc.

Syntax coloring will take effect on any file with extension *.input or *.log.
If you do not want this, uncomment the corresponding autocmd line(s) in
~/.vimrc. If you prefer detection of molcas output files based on file contents
instead of filename, comment out the line in ~/.vimrc and copy the
'scripts.vim' file in your ~/.vim directory.

For the molcas help feature, pressing K (shift-k) while the cursor is on a
keyword in an input file, a buffer will pop up with the relevant molcas help.
Close the buffer with :q as usual. It works with module names, keywords inside
a module, and emil commands (if the line begins with >).

Nedit setup
===========

Rys polynomials depend on their order, n, and a continuous parameter, x (the
independent variable of the polynomial is customarily called t, but sometimes
it's the other way around). So for any value of x there is a family of
orthogonal polynomials given by the order n.

For large enough values of x, the roots of the Rys polynomials and the
corresponding weights for the quadrature can be obtained from the roots and
weights of Hermite polynomials of double order, with a proper x-dependent
scaling. The script "asymptotic.py" computes the value of x from which the
error in this procedure falls below a specified threshold, which will be
different for each order n.

For values of x below the "asymptotic limit", the roots and weights of the Rys
polynomials can be precomputed at certain values of x, divided by intervals and
results within each interval can be fitted by an m-degree polynomial. Rys
polynomials of n degree have n roots and n associated weights, so they will
require 2*n different fitting polynomials. In addition, different intervals or
ranges of x will require different sets of fitting polynomials. The script
"genfit.py" generates these fitting polynomials (with predefined m) to ensure
that the roots and weights at some finer-grained x values can be reproduced
with a specified accuracy. The (trimmed) output can be used as the "rysrw" file
for Molcas. The script "testfit.py" Takes a rysrw-formatted file and computes
the actual errors generated by the fitting polynomials.

For higher orders of n not tabulated in rysrw, or as an alternative approach,
the roots and weights can be computed from the alpha and beta coefficients of
the three-term recurrence of the Rys polynomials. These alpha and beta
coefficients are infinite series and depend on x, but only the first n of them
are needed to compute the roots and weights of Rys polynomials of order n. The
script "genab.py" calculates the first members of the alpha and beta series for
a range of x values. The x values are not evenly spaced, but follow a seemingly
arbitrary rule. The output can be used as the "abdata" file for Molcas.

Baker test suite, from:

Jon Baker
"Techniques for geometry optimization: A comparison of cartesian and natural internal coordinates"
J. Comput. Chem. 14:9 (1993) 1085-1100
doi:10.1002/jcc.540140910

01: water
02: ammonia
03: ethane
04: acetylene
05: allene
06: hydroxysulphane
07: benzene
08: methylamine
09: ethanol
10: acetone
11: disilyl ether
12: 1,3,5-trisilacyclohexane
13: benzaldehyde
14: 1,3-difluorobenzene
15: 1,3,5-trifluorobenzene
16: neopentane
17: furan
18: naphthalene
19: 1,5-difluoronaphthalene
20: 2-hydroxybicyclopentane
21: ACHTAR10
22: ACANIL01
23: benzidine
24: pterin
25: difuropyrazine
26: mesityl oxide
27: histidine
28: 2,3-dimethylpentane
29: caffeine
30: menthone

Additional cases, not included in the standard test suite

31: ACTHCP
32: histamine H+
33: hydrazobenzene

The file RIJ_TestSet.txt obtained from supplementary material of

F. Weigend
"Accurate Coulomb-fitting basis sets for H to Rn"
Phys. Chem. Chem. Phys. 8, 1057-1065 (2006)

The pdf-file RIJ_TestSet.pdf was obtained the same place:
http://www.rsc.org/suppdata/CP/b5/b515623h/b515623h.pdf

CASSCF/MS-CASPT2 test set for the vertical excitation energies and
one-electron properties of 28 medium-sized organic molecules according to
benchmark calculations presented in

[1] M. Schreiber, M.R. Silva-Junior, S.P.A. Sauer and W. Thiel
Benchmarks for electronically excited states: CASPT2, CC2, CCSD, and CC3.
J. Chem. Phys. 128, 134110, (2008) doi:10.1063/1.2889385

[2] M.R. Silva-Junior, M. Schreiber, S.P.A. Sauer and W. Thiel
Benchmarks for electronically excited states: TD-DFT and DFT/MRCI.
J. Chem. Phys. 129, 104103, (2008). doi:10.1063/1.2973541

See [1] for details on the calculations and an extensive survey of the
literature and [2] for current MS-CASPT2 results which have been used to
derive reference data for an excited-state benchmark set.

Usage:

If the file run_all is executed a file called result is produced with
printed energies for all molecules in the g3/99 test set.

Syntax:

run_all <basis set> (default is 6-31G*) <{scf,dft or mp2}> (default is
scf) <functional> (default is B3LYP)

For more advanced usages edit the scriptfile run_all, the generic
input-file generic.input or just write your own script using all or
some of the xyz-files in the directory.

The geometries is the same as on
http://chemistry.anl.gov/compmat/comptherm.htm
but in xyz-format and designed to work with molcas extended
xyz-format.

Baker TS test suite, from:

Jon Baker, Fora Chan
"The Location of Transition States: A Comparison of Cartesian, Z-Matrix, and Natural Internal Coordinates"
J. Comput. Chem. 17:7 (1996) 888-904
doi:10.1002/(SICI)1096-987X(199605)17:7<888::AID-JCC12>3.0.CO;2-7


01: HCN <-> HNC
02: HCCH <-> CCH2
03: H2CO <-> H2 + CO
04: CH3O <-> CH2OH
05: ring opening cyclopropyl
06: ring opening bicyclo[1.1.0]butane TS 1
07: ring opening bicyclo[1.1.0]butane TS 2
08: 1,2-migration beta-(formyloxy)ethyl
09: butadiene + ethylene <-> cyclohexene
10: s-tetrazine <-> 2HCN + N2
11: trans-butadiene <-> cis-butadiene
12: CH3CH3 <-> CH2CH2 + H2
13: CH3CH2F <-> CH2CH2 + HF
14: vinyl alcohol <-> acetaldehyde
15: HCOCl <-> HCl + CO
16: H2O + PO3- <-> H2PO4-
17: CH2CHCH2-O-CHCH2 <-> CH2CHCH2CH2CHO
18: SiH2 + CH3CH3 <-> SiH3CH2CH3
19: HNCCS <-> HNC + CS
20: HCONH3+ <-> NH4+ + CO
21: rotational TS in acrolein
22: HCONHOH <-> HCOHNOH
23: HNC + H2 <-> H2CNH
24: H2CNH <-> HCNH2
25: HCNH2 <-> HCN + H2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
SUBROUTINE CASPT2_UDL(PSI,F,NAO,NMO,CMO,ONEINT,TWOINT)
  ! Computes the CASPT2 second-order energy of the wavefunction PSI, provided
  ! that the full Fock matrix and necessary 1- and 2-el integrals are given.

  ! Uses UDL decomposition of the Fock matrix and transforms the RHS according
  ! to the upper and lower triangular blocks Q of U and L by means of the
  ! exponential operator exp(Q).

  USE ISO_FORTRAN_ENV, ONLY: REAL64
  USE SECOND_QUANTIZATION
  USE WAVEFUNCTION
  USE DENSITY
  USE FOCKMATRIX
  USE ORBINT
  IMPLICIT NONE

  TYPE(WFN), INTENT(INOUT) :: PSI
  TYPE(FMAT), INTENT(INOUT) :: F
  INTEGER, INTENT(IN) :: NAO, NMO
  REAL(REAL64), INTENT(INOUT) :: ONEINT(NMO,NMO), TWOINT(NMO,NMO,NMO,NMO)
  REAL(REAL64), INTENT(INOUT) :: CMO(NAO,NMO)

  INTEGER :: NI, NA, NS
  INTEGER :: NACTEL, NTOTEL, MULT

  TYPE(WFN) :: PSI1, SGM, TAU, RHS
  REAL(REAL64), ALLOCATABLE :: D1(:,:), D2(:,:,:,:), FTOT(:,:)
  REAL(REAL64) :: FACT

  REAL(REAL64), ALLOCATABLE :: VPQRS(:,:,:,:), V0(:), X(:)
  REAL(REAL64), ALLOCATABLE :: H0(:,:), S0(:,:), U0(:,:), T0(:,:)
  REAL(REAL64) :: E0, E2
  INTEGER :: ISD, JSD, NSD, MSD

  REAL(REAL64), ALLOCATABLE :: PSI1BRA(:,:,:), PSI1KET(:,:,:), FOCKKET(:,:,:)

  REAL(REAL64), ALLOCATABLE :: WORK(:), EVAL(:)
  INTEGER :: NWORK, INFO

  INTEGER, ALLOCATABLE :: IPIV(:)

  INTEGER :: A, I, T, P, Q, R, S, IA, IB
  INTEGER :: DETA, DETB, TMPA, TMPB
  INTEGER, ALLOCATABLE :: IDXA(:), IDXB(:), ADET(:), BDET(:)

  REAL(REAL64), EXTERNAL :: DNRM2_, DDOT_

  ! get appropriate orbital space dimensions from the supplied Fock matrix
  NI=SIZE(F%II,1)
  NA=SIZE(F%AA,1)
  NS=SIZE(F%SS,1)

#ifdef _DEBUG_
  WRITE(*,'(1X,A,I6)') '#inactive  orbitals = ', NI
  WRITE(*,'(1X,A,I6)') '#active    orbitals = ', NA
  WRITE(*,'(1X,A,I6)') '#secondary orbitals = ', NS
  WRITE(*,'(1X,A,I6)') '#molecular orbitals = ', NMO
#endif

  ! some sanity checks
  IF (PSI%NORB.NE.NA) STOP 'CASPT2_AXB: PSI%NORB does not match #active orbitals'
  IF (NMO.NE.NI+NA+NS) STOP 'CASPT2_AXB: supplied total #orbitals does not compute'

  NACTEL=PSI%NEL
  NTOTEL=2*NI+NACTEL
  MULT=PSI%MULT

  ! reconstruct density matrices
  ALLOCATE(D1(NA,NA))
  ALLOCATE(D2(NA,NA,NA,NA))
  CALL D1_ANN(PSI,D1)
  CALL D2_ANN(PSI,D2)

  WRITE(*,*) 'Before inactive/active orbital rotation:'
  WRITE(*,*)
  CALL WFN_PRINT(PSI,0.0D0)
  CALL WFN_ENERGY(NI,NA,NS,D1,D2,ONEINT,TWOINT)

  ! copy Fock matrix and apply UDL decomposition after shifting by E0!
  E0 = -4.39765297778118
  DO I=1,NI
    F%II(I,I)=F%II(I,I)-E0/NTOTEL
  END DO
  DO T=1,NA
    F%AA(T,T)=F%AA(T,T)-E0/NTOTEL
  END DO
  DO A=1,NS
    F%SS(A,A)=F%SS(A,A)-E0/NTOTEL
  END DO

  CALL FMAT_UDL(F)
  WRITE(*,*) 'After UDL decomposition'
  CALL FMAT_PRINT(F)

  ! store diagonal in FTOT
  ALLOCATE(FTOT(NMO,NMO))
  FTOT=0.0D0
  DO I=1,NI
    FTOT(I,I)=F%DI(I)
  END DO
  DO T=1,NA
    FTOT(NI+T,NI+T)=F%DA(T)
  END DO
  DO A=1,NS
    FTOT(NI+NA+A,NI+NA+A)=F%DS(A)
  END DO

!#ifdef _DEBUG_
  DO P=1,NMO
    WRITE(*,'(1X,7(2X,F21.14))') FTOT(P,:)
  END DO
!#endif

  ! copy and transform the wavefunction accordingly
  CALL WFN_ORBROT(PSI,F%AA)
  CALL ORBINT_TRANSFORM(CMO,ONEINT,TWOINT,F%II,F%AA,F%SS)

  ! reconstruct density matrices
  CALL D1_ANN(PSI,D1)
  CALL D2_ANN(PSI,D2)

  WRITE(*,*) 'After inactive/active orbital rotation:'
  WRITE(*,*)
  CALL WFN_PRINT(PSI,0.0D0)
  CALL WFN_ENERGY(NI,NA,NS,D1,D2,ONEINT,TWOINT)

  ! first, set up PSI1 as a (sparse) full-CI wavefunction for which we will use
  ! projectors to handle the restriction of single-double replacement states
  CALL WFN_INIT(PSI1,NTOTEL,NMO,MULT)

  PSI1%COEF=0.0D0
  CALL WFN_COPY0(NI,PSI,PSI1)

#ifdef _DEBUG_
  WRITE(*,'(1X,A)') 'The 0th-order wavefunction in FCI space:'
  CALL WFN_PRINT(PSI1,1.0D-15)
#endif

  DEALLOCATE(D1)
  DEALLOCATE(D2)

  ! compute the CASSCF energy for the 0-th order wavefunction
  ALLOCATE(D1(NMO,NMO))
  ALLOCATE(D2(NMO,NMO,NMO,NMO))
  CALL D1_ANN(PSI1,D1)
  CALL D2_ANN(PSI1,D2)
  
  CALL WFN_ENERGY(0,NMO,0,D1,D2,ONEINT,TWOINT)

  CALL WFN_INIT(SGM,NTOTEL,NMO,MULT)
  CALL WFN_INIT(TAU,NTOTEL,NMO,MULT)
  CALL WFN_INIT(RHS,NTOTEL,NMO,MULT)

  ! set up the RHS -V0 with V0_i  = <i|Ĥ|0>

  ! First, compute the 0-th order energy and construct the right hand side
  ! vector -V0, which is computed for each |i> that is non-zero. This still
  ! leaves an overcomplete basis for the VSD space, but that is solved later by
  ! diagonalization of S0 and removal of any linear dependency before solving
  ! Ax=b.

  ! step 1: |TAU> = Ĥ|0>
  TAU%COEF=0.0D0
  SGM%COEF=0.0D0

  DETB=LEX_INIT(PSI%NELB,PSI%NORB)
  DO IB=1,PSI%NDETB
    TMPB=ISHFT(DETB,NI)+(2**NI-1)
    DETA=LEX_INIT(PSI%NELA,PSI%NORB)
    DO IA=1,PSI%NDETA
      TMPA=ISHFT(DETA,NI)+(2**NI-1)

      FACT=PSI%COEF(IA,IB)
      DO P=1,NMO
        DO Q=1,NMO
          ! h_pq, g_pqrs for TAU
          CALL DET_EX1(FACT*ONEINT(P,Q),P,Q,TMPA,TMPB,TAU)
          DO R=1,NMO
            DO S=1,NMO
              CALL DET_EX2(FACT*0.5D0*TWOINT(P,Q,R,S),P,Q,R,S,TMPA,TMPB,TAU)
            END DO
          END DO
        END DO
      END DO

      DETA=LEX_NEXT(DETA)
    END DO
    DETB=LEX_NEXT(DETB)
  END DO

#ifdef _DEBUG_
  WRITE(*,'(1X,A)') 'wavefunction Ĥ|0>'
  CALL WFN_PRINT(TAU,1.0D-6)
#endif

  ! step 2: construct V0 = <i|TAU>, store the computed functions |i> in PSI1KET
  ! and PSI1BRA
  ALLOCATE(VPQRS(NMO,NMO,NMO,NMO))

  NSD=0
  VPQRS=0.0D0
  DO S=1,NMO
    DO R=1,NMO
      DO Q=1,NMO
        DO P=1,NMO

          ! determine |i> = E_pqrs |Psi0>
          SGM%COEF=0.0D0
          DETB=LEX_INIT(PSI%NELB,PSI%NORB)
          DO IB=1,PSI%NDETB
            TMPB=ISHFT(DETB,NI)+(2**NI-1)
            DETA=LEX_INIT(PSI%NELA,PSI%NORB)
            DO IA=1,PSI%NDETA
              TMPA=ISHFT(DETA,NI)+(2**NI-1)

              CALL DET_EX2(PSI%COEF(IA,IB),P,Q,R,S,TMPA,TMPB,SGM)

              DETA=LEX_NEXT(DETA)
            END DO
            DETB=LEX_NEXT(DETB)
          END DO

          PSI1%COEF=0.0D0
          CALL WFN_PSD(NI,NA,NS,SGM,PSI1)

          IF (DNRM2_(PSI1%NDET,PSI1%COEF,1).NE.0.0D0) THEN
            VPQRS(P,Q,R,S)=DDOT_(PSI1%NDET,PSI1%COEF,1,TAU%COEF,1)
            NSD=NSD+1
          END IF

        END DO
      END DO
    END DO
  END DO

  ALLOCATE(V0(NSD))

  ISD=0
  DO S=1,NMO
    DO R=1,NMO
      DO Q=1,NMO
        DO P=1,NMO
          IF (ABS(VPQRS(P,Q,R,S)).GT.0.0D0) THEN
            ISD=ISD+1
            V0(ISD)=VPQRS(P,Q,R,S)
          END IF
        END DO
      END DO
    END DO
  END DO

  DEALLOCATE(VPQRS)

  ALLOCATE(H0(NSD,NSD))
  ALLOCATE(S0(NSD,NSD))

  H0 = 0.0D0
  S0 = 0.0D0

  ! construct E_pqrs|0> in PSI1KET, PSI1BRA and

  ALLOCATE(PSI1BRA(NSD,PSI1%NDETA,PSI1%NDETB))
  ALLOCATE(PSI1KET(PSI1%NDETA,PSI1%NDETB,NSD))
  ALLOCATE(FOCKKET(PSI1%NDETA,PSI1%NDETB,NSD))

  ISD=0
  DO S=1,NMO
    DO R=1,NMO
      DO Q=1,NMO
        DO P=1,NMO

          SGM%COEF=0.0D0
          ! determine |i> = E_pqrs |0>
          DETB=LEX_INIT(PSI%NELB,PSI%NORB)
          DO IB=1,PSI%NDETB
            TMPB=ISHFT(DETB,NI)+(2**NI-1)
            DETA=LEX_INIT(PSI%NELA,PSI%NORB)
            DO IA=1,PSI%NDETA
              TMPA=ISHFT(DETA,NI)+(2**NI-1)

              CALL DET_EX2(PSI%COEF(IA,IB),P,Q,R,S,TMPA,TMPB,SGM)

              DETA=LEX_NEXT(DETA)
            END DO
            DETB=LEX_NEXT(DETB)
          END DO
          PSI1%COEF=0.0D0
          CALL WFN_PSD(NI,NA,NS,SGM,PSI1)

          IF (DNRM2_(PSI1%NDET,PSI1%COEF,1).NE.0.0D0) THEN
            ISD=ISD+1
            ! put |i> = E_pqrs |0> into PSI1BRA and PSI1KET
            PSI1BRA(ISD,:,:) = PSI1%COEF
            PSI1KET(:,:,ISD) = PSI1%COEF

            ! compute Ĥ_0|i> = Sum_pp f_pp Ê_pp |i>
            SGM%COEF=0.0D0
            DETB=LEX_INIT(PSI1%NELB,PSI1%NORB)
            DO IB=1,PSI1%NDETB
              DETA=LEX_INIT(PSI1%NELA,PSI1%NORB)
              DO IA=1,PSI1%NDETA

                DO I=1,NMO
                  ! accumulate F_ii Ê_ii |i>
                  CALL DET_EX1(PSI1%COEF(IA,IB)*FTOT(I,I),I,I,DETA,DETB,SGM)
                END DO

                DETA=LEX_NEXT(DETA)
              END DO
              DETB=LEX_NEXT(DETB)
            END DO
            ! put Ĥ_0|i> into FOCKKET
            FOCKKET(:,:,ISD) = SGM%COEF
          END IF

        END DO
      END DO
    END DO
  END DO

  CALL DGEMM_('N','N',NSD,NSD,PSI1%NDET,1.0D0, &
       & PSI1BRA,NSD,PSI1KET,PSI1%NDET, &
       & 0.0D0,S0,NSD)

  CALL DGEMM_('N','N',NSD,NSD,PSI1%NDET,1.0D0, &
       & PSI1BRA,NSD,FOCKKET,PSI1%NDET, &
       & 0.0D0,H0,NSD)

  ! preparation: determine T^T S T = 1, to remove linear dependencies by
  ! diagonalizing the overlap matrix, construct a transformation matrix to
  ! orthogonal basis, and transform X, S0, H0 and V0 accordingly

  ALLOCATE(U0(NSD,NSD))
  U0(:,:)=S0

  NWORK=NSD**2
  ALLOCATE(WORK(NWORK))
  ALLOCATE(EVAL(NSD))

  call dsyev_('V','U',NSD,U0,NSD,EVAL,WORK,NWORK,INFO)
  IF (INFO.NE.0) STOP 'CASPT2_UDL: diagonalization of S0 failed'

  ! go through columns of U0, keep non-zero eigenvalues
  MSD=0
  DO ISD=1,NSD
    IF (EVAL(ISD).GT.1.0D-6) THEN
      MSD=MSD+1
    END IF
  END DO
  WRITE(*,'(1X,A,I6)') '#non-zero overlap eigenvalues = ', MSD

  ALLOCATE(T0(NSD,MSD))
  ISD=0
  DO JSD=1,NSD
    IF (EVAL(JSD).GT.1.0D-6) THEN
      ISD=ISD+1
      T0(:,ISD) = U0(:,JSD)/SQRT(EVAL(JSD))
    END IF
  END DO

  DEALLOCATE(U0)

  ALLOCATE(X(NSD))
  X(:)=-V0

  ! compute RHS = Sum_i X_i |i>
  RHS%COEF=0.0D0
  DO ISD=1,NSD
    RHS%COEF(:,:)=RHS%COEF+X(ISD)*PSI1KET(:,:,ISD)
  END DO

  ! apply first series of operators exp(-Q_IA) exp(-Q_AS) exp(-Q_IS)

  ! exp(-Q_IS) = 1 - Sum_IS Q_IS E_IS + 0.5 ...
  SGM%COEF=0.0D0
  DO A=1,NS
    DO I=1,NI
      CALL WFN_EX1(-F%IS(I,A),I,NI+NA+A,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO A=1,NS
    DO I=1,NI
      CALL WFN_EX1(-0.5D0*F%IS(I,A),I,NI+NA+A,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_AS) = 1 - Sum_AS Q_AS E_AS + ...
  SGM%COEF=0.0D0
  DO A=1,NS
    DO T=1,NA
      CALL WFN_EX1(-F%AS(T,A),NI+T,NI+NA+A,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO A=1,NS
    DO T=1,NA
      CALL WFN_EX1(-0.5D0*F%AS(T,A),NI+T,NI+NA+A,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_IA) = 1 - Sum_IA Q_IA E_IA + ...
  SGM%COEF=0.0D0
  DO T=1,NA
    DO I=1,NI
      CALL WFN_EX1(-F%IA(I,T),I,NI+T,RHS,SGM)
    END DO
  END DO
  PSI1%COEF=0.0D0
  CALL WFN_PSD(NI,NA,NS,SGM,PSI1)
  !PSI1%COEF=SGM%COEF
  DO T=1,NA
    DO I=1,NI
      CALL WFN_EX1(-0.5D0*F%IA(I,T),I,NI+T,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! contract into X_i = <i|exp(-Q_IA)|RHS> and
  ! transform to adapt for the overcomplete basis
  CALL DGEMV_('N',NSD,PSI1%NDET,1.0D0, &
       & PSI1BRA,NSD,RHS%COEF,1,0.0D0,X,1)
  X(:) = MATMUL(MATMUL(T0,TRANSPOSE(T0)),X)


  ! apply diagonal inverse, e.g. solve H0' XNEW = XOLD

  ! transform equation system
  H0(1:MSD,1:MSD) = MATMUL(TRANSPOSE(T0),MATMUL(H0,T0))

  ! solution vector is already filled with RHS, just transform it
  X(1:MSD) = MATMUL(TRANSPOSE(T0),X)

  ALLOCATE(IPIV(NSD))

  call dgesv_(MSD,1,H0,NSD,IPIV,X,NSD,INFO)
  IF (INFO.NE.0) THEN
    WRITE(*,*) 'INFO = ', INFO
    STOP 'Failed to solve linear equation system'
  END IF

  DEALLOCATE(IPIV)

  X(:)=MATMUL(T0,X(1:MSD))

  ! Now, continue with the transformation steps for L

  ! compute new RHS = Sum_i X_i |i>
  RHS%COEF=0.0D0
  DO ISD=1,NSD
    RHS%COEF(:,:)=RHS%COEF+X(ISD)*PSI1KET(:,:,ISD)
  END DO

  ! apply second series of operators exp(-Q_SI) exp(-Q_SA) exp(-Q_SI)

  ! exp(-Q_AI) = 1 - Sum_AI Q_AI E_AI
  SGM%COEF=0.0D0
  DO I=1,NI
    DO T=1,NA
      CALL WFN_EX1(-F%AI(T,I),NI+T,I,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO I=1,NI
    DO T=1,NA
      CALL WFN_EX1(-0.5D0*F%AI(T,I),NI+T,I,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_SA) = 1 - Sum_SA Q_SA E_SA + ...
  SGM%COEF=0.0D0
  DO T=1,NA
    DO A=1,NS
      CALL WFN_EX1(-F%SA(A,T),NI+NA+A,NI+T,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO T=1,NA
    DO A=1,NS
      CALL WFN_EX1(-0.5D0*F%SA(A,T),NI+NA+A,NI+T,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_SI) = 1 - Sum_SI Q_SI E_SI + ...
  SGM%COEF=0.0D0
  DO I=1,NI
    DO A=1,NS
      CALL WFN_EX1(-F%SI(A,I),NI+NA+A,I,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO I=1,NI
    DO A=1,NS
      CALL WFN_EX1(-0.5D0*F%SI(A,I),NI+NA+A,I,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! contract into X_i = <i|exp(-Q_IA)|RHS> and
  ! transform to adapt for the overcomplete basis
  CALL DGEMV_('N',NSD,PSI1%NDET,1.0D0, &
       & PSI1BRA,NSD,RHS%COEF,1,0.0D0,X,1)
  X(:) = MATMUL(MATMUL(T0,TRANSPOSE(T0)),X)



  ! compute the energy

  ! method 1: E2 = <V0|X>
  E2 = DDOT_(NSD,V0,1,X,1)
  WRITE(*,'(1X,A32,F21.14)') 'E2 as <V0|X> = ', E2

  ! method 2: E2 = <0|Ĥ|Psi1>
  ! first, form the first-order wavefunction |Psi1>
  PSI1%COEF=0.0D0
  DO ISD=1,NSD
    PSI1%COEF(:,:)=PSI1%COEF+X(ISD)*PSI1KET(:,:,ISD)
  END DO

  !WRITE(*,*) 'Final first-order wavefunction from UDL method:'
  !CALL WFN_PRINT(PSI1,1.0D-8)

  ! TAU still contains Ĥ|0>, so contract with |Psi1>
  E2 = DDOT_(PSI1%NDET,PSI1%COEF,1,TAU%COEF,1)
  WRITE(*,'(1X,A32,F21.14)') 'E2 as <Psi1|H|0> = ', E2

  DEALLOCATE(H0)
  DEALLOCATE(S0)
  DEALLOCATE(T0)
  DEALLOCATE(V0)
  DEALLOCATE(X)
  DEALLOCATE(PSI1BRA)
  DEALLOCATE(PSI1KET)
  DEALLOCATE(FOCKKET)



  ! Same UDL decomposition procedure, but in a determinant basis instead of an
  ! excitation parameter space. This has the advantage of being simpler, faster,
  ! and the fact that there is an orthonormal basis in place already.

  ! step 1: |TAU> = Ĥ|0>
  TAU%COEF=0.0D0
  SGM%COEF=0.0D0
  RHS%COEF=0.0D0

  DETB=LEX_INIT(PSI%NELB,PSI%NORB)
  DO IB=1,PSI%NDETB
    TMPB=ISHFT(DETB,NI)+(2**NI-1)
    DETA=LEX_INIT(PSI%NELA,PSI%NORB)
    DO IA=1,PSI%NDETA
      TMPA=ISHFT(DETA,NI)+(2**NI-1)

      FACT=PSI%COEF(IA,IB)
      DO P=1,NMO
        DO Q=1,NMO
          ! h_pq, g_pqrs for TAU
          CALL DET_EX1(FACT*ONEINT(P,Q),P,Q,TMPA,TMPB,TAU)
          DO R=1,NMO
            DO S=1,NMO
              CALL DET_EX2(FACT*0.5D0*TWOINT(P,Q,R,S),P,Q,R,S,TMPA,TMPB,TAU)
            END DO
          END DO
        END DO
      END DO

      DETA=LEX_NEXT(DETA)
    END DO
    DETB=LEX_NEXT(DETB)
  END DO

  ! project out the non-SD determinants from H|0>
  CALL WFN_PSD(NI,NA,NS,TAU,RHS)

#ifdef _DEBUG_
  WRITE(*,'(1X,A)') 'wavefunction Ĥ|0>'
  CALL WFN_PRINT(TAU,1.0D-6)
#endif

  ! construct PSI1 = Sum_i |i>, store valid indices in separate index tables
  PSI1%COEF=0.0D0
  SGM%COEF=1.0D0
  CALL WFN_PSD(NI,NA,NS,SGM,PSI1)

  NSD=0
  DO IB=1,PSI1%NDETB
    DO IA=1,PSI1%NDETA
      IF (PSI1%COEF(IA,IB).NE.0.0D0) NSD=NSD+1
    END DO
  END DO

  WRITE(*,'(1X,A32,I6)') '#SD determinants in Psi1 = ', NSD

  ! store indices and determinants of non-zero Psi1 contributions in separate
  ! arrays
  ALLOCATE(IDXA(NSD))
  ALLOCATE(IDXB(NSD))
  ALLOCATE(ADET(NSD))
  ALLOCATE(BDET(NSD))

  ISD=0
  TMPB=LEX_INIT(PSI1%NELB,PSI1%NORB)
  DO IB=1,PSI1%NDETB
    TMPA=LEX_INIT(PSI1%NELA,PSI1%NORB)
    DO IA=1,PSI1%NDETA
      IF (PSI1%COEF(IA,IB).NE.0.0D0) THEN
        ISD=ISD+1
        IDXA(ISD)=IA
        IDXB(ISD)=IB
        ADET(ISD)=TMPA
        BDET(ISD)=TMPB
      END IF
      TMPA=LEX_NEXT(TMPA)
    END DO
    TMPB=LEX_NEXT(TMPB)
  END DO

  ! step 2: construct V0, V0_i = <i|H|0>

  ALLOCATE(V0(NSD))

  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    V0(ISD)=RHS%COEF(IA,IB)
  END DO

  ALLOCATE(H0(NSD,NSD))
  ALLOCATE(S0(NSD,NSD))

  H0 = 0.0D0
  S0 = 0.0D0

  ! construct elements <i|H_0|j>
  DO JSD=1,NSD
    TMPA=ADET(JSD)
    TMPB=BDET(JSD)
    SGM%COEF=0.0D0
    DO I=1,NMO
      ! accumulate Sum_i F_ii Ê_ii |j>
      CALL DET_EX1(FTOT(I,I),I,I,TMPA,TMPB,SGM)
    END DO
    DO ISD=1,NSD
      IA=IDXA(ISD)
      IB=IDXB(ISD)
      H0(ISD,JSD)=SGM%COEF(IA,IB)
    END DO
  END DO

  ! set RHS to -<i|H|0>
  RHS%COEF(:,:)=-RHS%COEF

  ! series of deexcitation operators exp(-Q_IA) exp(-Q_AS) exp(-Q_IS)

  ! exp(-Q_IS) = 1 - Sum_IS Q_IS E_IS + 0.5 ...
  SGM%COEF=0.0D0
  DO A=1,NS
    DO I=1,NI
      CALL WFN_EX1(-F%IS(I,A),I,NI+NA+A,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO A=1,NS
    DO I=1,NI
      CALL WFN_EX1(-0.5D0*F%IS(I,A),I,NI+NA+A,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_AS) = 1 - Sum_AS Q_AS E_AS + ...
  SGM%COEF=0.0D0
  DO A=1,NS
    DO T=1,NA
      CALL WFN_EX1(-F%AS(T,A),NI+T,NI+NA+A,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO A=1,NS
    DO T=1,NA
      CALL WFN_EX1(-0.5D0*F%AS(T,A),NI+T,NI+NA+A,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_IA) = 1 - Sum_IA Q_IA E_IA + ...
  SGM%COEF=0.0D0
  DO T=1,NA
    DO I=1,NI
      CALL WFN_EX1(-F%IA(I,T),I,NI+T,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO T=1,NA
    DO I=1,NI
      CALL WFN_EX1(-0.5D0*F%IA(I,T),I,NI+T,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ALLOCATE(X(NSD))

  ! contract into X_i = <i|exp(-Q_IA)|RHS>
  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    X(ISD)=RHS%COEF(IA,IB)
  END DO

  ! diagonal resolvent step

  ! method 1: invert H0 and multiply

  !ALLOCATE(U0(NSD,NSD))
  !U0=H0

  !NWORK=NSD**2
  !ALLOCATE(WORK(NWORK))
  !ALLOCATE(EVAL(NSD))

  !call dsyev_('V','U',NSD,U0,NSD,EVAL,WORK,NWORK,INFO)
  !IF (INFO.NE.0) STOP 'CASPT2_UDL: diagonalization of S0 failed'

  !S0=0.0D0
  !DO ISD=1,NSD
  !  S0(ISD,ISD)=1/EVAL(ISD)
  !END DO
  !H0=MATMUL(MATMUL(U0,S0),TRANSPOSE(U0))
  !X=MATMUL(H0,X)

  ! method 2: solve linear system H0 C = X

  ALLOCATE(IPIV(NSD))
  call dgesv_(NSD,1,H0,NSD,IPIV,X,NSD,INFO)
  IF (INFO.NE.0) THEN
    WRITE(*,*) 'INFO = ', INFO
    STOP 'Failed to solve linear equation system'
  END IF

  ! Now, continue with the transformation steps for L

  ! compute new RHS = Sum_i X_i |i>
  RHS%COEF=0.0D0
  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    RHS%COEF(IA,IB)=X(ISD)
  END DO

  ! apply second series of operators exp(-Q_SI) exp(-Q_SA) exp(-Q_SI)

  ! exp(-Q_AI) = 1 - Sum_AI Q_AI E_AI
  SGM%COEF=0.0D0
  DO I=1,NI
    DO T=1,NA
      CALL WFN_EX1(-F%AI(T,I),NI+T,I,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO I=1,NI
    DO T=1,NA
      CALL WFN_EX1(-0.5D0*F%AI(T,I),NI+T,I,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_SA) = 1 - Sum_SA Q_SA E_SA + ...
  SGM%COEF=0.0D0
  DO T=1,NA
    DO A=1,NS
      CALL WFN_EX1(-F%SA(A,T),NI+NA+A,NI+T,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO T=1,NA
    DO A=1,NS
      CALL WFN_EX1(-0.5D0*F%SA(A,T),NI+NA+A,NI+T,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_SI) = 1 - Sum_SI Q_SI E_SI + ...
  SGM%COEF=0.0D0
  DO I=1,NI
    DO A=1,NS
      CALL WFN_EX1(-F%SI(A,I),NI+NA+A,I,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO I=1,NI
    DO A=1,NS
      CALL WFN_EX1(-0.5D0*F%SI(A,I),NI+NA+A,I,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! contract into X_i = <i|exp(-Q_IA)|RHS> and
  ! transform to adapt for the overcomplete basis
  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    X(ISD)=RHS%COEF(IA,IB)
  END DO


  ! compute the energy

  ! method 1: E2 = <V0|X>
  E2 = DDOT_(NSD,V0,1,X,1)
  WRITE(*,'(1X,A32,F21.14)') 'E2 as <V0|X> = ', E2

  ! method 2: E2 = <0|Ĥ|Psi1>
  ! first, form the first-order wavefunction |Psi1>
  PSI1%COEF=0.0D0
  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    PSI1%COEF(IA,IB)=X(ISD)
  END DO

  !WRITE(*,*) 'Final first-order wavefunction from UDL method:'
  !CALL WFN_PRINT(PSI1,1.0D-8)

  ! TAU still contains Ĥ|0>, so contract with |Psi1>
  E2 = DDOT_(PSI1%NDET,PSI1%COEF,1,TAU%COEF,1)
  WRITE(*,'(1X,A32,F21.14)') 'E2 as <Psi1|H|0> = ', E2

END SUBROUTINE CASPT2_UDL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE WRTVCD(SEGMNT,LU,IREW,LBLK)
C
C PRINT VECTOR ON FILE LU
C
C LBLK DEFINES STRUCTURE OF FILES :
C
      IMPLICIT REAL*8(A-H,O-Z)
#include "io_util.fh"
      DIMENSION SEGMNT(*),IDUMMY(1)
C
      IF( IREW .NE. 0 ) THEN
        IF( LBLK .GE. 0 ) THEN
          IDISK(LU)=0
        ELSE
          IDISK(LU)=0
        END IF
      END IF
C LOOP OVER BLOCKS
C
      IBLK = 0
 1000 CONTINUE
        IF ( LBLK .GT. 0 ) THEN
          LBL = LBLK
        ELSE IF ( LBLK .EQ. 0 ) THEN
          CALL IDAFILE(LU,2,IDUMMY,1,IDISK(LU))
          LBL=IDUMMY(1)
        ELSE
          CALL IDAFILE(LU,2,IDUMMY,1,IDISK(LU))
          LBL=IDUMMY(1)
          CALL IDAFILE(LU,2,IDUMMY,1,IDISK(LU))
        END IF
        IBLK = IBLK + 1
        IF(LBL .GE. 0 ) THEN
          IF(LBLK .GE.0 ) THEN
            KBLK = LBL
          ELSE
            KBLK = -1
          END IF
           CALL FRMDSC(  SEGMNT,    LBL ,    KBLK,      LU,  IMZERO,
     &                  IAMPACK)
           IF(LBL .GT. 0 ) THEN
             WRITE(6,'(A,I3,A,I6)')
     &       ' Number of elements in segment ',IBLK,' IS ',LBL
             CALL WRTMAT(SEGMNT,1,LBL,1,LBL)
           END IF
        END IF
C
      IF( LBL.GE. 0 .AND. LBLK .LE. 0) GOTO 1000
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ChkVec(OrbFileName,iVer,NSYM_L,NBAS_L,NORB_L,
     &                    InfoLbl,iRc)
      Character*(*) OrbFileName
      Character*8 InfoLbl
      Character*80 line
      Dimension NBAS_L(8)
      Dimension NORB_L(8)
#include "warnings.fh"
#include "inporbfmt.fh"
      Logical lExists

* Purpose: To check if OrbFileName is a valid orbital file, and which
* information it contains.
      Call f_Inquire(OrbFileName,lExists)
      If (.not.lExists) Go To 921
      LU=99
      LU=IsFreeUnit(LU)
      Call Molcas_Open(LU, OrbFileName)
* Check version!
      READ(LU,'(A80)',ERR=920,END=920) Line
      iVer=0
      Do jVer=1,mxVer
        if(Magic(jVer).eq.Line(1:len(Magic(jVer)))) iVer=jVer
      End Do
      iRc=_RC_IO_ERROR_READ_
      IF(iVer.eq.0) Return

* Find and read information section:
  10  CONTINUE
      READ(LU,'(A80)',ERR=920) LINE
      IF(LINE.NE.'#INFO') GOTO 10
  11  CONTINUE
      READ(LU,'(A80)',ERR=920) LINE
      IF(LINE(1:1).EQ.'*') GOTO 11
      READ(LINE,*) IUHF,NSYM_L
  12  CONTINUE
      READ(LU,'(A80)',ERR=920) LINE
      IF(LINE(1:1).EQ.'*') GOTO 12
      READ(LINE,*) (NBAS_L(I),I=1,NSYM_L)
  13  CONTINUE
      READ(LU,'(A80)',ERR=920) LINE
      IF(LINE(1:1).EQ.'*') GOTO 13
      READ(LINE,*) (NORB_L(I),I=1,NSYM_L)

* Create a InfoLbl telling what data sets are available:
      iORB=0
      iOCC=0
      iONE=0
      iIND=0
* Find section InfoLbls:
      If (IUHF.eq.0) Then
  21    CONTINUE
        READ(LU,'(A80)',END=900,ERR=900) LINE
        IF(LINE(1:4).EQ.'#ORB') iORB=1
        IF(LINE(1:4).EQ.'#OCC') iOCC=1
        IF(LINE(1:4).EQ.'#ONE') iONE=1
        IF(LINE(1:4).EQ.'#IND') iIND=1
        GOTO 21
      Else
  22    CONTINUE
        READ(LU,'(A80)',END=900,ERR=900) LINE
        IF(LINE(1:5).EQ.'#UORB') iORB=1
        IF(LINE(1:5).EQ.'#UOCC') iOCC=1
        IF(LINE(1:5).EQ.'#UONE') iONE=1
        IF(LINE(1:4).EQ.'#IND') iIND=1
        GOTO 22
      End If

* Intentionally reached end of file:
 900  CONTINUE
      InfoLbl=' '
      ip=0
      ip=ip+iorb
      if(iorb.eq.1) InfoLbl(ip:ip)='C'
      ip=ip+iocc
      if(iocc.eq.1) InfoLbl(ip:ip)='O'
      ip=ip+ione
      if(ione.eq.1) InfoLbl(ip:ip)='E'
      ip=ip+iind
      if(iind.eq.1) InfoLbl(ip:ip)='I'

* -----------------------------------------------------------------
      CLOSE(LU)
      iRC=_RC_ALL_IS_WELL_
      RETURN
* -----------------------------------------------------------------
 920  CONTINUE
      CLOSE(LU)
 921  CONTINUE
      iRC=_RC_IO_ERROR_READ_
      RETURN
* -----------------------------------------------------------------
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RASSI(IRETURN)

      !> module dependencies
      use rassi_global_arrays, only: HAM, SFDYS, SODYSAMPS, EIGVEC,
     &                               SODYSAMPSR, SODYSAMPSI,
     &                               PROP, ESHFT, HDIAG, JBNUM, LROOT
      use rassi_aux
      use kVectors
#ifdef _HDF5_
      use Dens2HDF5
      use mh5, only: mh5_put_dset
#endif
#ifdef _DMRG_
      use qcmaquis_interface_cfg
      use qcmaquis_interface, only: qcmaquis_interface_deinit
      use qcmaquis_info, only : qcmaquis_info_deinit
      use rasscf_data, only: doDMRG
#endif
      use Fock_util_global, only: Fake_CMO2

      use mspt2_eigenvectors, only : deinit_mspt2_eigenvectors

      IMPLICIT REAL*8 (A-H,O-Z)
C Matrix elements over RAS wave functions.
C RAS state interaction.
#include "rasdim.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "Morsel.fh"
#include "Struct.fh"
#include "SysDef.fh"
#include "rassi.fh"
#include "prgm.fh"
#include "rasdef.fh"
#include "jobin.fh"
#include "symmul.fh"
#include "rassiwfn.fh"
#include "stdalloc.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='RASSI')
      Logical CLOSEONE
      INTEGER IRC
      Real*8, Allocatable:: USOR(:,:),
     &                      USOI(:,:), OVLP(:,:), DYSAMPS(:,:),
     &                      ENERGY(:), DMAT(:), TDMZZ(:),
     &                      VNAT(:),OCC(:), SOENE(:)
      Integer, Allocatable:: IDDET1(:)
*                                                                      *
************************************************************************
*                                                                      *
*     Prolouge
*
      IRETURN=20

      Call StatusLine('RASSI:','Starting calculation')

      CALL GETPRINTLEVEL


C Greetings. Default settings. Initialize data sets.
      CALL INIT_RASSI()

      CLOSEONE=.FALSE.
      IRC=-1
      CALL OPNONE(IRC,0,'ONEINT',LUONE)
      IF (IRC.NE.0) Then
         WRITE (6,*) 'RASSI: Error opening file'
         CALL ABEND()
      END IF
      CLOSEONE=.TRUE.

C Read and check keywords etc. from stdin. Print out.
      CALL INPCTL_RASSI()

CSVC: prepare HDF5 wavefunction file
      CALL CRE_RASSIWFN

C--------  RAS wave function section --------------------------
C First, in a double loop over the states, compute any matrix
C elements required for the input RASSCF state pairs.
C Needed generalized transition density matrices are computed by
C GTDMCTL. They are written on unit LUTDM.
C Needed matrix elements are computed by PROPER.
      Call mma_allocate(OVLP,NSTATE,NSTATE,Label='OVLP')
      Call mma_allocate(DYSAMPS,NSTATE,NSTATE,Label='DYSAMPS')
      Call mma_allocate(EigVec,nState,nState,Label='EigVec')
      Call mma_allocate(ENERGY,nState,Label='Energy')
      Call mma_allocate(TocM,NSTATE*(NSTATE+1)/2,Label='TocM')

      Call mma_allocate(PROP,NSTATE,NSTATE,NPROP,LABEL='Prop')
      Prop(:,:,:)=0.0D0
*                                                                      *
************************************************************************
*                                                                      *
C Number of basis functions
      NZ=0                      ! (NBAS is already used...)
      DO ISY=1,NSYM
         NZ=NZ+NBASF(ISY)
      END DO
      IF (DYSO) Call mma_allocate(SFDYS,nZ,nState,nState,Label='SFDYS')

*
C Loop over jobiphs JOB1:
      Call mma_allocate(IDDET1,nState,Label='IDDET1')
      IDISK=0  ! Initialize disk address for TDMs.
      DO JOB1=1,NJOB
        DO JOB2=1,JOB1

        Fake_CMO2 = JOB1.eq.JOB2  ! MOs1 = MOs2  ==> Fake_CMO2=.true.

C Compute generalized transition density matrices, as needed:
          CALL GTDMCTL(PROP,JOB1,JOB2,OVLP,DYSAMPS,NZ,IDDET1,IDISK)
        END DO
      END DO
      Call mma_deallocate(IDDET1)

#ifdef _HDF5_
      CALL mh5_put_dset(wfn_overlap,OVLP,[NSTATE,NSTATE],[0,0])
#endif
      Call Put_dArray('State Overlaps',OVLP,NSTATE*NSTATE)

      IF(TRACK) CALL TRACK_STATE(OVLP)
      IF(TRACK.OR.ONLY_OVERLAPS) THEN

C       Print the overlap matrix here, since MECTL is skipped
        IF(IPGLOB.GE.USUAL) THEN
          WRITE(6,*)
          WRITE(6,*)'     OVERLAP MATRIX FOR THE ORIGINAL STATES:'
          WRITE(6,*)
          DO ISTATE=1,NSTATE
            WRITE(6,'(5(1X,F15.8))')(Ovlp(j,iState),j=1,istate)
          END DO
        END IF
        GOTO 100
      END IF

C Property matrix elements:
      Call StatusLine('RASSI:','Computing matrix elements.')
      CALL MECTL(PROP,OVLP,HAM,ESHFT)
*                                                                      *
************************************************************************
*                                                                      *
*     Spin-free section
*
C--------  SI wave function section --------------------------
C In a second section, if Hamiltonian elements were requested,
C then also a set of secular equations are solved. This gives
C a set of non-interacting, orthonormal wave functions expressed
C as linear combinations of the input wave functions. These
C results are written out, as well as the matrix elements  of
C the eigenstates, and if requested, their density matrices
C and perhaps GTDMs.

C Hamiltonian matrix elements, eigenvectors:
      IF(IFHAM) THEN
        Call StatusLine('RASSI:','Computing Hamiltonian.')
        CALL EIGCTL(PROP,OVLP,DYSAMPS,HAM,EIGVEC,ENERGY)
      END IF


! +++ J. Creutzberg, J. Norell - 2018
! Write the spin-free Dyson orbitals to .DysOrb and .molden
! files if requested
*----------------------------------------------------------------

      IF (DYSEXPORT) THEN

       CALL WRITEDYS(DYSAMPS,SFDYS,NZ,ENERGY)

      END IF
! +++


*---------------------------------------------------------------------*
C Natural orbitals, if requested:
      IF(NATO) THEN
C CALCULATE AND WRITE OUT NATURAL ORBITALS.
        Call mma_allocate(DMAT,nBSQ,Label='DMAT')
        Call mma_allocate(TDMZZ,nTDMZZ,Label='TDMZZ')
        Call mma_allocate(VNAT,nBSQ,Label='VNAT')
        Call mma_allocate(OCC,nBST,Label='OCC')
*
        CALL NATORB_RASSI(DMAT,TDMZZ,VNAT,OCC,EIGVEC)
        CALL NATSPIN_RASSI(DMAT,TDMZZ,VNAT,OCC,EIGVEC)
*
        Call mma_deallocate(DMAT)
        Call mma_deallocate(TDMZZ)
        Call mma_deallocate(VNAT)
        Call mma_deallocate(OCC)
      END IF
C Bi-natural orbitals, if requested:
      IF (BINA) CALL BINAT()
*
      IF(.NOT.IFHAM) GOTO 100

*                                                                      *
************************************************************************
*                                                                      *
*      Spin_Orbit section
*
C-------- Spin-Orbit calculations   --------------------------
C In this third section, if spin-orbit coupling parameters were
C computed by the previous sections, then additionally the
C spin-orbit eigenfunctions and levels are computed.

C Nr of spin states and division of loops:
      NSS=0
      DO ISTATE=1,NSTATE
         JOB=JBNUM(ISTATE)
         MPLET=MLTPLT(JOB)
         NSS=NSS+MPLET
      END DO

      Call mma_allocate(USOR,NSS,NSS,Label='USOR')
      USOR(:,:)=0.0D0
      For All (i=1:NSS) USOR(i,i)=1.0D0
      Call mma_allocate(USOI,NSS,NSS,Label='USOI')
      USOI(:,:)=0.0D0
      Call mma_allocate(SOENE,nSS,Label='SOENE')
      SOENE(:)=0.0D0

      IF(IFSO) THEN
        Call StatusLine('RASSI:','Computing SO Hamiltonian.')
        CALL SOEIG(PROP,USOR,USOI,SOENE,NSS,ENERGY)
      END IF

C Store TDMs in HDF5
#ifdef _HDF5_
      Call StoreDens(EigVec)
#endif

! +++ J. Norell - 2018
C Make the SO Dyson orbitals and amplitudes from the SF ones

      IF (DYSO.AND.IFSO) THEN
         Call mma_allocate(SODYSAMPS,NSS,NSS,Label='SODYSAMPS')
         Call mma_allocate(SODYSAMPSR,NSS,NSS,Label='SODYSAMPSR')
         Call mma_allocate(SODYSAMPSI,NSS,NSS,Label='SODYSAMPSI')

         CALL SODYSORB(NSS,USOR,USOI,DYSAMPS,NZ,SOENE)
      END IF

      IF (Allocated(SFDYS)) Call mma_deallocate(SFDYS)
! +++

      CALL PRPROP(PROP,USOR,USOI,SOENE,NSS,OVLP,
     &            ENERGY,JBNUM,EigVec)

C Plot SO-Natural Orbitals if requested
C Will also handle mixing of states (sodiag.f)
      IF(SONATNSTATE.GT.0) THEN
        CALL DO_SONATORB(NSS,USOR,USOI)
      END IF
C Plot SO-Natural Transition Orbitals if requested
      IF(SONTOSTATES.GT.0) THEN
        CALL DO_SONTO(NSS,USOR,USOI)
      END IF

      Call mma_deallocate(USOR)
      Call mma_deallocate(USOI)
      Call mma_deallocate(SOENE)
      IF (DYSO.AND.IFSO) THEN
         Call mma_deallocate(SODYSAMPS)
         Call mma_deallocate(SODYSAMPSR)
         Call mma_deallocate(SODYSAMPSI)
      END IF
*                                                                      *
************************************************************************
*                                                                      *
*   Trajectory Surface Hopping                                         *
*                                                                      *
*   Turns on the procedure if the Keyword HOP was specified.           *
*                                                                      *
      IF (HOP) then
        Call StatusLine('RASSI:','Trajectory Surface Hopping')
        CALL TSHinit(ENERGY)
      END IF
*                                                                      *
************************************************************************
*                                                                      *
* CEH April 2015 DQV diabatization scheme
* This passes the PROP matrix into the DQV diabatization subroutine
* The subroutine will compute a transformation matrix, which is used
* to compute diabats.
*
* The user has to compute x, y, z, xx, yy, zz, 1/r in this order.

      IF (DQVD) then
        Call StatusLine('RASSI:', 'DQV Diabatization')
        CALL DQVDiabat(PROP,HAM)
      END IF
*                                                                      *
************************************************************************
*                                                                      *
*     EPILOUGE                                                         *
*                                                                      *
************************************************************************
*                                                                      *
 100  CONTINUE
      Call mma_deallocate(Ovlp)
      Call mma_deallocate(DYSAMPS)
      Call mma_deallocate(HAM)
      Call mma_deallocate(EigVec)
      Call mma_deallocate(Energy)
      Call mma_deallocate(ESHFT)
      Call mma_deallocate(HDIAG)
      Call mma_deallocate(jDisk_TDM)
      Call mma_deallocate(JBNUM)
      Call mma_deallocate(LROOT)
      Call mma_deallocate(TocM)
      Call mma_deallocate(Prop)

      If (Do_SK) Call mma_deallocate(k_Vector)

      IF (CLOSEONE) THEN
         IRC=-1
         CALL CLSONE(IRC,0)
         IF (IRC.NE.0) Then
            WRITE (6,*) 'RASSI: Error opening file'
            CALL ABEND()
         END IF
      END IF

#ifdef _DMRG_
!     !> finalize MPS-SI interface
      if (doDMRG)then
        call qcmaquis_interface_deinit
        call qcmaquis_info_deinit
      end if
#endif
!     > free memory (if allocated at all - currently only for QD-NEVPT2 as ref wfn)
      call deinit_mspt2_eigenvectors()
*                                                                      *
************************************************************************
*                                                                      *
*     Close dafiles.
*
      Call DaClos(LuScr)
      IF (SaveDens) Then
         Call DaClos(LuTDM)
         If (Allocated(JOB_INDEX)) Call mma_deallocate(JOB_INDEX)
         If (Allocated(CMO1)) Call mma_deallocate(CMO1)
         If (Allocated(CMO2)) Call mma_deallocate(CMO2)
         If (Allocated(DMAB)) Call mma_deallocate(DMAB)
      End If
      Call DaClos(LuExc)
*                                                                      *
************************************************************************
*                                                                      *
*     PRINT I/O STATISTICS:
      i=iPrintLevel(3)
      CALL FASTIO('STATUS')

      Call StatusLine('RASSI:','Finished.')
      IRETURN=0
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
*               Thomas Bondo Pedersen                                  *
************************************************************************
      Subroutine Readinp_localisation()
c
c     Author: Y. Carissan [heavily modified by T.B. Pedersen].
c
      Implicit Real*8(a-h,o-z)
#include "Molcas.fh"
#include "inflocal.fh"
#include "debug.fh"
c
cTBP  Namelist /LOCALISATION/ dummy
c
      Character*20 SecNam
      Parameter (SecNam = 'Readinp_localisation')
c
      Character*180  Key, Line, Blank
      Character*180 Get_Ln
      External Get_Ln
c
      Integer  iPrintLevel
      External iPrintLevel
c
      Logical Thrs_UsrDef, LocModel_UsrDef, Freeze
      Parameter (ThrsDef = 1.0d-6, ThrRotDef = 1.0d-10)
      Parameter (ThrGradDef = 1.0d-2)
c
      LuSpool=17
      LuSpool=isFreeUnit(LuSpool)
      Call SpoolInp(LuSpool)
c
      Debug=.False.
c---- Locate "start of input"
      Rewind(LuSpool)
      Call RdNLst(LuSpool,'LOCALISATION')
      Blank=' '
c
c Get print level
c
      iPL = iPrintLevel(-1)
c
c Default Parameters
c
      Do iSym = 1,nSym
         nOrb2Loc(iSym) = 0
         nFro(iSym) = 0
         nConstr(iSym) = 0
      End Do
      Skip = .False.
      LocOrb=Occupied
*     LocVir = .False.
      Thrs_UsrDef = .False.
      nOrb2Loc_UsrDef = .False.
      nFro_UsrDef = .False.
      Freeze = .False.
      If (iPL .ge. 4) Then
         Debug = .True.
      Else
         Debug = .False.
      End If
      Maximisation = .True.
      ChoStart = .False.
      If (iPL .lt. 3) Then
         Silent = .True.
      Else
         Silent = .False.
      End If
      LocModel = 1  ! Pipek-Mezey localisation
      If (nSym.gt.1) LocModel = 3  ! Cholesky localisation
      LocModel_UsrDef = .False.
      Test_Localisation = .False.
      NMxIter = 300
      Thrs = ThrsDef
      ThrRot = ThrRotDef
      ThrGrad = ThrGradDef
      Analysis = .False.
      AnaAtom  = nSym.eq.1
      AnaNrm = 'Fro'
      PrintMOs = .True.
      Timing = .True.
      EvalER = .False.
      Order = .False.
      LocPAO = .False.
      AnaPAO = .False.
      AnaPAO_Save = AnaPAO
      DoDomain = .False.
      AnaDomain = .False.
      ThrDomain(1) = 9.0d-1
      ThrDomain(2) = 2.0d-2
      ThrPairDomain(1) = 1.0d-10
      ThrPairDomain(2) = 1.0d1
      ThrPairDomain(3) = 1.5d1
      LocNatOrb=.false.
      LocCanOrb=.false.
      Wave=.false.
      iWave=0
      DoCNOs=.false.
c
c End Default Parameters
c
  999 Continue
      Key = Get_Ln(LuSpool)
      Line = Key
      Call UpCase(Line)
      If (Line(1:4).eq.'DEBU') Go To 1000
      If (Line(1:4).eq.'NORB') Go To 2000
      If (Line(1:4).eq.'NFRO') Go To 2100
      If (Line(1:4).eq.'FREE') Go To 2200
      If (Line(1:4).eq.'MAXI') Go To 3000
      If (Line(1:4).eq.'MINI') Go To 3100
      If (Line(1:4).eq.'NITE') Go To 4000
      If (Line(1:4).eq.'ITER') Go To 4000
      If (Line(1:4).eq.'THRE') Go To 5000
      If (Line(1:4).eq.'THRG') Go To 5001
      If (Line(1:4).eq.'CHOS') Go To 5100
      If (Line(1:4).eq.'THRR') Go To 6000
      If (Line(1:4).eq.'PIPE') Go To 7000
      If (Line(1:4).eq.'PM  ') Go To 7000
      If (Line(1:4).eq.'BOYS') Go To 7100
      If (Line(1:4).eq.'CHOL') Go To 7200
      If (Line(1:4).eq.'EDMI') Go To 7300
      If (Line(1:4).eq.'ER  ') Go To 7300
      If (Line(1:4).eq.'SILE') Go To 8000
      If (Line(1:4).eq.'TEST') Go To 9000
      If (Line(1:4).eq.'ANAL') Go To 10000
      If (Line(1:4).eq.'ANAA') Go To 10100
      If (Line(1:4).eq.'ANAS') Go To 10200
      If (Line(1:4).eq.'MAX ') Go To 10300
      If (Line(1:4).eq.'FROB') Go To 10310
      If (Line(1:4).eq.'NOMO') Go To 11000
      If (Line(1:4).eq.'TIME') Go To 12000
      If (Line(1:4).eq.'NOTI') Go To 12100
      If (Line(1:4).eq.'ERFU') Go To 13000
      If (Line(1:4).eq.'ORDE') Go To 14000
      If (Line(1:4).eq.'VIRT') Go To 15000
      If (Line(1:4).eq.'OCCU') Go To 15100
      If (Line(1:4).eq.'ALL ') Go To 15200
      If (Line(1:4).eq.'PAO ') Go To 16000
      If (Line(1:4).eq.'ANAP') Go To 16100
      If (Line(1:4).eq.'DOMA') Go To 17000
      If (Line(1:4).eq.'THRD') Go To 17100
      If (Line(1:4).eq.'THRP') Go To 17200
      If (Line(1:4).eq.'ANAD') Go To 17300
      If (Line(1:4).eq.'SKIP') Go To 18000
      If (Line(1:4).eq.'LOCN') Go To 18100
      If (Line(1:4).eq.'LOCC') Go To 18200
      If (Line(1:4).eq.'WAVE') Go To 18300
      If (Line(1:4).eq.'CONS') Go To 18400
      If (Line(1:4).eq.'FILE') Go To 18500
      If (Line(1:4).eq.'END ') Go To 99999
      Write (6,*) 'Unidentified key word  : ',Key
      Write (6,*) 'Internal representation: ',Line(1:4)
      Call FindErrorLine
      Call Quit_OnUserError()
c
c DEBUg
c
 1000 Continue
      Debug=.True.
      Go To 999
c
c NORBitals
c
 2000 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,nOrb2Loc,nSym)
      nOrb2Loc_UsrDef=.True.
      Go To 999
c
c NFROzen
c
 2100 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,nFro,nSym)
      nFro_UsrDef=.True.
      Freeze = .False.
      If (LocOrb.eq.Virtual) Then
*     If (LocVir) Then
         Write (6,*)
         Write (6,*) 'WARNING!!!'
         Write (6,*) 'You have chosen to freeze some orbitals AND asked'
     &             //' to localize the virtual space. This implies that'
         Write (6,*) ' some virtual orbitals will be kept frozen, thus '
     &             //'they will be left unchanged. Is that OK ?'
         Write (6,*)
      EndIf
      Go To 999
c
c FREEze core orbitals (as defined by seward)
c
 2200 Continue
      If(.not.nFro_UsrDef)Then
        Call Get_iArray('Non valence orbitals',nFro,nSym)
        Freeze = .True.
        If (LocOrb.eq.Virtual) Then
*       If (LocVir) Then
         Write (6,*)
         Write (6,*) 'WARNING!!!'
         Write (6,*) 'You have chosen to freeze some orbitals AND asked'
     &             //' to localize the virtual space. This implies that'
         Write (6,*) ' some virtual orbitals will be kept frozen, thus '
     &             //'they will be left unchanged. Is that OK ?'
         Write (6,*)
        EndIf
      End If
      Go To 999
c
c MAXImisation
c
 3000 Continue
      Maximisation=.True.
      Go To 999
c
c MINImisation
c
 3100 Continue
      Maximisation=.False.
      Go To 999
c
c NITErations or ITERations
c
 4000 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I1(1,NMxIter)
      Go To 999
c
c THREshold
c
 5000 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,Thrs)
      Thrs_UsrDef = .True.
      Go To 999
c
c THRGrad
c
 5001 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,ThrGrad)
      Go To 999
c
c CHOStart (use Cholesky orbitals as start guess for PM/Boys/ER)
c
 5100 Continue
      ChoStart = .True.
      Go To 999
c
c THRRotation
c
 6000 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,ThrRot)
      Go To 999
c
c PIPEk-Mezey or PM
c
 7000 Continue
      LocModel = 1
      LocModel_UsrDef = .True.
      Go To 999
c
c BOYS
c
 7100 Continue
      LocModel = 2
      LocModel_UsrDef = .True.
      Go To 999
c
c CHOLesky
c
 7200 Continue
      LocModel = 3
      LocModel_UsrDef = .True.
      Go To 999
c
c EDMIston-Ruedenberg or ER
c
 7300 Continue
      LocModel = 4
      LocModel_UsrDef = .True.
      Go To 999
c
c SILEnt mode
c
 8000 Continue
      Silent = .True.
      Go To 999
c
c TEST localisation (orthonormality, density, etc.)
c
 9000 Continue
      Test_Localisation = .True.
      Go To 999
c
c ANALysis: generate bitmaps + histograms for density, original, and
c           local MOs. Analysis "per atom" is default, but does not work
c           with symmetry.
c
10000 Continue
      Analysis = .True.
      AnaAtom  = nSym.eq.1
      Go To 999
c
c ANAAtom: generate bitmaps + histograms for density, original, and
c          local MOs. Analysis "per atom".
c
10100 Continue
      Analysis = .True.
      AnaAtom  = .True.
      Go To 999
c
c ANAShell: generate bitmaps + histograms for density, original, and
c           local MOs. Analysis "per shell".
c
10200 Continue
      Analysis = .True.
      AnaAtom  = .False.
      Go To 999
c
c MAX norm: use max element as norm in analysis.
c
10300 Continue
      AnaNrm  = 'Max'
      Go To 999
c
c FROBenius norm: use Frobenius norm in analysis.
c
10310 Continue
      AnaNrm  = 'Fro'
      Go To 999
c
c NOMO: do not print MOs.
c
11000 Continue
      PrintMOs = .False.
      Go To 999
c
c TIME: time the localisation procedure explicitly
c
12000 Continue
      Timing = .True.
      Go To 999
c
c NOTI: do not time the localisation procedure explicitly
c
12100 Continue
      Timing = .False.
      Go To 999
c
c ERFUnctional: evaluate Edmiston-Ruedenberg functional with original
c               and localised orbitals.
c
13000 Continue
      EvalER = .True.
      Go To 999
c
c ORDEr: order localised orbitals according to Cholesky orbital
c        ordering, defined according to the overlap between the two sets
c        orbitals.
c
14000 Continue
      Order = .True.
      Go To 999
c
c VIRTual: localise virtual orbitals
c
15000 Continue
      LocOrb = Virtual
*     LocVir = .True.
      If (nFro_UsrDef .or. Freeze) Then
         Write (6,*)
         Write (6,*) 'WARNING!!!'
         Write (6,*) 'You have chosen to freeze some orbitals AND asked'
     &             //' to localize the virtual space. This implies that'
         Write (6,*) ' some virtual orbitals will be kept frozen, thus '
     &             //'they will be left unchanged. Is that OK ?'
         Write (6,*)
      EndIf
      Go To 999
c
c OCCUpied: localise occupied orbitals
c
15100 Continue
      LocOrb = Occupied
*     LocVir = .False.
      Go To 999
c
c ALL: localise all orbitals
c
15200 Continue
      LocOrb = All
      Go To 999
c
c PAO : compute projected AOs that span the virtual space
c       (= all - occupied - frozen) using Cholesky decomposition to
c       remove linear dependence.
c
16000 Continue
      LocPAO = .True.
      LocModel = 3
      LocModel_UsrDef = .True.
      Go To 999
c
c ANAP: Special analysis for Cholesky PAOs before orthonormalization.
c
16100 Continue
      AnaPAO = .True.
      Go To 999
c
c DOMAin: set up orbital domains (Pulay-style) and pair domains
c
17000 Continue
      DoDomain = .True.
      Go To 999
c
c THRDomain: thresholds for setting up orbital domains.
c            First value is the minimum sum of gross atomic Mulliken
c            charge for each orbital.
c            Second value is the threshold used for the completeness
c            check of Boughton and Pulay.
c
17100 Continue
      DoDomain = .True.
      Line=Get_Ln(LuSpool)
      Call Get_F(1,ThrDomain,2)
      Go To 999
c
c THRPairdomain: thresholds for setting up pair domains.
c                3 values needed: Rs, Rw, Rd (in bohr).
c                Let R be the minimum distance between any two atoms in
c                a pair domain. Then,
c                     R <= Rs: strong pair
c                Rs < R <= Rw: weak pair
c                Rw < R <= Rd: distant pair
c                Rd < R <= Rd: very distant pair
c
17200 Continue
      DoDomain = .True.
      Line=Get_Ln(LuSpool)
      Call Get_F(1,ThrPairDomain,3)
      Go To 999
c
c ANADomain: analysis of orbital domains
c
17300 Continue
      AnaDomain = .True.
      DoDomain = .True.
      Go To 999
c
c SKIP: skip localisation completely; i.e. only perform analysis etc.
c
18000 Continue
      Skip = .True.
      Go To 999
c
c LOCN: localized natural orbitals
c
18100 Continue
      LocNatOrb=.true.
      Read(LuSpool,*) nActa, ThrSel
*     Read atom names
18101 Read(LuSpool,'(A)',End=9940) Line
      If ( Line(1:1).eq.'*' ) Goto 18101
      If ( Line.eq.Blank ) Goto 18101
      Call UpCase(Line)
      Do i=1,nActa
       Call LeftAd(Line)
       If( Line.eq.Blank ) Goto 9940
       j=Index(Line,' ')
       NamAct(i)=Line(1:j-1)
       Line(1:j-1)=Blank(1:j-1)
      Enddo
      Go To 999
c
c LOCC: localized canonical orbitals
c
18200 Continue
      LocCanOrb=.true.
      Read(LuSpool,*) nActa, ThrSel
*     Read atom names
      Read(LuSpool,'(A)',End=9940) Line
      If ( Line(1:1).eq.'*' ) Goto 18101
      If ( Line.eq.Blank ) Goto 18101
      Call UpCase(Line)
      Do i=1,nActa
       Call LeftAd(Line)
       If( Line.eq.Blank ) Goto 9940
       j=Index(Line,' ')
       NamAct(i)=Line(1:j-1)
       Line(1:j-1)=Blank(1:j-1)
      Enddo
      Go To 999
c
c WAVE: wavelet transform of the MO basis
c
18300 Continue
      Read(LuSpool,*) iWave
      If (iWave.ne.0 .and. iWave.ne.1) Then
         Write (6,*) ' WARNING!!!'
         Write (6,*) ' Incorrect bit-switch input parameter for WAVE.'
         Write (6,*) ' I will continue with the default value.'
         iWave=0
      EndIf
      Skip=.false.
      Wave=.true.
      LocModel=0
      Go To 999
c
c CONS: constrained natural orbital analysis
c
18400 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,nConstr,nSym)
      MxConstr=0
      Do i=1,nSym
         MxConstr=Max(MxConstr,nConstr(i))
      End Do
      If (MxConstr.gt.16) Then
        Write (6,*) ' ERROR  !!!'
        Write (6,*) ' Cannot handle more than 16 constraints/symm !!'
        Write (6,*) ' Increase size of indxC in Get_CNOs and recompile.'
      EndIf
      DoCNOs=.true.
      Skip=.false.
      PrintMOs=.false.
      LocModel=0
      Go To 999
c
c FILE: filename with input orbitals
c
18500 Continue
      Line=Get_Ln(LuSpool)
C     Filename is read in localisation.f
      Go To 999
c
c END of Input
c
99999 Continue

C     ==============
C     Postprocessing
C     ==============

C     Only Cholesky localisation can be run with symmetry.
C     Reset if the user explicitly requested a localisation
C     model different from Cholesky.
C     ------------------------------------------------------------------

      If (nSym.gt.1 .and. LocModel_UsrDef .and. .not.LocModel.eq.3) Then
         Write (6,*)
         Write (6,*) 'WARNING!!!'
         Write (6,*) 'The localisation model you have suggested in '
     &             //'combination with symmetry will not work.'
         Write (6,*) 'In this case the program defaults to the '
     &             //'Cholesky localisation scheme!'
         Write (6,*)
         LocModel = 3
      End If

C     Special settings for PAO: LocModel must be 3 (i.e. Cholesky), else
C     we cancel PAO. For PAO, special analysis may be activated by the
C     DEBUg keyword.
C     ------------------------------------------------------------------

      LocPAO = LocPAO .and. LocModel.eq.3
      If (LocPAO) Then
         AnaPAO = AnaPAO .or. Debug
      Else
         AnaPAO = .False.
      End If

C     Set orbitals to localize.
C     If the user specified which orbitals to localise, frozen orbitals
C     is not our problem (the user must set those as well or use the
C     default).
C     If the user did not specify which orbitals to localise, we have
C     several cases (remembering that virtual localisation is default
C     for the PAO method):
C     For virtual localisation (specified with keyword VIRTual):
C        user-defined frozen orbitals are regarded as frozen virtual,
C        else we freeze all occupied and localise the rest. Note that
C        keyword FREEze is ignored for virtual localisation!
C     For occupied localisation (default for all methods but PAO):
C        user-defined frozen orbitals (possibly by FREEze keyword)
C        are subtracted from the set of occupied orbitals, else we
C        localise all occupied.
C     -----------------------------------------------------------------

      If (nOrb2Loc_UsrDef) Then
         LocOrb = Occupied
*        LocVir = .False.
      Else
*        If (LocOrb.eq.Virtual .or. LocPAO) Then
*           LocOrb = Virtual
*        End If
*        LocVir = LocVir .or. LocPAO ! virtual is default for PAO
         If (LocOrb.eq.Virtual) Then ! virtual localisation
*        If (LocVir) Then ! virtual localisation
            If (nFro_UsrDef) Then
               Do iSym = 1,nSym
                  nFro(iSym) = nOccInp(iSym) + nFro(iSym)
                  nOrb2Loc(iSym) = nOrb(iSym) - nFro(iSym)
               End Do
            Else
               Do iSym = 1,nSym
                  nFro(iSym) = nOccInp(iSym)
                  nOrb2Loc(iSym) = nVirInp(iSym)
               End Do
            End If
         Else If (LocOrb.eq.Occupied) Then ! occupied localisation
*        Else ! occupied localisation
            If (nFro_UsrDef .or. Freeze) Then
               Do iSym = 1,nSym
                  nOrb2Loc(iSym) = nOccInp(iSym) - nFro(iSym)
               End Do
            Else
               Do iSym = 1,nSym
                  nOrb2Loc(iSym) = nOccInp(iSym)
               End Do
            End If
         Else ! All
            If (nFro_UsrDef .or. Freeze) Then
               Do iSym = 1,nSym
                  nOrb2Loc(iSym) = nOccInp(iSym) + nVirInp(iSym)
     &                           - nFro(iSym)
               End Do
            Else
               Do iSym = 1,nSym
                  nOrb2Loc(iSym) = nOccInp(iSym) + nVirInp(iSym)
               End Do
            End If
         End If
      End If

      If (Debug) Then
         Write(6,'(/,A,A)') SecNam,': orbital definitions:'
         Write(6,'(A,8I9)') 'nBas    : ',(nBas(iSym),iSym=1,nSym)
         Write(6,'(A,8I9)') 'nOrb    : ',(nOrb(iSym),iSym=1,nSym)
         Write(6,'(A,8I9)') 'nOccInp : ',(nOccInp(iSym),iSym=1,nSym)
         Write(6,'(A,8I9)') 'nVirInp : ',(nVirInp(iSym),iSym=1,nSym)
         Write(6,'(A,8I9)') 'nFro    : ',(nFro(iSym),iSym=1,nSym)
         Write(6,'(A,8I9,/)') 'nOrb2Loc: ',(nOrb2Loc(iSym),iSym=1,nSym)
      End If

C     If Cholesky, reset default threshold (unless user defined).
C     -----------------------------------------------------------

      If (LocModel.eq.3 .and. .not.Thrs_UsrDef) Then
         Thrs = 1.0d-8
      End If

C     No need to order Cholesky MOs.
C     ------------------------------

      Order = Order .and. LocModel.ne.3

C     No need to evaluate ER function for Edmiston-Ruedenberg.
C     --------------------------------------------------------

      EvalER = EvalER .and. LocModel.ne.4

C     Turn on localisation test if debug or analysis was specified.
C     -------------------------------------------------------------

      Test_Localisation = Test_Localisation .or. Debug .or. Analysis

      Go To 9950

9940  Continue
      WRITE(6,*)' READIN: Premature end of file when reading selected'
      WRITE(6,*)' atoms in keyword LOCN'
      CALL ABEND()

9950  Continue

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
          SubRoutine MkFck(iAnga,iCmpa,iCmp,
     &                        Shijij,
     &                        iShll,iShell,
     &                        iBasi,jBasj,kBask,lBasl,
     &                        iAO,iAOst,nOp,jOp,
     &                        Dij,mDij,nDij,ij1,ij2,ij3,ij4,
     &                        Dkl,mDkl,nDkl,kl1,kl2,kl3,kl4,
     &                        Dik,mDik,nDik,ik1,ik2,ik3,ik4,
     &                        Dil,mDil,nDil,il1,il2,il3,il4,
     &                        Djk,mDjk,nDjk,jk1,jk2,jk3,jk4,
     &                        Djl,mDjl,nDjl,jl1,jl2,jl3,jl4,
     &                        AOInt,nAO,TwoHam,nFock,
     &                        Scrtch1,nS1,Scrtch2,nS2,
     &                        iDCRR,iDCRS,iDCRT,FckTmp,nFT,
     &                        pert,iuvwx,iCent,iCar,indgrd,ipDisp)
*
************************************************************************
*                                                                      *
* Object: Driver for the generation of the two electron contribution   *
*         to the Fock Matrix directly from the two electron integrals. *
*                                                                      *
*     Author:  Anders Bernhardsson 1995                                *
************************************************************************
      use Real_Spherical
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "disp.fh"
#include "disp2.fh"
*
      Real*8 Dij(mDij,nDij),Dkl(mDkl,nDkl),Dik(mDik,nDik),
     &       Dil(mDil,nDil),Djk(mDjk,nDjk),Djl(mDjl,nDjl),
     &       FckTmp(nFT),AOInt(nAO),TwoHam(nFock),
     &       Scrtch1(nS1),Scrtch2(nS2)
      Integer iCmp(4), nOp(4),iAnga(4), iShll(4),iShell(4),
     &        jOp(6),iCmpa(4) , iAO(4), iAOst(4),
     &        indgrd(3,4,0:7),ipdisp(*)
      Logical Shijij,pert(0:7)
*
*     Just the make a nice interface
*
c     iRout = 12
c     iPrint = nPrint(iRout)
      nijkl=iBasi*jBasj*kBask*lBasl
*
*--------------Accumulate contributions directly to the symmetry
*              adapted Fock matrix.
*
      Fact=DBLE(iuvwx)/DBLE(nIrrep)
*
      Call FckAcc_mck(iAnga,iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &            Shijij,iShll,iShell,nOp,nijkl,
     &            AOInt,TwoHam,nFock,Scrtch2,nS2,
     &            iAO,iAOst,
     &            iBasi,jBasj,kBask,lBasl,
     &            Dij(1,jOp(1)),ij1,ij2,ij3,ij4,
     &            Dkl(1,jOp(2)),kl1,kl2,kl3,kl4,
     &            Dik(1,jOp(3)),ik1,ik2,ik3,ik4,
     &            Dil(1,jOp(4)),il1,il2,il3,il4,
     &            Djk(1,jOp(5)),jk1,jk2,jk3,jk4,
     &            Djl(1,jOp(6)),jl1,jl2,jl3,jl4,
     &            FckTmp,nFT,fact,iCar,iCent,pert,indgrd,ipdisp)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(iCmpa)
         Call Unused_real_array(Scrtch1)
         Call Unused_integer(iDCRR)
         Call Unused_integer(iDCRS)
         Call Unused_integer(iDCRT)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkOE(OE)
! OEo(i) <- OE(i)
! OEv(a) <- OE(a)

use chcc_global, only: no, nv, OEo, OEv
use stdalloc, only: mma_allocate
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: OE(no+nv)

call mma_allocate(OEo,no,label='OEo')
call mma_allocate(OEv,nv,label='OEv')

OEo(:) = OE(1:no)

OEv(:) = OE(no+1:no+nv)

return

end subroutine MkOE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine InsReaW4 (aSGrp,bSGrp,cSGrp,dSGrp,length)
c
c        this routine do:
c        Check which W4 file corresponds to given combination
c        of indexes,
c        - increase the parameter, checking the overal number of
c        required integrals if these block is conted first time
c        - and set corresponding InqW4 to T
c
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "parcc.fh"
c
        integer aSGrp,bSGrp,cSGrp,dSGrp,length
c
c        help variables
        integer abSGrp,cdSGrp
        integer abLen,cdLen,abcdLen
        integer dima,dimb,dimc,dimd
        integer pSGrp,qSGrp,rSGrp,sSGrp,dimp,dimq,dimr,dims
        integer pqSGrp,rsSGrp
        integer i
c
c
c        -------- part I - define basic parameters
c
c1        Def dima,dimb,dimc,dimc
        dima=DimSGrpa(aSGrp)
        dimb=DimSGrpbe(bSGrp)
        dimc=DimSGrpa(cSGrp)
        dimd=DimSGrpbe(dSGrp)
c
c
c        In steps 2.1 - 2.3 also dimp-dims and pSGrp-sSGrp
c2.1        Def abSGrp
        if (aSGrp.ge.bSGrp) then
          abSGrp=(aSGrp*(aSGrp-1)/2)+bSGrp
          pSGrp=aSGrp
          qSGrp=bSGrp
          dimp=dima
          dimq=dimb
        else
          abSGrp=(bSGrp*(bSGrp-1)/2)+aSGrp
          pSGrp=bSGrp
          qSGrp=aSGrp
          dimp=dimb
          dimq=dima
        end if
c
c2.2        Def cdSGrp
        if (cSGrp.ge.dSGrp) then
          cdSGrp=(cSGrp*(cSGrp-1)/2)+dSGrp
          rSGrp=cSGrp
          sSGrp=dSGrp
          dimr=dimc
          dims=dimd
        else
          cdSGrp=(dSGrp*(dSGrp-1)/2)+cSGrp
          rSGrp=dSGrp
          sSGrp=cSGrp
          dimr=dimd
          dims=dimc
        end if
c
        if (abSGrp.lt.cdSGrp) then
          i=pSGrp
          pSGrp=rSGrp
          rSGrp=i
          i=qSGrp
          qSGrp=sSGrp
          sSGrp=i
          i=dimp
          dimp=dimr
          dimr=i
          i=dimq
          dimq=dims
          dims=i
        end if
c
c
c3.1        Def abLen
        if (aSGrp.eq.bSGrp) then
          abLen=dima*(dima+1)/2
        else
          abLen=dima*dimb
        end if
c
c3.2        Def cdLen
        if (cSGrp.eq.dSGrp) then
          cdLen=dimc*(dimc+1)/2
        else
          cdLen=dimc*dimd
        end if
c
c3.3        Def abcdLen
        abcdLen=abLen*cdLen
c
c
c        -------- part II - read proper integrals (pq|rs) from disc
c
        pqSGrp=(pSGrp*(pSGrp-1)/2)+qSGrp
        rsSGrp=(rSGrp*(rSGrp-1)/2)+sSGrp
c
        if (InqW4(pqSGrp,rsSGrp).eqv..False.) then
          InqW4(pqSGrp,rsSGrp)=.True.
          length=length+abcdLen
        end if
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,2015, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine CCrtCmp(Zeta,P,nZeta,A,Axyz,na,HerR,nHer,ABeq,KVector)
************************************************************************
*                                                                      *
* Object: to compile the value of the angular part of a basis function *
*         evaluated at a root of the quadrature.                       *
*                                                                      *
* Called from: PrpInt                                                  *
*                                                                      *
* Calling    :                                                         *
*              RecPrt                                                  *
*              DCopy (ESSL)                                            *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*                                                                      *
*             Roland Lindh, Uppsala Universitet, Uppsala Sweden        *
*             December 2015.                                           *
*             Modification to wave vectors and complex representation. *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Zeta(nZeta), P(nZeta,3), A(3), HerR(nHer), KVector(3)
      Complex*16 Axyz(nZeta,3,nHer,0:na)
      Character*80 Label
      Logical ABeq(3)
*
      iRout = 116
      iPrint = nPrint(iRout)
*
      If (na.lt.0) Then
         Call WarningMessage(2,'CCrtCmp: na.lt.0')
         Call Abend()
      End If
      If (iPrint.ge.99) Then
         Call RecPrt(' In CCrtCmp: HerR',' ',HerR,1,nHer)
         Call RecPrt(' In CCrtCmp: Zeta',' ',Zeta,nZeta,1)
         Call RecPrt(' In CCrtCmp: A   ',' ',A   ,1    ,3)
         Call RecPrt(' In CCrtCmp: P   ',' ',P   ,nZeta,3)
         Call RecPrt(' In CCrtCmp: KVec',' ',KVector,1,3)
      End If
      Do iHer = 1, nHer
         Do iCar = 1, 3
            Do iZeta = 1, nZeta
               Axyz(iZeta,iCar,iHer,0) = DCMPLX(One,Zero)
            End Do
         End Do
      End Do
      If (na.eq.0) Go to 99
*
      Do iHer = 1, nHer
         Do iCar = 1, 3
*
            Do iZeta = 1, nZeta
               Axyz(iZeta,iCar,iHer,1) =
     &                DCMPLX(
     &                HerR(iHer)*1/Sqrt(Zeta(iZeta)) +
     &                P(iZeta,iCar) - A(iCar),
     &                KVector(iCar)/(Two*Zeta(iZeta)))
            End Do
*
            Do ia = 2, na
               Do iZeta = 1, nZeta
                  Axyz(iZeta,iCar,iHer,ia) = Axyz(iZeta,iCar,iHer,1) *
     &                                       Axyz(iZeta,iCar,iHer,ia-1)
               End Do
            End Do
*
         End Do
      End Do
 99   Continue
*
      If (iPrint.ge.99) Then
         Write (Label,'(A)') ' In CCrtCmp: Axyz '
         Call CRecPrt(Label,' ',Axyz,nZeta*3,nHer*(na+1),'R')
         Call CRecPrt(Label,' ',Axyz,nZeta*3,nHer*(na+1),'I')
      End If
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical_array(ABeq)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cdiv(ar,ai,br,bi,cr,ci)
      real*8 ar,ai,br,bi,cr,ci
c
c     complex division, (cr,ci) = (ar,ai)/(br,bi)
c
      real*8 s,ars,ais,brs,bis
      s = abs(br) + abs(bi)
      ars = ar/s
      ais = ai/s
      brs = br/s
      bis = bi/s
      s = brs**2 + bis**2
      cr = (ars*brs + ais*bis)/s
      ci = (ais*brs - ars*bis)/s
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _HDF5_

subroutine Restart_Dynamix(File_H5res)

use mh5, only: mh5_open_file_r, mh5_fetch_attr, mh5_open_attr, mh5_get_attr, mh5_close_attr, mh5_exists_dset, mh5_fetch_dset, &
               mh5_open_dset, mh5_get_dset_dims, mh5_close_dset, mh5_close_file
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
character(len=180), intent(in) :: File_H5Res
real(kind=wp), allocatable :: vel(:), NHC(:)
real(kind=wp) :: time, dt, e
integer(kind=iwp) :: attr_id, i, restart_fileid, natom, nsym, dset_id, nh(1)
character(len=256) :: tmp, sFile
logical(kind=iwp) :: Exists

write(u6,'(A)') 'Restarting dynamix from h5 file',file_h5res

! Check the file exists
sFile = File_H5Res
call f_inquire(sFile,Exists)
if (.not. Exists) then
  call getenvf('MOLCAS_SUBMIT_DIR',tmp)
  if (tmp /= ' ') then
    i = index(tmp,' ')
    if (i > 0) then
      sFile = tmp(1:i-1)//'/'//file_h5res
      call f_inquire(sFile,Exists)
    end if
  end if
  if (.not. Exists) then
    call WarningMessage(2,'File '//trim(sFile)//' is not found')
    call Quit_OnUserError()
  end if
end if

restart_fileid = mh5_open_file_r(sFile)

! read number of atoms
call mh5_fetch_attr(restart_fileid,'NSYM',nsym)
if (nsym > 1) then
  attr_id = mh5_open_attr(restart_fileid,'NATOMS_ALL')
else
  attr_id = mh5_open_attr(restart_fileid,'NATOMS_UNIQUE')
end if
call mh5_get_attr(attr_id,natom)
call mh5_close_attr(attr_id)

! read time and save in RunFile
call mh5_fetch_dset(restart_fileid,'TIME',time)
call Put_dScalar('MD_Time',time)

! read time step and save in RunFile
call mh5_fetch_dset(restart_fileid,'TIME_STEP',dt)
call Put_dScalar('Timestep',dt)

! read max hop and save in RunFile
if (mh5_exists_dset(restart_fileid,'MAX_HOP')) then
  call mh5_fetch_dset(restart_fileid,'MAX_HOP',i)
  call Put_iScalar('MaxHops',i)
end if

! read total energy and save in RunFile
call mh5_fetch_dset(restart_fileid,'ETOT',e)
call Put_dScalar('MD_Etot',e)

! read velocities and save in RunFile
call mma_allocate(vel,natom*3)
call mh5_fetch_dset(restart_fileid,'VELOCITIES',vel)
call Put_dArray('Velocities',vel,3*natom)
call mma_deallocate(vel)

! read thermostat info and save in RunFile
dset_id = mh5_open_dset(restart_fileid,'NOSEHOOVER')
call mh5_get_dset_dims(dset_id,nh)
call mh5_close_dset(dset_id)
call mma_allocate(NHC,nh(1))
call mh5_fetch_dset(restart_fileid,'NOSEHOOVER',NHC)
call Put_dArray('NOSEHOOVER',NHC,nh(1))
call mma_deallocate(NHC)

call mh5_close_file(restart_fileid)

return

end subroutine Restart_Dynamix

#elif !defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(Restart_Dynamix)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine CalcAXk2(AXk,D1,D2,PUVX,NPUVX,IndPUVX,Off_Act,Off_Orb)

use MCLR_Data, only: ipMat, nDens, nNA
use input_mclr, only: nAsh, nIsh, nOrb, nSym, ntAsh, ntBas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: AXk(nDens)
integer(kind=iwp), intent(in) :: NPUVX, IndPUVX(ntBas,ntAsh,ntAsh,ntAsh), Off_Act(nSym), Off_Orb(nSym)
real(kind=wp), intent(in) :: D1(ntAsh**2), D2(ntAsh**2), PUVX(NPUVX)
integer(kind=iwp) :: ip, iq, iSym, it, loc1, loc2, p, q, t, u, v, x
real(kind=wp) :: tempa
real(kind=wp), allocatable :: Opu(:)

call mma_allocate(Opu,ntBas*ntAsh)
do p=1,ntBas
  do u=1,ntAsh
    tempa = Zero
    do v=1,ntAsh
      do x=1,ntAsh
        if (IndPUVX(p,u,v,x) /= 0) tempa = tempa+PUVX(IndPUVX(p,u,v,x))*D2((v-1)*nnA+x)
      end do
    end do
    Opu((p-1)*ntAsh+u) = tempa
  end do
end do
do iSym=1,nSym
  do iq=1,nAsh(iSym)
    q = iq+Off_Act(ISym)
    do ip=1,nIsh(iSym)  ! p is inactive
      p = ip+Off_Orb(ISym)
      tempa = Zero
      do it=1,nAsh(ISym)
        t = it+Off_Act(ISym)
        tempa = tempa+(D1((t-1)*nnA+q)+D1((q-1)*nnA+t))*Opu((p-1)*nnA+t)
      end do
      !write(u6,*) 'tempa after sum over t',tempa
      loc1 = ipMat(iSym,iSym)+(iq-1)*nOrb(iSym)+ip-1+nOrb(iSym)*NIsh(iSym)
      loc2 = ipMat(iSym,iSym)+(ip-1)*nOrb(iSym)+iq-1+NIsh(iSym)
      AXK(loc1) = AXK(loc1)+tempa
      AXK(loc2) = AXK(loc2)-tempa
    end do
    do ip=nIsh(iSym)+nAsh(iSym)+1,nOrb(iSym)  ! p is virtual
      p = ip+Off_Orb(ISym)
      tempa = Zero
      do it=1,nAsh(ISym)
        t = it+Off_Act(ISym)
        tempa = tempa+(D1((t-1)*nnA+q)+D1((q-1)*nnA+t))*Opu((p-1)*nnA+t)
      end do
      loc1 = ipMat(iSym,iSym)+(iq-1)*nOrb(iSym)+ip-1+nOrb(iSym)*NIsh(iSym)
      loc2 = ipMat(iSym,iSym)+(ip-1)*nOrb(iSym)+iq-1+NIsh(iSym)
      AXK(loc1) = AXK(loc1)+tempa
      AXK(loc2) = AXK(loc2)-tempa
    end do
  end do
end do
call mma_deallocate(Opu)

end subroutine CalcAXk2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
C
      SUBROUTINE SING(IWHY)
      IMPLICIT REAL*8 (A-H,O-Z)
11    FORMAT(54H MATRIX WITH ZERO ROW IN DECOMPOSE.                   )
12    FORMAT(54H SINGULAR MATRIX IN DECOMPOSE. ZERO DIVIDE IN SOLVE.  )
13    FORMAT(54H NO CONVERGENCE IN IMPROVE. MATRIX IS NEARLY SINGULAR.)
      NOUT=6
C**** NOUTE=STANDARD OUTPUT UNIT
      GOTO (1,2,3),IWHY
1     WRITE(NOUT,11)
      CALL XFLUSH(6)
      GOTO 10
2     WRITE(NOUT,12)
      CALL XFLUSH(6)
      GOTO 10
3     WRITE(NOUT,13)
      CALL XFLUSH(6)
10    RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Rotate multipole.
subroutine Rotation_qmstat(iL,dMul,Rotte,Sigge)

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

! Maximum multipole implemented
#define _MxM_ 2

implicit none
integer(kind=iwp), intent(in) :: iL
real(kind=wp), intent(inout) :: dMul(nTri_Elem1(_MxM_))
real(kind=wp), intent(in) :: Rotte(3,3), Sigge
real(kind=wp) :: d1, d2, d3, dMTrans(6), Sig, TD(6,6)
integer(kind=iwp) :: i, j
#include "warnings.h"

if (iL == 0) then
  ! Charge, trivial to rotate.

else if (iL == 1) then
  ! Dipole, transforms as a vector. Sigge controls that if the
  ! multipole is located not in origin, but at the other end,
  ! i.e. molecule A, then any odd occurrence of z should be
  ! mirrored. Applies for the quadrupole as well, see below.

  d1 = dMul(1)
  d2 = dMul(2)
  d3 = dMul(3)
  dMul(:) = Rotte(:,1)*d1+Rotte(:,2)*d2+Rotte(:,3)*d3
  dMul(3) = Sigge*dMul(3)
else if (iL == 2) then
  ! Quadrupole, transforms as a quadratic form. Also, transform to spherical representation.

  ! Compute the transformation matrix for second-moments.

  call M2Trans(Rotte,TD)

  ! Transform. Sigge is explained above.

  dMTrans(:) = Zero
  do i=1,6
    do j=1,6
      dMTrans(i) = dMTrans(i)+TD(i,j)*dMul(j)
    end do
  end do
  do i=1,6
    Sig = One
    if ((i == 3) .or. (i == 5)) Sig = Sigge
    dMul(i) = dMTrans(i)*Sig
  end do

  ! Go to spherical representation.

  call Spherical(dMul)
else
  write(u6,*) 'Nope!, Error in sl_grad'
  call Quit(_RC_IO_ERROR_READ_)
end if

return

end subroutine Rotation_qmstat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RHSALL2(IVEC)
      USE CHOVEC_IO
      IMPLICIT REAL*8 (A-H,O-Z)
* ----------------------------------------------------------------
* Code for processing all the cholesky vectors
* in construction of caspt2 right-hand-side array
* Also form the active two-electron integrals 'TUVX'.
* ================================================================
#include "rasdim.fh"
#include "warnings.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "chocaspt2.fh"
#include "WrkSpc.fh"
*
      Integer Active, Inactive, Virtual
      Parameter (Inactive=1, Active=2, Virtual=3)
      Integer nSh(8,3)
#ifdef _DEBUGPRINT_
      INTEGER NUMERR
      SAVE NUMERR
      DATA NUMERR / 0 /
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Call ICopy(NSYM,NISH,1,nSh(1,Inactive),1)
      Call ICopy(NSYM,NASH,1,nSh(1,Active  ),1)
      Call ICopy(NSYM,NSSH,1,nSh(1,Virtual ),1)
*                                                                      *
************************************************************************
*                                                                      *

      IF (IPRGLB.GE.VERBOSE) THEN
        WRITE(6,'(1X,A)') ' Using RHSALL2+ADDRHS algorithm'
      END IF

*
* TUVX RHSX        Na^4
* TJVX RHSA        Na^3 Ni
* TJVL RHSB        Na^2 Ni^2
* AJVX RHSD1       Na^2 Ni   Ns
* AJCL RHSH             Ni^2 Ns^2     N^4
* AUVX RHSC        Na^3      Ns
* AUCX RHSF        Na^2      Ns^2
* AUVL RHSD2       Na^2 Ni   Ns
* AUCL RHSG        Na   Ni   Ns^2     N^3
* AJVL RHSE        Na   Ni^2 Ns       N^3
*
*     Initialize RHS array as 'vector' nr IVEC=IRHS on LUSOLV:
*
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate and clear TUVX, two-electron integrals for active
*     orbital indices only: Simple storage, same as for GAMMA2.
*     TUVX is kept allocated until end of subroutine.
      NG1=NASHT**2
      NG2=NG1**2
      NTUVX=NG2
      CALL GETMEM('TUVX','ALLO','REAL',LTUVX,NTUVX)
      CALL DCOPY_(NTUVX,[0.0D0],0,WORK(LTUVX),1)
*                                                                      *
************************************************************************
*                                                                      *
      DO JSYM=1,NSYM
*
       IB1=NBTCHES(JSYM)+1
       IB2=NBTCHES(JSYM)+NBTCH(JSYM)
*
       MXBGRP=IB2-IB1+1
       IF (MXBGRP.LE.0) CYCLE
       CALL GETMEM('BGRP','ALLO','INTE',LBGRP,2*MXBGRP)
       IBGRP=1
       DO IB=IB1,IB2
        IWORK(LBGRP  +2*(IBGRP-1))=IB
        IWORK(LBGRP+1+2*(IBGRP-1))=IB
        IBGRP=IBGRP+1
       END DO
       NBGRP=MXBGRP

       CALL MEMORY_ESTIMATE(JSYM,IWORK(LBGRP),NBGRP,
     &                      NCHOBUF,MXPIQK,NADDBUF)
       IF (IPRGLB.GT.VERBOSE) THEN
         WRITE(6,*)
         WRITE(6,'(A,I12)') '  Number of Cholesky batches: ',IB2-IB1+1
         WRITE(6,'(A,I12)') '  Number of batch groups:     ',NBGRP
         WRITE(6,*)
       END IF
* buffers are kept allocated until the end of JSYM loop.
       CALL GetMem('PIQK','ALLO','REAL',LPIQK,MXPIQK)
       CALL GetMem('BUFF','ALLO','REAL',LBUFF,NADDBUF)
       CALL GetMem('IDXB','ALLO','INTE',LIDXB,NADDBUF)
       CALL GETMEM('BRABUF','ALLO','REAL',LBRA,NCHOBUF)
       CALL GETMEM('KETBUF','ALLO','REAL',LKET,NCHOBUF)
*
*      Loop over groups of batches of Cholesky vectors
*
*      IBSTEP=1
*
*      DO IBSTA=IB1,IB2,IBSTEP
       DO IBGRP=1,NBGRP
        IBSTA=IWORK(LBGRP  +2*(IBGRP-1))
        IBEND=IWORK(LBGRP+1+2*(IBGRP-1))

        NV=0
        DO IB=IBSTA,IBEND
           NV=NV+NVLOC_CHOBATCH(IB)
        END DO

        IF (IPRGLB.GT.VERBOSE) THEN
         WRITE(6,'(A,I12)') '  Cholesky vectors in this group = ', NV
         WRITE(6,*)
        END IF
*                                                                      *
************************************************************************
*                                                                      *
*      Read kets (Cholesky vectors) in the form L(VX), all symmetries:
*
       Call Get_Cholesky_Vectors(Active,Active,JSYM,
     &                           Work(LKET),nKet,
     &                           IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
*      Assemble constributions to TUVX integrals
*      Reuse the ket vectors as L(TU) bra vectors
*
       LBRASM=LKET
       DO ISYI=1,NSYM
        NI=NASH(ISYI)
        iOffi=NAES(iSYI)
        IF(NI.EQ.0) GOTO 115
        ISYP=MUL(ISYI,JSYM)
        NP=NASH(ISYP)
        iOffp=NAES(iSYP)
        IF(NP.EQ.0) GOTO 115
        NPI=NP*NI
        NBRASM=NPI*NV
        LKETSM=LKET

        DO ISYK=1,NSYM
         NK=NASH(ISYK)
         iOffK=NAES(iSYK)
         IF(NK.EQ.0) GOTO 112
         ISYQ=MUL(ISYK,JSYM)
         NQ=NASH(ISYQ)
         iOffQ=NAES(iSYQ)
         IF(NQ.EQ.0) GOTO 112
         NQK=NQ*NK
         NKETSM=NQK*NV
*
         IF (NPI*NQK.GT.mxPIQK) THEN
           WRITE(6,*) 'NPIQK larger than mxPIQK in TUVX, bug?'
           Call AbEnd()
         END IF
*        CALL GETMEM('PIQK','ALLO','REAL',LPIQK,NPI*NQK)
         CALL DGEMM_('N','T',NPI,NQK,NV,1.0D0,WORK(LBRASM),NPI,
     &        WORK(LKETSM),NQK,0.0D0,WORK(LPIQK),NPI)
*
         Call ADDTUVX(NP,NI,NQ,NK,NASHT,iOffP,iOffI,iOffQ,iOffK,
     &                WORK(LTUVX),nTUVX,Work(LPIQK),NPI*NQK,
     &                NUMERR)
*        CALL GETMEM('PIQK','FREE','REAL',LPIQK,NPI*NQK)
*
         LKETSM=LKETSM+NKETSM
 112     CONTINUE
        END DO
        LBRASM=LBRASM+NBRASM
 115    CONTINUE
       END DO
*                                                                      *
************************************************************************
*                                                                      *
*      Read bra (Cholesky vectors) in the form L(TJ): All symmetries
*
       Call Get_Cholesky_Vectors(Inactive,Active,JSYM,
     &                           Work(LBRA),nBra,
     &                           IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
*      Assemble contributions to TJVX
*      Loop over the bras and kets, form <A|0>
*
      Call Process_RHS_Block(Inactive,Active,Active,Active,
     &                       'A ',
     &                       Work(LBRA),nBra,Work(LKET),nKet,
     &                       Work(LPIQK),mxPIQK,
     &                       Work(LBUFF),iWork(LidxB),nAddBuf,
     &                       nSh,JSYM,
     &                       IVEC,NV)
*                                                                      *
************************************************************************
*                                                                      *
*      TJVL RHSB
*      TJVL: Use TJ buffer as if it was VL, form <B|0>
*
      Call Process_RHS_Block(Inactive,Active,Inactive,Active,
     &                       'B ',
     &                       Work(LBRA),nBra,Work(LBRA),nBra,
     &                       Work(LPIQK),mxPIQK,
     &                       Work(LBUFF),iWork(LidxB),nAddBuf,
     &                       nSh,JSYM,
     &                       IVEC,NV)
*                                                                      *
************************************************************************
*                                                                      *
* Read bra (Cholesky vectors) in the form L(AJ), form <D1|0>
* We still have L(VX) vectors in core, at WORK(LKETS).
*
       Call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,
     &                           Work(LBRA),nBra,
     &                           IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
* AJVX RHSD1
* Loop over the bra and ket vectors.
*
      Call Process_RHS_Block(Inactive,Virtual,Active,Active,
     &                       'D1',
     &                       Work(LBRA),nBra,Work(LKET),nKet,
     &                       Work(LPIQK),mxPIQK,
     &                       Work(LBUFF),iWork(LidxB),nAddBuf,
     &                       nSh,JSYM,
     &                       IVEC,NV)
*                                                                      *
************************************************************************
*                                                                      *
* AJCL RHSH
* AJCL: Use AJ buffer still in core as if it was CL, form <H|0>
*
      Call Process_RHS_Block(Inactive,Virtual,Inactive,Virtual,
     &                       'H ',
     &                       Work(LBRA),nBra,Work(LBRA),nBra,
     &                       Work(LPIQK),mxPIQK,
     &                       Work(LBUFF),iWork(LidxB),nAddBuf,
     &                       nSh,JSYM,
     &                       IVEC,NV)
*                                                                      *
************************************************************************
*                                                                      *
* Read Bra (Cholesky vectors)= L(AU)
*
       Call Get_Cholesky_Vectors(Active,Virtual,JSYM,
     &                           Work(LBRA),nBra,
     &                           IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
* AUVX RHSC
* AUVX: Loop over the bras and kets
*
      Call Process_RHS_Block(Active,Virtual,Active,Active,
     &                       'C ',
     &                       Work(LBRA),nBra,Work(LKET),nKet,
     &                       Work(LPIQK),mxPIQK,
     &                       Work(LBUFF),iWork(LidxB),nAddBuf,
     &                       nSh,JSYM,
     &                       IVEC,NV)
*                                                                      *
************************************************************************
*                                                                      *
* AUCX RHSF
* AUCX: Use AU buffer still in core as if it was CX, form <F|0>
*
      Call Process_RHS_Block(Active,Virtual,Active,Virtual,
     &                       'F ',
     &                       Work(LBRA),nBra,Work(LBRA),nBra,
     &                       Work(LPIQK),mxPIQK,
     &                       Work(LBUFF),iWork(LidxB),nAddBuf,
     &                       nSh,JSYM,
     &                       IVEC,NV)
*                                                                      *
************************************************************************
*                                                                      *
* Read kets (Cholesky vectors) in the form L(VL), all symmetries:
*
       Call Get_Cholesky_Vectors(Inactive,Active,JSYM,
     &                           Work(LKET),nKet,
     &                           IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
* AUVL RHSD2
* Loop over bras and kets, form <D2|0>.
*
      Call Process_RHS_Block(Active,Virtual,Inactive,Active,
     &                       'D2',
     &                       Work(LBRA),nBra,Work(LKET),nKet,
     &                       Work(LPIQK),mxPIQK,
     &                       Work(LBUFF),iWork(LidxB),nAddBuf,
     &                       nSh,JSYM,
     &                       IVEC,NV)
*                                                                      *
************************************************************************
*                                                                      *
* Read kets (Cholesky vectors) in the form L(CL), all symmetries:
*
       Call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,
     &                           Work(LKET),nKet,
     &                           IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
* AUCL RHSG
* Loop over bras and kets, form  <G|0>
*
      Call Process_RHS_Block(Active,Virtual,Inactive,Virtual,
     &                       'G ',
     &                       Work(LBRA),nBra,Work(LKET),nKet,
     &                       Work(LPIQK),mxPIQK,
     &                       Work(LBUFF),iWork(LidxB),nAddBuf,
     &                       nSh,JSYM,
     &                       IVEC,NV)
*                                                                      *
************************************************************************
*                                                                      *
* Read bra vectors AJ
*
       Call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,
     &                           Work(LBRA),nBra,
     &                           IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
* Read kets in the form L(VL)
*
       Call Get_Cholesky_Vectors(Inactive,Active,JSYM,
     &                           Work(LKET),nKet,
     &                           IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
* AJVL RHSE
* AJVL: Loop over bras and kets. Form <E|0>
*
      Call Process_RHS_Block(Inactive,Virtual,Inactive,Active,
     &                       'E ',
     &                       Work(LBRA),nBra,Work(LKET),nKet,
     &                       Work(LPIQK),mxPIQK,
     &                       Work(LBUFF),iWork(LidxB),nAddBuf,
     &                       nSh,JSYM,
     &                       IVEC,NV)
*                                                                      *
************************************************************************
*                                                                      *
* End of loop over batches, IB
      END DO
*                                                                      *
************************************************************************
*                                                                      *
*SVC  Call GetMem('ADDRHS','Free','Real',ipAdd,nAdd)
      CALL GETMEM('BRABUF','FREE','REAL',LBRA,NCHOBUF)
      CALL GETMEM('KETBUF','FREE','REAL',LKET,NCHOBUF)
      CALL GetMem('PIQK','FREE','REAL',LPIQK,MXPIQK)
      CALL GetMem('BUFF','FREE','REAL',LBUFF,NADDBUF)
      CALL GetMem('IDXB','FREE','INTE',LIDXB,NADDBUF)
      CALL GETMEM('BGRP','FREE','INTE',LBGRP,2*MXBGRP)
*                                                                      *
************************************************************************
*                                                                      *
* End of loop over JSYM
      END DO
*                                                                      *
************************************************************************
*                                                                      *
* Synchronized add RHS partial arrays from all nodes into each node.

C-SVC: read the DRA's from disk and copy them all to LUSOLV to continue
C      in serial mode.  FIXME: this call has to be removed when we reach
C      full parallel capabilities
*     CALL SYNRHS(IVEC)
C-SVC: at this point, the RHS elements are on disk, both in LUSOLV and
C      as DRAs with the name RHS_XX_XX_XX with XX a number representing
C      the case, symmetry, and rhs vector respectively.

* The RHS elements of Cases A, C, D1  need a correction:
      CALL MODRHS(IVEC,WORK(LFIMO))

#ifdef _DEBUGPRINT_
* compute and print RHS fingerprints
      WRITE(6,'(1X,A4,1X,A3,1X,A18)') 'Case','Sym','Fingerprint'
      WRITE(6,'(1X,A4,1X,A3,1X,A18)') '====','===','==========='
      DO ICASE=1,13
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF (NAS*NIS.NE.0) THEN
            CALL RHS_ALLO (NAS,NIS,lg_W)
            CALL RHS_READ (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
            DNRM2 = RHS_DDOT(NAS,NIS,lg_W,lg_W)
            WRITE(6,'(1X,I4,1X,I3,1X,F18.11)') ICASE,ISYM,DNRM2
          END IF
        END DO
      END DO
#endif

* Synchronized add tuvx partial arrays from all nodes into each node.
      CALL CHO_GADGOP(WORK(LTUVX),NTUVX,'+')
* Put TUVX on disk for possible later use:
      CALL PT2_PUT(NTUVX,'TUVX',WORK(LTUVX))
      CALL GETMEM('TUVX','FREE','REAL',LTUVX,NTUVX)

*                                                                      *
************************************************************************
*                                                                      *

      RETURN
      END
      Subroutine Get_Cholesky_Vectors(ITK,ITQ,JSYM,
     &                                Array,nArray,
     &                                IBSTA,IBEND)
      USE CHOVEC_IO
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
      Real*8  Array(*)

      ! ugly hack to convert separate k/q orbital types into a specific
      ! case
      ICASE=ITK*ITQ
      IF (ICASE.EQ.3) THEN
        ICASE=4
      ELSE
        ICASE=ICASE/2
      END IF

      LKETSM=1
      DO ISYK=1,NSYM
        NQK=NPQ_CHOTYPE(ICASE,ISYK,JSYM)
        IF(NQK.EQ.0) CYCLE
        DO IB=IBSTA,IBEND
          NV=NVLOC_CHOBATCH(IB)
          NKETSM=NQK*NV
          IDISK=IDLOC_CHOGROUP(ICASE,ISYK,JSYM,IB)
          CALL DDAFILE(LUDRA,2,Array(LKETSM),NKETSM,IDISK)
          LKETSM=LKETSM+NKETSM
        END DO
      END DO
      nArray=LKETSM-1
*
      Return
      End
      Subroutine Process_RHS_Block(ITI,ITP,ITK,ITQ,
     &                             Case,
     &                             Cho_Bra,nBra,Cho_Ket,nKet,
     &                             PIQK,mxPIQK,
     &                             BUFF,idxBuff,nBUFF,
     &                             nSh,JSYM,
     &                             IVEC,NV)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
      DIMENSION Cho_Bra(nBra), Cho_Ket(nKet)
      DIMENSION BUFF(nBuff),idxBuff(nBuff),PIQK(mxPIQK)
      Integer nSh(8,3)
      Character Case*2
*
*
      IF (iPrGlb.GE.DEBUG) THEN
        WRITE(6,*) 'Processing RHS block '//Case
      END IF
      LBRASM=1
      DO ISYI=1,NSYM
         NI=NSH(ISYI,ITI)
         IF(NI.EQ.0) GOTO 125
         ISYP=MUL(ISYI,JSYM)
         NP=NSH(ISYP,ITP)
         IF(NP.EQ.0) GOTO 125
         NPI=NP*NI
         NBRASM=NPI*NV
*
         LKETSM=1
         DO ISYK=1,NSYM
            NK=NSH(ISYK,ITK)
            IF(NK.EQ.0) GOTO 122
            ISYQ=MUL(ISYK,JSYM)
            NQ=NSH(ISYQ,ITQ)
            IF(NQ.EQ.0) GOTO 122
            NQK=NQ*NK
            NKETSM=NQK*NV
*
C SVC: we need an NPI*NQK to store the 2-electron integrals, and 2
C buffers (values+indices) for sorting them.  Later, we can try to get
C rid of the buffer that stores the values and only use an index buffer
C and the two-electron integrals for the scatter operation.  For the
C buffer, any size can be taken, but assuming there is enough memory
C available, it's set to the size of the two-electron integrals unless
C larger than some predefined maximum buffer size.
            NPIQK=NPI*NQK
            IF (NPIQK.GT.MXPIQK) THEN
              IF (Case.eq.'H') THEN
                KPI=MXPIQK/NQK
                NPIQK=KPI*NQK
              ELSE IF (Case.eq.'G') THEN
                KQK=MXPIQK/NPI
                NPIQK=NPI*KQK
              ELSE
                WRITE(6,*) ' NPIQK > MXPIQK and case != G or H'
                WRITE(6,'(A,A2)')  ' CASE =   ', Case
                WRITE(6,'(A,I12)') ' NPIQK =  ', NPIQK
                WRITE(6,'(A,I12)') ' MXPIQK = ', MXPIQK
                WRITE(6,*) ' This should not happen, please report.'
                CALL AbEnd()
              END IF
            END IF

C-SVC: sanity check
            IF (NPIQK.LE.0) THEN
              WRITE(6,'(1X,A)') ' ADDRHS: zero-sized NPIQK'
              CALL AbEnd()
            END IF
*
            If (Case.eq.'A ') Then
               CALL ADDRHSA(IVEC,JSYM,ISYI,ISYK,
     &                      NP,NI,NQ,NK,PIQK,
     &                      nBuff,Buff,idxBuff,
     &                      Cho_Bra(LBRASM),
     &                      Cho_Ket(LKETSM),NV)
            Else If (Case.eq.'B ') Then
               CALL ADDRHSB(IVEC,JSYM,ISYI,ISYK,
     &                      NP,NI,NQ,NK,PIQK,
     &                      nBuff,Buff,idxBuff,
     &                      Cho_Bra(LBRASM),
     &                      Cho_Ket(LKETSM),NV)
            Else If (Case.eq.'D1') Then
               CALL ADDRHSD1(IVEC,JSYM,ISYI,ISYK,
     &                       NP,NI,NQ,NK,PIQK,
     &                       nBuff,Buff,idxBuff,
     &                       Cho_Bra(LBRASM),
     &                       Cho_Ket(LKETSM),NV)
            Else If (Case.eq.'H ') Then
               CALL ADDRHSH(IVEC,JSYM,ISYI,ISYK,
     &                      NP,NI,NQ,NK,PIQK,NPIQK,
     &                      nBuff,Buff,idxBuff,
     &                      Cho_Bra(LBRASM),
     &                      Cho_Ket(LKETSM),NV)
            Else If (Case.eq.'C ') Then
               CALL ADDRHSC(IVEC,JSYM,ISYI,ISYK,
     &                      NP,NI,NQ,NK,PIQK,
     &                      nBuff,Buff,idxBuff,
     &                      Cho_Bra(LBRASM),
     &                      Cho_Ket(LKETSM),NV)
            Else If (Case.eq.'F ') Then
               CALL ADDRHSF(IVEC,JSYM,ISYI,ISYK,
     &                      NP,NI,NQ,NK,PIQK,
     &                      nBuff,Buff,idxBuff,
     &                      Cho_Bra(LBRASM),
     &                      Cho_Ket(LKETSM),NV)
            Else If (Case.eq.'D2') Then
               CALL ADDRHSD2(IVEC,JSYM,ISYI,ISYK,
     &                       NP,NI,NQ,NK,PIQK,
     &                       nBuff,Buff,idxBuff,
     &                       Cho_Bra(LBRASM),
     &                       Cho_Ket(LKETSM),NV)
            Else If (Case.eq.'G ') Then
               CALL ADDRHSG(IVEC,JSYM,ISYI,ISYK,
     &                      NP,NI,NQ,NK,PIQK,NPIQK,
     &                      nBuff,Buff,idxBuff,
     &                      Cho_Bra(LBRASM),
     &                      Cho_Ket(LKETSM),NV)
            Else If (Case.eq.'E ') Then
               CALL ADDRHSE(IVEC,JSYM,ISYI,ISYK,
     &                      NP,NI,NQ,NK,PIQK,
     &                      nBuff,Buff,idxBuff,
     &                      Cho_Bra(LBRASM),
     &                      Cho_Ket(LKETSM),NV)
            Else
               Call Abend()
            End If
*
         LKETSM=LKETSM+NKETSM
 122     CONTINUE
        END DO
        LBRASM=LBRASM+NBRASM
 125    CONTINUE
      END DO
*
      Return
      End
      Subroutine ADDTUVX(NP,NI,NQ,NK,NASHT,iOffP,iOffI,iOffQ,iOffK,
     &                   TUVX,nTUVX,PIQK,nPIQK,
     &                   NUMERR)
      Implicit Real*8 (A-H,O-Z)
      Real*8 TUVX(nTUVX), PIQK(nPIQK)
*
* Add into correct positions in TUVX:
*
      DO iX=0,NK-1
         iX1=NASHT*(iX+iOffK)
         iX2=NQ   * iX
         DO iV=0,NQ-1
            iVX1=NASHT*(iV+iOffQ+iX1)
            iVX2=NI   *(iV      +iX2)
            DO iU=0,NI-1
               iUVX1=NASHT*(iU+iOffI+iVX1)
               iUVX2=NP   *(iU+      iVX2)
#ifdef __INTEL_COMPILER
*  This to avoid Intel over optimization
               Call DaXpY_(nP,1.0D0,PIQK(1+      iUVX2),1,
     &                             TUVX(1+iOffP+iUVX1),1)
#else
               DO iT=0,NP-1
                  iTUVX=iT+iOffP+iUVX1
                  iPIQK=iT      +iUVX2
#ifdef _DEBUGPRINT_
* Temporary test statements -- remove after debug!
                  IF(ITUVX.LT.0 .or. ITUVX.gt.NTUVX) THEN
                     ITUVX=NTUVX
                     NUMERR=NUMERR+1
                     IF (NUMERR.GT.100) THEN
                        WRITE(6,*)' THIS IS TOO MUCH -- STOP.'
                        CALL QUIT(_RC_INTERNAL_ERROR_)
                     END IF
                  END IF
* End of temporary test statements
#else
* Avoid unused argument warnings
      IF (.FALSE.) Call Unused_integer(NUMERR)
#endif
                  TUVX(1+iTUVX)=TUVX(1+iTUVX)+PIQK(1+iPIQK)
               END DO
#endif
            END DO
         END DO
      END DO
*
      Return
      End
      SUBROUTINE MEMORY_ESTIMATE(JSYM,LBGRP,NBGRP,
     &                           NCHOBUF,NPIQK,NADDBUF)
      USE CHOVEC_IO
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
      DIMENSION LBGRP(2,NBGRP)
      Integer Active, Inactive, Virtual
      Parameter (Inactive=1, Active=2, Virtual=3)
      Integer nSh(8,3)
      DIMENSION ITYPE(4,9)
      DATA ITYPE /
     &  Inactive,Active,Active,Active,
     &  Inactive,Active,Inactive,Active,
     &  Inactive,Virtual,Active,Active,
     &  Inactive,Virtual,Inactive,Virtual,
     &  Active,Virtual,Active,Active,
     &  Active,Virtual,Active,Virtual,
     &  Active,Virtual,Inactive,Active,
     &  Active,Virtual,Inactive,Virtual,
     &  Inactive,Virtual,Inactive,Active /

      Call ICopy(NSYM,NISH,1,nSh(1,Inactive),1)
      Call ICopy(NSYM,NASH,1,nSh(1,Active  ),1)
      Call ICopy(NSYM,NSSH,1,nSh(1,Virtual ),1)

CSVC: compute the maximum RHS size that will be allocated per node, this
C     will be later allocated when addrhs routines are called. If global
C     arrays are used, this may actually be done outside of GETMEM, but
C     let's just reserve it anyway.
      ISYM=JSYM
      MXRHS=2*NTU(ISYM)*NISUP(ISYM,5)
      DO ISYI=1,NSYM
        ISYM=ISYI
C case A
        MXRHS=Max(MXRHS,NTUV(ISYM)*NISH(ISYM))
C case GP,GM
        MXRHS=Max(MXRHS,NASH(ISYM)*NISUP(ISYM,10)
     &                 +NASH(ISYM)*NISUP(ISYM,11))

        ISYM=MUL(JSYM,ISYI)
C case C
        MXRHS=Max(MXRHS,NTUV(ISYM)*NSSH(ISYM))
C case EP,EM
        MXRHS=Max(MXRHS,NASH(ISYM)*NISUP(ISYM,6)
     &                 +NASH(ISYM)*NISUP(ISYM,7))
        DO ISYK=1,NSYM
          ISYM=MUL(ISYI,ISYK)
C case BP,BM
          MXRHS=Max(MXRHS,NTGEU(ISYM)*NIGEJ(ISYM))
          MXRHS=Max(MXRHS,NTGTU(ISYM)*NIGTJ(ISYM))
C case HP,HM
          MXRHS=Max(MXRHS,NAGEB(ISYM)*NIGEJ(ISYM))
          MXRHS=Max(MXRHS,NAGTB(ISYM)*NIGTJ(ISYM))
C case F
          MXRHS=Max(MXRHS,NTGEU(ISYM)*NAGEB(ISYM))
          MXRHS=Max(MXRHS,NTGTU(ISYM)*NAGTB(ISYM))

          ISYM=MUL(ISYI,MUL(JSYM,ISYK))
C case D1,D2
          MXRHS=Max(MXRHS,2*NTU(ISYM)*NISUP(ISYM,5))
        End Do
      End Do
      MXRHS = iPARDIV(MXRHS,0)

CSVC: determine maximum pair index size per symmetry and in total.
*     MXBFSZ=0
      MXNPITOT=0
      DO ISYI=1,NSYM
        ISYP=MUL(ISYI,JSYM)
        NI=MAX(NISH(ISYI),NASH(ISYI))
        NP=MAX(NASH(ISYP),NSSH(ISYP))
        MXNPITOT=MXNPITOT+NP*NI
*       MXBFSZ=MXBFSZ+NP*NI*NJSCT
      END DO

CSVC: determine maximum and minimum size to hold integral matrix.
C     cases here correspond to A, B, D1, H, C, F, D2, G, E.
C     with number icase =      1, 2,  3, 4, 5, 6,  7, 8, 9.
C     both case G and H can use blocking, currently this is done over
C     the number of inactive orbitals in one of the pair indices.
C     for case G, the minimum needed is NAU*NC, because of blocking NL.
C     for case H, the minimum needed is NA*NCL, because of blocking NJ.
C     to start, reserve space for TUVX integrals (NASHT**4)
      MAXPIQK=NASHT**4
      MINPIQK=NASHT**4
      DO ICASE=1,9
        DO ISYI=1,NSYM
          NI=NSH(ISYI,ITYPE(1,ICASE))
          ISYP=MUL(ISYI,JSYM)
          NP=NSH(ISYP,ITYPE(2,ICASE))
          NPI=NP*NI
          DO ISYK=1,NSYM
            NK=NSH(ISYK,ITYPE(3,ICASE))
            ISYQ=MUL(ISYK,JSYM)
            NQ=NSH(ISYQ,ITYPE(4,ICASE))
            NQK=NQ*NK
            MAXPIQK=MAX(MAXPIQK,NPI*NQK)
            IF (ICASE.EQ.4) THEN
              MINPIQK=MAX(MINPIQK,NP*NQK)
            ELSE IF (ICASE.EQ.8) THEN
              MINPIQK=MAX(MINPIQK,NPI*NQ)
            ELSE
              MINPIQK=MAX(MINPIQK,NPI*NQK)
            END IF
          END DO
        END DO
      END DO
      MAXBUFF=NINT(SQRT(DBLE(MAXPIQK)))
      MINBUFF=NINT(SQRT(DBLE(MINPIQK)))

CSVC: total number of cholesky vectors
      MXBATCH=0
      NVECTOT=0
      IB1=NBTCHES(JSYM)+1
      IB2=NBTCHES(JSYM)+NBTCH(JSYM)
      DO IB=IB1,IB2
        NV=NVLOC_CHOBATCH(IB)
        MXBATCH=MAX(MXBATCH,NV)
        NVECTOT=NVECTOT+NV
      END DO
      MAXCHOL=MXNPITOT*NVECTOT
      MINCHOL=MXNPITOT*MXBATCH

CSVC: can we fit this all in memory?
      CALL GetMem('MAXSIZE','MAX','Real',iDum,MXAVAIL)

      MINNICE=MXRHS+MAXPIQK+2*MAXBUFF+2*MAXCHOL
      MINGOOD=MXRHS+MINPIQK+2*MINBUFF+2*MAXCHOL
      MINSLOW=MXRHS+MINPIQK+2*MINBUFF+2*MINCHOL

      IF (IPRGLB.GT.VERBOSE) THEN
        WRITE(6,*)
        WRITE(6,'(A,I1)') '  Memory estimates in RHSALL, SYM ', JSYM
        WRITE(6,'(A,2X,I16)') '   allocatable:    ', MXAVAIL
        WRITE(6,'(A,2X,I16)') '   recommended:    ', MINNICE
        WRITE(6,'(A,2X,I16)') '   convenient:     ', MINGOOD
        WRITE(6,'(A,2X,I16)') '   minimum:        ', MINSLOW
        WRITE(6,*)
        IF (MXAVAIL.GE.MINNICE) THEN
          WRITE(6,*) ' I can use all cholesky vectors at once'
          WRITE(6,*) ' as well as the whole integral matrixi.'
        ELSE IF (MXAVAIL.GE.MINGOOD) THEN
          WRITE(6,*) ' I will group batches of cholesky vectors'
          WRITE(6,*) ' and then maximize use of the integral matrix.'
        ELSE IF (MXAVAIL.GE.MINSLOW) THEN
          WRITE(6,*) ' I will at least try to group batches.'
        ELSE
          WRITE(6,*) ' Do you see my problem?'
        END IF
      END IF

      IF (MXAVAIL.GE.MINNICE) THEN
C group all batches, take the maximum needed for integrals and try
C to max out the buffer size, check it is larger than the minimum.
        NCHOBUF=MAXCHOL
        NBGRP=1
        LBGRP(1,1)=IB1
        LBGRP(2,1)=IB2
        NADDBUF=MAXBUFF
        NPIQK=MAXPIQK
      ELSE IF (MXAVAIL.GE.MINGOOD) THEN
C group all batches, take smaller buffer size, and try to max out
C integrals, and check they are lager than minimum needed
        NCHOBUF=MAXCHOL
        NBGRP=1
        LBGRP(1,1)=IB1
        LBGRP(2,1)=IB2
        NADDBUF=MINBUFF
        NCHUNK=(MXAVAIL-MXRHS-2*NADDBUF-2*NCHOBUF)/MINPIQK
        NPIQK=MINPIQK*NCHUNK
      ELSE IF (MXAVAIL.GE.MINSLOW) THEN
        NADDBUF=MINBUFF
        NPIQK=MINPIQK
        NCHOBUF=(MXAVAIL-MXRHS-NPIQK-2*NADDBUF)/2
C create batch groups that have at most MXCHOVEC cholesky vectors
        MXCHOVEC=MAX(NCHOBUF/MXNPITOT,1)
        NCHOVEC=0
        IBGRP=1
        LBGRP(1,IBGRP)=IB1
        DO IB=IB1,IB2
          NV=NVLOC_CHOBATCH(IB)
          NCHOVEC=NCHOVEC+NV
          IF (NCHOVEC.GT.MXCHOVEC) THEN
            LBGRP(2,IBGRP)=IB-1
            IBGRP=IBGRP+1
            LBGRP(1,IBGRP)=IB
            NCHOVEC=NV
          END IF
        END DO
        LBGRP(2,IBGRP)=IB2
        NBGRP=IBGRP
      ELSE
        WRITE(6,*)
        WRITE(6,*) '  Not enough memory in RHSLL2...'
        WRITE(6,'(A,I16)') '   allocatable:    ', MXAVAIL
        WRITE(6,'(A,I16)') '   minimum:        ', MINSLOW
        Call AbEnd()
      END IF

CSVC: sanity check, should not happen.
      IF (MXRHS.GT.MXAVAIL-2*NCHOBUF-NPIQK-2*NADDBUF) THEN
        WRITE(6,*)
        WRITE(6,*) 'RHSALL2: RHS allocation will starve.'
        WRITE(6,*) 'Possible bug in memory estimate.'
        WRITE(6,*) 'This should not happen, please report.'
        WRITE(6,*)
        WRITE(6,'(2X,A8,2X,I14)') 'MXAVAIL ', MXAVAIL
        WRITE(6,'(2X,A8,2X,I14)') 'MXRHS   ', MXRHS
        WRITE(6,'(2X,A8,2X,I14)') 'NCHOBUF ', NCHOBUF
        WRITE(6,'(2X,A8,2X,I14)') 'NPIQK   ', NPIQK
        WRITE(6,'(2X,A8,2X,I14)') 'NADDBUF ', NADDBUF
        CALL AbEnd()
      END IF

      IF (IPRGLB.GT.VERBOSE) THEN
        WRITE(6,*)
        WRITE(6,'(A16,2A16)') '  Buffer sizes:',
     &                        '           used',
     &                        '          ideal'
        WRITE(6,'(A16,2I16)') '  ChoVecs:  ', 2*NCHOBUF, 2*MAXCHOL
        WRITE(6,'(A16,2I16)') '  Integral: ',   NPIQK  ,   MAXPIQK
        WRITE(6,'(A16,2I16)') '  Scatter:  ', 2*NADDBUF, 2*MAXBUFF
        WRITE(6,*)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_PC_Coord_New(Coord,nData)
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"

      Character*24 Label
      Logical      Found
      Real*8, Dimension(:), Allocatable :: Coord

      Label='GeoNewPC'
      Call qpg_dArray(Label,Found,nData)
      If(.not.Found .or. nData.eq.0) Return
      call mma_allocate(Coord,nData,label='Coord')
      Call Get_dArray(Label,Coord,nData)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine CONFIG(NREF,IOCR,nIOCR,L0,L1,L2,L3,JSY,INTNUM,LSYM,JJS,LV,IFCORE,ICOR,NONE_,JONE,JREFX,NFREF)

use guga_global, only: IB, ICASE, IFIRST, ILIM, IRC, ISPIN, IV0, IWAY, J2, JNDX, JRC, LN, MXVERT, N, NIORB, NSM, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Symmetry_Info, only: Mul
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NREF, nIOCR, IOCR(nIOCR), L0(*), L1(*), L2(*), L3(*), INTNUM, LV, IFCORE, ICOR(*), NONE_, JONE(*)
integer(kind=iwp), intent(out) :: JSY(3000), LSYM, JJS(18), JREFX(9000), NFREF
integer(kind=iwp) :: I, I1, IBS, IDIF, IEL, IFEXC, IFREF, IIJ, IJJ, IND, INHOLE, IOC(55), IPART, IRC1, IRC2, IREF, IRR, ISP(55), &
                     ISTA, ITEMP, ITU, IX1, IX2, IX3, IX4, J, JHOLE, JJ1, JND, JPART, JRC1, JRC2, JRC21, JRX, JSYL, K, KM, KM1, L, &
                     LMN, LMN0, LNS, M, MND, NCORR, NSJ, NSJ1
logical(kind=iwp) :: first
integer(kind=iwp), allocatable :: ISO(:,:), JSYM(:), TEMP(:)

JSYL = 30000
JRX = size(JREFX)
IBS = 0
IEL = 2
LSYM = 1
NFREF = 0
LNS = NIORB+LV+1
! Compute wave function symmetry
IRR = 0
do I=LNS,LN
  IRR = IRR+1
  if (IOCR(IRR) == 1) LSYM = Mul(LSYM,NSM(I))
end do
write(u6,'(6X,A,I3)') 'WAVE-FUNCTION SYMMETRY LABEL:',LSYM

! Initialize arrays JJS, JNDX, JSY
JJS(:) = 0
! CONSTRUCT JNDX
! ILIM=2 or ILIM=4 was set by input: Normally 4, but 2 if keyword FIRST
! has been given.
JNDX(:) = 0
JSY(:) = 0
JND = 0
LMN = 0

call mma_allocate(JSYM,JSYL,label='JSYM')
call mma_allocate(ISO,LN,JRX,label='ISO')
call mma_allocate(TEMP,LN,label='TEMP')
do IIJ=1,ILIM
  ! Special cases:
  JRC(IIJ) = LMN
  if ((N == 0) .and. (IIJ > 1)) cycle
  if ((N == 1) .and. (IIJ > 2)) cycle
  if ((N == 2) .and. (ISPIN == 1) .and. (IIJ == 3)) cycle
  if ((N == 2) .and. (ISPIN == 3) .and. (IIJ == 4)) cycle
  ! ISTA is actually an offset, not a start point.
  ISTA = (IIJ-1)*MXVERT
  ! Element in row IJJ=IV0+1-IIJ of the tables is the top vertex, for
  ! IIJ=1 (Valence), 2 (Singles), 3 (Doubles T), 4 (Doubles S).
  ! It is found as element ISTA+IJJ of arrays L0, L1 etc.
  IJJ = IV0+1-IIJ
  KM = 1
  J2(KM) = IJJ
  first = .true.
  do
    if (first) then
      KM = KM+1
      IWAY(KM) = 0
      first = .false.
    end if
    KM1 = KM-1
    ! At KM, trying for a way down.
    if ((L0(ISTA+J2(KM1)) /= 0) .and. (IWAY(KM) < 1)) then
      ! IWAY is 0, and the next vertex L0(ISTA+J2(KM1)) is actually there:
      J2(KM) = L0(ISTA+J2(KM1))
      IWAY(KM) = 1
      IOC(KM1) = 0
      ISP(KM1) = 0
    else if ((L1(ISTA+J2(KM1)) /= 0) .and. (IWAY(KM) < 2)) then
      ! IWAY is 1, and the next vertex is actually there:
      J2(KM) = L1(ISTA+J2(KM1))
      IWAY(KM) = 2
      IOC(KM1) = 1
      ISP(KM1) = 1
    else if ((L2(ISTA+J2(KM1)) /= 0) .and. (IWAY(KM) < 3)) then
      ! IWAY is 2, and the next vertex is actually there:
      J2(KM) = L2(ISTA+J2(KM1))
      IWAY(KM) = 3
      IOC(KM1) = 1
      ISP(KM1) = 2
    else if ((L3(ISTA+J2(KM1)) /= 0) .and. (IWAY(KM) < 4)) then
      ! IWAY is 3, and the next vertex is actually there:
      J2(KM) = L3(ISTA+J2(KM1))
      IWAY(KM) = 4
      IOC(KM1) = 2
      ISP(KM1) = 3
    else
      KM = KM-1
      ! No more ways to try from this vertex. Up to higher vertex:
      if (KM == 1) exit
      ! If KM was 1, then finish this IIJ value and do next one.
      ! Else, take new route from the higher vertex.
      cycle
    end if

    ! While trying to find a new wav through the graph, we found
    ! a feasible edge from a vertex J2(KM) to a vertex at level KM1.
    if (KM1 == NIORB+LV) IBS = IB(J2(KM))
    if (KM /= LN+1) then
      first = .true.
      cycle
    end if
    ! KM has reached top of the graph.

    JND = JND+1
    ! A formally legal way was found. Should it be accepted?
    NSJ = 1
    INHOLE = 0
    do I=1,LN
      if (IOC(I) == 1) NSJ = Mul(NSJ,NSM(I))
      if ((I <= NIORB+LV) .and. (I > LV)) INHOLE = INHOLE+2-IOC(I)
    end do
    ! STRIKE OUT INTERNAL CONFIGURATIONS
    IPART = 0
    if (JND > IRC(1)) IPART = IPART+1
    if (JND > IRC(2)) IPART = IPART+1
    if ((IPART == 0) .and. (NSJ /= LSYM)) cycle
    ! TEST IF TOO HIGHLY EXCITED
    ! TEST ALSO IF REFERENCE STATE
    IFEXC = 0
    IFREF = 0
    JJ1 = 0
    do IREF=1,NREF
      JHOLE = 0
      JPART = IPART
      do I=1,LN
        if (I <= LV) then
          IDIF = IOC(I)
        else if (I <= NIORB+LV) then
          IDIF = IOC(I)-2
        else
          JJ1 = JJ1+1
          if (IOC(I) == IOCR(JJ1)) cycle
          IDIF = IOC(I)-IOCR(JJ1)
        end if
        if (IDIF <= 0) then
          JHOLE = JHOLE-IDIF
        else
          JPART = JPART+IDIF
        end if
      end do
      if (JPART /= JHOLE) then
        write(u6,*) 'Config: JPART /= JHOLE'
        write(u6,*) 'JPART,JHOLE=',JPART,JHOLE
        call Abend()
      end if
      if (JPART <= IEL) IFEXC = 1
      if (JPART == 0) IFREF = 1
    end do
    if (IFEXC == 0) cycle
    if ((IPART == 2) .and. (INTNUM /= 0)) then
      ! INTERACTING SPACE
      if ((INHOLE == 2) .and. (IBS /= 0)) cycle
    end if
    ! NO CORE-CORE CORRELATION
    if (IFCORE /= 0) then
      NCORR = 0
      do I=1,LN
        if (ICOR(I) == 0) cycle
        NCORR = NCORR+2-IOC(I)
      end do
      if (NCORR > 1) cycle
    end if
    ! SINGLY OCCUPIED ORBITALS
    do I=1,NONE_
      if (IOC(JONE(I)) /= 1) cycle
    end do
    LMN = LMN+1
    L = JND
    IND = LMN
    JNDX(L) = IND
    if (IIJ == 1) then
      ! CONSTRUCT INDEX LIST FOR REFERENCE STATES
      if (LMN > JRX) then
        write(u6,*) 'Config: LMN > JRX'
        write(u6,*) 'LMN,JRX=',LMN,JRX
        write(u6,*) 'This error is almost certainly that the problem'
        write(u6,*) ' at hand requires larger arrays than GUGA is'
        write(u6,*) ' compiled for. Please check your input against'
        write(u6,*) ' the manual. If you are certain that this'
        write(u6,*) ' calculation should be possible, please report'
        write(u6,*) ' this as a bug.'
        call Abend()
      end if
      JREFX(LMN) = 0
      if (IFREF /= 0) then
        NFREF = NFREF+1
        JREFX(LMN) = NFREF
      end if
    end if

    JRC(IIJ) = LMN
    if (LMN <= JSYL) then
      JSYM(LMN) = NSJ
      if (IIJ > 2) then
        NSJ1 = NSJ+1
        if (IIJ == 3) JJS(NSJ1) = JJS(NSJ1)+1
        if (IIJ == 4) JJS(NSJ1+9) = JJS(NSJ1+9)+1
      end if
    end if

    if (LMN > JRX) then
      write(u6,*) 'Config: LMN > JRX'
      write(u6,*) 'LMN,JRX=',LMN,JRX
      write(u6,*) 'This error may be due to a bug.'
      write(u6,*) ' Please check your input against the manual.'
      write(u6,*) ' If there is no input errors, please report'
      write(u6,*) ' this as a bug.'
      call Abend()
    end if
    ISO(:,LMN) = ISP(1:LN)
  end do
end do

JRC(ILIM) = LMN
write(u6,214)
IX1 = JRC(1)
IX2 = JRC(2)-JRC(1)
if (IFIRST == 0) then

  !if (N == 2) JRC(3) = JRC(2)

  IX3 = JRC(3)-JRC(2)
  IX4 = JRC(4)-JRC(3)
  write(u6,215) IX1,IX2,IX3,IX4
  if (LMN > JSYL) then
    write(u6,*) 'Config: LMN > JSYL'
    write(u6,*) 'LMN,JSYL=',LMN,JSYL
    call Abend()
  end if
  if ((IX1 >= 8192) .or. (IX2 >= 8192) .or. (IX3 >= 8192) .or. (IX4 >= 8192)) then
    write(u6,*) 'Config: IX? >= 8192'
    write(u6,*) 'IX1,IX2,IX3,IX4=',IX1,IX2,IX3,IX4
    write(u6,*) 'This error is almost certainly that the problem'
    write(u6,*) ' at hand requires larger arrays than GUGA is'
    write(u6,*) ' compiled for. Please check your input against'
    write(u6,*) ' the manual. If you are certain that this'
    write(u6,*) ' calculation should be possible, please report'
    write(u6,*) ' this as a bug.'
    call Abend()
  end if
  ! SORT BY SYMMETRY
  if (NSYM /= 1) then
    ITU = 2
    do
      IRC1 = IRC(ITU)+1
      IRC2 = IRC(ITU+1)
      JRC1 = JRC(ITU)+1
      JRC2 = JRC(ITU+1)
      JRC21 = JRC2-1
      do I=JRC1,JRC21
        I1 = I+1
        do J=I1,JRC2
          if (JSYM(J) >= JSYM(I)) cycle
          ITEMP = JSYM(I)
          JSYM(I) = JSYM(J)
          JSYM(J) = ITEMP
          TEMP(:) = ISO(:,I)
          ISO(:,I) = ISO(:,J)
          ISO(:,J) = TEMP
          do K=IRC1,IRC2
            if (JNDX(K) == I) then
              JNDX(K) = J
            else if (JNDX(K) == J) then
              JNDX(K) = I
            end if
          end do
        end do
      end do
      if (ITU == 3) exit
      ITU = 3
    end do

    ! JJS(2..9): JJS(I+1)=Nr of internal triplet states per symmetry I.
    ! JJS(11..18): JJS(I+10)=Nr of internal singlet states per symmetry I.
    write(u6,407) (JJS(I+1),I=1,NSYM)
    write(u6,408) (JJS(I+10),I=1,NSYM)
    do I=2,NSYM
      I1 = I+1
      JJS(I1) = JJS(I)+JJS(I1)
      JJS(I1+9) = JJS(I+9)+JJS(I1+9)
    end do
    ! Now, JJS is changed to contain instead the corresponding cumulative sum
    ! summed over the symmetries.
  end if
else
  write(u6,216) IX1,IX2
  if ((IX1 >= 8192) .or. (IX2 >= 8192)) then
    write(u6,*) 'Config: IX? >= 8192'
    write(u6,*) 'IX1,IX2=',IX1,IX2
    call Abend()
  end if
end if

! PACK OCCUPATION AND SYMMETRY VECTORS FOR CI
LMN0 = JRC(ILIM)*LN
!PAM97 M = (LMN0+29)/30
M = (LMN0+14)/15
call mma_allocate(ICASE,M,label='ICASE')
ICASE(:) = 0
M = 0
do L=1,LMN
  do K=1,LN
    M = M+1
    MND = ISO(K,L)
    !IOCC((M+29)/30) = OR(IOCC((M+29)/30),1SHIFT(MND,2*((M+29)/30*30-M)))
    !PAM97 QOCC((M+29)/30) = PACK(QOCC((M+29)/30),MND,2*M-(2*M-1)/60*60,2)
    call ICPCK(ICASE,M,MND)
  end do
  !PAM97 NSJ = JSYM(L)-1
  !PAM97 JSY((L+9)/10) = ior(JSY((L+9)/10),ishft(NSJ,29-3*mod(L-1,10)))
  call JSPCK(JSY,L,JSYM(L))
end do
call mma_deallocate(JSYM)
call mma_deallocate(ISO)
call mma_deallocate(TEMP)

return

214 format(//,6X,'INTERNAL CONFIGURATIONS (REAL)')
215 format(/,6X,'NUMBER OF VALENCE STATES',I16,/,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7,/,6X, &
           'NUMBER OF TRIPLET COUPLED DOUBLES',I7,/,6X,'NUMBER OF SINGLET COUPLED DOUBLES',I7)
216 format(/,6X,'NUMBER OF VALENCE STATES',I16,/,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7)
407 format(/6X,'INTERNAL TRIPLET STATES PER SYMMETRY:',6X,8I5)
408 format(6X,'INTERNAL SINGLET STATES PER SYMMETRY:',6X,8I5)

end subroutine CONFIG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
************************************************************************
      Subroutine Rho_meta_GGA2(nD,Rho,nRho,mGrid,
     &                         list_s,nlist_s,TabAO,ipTabAO,mAO,nTabAO,
     &                         Fact,mdc,TabAOMax,list_bas,Index,nIndex)
************************************************************************
*      Author:Roland Lindh, Department of Chemical Physics, University *
*             of Lund, SWEDEN.  2000                                   *
************************************************************************
      use iSD_data
      use k2_arrays, only: DeDe, ipDijS
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "debug.fh"
#include "nq_info.fh"
#include "nsd.fh"
#include "setup.fh"
      Integer list_s(2,nlist_s), ipTabAO(nlist_s), list_bas(2,nlist_s),
     &        Index(nIndex)
      Real*8 Rho(nRho,mGrid), Fact(mdc**2),
     &       TabAO(nTabAO), TabAOMax(nlist_s)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*define _TIME_
#ifdef _TIME_
#endif
#ifdef _DEBUGPRINT_
      If (Debug) Then
         Write (6,*) 'mAO=',mAO
         Write (6,*) 'mGrid=',mGrid
         Write (6,*) 'nTabAO=',nTabAO
         Write (6,*) 'nlist_s=',nlist_s
         Do iList_s = 1, nList_s
            Write (6,*) 'iList_s=',iList_s
            iSkal = list_s(1,ilist_s)
            iCmp  = iSD( 2,iSkal)
            iBas  = iSD( 3,iSkal)
            mTabAO=iBas*iCmp
            Call RecPrt('Rho_meta_GGA: TabAO',' ',
     &                  TabAO(ipTabAO(iList_s)),mAO,mGrid*mTabAO)
         End Do
      End If
#endif
*
      Call FZero(Rho,nRho*mGrid)
*                                                                      *
************************************************************************
*                                                                      *
      Do ilist_s=1,nlist_s
         iSkal = list_s(1,ilist_s)
         iCmp  = iSD( 2,iSkal)
         iBas  = iSD( 3,iSkal)
         iBas_Eff=list_bas(1,ilist_s)
         ix = iDAMax_(mAO*mGrid*iBas_Eff*iCmp,TabAO(ipTabAO(iList_s)),1)
         TabAOMax(ilist_s)=Abs(TabAO(ipTabAO(ilist_s)-1+ix))
         TMax_i=TabAOMax(ilist_s)
         If (TMax_i.le.T_X) Go To 999
         kDCRE=list_s(2,ilist_s)
         index_i=list_bas(2,ilist_s)
         mdci  = iSD(10,iSkal)
         iShell= iSD(11,iSkal)
         nFunc_i=iBas*iCmp
*
         mDij=nFunc_i*nFunc_i
*
*------- Get the Density
*
         ijS=iTri(iShell,iShell)
         ip_Tmp=ipDijs
         Call Dens_Info(ijS,ipDij,ipDSij,mDCRij,ipDDij,ip_Tmp,nD)
*
         ij = (mdci-1)*mdc + mdci
*
         iER=iEOr(kDCRE,kDCRE)
         lDCRER=NrOpr(iER)
*
         ip_D_a=ipDij+lDCRER*mDij
         ip_D_b=ip_D_a
         If (nD.ne.1) ip_D_b=ipDSij+lDCRER*mDij
*
         If (nD.ne.1) Then
            ix=iDAMax_(mDij,DeDe(ip_D_a),1)
            iy=iDAMax_(mDij,DeDe(ip_D_b),1)
            DMax_ii=Half*( Abs(DeDe(ip_D_a-1+ix))
     &                    +Abs(DeDe(ip_D_b-1+iy)) )
         Else
            ix=iDAMax_(mDij,DeDe(ip_D_a),1)
            DMax_ii=Abs(DeDe(ip_D_a-1+ix))
         End If
         If (TMax_i*TMax_i*DMax_ii.ge.T_X) Then
            If (nD.eq.1) Then
               Call Do_Rho9a_d(Rho,nRho,mGrid,
     &                         DeDe(ip_D_a),mAO,
     &                         TabAO(ipTabAO(iList_s)),
     &                         iBas,iBas_Eff,iCmp,
     &                         Fact(ij),T_X,TMax_i*TMax_i,
     &                         Index(index_i))
            Else
               Call Do_Rho9_d(Rho,nRho,mGrid,
     &                        DeDe(ip_D_a),DeDe(ip_D_b),mAO,
     &                        TabAO(ipTabAO(iList_s)),
     &                        iBas,iBas_Eff,iCmp,
     &                        Fact(ij),T_X,TMax_i*TMax_i,
     &                        Index(index_i))
            End If
         End If

*
         Do jlist_s=1,ilist_s-1
            TMax_j=TabAOMax(jlist_s)
            If (TMax_i*TMax_j.lt.T_X) Go To 998
            jSkal = list_s(1,jlist_s)
            kDCRR=list_s(2,jlist_s)
            jCmp  = iSD( 2,jSkal)
            jBas  = iSD( 3,jSkal)
            jBas_Eff=list_bas(1,jlist_s)
            index_j =list_bas(2,jlist_s)
            mdcj  = iSD(10,jSkal)
            jShell= iSD(11,jSkal)
            nFunc_j=jBas*jCmp
*
            mDij=nFunc_i*nFunc_j
*
*---------- Get the Density
*
            ijS=iTri(iShell,jShell)
            ip_Tmp=ipDijs
            Call Dens_Info(ijS,ipDij,ipDSij,mDCRij,ipDDij,ip_Tmp,nD)
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*)
               Write (6,*) 'iS,jS=',iSkal,jSkal
               Write (6,*) 'mDCRij,mDij=',mDCRij,mDij
               Write (6,*) 'ipDij,ipDSij,ipDDij=',ipDij,ipDSij,ipDDij
            End If
#endif
*
            ij = (mdcj-1)*mdc + mdci
*
            iER=iEOr(kDCRE,kDCRR)
            lDCRER=NrOpr(iER)
*
            ip_D_a=ipDij+lDCRER*mDij
            ip_D_b=ip_D_a
            If (nD.ne.1) ip_D_b=ipDSij+lDCRER*mDij
*
            If (nD.ne.1) Then
               ix=iDAMax_(mDij,DeDe(ip_D_a),1)
               iy=iDAMax_(mDij,DeDe(ip_D_b),1)
               DMax_ij=Half*( Abs(DeDe(ip_D_a-1+ix))
     &                       +Abs(DeDe(ip_D_b-1+iy)) )
            Else
               ix=iDAMax_(mDij,DeDe(ip_D_b),1)
               DMax_ij=Abs(DeDe(ip_D_a-1+ix))
            End If
            If (TMax_i*TMax_j*DMax_ij.lt.T_X) Go To 998
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*) 'Rho_meta_GGA2'
               nBB = iBas*jBas
               nCC = iCmp*jCmp
               Write (6,*) 'iShell,jshell=', iShell,jshell
               Write (6,*) 'kDCRE,kDCRR=', kDCRE,kDCRR
               Write (6,*) 'iER,lDCRER=',iER,lDCRER
               Call RecPrt('DAij',' ',DeDe(ip_D_a),nBB,nCC)
               If (nD.ne.1)
     &            Call RecPrt('DBij',' ',DeDe(ip_D_b),nBB,nCC)
            End If
#endif
*
            If (nD.eq.1) Then
               If (iShell.ge.jShell) Then
               Call Do_Rho9a(Rho,nRho,mGrid,
     &                       DeDe(ip_D_a),                  mAO,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       Fact(ij)*Two,T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               Else
               Call Do_Rho9a(Rho,nRho,mGrid,
     &                       DeDe(ip_D_a),                  mAO,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       Fact(ij)*Two,T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               End If
            Else
               If (iShell.ge.jShell) Then
               Call Do_Rho9_(Rho,nRho,mGrid,
     &                       DeDe(ip_D_a),DeDe(ip_D_b),     mAO,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       Fact(ij)*Two,T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               Else
               Call Do_Rho9_(Rho,nRho,mGrid,
     &                       DeDe(ip_D_a),DeDe(ip_D_b),     mAO,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       Fact(ij)*Two,T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               End If
            End If
*
 998        Continue
         End Do                      ! jlist_s
 999     Continue
      End Do                         ! ilist_s
*
#ifdef _DEBUGPRINT_
      If (Debug) Then
c        Do iGrid=1,mGrid_Eff
c           Write (*,*) (Rho(iRho,iGrid),iRho=1,nRho)
c        End Do
         Call RecPrt('Rho_meta_GGA: Rho',' ',Rho,nRho,mGrid)
      End If
*
#endif
#ifdef _TIME_
#endif
      Return
      End
      Subroutine Do_Rho9a(Rho,nRho,mGrid,
     &                    DAij,
     &                    mAO,TabAO1,iBas,iBas_Eff,iCmp,
     &                        TabAO2,jBas,jBas_Eff,jCmp,
     &                    Fact,T_X,TMax_ij,Index_i,Index_j)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Rho(nRho,mGrid), DAij(iBas*iCmp,jBas*jCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp),
     &       TabAO2(mAO,mGrid,jBas_Eff*jCmp)
      Integer Index_i(iBas_Eff*iCmp), Index_j(jBas_Eff*jCmp)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _TIME_
#endif
      Do jCB_Eff = 1, jBas_Eff*jCmp
         jCB = Index_j(jCB_Eff)
*

         Do iCB_Eff = 1, iBas_Eff*iCmp
            iCB = Index_i(iCB_Eff)
*
            DAij_=DAij(iCB,jCB)*Fact
            If (TMax_ij*Abs(DAij_).lt.T_X) Go To 99
*
            Do iGrid = 1, mGrid
               Prod_11=TabAO1(1,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
               Prod_21=TabAO1(2,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
               Prod_12=TabAO1(1,iGrid,iCB_Eff)*TabAO2(2,iGrid,jCB_Eff)
               Prod_31=TabAO1(3,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
               Prod_13=TabAO1(1,iGrid,iCB_Eff)*TabAO2(3,iGrid,jCB_Eff)
               Prod_41=TabAO1(4,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
               Prod_14=TabAO1(1,iGrid,iCB_Eff)*TabAO2(4,iGrid,jCB_Eff)
*
               Prod_22=TabAO1(2,iGrid,iCB_Eff)*TabAO2(2,iGrid,jCB_Eff)
               Prod_33=TabAO1(3,iGrid,iCB_Eff)*TabAO2(3,iGrid,jCB_Eff)
               Prod_44=TabAO1(4,iGrid,iCB_Eff)*TabAO2(4,iGrid,jCB_Eff)
               Prod_1X= TabAO1( 1,iGrid,iCB_Eff) *
     &                 (TabAO2( 5,iGrid,jCB_Eff)
     &                 +TabAO2( 8,iGrid,jCB_Eff)
     &                 +TabAO2(10,iGrid,jCB_Eff))
               Prod_X1=(TabAO1( 5,iGrid,iCB_Eff)
     &                 +TabAO1( 8,iGrid,iCB_Eff)
     &                 +TabAO1(10,iGrid,iCB_Eff))
     &                 *TabAO2( 1,iGrid,jCB_Eff)
*
               Rho(1,iGrid)=Rho(1,iGrid) +     Prod_11      *DAij_
               Rho(2,iGrid)=Rho(2,iGrid) + (Prod_21+Prod_12)*DAij_
               Rho(3,iGrid)=Rho(3,iGrid) + (Prod_31+Prod_13)*DAij_
               Rho(4,iGrid)=Rho(4,iGrid) + (Prod_41+Prod_14)*DAij_
               Rho(5,iGrid)=Rho(5,iGrid)
     &                     + (Prod_22+Prod_33+Prod_44)*DAij_
               Rho(6,iGrid)=Rho(6,iGrid) + (Prod_1X
     &                     + Two*(Prod_22+Prod_33+Prod_44)
     &                                   +  Prod_X1) *DAij_
            End Do    ! iGrid
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
#ifdef _TIME_
#endif
      Return
      End
      Subroutine Do_Rho9_(Rho,nRho,mGrid,
     &                    DAij,DBij,
     &                    mAO,TabAO1,iBas,iBas_Eff,iCmp,
     &                        TabAO2,jBas,jBas_Eff,jCmp,
     &                    Fact,T_X,TMax_ij,Index_i,Index_j)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Rho(nRho,mGrid),
     &       DAij(iBas*iCmp,jBas*jCmp), DBij(iBas*iCmp,jBas*jCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp),
     &       TabAO2(mAO,mGrid,jBas_Eff*jCmp)
      Integer Index_i(iBas_Eff*iCmp), Index_j(jBas_Eff*jCmp)
*                                                                      *
************************************************************************
*                                                                      *
      Do jCB_Eff = 1, jBas_Eff*jCmp
         jCB = Index_j(jCB_Eff)
*
         Do iCB_Eff = 1, iBas_Eff*iCmp
            iCB = Index_i(iCB_Eff)
*
            DAij_=DAij(iCB,jCB)*Fact
            DBij_=DBij(iCB,jCB)*Fact
            Dij_ =Half*(Abs(DAij_)+Abs(DBij_))
            If (TMax_ij*Abs(Dij_).lt.T_X) Go To 99
*
            Do iGrid = 1, mGrid
               Prod_11=TabAO1(1,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
               Prod_21=TabAO1(2,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
               Prod_12=TabAO1(1,iGrid,iCB_Eff)*TabAO2(2,iGrid,jCB_Eff)
               Prod_31=TabAO1(3,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
               Prod_13=TabAO1(1,iGrid,iCB_Eff)*TabAO2(3,iGrid,jCB_Eff)
               Prod_41=TabAO1(4,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
               Prod_14=TabAO1(1,iGrid,iCB_Eff)*TabAO2(4,iGrid,jCB_Eff)
*
               Prod_22=TabAO1(2,iGrid,iCB_Eff)*TabAO2(2,iGrid,jCB_Eff)
               Prod_33=TabAO1(3,iGrid,iCB_Eff)*TabAO2(3,iGrid,jCB_Eff)
               Prod_44=TabAO1(4,iGrid,iCB_Eff)*TabAO2(4,iGrid,jCB_Eff)
               Prod_1X= TabAO1( 1,iGrid,iCB_Eff) *
     &                 (TabAO2( 5,iGrid,jCB_Eff)
     &                 +TabAO2( 8,iGrid,jCB_Eff)
     &                 +TabAO2(10,iGrid,jCB_Eff))
               Prod_X1=(TabAO1( 5,iGrid,iCB_Eff)
     &                 +TabAO1( 8,iGrid,iCB_Eff)
     &                 +TabAO1(10,iGrid,iCB_Eff))
     &                 *TabAO2( 1,iGrid,jCB_Eff)
*
               Rho( 1,iGrid)=Rho(1,iGrid) +     Prod_11      *DAij_
               Rho( 2,iGrid)=Rho(2,iGrid) +     Prod_11      *DBij_
               Rho( 3,iGrid)=Rho(3,iGrid) + (Prod_21+Prod_12)*DAij_
               Rho( 4,iGrid)=Rho(4,iGrid) + (Prod_31+Prod_13)*DAij_
               Rho( 5,iGrid)=Rho(5,iGrid) + (Prod_41+Prod_14)*DAij_
               Rho( 6,iGrid)=Rho(6,iGrid) + (Prod_21+Prod_12)*DBij_
               Rho( 7,iGrid)=Rho(7,iGrid) + (Prod_31+Prod_13)*DBij_
               Rho( 8,iGrid)=Rho(8,iGrid) + (Prod_41+Prod_14)*DBij_
               Rho( 9,iGrid)=Rho( 9,iGrid)
     &                      +(Prod_22+Prod_33+Prod_44)*DAij_
               Rho(10,iGrid)=Rho(10,iGrid)
     &                      +(Prod_22+Prod_33+Prod_44)*DBij_
               Rho(11,iGrid)=Rho(11,iGrid) + (Prod_1X
     &                     + Two*(Prod_22+Prod_33+Prod_44)
     &                                   +  Prod_X1) *DAij_
               Rho(12,iGrid)=Rho(12,iGrid) + (Prod_1X
     &                     + Two*(Prod_22+Prod_33+Prod_44)
     &                                   +  Prod_X1) *DBij_
            End Do    ! iGrid
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
      Return
      End
      Subroutine Do_Rho9a_d(Rho,nRho,mGrid,
     &                    DAii,
     &                    mAO,TabAO1,iBas,iBas_Eff,iCmp,
     &                    Fact,T_X,TMax_ii,Index_i)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Rho(nRho,mGrid), DAii(iBas*iCmp,iBas*iCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp)
      Integer Index_i(iBas_Eff*iCmp)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _TIME_
#endif
      Do jCB_Eff = 1, iBas_Eff*iCmp
         jCB=Index_i(jCB_Eff)
*
         DAii_=DAii(jCB,jCB)*Fact
         If (TMax_ii*Abs(DAii_).ge.T_X) Then
            Do iGrid = 1, mGrid
               Prod_11=TabAO1(1,iGrid,jCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_21=TabAO1(2,iGrid,jCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_31=TabAO1(3,iGrid,jCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_41=TabAO1(4,iGrid,jCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
*
               Prod_22=TabAO1(2,iGrid,jCB_Eff)*TabAO1(2,iGrid,jCB_Eff)
               Prod_33=TabAO1(3,iGrid,jCB_Eff)*TabAO1(3,iGrid,jCB_Eff)
               Prod_44=TabAO1(4,iGrid,jCB_Eff)*TabAO1(4,iGrid,jCB_Eff)
               Prod_1X= TabAO1( 1,iGrid,jCB_Eff) *
     &                 (TabAO1( 5,iGrid,jCB_Eff)
     &                 +TabAO1( 8,iGrid,jCB_Eff)
     &                 +TabAO1(10,iGrid,jCB_Eff))
               Prod_X1=(TabAO1( 5,iGrid,jCB_Eff)
     &                 +TabAO1( 8,iGrid,jCB_Eff)
     &                 +TabAO1(10,iGrid,jCB_Eff))
     &                 *TabAO1( 1,iGrid,jCB_Eff)
*
               Rho(1,iGrid)=Rho(1,iGrid) +     Prod_11*DAii_
               Rho(2,iGrid)=Rho(2,iGrid) + Two*Prod_21*DAii_
               Rho(3,iGrid)=Rho(3,iGrid) + Two*Prod_31*DAii_
               Rho(4,iGrid)=Rho(4,iGrid) + Two*Prod_41*DAii_
               Rho(5,iGrid)=Rho(5,iGrid)
     &                     +(Prod_22+Prod_33+Prod_44)*DAii_
               Rho(6,iGrid)=Rho(6,iGrid) + (Prod_1X
     &                     + Two*(Prod_22+Prod_33+Prod_44)
     &                                   +  Prod_X1) *DAii_
            End Do    ! iGrid
         End If
*
         Do iCB_Eff = 1, jCB_Eff-1
            iCB=Index_i(iCB_Eff)
*
            DAij_=DAii(iCB,jCB)*Fact*Two
            If (TMax_ii*Abs(DAij_).lt.T_X) Go To 99
*
            Do iGrid = 1, mGrid
               Prod_11=TabAO1(1,iGrid,iCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_21=TabAO1(2,iGrid,iCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_12=TabAO1(1,iGrid,iCB_Eff)*TabAO1(2,iGrid,jCB_Eff)
               Prod_31=TabAO1(3,iGrid,iCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_13=TabAO1(1,iGrid,iCB_Eff)*TabAO1(3,iGrid,jCB_Eff)
               Prod_41=TabAO1(4,iGrid,iCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_14=TabAO1(1,iGrid,iCB_Eff)*TabAO1(4,iGrid,jCB_Eff)
*
               Prod_22=TabAO1(2,iGrid,iCB_Eff)*TabAO1(2,iGrid,jCB_Eff)
               Prod_33=TabAO1(3,iGrid,iCB_Eff)*TabAO1(3,iGrid,jCB_Eff)
               Prod_44=TabAO1(4,iGrid,iCB_Eff)*TabAO1(4,iGrid,jCB_Eff)
               Prod_1X= TabAO1( 1,iGrid,iCB_Eff) *
     &                 (TabAO1( 5,iGrid,jCB_Eff)
     &                 +TabAO1( 8,iGrid,jCB_Eff)
     &                 +TabAO1(10,iGrid,jCB_Eff))
               Prod_X1=(TabAO1( 5,iGrid,iCB_Eff)
     &                 +TabAO1( 8,iGrid,iCB_Eff)
     &                 +TabAO1(10,iGrid,iCB_Eff))
     &                 *TabAO1( 1,iGrid,jCB_Eff)
*
               Rho(1,iGrid)=Rho(1,iGrid) +     Prod_11      *DAij_
               Rho(2,iGrid)=Rho(2,iGrid) + (Prod_21+Prod_12)*DAij_
               Rho(3,iGrid)=Rho(3,iGrid) + (Prod_31+Prod_13)*DAij_
               Rho(4,iGrid)=Rho(4,iGrid) + (Prod_41+Prod_14)*DAij_
               Rho(5,iGrid)=Rho(5,iGrid)
     &                     +(Prod_22+Prod_33+Prod_44)*DAij_
               Rho(6,iGrid)=Rho(6,iGrid) + (Prod_1X
     &                     + Two*(Prod_22+Prod_33+Prod_44)
     &                                   +  Prod_X1) *DAij_
            End Do    ! iGrid
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
#ifdef _TIME_
#endif
      Return
      End
      Subroutine Do_Rho9_d(Rho,nRho,mGrid,
     &                     DAii,DBii,
     &                     mAO,TabAO1,iBas,iBas_Eff,iCmp,
     &                     Fact,T_X,TMax_ii,Index_i)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Rho(nRho,mGrid),
     &       DAii(iBas*iCmp,iBas*iCmp), DBii(iBas*iCmp,iBas*iCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp)
      Integer Index_i(iBas_Eff*iCmp)
*                                                                      *
************************************************************************
*                                                                      *
      Do jCB_Eff = 1, iBas_Eff*iCmp
         jCB=Index_i(jCB_Eff)
*
         DAii_=DAii(jCB,jCB)*Fact
         DBii_=DBii(jCB,jCB)*Fact
         Dii_ =Half*(Abs(DAii_)+Abs(DBii_))
         If (TMax_ii*Abs(Dii_).ge.T_X) Then
            Do iGrid = 1, mGrid
               Prod_11=TabAO1(1,iGrid,jCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_21=TabAO1(2,iGrid,jCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_31=TabAO1(3,iGrid,jCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_41=TabAO1(4,iGrid,jCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
*
               Prod_22=TabAO1(2,iGrid,jCB_Eff)*TabAO1(2,iGrid,jCB_Eff)
               Prod_33=TabAO1(3,iGrid,jCB_Eff)*TabAO1(3,iGrid,jCB_Eff)
               Prod_44=TabAO1(4,iGrid,jCB_Eff)*TabAO1(4,iGrid,jCB_Eff)
               Prod_1X= TabAO1( 1,iGrid,jCB_Eff) *
     &                 (TabAO1( 5,iGrid,jCB_Eff)
     &                 +TabAO1( 8,iGrid,jCB_Eff)
     &                 +TabAO1(10,iGrid,jCB_Eff))
               Prod_X1=(TabAO1( 5,iGrid,jCB_Eff)
     &                 +TabAO1( 8,iGrid,jCB_Eff)
     &                 +TabAO1(10,iGrid,jCB_Eff))
     &                 *TabAO1( 1,iGrid,jCB_Eff)
*
               Rho(1,iGrid)=Rho(1,iGrid) +     Prod_11*DAii_
               Rho(2,iGrid)=Rho(2,iGrid) +     Prod_11*DBii_
               Rho(3,iGrid)=Rho(3,iGrid) + Two*Prod_21*DAii_
               Rho(4,iGrid)=Rho(4,iGrid) + Two*Prod_31*DAii_
               Rho(5,iGrid)=Rho(5,iGrid) + Two*Prod_41*DAii_
               Rho(6,iGrid)=Rho(6,iGrid) + Two*Prod_21*DBii_
               Rho(7,iGrid)=Rho(7,iGrid) + Two*Prod_31*DBii_
               Rho(8,iGrid)=Rho(8,iGrid) + Two*Prod_41*DBii_
               Rho( 9,iGrid)=Rho( 9,iGrid)
     &                      +(Prod_22+Prod_33+Prod_44)*DAii_
               Rho(10,iGrid)=Rho(10,iGrid)
     &                      +(Prod_22+Prod_33+Prod_44)*DBii_
               Rho(11,iGrid)=Rho(11,iGrid) + (Prod_1X
     &                     + Two*(Prod_22+Prod_33+Prod_44)
     &                                   +  Prod_X1) *DAii_
               Rho(12,iGrid)=Rho(12,iGrid) + (Prod_1X
     &                     + Two*(Prod_22+Prod_33+Prod_44)
     &                                   +  Prod_X1) *DBii_
            End Do    ! iGrid
         End If
*
         Do iCB_Eff = 1, jCB_Eff-1
            iCB=Index_i(iCB_Eff)
*
            DAij_=DAii(iCB,jCB)*Fact*Two
            DBij_=DBii(iCB,jCB)*Fact*Two
            Dij_ =Half*(Abs(DAij_)+Abs(DBij_))
            If (TMax_ii*Abs(Dij_).lt.T_X ) Go To 99
*
            Do iGrid = 1, mGrid
               Prod_11= TabAO1(1,iGrid,iCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_21= TabAO1(2,iGrid,iCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_12= TabAO1(1,iGrid,iCB_Eff)*TabAO1(2,iGrid,jCB_Eff)
               Prod_31= TabAO1(3,iGrid,iCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_13= TabAO1(1,iGrid,iCB_Eff)*TabAO1(3,iGrid,jCB_Eff)
               Prod_41= TabAO1(4,iGrid,iCB_Eff)*TabAO1(1,iGrid,jCB_Eff)
               Prod_14= TabAO1(1,iGrid,iCB_Eff)*TabAO1(4,iGrid,jCB_Eff)
*
               Prod_22=TabAO1(2,iGrid,iCB_Eff)*TabAO1(2,iGrid,jCB_Eff)
               Prod_33=TabAO1(3,iGrid,iCB_Eff)*TabAO1(3,iGrid,jCB_Eff)
               Prod_44=TabAO1(4,iGrid,iCB_Eff)*TabAO1(4,iGrid,jCB_Eff)
               Prod_1X= TabAO1( 1,iGrid,iCB_Eff) *
     &                 (TabAO1( 5,iGrid,jCB_Eff)
     &                 +TabAO1( 8,iGrid,jCB_Eff)
     &                 +TabAO1(10,iGrid,jCB_Eff))
               Prod_X1=(TabAO1( 5,iGrid,iCB_Eff)
     &                 +TabAO1( 8,iGrid,iCB_Eff)
     &                 +TabAO1(10,iGrid,iCB_Eff))
     &                 *TabAO1( 1,iGrid,jCB_Eff)
*
               Rho(1,iGrid)=Rho(1,iGrid) +     Prod_11      *DAij_
               Rho(2,iGrid)=Rho(2,iGrid) +     Prod_11      *DBij_
               Rho(3,iGrid)=Rho(3,iGrid) + (Prod_21+Prod_12)*DAij_
               Rho(4,iGrid)=Rho(4,iGrid) + (Prod_31+Prod_13)*DAij_
               Rho(5,iGrid)=Rho(5,iGrid) + (Prod_41+Prod_14)*DAij_
               Rho(6,iGrid)=Rho(6,iGrid) + (Prod_21+Prod_12)*DBij_
               Rho(7,iGrid)=Rho(7,iGrid) + (Prod_31+Prod_13)*DBij_
               Rho(8,iGrid)=Rho(8,iGrid) + (Prod_41+Prod_14)*DBij_
               Rho( 9,iGrid)=Rho( 9,iGrid)
     &                      +(Prod_22+Prod_33+Prod_44)*DAij_
               Rho(10,iGrid)=Rho(10,iGrid)
     &                      +(Prod_22+Prod_33+Prod_44)*DBij_
               Rho(11,iGrid)=Rho(11,iGrid) + (Prod_1X
     &                     + Two*(Prod_22+Prod_33+Prod_44)
     &                                   +  Prod_X1) *DAij_
               Rho(12,iGrid)=Rho(12,iGrid) + (Prod_1X
     &                     + Two*(Prod_22+Prod_33+Prod_44)
     &                                   +  Prod_X1) *DBij_
            End Do    ! iGrid
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this fil contains following routines:
c     initfiles
c     reainput
c     wrhead
c     divfok
c     fokunpck1
c     fokunpck2
c     fokunpck3
c     fokunpck4
c     fokunpck5
c     reaintsta
c
c     -----------------------
c
       subroutine initfiles (lenght,lenv,lenn)
c
c     this routine distribute work space WRK for required files
c     for fix mediates it defines also mapd and mapi, for help mediates
c     it estimates their lenght and distribute WRK (i.e. def poss0 parameters)
c     !N.B. This routine cannot run with +OP2 level
c
c       lenght  -  total length of all work space needed
c       lenv    -  length of V - type array
c       lenn    -  length of N - type array
c
#include "ccsd1.fh"
#include "ccsd2.fh"
c
       integer lenght,lenv,lenn
c
c     help variable
c
       integer posst,symp,symq,sympq,symr,syms
       integer lenghtv,lenghtm,lenghth,lenghtn
       integer maxnoa,maxnvb,maxnorb
       integer maxov(1:8)
c
c1    maps and possitions for fix mediated
c
c1.0  maps for DP - diagonal part
c     N.B. DP has one degree of freedom, while other 1 index has none
c     DP1 - dp(p)a
c     DP2 - dp(p)b
c
       do symp=1,nsym
       do symq=1,nsym
       do symr=1,nsym
       mapidp1(symp,symq,symr)=0
       mapidp2(symp,symq,symr)=0
       end do
       end do
       end do
c
       posst=1
c
       possdp10=posst
       mapddp1(0,1)=5
       mapddp1(0,2)=0
       mapddp1(0,3)=0
       mapddp1(0,4)=0
       mapddp1(0,5)=nsym
       mapddp1(0,6)=0
c
       do symp=1,nsym
       mapddp1(symp,1)=posst
       mapddp1(symp,2)=norb(symp)
       mapddp1(symp,3)=symp
       mapddp1(symp,4)=1
       mapddp1(symp,5)=1
       mapddp1(symp,6)=1
       mapidp1(symp,1,1)=symp
       posst=posst+norb(symp)
       end do
c
       possdp20=posst
       mapddp2(0,1)=5
       mapddp2(0,2)=0
       mapddp2(0,3)=0
       mapddp2(0,4)=0
       mapddp2(0,5)=nsym
       mapddp2(0,6)=0
c
       do symp=1,nsym
       mapddp2(symp,1)=posst
       mapddp2(symp,2)=norb(symp)
       mapddp2(symp,3)=symp
       mapddp2(symp,4)=1
       mapddp2(symp,5)=1
       mapddp2(symp,6)=1
       mapidp2(symp,1,1)=symp
       posst=posst+norb(symp)
       end do
c
c
c1.1  maps for T1
c     T11 - t1oaa(a,i)
c     T12 - t1obb(a,i)
c     T13 - t1naa(a,i)
c     T14 - t1nbb(a,i)
c
       posst110=posst
       call grc0 (2,0,3,1,0,0,1,
     & posst110,posst,mapdt11,mapit11)
       posst120=posst
       call grc0 (2,0,4,2,0,0,1,
     & posst120,posst,mapdt12,mapit12)
       posst130=posst
       call grc0 (2,0,3,1,0,0,1,
     & posst130,posst,mapdt13,mapit13)
       posst140=posst
       call grc0 (2,0,4,2,0,0,1,
     & posst140,posst,mapdt14,mapit14)
c
c
c1.2  maps for F1
c     F11 - FI(a,e)aa
c     F12 - FI(a,e)bb
c
       possf110=posst
       call grc0 (2,0,3,3,0,0,1,
     & possf110,posst,mapdf11,mapif11)
       possf120=posst
       call grc0 (2,0,4,4,0,0,1,
     & possf120,posst,mapdf12,mapif12)
c
c
c1.3  maps for F2
c     F21 - FII(m,i)aa
c     F22 - FII(m,i)bb
c
       possf210=posst
       call grc0 (2,0,1,1,0,0,1,
     & possf210,posst,mapdf21,mapif21)
       possf220=posst
       call grc0 (2,0,2,2,0,0,1,
     & possf220,posst,mapdf22,mapif22)
c
c
c1.4  maps for F3
c     F31 - FIII(e,m)aa
c     F32 - FIII(e,m)bb
c
       possf310=posst
       call grc0 (2,0,3,1,0,0,1,
     & possf310,posst,mapdf31,mapif31)
       possf320=posst
       call grc0 (2,0,4,2,0,0,1,
     & possf320,posst,mapdf32,mapif32)
c
c
c1.5  maps for FK
c     FK1 - f(a,b)aa
c     FK2 - f(a,b)bb
c     FK3 - f(a,i)aa
c     FK4 - f(a,i)bb
c     FK5 - f(i,j)aa
c     FK6 - f(i,j)bb
c
       possfk10=posst
       call grc0 (2,0,3,3,0,0,1,
     & possfk10,posst,mapdfk1,mapifk1)
       possfk20=posst
       call grc0 (2,0,4,4,0,0,1,
     & possfk20,posst,mapdfk2,mapifk2)
       possfk30=posst
       call grc0 (2,0,3,1,0,0,1,
     & possfk30,posst,mapdfk3,mapifk3)
       possfk40=posst
       call grc0 (2,0,4,2,0,0,1,
     & possfk40,posst,mapdfk4,mapifk4)
       possfk50=posst
       call grc0 (2,0,1,1,0,0,1,
     & possfk50,posst,mapdfk5,mapifk5)
       possfk60=posst
       call grc0 (2,0,2,2,0,0,1,
     & possfk60,posst,mapdfk6,mapifk6)
c
c
c1.6  maps for T2
c     T21 - t2n(ab,ij)aaaa
c     T22 - t2n(ab,ij)bbbb
c     T33 - t2n(a,b,i,j)abab
c
       posst210=posst
       call grc0 (4,4,3,3,1,1,1,
     & posst210,posst,mapdt21,mapit21)
       posst220=posst
       call grc0 (4,4,4,4,2,2,1,
     & posst220,posst,mapdt22,mapit22)
       posst230=posst
       call grc0 (4,0,3,4,1,2,1,
     & posst230,posst,mapdt23,mapit23)
c
c
c1.7  maps for W0
c     W01 - <mn||ij>aaaa
c     W02 - <mn||ij>bbbb
c     W03 - <mn||ij>abab
c
       possw010=posst
       call grc0 (4,4,1,1,1,1,1,
     & possw010,posst,mapdw01,mapiw01)
       possw020=posst
       call grc0 (4,4,2,2,2,2,1,
     & possw020,posst,mapdw02,mapiw02)
       possw030=posst
       call grc0 (4,0,1,2,1,2,1,
     & possw030,posst,mapdw03,mapiw03)
c
c
c1.8  maps for W1
c     W11 - <ie||mn>aaaa
c     W12 - <ie||mn>bbbb
c     W13 - <ie||mn>abab
c     W14 - <ie||mn>baab
c
       possw110=posst
       call grc0 (4,3,1,3,1,1,1,
     & possw110,posst,mapdw11,mapiw11)
       possw120=posst
       call grc0 (4,3,2,4,2,2,1,
     & possw120,posst,mapdw12,mapiw12)
       possw130=posst
       call grc0 (4,0,1,4,1,2,1,
     & possw130,posst,mapdw13,mapiw13)
       possw140=posst
       call grc0 (4,0,2,3,1,2,1,
     & possw140,posst,mapdw14,mapiw14)
c
c
c2    for help files mapps are irrelevant,
c     here only estimation of maximal lenght is done to
c     define poss0 of help files
c     we have:
c     four V files - of vvoo type
c     four M files - of vvo  type
c     four H files - of voo  type
c     one  N file  - of nn   type
c
c2.*  def max{noa}, max{norb} ,max{nvb}, maxov(isym)=max{noa(isym),nvb(isym)}
c
       maxnoa=noa(1)
       maxnvb=nvb(1)
       maxnorb=norb(1)
       do 100 symp=1,nsym
       if (noa(symp).gt.maxnoa) then
       maxnoa=noa(symp)
       end if
       if (norb(symp).gt.maxnorb) then
       maxnorb=norb(symp)
       end if
       if (nvb(symp).gt.maxnvb) then
       maxnvb=nvb(symp)
       end if
       if (nvb(symp).gt.noa(symp)) then
       maxov(symp)=nvb(symp)
       else
       maxov(symp)=noa(symp)
       end if
 100    continue
c
c2.*  def lenghts of V,M,H and N fils
c
       lenghtv=0
       lenghtm=0
       lenghth=0
       lenghtn=0
c
       do 200 symp=1,nsym
c     symq is not known for N file
c     instead of norb(symr) maxnorb will be used so that reallenght<=lenght
       lenghtn=lenghtn+norb(symp)*maxnorb
       do 201 symq=1,nsym
       sympq=mmul(symp,symq)
c     symr is not known for M and H files
c     instead of noa(symr) maxnoa will be used so that reallenght<=lenght
       lenghtm=lenghtm+maxov(symp)*maxov(symq)*maxnoa
       lenghth=lenghth+maxov(symp)*noa(symq)*maxnoa
       do 202 symr=1,nsym
       syms=mmul(sympq,symr)
       lenghtv=lenghtv+maxov(symp)*maxov(symq)*noa(symr)*noa(syms)
 202    continue
 201    continue
 200    continue
c
c2.1  V - files
c
       possv10=posst
       posst=posst+lenghtv
       possv20=posst
       posst=posst+lenghtv
       possv30=posst
       posst=posst+lenghtv
       possv40=posst
       posst=posst+lenghtv
       lenv=lenghtv
c
c2.2  M - files
c
       possm10=posst
       posst=posst+lenghtm
       possm20=posst
       posst=posst+lenghtm
       possm30=posst
       posst=posst+lenghtm
       possm40=posst
       posst=posst+lenghtm
c
c2.3  H - files
c
       possh10=posst
       posst=posst+lenghth
       possh20=posst
       posst=posst+lenghth
       possh30=posst
       posst=posst+lenghth
       possh40=posst
       posst=posst+lenghth
c
c2.4  N,P - files
c
       possn0=posst
       posst=posst+lenghtn
       possp0=posst
       posst=posst+lenghtn
       lenn=lenghtn
c
c2.5  dedlare space for help matrix D in for matrix multiplication C=AT*B if
c     mchntyp=2
c
       if (mchntyp.eq.2) then
       possd0=posst
       if (maxnoa.le.maxnvb) then
       posst=posst+maxnoa*maxnoa*maxnvb*maxnvb
       else
       posst=posst+maxnoa*maxnoa*maxnoa*maxnoa
       end if
       end if
c
c2.6   def size of Work space
       lenght=posst-1
c
       return
       end
c
c     ----------------------
c
       subroutine reainput
c
c     this routine do:
c     1) read INPDAT file, produced by REORG with mul,nsym,noa,nob,nva,nvb,norb,eps
c     2) read input file for CCSD to read (parameters transported through cmm common)
c     ! title   - jobtitle
c     1-ntit rows with 72 characters
c     no default
c     ! ntit    - number of rows in jobtitle
c     ntit is limited to 10 !!! NOT ANY MORE !!! ntit is limited to 1
c     default (1)
c     ! maxiter - maximum number of iterations
c     default (10)
c     ! typt3   - type of T3 cpntribution
c     0 - CCSD
c     1 - CCSD+T(CCSD)
c     2 - CCSD(T)
c     default (0)
c     ! typden  - type of denominator (division of fok)
c     0 - diagonal elements
c     1 - average of faa and fbb
c     2 - orbital energies
c     default (0)
c     ! firstext- first iteration wnere extrapolation is used
c     (default-no) less than cycext is not possible
c     ! cycext  - cycle of extrapolation
c     (default-no) limited to 2-4
c     ! ccnonv  - energy convergence criterion
c     (default=1.0d-6)
c     ! keysa   - Spin adaptation key
c     0 - no adaptation
c     1 - T2 DDVV adaptation
c     2 - T2 DDVV + T1 DV adaptation
c     3 - full T1 and T2 adaptation (only for doublets)
c     4 - full T2 adaptation without SDVS (only for doublets)
c     (default=0)
c     ! keyrst  - restart key
c     0 - no saving restart informations (amplitudes)
c     1 - save amplitudes
c     2 - start from previous informations
c     (default=1)
c     ! filerst - name for restart informations file
c     (default=RSTART)
c     ! mchntyp - type of machine in matrix multiplication
c     1 - C=A*B is faster or comparable with C=AT*B
c     2 - C=AT*B is faster
c     (default=1)
c     ! slim    - limitation for usieng C=AT*B
c     no default (suitable=2.0d0)
c     ! shifhto - shift for occupied
c     (default=0.0)
c     ! shifhtv - shift for virtuals
c     (default=0.0)
c     ! maxspace - maximal allowed work space
c     (default=0 - unlimited)
c     ! fullprint - level of printing contrlo key
c     (default=0)
c     & noop  - no operation key
c     (default=no)
c     & iokey - I/O control key
c       1 - Fortran I/O system
c       2 - MOLCAS DA IO system
c     (default=2)
c     & mhkey - Matrix handling control key
c       1 - ESSL routines
c       2 - Fortran I/O system
c     & noccsd - key to supress CCSD run
c     (default=no)c     (default=1)
c     .....   - can be added
c
#include "ccsd1.fh"
c
c     help variables
c
       character*80 LINE
       integer nhelp
       integer f_iostat,f_recl
       logical is_error
c
c1    read INPDAT
c
       call molcas_open_ext2(1,'INPDAT','sequential','unformatted',
     &             f_iostat,.false.,f_recl,'unknown',is_error)
c       open (unit=1,file='INPDAT',form='unformatted')
       read (1) nactel,ispin,nsym,lsym,mmul,
     &          noa,nob,nva,nvb,norb,eps,Escf
       close (1)
c
c2    def dimm
c
       do 10 nhelp=1,nsym
c
       dimm(1,nhelp)=noa(nhelp)
       dimm(2,nhelp)=nob(nhelp)
       dimm(3,nhelp)=nva(nhelp)
       dimm(4,nhelp)=nvb(nhelp)
       dimm(5,nhelp)=norb(nhelp)
c
 10     continue
c
c3    define nshf
c
       do 20 nhelp=1,maxorb
       nshf(nhelp)=(nhelp-1)*(nhelp-2)/2
 20     continue

c
c4    define defaults
c
       maxiter=30
       typt3=0
       ntit=1
       typden=0
       yesext=0
       firstext=0
       cycext=0
       ccconv=1.0d-7
       keysa=0
       keyrst=1
       filerst='RSTART'
       mchntyp=1
       slim=1.0d0
       shifto=0.0d0
       shiftv=0.0d0
       maxspace=0
CGG       fullprint=0
       noop=0
       iokey=1
       mhkey=1
       noccsd=0
c
c5    read input file
c
      LuSpool = 17
      Call SpoolInp(LuSpool)
      Rewind(LuSpool)
 5      Read(LuSpool,'(A80)') LINE
       CALL UPCASE(LINE)
       IF( INDEX(LINE,'&CCSDT') .EQ. 0 ) GOTO 5
       TITLE=' '
 6     Read(LuSpool,'(A80)') LINE
       IF(LINE(1:1).EQ.'*') GOTO 6
       CALL UPCASE(LINE)
c
       IF (LINE(1:4).EQ.'TITL') THEN
       Read(LuSpool,'(A72)') TITLE
       ELSE IF (LINE(1:4).EQ.'ITER') THEN
       Read(LuSpool,*) maxiter
       ELSE IF (LINE(1:4).EQ.'DENO') THEN
       Read(LuSpool,*) typden
       if ((typden.lt.0).or.(typden.gt.2)) then
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Invalid type of denominators'
         write(6,*) ' parameter typden changed to 2'
         end if
       typden=2
       end if
       ELSE IF (LINE(1:4).EQ.'EXTR') THEN
       yesext=1
       Read(LuSpool,*) firstext,cycext
       if ((cycext.lt.2).or.(cycext.gt.4)) then
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Size of DIIS procedure out of range'
         write(6,*) ' parameter cycext changed to 4'
         end if
       cycext=4
       end if
       if (firstext.lt.cycext) then
       firstext=cycext
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, First DIIS iteration is smaller '//
     &              'then DIIS size'
         write(6,*) ' parameter firstext was changed to:',firstext
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'ACCU') THEN
       Read(LuSpool,*) ccconv
       ELSE IF (LINE(1:4).EQ.'ADAP') THEN
       Read(LuSpool,*) keysa
       if ((keysa.gt.4).or.(keysa.lt.0)) then
       keysa=0
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Adaptation key out of range'
         write(6,*) ' parameter keysa changed to 0'
         end if
       end if
       if ((keysa.ne.0).and.(typden.eq.0)) then
       typden=2
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, typden is incompatible with SA'
         write(6,*) ' type of denominators changed to 2 - Orb. energies'
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'REST') THEN
       Read(LuSpool,*) keyrst
       if ((keyrst.lt.0).or.(keyrst.gt.2)) then
       keyrst=1
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Restart key out of range'
         write(6,*) ' parameter keyrst changed to 1'
         end if
       end if
       Read(LuSpool,*) filerst
       ELSE IF (LINE(1:4).EQ.'MACH') THEN
       Read(LuSpool,*) mchntyp,slim
       if ((mchntyp.lt.1).or.(mchntyp.gt.2)) then
       mchntyp=1
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Machinetype out of range'
         write(6,*) ' parameter mchtyp changed to 1'
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'SHIF') THEN
       Read(LuSpool,*) shifto,shiftv
       ELSE IF (LINE(1:4).EQ.'PRIN') THEN
       Read(LuSpool,*) fullprint
       if ((fullprint.lt.0).or.(fullprint.gt.3)) then
       fullprint=0
       write(6,*) ' Warning!!!, Printing key out of range'
       write(6,*) ' parameter fullprint changed to 0'
       end if
       ELSE IF (LINE(1:4).EQ.'NOOP') THEN
       noop=1
       ELSE IF (LINE(1:4).EQ.'IOKE') THEN
       Read(LuSpool,*) iokey
       if ((iokey.lt.0).or.(iokey.gt.2)) then
       iokey=2
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, I/O key out of range'
         write(6,*) ' parameter iokey changed to 2'
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'MHKE') THEN
       Read(LuSpool,*) mhkey
       if ((mhkey.lt.0).or.(mhkey.gt.2)) then
       mhkey=1
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Matrix handling key out of range'
         write(6,*) ' parameter mhkey changed to 1'
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'NOSD') THEN
       noccsd=1
       ELSE IF (LINE(1:4).EQ.'END ') THEN
       GOTO 7
       END IF
       GOTO 6
 7      CONTINUE
c
       Call Close_LuSpool(LuSpool)
       return
       end
c
c     ----------------------
c
c
c
c     ----------------------
c
       subroutine wrhead
c
c     this routine write head of ther output file
c     parameters transported through cmm common
c
#include "ccsd1.fh"
c
c     help variables
c
       integer nhelp,nhelp1,nhelp2
c
c1    write header and title
c
*      Call HelloPN
      if (noop.eq.1) then
      write(6,'(6X,A)') ' No Operation is required'
      write(6,'(6X,A)') ' Happy Landing'
      Call Finish(0)
      end if
c
      if ( title(1:1).ne.' ' ) then
          write(6,*)
          write(6,'(6X,112A1)') ('*',i=1,112)
          write(6,'(6X,A1,19X,A72,19X,A1)') '*',title,'*'
          write(6,'(6X,112A1)') ('*',i=1,112)
      end if
c
c2    write occupations and matrix multiplication tablaux
c
       Write(6,*)
       Write(6,*)
       Write(6,'(6X,A)')'Wave function specifications:'
       Write(6,'(6X,A)')'-----------------------------'
       Write(6,*)
       Write(6,'(6X,A,T45,I6)') 'Spin mutiplicity',ispin
       Write(6,'(6X,A,T45,I6)')   'State symmetry',lsym
       Write(6,*)
       Write(6,'(6X,A)')'Orbital specifications:'
       Write(6,'(6X,A)')'-----------------------'
       Write(6,*)
       Write(6,'(6X,A,T47,8I4)')
     & 'Symmetry species',
     & (nhelp,nhelp=1,nsym)
       Write(6,'(6X,A,T47,8I4)')
     & 'Total no. of orbitals',
     & (norb(nhelp),nhelp=1,nsym)
       Write(6,'(6X,A,T47,8I4)')
     & 'No. of occupied orbitals with alpha spin',
     & (noa(nhelp),nhelp=1,nsym)
       Write(6,'(6X,A,T47,8I4)')
     & 'No. of occupied orbitals with beta spin',
     & (nob(nhelp),nhelp=1,nsym)
       Write(6,'(6X,A,T47,8I4)')
     & 'No. of virtual orbitals with alpha spin',
     & (nva(nhelp),nhelp=1,nsym)
       Write(6,'(6X,A,T47,8I4)')
     & 'No. of virtual orbitals with beta spin',
     & (nvb(nhelp),nhelp=1,nsym)
       Write(6,*)
           if (fullprint.gt.1) then
           write(6,*)
           write(6,16) nsym
 16        format (' NUMBER OF IRREPS             :',i3)
           write(6,17)
17         format (' MATRIX MULTIPLICATION TABLE')
           write(6,*)
           write(6,18) (nhelp,nhelp=1,nsym)
18         format (' IRREP #',9x,8(i3,2x))
           write(6,*)
           do 19 nhelp1=1,nsym
           write(6,20) nhelp1,(mmul(nhelp1,nhelp),nhelp=1,nsym)
19         continue
20         format (' IRREP #',i3,6x,8(i3,2x))
           write(6,*)
           end if
       Write(6,*)
       Write(6,'(6X,A)')'Methods and options:'
       Write(6,'(6X,A)')'--------------------'
       Write(6,*)
       Write(6,'(6X,A,T45,I3)') 'Max no. of iterations',maxiter
       if (typden.eq.0) then
         Write(6,'(6X,A,T45,A)') 'Type of denominators',
     &   'diagonal Fock matrix elements'
       else if (typden.eq.1) then
         Write(6,'(6X,A,T45,A)') 'Type of denominators',
     &   'spin averaged diagonal Fock matrix elements'
       else
         Write(6,'(6X,A,T45,A)') 'Type of denominators',
     &   'orbital energies'
       end if
       Write(6,'(6X,A,T45,F22.14)') 'energy convergence criterium',
     & ccconv
       if (yesext.ne.0) then
       end if
c
c6    write orbital energies per symmetry
c
       write(6,*)
       if (fullprint.gt.0) then
       write(6,51)
 51     format (' LIST OF ORBITAL ENERGIES')
       write(6,*)
c
       nhelp2=1
       do nhelp=1,nsym
       write(6,54) nhelp
 54     format (' IRREDUCIBLE REPRESENTATION NO:',i2)
       do nhelp1=1,norb(nhelp)
       write(6,55) nhelp1,eps(nhelp2)
 55     format (' ORBITAL NO:',i3,5x,f16.10)
       nhelp2=nhelp2+1
       end do
       end do
       write(6,*)
       end if
c
c6    extrapolation parameters
c
       if (yesext.eq.0) then
       write(6,61)
 61     format (' DIIS EXTRAPOLATION USED     : NO')
       else
        write(6,62)
 62      format (' DIIS EXTRAPOLATION USED     : YES')
        write(6,63) firstext
 63      format (' FIRST ITERATION OF EXT.     :',i3)
        write(6,64) cycext
 64      format (' EXTRAPOLATION CYCLE         :',i3)
       end if
       write(6,*)
c
c7    convergence criterion
c
CFUE       write(6,71) ccconv
CFUE 71     format (' ENERGY CONVERGENCE CRITER.  : ',d10.5)
c
c8    spin adaptation
c
       if (keysa.eq.0) then
       write(6,81)
       else if (keysa.eq.1) then
       write(6,82)
       else if (keysa.eq.2) then
       write(6,83)
       else if (keysa.eq.3) then
       write(6,84)
       else if (keysa.eq.4) then
       write(6,85)
       end if
 81     format (' SPIN ADAPTATION             : NONE ')
 82     format (' SPIN ADAPTATION             : T2 DDVV ')
 83     format (' SPIN ADAPTATION             : T2 DDVV + T1 DV ')
 84     format (' SPIN ADAPTATION             : T1 AND T2 FULL ')
 85     format (' SPIN ADAPTATION             : T2 FULL WITHOUT SDVS')
c
c9    restart status
       if (keyrst.eq.0) then
       write(6,91)
       else if (keyrst.eq.1) then
       write(6,92) filerst
       else if (keyrst.eq.2) then
       write(6,93) filerst
       end if
 91     format (' RESTART STATUS              : NONE ')
 92     format (' RST. INF. WILL BE SAVED IN  : ',a6)
 93     format (' RST. INF. WILL BE LOAD FROM : ',a6)
c
c10   write matrix multiplication performance
c
       if (mchntyp.eq.1) then
       write(6,101)
       else if (mchntyp.eq.2) then
       write(6,102) slim
       end if
 101    format (' PREFERENCE MATRIX MULT.     : NORMAL')
 102    format (' PREFERENCE MATRIX MULT.     : TRANSP ; LIMIT =',d12.5)
c
c11   write denominator shifts
       write(6,111) shifto
       write(6,112) shiftv
 111    format (' DENOMINATOR SHIFT FOR OCC.  : ',d12.5)
 112    format (' DENOMINATOR SHIFT FOR VIRT. : ',d12.5)
c
c12   write workspace
c
c      if (maxspace.eq.0) then
c      write(6,121)
c      else
c      write(6,122) maxspace
c      end if
c121    format (' MAXIMAL ALLOWED WORK SPACE  : UNLIMITED')
c122    format (' MAXIMAL ALLOWED WORK SPACE  : ',i10)
c
c13   level of printing
c
       if (fullprint.eq.0) then
       write(6,131)
 131    format (' LEVEL OF OUTPUT PRINTING    : MINIMAL')
       else if (fullprint.eq.1) then
       write(6,132)
 132    format (' LEVEL OF OUTPUT PRINTING    : MEDIUM')
       else if (fullprint.eq.2) then
       write(6,133)
 133    format (' LEVEL OF OUTPUT PRINTING    : MAXIMAL')
       else if (fullprint.eq.3) then
       write(6,134)
 134    format (' LEVEL OF OUTPUT PRINTING    : DEBUG')
       end if
c
c14   I/O handling
c
       if (iokey.eq.1) then
       write(6,141)
 141    format (' INPUT/OUTPUT HANDLING       : Standard SQ ')
       else
       write(6,142)
 142    format (' INPUT/OUTPUT HANDLING       : Molcas4  DA ')
       end if
c
c15    Matrix handling
c
       if (mhkey.eq.1) then
       write(6,151)
 151    format (' MATRIX OPERATIONS           : ESSL        ')
       else
       write(6,152)
 152    format (' MATRIX OPERATIONS           : Fortran code')
       end if
c
c*    can be added
c
       write(6,*)
       write(6,*)
c
       return
       end
c
c     -----------------------------------------
c
       subroutine divfok (wrk,wrksize,
     & mapdfa,mapifa,possfa0,mapdfb,mapifb,possfb0,
     & mapdfk1,mapifk1,possfk10,mapdfk2,mapifk2,possfk20,
     & mapdfk3,mapifk3,possfk30,mapdfk4,mapifk4,possfk40,
     & mapdfk5,mapifk5,possfk50,mapdfk6,mapifk6,possfk60,
     & mapddp1,mapidp1,possdp10,mapddp2,mapidp2,possdp20,rc)
c
c     this routine divide fok(p,q) -> fk(a,b) + fk(a,i) + f(i,j) + dp(p)
c     to diagonal part and rest
c
c     mapd and mapi for:
c     fa,fb - fok(p,q)aa,bb
c     fk1-6 - f(ab)aa,f(ab)bb,f(ai)aa,f(ai)bb,f(ij)aa,f(ij)bb
c     dp1,2 - diagonal part dp(p)a,b
c     rc    - return (error) code
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer rc
c
c1    maps for FOKA,FOKB
c
       integer mapdfa(0:512,1:6)
       integer mapifa(1:8,1:8,1:8)
       integer possfa0
c
       integer mapdfb(0:512,1:6)
       integer mapifb(1:8,1:8,1:8)
       integer possfb0
c
c2    maps for FK
c     FK1 - f(a,b)aa
c     FK2 - f(a,b)bb
c     FK3 - f(a,i)aa
c     FK4 - f(a,i)bb
c     FK5 - f(i,j)aa
c     FK6 - f(i,j)bb
c
       integer mapdfk1(0:512,1:6)
       integer mapifk1(1:8,1:8,1:8)
       integer possfk10
c
       integer mapdfk2(0:512,1:6)
       integer mapifk2(1:8,1:8,1:8)
       integer possfk20
c
       integer mapdfk3(0:512,1:6)
       integer mapifk3(1:8,1:8,1:8)
       integer possfk30
c
       integer mapdfk4(0:512,1:6)
       integer mapifk4(1:8,1:8,1:8)
       integer possfk40
c
       integer mapdfk5(0:512,1:6)
       integer mapifk5(1:8,1:8,1:8)
       integer possfk50
c
       integer mapdfk6(0:512,1:6)
       integer mapifk6(1:8,1:8,1:8)
       integer possfk60
c
c
c3    maps for DP - diagonal part
c     DP1 - dp(p)a
c     DP2 - dp(p)b
c
       integer mapddp1(0:512,1:6)
       integer mapidp1(1:8,1:8,1:8)
       integer possdp10
c
       integer mapddp2(0:512,1:6)
       integer mapidp2(1:8,1:8,1:8)
       integer possdp20
c
c     help variables
c
       integer symp,rc1
       integer iifoka,iifokb,iifok,iifaa,iifai,iifii,iidpa,iidpb,iidp
       integer possfoka,possfokb,possfok,possfaa,possfai,possfii
       integer possdpa,possdpb,possdp
c
       rc=0
c
c1    define dp
c
       do 500 symp=1,nsym
c
       iidpa=mapidp1(symp,1,1)
       possdpa=mapddp1(iidpa,1)
       iidpb=mapidp2(symp,1,1)
       possdpb=mapddp2(iidpb,1)
       iifoka=mapifa(symp,1,1)
       possfoka=mapdfa(iifoka,1)
       iifokb=mapifb(symp,1,1)
       possfokb=mapdfb(iifokb,1)
c
       if (norb(symp).gt.0) then
       call fokunpck5 (symp,wrk(possfoka),wrk(possfokb),
     & wrk(possdpa),wrk(possdpb),norb(symp),rc1)
       end if
c
 500    continue
c
c2    define faa,fai,fii
c
       do 1000 symp=1,nsym
       if (norb(symp).eq.0) goto 1000
c
c2.1  alpha case
c
       iifok=mapifa(symp,1,1)
       iifaa=mapifk1(symp,1,1)
       iifai=mapifk3(symp,1,1)
       iifii=mapifk5(symp,1,1)
       iidp=mapidp1(symp,1,1)
c
       possfok=mapdfa(iifok,1)
       possfaa=mapdfk1(iifaa,1)
       possfai=mapdfk3(iifai,1)
       possfii=mapdfk5(iifii,1)
       possdp=mapddp1(iidp,1)
c
       call fokunpck1 (wrk(possfok),wrk(possdp),norb(symp))
       if (nva(symp).gt.0) then
       call fokunpck2 (wrk(possfok),wrk(possfaa),norb(symp),nva(symp),
     &                 noa(symp))
       end if
       if ((noa(symp)*nva(symp)).gt.0) then
       call fokunpck3 (wrk(possfok),wrk(possfai),norb(symp),nva(symp),
     &                 noa(symp))
       end if
       if (noa(symp).gt.0) then
       call fokunpck4 (wrk(possfok),wrk(possfii),norb(symp),noa(symp))
       end if
c
c2.2  alpha case
c
       iifok=mapifb(symp,1,1)
       iifaa=mapifk2(symp,1,1)
       iifai=mapifk4(symp,1,1)
       iifii=mapifk6(symp,1,1)
       iidp=mapidp2(symp,1,1)
c
       possfok=mapdfb(iifok,1)
       possfaa=mapdfk2(iifaa,1)
       possfai=mapdfk4(iifai,1)
       possfii=mapdfk6(iifii,1)
       possdp=mapddp2(iidp,1)
c
       call fokunpck1 (wrk(possfok),wrk(possdp),norb(symp))
       if (nvb(symp).gt.0) then
       call fokunpck2 (wrk(possfok),wrk(possfaa),norb(symp),nvb(symp),
     &                 nob(symp))
       end if
       if ((nob(symp)*nvb(symp)).gt.0) then
       call fokunpck3 (wrk(possfok),wrk(possfai),norb(symp),nvb(symp),
     &                 nob(symp))
       end if
       if (nob(symp).gt.0) then
       call fokunpck4 (wrk(possfok),wrk(possfii),norb(symp),nob(symp))
       end if
c
 1000   continue
c
       return
c Avoid unused argument warnings
       if (.false.) then
         call Unused_integer(possfa0)
         call Unused_integer(possfb0)
         call Unused_integer(possfk10)
         call Unused_integer(possfk20)
         call Unused_integer(possfk30)
         call Unused_integer(possfk40)
         call Unused_integer(possfk50)
         call Unused_integer(possfk60)
         call Unused_integer(possdp10)
         call Unused_integer(possdp20)
       end if
       end
c
c     -------------
c
       subroutine fokunpck1 (fok,dp,dimfok)
c
c     this routine do Fok = Fok - dp
c     fok    - Fok matrix (I/O)
c     dp     - Diagonal part vector (I)
c     dimfok - dimension for Fok matrix - norb (I)
c
       integer dimfok
c
       real*8 fok(1:dimfok,1:dimfok)
       real*8 dp(1:dimfok)
c
c     help variables
c
       integer p
c
c1    substract dp from Fok
       do 100 p=1,dimfok
       fok(p,p)=fok(p,p)-dp(p)
 100    continue
c
       return
       end
c
c     -------------
c
       subroutine fokunpck2 (fok,faa,dimfok,dimfa,shift)
c
c     this routine distribute (Fok - dp) to Faa
c     fok    - Fok matrix (I)
c     faa    - Faa matrix (O)
c     dimfok - dimension for Fok matrix - norb (I)
c     dimfa  - dimension of virtuals - nv (I)
c
       integer dimfok,dimfa,shift
c
       real*8 fok(1:dimfok,1:dimfok)
       real*8 faa(1:dimfa,1:dimfa)
c
c     help variables
c
       integer a,b
c
c1    distribute Fok to Faa
       do 200 b=1,dimfa
       do 201 a=1,dimfa
       faa(a,b)=fok(shift+a,shift+b)
 201    continue
 200    continue
c
       return
       end
c
c     -------------
c
       subroutine fokunpck3 (fok,fai,dimfok,dimfa,dimfi)
c
c     this routine distribute (Fok - dp) to Fai
c     fok    - Fok matrix (I)
c     fai    - Fai matrix (O)
c     dimfok - dimension for Fok matrix - norb (I)
c     dimfa  - dimension of virtuals - nv (I)
c     dimfi  - dimension of occupied - no (I)
c
       integer dimfok,dimfa,dimfi
c
       real*8 fok(1:dimfok,1:dimfok)
       real*8 fai(1:dimfa,1:dimfi)
c
c     help variables
c
       integer a,i
c
c1    distribute Fok to Fai
       do 300 i=1,dimfi
       do 301 a=1,dimfa
       fai(a,i)=fok(dimfi+a,i)
 301    continue
 300    continue
c
       return
       end
c
c     -------------
c
       subroutine fokunpck4 (fok,fii,dimfok,dimfi)
c
c     this routine distribute (Fok - dp) to Fii
c     fok    - Fok matrix (I)
c     fii    - Fii matrix (O)
c     dimfok - dimension for Fok matrix - norb (I)
c     dimfi  - dimension of occupied - no (I)
c
       integer dimfok,dimfi
c
       real*8 fok(1:dimfok,1:dimfok)
       real*8 fii(1:dimfi,1:dimfi)
c
c     help variables
c
       integer i,j
c
c1    distribute Fok to Fii
       do 400 j=1,dimfi
       do 401 i=1,dimfi
       fii(i,j)=fok(i,j)
 401    continue
 400    continue
c
       return
       end
c
c     -------------
c
       subroutine fokunpck5 (symp,foka,fokb,dpa,dpb,dimfok,rc)
c
c     this routine produce dpa,dpb from foka,fokb
c     for some cases
c     shifto,shiftv will be also added
c
c     symp   - symmtry of this block
c     foka   - Fok aa matrix (I)
c     fokb   - Fok bb matrix (I)
c     dpa    - Diagonal part alfa vector (O)
c     dpa    - Diagonal part beta vector (O)
c     dimfok - dimension for Fok matrix - norb (I)
c     rc     - return (error) code
c
#include "ccsd1.fh"
       integer symp,dimfok,rc
c
       real*8 foka(1:dimfok,1:dimfok)
       real*8 fokb(1:dimfok,1:dimfok)
       real*8 dpa(1:dimfok)
       real*8 dpb(1:dimfok)
c
c     help variables
c
       integer p,nhelp1,nhelp2
c
       rc=0
c
       if (typden.eq.0) then
c1    diagonal elements are required
c
       do 100 p=1,dimfok
       dpa(p)=foka(p,p)
       dpb(p)=fokb(p,p)
 100    continue
c
       else if (typden.eq.1) then
c2    (faa+fbb)/2 are required
c
       do 200 p=1,dimfok
       dpa(p)=(foka(p,p)+fokb(p,p))/2
       dpb(p)=dpa(p)
 200    continue
c
       else if (typden.eq.2) then
c3    orbital energies are required
c
c3.1  def shift
       if (symp.eq.1) then
       nhelp1=0
       else
       nhelp1=0
       do 300 nhelp2=1,symp-1
       nhelp1=nhelp1+norb(nhelp2)
 300    continue
       end if
c
c3.2  map oe to dp
       do 400 p=1,dimfok
       dpa(p)=eps(nhelp1+p)
       dpb(p)=eps(nhelp1+p)
 400    continue
c
       else
c     RC=1 : invalid key (NCI/Stup)
       rc=1
       end if
c
       if ((keysa.eq.3).or.(keysa.eq.4)) then
c     for full adaptation scheme only D and V orbitals are shifted
c
       do 501 p=1,nob(symp)
       dpa(p)=dpa(p)-shifto
       dpb(p)=dpb(p)-shifto
 501    continue
c
       do 502 p=1+noa(symp),norb(symp)
       dpa(p)=dpa(p)+shiftv
       dpb(p)=dpb(p)+shiftv
 502    continue
c
       else
c     for other schemes all orbitals are shifted
c
       do 511 p=1,noa(symp)
       dpa(p)=dpa(p)-shifto
 511    continue
c
       do 512 p=1,nob(symp)
       dpb(p)=dpb(p)-shifto
 512    continue
c
       do 513 p=1+noa(symp),norb(symp)
       dpa(p)=dpa(p)+shiftv
 513    continue
c
       do 514 p=1+nob(symp),norb(symp)
       dpb(p)=dpb(p)+shiftv
 514    continue
c
       end if
c
        if (fullprint.ge.2) then
        write (6,*) ' Diagonal part Dp aa, bb for irrep: ',symp
        do p=1,norb(symp)
        write (6,99) p,dpa(p),dpb(p)
99      format (2x,i4,2(f20.14,2x))
        end do
        end if
c
       return
       end
c
c     -------------------------------------
c
       subroutine reaintsta (wrk,wrksize)
c
c     this routine read integral file INTSTA (reorg), which contains
c     following integrals: foka,fokb,
c     <kl||ij>aaaa,<kl||ij>bbbb,<kl||ij>abab
c     <ka||ij>aaaa,<ka||ij>bbbb,<ka||ij>abab,<ka||ij>baab
c     <ab||ij>aaaa,<ab||ij>bbbb,<ab||ij>abab
c
c     two electron integrals are readed to their fix files,
c     foka,fokb are readed to N,P help files
c
c     use and destroy : V1-3, N,P
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "filemgr.fh"
#include "wrk.fh"
c
c     help variables
c
       integer lunsta,rc,f_recl,f_iostat
       logical is_error
c
c*    open INTSTA file
       lunsta=1
       if (iokey.eq.1) then
c      Fortran IO
       call molcas_open_ext2(lunsta,'INTSTA','sequential','unformatted',
     &                     f_iostat,.false.,f_recl,'unknown',is_error)
c       open (unit=lunsta,file='INTSTA',form='unformatted')
c
       else
c      MOLCAS IO
       call daname (lunsta,'INTSTA')
       daddr(lunsta)=0
       end if
c
c1    read foka to N
       call getmediate (wrk,wrksize,
     & lunsta,possn0,mapdn,mapin,rc)
c
c2    read fokb to P
       call getmediate (wrk,wrksize,
     & lunsta,possp0,mapdp,mapip,rc)
c
c
c3    read <kl||ij>aaaa to W01
       call getmediate (wrk,wrksize,
     & lunsta,possw010,mapdw01,mapiw01,rc)
c
c4    read <kl||ij>bbbb to W02
       call getmediate (wrk,wrksize,
     & lunsta,possw020,mapdw02,mapiw02,rc)
c
c5    read <kl||ij>abab to W03
       call getmediate (wrk,wrksize,
     & lunsta,possw030,mapdw03,mapiw03,rc)
c
c
c6    read <ie||mn>aaaa to W11
       call getmediate (wrk,wrksize,
     & lunsta,possw110,mapdw11,mapiw11,rc)
c
c7    read <ie||mn>bbbb to W12
       call getmediate (wrk,wrksize,
     & lunsta,possw120,mapdw12,mapiw12,rc)
c
c8    read <ie||mn>abab to W13
       call getmediate (wrk,wrksize,
     & lunsta,possw130,mapdw13,mapiw13,rc)
c
c9    read <ie||mn>baab to W14
       call getmediate (wrk,wrksize,
     & lunsta,possw140,mapdw14,mapiw14,rc)
c
c
c10   read <ab||ij>aaaa to V1
       call getmediate (wrk,wrksize,
     & lunsta,possv10,mapdv1,mapiv1,rc)
c
c11   read <ab||ij>bbbb to V2
       call getmediate (wrk,wrksize,
     & lunsta,possv20,mapdv2,mapiv2,rc)
c
c12   read <ab||ij>abab to V3
       call getmediate (wrk,wrksize,
     & lunsta,possv30,mapdv3,mapiv3,rc)
c
c*    close INTSTA file
c
       if (iokey.eq.1) then
c      Fortran IO
       close (lunsta)
c
       else
c      MOLCAS IO
       call daclos (lunsta)
       end if
c
       return
       end
c
c      -------------------------------------------------------------
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_X_Dealloc(irc)
!
! T.B. Pedersen, July 2004.
!
! Purpose: deallocate ALL index arrays for the Cholesky utility.
!          On exit, irc=0 signals sucessful completion.

use Cholesky, only: iAtomShl, iBasSh, iiBstRSh, iiBstRSh_G, iiBstRSh_Hidden, iiBstRSh_L_Hidden, iL2G, IndRed, IndRed_G, &
                    IndRed_G_Hidden, IndRed_Hidden, IndRSh, IndRSh_G, IndRSh_G_Hidden, IndRSh_Hidden, InfRed, InfRed_G, &
                    InfRed_G_Hidden, InfRed_Hidden, InfVec, InfVec_Bak, InfVec_G, InfVec_G_Hidden, InfVec_Hidden, IntMap, iQL2G, &
                    iQuAB, iQuAB_Hidden, iQuAB_L, iQuAB_L_Hidden, iRS2F, iScr, iShlSO, iShP2Q, iShP2RS, iSimRI, iSOShl, iSP2F, &
                    LQ_Tot, nBasSh, nBstSh, nDimRS, nnBstRSh, nnBstRSh_G, nnBstRSh_Hidden, nnBstRSh_L_Hidden
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc

irc = 0

! Deallocate.
! -----------

call mma_deallocate(InfRed_Hidden,safe='*')

call mma_deallocate(InfVec_Hidden,safe='*')

call mma_deallocate(IndRed_Hidden,safe='*')

call mma_deallocate(IndRSh_Hidden,safe='*')

call mma_deallocate(iScr,safe='*')

call mma_deallocate(iiBstRSh_Hidden,safe='*')

call mma_deallocate(nnBstRSh_Hidden,safe='*')

call mma_deallocate(IntMap,safe='*')

call mma_deallocate(nDimRS,safe='*')

call mma_deallocate(iRS2F,safe='*')

call mma_deallocate(iSOShl,safe='*')

call mma_deallocate(iShlSO,safe='*')

call mma_deallocate(iQuAB_Hidden,safe='*')

call mma_deallocate(iBasSh,safe='*')

call mma_deallocate(nBasSh,safe='*')

call mma_deallocate(nBstSh,safe='*')

call mma_deallocate(iAtomShl,safe='*')

call mma_deallocate(iSP2F,safe='*')

call mma_deallocate(iShP2RS,safe='*')

call mma_deallocate(iShP2Q,safe='*')

call mma_deallocate(iQuAB_L_Hidden,safe='*')

call mma_deallocate(iQL2G,safe='*')

call mma_deallocate(LQ_Tot,safe='*')

call mma_deallocate(InfVec_Bak,safe='*')

call mma_deallocate(iSimRI,safe='*')

call mma_deallocate(InfVec_G_Hidden,safe='*')

call mma_deallocate(IndRed_G_Hidden,safe='*')

call mma_deallocate(InfRed_G_Hidden,safe='*')

call mma_deallocate(IndRSh_G_Hidden,safe='*')

call mma_deallocate(iiBstRSh_L_Hidden,safe='*')

call mma_deallocate(nnBstRSh_L_Hidden,safe='*')

call mma_deallocate(iL2G,safe='*')

nullify(InfRed,InfVec,IndRed,IndRSh,iiBstRSh,nnBstRSh,iQuAB,iQuAB_L,InfVec_G,IndRed_G,InfRed_G,IndRSh_G,iiBstRSh_G,nnBstRSh_G)

return

end subroutine Cho_X_Dealloc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReadIn_Polar(NoField,Delta,MpProp_Level,Bond_Threshold,iPlot,iPrint,Standard,Opt_Method,UserDen,PrintDen,SubtractDen, &
                        SubScale,Restart,TDensity,nStateI,nStateF,Diffuse,dLimmo,Thrs1,Thrs2,nThrs,ThrsMul,Alpha,LIonize)

use Constants, only: One, Two, OneHalf
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(inout) :: NoField
real(kind=wp), intent(out) :: Delta, Bond_Threshold, SubScale, dLimmo(2), Thrs1, Thrs2, ThrsMul, Alpha
integer(kind=iwp), intent(out) :: MpProp_Level, iPlot, iPrint, nStateI, nStateF, nThrs
logical(kind=iwp), intent(out) :: Standard, UserDen, PrintDen, SubtractDen, Restart, TDensity, Diffuse(3), LIonize
character(len=12), intent(out) :: Opt_Method
!---- Define local variables
integer(kind=iwp) :: LuSpool, iRestart, lMax
logical(kind=iwp) :: Found
character(len=180) :: Key, Line
character(len=180), external :: Get_Ln

! copy input from standard input to a local scratch file

LuSpool = 21
call SpoolInp(LuSpool)

! read input

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

Delta = 0.001_wp
call Get_iScalar('Highest Mltpl',lMax)
MpProp_Level = lMax
Bond_Threshold = OneHalf
iPlot = 0
iPrint = 0
Standard = .true.
UserDen = .false.
PrintDen = .false.
SubtractDen = .false.
Restart = .false.
iRestart = 0
SubScale = One
nStateI = 1
nStateF = 2
Opt_Method = ' '
TDensity = .false.
Diffuse(:) = .false.
dLimmo(:) = [0.65_wp,Two]
Thrs1 = 1.0e-5_wp
Thrs2 = 1.0e-4_wp
nThrs = 3
ThrsMul = 1.0e-2_wp
Alpha = 7.1421297_wp
LIonize = .false.

! Comment on Alpha:
! This value of Alpha is for backward-compability.
! For large systems it may have to be reduced, for
! example to 2.0.

!---- Locate "start of input"
rewind(LuSpool)
call RdNLst(LuSpool,'LoProp')

do
  Key = Get_Ln(LuSpool)
  Line = Key
  call UpCase(Line)

  select case (Line(1:4))
    !case ('TIT')
      !>>>>>>>>>>>>> TITL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

    case ('NOFI')
      !>>>>>>>>>>>>> NOFI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      NoField = .true.

    case ('DELT')
      !>>>>>>>>>>>>> DELT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Key = Get_Ln(LuSpool)
      call Get_F1(1,Delta)

    case ('EXPA')
      !>>>>>>>>>>>>> EXPA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Key = Get_Ln(LuSpool)
      Line = Key
      call UpCase(Line)

      if (Line(1:4) == 'MIDP') then
        Standard = .true.
      else if (Line(1:4) == 'OPTI') then
        Standard = .false.
        Opt_Method = 'Optimized'
      else if (Line(1:4) == 'MULT') then
        Standard = .false.
        Opt_Method = 'Multipole'
      else
        write(u6,*) 'Undefined option for "EXPAnsion center":',Key
        call FindErrorLine()
        call Quit_OnUserError()
      end if

    case ('MPPR')
      !>>>>>>>>>>>>> MPPR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Read max multipole level for output in the MpProp file
      Key = Get_Ln(LuSpool)
      call Get_I1(1,MpProp_Level)

    case ('BOND')
      !>>>>>>>>>>>>> BOND <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Read max bond length - all bonds longer than this will be ignored
      Key = Get_Ln(LuSpool)
      call Get_F1(1,Bond_Threshold)

    case ('PLOT')
      !>>>>>>>>>>>>> PLOT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Provide informations needed for plotting t vs. bond coordinate
      ! as well as printing a table of t values.
      iPlot = 1

    case ('PRIN')
      !>>>>>>>>>>>>> PRIN   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Read print level
      Key = Get_Ln(LuSpool)
      call Get_I1(1,iPrint)

    case ('USER')
      !>>>>>>>>>>>>>> USER   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Tell LoProp to read in density matrix(es) supplied by user.
      UserDen = .true.

    case ('PRDE')
      !>>>>>>>>>>>>>> PRDE   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Tell LoProp to output density matrix to file
      PrintDen = .true.
      NoField = .true. !Only static properties allowed

    case ('SUBD')
      !>>>>>>>>>>>>>> SUBD   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Tell LoProp to subtract a user supplied density matrix
      ! from the current one (which could also be a USER supplied
      ! density matrix). Also input a scaling factor which the
      ! difference density is multiplied by.
      SubtractDen = .true.
      NoField = .true. !Only static properties allowed
      Key = Get_Ln(LuSpool)
      call Get_F1(1,SubScale)

    case ('REST')
      !>>>>>>>>>>>>> REST <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Restart LoProp with the info stored in a previous LoProp
      ! calculation.
      Restart = .true.
      call Qpg_iScalar('LoProp Restart',Found)
      if (Found) then
        call Get_iScalar('LoProp Restart',iRestart)
      end if
      if (iRestart == 0) then
        write(u6,*) 'LoProp was not able to restart.'
        write(u6,*) 'Make sure that LoProp was completed on a previous run.'
        call Quit_OnUserError()
      end if

    case ('TDEN')
      !>>>>>>>>>>>>>> TDEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Tell LoProp to collect a transition density from a previous
      ! Rassi-calculation.
      TDensity = .true.
      NoField = .true.
      Key = Get_Ln(LuSpool)
      call Get_I1(1,nStateI)
      call Get_I1(2,nStateF)

    case ('DIFF')
      !>>>>>>>>>>>>>>>> DIFFuse <<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Section for turning the LoProp moments into diffuse
      ! functions, i.e. obtain an exponent. No moving of bond
      ! stuff allowed.
      NoField = .true.
      Bond_Threshold = huge(Bond_Threshold)
      Key = Get_Ln(LuSpool)
      Line = Key
      call UpCase(Line)
      if (Line(1:4) == 'NUME') then
        Diffuse(1) = .true.
        Diffuse(2) = .true.
        do
          Key = Get_Ln(LuSpool)
          Line = Key
          call UpCase(Line)
          if (Line(1:4) == 'LIMI') then
            Key = Get_Ln(LuSpool)
            call Get_F(1,dLimmo,2)
          else if (Line(1:4) == 'THRE') then
            Key = Get_Ln(LuSpool)
            call Get_F1(1,Thrs1)
            call Get_F1(2,Thrs2)
            call Get_I1(3,nThrs)
            call Get_F1(4,ThrsMul)
          else if (Line(1:4) == 'END ') then
            exit
          else
            write(u6,*) 'Undefined option for "DIFFuse":',Key
            call FindErrorLine()
            call Quit_OnUserError()
          end if
        end do
      else if (Line(1:4) == 'REXT') then
        Diffuse(1) = .true.
        Diffuse(3) = .true.
      else
        write(u6,*) 'Undefined option for "DIFFuse":',Key
        call FindErrorLine()
        call Quit_OnUserError()
      end if

    case ('ALPH')
      !>>>>>>>>>>>>> ALPH <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Change the alpha in the penalty function for the
      ! fluctuating charge contribution to polarisabilities
      Key = Get_Ln(LuSpool)
      call Get_F1(1,Alpha)

    case ('LION')
      !>>>>>>>>>>>>> LION <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      LIonize = .true.

    case ('END ')
      !>>>>>>>>>>>>> END  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      exit

    case default
      write(u6,*) 'Unidentified key word:',Key
      call FindErrorLine()
      call Quit_OnUserError()

  end select

end do

write(u6,*)
if (NoField) then
  write(u6,*) ' No dynamic properties will be computed.'
  write(u6,*)
else
  if (Restart .and. (iRestart == 2)) then
    write(u6,*) ' Previous LoProp calculation was run with the NOFIeld flag.'
    write(u6,*) ' Thus it is not possible to restart and calculate dynamic properties.'
    call Quit_OnUserError()
  end if
  write(u6,*) ' Dynamic properties will be computed.'
  write(u6,*)
  write(u6,'(A,F12.6,A)') '  Applied field +/-',Delta,' au'
  write(u6,*)
end if
write(u6,*) ' Expansion centers of the domains are for the'
if (Standard) then
  write(u6,*) '  atomic domains: the atom center'
  write(u6,*) '  bond domains  : the center of the bond'
else
  write(u6,*) '  atomic domains: the center which set the dipole moments to zero'
  write(u6,*) '  bond domains  : the center which minimize the diagonal terms of the quadrupole moment'
  write(u6,*)
  write(u6,*) ' Observe that if the first non-zero term in the expansion does not dominate,'
  write(u6,*) ' the centers are the original atomic and bond centers!'
end if
write(u6,*)
if (UserDen) then
  write(u6,*) ' Read density matrix from user.'
  write(u6,*)
end if
if (TDensity) then
  write(u6,*) ' Use transition density matrix from Rassi.'
  write(u6,*)
end if
if (Diffuse(1)) then
  write(u6,*) ' Computation of exponents to non-zero width Slater functions.'
  if (Diffuse(2)) then
    write(u6,*) ' --- Numerical determination.'
  else if (Diffuse(3)) then
    write(u6,*) ' --- Analytical determination.'
  end if
  write(u6,*)
end if

! remove local copy of standard input

call Close_LuSpool(LuSpool)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine ReadIn_Polar

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine setstrtvb_cvb(recn)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: recn
integer(kind=iwp) :: iadd, jadd
real(kind=wp), parameter :: recdef = 3200.2_wp
logical(kind=iwp), external :: tstfile_cvb ! ... Files/Hamiltonian available ...

if (recn /= Zero) return
if (.not. tstfile_cvb(recdef)) return
do iadd=1,99
  if (.not. tstfile_cvb(recdef+real(iadd,kind=wp))) then
    jadd = iadd-1
    recn = recdef+real(jadd,kind=wp)
    return
  end if
end do

return

end subroutine setstrtvb_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
SUBROUTINE matderiv(diff_Order, d, m, d1, d2)
  use kriging_mod
  Implicit None
#include "stdalloc.fh"
  integer diff_Order,d1,d2
  real*8 d(d1,d2),m(d1,d2)
!
! Local variables
  integer p0,k
  real*8 nr,kr,a,t
  real*8, Allocatable :: b(:,:), dh(:,:), c(:,:)
!
  Call mma_Allocate(b,d1,d2,label="b")
  Call mma_Allocate(dh,d1,d2,label="dh")
  Call mma_Allocate(c,d1,d2,label="c")
!
  m = 0
!
! Analytic or Numerical Derivatives
!
  if (anMd) then
    p0=int(pAI)
    t=sqrt(2.0D0*pAI+1.0D0)
    dh(:,:) = sqrt(d)
    c(:,:)=(2.0D0*pAI+1)/(2.0D0*pAI-1)*exp(-t*dh)
    if (pAI.gt.3.or.pAI.lt.1) then
      Write(6,*) 'Analytical Matern derivatives (anamat=.True.)'
      Write(6,*) 'is only valid for pAI = 1, 2 and 3(v = 3/2, 5/2 and 7/2)'
    else
      select case (p0)
        case (1)
          select case (diff_Order)
            case (1)
              m = -c/2.0D0
            case (2)
              m = c*merge(0.75D0*t/dh,dh,dh.ne.0)/3.0d0
            case (3)
              m = -(2.0D0*t-3.0D0*dh)*c
          end select
        case (2)
          select case (diff_Order)
            case (1)
              m =-c*(1.0D0+t*dh)/2.0d0
            case (2)
              m = c*5.0D0/4.0D0
            case (3)
              m = merge(-5.0D0/8.0D0*t/dh,dh,dh.ne.0)*c
          end select
        case (3)
          select case (diff_Order)
            case (1)
              m =-c*(1.0D0+t*dh+dh**2)/2.0D0
            case (2)
              m = c*7.0D0*(1.0D0+t*dh)/12.0D0
            case (3)
              m = -c*49.0D0/24.0D0
          end select
      end select
    endif
  else
    ! write (6,*) 'Numerical Matern derivatives num',diff_Order
    nr = dble(diff_Order)
    a = Gamma(nr+1.0D0)/h**diff_Order
    b = 0.0D0
    do k = 0, diff_Order
      kr = dble(k)
      dh(:,:) = d(:,:) + kr*h
      call matern(dh, m, size(dh,1), size(dh,2))
      b(:,:) = b(:,:) + DBLE((-1)**(k+1))/(Gamma(nr-kr+1.0D0)*Gamma(kr+1.0D0))*m
    enddo
    m = a*b*DBLE((-1)**(nr+1))
  endif
!
  Call mma_deAllocate(b)
  Call mma_deAllocate(dh)
  Call mma_deAllocate(c)
!
END SUBROUTINE matderiv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************

subroutine matderiv(diff_Order,d,m,d1,d2)

use kriging_mod, only: anMd, h, pAI
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Four, Five, Seven, Eight, Twelve
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: diff_Order, d1, d2
real(kind=wp), intent(in) :: d(d1,d2)
real(kind=wp), intent(out) :: m(d1,d2)
! Local variables
integer(kind=iwp) :: k
real(kind=wp) :: nr, kr, a, t
real(kind=wp), allocatable :: b(:,:), dh(:,:), c(:,:)

call mma_Allocate(b,d1,d2,label='b')
call mma_Allocate(dh,d1,d2,label='dh')
call mma_Allocate(c,d1,d2,label='c')

m(:,:) = 0

! Analytic or Numerical Derivatives

if (anMd) then
  t = sqrt(Two*pAI+One)
  dh(:,:) = sqrt(d)
  c(:,:) = (Two*pAI+One)/(Two*pAI-One)*exp(-t*dh)
  if (pAI > 3 .or. pAI < 1) then
    write(u6,*) 'Analytical Matern derivatives (anamat=.True.)'
    write(u6,*) 'is only valid for pAI = 1, 2 and 3 (v = 3/2, 5/2 and 7/2)'
  else
    select case (pAI)
      case (1)
        select case (diff_Order)
          case (1)
            m(:,:) = -c(:,:)/Two
          case (2)
            m(:,:) = c(:,:)*merge(0.75_wp*t/dh,dh,dh /= 0)/Three
          case (3)
            m(:,:) = -(Two*t-Three*dh)*c(:,:)
        end select
      case (2)
        select case (diff_Order)
          case (1)
            m(:,:) = -c(:,:)*(One+t*dh)/Two
          case (2)
            m(:,:) = c(:,:)*Five/Four
          case (3)
            m(:,:) = merge(-Five/Eight*t/dh,dh,dh /= 0)*c(:,:)
        end select
      case (3)
        select case (diff_Order)
          case (1)
            m(:,:) = -c(:,:)*(One+t*dh+dh**2)/Two
          case (2)
            m(:,:) = c(:,:)*Seven*(One+t*dh)/Twelve
          case (3)
            m(:,:) = -c(:,:)*49.0_wp/24.0_wp
        end select
    end select
  end if
else
  ! write (u6,*) 'Numerical Matern derivatives num',diff_Order
  nr = real(diff_Order,kind=wp)
  a = gamma(nr+One)/h**diff_Order
  b = Zero
  do k=0,diff_Order
    kr = real(k,kind=wp)
    dh(:,:) = d(:,:)+kr*h
    call matern(dh,m,size(dh,1),size(dh,2))
    b(:,:) = b(:,:)+One**(k+1)/(gamma(nr-kr+One)*gamma(kr+One))*m(:,:)
  end do
  m(:,:) = a*b*(-One)**(nr+1)
end if

call mma_deAllocate(b)
call mma_deAllocate(dh)
call mma_deAllocate(c)

end subroutine matderiv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine psym2_cvb(civec1,civec2,
     >  isymalf,isymbet,iasyind,ibsyind,osym,ips)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension civec1(nda,ndb),civec2(nda,ndb)
      dimension isymalf(nda),isymbet(ndb)
      dimension iasyind(0:mxirrep),ibsyind(0:mxirrep)
      dimension osym(mxirrep)

      if(ips.eq.1)then
        do 1000 irp=1,nirrep
        if(isympr(irp).eq.1)goto 1000
        do 100 jrpa=1,nirrep
        jrpb=md2h(irp,jrpa)
        do 101 ida=iasyind(jrpa-1)+1,iasyind(jrpa)
        inda=isymalf(ida)
        do 102 idb=ibsyind(jrpb-1)+1,ibsyind(jrpb)
        civec1(inda,isymbet(idb))=zero
102     continue
101     continue
100     continue
1000    continue
      elseif(ips.eq.2)then
        do 2000 irp=1,nirrep
        osym(irp)=zero
        do 200 jrpa=1,nirrep
        jrpb=md2h(irp,jrpa)
        do 201 ida=iasyind(jrpa-1)+1,iasyind(jrpa)
        inda=isymalf(ida)
        do 202 idb=ibsyind(jrpb-1)+1,ibsyind(jrpb)
        osym(irp)=osym(irp)+
     >    civec1(inda,isymbet(idb))*civec2(inda,isymbet(idb))
202     continue
201     continue
200     continue
2000    continue
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gen_vvoo(w,l1,tmp,l2)
! this routine does:
!
! regenerate (ab,ij) integrals from blocked
! MO cholesky vectors
!
! <vv|oo> = (vo|vo)
!
! --------
!
!       L1(m,I,A')

use ChT3_global, only: DimGrpaR, L1Name, LunAux, nc, no, nv, NvGrp
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: w(*)
real(kind=wp), intent(_OUT_) :: l1(*), tmp(*), l2(*)
integer(kind=iwp) :: a, a_tmp, b, b_tmp, dima, dimb, lasta, lastb, length

do a=1,NvGrp

  !1 read tmp(m,I,A')

  dima = DimGrpaR(a)
  length = nc*no*dima
  call GetX_t3(tmp,length,LunAux,L1Name(a),1,1)

  !5 map l1 (A',I,m) <- tmp (m,I,A')

  call Map3_321_t3(tmp,l1,nc,no,dima)

  ! ----- read tmp(m,I,B')

  do b=1,a

    dimb = DimGrpaR(b)
    length = nc*no*dimb
    call GetX_t3(tmp,length,LunAux,L1Name(b),1,1)

    !4 map l2 (m,B',I) <- tmp (m,I,B')

    call Map3_132_t3(tmp,l2,nc,no,dimb)

    ! zero tmp

    tmp(1:dima*no*dimb*no) = Zero

    !7 mult tmp(A',I,B',J) <- l1 (A',I,m) . l2(m,B',J)

    call mc0c1a3b(dima*no,nc,nc,dimb*no,dima*no,dimb*no,dima*no,nc,dimb*no,l1,l2,tmp)

    lasta = 0
    if (a > 1) then
      do a_tmp=1,a-1
        lasta = lasta+DimGrpaR(a_tmp)
      end do
    end if

    lastb = 0
    if (b > 1) then
      do b_tmp=1,b-1
        lastb = lastb+DimGrpaR(b_tmp)
      end do
    end if

    !write(u6,'(A,4(i4,x))') 'BB1 dima, dimb, lasta, lastb ',dima,dimb,lasta,lastb
    call grow_vvoo(w,tmp,no,nv,dima,dimb,lasta,lastb)

    if (a /= b) then

      call Map4_3412_t3(tmp,l2,dima,no,dimb,no)

      !write(u6,'(A,4(i4,x))') 'BB2 dima, dimb, lasta, lastb ',dimb,dima,lastb,lasta
      call grow_vvoo(w,l2,no,nv,dimb,dima,lastb,lasta)

    end if

    !3 end loop over B'

  end do

  !3 end loop over A'

end do

return

end subroutine gen_vvoo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,2005, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      Subroutine PLF_RI_2(AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iShell,
     &                    iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,kOp,
     &                    TInt,nTInt,iSO2Ind,iOffA,nSOs)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*          Modified to 2-center RI June '05                            *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use Basis_Info, only: nBas
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "srt0.fh"
#include "srt1.fh"
#include "WrkSpc.fh"
*
      Real*8 AOint(ijkl,jCmp,lCmp), TInt(nTInt)
      Integer iShell(4), iAO(4), kOp(4), iAOst(4),
     &        iSO2Ind(nSOs), iOffA(4)
      Logical Shijij
*                                                                      *
************************************************************************
*                                                                      *
       iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      irout = 109
      iPrint = nPrint(irout)
      iPrint=99
      If (iPrint.ge.49) Then
         r1=DDot_(ijkl*jCmp*lCmp,AOInt,1,[One],0)
         r2=DDot_(ijkl*jCmp*lCmp,AOInt,1,AOInt,1)
         Write (6,*) ' Sum=',r1
         Write (6,*) ' Dot=',r2
      End If
      If (iPrint.ge.99) Call RecPrt(' In Plf_RI_2: AOInt',' ',
     &                              AOInt,ijkl,jCmp*lCmp)
#endif
*
      iAOstj=iAOst(2)
      iAOstl=iAOst(4)
      iAOj=iAO(2)
      iAOl=iAO(4)
      iOff = nBas(0)
      iOffA_ = iOffA(1)
      mm_= iOffA(4)
      nn = mm_ - iOffA(2)
      mx = nn*(nn+1)/2
*
#ifdef _DEBUGPRINT_
      Write (6,*) 'nn,mx=',nn,mx
      Write (6,*) 'iOff=',nn,mx
      Write (6,*) 'lBas,jBas=',lBas,jBas
      Write (6,*) 'lCmp,jCmp=',lCmp,jCmp
#endif
*
      Do i2 = 1, jCmp
         jSO=iAOtSO(iAOj+i2,kOp(2))+iAOstj
         Do i4 = 1, lCmp
            lSO=iAOtSO(iAOl+i4,kOp(4))+iAOstl
*
            nijkl = 0
            Do lSOl = lSO, lSO+lBas-1
               kSO = lSOl - iOff
*
               Do jSOj = jSO, jSO+jBas-1
*
                  iSO = jSOj - iOff
                  nijkl = nijkl + 1
                  AInt=AOint(nijkl,i2,i4)
*
                  iSO = iSO2Ind(iSO) + nn
                  ij = iTri(iSO,kSO) - mx + iOffA_
                  TInt(ij)=AInt
*
               End Do
            End Do
*
         End Do
      End Do
*
#ifdef _WARNING_WORKAROUND_
      If (.False.) Then
         Call Unused_integer(iCmp)
         Call Unused_integer(kCmp)
         Call Unused_integer_array(iShell)
         Call Unused_logical(Shijij)
         Call Unused_integer(iBas)
         Call Unused_integer(kBas)
      End If
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Per-Olof Widmark                                 *
!               2012, Victor P. Vysotskiy                              *
!***********************************************************************
!***********************************************************************
!                                                                      *
!                             A I X - I / O                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! rc=AixWr(Handle,Buf,nBuf,iDisk)                                      *
!                                                                      *
! A buffer is written to a file associated with the file handle. The   *
! operation is asynchronous, and must be followed by a call to AixWt   *
! to assure data integrity.                                            *
!                                                                      *
! Input:  Handle   - This is the unique file identifier associated     *
!                    with the file. It is created by AixOpn, and must  *
!                    be used on subsequent references to the file.     *
!         Buf      - The buffer that is to be written to disk.         *
!         nBuf     - Length of the buffer in words.                    *
!         iDisk    - External disk address.                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          S&TC, ACIS, IBM Sweden                                      *
! Written: November 1990                                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! History:                                                             *
!     V.P. Vysotskiy,University of Lund, Sweden, 2012                  *
!                                                                      *
!***********************************************************************

function AixWr(handle,Buf,nBuf,iDisk)

use Fast_IO, only: CtlBlk, eEof, eInErr, eNtOpn, FCtlBlk, MxFile, pDesc, pHndle, ProfData, pWhere
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: AixWr
integer(kind=iwp), intent(in) :: handle, Buf(*), nBuf
integer(kind=iwp), intent(inout) :: iDisk
integer(kind=iwp) :: desc, Lu, n, nFile, rc, pDisk
real(kind=wp) CPUA, CPUE, TIOA, TIOE
character(len=80) :: ErrTxt
character(len=*), parameter :: TheName = 'AixWr'
integer(kind=iwp), external :: AixErr
#include "warnings.h"
interface
  function c_lseek(FileDescriptor,Offset) bind(C,name='c_lseek_')
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: c_lseek
    integer(kind=MOLCAS_C_INT) :: FileDescriptor, Offset
  end function c_lseek
end interface

!----------------------------------------------------------------------*
! Entry to AixWr                                                       *
!----------------------------------------------------------------------*
AixWr = 0
!----------------------------------------------------------------------*
! Check if file is opened.                                             *
!----------------------------------------------------------------------*
n = 1
do
  if (CtlBlk(pHndle,n) == handle) exit
  n = n+1
  if (n > MxFile) then
    AixWr = eNtOpn
    return
  end if
end do
nFile = n
desc = CtlBlk(pDesc,nFile)
call FSCB2UNIT(handle,Lu)
call Timing(CPUA,CPUE,TIOA,TIOE)
!----------------------------------------------------------------------*
! Position file pointer                                                *
!----------------------------------------------------------------------*
pDisk = iDisk
if (CtlBlk(pWhere,nFile) /= pDisk) then
  rc = c_lseek(desc,pDisk)
  ProfData(7,Lu) = ProfData(7,Lu)+1
  if (rc < 0) then
    call FASTIO('STATUS')
    AixWr = AixErr(ErrTxt)
    call SysWarnFileMsg(TheName,FCtlBlk(nFile),'MSG: seek',ErrTxt)
    call SysCondMsg('rc < 0',rc,'<',0)
  else if (rc /= pDisk) then
    call FASTIO('STATUS')
    AixWr = eInErr
    call SysWarnFileMsg(TheName,FCtlBlk(nFile),'MSG: seek',' ')
    call SysCondMsg('rc != pDisk',rc,'!=',pDisk)
  end if
end if
CtlBlk(pWhere,nFile) = pDisk
!----------------------------------------------------------------------*
! Write to file                                                        *
!----------------------------------------------------------------------*
rc = c_write_wrapper(desc,Buf,nBuf)
if (rc < 0) then
  call FASTIO('STATUS')
  AixWr = AixErr(ErrTxt)
  call SysQuitFileMsg(_RC_IO_ERROR_WRITE_,TheName,FCtlBlk(nFile),'Premature abort while writing buffer to disk: ',ErrTxt)
else if (rc /= nBuf) then
  call FASTIO('STATUS')
  AixWr = eEof
  call SysQuitFileMsg(_RC_IO_ERROR_WRITE_,TheName,FCtlBlk(nFile),'Premature abort while writing buffer to disk: ','Disk full? ')
end if
CtlBlk(pWhere,nFile) = CtlBlk(pWhere,nFile)+nBuf
iDisk = iDisk+nBuf
call Timing(CPUA,CPUE,TIOA,TIOE)
ProfData(1,Lu) = ProfData(1,Lu)+1
ProfData(2,Lu) = ProfData(2,Lu)+nBuf
ProfData(3,Lu) = ProfData(3,Lu)+TIOE
!----------------------------------------------------------------------*
! Finished so return to caller                                         *
!----------------------------------------------------------------------*
return

contains

function c_write_wrapper(FileDescriptor,Buffer,nBytes)

  use, intrinsic :: iso_c_binding, only: c_loc

  integer(kind=iwp) :: c_write_wrapper
  integer(kind=iwp), intent(in) :: FileDescriptor, nBytes
  integer(kind=iwp), intent(in), target :: Buffer(*)
  interface
    function c_write(FileDescriptor,Buffer,nBytes) bind(C,name='c_write_')
      use, intrinsic :: iso_c_binding, only: c_ptr
      use Definitions, only: MOLCAS_C_INT
      integer(kind=MOLCAS_C_INT) :: c_write
      integer(kind=MOLCAS_C_INT) :: FileDescriptor, nBytes
      type(c_ptr), value :: Buffer
    end function c_write
  end interface

  c_write_wrapper = c_write(FileDescriptor,c_loc(Buffer(1)),nBytes)

end function c_write_wrapper

end function AixWr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE BJAI(IAD,EPSI,EPSE,E2BJAI,VECL2)

      IMPLICIT REAL*8 (A-H,O-Z)

#include "mxdim.fh"
#include "corbinf.fh"
#include "files_mbpt2.fh"
#include "WrkSpc.fh"
      DIMENSION EPSI(*),EPSE(*),IAD(3888)
      Logical DoCholesky, Debug
      Data Debug/.False./
c      Data Debug/.True./   ! CGG
      Dimension dVectorA(255) ! CGG
      Dimension dVectorB(255) ! CGG

#include "SysDef.fh"

      MUL(I,J)=1+IEOR(I-1,J-1)


      SKAL2=-9999999.9
      IAD13=0
      LIADUT=3888

      Call DecideOnCholesky(DoCholesky)
      If (Debug) then
      Write(6,*)
      Write(6,'(A,8I3)')'      nOcc:',(nOcc(i),i=1,nSym)
      Write(6,'(A,8I3)')'      nExt:',(nExt(i),i=1,nSym)
      Write(6,'(A,8I3)')'      nOrb:',(nOrb(i),i=1,nSym)
      EndIf

      CALL iDAFILE(LUINTM,2,IAD,LIADUT,IAD13)

      VECL2=1.0D+00
      E2BJAI=0.0D+00
      ISPQRS=0
      NRI=0
      DO 10 iSymI=1,nSym
       nOccI=nOcc(iSymI)
       nOrbI=nOrb(iSymI)
       NRJ=0
       DO 20 iSymJ=1,iSymI
        nOccJ=nOcc(iSymJ)
        nOrbJ=nOrb(iSymJ)
        NRA=0
        DO 30 iSymA=1,nSym
         nExtA=nExt(iSymA)
         nOrbA=nOrb(iSymA)
         NRB=0
         DO 40 iSymB=1,iSymA
          nExtB=nExt(iSymB)
          nOrbB=nOrb(iSymB)
          ISPQRS=ISPQRS+1
          IF (nOccI*nOccJ*nExtA*nExtB.EQ.0) GOTO 41
          IF (MUL(iSymI,iSymJ).EQ.MUL(iSymA,iSymB)) THEN
           IAD1=IAD(3*ISPQRS-1)
           IAD2=IAD(3*ISPQRS)

      If(Debug) then
      Write(6,*)
      Write(6,*)' [BJAI] Integrals <A,B|I,J> : ',iSymA,iSymB,iSymI,iSymJ
      EndIf
*    ---   iSymI.NE.iSymJ   ---
           IF (iSymI.NE.iSymJ) THEN
            LAB = nOrbA * nOrbB
            If (DoCholesky) LAB=nExtA * nExtB
            LAB1= nExtA * nExtB
            LB  = nExtB
            Call GetMem('INT1','ALLO','REAL',LINT1,LAB)
            Call GetMem('INT2','ALLO','REAL',LINT2,LAB)
            Call GetMem('AIBJ','ALLO','REAL',LAIBJ,LAB1) ! AB|IJ
            Call GetMem('AJBI','ALLO','REAL',LAJBI,LAB1) ! AB|JI
            DO 50 iI=1,nOccI
             DO 60 iJ=1,nOccJ
      If(Debug) then
      Write(6,*)
      Write(6,*) ' *  i,j = ',iI,iJ
      EndIf
              Call dDAFile(LUINTM,2,Work(LINT1),LAB,IAD1)
              Call dDAFile(LUINTM,2,Work(LINT2),LAB,IAD2)
      If (Debug .and. DoCholesky ) then
      Call RecPrt('Int1:','(8F10.6)',Work(lInt1),nExtB,nExtA)
      Call RecPrt('Int2:','(8F10.6)',Work(lInt2),nExtB,nExtA)
      EndIf
      If (Debug .and. .NOT.DoCholesky ) then
      Call RecPrt('Int1:','(8F10.6)',Work(lInt1),nOrbB,nOrbA)
      Call RecPrt('Int2:','(8F10.6)',Work(lInt2),nOrbB,nOrbA)
      EndIf
              EDIFIJ=EPSI(NRI+iI)+EPSI(NRJ+iJ)
              IADA=nOcc(iSymA) * nOrbB + nOcc(iSymB)
              If (DoCholesky) IADA=0  ! CGG
              IADB=LINT2+IADA
              IADA=LINT1+IADA
              I=0
       If(Debug) then
       Write(6,*)
       EndIf
              DO 70 iA=0,nExtA-1
               DO 80 iB=0,nExtB-1
                A=Work(IADA+iB)
                B=Work(IADB+iB)
       If(Debug) dVectorA(iB+1)=A
       If(Debug) dVectorB(iB+1)=B
                Work(LAIBJ+I)=A+B
                Work(LAJBI+I)=A-B
                I=I+1
80             CONTINUE
       If(Debug) then
       Write(6,'(A,I3,6F10.6)') 'A:',iA+1,(dVectorA(j),j=1,nExtB)
       Write(6,'(A,I3,6F10.6)') 'B:',iA+1,(dVectorB(j),j=1,nExtB)
       Write(6,*) ' -------'
       EndIf
               If (DoCholesky) then
                IADA=IADA + nExtB
                IADB=IADB + nExtB
               else
                IADA=IADA + nOrbB
                IADB=IADB + nOrbB
               EndIf
70            CONTINUE
              I=0
              DO 71 iA=1,nExtA
               DO 72 iB=1,nExtB
                EDIF=EPSE(NRA+iA)+EPSE(NRB+iB)-EDIFIJ
                Work(LINT1+I)=Work(LAIBJ+I)/EDIF
                Work(LINT2+I)=Work(LAJBI+I)/EDIF
                I=I+1
72             CONTINUE
71            CONTINUE
              SKAL1=DDOT_(LAB1,Work(LINT1),1,Work(LAIBJ),1)
              SKAL2=DDOT_(LAB1,Work(LINT2),1,Work(LAJBI),1)
              E2BJAI=E2BJAI-SKAL1-3.0D+00*SKAL2
              CKAL1=DDOT_(LAB1,Work(LINT1),1,Work(LINT1),1)
              CKAL2=DDOT_(LAB1,Work(LINT2),1,Work(LINT2),1)
              VECL2=VECL2+CKAL1+3.0D+00*CKAL2
60           CONTINUE
50          CONTINUE
            Call GetMem('INT1','FREE','REAL',LINT1,LAB)
            Call GetMem('INT2','FREE','REAL',LINT2,LAB)
            Call GetMem('AIBJ','FREE','REAL',LAIBJ,LAB1)
            Call GetMem('AJBI','FREE','REAL',LAJBI,LAB1)
           ENDIF

*    ---   iSymI.EQ.iSymJ   ---
           IF (iSymI.EQ.iSymJ) THEN
            LA  = nExtA
            LAB = nOrbA**2
            If (DoCholesky) LAB=nExtA**2
            LAA=(LA*(LA+1))/2
            Call GetMem('INT','ALLO','REAL',LINT,2*LAB)
            Call GetMem('AIBJ','ALLO','REAL',LAIBJ,2*LAA)
            Call GetMem('AJBI','ALLO','REAL',LAJBI,2*LAA)
            IADAB=LINT + nOcc(iSymA) * (nOrbA+1)
            If (DoCholesky) IADAB=LINT
            DO 90 iI=1,nOccI
             DO 100 iJ=1,iI
      If(Debug) then
      Write(6,*)
      Write(6,*) ' *  i,j = ',iI,iJ
      EndIf
              Call dDAFile(LUINTM,2,Work(LINT),LAB,IAD1)
      If (Debug .and. DoCholesky )
     &Call RecPrt('Int:','(8F10.6)',Work(lInt),nExtA,nExtA)
      If (Debug .and. .NOT.DoCholesky )
     &Call RecPrt('Int:','(8F10.6)',Work(lInt),nOrbA,nOrbA)
              EDIFIJ=EPSI(NRI+iI)+EPSI(NRJ+iJ)
              I=0
              IADA=IADAB
              DO 110 iA=0,nExtA-1
               IADB=IADAB
       If(Debug) then
       Write(6,*) ' iA=',iA+1,'  IADA:'
       Write(6,'(8F10.6)') (WORK(IADA+j),j=0,iA)
       EndIf
               DO 120 iB=0,iA
                A=Work(IADA+iB)
                B=Work(IADB+iA)
                Work(LAIBJ+I)=A+B
                Work(LAJBI+I)=A-B
                I=I+1
                If (DoCholesky) then
                  IADB=IADB+nExtA
                else
                  IADB=IADB+nOrbA
                EndIf
120            CONTINUE
               If (DoCholesky) then
                 IADA=IADA+nExtA
               else
                 IADA=IADA+nOrbA
               EndIf
110           CONTINUE
              I=0
              DO 130 iA=0,LA-1
               DO 140 iB=0,iA
                EDIF=EPSE(NRA+iA+1)+EPSE(NRA+iB+1)-EDIFIJ
                IF (iA.EQ.iB) EDIF=2.0D+00*EDIF
                Work(LINT+I)=Work(LAIBJ+I)/EDIF
                Work(LINT+LAA+I)=Work(LAJBI+I)/EDIF
                IF ((iA.EQ.iB).AND.(iI.NE.iJ)) THEN
                 VECL2=VECL2+2.0D+00*Work(LINT+I)**2
                ELSEIF ((iA.NE.iB).AND.(iI.EQ.iJ)) THEN
                 VECL2=VECL2+0.5D+00*Work(LINT+I)**2
                ELSE
                 VECL2=VECL2+Work(LINT+I)**2
                ENDIF
                I=I+1
140            CONTINUE
130           CONTINUE
              SKAL1=DDOT_(LAA,Work(LINT),1,Work(LAIBJ),1)
              IF (iI.NE.iJ) THEN
              SKAL2=3.0D+00*DDOT_(LAA,Work(LINT+LAA),1,Work(LAJBI),1)
              ENDIF
              IF (iI.EQ.iJ) E2BJAI=E2BJAI-0.5*SKAL1
              IF (iI.NE.iJ) E2BJAI=E2BJAI-SKAL1-SKAL2
              IF (iI.NE.iJ) THEN
               CKAL2=DDOT_(LAA,Work(LINT+LAA),1,Work(LINT+LAA),1)
               VECL2=VECL2+3.0D+00*CKAL2
              ENDIF
100          CONTINUE
90          CONTINUE
            Call GetMem('INT','FREE','REAL',LINT,LAB+LA)
            Call GetMem('AIBJ','FREE','REAL',LAIBJ,LAA)
            Call GetMem('AJBI','FREE','REAL',LAJBI,LAA)
           ENDIF
          ENDIF
41        NRB=NRB+nExtB
40       CONTINUE
         NRA=NRA+nExtA
30      CONTINUE
        NRJ=NRJ+nOccJ
20     CONTINUE
       NRI=NRI+nOccI
10    CONTINUE
      VECL2=sqrt(1.0D+00/VECL2)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DZAXPY(N,DA,DX,INCX,DY,INCY,DZ,INCZ)
! MULTIPLY A VECTOR, X, BY A SCALAR, ADD TO A VECTOR, Y, AND
! STORE THE RESULT IN THE VECTOR Z.

#include "intent.fh"

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, INCX, INCY, INCZ
real(kind=wp), intent(in) :: DA, DX(*), DY(*)
real(kind=wp), intent(_OUT_) :: DZ(*)
integer(kind=iwp) :: I, IX, IY, IZ, M, MP1

if (N <= 0) return
if ((INCX /= 1) .or. (INCY /= 1)) then

  ! CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL TO 1

  IY = 1
  IZ = 1
  if (INCY < 0) IY = (-N+1)*INCY+1
  if (INCZ < 0) IZ = (-N+1)*INCZ+1
  if (DA /= ZERO) then
    IX = 1
    if (INCX < 0) IX = (-N+1)*INCX+1
    do I=1,N
      DZ(IY) = DY(IY)+DA*DX(IX)
      IX = IX+INCX
      IY = IY+INCY
      IZ = IZ+INCZ
    end do
  else
    do I=1,N
      DZ(IY) = DY(IY)
      IY = IY+INCY
      IZ = IZ+INCZ
    end do
  end if

else

  ! CODE FOR BOTH INCREMENTS EQUAL TO 1

  ! CLEAN-UP LOOP

  M = mod(N,4)
  if (DA /= ZERO) then
    if (M /= 0) then
      do I=1,M
        DZ(I) = DY(I)+DA*DX(I)
      end do
      if (N < 4) return
    end if
    MP1 = M+1
    do I=MP1,N,4
      DZ(I) = DY(I)+DA*DX(I)
      DZ(I+1) = DY(I+1)+DA*DX(I+1)
      DZ(I+2) = DY(I+2)+DA*DX(I+2)
      DZ(I+3) = DY(I+3)+DA*DX(I+3)
    end do
  else
    if (M /= 0) then
      do I=1,M
        DZ(I) = DY(I)
      end do
      if (N < 4) return
    end if
    MP1 = M+1
    do I=MP1,N,4
      DZ(I) = DY(I)
      DZ(I+1) = DY(I+1)
      DZ(I+2) = DY(I+2)
      DZ(I+3) = DY(I+3)
    end do
  end if

end if

return

end subroutine DZAXPY

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Flip_Flop(Primitive)

use Basis_Info, only: DBSC, iCnttp_Dummy, nCnttp, Shells
use Sizes_of_Seward, only: S
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: Primitive
integer(kind=iwp) :: iAng, iCnttp, iShll, nExpi, nTest

S%MaxBas(:) = 0
S%MaxPrm(:) = 0

do iCnttp=1,nCnttp
  nTest = dbsc(iCnttp)%nVal-1
  if (DBSC(iCnttp)%Aux .and. (iCnttp == iCnttp_Dummy)) nTest = -1

  do iAng=0,S%iAngMx
    if (iAng > nTest) cycle
    iShll = dbsc(iCnttp)%iVal+iAng
    nExpi = Shells(iShll)%nExp
    if (nExpi == 0) cycle
    if (Shells(iShll)%nBasis_C == 0) cycle

    ! Decontract only the ordinary basis sets!

    call mma_deallocate(Shells(iShll)%pCff)
    if (Primitive .and. (.not. Shells(iShll)%Aux) .and. (.not. Shells(iShll)%Frag)) then
      Shells(iShll)%nBasis = nExpi
      call mma_allocate(Shells(iShll)%pCff,nExpi,Shells(iShll)%nBasis,Label='pCff')
      Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_p(:,:,1)
    else
      Shells(iShll)%nBasis = Shells(iShll)%nBasis_C
      call mma_allocate(Shells(iShll)%pCff,nExpi,Shells(iShll)%nBasis,Label='pCff')
      Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
    end if
    S%MaxPrm(iAng) = max(S%MaxPrm(iAng),nExpi)
    S%MaxBas(iAng) = max(S%MaxBas(iAng),Shells(iShll)%nBasis)

  end do ! iAng
end do   ! iCnttp

return

end subroutine Flip_Flop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_Stat()
      Implicit None
#include "cholesky.fh"
#include "choptr.fh"
#include "choglob.fh"
#include "cho_para_info.fh"
      Integer l_nDimRS_Save
      Integer iTmp, jTmp

      If (Cho_Real_Par) Then
         Call Cho_P_IndxSwp()
         l_nDimRS_Save = l_nDimRS
         Call iSwap(nSym,NumCho,1,NumCho_G,1)
         jTmp = NumChT
         NumChT = NumChT_G
         l_nDimRS = 0
         iTmp = LuRed
         LuRed = LuRed_G
         Call Cho_Stat()
         LuRed = iTmp
         l_nDimRS = l_nDimRS_Save
         NumChT = jTmp
         Call iSwap(nSym,NumCho,1,NumCho_G,1)
         Call Cho_P_IndxSwp()
      Else
         Call Cho_Stat()
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

! Strongly contracted NEVPT2 (SC-NEVPT2)
! See Angeli, C.; Cimiraglia, R.; Malrieu, J.-P. J. Chem. Phys. 2002, 117, 9138. for equations

module SC_NEVPT2

use Index_Functions, only: iTri, nTri_Elem
use caspt2_global, only: imag_shift, iPrGlb, jStLag, LUSBT, real_shift, sigma_p_epsilon
use caspt2_module, only: CASES, EREF, IfChol, JSTATE, MXCASE, NASUP, NISUP, NSTATE, NSYM
use EQSOLV, only: IDBMAT, IDSMAT, IVECC, IVECC2, IVECW
use fake_GA, only: GA_Arrays
# ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB, GA_NodeId
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
private

!! Do_FIC       :: Compute partially contracted or fully internally contracted NEVPT2 (PC- or FIC-NEVPT2) energy
!! Do_SC        :: Compute strongly contracted NEVPT2 (SC-NEVPT2) energy
!! SC_prop      :: Do property (energy and gradients) calculations using SC-NEVPT2 wavefunction
!! SC_amplitude :: Compute the T-amplitude for SC-NEVPT2 wavefunction
!! SC_thres     :: Threshold for avoiding vanishing denominators: the main purpose is to avoid numerical blow up, not for efficiency

!----- SC-NEVPT2
! ECORR_SC                         :: Correlation energy
! OVLAPS_SC                        :: Wavefunction (correction) overlap
! IDBMAT_NEVPT2(1:nSym,1:MXCASE,1) :: The original B matrix
! IDBMAT_NEVPT2(1:nSym,1:MXCASE,2) :: denominator of the amplitude

!----- QD-SC-NEVPT2
! DVALUE_SC :: temporary storage of DVALUE
! ENERGY_SC :: energy
! HEFF_SC   :: Effective Hamiltonian
! UEFF_SC   :: Eigenvector

integer(kind=iwp) :: IDBMAT_NEVPT2(8,13,2)
real(kind=wp) :: DVALUE_SC, ECORR_SC(0:8,0:MXCASE), OVLAPS_SC(0:8,0:MXCASE), SC_thres = 1.0e-9_wp
logical(kind=iwp) :: Do_FIC, Do_SC, SC_amplitude = .false., SC_prop = .false.
real(kind=wp), allocatable :: ENERGY_SC(:), HEFF_SC(:,:), UEFF_SC(:,:)

public :: Do_FIC, Do_SC, DVALUE_SC, ECORR_SC, ENERGY_SC, HEFF_SC, IDBMAT_NEVPT2, OVLAPS_SC, SC_amplitude, SC_NEVPT2_amplitude, &
          SC_NEVPT2_CLagD, SC_NEVPT2_final, SC_NEVPT2_initial, SC_NEVPT2_Print, SC_NEVPT2_res, SC_prop, SC_thres, UEFF_SC

contains

!-----------------------------------------------------------------------

subroutine SC_NEVPT2_initial()

  call mma_allocate(ENERGY_SC,nState,Label='ENERGY_SC')
  call mma_allocate(HEFF_SC,nState,nState,Label='HEFF_SC')
  call mma_allocate(UEFF_SC,nState,nState,Label='UEFF_SC')

  ENERGY_SC(:) = Zero
  HEFF_SC(:,:) = Zero
  UEFF_SC(:,:) = Zero

end subroutine SC_NEVPT2_initial

!-----------------------------------------------------------------------

subroutine SC_NEVPT2_final()

  call mma_deallocate(ENERGY_SC)
  call mma_deallocate(HEFF_SC)
  call mma_deallocate(UEFF_SC)

end subroutine SC_NEVPT2_final

!-----------------------------------------------------------------------

subroutine SC_NEVPT2_Print()

  use PrintLevel, only: TERSE, USUAL

  integer(kind=iwp) :: IC, iCase, IS, iSym, LAXITY
  real(kind=wp) :: DENORM_SC, E2CORR_SC, E2NONV_SC, E2TOT_SC, EAIVX_SC, EATVX_SC, EBJAI_SC, EBJAT_SC, EBVAT_SC, EVJAI_SC, &
                   EVJTI_SC, EVJTU_SC, REFWGT_SC, RNORM_SC
  integer(kind=iwp), external :: Cho_X_GetTol

  if (.not. Do_SC) return

  call SC_NEVPT2_Energy()

  do iCase=1,MXCASE
    ECORR_SC(0,iCase) = sum(ECORR_SC(1:nSym,iCase))
    OVLAPS_SC(0,iCase) = sum(OVLAPS_SC(1:nSym,iCase))
  end do

  do iSym=1,nSym
    ECORR_SC(iSym,0) = sum(ECORR_SC(iSym,0:MXCASE))
    OVLAPS_SC(iSym,0) = sum(OVLAPS_SC(iSym,0:MXCASE))
  end do

  ECORR_SC(0,0) = sum(ECORR_SC(1:nSym,1:MXCASE))
  OVLAPS_SC(0,0) = sum(OVLAPS_SC(1:nSym,1:MXCASE))

  EVJTU_SC = ECORR_SC(0,1)
  EVJTI_SC = ECORR_SC(0,2)+ECORR_SC(0,3)
  EATVX_SC = ECORR_SC(0,4)
  EAIVX_SC = ECORR_SC(0,5)
  EVJAI_SC = ECORR_SC(0,6)+ECORR_SC(0,7)
  EBVAT_SC = ECORR_SC(0,8)+ECORR_SC(0,9)
  EBJAT_SC = ECORR_SC(0,10)+ECORR_SC(0,11)
  EBJAI_SC = ECORR_SC(0,12)+ECORR_SC(0,13)

  E2NONV_SC = ECORR_SC(0,0)
  E2CORR_SC = E2NONV_SC !! Two*E2NONV_SC + OVLAPS_SC(0,0)
  E2TOT_SC = EREF+E2CORR_SC
  DENORM_SC = One+OVLAPS_SC(0,0)
  REFWGT_SC = One/DENORM_SC
  RNORM_SC = Zero

  if (IPRGLB > USUAL) then
    write(u6,*)
    write(u6,*) ' Correlation energy /case, /Symm, and sums (SC-NEVPT2):'
    do IC=1,13
      write(u6,'(1X,A8,9F12.8)') CASES(IC),(ECORR_SC(IS,IC),IS=1,NSYM),ECORR_SC(0,IC)
    end do
    write(u6,'(1X,A8,9F12.8)') 'Summed: ',(ECORR_SC(IS,0),IS=1,NSYM),ECORR_SC(0,0)
  end if

  if (IPRGLB >= TERSE) then
    write(u6,*)
    write(u6,*) ' FINAL SC-NEVPT2 RESULT:'
    write(u6,*)
    write(u6,'(6x,a,f18.10)') 'Reference energy:     ',EREF
    write(u6,'(6x,a,f18.10)') 'E2 (Non-variational): ',E2NONV_SC
    write(u6,'(6x,a,f18.10)') 'E2 (Variational):     ',E2CORR_SC
    write(u6,'(6x,a,f18.10)') 'Total energy:         ',E2TOT_SC
    write(u6,'(6x,a,f18.10)') 'Residual norm:        ',RNORM_SC
    write(u6,'(6x,a,f13.5)') 'Reference weight:     ',REFWGT_SC

    write(u6,*)
    write(u6,'(6x,a)') 'Contributions to the SC-NEVPT2 correlation energy'
    write(u6,'(6x,a,F18.10)') 'Active & Virtual only:    ',EATVX_SC+EBVAT_SC
    write(u6,'(6x,a,F18.10)') 'One Inactive Excited:     ',EVJTU_SC+EAIVX_SC+EBJAT_SC
    write(u6,'(6x,a,F18.10)') 'Two Inactive Excited:     ',EVJTI_SC+EVJAI_SC+EBJAI_SC
    write(u6,*)
  end if

  ENERGY_SC(JSTATE) = E2TOT_SC

  !! for verification
  LAXITY = 8
  if (IfChol) LAXITY = Cho_X_GetTol(LAXITY)
  call Add_Info('E_CASPT2',[E2TOT_SC],1,LAXITY)

end subroutine SC_NEVPT2_Print

!-----------------------------------------------------------------------

subroutine SC_NEVPT2_Energy()

  integer(kind=iwp) :: ias, iCase, idisk, IHI1, ILO1, isp, iSym, jas, JHI1, JLO1, lg_V, NAS, NIS
  real(kind=wp) :: etmp, otmp, vale, valh, valn
  logical(kind=iwp) :: do_H
  real(kind=wp), allocatable :: BMAT(:), E_value(:), LBD(:), LID(:), SMAT(:)
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: ii, jj, LDV, lg_S, MV, myRank
  real(kind=wp), allocatable :: WRK(:,:)
# endif

  ECORR_SC(:,0:11) = Zero
  OVLAPS_SC(:,0:11) = Zero

  if (.not. Do_SC) return

  ! Compute the SC-NEVPT2 energy
  ! Additionally, compute the strongly contracted zeroth-order active energy

  ! Hmm, I wish I could compute the T-amplitude in the SR basis...
  ! There is no linear dependence in SC-NEVPT2, so NIN = NAS.
  ! However, it is not easy to modify the variable later in the program.

  do_H = .false.
  if (.not. Do_FIC) do_H = .true.
  if ((real_shift /= Zero) .or. (imag_shift /= Zero) .or. (sigma_p_epsilon /= Zero)) do_H = .true.

  do iSym=1,nSym
    do iCase=1,MXCASE
      !cycle
      !if ((icase /= 12) .and. (icase /= 13)) cycle ! H
      !if ((icase /= 10) .and. (icase /= 11)) cycle ! G
      !if ((icase /= 6) .and. (icase /= 7)) cycle ! E
      !if ((icase /= 8) .and. (icase /= 9)) cycle ! F
      !if ((icase /= 2) .and. (icase /= 3)) cycle ! B
      !if (icase /= 5) cycle ! D
      !if (icase /= 4) cycle ! C
      !if (icase /= 1) cycle ! A

      NAS = NASUP(iSym,iCase)
      NIS = NISUP(iSym,iCase)
      if (NAS*NIS == 0) cycle

      if ((iCase == 12) .or. (iCase == 13)) then
        !! Compute the H subspace only when real/imaginary shift has been used
        if (do_H) then
          call RHS_ALLO(NAS,NIS,lg_V)
          call RHS_READ(NAS,NIS,lg_V,iCase,iSym,IVECW)

          call mma_allocate(LBD,NAS,Label='LBD')
          call mma_allocate(LID,NIS,Label='LID')
          idisk = IDBMAT(iSym,iCase)
          call dDaFile(LUSBT,2,LBD,NAS,idisk)
          call dDaFile(LUSBT,2,LID,NIS,idisk)

          ILO1 = 1
          IHI1 = NAS
          JLO1 = 1
          JHI1 = NIS
          etmp = Zero
          otmp = Zero
#         ifdef _MOLCAS_MPP_
          if (Is_Real_Par()) then
            myRank = GA_NodeID()
            call GA_DISTRIBUTION(lg_V,myRank,ILO1,IHI1,JLO1,JHI1)
            if ((ILO1 > 0) .and. (JLO1 > 0)) then
              call GA_Access(lg_V,ILO1,IHI1,JLO1,JHI1,MV,LDV)
              if (IHI1-ILO1+1 /= NAS) then
                write(u6,'(1x,A)') 'Something is wrong in SC_NEVPT2_Energy'
                call abend()
              end if
              do isp=JLO1,JHI1
                valn = Zero
                do ias=1,NAS
                  etmp = etmp-DBL_MB(MV+ias-1+NAS*(isp-JLO1))*DBL_MB(MV+ias-1+NAS*(isp-JLO1))/(lid(isp)+lbd(ias))
                  otmp = otmp+DBL_MB(MV+ias-1+NAS*(isp-JLO1))*DBL_MB(MV+ias-1+NAS*(isp-JLO1))/(lid(isp)+lbd(ias))**2
                end do
              end do
              call GA_RELEASE(lg_V,ILO1,IHI1,JLO1,JHI1)
            end if
          else
#         endif
            do isp=JLO1,JHI1
              do ias=ILO1,IHI1
                etmp = etmp-GA_Arrays(lg_V)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V)%A(ias+NAS*(isp-1))/(lid(isp)+lbd(ias))
                otmp = otmp+GA_Arrays(lg_V)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V)%A(ias+NAS*(isp-1))/(lid(isp)+lbd(ias))**2
              end do
            end do
#         ifdef _MOLCAS_MPP_
          end if
#         endif
          ECORR_SC(iSym,iCase) = etmp
          OVLAPS_SC(iSym,iCase) = otmp
          call mma_deallocate(LBD)
          call mma_deallocate(LID)
          call RHS_FREE(lg_V)
        end if
        cycle
      end if

      ! Read the original B matrix
      call mma_allocate(BMAT,nTri_Elem(NAS),Label='BMAT')
      idisk = IDBMAT_NEVPT2(iSym,iCase,1)
      call dDaFile(LUSBT,2,BMAT,nTri_Elem(NAS),idisk)

      ! Read the S matrix
      call mma_allocate(SMAT,nTri_Elem(NAS),Label='SMAT')
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par() .and. ((iCase == 1) .or. (iCase == 4))) then
        call mma_allocate(WRK,NAS,NAS,Label='WRK')
        call PSBMAT_GETMEM('S',lg_S,NAS)
        call PSBMAT_READ('S',iCase,iSYM,lg_S,NAS)
        call RHS_GET(NAS,NAS,lg_S,WRK)
        do ii=1,NAS
          do jj=ii,NAS
            SMAT(iTri(jj,ii)) = WRK(jj,ii)
          end do
        end do
        call PSBMAT_FREEMEM(lg_S)
        call mma_deallocate(WRK)
      else
#     endif
        idisk = IDSMAT(iSym,iCase)
        call dDaFile(LUSBT,2,SMAT,nTri_Elem(NAS),idisk)
#     ifdef _MOLCAS_MPP_
      end if
#     endif

      call RHS_ALLO(NAS,NIS,lg_V)
      call RHS_READ(NAS,NIS,lg_V,iCase,iSym,IVECW)

      call mma_allocate(LBD,NAS,Label='LBD')
      call mma_allocate(LID,NIS,Label='LID')
      idisk = IDBMAT(iSym,iCase)
      call dDaFile(LUSBT,2,LBD,NAS,idisk)
      call dDaFile(LUSBT,2,LID,NIS,idisk)

      call mma_allocate(E_value,NIS,Label='E_value')
      E_value(1:NIS) = Zero

      ILO1 = 1
      IHI1 = NAS
      JLO1 = 1
      JHI1 = NIS

      etmp = Zero
      otmp = Zero
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        myRank = GA_NodeID()
        call GA_DISTRIBUTION(lg_V,myRank,ILO1,IHI1,JLO1,JHI1)
        if ((ILO1 > 0) .and. (JLO1 > 0)) then
          call GA_Access(lg_V,ILO1,IHI1,JLO1,JHI1,MV,LDV)
          if (IHI1-ILO1+1 /= NAS) then
            write(u6,'(1x,A)') 'Something is wrong in SC_NEVPT2_Energy'
            call abend()
          end if
          do isp=JLO1,JHI1
            valh = Zero
            valn = Zero
            do ias=1,NAS
              do jas=1,ias-1 ! ias+1, NAS
                valh = valh+Two*DBL_MB(MV+ias-1+NAS*(isp-JLO1))*DBL_MB(MV+jas-1+NAS*(isp-JLO1))*BMAT(iTri(ias,jas))
                valn = valn+Two*DBL_MB(MV+ias-1+NAS*(isp-JLO1))*DBL_MB(MV+jas-1+NAS*(isp-JLO1))*SMAT(iTri(ias,jas))
              end do
              valh = valh+DBL_MB(MV+ias-1+NAS*(isp-JLO1))*DBL_MB(MV+ias-1+NAS*(isp-JLO1))*BMAT(nTri_Elem(ias))
              valn = valn+DBL_MB(MV+ias-1+NAS*(isp-JLO1))*DBL_MB(MV+ias-1+NAS*(isp-JLO1))*SMAT(nTri_Elem(ias))
            end do
            if (abs(valn) <= SC_thres) then
              vale = Zero
            else
              vale = valh/valn
            end if
            if (abs(lid(isp)+vale) > SC_thres) then
              etmp = etmp-valn/(lid(isp)+vale)
              otmp = otmp+valn/(lid(isp)+vale)**2
            end if
            E_value(isp) = vale
          end do
          call GA_RELEASE(lg_V,ILO1,IHI1,JLO1,JHI1)
        end if
        call GADGOP(E_value,NIS,'+')
      else
#     endif
        do isp=JLO1,JHI1
          valh = Zero !! <Psi|V[H,V]|Psi> (Eq. (A2), (A6), ...)
          valn = Zero !! N: norm (Eq. (11)--(18))
          do ias=ILO1,IHI1
            do jas=ias+1,IHI1
              valh = valh+Two*GA_Arrays(lg_V)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V)%A(jas+NAS*(isp-1))*BMAT(iTri(jas,ias))
              valn = valn+Two*GA_Arrays(lg_V)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V)%A(jas+NAS*(isp-1))*SMAT(iTri(jas,ias))
            end do
            valh = valh+GA_Arrays(lg_V)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V)%A(ias+NAS*(isp-1))*BMAT(nTri_Elem(ias))
            valn = valn+GA_Arrays(lg_V)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V)%A(ias+NAS*(isp-1))*SMAT(nTri_Elem(ias))
          end do
          !! compute epsilon (the equation after Eq. (28))
          if (abs(valn) <= SC_thres) then
            vale = Zero
          else
            vale = valh/valn
          end if
          if (abs(lid(isp)+vale) > SC_thres) then
            etmp = etmp-valn/(lid(isp)+vale)
            otmp = otmp+valn/(lid(isp)+vale)**2
          end if
          E_value(isp) = vale
        end do
#     ifdef _MOLCAS_MPP_
      end if
#     endif
      ECORR_SC(iSym,iCase) = etmp
      OVLAPS_SC(iSym,iCase) = otmp

      call mma_deallocate(BMAT)
      call mma_deallocate(SMAT)

      !! Save the denominator of the T-amplitude for future use
      !! LID gets the epsilon term
      LID(1:NIS) = LID(1:NIS)+E_value(1:NIS)
      idisk = IDBMAT_NEVPT2(iSym,iCase,2)
      call dDaFile(LUSBT,1,LID,NIS,idisk)

      call mma_deallocate(LBD)
      call mma_deallocate(LID)
      call mma_deallocate(E_value)

      call RHS_FREE(lg_V)
    end do
  end do

# ifdef _MOLCAS_MPP_
  !! Gather the contributions A~G (not H)
  if (is_real_par()) then
    if (do_H) then
      call GADGOP(ECORR_SC(:,0:13),9*14,'+')
      call GADGOP(OVLAPS_SC(:,0:13),9*14,'+')
    else
      call GADGOP(ECORR_SC(:,0:11),9*12,'+')
      call GADGOP(OVLAPS_SC(:,0:11),9*12,'+')
    end if
  end if
# endif

  return

end subroutine SC_NEVPT2_Energy

!-----------------------------------------------------------------------

subroutine SC_NEVPT2_Amplitude(NAS,NIS,iCase,iSym,lg_V)

  integer(kind=iwp), intent(in) :: NAS, NIS, iCase, iSym, lg_V
  integer(kind=iwp) :: ias, idisk, IHI, ILO, isp, JHI, JLO
  real(kind=wp) :: scal
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: LDV, MV, myRank
# endif
  real(kind=wp), allocatable :: LBD(:), LID(:)

  ! Compute the T-amplitude from the right hand side (lg_V = <Phi|H|Psi>)
  ! Different from CASPT2 and PC-NEVPT2, the amplitude and RHS must be in the contravariant MO basis

  if (NAS*NIS == 0) return

  call mma_allocate(LBD,NAS,Label='LBD')
  call mma_allocate(LID,NIS,Label='LID')

  idisk = IDBMAT(iSym,iCase)
  call dDaFile(LUSBT,2,LBD,NAS,idisk)
  call dDaFile(LUSBT,2,LID,NIS,idisk)

  if (iCase <= 11) then
    LBD(1:NAS) = Zero
    idisk = IDBMAT_NEVPT2(iSym,iCase,2)
    call dDaFile(LUSBT,2,LID,NIS,idisk)
  end if

  ILO = 1
  IHI = NAS
  JLO = 1
  JHI = NIS

# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    myRank = GA_NodeID()
    call GA_DISTRIBUTION(lg_V,myRank,ILO,IHI,JLO,JHI)
    if ((ILO > 0) .and. (JLO > 0)) then
      call GA_Access(lg_V,ILO,IHI,JLO,JHI,MV,LDV)
      if (iCase <= 11) then
        do isp=JLO,JHI
          if (abs(LID(isp)) <= SC_thres) then
            scal = Zero
          else
            scal = -One/LID(isp)
          end if
          do ias=ILO,IHI
            DBL_MB(MV+ias-ILO+LDV*(isp-JLO)) = DBL_MB(MV+ias-ILO+LDV*(isp-JLO))*scal
          end do
        end do
      else if ((iCase == 12) .or. (iCase == 13)) then
        do isp=JLO,JHI
          do ias=ILO,IHI
            if (abs(LBD(ias)+LID(isp)) <= SC_thres) then
              scal = Zero
            else
              scal = -One/(LBD(ias)+LID(isp))
            end if
            DBL_MB(MV+ias-ILO+LDV*(isp-JLO)) = DBL_MB(MV+ias-ILO+LDV*(isp-JLO))*scal
          end do
        end do
      end if
      call GA_Release_Update(lg_V,ILO,IHI,JLO,JHI)
    end if
  else
# endif
    if (iCase <= 11) then
      do isp=JLO,JHI
        if (abs(LID(isp)) <= SC_thres) then
          scal = Zero
        else
          scal = -One/LID(isp)
        end if
        GA_Arrays(lg_V)%A(NAS*(isp-1)+ILO:NAS*(isp-1)+IHI) = scal*GA_Arrays(lg_V)%A(NAS*(isp-1)+ILO:NAS*(isp-1)+IHI)
      end do
    else if ((iCase == 12) .or. (iCase == 13)) then
      do isp=JLO,JHI
        do ias=ILO,IHI
          if (abs(LBD(ias)+LID(isp)) <= SC_thres) then
            !! it is the MP2-like term, this should not happen...
            scal = Zero
          else
            scal = -One/(LBD(ias)+LID(isp))
          end if
          GA_Arrays(lg_V)%A(ias+NAS*(isp-1)) = scal*GA_Arrays(lg_V)%A(ias+NAS*(isp-1))
        end do
      end do
    end if
# ifdef _MOLCAS_MPP_
  end if
# endif

  call mma_deallocate(LBD)
  call mma_deallocate(LID)

end subroutine SC_NEVPT2_Amplitude

!-----------------------------------------------------------------------

subroutine SC_NEVPT2_CLagD(NASHT,NG3,NSTATE,G1,G2,G3,DG1,DG2,DG3,VECROT)

  use BDerNEV, only: BDN_G3, BDNA, BDNB, BDNC, BDND, BDNE, BDNF, BDNG

  integer(kind=iwp), intent(in) :: NASHT, NG3, NSTATE
  real(kind=wp), intent(in) :: G1(NASHT,NASHT), G2(NASHT,NASHT,NASHT,NASHT), G3(NG3), VECROT(NSTATE)
  real(kind=wp), intent(inout) :: DG1(NASHT,NASHT), DG2(NASHT,NASHT,NASHT,NASHT), DG3(NG3)
  integer(kind=iwp) :: ias, iCase, idisk, isp, iSym, jas, JHI1, JLO1, lg_V1, lg_V2, lg_V3, NAS, NIS, NVEC
  real(kind=wp) :: vale, valh, valn
  real(kind=wp), allocatable :: BDER(:,:), BMAT(:), derHNS(:,:), LID(:), SDER(:,:), SMAT(:)
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: idx_bs, idx_v1, idx_v2, idx_v3, IHI1, IHI2, IHI3, ii, ILO1, ILO2, ILO3, JHI2, JHI3, jj, JLO2, JLO3, LDV, &
                       LDV1, LDV2, lg_S, MV1, MV2, MV3, myRank
  real(kind=wp) :: tmph, tmpn

  if (Is_Real_Par()) call RHS_ZERO(iVecC2)
# endif

  do iCase=1,MXCASE
    !cycle
    !if ((icase /= 12) .and. (icase /= 13)) cycle ! H
    !if ((icase /= 10) .and. (icase /= 11)) cycle ! G
    !if ((icase /= 6) .and. (icase /= 7)) cycle ! E
    !if ((icase /= 8) .and. (icase /= 9)) cycle ! F
    !if ((icase /= 2) .and. (icase /= 3)) cycle ! B
    !if (icase /= 5) cycle ! D
    !if (icase /= 4) cycle ! C
    !if (icase /= 1) cycle ! A
    do iSym=1,nSym
      NIS = NISUP(iSym,iCase)
      NAS = NASUP(iSym,iCase)
      NVEC = NAS*NIS
      if (NVEC == 0) cycle

      if ((iCase == 12) .or. (iCase == 13)) then
        call RHS_ALLO(NAS,NIS,lg_V1)
        call RHS_READ(NAS,NIS,lg_V1,iCase,iSym,iVecC)
        call SC_NEVPT2_amplitude(NAS,NIS,iCase,iSym,lg_V1)
        call RHS_SAVE(NAS,NIS,lg_V1,iCase,iSym,iVecC2)
        call RHS_FREE(lg_V1)
        cycle
      end if

      ! Read the original B matrix
      call mma_allocate(BMAT,nTri_Elem(NAS),Label='BMAT')
      idisk = IDBMAT_NEVPT2(iSym,iCase,1)
      call DDAFILE(LUSBT,2,BMAT,nTri_Elem(NAS),idisk)

      ! Read the S matrix
      call mma_allocate(SMAT,nTri_Elem(NAS),Label='SMAT')
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par() .and. ((iCase == 1) .or. (iCase == 4))) then
        call mma_allocate(SDER,NAS,NAS,Label='SDER')
        call PSBMAT_GETMEM('S',lg_S,NAS)
        call PSBMAT_READ('S',iCase,iSYM,lg_S,NAS)
        call RHS_GET(NAS,NAS,lg_S,SDER)
        do ii=1,NAS
          do jj=1,ii
            SMAT(iTri(ii,jj)) = SDER(jj,ii)
          end do
        end do
        call PSBMAT_FREEMEM(lg_S)
        call mma_deallocate(SDER)
      else
#     endif
        idisk = IDSMAT(iSym,iCase)
        call DDAFILE(LUSBT,2,SMAT,nTri_Elem(NAS),idisk)
#     ifdef _MOLCAS_MPP_
      end if
#     endif

      !! Construct the T-amplitude in lg_V1
      call RHS_ALLO(NAS,NIS,lg_V1)
      call RHS_READ(NAS,NIS,lg_V1,iCase,iSym,iVecW)
      call SC_NEVPT2_Amplitude(NAS,NIS,iCase,iSym,lg_V1)
      !! Construct T+lambda in lg_V2 with (S+S')/2
      call RHS_ALLO(NAS,NIS,lg_V2)
      call RHS_READ(NAS,NIS,lg_V2,iCase,iSym,iVecC)
      call SC_NEVPT2_amplitude(NAS,NIS,iCase,iSym,lg_V2)

      call mma_allocate(LID,max(NAS,NIS),Label='LID')
      idisk = IDBMAT_NEVPT2(iSym,iCase,2)
      call dDaFile(LUSBT,2,LID,NIS,idisk)

      call mma_allocate(derHNS,NIS,3,Label='derHNS')
      derHNS(:,:) = Zero

#     ifdef _MOLCAS_MPP_
      ILO1 = 1
      IHI1 = NAS
#     endif
      JLO1 = 1
      JHI1 = NIS

      !! Compute derivative of H and N
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        myRank = GA_NodeID()
        call GA_DISTRIBUTION(lg_V1,myRank,ILO1,IHI1,JLO1,JHI1)
        call GA_DISTRIBUTION(lg_V2,myRank,ILO2,IHI2,JLO2,JHI2)
        if ((ILO1 > 0) .and. (JLO1 > 0) .and. (ILO2 > 0) .and. (JLO2 > 0)) then
          call GA_Access(lg_V1,ILO1,IHI1,JLO1,JHI1,MV1,LDV1)
          call GA_Access(lg_V2,ILO2,IHI2,JLO2,JHI2,MV2,LDV2)
          if ((IHI1-ILO1+1 /= NAS) .or. (ILO1 /= ILO2) .or. (IHI1 /= IHI2) .or. (JLO1 /= JLO2) .or. (JHI1 /= JHI2) .or. &
              (LDV1 /= LDV2)) then
            write(u6,'(1x,A)') 'Something is wrong in SC_NEVPT2_CLagD'
            call abend()
          end if
          do isp=JLO1,JHI1
            vale = Zero
            valh = Zero
            valn = Zero
            idx_v1 = MV1-1+NAS*(isp-JLO1)
            idx_v2 = MV2-1+NAS*(isp-JLO2)
            vale = vale+sum(DBL_MB(idx_v1+1:idx_v1+NAS)*DBL_MB(idx_v2+1:idx_v2+NAS))
            do ias=1,NAS
              idx_bs = nTri_Elem(ias-1)
              tmph = Zero
              tmpn = Zero
              if (ias >= 2) then
                tmph = sum(DBL_MB(idx_v1+1:idx_v1+ias-1)*BMAT(idx_bs+1:idx_bs+ias-1))
                tmpn = sum(DBL_MB(idx_v1+1:idx_v1+ias-1)*SMAT(idx_bs+1:idx_bs+ias-1))
              end if
              valh = valh+DBL_MB(idx_v1+ias)*(Two*tmph+DBL_MB(idx_v1+ias)*BMAT(idx_bs+ias))
              valn = valn+DBL_MB(idx_v1+ias)*(Two*tmpn+DBL_MB(idx_v1+ias)*SMAT(idx_bs+ias))
            end do
            !do ias=1,NAS
            !  vale = vale+DBL_MB(MV1+ias-1+NAS*(isp-JLO1))*DBL_MB(MV2+ias-1+NAS*(isp-JLO2))
            !  do jas=1,ias-1
            !    valh = valh+Two*DBL_MB(MV1+ias-1+NAS*(isp-JLO1))*DBL_MB(MV1+jas-1+NAS*(isp-JLO1))*BMAT(iTri(ias,jas))
            !    valn = valn+Two*DBL_MB(MV1+ias-1+NAS*(isp-JLO1))*DBL_MB(MV1+jas-1+NAS*(isp-JLO1))*SMAT(iTri(ias,jas))
            !  end do
            !  valh = valh+DBL_MB(MV1+ias-1+NAS*(isp-JLO1))*DBL_MB(MV1+ias-1+NAS*(isp-JLO1))*BMAT(nTri_Elem(ias))
            !  valn = valn+DBL_MB(MV1+ias-1+NAS*(isp-JLO1))*DBL_MB(MV1+ias-1+NAS*(isp-JLO1))*SMAT(nTri_Elem(ias))
            !end do
            if (abs(valn) <= SC_thres) then
              derHNS(isp,1) = Zero
              derHNS(isp,2) = Zero
              derHNS(isp,3) = Zero
            else
              derHNS(isp,1) = vale/valn
              derHNS(isp,2) = -vale*valh/(valn*valn)
              derHNS(isp,3) = -One*lid(isp)
            end if
          end do
          call GA_RELEASE(lg_V1,ILO1,IHI1,JLO1,JHI1)
          call GA_RELEASE(lg_V2,ILO2,IHI2,JLO2,JHI2)
        end if
        call GADGOP(derHNS,NIS*3,'+')
      else
#     endif
        do isp=1,NIS
          vale = Zero ! derivative contributions of e
          valh = Zero
          valn = Zero
          do ias=1,NAS
            vale = vale+GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V2)%A(ias+NAS*(isp-1))
            do jas=1,ias-1
              valh = valh+Two*GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V1)%A(jas+NAS*(isp-1))*BMAT(iTri(ias,jas))
              valn = valn+Two*GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V1)%A(jas+NAS*(isp-1))*SMAT(iTri(ias,jas))
            end do
            valh = valh+GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*BMAT(nTri_Elem(ias))
            valn = valn+GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*SMAT(nTri_Elem(ias))
          end do
          if (abs(valn) <= SC_thres) cycle
          ! derivative of H (through vale)
          derHNS(isp,1) = vale/valn
          ! derivative of N (through vale)
          derHNS(isp,2) = -vale*valh/(valn*valn)
          ! derivative of N: the explicit derivative (numerator)
          ! Compensate the division by lid
          derHNS(isp,3) = -One*lid(isp)
        end do
#     ifdef _MOLCAS_MPP_
      end if
#     endif

      call mma_allocate(BDER,NAS,NAS,Label='BDER')
      call mma_allocate(SDER,NAS,NAS,Label='SDER')
      BDER(:,:) = Zero
      SDER(:,:) = Zero

      !! Construct BDER and SDER
      do isp=JLO1,JHI1
        do ias=1,NAS
          do jas=1,NAS
#           ifdef _MOLCAS_MPP_
            if (is_real_par()) then
              BDER(ias,jas) = BDER(ias,jas)+derHNS(isp,1)*DBL_MB(MV1+ias-ILO1+NAS*(isp-JLO1))*DBL_MB(MV1+jas-ILO1+NAS*(isp-JLO1))
              SDER(ias,jas) = SDER(ias,jas)+derHNS(isp,2)*DBL_MB(MV1+ias-ILO1+NAS*(isp-JLO1))*DBL_MB(MV1+jas-ILO1+NAS*(isp-JLO1))
              SDER(ias,jas) = SDER(ias,jas)+ &
                              VECROT(jStLag)*derHNS(isp,3)*DBL_MB(MV1+ias-ILO1+NAS*(isp-JLO1))*DBL_MB(MV1+jas-ILO1+NAS*(isp-JLO2))
            else
#           endif
              BDER(ias,jas) = BDER(ias,jas)+derHNS(isp,1)*GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V1)%A(jas+NAS*(isp-1))
              SDER(ias,jas) = SDER(ias,jas)+derHNS(isp,2)*GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V1)%A(jas+NAS*(isp-1))
              SDER(ias,jas) = SDER(ias,jas)+ &
                              VECROT(jStLag)*derHNS(isp,3)*GA_Arrays(lg_V1)%A(ias+NAS*(isp-1))*GA_Arrays(lg_V1)%A(jas+NAS*(isp-1))
#           ifdef _MOLCAS_MPP_
            end if
#           endif
          end do
        end do
      end do

#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        call GADGOP(BDER,NAS**2,'+')
        call GADGOP(SDER,NAS**2,'+')
      end if
#     endif

      !! BDER and SDER --> DG1, DG2, DG3
      if (iCase == 1) call BDNA(iSym,NAS,NG3,BDER,SDER,G1,G2,G3,DG1,DG2,DG3)
      if ((iCase == 2) .or. (iCase == 3)) call BDNB(iSym,iCase,NAS,NG3,BDER,SDER,G1,G2,G3,DG1,DG2,DG3)
      if (iCase == 4) call BDNC(iSym,NAS,NG3,BDER,SDER,G1,G2,G3,DG1,DG2,DG3)
      if (iCase == 5) call BDND(iSym,NAS,NG3,BDER,SDER,G1,G2,G3,DG1,DG2,DG3)
      if ((iCase == 6) .or. (iCase == 7)) call BDNE(iSym,NAS,BDER,SDER,G1,G2,DG1,DG2)
      if ((iCase == 8) .or. (iCase == 9)) call BDNF(iSym,iCase,NAS,NG3,BDER,SDER,G2,G3,DG2,DG3)
      if ((iCase == 10) .or. (iCase == 11)) call BDNG(iSym,NAS,BDER,SDER,G1,G2,DG1,DG2)

      call mma_deallocate(BDER)
      call mma_deallocate(SDER)

      !! Construct integral derivatives
      call RHS_ALLO(NAS,NIS,lg_V3)
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        call RHS_READ(NAS,NIS,lg_V3,iCase,iSym,IVECC2) ! dummy read
        call GA_Sync()
        myRank = GA_NodeID()
        call GA_DISTRIBUTION(lg_V1,myRank,ILO1,IHI1,JLO1,JHI1)
        call GA_DISTRIBUTION(lg_V2,myRank,ILO2,IHI2,JLO2,JHI2)
        call GA_DISTRIBUTION(lg_V3,myRank,ILO3,IHI3,JLO3,JHI3)
        if ((ILO1 > 0) .and. (JLO1 > 0)) then
          call GA_Access(lg_V1,ILO1,IHI1,JLO1,JHI1,MV1,LDV)
          call GA_Access(lg_V2,ILO2,IHI2,JLO2,JHI2,MV2,LDV)
          call GA_Access(lg_V3,ILO3,IHI3,JLO3,JHI3,MV3,LDV)
          do isp=JLO1,JHI1
            DBL_MB(MV3+NAS*(isp-JLO1):MV3+NAS+NAS*(isp-JLO1)) = Zero
            if (abs(LID(isp)) <= SC_thres) cycle
            derHNS(isp,1) = -derHNS(isp,1)/LID(isp)
            derHNS(isp,2) = -derHNS(isp,2)/LID(isp)
            derHNS(isp,3) = One
            idx_v1 = MV1-1+NAS*(isp-JLO1)
            idx_v2 = MV2-1+NAS*(isp-JLO1)
            idx_v3 = MV3-1+NAS*(isp-JLO1)
            do ias=1,NAS
              do jas=1,ias-1
                ! <lambda|H0-E0|Psi1> terms
                DBL_MB(idx_v3+jas) = DBL_MB(idx_v3+jas)+derHNS(isp,1)*DBL_MB(idx_v1+ias)*BMAT(iTri(ias,jas))
                DBL_MB(idx_v3+jas) = DBL_MB(idx_v3+jas)+derHNS(isp,2)*DBL_MB(idx_v1+ias)*SMAT(iTri(ias,jas))
                DBL_MB(idx_v3+ias) = DBL_MB(idx_v3+ias)+derHNS(isp,1)*DBL_MB(idx_v1+jas)*BMAT(iTri(ias,jas))
                DBL_MB(idx_v3+ias) = DBL_MB(idx_v3+ias)+derHNS(isp,2)*DBL_MB(idx_v1+jas)*SMAT(iTri(ias,jas))
              end do
              DBL_MB(idx_v3+ias) = DBL_MB(idx_v3+ias)+derHNS(isp,1)*DBL_MB(idx_v1+ias)*BMAT(nTri_Elem(ias))
              DBL_MB(idx_v3+ias) = DBL_MB(idx_v3+ias)+derHNS(isp,2)*DBL_MB(idx_v1+ias)*SMAT(nTri_Elem(ias))
              ! <lambda|H|Psi0> term(s)
              DBL_MB(idx_v3+ias) = DBL_MB(idx_v3+ias)+DBL_MB(idx_v2+ias)
            end do
            !do ias=1,NAS
            !  do jas=1,NAS
            !    ! <lambda|H0-E0|Psi1> terms
            !    DBL_MB(MV3+ias-ILO1+LDV*(isp-JLO1)) = DBL_MB(MV3+ias-ILO1+LDV*(isp-JLO1))+ &
            !                                          derHNS(isp,1)*DBL_MB(MV1+jas-ILO1+LDV*(isp-JLO1))*BMAT(iTri(ias,jas))
            !    DBL_MB(MV3+ias-ILO1+LDV*(isp-JLO1)) = DBL_MB(MV3+ias-ILO1+LDV*(isp-JLO1))+ &
            !                                          derHNS(isp,2)*DBL_MB(MV1+jas-ILO1+LDV*(isp-JLO1))*SMAT(iTri(ias,jas))
            !  end do
            !  ! <lambda|H|Psi0> term(s)
            !  DBL_MB(MV3+ias-ILO1+LDV*(isp-JLO1)) = DBL_MB(MV3+ias-ILO1+LDV*(isp-JLO1))+ &
            !                                        derHNS(isp,3)*DBL_MB(MV2+ias-ILO1+LDV*(isp-JLO1))
            !end do
          end do
          call GA_Release(lg_V1,ILO1,IHI1,JLO1,JHI1)
          call GA_Release(lg_V2,ILO2,IHI2,JLO2,JHI2)
          call GA_Release_Update(lg_V3,ILO3,IHI3,JLO3,JHI3)
        end if
      else
#     endif
        GA_Arrays(lg_V3)%A(:) = Zero
        do isp=1,NIS
          if (abs(LID(isp)) <= SC_thres) cycle
          derHNS(isp,1) = -derHNS(isp,1)/LID(isp)
          derHNS(isp,2) = -derHNS(isp,2)/LID(isp)
          derHNS(isp,3) = One
          do ias=1,NAS
            do jas=1,NAS
              ! <lambda|H0-E0|Psi1> terms
              GA_Arrays(lg_V3)%A(ias+NAS*(isp-1)) = GA_Arrays(lg_V3)%A(ias+NAS*(isp-1))+ &
                                                    derHNS(isp,1)*GA_Arrays(lg_V1)%A(jas+NAS*(isp-1))*BMAT(iTri(ias,jas))
              ! <lambda|H0-E0|Psi1> terms
              GA_Arrays(lg_V3)%A(ias+NAS*(isp-1)) = GA_Arrays(lg_V3)%A(ias+NAS*(isp-1))+ &
                                                    derHNS(isp,2)*GA_Arrays(lg_V1)%A(jas+NAS*(isp-1))*SMAT(iTri(ias,jas))
            end do
            ! <lambda|H|Psi0> term(s)
            GA_Arrays(lg_V3)%A(ias+NAS*(isp-1)) = GA_Arrays(lg_V3)%A(ias+NAS*(isp-1))+ &
                                                  derHNS(isp,3)*GA_Arrays(lg_V2)%A(ias+NAS*(isp-1))
          end do
        end do
#     ifdef _MOLCAS_MPP_
      end if
#     endif
      call RHS_SAVE(NAS,NIS,lg_V3,iCase,iSym,iVecC2)

      call RHS_FREE(lg_V1)
      call RHS_FREE(lg_V2)
      call RHS_FREE(lg_V3)

      call mma_deallocate(LID)
      call mma_deallocate(BMAT)
      call mma_deallocate(SMAT)
      call mma_deallocate(derHNS)
    end do
  end do

  !! Compute correct DG3 contributions
  !! E4 contributions are evaluated elsewhere
  call BDN_G3(DG1,DG2,DG3)

end subroutine SC_NEVPT2_CLagD

!-----------------------------------------------------------------------

subroutine SC_NEVPT2_res(VECROT)

  real(kind=wp), intent(in) :: VECROT(*)
  integer(kind=iwp) :: iCase, iStLag, iSym, lg_V1, lg_V2, NAS, NIS, NVEC
  real(kind=wp) :: scal

  !! Construct the residual vector
  !! IVECC will contain (S+S')/2*T (S' = S transpose) but icase = 12 and 13 is omitted

  !! derivative of the Jth state wrt the T-amplitude of Jth state
  !! (residue) = VECROT(jStLag)*(\partial <Psi1|H|Psi0>)/(\partial T)
  !! S matrix is symmetric
  call RHS_ZERO(IVECC)
  do iSym=1,nSym
    do iCase=1,MXCASE
      NAS = NASUP(iSym,iCase)
      NIS = NISUP(iSym,iCase)
      NVEC = NAS*NIS
      if (NVEC == 0) cycle

      if ((iCase == 12) .or. (iCase == 13)) then
        call RHS_ALLO(NAS,NIS,lg_V1)
        !! Read RHS (residual of the target state)
        call RHS_READ(NAS,NIS,lg_V1,iCase,iSym,IVECW)
        !! Compute appropriate contributions
        call RHS_SCAL(NAS,NIS,lg_V1,VECROT(jStLag))
        !! Save the residual vector
        call RHS_SAVE(NAS,NIS,lg_V1,iCase,iSym,IVECC)
        call RHS_FREE(lg_V1)
      else
        call RHS_ALLO(NAS,NIS,lg_V1)
        call RHS_ALLO(NAS,NIS,lg_V2)
        !! Read RHS (residual of the target state)
        call RHS_READ(NAS,NIS,lg_V1,iCase,iSym,IVECW)
        call RHS_SCAL(NAS,NIS,lg_V2,Zero)
        !! Compute appropriate contributions
        call RHS_STRANS(NAS,NIS,VECROT(jStLag),lg_V1,lg_V2,ICASE,ISYM)
        !! Save the residual vector
        call RHS_SAVE(NAS,NIS,lg_V2,iCase,iSym,IVECC)
        call RHS_FREE(lg_V1)
        call RHS_FREE(lg_V2)
      end if
    end do
  end do

  !! derivative of the non-Jth states
  do iStLag=1,nState
    scal = VECROT(iStLag)
    if (iStLag == jStLag) cycle
    if (abs(scal) <= 1.0e-12_wp) cycle
    call MS_Res(1,iStLag,jStLag,scal)
  end do

end subroutine SC_NEVPT2_res

end module SC_NEVPT2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine ChoMP2_Energy_GetInd(LnT2am,LiT2am,iBatch,jBatch)
!
! Thomas Bondo Pedersen, Dec. 2004 / Feb. 2005.
!
! Purpose: setup (ai|bj) index arrays for batch i,j.
!          For iBatch=jBatch and ChoAlg=2, (ai|bj) is stored as
!          the matrix M(ab,ij) with i<=j.

use Cholesky, only: nSym
use ChoMP2, only: ChoAlg, LnMatij, LnT1am, nMatab
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: LnT2am, LiT2am(8)
integer(kind=iwp), intent(in) :: iBatch, jBatch
integer(kind=iwp) :: iSym
character(len=14) :: String
character(len=*), parameter :: SecNam = 'ChoMP2_Energy_GetInd'

if (iBatch == jBatch) then
  LnT2am = 0
  if (ChoAlg == 1) then
    do iSym=1,nSym
      LiT2am(iSym) = LnT2am
      LnT2am = LnT2am+LnT1am(iSym,iBatch)*(LnT1am(iSym,iBatch)+1)/2
    end do
  else if (ChoAlg == 2) then
    do iSym=1,nSym
      LiT2am(iSym) = LnT2am
      LnT2am = LnT2am+nMatab(iSym)*LnMatij(iSym,iBatch)
    end do
  else
    write(String,'(A8,I6)') 'ChoAlg =',ChoAlg
    call SysAbendMsg(SecNam,'ChoAlg out-of-bounds error!',String)
  end if
else
  LnT2am = 0
  do iSym=1,nSym
    LiT2am(iSym) = LnT2am
    LnT2am = LnT2am+LnT1am(iSym,iBatch)*LnT1am(iSym,jBatch)
  end do
end if

end subroutine ChoMP2_Energy_GetInd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 function Tkinet(l,alpha1,alpha2)
cbs   calculates the matrix element of kinetic energy
cbs   for primitive normalized functions with the same angular momentum l
cbs   and exponents alpha1 and alpha2
cbs   works only, if r**l is assumed for an l-value
cbs   formular obtained from the symmetric expression (d/dr's to (')
cbs   the left and to the right.
cbs   Overlaps of the different powers are partially crossed out
cbs   with  the overlap of functions with angular momentum l
cbs   final formula:
cbs   Tkinet=0.5*alpha12 (2l+3) (alpha1*alpha2/alpha12*alpha12)**((2L+7)/4)
cbs   with alpha12=0.5*(alpha1+alpha2)
cbs   as alpha12 has the dimensions 1/length**2, this can not be that bad...
      Implicit REAL*8 (a-h,o-z)
Cbs   alpha12 is the effective exponent
      Alpha12=0.5d0*(alpha1+alpha2)
      alphpro=alpha1*alpha2
      ll3=l+l+3
      ll7=l+l+7
      Tkinet=0.5d0*alpha12*DBLE(ll3)*(alphpro/
     *(alpha12*alpha12))**(0.25D0*DBLE(ll7))
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine NAMem(nRys,MemNA,la,lb,lr)
      use Basis_Info
      Integer iAngV(4)
*
*                                                                      *
************************************************************************
*                                                                      *
      Call mHrr(la,lb,nFlop,nMem)
*
      iAngV(1) = la
      iAngV(2) = lb
      iAngV(3) = lr
      iAngV(4) = 0
      Call MemRys(iAngV,MemNA)
      nRys=(la+lb+lr+2)/2
      If (Nuclear_Model.eq.mGaussian_Type) Then
*
         labcd = (la+1)*(la+2)/2 * (lb+1)*(lb+2)/2
*
         iAngV(3)=lr+2
         Call MemRys(iAngV,MemNA2)
         MemNA=Max(MemNA,MemNA2)
         nRys=(la+lb+lr+4)/2
         MemNA=MemNA+labcd
      End If
*
      MemNA = Max(nMem,MemNA)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine GetChVHlp3 (L2,Tmp,cGrp,deGrp,LunAux)
c
c       this routine do:
c       read L2(m,c'de') into L2 from disk file
c       structure of files: for each c',de' one file with
c       name L2Name(cGrp,deGrp)
c       @ citanie zatial odflaknute
c
c       parameter description:
c       L2     - Array for L2 (O)
c       Tmp    - Temporary array of L2 size, used for mapping, if needed
c       xGrp   - Groups of c, delta (I)
c       LunAux - lun for auxiliary reading (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
c
        real*8 L2(1)
        real*8 Tmp(1)
        integer cGrp,deGrp,LunAux
        character*6 LunName
c
c       help variables
        integer length
c
c        nacitanie (+expanzia, ak treba)
        if (cGrp.gt.deGrp) then
          LunName=L2Name(cGrp,deGrp)
          length=nc*DimGrpa(cGrp)*DimGrpbe(deGrp)
          call GetX (L2(1),length,LunAux,LunName,1,1)
        else if (cGrp.eq.deGrp) then
          LunName=L2Name(cGrp,deGrp)
          length=nc*DimGrpa(cGrp)*(DimGrpbe(deGrp)+1)/2
          call GetX (Tmp(1),length,LunAux,LunName,1,1)
          length=DimGrpa(cGrp)*(DimGrpbe(deGrp)+1)/2
          call Exp1 (Tmp(1),L2(1),nc,length,DimGrpa(cGrp))
        else
          LunName=L2Name(deGrp,cGrp)
          length=nc*DimGrpa(cGrp)*DimGrpbe(deGrp)
          call GetX (Tmp(1),length,LunAux,LunName,1,1)
          call Map3_132 (Tmp(1),L2(1),nc,DimGrpbe(deGrp),DimGrpa(cGrp))
        end if
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Read_Multipole_Int(lMax,sq_mu,nBas,imu,Ttot,Temp,Origin,rMPq,nElem,nBas1,nBas2,nBasMax,nTemp,nSym,P,Restart,Utility)

use Symmetry_Info, only: Mul
use Data_Structures, only: Alloc1DArray_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: lMax, nSym, nBas(0:nSym-1), nElem, nBas1, nBas2, nBasMax, nTemp
real(kind=wp), intent(out) :: sq_mu(nBas1**2,0:nElem-1), Temp(nTemp), Origin(3,0:lMax), rMPq(0:nElem-1)
type(Alloc1DArray_Type), intent(out) :: imu(0:nElem-1)
real(kind=wp), intent(in) :: Ttot(nBas2), P(*)
logical(kind=iwp), intent(in) :: Restart, Utility
integer(kind=iwp) :: iComp, idum(1), ijSym, iOff, iOffs, iOfft, iOpt0, iOpt1, iRc, iSyLbl, iSym, jSym, l, mu, nComp, nInts, &
                     nInts_Tot, nScr
character(len=8) :: Label
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: Comp(:), SyLbl(:)
real(kind=wp), allocatable :: all_ints(:), Scr(:), Tmp(:)
character(len=16), parameter :: RunFile_dLabel = 'LoProp Integrals', &
                                RunFile_iLabel = 'LoProp nInts', &
                                RunFile_iLabel2 = 'LoProp iSyLbl'

!                                                                      *
!***********************************************************************
!                                                                      *
! Note that we will store two sets of the integrals.
!
! Set 1: used to compute the localized properties.
! Set 2: used in the finite difference calculation of the polarizability.
!
! Set 1 will be desymmetrized in case of symmetry.
!
! Pointers to Set 1 are stored in sq_mu.
! Pointers to Set 2 are stored in imu.

nInts_Tot = 0
call mma_allocate(Comp,[0,nElem],label='nComp')
call mma_allocate(SyLbl,[0,nElem],label='SyLbl')
if (Restart) then
  call Qpg_dArray(RunFile_dLabel,Found,nInts_tot)
  if (.not. Found) then
    write(u6,*) 'LoProp Integrals not available on the RunFile.'
    call Abend()
  end if
  call mma_allocate(all_ints,nInts_Tot,label='all_ints')
  call Get_dArray(RunFile_dLabel,all_ints,nInts_tot)
  call Get_iArray(RunFile_iLabel,Comp,nElem)
  call Get_iArray(RunFile_iLabel2,SyLbl,nElem)
end if
nInts = 0
iOpt0 = 0
iOpt1 = 1
Label = 'Mltpl  X'
mu = -1
iOff = 1
do l=0,lMax
  nComp = (l+1)*(l+2)/2
  write(Label(8:8),'(I1)') l
  do iComp=1,nComp
#   ifdef _DEBUGPRINT_
    write(u6,*) 'l,iComp=',l,iComp
#   endif
    mu = mu+1
    if (Restart) then
      call mma_allocate(imu(mu)%A,Comp(mu),label='imu')
      nInts = Comp(mu)-4
      call dCopy_(Comp(mu),all_ints(iOff),1,imu(mu)%A,1)
      iSyLbl = SyLbl(mu)
      iOff = iOff+Comp(mu)
    else
      iRc = -1
      iSyLbl = 0
      call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
      if (iRc /= 0) then
        write(u6,*) 'Polar: error reading length of mu!'
        write(u6,*) 'Mu=',mu
        call Abend()
      end if
      nInts = idum(1)
      call mma_allocate(imu(mu)%A,nInts+4,label='imu')
      call RdOne(iRc,iOpt0,Label,iComp,imu(mu)%A,iSyLbl)
      if (iRc /= 0) then
        write(u6,*) 'Polar: error reading mu!'
        write(u6,*) 'Mu=',mu
        call Abend()
      end if
      SyLbl(mu) = iSyLbl
      Comp(mu) = nInts+4
      nInts_Tot = nInts_Tot+Comp(mu)
    end if

    ! Transform multipole moment integrals to new basis

    sq_mu(:,mu) = Zero
    if (nSym /= 1) then
      call mma_allocate(Tmp,nBas2,label='Tmp')
      Tmp(:) = Zero
    end if

    ! Now I square the dipole moment integral matrix because it
    ! has been stored as a low triangle

    iOfft = 1
    iOffs = 1
    do iSym=0,nSym-1
      do jSym=0,iSym
        ijSym = Mul(iSym+1,jSym+1)-1
        if (.not. btest(iSyLbl,ijSym)) cycle
        if (nBas(iSym)*nBas(jSym) == 0) cycle
        if (iSym == jSym) then

          ! Now I square the overlap matrix because it has been
          ! stored as a lower triangle

          if (nSym == 1) then
            call Square(imu(mu)%A(iOfft),sq_mu(iOffs,mu),1,nBas(iSym),nBas(iSym))
          else
            call Square(imu(mu)%A(iOfft),Tmp(iOffs),1,nBas(iSym),nBas(iSym))
          end if

          iOfft = iOfft+nBas(iSym)*(nBas(iSym)+1)/2
        else
          if (nSym == 1) then
            call dcopy_(nBas(iSym)*nBas(jSym),imu(mu)%A(iOfft),1,sq_mu(iOffs,mu),1)
          else
            call dcopy_(nBas(iSym)*nBas(jSym),imu(mu)%A(iOfft),1,Tmp(iOffs),1)
          end if
          iOfft = iOfft+nBas(iSym)*nBas(jSym)
        end if
        iOffs = iOffs+nBas(iSym)*nBas(jSym)
      end do
    end do

    if (nSym /= 1) then

      ! Desymmetrize

      nScr = nBasMax*nBas1
      call mma_allocate(Scr,nScr,label='Scr')
      sq_mu(:,mu) = Zero
      call Desymmetrize(Tmp,nBas2,Scr,nScr,sq_mu(:,mu),nBas,nBas1,P,nSym,iSyLbl)
      call mma_deallocate(Scr)
      call mma_deallocate(Tmp)

    end if

    ! Now I transform with my Transformation Matrix Ttot the
    ! multipole moment integral matrices

#   ifdef _DEBUGPRINT_
    call RecPrt('Multipole Integrals in AO Basis',' ',sq_mu(:,mu),nBas1,nBas1)
#   endif
    call TransMu(sq_mu(:,mu),nBas1,Ttot,Temp)
#   ifdef _DEBUGPRINT_
    call RecPrt('Multipole Integrals in LoProp Basis',' ',sq_mu(:,mu),nBas1,nBas1)
#   endif

    ! Pick up the nuclear value for this operator

    rMPq(mu) = imu(mu)%A(nInts+4)
  end do

  ! Pick up the origin of this operator

  Origin(:,l) = imu(mu)%A(nInts+1:nInts+3)

end do
if ((.not. Restart) .and. (.not. Utility)) then
  call mma_allocate(all_ints,nInts_Tot,label='all_ints')
  mu = -1
  iOff = 1
  do l=0,lMax
    nComp = (l+1)*(l+2)/2
    do iComp=1,nComp
      mu = mu+1
      call dCopy_(Comp(mu),imu(mu)%A,1,all_ints(iOff),1)
      iOff = iOff+Comp(mu)
    end do
  end do
  call Put_dArray(RunFile_dLabel,all_ints,nInts_Tot)
  call Put_iArray(RunFile_iLabel,Comp,nElem)
  call Put_iArray(RunFile_iLabel2,SyLbl,nElem)
end if
if (.not. Utility) then
  call mma_deallocate(all_ints)
end if
call mma_deallocate(Comp)
call mma_deallocate(SyLbl)
#ifdef _DEBUGPRINT_
call RecPrt('Origin',' ',Origin,3,lMax+1)
call RecPrt('rMPq',' ',rMPq,1,nElem)
call xSpot('Exit  Read_Multipole_Int')
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Read_Multipole_Int

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine OneEl_Property(Kernel,KrnlMm,Label,ip,lOper,nComp,CCoor,nOrdOp,rNuc,rHrmt,iChO,D_tot,nDens,Property,Sig)

use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Integral_Interfaces, only: int_kernel, int_mem, OneEl_Integrals
use stdalloc, only: mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
procedure(int_kernel) :: Kernel
procedure(int_mem) :: KrnlMm
character(len=8), intent(in) :: Label
integer(kind=iwp), intent(in) :: nComp, lOper(nComp), nOrdOp, iChO(nComp), nDens
integer(kind=iwp), intent(out) :: ip(nComp)
real(kind=wp), intent(in) :: CCoor(3,nComp), rNuc(nComp), rHrmt, D_tot(nDens), Sig
real(kind=wp), intent(out) :: Property(nComp)
integer(kind=iwp) :: iComp, iSmLbl, LenTot, n_Int
real(kind=wp), allocatable :: Integrals(:)
integer(kind=iwp), external :: n2Tri
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
if (rHrmt /= One) then
  call WarningMessage(2,'OneEl_Property: rHrmt /= One')
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the one-electron integrals

call OneEl_Integrals(Kernel,KrnlMm,Label,ip,lOper,nComp,CCoor,nOrdOp,rHrmt,iChO,Integrals)
!                                                                      *
!***********************************************************************
!                                                                      *
!                    P O S T P R O C E S S I N G                       *
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call PrMtrx(Label,lOper,nComp,ip,Integrals)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute properties

LenTot = 0
do iComp=1,nComp
  iSmLbl = lOper(iComp)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute properties directly from integrals

  n_Int = n2Tri(iSmLbl)
  LenTot = LenTot+n_Int+4
  if (n_Int /= 0) then
    call CmpInt(Integrals(ip(iComp)),n_Int,nBas,nIrrep,iSmLbl)
    if (n_Int /= nDens) then
      call WarningMessage(2,'OneEl_Property: n_Int /= nDens')
      write(u6,*) 'n_Int=',n_Int
      write(u6,*) 'nDens',nDens
      call Abend()
    end if
    Property(iComp) = rNuc(iComp)-Sig*DDot_(nDens,D_Tot,1,Integrals(ip(iComp)),1)
  else
    Property(iComp) = rNuc(iComp)
  end if

end do  ! iComp
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate memory for integral

call mma_deallocate(Integrals)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine OneEl_Property

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Felipe Zapata                                    *
************************************************************************

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C The Nose-Hoover chain of thermostat is based on the following paper
C Journal of Physical Chemistry B, 2001, 105, 7598
C The implemetation required first initialized the thermostat, then
C before calling the first part of velocity verlet the NHC is call,
C then the positions and velocities are updated using the verlet_first
C and after that the verlet_second is called and after this step
C the NHC subroutine is call. The order must not be changed
C
C Felipe Zapata, November 1, 2012
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
      SUBROUTINE NhcThermo (vel)
      IMPLICIT REAL*8 (a-h,o-z)
#include "prgm.fh"
#include "Molcas.fh"
      PARAMETER    (ROUTINE='NhcThermo')
#include "warnings.fh"
#include "MD.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "dyn.fh"
#include "constants2.fh"
      PARAMETER  (nh=6)
      INTEGER     natom,natom3,i,j
      REAL*8      Ekin,kb
      PARAMETER   (kb = CONST_BOLTZMANN_/
     &             (CONV_AU_TO_KJ_*1.0D3))
      REAL*8      NHC(nh), vel(*)
      REAL*8, ALLOCATABLE ::      Mass(:)

*nh stands for the number of variables in the thermostat
* NHC = Q1,Q2,X1,X2,VX1,VX2,Scale
*
C
C    The parameter kb is the Boltzmann constant in E_h/K

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8

CC READ PARAMETERS FROM RUNFILE

      CALL Get_nAtoms_Full(natom)

      CALL mma_allocate(Mass,natom)

      natom3=3*natom

C     Read Thermostat Variables
      CALL Get_NHC(NHC,nh)

      Q1 = NHC(1)
      Q2 = NHC(2)
      X1 = NHC(3)
      X2 = NHC(4)
      Vx1 = NHC(5)
      Vx2 = NHC(6)

C     Initialize the Mass variable
      CALL GetMassDx(Mass,natom)

      Ekin = 0.0D0


      DO i=1, natom
        DO j=1, 3
          Ekin = Ekin + 5.0D-01 * Mass(i) * (vel(3*(i-1)+j) ** 2.D0)
        END DO
      END DO



C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8

      DT2   = DT * 0.5D0
      DT4   = DT * 2.5D-1
      DT8   = DT * 1.25D-1

      G2 = (Q1*Vx1*Vx1 - TEMP*kb )/Q2
      Vx2 = Vx2 + G2*DT4
      Vx1 = Vx1 * exp(-Vx2*DT8)
      G1 = (2.D0*Ekin - 3.D0*dble(natom)*TEMP*kb)/Q1
      Vx1 = Vx1 + G1*DT4
      Vx1 = Vx1 *exp(-Vx2*DT8)
      sc  = exp(-Vx1*DT2)

      DO i=1, natom
          DO j=1, 3
             vel(3*(i-1)+j) = vel(3*(i-1)+j)*sc
          END DO
      END DO

      Ekin = Ekin*sc*sc

      X1 = X1 + Vx1*DT2
      X2 = X2 + Vx2*DT2
      Vx1 = Vx1 * exp(-Vx2*DT8)
      G1 = (2.D0*Ekin - 3.D0*dble(natom)*TEMP*kb)/Q1
      Vx1  = Vx1 + G1*DT4
      Vx1 = Vx1*exp(-Vx2*DT8)
      G2 = (Q1*(Vx1**2.D0)- TEMP*kb )/Q2
      Vx2 = Vx2 + G2*DT4

      NHC(3) = X1
      NHC(4) = X2
      NHC(5) = Vx1
      NHC(6) = Vx2

      CALL Put_NHC(NHC,nh)
#ifdef _HDF5_
      call mh5_put_dset(dyn_nh,NHC)
#endif

      CALL mma_deallocate(Mass)

      RETURN

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Ignacio Fdez. Galvan                             *
************************************************************************
      SUBROUTINE ZTRNSF_MASKED(N,UR,UI,AR,AI,IJ,IST,INUM,JST,JNUM)
      IMPLICIT NONE
      INTEGER :: N,INUM,JNUM
      REAL*8 :: UR(N,N),UI(N,N)
      REAL*8 :: AR(N,N),AI(N,N)
      INTEGER :: IJ(4),IST(INUM),JST(JNUM)
#include "real.fh"
#include "stdalloc.fh"
      REAL*8, ALLOCATABLE, DIMENSION(:,:) :: MR,MI,VR,VI,TR,TI
      INTEGER :: I,J,II,JJ,NI,NJ

      NI=IJ(2)-IJ(1)+1
      NJ=IJ(4)-IJ(3)+1

      CALL mma_allocate(MR,INUM,JNUM,LABEL='MR')
      CALL mma_allocate(MI,INUM,JNUM,LABEL='MI')
      DO J=1,JNUM
        DO I=1,INUM
          MR(I,J)=AR(IST(I),JST(J))
          MI(I,J)=AI(IST(I),JST(J))
        END DO
      END DO

      CALL mma_allocate(VR,JNUM,NJ,LABEL='VR')
      CALL mma_allocate(VI,JNUM,NJ,LABEL='VI')
      DO J=1,NJ
        JJ=IJ(3)+J-1
        DO I=1,JNUM
          VR(I,J)=UR(JST(I),JJ)
          VI(I,J)=UI(JST(I),JJ)
        END DO
      END DO

      CALL mma_allocate(TR,INUM,NJ,LABEL='TR')
      CALL mma_allocate(TI,INUM,NJ,LABEL='TI')
      CALL DGEMM_('N','N',INUM,NJ,JNUM, One,MR,INUM,VR,JNUM,
     &                                 Zero,TR,INUM)
      CALL DGEMM_('N','N',INUM,NJ,JNUM,-One,MI,INUM,VI,JNUM,
     &                                  One,TR,INUM)
      CALL DGEMM_('N','N',INUM,NJ,JNUM, One,MR,INUM,VI,JNUM,
     &                                 Zero,TI,INUM)
      CALL DGEMM_('N','N',INUM,NJ,JNUM, One,MI,INUM,VR,JNUM,
     &                                  One,TI,INUM)

      CALL mma_deallocate(VR)
      CALL mma_deallocate(VI)
      CALL mma_allocate(VR,INUM,NI,LABEL='VR')
      CALL mma_allocate(VI,INUM,NI,LABEL='VI')
      DO J=1,NI
        JJ=IJ(1)+J-1
        DO I=1,INUM
          VR(I,J)=UR(IST(I),JJ)
          VI(I,J)=UI(IST(I),JJ)
        END DO
      END DO

      CALL mma_deallocate(MR)
      CALL mma_deallocate(MI)
      CALL mma_allocate(MR,NI,NJ,LABEL='MR')
      CALL mma_allocate(MI,NI,NJ,LABEL='MI')
      CALL DGEMM_('T','N',NI,NJ,INUM, One,VR,INUM,TR,INUM,Zero,MR,NI)
      CALL DGEMM_('T','N',NI,NJ,INUM, One,VI,INUM,TI,INUM, One,MR,NI)
      CALL DGEMM_('T','N',NI,NJ,INUM, One,VR,INUM,TI,INUM,Zero,MI,NI)
      CALL DGEMM_('T','N',NI,NJ,INUM,-One,VI,INUM,TR,INUM, One,MI,NI)

      CALL DCOPY_(N*N,[Zero],0,AR,1)
      CALL DCOPY_(N*N,[Zero],0,AI,1)
      DO J=1,NJ
        JJ=IJ(3)+J-1
        DO I=1,NI
          II=IJ(1)+I-1
          AR(II,JJ)=MR(I,J)
          AI(II,JJ)=MI(I,J)
        END DO
      END DO

      CALL mma_deallocate(TR)
      CALL mma_deallocate(TI)
      CALL mma_deallocate(VR)
      CALL mma_deallocate(VI)
      CALL mma_deallocate(MR)
      CALL mma_deallocate(MI)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine AdToR2_MCLR(RHO2,RHO2T,ITYPE,NI,IOFF,NJ,JOFF,NK,KOFF,NL,LOFF,NORB)
! Add contributions to two electron density matrix RHO2
! output density matrix is in the form Rho2(ij,kl),(ij) >= (kl)
!
! Jeppe Olsen, Fall of 96
!
! Itype = 1 => alpha-alpha or beta-beta loop
!              input is in form Rho2t(ik,jl)
! Itype = 2 => alpha-beta loop
!              input is in form Rho2t(ij,kl)

use Index_Functions, only: iTri, nTri_Elem
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(inout) :: RHO2(*)
real(kind=wp), intent(in) :: RHO2T(*)
integer(kind=iwp), intent(in) :: ITYPE, NI, IOFF, NJ, JOFF, NK, KOFF, NL, LOFF, NORB
integer(kind=iwp) :: I, IACTIVE, II, IIOFF, IJ, IJKL, IJKLT, IKIND, IKJLT, IPERM, J, JJ, JJOFF, JLIND, K, KK, KKOFF, KL, L, LL, &
                     LLOFF, NII, NIK, NJJ, NKK, NLL
real(kind=wp) :: FACTOR, SGN, SIGNIK, SIGNJL

! dummy initialize
I = 0
J = 0
K = 0
L = 0
NII = 0
NJJ = 0
NKK = 0
NLL = 0
IIOFF = 0
JJOFF = 0
KKOFF = 0
LLOFF = 0
SGN = Zero
IACTIVE = 0

#ifdef _DEBUGPRINT_
write(u6,*) ' Welcome to ADTOR2'
write(u6,*) ' ================='
write(u6,*) ' NI NJ NK NL = ',NI,NJ,NK,NL
write(u6,*) ' IOFF JOFF KOFF LOFF =',IOFF,JOFF,KOFF,LOFF
write(u6,*) ' ITYPE = ',ITYPE
write(u6,*) ' Initial two body density matrix'
call PRSYM(RHO2,NORB**2)
!write(u6,*) ' RHO2T :'
!if (ITYPE == 1) then
!  if (IOFF == KOFF) then
!    NROW = nTri_Elem(NI)
!  else
!    NROW = NI*NK
!  end if
!  if (JOFF == LOFF) then
!    NCOL = nTri_Elem(NJ)
!  else
!    NCOL = NJ*NL
!  end if
!else if (ITYPE == 2) then
!  NROW = NI*NJ
!  NCOL = NK*NL
!end if
!call WRTMAT(RHO2T,NROW,NCOL,NROW,NCOL)
#endif

if (ITYPE == 1) then

  ! =======================================
  !     Alpha-alpha or beta-beta term
  ! =======================================

  ! Four permutations
  do IPERM=1,4
    if (IPERM == 1) then
      NII = NI
      IIOFF = IOFF
      NJJ = NJ
      JJOFF = JOFF
      NKK = NK
      KKOFF = KOFF
      NLL = NL
      LLOFF = LOFF
      SGN = One
      IACTIVE = 1
    else if (IPERM == 2) then
      if (IOFF /= KOFF) then
        NII = NK
        IIOFF = KOFF
        NKK = NI
        KKOFF = IOFF
        NJJ = NJ
        JJOFF = JOFF
        NLL = NL
        LLOFF = LOFF
        IACTIVE = 1
      else
        IACTIVE = 0
      end if
      SGN = -One
    else if (IPERM == 3) then
      if (JOFF /= LOFF) then
        NII = NI
        IIOFF = IOFF
        NKK = NK
        KKOFF = KOFF
        NJJ = NL
        JJOFF = LOFF
        NLL = NJ
        LLOFF = JOFF
        SGN = -One
        IACTIVE = 1
      else
        IACTIVE = 0
      end if
    else if (IPERM == 4) then
      if ((IOFF /= KOFF) .and. (JOFF /= LOFF)) then
        NKK = NI
        KKOFF = IOFF
        NII = NK
        IIOFF = KOFF
        NJJ = NL
        JJOFF = LOFF
        NLL = NJ
        LLOFF = JOFF
        SGN = One
        IACTIVE = 1
      else
        IACTIVE = 0
      end if
    end if

    !IJOFF = (JJOFF-1)*NORB+IIOFF
    !KLOFF = (LLOFF-1)*NORB+KKOFF
    !if ((IACTIVE == 1) .and. (IJOFF >= KLOFF)) then
    if (IACTIVE == 1) then
      do II=1,NII
        do JJ=1,NJJ
          do KK=1,NKK
            do LL=1,NLL
              IJ = (JJ+JJOFF-2)*NORB+II+IIOFF-1
              KL = (LL+LLOFF-2)*NORB+KK+KKOFF-1
              if (IJ >= KL) then
                IJKL = nTri_Elem(IJ-1)+KL
                if (IPERM == 1) then
                  I = II
                  K = KK
                  J = JJ
                  L = LL
                else if (IPERM == 2) then
                  I = KK
                  K = II
                  J = JJ
                  L = LL
                else if (IPERM == 3) then
                  I = II
                  K = KK
                  J = LL
                  L = JJ
                else if (IPERM == 4) then
                  I = KK
                  K = II
                  J = LL
                  L = JJ
                end if
                if (IOFF /= KOFF) then
                  IKIND = (K-1)*NI+I
                  NIK = NI*NK
                  SIGNIK = One
                else
                  IKIND = iTri(I,K)
                  NIK = nTri_Elem(NI)
                  if (I >= K) then
                    SIGNIK = One
                  else
                    SIGNIK = -One
                  end if
                end if
                if (JOFF /= LOFF) then
                  JLIND = (L-1)*NJ+J
                  SIGNJL = One
                else
                  JLIND = iTri(J,L)
                  if (J >= L) then
                    SIGNJL = One
                  else
                    SIGNJL = -One
                  end if
                end if
                IKJLT = (JLIND-1)*NIK+IKIND
                RHO2(IJKL) = RHO2(IJKL)-SGN*SIGNJL*SIGNIK*RHO2T(IKJLT)
                ! The minus: Rho2t comes as <a+i a+k aj al>, but we want
                ! <a+ia+k al aj>
              end if
            end do
          end do
        end do
      end do
      ! End of active/inactive if
    end if
    ! End of loop over permutations
  end do
else if (ITYPE == 2) then

  ! =======================================
  !     Alpha-alpha or beta-beta term
  ! =======================================

  do I=1,NI
    do J=1,NJ
      do K=1,NK
        do L=1,NL
          IJ = (J+JOFF-2)*NORB+I+IOFF-1
          KL = (L+LOFF-2)*NORB+K+KOFF-1
          if (IJ == KL) then
            FACTOR = Two
          else
            FACTOR = One
          end if
          IJKL = iTri(IJ,KL)
          IJKLT = (L-1)*NJ*NK*NI+(K-1)*NJ*NI+(J-1)*NI+I
          RHO2(IJKL) = RHO2(IJKL)+FACTOR*RHO2T(IJKLT)
        end do
      end do
    end do
  end do

else if (itype == 3) then
  do I=1,NI
    do J=1,NJ
      do K=1,NK
        do L=1,NL
          IJ = (J+JOFF-2)*NORB+I+IOFF-1
          KL = (L+LOFF-2)*NORB+K+KOFF-1
          !IJKL = iTri(IJ,KL)
          IJKL = (IJ-1)*NORB**2+KL
          IJKLT = (L-1)*NJ*NK*NI+(K-1)*NJ*NI+(J-1)*NI+I
          RHO2(IJKL) = RHO2(IJKL)+RHO2T(IJKLT)
        end do
      end do
    end do
  end do

end if

!i = 1
!j = 4
!k = 5
!l = 6
!iA1 = iTri((i-1)*nOrb+j,(k-1)*nOrb+l)
!iA2 = iTri((j-1)*nOrb+i,(k-1)*nOrb+l)
!iA3 = iTri((i-1)*nOrb+j,(l-1)*nOrb+k)
!iA4 = iTri((j-1)*nOrb+i,(l-1)*nOrb+k)
!rfel = RHO2(ia1)+RHO2(ia2)+RHO2(ia3)+RHO2(ia4)
!if (rfel /= Zero) write(u6,*) 'STOP'
!#ifdef _DEBUGPRINT_
!write(u6,*) ' Updated two-body density matrix'
!call PRSYM(RHO2,NORB**2)
!#endif

return

end subroutine AdToR2_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine NAMem_GIAO(nRys,MemNA_GIAO,la,lb,lr)
*
      Integer iAngV(4)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      lc = lr
      ld = 0
      nRys = (la+lb+lc+ld+2)/2
*
      labMin=nabSz(Max(la,lb)-1)+1
      labMax=nabSz(la+lb)
      lab = (labMax-labMin+1)
      kab = nElem(la)*nElem(lb)
*
      lcdMin_EF=nabSz(lr-1)+1
      lcdMax_EF=nabSz(lr)
      lcd_EF = (lcdMax_EF-lcdMin_EF+1)
      labcd_EF = lab*lcd_EF
      Mem0=labcd_EF
*
      lcdMin_NA=nabSz(lr-2)+1
      lcdMax_NA=nabSz(lr-1)
      lcd_NA = (lcdMax_NA-lcdMin_NA+1)
      labcd_NA = lab*lcd_NA
*
      Call mHRR(la,lb,nFlop,nMem)
      Mem1=Max(lcd_EF,lcd_NA)*nMem
*
      iAngV(1) = la
      iAngV(2) = lb
      iAngV(3) = lc
      iAngV(4) = ld
      Call MemRys(iAngV,Mem2_EF)
      iAngV(3) = 0
      Call MemRys(iAngV,Mem2_NA)
      Mem2 = Max(Mem2_EF,Mem2_NA,kab*Max(lcd_EF,lcd_NA))
*
      MemNA_GIAO = Mem0 + Mem1 + Mem2
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Giovanni Ghigo                                   *
!               2005, Francesco Aquilante                              *
!***********************************************************************

!***********************************************************************
! This Driver precedes the standard (TraCtl) and Cholesky (Cho_TraCtl) *
! AO/MO two-electrons transformation programs.                         *
! -------------------------------------------------------------------- *
! Author :  Giovanni Ghigo                                             *
!           Lund University, Sweden                                    *
! Written:  August-September 2004                                      *
! Modified for Cholesky-MP2 May 2005                                   *
!***********************************************************************
!  TraCtl_Drv
!
!> @brief
!>   Driver that calls the Cholesky or the Conventional routine for the
!>   generation of the two-electrons integrals file in MO basis.
!> @author Giovanni Ghigo
!> @modified_by F. Aquilante
!>
!> @details
!> All programs that need the generation of the two-electrons
!> integrals file in MO basis must tell to the Cholesky routine
!> who they are through \p iType:
!>
!> - ``1``: MBPT2
!> - ``2``: CASPT2
!> - ``3``: MCLR
!> - ``4``: CC
!>
!> Programs must also tell to the Cholesky routine whether they need
!> exchange-2 integrals through logical variable \p DoExch2. Both
!> values are not used by the Conventional routine.
!>
!> @param[in] iType   Caller program
!> @param[in] DoExch2 Flag for the generation of Exch-2 integrals
!> @param[in] iPart   Partitioning of temp files
!***********************************************************************
subroutine TraCtl_Drv(iType,DoExch2,iPart)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iType, iPart
logical(kind=iwp), intent(in) :: DoExch2
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
logical(kind=iwp) :: DoCholesky
character(len=*), parameter :: SECNAM = 'TraCtl_Drv'

call DecideOnCholesky(DoCholesky)

if (DoCholesky) then

  if (iType == 1) then

    call ChoMP2_TraCtl(LUINTM,Work(LCMO),NCMO)

  ! caspt2 with cholesky does no longer use call to tractl_drv/cho_caspt2_drv
  !else if (iALGO == 0) then
  else

    call Cho_TraCtl(iType,LUINTM,Work(LCMO),NCMO,DoExch2)

  !else if (iALGO == 1) then
  !
  !  call Cho_caspt2_drv(Work(LCMO))
  !
  !else
  !
  !  call Cho_x_Quit(SecNam,' !!! Unknown algorithm !!! ',' ')

  end if

else

  call TRACTL(iPart)

end if

return

end subroutine TraCtl_Drv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SUBTR(XINT,WRK,LWRK,ISYM)
C
C     Purpose: driver for subtracting contributions from previous vectors
C              from the qualified integrals (in XINT).
C
#include "implicit.fh"
      DIMENSION XINT(*), WRK(LWRK)
#include "cholesky.fh"

      CHARACTER*9 SECNAM
      PARAMETER (SECNAM = 'CHO_SUBTR')

      LOGICAL LOCDBG, FXDMEM
      PARAMETER (LOCDBG = .FALSE.)

C     Return if nothing to do.
C     ------------------------

      IF (NUMCHO(ISYM) .LT. 1) THEN ! no prev. vectors.
         IF (LOCDBG) THEN
            WRITE(LUPRI,*) SECNAM,': nothing done because NUMCHO = ',
     &                     NUMCHO(ISYM),' (sym. ',ISYM,')'
         END IF
         return
      ELSE IF (NNBSTR(ISYM,2) .LT. 1) THEN ! nothing to do (this sym.)
         IF (LOCDBG) THEN
            WRITE(LUPRI,*) SECNAM,': nothing done because NNBSTR = ',
     &                     NNBSTR(ISYM,2),' (sym. ',ISYM,')'
         END IF
         return
      ELSE IF (NQUAL(ISYM) .LT. 1) THEN ! no qualifieds in this sym.
         IF (LOCDBG) THEN
            WRITE(LUPRI,*) SECNAM,': nothing done because NQUAL  = ',
     &                     NQUAL(ISYM),' (sym. ',ISYM,')'
         END IF
         return
      END IF

C     Debug: read original diagonal and check that these elements are
C            included in the integrals
C     ---------------------------------------------------------------

      IF (CHO_DIACHK .OR. LOCDBG) THEN
         KDIAG = 1
         KEND  = KDIAG + NNBSTRT(1)
         LWRK  = LWRK  - KEND + 1
         IF (LWRK .LT. 0) THEN
            WRITE(LUPRI,*) SECNAM,': diagonal/integral check skipped ',
     &                     'due to insufficient memory'
         ELSE
            TOL  = TOL_DIACHK
            NERR = 0
            CALL CHO_CHKINTO(XINT,WRK(KDIAG),ISYM,NERR,TOL,.TRUE.)
            IF (NERR .NE. 0) THEN
               WRITE(LUPRI,*) SECNAM,': ',NERR,' diagonal errors found!'
               WRITE(LUPRI,*) '          #tests: ',NQUAL(ISYM)
c              WRITE(LUPRI,*) '          Printing integrals:'
c              CALL CHO_OUTPUT(XINT,1,NNBSTR(ISYM,2),1,NQUAL(ISYM),
c    &                         NNBSTR(ISYM,2),NQUAL(ISYM),1,LUPRI)
               CALL CHO_QUIT('Diagonal errors in '//SECNAM,104)
            ELSE
               WRITE(LUPRI,*) SECNAM,': comparison of qual. integrals ',
     &                     'and original diagonal: no errors !'
            END IF
         END IF
      END IF

C     Subtract contributions for vectors in buffer.
C     (Returns immediately if nothing to do.)
C     ---------------------------------------------

      CALL CHO_VECBUF_SUBTR(XINT,WRK,LWRK,ISYM,.TRUE.,.TRUE.)

C     Subtract contributions for vectors on disk.
C     -------------------------------------------

      IF (CHO_IOVEC.EQ.3 .OR. CHO_IOVEC.EQ.4) THEN
         FXDMEM = CHO_IOVEC .EQ. 4
         CALL CHO_SUBTR1(XINT,WRK,LWRK,ISYM,FXDMEM)
      ELSE
         CALL CHO_SUBTR0(XINT,WRK,LWRK,ISYM)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine REVERSE(A_dir,A_inv,det)
! THIS ROUTINE CALCULATES THE INVERSE OF A SQUARE 3x3 MATRIX, AND ITS DETERMINANT.

use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: A_dir(3,3)
real(kind=wp), intent(out) :: A_inv(3,3), det
real(kind=wp) :: A(3,3)
real(kind=wp), external :: FindDetR

A(:,:) = A_dir(:,:)

det = FindDetR(A,3)

A_inv(1,1) = A(2,2)*A(3,3)-A(3,2)*A(2,3)
A_inv(1,2) = -A(1,2)*A(3,3)+A(3,2)*A(1,3)
A_inv(1,3) = A(1,2)*A(2,3)-A(2,2)*A(1,3)
A_inv(2,1) = -A(2,1)*A(3,3)+A(3,1)*A(2,3)
A_inv(2,2) = A(1,1)*A(3,3)-A(3,1)*A(1,3)
A_inv(2,3) = -A(1,1)*A(2,3)+A(2,1)*A(1,3)
A_inv(3,1) = A(2,1)*A(3,2)-A(3,1)*A(2,2)
A_inv(3,2) = -A(1,1)*A(3,2)+A(3,1)*A(1,2)
A_inv(3,3) = A(1,1)*A(2,2)-A(2,1)*A(1,2)

A_inv(:,:) = A_inv(:,:)/det

return

end subroutine REVERSE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Final(TermInts,irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Finalize Local Density Fitting.
C
C     Return codes:
C        irc=0: success
C        irc=1: internal error
C
      Implicit None
      Logical TermInts
      Integer irc
#include "localdf.fh"

      Character*9 SecNam
      Parameter (SecNam='LDF_Final')

      Integer nErr

      nErr=0

      If (LDF_Run_Mode.eq.LDF_RUN_INTERNAL) Then
         ! Write atom pair info to disk for later use
         Call LDF_WriteAtomPairInfo(irc)
         If (irc.ne.0) Then
            Write(6,'(//,A,A,I8)')
     &      SecNam,': LDF_WriteAtomPairInfo returned code',irc
            nErr=nErr+1
         End If
      Else If (LDF_Run_Mode.ne.LDF_RUN_EXTERNAL) Then
         Call WarningMessage(2,SecNam//' improper run mode!')
         Write(6,'(A,I9)') 'Run mode=',LDF_Run_Mode
         Call LDF_Quit(1)
      End If

      ! Unset atom to atom pair map (if set)
      Call LDF_UnsetA2AP()

      ! Unset atom pair info
      Call LDF_UnsetAtomPairInfo(irc)
      If (irc.ne.0) Then
         Write(6,'(//,A,A,I8)')
     &   SecNam,': LDF_UnsetAtomPairInfo returned code',irc
         nErr=nErr+1
      End If

      ! Unset atom info
      Call LDF_UnsetAtomInfo(irc)
      If (irc.ne.0) Then
         Write(6,'(//,A,A,I8)')
     &   SecNam,': LDF_UnsetAtomInfo returned code',irc
         nErr=nErr+1
      End If

      ! Unset shell info
      Call LDF_UnsetSh(irc)
      If (irc.ne.0) Then
         Write(6,'(//,A,A,I8)')
     &   SecNam,': LDF_UnsetSh returned code',irc
         nErr=nErr+1
      End If

      ! Terminate integral setup and free shell tables
      If (TermInts) Then
         Call Term_Ints(.False.,.True.)
         Call Free_iSD()
      End If

      ! Set status on runfile
      Call LDF_SetStatusOnRunFile(LDF_Set-1)

      ! Set return code
      If (nErr.ne.0) Then
         irc=1
      Else
         irc=0
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Subroutine Swap_Seward(i,j)
************************************************************************
*                                                                      *
* Object: to swap the value of i and j.                                *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             April '90                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
*
      iTemp = i
      i = j
      j = iTemp
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
*               2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine PLF_LDF_G_3(TInt,nTInt,
     &                       AOint,ijkl,iCmp,jCmp,kCmp,lCmp,
     &                       iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*          Modified for Local DF, Thomas Bondo Pedersen, June 2010     *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit None
      Integer nTInt
      Real*8  TInt(nTInt)
      Integer ijkl, iCmp, jCmp, kCmp, lCmp
      Real*8  AOInt(ijkl,iCmp,jCmp,kCmp,lCmp)
      Integer iAO(4), iAOst(4)
      Integer iBas, jBas, kBas, lBas
      Integer kOp(4)
#include "localdf_bas.fh"
#include "localdf_int.fh"
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      Character*11 SecNam
      Parameter (SecNam='PLF_LDF_G_3')
#endif

      Integer i1, i2, i3, i4
      Integer iShlI, iShlK
      Integer iSO, jSO, kSO, lSO
      Integer iSOi, jSOj, kSOk, lSOl
      Integer ii, jj, kk, ll
      Integer iShlIJ, iShlKL, ij, kl
      Integer ijkl_, klij_, ij0, kl0
      Integer nijkl

      Integer i, j
      Integer nBasSh, iShlSO, IndxG2
#if defined (_DEBUGPRINT_)
      Integer iSOShl
      iSOShl(i)=iWork(ip_iSOShl-1+i)
#endif
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iShlSO(i)=iWork(ip_iShlSO-1+i)
      IndxG2(i,j)=iWork(ip_IndxG2-1+l_IndxG2_1*(j-1)+i)

#if defined (_DEBUGPRINT_)
      If (iSOShl(iAOtSO(iAO(1)+1,kOp(1))+iAOst(1)).ne.SHA) Then
         Call WarningMessage(2,SecNam//': Shell problem [1]')
         Call LDF_Quit(1)
      End If
      If (iSOShl(iAOtSO(iAO(2)+1,kOp(2))+iAOst(2)).ne.SHB) Then
         Call WarningMessage(2,SecNam//': Shell problem [2]')
         Call LDF_Quit(1)
      End If
      If (iSOShl(iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)).ne.SHC) Then
         Call WarningMessage(2,SecNam//': Shell problem [3]')
         Call LDF_Quit(1)
      End If
      If (iSOShl(iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)).ne.SHD) Then
         Call WarningMessage(2,SecNam//': Shell problem [4]')
         Call LDF_Quit(1)
      End If
#endif

      iShlI=SHA
      iShlK=SHC
      iShlIJ=SPAB
      iShlKL=SPCD
      Do i4=1,lCmp
         lSO=iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
         Do i3=1,kCmp
            kSO=iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
            Do i2=1,jCmp
               jSO=iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
               Do i1=1,iCmp
                  iSO=iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
                  nijkl=0
                  Do lSOl=lSO,lSO+lBas-1
                     ll=iShlSO(lSOl)
                     kl0=nBasSh(iShlK)*(ll-1)
                     Do kSOk=kSO,kSO+kBas-1
                        kk=iShlSO(kSOk)
                        kl=kl0+kk
                        If (IndxG2(kl,iShlKL).gt.0) Then
                           Do jSOj=jSO,jSO+jBas-1
                              jj=iShlSO(jSOj)
                              ij0=nBasSh(iShlI)*(jj-1)
                              Do iSOi=iSO,iSO+iBas-1
                                 ii=iShlSO(iSOi)
                                 ij=ij0+ii
                                 nijkl=nijkl+1
                                 If (IndxG2(ij,iShlIJ).gt.0) Then
                                    ijkl_=nRow_G*(IndxG2(kl,iShlKL)-1)
     &                                   +IndxG2(ij,iShlIJ)
                                    klij_=nRow_G*(IndxG2(ij,iShlIJ)-1)
     &                                   +IndxG2(kl,iShlKL)
                                    TInt(ijkl_)=AOInt(nijkl,i1,i2,i3,i4)
                                    TInt(klij_)=TInt(ijkl_)
                                 End If
                              End Do
                           End Do
                        Else
                           nijkl=nijkl+jBas*iBas
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Ovlp(iWay,C1,C2,Smat)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Compute the orbital overlap matrix between the MO sets C1 and C2 *
!                                                                      *
!     calling arguments:                                               *
!     iWay    : integer                                                *
!               =0 : S-matrix for all orbitals                         *
!                    symmetry blocked, triangular                      *
!               =1 : S-matrix for active orbitals only                 *
!                    no symmetry, triangular                           *
!     C1      : real*8                                                 *
!               MO-basis                                               *
!     C2      : real*8                                                 *
!               MO-basis                                               *
!     S       : real*8                                                 *
!               orbital overlap matrix                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1999                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use rasscf_global, only: NAC
use general_data, only: NASH, NBAS, NFRO, NISH, NSYM, NTOT1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iWay
real(kind=wp), intent(in) :: C1(*), C2(*)
real(kind=wp), intent(out) :: Smat(NAC**2)
integer(kind=iwp) :: iComp, iiOrb, ij, iOpt, iOrb, ipC, ipO, ipSMat, iRC, iSyLbl, iSym, jjOrb, jOrb, nAcO, nAs, nBs, nIs
character(len=8) :: Label
real(kind=wp), allocatable :: OAO(:), Scr1(:), Scr2(:)
#include "warnings.h"

! prologue

Smat(1:nAc*nAc) = Zero
call mma_allocate(OAO,nTot1,Label='OAO')

! read the overlap integrals

iRc = -1
iOpt = ibset(ibset(0,sNoOri),sNoNuc)
iComp = 1
iSyLbl = 1
Label = 'Mltpl  0'
call RdOne(iRc,iOpt,Label,iComp,OAO,iSyLbl)
if (iRc /= 0) then
  write(u6,*)
  write(u6,*) ' *** Error in subroutine Ovlp ***'
  write(u6,*) ' premature abort in subroutine RdOne'
  write(u6,*) ' reading label: ',Label
  write(u6,*) ' RASSCF is trying to orthonormalize orbitals but'
  write(u6,*) ' could not read overlaps from ONEINT. Something'
  write(u6,*) ' is wrong with the file, or possibly with the'
  write(u6,*) ' program. Please check.'
  write(u6,*)
  call Quit(_RC_IO_ERROR_READ_)
end if

! compute the S-matrix for all orbitals and select elements

ipC = 1
ipO = 1
ipSmat = 1
nAcO = 0
do iSym=1,nSym
  nBs = nBas(iSym)
  nIs = nFro(iSym)+nIsh(iSym)
  nAs = nAsh(iSym)
  if (nBs > 0) then
    call mma_allocate(Scr1,nBs*nBs,Label='Scr1')
    call mma_allocate(Scr2,nBs*nBs,Label='Scr2')
    call Square(OAO(ipO),Scr1,1,nBs,nBs)
    call DGEMM_('N','N',nBs,nBs,nBs,One,Scr1,nBs,C1(ipC),nBs,Zero,Scr2,nBs)
    call DGEMM_('T','N',nBs,nBs,nBs,One,C2(ipC),nBs,Scr2,nBs,Zero,Scr1,nBs)
    if (iWay == 0) then
      ij = 1
      do iOrb=1,nBs
        do jOrb=1,nBs
          if (jOrb <= iOrb) then
            Smat(ipSmat) = Scr1(ij)
            ipSmat = ipSmat+1
          end if
          ij = ij+1
        end do
      end do
    else
      ij = 1
      do iOrb=1,nBs
        do jOrb=1,nBs
          !if (jOrb <= iOrb) then
          if ((iOrb > nIs) .and. (iOrb <= (nIs+nAs))) then
            if ((jOrb > nIs) .and. (jOrb <= (nIs+nAs))) then
              iiOrb = iOrb-nIs+nAcO
              jjOrb = jOrb-nIs+nAcO
              ipSmat = jjOrb+nTri_Elem(iiOrb-1)
              ipSmat = jjOrb+(iiOrb-1)*nAc
              Smat(ipSmat) = Scr1(ij)
            end if
          end if
          !end if
          ij = ij+1
        end do
      end do
    end if
    call mma_deallocate(Scr2)
    call mma_deallocate(Scr1)
  end if
  ipC = ipC+nBs*nBs
  ipO = ipO+nTri_Elem(nBs)
  nAcO = nAcO+nAs
end do

! epilogue

call mma_deallocate(OAO)

end subroutine Ovlp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_mc0c1at3b(rowa,cola,rowb,colb,rowc,colc,row,isum,col,a,b,c)
! C = C + A(T)*B

use CCT3_global, only: mhkey
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: rowa, cola, rowb, colb, rowc, colc, row, isum, col
real(kind=wp), intent(in) :: a(rowa,cola), b(rowb,colb)
real(kind=wp), intent(inout) :: c(rowc,colc)
integer(kind=iwp) :: j, k

if (mhkey == 1) then
  ! ESSL
  call DGEMM_('T','N',row,col,isum,One,a,rowa,b,rowb,One,c,rowc)

else
  ! Fortran

  do j=1,col
    do k=1,isum
      c(1:row,j) = c(1:row,j)+a(k,1:row)*b(k,j)
    end do
  end do

end if

return

end subroutine cct3_mc0c1at3b

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReLoad(A,idsym,NBAS1,NBAS2)

use Symmetry_Info, only: Mul
use MCLR_Data, only: ipMat, nDens
use input_mclr, only: nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: A(*)
integer(kind=iwp), intent(in) :: idSym, nbas2(nsym), nbas1(nsym)
integer(kind=iwp) :: iS, j, jS, m, n1, n2
real(kind=wp), allocatable :: ATemp(:)

call mma_allocate(ATemp,nDens,Label='ATemp')

do iS=1,nsym
  js = Mul(is,idsym)
  m = min(nbas1(is),nbas2(is))
  do j=1,min(nbas2(js),nbas1(js))
    n1 = ipMat(is,js)+(j-1)*nbas1(is)
    n2 = ipMat(is,js)+(j-1)*nbas2(is)
    ATemp(n2:n2+m-1) = A(n1:n1+m-1)
  end do
end do
A(1:nDens) = ATemp(:)
call mma_deallocate(ATemp)

end subroutine ReLoad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DumInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: dummy routine that should never be actually called.          *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp

implicit none
#include "int_interface.fh"

#include "macros.fh"
unused_var(Alpha)
unused_var(nAlpha)
unused_var(Beta)
unused_var(nBeta)
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(P)
unused_var(rFinal)
unused_var(nZeta)
unused_var(nIC)
unused_var(nComp)
unused_var(la)
unused_var(lb)
unused_var(A)
unused_var(RB)
unused_var(nHer)
unused_var(Array)
unused_var(nArr)
unused_var(Ccoor)
unused_var(nOrdOp)
unused_var(lOper)
unused_var(iChO)
unused_var(iStabM)
unused_var(nStabM)
unused_var(PtChrg)
unused_var(nGrid)
unused_var(iAddPot)

call WarningMessage(2,'DumInt should never be called')
call Abend()

end subroutine DumInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT1T2()
! T1(a,i) = 0 (mozno neskor ine)
! T2(a,b,i,j) = (ai|bj)/Dabij

use chcc_global, only: no, nv, OEo, OEv, Q21, T1c, T2c
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: b, i, j

call mma_allocate(T1c,nv,no,label='T1c')
call mma_allocate(T2c,nv,nv,no,no,label='T2c')


T1c(:,:) = Zero

do j=1,no
  do i=1,no
    do b=1,nv
      T2c(:,b,i,j) = Q21(:,i,b,j)/(OEo(i)+OEo(j)-OEv(:)-OEv(b))
    end do
  end do
end do

return

end subroutine MkT1T2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine TERI(Zeta,Eta,P,Q,rKapab,rKapcd,T,Fact,ZEInv,nT,IsChi,
     &                ChiI2)
************************************************************************
*                                                                      *
* Object: to entities for the two-electron integrals which are used in *
*         in the Rys quadrature to evaluate these integrals.           *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Intrinsic Sqrt
#include "print.fh"
#include "real.fh"
      Real*8 Zeta(nT), Eta(nT), P(nT,3), Q(nT,3),
     &       rKapab(nT), rKapcd(nT),
     &       T(nT), Fact(nT), ZEInv(nT)
*
      iRout = 56
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt(' Zeta in TERI',' ',Zeta,1,nT)
      Call RecPrt(' Eta in TERI',' ',Eta,1,nT)
      Call RecPrt(' P in TERI',' ',P,nT,3)
      Call RecPrt(' Q in TERI',' ',Q,nT,3)
      Call RecPrt(' Kab in TERI',' ',rKapab,1,nT)
      Call RecPrt(' Kcd in TERI',' ',rKapcd,1,nT)
#endif
*
      Do iT = 1, nT
         tmp = 1.0D0/(Zeta(iT)+Eta(iT)
     >       +(Eta(iT)*Zeta(iT)*ChiI2)*Dble(IsChi))
         ZEInv(iT) = tmp
         Rho = Zeta(iT)*Eta(iT)*tmp
         PQ2 = (P(iT,1)-Q(iT,1))**2
     &       + (P(iT,2)-Q(iT,2))**2
     &       + (P(iT,3)-Q(iT,3))**2
         T(iT) = Rho*PQ2
         Fact(iT) =  rKapab(iT) * rKapcd(iT) * Sqrt(tmp)
       End Do
#ifdef _DEBUGPRINT_
       Call RecPrt('Tvalue',' ',T,1,nT)
       Call RecPrt('Fact  ',' ',Fact,1,nT)
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SymAdp(iAng,iCmp,jCmp,kCmp,lCmp,Shijij,iShll,iShell,iAO,kOp,ijkl,Aux,nAux,AOInt,SOInt,nSOInt,Done)
!***********************************************************************
!                                                                      *
!  Object: to transform the integrals in AO basis to symmetry adapted  *
!          orbitals , SO. This is done by accumulating the AO inte-    *
!          grals onto the SO integrals.                                *
!          Observe that one of the operator is the Unit operation      *
!          performed on center A. However, since we scramble the order *
!          we do not really know which center is which. However, the   *
!          Unit operator will always give a factor of one. Hence, this *
!          is a convenient way to do the symmetry transformation with- *
!          out having to know the order.                               *
!                                                                      *
!          The indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!          This code is never executed in the no symmetry case!!!      *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!***********************************************************************

use Index_Functions, only: nTri_Elem, nTri3_Elem
use Basis_Info, only: Shells
use Symmetry_Info, only: iChBas, iChTbl, iOper, nIrrep, Prmt
use SOAO_Info, only: iAOtSO
use Real_Spherical, only: iSphCr
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iAng(4), iCmp, jCmp, kCmp, lCmp, iShll(4), iShell(4), iAO(4), kOp(4), ijkl, nAux, nSOInt
logical(kind=iwp), intent(in) :: Shijij
real(kind=wp), intent(in) :: AOInt(ijkl,iCmp,jCmp,kCmp,lCmp)
real(kind=wp), intent(inout) :: SOInt(ijkl,nSOInt), Aux(nAux)
logical(kind=iwp), intent(out) :: Done
integer(kind=iwp) :: i1, i12, i2, i3, i34, i4, iAux, iChBs, ii, iSym(0:7), ix, j, j1, j12, j2, j2Max, j3, j4, jChBs, jCmpMx, jj, &
                     jSym(0:7), k12, k34, kChBs, kk, kSym(0:7), lChBs, lCmpMx, ll, lSym(0:7), MemSO2
real(kind=wp) :: pEa, pRb, pTc, pTSd, Xa, Xb, Xg
logical(kind=iwp) :: Qij, Qijij, Qkl, Shij, Shkl

Done = .false.
k12 = 0
k34 = 0
ii = nTri3_Elem(iAng(1))
jj = nTri3_Elem(iAng(2))
kk = nTri3_Elem(iAng(3))
ll = nTri3_Elem(iAng(4))
MemSO2 = 1
#ifdef _DEBUGPRINT_
call RecPrt(' In SymAdp: AOInt ',' ',AOInt,ijkl,iCmp*jCmp*kCmp*lCmp)
#endif

! Quadruple loop over elements of the basis functions angular
! description. Loops are reduced to just produce unique SO integrals
! Observe that we will walk through the memory in AOInt in a
! sequential way.

Shij = iShell(1) == iShell(2)
Shkl = iShell(3) == iShell(4)
do i1=1,iCmp
  do j=0,nIrrep-1
    ix = 0
    if (iAOtSO(iAO(1)+i1,j) > 0) ix = 2**j
    iSym(j) = ix
  end do
  jCmpMx = jCmp
  if (Shij) jCmpMx = i1
  iChBs = iChBas(ii+i1)
  if (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+i1))
  pEa = Prmt(iOper(kOp(1)),iChBs)
  do i2=1,jCmpMx
    do j=0,nIrrep-1
      ix = 0
      if (iAOtSO(iAO(2)+i2,j) > 0) ix = 2**j
      jSym(j) = ix
    end do
    jChBs = iChBas(jj+i2)
    if (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+i2))
    pRb = Prmt(iOper(kOp(2)),jChBs)*pEa
    Qij = i1 == i2
    if (iShell(2) > iShell(1)) then
      i12 = jCmp*(i1-1)+i2
    else
      i12 = iCmp*(i2-1)+i1
    end if
    do i3=1,kCmp
      do j=0,nIrrep-1
        ix = 0
        if (iAOtSO(iAO(3)+i3,j) > 0) ix = 2**j
        kSym(j) = ix
      end do
      lCmpMx = lCmp
      if (Shkl) lCmpMx = i3
      kChBs = iChBas(kk+i3)
      if (Shells(iShll(3))%Transf) kChBs = iChBas(iSphCr(kk+i3))
      pTc = Prmt(iOper(kOp(3)),kChBs)*pRb
      do i4=1,lCmpMx
        do j=0,nIrrep-1
          ix = 0
          if (iAOtSO(iAO(4)+i4,j) > 0) ix = 2**j
          lSym(j) = ix
        end do
        Qkl = i3 == i4
        lChBs = iChBas(ll+i4)
        if (Shells(iShll(4))%Transf) lChBs = iChBas(iSphCr(ll+i4))
        pTSd = Prmt(iOper(kOp(4)),lChBs)*pTc
        if (iShell(4) > iShell(3)) then
          i34 = lCmp*(i3-1)+i4
        else
          i34 = kCmp*(i4-1)+i3
        end if
        if (Shijij .and. (i34 > i12)) cycle
        Qijij = Shijij .and. (i12 == i34)

        ! Loop over irreps which are spanned by the basis function.
        ! Again, the loop structure is restricted to ensure unique
        ! integrals.

        iAux = 0
        do j1=0,nIrrep-1
          if (iSym(j1) == 0) cycle
          Xa = real(iChTbl(j1,kOp(1)),kind=wp)*pTSd
          j2Max = nIrrep-1
          if (Shij .and. Qij) j2Max = j1
          do j2=0,j2Max
            if (jSym(j2) == 0) cycle
            Xb = real(iChTbl(j2,kOp(2)),kind=wp)*Xa
            j12 = ieor(j1,j2)
            if (Qijij) then
              if (Shij .and. Qij) then
                k12 = nTri_Elem(j1)+j2+1
              else if (Shij) then
                k12 = nIrrep*j1+j2+1
              else if (iShell(1) > iShell(2)) then
                k12 = nIrrep*j1+j2+1
              else
                k12 = nIrrep*j2+j1+1
              end if
            end if
            do j3=0,nIrrep-1
              if (kSym(j3) == 0) cycle
              j4 = ieor(j12,j3)
              if (lSym(j4) == 0) cycle
              if (Shkl .and. Qkl .and. (j4 > j3)) cycle
              if (Qijij) then
                if (Shkl .and. Qkl) then
                  k34 = nTri_Elem(j3)+j4+1
                else if (Shkl) then
                  k34 = nIrrep*j3+j4+1
                else if (iShell(3) > iShell(4)) then
                  k34 = nIrrep*j3+j4+1
                else
                  k34 = nIrrep*j4+j3+1
                end if
                if (Qijij .and. (k34 > k12)) cycle
              end if
              Xg = real(iChTbl(j3,kOp(3)),kind=wp)*Xb
              iAux = iAux+1
              Aux(iAux) = real(iChTbl(j4,kOp(4)),kind=wp)*Xg

            end do
          end do
        end do

#       ifdef _DEBUGPRINT_
        call RecPrt(' Aux',' ',Aux,iAux,1)
#       endif
        if (iAux /= 0) then
          if (iAux /= 1) then
            call DNaXpY(iAux,ijkl,Aux,1,AOInt(1,i1,i2,i3,i4),1,0,SOInt(1,MemSO2),1,ijkl)
          else
            SOInt(:,MemSO2) = SOInt(:,MemSO2)+Aux(1)*AOInt(:,i1,i2,i3,i4)
          end if
          MemSO2 = MemSO2+iAux
        end if

      end do
    end do
  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt(' On exit from SymAdp: SOInt ',' ',SOInt,ijkl,nSOInt)
#endif

end subroutine SymAdp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c drt related subroutines
c
      subroutine active_drt()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "files_gugaci.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
      dimension iin(0:max_node)
      nci_dim=0
      if(norb_act.ne.0) goto 100
!====================  norb_act=0 ========================
      iseg_sta(1)=0
      iseg_dim(1)=1
      do im=1,ng_sm
        jdim=nu_ae(1+im)
        jtim=nu_ae(9+im)
        jsim=nu_ae(17+im)
        jd(im)=jdim
        jt(im)=jtim
        js(im)=jsim
        iseg_dim(jdim)=iseg_downwei(jdim)*jpad_upwei(jdim)
        iseg_dim(jtim)=iseg_downwei(jtim)*jpad_upwei(jtim)
        iseg_dim(jsim)=iseg_downwei(jsim)*jpad_upwei(jsim)
        if(iseg_dim(jdim).eq.0) then
          jd(im)=0
          nu_ad(jdim)=0
          nu_ae(jdim)=0
        endif
        if(iseg_dim(jtim).eq.0) then
          jt(im)=0
          nu_ad(jtim)=0
          nu_ae(jtim)=0
        endif
        if(iseg_dim(jsim).eq.0) then
          js(im)=0
          nu_ad(jsim)=0
          nu_ae(jsim)=0
        endif
      enddo
      do jp=2,25
        iseg_sta(jp)=iseg_sta(jp-1)+iseg_dim(jp-1)
        enddo
      nci_dim=iseg_sta(25)+iseg_dim(25)
      iseg_sta(26)=nci_dim
      do jp=1,25
        if(iseg_downwei(jp).eq.0) cycle
        iseg_upwei(jp)=iseg_dim(jp)/iseg_downwei(jp)
      enddo
      goto 200
!====================  norb_act<>0 ========================
!100   if(logic_mr)      call rst(ndd,indd)    !npp=2
!      if(logic_mrelcas) call rcas(ndd,indd)   !npp=3

100   write(6,*)' '
      write(6,*) ' now reading distinct row tableau'
      call readdrt(ludrt)
c
      nu_ae(1)=jv
      do im=1,ng_sm
        nu_ae(1+im)=jd(im)
        nu_ae(9+im)=jt(im)
        nu_ae(17+im)=js(im)
      enddo
      jds=1
      jde=mxnode
      jps=no(norb_inn)+1
      jpe=no(norb_inn+1)

      jp=jv
c     iin(1:jpe)=0
c     iin(0)=0
      iin(:)=0
      iin(jp)=1
      iseg_sta(1)=0       ! for node_ext
      iseg_dim(1)=0
      do jpn=jpe,1,-1
        do i=1,4
          jji=jj(i,jpn)
          if(iin(jji).eq.0) cycle
          iin(jpn)=iin(jpn)+iin(jji)
        enddo
      enddo
      do jdn=jds,jde
        if(nu_ad(jdn).eq.0) cycle
        ndi=iin(jdn)*iseg_downwei(1)*jpad_upwei(jdn)
        iseg_dim(1)=iseg_dim(1)+ndi
      enddo
      do im=1,ng_sm
        jp=jd(im)
        iseg_sta(1+im)=nci_dim       ! for node_d_ext
        iseg_dim(1+im)=0
        if(jp.eq.0) cycle
        iin(1:jpe)=0
        iin(0)=0
        iin(jp)=1
        do jpn=jpe,1,-1
          do i=1,4
            jji=jj(i,jpn)
            if(iin(jji).eq.0) cycle
            iin(jpn)=iin(jpn)+iin(jji)
          enddo
        enddo
        do jdn=jds,jde
          if(nu_ad(jdn).eq.0) cycle
          ndi=iin(jdn)*iseg_downwei(1+im)*jpad_upwei(jdn)
          iseg_dim(1+im)=iseg_dim(1+im)+ndi
        enddo
      enddo

      do im=1,ng_sm
        jp=jt(im)
        iseg_sta(9+im)=nci_dim       ! for node_t_ext
        iseg_dim(9+im)=0
        if(jp.eq.0) cycle
        iin(1:jpe)=0
        iin(0)=0
        iin(jp)=1
        do jpn=jpe,1,-1
          do i=1,4
            jji=jj(i,jpn)
            if(iin(jji).eq.0) cycle
            iin(jpn)=iin(jpn)+iin(jji)
          enddo
        enddo
        do jdn=jds,jde
          if(nu_ad(jdn).eq.0) cycle
          ndi=iin(jdn)*iseg_downwei(9+im)*jpad_upwei(jdn)
          iseg_dim(9+im)=iseg_dim(9+im)+ndi
        enddo
      enddo
      do im=1,ng_sm
        jp=js(im)
        iseg_sta(17+im)=nci_dim       ! for node_s_ext
        iseg_dim(17+im)=0
        if(jp.eq.0) cycle
        iin(1:jpe)=0
        iin(0)=0
        iin(jp)=1
        do jpn=jpe,1,-1
          do i=1,4
            jji=jj(i,jpn)
            if(iin(jji).eq.0) cycle
            iin(jpn)=iin(jpn)+iin(jji)
          enddo
        enddo
        do jdn=jds,jde
          if(nu_ad(jdn).eq.0) cycle
          ndi=iin(jdn)*iseg_downwei(17+im)*jpad_upwei(jdn)
          iseg_dim(17+im)=iseg_dim(17+im)+ndi
        enddo
      enddo
      do jp=2,25
        iseg_sta(jp)=iseg_sta(jp-1)+iseg_dim(jp-1)
c        write(nf2,'(3i10)')jp-1,iseg_sta(jp-1),iseg_dim(jp-1)      !to
      enddo
c        write(nf2,'(3i10)')25,iseg_sta(25),iseg_dim(25)          !to de
      nci_dim=iseg_sta(25)+iseg_dim(25)
      iseg_sta(26)=nci_dim
      do jp=1,25
        if(iseg_downwei(jp).eq.0) cycle
        iseg_upwei(jp)=iseg_dim(jp)/iseg_downwei(jp)
      enddo
c      call get_ivy()

! to the end of dbl,act,ext parts
200   call dbl_downwalk()
      write(6,*)'  end of drt,nci_dim= ',nci_dim
      !write(6,*)'-----------------------------------------------'
      !write(6,*)'         ci drt-information'
      !write(6,*)'       num.of orbitals:       ',nst
      !write(6,*)'       num.of froz-orbitals:  ',nzst
      !write(6,*)'       num.of active-orbitals:',ndh
      !write(6,*)'       num.of electrons:      ',nel
      !write(6,*)'       multiplicity:          ',mult
      !write(6,*)'       num.of configurations: ',ndime
      !write(6,*)'       symmetry:              ',zm
      !write(6,*)'-----------------------------------------------'
      return
      end

      subroutine rst(id,indd)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "files_gugaci.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
      write(6,*)' '
      write(6,*) ' now reading distinct row tableau'
      call readdrt(ludrt)
c      open(21,file="fort.drt",form="unformatted")
c      read(21) id
c      write(6,*) " id=",id
c      read(21) ja(1:id),jb(1:id),jm(1:id)
c      read(21) jj(1:4,0:id)
c      read(21) kk(0:id)
c      read(21) no(0:norb_inn+1)
c      read(21) jv,jd(1:8),jt(1:8),js(1:8)
c      close(21)

      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(id)
        call Unused_integer(indd)
      end if
      end

      subroutine ref_gfs(nel,ndj,locu,nm)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
      dimension lhsm(8),locu(8,max_ref),lscu(0:8,max_ref)
      nl_act=norb_act
      ne_act=nel-2*norb_dz
      ne_s=nint(spin*2)
      lhs=nstart_act
      lhe=norb_inn
      lhsm(1:8)=0
      do lh=lhs,lhe
          lm=lsm_inn(lh)
        lhsm(lm)=lhsm(lm)+1
      enddo
      mdj=0
      do 500 nes=ne_s,ne_act,2
        do 100 l1=0,lhsm(1)
          do 101 l2=0,lhsm(2)
            do 102 l3=0,lhsm(3)
              do 103 l4=0,lhsm(4)
                do 104 l5=0,lhsm(5)
                  do 105 l6=0,lhsm(6)
                    do 106 l7=0,lhsm(7)
                      do 107 l8=0,lhsm(8)
                        lpsum=l1+l2+l3+l4+l5+l6+l7+l8
                        if(lpsum.ne.nes) goto 107
                        mys=1
                        if(mod(l1,2).eq.1)mys=mul_tab(mys,1)
                        if(mod(l2,2).eq.1)mys=mul_tab(mys,2)
                        if(mod(l3,2).eq.1)mys=mul_tab(mys,3)
                        if(mod(l4,2).eq.1)mys=mul_tab(mys,4)
                        if(mod(l5,2).eq.1)mys=mul_tab(mys,5)
                        if(mod(l6,2).eq.1)mys=mul_tab(mys,6)
                        if(mod(l7,2).eq.1)mys=mul_tab(mys,7)
                        if(mod(l8,2).eq.1)mys=mul_tab(mys,8)
                        if(mys.ne.nm) goto 107
                        mdj=mdj+1
                        lscu(0,mdj)=lpsum
                        lscu(1,mdj)=l1
                        lscu(2,mdj)=l2
                        lscu(3,mdj)=l3
                        lscu(4,mdj)=l4
                        lscu(5,mdj)=l5
                        lscu(6,mdj)=l6
                        lscu(7,mdj)=l7
                        lscu(8,mdj)=l8
107                   continue
106                 continue
105               continue
104             continue
103           continue
102         continue
101       continue
100     continue
500   continue
      ndj=0
      do 300 m=1,mdj
        npair=(ne_act-lscu(0,m))/2
        do 200 l1=0,lhsm(1)-lscu(1,m)
          do 201 l2=0,lhsm(2)-lscu(2,m)
            do 202 l3=0,lhsm(3)-lscu(3,m)
              do 203 l4=0,lhsm(4)-lscu(4,m)
                do 204 l5=0,lhsm(5)-lscu(5,m)
                  do 205 l6=0,lhsm(6)-lscu(6,m)
                    do 206 l7=0,lhsm(7)-lscu(7,m)
                      do 207 l8=0,lhsm(8)-lscu(8,m)
                        lpsum=l1+l2+l3+l4+l5+l6+l7+l8
                        if(lpsum.eq.npair) then
                          m1=l1*2+lscu(1,m)
                          m2=l2*2+lscu(2,m)
                          m3=l3*2+lscu(3,m)
                          m4=l4*2+lscu(4,m)
                          m5=l5*2+lscu(5,m)
                          m6=l6*2+lscu(6,m)
                          m7=l7*2+lscu(7,m)
                          m8=l8*2+lscu(8,m)
                          do 600 ldj=1,ndj
                            if(m1.ne.locu(1,ldj)) goto 600
                            if(m2.ne.locu(2,ldj)) goto 600
                            if(m3.ne.locu(3,ldj)) goto 600
                            if(m4.ne.locu(4,ldj)) goto 600
                            if(m5.ne.locu(5,ldj)) goto 600
                            if(m6.ne.locu(6,ldj)) goto 600
                            if(m7.ne.locu(7,ldj)) goto 600
                            if(m8.ne.locu(8,ldj)) goto 600
                            goto 207
600                       continue
                          ndj=ndj+1
                          locu(1,ndj)=m1
                          locu(2,ndj)=m2
                          locu(3,ndj)=m3
                          locu(4,ndj)=m4
                          locu(5,ndj)=m5
                          locu(6,ndj)=m6
                          locu(7,ndj)=m7
                          locu(8,ndj)=m8
                        endif
207                   continue
206                 continue
205               continue
204             continue
203           continue
202         continue
201       continue
200     continue
300   continue

      do nre=1,ndj
      write(6,'(5x,i6,8i3)')nre,(locu(i,nre),i=1,8)
      enddo
      return
      end

      subroutine rcas(id,indd)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "files_gugaci.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
      write(6,*)' '
      write(6,*) ' now reading distinct row tableau'
      call readdrt(ludrt)

!      print*, "bbs debug rcas,kk(27)",kk(27)

c      open(21,file="fort.drt",form="unformatted")
c      read(21) id
c      read(21) ja(1:id),jb(1:id),jm(1:id)
c      read(21) jj(1:4,0:id)
c      read(21) kk(0:id)
c      read(21) no(0:norb_inn+1)
c      read(21) jv,jd(1:8),jt(1:8),js(1:8)
c      close(21)
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(id)
        call Unused_integer(indd)
      end if

      end

      subroutine check_rcas3(jk,ind,inb,ndj,locu)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
      dimension ind(8,max_node),lsym(8),iexcit(ndj),locu(8,ndj)
      inb=0
      nsumel=0
      do i=1,8
        lsym(i)=ind(i,jk)
        nsumel=nsumel+lsym(i)
      enddo
      do i=1,ndj
        iexcit(i)=0
        do m=1,8
          iex=lsym(m)-locu(m,i)
         if(iex.gt.0) then
           iexcit(i)=iexcit(i)+iex
          endif
        enddo
      enddo
      inb=iexcit(1)
      do i=2,ndj
         inb=min(inb,iexcit(i))
      enddo
      inb=inb+ja(jk)*2+jb(jk)
      return
      end

      subroutine irfrst(iselcsf_occ)
#include "drt_h.fh"
#include "pl_structure_h.fh"
c ifrno(j)=i
c irfno(i)=j no. i ref is no. j cfs in h0
      common/config/ndr,nwalk(0:max_orb)
      dimension iselcsf_occ(max_innorb,max_ref)
      dimension iwalktmp(max_orb)
      logical log_exist
      icsfwlk=0
      ndimh0=nci_h0 !iw_sta(2,1)
      icount=0
      do i=1,n_ref
        do j=1,ndimh0
          call found_a_config(j,1.0,0)
          do im=1,norb_all
            iwalktmp(im)=nwalk(norb_all-im+1)
          enddo

          log_exist=.false.
          ij=norb_dz
          do ii=1,norb_act
            ij=ij+1
            icsfwlk=iwalktmp(ij)
            if(icsfwlk.eq.3) then
              icsfocc=2
            elseif(icsfwlk.eq.2) then
              icsfocc=1
            elseif(icsfwlk.eq.1) then
              icsfocc=1
            elseif(icsfwlk.eq.0) then
              icsfocc=0
            else
              icsfocc=-1
            endif
            if(icsfocc.ne.iref_occ(ij,i)) then
              goto 30
            endif
          enddo
          log_exist=.true.
          icount=icount+1
          irfno(icount)=j
          ifrno(j)=icount
c          write(6,2000) iwalktmp(norb_dz+1:norb_dz+norb_act)
c          write(6,*) "icount",icount,j
30        continue
        enddo
      enddo

      irf=icount
      write(6,3000) irf

      return
c1000  format(1x,"warnning!the selected csf is not in references states")
c2000  format(1x,"the selected csf is :",2x,32(i1))
3000  format(1x,"number of gelfand states in referance space:",1x,i4)
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(iselcsf_occ)
c...end of irfrst
      end

      subroutine irfrst_bak(iselcsf_occ)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/config/ndr,nwalk(0:max_orb)
      dimension iselcsf_occ(max_innorb,max_ref)
      dimension iwalktmp(max_orb)
      logical log_exist
      nocc=0
      do i=1,mroot
        log_exist=.false.
        do ire=1,n_ref
          ij=norb_dz
          do io=1,norb_act
            ij=ij+1
            if(iselcsf_occ(io,i).eq.3) nocc=2
            if(iselcsf_occ(io,i).eq.2) nocc=1
            if(iselcsf_occ(io,i).eq.1) nocc=1
            if(iselcsf_occ(io,i).eq.0) nocc=0
            if(nocc.ne.iref_occ(io+norb_dz,ire)) then
               goto 10
            endif
          enddo
          log_exist=.true.
          goto 20
10        continue
        enddo
20      continue
        if(.not.log_exist) then
          write(6,1000)
          write(6,2000) iselcsf_occ(1:norb_act,i)
          write(6,*) " please select this state as reference state"
c          stop 777
        endif
      enddo
      icsfocc=0
      ndimh0=nci_h0 !iw_sta(2,1)
      icount=0
      do i=1,n_ref
        do j=1,ndimh0
          call found_a_config(j,1.0,0)
          do im=1,norb_all
            iwalktmp(im)=nwalk(norb_all-im+1)
          enddo

          log_exist=.false.
          ij=norb_dz
          do ii=1,norb_act
            ij=ij+1
            icsfwlk=iwalktmp(ij)
            if(icsfwlk.eq.3) icsfocc=2
            if(icsfwlk.eq.2) icsfocc=1
            if(icsfwlk.eq.1) icsfocc=1
            if(icsfwlk.eq.0) icsfocc=0
            if(icsfocc.ne.iref_occ(ij,i)) then
              goto 30
            endif
          enddo
          log_exist=.true.
          icount=icount+1
          irfno(icount)=j
          ifrno(j)=icount
c          write(6,2000) iwalktmp(norb_dz+1:norb_dz+norb_act)
c          write(6,*) "icount",icount,j
30        continue
        enddo
      enddo

      irf=icount
      do i=1,2*mroot
        iocsf=mjn(i)
        log_exist=.false.
        do j=1,icount
          if(iocsf.eq.irfno(j)) then
            log_exist=.true.
            goto 40
          endif
        enddo
40      continue
        if(.not.log_exist) then
          irf=irf+1
          irfno(irf)=iocsf
          ifrno(iocsf)=irf
        endif
      enddo

      write(6,3000) irf

      return
1000  format(1x,"warnning!the selected csf is not in references states")
2000  format(1x,"the selected csf is :",2x,32(i1))
3000  format(1x,"number of gelfand states in referance space:",1x,i4)
c...end of irfrst
      end

      function min_itexcit(indjk)
      common/ref/ndj,ndjgrop,ndjmod
      dimension indjk(4),itexcit(ndj)
c      integer*4 indjk  =  00 00 00 00 00 00 00 00 00 00  00 00 00 00 00
!    indexcit=  ir1 ir2 ir3 ir4 ir5 ir6 ir7 ir8 ......... ir15
!--------------------------------------------------------
      min_itexcit=3
      nj=0
      do ngrop=1,ndjgrop-1         !1-(ndjgrop-1) grop
        indexcit=indjk(ngrop)
        do lref=1,15
          ixcit=ishft(indexcit,-2*(lref-1))
          ixcit=mod(ixcit,4)
!          if(ixcit.ne.0) ixcit=ixcit-1
!          if(ixcit.eq.0) ixcit=3
            min_itexcit=min(min_itexcit,ixcit)
          if(min_itexcit.eq.0) return
          itexcit(nj+lref)=ixcit
        enddo
        nj=nj+15
      enddo
        indexcit=indjk(ndjgrop)       !last grop
        do lref=1,ndjmod
          ixcit=ishft(indexcit,-2*(lref-1))
          ixcit=mod(ixcit,4)
!          if(ixcit.ne.0) ixcit=ixcit-1
!          if(ixcit.eq.0) ixcit=3
          min_itexcit=min(min_itexcit,ixcit)
          if(min_itexcit.eq.0) return
          itexcit(nj+lref)=ixcit
        enddo
!--------------------------------------------------------
      return
      end

      subroutine njexcit(idcc,indjk,locuk0,n_ref)
      common/ref/ndj,ndjgrop,ndjmod
      dimension indjk(4),locuk0(n_ref),itexcit(n_ref)
      nj=0
      do ngrop=1,ndjgrop-1         !1-(ndjgrop-1) grop
        indexcit=indjk(ngrop)
        indjk(ngrop)=0
        do lref=1,15
          ixcit=ishft(indexcit,-2*(lref-1))
          ixcit=mod(ixcit,4)
         if(idcc-locuk0(nj+lref).eq.1) ixcit=ixcit+1
         if(idcc-locuk0(nj+lref).eq.2) ixcit=ixcit+2
         if(ixcit.ge.3) ixcit=3
         itexcit(nj+lref)=ixcit
          indjk(ngrop)=ishft(ixcit,2*(lref-1))+indjk(ngrop)
        enddo
        nj=nj+15
      enddo
        indexcit=indjk(ndjgrop)       !last grop
        indjk(ndjgrop)=0
        do lref=1,ndjmod
          ixcit=ishft(indexcit,-2*(lref-1))
          ixcit=mod(ixcit,4)
         if(idcc-locuk0(nj+lref).eq.1) ixcit=ixcit+1
         if(idcc-locuk0(nj+lref).eq.2) ixcit=ixcit+2
         if(ixcit.ge.3) ixcit=3
         itexcit(nj+lref)=ixcit
         indjk(ngrop)=ishft(ixcit,2*(lref-1))+indjk(ngrop)
       enddo

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SORTB(BUFS,INDS,ACBDS,ACBDT,ISAB,BFACBD)
! SORTS INTEGRALS (AB/CD)
! FOR FIXED A,C ALL B,D

use mrci_global, only: ICH, IPASS, IRC, IROW, JJS, KBUFF1, LASTAD, LN, LSYM, Lu_60, Lu_80, LUTRA, MCHAIN, NBITM2, NCHN2, NORB, &
                       NSM, NSYM, NTIBUF, NVIR, NVIRP, NVIRT, TIBUF
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(out) :: BUFS(NBITM2,NCHN2)
integer(kind=iwp), intent(out) :: INDS(NBITM2+2,NCHN2)
real(kind=wp), intent(_OUT_) :: ACBDS(*), ACBDT(*), BFACBD(*)
integer(kind=iwp), intent(in) :: ISAB(*)
#include "tratoc.fh"
#include "warnings.h"
integer(kind=iwp) :: I, IAC, IACMAX, IACMIN, IAD16, IAD50, IADR, IBDS, IDISK, IFIN1, IFIN2, ILOOP, IN1, INB, INND, INPS, INPT, &
                     INS, INSB, INSOUT, INUMB, IOUT, IPOS, IST, IST1, IST2, ISTEP, ISYM, ITAIL, ITURN, JDISK, KK, LENGTH, M1, M2, &
                     M3, M4, N1, N2, N3, N4, NA, NAC, NB, NC, ND, NDMAX, NI, NJ, NK, NL, NOP, NOQ, NOR, NORB0(9), NORBP, NOS, &
                     NOVM, NOVST, NSAC, NSACL, NSC, NSP, NSPQ, NSPQR, NSQ, NSR, NSS, NSSM, NT, NTM, NU, NUMAX, NUMIN, NV, NVT, NX, &
                     NXM
real(kind=wp) :: FINI

NVT = IROW(NVIRT+1)
NOVST = LN*NVIRT+1
IAD16 = 0

NORB0(1) = 0
do I=1,NSYM
  NORB0(I+1) = NORB0(I)+NORB(I)
end do

INSOUT = 0
IACMAX = 0
do ISTEP=1,IPASS
  IAD50 = 0
  call iDAFILE(LUTRA,2,iTraToc,nTraToc,IAD50)
  IDISK = 0
  IACMIN = IACMAX+1
  IACMAX = IACMAX+NCHN2
  if (IACMAX > NVT) IACMAX = NVT
  if (IACMIN > IACMAX) cycle

  ! Initialize Buffer Counts and BackChain Links.
  INDS(NBITM2+1,:) = 0
  INDS(NBITM2+2,:) = -1

  ! Loop over symmetry blocks of all-virtual integrals.
  do NSP=1,NSYM
    NOP = NORB(NSP)
    do NSQ=1,NSP
      NSPQ = MUL(NSP,NSQ)
      NOQ = NORB(NSQ)
      do NSR=1,NSP
        NSPQR = MUL(NSPQ,NSR)
        NOR = NORB(NSR)
        NSSM = NSR
        if (NSR == NSP) NSSM = NSQ
        do NSS=1,NSSM
          if (NSS /= NSPQR) cycle
          NOS = NORB(NSS)
          NORBP = NOP*NOQ*NOR*NOS
          if (NORBP == 0) cycle

          call dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)

          ! Loop over index quadruples in this symm block
          IOUT = 0
          do NV=1,NOR
            NXM = NOS
            if (NSR == NSS) NXM = NV
            do NX=1,NXM
              NTM = 1
              if (NSP == NSR) NTM = NV
              do NT=NTM,NOP
                NUMIN = 1
                if ((NSP == NSR) .and. (NT == NV)) NUMIN = NX
                NUMAX = NOQ
                if (NSP == NSQ) NUMAX = NT
                do NU=NUMIN,NUMAX

                  ! MO integral value is made accessable at TIBUF(IOUT)
                  IOUT = IOUT+1
                  if (IOUT > NTIBUF) then
                    call dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
                    IOUT = 1
                  end if

                  ! M1..M4 seqential number of orbitals.
                  M1 = ICH(NORB0(NSP)+NT)
                  M2 = ICH(NORB0(NSQ)+NU)
                  M3 = ICH(NORB0(NSR)+NV)
                  M4 = ICH(NORB0(NSS)+NX)
                  if ((M1 <= LN) .or. (M2 <= LN)) cycle
                  if ((M3 <= LN) .or. (M4 <= LN)) cycle

                  ! Permute orbital indices to canonical order
                  ! and put integral value in FINI
                  N1 = max(M1,M2)
                  N2 = min(M1,M2)
                  N3 = max(M3,M4)
                  N4 = min(M3,M4)
                  NI = N1
                  NJ = N2
                  NK = N3
                  NL = N4
                  if (NI <= NK) then
                    if (NI /= NK) then
                      NI = N3
                      NJ = N4
                      NK = N1
                      NL = N2
                    else if (NJ > NL) then
                      NL = N2
                      NJ = N4
                    end if
                  end if
                  FINI = TIBUF(IOUT)

                  ! Compute virtual indices.
                  NA = NI-LN
                  NB = NJ-LN
                  NC = NK-LN
                  ND = NL-LN
                  ITURN = 0
                  if ((NA == NB) .and. (NC == ND)) cycle
                  do
                    IAC = IROW(NA)+NC
                    if ((IAC >= IACMIN) .and. (IAC <= IACMAX)) then
                      if ((NA == NC) .and. (NB == ND)) FINI = FINI/2
                      NAC = IAC-IACMIN+1
                      IPOS = INDS(NBITM2+1,NAC)+1
                      INDS(NBITM2+1,NAC) = IPOS
                      INDS(IPOS,NAC) = NB+2**8*ND
                      BUFS(IPOS,NAC) = FINI
                      if (IPOS >= NBITM2) then
                        ! Save this buffer if filled up.
                        JDISK = IDISK
                        call iDAFILE(Lu_60,1,INDS(1,NAC),NBITM2+2,IDISK)
                        call dDAFILE(Lu_60,1,BUFS(1,NAC),NBITM2,IDISK)
                        INDS(NBITM2+1,NAC) = 0
                        INDS(NBITM2+2,NAC) = JDISK
                      end if
                    end if

                    if (ITURN == 1) exit
                    if ((NA == NC) .and. (NB == ND)) exit
                    if ((NA == NB) .or. (NC == ND)) exit
                    ITURN = 1
                    NC = NL-LN
                    ND = NK-LN
                  end do
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end do
  ! EMPTY LAST BUFFERS
  NOVM = IACMAX-IACMIN+1
  if ((NOVST+IACMIN-1+NOVM) > MCHAIN) then
    write(u6,*) 'SORTB Error: NOVST+IACMIN-1+NOVM > MCHAIN'
    write(u6,*) 'NOVST =',NOVST
    write(u6,*) 'IACMIN=',IACMIN
    write(u6,*) 'NOVM  =',NOVM
    write(u6,*) 'MCHAIN=',MCHAIN
    write(u6,*) '  (See code).'
    call QUIT(_RC_GENERAL_ERROR_)
  end if
  do I=1,NOVM
    JDISK = IDISK
    call iDAFILE(Lu_60,1,INDS(1,I),NBITM2+2,IDISK)
    call dDAFILE(Lu_60,1,BUFS(1,I),NBITM2,IDISK)
    LASTAD(NOVST+IACMIN-1+I) = JDISK
  end do
  do ISYM=1,NSYM
    IST1 = IRC(3)+JJS(ISYM+9)+1
    IFIN1 = IRC(3)+JJS(ISYM+10)
    INPS = IFIN1-IST1+1
    IST2 = IRC(2)+JJS(ISYM)+1
    IFIN2 = IRC(2)+JJS(ISYM+1)
    INPT = IFIN2-IST2+1
    ITAIL = INPS+INPT
    if (ITAIL == 0) cycle
    IN1 = -NVIRT
    do NA=1,NVIRT
      IN1 = IN1+NVIRT
      do NC=1,NA
        IAC = IROW(NA)+NC
        if (IAC < IACMIN) cycle
        if (IAC > IACMAX) cycle
        if (NA == 1) cycle
        NSAC = MUL(NSM(LN+NA),NSM(LN+NC))
        NSACL = MUL(NSAC,LSYM)
        if (NSACL /= ISYM) cycle
        NSC = NSM(LN+NC)
        NDMAX = NVIRP(NSC)+NVIR(NSC)
        if (NDMAX > NA) NDMAX = NA
        INS = ISAB(NA+(NDMAX-1)*NVIRT)
        ACBDS(1:INS) = Zero
        ACBDT(1:INS) = Zero
        IADR = LASTAD(NOVST+IAC)
        do
          call iDAFILE(Lu_60,2,INDS,NBITM2+2,IADR)
          call dDAFILE(Lu_60,2,BUFS,NBITM2,IADR)
          LENGTH = INDS(NBITM2+1,1)
          IADR = INDS(NBITM2+2,1)
          do KK=1,LENGTH
            INND = INDS(KK,1)
            NB = ibits(INND,0,8)
            ND = ibits(INND,8,8)

            IBDS = ISAB(NB+(ND-1)*NVIRT)
            ACBDS(IBDS) = ACBDS(IBDS)+BUFS(KK,1)
            if (NB > ND) ACBDT(IBDS) = ACBDT(IBDS)+BUFS(KK,1)
            if (NB < ND) ACBDT(IBDS) = ACBDT(IBDS)-BUFS(KK,1)
          end do
          if (IADR == -1) exit
        end do
        ILOOP = 0
        do
          INSB = INS
          do
            INB = KBUFF1-INSOUT
            INUMB = INSB
            if (INSB > INB) INUMB = INB
            IST = INS-INSB+1
            if (ILOOP == 0) call DCOPY_(INUMB,ACBDS(IST),1,BFACBD(INSOUT+1),1)
            if (ILOOP == 1) call DCOPY_(INUMB,ACBDT(IST),1,BFACBD(INSOUT+1),1)
            INSOUT = INSOUT+INUMB
            if (INSOUT >= KBUFF1) then
              call dDAFILE(Lu_80,1,BFACBD,KBUFF1,IAD16)
              INSOUT = 0
            end if
            INSB = INSB-INUMB
            if (INSB <= 0) exit
          end do
          ILOOP = ILOOP+1
          if (ILOOP /= 1) exit
        end do
      end do
    end do
  end do
end do
! EMPTY LAST BUFFER
if (INSOUT /= 0) call dDAFILE(Lu_80,1,BFACBD,KBUFF1,IAD16)

return

end subroutine SORTB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine add10(a,b,dimp,fact)
! this routine does:
! B(p) <-- fact * A(p)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp
real(kind=wp), intent(in) :: a(dimp), fact
real(kind=wp), intent(inout) :: b(dimp)

b(:) = b(:)+fact*a(:)

return

end subroutine add10

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Print_NQ_Info()

use nq_Info, only: Dens_I, Energy_integrated, Grad_I, nTotGP, Tau_I
use Constants, only: Zero
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iPL
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: Reduce_Prt

!                                                                      *
!***********************************************************************
!                                                                      *
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0
!                                                                      *
!***********************************************************************
!                                                                      *
if (iPL >= 3) then
  call GAIGOP_SCAL(nTotGP,'+')
  write(u6,*)
  write(u6,'(6X,A,T52,F17.10)') 'Integrated DFT Energy   ',Energy_integrated
  write(u6,'(6X,A,T56,G17.10)') 'Integrated number of electrons',Dens_I
  if (Grad_I /= Zero) write(u6,'(6X,A,T56,G17.10)') 'Integrated |grad|             ',Grad_I
  if (Tau_I /= Zero) write(u6,'(6X,A,T56,G17.10)') 'Integrated tau                ',Tau_I
  write(u6,'(6X,A,T54,I13)') 'Total number of prunned grid points  ',nTotGP
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call Add_Info('DFT_Energy',[Energy_integrated],1,6)
call Add_Info('NQ_Density',[Dens_I],1,8)
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Print_NQ_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine rm_AuxShell(iCnttp)
************************************************************************
*                                                                      *
*     Remove an auxiliary basis set by making it empty.                *
*                                                                      *
************************************************************************
      Use Basis_Info, only: dbsc, Shells
      Implicit Real*8 (A-H,O-Z)
#include "SysDef.fh"
#include "real.fh"
*                                                                      *
************************************************************************
*                                                                      *
      Do k = 0, dbsc(iCnttp)%nShells-1
         iShll = dbsc(iCnttp)%iVal + k
*
         Shells(iShll)%nExp=0
         Shells(iShll)%nBasis  =0
         Shells(iShll)%nBasis_c=0
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine tr2NsA1(CMO,X1,nX1,X2,nX2,X3,nX3,pqUS,npqUS,pqRU,npqRU,pqTU,npqTU,lBuf)
! SECOND ORDER TWO-ELECTRON TRANSFORMATION ROUTINE
!
! THIS ROUTINE IS CALLED FOR EACH SYMMETRY BLOCK OF INTEGRALS
! (ISP,ISQ,ISR,ISS) WITH ISP >= ISQ AND ISR >= ISS.
! P,Q,R,S are SO indices.
! A,B are MO indices, counting only non-frozen and non-deleted.
! T,U are occupied MO indices, only non-frozen and non-deleted.
! INTEGRALS (AB/TU) ARE ALWAYS GENERATED
! EXCHANGE INTEGRALS (AT/BU) ARE GENERATED AS FOLLOWS:
! (AT/BU) IF ISP >= ISR
! (AT/UB) IF ISP > ISS AND ISP /= ISQ
! (TA/BU) IF ISQ > ISR AND ISP /= ISQ
! (TA/UB) IF ISQ >= ISS AND ISP /= ISQ

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "rasdim.fh"
#include "caspt2.fh"
integer(kind=iwp), intent(in) :: nX1, nX2, nX3, npqUS, npqRU, npqTU, lBuf
real(kind=wp), intent(in) :: CMO(NCMO)
real(kind=wp), intent(out) :: X1(nX1), X2(nX2), X3(nX3)
real(kind=wp), intent(inout) :: pqUS(npqUS), pqRU(npqRU), pqTU(npqTU)
integer(kind=iwp) :: IAD1, IAD1S, IAD2, IAD2S, IAD3, IAD3S, icc, icxc1, icxc3, icxc5, icxc7, iOpt, IOUT1, IOUT2, IOUT3, IP, &
                     IPQMX1, IPQMX2, IPQMX3, IQ, iRc, IRSST, LPQ, NORU, NOTU, NOUS, Num
#include "trafo.fh"

NOTU = NOCR*NOCS
if (ISR == ISS) NOTU = (NOCR**2+NOCR)/2
NOUS = NOCR*NBS
NORU = NBR*NOCS
icc = NOP*NOQ*NOCR*NOCS
icxc1 = NOP*NOCQ*NOR*NOCS
icxc3 = NOP*NOCQ*NOCR*NOS
icxc5 = NOCP*NOQ*NOR*NOCS
icxc7 = NOCP*NOQ*NOCR*NOS

! Check for in core or out of core transformation

! 1. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|US) ON UNIT LUHLF1
IPQMX1 = NBPQ
!vv prevent integer overflow
if (One*NBPQ*NOUS > LURPQ) then
  IPQMX1 = LURPQ/NOUS
  !write(u6,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|US)',IPQMX1
  IAD1S = 0
  call dDAFILE(LUHLF1,0,pqUS,IPQMX1,IAD1S)
end if
IAD1 = 0
IOUT1 = 0
! 2. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|RU) ON UNIT LUHLF2
IPQMX2 = NBPQ
!vv prevent integer overflow
if (One*NBPQ*NORU > LRUPQ) then
  IPQMX2 = LRUPQ/NORU
  !write(u6,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|RU)',IPQMX2
  IAD2S = 0
  call dDAFILE(LUHLF2,0,pqRU,IPQMX2,IAD2S)
end if
IAD2 = 0
IOUT2 = 0
! 3. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|TU) ON UNIT LUHLF3
IPQMX3 = NBPQ
!vv prevent integer overflow
if (One*NBPQ*NOTU > LTUPQ) then
  IPQMX3 = LTUPQ/NOTU
  !write(u6,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|TU)',IPQMX3
  IAD3S = 0
  call dDAFILE(LUHLF3,0,PQTU,IPQMX3,IAD3S)
end if
IAD3 = 0
IOUT3 = 0

! First half transformation

LPQ = 0
NPQ = 0
iRc = 0
iOpt = 1
IRSST = 1-NBRS
! Loop over p,q symmetry pair, if(ISP == ISQ) loop should be triangle
do IP=1,NBP
  Num = NBQ
  if (ISP == ISQ) Num = IP
  do IQ=1,Num
    IOUT1 = IOUT1+1
    IOUT2 = IOUT2+1
    IOUT3 = IOUT3+1
    ! Read integrals (pq,rs)
    if (LPQ == NPQ) then
      call Rdord(iRc,iOpt,ISP,ISQ,ISR,ISS,X1,lBuf,nPQ)
      if (IRC > 1) then
        write(u6,*) ' ERROR RETURN CODE IRC=',IRC
        write(u6,*) ' FROM RDORD, CALLED FROM TRA2.'
        call Abend()
      end if
      iOpt = 2
      LPQ = 0
      IRSST = 1-NBRS
    end if
    LPQ = LPQ+1
    IRSST = IRSST+NBRS
    ! Square if necessary
    if (ISR == ISS) then
      call Square(X1(IRSST),X2,1,NBS,NBS)
    else
      call dcopy_(NBRS,X1(IRSST),1,X2,1)
    end if

    !====================================================
    ! First half transformation to (pq,Us), if ISR /= ISS
    ! For exchange case3,4 (AT,UB), case7,8 (TA,UB)
    !====================================================
    if ((icxc3 /= 0) .or. (icxc7 /= 0)) then
      if (ISR /= ISS) then
        !  (pq,rs) -> (pq,Us)
        call DGEMM_('N','N',NBS,NOCR,NBR,One,X2,NBS,CMO(LMOR2),NBR,Zero,X3,NBS)
        !  (pq,Us) Sorting
        if (IOUT1 > IPQMX1) then
          IOUT1 = 1
          call dDAFILE(LUHLF1,1,pqUS,IPQMX1*NOUS,IAD1)
        end if
        call DCOPY_(NOUS,X3,1,pqUS(IOUT1),IPQMX1)
      end if
    end if

    ! First half transformation to (pq,rU)
    ! For coulomb (AB,TU), exchange case1,2 (AT,BU), case5,6 (TA,BU)

    if ((icc /= 0) .or. (icxc1 /= 0) .or. (icxc5 /= 0)) then
      ! (pq,rs) -> (pq,rU)
      call DGEMM_('T','N',NBR,NOCS,NBS,One,X2,NBS,CMO(LMOS2),NBS,Zero,X3,NBR)
      ! (pq,rU) Sorting
      if (IOUT2 > IPQMX2) then
        IOUT2 = 1
        call dDAFILE(LUHLF2,1,pqRU,IPQMX2*NORU,IAD2)
      end if
      call DCOPY_(NORU,X3,1,pqRU(IOUT2),IPQMX2)

      ! First half transformation to (pq,TU), if(ISR == ISS) then triangle
      ! (pq,rU) -> (pq,TU)
      if (icc /= 0) then
        if (ISR == ISS) then
          call DGEMM_Tri('T','N',NOCR,NOCR,NBR,One,X3,NBR,CMO(LMOR2),NBR,Zero,X2,NOCR)
        else
          call DGEMM_('T','N',NOCS,NOCR,NBR,One,X3,NBR,CMO(LMOR2),NBR,Zero,X2,NOCS)
        end if
        ! (pq,TU) Sorting
        if (IOUT3 > IPQMX3) then
          IOUT3 = 1
          call dDAFILE(LUHLF3,1,PQTU,IPQMX3*NOTU,IAD3)
        end if
        call DCOPY_(NOTU,X2,1,PQTU(IOUT3),IPQMX3)
      end if
    end if
  end do
end do
!  Store last buffer
if (IPQMX1 < NBPQ) then
  call dDAFILE(LUHLF1,1,pqUS,IPQMX1*NOUS,IAD1)
end if
if (IPQMX2 < NBPQ) then
  call dDAFILE(LUHLF2,1,pqRU,IPQMX2*NORU,IAD2)
end if
if (IPQMX3 < NBPQ) then
  call dDAFILE(LUHLF3,1,PQTU,IPQMX3*NOTU,IAD3)
end if

return

end subroutine tr2NsA1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine symelminp_cvb(rsymelm,nsyme,tags,izeta,mxirrep,mxorb,mxsyme,ityp)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nsyme, mxirrep, mxorb, mxsyme, ityp(mxorb)
real(kind=wp), intent(inout) :: rsymelm(mxorb,mxorb,nsyme)
character(len=3), intent(inout) :: tags(mxsyme)
integer(kind=iwp), intent(inout) :: izeta(*)
integer(kind=iwp) :: i, i_dim, iaux(1), io, iorb, irrep, isgn, istr2, jor, jorb, nread
real(kind=wp) :: daux(1)
integer(kind=iwp), allocatable :: tmp(:)
integer(kind=iwp), parameter :: ncmp = 4, nsign = 2, nsymelm = 5
character(len=*), parameter :: sgn(nsign) = ['+       ','-       '], &
                               symelm(nsymelm) = ['IRREPS  ','COEFFS  ','TRANS   ','END     ','ENDSYMEL']
logical(kind=iwp), external :: mxorth_cvb ! ... Matrices (orthogonal/determinant) ...

tags(nsyme) = ' '
call string_cvb(tags(nsyme),1,nread,1)
call fstring_cvb(sgn,nsign,isgn,ncmp,1)
if (isgn == 1) then
  izeta(nsyme) = 1
else if (isgn == 2) then
  izeta(nsyme) = -1
else
  izeta(nsyme) = 0
end if
call unitmat(rsymelm(:,:,nsyme),mxorb)

do
  call fstring_cvb(symelm,nsymelm,istr2,ncmp,2)
  if (istr2 == 1) then
    ! 'IRREPS'
    do i=1,mxirrep
      iaux = 0
      call int_cvb(iaux,1,nread,0)
      irrep = iaux(1)
      if (irrep /= 0) then
        do iorb=1,mxorb
          if (irrep == ityp(iorb)) rsymelm(iorb,iorb,nsyme) = -One
        end do
      end if
    end do
  else if (istr2 == 2) then
    ! 'COEFFS'
    do i=1,mxorb
      iaux = 0
      call int_cvb(iaux,1,nread,0)
      iorb = iaux(1)
      if (iorb /= 0) then
        rsymelm(iorb,iorb,nsyme) = -One
      else
        exit
      end if
    end do
  else if (istr2 == 3) then
    ! 'TRANS'
    iaux = 0
    call int_cvb(iaux,1,nread,0)
    i_dim = iaux(1)
    if ((i_dim < 1) .or. (i_dim > mxorb)) then
      write(u6,*) ' Illegal dimension in TRANS:',i_dim,mxorb
      call abend_cvb()
    end if
    call mma_allocate(tmp,i_dim,label='tmp')
    do i=1,i_dim
      call int_cvb(iaux,1,nread,0)
      iorb = iaux(1)
      if ((iorb < 1) .or. (iorb > mxorb)) then
        write(u6,*) ' Illegal orbital number in TRANS:',iorb
        call abend_cvb()
      end if
      tmp(i) = iorb
    end do
    do io=1,i_dim
      iorb = tmp(io)
      do jor=1,i_dim
        jorb = tmp(jor)
        daux = Zero
        call real_cvb(daux(1),1,nread,0)
        rsymelm(iorb,jorb,nsyme) = daux(1)
      end do
    end do
    call mma_deallocate(tmp)
  end if
  ! 'END' , 'ENDSYMEL' or unrecognized keyword -- end SYMELM input:
  if ((istr2 == 4) .or. (istr2 == 5) .or. (istr2 == 0)) exit
end do
if (.not. mxorth_cvb(rsymelm(:,:,nsyme),mxorb)) then
  write(u6,*) ' Symmetry element ',tags(nsyme),' not orthogonal!'
  write(u6,*) ' Check usage of TRANS keyword.'
  call abend_cvb()
end if

return

end subroutine symelminp_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
************************************************************************
*                                                                      *
*  Subroutine Shell_MxDens:   returns max density values for each      *
*                             shell pair...                            *
*                                                                      *
************************************************************************
      subroutine Shell_MxDens(Dens,DMax,nSkal)
c----------------------------------------------------------------------
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      dimension dmax(nskal,nskal),dens(*)
      ijoff=0
      call fzero(dmax,nskal*nskal)
      Do irp=0,nirrep-1
        ie=0
        Do iSh = 1, nSkal
          n=nbfshl(ish,irp)
          ia=ie+1
          ie=ie+n
          je=0
          Do jSh=1,iSh
            m=nbfshl(jsh,irp)
            ja=je+1
            je=je+m
            Do i=ia,ie
              ij=i*(i-1)/2+ja+ijoff
              Do j=ja,min(i,je)
                dmax(jsh,ish)=max(dmax(jsh,ish),abs(dens(ij)))
                ij=ij+1
              End Do
            End Do
          dmax(ish,jsh)=dmax(jsh,ish)
          End Do
        End Do
        ijoff=ijoff+ie*(ie+1)/2
      End Do
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Step3(iCenter,SMatrix,nDim,TMatrix,iType)
*                                                                      *
************************************************************************
*                                                                      *
*     Step 3. GS S2 ->S3
*
      Implicit ReaL*8 (A-H,O-Z)
      Real*8 SMatrix(nDim*nDim),TMatrix(nDim*nDim)
      Integer iCenter(nDim),iType(nDim)
#include "real.fh"
*
clg   write (*,*) 'Step 3', nDim
clg   Call RecPrt('T before GS 3',' ',TMatrix,nDim,nDim)
clg   write (*,*)
      call dcopy_(nDim**2,[Zero],0,TMatrix,1)
      call dcopy_(nDim,[One],0,TMatrix,nDim+1)
      Call GramSchmidt(SMatrix,TMatrix,nDim,iType,iCenter,1)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine Localise_Noniterative(irc,Model,xNrm)
! Author: T.B. Pedersen
!
! Purpose: Non-iterative localisation of orbitals.
!          Models implemented:
!            Cholesky [MODEL='CHOL']
!            PAO      [MODEL='PAO ']

use Localisation_globals, only: AnaPAO, CMO, nBas, nFro, nOrb, nOrb2Loc, nSym, Occ, Thrs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
character(len=4), intent(in) :: Model
real(kind=wp), intent(out) :: xNrm
integer(kind=iwp) :: idum(1), iSym, kOff1, kOffC, kSav, l_Dens, l_Dv, l_R, Lu_, nOrPs
real(kind=wp) :: dum(1), yNrm
character(len=80) :: Txt
character(len=6) :: Namefile
character(len=4) :: myModel
logical(kind=iwp) :: Normalize
real(kind=wp), allocatable :: Dens(:), Dv(:), DvSav(:), R(:)
logical(kind=iwp), parameter :: Test_OrthoPAO = .false.
character(len=*), parameter :: SecNam = 'Localise_Noniterative'
integer(kind=iwp), external :: isFreeUnit

irc = 0
xNrm = Zero

myModel = Model
call UpCase(myModel)
if (myModel == 'CHOL') then
  !if (.not. Silent) then
  write(u6,'(/,1X,A)') 'Cholesky localisation'
  write(u6,'(1X,A,1X,D12.4,A)') 'Convergence threshold:',Thrs,' (decomposition)'
  write(u6,'(1X,A,8(1X,I6))') 'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
  write(u6,'(1X,A,8(1X,I6))') 'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
  !end if
  l_Dens = nBas(1)**2
  do iSym=2,nSym
    l_Dens = max(l_Dens,nBas(iSym)**2)
  end do
  call mma_allocate(Dens,l_Dens,label='Dens')
  kOffC = 1
  do iSym=1,nSym
    if (nOrb2Loc(iSym) > 0) then
      kOff1 = kOffC+nBas(iSym)*nFro(iSym)
      call GetDens_Localisation(Dens,CMO(kOff1),nBas(iSym),nOrb2Loc(iSym))
      call ChoLoc(irc,Dens,CMO(kOff1),Thrs,yNrm,nBas(iSym),nOrb2Loc(iSym))
      xNrm = xNrm+yNrm*yNrm
      if (irc /= 0) then
        call mma_deallocate(Dens)
        irc = 1
        xNrm = -huge(xNrm)
        return
      end if
    end if
    kOffC = kOffC+nBas(iSym)**2
  end do
  xNrm = sqrt(xNrm)
  call mma_deallocate(Dens)
else if (myModel == 'PAO ') then
  !if (.not. Silent) then
  write(u6,'(/,1X,A)') 'PAO Cholesky localisation'
  write(u6,'(1X,A,1X,D12.4,A)') 'Convergence threshold:',Thrs,' (decomposition)'
  write(u6,'(1X,A,8(1X,I6))') 'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
  write(u6,'(1X,A,8(1X,I6))') 'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
  !end if
  l_Dv = nBas(1)**2
  l_R = nBas(1)**2
  do iSym=2,nSym
    l_R = l_R+nBas(iSym)**2
    l_Dv = max(l_Dv,nBas(iSym)**2)
  end do
  call mma_allocate(R,l_R,label='R')
  call mma_allocate(Dv,l_Dv,label='Dv')
  Normalize = .true.
  call GetRawPAOs(R,CMO,nBas,nOrb,nFro,nOrb2Loc,nSym,Normalize)
  if (AnaPAO) then
    call mma_allocate(DvSav,l_R,label='DvSav')
  end if
  kSav = 1
  kOffC = 1
  do iSym=1,nSym
    if (nOrb2Loc(iSym) > 0) then
      call GetDens_Localisation(Dv,R(kOffC),nBas(iSym),nBas(iSym))
      if (AnaPAO) then
        call dCopy_(nBas(iSym)**2,Dv,1,DvSav(kSav),1)
        kSav = kSav+nBas(iSym)**2
      end if
      kOff1 = kOffC+nBas(iSym)*nFro(iSym)
      call ChoLoc(irc,Dv,CMO(kOff1),Thrs,yNrm,nBas(iSym),nOrb2Loc(iSym))
      xNrm = xNrm+yNrm*yNrm
      if (irc /= 0) then
        if (AnaPAO) call mma_deallocate(DvSav)
        call mma_deallocate(R)
        call mma_deallocate(Dv)
        irc = 1
        xNrm = -huge(xNrm)
        return
      end if
    end if
    kOffC = kOffC+nBas(iSym)**2
  end do
  xNrm = sqrt(xNrm)
  if (AnaPAO) then
    call PAO_Analysis(DvSav,R,CMO)
    call mma_deallocate(DvSav)
  end if
  write(Namefile,'(A)') 'DPAORB'
  write(Txt,'(80X)')
  write(Txt,'(A)') 'Linearly dependent PAOs'
  Lu_ = isFreeUnit(11)
  call WrVec_Localisation(Namefile,Lu_,'CO',nSym,nBas,nBas,R,Occ,dum,idum,Txt)
  !if (.not. Silent) then
  write(u6,'(1X,A)') 'The DPAORB file has been written.'
  !end if
  write(Namefile,'(A)') 'IPAORB'
  write(Txt,'(80X)')
  write(Txt,'(A)') 'Linearly independent PAOs'
  Lu_ = isFreeUnit(11)
  call WrVec_Localisation(Namefile,Lu_,'CO',nSym,nBas,nBas,CMO,Occ,dum,idum,Txt)
  !if (.not. Silent) then
  write(u6,'(1X,A)') 'The IPAORB file has been written.'
  !end if
  call mma_deallocate(R)
  call mma_deallocate(Dv)
  nOrPs = 2 ! use 2 orthonorm. passes for num. accuracy
  call OrthoPAO_Localisation(CMO,nBas,nFro,nOrb2Loc,nSym,nOrPs,Test_OrthoPAO)
else
  write(Txt,'(A,A4)') 'Model = ',Model
  call SysAbendMsg(SecNam,'Unknown model',Txt)
end if

end subroutine Localise_Noniterative

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      Subroutine R1IBas
************************************************************************
*                                                                      *
*     purpose: Read basis set informations.                            *
*                                                                      *
*     called from: ReadIn                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
#include "mxdm.fh"
#include "infscf.fh"
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*
*---- read file header
      Call Get_cArray('Seward Title',Header,144)
*---- read number of symm. species
      Call Get_iScalar('nSym',nSym)
*---- read number of basis functions per symmetry species
      Call Get_iArray('nBas',nBas,nSym)
*---- read basis function labels
      nBas_tot=0
      Do iSym = 1, nSym
         nBas_tot=nBas_tot+nBas(iSym)
      End Do
      Call Get_cArray('Unique Basis Names',Name,(LENIN8)*nBas_tot)
*---- read number of atoms
      Call Get_iScalar('Unique atoms',nAtoms)
*---- read nuclear potential
*     Call get_dScalar('PotNuc',PotNuc)
      Call Peek_dScalar('PotNuc',PotNuc)
*
*---- Compute lengths of matrices
      lthBas = 0
      Do iSym = 1, nSym
         lthBas = lthBas + nBas(iSym)
      End Do
*
*---- Define atom and type
      Do i = 1, lthBas
         Atom(i) = Name(i)(1:LENIN)
         Type(i) = Name(i)(LENIN1:LENIN8)
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_CalculateGMat
*
*> @brief
*>   Calculate Cholesky \f$ G \f$ matrix (metric matrix)
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Calculate the metric matrix from Cholesky vectors (i.e. exact).
*>
*> \f[ G_{IJ} = \sum_{K=1}^{\min(I,J)} L_{IK} L_{JK} \f]
*>
*> The matrix is symmetric and stored on disk (file ``AVECXX``) in
*> triangular storage. The file is opened and closed in this
*> routine using routines ::DAName_MF_WA and ::DAClos, respectively
*> (i.e. \c FileName is opened as a word addressable multifile).
*> The calculation failed if \p irc is different from zero on exit.
*>
*> @note
*> This routine should *not* be used with DF.
*>
*> @param[out] irc Return code
************************************************************************
      SubRoutine Cho_X_CalculateGMat(irc)
      Implicit Real*8 (A-H,O-Z)
      Character*(6) FileName

#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      real*8 ddot_
      external ddot_
#endif

      Logical isDF

      Parameter (N2 = InfVec_N2)
      InfVcT(i,j,k)=iWork(ip_InfVec_T-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
      InfVec(i,j,k)=iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
      NVT(i)=iWork(ip_NVT-1+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
      iRS2RS(i)=iWork(ip_iRS2RS-1+i)

C     Set return code.
C     ----------------

      irc = 0

C     Refuse to perform calculation for DF.
C     -------------------------------------

      Call DecideOnDF(isDF)
      If (isDF) Then
         irc = -1
         Return
      End If


C     Scratch location in index arrays.
C     ---------------------------------

      iLoc = 3 ! do NOT change (used implicitly by reading routine)

C     Create memory pointer for flushing memory.
C     ------------------------------------------

      l_Flush = 1
      Call GetMem('FLUSH','Allo','Inte',ip_Flush,l_Flush)

C     Get pointer to InfVec array for all vectors (needed for parallel
C     runs) and the total number of vectors.
C     ----------------------------------------------------------------

      l_NVT = nSym
      Call GetMem('NVT','Allo','Inte',ip_NVT,l_NVT)
      Call Cho_CGM_InfVec(ip_InfVec_T,iWork(ip_NVT),l_NVT)

C     Copy rs1 to location 2.
C     -----------------------

      Call Cho_X_RSCopy(irc,1,2)
      If (irc .ne. 0) Then
         irc = 1
         Go To 1 ! exit after deallocation
      End If

C     Calculate triangular G matrix.
C     G(IJ)=sum_K L(I,K)*L(J,K).
C     ------------------------------

      iRedC = -1
      Do iSym = 1,nSym

C        Open file.
C        ----------

         Write (FileName,'(A4,I2.2)') 'AVEC',iSym-1
         lUnit = 7
         Call DAName_MF_WA(lUnit,FileName)
         iDisk=0

         l_iRS2RS = nnBstR(iSym,1)
         l_G = NVT(iSym)*(NVT(iSym)+1)/2
         Call GetMem('RS-TO-RS','Allo','Inte',ip_iRS2RS,l_iRS2RS)
         Call GetMem('G','Allo','Real',ip_G,l_G)
         Call GetMem('MX','Max ','Real',ip_Wrk,l_Wrk)
         Call GetMem('Wrk','Allo','Real',ip_Wrk,l_Wrk)
         Call fZero(Work(ip_G),l_G)
         Call iZero(iWork(ip_iRS2RS),l_iRS2RS)
         idRS2RS = -2
         kOffG = ip_G - 1
         KK1 = 1
         Do While (KK1 .le. NumCho(iSym))
            nVRead = 0
            mUsed = 0
            Call Cho_X_VecRd(Work(ip_Wrk),l_Wrk,KK1,NumCho(iSym),iSym,
     &                       nVRead,iRedC,mUsed)
            If (nVRead .lt. 1) Then
               irc = 2
               Go To 1 ! exit after deallocation
            End If
            kOffV = ip_Wrk - 1
            Do KKK = 0,nVRead-1
               KK = KK1 + KKK
               iRed = InfVec(KK,2,iSym)
               If (iRedC .ne. iRed) Then
                  Call Cho_X_SetRed(irc,iLoc,iRed)
                  If (irc .ne. 0) Then
                     irc = 3
                     Go To 1 ! exit after deallocation
                  End If
                  iRedC = iRed
               End If
               If (idRS2RS .ne. iRedC) Then
                  Call Cho_RS2RS(iWork(ip_iRS2RS),l_iRS2RS,
     &                           2,iLoc,iRedC,iSym)
                  idRS2RS = iRedC
               End If
               K = InfVec(KK,5,iSym)
               Do J = K,NVT(iSym)
                  iJ = iRS2RS(InfVcT(J,1,iSym)-iiBstR(iSym,1))
                  V_J = Work(kOffV+iJ)
                  Do I = K,J
                     iI = iRS2RS(InfVcT(I,1,iSym)-iiBstR(iSym,1))
                     kG_IJ = kOffG + iTri(I,J)
                     Work(kG_IJ) = Work(kG_IJ) + Work(kOffV+iI)*V_J
                  End Do
               End Do
               kOffV = kOffV + nnBstR(iSym,iLoc)
            End Do
            KK1 = KK1 + nVRead
         End Do
         Call Cho_GADGOP(Work(ip_G),l_G,'+')
         iOpt = 1
         Call DDAFile(lUnit,iOpt,Work(ip_G),l_G,iDisk)
#if defined (_DEBUGPRINT_)
         Call TriPrt('G-matix',' ',Work(ip_G),NVT(iSym))
         Write(6,'(A,I2,A,1P,D16.7)')
     &   'G matrix, sym.',iSym,': Norm = ',
     &   sqrt(dDot_(l_G,Work(ip_G),1,Work(ip_G),1))
#endif
         Call GetMem('Wrk','Free','Real',ip_Wrk,l_Wrk)
         Call GetMem('G','Free','Real',ip_G,l_G)
         Call GetMem('RS-TO-RS','Free','Inte',ip_iRS2RS,l_iRS2RS)

C        Close file
C        ----------
         Call DAClos(lUnit)
      End Do

C     Flush memory, close file, and exit.
C     -----------------------------------

    1 Continue
      Call GetMem('FLUSH','Flush','Inte',ip_Flush,l_Flush)
      Call GetMem('FLUSH','Free','Inte',ip_Flush,l_Flush)

      End
C
C**********************************************************************C
C
      SubRoutine Cho_CGM_InfVec(ip_InfVec_T,NVT,n)
      Implicit None
      Integer ip_InfVec_T
      Integer n
      Integer NVT(n)

      Call Cho_X_GetIP_InfVec(ip_InfVec_T)
      Call Cho_X_GetTotV(NVT,n)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine Start2(FName,LuOrb,CMO,mBB,nD,Ovrlp,mBT,
     &                  EOrb,OccNo,mmB)
************************************************************************
*                                                                      *
*     purpose: Get starting orbitals INPORB                            *
*                                                                      *
*     called from: SOrb                                                *
*                                                                      *
*     calls to: Ortho                                                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "file.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
#  include "mh5.fh"
#endif
      Real*8 CMO(mBB,nD), Ovrlp(mBT), EOrb(mmB,nD), OccNo(mmB,nD)
      Character FName*(*)
      Integer nTmp(8)
      Character*6 OrbName
* Pam 2012 Changed VECSORT arg list, need dummy array:
      Integer NewOrd(2)
      Integer, Dimension(:,:), Allocatable:: IndT
#ifdef _MSYM_
      Real*8 msym_ctx
#endif
      Dimension Dummy(1),iDum(7,8)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*---- Read vectors (vectors MUST !!!!! be written in symmetry blocks
*     of dimension nBas(i)*nBas(i))
*
      Call mma_allocate(IndT,nnB,nD,Label='IndT')
*
      Lu_=LuOrb
      nD = iUHF + 1
      If(iUHF.eq.0) Then
         If (isHDF5) Then
            Call RdVec_HDF5(fileorb_id,'COEI',nSym,nBas,
     &                      CMO,OccNo,EOrb,IndT)
         Else
            Call RdVec_(FName,Lu_,'COEI',iUHF,nSym,nBas,nOrb,
     &                  CMO,Dummy,
     &                  OccNo,Dummy,
     &                  EOrb(1,1),Dummy,
     &                  IndT(1,1),VTitle,1,iErr,iWFtype)
         End If
         Call VecSort(nSym,nBas,nBas,
     &               CMO,OccNo,IndT(1,1),0,NewOrd,iErr)
         indx=1
         Do iSym=1,nSym
            nTmp(iSym)=0
            Do iBas=1,nBas(iSym)
               If(IndT(indx,1).eq.7) nTmp(iSym)=nTmp(iSym)+1
               indx=indx+1
            End Do
            If(nOrb(iSym).gt.nBas(iSym)-nTmp(iSym)) Then
               nOrb(iSym)=nBas(iSym)-nTmp(iSym)
               nDel(iSym)=nTmp(iSym)
            End If
         End Do
         Call TrimCMO(CMO,CMO,nSym,nBas,nOrb)
         Call TrimEor(EOrb(1,1),EOrb(1,1),nSym,nBas,nOrb)

         Call Setup
         If(.not.Aufb .and. .not.OnlyProp) Then
            iOff=0
            Do iSym=1,nSym
               Do iOrb=1,nOcc(iSym,1)
                  OccNo(iOrb+iOff,1)=2.0d0
               End Do
               Do iOrb=nOcc(iSym,1)+1,nOrb(iSym)
                  OccNo(iOrb+iOff,1)=0.0d0
               End Do
               iOff=iOff+nOrb(iSym)
            End Do
         End If
      Else
         If (isHDF5) Then
            isUHF=0
#ifdef _HDF5_
            If (mh5_exists_dset(fileorb_id,'MO_ALPHA_VECTORS')) isUHF=1
#endif
         Else
            Call Chk_Vec_UHF(FNAME,Lu_,isUHF)
         End If
         If(isUHF.eq.1) Then
            If (isHDF5) Then
              Call RdVec_HDF5(fileorb_id,'COEIA',nSym,nBas,
     &                        CMO(1,1),OccNo(1,1),EOrb(1,1),IndT(1,1))
              Call RdVec_HDF5(fileorb_id,'COEIB',nSym,nBas,
     &                        CMO(1,2),OccNo(1,2),EOrb(1,2),IndT(1,2))
            Else
               Call RdVec_(FName,Lu_,'COEI',iUHF,nSym,nBas,nOrb,
     &                     CMO(1,1),CMO(1,2),
     &                     OccNo(1,1),OccNo(1,2),
     &                     EOrb(1,1),EOrb(1,2),
     &                     IndT(1,1),VTitle,1,iErr,iWFtype)
               Call iCopy(nnB,IndT(1,1),1,IndT(1,2),1)
            End If
            Call VecSort(nSym,nBas,nBas,CMO(1,1),OccNo(1,1),
     &                   IndT(1,1),0,NewOrd,iErr)
            Call VecSort(nSym,nBas,nBas,CMO(1,2),OccNo(1,2),
     &                   IndT(1,2),0,NewOrd,iErr)
            indx=1
            Do iSym=1,nSym
               nTmp(iSym)=0
               Do iBas=1,nBas(iSym)
                  If(IndT(indx,1).eq.7) nTmp(iSym)=nTmp(iSym)+1
                  indx=indx+1
               End Do
               If(nOrb(iSym).gt.nBas(iSym)-nTmp(iSym)) Then
                  nOrb(iSym)=nBas(iSym)-nTmp(iSym)
                  nDel(iSym)=nTmp(iSym)
               End If
            End Do
            Call TrimCMO(CMO(1,1),CMO(1,1),nSym,nBas,nOrb)
            Call TrimEor(EOrb(1,1),EOrb(1,2),nSym,nBas,nOrb)
            Call TrimCMO(CMO(1,2),CMO(1,2),nSym,nBas,nOrb)
            Call TrimEor(EOrb(1,2),EOrb(1,2),nSym,nBas,nOrb)
            Call Setup
         Else
            If (isHDF5) Then
              Call RdVec_HDF5(fileorb_id,'COEI',nSym,nBas,
     &                        CMO,OccNo,EOrb,IndT)
            Else
               Call RdVec_(FName,Lu_,'COEI',0,nSym,nBas,nOrb,
     &                     CMO,Dummy,
     &                     OccNo,Dummy,
     &                     EOrb(1,1),Dummy,
     &                     IndT(1,1),VTitle,1,iErr,iWFtype)
            End If
            Call VecSort(nSym,nBas,nBas,CMO,OccNo,
     &                   IndT(1,1),0,NewOrd,iErr)
            indx=1
            Do iSym=1,nSym
               nTmp(iSym)=0
               Do iBas=1,nBas(iSym)
                  If(IndT(indx,1).eq.7) nTmp(iSym)=nTmp(iSym)+1
                  indx=indx+1
               End Do
               If(nOrb(iSym).gt.nBas(iSym)-nTmp(iSym)) Then
                  nOrb(iSym)=nBas(iSym)-nTmp(iSym)
                  nDel(iSym)=nTmp(iSym)
               End If
            End Do
            Call TrimCMO(CMO,CMO,nSym,nBas,nOrb)
            Call TrimEor(EOrb(1,1),EOrb(1,1),nSym,nBas,nOrb)
            Call Setup
            Call dCopy_(nBO,CMO(1,1),1,CMO(1,2),1)
            Call dCopy_(nnB,OccNo(1,1),1,OccNo(1,2),1)
            Call dCopy_(nnB,EOrb(1,1),1,EOrb(1,2),1)
            Call dScal_(nnB,0.5d0,OccNo(1,1),1)
            Call dScal_(nnB,0.5d0,OccNo(1,2),1)
         End If
         If(.not.Aufb) Then
            iOff=0
            Do iSym=1,nSym
               Do iOrb=1,nOcc(iSym,1)
                  OccNo(iOrb+iOff,1)=1.0d0
               End Do
               Do iOrb=nOcc(iSym,1)+1,nOrb(iSym)
                  OccNo(iOrb+iOff,1)=0.0d0
               End Do
               iOff=iOff+nOrb(iSym)
            End Do
            iOff=0
            Do iSym=1,nSym
               Do iOrb=1,nOcc(iSym,2)
                  OccNo(iOrb+iOff,2)=1.0d0
               End Do
               Do iOrb=nOcc(iSym,2)+1,nOrb(iSym)
                  OccNo(iOrb+iOff,2)=0.0d0
               End Do
               iOff=iOff+nOrb(iSym)
            End Do
         End If
      End If
      If(Allocated(IndT)) Call mma_deallocate(IndT)
*
      If (MSYMON) Then
#ifdef _MSYM_
         Write(6,*) 'Symmetrizing start orbitals'
         Call fmsym_create_context(msym_ctx)
         Call fmsym_set_elements(msym_ctx)
         Call fmsym_find_symmetry(msym_ctx)
         Do iD = 1, nD
            Call fmsym_symmetrize_orbitals(msym_ctx,CMO(1,iD))
         End Do
#else
         Write(6,*) 'No msym support, skipping symmetrization '
     $           //'of start orbitals...'
#endif
      End If
*
      Do iD = 1, nD
         Call Ortho(CMO(1,iD),nBO,Ovrlp,nBT)
      End Do
*
#ifdef _MSYM_
      If (MSYMON) Then
         Call fmsym_release_context(msym_ctx)
      End If
#endif
*
* Dump orbitals
*
      If(iUHF.eq.0) then
         OrbName='SCFORB'
         Call WrVec_(OrbName,LuOut,'COE',iUHF,nSym,nBas,nBas,
     &               CMO,Dummy,OccNo,Dummy,
     &               EOrb(1,1),Dummy,iDum,VTitle,iWFtype)
      Else
         OrbName='UHFORB'
         Call WrVec_(OrbName,LuOut,'COE',iUHF,nSym,nBas,nBas,
     &               CMO(1,1),CMO(1,2),OccNo(1,1),OccNo(1,2),
     &               EOrb(1,1),EOrb(1,2),iDum,VTitle,iWFtype)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Markus P. Fuelscher                              *
!               1991, Per Ake Malmqvist                                *
!***********************************************************************

subroutine MkSrt2()
!***********************************************************************
!                                                                      *
!     Purpose: Initialize counters and offsets required                *
!              for bin sorting algorithm                               *
!                                                                      *
!     Called from: Sort1                                               *
!                                                                      *
!     Calls to : none                                                  *
!                                                                      *
!     Calling parameters: none                                         *
!                                                                      *
!*** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****

use sort_data, only: iDIBin, iDVBin, mSyBlk, n_Int, nRec, nSln
use Definitions, only: iwp, u6

implicit none
#include "print.fh"
integer(kind=iwp) :: iBin, iPrint, iRout, iSlice, iSyBlk, nSlice

iRout = 80
iPrint = nPrint(iRout)
if (iPrint > 10) write(u6,*) ' >>> Enter MKSRT2 <<<'

!----------------------------------------------------------------------*
!     initialize various pointers, counters and disk adresses          *
!----------------------------------------------------------------------*

iBin = 0
do iSyBlk=1,mSyBlk
  nSlice = nSln(iSyBlk)
  if (nSlice /= 0) then
    do iSlice=1,nSlice
      iBin = iBin+1
      iDIBin(2,iBin) = -1
      iDVBin(2,iBin) = -1
      iDVBin(3,iBin) = -1
      iDVBin(4,iBin) = -1
      n_Int(iBin) = 0
      nRec(iBin) = 0
    end do
  end if
end do

return

end subroutine MkSrt2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_X_Init_Par(irc,isDF)
C
C     Purpose: setup for parallel Cholesky/DF.
C
      Implicit None
      Integer irc
      Logical isDF

      If (isDF) Then
         Call Cho_X_Init_Par_DF(irc)
      Else
         Call Cho_X_Init_Par_GenBak()
         Call Cho_X_Init_Par_Cho(irc)
      End If

      End
      SubRoutine Cho_X_Init_Par_DF(irc)
C
C     Purpose: setup for parallel DF.
C
#if defined (_MOLCAS_MPP_)
      Use Para_Info, Only: MyRank, nProcs, Is_Real_Par
#endif
      Implicit None
      Integer irc

      Character(LEN=17), Parameter:: SecNam = 'Cho_X_Init_Par_DF'

#if defined (_DEBUGPRINT_)
      Logical, Parameter:: LocDbg = .True.
#else
      Logical, Parameter:: LocDbg = .False.
#endif

#if defined (_MOLCAS_MPP_)
#include "cholesky.fh"
      Integer nV(8)
      Integer iSym
      Logical isSerial

      irc = 0

C     Return if serial.
C     -----------------

      isSerial = nProcs.eq.1 .or. .not.Is_Real_Par()
      If (isSerial) Then
         If (LocDbg) Then
            Write(6,*) SecNam,': serial run, nothing to do...'
            Write(6,*) '#nodes: ',nProcs,'  myRank: ',myRank
         End If
         Return
      Else
         If (LocDbg) Then
            Write(6,*) SecNam,': parallel run...'
            Write(6,*) '#nodes: ',nProcs,'  myRank: ',myRank
         End If
      End If

C     Reset number of vectors to the number on this node as stored on
C     the runfile.
C     ---------------------------------------------------------------

      Call iCopy(nSym,NumCho,1,nV,1)
      Call Get_iArray('nVec_RI',NumCho,nSym)
      NumChT = NumCho(1)
      Do iSym = 2,nSym
         NumChT = NumChT + NumCho(iSym)
      End Do

C     Debug print.
C     ------------

      If (LocDbg) Then
         Write(6,*)
         Write(6,*) 'Output from ',SecNam,':'
         Write(6,*) 'NumCho before: ',(nV(iSym),iSym=1,nSym)
         Write(6,*) 'NumCho after : ',(NumCho(iSym),iSym=1,nSym)
      End If

#else

      irc = 0
      If (LocDbg) Then
         Write(6,*) SecNam,': serial run, nothing to do...'
      End If

#endif

      End
      SubRoutine Cho_X_Init_Par_Cho(irc)
C
C     Purpose: setup for parallel Cholesky.
C
#if defined (_MOLCAS_MPP_)
      Use Para_Info, Only: MyRank, nProcs, Is_Real_Par
      use ChoSwp, only: InfVec
#endif
      Implicit None
      Integer irc

      Character(LEN=18), Parameter:: SecNam = 'Cho_X_Init_Par_Cho'

#if defined (_DEBUGPRINT_)
      Logical, Parameter:: LocDbg = .True.
#else
      Logical, Parameter:: LocDbg = .False.
#endif

#if defined (_MOLCAS_MPP_)
#include "cholesky.fh"
#include "stdalloc.fh"

      Integer nV(8)
      Integer iSym, i, j
      Logical isSerial


      Integer, Allocatable:: IDV(:), myInfV(:)

      irc = 0

C     Return if serial.
C     -----------------

      isSerial = nProcs.eq.1 .or. .not.Is_Real_Par()
      If (isSerial) Then
         If (LocDbg) Then
            Write(6,*) SecNam,': serial run, nothing to do...'
            Write(6,*) '#nodes: ',nProcs,'  myRank: ',myRank
         End If
         Return
      Else
         If (LocDbg) Then
            Write(6,*) SecNam,': parallel run...'
            Write(6,*) '#nodes: ',nProcs,'  myRank: ',myRank
         End If
      End If

C     Reset vector info to fit vectors stored on this node.
C     -----------------------------------------------------

      Do iSym = 1,nSym
         nV(iSym) = 0
         If (NumCho(iSym) .gt. 0) Then
            Call mma_allocate(IDV,NumCho(iSym),Label='IDV')
            Call Cho_Distrib_Vec(1,NumCho(iSym),IDV,nV(iSym))
            If (nV(iSym) .gt. 0) Then
               Call mma_allocate(myInfV,nV(iSym),Label='myInfV')
               Do j = 1,SIZE(InfVec,2)
                  If (j .ne. 3) Then
                     Do i = 1,nV(iSym)
                        myInfV(i) = InfVec(IDV(i),j,iSym)
                     End Do
                     InfVec(:,j,iSym) = myInfV(:)
                  End If
               End Do
               Call mma_deallocate(myInfV)
            End If
            Call mma_deallocate(IDV)
         End If
      End Do

C     Reset number of vectors.
C     ------------------------

      Call iSwap(nSym,NumCho,1,nV,1)
      NumChT = NumCho(1)
      Do iSym = 2,nSym
         NumChT = NumChT + NumCho(iSym)
      End Do

C     Debug print.
C     ------------

      If (LocDbg) Then
         Write(6,*)
         Write(6,*) 'Output from ',SecNam,':'
         Write(6,*) 'NumCho before: ',(nV(iSym),iSym=1,nSym)
         Write(6,*) 'NumCho after : ',(NumCho(iSym),iSym=1,nSym)
      End If

#else

      irc = 0
      If (LocDbg) Then
         Write(6,*) SecNam,': serial run, nothing to do...'
      End If

#endif

      End
      SubRoutine Cho_X_Init_Par_GenBak()
      Use Para_Info, Only: Is_Real_Par
      use ChoSwp, only: InfVec, InfVec_Bak
      Implicit None
#include "cholesky.fh"
#include "chpari.fh"
#include "stdalloc.fh"

      NumCho_Bak(:)=0
      If (Is_Real_Par()) Then
         Call mma_allocate(InfVec_Bak,SIZE(InfVec,1),SIZE(InfVec,2),
     &                     SIZE(InfVec,3),Label='InfVec_Bak')
         InfVec_Bak(:,:,:)=InfVec(:,:,:)
         NumCho_Bak(1:nSym)=NumCho(1:nSym)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015,2016, Valera Veryazov                             *
************************************************************************
            Subroutine Append_file(iUnit)
            iset=0
            rewind(iUnit)
10          read(iUnit,*,err=20,end=20)
            iset=iset+1
            goto 10
20          rewind(iUnit)
            do i=1,iset
            read(iUnit,*)
            enddo
            return
            end
c same for unformatted files
            Subroutine Append_file_u(iUnit)
            iset=0
            rewind(iUnit)
10          read(iUnit,err=20,end=20)
            iset=iset+1
            goto 10
20          rewind(iUnit)
            do i=1,iset
            read(iUnit)
            enddo
            return
            end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine espf_grad (natom,nGrdPt,ipExt,ipGrid,ipB,ipDB,
     &                      ipIsMM,ipGradCl,DoTinker,DoGromacs)
      Implicit Real*8 (A-H,O-Z)
*
*     Gradient due to the external potential
*
#include "espf.fh"
#include "stdalloc.fh"
*
#include "disp.fh"
#include "nac.fh"
      Logical Exist,lMMHess,lMMGrd,DoTinker,DoGromacs,isNAC_tmp
      Character*180 Line
      Character*180 Get_Ln
      External Get_Ln
      Dimension FX(4)
      Dimension opnuc(1)
      Real*8, Allocatable:: Grad(:,:)
*
      iPL = iPL_espf()
*
      Call mma_allocate(Grad,3,nAtom,Label='Grad')
      nGrad=3*nAtom
      Call Get_Grad(Grad,nGrad)
      lMMHess = .False.
      If (iPL.ge.3) Call PrGrad(' Molecular gradients, entering ESPF',
     &                          Grad,lDisp(0),ChDisp)
*
*     Recover MM gradient and hessian, if any, in QMMM file
*
      Call F_Inquire('QMMM',Exist)
      natMM = 0
      If (((Exist.and.DoTinker).or.DoGromacs).and. .not.isNAC) Then
         Call Allocate_Work(ipMMGrd,6*natom)
         Call Qpg_dArray('MM Grad',lMMGrd,6*natom)
         If (lMMGrd) Then
            Call Get_dArray('MM Grad',Work(ipMMGrd),6*natom)
            call dcopy_(3*natom,Work(ipMMGrd+3*natom),1,Work(ipMMGrd),1)
            call dcopy_(3*natom,[Zero],0,Work(ipMMGrd+3*natom),1)
         Else
            call dcopy_(6*natom,[Zero],0,Work(ipMMGrd),1)
         End If
      End If
*
      If (Exist .and. DoTinker .and. .not.isNAC) Then
         Call GetMem('Hess','Allo','Real',ipHC,3*natom*(3*natom+1)/2)
         call dcopy_((3*natom*(3*natom+1)/2),[Zero],0,Work(ipHC),1)
      End If
*
      If (Exist .and. DoTinker .and. .not.isNAC) Then
         ITkQMMM=IsFreeUnit(15)
         Call Molcas_Open(ITkQMMM,'QMMM')
         Line = ' '
         Do While (Index(Line,'TheEnd ') .eq. 0)
            Line=Get_Ln(ITkQMMM)
            If (Index(Line,'NMM').ne.0) Then
               Call Get_I1(2,natMM)
            Else If (Index(Line,'MMGradient').ne.0) Then
               Call Get_I1(2,iAtom)
               Call Get_F(3,FX,3)
               Do iXYZ = 0, 2
                  iOff = (iAtom-1)*3+iXYZ
                  Work(ipMMGrd+3*natom+iOff) = FX(iXYZ+1) * Angstrom
     &                                                    * ToHartree
                  Grad(iXYZ+1,iAtom) = Grad(iXYZ+1,iAtom)
     &                              + Work(ipMMGrd+3*natom+iOff)
               EndDo
            Else If (Index(Line,'MMHDiag').ne.0) Then
               lMMHess = .True.
               Call Get_I1(2,iAtom)
               Call Get_F(3,FX,3)
               Do iXYZ = 1, 3
                  Work(ipHC+LHR(iXYZ,iAtom,iXYZ,iAtom)-1) = FX(iXYZ)
     &                              * Angstrom * Angstrom * ToHartree
               EndDo
            Else If (Index(Line,'MMHOff').ne.0) Then
               lMMHess = .True.
               Call Get_I1(2,iAtom)
               Call Get_I1(3,iXYZ)
               Call Get_I1(4,iNumb)
c            Write (6,*) 'HOff read ',iAtom,iXYZ,iNumb
               iCur = 0
               jAtom = iAtom
               jXYZ = iXYZ
51             iStep = Min(4,iNumb-iCur)
               Line = Get_Ln(ITkQMMM)
               Call Get_F(1,FX,iStep)
c            Write (6,'(A,4f10.5)') 'HOff read ',(FX(j),j=1,iStep)
               Do iBla = 1, iStep
                  jXYZ = jXYZ + 1
                  If (jXYZ.eq.4) Then
                     jXYZ = 1
                     jAtom = jAtom + 1
                     If (jAtom.gt.natom) Call Abend
                  End If
                  Work(ipHC+LHR(iXYZ,iAtom,jXYZ,jAtom)-1) = FX(iBla)
     &                             * Angstrom * Angstrom * ToHartree
               End Do
               iCur = iCur + 4
               If (iCur.lt.iNumb) goto 51
            End If
         End Do
         Close (ITkQMMM)
      End If
*
      If (DoGromacs .and. .not.isNAC) Then
         Call dcopy_(3*natom,Work(ipGradCl),1,Work(ipMMGrd+3*natom),1)
         Do iAtom = 1, nAtom
            Do ixyz = 1, 3
               i = ixyz + 3*(iAtom-1) - 1
               Grad(ixyz,iAtom)=Grad(ixyz,iAtom)+Work(ipMMGrd+3*natom+i)
            End Do
         End Do
      End If
*
      If (((Exist.and.DoTinker).or.DoGromacs) .and. .not.isNAC) Then
         If (iPL.ge.4) Then
            Call RecPrt('Old MM Grad:',' ',Work(ipMMGrd),3,natom)
            Call RecPrt('New MM Grad:',' ',Work(ipMMGrd+3*natom),3,
     &                  natom)
         End If
         If (natMM.gt.0) Call Put_dArray('MM Grad',Work(ipMMGrd),
     &                                   6*natom)
         Call Free_Work(ipMMGrd)
      End If
*
      If (Exist.and.DoTinker .and. .not.isNAC) Then
         If (lMMHess .and. iPL.ge.4)
     &      Call TriPrt(' In ESPF_grad: MM Hessian','(12f12.7)',
     &      Work(ipHC),3*natom)
         If (lMMHess) Call Put_dArray('MMHessian',Work(ipHC),
     &                                3*natom*(3*natom+1)/2)
         Call GetMem('Hess','Free','Real',ipHC,3*natom*(3*natom+1)/2)
      End If
*
      If (((Exist.and.DoTinker).or.DoGromacs) .and. .not.isNAC) Then
         Call Put_iScalar('No of Internal coordinates',3*natom)
         If (iPL.ge.3) Call PrGrad(' Molecular gradients, after MM',
     &                          Grad,lDisp(0),ChDisp)
      End If
*
*     External field acting on nuclear charges
*
      If (isNac) Then
         Write(6,*) 'ESPF: Skipping nuclear-external field contribution'
      Else
         Call GetMem('XCharge','Allo','Real',ipXC,nAtom)
         Call Get_dArray('Effective nuclear Charge',Work(ipXC),nAtom)
         Do iAt = 1, nAtom
            iCurXC = ipXC+iAt-1
            iCurE = ipExt+(iAt-1)*MxExtPotComp
            Grad(1,iAt)=Grad(1,iAt) + Work(iCurXC)*Work(iCurE+1)
            Grad(2,iAt)=Grad(2,iAt) + Work(iCurXC)*Work(iCurE+2)
            Grad(3,iAt)=Grad(3,iAt) + Work(iCurXC)*Work(iCurE+3)
         EndDo
         Call GetMem('XCharge','Free','Real',ipXC,natom)
         If (iPL.ge.3) Call PrGrad(' Molecular grad, after nuc ESPF',
     &                             Grad,lDisp(0),ChDisp)
      End If
*
*     Here I need the integral derivatives, weighted by B and contracted
*     with the density matrix: B * Sum_mu,nu P_mu,nu*d/dq(<mu|1/R_grid|nu>)
*
*     Basically, it should work like the following lines ... but it can't now.
*
*      opnuc = Dum
*      ncmp = 3
*      iAddPot = -1
*      Call GetMem('dESPF1','Allo','Real',ipD1,nGrdPt*natom*3)
*      Call DrvPot(Work(ipGrid),opnuc,ncmp,Work(ipD1),nGrdPt,iAddPot)
*      Call GetMem('dESPF1','Free','Real',ipD1,nGrdPt*natom*3)
*
*     Now I try another thing, following the way derivatives with respect to point
*     charges are computed in alaska. I just copied 2 files from alaska: drvh1 and
*     xfdgrd then renamed them drvespf and bdvgrd.

      Call GetMem('Temp','Allo','Real',ipTemp,3*natom)
      Call GetMem('GridInfo','Allo','Real',ipGrdI,4*nGrdPt)
*     Need to save isNAC here because Prepare calling inisew calling init_seward which resets isNAC .to False.
      isNAC_tmp = isNAC
      Call Prepare(nGrdPt,ipGrid,ipB,ipGrdI)
      Call Drvespf(Grad,Work(ipTemp),3*natom,Work(ipGrdI))
      Call GetMem('GridInfo','Free','Real',ipGrdI,4*nGrdPt)
      If (iPL.ge.3) Call PrGrad(' Molecular gradients, after P*B*dV',
     &                          Grad,lDisp(0),ChDisp)
      Call GetMem('Temp','Free','Real',ipTemp,3*natom)
*
*     Here I need the integrals contracted with the density matrix and weighted
*     by the derivatives of B: dB/dq * Sum_mu,nu P_mu,nu*(<mu|1/R_grid|nu>)
*
      opnuc = Dum
      ncmp = 1
      iAddPot = -1
      Call GetMem('dESPF2','Allo','Real',ipD2,nGrdPt)
      Call DrvPot(Work(ipGrid),opnuc,ncmp,Work(ipD2),nGrdPt,iAddPot)
      If (iPL.ge.4) Then
         Write(6,'(/,A,/)') ' PV = '
         Do iPnt = 1, nGrdPt
            Write(6,*) Work(ipD2+iPnt-1)
         EndDo
      End If
      iQM = 0
      Do iAt = 1, natom
         If (iWork(ipIsMM+iAt-1).eq.1) Goto 10
         iQM = iQM + 1
         Do jPnt = 1, NGrdPt
            iCurDB1 = ipDB + (jPnt-1)+((iQM-1)*3+0)*nGrdPt
            iCurDB2 = ipDB + (jPnt-1)+((iQM-1)*3+1)*nGrdPt
            iCurDB3 = ipDB + (jPnt-1)+((iQM-1)*3+2)*nGrdPt
            iCurI  = ipD2 + jPnt-1
            Grad(1,iAt)=Grad(1,iAt) + Work(iCurDB1)*Work(iCurI)
            Grad(2,iAt)=Grad(2,iAt) + Work(iCurDB2)*Work(iCurI)
            Grad(3,iAt)=Grad(3,iAt) + Work(iCurDB3)*Work(iCurI)
         EndDo
10       Continue
      EndDo
      isNAC = isNAC_tmp
*
*     Apply Morokuma's scheme if needed
*
      If ((Exist.and.DoTinker).or.DoGromacs) Call LA_Morok(natom,Grad,1)
*
*     Finally
*
      Call Put_Grad(Grad,3*natom)
      Call GetMem('dESPF2','Free','Real',ipD2,nGrdPt)
      If (iPL.ge.2) Call PrGrad(' Molecular gradients, after ESPF',
     &                          Grad,lDisp(0),ChDisp)
      Call Add_Info('Grad',Grad,3*natom,6)
      Call mma_deallocate(Grad)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FMOVE_CVB(IA,IB,N)
C      INTEGER    N
C      REAL*8     IA(N),IB(N)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8      IA,IB
      DIMENSION   IA(*),IB(*)
#include "SysDef.fh"

C      CALL DCOPY_(N*RtoI,IA,1,IB,1)
      DO I=1,N*RtoI
         IB(I)=IA(I)
      END DO

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
C
      SUBROUTINE TRADD_CPF(A,B,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(N,N),B(*)
      IN=0
      DO 10 I=1,N
      DO 20 J=1,I
      IN=IN+1
      B(IN)=B(IN)+A(I,J)-A(J,I)
20    CONTINUE
10    CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_GetVec
*
*> @brief
*>   Read Cholesky vectors
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Read Cholesky vectors \c iVec = \p iVec1, ...., \p iVec1+NumVec-1
*> of symmetry \p  iSym from file. The vectors are returned
*> in the reduced set storage defined by reduced set index array
*> location ``2``.
*>
*> @param[out] ChoVec Cholesky vectors
*> @param[in]  LenVec vector dimension
*> @param[in]  NumVec number of vectors to read
*> @param[in]  iVec1  first vector to read
*> @param[in]  iSym   vector symmetry
*> @param[in]  Scr    scratch array for read
*> @param[in]  lScr   dimension of \p Scr array
************************************************************************
      Subroutine Cho_X_GetVec(ChoVec,LenVec,NumVec,iVec1,iSym,Scr,lScr)
      Implicit None
      Integer LenVec, NumVec, iVec1, iSym, lScr
      Real*8  ChoVec(LenVec,NumVec), Scr(lScr)

      Call Cho_GetVec(ChoVec,LenVec,NumVec,iVec1,iSym,Scr,lScr)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine applyts_cvb(civbs,orbs,gjorb,gjorb2,gjorb3)
c  Apply T(s) to CIVBS :
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension civbs(ndet)
      dimension orbs(norb,norb),gjorb(*),gjorb2(*),gjorb3(*)

      call makegjorbs_cvb(orbs,gjorb,gjorb2,gjorb3)

      if(.not.proj)then
        call applyt_cvb(civbs,gjorb3)
      else
        call applyt_cvb(civbs,gjorb)
        call proj_cvb(civbs)
        call applyt_cvb(civbs,gjorb2)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine saamphlp3(t1aa,t1bb,t2abab,noa,nob,nva,nvb,noas,nvbs,key)
! this routine rearranges amplitudes to be spin adapted
! for T1 amplitudes for given si(=sa)
!
! t1aa   - T1aa amplitudes for given si (=sa) (I/O)
! t1bb   - T1bb amplitudes for given si (=sa) (I/O)
! t2abab - T2(arsi)abab amplitudes sa=si (sr=ss=irrep of S) (I/O)
! noa    - number of alpha occupied in symi (I)
! nob    - number of beta occupied in symi (I)
! nva    - number of alpha virtuals in symi (I)
! nvb    - number of beta virtuals in symi (I)
! noas   - number of alpha occupied in symmetry, where S orbitals is (I)
! nvbs   - number of beta virtuals in symmetry, where S orbitals is (I)
! key    - 0 - no adaptation (I)
!          1 - T2 DDVV adaptation
!          2 - T2 DDVV + T1 DV adaptation
!          3 - full T1 and T2 adaptation (only for doublets)
!          4 - full T2 without SDVS (only for doublets)

use Constants, only: Two, Six, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: noa, nob, nva, nvb, noas, nvbs, key
real(kind=wp), intent(inout) :: t1aa(nva,noa), t1bb(nvb,nob), t2abab(nva,nvbs,noas,nob)
integer(kind=iwp) :: a, i, nd, ns, nv
real(kind=wp) :: t1, t2

if (key == 0) return

nd = nob
ns = noa-nob
nv = nva

! T1 adaptation
!
! ta=t1oaa(i,a)     DV
! tb=t1obb(i,a)     DV
! tc=t2o2b(p,i,a,p) SDVS
!
! direct :
! t1= (ta+tb)/2
! t2= (-ta+tb+2tc)/6
!
! reverse :
! ta= t1-t2
! tb= t1+t2
! tc= 2t2

if (key == 3) then

  do i=1,nd
    do a=1,nv

      t1 = Half*(t1aa(a,i)+t1bb(a+ns,i))
      t2 = (t1bb(a+ns,i)-t1aa(a,i)+Two*t2abab(a,1,noas,i))/Six

      t1aa(a,i) = t1-t2
      t1bb(a+ns,i) = t1+t2
      t2abab(a,1,noas,i) = Two*t2

    end do
  end do

else if (key == 2) then

  do i=1,nd
    do a=1,nv

      t1 = Half*(t1aa(a,i)+t1bb(a+ns,i))

      t1aa(a,i) = t1
      t1bb(a+ns,i) = t1

    end do
  end do

!else if (key == 1) then
!  no adaptation in T1 turn on
end if

return

end subroutine saamphlp3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine string_cvb(arr,nmax,nread,ifc)
      implicit real*8 (a-h,o-z)
#include "inpmod_cvb.fh"
      character*(*) arr(nmax)
      character*100 string

      if(inputmode.eq.2)then
        call geths_cvb(arr,nread)
        return
      endif
      nread=0
      if(nmax.le.0)goto 2000

c  Treat first field differently
      ifcuse=mod(ifc,4)
      if(ifcuse.ge.2)ifcuse=2
      call popfield_cvb(ifcuse)
      call rdstring_cvb(string,ierr)
      if(ierr.gt.0)goto 1000
      arr(1)=string
      nread=nread+1

      ifcuse=mod(ifc,2)
      do 100 i=2,nmax
      call popfield_cvb(ifcuse)
      call rdstring_cvb(string,ierr)
      if(ierr.gt.0)goto 1000
      arr(i)=string
      nread=nread+1
100   continue
      goto 2000
1000  call pushfield_cvb()
2000  continue
      if(inputmode.eq.1)then
        call seths_cvb(arr,nread)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRGASTAB(LREST)
      IMPLICIT NONE
      INTEGER IGAS,LREST,NGAS
      INTEGER NSYM,ISYM,KORB,KREST
#include "WrkSpc.fh"

C Executable statements
      WRITE(6,*)
      WRITE(6,*)' GAS restriction table printout'
      WRITE(6,'(A,I5)')'Table size        NSIZE=',IWORK(LREST+0)
      WRITE(6,'(A,I5)')'Table type ID     ITYPE=',IWORK(LREST+1)
      WRITE(6,'(A,I5)')'Nr of partitions  NGAS=',IWORK(LREST+2)
      WRITE(6,'(A,I5)')'Nr of symm labels NSYM =',IWORK(LREST+3)
      WRITE(6,*)' Orbital partitions:'
      NGAS=IWORK(LREST+2)
      NSYM =IWORK(LREST+3)
      KORB=5
      WRITE(6,'(8X,I5,5X,8I5)')
     &      (IWORK(LREST-1+KORB+ISYM),ISYM=0,NSYM)
      DO IGAS=1,NGAS
       WRITE(6,'(I3,5X,I5,5X,8I5)')IGAS,
     &      (IWORK(LREST-1+KORB+ISYM+(NSYM+1)*IGAS),ISYM=0,NSYM)
      END DO
      WRITE(6,*)' Electron population restrictions:'
      KREST=KORB+(NGAS+1)*(NSYM+1)
      WRITE(6,'(5X,A7,5X,30I3)')'Minimum',
     &      (IWORK(LREST-1+KREST+0+2*(IGAS-1)),IGAS=1,NGAS)
      WRITE(6,'(5X,A7,5X,30I3)')'Maximum',
     &      (IWORK(LREST-1+KREST+1+2*(IGAS-1)),IGAS=1,NGAS)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FOCK(F,BM,FI,FP,D,P,Q,FINT,IFINAL,CMO)
! RASSCF program version IBM-3090: SX section
!
!*****************************************************************************
!   BM    : output
!   F     : used only in this routine
!   Q     : used only in this routine
!   FP    : in Input it is the FA matrix in MO. in Output it is FI + FA in MO.
!   FI    : input. FI in MO basis
!   D     : input. Active 1RDM in MO basis
!   P     : input. Active 2RDM in MO basis
!   FINT  : input. Active two-electron integrals in MO basis.
!   IFINAL: input
!   CMO   : input
!*****************************************************************************
! Calculation of the MCSCF fock matrix F(eq.(7) in I.J.Q.C.S14,175)
! FP is the matrix FI+FA (FP is FA at entrance)
! F is stored as a symmetry blocked square matrix, by columns.
! Note that F contains all elements, also the zero elements
! occurring when the first index is secondary.
! F is used to construct the Brillouin elements and the first row
! of the super-CI Hamiltonian, while FP is used as the effective
! one-electron operator in the construction of the super-CI
! interaction matrix.
!
!      ********** IBM-3090 MOLCAS Release: 90 02 22 **********

use Index_Functions, only: iTri, nTri_Elem
use Fock_util_global, only: ALGO, DoCholesky
use rasscf_global, only: CBLB, CBLBM, E2act, ECAS, HalfQ1, IBLB, IBLBM, ISTORD, ISTORP, iSymBB, ixSym, iZROT, JBLB, JBLBM, KSDFT, &
                         NTOT3, via_DFT
use PrintLevel, only: DEBUG
use output_ras, only: IPRLOC
use general_data, only: NASH, NBAS, NFRO, NISH, NORB, NSSH, NSYM
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: F(*), BM(*), Q(*)
real(kind=wp), intent(in) :: FI(*), D(*), P(*), FINT(*), CMO(*)
real(kind=wp), intent(inout) :: FP(*)
integer(kind=iwp), intent(in) :: iFinal
integer(kind=iwp) :: ipBM, ipFMCSCF, ipMOs, ipQs, iPrLev, ISTAV(8), ISTBM, ISTD, ISTFCK, ISTFP, ISTP, ISTSQ(8), ISTZ, iSym, IX, &
                     IX1, JSTF, N1, N2, NAO, NAS, NEO, NI, NIA, NIO, NIS, NM, NO, NO2, nOr, NP, NPQ, NQ, nSs, NT, NTM, NTT, NTU, &
                     NTV, NU, NUVX, NV, NVI, NVM
real(kind=wp) :: CASDFT_En, CSX, ECAS0, QNTM

IPRLEV = IPRLOC(4)
if (IPRLEV >= DEBUG) write(u6,*) ' Entering FOCK'

ISTSQ(1) = 0
ISTAV(1) = 0
do iSym=2,nSym
  ISTSQ(iSym) = ISTSQ(iSym-1)+nBas(iSym-1)**2
  ISTAV(iSym) = ISTAV(iSym-1)+nBas(iSym-1)*nAsh(iSym-1)
end do

!***********************************************************************
! add FI to FA to obtain FP
!***********************************************************************
FP(1:NTOT3) = FP(1:NTOT3)+FI(1:NTOT3)

!***********************************************************************
! Loop over symmetry blocks
!***********************************************************************
ISTFCK = 0
ISTFP = 0
ISTD = 0
ISTBM = 0
IX1 = 0
ISTZ = 0
E2act = Zero
HalfQ1 = Zero

do ISYM=1,NSYM
  IX = IX1+NFRO(ISYM)
  NIO = NISH(ISYM)
  NAO = NASH(ISYM)
  NEO = NSSH(ISYM)
  NIA = NIO+NAO
  NO = NORB(ISYM)
  NO2 = nTri_Elem(NO)
  CSX = Zero
  N1 = 0
  N2 = 0

  ! If no orbitals in this symmetry block go to next symm
  if (NO /= 0) then

    !************************
    ! clear F_gen matrix
    !************************
    F(ISTFCK+1:ISTFCK+NO**2) = Zero

    !*******************************************************************
    ! first index in F is inactive: F_gen is twice FP=FI+FA (Eq.10.8.27 MEST)
    !*******************************************************************
    if (NIO /= 0) then
      do NP=1,NO
        do NI=1,NIO
          F(ISTFCK+NO*(NP-1)+NI) = 2*FP(ISTFP+iTri(NP,NI))
        end do
      end do
    end if

    !*******************************************************************
    ! first index in F active
    !*******************************************************************
    if (NAO /= 0) then
      ISTP = ISTORP(ISYM)+1
      JSTF = ISTORD(ISYM)+1
      NUVX = (ISTORP(ISYM+1)-ISTORP(ISYM))/NAO

      if ((.not. DoCholesky) .or. (ALGO == 1)) then
        !***************************************************************
        ! Compute the Q-matrix (Eq. (19) in IJQC S14 175 1980 or Eq. 10.8.31 MEST)
        ! Q(m,v) = sum_wxy  (m|wxy) * P(wxy,v)
        ! P is packed in xy and pre-multiplied by 2 and reordered
        !***************************************************************
        if (IPRLEV >= DEBUG) then
          write(u6,*) 'PUVX integrals in FOCK'
          call wrtmat(FINT(JSTF),NO,NUVX,NO,NUVX)
          write(u6,*) 'two-elec density mat OR DMAT*DMAT in FOCK'
          call wrtmat(P(ISTP),NAO,NUVX,NAO,NUVX)
        end if

        call DGEMM_('N','N',NO,NAO,NUVX,One,FINT(JSTF),NO,P(ISTP),NUVX,Zero,Q,NO)

      else if (ALGO == 2) then
        !***************************************************************
        ! --- the Q-matrix has been already computed as Q(a,v)
        ! --- where a is an AO index and v is an active index
        ! --- Transform the 1st index to MOs (one symmetry at the time)
        ! --- Q(m,v) = C(a,m) * Q(a,v)
        !***************************************************************
        ipQS = 1+ISTAV(iSym)
        ipMOs = 1+ISTSQ(iSym)+nBas(iSym)*nFro(iSym)

        call DGEMM_('T','N',nOrb(iSym),nAsh(iSym),nBas(iSym),One,CMO(ipMOs),nBas(iSym),Q(ipQS),nBas(iSym),Zero,Q(1),nOrb(iSym))
      else
        write(u6,*) 'FOCK: illegal Cholesky parameter ALGO= ',ALGO
        call abend()
      end if

      if (IPRLEV >= DEBUG) call recprt('Q-mat in fock.f',' ',Q(1),NO,NAO)

      !*****************************************************************
      ! active-active interaction energy term in the RASSCF energy: trace of Q
      !*****************************************************************
      ECAS0 = ECAS
      do NT=1,NAO
        NTT = (NT-1)*NO+NIO+NT
        ECAS = ECAS+Half*Q(NTT)
        HALFQ1 = HALFQ1+Half*Q(NTT)
        E2act = E2act+Half*Q(NTT)
      end do
      if (IPRLEV >= DEBUG) then
        write(u6,*) 'Two-electron contribution (Q term):',ECAS-ECAS0
        write(u6,*) 'ECAS aft adding Q in fock.f :',ECAS
      end if

      !*****************************************************************
      ! Continue... Fock matrix for first index active
      !*****************************************************************
      NTM = 0
      do NT=1,NAO
        do NM=1,NO
          NTM = NTM+1
          QNTM = Q(NTM)
          do NV=1,NAO
            NVI = NV+NIO
            NTV = iTri(NT,NV)+ISTD
            NVM = iTri(NVI,NM)+ISTFP
            QNTM = QNTM+D(NTV)*FI(NVM)
          end do
          F(ISTFCK+NO*(NM-1)+NT+NIO) = QNTM
        end do
      end do

    end if
    !*******************************************************************
    !^ End if related to first index in F active
    !*******************************************************************

    !*******************************************************************
    !       The Brillouin matrix BM(pq)=F(qp)-F(pq)
    !*******************************************************************
    NPQ = ISTBM
    do NP=NIO+1,NO
      do NQ=1,NIA
        NPQ = NPQ+1
        BM(NPQ) = F(ISTFCK+NO*(NP-1)+NQ)-F(ISTFCK+NO*(NQ-1)+NP)

        ! Set zeroes to BM elements corresponding to rotations not allowed
        ! as controlled by the array IZROT.

        if ((NP <= NIA) .and. (NQ > NIO)) then
          NT = NP-NIO
          NU = NQ-NIO
          if (NT <= NU) then
            BM(NPQ) = Zero
          else
            NTU = ISTZ+nTri_Elem(NT-2)+NU
            if (IZROT(NTU) /= 0) BM(NPQ) = Zero
            if (IXSYM(IX+NP) /= IXSYM(IX+NQ)) BM(NPQ) = Zero
          end if
        end if

        ! check for largest Brillouin matrix element

        if (abs(BM(NPQ)) < abs(CSX)) cycle
        if (IXSYM(IX+NP) /= IXSYM(IX+NQ)) cycle
        CSX = BM(NPQ)
        N1 = NQ+NFRO(ISYM)
        N2 = NP+NFRO(ISYM)
      end do
    end do
  end if

  ISTFCK = ISTFCK+NO**2
  ISTFP = ISTFP+NO2
  ISTD = ISTD+nTri_Elem(NAO)
  ISTBM = ISTBM+(NIO+NAO)*(NAO+NEO)
  IX1 = IX1+NBAS(ISYM)
  ISTZ = ISTZ+nTri_Elem(NAO-1)
  CBLB(ISYM) = CSX
  IBLB(ISYM) = N1
  JBLB(ISYM) = N2
end do
!***********************************************************************
!^ End of long loop over symmetry
!***********************************************************************

if (iPrLev >= DEBUG) then
  CASDFT_En = Zero
  if ((KSDFT(1:3) /= 'SCF') .and. (KSDFT(1:3) /= 'PAM')) call Get_dScalar('CASDFT energy',CASDFT_En)
  write(u6,'(A,2F22.16)') ' RASSCF energy: ',ECAS+CASDFT_En,VIA_DFT
end if
if (iPrLev >= DEBUG) then
  write(u6,'(A)') ' MCSCF Fock-matrix in MO-basis'
  ipFMCSCF = 1
  do iSym=1,nSym
    nOr = nOrb(iSym)
    call RecPrt(' ',' ',F(ipFMCSCF),nOr,nOr)
    ipFMCSCF = ipFMCSCF+nOr*nOr
  end do
end if
if (iPrLev >= DEBUG) then
  write(u6,'(A)') ' Brillouin matrix'
  ipBM = 1
  do iSym=1,nSym
    nIs = nIsh(iSym)
    nAs = nAsh(iSym)
    nSs = nSsh(iSym)
    call RecPrt(' ',' ',BM(ipBM),(nAs+nIs),(nAs+nSs))
    ipBM = ipBM+(nAs+nIs)*(nAs+nSs)
  end do
end if

! Maximum BLB matrix element all symmetries

CBLBM = Zero
ISYMBB = 0
do ISYM=1,NSYM
  if (abs(CBLB(ISYM)) < abs(CBLBM)) cycle
  CBLBM = CBLB(ISYM)
  IBLBM = IBLB(ISYM)
  JBLBM = JBLB(ISYM)
  ISYMBB = ISYM
end do

!***********************************************************************
! Calculate Fock matrix for occupied orbitals.
!***********************************************************************
if (iFinal == 1) call FOCKOC(Q,F,CMO)

if (IPRLEV >= DEBUG) then
  write(u6,*)
  write(u6,*) ' >>> Exit Fock <<< '
  write(u6,*)
end if

end subroutine FOCK

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine intergeo(FileName,Enrg,Crd,Grd,nAtm,nIter)
*---------------------------------*
* Add geometry optimization info  *
*   to the Molden inputfile       *
*---------------------------------*
      use Symmetry_Info, only: nIrrep
      use Phase_Info
      use Slapaf_Info, only: Cx, nStab
      implicit real*8 (a-h,o-z)
#include "stdalloc.fh"
#include "angstr.fh"
#include "periodic_table.fh"
      Real*8 Crd(3,nAtm,nIter),Enrg(nIter), Grd(3,nAtm,nIter)
      Integer, Allocatable :: icoset2(:,:,:), jStab2(:,:), nStab2(:)
      Character*(*) FileName
      Real*8, Allocatable:: Cx_p(:,:), Charge(:)
*                                                                      *
************************************************************************
*                                                                      *
*     Pick information for centers and pseudo centers
*
      Call Get_iScalar('Unique atoms',msAtom)
      Call Get_iScalar('Pseudo atoms',msAtom_p)
*
      Call mma_Allocate(Charge,msAtom+msAtom_p,Label='Charge')
      Call Get_dArray('Nuclear charge',Charge,msAtom)

      If (msAtom_p.gt.0) Then
         Call Get_dArray('Pseudo charge',Charge(msAtom+1),msAtom_p)
         Call mma_allocate(Cx_p,3,msAtom_p,Label='Cx_p')
         Call Get_dArray('Pseudo Coordinates',Cx_p,3*msAtom_p)
      Else
         Call mma_allocate(Cx_p,3,1,Label='Cx_p')
         Cx_p(:,:)=0.0d0
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (msAtom.gt.nAtm) Then
         Call WarningMessage(2,'Error in InterGEO')
         Write (6,*) 'msAtom.gt.nAtm'
         Write (6,*) 'msAtom=',msAtom
         Write (6,*) 'nAtm=',nAtm
         Call Abend()
      End If
*
      Lu_Molden=19
      Call molcas_open(Lu_Molden,FileName)
      Write (Lu_Molden,*) '[Molden Format]'
      Write (Lu_Molden,*) '[N_GEO]'
      Write (Lu_Molden,*) nIter
      Write (Lu_Molden,*) '[GEOCONV]'
      Write (Lu_Molden,*) 'energy'
*
      iEner=0
      Do iIter=1,nIter
         Write (Lu_Molden,'(E24.17)') Enrg(iIter)
         iEner=iEner+1
      End Do
*
      Write (Lu_Molden,*) 'max-force'
      iGx=0
      Do iIter=1,nIter
        grmax=0.0D0
        Do ndc=1,msAtom
           grx=abs(Grd(1,ndc,iIter))
           gry=abs(Grd(2,ndc,iIter))
           grz=abs(Grd(3,ndc,iIter))
           If (grx.gt.grmax) grmax=grx
           If (gry.gt.grmax) grmax=gry
           If (grz.gt.grmax) grmax=grz
           iGx=iGx+3
        End Do
        Write (Lu_Molden,'(F12.7)') grmax
      End Do
*
      Write (Lu_Molden,*) 'rms-force'
      iGx=0
      Do iIter=1,nIter
         grtot=0.0D0
         ngrad=0
         Do ndc=1,msAtom
            grx=Grd(1,ndc,iIter)
            gry=Grd(2,ndc,iIter)
            grz=Grd(3,ndc,iIter)
            Do i=0,nIrrep/nStab(ndc)-1
               grtot=grtot+grx*grx+gry*gry+grz*grz
               ngrad=ngrad+1
            End Do
            iGx=iGx+3
         End Do
         Write (Lu_Molden,'(F12.7)') sqrt(grtot)/DBLE(ngrad)
      End Do
*
*     This part disabled because gv refuses to open the file
#ifdef write_molden_steps
      Write (Lu_Molden,*) 'max-step'
      Do iIter=1,nIter-1
         stepmax=0.0D0
         Do ndc=1,msAtom
            dx=Crd(1,ndc,iIter+1)-Crd(1,ndc,iIter)
            dy=Crd(2,ndc,iIter+1)-Crd(2,ndc,iIter)
            dz=Crd(3,ndc,iIter+1)-Crd(3,ndc,iIter)
            If (dx.gt.stepmax) stepmax=dx
            If (dy.gt.stepmax) stepmax=dy
            If (dz.gt.stepmax) stepmax=dz
         End Do
         Write (Lu_Molden,'(F12.7)') stepmax
      End Do
*
      Write (Lu_Molden,*) 'rms-step'
      Do iIter=1,nIter-1
         step=0.0D0
         Do ndc=1,msAtom
            dx=Crd(1,ndc,iIter+1)-Crd(1,ndc,iIter)
            dy=Crd(2,ndc,iIter+1)-Crd(2,ndc,iIter)
            dz=Crd(3,ndc,iIter+1)-Crd(3,ndc,iIter)
            Do i=0,nIrrep/nStab(ndc)-1
               step=step+dx*dx+dy*dy+dz*dz
            End Do
         End Do
         Write (Lu_Molden,'(F12.7)') sqrt(step)/DBLE(ngrad)
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Set up the desymmetrization of the coordinates
*
      ixyz   = 0
      ixyz_p = 0
      MaxDCR=0
      Call mma_allocate(icoset2,[0,7],[0,7],[1,msAtom+msAtom_p],
     &                  label='icoset2')
      Call mma_allocate(jStab2,[0,7],[1,msAtom+msAtom_p],
     &                  label='jStab2')
      Call mma_allocate(nStab2,[1,msAtom+msAtom_p],
     &                  label='nStab2')
      Do ndc = 1, msAtom + msAtom_p
         If (ndc.le.msAtom) Then
            ixyz   = ixyz   + 1
            iChxyz=iChAtm(Cx(1,ixyz,1))
         Else
            ixyz_p = ixyz_p + 1
            iChxyz=iChAtm(Cx_p(1,ixyz_p))
         End If
         Call Stblz(iChxyz,nStab2(ndc),jStab2(0,ndc),
     &              MaxDCR,iCoSet2(0,0,ndc))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      nAt=0
      Write (Lu_Molden,*) '[GEOMETRIES] (XYZ)'
      Do ndc = 1, msAtom+msAtom_p
         Do i=0,nIrrep/nStab2(ndc)-1
            nAt=nAt+1
         End do
      End do
*
      Do iIter=1,nIter
         Write (Lu_Molden,'(I4)') nAt
         Write (Lu_Molden,*) Enrg(iIter)
         Do ndc = 1, msAtom+msAtom_p
            If (ndc.le.msAtom) Then
               x=Crd(1,ndc,iIter)
               y=Crd(2,ndc,iIter)
               z=Crd(3,ndc,iIter)
            Else
               x=Cx_p(1,ndc-msAtom)
               y=Cx_p(2,ndc-msAtom)
               z=Cx_p(3,ndc-msAtom)
            End If
            Do i=0,nIrrep/nStab2(ndc)-1
               iFacx=iPhase(1,icoset2(i,0,ndc))
               iFacy=iPhase(2,icoset2(i,0,ndc))
               iFacz=iPhase(3,icoset2(i,0,ndc))
               x1=angstr*x*DBLE(iFacx)
               y1=angstr*y*DBLE(iFacy)
               z1=angstr*z*DBLE(iFacz)
               LbAtom=int(charge(ndc))
               Write (Lu_Molden,102) pTab(LbAtom),x1,y1,z1
 102           Format(A2,3(3x,F12.7))
            End do
         End do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Write (Lu_Molden,*) '[FORCES]'
*
      Do iIter=1,nIter
         Write (Lu_Molden,'(A,1X,I4)') 'point',iIter
         Write (Lu_Molden,'(I4)') nAt
         Do ndc = 1, msAtom+msAtom_p
            If (ndc.le.msAtom) Then
               x=Grd(1,ndc,iIter)
               y=Grd(2,ndc,iIter)
               z=Grd(3,ndc,iIter)
            Else
               x=0.0D0
               y=0.0D0
               z=0.0D0
            End If
            Do i=0,nIrrep/nStab2(ndc)-1
               iFacx=iPhase(1,icoset2(i,0,ndc))
               iFacy=iPhase(2,icoset2(i,0,ndc))
               iFacz=iPhase(3,icoset2(i,0,ndc))
               x1=x/angstr*DBLE(iFacx)
               y1=y/angstr*DBLE(iFacy)
               z1=z/angstr*DBLE(iFacz)
               Write (Lu_Molden,103) x1,y1,z1
 103           Format(3(3x,F12.7))
            End do
         End do
      End Do
      Call mma_deallocate(nStab2)
      Call mma_deallocate(jStab2)
      Call mma_deallocate(icoset2)
*
      Close(Lu_Molden)
*                                                                      *
************************************************************************
*                                                                      *
      If (Allocated(Cx_p)) Call mma_deallocate(Cx_p)
      Call mma_deallocate(Charge)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

#include "compiler_features.h"
#ifdef _WARNING_WORKAROUND_
#  ifdef _LIFETIME_BUG_
#    define _SAVE_TARGET_ , save
#  else
#    define _SAVE_TARGET_
#  endif
#else
#  define _SAVE_TARGET_
#endif

subroutine CISigma_td(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,Int2a,nInt2a,ipCI1,ipCI2,NT,Have_2_el)

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use ipPage, only: ipin, ipin1, ipnout, opout, W
use MCLR_Data, only: i12, ipCM, ipMat, iRefSM, ist, KAIN1, KINT2, KINT2A, nConf1, nDens, pInt1, Square, XISPSM
use CandS, only: ICSM, ISSM
use input_mclr, only: nBas, nCSF, nSym, ntAsh, Page, State_Sym, TimeDep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iiSpin, iCSym, iSSym, nInt1, nInt2s, nInt2a, ipCI1, ipCI2
real(kind=wp), target, intent(in) :: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
character, intent(in) :: NT
logical(kind=iwp), intent(in) :: Have_2_el
integer(kind=iwp) :: i, ij, ijkl, iOp, iS, j, ji, jilk, jS, k, kic(2), kl, l, lk, nDet
real(kind=wp), allocatable :: CIDET(:)
real(kind=wp), allocatable, target _SAVE_TARGET_ :: TI1(:), TI2(:)

! For the timeindep case ipS1 and ipS2 will be half as long
! Avoid sigmavec calls. 95% of the time in mclr is spent in sigmavec

! Interface Anders to Jeppe
! This interface initiates Jeppe's common block
! and will make it easier to use Anders modifications
! of the CI routines

! OK first tell Jeppe where the integrals are.

if (nconf1 == 0) return

! One electron integrals

KAIN1(1:nInt1) => Int1(:)

! Two electron integrals
! symmetric in particle one and two

KINT2(1:nInt2s) => Int2s(:)
KINT2a(1:nInt2a) => Int2a(:)

! Two electron integrals
! anti symmetric in particle one and two

irefsm = iCSym

! Do we have any two-electron integrals?

if (Have_2_el) then
  i12 = 2
else
  i12 = 1
end if

! Symmetry of Sigma vector

iSSM = iSSym
kic(2) = 2
if (issm == State_sym) kic(2) = 1

! Symmetry of CI vector

iCSM = iCSym
kic(1) = 2
if (icsm == State_sym) kic(1) = 1

! Symmetry properties of operator

ndet = nint(max(xispsm(iSSym,1),xispsm(iCSym,1)))
ndet = max(ndet,ncsf(icsym),ncsf(issym))
if (ndet == 0) return
iOP = Mul(iCSM,iSSm)
if (iOp == 1) then
  pInt1(1:nSym) = ipCM(1:nSym)
else
  do iS=1,nSym
    pInt1(is) = ipMat(is,Mul(iS,iOp))
  end do
end if

! Triplet/Singlet operator

ist = iispin+1
square = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
if (TIMEDEP) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (NT == 'T') square = .true.  ! The operator is not sym

  if (page) then
    write(u6,*) 'Page not implemented for Time-dependent perturbations'
    call Abend()
  end if

  ! CIDET is here because sigmavec will destroy the first input vector.
  call mma_allocate(CIDET,nDet,Label='CIDET')
  call ipin(ipCI1)
  CIDET(1:nCSF(iCSM)) = W(ipCI1)%A(1:nCSF(iCSM))

  call ipin(ipci2)
  call SigmaVec(CIDET,W(ipci2)%A,kic)

  if (NT == 'N') then
    call mma_deallocate(CIDET)
    return

  else if (NT == 'S') then

    ! Symmetric operator, no transpose of integrals needed!
    call ipin(ipCI1)
    CIDET(1:nCSF(iCSM)) = W(ipCI1)%A(nConf1+1:nConf1+nCSF(iCSM))

    call ipin(ipci2)
    call SigmaVec(CIDET,W(ipci2)%A(1+nconf1),kic)

  else  ! NT /= 'S'

    ! The operator is not sym --> transpose integrals! NT /= S
    call ipin(ipCI1)
    CIDET(1:nCSF(iCSM)) = W(ipCI1)%A(1:nCSF(iCSM))

    call mma_allocate(TI1,nDens,Label='TI1')
    call mma_allocate(TI2,ntash**4,Label='TI2')

    do i=1,ntash
      do j=1,ntash
        ij = i+ntash*(j-1)
        ji = j+ntash*(i-1)
        do k=1,ntash
          do l=1,ntash
            kl = k+ntash*(l-1)
            lk = l+ntash*(k-1)
            if (ij >= kl) then
              ijkl = iTri(ij,kl)
              jilk = iTri(ji,lk)
              TI2(jilk) = int2s(ijkl)
            end if
          end do
        end do
      end do
    end do

    do is=1,nSym
      js = Mul(Mul(icsym,issym),is)
      if (nbas(js)*nbas(is) /= 0) call DGETMO(Int1(ipmat(is,js)),nbas(is),nbas(is),nbas(js),TI1(ipmat(js,is)),nbas(js))
    end do

    KAIN1 => TI1
    KINT2 => TI2

    call ipin(ipci2)
    call SigmaVec(CIDET,W(ipci2)%A(1+nconf1),kic)

    nullify(KAIN1,KINT2)
    call mma_deallocate(TI1)
    call mma_deallocate(TI2)

  end if  ! End the transpose of integrals.

  call mma_deallocate(CIDET)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else   ! If not timedep
  !                                                                    *
  !*********************************************************************
  !                                                                    *

  if (.not. page) then
    call mma_allocate(CIDET,nDet,Label='CIDET')
    call ipin(ipCI1)
    CIDET(1:nCSF(iCSM)) = W(ipCI1)%A(1:nCSF(iCSM))
    call ipin(ipci2)
    call SigmaVec(CIDET,W(ipci2)%A,kic)
    call mma_deallocate(CIDET)
  else
    call ipnout(ipci2)
    call ipin1(ipCI1,ndet)
    call ipin(ipci2)
    call SigmaVec(W(ipCI1)%A,W(ipci2)%A,kic)
    call opout(ipci1)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine CISigma_td

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
         Integer Function Get_sNumber(dkhunit3)
         Integer dkhunit3, snumber
         character*(43) scrtxt
#ifdef _MOLCAS_
         Call molcas_open(dkhunit3,'dkhops.13')
#endif
         Rewind(dkhunit3)
         Read (dkhunit3,'(A43)') scrtxt(1:43)
         Read (dkhunit3,'(A43)') scrtxt(1:43)
1050     Read (dkhunit3,'(A3)') scrtxt(1:3)
         If (scrtxt(1:3).ne.'+++') goto 1050
         Read (dkhunit3,'(I3)') snumber
#ifdef _MOLCAS_
         Close (dkhunit3)
#endif
*
         Get_sNumber = snumber
         Return
         End
         Integer Function Get_tNumber(dkhunit4)
         Integer dkhunit4, tnumber
         character*(3) scrtxt
*
#ifdef _MOLCAS_
         Call molcas_open(dkhunit4,'dkhops.14')
#endif
         Rewind(dkhunit4)
1051     Read (dkhunit4,'(A3)') scrtxt(1:3)
         If (scrtxt(1:3).ne.'+++') goto 1051
         Read (dkhunit4,'(I3)') tnumber
#ifdef _MOLCAS_
         Close (dkhunit4)
#endif
*
         Get_tNumber = tnumber
         Return
         End
         Integer Function Get_uNumber(dkhunit5)
         Integer dkhunit5, unumber
         character*(3) scrtxt
*
#ifdef _MOLCAS_
         Call molcas_open(dkhunit5,'dkhops.15')
#endif
         Rewind(dkhunit5)
1052     Read (dkhunit5,'(A3)') scrtxt(1:3)
         If (scrtxt(1:3).ne.'+++') goto 1052
         Read (dkhunit5,'(I3)') unumber
#ifdef _MOLCAS_
         Close (dkhunit5)
#endif
*
         Get_uNumber = unumber
         Return
         End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
*               2005, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RotateOrb(cMO,PACol,nBasis,nAtoms,PA,
     &                     Maximisation,nOrb2loc,Name,
     &                     nBas_per_Atom,nBas_Start,ThrRot,PctSkp,
     &                     Debug)
c
c     Author: Yannick Carissan.
c
c     Modifications:
c        - October 6, 2005 (Thomas Bondo Pedersen):
c          Array PACol introduced in argument list.
c
      Implicit Real*8(a-h,o-z)
#include "WrkSpc.fh"
#include "real.fh"
#include "Molcas.fh"
      Real*8 cMO(nBasis,*), PACol(nOrb2Loc,2)
      Integer nBas_per_Atom(*),nBas_Start(*)
      Real*8 PA(nOrb2Loc,nOrb2Loc,nAtoms)
      Logical Maximisation, Debug
      Character*80 Txt
      Character*(LENIN8) Name(*),PALbl
c
      xDone = 0.0d0
      If (Debug) Then
         Write(6,*) 'RotateOrb[Debug]: nBas_per_Atom: ',
     &              (nBas_per_Atom(i),i=1,nAtoms)
         iCouple=0
      End If
      Do iMO1=1,nOrb2Loc-1
        Do iMO2=iMO1+1,nOrb2Loc
c
          If (Debug) Then
            iCouple = iCouple + 1
            Write(6,'(a9,i5)') 'Couple n:',iCouple
            Write(6,'(a9,i5)') '    MO1 :',iMO1
            Write(6,'(a9,i5)') '    MO2 :',iMO2
          End If
c
          iMO_s=iMO1
          iMO_t=iMO2
          SumA=Zero
          SumB=Zero
          Do iAt=1,nAtoms
            PAst=PA(iMO_t,iMO_s,iAt)
            PAss=PA(iMO_s,iMO_s,iAt)
            PAtt=PA(iMO_t,iMO_t,iAt)
            If (Debug) Then
              Write(6,*) 'In RotateOrb'
              Write(6,*) '------------'
              PALbl='PA__'//Name(nBas_Start(iAt))(1:LENIN)
              Call RecPrt(PALbl,' ',PA(1,1,iAt),nOrb2Loc,nOrb2Loc)
              Write(6,*) '**************************'
              Write(6,*) 'A :',iAt
              Write(6,*) '<',iMO_s,'|PA|',iMO_t,'> = ',PAst
              Write(6,*) '<',iMO_s,'|PA|',iMO_s,'> = ',PAss
              Write(6,*) '<',iMO_t,'|PA|',iMO_t,'> = ',PAtt
              Write(6,*) '**************************'
            End If
            SumA=SumA+PAst**2-0.25d0*(PAss-PAtt)**2
            SumB=SumB+PAst*(PAss-PAtt)
          End Do
          Ast=SumA
          Bst=SumB
c
          If ((Ast.eq.Zero).and.(Bst.eq.Zero)) Then
            cos4alpha=-One
            sin4alpha=Zero
          Else
            cos4alpha=-Ast/sqrt(Ast**2+Bst**2)
            sin4alpha= Bst/sqrt(Ast**2+Bst**2)
          End If
          Tst=abs(cos4alpha)-1.0d0
          If (Tst .gt. 0.0d0) Then
            If (Tst .gt. 1.0d-10) Then
              Write(Txt,'(A,D18.10)') 'Actual: cos4alpha = ',cos4alpha
              Call SysAbendMsg('RotateOrb','-1.0d0 < cos4alpha < 1.0d0',
     &                         Txt)
            Else
               If (cos4alpha .lt. 0.0d0) Then
                  cos4alpha=-1.0d0
               Else
                  cos4alpha=1.0d0
               End If
            End If
          End If
c
c-------- On choisit le cos car Alpha IN [0;PI/2]
c
          Alpha1=acos(cos4alpha)/4.0d0
          Alpha2=asin(sin4alpha)/4.0d0
          If (Alpha2.lt.Zero) Alpha1=Alpha2+PI
          Alpha=Alpha1
          If (.Not.Maximisation) Then
            Gamma_rot=Alpha-PI/4.0d0
          Else
            Gamma_rot=Alpha
          End If
          If (Debug) Then
            Write(6,'(a9,f10.5)') '   Ast :',Ast
            Write(6,'(a9,f10.5)') '   Bst :',Bst
            Write(6,'(a9,f10.5)') 'Alpha1 :',Alpha1
            Write(6,'(a9,f10.5)') 'Alpha2 :',Alpha2
            Write(6,'(a9,f10.5)') ' Gamma :',Gamma_rot
          End If
c
          Tsts = sin(Gamma_rot)
          Tstc = 1.0d0 - cos(Gamma_rot)
          If (abs(Tsts).gt.ThrRot .or. abs(Tstc).gt.ThrRot) Then
             Call Rot_st(cMO(1,iMO_s),cMO(1,iMO_t),nBasis,Gamma_rot,
     &                   Debug)
             Call UpdateP(PACol,Name,nBas_Start,
     &                    nOrb2Loc,nAtoms,PA,Gamma_rot,
     &                    iMO_s,iMO_t,Debug)
             xDone = xDone + 1.0d0
          End If
c
          If (Debug) Then
            Call RecPrt('MO after rotation',' ',cMO,nBasis,nBasis)
          End If
c
        End Do !iMO2
      End Do !iMO1
c
      If (nOrb2Loc .gt. 1) Then
         xOrb2Loc = dble(nOrb2Loc)
         xTotal = xOrb2Loc*(xOrb2Loc-1.0d0)/2.0d0
         PctSkp = 1.0d2*(xTotal-xDone)/xTotal
      Else
         PctSkp = 0.0d0
      End If
c
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,labs,PrTot,iPL,iPoint,ifallorb)
!***********************************************************************
!                                                                      *
!     purpose: printing of tables for different tensor properties      *
!                                                                      *
!     Short           logical option for either Short (Short           *
!                     =.true., the total electronic contribution)      *
!                     long (Short=.false., orbital contributions)      *
!                     output                                           *
!     sig             the sign factor for the electronic contri-       *
!                     bution, positive for ndiamagnetic shielding      *
!     nIrrep          the number of irreducible representations        *
!     nBas            the number of functions in each representa-      *
!     (0:nIrrep-1)    tion                                             *
!     nTot            the total number of elements supplied for        *
!                     each component of the property tensor; equal     *
!                     either to 1 (total electronic and total nuc-     *
!                     lear contributions) or to the dimension of       *
!                     the basis set.                                   *
!     Occ(1:nTot)     Occupation numbers for all eigenvectors,         *
!                     a dummy for Short outputs                        *
!     ThrSV           threshold for Occupation numbers; if             *
!                     Occ(i).le.ThrSV the contribution will not        *
!                     be printed                                       *
!     PrEl(1:nTot,    matrix elements for all components 1,2,...,      *
!          1:maxlab)  maxlab, nTot entries for each component          *
!                                                                      *
!     PrNu(1:maxlab)  nuclear contributions for each component         *
!     maxlab          total number of cartesian components             *
!     labs(1:maxlab)  labels for each component                        *
!     TotEl(1:6)      auxiliary storage area                           *
!     PrTot(1:maxlab) Total value for each component                   *
!     iPL             Print level                                      *
!     iPoint          The number of the center                         *
!     ifallorb        logical option for whether the property of       *
!                     all orbitals are printed (and not weighted by    *
!                     occupation number)in property calculation when   *
!                     short=.false. (S.S.Dong, 2018)                   *
!                                                                      *
! 2000 Dept. of Chem. Phys., Univ. of Lund, Sweden                     *
! Modified by S.S.Dong, 2018, Univ. of Minnesota                       *
! - Enable properties to be printed for all orbitals                   *
! (including virtuals) and not weighted by occupation numbers          *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: Short, ifallorb
integer(kind=iwp), intent(in) :: nIrrep, nBas(0:nIrrep-1), nTot, maxlab, iPL, iPoint
real(kind=wp), intent(in) :: sig, Occ(nTot), ThrSV, PrEl(nTot,maxlab), PrNu(maxlab)
character(len=16), intent(in) :: labs(maxlab)
real(kind=wp), intent(out) :: PrTot(maxlab)
integer(kind=iwp) :: i, icount, ii, j, jcount, jj, nDec, nLog10
real(kind=wp) :: TotEl(6), val
character(len=132) :: outlab
character(len=18) :: Format1
character(len=16) :: lab
character(len=14) :: Format3
character(len=13) :: Format2
character(len=11) :: Format4
character(len=4) :: lbb4
character(len=5) :: lab5

Format1 = '(2i5,f14.8,6f16.8)'
Format2 = '(1x,a,6f16.8)'
Format3 = '(1x,a,6f16.8/)'
Format4 = '(a5,6f16.8)'
val = Zero
do i=1,maxlab
  val = max(val,abs(PrNu(i)))
  do j=1,nTot
    val = max(val,abs(PrEl(j,i)))
  end do
end do
val = max(val,One)
nLog10 = max(1,int(log10(val)+One)+1)
nDec = min(14-nLog10,8)
write(Format1(17:17),'(I1)') nDec
write(Format2(12:12),'(I1)') nDec
write(Format3(12:12),'(I1)') nDec
write(Format4(10:10),'(I1)') nDec

if ((.not. Short) .and. (.not. ifallorb)) then
  write(u6,'(A,D9.2/)') ' orbital contributions printed for occupation numbers >',ThrSV
else if ((.not. Short) .and. ifallorb) then
  write(u6,'(A)') ' orbital properties printed for all occupation numbers'
end if

do i=1,maxlab,6

  do j=1,132
    outlab(j:j) = ' '
  end do

  if (Short) then
    if (iPL >= 3) then
      if ((maxlab > 1) .or. (labs(1) /= ' ')) then
        write(outlab,'(1x,a,6a16)') 'Component              ',(labs(j),j=i,min(i+5,maxlab))
        write(u6,'(a)') trim(outlab)
      end if
    end if
    jcount = 0
    do j=i,min(i+5,maxlab)
      jcount = jcount+1
      TotEl(jcount) = PrEl(1,j)
    end do
  else
    do j=1,6
      TotEl(j) = Zero
    end do
    write(outlab,'(1x,a,6a16)') 'Irrep  Orb   Occupation',(labs(j),j=i,min(i+5,maxlab))
    write(u6,'(a)') trim(outlab)
    lbb4 = '    '
    write(outlab,'(33a4)') (lbb4,j=1,33)
    lbb4 = '----'
    lab = '----------------'
    write(outlab,'(6a4,6a16)') (lbb4,j=1,6),(lab,j=i,min(i+5,maxlab))
    write(u6,'(1x,a)') trim(outlab)
    icount = 0
    do ii=0,nIrrep-1
      do jj=1,nBas(ii)
        icount = icount+1
        jcount = 0
        do j=i,min(i+5,maxlab)
          jcount = jcount+1
          if (ifallorb) then
            TotEl(jcount) = TotEl(jcount)+PrEl(icount,j)*Occ(icount)
          else
            TotEl(jcount) = TotEl(jcount)+PrEl(icount,j)
          end if
        end do
        if (ifallorb .or. (Occ(icount) > ThrSV)) then
          write(u6,Format1) ii+1,jj,Occ(icount),(sig*PrEl(icount,j),j=i,min(i+5,maxlab))
        end if
      end do
    end do
    write(u6,'(1x,a)') trim(outlab)
  end if

  do j=i,min(i+5,maxlab)
    PrTot(j) = sig*TotEl(j-i+1)+PrNu(j)
  end do
  if ((iPL >= 3) .or. ((.not. Short) .and. (iPL == 2))) then
    write(u6,Format2) 'Total electronic       ',(sig*TotEl(j-i+1),j=i,min(i+5,maxlab))
    write(u6,Format2) 'Total nuclear          ',(PrNu(j),j=i,min(i+5,maxlab))
    write(u6,Format3) 'Total                  ',(PrTot(j),j=i,min(i+5,maxlab))
  else
    lab5 = '     '
    if ((iPoint > 0) .and. (i == 1)) write(lab5,'(I5)') iPoint
    write(u6,Format4) lab5,(PrTot(j),j=i,min(i+5,maxlab))
  end if
end do

return

end subroutine PrOut

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Bjorn O. Roos                                    *
!               1989, Per Ake Malmqvist                                *
!               1991,1993,1996, Markus P. Fuelscher                    *
!***********************************************************************

subroutine Fmat(CMO,PUVX,D,D1A,FI,FA)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Update the Fock matrix for the active orbitals and transform     *
!     it to MO basis as well as the matrix FI (Fock matrix) for        *
!     frozen and inactive orbitals).                                   *
!                                                                      *
!     calling arguments:                                               *
!     CMO     : array of real*8                                        *
!               MO-coefficients                                        *
!     PUVX    : array of real*8                                        *
!               two-electron integrals (pu!vx)                         *
!     D       : array of real*8                                        *
!               averaged one-body density matrix                       *
!     D1A     : array of real*8                                        *
!               active one body density matrix in AO-basis             *
!     FI      : array of real*8                                        *
!               inactive Fock matrix. In input is in AO basis.         *
!               In output in MO basis.                                 *
!     FA      : array of real*8                                        *
!               active Fock matrix. In input in AO Basis.              *
!               In output in MO basis. It is also modified by scaling  *
!               exchange part in ExFac /= 1.0                          *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     B.O. Roos and P.Aa. Malmqvist                                    *
!     University of Lund, Sweden, 1989                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     - updated for MOLCAS version 2                                   *
!       M.P. Fuelscher, University of Lund, Sweden, 1991               *
!     - updated for MOLCAS version 3                                   *
!       M.P. Fuelscher, University of Lund, Sweden, 1993               *
!     - updated for integral direct and reaction field calculations    *
!       M.P. Fuelscher, University of Lund, Sweden, 1996               *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use RunFile_procedures, only: Get_dExcdRa
use rasscf_global, only: DFTFOCK, ECAS, EMY, ExFac, KSDFT, l_casdft, NAC, NewFock, nFint, VIA, VIA_DFT
use PrintLevel, only: DEBUG
use output_ras, only: IPRLOC
use general_data, only: NASH, NBAS, NFRO, NISH, NORB, NSYM, NTOT1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CMO(*), PUVX(*), D(*), D1A(*)
real(kind=wp), intent(inout) :: FI(*), FA(*)
integer(kind=iwp) :: i, iBas, iFro, ij, iOff, iOff1, iOff2, iOff3, iOrb, iPrLev, ipTmpFck, ipTmpFckA, ipTmpFckI, iSym, j, jOrb, &
                     nTmpFck
real(kind=wp), allocatable :: TmpFck(:), Tmp1(:), Tmp2(:), TmpD1A(:)
real(kind=wp), external :: DDot_

! Local print level (if any)
IPRLEV = IPRLOC(4)
if (IPRLEV >= DEBUG) then
  write(u6,*) ' Entering FMAT'

  write(u6,*) repeat('*',65)
  write(u6,*) 'Entering FMAT routine called by SXCTL!'
  write(u6,*) repeat('*',65)
  write(u6,*) 'printing input matrices :'
  write(u6,*) repeat('*',65)
  write(u6,*)
  write(u6,*) ' CMOs in FMAT'
  write(u6,*) ' ---------------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iBas = nBas(iSym)
    if (iBas /= 0) then
      write(u6,*) 'Sym =',iSym
      do i=1,iBas
        write(u6,*) (CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
      end do
      iOff = iOff+(iBas*iBas)
    end if
  end do

  write(u6,*)
  write(u6,*) ' PUVX in FMAT'
  write(u6,*) ' ---------------------'
  write(u6,*)
  call wrtmat(PUVX,1,nFint,1,nFint)

  write(u6,*)
  write(u6,*) ' ---------------------'
  call TRIPRT('Averaged one-body density matrix D, in MO in FMAT',' ',D,NAC)

  write(u6,*)
  write(u6,*) ' D1A in AO basis in FMAT'
  write(u6,*) ' ---------------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iBas = nBas(iSym)
    call wrtmat(D1A(iOff),iBas,iBas,iBas,iBas)
    iOff = iOff+iBas*iBas
  end do

  write(u6,*)
  write(u6,*) ' FI in AO-basis in FMAT'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    call TriPrt(' ',' ',FI(iOff),iOrb)
    iOff = iOff+nTri_Elem(iOrb)
  end do

  write(u6,*)
  write(u6,*) ' FA in AO-basis in FMAT'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    call TriPrt(' ',' ',FA(iOff),iOrb)
    iOff = iOff+nTri_Elem(iOrb)
  end do
end if

! create FA in AO basis
call mma_allocate(Tmp1,nTot1,Label='Tmp1')
call Fold(nSym,nBas,D1A,Tmp1)
if (KSDFT /= 'SCF') NewFock = 0
!if (NewFock == 0) then
!  nBMX = 0
!  do iSym=1,nSym
!    nBMX = max(nBMX,nBas(iSym))
!  end do
!  FA(1:nTot1) = Zero
!  call FTwo_Drv(nSym,nBas,nAsh,nSkipX,Tmp1,D1A,FA,nTot1,ExFac,nBMX,CMO)
!end if

! Inactive-active contribution to ECAS
VIA = dDot_(nTot1,FI,1,Tmp1,1)
ECAS = EMY+VIA
if (iPrLev >= DEBUG) then
  write(u6,*) ' Total core energy fmat:       ',EMY
  write(u6,*) ' inactive-active interaction:  ',VIA
  write(u6,*) ' CAS energy (core+interaction):',ECAS
end if
call mma_deallocate(Tmp1)

! print FI and FA
if (iPrLev >= DEBUG) then
  write(u6,*)
  write(u6,*) ' FI in AO-basis in fmat'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    call TriPrt(' ',' ',FI(iOff),iOrb)
    iOff = iOff+nTri_Elem(iOrb)
  end do
  write(u6,*)
  write(u6,*) ' FA in AO-basis in fmat'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    call TriPrt(' ',' ',FA(iOff),iOrb)
    iOff = iOff+nTri_Elem(iOrb)
  end do
end if

! transform FI from AO to MO basis
iOff1 = 1
iOff2 = 1
iOff3 = 1
do iSym=1,nSym
  iBas = nBas(iSym)
  if (iBas == 0) cycle
  iOrb = nOrb(iSym)
  if (iOrb == 0) cycle
  iFro = nFro(iSym)
  call mma_allocate(Tmp1,iBas*iBas,Label='Tmp1')
  call mma_allocate(Tmp2,iOrb*iBas,Label='Tmp2')
  call Square(FI(iOff1),Tmp1,1,iBas,iBas)
  call DGEMM_('N','N',iBas,iOrb,iBas,One,Tmp1,iBas,CMO(iOff2+(iFro*iBas)),iBas,Zero,Tmp2,iBas)
  call DGEMM_Tri('T','N',iOrb,iOrb,iBas,One,Tmp2,iBas,CMO(iOff2+(iFro*iBas)),iBas,Zero,FI(iOff3),iOrb)
  call mma_deallocate(Tmp2)
  call mma_deallocate(Tmp1)
  iOff1 = iOff1+nTri_Elem(iBas)
  iOff2 = iOff2+iBas*iBas
  iOff3 = iOff3+nTri_Elem(iOrb)
end do

! transform FA from AO to MO basis
iOff1 = 1
iOff2 = 1
iOff3 = 1
do iSym=1,nSym
  iBas = nBas(iSym)
  if (iBas == 0) cycle
  iOrb = nOrb(iSym)
  if (iOrb == 0) cycle
  iFro = nFro(iSym)
  call mma_allocate(Tmp1,iBas*iBas,Label='Tmp1')
  call mma_allocate(Tmp2,iOrb*iBas,Label='Tmp2')
  call Square(FA(iOff1),Tmp1,1,iBas,iBas)
  call DGEMM_('N','N',iBas,iOrb,iBas,One,Tmp1,iBas,CMO(iOff2+(iFro*iBas)),iBas,Zero,Tmp2,iBas)
  call DGEMM_Tri('T','N',iOrb,iOrb,iBas,One,Tmp2,iBas,CMO(iOff2+(iFro*iBas)),iBas,Zero,FA(iOff3),iOrb)
  call mma_deallocate(Tmp2)
  call mma_deallocate(Tmp1)
  iOff1 = iOff1+nTri_Elem(iBas)
  iOff2 = iOff2+iBas*iBas
  iOff3 = iOff3+nTri_Elem(iOrb)
end do

!***********************************************************************
!              Add DFT part to Fock matrix:                            *
!***********************************************************************
if ((KSDFT(1:3) /= 'SCF') .and. (KSDFT(1:3) /= 'PAM') .and. (.not. l_casdft)) then
  ipTmpFckI = -99999
  ipTmpFckA = -99999
  call Get_dExcdRa(TmpFck,nTmpFck)
  ipTmpFck = 1
  if (nTmpFck == NTOT1) then
    ipTmpFckI = ipTmpFck
  else if (nTmpFck == 2*NTOT1) then
    ipTmpFckI = ipTmpFck
    ipTmpFckA = ipTmpFck+nTot1
  else
    write(u6,*) ' Somethings wrong in dim. DFT',nTmpFck
    call Abend()
  end if
  call mma_allocate(TmpD1A,nTot1,Label='TmpD1A')
  call Fold(nSym,nBas,D1A,TmpD1A)
  VIA_DFT = dDot_(nTot1,TmpFck(ipTmpFckI),1,TmpD1A,1)
  call mma_deallocate(TmpD1A)

  ! Transform alpha density from AO to MO

  iOff1 = 1
  iOff2 = 1
  iOff3 = 1
  do iSym=1,nSym
    iBas = nBas(iSym)
    if (iBas == 0) cycle
    iOrb = nOrb(iSym)
    if (iOrb == 0) cycle
    iFro = nFro(iSym)
    call mma_allocate(Tmp1,iBas*iBas,Label='Tmp1')
    call mma_allocate(Tmp2,iOrb*iBas,Label='Tmp2')
    call Square(TmpFck(ipTmpFckI+iOff1-1),Tmp1,1,iBas,iBas)
    call DGEMM_('N','N',iBas,iOrb,iBas,One,Tmp1,iBas,CMO(iOff2+(iFro*iBas)),iBas,Zero,Tmp2,iBas)
    call DGEMM_Tri('T','N',iOrb,iOrb,iBas,One,Tmp2,iBas,CMO(iOff2+(iFro*iBas)),iBas,Zero,TmpFck(ipTmpFckI+iOff3-1),iOrb)
    call mma_deallocate(Tmp2)
    call mma_deallocate(Tmp1)
    iOff1 = iOff1+nTri_Elem(iBas)
    iOff2 = iOff2+iBas*iBas
    iOff3 = iOff3+nTri_Elem(iOrb)
  end do

  ! Transform Active DFT Fock from AO to MO

  if (ipTmpFckA /= -99999) then
    iOff1 = 1
    iOff2 = 1
    iOff3 = 1
    do iSym=1,nSym
      iBas = nBas(iSym)
      if (iBas == 0) cycle
      iOrb = nOrb(iSym)
      if (iOrb == 0) cycle
      iFro = nFro(iSym)
      call mma_allocate(Tmp1,iBas*iBas,Label='Tmp1')
      call mma_allocate(Tmp2,iOrb*iBas,Label='Tmp2')
      call Square(TmpFck(ipTmpFckA+iOff1-1),Tmp1,1,iBas,iBas)
      call DGEMM_('N','N',iBas,iOrb,iBas,One,Tmp1,iBas,CMO(iOff2+(iFro*iBas)),iBas,Zero,Tmp2,iBas)
      call DGEMM_Tri('T','N',iOrb,iOrb,iBas,One,Tmp2,iBas,CMO(iOff2+(iFro*iBas)),iBas,Zero,TmpFck(ipTmpFckA+iOff3-1),iOrb)
      call mma_deallocate(Tmp2)
      call mma_deallocate(Tmp1)
      iOff1 = iOff1+nTri_Elem(iBas)
      iOff2 = iOff2+iBas*iBas
      iOff3 = iOff3+nTri_Elem(iOrb)
    end do
  end if

  !if (DFTFOCK(1:4) /= 'ROKS') then
  !  write(u6,*) ' Just add a,b to FA,FI',DFTFOCK(1:4)
  !else
  !  write(u6,*) ' ROKS formula',DFTFOCK(1:4)
  !end if

  if (DFTFOCK(1:4) /= 'ROKS') then
    FI(1:NTOT1) = FI(1:NTOT1)+TmpFck(ipTmpFckI:ipTmpFckI+NTOT1-1)
    if (ipTmpFckA /= -99999) FA(1:NTOT1) = FA(1:NTOT1)+TmpFck(ipTmpFckA:ipTmpFckA+NTOT1-1)
  else if (DFTFOCK(1:4) == 'ROKS') then
    iOff1 = 0
    do iSym=1,nSym
      do iOrb=1,nOrb(iSym)
        do jOrb=1,iOrb
          ij = iOff1+iTri(iOrb,jOrb)
          if (iOrb <= nIsh(iSym)) FI(ij) = FI(ij)+Half*(TmpFck(ipTmpFckI+ij-1)+TmpFck(ipTmpFckA+ij-1))
          if ((iOrb > nIsh(iSym)) .and. (iOrb <= nIsh(iSym)+nAsh(iSym))) then
            if (jOrb <= nIsh(iSym)) then
              FI(ij) = FI(ij)+TmpFck(ipTmpFckA+ij-1)
            else
              FI(ij) = FI(ij)+Half*(TmpFck(ipTmpFckI+ij-1)+TmpFck(ipTmpFckA+ij-1))
            end if
          end if
          if (iOrb > nIsh(iSym)+nAsh(iSym)) then
            if ((jOrb > nIsh(iSym)) .and. (jOrb <= nIsh(iSym)+nAsh(iSym))) then
              FI(ij) = FI(ij)+TmpFck(ipTmpFckI+ij-1)
            else
              FI(ij) = FI(ij)+Half*(TmpFck(ipTmpFckI+ij-1)+TmpFck(ipTmpFckA+ij-1))
            end if

          end if
        end do
      end do
      iOff1 = iOff1+nTri_Elem(nOrb(iSym))
    end do
  else
    write(u6,*) ' Not implemented yet'
  end if
  call mma_deallocate(TmpFck)
end if
!***********************************************************************
if (iPrLev >= DEBUG) then
  write(u6,*)
  write(u6,*) ' FA in MO-basis in fmat'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    call TriPrt(' ',' ',FA(iOff),iOrb)
    iOff = iOff+nTri_Elem(iOrb)
  end do
end if
! update Fock matrix by rescaling exchange term...
if (NewFock == 1) call Upd_FA(PUVX,FA,D,ExFac)

! print FI and FA
if (iPrLev >= DEBUG) then
  write(u6,*)
  write(u6,*) ' FI in MO-basis in fmat'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    call TriPrt(' ',' ',FI(iOff),iOrb)
    iOff = iOff+nTri_Elem(iOrb)
  end do
end if
if (iPrLev >= DEBUG) then
  write(u6,*)
  write(u6,*) ' FA in MO-basis in fmat after upd_FA'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    call TriPrt(' ',' ',FA(iOff),iOrb)
    iOff = iOff+nTri_Elem(iOrb)
  end do
end if

end subroutine Fmat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      SUBROUTINE Copy_JobIph(InFile,OutFile)
c This is very nasty routine, actually a temporary hack!!!
c should be replaced to a proper copy of JobIph files!
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Character*(*) InFile,OutFile

      call fcopy(InFile,OutFile,ierr)
        if(iErr.ne.0) call abend
c      Junk='cp -p '//File1(1:lFile1)//' '//File2(1:lFile2)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*---------------------------------------------------------------------
* Read input for averd.
*
* Title                -Title
* Wset                -Set of weights. Dimension is Nset.
* iPrint        -How much print.(1=minimal,2=print average orbitals,
*                5=print all orbitals,99=wacko!)
* Nset                -Number of orbitals to read
* DensityBased        -Is the procedure density or orbital based
* ThrOcc        -Print which orbitals have occupation number below
*                this threshold.
*-----------------------------------------------------------------------
      Subroutine Get_Averd_input(Title,Wset,iPrint,Nset,DensityBased
     &                          ,ThrOcc)
      Implicit Real*8 (a-h,o-z)

#include "mxave.fh"
#include "warnings.fh"

      Character*72 Title
      Dimension Wset(MxSets)
      Logical DensityBased

      Character*180 Key
      Character*4 Kword
      Character*180 Get_Ln
      Integer iCLast
      External Get_Ln,iCLast

*
*-- Call subroutines that handle the input.
*
      LuRd=21
      Call SpoolInp(LuRd)
      Rewind(LuRd)
      Call RdNLst(LuRd,'AVERD')

*
*-- Label 1000 is the top.
*
1000  Continue

*
*-- Get_Ln read the keyword and skips line starting with *
*   or is empty.
*
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)

*
*-- The keywords...
*
      If (Kword(1:4).eq.'WSET') Go To 101
      If (Kword(1:4).eq.'PRIN') Go To 102
      If (Kword(1:4).eq.'TITL') Go To 103
      If (Kword(1:4).eq.'ORBI') Go To 104
      If (Kword(1:4).eq.'OCCU') Go To 105
      If (Kword(1:4).eq.'END ') Go To 9999

*
*-- ...and what happens if something else is encountered.
*
      iChrct=Len(KWord)
      Last=iCLast(KWord,iChrct)
      Write(6,*)' '
      Write(6,'(1X,A,A)')Kword(1:Last),' is not a valid keyword!'
      Write(6,*)' ERROR!'
      Call Quit(_RC_INPUT_ERROR_)

*
*-- Read weights.
*
101   Continue
      Key=Get_Ln(LuRd)
      Call Get_I1(1,Nset)
      Key=Get_Ln(LuRd)
      Call Get_F(1,Wset,Nset)
      Go To 1000
*
*-- How much print?
*
102   Continue
      Key=Get_Ln(LuRd)
      Call Get_I1(1,iPrint)
      Go To 1000
*
*-- Title
*
103   Continue
      Key=Get_Ln(LuRd)
      Title=Key(1:Len(Title))
      Go To 1000
*
*-- Should it be density based, or orbital based.
*
104   Continue
      DensityBased=.false.
      Go To 1000

*
*-- I want to be told which orbitals have occ.num. below threshold.
*
105   Continue
      Key=Get_Ln(LuRd)
      Call Get_F1(1,ThrOcc)
      Go To 1000

*
*-- A most Graceful Exit.
*
9999  Continue

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine espf_analysis(lSave)
      Implicit Real*8 (A-H,O-Z)
#include "espf.fh"
*
      Logical Exist,DoTinker,DoGromacs,lMorok,DoDirect,lSave
      Character*10 ESPFKey
      Character*180 ESPFLine, Get_Ln
      External Get_Ln
*
      iPL = iPL_espf()
*
      If (iPL.ge.2) Then
         Write(6,*)
         Call CollapseOutput(1,'   ESPF analysis')
         Write(6,'(3X,A)')     '   -------------'
      End If
*
* Recover some ESPF data
*
      MltOrd = 0
      iRMax = 0
      DeltaR = Zero
      iGrdTyp = 0
      nGrdPt = 0
      DoTinker = .False.
      DoGromacs = .False.
      lMorok = .False.
      DoDirect = .False.
      Call F_Inquire('ESPF.DATA',Exist)
      If (Exist) Then
         IPotFl = IsFreeUnit(1)
         Call Molcas_Open(IPotFl,'ESPF.DATA')
10       ESPFLine = Get_Ln(IPotFl)
         ESPFKey = ESPFLine(1:10)
         If (ESPFKey.eq.'MLTORD    ') Then
            Call Get_I1(2,MltOrd)
            ibla = 0
            Do ii = 0, MltOrd
               ibla = ibla + (ii+2)*(ii+1)/2
            End Do
            MltOrd = ibla
         Else If (ESPFKey.eq.'IRMAX     ') Then
            Call Get_I1(2,iRMax)
         Else If (ESPFKey.eq.'DELTAR    ') Then
            Call Get_F1(2,DeltaR)
         Else If (ESPFKey.eq.'GRIDTYPE  ') Then
            Call Get_I1(2,iGrdTyp)
         Else If (ESPFKey.eq.'GRID      ') Then
            Call Get_I1(2,nGrdPt)
         Else If (ESPFKey.eq.'TINKER    ') Then
            DoTinker = .True.
         Else If (ESPFKey.eq.'GROMACS   ') Then
            DoGromacs = .True.
         Else If (ESPFKey.eq.'LA_MOROK  ') Then
            lMorok = .True.
         Else If (ESPFKey.eq.'DIRECT    ') Then
            DoDirect = .True.
         Else If (ESPFKey.eq.'ENDOFESPF ') Then
            Goto 11
         EndIf
         Goto 10
11       Close (IPotFl)
      Else
         Write(6,*) 'No ESPF.DATA file. Abort'
         Call Quit_OnUserError()
      End If
*
      Call espf_init(natom,nAtQM,ipCord,ipIsMM,ipExt)
      nMult = MltOrd * nAtQM
*
* Read the ESPF potential (and derivatives) from PotFile
*
      IPotFl = IsFreeUnit(33)
      IPotFl=IsFreeUnit(IPotFl)
      Call Molcas_Open(IPotFl,'ESPF.EXTPOT')
      ESPFLine = Get_Ln(IPotFl)
      Call Get_I1(1,nChg)
      If (nChg.ne.0) Then
         Write(6,*) 'ESPF: nChg ne 0 in espf_analysis'
         Call Abend()
      End If
      Do iAt = 1, natom
         ESPFLine = Get_Ln(IPotFl)
         Call Get_I1(1,jAt)
         Call Get_F(2,Work(ipExt+(jAt-1)*MxExtPotComp),MxExtPotComp)
      End Do
      Close(IPotFl)
*
* Compute the grid around the molecule
*
*      nGrdPt = 0
      ipGrid = ip_Dummy
      ipDGrd = ip_Dummy
      If (iGrdTyp.eq.1)
     &   Call GetMem('ESPF_Grid','Allo','Real',ipGrid,3*nGrdPt)
      Call MkGrid(natom,ipCord,ipGrid,nGrdPt,iRMax,DeltaR,.False.,
     &   ipIsMM,iGrdTyp,ipDGrd,nAtQM)
*
* Compute the cartesian tensor T, TtT^-1, [TtT^-1]Tt
* and B=ExtPot[TtT^-1]Tt
* Tt means the transpose of T
*
      iSize1 = nMult * nGrdPt
      iSize2 = nMult * nMult
      iSize3 = nMult * Max(nMult,nGrdPt)
      Call GetMem('CartTensor','Allo','Real',ipT,iSize1)
      Call GetMem('TT','Allo','Real',ipTT,iSize2)
      Call GetMem('TTT','Allo','Real',ipTTT,iSize3)
      Call GetMem('ExtPot*TTT','Allo','Real',ipB,nGrdPt)
      Call InitB(nMult,natom,nAtQM,nGrdPt,ipCord,ipGrid,ipT,ipTT,ipTTT,
     &           ipExt,ipB,ipIsMM)
*
* Now the analysis
*
      Call GetMem('ESPFMltp','Allo','Real',ipMltp,nMult)
      Call espf_mltp(natom,MltOrd,nMult,nGrdPt,ipTTT,ipMltp,ipGrid,
     &               ipIsMM,ipExt,iPL+1)
      Call Add_Info('ESPF multipoles',Work(ipMltp),nMult,6)
*
* Save some data
*
      If (lSave) Call espf_write(MltOrd,iRMax,DeltaR,iGrdTyp,nGrdPt,
     &                DoTinker,DoGromacs,lMorok,ipMltp,nMult,ipIsMM,
     &                natom,.False.,.False.,DoDirect)
*
* The end
*
      If (iPL.ge.2) Then
         Call CollapseOutput(0,'   ESPF analysis')
         Write(6,*)
      End If
      Call GetMem('ESPFMltp','Free','Real',ipMltp,nMult)
      Call GetMem('ExtPot*TTT','Free','Real',ipB,nGrdPt)
      Call GetMem('TTT','Free','Real',ipTTT,iSize3)
      Call GetMem('TT','Free','Real',ipTT,iSize2)
      Call GetMem('CartTensor','Free','Real',ipT,iSize1)
      Call GetMem('ESPF_Grid','Free','Real',ipGrid,3*nGrdPt)
      Call GetMem('ExtPot','Free','Real',ipExt,natom*MxExtPotComp)
      Call GetMem('IsMM for atoms','Free','Inte',ipIsMM,natom)
      Call GetMem('AtomCoord','Free','Real',ipCord,3*natom)
*
      Call ClsSew()
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Find_Min(nOrder,XStart,A,XMin,RC,XLow,XHi,ENew)

use PrintLevel, only: nPrint
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nOrder
real(kind=wp), intent(in) :: XStart, A(0:nOrder), XLow, XHi
real(kind=wp), intent(out) :: XMin, ENew
logical(kind=iwp), intent(out) :: RC
integer(kind=iwp) :: i, iPrint, iRout, j, MaxIter
real(kind=wp) :: ddfnc, dfnc, fnc, tmp, X, XInc, XValue, XX
real(kind=wp), parameter :: Thr = 1.0e-12_wp

iRout = 117
iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
call RecPrt('Find_Min: A',' ',A,1,nOrder+1)
#endif
XValue = XStart
RC = .false.
MaxIter = 100
do i=1,MaxIter
  X = XValue
  fnc = Zero
  XX = One
  do j=0,nOrder
    fnc = fnc+A(j)*XX
    XX = XX*X
  end do
  dfnc = Zero
  XX = One
  do j=1,nOrder
    tmp = real(j,kind=wp)
    dfnc = dfnc+A(j)*tmp*XX
    XX = XX*X
  end do
  ddfnc = Zero
  XX = One
  do j=2,nOrder
    tmp = real(j*j-j,kind=wp)
    ddfnc = ddfnc+A(j)*tmp*XX
    XX = XX*X
  end do
  XInc = dfnc/ddfnc
  XValue = XValue-XInc
# ifdef _DEBUGPRINT_
  write(u6,*) 'Fnc,dFnc,ddFnc=',Fnc,dFnc,ddFnc
# endif
  if (abs(XInc) < Thr) then
    ENew = fnc
    XMin = XValue
    RC = .true.
    exit
  end if
  if (XValue > XHi) XValue = XHi
  if (XValue < XLow) XValue = XLow
end do
if ((.not. RC) .and. (iPrint >= 6)) write(u6,*) '-- Too many iterations in Find_Min'

return

end subroutine Find_Min

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Giovanni Ghigo                                   *
*               2005, Francesco Aquilante                              *
************************************************************************
************************************************************************
* This Driver precedes the standard (TraCtl) and Cholesky (Cho_TraCtl) *
* AO/MO two-electrons transformation programs.                         *
* -------------------------------------------------------------------- *
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden                                    *
* Written:  August-September 2004                                      *
* Modified for Cholesky-MP2 May 2005                                   *
************************************************************************
*  TraCtl
*
*> @brief
*>   Driver that calls the Cholesky or the Conventional routine for the
*>   generation of the two-electrons integrals file in MO basis.
*> @author Giovanni Ghigo
*> @modified_by F. Aquilante
*>
*> @details
*> All programs that need the generation of the two-electrons
*> integrals file in MO basis must tell to the Cholesky routine
*> who they are through \p iType:
*>
*> - ``1``: MBPT2
*> - ``2``: CASPT2
*> - ``3``: MCLR
*> - ``4``: CC
*>
*> Programs must also tell to the Cholesky routine whether they need
*> exchange-2 integrals through logical variable \p DoExch2. Both
*> values are not used by the Conventional routine.
*>
*> @param[in] iType   Caller program
*> @param[in] DoExch2 Flag for the generation of Exch-2 integrals
*> @param[in] iPart   Partitioning of temp files
************************************************************************
      SUBROUTINE TraCtl_Drv(iType,DoExch2,iPart)
      Implicit Real*8 (a-h,o-z)
      Integer iType
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
      Logical DoCholesky, DoExch2
#include "chocaspt2.fh"
      Character*10 SECNAM

      SECNAM='TraCtl_Drv'

      Call DecideOnCholesky(DoCholesky)

      If (DoCholesky) then

        If (iType.EQ.1) then

          Call ChoMP2_TraCtl(LUINTM,Work(LCMO),NCMO)

        elseIf (iALGO.eq.0) Then

          Call Cho_TraCtl(iType,LUINTM,Work(LCMO),NCMO,DoExch2)

        elseIf (iALGO.eq.1) Then

* caspt2 with cholesky does no longer use call to tractl_drv/cho_caspt2_drv
*          Call Cho_caspt2_drv(Work(LCMO))

        else

          Call Cho_x_Quit(SecNam,' !!! Unknown algorithm !!! ',' ')

        EndIf

      Else

        Call TRACTL(iPart)

      EndIf


      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Per Ake Malmqvist                                *
!***********************************************************************

subroutine CREIPH_CASPT2(Heff,Ueff,U0,nState)
! Normal operation: A new file, 'JOBMIX', will be created, with the
! CMO's and CI arrays of the JOBIPH, except that the CI arrays have
! been modified. They are now linear combinations of the original ones,
! using coefficients taken from the eigenvectors of the effective
! Hamiltonian.
! Also, replace the original CASSCF energies with CASPT2 or MS-CASPT2
! energies.

use fciqmc_interface, only: DoFCIQMC
use PrintLevel, only: USUAL
use REFWFN, only: IADR15, REFWFN_FILENAME
use sguga, only: L2ACT, LEVEL
use Molcas, only: LenIn, MxAct, MxLev, MxOrb, MxRoot
use RASDim, only: MxIter, MxTit
use caspt2_global, only: CMO, CMO_Internal, iPrGlb, NCMO, Weight
use caspt2_module, only: BNAME, CITHR, DOCUMULANT, ENERGY, HEADER, IFMIX, IFMSCOUP, IFQCAN, IFRMS, IFXMS, IROOT, ISCF, ISPIN, &
                         LROOTS, MSTATE, MSTATE, MXCI, NACTEL, NASH, NBAS, NBSQT, NCONF, NDEL, NELE3, NFRO, NHOLE1, NISH, NRAS1, &
                         NRAS2, NRAS3, NROOTS, NSYM, POTNUC, STSYM, TITLE
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Nstate
real(kind=wp), intent(in) :: Heff(Nstate,Nstate), Ueff(Nstate,Nstate), U0(Nstate,Nstate)
integer(kind=iwp) :: I, IAD15, ID, IDISK, IDR, IDW, IISTATE, ISNUM, ISTATE, J, JOBIPH, JOBMIX, JSNUM, MROOTS, NIDIST, NOLDE
integer(kind=iwp), allocatable :: IDIST(:), JROOT(:), xL2Act(:), xLevel(:)
real(kind=wp), allocatable :: CI1(:), CI2(:), EFFCP(:), OLDE(:), Weight_(:)

! Not called, if .not. IFMIX, then only the new CI coefficients are
! printed, no JOBMIX file is created.
if (IFMSCOUP .and. (ISCF == 0)) then
  if (.not. IFMIX) then
    if (IPRGLB >= USUAL) call PRINT_CI_MIX(Ueff)
    return
  end if
end if
if (DOCUMULANT .or. (.not. IFMIX)) return

if (DoFCIQMC) return

if (IFMSCOUP) then
  if (IPRGLB >= USUAL) then
    write(u6,*) ' THE ORIGINAL CI ARRAYS ARE NOW MIXED AS LINEAR'
    write(u6,*) ' COMBINATIONS, GIVEN BY THE EIGENVECTORS.'
  end if
end if

if (IPRGLB >= USUAL) then
  write(u6,*) ' A NEW JOBIPH FILE NAMED ''JOBMIX'' IS PREPARED.'
  write(u6,'(A)') repeat('*',80)
end if

! Note that JOBIPH file will contain all the RASSCF CI vectors
! plus a CASPT2 effective Hamiltonian for the selected states.
! The effective Hamiltonian for the states not included in the
! CASPT2 treatment will be diagonal with RASSCF energies!

! The JOBMIX will contain the (possibly mixed) CI vectors,
! with CASPT2 energies for the selected states and zero energy
! for states not included in the CASPT2 treatment
! If NoMulti was specified, the original state indexing is
! maintained, otherwise the new states are just 1, 2, 3...

call mma_allocate(CI1,MXCI,Label='CI1')
call mma_allocate(CI2,MXCI,Label='CI2')
JOBIPH = 15
call DANAME(JOBIPH,refwfn_filename)
JOBMIX = 11
call DANAME(JOBMIX,'JOBMIX')
! IADR15 is already known (it is the table of contents of the
! JOBIPH file). When copying/modifying selected data from JOBIPH
! to JOBMIX, we use the same TOC array, IADR15.
IAD15 = 0
call IDAFILE(JOBIPH,2,IADR15,30,IAD15)
IAD15 = 0
call IDAFILE(JOBMIX,1,IADR15,30,IAD15)
IAD15 = IADR15(1)
! Modify root index in case of MS
call mma_allocate(JROOT,MXROOT,LABEL='JROOT')
if (IFMSCOUP) then
  JROOT(1:NSTATE) = [(ISTATE,ISTATE=1,NSTATE)]
  JROOT(NSTATE+1:) = 0
  MROOTS = NSTATE
else
  JROOT(:) = IROOT(:)
  MROOTS = NROOTS
end if
call mma_allocate(Weight_,MxRoot,Label='Weight_')
WEIGHT_(1:NROOTS) = WEIGHT(1:NROOTS)
WEIGHT_(NROOTS+1:) = Zero
call WR_RASSCF_INFO(JOBMIX,1,iAd15,NACTEL,ISPIN,NSYM,STSYM,NFRO,NISH,NASH,NDEL,NBAS,8,BNAME,(LenIn+8)*MXORB,NCONF,HEADER,144, &
                    TITLE,4*18*MXTIT,POTNUC,LROOTS,MROOTS,JROOT,MXROOT,NRAS1,NRAS2,NRAS3,NHOLE1,NELE3,IFQCAN,Weight_)
call mma_deallocate(Weight_)
call mma_deallocate(JROOT)
! Copy MO coefficients from JOBIPH to JOBMIX
NCMO = NBSQT
call mma_allocate(CMO_Internal,NCMO,Label='CMO_Internal')
CMO => CMO_Internal
IAD15 = IADR15(9)
call DDAFILE(JOBIPH,2,CMO,NCMO,IAD15)
IAD15 = IADR15(9)
call DDAFILE(JOBMIX,1,CMO,NCMO,IAD15)
! If IFQCAN == 0, there is also an additional CMO set:
if (IFQCAN == 0) then
  IAD15 = IADR15(2)
  call DDAFILE(JOBIPH,2,CMO,NCMO,IAD15)
  IAD15 = IADR15(2)
  call DDAFILE(JOBMIX,1,CMO,NCMO,IAD15)
end if
call mma_deallocate(CMO_Internal)
nullify(CMO)
! Copy all CI coefficients
IDR = IADR15(4)
IDW = IADR15(4)
do I=1,LROOTS
  call DDAFILE(JOBIPH,2,CI1,NCONF,IDR)
  call DDAFILE(JOBMIX,1,CI1,NCONF,IDW)
end do
! Replace old energy array with (MS-)CASPT2 energy values:
NOLDE = MXROOT*MXITER
call mma_allocate(OLDE,NOLDE,LABEL='OLDE')
OLDE(:) = Zero
if (IFMSCOUP) then
  OLDE(1:NSTATE) = ENERGY(1:NSTATE)
else
  do ISTATE=1,NSTATE
    OLDE(MSTATE(ISTATE)) = ENERGY(ISTATE)
  end do
end if
IAD15 = IADR15(6)
call DDAFILE(JOBMIX,1,OLDE,NOLDE,IAD15)
call mma_deallocate(OLDE)
IAD15 = IADR15(18)
!SVC: translates levels to orbital index
!Copy to local array since L2Act and Level are protected.
call mma_allocate(xL2Act,MxLev,Label='xL2Act')
call mma_allocate(xLevel,MxLev,Label='xLevel')
XL2Act(:) = L2Act(:)
call IDAFILE(JOBMIX,1,xL2ACT,mxAct,IAD15)
!SVC: translates orbital index to levels
XLevel(:) = Level(:)
call IDAFILE(JOBMIX,1,xLEVEL,mxAct,IAD15)
call mma_deallocate(xL2Act)
call mma_deallocate(xLevel)

! PAM07: Eliminate unsafe IPOSFILE calls, use instead dummy i/o operations
! to find disk addresses to CI arrays:
NIDIST = maxval(MSTATE(1:NSTATE))
call mma_allocate(IDIST,NIDIST,Label='IDIST')
ID = IADR15(4)
do JSNUM=1,NIDIST
  IDIST(JSNUM) = ID
  ! This dummy operation does nothing, merely updates file pointer ID
  call DDAFILE(JOBIPH,0,CI1,NCONF,ID)
end do
! PAM07: Now IDIST() is used, instead of IPOSFILE, below!

! PAM05: Now CREIPH is called also in the NOMULT=1 case, to allow making
! a JOBMIX file also when NOMULT was ordered. Then the energies
! will be state-specific, of course. But no mixing of CI vectors.
if (IFMSCOUP) then
  ! Also write effective Hamiltonian on Jobiph file:
  call mma_allocate(EFFCP,LROOTS**2,Label='EFFCP')
  ! Read the effective Hamiltonian on JobIph file:
  IAD15 = IADR15(17)
  call DDAFILE(JOBIPH,2,EFFCP,LROOTS**2,IAD15)
  ! Replace the relevant elements:
  do I=1,NSTATE
    ISNUM = MSTATE(I)
    do J=1,NSTATE
      JSNUM = MSTATE(J)
      EFFCP(ISNUM+LROOTS*(JSNUM-1)) = HEFF(I,J)
    end do
  end do
  ! Write the present effective Hamiltonian:
  IAD15 = IADR15(17)
  call DDAFILE(JOBIPH,1,EFFCP,LROOTS**2,IAD15)
  ! Write a diagonal Hamiltonian in the JOBMIX:
  IAD15 = IADR15(17)
  EFFCP(:) = Zero
  do ISTATE=1,NSTATE
    EFFCP((ISTATE-1)*LROOTS+ISTATE) = ENERGY(ISTATE)
  end do
  call DDAFILE(JOBMIX,1,EFFCP,LROOTS**2,IAD15)
  call mma_deallocate(EFFCP)
  ! Now 'mix' those states that were treated in the multi-state CASPT2
  if (IPRGLB >= USUAL) then
    write(u6,*)
    call CollapseOutput(1,'Mixed CI coefficients:')
  end if
  do ISTATE=1,NSTATE
    CI2(:) = Zero
    do IISTATE=1,NSTATE
      JSNUM = MSTATE(IISTATE)
      IDISK = IDIST(JSNUM)
      call DDAFILE(JOBIPH,2,CI1,NCONF,IDISK)
      CI2(1:NCONF) = CI2(1:NCONF)+Ueff(IISTATE,ISTATE)*CI1(1:NCONF)
    end do
    if (ISCF == 0) then
      if (IPRGLB >= USUAL) then
        write(u6,'(1x,a,i3)') ' The CI coefficients for the MIXED state nr. ',ISTATE
        call PRWF_CP2(STSYM,NCONF,CI2,CITHR)
      end if
    end if
    IDISK = IDIST(ISTATE)
    call DDAFILE(JOBMIX,1,CI2,NCONF,IDISK)
  end do
  if (IPRGLB >= USUAL) then
    call CollapseOutput(0,'Mixed CI coefficients:')
    write(u6,*)
  end if
else if (IFXMS .or. IFRMS) then
  ! In case of XMS/XDW/RMS and NOMUL, the CI vectors are replaced by the
  ! rotated zeroth-order states (they should have been printed earlier,
  ! in grpini)
  do ISTATE=1,NSTATE
    ISNUM = MSTATE(ISTATE)
    CI2(:) = Zero
    do IISTATE=1,NSTATE
      JSNUM = MSTATE(IISTATE)
      IDISK = IDIST(JSNUM)
      call DDAFILE(JOBIPH,2,CI1,NCONF,IDISK)
      CI2(1:NCONF) = CI2(1:NCONF)+U0(IISTATE,ISTATE)*CI1(1:NCONF)
    end do
    IDISK = IDIST(ISNUM)
    call DDAFILE(JOBMIX,1,CI2,NCONF,IDISK)
  end do
end if

call mma_deallocate(IDIST)
call mma_deallocate(CI1)
call mma_deallocate(CI2)

call DACLOS(JOBIPH)
call DACLOS(JOBMIX)

end subroutine CREIPH_CASPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Giovanni Li Manni                                *
************************************************************************
      SUBROUTINE NXTDIST(NSMST,NGRP,NELMNT,KGRP,ISMDFGP,SCR,
     &                   NACTSYM,NONEW)
*
* NONEW = 1 on return indicates that no additional numbers
* could be obtained.
*
*Giovanni Li Manni Feb 2012
*
**************
*. Input
**************
* NSMST   = Number of Irreps
* NGRP    = Number of Groups
* NELMNT  = Number of GAS spaces
* KGRP    = K supergroup
* ISMDFGP = Symmetry distributions per group
**************
* OUTPUT
**************
* NONEW
********************
*. Input and output
********************
      INTEGER KGRP(NELMNT),ISMDFGP(NSMST,NGRP),NELMNT
      INTEGER SCR(NELMNT), NACTSYM(NGRP)
*
       NTEST = 0
       IF(NTEST.NE.0) THEN
         write(6,*) 'NACTSYM : '
         call IWRTMA(NACTSYM,1,NGRP,1,NGRP)
         write(6,*) ' ISMDFGP  Table:'
         do J = 1, NSMST
           WRITE(6,'(40I2)') (ISMDFGP(J,I), I=1,NGRP)
         end do
         write(6,*) 'Initial SCR'
         call IWRTMA(SCR,1,NELMNT,1,NELMNT)
       END IF
*
      IF(NELMNT.EQ.0) THEN
        NONEW = 1
        GOTO 1001
      END IF
*
      IPLACE = 0
 1000 CONTINUE
        IPLACE = IPLACE + 1
        IF(SCR(IPLACE).LT.NACTSYM(KGRP(IPLACE))) THEN
          SCR(IPLACE) =  SCR(IPLACE) + 1
          NONEW = 0
          GOTO 1001
        ELSE IF ( IPLACE.LT.NELMNT) THEN
          DO JPLACE = 1, IPLACE
            SCR(JPLACE) = 1
          END DO
        ELSE IF ( IPLACE. EQ. NELMNT ) THEN
          NONEW = 1
          GOTO 1001
        END IF
      GOTO 1000
 1001 CONTINUE
*
      IF(NTEST.ne.0) then
        write(6,*) 'New ISMDFGP'
        write(6,'(40I2)') (ISMDFGP(SCR(IGAS),KGRP(IGAS)), IGAS=1,NELMNT)
      end if

      IF(NTEST.NE.0) THEN
        write(6,*) ' New SCR'
        CALL IWRTMA(SCR,1,NELMNT,1,NELMNT)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine ModU2( &
#                define _CALLING_
#                include "modu2_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: precompute u2/(zeta+eta)                                     *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             May '90                                                  *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
#include "modu2_interface.fh"
integer(kind=iwp) :: iT

#ifdef _DEBUGPRINT_
call RecPrt(' In ModU2: U2',' ',U2,nRys,mT)
call RecPrt(' In ModU2: ZEInv',' ',ZEInv,1,mT)
#endif

if (nRys > 1) then
  do iT=1,mT
    U2(:,iT) = U2(:,iT)*ZEInv(iT)
  end do
else
  U2(1,:) = U2(1,:)*ZEInv(:)
end if

end subroutine ModU2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine WriteFreq(Freq,NormModes,l_NormModes,Title)

use Constants, only: auTocm, auToHz
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: l_NormModes, NormModes(l_NormModes)
real(kind=wp), intent(in) :: Freq(l_NormModes)
character(len=*), intent(in) :: Title
integer(kind=iwp) :: i, NumInt
real(kind=wp) :: frequency
character(len=8) :: F1

F1 = '(a2,a)'
NumInt = l_NormModes
write(u6,*)
write(u6,*)
write(u6,*)
write(u6,F1) ' ',Title
write(u6,F1) ' ','===================================================='
write(u6,F1) ' ',' mode        1/cm             GHz          hartrees'
write(u6,F1) ' ','----------------------------------------------------'
do i=1,NumInt
  frequency = Freq(i)
  write(u6,'(A3,I2,A1,A3,F14.8,F18.8,F12.8)') ' ',NormModes(i),'.',' ',frequency*auTocm,frequency*auToHz*1.0e-6_wp,frequency
end do
write(u6,F1) ' ','===================================================='
write(u6,*)
write(u6,*)

end subroutine WriteFreq

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Print_EigenValues(H,nH)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nH
real(kind=wp), intent(in) :: H(nTri_Elem(nH))
integer(kind=iwp) :: i
real(kind=wp), allocatable :: EVal(:), EVec(:,:)

call mma_allocate(EVal,nTri_Elem(nH),label='EVal')
call mma_allocate(EVec,nH,nH,label='EVec')

! Copy elements for H

EVal(:) = H

! Set up a unit matrix

call unitmat(EVec,nH)

! Compute eigenvalues and eigenvectors

call Jacob(EVal,EVec,nH,nH)
call Jacord(EVal,EVec,nH,nH)

! Print out the result

write(u6,*)
write(u6,*) 'Eigenvalues of the matrix'
write(u6,*)
write(u6,'(10F15.8)') (EVal(nTri_Elem(i)),i=1,nH)

call mma_deallocate(EVal)
call mma_deallocate(EVec)

return

end subroutine Print_EigenValues

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------
! 1998  PER-AAKE MALMQUIST
! DEPARTMENT OF THEORETICAL CHEMISTRY
! UNIVERSITY OF LUND
! SWEDEN
!--------------------------------------------

subroutine MKRHSH(IVEC,ERI1,nERI1,ERI2,nERI2,SCR,nSCR)
! Set up RHS vector of PT2 Linear Equation System, in vector
! number IVEC of LUSOLV, for cases 12 and 13 (BJAI).

use Symmetry_Info, only: Mul
use SUPERINDEX, only: KAGEB, KAGTB, KIGEJ, KIGTJ
use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array, GA_Arrays
use caspt2_module, only: NAGEB, NAGEBES, NAGTB, NAGTBES, NASH, NIES, NIGEJ, NIGEJES, NIGTJ, NIGTJES, NISH, NORB, NSES, NSSH, NSYM
use Constants, only: Three, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, nERI1, nERI2, nSCR
real(kind=wp), intent(inout) :: ERI1(nERI1), ERI2(nERI2), SCR(nSCR)
integer(kind=iwp) :: IA, IAABS, IATOT, IB, IBABS, IBTOT, IBUF, ICASE, II, IIABS, IJ, IJABS, ISYM, ISYMA, ISYMB, ISYMI, ISYMJ, &
                     IVAM, IVAP, IVIM, IVIP, IVM, IVP, LVM, LVP, NASM, NASP, NISM, NISP, NVM, NVP
real(kind=wp) :: A, B
real(kind=wp), parameter :: SQI2 = sqrt(Half), SQ3 = sqrt(Three)

do ISYM=1,NSYM
  NASP = NAGEB(ISYM)
  NISP = NIGEJ(ISYM)
  NVP = NASP*NISP
  if (NVP == 0) cycle
  NASM = NAGTB(ISYM)
  NISM = NIGTJ(ISYM)
  NVM = NASM*NISM
  LVP = Allocate_GA_Array(NVP,'WHP')
  if (NVM > 0) LVM = Allocate_GA_Array(NVM,'WHM')
  !  VP(ij,ab)=2*((aibj)+(ajbi))
  ! With new norm., divide by /SQRT(4*(1+Kron(ij))*(1+Kron(ab))
  !   VM(ij,ab)=6*((aibj)-(ajbi))
  ! With new norm., divide by /SQRT(12)
  do ISYMA=1,NSYM
    ISYMB = Mul(ISYMA,ISYM)
    if (ISYMA < ISYMB) cycle
    do ISYMI=1,NSYM
      ISYMJ = Mul(ISYMI,ISYM)
      if (ISYMI < ISYMJ) cycle
      do II=1,NISH(ISYMI)
        IIABS = II+NIES(ISYMI)
        do IJ=1,NISH(ISYMJ)
          IJABS = IJ+NIES(ISYMJ)
          if (IIABS < IJABS) exit
          call EXCH(ISYMA,ISYMI,ISYMB,ISYMJ,II,IJ,ERI1,SCR)
          call EXCH(ISYMA,ISYMJ,ISYMB,ISYMI,IJ,II,ERI2,SCR)
          do IA=1,NSSH(ISYMA)
            IAABS = IA+NSES(ISYMA)
            IATOT = IA+NISH(ISYMA)+NASH(ISYMA)
            do IB=1,NSSH(ISYMB)
              IBABS = IB+NSES(ISYMB)
              if (IAABS < IBABS) exit
              IBTOT = IB+NISH(ISYMB)+NASH(ISYMB)
              IBUF = IATOT+NORB(ISYMA)*(IBTOT-1)
              IVAP = KAGEB(IAABS,IBABS)-NAGEBES(ISYM)
              IVIP = KIGEJ(IIABS,IJABS)-NIGEJES(ISYM)
              IVP = IVAP+NAGEB(ISYM)*(IVIP-1)
              A = ERI1(IBUF)+ERI2(IBUF)
              if (IIABS /= IJABS) then
                if (IAABS /= IBABS) then
                  GA_Arrays(LVP)%A(IVP) = A
                  IVAM = KAGTB(IAABS,IBABS)-NAGTBES(ISYM)
                  IVIM = KIGTJ(IIABS,IJABS)-NIGTJES(ISYM)
                  IVM = IVAM+NAGTB(ISYM)*(IVIM-1)
                  B = ERI1(IBUF)-ERI2(IBUF)
                  GA_Arrays(LVM)%A(IVM) = SQ3*B
                else
                  GA_Arrays(LVP)%A(IVP) = SQI2*A
                end if
              else
                if (IAABS /= IBABS) then
                  GA_Arrays(LVP)%A(IVP) = SQI2*A
                else
                  GA_Arrays(LVP)%A(IVP) = Half*A
                end if
              end if
            end do
          end do
        end do
      end do
    end do
  end do

  ICASE = 12
  call MKRHS_SAVE(ICASE,ISYM,IVEC,LVP)
  call Deallocate_GA_Array(LVP)
  if (NVM > 0) then
    ICASE = 13
    call MKRHS_SAVE(ICASE,ISYM,IVEC,LVM)
    call Deallocate_GA_Array(LVM)
  end if
end do

end subroutine MKRHSH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine ExV_X43 (Vp,V,dimab,no)
c
c       this routine do:
c       Vp(a_b,ij) <- V(a_b,j,i) for i>=j
c
        implicit none
        integer dimab,no
        real*8 Vp(1:dimab,1:no*(no+1)/2)
        real*8 V(1:dimab,1:no,1:no)
c
c       help variables
        integer i,j,ij,ab
c
        ij=0
        do i=1,no
        do j=1,i
        ij=ij+1
          do ab=1,dimab
            Vp(ab,ij)=V(ab,j,i)
          end do
        end do
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Markus P. Fuelscher                              *
*               1994, Per Ake Malmqvist                                *
************************************************************************
      Subroutine PrInp_CASPT2
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     - echo the input parameters                                      *
*                                                                      *
*     calling parameters: none                                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and P.-AA. Malmqvist                              *
*     University of Lund, Sweden, 1994                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "pt2_guga.fh"
      Character(Len=8)   Fmt1,Fmt2
      Character(Len=120)  Line,BlLine,StLine
      Character(Len=3) lIrrep(8)
      Character(Len=20) calctype,FockOpType
*----------------------------------------------------------------------*
*     Start and define the paper width                                 *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*     Initialize blank and header lines                                *
*----------------------------------------------------------------------*
      Line=' '
      lLine=Len(Line)
      Do i=1,lLine
        BlLine(i:i)=' '
        StLine(i:i)='*'
      End Do
      lPaper=132
      left=(lPaper-lLine)/2
      WRITE(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
      WRITE(Fmt2,'(A,I3.3,A)') '(',left,'X,'
*----------------------------------------------------------------------*
*     Print the ONEINT file identifier                                 *
*----------------------------------------------------------------------*
      IF(IPRGLB.GE.VERBOSE) THEN
      WRITE(6,*)
      WRITE(6,Fmt1) 'Header of the ONEINT file:'
      WRITE(6,Fmt1) '--------------------------'
      WRITE(Line,'(36A2)') (Header(i),i=1,36)
      Call LeftAd(Line)
      WRITE(6,Fmt1)  Line(:mylen(Line))
      WRITE(Line,'(36A2)') (Header(i),i=37,72)
      Call LeftAd(Line)
      WRITE(6,Fmt1)  Line(:mylen(Line))
      WRITE(6,*)
      END IF
*----------------------------------------------------------------------*
*     Print cartesian coordinates of the system                        *
*----------------------------------------------------------------------*
      IF(IPRGLB.GE.VERBOSE) THEN
      Call PrCoor
      END IF
*----------------------------------------------------------------------*
*     Print orbital and wavefunction specifications                    *
*----------------------------------------------------------------------*
      IF(IPRGLB.GE.USUAL) THEN
      WRITE(6,*)
      Line=' '
      WRITE(Line(left-2:),'(A)') 'Wave function specifications:'
      CALL CollapseOutput(1,Line)
      WRITE(6,Fmt1)'-----------------------------'
      WRITE(6,*)
      WRITE(6,Fmt2//'A,T45,I6)')'Number of closed shell electrons',
     &                           2*NISHT
      WRITE(6,Fmt2//'A,T45,I6)')'Number of electrons in active shells',
     &                           NACTEL
      WRITE(6,Fmt2//'A,T45,I6)')'Max number of holes in RAS1 space',
     &                           NHOLE1
      WRITE(6,Fmt2//'A,T45,I6)')'Max number of electrons in RAS3 space',
     &                           NELE3
      WRITE(6,Fmt2//'A,T45,I6)')'Number of inactive orbitals',
     &                           NISHT
      WRITE(6,Fmt2//'A,T45,I6)')'Number of active orbitals',
     &                           NASHT
      WRITE(6,Fmt2//'A,T45,I6)')'Number of secondary orbitals',
     &                           NSSHT
      WRITE(6,Fmt2//'A,T45,F6.1)')'Spin quantum number',
     &                           0.5D0*DBLE(ISPIN-1)
      WRITE(6,Fmt2//'A,T45,I6)')'State symmetry',
     &                           LSYM
      WRITE(6,Fmt2//'A,T40,I11)')'Number of CSFs',
     &                           NCONF
      WRITE(6,Fmt2//'A,T45,I6)')'Number of root(s) available',
     &                           NROOTS
      WRITE(6,Fmt2//'A,T45,I6)')'Root passed to geometry opt.',
     &                           iRlxRoot
      IF(IFMIX) THEN
        WRITE(6,Fmt2//'A,T45,10I3)')'A file JOBMIX will be created'
      END IF
      IF(NSTATE.GT.1) THEN
        WRITE(6,Fmt1) 'This is a MULTI-STATE CASSCF reference'
        WRITE(6,Fmt2//'A,T45,I6)')'Number of CI roots used',
     &                           NSTATE
        WRITE(6,Fmt2//'A,(T47,10I4))')'These are:',
     &                           (MSTATE(I),I=1,NSTATE)
        IF(IFMSCOUP) THEN
           WRITE(6,Fmt1) 'Off-diagonal elements of Heff are computed'
        ELSE
           WRITE(6,Fmt1) 'Heff is assumed diagonal'
        ENDIF
      ELSE
        If ( ISCF.eq.0 ) then
           WRITE(6,Fmt1) 'This is a CASSCF or RASSCF reference function'
#ifdef _ENABLE_BLOCK_DMRG_
           If (DoCumulant) then
              write(6,Fmt1) 'Using 4-RDM cumulant approximation,' //
     &                      ' activated by 3RDM keyword in RASSCF'
           End If
#elif _ENABLE_CHEMPS2_DMRG_
           If (DoCumulant) then
            write(6,Fmt1) 'This is a DMRG reference with exact 4-RDM,'//
     &                    ' activated by 3RDM keyword in RASSCF'
           End If
#endif
        Else If ( ISCF.eq.1 ) then
           WRITE(6,Fmt1) 'This is a closed shell RHF reference function'
        Else
           WRITE(6,Fmt1)
     &     'This is a high spin open shell RHF reference function'
        End If
      END IF
      CALL CollapseOutput(0,'Wave function specifications:')
      END IF
*
      Call Get_cArray('Irreps',lIrrep,24)
      Do iSym = 1, nSym
         Call RightAd(lIrrep(iSym))
      End Do
*
      IF(IPRGLB.GE.USUAL  ) THEN
      WRITE(6,*)
      Line=' '
      WRITE(Line(left-2:),'(A)') 'Orbital specifications:'
      CALL CollapseOutput(1,Line)
      WRITe(6,Fmt1)'-----------------------'
      WRITE(6,*)
      WRITE(6,Fmt2//'A,T47,8I4)') 'Symmetry species',
     &                            (iSym,iSym=1,nSym)
      WRITE(6,Fmt2//'A,T47,8(1X,A))') '                ',
     &                            (lIrrep(iSym),iSym=1,nSym)
      WRITE(6,Fmt2//'A,T47,8I4)') 'Frozen orbitals',
     &                            (nFro(iSym),iSym=1,nSym)
      WRITE(6,Fmt2//'A,T47,8I4)') 'Inactive orbitals',
     &                            (nIsh(iSym),iSym=1,nSym)
      WRITE(6,Fmt2//'A,T47,8I4)') 'Active orbitals',
     &                            (nAsh(iSym),iSym=1,nSym)
      WRITE(6,Fmt2//'A,T47,8I4)') 'Secondary orbitals',
     &                            (nSsh(iSym),iSym=1,nSym)
      WRITE(6,Fmt2//'A,T47,8I4)') 'Deleted orbitals',
     &                            (nDel(iSym),iSym=1,nSym)
      WRITE(6,Fmt2//'A,T47,8I4)') 'Number of basis functions',
     &                            (nBas(iSym),iSym=1,nSym)
      CALL CollapseOutput(0,'Orbital specifications:')
      END IF
*----------------------------------------------------------------------*
*     Print routing information                                        *
*----------------------------------------------------------------------*
      IF (IPRGLB.GE.TERSE) THEN
        If ( RFpert ) then
          WRITE(6,*)
          WRITE(6,Fmt1)'Reaction field specifications:'
          WRITE(6,Fmt1)'------------------------------'
          WRITE(6,*)
          WRITE(6,'(6X,A)')'An external reaction field was determined'//
     &        ' previously and added to the one-electron Hamiltonian'
          WRITE(6,'(6X,A)')'It will not be reevaluated even though'//
     &               ' dynamic correlation may change the density.'
          WRITE(6,*)
        End If

        write(6,*)
        Line=' '
        write(Line(left-2:),'(A)') 'CASPT2 specifications:'
        call CollapseOutput(1,Line)
        write(6,Fmt1)'----------------------'
        write(6,*)

        if (IFMSCOUP) then
          if (IFDW) then
            FockOpType='dynamically weighted'
            if (IFXMS) then
              calctype='XDW-CASPT2'
            else
              calctype='DW-CASPT2'
            end if
          else
            if (IFXMS) then
              FockOpType='state-average'
              calctype='XMS-CASPT2'
            else
              FockOpType='state-specific'
              calctype='MS-CASPT2'
            end if
          end if
        else
          FockOpType='state-specific'
          calctype='SS-CASPT2'
        end if

        write(6,Fmt2//'A,T50,A)')'Type of calculation',trim(calctype)

        write(6,Fmt2//'A,T50,A)')'Fock operator',trim(FockOpType)
        if (IFDW) then
          if (zeta.ge.0) then
            write(6,Fmt2//'A,T41,I10)')'DW exponent',zeta
          else
            write(6,Fmt2//'A,T50,A)')'DW exponent','infinity'
          end if
        end if

        if (Hzero.ne.'STANDARD') then
          write(6,Fmt2//'A,T50,A)')'0th-order Hamiltonian',trim(Hzero)
        end if

        write(6,Fmt2//'A,T45,F9.2)')'IPEA shift',BSHIFT
        write(6,Fmt2//'A,T45,F9.2)')'Real shift',SHIFT
        write(6,Fmt2//'A,T45,F9.2)')'Imaginary shift',SHIFTI

        if (ORBIN.eq.'TRANSFOR') then
          write(6,Fmt1)'The input orbitals will be transformed'//
     &                 ' to quasi-canonical'
        else
          write(6,Fmt1)'The input orbitals will not be transformed'//
     &                 ' to quasi-canonical'
        end if

        if (IFXMS) then
          write(6,Fmt1)'The input states will be rotated to '//
     &     'diagonalize the Fock operator'
        end if

        call CollapseOutput(0,'CASPT2 specifications:')
        write(6,*)
      end if

C Compute necessary quantities for subsequent gradient calc:
      IF (IPRGLB.GE.USUAL) THEN
        IF(IFDENS) THEN
        WRITE(6,*)
          WRITE(6,*)' The wave functions (P_CAS) H W |Psi_0> and '//
     &         '(P_CAS) W H |Psi_0>'
          WRITE(6,*)' will be computed and written out for subsequent'
          WRITE(6,*)' use in a gradient calculation.'
        END IF
      END IF

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_SetGL()
!
! Purpose: set global and local index arrays and diagonal.
!          If a sequencial run:
!             Diag   => Diag_Hidden
!             Diag_G => null()
!          If a parallel run:
!             Diag   => Diag_G_Hidden
!             Diag_G => Diag_Hidden
!
!          Diag_Hidden is allocated in the calling routine, while
!          Diag_G_Hidden is allocated here if needed.

use Cholesky, only: Cho_Real_Par, Diag, Diag_G, Diag_G_Hidden, Diag_Hidden, iiBstR, iiBstR_G, iiBstRSh, iiBstRSh_G, &
                    iiBstRsh_L_Hidden, iL2G, IndRed, IndRed_G, IndRed_G_Hidden, IndRSh, IndRSh_G, IndRsh_G_Hidden, InfRed, &
                    InfRed_G, InfRed_G_Hidden, InfVec, InfVec_G, InfVec_G_Hidden, LuPri, mmBstRT, mmBstRT_G, MySP, n_MySP, nnBstR, &
                    nnBstR_G, nnBstRSh, nnBstRSh_G, nnBstRT, nnBstRT_G, nnBstRsh_L_Hidden, nnShl, nnShl_G, nSym
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, i1, i2, irc, iShlAB, iSP, iSym, N
character(len=*), parameter :: SecNam = 'Cho_P_SetGL'

! If not parallel, return.
! ------------------------

if (.not. Cho_Real_Par) then
  Diag => Diag_Hidden
  return
end if

! Set global data Cholesky.
! -------------------------

Diag_G => Diag_Hidden

nnShl_G = nnShl
mmBstRT_G = mmBstRT

iiBstR_G(:,:) = iiBstR(:,:)
nnBstR_G(:,:) = nnBstR(:,:)
nnBstRT_G(:) = nnBstRT(:)

InfRed_G => InfRed

InfVec_G => InfVec

iiBstRSh_G => iiBstRSh

nnBstRSh_G => nnBstRSh

IndRed_G => IndRed

IndRSh_G => IndRSh

! Reallocate and reset local data.
! --------------------------------

call mma_allocate(InfRed_G_Hidden,size(InfRed),Label='InfRed_G_Hidden')
InfRed => InfRed_G_Hidden

call mma_allocate(InfVec_G_Hidden,size(InfVec,1),size(InfVec,2),size(InfVec,3),Label='InfVec_G_Hidden')
InfVec => InfVec_G_Hidden

nnShl = n_mySP
call mma_allocate(iiBstRsh_L_Hidden,nSym,n_mySP,3,Label='iiBstRSh_L_Hidden')
iiBstRSh => iiBstRSh_L_Hidden
call mma_allocate(nnBstRsh_L_Hidden,nSym,n_mySP,3,Label='nnBstRSh_L_Hidden')
nnBstRSh => nnBstRSh_L_Hidden

do iSP=1,nnShl
  iShlAB = mySP(iSP)
  nnBstRSh(1:nSym,iSP,1) = nnBstRSh_G(1:nSym,iShlAB,1)
end do
call Cho_SetRedInd(1)
mmBstRT = nnBstRT(1)

call mma_allocate(IndRed_G_Hidden,mmBstRT,3,Label='IndRed_G_Hidden')
IndRed => IndRed_G_Hidden
call mma_allocate(IndRSh_G_Hidden,mmBstRT,Label='IndRSh_G_Hidden')
IndRSh => IndRSh_G_Hidden
call mma_allocate(iL2G,mmBstRT,Label='iL2G')

N = 0
do iSym=1,nSym
  do iSP=1,nnShl
    iShlAB = mySP(iSP)
    i1 = iiBstR_G(iSym,1)+iiBstRSh_G(iSym,iShlAB,1)+1
    i2 = i1+nnBstRSh_G(iSym,iShlAB,1)-1
    do i=i1,i2
      N = N+1
      IndRed(N,1) = IndRed_G(i,1)
      IndRSh(N) = IndRSh_G(i)
      iL2G(N) = i
    end do
  end do
end do
call Cho_X_RSCopy(irc,1,2)
if (irc /= 0) then
  write(Lupri,*) SecNam,': [1] Cho_X_RSCopy returned ',irc
  call Cho_Quit('Error in '//SecNam,104)
end if
call Cho_X_RSCopy(irc,2,3)
if (irc /= 0) then
  write(Lupri,*) SecNam,': [2] Cho_X_RSCopy returned ',irc
  call Cho_Quit('Error in '//SecNam,104)
end if

! Allocate and set local diagonal.
! --------------------------------

call mma_allocate(Diag_G_Hidden,mmBstRT,Label='Diag_G_Hidden')
Diag => Diag_G_Hidden
do i=1,mmBstRT
  Diag(i) = Diag_G(iL2G(i))
end do

end subroutine Cho_P_SetGL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

subroutine ABTOR2(SKII,CKJJ,NKA,NKB,RHO2B,NI,NJ,NK,NL,MAXK,KBIB,XKBIB,KBJB,XKBJB,IKORD)
! Obtain contributions alpha-beta contributions to two-particle
! density matrix
!
! Rho2b(ij,kl)  = RHo2b(ij,kl)
!               + sum(Ka) Skii(Ka,i,Ib)<Ib!Eb(kl)!Jb> Ckjj(Ka,j,Jb)
!
! Jeppe Olsen, Fall of 96

use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NKA, NKB, NI, NJ, NK, NL, MAXK, KBIB(MAXK,NK), KBJB(MAXK,NL), IKORD
real(kind=wp), intent(in) :: SKII(*), CKJJ(*), XKBIB(MAXK,NK), XKBJB(MAXK,NL)
real(kind=wp), intent(inout) :: RHO2B(NI*NJ*NK*NL)
integer(kind=iwp) :: IB, ICOFF, IMAX, ISOFF, JB, K, KB, KK, KLOFF, L, LL
real(kind=wp) :: FACTOR, SGNK, SGNL

if (IKORD /= 0) then
  write(u6,*) ' ABTOR2 : IKORD /= 0'
  write(u6,*) ' I am not ready for this'
  !stop ' ABTOR2 : IKORD /= 0'
  call SYSABENDMSG('lucia_util/abtor2_gas','Internal error','')
end if

! Excitations <Ib!Eb(kl)!Jb>
do KB=1,NKB
  ! Number of nonvanishing connections from KB
  LL = 0
  KK = 0
  do L=1,NL
    if (KBJB(KB,L) /= 0) LL = LL+1
  end do
  do K=1,NK
    if (KBIB(KB,K) /= 0) KK = KK+1
  end do

  if ((KK /= 0) .and. (LL /= 0)) then
    do K=1,NK
      IB = KBIB(KB,K)
      if (IB /= 0) then
        SGNK = XKBIB(KB,K)
        do L=1,NL
          JB = KBJB(KB,L)
          if (JB /= 0) then
            SGNL = XKBJB(KB,L)
            FACTOR = SGNK*SGNL
            ! We have now a IB and Jb string, let's do it
            ISOFF = (IB-1)*NI*NKA+1
            ICOFF = (JB-1)*NJ*NKA+1
            KLOFF = ((L-1)*NK+K-1)*NI*NJ+1
            IMAX = NI

            !if (IKORD /= 0) then
            !  ! Restrict so (ij) <= (kl)
            !  IMAX = K
            !  JKINTOF = INTOF+(K-1)*NJ
            !  XIJILS(L:NL) = XIJKL(JKINTOF:JKINTOF+NL-1)
            !  XIJKL(JKINTOF-1+L) = Half*XIJKL(JKINTOF-1+L)
            !  XIJKL(JKINTOF+L:JKINTOF+NL-1) = Zero
            !end if
            call MATML7(RHO2B(KLOFF),SKII(ISOFF),CKJJ(ICOFF),NI,NJ,NKA,IMAX,NKA,NJ,One,FACTOR,1)
            !if (IKORD /= 0) XIJKL(JKINTOF+L-1:JKINTOF+NL-1) = XIJILS(L:NL)

          end if
        end do

      end if
    end do
  end if
end do
! (end over loop over Kb strings)

end subroutine ABTOR2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine CCmbnVe(Rnxyz,nZeta,la,lb,Zeta,rKappa,Final,nComp,
     &                  Vxyz,KVector)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January  91                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp),
     &       Zeta(nZeta), rKappa(nZeta), rTemp, Fact, KVector(3)
      Complex*16 Rnxyz(nZeta,3,0:la+1,0:lb+1),
     &          Vxyz(nZeta,3,0:la,0:lb,2), Temp1, Temp2
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
      iRout = 161
      iPrint = nPrint(iRout)
*
      Do 10 ixa = 0, la
         iyaMax=la-ixa
      Do 11 ixb = 0, lb
         iybMax=lb-ixb
         Do 20 iya = 0, iyaMax
            iza = la-ixa-iya
            ipa= Ind(la,ixa,iza)
         Do 21 iyb = 0, iybMax
            izb = lb-ixb-iyb
            ipb= Ind(lb,ixb,izb)
*
*           Combine integrals
*
            Do 30 iZeta = 1, nZeta
*
*              Put in the correct prefactors
*
               rTemp=KVector(1)**2 + kVector(2)**2 + kVector(3)**2
               rTemp=rTemp/(Four*Zeta(iZeta))
               Fact = rKappa(iZeta) * Zeta(iZeta)**(-Three/Two) *
     &               Exp(-rTemp)
               Temp1= Fact *
     &               Vxyz(iZeta,1,ixa,ixb,1)*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb)
               Temp2= Fact *
     &               Vxyz(iZeta,1,ixa,ixb,2)*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb)
               Final(iZeta,ipa,ipb,1) = DBLE((Temp1+Temp2)*Half)
               Final(iZeta,ipa,ipb,4) = DBLE((Temp1-Temp2)*Half)
               Final(iZeta,ipa,ipb,7) = DIMAG((Temp1+Temp2)*Half)
               Final(iZeta,ipa,ipb,10)= DIMAG((Temp1-Temp2)*Half)
               Temp1= Fact *
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &               Vxyz(iZeta,2,iya,iyb,1)*
     &               Rnxyz(iZeta,3,iza,izb)
               Temp2= Fact *
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &               Vxyz(iZeta,2,iya,iyb,2)*
     &               Rnxyz(iZeta,3,iza,izb)
               Final(iZeta,ipa,ipb,2) = DBLE((Temp1+Temp2)*Half)
               Final(iZeta,ipa,ipb,5) = DBLE((Temp1-Temp2)*Half)
               Final(iZeta,ipa,ipb,8) = DIMAG((Temp1+Temp2)*Half)
               Final(iZeta,ipa,ipb,11)= DIMAG((Temp1-Temp2)*Half)
               Temp1= Fact *
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Vxyz(iZeta,3,iza,izb,1)
               Temp2= Fact *
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Vxyz(iZeta,3,iza,izb,2)
               Final(iZeta,ipa,ipb,3) = DBLE((Temp1+Temp2)*Half)
               Final(iZeta,ipa,ipb,6 )= DBLE((Temp1-Temp2)*Half)
               Final(iZeta,ipa,ipb,9 )= DIMAG((Temp1+Temp2)*Half)
               Final(iZeta,ipa,ipb,12)= DIMAG((Temp1-Temp2)*Half)
 30         Continue
            If (iPrint.ge.99) Then
               Write (6,*) '(',ixa,iya,iza,ixb,iyb,izb,')'
               Write (6,*) 'x-component'
               Write (6,*) Final(1,ipa,ipb,1)
               Write (6,*) Final(1,ipa,ipb,4)
               Write (6,*) Final(1,ipa,ipb,7)
               Write (6,*) Final(1,ipa,ipb,10)
               Write (6,*) 'y-component'
               Write (6,*) Final(1,ipa,ipb,2)
               Write (6,*) Final(1,ipa,ipb,5)
               Write (6,*) Final(1,ipa,ipb,8)
               Write (6,*) Final(1,ipa,ipb,11)
               Write (6,*) 'z-component'
               Write (6,*) Final(1,ipa,ipb,3)
               Write (6,*) Final(1,ipa,ipb,6)
               Write (6,*) Final(1,ipa,ipb,9)
               Write (6,*) Final(1,ipa,ipb,12)
            End If
*
 21      Continue
 20      Continue
 11   Continue
 10   Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine TMatrix(TMx,mInt)
!***********************************************************************
! subroutine to get the T matrix that defines the constrained and      *
! unconstrained subspaces.                                             *
!***********************************************************************

use Slapaf_Info, only: nStab, Coor
use Slapaf_Parameters, only: iRow_c, nLambda, iter
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mInt
real(kind=wp), intent(inout) :: TMx(mInt,mInt)
integer(kind=iwp) :: Lambda1, Lambda2
logical(kind=iwp) :: Invert
real(kind=wp), allocatable, dimension(:,:) :: C1, C2, CT

! Get the global constraint vectors

call mma_Allocate(C1,mInt,nLambda)
call get_drdq(C1,mInt,nLambda,Lambda1,Iter)

! Get the NG constraint vectors

call Merge_Constraints('UDC.NG','','UDC',nLambda,iRow_c)
call Fix_UDC(iRow_c,nLambda,size(Coor,2),nStab,.true.)
call mma_Allocate(C2,mInt,nLambda)
call get_drdq(C2,mInt,nLambda,Lambda2,Iter)

! Combine both sets of constraints and get the T matrix

nLambda = Lambda1+Lambda2
call mma_Allocate(CT,mInt,mInt)
CT(:,1:Lambda1) = C1(:,:)
CT(:,Lambda1+1:nLambda) = C2(:,:)
CT(:,nLambda+1:) = Zero
if (nLambda > 0) then
  call GS(CT,nLambda,TMx,mInt,.false.,.true.)
else
  TMx(:,:) = Zero
  call dCopy_(mInt,[One],0,TMx,mInt+1)
end if

! If NG constraints are to be inverted, combine the complement
! with the global constraints instead

call Qpg_iScalar('Invert constraints',Invert)
if (Invert) call Get_lScalar('Invert constraints',Invert)
if (Invert) then
  Lambda2 = mInt-nLambda
  CT(:,1:Lambda1) = C1(:,:)
  CT(:,Lambda1+1:Lambda1+Lambda2) = TMx(:,nLambda+1:nLambda+Lambda2)
  nLambda = Lambda1+Lambda2
  CT(:,nLambda+1:) = Zero
  if (nLambda > 0) then
    call GS(CT,nLambda,TMx,mInt,.false.,.true.)
  else
    TMx(:,:) = Zero
    call dCopy_(mInt,[One],0,TMx,mInt+1)
  end if
end if

call mma_Deallocate(C1)
call mma_Deallocate(C2)
call mma_Deallocate(CT)

return

end subroutine TMatrix

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE CHEL(IA,IB,IIM,IEL,ISTOP)
      IMPLICIT REAL*8 (A-H,O-Z)
      IR=IIM-1
C     CHECK FOR A=0 , B=IEL
      IRR=IR-IA
      IF(IRR.LT.0)GO TO 50
      IF(IRR.GE.IB-IEL)GO TO 100
50    IF(IEL.EQ.1)GO TO 90
C     CHECK FOR A=1 , B=IEL-2
      IRR=IR-IA+1
      IF(IRR.LT.0)GO TO 90
      IF(IRR.GE.IB-IEL+2)GO TO 100
90    ISTOP=1
      RETURN
100   ISTOP=0
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine Cllct(Strng,Vector,Value,nAtom,Coor,nCntr,mCntr,
     &                 xyz,Temp,Ind,Type,qMss,TMtrx,First,Lbl,
     &                 lWrite,Deg,lAtom)
************************************************************************
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             May '91                                                  *
************************************************************************
      use Symmetry_Info, only: nIrrep, iOper
      use Slapaf_Info, only: dMass, AtomLbl
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "Molcas.fh"
      Character*(*) Strng
      Character Label*(LENIN5), Name*(LENIN)
      Character Oper*3, Type*6, Lbl*8
      Real*8 Coor(3,nAtom), Vector(3,nAtom), xyz(3,nCntr+mCntr),
     &       Temp(3,nCntr+mCntr), qMss(nCntr+mCntr),
     &       TMtrx(3,nAtom,3,(nCntr+mCntr)), Axis(3), Perp_Axis(3,2)
      Integer   Ind(nCntr+mCntr,2)
      Logical First, lWrite, ldB, lWarn, lAtom(nAtom)
      Dimension Dummy(1)
*
      iRout = 50
      iPrint = nPrint(iRout)
      ldB=.False.
      lWrite = First
      lWarn  = First
      If (iPrint.gt.20) lWrite = .True.
      If (iPrint.ge.99) Call RecPrt(' In Cllct: Coor',' ',
     &                               Coor,3,nAtom)
*
      iFrst = 1
      nCent = nCntr+mCntr
*
*     Pick up cartesian coordinates associated with the
*     internal coordinate
*
      Do 10 ixyz = 1, nCent
         Call NxtWrd(Strng,iFrst,iEnd)
         Label = Strng(iFrst:iEnd)
         nPar1 = Index(Label,'(')
         nPar2 = Index(Label,')')
         iPhase = 0
         If (nPar1.ne.0 .and. nPar2.ne.0) Then
            Name = '    '
            Name = Label(1:nPar1-1)
            Oper = Label(nPar1+1:nPar2-1)
            Call UpCase(Oper)
            If (Index(Oper,'X').ne.0) iPhase=iEor(iPhase,1)
            If (Index(Oper,'Y').ne.0) iPhase=iEor(iPhase,2)
            If (Index(Oper,'Z').ne.0) iPhase=iEor(iPhase,4)

*
*---------- Check if operator belongs to the current point group
*
            i = 0
            Do 11 j = 1, nIrrep-1
               If (iPhase.eq.iOper(j)) i = j
 11         Continue
            If (i.eq.0) Then
               Call WarningMessage(2,'Error in Cllclt')
               Write (6,*) '*********** ERROR ***********'
               Write (6,*) ' Undefined symmetry operator '
               Write (6,*) '*****************************'
               Write (6,*) ' ',Oper
               Write (6,*)
               Call Quit_OnUserError()
            End If
         Else If (nPar1.eq.0 .and. nPar2.eq.0) Then
            Name = '    '
            Name = Strng(iFrst:iEnd)
            Oper = ' '
         Else
            Call WarningMessage(2,'Error in Cllclt')
            Write (6,*) '********** ERROR **********'
            Write (6,*) ' Syntax error in:'
            Write (6,*) ' ',Label
            Write (6,*) '***************************'
            Write (6,*)
            Call Quit_OnUserError()
         End If
*
*------- Find corresponding coordinate
*
         jsAtom = 0
         Do 20 isAtom = 1, nAtom
            If (Name.eq.AtomLbl(isAtom)) jsAtom = isAtom
 20      Continue
         If (jsAtom.eq.0) Then
            Call WarningMessage(2,'Error in Cllclt')
            Write (6,*) '********** ERROR **********'
            Write (6,*) ' Unrecognizable atom label '
            Write (6,*) ' ',Name
            Write (6,*) '***************************'
            Write (6,*)
            Call Quit_OnUserError()
         End If
         lAtom(jsAtom) = .False.
*
*--------Store away the unique center index and the operator
*
         Ind(ixyz,1) = jsAtom
         Ind(ixyz,2) = iPhase
         call dcopy_(3,Coor(1,jsAtom),1,xyz(1,ixyz),1)
*--------Generate actual coordinate
         If (iAnd(iPhase,1).ne.0) xyz(1,ixyz) = - xyz(1,ixyz)
         If (iAnd(iPhase,2).ne.0) xyz(2,ixyz) = - xyz(2,ixyz)
         If (iAnd(iPhase,4).ne.0) xyz(3,ixyz) = - xyz(3,ixyz)
         If (Type.eq.'DISSOC') qMss(ixyz) = dMass(jsAtom)
         iFrst = iEnd + 1
 10   Continue
*
      If (iPrint.ge.99) Call RecPrt(' Coordinates',' ',
     &                              xyz,3,nCent)
*                                                                      *
************************************************************************
*                                                                      *
*
*---- Process the internal coordinate
*
      If (Type.eq.'X     ') Then
         Value = xyz(1,1)
         call dcopy_(3,[Zero],0,Temp,1)
         Temp(1,1) = One
         If (lWrite) Write (6,'(1X,A,A,2X,F10.4,A)') Lbl,
     &          ' : x-component=',Value,'/ bohr'
         Deg=D_Cart(Ind,nIrrep)
      Else If (Type.eq.'Y     ') Then
         Value = xyz(2,1)
         call dcopy_(3,[Zero],0,Temp,1)
         Temp(2,1) = One
         If (lWrite) Write (6,'(1X,A,A,2X,F10.4,A)') Lbl,
     &          ' : y-component=',Value,'/ bohr'
         Deg=D_Cart(Ind,nIrrep)
      Else If (Type.eq.'Z     ') Then
         Value = xyz(3,1)
         call dcopy_(3,[Zero],0,Temp,1)
         Temp(3,1) = One
         If (lWrite) Write (6,'(1X,A,A,2X,F10.4,A)') Lbl,
     &          ' : z-component=',Value,'/ bohr'
         Deg=D_Cart(Ind,nIrrep)
      Else If (Type.eq.'STRTCH') Then
         Call Strtch(xyz,nCent,Value,Temp,lWrite,Lbl,Dummy,ldB)
         Deg=D_Bond(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'LBEND1')Then
         Call CoSys(xyz,Axis,Perp_Axis)
         Call LBend(xyz,nCent,Value,Temp,lWrite,Lbl,Dummy,ldB,
     &              Axis,Perp_Axis(1,1),.False.)
         Deg=D_Bend(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'LBEND2')Then
         Call CoSys(xyz,Axis,Perp_Axis)
         Call LBend(xyz,nCent,Value,Temp,lWrite,Lbl,Dummy,ldB,
     &              Axis,Perp_Axis(1,2),.True.)
         Deg=D_Bend(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'BEND  ')Then
         Call Bend(xyz,nCent,Value,Temp,lWrite,lWarn,Lbl,Dummy,ldB)
         Deg=D_Bend(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'TRSN  ')Then
         Call Trsn(xyz,nCent,Value,Temp,lWrite,lWarn,Lbl,Dummy,ldB)
         Deg=D_Trsn(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'OUTOFP')Then
         Call OutOfP(xyz,nCent,Value,Temp,lWrite,lWarn,Lbl,Dummy,ldB)
         Deg=D_Trsn(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'DISSOC')Then
         Call Dissoc(xyz,nCntr,mCntr,qMss,Value,Temp,lWrite,
     &               Lbl,Dummy,ldB)
         Deg=One
      Else
         Call WarningMessage(2,'Error in Cllclt')
         Write (6,'(A,A)') ' Type declaration is corrupted:',Type
         Call Quit_OnUserError()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Deg=Sqrt(Deg)
*
*-----Symmetrize and normalize
*     Observe that the B matrix is defined in both symmetry adapted
*     internal coordinates and symmetry adapted cartesian coordinates.
*
      If (iPrint.ge.99) Call RecPrt(' Transformation vector',' ',
     &   Temp,3,nCent)
*
*
*     Symmetrization of P: 1/g Sum over G of X(G)*GPG
*
*     i) project away symmetry breaking displacements
*     ii) divide the contribution for each center with
*         the multiplicity, g/u
*     iii) sum over unique centers.
*
      call dcopy_(3*nAtom,[Zero],0,Vector,1)
      call dcopy_(3*nAtom*3*nCent,[Zero],0,TMtrx,1)
      Do 30 ixyz = 1, nCent
         jsAtom = Ind(ixyz,1)
         iPhase = Ind(ixyz,2)
         tx=One
         ty=One
         tz=One
*
*--------Step i
*--------Project away nonsymmetric displacements
*
*--------Restrict loop to the stabilizers of the center.
         Do 350 iIrrep= 0, nIrrep-1
            If (Coor(1,jsAtom).ne.Zero.and.iAnd(iOper(iIrrep),
     &          1).ne.0) Go To 350
            If (Coor(2,jsAtom).ne.Zero.and.iAnd(iOper(iIrrep),
     &          2).ne.0) Go To 350
            If (Coor(3,jsAtom).ne.Zero.and.iAnd(iOper(iIrrep),
     &          4).ne.0) Go To 350
*
            If (iAnd(iOper(iIrrep),1).ne.0) tx=Zero
            If (iAnd(iOper(iIrrep),2).ne.0) ty=Zero
            If (iAnd(iOper(iIrrep),4).ne.0) tz=Zero
 350     Continue
*
*--------Step ii
*
*--------Rotate vector back to the unique center
*
         If (iAnd(iPhase,1).ne.0) tx = - tx
         If (iAnd(iPhase,2).ne.0) ty = - ty
         If (iAnd(iPhase,4).ne.0) tz = - tz
         TMtrx(1,jsAtom,1,ixyz)=tx
         TMtrx(2,jsAtom,2,ixyz)=ty
         TMtrx(3,jsAtom,3,ixyz)=tz
 30   Continue
      Call dGeMV_('N',3*nAtom,3*nCent,
     &           One,TMtrx,3*nAtom,
     &               Temp,1,
     &           Zero,Vector,1)
      If (iPrint.ge.99) Then
         Call RecPrt('TMtrx',' ',TMtrx,3*nAtom,3*nCent)
         Call RecPrt(' symmetry adapted vector',
     &                              ' ',Vector,3,nAtom)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_REOINI()
C
C     Purpose: initializations for vector reordering.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "choreo.fh"

      MULD2H(I,J)=IEOR(I-1,J-1)+1

      CALL CHO_IZERO(NNBST,NSYM)
      DO ISYMA = 1,NSYM
         DO ISYMB = 1,ISYMA-1
            NABPK(ISYMA,ISYMB) = NBAS(ISYMA)*NBAS(ISYMB)
            NABPK(ISYMB,ISYMA) = NABPK(ISYMA,ISYMB)
            ISYM = MULD2H(ISYMB,ISYMA)
            NNBST(ISYM) = NNBST(ISYM) + NABPK(ISYMA,ISYMB)
         END DO
         NABPK(ISYMA,ISYMA) = NBAS(ISYMA)*(NBAS(ISYMA) + 1)/2
         NNBST(1) = NNBST(1) + NABPK(ISYMA,ISYMA)
      END DO

      CALL CHO_OPFVEC(1,0)

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Pavel Neogrady                                   *
************************************************************************
       subroutine grc0stack (bsize,typ,typp,typq,typr,typs,stot,
     & poss0,posst,mapd,mapi)
c
c             This routine defines mapd and mapi for specific
c        3 index intermediat A(pq,Bp), needed when stacking
c        (About Bp, see notes in multstack)
c        This routine is a modification of grc0 routine
c
c        P.N. 17.02.06
c     !N.B. (this routine cannot run with +OP2)
c
       integer bsize,typ,typp,typq,typr,typs,stot,poss0,posst
c
#include "ccsd1.fh"
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer sp,sq
CLD    integer sp,sq,sr,ss,spq,spqr
CLD    integer nsymq,nsymr
       integer poss,i,nhelp1,nhelp2,nhelp3
CLD    integer poss,i,nhelp1,nhelp2,nhelp3,nhelp4

c     To get rid of compiler warning
      poss=0
      i=0
c
c     vanishing mapi files
c
       do nhelp1=1,nsym
       do nhelp2=1,nsym
       do nhelp3=1,nsym
       mapi(nhelp3,nhelp2,nhelp1)=0
       end do
       end do
       end do
c
c     matrix A(p,q) or specifilally A(i,j,Bp)
c
       i=1
       poss=poss0
c
       do 100 sp=1,nsym
c
       sq=mmul(stot,sp)
       if ((typ.eq.1).and.(sp.lt.sq)) then
c     Meggie out
       goto 100
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
c
c     def mapi
       mapi(sp,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def length
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=bsize*nhelp1*(nhelp1-1)/2
       else
       mapd(i,2)=bsize*nhelp1*nhelp2
       end if
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 100    continue
c
c
       posst=poss
c
c     definition of other coll
c
       mapd(0,1)=typp
       mapd(0,2)=typq
       mapd(0,3)=typr
       mapd(0,4)=typs
       mapd(0,5)=i-1
       mapd(0,6)=typ
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Markus P. Fuelscher                              *
!***********************************************************************

subroutine ClnMO(CMO)
!***********************************************************************
!                                                                      *
!     In order to preserve symmetry of orbitals which belong           *
!     to a point group of higher order than those allowed in           *
!     MOLCAS, it is sometimes necessary to enforce the MO coefficients *
!     to remain zero. This subroutine does that job in every           *
!     iteration.                                                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 2000                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!     This subroutine replaces the one written earlier by L. Serrano   *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 2000                                 *
!                                                                      *
!***********************************************************************

use general_data, only: CleanMask, NSYM, NBAS
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: CMO(*)
integer(kind=iwp) :: i, ij, iSym, j

! Body

ij = 0
do iSym=1,nSym
  do i=1,nBas(iSym)
    do j=1,nBas(iSym)
      ij = ij+1
      if (CleanMask(ij) == 1) CMO(ij) = Zero
    end do
  end do
end do

end subroutine ClnMO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_Col_Comp(Col,nDim,iCol,nCol,Vec,nVec,Buf,lBuf,Fac,irc)
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: compute columns from a set of vectors.

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, nCol, iCol(nCol), nVec, lBuf
real(kind=wp), intent(inout) :: Col(nDim,nCol)
real(kind=wp), intent(in) :: Vec(nDim,nVec), Fac
real(kind=wp), intent(out) :: Buf(lBuf)
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: iBat, iC, iC1, NumBat, NumC, NumCol

irc = 0
if ((nDim < 1) .or. (nCol < 1)) return
if (nVec < 1) then
  if (Fac /= One) Col(:,:) = Fac*Col(:,:)
  return
end if

if ((nCol > 1) .and. (lBuf >= nVec)) then

  NumCol = min(lBuf/nVec,nCol)
  NumBat = (nCol-1)/NumCol+1

  do iBat=1,NumBat

    if (iBat == NumBat) then
      NumC = nCol-NumCol*(NumBat-1)
    else
      NumC = NumCol
    end if
    iC1 = NumCol*(iBat-1)+1

    if (lBuf < NumC*nVec) then
      irc = -1
      return
    end if

    call ChoMP2_Col_cp(Vec,nDim,nVec,Buf,NumC,iCol(iC1))
    call DGEMM_('N','T',nDim,NumC,nVec,One,Vec,nDim,Buf,NumC,Fac,Col(:,iC1),nDim)

  end do

else

  do iC=1,nCol
    call dGeMV_('N',nDim,nVec,One,Vec(:,:),nDim,Vec(iCol(iC),1),nDim,Fac,Col(:,iC),1)
  end do

end if

end subroutine ChoMP2_Col_Comp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRCMAT2(INPUT,NSS,XMATR,XMATI)
! Write out matrix elements over states as a complex matrix
! in parsable format

use Cntrl, only: ISOCMP, SOPRNM
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: INPUT, NSS
real(kind=wp), intent(in) :: XMATR(NSS,NSS), XMATI(NSS,NSS)
integer(kind=iwp) :: ISS, JSTA, LU
character(len=200) :: FILENAME
character(len=8) :: PROPERTY
character :: DIRECTION
integer(kind=iwp), external :: IsFreeUnit

if (INPUT > 0) then
  PROPERTY = SOPRNM(INPUT)
else
  PROPERTY = 'EIGVEC'
end if

write(DIRECTION,'(I1)') ISOCMP(INPUT)
if (PROPERTY(1:5) == 'MLTPL') then
  if (PROPERTY(8:8) == '0') then
    FILENAME = 'monopole-'//DIRECTION//'.txt'
  else if (PROPERTY(8:8) == '1') then
    FILENAME = 'dipole-'//DIRECTION//'.txt'
  else if (PROPERTY(8:8) == '2') then
    FILENAME = 'quadrupole-'//DIRECTION//'.txt'
  else
    return
  end if
else if (PROPERTY(1:5) == 'MLTPV') then
  if (PROPERTY(8:8) == '2') then
    FILENAME = 'velocity_quadrupole-'//DIRECTION//'.txt'
  else
    return
  end if
else if (PROPERTY(1:4) == 'VELO') then
  FILENAME = 'velocity_dipole-'//DIRECTION//'.txt'
else if (PROPERTY(1:4) == 'ANGM') then
  FILENAME = 'angmom-'//DIRECTION//'.txt'
else if (PROPERTY(1:6) == 'EIGVEC') then
  FILENAME = 'eigvectors.txt'
else
  return
end if
Lu = IsFreeUnit(88)
open(unit=LU,file=FILENAME,status='REPLACE')
write(LU,*) '#NROW NCOL REAL IMAG'
do JSTA=1,NSS
  do ISS=1,NSS
    write(LU,'(I6,1X,I6,A1,ES25.16,A1,ES25.16)') ISS,JSTA,' ',XMATR(ISS,JSTA),' ',XMATI(ISS,JSTA)
  end do
end do
close(LU)

end subroutine PRCMAT2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! AO-basis route.
subroutine StateMMEao(nAObas,nState,nTyp,MME,iCent,Cha,Dip,Qua)

use qmstat_global, only: BigT, MxMltp
use Index_Functions, only: nTri3_Elem, nTri_Elem
use Data_Structures, only: Alloc1DArray_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAObas, nState, nTyp, iCent(nTri_Elem(nAObas))
type(Alloc1DArray_Type), intent(in) :: MME(nTri3_Elem(MxMltp))
real(kind=wp), intent(inout) :: Cha(nTri_Elem(nState),*), Dip(nTri_Elem(nState),3,*), Qua(nTri_Elem(nState),6,*)
integer(kind=iwp) :: iB1, iB2, iS1, iS2, iTyp, kaunta, kaunter, nSize
real(kind=wp) :: PerAake
real(kind=wp), allocatable :: AOG(:), O(:)
! The reason why 8 and 7 are interchanged is that
! QMSTAT uses the ordering xx,xy,yy,xz,yz,zz while
! Seward uses the ordering xx,xy,xz,yy,yz,zz.
integer(kind=iwp), parameter :: xTyp(10) = [1,2,3,4,5,6,8,7,9,10]

kaunter = 0
nSize = nTri_Elem(nAObas)
call mma_allocate(AOG,nSize,label='Transition')
call mma_allocate(O,nTyp,label='OnTheWay')
! Loop over state pairs.
do iS1=1,nState
  do iS2=1,iS1
    kaunter = kaunter+1
    ! Collect this piece of the TDM in AO-basis.
    AOG(:) = BigT(:,kaunter)
    kaunta = 0
    ! Loop over AO-basis pairs and transform them as well as
    ! distribute their multipoles. Observe that the array iCent
    ! keeps track on where a certain AO-basis pair belongs.
    do iB1=1,nAObas
      do iB2=1,iB1
        kaunta = kaunta+1
        PerAake = AOG(kaunta)
        do iTyp=1,nTyp
          O(iTyp) = MME(xTyp(iTyp))%A(kaunta)*PerAake
        end do
        Cha(kaunter,iCent(kaunta)) = Cha(kaunter,iCent(kaunta))+O(1)
        Dip(kaunter,:,iCent(kaunta)) = Dip(kaunter,:,iCent(kaunta))+O(2:4)
        Qua(kaunter,:,iCent(kaunta)) = Qua(kaunter,:,iCent(kaunta))+O(5:10)
      end do
    end do
  end do
end do
call mma_deallocate(AOG)
call mma_deallocate(O)

return

end subroutine StateMMEao

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3sglh223(w,dima,dimb,dimc,s1,d1,ns)
! this routine adds following contribution to W
! for syma>symb;symc
!
! W(a,b;c) <- + S1 _i(c) . D1 _jk(a,b)
!
! w    - W matrix (I/O)
! dima - dimension of a index (I)
! dimb - dimension of b index (I)
! dimc - dimension of c index (I)
! s1   - S1 matrix (I)
! d1   - D1 matrix (I)
! ns   - signum of the contribution (+-1) (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimc, ns
real(kind=wp), intent(inout) :: w(dima,dimb,dimc)
real(kind=wp), intent(in) :: s1(dimc), d1(dima,dimb)
integer(kind=iwp) :: c

if (ns == 1) then
  ! phase + 1

  do c=1,dimc
    w(:,:,c) = w(:,:,c)+d1*s1(c)
  end do

else
  ! phase - 1

  do c=1,dimc
    w(:,:,c) = w(:,:,c)-d1*s1(c)
  end do

end if

return

end subroutine t3sglh223

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SortCanonical(AB,l_Scr,Scr,
     &                             OffsetDefined,
     &                             l_iOff1,l_iOff2,iOff,
     &                             l_X,X)
C
C     Thomas Bondo Pedersen, September 2012.
C
C     Change ordering from shell-pair blocks to 'canonical' order
C     [nbas(A) x nbas(B)].
C
      Implicit None
      Integer AB
      Integer l_Scr
      Real*8  Scr(l_Scr)
      Logical OffSetDefined
      Integer l_iOff1, l_iOff2
      Integer iOff(l_iOff1,l_iOff2)
      Integer l_X
      Real*8  X(l_X)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_bas.fh"

      Character*17 SecNam
      Parameter (SecNam='LDF_SortCanonical')

      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom

      Integer A, B
      Integer nA, nB, nAB
      Integer nSA, nSB
      Integer ipA, ipB
      Integer iS, jS
      Integer iShell, jShell
      Integer ni, nj
      Integer i, j
      Integer ij
      Integer ip0

      Logical TestIt
#if defined (_DEBUGPRINT_)
      Parameter (TestIt=.True.)
#else
      Parameter (TestIt=.False.)
#endif
      Real*8   ChkSum(2), ChkNorm(2), diff(2)
      real*8 ddot_
      external ddot_
      Real*8   Tol
      Parameter (Tol=1.0d-14)

      Integer m, n
      Integer nBasSh
      Integer AP_Atoms
      nBasSh(m)=iWork(ip_nBasSh-1+m)
      AP_Atoms(m,n)=iWork(ip_AP_Atoms-1+2*(n-1)+m)

      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      nA=LDF_nBas_Atom(A)
      nB=LDF_nBas_Atom(B)
      nAB=nA*nB
      nSA=LDF_nShell_Atom(A)
      nSB=LDF_nShell_Atom(B)
      If (l_X.lt.nAB .or. l_Scr.lt.nAB .or. l_iOff1.lt.nSA .or.
     &    l_iOff2.lt.nSB) Then
         Call WarningMessage(2,
     &                SecNam//': input arrays not properly dimensioned')
         Write(6,'(A,7I10)') 'l_X,l_Scr,nAB,l_iOff1,nSA,l_iOff2,nSB=',
     &   l_X,l_Scr,nAB,l_iOff1,nSA,l_iOff2,nSB
         Call LDF_Quit(1)
      End If
      ipA=LDF_lShell_Atom(A)-1
      ipB=LDF_lShell_Atom(B)-1

      If (.not.OffsetDefined) Then
         ij=0
         Do jS=1,nSB
            jShell=iWork(ipB+jS)
            nj=nBasSh(jShell)
            Do iS=1,nSA
               iShell=iWork(ipA+iS)
               ni=nBasSh(iShell)
               iOff(iS,jS)=ij
               ij=ij+ni*nj
            End Do
         End Do
         OffsetDefined=.True.
      End If

      Call dCopy_(nAB,X,1,Scr,1)
      ij=0
      Do jS=1,nSB
         jShell=iWork(ipB+jS)
         nj=nBasSh(jShell)
         Do j=1,nj
            Do iS=1,nSA
               iShell=iWork(ipA+iS)
               ni=nBasSh(iShell)
               ip0=iOff(iS,jS)+ni*(j-1)
               Do i=1,ni
                  ij=ij+1
                  X(ij)=Scr(ip0+i)
               End Do
            End Do
         End Do
      End Do

      ! Self test
      If (TestIt) Then
         ChkSum(1)=0.0d0
         Do i=1,nAB
            ChkSum(1)=ChkSum(1)+Scr(i)
         End Do
         ChkSum(2)=0.0d0
         Do i=1,nAB
            ChkSum(2)=ChkSum(2)+X(i)
         End Do
         ChkNorm(1)=sqrt(dDot_(nAB,Scr,1,Scr,1))
         ChkNorm(2)=sqrt(dDot_(nAB,X,1,X,1))
         diff(1)=ChkSum(1)-ChkSum(2)
         diff(2)=ChkNorm(1)-ChkNorm(2)
         If (abs(diff(1)).gt.Tol .or. abs(diff(2)).gt.Tol) Then
            Call WarningMessage(2,SecNam//': sorting failed!')
            Write(6,'(A,1P,3D20.12)') 'Sum(src,trg,diff)= ',
     &      ChkSum(1),ChkSum(2),diff(1)
            Write(6,'(A,1P,3D20.12)') 'Norm(src,trg,diff)=',
     &      ChkNorm(1),ChkNorm(2),diff(2)
            Call LDF_Quit(1)
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine InpPri(lOPTO)
!***********************************************************************
!                                                                      *
!     Echo input                                                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use OneDat, only: sNoOri
use fcidump, only: DumpOnly
use fciqmc, only: DoNECI
use CC_CI_mod, only: Do_CC_CI
use Fock_util_global, only: DoLocK
use Functionals, only: Init_Funcs, Print_Info
use KSDFT_Info, only: CoefR, CoefX
use rctfld_module, only: lRF
use gas_data, only: iDoGAS, IGSOCCX, NGAS, NGSSH
use rasscf_global, only: cCI, DoBlockDMRG, DoDMRG, Header, iCI, ICICH, ICIRST, iPCMRoot, iRLXRoot, iRoot, iSupSM, ITMAX, ixSym, &
                         KSDFT, l_casdft, lRoots, lSquare, LvShft, MAXIT, n_Det, NAC, NFR, NIN, NONEQ, NQUNE, NROOTS, NSEC, nTit, &
                         RFPert, ThrE, ThrSX, ThrTE, Title, Tot_Charge, Tot_El_Charge, Tot_Nuc_Charge, Weight
#ifdef _DMRG_
use qcmaquis_interface_cfg, only: dmrg_orbital_space, dmrg_warmup
use qcmaquis_interface_utility_routines, only: print_dmrg_info
#endif
#ifdef _ENABLE_DICE_SHCI_
use rasscf_global, only: dice_eps1, dice_eps2, dice_iter, dice_Restart, dice_SampleN, Dice_Stoc, diceocc, nRef_Dice
#endif
#if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_)
use rasscf_global, only: ChemPS2_blb, ChemPS2_lreStart, ChemPS2_Noise, ChemPS2_Restart, Davidson_tol, Do3RDM, HFOcc, &
                         Max_canonical, Max_Sweep, MXDMRG
#endif
use PrintLevel, only: SILENT, USUAL
use output_ras, only: IPRLOC
use general_data, only: ISPIN, NACTEL, NASH, NBAS, NDEL, NELEC3, NFRO, NHOLE1, NISH, NRS1, NRS2, NRS3, NSEL, NSSH, NSYM, NTOT1, &
                        STSYM
use spinfo, only: DoComb, I_ELIMINATE_GAS_MOLCAS, NCNFTP, NCSASM, NCSF_HEXS, NDTASM, NDTFTP
use DWSol, only: DWSol_fixed, DWSolv, W_SOLV
use RASDim, only: MxRef
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, Two, Six, Half, OneHalf
use Definitions, only: wp, iwp, u6, RtoB

implicit none
logical(kind=iwp), intent(in) :: lOPTO
integer(kind=iwp) :: i, iCharge, iComp, iDoRI, iEnd, iGAS, iOpt, iPrLev, iRC, iRef, iStart, iSyLbl, iSym, iTemp, j, left, lLine, &
                     lPaper, MaxRem, n_paired_elec, n_unpaired_elec, nLine
real(kind=wp) :: AvailMB, WillNeedMB
logical(kind=iwp) :: DoCholesky
character(len=120) :: Line
character(len=80) :: KSDFT2
character(len=8) :: Fmt1, Fmt2, Label
character(len=3) :: lIrrep(8)
character(len=2) :: GASidx
real(kind=wp), allocatable :: Tmp0(:)
#if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_) || defined (_ENABLE_DICE_SHCI_)
integer(kind=iwp) :: iHFOcc
character(len=3) :: SNAC
#endif
#ifdef _DMRG_
character(len=100) :: dmrg_start_guess
#endif
#ifdef _ENABLE_DICE_SHCI_
integer(kind=iwp) :: iRef_Dice
#endif

! Print level:
IPRLEV = IPRLOC(1)
!----------------------------------------------------------------------*
!     Start and define the paper width                                 *
!----------------------------------------------------------------------*
lPaper = 132
!----------------------------------------------------------------------*
!     Initialize blank and header lines                                *
!----------------------------------------------------------------------*
lLine = len(Line)
lPaper = 132
left = (lPaper-lLine)/2
write(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
if (IPRLEV > SILENT) then
  !--------------------------------------------------------------------*
  !     Print the project title                                        *
  !--------------------------------------------------------------------*
  if (IPRLEV >= USUAL) then
    if (nTit > 0) then
      write(u6,*)
      nLine = nTit+5
      do i=1,nLine
        Line = ''
        if ((i == 1) .or. (i == nLine)) Line = repeat('*',lLine)
        if (i == 3) Line = 'Project:'
        if ((i >= 4) .and. (i <= nLine-2)) write(Line,'(A72)') Title(i-3)
        call Center_Text(Line)
        write(u6,Fmt1) '*'//Line//'*'
      end do
      write(u6,*)
    end if
  end if
  !--------------------------------------------------------------------*
  !     Print the ONEINT file identifier                               *
  !--------------------------------------------------------------------*
  if ((IPRLEV >= USUAL) .and. (.not. lOPTO)) then
    write(u6,*)
    write(u6,Fmt1) 'Header of the ONEINT file:'
    write(u6,Fmt1) '--------------------------'
    write(Line,'(36A2)') (Header(i),i=1,36)
    write(u6,Fmt1) trim(adjustl(Line))
    write(Line,'(36A2)') (Header(i),i=37,72)
    write(u6,Fmt1) trim(adjustl(Line))
    write(u6,*)
    !------------------------------------------------------------------*
    !     Print the status of ORDINT                                   *
    !------------------------------------------------------------------*
    write(u6,*)
    if (lSquare) then
      write(u6,Fmt1) 'OrdInt status: squared'
    else
      write(u6,Fmt1) 'OrdInt status: non-squared'
    end if
    write(u6,*)
    !------------------------------------------------------------------*
    !     Print cartesian coordinates of the system                    *
    !------------------------------------------------------------------*
    call PrCoor()
  end if
  !--------------------------------------------------------------------*
  !     Print orbital and wavefunction specifications                  *
  !--------------------------------------------------------------------*
  if ((IPRLEV >= USUAL) .and. (.not. lOPTO)) then
    write(u6,*)
    Line = ' '
    write(Line(left-2:),'(A)') 'Wave function specifications:'
    call CollapseOutput(1,Line)
    write(u6,Fmt1) '-----------------------------'
    write(u6,*)
    if (NFR > 0) write(u6,Fmt2//'A,T45,I6)') 'Number of frozen shell electrons',2*NFR
    write(u6,Fmt2//'A,T45,I6)') 'Number of closed shell electrons',2*NIN
    write(u6,Fmt2//'A,T45,I6)') 'Number of electrons in active shells',NACTEL
    if (.not. idogas) then
      !.. for RAS
      write(u6,Fmt2//'A,T45,I6)') 'Max number of holes in RAS1 space',NHOLE1
      write(u6,Fmt2//'A,T45,I6)') 'Max nr of electrons in RAS3 space',NELEC3
    else
      !.. for GAS
      do IGAS=1,NGAS
        write(GASidx,'(i0)') IGAS
        write(u6,Fmt2//'A,A,A,T45,2I6)') 'Min/Max nr of electrons up to GAS',GASidx,' sp.',igsoccx(igas,1),igsoccx(igas,2)
      end do
    end if

    if (NFR > 0) write(u6,Fmt2//'A,T45,I6)') 'Number of frozen orbitals',NFR
    write(u6,Fmt2//'A,T45,I6)') 'Number of inactive orbitals',NIN
    write(u6,Fmt2//'A,T45,I6)') 'Number of active orbitals',NAC
    write(u6,Fmt2//'A,T45,I6)') 'Number of secondary orbitals',NSEC
    write(u6,Fmt2//'A,T45,F6.1)') 'Spin quantum number',Half*real(ISPIN-1,kind=wp)
    write(u6,Fmt2//'A,T45,I6)') 'State symmetry',STSYM
    call CollapseOutput(0,'Wave function specifications:')

    call Get_cArray('Irreps',lIrrep,24)
    lIrrep(1:nSym) = adjustr(lIrrep(1:nSym))

    write(u6,*)
    Line = ' '
    write(Line(left-2:),'(A)') 'Orbital specifications:'
    call CollapseOutput(1,Line)
    write(u6,Fmt1) '-----------------------'
    write(u6,*)
    write(u6,Fmt2//'A,T47,8I4)') 'Symmetry species',(iSym,iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8(1X,A))') '                ',(lIrrep(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I4)') 'Frozen orbitals',(nFro(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I4)') 'Inactive orbitals',(nIsh(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I4)') 'Active orbitals',(nAsh(iSym),iSym=1,nSym)
    if (.not. iDoGas) then
      write(u6,Fmt2//'A,T47,8I4)') 'RAS1 orbitals',(nRs1(iSym),iSym=1,nSym)
      write(u6,Fmt2//'A,T47,8I4)') 'RAS2 orbitals',(nRs2(iSym),iSym=1,nSym)
      write(u6,Fmt2//'A,T47,8I4)') 'RAS3 orbitals',(nRs3(iSym),iSym=1,nSym)
    else
      do IGAS=1,NGAS
        write(u6,Fmt2//'A,I1,A,T47,8I4)') 'GAS',IGAS,' orbitals',(ngssh(igas,iSym),iSym=1,nSym)
      end do
    end if

    write(u6,Fmt2//'A,T47,8I4)') 'Secondary orbitals',(nSsh(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I4)') 'Deleted orbitals',(nDel(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I4)') 'Number of basis functions',(nBas(iSym),iSym=1,nSym)
    call CollapseOutput(0,'Orbital specifications:')
    write(u6,*)

#   if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_) || defined (_ENABLE_DICE_SHCI_)
    if (DoBlockDMRG) then

#     ifdef _ENABLE_DICE_SHCI_
      Line = ' '
      write(Line(left-2:),'(A)') 'DICE specifications:'
      call CollapseOutput(1,Line)
      write(u6,Fmt1) '--------------------------'
      write(u6,*)
      write(u6,Fmt2//'A,T70,L6)') 'Heat-bath configuration interaction (JCTC, 2017, 13, 1595)',DoBlockDMRG
      write(u6,Fmt2//'A,T45,L6)') 'Semistochastic algorithm',Dice_stoc
      write(u6,Fmt2//'A,T45,L6)') 'Full restart',dice_restart
      write(u6,Fmt2//'A,T45,I6)') 'Max iterations',dice_iter
      write(u6,Fmt2//'A,T45,ES10.3)') 'Epsilon1',dice_eps1
      write(u6,Fmt2//'A,T45,ES10.3)') 'Epsilon2',dice_eps2
      write(u6,Fmt2//'A,T45,I6)') 'SampleN',dice_sampleN
      write(u6,Fmt2//'A,T45)') 'Occupation guess'
      do iref_dice=1,nref_dice
        write(u6,Fmt2//'A)') trim(diceocc(iref_dice))
      end do
      call CollapseOutput(0,'DICE specifications:')
#     else
      Line = ' '
      write(Line(left-2:),'(A)') 'DMRG sweep specifications:'
      call CollapseOutput(1,Line)
      write(u6,Fmt1) '--------------------------'
      write(u6,*)
      write(u6,Fmt2//'A,T45,I6)') 'Number of renormalized basis',MxDMRG
      write(u6,Fmt2//'A,T45,I6)') 'Number of root(s) required',NROOTS

      write(u6,Fmt2//'A,T45,I6)') 'Maximum number of sweeps',max_sweep
      write(u6,Fmt2//'A,T45,I6)') 'Maximum number of sweeps in RDM',max_canonical
      write(u6,Fmt2//'A,T45,ES10.3)') 'Threshold for restarting',chemps2_blb
      write(u6,Fmt2//'A,T45,ES10.3)') 'Minimum Davidson tolerance',davidson_tol
      write(u6,Fmt2//'A,T45,ES10.3)') 'DMRG convergence threshold',Half*THRE
      write(u6,Fmt2//'A,T45,ES10.3)') 'Noise prefactor',chemps2_noise
      write(u6,Fmt2//'A,T45,L6)') 'Restart from previous calculation',chemps2_restart
      write(u6,Fmt2//'A,T45,L6)') 'Calculate 3-RDM and F.4-RDM',Do3RDM
      write(u6,Fmt2//'A,T45,I6)') 'Restart scheme in 3-RDM and F.4-RDM',chemps2_lrestart
      write(SNAC,'(I3)') NAC
      write(u6,Fmt2//'A,T45,'//trim(adjustl(SNAC))//'I2)') 'Occupation guess',(HFOCC(ihfocc),ihfocc=1,NAC)

      ! NN.14 FIXME: haven't yet checked whether geometry opt. works correctly with DMRG
      write(u6,Fmt2//'A,T45,I6)') 'Root chosen for geometry opt.',IRLXROOT
      call CollapseOutput(0,'DMRG sweep specifications:')
#     endif
    else
#   endif

      Line = ' '
      if (doDMRG) then
        write(Line(left-2:),'(A)') 'DMRG specifications:'
      else
        write(Line(left-2:),'(A)') 'CI expansion specifications:'
      end if
      call CollapseOutput(1,Line)
      write(u6,Fmt1) '----------------------------'
      write(u6,*)

      if (doDMRG) then  !> Information for QCMaquis-DMRG
#       ifdef _DMRG_
        if (dmrg_orbital_space%initial_occ(1,1) > 0) then
          dmrg_start_guess = 'Single determinant'
        else if (dmrg_warmup%doCIDEAS) then
          dmrg_start_guess = 'CI-DEAS'
        else
          dmrg_start_guess = 'Random numbers (default)'
        end if
        call print_dmrg_info(u6,fmt2,1,dmrg_start_guess,nroots,thre)
#       endif
      else
        write(u6,Fmt2//'A,T40,I11)') 'Number of CSFs',NCSASM(STSYM)
        if (I_ELIMINATE_GAS_MOLCAS > 0) write(u6,Fmt2//'A,T40,I11)') 'Number of highly excited CSFs',nCSF_HEXS
        if (DoComb) then
          write(u6,Fmt2//'A,T40,I11)') 'Number of spin combinations',NDTASM(STSYM)
          write(u6,Fmt2//'A,T40,I11)') 'Number of determinants',2*NDTASM(STSYM)-NDTFTP(1)*NCNFTP(1,STSYM)
        else
          write(u6,Fmt2//'A,T40,I11)') 'Number of determinants',NDTASM(STSYM)
        end if
      end if
      n_Det = 2
      n_unpaired_elec = (iSpin-1)
      n_paired_elec = nActEl-n_unpaired_elec
      if ((n_unpaired_elec+n_paired_elec/2 == nac) .or. (NDTASM(STSYM) == 1)) n_Det = 1
      if (KSDFT == 'DIFF') n_Det = 1
      if (KSDFT == 'ROKS') n_Det = 1

      write(u6,Fmt2//'A,T45,I6)') 'Number of root(s) required',NROOTS
      if (irlxroot /= 0) write(u6,Fmt2//'A,T45,I6)') 'Root chosen for geometry opt.',IRLXROOT
      if (ICICH == 0) then

        if (nRoots == 1) then

          if (doDMRG) then
            write(u6,Fmt2//'A,(T45,10I6))') 'DMRG root used',IROOT(1)
          else
            write(u6,Fmt2//'A,(T45,10I6))') 'CI root used',IROOT(1)
          end if
          write(u6,Fmt1) '   '

        else

          if (doDMRG) then
            write(u6,Fmt2//'A,(T45,10I6))') 'DMRG roots used',(IROOT(i),i=1,nRoots)
          else
            write(u6,Fmt2//'A,(T45,10I6))') 'CI roots used',(IROOT(i),i=1,nRoots)
          end if
          write(u6,Fmt2//'A,(T45,10F6.3))') 'weights',(Weight(i),i=1,nRoots)
        end if

      else
        do i=1,nRoots
          write(u6,Fmt2//'A,T45,I6)') 'selected root',iRoot(i)
          write(u6,Fmt2//'A,T45,10I6)') 'Reference configurations',(iCI(i,iRef),iRef=1,mxRef)
          write(u6,Fmt2//'A,T45,10F6.3)') 'CI-coeff',(cCI(i,iRef),iRef=1,mxRef)
        end do
      end if
      if (.not. doDMRG) then
        write(u6,Fmt2//'A,T45,I6)') 'highest root included in the CI',LROOTS
        write(u6,Fmt2//'A,T45,I6)') 'max. size of the explicit Hamiltonian',NSEL
      end if
      call CollapseOutput(0,'CI expansion specifications:')

#   if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_) || defined (_ENABLE_DICE_SHCI_)
    end if
#   endif

  end if
  if (lOPTO) then
    write(u6,*)
    Line = ' '
    write(Line(left-2:),'(A)') 'RASSCF input specifications:'
    call CollapseOutput(1,Line)
    write(u6,Fmt1) '----------------------------'
    write(u6,Fmt2//'A,T45,I6)') 'Number of root(s) required',NROOTS
    if (irlxroot /= 0) write(u6,Fmt2//'A,T45,I6)') 'Root chosen for geometry opt.',IRLXROOT
    if (ICICH == 0) then
      if (nRoots == 1) then
        write(u6,Fmt2//'A,(T45,10I6))') 'CI root used',IROOT(1)
      else
        write(u6,Fmt2//'A,(T45,10I6))') 'CI roots used',(IROOT(i),i=1,nRoots)
        write(u6,Fmt2//'A,(T45,10F6.3))') 'weights',(Weight(i),i=1,nRoots)
      end if
    else
      do i=1,nRoots
        write(u6,Fmt2//'A,T45,I6)') 'selected root',iRoot(i)
        write(u6,Fmt2//'A,T45,10I6)') 'Reference configurations',(iCI(i,iRef),iRef=1,mxRef)
        write(u6,Fmt2//'A,T45,10F6.3)') 'CI-coeff',(cCI(i,iRef),iRef=1,mxRef)
      end do
    end if
    call CollapseOutput(0,'RASSCF input specifications:')
  end if
  ! Check that the user doesn't try to calculate more roots than it's possible
  ! NN.14 FIXME: in DMRG-CASSCF, skip this check for the time
  !              since Block DMRG code will check this internally
  !if (NROOTS > NCSASM(STSYM)) then
  if ((.not. any([DoNECI,Do_CC_CI,DumpOnly,doDMRG,doBlockDMRG])) .and. (NROOTS > NCSASM(STSYM))) then
    write(u6,*) '************ ERROR ***********'
    write(u6,*) ' You can''t ask for more roots'
    write(u6,*) ' than there are configurations '
    write(u6,*) '******************************'
    write(u6,*)
    call Quit_OnUserError()
  end if
  ! If the calculation will be too big:
  call mma_MaxDBLE(MaxRem)
  WillNeedMB = OneHalf*Six*NDTASM(STSYM)*RtoB/Two**20
  AvailMB = MaxRem*RtoB/Two**20
  if (WillNeedMB > AvailMB) then
    write(u6,*)
    write(u6,*) ' *************************************************'
    write(u6,*) ' Sorry, but your calculation will probably be too'
    write(u6,*) ' large for the available memory.'
    write(u6,*) ' The number of determinants is ',NDTASM(STSYM)
    write(u6,*) ' During CI equation solution, there will be'
    write(u6,*) ' up to six vectors of this size in memory.'
    write(u6,*) ' We estimate an additional 50% for other stuff.'
    write(u6,*)
    write(u6,'(A,F9.1,A)') ' This alone will need at least ',WillNeedMB,' MB.'
    write(u6,'(A,F9.1,A)') ' Available at this point is ',AvailMB,' MB.'
    write(u6,*) ' Please increase MOLCAS_MEM, and try again.'
    write(u6,*) ' *************************************************'
    write(u6,*)
    call Quit_OnUserError()
  end if

  if ((IPRLEV >= USUAL) .and. (.not. lOPTO)) then
    write(u6,*)
    Line = ' '
    write(Line(left-2:),'(A)') 'Optimization specifications:'
    call CollapseOutput(1,Line)
    write(u6,Fmt1) '----------------------------'
    write(u6,*)
    call DecideOnCholesky(DoCholesky)
    if (DoCholesky) then
      call Get_iScalar('System BitSwitch',iDoRI)
      if (btest(iDoRI,10)) then
        if (DoLocK) then
          write(u6,Fmt2//'A,T45,I6)') 'RASSCF algorithm: LK RI/DF'
        else
          write(u6,Fmt2//'A,T45,I6)') 'RASSCF algorithm: RI/DF'
        end if
      else
        if (DoLocK) then
          write(u6,Fmt2//'A,T45,I6)') 'RASSCF algorithm: LK Cholesky'
        else
          write(u6,Fmt2//'A,T45,I6)') 'RASSCF algorithm: Cholesky'
        end if
      end if
    else
      write(u6,Fmt2//'A,T45,I6)') 'RASSCF algorithm: Conventional'
    end if
    !*******************************************************************
    ! Some printout for mcpdft method
    !*******************************************************************
    KSDFT2 = KSDFT
    if (l_casdft) then
      KSDFT2 = KSDFT(index(KSDFT,'T:')+2:)
      write(u6,Fmt2//'A)') 'This is a MC-PDFT calculation with functional: '//KSDFT
      write(u6,Fmt2//'A,T45,ES10.3)') 'Exchange scaling factor',CoefX
      write(u6,Fmt2//'A,T45,ES10.3)') 'Correlation scaling factor',CoefR
    end if
    !*******************************************************************

    write(u6,Fmt2//'A,T45,I6)') 'Maximum number of macro iterations',MAXIT
    write(u6,Fmt2//'A,T45,I6)') 'Maximum number of SX iterations',ITMAX
    write(u6,Fmt2//'A,T45,ES10.3)') 'Threshold for RASSCF energy',THRE
    call Put_dScalar('EThr',ThrE)
    write(u6,Fmt2//'A,T45,ES10.3)') 'Threshold for max MO rotation',THRTE
    write(u6,Fmt2//'A,T45,ES10.3)') 'Threshold for max BLB element',THRSX
    write(u6,Fmt2//'A,T45,ES10.3)') 'Level shift parameter',LVSHFT
    if (NQUNE /= 0) write(u6,Fmt1) 'Make Quasi-Newton update'
    if (ISUPSM /= 0) then
      write(u6,Fmt1) 'Supersymmetry is used to disable selected orbital rotations'
      iEnd = 0
      do iSym=1,nSym
        iStart = iEnd+1
        iEnd = iEnd+nBas(iSym)
        iTemp = sum(IXSYM(iStart:iEnd))
        if (iTemp > 0) then
          write(u6,Fmt2//'A,I3)') 'Supersymmetry vector for symmetry species',iSym
          write(u6,Fmt2//'30I3)') (IXSYM(i),i=iStart,iEnd)
        end if
      end do
    end if
    if (lRF) then
      call mma_allocate(Tmp0,nTot1+4,Label='Tmp0')
      iRc = -1
      iOpt = ibset(0,sNoOri)
      iComp = 1
      iSyLbl = 1
      Label = 'Mltpl  0'
      call RdOne(iRc,iOpt,Label,iComp,Tmp0,iSyLbl)
      Tot_Nuc_Charge = Tmp0(nTot1+4)
      if (iRc /= 0) then
        write(u6,*) 'InpPri: iRc from Call RdOne not 0'
        write(u6,*) 'Label = ',Label
        write(u6,*) 'iRc = ',iRc
        call Abend()
      end if
      call mma_deallocate(Tmp0)
      Tot_El_Charge = -Two*sum(nFro(1:nSym)+nIsh(1:nSym))
      Tot_El_Charge = Tot_El_Charge-real(nActEl,kind=wp)
      Tot_Charge = Tot_Nuc_Charge+Tot_El_Charge
      iCharge = int(Tot_Charge)
      call PrRF(.false.,NonEq,iCharge,2)

      if (DWSolv%DWZeta == -12345.0_wp) then
        write(u6,Fmt2//'A)') 'Weights of the reaction field are specified by RFROOT'
        write(u6,Fmt2//'(T45,10F6.3))') (W_SOLV(i),i=1,nRoots)
      else if (DWSolv%DWZeta < Zero) then
        call DWSol_fixed(i,j)
        if ((i == 0) .and. (j == 0)) then
          write(u6,Fmt2//'A)') 'Unrecognized negative DWZeta (DWSOl)'
          write(u6,Fmt2//'A,T51,A)') 'Dynamically weighted solvation is ','automatically turned off!'
        else
          write(u6,Fmt2//'A,T45,I2,X,I2)') 'Reaction field from states:',i,j
          if (max(i,j) > nRoots) then
            write(u6,Fmt2//'A)') 'The specified state is too high! Cannot proceed...'
            call Quit_OnUserError()
          end if
        end if
      else if (IPCMROOT <= 0) then
        write(u6,Fmt2//'A,T44,A)') 'Reaction field from state:',' State-Averaged'
        if (DWSolv%DWZeta /= Zero) then
          write(u6,Fmt2//'A,T51,A)') 'Dynamically weighted solvation is ','automatically turned off!'
          DWSolv%DWZeta = Zero
        end if
      else
        write(u6,Fmt2//'A,T44,I2)') 'Reaction field from state:',IPCMROOT
        if (DWSolv%DWZeta > Zero) write(u6,Fmt2//'A,ES10.3,A,I1,A)') 'Dynamically weighted solvation is used with DWSOlv = ', &
                                                                     DWSolv%DWZeta,' (DWTYpe = ',DWSolv%DWType,')'
      end if
    end if
    !if (DWSCF%do_DW) then
    !  write(u6,Fmt2//'A)') 'Dynamically weighted MCSCF is enabled'
    !  write(u6,Fmt2//'A,T44,I2)') 'Target state:', DWSCF%DWRoot
    !  write(u6,Fmt2//'A,ES10.3,A,I1,A)') 'Dynamically weighted MCSCF is used with DWZEta = ',DWSCF%DWZeta,' (DWTYpe = ', &
    !                                     DWSCF%DWType,')'
    !end if
    call CollapseOutput(0,'Optimization specifications:')
    if (RFpert) then
      write(u6,*)
      write(u6,Fmt1) 'Reaction field specifications:'
      write(u6,Fmt1) '------------------------------'
      write(u6,*)
      write(u6,'(6X,A)') 'The Reaction field is added as a perturbation and has been determined in a previous calculation'
      write(u6,*)
    end if
    if (ICIRST == 1) write(u6,Fmt1) 'Starting CI array(s) will be read from file'
    call Put_dScalar('EThr',ThrE)

    ! Print out grid information in case of DFT

    if (KSDFT /= 'SCF') then
      call Put_dScalar('DFT exch coeff',CoefX)
      call Put_dScalar('DFT corr coeff',CoefR)
      call Funi_Print()
      if (IPRLEV >= USUAL) then
        write(u6,*)
        write(u6,'(6X,A)') 'DFT functional specifications'
        write(u6,'(6X,A)') '-----------------------------'
        call libxc_version()
        call Init_Funcs(KSDFT2)
        call Print_Info()
        write(u6,*)
      end if
    end if
  end if
  write(u6,*)
end if

call XFlush(u6)
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine InpPri

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PNT4DM(   NSMOB,   NSMSX,  MXPOBS,   NO1PS,   NO2PS,
     &                     NO3PS,   NO4PS,   IDXSM,   ADSXA,  SXDXSX,
     &                      IS12,    IS34,  IS1234,   IPNTR,   ISM4A,
     &                     ADASX)
*
* Pointer for 4 dimensionl array with total symmetry IDXSM
* Pointer is given as 3 dimensional array corresponding
* to the first 3 indeces
* Symmetry of last index is give by ISM4
*
* IS12 (0,1,-1)   : Permutational symmetry between indeces 1 and 2
* IS34 (0,1,-1)   : Permutational symmetry between indeces 3 and 3
* IS1234 (0,1,-1) : permutational symmetry between indeces 12 and 34
*
*. General input
      INTEGER ADSXA(MXPOBS,2*MXPOBS),SXDXSX(2*MXPOBS,4*MXPOBS)
      INTEGER ADASX(MXPOBS,MXPOBS)
*. Specific input
      INTEGER NO1PS(*),NO2PS(*),NO3PS(*),NO4PS(*)
*.Output
      INTEGER IPNTR(NSMOB,NSMOB,NSMOB),ISM4A(NSMOB,NSMOB,NSMOB)
*
      CALL ISETVC(IPNTR,0,NSMOB ** 3 )
      CALL ISETVC(ISM4A,0,NSMOB ** 3 )
*
C?    WRITE(6,*) 'NO1PS NO2PS NO3PS NO4PS '
C?    CALL IWRTMA(NO1PS,1,NSMOB,1,NSMOB)
C?    CALL IWRTMA(NO2PS,1,NSMOB,1,NSMOB)
C?    CALL IWRTMA(NO3PS,1,NSMOB,1,NSMOB)
C?    CALL IWRTMA(NO4PS,1,NSMOB,1,NSMOB)
      IOFF= 1
      N12 = 0
      N34 = 0
*
      DO 10 I1SM = 1, NSMOB
        DO 20 I2SM = 1, NSMOB
          I12SM = ADASX(I1SM,I2SM)
          I34SM = SXDXSX(I12SM,IDXSM)
          IF(I34SM.EQ.0) GOTO 20
          IF(IS12.NE.0.AND.I1SM.LT.I2SM) GOTO 20
          IF(IS12.EQ.0) THEN
           I12NUM = (I1SM-1)*NSMOB+I2SM
          ELSE
           I12NUM =  I1SM*(I1SM+1)/2+I2SM
          END IF
          IF(IS12.EQ.0.OR.I1SM.NE.I2SM) THEN
            N12 = NO1PS(I1SM)*NO2PS(I2SM)
          ELSE IF(IS12.EQ.1.AND.I1SM.EQ.I2SM) THEN
            N12 = NO1PS(I1SM)*(NO1PS(I1SM)+1)/2
          ELSE IF(IS12.EQ.-1.AND.I1SM.EQ.I2SM) THEN
            N12 = NO1PS(I1SM)*(NO1PS(I1SM)-1)/2
          END IF
          DO 30 I3SM = 1, NSMOB
            I4SM = ADSXA(I3SM,I34SM)
            IF(I4SM.EQ.0) GOTO 30
            IF(IS34.NE.0.AND.I3SM.LT.I4SM) GOTO 30
            IF(IS34.EQ.0) THEN
             I34NUM = (I3SM-1)*NSMOB+I4SM
            ELSE
             I34NUM =  I3SM*(I3SM+1)/2+I4SM
            END IF
            IF(IS1234.NE.0.AND.I12NUM.LT.I34NUM) GOTO 30
            IF(IS34.EQ.0.OR.I3SM.NE.I4SM) THEN
            N34 = NO3PS(I3SM)*NO4PS(I4SM)
            ELSE IF(IS34.EQ.1.AND.I3SM.EQ.I4SM) THEN
              N34 = NO3PS(I3SM)*(NO3PS(I3SM)+1)/2
            ELSE IF(IS34.EQ.-1.AND.I3SM.EQ.I4SM) THEN
              N34 = NO3PS(I3SM)*(NO3PS(I3SM)-1)/2
            END IF
            IF(IS1234.EQ.0.OR.I12NUM.NE.I34NUM) THEN
              IPNTR(I1SM,I2SM,I3SM) = IOFF
              ISM4A(I1SM,I2SM,I3SM) = I4SM
              IOFF= IOFF+ N12 * N34
            ELSE IF( IS1234.EQ.1.AND.I12NUM.EQ.I34NUM) THEN
              IPNTR(I1SM,I2SM,I3SM) = IOFF
              ISM4A(I1SM,I2SM,I3SM) = I4SM
              IOFF= IOFF + N12*(N12+1)/2
            ELSE IF( IS1234.EQ.-1.AND.I12NUM.EQ.I34NUM) THEN
              IPNTR(I1SM,I2SM,I3SM) = IOFF
              ISM4A(I1SM,I2SM,I3SM) = I4SM
              IOFF=  IOFF+ N12*(N12-1)/2
            END IF
C?          WRITE(6,*) ' I1SM I2SM I3SM I4SM    IOFF'
C?          WRITE(6,'(1H ,4I4,I9)')   I1SM,I2SM,I3SM,I4SM,IOFF
   30       CONTINUE
   20     CONTINUE
   10   CONTINUE
*
*
C?    WRITE(6,*) ' PNT4DM , 64 elemets of IPNTR '
C?    call IWRTMA(IPNTR,1,64,1,64)
      NTEST = 0
      IF(NTEST.NE.0) THEN
         WRITE(6,*) ' Length of 4 index array ', IOFF - 1
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NSMSX)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrintHeader(nMOs,nShowMOs,nShowMOs_ab,nCoor,nInc,iiCoord,nTypes,iCRSIZE,NBYTES,NINLINE,nBlocks)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use grid_it_globals, only: Cutoff, GridAxis1, GridAxis2, GridAxis3, GridOrigin, iGridNpt, isCutOff, isLine, isLuscus, isMOPack, &
                           isTheOne, isUHF, LID, LID_ab, LuVal, LuVal_ab, VERSION
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nMOs, nShowMOs, nShowMOs_ab, nCoor, nInc, iiCoord, nTypes(7), iCRSIZE, NBYTES, NINLINE
integer(kind=iwp), intent(inout) :: nBlocks
integer(kind=iwp) :: i, iiUHF, LuVal_, NFIRST, NLAST, nn, nn1, nShowMOs_
character(len=128) :: line

LuVal_ = LuVal
if (isLuscus) LuVal_ = LID
nShowMOs_ = nShowMOs
!call bXML('Header')
!call iXML('UHF',merge(1,0,isUHF))
do iiUHF=0,merge(1,0,isUHF)
  if (iiUHF == 1) then
    LuVal_ = LuVal_ab
    if (isLuscus) LuVal_ = LID_ab
    nShowMOs_ = nShowMOs_ab
  end if
  if (isLuscus) then
    ! debug
    !write(u6,*) 'N_of_MO=',nMOs
    !write(u6,*) 'N_of_Grids=',nShowMOs_
    !write(u6,*) 'N_of_Points=',nCoor
    !write(u6,*) 'Block_Size=',nInc
    !write(u6,*) 'N_Blocks=',nBlocks
    !write(u6,*) 'Is_cutoff=',isCutOff
    !write(u6,*) 'CutOff=',Cutoff
    !write(u6,*) 'N_P=',iiCoord
    ! end debug

    if (nMOs > 99999) then
      write(u6,*) 'Number of MO''s can''t be larger that 99999'
      call Quit_OnUserError()
    end if
    if (nShowMOs_ > 9999) then
      write(u6,*) 'Number of grids can''t be larger that 9999'
      call Quit_OnUserError()
    end if
    if (nCoor > 99999999) then
      write(u6,*) 'Number of points can''t be larger that 99999999'
      call Quit_OnUserError()
    end if
    if (nInc > 999999) then
      write(u6,*) 'Block size can''t be larger that 999999'
      call Quit_OnUserError()
    end if
    nBlocks = nCoor/nInc+1
    if (nBlocks > 9999) then
      write(u6,*) 'Number of blocks can''t be larger that 9999'
      !write(u6,*) 'nBlocks = ',nBlocks
      call Quit_OnUserError()
    end if
    !if (isCutOff > 9) then
    !  write(u6,*) 'Wrong cutoff'
    !  call Quit_OnUserError()
    !end if
    if (iiCoord > 99999999) then
      write(u6,*) 'N_P can''t be larger that 99999999'
      call Quit_OnUserError()
    end if
    write(LINE,'(''<GRID>'')')
    call PRINTLINE(LUVAL_,LINE,6,.false.)

    write(LINE,1000) nMOs,nShowMOs_,nCoor,nInc,nBlocks,merge(1,0,isCutOff),Cutoff,iiCoord
    call PRINTLINE(LUVAL_,LINE,124,.false.)
    write(LINE,1010) (nTypes(i),i=1,7)
    call PRINTLINE(LUVAL_,LINE,44,.false.)
    if (isLuscus) then
      write(LINE,1020) iGridNpt(1),iGridNpt(2),iGridNpt(3)
    else
      write(LINE,1020) iGridNpt(1)-1,iGridNpt(2)-1,iGridNpt(3)-1
    end if
    call PRINTLINE(LUVAL_,LINE,20,.false.)
    write(LINE,1030) GridOrigin
    call PRINTLINE(LUVAL_,LINE,47,.false.)
    write(LINE,1040) GridAxis1
    call PRINTLINE(LUVAL_,LINE,47,.false.)
    write(LINE,1050) GridAxis2
    call PRINTLINE(LUVAL_,LINE,47,.false.)
    write(LINE,1060) GridAxis3
    call PRINTLINE(LUVAL_,LINE,47,.false.)
    ! Here we dump all missing information
    if (.not. isLuscus) then
      write(LINE,'(1x,A,I2)') 'CR_SIZE=',iCRSIZE
      call PRINTLINE(LUVAL_,LINE,20,.false.)
      write(LINE,'(1x,A,I2)') 'PACK=',merge(1,0,isMOPack)
      call PRINTLINE(LUVAL_,LINE,20,.false.)
      write(LINE,'(1x,A,I3)') 'BYTES=',NBYTES
      call PRINTLINE(LUVAL_,LINE,20,.false.)
      write(LINE,'(1x,A,I3)') 'N_in_Line=',NINLINE
      call PRINTLINE(LUVAL_,LINE,20,.false.)
      NFIRST = nInc
      if (nBlocks == 1) NFIRST = nCoor
      write(LINE,'(1x,A,I8)') 'N_FIRST=',NFIRST
      call PRINTLINE(LUVAL_,LINE,20,.false.)

      NLAST = nCoor-(nBlocks-1)*nInc
      if (NLAST == 0) NLAST = nInc
      write(LINE,'(1x,A,I8)') 'N_LAST=',NLAST
      call PRINTLINE(LUVAL_,LINE,20,.false.)

      nn = (NFIRST/NINLINE)*(NBYTES*NINLINE+iCRSIZE)
      nn1 = NFIRST-(NFIRST/NINLINE)*NINLINE
      if (nn1 > 0) nn = nn+nn1*NBYTES+iCRSIZE

      write(LINE,'(1x,A,I10)') 'N_OFFSET=',nn
      call PRINTLINE(LUVAL_,LINE,30,.false.)

      nn = (NLAST/NINLINE)*(NBYTES*NINLINE+iCRSIZE)
      nn1 = NLAST-(NLAST/NINLINE)*NINLINE
      if (nn1 > 0) nn = nn+nn1*NBYTES+iCRSIZE
      write(LINE,'(1x,A,I10)') 'N_LAST_OFFSET=',nn
      call PRINTLINE(LUVAL_,LINE,30,.false.)
    end if

    ! skip file pointers
    ! skip end orbital section
  else

    if (isLine) then
      write(line,'(a,2i10)') '# ',nShowMOs_,nCoor
      call PrintLine(LuVal_,line,23,.false.)
    else
      write(line,'(a,a)') 'VERSION=     ',VERSION
      call PrintLine(LuVal_,line,23,.false.)
      !write(line,'(a,a)') 'Extension=   ',0
      !call PrintLine(LuVal_,line,23,.false.)
      write(line,'(a,i10)') 'N_of_MO=     ',nMOs
      !call iXML('nMOs',nMOs)
      call PrintLine(LuVal_,line,23,.false.)
      write(line,'(a,i10)') 'N_of_Grids=  ',nShowMOs_
      !call iXML('nGrids',nShowMOs_)
      call PrintLine(LuVal_,line,23,.false.)
      write(line,'(a,i10)') 'N_of_Points= ',nCoor
      !call iXML('nPoints',nCoor)
      call PrintLine(LuVal_,line,23,.false.)
      write(line,'(a,i10)') 'Block_Size=  ',nInc
      !call iXML('Block Size',nInc)
      call PrintLine(LuVal_,line,23,.false.)
      nBlocks = nCoor/nInc+1
      write(line,'(a,i10)') 'N_Blocks=    ',nBlocks
      !call iXML('nBlocks',nBlocks)
      call PrintLine(LuVal_,line,23,.false.)
      ! new cut off
      write(line,'(a,i10)') 'Is_cutoff=   ',merge(1,0,isCutOff)
      call PrintLine(LuVal_,line,23,.false.)
      write(line,'(a,f10.4)') 'CutOff=      ',CutOff
      call PrintLine(LuVal_,line,23,.false.)
      write(line,'(a,i10)') 'N_P=         ',iiCoord
      call PrintLine(LuVal_,line,23,.false.)
      write(line,'(a,7I5)') 'N_INDEX=     ',nTypes
      call PrintLine(LuVal_,line,48,.false.)
    end if
    if (.not. isTheOne) then

      write(line,'(a,3i5)') 'Net=         ',iGridNpt(1)-1,iGridNpt(2)-1,iGridNpt(3)-1
      !call iaXML('Net',iGridNpt,3)
      call PrintLine(LuVal_,line,28,.false.)

      write(line,'(a,3f12.3)') 'Origin= ',GridOrigin
      !call daXML('Origin',GridOrigin,3)
      call PrintLine(LuVal_,line,44,.false.)

      write(line,'(a,3f12.3)') 'Axis_1= ',GridAxis1
      !call daXML('Axis 1',GridAxis1,3)
      call PrintLine(LuVal_,line,44,.false.)
      write(line,'(a,3f12.3)') 'Axis_2= ',GridAxis2
      !call daXML('Axis 2',GridAxis2,3)
      call PrintLine(LuVal_,line,44,.false.)
      write(line,'(a,3f12.3)') 'Axis_3= ',GridAxis3
      !call daXML('Axis 3',GridAxis3,3)
      call PrintLine(LuVal_,line,44,.false.)

    end if
  end if
end do
!call eXML('Header')

return

1000 format(1X,'N_of_MO=',I5,1X,'N_of_Grids=',I4,1X,'N_of_Points=',I8,1X,'Block_Size=',I6,1X,'N_Blocks=',I4,1X,'Is_cutoff=',I1,1X, &
            'CutOff=',F8.4,1X,'N_P=',I8)
1010 format(1X,'N_INDEX=',7I5)
1020 format(1X,'Net=',3I5)
1030 format(1X,'Origin=',3(1X,F12.8))
1040 format(1X,'Axis_1=',3(1X,F12.3))
1050 format(1X,'Axis_2=',3(1X,F12.3))
1060 format(1X,'Axis_3=',3(1X,F12.3))

end subroutine PrintHeader

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine comp2ind(W,IDM,no)
      implicit none
      real*8 W,DD
      integer IDM,no, IJ,I,IJO,II,K,L,KL,LK, NF, J, JIO
      dimension W(IDM,*)
cmp!      include 'pvtrace_inc.f'
cmp!      include 'pvtrace_inc'
cmp!      if (LLtrace) then
cmp!         write(6,*) 'Entering COMP2IND'
cmp!         call xflush(6)
cmp!      endif
C
C   comprises the back square to triangle  (r,s,p,>t)>>> (r,s,pt)
C   remains in the same array!
C
C   Fixed DCOPY for no=2 to avoid overlap in input and output fields
C   with impredictable behavior on pwr4/ESSL.       PV, 12 aug 2004.
C
c      write(6,*)'comp2ind:',IDM,no
c   check
c      do I=1,no
c      do J=1,I
c      IJ=(I-1)*no+J
c      JI=(J-1)*no+I
c      DD1=DDOT_(IDM,W(1,IJ),1,W(1,IJ),1)
c      DD2=DDOT_(IDM,W(1,JI),1,W(1,JI),1)
c      if(abs(DD1-DD2).GT.1D-10)write(6,*)'warning'
c      write(6,*)dd1,dd2
c      enddo
c      enddo
      IJ=2
      do I=2,no
         IJO=(I-1)*no+1
C        CALL DCOPY_(IDM*I,W(1,IJO),1,W(1,IJ),1)
         if (no.eq.2) then
            CALL DCOPY_(IDM,W(1,3),1,W(1,2),1)
            CALL DCOPY_(IDM,W(1,4),1,W(1,3),1)
         else
            CALL DCOPY_(IDM*I,W(1,IJO),1,W(1,IJ),1)
         endif
         IJ=IJ+I
      enddo
cmp!      if (LLtrace) then
cmp!         write(6,*) 'Leaving COMP2IND'
cmp!         call xflush(6)
cmp!      endif
      return

      entry decomp2ind(W,IDM,no,NF)
cmp!      if (LLtrace) then
cmp!         write(6,*) 'Entering DECOMP2IND'
cmp!         call xflush(6)
cmp!      endif
C
C symmetrizes the upper index
C
C      write(6,*)'decomp2ind:',IDM,no,NF
      DO I=1,no
         II=I*(I+1)/2
         DO K=2,NF
            DO L=1,K-1
               KL=(K-1)*NF+L
               LK=(L-1)*NF+K
               DD=0.5d0*(W(KL,II)+W(LK,II))
               W(KL,II)=DD
               W(LK,II)=DD
            enddo
         enddo
      enddo
      IF(NO.GT.2)THEN
         DO I=NO,2,-1
            IJ=I*(I-1)/2+1
            IJO=(I-1)*no+1
            CALL DCOPY_(IDM*I,W(1,IJ),1,W(1,IJO),1)
         enddo
      ELSEIF(NO.EQ.2)THEN
         CALL DCOPY_(IDM,W(1,3),1,W(1,4),1)
         CALL DCOPY_(IDM,W(1,2),1,W(1,3),1)
      endif
      DO I=2,no
         DO J=1,I-1
            IJO=(I-1)*no+J
            JIO=(J-1)*no+I
            call transm(W(1,IJO),W(1,JIO),NF,NF)
         enddo
      enddo
c     stop
cmp!      if (LLtrace) then
cmp!         write(6,*) 'Leaving DECOMP2IND'
cmp!         call xflush(6)
cmp!      endif
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1999, Roland Lindh                      *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine OneEl_Inner(Kernel,KrnlMm,Label,ip,lOper,nComp,CoorO,nOrdOp,rHrmt,iChO,iStabO,nStabO,nIC,PtChrg,nGrid,iAddPot,Array, &
                       LenTot)
!***********************************************************************
!                                                                      *
! Object: to compute the one-electron integrals. The method employed at*
!         this point is not necessarily the fastest. However, the total*
!         time for the computation of integrals will depend on the time*
!         spent in computing the two-electron integrals.               *
!         The memory at this point is assumed to be large enough to do *
!         the computation in core.                                     *
!         The data is structured with respect to four indices, two (my *
!         ny or i j) refer to primitives or basis functions and two (a *
!         b) refer to the components of the cartesian or spherical     *
!         harmonic gaussians.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!             Modified for Hermite-Gauss quadrature November '90       *
!             Modified for Rys quadrature November '90                 *
!             Modified for multipole moments November '90              *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for general kernel routines January  91         *
!             Modified for nonsymmetrical operators February  91       *
!             Modified for better symmetry treatement October  93      *
!             Modified loop structure April 99                         *
!***********************************************************************

use Index_Functions, only: nTri_Elem, nTri_Elem1
use iSD_data, only: iSD
use Basis_Info, only: dbsc
use Sizes_of_Seward, only: S
use rmat, only: RMat_Type_Integrals
use property_label, only: PLabel
use Integral_interfaces, only: int_kernel, int_mem, OneEl_IJ
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
procedure(int_kernel) :: Kernel
procedure(int_mem) :: KrnlMm
character(len=8), intent(in) :: Label
integer(kind=iwp), intent(in) :: nComp, ip(nComp), lOper(nComp), nOrdOp, iChO(nComp), iStabO(0:7), nStabO, nIC, nGrid, iAddPot, &
                                 LenTot
real(kind=wp), intent(in) :: CoorO(3,nComp), rHrmt, PtChrg(nGrid)
real(kind=wp), intent(inout) :: Array(LenTot)
integer(kind=iwp) :: i, iAng, iAO, iBas, iCmp, iCnttp, iComp, id_Tsk, ijS, ijSh, iPrim, iPrint, ipSO, iS, iShell, iSmLbl, iSOBlk, &
                     jAng, jAO, jBas, jCmp, jCnttp, jPrim, jS, jShell, l_SOInt, lA0, lA1, lB0, lB1, lFinal, lScrt1, lScrt2, &
                     MemAux, MemBux, MemCux, MemKer, MemKrn, mFinal, mScrt1, mScrt2, mSO, nIJS, nOrder, nSkal, nSO
real(kind=wp) :: rHrmt_in
logical(kind=iwp) :: Do_PGamma
integer(kind=iwp), allocatable :: Ind_ij(:,:)
real(kind=wp), allocatable :: Kappa(:), PCoor(:), ScrSph(:), Scrtch(:), SOInt(:), Zeta(:), ZI(:)
real(kind=wp), allocatable, target :: FArray(:), Kern(:)
integer(kind=iwp), external :: MemSO1, n2Tri
logical(kind=iwp), external :: Rsv_Tsk

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
iPrint = 99
#else
iPrint = 5
#endif
RMat_type_integrals = .false.
Do_PGamma = .true.

! Auxiliary memory allocation.

call mma_allocate(Zeta,S%m2Max,label='Zeta')
call mma_allocate(ZI,S%m2Max,label='ZI')
call mma_allocate(Kappa,S%m2Max,label='Kappa')
call mma_allocate(PCoor,S%m2Max*3,label='PCoor')
!                                                                      *
!***********************************************************************
!                                                                      *
call Nr_Shells(nSkal)
!                                                                      *
!***********************************************************************
!                                                                      *
! Double loop over shells. These loops decide the integral type
!                                                                      *
!***********************************************************************
!                                                                      *
! Create list of non-vanishing pairs

call mma_allocate(Ind_ij,2,nTri_Elem(nSkal),label='Ind_ij')
nijS = 0
is = 0
js = 0
do I=1,nTri_Elem(nSkal)
  nijS = nijS+1
  js = js+1
  if (jS > iS) then
    iS = jS
    jS = 1
  end if
  Ind_ij(1,nijS) = iS
  Ind_ij(2,nijS) = jS
end do
call Init_Tsk(id_Tsk,nijS)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate scratch for the integral evaluation.

lFinal = 1
lScrt1 = 1
lScrt2 = 1
MemKrn = 1
do ijS=1,nijS
  iS = Ind_ij(1,ijS)
  jS = Ind_ij(2,ijS)
  iPrim = iSD(5,iS)
  jPrim = iSD(5,jS)
  iBas = iSD(3,iS)
  jBas = iSD(3,jS)
  iAng = iSD(1,iS)
  jAng = iSD(1,jS)

  mFinal = nIC*iPrim*jPrim*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  lFinal = max(lFinal,mFinal)

  if (Label(1:3) == 'MAG') cycle
  mScrt1 = nIC*max(iPrim,jBas)*max(iBas,jPrim)*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  lScrt1 = max(mScrt1,lScrt1)

  mScrt2 = nIC*iBas*jBas*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  lScrt2 = max(mScrt2,lScrt2)

  call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)

  if (PLabel /= ' ') then
    la0 = iAng
    lb0 = jAng
    MemAux = 1+3*nTri_Elem1(la0)*nTri_Elem1(lb0+1)*nIC
    la1 = la0
    lb1 = lb0+1
    MemBux = 1+3*nTri_Elem1(la1+1)*nTri_Elem1(lb1)*nIC
    if (la1 /= 0) MemBux = MemBux+3*nTri_Elem1(la1-1)*nTri_Elem1(lb1)*nIC
    if (lb0 /= 0) then
      lb1 = lb0-1
      MemAux = MemAux+3*nTri_Elem1(la0)*nTri_Elem1(lb0-1)*nIC
      MemCux = 1+3*nTri_Elem1(la1+1)*nTri_Elem1(lb1)*nIC
      if (la1 /= 0) MemCux = MemCux+3*nTri_Elem1(la1-1)*nTri_Elem1(lb1)*nIC
    else
      MemCux = 0
    end if
    MemAux = MemAux+max(MemBux,MemCux)
    MemKer = MemKer+MemAux
  end if

  MemKrn = max(MemKer*iPrim*jPrim,MemKrn)
end do

call mma_Allocate(FArray,lFinal,label='Final')
call mma_allocate(Scrtch,lScrt1,label='Scrtch')
call mma_allocate(ScrSph,lScrt2,label='ScrSph')
call mma_allocate(Kern,MemKrn,label='Kern')
!                                                                      *
!***********************************************************************
!                                                                      *
! big loop over individual tasks, distributed over individual nodes
ijSh = 0
do
  ! make reservation of a task on global task list and get task range
  ! in return. Function will be false if no more tasks to execute.
  if (.not. Rsv_Tsk(id_Tsk,ijSh)) exit
  iS = Ind_ij(1,ijSh)
  jS = Ind_ij(2,ijSh)

  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iAO = iSD(7,iS)
  iShell = iSD(11,iS)
  iCnttp = iSD(13,iS)

  jCmp = iSD(2,jS)
  jBas = iSD(3,jS)
  jAO = iSD(7,jS)
  jShell = iSD(11,jS)
  jCnttp = iSD(13,jS)

  nSO = 0
  do iComp=1,nComp
    iSmLbl = lOper(iComp)
    nSO = nSO+MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) ' nSO=',nSO
# endif

  ! Do not compute matrix elements in which electronic and
  ! muonic basis sets are mixed.

  if ((nSO > 0) .and. (dbsc(iCnttp)%fMass == dbsc(jCnttp)%fMass)) then
    l_SOInt = iBas*jBas*nSO
    call mma_allocate(SOInt,l_SOInt,label='SOInt')
    SOInt(:) = Zero
    ipSO = 1
    call OneEl_IJ(iS,jS,iPrint,Do_PGamma,Zeta,ZI,Kappa,PCoor,Kernel,KrnlMm,Label,lOper,nComp,CoorO,nOrdOp,iChO,iStabO,nStabO,nIC, &
                  PtChrg,nGrid,iAddPot,SOInt,l_SOInt,FArray,lFinal,Scrtch,lScrt1,ScrSph,lScrt2,Kern,MemKrn)
    iSOBlk = ipSO
    do iComp=1,nComp
      iSmLbl = lOper(iComp)
      if (n2Tri(iSmLbl) /= 0) then
        mSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
      else
        mSO = 0
      end if

      ! Special trick for integrals over electromagnetic field
      ! radiation integrals.

      rHrmt_in = rHrmt

      if ((Label(1:5) == 'EMFR ') .or. (Label(1:5) == 'TMOM ')) then
        if (mod((iComp+5),6) < 3) then
          rHrmt_in = One
        else
          rHrmt_in = -One
        end if
      end if
      !write(u6,*) 'Label,iComp,rHrmt_in=',Label,iComp,rHrmt_in
      if (mSO /= 0) then
        call SOSctt(SOInt(iSOBlk),iBas,jBas,mSO,Array(ip(iComp)),n2Tri(iSmLbl),iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO,rHrmt_in)
        iSOBlk = iSOBlk+mSO*iBas*jBas
      end if
    end do
    call mma_deallocate(SOInt)
  end if
end do
call Free_Tsk(id_Tsk)
do iComp=1,nComp
  iSmLbl = lOper(iComp)
  call GADSum(Array(ip(iComp)),n2Tri(iSmLbl))
end do

call mma_deallocate(Kern)
call mma_deallocate(ScrSph)
call mma_deallocate(Scrtch)
call mma_deallocate(FArray)
call mma_deallocate(Ind_ij)
call mma_deallocate(PCoor)
call mma_deallocate(Kappa)
call mma_deallocate(ZI)
call mma_deallocate(Zeta)

return

end subroutine OneEl_Inner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Roland Lindh                                     *
!***********************************************************************

subroutine ReNorm2_Inner(iCnttp)
!***********************************************************************
!                                                                      *
!    Objective: Orthonormalize parts of the auxiliary basis set.       *
!                                                                      *
! Called from: Mk_RICD_Shells                                          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theor. Chemi., Lund Univ., Sweden.*
!                                                                      *
!             Modified to transform the auxiliary basis to a true      *
!             Cholesky basis set while on TACC 2008 conference in      *
!             Songjiang District, Shanghai, China, 23-27 Sept. 2008.   *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use RI_procedures, only: Drv2El_Atomic_NoSym
use SOAO_Info, only: iAOtSO, nSOInf
use Real_Spherical, only: Sphere
use Basis_Info, only: dbsc, iCnttp_Dummy, Shells
use Sizes_of_Seward, only: S
use RICD_Info, only: Thrshld_CD
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCnttp
#include "itmax.fh"
integer(kind=iwp) :: i, iAng, iAO, iBas, iCase, iCmp, iDisk, ij, ijF, ijS, ijS_req, ijT, iSeed, iShll, iShll_, iSO, j, jBas, jCmp, &
                     jiS, Keep_Shell, Lu_A, Lu_Q, m, nBasisi, nCmp, nExpi, nSO, nTest, nTInt_c
real(kind=wp) :: Thr_CB, ThrAO
logical(kind=iwp) :: In_Core
real(kind=wp), allocatable :: ADiag(:), Not_Used(:), QVec(:,:), TInt_c(:), TInt_d(:), Tmp(:,:)
integer(kind=iwp), external :: IsFreeUnit
external :: Integral_RI_2

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
! Let us now Gram-Schmidt orthonormalize the auxiliary basis for
! better numerics and balance.

! Update kOffAO and lOffAO to include the auxiliary basis too.

call Setup_OffAO()

! Set up transformation matrix from Cartesian to real spherical harmonics.

call Sphere(S%iAngMx)

call Flip_Flop(.false.) ! Contracted mode.

Thr_CB = max(1.0e-14_wp,Thrshld_CD*1.0e-10_wp)
ThrAO = Zero

!do iCnttp = 1, nCnttp
! Skip the dummy shell
if (iCnttp == iCnttp_dummy) return
! skip non-auxiliary basis sets
if (.not. dbsc(iCnttp)%Aux) return
!                                                                      *
!***********************************************************************
!                                                                      *
! Define some parameters to facilitate the atomic calculation

S%nShlls = dbsc(iCnttp)%nVal
nTest = dbsc(iCnttp)%nVal-1

! Define AOtSO

iAO = 0
iSO = 0
nSO = 0
do iAng=0,nTest
  iShll_ = dbsc(iCnttp)%iVal+iAng
  nCmp = nTri_Elem1(iAng)
  if (Shells(iShll_)%Prjct) nCmp = 2*iAng+1
  iSO = 0
  if (Shells(iShll_)%nBasis_C*Shells(iShll_)%nExp == 0) cycle
  do iCmp=1,nCmp
    iAO = iAO+1
    if (iAO > nSOInf) then
      write(u6,*) 'renorm2_inner: iAO>nSOInf'
      write(u6,*) 'iAO=',iAO
      write(u6,*) 'nSOInf=',nSOInf
      call Abend()
    end if
    iAOtSO(iAO,0) = iSO+1
    iSO = iSO+Shells(iShll_)%nBasis
  end do
  nSO = nSO+iSO
end do

ijS_req = 0
Keep_Shell = iTabMx
do iAng=0,nTest
  iShll = dbsc(iCnttp)%iVal+iAng
  nExpi = Shells(iShll)%nExp
  nBasisi = Shells(iShll)%nBasis
  if (nExpi*nBasisi == 0) cycle

  nCmp = nTri_Elem1(iAng)
  if (Shells(iShll)%Prjct) nCmp = 2*iAng+1

  ijS_req = ijS_req+1

  call Drv2El_Atomic_NoSym(Integral_RI_2,ThrAO,iCnttp,iCnttp,TInt_c,nTInt_c,In_Core,Not_Used,Lu_A,ijS_req,Keep_Shell)
# ifdef _DEBUGPRINT_
  call TriPrt('TInt_c',' ',TInt_c,nTInt_c)
# endif

  if (.not. In_Core) then
    call WarningMessage(2,'Error in ReNorm')
    write(u6,*) 'Out-of-core acCD not implemented!'
    call Abend()
  end if

  ! Produce the reduced set, in-place reduction.

  call mma_allocate(TInt_d,nTInt_c**2,Label='TInt_d')
  ijT = 0
  do iBas=1,nTInt_c
    do jBas=1,iBas
      ijT = ijT+1
      ijS = (jBas-1)*nTInt_c+iBas
      jiS = (iBas-1)*nTInt_c+jBas
      TInt_d(ijS) = TInt_c(ijT)
      TInt_d(jiS) = TInt_c(ijT)
    end do
  end do
  call mma_deallocate(TInt_c)
# ifdef _DEBUGPRINT_
  call RecPrt('TInt_d',' ',TInt_d,nTInt_c,nTInt_c)
# endif

  ij = 0
  iCmp = 1
  jCmp = 1
  do jBas=1,nBasisi
    j = (jCmp-1)*nBasisi+jBas
    do iBas=1,nBasisi
      i = (iCmp-1)*nBasisi+iBas
      ijF = (j-1)*nBasisi*nCmp+i
      ij = ij+1

      TInt_d(ij) = TInt_d(ijF)

    end do
  end do
# ifdef _DEBUGPRINT_
  call RecPrt('TInt_d(r)','(5G20.10)',TInt_d,nBasisi,nBasisi)
# endif

  call mma_allocate(ADiag,nBasisi,Label=' ADiag')

  iSeed = 77
  Lu_A = IsFreeUnit(iSeed)
  call DaName_MF_WA(Lu_A,'AMat09')

  iDisk = 0
  call dDaFile(Lu_A,1,TInt_d,nBasisi**2,iDisk)

  iSeed = iSeed+1
  Lu_Q = IsFreeUnit(iSeed)
  call DaName_MF_WA(Lu_Q,'QMat09')

  call dcopy_(nBasisi,TInt_d,nBasisi+1,ADiag,1)

  call CD_AInv_Inner(nBasisi,m,ADiag,Lu_A,Lu_Q,Thr_CB)

  call mma_deallocate(ADiag)
  call mma_deallocate(TInt_d)

  ! Transform the contraction coefficients according to the Cholesky vectors.

  call mma_allocate(Tmp,nExpi,nBasisi,Label='Tmp')
  call mma_allocate(QVec,nBasisi,nBasisi,Label='QVec')
  QVec(:,:) = Zero

  iDisk = 0
  call dDaFile(Lu_Q,2,QVec,nBasisi*m,iDisk)
  call DaEras(Lu_Q)
# ifdef _DEBUGPRINT_
  call RecPrt('QVec',' ',QVec,nBasisi,m)
# endif

  do iCase=1,2
    Tmp(:,:) = Shells(iShll)%Cff_c(:,:,iCase)
#   ifdef _DEBUGPRINT_
    call RecPrt('Coeff(old)',' ',Shells(iShll)%Cff_c(:,:,iCase),nExpi,nBasisi)
#   endif
    call DGEMM_('N','N',nExpi,nBasisi,nBasisi,One,Tmp,nExpi,QVec,nBasisi,Zero,Shells(iShll)%Cff_c(:,:,iCase),nExpi)
#   ifdef _DEBUGPRINT_
    call RecPrt('Coeff(new)',' ',Shells(iShll)%Cff_c(:,:,iCase),nExpi,nBasisi)
#   endif
  end do

  call mma_deallocate(QVec)
  call mma_deallocate(Tmp)

end do

!end do
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine ReNorm2_Inner

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CXInit(iSGStruct,iCIstruct,iXStruct)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='CXINIT')
#include "Struct.fh"
      Dimension iSGStruct(nSGSize)
      Dimension iCIStruct(nCISize)
      Dimension iXStruct (nXSize)
#include "WrkSpc.fh"


      nSym   =iSGStruct(1)
      nLev   =iSGStruct(2)
      lISm   =iSGStruct(3)
      nVert  =iSGStruct(4)
      lDRT   =iSGStruct(5)
      lDown  =iSGStruct(6)
CUNUSED      lUp    =iSGStruct(7)
      MidLev =iSGStruct(8)
      MVSta  =iSGStruct(9)
      MVEnd  =iSGStruct(10)
      lMAW   =iSGStruct(11)
      lLTV   =iSGStruct(12)

CTEST      write(*,*)' In CXINIT.'
CTEST      write(*,*)'   NSYM:',NSYM
CTEST      write(*,*)'   NLEV:',NLEV
CTEST      write(*,*)'  NVERT:',NVERT
CTEST      write(*,*)' MIDLEV:',MIDLEV
CTEST      write(*,*)' MVSTA :',MVSTA
CTEST      write(*,*)' MVEND :',MVEND
C Calculate segment values, and MVL and MVR tables:
      nMidV=1+MVEnd-MVSta
C nIpWlk: NR OF INTEGERS USED TO PACK EACH UP- OR DOWNWALK.
      nIpWlk=1+(MidLev-1)/15
      nIpWlk=MAX(nIpWlk,1+(nLev-MidLev-1)/15)
      Call GetMem('IVR','Allo','Inte',lIVR,2*nVert)
      Call GetMem('MVR','Allo','Inte',lMVR,2*nMidV)
      Call GetMem('MVL','Allo','Inte',lMVL,2*nMidV)
      nSgmnt=26*nVert
      Call GetMem('ISGM','Allo','Inte',lISgm,nSgmnt)
      Call GetMem('VSGM','Allo','Real',lVSgm,nSgmnt)
CTEST      write(*,*)' Calling MKSEG.'
      Call MkSeg(iSGStruct,nLev,nVert,nMidv,
     &        IWork(lDRT),IWork(lDown),IWork(lLTV),
     &        IWork(lIVR),IWork(lMVL),IWork(lMVR),
     &        IWork(lISgm),Work(lVSgm))
CTEST      write(*,*)' Back from MKSEG.'
      iCIStruct(1)=nMidV
      iCIStruct(2)=nIpWlk
      iXStruct(8 )=lMVL
      iXStruct(9 )=lMVR

C Various offset tables:
      nNOW=2*nMidV*nSym
CUNUSED      nIOW=nNOW
      Call GetMem('NOW','Allo','Inte',lNOW,nNOW)
      Call GetMem('IOW','Allo','Inte',lIOW,nNOW)
      MxEO=(nLev*(nLev+5))/2
      nNOCP=MxEO*nMidV*nSym
      nIOCP=nNOCP
      nNRL=(1+MxEO)*nVert*nSym
      Call GetMem('NOCP','Allo','Inte',lNOCP,nNOCP)
      Call GetMem('IOCP','Allo','Inte',lIOCP,nIOCP)
      Call GetMem('NCSF','Allo','Inte',lNCSF,nSym)
      Call GetMem('NRL','Allo','Inte',lNRL,nNRL)
      nNOCSF=nMidV*(nSym**2)
      nIOCSF=nNOCSF

      Call GetMem('NOCSF','Allo','Inte',lNOCSF,nNOCSF)
      Call GetMem('IOCSF','Allo','Inte',lIOCSF,nIOCSF)
      iCIStruct(3)=lNOW
      iCIStruct(4)=lIOW
      iCIStruct(5)=lNCSF
      iCIStruct(6)=lNOCSF
      iCIStruct(7)=lIOCSF
      iXStruct(1)=MxEO
      iXStruct(2)=lNOCP
      iXStruct(3)=lIOCP
CTEST      write(*,*)' Calling NRCOUP.'
      Call NrCoup(iSGStruct,iCIStruct,iXStruct,
     &         nVert,nMidV,MxEO,IWork(lISm),IWork(lDRT),
     &         IWork(lISgm),IWork(lNOW),IWork(lIOW),IWork(lNOCP),
     &         IWork(lIOCP),IWork(lNOCSF),IWork(lIOCSF),
     &         IWork(lNCSF),IWork(lNRL),IWork(lMVL),IWork(lMVR))
CTEST      write(*,*)' Back from NRCOUP.'
      Call GetMem('NRL','Free','Inte',lNRL,nNRL)
C Computed in NrCoup:
      nWalk=ICISTRUCT(8)
      nICoup=IXSTRUCT(4)

      nICase=nWalk*nIpWlk
CTEST      write(*,*)' NWALK:',NWALK
      Call GetMem('ICASE','Allo','Inte',lICase,nICase)
      nnICoup=3*nICoup
      Call GetMem('ICoup','Allo','Inte',lICoup,nnICoup)
      nVMax=5000
      Call GetMem('VTabTmp','Allo','Real',lVTabTmp,nVMax)
      nILNDW=nWalk
      Call GetMem('iLndw','Allo','Inte',liLndw,niLndw)
      nScr=7*(nLev+1)
      Call GetMem('SCR','Allo','Inte',lScr,nScr)
      Call GetMem('VAL','Allo','Real',lVal,nLev+1)
      iCIStruct(9)=lICase
      iXStruct(5)=lICoup
      iXStruct(6)=nVMax
      iXStruct(7)=lVTabTmp
      nVTab=nVMax
      lVTab=lVTabTmp
      Call MkCoup(nLev,IWork(lIsm),nVert,MidLev,nMidV,MVSta,MVEnd,
     &            MxEO,nICoup,nWalk,nICase,nVTab,
     &            IWork(lIVR),IWork(lMAW),IWork(lISGM),
     &            WORK(lVSGM),IWork(lNOW),IWork(lIOW),IWork(lNOCP),
     &     IWork(lIOCP),IWork(lILNDW),IWork(lICASE),IWork(lICOUP),
     &     WORK(lVTAB),IWork(lSCR),WORK(lVAL))
C iXStruct(10)..iXStruct(14) are set in MkCoup

C nVTab has now been updated to the true size. Allocate final array:
      Call GetMem('VTab','Allo','Real',lVtab,nVTab)
      iXStruct(6)=nVTab
      iXStruct(7)=lVTab
      call dcopy_(nVTab,Work(lVTabTmp),1,Work(lVTab),1)
      Call GetMem('VTabTmp','Free','Real',lVTabTmp,nVMax)
      Call GetMem('iLndw','Free','Inte',liLndw,niLndw)
      Call GetMem('SCR','Free','Inte',lScr,nScr)
      Call GetMem('VAL','Free','Real',lVal,nLev+1)
      Call GetMem('ISGM','Free','Inte',lISgm,nSgmnt)
      Call GetMem('VSGM','Free','Real',lVSgm,nSgmnt)
      Call GetMem('IVR','Free','Inte',lIVR,2*nVert)

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine getmap(lun,length,map,rc)
! this routine reads %d and %i of the given mediate
! from lun and reconstructs %d to actual positions %pos0
!
! lun    - Logical unit number of file, where mediate is stored (Input)
! length - overall length of mediate (Output)
! map    - map type corresponding to given mediate (Output)
! rc     - return (error) code (Output)
!
! N.B.
! all mediates are stored as follows
! 1 - Map_Type
! 2 - one record with complete mediate

use ccsd_global, only: daddr, iokey, Map_Type
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lun
integer(kind=iwp), intent(out) :: length, rc
type(Map_Type), intent(inout) :: map
integer(kind=iwp) :: im, pos

rc = 0

!1 read %d

if (iokey == 1) then
  ! Fortran IO
  read(lun) map%d(:,:),map%i(:,:,:)
else
  ! MOLCAS IO
  call idafile(lun,2,map%d,size(map%d),daddr(lun))
  call idafile(lun,2,map%i,size(map%i),daddr(lun))
end if

!2 change positions in %d to proper one and calculate overall length

pos = map%pos0
length = 0

do im=1,map%d(0,5)

  map%d(im,1) = pos
  pos = pos+map%d(im,2)
  length = length+map%d(im,2)

end do

return

end subroutine getmap

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RASSI(IRETURN)

use Index_Functions, only: nTri_Elem
use Basis_Info, only: nBas
use Cntrl, only: BINA, Do_SK, DQVD, DYSEXPORT, DYSO, HOP, IFHAM, IFSO, LuExc, LuOne, LuTDM, MLTPLT, NATO, NJOB, NPROP, NSTATE, &
                 ONLY_OVERLAPS, SaveDens, SONATNSTATE, SONTOSTATES, TRACK
use Fock_util_global, only: Fake_CMO2
use frenkel_global_vars, only: doCoul, doExcitonics, eNucB, vNucB
use kVectors, only: k_Vector
use Molcas, only: MxRoot
use mspt2_eigenvectors, only: deinit_mspt2_eigenvectors
use rassi_aux, only: CMO1, CMO2, DMAB, ipglob, jDisk_TDM, Job_Index, TocM
use rassi_data, only: NBASF, NBSQ, NBST, NTDMZZ
use rassi_global_arrays, only: EIGVEC, ESHFT, HAM, HDIAG, JBNUM, LROOT, SFDYS, SODYSAMPS, SODYSAMPSI, SODYSAMPSR
use Symmetry_Info, only: nIrrep, Symmetry_Info_Free
#ifdef _HDF5_
use Dens2HDF5, only: StoreDens
use mh5, only: mh5_put_dset
use RASSIWfn, only: wfn_overlap
#endif
#ifdef _DMRG_
use qcmaquis_info, only: qcmaquis_info_deinit
use qcmaquis_interface, only: qcmaquis_interface_deinit
use rasscf_global, only: doDMRG
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: IRETURN
integer(kind=iwp) :: IDISK, IOPT, IRC, ISTATE, ISY, J, JOB, JOB1, JOB2, MPLET, nh1, NSS, NZ, NZCOUL
logical(kind=iwp) :: aux2, CLOSEONE
real(kind=wp), allocatable :: DMAT(:), DYSAMPS(:,:), ENERGY(:), OCC(:), OVLP(:,:), PROP(:,:,:), SOENE(:), TDMZZ(:), USOI(:,:), &
                              USOR(:,:), VNAT(:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Prologue

IRETURN = 20

call StatusLine('RASSI: ','Starting calculation')

call GETPRINTLEVEL()

! Greetings. Default settings. Initialize data sets.
call INIT_RASSI()

CLOSEONE = .false.
IRC = -1
IOPT = 0
call OPNONE(IRC,IOPT,'ONEINT',LUONE)
if (IRC /= 0) then
  write(u6,*) 'RASSI: Error opening file'
  call ABEND()
end if
CLOSEONE = .true.

! Read and check keywords etc. from stdin. Print out.
call INPCTL_RASSI()

!SVC: prepare HDF5 wavefunction file
call CRE_RASSIWFN()

!--------  RAS wave function section --------------------------
! First, in a double loop over the states, compute any matrix
! elements required for the input RASSCF state pairs.
! Needed generalized transition density matrices are computed by
! GTDMCTL. They are written on unit LUTDM.
! Needed matrix elements are computed by PROPER.
call mma_allocate(OVLP,NSTATE,NSTATE,Label='OVLP')
call mma_allocate(DYSAMPS,NSTATE,NSTATE,Label='DYSAMPS')
call mma_allocate(EigVec,nState,nState,Label='EigVec')
call mma_allocate(ENERGY,nState,Label='Energy')
call mma_allocate(TocM,nTri_Elem(NSTATE),Label='TocM')
call mma_allocate(PROP,NSTATE,NSTATE,NPROP,LABEL='Prop')
Prop(:,:,:) = Zero
DYSAMPS(:,:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! Number of basis functions
NZ = 0  ! (NBAS is already used...)
do ISY=1,nIrrep
  NZ = NZ+NBASF(ISY)
end do
if (DYSO) call mma_allocate(SFDYS,nZ,nState,nState,Label='SFDYS')

aux2 = .false.
if (doCoul) then
  call mma_allocate(eNucB,nTri_Elem(mxroot),Label='eNuc')
  eNucB(:) = Zero
  NZcoul = 0  ! (NBAS is already used...)
  inquire(file='AUXRFIL2',exist=aux2)
  if (aux2) then
    call NameRun('AUXRFIL2')
  else
    call NameRun('AUXRFIL1')
  end if
  call get_iArray('nBas',nBas,nIrrep)
  NZcoul = nBas(0)
  nh1 = nTri_Elem(NZcoul)
  call mma_allocate(vNucB,nh1,Label='Attr PotB')
  call Get_dArray('Nuc Potential',vNucB,nh1)
  call NameRun('#Pop')    ! switch back to old RUNFILE
end if

! Loop over jobiphs:
IDISK = 0  ! Initialize disk address for TDMs.
do JOB1=1,NJOB
  do JOB2=1,JOB1

    Fake_CMO2 = JOB1 == JOB2  ! MOs1 = MOs2  ==> Fake_CMO2=.true.

    ! Compute generalized transition density matrices, as needed:
    call GTDMCTL(PROP,JOB1,JOB2,OVLP,DYSAMPS,NZ,IDISK)
  end do
end do

#ifdef _HDF5_
call mh5_put_dset(wfn_overlap,OVLP,[NSTATE,NSTATE],[0,0])
#endif
call Put_dArray('State Overlaps',OVLP,NSTATE*NSTATE)

if (TRACK) call TRACK_STATE(OVLP)
if (TRACK .or. ONLY_OVERLAPS) then

  ! Print the overlap matrix here, since MECTL is skipped
  if (IPGLOB >= 2) then
    write(u6,*)
    write(u6,*) '     OVERLAP MATRIX FOR THE ORIGINAL STATES:'
    write(u6,*)
    do ISTATE=1,NSTATE
      write(u6,'(5(1X,F15.8))') (Ovlp(j,iState),j=1,istate)
    end do
  end if
else

  ! Property matrix elements:
  call StatusLine('RASSI: ','Computing matrix elements.')
  call MECTL(PROP,OVLP,HAM,ESHFT)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Spin-free section

  !--------  SI wave function section --------------------------
  ! In a second section, if Hamiltonian elements were requested,
  ! then also a set of secular equations are solved. This gives
  ! a set of non-interacting, orthonormal wave functions expressed
  ! as linear combinations of the input wave functions. These
  ! results are written out, as well as the matrix elements  of
  ! the eigenstates, and if requested, their density matrices
  ! and perhaps GTDMs.

  ! Hamiltonian matrix elements, eigenvectors:
  if (IFHAM) then
    call StatusLine('RASSI: ','Computing Hamiltonian.')
    call EIGCTL(PROP,OVLP,DYSAMPS,HAM,EIGVEC,ENERGY)
  end if

  ! +++ J. Creutzberg, J. Norell - 2018
  ! Write the spin-free Dyson orbitals to .DysOrb and .molden
  ! files if requested
  !----------------------------------------------------------------

  ! Bruno Tenorio, 2020. It writes now the new Dyson norms
  ! See e.g. dysnorm subroutine.
  if (DYSEXPORT) call WRITEDYS(DYSAMPS,SFDYS,NZ,ENERGY)
  ! +++

  ! Loop over states to compute Excitonic Couplings

  if (DoExcitonics) call EXCCOUPL()

  !--------------------------------------------------------------------*
  ! Natural orbitals, if requested:
  if (NATO) then
    ! CALCULATE AND WRITE OUT NATURAL ORBITALS.
    call mma_allocate(DMAT,nBSQ,Label='DMAT')
    call mma_allocate(TDMZZ,nTDMZZ,Label='TDMZZ')
    call mma_allocate(VNAT,nBSQ,Label='VNAT')
    call mma_allocate(OCC,nBST,Label='OCC')

    call NATORB_RASSI(DMAT,TDMZZ,VNAT,OCC,EIGVEC)
    call NATSPIN_RASSI(DMAT,TDMZZ,VNAT,OCC,EIGVEC)

    call mma_deallocate(DMAT)
    call mma_deallocate(TDMZZ)
    call mma_deallocate(VNAT)
    call mma_deallocate(OCC)
  end if
  ! Bi-natural orbitals, if requested:
  if (BINA) call BINAT()

  if (IFHAM) then

    !                                                                  *
    !*******************************************************************
    !                                                                  *
    !  Spin_Orbit section

    !-------- Spin-Orbit calculations   --------------------------
    ! In this third section, if spin-orbit coupling parameters were
    ! computed by the previous sections, then additionally the
    ! spin-orbit eigenfunctions and levels are computed.

    ! Nr of spin states and division of loops:
    NSS = 0
    do ISTATE=1,NSTATE
      JOB = JBNUM(ISTATE)
      MPLET = MLTPLT(JOB)
      NSS = NSS+MPLET
    end do

    call mma_allocate(USOR,NSS,NSS,Label='USOR')
    call unitmat(USOR,NSS)
    call mma_allocate(USOI,NSS,NSS,Label='USOI')
    USOI(:,:) = Zero
    call mma_allocate(SOENE,nSS,Label='SOENE')
    SOENE(:) = Zero

    if (IFSO) then
      call StatusLine('RASSI: ','Computing SO Hamiltonian.')
      call SOEIG(PROP,USOR,USOI,SOENE,NSS,ENERGY)
    end if

#   ifdef _HDF5_
    ! Store TDMs in HDF5
    call StoreDens(EigVec)
#   endif

    ! +++ J. Norell - 2018
    ! Make the SO Dyson orbitals and amplitudes from the SF ones

    if (DYSO) then

      if (IFSO) then
        call mma_allocate(SODYSAMPS,NSS,NSS,Label='SODYSAMPS')
        call mma_allocate(SODYSAMPSR,NSS,NSS,Label='SODYSAMPSR')
        call mma_allocate(SODYSAMPSI,NSS,NSS,Label='SODYSAMPSI')

        call SODYSORB(NSS,USOR,USOI,DYSAMPS,NZ,SOENE)
      end if

      call mma_deallocate(SFDYS)
    end if

    ! +++

    call PRPROP(PROP,USOR,USOI,SOENE,NSS,OVLP,ENERGY,JBNUM,EigVec)

    ! Plot SO-Natural Orbitals if requested
    ! Will also handle mixing of states (sodiag)
    if (SONATNSTATE > 0) call DO_SONATORB(NSS,USOR,USOI)
    ! Plot SO-Natural Transition Orbitals if requested
    if (SONTOSTATES > 0) call DO_SONTO(NSS,USOR,USOI)

    call mma_deallocate(USOR)
    call mma_deallocate(USOI)
    call mma_deallocate(SOENE)
    if (DYSO .and. IFSO) then
      call mma_deallocate(SODYSAMPS)
      call mma_deallocate(SODYSAMPSR)
      call mma_deallocate(SODYSAMPSI)
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Trajectory Surface Hopping

    ! Turns on the procedure if the Keyword HOP was specified.

    if (HOP) then
      call StatusLine('RASSI: ','Trajectory Surface Hopping')
      call TSHinit(ENERGY(:))
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! CEH April 2015 DQV diabatization scheme
    ! This passes the PROP matrix into the DQV diabatization subroutine
    ! The subroutine will compute a transformation matrix, which is used
    ! to compute diabats.

    ! The user has to compute x, y, z, xx, yy, zz, 1/r in this order.

    if (DQVD) then
      call StatusLine('RASSI: ','DQV Diabatization')
      call DQVDiabat(PROP,HAM)
    end if
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
!     EPILOGUE                                                         *
!                                                                      *
!***********************************************************************
!                                                                      *

if (DoCoul) then
  if (.not. aux2) then
    call NameRun('AUXRFIL1')
    call Put_dArray('<rhoB|VnucA>',eNucB,nTri_Elem(mxroot))
    call Cho_X_Final(irc)
    call NameRun('#Pop') ! switch back to old RUNFILE
    call mma_deallocate(VNucB)
    call mma_deallocate(eNucB)
  else
    call NameRun('AUXRFIL1')
    call Cho_X_Final(irc)
    call NameRun('#Pop')
    call mma_deallocate(VNucB)
    call mma_deallocate(eNucB)
  end if
end if

call mma_deallocate(Ovlp)
call mma_deallocate(DYSAMPS)
call mma_deallocate(HAM)
call mma_deallocate(EigVec)
call mma_deallocate(Energy)
call mma_deallocate(ESHFT)
call mma_deallocate(HDIAG)
call mma_deallocate(jDisk_TDM)
call mma_deallocate(JBNUM)
call mma_deallocate(LROOT)
call mma_deallocate(TocM)
call mma_deallocate(Prop)

if (Do_SK) call mma_deallocate(k_Vector)

if (CLOSEONE) then
  IRC = -1
  call CLSONE(IRC,0)
  if (IRC /= 0) then
    write(u6,*) 'RASSI: Error opening file'
    call ABEND()
  end if
end if

#ifdef _DMRG_
!> finalize MPS-SI interface
if (doDMRG) then
  call qcmaquis_interface_deinit()
  call qcmaquis_info_deinit()
end if
#endif
!> free memory (if allocated at all - currently only for QD-NEVPT2 as ref wfn)
call deinit_mspt2_eigenvectors()
!                                                                      *
!***********************************************************************
!                                                                      *
! Close dafiles.

if (SaveDens) then
  call DaClos(LuTDM)
  call mma_deallocate(JOB_INDEX,safe='*')
  call mma_deallocate(CMO1,safe='*')
  call mma_deallocate(CMO2,safe='*')
  call mma_deallocate(DMAB,safe='*')
end if
call DaClos(LuExc)
call Symmetry_Info_Free()
!                                                                      *
!***********************************************************************
!                                                                      *
! PRINT I/O STATISTICS:
call FASTIO('STATUS')

call StatusLine('RASSI: ','Finished.')
IRETURN = 0

end subroutine RASSI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Compute_dMdx(ZA,RA,nAtoms,T,iAtom,iCar,dTdRai,dMdx)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 ZA(nAtoms), RA(3,nAtoms), T(3), dMdx(3,3)
#ifdef _DEBUGPRINT_
      Real*8 M(3,3)
#endif
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Z_Tot=DDot_(nAtoms,[One],0,ZA,1)
      delta=1.0D-4
      temp = RA(iCar,iAtom)
*
      RA(iCar,iAtom) = Temp + Delta
      Call Compute_M(ZA,nAtoms,RA,Z_Tot,T,M)
*
      RA(iCar,iAtom) = Temp - Delta
      Call Compute_M(ZA,nAtoms,RA,Z_Tot,T,dMdx)
*
      RA(iCar,iAtom) = Temp
*
      Do i = 1, 3
         Do j = 1, 3
            dMdx(i,j) = (M(i,j)-dMdx(i,j))/(2.0D0*Delta)
         End Do
      End Do
      Call RecPrt('dMdx(Numerical)',' ',dMdx,3,3)
#endif

      Call FZero(dMdx,3*3)
      Do jAtom = 1, nAtoms
         ZB=ZA(jAtom)
         If (iAtom.eq.jAtom) Then
            tmp=(One-dTdRAi)*ZB
         Else
            tmp=(   -dTdRAi)*ZB
         End If
*
         RTx=RA(1,jAtom)-T(1)
         RTy=RA(2,jAtom)-T(2)
         RTz=RA(3,jAtom)-T(3)
         If (iCar.eq.1) Then
            dMdx(2,2) = dMdx(2,2) + Two*tmp*RTx
            dMdx(3,3) = dMdx(3,3) + Two*tmp*RTx
            dMdx(1,2) = dMdx(1,2) -     tmp*RTy
            dMdx(2,1) = dMdx(2,1) -     RTy*tmp
            dMdx(1,3) = dMdx(1,3) -     tmp*RTz
            dMdx(3,1) = dMdx(3,1) -     RTz*tmp
         End If
         If (iCar.eq.2) Then
            dMdx(1,1) = dMdx(1,1) + Two*tmp*RTy
            dMdx(3,3) = dMdx(3,3) + Two*tmp*RTy
            dMdx(1,2) = dMdx(1,2) -     RTx*tmp
            dMdx(2,1) = dMdx(2,1) -     tmp*RTx
            dMdx(2,3) = dMdx(2,3) -     tmp*RTz
            dMdx(3,2) = dMdx(3,2) -     RTz*tmp
         End If
         If (iCar.eq.3) Then
            dMdx(1,1) = dMdx(1,1) + Two*tmp*RTz
            dMdx(2,2) = dMdx(2,2) + Two*tmp*RTz
            dMdx(1,3) = dMdx(1,3) -     RTx*tmp
            dMdx(3,1) = dMdx(3,1) -     tmp*RTx
            dMdx(2,3) = dMdx(2,3) -     RTy*tmp
            dMdx(3,2) = dMdx(3,2) -     tmp*RTy
         End If
      End Do
*
*     Remove noise
*
      Do i = 1, 3
         Do j = 1, 3
            If (Abs(dMdx(i,j)).lt.1.0D-14) dMdx(i,j)=Zero
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('dMdx',' ',dMdx,3,3)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Jeppe Olsen                                      *
!***********************************************************************
! Some GAS routines
!
! Nomenclature
!
! Group of strings : set of strings with a given number of orbitals
!                   in a given GASspace
!
! Supergroup of strings : product of NGAS groups, i.e. a string with a
!                         given numb er of electrons in each GAS space
!
! Type of string : Type is defined by the total number of electrons
!                  in the string. A type will therefore in general
!                  consists of several supergroups

!#define _DEBUGPRINT_
subroutine SPGP_AC(INSPGRP,NINSPGRP,IOUTSPGRP,NOUTSPGRP,NGAS,MXPNGAS,IAC,ISPGRP_AC,IBASEIN,IBASEOUT)
! Annihilation/Creation mapping of strings
!
! Jeppe Olsen, April 1, 1997

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: MXPNGAS, NINSPGRP, IOUTSPGRP(MXPNGAS,*), NOUTSPGRP, NGAS, IAC, IBASEIN, IBASEOUT
integer(kind=iwp), intent(inout) :: INSPGRP(MXPNGAS,*), ISPGRP_AC(NGAS,*)
integer(kind=iwp) :: IAMOKAY, IGAS, ISPGRP, ITO, JGAS, JSPGRP, NELIN, NELOUT

! Check first that supergroups + IAC information is consistent
NELIN = sum(INSPGRP(1:NGAS,IBASEIN))
NELOUT = sum(IOUTSPGRP(1:NGAS,IBASEOUT))
if (.not. (((IAC == 1) .and. (NELIN == NELOUT+1)) .or. ((IAC == 2) .and. (NELIN == NELOUT-1)))) then
  write(u6,*) ' Inconsistent data provided to SPGP_AC'
  write(u6,*) ' NELIN NELOUT IAC=',NELIN,NELOUT,IAC
  !stop ' Inconsistent data provided to SPGRP_AC'
  call SYSABENDMSG('lucia_util/spgp_ac','Internal error','')
end if

do ISPGRP=IBASEIN,IBASEIN+NINSPGRP-1
  do IGAS=1,NGAS
    if (IAC == 1) then
      INSPGRP(IGAS,ISPGRP) = INSPGRP(IGAS,ISPGRP)-1
    else if (IAC == 2) then
      INSPGRP(IGAS,ISPGRP) = INSPGRP(IGAS,ISPGRP)+1
    end if
    ! Find corresponding supergroup
    ITO = 0
    do JSPGRP=IBASEOUT,IBASEOUT+NOUTSPGRP-1
      IAMOKAY = 1
      do JGAS=1,NGAS
        if (INSPGRP(JGAS,ISPGRP) /= IOUTSPGRP(JGAS,JSPGRP)) IAMOKAY = 0
      end do
      if (IAMOKAY == 1) ITO = JSPGRP
    end do
    ISPGRP_AC(IGAS,ISPGRP) = ITO
    ! And clean up
    if (IAC == 1) then
      INSPGRP(IGAS,ISPGRP) = INSPGRP(IGAS,ISPGRP)+1
    else if (IAC == 2) then
      INSPGRP(IGAS,ISPGRP) = INSPGRP(IGAS,ISPGRP)-1
    end if
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Input supergroups'
call IWRTMA(INSPGRP(1,IBASEIN),NGAS,NINSPGRP,MXPNGAS,NINSPGRP)
write(u6,*) ' Output supergroups'
call IWRTMA(IOUTSPGRP(1,IBASEOUT),NGAS,NOUTSPGRP,MXPNGAS,NOUTSPGRP)

write(u6,*) ' Output from SPGP_AC'
write(u6,*) ' ==================='
write(u6,*)
write(u6,*) ' IAC = ',IAC
write(u6,*) ' Mapping :'
call IWRTMA(ISPGRP_AC(1,IBASEIN),NGAS,NINSPGRP,NGAS,NINSPGRP)
#endif

end subroutine SPGP_AC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************

subroutine NoBlanks(strout,strin)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use Definitions, only: iwp

implicit none
character(len=*), intent(out) :: strout
character(len=*), intent(in) :: strin
integer(kind=iwp) :: flag, i, j

flag = -1
j = 0
do i=1,len(strin)
  if ((flag == -1) .and. (strin(i:i) == ' ')) cycle
  flag = 0
  if (i <= len(strin)-1) then
    if (strin(i:i+1) == '  ') cycle
  end if
  j = j+1
  strout(j:j) = strin(i:i)
end do
strout(j+1:) = ' '

return

end subroutine NoBlanks

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_nVecRS
*
*> @brief
*>   Find first vector and number of vectors in reduced set \p iRed, sym. block \p iSym
*> @author Thomas Bondo Pedersen
*>
*> @details
*> This routine finds the first vector and number of
*> vectors in reduced set \p iRed, sym. block \p iSym.
*> Note that \p iVec=\p nVec = ``0`` may be returned---this is
*> perfectly acceptable: a given reduced set may be
*> empty. However, if negative numbers are returned
*> (\p iVec < ``0`` and \p nVec < ``0``), an error has ocurred. This
*> should be tested by the caller!!
*>
*> @note
*> The Cholesky procedure must have been successfully initialized (by ::Cho_X_Init).
*>
*> @param[in]  iRed Reduced set
*> @param[in]  iSym Symmetry block (1-8)
*> @param[out] iVec First vector in red. set \p iRed, sym. \p iSym
*> @param[out] nVec Number of vectors in red. set \p iRed, sym. \p iSym
************************************************************************
      SubRoutine Cho_X_nVecRS(iRed,iSym,iVec,nVec)
      Implicit None
      Integer iRed, iSym, iVec, nVec
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Character*12 SecNam
      Parameter (SecNam = 'Cho_X_nVecRS')

      Logical Found

      Integer irc, LastRed, jVec, jRed

      Integer InfVec, i, j, k
      Integer N2
      Parameter (N2 = InfVec_N2)

      InfVec(i,j,k)=iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)

C     Check input.
C     ------------

      irc = 0
      If (iSym.lt.1 .or. iSym.gt.nSym) Then
         irc = -1
      End If
      If (NumCho(iSym).lt.0 .or. NumCho(iSym).gt.MaxVec) Then
         irc = -2
      End If
      LastRed = InfVec(NumCho(iSym),2,iSym)
      If (LastRed .lt. 1) Then
         irc = -3
      End If
      If (iRed .lt. 1) Then
         irc = -4
      End If
      If (irc .ne. 0) Then
         iVec = irc
         nVec = irc
         Return
      End If
      If (iRed .gt. LastRed) Then
         iVec = 0
         nVec = 0
         Return
      End If

C     Find first vector in reduced set iRed.
C     --------------------------------------

      Found = .false.
      jVec  = 0
      Do While (jVec.lt.NumCho(iSym) .and. .not.Found)
         jVec = jVec + 1
         jRed = InfVec(jVec,2,iSym)
         If (jRed .eq. iRed) Then
            iVec  = jVec
            Found = .true.
         Else If (jRed .gt. iRed) Then
            jVec = NumCho(iSym)  ! break loop
         End If
      End Do

C     No first vector <=> 0 vectors in reduced set iRed.
C     --------------------------------------------------

      If (.not. Found) Then
         iVec = 0
         nVec = 0
         Return
      End If

C     Count number of vectors in reduced set iRed.
C     --------------------------------------------

      nVec = 1
      jVec = iVec
      Do While (jVec .lt. NumCho(iSym))
         jVec = jVec + 1
         jRed = InfVec(jVec,2,iSym)
         If (jRed .eq. iRed) Then
            nVec = nVec + 1
         Else
            jVec = NumCho(iSym) ! break loop
         End If
      End Do

#if defined (_DEBUGPRINT_)
C     Debug: print result.
C     --------------------

      Write(6,*) SecNam,': there are ',nVec,' vectors in reduced set ',
     &           iRed,' (sym. block ',iSym,')'
      Write(6,*) SecNam,': first vector is: ',iVec
#endif

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
* This routine perform some initialization after reading the first     *
* one electron file.                                                   *
* These parameters are checked when reading subsequent one electron    *
* files.                                                               *
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine Init_GenANO
      Implicit Real*8 (a-h,o-z)
#include "parm.fh"
#include "common.fh"
#include "symlab.fh"
      Character*(LENIN4) LblCnt(MxAtom)
      Logical Found

      Call Get_nAtoms_all(nAtoms)
      Call Get_cArray('LP_L',LblCnt,(LENIN4)*nAtoms)
      Found=.FALSE.
      Do i=1,nAtoms
        If (LblCnt(i)(1:LENIN).eq.Center) Found=.TRUE.
      End Do
      If (.not.Found) Then
        Call WarningMessage(2,'Center '//Center//' not found')
        Call Quit_OnUserError()
      End IF
      ind=0
      Do 100 iSym=1,nSym
*        Write(*,'(a,i1,a)') ' <<< Symmetry ',iSym,' >>>'
         Do 110 iBas=1,nBas(iSym)
            ind=ind+1
*           Write(*,*) Name(ind)
            Do 111 l=0,MxLqn
               If(Name(ind)(1:LENIN).eq.Center) Then
                  If(Name(ind)(LENIN1:LENIN8).eq.type(l*(l+1)+1)) Then
                     nPrim(l)=nPrim(l)+1
                  End If
               End If
111         Continue
110      Continue
100   Continue
      Write(6,*)
      Write(6,'(a,8i5)') 'Number of primitives per shell:',nPrim
      nDsym=0
      Do 200 l=0,MxLqn
*        Write(*,'(1x,a,i5)') type(l*(l+1)+1),nPrim(l)
         nDsym=nDsym+(2*l+1)*nPrim(l)*(nPrim(l)+1)/2
200   Continue
      Do 300 i=1,nDsym
         pDsym(i)=0.0d0
         tDsym(i)=0.0d0
300   Continue
*----------------------------------------------------------------------*
      ind=0
      len=0
      next=1
      Do 400 iShell=0,MxLqn
         len=nPrim(iShell)*(nPrim(iShell)+1)/2
         Do 410 iComp=-iShell,iShell
            ind=ind+1
            iSymBk(ind)=next
            next=next+len
410      Continue
400   Continue
*     Write(*,*) 'In Init: density block pointers'
*     Write(*,'(1x,10i5)') (iSymBk(i),i=1,(MxLqn+1)*(MxLqn+1))
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
*               1994, Markus P. Fuelscher                              *
************************************************************************
      SubRoutine RFmltp()
      use PCM_arrays, only: MM
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "rctfld.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: VTot(:), QTot(:)
*
      If (.Not.lRF) Return
      nComp = (lMax+1)*(lMax+2)*(lMax+3)/6
      Call mma_allocate(VTot,nComp,Label='VTot')
      Call mma_allocate(QTot,nComp,Label='QTot')
*
      Call RFmltp_(MM,VTot,QTot,nComp)
*
      Call mma_deallocate(VTot)
      Call mma_deallocate(QTot)
*
      Return
      End
      Subroutine RFmltp_(Qs,QTot,VTot,nComp)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*                                                                      *
*     modified by M. P. Fuelscher, 94/04/28                            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 Qs(nComp,2), QTot(nComp), VTot(nComp)
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
*
      iRout = 4
      iPrint = nPrint(iRout)
      If ( lRF .and. .Not.PCM .and. lRFCav) then
         call dcopy_(nComp,Qs(1,1),1,QTot,1)
         Call DaXpY_(nComp,One,Qs(1,2),1,QTot,1)
         If (iPrint.ge.99) Call RecPrt('Total Multipole Moments',' ',
     &                                 QTot,1,nComp)
         call dcopy_(nComp,QTot,1,VTot,1)
*--------Compute the electric field due to the total charge
*        distribution.
         Call AppFld(VTot,rds,Eps,lMax,EpsInf,NonEq_ref)
         If (iPrint.ge.99) Call RecPrt('Total Electric Field',
     &                                 ' ',VTot,1,nComp)
*                                                                      *
************************************************************************
*                                                                      *
         Write (6,*)
     &   '     Multipole analysis of the contributions to the '//
     &          'dielectric solvation energy'
         Write (6,*)
         Write (6,*) '     --------------------------------------'
         Write (6,*) '        l             dE '
         Write (6,*) '     --------------------------------------'
         Esolv=Zero
         iOff = 1
         Do l = 0, lMax
            nElem = (l+1)*(l+2)/2
            dEsolv= -Half*DDot_(nElem,QTot(iOff),1,VTot(iOff),1)
            Write (6,'(8X,I2,10X,F13.10)') l,dEsolv
            iOff = iOff + nElem
            Esolv = Esolv + dEsolv
         End Do
         Write (6,*) '     --------------------------------------'
         Write (6,*)
         Write (6,*)
         Write (6,*) '     Total Multipole Moments (cartesian)'
         Write (6,*) '     -----------------------------------'
         iM = 1
         Do l = 0, lMax
            nElem = (l+1)*(l+2)/2
            jM = iM
            Do iElem = 1, nElem, 7
               nM=Min(7,nElem-iElem+1)
               Write (6,'(8X,7E14.5)') (QTot(i),i=jM,jM+nM-1)
               jM = jM + nM
            End Do
            iM = iM + nElem
         End Do
         Write (6,*) '     -----------------------------------'
         Write (6,*)
         Write (6,*)
         Write (6,*) '     Total Electric Field (cartesian)'
         Write (6,*) '     --------------------------------'
         iM = 1
         Do l = 0, lMax
            nElem = (l+1)*(l+2)/2
            jM = iM
            Do iElem = 1, nElem, 7
               nM=Min(7,nElem-iElem+1)
               Write (6,'(8X,7E14.5)') (VTot(i),i=jM,jM+nM-1)
               jM = jM + nM
            End Do
            iM = iM + nElem
         End Do
         Write (6,*) '     -----------------------------------'
         Write (6,*)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SimRI_Z1CDia(Diag,Thr,Indx)
C
C     Purpose: Zero 1-center diagonals smaller then Thr.
C              Diag is the diagonal (1st reduced set).
C              On exit, Indx(i)=1 if diagonal i was zeroed, else
C              Indx(i)=0 (thus, Indx must have same dimension as Diag).
C
      Implicit None
      Real*8  Diag(*)
      Real*8  Thr
      Integer Indx(*)
#include "cholesky.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer iShlAB, iShlA, iShlB
      Integer iAB1, iAB2, iAB
      Integer n
      Real*8  zmx

      Real*8 Zero
      Parameter (Zero = 0.0d0)

      Integer Inf_SimRI
      Parameter (Inf_SimRI = 0)

      Integer iSP2F, iAtomShl, iiBstRSh, nnBstRSh
      Integer i, j, k
      iSP2F(i)=iWork(ip_iSP2F-1+i)
      iAtomShl(i)=iWork(ip_iAtomShl-1+i)
      iiBstRSh(i,j,k)=iWork(ip_iiBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      nnBstRSh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)

      Call Cho_iZero(Indx,nnBstR(1,1))

      zmx = 0.0d0
      n = 0
      Do iShlAB = 1,nnShl
         Call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.True.)
         If (iAtomShl(iShlA) .eq. iAtomShl(iShlB)) Then
            iAB1 = iiBstR(1,1)
     &           + iiBstRSh(1,iShlAB,1) + 1
            iAB2 = iAB1 + nnBstRSh(1,iShlAB,1) - 1
            Do iAB = iAB1,iAB2
               If (Diag(iAB) .lt. Thr) Then
                  zmx = max(zmx,Diag(iAB))
                  n = n + 1
                  Indx(iAB) = 1
                  Diag(iAB) = 0.0d0
               End If
            End Do
         End If
      End Do

      If (iPrint .gt. Inf_SimRI) Then
         Write(LuPri,'(/,A,I7,A,1P,D10.2,A)')
     &   'Simulating RI:',n,' 1-center diagonals < ',Thr,
     &   ' have been zeroed'
         If (n .gt. 0) Then
            Write(LuPri,'(A,1P,D15.7)')
     &      'Largest zeroed diagonal: ',zmx
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine ClsFls_RASSCF()
!***********************************************************************
!                                                                      *
!     Close files.                                                     *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

#ifdef _HDF5_
use mh5, only: mh5_close_file
use RASWfn, only: wfn_fileid
#endif
use general_data, only: ITERFILE, JOBIPH, JOBOLD, LUDAVID, LUINTM, LUQUNE
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iRC
logical(kind=iwp) :: DoCholesky

!----------------------------------------------------------------------*
!     Start                                                            *
!-------------------------------------- -------------------------------*
! Local print level (if any)
!---  close the JOBOLD file -------------------------------------------*
if ((JOBOLD > 0) .and. (JOBOLD /= JOBIPH)) then
  call DaClos(JOBOLD)
  JOBOLD = -1
else if (JOBOLD > 0) then
  JOBOLD = -1
end if
!---  close the JOBIPH file -------------------------------------------*
if (JOBIPH > 0) then
  call DaClos(JOBIPH)
  JOBIPH = -1
end if
#ifdef _HDF5_
if (wfn_fileid /= 0) then
  call mh5_close_file(wfn_fileid)
  wfn_fileid = 0
end if
#endif
!---  close the ORDINT file -------------------------------------------*
call DecideOnCholesky(DoCholesky)
if (.not. DoCholesky) then
  iRc = -1
  call ClsOrd(iRc)
  if (iRc /= 0) call WarningMessage(1,'Failed to close the ORDINT file.')
end if
!---  close the file carrying the transformed two-electron integrals --*
call DaClos(LUINTM)
!---  close the DAVID file carrying temporary CI and sigma vectros ----*
call DaClos(LUDAVID)
!---  open the file carrying the hessian update vectors ---------------*
call DaClos(LuQune)
!---  close the file for storage of informations on CI-iterations
close(ITERFILE)
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine ClsFls_RASSCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PolScf(Dist,DistIm,DT,FI,FP,Fil,iCStart,iTri,VMat,Smat,DiFac,Ract,icnum,Energy,NVarv,MOC,Haveri,iQ_Atoms,ExpVal,Poli)

use qmstat_global, only: ChaNuc, CT, DenCorrD, FockM, HHmat, iOcc1, iOrb, lExtr, Mp2DensCorr, nCent, nPart, nPol, PotNuc, qTot, &
                         SupM, Trace_MP2, xyzMyI, xyzMyP, xyzMyQ, xyzQuQ
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms, iCStart, iTri, icnum
real(kind=wp), intent(in) :: Dist(nCent,nCent,nTri_Elem(nPart-icnum-1)), DistIm(nCent,nPart-icnum,nCent,nPart-icnum), &
                             FP(3,nPol*nPart), Fil(nPol*nPart,3,nTri_Elem(iQ_Atoms),10), VMat(iTri), Smat(iTri), DiFac, Ract
real(kind=wp), intent(inout) :: DT(3,nPol*nPart), Energy
real(kind=wp), intent(out) :: FI(3,nPol*nPart), MOC(iOrb(1),iOrb(1)), ExpVal(4,1), Poli(nTri_Elem(iQ_Atoms),10)
integer(kind=iwp), intent(out) :: NVarv
logical(kind=iwp), intent(out) :: Haveri
integer(kind=iwp) :: i, iDum, iErr, iOrba, j, nFound, nPolCent, nQMCent
real(kind=wp) :: Dummy, Egun, OneEl, PolFac, R2inv, Rinv
logical(kind=iwp) :: JaNej
real(kind=wp), allocatable :: EEigen(:), FFp(:,:), Gri(:,:), RoMat(:), rr3(:,:), Scratch(:,:), VpolMat(:), xx(:,:), xxi(:,:), &
                              yy(:,:), yyi(:,:), zz(:,:), zzi(:,:)
#include "warnings.h"

! Allocate and initialize the eigenvector matrix with the unit matrix.

iOrba = iOrb(1)
MOC(:,:) = Zero
call dcopy_(iOrba,[One],0,MOC,iOrba+1)

! Define some numbers.

nQMCent = nTri_Elem(iQ_Atoms)
nPolCent = nPart*nPol
Rinv = One/Ract
R2inv = Rinv**2
PolFac = DiFac/Ract**3
Egun = Zero

! Compute some distances needed for the polarization. See polras for some additional information on this.

call mma_allocate(xx,nPolCent,nPolCent,label='xx')
call mma_allocate(yy,nPolCent,nPolCent,label='yy')
call mma_allocate(zz,nPolCent,nPolCent,label='zz')
call mma_allocate(xxi,nPolCent,nPolCent,label='ixx')
call mma_allocate(yyi,nPolCent,nPolCent,label='iyy')
call mma_allocate(zzi,nPolCent,nPolCent,label='izz')
call mma_allocate(rr3,nPolCent,nPolCent,label='irr3')
call mma_allocate(Gri,nPolCent,nPolCent,label='iGri')
xx(:,:) = Zero
yy(:,:) = Zero
zz(:,:) = Zero
xxi(:,:) = Zero
yyi(:,:) = Zero
zzi(:,:) = Zero
rr3(:,:) = Zero
Gri(:,:) = Zero
call PolPrep(Dist,DistIm,xx,yy,zz,rr3,xxi,yyi,zzi,Gri,iCNum,nPolCent)

! Polarization loop commencing.

call mma_allocate(FFp,nPolCent,3,label='FFp')
call mma_allocate(RoMat,max(nTri_Elem(iOrba),iTri),label='RoMat')
call mma_allocate(VpolMat,max(nTri_Elem(iOrba),iTri),label='VpolMat')
call mma_allocate(EEigen,iOrba,label='EEigen')
NVarv = 0
do
  NVarv = NVarv+1
  Energy = Zero
  call PolSolv(DT,FI,FP,xx,yy,zz,rr3,xxi,yyi,zzi,Gri,FFp,iCNum,r2Inv,DiFac,nPolCent)
  call Densi_MO(Romat,MOC,1,iOcc1,iOrba,iOrba)
  if (Mp2DensCorr) call DCorrCorr(Romat,DenCorrD,Trace_MP2,iOrba,iOcc1)
  call Polink(Energy,nPolCent,nQMCent,Fil,VpolMat,FFp,PolFac,Poli,iCstart,iTri,iQ_Atoms,qTot,ChaNuc,xyzMyQ,xyzMyI,xyzMyP,Romat, &
              xyzQuQ,CT)

  ! Construct the Fock-matrix from two-electron super-matrix and one-electron matrix, with solvent perturbations added.

  FockM(:) = Zero
  do i=1,iTri
    do j=1,iTri
      FockM(i) = FockM(i)+RoMat(j)*SupM(j,i)
    end do
    OneEl = HHmat(i)+Vmat(i)+VpolMat(i)+Smat(i)
    FockM(i) = FockM(i)+OneEl
    ! See Szabo-Ostlund eq. 3.184.
    Energy = Energy+(FockM(i)+OneEl)*RoMat(i)
  end do
  ! Add potential-nuclear energy.
  Energy = Potnuc+Energy*Half

  ! If energy is strange, scream!

  if (Energy > 0) then
    write(u6,*)
    write(u6,*) '  SCF energy is positive. Serious error somewhere.'
    call Quit(_RC_GENERAL_ERROR_)
  end if

  ! Diagonalize the Fock-matrix. Eigenvalues are sorted.

  call mma_allocate(Scratch,iOrba,iOrba,label='Scratch')
  call Diag_Driver('V','A','L',iOrba,FockM,Scratch,iOrba,Dummy,Dummy,iDum,iDum,EEigen,MOC,iOrba,1,-1,'J',nFound,iErr)
  call mma_deallocate(Scratch)

  ! Check if polarization loop has converged.

  call HaveWeConv(iCNum,iCStart,iQ_Atoms,nPolCent,DT,FFp,xyzMyI,Egun,Energy,NVarv,JaNej,Haveri)
  if (Haveri .or. JaNej) exit
end do

! Deallocate.

call mma_deallocate(FFp)
call mma_deallocate(RoMat)
call mma_deallocate(EEigen)
call mma_deallocate(xx)
call mma_deallocate(yy)
call mma_deallocate(zz)
call mma_deallocate(xxi)
call mma_deallocate(yyi)
call mma_deallocate(zzi)
call mma_deallocate(rr3)
call mma_deallocate(Gri)

! If expectation values are extracted, make a detour.

if (lExtr(6)) call Expectus('SCF  ',HHmat,Vmat,VpolMat,Smat,MOC,iOrba,.false.,iOcc1,ExpVal)
call mma_deallocate(VpolMat)

! The end is near, hold me!

return

end subroutine PolScf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETMAXSHL(DIAG,DIASH,ISYSH,IRED)
C
C     Purpose: set max. shell pair data for selection procedure.
C
#include "implicit.fh"
      DIMENSION DIAG(*), DIASH(*)
      INTEGER   ISYSH(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*13 SECNAM
      PARAMETER (SECNAM = 'CHO_SETMAXSHL')

      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)
      IIBSTRSH(I,J,K)=IWORK(ip_IIBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      ISP2F(I)=IWORK(ip_iSP2F-1+I)
      IATOMSHL(I)=IWORK(ip_IATOMSHL-1+I)

C     Initialize the largest diagonal in each shell pair.
C     ---------------------------------------------------

      CALL CHO_DZERO(DIASH,NNSHL)
      CALL CHO_IZERO(ISYSH,NNSHL)

C     Find largest diagonal in each shell pair. Loop only
C     over those that are included in the reduced set at hand.
C     --------------------------------------------------------

      IF (IRED .EQ. 1) THEN
         DO ISYMAB = 1,NSYM
            DO ISHLAB = 1,NNSHL
               IAB1 = IIBSTR(ISYMAB,IRED)
     &              + IIBSTRSH(ISYMAB,ISHLAB,IRED) + 1
               IAB2 = IAB1 + NNBSTRSH(ISYMAB,ISHLAB,IRED) - 1
               DO IAB = IAB1,IAB2
                  IF (DIASH(ISHLAB) .LT. DIAG(IAB)) THEN
                     DIASH(ISHLAB) = DIAG(IAB)
                     ISYSH(ISHLAB) = ISYMAB
                  END IF
               END DO
            END DO
         END DO
      ELSE IF ((IRED.EQ.2) .OR. (IRED.EQ.3)) THEN
         DO ISYMAB = 1,NSYM
            DO ISHLAB = 1,NNSHL
               JAB1 = IIBSTR(ISYMAB,IRED)
     &              + IIBSTRSH(ISYMAB,ISHLAB,IRED) + 1
               JAB2 = JAB1 + NNBSTRSH(ISYMAB,ISHLAB,IRED) - 1
               DO JAB = JAB1,JAB2
                  IAB = INDRED(JAB,IRED)
                  IF (DIASH(ISHLAB) .LT. DIAG(IAB)) THEN
                     DIASH(ISHLAB) = DIAG(IAB)
                     ISYSH(ISHLAB) = ISYMAB
                  END IF
               END DO
            END DO
         END DO
      ELSE
         WRITE(LUPRI,*) SECNAM,': unknown reduced set, IRED = ',IRED
         CALL CHO_QUIT('Unknown reduced set in '//SECNAM,104)
      END IF

C     Exclude 2-center diagonals (if requested).
C     The effect of this is that 2-center diagonals can never be
C     qualified; they may still be included in the vectors, though.
C     If CHO_NO2CENTER=T, the 2-center diagonals are removed from the
C     initial diagonal and we need not worry here.
C     ---------------------------------------------------------------

      IF (CHO_1CENTER .AND. .NOT.CHO_NO2CENTER) THEN
         DO ISAB = 1,NNSHL
            ISHLAB = ISP2F(ISAB)
            CALL CHO_INVPCK(ISHLAB,ISHLA,ISHLB,.TRUE.)
            IF (IATOMSHL(ISHLA) .NE. IATOMSHL(ISHLB)) THEN
               DIASH(ISAB) = 0.0D0
            END IF
         END DO
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine BSSint()

use Basis_Info, only: dbsc, nBas, nCnttp
use Symmetry_Info, only: Mul, nIrrep
use DKH_Info, only: cLightAU
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, OneHalf
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
#include "rinfo.fh"
#include "print.fh"
integer(kind=iwp) :: i, iAngr, iBas, icnt, iCnttp, iComp, idbg, iExp, iip1, iOpt, ip1, iPrint, iRC, iRout, iSize, iSizea, iSizeab, &
                     iSizeb, iSizec, iSyma, iSymb, ixyz, jExp, kAng, kC, kCof, kCofi, kCofj, kExp, kExpi, kExpj, L, lOper, Lu_One, &
                     n, na, nb, nBasMax, ncomp, nSym
real(kind=wp) :: rCofi, rCofj, rExpi, rExpj, rI, rNorm, Sum_, VELIT
type(DSBA_Type) :: Aaf, Eigf, Kin, pV, pVf, pVp, Revtf, Rrf, Sinvf, SS, V, Vp, Vpf
integer(kind=iwp), allocatable :: iLen(:), lOper1(:)
real(kind=wp), allocatable :: Aa(:), Aux(:), Bu(:), Bu2(:), Bu4(:), Cmm1(:), Cmm2(:), E(:), Eig(:), Ev(:), Ew(:), G(:), H(:), &
                              H_nr(:), H_temp(:), ifpV(:), ifVp(:), ipVa(:), iVpa(:), Ove(:), P(:), Revt(:), Rr(:), ScpV(:), &
                              ScVp(:), Sinv(:), Tt(:)
character(len=8) :: Label
#ifdef _DEBUGPRINT_
#define _TEST_ .true.
#else
#define _TEST_ .false.
#endif
integer(kind=iwp), parameter :: Arr2(8) = 2
logical(kind=iwp), parameter :: IfTest = _TEST_
integer(kind=iwp), external :: IrrFnc, n2Tri

iRout = 77
iPrint = nPrint(iRout)

! Save basis set info from contracted run

if (iprint >= 10) write(u6,*) ' In dkint',ncnttp
kCof = 0
kAng = 0
kExp = 0
kC = 0

! Normalize coefficients

do iCnttp=1,nCnttp
  do icnt=1,dbsc(iCnttp)%nCntr
    kC = kC+1
    !do iAngr=0,nAngr(icnt)
    do iAngr=0,nAngr(kC)
      !rI = iAngr+OneHalf
      rI = real(iAngr,kind=wp)+OneHalf
      kAng = kAng+1
      do iBas=1,nBasisr(kAng)
        Sum_ = Zero
        kExpi = kExp
        kCofi = kCof
        do iExp=1,nPrimr(kAng)
          kExpi = kExpi+1
          kCofi = kCofi+1
          rExpi = rExp(kExpi)
          !write(u6,'(a11,f20.8)') ' Exponents',rExpi
          rCofi = rCof(kCofi)
          kExpj = kExp
          kCofj = kCof
          do jExp=1,nPrimr(kAng)
            kExpj = kExpj+1
            kCofj = kCofj+1
            rExpj = rExp(kExpj)
            rCofj = rCof(kCofj)
            Sum_ = Sum_+rCofi*rCofj*(Two*sqrt(rExpi*rExpj)/(rExpi+rExpj))**rI
          end do
        end do
        rNorm = One/sqrt(Sum_)
        if (iprint >= 10) write(u6,*) ' rNorm',kAng,rNorm
        do iExp=1,nPrimr(kAng)
          rCof(kCof+iExp) = rCof(kCof+iExp)*rNorm
          if (iprint >= 10) then
            write(u6,'(a24,f20.6)') ' normalized coefficients',rCof(kCof+iExp)
          end if
        end do
        kCof = kCof+nPrimr(kAng)
      end do
      kExp = kExp+nPrimr(kAng)
    end do
  end do
end do

i = 0
if (iPrint >= 10) then
  do L=1,nrSym
    write(u6,*) ' Irreducible representation',L
    do ibas=1,nrBas(L)
      i = i+1
      write(u6,'(20i4)') i,icent(i),lnang(i),lmag(i)
    end do
  end do
end if

! Close ONEINT and re-open ONEREL

nSym = nIrrep
iOpt = 0
call ClsOne(iRC,iOpt)
iOpt = 0
iRC = -1
Lu_One = 2
call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
if (iRC /= 0) then
  write(u6,*) ' *** Error in subroutine BSSint ***'
  write(u6,*) '     Abend in subroutine OpnOne'
  call Abend()
end if

call OneBas('PRIM')
call Get_iArray('nBas_Prim',nBas,nSym)

if (iPrint >= 10) then
  write(u6,'(a11,10i5)') ' Symmetries',nSym
  write(u6,'(a11,10i5)') ' Primitive basis fcns',(nBas(i),i=0,nSym-1)
end if

! Allocate memory for relativistic part

call Allocate_DT(Eigf,nBas,nBas,nSym,label='Eigf')
call Allocate_DT(Sinvf,nBas,nBas,nSym,label='Sinvf')
call Allocate_DT(Revtf,nBas,nBas,nSym,label='Revtf')
call Allocate_DT(Aaf,nBas,nBas,nSym,aCase='ONE',label='Aaf')
call Allocate_DT(Rrf,nBas,nBas,nSym,aCase='ONE',label='Rrf')
nBasMax = 0
do L=1,nSym
  n = nBas(L-1)
  nBasMax = max(nBasMax,n)
end do

VELIT = cLightAU

call Allocate_DT(Kin,nBas,nBas,nSym,aCase='TRI',label='Kin')
call Allocate_DT(SS,nBas,nBas,nSym,aCase='TRI',label='SS')
call Allocate_DT(V,nBas,nBas,nSym,aCase='TRI',label='V')
call Allocate_DT(pVp,nBas,nBas,nSym,aCase='TRI',label='pVp')

Label = 'Mltpl  0'
iComp = 1
iOpt = 0
iOpt = 6 ! Do not read origin or nuclear contribution
iRC = -1
call RdOne(iRC,iOpt,Label,1,SS%A0,lOper)
if (iRC /= 0) then
  write(u6,*) 'BSSInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
!write(u6,'(8f9.4)') SS%A0
if (iPrint >= 20) call PrMtrx(Label,[lOper],1,[1],SS%A0)
Label = 'Attract '
iRC = -1
call RdOne(iRC,iOpt,Label,1,V%A0,lOper)
if (iRC /= 0) then
  write(u6,*) 'BSSInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
Label = 'Kinetic '
iRC = -1
call RdOne(iRC,iOpt,Label,1,Kin%A0,lOper)
if (iRC /= 0) then
  write(u6,*) 'BSSInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
Label = 'pVp     '
iRC = -1
call RdOne(iRC,iOpt,Label,1,pVp%A0,lOper)
if (iRC /= 0) then
  write(u6,*) 'BSSInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if

nComp = 3
call mma_allocate(lOper1,nComp,label='lOper1')
do iComp=1,nComp
  ixyz = 2**(iComp-1)
  lOper1(iComp) = 2**IrrFnc(ixyz)
end do

! Read pV matrix , elements <iSyma|pV|iSymb>, iSymb <= iSyma !

call mma_allocate(iLen,nComp,label='iLen')
do iComp=1,nComp
  iLen(iComp) = n2Tri(lOper1(iComp))
end do

call Allocate_DT(pV,iLen,iLen,nComp,aCase='ONE',label='pV')

Label = 'pV      '
do iComp=1,nComp

  iRC = -1
  call RdOne(iRC,iOpt,Label,iComp,pV%SB(iComp)%A1,lOper1(iComp))
end do

! Read Vp matrix , elements <iSyma|Vp|iSymb>, iSymb <= iSyma !

! Read Vp matrix

call Allocate_DT(Vp,iLen,iLen,nComp,aCase='ONE',label='Vp')

Label = 'Vp      '
do iComp=1,nComp

  iRC = -1
  call RdOne(iRC,iOpt,Label,iComp,Vp%SB(iComp)%A1,lOper1(iComp))
end do

! Build the whole matrix <iSyma|pV|iSymb> lower triangle
! and put into pVf%SB(iComp)%A2(:,1) and the upper triangle
! and put into pVf%SB(iComp)%A2(:,2).
! For 'Vp' matrix the same, Vpf instead of pVf

call Allocate_DT(pVf,iLen,Arr2,nComp,label='pVf')
call Allocate_DT(Vpf,iLen,Arr2,nComp,label='Vpf')

do iComp=1,nComp

  ip1 = 0
  iip1 = 0

  do iSyma=1,nSym
    na = nBas(iSyma-1)
    if (na == 0) cycle

    do iSymb=1,iSyma
      nb = nBas(iSymb-1)
      if (nb == 0) cycle
      if (.not. btest(lOper1(iComp),Mul(iSyma,iSymb)-1)) cycle
      if (iSyma == iSymb) then
        iSize = na*(na+1)/2

        ! Elements <iSyma|pV|iSyma> and <iSyma|Vp|iSyma>

        pVf%SB(iComp)%A2(ip1+1:ip1+iSize,1) = pV%SB(iComp)%A1(ip1+1:ip1+iSize)
        Vpf%SB(iComp)%A2(ip1+1:ip1+iSize,1) = Vp%SB(iComp)%A1(ip1+1:ip1+iSize)
        ip1 = ip1+na*(na+1)/2
      else
        iSize = na*nb

        ! Elements <iSyma|pV|iSymb> and <iSymb|pV|iSyma> = -<iSyma|Vp|iSymb>
        ! AND
        ! Elements <iSyma|Vp|iSymb> and <iSymb|Vp|iSyma> = -<iSyma|pV|iSymb>

        pVf%SB(iComp)%A2(ip1+1:ip1+iSize,1) = pV%SB(iComp)%A1(ip1+1:ip1+iSize)
        Vpf%SB(iComp)%A2(ip1+1:ip1+iSize,1) = Vp%SB(iComp)%A1(ip1+1:ip1+iSize)
        pVf%SB(iComp)%A2(iip1+1:iip1+iSize,2) = -Vp%SB(iComp)%A1(ip1+1:ip1+iSize)
        Vpf%SB(iComp)%A2(iip1+1:iip1+iSize,2) = -pV%SB(iComp)%A1(ip1+1:ip1+iSize)
        ip1 = ip1+na*nb
        iip1 = iip1+na*nb
      end if

    end do
  end do

  !write(u6,*) 'Created  whole matrix (NAxNB) PV '
  !
  !write(u6,*) 'pV matrix <iSyma|pV|iSymb> '
  !write(u6,*)
  !write(u6,*) pVf%SB(iComp)%A2(:,1)
  !write(u6,*)
  !write(u6,*)
  !write(u6,*) 'pV matrix <iSymb|pV|iSyma> if iSyma /= iSymb otherwise zero matrix '
  !write(u6,*)
  !write(u6,*) pVf%SB(iComp)%A2(:,2)
  !
  ! Create the whole matrix (NAxNB) VP
  !
  !write(u6,*) 'Create the whole matrix (NAxNB) VP '
  !
  !write(u6,*)
  !write(u6,*) 'Vp matrix <iSyma|Vp|iSymb> '
  !write(u6,*)
  !write(u6,*) Vpf%SB(iComp)%A2(:,1)
  !write(u6,*)
  !write(u6,*)
  !write(u6,*) 'Vp matrix <iSymb|Vp|iSyma> if iSyma /= iSymb otherwise zero matrix '
  !write(u6,*)
  !write(u6,*) Vpf%SB(iComp)%A2(:,2)

  ! End of iComp loop

end do

call mma_deallocate(iLen)

call mma_allocate(Bu,nBasMax*(nBasMax+1)/2,label='Bu')
call mma_allocate(P,nBasMax*(nBasMax+1)/2,label='P')
call mma_allocate(Ev,nBasMax*(nBasMax+1)/2,label='Ev')
call mma_allocate(G,nBasMax**2,label='G')
call mma_allocate(Eig,nBasMax**2,label='Eig')
call mma_allocate(Sinv,nBasMax**2,label='Sinv')
call mma_allocate(Revt,nBasMax**2,label='Revt')
call mma_allocate(Aux,nBasMax**2,label='Aux')
call mma_allocate(Ove,nBasMax**2,label='Ove')
call mma_allocate(Ew,nBasMax,label='Ew')
call mma_allocate(E,nBasMax,label='E')
call mma_allocate(Aa,nBasMax,label='Aa')
call mma_allocate(Rr,nBasMax,label='Rr')
call mma_allocate(Tt,nBasMax,label='Tt')

! Main loop  1
do L=1,nSym

  n = nBas(L-1)
  iSize = n*(n+1)/2
  !AJS protection against zero dimension representation
  if (iSize == 0) cycle

  ! Debug output on unit idbg
  if (IfTest) then
    idbg = 41
  else
    idbg = -1
  end if

  ! call to package relsewb
  call SCFCLI2(idbg,SS%SB(L)%A1,Kin%SB(L)%A1,V%SB(L)%A1,pVp%SB(L)%A1,n,iSize,VELIT,Bu,P,G,Ev,Eig,Sinv,Revt,Aux,Ove,Ew,E,Aa,Rr,Tt)

  Eigf%SB(L)%A1(:) = Eig(1:n*n)
  Sinvf%SB(L)%A1(:) = Sinv(1:n*n)
  Revtf%SB(L)%A1(:) = Revt(1:n*n)
  Aaf%SB(L)%A1(:) = Aa(1:n)
  Rrf%SB(L)%A1(:) = Rr(1:n)

end do

call mma_deallocate(Bu)
call mma_deallocate(Sinv)
call mma_deallocate(Revt)
call mma_deallocate(Ove)
call mma_deallocate(E)
call mma_deallocate(Aa)
call mma_deallocate(Rr)
call mma_deallocate(Tt)

call mma_allocate(ipVa,nBasMax*(nBasMax+1)/2,label='ipVa')
call mma_allocate(iVpa,nBasMax*(nBasMax+1)/2,label='iVpa')
call mma_allocate(ifpV,nBasMax**2,label='ifpV')
call mma_allocate(ifVp,nBasMax**2,label='ifVp')
call mma_allocate(ScpV,nBasMax**2,label='ScpV')
call mma_allocate(ScVp,nBasMax**2,label='ScVp')
call mma_allocate(Bu2,nBasMax**2,label='Bu2')
call mma_allocate(Bu4,nBasMax**2,label='Bu4')
call mma_allocate(Cmm1,nBasMax**2,label='Cmm1')
call mma_allocate(Cmm2,nBasMax**2,label='Cmm2')

! Main loop  2
do iComp=1,nComp

  ip1 = 0
  iip1 = 0

  do iSyma=1,nSym

    na = nBas(iSyma-1)
    iSizea = na*(na+1)/2
    !AJS protection against zero dimension representation
    if (iSizea <= 0) cycle
    !AJS

    do iSymb=1,nSym

      nb = nBas(iSymb-1)
      iSizeb = nb*(nb+1)/2
      if (iSizeb <= 0) cycle
      iSizeab = na*nb
      if (.not. btest(lOper1(iComp),Mul(iSyma,iSymb)-1)) cycle

      if (iSyma == iSymb) then

        ipVa(1:iSizea) = pVf%SB(iComp)%A2(ip1+1:ip1+iSizea,1)
        iVpa(1:iSizea) = Vpf%SB(iComp)%A2(ip1+1:ip1+iSizea,1)
        ScpV(1:iSizeab) = Zero
        ScVp(1:iSizeab) = Zero
        ip1 = ip1+iSizea

      else if (iSyma > iSymb) then

        ifpV(1:iSizeab) = pVf%SB(iComp)%A2(ip1+1:ip1+iSizeab,1)
        ifVp(1:iSizeab) = Vpf%SB(iComp)%A2(ip1+1:ip1+iSizeab,1)
        ScpV(1:iSizeab) = Zero
        ScVp(1:iSizeab) = Zero
        ip1 = ip1+na*nb

      else if (iSyma < iSymb) then

        ifpV(1:iSizeab) = pVf%SB(iComp)%A2(iip1+1:iip1+iSizeab,2)
        ifVp(1:iSizeab) = Vpf%SB(iComp)%A2(iip1+1:iip1+iSizeab,2)
        ScpV(1:iSizeab) = ifpV(1:iSizeab)
        ScVp(1:iSizeab) = ifVp(1:iSizeab)
        iip1 = iip1+na*nb

      end if

      Bu2(1:na*nb) = Zero
      Bu4(1:na*nb) = Zero
      Ew(1:na) = Zero
      Ev(1:iSizea) = Zero
      G(1:na*nb) = Zero
      Aux(1:na*nb) = Zero
      Cmm1(1:na*nb) = Zero
      Cmm2(1:na*nb) = Zero

      ! Calculate the matrix elements of the
      ! following commutator :
      ! Revta*AAA*<a|[bp,V]|b>store in CMM1(iSyma,iSymb) matrix,

      call VPBMBPV(Eigf%SB(iSyma)%A2,Eigf%SB(iSymb)%A2,Revtf%SB(iSyma)%A2,Sinvf%SB(iSyma)%A2,Sinvf%SB(iSymb)%A2,na,nb,iSizea, &
                   Aaf%SB(iSyma)%A1,Aaf%SB(iSymb)%A1,Rrf%SB(iSyma)%A1,Rrf%SB(iSymb)%A1,ifpV,ifVp,iSyma,iSymb,Bu2,G,Aux,Cmm1,Bu4, &
                   Cmm2,ipVa,iVpa,ScpV,ScVp)

      Bu2(1:na*na) = Zero
      Aux(1:na*nb) = Zero
      Eig(1:na*na) = Zero

      ! call to package relsewc, BSS up to the fourth order in alpha

      call SCFCLI4(idbg,SS%SB(iSyma)%A1,Kin%SB(iSyma)%A1,Sinvf%SB(iSyma)%A2,na,nb,iSizea,VELIT,Cmm1,Cmm2,Ev,Bu2,Eig,Ew,P)

    end do
  end do
end do

call mma_deallocate(P)
call mma_deallocate(Ev)
call mma_deallocate(G)
call mma_deallocate(Eig)
call mma_deallocate(Aux)
call mma_deallocate(Ew)
call mma_deallocate(ipVa)
call mma_deallocate(iVpa)
call mma_deallocate(ifpV)
call mma_deallocate(ifVp)
call mma_deallocate(ScpV)
call mma_deallocate(ScVp)
call mma_deallocate(Bu2)
call mma_deallocate(Bu4)
call mma_deallocate(Cmm1)
call mma_deallocate(Cmm2)

call mma_deallocate(lOper1)

call Deallocate_DT(pVf)
call Deallocate_DT(Vpf)
call Deallocate_DT(pV)
call Deallocate_DT(Vp)
call Deallocate_DT(pVp)

! open arrays in contracted basis

iSizec = 0
do L=1,nSym
  iSizec = iSizec+nrBas(L)*(nrBas(L)+1)/2
end do
call mma_allocate(H,iSizec+4)
call mma_allocate(H_nr,iSizec+4)
call mma_allocate(H_temp,iSizec+4)
H(:) = Zero
H_temp(:) = Zero

! compute stripped non-relativistic H

Label = 'Kinetic '
call RdOne(iRC,iOpt,Label,1,SS%A0,lOper)
if (iRC /= 0) then
  write(u6,*) 'BSSInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if

Label = 'Attract '
call RdOne(iRC,iOpt,Label,1,V%A0,lOper)
if (iRC /= 0) then
  write(u6,*) 'BSSInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if

V%A0(:) = V%A0+SS%A0

call repmat(idbg,V%A0,H_temp,.true.)

call Deallocate_DT(SS)
call Deallocate_DT(V)

! Close ONEREL and re-open ONEINT

iOpt = 0
iRC = -1
call ClsOne(iRC,iOpt)
if (iRC /= 0) then
  write(u6,*) ' *** Error in subroutine BSSint ***'
  write(u6,*) '     Abend in subroutine OpnOne'
  call Abend()
end if
iOpt = 0
iRC = -1
Lu_One = 2
call OpnOne(iRC,iOpt,'ONEINT',Lu_One)
if (iRC /= 0) then
  write(u6,*) ' *** Error in subroutine BSSint ***'
  write(u6,*) '     Abend in subroutine OpnOne'
  call Abend()
end if

! Transform to contracted basis

! The Hamiltonian is now in Kin.

call repmat(idbg,Kin%A0,H,.true.)

call Deallocate_DT(Kin)

iOpt = 0
iRC = -1
Label = 'OneHam 0'
call RdOne(iRC,iOpt,Label,1,H_nr,lOper)
if (iRC /= 0) then
  write(u6,*) 'BSSInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
iRC = -1

! final Hamiltonian computed as H(nrel) + ( Hrel(s) - Hnrel(s))
! where (s) is stripped and with full charge

H(:) = H(:)-H_temp+H_nr

call Get_iArray('nBas',nBas,nSym)
if (iPrint >= 10) then
  write(u6,'(a11,10i5)') ' Symmetries',nSym
  write(u6,'(a11,10i5)') ' Contracted',(nBas(i),i=0,nSym-1)
end if
Label = 'OneHam 0'
lOper = 1
if (iPrint >= 20) call PrMtrx(Label,[lOper],1,[1],H)

! Replace 1-el Hamiltonian on ONEINT

iRC = -1
call WrOne(iRC,iOpt,Label,1,H,lOper)
Label = 'OneHam  '
call WrOne(iRC,iOpt,Label,1,H,lOper)
if (iRC /= 0) then
  write(u6,*) 'BSSInt: Error writing to ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if

call mma_deallocate(H)
call mma_deallocate(H_nr)
call mma_deallocate(H_temp)

call Deallocate_DT(Eigf)
call Deallocate_DT(Sinvf)
call Deallocate_DT(Revtf)
call Deallocate_DT(Aaf)
call Deallocate_DT(Rrf)

return

contains

end subroutine BSSint

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_IODIAG(DIAG,IOPT)
!
! Purpose: write/read a copy of diagonal to disk (1st reduced set).
!          The file is opened and closed here.
!          IOPT=1: write
!          IOPT=2: read

use Cholesky, only: LuPri, nnBstRT
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: DIAG(*)
integer(kind=iwp), intent(in) :: IOPT
integer(kind=iwp) :: IADR, LENGTH, LUNIT
character(len=*), parameter :: FNAME = 'CHODIAG', SECNAM = 'CHO_IODIAG_1'

LUNIT = 7
call DANAME(LUNIT,FNAME)
if ((IOPT == 1) .or. (IOPT == 2)) then
  LENGTH = NNBSTRT(1)
  IADR = 0
  call DDAFILE(LUNIT,IOPT,DIAG,LENGTH,IADR)
else   ! error
  write(LUPRI,*) SECNAM,': IOPT out of bounds: ',IOPT
  call CHO_QUIT('Error in '//SECNAM,104)
end if
call DACLOS(LUNIT)

end subroutine CHO_IODIAG

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PCM_Cavity(iPrint,ICharg,NAtm,AtmC,IAtm,IsAtMM,LcAtmC,LcIAtm,JSurf)

use PCM_arrays, only: Centr, dCntr, dPnt, dRad, dTes, IntSph, MxSph, NewSph, NVert, PCM_N, PCM_SQ, PCMiSph, PCMSph, PCMTess, Vert
use rctfld_module, only: DoDeriv, ISlPar, nPCM_Info, nS, nSInit, nTS, RSlPar, RSolv
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, ICharg, NAtm, IAtm(NAtm), IsAtMM(NAtm), JSurf
real(kind=wp), intent(in) :: AtmC(3,NAtm)
real(kind=wp), intent(out) :: LcAtmC(3,NAtm)
integer(kind=iwp), intent(out) :: LcIAtm(NAtm)
integer(kind=iwp) :: I, LcI, LcNAtm
integer(kind=iwp), allocatable :: pNs(:)
real(kind=wp), allocatable :: Rs(:), Xs(:), Ys(:), Zs(:)
real(kind=wp), parameter :: Rad_Cor = Two, Surf_Inc = Half

! Build the cavity.

call PCMDef(ISlPar,RSlPar)
RSlPar(3) = Half
RSlPar(7) = Two
RSlPar(9) = Rad_Cor+real(JSurf,kind=wp)*Surf_Inc

! Possibly print parameter values

if (iPrint >= 99) then
  write(u6,'(''PCM parameters'')')
  do I=1,100
    write(u6,'(''ISlpar('',i3,'') ='',i6)') I,ISlPar(I)
  end do
  do I=1,100
    write(u6,'(''RSlpar('',i3,'') ='',F8.3)') I,RSlPar(I)
  end do
end if

! Recover solvent data

call DataSol(ISlPar(15))

! It is necessary to avoid spurious "atoms" which can cause errors
! in UATM: then let's copy only the real atoms on local arrays
! of coordinates and atomic numbers.

LcI = 0
do I=1,NAtm
  if ((IAtm(I) > 0) .and. (IsAtMM(I) == 0)) then
    LcI = LcI+1
    LcAtmC(:,LcI) = AtmC(:,I)
    LcIAtm(LcI) = IAtm(I)
  end if
end do
LcNAtm = LcI
ISlPar(42) = LcNAtm

! Define atomic/group spheres
! Allocate space for X, Y, Z, Radius and NOrd for MxSph spheres

call mma_allocate(Xs,MxSph,Label='Xs')
call mma_allocate(Ys,MxSph,Label='Ys')
call mma_allocate(Zs,MxSph,Label='Zs')
call mma_allocate(Rs,MxSph,Label='Rs')
call mma_allocate(pNs,MxSph,Label='pNs')

NSinit = 0
call FndSph(LcNAtm,ICharg,LcAtmC,LcIAtm,ISlPar(9),ISlPar(14),RSlPar(9),Xs,Ys,Zs,Rs,pNs,MxSph,iPrint)

! Define surface tesserae

call FndTess(iPrint,Xs,Ys,Zs,Rs,pNs,MxSph)

call mma_deallocate(pNs)
call mma_deallocate(Rs)
call mma_deallocate(Zs)
call mma_deallocate(Ys)
call mma_deallocate(Xs)

! If needed compute the geometrical derivatives

if (DoDeriv) then
  RSolv = RSlPar(19)
  LcNAtm = ISlPar(42)
  call mma_allocate(dTes,nTs,LcNAtm,3,Label='dTes')
  call mma_allocate(dPnt,nTs,LcNAtm,3,3,Label='dPnt')
  call mma_allocate(dRad,nS,LcNAtm,3,Label='dRad')
  call mma_allocate(dCntr,nS,LcNAtm,3,3,Label='dCntr')
  call mma_allocate(PCM_SQ,2,nTs,Label='PCM_SQ')
  call Deriva(0,LcNAtm,nTs,nS,nSInit,RSolv,PCMTess,Vert,Centr,PCMSph,PCMiSph,IntSph,PCM_N,NVert,NewSph,dTes,dPnt,dRad,dCntr)
  if (nPCM_info == 0) then
    write(u6,'(A)') ' GEPOL failed to compute the grid deriv.'
    write(u6,'(A)') ' Reduce the number of surfaces.'
    call Quit_OnUserError()
  end if
end if

return

end subroutine PCM_Cavity

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine geth0()

use gugaci_global, only: ecih0, escf, indx, ipae, irf, irfno, jpad, jpadl, jpae, logic_mr, max_h0, max_innorb, max_kspace, &
                         max_ref, max_root, mroot, ndim, ndim_h0, norb_act, nu_ad, nu_ae, vcm, vd, ve, vector1, vector2, vu
                         !, len_str, tmpdir
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, ijm, kval, l, m, mmspace, mn, ndim0, nxb, nxh
real(kind=wp) :: vad0(max_h0)
!character(len=256) :: filename
integer(kind=iwp), allocatable :: iselcsf_occ(:,:)
real(kind=wp), allocatable :: vb1(:), vb2(:)
real(kind=wp), parameter :: dcrita = 5.0e-6_wp

call mma_allocate(iselcsf_occ,max_innorb,max_ref,label='iselcsf_occ')
if (.not. logic_mr) then
  call minevalue(iselcsf_occ)
end if
!=======================================================================
! calculate ndim_h0
if (norb_act == 0) then
  ndim_h0 = 1
  vector2(1) = vector1(1)
  irfno(1) = 1
  !return
else
  ipae = 1
  jpae = nu_ae(ipae)
  if (jpae == 0) return
  jpadl = 1
  if (nu_ad(jpadl) == 0) return
  jpad = jpadl
  call seg_drt()
  if (ndim == 0) return
  ndim_h0 = ndim

  if (mroot > ndim_h0) then
    write(u6,*) '    mroot> ndim_h0, mroot,ndim_h0=',mroot,ndim_h0
    mroot = min(ndim_h0,mroot)
    write(u6,*) '   ',mroot,'roots are calculated'
  end if

  call copy_to_drtl()

  if (logic_mr) then
    call irfrst()
    if (mroot > ndim_h0) then
      write(u6,*) '    mroot> ndim_h0, mroot,ndim_h0=',mroot,ndim_h0
      mroot = min(ndim_h0,mroot)
      write(u6,*) '   ',mroot,'roots are calculated'
    end if
    call minevalue(iselcsf_occ)
  end if
end if
call mma_deallocate(iselcsf_occ)

!=======================================================================
!if (logic_mr) ndim_h0 = irf
if (.not. logic_mr) then
  ndim0 = ndim_h0
else
  ndim0 = irf
end if
write(u6,*) '     ================================'
write(u6,*) '         step 1: diagnalization h0   '
write(u6,*) '            ndim_h0=',ndim0
write(u6,*) '     ================================'

if (ndim_h0 == 1) then
  ecih0(1) = escf(1)
  vcm(1) = One
else

  call formh0()   ! for log_mr, ndim_h0 changed to irf in this subroutine
  !=====================================================================
  if (allocated(vcm)) call mma_deallocate(vcm)
  call mma_allocate(vcm,ndim_h0*mroot,label='vcm')

  if (ndim_h0 <= 30) then
    call hotred(max_kspace,ndim_h0,vector2,vd,ve,vu)
    call qlcm(max_kspace,ndim_h0,vd,ve,vu)
    ijm = 0
    do m=1,mroot
      ecih0(m) = vd(m)
      do l=1,ndim_h0
        vcm(ijm+l) = vu(m,l)
      end do
      ijm = ijm+ndim_h0
    end do
  else
    mmspace = mroot*3+10
    do i=1,mmspace
      indx(i) = (i-1)*ndim_h0
    end do

    do i=1,ndim_h0
      mn = i*(i+1)/2
      vad0(i) = vector2(mn)
    end do

    nxh = ndim_h0*(ndim_h0+1)/2
    nxb = ndim_h0*max_kspace

    call mma_allocate(vb1,max_h0*max_kspace,label='vb1')
    call mma_allocate(vb2,max_h0*max_kspace,label='vb2')
    call basis_2(ndim_h0,vb1,nxb,vad0,vector2,nxh)

    do m=1,mroot
      ecih0(m) = escf(m)
    end do

    kval = mroot*2
    call hymat_2(max_root,max_kspace,ndim_h0,kval,mroot,dcrita,ecih0,vcm,indx,vector2,nxh,vb1,vb2,nxb,vad0)
    !vcm(1:mroot*ndim_h0) = vb1(1:mroot*ndim_h0)
    ! save ci vector in h0 into vb2
    !numh0 = nci_h0 !iw_sta(2,1)
    !vb2(1:numh0*mroot) = Zero
    !if (logic_mr) then
    !  idx1 = 0
    !  idx2 = 0
    !  do i=1,mroot
    !    do j=1,ndim_h0
    !      m = irfno(j)
    !      vb2(idx1+m) = vb1(idx2+j)
    !    end do
    !    idx1 = idx1+numh0
    !    idx2 = idx2+ndim_h0
    !  end do
    !else
    !  vb2(1:numh0*mroot) = vb1(1:numh0*mroot)
    !end if
    call mma_deallocate(vb1)
    call mma_deallocate(vb2)
  end if
  call mma_deallocate(vcm)
end if

write(u6,*)
do m=1,mroot
  write(u6,'(5x,a7,i5,f18.8)') ' root,',m,ecih0(m)
end do
write(u6,*)

!filename = tmpdir(1:len_str)//'/fort7'
!len = len_str+6
!open(nf7,file=filename(1:len),form='unformatted')
!write(nf7) vb2(1:numh0*mroot)
!close(nf7)

!open(100,file='tmp.dat')
!do i=1,ndim_h0
!  write(100,'(1x,f18.9,2i8)') vb1(i),i,irfno(i)
!end do
!write(100,*) 'ndim_h0=',ndim_h0,'v0=',numh0
!idx1 = 0
!idx2 = 0
!do i=1,mroot
!  write(100,*) 'mroot=',mroot
!  do j=1,numh0
!    write(100,'(1x,i2,1x,i5,2x,f18.9)') 1,j,vb2(j)
!    m = ifrno(j)
!    write(100,'(2(1x,i8,1x,f18.9))') j,vb2(j+idx1),m,vb1(m+idx2)
!  end do
!  idx1 = idx1+numh0
!  idx2 = idx2+ndim_h0
!end do
!close(100)
!call abend()

return

end subroutine geth0

subroutine formh0()

use gugaci_global, only: irf, irfno, lenvec, log_prod, logic_mr, max_vector, ndim_h0, vector1, vector2, vint_ci
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, iconf1, iconf2, iconfmax, iconfmin, ii, iicc, ir1, ir2, mnh0, mnrh0, num
real(kind=wp), allocatable :: buff(:)

num = ndim_h0*(ndim_h0+1)/2
if (num > max_vector) then
  write(u6,*) ' not enough space to store h0 matrix',num
# ifndef MOLPRO
  call abend()
# endif
  !call abend()
end if

vector2(1:lenvec) = Zero
log_prod = 2
call readint(1,vint_ci)
! act complete loop
call cloop_in_act()
! dbl- act loop
call ploop_in_act()

! save the h0 matrix into sracth file 23 to use later
if (logic_mr) then ! rst
  call mma_allocate(buff,ndim_h0,label='buff')
  buff(1:ndim_h0) = vector1(1:ndim_h0)
  vector1(1:lenvec) = Zero
  mnh0 = ndim_h0*(ndim_h0+1)/2
  vector1(1:mnh0) = vector2(1:mnh0)
  mnrh0 = irf*(irf+1)/2
  vector2(1:mnrh0) = Zero
  do ir1=1,irf
    iconf1 = irfno(ir1)
    ii = ir1*(ir1+1)/2
    vector2(ii) = buff(iconf1)
    do ir2=1,ir1-1
      iconf2 = irfno(ir2)
      ii = ir1*(ir1-1)/2+ir2
      iconfmax = max(iconf1,iconf2)
      iconfmin = min(iconf1,iconf2)
      iicc = iconfmax*(iconfmax-1)/2+iconfmin
      vector2(ii) = vector1(iicc)
    end do
  end do
  ndim_h0 = irf
  call mma_deallocate(buff)
else
  do i=1,ndim_h0   ! rcas
    ii = i*(i-1)/2+i
    vector2(ii) = vector2(ii)+vector1(i)
  end do
end if

!do i=1,ndim_h0
!  write(u6,'(i4,1x,f12.6)') i,vector1(i)
!end do
!call abend()
write(u6,'(a24,i5)') ' dimension of h0 space= ',ndim_h0
log_prod = 1

!open(100,file='h0_new')
!do i=1,num
!  write(100,*) i,vector2(i)
!end do
!close(100)
!call abend()

return

end subroutine formh0

! mroot=2 min_space=4
!    b1=(0,0,1.0,0,0,0...) b2=(0,0,0,0,1.0,0...)

subroutine basis_2(ndim,vb1,nxb,vad,th,nxh)

use gugaci_global, only: ifrno, indx, logic_mr, max_kspace, mjn, mroot
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ndim, nxb, nxh
real(kind=wp), intent(out) :: vb1(max_kspace*ndim)
real(kind=wp), intent(in) :: vad(ndim), th(nxh)
integer(kind=iwp) :: i, ib, ij, ijh, j, l, m, m0, mief, mjnj
real(kind=wp) :: fenmu, vadi
integer(kind=iwp), allocatable :: ijb1(:)
real(kind=wp), parameter :: dcrita = 1.0e-6_wp, epc = 5.0e-3_wp

vb1(:) = Zero

do j=1,mroot
  ij = indx(j)
  mief = mjn(j)
  if (logic_mr) then
    mjnj = mjn(j)
    mief = ifrno(mjnj)
  end if
  do l=1,ndim
    vb1(ij+l) = Zero
  end do
  vb1(ij+mief) = One
end do

!=======================================================================
call mma_allocate(ijb1,mroot,label='ijb1')
j = mroot
do m=1,mroot
  i = mjn(m)
  if (logic_mr) then
    mjnj = mjn(m)
    i = ifrno(mjnj)
  end if
  vadi = vad(i)
  ijh = i*(i-1)/2
  j = j+1
  ijb1(m) = indx(j)
  do l=1,i-1
    fenmu = vadi-vad(l)
    if (abs(fenmu) < epc) fenmu = epc
    vb1(ijb1(m)+l) = th(ijh+l)/fenmu
  end do
  do l=i+1,ndim
    fenmu = vadi-vad(l)
    if (abs(fenmu) < epc) fenmu = epc
    ijh = l*(l-1)/2
    vb1(ijb1(m)+l) = th(ijh+i)/fenmu
  end do
end do
call mma_deallocate(ijb1)

!-----------------------------------------------------------------------
! write out basis
!-----------------------------------------------------------------------
!write(nf2,*) ' l    vb5       vb6      vb7       vb8'
!
!do l=1,ndim
!  write(nf2,'(2x,i5,4f10.4)') l,vb1(indx(5)+l),vb1(indx(6)+l),vb1(indx(7)+l),vb1(indx(8)+l)
!end do
!call abend()   !wyb_tmp
!-----------------------------------------------------------------------
do m0=1,mroot
  ib = m0+mroot
  call orthnor(ndim,ib,dcrita,vb1,nxb)
end do

return

end subroutine basis_2

subroutine minevalue(iselcsf_occ)

use gugaci_global, only: escf, irf, irfno, logic_mr, LuCiDia, max_innorb, max_ref, mjn, mroot, nci_dim, nci_h0, norb_act, &
                         norb_all, norb_dz, nwalk, vector1, vector2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iselcsf_occ(max_innorb,max_ref)
integer(kind=iwp) :: i, ij, io, j, jm, l, m, ndimh0
integer(kind=iwp), allocatable :: iwalktmp(:)
real(kind=wp) :: am

call read_ml(lucidia,vector1,nci_dim,1)

vector2(1:nci_dim) = vector1(1:nci_dim)
ndimh0 = nci_h0 !iw_sta(2,1)

if (.not. logic_mr) then
  do i=1,mroot
    l = 1
    am = vector2(l)
    do j=1,ndimh0
      if ((vector2(j) /= Zero) .and. (vector2(j) < am)) then
        l = j
        am = vector2(j)
      end if
    end do
    mjn(i) = l
    vector2(l) = Zero
  end do
else
  do i=1,mroot
    l = 1
    am = vector2(l)
    do j=1,irf
      jm = irfno(j)
      if ((vector2(jm) /= Zero) .and. (vector2(jm) < am)) then
        l = jm
        am = vector2(jm)
      end if
    end do
    mjn(i) = l
    vector2(l) = Zero
  end do
end if

do m=1,mroot
  escf(m) = vector1(mjn(m))
end do

call mma_allocate(iwalktmp,norb_all,label='iwalktmp')
write(u6,*) '   mjn(k) :',mroot
do m=1,mroot
  call found_a_config(mjn(m),escf(m),1)
  do i=1,norb_all
    iwalktmp(i) = nwalk(norb_all-i+1)
  end do
  ij = norb_dz
  if (m <= 2*mroot) then
    do io=1,norb_act
      ij = ij+1
      if (iwalktmp(ij) == 3) iselcsf_occ(io,m) = 3
      if (iwalktmp(ij) == 2) iselcsf_occ(io,m) = 2
      if (iwalktmp(ij) == 1) iselcsf_occ(io,m) = 1
      if (iwalktmp(ij) == 0) iselcsf_occ(io,m) = 0
    end do
    !write(u6,'(16(i1))') iwalktmp(norb_dz+1:norb_dz+norb_act)
  end if
  !write(u6 ,'(2x,2i8,f18.8)') m,mjn(m),escf(m)
  !write(nf2,'(2x,2i8,f18.8)') m,mjn(m),escf(m)
end do
write(u6,*)
call mma_deallocate(iwalktmp)

end subroutine minevalue

!subroutine orthnor_ab(n,av,bv,id)  !bv:basis, av:vector for orth a
!
!use Constants, only: Zero
!use Definitions, only: wp, iwp, r8
!
!implicit none
!integer(kind=iwp), intent(in) :: n, id
!real(kind=wp), intent(inout) :: av(n)
!real(kind=wp), intent(in) :: bv(n)
!integer(kind=iwp) :: i
!real(kind=wp) :: s
!real(kind=wp), parameter :: dcrita = 1.0e-10_wp
!real(kind=r8), external :: ddot_
!
!if (id == 0) then
!  ! orthogonalization av,bv
!  s = ddot_(n,av,1,bv,1)
!  do i=1,n
!    av(i) = av(i)-s*bv(i)
!  end do
!end if
!! normalization of av_eigenvector.
!s = Zero
!s = ddot_(n,av,1,av,1)
!s = sqrt(s)
!s = max(s,dcrita)
!do i=1,n
!  av(i) = av(i)/s
!end do
!
!return
!
!end subroutine orthnor_ab

!function ddot_bak(n,dx,dy)
!
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: n
!real(kind=wp), intent(in) :: dx(n), dy(n)
!integer(kind=iwp) :: l
!real(kind=wp) :: ddot_bak
!real(kind=wp) :: s
!
!s = Zero
!do l=1,n
!  s = s+dx(l)*dy(l)
!end do
!ddot_bak = s
!
!return
!
!end function ddot_bak

!subroutine matrmk_1(k)
!
!use gugaci_global, only: LuCiTv1, LuCiTv2, nci_dim, vector1, vector2, vp
!use Constants, only: Zero
!use Definitions, only: wp, iwp, u6
!
!implicit none
!integer(kind=iwp), intent(in) :: k
!integer(kind=iwp) :: i, ibas, ij, il, jbas, l
!real(kind=wp) :: vsumtmp
!
!do ibas=1,k
!  call read_ml(lucitv1,vector1,nci_dim,ibas)
!  ij = ibas*(ibas-1)/2
!  do jbas=1,ibas
!    call read_ml(lucitv2,vector2,nci_dim,jbas)
!    vsumtmp = Zero
!    do l=1,nci_dim
!      vsumtmp = vsumtmp+vector1(l)*vector2(l)
!    end do
!    vp(ij+jbas) = vsumtmp
!  end do
!end do
!write(u6,*)
!il = 0
!do l=1,k
!  write(u6,1112) (vp(i),i=il+1,il+l)
!  il = il+l
!end do
!write(u6,*)
!
!return
!
!1112 format(2x,20f14.8)
!
!end subroutine matrmk_1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MLTSCA_DH(IMLTOP,LST1,LST2,X,NXI,NXA,F,NFI,NFA,Y,NAS2,jYLo,jYHi)
! Given two lists with entries LST1(4,ITEM), ITEM=1,NLST1, the
! four entries called L11,L12,L13,L14 for short, for a given
! item, and with V1=VAL1(L14), and similar for the other list,
! compute, for IMLTOP=0 or 1 respectively,
!     X(L11,L21) := Add V1*V2*F(L12,L22)*Y(L13,L23)
!  or Y(L13,L23) := Add V1*V2*F(L12,L22)*X(L11,L21)
! or for IMLTOP=2, compute
!     F(L12,L22) := Add V1*V2*X(L11,L21)*Y(L13,L23)

use Sigma_data, only: NLST1, NLST2, VAL1, VAL2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IMLTOP, LST1(4,NLST1), LST2(4,NLST2), NXI, NXA, NFI, NFA, NAS2, jYLo, jYHi
real(kind=wp), intent(inout) :: X(NXI,NXA), F(NFI,NFA), Y(NAS2,jYHi-jYLo+1)
integer(kind=iwp) :: ILST1, ILST2, JY, L11, L12, L13, L14, L21, L22, L23, L24
real(kind=wp) :: V1, V2

if (IMLTOP == 0) then
  do ILST1=1,NLST1
    L11 = LST1(1,ILST1)
    L12 = LST1(2,ILST1)
    L13 = LST1(3,ILST1)
    L14 = LST1(4,ILST1)
    V1 = VAL1(L14)
    if ((L13 >= jYLo) .and. (L13 <= jYHi)) then
      JY = L13-jYLo+1
      do ILST2=1,NLST2
        L21 = LST2(1,ILST2)
        L22 = LST2(2,ILST2)
        L23 = LST2(3,ILST2)
        L24 = LST2(4,ILST2)
        V2 = VAL2(L24)
        X(L11,L21) = X(L11,L21)+V1*V2*F(L12,L22)*Y(L23,JY)
      end do
    end if
  end do
else if (IMLTOP == 1) then
  do ILST1=1,NLST1
    L11 = LST1(1,ILST1)
    L12 = LST1(2,ILST1)
    L13 = LST1(3,ILST1)
    L14 = LST1(4,ILST1)
    V1 = VAL1(L14)
    if ((L13 >= jYLo) .and. (L13 <= jYHi)) then
      JY = L13-jYLo+1
      do ILST2=1,NLST2
        L21 = LST2(1,ILST2)
        L22 = LST2(2,ILST2)
        L23 = LST2(3,ILST2)
        L24 = LST2(4,ILST2)
        V2 = VAL2(L24)
        Y(L23,JY) = Y(L23,JY)+V1*V2*F(L12,L22)*X(L11,L21)
      end do
    end if
  end do
else
  do ILST1=1,NLST1
    L11 = LST1(1,ILST1)
    L12 = LST1(2,ILST1)
    L13 = LST1(3,ILST1)
    L14 = LST1(4,ILST1)
    V1 = VAL1(L14)
    if ((L13 >= jYLo) .and. (L13 <= jYHi)) then
      JY = L13-jYLo+1
      do ILST2=1,NLST2
        L21 = LST2(1,ILST2)
        L22 = LST2(2,ILST2)
        L23 = LST2(3,ILST2)
        L24 = LST2(4,ILST2)
        V2 = VAL2(L24)
        F(L12,L22) = F(L12,L22)+V1*V2*X(L11,L21)*Y(L23,JY)
      end do
    end if
  end do
end if

!NFSCA = NFSCA+4*NLST1*NLST2

end subroutine MLTSCA_DH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_GetAtomToUniqueAtomMap(A2UA,nA)
      Use Basis_Info
      use Center_Info
C
C     Thomas Bondo Pedersen, June 2010.
C     - based on Print_Geometry by Roland Lindh.
C
C     Compute map from atom to unique atom.
C
C     A2UA(i): returns unique atom corresponding to atom i
C              (i is an index in the LDF Atom Info list)
C
      Implicit Real*8 (A-H,O-Z)
      Integer A2UA(nA)
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      Character*62 Msg, Msg2, Msg3, Msg4
      Parameter (Msg=
     & 'LDF_GetAtomToUniqueAtomMap: LDF_AtomWithCoordinates returned 0')
      Parameter (Msg2=
     & 'LDF_GetAtomToUniqueAtomMap: LDF_AtomWithCoordinates too large ')
      Parameter (Msg3=
     & 'LDF_GetAtomToUniqueAtomMap: Internal error detected...        ')
      Parameter (Msg4=
     & 'LDF_GetAtomToUniqueAtomMap: Some atoms were not found...      ')
#endif
      Integer  LDF_AtomWithCoordinates
      External LDF_AtomWithCoordinates

#if defined (_DEBUGPRINT_)
      Call iZero(A2UA,nA)
      nCount=0
#endif

      ndc=0
      l_UAR=3
      Call GetMem('LDFUAR','Allo','Real',ip_UAR,l_UAR)
      Do jCnttp=1,nCnttp
         mCnt=dbsc(jCnttp)%nCntr
         If (dbsc(jCnttp)%pChrg .or.
     &       dbsc(jCnttp)%Aux .or.
     &       dbsc(jCnttp)%Frag) Then
            ndc=ndc+mCnt
         Else
            Call OA(dc(ndc+1)%iCoSet(0,0),dbsc(jCnttp)%Coor(1:3,1),
     &                               Work(ip_UAR:ip_UAR+2))
            ndc=ndc+1
            jxyz=jxyz+3
            iAtom=LDF_AtomWithCoordinates(Work(ip_UAR))
#if defined (_DEBUGPRINT_)
            nCount=nCount+1
            If (iAtom.lt.1) Then
               Call WarningMessage(2,Msg)
               Call LDF_Quit(1)
            End If
            If (iAtom.gt.nA) Then
               Call WarningMessage(2,Msg2)
               Call LDF_Quit(1)
            End If
            If (A2UA(iAtom).ne.0) Then
               Call WarningMessage(2,Msg3)
               Call LDF_Quit(1)
            End If
#endif
            iAtom_Unique=iAtom
            A2UA(iAtom)=iAtom_Unique
            Do jCnt=2,mCnt
               Call OA(dc(ndc+1)%iCoSet(0,0),
     &                                  dbsc(jCnttp)%Coor(1:3,jCnt),
     &                                  Work(ip_UAR:ip_UAR+2))
               ndc=ndc+1
               jxyz=jxyz+3
               iAtom=LDF_AtomWithCoordinates(Work(ip_UAR))
#if defined (_DEBUGPRINT_)
               nCount=nCount+1
               If (iAtom.lt.1) Then
                  Call WarningMessage(2,Msg)
                  Call LDF_Quit(1)
               End If
               If (iAtom.gt.nA) Then
                  Call WarningMessage(2,Msg2)
                  Call LDF_Quit(1)
               End If
               If (A2UA(iAtom).ne.0) Then
                  Call WarningMessage(2,Msg3)
                  Call LDF_Quit(1)
               End If
#endif
               A2UA(iAtom)=iAtom_Unique
            End Do
         End If
      End Do
      Call GetMem('LDFUAR','Free','Real',ip_UAR,l_UAR)

#if defined (_DEBUGPRINT_)
      If (nCount.ne.nA) Then
         Call WarningMessage(2,Msg4)
         Call LDF_Quit(1)
      End If
      nErr=0
      Do iA=1,nA
         If (A2UA(iA).lt.1 .or. A2UA(iA).gt.nA) Then
            nErr=nErr+1
         End If
      End Do
      If (nErr.ne.0) Then
         Call WarningMessage(2,Msg3)
         Call LDF_Quit(1)
      End If
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Martin Schuetz                                   *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Aufbau(nAuf,Occup,nOccup,iOK,nD)
!***********************************************************************
!                                                                      *
!     purpose: sets the orbital occupation numbers in the different    *
!              irreps according to the Aufbau scheme...                *
!                                                                      *
!     method:  sets up a map vector, which is sorted with respect to   *
!              the orbital energies, neglecting the boundaries of the  *
!              different irrep blocks. The lowest orbitals then are    *
!              occupied...                                             *
!     input:                                                           *
!       nAuf          : # (doubly) occupied orbitals                   *
!                                                                      *
!     output:                                                          *
!       Occup(nOccup) : orbital occupation numbers                     *
!***********************************************************************

use InfSCF, only: EOrb, nFro, nOcc, nOrb, nSym, rTemp, TEEE
use Molcas, only: MxSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Three, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nAuf(2), nOccup, nD
real(kind=wp), intent(out) :: Occup(nOccup,nD)
integer(kind=iwp), intent(out) :: iOK
integer(kind=iwp) :: iD, iOrb, iOrBas, ipOcc, iSym, jOrBas, mD, mOrb_AS(2), nElec, nEOrb, nOrb_AS(2), nOrBas, Tmp
! These occupation number vectors are used to determine if we have convergence.
integer(kind=iwp) :: kOccAuf = 1, nOccAuf(MxSym,2,2) = -1
real(kind=wp) :: EFerm, Fact, Fact2, Sum_el(2), UHF_Occ, UnlikelyOcc
integer(kind=iwp), allocatable :: Map(:,:), Irp(:,:)
real(kind=wp), external :: Fermipop

nEOrb = size(EOrb,1)

call mma_allocate(Map,nEOrb,nD,Label='Map')
call mma_allocate(Irp,nEOrb,nD,Label='Irp')
!----------------------------------------------------------------------*
! Initialize convergence detection                                     *
!----------------------------------------------------------------------*
if (kOccAuf == -1) then
  nOccAuf(:,:,:) = -1
  kOccAuf = 1
end if

! Set up map...

iOrbAS = 0
do iSym=1,nSym
  do iOrb=1,nOrb(iSym)-nFro(iSym)
    iOrbAS = iOrbAS+1
    Irp(iOrbAS,:) = iSym
    Map(iOrbAS,:) = iOrbAS
  end do
end do
nOrbAS = iOrbAS

! Now sort map with respect to orbital energies (bubblesort)

do iOrbAS=1,nOrbAS-1
  do jOrbAS=nOrbAS-1,iOrbAS,-1
    do iD=1,nD
      if (EOrb(Map(jOrbAS,iD),iD) > EOrb(Map(1+jOrbAS,iD),iD)) then
        Tmp = Map(jOrbAS,iD)
        Map(jOrbAS,iD) = Map(1+jOrbAS,iD)
        Map(1+jOrbAS,iD) = Tmp
      end if
    end do
  end do
end do

! and fill up the orbitals...

nOcc(:,:) = 0
Occup(:,:) = Zero

if (Teee) then

  UHF_occ = Three-real(nD,kind=wp)
  mD = 2/nD
  do iD=1,nD
    eferm = FermiPop(EOrb(:,iD),Occup(:,iD),nOrbAS,RTemp,nAuf(iD)*mD,UHF_occ)
#   ifdef _DEBUGPRINT_
    write(u6,'(A,G20.10)') '         E(Fermi)=',eferm
#   else
#   include "macros.fh"
    unused_var(eferm)
#   endif
  end do

  iOrbAS = 0
  do iSym=1,nSym
    nOrb_AS(1:nD) = 0
    mOrb_AS(1:nD) = 0
    sum_el(:) = Zero

    jOrbAS = iOrbAS
    unlikelyOcc = 0.19_wp
    do iOrb=1,nOrb(iSym)-nFro(iSym)
      iOrbAS = iOrbAS+1
      do iD=1,nD
        if (Occup(iOrbAS,iD) >= UHF_occ-unlikelyOcc) nOrb_AS(iD) = nOrb_AS(iD)+1
        if (Occup(iOrbAS,iD) < unlikelyOcc) mOrb_AS(iD) = mOrb_AS(iD)+1
      end do
      sum_el(1:nD) = sum_el(1:nD)+Occup(iOrbAS,1:nD)
    end do
    Fact = nD*Half
    Fact2 = 0.99_wp+real(2-nD,kind=wp)
    nOccAuf(iSym,kOccAuf,1:nD) = nOrb_AS(1:nD)
    nOcc(iSym,1:nD) = int(Fact*(sum_el(1:nD)+Fact2/nSym))
  end do
  kOccAuf = 3-kOccAuf

else

  Fact = Two/real(nD,kind=wp)
  do iD=1,nD
    do iOrbAS=1,nAuf(iD)
      iSym = Irp(Map(iOrbAS,iD),iD)
      nOcc(iSym,iD) = nOcc(iSym,iD)+1
      ipOcc = sum(nOrb(1:iSym-1))
      Occup(ipOcc+nOcc(iSym,iD),iD) = Fact
    end do
  end do

end if

iOK = 1
do iD=1,nD
  if (any(nOccAuf(1:nSym,1,iD) /= nOccAuf(1:nSym,2,iD))) iOK = 0
  nElec = sum(nOccAuf(1:nSym,1,iD))
  if (nElec /= nAuf(iD)) iOK = 0
end do
if (iOK == 1) nOcc(1:nSym,1:nD) = nOccAuf(1:nSym,1,1:nD)

! Write new occupation on the RUNFILE

call Put_iArray('nIsh',nOcc(1,1),nSym)
if (nD == 2) call Put_iArray('nIsh beta',nOcc(1,2),nSym)

call mma_deallocate(Irp)
call mma_deallocate(Map)

return

end subroutine Aufbau

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995,2001,2008, Roland Lindh                           *
************************************************************************
      SubRoutine PCMHss(
#define _CALLING_
#include "hss_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of nuclear attraction     *
*         integrals.                                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, May 1995                                *
*                                                                      *
*             Modified to PCM gradients September 2001, Lund, by       *
*             R. Lindh.                                                *
*             Modified to PCM Hessian February 2008, Lund by           *
*             R. Lindh.                                                *
************************************************************************
      use PCM_arrays, only: PCM_SQ, PCMTess
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
      External TNAI1, Fake, XCff2D
#include "real.fh"
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "disp.fh"
#include "disp2.fh"
#include "rctfld.fh"

#include "hss_interface.fh"

*     Local variables
      Integer iDCRT(0:7), Index(3,4)
      Real*8 Coori(3,4), CoorAC(3,2), C(3), TC(3)
      Logical NoLoop, JfGrd(0:2,0:3),
     &        JfHss(0:3,0:2,0:3,0:2),
     &        IfG(0:3), Tr(0:3)
      Integer iAnga(4), iStb(0:7), JndGrd(0:2,0:3,0:7),
     &        JndHss(0:3,0:2,0:3,0:2,0:7),
     &         mOp(4), iuvwx(4)
      Character ChOper(0:7)*3
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*                                                                      *
************************************************************************
*                                                                      *
*    We will have five terms here!
*
*    1) Sum(i) q_i V_ie^xy
*    2) Sum(ij) V_in^y Q_ij V_je^x
*    3) Sum(ij) V_ie^y Q_ij V_je^x
*    Maurizio to add comments for the last two terms!
*
      iRout = 151
      iPrint = nPrint(iRout)
*
      nip = 1
      ipA = nip
      nip = nip + nAlpha*nBeta
      ipB = nip
      nip = nip + nAlpha*nBeta
      ipDAO = nip
      nip = nip + nAlpha*nBeta*nElem(la)*nElem(lb)*nElem(nOrdOp)
      If (nip-1.gt.nZeta*nArr) Then
         Write (6,*) 'nip-1.gt.nZeta*nArr'
         Call ErrTra
         Call Abend()
      End If
      nArray = nZeta*nArr - nip + 1
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = nOrdOp
      iAnga(4) = 0
      call dcopy_(3, A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
      If (la.ge.lb) Then
       call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
       call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      mOp(1) = nOp(1)
      mOp(2) = nOp(2)
*
      ipAOff = ipA
      Do iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
      End Do
*
      ipBOff = ipB
      Do iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
      End Do
*
*---- Modify the density matrix with the prefactor
*
      nDAO = nElem(la) * nElem(lb)
      Do iDAO = 1, nDAO
         Do iZeta = 1, nZeta
            Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
            DAO(iZeta,iDAO) = Fact * DAO(iZeta,iDAO)
         End Do
      End Do
      If (iPrint.ge.99) Call RecPrt('DAO',' ',DAO,nZeta,nDAO)
*
*---- Generate stabilizor of C, i.e. a center of a tile.
*
      nStb=1
      iStb(0)=0
*
*     Loop over the tiles
*
      Do iTs = 1, nTs
         q_i=PCM_SQ(1,iTs)+PCM_SQ(2,iTs)
         NoLoop = q_i.eq.Zero
         If (NoLoop) Go To 111
*------- Pick up the tile coordinates
         C(1:3)=PCMTess(1:3,iTs)

         If (iPrint.ge.99) Call RecPrt('C',' ',C,1,3)
         Call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
         Fact = -q_i*DBLE(nStabM) / DBLE(LmbdT)
*
         Call DYaX(nZeta*nDAO,Fact,DAO,1,Array(ipDAO),1)
*
         iuvwx(3) = nStb
         iuvwx(4) = nStb
*
         Do lDCRT = 0, nDCRT-1
            mOp(3) = NrOpr(iDCRT(lDCRT))
            mOp(4) = mOp(3)
            Call OA(iDCRT(lDCRT),C,TC)
            call dcopy_(3,TC,1,CoorAC(1,2),1)
            call dcopy_(3,TC,1,Coori(1,3),1)
            call dcopy_(3,TC,1,Coori(1,4),1)
*
*           Initialize JfGrd, JndGrd, JfHss, and JndHss.
*
            Call LCopy(12,[.False.],0,JfGrd,1)
            Call ICopy(nSym*4*3,[0],0,JndGrd,1)
            Call LCopy(144,[.False.],0,JfHss,1)
            Call ICopy(nSym*16*9,[0],0,JndHss,1)
*
*           Overwrite with information in IfGrd, IndGrd, IfHss,
*           and IndHss. This sets up the info for the first two
*           centers! Make sure that no translational invariance
*           is used.

            Do iAtom = 0, 1
               Do iCar  = 0, 2
                  JfGrd(iCar,iAtom) = Ifgrd(iCar,iAtom)
                  Do iIrrep=0,nSym-1
                     JndGrd(iCar,iAtom,iIrrep)=
     &                  Abs(IndGrd(iCar,iAtom,iIrrep))
                  End Do
                  Do jAtom = 0, 1
                     Do jCar = 0, 2
                        JfHss(iAtom,iCar,jAtom,jCar) =
     &                    IfHss(iAtom,iCar,jAtom,jCar)
                        Do iIrrep=0,nSym-1
                           JndHss(iAtom,iCar,jAtom,jCar,iIrrep) =
     &                       Abs(IndHss(iAtom,iCar,jAtom,jCar,iIrrep))
                        End Do
                     End Do
                  End Do
               End Do
            End Do
*
*-----------Derivatives with respect to the operator is computed via
*           the translational invariance.
*           Note: We want no such thing!
*
*
*           The third center is calculated by translational invariance.
*           This requires the 2nd derivatives on the other centers.
*           Note: We want no such thing!
*
            Call LCopy(4,[.False.],0,Tr,1)
*
            IfG(0)=.True.
            IfG(1)=.True.
            IfG(2)=.False.
            IfG(3)=.False.
            Call LCopy(12,[.False.],0,JfGrd,1)
*
*           Compute integrals with the Rys quadrature.
*
            nDiff=2
            mRys=(la+lb+2+nDiff+nOrdOp)/2
            Eta=One
            EInv=One
            nFinal=0
            Call Rysg2(iAnga,mRys,nZeta,
     &                 Array(ipA),Array(ipB),[One],[One],
     &                 Zeta,ZInv,nZeta,[Eta],[EInv],1,
     &                 P,nZeta,TC,1,Coori,Coori,CoorAC,
     &                 Array(nip),nArray,
     &                 TNAI1,Fake,XCff2D,
     &                 Array(ipDAO),nDAO*nElem(nOrdOp),
     &                 Hess,nHess,
     &                 JfGrd,JndGrd,
     &                 JfHss,JndHss,mOp,iuvwx,IfG,
     &                 nFinal,Index,.False.,.True.,Tr)
*
*           Call RecPrt(' In PCMHss:Hess',' ',Hess,nHess,1)
         End Do  ! End loop over DCRs
*
111      Continue
      End Do     ! End loop over centers in the external field
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(Final)
        Call Unused_integer(nHer)
        Call Unused_real_array(Ccoor)
        Call Unused_integer_array(lOper)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Roland Lindh                                     *
!***********************************************************************

subroutine sspp(EFInt,Zeta,ZInv,nZeta,P,lP,rKappAB,A,B,Eta,EInv,nEta,Q,lQ,rKappCD,C,D,CoorAC,TMax,iPntr,nPntr,x0,nMax,CW6,CW5,CW4, &
                CW3,CW2,CW1,CW0,CR6,CR5,CR4,CR3,CR2,CR1,CR0,ddx,HerW,HerR2,IsChi,ChiI2)
!***********************************************************************
!                                                                      *
! Object: to compute the primitive integrals of type (ss|pp).          *
!                                                                      *
!  Author:    Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN. 1994                                    *
!***********************************************************************

use Constants, only: Zero, One, Ten, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, lP, nEta, lQ, nPntr, iPntr(nPntr), nMax, IsChi
real(kind=wp), intent(out) :: EFInt(nZeta,nEta,9)
real(kind=wp), intent(in) :: Zeta(nZeta), ZInv(nZeta), P(lP,3), rKappAB(nZeta), A(3), B(3), Eta(nEta), EInv(nEta), Q(lQ,3), &
                             rKappCD(nEta), C(3), D(3), CoorAC(3,2), TMax, x0(nMax), CW6(nMax,2), CW5(nMax,2), CW4(nMax,2), &
                             CW3(nMax,2), CW2(nMax,2), CW1(nMax,2), CW0(nMax,2), CR6(nMax,2), CR5(nMax,2), CR4(nMax,2), &
                             CR3(nMax,2), CR2(nMax,2), CR1(nMax,2), CR0(nMax,2), ddx, HerW(2), HerR2(2), ChiI2
integer(kind=iwp) :: iEta, iZeta, n
real(kind=wp) :: ai, B011, B012, dddx, PQ2, PQx, PQy, PQz, PreFct, QCPQx1, QCPQx2, QCPQy1, QCPQy2, QCPQz1, QCPQz2, r1, r2, rho, &
                 si, T, w1, w2, x011, x012, x021, x022, xdInv, y011, y012, y021, y022, z, z011, z012, z021, z022, ZEInv, Zu21, Zu22
logical(kind=iwp) :: ABeqCD
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(ZInv)

xdInv = One/ddx
dddx = ddx/Ten+ddx

ABeqCD = EQ(A,B) .and. EQ(A,C) .and. EQ(A,D)

if (ABeqCD) then

  ! AAAA case

  z = -x0(1)
  w1 = (((((CW6(1,1)*z+CW5(1,1))*z+CW4(1,1))*z+CW3(1,1))*z+CW2(1,1))*z+CW1(1,1))*z+Cw0(1,1)
  w2 = (((((CW6(1,2)*z+CW5(1,2))*z+CW4(1,2))*z+CW3(1,2))*z+CW2(1,2))*z+CW1(1,2))*z+Cw0(1,2)
  r1 = (((((CR6(1,1)*z+CR5(1,1))*z+CR4(1,1))*z+CR3(1,1))*z+CR2(1,1))*z+CR1(1,1))*z+CR0(1,1)
  r2 = (((((CR6(1,2)*z+CR5(1,2))*z+CR4(1,2))*z+CR3(1,2))*z+CR2(1,2))*z+CR1(1,2))*z+CR0(1,2)
  do iEta=1,nEta
    do iZeta=1,nZeta
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      rho = Eta(iEta)*(Zeta(iZeta)*ZEInv)
      Zu21 = r1*(Zeta(iZeta)*ZEInv)
      Zu22 = r2*(Zeta(iZeta)*ZEInv)
      B011 = (Half-Half*Zu21)*EInv(iEta)
      B012 = (Half-Half*Zu22)*EInv(iEta)
      PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)
      EFInt(iZeta,iEta,1) = PreFct*(B011*w1+B012*w2)
      EFInt(iZeta,iEta,2) = Zero
      EFInt(iZeta,iEta,3) = Zero
      EFInt(iZeta,iEta,4) = PreFct*(B011*w1+B012*w2)
      EFInt(iZeta,iEta,5) = Zero
      EFInt(iZeta,iEta,6) = PreFct*(B011*w1+B012*w2)
    end do
  end do

else if (EQ(A,B) .and. (.not. EQ(C,D))) then

  ! AACD case

  do iEta=1,nEta
    do iZeta=1,nZeta
      PQx = CoorAC(1,1)-Q(iEta,1)
      PQy = CoorAC(2,1)-Q(iEta,2)
      PQz = CoorAC(3,1)-Q(iEta,3)
      PQ2 = (PQx**2+PQy**2+PQz**2)
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      rho = Eta(iEta)*(Zeta(iZeta)*ZEInv)
      T = rho*PQ2
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w1 = (((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
        w2 = (((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
        r1 = (((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
        r2 = (((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
      else
        ai = One/T
        si = sqrt(ai)
        w1 = HerW(1)*si
        w2 = HerW(2)*si
        r1 = HerR2(1)*ai
        r2 = HerR2(2)*ai
      end if
      Zu21 = r1*(Zeta(iZeta)*ZEInv)
      Zu22 = r2*(Zeta(iZeta)*ZEInv)
      QCPQx1 = (Q(iEta,1)-CoorAC(1,2))+Zu21*PQx
      QCPQx2 = (Q(iEta,1)-CoorAC(1,2))+Zu22*PQx
      QCPQy1 = (Q(iEta,2)-CoorAC(2,2))+Zu21*PQy
      QCPQy2 = (Q(iEta,2)-CoorAC(2,2))+Zu22*PQy
      QCPQz1 = (Q(iEta,3)-CoorAC(3,2))+Zu21*PQz
      QCPQz2 = (Q(iEta,3)-CoorAC(3,2))+Zu22*PQz
      B011 = (Half-Half*Zu21)*EInv(iEta)
      B012 = (Half-Half*Zu22)*EInv(iEta)
      x011 = QCPQx1
      x012 = QCPQx2
      x021 = QCPQx1*x011+B011
      x022 = QCPQx2*x012+B012
      y011 = QCPQy1
      y012 = QCPQy2
      y021 = QCPQy1*y011+B011
      y022 = QCPQy2*y012+B012
      z011 = QCPQz1*w1
      z012 = QCPQz2*w2
      z021 = QCPQz1*z011+B011*w1
      z022 = QCPQz2*z012+B012*w2
      PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)
      EFInt(iZeta,iEta,1) = PreFct*(x011*w1+x012*w2)
      EFInt(iZeta,iEta,2) = PreFct*(y011*w1+y012*w2)
      EFInt(iZeta,iEta,3) = PreFct*(z011+z012)
      EFInt(iZeta,iEta,4) = PreFct*(x021*w1+x022*w2)
      EFInt(iZeta,iEta,5) = PreFct*(x011*y011*w1+x012*y012*w2)
      EFInt(iZeta,iEta,6) = PreFct*(x011*z011+x012*z012)
      EFInt(iZeta,iEta,7) = PreFct*(y021*w1+y022*w2)
      EFInt(iZeta,iEta,8) = PreFct*(y011*z011+y012*z012)
      EFInt(iZeta,iEta,9) = PreFct*(z021+z022)
    end do
  end do

else if ((.not. EQ(A,B)) .and. EQ(C,D)) then

  ! ABCC case

  do iEta=1,nEta
    do iZeta=1,nZeta
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      rho = Eta(iEta)*(Zeta(iZeta)*ZEInv)
      PQx = P(iZeta,1)-CoorAC(1,2)
      PQy = P(iZeta,2)-CoorAC(2,2)
      PQz = P(iZeta,3)-CoorAC(3,2)
      T = rho*(PQx**2+PQy**2+PQz**2)
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w1 = (((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
        w2 = (((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
        r1 = (((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
        r2 = (((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
      else
        ai = One/T
        si = sqrt(ai)
        w1 = HerW(1)*si
        w2 = HerW(2)*si
        r1 = HerR2(1)*ai
        r2 = HerR2(2)*ai
      end if
      Zu21 = r1*(Zeta(iZeta)*ZEInv)
      Zu22 = r2*(Zeta(iZeta)*ZEInv)
      QCPQx1 = Zu21*PQx
      QCPQx2 = Zu22*PQx
      QCPQy1 = Zu21*PQy
      QCPQy2 = Zu22*PQy
      QCPQz1 = Zu21*PQz
      QCPQz2 = Zu22*PQz
      B011 = (Half-Half*Zu21)*EInv(iEta)
      B012 = (Half-Half*Zu22)*EInv(iEta)
      x011 = QCPQx1
      x012 = QCPQx2
      x021 = QCPQx1*x011+B011
      x022 = QCPQx2*x012+B012
      y011 = QCPQy1
      y012 = QCPQy2
      y021 = QCPQy1*y011+B011
      y022 = QCPQy2*y012+B012
      z011 = QCPQz1*w1
      z012 = QCPQz2*w2
      z021 = QCPQz1*z011+B011*w1
      z022 = QCPQz2*z012+B012*w2
      PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)
      EFInt(iZeta,iEta,1) = PreFct*(x021*w1+x022*w2)
      EFInt(iZeta,iEta,2) = PreFct*(x011*y011*w1+x012*y012*w2)
      EFInt(iZeta,iEta,3) = PreFct*(x011*z011+x012*z012)
      EFInt(iZeta,iEta,4) = PreFct*(y021*w1+y022*w2)
      EFInt(iZeta,iEta,5) = PreFct*(y011*z011+y012*z012)
      EFInt(iZeta,iEta,6) = PreFct*(z021+z022)
    end do
  end do

else if (EQ(A,B) .and. EQ(C,D)) then

  ! AACC case

  PQx = CoorAC(1,1)-CoorAC(1,2)
  PQy = CoorAC(2,1)-CoorAC(2,2)
  PQz = CoorAC(3,1)-CoorAC(3,2)
  PQ2 = (PQx**2+PQy**2+PQz**2)
  do iEta=1,nEta
    do iZeta=1,nZeta
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      rho = Eta(iEta)*(Zeta(iZeta)*ZEInv)
      T = rho*PQ2
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w1 = (((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
        w2 = (((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
        r1 = (((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
        r2 = (((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
      else
        ai = One/T
        si = sqrt(ai)
        w1 = HerW(1)*si
        w2 = HerW(2)*si
        r1 = HerR2(1)*ai
        r2 = HerR2(2)*ai
      end if
      Zu21 = r1*(Zeta(iZeta)*ZEInv)
      Zu22 = r2*(Zeta(iZeta)*ZEInv)
      QCPQx1 = Zu21*PQx
      QCPQx2 = Zu22*PQx
      QCPQy1 = Zu21*PQy
      QCPQy2 = Zu22*PQy
      QCPQz1 = Zu21*PQz
      QCPQz2 = Zu22*PQz
      B011 = (Half-Half*Zu21)*EInv(iEta)
      B012 = (Half-Half*Zu22)*EInv(iEta)
      x011 = QCPQx1
      x012 = QCPQx2
      x021 = QCPQx1*x011+B011
      x022 = QCPQx2*x012+B012
      y011 = QCPQy1
      y012 = QCPQy2
      y021 = QCPQy1*y011+B011
      y022 = QCPQy2*y012+B012
      z011 = QCPQz1*w1
      z012 = QCPQz2*w2
      z021 = QCPQz1*z011+B011*w1
      z022 = QCPQz2*z012+B012*w2
      PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)
      EFInt(iZeta,iEta,1) = PreFct*(x021*w1+x022*w2)
      EFInt(iZeta,iEta,2) = PreFct*(x011*y011*w1+x012*y012*w2)
      EFInt(iZeta,iEta,3) = PreFct*(x011*z011+x012*z012)
      EFInt(iZeta,iEta,4) = PreFct*(y021*w1+y022*w2)
      EFInt(iZeta,iEta,5) = PreFct*(y011*z011+y012*z012)
      EFInt(iZeta,iEta,6) = PreFct*(z021+z022)
    end do
  end do

else

  ! ABCD case

  do iEta=1,nEta
    do iZeta=1,nZeta
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      rho = Eta(iEta)*(Zeta(iZeta)*ZEInv)
      PQx = P(iZeta,1)-Q(iEta,1)
      PQy = P(iZeta,2)-Q(iEta,2)
      PQz = P(iZeta,3)-Q(iEta,3)
      T = rho*(PQx**2+PQy**2+PQz**2)
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w1 = (((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
        w2 = (((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
        r1 = (((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
        r2 = (((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
      else
        ai = One/T
        si = sqrt(ai)
        w1 = HerW(1)*si
        w2 = HerW(2)*si
        r1 = HerR2(1)*ai
        r2 = HerR2(2)*ai
      end if
      Zu21 = r1*(Zeta(iZeta)*ZEInv)
      Zu22 = r2*(Zeta(iZeta)*ZEInv)
      QCPQx1 = (Q(iEta,1)-CoorAC(1,2))+Zu21*PQx
      QCPQx2 = (Q(iEta,1)-CoorAC(1,2))+Zu22*PQx
      QCPQy1 = (Q(iEta,2)-CoorAC(2,2))+Zu21*PQy
      QCPQy2 = (Q(iEta,2)-CoorAC(2,2))+Zu22*PQy
      QCPQz1 = (Q(iEta,3)-CoorAC(3,2))+Zu21*PQz
      QCPQz2 = (Q(iEta,3)-CoorAC(3,2))+Zu22*PQz
      B011 = (Half-Half*Zu21)*EInv(iEta)
      B012 = (Half-Half*Zu22)*EInv(iEta)
      x011 = QCPQx1
      x012 = QCPQx2
      x021 = QCPQx1*x011+B011
      x022 = QCPQx2*x012+B012
      y011 = QCPQy1
      y012 = QCPQy2
      y021 = QCPQy1*y011+B011
      y022 = QCPQy2*y012+B012
      z011 = QCPQz1*w1
      z012 = QCPQz2*w2
      z021 = QCPQz1*z011+B011*w1
      z022 = QCPQz2*z012+B012*w2
      PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)
      EFInt(iZeta,iEta,1) = PreFct*(x011*w1+x012*w2)
      EFInt(iZeta,iEta,2) = PreFct*(y011*w1+y012*w2)
      EFInt(iZeta,iEta,3) = PreFct*(z011+z012)
      EFInt(iZeta,iEta,4) = PreFct*(x021*w1+x022*w2)
      EFInt(iZeta,iEta,5) = PreFct*(x011*y011*w1+x012*y012*w2)
      EFInt(iZeta,iEta,6) = PreFct*(x011*z011+x012*z012)
      EFInt(iZeta,iEta,7) = PreFct*(y021*w1+y022*w2)
      EFInt(iZeta,iEta,8) = PreFct*(y011*z011+y012*z012)
      EFInt(iZeta,iEta,9) = PreFct*(z021+z022)
    end do
  end do

end if

return

end subroutine sspp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReaW3hlp2(Ww,Wx,dima,dimb,no,LunName,LunAux)
! this routine does:
! reconstruct  Ww(a",be',b,i)  for aSGrp=beSGrp
! from (a">=be"|b,i) records in V3 file LunName

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, no, LunAux
real(kind=wp), intent(out) :: Ww(dima,dima,dimb,no), Wx(nTri_Elem(dima)*dimb*no)
character(len=8) :: LunName
integer(kind=iwp) :: a, abebi, b, i, length

! read block (a">=be"|b"_i)
length = no*nTri_Elem(dima)*dimb
!open(unit=LunAux,file=LunName,form='unformatted')
call Molcas_BinaryOpen_Vanilla(LunAux,LunName)
call rea_chcc(LunAux,length,Wx)
!mp Wx(1:length) = Zero
close(LunAux)

! Expand and Set Ww(a",be",b",i) <- Wx(a">=be"|b",i)
abebi = 0

do i=1,no
  do b=1,dimb
    do a=1,dima
      Ww(a,1:a-1,b,i) = Wx(abebi+1:abebi+a-1)
      Ww(1:a,a,b,i) = Wx(abebi+1:abebi+a)
      abebi = abebi+a
    end do
  end do
end do

return

end subroutine ReaW3hlp2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Valera Veryazov                                  *
************************************************************************
        subroutine read_xbas(LuRd,iglobal,nxbas,xb_label,xb_bas,ierr)
        character *(*) xb_label(*)
        character *(*) xb_bas(*)
        character*128 Line
        icount=0
        iglobal=0
        ierr=0
100     read(LuRd,'(a)',err=300,end=300) Line
        if(Line.eq.' '.or.Line(1:3).eq.'END'.or.Line(1:3).eq.'end'
     &        .or. Line(1:3).eq.'End') goto 200
        i=index(Line,'.')
        if(i.eq.0) then
          if(icount.eq.0) then
            iglobal=1
            xb_bas(1)=Line
            goto 200
          else
            goto 300
          endif
        endif
        icount=icount+1
        nxbas=icount
        xb_label(nxbas)=Line(1:i-1)
        xb_bas(nxbas)=Line(i+1:)
        goto 100
200    continue
       return
300    ierr=1
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_FindSignificantAtomPairs(irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: find significant atom pairs based on Cauchy-Schwarz
C              screening. The integral diagonal is computed as a
C              biproduct. Results are stored in ldf_atom_pair_info.fh
C
C     Return codes: 0 for success, 1 otherwise.
C
      Implicit None
      Integer irc
#include "localdf.fh"
#include "WrkSpc.fh"

      Character*28 SecNam
      Parameter (SecNam='LDF_FindSignificantAtomPairs')

      Integer nRSAP
      Integer ip_RSAP, l_RSAP

      Real*8 tau
      Real*8 CutInt_, CutInt

      ! Init return code
      irc=0

      ! Set CutInt so low that all diagonals are computed
      ! Save old value (in order to reset it after diag calc)
      Call LDF_GetCutInt(CutInt_)
      CutInt=1.0d-99
      Call LDF_SetCutInt(CutInt)

      ! Get rough list of significant atom pairs based on Cauchy-Schwarz
      ! and estimated integral diagonals.
      tau=Thr_LDFPrescreen**2
      nRSAP=0
      ip_RSAP=0
      Call LDF_RoughSAP(tau,nRSAP,ip_RSAP,irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': LDF_RoughSAP returned code',irc
         irc=1
         Return
      End If

      ! Set up list of significant atom pairs, computing integral
      ! diagonals as a biproduct.
      tau=Thr_LDFPrescreen**2
      Call LDF_SAP(tau,nRSAP,iWork(ip_RSAP),irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': LDF_SAP returned code',irc
         irc=1
         Return
      End If

      ! Deallocate rough list of significant atom pairs
      l_RSAP=2*nRSAP
      Call GetMem('LDF_AP','Free','Inte',ip_RSAP,l_RSAP)

      ! Reset CutInt
      Call LDF_SetCutInt(CutInt_)

      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_RoughSAP(tau,nAtomPair,ip_AtomPair,irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Get rough estimate of significant atom pairs.
C
      Implicit None
      Real*8  tau ! screening threshold
      Integer nAtomPair
      Integer ip_AtomPair
      Integer irc
#include "WrkSpc.fh"

      Integer nShell, nAtom
      Integer ip_Dmax, l_Dmax
      Integer ip_Tmax, l_Tmax
      Integer nShell_i, nShell_j
      Integer ip_i, ip_j
      Integer iAtom, jAtom
      Integer iS, jS
      Integer ijAtom, jiAtom
      Integer l_AtomPair

      Real*8 Dmax_All

      Integer  LDF_nShell, LDF_nAtom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nShell, LDF_nAtom, LDF_nShell_Atom, LDF_lShell_Atom

      Integer i, j
      Integer iShell_i, iShell_j
      Real*8  Tmax, Dmax
      iShell_i(i)=iWork(ip_i-1+i)
      iShell_j(i)=iWork(ip_j-1+i)
      Tmax(i,j)=Work(ip_Tmax-1+nShell*(j-1)+i)
      Dmax(i,j)=Work(ip_Dmax-1+nAtom*(j-1)+i)

      ! Init return code
      irc=0

      ! Get total number of valence shells
      nShell=LDF_nShell()

      ! Get total number of atoms
      nAtom=LDF_nAtom()

      ! Allocate atom pair diagonal
      l_Dmax=nAtom*nAtom
      Call GetMem('LDF_Dmax','Allo','Real',ip_Dmax,l_Dmax)

      ! Allocate and get estimated shell pair diagonals
      l_Tmax=nShell*nShell
      Call GetMem('LDF_Tmax','Allo','Real',ip_Tmax,l_Tmax)
      Call Shell_MxSchwz(nShell,Work(ip_Tmax))

      ! Find max for each atom pair
      Call FZero(Work(ip_Dmax),l_Dmax)
      Do jAtom=1,nAtom
         nShell_j=LDF_nShell_Atom(jAtom)
         ip_j=LDF_lShell_Atom(jAtom)
         ijAtom=ip_Dmax-1+nAtom*(jAtom-1)+jAtom
         Do jS=1,nShell_j
            Do iS=jS,nShell_j
               Work(ijAtom)=max(Work(ijAtom),
     &                          Tmax(iShell_j(iS),iShell_j(jS)))
            End Do
         End Do
         Do iAtom=jAtom+1,nAtom
            nShell_i=LDF_nShell_Atom(iAtom)
            ip_i=LDF_lShell_Atom(iAtom)
            ijAtom=ip_Dmax-1+nAtom*(jAtom-1)+iAtom
            Do jS=1,nShell_j
               Do iS=1,nShell_i
                  Work(ijAtom)=max(Work(ijAtom),
     &                             Tmax(iShell_i(iS),iShell_j(jS)))
               End Do
            End Do
            jiAtom=ip_Dmax-1+nAtom*(iAtom-1)+jAtom
            Work(jiAtom)=Work(ijAtom)
         End Do
      End Do

      ! Deallocate shell pair diagonal
      Call GetMem('LDF_Tmax','Free','Real',ip_Tmax,l_Tmax)

      ! Find global max among atom pairs
      Dmax_All=Dmax(1,1)
      Do iAtom=2,nAtom
         Do jAtom=1,iAtom
            Dmax_All=max(Dmax_All,Dmax(iAtom,jAtom))
         End Do
      End Do

      ! Compute nAtomPair
      nAtomPair=0
      Do iAtom=1,nAtom
         Do jAtom=1,iAtom
            If (Dmax_All*Dmax(iAtom,jAtom) .gt. tau) Then
               nAtomPair=nAtomPair+1
            End If
         End Do
      End Do

      ! Allocate atom pair list
      l_AtomPair=2*nAtomPair
      Call GetMem('LDF_AP','Allo','Inte',ip_AtomPair,l_AtomPair)

      ! Set atom pair list
      ijAtom=0
      Do iAtom=1,nAtom
         Do jAtom=1,iAtom
            If (Dmax_All*Dmax(iAtom,jAtom) .gt. tau) Then
               iWork(ip_AtomPair+2*ijAtom)=iAtom
               iWork(ip_AtomPair+2*ijAtom+1)=jAtom
               ijAtom=ijAtom+1
            End If
         End Do
      End Do

      ! Deallocate atom pair diagonal
      Call GetMem('LDF_Dmax','Free','Real',ip_Dmax,l_Dmax)

      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_SAP(tau,nRSAP,ID_RSAP,irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Get significant atom pairs.
C
      Implicit None
      Real*8  tau
      Integer nRSAP
      Integer ID_RSAP(2,nRSAP)
      Integer irc
#include "WrkSpc.fh"

      Integer ip_TmpDiag, l_TmpDiag
      Integer iRSAP
      Integer iAtom, jAtom
      Integer ni, nj

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      ! Init return code
      irc=0

      ! Return if nothing to do
      If (nRSAP.lt.1) Return

      ! Allocate tmp memory for diagonal
      l_TmpDiag=0
      Do iRSAP=1,nRSAP
         iAtom=ID_RSAP(1,iRSAP)
         jAtom=ID_RSAP(2,iRSAP)
         ni=LDF_nBas_Atom(iAtom)
         If (iAtom.eq.jAtom) Then
            l_TmpDiag=l_TmpDiag+ni*(ni+1)/2
         Else If (iAtom.gt.jAtom) Then
            nj=LDF_nBas_Atom(jAtom)
            l_TmpDiag=l_TmpDiag+ni*nj
         Else
            Call WarningMessage(2,'LDF_SAP: iAtom<jAtom')
            Call LDF_Quit(1)
         End If
      End Do
      Call GetMem('TmpDiag','Allo','Real',ip_TmpDiag,l_TmpDiag)

      ! Compute diagonal
      Call LDF_ComputeRSAPDiagonal(nRSAP,ID_RSAP,l_TmpDiag,
     &                             Work(ip_TmpDiag))

      ! Set significant atom pairs in ldf_atom_pair_info.fh
      ! Store pointers to diagonal blocks
      Call LDF_SetAPI(nRSAP,ID_RSAP,l_TmpDiag,Work(ip_TmpDiag))

      ! Deallocate TmpDiag
      Call GetMem('TmpDiag','Free','Real',ip_TmpDiag,l_TmpDiag)

c Avoid unused argument warnings
      If (.False.) Call Unused_real(tau)
      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_ComputeRSAPDiagonal(nRSAP,ID_RSAP,l_Diag,Diag)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Compute diagonal for atom pairs listed in ID_RSAP.
C
      Implicit None
      Integer nRSAP
      Integer ID_RSAP(2,nRSAP)
      Integer l_Diag
      Real*8  Diag(l_Diag)
#include "WrkSpc.fh"
#include "localdf_mem.fh"

      Integer ip_iOff, l_iOff
      Integer ip_SewWrk, l_SewWrk
      Integer l, ID
      Integer iRSAP
      Integer iAtom, jAtom
      Integer ni, nj

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Logical  Rsv_Tsk
      External Rsv_Tsk

      Integer i
      Integer iOff
      iOff(i)=iWork(ip_iOff-1+i)

      ! Compute diagonal offset array
      l_iOff=nRSAP+1
      Call GetMem('iOff','Allo','Inte',ip_iOff,l_iOff)
      l=1
      Do iRSAP=1,nRSAP
         iWork(ip_iOff-1+iRSAP)=l
         iAtom=ID_RSAP(1,iRSAP)
         jAtom=ID_RSAP(2,iRSAP)
         ni=LDF_nBas_Atom(iAtom)
         If (iAtom.eq.jAtom) Then
            l=l+ni*(ni+1)/2
         Else
            nj=LDF_nBas_Atom(jAtom)
            l=l+ni*nj
         End If
      End Do
      iWork(ip_iOff+nRSAP)=l
#if defined (_DEBUGPRINT_)
      If (l_Diag.lt.(iOff(nRSAP+1)-1)) Then
         Call WarningMessage(2,
     &                   'LDF_ComputeRSAPDiagonal: dimension mismatch!')
         Call LDF_Quit(1)
      End If
#endif

      ! Compute diagonal integrals (parallelzation over atom pairs)
      Call Init_Tsk(ID,nRSAP)
      Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
      l_SewWrk = min(l_SewWrk,MaxLDFSew)
      Call xSetMem_Ints(l_SewWrk)
      Call FZero(Diag,iOff(nRSAP+1)-1)
      Do While (Rsv_Tsk(ID,iRSAP))
         l=iOff(iRSAP+1)-iOff(iRSAP)
         Call LDF_ComputeAPDiagonal(ID_RSAP(1,iRSAP),
     &                              ID_RSAP(2,iRSAP),
     &                              l,Diag(iOff(iRSAP)))
      End Do
      Call GAdGOP(Diag,iOff(nRSAP+1)-1,'+')
      Call xRlsMem_Ints()
      Call Free_Tsk(ID)

      ! Deallocation
      Call GetMem('iOff','Free','Inte',ip_iOff,l_iOff)

      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_ComputeAPDiagonal(iAtom,jAtom,l_Diag,Diag)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Compute diagonal for atom pair iAtom,jAtom
C
      Implicit None
      Integer iAtom, jAtom
      Integer l_Diag
      Real*8  Diag(l_Diag)
#include "WrkSpc.fh"

      Character*21 SecNam
      Parameter (SecNam='LDF_ComputeAPDiagonal')

      Integer iOff, l
      Integer iSi, iSj
      Integer ni, nj
      Integer iS, jS
      Integer ip_i, ip_j

      Integer  LDF_lShell_Atom, LDF_nShell_Atom, LDF_nBasSh_Atom
      External LDF_lShell_Atom, LDF_nShell_Atom, LDF_nBasSh_Atom

      Integer i
      Integer iShell_i, iShell_j
      iShell_i(i)=iWork(ip_i-1+i)
      iShell_j(i)=iWork(ip_j-1+i)

      ip_i=LDF_lShell_Atom(iAtom)
      ip_j=LDF_lShell_Atom(jAtom)

      iOff=1
      If (iAtom.eq.jAtom) Then
         Do iSi=1,LDF_nShell_Atom(iAtom)
            ni=LDF_nBasSh_Atom(iSi,iAtom)
            iS=iShell_i(iSi)
            Do iSj=1,iSi-1
               nj=LDF_nBasSh_Atom(iSj,iAtom)
               jS=iShell_i(iSj)
               l=ni*nj
               Call LDF_CAPD(iS,jS,l,Diag(iOff))
               iOff=iOff+l
            End Do
            l=ni*(ni+1)/2
            Call LDF_CAPD(iS,iS,l,Diag(iOff))
            iOff=iOff+l
         End Do
      Else If (iAtom.gt.jAtom) Then
         Do iSj=1,LDF_nShell_Atom(jAtom)
            nj=LDF_nBasSh_Atom(iSj,jAtom)
            jS=iShell_j(iSj)
            Do iSi=1,LDF_nShell_Atom(iAtom)
               ni=LDF_nBasSh_Atom(iSi,iAtom)
               iS=iShell_i(iSi)
               l=ni*nj
               Call LDF_CAPD(iS,jS,l,Diag(iOff))
               iOff=iOff+l
            End Do
         End Do
      Else
         Call WarningMessage(2,SecNam//': iAtom<jAtom')
         Call LDF_Quit(1)
      End If

      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_CAPD(iS,jS,l_Diag,Diag)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: compute diagonal (iS jS | iS jS)
C
      Implicit None
      Integer iS, jS
      Integer l_Diag
      Real*8  Diag(l_Diag)
#include "localdf_int.fh"

      External Integral_WrOut_LDF_Diag

      SHA=iS
      SHB=jS
      SHC=iS
      SHD=jS

      Call Eval_IJKL(iS,jS,iS,jS,Diag,l_Diag,Integral_WrOut_LDF_Diag)

      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_SetAPI(nRSAP,ID_RSAP,l_TmpDiag,TmpDiag)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: set atom pair info
C
C     - tbp, March 2011: use block matrix for diagonals (i.e. diagonal
C                        blocks no longer stored in triangular format)
C
      Implicit None
      Integer nRSAP
      Integer ID_RSAP(2,nRSAP)
      Integer l_TmpDiag
      Real*8  TmpDiag(l_TmpDiag)
#include "localdf.fh"
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      Integer iAtomPair
      Integer uv
      Integer ip_LT, l_LT
      Integer ip_Q, l_Q
      Real*8  Mx
#endif
      Integer i0, ii, l
      Integer iRSAP
      Integer iAtom, jAtom
      Integer ip_APDmax, l_APDmax
      Integer ni, nj
      Integer ip

      Real*8 Dmax_All, tau

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Integer i

C     Count significant atom pairs.
C     =============================

      ! Set screening threshold
      tau=Thr_LDFPrescreen**2

      ! Allocate atom pair max diag
      l_APDmax=nRSAP
      Call GetMem('APDmax','Allo','Real',ip_APDmax,l_APDmax)

      ! Find max. diagonal, globally and per atom pair
      Dmax_All=-9.9d9
      i0=1
      Do iRSAP=1,nRSAP
         iAtom=ID_RSAP(1,iRSAP)
         jAtom=ID_RSAP(2,iRSAP)
         ni=LDF_nBas_Atom(iAtom)
         If (iAtom.eq.jAtom) Then
            l=ni*(ni+1)/2
         Else If (iAtom.gt.jAtom) Then
            nj=LDF_nBas_Atom(jAtom)
            l=ni*nj
         Else
            Call WarningMessage(2,'LDF_SetAPI: iAtom<jAtom [1]')
            Call LDF_Quit(1)
            l=0
         End If
         ii=ip_APDmax-1+iRSAP
         Work(ii)=TmpDiag(i0)
         Do i=i0+1,i0+l-1
            Work(ii)=max(Work(ii),TmpDiag(i))
         End Do
         Dmax_All=max(Dmax_All,Work(ii))
         i0=i0+l
      End Do

      ! Count atom pairs
      NumberOfAtomPairs=0
      i0=ip_APDmax-1
      Do iRSAP=1,nRSAP
         If ((Dmax_All*Work(i0+iRSAP)).gt.tau) Then
            NumberOfAtomPairs=NumberOfAtomPairs+1
         End If
      End Do

C     Set atom pair info and diagonal blocks.
C     =======================================

      ! Allocate and set AP_Atoms
      l_AP_Atoms=2*NumberOfAtomPairs
      Call GetMem('LDFAPA','Allo','Inte',ip_AP_Atoms,l_AP_Atoms)
      i0=ip_APDmax-1
      i=0
      Do iRSAP=1,nRSAP
         iAtom=ID_RSAP(1,iRSAP)
         jAtom=ID_RSAP(2,iRSAP)
         If ((Dmax_All*Work(i0+iRSAP)).gt.tau) Then
            iWork(ip_AP_Atoms+2*i)=iAtom
            iWork(ip_AP_Atoms+2*i+1)=jAtom
            i=i+1
         End If
      End Do
      If (i.ne.NumberOfAtomPairs) Then
         Call WarningMessage(2,'LDF_SetAPI: i != NumberOfAtomPairs [1]')
         Call LDF_Quit(1)
      End If

      ! Allocate diagonals (as block matrices)
      Call LDF_AllocateBlockMatrix('APD',ip_AP_Diag)
      l_AP_Diag=NumberOfAtomPairs
      Call LDF_AllocateBlockMatrix('APB',ip_AP_DiagBak)
      l_AP_DiagBak=NumberOfAtomPairs

      ! Set diagonals
      i0=ip_APDmax-1
      ii=1
      i=0
      Do iRSAP=1,nRSAP
         iAtom=ID_RSAP(1,iRSAP)
         jAtom=ID_RSAP(2,iRSAP)
         If (iAtom.eq.jAtom) Then
            ni=LDF_nBas_Atom(iAtom)
            l=ni*(ni+1)/2
            If ((Dmax_All*Work(i0+iRSAP)).gt.tau) Then
               ip=iWork(ip_AP_Diag+i)
               Call LDF_LT2Q(iAtom,TmpDiag(ii),Work(ip))
               Call dCopy_(ni**2,Work(ip),1,
     &                          Work(iWork(ip_AP_DiagBak+i)),1)
               i=i+1
            End If
         Else If (iAtom.gt.jAtom) Then
            ni=LDF_nBas_Atom(iAtom)
            nj=LDF_nBas_Atom(jAtom)
            l=ni*nj
            If ((Dmax_All*Work(i0+iRSAP)).gt.tau) Then
               ip=iWork(ip_AP_Diag+i)
               Call dCopy_(l,TmpDiag(ii),1,Work(ip),1)
               ip=iWork(ip_AP_DiagBak+i)
               Call dCopy_(l,TmpDiag(ii),1,Work(ip),1)
               i=i+1
            End If
         Else
            Call WarningMessage(2,'LDF_SetAPI: iAtom<jAtom [2]')
            Call LDF_Quit(1)
            l=0 ! avoid compiler warning
         End If
         ii=ii+l
      End Do
      If (i.ne.NumberOfAtomPairs) Then
         Call WarningMessage(2,'LDF_SetAPI: i != NumberOfAtomPairs [2]')
         Call LDF_Quit(1)
      End If

      ! Deallocate atom pair max diag
      l_APDmax=nRSAP
      Call GetMem('APDmax','Free','Real',ip_APDmax,l_APDmax)

C     Allocate and initialize number of linearly dependent one-center
C     functions and number of two-center functions.
C     ===============================================================

      l_AP_1CLinDep=2*NumberOfAtomPairs
      l_AP_2CFunctions=2*NumberOfAtomPairs
      Call GetMem('AP1CLD','Allo','Inte',ip_AP_1CLinDep,l_AP_1CLinDep)
      Call GetMem('AP2CFN','Allo','Inte',ip_AP_2CFunctions,
     &                                    l_AP_2CFunctions)
      Call iZero(iWork(ip_AP_1CLinDep),l_AP_1CLinDep)
      Call iZero(iWork(ip_AP_2CFunctions),l_AP_2CFunctions)

#if defined (_DEBUGPRINT_)
C     Debug: "unit test" of LDF_Q2LT and LDF_LT2Q
C     ===========================================
      Do iAtomPair=1,NumberOfAtomPairs
         iAtom=iWork(ip_AP_Atoms+2*(iAtomPair-1))
         jAtom=iWork(ip_AP_Atoms+2*(iAtomPair-1)+1)
         If (iAtom.eq.jAtom) Then
            If (LDF_nBas_Atom(iAtom).gt.0) Then
               l_LT=LDF_nBas_Atom(iAtom)*(LDF_nBas_Atom(iAtom)+1)/2
               Call GetMem('LT','Allo','Real',ip_LT,l_LT)
               l_Q=LDF_nBas_Atom(iAtom)**2
               Call GetMem('Q','Allo','Real',ip_Q,l_Q)
               ip=iWork(ip_AP_Diag-1+iAtomPair)
               Call LDF_Q2LT(iAtom,Work(ip),Work(ip_LT))
               Call LDF_LT2Q(iAtom,Work(ip_LT),Work(ip_Q))
               Call dAXPY_(l_Q,-1.0d0,Work(ip),1,Work(ip_Q),1)
               Mx=0.0d0
               Do uv=0,l_Q-1
                  Mx=max(Mx,abs(Work(ip_Q+uv)))
               End Do
               If (Mx.gt.1.0d-14) Then
                  Call WarningMessage(2,
     &                          'LDF_SetAPI: LDF_Q2LT/LDF_LT2Q failure')
                  Write(6,'(A,1P,D20.10)') 'Max asymmetry:',Mx
                  Call LDF_Quit(1)
               End If
               Call GetMem('Q','Free','Real',ip_Q,l_Q)
               Call GetMem('LT','Free','Real',ip_LT,l_LT)
            End If
         End If
      End Do
#endif

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE CI_SELECT(INDOUT,ICAD,IBUFL,L0,L1,L2,L3,
     &                     KBUF,NTPB,NBINS)
      IMPLICIT REAL*8 (A-H,O-Z)
      External Int8, Int2, int1, int4
#include "SysDef.fh"
      DIMENSION INDOUT(*),ICAD(*),IBUFL(*),L0(*),L1(*),L2(*),L3(*)
#include "real_guga.fh"
#include "integ.fh"
#include "files_guga.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
*
      CALL JTIME(IST)
      CALL CI_SELECT_INTERNAL(INDOUT,IBUFL)
      RETURN
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE CI_SELECT_INTERNAL(INDOUT,IBUFL)
      USE ISO_C_BINDING
      INTEGER, TARGET :: INDOUT(*),IBUFL(*)
      REAL*8, POINTER :: dINDOUT(:),dIBUFL(:)
      CALL C_F_POINTER(C_LOC(INDOUT),dINDOUT,[1])
      CALL C_F_POINTER(C_LOC(IBUFL),dIBUFL,[1])
*
      KBUF2=(RTOI+1)*KBUF+2
      ID=0
      DO 5 IREC=1,NBINS
         IBUFL(IREC)=0
         ICAD(IREC)=ID
         INDOUT(ID+KBUF2)=-1
         ID=ID+KBUF2
5     CONTINUE
      II=0
      IID=0
      JJ=0
      JJD=0
      JTYP=0
C     DIAGONAL ELEMENTS
      IADD11=0
      IAD10(3)=IADD10
      IOUT=0
      NMAT=0
      IDIAG=1
      DO 205 M3=1,LN
      DO 200 M4=1,M3
      DO 300 M1=M3,LN
      M2MIN=1
      IF(M1.EQ.M3)M2MIN=M4
      DO 310 M2=M2MIN,M1
      IF(M1.NE.M3.OR.M2.NE.M4)GO TO 310
      IF(M1.EQ.M2)GO TO 310
      NA=ICH(M1)
      NB=ICH(M2)
      IF(NA.GE.NB)GO TO 131
      NSAVE=NA
      NA=NB
      NB=NSAVE
131   NC=ICH(M3)
      ND=ICH(M4)
      IF(NC.GE.ND)GO TO 130
      NSAVE=NC
      NC=ND
      ND=NSAVE
130   IF(NA.GT.NC)GO TO 132
      IF(NA.EQ.NC)GO TO 133
      NSAV1=NA
      NSAV2=NB
      NA=NC
      NB=ND
      NC=NSAV1
      ND=NSAV2
      GO TO 132
133   IF(NB.GT.ND)GO TO 132
      NSAVE=NB
      NB=ND
      ND=NSAVE
132   CALL INT7(ND,NB,NA,IDIAG,dINDOUT,INDOUT,ICAD,IBUFL,KBUF,NTPB)
310   CONTINUE
300   CONTINUE
200   CONTINUE
205   CONTINUE
      CALL AIAI(dINDOUT,INDOUT,ICAD,IBUFL,KBUF,NTPB,NBINS)
      CALL EMPTY(dIBUFL,IBUFL(RtoI*kBuf+1),ICAD,dINDOUT,KBUF,NTPB)
      ICOP1(nCOP+1)=IOUT
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+IOUT
      ICOP1(nCOP+1)=-1
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      WRITE(IW,601)NMAT
601   FORMAT(/6X,'COEFFICIENTS FOR DIAG',I9)
      CALL JTIME(IFIN)
      ITIM=IFIN-IST
      WRITE(IW,701)ITIM
701   FORMAT(6X,'TIME FOR DIAG',I17)
      IAD10(4)=IADD10
      IST=IFIN
      JTYP=1
CFUE start modification
C     IF(IFIRST.EQ.0)CALL AI(JTYP,INDOUT,L0,L1,L2,L3)
      IF(IFIRST.EQ.0) THEN
        CALL AI(JTYP,INDOUT,L0,L1,L2,L3)
      ELSE
        ICOP1(nCOP+1)=0
        CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
        CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
        ICOP1(nCOP+1)=-1
        CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
        CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      END IF
CFUE end modification
      CALL JTIME(IFIN)
      ITIM=IFIN-IST
      WRITE(IW,702)ITIM
702   FORMAT(6X,'TIME FOR ABCI',I17)
      IAD10(5)=IADD10
      IST=IFIN
      IOUT=0
      NMAT=0
      IDIAG=0
      DO 405 M3=1,LN
      NSC=NSM(ICH(M3))
      DO 400 M4=1,M3
      NSD=NSM(ICH(M4))
      NSCD=MUL(NSC,NSD)
      DO 500 M1=M3,LN
      NSA=NSM(ICH(M1))
      NSABC=MUL(NSA,NSCD)
      M2MIN=1
      IF(M1.EQ.M3)M2MIN=M4
      DO 510 M2=M2MIN,M1
      NA=ICH(M1)
      NB=ICH(M2)
      NSB=NSM(NB)
      IF(NSB.NE.NSABC)GO TO 510
      IF(NA.GE.NB)GO TO 231
      NSAVE=NA
      NA=NB
      NB=NSAVE
231   NC=ICH(M3)
      ND=ICH(M4)
      IF(NC.GE.ND)GO TO 230
      NSAVE=NC
      NC=ND
      ND=NSAVE
230   IF(NA.GT.NC)GO TO 232
      IF(NA.EQ.NC)GO TO 233
      NSAV1=NA
      NSAV2=NB
      NA=NC
      NB=ND
      NC=NSAV1
      ND=NSAV2
      GO TO 232
233   IF(NB.GT.ND)GO TO 232
      NSAVE=NB
      NB=ND
      ND=NSAVE
232   IOUT=IOUT+1
      ICOP1(IOUT)=0
      IF(IOUT.LT.NBUF)GO TO 460
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
460   IOUT=IOUT+1
*      IND1=NA+2**8*NB
*      IND2=IND1+2**16*NC
*      ICOP1(IOUT)=IND2+2**24*ND
      IND1=IOR(NA,ISHFT(NB,8))
      IND2=IOR(IND1,ISHFT(NC,16))
      ICOP1(IOUT)=IOR(IND2,ISHFT(ND,24))
      IF(IOUT.LT.NBUF)GO TO 511
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
511   IF(NA.NE.NC)GO TO 520
      IF(NB.EQ.ND)GO TO 525
      IF(NB.EQ.NC)GO TO 524
      DO 101 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      CALL INT61(ND,NB,NA,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
      CALL INT62(ND,NB,NA,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
101   CONTINUE
      GO TO 510
524   DO 108 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      CALL INT9(ND,NC,NA,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
108   CONTINUE
      GO TO 510
525   IF(NA.EQ.NB)GO TO 510
      CALL INT7(ND,NB,NA,IDIAG,dINDOUT,INDOUT,ICAD,IBUFL,
     *KBUF,NTPB)
      GO TO 510
520   IF(NB.NE.ND)GO TO 530
      IF(NC.EQ.ND)GO TO 529
      CALL INT5(ND,NC,NA)
      GO TO 510
529   DO 109 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      CALL INT9(ND,NC,NA,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
109   CONTINUE
      GO TO 510
530   IF(NB.NE.NC)GO TO 535
      DO 102 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      CALL INT4(ND,NC,NA,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
102   CONTINUE
      GO TO 510
535   IF(NA.EQ.NB)GO TO 546
      IF(NC.NE.ND)GO TO 547
      DO 103 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      CALL INT8(NB,NA,NC,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
103   CONTINUE
      GO TO 510
546   IF(NC.EQ.ND)GO TO 510
      DO 104 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      CALL INT8(ND,NC,NA,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
104   CONTINUE
      GO TO 510
547   IF(NB.GT.ND)GO TO 540
      DO 105 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      CALL INT3(ND,NC,NB,NA,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
105   CONTINUE
      GO TO 510
540   IF(NB.GT.NC)GO TO 545
      DO 106 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      CALL INT2(ND,NC,NB,NA,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
106   CONTINUE
      GO TO 510
545   DO 107 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      CALL INT1(ND,NC,NB,NA,IT1,IT2,II,IID,JJ,JJD,JTYP,INDOUT,
     *L0,L1,L2,L3)
107   CONTINUE
510   CONTINUE
500   CONTINUE
400   CONTINUE
405   CONTINUE
      ICOP1(nCOP+1)=IOUT
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+IOUT
      ICOP1(nCOP+1)=-1
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      WRITE(IW,600)NMAT
600   FORMAT(/6X,'COEFFICIENTS FOR IJKL',I9)
      CALL JTIME(IFIN)
      ITIM=IFIN-IST
      WRITE(IW,703)ITIM
703   FORMAT(6X,'TIME FOR IJKL',I17)
      IAD10(6)=IADD10
      IST=IFIN
      NMAT=0
      CALL AIBJ(L0,L1,L2,L3,INDOUT)
      CALL JTIME(IFIN)
      ITIM=IFIN-IST
      WRITE(IW,704)ITIM
704   FORMAT(6X,'TIME FOR AIBJ',I17)
      IAD10(7)=IADD10
      IST=IFIN
      CALL AIJK(INDOUT,L0,L1,L2,L3)
      CALL JTIME(IFIN)
      ITIM=IFIN-IST
      WRITE(IW,705)ITIM
705   FORMAT(6X,'TIME FOR AIJK',I17)
      IAD10(8)=IADD10
      IST=IFIN
      CALL ONEEL_GUGA()
      IAD10(9)=IADD10
      JTYP=0
      CALL AI(JTYP,INDOUT,L0,L1,L2,L3)
      CALL JTIME(IFIN)
      ITIM=IFIN-IST
      WRITE(IW,706)ITIM
706   FORMAT(6X,'TIME FOR ONEEL',I16)
      NULLIFY(dINDOUT,dIBUFL)
      RETURN
      END SUBROUTINE CI_SELECT_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module MkGUGA_mod

! This module contains a single function, to avoid explicit interfaces

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
private

public :: MKGUGA

contains

subroutine MKGUGA(SGS,CIS)
! PURPOSE: MAKE THE GUGA TABLES
! NOTE:    TO RETAIN THE TABLES AVAILABLE FOR LATER PURPOSES
!          THE START ADDRESSES OF OF THE ARRAYS ETC. ARE STORED IN
!          THREE USER DEFINED TYPES. Consult the gugx module for the details.

  use gugx, only: CIStruct, SGStruct

  type(SGStruct), target, intent(inout) :: SGS
  type(CIStruct), intent(inout) :: CIS
  integer(kind=iwp), parameter :: LTAB = 1, NTAB = 2, ATAB = 3, BTAB = 4, CTAB = 5

  ! CREATE THE SYMMETRY INDEX VECTOR

  call MKISM()

  ! COMPUTE TOP ROW OF THE GUGA TABLE

  call mknVert0()

  ! SET UP A FULL PALDUS DRT TABLE:
  ! (INITIALLY NO RESTRICTIONS ARE PUT UP)

  SGS%nVert = SGS%nVert0
  if (SGS%IFRAS /= 0) then
    call mma_allocate(SGS%DRT0,SGS%nVert0,5,Label='DRT0')
    call mma_allocate(SGS%DOWN0,[1,SGS%nVert0],[0,3],Label='DOWN0')
    SGS%DRTP => SGS%DRT0
    SGS%DOWNP => SGS%DOWN0
  else
    call mma_allocate(SGS%DRT,SGS%nVert,5,Label='SGS%DRT')
    call mma_allocate(SGS%DOWN,[1,SGS%nVert],[0,3],Label='SGS%DOWN')
    SGS%DRTP => SGS%DRT
    SGS%DOWNP => SGS%DOWN
  end if

  call mkDRT0()

  ! IF THIS IS A RAS CALCULATION PUT UP RESTRICTIONS BY DELETING
  ! VERTICES WHICH VIOLATE THE FORMER.

  if (SGS%IFRAS /= 0) then
    call mkRAS()

    ! REASSEMBLE THE DRT TABLE (REMOVE DISCONNECTED VERTICES)

    call mkDRT()

    ! IF THIS IS A CAS CALCULATION PROCEED WITH THE UNRESTRICTED DRT TABLE

  end if

  nullify(SGS%DOWNP,SGS%DRTP)

  ! CALCULATE ARC WEIGHT.

  call MKDAW()

  ! COMPUTE UPCHAIN TABLE AND REVERSE ARC WEIGHTS

  call MKRAW()

  ! COMPUTE LTV TABLES.

  call MKLTV()

  ! COMPUTE MIDLEVEL AND LIMITS ON MIDVERTICE.

  call MKMID()

contains

  subroutine MKISM()

    use UnixInfo, only: ProgName

    if (ProgName(1:6) == 'rassi') then
      call mkISm_Rassi()
    else if (ProgName(1:4) == 'mclr') then
      call mkISm_mclr()
    else if (ProgName(1:6) == 'caspt2') then
      call mkISm_cp2()
    else
      call mkNSM()
    end if

  end subroutine MKISM

  subroutine MKISM_MCLR()

    use input_mclr, only: NRS1, NRS2, NRS3, NSYM, NTASH

    integer(kind=iwp) :: iBas, iOrb, iSym

    SGS%NLEV = ntASh

    call mma_allocate(SGS%ISM,SGS%nLev,Label='SGS%ISM')

    iOrb = 0
    do iSym=1,nSym
      do iBas=1,nRs1(iSym)
        iOrb = iOrb+1
        SGS%ISM(iOrb) = iSym
      end do
    end do
    do iSym=1,nSym
      do iBas=1,nRs2(iSym)
        iOrb = iOrb+1
        SGS%ISM(iOrb) = iSym
      end do
    end do
    do iSym=1,nSym
      do iBas=1,nRs3(iSym)
        iOrb = iOrb+1
        SGS%ISM(iOrb) = iSym
      end do
    end do

  end subroutine MKISM_MCLR

  subroutine MKISM_RASSI()

    use gugx, only: LEVEL
    use rassi_data, only: NASH, NASHT

    integer(kind=iwp) :: ITABS, ISYM, IT, ILEV, nSym

    nSym = SGS%nSym
    SGS%NLEV = NASHT ! Total number of active orbitals
    ! Allocate Level to Symmetry table ISm:
    call mma_allocate(SGS%ISm,SGS%nLev,Label='SGS%ISm')
    ITABS = 0
    do ISYM=1,NSYM
      do IT=1,NASH(ISYM)
        ITABS = ITABS+1
        ILEV = LEVEL(ITABS)
        SGS%ISM(ILEV) = ISYM
      end do
    end do

  end subroutine MKISM_RASSI

  subroutine mkism_cp2()

    use fciqmc_interface, only: DoFCIQMC
    use gugx, only: L2ACT, LEVEL
    use caspt2_module, only: DoCumulant, nAsh, nAshT, nSym

    integer(kind=iwp) :: ILEV, iq, ISYM, IT, ITABS, nLev

    NLEV = NASHT
    SGS%nLev = NLEV
    call mma_allocate(SGS%ISM,NLEV,Label='ISM')
    ! ISM(LEV) IS SYMMETRY LABEL OF ACTIVE ORBITAL AT LEVEL LEV.
    ! PAM060612: With true RAS space, the orbitals must be ordered
    ! first by RAS type, then by symmetry.
    ITABS = 0
    do ISYM=1,NSYM
      do IT=1,NASH(ISYM)
        ITABS = ITABS+1
        ! Quan: Bug in LEVEL(ITABS) and L2ACT
        if (DoCumulant .or. DoFCIQMC) then
          do iq=1,NLEV
            LEVEL(iq) = iq
            L2ACT(iq) = iq
          end do
        end if
        ILEV = LEVEL(ITABS)
        SGS%ISM(ILEV) = ISYM
      end do
    end do

  end subroutine mkism_cp2

  subroutine MKNSM()
  ! PURPOSE: CREATE THE SYMMETRY INDEX VECTOR

    use gugx, only: SGS
    use gas_data, only: NGAS, NGSSH
    use rasscf_global, only: NSM
    use general_data, only: NSYM

    ! to get some dimensions
    integer(kind=iwp) :: IGAS, ISYM, NLEV, NSTA

    NLEV = 0
    do IGAS=1,NGAS
      do ISYM=1,NSYM
        NSTA = NLEV+1
        NLEV = NLEV+NGSSH(IGAS,ISYM)
        NSM(NSTA:NLEV) = ISYM
      end do
    end do

    if (SGS%nSym /= 0) then
      SGS%nLev = nLev
      call mma_allocate(SGS%ISM,nLev,Label='SGS%ISM')
      SGS%ISM(1:nLev) = NSM(1:nLev)
    end if

  end subroutine MKNSM

  subroutine mknVert0()

    integer(kind=iwp) :: IAC

    SGS%IB0 = SGS%iSpin-1
    SGS%IA0 = (SGS%nActEl-SGS%IB0)/2
    SGS%IC0 = SGS%nLev-SGS%IA0-SGS%IB0

    if ((2*SGS%IA0+SGS%IB0 /= SGS%nActEl) .or. (SGS%IA0 < 0) .or. (SGS%IB0 < 0) .or. (SGS%IC0 < 0)) then
      write(u6,*) 'mknVert0 Error: Impossible specifications.'
      write(u6,'(1x,a,3I8)') 'NACTEL,NLEV,ISPIN:',SGS%nActEl,SGS%nLev,SGS%iSpin
      write(u6,'(1x,a,3I8)') 'IA0,IB0,IC0:      ',SGS%IA0,SGS%IB0,SGS%IC0
      write(u6,*) ' This is a severe internal error, or possibly'
      write(u6,*) ' indicates a strange input which should have been'
      write(u6,*) ' diagnosed earlier. Please submit a bug report.'
      call Abend()
    end if
    IAC = min(SGS%IA0,SGS%IC0)
    SGS%nVert0 = ((SGS%IA0+1)*(SGS%IC0+1)*(2*SGS%IB0+IAC+2))/2-(IAC*(IAC+1)*(IAC+2))/6

  end subroutine mknVert0

  subroutine mkDRT0()
  ! PURPOSE: CONSTRUCT THE UNRESTRICTED GUGA TABLE

    use Index_Functions, only: nTri_Elem1

    integer(kind=iwp) :: ADDR, ADWN, AUP, BC, BDWN, BUP, CDWN, CUP, DWN, LEV, MXADDR, NACTEL, nTmp, STEP, VDWN, VEND, VSTA, VUP, &
                         VUPS
    integer(kind=iwp), allocatable :: TMP(:)
    integer(kind=iwp), parameter :: DA(0:3) = [0,0,1,1], DB(0:3) = [0,1,-1,0], DC(0:3) = [1,0,1,0]
#   ifdef _DEBUGPRINT_
    integer(kind=iwp) :: VERT
#   endif

    NTMP = nTri_Elem1(SGS%nLev+1)
    call mma_allocate(TMP,NTMP,Label='TMP')

    ! SET UP TOP ROW

    NACTEL = 2*SGS%IA0+SGS%IB0
    SGS%nLev = SGS%IA0+SGS%IB0+SGS%IC0
    SGS%DRTP(1,LTAB) = SGS%nLev
    SGS%DRTP(1,NTAB) = NACTEL
    SGS%DRTP(1,ATAB) = SGS%IA0
    SGS%DRTP(1,BTAB) = SGS%IB0
    SGS%DRTP(1,CTAB) = SGS%IC0
    VSTA = 1
    VEND = 1
#   ifdef _DEBUGPRINT_
    write(u6,*) 'A0,B0,C0,NVERT=',SGS%IA0,SGS%IB0,SGS%IC0,SGS%nVert
#   endif

    ! LOOP OVER ALL LEVELS

    do LEV=SGS%nLev,1,-1
      MXADDR = ((LEV+1)*(LEV+2))/2
      TMP(1:MXADDR) = 0

      ! LOOP OVER VERTICES

      do VUP=VSTA,VEND
        AUP = SGS%DRTP(VUP,ATAB)
        BUP = SGS%DRTP(VUP,BTAB)
        CUP = SGS%DRTP(VUP,CTAB)

        ! LOOP OVER CASES
        ! AND STORE ONLY VALID CASE NUMBERS WITH ADDRESSES

        do STEP=0,3
          SGS%DownP(VUP,STEP) = 0
          ADWN = AUP-DA(STEP)
          if (ADWN < 0) cycle
          BDWN = BUP-DB(STEP)
          if (BDWN < 0) cycle
          CDWN = CUP-DC(STEP)
          if (CDWN < 0) cycle
          BC = BDWN+CDWN
          ADDR = 1+(BC*(BC+1))/2+CDWN
          TMP(ADDR) = 4*VUP+STEP
          SGS%DownP(VUP,STEP) = ADDR
        end do
      end do
      VDWN = VEND

      ! NOW INSERT VALID CASES INTO DRT TABLE

      do ADDR=1,MXADDR
        VUPS = TMP(ADDR)
        if (VUPS == 0) cycle
        VUP = VUPS/4
        STEP = mod(VUPS,4)
        VDWN = VDWN+1
        SGS%DRTP(VDWN,ATAB) = SGS%DRTP(VUP,ATAB)-DA(STEP)
        SGS%DRTP(VDWN,BTAB) = SGS%DRTP(VUP,BTAB)-DB(STEP)
        SGS%DRTP(VDWN,CTAB) = SGS%DRTP(VUP,CTAB)-DC(STEP)
        TMP(ADDR) = VDWN
      end do

      ! CREATE DOWN CHAIN TABLE

      do VUP=VSTA,VEND
        do STEP=0,3
          DWN = SGS%DownP(VUP,STEP)
          if (DWN /= 0) SGS%DownP(VUP,STEP) = TMP(DWN)
        end do
      end do
      VSTA = VEND+1
      VEND = VDWN
    end do
    ! End of loop over levels.

    ! ADDING THE ZERO LEVEL TO DRT AND DOWNCHAIN TABLE

    SGS%DRTP(VEND,1:5) = 0
    SGS%DownP(VEND,0:3) = 0

    ! COMPLETE DRT TABLE BY ADDING NO. OF ORBITALS AND ELECTRONS
    ! INTO THE FIRST AND SECOND COLUMN

    SGS%DRTP(1:VEND,LTAB) = SGS%DRTP(1:VEND,ATAB)+SGS%DRTP(1:VEND,BTAB)+SGS%DRTP(1:VEND,CTAB)
    SGS%DRTP(1:VEND,NTAB) = 2*SGS%DRTP(1:VEND,ATAB)+SGS%DRTP(1:VEND,BTAB)
#   ifdef _DEBUGPRINT_
    do VERT=1,VEND
      write(u6,*) 'DRT0(:,LTAB)=',SGS%DRTP(VERT,LTAB)
      write(u6,*) 'DRT0(:,NTAB)=',SGS%DRTP(VERT,NTAB)
    end do
#   endif

    call mma_deallocate(TMP)

  end subroutine mkDRT0

  subroutine mkRAS()

    use UnixInfo, only: ProgName

    if (ProgName(1:5) == 'rassi') then
      call rmvert(SGS)
    else
      call RESTR(SGS)
    end if

  end subroutine mkRAS

  subroutine mkDRT()
  ! PURPOSE: USING THE UNRESTRICTED DRT TABLE GENERATED BY DRT0 AND
  !          THE MASKING ARRAY PRODUCED BY RESTR COPY ALL VALID
  !          VERTICES FROM THE OLD TO THE NEW DRT TABLE

    integer(kind=iwp) :: IC, ID, IDNEW, IV, IVNEW

    call mma_allocate(SGS%DRT,SGS%nVert,5,Label='DRT')
    call mma_allocate(SGS%Down,[1,SGS%nVert],[0,3],Label='SGS%DOWN')

    do IV=1,SGS%nVert0
      IVNEW = SGS%Ver(IV)
      if (IVNEW == 0) cycle
      SGS%DRT(IVNEW,:) = SGS%DRT0(IV,1:5)
      do IC=0,3
        ID = SGS%Down0(IV,IC)
        IDNEW = 0
        if (ID /= 0) IDNEW = SGS%Ver(ID)
        SGS%Down(IVNEW,IC) = IDNEW
      end do
    end do
#   ifdef _DEBUGPRINT_
    do IV=1,SGS%nVert
      write(u6,*) 'DRT(i,:)=',SGS%DRT(IV,:)
    end do
#   endif

    call mma_deallocate(SGS%Ver)
    call mma_deallocate(SGS%DRT0)
    call mma_deallocate(SGS%Down0)

  end subroutine mkDRT

  subroutine MKDAW()
  ! PURPOSE: CONSTRUCT DIRECT ARC WEIGHTS TABLE

    integer(kind=iwp) :: IC, IDWN, ISUM, IV

    call mma_allocate(SGS%DAW,[1,SGS%nVert],[0,4],Label='SGS%DAW')

    ! BEGIN TO CONSTRUCT DOWN CHAIN TABLE

    SGS%DAW(SGS%nVert,0:3) = 0
    SGS%DAW(SGS%nVert,4) = 1
    do IV=SGS%nVert-1,1,-1
      ISUM = 0
      do IC=0,3
        SGS%DAW(IV,IC) = 0
        IDWN = SGS%Down(IV,IC)
        if (IDWN == 0) cycle
        SGS%DAW(IV,IC) = ISUM
        ISUM = ISUM+SGS%DAW(IDWN,4)
      end do
      SGS%DAW(IV,4) = ISUM
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) ' DIRECT ARC WEIGHTS:'
    do IV=1,SGS%nVert
      write(u6,'(1X,I4,5X,5(1X,I6))') IV,SGS%DAW(IV,0:4)
    end do
    write(u6,*)
#   endif

  end subroutine MKDAW

  subroutine MKRAW()
  ! PURPOSE: CONSTRUCT UPCHAIN INDEX TABLE AND REVERSE ARC WEIGHTS

    integer(kind=iwp) :: IC, IDWN, ISUM, IU, IV

    call mma_allocate(SGS%UP,[1,SGS%nVert],[0,3],Label='SGS%UP')
    call mma_allocate(SGS%RAW,[1,SGS%nVert],[0,4],Label='SGS%RAW')

    ! BEGIN BY CONSTRUCTING THE UPCHAIN TABLE IUP:

    SGS%Up(:,:) = 0
    do IU=1,SGS%nVert-1
      do IC=0,3
        IDWN = SGS%Down(IU,IC)
        if (IDWN == 0) cycle
        SGS%Up(IDWN,IC) = IU
      end do
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) ' THE UPCHAIN TABLE IN MKRAW:'
    do IV=1,SGS%nVert
      write(u6,'(1X,I4,5X,4(1X,I6))') IV,SGS%Up(IV,0:3)
    end do
    write(u6,*)
#   endif

    ! USE UPCHAIN TABLE TO CALCULATE THE REVERSE ARC WEIGHT TABLE:

    SGS%RAW(:,0:3) = 0
    SGS%RAW(1,4) = 1
    do IV=2,SGS%nVert
      ISUM = 0
      do IC=0,3
        IU = SGS%Up(IV,IC)
        if (IU == 0) cycle
        SGS%RAW(IV,IC) = ISUM
        ISUM = ISUM+SGS%RAW(IU,4)
      end do
      SGS%RAW(IV,4) = ISUM
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) ' THE REVERSE ARC WEIGHT TABLE IN MKRAW:'
    do IV=1,SGS%nVert
      write(u6,'(1X,I4,5X,5(1X,I6))') IV,SGS%RAW(IV,0:4)
    end do
    write(u6,*)
#   endif

  end subroutine MKRAW

  subroutine MKLTV()
  ! PURPOSE: FIND THE MIDLEVEL

    integer(kind=iwp) :: IV, LEV

    call mma_allocate(SGS%LTV,[-1,SGS%nLev],Label='LTV')

    ! SET UP A LEVEL-TO-VERTEX TABLE, LTV, AND IDENTIFY MIDVERTICES:

    SGS%LTV(:) = 0

    do IV=1,SGS%nVert
      LEV = SGS%DRT(IV,LTAB)
      SGS%LTV(LEV) = SGS%LTV(LEV)+1
    end do

    do LEV=SGS%nLev,0,-1
      SGS%LTV(LEV-1) = SGS%LTV(LEV-1)+SGS%LTV(LEV)
    end do

    do LEV=-1,SGS%nLev-1
      SGS%LTV(LEV) = 1+SGS%LTV(LEV+1)
    end do

  end subroutine MKLTV

  subroutine MKMID()
  ! PURPOSE: FIND THE MIDLEVEL

    integer(kind=iwp) :: IL, IV, MINW, MV, NW

    ! USE DAW,RAW TABLES TO DETERMINE MIDLEV.
    ! THE ASSUMPTION IS THAT A BALANCED NUMBER OF UPPER/LOWER WALKS
    ! IS THE BEST CHOICE.

    !hrl 980529 fix for nLev=0 (no orbitals in any active space)
    ! Since LTV(-1:nLev)  and the statement after the loop
    ! MVSta=LTV(MidLev) we have the condition MidLev>=nLev
    ! Hence MidLev=1 is inappropriate for nLev=0
    ! MIDLEV=1

    if (SGS%nLev == 0) then
      SGS%MidLev = 0
    else
      SGS%MidLev = 1
    end if
    MINW = 1000000
    do IL=1,SGS%nLev-1
      NW = 0
      do IV=SGS%LTV(IL),SGS%LTV(IL-1)-1
        NW = NW+SGS%RAW(IV,4)-SGS%DAW(IV,4)
      end do
      NW = abs(NW)
      if (NW >= MINW) cycle
      SGS%MidLev = IL
      MINW = NW
    end do
    SGS%MVSta = SGS%LTV(SGS%MidLev)
    SGS%MVEnd = SGS%LTV(SGS%MidLev-1)-1
    CIS%nMidV = SGS%MVEnd-SGS%MVSta+1

    ! NOW FIND THE MAX NUMBERS OF UPPER AND LOWER WALKS. RESPECTIVELY
    ! (DISREGARDING SYMMETRY)

    SGS%MxUp = 0
    SGS%MxDwn = 0
    do MV=SGS%MVSta,SGS%MVEnd
      if (SGS%MxUp < SGS%RAW(MV,4)) SGS%MxUp = SGS%RAW(MV,4)
      if (SGS%MxDwn < SGS%DAW(MV,4)) SGS%MxDwn = SGS%DAW(MV,4)
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,'(A,I3)') ' MIDLEVEL =             ',SGS%MidLev
    write(u6,'(A,I3)') ' NUMBER OF MIDVERTICES =',CIS%NMIDV
    write(u6,'(A,I3)') ' FIRST MIDVERTEX =      ',SGS%MVSta
    write(u6,'(A,I3)') ' LAST MIDVERTEX =       ',SGS%MVEnd
    write(u6,'(A,I3)') ' MAX. NO UPPER WALKS=   ',SGS%MxUp
    write(u6,'(A,I3)') ' MAX. NO LOWER WALKS=   ',SGS%MxDwn
    write(u6,*)
#   endif

  end subroutine MKMID

end subroutine MKGUGA

end module MkGUGA_mod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      FUNCTION NOP_FOR_CONF(ICONF,NEL)
*
* A configuration is given as a nonstrict ascending sequence of occupied
* occupied orbitals. Find number of double occupied orbitals
*
* Jeppe Olsen, Nov. 2001
*
#include "implicit.fh"
      INTEGER ICONF(NEL)
*. Loop over electrons
      NOPEN = 0
      IEL = 1
 1000 CONTINUE
        IF(IEL.LT.NEL) THEN
          IF(ICONF(IEL).NE.ICONF(IEL+1)) THEN
           NOPEN = NOPEN + 1
           IEL = IEL + 1
          ELSE IF (ICONF(IEL).EQ.ICONF(IEL+1) ) THEN
           IEL = IEL + 2
          END IF
        END IF
*
        IF(IEL.EQ.NEL) THEN
*. The last orbital is not identical to any later orbitals so
         NOPEN = NOPEN+1
         IEL = IEL + 1
        END IF
      IF(IEL.LT.NEL) GOTO 1000
*
      NOP_FOR_CONF = NOPEN
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Configuration '
        CALL IWRTMA(ICONF,1,NEL,1,NEL)
        WRITE(6,*) ' Number of open orbitals = ', NOP_FOR_CONF
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2006  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE DENS2T_RPT2 (CI1,CI2,SGM1,SGM2,G1,G2,nLev)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
#endif
      use Symmetry_Info, only: Mul
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use gugx, only: SGS, L2ACT, CIS
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: iSCF, nActEl, nAshT, nConf, STSym
      use pt2_guga, only: MxCI, nG1, nG2
      IMPLICIT NONE


      LOGICAL RSV_TSK
      Integer, Intent(In):: nLev
      REAL*8 CI1(MXCI),CI2(MXCI),SGM1(MXCI),SGM2(MXCI)
      REAL*8 G1(NLEV,NLEV),G2(NLEV,NLEV,NLEV,NLEV)

      REAL*8 GTU,GTUVX !! ,GTUXV

      INTEGER ID
      INTEGER IST,ISU,ISV,ISX,ISTU,ISVX
      INTEGER IT,IU,IV,IX,LT,LU,LV,LX,LVX
      integer itu,ivx

      INTEGER ITASK,NTASKS

      INTEGER ISSG,NSGM

      REAL*8, EXTERNAL :: DDOT_,DNRM2_
      INTEGER, ALLOCATABLE:: Task(:,:)

c Purpose: Compute the 1- and 2-electron density matrix
c arrays G1 and G2.


      CALL DCOPY_(NG1,[0.0D0],0,G1,1)
      CALL DCOPY_(NG2,[0.0D0],0,G2,1)

C For the special cases, there is no actual CI-routines involved:
c Special code for hi-spin case:
      IF(ISCF.EQ.2) THEN
        DO IT=1,NASHT
          G1(IT,IT)=1.0D00
          DO IU=1,IT-1
            G2(IT,IT,IU,IU)= 1.0D00
            G2(IU,IU,IT,IT)= 1.0D00
            G2(IT,IU,IU,IT)=-1.0D00
            G2(IU,IT,IT,IU)=-1.0D00
          END DO
        END DO
        GOTO 99
      END IF
c Special code for closed-shell:
      IF(ISCF.EQ.1 .AND. NACTEL.GT.0) THEN
        DO IT=1,NASHT
          G1(IT,IT)=2.0D00
          G2(IT,IT,IT,IT)= 2.0D00
          DO IU=1,IT-1
            G2(IT,IT,IU,IU)= 4.0D00
            G2(IU,IU,IT,IT)= 4.0D00
            G2(IT,IU,IU,IT)=-2.0D00
            G2(IU,IT,IT,IU)=-2.0D00
          END DO
        END DO
        GOTO 99
      END IF

* For the general cases, we use actual CI routine calls, and
* have to take account of orbital order.
* We will use level inices LT,LU... in these calls, but produce
* the density matrices with usual active orbital indices.
* Translation tables L2ACT and LEVEL, in pt2_guga.F90

C-SVC20100311: set up a task table with LT,LU
      nTasks=(nLev**2+nLev)/2
      nTasks= nLev**2

      CALL mma_allocate (Task,nTasks,2,Label='Task')

      iTask=0
      DO LT=1,nLev
        DO LU=1,nLev!LT
          iTask=iTask+1
          Task(iTask,1)=LT
          Task(iTask,2)=LU
        ENDDO
      ENDDO
      IF (iTask.NE.nTasks) WRITE(6,*) "ERROR nTasks"

      Call Init_Tsk(ID, nTasks)

C-SVC20100311: BEGIN SEPARATE TASK EXECUTION
 500  If (.NOT.Rsv_Tsk (ID,iTask)) GOTO 501

* Compute SGM1 = E_UT acting on CI, with T.ge.U,
* i.e., lowering operations. These are allowed in RAS.
C     LTU=0
C     DO 140 LT=1,NLEV
      LT=Task(iTask,1)
        IST=SGS%ISM(LT)
        IT=L2ACT(LT)
C       DO 130 LU=1,LT
        LU=Task(iTask,2)
C         LTU=LTU+1
          ! LTU=iTask
          ISU=SGS%ISM(LU)
          IU=L2ACT(LU)
          ISTU=Mul(IST,ISU)
          ISSG=Mul(ISTU,STSYM)
          NSGM=CIS%NCSF(ISSG)
C         IF(NSGM.EQ.0) GOTO 130
          IF(NSGM.EQ.0) GOTO 500
C         CALL GETSGM2(LT,LU,STSYM,CI1,SGM1)
C         write(6,*) "LT,LU=",lt,lu
C         do ix = 1, nsgm
C         write(6,'(i3,f20.10)') ix,sgm1(ix)
C         end do
          CALL GETSGM2(LU,LT,STSYM,CI1,SGM1)
          IF(ISTU.EQ.1) THEN
            GTU=DDOT_(NSGM,CI2,1,SGM1,1)
            G1(IT,IU)=G1(IT,IU)+GTU
C           G1(IU,IT)=GTU
          END IF
          LVX=0
          DO LV=1,NLEV!LT
            ISV=SGS%ISM(LV)
            IV=L2ACT(LV)
            DO LX=1,NLEV!LV
              LVX=LVX+1
C             IF(LVX.GT.LTU) GOTO 500
              ISX=SGS%ISM(LX)
              ISVX=Mul(ISV,ISX)
              IF(ISVX.NE.ISTU) GOTO 110
              IX=L2ACT(LX)
C             IF(LX.EQ.LT) THEN
C then actually T=U=V=X.
C               GTUVX=DDOT_(NSGM,SGM1,1,SGM1,1)
C             ELSE
                CALL GETSGM2(LX,LV,ISSG,SGM1,SGM2)
                GTUVX=DDOT_(NCONF,CI2,1,SGM2,1)
C             END IF

C             IF(LV.EQ.LX) THEN
C               GTUXV=GTUVX
C             ELSE
C               IF(LVX.EQ.LTU) THEN
C                 GTUXV=DDOT_(NSGM,SGM1,1,SGM1,1)
C               ELSE
C                 CALL GETSGM2(LX,LV,STSYM,CI,SGM2)
C                 GTUXV=DDOT_(NSGM,SGM1,1,SGM2,1)
C               END IF
C             END IF
              G2(IT,IU,IV,IX)=G2(IT,IU,IV,IX)+GTUVX
C             G2(IT,IU,IX,IV)=GTUXV
 110        CONTINUE
            END DO
          END DO

          CALL GETSGM2(LU,LT,STSYM,CI2,SGM1)
          IF(ISTU.EQ.1) THEN
            GTU=DDOT_(NSGM,CI1,1,SGM1,1)
            G1(IT,IU)=G1(IT,IU)+GTU
          END IF
          LVX=0
          DO LV=1,NLEV
            ISV=SGS%ISM(LV)
            IV=L2ACT(LV)
            DO LX=1,NLEV
              LVX=LVX+1
C             IF(LVX.GT.LTU) GOTO 500
              ISX=SGS%ISM(LX)
              ISVX=Mul(ISV,ISX)
C             IF(ISVX.NE.ISTU) GOTO 110
              IX=L2ACT(LX)
              CALL GETSGM2(LX,LV,ISSG,SGM1,SGM2)
              GTUVX=DDOT_(NCONF,CI1,1,SGM2,1)
              G2(IT,IU,IV,IX)=G2(IT,IU,IV,IX)+GTUVX
C110        CONTINUE
            END DO
          END DO

CSVC: The master node now continues to only handle task scheduling,
C     needed to achieve better load balancing. So it exits from the task
C     list.  It has to do it here since each process gets at least one
C     task.

      GOTO 500
 501  CONTINUE
      CALL Free_Tsk(ID)

      CALL mma_deallocate(Task)

      CALL GAdSUM (G1,NG1)
      CALL GAdSUM (G2,NG2)

C     write(6,*) "before"
C     call sqprt(g2,nlev**2)
      Do LT = 1, NLEV
        IT = L2ACT(LT)
        Do LU = 1, NLEV
          IU = L2ACT(LU)
          Do LV = 1, NLEV
            IV = L2ACT(LV)
            G2(IT,IV,IV,IU) = G2(IT,IV,IV,IU) - G1(IT,IU)
          End Do
        End Do
      End Do
      do it = 1, nlev
      do iu = 1, nlev
      itu = it+nasht*(iu-1)
      do iv = 1, nlev
      do ix = 1, nlev
      ivx = iv+nasht*(ix-1)
       if (ivx.gt.itu) g2(iv,ix,it,iu) = g2(it,iu,iv,ix)
      end do
      end do
      end do
      end do
C-SVC20100311: serial part: add corrections to G2
C     DO LT=1,NLEV
C      IT=L2ACT(LT)
C      DO LX=1,LT
C       IX=L2ACT(LX)
C       DO LU=LX,LT
C        IU=L2ACT(LU)
C        G2(IT,IU,IU,IX)=G2(IT,IU,IU,IX)-G1(IT,IX)
C       END DO
C      END DO
C     END DO
C     DO LT=2,NLEV
C      IT=L2ACT(LT)
C      DO LX=2,LT
C       IX=L2ACT(LX)
C       DO LU=1,LX-1
C        IU=L2ACT(LU)
C        G2(IT,IU,IU,IX)=G2(IT,IU,IU,IX)-G1(IT,IX)
C       END DO
C      END DO
C     END DO
C     LTU=0
C     DO LT=1,NLEV
C      IT=L2ACT(LT)
C      DO LU=1,LT
C       LTU=LTU+1
C       IU=L2ACT(LU)
C       LVX=0
C       DO LV=1,LT
C        IV=L2ACT(LV)
C        DO LX=1,LV
C         LVX=LVX+1
C         IX=L2ACT(LX)
C         IF(LVX.GT.LTU) GOTO 225
C         GTUVX=G2(IT,IU,IV,IX)
C         G2(IU,IT,IX,IV)=GTUVX
C         G2(IV,IX,IT,IU)=GTUVX
C         G2(IX,IV,IU,IT)=GTUVX
C         GTUXV=G2(IT,IU,IX,IV)
C         G2(IU,IT,IV,IX)=GTUXV
C         G2(IX,IV,IT,IU)=GTUXV
C         G2(IV,IX,IU,IT)=GTUXV
C        END DO
C       END DO
C225    CONTINUE
C      END DO
C     END DO
  99  CONTINUE

      IF(iPrGlb.GE.DEBUG) THEN
        WRITE(6,'("DEBUG> ",A)')
     &   "DENS2_RPT2: norms of the density matrices:"
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G1:", DNRM2_(NG1,G1,1)
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G2:", DNRM2_(NG2,G2,1)
      ENDIF


      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!----------------------------------------------------------------------*
!                                                                      *
! This module contains various parameters and variables for GenAno.    *
!                                                                      *
! o MxLqn  - The highest l-q.n. that the program can handle.           *
! x MxSets - The highest number of orbitals sets that can be used.     *
! x MxBasX - The highest number of basis functions in any of the sets. *
! x MxS    - The maximum number of s-primitives.                       *
! x MxP    - The maximum number of p-primitives.                       *
! x MxD    - The maximum number of d-primitives.                       *
! x MxF    - The maximum number of f-primitives.                       *
! x MxG    - The maximum number of g-primitives.                       *
! x MxH    - The maximum number of h-primitives.                       *
! x MxI    - The maximum number of i-primitives.                       *
! x MxK    - The maximum number of k-primitives.                       *
! x MxDsym - The space allocated for l-q.n. blocked density matrices.  *
!                                                                      *
! o nPrim  - Number of primitives per l quantum number.                *
! o nCore  - Number of core orbitals per l quantum number.             *
!            Note: currently not used.                                 *
! o nSets  - Number of orbital sets to include in averaging.           *
! o kSet   - Set number counter.                                       *
! o nSym   - Number of symmetries blocks of current set.               *
! o nBas   - Number of basis functions per symmetry block of           *
!            current set.                                              *
! x nDsym  - Size of density matrix in l-q.n. blocked form stored as   *
!            lower triangles.                                          *
! o iProj  - Switch for performing projection.                         *
! o iSymBk - Pointer to start of l-q.n. blocks of density matrix.      *
! o kRfSet - Reference set from which the metric (overlap matrix) is   *
!            read.                                                     *
!                                                                      *
! o wSet   - Weight of the individual set in the averaging. Not        *
!            normalized if read from input.                            *
! o pDsym  - Partial l-q.n. blocked density matrix.                    *
! o tDsym  - Total l-q.n. blocked density matrix.                      *
! o thr    - Threshold for reporting NO's.                             *
! o Ssym   - Metric (overlap matrix) from reference set.               *
! o Cmo    - Natural orbitals.                                         *
! o Occ    - Occupation numbers from vector file.                      *
! o Eps    - Orbital energies                                          *
! o wc0    - Weight coefficient 0                                      *
! o wc1    - Weight coefficient 1                                      *
!                                                                      *
! o Center - Atomic label for which to generate ano's.                 *
! o BasName- Atomic labels and basis function label from one-electron  *
!            file.                                                     *
! o Title  - First title line from input.                              *
!                                                                      *
! o rowise - Switch for printing ano's as rows instead of columns.     *
! o lftdeg - Switch for lifting occupation number degeneracy           *
! o rydgen - Switch for generating rydberg orbitals                    *
!                                                                      *
! o symlab - Symmetry label information for basis functions generated  *
!            by seward.                                                *
!----------------------------------------------------------------------*

module Genano_globals

use Definitions, only: wp, iwp

implicit none
private

#include "Molcas.fh"
!--- MkS is set to 90 to circumvent a logical error in the code!
!#define MxS 90
!#define MxP 25
!#define MxD 20
!#define MxF 15
!#define MxG 12
!#define MxH 10
!#define MxI  8
!#define MxK  8
! MxDsym =   MxS*(MxS+1)/2 +  3*MxP*(MxP+1)/2 +  5*MxD*(MxD+1)/2 +  7*MxF*(MxF+1)/2 + &
!          9*MxG*(MxG+1)/2 + 11*MxH*(MxH+1)/2 + 13*MxI*(MxI+1)/2 + 15*MxK*(MxK+1)/2
integer(kind=iwp), parameter :: MxLqn = 7
integer(kind=iwp) :: nPrim(0:MxLqn), nCore(0:MxLqn), nSets, kSet, nSym, nBas(1:MxSym), nDsym, iProj, iSymBk((MxLqn+1)**2), kRfSet, &
                     isUHF
real(kind=wp) :: thr, wc0, wc1
real(kind=wp), allocatable :: wSet(:), pDsym(:), tDsym(:), Ssym(:), Cmo(:), Occ(:), Cmo2(:), Occ2(:), Eps(:)
logical(kind=iwp) :: rowise, lftdeg, rydgen
character(len=LenIn) :: Center
character(len=LenIn+8), allocatable :: BasName(:)
character(len=80) :: Title
character(len=8) :: symlab((MxLqn+1)**2)

public :: MxLqn, nPrim, nCore, nSets, kSet, nSym, nBas, nDsym, iProj, iSymBk, kRfSet, isUHF, wSet, pDsym, tDsym, thr, Ssym, Cmo, &
          Occ, Cmo2, Occ2, Eps, wc0, wc1, rowise, lftdeg, rydgen, LenIn, Center, BasName, Title, symlab

end module Genano_globals

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module grd_interface

implicit none
private

abstract interface
  subroutine grd_kernel( &
#                       define _CALLING_
#                       include "grd_interface.fh"
                       )
    use Index_Functions, only: nTri_Elem1
    use Definitions, only: wp, iwp
#   include "grd_interface.fh"
  end subroutine grd_kernel

  subroutine grd_mem( &
#                    define _CALLING_
#                    include "mem_interface.fh"
                    )
    use Definitions, only: iwp
#   include "mem_interface.fh"
  end subroutine grd_mem
end interface

public :: grd_kernel, grd_mem

end module grd_interface

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Oskar Weser                                      *
!***********************************************************************

module filesystem

#include "compiler_features.h"

use, intrinsic :: iso_c_binding, only: c_char, c_int, c_ptr, c_null_char
use fortran_strings, only: split, StringWrapper_t, Cptr_to_str, str
use linalg_mod, only: abort_
use Definitions, only: iwp, MOLCAS_C_INT

implicit none
private

public :: getcwd_, chdir_, symlink_, get_errno_, strerror_, mkdir_, &
  remove_, real_path, basename, inquire_, copy_

interface
  subroutine getcwd_c(path,n,err) bind(C,name='getcwd_wrapper')
    import :: c_char, MOLCAS_C_INT
    character(len=1,kind=c_char), intent(out) :: path(*)
    integer(MOLCAS_C_INT), intent(in) :: n
    integer(MOLCAS_C_INT), intent(out) :: err
  end subroutine getcwd_c

  subroutine chdir_c(path,err) bind(C,name='chdir_wrapper')
    import :: c_char, MOLCAS_C_INT
    character(len=1,kind=c_char), intent(in) :: path(*)
    integer(MOLCAS_C_INT), intent(out) :: err
  end subroutine chdir_c

  subroutine symlink_c(to,from,err) bind(C,name='symlink_wrapper')
    import :: c_char, MOLCAS_C_INT
    character(len=1,kind=c_char), intent(in) :: to(*), from(*)
    integer(MOLCAS_C_INT), intent(out) :: err
  end subroutine symlink_c

  subroutine mkdir_c(path,mode,err) bind(C,name='mkdir_wrapper')
    import :: c_char, MOLCAS_C_INT
    character(len=1,kind=c_char), intent(in) :: path(*)
    integer(kind=MOLCAS_C_INT), intent(in) :: mode
    integer(kind=MOLCAS_C_INT), intent(out) :: err
  end subroutine mkdir_c

  function get_errno_c() bind(C,name='get_errno')
    import :: MOLCAS_C_INT
    integer(MOLCAS_C_INT) :: get_errno_c
  end function get_errno_c

# ifdef C_PTR_BINDING
  function strerror_c(errno) bind(C,name='strerror')
    import :: c_ptr, c_int
    type(c_ptr) :: strerror_c
    integer(c_int), value, intent(in) :: errno
  end function strerror_c
# endif

  subroutine remove_c(path,err) bind(C,name='remove_wrapper')
    import :: c_char, MOLCAS_C_INT
    character(len=1,kind=c_char), intent(in) :: path(*)
    integer(kind=MOLCAS_C_INT), intent(out) :: err
  end subroutine remove_c

  subroutine copy_c(src,dst,err) bind(C,name='copy')
    import :: c_char, MOLCAS_C_INT
    character(len=1,kind=c_char), intent(in) :: src(*),dst(*)
    integer(kind=MOLCAS_C_INT), intent(out) :: err
  end subroutine copy_c

  function access_c(path) bind(C,name='access_wrapper')
    import :: c_char, MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT)  :: access_c
    character(len=1,kind=c_char), intent(in) :: path(*)
  end function

end interface

contains

!> @brief
!> Return the current working directory.
subroutine getcwd_(path,err)
  character(len=*), intent(out) :: path
  integer(kind=iwp), intent(out), optional :: err
  integer(MOLCAS_C_INT) :: c_err
  call getcwd_c(path,len(path,MOLCAS_C_INT),c_err)
  if (present(err)) err = int(c_err)
end subroutine getcwd_

!> @brief
!> Change the current directory to `path`.
subroutine chdir_(path,err)
  character(len=*), intent(in) :: path
  integer(kind=iwp), intent(out), optional :: err
  integer(MOLCAS_C_INT) :: c_err
  call chdir_c(trim(path)//c_null_char,c_err)
  if (present(err)) err = int(c_err)
end subroutine chdir_

!> @brief
!> Create a weak symlink_ `from` -> `to`.
subroutine symlink_(to,from,err)
  character(len=*), intent(in) :: to, from
  integer(kind=iwp), intent(out), optional :: err
  integer(MOLCAS_C_INT) :: c_err
  call symlink_c(trim(to)//c_null_char,trim(from)//c_null_char,c_err)
  if (present(err)) err = int(c_err)
end subroutine symlink_

!> @brief
!> Create a directory at `path`.
subroutine mkdir_(path,err)
  character(len=*), intent(in) :: path
  integer(kind=iwp), optional, intent(out) :: err
  integer(MOLCAS_C_INT) :: loc_err
  call mkdir_c(trim(path)//c_null_char,int(o'772',MOLCAS_C_INT),loc_err)
  if (present(err)) err = loc_err
end subroutine mkdir_

!> @brief
!> Return the global error number.
function get_errno_()
  integer(kind=iwp) :: get_errno_
  get_errno_ = int(get_errno_c())
end function get_errno_

!> @brief
!> Return Error String from Error number
function strerror_(errnum) result(res)
  character(len=:), allocatable :: res
  integer(kind=iwp), intent(in) :: errnum
# ifndef C_PTR_BINDING
  integer(kind=iwp) :: rc
  character(len=80) :: errstr
  integer(kind=iwp), external :: aixerr
  errstr = ''
  rc = aixerr(errstr)
  res = trim(errstr)
# else
  res = Cptr_to_str(strerror_c(int(errnum,c_int)))
# endif
end function strerror_

!> @brief
!> Remove the file `path`.
subroutine remove_(path,err)
  character(len=*) :: path
  integer(kind=iwp), optional, intent(out) :: err
  integer(MOLCAS_C_INT) :: loc_err
  call remove_c(trim(path)//c_null_char,loc_err)
  if (present(err)) err = int(loc_err)
end subroutine remove_

!> @brief
!> Translate internal Molcas filenames to system paths.
function real_path(molcas_name) result(path)
  character(len=:), allocatable :: path
  character(len=*), intent(in) :: molcas_name
  character(len=1024) :: buffer
  integer(kind=iwp) :: L
  call prgmtranslate_master(molcas_name,buffer,L)
  path = buffer(:L)
end function real_path

!> @brief
!> Return the basename of `path`.
function basename(path) result(res)
  character(len=:), allocatable :: res
  character(len=*), intent(in) :: path
  type(StringWrapper_t), allocatable :: names(:)

  call split(path,'/',names)

  if (size(names(size(names))%str) /= 0) then
    ! Base is a normal file that is not a directory .../.../basename
    res = str(names(size(names))%str)
  else
    ! Base is itself a directory .../.../basename/
    res = str(names(size(names)-1)%str)
  end if
end function basename

!> @brief
!> Return true if the file or directory `path` exists.
function inquire_(path)
  character(len=*), intent(in) :: path
  logical(kind=iwp) :: inquire_
  inquire_ = access_c(trim(path)//c_null_char) == 0
end function

!> @brief
!> Copy file from src to dst
!>
!> @details
!> This function is not guaranteed to be thread-safe.
!> As long as `dst` is different for two processes calling at the same
!> time, it is safe to use in process-based parallelisation.
subroutine copy_(src, dst, err)
  character(len=*), intent(in) :: src, dst
  integer(kind=iwp), intent(out), optional :: err
  integer(kind=iwp) :: err_
  call copy_c(trim(src)//c_null_char, trim(dst)//c_null_char, err_)
  if (present(err)) then
    err = err_
  else if (err_ /= 0) then
    call abort_('Error in copy')
  end if
end subroutine

end module filesystem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_INIT(SKIP_PRESCREEN,ALLOCATE_BOOKMARKS)
C
C     Purpose: initializations.
C
C              IF (SKIP_PRESCREEN): skip prescreening of diagonal.
C              In this case, NNSHL and array iSP2F must be set
C              externally (the allocation is checked here).
C
C              IF (ALLOCATE_BOOKMARKS): allocate arrays needed to
C              record bookmarks during Cholesky decomposition.
C
#include "implicit.fh"
      LOGICAL SKIP_PRESCREEN
      LOGICAL ALLOCATE_BOOKMARKS
#include "choorb.fh"
#include "cholesky.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "choptr2.fh"
#include "chosp.fh"
#include "chosubscr.fh"
#include "chobkm.fh"
#include "WrkSpc.fh"

      DIMENSION XXB(8)

      CHARACTER*1  LINE
      CHARACTER*8  SECNAM
      CHARACTER*17 STRING
      PARAMETER (LINE = '=', SECNAM = 'CHO_INIT',
     &           STRING = 'Information from ')

      PARAMETER (GBLIM = 2.147483648D9)

      MULD2H(I,J)=IEOR(I-1,J-1)+1
      ISOSHL(I)=IWORK(ip_iSOShl-1+i)
      ISHLSO(I)=IWORK(ip_iShlSO-1+i)
      IBASSH(I,J)=IWORK(ip_IBASSH-1+NSYM*(J-1)+I)
      NBASSH(I,J)=IWORK(ip_NBASSH-1+NSYM*(J-1)+I)
      NBSTSH(I)=IWORK(ip_NBSTSH-1+I)


C     Check settings for parallel runs.
C     Return code: 3 will cause verification to accept this as a passed
C     test (certain options are not available in parallel runs).
C     -----------------------------------------------------------------

      IRC = -1
      CALL CHO_P_CHECK(IRC)
      IF (IRC .NE. 0) THEN
         WRITE(LUPRI,*) SECNAM,': CHO_P_CHECK returned ',irc
C        CALL CHO_QUIT('Error in '//SECNAM,102)
         CALL CHO_QUIT('Parallel option conflicts in '//SECNAM,3)
      END IF

C     Allocate array for tracing idle procs.
C     --------------------------------------

      IF (TRACE_IDLE) THEN
         CALL CHO_TRCIDL_INIT()
      END IF

C     Set diagonal prescreening threshold.
C     ------------------------------------

      IF (SKIP_PRESCREEN) CHO_PRESCREEN = .FALSE.
      IF (CHO_PRESCREEN) THEN
         IF (THR_PRESCREEN .LT. 0.0D0) THEN
            THR_PRESCREEN = MIN(1.0d-14,THRCOM)
         END IF
      END IF

C     Get info from Seward.
C     ---------------------

      CALL CHO_MCA_INIT(SKIP_PRESCREEN)

C     Initialize chosp.fh (enabling use of function CHO_F2SP).
C     ---------------------------------------------------------

      NNSHL_SP = NNSHL

C     Set damping.
C     ------------

      CALL CHO_SETDAMP()

C     Allocate memory for reduced set index arrays.
C     ---------------------------------------------

      l_IIBSTRSH = NSYM*NNSHL*3
      l_NNBSTRSH = l_IIBSTRSH
      l_INTMAP   = NNSHL
      l_MYSP     = NNSHL
      CALL CHO_MEM('iibstrsh','ALLO','INTE',ip_IIBSTRSH,l_IIBSTRSH)
      CALL CHO_MEM('nnbstrsh','ALLO','INTE',ip_NNBSTRSH,l_NNBSTRSH)
      CALL CHO_MEM('intmap','ALLO','INTE',ip_INTMAP,l_INTMAP)
      CALL CHO_MEM('mySP','ALLO','INTE',ip_MYSP,l_MYSP)

C     Initialize timings etc.
C     -----------------------

      CALL CHO_DZERO(TDECDRV,2)
      CALL CHO_DZERO(TINTEG,2*NINTEG)
      CALL CHO_DZERO(TDECOM,2*NDECOM)
      CALL CHO_DZERO(TMISC,2*NMISC)
      CALL CHO_IZERO(ICHKQ,4*(NCHKQ+1))
      CALL CHO_IZERO(NVECRS1,NSYM)

      DID_DECDRV = .FALSE.

      DIAMNZ = 0.0D0
      IABMNZ = 0
      NNZTOT = 0

      NSYS_CALL = 0
      NDGM_CALL = 0

C     Open files for vector and reduced set storage.
C     Open restart files.
C     ----------------------------------------------

      CALL CHO_UNINI()
      CALL CHO_P_OPENVR(1)

C     Initialize integral SP counter.
C     -------------------------------

      CALL CHO_INIMAP()

C     Allocate memory for INFRED and INFVEC arrays.
C     In so doing, determine the max. #vectors and #reduced sets.
C     -----------------------------------------------------------

      IF (MAXRED.LT.1 .OR. MAXVEC.LT.1) THEN
         XXBMX = -1.0D8
         XXBT  = 0.0D0
         DO ISYM = 1,NSYM
            XXB(ISYM) = 0.0D0
            DO ISYMB = 1,NSYM
               ISYMA = MULD2H(ISYMB,ISYM)
               IF (ISYMA .EQ. ISYMB) THEN
                  XA = DBLE(NBAS(ISYMA))
                  XXB(ISYM) = XXB(ISYM) + XA*(XA + 1.0D0)/2.0D0
               ELSE IF (ISYMA .GT. ISYMB) THEN
                  XA = DBLE(NBAS(ISYMA))
                  XB = DBLE(NBAS(ISYMB))
                  XXB(ISYM) = XXB(ISYM) + XA*XB
               END IF
            END DO
            XXBT  = XXBT + XXB(ISYM)     ! total diag. dim.
            XXBMX = MAX(XXBMX,XXB(ISYM)) ! max. diag. block
         END DO
         IF (MAXVEC .LT. 1) THEN
            NBSMAX = NBAS(1)
            DO ISYM = 2,NSYM
               NBSMAX = MAX(NBSMAX,NBAS(ISYM))
            END DO
            MAXVEC = 20*NBSMAX ! default max. #vectors
            IF (XXBMX .LT. GBLIM) THEN
               NNBMX  = INT(XXBMX)
               MAXVEC = MIN(MAXVEC,NNBMX) ! reset if less than default
            END IF
         END IF
         IF (MAXRED .LT. 1) THEN
            MAXRED = NSYM*MAXVEC ! default max. #red. sets
            IF (XXBT .LT. GBLIM) THEN
               NNBT   = INT(XXBT)
               MAXRED = MIN(MAXRED,NNBT) ! reset if less than default
            END IF
         END IF
      END IF

      IF (MAXRED.LT.1 .OR. MAXVEC.LT.1) THEN
         WRITE(LUPRI,*) SECNAM,': MAXRED = ',MAXRED
         WRITE(LUPRI,*) SECNAM,': MAXVEC = ',MAXVEC
         CALL CHO_QUIT('MAXRED/MAXVEC error in '//SECNAM,103)
      ELSE
         l_INFRED = MAXRED
         l_INFVEC = MAXVEC*INFVEC_N2*NSYM
         l_NDIMRS = NSYM*MAXRED
         CALL CHO_MEM('INFRED','ALLO','INTE',ip_INFRED,l_INFRED)
         CALL CHO_MEM('INFVEC','ALLO','INTE',ip_INFVEC,l_INFVEC)
         CALL CHO_MEM('NDIMRS','ALLO','INTE',ip_NDIMRS,l_NDIMRS)
      END IF

C     Allocate bookmarks (accuracy and number of Cholesky vectors).
C     Not available with restart.
C     -------------------------------------------------------------

      If (Allocate_Bookmarks) Then
         If (RSTCHO) Then
            ip_BkmVec=0
            l_BkmVec=0
            nRow_BkmVec=0
            nCol_BkmVec=0
            ip_BkmThr=0
            l_BkmThr=0
            nRow_BkmThr=0
            nCol_BkmThr=0
         Else
            l_BkmVec=nSym*MaxRed
            Call GetMem('BkmVec','Allo','Inte',ip_BkmVec,l_BkmVec)
            nRow_BkmVec=nSym
            nCol_BkmVec=0
            l_BkmThr=nSym*MaxRed
            Call GetMem('BkmThr','Allo','Real',ip_BkmThr,l_BkmThr)
            nRow_BkmThr=nSym
            nCol_BkmThr=0
         End If
      Else
         ip_BkmVec=0
         l_BkmVec=0
         nRow_BkmVec=0
         nCol_BkmVec=0
         ip_BkmThr=0
         l_BkmThr=0
         nRow_BkmThr=0
         nCol_BkmThr=0
      End If

C     Initialize INFRED, INFVEC, vector counter, etc.
C     Special handling depending on Cholesky restart.
C     -----------------------------------------------

      CALL CHO_INIT1()

C     Set threshold for screening in vector subtraction.
C     --------------------------------------------------

      IF (CHO_SSCREEN) THEN
         IF (SSTAU .LT. 0.0D0) THEN
            SSTAU = THRCOM*1.0D-6
         END IF
      END IF

C     Print header and configuration.
C     -------------------------------

      IF (IPRINT .GE. 1) THEN
         CALL CHO_PRTHEAD(.FALSE.)
         CALL CHO_FLUSH(LUPRI)
      END IF

C     Check configuration.
C     --------------------

      NCONFL = 0
      CALL CHO_CHKCONF(NCONFL,.TRUE.)
      IF (CHKONLY) THEN
         WRITE(LUPRI,'(A,A,I4,A)')
     &   SECNAM,':',NCONFL,' conflicts detected in Cholesky config'
         CALL CHO_QUIT('End of configuration check in '//SECNAM,100)
      ELSE IF (NCONFL .NE. 0) THEN
         WRITE(LUPRI,'(A,A,I4,A)')
     &   SECNAM,':',NCONFL,' conflicts detected in Cholesky config'
         CALL CHO_QUIT('Configuration conflicts in '//SECNAM,105)
      END IF

C     Allocate and set shell-to-center mapping for 1-center
C     decomposition.
C     -----------------------------------------------------

      IF (CHO_1CENTER) THEN
         l_IATOMSHL = NSHELL
         CALL CHO_MEM('IATOMSHL','ALLO','INTE',ip_IATOMSHL,l_IATOMSHL)

         IRC = -1
         CALL CHO_SETATOMSHL(IRC,IWORK(ip_IATOMSHL),l_IATOMSHL)
         IF (IRC .NE. 0) THEN
            WRITE(LUPRI,*) SECNAM,': CHO_SETATOMSHL returned ',IRC
            CALL CHO_QUIT(SECNAM//': shell-to-atom init failed!',102)
         END IF
      END IF

C     Allocate IQUAB array for qualification.
C     Allocate IQUAB_L array for parallel runs.
C     -----------------------------------------

      l_IQUAB = MAXQUAL*NSYM
      CALL CHO_MEM('IQUAB','ALLO','INTE',ip_IQUAB,l_IQUAB)
      CALL CHO_P_INILQ(MAXQUAL,NSYM)

C     Set screening mode.
C     -------------------

      IF (CHO_DECALG.EQ.2 .OR. CHO_DECALG.EQ.3 .OR.
     &    CHO_DECALG.EQ.5 .OR. CHO_DECALG.EQ.6) THEN
         IF (CHO_1CENTER) THEN
            IF (CHO_NO2CENTER) THEN ! 2-c removed at diag. calc.
               MODE_SCREEN = 2 ! remove diagonals < THRCOM
            ELSE
               MODE_SCREEN = 3 ! remove 2-c diags and diags < THRCOM
            END IF
         ELSE
            MODE_SCREEN = 2 ! remove diagonals < THRCOM
         END IF
      ELSE
         MODE_SCREEN = 1 ! damped screening
      END IF

C     Print section.
C     --------------

      IF (IPRINT .GE. INF_INIT) THEN

         CALL CHO_HEAD(STRING//SECNAM,LINE,80,LUPRI)

         WRITE(LUPRI,'(/,2X,A,I10)')
     &   'Number of irreps        : ',NSYM
         WRITE(LUPRI,'(2X,A,I10)')
     &   'Number of SOs           : ',NBAST
         WRITE(LUPRI,'(2X,A,I10)')
     &   'Number of shells        : ',NSHELL
         WRITE(LUPRI,'(2X,A,I10)')
     &   'Number of shell pairs   : ',NNSHL_TOT
         WRITE(LUPRI,'(2X,A,I10)')
     &   'Contributing shell pairs: ',NNSHL
         WRITE(LUPRI,'(2X,A,I10)')
     &   'Max. shell dimension    : ',MXORSH
         WRITE(LUPRI,'(2X,A,I10)')
     &   'Max. shell pair dim.    : ',MX2SH

         IF (IPRINT .GE. 4) THEN ! debug print

C           Basis size info.
C           ----------------

            WRITE(LUPRI,'(/,2X,A,/,2X,A)')
     &      '  Symmetry        NBAS        IBAS',
     &      '----------------------------------'
            DO ISYM = 1,NSYM
               WRITE(LUPRI,'(2X,I10,2X,I10,2X,I10)')
     &         ISYM,NBAS(ISYM),IBAS(ISYM)
            END DO
            WRITE(LUPRI,'(2X,A)')
     &      '----------------------------------'

C           Shell info.
C           -----------

            WRITE(LUPRI,'(/,2X,A,/,2X,A,/,2X,A)')
     &     '     Shell   Dimension    Symmetry   Dimension      Offset',
     &     '             (NBSTSH)                (NBASSH)     (IBASSH)',
     &     '----------------------------------------------------------'
            DO ISHL = 1,NSHELL
               DO ISYM = 1,NSYM
                  IF (ISYM .EQ. 1) THEN
                     WRITE(LUPRI,'(2X,I10,2X,I10,2X,I10,2X,I10,2X,I10)')
     &               ISHL,NBSTSH(ISHL),
     &               ISYM,NBASSH(ISYM,ISHL),IBASSH(ISYM,ISHL)
                  ELSE
                     WRITE(LUPRI,'(26X,I10,2X,I10,2X,I10)')
     &               ISYM,NBASSH(ISYM,ISHL),IBASSH(ISYM,ISHL)
                  END IF
               END DO
            END DO
            WRITE(LUPRI,'(2X,A)')
     &     '----------------------------------------------------------'

            WRITE(LUPRI,'(/,2X,A,/,2X,A,/,2X,A)')
     &      '    SO        SO    sym    Shell     Index ',
     &      ' (global) (reduced)      (ISOSHL)  (ISHLSO)',
     &      '-------------------------------------------'
            DO ISYM = 1,NSYM
               DO I = 1,NBAS(ISYM)
                  IA = IBAS(ISYM) + I
                  WRITE(LUPRI,'(2X,I9,1X,I9,1X,I3,1X,I9,1X,I9)')
     &                 IA,I,ISYM,ISOSHL(IA),ISHLSO(IA)
               END DO
            END DO
            WRITE(LUPRI,'(2X,A)')
     &      '-------------------------------------------'

         END IF

      END IF


      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!               1995,1996, Pavel Neogrady                              *
!***********************************************************************

subroutine REORG(run_triples,IRETURN)
!----------------------------------------------------------------------*
!     1994  PER-AAKE MALMQUIST                                         *
!     DEPARTMENT OF THEORETICAL CHEMISTRY                              *
!     UNIVERSITY OF LUND, SWEDEN                                       *
!                                                                      *
! modified by P.N. (Dec. 1995)                                         *
! all allocation memory routines removed by P.N. (8.03.1996)           *
!----------------------------------------------------------------------*
!
! FILES USED:
!     TRAINT    2 electron MO INTEGRALS
!     JOBIPH    THE JOB-INTERFACE FILE AS PRODUCED BY THE RASSCF
!               PROGRAM
! INPUT
!     AT PRESENT:  THE INPUT FILE IS SEARCHED FOR THE STRING
!     '&REORG '. Input is only TITLE
!
! LIMITATIONS
!     Like in CASPT2
!
!***********************************************************************

use ccsort_global, only: clopkey, Escf, fullprint, IADR15, JOBIPH, LROOT, LUINTM, mbas, NASH, NDEL, ndelr, NFRO, nfror, NISH, noa, &
                         nob, NORB, NSSH, NSYM, nva, nvb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(out) :: run_triples
integer(kind=iwp), intent(out) :: IRETURN
#include "rasdim.fh"
integer(kind=iwp) :: i, iad15, ij, j, lad15, NOIPSB(106), ntot2, ntot3
logical(kind=iwp) :: run_sort
real(kind=wp), allocatable :: Ene(:,:), EPS(:), EPSRAS(:), FI(:), FIRAS(:), FOKA(:), FOKB(:)
integer(kind=iwp), external :: iPrintLevel

fullprint = 0
if (iPrintLevel(-1) <= 0) fullprint = -1
call mma_allocate(FIRAS,mbas*mbas,Label='FIRAS')
call mma_allocate(FI,mbas*mbas,Label='FI')

! READ AND ECHO INPUT DATA, READ JOBIPH, PRINT INPUT DATA,
call RDINPPN(run_triples,run_sort)
if (fullprint >= 0) call PRINPPN()
call CHKINP_CCSORT()

if (run_sort) then

  ! read FI from JOBIPH
  ntot3 = 0
  ntot2 = 0
  do i=1,nsym
    ntot3 = ntot3+(norb(i)*(norb(i)+1))/2
    ntot2 = ntot2+norb(i)
  end do

  ! pick the total energy from the JOBIPH file

  call mma_allocate(Ene,mxRoot,mxIter)

  iad15 = iadr15(6)
  lad15 = mxroot*mxiter
  call dDaFile(JOBIPH,2,Ene,lad15,iad15)
  EScf = Zero
  i = 1

  ! take the last non-zero energy stored

  do while ((Ene(LROOT,i) /= Zero) .and. (i <= mxIter))
    Escf = Ene(LROOT,i)
    i = i+1
  end do
  call mma_deallocate(Ene)
  if (fullprint >= 0) then
    write(u6,*)
    write(u6,'(6X,A,F16.8)') 'SCF energy:',Escf
    write(u6,'(6X,A)') '-----------'
    write(u6,*)
  end if

  ! get fi from previous RASSCF

  iad15 = iadr15(10)
  call ddafile(JOBIPH,2,firas(1),ntot3,iad15)

  ! get eps from previous RASSCF

  call mma_allocate(eps,mbas,label='eps')
  call mma_allocate(epsras,ntot2,label='epsras')

  iad15 = iadr15(11)
  call ddafile(JOBIPH,2,epsras,ntot2,iad15)

  ! reduce fi,eps and update n's
  call mod1(nsym,nfro,nish,nssh,ndel,norb,nfror,ndelr,firas,fi,epsras,eps)

  call mma_deallocate(epsras)

  ! def diagonal Fok for closed shell

  if (clopkey == 2) call mod2(nsym,nish,nash,norb,fi,eps)

  ! define noa,nob,nva,nvb

  noa(1:nsym) = nish(1:nsym)+nash(1:nsym)
  nob(1:nsym) = nish(1:nsym)
  nva(1:nsym) = nssh(1:nsym)
  nvb(1:nsym) = nssh(1:nsym)+nash(1:nsym)

  if (nsym < 8) then
    noa(nsym+1:8) = 0
    nob(nsym+1:8) = 0
    nva(nsym+1:8) = 0
    nvb(nsym+1:8) = 0
  end if

  if (fullprint > 1) then
    write(u6,*)
    write(u6,'(6X,A)') 'Diagonal Fock matrix elements and orbital energies:'
    write(u6,'(6X,A)') '---------------------------------------------------'
    write(u6,*)
    write(u6,'(6X,A)') '----------------------------------------'
    write(u6,'(6X,A)') '   i      F(i,i)           eps(i)       '
    write(u6,'(6X,A)') '----------------------------------------'
    ij = 0
    do i=1,norb(1)
      do j=1,i
        ij = ij+1
        if (i == j) write(u6,'(6X,I4,2F18.10)') i,fi(ij),eps(i)
      end do
    end do
    write(u6,'(6X,A)') '----------------------------------------'
    write(u6,*)
  end if

  ! prepare address (stupid)

  !FUE The unit number of the transformed two electron integrals
  !FUE must be 40, 50, 60, 70, 80 or 90. Any other number will
  !FUE not be compatible with the I/O driver in MOLCAS.

  LUINTM = 40
  !JR  call DANAME(LUINTM,'TRAINT')
  call DANAME_MF(LUINTM,'TRAINT')
  call mkaddress(NOIPSB)

  ! open TRAINT and call action

  call mma_allocate(FOKA,mbas*(mbas+1)/2,label='FOKA')
  call mma_allocate(FOKB,mbas*(mbas+1)/2,label='FOKB')

  call action_ccsort(FOKA,FOKB,fi,eps)
  call mma_deallocate(FOKA)
  call mma_deallocate(FOKB)
  call mma_deallocate(eps)

  ! close files

  call daclos(luintm)
  call daclos(jobiph)

else
  ! case, when SORT was skipped
  write(u6,*) ' SORT part was skipped'
  write(u6,*) ' Input parameters are from last actual run of SORT'
end if

ireturn = 0

call mma_deallocate(FIRAS)
call mma_deallocate(FI)

return

end subroutine REORG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MLTDXP(IMLTOP,LST1,LST2,X,F,Y)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(*),F(*),Y(*)
      DIMENSION LST1(4,NLST1), LST2(4,NLST2)
#include "sigma.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#endif

C Given two lists with entries LST1(4,ITEM), ITEM=1,NLST1, the
C four entries called L11,L12,L13,L14 for short, for a given
C item, and with V1=VAL1(L14), and similar for the other list,
C compute, for IMLTOP=0 or 1 resp.,
C     X(L11,L21,a) := Add V1*V2*F(L12,L22)*Y(L13,L23,a)
C or  Y(L13,L23,a) := Add V1*V2*F(L12,L22)*X(L11,L21,a), a=1,LEN1
C or for IMLTOP=2, compute
C     F(L12,L22) := Add V1*V2*X(L11,L21,a)*Y(L13,L23,a)
C However, strides etc can vary from case to case: The indices
C may appear in 1st, 2nd or 3rd position, Fortran-address-wise,
C thus an independent stride is to be given for each of the
C indices in the above 'formal' index ordering, as follows:
C The formal X(p,q,r) is accessed as
C X(1+INCX1*(p-1)+INCX2*(q-1)+INCX3*(r-1)), etc.

CSVC: determine outer loop properties
#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        ILST1_IOFF=MYRANK+1
        ILST1_SKIP=NPROCS
      ELSE
        ILST1_IOFF=1
        ILST1_SKIP=1
      ENDIF
#else
      ILST1_IOFF=1
      ILST1_SKIP=1
#endif

      IF(IMLTOP.EQ.0) THEN
        DO ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
          L11=LST1(1,ILST1)
          L12=LST1(2,ILST1)
          L13=LST1(3,ILST1)
          L14=LST1(4,ILST1)
          V1=VAL1(L14)
          DO ILST2=1,NLST2
            L21=LST2(1,ILST2)
            L22=LST2(2,ILST2)
            L23=LST2(3,ILST2)
            L24=LST2(4,ILST2)
            V2=VAL2(L24)
            IX=1+INCX1*(L11-1)+INCX2*(L21-1)
            IY=1+INCY1*(L13-1)+INCY2*(L23-1)
            IF=1+INCF1*(L12-1)+INCF2*(L22-1)
            A=V1*V2*F(IF)
            CALL DAXPY_(LEN1,A,Y(IY),INCY3,X(IX),INCX3)
          END DO
        END DO
      ELSE IF(IMLTOP.EQ.1) THEN
        DO ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
          L11=LST1(1,ILST1)
          L12=LST1(2,ILST1)
          L13=LST1(3,ILST1)
          L14=LST1(4,ILST1)
          V1=VAL1(L14)
          DO ILST2=1,NLST2
            L21=LST2(1,ILST2)
            L22=LST2(2,ILST2)
            L23=LST2(3,ILST2)
            L24=LST2(4,ILST2)
            V2=VAL2(L24)
            IX=1+INCX1*(L11-1)+INCX2*(L21-1)
            IY=1+INCY1*(L13-1)+INCY2*(L23-1)
            IF=1+INCF1*(L12-1)+INCF2*(L22-1)
            A=V1*V2*F(IF)
            CALL DAXPY_(LEN1,A,X(IX),INCX3,Y(IY),INCY3)
          END DO
        END DO
      ELSE
        DO ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
          L11=LST1(1,ILST1)
          L12=LST1(2,ILST1)
          L13=LST1(3,ILST1)
          L14=LST1(4,ILST1)
          V1=VAL1(L14)
          DO ILST2=1,NLST2
            L21=LST2(1,ILST2)
            L22=LST2(2,ILST2)
            L23=LST2(3,ILST2)
            L24=LST2(4,ILST2)
            V2=VAL2(L24)
            IX=1+INCX1*(L11-1)+INCX2*(L21-1)
            IY=1+INCY1*(L13-1)+INCY2*(L23-1)
            IF=1+INCF1*(L12-1)+INCF2*(L22-1)
            A=V1*V2*F(IF)
            V=V1*V2
            F(IF)=F(IF)+V*DDOT_(LEN1,X(IX),INCX3,Y(IY),INCY3)
          END DO
        END DO
      END IF
      NFDXP=NFDXP+2*NLST1*NLST2*LEN1
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  LDF_X_Final
*
*> @brief
*>   Finalize LDF enviroment
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Finalization of the LDF environment, including
*> proper deallocations of memory. If \p Term_Sew, terminate the
*> Seward environment as well. On exit, \p irc = ``0`` signals successful
*> finalization.
*>
*> @param[in]  Term_Sew Do termination of Seward environment
*> @param[out] irc      Return code
*>
*> @see ::LDF_X_Init
************************************************************************
      Subroutine LDF_X_Final(Term_Sew,irc)
      Implicit None
      Logical Term_Sew
      Integer irc
#include "localdf.fh"

      Character*11 SecNam
      Parameter (SecNam='LDF_X_Final')

      Integer LDF_Status

      ! Init return code
      irc=0

      ! Read init flag on runfile
      Call Get_iScalar('LDF Status',LDF_Status)

      ! Finalize if set
      If (LDF_Status.eq.LDF_Set) Then
         Call LDF_UnsetMltplCenters(max(LDF_Constraint,0))
         Call LDF_CIO_Final()
         Call LDF_Final(Term_Sew,irc)
         If (irc.ne.0) Then
            Write(6,'(A,A,I8)')
     &      SecNam,': LDF_Final returned code',irc
            irc=1
         End If
         If (Term_Sew) Then
            Call ClsSew()
         End If
         LDF_Status=LDF_Set-1
         Call LDF_SetStatusOnRunFile(LDF_Status)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkvbinfo_cvb()

use casvb_global, only: iapr, ibpr, iconfs, idetvb, ixapr, ixbpr, nalf, nbet, nconf, nconfion_fr, nda, ndb, ndetvb, nel, nfrag, &
                        noe, norb

implicit none

if (nfrag > 1) then
  call dpgendet_cvb()
else
  call vbgendet_cvb(iapr,ixapr,ibpr,ixbpr,iconfs,idetvb,nconf,nconfion_fr(0,1),nda,ndb,ndetvb,nel,noe,nalf,nbet,norb)
end if

return

end subroutine mkvbinfo_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine o2v4ctl(wrk,wrksize,NvGrp,NvSGrp,LunAux)
! drajver o2v4 procesu

use Index_Functions, only: nTri_Elem
use chcc_global, only: ABID, printkey, TCpu, TCpu_l, TWall, TWall_l, TWall0
use Para_Info, only: nProcs
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, NvGrp, NvSGrp, LunAux
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: actJobs, addJobs, aGrp, bGrp, i, j, mdGrpa, mdGrpbe, mdSGrpa, mdSGrpbe, NaGrp, NaSGrp, NbeGrp, NbeSgrp, &
                     nJobs, proc

!1 Inicializacia premennych (Predbezna)

!@c
! return
!@c
NaGrp = NvGrp
NbeGrp = NvGrp
NaSGrp = NvSGrp
nbeSGrp = NvSGrp

!2 define all groups and ssungroup parameters

call DefParo2v4(NaGrp,NbeGrp,NaSGrp,NbeSgrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
if (printkey >= 10) write(u6,*) NaGrp,NbeGrp,NaSGrp,NbeSgrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
!mp
call CWTime(TCpu,TWall)
if (printkey > 1) then
  write(u6,*)
  write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
  write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
  write(u6,*)
  write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
  write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
  write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0d0*TCpu/(TWall-TWall0)
  write(u6,*)
end if
TCpu_l = TCpu
TWall_l = TWall
!mp

!3 distribute work among nodes (def ABID)

ABID(0:nProcs-1,1:NaGrp,1:NaGrp) = 0

if ((nProcs == 1) .or. (NaGrp == 1)) then
  !3.1 nP = <1>
  ! all jobs to one node

  ABID(0,1:NaGrp,1:NaGrp) = 1

else
  !3.2 nP = <2, inf)
  ! N.B. cele zatial trochu odflaknute, lebo sa neberie do uvahy,
  ! ze pre half joby je lepsie ked nadvazuju na plne joby s
  ! rovnakymi indexami

  !3.2.1 Full Jobs

  i = nTri_Elem(NaGrp-1)
  nJobs = int(i/nProcs)
  addJobs = mod(i,nProcs)

  ! first nodes: 0-addJobs
  !    will have int(N'(N'-1)/2 /nProc)+1 Full Jobs
  ! rest nodes: addJobs-nProcs-1
  !      will have int(N'(N'-1)/2 /nProc)

  proc = 0
  actJobs = nJobs
  do aGrp=2,NaGrp
    do bGrp=1,aGrp-1
      ABID(proc,aGrp,bGrp) = 1
      actJobs = actJobs-1
      if (actJobs == -1) then
        proc = proc+1
        actJobs = nJobs
      else if (actJobs == 0) then
        if (addJobs > 0) then
          addJobs = addJobs-1
        else
          proc = proc+1
          actJobs = nJobs
        end if
      end if
    end do
  end do

  !3.2.2 Half Jobs
  !
  ! distribution of Half Jobs
  !   - first distribution - addjobs-nProcs-1
  !   - second distribution - addjobs-nProcs-1
  !   - other distributions - 0 - nProcs-1

  addJobs = mod(i,nProcs)
  proc = addJobs
  j = 0

  do aGrp=1,NaGrp
    ABID(proc,aGrp,aGrp) = 1
    proc = proc+1
    if (proc == nProcs) then
      if (j == 0) then
        ! first distribution - addjobs-nProcs-1
        proc = addJobs
        j = 1
      else if (j == 1) then
        ! second distribution - addjobs-nProcs-1
        proc = addJobs
        j = 2
      else
        ! other distributions - 0 - nProcs-1
        proc = 0
      end if
    end if
  end do

end if

! Printing ABID
if (printkey >= 10) then
  do proc=0,nProcs-1
    write(u6,*) ' For myRank = ',proc
    do aGrp=1,NaGrp
      do bGrp=1,aGrp
        if (ABID(proc,aGrp,bGrp) == 1) write(u6,*) '    aGrp,bGrp ',aGrp,bGrp
      end do
    end do
  end do
end if

!4 A ideme na to

call o2v4(wrk,wrksize,NaGrp,NbeGrp,NaSGrp,NbeSgrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,LunAux)

return

end subroutine o2v4ctl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine dafupd_cvb(lu,ioffset)

use Definitions, only: iwp, RtoI

implicit none
integer(kind=iwp), intent(in) :: lu, ioffset
integer(kind=iwp) :: ibuf(1000), ioff, mxddr, nwrite

mxddr = 1000
nwrite = 1000
ibuf(:) = 0

call iDaFile(lu,8,ibuf,nwrite,mxddr)

if (mxddr < ioffset) then
  ioff = mxddr
  do
    nwrite = min((ioffset-ioff)*RtoI,1000)
    call iDaFile(lu,1,ibuf,nwrite,ioff)
    if (ioff >= ioffset) exit
  end do
end if

return

end subroutine dafupd_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine FckMat
************************************************************
*                                                          *
*   Driver for calculation of optimized fock matrix.       *
*                                                          *
************************************************************
      use Arrays, only: FAMO, FIMO, F0SQMO, INT2
      implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
#include "machine.fh"
      Real*8, Allocatable:: Q(:), Tmp2(:,:), T3(:)
*
*                                                                      *
************************************************************************
*                                                                      *
*...  Read density matrix
*
      nm=0
      nmm=0
      nmmm=0
      Do iS=1,nSym
         nm=nAsh(is)+nm
         nMM=Max(nMM,nAsh(is)+nIsh(iS))
         nMMM=Max(nmmM,nBas(is))
      End Do
      nAtri=nm*(nm+1)/2
      nAtri=nAtri*(nAtri+1)/2
      nmmm=((nmmm-1)/nRec+1)*nRec
      nmm=nmm*nMMM
      nmm=nmm**2
      Call mma_allocate(F0SQMO,ndens2,Label='F0SQMO')
      Call mma_allocate(FIMO,ndens2,Label='FIMO')
      If (iMethod.eq.2) Then
         Call mma_allocate(Int2,nAtri,Label='Int2')
      Else
         Call mma_allocate(Int2,1,Label='Int2')
      End If
      Int2(:)=0.0d0
      Call mma_allocate(FAMO,nDens2,Label='FAMO')
      Call mma_allocate(Q,nDens2,Label='Q')
      Call mma_allocate(Tmp2,ndens2,2,Label='Tmp2')
      Call mma_allocate(T3,ndens2,Label='T3')
*                                                                      *
************************************************************************
*                                                                      *
*     Calculate two-electron contribution
*
      Call Read22_2(Int2,F0SQMO,Q,FIMO,FAMO,Tmp2(:,1),Tmp2(:,2),T3)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(T3)
      Call mma_deallocate(Tmp2)
      Call mma_deallocate(Q)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE APPRIM(EPP,EPB,TPQ,AP,ENP,T1,T2,ICASE)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      DIMENSION EPP(*),EPB(*),TPQ(*),AP(*),ENP(*),T1(*),T2(*)
      DIMENSION ICASE(*)
C
      IP=IRC(4)
      DO 5 I=1,IP
        CALL TPQSET(ICASE,TPQ,I)
        CALL VAM(EPP,1,EPB,1,TPQ,1,T1,1,IP)
        CALL VDIV(ENP,1,T1,1,T2,1,IP)
        CALL VECSUM_CPFMCPF(T2,AP(I),IP)
        AP(I)=AP(I)*ENP(I)
5     CONTINUE
C
      IF(IPRINT.GT.5)WRITE(6,999)(AP(I),I=1,IP)
999   FORMAT(6X,'AP ',5F10.6)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NEWPRTTAB(NSYM,NFRO,NISH,NRAS1,NRAS2,NRAS3,NSSH,NDEL)

use rassi_global_arrays, only: PART
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NSYM, NFRO(NSYM), NISH(NSYM), NRAS1(NSYM), NRAS2(NSYM), NRAS3(NSYM), NSSH(NSYM), NDEL(NSYM)
integer(kind=iwp) :: IPART, ISUM, ISYM, ITYPE, NPART, NSIZE

NPART = 7
NSIZE = 4+(NSYM+1)*(NPART+1)
ITYPE = 93
call mma_allocate(PART,NSIZE,Label='PART')
PART(1) = NSIZE
PART(2) = ITYPE
PART(3) = NPART
PART(4) = NSYM
do ISYM=1,NSYM
  PART(5+ISYM+(NSYM+1)*1) = NRAS1(ISYM)
  PART(5+ISYM+(NSYM+1)*2) = NRAS2(ISYM)
  PART(5+ISYM+(NSYM+1)*3) = NRAS3(ISYM)
  PART(5+ISYM+(NSYM+1)*4) = NISH(ISYM)
  PART(5+ISYM+(NSYM+1)*5) = NSSH(ISYM)
  PART(5+ISYM+(NSYM+1)*6) = NFRO(ISYM)
  PART(5+ISYM+(NSYM+1)*7) = NDEL(ISYM)
  ISUM = 0
  do IPART=1,7
    ISUM = ISUM+PART(5+ISYM+(NSYM+1)*IPART)
  end do

  ! VV: original code was unrolled uncorrectly by GCC 3.0.4
  !do IPART=1,7
  !  ISUM = ISUM+PART(5+ISYM+(NSYM+1)*IPART)
  !end do

  PART(5+ISYM+(NSYM+1)*0) = ISUM
end do
do IPART=0,7
  ISUM = sum(PART(6+(NSYM+1)*IPART:5+NSYM+(NSYM+1)*IPART))
  PART(5+(NSYM+1)*IPART) = ISUM
end do

end subroutine NEWPRTTAB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Diff_Numerical(nAt,nB,MP,nij,EC,iANr,Ttot,Ttot_Inv,lMax,TP,dLimmo,Thrs1,Thrs2,nThrs,iPrint,ThrsMul,Pot_Expo,Pot_Point, &
                          Pot_Fac,Diffed)

use Index_Functions, only: nTri3_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Three, Ten, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt, nB, nij, iANr(nAt), lMax, nThrs, iPrint
real(kind=wp), intent(in) :: MP(nij,*), EC(3,nij), Ttot(nB,nB), Ttot_Inv(nB,nB), TP(nAt), dLimmo(2), Thrs1, Thrs2, ThrsMul
real(kind=wp), intent(out) :: Pot_Expo(nij*2), Pot_Point(nij), Pot_Fac(nij*4)
logical(kind=iwp), intent(out) :: Diffed(nij*2)
integer(kind=iwp) :: iAtom, iDC, ij, iK, irc, jAtom, k, kaunt, kauntA, kComp, l, nAbove, nEPP, nK, nPick
real(kind=wp) :: A(2), BS, Chi2B, chPoint, dM, dMag, ThrsMul_Clever
logical(kind=iwp) :: AboveMul(2), AboveThr
character(len=50) :: UtChar
character(len=10) :: OneFile
integer(kind=iwp), allocatable :: Center(:), Pick(:)
real(kind=wp), allocatable :: dMullig(:), DPick(:), EPCo(:,:), Potte(:)
real(kind=wp), external :: vdwRad
interface
  subroutine Diff_Aux1(nEPotPoints,EPCo,nB,OneFile)
    import :: wp, iwp
    integer(kind=iwp), intent(out) :: nEPotPoints
    real(kind=wp), allocatable, intent(out) :: EPCo(:,:)
    integer(kind=iwp), intent(in) :: nB
    character(len=10), intent(in) :: OneFile
  end subroutine
end interface

! Pick up some auxiliary stuff.

write(OneFile,'(A)') 'ONEINT'
call Diff_Aux1(nEPP,EPCo,nB,OneFile)
call mma_allocate(Center,nB,label='BasIndCent')
call Get_iArray('Center Index',Center,nB)
call mma_allocate(Pick,nEPP,label='PickPoints')
call mma_allocate(DPick,nEPP,label='DistPick')
call mma_allocate(dMullig,nTri3_Elem1(lMax),label='dMullig')

!-- Do a 'clever' determination of the threshold for the multipole magnitude.

!call Diff_ThrsMul(MP,ThrsMul,ThrsMul_Clever,nAt,nij)
ThrsMul_Clever = ThrsMul

! Run a numerical fit for each active centre.

kauntA = 1
nAbove = 0
do iAtom=1,nAt
  do jAtom=1,iAtom
    ij = iAtom*(iAtom-1)/2+jAtom

    ! Pick up the nuclei+core charge.

    if (iAtom == jAtom) then
      chPoint = TP(iAtom)
    else
      chPoint = Zero
    end if

    ! Pick out the multipole, the prefactors. If none is above a
    ! certain threshold, then it is not meaningful to make them
    ! diffuse. Also check which individual multipoles that should
    ! be made diffuse.

    kaunt = 1
    AboveThr = .false.
    do l=0,lMax
      kComp = (l+1)*(l+2)/2
      dMag = Zero
      do k=1,kComp
        dM = MP(kauntA,kaunt)
        dMullig(kaunt) = dM
        dMag = dMag+dM**2
        kaunt = kaunt+1
      end do
      dMag = sqrt(dMag)
      if ((dMag > ThrsMul_Clever) .and. (l <= 1)) then
        AboveThr = .true.
        AboveMul(l+1) = .true.
      else if ((dMag <= ThrsMul_Clever) .and. (l <= 1)) then
        AboveMul(l+1) = .false.
      end if
    end do

    if (AboveThr) then
      nAbove = nAbove+1

      ! Select the potential points which should be used for this centre.

      !BS = Half*(Bragg_Slater(iANr(iAtom))+Bragg_Slater(iANr(jAtom)))
      BS = Half*(vdWRad(iANr(iAtom))+vdWRad(iANr(jAtom)))
      call PickPoints(nPick,Pick,DPick,nEPP,EPCo,EC(:,ij),dLimmo,BS)

      ! Compute the true potential from the density assigned to this centre.

      call mma_allocate(Potte,nPick,label='Potential')
      call EPotPoint(Potte,nPick,Pick,DPick,Ttot,Ttot_Inv,iANr(iAtom),nB,iAtom,jAtom,Center)

      ! Print the true potential for given centre if requested.

      if (iPrint >= 5) then
        write(UtChar,'(A,2I3)') 'Partial density potential, centre',iAtom,jAtom
        call RecPrt(UtChar,' ',Potte,nPick,1)
      end if

      ! All hail to the chiefs, i.e. Levenberg and Marquardt.

      call LevMarquart(Potte,nPick,Pick,EPCo,EC(:,ij),dMullig,lMax,A,iAtom,jAtom,chPoint,Thrs1,Thrs2,nThrs,Chi2B,iPrint,AboveMul)
      call mma_deallocate(Potte)
    end if

    ! Store things for later.

    kaunt = 1
    Pot_Point(kauntA) = chPoint
    do iDC=1,2
      nK = iDC*(iDC+1)/2
      do iK=1,nK
        Pot_Fac(4*(kauntA-1)+kaunt) = dMullig(kaunt)
        kaunt = kaunt+1
      end do
      if (.not. AboveThr) then
        Diffed(2*(kauntA-1)+iDC) = .false.
      else
        if ((A(iDC) < Three) .and. AboveMul(iDC)) then
          Diffed(2*(kauntA-1)+iDC) = .true.
          Pot_Expo(2*(kauntA-1)+iDC) = A(iDC)
        else
          Diffed(2*(kauntA-1)+iDC) = .false.
          Pot_Expo(2*(kauntA-1)+iDC) = Ten !Dummy
        end if
      end if
    end do

    ! Step the atom-pair counter.

    kauntA = kauntA+1
  end do
end do

! Deallocations.

call mma_deallocate(Center)
call mma_deallocate(Pick)
call mma_deallocate(DPick)
call mma_deallocate(EPCo)
call mma_deallocate(dMullig)
irc = -1
call ClsOne(irc,0)

return

end subroutine Diff_Numerical

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Anders Bernhardsson                              *
!***********************************************************************

subroutine CmbnACB2(FA1,FA2,FB1,FB2,rFinal,Fact,nAlpha,nBeta,C,nC,la,lb,iang,jfhess,Tmp,lsro)
!******************************************************************************
!
! Merges the second derivatives of ECP projection/SRO integrals
! for derivatives of components
!
!******************************************************************************
!
! @parameter FA1    The first derivative of Left side. Includes no derivative
! @parameter FA2    The second derivative of Left side
! @parameter FB1    The first derivative of Right side. Includes no derivative
! @parameter FB2    The second derivative of Right side
! @parameter rFinal Result added up to (out)
! @parameter Fact   Factor the result is multiplied with before added up
! @parameter C      Coefficients for SRO
! @parameter nAlpha Number of exponents LS
! @parameter nBeta  Number of exponents RS
! @parameter nC     Number of exponents in SRO
! @parameter la     Angular monenta LS
! @parameter lb     Angular monenta RS
! @parameter iAng   Angular monenta SRO
! @parameter nBeta  Number of exponents RS
! @parameter nC     Number of exponents in SRO
! @parameter Tmp    Working Area nAlpha*nC (SRO case)
! @parameter lSRO   true for SRO false projection operator
!
!******************************************************************************

use Index_Functions, only: iTri, nTri_Elem1
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAlpha, nBeta, nC, la, lb, iang
logical(kind=iwp), intent(in) :: jfHess(4,3,4,3), lsro
real(kind=wp), intent(in) :: FA1(nAlpha,nC,nTri_Elem1(la),2*iang+1,4), FA2(nAlpha,nC,nTri_Elem1(la),2*iang+1,6), &
                             FB1(nC,nBeta,2*iang+1,nTri_Elem1(lb),4), FB2(nC,nBeta,2*iang+1,nTri_Elem1(lb),6), Fact, &
                             C(nC,merge(nC,0,lsro))
real(kind=wp), intent(inout) :: rFinal(nAlpha*nBeta,nTri_Elem1(la),nTri_Elem1(lb),21)
real(kind=wp), intent(out) :: Tmp(nAlpha,merge(nC,0,lsro))
integer(kind=iwp) :: ia, ib, iC, iCar, jCar, mVec, mVecB

!                                                                      *
!***********************************************************************
!                                                                      *
! Merge integrals with one derivative on each center

do iCar=1,3
  do jCar=1,3
    mVec = itri(iCar+3,jCar)
    if (jfHess(2,iCar,1,jCar)) then
      do ib=1,nTri_Elem1(lb)
        do ia=1,nTri_Elem1(la)
          do iC=1,2*iAng+1

            if (lsro) then
              call mult_sro(FA1(:,:,ia,ic,iCar+1),nAlpha,C,nC,FB1(:,:,ic,ib,jCar+1),nBeta,Fact,rFinal(:,ia,ib,mVec),Tmp)
            else
              call DGEMM_('N','N',nAlpha,nBeta,nC,Fact,FA1(:,:,ia,ic,iCar+1),nAlpha,FB1(:,:,ic,ib,jCar+1),nC,One, &
                          rFinal(:,ia,ib,mVec),nAlpha)
            end if
          end do
        end do
      end do
    end if
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Merge integrals with both derivative on center A
do iCar=1,3
  do jCar=1,iCar
    mVec = itri(iCar,jCar)
    if (jfHess(1,iCar,1,jCar)) then
      do ib=1,nTri_Elem1(lb)
        do ia=1,nTri_Elem1(la)
          do iC=1,2*iAng+1
            if (lsro) then
              call mult_sro(FA2(:,:,ia,ic,mVec),nAlpha,C,nC,FB1(:,:,ic,ib,1),nBeta,Fact,rFinal(:,ia,ib,mVec),Tmp)
            else
              call DGEMM_('N','N',nAlpha,nBeta,nC,Fact,FA2(:,:,ia,ic,mVec),nAlpha,FB1(:,:,ic,ib,1),nC,One,rFinal(:,ia,ib,mVec), &
                          nAlpha)
            end if
          end do
        end do
      end do
    end if
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Merge integrals with both derivative on center B
do iCar=1,3
  do jCar=1,iCar
    mVec = itri(3+iCar,3+jCar)
    mVecB = itri(iCar,jCar)
    if (jfHess(2,iCar,2,jCar)) then

      do ib=1,nTri_Elem1(lb)
        do ia=1,nTri_Elem1(la)

          do iC=1,2*iAng+1
            if (lsro) then
              call mult_sro(FA1(:,:,ia,ic,1),nAlpha,C,nC,FB2(:,:,ic,ib,mVecB),nBeta,Fact,rFinal(:,ia,ib,mVec),Tmp)
            else
              call DGEMM_('N','N',nAlpha,nBeta,nC,Fact,FA1(:,:,ia,ic,1),nAlpha,FB2(:,:,ic,ib,mVecB),nC,One,rFinal(:,ia,ib,mVec), &
                          nAlpha)
            end if
          end do
        end do
      end do
    end if
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine CmbnACB2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine dkh_wspec(n,ord,ndk,ifodd,cdk,wr,rw,t1,t2,
     &                     e,rer,or,ro,info,s1,s2,t3,t4,c)
C
C Calculate U(Word)O_{ord}U^{\dag}(Word) + U(Word)E_{0}U^{\dag}(Word)
C
      implicit none
      integer n,ord,ndk,info,m,i,j,k,L1,L2
      logical ifodd
      Real*8 cdk(ndk),t1(n,n),t2(n,n),e(n,n,ndk),
     & rer(n,n,ndk),or(n,n,ndk),ro(n,n,ndk),wr(n,n),rw(n,n)
      Real*8 s1(n,n,*),s2(n,n,*),t3(n,n),t4(n,n),c(*)
C
      m=ndk/ord
      do L1=1,n
        do L2=1,n
          s1(L2,L1,1) = t1(L2,L1)
          s2(L2,L1,1) = t2(L2,L1)
        end do
      end do
      do i=1,m-1
        do L1=1,n
          do L2=1,n
            t1(L2,L1) = 0.d0
            t2(L2,L1) = 0.d0
          end do
        end do
        call dkh_cofu_spec(ndk,cdk,i+1,c)
        k=(i+1)*ord
        call dkh_woprig(n,ifodd,ord,i*ord,wr,rw,s1(1,1,i),s2(1,1,i),
     &                    s1(1,1,i+1),s2(1,1,i+1),t3,t4 )
        info=info+2
        do L1=1,n
          do L2=1,n
            t1(L2,L1) = t1(L2,L1) + s1(L2,L1,i+1)*c(i+1)
            t2(L2,L1) = t2(L2,L1) + s2(L2,L1,i+1)*c(i+1)
          end do
        end do
        do j=1,i
          call dkh_woplft(n,ifodd,ord,i*ord,wr,rw,s1(1,1,j),
     &                      s2(1,1,j),s1(1,1,j),s2(1,1,j),t3,t4 )
          info=info+2
          do L1=1,n
            do L2=1,n
              t1(L2,L1) = t1(L2,L1) + s1(L2,L1,j)*c(j)
              t2(L2,L1) = t2(L2,L1) + s2(L2,L1,j)*c(j)
            end do
          end do
        end do
        ifodd=.not.ifodd
        if(ifodd)then
          do L1=1,n
            do L2=1,n
              or(L2,L1,k) = or(L2,L1,k) + t1(L2,L1)
              ro(L2,L1,k) = ro(L2,L1,k) + t2(L2,L1)
            end do
          end do
        else
          do L1=1,n
            do L2=1,n
              e(L2,L1,k)   = e(L2,L1,k)   + t1(L2,L1)
              rer(L2,L1,k) = rer(L2,L1,k) + t2(L2,L1)
            end do
          end do
        end if
      end do
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine BitMap_Localisation_Atom(PreFix)

use Localisation_globals, only: AnaNrm, BName, CMO, MOrig, nAtoms, nBas, nFro, nOrb2Loc, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
character(len=2), intent(in) :: PreFix
integer(kind=iwp) :: i, kC1, kC2
logical(kind=iwp) :: Debug
character(len=12) :: BasNam
integer(kind=iwp), allocatable :: nBas_per_Atom(:), nBas_Start(:)
real(kind=wp), allocatable :: Coord(:,:), CAt(:), DAt(:), Den(:), XAt(:)
character(len=*), parameter :: SecNam = 'BitMap_Localisation_Atom'

Debug = .false.

! Symmetry is not allowed!
! ------------------------

if (nSym /= 1) then
  call SysAbendMsg(SecNam,'Symmetry not implemented!','Sorry!')
end if

! Allocate max. sym. block of density matrix
! and atom based density and CMO matrices.
! ------------------------------------------

call mma_allocate(Den,nBas(1)**2,label='BMpLoc')
call mma_allocate(DAt,nAtoms**2,label='DAt')
call mma_allocate(CAt,nAtoms*nOrb2Loc(1),label='CAt')
call mma_allocate(XAt,nAtoms*nOrb2Loc(1),label='XAt')

! Allocate and get index arrays for basis functions per atom.
! -----------------------------------------------------------

call mma_allocate(nBas_per_Atom,nAtoms,label='nB_per_Atom')
call mma_allocate(nBas_Start,nAtoms,label='nB_Start')
call BasFun_Atom(nBas_per_Atom,nBas_Start,BName,nBas(1),nAtoms,Debug)

! Compute density matrix, Den = CC^T, and set atom based matrices.
! Generate bitmap and perform sparsity analysis.
! ----------------------------------------------------------------

kC1 = nBas(1)*nFro(1)+1
call GetDens_Localisation(Den,MOrig(kC1),nBas(1),nOrb2Loc(1))
call GetAt_Localisation(Den,nBas(1),nBas(1),DAt,nAtoms,2,nBas_per_Atom,nBas_Start,AnaNrm)
call GetAt_Localisation(MOrig(kC1),nBas(1),nOrb2Loc(1),CAt,nAtoms,1,nBas_per_Atom,nBas_Start,AnaNrm)
call GetAt_Localisation(CMO(kC1),nBas(1),nOrb2Loc(1),XAt,nAtoms,1,nBas_per_Atom,nBas_Start,AnaNrm)
call GenBMp_Localisation(DAt,CAt,XAt,nAtoms,1,'r','r','r',PreFix)
call Anasize_Localisation(DAt,CAt,XAt,nAtoms,nOrb2Loc(1),1)
write(u6,*) 'Bitmap files have been generated. Norm: ',AnaNrm

! Allocate memory for nuclear coordinates.
! Read nuclear coordinates from the runfile.
! Generate gnuplot files.
! ------------------------------------------

call mma_allocate(Coord,3,nAtoms,label='NucCoord')
call Get_dArray('Unique Coordinates',Coord,3*nAtoms)

call GetAt_Localisation(Den,nBas(1),nBas(1),DAt,nAtoms,2,nBas_per_Atom,nBas_Start,AnaNrm)
write(BasNam,'(A2,A10)') PreFix,'TotDensity'
call GenGnu_Localisation(BasNam,DAt,Coord,nAtoms)
kC1 = nBas(1)*nFro(1)+1
do i=1,nOrb2Loc(1)
  kC2 = kC1+nBas(1)*(i-1)
  call GetDens_Localisation(Den,MOrig(kC2),nBas(1),1)
  call GetAt_Localisation(Den,nBas(1),nBas(1),DAt,nAtoms,2,nBas_per_Atom,nBas_Start,AnaNrm)
  write(BasNam,'(A2,A4,I6)') PreFix,'Dini',i
  call GenGnu_Localisation(BasNam,DAt,Coord,nAtoms)
end do
do i=1,nOrb2Loc(1)
  kC2 = kC1+nBas(1)*(i-1)
  call GetDens_Localisation(Den,CMO(kC2),nBas(1),1)
  call GetAt_Localisation(Den,nBas(1),nBas(1),DAt,nAtoms,2,nBas_per_Atom,nBas_Start,AnaNrm)
  write(BasNam,'(A2,A4,I6)') PreFix,'Dloc',i
  call GenGnu_Localisation(BasNam,DAt,Coord,nAtoms)
end do
write(u6,*) 'Gnuplot files have been generated. Norm: ',AnaNrm

! De-allocations.
! ---------------

call mma_deallocate(Den)
call mma_deallocate(CAt)
call mma_deallocate(DAt)
call mma_deallocate(XAt)
call mma_deallocate(nBas_per_Atom)
call mma_deallocate(nBas_Start)
call mma_deallocate(Coord)

end subroutine BitMap_Localisation_Atom

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

subroutine CsfInf(lSym,iSpin,iSPC,nsym)

use Str_Info, only: CFTP, CNSM, DFTP, DTOC, NELEC, NOCTYP, STR
use MCLR_Data, only: i1, iAnders, IASTFI, IBSTFI, iDC, iRefSM, lConf, llDET, LuCSF2SD, MAXOP, MINOP, MNR1IC, MS2, MXR3IC, NACOB, &
                     NCNATS, NELCI, NORB1, NORB2, NORB3, PSSIGN
use CandS, only: ICSM, ICSPC, ISSM, ISSPC
use input_mclr, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lSym, iSpin, iSPC, nsym
integer(kind=iwp) :: IA, IATP, IBTP, idum(1), ISYM, LLCSF, MNELR1, MXELR3, NCOMB, NEL, NOCTPA, NOCTPB, NOOS
integer(kind=iwp), allocatable :: IOOS1(:), NOOS1(:), SBLTP(:), SIOIO(:)

! Sorry about this  but this is just to tell the program
! that no CSF<->SD coefficents is in core
i1 = -9
iAnders = -9
ICSM = lSym
ISSM = lSym
ICSPC = 1
ISSPC = 1
NEL = NELCI(ISPC)
IATP = IASTFI(ISPC)
IBTP = IBSTFI(ISPC)
NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)
MNELR1 = MNR1IC(ISPC)
!MXELR3 = MNR1IC(ISPC)
MXELR3 = MXR3IC(ISPC)
iRefSm = lsym
! Obtain OOS pointer array
call mma_allocate(SIOIO,NOCTPA*NOCTPB,Label='SIOIO')
call IAIBCM_MCLR(MNR1IC(ISSPC),MXR3IC(ISSPC),NOCTPA,NOCTPB,Str(IATP)%EL1,Str(IATP)%EL3,Str(IBTP)%EL1,Str(IBTP)%EL3,SIOIO)
call mma_allocate(SBLTP,nIrrep,Label='SBLTP')
NOOS = NOCTPA*NOCTPB*nIrrep
call mma_allocate(IOOS1,NOOS,Label='IOOS1')
call mma_allocate(NOOS1,NOOS,Label='NOOS1')
call INTCSF(NACOB,NEL,iSpin,MS2,NORB1,NORB2,NORB3,MNELR1,MXELR3,LLCSF,1,PSSIGN,lconf,lldet)

! Calculate CG COEFFICENTS ETC

call CSDTMT(DFTP,CFTP,DTOC,PSSIGN)

! Calculate the reordering vector and write it to disk

iA = 0
do iSym=1,nSym
  !OOS arrayy
  call ZBLTP(ISYM,nIrrep,IDC,SBLTP,idum)
  call ZOOS(ISYM,SBLTP,nIrrep,SIOIO,Str(IATP)%NSTSO,Str(IBTP)%NSTSO,NOCTPA,NOCTPB,idc,IOOS1,NOOS1,NCOMB,0)
  !EAW call CNFORD(CNSM(1)%ICTS,CNSM(1)%ICONF,iSym,NACOB,DFTP,NCNATS(1,ISYM),NEL,0,IDUM,IDUM,IASTFI(ISPC),IBSTFI(ISPC),IOOS1, &
  !                NORB1,NORB2,NORB3,MNELR1,MXELR3,NELEC(IASTFI(ISPC)),NELEC(IBSTFI(ISPC)),MINOP,MAXOP)
  call CNFORD(CNSM(1)%ICTS,CNSM(1)%ICONF,iSym,NACOB,DFTP,NCNATS(1,ISYM),NEL,0,IDUM,IDUM,IASTFI(ISPC),IBSTFI(ISPC),IOOS1,NORB1, &
              NORB2,NORB3,MNELR1,MXELR3,NELEC(IASTFI(ISPC)),NELEC(IBSTFI(ISPC)),MINOP,MAXOP,PSSIGN)

  call iDAFILE(LUCSF2SD,1,CNSM(1)%ICTS,lldet,iA)
  call iDAFILE(LUCSF2SD,1,CNSM(1)%ICONF,lconf,iA)
end do

call mma_deallocate(CNSM(1)%ICTS)
call mma_deallocate(CNSM(1)%ICONF)
call mma_deallocate(IOOS1)
call mma_deallocate(NOOS1)
call mma_deallocate(SBLTP)
call mma_deallocate(SIOIO)

end subroutine CsfInf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RFMmG(nHer,MmRFG,la,lb,lr)
*
      nHer=(la+lb+lr+1+2)/2
      MmRFG = 3*nHer*(la+2) +
     &         3*nHer*(lb+2) +
     &         3*nHer*(lr+1) +
     &         3*(la+2)*(lb+2)*(lr+1) + 4 + 3*nHer
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MoReduce(nBas,MOsToKeep,ipAvRedMO)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "files_qmstat.fh"
#include "qminp.fh"
#include "qm2.fh"
#include "numbers.fh"
#include "WrkSpc.fh"
*Removed by Valera or maybe it wasn't in his version #include "MolcasQmStat.fh"
#include "lenin.fh"

      Parameter (ReduceWarning=0.5d0)

      Dimension nBas(MxSym),iTocBig(MxStOT)

      Character Header*50,BsLbl*1

      Dimension BsLbl(LENIN8*MxBas)

      Logical LindMOs(MxBas),First

      Data First /.true./

      Dimension Dummy(1)

*
*--- A word of welcome.
*
      Write(6,*)'     ----- Transform to average natural MO-reduced'
     &//' basis.'
*
*--- First we accumulate the different density matrices.
*
      nSize=nBas(1)*(nBas(1)+1)/2
      nStri=nState*(nState+1)/2
      weight=ONE/dble(nState)
      Call GetMem('DenM','Allo','Real',iDin,nSize)
      Call GetMem('DenA','Allo','Real',iDav,nSize)
      call dcopy_(nSize,[ZERO],iZERO,Work(iDav),iONE)
      Do 201, iS1=1,nState
        Do 202, iS2=1,iS1
          index=(iS1*(iS1-1)/2+iS2-1)*nSize
          call dcopy_(nSize,Work(iBigT+index),iONE,Work(iDin),iONE)
          If(iS1.ne.iS2) GoTo 202
          kaunt=0
          Do 203, iB1=1,nBas(1)
            Do 204, iB2=1,iB1
              If(iB1.eq.iB2) then
                Fac=1.0d0*weight
              Else
                Fac=0.5d0*weight
              Endif
              Work(iDav+kaunt)=Work(iDav+kaunt)+Work(iDin+kaunt)*Fac
              kaunt=kaunt+1
204         Continue
203       Continue
202     Continue
201   Continue
*
*--- Then since we are working in the non-orthogonal AO-basis,
*    it is necessary to orthogonalize before we diagonalize
*    accumulated density.
*
      Call GetMem('Vecs','Allo','Real',iVecs,nBas(1)**2)
      Call GetMem('Vecs2','Allo','Real',iVecs2,nBas(1)**2)
      Call GetMem('AuxS','Allo','Real',iAUX,nBas(1)**2)
      Call GetMem('OvlSs','Allo','Real',iSs,nBas(1)**2)
      Call GetMem('OvlSs','Allo','Real',iSx,nSize)
      Call GetMem('OvlSi','Allo','Real',iSst,nBas(1)**2)
      Call GetMem('OvlSi','Allo','Real',iSt,nSize)
      Call GetMem('DavSq','Allo','Real',iDavS,nBas(1)**2)
      Call GetMem('Trans','Allo','Real',iTrans,nBas(1)**2)
      Call GetMem('Trans','Allo','Real',iTransB,nBas(1)**2)
      Call GetMem('OrtoAvDen','Allo','Real',iOtD,nBas(1)**2)
      Call GetMem('OrtoAcDeT','Allo','Real',iOtDt,nSize)
      Call GetMem('OvlS','Allo','Real',iS,nSize+4)
      Call GetMem('Occs','Allo','Real',iOcc,nBas(1))
      kaunter=0
      Do 211, iB1=1,nBas(1)
        Do 212, iB2=1,nBas(1)
          Work(iVecs+kaunter)=0
          If(iB1.eq.iB2)Work(iVecs+kaunter)=1
          kaunter=kaunter+1
212     Continue
211   Continue
*--- Symmetric orthogonalization, hence get overlap matrix, S.
      Lu_One=92
      Call OpnOne(irc,0,'ONEINT',Lu_One)
      irc=-1
      iopt=0
      iSmLbl=0
      icomp=1
      Call RdOne(irc,iopt,'Mltpl  0',icomp,Work(iS),iSmLbl)
      Call Jacob(Work(iS),Work(iVecs),nBas(1),nBas(1))
      call dcopy_(nSize,[ZERO],iZERO,Work(iSx),iONE)
      call dcopy_(nSize,[ZERO],iZERO,Work(iSt),iONE)
      Do 221, i=1,nBas(1)
        Sqroot=sqrt(Work(iS+i*(i+1)/2-1))
        Work(iSx+i*(i+1)/2-1)=ONE/Sqroot
        Work(iSt+i*(i+1)/2-1)=Sqroot
221   Continue
      Call Square(Work(iSx),Work(iSs),iONE,nBas(1),nBas(1))
      Call Square(Work(iSt),Work(iSst),iONE,nBas(1),nBas(1))
*------S^(-1/2)
      Call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),ONE,Work(iVecs)
     &          ,nBas(1),Work(iSs),nBas(1),ZERO,Work(iAUX),nBas(1))
      Call Dgemm_('N','T',nBas(1),nBas(1),nBas(1),ONE,Work(iAUX)
     &          ,nBas(1),Work(iVecs),nBas(1),ZERO,Work(iTrans),nBas(1))
*------S^(1/2)
      Call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),ONE,Work(iVecs)
     &          ,nBas(1),Work(iSst),nBas(1),ZERO,Work(iAUX),nBas(1))
      Call Dgemm_('N','T',nBas(1),nBas(1),nBas(1),ONE,Work(iAUX)
     &          ,nBas(1),Work(iVecs),nBas(1),ZERO,Work(iTransB),nBas(1))
*--- The density matrix transforms 'inversly' from the matrix-elements,
*    thus let S^(1/2) transform it, not S^(-1/2) which applies to the
*    matrix elements.
      Call Square(Work(iDav),Work(iDavS),iONE,nBas(1),nBas(1))
      Call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),ONE,Work(iTransB)
     &          ,nBas(1),Work(iDavS),nBas(1),ZERO,Work(iAUX),nBas(1))
      Call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),ONE,Work(iAUX)
     &          ,nBas(1),Work(iTransB),nBas(1),ZERO,Work(iOtD),nBas(1))
      kaunter=0
      Do 213, iB1=1,nBas(1)
        Do 214, iB2=1,nBas(1)
          Work(iVecs2+kaunter)=0
          If(iB1.eq.iB2)Work(iVecs2+kaunter)=1
          kaunter=kaunter+1
214     Continue
213   Continue
      Call SqToTri_Q(Work(iOtD),Work(iOtDt),nBas(1))
      Call Jacob(Work(iOtDt),Work(iVecs2),nBas(1),nBas(1))
*--- With diagonalized density matrix, collect occupation numbers and
*    natural orbital coefficients.
      Call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),ONE,Work(iTrans)
     &          ,nBas(1),Work(iVecs2),nBas(1),ZERO,Work(iAUX),nBas(1))
      kaunt=0
      kaunter=0
      Do 231, i=1,nBas(1)
        Do 232, j=1,i
          If(i.eq.j) then
            Work(iOcc+kaunt)=Work(iOtDt+kaunter)
            kaunt=kaunt+1
          Endif
          kaunter=kaunter+1
232     Continue
231   Continue
      TraceFull=0
      Do 233, i=1,nBas(1)
        TraceFull=TraceFull+Work(iOcc+i-1)
233   Continue
      If(iPrint.ge.10) then
        Call Get_cArray('Unique Basis Names',BsLbl,LENIN8*nBas(1))
        Write(Header,'(A)')'All average transition density orbitals'
        ThrOcc=-1D-0
        Call Primo(Header,.true.,.false.,ThrOcc,Dum,iONE,nBas(1),nBas(1)
     &            ,BsLbl,Dummy,Work(iOcc),Work(iAUX),-1)
        Write(6,*)
        Write(6,*)'  Trace = ',TraceFull
      Endif
*--- Deallocations.
      Call GetMem('DenM','Free','Real',iDin,nSize)
      Call GetMem('DenA','Free','Real',iDav,nSize)
      Call GetMem('Vecs','Free','Real',iVecs,nBas(1)**2)
      Call GetMem('Vecs2','Free','Real',iVecs2,nBas(1)**2)
      Call GetMem('OvlSs','Free','Real',iSs,nBas(1)**2)
      Call GetMem('OvlSs','Free','Real',iSx,nSize)
      Call GetMem('OvlSi','Free','Real',iSst,nBas(1)**2)
      Call GetMem('OvlSi','Free','Real',iSt,nSize)
      Call GetMem('DavSq','Free','Real',iDavS,nBas(1)**2)
      Call GetMem('Trans','Free','Real',iTrans,nBas(1)**2)
      Call GetMem('Trans','Free','Real',iTransB,nBas(1)**2)
      Call GetMem('OrtoAvDen','Free','Real',iOtD,nBas(1)**2)
      Call GetMem('OrtoAcDeT','Free','Real',iOtDt,nSize)
      Call GetMem('OvlS','Free','Real',iS,nSize+4)

*
*--- Jetzt far wir mal wieder. Reduce MO-basis according to input
*    criterion.
*
      MOsToKeep=0
      Do 301, iB=1,nBas(1)
        If(Work(iOcc+iB-1).ge.ThrsRedOcc) then
          LindMOs(iB)=.true.
          MOsToKeep=MOsToKeep+1
        Else
          LindMOs(iB)=.false.
        Endif
301   Continue
      nSize=nBas(1)*MOsToKeep
      Call GetMem('UncleMoe','Allo','Real',ipAvRedMO,nSize)
      Call GetMem('NewOccs','Allo','Real',iNewOcc,MOsToKeep)
      ind2=0
      ind3=0
*--- Loop to suck-out the nice MOs.
      Do 302, iB=1,nBas(1)
        If(LindMOs(iB)) then
          ind1=nBas(1)*(iB-1)
          call dcopy_(nBas(1),Work(iAUX+ind1),iONE,Work(ipAvRedMO+ind2)
     &              ,iONE)
          Work(iNewOcc+ind3)=Work(iOcc+iB-1)
          ind2=ind2+nBas(1)
          ind3=ind3+1
        Endif
302   Continue
      TraceRed=0
      Do 303, i=1,MOsToKeep
        TraceRed=TraceRed+Work(iNewOcc+i-1)
303   Continue
*--- Make a trace check.
      If((TraceFull-TraceRed).ge.ReduceWarning) then
        Write(6,*)
        Write(6,*)'WARNING!  With your occupation threshold, the densit'
     &//'y matrix trace'
        Write(6,*)'differs by ',TraceFull-TraceRed,'.'
        Write(6,*)'You should consider lowering the threshold!'
      Endif
      If(iPrint.ge.5) then
        Call Get_cArray('Unique Basis Names',BsLbl,LENIN8*nBas(1))
        Write(Header,'(A)')'Reduced average orbitals'
        ThrOcc=-1D-0
        Call Primo(Header,.true.,.false.,ThrOcc,Dum,iONE,nBas(1)
     &            ,[MOsToKeep],BsLbl,Dummy,Work(iNewOcc)
     &            ,Work(ipAvRedMO),-1)
        Write(6,*)
        Write(6,*)'  Trace = ',TraceRed,MOsToKeep
      Endif

*
*--- Time to reduce all individual density matrices in the big TDM to
*    the reduced MO-basis. Once more, observe that the density
*    transforms contravariantly. But sadly, we need to invert the
*    full square MO-matrix before we make reductions.
*
      Call GetMem('InverseC','Allo','Real',ipInv,nBas(1)**2)
      Call MInv(Work(iAUX),Work(ipInv),Ising,Det,nBas(1))

*
*--- Now all those transformations and density reductions. To check for
*    density losses, the overlaps are read. These partially transformed
*    transition density matrix is stored in a scratch file.
*
      DiffMegaMax=0.0d0
      nSize=nBas(1)*(nBas(1)+1)/2
      nMtK=MOsToKeep*(MOsToKeep+1)/2
      Call GetMem('Temporary','Allo','Real',ipTEMP,nBas(1)**2)
      Call GetMem('MOtrDen','Allo','Real',ipTmoD,nBas(1)**2)
      Call GetMem('MOreDen','Allo','Real',ipTreD,MOsToKeep**2)
      Call GetMem('MOreDen','Allo','Real',ipTreT,nMtK)
      Call GetMem('DenM','Allo','Real',iDin,nSize)
      Call GetMem('DenMsq','Allo','Real',iDsq,nBas(1)**2)
      Call GetMem('OvlS','Allo','Real',iS,nSize+4)
      Call GetMem('Ssquare','Allo','Real',iSsq,nBas(1)**2)
      Call GetMem('Strans','Allo','Real',iStrans,nBas(1)**2)
      Call GetMem('Stri','Allo','Real',iStri,nMtK)
      Lu_Scratch=57
      Lu_Scratch=IsFreeUnit(Lu_Scratch)
      Call DaName(Lu_Scratch,'TDMSCR')
      irc=-1
      iopt=0
      iSmLbl=0
      icomp=1
      Call RdOne(irc,iopt,'Mltpl  0',icomp,Work(iS),iSmLbl)
      Call ClsOne(irc,iopt)
      iDiskUt=0
      Call iDaFile(Lu_Scratch,1,iTocBig,MxStOT,iDiskUt)
      Do 401, iS1=1,nState
        Do 402, iS2=1,iS1
*------- Collect this particular density matrix.
          index=(iS1*(iS1-1)/2+iS2-1)*nSize
          call dcopy_(nSize,Work(iBigT+index),iONE,Work(iDin),iONE)
*------- Square it and correct the non-diagonal (recall convention)
          Call Dsq(Work(iDin),Work(iDsq),iONE,nBas(1),nBas(1))
*------- Contravariant transformation of density matrix.
          Call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),ONE,Work(ipInv)
     &              ,nBas(1),Work(iDsq),nBas(1),ZERO,Work(ipTEMP)
     &              ,nBas(1))
          Call Dgemm_('N','T',nBas(1),nBas(1),nBas(1),ONE,Work(ipTEMP)
     &              ,nBas(1),Work(ipInv),nBas(1),ZERO,Work(ipTmoD)
     &              ,nBas(1))
*------- Covariant transformation of overlap matrix.
          Call Square(Work(iS),Work(iSsq),iONE,nBas(1),nBas(1))
          Call Dgemm_('T','N',nBas(1),nBas(1),nBas(1),ONE,Work(iAUX)
     &              ,nBas(1),Work(iSsq),nBas(1),ZERO,Work(ipTEMP)
     &              ,nBas(1))
          Call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),ONE,Work(ipTEMP)
     &              ,nBas(1),Work(iAUX),nBas(1),ZERO,Work(iStrans)
     &              ,nBas(1))
*------- How much charge ('overlap') is there in this density element?
          ChargeNonReduced=Ddot_(nBas(1)**2,Work(ipTmoD),iONE
     &                         ,Work(iStrans),iONE)
*------- Reduction of density matrix and overlap matrix.
          kaunter=0
          ind1=0
          Do 405, iM1=1,nBas(1)
            Do 406, iM2=1,nBas(1)
              If(LindMOs(iM1).and.LindMOs(iM2)) then
                Work(ipTreD+ind1)=Work(ipTmoD+kaunter)
                Work(iSsq+ind1)=Work(iStrans+kaunter)
                ind1=ind1+1
              Endif
              kaunter=kaunter+1
406         Continue
405       Continue
*------- Triangualize, jetzt!
          kaunter=0
          Do 407, iM1=1,MOsToKeep
            Do 408, iM2=1,MOsToKeep
              If(iM1.ne.iM2)Work(ipTreD+kaunter)=2*Work(ipTreD+kaunter)
              kaunter=kaunter+1
408         Continue
407       Continue
          Call SqToTri_Q(Work(ipTreD),Work(ipTreT),MOsToKeep)
          Call SqToTri_Q(Work(iSsq),Work(iStri),MOsToKeep)
*------- Compute total electronic charge of this reduced density.
          ChargeReduced=Ddot_(nMtK,Work(ipTreT),iONE,Work(iStri),iONE)
*------- Renormalize to get right charge ('overlap'); to safeguard
*        against zero overlaps, make check.
          If(abs(ChargeNonReduced).le.1D-7.or.
     &          abs(ChargeReduced).le.1D-7) then
            Fac=1.0D0
          Else
            Fac=ChargeNonReduced/ChargeReduced
          Endif
          kaunter=0
          Do 409, iM1=1,MOsToKeep
            Do 410, iM2=1,iM1
              Work(ipTreT+kaunter)=Work(ipTreT+kaunter)*Fac
              kaunter=kaunter+1
410         Continue
409       Continue
*------- If sufficient printlevel, show moment modifications.
          If(iPrint.ge.10) then
            Call MomentMod(ipTreT,ipTmoD,iAUX,MOsToKeep,nBas(1),LindMOs
     &                    ,iS1,iS2,First,DiffMax)
            If(DiffMax.gt.DiffMegaMax) DiffMegaMax=DiffMax
          Endif
*------- Add previous disk address to T-o-C.
          ind=iS1*(iS1+1)/2-iS1+iS2
          iTocBig(ind)=iDiskUt
*------- 'Because I will take a gigant dump on you!'
          Call dDaFile(Lu_Scratch,1,Work(ipTreT),nMtk,iDiskUt)
402     Continue
401   Continue
*--- The real table-of-content
      iDiskUt=0
      Call iDaFile(Lu_Scratch,1,iTocBig,MxStOT,iDiskUt)
*--- Deallocations and closing.
      Call GetMem('NewOccs','Free','Real',iNewOcc,MOsToKeep)
      Call GetMem('InverseC','Free','Real',ipInv,nBas(1)**2)
      Call GetMem('Temporary','Free','Real',ipTEMP,nBas(1)**2)
      Call GetMem('MOtrDen','Free','Real',ipTmoD,nBas(1)**2)
      Call GetMem('MOreDen','Free','Real',ipTreD,MOsToKeep**2)
      Call GetMem('MOreDen','Free','Real',ipTreT,nMtK)
      Call GetMem('DenM','Free','Real',iDin,nSize)
      Call GetMem('DenMsq','Free','Real',iDsq,nBas(1)**2)
      Call GetMem('OvlS','Free','Real',iS,nSize+4)
      Call GetMem('Ssquare','Free','Real',iSsq,nBas(1)**2)
      Call GetMem('Strans','Free','Real',iStrans,nBas(1)**2)
      Call GetMem('Stri','Free','Real',iStri,nMtK)
      Call GetMem('AuxS','Free','Real',iAUX,nBas(1)**2)
      Call GetMem('Occs','Free','Real',iOcc,nBas(1))
      Call DaClos(Lu_Scratch)

*
*--- Report on the reduction.
*
      Write(6,*)
      Write(6,90)'AO-basis ---> MO-basis reduction complete.'
      Write(6,91)'From ',nBas(1),' functions to ',MosToKeep,'.'
      Write(6,90)'Reduced basis renormalized to have same overlap as no'
     &//'n-reduced.'
      If(iPrint.ge.10) then
        Write(6,92)'Largest dipole difference is ',DiffMegaMax
      Endif
90    Format('        ',A)
91    Format('        ',A,I3,A,I3,A)
92    Format('        ',A,F10.7)

      Return
      End


      Subroutine MomentMod(ipRe,ipNRe,iCmo,nBRe,nBNRe,LindMOs,iS1,iS2
     &                    ,First,DiffMax)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "files_qmstat.fh"
#include "qminp.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension DipRe(3),DipNRe(3)

      Logical LindMOs(MxBas),First

      If(First.and.iPrint.ge.5) then
        Write(6,*)
        Write(6,*)'     Modifications of dipoles by renormalization and'
     &//' basis reduction.'
        Write(6,*)
        Write(6,*)'     State pair    |  Difference '
        Write(6,*)'     --------------|---------------------'
        First=.false.
      Endif

      nSize1=nBNRe*(nBNRe+1)/2
      nSize2=nBRe*(nBRe+1)/2
      Call GetMem('DipX','Allo','Real',ipDx,nSize1+4)
      Call GetMem('DipY','Allo','Real',ipDy,nSize1+4)
      Call GetMem('DipZ','Allo','Real',ipDz,nSize1+4)
      Call GetMem('DipXre','Allo','Real',ipDxRe,nSize2)
      Call GetMem('DipYre','Allo','Real',ipDyRe,nSize2)
      Call GetMem('DipZre','Allo','Real',ipDzRe,nSize2)
      Call GetMem('DipXsq','Allo','Real',ipDxsq,nBNRe**2)
      Call GetMem('DipYsq','Allo','Real',ipDysq,nBNRe**2)
      Call GetMem('DipZsq','Allo','Real',ipDzsq,nBNRe**2)
      Call GetMem('DipXm','Allo','Real',ipDxM,nBNRe**2)
      Call GetMem('DipYm','Allo','Real',ipDyM,nBNRe**2)
      Call GetMem('DipZm','Allo','Real',ipDzM,nBNRe**2)
      Call GetMem('TEMP','Allo','Real',ipTEMP,nBNRe**2)
      irc=-1
      iopt=0
      iSmLbl=0
*--- X
      icomp=1
      Call RdOne(irc,iopt,'Mltpl  1',icomp,Work(ipDx),iSmLbl)
      Call Square(Work(ipDx),Work(ipDxsq),iONE,nBNRe,nBNRe)
      Call Dgemm_('T','N',nBNRe,nBNRe,nBNRe,ONE,Work(iCmo)
     &          ,nBNRe,Work(ipDxsq),nBNRe,ZERO,Work(ipTEMP)
     &          ,nBNRe)
      Call Dgemm_('N','N',nBNRe,nBNRe,nBNRe,ONE,Work(ipTEMP)
     &          ,nBNRe,Work(iCmo),nBNRe,ZERO,Work(ipDxM)
     &          ,nBNRe)
*--- Y
      icomp=2
      Call RdOne(irc,iopt,'Mltpl  1',icomp,Work(ipDy),iSmLbl)
      Call Square(Work(ipDy),Work(ipDysq),iONE,nBNRe,nBNRe)
      Call Dgemm_('T','N',nBNRe,nBNRe,nBNRe,ONE,Work(iCmo)
     &          ,nBNRe,Work(ipDysq),nBNRe,ZERO,Work(ipTEMP)
     &          ,nBNRe)
      Call Dgemm_('N','N',nBNRe,nBNRe,nBNRe,ONE,Work(ipTEMP)
     &          ,nBNRe,Work(iCmo),nBNRe,ZERO,Work(ipDyM)
     &          ,nBNRe)
*--- Z
      icomp=3
      Call RdOne(irc,iopt,'Mltpl  1',icomp,Work(ipDz),iSmLbl)
      Call Square(Work(ipDz),Work(ipDzsq),iONE,nBNRe,nBNRe)
      Call Dgemm_('T','N',nBNRe,nBNRe,nBNRe,ONE,Work(iCmo)
     &          ,nBNRe,Work(ipDzsq),nBNRe,ZERO,Work(ipTEMP)
     &          ,nBNRe)
      Call Dgemm_('N','N',nBNRe,nBNRe,nBNRe,ONE,Work(ipTEMP)
     &          ,nBNRe,Work(iCmo),nBNRe,ZERO,Work(ipDzM)
     &          ,nBNRe)
*--- Triangualize and reduce.
      kaunt1=0
      kaunt2=0
      Do 2001, i=1,nBNRe
        Do 2002, j=1,nBNRe
          If(j.le.i) then
            If(LindMOs(i).and.LindMOs(j)) then
              Work(ipDxRe+kaunt1)=Work(ipDxM+kaunt2)
              Work(ipDyRe+kaunt1)=Work(ipDyM+kaunt2)
              Work(ipDzRe+kaunt1)=Work(ipDzM+kaunt2)
              kaunt1=kaunt1+1
            Endif
          Endif
          kaunt2=kaunt2+1
2002    Continue
2001  Continue
*--- Density
      DipNRe(1)=Ddot_(nBNRe**2,Work(ipDxM),iONE,Work(ipNRe),iONE)
      DipNRe(2)=Ddot_(nBNRe**2,Work(ipDyM),iONE,Work(ipNRe),iONE)
      DipNRe(3)=Ddot_(nBNRe**2,Work(ipDzM),iONE,Work(ipNRe),iONE)
      DipRe(1)=Ddot_(nSize2,Work(ipDxRe),iONE,Work(ipRe),iONE)
      DipRe(2)=Ddot_(nSize2,Work(ipDyRe),iONE,Work(ipRe),iONE)
      DipRe(3)=Ddot_(nSize2,Work(ipDzRe),iONE,Work(ipRe),iONE)
      Diffx=abs(DipRe(1)-DipNRe(1))
      Diffy=abs(DipRe(2)-DipNRe(2))
      Diffz=abs(DipRe(3)-DipNRe(3))
      If(iPrint.ge.5) then
        Write(6,99)iS1,iS2,'(',Diffx,',',Diffy,',',Diffz,')'
      Endif
99    Format('     ',2I3,'          ',3(A,F10.7),A)
*--- Return number
      DiffMax=Diffy
      If(Diffx.ge.Diffy) DiffMax=Diffx
      If(Diffz.ge.Diffx.and.Diffz.ge.Diffy) DiffMax=Diffz
*--- Deallocate en masse.
      Call GetMem('DipX','Free','Real',ipDx,nSize1+4)
      Call GetMem('DipY','Free','Real',ipDy,nSize1+4)
      Call GetMem('DipZ','Free','Real',ipDz,nSize1+4)
      Call GetMem('DipXre','Free','Real',ipDxRe,nSize2)
      Call GetMem('DipYre','Free','Real',ipDyRe,nSize2)
      Call GetMem('DipZre','Free','Real',ipDzRe,nSize2)
      Call GetMem('DipXsq','Free','Real',ipDxsq,nBNRe**2)
      Call GetMem('DipYsq','Free','Real',ipDysq,nBNRe**2)
      Call GetMem('DipZsq','Free','Real',ipDzsq,nBNRe**2)
      Call GetMem('DipXm','Free','Real',ipDxM,nBNRe**2)
      Call GetMem('DipYm','Free','Real',ipDyM,nBNRe**2)
      Call GetMem('DipZm','Free','Real',ipDzM,nBNRe**2)
      Call GetMem('TEMP','Free','Real',ipTEMP,nBNRe**2)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  ChoDec_MxVec
!
!> @brief
!>   Decompose a symmetric positive (semi-)definite matrix
!> @author Thomas Bondo Pedersen
!>
!> @details
!> ::ChoDec_MxVec will Cholesky decompose a positive (semi-)definite
!> matrix without knowledge of all its elements (i.e., using a
!> matrix-direct approach).
!>
!> Given the diagonal, the idea is that ::ChoDec_MxVec asks the
!> caller for specified columns of the matrix when needed during
!> decomposition. This is done by invoking the external routine
!> passed as \p CD_Col. Similarly, the caller must provide an
!> external routine, passed as \p CD_Vec, that handles the Cholesky
!> vector buffer---that is, empties or fills the buffer (\p CD_Vec
!> could e.g. do Cholesky vector I/O).
!>
!> Unlike ::ChoDec, however, this routine will stop when either of
!> the following conditions are met:
!>
!> 1. max. diagonal &le; \p Thr
!> 2. number of vectors = \p MxVec
!>
!> The external subroutine \p CD_Col must have the following call
!> pattern:
!>
!> \code
!>   Call CD_Col(Col,nDim,iCol,nCol,Buf,lBuf)
!> \endcode
!>
!> where \p Col(nDim,nCol) contains the columns, \p iCol(nCol) specifies
!> the columns requested [i.e., column \p Col(*,i) should correspond
!> to column \p iCol(i) in the full matrix], and \p Buf(lBuf) can be
!> used as (perhaps additional) work space.
!>
!> The external subroutine \p CD_Vec must have the following call
!> pattern:
!>
!> \code
!>   Call CD_Vec(iVec1,nVec,Buf,lBuf,nDim,iOpt)
!> \endcode
!>
!> where \p iVec1 is the index of the first vector, \p nVec the number
!> of vectors, and \p nDim the vector dimension. The buffer \p Buf has
!> total dimension \p lBuf. For \p iOpt = ``1`` ("empty buffer option"),
!> the first \p nDim*\p nVec elements of Buf contain the vectors on
!> input---i.e. \p CD_Vec is expected to move the vectors to another
!> location so that all of \p Buf is again available for use.
!> For \p iOpt = ``2`` ("fill buffer option"), the process is reversed and
!> ::ChoDec_MxVec expects \p CD_Vec to return vectors
!> \p iVec1, \p iVec1+1, ..., \p iVec1+ \p nVec-1, in the first \p nDim*\p nVec elements
!> of \p Buf.
!>
!> The error code \p irc is ``0`` if success, while a non-zero number
!> is returned if some failure (or if the matrix is not positive
!> (semi-)definite) occurs. In the latter cases, the
!> decomposition is ill-defined and the data returned is junk!
!>
!> @note
!> \p Thr and \p Span may be reset in this routine (if they
!> are not properly defined on input).
!>
!> @param[in]     CD_Col  External subroutine for retrieving matrix columns
!> @param[in]     CD_Vec  External subroutine for filling and emptying Cholesky vector buffer
!> @param[in]     MxVec   Maximum number of vectors to be generated
!> @param[in]     Restart Flag for restarting decomposition
!> @param[in,out] Thr     Decomposition threshold (precision)
!> @param[in,out] Span    Span factor
!> @param[in]     MxQual  Max. number of qualified columns per decomposition pass
!> @param[in]     Diag    Array containing the diagonal of the matrix to be decomposed
!> @param[out]    Qual    Storage array for matrix columns
!> @param[in,out] Buf     Buffer for storing Cholesky vectors
!> @param[out]    iPivot  Pivoting array
!> @param[out]    iQual   Array for storing qualified indices
!> @param[in]     nDim    Linear dimension of matrix
!> @param[in]     lBuf    Buffer size
!> @param[out]    ErrStat Min, max, and RMS errors, respectively, for decomposition as judged
!>                        from the residual diagonal elements
!> @param[in,out] NumCho  Number of Cholesky vectors
!> @param[out]    irc     Return code
!***********************************************************************

subroutine ChoDec_MxVec(CD_Col,CD_Vec,MxVec,Restart,Thr,Span,MxQual,Diag,Qual,Buf,iPivot,iQual,nDim,lBuf,ErrStat,NumCho,irc)

use Cho_interfaces, only: cdcol_kernel, cdvec_kernel
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
procedure(cdcol_kernel) :: CD_Col
procedure(cdvec_kernel) :: CD_Vec
integer(kind=iwp), intent(in) :: MxVec, MxQual, nDim, lBuf
logical(kind=iwp), intent(in) :: Restart
real(kind=wp), intent(inout) :: Thr, Span, Buf(lBuf)
real(kind=wp), intent(in) :: Diag(nDim)
real(kind=wp), intent(out) :: Qual(nDim,0:MxQual), ErrStat(3)
integer(kind=iwp), intent(out) :: iPivot(nDim), iQual(MxQual), irc
integer(kind=iwp), intent(inout) :: NumCho
integer(kind=iwp) :: MinBuf, mQual, MxNumCho
logical(kind=iwp) :: Converged
real(kind=wp), parameter :: DefThr = 1.0e-6_wp, DefSpan = 1.0e-2_wp, dum = 9.876543210e15_wp, ThrFail = -1.0e-8_wp, &
                            ThrNeg = -1.0e-13_wp
character(len=*), parameter :: SecNam = 'ChoDec_MxVec'

! Initialize variables.
! ---------------------

irc = 0
ErrStat(1) = dum
ErrStat(2) = -dum
ErrStat(3) = -dum
if (.not. Restart) NumCho = 0
Converged = .false.

! Check dimensions.
! -----------------

if (nDim < 1) then
  irc = 0
  return ! exit (nothing to do)
end if
if (MxQual < 1) then
  irc = -1
  return ! exit (qualification not possible)
end if
mQual = min(MxQual,nDim)
MinBuf = nDim+mQual
if (lBuf < MinBuf) then
  irc = -2
  return ! exit (buffer too small)
end if
if (MxVec < 1) then
  irc = -3
  return ! exit (MxVec too small)
end if
MxNumCho = min(MxVec,nDim)

! Check and possibly reset configuration.
! ---------------------------------------

if (Thr < Zero) Thr = DefThr  ! reset threshold
if ((Span < Zero) .or. (Span > One)) Span = DefSpan ! reset span factor

! Set up a (possibly updated) copy of the diagonal.
! Test diagonal for negative elements.
! -------------------------------------------------

call CD_Diag(CD_Vec,Restart,Converged,Thr,ThrNeg,ThrFail,Diag,Qual(1,0),Buf,nDim,lBuf,ErrStat,NumCho,irc)
if (irc /= 0) return ! exit (initial diagonal error)

! Only do decomposition if not converged!
! ---------------------------------------

if ((.not. Converged) .and. (NumCho < MxNumCho)) then

  ! Cholesky decompose.
  ! -------------------

  call CD_Decomposer(CD_Col,CD_Vec,MxNumCho,Thr,Span,mQual,ThrNeg,ThrFail,Qual(1,0),Qual(1,1),Buf,iPivot,iQual,nDim,lBuf,NumCho,irc)
  if (irc /= 0) return ! exit (decomposition error)

  ! Check diagonal and set up error statistics.
  ! -------------------------------------------

  call CD_Diag(CD_Vec,.true.,Converged,Thr,ThrNeg,ThrFail,Diag,Qual(1,0),Buf,nDim,lBuf,ErrStat,NumCho,irc)
  if (irc /= 0) then
    irc = irc+200 ! makes the error code 400 + n
    return ! exit (check error)
  else if (.not. Converged) then
    if (NumCho < MxNumCho) then
      irc = 1
      return ! exit (decomposition failure)
    else if (NumCho > MxNumCho) then
      call SysAbendMsg(SecNam,'Logical error!',' ')
    end if
  end if

end if

! That's it!
! ----------

end subroutine ChoDec_MxVec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ADSTN_GASSM(NSTB,NSTA,IOFFK,IOFFI,IOFFISP,
     &              IOFFKSP,ICREORB,ICRESTR,
     &              IORBTSF,IORBTF,NORBTS,NSTAK,NSTAKT,NSTAI,
     &              NSTAKTS,ISTAKTS,NELB,NACGSOB,
     *              ISTMAP,SGNMAP,SCLFAC)
*
* Creation mappings from K-strings of given sym in each gasspace
*
* Input
* NSTB : Number of strings before active gasspace
* NSTA : Number of strings after accive gasspace
* IOFFK : Offset for K group of strings in active gasspace, i.e. start of
*         this symmetry of active K group strings
* IOFFI : Offset for I group of strings in active gasspace, i.e. start of
*         this symmetry of active I group strings
* IOFFISP: Offset for this symmetrydistribution of active I supergroup strings
* IOFFKSP: Offset for this symmetrydistribution of active K supergroup strings
* ICREORB : Orbital part of creation map for active K groupstrings
* ICRESTR : String  part of creation map for active K groupstrings
* IORBTSF   : First active orbital ( first orbital in in active GASspace
*           with required sym)
* IORBTF   : First orbital in active gas space, (can have any sym)
* NORBTS  : Number of orbitals of given symmetry and type
* NSTAK : Number of K groupstrings with given correct symmetry
* NSTAKT: Total Number of K groupstrings in active group (all symmetries)
* NSTAKTS: Total Number of K supergroup strings with correct symmetry
* ISTAKTS: Offset for K supergroup strings with hiven symmetrydistribution
* NSTAI : Number of I groupstrings in active gasspace
*
      IMPLICIT REAL*8(A,H,O-Z)
*. Input
      DIMENSION ICREORB(NACGSOB,*), ICRESTR(NACGSOB,*)
*. Output
      DIMENSION ISTMAP(NSTAKTS,*),SGNMAP(NSTAKTS,*)
*
C?    WRITE(6,*) ' ADSTN_GASSM : NSTA, NSTB, NSTAK',NSTA,NSTB,NSTAK
C?    WRITE(6,*) ' IOFFISP,IOFFKSP', IOFFISP, IOFFKSP
C?    WRITE(6,*) ' IORBTSF IORBTF ', IORBTSF,IORBTF
C?    WRITE(6,*) ' NSTAKT ', NSTAKT
*
*      SIGN0 = DBLE((-1)**NELB)*SCLFAC
      IF( MOD(NELB,2).EQ.0 ) THEN
        SIGN0 = SCLFAC
      ELSE
        SIGN0 = -SCLFAC
      END IF
C?    WRITE(6,*) ' NELB sign0 = ', NELB, SIGN0
      DO KSTR = IOFFK, NSTAK+IOFFK-1
        DO IORB = IORBTSF, IORBTSF-1+NORBTS
*. Relative to Type-symmetry start
          IORBRTS = IORB-IORBTSF+1
*. Relative to type start
          IORBRT = IORB-IORBTF+1
C?         write(6,*) 'IORB IORBRT KSTR ', IORB,IORBRT, KSTR
C?         WRITE(6,*) 'ICRESTR(IORBRT,KSTR),ICREORB(IORBRT,KSTR)',
C?   &                 ICRESTR(IORBRT,KSTR),ICREORB(IORBRT,KSTR)
          IF(ICREORB(IORBRT,KSTR) .GT. 0 ) THEN
*. Excitation is open, corresponding active I string
            IF(ICRESTR(IORBRT,KSTR) .GT. 0 ) THEN
              SIGN = SIGN0
              ISTR = ICRESTR(IORBRT,KSTR)
            ELSE
              SIGN = -SIGN0
              ISTR = -ICRESTR(IORBRT,KSTR)
            END IF
* Relative to start of given symmetry for this group
            ISTR = ISTR - IOFFI+ 1
*. This Creation is active for all choices of strings in supergroup
*. before and after the active type. Store the corrsponding mappings
            IADRK0 = (KSTR-IOFFK)*NSTA +IOFFKSP-1
            IADRI0 = (ISTR-1)*NSTA     +IOFFISP-1
C?          write(6,*) ' ISTR IADRK0 IADRI0 = ', ISTR, IADRK0,IADRI0
*
            NSTAINSTA = NSTAI*NSTA
            NSTAKNSTA = NSTAK*NSTA
            DO IB = 1, NSTB
              DO IA = 1, NSTA
C               IBKA = IADRI0 + (IB-1)*NSTAI*NSTA+IA
C               KBKA = IADRK0 + (IB-1)*NSTAK*NSTA+IA
C?              write(6,*) ' IBKA, KBKA ',IBKA,KBKA
                ISTMAP(IADRK0+IA,IORBRTS) = IADRI0 + IA
                SGNMAP(IADRK0+IA,IORBRTS) = SIGN
              END DO
              IADRI0 = IADRI0 +  NSTAINSTA
              IADRK0 = IADRK0 +  NSTAKNSTA
            END DO
C         ELSE
C            SIGN = 0.0D0
C            ISTR = 0
*. This Creation is inactive for all choices of strings in supergroup
*. before and after the active type.
C           IADRK0 = (KSTR-IOFFK)*NSTA +IOFFKSP-1
C?          write(6,*) ' ISTR IADRK0 = ', ISTR, IADRK0
*
C           DO IB = 1, NSTB
C             DO IA = 1, NSTA
C               KBKA = IADRK0 + (IB-1)*NSTAK*NSTA+IA
C?              write(6,*) ' IBKA, KBKA ',IBKA,KBKA
C               IF(ISTMAP(KBKA,IORBRTS).NE.999) THEN
C                 WRITE(6,*) ' overwriting ??? '
C                 WRITE(6,*) ' Element ', (IORBRTS-1)*NSTAKTS+KBKA
C                 STOP
C               END IF
C               ISTMAP(KBKA,IORBRTS) = ISTR
C               SGNMAP(KBKA,IORBRTS) = SIGN
C
C             END DO
C           END DO
          END IF
*. This Creation is active for all choices of strings in supergroup
*. before and after the active type. Store the corrsponding mappings
COLD        IADRK0 = (KSTR-IOFFK)*NSTA +IOFFKSP-1
COLD        IADRI0 = (ISTR-1)*NSTA     +IOFFISP-1
C?          write(6,*) ' ISTR IADRK0 IADRI0 = ', ISTR, IADRK0,IADRI0
*
COLD        DO IB = 1, NSTB
COLD          DO IA = 1, NSTA
COLD            IBKA = IADRI0 + (IB-1)*NSTAI*NSTA+IA
COLD            KBKA = IADRK0 + (IB-1)*NSTAK*NSTA+IA
C?              write(6,*) ' IBKA, KBKA ',IBKA,KBKA
COLD            ISTMAP(KBKA,IORBRTS) = IBKA
COLD            SGNMAP(KBKA,IORBRTS) = SIGN
COLD          END DO
COLD        END DO
C         END IF
*
        END DO
      END DO
*
      NTEST = 000
      IF(NTEST.GT.0) THEN
        WRITE(6,*) ' Output from ADSTN_GASSM '
        WRITE(6,*) ' ======================== '
        NK = NSTB*NSTAK*NSTA
        WRITE(6,*) ' Number of K strings accessed ', NK
        IF(NK.NE.0) THEN
          DO IORB = IORBTSF,IORBTSF + NORBTS  - 1
            IORBR = IORB-IORBTSF+1
            WRITE(6,*) ' Update Info for orbital ', IORB
            WRITE(6,*) ' Excited strings and sign '
            CALL IWRTMA(ISTMAP(1,IORBR),1,NK,1,NK)
            CALL WRTMAT(SGNMAP(1,IORBR),1,NK,1,NK)
          END DO
        END IF
      END IF

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NSTAKT)
        CALL Unused_integer(ISTAKTS)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine Distg1(Temp,mVec,Grad,nGrad,IfGrad,IndGrd,
     &                  iStab,kOp)
************************************************************************
*                                                                      *
* Object: trace the gradient of the ERI's with the second order        *
*         density matrix                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChBas
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Grad(nGrad), Temp(9), PAOg1(12), Prmt(0:7)
      Logical IfGrad(3,4)
      Integer IndGrd(3,4), kOp(4), iStab(4)
      Data Prmt/1.d0,-1.d0,-1.d0,1.d0,-1.d0,1.d0,1.d0,-1.d0/
*
*     Statement Function
*
      xPrmt(i,j) = Prmt(iAnd(i,j))
*
      iRout = 239
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt('Accumulated gradient on entrance',
     &               ' ',Grad,nGrad,1)
         Write (6,*) ' kOp=',kOp
         Write (6,*) ' iStab=',iStab
         Call RecPrt('Distg1: Temp',' ',Temp,9,1)
      End If
      If (iPrint.ge.49) Write (6,*) IndGrd
#endif
*
*----- Distribute Temp in PAOg1
*
      nVec = 0
#ifdef __INTEL_COMPILER
      Do kl = 1, 12
         iCar = (kl-1)/4 + 1
         iCent = kl - (iCar-1)*4
         ij = 3*(iCent-1)+iCar
         If (IfGrad(iCar,iCent)) Then
            nVec = nVec + 1
            PAOg1(ij) = Temp(nVec)
         Else
            PAOg1(ij) = Zero
         End If
      End Do
#else
*
*     Original code didn't work for Intel compiler with -O3
*     options since it swaps the loops.
*
      Do iCar = 1, 3
         Do iCent = 1, 4
            ij = 3*(iCent-1)+iCar
            If (IfGrad(iCar,iCent)) Then
               nVec = nVec + 1
               PAOg1(ij) = Temp(nVec)
            Else
               PAOg1(ij) = Zero
            End If
         End Do
      End Do
#endif
*
*-----a) Compute some of the contributions via the translational
*        invariance
*-----b) Distribute contribution to the gradient.
*
      Do iCn = 1, 4
         Do iCar = 1, 3
            ij = 3*(iCn-1) + iCar
*
*           a)
*
            If (IndGrd(iCar,iCn).lt.0) Then
               Do jCn = 1, 4
                  If (iCn.ne.jCn.and.IfGrad(iCar,jCn)) Then
                     kl = 3*(jCn-1) + iCar
                     PAOg1(ij)=PAOg1(ij)-PAOg1(kl)
                  End If
               End Do
            End If
*
*           b)
*
            If (IndGrd(iCar,iCn).ne.0) Then
               iGrad = Abs(IndGrd(iCar,iCn))
*--------------Parity due to integration direction
               ps = xPrmt(kOp(iCn),iChBas(1+iCar))
               Fact = ps * DBLE(iStab(iCn)) / DBLE(nIrrep)
               Grad(iGrad) = Grad(iGrad) + Fact * PAOg1(ij)
            End If
*
         End Do
      End Do
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.49) Then
         Call RecPrt('PAOg1',' ',PAOg1,12,1)
         Call RecPrt('Accumulated gradient on exit',
     &               ' ',Grad,nGrad,1)
      End If
#endif
*
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(mVec)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE TRDNS2D(IVEC,JVEC,DPT2,NDPT2,SCAL)

      use definitions, only: iwp, wp
      use constants, only: Zero, One
      use caspt2_global, only: imag_shift, sigma_p_epsilon
      use caspt2_global, only: do_grad
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
#endif
      use caspt2_global, only: LUSBT, LISTS
      use EQSOLV, only: iDBMat
      use stdalloc, only: mma_allocate, mma_deallocate
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: nSym, nInDep, nISup, nASup

      IMPLICIT NONE

#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif
      integer(kind=iwp), intent(in) :: IVEC,JVEC,NDPT2
      real(kind=wp), intent(inout) :: DPT2(NDPT2)
      real(kind=wp), intent(in) :: SCAL

      real(kind=wp), ALLOCATABLE:: BD(:), ID(:)
#ifdef _MOLCAS_MPP_
      real(kind=wp), ALLOCATABLE:: VEC1(:), VEC2(:)
#endif
      integer(kind=iwp) ICASE, ISYM, jD, lg_v1, lg_v2, NAS, NIN, NIS,
     &                  nVec

C Add to the diagonal blocks of transition density matrix,
C    DPT2(p,q) = Add <IVEC| E(p,q) |JVEC>,
C i.e. inactive/inactive, active/active, and virt/virt
C submatrices.IVEC, JVEC stands for the 1st-order perturbed
C CASPT2 wave functions in vectors nr IVEC, JVEC on LUSOLV.

C Inact/Inact and Virt/Virt blocks:
      DO ICASE=1,13
C       if (icase/=12 .and. icase.ne.13) cycle ! H
        DO ISYM=1,NSYM
          NIN=NINDEP(ISYM,ICASE)
          IF(NIN==0) CYCLE
          NIS=NISUP(ISYM,ICASE)
          NVEC=NIN*NIS
          IF(NVEC==0) CYCLE
          !! lg_V1: T+lambda
          !! lg_V2: T
          !! IVEC = iVecX
          !! JVEC = iVecR
          CALL RHS_ALLO(NIN,NIS,lg_V1)
          CALL RHS_READ_SR(lg_V1,ICASE,ISYM,IVEC)
          IF(IVEC==JVEC) THEN
            lg_V2=lg_V1
          ELSE
            CALL RHS_ALLO(NIN,NIS,lg_V2)
            CALL RHS_READ_SR(lg_V2,ICASE,ISYM,JVEC)
            If (do_grad) Then
              CALL RHS_SCAL(NIN,NIS,lg_V1,SCAL)
              if (sigma_p_epsilon /= Zero) then
                !! derivative of the numerator
                nAS = nASUP(iSym,iCase)
                Call mma_allocate(BD,nAS,Label='BD')
                Call mma_allocate(ID,nIS,Label='ID')
                jD = iDBMat(iSym,iCase)
                Call dDaFile(LUSBT,2,BD,nAS,jD)
                Call dDaFile(LUSBT,2,ID,nIS,jD)
                Call CASPT2_ResD(3,nIN,nIS,lg_V2,lg_V1,BD,ID)
                Call mma_deallocate(BD)
                Call mma_deallocate(ID)
              end if
              CALL RHS_DAXPY(NIN,NIS,One,lg_V2,lg_V1)
              CALL RHS_READ_SR(lg_V2,ICASE,ISYM,IVEC)
            End If
          END IF

CSVC: DIADNS can currently not handle pieces of RHS, so pass the
C full array in case we are running in parallel
#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            IF (KING()) THEN
              ! copy global array to local buffer
              CALL mma_allocate(VEC1,NVEC,Label='VEC1')
              CALL GA_GET(lg_V1,1,NIN,1,NIS,VEC1,NIN)
              IF(IVEC==JVEC) THEN
                CALL DIADNS(ISYM,ICASE,VEC1,VEC1,DPT2,LISTS)
              ELSE
                CALL mma_allocate(VEC2,NVEC,Label='VEC2')
                CALL GA_GET(lg_V2,1,NIN,1,NIS,VEC2,NIN)
                CALL DIADNS(ISYM,ICASE,VEC1,VEC2,DPT2,LISTS)
                CALL mma_deallocate(VEC2)
              END IF
              CALL mma_deallocate(VEC1)
            END IF
            CALL GASYNC()
          ELSE
#endif
            CALL DIADNS(ISYM,ICASE,GA_Arrays(lg_V1)%A,
     &                             GA_Arrays(lg_V2)%A,DPT2,LISTS)
#ifdef _MOLCAS_MPP_
          END IF
#endif
          If (do_grad .and. (imag_shift /=Zero
     *                  .or. sigma_p_epsilon /= Zero)) Then
            !! for sigma-p CASPT2, derivative of the denominator
            nAS = nASUP(iSym,iCase)
            Call mma_allocate(BD,nAS,Label='BD')
            Call mma_allocate(ID,nIS,Label='ID')
            jD = iDBMat(iSym,iCase)
            Call dDaFile(LUSBT,2,BD,nAS,jD)
            Call dDaFile(LUSBT,2,ID,nIS,jD)
C
            CALL RHS_READ_SR(lg_V1,ICASE,ISYM,IVEC)
            CALL RHS_READ_SR(lg_V2,ICASE,ISYM,JVEC)
            Call CASPT2_ResD(2,nIN,nIS,lg_V1,lg_V2,BD,ID)
C
            Call DScal_(NDPT2,-One,DPT2,1)
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              IF (KING()) THEN
                ! copy global array to local buffer
                CALL mma_allocate(VEC1,NVEC,Label='VEC1')
                CALL GA_GET(lg_V1,1,NIN,1,NIS,VEC1,NIN)
                IF(IVEC==JVEC) THEN
                  CALL DIADNS(ISYM,ICASE,VEC1,VEC1,DPT2,LISTS)
                ELSE
                  CALL mma_allocate(VEC2,NVEC,Label='VEC2')
                  CALL GA_GET(lg_V2,1,NIN,1,NIS,VEC2,NIN)
                  CALL DIADNS(ISYM,ICASE,VEC1,VEC2,DPT2,LISTS)
                  CALL mma_deallocate(VEC2)
                END IF
                CALL mma_deallocate(VEC1)

              END IF
              CALL GASYNC()
            ELSE
#endif
              CALL DIADNS(ISYM,ICASE,GA_Arrays(lg_V1)%A,
     &                               GA_Arrays(lg_V2)%A,DPT2,LISTS)
#ifdef _MOLCAS_MPP_
            END IF
#endif
            Call DScal_(NDPT2,-One,DPT2,1)
            Call mma_deallocate(BD)
            Call mma_deallocate(ID)
          End IF

          CALL RHS_FREE(lg_V1)
          IF(IVEC/=JVEC) CALL RHS_FREE(lg_V2)
        End Do
      End Do
#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par().and.do_grad) call gadsum(DPT2,NDPT2)
#endif

      END SUBROUTINE TRDNS2D

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Ignacio Fdez. Galvan                             *
!***********************************************************************

module casvb_global

! What calculation? :
!--------------------
! endvar nmcscf service variat

! Definition of CASSCF active space :
!------------------------------------
! ... Orbital space ...
! ityp
! ... Orbital-space symmetries ...
! isym isympr isymv nirrep nsym
! ... State-averaged wavefunction ...
! esym
! ... Number of determinants in each irrep ...
! ncivb

! Numbers defining, or relating to, the active CI space :
!--------------------------------------------------------
! n1a n1b nalf nam1 nbet nbm1 nda ndb ndet nel noe norb

! ... Utilize alpha<->beta symmetry in various circumstances ...
! absym

! Numbers relating to the definition of the VB wavefunction :
!------------------------------------------------------------
! kbasis kbasiscvb mnion mxion naprodvb nbprodvb nconf ndetvb npvb nvb nvbinp sc

! CASVB algorithm (for evaluating g/G, etc.) :
!---------------------------------------------
! ... Overlap-based or energy based? ...
! icrit
! ... Projection operators ...
! proj projcas projsym

! Parameters relating to the optimization procedure :
!----------------------------------------------------
! imethod isaddle maxdav mxiter

! Optimization handler :
!-----------------------
! convinone ifinish initial ioptc_new

! Orbital permutation :
!----------------------
! iorbprm

! CI vectors :
!-------------
! icnt_ci iform_ci mxciobj ndres nv

! Symmetry information and constraints:
!--------------------------------------
! ... General ...
! sym
! ... Symmetry elements ...
! mxsyme nsyme tags
! ... Symmetry-constrained orbitals ...
! mxops ndimrel nijrel niorth norbrel
! ... Fixed orbitals ...
! nfxorb
! ... Orthogonalized orbitals/deleted rotations ...
! ndrot nort
! ... Symmetry-constrained/fixed/deleted structures ...
! iconstruc lfxvb lzrvb nconstr nfxvb nzeta nzrvb

! Various maximum dimensions defined in input :
!----------------------------------------------
! mxnvb

! All2free/free2all variable transformation :
!--------------------------------------------
! nfr nfrorb nfrvb npr nprorb nprvb orbfr_is_unit orbopt strucopt

! Integrals (number of, core energy, etc.) :
!-------------------------------------------
! mxaobf

! Analysis :
!-----------
! iciweights ishstruc ivbweights lcalccivbs lcalcevb lcalcsvb lciweights npcf sij

! Strictly localized calculations :
!----------------------------------
! plc_const ploc

! Various quantities calculated from VB wavefunction :
!-----------------------------------------------------
! cvbnrm evb ovraa svb

! Usage statistics :
!-------------------
! cpu0, cpu_prev n_2el n_applyh n_applyt n_cihess n_hess n_iter n_orbhess

! Print control :
!----------------
! ipr iprec iwidth

! Save memory? :
!---------------
! dxmove memplenty

! Format statements depending on iprec:
!--------------------------------------
! form2AD form2AF formAD formAF formChk1 formChk2 formChk3 formcvp formE formMXP1 formMXP2 formMXP3 formMXP4 formMXP5 formMXP6
! formroot formSymW formVBWnorm

! _c quantities are based on latest CASSCF
! _d quantities are those actually used (= _c if not changed in input)
! iorclos_* iorcore_* iorocc_* istms2_* istnel_* istsy_* mcore_* nstats_* nstsym_* weight_*

use Definitions, only: wp, iwp

implicit none
private

type gjorb_type
  real(kind=wp), allocatable :: r(:,:)
  integer(kind=iwp), allocatable :: i1(:)
  integer(kind=iwp), allocatable :: i2(:,:)
end type gjorb_type

integer(kind=iwp), parameter :: lbuf = 512, max_rec = 5000, mxact_mo = 16, mxciobj = 20, mxdep = 200, mxfield = 500, mxfiles = 40, &
                                mxfrag = 10, mxI = 20, mxirrep = 8, mxirrep_ci = 8, mxirrep_mo = 8, mxMs = 20, mxobj = 100, &
                                mxopth = 10, mxops = 32, mxorb_cvb = 50, mxprm = 100, mxS = 20, mxstep = 200, mxstsy_ci = 8, &
                                mxstt_ci = 20, mxsyme = 32, mxunits = 8, nspinb = 7, nstackrep = 50

integer(kind=iwp) :: i_dep_on_j(mxdep), i2s_fr(mxS,mxfrag), iact_mo(mxact_mo), iaddrm(mxfield), ibuf, ibuffer(lbuf), icase6, &
                     icase7, iciweights, icnt, icnt_ci(mxciobj), icode(mxstep), iconstruc, icrit, idan(mxfiles), ifield, &
                     ifilio(max_rec), ifinish, ifollow, iform_ci(mxciobj), ifsc_fr(mxfrag), ifvb, iline = 0, ilv(300), imethod, &
                     initial, inp, inputmode, invec_cvb, ioffs(mxobj+1), iopt2step(0:30), ioptc_new, ioptcode(30), ioptim, &
                     ioptstep, iorbprm(mxorb_cvb), iorclos_c(mxirrep_ci), iorclos_d(mxirrep_ci), iorcore_c(mxirrep_ci), &
                     iorcore_d(mxirrep_ci), iorder(mxunits), iorocc_c(mxirrep_ci), iorocc_d(mxirrep_ci), ip, ipAnchr, ipdd, &
                     ipos(mxstep), ipp10, ipp12e, ipp12s, ipp7, ipr(10), iprec, iprint, iprm, iroot, is_set = 0, isaddle, &
                     isaddledd, isaddleo, ishstruc, istackrep(nstackrep), istms2_c(mxstsy_ci), istms2_d(mxstsy_ci), &
                     istnel_c(mxstsy_ci), istnel_d(mxstsy_ci), istsy_c(mxstsy_ci), istsy_d(mxstsy_ci), isym, isympr(mxirrep), &
                     isymv(mxirrep), iter10, iter12e, iter12s, iter7, ityp(mxorb_cvb), ivbweights, iwidth, izbuffer(lbuf), &
                     j_dep_on_i(mxdep), joffs(mxobj+1), joptstep, jroot, kbasis, kbasiscvb, lenline, lfxvb, loopstep, loopstepmx, &
                     lstprm(mxprm), lzrvb, maxd, maxdav, mcore_c, mcore_d, mnion, mnion_fr(mxfrag), mxaobf, mxdav, mxion, &
                     mxion_fr(mxfrag), mxit, mxiter, mxnvb = 0, mxrhs, n1a, n1b, n_2el, n_applyh, n_applyt, n_cihess, n_div, &
                     n_hess, n_iter, n_orbhess, nact_mo, nalf, nalf_fr(mxMs,mxfrag), nam1, naprodvb, nbas_mo, &
                     nbasf_mo(mxirrep_mo), nbasi_mo(mxirrep_mo), nbasisq_mo, nbassqf_mo(mxirrep_mo), nbassqi_mo(mxirrep_mo), nbet, &
                     nbet_fr(mxMs,mxfrag), nbm1, nbprodvb, nbuf, ncivb(mxirrep), ncnt, nconf, nconf_fr(mxfrag), &
                     nconfion_fr(0:mxI,mxfrag), nconstr, nda, nda_fr(mxMs,mxfrag), ndb, ndb_fr(mxMs,mxfrag), ndep_ij, ndep_ji, &
                     ndet, ndetvb, ndetvb_fr(mxfrag), ndetvb2_fr(mxfrag), ndimrel, ndres, ndrot, nel, nel_fr(mxfrag), nfield, &
                     nfold, nfr, nfrag, nfrdim, nfrorb, nfrvb, nfxorb, nfxvb, nijrel, niorth, nirrep, nline = 0, nlold = 0, &
                     nmcscf, nMs_fr(mxfrag), nobj, noe, nopth1(2), nopth2(2), noptim, noptstep, norb, norbrel, nort, nortiter, &
                     nortiterdd, nparm, npcf, npr, nprorb, nprvb, npvb, nrec, nroot, nS_fr(mxfrag), nstats_c(mxstsy_ci), &
                     nstats_d(mxstsy_ci), nstsym_c, nstsym_d, nsym, nsym_mo, nsyme, nv, nvb, nvb_fr(mxfrag), nvbinp, &
                     nvbr_fr(mxfrag), nvecmx, nvguess, nvrestart, nvrhs, nvtot, nword, nzeta, nzrvb
real(kind=wp) :: aa1, aa2, alftol, cnrm, cnrmtol, corenrg, cpropt(mxopth), cpu0, cpu_prev, cvbnrm, cvbnrm_fr(mxfrag), delopth1(2), &
                 delopth2(2), dfx(6), dfxmin(2), dfxtol, dx(3,6), eigwrngtol, esym(mxirrep), evb, exp12tol, expct, f1, f2, f3, f4, &
                 file_id, fileids(max_rec), fxbest, grd(3,6), grdwrngtol, hh, hhaccfac(5,2), hhkeep, hhmax(2), hhopt(mxopth), &
                 hhrejfac(2), hhstart, hhtol(2), oaa2, oaa3, orththr, orththrdd, ovraa, ovraa_try, ovrab, ovrab_try, recinp, &
                 recinp_old, recn, recn_jobiph, recn_jobold, recn_oneint, recn_tmp01, recn_tmp02, recn_tmp03, recn_tmp04, &
                 recn_vbwfn, resthr, resthrdd, safety, savvb, savvbci, sgn(6), signtol, singul(3), strtci, strtint, strtmo, &
                 strtvb, svb, thresh_io, weight_c(mxstt_ci,mxstsy_ci), weight_d(mxstt_ci,mxstsy_ci), ww, ww_try, zzacclim(4,2), &
                 zzmax(6), zzmin(6), zzrejmax(2), zzrejmin(2)
logical(kind=iwp) :: absym(5), convinone, dxmove, endvar, endwhenclose, follow, have_solved_it, lcalccivbs, lcalcevb, lcalcsvb, &
                     lciweights, maxize, memplenty, mustdeclare, ndres_ok, orbfr_is_unit, orbopt, plc_const, ploc, proj, projcas, &
                     projsym, release(10), sc, scalesmall(2), service, sij, strucopt, sym, up2date(mxobj), variat
character(len=300) :: line
character(len=20) :: filename(max_rec), form2AD, form2AF, formAD, formAF, formChk1, formChk2, formChk3, formcvp, formE, formMXP1, &
                     formMXP2, formMXP3, formMXP4, formMXP5, formMXP6, formroot, formSymW, formVBWnorm
character(len=8) :: charobj(mxobj)
character(len=3) :: tags(mxsyme)
type(gjorb_type) :: gjorb, gjorb2, gjorb3
integer(kind=iwp), allocatable :: confsinp(:,:), ia12ind(:), iapr(:), iapr1(:), ib12ind(:), ibpr(:), ibpr1(:), iconfs(:,:), &
                                  idelstr(:), idetvb(:), ifxorb(:), ifxstr(:), ikcoff(:,:,:), iorbrel(:), iorts(:,:), &
                                  ipermzeta(:,:), irels(:,:), irots(:,:), ixapr(:), ixapr1(:), ixbpr(:), ixbpr1(:), izeta(:), &
                                  ndetvbs(:,:), north(:)
integer(kind=iwp), allocatable, target :: i1alf(:,:), i1c(:,:), iafrm(:,:), iato(:,:), icfrm(:,:), icto(:,:), ifnss1(:,:), &
                                          ifnss2(:,:)
real(kind=wp), allocatable :: ap(:,:), axc(:,:), c(:,:), corth(:,:), cvb(:), cvbdet(:), cvbsspn(:), cvbstot(:), cvbtry(:), &
                              dvbdet(:), eigval(:), eigvec(:,:), evbdet(:), grad1(:), grad2(:), gradx(:,:), gsinp(:), &
                              hessorb(:,:), hesst(:,:), odx(:), odxp(:), ograd(:), ogradp(:), orbinv(:,:), orbs(:,:), &
                              orbstry(:,:), owrk(:), owrk2(:,:), relorb(:,:,:), res(:), rhs(:,:), rhsp(:), solp(:), solp_res(:), &
                              sorbs(:,:), span(:,:), sstruc(:,:), sstruc2(:,:), sxc(:,:), symelm(:,:,:), tconstr(:,:), trprm(:,:), &
                              vbdet(:), vec1(:), wdx(:)
real(kind=wp), allocatable, target :: aikcof(:), cikcof(:), civbvecs(:,:), phato(:,:), phcto(:,:)
integer(kind=iwp), pointer :: i1bet(:,:) => null(), ibfrm(:,:) => null(), ibto(:,:) => null()
real(kind=wp), pointer :: bikcof(:) => null(), civb1(:) => null(), civb2(:) => null(), civb3(:) => null(), civb4(:) => null(), &
                          civb5(:) => null(), civb6(:) => null(), civb7(:) => null(), civb8(:) => null(), phbto(:,:) => null()

integer(kind=iwp), parameter :: iunset = -1357924680
logical(kind=iwp), parameter :: ifhamil = .true., ifmos = .true.
character(len=*), parameter :: spinb(nspinb) = ['Kotani      ','Serber      ','Rumer       ','Rumer (LT)  ','Projected   ', &
                                                'Determinants','Determinants'], &
                               spinbkw(nspinb) = ['KOTANI  ','SERBER  ','RUMER   ','LTRUMER ','PROJECT ','DET     ', &
                                                  'DETERM  ']

public :: aa1, aa2, absym, aikcof, alftol, ap, axc, bikcof, c, casvb_free, charobj, cikcof, civb1, civb2, civb3, civb4, civb5, &
          civb6, civb7, civb8, civbvecs, cnrm, cnrmtol, confsinp, convinone, corenrg, corth, cpropt, cpu0, cpu_prev, cvb, cvbdet, &
          cvbnrm, cvbnrm_fr, cvbsspn, cvbstot, cvbtry, delopth1, delopth2, dfx, dfxmin, dfxtol, dvbdet, dx, dxmove, eigval, &
          eigvec, eigwrngtol, endvar, endwhenclose, esym, evb, evbdet, exp12tol, expct, f1, f2, f3, f4, file_id, fileids, &
          filename, follow, form2AD, form2AF, formAD, formAF, formChk1, formChk2, formChk3, formcvp, formE, formMXP1, formMXP2, &
          formMXP3, formMXP4, formMXP5, formMXP6, formroot, formSymW, formVBWnorm, fxbest, gjorb, gjorb_type, gjorb2, gjorb3, &
          grad1, grad2, gradx, grd, grdwrngtol, gsinp, have_solved_it, hessorb, hesst, hh, hhaccfac, hhkeep, hhmax, hhopt, &
          hhrejfac, hhstart, hhtol, i_dep_on_j, i1alf, i1bet, i1c, i2s_fr, ia12ind, iact_mo, iaddrm, iafrm, iapr, iapr1, iato, &
          ib12ind, ibfrm, ibpr, ibpr1, ibto, ibuf, ibuffer, icase6, icase7, icfrm, iciweights, icnt, icnt_ci, icode, iconfs, &
          iconstruc, icrit, icto, idan, idelstr, idetvb, ifhamil, ifield, ifilio, ifinish, ifmos, ifnss1, ifnss2, ifollow, &
          iform_ci, ifsc_fr, ifvb, ifxorb, ifxstr, ikcoff, iline, ilv, imethod, initial, inp, inputmode, invec_cvb, ioffs, &
          iopt2step, ioptc_new, ioptcode, ioptim, ioptstep, iorbprm, iorbrel, iorclos_c, iorclos_d, iorcore_c, iorcore_d, iorder, &
          iorocc_c, iorocc_d, iorts, ip, ipAnchr, ipdd, ipermzeta, ipos, ipp10, ipp12e, ipp12s, ipp7, ipr, iprec, iprint, iprm, &
          irels, iroot, irots, is_set, isaddle, isaddledd, isaddleo, ishstruc, istackrep, istms2_c, istms2_d, istnel_c, istnel_d, &
          istsy_c, istsy_d, isym, isympr, isymv, iter10, iter12e, iter12s, iter7, ityp, iunset, ivbweights, iwidth, ixapr, ixapr1, &
          ixbpr, ixbpr1, izbuffer, izeta, j_dep_on_i, joffs, joptstep, jroot, kbasis, kbasiscvb, lbuf, lcalccivbs, lcalcevb, &
          lcalcsvb, lciweights, lenline, lfxvb, line, loopstep, loopstepmx, lstprm, lzrvb, max_rec, maxd, maxdav, maxize, mcore_c, &
          mcore_d, memplenty, mnion, mnion_fr, mustdeclare, mxact_mo, mxaobf, mxdav, mxdep, mxfield, mxfiles, mxfrag, mxI, mxion, &
          mxion_fr, mxirrep, mxirrep_ci, mxirrep_mo, mxit, mxiter, mxMs, mxnvb, mxobj, mxopth, mxops, mxorb_cvb, mxprm, mxrhs, &
          mxS, mxstep, mxstsy_ci, mxstt_ci, mxsyme, mxunits, n1a, n1b, n_2el, n_applyh, n_applyt, n_cihess, n_div, n_hess, n_iter, &
          n_orbhess, nact_mo, nalf, nalf_fr, nam1, naprodvb, nbas_mo, nbasf_mo, nbasi_mo, nbasisq_mo, nbassqf_mo, nbassqi_mo, &
          nbet, nbet_fr, nbm1, nbprodvb, nbuf, ncivb, ncnt, nconf, nconf_fr, nconfion_fr, nconstr, nda, nda_fr, ndb, ndb_fr, &
          ndep_ij, ndep_ji, ndet, ndetvb, ndetvb_fr, ndetvb2_fr, ndetvbs, ndimrel, ndres, ndres_ok, ndrot, nel, nel_fr, nfield, &
          nfold, nfr, nfrag, nfrdim, nfrorb, nfrvb, nfxorb, nfxvb, nijrel, niorth, nirrep, nline, nlold, nmcscf, nMs_fr, nobj, &
          noe, nopth1, nopth2, noptim, noptstep, norb, norbrel, nort, north, nortiter, nortiterdd, nparm, npcf, npr, nprorb, &
          nprvb, npvb, nrec, nroot, nS_fr, nspinb, nstackrep, nstats_c, nstats_d, nstsym_c, nstsym_d, nsym, nsym_mo, nsyme, nv, &
          nvb, nvb_fr, nvbinp, nvbr_fr, nvecmx, nvguess, nvrestart, nvrhs, nvtot, nword, nzeta, nzrvb, oaa2, oaa3, odx, odxp, &
          ograd, ogradp, orbfr_is_unit, orbinv, orbopt, orbs, orbstry, orththr, orththrdd, ovraa, ovraa_try, ovrab, ovrab_try, &
          owrk, owrk2, phato, phbto, phcto, plc_const, ploc, proj, projcas, projsym, recinp, recinp_old, recn, recn_jobiph, &
          recn_jobold, recn_oneint, recn_tmp01, recn_tmp02, recn_tmp03, recn_tmp04, recn_vbwfn, release, relorb, res, resthr, &
          resthrdd, rhs, rhsp, savvb, savvbci, safety, sc, scalesmall, service, sgn, signtol, sij, singul, solp, solp_res, sorbs, &
          span, spinb, spinbkw, sstruc, sstruc2, strtci, strtint, strtmo, strtvb, strucopt, svb, sxc, sym, symelm, tags, tconstr, &
          thresh_io, trprm, up2date, variat, vbdet, vec1, wdx, weight_c, weight_d, ww, ww_try, zzacclim, zzmax, zzmin, zzrejmax, &
          zzrejmin

contains

subroutine casvb_free()
  use stdalloc, only: mma_deallocate
  call mma_deallocate(civbvecs,safe='*')
  call mma_deallocate(orbinv,safe='*')
  call mma_deallocate(sorbs,safe='*')
  call mma_deallocate(owrk2,safe='*')
  call mma_deallocate(gjorb%r,safe='*')
  call mma_deallocate(gjorb%i1,safe='*')
  call mma_deallocate(gjorb%i2,safe='*')
  call mma_deallocate(gjorb2%r,safe='*')
  call mma_deallocate(gjorb2%i1,safe='*')
  call mma_deallocate(gjorb2%i2,safe='*')
  call mma_deallocate(gjorb3%r,safe='*')
  call mma_deallocate(gjorb3%i1,safe='*')
  call mma_deallocate(gjorb3%i2,safe='*')
  call mma_deallocate(cvbstot,safe='*')
  call mma_deallocate(cvbsspn,safe='*')
  call mma_deallocate(cvbdet,safe='*')
  call mma_deallocate(dvbdet,safe='*')
  call mma_deallocate(evbdet,safe='*')
  call mma_deallocate(orbstry,safe='*')
  call mma_deallocate(cvbtry,safe='*')
  call mma_deallocate(i1alf,safe='*')
  call mma_deallocate(i1c,safe='*')
  call mma_deallocate(iafrm,safe='*')
  call mma_deallocate(icfrm,safe='*')
  call mma_deallocate(iato,safe='*')
  call mma_deallocate(icto,safe='*')
  call mma_deallocate(phato,safe='*')
  call mma_deallocate(phcto,safe='*')
  call mma_deallocate(iapr,safe='*')
  call mma_deallocate(ixapr,safe='*')
  call mma_deallocate(ibpr,safe='*')
  call mma_deallocate(ixbpr,safe='*')
  call mma_deallocate(iconfs,safe='*')
  call mma_deallocate(idetvb,safe='*')
  call mma_deallocate(ia12ind,safe='*')
  call mma_deallocate(ib12ind,safe='*')
  call mma_deallocate(iapr1,safe='*')
  call mma_deallocate(ixapr1,safe='*')
  call mma_deallocate(ibpr1,safe='*')
  call mma_deallocate(ixbpr1,safe='*')
  call mma_deallocate(hessorb,safe='*')
  call mma_deallocate(hesst,safe='*')
  call mma_deallocate(grad1,safe='*')
  call mma_deallocate(grad2,safe='*')
  call mma_deallocate(gradx,safe='*')
  call mma_deallocate(vec1,safe='*')
  call mma_deallocate(symelm,safe='*')
  call mma_deallocate(iorbrel,safe='*')
  call mma_deallocate(north,safe='*')
  call mma_deallocate(corth,safe='*')
  call mma_deallocate(irels,safe='*')
  call mma_deallocate(relorb,safe='*')
  call mma_deallocate(ifxorb,safe='*')
  call mma_deallocate(ifxstr,safe='*')
  call mma_deallocate(idelstr,safe='*')
  call mma_deallocate(iorts,safe='*')
  call mma_deallocate(irots,safe='*')
  call mma_deallocate(izeta,safe='*')
  call mma_deallocate(trprm,safe='*')
  call mma_deallocate(tconstr,safe='*')
  call mma_deallocate(ipermzeta,safe='*')
  call mma_deallocate(sstruc,safe='*')
  call mma_deallocate(sstruc2,safe='*')
  call mma_deallocate(wdx,safe='*')
  call mma_deallocate(orbs,safe='*')
  call mma_deallocate(cvb,safe='*')
  call mma_deallocate(vbdet,safe='*')
  call mma_deallocate(aikcof,safe='*')
  call mma_deallocate(cikcof,safe='*')
  call mma_deallocate(ikcoff,safe='*')
  call mma_deallocate(ifnss1,safe='*')
  call mma_deallocate(ifnss2,safe='*')
  call mma_deallocate(ndetvbs,safe='*')
  nullify(civb1,civb2,civb3,civb4,civb5,civb6,civb7,civb8,i1bet,ibfrm,ibto,phbto,bikcof)
end subroutine casvb_free

end module casvb_global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ang2(ang,binom,crda,dfac,it,l,lit,lmlo,lmhi,lmf,lml,lmx,lmy,lmz,mproju,xk,yk,zk,zlm)
! compute type 2 angular integrals

use ppint_arrays, only: lmnv
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: it, l, lit, lmlo, lmhi, lmf(*), lml(*), lmx(*), lmy(*), lmz(*), mproju
real(kind=wp), intent(out) :: ang(lit,mproju,lmhi)
real(kind=wp), intent(in) :: binom(*), crda(lit,3), dfac(*), xk, yk, zk, zlm(*)
integer(kind=iwp) :: i, ia, ib, ic, iend, indx, indy, indz, istart, j, l2, la1, laind, lam, lamhi, lamlo, loc1, loc2, m, ma1, &
                     maind, mend, mhi, mndx, mndy, mndz, mstart, mu, n, na1, naind
real(kind=wp) :: a_int, angt, pab1, pab2, pab3, pre, xkp, ykp, zkp

ang(:,:,:) = Zero
na1 = lmnv(1,it)+1
la1 = lmnv(2,it)+1
ma1 = lmnv(3,it)+1
naind = (na1*(na1-1))/2
laind = (la1*(la1-1))/2
maind = (ma1*(ma1-1))/2
loc1 = (l-1)**2
mhi = l+l-1
do ia=1,na1
  pab1 = binom(naind+ia)*crda((na1+1)-ia,1)
  if (pab1 == Zero) cycle
  do ib=1,la1
    pab2 = pab1*binom(laind+ib)*crda((la1+1)-ib,2)
    if (pab2 == Zero) cycle
    do ic=1,ma1
      pab3 = pab2*binom(maind+ic)*crda((ma1+1)-ic,3)
      if (pab3 == Zero) cycle
      n = ((ia-3)+ib)+ic
      lamlo = max(l-n,lmlo+mod(l+n+lmlo,2))
      lamhi = min(l+n,lmhi-mod(l+n+lmhi,2))
      if (lamlo > lamhi) cycle
      do m=1,mhi
        mstart = lmf(loc1+m)
        mend = lml(loc1+m)
        do lam=lamlo,lamhi,2
          l2 = lam+lam-1
          angt = Zero
          loc2 = (lam-1)**2
          do mu=1,l2
            istart = lmf(loc2+mu)
            if ((mod(ia+lmx(mstart)+lmx(istart),2) /= 1) .or. &
                (mod(ib+lmy(mstart)+lmy(istart),2) /= 1) .or. &
                (mod(ic+lmz(mstart)+lmz(istart),2) /= 1)) cycle
            pre = Zero
            iend = lml(loc2+mu)
            a_int = Zero
            do i=istart,iend
              indx = lmx(i)
              indy = lmy(i)
              indz = lmz(i)
              if (indx == 0) then
                xkp = One
              else
                xkp = xk**indx
              end if
              if (indy == 0) then
                ykp = One
              else
                ykp = yk**indy
              end if
              if (indz == 0) then
                zkp = One
              else
                zkp = zk**indz
              end if
              pre = pre+zlm(i)*xkp*ykp*zkp
              do j=mstart,mend
                mndx = lmx(j)
                mndy = lmy(j)
                mndz = lmz(j)
                a_int = a_int+zlm(i)*zlm(j)*dfac(ia+indx+mndx)*dfac(ib+indy+mndy)*dfac(ic+indz+mndz)/ &
                        dfac(ia+indx+mndx+ib+indy+mndy+ic+indz+mndz)
              end do
            end do
            angt = angt+pre*a_int
          end do
          ang(n+1,m,lam) = ang(n+1,m,lam)+angt*pab3
        end do
      end do
    end do
  end do
end do

return

end subroutine ang2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Jun-ya Hasegawa                                  *
*               2004, Giovanni Ghigo                                   *
************************************************************************
      SUBROUTINE RDINT2(IPRX,DoTCVA)
C
C     SECOND ORDER TWO-ELECTRON TRANFORMATION PROGRAM. TEST SECTION
C
C     THIS SUBROUTINE READS AND CHECKS THE RESULT OF THE SECOND ORDER
C     TWO-ELECTRON TRANSFORMATION PROGRAM TRA2. IT CAN BE CALLED BY
C     TR2CTL IMMEDIATELY AFTER THE CALL TO TRA2
C      IPRX=0 Do not print Coulomb nor Exchange Integrals
C      IPRX=1 Print only Coulomb Integrals
C      IPRX=2 Print all Integrals
C      IPRX=3 Print only Exchange Integrals
C
*     Modified for caspt2 by Jun-ya Hasegawa(98/08/18)
*     Modified again by G. Ghigo - September-December 2004
C
C     A,B are MO indices, counting only non-frozen and non-deleted.
C     T,U are occupied MO indices, only non-frozen and non-deleted.
C
C     <AB/TU> ARE ALWAYS GENERATED
C     EXCHANGE INTEGRALS <AT/BU> ARE GENERATED AS FOLLOWS:
C     <AT/BU> IF ISP.GE.ISR
C     <AT/UB> IF ISP.GT.ISS AND ISP.NE.ISQ
C     <TA/BU> IF ISQ.GT.ISR AND ISP.NE.ISQ
C     <TA/UB> IF ISQ.GE.ISS AND ISP.NE.ISQ
C
C     IAD2M CONTAINS START ADRESS FOR EACH TYPE OF INTEGRALS:
C     IAD2M(1,iSymIJAB)   COULOMB INTEGRALS <AB|TU>
C     IAD2M(2,iSymIJAB)   EXCHANGE INTEGRALS <AB|TU> FOR SYM T > SYM U
C     IAD2M(3,iSymIJAB)   EXCHANGE INTEGRALS <AB|TU> FOR SYM T < SYM U
C     THE LAST ADRESS IS ZERO IF SYM T = SYM U

      Implicit Integer (i-n)
      Implicit Real*8 (A-H,O-Z)

      Parameter (MxFro = 50)
      Parameter (MxDel = 50)

#include "rasdim.fh"
#include "caspt2.fh"
#include "trafo.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

      Dimension IAD2M(3*36*36)
      Logical DoTCVA
      Logical Found

C GG-Dec04  The following informations must be passed to the Cholesky
C transformation section through RunFile. COMMON blocks could not be
C used due to several conflicts.
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      Call Get_iArray('nFroPT',nFro,nSym)
      Call Get_iArray('nDelPT',nDel,nSym)
      Call Get_iArray('nIsh',nIsh,nSym)
* PAM 2007      Call Get_iArray('nAsh',nAsh,nSym)
* Replaced by:
      Do i=1,nSym
        nAsh(i)=0
      End Do
      Call qpg_iArray('nAsh',Found,nData)
      If(Found .and. nData.eq.nSym) Then
        Call Get_iArray('nAsh',nAsh,nSym)
      End If
* End of replacement
      Do i=1,nSym
        nOrb(i) = nBas(i) - nFro(i) - nDel(i)
        nIsh(i) = nIsh(i) - nFro(i)
        nOsh(i) = nIsh(i) + nAsh(i)
        nSsh(i) = nOrb(i) - nOsh(i)
      EndDo

      Write(6,*)
      Write(6,*) 'SECOND ORDER TWO-ELECTRON TRANFORMATION PROGRAM. ',
     &' TEST SECTION:'
      Write(6,*) ' A,B are MO-symmetry indices, counting only',
     &'  non-frozen and non-deleted.'
      Write(6,*) ' I,J are occupied MO-symmetry indices, only',
     &'  non-frozen and non-deleted.'
      Write(6,*) ' i,j are occupied MO indices'
c      Write(6,*) ' <AB/TU> COULOMB INTEGRALS ARE ALWAYS GENERATED.'
c      Write(6,*) ' <AB|TU> EXCHANGE INTEGRALS ARE GENERATED AS FOLLOWS:'
c      Write(6,*) '   <AT/BU> IF ISP.GE.ISR'
c      Write(6,*) '   <AT/UB> IF ISP.GT.ISS AND ISP.NE.ISQ'
c      Write(6,*) '   <TA/BU> IF ISQ.GT.ISR AND ISP.NE.ISQ'
c      Write(6,*) '   <TA/UB> IF ISQ.GE.ISS AND ISP.NE.ISQ'
c      Write(6,*) ' IAD2M(1,iSymIJAB)  COULOMB INTEGRALS <AB|TU>'
c      Write(6,*) ' IAD2M(2,iSymIJAB)  EXCHANGE INTEGRALS <AB|TU> FOR SYM
c     &  T > SYM U'
c      Write(6,*) ' IAD2M(3,iSymIJAB)  EXCHANGE INTEGRALS <AB|TU> FOR SYM
c     &  T < SYM U'
c      Write(6,*) ' THE LAST ADRESS IS ZERO IF SYM T = SYM U'
      Write(6,*)
      Write(6,'(A,8I3)')'        Symmetries :',(i,i=1,nSym)
      Write(6,*)
      Write(6,'(A,8I3)')'           Frozen  :',(nFro(i),i=1,nSym)
      Write(6,'(A,8I3)')'      Inactive (I) :',(nIsh(i),i=1,nSym)
      Write(6,'(A,8I3)')'        Active (A) :',(nAsh(i),i=1,nSym)
      Write(6,'(A,8I3)')'     Secondary (S) :',(nSsh(i),i=1,nSym)
      Write(6,'(A,8I3)')'          Deleted  :',(nDel(i),i=1,nSym)
      Write(6,*)
      Write(6,'(A,8I3)')'  Total correlated :',(nOrb(i),i=1,nSym)
      Call XFlush(6)

C
C     READ ADDRESS RECORD ON UNIT LUINTM
C
      IAD13=0
      LIADUT=3888
      CALL iDAFILE(LUINTM,2,IAD2M,LIADUT,IAD13)
C
C     LOOP OVER QUADRUPLES OF SYMMETRIES (iSymI,iSymJ,iSymA,iSymB)
C
      iSymIJAB=0
      LTotInt=0
      LTotEx1=0
      LTotEx2=0
      DO 104 iSymI=1,NSYM
       nOrbI=nOrb(iSymI)
       nOccI=nOsh(iSymI)
       DO 103 iSymJ=1,iSymI
        nOrbJ=nOrb(iSymJ)
        nOccJ=nOsh(iSymJ)
        iSymIJ=MUL(iSymI,iSymJ)
        DO 102 iSymA=1,NSYM
         nOrbA=nOrb(iSymA)
         nOccA=nOsh(iSymA)
         iSymIJA=MUL(iSymIJ,iSymA)
         ISR=iSymA
         DO 101 iSymB=1,iSymA
          nOrbB=nOrb(iSymB)
          nOccB=nOsh(iSymB)
          iSymIJAB=iSymIJAB+1

          IF(iSymIJA.NE.iSymB) GO TO 101
          IF((nOccI*nOccJ).EQ.0) GO TO 101
          IF(nOrbI*nOrbJ*nOrbA*nOrbB.EQ.0) GO TO 101
C
C         FIND ADDRESSES FOR THIS SYMMETRY BLOCK
C
          IADC =IAD2M(3*iSymIJAB-2)
          IADX1=IAD2M(3*iSymIJAB-1)
          IADX2=IAD2M(3*iSymIJAB)
          WRITE(6,1000) iSymA,iSymB,iSymI,iSymJ
1000      FORMAT(/1X,'SYMMETRY BLOCK < A B | I J >',4I4)

          IF(IADC.EQ.0) THEN
C           WRITE(6,*)
           WRITE(6,1100)
1100       FORMAT(1X,'NO COULOMB INTEGRALS FOR THIS SYMMETRY BLOCK')
          ELSE
           WRITE(6,1200) IADC
1200       FORMAT(1X,'ADDRESS FOR COULOMB INTEGRALS',I8)
           IAD13C=IADC
          ENDIF
          IF(IADX1.EQ.0) THEN
C           WRITE(6,*)
           WRITE(6,1110)
1110       FORMAT(1X,'NO EXCHAN1 INTEGRALS FOR THIS SYMMETRY BLOCK')
          ELSE
           WRITE(6,1210) IADX1
1210       FORMAT(1X,'ADDRESS FOR EXCHAN1 INTEGRALS',I8)
           IAD131=IADX1
          ENDIF
          IF(IADX2.EQ.0) THEN
C           WRITE(6,*)
           WRITE(6,1120)
1120       FORMAT(1X,'NO EXCHAN2 INTEGRALS FOR THIS SYMMETRY BLOCK')
          ELSE
           WRITE(6,1220) IADX2
1220       FORMAT(1X,'ADDRESS FOR EXCHAN2 INTEGRALS',I8)
           IAD132=IADX2
          ENDIF
          LREC=nOrbA*nOrbB
          IF(iSymA.EQ.iSymB) LREC=(nOrbA**2+nOrbA)/2
          LRECX=nOrbA*nOrbB
          IF(.NOT.DoTCVA) LRECX=(nOrbA-nOccA)*(nOrbB-nOccB)
          LInt=0
          LEx1=0
          LEx2=0
          DO 10 NI=1,nOccI
           NUM=nOccJ
           IF(iSymI.EQ.iSymJ) NUM=NI
            DO 11 NJ=1,NUM

C     THE LOOP ABOVE OVER T AND U RECOVERS ONE BLOCK OF INTEGRALS <AB|TU>
C     FOR EACH PAIR T,U. TO PROCESS ONE BLOCK FOR ALL A AND B THE
C     FOLLOWING LOOP STRUCTURE IS USED:

            IF (IADC.NE.0) THEN
             LInt=LInt+LREC
             If (IPRX.GT.0. and. IPRX.LT.3) then
              Call GetMem('Tmp','ALLO','REAL',iTmp,LREC)
              CALL dDAFILE(LUINTM,2,WORK(iTmp),LREC,IAD13C)
          WRITE(6,1300) NI,NJ,IAD13C-LREC,(WORK(I),I=iTmp,iTmp+LREC-1)
              Call GetMem('Tmp','FREE','REAL',iTmp,LREC)
1300          FORMAT(/1X,'<AB|IJ> COULOMB INTEGR.S FOR |ij> PAIR',2I3,
     &      '  DiskAdd=',I8  /(8F10.6))
             EndIf
            ENDIF

C      THE EXCHANGE INTEGRALS OF TYPE 1 ,(AT|BU) ARE PROCESSED AS THE
C      COULOMB INTEGRALS. IF NST.NE.NSU THERE ARE ALSO EXCHANGE
C      INTEGRALS OF TYPE 2, (AU|BT). THE ORDERING IS STILL T,U AND A,B
C      BUT T IS NOW THE FOURTH INDEX AND U THE SECOND
C      EXCHANGE INTEGRALS ARE ALWAYS QUADRATIC IN A,B

            IF (IADX1.NE.0) THEN
             LEx1=LEx1+LRECX
             If (IPRX.GT.1) then
              Call GetMem('Tmp','ALLO','REAL',iTmp,LRECX)
              CALL dDAFILE(LUINTM,2,WORK(iTmp),LRECX,IAD131)
          WRITE(6,1310) NI,NJ,IAD131-LRECX,(WORK(I),I=iTmp,iTmp+LRECX-1)
              Call GetMem('Tmp','FREE','REAL',iTmp,LRECX)
1310          FORMAT(/1X,'EXCHAN1 INTEGRALS FOR |ij> PAIR',2I3,
     &      '  DiskAdd=',I8  /(8F10.6))
             EndIf
            ENDIF

            IF (IADX2.NE.0) THEN
             LEx2=LEx2+LRECX
             If (IPRX.GT.1) then
              Call GetMem('Tmp','ALLO','REAL',iTmp,LRECX)
              CALL dDAFILE(LUINTM,2,WORK(iTmp),LRECX,IAD132)
          WRITE(6,1320) NI,NJ,IAD132-LRECX,(WORK(I),I=iTmp,iTmp+LRECX-1)
              Call GetMem('Tmp','FREE','REAL',iTmp,LRECX)
1320          FORMAT(/1X,'EXCHAN2 INTEGRALS FOR |ij> PAIR',2I3,
     &      '  DiskAdd=',I8  /(8F10.6))
             EndIf
            ENDIF
11          CONTINUE
10        CONTINUE

          Write(6,*)
          Write(6,1010) LInt,LEx1,LEx2
1010      Format(3X,'LCou=',I8,' , LEx1=',I8,' , LEx2=',I8)
          LTotInt=LTotInt+LInt
          LTotEx1=LTotEx1+LEx1
          LTotEx2=LTotEx2+LEx2
C
C     ALL INTEGRALS FOR SYMMETRY BLOCK iSymI,iSymJ,iSymA,iSymB ARE READ
C
101      CONTINUE
102     CONTINUE
103    CONTINUE
104   CONTINUE
      Write(6,*)
      Write(6,2000) LTotInt,LTotEx1,LTotEx2
2000  Format(3X,'LTotCou=',I8,' , LTotEx1=',I8,' , LTotEx2=',I8)
      Write(6,*) '   LTotTot=',LTotInt+LTotEx1+LTotEx2
      Write(6,*)
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine CCmbnMP(Rnxyz,nZeta,la,lb,lr,Zeta,rKappa,rFinal,nComp,kVector,P)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: One, Quart, Onei
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, lr, nComp
complex(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la,0:lb,0:lr)
real(kind=wp), intent(in) :: Zeta(nZeta), rKappa(nZeta), kVector(3), P(nZeta,3)
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nComp)
integer(kind=iwp) :: iComp, ipa, ipb, ix, ixa, ixb, iy, iya, iyaMax, iyb, iybMax, iz, iza, izb, iZeta
complex(kind=wp) :: Temp
real(kind=wp) :: Fact, k_Dot_P, kModQ, rTemp

kModQ = Quart*(kVector(1)**2+kVector(2)**2+kVector(3)**2)

do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        ! Combine multipole moment integrals

        iComp = 0
        do ix=lr,0,-1
          do iy=lr-ix,0,-1
            iz = lr-ix-iy
            do iZeta=1,nZeta
              rTemp = kModQ/Zeta(iZeta)
              Fact = rKappa(iZeta)*(One/sqrt(Zeta(iZeta)**3))*exp(-rTemp)
              k_Dot_P = kVector(1)*P(iZeta,1)+kVector(2)*P(iZeta,2)+kVector(3)*P(iZeta,3)
              Temp = exp(Onei*k_Dot_P)*Fact*Rnxyz(iZeta,1,ixa,ixb,ix)*Rnxyz(iZeta,2,iya,iyb,iy)*Rnxyz(iZeta,3,iza,izb,iz)
              rFinal(iZeta,ipa,ipb,iComp+1) = real(Temp)
              rFinal(iZeta,ipa,ipb,iComp+2) = aimag(Temp)
            end do
            iComp = iComp+2
          end do
        end do

      end do
    end do
  end do
end do

return

end subroutine CCmbnMP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Roland Lindh                                     *
************************************************************************
      Subroutine dRho_dR_meta_GGA2
     &                      (nD,dRho_dR,ndRho_dR,mGrid,
     &                       list_s,nlist_s,TabAO,ipTabAO,mAO,nTabAO,
     &                       nSym,nGrad_Eff,list_g,Maps2p,nShell,
     &                       Fact,ndc,TabAOMax,T_X,
     &                       list_bas,Index,nIndex)
************************************************************************
*                                                                      *
* Object: to compute the gradient of rho, grad rho, and nabla rho      *
*                                                                      *
*      Author:Roland Lindh, Department of Theoretical Chemistry,       *
*             Lund university, SWEDEN.  September 2007                 *
************************************************************************
      use iSD_data
      use k2_arrays, only: DeDe, ipDijS
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "disp.fh"
#include "real.fh"
#include "print.fh"
#include "debug.fh"
#include "nsd.fh"
#include "setup.fh"
      Integer On, Off
      Parameter (On=1, Off=0)
      Integer list_s(2,nlist_s), list_g(3,nlist_s),
     &        ipTabAO(nlist_s), Maps2p(nShell,0:nSym-1),
     &        list_bas(2,nlist_s), Index(nIndex)
      Real*8 dRho_dR(ndRho_dR,mGrid,nGrad_Eff),
     &       TabAO(nTabAO), Fact(ndc**2), TabAOMax(nlist_s)
      Integer IndGrd_Eff(3,2)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (Debug) Then
         Write (6,*) 'mAO=',mAO
         Write (6,*) 'mGrid=',mGrid
         Write (6,*) 'nTabAO=',nTabAO
         Write (6,*) 'nlist_s=',nlist_s
         Do iList_s = 1, nList_s
            Write (6,*) 'iList_s=',iList_s
            iS = list_s(1,ilist_s)
            iCmp  = iSD( 2,iS)
            iBas  = iSD( 3,iS)
            iBas_Eff = list_bas(1,ilist_s)
            mTabAO=iBas_Eff*iCmp
            mdci  = iSD(10,iS)
            Call RecPrt('dRho_dR_meta_GGA: TabAO',' ',
     &                  TabAO(ipTabAO(iList_s)),mAO,mGrid*mTabAO)
         End Do
      End If
#endif
*
      Call FZero(dRho_dR,ndRho_dR*mGrid*nGrad_Eff)
*                                                                      *
************************************************************************
*                                                                      *
      Do ilist_s=1,nlist_s
         iS    = list_s(1,ilist_s)
         kDCRE = list_s(2,ilist_s)
         iCmp  = iSD( 2,iS)
         iBas_Eff=list_bas(1,ilist_s)
         ix = iDAMax_(mAO*mGrid*iBas_Eff*iCmp,TabAO(ipTabAO(iList_s)),1)
         TabAOMax(ilist_s)=Abs(TabAO(ipTabAO(ilist_s)-1+ix))
         TMax_i=TabAOMax(ilist_s)
         If (TMax_i.le.T_X) Go To 999
         iBas  = iSD( 3,iS)
         iPrim = iSD( 5,iS)
         mdci  = iSD(10,iS)
         iShell= iSD(11,iS)
         index_i=list_bas(2,ilist_s)
*
         lDCRE=NrOpr(kDCRE)
*
         jNQ=Maps2p(iS,lDCRE)
         Call ICopy(3,list_g(1,ilist_s),1,IndGrd_Eff(1,1),1)
         n1 = IndGrd_Eff(1,1) + IndGrd_Eff(2,1) + IndGrd_Eff(3,1)
*
         Do jlist_s=1,ilist_s
            TMax_j=TabAOMax(jlist_s)
            If (TMax_j.le.T_X) Go To 98
            If (TMax_i*TMax_j.lt.T_X) Go To 98
            jS    = list_s(1,jlist_s)
            kDCRR = list_s(2,jlist_s)
            jCmp  = iSD( 2,jS)
            jBas  = iSD( 3,jS)
            jPrim = iSD( 5,jS)
            mdcj  = iSD(10,jS)
            jShell= iSD(11,jS)
            jBas_Eff=list_bas(1,jlist_s)
            index_j =list_bas(2,jlist_s)
*
            lDCRR=NrOpr(kDCRR)
*
            kNQ=Maps2p(jS,lDCRR)
            Call ICopy(3,list_g(1,jlist_s),1,IndGrd_Eff(1,2),1)
            n2 = IndGrd_Eff(1,2) + IndGrd_Eff(2,2) + IndGrd_Eff(3,2)
            If (n1+n2.eq.0) Go To 98
*
            mDij=iBas*jBas*iCmp*jCmp
*
*---------- Get the Density
*
            ijS=iTri(iShell,jShell)
            ipTmp=ipDijs
            Call Dens_Info(ijS,ipDij,ipDSij,mDCRij,ipDDij,ipTmp,nD)
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*)
               Write (6,*) 'iS,jS=',iS,jS
               Write (6,*) 'mDCRij,mDij=',mDCRij,mDij
               Write (6,*) 'ipDij,ipDSij,ipDDij=',ipDij,ipDSij,ipDDij
            End If
#endif
*
            ij = (mdcj-1)*ndc + mdci
*
            Deg=Two
            If (ilist_s.eq.jlist_s) Deg=One
*
            iER=iEOr(kDCRE,kDCRR)
            lDCRER=NrOpr(iER)
*
            ip_D_a=ipDij+lDCRER*mDij
            ip_D_b=ip_D_a
            If (nD.ne.1) ip_D_b=ipDSij+lDCRER*mDij
*
            If (nD.ne.1) Then
               ix=iDAMax_(mDij,DeDe(ip_D_a),1)
               iy=iDAMax_(mDij,DeDe(ip_D_b),1)
               DMax_ij=Half*( Abs(DeDe(ip_D_a-1+ix))
     &                       +Abs(DeDe(ip_D_b-1+iy)) )
            Else
               ix=iDAMax_(mDij,DeDe(ip_D_a),1)
               DMax_ij=Abs(DeDe(ip_D_a-1+ix))
            End If
            DMax_ij=DMax_ij*Fact(ij)
            If (TMax_i*TMax_j*DMax_ij.lt.T_X) Go To 98
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*) 'dRho_dR_meta_GGA2'
               nBB = iBas*jBas
               nCC = iCmp*jCmp
               Write (6,*) 'iER,lDCRER=',iER,lDCRER
               Call RecPrt('DAij',' ',DeDe(ip_D_a),nBB,nCC)
               If (nD.ne.1)
     &            Call RecPrt('DBij',' ',DeDe(ip_D_b),nBB,nCC)
            End If
#endif
*
            If (iShell.lt.jShell) Then
               itmp=IndGrd_Eff(1,1)
               IndGrd_Eff(1,1)=IndGrd_Eff(1,2)
               IndGrd_Eff(1,2)=itmp
               itmp=IndGrd_Eff(2,1)
               IndGrd_Eff(2,1)=IndGrd_Eff(2,2)
               IndGrd_Eff(2,2)=itmp
               itmp=IndGrd_Eff(3,1)
               IndGrd_Eff(3,1)=IndGrd_Eff(3,2)
               IndGrd_Eff(3,2)=itmp
            End If
            If (nD.eq.1) Then
               If (iShell.ge.jShell) Then
               Call Do_Rho9da(dRho_dR,    mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),                  mAO,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               Else
               Call Do_Rho9da(dRho_dR,    mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),                  mAO,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               End If
            Else
               If (iShell.ge.jShell) Then
               Call Do_Rho9d_(dRho_dR,    mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),DeDe(ip_D_b),     mAO,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               Else
               Call Do_Rho9d_(dRho_dR,    mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),DeDe(ip_D_b),     mAO,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               End If
            End If
*
 98         Continue
         End Do                      ! jlist_s
 999     Continue
      End Do                         ! ilist_s
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (Debug) Call RecPrt('dRho_dR_meta_GGA: dRho_dR',' ',dRho_dR,
     &                        ndRho_dR*mGrid,nGrad_Eff)
*
#endif
      Return
      End
      Subroutine Do_Rho9da(dRho_dR,     mGrid,nGrad_Eff,
     &                     DAij,          mAO,
     &                     TabAO1,iBas,iBas_Eff,iCmp,
     &                     TabAO2,jBas,jBas_Eff,jCmp,
     &                     Fact,IndGrd_Eff,T_X,TMax_ij,
     &                     Index_i,Index_j)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 dRho_dR(  6,mGrid,nGrad_Eff), DAij(iBas*iCmp,jBas*jCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp),
     &       TabAO2(mAO,mGrid,jBas_Eff*jCmp)
      Integer IndGrd_Eff(3,2), Index_i(iBas_Eff*iCmp),
     &                         Index_j(jBas_Eff*jCmp)
*                                                                      *
************************************************************************
*                                                                      *
*     Rather than to use integers directly we set up a symbolic way of
*     doing the indexation.
*
      Integer F,
     &        dx, dy, dz,
     &        dx2, dxdy, dxdz, dy2, dydz, dz2,
     &             dydx, dzdx,      dzdy,
     &        dx3, dx2dy, dx2dz, dxdy2, dxdydz,
     &             dydx2, dzdx2, dy2dx, dxdzdy,
     &                                  dydxdz,
     &                                  dydzdx,
     &                                  dzdxdy,
     &                                  dzdydz,
     &        dxdz2, dy3, dy2dz, dydz2, dz3,
     &        dz2dx,      dzdy2, dz2dy
      Parameter(F=1,
     &          dx=2, dy=3, dz=4,
     &          dx2=5, dxdy=6, dxdz=7, dy2=8, dydz=9,
     &                 dydx=6, dzdx=7,        dzdy=9,
     &          dz2=10,
     &  dx3=11, dx2dy=12, dx2dz=13, dxdy2=14, dxdydz=15,
     &          dydx2=12, dzdx2=13, dy2dx=14, dxdzdy=15,
     &                                        dydxdz=15,
     &                                        dydzdx=15,
     &                                        dzdxdy=15,
     &                                        dzdydz=15,
     &     dxdz2=16, dy3=17, dy2dz=18, dydz2=19, dz3=20,
     &     dz2dx=16,         dzdy2=18, dz2dy=19
     &         )
*                                                                      *
************************************************************************
*                                                                      *
      Do jCB_Eff = 1, jBas_Eff*jCmp
         jCB = Index_j(jCB_Eff)
*
         Do iCB_Eff = 1, iBas_Eff*iCmp
            iCB = Index_i(iCB_Eff)
*
            DAij_=DAij(iCB,jCB)*Fact
            If (TMax_ij*Abs(DAij_).lt.T_X) Go To 99
*                                                                      *
************************************************************************
*                                                                      *
*---------- x component
*
            Ind_x1=IndGrd_Eff(1,1)
            Ind_x2=IndGrd_Eff(1,2)
            If (Ind_x1.ne.0.and.Ind_x2.ne.0) Then
               Do iGrid = 1, mGrid
                  x1   =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
                  x1_x =TabAO1(dx2  ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x1_y =TabAO1(dxdy ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  x1_z =TabAO1(dxdz ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  x1_t =TabAO1(dx2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dxdy ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dxdz ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  x1_r=(TabAO1(dx3  ,iGrid,iCB_Eff)
     &                 +TabAO1(dxdy2,iGrid,iCB_Eff)
     &                 +TabAO1(dxdz2,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +x1_t
                  x2   =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_x =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_y =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_z =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx2  ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)*Two
                  x2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx3  ,iGrid,jCB_Eff)
     &                 +TabAO2(dxdy2,iGrid,jCB_Eff)
     &                 +TabAO2(dxdz2,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
     &                 +x2_t
                  dRho_dR(1,iGrid,Ind_x1)=dRho_dR(1,iGrid,Ind_x1)
     &                                   +x1  *DAij_
                  dRho_dR(2,iGrid,Ind_x1)=dRho_dR(2,iGrid,Ind_x1)
     &                                   +x1_x*DAij_
                  dRho_dR(3,iGrid,Ind_x1)=dRho_dR(3,iGrid,Ind_x1)
     &                                   +x1_y*DAij_
                  dRho_dR(4,iGrid,Ind_x1)=dRho_dR(4,iGrid,Ind_x1)
     &                                   +x1_z*DAij_
                  dRho_dR(5,iGrid,Ind_x1)=dRho_dR(5,iGrid,Ind_x1)
     &                                   +x1_t*DAij_
                  dRho_dR(6,iGrid,Ind_x1)=dRho_dR(6,iGrid,Ind_x1)
     &                                   +x1_r*DAij_
                  dRho_dR(1,iGrid,Ind_x2)=dRho_dR(1,iGrid,Ind_x2)
     &                                   +x2   *DAij_
                  dRho_dR(2,iGrid,Ind_x2)=dRho_dR(2,iGrid,Ind_x2)
     &                                   +x2_x *DAij_
                  dRho_dR(3,iGrid,Ind_x2)=dRho_dR(3,iGrid,Ind_x2)
     &                                   +x2_y *DAij_
                  dRho_dR(4,iGrid,Ind_x2)=dRho_dR(4,iGrid,Ind_x2)
     &                                   +x2_z *DAij_
                  dRho_dR(5,iGrid,Ind_x2)=dRho_dR(5,iGrid,Ind_x2)
     &                                   +x2_t*DAij_
                  dRho_dR(6,iGrid,Ind_x2)=dRho_dR(6,iGrid,Ind_x2)
     &                                   +x2_r*DAij_
               End Do ! iGrid
            Else If (Ind_x1.ne.0) Then
               Do iGrid = 1, mGrid
                  x1   =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
                  x1_x =TabAO1(dx2  ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x1_y =TabAO1(dxdy ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  x1_z =TabAO1(dxdz ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  x1_t =TabAO1(dx2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dxdy ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dxdz ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  x1_r=(TabAO1(dx3  ,iGrid,iCB_Eff)
     &                 +TabAO1(dxdy2,iGrid,iCB_Eff)
     &                 +TabAO1(dxdz2,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +x1_t
                  dRho_dR(1,iGrid,Ind_x1)=dRho_dR(1,iGrid,Ind_x1)
     &                                   +x1  *DAij_
                  dRho_dR(2,iGrid,Ind_x1)=dRho_dR(2,iGrid,Ind_x1)
     &                                   +x1_x*DAij_
                  dRho_dR(3,iGrid,Ind_x1)=dRho_dR(3,iGrid,Ind_x1)
     &                                   +x1_y*DAij_
                  dRho_dR(4,iGrid,Ind_x1)=dRho_dR(4,iGrid,Ind_x1)
     &                                   +x1_z*DAij_
                  dRho_dR(5,iGrid,Ind_x1)=dRho_dR(5,iGrid,Ind_x1)
     &                                   +x1_t*DAij_
                  dRho_dR(6,iGrid,Ind_x1)=dRho_dR(6,iGrid,Ind_x1)
     &                                   +x1_r*DAij_
               End Do ! iGrid
            Else If (Ind_x2.ne.0) Then
               Do iGrid = 1, mGrid
                  x2   =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_x =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_y =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_z =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx2  ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)*Two
                  x2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx3  ,iGrid,jCB_Eff)
     &                 +TabAO2(dxdy2,iGrid,jCB_Eff)
     &                 +TabAO2(dxdz2,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
     &                 +x2_t
                  dRho_dR(1,iGrid,Ind_x2)=dRho_dR(1,iGrid,Ind_x2)
     &                                   +x2   *DAij_
                  dRho_dR(2,iGrid,Ind_x2)=dRho_dR(2,iGrid,Ind_x2)
     &                                   +x2_x *DAij_
                  dRho_dR(3,iGrid,Ind_x2)=dRho_dR(3,iGrid,Ind_x2)
     &                                   +x2_y *DAij_
                  dRho_dR(4,iGrid,Ind_x2)=dRho_dR(4,iGrid,Ind_x2)
     &                                   +x2_z *DAij_
                  dRho_dR(5,iGrid,Ind_x2)=dRho_dR(5,iGrid,Ind_x2)
     &                                   +x2_t*DAij_
                  dRho_dR(6,iGrid,Ind_x2)=dRho_dR(6,iGrid,Ind_x2)
     &                                   +x2_r*DAij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*---------- y component
*
            Ind_y1=IndGrd_Eff(2,1)
            Ind_y2=IndGrd_Eff(2,2)
            If (Ind_y1.ne.0.and.Ind_y2.ne.0) Then
               Do iGrid = 1, mGrid
                  y1   =TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
                  y1_x =TabAO1(dydx ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  y1_y =TabAO1(dy2  ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y1_z =TabAO1(dydz ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  y1_t =TabAO1(dydx ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dydz ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  y1_r=(TabAO1(dx2dy,iGrid,iCB_Eff)
     &                 +TabAO1(dy3  ,iGrid,iCB_Eff)
     &                 +TabAO1(dydz2,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +y1_t
                  y2   =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_x =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dydx ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_y =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_z =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy2  ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)*Two
                  y2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2dy,iGrid,jCB_Eff)
     &                 +TabAO2(dy3  ,iGrid,jCB_Eff)
     &                 +TabAO2(dydz2,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
     &                 +y2_t
                  dRho_dR(1,iGrid,Ind_y1)=dRho_dR(1,iGrid,Ind_y1)
     &                                   +y1   *DAij_
                  dRho_dR(2,iGrid,Ind_y1)=dRho_dR(2,iGrid,Ind_y1)
     &                                   +y1_x *DAij_
                  dRho_dR(3,iGrid,Ind_y1)=dRho_dR(3,iGrid,Ind_y1)
     &                                   +y1_y *DAij_
                  dRho_dR(4,iGrid,Ind_y1)=dRho_dR(4,iGrid,Ind_y1)
     &                                   +y1_z *DAij_
                  dRho_dR(5,iGrid,Ind_y1)=dRho_dR(5,iGrid,Ind_y1)
     &                                   +y1_t *DAij_
                  dRho_dR(6,iGrid,Ind_y1)=dRho_dR(6,iGrid,Ind_y1)
     &                                   +y1_r *DAij_
                  dRho_dR(1,iGrid,Ind_y2)=dRho_dR(1,iGrid,Ind_y2)
     &                                   +y2   *DAij_
                  dRho_dR(2,iGrid,Ind_y2)=dRho_dR(2,iGrid,Ind_y2)
     &                                   +y2_x *DAij_
                  dRho_dR(3,iGrid,Ind_y2)=dRho_dR(3,iGrid,Ind_y2)
     &                                   +y2_y *DAij_
                  dRho_dR(4,iGrid,Ind_y2)=dRho_dR(4,iGrid,Ind_y2)
     &                                   +y2_z *DAij_
                  dRho_dR(5,iGrid,Ind_y2)=dRho_dR(5,iGrid,Ind_y2)
     &                                   +y2_t *DAij_
                  dRho_dR(6,iGrid,Ind_y2)=dRho_dR(6,iGrid,Ind_y2)
     &                                   +y2_r *DAij_
               End Do ! iGrid
            Else If (Ind_y1.ne.0) Then
               Do iGrid = 1, mGrid
                  y1   =TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
                  y1_x =TabAO1(dydx ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  y1_y =TabAO1(dy2  ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y1_z =TabAO1(dydz ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  y1_t =TabAO1(dydx ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dydz ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  y1_r=(TabAO1(dx2dy,iGrid,iCB_Eff)
     &                 +TabAO1(dy3  ,iGrid,iCB_Eff)
     &                 +TabAO1(dydz2,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +y1_t
                  dRho_dR(1,iGrid,Ind_y1)=dRho_dR(1,iGrid,Ind_y1)
     &                                   +y1   *DAij_
                  dRho_dR(2,iGrid,Ind_y1)=dRho_dR(2,iGrid,Ind_y1)
     &                                   +y1_x *DAij_
                  dRho_dR(3,iGrid,Ind_y1)=dRho_dR(3,iGrid,Ind_y1)
     &                                   +y1_y *DAij_
                  dRho_dR(4,iGrid,Ind_y1)=dRho_dR(4,iGrid,Ind_y1)
     &                                   +y1_z *DAij_
                  dRho_dR(5,iGrid,Ind_y1)=dRho_dR(5,iGrid,Ind_y1)
     &                                   +y1_t *DAij_
                  dRho_dR(6,iGrid,Ind_y1)=dRho_dR(6,iGrid,Ind_y1)
     &                                   +y1_r *DAij_
               End Do ! iGrid
            Else If (Ind_y2.ne.0) Then
               Do iGrid = 1, mGrid
                  y2   =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_x =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dydx ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_y =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_z =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy2  ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)*Two
                  y2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2dy,iGrid,jCB_Eff)
     &                 +TabAO2(dy3  ,iGrid,jCB_Eff)
     &                 +TabAO2(dydz2,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
     &                 +y2_t
                  dRho_dR(1,iGrid,Ind_y2)=dRho_dR(1,iGrid,Ind_y2)
     &                                   +y2   *DAij_
                  dRho_dR(2,iGrid,Ind_y2)=dRho_dR(2,iGrid,Ind_y2)
     &                                   +y2_x *DAij_
                  dRho_dR(3,iGrid,Ind_y2)=dRho_dR(3,iGrid,Ind_y2)
     &                                   +y2_y *DAij_
                  dRho_dR(4,iGrid,Ind_y2)=dRho_dR(4,iGrid,Ind_y2)
     &                                   +y2_z *DAij_
                  dRho_dR(5,iGrid,Ind_y2)=dRho_dR(5,iGrid,Ind_y2)
     &                                   +y2_t *DAij_
                  dRho_dR(6,iGrid,Ind_y2)=dRho_dR(6,iGrid,Ind_y2)
     &                                   +y2_r *DAij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*---------- z component
*
            Ind_z1=IndGrd_Eff(3,1)
            Ind_z2=IndGrd_Eff(3,2)
            If (Ind_z1.ne.0.and.Ind_z2.ne.0) Then
               Do iGrid = 1, mGrid
                  z1   =TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
                  z1_x =TabAO1(dzdx,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  z1_y =TabAO1(dzdy,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  z1_z =TabAO1(dz2 ,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z1_t =TabAO1(dzdx ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dzdy ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  z1_r=(TabAO1(dx2dz,iGrid,iCB_Eff)
     &                 +TabAO1(dy2dz,iGrid,iCB_Eff)
     &                 +TabAO1(dz3  ,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +z1_t
                  z2   =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_x =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dzdx,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_y =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dzdy,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_z =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2 ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2  ,iGrid,jCB_Eff)*Two
                  z2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2dz,iGrid,jCB_Eff)
     &                 +TabAO2(dy2dz,iGrid,jCB_Eff)
     &                 +TabAO2(dz3  ,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
     &                 +z2_t
                  dRho_dR(1,iGrid,Ind_z1)=dRho_dR(1,iGrid,Ind_z1)
     &                                   +z1  *DAij_
                  dRho_dR(2,iGrid,Ind_z1)=dRho_dR(2,iGrid,Ind_z1)
     &                                   +z1_x *DAij_
                  dRho_dR(3,iGrid,Ind_z1)=dRho_dR(3,iGrid,Ind_z1)
     &                                   +z1_y *DAij_
                  dRho_dR(4,iGrid,Ind_z1)=dRho_dR(4,iGrid,Ind_z1)
     &                                   +z1_z *DAij_
                  dRho_dR(5,iGrid,Ind_z1)=dRho_dR(5,iGrid,Ind_z1)
     &                                   +z1_t *DAij_
                  dRho_dR(6,iGrid,Ind_z1)=dRho_dR(6,iGrid,Ind_z1)
     &                                   +z1_r *DAij_
                  dRho_dR(1,iGrid,Ind_z2)=dRho_dR(1,iGrid,Ind_z2)
     &                                   +z2   *DAij_
                  dRho_dR(2,iGrid,Ind_z2)=dRho_dR(2,iGrid,Ind_z2)
     &                                   +z2_x *DAij_
                  dRho_dR(3,iGrid,Ind_z2)=dRho_dR(3,iGrid,Ind_z2)
     &                                   +z2_y *DAij_
                  dRho_dR(4,iGrid,Ind_z2)=dRho_dR(4,iGrid,Ind_z2)
     &                                   +z2_z *DAij_
                  dRho_dR(5,iGrid,Ind_z2)=dRho_dR(5,iGrid,Ind_z2)
     &                                   +z2_t *DAij_
                  dRho_dR(6,iGrid,Ind_z2)=dRho_dR(6,iGrid,Ind_z2)
     &                                   +z2_r *DAij_
               End Do ! iGrid
            Else If (Ind_z1.ne.0) Then
               Do iGrid = 1, mGrid
                  z1   =TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
                  z1_x =TabAO1(dzdx,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  z1_y =TabAO1(dzdy,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  z1_z =TabAO1(dz2 ,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z1_t =TabAO1(dzdx ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dzdy ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  z1_r=(TabAO1(dx2dz,iGrid,iCB_Eff)
     &                 +TabAO1(dy2dz,iGrid,iCB_Eff)
     &                 +TabAO1(dz3  ,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +z1_t
                  dRho_dR(1,iGrid,Ind_z1)=dRho_dR(1,iGrid,Ind_z1)
     &                                   +z1  *DAij_
                  dRho_dR(2,iGrid,Ind_z1)=dRho_dR(2,iGrid,Ind_z1)
     &                                   +z1_x *DAij_
                  dRho_dR(3,iGrid,Ind_z1)=dRho_dR(3,iGrid,Ind_z1)
     &                                   +z1_y *DAij_
                  dRho_dR(4,iGrid,Ind_z1)=dRho_dR(4,iGrid,Ind_z1)
     &                                   +z1_z *DAij_
                  dRho_dR(5,iGrid,Ind_z1)=dRho_dR(5,iGrid,Ind_z1)
     &                                   +z1_t *DAij_
                  dRho_dR(6,iGrid,Ind_z1)=dRho_dR(6,iGrid,Ind_z1)
     &                                   +z1_r *DAij_
               End Do ! iGrid
            Else If (Ind_z2.ne.0) Then
               Do iGrid = 1, mGrid
                  z2   =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_x =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dzdx,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_y =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dzdy,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_z =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2 ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2  ,iGrid,jCB_Eff)*Two
                  z2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2dz,iGrid,jCB_Eff)
     &                 +TabAO2(dy2dz,iGrid,jCB_Eff)
     &                 +TabAO2(dz3  ,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
     &                 +z2_t
                  dRho_dR(1,iGrid,Ind_z2)=dRho_dR(1,iGrid,Ind_z2)
     &                                   +z2   *DAij_
                  dRho_dR(2,iGrid,Ind_z2)=dRho_dR(2,iGrid,Ind_z2)
     &                                   +z2_x *DAij_
                  dRho_dR(3,iGrid,Ind_z2)=dRho_dR(3,iGrid,Ind_z2)
     &                                   +z2_y *DAij_
                  dRho_dR(4,iGrid,Ind_z2)=dRho_dR(4,iGrid,Ind_z2)
     &                                   +z2_z *DAij_
                  dRho_dR(5,iGrid,Ind_z2)=dRho_dR(5,iGrid,Ind_z2)
     &                                   +z2_t *DAij_
                  dRho_dR(6,iGrid,Ind_z2)=dRho_dR(6,iGrid,Ind_z2)
     &                                   +z2_r *DAij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
      Return
      End
      Subroutine Do_Rho9d_(dRho_dR,     mGrid,nGrad_Eff,
     &                     DAij,DBij,     mAO,
     &                     TabAO1,iBas,iBas_Eff,iCmp,
     &                     TabAO2,jBas,jBas_Eff,jCmp,
     &                     Fact,IndGrd_Eff,T_X,TMax_ij,
     &                     Index_i,Index_j)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 dRho_dR(  12,mGrid,nGrad_Eff),
     &       DAij(iBas*iCmp,jBas*jCmp), DBij(iBas*iCmp,jBas*jCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp),
     &       TabAO2(mAO,mGrid,jBas_Eff*jCmp)
      Integer IndGrd_Eff(3,2), Index_i(iBas_Eff*iCmp),
     &                         Index_j(jBas_Eff*jCmp)
*                                                                      *
************************************************************************
*                                                                      *
*     Rather than to use integers directly we set up a symbolic way of
*     doing the indexation.
*
      Integer F,
     &        dx, dy, dz,
     &        dx2, dxdy, dxdz, dy2, dydz, dz2,
     &             dydx, dzdx,      dzdy,
     &        dx3, dx2dy, dx2dz, dxdy2, dxdydz,
     &             dydx2, dzdx2, dy2dx, dxdzdy,
     &                                  dydxdz,
     &                                  dydzdx,
     &                                  dzdxdy,
     &                                  dzdydz,
     &        dxdz2, dy3, dy2dz, dydz2, dz3,
     &        dz2dx,      dzdy2, dz2dy
      Parameter(F=1,
     &          dx=2, dy=3, dz=4,
     &          dx2=5, dxdy=6, dxdz=7, dy2=8, dydz=9,
     &                 dydx=6, dzdx=7,        dzdy=9,
     &          dz2=10,
     &  dx3=11, dx2dy=12, dx2dz=13, dxdy2=14, dxdydz=15,
     &          dydx2=12, dzdx2=13, dy2dx=14, dxdzdy=15,
     &                                        dydxdz=15,
     &                                        dydzdx=15,
     &                                        dzdxdy=15,
     &                                        dzdydz=15,
     &     dxdz2=16, dy3=17, dy2dz=18, dydz2=19, dz3=20,
     &     dz2dx=16,         dzdy2=18, dz2dy=19
     &         )
*                                                                      *
************************************************************************
*                                                                      *
      Do jCB_Eff = 1, jBas_Eff*jCmp
         jCB = Index_j(jCB_Eff)
*
         Do iCB_Eff = 1, iBas_Eff*iCmp
            iCB = Index_i(iCB_Eff)
*
            DAij_=DAij(iCB,jCB)*Fact
            DBij_=DBij(iCB,jCB)*Fact
            Dij_ =Half*(Abs(DAij_)+Abs(DBij_))
            If (TMax_ij*Abs(Dij_).lt.T_X) Go To 99
*                                                                      *
************************************************************************
*                                                                      *
*---------- x component
*
            Ind_x1=IndGrd_Eff(1,1)
            Ind_x2=IndGrd_Eff(1,2)
            If (Ind_x1.ne.0.and.Ind_x2.ne.0) Then
               Do iGrid = 1, mGrid
                  x1   =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
                  x1_x =TabAO1(dx2  ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x1_y =TabAO1(dxdy ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  x1_z =TabAO1(dxdz ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  x1_t =TabAO1(dx2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dxdy ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dxdz ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  x1_r=(TabAO1(dx3  ,iGrid,iCB_Eff)
     &                 +TabAO1(dxdy2,iGrid,iCB_Eff)
     &                 +TabAO1(dxdz2,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +x1_t
                  x2   =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_x =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_y =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_z =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx2  ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)*Two
                  x2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx3  ,iGrid,jCB_Eff)
     &                 +TabAO2(dxdy2,iGrid,jCB_Eff)
     &                 +TabAO2(dxdz2,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
     &                 +x2_t
                  dRho_dR(1,iGrid,Ind_x1)=dRho_dR(1,iGrid,Ind_x1)
     &                              +x1   *DAij_
                  dRho_dR(2,iGrid,Ind_x1)=dRho_dR(2,iGrid,Ind_x1)
     &                              +x1   *DBij_
                  dRho_dR(3,iGrid,Ind_x1)=dRho_dR(3,iGrid,Ind_x1)
     &                              +x1_x *DAij_
                  dRho_dR(4,iGrid,Ind_x1)=dRho_dR(4,iGrid,Ind_x1)
     &                              +x1_y *DAij_
                  dRho_dR(5,iGrid,Ind_x1)=dRho_dR(5,iGrid,Ind_x1)
     &                              +x1_z *DAij_
                  dRho_dR(6,iGrid,Ind_x1)=dRho_dR(6,iGrid,Ind_x1)
     &                              +x1_x *DBij_
                  dRho_dR(7,iGrid,Ind_x1)=dRho_dR(7,iGrid,Ind_x1)
     &                              +x1_y *DBij_
                  dRho_dR(8,iGrid,Ind_x1)=dRho_dR(8,iGrid,Ind_x1)
     &                              +x1_z *DBij_
                  dRho_dR(9,iGrid,Ind_x1)=dRho_dR(9,iGrid,Ind_x1)
     &                              +x1_t *DAij_
                  dRho_dR(10,iGrid,Ind_x1)=dRho_dR(10,iGrid,Ind_x1)
     &                              +x1_t *DBij_
                  dRho_dR(11,iGrid,Ind_x1)=dRho_dR(11,iGrid,Ind_x1)
     &                              +x1_r *DAij_
                  dRho_dR(12,iGrid,Ind_x1)=dRho_dR(12,iGrid,Ind_x1)
     &                              +x1_r *DBij_
                  dRho_dR(1,iGrid,Ind_x2)=dRho_dR(1,iGrid,Ind_x2)
     &                              +x2   *DAij_
                  dRho_dR(2,iGrid,Ind_x2)=dRho_dR(2,iGrid,Ind_x2)
     &                              +x2   *DBij_
                  dRho_dR(3,iGrid,Ind_x2)=dRho_dR(3,iGrid,Ind_x2)
     &                              +x2_x *DAij_
                  dRho_dR(4,iGrid,Ind_x2)=dRho_dR(4,iGrid,Ind_x2)
     &                              +x2_y *DAij_
                  dRho_dR(5,iGrid,Ind_x2)=dRho_dR(5,iGrid,Ind_x2)
     &                              +x2_z *DAij_
                  dRho_dR(6,iGrid,Ind_x2)=dRho_dR(6,iGrid,Ind_x2)
     &                              +x2_x *DBij_
                  dRho_dR(7,iGrid,Ind_x2)=dRho_dR(7,iGrid,Ind_x2)
     &                              +x2_y *DBij_
                  dRho_dR(8,iGrid,Ind_x2)=dRho_dR(8,iGrid,Ind_x2)
     &                              +x2_z *DBij_
                  dRho_dR(9,iGrid,Ind_x2)=dRho_dR(9,iGrid,Ind_x2)
     &                              +x2_t *DAij_
                  dRho_dR(10,iGrid,Ind_x2)=dRho_dR(10,iGrid,Ind_x2)
     &                              +x2_t *DBij_
                  dRho_dR(11,iGrid,Ind_x2)=dRho_dR(11,iGrid,Ind_x2)
     &                              +x2_r *DAij_
                  dRho_dR(12,iGrid,Ind_x2)=dRho_dR(12,iGrid,Ind_x2)
     &                              +x2_r *DBij_
               End Do ! iGrid
            Else If (Ind_x1.ne.0) Then
               Do iGrid = 1, mGrid
                  x1   =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
                  x1_x =TabAO1(dx2  ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x1_y =TabAO1(dxdy ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  x1_z =TabAO1(dxdz ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  x1_t =TabAO1(dx2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dxdy ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dxdz ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  x1_r=(TabAO1(dx3  ,iGrid,iCB_Eff)
     &                 +TabAO1(dxdy2,iGrid,iCB_Eff)
     &                 +TabAO1(dxdz2,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +x1_t
                  dRho_dR(1,iGrid,Ind_x1)=dRho_dR(1,iGrid,Ind_x1)
     &                              +x1   *DAij_
                  dRho_dR(2,iGrid,Ind_x1)=dRho_dR(2,iGrid,Ind_x1)
     &                              +x1   *DBij_
                  dRho_dR(3,iGrid,Ind_x1)=dRho_dR(3,iGrid,Ind_x1)
     &                              +x1_x *DAij_
                  dRho_dR(4,iGrid,Ind_x1)=dRho_dR(4,iGrid,Ind_x1)
     &                              +x1_y *DAij_
                  dRho_dR(5,iGrid,Ind_x1)=dRho_dR(5,iGrid,Ind_x1)
     &                              +x1_z *DAij_
                  dRho_dR(6,iGrid,Ind_x1)=dRho_dR(6,iGrid,Ind_x1)
     &                              +x1_x *DBij_
                  dRho_dR(7,iGrid,Ind_x1)=dRho_dR(7,iGrid,Ind_x1)
     &                              +x1_y *DBij_
                  dRho_dR(8,iGrid,Ind_x1)=dRho_dR(8,iGrid,Ind_x1)
     &                              +x1_z *DBij_
                  dRho_dR(9,iGrid,Ind_x1)=dRho_dR(9,iGrid,Ind_x1)
     &                              +x1_t *DAij_
                  dRho_dR(10,iGrid,Ind_x1)=dRho_dR(10,iGrid,Ind_x1)
     &                              +x1_t *DBij_
                  dRho_dR(11,iGrid,Ind_x1)=dRho_dR(11,iGrid,Ind_x1)
     &                              +x1_r *DAij_
                  dRho_dR(12,iGrid,Ind_x1)=dRho_dR(12,iGrid,Ind_x1)
     &                              +x1_r *DBij_
               End Do ! iGrid
            Else If (Ind_x2.ne.0) Then
               Do iGrid = 1, mGrid
                  x2   =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_x =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_y =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_z =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  x2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx2  ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)*Two
                  x2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx3  ,iGrid,jCB_Eff)
     &                 +TabAO2(dxdy2,iGrid,jCB_Eff)
     &                 +TabAO2(dxdz2,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
     &                 +x2_t
                  dRho_dR(1,iGrid,Ind_x2)=dRho_dR(1,iGrid,Ind_x2)
     &                              +x2   *DAij_
                  dRho_dR(2,iGrid,Ind_x2)=dRho_dR(2,iGrid,Ind_x2)
     &                              +x2   *DBij_
                  dRho_dR(3,iGrid,Ind_x2)=dRho_dR(3,iGrid,Ind_x2)
     &                              +x2_x *DAij_
                  dRho_dR(4,iGrid,Ind_x2)=dRho_dR(4,iGrid,Ind_x2)
     &                              +x2_y *DAij_
                  dRho_dR(5,iGrid,Ind_x2)=dRho_dR(5,iGrid,Ind_x2)
     &                              +x2_z *DAij_
                  dRho_dR(6,iGrid,Ind_x2)=dRho_dR(6,iGrid,Ind_x2)
     &                              +x2_x *DBij_
                  dRho_dR(7,iGrid,Ind_x2)=dRho_dR(7,iGrid,Ind_x2)
     &                              +x2_y *DBij_
                  dRho_dR(8,iGrid,Ind_x2)=dRho_dR(8,iGrid,Ind_x2)
     &                              +x2_z *DBij_
                  dRho_dR(9,iGrid,Ind_x2)=dRho_dR(9,iGrid,Ind_x2)
     &                              +x2_t *DAij_
                  dRho_dR(10,iGrid,Ind_x2)=dRho_dR(10,iGrid,Ind_x2)
     &                              +x2_t *DBij_
                  dRho_dR(11,iGrid,Ind_x2)=dRho_dR(11,iGrid,Ind_x2)
     &                              +x2_r *DAij_
                  dRho_dR(12,iGrid,Ind_x2)=dRho_dR(12,iGrid,Ind_x2)
     &                              +x2_r *DBij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*---------- y component
*
            Ind_y1=IndGrd_Eff(2,1)
            Ind_y2=IndGrd_Eff(2,2)
            If (Ind_y1.ne.0.and.Ind_y2.ne.0) Then
               Do iGrid = 1, mGrid
                  y1   =TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
                  y1_x =TabAO1(dydx ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  y1_y =TabAO1(dy2  ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y1_z =TabAO1(dydz ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  y1_t =TabAO1(dydx ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dydz ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  y1_r=(TabAO1(dx2dy,iGrid,iCB_Eff)
     &                 +TabAO1(dy3  ,iGrid,iCB_Eff)
     &                 +TabAO1(dydz2,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +y1_t
                  y2   =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_x =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dydx ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_y =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_z =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy2  ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)*Two
                  y2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2dy,iGrid,jCB_Eff)
     &                 +TabAO2(dy3  ,iGrid,jCB_Eff)
     &                 +TabAO2(dydz2,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
     &                 +y2_t
                  dRho_dR(1,iGrid,Ind_y1)=dRho_dR(1,iGrid,Ind_y1)
     &                              +y1   *DAij_
                  dRho_dR(2,iGrid,Ind_y1)=dRho_dR(2,iGrid,Ind_y1)
     &                              +y1   *DBij_
                  dRho_dR(3,iGrid,Ind_y1)=dRho_dR(3,iGrid,Ind_y1)
     &                              +y1_x *DAij_
                  dRho_dR(4,iGrid,Ind_y1)=dRho_dR(4,iGrid,Ind_y1)
     &                              +y1_y *DAij_
                  dRho_dR(5,iGrid,Ind_y1)=dRho_dR(5,iGrid,Ind_y1)
     &                              +y1_z *DAij_
                  dRho_dR(6,iGrid,Ind_y1)=dRho_dR(6,iGrid,Ind_y1)
     &                              +y1_x *DBij_
                  dRho_dR(7,iGrid,Ind_y1)=dRho_dR(7,iGrid,Ind_y1)
     &                              +y1_y *DBij_
                  dRho_dR(8,iGrid,Ind_y1)=dRho_dR(8,iGrid,Ind_y1)
     &                              +y1_z *DBij_
                  dRho_dR(9,iGrid,Ind_y1)=dRho_dR(9,iGrid,Ind_y1)
     &                              +y1_t *DAij_
                  dRho_dR(10,iGrid,Ind_y1)=dRho_dR(10,iGrid,Ind_y1)
     &                              +y1_t *DBij_
                  dRho_dR(11,iGrid,Ind_y1)=dRho_dR(11,iGrid,Ind_y1)
     &                              +y1_r *DAij_
                  dRho_dR(12,iGrid,Ind_y1)=dRho_dR(12,iGrid,Ind_y1)
     &                              +y1_r *DBij_
                  dRho_dR(1,iGrid,Ind_y2)=dRho_dR(1,iGrid,Ind_y2)
     &                              +y2   *DAij_
                  dRho_dR(2,iGrid,Ind_y2)=dRho_dR(2,iGrid,Ind_y2)
     &                              +y2   *DBij_
                  dRho_dR(3,iGrid,Ind_y2)=dRho_dR(3,iGrid,Ind_y2)
     &                              +y2_x *DAij_
                  dRho_dR(4,iGrid,Ind_y2)=dRho_dR(4,iGrid,Ind_y2)
     &                              +y2_y *DAij_
                  dRho_dR(5,iGrid,Ind_y2)=dRho_dR(5,iGrid,Ind_y2)
     &                              +y2_z *DAij_
                  dRho_dR(6,iGrid,Ind_y2)=dRho_dR(6,iGrid,Ind_y2)
     &                              +y2_x *DBij_
                  dRho_dR(7,iGrid,Ind_y2)=dRho_dR(7,iGrid,Ind_y2)
     &                              +y2_y *DBij_
                  dRho_dR(8,iGrid,Ind_y2)=dRho_dR(8,iGrid,Ind_y2)
     &                              +y2_z *DBij_
                  dRho_dR(9,iGrid,Ind_y2)=dRho_dR(9,iGrid,Ind_y2)
     &                              +y2_t *DAij_
                  dRho_dR(10,iGrid,Ind_y2)=dRho_dR(10,iGrid,Ind_y2)
     &                              +y2_t *DBij_
                  dRho_dR(11,iGrid,Ind_y2)=dRho_dR(11,iGrid,Ind_y2)
     &                              +y2_r *DAij_
                  dRho_dR(12,iGrid,Ind_y2)=dRho_dR(12,iGrid,Ind_y2)
     &                              +y2_r *DBij_
               End Do ! iGrid
            Else If (Ind_y1.ne.0) Then
               Do iGrid = 1, mGrid
                  y1   =TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
                  y1_x =TabAO1(dydx ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  y1_y =TabAO1(dy2  ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y1_z =TabAO1(dydz ,iGrid,iCB_Eff)*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  y1_t =TabAO1(dydx ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dydz ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  y1_r=(TabAO1(dx2dy,iGrid,iCB_Eff)
     &                 +TabAO1(dy3  ,iGrid,iCB_Eff)
     &                 +TabAO1(dydz2,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +y1_t
                  dRho_dR(1,iGrid,Ind_y1)=dRho_dR(1,iGrid,Ind_y1)
     &                              +y1   *DAij_
                  dRho_dR(2,iGrid,Ind_y1)=dRho_dR(2,iGrid,Ind_y1)
     &                              +y1   *DBij_
                  dRho_dR(3,iGrid,Ind_y1)=dRho_dR(3,iGrid,Ind_y1)
     &                              +y1_x *DAij_
                  dRho_dR(4,iGrid,Ind_y1)=dRho_dR(4,iGrid,Ind_y1)
     &                              +y1_y *DAij_
                  dRho_dR(5,iGrid,Ind_y1)=dRho_dR(5,iGrid,Ind_y1)
     &                              +y1_z *DAij_
                  dRho_dR(6,iGrid,Ind_y1)=dRho_dR(6,iGrid,Ind_y1)
     &                              +y1_x *DBij_
                  dRho_dR(7,iGrid,Ind_y1)=dRho_dR(7,iGrid,Ind_y1)
     &                              +y1_y *DBij_
                  dRho_dR(8,iGrid,Ind_y1)=dRho_dR(8,iGrid,Ind_y1)
     &                              +y1_z *DBij_
                  dRho_dR(9,iGrid,Ind_y1)=dRho_dR(9,iGrid,Ind_y1)
     &                              +y1_t *DAij_
                  dRho_dR(10,iGrid,Ind_y1)=dRho_dR(10,iGrid,Ind_y1)
     &                              +y1_t *DBij_
                  dRho_dR(11,iGrid,Ind_y1)=dRho_dR(11,iGrid,Ind_y1)
     &                              +y1_r *DAij_
                  dRho_dR(12,iGrid,Ind_y1)=dRho_dR(12,iGrid,Ind_y1)
     &                              +y1_r *DBij_
               End Do ! iGrid
            Else If (Ind_y2.ne.0) Then
               Do iGrid = 1, mGrid
                  y2   =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_x =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dydx ,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_y =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_z =TabAO1(F    ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  y2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdy ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy2  ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)*Two
                  y2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2dy,iGrid,jCB_Eff)
     &                 +TabAO2(dy3  ,iGrid,jCB_Eff)
     &                 +TabAO2(dydz2,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
     &                 +y2_t
                  dRho_dR(1,iGrid,Ind_y2)=dRho_dR(1,iGrid,Ind_y2)
     &                              +y2   *DAij_
                  dRho_dR(2,iGrid,Ind_y2)=dRho_dR(2,iGrid,Ind_y2)
     &                              +y2   *DBij_
                  dRho_dR(3,iGrid,Ind_y2)=dRho_dR(3,iGrid,Ind_y2)
     &                              +y2_x *DAij_
                  dRho_dR(4,iGrid,Ind_y2)=dRho_dR(4,iGrid,Ind_y2)
     &                              +y2_y *DAij_
                  dRho_dR(5,iGrid,Ind_y2)=dRho_dR(5,iGrid,Ind_y2)
     &                              +y2_z *DAij_
                  dRho_dR(6,iGrid,Ind_y2)=dRho_dR(6,iGrid,Ind_y2)
     &                              +y2_x *DBij_
                  dRho_dR(7,iGrid,Ind_y2)=dRho_dR(7,iGrid,Ind_y2)
     &                              +y2_y *DBij_
                  dRho_dR(8,iGrid,Ind_y2)=dRho_dR(8,iGrid,Ind_y2)
     &                              +y2_z *DBij_
                  dRho_dR(9,iGrid,Ind_y2)=dRho_dR(9,iGrid,Ind_y2)
     &                              +y2_t *DAij_
                  dRho_dR(10,iGrid,Ind_y2)=dRho_dR(10,iGrid,Ind_y2)
     &                              +y2_t *DBij_
                  dRho_dR(11,iGrid,Ind_y2)=dRho_dR(11,iGrid,Ind_y2)
     &                              +y2_r *DAij_
                  dRho_dR(12,iGrid,Ind_y2)=dRho_dR(12,iGrid,Ind_y2)
     &                              +y2_r *DBij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*---------- z component
*
            Ind_z1=IndGrd_Eff(3,1)
            Ind_z2=IndGrd_Eff(3,2)
            If (Ind_z1.ne.0.and.Ind_z2.ne.0) Then
               Do iGrid = 1, mGrid
                  z1   =TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
                  z1_x =TabAO1(dzdx,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  z1_y =TabAO1(dzdy,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  z1_z =TabAO1(dz2 ,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z1_t =TabAO1(dzdx ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dzdy ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  z1_r=(TabAO1(dx2dz,iGrid,iCB_Eff)
     &                 +TabAO1(dy2dz,iGrid,iCB_Eff)
     &                 +TabAO1(dz3  ,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +z1_t
                  z2   =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_x =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dzdx,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_y =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dzdy,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_z =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2 ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_z =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2 ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2  ,iGrid,jCB_Eff)*Two
                  z2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2dz,iGrid,jCB_Eff)
     &                 +TabAO2(dy2dz,iGrid,jCB_Eff)
     &                 +TabAO2(dz3  ,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
     &                 +z2_t
                  dRho_dR(1,iGrid,Ind_z1)=dRho_dR(1,iGrid,Ind_z1)
     &                              +z1   *DAij_
                  dRho_dR(2,iGrid,Ind_z1)=dRho_dR(2,iGrid,Ind_z1)
     &                              +z1   *DBij_
                  dRho_dR(3,iGrid,Ind_z1)=dRho_dR(3,iGrid,Ind_z1)
     &                              +z1_x *DAij_
                  dRho_dR(4,iGrid,Ind_z1)=dRho_dR(4,iGrid,Ind_z1)
     &                              +z1_y *DAij_
                  dRho_dR(5,iGrid,Ind_z1)=dRho_dR(5,iGrid,Ind_z1)
     &                              +z1_z *DAij_
                  dRho_dR(6,iGrid,Ind_z1)=dRho_dR(6,iGrid,Ind_z1)
     &                              +z1_x *DBij_
                  dRho_dR(7,iGrid,Ind_z1)=dRho_dR(7,iGrid,Ind_z1)
     &                              +z1_y *DBij_
                  dRho_dR(8,iGrid,Ind_z1)=dRho_dR(8,iGrid,Ind_z1)
     &                              +z1_z *DBij_
                  dRho_dR(9,iGrid,Ind_z1)=dRho_dR(9,iGrid,Ind_z1)
     &                              +z1_t *DBij_
                  dRho_dR(10,iGrid,Ind_z1)=dRho_dR(10,iGrid,Ind_z1)
     &                              +z1_t *DBij_
                  dRho_dR(11,iGrid,Ind_z1)=dRho_dR(11,iGrid,Ind_z1)
     &                              +z1_r *DAij_
                  dRho_dR(12,iGrid,Ind_z1)=dRho_dR(12,iGrid,Ind_z1)
     &                              +z1_r *DBij_
                  dRho_dR(1,iGrid,Ind_z2)=dRho_dR(1,iGrid,Ind_z2)
     &                              +z2   *DAij_
                  dRho_dR(2,iGrid,Ind_z2)=dRho_dR(2,iGrid,Ind_z2)
     &                              +z2   *DBij_
                  dRho_dR(3,iGrid,Ind_z2)=dRho_dR(3,iGrid,Ind_z2)
     &                              +z2_x *DAij_
                  dRho_dR(4,iGrid,Ind_z2)=dRho_dR(4,iGrid,Ind_z2)
     &                              +z2_y *DAij_
                  dRho_dR(5,iGrid,Ind_z2)=dRho_dR(5,iGrid,Ind_z2)
     &                              +z2_z *DAij_
                  dRho_dR(6,iGrid,Ind_z2)=dRho_dR(6,iGrid,Ind_z2)
     &                              +z2_x *DBij_
                  dRho_dR(7,iGrid,Ind_z2)=dRho_dR(7,iGrid,Ind_z2)
     &                              +z2_y *DBij_
                  dRho_dR(8,iGrid,Ind_z2)=dRho_dR(8,iGrid,Ind_z2)
     &                              +z2_z *DBij_
                  dRho_dR(9,iGrid,Ind_z2)=dRho_dR(9,iGrid,Ind_z2)
     &                              +z2_t *DAij_
                  dRho_dR(10,iGrid,Ind_z2)=dRho_dR(10,iGrid,Ind_z2)
     &                              +z2_t *DBij_
                  dRho_dR(11,iGrid,Ind_z2)=dRho_dR(11,iGrid,Ind_z2)
     &                              +z2_r *DAij_
                  dRho_dR(12,iGrid,Ind_z2)=dRho_dR(12,iGrid,Ind_z2)
     &                              +z2_r *DBij_
               End Do ! iGrid
            Else If (Ind_z1.ne.0) Then
               Do iGrid = 1, mGrid
                  z1   =TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
                  z1_x =TabAO1(dzdx,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)
                  z1_y =TabAO1(dzdy,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)
                  z1_z =TabAO1(dz2 ,iGrid,iCB_Eff)*
     &                  TabAO2(F      ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z1_t =TabAO1(dzdx ,iGrid,iCB_Eff)*
     &                  TabAO2(dx   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dzdy ,iGrid,iCB_Eff)*
     &                  TabAO2(dy   ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)*Two
                  z1_r=(TabAO1(dx2dz,iGrid,iCB_Eff)
     &                 +TabAO1(dy2dz,iGrid,iCB_Eff)
     &                 +TabAO1(dz3  ,iGrid,iCB_Eff))*
     &                  TabAO2(F    ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dy2  ,iGrid,jCB_Eff)
     &                 +TabAO2(dz2  ,iGrid,jCB_Eff))
     &                 +z1_t
                  dRho_dR(1,iGrid,Ind_z1)=dRho_dR(1,iGrid,Ind_z1)
     &                              +z1   *DAij_
                  dRho_dR(2,iGrid,Ind_z1)=dRho_dR(2,iGrid,Ind_z1)
     &                              +z1   *DBij_
                  dRho_dR(3,iGrid,Ind_z1)=dRho_dR(3,iGrid,Ind_z1)
     &                              +z1_x *DAij_
                  dRho_dR(4,iGrid,Ind_z1)=dRho_dR(4,iGrid,Ind_z1)
     &                              +z1_y *DAij_
                  dRho_dR(5,iGrid,Ind_z1)=dRho_dR(5,iGrid,Ind_z1)
     &                              +z1_z *DAij_
                  dRho_dR(6,iGrid,Ind_z1)=dRho_dR(6,iGrid,Ind_z1)
     &                              +z1_x *DBij_
                  dRho_dR(7,iGrid,Ind_z1)=dRho_dR(7,iGrid,Ind_z1)
     &                              +z1_y *DBij_
                  dRho_dR(8,iGrid,Ind_z1)=dRho_dR(8,iGrid,Ind_z1)
     &                              +z1_z *DBij_
                  dRho_dR(9,iGrid,Ind_z1)=dRho_dR(9,iGrid,Ind_z1)
     &                              +z1_t *DBij_
                  dRho_dR(10,iGrid,Ind_z1)=dRho_dR(10,iGrid,Ind_z1)
     &                              +z1_t *DBij_
                  dRho_dR(11,iGrid,Ind_z1)=dRho_dR(11,iGrid,Ind_z1)
     &                              +z1_r *DAij_
                  dRho_dR(12,iGrid,Ind_z1)=dRho_dR(12,iGrid,Ind_z1)
     &                              +z1_r *DBij_
               End Do ! iGrid
            Else If (Ind_z2.ne.0) Then
               Do iGrid = 1, mGrid
                  z2   =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_x =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dzdx,iGrid,jCB_Eff)
     &                 +TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_y =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dzdy,iGrid,jCB_Eff)
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_z =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2 ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_z =TabAO1(F      ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2 ,iGrid,jCB_Eff)
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
                  z2_t =TabAO1(dx   ,iGrid,iCB_Eff)*
     &                  TabAO2(dxdz ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dy   ,iGrid,iCB_Eff)*
     &                  TabAO2(dydz ,iGrid,jCB_Eff)*Two
     &                 +TabAO1(dz   ,iGrid,iCB_Eff)*
     &                  TabAO2(dz2  ,iGrid,jCB_Eff)*Two
                  z2_r =TabAO1(F    ,iGrid,iCB_Eff)*
     &                 (TabAO2(dx2dz,iGrid,jCB_Eff)
     &                 +TabAO2(dy2dz,iGrid,jCB_Eff)
     &                 +TabAO2(dz3  ,iGrid,jCB_Eff))
     &                +(TabAO1(dx2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dy2  ,iGrid,iCB_Eff)
     &                 +TabAO1(dz2  ,iGrid,iCB_Eff))*
     &                  TabAO2(dz   ,iGrid,jCB_Eff)
     &                 +z2_t
                  dRho_dR(1,iGrid,Ind_z2)=dRho_dR(1,iGrid,Ind_z2)
     &                              +z2   *DAij_
                  dRho_dR(2,iGrid,Ind_z2)=dRho_dR(2,iGrid,Ind_z2)
     &                              +z2   *DBij_
                  dRho_dR(3,iGrid,Ind_z2)=dRho_dR(3,iGrid,Ind_z2)
     &                              +z2_x *DAij_
                  dRho_dR(4,iGrid,Ind_z2)=dRho_dR(4,iGrid,Ind_z2)
     &                              +z2_y *DAij_
                  dRho_dR(5,iGrid,Ind_z2)=dRho_dR(5,iGrid,Ind_z2)
     &                              +z2_z *DAij_
                  dRho_dR(6,iGrid,Ind_z2)=dRho_dR(6,iGrid,Ind_z2)
     &                              +z2_x *DBij_
                  dRho_dR(7,iGrid,Ind_z2)=dRho_dR(7,iGrid,Ind_z2)
     &                              +z2_y *DBij_
                  dRho_dR(8,iGrid,Ind_z2)=dRho_dR(8,iGrid,Ind_z2)
     &                              +z2_z *DBij_
                  dRho_dR(9,iGrid,Ind_z2)=dRho_dR(9,iGrid,Ind_z2)
     &                              +z2_t *DAij_
                  dRho_dR(10,iGrid,Ind_z2)=dRho_dR(10,iGrid,Ind_z2)
     &                              +z2_t *DBij_
                  dRho_dR(11,iGrid,Ind_z2)=dRho_dR(11,iGrid,Ind_z2)
     &                              +z2_r *DAij_
                  dRho_dR(12,iGrid,Ind_z2)=dRho_dR(12,iGrid,Ind_z2)
     &                              +z2_r *DBij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
*-- Subroutine with purpose to initialize and set defaults for the
*   input section.
*
      Subroutine Qmstat_Init
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"

*IO_stuff
      StFilIn='STFIL0'
      SAFilIn='SAFIL0'
      StFilUt='STFIL0'
      SAFilUt='SAFIL0'
      BlockIn='BLOCIN'
      BlockUt='BLOCUT'
      SimEx='EXTRA0'
*--Jose: File for the optimization procedure
      FieldNuc='AVENUC'
*--------
      Do 101, i=1,MxJobs
        Write(JbName(i),'(A,i3.3)')'JOB',i
101   Continue
      RassiM='RASSIM'
      GammaO='GAMORB'
      EigV='EIGV'
      AddOns(1)='ADDON1'
      AddOns(2)='ADDON2'
      AddOns(3)='ADDON3'
      iNrIn=-1
      iNrUt=0
      iLuStIn=8+iNrIn
      iLuStUt=16+iNrUt
      iLuSaIn=24+iNrIn
      iLuSaUt=32+iNrUt
      iLuBlockIn=3
      iLuBlockUt=4
      iRead=0
*Defaults
      nEqState=1
      Cut_Ex1=10.0d0
      Cut_Ex2=0.0d0
      DelX = 0.00d0
      DelFi = 0.0d0
      DelR = 0.00d0
      Temp = 300.0d0
      ISEED = 791204
      IPrint = 1
      NMACRO = 1
      NMICRO = 1
      RSTART = 80.0d0
      NPART = 0
      nAtom=3
      NCENT = 5
      NPOL = 3
      NCHA = 4
*Jose.Slater Penetration
      nSlSiteC=5
      lMltSlC=0
*****
      nLvlShift=0
      Do 119, i=1,MxAt
        iExtr_Atm(i)=-1
119   Continue
      QSTA(1) = 0.5836d0
      QSTA(2) = 0.5836d0
      QSTA(3) =-0.5836d0
      QSTA(4) =-0.5836d0
      POL(1) = 5.932d0
      POL(2) = 0.641d0
      POL(3) = 0.641d0
*Jose.Slater Penetration
      Cut_Elc=6.0d0
      DifSlExp=0.001d0

      SlFactC(1,1)=-0.50d0
      SlFactC(1,2)=-0.4164d0
      SlFactC(1,3)=-0.4164d0
      SlFactC(1,4)=-0.5836d0
      SlFactC(1,5)=-0.5836d0
      Do 217, i=1,5
        Do 218, j=2,4
          SlFactC(j,i)=0.0d0
218     Continue
217   Continue
      SlExpC(1,1)=2.5552d0
      SlExpC(1,2)=2.6085d0
      SlExpC(1,3)=2.6085d0
      SlExpC(1,4)=2.5552d0
      SlExpC(1,5)=2.5552d0
      Do 219, i=1,5
        SlExpC(2,i)=0.00d0
219   Continue
      SlPC(1)=0.5d0
      SlPC(2)=1.0d0
      SlPC(3)=1.0d0
      SlPC(4)=0.0d0
      SlPC(5)=0.0d0
*******************************
      sExRep(1,1) = 2.092338000000000000d0
      sExRe1(1,1) = 158.998000000000000d0
      sExRe2(1,1) = 4.660090000000000d10
      sExRep(2,1) = 2.112447000000000000d0
      sExRe1(2,1) = 8.31922000000000000d0
      sExRe2(2,1) = 97560.62000000000000d0
      sExRep(2,2) = 1.075803000000000000d0
      sExRe1(2,2) = 0.06521000000000000d0
      sExRe2(2,2) = 1121941276d0
      sExRep(3,1) = 2.112447000000000000d0
      sExRe1(3,1) = 8.31922000000000000d0
      sExRe2(3,1) = 97560.62000000000000d0
      sExRep(3,2) = 1.075803000000000000d0
      sExRe1(3,2) = 0.06521000000000000d0
      sExRe2(3,2) = 1121941276d0
      sExRep(3,3) = 1.075803000000000000d0
      sExRe1(3,3) = 0.06521000000000000d0
      sExRe2(3,3) = 1121941276d0
      Disp(1,1) = 11.3380000000000000d0
      Disp(2,1) = 3.38283000000000000d0
      Disp(2,2) = 0.627068000000000000d0
      Disp(3,1) = 3.38283000000000000d0
      Disp(3,2) = 0.627068000000000000d0
      Disp(3,3) = 0.627068000000000000d0
      DO 10, I=1,NPOL
        DO 20, J=1,I
          DISP(J,I)=DISP(I,J)
          SEXREP(J,I)=SEXREP(I,J)
          SEXRE1(J,I)=SEXRE1(I,J)
          SEXRE2(J,I)=SEXRE2(I,J)
20      Continue
10    Continue
      CORDST(1,1) = 0.0d0
      CORDST(2,1) = 0.0d0
      CORDST(3,1) = 0.0d0
      CORDST(4,1) = 0.3126d0
      CORDST(5,1) = -0.3126d0
      CORDST(1,2) = 0.0d0
      CORDST(2,2) = 1.43d0
      CORDST(3,2) = -1.43d0
      CORDST(4,2) = 0.0d0
      CORDST(5,2) = 0.0d0
      CORDST(1,3) = 0.3d0
      CORDST(2,3) = -0.807d0
      CORDST(3,3) = -0.807d0
      CORDST(4,3) = -0.1191d0
      CORDST(5,3) = -0.1191d0
      ForceK = 0.001d0
      dLJrep=0.0d0
      Pres = 1.0d0
      PolLim = 0.0001d0
      EneLim = 0.0000001d0
      itMax=30
      Exdtal = 30.0d0
      Exdt1 = 0.060d0
      Surf = 30.0d0
      iOrb(2)=5
      iOcc2=5
      Diel = 80.0d0
      iExtra = 0
      Smeq=.false.
      Qmeq=.false.
      Fielddamp=.false.
      Dispdamp=.false.
      Smprod=.false.
      QmProd=.false.
      ChargedQM=.false.
      ATitle=.false.
      Anal=.false.
      ParallelT=.false.
      Mp2DensCorr=.false.
      MoAveRed=.false.
      lCiSelect=.false.
      EdSt=.false.
*JoseMEP***** The dimension was increased from 8 to 12
      Do 41, i=1,12
        DelOrAdd(i)=.false.
        lExtr(i)=.false.
        lAnal(i)=.false.
41    Continue
      lSlater=.true.
      lQuad=.false.


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1988, H. Rieger                                        *
!***********************************************************************
!**********************************************************************
!
!        PROGRAMMBIBLIOTHEK RHRZ BONN        23/11/88       DCOPIV
!                                            FORTRAN 77     IBM 3081
!
!
! NAME:    DCOPIV
!
! PURPOSE:
!
! This program calculates the solution of the system of linear
! equations  A*X = B  for several right-hand sides. The method used is
! complete pivoting which is generally considered a stable method,
! even if the matrix A is ill-conditioned.
! A is decomposed into the product of a lower triangular matrx L
! with main diagonal elements equal to 1 and an upper triangular
! matrix U such that:  L*U = A. While L is not saved, U is over-
! written on A.
! If the matrix A is nonsingular, the solutions are stored in B.
!
! USAGE:   CALL DCOPIV(A,B,N,M,D,EPS,DET,EX,CTR,S)
!
! PARAMETERS:
!
! N,M:     INTEGER, are the order of the matrix A (N) and the
!          number of right-hand sides (M).
!
! D:       INTEGER, is the actual dimension of the arrays as they
!          are declared in the main program. D >= N is necessary.
!
! A:       REAL*8, declared as DIMENSION A(1:D,1:N), is the coefficient
!          matrix. On return it will be over-written by U.
!
! B:       REAL*8, declared as DIMENSION B(1:D,1:M), contains the right
!          hand sides (columnwise). On return each column occupies the
!          corresponding solution.
!
! EPS:     REAL*8, is the tolerance: if a pivotal element is
!          (absolutely) smaller than EPS, matrix A is considered
!          to be singular.
!
! DET:     REAL*8, will contain the determinant (DET = 0 is set,
!          if A is singular). It is scaled such that
!          1.0e-10 <= ABS(DET) <= 1.0e10 .
!
! EX:      INTEGER, is the scale factor for DET. The determinant
!          of A can be obtained from  DET*10**EX .
!
! CTR:     INTEGER, is a control variable with the following
!          meaning on input:
!          CTR < 0: evaluation of just the determinant. Parameter
!                   B is not used at all.
!          CTR = 0: solution of the system of equations and evaluation
!                   of the determinant.
!          CTR > 0: solution of the system of equations only. EX = 0
!                   and DET = 0 (1) will be set, if A is singular
!                   (regular).
!          On return it contains the error code:
!          CTR = -1: parameter fault (see REMARK 1).
!          CTR =  0: program worked.
!          CTR =  1: matrix A is singular.
!
! S:       INTEGER, declared as DIMENSION S(1:N), is used for
!          auxiliary storage only and has no meaning otherwise.
!
! REMARKS: (1) If N < 1 or M < 1, CTR = -1 is set and control is
!              returned to the calling program.
!          (2) The original contents of matrices A and B are
!              destroyed on return.
!          (3) Choosing B = I (unit matrix) with M = N will
!              generate the inverse matrix of A in B.
!          (4) This program makes no use of any special forms or
!              properties of the coefficient matrix (Hessenberg or
!              tridiagonal form, band matrices, symmetric or sparse
!              matrices). Special algorithms should be used in
!              that case, if the order is sufficiently high.
!
! REF.:    J.H. Wilkinson,
!          The Algebraic Eigenvalue Problem,
!          Oxford University Press, pp 212-214, 1965.
!
! AUTHOR:        H. RIEGER, RHRZ
! INSTALLATION:  IBM 3081, VS FORTRAN V2 (OPT=3)
!
! ACCESS:
!                --- MVS ---              --- VM/CMS ---
! LOAD MODULE:   SYS3.FORTLIB(DCOPIV)     FORTLIB  TXTLIB P (DCOPIV)
! DESCRIPTION:   SYS3.INFOLIB(DCOPIV)     INFOLIB  MACLIB P (DCOPIV)
! SOURCE MODULE: SYS3.SYMLIB.FORTRAN(DCOPIV)
!
!**********************************************************************

subroutine DCOPIV(A,B,N,M,iD,EPS,DET,iEX,iCTR,S)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, M, iD
real(kind=wp), intent(inout) :: A(iD,N), B(iD,M)
real(kind=wp), intent(in) :: EPS
real(kind=wp), intent(out) :: DET, S(N)
integer(kind=iwp), intent(out) :: iEX
integer(kind=iwp), intent(inout) :: iCTR
integer(kind=iwp) :: iCI, iRI
real(kind=wp) :: C, SUM_

call DCOPIV_INTERNAL(S)

! This is to allow type punning without an explicit interface
contains

subroutine DCOPIV_INTERNAL(S)

  real(kind=wp), target, intent(out) :: S(*)
  integer(kind=iwp), pointer :: iS(:)
  integer(kind=iwp) :: I, J, K

  call c_f_pointer(c_loc(S(1)),iS,[N])
  if ((N < 1) .or. (M < 1)) then
    iCTR = -1
    nullify(iS)
    return
  end if
  iEX = 0
  DET = One
  if (N > 1) then
    do I=1,N-1
      C = abs(A(I,I))
      iRI = I
      iCI = I
      do J=I,N
        do K=I,N
          if (abs(A(J,K)) > C) then
            C = abs(A(J,K))
            iRI = J
            iCI = K
          end if
        end do
      end do
      if (iRI /= I) then
        DET = -DET
        do J=1,N
          C = A(I,J)
          A(I,J) = A(iRI,J)
          A(iRI,J) = C
        end do
        if (iCTR >= 0) then
          do J=1,M
            C = B(I,J)
            B(I,J) = B(iRI,J)
            B(iRI,J) = C
          end do
        end if
      end if
      if (iCI /= I) then
        DET = -DET
        do J=1,N
          C = A(J,I)
          A(J,I) = A(J,iCI)
          A(J,iCI) = C
        end do
      end if
      iS(I) = iCI
      SUM_ = A(I,I)
      if (abs(SUM_) <= EPS) then
        write(u6,*) ' case 1. i,sum_,eps',i,sum_,eps
        DET = Zero
        iCTR = 1
        nullify(iS)
        return
      end if
      do J=I+1,N
        C = A(J,I)/SUM_
        do K=I+1,N
          A(J,K) = A(J,K)-C*A(I,K)
        end do
        if (iCTR >= 0) then
          do K=1,M
            B(J,K) = B(J,K)-C*B(I,K)
          end do
        end if
      end do
    end do
  end if
  SUM_ = A(N,N)
  if (abs(SUM_) <= EPS) then
    write(u6,*) ' case 2. n,sum_,eps',n,sum_,eps
    DET = Zero
    iCTR = 1
    nullify(iS)
    return
  end if
  if (iCTR <= 0) then
    do K=1,N
      DET = DET*A(K,K)
      do while (abs(DET) > 1.0e10_wp)
        DET = DET*1.0e-20_wp
        iEX = iEX+20
      end do
      do while (abs(DET) <= 1.0e-10_wp)
        DET = DET*1.0e20_wp
        iEX = iEX-20
      end do
    end do
    if (iCTR < 0) then
      iCTR = 0
      nullify(iS)
      return
    end if
  end if
  do K=1,M
    B(N,K) = B(N,K)/SUM_
  end do
  if (N == 1) then
    iCTR = 0
  else
    do I=N-1,1,-1
      C = A(I,I)
      do J=1,M
        SUM_ = B(I,J)
        do K=I+1,N
          SUM_ = SUM_-A(I,K)*B(K,J)
        end do
        B(I,J) = SUM_/C
      end do
    end do
    do K=N-1,1,-1
      I = iS(K)
      if (I /= K) then
        do J=1,M
          C = B(I,J)
          B(I,J) = B(K,J)
          B(K,J) = C
        end do
      end if
    end do
  end if

  nullify(iS)
  return

end subroutine DCOPIV_INTERNAL

end subroutine DCOPIV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine EqRas(iQ_Atoms,nAtomsCC,Coord,nBas,nBas_C)

use qmstat_global, only: AvElcPot, CAFieldG, CBFieldG, CFexp, ChaNuc, CordIm, Cordst, DelFi, DelR, DelX, Diel, DispDamp, dLJrep, &
                         FieldDamp, Forcek, HmatState, iExtr_Eig, iExtra, iLuSaIn, iLuSaUt, info_atom, Inter, iPrint, iRead, &
                         iSeed, lExtr, lSlater, nAtom, nCent, nMacro, nMicro, nPart, nPol, nState, nTemp, OldGeo, outxyzRAS, &
                         PertNElcInt, Pres, Qmeq, QmProd, ParallelT, RasCha, RasDip, RasQua, rStart, SaFilIn, SaFilUt, SimEx, &
                         SURF, Temp, xyzMyI, xyzMyQ, xyzQuQ
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Four, Ten, Half, Pi, Angstrom, atmToau, auTokJ, deg2rad, KBoltzmann
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms, nAtomsCC, nBas(1), nBas_C(1)
real(kind=wp), intent(in) :: Coord(3,iQ_Atoms)
integer(kind=iwp) :: i, i9, iAcc, iAt, iCi, iCNum, iCStart, iDisk, iDiskSa, iDum(1), iHowMSampIN, iHowMSampUT, iLuExtr, iMacro, &
                     iMicro, IndMa, Inte, iProdMax, iSnurr, it1h, it1m, it2h, it2m, it3h, it3m, it4h, it4m, iTriBasQ, iTriState, &
                     jMacro, nBaseC, nBaseQ, nClas, NCountField, nVarv
real(kind=wp) :: AddRep, Ax, Ay, Az, BetaBol, Cpu1, Cpu2, Cpu3, Cpu4, Cpu5, dele, DiFac, Dum, E2Die, E_Nuc_Part, E_Nuc_Rubbet, &
                 Edisp, EEDisp, EHam, Elene, EnCLAS, Energy, Eold, Esav, Etot, Exrep, Expe, Expran, ExDie, Gam, Gmma, &
                 PertElcInt(1), Pr, Ract, Rold, RRRnVarv, s90um, Sum1, t1s, t2s, t3s, t4s, Tim1, Tim2, Tim3, timeCLAS, timeEL, &
                 timeEX, timeMC
logical(kind=iwp) :: CalledBefore, DidWeAccept, Exists, Haveri, InCutOff, Loop, SampleThis, Skip
character(len=200) :: Head
character(len=4) :: Labjhr
real(kind=wp), allocatable :: AOSum(:), BoMaH(:), BoMaO(:), Dist(:,:,:), DistIm(:,:,:,:), DT(:,:), Eint(:,:), Eint_Nuc(:), &
                              ExpCento(:,:), ExpVal(:,:), FI(:,:), Fil(:,:,:,:), FP(:,:), GP(:,:), Poli(:,:), Smat(:), &
                              SmatPure(:), STC(:,:), SumElcPot(:,:), Vmat(:)
real(kind=wp), parameter :: BoltzK = 1.0e-3_wp*KBoltzmann/auTokJ, &
                            ExLim = Ten !Over how long distance the exchange rep. is computed, the solv-solv.
integer(kind=iwp), external :: IsFreeUnit
real(kind=wp), external :: Random_Molcas
#include "warnings.h"
!****Jose** Interaction with Slater type to consider Penetration
!           Eint_Nuc
!****JoseMEP**New variables for the MEP calculation
!             SumElcPot, PertElcInt, Labjhr

! Enter eqras.

! Numbers, initializations, conversions.

Ract = rStart         !Initial radie
delX = delX/Angstrom  !angstrom-->bohr
delFi = delFi*deg2rad !degree-->radian
delR = delR/Angstrom  !angstrom-->bohr
CalledBefore = .false.
SampleThis = .true.
if (ParallelT) nMacro = nTemp*nMacro

! If we have vacuum, then no volume-pressure work is done, nor do we
! have any cavitation free-energy.

if ((abs(Diel-One) > 1.0e-4_wp) .and. (SURF > Zero)) then
  Gmma = Pres*Four/Three*Pi*atmToau
  Gam = 5.973455e-4_wp/74.0_wp*SURF !What are these numbers? Is 74.0 supposed to be the surface tension of water in mN/m?
else
  Gmma = Zero
  Gam = Zero
end if

! More numbers.

if (Temp <= Zero) then
  BetaBol = 1.0e23_wp
else
  BetaBol = One/(Temp*BoltzK)
end if
DiFac = -(Diel-One)/(Diel+One)
Expran = Zero
iHowMSampIN = 0
iHowMSampUT = 0
nBaseC = nBas_C(1)
nBaseQ = nBas(1)
iTriBasQ = nTri_Elem(nBaseQ)
iTriState = nTri_Elem(nState)
iCi = nTri_Elem(iQ_Atoms)
timeCLAS = Zero
timeEX = Zero
timeEL = Zero
timeMC = Zero

! If some damping has been requested, prepare it here and print.

if ((DispDamp .or. FieldDamp) .and. (iPrint >= 8)) then
  write(u6,*)
  write(u6,*) '-----Various damping data.'
  write(u6,*)
end if
call mma_allocate(BoMaH,iQ_Atoms,label='BoMaH')
call mma_allocate(BoMaO,iQ_Atoms,label='BoMaO')

! Construct the Born-Mayer parameters, a la Brdarski-Karlstrom
if (DispDamp) call BornMayerBK(iQ_Atoms,BoMaH,BoMaO)

! Damping of field.

if (FieldDamp .and. (iPrint >= 8)) then
  write(u6,*) '  Damping the field between Qm-region and solvent.'
  write(u6,*) '  E_damp=E_0*(1-exp(alpha*distance))^N'
  write(u6,*) '  alpha(QM-oxygen)   =',CAFieldG
  write(u6,*) '  alpha(QM-hydrogen) =',CBFieldG
  write(u6,*) '  N                  =',CFexp
end if

! Check what type of simulation to run, and generate some output of utmost beauty.

call mma_allocate(SumElcPot,iCi,10,label='SumElcPot')

if (Qmeq .and. (iRead /= 9)) then
  call NiceOutPut('EIQ')
else if (QmProd .and. (iRead /= 9)) then
  call NiceOutPut('PIQ')
  call DaName(iLuSaUt,SaFilUt)
  iDisk = 0 !Put some dummy on the sampfile so we have space for the real number later.
  iDum(1) = iHowMSampUT
  call iDaFile(iLuSaUt,1,iDum,1,iDisk)
  ! Below we make a check for extreme cases. Our algorithm to
  ! select sampling configurations sets this limit.
  iProdMax = (2**30-1)*2
  if ((nMacro*nMicro) >= iProdMax) then
    write(u6,*)
    write(u6,*) 'WARNING! Too large numbers for nMacro and nMicro to run production!'
    write(u6,*) '   Their product must not be greater than 2**31!'
    write(u6,*) '   If you wish to make such large samples, you can run several samplings and collect several sampfiles.'
    call Quit(_RC_INTERNAL_ERROR_)
  end if
else if (iRead == 9) then
  ! If we read from sampfile: open the
  ! sampfile and read how many configurations and open extract file.
  call NiceOutPut('SSS')
  call DaName(iLuSaIn,SaFilIn)
  iDiskSa = 0
  call iDaFile(iLuSaIn,2,iDum,1,iDiskSa)
  iHowMSampIN = iDum(1)
  iLuExtr = IsFreeUnit(54)
  call OpnFl(SimEx,iLuExtr,Exists)
  write(iLuExtr,*) 'Extract-File'
  write(iLuExtr,*)
  ! And put some words in the output
  write(u6,*)
  write(u6,*) '   Total number of sampled configurations:',iHowMSampIN
  write(u6,*) '   Reading from the file ',SaFilIn
  write(u6,*) '   Summarizing data put on ',SimEx
  !*****JoseMEP
  ! If we perform MEP calculation, first we make some zeros and allocate some memory.
  if (lExtr(8)) then
    call mma_allocate(AvElcPot,iCi,10,label='AvElcPot')
    SumElcPot(:,:) = Zero
    AvElcPot(:,:) = Zero
    NCountField = 0

    PertNElcInt(:) = Zero
    call mma_allocate(AOSum,iTriBasQ,label='SumOvlAOQ')
    AOSum(:) = Zero
  end if
  !*********
else
  write(u6,*)
  write(u6,*) 'An invalid number of iRead detected.'
  call Quit(_RC_INTERNAL_ERROR_)
end if
if (.not. allocated(AOSum)) call mma_allocate(AOSum,0,label='SumOvlAOQ')
!----------------------------------------------------------------------*
! If we have input file, then read from it.                            *
!----------------------------------------------------------------------*
call mma_allocate(Fil,nPol*nPart,3,iCi,10,label='Fil')
call mma_allocate(Eint,iCi,10,label='Eint')
call mma_allocate(Eint_Nuc,iQ_Atoms,label='Eint_Nuc')
call mma_allocate(Poli,iCi,10,label='Poli')
call mma_allocate(Smat,iTriState,label='Smat')
call mma_allocate(Vmat,iTriState,label='Vmat')
call mma_allocate(SmatPure,iTriState,label='SmatPure')
call mma_allocate(STC,nState,nState,label='Coeff')
call mma_allocate(ExpVal,4,nState,label='ExpVals')
call mma_allocate(ExpCento,4,nState,label='ExpCento')
if (.not. allocated(CordIm)) call mma_allocate(CordIm,3,nPart*nCent,label='CordIm')
iCStart = (((iQ_Atoms-1)/nAtom)+1)*nCent+1
iCNum = (iCStart-1)/nCent
i9 = 0 !i9 is active if iRead == 9 and we are collecting configurations from the sampfile.
outer: do
  Loop = .false.
  i9 = i9+1
  if ((iRead <= 8) .and. (iRead >= 6)) then
    call Get8(Ract,Dum)
  else if (iRead == 9) then
    call Get9(Ract,Coord,info_atom,iQ_Atoms,iDiskSa)
  else
    if (iExtra > 0) call NyPart(iExtra,nPart,Cordst,rStart,nCent,iSeed)
    if (iPrint >= 10) then
      write(Head,*) 'Coordinates of the initial distribution.'
      call Cooout(Head,Cordst,nPart,nCent)
    end if
  end if

  ! Give a startvalue for the Total energy. The effect is that we
  ! always accept the first microstep.

  Etot = 1.0e10_wp

  ! Some numbers.

  nClas = nPart-iCNum
  IndMa = nPart*nPol

  ! Put QM-molecule in its place.

  if ((iRead == 8) .or. (iRead == 0)) then
    call PlaceIt(Coord,iQ_Atoms,iCNum)
  else if (iRead == 6) then
    call PlaceIt9(Coord,Cordst,info_atom,iQ_Atoms)
    if (iPrint >= 10) then
      write(Head,*) 'CM-centred coordinates after substitution.'
      call Cooout(Head,Cordst,nPart,nCent)
    end if
  end if

  !--------------------------------------------------------------------*
  !                                                                    *
  !------------------------- START SIMULATION -------------------------*
  !                                                                    *
  !--------------------------------------------------------------------*

  iSnurr = 0 !How many steps taken totally.

  ! The Macrosteps.

  do iMacro=1,nMacro
    Esav = Zero
    if (iRead == 9) then
      iAcc = 1
    else
      iAcc = 0
    end if

    ! If we are running parallel tempering, then...
    if (ParallelT) call ParaRoot(Ract,BetaBol,Etot,CalledBefore,SampleThis)

    ! The Microsteps.

    Skip = .false.
    do iMicro=1,nMicro
      call Timing(Cpu1,Tim1,Tim2,Tim3)
      Eold = Etot
      iSnurr = iSnurr+1

      ! Generate new configuration, both solvent and QM-region.

      call GeoGen(Ract,Rold,iCNum,iQ_Atoms)

      ! Compute Solvent-solvent interaction.

      call mma_allocate(FP,3,nPol*nPart,label='FP')
      call mma_allocate(GP,3,nPol*nPart,label='GP')
      call mma_allocate(DT,3,nPol*nPart,label='DT')
      call mma_allocate(FI,3,nPol*nPart,label='FI')
      call mma_allocate(Dist,nCent,nCent,nTri_Elem(nClas-1),label='Dist')
      call mma_allocate(DistIm,nCent,nClas,nCent,nClas,label='DistIm')
      call ClasClas(iCNum,nClas,FP,GP,DT,FI,Dist,DistIm,Elene,Edisp,Exrep,E2Die,ExDie)
      call QMPosition(EHam,Cordst,Coord(:,1),Forcek,dLJrep,Ract,iQ_Atoms)
      call Timing(Cpu2,Tim1,Tim2,Tim3)
      timeCLAS = timeCLAS+(Cpu2-Cpu1)
      !----------------------------------------------------------------*
      ! Work a bit with the quantum part.                              *
      !----------------------------------------------------------------*
      xyzMyQ(:) = Zero !Dipoles for the QM-part, see polink.
      xyzMyI(:) = Zero
      Fil(:,:,:,:) = Zero
      Eint(:,:) = Zero
      Eint_Nuc(:) = Zero

      ! Compute the exchange operator.

      call ExRas(iCStart,nBaseQ,nBaseC,iQ_Atoms,nAtomsCC,Ax,Ay,Az,iTriState,Smat,SmatPure,InCutOff,AOSum)
      call Timing(Cpu3,Tim1,Tim2,Tim3)
      timeEX = timeEX+(Cpu3-Cpu2)

      ! Electrostatics commencing.

      ! Compute various gradients of 1/r.

      if (lSlater) then
        call OneOverR_Sl(Fil,Ax,Ay,Az,BoMaH,BoMaO,EEDisp,iCNum,Eint,iQ_Atoms,outxyzRAS,Eint_Nuc)
      else
        call OneOverR(Fil,Ax,Ay,Az,BoMaH,BoMaO,EEDisp,iCNum,Eint,iQ_Atoms,outxyzRAS)
      end if

      ! Couple the point-charges in the solvent to the QM-region.

      call HelState(Eint,nState,iCi,RasCha,RasDip,RasQua,Vmat)

      ! Let QM-region and solvent polarize.
      call PolRas(Dist,DistIM,DT,FI,FP,Fil,iCStart,iTriState,VMat,Smat,DiFac,Ract,iCNum,Energy,nVarv,STC,Haveri,iQ_Atoms,ExpVal, &
                  Poli)

      ! Energy from QM-nuclei interacting with solvent field.

      if (lSlater) then
        do i=1,iQ_Atoms
          Energy = Energy-Eint_Nuc(i)*ChaNuc(i)
        end do
      else
        do i=1,iQ_Atoms
          Energy = Energy-Eint(i,1)*ChaNuc(i)
        end do
      end if

      ! Some additional boost of short-range repulsion.

      call BoostRep(AddRep,SmatPure,STC,nState,InCutOff)

      ! Sum-up what we will call QM-region energy.

      Energy = Energy-EEdisp+AddRep

      !----------------------------------------------------------------*
      ! Final induction and reaction field energies.                   *
      !----------------------------------------------------------------*
      call ReaInd(GP,DT,DistIm,iCNum,IndMa,nClas,Sum1,s90um)
      call Timing(Cpu4,Tim1,Tim2,Tim3)
      timeEL = timeEL+(Cpu4-Cpu3)
      !----------------------------------------------------------------*
      ! Construct the final energy.                                    *
      !----------------------------------------------------------------*
      EnCLAS = Elene+EHam-Edisp+Exrep+E2Die+ExDie
      Etot = EnCLAS-Half*S90um-Sum1+Gmma*Ract**3+Energy+Gam*Ract**2
      Dele = Etot-Eold
      !----------------------------------------------------------------*
      ! Printing and various if requested.                             *
      !----------------------------------------------------------------*
      if (iPrint >= 10) then
        if (Haveri) Etot = 999999.0_wp
        write(u6,*)
        write(u6,*) '   ----Microstep',iMicro
        write(u6,*) '         Number of iterations:',nVarv
        write(u6,*) '         Total energy:',Etot
        write(u6,*) '         Of which is'
        write(u6,*) '            Pairwise solvent-solvent interaction:',EnCLAS
        write(u6,*) '              Solvent-solvent Electrostatic',Elene
        write(u6,*) '              Harmonic Spring:',EHam
        write(u6,*) '              Solvent-solvent Dispersion:',-Edisp
        write(u6,*) '              Solvent-solvent Exchange:',Exrep
        write(u6,*) '            Energy of induced dipoles in field from explicit solvent:',-Sum1
        write(u6,*) '            Energy of solvent charge distribution in reaction field:',-Half*S90um
        write(u6,*) '            Solvent E-interaction with image:',E2Die
        write(u6,*) '            Solvent Repulsion with boundary:',ExDie
        write(u6,*) '            Solvent-Solute dispersion:',EEdisp
        write(u6,*) '            Energy of QM-region:',Energy
        write(u6,*) '              Higher order overlap exchange pair-term:',AddRep
        write(u6,*) '            Surface tension term:',Gam*Ract**2
        write(u6,*) '            Volume-pressure term:',Gmma*Ract**3
        write(u6,*) '         Previous accepted energy:',Eold
        write(u6,*) '         Difference:',Dele
        write(u6,*) '         Total dipole in QM-region:(',-xyzMyQ(1),',',-xyzMyQ(2),',',-xyzMyQ(3),')'
        write(u6,*) '         Radie:',Ract
        if (Haveri) then
          write(u6,*) '    WARNING! SOME OF THE NUMBERS ABOVE HAVE NO MEANING SINCE THE POLARIZATION DID NOT CONVERGE!!!'
          Skip = .true.
          exit
        end if
      end if

      ! If we are collecting stuff from a sampfile, now is the time to put
      ! data on the extract file. If center-specific expectation values
      ! are requested, call Allen.

      if (iRead == 9) then
        if (lExtr(6)) then
          E_Nuc_Rubbet = Zero
          if (lSlater) then
            do iAt=1,iQ_Atoms
              E_Nuc_Rubbet = E_Nuc_Rubbet-(Eint_Nuc(iAt)+Poli(iAt,1))*ChaNuc(iAt)
            end do
          else
            do iAt=1,iQ_Atoms
              E_Nuc_Rubbet = E_Nuc_Rubbet-(Eint(iAt,1)+Poli(iAt,1))*ChaNuc(iAt)
            end do
          end if
        end if
        if (lExtr(7)) call AllenGinsberg('RASSI',Eint,Poli,ChaNuc,RasCha,RasDip,RasQua,STC,nState,lExtr(4),iExtr_Eig,iQ_Atoms, &
                                         ExpCento,E_Nuc_Part,lSlater,Eint_Nuc)

        call Extract(iLuExtr,i9,Etot,xyzMyQ,HMatState,STC,nState,xyzQuQ,ExpVal,ExpCento,E_Nuc_Rubbet,E_Nuc_Part)
        !***JoseMEP**********
        ! If MEP option. Add electr. potential, field, etc. for all solvent config.
        if (lExtr(8)) then
          Labjhr = 'Add '
          call AverMEP(Labjhr,Eint,Poli,iCi,SumElcPot,NCountField,PertElcInt,1,1,[1],[1],1)
          NCountField = NCountField+1
        end if
        !********
      else
        ! Resume the MC-wrap up.

        Dele = Dele*BetaBol
        DidWeAccept = .true.
        if (Dele < Zero) then
          iAcc = iAcc+1
        else
          Expe = exp(-Dele)
          Expran = Random_Molcas(iSeed)
          if (iPrint >= 10) then
            write(u6,*) '         Positive energy change!'
            write(u6,*) '         Boltzmann weight:',Expe
            write(u6,*) '         Random number:',ExpRan
          end if
          if (Expe >= ExpRan) then
            iAcc = iAcc+1
          else
            Etot = Eold
            Ract = Rold
            Cordst(:,:) = OldGeo
            DidWeAccept = .false.
            if (iPrint >= 10) write(u6,*) '         Not accepted!'
          end if
        end if
        if (DidWeAccept) Esav = Esav+Etot
        !--------------------------------------------------------------*
        ! If this is a production run, then put stuff on the sampfile. *
        !--------------------------------------------------------------*
        if (QmProd .and. (iRead /= 9)) then
          if (SampleThis) then
            if (Inter /= 0) then
              Inte = (iSnurr/Inter)*Inter
              if (Inte == ((iMacro-1)*nMicro+iMicro)) call Put9(Etot,Ract,iHowMSampUT,Gmma,Gam,Esav,iDisk)
            end if
          end if
        end if
      end if

      ! Free memory.

      call mma_deallocate(Dist)
      call mma_deallocate(DistIm)
      call mma_deallocate(FP)
      call mma_deallocate(GP)
      call mma_deallocate(DT)
      call mma_deallocate(FI)
      call Timing(Cpu5,Tim1,Tim2,Tim3)
      timeMC = timeMC+(Cpu5-Cpu4)

      !----------------------------------------------------------------*
      ! End of Microstep.                                              *
      !----------------------------------------------------------------*
    end do
    !------------------------------------------------------------------*
    ! Have we collected all sampled configurations? If no, go up again.*
    ! If yes, then close some files and take a little jump downwards to*
    ! the END!!!                                                       *
    !------------------------------------------------------------------*
    !Jose***************************************
    ! This point is also used to perform the Average of the Potential,
    ! Field and Field gradients to obtain and average Electrostatic
    ! perturbation. The Non-Electr. perturbation is also obtained here
    ! it will be added directly to the One-electron file.
    !******************************************

    if (.not. Skip) then
      if ((i9 < iHowMSampIN) .and. (iRead == 9)) then
        cycle outer
      else if ((i9 >= iHowMSampIN) .and. (iRead == 9)) then
        !*****JoseMEP**
        ! If MEP option. Obtain the mean Potential, Field and Field Gradients.
        ! It is also obtained the average of the Non-Electrostatic perturbation
        if (lExtr(8)) then
          Labjhr = 'Aver'
          call AverMEP(Labjhr,Eint,Poli,iCi,SumElcPot,NCountField,PertElcInt,1,1,[1],[1],1)

          PertNElcInt(:) = PertNElcInt+AOSum/real(NCountField,kind=wp)
          call mma_deallocate(AOSum)
        end if
        !********

        call DaClos(iLuSaIn)
        close(iLuExtr)
        exit outer
      end if
    end if
    !------------------------------------------------------------------*
    ! Write to startfile.                                              *
    !------------------------------------------------------------------*
    ESav = Esav/real(iAcc,kind=wp)
    call Put8(Ract,Etot,Gmma,Gam,ESav)
    if (Haveri) call Quit(_RC_NOT_CONVERGED_)
    !------------------------------------------------------------------*
    ! Print some things here at the end of the macrostep.              *
    !------------------------------------------------------------------*
    if (.not. ParallelT) then
      jMacro = iMacro
    else
      jMacro = 1+(iMacro-1)/nTemp
    end if
    write(u6,'(A,i4)') '---Macrostep ',jMacro
    write(u6,'(A,i4)') '     Number of microsteps:',nMicro
    Pr = 100.0_wp*(real(iAcc,kind=wp)/real(nMicro,kind=wp))
    write(u6,'(A,i4,A,f5.1,A)') '     Number of acceptances:',iAcc,'(',Pr,'%)'
    write(u6,'(A,f12.4)') '     Radie (a.u.):',Ract
    write(u6,'(A,f16.8)') '     Average Energy (a.u.) in Macrostep:',Esav
    write(u6,'(A,3(f12.4))') '     Total dipole in QM-region last microstep (a.u.):',-xyzMyQ(1),-xyzMyQ(2),-xyzMyQ(3)
    write(u6,*)
    call xFlush(u6)
    !------------------------------------------------------------------*
    ! End of Macrostep.                                                *
    !------------------------------------------------------------------*
  end do
  !--------------------------------------------------------------------*
  ! Put some things on info-file. Used to make tests.                  *
  !--------------------------------------------------------------------*
  call Add_Info('Total Energy',[Etot],1,6)
  call Add_Info('Induction of system',[Sum1],1,6)
  call Add_Info('React. field int.',[s90um],1,6)
  call Add_Info('Solv-Solu Disp.',[EEdisp],1,6)
  call Add_Info('QM-region Energy',[Energy],1,6)
  call Add_Info('QM-region dipole',xyzMyQ,3,5)
  RRRnVarv = real(nVarv,kind=wp)
  call Add_Info('Pol.Iterations',[RRRnVarv],1,8)
  if (.not. Loop) exit outer
end do outer
call mma_deallocate(BoMaH)
call mma_deallocate(BoMaO)
call mma_deallocate(Fil)
call mma_deallocate(Eint)
call mma_deallocate(Eint_Nuc)
call mma_deallocate(Poli)
call mma_deallocate(Smat)
call mma_deallocate(Vmat)
call mma_deallocate(SmatPure)
call mma_deallocate(STC)
call mma_deallocate(ExpVal)
call mma_deallocate(ExpCento)
call mma_deallocate(SumElcPot)
if (allocated(AOSum)) call mma_deallocate(AOSum)
!----------------------------------------------------------------------*
! Close some external files.                                           *
!----------------------------------------------------------------------*
if (QmProd .and. (iRead /= 9)) then
  iDisk = 0
  iDum(1) = iHowMSampUT
  call iDaFile(iLuSaUt,1,iDum,1,iDisk)
  call DaClos(iLuSaUt)
end if
!----------------------------------------------------------------------*
! The End... be happy!                                                 *
!----------------------------------------------------------------------*

write(u6,*)
write(u6,*)
write(u6,*) ' Time statistics. (hour:minute:second)'
write(u6,*) ' -----------------------------------------------------'
it1h = int(timeCLAS)/3600
it1m = int(timeCLAS-it1h*3600)/60
t1s = timeCLAS-it1h*3600-it1m*60
write(u6,9) '   Time spent on pair-wise solvent-solvent interactions: ',it1h,':',it1m,':',t1s
it2h = int(timeEX)/3600
it2m = int(timeEX-it2h*3600)/60
t2s = timeEX-it2h*3600-it2m*60
write(u6,9) '   Time spent on solvent-solute overlap calculations: ',it2h,':',it2m,':',t2s
it3h = int(timeEL)/3600
it3m = int(timeEL-it3h*3600)/60
t3s = timeEL-it3h*3600-it3m*60
write(u6,9) '   Time spent on solvent and solute electrostatic interaction: ',it3h,':',it3m,':',t3s
it4h = int(timeMC)/3600
it4m = int(timeMC-it4h*3600)/60
t4s = timeMC-it4h*3600-it4m*60
write(u6,9) '   Time spent on the Metropolis-Monte Carlo decision: ',it4h,':',it4m,':',t4s

return

9 format(A,I4,A,I3,A,F5.2)

end subroutine EqRas

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine GetInfo_Localisation_0()
! Author: T.B. Pedersen
!
! Purpose: read basic info from runfile and INPORB.

use Localisation_globals, only: BName, CMO, EOrb, Ind, LC_FileOrb, nAtoms, nBas, nCMO, nOccInp, nOrb, nSym, nVirInp, Occ
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: iwp

implicit none
#include "Molcas.fh"
integer(kind=iwp) :: i, iSym, kOff, n2Bas, nBasT, nOrbT
character(len=80) :: Txt
character(len=512) :: FName
character(len=*), parameter :: SecNam = 'GetInfo_Localisation_0'

! Read number of irreps.
! ----------------------

call Get_iScalar('nSym',nSym)
if ((nSym < 1) .or. (nSym > MxSym)) then
  write(Txt,'(A,I9)') 'nSym =',nSym
  call SysAbendMsg(SecNam,'Number of irreps out of bounds!',Txt)
end if

! Read number of basis functions.
! -------------------------------

call Get_iArray('nBas',nBas,nSym)
nBasT = nBas(1)
do iSym=2,nSym
  nBasT = nBasT+nBas(iSym)
end do
if ((nBasT < 1) .or. (nBasT > MxBas)) then
  write(Txt,'(A,I9)') 'nBasT =',nBasT
  call SysAbendMsg(SecNam,'Basis set limits exceeded!',Txt)
end if

! Set number of orbitals equal to nBas.
! -------------------------------------

nOrb(:) = nBas(:)
nOrbT = nOrb(1)
do iSym=2,nSym
  nOrbT = nOrbT+nOrb(iSym)
end do
if ((nOrbT < 1) .or. (nOrbT > MxBas)) then
  write(Txt,'(A,I9)') 'nOrbT =',nOrbT
  call SysAbendMsg(SecNam,'Orbital limits exceeded!',Txt)
end if
do iSym=1,nSym
  if (nOrb(iSym) > nBas(iSym)) then
    write(Txt,'(A,I2,2(1X,I9))') 'iSym,nOrb,nBas:',iSym,nOrb(iSym),nBas(iSym)
    call SysAbendMsg(SecNam,'#orb > #bas:',Txt)
  end if
end do

! Read MO coefficients, orbital occupations, and orbital energies
! from INPORB.
! ---------------------------------------------------------------

n2Bas = nBas(1)**2
do iSym=2,nSym
  n2Bas = n2Bas+nBas(iSym)**2
end do

nCMO = n2Bas
call mma_allocate(CMO,nCMO,label='CMO')
call mma_allocate(Occ,nBasT,label='Occup')
call mma_allocate(Eorb,nBasT,label='OrbEn')
call mma_allocate(Ind,nBasT,label='IndT')
FName = LC_FileOrb
if (FName == '') FName = 'INPORB' ! file name
call RdVec_Localisation(nSym,nBas,nOrb,Ind,CMO,Occ,EOrb,trim(FName))

! Set number of occupied and virtual orbitals according to the
! occupation numbers from INPORB (assuming that occupied orbitals
! precede virtual ones on file).
! ---------------------------------------------------------------

kOff = 0
do iSym=1,nSym
  nOccInp(iSym) = 0
  i = 0
  do while (i < nOrb(iSym))
    i = i+1
    if (Occ(kOff+i) > Zero) then
      nOccInp(iSym) = nOccInp(iSym)+1
    else
      i = nOrb(iSym) ! break while loop
    end if
  end do
  nVirInp(iSym) = nOrb(iSym)-nOccInp(iSym)
  if (nVirInp(iSym) < 0) then
    write(Txt,'(3(A,I9))') 'No. of occupied: ',nOccInp(iSym),' No. of orbitals: ',nOrb(iSym),' Symmetry: ',iSym
    call SysAbendMsg(SecNam,'#occ > #orb:',Txt)
  end if
  kOff = kOff+nBas(iSym)
end do

! Read number of atoms, atomic labels, and basis function labels
! from runfile.
! --------------------------------------------------------------

call Get_nAtoms_All(nAtoms)
if ((nAtoms < 1) .or. (nAtoms > MxAtom)) then
  write(Txt,'(A,I9)') 'nAtoms =',nAtoms
  call SysAbendMsg(SecNam,'Atom limit exceeded!',Txt)
end if
call mma_allocate(BName,nBasT,label='BName')
!call Get_cArray('Unique Atom Names',AtomLbl,4*nAtoms)
call Get_cArray('Unique Basis Names',BName,len(BName)*nBasT)

end subroutine GetInfo_Localisation_0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SA_PREC(S,rdia)

use ipPage, only: ipin, W
use MCLR_Data, only: ipCI
use input_mclr, only: ERASSCF, nRoots
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: S(nroots,nroots,nroots)
real(kind=wp), intent(in) :: rdia(*)
integer(kind=iwp) :: i

call ipin(ipci)
do i=1,nroots
  call SA_PREC2(rdia,S(:,:,i),W(ipci)%A,ERASSCF(i))
end do

end subroutine SA_PREC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine prtopt_cvb()
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "seth_cvb.fh"
#include "initopt_cvb.fh"
#include "loopcntr_cvb.fh"
#include "WrkSpc.fh"
      external istkprobe_cvb
      logical istkprobe_cvb

c  First determine if end of multi-step optimization may have been reached:
      if(istkprobe_cvb(istackrep))then
        call istkpop_cvb(istackrep,nc_zeroed)
        call istkpop_cvb(istackrep,nconvinone)
        call istkpop_cvb(istackrep,italter)
        call istkpop_cvb(istackrep,mxalter)
        call istkpop_cvb(istackrep,kk2)
        call istkpop_cvb(istackrep,ioptstep2)
        call istkpop_cvb(istackrep,ioptstep1)
        call istkpush_cvb(istackrep,ioptstep1)
        call istkpush_cvb(istackrep,ioptstep2)
        call istkpush_cvb(istackrep,kk2)
        call istkpush_cvb(istackrep,mxalter)
        call istkpush_cvb(istackrep,italter)
        call istkpush_cvb(istackrep,nconvinone)
        call istkpush_cvb(istackrep,nc_zeroed)
      else
        ioptstep1=0
        italter=0
      endif

      i1 = mstacki_cvb(2*norb*(norb-1)/2)
      i2 = mstacki_cvb(norb)
      i3 = mstacki_cvb(nvb)
      i4 = mstacki_cvb(nvb)

      call rdioff_cvb(11,recinp,ioffs)
      call rdis_cvb(iwork(i2),norb,recinp,ioffs)
      call rdis_cvb(iwork(i3),nfxvb,recinp,ioffs)
      call rdis_cvb(iwork(i4),nzrvb,recinp,ioffs)
      call rdis_cvb(iwork(i1),2*nort,recinp,ioffs)

      call prtopt2_cvb(ioptstep1,ioptim,italter,noptim,
     >  iwork(i1),iwork(i2),iwork(i3),iwork(i4))
      call mfreei_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine OFFDNS(ISYM1,ICASE1,ISYM2,ICASE2,X1,nX1,X2,nX2,DPT2,nDPT2,Y,nY,LIST,MLIST)
! Compute off-diagonal contributions to a trans density matrix.
! Sub-diagonal blocks only. If a density matrix is required,
! i.e. both wave functions equal, use symmetry. Else, call
! again with wave functions interchanged.

use Symmetry_Info, only: Mul
use EQSOLV, only: IFCOUP, LLIST, NLIST
use Sigma_data, only: IFTEST, INCF1, INCF2, INCX1, INCX2, INCX3, INCY1, INCY2, INCY3, LEN1, LEN2, NLST1, NLST2, VAL1, VAL2
use caspt2_module, only: NAGEB, NAGTB, NASH, NASUP, NIGEJ, NIGTJ, NISH, NISUP, NORB, NSSH, NSYM, NTGEU, NTGTU, NTUV
use Constants, only: One, Two, Three, Six, Half, OneHalf
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ISYM1, ICASE1, ISYM2, ICASE2, nX1, nX2, nY, nDPT2, mLIST, LIST(mList)
real(kind=wp), intent(inout) :: X1(nX1), X2(nX2), DPT2(nDPT2), Y(nY)
integer(kind=iwp) :: ICD, ICEM, ICEP, ICGM, ICGP, IDIA, IDIT, IDJB, IDOFF, IDTA, IJSYM, IMLTOP, IOFCD(8,8), IOFCEM(8,8), &
                     IOFCEP(8,8), IOFCGM(8,8), IOFCGP(8,8), IOFDIA(8), IOFDIT(8), IOFDTA(8), IOXIA, ISYM, ISYM12, ISYMA, ISYMAB, &
                     ISYMB, ISYMI, ISYMIJ, ISYMJ, IX, IXIA, IXTA, IXTI, IY, JSYM, KOD, LLST1, LLST2, NA, NAS1, NAS2, NB, NI, NIS1, &
                     NJ, NO, NT, NU
real(kind=wp), parameter :: SQR2 = sqrt(Two), SQR3 = sqrt(Three), SQR32 = sqrt(OneHalf), SQRI2 = sqrt(Half), SQRI6 = One/sqrt(Six)

NA = 0 ! dummy initialize

IFTEST = 0
IMLTOP = 2
KOD = IFCOUP(ICASE2,ICASE1)
if (KOD == 0) return

ISYM12 = Mul(ISYM1,ISYM2)
NAS1 = NASUP(ISYM1,ICASE1)
NIS1 = NISUP(ISYM1,ICASE1)
NAS2 = NASUP(ISYM2,ICASE2)
! Set up various offset arrays:
IDOFF = 0
do ISYM=1,NSYM
  NI = NISH(ISYM)
  NA = NASH(ISYM)
  NO = NORB(ISYM)
  IOFDIT(ISYM) = IDOFF+NO*NI
  IOFDIA(ISYM) = IOFDIT(ISYM)+NO*NA
  IOFDTA(ISYM) = IOFDIA(ISYM)+NI
  IDOFF = IDOFF+NO**2
  ICD = 0
  ICEP = 0
  ICEM = 0
  ICGP = 0
  ICGM = 0
  do JSYM=1,NSYM
    IJSYM = Mul(ISYM,JSYM)
    IOFCD(ISYM,JSYM) = ICD
    IOFCEP(ISYM,JSYM) = ICEP
    IOFCEM(ISYM,JSYM) = ICEM
    IOFCGP(ISYM,JSYM) = ICGP
    IOFCGM(ISYM,JSYM) = ICGM
    ICD = ICD+NSSH(JSYM)*NISH(IJSYM)
    ICEP = ICEP+NSSH(JSYM)*NIGEJ(IJSYM)
    ICEM = ICEM+NSSH(JSYM)*NIGTJ(IJSYM)
    ICGP = ICGP+NISH(JSYM)*NAGEB(IJSYM)
    ICGM = ICGM+NISH(JSYM)*NAGTB(IJSYM)
  end do
end do

select case (KOD)
  ! -----------------------------------------------
  case (1)
    ! A&BP One-el
    NLST1 = NLIST(ISYM1,ISYM2,12)
    NLST2 = NLIST(ISYM1,ISYM2,14)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,12)
      VAL1(1) = One
      VAL1(2) = Two
      LLST2 = LLIST(ISYM1,ISYM2,14)
      VAL2(1) = One
      VAL2(2) = SQR2
      IXTI = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      IDIT = 1+IOFDIT(ISYM12)
      INCF1 = NORB(ISYM12)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NTGEU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXTI),size(X1(IXTI:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY), &
                  size(Y(IY:)))
    end if

    ! A&BP Two-el
    NLST1 = NLIST(ISYM1,ISYM2,3)
    NLST2 = NLIST(ISYM1,ISYM2,14)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,3)
      VAL1(1) = -One
      VAL1(2) = -Two
      LLST2 = LLIST(ISYM1,ISYM2,14)
      VAL2(1) = One
      VAL2(2) = SQR2
      IX = 1
      INCX1 = 1
      INCX2 = NTUV(ISYM1)
      IDIT = 1+IOFDIT(ISYM12)
      INCF1 = NORB(ISYM12)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NTGEU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X2(IX),size(X2(IX:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (2)
    ! A&BM One-el
    NLST1 = NLIST(ISYM1,ISYM2,13)
    NLST2 = NLIST(ISYM1,ISYM2,15)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,13)
      VAL1(1) = Three
      VAL1(2) = -Three
      LLST2 = LLIST(ISYM1,ISYM2,15)
      ! Original:
      !VAL2(1) = -One
      !VAL2(2) = One
      ! Fix for sign error noted by Takeshi, May 2015:
      VAL2(1) = One
      VAL2(2) = -One
      IXTI = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      IDIT = 1+IOFDIT(ISYM12)
      INCF1 = NORB(ISYM12)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NTGTU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXTI),size(X1(IXTI:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY), &
                  size(Y(IY:)))
    end if

    ! A&BM Two-el
    NLST1 = NLIST(ISYM1,ISYM2,4)
    NLST2 = NLIST(ISYM1,ISYM2,15)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,4)
      VAL1(1) = -One
      VAL1(2) = One
      LLST2 = LLIST(ISYM1,ISYM2,15)
      ! Original:
      !VAL2(1) = -One
      !VAL2(2) = One
      ! Fix for sign error noted by Takeshi, May 2015:
      VAL2(1) = One
      VAL2(2) = -One
      IX = 1
      INCX1 = 1
      INCX2 = NTUV(ISYM1)
      IDIT = 1+IOFDIT(ISYM12)
      INCF1 = NORB(ISYM12)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NTGTU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X2(IX),size(X2(IX:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (3)
    ! A&D  Two-el
    LLST1 = LLIST(ISYM1,ISYM2,1)
    NLST1 = NLIST(ISYM1,ISYM2,1)
    if (NLST1 /= 0) then
      VAL1(1) = One
      VAL1(2) = One
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      IDTA = 1+IOFDTA(ISYM12)
      INCF1 = 1
      INCF2 = NORB(ISYM12)
      IY = 1+NAS2*IOFCD(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2
      INCY3 = NAS2*NISH(ISYM1)
      LEN1 = NISH(ISYM1)
      LEN2 = NSSH(ISYM12)
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),DPT2(IDTA),size(DPT2(IDTA:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (4)
    ! A&EP One-el
    NT = NASH(ISYM1)
    if ((ISYM2 == ISYM1) .and. (NT /= 0)) then
      do ISYMIJ=1,NSYM
        ISYMA = Mul(ISYMIJ,ISYM1)
        NA = NSSH(ISYMA)
        NLST1 = NLIST(ISYM1,ISYMIJ,14)
        if (NA*NLST1 /= 0) then
          LLST1 = LLIST(ISYM1,ISYMIJ,14)
          VAL1(1) = One
          VAL1(2) = SQR2
          IXTI = 1
          INCX1 = NT
          INCX2 = 1
          IDIA = 1+IOFDIA(ISYMA)
          INCF1 = 1
          INCF2 = NORB(ISYMA)
          IY = 1+NAS2*IOFCEP(ISYM2,ISYMA)
          INCY1 = NT*NA
          INCY2 = 1
          INCY3 = NT
          LEN1 = NT
          LEN2 = NA
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTI),size(X1(IXTI:)),DPT2(IDIA),size(DPT2(IDIA:)),Y(IY),size(Y(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (5)
    ! A&EM One-el
    NT = NASH(ISYM1)
    if ((ISYM2 == ISYM1) .and. (NT /= 0)) then
      do ISYMIJ=1,NSYM
        ISYMA = Mul(ISYMIJ,ISYM1)
        NA = NSSH(ISYMA)
        NLST1 = NLIST(ISYM1,ISYMIJ,15)
        if (NA*NLST1 /= 0) then
          LLST1 = LLIST(ISYM1,ISYMIJ,15)
          VAL1(1) = -SQR3
          VAL1(2) = SQR3
          IXTI = 1
          INCX1 = NT
          INCX2 = 1
          IDIA = 1+IOFDIA(ISYMA)
          INCF1 = 1
          INCF2 = NORB(ISYMA)
          IY = 1+NAS2*IOFCEM(ISYM2,ISYMA)
          INCY1 = NT*NA
          INCY2 = 1
          INCY3 = NT
          LEN1 = NT
          LEN2 = NA
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTI),size(X1(IXTI:)),DPT2(IDIA),size(DPT2(IDIA:)),Y(IY),size(Y(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (6)
    ! BP&EP Two-el
    NA = NSSH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,9)
    if (NA*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,9)
      VAL1(1) = SQRI2
      VAL1(2) = SQRI2
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      IDTA = 1+IOFDTA(ISYM12)
      INCF1 = 1
      INCF2 = NORB(ISYM12)
      IY = 1+NAS2*IOFCEP(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2*NA
      INCY3 = NAS2
      LEN1 = NIS1
      LEN2 = NA
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),DPT2(IDTA),size(DPT2(IDTA:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (7)
    ! BM&EM Two-el
    NA = NSSH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,10)
    if (NA*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,10)
      ! Original:
      !VAL1(1) = -SQRI6
      !VAL1(2) = SQRI6
      ! Fix for sign error noted by Takeshi, May 2015:
      VAL1(1) = SQRI6
      VAL1(2) = -SQRI6
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      IDTA = 1+IOFDTA(ISYM12)
      INCF1 = 1
      INCF2 = NORB(ISYM12)
      IY = 1+NAS2*IOFCEM(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2*NA
      INCY3 = NAS2
      LEN1 = NIS1
      LEN2 = NA
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),DPT2(IDTA),size(DPT2(IDTA:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (8)
    ! C&D  One-el
    NI = NISH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,11)
    if (NI*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,11)
      VAL1(1) = Two
      VAL1(2) = One
      IXTA = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      IDIT = 1+IOFDIT(ISYM12)
      INCF1 = NORB(ISYM12)
      INCF2 = 1
      IY = 1+NAS2*IOFCD(ISYM2,ISYM1)
      INCY1 = 1
      INCY2 = NAS2*NI
      INCY3 = NAS2
      LEN1 = NSSH(ISYM1)
      LEN2 = NI
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTA),size(X1(IXTA:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY),size(Y(IY:)))
    end if

    ! C&D  Two-el
    NI = NISH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,2)
    if (NI*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,2)
      VAL1(1) = -One
      VAL1(2) = -One
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      IDIT = 1+IOFDIT(ISYM12)
      INCF1 = NORB(ISYM12)
      INCF2 = 1
      IY = 1+NAS2*IOFCD(ISYM2,ISYM1)
      INCY1 = 1
      INCY2 = NAS2*NI
      INCY3 = NAS2
      LEN1 = NSSH(ISYM1)
      LEN2 = NI
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (9)
    ! C&FP One-el
    NLST1 = NLIST(ISYM1,ISYM2,12)
    NLST2 = NLIST(ISYM1,ISYM2,16)
    if (NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,12)
      VAL1(1) = -One
      VAL1(2) = -Two
      LLST2 = LLIST(ISYM1,ISYM2,16)
      VAL2(1) = One
      VAL2(2) = SQR2
      IXTA = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      IDTA = 1+IOFDTA(ISYM12)
      INCF1 = 1
      INCF2 = NORB(ISYM12)
      IY = 1
      INCY1 = 1
      INCY2 = NTGEU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXTA),size(X1(IXTA:)),DPT2(IDTA),size(DPT2(IDTA:)),Y(IY), &
                  size(Y(IY:)))
    end if

    ! C&FP Two-el
    NLST1 = NLIST(ISYM1,ISYM2,5)
    NLST2 = NLIST(ISYM1,ISYM2,16)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,5)
      VAL1(1) = One
      VAL1(2) = Two
      LLST2 = LLIST(ISYM1,ISYM2,16)
      VAL2(1) = One
      VAL2(2) = SQR2
      IX = 1
      INCX1 = 1
      INCX2 = NTUV(ISYM1)
      IDTA = 1+IOFDTA(ISYM12)
      INCF1 = 1
      INCF2 = NORB(ISYM12)
      IY = 1
      INCY1 = 1
      INCY2 = NTGEU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X2(IX),size(X2(IX:)),DPT2(IDTA),size(DPT2(IDTA:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (10)
    ! C&FM One-el
    NLST1 = NLIST(ISYM1,ISYM2,13)
    NLST2 = NLIST(ISYM1,ISYM2,17)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,13)
      VAL1(1) = -One
      VAL1(2) = One
      LLST2 = LLIST(ISYM1,ISYM2,17)
      VAL2(1) = One
      VAL2(2) = -One
      IXTA = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      IDTA = 1+IOFDTA(ISYM12)
      INCF1 = 1
      INCF2 = NORB(ISYM12)
      IY = 1
      INCY1 = 1
      INCY2 = NTGTU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXTA),size(X1(IXTA:)),DPT2(IDTA),size(DPT2(IDTA:)),Y(IY), &
                  size(Y(IY:)))
    end if

    ! C&FM Two-el
    NLST1 = NLIST(ISYM1,ISYM2,6)
    NLST2 = NLIST(ISYM1,ISYM2,17)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,6)
      VAL1(1) = -One
      VAL1(2) = One
      LLST2 = LLIST(ISYM1,ISYM2,17)
      VAL2(1) = One
      VAL2(2) = -One
      IX = 1
      INCX1 = 1
      INCX2 = NTUV(ISYM1)
      IDTA = 1+IOFDTA(ISYM12)
      INCF1 = 1
      INCF2 = NORB(ISYM12)
      IY = 1
      INCY1 = 1
      INCY2 = NTGTU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X2(IX),size(X2(IX:)),DPT2(IDTA),size(DPT2(IDTA:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (11)
    ! C&GP One-el
    NT = NASH(ISYM1)
    if ((ISYM2 == ISYM1) .and. (NT /= 0)) then
      do ISYMAB=1,NSYM
        ISYMI = Mul(ISYMAB,ISYM1)
        NI = NISH(ISYMI)
        NLST1 = NLIST(ISYM1,ISYMAB,16)
        if (NI*NLST1 /= 0) then
          LLST1 = LLIST(ISYM1,ISYMAB,16)
          VAL1(1) = SQRI2
          VAL1(2) = One
          IXTA = 1
          INCX1 = NT
          INCX2 = 1
          IDIA = 1+IOFDIA(ISYMI)
          INCF1 = NORB(ISYMI)
          INCF2 = 1
          IY = 1+NAS2*IOFCGP(ISYM2,ISYMI)
          INCY1 = NT*NI
          INCY2 = 1
          INCY3 = NT
          LEN1 = NT
          LEN2 = NI
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTA),size(X1(IXTA:)),DPT2(IDIA),size(DPT2(IDIA:)),Y(IY),size(Y(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (12)
    ! C&GM One-el
    NT = NASH(ISYM1)
    if ((ISYM2 == ISYM1) .and. (NT /= 0)) then
      do ISYMAB=1,NSYM
        ISYMI = Mul(ISYMAB,ISYM1)
        NI = NISH(ISYMI)
        NLST1 = NLIST(ISYM1,ISYMAB,17)
        if (NI*NLST1 /= 0) then
          LLST1 = LLIST(ISYM1,ISYMAB,17)
          VAL1(1) = SQR32
          VAL1(2) = -SQR32
          IXTA = 1
          INCX1 = NT
          INCX2 = 1
          IDIA = 1+IOFDIA(ISYMI)
          INCF1 = NORB(ISYMI)
          INCF2 = 1
          IY = 1+NAS2*IOFCGM(ISYM2,ISYMI)
          INCY1 = NT*NI
          INCY2 = 1
          INCY3 = NT
          LEN1 = NT
          LEN2 = NI
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTA),size(X1(IXTA:)),DPT2(IDIA),size(DPT2(IDIA:)),Y(IY),size(Y(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (13)
    ! D&EP One-el
    NT = NASH(ISYM2)
    if ((ISYM1 == 1) .and. (NT /= 0)) then
      IOXIA = 0
      do ISYMI=1,NSYM
        NI = NISH(ISYMI)
        NA = NSSH(ISYMI)
        ISYMIJ = Mul(ISYMI,ISYM2)
        LLST1 = LLIST(ISYMI,ISYMIJ,14)
        NLST1 = NLIST(ISYMI,ISYMIJ,14)
        if (NI*NA*NLST1 /= 0) then
          VAL1(1) = SQRI2
          VAL1(2) = One
          IXIA = IOXIA+1
          INCX1 = 1
          INCX2 = NI
          IDIT = 1+IOFDIT(ISYM2)
          INCF1 = 1
          INCF2 = NORB(ISYM2)
          IY = 1+NAS2*IOFCEP(ISYM2,ISYMI)
          INCY1 = NT*NA
          INCY2 = NT
          INCY3 = 1
          LEN1 = NA
          LEN2 = NT
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXIA),size(X1(IXIA:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY),size(Y(IY:)))
        end if
        IOXIA = IOXIA+NI*NA
      end do
    end if

    ! D&EP Two-el
    NLST1 = NLIST(ISYM1,ISYM2,7)
    NU = NASH(ISYM2)
    if (NLST1*NU /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,7)
      VAL1(1) = -One
      VAL1(2) = -One
      do ISYMA=1,NSYM
        NA = NSSH(ISYMA)
        ISYMI = Mul(ISYMA,ISYM1)
        NI = NISH(ISYMI)
        ISYMIJ = Mul(ISYMI,ISYM12)
        LLST2 = LLIST(ISYMI,ISYMIJ,14)
        NLST2 = NLIST(ISYMI,ISYMIJ,14)
        if (NA*NI*NLST2 /= 0) then
          VAL2(1) = SQRI2
          VAL2(2) = One
          IX = 1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1 = 1
          INCX2 = NAS1
          INCX3 = NAS1*NI
          IDIT = 1+IOFDIT(ISYM12)
          INCF1 = NORB(ISYM12)
          INCF2 = 1
          IY = 1+NU*IOFCEP(ISYM2,ISYMA)
          INCY1 = 1
          INCY2 = NU*NA
          INCY3 = NU
          LEN1 = NA
          call MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),X2(IX:),size(X2(IX:)),DPT2(IDIT:),size(DPT2(IDIT:)),Y(IY:),size(Y(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (14)
    ! D&EM One-el
    NT = NASH(ISYM2)
    if ((ISYM1 == 1) .and. (NT /= 0)) then
      IOXIA = 0
      do ISYMI=1,NSYM
        NI = NISH(ISYMI)
        NA = NSSH(ISYMI)
        ISYMIJ = Mul(ISYMI,ISYM2)
        LLST1 = LLIST(ISYMI,ISYMIJ,15)
        NLST1 = NLIST(ISYMI,ISYMIJ,15)
        if (NI*NLST1 /= 0) then
          VAL1(1) = SQR32
          VAL1(2) = -SQR32
          IXIA = IOXIA+1
          INCX1 = 1
          INCX2 = NI
          IDIT = 1+IOFDIT(ISYM2)
          INCF1 = 1
          INCF2 = NORB(ISYM2)
          IY = 1+NAS2*IOFCEM(ISYM2,ISYMI)
          INCY1 = NT*NA
          INCY2 = NT
          INCY3 = 1
          LEN1 = NA
          LEN2 = NT
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXIA),size(X1(IXIA:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY),size(Y(IY:)))
        end if
        IOXIA = IOXIA+NI*NA
      end do
    end if

    ! D&EM Two-el
    NLST1 = NLIST(ISYM1,ISYM2,7)
    NU = NASH(ISYM2)
    if (NLST1*NU /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,7)
      VAL1(1) = -One
      VAL1(2) = One
      do ISYMA=1,NSYM
        NA = NSSH(ISYMA)
        ISYMI = Mul(ISYMA,ISYM1)
        NI = NISH(ISYMI)
        ISYMIJ = Mul(ISYMI,ISYM12)
        NLST2 = NLIST(ISYMI,ISYMIJ,15)
        if (NA*NI*NLST2 /= 0) then
          LLST2 = LLIST(ISYMI,ISYMIJ,15)
          VAL2(1) = SQRI6
          VAL2(2) = -SQRI6
          IX = 1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1 = 1
          INCX2 = NAS1
          INCX3 = NAS1*NI
          IDIT = 1+IOFDIT(ISYM12)
          INCF1 = NORB(ISYM12)
          INCF2 = 1
          IY = 1+NU*IOFCEM(ISYM2,ISYMA)
          INCY1 = 1
          INCY2 = NU*NA
          INCY3 = NU
          LEN1 = NA
          call MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),X2(IX:),size(X2(IX:)),DPT2(IDIT:),size(DPT2(IDIT:)),Y(IY:),size(Y(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (15)
    ! D&GP Two-el
    NLST1 = NLIST(ISYM1,ISYM2,8)
    NU = NASH(ISYM2)
    if (NLST1*NU /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,8)
      VAL1(1) = One
      VAL1(2) = One
      do ISYMA=1,NSYM
        ISYMI = Mul(ISYMA,ISYM1)
        NI = NISH(ISYMI)
        ISYMAB = Mul(ISYMA,ISYM12)
        NLST2 = NLIST(ISYMA,ISYMAB,16)
        if (NI*NLST2 /= 0) then
          LLST2 = LLIST(ISYMA,ISYMAB,16)
          VAL2(1) = SQRI2
          VAL2(2) = One
          IX = 1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1 = 1
          INCX2 = NAS1*NI
          INCX3 = NAS1
          IDTA = 1+IOFDTA(ISYM12)
          INCF1 = 1
          INCF2 = NORB(ISYM12)
          IY = 1+NU*IOFCGP(ISYM2,ISYMI)
          INCY1 = 1
          INCY2 = NU*NI
          INCY3 = NU
          LEN1 = NI
          call MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),X2(IX:),size(X2(IX:)),DPT2(IDTA:),size(DPT2(IDTA:)),Y(IY:),size(Y(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (16)
    ! D&GM Two-el
    NLST1 = NLIST(ISYM1,ISYM2,8)
    NU = NASH(ISYM2)
    if (NLST1*NU /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,8)
      VAL1(1) = -One
      VAL1(2) = One

      do ISYMA=1,NSYM
        ISYMI = Mul(ISYMA,ISYM1)
        NI = NISH(ISYMI)
        ISYMAB = Mul(ISYMA,ISYM12)
        NLST2 = NLIST(ISYMA,ISYMAB,17)
        if (NI*NLST2 /= 0) then
          LLST2 = LLIST(ISYMA,ISYMAB,17)
          VAL2(1) = SQRI6
          VAL2(2) = -SQRI6
          IX = 1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1 = 1
          INCX2 = NAS1*NI
          INCX3 = NAS1
          IDTA = 1+IOFDTA(ISYM12)
          INCF1 = 1
          INCF2 = NORB(ISYM12)
          IY = 1+NU*IOFCGM(ISYM2,ISYMI)
          INCY1 = 1
          INCY2 = NU*NI
          INCY3 = NU
          LEN1 = NI
          call MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),X2(IX:),size(X2(IX:)),DPT2(IDTA:),size(DPT2(IDTA:)),Y(IY:),size(Y(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (17)
    ! EP&HP Two-el
    NA = NSSH(ISYM12)
    NLST1 = NLIST(ISYM12,ISYM2,16)
    if (NA*NLST1 /= 0) then
      LLST1 = LLIST(ISYM12,ISYM2,16)
      VAL1(1) = SQRI2
      VAL1(2) = One
      IX = 1+NAS1*IOFCEP(ISYM1,ISYM12)
      INCX1 = NAS1
      INCX2 = 1
      INCX3 = NAS1*NA
      IDTA = 1+IOFDTA(ISYM1)
      INCF1 = NORB(ISYM1)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NAS2
      LEN1 = NAS1
      LEN2 = NIGEJ(ISYM2)
      call MLTR1(IMLTOP,LIST(LLST1),X2(IX:),size(X2(IX:)),DPT2(IDTA:),size(DPT2(IDTA:)),Y(IY:),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (18)
    ! EM&HM Two-el
    NA = NSSH(ISYM12)
    NLST1 = NLIST(ISYM12,ISYM2,17)
    if (NA*NLST1 /= 0) then
      LLST1 = LLIST(ISYM12,ISYM2,17)
      VAL1(1) = SQRI2
      VAL1(2) = -SQRI2
      IX = 1+NAS1*IOFCEM(ISYM1,ISYM12)
      INCX1 = NAS1
      INCX2 = 1
      INCX3 = NAS1*NA
      IDTA = 1+IOFDTA(ISYM1)
      INCF1 = NORB(ISYM1)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NAS2
      LEN1 = NAS1
      LEN2 = NIGTJ(ISYM2)
      call MLTR1(IMLTOP,LIST(LLST1),X2(IX:),size(X2(IX:)),DPT2(IDTA:),size(DPT2(IDTA:)),Y(IY:),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (19)
    ! FP&GP Two-el
    NI = NISH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,9)
    if (NI*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,9)
      VAL1(1) = -SQRI2
      VAL1(2) = -SQRI2
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      IDIT = 1+IOFDIT(ISYM12)
      INCF1 = NORB(ISYM12)
      INCF2 = 1
      IY = 1+NAS2*IOFCGP(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2*NI
      INCY3 = NAS2
      LEN1 = NIS1
      LEN2 = NI
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (20)
    ! FM&GM Two-el
    NI = NISH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,10)
    if (NI*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,10)
      VAL1(1) = -SQRI6
      VAL1(2) = SQRI6
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      IDIT = 1+IOFDIT(ISYM12)
      INCF1 = NORB(ISYM12)
      INCF2 = 1
      IY = 1+NAS2*IOFCGM(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2*NI
      INCY3 = NAS2
      LEN1 = NIS1
      LEN2 = NI
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),DPT2(IDIT),size(DPT2(IDIT:)),Y(IY),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (21)
    ! GP&HP Two-el
    LLST1 = LLIST(ISYM12,ISYM2,14)
    NLST1 = NLIST(ISYM12,ISYM2,14)
    if (NLST1 /= 0) then
      VAL1(1) = -SQRI2
      VAL1(2) = -One
      IX = 1+NAS1*IOFCGP(ISYM1,ISYM12)
      INCX1 = NAS1
      INCX2 = 1
      INCX3 = NAS1*NISH(ISYM12)
      IDIT = 1+IOFDIT(ISYM1)
      INCF1 = 1
      INCF2 = NORB(ISYM1)
      IY = 1
      INCY1 = NAS2
      INCY2 = 1
      LEN1 = NAS1
      LEN2 = NAS2
      call MLTR1(IMLTOP,LIST(LLST1),X2(IX:),size(X2(IX:)),DPT2(IDIT:),size(DPT2(IDIT:)),Y(IY:),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (22)
    ! GM&HM Two-el
    LLST1 = LLIST(ISYM12,ISYM2,15)
    NLST1 = NLIST(ISYM12,ISYM2,15)
    if (NLST1 /= 0) then
      VAL1(1) = SQRI2
      VAL1(2) = -SQRI2
      IX = 1+NAS1*IOFCGM(ISYM1,ISYM12)
      INCX1 = NAS1
      INCX2 = 1
      INCX3 = NAS1*NISH(ISYM12)
      IDIT = 1+IOFDIT(ISYM1)
      INCF1 = 1
      INCF2 = NORB(ISYM1)
      IY = 1
      INCY1 = NAS2
      INCY2 = 1
      LEN1 = NAS1
      LEN2 = NAS2
      call MLTR1(IMLTOP,LIST(LLST1),X2(IX:),size(X2(IX:)),DPT2(IDIT:),size(DPT2(IDIT:)),Y(IY:),size(Y(IY:)))
    end if
    ! -----------------------------------------------
  case (23)
    ! D&HP One-el
    if (ISYM1 == 1) then
      IOXIA = 0
      do ISYMI=1,NSYM
        NI = NISH(ISYMI)
        ISYMA = ISYMI
        NA = NSSH(ISYMA)
        ISYMJ = Mul(ISYMI,ISYM2)
        NJ = NISH(ISYMJ)
        ISYMB = ISYMJ
        NB = NSSH(ISYMB)
        NLST1 = NLIST(ISYMI,ISYM2,14)
        NLST2 = NLIST(ISYMA,ISYM2,16)
        if (NI*NA*NJ*NB*NLST1*NLST2 /= 0) then
          LLST1 = LLIST(ISYMI,ISYM2,14)
          VAL1(1) = SQRI2
          VAL1(2) = One
          LLST2 = LLIST(ISYMA,ISYM2,16)
          VAL2(1) = SQRI2
          VAL2(2) = One
          IXIA = IOXIA+1
          INCX1 = 1
          INCX2 = NI
          IDJB = 1+IOFDIA(ISYMB)
          INCF1 = 1
          INCF2 = NORB(ISYMJ)
          IY = 1
          INCY1 = NAGEB(ISYM2)
          INCY2 = 1
          call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXIA),size(X1(IXIA:)),DPT2(IDJB),size(DPT2(IDJB:)),Y(IY), &
                      size(Y(IY:)))
        end if
        IOXIA = IOXIA+NI*NA
      end do
    end if
    ! ---------------------------
  case (24)
    ! D&HM One-el
    if (ISYM1 == 1) then
      IOXIA = 0
      do ISYMI=1,NSYM
        NI = NISH(ISYMI)
        ISYMA = ISYMI
        NA = NSSH(ISYMA)
        ISYMJ = Mul(ISYMI,ISYM2)
        NJ = NISH(ISYMJ)
        ISYMB = ISYMJ
        NB = NSSH(ISYMB)
        NLST1 = NLIST(ISYMI,ISYM2,15)
        NLST2 = NLIST(ISYMA,ISYM2,17)
        if (NI*NA*NJ*NB*NLST1*NLST2 /= 0) then
          LLST1 = LLIST(ISYMI,ISYM2,15)
          VAL1(1) = SQR3*Half
          VAL1(2) = -VAL1(1)
          LLST2 = LLIST(ISYMA,ISYM2,17)
          VAL2(1) = One
          VAL2(2) = -One
          IXIA = IOXIA+1
          INCX1 = 1
          INCX2 = NI
          IDJB = 1+IOFDIA(ISYMB)
          INCF1 = 1
          INCF2 = NORB(ISYMJ)
          IY = 1
          INCY1 = NAGTB(ISYM2)
          INCY2 = 1
          call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXIA),size(X1(IXIA:)),DPT2(IDJB),size(DPT2(IDJB:)),Y(IY), &
                      size(Y(IY:)))
        end if
        IOXIA = IOXIA+NI*NA
      end do
    end if
    ! ---------------------------
  case default
    write(u6,*) ' INTERNAL ERROR: OffDns reached invalid KOD=',KOD
    call Abend()
end select

end subroutine OFFDNS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine SolveforzX(zX,AXX,bX)

use Index_Functions, only: nTri_Elem
use MCLR_Data, only: ResQaaLag2
use input_mclr, only: Eps, nRoots
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: zX(nTri_Elem(nRoots-1))
real(kind=wp), intent(inout) :: AXX(nTri_Elem(nRoots-1),nTri_Elem(nRoots-1))
real(kind=wp), intent(in) :: bX(nTri_Elem(nRoots-1))
#include "warnings.h"
integer(kind=iwp) :: INFO, iPair, NDim, nScr, nSPair
real(kind=wp), allocatable :: bxscr(:), EigVal(:), Scr(:), zXscr(:)

NDim = nTri_Elem(nRoots-1)
nSPair = nDim
ResQaaLag2 = Zero
call mma_allocate(EigVal,nDim)
call mma_allocate(bxScr,nDim)
call mma_allocate(zXScr,nDim)

call GetDiagScr(nScr,AXX,EigVal,nDim)
call mma_allocate(Scr,nScr)

call DSYEV_('V','U',nDim,AXX,nDim,EigVal,Scr,nScr,INFO)

call DGEMM_('n','n',1,nDim,nDim,One,bx,1,AXX,nDim,Zero,bxScr,1)

do iPair=1,nDim
  zxScr(iPair) = -bxScr(iPair)/EigVal(iPair)
  if (abs(zxScr(iPair)) > Two*Pi) then
    zxScr(iPair) = Zero
    ResQaaLag2 = ResQaaLag2+bxScr(iPair)**2
  end if
end do

write(u6,'(6X,A37,2X,ES17.9)') 'Residual in Qaa Lagrange Multipliers:',sqrt(ResQaaLag2)
if (ResQaaLag2 > Eps**2) then
  write(u6,*)
  write(u6,'(6X,A)') 'ERROR: RESIDUAL(S) FOR INTERMEDIATE STATE TOO BIG!'
  write(u6,*)
  write(u6,'(6X,A)') 'This may come from a linear molecular or a linear'
  write(u6,'(6X,A)') 'fragment.'
  write(u6,'(6X,A)') 'CMS-PDFT Lagrange multipliers are not solved.'
  call WarningMessage(2,'Residual in Lagrange Multipliers for Qaa Too Big')
  call Quit(_RC_EXIT_EXPECTED_)
end if

call DGEMM_('n','t',1,nSPair,nSPair,One,zXScr,1,AXX,nSPair,Zero,zx,1)

call mma_deallocate(EigVal)
call mma_deallocate(bxScr)
call mma_deallocate(zXScr)
call mma_deallocate(Scr)

end subroutine SolveforzX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
*               Giovanni Ghigo                                         *
************************************************************************
      SubRoutine List(Line,Lbl,gq,mInt,nIter)
************************************************************************
*                                                                      *
* Object: to print gradient or internal coordinate lists               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             1993                                                     *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 gq(mInt,nIter)
      Character Lbl(mInt)*8, Format*72, Line*(*)
#include "print.fh"
#include "real.fh"
*
      Lu=6
*
      Write (Lu,*)
      Write (Lu,*)
      Write (Lu,*) Line
*
      MxWdth=132
      nLbl=8+1
      nRow=10
      inc = Min((MxWdth-nLbl)/nRow,nIter)
*
      Do 10 ii = 1, nIter, inc
         Write (Lu,*)
         Write(Format,'(A,I2,A)') '(A,1X,',inc,'(I5,5X))'
         Write (Lu,Format) 'Iter.   ',(i,i=ii,Min(ii+inc-1,nIter))
         Write (Lu,*)
         Write(Format,'(A,I2,A)') '(A,1X,',inc,'(F9.5,1X))'
         Do 20 igq = 1, mInt
            Write (Lu,Format) Lbl(igq),
     &            (gq(igq,i),i=ii,Min(ii+inc-1,nIter))
 20      Continue
         Write (Lu,*)
         Write (Lu,*)
 10   Continue
      Write (Lu,*)
*
      Return
      End

      SubRoutine ListU(Lu,Lbl,gq,mInt,nIter)
************************************************************************
*                                                                      *
* Object: to print last gradient or internal coordinate list           *
*                                                                      *
* Called from: RlxCtl                                                  *
*                                                                      *
*   Author: Giovanni Ghigo                                             *
*   Adapted from Lis by Roland Lindh, Dept. of Theoretical Chemistry,  *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 gq(mInt,nIter)
      Character Lbl(mInt)*8
#include "print.fh"
#include "real.fh"

      Write (Lu,*)
      Write (Lu,*) '****************************'
      Write (Lu,*) '* Value of internal forces *'
      Write (Lu,*) '----------------------------'
      Do igq = 1, mInt
         Write (Lu,'(1X,A8,1X,F9.5)') Lbl(igq),gq(igq,nIter)
      EndDo
      Write (Lu,*)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Roland Lindh                                     *
************************************************************************
      SubRoutine PXInt(
#define _CALLING_
#include "int_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of  pX integrals          *
*                                                                      *
* Called from: OneEl                                                   *
*                                                                      *
* Author: Roland Lindh, Dept. Chem. Phys., Lund University,            *
*         June 2006                                                    *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChBas
      Implicit Real*8 (A-H,O-Z)
      External NAInt, MltInt, EFInt, CntInt
#include "print.fh"
#include "property_label.fh"

#include "int_interface.fh"

*     Local variables
      Parameter (mComp=200)
      Integer kOper(mComp), kChO(mComp)
*                                                                      *
************************************************************************
*                                                                      *
*      Interface
*      Subroutine PVINT(
*#define _CALLING_
*#include "int_interface.fh"
*     &                , Kernel)
*#include "int_interface.fh"
*      External Kernel
*      End Subroutine PVINT
*      End Interface
*                                                                      *
************************************************************************
*                                                                      *
*
*                                                                      *
************************************************************************
*                                                                      *
*     nIC: number of symmetry adapted blocks in total for the nComp
*          elements of the compund operator, pX.
*     nComp: is the number of elements of the compund operator
*
*     kIC: number of symmetry adapted blocks in total for the kComp
*          elements of the operator X
*     kComp: is the number of elements of the operator X.
*                                                                      *
************************************************************************
*                                                                      *
*     Note that the p operator's each element is only a basis function
*     of a single irreducible representation. Hence, 3*kIC=nIC.
*
*     In addition if the operator X has kComp elements pX has 3*kComp
*     elements.
*                                                                      *
************************************************************************
*                                                                      *
      nRys = nHer
      kIC=nIC/3
      kComp=nComp/3
      kOrdOp = nOrdOp-1
*                                                                      *
************************************************************************
*                                                                      *
*     Now produce the kOper array with kComp elements from the lOper
*     array. Dito kChO/iChO.
*
*     lOper is an integer which bit pattern indicate to which irreps
*     the component of the operator is a basis function. Note that the
*     operator is not symmetry adapted, i.e. it can be a basis function
*     in more than one irrep.
*
*     iChO is an integer which describe the parity character of the
*     operator with respect to X, Y, and Z coordinates. For example,
*     if the first bit is set this means that the operator change sign
*     under a reflextion  in the yz-plane, etc.
*
      If (kComp.gt.mComp) Then
         Call WarningMessage(2,'PXInt: kComp.gt.mComp')
         Write (6,*) 'kComp=',kComp
         Write (6,*) 'mComp=',mComp
         Call Abend()
      End If
*
*     As we remove the p operator (three of them) X should be the same
*     regardless of if we remove d/dx, d/dy, or d/dz.
*
      iSym_p1 = IrrFnc(1)   ! d/dx
      iSym_p2 = IrrFnc(2)   ! d/dy
      iSym_p3 = IrrFnc(4)   ! d/dz
C     Write (6,*)
C     Write (6,*) 'pXInt******'
C     Write (*,*) 'iSym_p=',iSym_p1,iSym_p2,iSym_p3
      ipar_p1 = iChBas(2)
      ipar_p2 = iChBas(3)
      ipar_p3 = iChBas(4)
C     Write (6,*) 'ipar_p=',ipar_p1,ipar_p2,ipar_p3
      Do iComp = 1, kComp
         jComp1 = (iComp-1)*3 + 1
         jComp2 = (iComp-1)*3 + 2
         jComp3 = (iComp-1)*3 + 3
         iTemp1= lOper(jComp1)
         iTemp2= lOper(jComp2)
         iTemp3= lOper(jComp3)
         jpar_p1 = iChO(jComp1)
         jpar_p2 = iChO(jComp2)
         jpar_p3 = iChO(jComp3)
*
*        Look thru all irreps and check if pX is a basis function in
*        irrep iSym_pX. If so find the symmetry to which X is a basis
*        function
*
         jTemp1= 0
         jTemp2= 0
         jTemp3= 0
C        Write (6,*) 'lOper=',lOper(jComp1),lOper(jComp2),lOper(jComp3)
         Do iSym_pX = 0, nIrrep-1
            If (iAnd(2**iSym_pX,lOper(jComp1)).ne.0) Then
                iSym_X = iEOr(iSym_pX,iSym_p1)
C               Write (6,*) 'iSym_pX,iSym_X=',iSym_pX,iSym_X
                jTemp1=iOr(jTemp1,2**iSym_X)
C               Write (6,*) 'jTemp1=',jTemp1
            End If
            If (iAnd(2**iSym_pX,lOper(jComp2)).ne.0) Then
                iSym_X = iEOr(iSym_pX,iSym_p2)
C               Write (6,*) 'iSym_pX,iSym_X=',iSym_pX,iSym_X
                jTemp2=iOr(jTemp2,2**iSym_X)
C               Write (6,*) 'jTemp2=',jTemp2
            End If
            If (iAnd(2**iSym_pX,lOper(jComp3)).ne.0) Then
                iSym_X = iEOr(iSym_pX,iSym_p3)
C               Write (6,*) 'iSym_pX,iSym_X=',iSym_pX,iSym_X
                jTemp3=iOr(jTemp3,2**iSym_X)
C               Write (6,*) 'jTemp3=',jTemp3
            End If
         End Do
*
*        Check for consistency!
*
         If (jTemp1.ne.jTemp2.or.jTemp1.ne.jTemp3) Then
            Call WarningMessage(2,'PXInt: corrupted jTemps!')
            Write (6,*) 'jTemp1,jTemp2,jTemp3=',
     &                   jTemp1,jTemp2,jTemp3
            Call Abend()
         End If
*
*        Compute the parity of X
*
         jpar_p1=iEOr(jpar_p1,ipar_p1)
         jpar_p2=iEOr(jpar_p2,ipar_p2)
         jpar_p3=iEOr(jpar_p3,ipar_p3)
*
         If (jpar_p1.ne.jpar_p2.or.jpar_p1.ne.jpar_p3) Then
            Call WarningMessage(2,'PXInt: corrupted jpars!')
            Call Abend()
         End If
*
*        Store the data
*
         kOper(iComp)=jTemp1
         kChO(iComp)=jpar_p1
      End Do
*
C     Write (6,*) 'pXpInt'
C     Do iComp = 1, nComp
C        Write (6,*) lOper(iComp), iChO(iComp)
C     End Do
C     Write (6,*)
C     Do iComp = 1, kComp
C        Write (6,*) kOper(iComp), kChO(iComp)
C     End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Compute now the integrals
*
      If (PLabel.eq.'NAInt ') Then
         Call PVInt(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &              Final,nZeta,kIC,kComp,la,lb,A,RB,nRys,
     &              Array,nArr,CCoor,kOrdOp,kOper,kChO,
     &              iStabM,nStabM,
     &              PtChrg,nGrid,iAddPot,
     &              NAInt)
      Else If (PLabel.eq.'MltInt') Then
         Call PVInt(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &              Final,nZeta,kIC,kComp,la,lb,A,RB,nRys,
     &              Array,nArr,CCoor,kOrdOp,kOper,kChO,
     &              iStabM,nStabM,
     &              PtChrg,nGrid,iAddPot,
     &              MltInt)
      Else If (PLabel.eq.'EFInt ') Then
         Call PVInt(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &              Final,nZeta,kIC,kComp,la,lb,A,RB,nRys,
     &              Array,nArr,CCoor,kOrdOp,kOper,kChO,
     &              iStabM,nStabM,
     &              PtChrg,nGrid,iAddPot,
     &              EFInt)
      Else If (PLabel.eq.'CntInt') Then
         Call PVInt(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &              Final,nZeta,kIC,kComp,la,lb,A,RB,nRys,
     &              Array,nArr,CCoor,kOrdOp,kOper,kChO,
     &              iStabM,nStabM,
     &              PtChrg,nGrid,iAddPot,
     &              CntInt)
      Else
         Call WarningMessage(2,'PXInt: Illegal type!')
         Write(6,*) '       PLabel=',PLabel
         Call Abend()
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ORTHO1(S,U,V,N,M)
! Purpose: Orthonormalize N times N vector set U.
!
! Called from ORTHO.
!
! Subroutine calls: ORTHO2.
!
! ********** IBM-3090 Release 88 10 10 **********

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: S(*)
real(kind=wp), intent(inout) :: U(*), V(*)
integer(kind=iwp), intent(in) :: N, M
integer(kind=iwp) :: I, IBASE, J, JBASE
real(kind=wp) :: OVL, OVL1, XNORM
real(kind=wp), parameter :: THR = 0.2_wp
real(kind=wp), external :: DDot_

IBASE = 1

do I=1,M

  do
    call ORTHO2(S,U(IBASE),V(IBASE),N)
    ! Normalize U and calculate V=S*U.
    XNORM = ONE
    JBASE = 1
    do J=1,I-1
      OVL = DDOT_(N,U(IBASE),1,V(JBASE),1)
      OVL1 = -OVL
      U(IBASE:IBASE+N-1) = U(IBASE:IBASE+N-1)+OVL1*U(JBASE:JBASE+N-1)
      XNORM = XNORM-OVL**2
      if (XNORM >= THR) exit
      JBASE = JBASE+N
    end do
    call ORTHO2(S,U(IBASE),V(IBASE),N)
    IBASE = IBASE+N
  end do

end do

end subroutine ORTHO1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pa_prham(exch,npair,i_pair,nneq,neq,nexch,nmax,lmax,eso,HLIN1,HLIN3,HLIN9,HDIP,HKEX,HDMO,HITO,Dipol,AnisoLines1, &
                    AnisoLines3,AnisoLines9,KE,DM_Exchange,JITO_exchange)
! this function prints the exchange Hamiltonian
! it does not compute any new infromation

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero, cOne
use Definitions, only: wp, iwp, u6, CtoB

implicit none
integer(kind=iwp), intent(in) :: exch, npair, i_pair(npair,2), nneq, neq(nneq), nexch(nneq), nmax, lmax
real(kind=wp), intent(in) :: eso(nneq,nmax)
complex(kind=wp), intent(in) :: HLIN1(npair,nmax,nmax,nmax,nmax), HLIN3(npair,nmax,nmax,nmax,nmax), &
                                HLIN9(npair,nmax,nmax,nmax,nmax), HDIP(npair,nmax,nmax,nmax,nmax), &
                                HKEX(npair,nmax,nmax,nmax,nmax), HDMO(npair,nmax,nmax,nmax,nmax), HITO(npair,nmax,nmax,nmax,nmax)
logical(kind=iwp), intent(in) :: Dipol, AnisoLines1, AnisoLines3, AnisoLines9, KE, DM_exchange, JITO_exchange
integer(kind=iwp) :: i, i1, i2, ibas(exch,lmax), ibuf, icoord(lmax), intc(lmax), is1, is2, j, js1, js2, l, lb, lb1, lb2, lp, lpr, &
                     mem_local, nb, nb1, nb2, nind(lmax,2)
complex(kind=wp), allocatable :: H1(:), H2(:), H3(:), H4(:), HTOT(:)
integer(kind=iwp), external :: norder
real(kind=wp), external :: dznrm2_

!=======================================================================
if (npair == 0) then
  call WarningMessage(2,'PA_PRHAM: npair = 0')
  return
end if
if (nmax == 0) then
  call WarningMessage(2,'PA_PRHAM:  nmax = 0')
  return
end if
if (exch == 0) then
  call WarningMessage(2,'PA_PRHAM:  exch = 0')
  return
end if
if (lmax == 0) then
  call WarningMessage(2,'PA_PRHAM:  lmax = 0')
  return
end if
ibuf = npair*nmax*nmax*nmax*nmax
if (ibuf > 0) then
  if ((dznrm2_(ibuf,HLIN1,1) == Zero) .and. AnisoLines1) call WarningMessage(2,'PA_PRHAM:  HLIN1 is empty')
  if ((dznrm2_(ibuf,HLIN3,1) == Zero) .and. AnisoLines3) call WarningMessage(2,'PA_PRHAM:  HLIN3 is empty')
  if ((dznrm2_(ibuf,HLIN9,1) == Zero) .and. AnisoLines9) call WarningMessage(2,'PA_PRHAM:  HLIN9 is empty')
  if ((dznrm2_(ibuf,HDIP,1) == Zero) .and. Dipol) call WarningMessage(2,'PA_PRHAM:  HDIP is empty')
  if ((dznrm2_(ibuf,HKEX,1) == Zero) .and. KE) call WarningMessage(2,'PA_PRHAM:  HKEX is empty')
  if ((dznrm2_(ibuf,HDMO,1) == Zero) .and. DM_exchange) call WarningMessage(2,'PA_PRHAM:  HDMO is empty')
  if ((dznrm2_(ibuf,HITO,1) == Zero) .and. JITO_exchange) call WarningMessage(2,'PA_PRHAM:  HITO is empty')
end if !ibuf
!=======================================================================
! allocate memory
mem_local = 0
if (exch >= 0) then
  call mma_allocate(htot,exch,'htot')
  call mma_allocate(h1,exch,'h1')
  call mma_allocate(h2,exch,'h2')
  call mma_allocate(h3,exch,'h3')
  call mma_allocate(h4,exch,'h4')
  mem_local = mem_local+size(htot)*CtoB
  mem_local = mem_local+size(h1)*CtoB
  mem_local = mem_local+size(h2)*CtoB
  mem_local = mem_local+size(h3)*CtoB
  mem_local = mem_local+size(h4)*CtoB
end if

!do lp=1,nPair
!  write(u6,'(A,i2,A,i3)') 'i_Pair(',lp,',1)=',i_pair(lp,1)
!  write(u6,'(A,i2,A,i3)') 'i_Pair(',lp,',2)=',i_pair(lp,2)
!end do
! generate the tables:
lpr = 0
l = 0
do i=1,nneq
  do j=1,neq(i)
    l = l+1
    nind(l,1) = i
    nind(l,2) = j
  end do
end do
nind(l+1:,:) = 0
intc(1) = 1
if (lmax > 1) then
  do i=2,lmax
    i1 = nind(i-1,1)
    intc(i) = intc(i-1)*nexch(i1)
  end do
end if
do nb=1,exch
  nb1 = nb-1
  do i=1,lmax
    ibas(nb,lmax-i+1) = nb1/intc(lmax-i+1)
    nb1 = nb1-ibas(nb,lmax-i+1)*intc(lmax-i+1)
  end do
end do

write(u6,*)
write(u6,'(a)') repeat('%',100)
write(u6,'(30x,a)') 'Hamiltonian of the Total Magnetic Interaction'
write(u6,'(a)') repeat('%',100)

write(u6,'(A)') 'Only matrix elements with non-zero absolute value are listed below'

if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. KE .and. (.not. JITO_exchange)) then
  write(u6,'(6A)') '                 ','|       Lines  Model of Interaction   | ','|      Dipolar Magnetic Interaction   | ', &
                   '|      Kinetic Exchange Interaction   | ','|       TOTAL  Magnetic Interaction   | '
  lpr = 4
else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. (.not. KE) .and. (.not. JITO_exchange)) then
  write(u6,'(6A)') '                 ','|       Lines  Model of Interaction   | ','|      Dipolar Magnetic Interaction   | ', &
                   '|       TOTAL  Magnetic Interaction   | '
  lpr = 3
else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. KE .and. (.not. JITO_exchange)) then
  write(u6,'(6A)') '                 ','|       Lines  Model of Interaction   | ','|      Kinetic Exchange Interaction   | ', &
                   '|       TOTAL  Magnetic Interaction   | '
  lpr = 3
else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. Dipol .and. KE .and. (.not. JITO_exchange)) then
  write(u6,'(6A)') '                 ','|      Dipolar Magnetic Interaction   | ','|      Kinetic Exchange Interaction   | ', &
                   '|       TOTAL  Magnetic Interaction   | '
  lpr = 3
else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. (.not. KE) .and. (.not. JITO_exchange)) then
  write(u6,'(6A)') '                 ','|       Lines  Model of Interaction   | ','|       TOTAL  Magnetic Interaction   | '
  lpr = 2
else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. Dipol .and. (.not. KE) .and. (.not. JITO_exchange)) then
  write(u6,'(6A)') '                 ','|      Dipolar Magnetic Interaction   | ','|       TOTAL  Magnetic Interaction   | '
  lpr = 2
else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. (.not. Dipol) .and. KE .and. (.not. JITO_exchange)) then
  write(u6,'(6A)') '                 ','|      Kinetic Exchange Interaction   | ','|       TOTAL  Magnetic Interaction   | '
  lpr = 2
! JITO is active below:
else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. (.not. Dipol) .and. (.not. KE) .and. JITO_exchange) then
  write(u6,'(6A)') '                 ','|          ITO Exchange Interaction   | ','|       TOTAL  Magnetic Interaction   | '
  lpr = 2
else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. Dipol .and. (.not. KE) .and. JITO_exchange) then
  write(u6,'(6A)') '                 ','|      Dipolar Magnetic Interaction   | ','|          ITO Exchange Interaction   | ', &
                   '|       TOTAL  Magnetic Interaction   | '
  lpr = 3
else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. (.not. Dipol) .and. KE .and. JITO_exchange) then
  write(u6,'(6A)') '                 ','|      Kinetic Exchange Interaction   | ','|          ITO Exchange Interaction   | ', &
                   '|       TOTAL  Magnetic Interaction   | '
  lpr = 3
else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. Dipol .and. KE .and. JITO_exchange) then
  write(u6,'(6A)') '                 ','|      Dipolar Magnetic Interaction   | ','|      Kinetic Exchange Interaction   | ', &
                   '|          ITO Exchange Interaction   | ','|       TOTAL  Magnetic Interaction   | '
  lpr = 4
else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. (.not. KE) .and. JITO_exchange) then
  write(u6,'(6A)') '                 ','|       Lines  Model of Interaction   | ','|          ITO Exchange Interaction   | ', &
                   '|       TOTAL  Magnetic Interaction   | '
  lpr = 3
else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. (.not. KE) .and. JITO_exchange) then
  write(u6,'(6A)') '                 ','|       Lines  Model of Interaction   | ','|      Dipolar Magnetic Interaction   | ', &
                   '|          ITO Exchange Interaction   | ','|       TOTAL  Magnetic Interaction   | '
  lpr = 4
else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. KE .and. JITO_exchange) then
  write(u6,'(6A)') '                 ','|       Lines  Model of Interaction   | ','|      Kinetic Exchange Interaction   | ', &
                   '|          ITO Exchange Interaction   | ','|       TOTAL  Magnetic Interaction   | '
  lpr = 4
else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. KE .and. JITO_exchange) then
  write(u6,'(6A)') '                 ','|       Lines  Model of Interaction   | ','|      Dipolar Magnetic Interaction   | ', &
                   '|      Kinetic Exchange Interaction   | ','|          ITO Exchange Interaction   | ', &
                   '|       TOTAL  Magnetic Interaction   | '
  lpr = 5

end if
write(u6,'(110A)') '-----------------',('|-----  Real  ---------  Imaginary  --| ',i=1,lpr)

do nb1=1,exch
  H1(:) = cZero
  H2(:) = cZero
  H3(:) = cZero
  H4(:) = cZero
  HTOT(:) = cZero
  do lp=1,npair
    icoord(:) = ibas(nb1,:)

    lb1 = i_pair(lp,1)
    lb2 = i_pair(lp,2)
    i1 = nind(lb1,1)
    i2 = nind(lb2,1)
    is1 = icoord(lb1)+1
    is2 = icoord(lb2)+1

    do js1=1,nexch(i1)
      icoord(lb1) = js1-1
      do js2=1,nexch(i2)
        icoord(lb2) = js2-1
        nb2 = norder(icoord,intc,lmax)

        H1(nb2) = H1(nb2)+HLIN1(lp,is1,js1,is2,js2)+HLIN3(lp,is1,js1,is2,js2)+HLIN9(lp,is1,js1,is2,js2)

        H2(nb2) = H2(nb2)+HDIP(lp,is1,js1,is2,js2)

        H3(nb2) = H3(nb2)+HKEX(lp,is1,js1,is2,js2)

        H4(nb2) = H4(nb2)+HITO(lp,is1,js1,is2,js2)

        HTOT(nb2) = HTOT(nb2)+HLIN1(lp,is1,js1,is2,js2)+HLIN3(lp,is1,js1,is2,js2)+HLIN9(lp,is1,js1,is2,js2)+ &
                    HDIP(lp,is1,js1,is2,js2)+HKEX(lp,is1,js1,is2,js2)+HDMO(lp,is1,js1,is2,js2)+HITO(lp,is1,js1,is2,js2)

      end do ! js2
    end do ! js1
  end do ! lp

  if (.not. KE) then
    l = 0
    lb = 1
    do i=1,nneq
      do j=1,neq(i)
        l = l+1
        if (l == lb) then
          HTOT(nb1) = HTOT(nb1)+eso(i,ibas(nb1,lb)+1)*cOne
          if ((lb+1) <= (lmax)) lb = lb+1
        end if
      end do !j
    end do !i
  end if !.not.KE
  ! all matrices for HEXCH( Nb1, xxx) are known:
  ! proceed to print
  if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. KE) then
    do nb2=nb1,exch
      if ((abs(H1(nb2)) > Zero) .or. (abs(H2(nb2)) > Zero) .or. (abs(H3(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H1(nb2),H2(nb2),H3(nb2),HTOT(nb2)
    end do

  else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. (.not. KE)) then
    do nb2=nb1,exch
      if ((abs(H1(nb2)) > Zero) .or. (abs(H2(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H1(nb2),H2(nb2),HTOT(nb2)
    end do

  else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. KE) then
    do nb2=nb1,exch
      if ((abs(H1(nb2)) > Zero) .or. (abs(H3(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H1(nb2),H3(nb2),HTOT(nb2)
    end do

  else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. Dipol .and. KE) then
    do nb2=nb1,exch
      if ((abs(H2(nb2)) > Zero) .or. (abs(H3(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H2(nb2),H3(nb2),HTOT(nb2)
    end do

  else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. (.not. KE)) then
    do nb2=nb1,exch
      if ((abs(H1(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H1(nb2),HTOT(nb2)
    end do

  else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. Dipol .and. (.not. KE)) then
    do nb2=nb1,exch
      if ((abs(H2(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H2(nb2),HTOT(nb2)
    end do

  else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. (.not. Dipol) .and. KE) then
    do nb2=nb1,exch
      if ((abs(H3(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H3(nb2),HTOT(nb2)
    end do
  ! JITO is active below:
  else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. (.not. Dipol) .and. (.not. KE) .and. JITO_exchange) then
    do nb2=nb1,exch
      if ((abs(H4(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H4(nb2),HTOT(nb2)
    end do
  else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. Dipol .and. (.not. KE) .and. JITO_exchange) then
    do nb2=nb1,exch
      if ((abs(H2(nb2)) > Zero) .or. (abs(H4(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H2(nb2),H4(nb2),HTOT(nb2)
    end do
  else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. (.not. Dipol) .and. KE .and. JITO_exchange) then
    do nb2=nb1,exch
      if ((abs(H3(nb2)) > Zero) .or. (abs(H4(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H3(nb2),H4(nb2),HTOT(nb2)
    end do
  else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. Dipol .and. KE .and. JITO_exchange) then
    do nb2=nb1,exch
      if ((abs(H2(nb2)) > Zero) .or. (abs(H3(nb2)) > Zero) .or. (abs(H4(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H2(nb2),H3(nb2),H4(nb2),HTOT(nb2)
    end do
  else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. (.not. KE) .and. JITO_exchange) then
    do nb2=nb1,exch
      if ((abs(H1(nb2)) > Zero) .or. (abs(H4(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H1(nb2),H4(nb2),HTOT(nb2)
    end do
  else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. (.not. KE) .and. JITO_exchange) then
    do nb2=nb1,exch
      if ((abs(H1(nb2)) > Zero) .or. (abs(H2(nb2)) > Zero) .or. (abs(H4(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H1(nb2),H2(nb2),H4(nb2),HTOT(nb2)
    end do
  else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. KE .and. JITO_exchange) then
    do nb2=nb1,exch
      if ((abs(H1(nb2)) > Zero) .or. (abs(H3(nb2)) > Zero) .or. (abs(H4(nb2)) > Zero) .or. (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,4(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H1(nb2),H3(nb2),H4(nb2),HTOT(nb2)
    end do
  else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. KE .and. JITO_exchange) then
    do nb2=nb1,exch
      if ((abs(H1(nb2)) > Zero) .or. (abs(H2(nb2)) > Zero) .or. (abs(H3(nb2)) > Zero) .or. (abs(H4(nb2)) > Zero) .or. &
          (abs(HTOT(nb2)) > Zero)) &
        write(u6,'(A,i4,A,i4,A,5(2ES19.11,2x))') '<',nb1,'| H |',nb2,'> =',H1(nb2),H2(nb2),H3(nb2),H4(nb2),HTOT(nb2)
    end do
  end if

end do !nb1

write(u6,'(10A)') '-----------------',('|-------------------------------------| ',i=1,lpr)

!=======================================================================
! deallocate memory
if (exch >= 0) then
  call mma_deallocate(htot)
  call mma_deallocate(h1)
  call mma_deallocate(h2)
  call mma_deallocate(h3)
  call mma_deallocate(h4)
end if

return

end subroutine pa_prham

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine project_exch(N1,N2,S1,S2,M1,M2,E1,E2,HEXCH,Jpar,Jc)
c  this function determines the local pseuDospins and rotates the hamiltonian
c  to the local pseuDospin basis
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer N1,N2
!     spin-orbit energies on each site
      Real(kind=8) ::  E1(N1), E2(N2)
!     spin matrices on each site
      Complex(kind=8) ::  S1(3,N1,N1),S2(3,N2,N2)
!     magnetic moment matrices on each site
      Complex(kind=8) ::  M1(3,N1,N1),M2(3,N2,N2)
      Complex(kind=8) ::  HEXCH(N1,N1,N2,N2) ! exchange hamiltonian
      Complex(kind=8) ::  HEXCH2(N1,N1,N2,N2) ! exchange hamiltonian
      Complex(kind=8) ::  HEXCH3(N1,N1,N2,N2) ! exchange hamiltonian
c--  local variables --
      Integer ns1,ns2,is1,is2,iprint !,i1,j1,i2,j2
c      Integer k1,k2,q1,q2,js1,js2,ms1,ms2
      Real(kind=8) ::  Ethr,gtens(2,3), maxes(2,3,3),Jc(3,3)
      Complex(kind=8) ::  Z1(N1,N1), Z2(N2,N2)
      Complex(kind=8) ::  SR1(3,N1,N1),MR1(3,N1,N1)
      Complex(kind=8) ::  SR2(3,N2,N2),MR2(3,N2,N2)
      Complex(kind=8) ::  TMP(N1,N1)
c      Complex(kind=8) ::  DIP_O1(N1,N1)
c      Complex(kind=8) ::  DIP_W1(N1,N1)
c      Complex(kind=8) ::  DIP_O2(N2,N2)
c      Complex(kind=8) ::  DIP_W2(N2,N2)
c      Complex(kind=8) ::  SP_MOW1,SP_MOW2
c      Complex(kind=8) ::  QMAT(N1,N1,N2,N2) !,trace
c      Real(kind=8) ::  WCG ! Clebsh_Gordan Coefficeints
c      logical DBG
c      external WCG
      Complex(kind=8) ::  Jpar(N1-1,-N1+1:N1-1,N2-1,-N2+1:N2-1)
c      DBG=.false.

c      Write(6,'(A)') 'J parameters in the initial ab intio basis:'
c      Jpar=(0.0_wp,0.0_wp)
c      Call JKQPar(N1,N2,HEXCH,Jpar)
c      Jc=0.0_wp
c      Call tensor2cart(1,1,Jpar(1,-1:1,1,-1:1),Jc)


      maxes(:,:,:)=0.0_wp
      gtens(:,:)=0.0_wp
c determine the pseuDospin on each site (Z1 and Z2):
!     threshold for determination of the local pseuDospin main anisotropy axis
      Ethr=0.2_wp
      ns1=0
      ns2=0
      Do is1=1,N1
        If(E1(is1).lt.Ethr) Then
          ns1=ns1+1
        End If
      End Do
      Do is1=1,N2
        If(E2(is1).lt.Ethr) Then
          ns2=ns2+1
        End If
      End Do
      Write(6,'(A,i3)') 'size of local pseudospin, site 1  =',ns1
      Write(6,'(A,i3)') 'size of local pseudospin, site 2  =',ns2
      Call atens(  M1(1:3,1:ns1,1:ns1), ns1, gtens(1,1:3),
     &             maxes(1,1:3,1:3), 2 )
      Call atens(  M2(1:3,1:ns2,1:ns2), ns2, gtens(2,1:3),
     &             maxes(2,1:3,1:3), 2 )
c rotate the magnetic moment to the coordinate system of main magnetic axes on Ln
      SR1=(0.0_wp,0.0_wp)
      MR1=(0.0_wp,0.0_wp)
      SR2=(0.0_wp,0.0_wp)
      MR2=(0.0_wp,0.0_wp)
      Call rotmom2(   S1, N1, maxes(1,:,:), SR1 )
      Call rotmom2(   M1, N1, maxes(1,:,:), MR1 )
      Call rotmom2(   S2, N2, maxes(2,:,:), SR2 )
      Call rotmom2(   M2, N2, maxes(2,:,:), MR2 )
      Z1=(0.0_wp,0.0_wp)
      Z2=(0.0_wp,0.0_wp)
      iprint=1
      Call pseudospin(MR1,N1,Z1,3,1,iprint)
      Call pseudospin(MR2,N2,Z2,3,1,iprint)
c reWrite the exchange matrix in the basis of local pseuDospins:
      HEXCH2=(0.0_wp,0.0_wp)
      HEXCH3=(0.0_wp,0.0_wp)
      Do is1=1,N2
        Do is2=1,N2
          TMP(:,:)=(0.0_wp,0.0_wp)
          Call ZGEMM_('C','N',N1,  N1, N1, (1.0_wp,0.0_wp),
     &                Z1(1:N1,1:N1), N1,
     &                HEXCH(1:N1,1:N1,is1,is2), N1, (0.0_wp,0.0_wp),
     &                TMP(1:N1,1:N1), N1 )
          Call ZGEMM_('N','N',N1,  N1, N1, (1.0_wp,0.0_wp),
     &                TMP(1:N1,1:N1), N1,
     &                 Z1(1:N1,1:N1), N1, (0.0_wp,0.0_wp),
     &                HEXCH2(1:N1,1:N1,is1,is2), N1 )
        End Do
      End Do
      Do is1=1,N1
        Do is2=1,N1
          TMP(:,:)=(0.0_wp,0.0_wp)
          Call ZGEMM_('C','N',N2,  N2, N2, (1.0_wp,0.0_wp),
     &                Z2(1:N2,1:N2), N2,
     &                HEXCH2(is1,is2,1:N2,1:N2), N2, (0.0_wp,0.0_wp),
     &                TMP(1:N2,1:N2), N2 )
          Call ZGEMM_('N','N',N2,  N2, N2, (1.0_wp,0.0_wp),
     &                TMP(1:N2,1:N2), N2,
     &                 Z2(1:N2,1:N2), N2, (0.0_wp,0.0_wp),
     &                HEXCH3(is1,is2,1:N2,1:N2), N2 )
        End Do
      End Do
      Jpar=(0.0_wp,0.0_wp)
      Call JKQPar(N1,N2,HEXCH3,Jpar)
      Jc=0.0_wp
      Call tensor2cart(Jpar(1,-1:1,1,-1:1),Jc)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine Get_OCOF(nPrim,nBas,Work,nVec_p,OCOF)
       Implicit REAL*8 (a-h,o-z)

#include "Ocof.fh"
       DIMENSION  Work(nVec_p)

       iStdOut = 6 ! Added by EB
       iVec_p = 0
       Do i=1,nBas
          Do j=1,nPrim
             OCOF(i,j) = Work((i-1)*nPrim+j)
             iVec_p = iVec_p +1
             If (iVec_p.gt.nVec_p) Then
                Write(iStdOut,*) 'iVec_p.gt.nVec_p'
                Write(iStdOut,*) iVec_p,'.gt.',nVec_p
                Write(iStdOut,*) 'nPrim=',nPrim
                Call ABEND()
             End If
          End Do
       End Do
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine filemanager(request,lun,rc)
! request - specification of service (Input)
!           1 - open temporary file and give lun (minfiles-maxfiles)
!           2 - rewind file lun
!           3 - close file lun (and delete it if it is temporrary one)
!           4 - open file with given lun (used for fixed files 10-minfiles)
!           5 - close without deleting (for any file)
! lun     - Logical unit number (Input, Output)
! rc      - return (error) code (Output)
!
! This routine is a manager of temporary disk files, used during the calculations.
! if request=1 it finds free lun number if it is possible and open file as unformatted
! if request=2 it rewinds lun file if it is opened
! if request=3 it closes given lun file if it is opened

use ccsd_global, only: daddr, filename, filestatus, iokey, maxfiles, minfiles
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: request
integer(kind=iwp), intent(inout) :: lun
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: idum(1), ierr, nhelp, mhelp
logical(kind=iwp) :: is_error

rc = 0

if (request == 1) then

  !I open new file

  !I.1 look for lowest free lun

  mhelp = -1
  do nhelp=minfiles,maxfiles
    if (filestatus(nhelp) == 0) then
      mhelp = nhelp
      exit
    end if
  end do

  if (mhelp < 0) then
    !I.2 RC=1 : there is not enough Temporary files allowed
    rc = 1
    return
  end if

  !I.3 open file

  lun = mhelp

  if (iokey == 1) then
    ! Fortran IO
    call molcas_open_ext2(lun,filename(lun),'sequential','unformatted',ierr,.false.,1,'unknown',is_error)
    !open(unit=lun,file=filename(lun),status='unknown',form='unformatted',iostat=ierr)

  else
    ! MOLCAS IO
    call daname(lun,filename(lun))
    daddr(lun) = 0
  end if

  filestatus(lun) = 1

else if (request == 2) then

  !II rewind given file

  !II.1 test lun, if it is not too large

  if ((lun < 10) .or. (lun > maxfiles)) then
    ! RC=2 : lun is out of range
    rc = 2
    return
  end if

  !II.2 test, if lun is opened

  if (filestatus(lun) /= 1) then
    ! RC=3 : file with logical unit lun is not opened, it can't be rewined
    rc = 3
    return
  end if

  !II.3 rewind lun file

  if (iokey == 1) then
    ! Fortran IO
    rewind(lun)

  else
    ! MOLCAS IO
    nhelp = 0
    idum(1) = nhelp
    call idafile(lun,5,idum,1,daddr(lun))
  end if

else if (request == 3) then

  !III close given file + scratch if it is Temp

  !III.1 test lun, if it is not too large

  if ((lun < 10) .or. (lun > maxfiles)) then
    ! RC=4 : lun is out of range
    rc = 4
    return
  end if

  !III.2 test, if lun is opened

  if (filestatus(lun) /= 1) then
    ! RC=5 : file with logical unit lun is not opened,it can't be closed
    rc = 5
    return
  end if

  !III.3 close ; scratch file, if it was a temporarry one

  if (iokey == 1) then
    ! Fortran IO
    if (lun >= minfiles) then
      ! close and scratch
      close(lun)
      call molcas_open(lun,filename(lun))
      !open(unit=lun,file=filename(lun))
      write(lun,*) ' File scratched'
      close(lun)
      !call sqname(lun,filename'lun')
      !call sqeras(lun)
    else
      ! close only
      close(lun)
    end if

  else
    ! MOLCAS IO
    if (lun >= minfiles) then
      ! close and scratch
      call daeras(lun)
    else
      ! close only
      call daclos(lun)
    end if

  end if

  filestatus(lun) = 0

else if (request == 4) then

  !IV open file with given lun

  !IV.1 test lun, if it is not too large

  if ((lun < 10) .or. (lun > maxfiles)) then
    ! RC=6 : lun is out of range
    rc = 6
    return
  end if

  !IV.2 test if file is not already opened
  if (filestatus(lun) == 1) then
    ! RC=7 : file is already opened
    rc = 7
    return
  end if

  !IV.3 open file

  if (iokey == 1) then
    ! Fortran IO
    call molcas_open_ext2(lun,filename(lun),'sequential','unformatted',ierr,.false.,1,'unknown',is_error)
    !open(unit=lun,file=filename(lun),status='unknown',form='unformatted',iostat=ierr)

  else
    ! MOLCAS IO
    call daname(lun,filename(lun))
    daddr(lun) = 0
  end if

  filestatus(lun) = 1

else if (request == 5) then

  !V close file with given lun (without deleting)

  !V.1 test lun, if it is not too large

  if ((lun < 10) .or. (lun > maxfiles)) then
    ! RC=8 : lun is out of range
    rc = 8
    return
  end if

  !V.2 test, if lun is opened

  if (filestatus(lun) /= 1) then
    ! RC=9 : file with logical unit lun is not opened,it can't be closed
    rc = 9
    return
  end if

  !V.3 close

  if (iokey == 1) then
    ! Fortran IO
    close(lun)

  else
    ! MOLCAS IO
    call daclos(lun)
  end if

  filestatus(lun) = 0

else
  ! RC=10 : incorect value of request
  rc = 10
  return
end if

return

end subroutine filemanager

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1994, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE IEL13(MNRS1,MXRS1,MNRS3,MXRS3,NELEC,NOCTYP,
     &           IEL1,IEL3,IEL123,IACTIV)
*
* A type of strings contains NEL electrons and
*
* The number of electrons in RAS 1 is between MNRS1 AND MXRS1
* The number of electrons in RAS 3 is between MNRS3 AND MXRS3
*
* Find the number of electrons in RAS1 and RAS3 in each subtype
* and determine if subtype  is active
*
* Jeppe Olsen , Spring 1991
*               IEL123 added Jan 1994
*
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION IEL1(*),IEL3(*),IEL123(3,*),IACTIV(*)
*
      Call iCopy(NOCTYP,[0],0,IACTIV,1)
      Call iCopy(NOCTYP,[0],0,IEL1,1)
      Call iCopy(NOCTYP,[0],0,IEL3,1)
      DO 300 KEL3 = MNRS3,MXRS3
        DO 100 KEL1 = MNRS1,MXRS1
          ITYP = (MXRS1-KEL1) * (MXRS3-MNRS3+1 )
     &         + KEL3-MNRS3+1
            IEL1(ITYP) = KEL1
            IEL3(ITYP) = KEL3
*. Added
            IEL123(1,ITYP) = KEL1
            IEL123(2,ITYP) = NELEC - KEL1 - KEL3
            IEL123(3,ITYP) = KEL3
*. Added End
          IF(KEL1+KEL3.LE.NELEC) THEN
            IACTIV(ITYP) = 1
          END IF
  100   CONTINUE
  300 CONTINUE
*
      NTEST = 00
      IF(NTEST .NE. 0 ) THEN
        WRITE(6,*) ' ============== '
        WRITE(6,*) ' IEL13 speaking '
        WRITE(6,*) ' ============== '
        WRITE(6,'(A,4I3)')
     &  ' IEL1 IEL3 IACTIV for MNRS1 MXRS1 MNRS3 MXRS3 ',
     &    MNRS1,MXRS1,MNRS3,MXRS3
        DO 400 ITYP = 1, NOCTYP
          WRITE(6,'(3I3)') IEL1(ITYP),IEL3(ITYP),IACTIV(ITYP)
  400   CONTINUE
*
        WRITE(6,*) ' IEL123 matrix '
        CALL IWRTMA(IEL123,3,NOCTYP,3,NOCTYP)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Bernd Artur Hess                                 *
************************************************************************
      SUBROUTINE EVEN2(N,V,G,E,A,R,TT,AUXF,AUXG,AUXH,
     &                 W1W1,W1E0W1,EVN2)
C
C     EVEN2 - BERND HESS - V 1.0 - 5.2.86
C     CALCULATE EVEN2 OPERATORS
C
C
C     N       DIMENSION OF MATRICES
C     V       POTENTIAL MATRIX
C     G       MATRIX OF PVP OPERATOR. WILL CONTAIN EVEN2 OPERATORS
C             ON OUTPUT
C     E       RELATIVISTIC ENERGY (DIAGONAL)
C     A       A-FACTORS (DIAGONAL)
C     R       R-FACTORS (DIAGONAL)
C     TT      NONREL. KINETIC ENERGY (DIAGONAL)
C     AUXF,AUXG,AUXH  SCRATCH ARAYS
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION V(N*(N+1)/2),G(N*(N+1)/2),E(N),R(N),A(N),TT(N),
     &          AUXF(N,N),AUXG(N,N),AUXH(N,N)
      DIMENSION W1W1(N,N),W1E0W1(N,N)
      DIMENSION EVN2(N,N)
*
      M=N
      IJ=0
      DO 600 I=1,N
      DO 601 J=1,I
      IJ=IJ+1
      AUXH(I,J)=0.D0
      AUXH(J,I)=0.D0
      V(IJ)=V(IJ)/(E(I)+E(J))
      G(IJ)=G(IJ)/(E(I)+E(J))
      AUXF(I,J)=A(I)*R(I)*G(IJ)*A(J)*A(J)
      AUXF(J,I)=A(J)*R(J)*G(IJ)*A(I)*A(I)
      AUXG(I,J)=R(I)*V(IJ)*A(J)
      AUXG(J,I)=R(J)*V(IJ)*A(I)
601   CONTINUE
600   CONTINUE
C
C     ARQA ARQA
C
      CALL CPLAB(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
      IF (IE.NE.0) Call SysHalt('relint')
CCC   CALL PRSQ('AUXH   1',AUXH,N)
      IJ=0
      DO 602 I=1,N
      DO 603 J=1,I
      IJ=IJ+1
      AUXG(I,J)=-0.5D0/TT(I)*G(IJ)*A(J)*R(J)
      AUXG(J,I)=-0.5D0/TT(J)*G(IJ)*A(I)*R(I)
603   CONTINUE
602   CONTINUE
C
C     ARQA AQRA
C
      CALL CPLAB(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
CCC   CALL PRSQ('AUXH   2',AUXH,N)
      IJ=0
      DO 604 I=1,N
      DO 605 J=1,I
      IJ=IJ+1
      AUXF(I,J)=A(I)*V(IJ)*A(J)*A(J)*R(J)
      AUXF(J,I)=A(J)*V(IJ)*A(I)*A(I)*R(I)
      AUXG(I,J)=-2.D0*TT(I)*R(I)*V(IJ)*A(J)
      AUXG(J,I)=-2.D0*TT(J)*R(J)*V(IJ)*A(I)
605   CONTINUE
604   CONTINUE
C
C     AQRA ARQA
C
      CALL CPLAB(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
CCC   CALL PRSQ('AUXH   3',AUXH,N)
      IJ=0
      DO 606 I=1,N
      DO 607 J=1,I
      IJ=IJ+1
      AUXG(I,J)=G(IJ)*A(J)*R(J)
      AUXG(J,I)=G(IJ)*A(I)*R(I)
607   CONTINUE
606   CONTINUE
C
C     AQRA AQRA
C
      CALL CPLAB(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
C
C     KEEP W1*W1 FOR HIGHER-ORDER DK
C
      DO I=1,N
        DO J=1,N
          W1W1(I,J)=AUXH(I,J)
        ENDDO
      ENDDO
C
C     1/2 EW*W + 1/2 W*WE
C
      DO 610 I=1,N
      DO 611 J=1,N
      AUXH(I,J)=0.5D0*( AUXH(I,J)*E(I) + AUXH(I,J)*E(J) )
611   CONTINUE
610   CONTINUE
C
      IJ=0
      DO 400 I=1,N
      DO 401 J=1,I
      IJ=IJ+1
      AUXF(I,J)=A(I)*R(I)*G(IJ)*A(J)*E(J)*A(J)
      AUXF(J,I)=A(J)*R(J)*G(IJ)*A(I)*E(I)*A(I)
      AUXG(I,J)=R(I)*V(IJ)*A(J)
      AUXG(J,I)=R(J)*V(IJ)*A(I)
401   CONTINUE
400   CONTINUE
      CALL CPLAB(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
      IJ=0
      DO 402 I=1,N
      DO 403 J=1,I
      IJ=IJ+1
      AUXG(I,J)=-0.5D0/TT(I)*G(IJ)*A(J)*R(J)
      AUXG(J,I)=-0.5D0/TT(J)*G(IJ)*A(I)*R(I)
403   CONTINUE
402   CONTINUE
      CALL CPLAB(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
CCC   CALL PRSQ('AUXH   6',AUXH,N)
      IJ=0
      DO 404 I=1,N
      DO 405 J=1,I
      IJ=IJ+1
      AUXF(I,J)=A(I)*V(IJ)*R(J)*A(J)*E(J)*A(J)
      AUXF(J,I)=A(J)*V(IJ)*R(I)*A(I)*E(I)*A(I)
      AUXG(I,J)=-2.D0*TT(I)*R(I)*V(IJ)*A(J)
      AUXG(J,I)=-2.D0*TT(J)*R(J)*V(IJ)*A(I)
405   CONTINUE
404   CONTINUE
      CALL CPLAB(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
      IJ=0
      DO 406 I=1,N
      DO 407 J=1,I
      IJ=IJ+1
      AUXG(I,J)=G(IJ)*A(J)*R(J)
      AUXG(J,I)=G(IJ)*A(I)*R(I)
407   CONTINUE
406   CONTINUE
      CALL CPLAB(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
CCC   CALL PRSQ('AUXH   8',AUXH,N)
C
C     SYMMETRISIEREN
C
      IJ=0
      DO 430 I=1,N
      DO 431 J=1,I
      IJ=IJ+1
      G(IJ)=-0.5D0*(AUXH(I,J)+AUXH(J,I))
 431  CONTINUE
 430  CONTINUE
CCC   CALL PRM('OUTPUT  ',G,N)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_real_array(W1E0W1)
        CALL Unused_real_array(EVN2)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkorbperm_cvb()

use casvb_global, only: cvb, cvbdet, iorbprm, ipr, norb, orbs, owrk2
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: iorb, jorb
real(kind=wp) :: sgn

if (ipr(1) >= 1) then
  write(u6,'(/,a)') ' Permuting orbitals :'
  write(u6,'(1x,30i4)') iorbprm(1:norb)
end if
do iorb=1,norb
  jorb = abs(iorbprm(iorb))
  sgn = real(sign(1,iorbprm(iorb)),kind=wp)
  owrk2(:,iorb) = orbs(:,jorb)
  owrk2(:,iorb) = sgn*owrk2(:,iorb)
end do
orbs(:,:) = owrk2(:,:)
call str2vbc_cvb(cvb,cvbdet)
call permvb_cvb(cvbdet,iorbprm)
call vb2strc_cvb(cvbdet,cvb)

return

end subroutine mkorbperm_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

subroutine Get_Info_Static()
!***********************************************************************
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January 1992                                             *
!***********************************************************************

use Symmetry_Info, only: Symmetry_Info_Get
use Sizes_of_Seward, only: Size_Get
use DKH_Info, only: DKH_Info_Get
use Gateway_Info, only: Gateway_Info_Get
use RICD_Info, only: RICD_Info_Get
use NQ_Info, only: NQ_Info_Get
use External_Centers, only: External_Centers_Get

implicit none

call Symmetry_Info_Get()
call Size_Get()
call DKH_Info_Get()
call Gateway_Info_Get()
call RICD_Info_Get()
call NQ_Info_Get()
call External_Centers_Get()

return

end subroutine Get_Info_Static

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_Setup(irc,EOcc,EVir)
!
! Jonas Bostrom, Feb 2010
!
! Purpose: Do some additional setup only needed for
!          MP2-gradients or properties.

use Symmetry_Info, only: Mul
use Cholesky, only: nBas, nSym
use ChoMP2, only: AdrR1, AdrR2, ChoMP2g_Allocated, EFrozT, EOccuT, EVirtT, iAdrOff, iAoMo, iDel, iFro, iMoAo, iMoMo, iOcc, iVir, &
                  MP2D, MP2D_e, MP2D_e_full, MP2D_full, MP2W, MP2W_e, MP2W_e_full, MP2W_full, nAoMo, nDel, nFro, nFroT, nMo, &
                  nMoAo, nMoMo, nMoType, nOcc, nOccT, nOccVirt, nOrb, nVir, nVirT
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: EOcc(*), EVir(*)
integer(kind=iwp) :: iE, iMOType, iProdType, iS, iSym, iSymAl, iSymP, iSymQ, jMoType, lDens, lDens_e, nb

nMOType = 3
call ChoMP2_GetInf(nOrb,nOcc,nFro,nDel,nVir)

! Initialize an  offset for writing choleskyvectors to disk
iAdrOff(1:nSym,1:nMoType**2) = 0

nOccVirT = sum(nOcc(1:nSym)*nVir(1:nSym))

nMO(1:nSym,1) = nFro(1:nSym)
nMO(1:nSym,2) = nOcc(1:nSym)
nMO(1:nSym,3) = nVir(1:nSym)

do iMoType=1,nMoType
  do jMoType=1,nMoType
    iProdType = jMOType+(iMOType-1)*nMOType
    do iSym=1,nSym
      nMoMo(iSym,iProdType) = 0
      do iSymP=1,nSym
        iSymQ = Mul(iSymP,iSym)
        iMoMo(iSymq,iSymp,iProdType) = nMoMo(iSym,iProdType)
        nMoMo(iSym,iProdType) = nMoMo(iSym,iProdType)+nMO(iSymP,iMOType)*nMO(iSymQ,jMOType)
      end do
    end do
  end do
end do
do iMoType=1,nMoType
  do iSym=1,nSym
    nMoAo(iSym,iMoType) = 0
    do iSymAl=1,nSym
      iSymP = Mul(iSymAl,iSym)
      iMoAo(iSymP,iSymAl,iMoType) = nMoAo(iSym,iMoType)
      nMoAo(iSym,iMoType) = nMoAo(iSym,iMoType)+nBas(iSymAl)*nMO(iSymP,iMoType)
    end do
  end do
end do
do iMoType=1,nMoType
  do iSym=1,nSym
    nAoMo(iSym,iMoType) = 0
    do iSymQ=1,nSym
      iSymAl = Mul(iSymQ,iSym)
      iAoMo(iSymAl,iSymQ,iMoType) = nAoMo(iSym,iMoType)
      nAoMo(iSym,iMoType) = nAoMo(iSym,iMoType)+nBas(iSymAl)*nMO(iSymQ,iMoType)
    end do
  end do
end do

! Allocate MP2_density
! --------------------

lDens = sum(nOrb(1:nSym)*nOrb(1:nSym))

ChoMP2g_Allocated = .true.

call mma_allocate(MP2D_full,lDens,Label='MP2D_full')
call mma_allocate(MP2W_full,lDens,Label='MP2W_full')
MP2D_full(:) = Zero
MP2W_full(:) = Zero

iE = 0
do iSym=1,nSym
  nb = nOrb(iSym)
  iS = iE+1
  iE = iE+nb**2
  MP2D(iSym)%A(1:nb,1:nb) => MP2D_full(iS:iE)
  MP2W(iSym)%A(1:nb,1:nb) => MP2W_full(iS:iE)
end do

! Allocate extended MP2_density (with deleted orbitals)
! -----------------------------------------------------

lDens_e = sum((nOrb(1:nSym)+nDel(1:nSym))*(nOrb(1:nSym)+nDel(1:nSym)))

call mma_allocate(MP2D_e_full,lDens_e,Label='MP2D_e_full')
call mma_allocate(MP2W_e_full,lDens_e,Label='MP2W_e_full')
MP2D_e_full(:) = Zero
MP2W_e_full(:) = Zero

iE = 0
do iSym=1,nSym
  nb = nOrb(iSym)+nDel(iSym)
  iS = iE+1
  iE = iE+nb**2
  MP2D_e(iSym)%A(1:nb,1:nb) => MP2D_e_full(iS:iE)
  MP2W_e(iSym)%A(1:nb,1:nb) => MP2W_e_full(iS:iE)
end do

! Allocate address-field for reordered R-vectors
! ----------------------------------------------
call mma_allocate(AdrR1,nSym,nSym,nOccT,Label='AdrR1')
call mma_allocate(AdrR2,nSym,nSym,nVirT,Label='AdrR2')

! Allocate a vector for the orbital energies of frozen and virtual
! frozen molecules.
call mma_allocate(EFrozT,max(1,nFroT),Label='EFrozT')
call mma_allocate(EOccuT,max(1,nOccT),Label='EOccuT')
call mma_allocate(EVirtT,max(1,nVirT),Label='EVirtT')
! Fill them with the right things
do iSym=1,nSym
  EFrozT(iFro(iSym)+1:iFro(iSym)+nFro(iSym)) = EOcc(iFro(iSym)+nOccT+1:iFro(iSym)+nOccT+nFro(iSym))
  EOccuT(iOcc(iSym)+1:iOcc(iSym)+nOcc(iSym)) = EOcc(iOcc(iSym)+1:iOcc(iSym)+nOcc(iSym))
  EVirtT(iVir(iSym)+1:iVir(iSym)+nVir(iSym)) = EVir(iVir(iSym)+iDel(iSym)+1:iVir(iSym)+iDel(iSym)+nVir(iSym))
end do

irc = 0

end subroutine ChoMP2g_Setup

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Here we construct the density matrix given the orbital coefficients.
subroutine DENSI_MO(DENS,ORBCO,IS,IA,NBAS,IDM)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, Two, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IS, IA, NBAS, IDM
real(kind=wp), intent(out) :: DENS(nTri_Elem(NBAS))
real(kind=wp), intent(in) :: ORBCO(IDM,*)
integer(kind=iwp) :: I, IJ, J, K

DENS(:) = Zero
do I=IS,IS+IA-1
  IJ = 0
  do J=1,NBAS
    do K=1,J
      IJ = IJ+1
      DENS(IJ) = DENS(IJ)+Four*ORBCO(J,I)*ORBCO(K,I)
    end do
    DENS(IJ) = DENS(IJ)-ORBCO(J,I)*ORBCO(J,I)*Two
  end do
end do

return

end subroutine DENSI_MO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Per-Olof Widmark                                 *
!               1993, Markus P. Fuelscher                              *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine RdMCK(rc,Option,InLab,iComp,iData,iSymLab)
!***********************************************************************
!                                                                      *
!     Purpose: Read data from one-electron integral file               *
!                                                                      *
!     Calling parameters:                                              *
!     rc      : Return code                                            *
!     Option  : Switch to set options                                  *
!     InLab   : Identifier for the data to read                        *
!     Comp    : Composite identifier to select components              *
!     iData   : contains on output the requested data                  *
!     SymLab  : symmetry label of the requested data                   *
!                                                                      *
!     Local data declarations:                                         *
!     Label   : character(len=8), used to covert incoming names        *
!     HldBuf  : I/O buffer                                             *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark and M.P. Fuelscher                                  *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!     Modified by:                                                     *
!     Anders Bernhardsson                                              *
!     University of Lund, Sweden, 1995                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use MckDat, only: AuxMck, LenOp, MxOp, NaN, nBuf, nTitle, oAddr, oComp, oLabel, oSymLb, pASh, pBas, pChdisp, pdegdisp, pldisp, &
                  pndisp, pnrdisp, pOp, pPert, pSym, pSymOp, ptdisp, pTitle, rcMck, sLength, sDbg, sOpSiz, sRdCur, sRdFst, sRdNxt, &
                  TmpBuf, TocMck
use Definitions, only: iwp, u6, RtoI, ItoB

#include "intent.fh"

implicit none
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp), intent(in) :: Option, iComp, iSymLab
character(len=*), intent(inout) :: InLab
integer(kind=iwp), intent(_OUT_) :: iData(*)
integer(kind=iwp) :: CmpTmp, Comp, CurrOp = 1, i, iBas, icpi, iDisk, idx, iIrr, ij, ijS, iLen, IndDta, iS, iSym, iTmp, j, jBas, &
                     jS, k, Len_, Length, LuMck, na, SymLab, tBuf, TmpCmp
logical(kind=iwp) :: Debug, NoGo, NoOpSiz
character(len=*), parameter :: TheName = 'RdMck'
character(len=8) :: TmpLab, Label

!----------------------------------------------------------------------*
! Start procedure:                                                     *
! Pick up the file definitions                                         *
!----------------------------------------------------------------------*
icpi = ItoB
Len_ = rc
rc = rcMck%good
LuMck = AuxMck%Lu
!----------------------------------------------------------------------*
! Check the file status                                                *
!----------------------------------------------------------------------*
if (.not. AuxMck%Opn) call SysFileMsg(TheName,'MSG: open',LuMck,' ')
!----------------------------------------------------------------------*
! Truncate the label to 8 characters and convert it to upper case      *
!----------------------------------------------------------------------*
!call StdFmt(InLab,Label)
Label = InLab
call UpCase(Label)
TmpLab = Label
iLen = len(TmpLab)/ItoB
Comp = icomp
Symlab = isymlab
if ((label == 'STATHESS') .or. (label == 'RESPHESS') .or. (label == 'CONNHESS') .or. (label == 'HESS') .or. &
    (label == 'NUCGRAD') .or. (label == 'TWOGRAD')) then
  Comp = 1
  Symlab = 1
end if
!----------------------------------------------------------------------*
! Print debugging information                                          *
!----------------------------------------------------------------------*
Debug = btest(option,sDbg)
if (Debug) then
  write(u6,*) '<<< Entering RdMck  >>>'
  write(u6,'(a,z8)') ' rc on entry:     ',rc
  write(u6,'(a,a)') ' Label on entry:  ',Label
  write(u6,'(a,z8)') ' Comp on entry:   ',Comp
  write(u6,'(a,z8)') ' SymLab on entry: ',SymLab
  write(u6,'(a,z8)') ' Option on entry: ',Option
end if
!----------------------------------------------------------------------*
! Check reading mode                                                   *
!----------------------------------------------------------------------*
if (btest(option,sRdFst) .and. btest(option,sRdNxt)) then
  call SysWarnMsg(TheName,'Invalid value','sRdFst and sRdNxt')
else if (btest(option,sRdFst) .and. btest(option,sRdCur)) then
  call SysWarnMsg(TheName,'Invalid value','sRdFst and sRdNxt')
else if (btest(option,sRdNxt) .and. btest(option,sRdCur)) then
  call SysWarnMsg(TheName,'Invalid value','sRdNxt and sRdCur')
end if
!----------------------------------------------------------------------*
! Read data from ToC                                                   *
!----------------------------------------------------------------------*
NoOpSiz = .not. btest(option,sOpSiz)
NoGo = .not. (btest(option,sRdFst) .or. btest(option,sRdNxt) .or. btest(option,sRdCur))
if ((Label == 'TITLE') .and. NoGo) then
  if (TocMck(pTitle) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  if (NoOpSiz) then
    iData(1:nTitle) = TocMck(pTitle+1:pTitle+nTitle)
    if (debug) then
      write(u6,'(a,z8)') ' Reading Title:'
      write(u6,'(8(1x,z8))') iData(1:nTitle)
    end if
  else
    iData(1) = nTitle
    if (debug) write(u6,'(a,z8)') ' Reading Title:',iData(1)
  end if
else if ((Label == 'CHDISP') .and. NoGo) then
  if (TocMck(pCHDISP) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  if (NoOpSiz) then
    Length = TocMck(pnDisp)*30/icpi+1
    iData(1:Length) = TocMck(pchdisp:pchdisp+Length-1)
    if (debug) then
      write(u6,'(a,z8)') ' Reading perturbations:'
      write(u6,'(8(1x,z8))') iData(1:Length)
    end if
  else
    iData(1) = TocMck(pnDisp)*30/icpi+1
    if (debug) write(u6,'(a,z8)') ' Reading perturbations:',iData(1)
  end if
else if ((Label == 'NDISP') .and. NoGo) then
  if (TocMck(pndisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  if (NoOpSiz) then
    iData(1) = TocMck(pndisp)
  else
    iData(1) = 1
  end if
  if (debug) write(u6,'(a,z8)') ' Reading nSym: ',iData(1)
else if ((Label == 'NSYM') .and. NoGo) then
  if (TocMck(pSym) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  if (NoOpSiz) then
    iData(1) = TocMck(pSym)
  else
    iData(1) = 1
  end if
  if (debug) write(u6,'(a,z8)') ' Reading nSym: ',iData(1)
else if ((Label == 'NBAS') .and. NoGo) then
  if (TocMck(pBas) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  if (NoOpSiz) then
    Length = TocMck(pSym)
    iData(1:Length) = TocMck(pBas:pBas+Length-1)
    if (debug) write(u6,'(a,8z8)') ' Reading nBas: ',iData(1:Length)
  else
    iData(1) = TocMck(pSym)
    if (debug) write(u6,'(a,z8)') ' Reading nBas: ',iData(1)
  end if
else if ((Label == 'LDISP') .and. NoGo) then
  if (TocMck(pldisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  if (NoOpSiz) then
    Length = TocMck(psym)
    iData(1:Length) = TocMck(pldisp:pldisp+Length-1)
    if (debug) write(u6,'(a,8z8)') ' Reading ldisp: ',iData(1:Length)
  else
    iData(1) = TocMck(pSym)
    if (debug) write(u6,'(a,z8)') ' Reading ldisp: ',iData(1)
  end if
else if ((Label == 'TDISP') .and. NoGo) then
  if (TocMck(ptdisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  if (NoOpSiz) then
    Length = TocMck(pndisp)
    iData(1:Length) = TocMck(ptdisp:ptdisp+Length-1)
    if (debug) write(u6,'(a,8z8)') ' Reading nBas: ',iData(1:Length)
  else
    iData(1) = TocMck(pSym)
    if (debug) write(u6,'(a,z8)') ' Reading nBas: ',iData(1)
  end if
else if ((Label == 'NASH') .and. NoGo) then
  if (TocMck(pASH) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  if (NoOpSiz) then
    Length = TocMck(pSYM)
    iData(1:Length) = TocMck(pASH:pASH+length-1)
    if (debug) write(u6,'(a,8z8)') ' Reading nASH: ',iData(1:Length)
  else
    iData(1) = TocMck(pSym)
    if (debug) write(u6,'(a,z8)') ' Reading nASH: ',iData(1)
  end if
else if (label == 'PERT') then
  Length = 16/icpi
  iData(1:Length) = TocMck(pPert:pPert+Length-1)
else if (label == 'NRCTDISP') then
  if (TocMck(pndisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pndisp)
  iData(1:Length) = TocMck(pnrdisp:pnrdisp+Length-1)
else if ((Label == 'SYMOP') .and. NoGo) then
  if (TocMck(pSym) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  if (NoOpSiz) then
    !Length = (3*TocMck(pSym)-1)/icpi+1
    Length = (3*TocMck(pSym)+ItoB-1)/ItoB
    iData(1:Length) = TocMck(pSymOp:pSymOp+Length-1)
    if (debug) then
      write(u6,'(a)') ' Reading symmetry operators:'
      write(u6,'(8(1x,z8))') iData(1:Length)
    end if
  else
    iData(1) = TocMck(pSym)
    if (debug) write(u6,'(a,z8)') ' Reading symmetry operators:',iData(1)
  end if
else if (label == 'DEGDISP ') then
  if (TocMck(pndisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pndisp)
  iData(1:Length) = TocMck(pdegdisp:pdegdisp+Length-1)
else
!----------------------------------------------------------------------*
! Read operators from integral records                                 *
!----------------------------------------------------------------------*
  if (btest(option,sRdNxt)) then
    if (debug) write(u6,'(a)') ' Reading next item'
    CurrOp = CurrOp+1
    if (CurrOp > MxOp) then
      CurrOp = 0
    else if (TocMck(pOp+LenOp*(CurrOp-1)+oLabel) == Nan) then
      CurrOp = 0
    else
      i = CurrOp
      !LabTmp(1) = TocMck(pOp+LenOp*(i-1)+oLabel)
      !#ifndef _I8_
      !LabTmp(2) = TocMck(pOp+LenOp*(i-1)+oLabel+1)
      !#endif
      idx = pOp+LenOp*(i-1)+oLabel
      TmpLab = transfer(TocMck(idx:idx+iLen-1),TmpLab)
      Label = TmpLab
      InLab = Label
      SymLab = TocMck(pOp+LenOp*(i-1)+oSymLb)
      Comp = TocMck(pOp+LenOp*(i-1)+oComp)
    end if
  else if (btest(option,sRdFst)) then
    if (debug) write(u6,'(a)') ' Reading first item'
    CurrOp = 1
    if (TocMck(pOp+LenOp*(CurrOp-1)+oLabel) == NaN) then
      CurrOp = 0
    else
      i = CurrOp
      !LabTmp(1) = TocMck(pOp+LenOp*(i-1)+oLabel)
      !#ifndef _I8_
      !LabTmp(2) = TocMck(pOp+LenOp*(i-1)+oLabel+1)
      !#endif
      idx = pOp+LenOp*(i-1)+oLabel
      TmpLab = transfer(TocMck(idx:idx+iLen-1),TmpLab)
      Label = TmpLab
      InLab = Label
      SymLab = TocMck(pOp+LenOp*(i-1)+oSymLb)
      Comp = TocMck(pOp+LenOp*(i-1)+oComp)
    end if
  else if (btest(option,sRdCur)) then
    if (debug) write(u6,'(a)') ' Reading current item'
    if ((CurrOp < 1) .or. (CurrOp > MxOp)) then
      CurrOp = 0
    else if (TocMck(pOp+LenOp*(CurrOp-1)+oLabel) == NaN) then
      CurrOp = 0
    else
      i = CurrOp
      !LabTmp(1) = TocMck(pOp+LenOp*(i-1)+oLabel)
      !#ifndef _I8_
      !LabTmp(2) = TocMck(pOp+LenOp*(i-1)+oLabel+1)
      !#endif
      idx = pOp+LenOp*(i-1)+oLabel
      TmpLab = transfer(TocMck(idx:idx+iLen-1),TmpLab)
      Label = TmpLab
      InLab = Label
      SymLab = TocMck(pOp+LenOp*(i-1)+oSymLb)
      Comp = TocMck(pOp+LenOp*(i-1)+oComp)
    end if
  else
    CurrOp = 0
    do i=MxOp,1,-1
      !LabTmp(1) = TocMck(pOp+LenOp*(i-1)+oLabel)
      !#ifndef _I8_
      !LabTmp(2) = TocMck(pOp+LenOp*(i-1)+oLabel+1)
      !#endif
      idx = pOp+LenOp*(i-1)+oLabel
      TmpLab = transfer(TocMck(idx:idx+iLen-1),TmpLab)
      CmpTmp = TocMck(pOp+LenOp*(i-1)+oComp)
      TmpCmp = Comp
      if ((TmpLab == Label) .and. (CmpTmp == TmpCmp)) CurrOp = i
    end do
  end if
  if (CurrOp == 0) call SysAbendMsg(TheName,'Current Operation == 0',' ')
  SymLab = TocMck(pOp+LenOp*(CurrOp-1)+oSymLb)
  if (Label == 'MOPERT') then
    iTmp = SymLab
    do iIrr=1,TocMck(pSym)
      iTmp = iTmp/2
    end do
    na = 0
    do i=0,TocMck(psym)-1
      na = TocMck(pAsh+i)+na
    end do
    Length = nTri_Elem(na)
    Length = nTri_Elem(Length)
  else if (label == 'NUCGRAD') then
    Comp = 1
    SymLab = 1
    if (TocMck(pldisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
    Length = TocMck(pldisp)
  else if (label == 'TWOGRAD') then
    Comp = 1
    SymLab = 1
    if (TocMck(pldisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
    Length = TocMck(pldisp)
  else if ((label == 'STATHESS') .or. (label == 'RESPHESS') .or. (label == 'CONNHESS') .or. (label == 'HESS')) then
    Comp = 1
    SymLab = 1
    if (TocMck(pndisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
    Length = 0
    do iSym=0,TocMck(pSym)-1
      Length = Length+nTri_Elem(TocMck(pldisp+isym))
    end do
  else if (label == 'INACTIVE') then
    Length = 0
    do iS=1,TocMck(pSym)
      do jS=1,TocMck(pSym)
        ijS = Mul(iS,jS)-1
        if (btest(SymLab,ijS)) then
          jBas = TocMck(pbas+jS-1)
          iBas = TocMck(pbas+iS-1)
          if (jBas == NaN) call SysAbendMsg(TheName,'jBas == NaN at label',Label)
          if (iBas == NaN) call SysAbendMsg(TheName,'iBas == NaN at label',Label)
          Length = Length+iBas*jBas
        end if
      end do
    end do
  else if (label == 'TOTAL') then
    Length = 0
    do iS=1,TocMck(pSym)
      do jS=1,TocMck(pSym)
        ijS = Mul(iS,jS)-1
        if (btest(SymLab,ijS)) then
          jBas = TocMck(pbas+jS-1)
          iBas = TocMck(pbas+iS-1)
          if (jBas == NaN) call SysAbendMsg(TheName,'jBas == NaN at label',Label)
          if (iBas == NaN) call SysAbendMsg(TheName,'iBas == NaN at label',Label)
          Length = Length+iBas*jBas
        end if
      end do
    end do
  else
    Length = 0
    do i=1,TocMck(pSym)
      do j=1,i
        ij = Mul(i,j)-1
        if (btest(SymLab,ij)) then
          if (i == j) then
            Length = Length+nTri_Elem(TocMck(pBas-1+i))
          else
            Length = Length+TocMck(pBas-1+i)*TocMck(pBas-1+j)
          end if
        end if
      end do
    end do
    if (btest(Option,sLength)) Length = Len_
  end if

  iData(1) = Length
  if (NoOpSiz) then
    Length = RtoI*Length
    IndDta = 1
    !IndHld = 1
    iDisk = TocMck(pOp+LenOp*(CurrOp-1)+oAddr)
    do k=0,Length-1,nBuf
      tBuf = max(0,min(nBuf,Length-k))
      call iDaFile(LuMCK,2,TmpBuf,tBuf,iDisk)
      iData(IndDta:IndDta+tBuf-1) = TmpBuf(1:tBuf)
      if (debug) then
        write(u6,'(a,z8)') ' Reading buffer to: ',IndDta
        write(u6,'(8(1x,z8))') iData(IndDta:IndDta+tBuf-1)
      end if
      IndDta = IndDta+tBuf
      !if (tBuf < iBuf) then
      !  eBuf = iBuf-tBuf
      !  !HldBuf(IndHld:IndHld+eBuf-1) = TmpBuf(IndTmp:IndTmp+eBuf-1)
      !  IndTmp = IndTmp+eBuf
      !  !IndHld = IndHld+eBuf
      !end if
    end do
    !if (.not. btest(option,sNoOri)) then
    !  iData(IndDta:IndDta+5) = HldBuf(1:6)
    !  if (debug) then
    !    write(u6,'(a,z8)') ' Reading buffer to: ',IndDta
    !    write(u6,'(8(1x,z8))') iData(IndDta:IndDta+5)
    !  end if
    !end if
    !IndDta = IndDta+6
    !if (.not. btest(option,sNoNuc)) then
    !  iData(IndDta:IndDta+1) = HldBuf(7:8)
    !  if (debug) then
    !    write(u6,'(a,z8)') ' Reading buffer to: ',IndDta
    !    write(u6,'(8(1x,z8))') iData(IndDta:IndDta+1)
    !  end if
    !end if
    !IndDta = IndDta+2
  end if
end if
!----------------------------------------------------------------------*
! Print debugging information                                          *
!----------------------------------------------------------------------*
if (Debug) then
  write(u6,*) '<<< Exiting RdMck >>>'
  write(u6,'(a,z8)') ' rc on exit:     ',rc
  write(u6,'(a,a)') ' Label on exit:  ',Label
  write(u6,'(a,z8)') ' Comp on exit:    ',Comp
  write(u6,'(a,z8)') ' SymLab on exit: ',SymLab
  write(u6,'(a,z8)') ' Option on exit: ',Option
end if

!----------------------------------------------------------------------*
! Terminate procedure                                                  *
!----------------------------------------------------------------------*
return

end subroutine RdMCK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine elmem( &
#                define _CALLING_
#                include "mem_interface.fh"
                )

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"

nHer = (la+lb+lr+3)/2
Mem = 3*nHer*(la+2)+3*nHer*(lb+2)+3*nHer*(lr+1)+3*(la+2)*(lb+2)*(lr+1)+2+nTri_Elem1(la)*nTri_Elem1(lb)*4*6+2+3*nHer

return

end subroutine elmem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE EPSPRIM(JSY,INDEX,C,S,EPP)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      DIMENSION JSY(*),INDEX(*),C(*),S(*),EPP(*)
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CRL   JSYM(L)=IAND(ISHFT(JSY((L+19)/20),-3*((L+19)/20*20-L)),7)+1
CPAM96      JSYM(L)=UNPACK(JSY((L+9)/10),3*MOD(L-1,10)+1,3)+1
      JSYM(L)=JSUNP_CPF(JSY,L)
C
C     VALENCE
C
      IP=IRC(1)
      DO 15 I=1,IP
      EPP(I)=EPP(I)+C(I)*S(I)
15    CONTINUE
C
C
C     SINGLES
C
      IP=IRC(2)-IRC(1)
      IN=IRC(1)
      DO 5 I=1,IP
      NS1=JSYM(IN+I)
      NSIL=MUL(NS1,LSYM)
      INUM=NVIR(NSIL)
      IST=INDEX(IN+I)+1
CRL   CALL DOTPR(C(IST),1,S(IST),1,T,INUM)
      T=DDOT_(INUM,C(IST),1,S(IST),1)
      EPP(IN+I)=EPP(IN+I)+T
5     CONTINUE
C
C     DOUBLES
C
      IP=IRC(4)-IRC(2)
      IN=IRC(2)
      DO 10 I=1,IP
      NS1=JSYM(IN+I)
      NSIL=MUL(NS1,LSYM)
      INUM=NNS(NSIL)
      IST=INDEX(IN+I)+1
CRL   CALL DOTPR(C(IST),1,S(IST),1,T,INUM)
      T=DDOT_(INUM,C(IST),1,S(IST),1)
      EPP(IN+I)=EPP(IN+I)+T
10    CONTINUE
C
      IP=IRC(4)
      IF(IPRINT.GT.5)WRITE(6,998)(EPP(I),I=1,IP)
998   FORMAT(6X,'EPP ',5F10.6)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SECEQ(A,B,C,NAL,IFT,FAC)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NAL, IFT
real(kind=wp), intent(in) :: A(NAL,NAL), B(NAL,NAL), FAC
real(kind=wp), intent(out) :: C((NAL*(NAL+1))/2)
integer(kind=iwp) :: IAB, NA, NB

if (IFT == 0) then
  IAB = 0
  do NA=1,NAL
    do NB=1,NA-1
      IAB = IAB+1
      C(IAB) = B(NB,NA)+A(NA,NB)
    end do
    IAB = IAB+1
    C(IAB) = FAC*A(NA,NA)
  end do
else
  IAB = 0
  do NA=1,NAL
    do NB=1,NA-1
      IAB = IAB+1
      C(IAB) = B(NB,NA)-A(NA,NB)
    end do
    IAB = IAB+1
    C(IAB) = Zero
  end do
end if

return

end subroutine SECEQ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Giovanni Ghigo                                         *
!***********************************************************************

subroutine Rd_UDIC_RowH(nInter,nRowH,mRowH)
!***********************************************************************
!                                                                      *
! Object: Reading the Internal Coordinates required for Numerical      *
!         estimation of single rows and columns of Hessian             *
! Called from: PrePro when nRowH > 0                                   *
! Author: Giovanni Ghigo, University of Torino, Italy                  *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nInter, nRowH
integer(kind=iwp), intent(out) :: mRowH(nRowH)
integer(kind=iwp) :: iLines, iRowH, j, kLines, Lu_UDIC
character(len=120) :: Temp
character(len=16) :: filnam
character(len=8) :: cLbl
character(len=8), allocatable :: Labels(:)
integer(kind=iwp), external :: IsFreeUnit

Lu_UDIC = IsFreeUnit(91)
filnam = 'UDIC'
call molcas_open(Lu_UDIC,filnam)
rewind(Lu_UDIC)
mRowH(:) = 0

! Find begining of definitions of internal coordinates

call mma_allocate(Labels,nInter,Label='Labels')

do
  read(Lu_UDIC,'(A)') Temp
  call UpCase(Temp)
  if (Temp(1:4) == 'VARY') exit
end do
do iLines=1,nInter
  do
    read(Lu_UDIC,'(A)') Temp
    call UpCase(Temp)
    if (Temp(1:3) /= 'FIX') exit
  end do
  cLbl = '        '
  do j=1,120
    if (Temp(j:j) == ' ') exit
    cLbl(j:j) = Temp(j:j)
  end do
  Labels(iLines) = cLbl
  do
    if (index(Temp,'&') == 0) exit
    read(Lu_UDIC,'(A)') Temp
  end do
end do

read(Lu_UDIC,'(A)') Temp ! Skip ROWH
outer: do iRowH=1,nRowH
  read(Lu_UDIC,'(A)') Temp
  call UpCase(Temp)
  cLbl(1:8) = Temp(1:8)
  do kLines=1,nInter
    if (cLbl == Labels(kLines)) then
      mRowH(iRowH) = kLines
      cycle outer
    end if
  end do
  call WarningMessage(2,'Error in rd_udic')
  write(u6,*) '**********************************************'
  write(u6,*) ' ERROR: Undefined internal ROWH coordinate in '
  write(u6,*) ' ',Temp(1:60)
  write(u6,*) '**********************************************'
  call Quit_OnUserError()
end do outer
close(Lu_UDIC)

call mma_deallocate(Labels)

return

end subroutine Rd_UDIC_RowH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Roland Lindh                                     *
************************************************************************
      Subroutine Setup_NQ(Maps2p,nShell,nSym,nNQ,Do_Grad,On_Top,nD,
     &                    Pck_Old,PMode_old,R_Min,nR_Min)
************************************************************************
*                                                                      *
* Object: to set up information for calculation of integrals via a     *
*         numerical quadrature.                                        *
* Warning: The exponents of each shell are reordered diffuse to compact*
*                                                                      *
*     Author: Roland Lindh,                                            *
*             Dept of Chemical Physics,                                *
*             University of Lund, Sweden                               *
*             August 1999                                              *
************************************************************************
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "status.fh"
#include "nq_info.fh"
#include "nsd.fh"
#include "setup.fh"
#include "grid_on_disk.fh"
#include "print.fh"
      Real*8 Coor(3), C(3)
      Logical EQ, Do_Grad, On_Top, PMode_Old
      Real*8 Alpha(2),rm(2), R_Min(0:nR_Min)
      Integer Maps2p(nShell,0:nSym-1)
      Integer iDCRR(0:7)
      Dimension Dummy(1)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement Functions
*
#include "nq_structure.fh"
      declare_ip_coor
      declare_ip_a_high
      declare_ip_a_low
      declare_ip_r_rs
      declare_ip_l_max
      declare_ip_r_quad
      declare_ip_angular
      declare_ip_atom_nr
      declare_ip_dodx
      nElem(i)=(i+1)*(i+2)/2
*                                                                      *
************************************************************************
*                                                                      *
      Call ICopy(nShell*nSym,[-99999999],0,Maps2p,1)
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
c     Write(6,*) '********** Setup_NQ ***********'
      ntotgp=0
*                                                                      *
************************************************************************
*                                                                      *
*-----Check if NQ environment has been activated
*
      If (NQ_Status.ne.Active.and.NQ_Status.ne.Inactive) Then
         Call WarningMessage(2,'Setup_NQ: NQ_Status not initialized')
         Call Quit_OnUserError()
      End If
      If (NQ_Status.eq.Active) Return
      NQ_Status=Active
*                                                                      *
************************************************************************
*                                                                      *
*---- Get the coordinates to the centers of all Voronoi polyhedra
*
*     Note that this will be all centers with valence basis sets on
*     them. Hence this will also include any pseudo centers!
*
      Call Allocate_Work(ipTempC,3*nShell*nSym)
      nAtoms = 0
      If (nShell.gt.nskal_iSD) Then
         Write (6,*) 'nShell.gt.nSkal_iSD'
         Write (6,*) 'nShell=',nShell
         Write (6,*) 'nSkal_iSD=',nSkal_iSD
         Call AbEnd()
      End If
      Do iShell = 1, nShell
         iCnttp=iSD(13,iShell)
         iCnt  =iSD(14,iShell)
         Coor(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
         Call Process_Coor(Coor,Work(ipTempC),nAtoms,nSym,iOper)
      End Do
      Call Allocate_Work(ipCoor,3*nAtoms)
      call dcopy_(3*nAtoms,Work(ipTempC),1,Work(ipCoor),1)
C     Call RecPrt('Coor',' ',Work(ipCoor),3,nAtoms)
      Call Free_Work(ipTempC)
*                                                                      *
************************************************************************
*                                                                      *
*---- Get the symmetry unique coordinates
*
      nNQ=nAtoms
      Call GetMem('nq_centers','Allo','Real',ipNQ,nNQ*l_NQ)
      ipTmp1=ipCoor
      Do iNQ = 1, nNQ
         call dcopy_(3,Work(ipTmp1),1,Work(ip_Coor(iNQ)),1)
         ipTmp1=ipTmp1+3
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*-----Pick up the requested accuracy.
*
*     Dr=-Log10(Thr)
*                                                                      *
************************************************************************
*                                                                      *
*-----Loop over each unique center, and find the highest and lowest    *
*     Gaussians exponents associated with this center. The later       *
*     information will be used to design the radial grid associated    *
*     with this center.                                                *
*                                                                      *
*-----Initialize the exponents to extreme values.
      Do iNQ=1,nNQ
         Work(ip_lMax(iNQ))=DBLE(-1)
         Work(ip_A_high(iNQ))=-1.0D99
         Work(ip_A_low(iNQ) )= 1.0D99
      End Do
*
      iAngMax=0
      NbrMxBas=0
      Do iShell=1,nShell
         iAng  =iSD(1,iShell)
         nCntrc=iSD(3,iShell) !Get the # of contracted functions
                              !for iShell
         mExp  =iSD(5,iShell) ! Get the number of exponents of ishell
         NbrMxBas=Max(NbrMxbas,nCntrc)
         iAngMax=Max(iAngMax,iAng)
      End Do
*
*-----Loop over the shells
*
      nMaxExp=0
      nAOMax=0
      Do iShell = 1, nShell
*
*------- Get the Atom number
         iANr=dbsc(iSD(13,iShell))%AtmNr
*
         iShll=iSD(0,iShell)   ! Get the angular momentum of ishell
         iAng=iSD(1,iShell)   ! Get the angular momentum of ishell
         iCmp=iSD(2,iShell)   ! Get the # of angular components
         nCntrc=iSD(3,iShell) !Get the # of contracted functions
                              !for iShell
         mExp=iSD(5,iShell)   ! Get the number of exponents of ishell
         nMaxExp=Max(nMaxExp,mExp)
         nAOMax=Max(nAOMax,iCmp*nCntrc)
*
************************************************************************
*                                                                      *
*     Order the exponents diffuse to compact for the active shell      *
*                                                                      *
************************************************************************
         Call OrdExpD2C(mExp,Shells(iShll)%Exp,nCntrc,
     &                       Shells(iShll)%pCff)
*
*-----Get the extreme exponents for the active shell.
         A_low =Shells(iShll)%Exp(1)
         A_high=Shells(iShll)%Exp(mExp)
*
         iCnttp=iSD(13,iShell)
         iCnt  =iSD(14,iShell)
         C(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
         Do iIrrep = 0, nIrrep-1
            Call OA(iOper(iIrrep),C,Coor)
         Do iNQ=1,nNQ
            jNQ=ip_Coor(iNQ)
*
            If (EQ(Work(jNQ  ),Coor)) Then
*
               Work(ip_Atom_Nr(iNQ))=DBLE(iANR)
*
*------------- Assign the BS radius to the center
               Work(ip_R_RS(iNQ))=Bragg_Slater(iANr)
*
*------------- What is the maximum angular momentum for the active center ?
               Work(ip_lMax(iNQ))=Max(Work(ip_lMax(iNQ)),DBLE(iAng))
*
*------------- Get the extreme exponents for the atom
               Work(ip_A_high(iNQ))=Max(Work(ip_A_high(iNQ)),A_High)
               Work(ip_A_low(iNQ) )=Min(Work(ip_A_low(iNQ) ),A_low)
*
               Maps2p(iShell,iIrrep)=iNQ
               Go To 100
            End If
         End Do                 ! iNQ
         Call WarningMessage(2,
     &              'Didn''t find a center associated with the shell!')
         Call Abend()
 100     Continue
         End Do                 ! iIrrep
*
      End Do                    !iShell
*
************************************************************************
*                                                                      *
*               END OF THE LOOP OVER THE SHELLS.                       *
*     Now we have the number of unique center and their associated     *
*     exponents and maximum angular momentum. And for each shell the   *
*     exponents are ordered diffuse to compact.                        *
*                                                                      *
************************************************************************
*                                                                      *
*     Loop over all the atoms to create the radial quadrature          *
*                                                                      *
************************************************************************
*
*-----Allocate memory to store the number of effective radial points for
*     each center and the radius of this center.
      Call GetMem('NumRadEff','Allo','Inte',ip_nR_eff,nNQ)
*
      iNQ_MBC=0
      iReset=0
      Threshold_tmp=Zero
      nR_tmp=0
      Do iNQ=1,nNQ
*--------Get the extreme exponents for the atom
         Alpha(1)=Work(ip_A_low(iNQ) )
         Alpha(2)=Work(ip_A_high(iNQ))
*
*--------Get the coordinates of the atom
         call dcopy_(3,Work(ip_Coor(iNQ)),1,Coor,1)
*
*        For a special center we can increase the accuracy.
*
         jNQ=ip_Coor(iNQ)
         If (MBC.ne.' ') Then
            Do iS = 1, nShell
               iCnttp=iSD(13,iS)
               iCnt  =iSD(14,iS)
               C(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
               If ( EQ(Work(jNQ),C) ) Then
                  mdci=iSD(10,iS)
                  If (dc(mdci)%LblCnt.eq.MBC) Then
                     nR_tmp=nR
                     nR=INT(DBLE(nR)*2.0D0)
                     Threshold_tmp=Threshold
                     Threshold=Threshold*1.0D-6
*
                     iReset=1
                     iNQ_MBC=iNQ
                     Go To 1771
                  End If
               End If
            End Do
         End If
 1771    Continue
*
*        Max angular momentum for the atom -> rm(1)
*        Max Relative Error -> rm(2)
         rm(1)=Work(ip_lMax(iNQ))
         rm(2)=Threshold
*
         Call GenVoronoi(Coor,iWork(ip_nR_eff),nNQ,Alpha,rm,iNQ)
*
         If (iReset.eq.1) Then
            nR=nR_tmp
            Threshold=Threshold_tmp
            iReset=0
         End If
*
      End Do  ! iNQ
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the principal axis system and optionally to
*     compute derivatives of the principal axis. Needed in order to
*     compute the gradient of the rotationally invariant DFT energy.
*
      Call GetMem('O','Allo','Real',ip_O,3*3)
      Call GetMem('dOdx','Allo','Real',ipdOdx,3*3*nNQ*3)
      Call FZero(Work(ipdOdx),3*3*nNQ*3)
      Call GetMem('ZA','Allo','Real',ip_ZA,nNQ)
      Call Allocate_Work(ip_Crd,3*nNQ)
*
*     Collect coordinates and charges of the nuclei
*
      iOff = ip_Crd
      Do iNQ = 1, nNQ
         Work(ip_ZA+(iNQ-1))=Work(ip_Atom_Nr(iNQ))
         call dcopy_(3,Work(ip_Coor(iNQ)),1,Work(iOff),1)
         iOff = iOff + 3
      End Do
*
#ifdef _DEBUGPRINT_
      If (Do_Grad) Then
      delta=1.0D-8
      Call Allocate_Work(ip_Dbg,9)
      Do iNQ = 1, nNQ
         Do iCar = 1, 3
*
            Write (6,*) 'iCar,iNQ=',iCar,iNQ
*
            Call RotGrd(Work(ip_Crd),Work(ip_ZA),Work(ip_O),
     &                  Dummy,Dummy,nNQ,.False.,.False.)
            Call RecPrt('O(original)',' ',Work(ip_O),3,3)
*
            i3 = (iNQ-1)*3+iCar-1+ip_Crd
            temp=Work(i3)
*
            Work(i3)=temp+delta
            Call RotGrd(Work(ip_Crd),Work(ip_ZA),Work(ip_O),
     &                  Dummy,Dummy,nNQ,.False.,.False.)
            call dcopy_(9,Work(ip_O),1,Work(ip_Dbg),1)
            Call RecPrt('O',' ',Work(ip_O),3,3)
*
            Work(i3)=temp-delta
            Call RotGrd(Work(ip_Crd),Work(ip_ZA),Work(ip_O),
     &                  Dummy,Dummy,nNQ,.False.,.False.)
            Call RecPrt('O',' ',Work(ip_O),3,3)
*
            Work(i3)=temp
*
            Do i = 0, 8
               temp = (Work(ip_Dbg+i) - Work(ip_O+i))/(2.0D0*delta)
               Work(ip_O+i) = temp
            End Do
            Call RecPrt('dOdx(numerical)',' ',Work(ip_O),3,3)
            call dcopy_(9,Work(ip_O),1,Work(ip_dOdx(iNQ,iCar)),1)
*
         End Do
      End Do
      Call Free_Work(ip_Dbg)
      End If
#endif
      Call RotGrd(Work(ip_Crd),Work(ip_ZA),Work(ip_O),Work(ipdOdx),
     &            Dummy,nNQ,Do_Grad,.False.)
*
*     Distribute derivative of the principle axis system
*
      If (Do_Grad) Then
      iOff = ipdOdx
      Do iCar = 1, 3
         Do iNQ = 1, nNQ
#ifdef _DEBUGPRINT_
         Call RecPrt('dOdx','(3G20.10)',Work(iOff),3,3)
         Call RecPrt('dOdx(numerical)','(3G20.10)',
     &               Work(ip_dOdx(iNQ,iCar)),3,3)
#endif
            call dcopy_(9,Work(iOff),1,Work(ip_dOdx(iNQ,iCar)),1)
            iOff = iOff + 9
         End Do
      End Do
      End If
#ifdef _DEBUGPRINT_
*
*     Check translational invariance
*
      Call Allocate_Work(ip_debug,9)
      Do iCar = 1, 3
         Call FZero(Work(ip_debug),9)
         Do iNQ = 1, nNQ
            Call DaXpY_(9,1.0D0,Work(ip_dOdx(iNQ,iCar)),1,
     &                         Work(ip_debug),1)
         End Do
         Call RecPrt('Debug',' ',Work(ip_debug),3,3)
      End Do
      Call Free_Work(ip_debug)
*
#endif
*

      Call Free_Work(ipdOdx)
      Call Free_Work(ip_Crd)
      Call Free_Work(ip_ZA)
*                                                                      *
************************************************************************
*                                                                      *
      If (Rotational_Invariance.eq.Off) Then
         Call FZero(Work(ip_O),9)
         call dcopy_(3,[One],0,Work(ip_O),4)
         Do iNQ = 1, nNQ
            Do iCar = 1, 3
               Call FZero(Work(ip_dOdx(iNQ,iCar)),9)
            End Do
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Generate the angular grid
*
      Call Angular_grid()
*
      Crowding_tmp=Zero
      Do iNQ = 1, nNQ
*
*        Assign the angular grid to be used with each radial grid point
*
         nR_Eff=iWork(ip_nR_eff-1+iNQ)
         Call GetMem('ip_Angular','Allo','Inte',ip_A,nR_Eff)
         ip_iA=ip_of_iWork_d(Work(ip_Angular(iNQ)))
         iWork(ip_iA)=ip_A
         Call ICopy(nR_Eff,[nAngularGrids],0,iWork(ip_A),1)
*
*        Prune the angular grid
*
         If (Angular_Prunning.eq.On) Then
*
*
*---------- Find the R_min values of each angular shell
*
            lAng=Int(Work(ip_lMax(iNQ)))
            Do iAng = 0, lAng
               R_Min(iAng)=Zero
               ValExp=-One
               iSet=0
               Do iShell=1,nShell
                  iShll =iSD(0,iShell)
                  iAng_ =iSD(1,iShell)
                  NrExp =iSD(5,iShell)
*                 Write (6,*) 'iAng_,iAng=',iAng_,iAng
                  If (iAng_.eq.iAng.and.NrExp.ge.1) Then
                     Do iSym = 0, nSym-1
                        iNQ_=Maps2p(iShell,iSym)
*                       Write (6,*) 'iNQ_,iNQ=',iNQ_,iNQ
                        If (iNQ_.eq.iNQ) Then
                           ValExp=Shells(iShll)%Exp(NrExp)
                           iSet=1
                        End If
                     End Do
                  End If
               End Do
               If (ValExp.lt.Zero.and.iSet.eq.1) Then
                  Call WarningMessage(2,'ValExp.lt.Zero')
                  Call Abend()
               End If
               If (iSet.eq.1) Then
                  R_Min(iAng)=Eval_RMin(ValExp,iAng,Threshold)
                  If (iAng.eq.0) R_Min(iAng)=Zero
               End If
            End Do
*
            ip_iRx=ip_of_iWork_d(Work(ip_R_Quad(iNQ)))
            ip_Rx=iWork(ip_iRx)
            R_BS = Work(ip_R_RS(iNQ))
*
            If (iNQ.eq.iNQ_MBC) Then
               Crowding_tmp=Crowding
               Crowding=One + (Crowding-One)*0.25D0
               iReset=1
            End If
*
            Call Angular_Prune(Work(ip_Rx),nR_Eff,iWork(ip_A),Crowding,
     &                         Fade,R_BS,L_Quad,R_Min,lAng,
     &                         nAngularGrids,Info_Ang,LMax_NQ)
*
            If (iReset.eq.1) Then
               Crowding=Crowding_tmp
               iReset=0
            End If
*
         End if
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,'(A)') ' =================================='
      Write (6,'(A)') ' =        Grid information        ='
      Write (6,'(A)') ' =================================='
      Write (6,'(A)') ' Legend             '
      Write (6,'(A)') ' ----------------------------------'
      Write (6,'(A)') ' ANr: element number'
      Write (6,'(A)') ' nR : number of radial grid points'
      Write (6,'(A)') ' iNQ: grid index'
      Write (6,'(A)') ' ----------------------------------'
      Write (6,*)
      Write (6,'(A)') ' iNQ ANr  nR'
      Do iNQ=1,nNQ
         iANr=Int(Work(ip_Atom_Nr(iNQ)))
         kR=iWork(ip_nR_Eff+iNQ-1)
         Write (6,'(3I4)') iNQ, iANr, kR
      End Do
      Write (6,*)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Determine the spatial extension of the molecular system
*
      Box_Size=Two            ! Angstrom
      !Box_Size=1.0d0/Two            ! Angstrom
      Block_size=Box_Size
      x_min=1.0D99
      y_min=1.0D99
      z_min=1.0D99
      x_max=-1.0D99
      y_max=-1.0D99
      z_max=-1.0D99
      Do iAt = 0, nAtoms-1
         x_min=Min(x_min,Work(ipCoor+iAt*3+0))
         y_min=Min(y_min,Work(ipCoor+iAt*3+1))
         z_min=Min(z_min,Work(ipCoor+iAt*3+2))
         x_max=Max(x_max,Work(ipCoor+iAt*3+0))
         y_max=Max(y_max,Work(ipCoor+iAt*3+1))
         z_max=Max(z_max,Work(ipCoor+iAt*3+2))
      End Do
*
*---- Add half an box size around the whole molecule
*
      x_min=x_min-Box_Size/Two
      y_min=y_min-Box_Size/Two
      z_min=z_min-Box_Size/Two
      x_max=x_max+Box_Size/Two
      y_max=y_max+Box_Size/Two
      z_max=z_max+Box_Size/Two
*
*---- At least one finite box. Adjust to an even number of boxes.
*
      nx=Int((x_max-x_min+Box_Size)/Box_Size)
      nx=2*((nx+1)/2)
      ny=Int((y_max-y_min+Box_Size)/Box_Size)
      ny=2*((ny+1)/2)
      nz=Int((z_max-z_min+Box_Size)/Box_Size)
      nz=2*((nz+1)/2)
*
*---- Adjust extremal values to fit exactly with the
*     box size.
*
      dx=(DBLE(nx)*Box_Size-(x_max-x_min))/Two
      dy=(DBLE(ny)*Box_Size-(y_max-y_min))/Two
      dz=(DBLE(nz)*Box_Size-(z_max-z_min))/Two
*
      x_min=x_min-dx
      y_min=y_min-dy
      z_min=z_min-dz
      x_max=x_max+dx
      y_max=y_max+dy
      z_max=z_max+dz
*
*---- Add the infinite edge boxes
*
      nx=nx+2
      ny=ny+2
      nz=nz+2
#ifdef _DEBUGPRINT_
      Write (6,*) 'x_min=',x_min,dx
      Write (6,*) 'y_min=',y_min,dy
      Write (6,*) 'z_min=',z_min,dz
      Write (6,*) 'x_max=',x_max
      Write (6,*) 'y_max=',y_max
      Write (6,*) 'z_max=',z_max
      Write (6,*) 'nx,ny,nz=',nx,ny,nz
      Write (6,*) 'Total number of blocks=',nx*ny*nz
#endif
      number_of_subblocks=nx*ny*nz
*                                                                      *
************************************************************************
*                                                                      *
*     nFOrd: the order of the functional. nFOrd-1 is the number of times
*            the basis functions has to be differentiated to compute the
*            energy contribution.
*     mTmp: seems to be redundant?
*     mRad: number of different radial functions associated with a
*           basis function. This number depends on the type of
*           functional and the number of times the basis function has
*           to be differentiated in order to produce the values of the
*           parameters which the functional depends on (rho, grad rho,
*           and nabla rho).
*     nScr: Used to assemble integrals, (rho, grad rho, nabla rho)
*           (1,4, or 5). This is not needed in gradient calculations!
*     mAO: number of elements a basis function generates upon
*          differentiation (1,4,10,20, etc.)
*
      If (Functional_type.eq.LDA_type) Then
         nFOrd=1
         mAO=(nFOrd*(nFOrd+1)*(nFOrd+2))/6
         if(do_grad) mAO=4!AMS - GRADIENTS?
         If (.Not.Do_Grad) Then
            mTmp=1
            mRad=nFOrd
            nScr=nD*nAOMax
         Else
            mTmp=7
            mRad=nFOrd+1
            nScr=0
         End If
*
      Else If (Functional_type.eq.GGA_type) Then
         nFOrd=2
         mAO=(nFOrd*(nFOrd+1)*(nFOrd+2))/6
         if(do_grad) mAO=10
         If (.Not.Do_Grad) Then
            mTmp=7
            mRad=nFOrd
            nScr=nD*4*nAOMax
         Else
            mTmp=28
            mRad=nFOrd+1
            nScr=0
         End If
      Else If (Functional_type.eq.CASDFT_type) Then
*        I need to discuss this with Sergey!
*        nFOrd=3 !?
*        mAO=(nFOrd*(nFOrd+1)*(nFOrd+2))/6
         nFOrd=2
         mAO=10
         If (.Not.Do_Grad) Then
            mTmp=7
            mRad=nFOrd
            nScr=nD*4*nAOMax
         Else
            mTmp=28
            mRad=nFOrd+1
            nScr=0
         End If
*
      Else If (Functional_type.eq.meta_GGA_type1) Then
         nFOrd=2
         mAO=(nFOrd*(nFOrd+1)*(nFOrd+2))/6
         If (.Not.Do_Grad) Then
            mTmp=7
            mRad=nFOrd
            nScr=nD*4*nAOMax
         Else
            mTmp=28
            mRad=NFOrd+1
            nScr=0
         End If
*
      Else If (Functional_type.eq.meta_GGA_type2) Then
         nFOrd=3
         mAO=(nFOrd*(nFOrd+1)*(nFOrd+2))/6
         If (.Not.Do_Grad) Then
            mTmp=7
            mRad=nFOrd
            nScr=nD*5*nAOMax
         Else
            mTmp=28
            mRad=NFOrd+1
            nScr=0
         End If
*
*     Else If (Functional_type.eq.Other_type) Then
      Else
         mTmp=0 ! Dummy initialize
         mRad=0 ! Dummy initialize
         mAO=0  ! Dummy initialize
         nScr=0 ! Dummy initialize
         Call WarningMessage(2,'Functional_type.eq.Other_type')
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate scratch for processing AO's on the grid
*
      nTmp=nGridMax*Max(mTmp,nScr)
      Call GetMem('Tmp','Allo','Real',ipTmp,nTmp+nShell*nIrrep)

      ipTabAOMax=ipTmp+nTmp
*
      nMem=0
      nSO =0
      Do ish = 1, nShell
         iAng  = iSD( 1,iSh)
         iCmp  = iSD( 2,iSh)
         iBas  = iSD( 3,iSh)
         iPrim = iSD( 5,iSh)
*
         nxyz    = nGridMax*3*(iAng+mRad)
         nDrv     = mRad - 1
         nForm    = 0
         Do iDrv  = 0, nDrv
            nForm = nForm + nElem(iDrv)
         End Do
         nTerm    = 2**nDrv
         nAngular = 5*nForm*nTerm
         nRad    = iPrim*nGridMax*mRad
         nRadial = iBas*nGridMax*mRad
         If (On_Top) Then
            mdci  = iSD(10,iSh)
            kAO=iCmp*iBas*nGridMax
            nSO=kAO*nSym/dc(mdci)%nStab*mAO
         End If
c         nMem=Max(nMem,nxyz+nAngular+nRad+nRadial+nSO)
         nMem=Max(nMem,nxyz+nAngular+nRad+nRadial,2*nSO)
      End Do
*
      Call GetMem('nMem','Allo','Real',ipMem,nMem)
*                                                                      *
************************************************************************
*                                                                      *
*     Access the file with Grid points and weights.
*
*---- Open the file.
      Lu_Grid=88
      Call DaName_MF_WA(Lu_Grid,'NQGRID')
*
      If (iGrid_Set.eq.Not_Specified) iGrid_Set=Final
*
*---- Read the status flag.
      iDisk_Grid=0
      Call iDaFile(Lu_Grid,2,G_S,5,iDisk_Grid)
*
      Grid_Status=G_S(iGrid_Set)
      If (Old_Functional_Type.ne.Functional_Type) Then
         G_S(Final)=Regenerate
         G_S(Intermediate)=Regenerate
         Grid_Status=Regenerate
      End If
      iDisk_Grid=iDisk_Set(iGrid_Set)
*
*---- Allocate memory for the master TOC.
      Call GetMem('GridInfo','Allo','Inte',ip_GridInfo,
     &            2*number_of_subblocks)
*
*---- Retrieve the TOC or regenerate it.
*
*     The table contains two data items per subblock.
*     1) disk address and 2) number of batches.
*
      If (Grid_Status.eq.Regenerate) Then
C        Write (6,*) 'Grid_Status.eq.Regenerate'
         Grid_Status=Regenerate
         Call ICopy(2*number_of_subblocks,[0],0,iWork(ip_GridInfo),1)
         Call iDaFile(Lu_Grid,1,iWork(ip_GridInfo),
     &                2*number_of_subblocks,iDisk_Grid)
         Old_Functional_Type=Functional_Type
      Else If (Grid_Status.eq.Use_Old) Then
C        Write (6,*) 'Grid_Status.eq.Use_Old'
         Call iDaFile(Lu_Grid,2,iWork(ip_GridInfo),
     &                2*number_of_subblocks,iDisk_Grid)
      Else
         Call WarningMessage(2,'Illegal Grid Status!')
         Call Abend()
      End If
*
      Call ParmPkR8(Pck_Old,PMode_old)
      Call IniPkR8(T_X,.True.)
*                                                                      *
************************************************************************
*                                                                      *
*     Setup some symmetry stuff outside the loop
*
      ndc = 0
      Do iSh = 1, nShell
         ndc = Max(ndc,iSD(10,iSh))
      End Do
      ndc2 = ndc**2
      Call GetMem('Fact','Allo','Real',ip_Fact,ndc2)
      Do mdci = 1, ndc
         nDegi=nIrrep/dc(mdci)%nStab
         Do mdcj = 1, ndc
            nDegj=nIrrep/dc(mdcj)%nStab
*
            Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &                     dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
*
            iuv = dc(mdci)%nStab*dc(mdcj)%nStab
            If (MolWgh.eq.1) Then
               Fact = DBLE(nIrrep) / DBLE(LmbdR)
            Else If (MolWgh.eq.0) Then
               Fact = DBLE(iuv) / DBLE(nIrrep * LmbdR)
            Else
               Fact = Sqrt(DBLE(iuv))/ DBLE(LmbdR)
            End If
            Fact=Fact*DBLE(nDCRR)/DBLE(nDegi*nDegj)
*
*---------- Save: Fact
*
            ij = (mdcj-1)*ndc + mdci
            Work(ip_Fact+ij-1) = Fact
*
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Constants

use Definitions, only: wp

implicit none
private

! Common numbers

real(kind=wp), parameter :: Zero = 0.0_wp, One = 1.0_wp, Two = 2.0_wp, Three  = 3.0_wp, Four = 4.0_wp, Five = 5.0_wp, &
                            Six = 6.0_wp, Seven = 7.0_wp, Eight = 8.0_wp, Nine = 9.0_wp, Ten = 10.0_wp, Eleven = 11.0_wp, &
                            Twelve = 12.0_wp, Half = 0.5_wp, Quart = 0.25_wp, OneHalf = 1.5_wp

complex(kind=wp), parameter :: cZero = (Zero,Zero), cOne = (One,Zero), Onei = (Zero,One)

! Pi and related constants

real(kind=wp), parameter :: Pi = Four*atan2(One,One), TwoP34 = One/(Two*Pi)**(Three/Four), TwoP54 = sqrt(Two)*Pi**(Five/Four)

!***********************************************************************
!                                                                      *
!              Physical constants and conversion factors               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! The constants and conversion factors in this file are taken from     *
! NIST at URL https://physics.nist.gov/cuu/Constants                   *
!                                                                      *
! CODATA 2010: Peter J. Mohr, Barry N. Taylor, David B. Newell,        *
!              CODATA recommended values of the fundamental physical   *
!              constants: 2010                                         *
!              Rev. Mod. Phys. vol. 84(4) 1527-1605 (2012).            *
!              doi:10.1103/RevModPhys.84.1527                          *
!                                                                      *
! CODATA 2014: Peter J. Mohr, David B. Newell, Barry N. Taylor,        *
!              CODATA recommended values of the fundamental physical   *
!              constants: 2014                                         *
!              Rev. Mod. Phys. vol. 88(3) 035009 (2016).               *
!              doi:10.1103/RevModPhys.88.035009                        *
!                                                                      *
! CODATA 2018: Eite Tiesinga, Peter J. Mohr, David B. Newell,          *
!              Barry N. Taylor,                                        *
!              CODATA recommended values of the fundamental physical   *
!              constants: 2018                                         *
!              Rev. Mod. Phys. vol. 93(2) 025010 (2021).               *
!              doi:10.1103/RevModPhys.93.025010                        *
!                                                                      *
! CODATA 2022: Eite Tiesinga, Peter J. Mohr, David B. Newell,          *
!              Barry N. Taylor,                                        *
!              The 2022 CODATA Recommended Values of the Fundamental   *
!              Physical Constants                                      *
!              (Web Version 9.0)                                       *
!                                                                      *
!----------------------------------------------------------------------*

! Constants
! ---------
! CONST_AMU_IN_SI_               -- Atomic mass unit (1/12*m[C12]) in SI units.
! CONST_ATM_IN_SI_               -- 1atm in SI units.
! CONST_AU_TIME_IN_SI_           -- Atomic units time unit in SI units.
! CONST_AU_VELOCITY_IN_SI_       -- Atomic units velocity unit in SI units.
! CONST_AVOGADRO_                -- Avogadro's number in SI units.
! CONST_BOHR_MAGNETON_IN_SI_     -- Bohr magneton in SI units.
! CONST_BOHR_RADIUS_IN_SI_       -- Bohr radius in SI units.
! CONST_BOLTZMANN_               -- Boltzmann's constant in SI units.
! CONST_C_IN_AU_                 -- Speed of light in atomic units.
! CONST_C_IN_SI_                 -- Speed of light in SI units.
! CONST_DIELECTRIC_IN_SI_        -- Electric constant (eps0) in SI units.
! CONST_DIPOLE_IN_SI_            -- Atomic unit of dipole (e*a0) in SI units.
! CONST_ELECTRON_G_FACTOR_       -- Electron g-factor (dimensionless).
! CONST_ELECTRON_MASS_IN_SI_     -- Mass of the electron in SI units.
! CONST_ELEMENTARY_CHARGE_IN_SI_ -- Elementary charge in SI units.
! CONST_MOLAR_GAS_               -- Molar gas constant in SI units.
! CONST_MUON_MASS_IN_SI_         -- Mass of the muon in SI units.
! CONST_PLANCK_                  -- Planck's constant in SI units.
!
! Conversion factors
! ------------------
! CONV_AMU_TO_AU_                -- Convert 1AMU to au.
! CONV_ATM_TO_AU_                -- Convert 1tm to au.
! CONV_AU_TO_CM1_                -- Convert 1Eh to reciprocal cm.
! CONV_AU_TO_DEBYE               -- Convert 1au to debye.
! CONV_AU_TO_EV_                 -- Convert 1Eh to electron-volt.
! CONV_AU_TO_HZ_                 -- Convert 1Eh to hertz.
! CONV_AU_TO_KJ_                 -- Convert 1Eh to kilojoule.
! CONV_AU_TO_KJ_PER_MOLE_        -- Convert 1Eh to kilojoule per mole.
! CONV_AU_TO_T                   -- Convert 1au to tesla.
! CONV_CAL_TO_J_                 -- Convert 1cal to joule.

!***********************************************************************
! Select a set of physical constants, valid values are:
! 2010, 2014, 2018, 2022

#ifndef CODATA_SET
#define CODATA_SET 2022
#endif

! Constants

#if CODATA_SET == 2022
#  define CONST_AMU_IN_SI_                1.66053906892e-27_wp
#  define CONST_AU_TIME_IN_SI_            2.4188843265864e-17_wp
#  define CONST_AU_VELOCITY_IN_SI_        2.18769126216e6_wp
#  define CONST_AVOGADRO_                 6.02214076e23_wp
#  define CONST_BOHR_RADIUS_IN_SI_        5.29177210544e-11_wp
#  define CONST_ELECTRON_MASS_IN_SI_      9.1093837139e-31_wp
#  define CONST_MUON_MASS_IN_SI_          1.883531627e-28_wp
#  define CONST_BOLTZMANN_                1.380649e-23_wp
#  define CONST_ELEMENTARY_CHARGE_IN_SI_  1.602176634e-19_wp
#  define CONST_PLANCK_                   6.62607015e-34_wp
#  define CONST_DIELECTRIC_IN_SI_         8.8541878188e-12_wp
#  define CONST_ELECTRON_G_FACTOR_       -2.00231930436092_wp
#  define CONST_BOHR_MAGNETON_IN_SI_      9.2740100657e-24_wp
#elif CODATA_SET == 2018
! CONST_AVOGADRO_, CONST_BOLTZMANN_, CONST_ELEMENTARY_CHARGE_IN_SI_, CONST_PLANCK_ are now exact
#  define CONST_AMU_IN_SI_                1.66053906660e-27_wp
#  define CONST_AU_TIME_IN_SI_            2.4188843265857e-17_wp
#  define CONST_AU_VELOCITY_IN_SI_        2.18769126364e6_wp
#  define CONST_AVOGADRO_                 6.02214076e23_wp
#  define CONST_BOHR_RADIUS_IN_SI_        5.29177210903e-11_wp
#  define CONST_ELECTRON_MASS_IN_SI_      9.1093837015e-31_wp
#  define CONST_MUON_MASS_IN_SI_          1.883531627e-28_wp
#  define CONST_BOLTZMANN_                1.380649e-23_wp
#  define CONST_ELEMENTARY_CHARGE_IN_SI_  1.602176634e-19_wp
#  define CONST_PLANCK_                   6.62607015e-34_wp
#  define CONST_DIELECTRIC_IN_SI_         8.8541878128e-12_wp
#  define CONST_ELECTRON_G_FACTOR_       -2.00231930436256_wp
#  define CONST_BOHR_MAGNETON_IN_SI_      9.2740100783e-24_wp
#elif CODATA_SET == 2014
#  define CONST_AMU_IN_SI_                1.660539040e-27_wp
#  define CONST_AU_TIME_IN_SI_            2.418884326509e-17_wp
#  define CONST_AU_VELOCITY_IN_SI_        2.18769126277e6_wp
#  define CONST_AVOGADRO_                 6.022140857e23_wp
#  define CONST_BOHR_RADIUS_IN_SI_        5.2917721067e-11_wp
#  define CONST_ELECTRON_MASS_IN_SI_      9.10938356e-31_wp
#  define CONST_MUON_MASS_IN_SI_          1.883531594e-28_wp
#  define CONST_MOLAR_GAS_                8.3144598_wp
#  define CONST_ELEMENTARY_CHARGE_IN_SI_  1.6021766208e-19_wp
#  define CONST_PLANCK_                   6.626070040e-34_wp
#  define CONST_DIELECTRIC_IN_SI_         8.854187817e-12_wp
#  define CONST_ELECTRON_G_FACTOR_       -2.00231930436182_wp
#  define CONST_BOHR_MAGNETON_IN_SI_      9.274009994e-24_wp
#elif CODATA_SET == 2010
#  define CONST_AMU_IN_SI_                1.660538921e-27_wp
#  define CONST_AU_TIME_IN_SI_            2.418884326502e-17_wp
#  define CONST_AU_VELOCITY_IN_SI_        2.18769126379e6_wp
#  define CONST_AVOGADRO_                 6.02214129e23_wp
#  define CONST_BOHR_RADIUS_IN_SI_        5.2917721092e-11_wp
#  define CONST_ELECTRON_MASS_IN_SI_      9.10938291e-31_wp
#  define CONST_MUON_MASS_IN_SI_          1.883531475e-28_wp
#  define CONST_MOLAR_GAS_                8.3144621_wp
#  define CONST_ELEMENTARY_CHARGE_IN_SI_  1.602176565e-19_wp
#  define CONST_PLANCK_                   6.62606957e-34_wp
#  define CONST_DIELECTRIC_IN_SI_         8.85418782e-12_wp
#  define CONST_ELECTRON_G_FACTOR_       -2.00231930436153_wp
#  define CONST_BOHR_MAGNETON_IN_SI_      9.27400968e-24_wp
#endif
#define CONST_C_IN_SI_                    2.99792458e8_wp
#define CONST_ATM_IN_SI_                  101325.0_wp

! Derived constants

#if CODATA_SET >= 2018
#  define CONST_MOLAR_GAS_                (CONST_AVOGADRO_*CONST_BOLTZMANN_)
#else
#  define CONST_BOLTZMANN_                (CONST_MOLAR_GAS_/CONST_AVOGADRO_)
#endif
#define CONST_C_IN_AU_                    (CONST_C_IN_SI_/CONST_AU_VELOCITY_IN_SI_)
#define CONST_DIPOLE_IN_SI_               (CONST_ELEMENTARY_CHARGE_IN_SI_*CONST_BOHR_RADIUS_IN_SI_)

! Conversion factors

#if CODATA_SET == 2022
#  define CONV_AU_TO_EV_                  27.211386245981_wp
#  define CONV_AU_TO_CM1_                 2.1947463136314e5_wp
#  define CONV_AU_TO_KJ_                  4.3597447222060e-21_wp
#  define CONV_AU_TO_HZ_                  6.5796839204999e15_wp
#  define CONV_AU_TO_T_                   2.35051757077e5_wp
#elif CODATA_SET == 2018
#  define CONV_AU_TO_EV_                  27.211386245988_wp
#  define CONV_AU_TO_CM1_                 2.1947463136320e5_wp
#  define CONV_AU_TO_KJ_                  4.3597447222071e-21_wp
#  define CONV_AU_TO_HZ_                  6.579683920502e15_wp
#  define CONV_AU_TO_T_                   2.35051756758e5_wp
#elif CODATA_SET == 2014
#  define CONV_AU_TO_EV_                  27.21138602_wp
#  define CONV_AU_TO_CM1_                 2.194746313702e5_wp
#  define CONV_AU_TO_KJ_                  4.359744650e-21_wp
#  define CONV_AU_TO_HZ_                  6.579683920711e15_wp
#  define CONV_AU_TO_T_                   2.350517550e5_wp
#elif CODATA_SET == 2010
#  define CONV_AU_TO_EV_                  27.21138505_wp
#  define CONV_AU_TO_CM1_                 2.194746313708e5_wp
#  define CONV_AU_TO_KJ_                  4.35974434e-21_wp
#  define CONV_AU_TO_HZ_                  6.579683920729e15_wp
#  define CONV_AU_TO_T_                   2.350517464e5_wp
#endif
#define CONV_CAL_TO_J_                    4.184_wp

! Derived conversion factors

#define CONV_AU_TO_DEBYE_                 (CONST_DIPOLE_IN_SI_*CONST_C_IN_SI_*1.0e21_wp)
#define CONV_AMU_TO_AU_                   (CONST_AMU_IN_SI_/CONST_ELECTRON_MASS_IN_SI_)
#define CONV_AU_TO_KJ_PER_MOLE_           (CONST_AVOGADRO_*CONV_AU_TO_KJ_)
#define CONV_ATM_TO_AU_                   (CONST_ATM_IN_SI_*CONST_BOHR_RADIUS_IN_SI_**3/CONV_AU_TO_KJ_*1.0e-3_wp)

! Fortran constants

real(kind=wp), parameter :: Angstrom = CONST_BOHR_RADIUS_IN_SI_*1.0e10_wp, &
                            atmToau = CONV_ATM_TO_AU_, &
                            atmToPa = CONST_ATM_IN_SI_, &
                            ATokg = CONST_AMU_IN_SI_, &
                            auTocm = CONV_AU_TO_CM1_, &
                            auToeV = CONV_AU_TO_EV_, &
                            auTofs = CONST_AU_TIME_IN_SI_*1.0e15_wp, &
                            auToHz = CONV_AU_TO_HZ_, &
                            auTokcalmol = CONV_AU_TO_KJ_PER_MOLE_/CONV_CAL_TO_J_, &
                            auTokJ = CONV_AU_TO_KJ_, &
                            auTokJmol = CONV_AU_TO_KJ_PER_MOLE_, &
                            auTokJmolnm = 1.0e-9*CONV_AU_TO_KJ_PER_MOLE_/CONST_BOHR_RADIUS_IN_SI_, &
                            auToN = CONV_AU_TO_KJ_/CONST_BOHR_RADIUS_IN_SI_*1.0e3_wp, &
                            auToT = CONV_AU_TO_T_, &
                            c_in_au = CONST_C_IN_AU_, &
                            cal_to_J = CONV_CAL_TO_J_, &
                            cLight = CONST_C_IN_SI_, &
                            cm_s = CONST_C_IN_SI_*1.0e2_wp, &
                            Debye = CONV_AU_TO_DEBYE_, &
                            deg2rad = Pi/180.0_wp, &
                            diel = CONST_DIELECTRIC_IN_SI_, &
                            elcharge = CONST_ELEMENTARY_CHARGE_IN_SI_, &
                            elmass = CONST_ELECTRON_MASS_IN_SI_, &
                            gElectron = CONST_ELECTRON_G_FACTOR_, &
                            hPlanck = CONST_PLANCK_, &
                            kBoltzmann = CONST_BOLTZMANN_, &
                            mBohr = CONST_BOHR_MAGNETON_IN_SI_, &
                            mu2elmass = CONST_MUON_MASS_IN_SI_/CONST_ELECTRON_MASS_IN_SI_, &
                            rBohr = CONST_BOHR_RADIUS_IN_SI_, &
                            Rgas = CONST_MOLAR_GAS_, &
                            rNAVO = CONST_AVOGADRO_, &
                            uToau = CONV_AMU_TO_AU_

public :: Angstrom, atmToau, atmToPa, ATokg, auTocm, auToeV, auTofs, auToHz, auTokcalmol, auTokJ, auTokJmol, auTokJmolnm, auToN, &
          auToT, c_in_au, cal_to_J, cLight, cm_s, cOne, cZero, Debye, deg2rad, diel, Eight, elcharge, Eleven, elmass, Five, Four, &
          gElectron, Half, hPlanck, kBoltzmann, mBohr, mu2elmass, Nine, One, OneHalf, Onei, Pi, Quart, rBohr, Rgas, rNAVO, Seven, &
          Six, Ten, Three, Twelve, Two, TwoP34, TwoP54, uToau, Zero

end module Constants

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHOSCF_MEM(nSym,nBas,nD,DoExchange,pNocc,ALGO,REORD,MinMem,lOff1)
!****************************************************************
!  Author : F. Aquilante
!
!  Purpose:
!            Returns an array MinMem that contains the minimum
!            amount of memory required for each Cholesky
!            vector for the building of the frozen AO-Fock matrix
!
!            The first vector is stored in a larger memory block
!            in some cases in order to re-use the allocated memory
!            for computing the exchange intermediate.
!            The value of LOFF1 specifies the amount of memory
!            reserved for the 1st vector
!
!            Note that this is a specialized code and can be used
!                 only in connection with the truth table defined
!                 in the calling routine
!*****************************************************************

use ChoArr, only: nDimRS
use Symmetry_Info, only: Mul
use Data_Structures, only: Integer_Pointer
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nD, ALGO
logical(kind=iwp), intent(in) :: DoExchange(*), REORD
type(Integer_Pointer), intent(in) :: pNocc(*)
integer(kind=iwp), intent(out) :: MinMem(nSym), lOff1
integer(kind=iwp) :: i, iSym, iSymp, j, jSym, ksym, Nab, nDen, Nmax, NSab, Mabmx(nSym), Moccmx(nSym), MxBas(nSym)
logical(kind=iwp) :: xToDo

!*************************************************
nDen = nD*(nD+1)/2
xToDo = DoExChange(nD)

!============================
lOff1 = 0
do i=1,nDen
  do j=1,nSym
    lOff1 = max(lOff1,pNocc(i)%I1(j))
  end do
end do

do j=1,nSym
  Moccmx(j) = 0
  do i=1,nDen
    Moccmx(j) = max(Moccmx(j),pNocc(i)%I1(j))
  end do
end do

! Max dimension of a read symmetry block
Nmax = 0
do iSym=1,nSym
  if ((NBAS(iSym) > Nmax) .and. (Moccmx(isym) /= 0)) then
    Nmax = NBAS(iSym)
  end if
end do

lOff1 = Nmax*lOff1

!============================
do jSym=1,nSym

  ! Total length of a vector
  Mabmx(jSym) = 0
  MxBas(jSym) = 0
  Nab = 0
  NSab = 0
  do ksym=1,nSym
    iSymp = Mul(ksym,jSym)
    if ((iSymp > ksym) .and. ((Moccmx(iSymp) /= 0) .or. (Moccmx(ksym) /= 0))) then
      Nab = Nab+nBas(ksym)*nBas(iSymp)
      Mabmx(jSym) = max(Mabmx(jSym),max(nBas(ksym)*Moccmx(iSymp),nBas(iSymp)*Moccmx(ksym)))
      MxBas(jSym) = max(MxBas(jSym),nBas(ksym)*nBas(iSymp))
    else
      if (iSymp == ksym) then ! all are needed for the Coulomb
        Nab = Nab+nBas(ksym)*(nBas(ksym)+1)/2
        NSab = NSab+nBas(ksym)**2
      end if
    end if
  end do

  !============================================================
  ! The following memory management is bound to the truth table
  ! assigned in the calling routine
  !============================================================

  if (.not. xToDo) then

    MinMem(jSym) = Nab+1 ! to store 1 vector of L(rJ),s + V(J)
    if (.not. REORD) then
      MinMem(jSym) = Nab+nDimRS(jSym,1)
      ! L + read 1 vect reduced set1
    end if

  else ! Memory for "off-diagonal" exchange only (jSym /= 1)

    if (REORD) then
      MinMem(jSym) = 2*Nab ! 1 vector of L(rJ),s + W(rJ),s
    else
      if (ALGO == 2) then
        MinMem(jSym) = Nab+max(nDimRS(jSym,1),Mabmx(jSym))
      else
        MinMem(jSym) = Nab+max(nDimRS(jSym,1),MxBas(jSym))
      end if
    end if

  end if

  !-----
  if (xToDo .and. (jSym == 1)) then ! jSym=1 is a special case

    if (nSym == 1) then

      if (ALGO == 2) then
        if (lOff1 > Nab) then
          MinMem(jSym) = lOff1+NSab
        else
          MinMem(jSym) = Nab+NSab
          lOff1 = Nab
        end if
      else

        MinMem(jSym) = 2*NSab
        lOff1 = NSab

      end if

    else  ! nSym > 1   jSym=1

      if (ALGO == 2) then
        if (lOff1 > nBas(1)*(nBas(1)+1)/2) then
          MinMem(jSym) = Nab-nBas(1)*(nBas(1)+1)/2+lOff1+Nmax**2
        else
          MinMem(jSym) = Nab+Nmax**2
          lOff1 = nBas(1)*(nBas(1)+1)/2
        end if
      else

        MinMem(jSym) = 2*(Nmax**2)+(Nab-nBas(1)*(nBas(1)+1)/2)
        lOff1 = Nmax**2

      end if

    end if

  end if ! JSYM=1  special case

! ====================================================================

end do ! loop over jSym

return

end subroutine CHOSCF_MEM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine   tosigZ(m1,m2,m3,m4,angint,
     *mcombina,ncontl1,ncontl2,ncontl3,
     *ncontl4,carteZ,preXZ,interxyz,isgnprod,
     *cleaner)
cbs   this subroutine combines the angular integrals
cbs   to the integrals for the real-valued linear
cbs   combinations for the sigma_Z part
cbs   definition of the real-valued linear combinations:
cbs
cbs
cbs   M=0  is the same as   Y(L,0)
cbs
cbs
cbs   M > 0
cbs
cbs   | L,M,+> = 2**(-0.5) ( (-1)**M Y(L,M) + Y(L,-M))
cbs
cbs   | L,M,-> = -i 2**(-0.5) ( (-1)**M Y(L,M) - Y(L,-M)) ($$$$)
cbs
cbs   only angular integrals of type 2 (sigma_0) contribute
cbs
      implicit real*8 (a-h,o-z)
#include "para.fh"
      parameter (fine=7.29735308D-03) !TO_BE_CHECKED
cbs   at least it's identical with Odd's valuE
      parameter (speed=1d0/fine)
      parameter (speed2=speed*speed)
      dimension mcombina(2,-Lmax:Lmax,-Lmax:Lmax,
     *-Lmax:Lmax,-Lmax:Lmax),
     *angint(ncontl1,ncontl2,ncontl3,ncontl4,*),
cbs  !!!!!!!!!!!changing now to the order of chemists notation!!!!!!!!!!
     *carteZ(ncontl1,ncontl3,ncontl2,ncontl4),
     *preXZ(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax),
     *interxyz(*),
     *isgnprod(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax),
     *isgnM(-1:1,-1:1,-1:1,-1:1)
      logical cleaner
cbs   cleaning up the integral-array
      irun=ncontl4*ncontl2*ncontl3*ncontl1
      call dzero(carteZ,irun)
c     write(6,*) 'begin tosigz'
cbs   set some signs
cbs   isgnM will give an additonal minus-sign if both m-values
cbs   (cartesian and angular) are negative  see $$$$
      do irun4=-1,1
      do irun3=-1,1
      do irun2=-1,1
      do irun1=-1,1
      isgnM(irun1,irun2,irun3,irun4)=1
      enddo
      enddo
      enddo
      enddo
      if (m1.lt.0) then
      do irun4=-1,1
      do irun3=-1,1
      do irun2=-1,1
      isgnM(-1,irun2,irun3,irun4)=
     *-isgnM(-1,irun2,irun3,irun4)
      enddo
      enddo
      enddo
      endif
      if (m2.lt.0) then
      do irun4=-1,1
      do irun3=-1,1
      do irun1=-1,1
      isgnM(irun1,-1,irun3,irun4)=
     *-isgnM(irun1,-1,irun3,irun4)
      enddo
      enddo
      enddo
      endif
      if (m3.lt.0) then
      do irun4=-1,1
      do irun2=-1,1
      do irun1=-1,1
      isgnM(irun1,irun2,-1,irun4)=
     *-isgnM(irun1,irun2,-1,irun4)
      enddo
      enddo
      enddo
      endif
      if (m4.lt.0) then
      do irun3=-1,1
      do irun2=-1,1
      do irun1=-1,1
      isgnM(irun1,irun2,irun3,-1)=
     *-isgnM(irun1,irun2,irun3,-1)
      enddo
      enddo
      enddo
      endif
cbs   define absolute m-values
      Mabs1=iabs(m1)
      Mabs2=iabs(m2)
      Mabs3=iabs(m3)
      Mabs4=iabs(m4)
      irun=0
      if (interxyz(1).eq.0) then
      write(6,*) 'tosigz: no interaction: ',m1,m2,m3,m4
      Call Abend()
      endif
      prexz1234=preXZ(m1,m2,m3,m4)
c      do while (interxyz(irun+1).gt.0)
       if(interxyz(irun+1).le.0) goto 777
666    continue
      irun=irun+1
c
cbs
cbs
cbs   This could be done with gotos, but I am biased to hate those..
cbs
cbs
         if (interxyz(irun).eq.1) then
         ityp=mcombina(1,Mabs1,Mabs2,Mabs3,Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 1',' ' )
         iblock=mcombina(2,Mabs1,Mabs2,Mabs3,Mabs4)
         factor=isgnM(1,1,1,1)*prexz1234*
     *   DBLE(isgnprod(Mabs1,Mabs2,Mabs3,Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.2) then
         ityp=mcombina(1,Mabs1,Mabs2,Mabs3,Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 2',' ' )
         iblock=mcombina(2,Mabs1,Mabs2,Mabs3,Mabs4)
         factor=-isgnM(-1,-1,-1,-1)*prexz1234*
     *   DBLE(isgnprod(-Mabs1,-Mabs2,-Mabs3,-Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.3) then
         ityp=mcombina(1,Mabs1,Mabs2,Mabs3,-Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 3',' ' )
         iblock=mcombina(2,Mabs1,Mabs2,Mabs3,-Mabs4)
         factor=isgnM(1,1,1,-1)*prexz1234*
     *   DBLE(isgnprod(Mabs1,Mabs2,Mabs3,-Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.4) then
         ityp=mcombina(1,Mabs1,Mabs2,Mabs3,-Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 4',' ' )
         iblock=mcombina(2,Mabs1,Mabs2,Mabs3,-Mabs4)
         factor=-isgnM(-1,-1,-1,1)*prexz1234*
     *   DBLE(isgnprod(-Mabs1,-Mabs2,-Mabs3,Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.5) then
         ityp=mcombina(1,Mabs1,Mabs2,-Mabs3,Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 5',' ' )
         iblock=mcombina(2,Mabs1,Mabs2,-Mabs3,Mabs4)
         factor=isgnM(1,1,-1,1)*prexz1234*
     *   DBLE(isgnprod(Mabs1,Mabs2,-Mabs3,Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.6) then
         ityp=mcombina(1,Mabs1,Mabs2,-Mabs3,Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 6',' ' )
         iblock=mcombina(2,Mabs1,Mabs2,-Mabs3,Mabs4)
         factor=-isgnM(-1,-1,1,-1)*prexz1234*
     *   DBLE(isgnprod(-Mabs1,-Mabs2,Mabs3,-Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.7) then
         ityp=mcombina(1,Mabs1,-Mabs2,Mabs3,Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 7',' ' )
         iblock=mcombina(2,Mabs1,-Mabs2,Mabs3,Mabs4)
         factor=isgnM(1,-1,1,1)*prexz1234*
     *   DBLE(isgnprod(Mabs1,-Mabs2,Mabs3,Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.8) then
         ityp=mcombina(1,Mabs1,-Mabs2,Mabs3,Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 8',' ' )
         iblock=mcombina(2,Mabs1,-Mabs2,Mabs3,Mabs4)
         factor=-isgnM(-1,1,-1,-1)*prexz1234*
     *   DBLE(isgnprod(-Mabs1,Mabs2,-Mabs3,-Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.9) then
         ityp=mcombina(1,Mabs1,-Mabs2,-Mabs3,-Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 9',' ' )
         iblock=mcombina(2,Mabs1,-Mabs2,-Mabs3,-Mabs4)
         factor=-isgnM(-1,1,1,1)*prexz1234*
     *   DBLE(isgnprod(-Mabs1,Mabs2,Mabs3,Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.10) then
         ityp=mcombina(1,Mabs1,-Mabs2,-Mabs3,-Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 10',' ' )
         iblock=mcombina(2,Mabs1,-Mabs2,-Mabs3,-Mabs4)
         factor=isgnM(1,-1,-1,-1)*prexz1234*
     *   DBLE(isgnprod(Mabs1,-Mabs2,-Mabs3,-Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.11) then
         ityp=mcombina(1,Mabs1,Mabs2,-Mabs3,-Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 11',' ' )
         iblock=mcombina(2,Mabs1,Mabs2,-Mabs3,-Mabs4)
         factor=isgnM(1,1,-1,-1)*prexz1234*
     *   DBLE(isgnprod(Mabs1,Mabs2,-Mabs3,-Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.12) then
         ityp=mcombina(1,Mabs1,Mabs2,-Mabs3,-Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 12',' ' )
         iblock=mcombina(2,Mabs1,Mabs2,-Mabs3,-Mabs4)
         factor=-isgnM(-1,-1,1,1)*prexz1234*
     *   DBLE(isgnprod(-Mabs1,-Mabs2,Mabs3,Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.13) then
         ityp=mcombina(1,Mabs1,-Mabs2,Mabs3,-Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 13',' ' )
         iblock=mcombina(2,Mabs1,-Mabs2,Mabs3,-Mabs4)
         factor=isgnM(1,-1,1,-1)*prexz1234*
     *   DBLE(isgnprod(Mabs1,-Mabs2,Mabs3,-Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.14) then
         ityp=mcombina(1,Mabs1,-Mabs2,Mabs3,-Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 14',' ' )
         iblock=mcombina(2,Mabs1,-Mabs2,Mabs3,-Mabs4)
         factor=-isgnM(-1,1,-1,1)*prexz1234*
     *   DBLE(isgnprod(-Mabs1,Mabs2,-Mabs3,Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.15) then
         ityp=mcombina(1,Mabs1,-Mabs2,-Mabs3,Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 15',' ' )
         iblock=mcombina(2,Mabs1,-Mabs2,-Mabs3,Mabs4)
         factor=isgnM(1,-1,-1,1)*prexz1234*
     *   DBLE(isgnprod(Mabs1,-Mabs2,-Mabs3,Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         elseif (interxyz(irun).eq.16) then
         ityp=mcombina(1,Mabs1,-Mabs2,-Mabs3,Mabs4)
         if (ityp.ne.2)
     *     Call SysAbendMsg('tosigz', 'wrong ityp in tosigz 16',' ' )
         iblock=mcombina(2,Mabs1,-Mabs2,-Mabs3,Mabs4)
         factor=-isgnM(-1,1,1,-1)*prexz1234*
     *   DBLE(isgnprod(-Mabs1,Mabs2,Mabs3,-Mabs4))
         call daxpint(angint(1,1,1,1,iblock),carteZ,
     *   factor,ncontl1,ncontl2,ncontl3,ncontl4)
c
         endif
c      enddo
        if(interxyz(irun+1).gt.0) goto 666
777     continue
        if (cleaner) then
        do irun4=1,ncontl4
        do irun2=1,ncontl2
        do irun1=1,ncontl1
        cartez(irun1,irun1,irun2,irun4)=0d0
        enddo
        enddo
        enddo
        endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine creates a runfile.                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! iOpt: Bitswitch                                                      *
!    1 -- Do not create if exist.                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund university, Sweden                                     *
! Written: August 2003                                                 *
!                                                                      *
!***********************************************************************

subroutine MkRun(iRc,iOpt)

use RunFile_data, only: icWr, IDRun, lw, nHdrSz, nToc, NulPtr, RunHdr, RunHdr2Arr, RunName, Toc, TypUnk, VNRun
use Para_Info, only: nProcs
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: iRc
integer(kind=iwp), intent(in) :: iOpt
integer(kind=iwp) :: Hdr(nHdrSz), iAllow, iDisk, Lu
logical(kind=iwp) :: ok
character(len=64) :: ErrMsg
integer(kind=iwp), allocatable :: Tmp(:)
character(len=lw), allocatable :: TmpLab(:)
integer(kind=iwp), external :: isFreeUnit

!----------------------------------------------------------------------*
! Check that arguments are ok.                                         *
!----------------------------------------------------------------------*
iAllow = not(ibset(0,0))
if (iand(iOpt,iAllow) /= 0) then
  write(ErrMsg,*) 'Illegal option flag:',iOpt
  call SysAbendMsg('MkRun',ErrMsg,' ')
end if
iRc = 0
!----------------------------------------------------------------------*
! Optionally do not create.                                            *
!----------------------------------------------------------------------*
if (btest(iOpt,0)) then
  call f_inquire(RunName,ok)
  if (ok) then
    !write(u6,*) '*** NOT creating runfile ',RunName
    return
  end if
end if
!write(u6,*) '*** Creating runfile ',RunName
!----------------------------------------------------------------------*
! Create it.                                                           *
!----------------------------------------------------------------------*
Lu = 11
Lu = isFreeUnit(Lu)

RunHdr%ID = IDrun
RunHdr%Ver = VNrun
RunHdr%Next = 0
RunHdr%Items = 0
RunHdr%nProcs = nProcs
call DaName(Lu,RunName)
iDisk = 0
call RunHdr2Arr(Hdr)
call iDaFile(Lu,icWr,Hdr,nHdrSz,iDisk)
RunHdr%Next = iDisk
iDisk = 0
call RunHdr2Arr(Hdr)
call iDaFile(Lu,icWr,Hdr,nHdrSz,iDisk)

iDisk = RunHdr%Next
call mma_allocate(Tmp,nToc,label='Tmp')
call mma_allocate(TmpLab,nToc,label='TmpLab')

TmpLab(:) = 'Empty'
RunHdr%DaLab = iDisk
call cDaFile(Lu,icWr,TmpLab,lw*nToc,iDisk)
Toc(:)%Lab = TmpLab(:)

Tmp(:) = NulPtr
RunHdr%DaPtr = iDisk
call iDaFile(Lu,icWr,Tmp,nToc,iDisk)
Toc(:)%Ptr = Tmp(:)

Tmp(:) = 0
RunHdr%DaLen = iDisk
call iDaFile(Lu,icWr,Tmp,nToc,iDisk)
Toc(:)%Len = Tmp(:)

RunHdr%DaMaxLen = iDisk
call iDaFile(Lu,icWr,Tmp,nToc,iDisk)
Toc(:)%MaxLen = Tmp(:)

Tmp(:) = TypUnk
RunHdr%DaTyp = iDisk
call iDaFile(Lu,icWr,Tmp,nToc,iDisk)
Toc(:)%Typ = Tmp(:)

call mma_deallocate(Tmp)
call mma_deallocate(TmpLab)
RunHdr%Next = iDisk
iDisk = 0
call RunHdr2Arr(Hdr)
call iDaFile(Lu,icWr,Hdr,nHdrSz,iDisk)

call DaClos(Lu)
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine MkRun

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Init_LoProp(nSym,nBas,nOrb,CoC,nAtoms,LP_context,nSize,nBas1,nBas2,nBasMax)

use loprop_arrays, only: LP_context_type
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: nSym, nBas(8), nOrb(8), nAtoms, nSize, nBas1, nBas2, nBasMax
real(kind=wp), intent(out) :: CoC(3)
type(LP_context_type), intent(out) :: LP_context
integer(kind=iwp) :: i, iDum, ISING, iSym
real(kind=wp) :: DET
logical(kind=iwp) :: lOrb
integer(kind=iwp), parameter :: Occ = 1, Vir = 0

!                                                                      *
!***********************************************************************
!                                                                      *
call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
call qpg_iarray('nOrb',lOrb,iDum)
if (lOrb) then
  call Get_iArray('nOrb',nOrb,nSym)
else
  nOrb(1:nSym) = nBas(1:nSym)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
nSize = 0
nBas1 = 0
nBas2 = 0
nBasMax = 0
do iSym=1,nSym
  nSize = nSize+nBas(iSym)*(nBas(iSym)+1)/2
  nBas1 = nBas1+nBas(iSym)
  nBas2 = nBas2+nBas(iSym)**2
  nBasMax = max(nBasMax,nBas(iSym))
end do
nSize = nSize+4
!                                                                      *
!***********************************************************************
!                                                                      *
! Center of Charge
call Get_dArray('Center of Charge',CoC,3)

! List coordinates of Coordinates
call Get_iScalar('LP_nCenter',nAtoms)
call mma_allocate(LP_context%C,3,nAtoms,label='C')
call Get_dArray('LP_Coor',LP_context%C,3*nAtoms)

! Effective charge at each center
call mma_allocate(LP_context%Q_Nuc,nAtoms,label='nAtoms')
call Get_dArray('LP_Q',LP_context%Q_Nuc,nAtoms)

! Atom number of each center
call mma_allocate(LP_context%ANr,nAtoms,label='ANr')
call Get_iArray('LP_A',LP_context%ANr,nAtoms)

! Pick up information of orbital type. Occ/Vir
call mma_allocate(LP_context%otype,nbas1,label='otype')
call Get_iArray('Orbital Type',LP_context%otype,nBas1)
do i=1,nBas1
  if ((LP_context%otype(i) /= Occ) .and. (LP_context%otype(i) /= Vir)) then
    write(u6,*) 'Orbital type vector is corrupted!'
    call Abend()
  end if
end do

! Pick up index array of which center a basis function belong.
call mma_allocate(LP_context%center,nbas1,label='center')
call Get_iArray('Center Index',LP_context%center,nBas1)

#ifdef _DEBUGPRINT_
write(u6,*) '******* LoProp Debug Info *******'
call RecPrt('Coordinates',' ',LP_context%C,3,nAtoms)
call RecPrt('Charges',' ',LP_context%Q_Nuc,1,nAtoms)
write(u6,*) 'Atom Nr:',LP_context%ANr(:)
do iBas=1,nBas1
  if (LP_context%otype(iBas) == Occ) then
    write(u6,'(A,I3,A)') 'Basis function ',iBas,' is occupied'
  else
    write(u6,'(A,I3,A)') 'Basis function ',iBas,' is virtual'
  end if
end do
write(u6,*)
do iBas=1,nBas1
  write(u6,'(A,I3,A,I3)') 'Basis function ',iBas,' belongs to center ',LP_context%center(iBas)
end do
write(u6,*) '*********************************'
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! In case of symmetry we need the desymmetrization matrix

if (nSym /= 1) then
  call mma_allocate(LP_context%P,nbas1,nbas1,label='P')
  call mma_allocate(LP_context%PInv,nbas1,nbas1,label='PInv')
  call Get_dArray('SM',LP_context%P,nbas1**2)
# ifdef _DEBUGPRINT_
  call RecPrt('SM',' ',LP_context%P,nbas1,nbas1)
# endif
  call MINV(LP_context%P,LP_context%PInv,ISING,DET,nBas1)
# ifdef _DEBUGPRINT_
  call RecPrt('SMInv',' ',LP_context%PInv,nbas1,nbas1)
# endif
  call DGeTMi(LP_context%PInv,nbas1,nbas1)
else
  call mma_allocate(LP_context%P,0,0,label='P')
  call mma_allocate(LP_context%PInv,0,0,label='PInv')
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Init_LoProp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!  Sl_Grad
!
!> @brief
!>   This subroutine is taken from the Anders program called Diffsph that calculates
!>   the Coulombic interaction between two Slater-type densities
!> @author A. Ohrn
!> @modified_by Jose
!>
!> @details
!> The subroutine (originally called ``Coulomb``) is taken and simplified
!> to QmStat purposes. Molecule A is going to be always the Solvent
!> Molecule and Molecule B the Quantum system. The subroutine is
!> writen for one center in the QM system, so it is called for each
!> center of the QM, and gives the Potential, Field and Field gradient
!> generated by all centers of the classical molecule in this center of the
!> QM molecule but considering the penetration. The original subroutine is for
!> classical molecules with as S (charge) slater distribution and a P
!> (dipole) distribution and it is not ready for Qmstat purposes.
!> Quantum molecule is represented up to \f$ L = 2 \f$. Interaction with
!> Multipole distributed Quadrupoles can be treated using an S
!> distribution in the clasical molecules. However a ``Logical``
!> variable is introduced to avoid the evaluation of this
!> iteraction and perform (in QmStat) less cumbersome calculations
!> using point charges in the classical molecule.
!>
!> This subroutine works with the Molcas order for the quadrupoles
!> \f$ xx=1 \f$, \f$ xy=2 \f$, \f$ xz=3 \f$, \f$ yy=4 \f$, \f$ yz=5 \f$ and \f$ zz=6 \f$
!> So the \p EintSl have to be changed outside the subroutine
!> to be adapted to the QmStat order
!> \f$ xx=1 \f$, \f$ xy=2 \f$, \f$ yy=3 \f$, \f$ xz=4 \f$, \f$ yz=5 \f$ and \f$ zz=6 \f$
!> The subroutine has the parameter \c _MxM_ that should be
!> changed if higher multipoles are included.
!***********************************************************************

subroutine Sl_Grad(nCentA,lMaxA,Coord,Dist,DInv,ExpoA,FactorA,SlPA,lMaxB,ExpoB,dNeigh,EintSl,EintSl_Nuc,lAtom)

use Index_Functions, only: nTri_Elem1, nTri3_Elem, nTri3_Elem1
use Constants, only: Zero, One, Three, Half
use Definitions, only: wp, iwp

! Maximum multipole implemented
#define _MxM_ 2

implicit none
integer(kind=iwp), intent(in) :: nCentA, lMaxA, lMaxB
real(kind=wp), intent(in) :: Coord(3,nCentA), Dist(nCentA), DInv(nCentA), ExpoA(2,nCentA), FactorA(4,nCentA), SlPA(nCentA), &
                             ExpoB(_MxM_+1), dNeigh
real(kind=wp), intent(out) :: EintSl(nTri3_Elem1(_MxM_)), EintSl_Nuc
logical(kind=iwp), intent(in) :: lAtom
integer(kind=iwp) :: iCA, iLA, iLB, kaunt, kComp, nS, nT
real(kind=wp) :: Colle(3), dKappa, EA, EAp, EB, EBp, R, Rho, RhoA, RhoB, Rinv, Rotte(3,3), Sigge, Tau, TMPA(nTri_Elem1(_MxM_)), &
                 TR(6,6), v(3)
logical(kind=iwp) :: lDiffA, lDiffB, lTooSmall

! Some zeros.
EintSl(:) = Zero
EintSl_Nuc = Zero

! Loop over all centers in molecule A.

do iCA=1,nCentA
  v(:) = Coord(:,iCA)
  R = Dist(iCA)
  Rinv = DInv(iCA)

  ! Obtain rotation matrix.

  call Revolution(v,Rinv,Rotte)

  ! Obtain the Matrix used to transform the Quadrupoles
  ! This 6x6 matrix is really 6 matrix of 3x3 in diagonal form
  ! Each element of each matrix gives the contribution from the
  ! old quadrupole to the new quadrupole (new coordinate system)
  ! Thus, if xx=1, xy=2, xz=3, yy=4, yz=5 and zz=6
  ! QNew(1)=Qold(1)*TD(1,1)+Qold(2)*TD(1,2)+Qold(3)+TD(1,3)+...
  ! So, to get field gradient for xx from the sigma interaction
  ! (see Anders paper) we have
  ! FG(xx)=FGSigma*(TD(6,1)-0.5(TD(1,1)*TD(4,1))). Remember that
  ! the Energy contribution in sigma is calculated using spherical
  ! harmonics so ESigma=FGSigma(Qnew(6)-0.5(Qnew(1)+Qnew(4)))

  call M2Trans(Rotte,TR)

  ! Loop over centres on A. Suck out exponents, factors and point-part. Rotate multipole.

  do iLA=0,lMaxA
    EA = ExpoA(iLA+1,iCA)
    lDiffA = EA > -One
    nS = nTri3_Elem(iLA)
    nT = nTri3_Elem((iLA+1))
    kaunt = 0
    do kComp=nS+1,nT
      kaunt = kaunt+1
      TMPA(kaunt) = FactorA(kComp,iCA)
    end do

    ! Rotate and go over to spherical representation.

    Sigge = -One
    call Rotation_qmstat(iLA,TMPA,Rotte,Sigge)

    ! Jose. Only one center in B so not loop over centres on B.
    !       Not Suck out Factors since we do not use them here.

    do iLB=0,lMaxB
      EB = ExpoB(iLB+1)
      lDiffB = EB > -One

      ! There is no rotation of Multipoles in B since we do not use them.

      ! ELECTRON--ELECTRON.

      EAp = Half*EA
      EBp = Half*EB
      if (lDiffA .and. lDiffB) then
        ! Both diffuse.

        call TKP(Tau,dKappa,Rho,RhoA,RhoB,EAp,EBp,R,dNeigh,lTooSmall)
        call ABBoth(iLA,iLB,TMPA,dKappa,Rho,RhoA,RhoB,Rinv,lTooSmall,Colle)
        if (iLB == 0) then
          EintSl(1) = EintSl(1)+Colle(1)
        else ! if iLB not 0 then it is 1
          if (iLA == 0) then
            EintSl(2:4) = EintSl(2:4)+Colle(1)*Rotte(3,:)
          else ! if iLA is not 0 is 1
            EintSl(2:4) = EintSl(2:4)+Colle(1)*Rotte(3,:)+Colle(2)*Rotte(1,:)+Colle(3)*Rotte(2,:)
          end if
        end if

      else if (lDiffA .and. (.not. lDiffB)) then
        ! One diffuse, one not diffuse.

        call ABOne(iLA,iLB,TMPA,EAp,R,Rinv,Colle,lDiffA)
        if (iLB == 0) then
          EintSl(1) = EintSl(1)+Colle(1)
        else if (iLB == 1) then
          if (iLA == 0) then
            EintSl(2:4) = EintSl(2:4)+Colle(1)*Rotte(3,:)
          else ! if iLA not 0 then it is 1
            EintSl(2:4) = EintSl(2:4)+Colle(1)*Rotte(3,:)+Colle(2)*Rotte(1,:)+Colle(3)*Rotte(2,:)
          end if
        else if (iLB == 2) then
          if (iLA == 0) then
            ! Remember Qsigma=z2-0.5(x2+y2)
            EintSl(5:10) = EintSl(5:10)+Colle(1)*(TR(6,:)-Half*(TR(1,:)+TR(4,:)))
          else ! if iLA not 0 then it is 1
            ! Remember Qsigma=z2-0.5(x2+y2) QPi1=sqrt(3)*xz QPi2=sqrt(3)*yz
            EintSl(5:10) = EintSl(5:10)+Colle(1)*(TR(6,:)-Half*(TR(1,:)+TR(4,:)))+ &
                           Colle(2)*sqrt(Three)*TR(3,:)+Colle(3)*sqrt(Three)*TR(5,:)
          end if
        end if

      else if ((.not. lDiffA) .and. lDiffB) then
        call ABOne(iLB,iLA,TMPA,EBp,R,Rinv,Colle,lDiffA)

        if (iLB == 0) then
          EintSl(1) = EintSl(1)+Colle(1)
        else ! if iLB not 0 then it is 1
          if (iLA == 0) then
            EintSl(2:4) = EintSl(2:4)+Colle(1)*Rotte(3,:)
          else ! is the same for iLA 1 and 2 because both have sigma pi1 and pi2 components regarding to B
            EintSl(2:4) = EintSl(2:4)+Colle(1)*Rotte(3,:)+Colle(2)*Rotte(1,:)+Colle(3)*Rotte(2,:)
          end if
        end if
      else if ((.not. lDiffA) .and. (.not. lDiffB)) then
        ! Neither diffuse.

        call ABNone(iLA,iLB,TMPA,Rinv,Colle)

        if (iLB == 0) then
          EintSl(1) = EintSl(1)+Colle(1)
        else if (iLB == 1) then
          if (iLA == 0) then
            EintSl(2:4) = EintSl(2:4)+Colle(1)*Rotte(3,:)
          else ! is the same for iLA 1 or 2
            EintSl(2:4) = EintSl(2:4)+Colle(1)*Rotte(3,:)+Colle(2)*Rotte(1,:)+Colle(3)*Rotte(2,:)
          end if
        else if (iLB == 2) then
          if (iLA == 0) then
            ! Remember Qsigma=z2-0.5(x2+y2)
            EintSl(5:10) = EintSl(5:10)+Colle(1)*(TR(6,:)-Half*(TR(1,:)+TR(4,:)))
          else if (iLA == 1) then
            ! Remember Qsigma=z2-0.5(x2+y2) QPi1=sqrt(3)*xz QPi2=sqrt(3)*yz
            EintSl(5:10) = EintSl(5:10)+Colle(1)*(TR(6,:)-Half*(TR(1,:)+TR(4,:)))+ &
                           Colle(2)*sqrt(Three)*TR(3,:)+Colle(3)*sqrt(Three)*TR(5,:)
          !Jose. This will be for a d-d interaction
          !else if (iLA == 2) then
          !  ! Remember Qsigma=z2-0.5(x2+y2) QPi1=sqrt(3)*xz QPi2=sqrt(3)*yz Del1=sqrt(3)*xy Del2=0.5*sqrt(3)*(x2-y2)
          !  EintSl(5:10) = EintSl(5:10)+Colle(1)*(TR(6,:)-Half*(TR(1,:)+TR(4,:)))+ &
          !                 Colle(2)*sqrt(Three)*TR(3,:)+Colle(3)*sqrt(Three)*TR(5,:)+ &
          !                 Colle(4)*sqrt(Three)*TR(2,:)+Colle(5)*Half*sqrt(Three)*(TR(1,:)-TR(4,:))
          !  end do
          !--------
          end if
        end if

      end if
    end do

    ! ELECTRON--POINT.

    ! Point on centre B.
    ! Jose. Potential, Field and Field Gradient of Multipole
    ! distribution in A on B (to obtain nuclear interaction in B)

    if (lAtom) then
      if (lDiffA) then
        call ABOne(iLA,0,TMPA,EAp,R,Rinv,Colle,lDiffA)
        EintSl_Nuc = EintSl_Nuc+Colle(1)
      else
        call ABNone(iLA,0,TMPA,Rinv,Colle)
        EintSl_Nuc = EintSl_Nuc+Colle(1)
      end if
    end if

  end do

  ! ELECTRON--POINT.

  ! Point on centre A.
  ! Jose. Potential, Field and Field Gradient of nuclear
  ! charge in A on the B sites

  if (SlPA(iCA) > 1.0e-8_wp) then
    do iLB=0,lMaxB
      EB = ExpoB(iLB+1)
      lDiffB = EB > -One
      EBp = Half*EB

      if (lDiffB) then
        call ABOne(iLB,0,SlPA(iCA),EBp,R,Rinv,Colle,.false.)
      else
        call ABNone(0,iLB,SlPA(iCA),Rinv,Colle)
      end if
      if (iLB == 0) then
        EintSl(1) = EintSl(1)+Colle(1)
      else if (iLB == 1) then
        EintSl(2:4) = EintSl(2:4)+Colle(1)*Rotte(3,:)
      else if (iLB == 2) then
        ! Remember Qsigma=z2-0.5(x2+y2)
        EintSl(5:10) = EintSl(5:10)+Colle(1)*(TR(6,:)-Half*(TR(1,:)+TR(4,:)))
      end if
    end do

    ! POINT--POINT.
    ! Jose. Potential of nuclear charge in A on B
    ! (to obtain nuclear interaction in B)
    if (lAtom) then
      call ABNone(0,0,SlPA(iCA),Rinv,Colle)
      EintSl_Nuc = EintSl_Nuc+Colle(1)
    end if
  end if

end do

return

end subroutine Sl_Grad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Francesco Aquilante                              *
!***********************************************************************

subroutine FnoSCF_putInf(mSym,lnOrb,lnOcc,lnFro,lnDel,lnVir)
! Purpose: put info in MP2 common blocks.

use ChoMP2, only: DoFNO, l_Dii
use cOrbInf, only: nDel, nExt, nFro, nOcc, nOrb, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: mSym, lnOrb(mSym), lnOcc(mSym), lnFro(mSym), lnDel(mSym), lnVir(mSym)

nSym = mSym

nOrb(1:nSym) = lnOrb(:)
nOcc(1:nSym) = lnOcc(:)
nFro(1:nSym) = lnFro(:)
nDel(1:nSym) = lnDel(:)
nExt(1:nSym) = lnVir(:)

DoFNO = .true.
l_Dii = sum(nOcc(:))

end subroutine FnoSCF_putInf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

function Cho_LK_ScreeningThreshold(delta)
! Thomas Bondo Pedersen, May 2013.
!
! Return the basic LK screening threshold. Input is a damping
! parameter, f.ex. the max. Fock matrix element in the previous
! iteration. Use delta < 0 or delta > 1 to avoid damping.
!
! The Cholesky environment must have been set up prior to calling
! this function [by calling Cho_X_Init(..)]

use Constants, only: Zero, One
use Definitions, only: wp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp) :: Cho_LK_ScreeningThreshold
real(kind=wp), intent(in) :: delta
#include "cholesky.fh"
real(kind=wp) :: thr
real(kind=wp), parameter :: thr0 = 1.0e-6_wp

thr = min(ThrCom,thr0)
if ((delta >= Zero) .and. (delta <= One)) then
  thr = thr*delta
end if
Cho_LK_ScreeningThreshold = max(thr,1.0e-15_wp)
#ifdef _DEBUGPRINT_
write(u6,'(1P,4(A,ES15.6))') 'ThrCom=',ThrCom,' thr0=',thr0,' delta=',delta,' Cho_LK_ScreeningThreshold=',Cho_LK_ScreeningThreshold
#endif

end function Cho_LK_ScreeningThreshold

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine  C_Adjust(CInter,n,CThr)
      Implicit None
      Integer n, i
      Real*8 CInter(n), CThr, Fact
*
      If (CInter(n).lt.CThr) Then
         Fact=(1.0D0-CThr)/(1.0D0-CInter(n))
         Do i = 1, n - 1
            CInter(i) = Fact * CInter(i)
         End Do
         CInter(n)=CThr
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module GUGX

use Definitions, only: wp, iwp

implicit none
private

! Split-Graph descriptor, sizes, addresses...
type SGStruct
  integer(kind=iwp) :: NSym = 0, nActEl = 0, IFRAS = 0
  integer(kind=iwp) :: IA0, IB0, IC0, iSpin, nLev, nVert, nVert0, MidLev, MVSta, MVEnd, MXUP, MXDWN, LV1RAS, LM1RAS, LV3RAS, LM3RAS
  integer(kind=iwp), allocatable :: ISm(:), DRT(:,:), DRT0(:,:), Down(:,:), Down0(:,:), Up(:,:), Ver(:), MAW(:,:), LTV(:), &
                                    DAW(:,:), RAW(:,:), SCR(:,:)
  integer(kind=iwp), pointer :: DRTP(:,:), DOWNP(:,:)
end type SGStruct

! CI Structures, addresses,..
type CIStruct
  integer(kind=iwp) :: nMidV, nIpWlk, nWalk
  integer(kind=iwp), allocatable :: NOW(:,:,:), IOW(:,:,:), NCSF(:), NOCSF(:,:,:), IOCSF(:,:,:), ICase(:), IVR(:,:), ISGM(:,:)
  real(kind=wp), allocatable :: VSGM(:,:)
end type CIStruct

! Excitation operators, coupling coefficients,...
type EXStruct
  integer(kind=iwp) :: MxEO, nICoup
  integer(kind=iwp), allocatable :: NOCP(:,:,:), IOCP(:,:,:), ICoup(:,:), MVL(:,:), MVR(:,:), USGN(:,:), LSGN(:,:)
  real(kind=wp), allocatable :: VTab(:), SGTMP(:)
end type EXStruct

type(SGStruct), target :: SGS
type(CIStruct), target :: CIS
type(EXStruct), target :: EXS

integer(kind=iwp), parameter :: MXLEV = 100
integer(kind=iwp) :: L2ACT(MXLEV), LEVEL(MXLEV)

public :: CIS, CIStruct, EXS, EXStruct, L2ACT, LEVEL, MXLEV, SGS, SGStruct

end module GUGX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine CiOvlp(jRoot,S1,S2,CI_vec)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Compute the overlap of the CI_vector, CI_vec, with the           *
!     a set of test vectors.                                           *
!                                                                      *
!     calling arguments:                                               *
!     jRoot   : integer                                                *
!               root identifier                                        *
!     S1      : array of real*8, input/output                          *
!               overlap matrix with test vectors                       *
!     S2      : array of real*8, input/output                          *
!               norm of the test configurations in the CI vector       *
!     CI_vec  : array of real*8, input                                 *
!               CI_vector                                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
#include "rasdim.fh"
#include "general.fh"
#include "rasscf.fh"
integer(kind=iwp), intent(in) :: jRoot
real(kind=wp), intent(inout) :: S1(lRoots,lRoots), S2(lRoots,lRoots)
real(kind=wp), intent(in) :: CI_vec(nConf)
integer(kind=iwp) :: iConf, kRef, kRoot
real(kind=wp) :: Sum1, Sum2

if (ITER == 1) return

do kRoot=1,nRoots
  Sum1 = Zero
  Sum2 = Zero
  do kRef=1,mxRef
    iConf = jCj(kRoot,kRef)
    if (iConf /= 0) then
      Sum1 = Sum1+cCI(kRoot,kRef)*CI_vec(iConf)
      Sum2 = Sum2+CI_vec(iConf)*CI_vec(iConf)
    end if
  end do
  S1(jRoot,kRoot) = abs(Sum1)
  S2(jRoot,kRoot) = Sum2
end do

return

end subroutine CiOvlp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FockTwo_Drv(nSym,nBas,nAux,Keep,
     &                       DLT,DSQ,FLT,nFLT,
     &                       ExFac,nBSQT,nBMX)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 DLT(*),DSQ(*),FLT(nFLT)
      Integer nBas(8), nAux(8), Keep(8)
      Logical DoCholesky,GenInt
      Integer ALGO
      Logical REORD,DECO
      Real*8 CMO_DUMMY(1)

      Common /CHORAS / REORD,DECO,ALGO
*
* nAux is the number of occupied orbitals
      GenInt=.false.
      DoCholesky=.false.
      if(ALGO.eq.0) GenInt=.true. !use GenInt to regenerate integrals

      Call DecideOnCholesky(DoCholesky)

      Call GetMem('LWFSQ','Allo','Real',LWFSQ,NBSQT)
      call dcopy_(NBSQT,[Zero],0,Work(LWFSQ),1)

      if((.not.DoCholesky).or.(GenInt)) then
      Call GetMem('LW2','Allo','Real',LW2,NBMX*NBMX)
      end if
*
      Call Allocate_Work(ipTemp,nFlt)
      Call FZero(Work(ipTemp),nFlt)
*
      Call GetMem('LW1','MAX','Real',LW1,LBUF)
*
* Standard building of the Fock matrix from Two-el integrals
*

      IF (.not.DoCholesky) THEN
         Call GetMem('LW1','Allo','Real',LW1,LBUF)

      If (LBUF.LT.1+NBMX**2) Then
         WRITE(6,*)' FockTwo_Drv Error: Too little memory remains for'
     &     //' the call to FOCKTWO.'
         WRITE(6,*)' Largest allocatable array size LBUF=',LBUF
         WRITE(6,*)' Max nr of bf in any symmetry,  NBMX=',NBMX
         WRITE(6,*)' Required minimum size     1+NBMX**2=',1+NBMX**2
         WRITE(6,*)'    (All in Real*8-size words)'
         Call  ABEND()
      End If
*
      Call FOCKTWO(nSym,nBas,nAux,Keep,
     &             DLT,DSQ,Work(ipTemp),nFlt,
     &             Work(LWFSQ),LBUF,Work(LW1),Work(LW2),ExFac)

      ENDIF
*
*
* Building of the Fock matrix regenerating the integrals on the fly
*
      IF (DoCholesky.and.GenInt) THEN ! save some space for GenInt
           LBUF = MAX(LBUF-LBUF/10,0)
           Call GetMem('LW1','Allo','Real',LW1,LBUF)

      If (LBUF.LT.1+NBMX**2) Then
         WRITE(6,*)' FockTwo_Drv Error: Too little memory remains for'
     &     //' the call to FOCKTWO.'
         WRITE(6,*)' Largest allocatable array size LBUF=',LBUF
         WRITE(6,*)' Max nr of bf in any symmetry,  NBMX=',NBMX
         WRITE(6,*)' Required minimum size     1+NBMX**2=',1+NBMX**2
         WRITE(6,*)'    (All in Real*8-size words)'
         Call  ABEND()
      End If
*
      Call FOCKTWO(nSym,nBas,nAux,Keep,
     &             DLT,DSQ,Work(ipTemp),nFlt,
     &             Work(LWFSQ),LBUF,Work(LW1),Work(LW2),ExFac)

      ENDIF

*
* Building of the Fock matrix directly from Cholesky vectors
*
      IF (DoCholesky .and. .not.GenInt) THEN

*
* CMO_DUMMY is required call argument of choras_drv:
* (Not used, see logical flags in choras_drv)
*      SUBROUTINE CHORAS_DRV(nSym,nBas,nOcc,DSQ,DLT,FLT,
*     &                      ExFac,LWFSQ,CMO)
       CALL CHOras_drv(nSym,nBas,nAux,DSQ,DLT,
     &                 Work(ipTemp),ExFac,LWFSQ,CMO_DUMMY)
*
      ENDIF
*


      Call DaXpY_(nFlt,One,Work(ipTemp),1,FLT,1)
*
      Call Free_Work(ipTemp)

      if(.not.DoCholesky)then
      Call GetMem('LW1','Free','Real',LW1,LBUF)
      Call GetMem('LW2','Free','Real',LW2,NBMX*NBMX)
      endif

      Call GetMem('LWFSQ','Free','Real',LWFSQ,NBSQT)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!               Giovanni Ghigo                                         *
!***********************************************************************

subroutine ListU(Lu,Lbl,gq,mInt,nIter)
!***********************************************************************
!                                                                      *
! Object: to print last gradient or internal coordinate list           *
!                                                                      *
! Called from: RlxCtl                                                  *
!                                                                      *
!   Author: Giovanni Ghigo                                             *
!   Adapted from List by Roland Lindh, Dept. of Theoretical Chemistry, *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lu, mInt, nIter
character(len=8), intent(in) :: Lbl(mInt)
real(kind=wp), intent(in) :: gq(mInt,nIter)
integer(kind=iwp) :: igq

write(Lu,*)
write(Lu,*) '****************************'
write(Lu,*) '* Value of internal forces *'
write(Lu,*) '----------------------------'
do igq=1,mInt
  write(Lu,'(1X,A8,1X,F9.5)') Lbl(igq),gq(igq,nIter)
end do
write(Lu,*)

return

end subroutine ListU

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  DefinePairDomain
*
*> @brief
*>   Define pair domains
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Pair domains are defined by the union of individual orbital
*> domains, \p iDomain(0:nAtom,nOcc), see SubRoutine ::DefineDomain.
*>
*> On exit, the contents of \p iPairDomain array are:
*>
*> - \p iPairDomain(0,ij): number of atoms in pair domain \c ij.
*> - \p iPairDomain(n,ij): id of atom \c n (\c n = ``1``, ``2``, ..., \p iPairDomain(0,ij)) in pair domain \c ij.
*>
*> The contents of \p Rmin array are:
*>
*> - \p Rmin(ij): minimum distance between atoms in pair \p ij.
*>
*> The contents of \p iClass array are (for \c i = ``1``, ``2`` , ``3``, ..., \p nRThr):
*>
*> - \p iClass(ij) = \c i-1 implies \p Rmin(ij) &le; \p RThr(i) and
*> - \p iClass(ij) = \p nRThr implies \p Rmin(ij) > \p RThr(nRThr)
*>
*> Note that if classification is not wanted, simply specify
*> \p nRThr = ``0`` (in which case arrays \p iClass and \p RThr are not referenced,
*> may be dummy arguments in the call to this routine).
*> The \p iDomain array should be set by SubRoutine ::DefineDomain
*> before calling this routine.
*>
*> Return codes:
*>
*> - \p irc = ``0``: all OK.
*>
*> (at the moment, this is the only possible return code, but that
*> might change.)
*>
*> @param[out] irc         Return code
*> @param[out] iPairDomain Pair domain definition
*> @param[out] iClass      Classification
*> @param[out] Rmin        Minimum interatomic distance in each pair
*> @param[in]  iDomain     Orbital domain definition
*> @param[in]  RThr        Thresholds for classification
*> @param[in]  Coord       Nuclear coordinates
*> @param[in]  nAtom       Number of atoms
*> @param[in]  nOcc        Number of orbitals for which domains are defined
*> @param[in]  nRThr       Number of thresholds for classification
************************************************************************
      SubRoutine DefinePairDomain(irc,iPairDomain,iClass,Rmin,iDomain,
     &                            RThr,Coord,nAtom,nOcc,nRThr)
      Implicit Real*8 (a-h,o-z)
      Integer iPairDomain(0:nAtom,*), iClass(*)
      Real*8  Rmin(*)
      Integer iDomain(0:nAtom,nOcc)
      Real*8  RThr(*), Coord(3,nAtom)
#include "WrkSpc.fh"

C     Set return code.
C     ----------------

      irc = 0
      If (nOcc .lt. 2) Return

C     Set pair domains as union of individual domains: [ij]=[i]U[j] for
C     i>=j.
C     -----------------------------------------------------------------

      nnOcc = nOcc*(nOcc+1)/2
      lT = (nAtom+1)*nnOcc
      Call iCopy(lT,[0],0,iPairDomain,1)

      l_Union = nAtom*nOcc
      Call GetMem('Union','Allo','Inte',ip_Union,l_Union)

      Call iCopy(l_Union,[0],0,iWork(ip_Union),1)
      kOff = ip_Union - 1
      Do i = 1,nOcc
         iOff = kOff + nAtom*(i-1)
         Do iA = 1,iDomain(0,i)
            iAtom = iDomain(iA,i)
            iWork(iOff+iAtom) = 1
         End Do
      End Do

      kOff = ip_Union - 1
      ij = 0
      Do j = 1,nOcc
         ij = ij + 1
         lD = iDomain(0,j) + 1
         Call iCopy(lD,iDomain(0,j),1,iPairDomain(0,ij),1) ! case i=j
         jOff = kOff + nAtom*(j-1)
         Do i = j+1,nOcc
            iOff = kOff + nAtom*(i-1)
            iCount = 0
            ij = ij + 1
            Do kAtom = 1,nAtom
               isThere = iWork(jOff+kAtom) + iWork(iOff+kAtom)
               If (isThere .gt. 0) Then
                  iCount = iCount + 1
                  iPairDomain(iCount,ij) = kAtom
               End If
            End Do
            iPairDomain(0,ij) = iCount
         End Do
      End Do

      Call GetMem('Union','Free','Inte',ip_Union,l_Union)

C     Set min. distance between any two atoms in pairs of domains.
C     ------------------------------------------------------------

      ij = 0
      Do j = 1,nOcc
         ij = ij + 1
         Rmin(ij) = 0.0d0 ! case i=j
         Do i = j+1,nOcc
            ij = ij + 1
            Rmin(ij) = 1.0d15
            Do jA = 1,iDomain(0,j)
               jAtom = iDomain(jA,j)
               Do iA = 1,iDomain(0,i)
                  iAtom = iDomain(iA,i)
                  R = sqrt((Coord(1,iAtom)-Coord(1,jAtom))**2
     &                    +(Coord(2,iAtom)-Coord(2,jAtom))**2
     &                    +(Coord(3,iAtom)-Coord(3,jAtom))**2)
                  Rmin(ij) = min(Rmin(ij),R)
               End Do
            End Do
         End Do
      End Do

C     Set classification for each pair domain.
C     Note that the caller must have ordered the thresholds according to
C     RThr(1) < RThr(2) < RThr(3) < ... < RThr(nRThr)
C     ------------------------------------------------------------------

      If (nRThr .gt. 0) Then
         Call iCopy(nnOcc,[nRThr],0,iClass,1)
         Do ij = 1,nnOcc
            i = 0
            Do While (i .lt. nRThr)
               i = i + 1
               If (Rmin(ij) .le. RThr(i)) Then
                  iClass(ij) = i - 1
                  i = nRThr ! break while loop
               End If
            End Do
         End Do
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine symtrizcvb2_cvb(vecstr,
     >  izeta,ipermzeta,dvbdet,vecstr2)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension vecstr(nvb)
      dimension izeta(nsyme),ipermzeta(norb,nzeta)
      dimension dvbdet(ndetvb),vecstr2(nvb)

      izeta1=0
      do 100 isyme=1,nsyme
      if(izeta(isyme).ne.0)then
        izeta1=izeta1+1
        call str2vbc_cvb(vecstr,dvbdet)
        call permvb_cvb(dvbdet,ipermzeta(1,izeta1))
        call vb2strc_cvb(dvbdet,vecstr2)
        call daxpy_(nvb,dble(izeta(isyme)),vecstr2,1,vecstr,1)
      endif
100   continue
      if(izeta1.gt.0)call dscal_(nvb,1d0/DBLE(2**izeta1),vecstr,1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!----------------------------------------------------------------------*
! This subroutine reads from the formatted output of mpprop the        *
! coordinates of the expansion centers.                                *
!----------------------------------------------------------------------*
subroutine Get_Centers(nAt,xyz)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(out) :: xyz(3,nAt,nAt)
integer(kind=iwp) :: i, j, jj, Lu
logical(kind=iwp) :: Exists
character(len=13) :: TheLine
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

! Open the file
Lu = IsFreeUnit(40)
call Opnfl('MPPROP',Lu,Exists)
if (.not. Exists) then
  write(u6,*)
  write(u6,*) ' Can not locate output file from MpProp. '
  call Quit(_RC_IO_ERROR_READ_)
end if
rewind(Lu)

! Read until you get standard line
do
  read(Lu,'(A)') TheLine
  if (TheLine == '* All centers') exit
end do
read(Lu,*) i

! Read atom centers.
do i=1,nAt
  read(Lu,'(A)') TheLine
  read(Lu,*) xyz(:,i,i)
  do j=1,10
    read(Lu,'(A)') TheLine
  end do
end do

! Read bond centers.
do i=2,nAt
  do j=1,i-1
    read(Lu,'(A)') TheLine
    read(Lu,*) xyz(:,i,j)
    do jj=1,10
      read(Lu,'(A)') TheLine
    end do
  end do
end do

! Square xyz for later convenience
do i=2,nAt
  do j=1,i-1
    xyz(:,j,i) = xyz(:,i,j)
  end do
end do

close(Lu)

return

end subroutine Get_Centers

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Per Ake Malmqvist                                *
************************************************************************
*****************************************************************
*  PROGRAM RASSI        PER-AAKE MALMQVIST
*  SUBROUTINE FINDT     IBM-3090 RELEASE 89 01 31
*  GIVEN CMO1 AND CMO2, FIND SUITABLE COUEFFICIENTS FOR THE
*  SINGLE-ORBITAL TRANSFORMATION SEQUENCE FOR EACH SET, RETURNED
*  IN ARRAYS TRA1 AND TRA2, FOR TRANSFORMATION INTO BIORTHONORMAL
*  ORBITALS.
*****************************************************************
      SUBROUTINE FINDT (CMO1,CMO2,TRA1,TRA2)
      use stdalloc, only: mma_allocate, mma_deallocate
      use Cntrl, only: PRSXY, PRTRA, PRORB
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NCMO,NTRA,NSXY,NBASF,NOSH
      IMPLICIT None
      Real*8 CMO1(NCMO),CMO2(NCMO)
      Real*8 TRA1(NTRA),TRA2(NTRA)
      Real*8, allocatable:: SXY(:), CXA(:), CYB(:)
      Integer NCXA, NCYB

C BEGIN BY COMPUTING MO OVERLAPS, SXY.
C MO OVERLAP MATRIX HAS SAME STRUCTURE AS TRA1,TRA2:
      NSXY=NTRA
      CALL mma_allocate(SXY,NSXY,Label='SXY')
      CALL MKSXY(CMO1,CMO2,SXY)
      IF (PRSXY) THEN
        WRITE(6,*)
        CALL WRMAT('MO OVERLAP MATRIX IN ORIGINAL ORBITAL BASES:',
     *             1,NOSH,NOSH,NSXY,SXY)
      END IF
C NEXT, DETERMINE SEQUENTIAL SINGLE-TRANSFORMATION
C COEFFICIENTS TRA.
      CALL PART(SXY,TRA1,TRA2)
      CALL mma_deallocate(SXY)
      IF (PRTRA) THEN
        WRITE(6,*)
        CALL WRMAT(
     *  'SINGLE-ORBITAL TRANSFORMATION COEFFS FOR STATE ONE (TRA1):',
     *             1,NOSH,NOSH,NTRA,TRA1)
        CALL WRMAT('FOR STATE TWO (TRA2):',
     *             1,NOSH,NOSH,NTRA,TRA2)
      END IF
C TRA1,TRA2 ARE NOT TRANSFORMATION MATRICES, ALTHOUGH THEY CONTAIN
C COEFFICIENTS FOR A SEQUENCE OF SINGLE-ORBITAL TRANSFORMATIONS.
C CONSTRUCT GENUINE TRANSFORMATION MATRICES (TEMPORARY) AND
C USE THEM TO TRANSFORM THE ORBITALS.
      NCXA=NTRA
      CALL mma_allocate(CXA,NCXA,Label='CXA')
      CALL MKCXA(NSYM,NOSH,NCXA,TRA1,CXA)
      CALL TRAORB(NSYM,NOSH,NBASF,NCXA,CXA,NCMO,CMO1)
      CALL mma_deallocate(CXA)
      NCYB=NTRA
      CALL mma_allocate(CYB,NCYB,Label='CYB')
      CALL MKCXA(NSYM,NOSH,NCYB,TRA2,CYB)
      CALL TRAORB(NSYM,NOSH,NBASF,NCYB,CYB,NCMO,CMO2)
      CALL mma_deallocate(CYB)
C print transformed MOs
      if (PRORB) then
        write(6,*)
        call WRMAT('TRANSFORMED MO COEFFICIENTS FOR STATE ONE (CMO1):',
     &               1,NBASF,NOSH,NCMO,CMO1)
        write(6,*)
        call WRMAT('TRANSFORMED MO COEFFICIENTS FOR STATE TWO (CMO2):',
     &               1,NBASF,NOSH,NCMO,CMO2)
      end if

      END SUBROUTINE FINDT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mhpfreei_cvb(ipoint)
      implicit real*8 (a-h,o-z)
#include "idbl_cvb.fh"
#include "memman_cvb.fh"

      if(memdebug)write(6,*)'   Enter mhpfreei: pointer :',ipoint
      iraddr=(ipoint-1)/idbl+1
      call mhpfreer_cvb(iraddr)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_GetBlockedOverlapMatrix(iOpt,ip_Blocks)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: get the overlap matrix stored as a block matrix.
C              Options:
C              iOpt=0: read the full overlap matrix from disk and
C                      reorder to block matrix.
C              iOpt=1: compute each block individually.
C                      (not implemented yet.)
C
      Implicit None
      Integer iOpt
      Integer ip_Blocks

      Character*27 SecNam
      Parameter (SecNam='LDF_GetBlockedOverlapMatrix')

      If (iOpt.eq.0) Then
         Call LDF_GetBlockedOverlapMatrix_0(ip_Blocks)
      Else If (iOpt.eq.1) Then
         Write(6,'(A,A,I10,A)')
     &   SecNam,': iOpt=',iOpt,' not implemented!'
         Call LDF_NotImplemented()
      Else
         Call WarningMessage(2,SecNam//': illegal option')
         Write(6,'(A,I10)') 'iOpt=',iOpt
         Call LDF_Quit(1)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_GetBlockedOverlapMatrix_0(ip_Blocks)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: get the overlap matrix stored as a block matrix.
C              Read the full overlap matrix from disk and
C              reorder to block matrix.
C
      Implicit None
      Integer ip_Blocks
#include "WrkSpc.fh"
#include "localdf_bas.fh"

      Character*29 SecNam
      Parameter (SecNam='LDF_GetBlockedOverlapMatrix_0')

      Character*8 Label

      Logical Packed
      Integer ip_S, l_S
      Integer irc
      Integer iOpt, iComp, iSyLab

      Packed=.True.
      l_S=nBas_Valence*(nBas_Valence+1)/2+4
      Call GetMem('LDFOVLP','Allo','Real',ip_S,l_S)
      irc=-1
      iOpt=2
      Label='Mltpl  0'
      iComp=1
      iSyLab=1
      Call RdOne(irc,iOpt,Label,iComp,Work(ip_S),iSyLab)
      If (irc.ne.0) Then
         Call WarningMessage(2,
     &                      SecNam//': non-zero return code from RdOne')
         Write(6,'(A,I10)') 'irc=',irc
         Call LDF_Quit(1)
      End If
      Call LDF_Full2Blocked(Work(ip_S),Packed,ip_Blocks)
      Call GetMem('LDFOVLP','Free','Real',ip_S,l_S)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefW4y2(aSGrp,bSGrp,cGrp,dGrp,w4y)
! this routine does:
! define w4y key, which indicates, if at least one
! W4 file needs to be calculated on this node for
! given a",b",c',d'

#ifdef _MOLCAS_MPP_
use Index_Functions, only: nTri_Elem
use chcc_global, only: GrpaLow, GrpaUp, InqW4
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: aSGrp, bSGrp, cGrp, dGrp
integer(kind=iwp), intent(out) :: w4y
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: abSGrp, cdSGrp, cSGrp, dSGrp, dSGrpUp

w4y = 0

! def abSGrp
abSGrp = nTri_Elem(aSGrp-1)+bSGrp

! cycle over  c">=d" for c',d'
do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
  if (cGrp == dGrp) then
    dSGrpUp = cSGrp
  else
    dSGrpUp = GrpaUp(dGrp)
  end if
  do dSGrp=GrpaLow(dGrp),dSGrpUp
    cdSGrp = nTri_Elem(cSGrp-1)+dSGrp
    if (InqW4(abSGrp,cdSGrp)) w4y = w4y+1
  end do
end do

#else

#include "macros.fh"
unused_var(aSGrp)
unused_var(bSGrp)
unused_var(cGrp)
unused_var(dGrp)

w4y = 1
#endif

return

end subroutine DefW4y2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_X_nVecRS
!
!> @brief
!>   Find first vector and number of vectors in reduced set \p iRed, sym. block \p iSym
!> @author Thomas Bondo Pedersen
!>
!> @details
!> This routine finds the first vector and number of
!> vectors in reduced set \p iRed, sym. block \p iSym.
!> Note that \p iVec=\p nVec = ``0`` may be returned---this is
!> perfectly acceptable: a given reduced set may be
!> empty. However, if negative numbers are returned
!> (\p iVec < ``0`` and \p nVec < ``0``), an error has ocurred. This
!> should be tested by the caller!!
!>
!> @note
!> The Cholesky procedure must have been successfully initialized (by ::Cho_X_Init).
!>
!> @param[in]  iRed Reduced set
!> @param[in]  iSym Symmetry block (1-8)
!> @param[out] iVec First vector in red. set \p iRed, sym. \p iSym
!> @param[out] nVec Number of vectors in red. set \p iRed, sym. \p iSym
!***********************************************************************

subroutine Cho_X_nVecRS(iRed,iSym,iVec,nVec)

use Cholesky, only: InfVec, MaxVec, nSym, NumCho
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iRed, iSym
integer(kind=iwp), intent(out) :: iVec, nVec
integer(kind=iwp) :: irc, jRed, jVec, LastRed
logical(kind=iwp) :: Found
character(len=*), parameter :: SecNam = 'Cho_X_nVecRS'

! Check input.
! ------------

irc = 0
if ((iSym < 1) .or. (iSym > nSym)) irc = -1
if ((NumCho(iSym) < 0) .or. (NumCho(iSym) > MaxVec)) irc = -2
if (NumCho(iSym) == 0) then
  iVec = 0
  nVec = 0
  return
end if
LastRed = InfVec(NumCho(iSym),2,iSym)
if (LastRed < 1) irc = -3
if (iRed < 1) irc = -4
if (irc /= 0) then
  iVec = irc
  nVec = irc
  return
end if
if (iRed > LastRed) then
  iVec = 0
  nVec = 0
  return
end if
nVec = 0

! Find first vector in reduced set iRed.
! --------------------------------------

Found = .false.
jVec = 0
do while ((jVec < NumCho(iSym)) .and. (.not. Found))
  jVec = jVec+1
  jRed = InfVec(jVec,2,iSym)
  if (jRed == iRed) then
    iVec = jVec
    Found = .true.
  else if (jRed > iRed) then
    jVec = NumCho(iSym)  ! break loop
  end if
end do

! No first vector <=> 0 vectors in reduced set iRed.
! --------------------------------------------------

if (.not. Found) then
  iVec = 0
  nVec = 0
  return
end if

! Count number of vectors in reduced set iRed.
! --------------------------------------------

nVec = 1
jVec = iVec
do while (jVec < NumCho(iSym))
  jVec = jVec+1
  jRed = InfVec(jVec,2,iSym)
  if (jRed == iRed) then
    nVec = nVec+1
  else
    jVec = NumCho(iSym) ! break loop
  end if
end do

#ifdef _DEBUGPRINT_
! Debug: print result.
! --------------------

write(u6,*) SecNam,': there are ',nVec,' vectors in reduced set ',iRed,' (sym. block ',iSym,')'
write(u6,*) SecNam,': first vector is: ',iVec
#endif

end subroutine Cho_X_nVecRS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PPMmG( &
#                define _CALLING_
#                include "mem_interface.fh"
                )

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: lalbm, lalbp, lambl, lapbl

#include "macros.fh"
unused_var(lr)

nHer = 0
Mem = 0

lapbl = max(nTri_Elem1(la+1),nTri_Elem1(lb))**2
Mem = Mem+2*lapbl

if (la > 0) then
  lambl = max(nTri_Elem1(la-1),nTri_Elem1(lb))**2
else
  lambl = 0
end if
Mem = Mem+2*lambl

lalbp = max(nTri_Elem1(la),nTri_Elem1(lb+1))**2
Mem = Mem+2*lalbp

if (lb > 0) then
  lalbm = max(nTri_Elem1(la),nTri_Elem1(lb-1))**2
else
  lalbm = 0
end if
Mem = Mem+2*lalbm

return

end subroutine PPMmG

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _GROMACS_

subroutine Opt_MMO(nAtIn,Coord,nAtOut,CoordMMO,nAtGMX,AT,ipGMS)

use, intrinsic :: iso_c_binding, only: c_loc, c_ptr
use espf_global, only: ConvF, MMI, MMIterMax, MMO, QM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Ten, Angstrom, auTokJmol, auTokJmolnm
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtIn, nAtOut, nAtGMX, AT(nAtGMX)
real(kind=wp), intent(in) :: Coord(3,nAtIn)
real(kind=wp), intent(inout) :: CoordMMO(3,nAtOut)
type(c_ptr), intent(in) :: ipGMS
integer(kind=iwp) :: i, iAtIn, iAtOut, iOk, iPL, MMIter
real(kind=wp) :: EnergyGMX, MaxF, OldEn, PotGMX(1), Step
character(len=256) :: Message
real(kind=wp), allocatable :: CoordGMX(:,:), FieldGMX(:,:), ForceGMX(:,:), GradMMO(:,:), NewCoord(:,:), OldCoord(:,:)
real(kind=wp), parameter :: AuToNm = Angstrom/Ten, NmToAng = Ten, TinyStep = 1.0e-50_wp*AuToNm
integer(kind=iwp), external :: iPL_espf
real(kind=wp), external :: ddot_

iPL = iPL_espf()

if (nAtOut == 0) then
  Message = 'Opt_MMO: subroutine called with nAtOut=0'
  call WarningMessage(2,Message)
  call Abend()
end if

! Set up arrays for use with Gromacs
call mma_allocate(CoordGMX,3,nAtGMX)
call mma_allocate(ForceGMX,3,nAtGMX)
call mma_allocate(FieldGMX,3,nAtGMX)
iAtIn = 1
iAtOut = 1
do i=1,nAtGMX
  if ((AT(i) == QM) .or. (AT(i) == MMI)) then
    CoordGMX(:,i) = Coord(:,iAtIn)
    iAtIn = iAtIn+1
  else
    CoordGMX(:,i) = CoordMMO(:,iAtOut)
    iAtOut = iAtOut+1
  end if
end do
CoordGMX(:,:) = CoordGMX*AuToNm

! Set up arrays with MMO coordinates and gradient
call mma_allocate(NewCoord,3,nAtOut)
call mma_allocate(OldCoord,3,nAtOut)
call mma_allocate(GradMMO,3,nAtOut)
NewCoord(:,:) = CoordMMO*AuToNm

if (iPL >= 2) then
  call CollapseOutput(1,'Gromacs microiterations')
  write(u6,*)
  write(u6,*) 'Initial coordinates (angstrom)'
  write(u6,*) '------------------------------'
  do i=1,nAtGMX
    if (AT(i) == QM) then
      write(u6,100) i,CoordGMX(:,i)*NmToAng,'QM'
    else if (AT(i) == MMI) then
      write(u6,100) i,CoordGMX(:,i)*NmToAng,'MMI'
    else
      write(u6,100) i,CoordGMX(:,i)*NmToAng,'MMO'
    end if
  end do
  write(u6,*)
end if

! MMO optimization cycle, performed in Gromacs units
Step = 0.1_wp*AuToNm
OldEn = huge(OldEn)
MaxF = huge(MaxF)
MMIter = 0
do while ((MMIter < MMIterMax) .and. (MaxF > ConvF) .and. (Step > TinyStep))
  MMIter = MMIter+1
  ! Get gradient from Gromacs
  iOk = mmslave_calc_energy_wrapper(ipGMS,CoordGMX,ForceGMX,FieldGMX,PotGMX,EnergyGMX)
  if (iOk /= 1) then
    Message = 'Opt_MMO: mmslave_calc_energy is not ok'
    call WarningMessage(2,Message)
    call Abend()
  end if
  iAtOut = 1
  do i=1,nAtGMX
    if (AT(i) == MMO) then
      GradMMO(1,iAtOut) = -ForceGMX(1,i)
      GradMMO(2,iAtOut) = -ForceGMX(2,i)
      GradMMO(3,iAtOut) = -ForceGMX(3,i)
      iAtOut = iAtOut+1
    end if
  end do
# ifdef _DEBUGPRINT_
  if (MMIter == 1) then
    write(u6,*) 'Iter       E          |F|         Fmax       Step'
    write(u6,*) '                     (Atomic units)'
    write(u6,*) '-----------------------------------------------------'
  end if
  if ((mod(MMIter,10) == 0) .or. (MMIter == 1)) &
    write(u6,200) MMIter,EnergyGMX/auTokJmol,sqrt(DDot_(3*nAtOut,GradMMO,1,GradMMO,1))/auTokJmolnm,MaxF/auTokJmolnm,Step/AuToNm
# endif
  ! Steepest descent with adaptive step a la Gromacs
  if ((EnergyGMX < OldEn) .or. (MMIter == 1)) then
    Step = 1.2_wp*Step
    MaxF = Zero
    do iAtOut=1,nAtOut
      do i=1,3
        MaxF = max(MaxF,abs(GradMMO(i,iAtOut)))
      end do
    end do
    OldEn = EnergyGMX
    OldCoord(:,:) = NewCoord
  else
    Step = 0.2_wp*Step
    NewCoord(:,:) = OldCoord
  end if
  NewCoord(:,:) = NewCoord-Step/MaxF*GradMMO
  ! Update coordinates for Gromacs
  iAtOut = 1
  do i=1,nAtGMX
    if (AT(i) == MMO) then
      CoordGMX(:,i) = NewCoord(:,iAtOut)
      iAtOut = iAtOut+1
    end if
  end do
end do

! Issue warning if calculation stopped for other reason than small F
if (MaxF > ConvF) then
  if (MMIter == MMIterMax) then
    Message = 'Maximum number of microiterations reached'
    call WarningMessage(1,Message)
  else if (Step <= TinyStep) then
    Message = 'Microiterations stopped due to zero step size'
    call WarningMessage(1,Message)
  end if
end if

! Undo the last move to recover the "converged" coordinates
if (MMIter > 0) then
  NewCoord(:,:) = OldCoord
  iAtOut = 1
  do i=1,nAtGMX
    if (AT(i) == MMO) then
      CoordGMX(:,i) = NewCoord(:,iAtOut)
      iAtOut = iAtOut+1
    end if
  end do
end if

if (iPL >= 2) then
  write(u6,*)
  write(u6,300) MMIter
  write(u6,400) MaxF/auTokJmolnm,ConvF/auTokJmolnm
  ForceGMX(:,:) = -ForceGMX/auTokJmolnm
  EnergyGMX = EnergyGMX/auTokJmol
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Properties'
  write(u6,*) '----------'
  write(u6,*) 'Energy: ',EnergyGMX
  do i=1,nAtGMX
    if (AT(i) == MMO) then
      write(u6,500) ForceGMX(:,i)
    else
      write(u6,500) Zero,Zero,Zero
    end if
  end do
# endif
  write(u6,*)
end if

! Put optimized MMO coordinates on runfile
CoordMMO(:,:) = NewCoord/AuToNm
call Put_dArray('MMO Coords',CoordMMO,3*nAtOut)

if (iPL >= 2) then
  if (MMIter > 1) then
    write(u6,*) 'Final coordinates (angstrom)'
    write(u6,*) '----------------------------'
    do i=1,nAtGMX
      if (AT(i) == QM) then
        write(u6,100) i,CoordGMX(:,i)*NmToAng,'QM'
      else if (AT(i) == MMI) then
        write(u6,100) i,CoordGMX(:,i)*NmToAng,'MMI'
      else
        write(u6,100) i,CoordGMX(:,i)*NmToAng,'MMO'
      end if
    end do
  end if
  call CollapseOutput(0,'Gromacs microiterations')
  write(u6,*)
end if

! Clean up
call mma_deallocate(CoordGMX)
call mma_deallocate(ForceGMX)
call mma_deallocate(FieldGMX)
call mma_deallocate(NewCoord)
call mma_deallocate(OldCoord)
call mma_deallocate(GradMMO)

return

100 format(I6,3(F12.6,1X),2X,A)
300 format(' Performed: ',I6,' MM iterations')
400 format(' Max. force: ',F12.6,' (convergence at: ',F12.6,')')
#ifdef _DEBUGPRINT_
200 format(I5,6ES12.4)
500 format(3(F12.6,1X))
#endif

contains

function mmslave_calc_energy_wrapper(gms,x,f,A,phi,energy)
  integer(kind=iwp) :: mmslave_calc_energy_wrapper
  type(c_ptr), intent(in) :: gms
  real(kind=wp), target, intent(in) :: x(*), f(*), A(*), phi(*)
  real(kind=wp), intent(out) :: energy
  interface
    function mmslave_calc_energy(gms,x,f,A,phi,energy) bind(C,NAME='mmslave_calc_energy_')
      use, intrinsic :: iso_c_binding, only: c_double, c_int, c_ptr
      integer(kind=c_int) :: mmslave_calc_energy
      type(c_ptr), value :: gms, x, f, A, phi
      real(kind=c_double) :: energy
    end function mmslave_calc_energy
  end interface
  mmslave_calc_energy_wrapper = mmslave_calc_energy(gms,c_loc(x(1)),c_loc(f(1)),c_loc(A(1)),c_loc(phi(1)),energy)
end function mmslave_calc_energy_wrapper

end subroutine Opt_MMO

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(Opt_MMO)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3addpck (wrk,wrksize,
     & nind,typap,mapda,mapia,ssa,mapdb,mapib,
     & ns,szkey,rc)
c
c     nind   - # of indexes in matrices A,B (Input)
c     typap  - typ of operation (see Table) (Input)
c     mapda  - direct map matrix corresponding to A (Input)
c     mapia  - inverse map matrix corresponding to A (Input)
c     ssa    - overall symmetry state of matrix A (Input)
c     mapdb  - direct map matrix corresponding to B (Input)
c     mapib  - inverse map matrix corresponding to B (Input)
c     ns     - signum of the operation (+-1) (Input)
c     szkey  - zet zero key (I)
c     = 0 no vanishing
c     = 1 set B=0 at the beggining
c     rc     - return (error) code (Output)
c
c     this routine is an addition to CCSD add/pack routine. It do not
c     realize operations, which is done there (add/pack), but only
c     additional ones, required in T3 code, namely:
c
c     Operation                        Nind TypA TypB typap
c
c     B(pqr)  = B + ns*(A(qr,p)-A(pr,q)+A(pq,r))    3    1    5    1
c     B(pq,r) = B + ns*(A(q,r,p)-A(p,r,q))          3    1    1    2
c     B(p,qr) = B + ns*(     -A(p,r,q)+A(p,q,r))    3    1    2    3
c
c     N.B. typab is redundant, it can be determined from mapd's
c     N.B. mapib is redundant
c
#include "t31.fh"
#include "wrk.fh"
c
       integer nind,typap,ssa,ns,szkey,rc
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
c
c     help variables
c
       integer ib,possb
       integer ia1,ia2,ia3,possa1,possa2,possa3
       integer syma,symb,symc,dima,dimb,dimc
       integer nhelp1,nhelp2
c
c
c0    some tests
c
       if (nind.ne.3) then
c     RC=1 : nind is not 3 (NCI)
       rc=1
       return
       end if
c
       if ((typap.eq.1).and.
     & ((mapda(0,6).ne.1).and.(mapdb(0,6).ne.5))) then
c     RC=2 : typap=1, typA=1, and typB is not 5 (Stup)
       rc=2
       return
       end if
c
       if ((typap.eq.2).and.
     & ((mapda(0,6).ne.0).and.(mapdb(0,6).ne.1))) then
c     RC=3 : typap=2, typA=0, and typB is not 1 (Stup)
       rc=3
       return
       end if
c
       if ((typap.eq.3).and.
     & ((mapda(0,6).ne.0).and.(mapdb(0,6).ne.2))) then
c     RC=4 : typap=3, typA=0, and typB is not 2 (Stup)
       rc=4
       return
       end if
c
c
       if (typap.eq.1) then
c1    case B(pqr) = B(pqr) + ns*(A(qr,p)-A(pr,q)+A(pq,r))
c
       do 100 ib=1,mapdb(0,5)
c
c1.*  def possition of b
       possb=mapdb(ib,1)
c
c1.*  def symmetry status
       syma=mapdb(ib,3)
       symb=mapdb(ib,4)
       symc=mapdb(ib,5)
c
c1.*  def dimensions
       dima=dimm(mapdb(0,1),syma)
       dimb=dimm(mapdb(0,2),symb)
       dimc=dimm(mapdb(0,3),symc)
c
c1.*  realize packing
c
       if (syma.eq.symc) then
c1.a  case syma=symb=symc
c
c1.a.*find address for a1,2,3 (the same one)
       ia1=mapia(symb,symc,1)
c
c1.a.*def possition of a1,2,3 (the same one)
       possa1=mapda(ia1,1)
c
c1.a.*def additional dimensions ab,abc
       nhelp1=dima*(dima-1)/2
       nhelp2=dima*(dima-1)*(dima-2)/6
c
c1.a.*do packing
       call t3aphlp4 (wrk(possa1),wrk(possb),dima,
     & nhelp1,nhelp2,ns,szkey)
c
       else if (syma.eq.symb) then
c1.b  case syma=symb.ne.symc
c
c1.b.*find address for a1,2,3
       ia1=mapia(symb,symc,1)
       ia2=mapia(syma,symc,1)
       ia3=mapia(syma,symb,1)
c
c1.b.*def possition of a1,2,3
       possa1=mapda(ia1,1)
       possa2=mapda(ia2,1)
       possa3=mapda(ia3,1)
c
c1.b.*def additional dimensions ab
       nhelp1=dima*(dima-1)/2
c
c1.b.*do packing
       call t3aphlp2 (wrk(possa1),wrk(possa2),wrk(possa3),
     & wrk(possb),
     & dima,dimb,dimc,nhelp1,ns,szkey)
c
       else if (symb.eq.symc) then
c1.c  case syma.ne.symb=symc
c
c1.c.*find address for a1,2,3
       ia1=mapia(symb,symc,1)
       ia2=mapia(syma,symc,1)
       ia3=mapia(syma,symb,1)
c
c1.c.*def possition of a1,2,3
       possa1=mapda(ia1,1)
       possa2=mapda(ia2,1)
       possa3=mapda(ia3,1)
c
c1.c.*def additional dimensions bc
       nhelp1=dimb*(dimb-1)/2
c
c1.c.*do packing
       call t3aphlp3 (wrk(possa1),wrk(possa2),wrk(possa3),
     & wrk(possb),
     & dima,dimb,dimc,nhelp1,ns,szkey)
c
       else
c1.d  case syma.ne.symb.ne.symc
c
c1.d.*find address for a1,2,3
       ia1=mapia(symb,symc,1)
       ia2=mapia(syma,symc,1)
       ia3=mapia(syma,symb,1)
c
c1.d.*def possition of a1,2,3
       possa1=mapda(ia1,1)
       possa2=mapda(ia2,1)
       possa3=mapda(ia3,1)
c
c1.d.*do packing
       call t3aphlp1 (wrk(possa1),wrk(possa2),wrk(possa3),
     & wrk(possb),
     & dima,dimb,dimc,ns,szkey)
c
       end if
c
c
 100    continue

       else if (typap.eq.2) then
c2    case B(pq,r) = B(pq,r) + ns*(A(q,r,p)-A(p,r,q))
c
       do 200 ib=1,mapdb(0,5)
c
c2.*  def possition of b
       possb=mapdb(ib,1)
c
c2.*  def symmetry status
       syma=mapdb(ib,3)
       symb=mapdb(ib,4)
       symc=mapdb(ib,5)
c
c2.*  def dimensions
       dima=dimm(mapdb(0,1),syma)
       dimb=dimm(mapdb(0,2),symb)
       dimc=dimm(mapdb(0,3),symc)
c
c2.*  realize packing
c
       if (syma.eq.symb) then
c2.a  case syma=symb,symc
c
c2.a.*find address for a1,2
       ia1=mapia(symb,symc,1)
       ia2=mapia(syma,symc,1)
c
c2.a.*def possition of a1,2,3
       possa1=mapda(ia1,1)
       possa2=mapda(ia2,1)
c
c2.a.*def additional dimensions ab
       nhelp1=dima*(dima-1)/2
c
c2.a.*do packing
       call t3aphlp6 (wrk(possa1),wrk(possa2),wrk(possb),
     & dima,dimb,dimc,nhelp1,ns,szkey)
c
       else
c2.b  case syma.ne.symb,symc
c
c2.b.*find address for a1,2
       ia1=mapia(symb,symc,1)
       ia2=mapia(syma,symc,1)
c
c2.b.*def possition of a1,2,3
       possa1=mapda(ia1,1)
       possa2=mapda(ia2,1)
c
c2.b.*do packing
       call t3aphlp5 (wrk(possa1),wrk(possa2),wrk(possb),
     & dima,dimb,dimc,ns,szkey)
c
       end if
c
 200    continue
c
c
       else if (typap.eq.3) then
c3    case B(p,qr) = B(p,qr) + ns*(-A(p,r,q)+A(p,q,r))
c
       do 300 ib=1,mapdb(0,5)
c
c3.*  def possition of b
       possb=mapdb(ib,1)
c
c3.*  def symmetry status
       syma=mapdb(ib,3)
       symb=mapdb(ib,4)
       symc=mapdb(ib,5)
c
c3.*  def dimensions
       dima=dimm(mapdb(0,1),syma)
       dimb=dimm(mapdb(0,2),symb)
       dimc=dimm(mapdb(0,3),symc)
c
c3.*  realize packing
c
       if (symb.eq.symc) then
c3.a  case syma,symb=symc
c
c3.a.*find address for a2,3
       ia2=mapia(syma,symc,1)
       ia3=mapia(syma,symb,1)
c
c3.a.*def possition of a2,3
       possa2=mapda(ia2,1)
       possa3=mapda(ia3,1)
c
c3.a.*def additional dimensions bc
       nhelp1=dimb*(dimb-1)/2
c
c3.a.*do packing
       call t3aphlp8 (wrk(possa2),wrk(possa3),wrk(possb),
     & dima,dimb,nhelp1,ns,szkey)
c
       else
c3.b  case syma,symb.ne.symc
c
c3.b.*find address for a2,3
       ia2=mapia(syma,symc,1)
       ia3=mapia(syma,symb,1)
c
c3.b.*def possition of a2,3
       possa2=mapda(ia2,1)
       possa3=mapda(ia3,1)
c
c3.b.*do packing
       call t3aphlp7 (wrk(possa2),wrk(possa3),wrk(possb),
     & dima,dimb,dimc,ns,szkey)
c
       end if
c
 300    continue
c
c
       else
c     RC=5 , typap is not 1,2,3 (NCI)
       rc=5
       return
c
       end if
c
       return
c Avoid unused argument warnings
       if (.false.) then
         call Unused_integer(ssa)
         call Unused_integer_array(mapib)
       end if
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2006, Markus Reiher                               *
************************************************************************
      subroutine output1 (dkhorder,xorder,paramtype,dkhscfflg)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.2
c
c   last modified: 11.10.2006 (MR, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,xorder,ramused
      character*(3) paramtype
      logical dkhscfflg
c
      If (DKH_Verbose) Then
      write (stdout,1001)
1001  format (//2X,'DKH PARSER : Symbolic construction and evaluation',
     *        ' of the Douglas--Kroll--Hess Hamiltonian',/2X,
     *        12('-'),/15X,'written by:  M. Reiher and A. Wolf  ',
     *        '(Univ. Bonn, 2004; Univ. Jena 2005, ETH Zurich 2006)',
     *        //15X,'References:  M.Reiher, A.Wolf, J. Chem. Phys. 121',
     *        ' (2004) 10945  (Hamiltonian),',
     *        /28X,'A.Wolf, M.Reiher, J. Chem. Phys. 124 (2006) ',
     *        '064103 (properties)',//2X)
c
      write (stdout,1011) dkhorder,xorder,paramtype
1011  format (5X,'DKH Hamiltonian order:',5X,I2,/5X,
     *        'DKH property order:',8X,I2,/5X,'Chosen parametrization',
     *        ' of unitary transformations U_i:',5X,A3,/)
c
      if (dkhscfflg) then
        write (stdout,1012)
1012    format (5X,'Treat property X variationally, i.e., U_i = ',
     *          'U_i(X).')
      else
        write (stdout,1013)
1013    format (5X,'Treat property X perturbatively, i.e., U_i is ',
     *          'independent of X.')
      endif
c
CMR      write (stdout,1015) maxoperators,maxuops,maxlength
CMR1015  format (/5X,'Max. number of operators:',6X,
CMR     *        'maxoperators =',I9,/5X,'Max. number of terms for U:',4X,
CMR     *        'maxuops',6X,'=',I9,/5X,'Max. length of each operator:',
CMR     *        2X,'maxlength',4X,'=',5X,I4)

      write (stdout,1023) dkhzero
1023  format (5X,'Zero threshold:',16X,'dkhzero',6X,'=',D13.5)
      if (dynthrsh.eq.0) write (stdout,1025) dynthrsh
      if (dynthrsh.eq.1) write (stdout,1026) dynthrsh
1025  format (5X,'No dynamical thresholding:     dynthrsh = ',I1,/)
1026  format (5X,'Use dynamical thresholding:    dynthrsh = ',I1,/)
      End If
c
c   Calculate approximate RAM requirements in MByte
c
      ramused = 4*maxoperators*(maxlength+20)
      ramused = ramused + (maxuops*(maxlength+24))
      ramused = ramused/8388608
c
CMR      write (stdout,1031) ramused
CMR1031  format (5X,'-->  Approximately ',I4,' MB RAM needed for symbolic',
CMR     *        ' DKH PARSER subroutines.'//)
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  CD_Tester
!
!> @brief
!>   Test the decomposition modules
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Runs and tests the output from the general Cholesky decomposers
!> ::ChoDec (out-of-core) and ::CD_InCore (in-core). The positive
!> definite matrix to which \p ip_PDM points should be stored as a
!> lower triangle.
!>
!> Error codes:
!> - \p irc = ``-1``: \p n non-positive (&rarr; nothing done)
!> - \p irc =  ``0``: all OK
!> - \p irc =  ``1``: error in ::ChoDec
!> - \p irc =  ``2``: error in ::CD_InCore
!> - \p irc =  ``3``: error in both
!>
!> @param[out] irc     Return code
!> @param[in]  PDM     matrix in \p Work
!> @param[in]  n       Dimension of matrix (\p n &times; \p n)
!> @param[in]  Verbose Print flag
!***********************************************************************

subroutine CD_Tester(irc,PDM,n,Verbose)

use Index_Functions, only: nTri_Elem
use Cho_interfaces, only: cdcol_kernel, cdvec_kernel
use CD_Tester_mod, only: Mat, Vec
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: PDM(nTri_Elem(n))
logical(kind=iwp), intent(in) :: Verbose
integer(kind=iwp) :: irc_sav, jrc, l_Buf, l_ES, l_iQual, l_Pivot, l_Qual, MxQual, NumCho
real(kind=wp) :: Span, Thr
logical(kind=iwp) :: Restart
real(kind=wp), allocatable :: Buf(:), Diag(:), ES(:), Qual(:)
integer(kind=iwp), allocatable :: iQual(:), Pivot(:)
character(len=*), parameter :: SecNam = 'CD_Tester'
procedure(cdcol_kernel) :: CD_Tester_Col
procedure(cdvec_kernel) :: CD_Tester_Vec

irc = 0
if (n < 1) then
  if (Verbose) then
    write(u6,*) SecNam,': nothing tested! Dimension is: n = ',n
    call xFlush(u6)
  end if
  return
end if

! Test ChoDec.
! ============

Restart = .false.
Thr = 1.0e-12_wp
Span = 1.0e-2_wp
MxQual = max(n/10,1)
NumCho = 0

irc_sav = irc
if (Verbose) then
  write(u6,*)
  write(u6,*) '          >>>>>>>>>>>><<<<<<<<<<<<'
  write(u6,*) '          >>>> Testing ChoDec <<<<'
  write(u6,*) '          >>>>>>>>>>>><<<<<<<<<<<<'
  write(u6,*)
  call xFlush(u6)
end if

call mma_allocate(Mat,n*n,Label='Mat')
call mma_allocate(Vec,n*n,Label='Vec')

l_Buf = n*(n+MxQual)
l_Qual = n*(MxQual+1)
l_ES = 6
l_Pivot = n
l_iQual = MxQual

call mma_allocate(Buf,l_Buf,Label='Buf')
call mma_allocate(Diag,n,Label='Diag')
call mma_allocate(Qual,l_Qual,Label='Qual')
call mma_allocate(ES,l_ES,Label='ES')
call mma_allocate(Pivot,l_Pivot,Label='Pivot')
call mma_allocate(iQual,l_iQual,Label='iQual')

call CD_Tester_CPPF(PDM,Mat,n)
call CD_Tester_Diag(PDM,Diag,n)
jrc = 0
call ChoDec(CD_Tester_Col,CD_Tester_Vec,Restart,Thr,Span,MxQual,Diag,Qual,Buf,Pivot,iQual,n,l_Buf,ES,NumCho,jrc)
if (jrc == 0) then
  call DGEMM_('N','T',n,n,NumCho,-One,Vec,n,Vec,n,One,Mat,n)
  call CD_Tester_ES(Mat,n,ES)
  call CD_Tester_Diff(Mat,n,ES(4))
  call CD_Tester_Final(jrc,NumCho,n,Thr,ES,Verbose)
  if (jrc /= 0) irc = irc+1
else
  if (Verbose) then
    write(u6,*) SecNam,': ChoDec returned error code ',jrc
    write(u6,*) '<=> decomposition failed, no test performed!'
    call xFlush(u6)
  end if
  irc = irc+1
end if
if (Verbose) then
  if (irc == irc_sav) then
    write(u6,*) 'ChoDec succeeded....'
  else
    write(u6,*) 'ChoDec failed....'
  end if
  call xFlush(u6)
end if

! Test in-core decomposition.
! ===========================

if (Verbose) then
  irc_sav = irc
  write(u6,*)
  write(u6,*) '          >>>>>>>>>>>><<<<<<<<<<<<<<<'
  write(u6,*) '          >>>> Testing CD_InCore <<<<'
  write(u6,*) '          >>>>>>>>>>>><<<<<<<<<<<<<<<'
  write(u6,*)
  call xFlush(u6)
end if

call CD_Tester_CPPF(PDM,Mat,n)
jrc = 0
NumCho = 0
call CD_InCore(Mat,n,Vec,n,NumCho,Thr,jrc)
if (jrc == 0) then
  call CD_Tester_CPPF(PDM,Mat,n)
  call DGEMM_('N','T',n,n,NumCho,-One,Vec,n,Vec,n,One,Mat,n)
  call CD_Tester_ES(Mat,n,ES)
  call CD_Tester_Diff(Mat,n,ES(4))
  call CD_Tester_Final(jrc,NumCho,n,Thr,ES,Verbose)
  if (jrc /= 0) irc = irc+2
else
  if (Verbose) then
    write(u6,*) SecNam,': CD_InCore returned error code ',jrc
    write(u6,*) '<=> decomposition failed, no test performed!'
    call xFlush(u6)
  end if
  irc = irc+2
end if
if (Verbose) then
  if (irc == irc_sav) then
    write(u6,*) 'CD_InCore succeeded....'
  else
    write(u6,*) 'CD_InCore failed....'
  end if
  write(u6,*)
  call xFlush(u6)
end if

call mma_deallocate(iQual)
call mma_deallocate(Pivot)
call mma_deallocate(ES)
call mma_deallocate(Qual)
call mma_deallocate(Diag)
call mma_deallocate(Buf)
call mma_deallocate(Vec)
call mma_deallocate(Mat)

end subroutine CD_Tester

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine saamphlp1 (t24a,t24b,t22b,noa,nob,nva,nvb,key)
c
c     adaptation routine for T2 amplitudes for symi=symj, syma=symb
c
c     t24a  - amplitides T2(ab,ij)aaaa (I/O)
c     t24b  - amplitides T2(ab,ij)bbbb (I/O)
c     t22b  - amplitides T2(a,b,i,j)abab (I/O)
c     noa   - number of alpha occupied orbitals in symi (I)
c     nob   - number of beta occupied orbitals in symi (I)
c     nva   - number of alpha virtual orbitals in syma (I)
c     nvb   - number of beta virtual orbitals in syma (I)
c     key   - type of adaptation (I)
c     0 - no adaptation
c     1 - T2 DDVV adaptation
c     2 - T2 DDVV + T1 DV adaptation
c     3 - full T1 and T2 adaptation (only for doublets)
c     4 - full T2 without SDVS (only for doublets)
c
       integer noa,nob,nva,nvb
cT2
       real*8 t24a(1:(nva*(nva-1))/2,1:(noa*(noa-1))/2)
       real*8 t24b(1:(nvb*(nvb-1))/2,1:(nob*(nob-1))/2)
       real*8 t22b(1:nva,1:nvb,1:noa,1:nob)
c
       integer key
c
c     help variables
c
       integer nd,nv,nsi,nsa
       integer i,j,a,b,ij,ab,ab1
       real*8 taaaa,tbbbb,tabab,tabba,tbaab,tbaba,t1,t2
c
       if (key.eq.0) return
c
       nd=nob
       nv=nva
       nsi=noa-nob
       nsa=nvb-nva
c
c
c     T2 adatption
c
c     case I) DDVV i>=j,a>=b
c     turn od in any case of type of adaption
c
c     aaaa=t24a(ijab) DDVV
c     bbbb=t24b(ijab) DDVV
c     abab=t22b(ijab) DDVV
c     abba=-t22b(ijba) DDVV
c     baab=-t22b(jiab) DDVV
c     baba=t22b(ji,ba) DDVV
c
c     direct
c     t1 = (abab+baba-abba-baab)/4
c     t2 = (2aaaa+2bbbb+abab+baba+abba+baab)/12
c
c     reverse
c
c     aaaa = 2t2
c     bbbb = 2t2
c     abab = t2+t1
c     abba = t2-t1
c     baab = t2-t1
c     baba = t2+t1
c
       do 100 a=2,nv
       do 1000 b=1,a-1
       ab=(a-1)*(a-2)/2+b
       ab1=(a+nsa-1)*(a+nsa-2)/2+b+nsa
       do 1001 i=2,nd
       do 1002 j=1,i-1
       ij=(i-1)*(i-2)/2+j
c
       taaaa=t24a(ab,ij)
       tbbbb=t24b(ab1,ij)
       tabab=t22b(a,b+nsa,i,j)
       tabba=-t22b(b,a+nsa,i,j)
       tbaab=-t22b(a,b+nsa,j,i)
       tbaba=t22b(b,a+nsa,j,i)
c
       t1=(tabab+tbaba-tabba-tbaab)/4.0d0
       t2=(2.0d0*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/1.2d1
c
       t24a(ab,ij)=2.0d0*t2
       t24b(ab1,ij)=2.0d0*t2
       t22b(a,b+nsa,i,j)=t2+t1
       t22b(b,a+nsa,i,j)=t1-t2
       t22b(a,b+nsa,j,i)=t1-t2
       t22b(b,a+nsa,j,i)=t2+t1
c
 1002   continue
 1001   continue
 1000   continue
 100    continue
c
       do 101 a=2,nv
       do 1010 b=1,a-1
       ab=(a-1)*(a-2)/2+b
       ab1=(a+nsa-1)*(a+nsa-2)/2+b+nsa
       do 1011 i=1,nd
       j=i
       ij=(i-1)*(i-2)/2+j
c
c     taaaa=t24a(ab,ij)
c     tbbbb=t24b(ab1,ij)
       tabab=t22b(a,b+nsa,i,j)
       tabba=-t22b(b,a+nsa,i,j)
       tbaab=-t22b(a,b+nsa,j,i)
       tbaba=t22b(b,a+nsa,j,i)
c
       t1=(tabab+tbaba-tabba-tbaab)/4.0d0
c     t2=(2.0d0*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/1.2d1
       t2=0.0d0
c
c     t24a(ab,ij)=2.0d0*t2
c     t24b(ab1,ij)=2.0d0*t2
       t22b(a,b+nsa,i,j)=t2+t1
       t22b(b,a+nsa,i,j)=t1-t2
       t22b(a,b+nsa,j,i)=t1-t2
       t22b(b,a+nsa,j,i)=t2+t1
c
 1011   continue
 1010   continue
 101    continue
c
       do 102 a=1,nv
       b=a
       ab=(a-1)*(a-2)/2+b
       ab1=(a+nsa-1)*(a+nsa-2)/2+b+nsa
       do 1020 i=2,nd
       do 1021 j=1,i-1
       ij=(i-1)*(i-2)/2+j
c
c     taaaa=t24a(ab,ij)
c     tbbbb=t24b(ab1,ij)
       tabab=t22b(a,b+nsa,i,j)
       tabba=-t22b(b,a+nsa,i,j)
       tbaab=-t22b(a,b+nsa,j,i)
       tbaba=t22b(b,a+nsa,j,i)
c
       t1=(tabab+tbaba-tabba-tbaab)/4.0d0
c     t2=(2.0d0*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/1.2d1
       t2=0.0d0
c
c     t24a(ab,ij)=2.0d0*t2
c     t24b(ab1,ij)=2.0d0*t2
       t22b(a,b+nsa,i,j)=t2+t1
       t22b(b,a+nsa,i,j)=t1-t2
       t22b(a,b+nsa,j,i)=t1-t2
       t22b(b,a+nsa,j,i)=t2+t1
c
 1021   continue
 1020   continue
 102    continue
c
       do 103 a=1,nv
       b=a
       ab=(a-1)*(a-2)/2+b
       ab1=(a+nsa-1)*(a+nsa-2)/2+b+nsa
       do 1030 i=1,nd
       j=i
       ij=(i-1)*(i-2)/2+j
c
c     taaaa=t24a(ab,ij)
c     tbbbb=t24b(ab1,ij)
       tabab=t22b(a,b+nsa,i,j)
       tabba=-t22b(b,a+nsa,i,j)
       tbaab=-t22b(a,b+nsa,j,i)
       tbaba=t22b(b,a+nsa,j,i)
c
       t1=(tabab+tbaba-tabba-tbaab)/4.0d0
c     t2=(2.0d0*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/1.2d1
       t2=0.0d0
c
c     t24a(ab,ij)=2.0d0*t2
c     t24b(ab1,ij)=2.0d0*t2
       t22b(a,b+nsa,i,j)=t2+t1
       t22b(b,a+nsa,i,j)=t1-t2
       t22b(a,b+nsa,j,i)=t1-t2
       t22b(b,a+nsa,j,i)=t2+t1
c
 1030   continue
 103    continue
c
c
       if (((key.eq.3).or.(key.eq.4)).and.(nsa.gt.0)) then
c
c     case II) DDVS i>=j,a,b
c
c     bbbb = t24b(ij,ab)
c     abab = t22b(i,j,a,b)
c     baab =-t22b(j,i,a,b)
c
c     direct :
c
c     t1=(abab-baab)/2
c     t2=(2bbbb+abab+baab)/6
c
c     reverse:
c
c     bbbb = 2t2
c     abab = t2+t1
c     baab = t2-t1
c
       b=nsa
       do 200 a=1,nv
       ab=a*(a-1)/2+b
       do 201 i=2,nd
       do 202 j=1,i-1
       ij=(i-1)*(i-2)/2+j
c
       tbbbb=t24b(ab,ij)
       tabab=t22b(a,b,i,j)
       tbaab=-t22b(a,b,j,i)
c
       t1=(tabab-tbaab)/2.0d0
       t2=(2.0d0*tbbbb+tabab+tbaab)/6.0d0
c
       t24b(ab,ij)=2.0d0*t2
       t22b(a,b,i,j)=t2+t1
       t22b(a,b,j,i)=t1-t2
c
 202    continue
 201    continue
 200    continue
c
       b=nsa
       do 203 a=1,nv
       ab=a*(a-1)/2+b
       do 204 i=1,nd
       j=i
       ij=(i-1)*(i-2)/2+j
c
c     tbbbb=t24b(ab,ij)
       tabab=t22b(a,b,i,j)
       tbaab=-t22b(a,b,j,i)
c
       t1=(tabab-tbaab)/2.0d0
c     t2=(2.0d0*tbbbb+tabab+tbaab)/6.0d0
       t2=0.0d0
c
c     t24b(ab,ij)=2.0d0*t2
       t22b(a,b,i,j)=t2+t1
       t22b(a,b,j,i)=t1-t2
c
 204    continue
 203    continue
c
       end if
c
c
       if (((key.eq.3).or.(key.eq.4)).and.(nsi.gt.0)) then
c
c     case III) SDVV i,j,a>=b
c
c     aaaa=t24a(ij,ab)
c     abab=t22b(i,j,a,b)
c     abba=-t22b(i,j,b,a)
c
c     direct
c
c     t1=(abab-abba)/2
c     t2=(2aaaa+abab+abba)/6
c
c     reverse
c
c     aaaa=2t2
c     abab=t2+t1
c     abba=t2-t1
c
       i=nd+nsi
       do 300 a=2,nv
       do 301 b=1,a-1
       ab=(a-1)*(a-2)/2+b
       do 302 j=1,nd
       ij=(i-1)*(i-2)/2+j
c
       taaaa=t24a(ab,ij)
       tabab=t22b(a,b+nsa,i,j)
       tabba=-t22b(b,a+nsa,i,j)
c
       t1=(tabab-tabba)/2.0d0
       t2=(2.0d0*taaaa+tabab+tabba)/6.0d0
c
       t24a(ab,ij)=2.0d0*t2
       t22b(a,b+nsa,i,j)=t2+t1
       t22b(b,a+nsa,i,j)=t1-t2
c
 302    continue
 301    continue
 300    continue
c
       i=nd+nsi
       do 303 a=1,nv
       b=a
       ab=(a-1)*(a-2)/2+b
       do 304 j=1,nd
       ij=(i-1)*(i-2)/2+j
c
c     taaaa=t24a(ab,ij)
       tabab=t22b(a,b+nsa,i,j)
       tabba=-t22b(b,a+nsa,i,j)
c
       t1=(tabab-tabba)/2.0d0
c     t2=(2.0d0*taaaa+tabab+tabba)/6.0d0
       t2=0.0d0
c
c     t24a(ab,ij)=2.0d0*t2
       t22b(a,b+nsa,i,j)=t2+t1
       t22b(b,a+nsa,i,j)=t1-t2
c
 304    continue
 303    continue
c
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Bjorn O. Roos                                    *
************************************************************************
      SUBROUTINE FCKPT2(CMOO,CMON,FI,FP,FTR,VEC,WO,SQ,CMOX)
*
* Purpose: To diagonalize the inactive, active,
* and external parts of the Fock matrix (FI+FA) for CASPT2
* and order the eigenvalues and eigenvectors after energy.
* This ordering is of value in subsequent CI and CASPT2
* calculations. All diagonal elements of
* the transformed Fock matrix are collected in FDIAG for
* later printing. The new MO's are written onto JOBIPH
* in address IADR15(9). Also the inactive Fock matrix FI
* is saved on Jobiph for use in CASPT2.
* Note:these orbitals leave the CI expansion
* invariant only for CAS wave functions.
* Called from SXCTL if IFINAL=1 (after last MC iteration)
*
* Modifications: - Produce full matrix FP and write it to JOBIPH.
* B. Roos, Lund, June 1990
*
* ********** IBM-3090 Release 88 09 07 **********
*

#ifdef _HDF5_
      use mh5, only: mh5_put_dset
#endif
      IMPLICIT REAL*8 (A-H,O-Z)

#ifdef _ENABLE_CHEMPS2_DMRG_
      Integer iChMolpro(8)
      Character*3 Label
#endif


#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
#include "WrkSpc.fh"
#include "raswfn.fh"
      Character*16 ROUTINE
      Parameter (ROUTINE='FCKPT2  ')

      DIMENSION CMOO(*),CMON(*),FI(*),FP(*),FTR(*),VEC(*),
     &          WO(*),SQ(*),CMOX(*)

* Local print level (if any)
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
*
      IB=0
      ISTMO1=1
      ISTFCK=0
      ID=0

#ifdef _ENABLE_CHEMPS2_DMRG_
      ifock=1
      norbtot = 0
      do iiash=1,nsym
        norbtot = norbtot + nAsh(iiash)
      enddo

* Get character table to convert MOLPRO symmetry format
      Call MOLPRO_ChTab(nSym,Label,iChMolpro)

* Convert orbital symmetry into MOLPRO format
      Call Getmem('OrbSym','Allo','Inte',lOrbSym,NAC)
      iOrb=1
      Do iSym=1,nSym
        Do jOrb=1,NASH(iSym)
          iWork(lOrbSym+iOrb-1)=iChMolpro(iSym)
          iOrb=iOrb+1
        End Do
      End Do
      lSymMolpro=iChMolpro(stSym)

      LuFCK=isFreeUnit(27)
*      open ( unit = LuFCK, file = "FOCK_CHEMPS2",
*     &        action="write", status="replace" )
      call molcas_open(LuFCK,'FOCK_CHEMPS2')
      write(LuFCK,'(1X,A12,I2,A1)') '&FOCK NACT= ', norbtot,','
      write(LuFCK,'(2X,A7)',ADVANCE = "NO") 'ORBSYM='
      do iOrb=1,norbtot
        write(LuFCK,'(I1,A1)',ADVANCE = "NO") iWork(lOrbSym+iOrb-1),','
      enddo
      write(LuFCK,*)
      write(LuFCK,*) '/'
      Call Getmem('OrbSym','Free','Inte',lOrbSym,NAC)
#endif

      DO ISYM=1,NSYM
       NBF=NBAS(ISYM)
       NFO=NFRO(ISYM)
       NIO=NISH(ISYM)
       NAO=NASH(ISYM)
       NR1=NRS1(ISYM)
       NR2=NRS2(ISYM)
       NR3=NRS3(ISYM)
       NEO=NSSH(ISYM)
       NOO=NFO+NIO+NAO
       NOT=NIO+NAO+NEO
       NOC=NIO+NAO
       ISTMO=ISTMO1+NFO*NBF
************************************************************************
* Frozen orbitals (move MO's to CMON and set FDIAG to zero)
************************************************************************
       IF(NFO.NE.0) THEN
        NFNB=NBF*NFO
        CALL DCOPY_(NFNB,CMOO(ISTMO1),1,CMON(ISTMO1),1)
        DO  NF=1,NFO
         FDIAG(IB+NF)=0.0D0
        END DO
       ENDIF
*
* Clear the MO transformation matrix CMOX
*
       CALL FZERO(CMOX,NOT*NOT)
*
************************************************************************
* Inactive part of the Fock matrix
************************************************************************
*
       IF(NIO.NE.0) THEN
* MOVE FP TO TRIANGULAR FORM
        NIJ=0
        DO NI=1,NIO
         DO NJ=1,NI
          NIJ=NIJ+1
          FTR(NIJ)=FP(NIJ+ISTFCK)
          IF(IXSYM(IB+NFO+NI).NE.IXSYM(IB+NFO+NJ)) FTR(NIJ)=0.0D0
         END DO
        END DO
* DIAGONALIZE
        NIO2=NIO**2
        CALL FZERO(VEC,NIO2)
        II=1
        DO NI=1,NIO
         VEC(II)=1.0D0
         II=II+NIO+1
        END DO
        CALL Jacob(FTR,VEC,NIO,NIO)
* MOVE EIGENVALUES TO FDIAG.
*
        II=0
        NO1=IB+NFO
        DO NI=1,NIO
         II=II+NI
         FDIAG(NO1+NI)=FTR(II)
        END DO
*
* Sort eigenvalues and orbitals after energy
*
        IF(NIO.GT.1) THEN
         NIO1=NIO-1
         DO NI=1,NIO1
          NI1=NI+1
          MIN=NI
          DO NJ=NI1,NIO
           IF(FDIAG(NO1+NJ).LT.FDIAG(NO1+MIN)) MIN=NJ
          END DO
          IF(MIN.EQ.NI) GO TO 20
          FMIN=FDIAG(NO1+MIN)
          FDIAG(NO1+MIN)=FDIAG(NO1+NI)
          FDIAG(NO1+NI)=FMIN
          CALL DSWAP_(NIO,VEC(1+NIO*(NI-1)),1,VEC(1+NIO*(MIN-1)),1)
20       CONTINUE
         END DO
        ENDIF
        CALL DGEADD(CMOX,NOT,'N',
     *              VEC,NIO,'N',CMOX,NOT,NIO,NIO)
       ENDIF
*
************************************************************************
* Active part of the Fock matrix
************************************************************************
*
       IF(NAO.NE.0) THEN
************************************************************************
* RAS1 part of the Fock matrix
************************************************************************
        IF(NR1.NE.0) THEN
* MOVE FP TO TRIANGULAR FORM
         NTU=0
         DO NT=1,NR1
          DO NU=1,NT
           NTU=NTU+1
           NTT=NT+NIO
           NUT=NU+NIO
           NTUT=ISTFCK+(NTT**2-NTT)/2+NUT
           FTR(NTU)= FP(NTUT)
           IF(IXSYM(IB+NFO+NTT).NE.IXSYM(IB+NFO+NUT)) FTR(NTU)=0.0D0
          END DO
         END DO
* DIAGONALIZE
         NR12=NR1**2
         CALL FZERO(VEC,NR12)
         II=1
         DO NT=1,NR1
          VEC(II)=1.0D0
          II=II+NR1+1
         END DO
         CALL Jacob(FTR,VEC,NR1,NR1)
*
* Move eigenvalues to FDIAG.
*
         II=0
         NO1=IB+NFO+NIO
         DO NT=1,NR1
          II=II+NT
          FDIAG(NO1+NT)=FTR(II)
         END DO
*
* Sort eigenvalues and orbitals after energy
*
         IF(NR1.GT.1) THEN
          NR11=NR1-1
          DO NT=1,NR11
           NT1=NT+1
           MIN=NT
           DO NU=NT1,NR1
            IF(FDIAG(NO1+NU).LT.FDIAG(NO1+MIN)) MIN=NU
           END DO
           IF(MIN.EQ.NT) GO TO 41
           FMIN=FDIAG(NO1+MIN)
           FDIAG(NO1+MIN)=FDIAG(NO1+NT)
           FDIAG(NO1+NT)=FMIN
           CALL DSWAP_(NR1,VEC(1+NR1*(NT-1)),1,VEC(1+NR1*(MIN-1)),1)
41         CONTINUE
          END DO
         ENDIF
         CALL DGEADD(CMOX(1+NOT*NIO+NIO),NOT,'N',
     *               VEC,NR1,'N',CMOX(1+NOT*NIO+NIO),NOT,NR1,NR1)

#ifdef _ENABLE_CHEMPS2_DMRG_
         II=0
         NO1=IB+NFO+NIO
         DO NT=1,NR1
           write(LuFCK,'(1X,E23.16E2,I4,I4)') FDIAG(NO1+NT),ifock,ifock
           ifock = ifock + 1
         END DO
#endif
        ENDIF ! NR1




************************************************************************
* RAS2 part of the Fock matrix
************************************************************************
        IF(NR2.NE.0) THEN
* MOVE FP TO TRIANGULAR FORM
         NTU=0
         DO NT=1,NR2
          DO NU=1,NT
           NTU=NTU+1
           NTT=NT+NIO+NR1
           NUT=NU+NIO+NR1
           NTUT=ISTFCK+(NTT**2-NTT)/2+NUT
           FTR(NTU)= FP(NTUT)
           IF(IXSYM(IB+NFO+NTT).NE.IXSYM(IB+NFO+NUT)) FTR(NTU)=0.0D0
          END DO
         END DO
* DIAGONALIZE
         NR22=NR2**2
         CALL FZERO(VEC,NR22)
         II=1
         DO NT=1,NR2
          VEC(II)=1.0D0
          II=II+NR2+1
         END DO
         CALL Jacob(FTR,VEC,NR2,NR2)
*
* Move eigenvalues to FDIAG.
*
         II=0
         NO1=IB+NFO+NIO+NR1
         DO NT=1,NR2
          II=II+NT
          FDIAG(NO1+NT)=FTR(II)
         END DO
*
* Sort eigenvalues and orbitals after energy
*
         IF(NR2.GT.1) THEN
          NR21=NR2-1
          DO NT=1,NR21
           NT1=NT+1
           MIN=NT
           DO NU=NT1,NR2
            IF(FDIAG(NO1+NU).LT.FDIAG(NO1+MIN)) MIN=NU
           END DO
           IF(MIN.EQ.NT) GO TO 42
           FMIN=FDIAG(NO1+MIN)
           FDIAG(NO1+MIN)=FDIAG(NO1+NT)
           FDIAG(NO1+NT)=FMIN
           CALL DSWAP_(NR2,VEC(1+NR2*(NT-1)),1,VEC(1+NR2*(MIN-1)),1)
42         CONTINUE
          END DO
         ENDIF
         CALL DGEADD(CMOX(1+NOT*(NIO+NR1)+NIO+NR1),NOT,'N',
     *               VEC,NR2,'N',
     *               CMOX(1+NOT*(NIO+NR1)+NIO+NR1),NOT,NR2,NR2)

#ifdef _ENABLE_CHEMPS2_DMRG_
         II=0
         NO1=IB+NFO+NIO+NR1
         DO NT=1,NR2
           write(LuFCK,'(1X,E23.16E2,I4,I4)') FDIAG(NO1+NT),ifock,ifock
           ifock = ifock + 1
         END DO
#endif
        ENDIF ! NR2

************************************************************************
* RAS3 part of the Fock matrix
************************************************************************
        IF(NR3.NE.0) THEN
* MOVE FP TO TRIANGULAR FORM
         NTU=0
         DO NT=1,NR3
          DO NU=1,NT
           NTU=NTU+1
           NTT=NT+NIO+NR1+NR2
           NUT=NU+NIO+NR1+NR2
           NTUT=ISTFCK+(NTT**2-NTT)/2+NUT
           FTR(NTU)= FP(NTUT)
           IF(IXSYM(IB+NFO+NTT).NE.IXSYM(IB+NFO+NUT)) FTR(NTU)=0.0D0
          END DO
         END DO
* DIAGONALIZE
         NR32=NR3**2
         CALL FZERO(VEC,NR32)
         II=1
         DO NT=1,NR3
          VEC(II)=1.0D0
          II=II+NR3+1
         END DO
         CALL Jacob(FTR,VEC,NR3,NR3)
*
* Move eigenvalues to FDIAG.
*
         II=0
         NO1=IB+NFO+NIO+NR1+NR2
         DO NT=1,NR3
          II=II+NT
          FDIAG(NO1+NT)=FTR(II)
         END DO
*
* Sort eigenvalues and orbitals after energy
*
         IF(NR3.GT.1) THEN
          NR31=NR3-1
          DO NT=1,NR31
           NT1=NT+1
           MIN=NT
           DO NU=NT1,NR3
            IF(FDIAG(NO1+NU).LT.FDIAG(NO1+MIN)) MIN=NU
           END DO
           IF(MIN.EQ.NT) GO TO 43
           FMIN=FDIAG(NO1+MIN)
           FDIAG(NO1+MIN)=FDIAG(NO1+NT)
           FDIAG(NO1+NT)=FMIN
           CALL DSWAP_(NR3,VEC(1+NR3*(NT-1)),1,VEC(1+NR3*(MIN-1)),1)
43         CONTINUE
          END DO
         ENDIF
         CALL DGEADD(CMOX(1+NOT*(NIO+NR1+NR2)+NIO+NR1+NR2),NOT,'N',
     *               VEC,NR3,'N',
     *               CMOX(1+NOT*(NIO+NR1+NR2)+NIO+NR1+NR2),NOT,NR3,NR3)

#ifdef _ENABLE_CHEMPS2_DMRG_
         II=0
         NO1=IB+NFO+NIO+NR1+NR2
         DO NT=1,NR3
           write(LuFCK,'(1X,E23.16E2,I4,I4)') FDIAG(NO1+NT),ifock,ifock
           ifock = ifock + 1
         END DO
#endif
        ENDIF ! NR3

       ENDIF ! NAO
*
************************************************************************
* external part of the Fock matrix
************************************************************************
       IF(NEO.NE.0) THEN
* MOVE FP TO TRIANGULAR FORM
        NAB=0
        DO NA=1,NEO
         DO NB=1,NA
          NAB=NAB+1
          NAT=NA+NIO+NAO
          NBT=NB+NIO+NAO
          NABT=ISTFCK+(NAT**2-NAT)/2+NBT
          FTR(NAB)=FP(NABT)
          IF(IXSYM(IB+NFO+NAT).NE.IXSYM(IB+NFO+NBT)) FTR(NAB)=0.0D0
         END DO
        END DO
* DIAGONALIZE
        NEO2=NEO**2
        CALL FZERO(VEC,NEO2)
        II=1
        DO NA=1,NEO
         VEC(II)=1.0D0
         II=II+NEO+1
        END DO
        CALL Jacob(FTR,VEC,NEO,NEO)
*
* Move eigenvalues to FDIAG.
*
        II=0
        NO1=IB+NFO+NIO+NAO
        DO NA=1,NEO
         II=II+NA
         FDIAG(NO1+NA)=FTR(II)
        END DO
*
* Sort eigenvalues and orbitals after energy
*
        IF(NEO.GT.1) THEN
         NEO1=NEO-1
         DO NA=1,NEO1
          NA1=NA+1
          MIN=NA
          DO NB=NA1,NEO
           IF(FDIAG(NO1+NB).LT.FDIAG(NO1+MIN)) MIN=NB
          END DO
          IF(MIN.EQ.NA) GO TO 60
          FMIN=FDIAG(NO1+MIN)
          FDIAG(NO1+MIN)=FDIAG(NO1+NA)
          FDIAG(NO1+NA)=FMIN
          CALL DSWAP_(NEO,VEC(1+NEO*(NA-1)),1,VEC(1+NEO*(MIN-1)),1)
60       CONTINUE
         END DO
        ENDIF
        CALL DGEADD(CMOX(1+NOT*NOC+NOC),NOT,'N',
     *              VEC,NEO,'N',CMOX(1+NOT*NOC+NOC),NOT,NEO,NEO)
       ENDIF
*
* Transform molecular orbitals
*
        IF ( NBF*NTOT.GT.0 )
     &  CALL DGEMM_('N','N',
     &              NBF,NOT,NOT,
     &              1.0d0,CMOO(ISTMO),NBF,
     &              CMOX,NOT,
     &              0.0d0,CMON(ISTMO),NBF)
*
************************************************************************
* Deleted orbitals (move MO's and set zero to FDIAG)
************************************************************************
       NDO=NDEL(ISYM)
       IF(NDO.NE.0) THEN
        NDNB=NDO*NBF
        IST=ISTMO1+NBF*(NOO+NEO)
        CALL DCOPY_(NDNB,CMOO(IST),1,CMON(IST),1)
        DO ND=1,NDO
         FDIAG(IB+NBF-NDO+ND)=0.0D0
        END DO
       ENDIF
*
* Transform inactive Fock matrix FI and the CASPT2 matrix FP
*
       IF(NOT.GT.0) THEN
        CALL SQUARE(FI(ISTFCK+1),SQ,1,NOT,NOT)
        CALL DGEMM_('N','N',
     &              NOT,NOT,NOT,
     &              1.0d0,SQ,NOT,
     &              CMOX,NOT,
     &              0.0d0,VEC,NOT)
        CALL DGEMM_('T','N',
     &              NOT,NOT,NOT,
     &              1.0d0,CMOX,NOT,
     &              VEC,NOT,
     &              0.0d0,SQ,NOT)
*
* Move transformed Fock matrix back to FI
*
        NPQ=ISTFCK
        DO NP=1,NOT
         DO NQ=1,NP
          NPQ=NPQ+1
          FI(NPQ)=SQ(NOT*(NP-1)+NQ)
         END DO
        END DO
*
* The FP matrix
*
        CALL SQUARE(FP(ISTFCK+1),SQ,1,NOT,NOT)
        CALL DGEMM_('N','N',
     &              NOT,NOT,NOT,
     &              1.0d0,SQ,NOT,
     &              CMOX,NOT,
     &              0.0d0,VEC,NOT)
        CALL DGEMM_('T','N',
     &              NOT,NOT,NOT,
     &              1.0d0,CMOX,NOT,
     &              VEC,NOT,
     &              0.0d0,SQ,NOT)
*
* Move transformed Fock matrix back to FP
*
        NPQ=ISTFCK
        DO NP=1,NOT
         DO NQ=1,NP
          NPQ=NPQ+1
          FP(NPQ)=SQ(NOT*(NP-1)+NQ)
         END DO
        END DO
       ENDIF
*
       IB=IB+NBF
       ISTFCK=ISTFCK+(NOT**2+NOT)/2
       ISTMO1=ISTMO1+NBF**2
       ID=ID+(NAO**2+NAO)/2
      END DO
*
#ifdef _ENABLE_CHEMPS2_DMRG_
*      close(27)
      close(LuFCK)
#endif
      IF(IPRLEV.GE.VERBOSE) THEN
       Write(LF,*)' Diagonal elements of the Fock matrix in FCKPT2:'
       Write(LF,'(1X,10F11.6)') (FDIAG(I),I=1,NTOT)
      END IF
*
************************************************************************
* Orthogonalise new orbitals
************************************************************************
*
      CALL SUPSCH(WO,CMOO,CMON)
      CALL ORTHO_RASSCF(WO,CMOX,CMON,SQ)
*
************************************************************************
* Write new orbitals to JOBIPH/rasscf.h5
************************************************************************
*
        If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' CMO in FCKPT2 after diag and orthog'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         ioff=0
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          if(iBas.ne.0) then
            write(6,*) 'Sym =', iSym
            do i= 1,iBas
              write(6,*) (CMON(ioff+iBas*(i-1)+j),j=1,iBas)
            end do
            iOff = iOff + (iBas*iBas)
          end if
         End Do
        End If

      IAD15=IADR15(9)
      CALL DDAFILE(JOBIPH,1,CMON,NTOT2,IAD15)
#ifdef _HDF5_
        call mh5_put_dset(wfn_mocoef,CMON)
#endif
*
* Write FI, FP and FDIAG to JOBIPH
* First remove frozen and deleted part of FDIAG
*
      IF=0
      IFD=0
      DO ISYM=1,NSYM
       NBF=NBAS(ISYM)
       DO NB=1,NBF
        IFD=IFD+1
        IF(NB.GT.NFRO(ISYM).AND.NB.LE.NBF-NDEL(ISYM)) THEN
         IF=IF+1
         SQ(IF)=FDIAG(IFD)
        ENDIF
       END DO
      END DO
*
      IAD15=IADR15(10)
      CALL DDAFILE(JOBIPH,1,FI,NTOT3,IAD15)
      CALL DDAFILE(JOBIPH,1,FP,NTOT3,IAD15)
      CALL DDAFILE(JOBIPH,1,SQ,NORBT,IAD15)
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_D1AV(D1AV,nD1AV)
      Implicit Real*8 (A-H,O-Z)
      Character*24 Label
      Logical      Found
      Real*8 D1AV(nD1AV)

      Label='D1av'
      Call qpg_dArray(Label,Found,mD1AV)
      If(.not.Found .or. mD1AV.eq.0) Then
         Call SysAbendMsg('Get_D1AV','Did not find:',Label)
      End If
      If (nD1AV/=mD1AV) Then
         Write (6,*) 'Get_D1AV: nD1AV/=mD1AV'
         Write (6,*) 'nD1AV=',nD1AV
         Write (6,*) 'mD1AV=',mD1AV
         Call Abend()
      End If

      Call Get_dArray(Label,D1AV,nD1AV)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
* This routine prints the body part to the postscript figure of        *
* occupation numbers.                                                  *
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine FigPrt(lu,Title,nLqn,nOrb,Occ)
      Implicit Real*8 (a-h,o-z)
      Dimension nOrb(0:nLqn),Occ(*)
      Dimension iOff(0:25)
      Character*(*) Title
      Character*1 type(0:5)
      Data type/'s','p','d','f','g','h'/
      Write(lu,'(a)') 'HF setfont'
      Write(lu,'(a)') '2.25 X -7.0 Y moveto'
      k0 =0
      k1 =0
      Do 10 i=len(Title),1,-1
         If(Title(i:i).ne.' ') k0=i
10    Continue
      Do 20 i=1,len(Title)
         If(Title(i:i).ne.' ') k1=i
20    Continue
      Write(lu,'(3a)') '(',Title(k0:k1),') CenterLine'
      nOff=0
      mxNqn=0
      Do 100 i=0,nLqn
         if(nOrb(i).gt.0) mxNqn=max(mxNqn,nOrb(i)+i)
         iOff(i)=nOff
         nOff=nOff+nOrb(i)
100   Continue
      Do 200 n=1,mxNqn
         Write(lu,'(a,i2)') '%--- shell n=',n
         lqn0=nLqn
         lqn1=0
         Do 210 i=0,min(n-1,nLqn)
            If(n-i.le.nOrb(i)) Then
               If(i.gt.lqn1) lqn1=i
               If(i.lt.lqn0) lqn0=i
               O=log10(Occ(iOff(i)+n-i))
               Write(lu,'(i2,a,f7.4,a)') i,' X ',O,' Y Draw'
            End If
210      Continue
         if(n.lt.10) Then
            Write(lu,'(a,i1,a,a,i1,a,a)')
     &         ' (',n,type(lqn0),'\261',n,type(lqn1),') Label'
         Else
            Write(lu,'(a,i2,a,a,i2,a,a)')
     &         ' (',n,type(lqn0),'\261',n,type(lqn1),') Label'
         End If
         Do 220 i=1,min(n-1,nLqn)
            If( (n-i.le.nOrb(i)).and.(n-i+1.le.nOrb(i-1)) ) Then
               Oa=log10(Occ(iOff(i-1)+n-i+1))
               Ob=log10(Occ(iOff(i)+n-i))
               Write(lu,'(i2,a,f7.4,a,i2,a,f7.4,a)')
     &            i-1,' X ',Oa,' Y ',i,' X ',Ob,' Y Connect'
            End If
220      Continue
200   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKWWOPF(IVEC,JVEC,NOP2,OP2)
! Presently symmetry blocking is disregarded, but index pair
! permutation symmetry is used.
! NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)

! Given the coefficients for two excitation operators, available in
! vectors numbered IVEC and JVEC on file, use the blocks for
! excitation cases BVAT(+) and BVAT(-), i.e. cases 8 and 9, to
! construct the zero-, one-, and two-body
! expansions of the product (Op in IVEC conjugated)(Op in JVEC)
! as operating on the CASSCF space.
! Formulae used:
! For the F+ case (i.e. case 8)
! W1(tu,ab)(conj)*W2(xy,cd) = (dac*dbd)*(2 Etxuy + 2 Etyux)
! For the F- case (i.e. case 9)
! W1(tu,ab)(conj)*W2(xy,cd) = (dac*dbd)*(2 Etxuy - 2 Etyux)

use Index_Functions, only: iTri
use SUPERINDEX, only: MTGEU, MTGTU
use EQSOLV, only: MODVEC
use caspt2_module, only: NASHT, NASUP, NINDEP, NISUP, NSYM, NTGEUES, NTGTUES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC, NOP2
real(kind=wp), intent(inout) :: OP2(NOP2)
integer(kind=iwp) :: ICASE, IIEND, IISTA, ISCT, ISYM, ITABS, ITU, ITUABS, ITX, ITY, IUABS, IUX, IUY, IW1, IW2, IWPROD, IXABS, IXY, &
                     IXYABS, IYABS, JTXUY, JTYUX, MDVEC, NAS, NCOL, NIS, NWPROD
real(kind=wp) :: W_PROD
real(kind=wp), allocatable :: WPROD(:)
real(kind=wp), allocatable, target :: W1(:), W2_H(:)
real(kind=wp), pointer :: W2(:)

! FIRST THE F+ i.e. BVAT+ i.e. CASE 8 -----------------------------
ICASE = 8
! Loop over symmetry ISYM
do ISYM=1,NSYM
  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  if (NINDEP(ISYM,ICASE) == 0) cycle
  ! Allocate space for one section of excitation amplitudes:
  ! Pick up a symmetry block of W1 and W2
  MDVEC = MODVEC(ISYM,ICASE)
  call mma_allocate(W1,NAS*MDVEC,Label='W1')
  if (JVEC == IVEC) then
    W2 => W1
  else
    call mma_allocate(W2_H,NAS*MDVEC,Label='W2_H')
    W2 => W2_H
  end if
  NWPROD = NAS**2
  ! Allocate space for the contraction:
  call mma_allocate(WPROD,NWPROD,Label='WPROD')
  WPROD(:) = Zero
  ! Sectioning loop added:
  ISCT = 0
  do IISTA=1,NIS,MDVEC
    ISCT = ISCT+1
    IIEND = min(IISTA-1+MDVEC,NIS)
    NCOL = 1+IIEND-IISTA
    call RDSCTC(ISCT,ISYM,ICASE,IVEC,W1,NAS*MDVEC)
    call RDSCTC(ISCT,ISYM,ICASE,JVEC,W2,NAS*MDVEC)
    ! Multiply WProd = (W1 sect )*(W2 sect transpose)
    call DGEMM_('N','T',NAS,NAS,NCOL,One,W1,NAS,W2,NAS,One,WPROD,NAS)
  end do
  ! Deallocate W1 and W2
  call mma_deallocate(W1)
  if (JVEC /= IVEC) call mma_deallocate(W2_H)
  nullify(W2)

  ! Loop over (TU)
  do ITU=1,NAS
    IW1 = ITU
    ITUABS = ITU+NTGEUES(ISYM)
    ITABS = MTGEU(1,ITUABS)
    IUABS = MTGEU(2,ITUABS)
    ! Loop over (XY)
    do IXY=1,NAS
      IW2 = IXY
      IXYABS = IXY+NTGEUES(ISYM)
      IXABS = MTGEU(1,IXYABS)
      IYABS = MTGEU(2,IXYABS)
      ITX = ITABS+NASHT*(IXABS-1)
      IUY = IUABS+NASHT*(IYABS-1)
      ITY = ITABS+NASHT*(IYABS-1)
      IUX = IUABS+NASHT*(IXABS-1)
      IWPROD = IW1+NAS*(IW2-1)
      W_PROD = WPROD(IWPROD)
      ! Remember: C For the F+ case (i.e. case 8)
      ! W1(tu,ij)(conj)*W2(xy,kl) = (dik*djl)*(2 Etxuy + 2 Etyux)
      ! Contrib to 2-particle operator, from 2 Etxuy:
      JTXUY = iTri(ITX,IUY)
      OP2(JTXUY) = OP2(JTXUY)+Two*W_PROD
      ! Contrib to 2-particle operator, from 2 Etyux:
      JTYUX = iTri(ITY,IUX)
      OP2(JTYUX) = OP2(JTYUX)+Two*W_PROD
    end do
  end do
  ! Deallocate matrix product:
  call mma_deallocate(WPROD)
end do
! THEN THE F- i.e. BVAT- i.e. CASE 9 -----------------------------
ICASE = 9
! Loop over symmetry ISYM
do ISYM=1,NSYM
  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  if (NINDEP(ISYM,ICASE) == 0) cycle
  ! Allocate space for one section of excitation amplitudes:
  ! Pick up a symmetry block of W1 and W2
  MDVEC = MODVEC(ISYM,ICASE)
  call mma_allocate(W1,NAS*MDVEC,Label='W1')
  if (JVEC == IVEC) then
    W2 => W1
  else
    call mma_allocate(W2_H,NAS*MDVEC,Label='W2_H')
    W2 => W2_H
  end if
  NWPROD = NAS**2
  ! Allocate space for the contraction:
  call mma_allocate(WPROD,NWPROD,Label='WPROD')
  WPROD(:) = Zero
  ! Sectioning loop added:
  ISCT = 0
  do IISTA=1,NIS,MDVEC
    ISCT = ISCT+1
    IIEND = min(IISTA-1+MDVEC,NIS)
    NCOL = 1+IIEND-IISTA
    call RDSCTC(ISCT,ISYM,ICASE,IVEC,W1,NAS*MDVEC)
    call RDSCTC(ISCT,ISYM,ICASE,JVEC,W2,NAS*MDVEC)
    ! Multiply WProd = (W1 sect )*(W2 sect transpose)
    call DGEMM_('N','T',NAS,NAS,NCOL,One,W1,NAS,W2,NAS,One,WPROD,NAS)
  end do
  ! Deallocate W1 and W2
  call mma_deallocate(W1)
  if (JVEC /= IVEC) call mma_deallocate(W2_H)
  nullify(W2)

  ! Loop over (TU)
  do ITU=1,NAS
    IW1 = ITU
    ITUABS = ITU+NTGTUES(ISYM)
    ITABS = MTGTU(1,ITUABS)
    IUABS = MTGTU(2,ITUABS)
    ! Loop over (XY)
    do IXY=1,NAS
      IW2 = IXY
      IXYABS = IXY+NTGTUES(ISYM)
      IXABS = MTGTU(1,IXYABS)
      IYABS = MTGTU(2,IXYABS)
      ITX = ITABS+NASHT*(IXABS-1)
      IUY = IUABS+NASHT*(IYABS-1)
      ITY = ITABS+NASHT*(IYABS-1)
      IUX = IUABS+NASHT*(IXABS-1)
      IWPROD = IW1+NAS*(IW2-1)
      W_PROD = WPROD(IWPROD)
      ! Remember: C For the F- case (i.e. case 9)
      ! W1(tu,ij)(conj)*W2(xy,kl) = (dik*djl)*(2 Etxuy - 2 Etyux)
      ! Contrib to 2-particle operator, from 2 Etxuy:
      JTXUY = iTri(ITX,IUY)
      OP2(JTXUY) = OP2(JTXUY)+Two*W_PROD
      ! Contrib to 2-particle operator, from -2 Etyux:
      JTYUX = iTri(ITY,IUX)
      OP2(JTYUX) = OP2(JTYUX)-Two*W_PROD
    end do
  end do
  ! Deallocate matrix product:
  call mma_deallocate(WPROD)
end do

end subroutine MKWWOPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqag(f,a,b,epsabs,epsrel,key,reslt,abserr,neval,ier,limit,lenw,last,iwork,work)
!***begin prologue  dqag
!***date written   800101   (yymmdd)
!***revision date  830518   (yymmdd)
!***category no.  h2a1a1
!***keywords  automatic integrator, general-purpose,
!             integrand examinator, globally adaptive,
!             gauss-kronrod
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  the routine calculates an approximation result to a given
!            definite integral i = integral of f over (a,b),
!            hopefully satisfying following claim for accuracy
!            abs(i-reslt)le.max(epsabs,epsrel*abs(i)).
!***description
!
!        computation of a definite integral
!        standard fortran subroutine
!        real*8 version
!
!            f      - real*8
!                     function subprogam defining the integrand
!                     function f(x). the actual name for f needs to be
!                     declared e x t e r n a l in the driver program.
!
!            a      - real*8
!                     lower limit of integration
!
!            b      - real*8
!                     upper limit of integration
!
!            epsabs - real*8
!                     absolute accoracy requested
!            epsrel - real*8
!                     relative accuracy requested
!                     if  epsabs <= 0
!                     and epsrel < max(50*rel.mach.acc.,0.5d-28),
!                     the routine will end with ier = 6.
!
!            key    - integer
!                     key for choice of local integration rule
!                     a gauss-kronrod pair is used with
!                       7 - 15 points if key < 2,
!                      10 - 21 points if key = 2,
!                      15 - 31 points if key = 3,
!                      20 - 41 points if key = 4,
!                      25 - 51 points if key = 5,
!                      30 - 61 points if key > 5.
!
!         on return
!            reslt  - real*8
!                     approximation to the integral
!
!            abserr - real*8
!                     estimate of the modulus of the absolute error,
!                     which should equal or exceed abs(i-reslt)
!
!            neval  - integer
!                     number of integrand evaluations
!
!            ier    - integer
!                     ier = 0 normal and reliable termination of the
!                             routine. it is assumed that the requested
!                             accuracy has been achieved.
!                     ier > 0 abnormal termination of the routine
!                             the estimates for result and error are
!                             less reliable. it is assumed that the
!                             requested accuracy has not been achieved.
!                      error messages
!                     ier = 1 maximum number of subdivisions allowed
!                             has been achieved. one can allow more
!                             subdivisions by increasing the value of
!                             limit (and taking the according dimension
!                             adjustments into account). however, if
!                             this yield no improvement it is advised
!                             to analyze the integrand in order to
!                             determine the integration difficulaties.
!                             if the position of a local difficulty can
!                             be determined (i.e.singularity,
!                             discontinuity within the interval) one
!                             will probably gain from splitting up the
!                             interval at this point and calling the
!                             integrator on the subranges. if possible,
!                             an appropriate special-purpose integrator
!                             should be used which is designed for
!                             handling the type of difficulty involved.
!                         = 2 the occurrence of roundoff error is
!                             detected, which prevents the requested
!                             tolerance from being achieved.
!                         = 3 extremely bad integrand behaviour occurs
!                             at some points of the integration
!                             interval.
!                         = 6 the input is invalid, because
!                             (epsabs <= 0 and
!                              epsrel < max(50*rel.mach.acc.,0.5d-28))
!                             or limit < 1 or lenw < limit*4.
!                             reslt, abserr, neval, last are set
!                             to zero.
!                             except when lenw is invalid, iwork(1),
!                             work(limit*2+1) and work(limit*3+1) are
!                             set to zero, work(1) is set to a and
!                             work(limit+1) to b.
!
!         dimensioning parameters
!            limit - integer
!                    dimensioning parameter for iwork
!                    limit determines the maximum number of subintervals
!                    in the partition of the given integration interval
!                    (a,b), limit >= 1.
!                    if limit < 1, the routine will end with ier = 6.
!
!            lenw  - integer
!                    dimensioning parameter for work
!                    lenw must be at least limit*4.
!                    if lenw < limit*4, the routine will end with
!                    ier = 6.
!
!            last  - integer
!                    on return, last equals the number of subintervals
!                    produced in the subdiviosion process, which
!                    determines the number of significant elements
!                    actually in the work arrays.
!
!         work arrays
!            iwork - integer
!                    vector of dimension at least limit, the first k
!                    elements of which contain pointers to the error
!                    estimates over the subintervals, such that
!                    work(limit*3+iwork(1)),... , work(limit*3+iwork(k))
!                    form a decreasing sequence with k = last if
!                    last <= (limit/2+2), and k = limit+1-last otherwise
!
!            work  - real*8
!                    vector of dimension at least lenw
!                    on return
!                    work(1), ..., work(last) contain the left end
!                    points of the subintervals in the partition of
!                     (a,b),
!                    work(limit+1), ..., work(limit+last) contain the
!                     right end points,
!                    work(limit*2+1), ..., work(limit*2+last) contain
!                     the integral approximations over the subintervals,
!                    work(limit*3+1), ..., work(limit*3+last) contain
!                     the error estimates.
!
!***references  (none)
!***routines called  dqage,xerror
!***end prologue  dqag

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
interface
  function f(x)
    import :: wp
    real(kind=wp) :: f
    real(kind=wp), intent(in) :: x
  end function f
end interface
real(kind=wp), intent(in) :: a, b, epsabs, epsrel
integer(kind=iwp), intent(in) :: key, limit, lenw
real(kind=wp), intent(out) :: reslt, abserr, work(lenw)
integer(kind=iwp), intent(out) :: neval, ier, last, iwork(limit)
integer(kind=iwp) :: lvl, l1, l2, l3

!***first executable statement  dqag

! check validity of lenw.

ier = 6
neval = 0
last = 0
reslt = Zero
abserr = Zero
if ((limit >= 1) .and. (lenw >= limit*4)) then

  ! prepare call for dqage.

  l1 = limit+1
  l2 = limit+l1
  l3 = limit+l2

  call dqage(f,a,b,epsabs,epsrel,key,limit,reslt,abserr,neval,ier,work(1),work(l1),work(l2),work(l3),iwork,last)

end if

! call error handler if necessary.

lvl = 0
if (ier == 6) lvl = 1
if (ier /= 0) call xerror('abnormal return from dqag ',26,ier,lvl)

return

end subroutine dqag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RSTCNF(NERR)
!
! Purpose: check restart configuration info.

use Cholesky, only: Cho_AdrVec, Damp, LuPri, ScDiag, Span, ThrCom, ThrDiag, ThrNeg, TooNeg, WarNeg, XCho_AdrVec, XDamp, XScDiag, &
                    XSpan, XThrCom, XThrDiag, XThrNeg, XTooNeg, XWarNeg
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: NERR
integer(kind=iwp) :: I, J
real(kind=wp) :: ERR
real(kind=wp), parameter :: ERRTOL = 1.0e-14_wp
character(len=*), parameter :: SWITCH(2) = [' ON','OFF']

NERR = 0

if (CHO_ADRVEC /= XCHO_ADRVEC) then
  write(LUPRI,'(A,I9,/,A,I9)') 'RESTART: addressing mode for vectors from restart file:',XCHO_ADRVEC, &
                               '         addressing mode for vectors from input       :',CHO_ADRVEC
  write(LUPRI,'(A,A)') '         Restart will fail - please specify correct address mode.'
  call CHO_QUIT('Cholesky restart failure in CHO_RSTCNF',105)
end if

ERR = abs(THRCOM-XTHRCOM)
if (ERR > ERRTOL) then
  write(LUPRI,'(A,ES16.8,/,A,ES16.8)') 'RESTART: decomposition threshold from restart file: ',XTHRCOM, &
                                       '         decomposition threshold from input       : ',THRCOM
  NERR = NERR+1
end if

ERR = abs(THRDIAG-XTHRDIAG)
if (ERR > ERRTOL) then
  write(LUPRI,'(A,ES16.8,/,A,ES16.8)') 'RESTART: init. diag. screening from restart file: ',XTHRDIAG, &
                                       '         init. diag. screening from input       : ',THRDIAG
  NERR = NERR+1
end if

ERR = abs(DAMP(1)-XDAMP(1))
if (ERR > ERRTOL) then
  write(LUPRI,'(A,ES16.8,/,A,ES16.8)') 'RESTART: 1st screening damping from restart file: ',XDAMP(1), &
                                       '         1st screening damping from input       : ',DAMP(1)
  NERR = NERR+1
end if

ERR = abs(DAMP(2)-XDAMP(2))
if (ERR > ERRTOL) then
  write(LUPRI,'(A,ES16.8,/,A,ES16.8)') 'RESTART: 2nd screening damping from restart file: ',XDAMP(2), &
                                       '         2nd screening damping from input       : ',DAMP(2)
  NERR = NERR+1
end if

if (SCDIAG .neqv. XSCDIAG) then
  if (XSCDIAG) then
    I = 1
  else
    I = 2
  end if
  if (SCDIAG) then
    J = 1
  else
    J = 2
  end if
  write(LUPRI,'(A,A,/,A,A)') 'RESTART: diag. screening from restart file: ',SWITCH(I), &
                             '         diag. screening from input       : ',SWITCH(J)
  NERR = NERR+1
end if

ERR = abs(THRNEG-XTHRNEG)
if (ERR > ERRTOL) then
  write(LUPRI,'(A,ES16.8,/,A,ES16.8)') 'RESTART: neg. diag. threshold from restart file: ',XTHRNEG, &
                                       '         neg. diag. threshold from input       : ',THRNEG
  NERR = NERR+1
end if

ERR = abs(WARNEG-XWARNEG)
if (ERR > ERRTOL) then
  write(LUPRI,'(A,ES16.8,/,A,ES16.8)') 'RESTART: neg. diag. warn thr. from restart file: ',XWARNEG, &
                                       '         neg. diag. warn thr. from input       : ',WARNEG
  NERR = NERR+1
end if

ERR = abs(TOONEG-XTOONEG)
if (ERR > ERRTOL) then
  write(LUPRI,'(A,ES16.8,/,A,ES16.8)') 'RESTART: too neg. diag. thr. from restart file: ',XTOONEG, &
                                       '         too neg. diag. thr. from input       : ',TOONEG
  NERR = NERR+1
end if

ERR = abs(SPAN-XSPAN)
if (ERR > ERRTOL) then
  write(LUPRI,'(A,ES16.8,/,A,ES16.8)') 'RESTART: span factor from restart file: ',XSPAN, &
                                       '         span factor from input       : ',SPAN
  NERR = NERR+1
end if

end subroutine CHO_RSTCNF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine XDR_fpFWprop(n,Tr,X,pXp,A,B,R,EL,ES,OL,OS,tmp)
!  Transform property operator (X,pXp) to fpFW picture

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: Tr(n,n), A(n), B(n), R(n)
real(kind=wp), intent(inout) :: X(n,n), pXp(n,n)
real(kind=wp), intent(out) :: EL(n,n), ES(n,n), OL(n,n), OS(n,n), tmp(n,n)
integer(kind=iwp) :: i, j
real(kind=wp) :: av, aw

call dmxma(n,'C','N',Tr,X,tmp,One)
call dmxma(n,'N','N',tmp,Tr,X,One)
call dmxma(n,'C','N',Tr,pXp,tmp,One)
call dmxma(n,'N','N',tmp,Tr,pXp,One)

do i=1,n
  do j=1,n
    av = X(j,i)*A(i)*A(j)
    aw = pXp(j,i)*B(i)*B(j)
    EL(j,i) = av+aw
    ES(j,i) = aw/R(i)/R(j)+av*R(i)*R(j)
    OL(j,i) = aw/R(i)-av*R(i)
    OS(j,i) = aw/R(j)-av*R(j)
  end do
end do

return

end subroutine XDR_fpFWprop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Init_LoProp(nSym,nBas,nOrb,CoC,nAtoms,ipC,
     &                       ipQ_Nuc,ip_ANr,ip_Type,ip_Center,
     &                       nSize,nBas1,nBas2,nBasMax,ipP,ipPInv)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Integer Occ, Vir
      Parameter(Occ=1,Vir=0)
      Integer nBas(8), nOrb(8)
      Real*8 CoC(3)
      Logical lOrb
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      Call qpg_iarray('nOrb',lOrb,iDum)
      If (lOrb) Then
         Call Get_iArray('nOrb',nOrb,nSym)
      Else
         Call ICopy(nSym,nBas,1,nOrb,1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      nSize=0
      nBas1=0
      nBas2=0
      nBasMax=0
      Do iSym = 1, nSym
         nSize = nSize + nBas(iSym)*(nBas(iSym)+1)/2
         nBas1 = nBas1 + nBas(iSym)
         nBas2 = nBas2 + nBas(iSym)**2
         nBasMax = Max(nBasMax,nBas(iSym))
      End Do
      nSize=nSize + 4
*                                                                      *
************************************************************************
*                                                                      *
*---- Center of Charge
      Call Get_dArray('Center of Charge',CoC,3)
*
*---- List coordinates of Coordinates
      Call Get_iScalar('LP_nCenter',nAtoms)
      Call Allocate_Work(ipC,3*nAtoms)
      Call Get_dArray('LP_Coor',Work(ipC),3*nAtoms)
      Call Allocate_Work(ipQ_Nuc,nAtoms)
*
*---- Effective charge at each center
      Call Get_dArray('LP_Q',Work(ipQ_Nuc),nAtoms)
*
*---- Atom number of each center
      Call Allocate_iWork(ip_ANr,nAtoms)
      Call Get_iArray('LP_A',iWork(ip_ANr),nAtoms)
*
*---- Pick up information of orbital type. Occ/Vir
      Call Allocate_iWork(ip_type,nbas1)
      Call Get_iArray('Orbital Type',iWork(ip_type),nBas1)
      Do i = ip_type, ip_type+nBas1-1
         If (iWork(i).ne.Occ.and.iWork(i).ne.Vir) Then
            Write (6,*) 'Orbital type vector is corrupted!'
            Call Abend()
         End If
      End Do
*
*---- Pick up index array of which center a basis function belong.
      Call Allocate_iWork(ip_center,nbas1)
      Call Get_iArray('Center Index',iWork(ip_center),nBas1)
*
#ifdef _DEBUGPRINT_
      Write (6,*) '******* LoProp Debug Info *******'
      Call RecPrt('Coordinates',' ',Work(ipC),3,nAtoms)
      Call RecPrt('Charges',' ',Work(ipQ_Nuc),1,nAtoms)
      Write (6,*) 'Atom Nr:',(iWork(i),i=ip_ANr,ip_ANr+nAtoms-1)
      Do iBas = 1, nBas1
         If (iWork(ip_type+iBas-1).eq.Occ) Then
            Write (6,'(A,I3,A)') 'Basis function ',iBas,
     &            ' is occupied'
         Else
            Write (6,'(A,I3,A)') 'Basis function ',iBas,
     &            ' is virtual'
         End If
      End Do
      Write (6,*)
      Do iBas = 1, nBas1
         Write (6,'(A,I3,A,I3)') 'Basis function ',iBas,' belongs'//
     &         ' to center ',iWork(ip_center+iBas-1)
      End Do
      Write (6,*) '*********************************'
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     In case of symmetry we need the desymmetrization matrix
*
      If (nSym.eq.1) Go To 99
*
      Call Allocate_Work(ipP,nbas1**2)
      Call Allocate_Work(ipPInv,nbas1**2)
      Call Get_dArray('SM',Work(ipP),nbas1**2)
#ifdef _DEBUGPRINT_
      Call RecPrt('SM',' ',Work(ipP),nbas1,nbas1)
#endif
      Call MINV(Work(ipP),Work(ipPInv),ISING,DET,nBas1)
#ifdef _DEBUGPRINT_
      Call RecPrt('SMInv',' ',Work(ipPInv),nbas1,nbas1)
#endif
      Call DGeTMi(Work(ipPInv),nbas1,nbas1)
*                                                                      *
************************************************************************
*                                                                      *
 99   Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Hidden(Coor,AN,nHidden)
! Add to the Grand atom list some hidden atoms, coming e.g.
! from the MM part of a QM/MM system

use Slapaf_Info, only: rHidden
use Isotopes, only: MaxAtomNum, PTab
use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), allocatable, intent(inout) :: Coor(:,:)
integer(kind=iwp), allocatable, intent(inout) :: AN(:)
integer(kind=iwp), intent(out) :: nHidden
integer(kind=iwp) :: i, iAtNum, iHidden, iKept, iPL, ITkQMMM, mTot, mTtAtm, nKept
real(kind=wp) :: XYZ(3)
logical(kind=iwp) :: Do_ESPF, Exists
character(len=180) :: Line
character(len=2) :: Symbol
real(kind=wp), allocatable :: Coor_h(:,:), h_xyz(:,:)
integer(kind=iwp), allocatable :: AN_h(:), h_AN(:)
character(len=LenIn), allocatable :: LabMMO(:)
integer(kind=iwp), external :: iPrintLevel, IsFreeUnit
character(len=180), external :: Get_Ln

nHidden = 0
if (rHidden < Two) return
iPL = iPrintLevel(-1)
mTtAtm = size(Coor,2)

!#define _DEBUGPRINT_

#ifdef _DEBUGPRINT_
iPL = 4
#endif
iHidden = 0
Do_ESPF = .false.

! Is there a ESPF/QMMM file ?

call DecideOnESPF(Do_ESPF)
if (Do_ESPF) then

  ! Try MM atoms from Tinker QM/MM interface file

  call F_Inquire('QMMM',Exists)
  if (Exists) then
    ITkQMMM = IsFreeUnit(25)
    call Molcas_Open(ITkQMMM,'QMMM')
    Line = ' '
    do while (index(Line,'TheEnd ') == 0)
      Line = Get_Ln(ITkQMMM)

      ! Read the maximum number of MM atoms + some temporary arrays allocation

      if (index(Line,'NMM') /= 0) then
        call Get_I1(2,nHidden)
        if (iPL > 3) write(u6,'(A,I5,A)') 'Found ',nHidden,' hidden atoms.'
        if (nHidden > 0) then
          call mma_allocate(h_xyz,3,nHidden,Label='h_xyz')
          call mma_allocate(h_AN,nHidden,Label='h_AN')
          do iHidden=1,nHidden
            Line = Get_Ln(ITkQMMM)
            if (index(Line,'MMCoord') == 0) then
              write(u6,*) 'Error in hidden. Last line does not start with MMCoord:'
              write(u6,*) Line
              call Quit_onUserError()
            end if
            call Get_I1(2,iAtNum)
            h_AN(iHidden) = -iAtNum
            call Get_F(3,XYZ,3)
            h_xyz(1,iHidden) = XYZ(1)/Angstrom
            h_xyz(2,iHidden) = XYZ(2)/Angstrom
            h_xyz(3,iHidden) = XYZ(3)/Angstrom
          end do
        end if
      end if
    end do
    close(ITkQMMM)
  else
    ! Try outer MM atoms stored on runfile
    call Qpg_dArray('MMO Coords',Exists,nHidden)
    if (Exists) then
      nHidden = nHidden/3
      call mma_allocate(h_xyz,3,nHidden,Label='h_xyz')
      call mma_allocate(h_AN,nHidden,Label='h_AN')
      call mma_allocate(LabMMO,nHidden,Label='LabMMO')
      call Get_dArray('MMO Coords',h_xyz,nHidden*3)
      call Get_cArray('MMO Labels',LabMMO,LenIn*nHidden)
      do iHidden=1,nHidden
        Symbol(1:1) = LabMMO(iHidden)(1:1)
        Symbol(2:2) = LabMMO(iHidden)(2:2)
        if (Symbol(2:2) == '_') Symbol = ' '//Symbol(1:1)
        do i=0,MaxAtomNum
          if (Ptab(i) == Symbol) then
            h_AN(iHidden) = -i
            exit
          end if
        end do
      end do
      call mma_deallocate(LabMMO)
    end if
  end if
end if
if (.not. allocated(h_xyz)) then
  call mma_allocate(h_xyz,3,nHidden,Label='h_xyz')
  call mma_allocate(h_AN,nHidden,Label='h_AN')
end if
if (iPL > 3) call RecPrt('Hidden coord:',' ',h_xyz,3,nHidden)

! Select the hidden atoms to be kept.

nKept = 0
if (nHidden > 0) call Select_hidden(mTtAtm,nHidden,Coor,h_xyz,h_AN,nKept,iPL)

! Copy all the arrays needed by box and nlm

if (nKept > 0) then
  if (iPL > 3) write(u6,'(A8,I5,A)') 'Hidden: ',nKept,' atoms are kept.'
  mTot = mTtAtm+nKept
  call mma_allocate(Coor_h,3,mTot,Label='Coor_h')
  call mma_allocate(AN_h,mTot,Label='AN_h')

  Coor_h(:,1:mTtAtm) = Coor(:,1:mTtAtm)
  AN_h(1:mTtAtm) = AN(1:mTtAtm)

  ! Copy the kept hidden atom coordinates, atom numbers and masses

  iKept = 0
  do iHidden=1,nHidden
    if (h_AN(iHidden) > 0) then
      iKept = iKept+1
      Coor_h(:,mTtAtm+iKept) = h_xyz(:,iHidden)
      AN_h(mTtAtm+iKept) = h_AN(iHidden)
    end if
  end do
  if (iKept /= nKept) then
    write(u6,'(A)') ' Hidden: wrong number of kept hidden atoms.'
    call Quit_OnUserError()
  end if
  call mma_deallocate(Coor)
  call mma_deallocate(AN)

  ! The end

  call mma_allocate(Coor,3,mTot,Label='Coor')
  Coor(:,:) = Coor_h(:,:)
  call mma_deallocate(Coor_h)
  call mma_allocate(AN,mTot,Label='AN')
  AN(:) = AN_h(:)
  call mma_deallocate(AN_h)

  if (iPL > 3) call RecPrt('Hidden: Coor',' ',Coor,3,mTot)
end if
nHidden = nKept
call mma_deallocate(h_AN)
call mma_deallocate(h_xyz)

return

#undef _DEBUGPRINT_
end subroutine Hidden

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gen_vvvo(occ_ind,w3,l1_1,l2_1,tmp)
! this routine does:
!
! regenerate VVVo integrals from cholesky vectors
!
! -------------------
!
! structure of the cholesky vector files :
!
!       L1(m,I ,A') L1vcxx xx - Group of A'
!
!       L2(m,A'B')  L2xxyy xx - Group of A', A'>=B'
!                          yy - Group of B'

use ChT3_global, only: DimGrpaR, L1Name, L2Name, LunAux, nc, no, nv, NvGrp
use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: occ_ind
real(kind=wp), intent(inout) :: w3(nTri_Elem(nv),nv)
real(kind=wp), intent(_OUT_) :: l1_1(*), l2_1(*), tmp(*)
integer(kind=iwp) :: a, a_tmp, b, b_tmp, c, c_tmp, dima, dimb, dimc, lasta, lastb, lastc, length

! algoritmus je dobry ak maxdim > no
! inak treba vymenit citanie L1 za L2
!
! dalo by sa to urobit podstatne lepsie, kedby
! dircc nevyzadoval VVV ako (ab,c) ale ako (a,b,c)
!
! mozno urob sort L1i (m,c') <- L1(m,i,c')
! ---

!1 loop over a'

do a=1,NvGrp

  !2        loop over b'

  do b=1,a

    !2.1        read L2(m,a',b')

    if (a == b) then  ! a=b
      ! open the pertinent file

      !mp@ dima = nv/NvGrp
      !mp@ if (a == NvGrp) dima = nv-((NvGrp-1)*dima)
      dima = DimGrpaR(a)

      !mp !write(u6,*) 'dima = ',dima
      dimb = dima
      length = nTri_Elem(dima)*nc
      !mp !write(u6,*) 'length L2Name(a,b) = ',L2Name(a,b),length
      !mp !write(u6,*) 'file size (g77) = ',16+length*8
      !mp !write(u6,*) 'file size L2Name(a,b) (ifort) = ',L2Name(a,b),8+length*8

      call GetX_t3(tmp,length,LunAux,L2Name(a,b),1,1)

    else ! a>b
      ! open the pertinent file

      !mp@@ dima = nv/NvGrp
      !mp@@ dimb = nv/NvGrp
      !mp@@ if (a == NvGrp) dima = nv-((NvGrp-1)*dima)
      !mp@@ if (b == NvGrp) dimb = nv-((NvGrp-1)*dimb)
      dima = DimGrpaR(a)
      dimb = DimGrpaR(b)

      !mp !write(u6,*) 'dima, dimb = ',dima,dimb
      length = dima*dimb*nc
      !mp !write(u6,*) 'length L2Name(a,b) = ',L2Name(a,b),length
      !mp !write(u6,*) 'file size (g77) = ',16+length*8
      !mp !write(u6,*) 'file size L2Name(a,b) (ifort) = ',L2Name(a,b),8+length*8

      call GetX_t3(tmp,length,LunAux,L2Name(a,b),1,1)
    end if

    !2.2 map  L2_1(a',b',m) <- tmp(m,a',b')

    if (a == b) then ! expand and map
      ! expand and map l2_1 (a',b',m) <- tmp (m,ab')
      call exMap3_231(tmp,l2_1,nc,dima)
    else
      call Map3_231_t3(tmp,l2_1,nc,dima,dimb)
    end if

    !3 loop over c'

    do c=1,NvGrp

      !3.1 read L1(m,i,c')

      !mp@@ dimc = nv/NvGrp
      !mp@@ if (c == NvGrp) dimc = nv-((NvGrp-1)*dimc)
      dimc = DimGrpaR(c)

      !mp !write(u6,*) 'dimc = ',dimc
      length = nc*no*dimc
      !mp !write(u6,*) 'length L1Name(c) = ',L1Name(c),length
      !mp !write(u6,*) 'file size L1Name(c) (ifort) = ',L1Name(c),8+8*length

      call GetX_t3(tmp,length,LunAux,L1Name(c),1,1)

      !3.2 extract l1_1 (m,c')_i <- tmp (m,i,c')
      ! toto by sa dalo nahradit mapovanim

      call ext_o_32(tmp,l1_1,nc,no,dimc,occ_ind)

      !3.2.1 zero tmp

      tmp(1:dima*dimb*dimc) = Zero

      !3.3 mult tmp (a',b',c') <- L2_1 (a',b',m) l1_1 (m,c')

      call mc0c1a3b(dima*dimb,nc,nc,dimc,dima*dimb,dimc,dima*dimb,nc,dimc,l2_1,l1_1,tmp)

      !3.4 add W(ab,c) <- tmp (a'b'c')

      !mp@@ lasta = (a-1)*(nv/NvGrp)
      !mp@@ lastb = (b-1)*(nv/NvGrp)
      !mp@@ lastc = (c-1)*(nv/NvGrp)

      lasta = 0
      if (a > 1) then
        do a_tmp=1,a-1
          lasta = lasta+DimGrpaR(a_tmp)
        end do
      end if

      lastb = 0
      if (b > 1) then
        do b_tmp=1,b-1
          lastb = lastb+DimGrpaR(b_tmp)
        end do
      end if

      lastc = 0
      if (c > 1) then
        do c_tmp=1,c-1
          lastc = lastc+DimGrpaR(c_tmp)
        end do
      end if

      !mp !write(u6,'(A,3(i4),2x,3(i4))') 'lasta, lastb, lastc = ',lasta,lastb,lastc,a,b,c

      ! sme v gen_vvvo
      call grow_w3(w3,tmp,nv,nv,dima,dimb,dimc,lasta,lastb,lastc)

      !3.5 end loop over c'
    end do
    !4 end loop over b'
  end do
  !5 end loop over a'
end do

return

end subroutine gen_vvvo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine fokunpck3 (fok,fai,dimfok,dimfa,dimfi)
c
c     this routine distribute (Fok - dp) to Fai
c     fok    - Fok matrix (I)
c     fai    - Fai matrix (O)
c     dimfok - dimension for Fok matrix - norb (I)
c     dimfa  - dimension of virtuals - nv (I)
c     dimfi  - dimension of occupied - no (I)
c
       integer dimfok,dimfa,dimfi
c
       real*8 fok(1:dimfok,1:dimfok)
       real*8 fai(1:dimfa,1:dimfi)
c
c     help variables
c
       integer a,i
c
c1    distribute Fok to Fai
       do 300 i=1,dimfi
       do 301 a=1,dimfa
       fai(a,i)=fok(dimfi+a,i)
 301    continue
 300    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Rys01(Arg,nArg,Weight,iPntr,nPntr,
     &                 x0,nMax,W6,W5,W4,W3,W2,W1,W0,ddx,HerW,Tmax)
************************************************************************
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             September '90                                            *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Arg(nArg), Weight(nArg), x0(nMax), W6(nMax), W5(nMax),
     &       W4(nMax), W3(nMax), W2(nMax), W1(nMax), W0(nMax)
      Integer iPntr(nPntr)
*
      xdInv=One/ddx
      dddx = ddx/10d0 + ddx
      Do 10 iArg = 1, nArg
         If (Arg(iArg).lt.TMax) Then
            n = iPntr(Int((Arg(iArg)+dddx)*xdInv))
            z = Arg(iArg) - x0(n)
            w =(((((W6(n)*z+W5(n))*z+W4(n))*z+W3(n))*z+W2(n))*z+W1(n))
     &          *z+w0(n)
            Weight(iArg) = w
         Else
            ai = 1.0D0/Arg(iArg)
            Weight(iArg) = HerW*Sqrt(ai)
         End If
 10   Continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_FINAL(WriteBookmarks)
      use ChoArr, only: iSOShl
C
C     Purpose: Cholesky finalizations.
C
      use ChoBkm, only: BkmVec, BkmThr, nRow_BkmVec, nCol_BkmVec,
     &                   nRow_BkmThr, nCol_BkmThr
      Implicit None
      Logical WriteBookmarks
#include "cholesky.fh"
#include "choorb.fh"
#include "choini.fh"
#include "stdalloc.fh"

      Integer, Allocatable:: BkmDim(:), iScratch(:)
      Real*8, Allocatable:: Scratch(:)
      INTEGER CHOISINI, IREO, l
      INTEGER NUMV(8)
#if defined (_DEBUGPRINT_)
      Integer is1CCD
#endif

C     Write NUMCHO array, shell indices, and threshold to runfile.
C     ------------------------------------------------------------

      CALL CHO_P_GETGV(NUMV,NSYM)
      CALL PUT_IARRAY('NUMCHO',NUMV,NSYM)
      CALL PUT_IARRAY('iSOShl',ISOSHL,NBAST)
      CALL PUT_DSCALAR('Cholesky Threshold',THRCOM)
#if defined (_DEBUGPRINT_)
      ! This is needed in order for bookmark tests in cho_x_init to work
      If (WriteBookmarks) Then
         If (Cho_1Center) Then
            is1CCD=1
         Else
            is1CCD=0
         End If
         Call Put_iScalar('1C-CD',is1CCD)
      End If
#endif

C     Write bookmarks to runfile.
C     First, transpose array.
C     ---------------------------

      If (WriteBookmarks) Then
         Call mma_allocate(BkmDim,4,Label='BkmDim')
         BkmDim(1)=nCol_BkmVec
         BkmDim(2)=nRow_BkmVec
         BkmDim(3)=nCol_BkmThr
         BkmDim(4)=nRow_BkmThr
         Call Put_iArray('Cholesky BkmDim',BkmDim,SIZE(BkmDim))
         Call mma_deallocate(BkmDim)
         If (nRow_BkmVec.gt.0 .and. nCol_BkmVec.gt.0 .and.
     &       nRow_BkmThr.gt.0 .and. nCol_BkmThr.gt.0) Then
            l=nRow_BkmVec*nCol_BkmVec
            Call mma_allocate(iScratch,l,Label='iScratch')
            Call iTrnsps(nSym,nCol_BkmVec,BkmVec,iScratch)
            Call Put_iArray('Cholesky BkmVec',iScratch,l)
            Call mma_deallocate(iScratch)
            Call mma_deallocate(BkmVec)
            nRow_BkmVec=0
            nCol_BkmVec=0
            l=nRow_BkmThr*nCol_BkmThr
            Call mma_allocate(Scratch,l,Label='Scratch')
            Call Trnsps(nSym,nCol_BkmThr,BkmThr,Scratch)
            Call Put_dArray('Cholesky BkmThr',Scratch,l)
            Call mma_deallocate(Scratch)
            Call mma_deallocate(BkmThr)
            nRow_BkmThr=0
            nCol_BkmThr=0
         End If
      End If
      If (Allocated(BkmVec)) Then
         Call mma_deallocate(BkmVec)
         nRow_BkmVec=0
         nCol_BkmVec=0
      End If
      If (Allocated(BkmThr)) Then
         Call mma_deallocate(BkmThr)
         nRow_BkmThr=0
         nCol_BkmThr=0
      End If

C     Write vector file address mode to runfile.
C     ------------------------------------------

      CALL PUT_ISCALAR('ChoVec Address',CHO_ADRVEC)

C     Write reorder mark to runfile.
C     ------------------------------

      IF (CHO_REORD) THEN
         IREO = 1
      ELSE
         IREO = 0
      END IF
      CALL PUT_ISCALAR('Cholesky Reorder',IREO)

C     Set initialization integer flag to "not set".
C     ---------------------------------------------

      CHOISINI = CHOINICHECK + 1
      CALL PUT_ISCALAR('ChoIni',CHOISINI)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

subroutine RHSOD_B_NOSYM(IVEC)

use Symmetry_Info, only: Mul
use SUPERINDEX, only: MIGEJ, MIGTJ, MIREL, MTGEU, MTGTU, MTREL
use CHOVEC_IO, only: ChoVec_Read, ChoVec_Size, NVTOT_ChoSym
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB
#else
use fake_GA, only: GA_Arrays
#endif
use caspt2_global, only: iPrGlb
use caspt2_module, only: nAsh, nASup, NIGEJES, NIGTJES, nISup, nSym, NTGEUES, NTGTUES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iVec
integer(kind=iwp) :: IAEND, IASTA, iCASE, IDX, IIEND, IISTA, IJ, IJABS, IJGEL, IJGELTOT, IJGTL, IJGTLTOT, IL, ILABS, IOFFTJ, &
                     IOFFTL, IOFFVJ, IOFFVL, IOSYM(8,8), ISYJ, ISYL, ISYM, ISYT, ISYV, IT, ITABS, ITGEU, ITGEUTOT, ITGTU, &
                     ITGTUTOT, ITJ, ITL, IV, IVABS, IVJ, IVL, lg_W, MW, NAS, NCHOBUF, NIS, NV, NW
real(kind=wp) :: BMTVJL, BPTVJL, SCL, TJVL, TLVJ
real(kind=wp), allocatable :: CHOBUF(:)
real(kind=wp), parameter :: SQRTH = sqrt(Half)
real(kind=wp), external :: DDot_

if (iPrGlb >= DEBUG) write(u6,*) 'RHS on demand: case B'

!***********************************************************************
! Case B (2,3):
!   Let  W(tv,j,l)=(jt,lv):
!   BP(tv,jl)=((tj,vl)+(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
!   BM(tv,jl)=((tj,vl)-(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
!***********************************************************************

!***********************************************************************
!SVC: read in all the cholesky vectors (need all symmetries)
!***********************************************************************
call CHOVEC_SIZE(1,NCHOBUF,IOSYM)

call mma_allocate(CHOBUF,NCHOBUF,LABEL='CHOBUF')

call CHOVEC_READ(1,CHOBUF,NCHOBUF)

iCASE = 2
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  do IJGEL=IISTA,IIEND
    IJGELTOT = IJGEL+NIGEJES(ISYM)
    IJABS = MIGEJ(1,IJGELTOT)
    ILABS = MIGEJ(2,IJGELTOT)
    IJ = MIREL(1,IJABS)
    ISYJ = MIREL(2,IJABS)
    IL = MIREL(1,ILABS)
    ISYL = MIREL(2,ILABS)
    do ITGEU=IASTA,IAEND ! these are always all elements
      ITGEUTOT = ITGEU+NTGEUES(ISYM)
      ITABS = MTGEU(1,ITGEUTOT)
      IVABS = MTGEU(2,ITGEUTOT)
      IT = MTREL(1,ITABS)
      ISYT = MTREL(2,ITABS)
      IV = MTREL(1,IVABS)
      ISYV = MTREL(2,IVABS)
      ! compute integrals (ajcl) and (alcj)
      NV = NVTOT_CHOSYM(Mul(ISYT,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
      ITJ = IT-1+NASH(ISYT)*(IJ-1)
      IVL = IV-1+NASH(ISYV)*(IL-1)
      IOFFTJ = 1+IOSYM(ISYT,ISYJ)+NV*ITJ
      IOFFVL = 1+IOSYM(ISYV,ISYL)+NV*IVL
      TJVL = DDOT_(NV,CHOBUF(IOFFTJ),1,CHOBUF(IOFFVL),1)

      NV = NVTOT_CHOSYM(Mul(ISYT,ISYL))
      ITL = IT-1+NASH(ISYT)*(IL-1)
      IVJ = IV-1+NASH(ISYV)*(IJ-1)
      IOFFTL = 1+IOSYM(ISYT,ISYL)+NV*ITL
      IOFFVJ = 1+IOSYM(ISYV,ISYJ)+NV*IVJ
      TLVJ = DDOT_(NV,CHOBUF(IOFFTL),1,CHOBUF(IOFFVJ),1)

      ! BP(tv,jl)=((tj,vl)+(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
      SCL = Half
      if (ITABS == IVABS) SCL = SCL*Half
      if (ILABS == IJABS) SCL = SCL*SQRTH
      BPTVJL = SCL*(TJVL+TLVJ)
      ! write element HP(ac,jl)
      IDX = ITGEU+NAS*(IJGEL-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = BPTVJL
#     else
      GA_Arrays(lg_w)%A(IDX) = BPTVJL
#     endif
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

iCASE = 3
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  do IJGTL=IISTA,IIEND
    IJGTLTOT = IJGTL+NIGTJES(ISYM)
    IJABS = MIGTJ(1,IJGTLTOT)
    ILABS = MIGTJ(2,IJGTLTOT)
    IJ = MIREL(1,IJABS)
    ISYJ = MIREL(2,IJABS)
    IL = MIREL(1,ILABS)
    ISYL = MIREL(2,ILABS)
    do ITGTU=IASTA,IAEND ! these are always all elements
      ITGTUTOT = ITGTU+NTGTUES(ISYM)
      ITABS = MTGTU(1,ITGTUTOT)
      IVABS = MTGTU(2,ITGTUTOT)
      IT = MTREL(1,ITABS)
      ISYT = MTREL(2,ITABS)
      IV = MTREL(1,IVABS)
      ISYV = MTREL(2,IVABS)
      ! compute integrals (tj,vl) and (tlvj)
      NV = NVTOT_CHOSYM(Mul(ISYT,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
      ITJ = IT-1+NASH(ISYT)*(IJ-1)
      IVL = IV-1+NASH(ISYV)*(IL-1)
      IOFFTJ = 1+IOSYM(ISYT,ISYJ)+NV*ITJ
      IOFFVL = 1+IOSYM(ISYV,ISYL)+NV*IVL
      TJVL = DDOT_(NV,CHOBUF(IOFFTJ),1,CHOBUF(IOFFVL),1)

      NV = NVTOT_CHOSYM(Mul(ISYT,ISYL))
      ITL = IT-1+NASH(ISYT)*(IL-1)
      IVJ = IV-1+NASH(ISYV)*(IJ-1)
      IOFFTL = 1+IOSYM(ISYT,ISYL)+NV*ITL
      IOFFVJ = 1+IOSYM(ISYV,ISYJ)+NV*IVJ
      TLVJ = DDOT_(NV,CHOBUF(IOFFTL),1,CHOBUF(IOFFVJ),1)

      ! BM(tv,jl)=((tj,vl)-(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
      SCL = Half
      !if (ITABS == IVABS) SCL = SCL*Half
      !if (ILABS == IJABS) SCL = SCL*SQRTH
      BMTVJL = SCL*(TJVL-TLVJ)
      ! write element BM(tv,jl)
      IDX = ITGTU+NAS*(IJGTL-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = BMTVJL
#     else
      GA_Arrays(lg_w)%A(IDX) = BMTVJL
#     endif
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

call mma_deallocate(CHOBUF)

end subroutine RHSOD_B_NOSYM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ValANM(nAtom,nInter,nIter,Bmx,Degen,rInt,Cx,Label,nWndw)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nAtom, nInter, nIter, nWndw
real(kind=wp), intent(in) :: BMx(3*nAtom,3*nAtom), Degen(3*nAtom), Cx(3*nAtom,nIter)
real(kind=wp), intent(inout) :: rInt(nInter,nIter)
character(len=*), intent(in) :: Label
integer(kind=iwp) :: iEnd, iIter, ij, iSt, j, NRHS
real(kind=wp), allocatable :: ScrC(:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Values:    q=BuX
! Gradients: g=Bu(dE/dX)
!                                                                      *
!***********************************************************************
!                                                                      *
iSt = nIter
iEnd = iSt-min(nIter,nWndw+1)+1
!NRHS = nIter
NRHS = iSt-iEnd+1
if (Label == 'Values') then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Values:    q=BX

  call mma_allocate(ScrC,3*nAtom*(iSt-iEnd+1),Label='ScrC')

  do iIter=iSt,iEnd,-1
    do j=1,3*nAtom
      ij = (iIter-iEnd)*3*nAtom+j
      ScrC(ij) = Cx(j,iIter)*Degen(j)
    end do
  end do

  call DGEMM_('T','N',nInter,NRHS,3*nAtom,One,BMx,3*nAtom,ScrC,3*nAtom,Zero,rInt(:,iEnd),nInter)

  call mma_deallocate(ScrC)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call Eq_Solver('N',3*nAtom,nInter,NRHS,BMx,.false.,Degen,Cx(:,iEnd),rInt(:,iEnd))
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,'(A)') ' In ValANM: New '
call RecPrt(Label,' ',rInt(1,iEnd),nInter,iSt-iEnd+1)
#endif

return

end subroutine ValANM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MLTCTL(HEFF,EIGVEC,U0)

use Index_Functions, only: nTri_Elem
use caspt2_global, only: iPrGlb
use PrintLevel, only: TERSE, USUAL, VERBOSE
use caspt2_module, only: ENERGY, HZERO, IfChol, IFDW, IFRMS, IFXMS, JMS, MSTATE, NSTATE, PT2Method
use SC_NEVPT2, only: Do_FIC, Do_SC, ENERGY_SC, HEFF_SC, SC_prop, UEFF_SC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: HEFF(NSTATE,NSTATE), EIGVEC(NSTATE,NSTATE)
real(kind=wp), intent(in) :: U0(Nstate,Nstate)
integer(kind=iwp) :: I, IEND, II0, IJ, iloop, ISTA, J, LAXITY, NHTRI, nloop, NUMAT
real(kind=wp) :: DSHIFT, tmp
logical(kind=iwp) :: PrRes
character(len=8) :: INLAB
character(len=5) :: variant
real(kind=wp), allocatable :: HTRI(:), UMAT(:,:), Utmp(:,:)
integer(kind=iwp), external :: Cho_X_GetTol

if (IPRGLB >= TERSE) then
  call CollapseOutput(1,'Multi-State '//trim(PT2Method)//' section:')
  write(u6,'(A)') repeat('*',80)
  write(u6,*) ' MULTI-STATE '//trim(PT2Method)//' SECTION'
  if (IPRGLB >= USUAL) then
    write(u6,'(A)') repeat('-',80)
    write(u6,*)
  end if
end if

! Write out the effective Hamiltonian, for use in e.g. RASSI:
INLAB = 'HEFF'
if ((HZERO /= 'DYALL') .or. (.not. SC_prop)) then
  call put_darray(INLAB,HEFF,NSTATE**2)
else
  call put_darray(INLAB,HEFF_SC,NSTATE**2)
end if

! Analyze the effective Hamiltonian:
DSHIFT = Zero
if (HEFF(1,1) <= -100.0_wp) DSHIFT = -real(ceiling(HEFF(1,1)),kind=wp)
do I=1,NSTATE
  HEFF(I,I) = HEFF(I,I)-DSHIFT
end do

if ((IPRGLB >= TERSE) .and. (DSHIFT /= Zero)) write(u6,*) ' Output diagonal energies have been shifted. Add ',DSHIFT

nloop = 1
if ((HZERO == 'DYALL') .and. Do_SC) nloop = 2

do iloop=1,nloop
  PrRes = .true.
  if (HZERO == 'DYALL') then
    if ((iloop == 1) .and. (.not. Do_FIC)) PrRes = .false.
    if ((iloop == 2) .and. (.not. Do_SC)) PrRes = .false.
  end if

  if (((IPRGLB >= VERBOSE) .or. JMS) .and. PrRes) then
    write(u6,*) ' Effective Hamiltonian matrix (Asymmetric):'
    do ISTA=1,NSTATE,5
      IEND = min(ISTA+4,NSTATE)
      write(u6,*)
      write(u6,'(1x,5I16)') (MSTATE(I),I=ISTA,IEND)
      do J=1,NSTATE
        write(u6,'(1x,I3,3X,5F16.8)') MSTATE(J),(HEFF(J,I),I=ISTA,IEND)
      end do
    end do
  end if

  ! Diagonalize:
  ! Use a symmetrized matrix, in triangular storage:
  NUMAT = NSTATE**2
  NHTRI = nTri_Elem(NUMAT)
  call mma_allocate(UMAT,NSTATE,NSTATE,LABEL='UMAT')
  call mma_allocate(HTRI,NHTRI,LABEL='HTRI')
  IJ = 0
  do I=1,NSTATE
    HTRI(IJ+1:IJ+I) = Half*(HEFF(I,1:I)+HEFF(1:I,I))
    IJ = IJ+I
  end do
  if ((IPRGLB >= USUAL) .and. PrRes) then
    write(u6,*)
    write(u6,*) ' Effective Hamiltonian matrix (Symmetric):'
    do ISTA=1,NSTATE,5
      IEND = min(ISTA+4,NSTATE)
      write(u6,*)
      write(u6,'(1x,5I16)') (MSTATE(I),I=ISTA,IEND)
      do I=ISTA,NSTATE
        II0 = nTri_Elem(I-1)
        write(u6,'(1x,I3,3X,5F16.8)') MSTATE(I),(HTRI(II0+J),J=ISTA,min(I,IEND))
      end do
    end do
  end if
  call unitmat(UMAT,NSTATE)
  call NIDiag(HTRI,UMAT,NSTATE,NSTATE)
  call JACORD(HTRI,UMAT,NSTATE,NSTATE)
  do I=1,NSTATE
    ENERGY(I) = DSHIFT+HTRI(nTri_Elem(I))
    EIGVEC(:,I) = UMAT(:,I)
  end do
  call mma_deallocate(UMAT)
  call mma_deallocate(HTRI)

  if ((IPRGLB >= TERSE) .and. PrRes) then
    if (IFRMS) then
      variant = 'RMS'
    else if (IFXMS .and. IFDW) then
      variant = 'XDW'
    else if (IFXMS) then
      variant = 'XMS'
    else if (IFDW) then
      variant = 'DW '
    else
      variant = 'MS '
    end if
    if (HZERO /= 'DYALL') then !! CASPT2
      write(u6,*)
      write(u6,'(6X,A,A)') ' Total ',trim(variant)//'-CASPT2 energies:'
      do I=1,NSTATE
        call PrintResult(u6,'(6x,A,I3,5X,A,F16.8)',trim(variant)//'-CASPT2 Root',I,'Total energy:',ENERGY(I),1)
      end do
    else !! NEVPT2
      if (iloop == 1) variant = 'QD-PC'
      if (iloop == 2) variant = 'QD-SC'
      write(u6,*)
      write(u6,'(6X,A,A)') ' Total ',trim(variant)//'-NEVPT2 energies:'
      do I=1,NSTATE
        call PrintResult(u6,'(6x,A,I3,5X,A,F16.8)',trim(variant)//'-NEVPT2 Root',I,'Total energy:',ENERGY(I),1)
      end do
    end if
  end if

  if ((IPRGLB >= USUAL) .and. PrRes) then
    write(u6,*)
    write(u6,'(6X,A)') ' Eigenvectors:'
    do ISTA=1,NSTATE,5
      IEND = min(ISTA+4,NSTATE)
      do J=1,NSTATE
        write(u6,'(6x,5F16.8)') (EIGVEC(J,I),I=ISTA,IEND)
      end do
      write(u6,*)
    end do
    if (IFXMS .or. IFRMS) then
      ! Transform eigenvectors into the original input basis
      call mma_allocate(Utmp,Nstate,Nstate,Label='Utmp')
      call dgemm_('N','N',Nstate,Nstate,Nstate,One,U0,Nstate,eigvec,Nstate,Zero,Utmp,Nstate)
      write(u6,'(6X,A)') ' In terms of the input states:'
      do ISTA=1,NSTATE,5
        IEND = min(ISTA+4,NSTATE)
        do J=1,NSTATE
          write(u6,'(6x,5F16.8)') (Utmp(J,I),I=ISTA,IEND)
        end do
        write(u6,*)
      end do
      call mma_deallocate(Utmp)
    end if
    call CollapseOutput(0,'Multi-State CASPT2 section:')
    write(u6,*)
  end if

  ! Restore original effective Hamiltonian
  do I=1,NSTATE
    HEFF(I,I) = HEFF(I,I)+DSHIFT
  end do

  if (nloop == 2) then
    do i=1,nstate
      do j=1,nstate
        tmp = HEFF(j,i)
        HEFF(j,i) = HEFF_SC(j,i)
        HEFF_SC(j,i) = tmp
        tmp = EIGVEC(j,i)
        EIGVEC(j,i) = UEFF_SC(j,i)
        UEFF_SC(j,i) = tmp
      end do
    end do
    call dswap_(NSTATE,ENERGY,1,ENERGY_SC,1)
    if (iloop == 1) then
      do I=1,NSTATE
        HEFF(I,I) = HEFF(I,I)-DSHIFT
      end do
    end if
  end if
end do

! In automatic verification calculations, the precision is lower
! in case of Cholesky calculation.
LAXITY = 8
if (IfChol) LAXITY = Cho_X_GetTol(LAXITY)
if ((HZERO /= 'DYALL') .or. (.not. SC_prop)) then
  call Add_Info('E_MSPT2',ENERGY,nState,LAXITY)
else
  call Add_Info('E_MSPT2',ENERGY_SC,nState,LAXITY)
  ENERGY(1:NSTATE) = ENERGY_SC(:)
  !! Replace the effective H and eigenvec with those for SC
  HEFF(:,:) = HEFF_SC(:,:)
  EIGVEC(:,:) = UEFF_SC(:,:)
end if

end subroutine MLTCTL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      Subroutine PutRlx(D,DS,P,DAO,C)
      use spin_correlation, only: tRootGrad
      use stdalloc, only: mma_allocate, mma_deallocate
      use rasscf_global, only: CBLBM, ENER, ExFac, iBLBM, IPCMROOT, iPr,
     &                         iRLXRoot, iSymBB, ITER, lRoots, lSquare,
     &                         NACPAR, NACPR2, NewFock, nFint, nRoots,
     &                         NSXS, NTOT4, RlxGrd, iAdr15, ISTORP,
     &                         JBLBM
      use PrintLevel, only: DEBUG,USUAL
      use output_ras, only: LF,IPRLOC
      use general_data, only: NTOT1,NTOT2,NSYM,JOBIPH,NBAS
      use DWSol, only: DWSolv, DWSol_wgt, W_SOLV
      use rctfld_module, only: lRF

      Implicit None
      Real*8 D(*),DS(*),P(*),DAO(*),C(*)

      Character(LEN=8)  Fmt2
      Character(LEN=16), Parameter:: ROUTINE='PUTRLX  '
      Real*8 rdum(1)
      Integer i, iFinal, iPrLev, istmp, itmp, jDisk, jtmp, kDisk,
     &        left, NFSize, NZ
      Real*8 rTmp, wgt
      Real*8, External:: DNRM2_

      Real*8, Allocatable:: DA(:), DA_ave(:), DI(:), DSX(:), DS_ave(:),
     &                      DX(:), F(:), B(:), Q(:), FA(:), FI(:),
     &                      PUVX(:), TUVX(:), PX(:), WRK1(:), WRK2(:)
      Logical, external :: PCM_On

      IPRLEV=IPRLOC(3)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
*
*     Read in corresponding density matrixes
*

      ! empty line before root resolved orbital gradient
      NZ=NTOT2
      kDisk = IADR15(3)  ! we need to save this address to reset later
      jDisk = IADR15(3)
      Call mma_allocate(DA,NZ,Label='DA')
      Call mma_allocate(DI,NZ,Label='DI')
      Call mma_allocate(DSX,NZ,Label='DSX')
      if (tRootGrad) then
        write(lf,*)
        do i = 1, LRoots
          call ddafile(JOBIPH, 2, D, NACPAR, jDisk)
          call ddafile(JOBIPH, 2, DS, NACPAR, jDisk)
          call ddafile(JOBIPH, 2, P, NACPR2, jDisk)
          call ddafile(JOBIPH, 0, rdum, NACPR2, jDisk)
*
*         Construc D-ACTIVE AND D-INACTIVE IN AO BASIS
*
*
          Call Get_D1I_RASSCF(C,DI)
*
          Call mma_allocate(DX,NACPAR,Label='DX')
*
          CALL DCOPY_(NACPAR,DS,1,DX,1)
          Call DBLOCK(DX)
          CALL Get_D1A_RASSCF(C,DX,DSX)
*
          CALL DCOPY_(NACPAR,D,1,DX,1)
          Call DBLOCK(DX)
          CALL Get_D1A_RASSCF(C,DX,DA)
*
*         Construct the Fock matrix used for the connection term.
*
          NFSIZE=MAX(NACPAR,NTOT4)
          Call mma_allocate(F,NFSIZE,Label='F')
          Call mma_allocate(B,NZ,Label='B')
          Call mma_allocate(Q,NZ,Label='Q')
          Call mma_allocate(FA,NZ,Label='FA')
          Call mma_allocate(FI,NZ,Label='FI')
          Call mma_allocate(PUVX,NFINT,Label='PUVX')
          Call mma_allocate(tuvx,nacpr2,Label='tuvx')
          IPR=0
          IF(IPRLEV.EQ.3) IPR=1
          IF(IPRLEV.EQ.4) IPR=5
          IF(IPRLEV.EQ.5) IPR=10
          PUVX(:)=0.0D0
          Call TraCtl2(C,PUVX,TUVX,DI,FI,DA,FA,ipr,lsquare,ExFac)
          CALL SGFCIN(C,F,FI,DI,DA,DSX)
          call dcopy_(ntot4,[0.0d0],0,F,1)
          call dcopy_(ntot4,[0.0d0],0,B,1)
*
*         Prevent FMAT from changing Active fock matrix
*
          iTmp=newfock
          newFock=-99999
*
          Call Fmat(C,PUVX,DX,DA,FI,FA)
          newFock=itmp
          IFINAL=1
          rTmp=   CBLBM
          itmp= IBLBM
          jtmp= JBLBM
          istmp= ISYMBB

          IF(ISTORP(NSYM+1).GT.0) THEN
              CALL mma_allocate(PX,ISTORP(NSYM+1),Label='PX')
              CALL PMAT_RASSCF(P,PX)
          Else
              CALL mma_allocate(PX,1,Label='PX')
          END IF
*
          Call FOCK(F,B,FI,FA,DX,PX,Q,PUVX,IFINAL,C)
          CBLBM=rtmp
          IBLBM=itmp
          JBLBM=jtmp
          ISYMBB=istmp
          CALL mma_deallocate(PX)

          write(6,'(6x,a,i3,5x,f12.10)')
     &        "Norm of electronic gradient for root ", i,
     &        DNRM2_(NSXS,B,1)
*
          Call mma_deallocate(DX)
          Call mma_deallocate(tuvx)
          Call mma_deallocate(puvx)
          Call mma_deallocate(FI)
          Call mma_deallocate(FA)
          Call mma_deallocate(Q)
          Call mma_deallocate(B)
          Call mma_deallocate(F)
        end do
      end if

      Do i=1,iRlxRoot-1
        Call DDaFile(JOBIPH,0,rdum,NACPAR,kDisk)
        Call DDaFile(JOBIPH,0,rdum,NACPAR,kDisk)
        Call DDaFile(JOBIPH,0,rdum,NACPR2,kDisk)
        Call DDaFile(JOBIPH,0,rdum,NACPR2,kDisk)
      End Do
      Call DDaFile(JOBIPH,2,D,NACPAR,kDisk)
      Call DDaFile(JOBIPH,2,DS,NACPAR,kDisk)
      Call DDaFile(JOBIPH,2,P,NACPR2,kDisk)
      Call DDaFile(JOBIPH,0,rdum,NACPR2,kDisk)
*
*     Construc D-ACTIVE AND D-INACTIVE IN AO BASIS
*
      Call Get_D1I_RASSCF(C,DI)
*
      Call mma_allocate(DX,NACPAR,Label='DX')
*
      CALL DCOPY_(NACPAR,DS,1,DX,1)
      Call DBLOCK(DX)
      CALL Get_D1A_RASSCF(C,DX,DSX)
*
      CALL DCOPY_(NACPAR,D,1,DX,1)
      Call DBLOCK(DX)
      CALL Get_D1A_RASSCF(C,DX,DA)
*
*     Construct the Fock matrix used for the connection term.
*
      NFSIZE=MAX(NACPAR,NTOT4)
      Call mma_allocate(F,NFSIZE,Label='F')
      Call mma_allocate(B,NZ,Label='B')
      Call mma_allocate(Q,NZ,Label='Q')
      Call mma_allocate(FA,NZ,Label='FA')
      Call mma_allocate(FI,NZ,Label='FI')
      Call mma_allocate(PUVX,NFINT,Label='PUVX')
      Call mma_allocate(tuvx,nacpr2,Label='tuvx')
      IPR=0
      IF(IPRLEV.EQ.3) IPR=1
      IF(IPRLEV.EQ.4) IPR=5
      IF(IPRLEV.EQ.5) IPR=10
      PUVX(:)=0.0D0
      Call TraCtl2(C,PUVX,TUVX,DI,FI,DA,FA,ipr,lsquare,ExFac)
*
      ! DA constructed above is the density for the RLXROOT state.
      ! We should reconstruct the AO density matrix to prevent the
      ! mismatch of states for reaction field and geometry optimization
      ! It seems that IPCMROOT may not be defined sometimes
      if (lRF .and. PCM_On() .and. (IPCMROOT /= iRLXROOT .or.
     *    IPCMROOT <= 0 .or. DWSolv%DWZeta /= 0.0d+00)) then
        !! Polarize PCM etc with weighted density
        Call mma_allocate(DA_ave,MAX(NACPAR,NZ),Label='DA_ave')
        Call mma_allocate(DS_ave,MAX(NACPAR,NZ),Label='DS_ave')
        Call mma_allocate(WRK1,MAX(NACPAR,NZ),Label='WRK1')
        Call mma_allocate(WRK2,MAX(NACPAR,NZ),Label='WRK2')
*
        DA_ave(:) = 0.0d+00
        DS_ave(:) = 0.0d+00
*
        call DWSol_wgt(2,ENER(:,ITER))
        kDisk = IADR15(3)
        Do i=1,nRoots
          wgt = W_SOLV(i)
          Call DDaFile(JOBIPH,2,WRK1,NACPAR,kDisk)
          Call DDaFile(JOBIPH,2,WRK2,NACPAR,kDisk)
          Call DDaFile(JOBIPH,0,rdum,NACPR2,kDisk)
          Call DDaFile(JOBIPH,0,rdum,NACPR2,kDisk)
          if (wgt < 1.0d-09) cycle
          call daxpy_(NACPAR,wgt,WRK1,1,DA_ave,1)
          call daxpy_(NACPAR,wgt,WRK2,1,DS_ave,1)
        End Do
*
*       Construc D-ACTIVE AND D-INACTIVE IN AO BASIS
*
        CALL DCOPY_(NACPAR,DS_ave,1,DX,1)
        call dcopy_(NZ,DSX,1,DS_ave,1)
        Call DBLOCK(DX)
        CALL Get_D1A_RASSCF(C,DX,DSX)
*
        CALL DCOPY_(NACPAR,DA_ave,1,DX,1)
        call dcopy_(NZ,DA,1,DA_ave,1)
        Call DBLOCK(DX)
        CALL Get_D1A_RASSCF(C,DX,DA)
*
        Call mma_deallocate(WRK1)
        Call mma_deallocate(WRK2)
        IF(IPRLEV.GE.USUAL .AND. DWSolv%DWZeta > 0.0d+00) THEN
          left=6
          Write(LF,*)
          Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
          Write(LF,Fmt2//'A)')
     &      'Dynamically weighted solvation has been employed'
          Write(LF,Fmt2//'A,(T45,10F6.3))')
     &      'Final weights for the reaction field:',
     &                                (W_SOLV(i),i=1,nRoots)
        END IF
      end if
*
      CALL SGFCIN(C,F,FI,DI,DA,DSX)
      call dcopy_(ntot4,[0.0d0],0,F,1)
      call dcopy_(ntot4,[0.0d0],0,B,1)
*
*     Prevent FMAT from changing Active fock matrix
*
      iTmp=newfock
      newFock=-99999
*
      if (lRF .and. PCM_On() .and. (IPCMROOT /= iRLXROOT .or.
     *    IPCMROOT <= 0 .or. DWSolv%DWZeta /= 0.0d+00)) then
        ! The rest of the RASSCF program uses state-specific density
        ! (note that, it is iRlxRoot!), so restore the one constructed
        ! above, before TraCtl2
        Call dcopy_(NZ,DA_ave,1,DA,1)
        Call dcopy_(NZ,DS_ave,1,DSX,1)
        Call mma_deallocate(DA_ave)
        Call mma_deallocate(DS_ave)
*
        Call mma_allocate(WRK1,nTot1,Label='WRK1')
        Call mma_allocate(WRK2,nTot1,Label='WRK2')
        Call Fold(nSym,nBas,DI,WRK1)
        Call Fold(nSym,nBas,DA,WRK2)
        Call Daxpy_(nTot1,1.0d+00,WRK1,1,WRK2,1)
        Call Put_dArray('D1ao',WRK2,nTot1)
        Call Fold(nSym,nBas,DSX,WRK1)
        Call Put_dArray('D1sao',WRK1,nTot1)
        Call mma_deallocate(WRK1)
        Call mma_deallocate(WRK2)
      end if
*
      Call Fmat(C,PUVX,DX,DA,FI,FA)
      newFock=itmp
      IFINAL=1
      rTmp=   CBLBM
      itmp= IBLBM
      jtmp= JBLBM
      istmp= ISYMBB

      IF(ISTORP(NSYM+1).GT.0) THEN
          CALL mma_allocate(PX,ISTORP(NSYM+1),Label='PX')
          CALL PMAT_RASSCF(P,PX)
      Else
          CALL mma_allocate(PX,1,Label='PX')
      END IF
*
      Call FOCK(F,B,FI,FA,DX,PX,Q,PUVX,IFINAL,C)
      CBLBM=rtmp
      IBLBM=itmp
      JBLBM=jtmp
      ISYMBB=istmp
      CALL mma_deallocate(PX)

      RlxGrd=DNRM2_(NSXS,B,1)
*
      Call mma_deallocate(DX)
      Call mma_deallocate(tuvx)
      Call mma_deallocate(puvx)
      Call mma_deallocate(FI)
      Call mma_deallocate(FA)
      Call mma_deallocate(Q)
      Call mma_deallocate(B)
      Call mma_deallocate(F)
*
* Add up one electron densities
*
      call daxpy_(nZ,1.0d0,DA,1,DI,1)
      Call Fold(nSym,nBas,DI,DAO)

      Call mma_deallocate(DSX)
      Call mma_deallocate(DA)
      Call mma_deallocate(DI)

      end Subroutine PutRlx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_getIntegralsSelectedByPSD(PrintLevel,
     &                                         Mode,tau,Tol,
     &                                         AB,CD,
     &                                         l_xInt,xInt,
     &                                         IntegralID)
C
C     Thomas Bondo Pedersen, January 2012.
C
C     Purpose: return (AB|CD) integrals in xInt.
C              If the LDF integrals are positive semidefinite:
C                 IntegralID='LDF  '
C                 return LDF integrals
C              else
C                 IntegralID='exact'
C                 return exact integrals
C
C              Positivity is established by means of Cholesky
C              decomposition and Tol defines the tolerance for
C              negative diagonal elements (and hence negativity).
C
C              LDF integrals are computed according to Mode,
C              which is simply passed on to the LDF integral routines
C              along with tau, the integral prescreening threshold.
C
C              Verbosity:
C                PrintLevel<=0: silent
C                PrintLevel=1:  only print stuff in case of error
C                PrintLevel>=2: verbose
C
      Implicit None
      Integer PrintLevel
      Integer Mode
      Real*8  tau
      Real*8  Tol
      Integer AB, CD
      Integer l_xInt
      Real*8  xInt(l_xInt)
      Character*5 IntegralID
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*29 SecNam
      Parameter (SecNam='LDF_getIntegralsSelectedByPSD')

      Real*8 Dummy
      Integer iDummy
      Parameter (iDummy=-1234567)

      Logical doDiagonalization
      Parameter (doDiagonalization=.False.)

      Logical Debug
#if defined (_DEBUGPRINT_)
      Parameter (Debug=.True.)
#else
      Parameter (Debug=.true.)
#endif

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Logical  isSymmetric
      External isSymmetric

      real*8 ddot_
      external ddot_

      Integer iPrint
      Integer nAB, nCD, nTot
      Integer ip_LDFInt, l_LDFInt
      Integer ip_Scr, l_Scr
      Integer l, m, ip1, ip2
      Integer ip_EigVal, l_Eigval
      Integer ip_EigVec, l_Eigvec
      Integer ip_Aux, l_Aux
      Integer nFound, iErr

      Real*8 ThrNeg, ThrFail
      Real*8 x
      Real*8 Norm_2(3)

      Integer i, j
      Integer AP_Atoms
      Integer iTri
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      iPrint=PrintLevel
      ThrNeg=-min(1.0d-13,abs(Tol)*1.0d-2)
      If (sign(1.0d0,Tol).lt.0.0d0) Then
         ThrFail=Tol
      Else
         ThrFail=-Tol
      End If

      ! Check dimension
      nAB=LDF_nBas_Atom(AP_Atoms(1,AB))*LDF_nBas_Atom(AP_Atoms(2,AB))
      nCD=LDF_nBas_Atom(AP_Atoms(1,CD))*LDF_nBas_Atom(AP_Atoms(2,CD))
      If (nAB*nCD .gt. l_xInt) Then
         Call WarningMessage(2,
     &                SecNam//': insufficient integral array dimension')
         Call LDF_Quit(1)
      End If

      ! Print header
      If (iPrint.gt.0) Then
         Write(6,'(A,A,I6,A,I6)') SecNam,': AB=',AB,' CD=',CD
         Write(6,'(80A)') ('=',l=1,len(SecNam)+21)
         Write(6,'(3X,A,I2)') 'Mode=',Mode
         Write(6,'(3X,A,1P,D12.4)') 'Prescreening=',tau
         If (.not.doDiagonalization) Then
            Write(6,'(3X,A,1P,D12.4)') 'Negative diagonal zeroing=',
     &                                 ThrNeg
         End If
         Write(6,'(3X,A,1P,D12.4)') 'Tolerance for negative diagonal=',
     &                              ThrFail
      End If

      ! Compute LDF integrals, full AB,CD block
      ! [i.e. including (AB|AB) and (CD|CD)]
      ! Save (AB|CD) in xInt; it may be returned later
      If (AB.eq.CD) Then
         If (iPrint.gt.1) Then
            Write(6,'(3X,A)') 'Computing (AB|AB) LDF integrals'
         End If
         nTot=nAB
         l_LDFInt=nTot**2
         Call GetMem('LDFInt','Allo','Real',ip_LDFInt,l_LDFInt)
         Call LDF_ComputeValenceIntegralsFromC(Mode,tau,
     &                                         AB,AB,l_LDFInt,
     &                                         Work(ip_LDFInt))
         Call dCopy_(l_LDFInt,Work(ip_LDFInt),1,xInt(1),1) !save (AB|AB)
         If (Debug) Then
            Norm_2(1)=dDot_(l_LDFInt,Work(ip_LDFInt),1,
     &                              Work(ip_LDFInt),1)
            Norm_2(2)=0.0d0
            Norm_2(3)=0.0d0
         End If
      Else
         If (iPrint.gt.1) Then
            Write(6,'(3X,A)') 'Computing (AB|AB) LDF integrals'
         End If
         nTot=nAB+nCD
         l_LDFInt=nTot**2
         Call GetMem('LDFInt','Allo','Real',ip_LDFInt,l_LDFInt)
         l_Scr=max(nAB,nCD)**2
         Call GetMem('IntScr','Allo','Real',ip_Scr,l_Scr)
         Call LDF_ComputeValenceIntegralsFromC(Mode,tau,
     &                                         AB,AB,l_Scr,
     &                                         Work(ip_Scr))
         If (Debug) Then
            Norm_2(1)=dDot_(nAB**2,Work(ip_Scr),1,Work(ip_Scr),1)
         End If
         ip1=ip_Scr
         ip2=ip_LDFInt
         Do l=1,nAB
            Call dCopy_(nAB,Work(ip1),1,Work(ip2),1)
            ip1=ip1+nAB
            ip2=ip2+nTot
         End Do
         If (iPrint.gt.1) Then
            Write(6,'(3X,A)') 'Computing (AB|CD) LDF integrals'
         End If
         Call LDF_ComputeValenceIntegralsFromC(Mode,tau,
     &                                         AB,CD,l_Scr,
     &                                         Work(ip_Scr))
         If (Debug) Then
            Norm_2(2)=dDot_(nAB*nCD,Work(ip_Scr),1,Work(ip_Scr),1)
         End If
         Call dCopy_(nAB*nCD,Work(ip_Scr),1,xInt(1),1) !save (AB|CD)
         ip1=ip_Scr
         ip2=ip_LDFInt+nTot*nAB
         Do l=1,nCD
            Call dCopy_(nAB,Work(ip1),1,Work(ip2),1)
            ip1=ip1+nAB
            ip2=ip2+nTot
         End Do
         ip1=ip_Scr
         ip2=ip_LDFInt+nAB
         Do l=1,nAB
            Call dCopy_(nCD,Work(ip1),nAB,Work(ip2),1)
            ip1=ip1+1
            ip2=ip2+nTot
         End Do
         If (iPrint.gt.1) Then
            Write(6,'(3X,A)') 'Computing (CD|CD) LDF integrals'
         End If
         Call LDF_ComputeValenceIntegralsFromC(Mode,tau,
     &                                         CD,CD,l_Scr,
     &                                         Work(ip_Scr))
         If (Debug) Then
            Norm_2(3)=dDot_(nCD**2,Work(ip_Scr),1,Work(ip_Scr),1)
         End If
         ip1=ip_Scr
         ip2=ip_LDFInt+nTot*nAB+nAB
         Do l=1,nCD
            Call dCopy_(nCD,Work(ip1),1,Work(ip2),1)
            ip1=ip1+nCD
            ip2=ip2+nTot
         End Do
         Call GetMem('IntScr','Free','Real',ip_Scr,l_Scr)
      End If

      If (Debug) Then
         If (isSymmetric(Work(ip_LDFInt),nTot,1.0d-12)) Then
            If (iPrint.gt.1) Then
               If (AB.eq.CD) Then
                  Write(6,'(3X,A)') '(AB|AB)  is symmetric'
               Else
                  Write(6,'(3X,A)') '(AB|AB) | (AB|CD)'
                  Write(6,'(3X,A)') '-----------------  is symmetric'
                  Write(6,'(3X,A)') '(CD|AB) | (CD|CD)'
               End If
            End If
         Else
            If (iPrint.gt.1) Then
               Call Cho_Head('Block: (AB|AB)','-',80,6)
               Call Cho_Output(Work(ip_LDFInt),1,nAB,1,nAB,nTot,nTot,
     &                         1,6)
               If (AB.ne.CD) Then
                  Call Cho_Head('Block: (AB|CD)','-',80,6)
                  Call Cho_Output(Work(ip_LDFInt),1,nAB,nAB+1,nTot,
     &                            nTot,nTot,1,6)
                  Call Cho_Head('Block: (CD|AB)','-',80,6)
                  Call Cho_Output(Work(ip_LDFInt),nAB+1,nTot,1,nAB,
     &                            nTot,nTot,1,6)
                  Call Cho_Head('Block: (CD|CD)','-',80,6)
                  Call Cho_Output(Work(ip_LDFInt),nAB+1,nTot,nAB+1,nTot,
     &                            nTot,nTot,1,6)
               End If
            End If
            Call WarningMessage(2,
     &                      SecNam//': integral block is not symmetric')
            Call LDF_Quit(1)
         End If
         iErr=0
         x=0.0d0
         Do i=1,nTot
            If (sign(1.0d0,Work(ip_LDFInt-1+nTot*(i-1)+i)).lt.0.0d0)
     &      Then
               If (Work(ip_LDFInt-1+nTot*(i-1)+i).lt.ThrNeg) Then
                  iErr=iErr+1
                  If (iPrint.gt.0) Then
                     Write(6,'(3X,A,1P,D20.10)')
     &               'Negative diagonal element:',
     &               Work(ip_LDFInt-1+nTot*(i-1)+i)
                  End If
                  If (Work(ip_LDFInt-1+nTot*(i-1)+i).lt.x) Then
                     x=Work(ip_LDFInt-1+nTot*(i-1)+i)
                  End If
               End If
            End If
         End Do
         If (iErr.eq.0) Then
            If (iPrint.gt.1) Then
               Write(6,'(3X,A)') 'Diagonal positive'
            End If
         Else
            If (iPrint.gt.0) Then
               Write(6,'(3X,A,1P,D20.10)')
     &         'Diagonal NOT positive, smallest=',x
            End If
            If (x.lt.ThrFail) Then
               Call WarningMessage(2,SecNam//': negative diagonal')
               Call LDF_Quit(1)
            End If
         End If
         x=0.0d0
         Do j=1,nAB
            x=x+dDot_(nAB,Work(ip_LDFInt+nTot*(j-1)),1,
     &                   Work(ip_LDFInt+nTot*(j-1)),1)
         End Do
         If (abs(x-Norm_2(1)).gt.1.0d-10) Then
            Call WarningMessage(2,SecNam//': (AB|AB) norm error')
            Call LDF_Quit(1)
         End If
         If (CD.ne.AB) Then
            x=0.0d0
            Do j=1,nCD
               x=x+dDot_(nAB,Work(ip_LDFInt+nTot*(nAB+j-1)),1,
     &                      Work(ip_LDFInt+nTot*(nAB+j-1)),1)
            End Do
            If (abs(x-Norm_2(2)).gt.1.0d-10) Then
               Call WarningMessage(2,SecNam//': (AB|CD) norm error')
               Call LDF_Quit(1)
            End If
            x=0.0d0
            Do j=1,nAB
               x=x+dDot_(nCD,Work(ip_LDFInt+nTot*(j-1)+nAB),1,
     &                      Work(ip_LDFInt+nTot*(j-1)+nAB),1)
            End Do
            If (abs(x-Norm_2(2)).gt.1.0d-10) Then
               Call WarningMessage(2,SecNam//': (CD|AB) norm error')
               Call LDF_Quit(1)
            End If
            x=0.0d0
            Do j=1,nCD
               x=x+dDot_(nCD,Work(ip_LDFInt+nTot*(nAB+j-1)+nAB),1,
     &                      Work(ip_LDFInt+nTot*(nAB+j-1)+nAB),1)
            End Do
            If (abs(x-Norm_2(3)).gt.1.0d-10) Then
               Call WarningMessage(2,SecNam//': (CD|CD) norm error')
               Call LDF_Quit(1)
            End If
         End If
         If (iPrint.gt.1) Then
            Write(6,'(3X,A)')
     &      'Block norms OK within 1.0d-10'
         End If
         x=dDot_(nTot**2,Work(ip_LDFInt),1,Work(ip_LDFInt),1)
         If (abs(x-(Norm_2(1)+2.0d0*Norm_2(2)+Norm_2(3))).gt.1.0d-10)
     &   Then
            Call WarningMessage(2,SecNam//': integral norm error')
            Call LDF_Quit(1)
         End If
      End If

      If (doDiagonalization) Then
         ! Check for positivity by diagonalization
         If (iPrint.gt.1) Then
            If (AB.eq.CD) Then
               Write(6,'(3X,A)') 'Triangularization of (AB|AB)'
            Else
               Write(6,'(3X,A)')
     &                        '                     (AB|AB) | (AB|CD)'
               Write(6,'(3X,A)')
     &                        'Triangularization of -----------------'
               Write(6,'(3X,A)')
     &                        '                     (CD|AB) | (CD|CD)'
            End If
         End If
         l_Aux=nTot**2
         l_EigVal=nTot
         l_EigVec=nTot**2
         Call GetMem('Aux','Allo','Real',ip_Aux,l_Aux)
         Call GetMem('EigVal','Allo','Real',ip_EigVal,l_EigVal)
         Call GetMem('EigVec','Allo','Real',ip_EigVec,l_EigVec)
        If (Debug) Call dCopy_(nTot**2,Work(ip_LDFInt),1,Work(ip_Aux),1)
         Call Local_Triang(nTot,Work(ip_LDFInt)) !triangularization
         If (Debug) Then
            iErr=0
            Do m=1,nTot
               Do l=1,nTot
                  If (abs(Work(ip_LDFInt-1+iTri(l,m))
     &                   -Work(ip_Aux-1+nTot*(m-1)+l)).gt.1.0d-12) Then
                     iErr=iErr+1
                     If (iPrint.gt.1) Then
                        Write(6,'(3X,A,I12,A,2I7,1P,2(1X,D15.6))')
     &                  'Triangularization error',iErr,': i,j,sq,tri=',
     &                  l,m,Work(ip_Aux-1+nTot*(m-1)+l),
     &                  Work(ip_Aux-1+iTri(l,m))
                     End If
                  End If
               End Do
            End Do
            If (iErr.ne.0) Then
               If (iPrint.gt.0) Then
                  Write(6,'(3X,A,I12)')
     &            'Triangularization errors:',iErr
               End If
               Call WarningMessage(2,
     &             SecNam//': integral matrix triangularization failed')
               Call LDF_Quit(1)
            Else
               If (iPrint.gt.0) Then
                  Write(6,'(3X,A)')
     &            'Triangularization succeeded'
               End If
            End If
         End If
         If (iPrint.gt.1) Then
            If (AB.eq.CD) Then
               Write(6,'(3X,A)') 'Diagonalizing (AB|AB)'
            Else
               Write(6,'(3X,A)') '              (AB|AB) | (AB|CD)'
               Write(6,'(3X,A)') 'Diagonalizing -----------------'
               Write(6,'(3X,A)') '              (CD|AB) | (CD|CD)'
            End If
         End If
         nFound=0
         iErr=0
         Call Diag_Driver('V','A','L',nTot,Work(ip_LDFInt),Work(ip_Aux),
     &                    nTot,Dummy,Dummy,iDummy,iDummy,
     &                    Work(ip_EigVal),Work(ip_EigVec),nTot,1,
     &                    1,'A',nFound,iErr)
         iErr=0
         l=0
         Do While (l.lt.nTot)
            If (sign(1.0d0,Work(ip_EigVal+l)).lt.0.0d0) Then
               If (Work(ip_EigVal+l).lt.ThrNeg .and. iPrint.gt.1) Then
                  Write(6,'(2X,A,1P,D20.10)')
     &            'Negative eigenvalue=',Work(ip_EigVal+l)
               End If
               If (Work(ip_EigVal+l).lt.ThrFail) Then
                  If (iPrint.gt.0) Then
                     Write(6,'(3X,A,1P,D20.10)')
     &               'NON-PSD! Negative eigenvalue=',Work(ip_EigVal+l)
                  End If
                  iErr=iErr+1
                  l=l+1
               Else
                  l=nTot
               End If
            Else
               l=nTot ! break loop
            End If
         End Do
         Call GetMem('EigVec','Free','Real',ip_Eigvec,l_EigVec)
         Call GetMem('EigVal','Free','Real',ip_EigVal,l_EigVal)
         Call GetMem('Aux','Free','Real',ip_Aux,l_Aux)
      Else
         ! Check for positivity by Cholesky decomposition
         If (iPrint.gt.1) Then
            If (AB.eq.CD) Then
               Write(6,'(3X,A)') 'Cholesky dec. (AB|AB)'
            Else
               Write(6,'(3X,A)') '              (AB|AB) | (AB|CD)'
               Write(6,'(3X,A)') 'Cholesky dec. -----------------'
               Write(6,'(3X,A)') '              (CD|AB) | (CD|CD)'
            End If
         End If
         l_Aux=nTot**2
         Call GetMem('CDVec','Allo','Real',ip_Aux,l_Aux)
         Call CD_InCore_1(Work(ip_LDFInt),nTot,Work(ip_Aux),nTot,l,
     &                    1.0d-12,ThrNeg,ThrFail,iErr)
         If (iErr.ne.0) Then
            If (iPrint.gt.0) Then
               Write(6,'(3X,A,I6)')
     &         'Cholesky decomposition failed with error code',iErr
            End If
            If (iErr.lt.0) Then
               Call WarningMessage(2,SecNam//': error in CD_InCore')
               Call LDF_Quit(1)
            End If
            If (iErr.eq.101 .and. iPrint.gt.1) Then
               x=Work(ip_LDFInt)
               Do i=2,nTot
                  x=min(x,Work(ip_LDFInt-1+nTot*(i-1)+i))
               End Do
               Write(6,'(3X,A,1P,D20.10)')
     &         'Smallest diagonal element=',x
            End If
         Else
            If (iPrint.gt.1) Then
               Write(6,'(3X,A,2I6)')
     &         'Cholesky decomposition succeeded: dimension and rank=',
     &         nTot,l
               If (l.lt.nTot) Then
                  Write(6,'(3X,A)')
     &            'Matrix is positive semidefinite'
               Else If (l.eq.nTot) Then
                  Write(6,'(3X,A)')
     &            'Matrix is positive definite'
               Else
                  Call WarningMessage(2,SecNam//': rank>dimension')
                  Call LDF_Quit(1)
               End If
            End If
         End If
         Call GetMem('CDVec','Free','Real',ip_Aux,l_Aux)
      End If
      Call GetMem('LDFInt','Free','Real',ip_LDFInt,l_LDFInt)

      ! If negative eigenvalues, compute and return conventional
      ! integrals, else return LDF integrals (already in xInt)
      If (iErr.ne.0) Then
         If (iPrint.gt.1) Then
            Write(6,'(3X,A)') 'Computing exact integrals (AB|CD)'
         End If
         IntegralID='exact'
         Call LDF_ComputeValenceIntegrals(AB,CD,l_xInt,xInt)
      Else
         IntegralID='LDF  '
      End If
      If (iPrint.gt.0) Then
         If (AB.eq.CD) Then
            Write(6,'(3X,A,A,A)')
     &      'Returning ',IntegralID,' integrals (AB|AB)'
         Else
            Write(6,'(3X,A,A,A)')
     &      'Returning ',IntegralID,' integrals (AB|CD)'
         End If
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine ReadBas(Lhigh,makemean,bonn,breit,
     &                   symmetry,sameorb,AIMP,oneonly,ncont4,
     &                   numballcart,IN,ifinite)
*
*     Suposed to read the maximum of l-values, the number of primitive and
*     contracted functions, the exponents and contraction coefficients
*
      Implicit Real*8 (a-h,o-z)
#include "para.fh"
#include "param.fh"
#include "ired.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
      Integer, Allocatable:: nOff(:,:)
      Character*4 Word
      Character*4 Symmetry
      Character*15 lLimit
      Character*21 chCharge
      Character*32 NofPrim
      Character*30 AddText
      Character*33 Nofcont
      Character*54 Stars
      Logical MakeMean, Bonn, Breit, SameOrb, AIMP, OneOnly, IfTest
      Common /Nucleus/ Charge, Exp_Finite
      Integer OUT, iBeginIRed(8), iDelperSym(8)
      Data IfTest/.False./
*
#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif
      OUT=6
      Llimit  =' Max. l-value: '
      chCharge='  Charge of nucleus: '
      NofPrim =' Number of primitive functions: '
      NofCont =' Number of contracted functions: '
      AddText =' Additional functions in IRS: '
      Stars   ='******************************************************'
      Bonn    =.False.
      Breit   =.False.
      SameOrb =.False.
      AIMP    =.False.
      OneOnly =.False.
      MakeMean=.True.
*
      If (IfTest) Then
         Write(OUT,'(/,/,/,24X,A)') Stars
         Write(OUT,'(24X,2A)') '******** Starting Atomic Spin-Orbit MF',
     &                         ' code ********'
         Write(OUT,'(24X,A,/,/)') Stars
      End If
*
      Do I = 0, lMax
         iCore(I) = 0
      End Do
      Call RdNLst(IN,'AMFI')
 123  Read(IN,'(A4)') Word
      If (IfTest) Write(OUT,'(A4)') Word
      Call UpCase(Word)
      If (WORD.eq.'BONN') Then
         Bonn=.True.
         GoTo 123
      ElseIf (WORD.eq.'BREI') Then
         Breit=.True.
         GoTo 123
      ElseIf (WORD.eq.'FINI') Then
         iFinite=1
         Read(IN,*) Exp_finite
         GoTo 123
      ElseIf (WORD.eq.'SAME') then
         SameOrb=.True.
         GoTo 123
      ElseIf (WORD.eq.'AIMP') then
         AIMP=.True.
                Read(IN,*) lDel,(iCore(I),I=0,ldel)
         If (IfTest) Then
            Write(OUT,*)
            Write(OUT,*) 'CORE to be deleted '
                   Write(OUT,*) '   L   #orbs.  '
            Write(OUT,*)
                   Do I = 0, lDel
                      Write(OUT,'(2I5)') I,iCore(I)
                   End Do
         End If
         GoTo 124
      ElseIf (Word.eq.'ONEO') Then
         OneOnly=.True.
         Write(OUT,*) ' Only one-electron integrals!!'
         Write(OUT,*) ' Probably useful for test-purposes only'
         GoTo 123
      End If
*
 124  Continue
      If (IfTest) Then
         Write(OUT,*) ' AMFI: '
         If (BONN) Then
            Write(OUT,*) ' Bonn-approach for spin-other-orbit part'
         End If
         If (BREIT) Then
            Write(OUT,*) ' Breit-Pauli type of the SO operator'
         Else
            Write(OUT,*) ' Douglas-Kroll type of the SO operator'
         End If
         If (iFinite.eq.0) Then
            Write(OUT,*) ' Point nucleus '
         Else
            Write(OUT,*) ' Finite nucleus'
         End If
      End If
*
      Symmetry='D2H'
      NumbofSym=8
      If (IfTest) Then
         Write(OUT,*) ' Symmetry is D2H'
         If (SameOrb) then
            Write(OUT,*) ' Same-Orbit only'
         Else
            Write(OUT,*) ' Other-Orbit included'
         End If
      End If
      Read(IN,*) Charge,Lhigh
      If (Lhigh.gt.Lmax) Then
          Write(OUT,*) ' Sorry, so far this code deals only ',
     &                 '    with maximum l-values of ',Lmax
          Call Abend()
      End If
#ifdef _DEBUGPRINT_
      Write(OUT,'(A21,F5.2)') chCharge, Charge
#endif
      Call InitiRed
      Do iredrun=1,numbofsym
         Do Lrun=0,Lhigh
            nmbMperIRL(iredrun,Lrun)=0
         End Do
      End Do
      If (IfTest) Write(OUT,'(/,A)') '  Used SOC basis set: '
      Do Lrun=0,Lhigh
         Read(IN,*) nprimit(Lrun),ncontrac(Lrun)
         If (IfTest) Then
            Write(OUT,'(/,A,I2,A,I2)') '  nExp: ', nprimit(Lrun),
     &                                 ' lAng: ',lRun
            Write(OUT,'(I3,I3)') nprimit(Lrun),ncontrac(Lrun)
         End If
         If (nprimit(Lrun).gt.MxprimL) Then
            Write(OUT,*) 'To many primitives for L=',Lrun,
     &        ' increase MxprimL in para.fh or reduce ',
     &        ' the number of primitives to at least ',MxprimL
            Call Abend()
         End If
         If (ncontrac(Lrun).gt.MxcontL) Then
            Write(OUT,*) ' To many contracted fncts for L=',Lrun,
     &                   ' increase MxcontL in para.fh or ',
     &                   ' reduce the number of contracted functions',
     &                   ' to at most ',MxcontL
            Call Abend()
            End If
         If (ncontrac(Lrun).gt.nprimit(Lrun)) Then
            Write(OUT,*) ' You have more contracted than ',
     &                   ' uncontracted functions, I don''t believe ',
     &                   ' that. Sorry!! '
            Call Abend()
      End If
*
*     Read input in MOLCAS-style
*
              Read(IN,*) (exponents(ILINE,Lrun),ILINE=1,nprimit(Lrun))
              Do ILINE=1,nprimit(Lrun)
                 Read(IN,*) (cntscrtch(ILINE,JRUN,Lrun),Jrun=1,
     &                             ncontrac(Lrun))
              End Do
*
*     End of reading for the current L-value
*
      If (IfTest) Then
         Write(OUT,'(5E18.8)') (exponents(ILINE,Lrun),
     &                          ILINE=1,nprimit(Lrun))
         Do Irun = 1, ncontrac(Lrun)
            Write(OUT,*) ' orbital : ',irun
            Write(OUT,'(6(1X,F12.7))')
     &           (cntscrtch(I,Irun,Lrun),I=1,nprimit(Lrun))
         End Do
      End If
*
*     Setting the numbers of cartesians per IR
*
         Do iRedRun = 1, NumbofSym
            nFunctions(iRedRun,Lrun)=0
         End Do
         Do mRun=-Lrun,Lrun
            nfunctions(ipow2ired(ipowxyz(1,mrun,Lrun),
     &      ipowxyz(2,mrun,Lrun),Ipowxyz(3,mrun,Lrun)),Lrun)=
     &      nfunctions(ipow2ired(ipowxyz(1,mrun,Lrun),
     &      ipowxyz(2,mrun,Lrun),ipowxyz(3,mrun,Lrun)),Lrun)+
     &      ncontrac(Lrun)
         End Do
         Do mRun=-Lrun,Lrun
            nmbMperIRL(ipow2ired(ipowxyz(1,mrun,Lrun),
     &      ipowxyz(2,mrun,Lrun),Ipowxyz(3,mrun,Lrun)),lruN)=
     &      nmbMperIRL(ipOw2ired(ipowxyz(1,mrun,Lrun),
     &      ipowxyz(2,mrun,Lrun),IpowxYz(3,mrun,Lrun)),lruN)+1
         End Do
         If (IfTest) Then
            Write(OUT,'(A,8I4)')
     &      ' Number of functions per IR: ',(nfunctions(iredrun,Lrun),
     &                                           iredrun=1,numbofsym)
         End If
      End Do   ! End Do for loop over L-values
*
      If (IfTest) Then
          Write(OUT,*) ' Distribution of M-values'
          Do Lrun=0,Lhigh
             Write(OUT,*) (nmbMperIRL(nsym,Lrun),nsym=1,numbofsym)
          End Do
      End If
*
      numbofcart=0
      Do lrun=0,Lhigh
         numbofcart=numbofcart+(Lrun+Lrun+1)*
     &              ncontrac(Lrun)
      End Do
*
      Call mma_allocate(nOff,numbofcart,2,Label='nOff')
*
      Do iredrun=1,numbofsym
         nfunctperIRED(iredrun)=0
      End Do
      Do Lrun=0,Lhigh
         Do iredrun=1,numbofsym
         nfunctperIRED(iredrun)=nfunctperIRED(iredrun)+
     &                          nfunctions(iredrun,Lrun)
         End Do
      End Do
      If (IfTest) Then
         Write(OUT,'(A,8I3)')
     &        ' Total number of atomic functions per IRED ',
     &        (nfunctperIRED(iredrun),iredrun=1,numbofsym)
      End If
      isum=0
      Do iredrun=1,numbofsym
         itotalperIR(iredrun)=nfunctperIRED(iredrun)
         isum=isum+itotalperIR(iredrun)
      End Do
      numballcart=isum
      iorbrun=0
      Do iredrun=1,numbofsym
         Do inired=1,itotalperIR(iredrun)
            iorbrun=iorbrun+1
            IREDoffunctnew(Iorbrun)=iredrun
         End Do
      End Do
      If (IfTest) Then
         Write(OUT,'(A,8I3)')
     &        'including additional functions per IRED ',
     &        (itotalperIR(iredrun),iredrun=1,numbofsym)
      End If
      Do iredrun=1,numbofsym
         ibeginIRED(iredrun)=0
      End Do
      Do lrun=0,Lhigh
         Do mrun=-lrun,lrun
            iredLM(mrun,lrun)=ipow2ired(ipowxyz(1,mrun,Lrun),
     &      ipowxyz(2,mrun,Lrun),
     &      ipowxyz(3,mrun,Lrun))
            incrLM(mrun,lrun)=ibeginIRED(iredLM(mrun,lrun))
            ibeginIRED(iredLM(mrun,lrUn))=
     &      ibeginIRED(iredLM(mrun,lrun))+ncontrac(lrun)
         EndDo
      EndDo
      If (IfTest) Then
         Do lrun=0,Lhigh
            Write(OUT,'(A,I4,A,21I3)') 'L= ',lrun,
     &                                 ' shifts inside the IRED',
     &                       (incrLM(mrun,lrun),mrun=-lrun,lrun)
         End Do
      End If
      shiftIRED(1)=0
      Do iredrun=2,numbofsym
         shiftIRED(iredrun)=shiftIRED(iredrun-1)
     &                   +itotalperIR(iredrun-1)
      End Do
      If (IfTest) Then
         Write(OUT,'(A,8I4)') 'shifts for the IREDs ',
     &       (shiftIRED(iredrun),iredrun=1,numbofsym)
         Do lrun=0,Lhigh
            Do mrun=-Lrun,Lrun
               Do irun=1,ncontrac(lrun)
                  Write(OUT,*) 'L,M,contr funct, absolute number ',
     &            lrun,mrun,irun,shiftired(iredLM(mrun,lrun))+
     &            incrLM(mrun,Lrun)+irun
               End Do
            End Do
         End Do
      End If
      shiftIRIR(1)=0
      irun=1
      Do ired1=2,numbofsym
         Do ired2=1,ired1
            irun=irun+1
            If (ired2.eq.1) Then
               shiftIRIR(irun)=shiftIRIR(irun-1)+
     &         (itotalperIR(ired1-1)*itotalperIR(ired1-1)+
     &         itotalperIR(ired1-1))/2
            Else
               shiftIRIR(irun)=shiftIRIR(irun-1)+
     &         itotalperIR(ired1)*itotalperIR(ired2-1)
            End If
         End Do
      End Do
      Do lrun=0,Lhigh
         Do Mrun=-Lrun,Lrun
            ired=iredLM(Mrun,Lrun)
            ishifter=shiftIRED(ired)+incrLM(mrun,lrun)
            Do icart=1,ncontrac(Lrun)
               moffunction(ishifter+icart)=Mrun
               Loffunction(ishifter+icart)=Lrun
               IREDoffunction(ishifter+Icart)=ired
               nOff(ishifter+Icart,2)=icart
            End Do
         End Do
      End Do
      Do irun = 1, numbofcart
         nOff(irun,1)=irun
      End Do
      Do nsymrun=1,numbofsym
         idelpersym(nsymrun)=0
      End Do
      Do nsymrun=1,numbofsym
         nrtofiperIR(nsymrun)=itotalperIR(nsymrun)
      End Do
      If (AIMP) Then
*
*     Generate list of orbitals to be removed
*
         If (IfTest)
     &      Write(OUT,'(/,A)') '  Core removed for use with AIMP'
         ikeeporb=0
         numbprev=0
         Do irun=1,numbofcart
4712        If (irun.eq.1.or.(irun.ge.2.and.noff(irun,1).eq.
     &         numbprev+1)) Then
               Lval=Loffunction(irun)
               number=nOff(irun,1)
               itype=nOff(irun,2)
               If (itype.le.icore(lval)) then
                  Write(OUT,777) number,itype,lval
                  idelpersym(IREDoffunction(irun))=
     &            idelpersym(IREDoffunction(irun))+1
                  numbprev=number
               Else
                  ikeeporb=ikeeporb+1
                  ikeeplist(ikeeporb)=number
                  numbprev=number
               End If
            Else
               ikeeporb=ikeeporb+1
               ikeeplist(ikeeporb)=numbprev+1
               numbprev=numbprev+1
               GoTo 4712
            End If
         End Do
         ikeeporb=0
         Do nsymrun=1,numbofsym
            nrtofiperIR(nsymrun)=
     &      itotalperIR(nsymrun)-idelpersym(nsymrun)
         End Do
         Do nsymrun=1,numbofsym
            ikeeporb=ikeeporb+nrtofiperIR(nsymrun)
         End Do
         If (IfTest) Then
            Write(OUT,'(A,8I3)')
     &      '  Number of funct. per IRED after removing core: ',
     &           (nrtofiperIR(iredrun),iredrun=1,numbofsym)
            Write(OUT,'(I4,A)') ikeeporb,
     &      ' orbitals left after deleting core'
         End If
      End If
      nmax=max(6,ncontrac(0))
      Do lrun=1,Lhigh
         nmax=max(nmax,ncontrac(lrun))
      End Do
      ncont4=nmax*nmax*nmax*nmax
*
      Call mma_deallocate(nOff)
*
      Return
777   Format('  Orbital number ',I4,' is the ',I3,'th of L-value ',I3,
     &       ' it will be removed !!!')
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Francesco Aquilante                              *
************************************************************************
      SubRoutine Cho_SOSmp2_Energy(irc,EMP2,EOcc,EVir,Delete)
C
C     Francesco Aquilante, May 2007.
C
C     Purpose: compute "Scaled Opposite-Spin" MP2 energy correction from
C              MO Cholesky vectors of the matrix M(ai,bj)=(ai|bj)^2.
C
      Implicit Real*8 (a-h,o-z)
      Real*8  EMP2
      Real*8  EOcc(*), EVir(*)
      Integer irc
      Logical Delete
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"
#include "WrkSpc.fh"

      Character*6  ThisNm
      Character*17 SecNam
      Parameter (SecNam = 'Cho_SOSmp2_Energy', ThisNm = 'Energy')
      Parameter (zero = 0.0d0,  one = 1.0d0, two = 2.0d0)

      Integer ipWrk, lWrk, iiSoff(8), iaSoff(8)
      Integer nEnrVec(8)
*****************************************************************
      MulD2h(i,j)=iEor(i-1,j-1)+1
*****************************************************************

      irc = 0

      iTyp = 2
      Call iCopy(nSym,nMP2Vec,1,nEnrVec,1)

C     Initialize SOS-MP2 energy correction.
C     -------------------------------------

      EMP2 = 0.0D0

C     Some offsets
C     ------------
      nIt=nOcc(1)
      nAt=nVir(1)
      iiSoff(1)=0
      iaSoff(1)=0
      Do iSym=2,nSym
         iiSoff(iSym)=nIt
         iaSoff(iSym)=nAt
         nIt = nIt + nOcc(iSym)
         nAt = nAt + nVir(iSym)
      End Do
      MaxNVec = nIt*nAt

      Call GetMem('Ea-Ei','Allo','Real',ip_W,MaxNVec)
      Call GetMem('iD_bj','Allo','Inte',ID_bj,MaxNVec)

C     Loop over Cholesky vector symmetries.
C     -------------------------------------

      Do jSym = 1,nSym

         Nai = nT1am(jSym)
         If (Nai.gt.0 .and. nEnrVec(jSym).gt.0) Then

            nOV=0
            Do iiSym=1,nSym
               iaSym=MulD2h(iiSym,jSym)
               Do ii=1,nOcc(iiSym)
                  iiT=iiSoff(iiSym)+ii
                  iaS=nOV+nVir(iaSym)*(ii-1)
                  Do ia=1,nVir(iaSym)
                     iaT=iaSoff(iaSym)+ia
                     iaiS=iaS+ia-1
                     Work(ip_W+iaiS)=EVir(iaT)-EOcc(iiT)
                  End Do
               End Do
               nOV=nOV+nVir(iaSym)*nOcc(iiSym) ! ... = Nai
            End Do

C           Cholesky decompsition of the Orbital Energy
C           Denominators (OED)
C           -------------------------------------------
            Call CHO_GET_ORD_bj(nOV,MaxNVec,OED_Thr,Work(ip_W),
     &                          iWork(ID_bj),NKVec,Dmax)

            If (Verbose .or. NKVec.lt.1) Then
               Write(6,'(A)')
     &         '---------------------------------------'
               Write(6,'(A,I2,A)')
     &         'Orbital energy denominators CD (sym=',jSym,')'
               Write(6,'(A)')
     &         '---------------------------------------'
               Write(6,'(1X,A,I3,A,I9,A,1P,D25.16)')
     &         'Number of vectors needed: ',NKVec,
     &         '   ( nAocc x nAvir : ',nOV,' ), max residual:',
     &         Dmax
               Call xFlush(6)
            EndIf

            If (NKVec.gt.0) Then

               Call GetMem('Yai_k','Allo','Real',ip_Y,nOV*NKVec)
!              init to one the 1st col
               call dcopy_(nOV,[one],0,Work(ip_Y),1)

               Call CHO_GET_OED_cd(.true.,nOV,Work(ip_W),NKVec,
     &                             iWork(ID_bj),1,Work(ip_Y),Work(ip_Y))

               Call GetMem('GetMax','Max ','Real',ipWrk,lWrk)
               Call GetMem('GetMax','Allo','Real',ipWrk,lWrk)

C              Set up batch over Cholesky vectors.
C              -----------------------------------

               nVec = min(lWrk/(Nai+NKVec),nEnrVec(jSym))
               If (nVec .lt. 1) Then
                  Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                             'Batch setup')
               End If
               nBat = (nEnrVec(jSym)-1)/nVec + 1

               kRead = ipWrk + NKVec*nVec

C              Open Cholesky vector files.
C              ---------------------------

               Call ChoMP2_OpenF(1,iTyp,jSym)

C              Start vector batch loop.
C              ------------------------

               Do iBat = 1,nBat

                  If (iBat .eq. nBat) Then
                     NumVec = nEnrVec(jSym) - nVec*(nBat-1)
                  Else
                     NumVec = nVec
                  End If
                  jVec = nVec*(iBat-1) + 1

C                 Read vectors
C                 ------------
                  lTot = nT1am(jSym)*NumVec
                  iAdr = nT1am(jSym)*(jVec-1) + 1
                  Call ddaFile(lUnit_F(jSym,iTyp),2,
     &                         Work(kRead),lTot,iAdr)

C                 Compute   E(k,J) = sum_ai Y(ai,k) * R(ai,J)
C                 --------------------------------------------
                  Call DGEMM_('T','N',NKVec,NumVec,Nai,
     &                       one,Work(ip_Y),Nai,Work(kRead),Nai,
     &                       zero,Work(ipWrk),NKVec)

C                 Compute (unscaled) SOS-MP2 energy
C                 -----------------------------------

                  EMP2 = EMP2 + ddot_(NKVec*NumVec,Work(ipWrk),1,
     &                                            Work(ipWrk),1)

               End Do ! Cholesky vector batch

C              Close Cholesky vector files.
C              ----------------------------
               Call ChoMP2_OpenF(2,iTyp,jSym)

               Call GetMem('GetMax','Free','Real',ipWrk,lWrk)
               Call GetMem('Yai_k','Free','Real',ip_Y,nOV*NKVec)

            End If

         End If

      End Do


      Call GetMem('iD_bj','Free','Inte',ID_bj,MaxNVec)
      Call GetMem('Ea-Ei','Free','Real',ip_W,MaxNVec)

C     If requested, delete vector files.
C     ----------------------------------

      If (Delete) Then
         Do jSym = 1,nSym
            Call ChoMP2_OpenF(1,iTyp,jSym)
            Call ChoMP2_OpenF(3,iTyp,jSym)
         End Do
      End If

C     Change sign and use proper factor on energy.
C     --------------------------------------------

C-tbp, December 2012: removed factor 2
C-tbp  (wrong result for two-electron systems with factor 2)
c-tbp EMP2 = -two*EMP2
      EMP2 = -EMP2



      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine CoW(Coor,CoF,W,nAtom,T)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January '91                                              *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtom
real(kind=wp), intent(in) :: Coor(3,nAtom), W(nAtom)
real(kind=wp), intent(out) :: CoF(3), T
#include "print.fh"
integer(kind=iwp) :: iAtom, iPrint, iRout

iRout = 140
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  call RecPrt(' In CoW: Coor',' ',Coor,3,nAtom)
  call RecPrt(' In CoW: W',' ',W,nAtom,1)
end if
T = Zero
do iAtom=1,nAtom
  T = T+W(iAtom)
end do
CoF(:) = Zero
do iAtom=1,nAtom
  CoF(:) = CoF(:)+Coor(:,iAtom)*W(iAtom)
end do
if (T /= Zero) then
  CoF(:) = CoF(:)/T
else
  CoF(:) = Zero
end if
if (iPrint >= 99) then
  call RecPrt(' In CoW: CoF',' ',CoF,1,3)
  call RecPrt(' In CoW: T',' ',[T],1,1)
end if

return

end subroutine CoW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_X_Init_Par_GenBak()

use Para_Info, only: Is_Real_Par
use Cholesky, only: InfVec, InfVec_Bak, nSym, NumCho, NumCho_Bak
use stdalloc, only: mma_allocate

implicit none

NumCho_Bak(:) = 0
if (Is_Real_Par()) then
  call mma_allocate(InfVec_Bak,size(InfVec,1),size(InfVec,2),size(InfVec,3),Label='InfVec_Bak')
  InfVec_Bak(:,:,:) = InfVec(:,:,:)
  NumCho_Bak(1:nSym) = NumCho(1:nSym)
end if

end subroutine Cho_X_Init_Par_GenBak

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Yoshio Nishimoto                                 *
!***********************************************************************
!
! Dynamically weighted solvation (reaction field)
!
! Could be used for dynamically weighted MCSCF (DW-MCSCF), and this was an initial plan...
! The density matrix used for generating the reaction field is constructed by a weighted averaged
! of state-specific density matrices. The weight is determined with the electronic energy and
! distribution function. This is similar to the well-known DW-MCSCF.
!
! At present, only the Boltzmann distribution function can be used.
! Note also that the electronic gradient and Hessian of the weight function is ignored.
!
! (hidden) options in &GATEWAY RF-Input
!
! DWSOlvation
!   DWZeta in the code. This regulates the distribution function.
! FIXRfroot
!   Generate fixed weight reaction fields; it is not a dynamically weighted, of course.
!   This is the only option written in the manual among the three.
! DWTYpe
!   Specifies the distribution function (see DWSol_func). Only DWTYPE = 1 is working.
!   I think we just need to update DWSol_func and DWSol_Der (zeroth- and first-order derivatives
!   wrt the energy)

module DWSol

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Half
use Definitions, only: wp, iwp, u6

implicit none

type type_DW
  logical(kind=iwp) :: do_DW = .false.
  integer(kind=iwp) :: DWType = -99
  integer(kind=iwp) :: DWRoot = 0
  real(kind=wp) :: DWZeta = Zero
end type type_DW

!! DWSolv: dynamically weighted solvation
!! DWSCF : dynamically weighted MCSCF
type(type_DW), target :: DWSolv, DWSCF

integer(kind=iwp) :: IPCMROOT = 0, nRoots = 0

real(kind=wp), allocatable :: W_SOLV(:)

contains

!-----------------------------------------------------------------------

! dummy subroutine for initialization things
subroutine DWSol_dummy()

  return

end subroutine DWSol_dummy

!-----------------------------------------------------------------------

! should be called somewhere in RASSCF or MCLR after nRoots and
! IPCMROOT are determined
subroutine DWSol_init(IPCMROOT_,nRoots_,NonEq_)

  use rctfld_module, only: iSLPar, rSlPar
  use input_mclr, only: Weight_MCLR => Weight
  use rasscf_global, only: Weight_RASSCF => Weight
  use UnixInfo, only: ProgName

  integer(kind=iwp), intent(in) :: IPCMROOT_, nRoots_
  logical(kind=iwp), intent(in) :: NonEq_
  integer(kind=iwp) :: i, istate, jstate, mData
  real(kind=wp) :: wgt
  logical(kind=iwp) :: Found

  IPCMROOT = IPCMROOT_
  nRoots = nRoots_

  DWSolv%DWType = ISlPar(17)
  DWSolv%DWRoot = IPCMROOT
  DWSolv%DWZeta = RSlPar(53)

  if (NonEq_) DWSolv%DWZeta = Zero

  call mma_allocate(W_SOLV,nRoots,Label='W_SOLV')
  W_SOLV(:) = Zero

  call qpg_dArray('SolventWeight',Found,mData)
  if (Found .and. (mData /= 0)) then
    if (mData /= nRoots) call warningMessage(1,'The number of roots specified by FIXRFROOT/DWROOT and CIROOT may be inconsistent.')
    call Get_dArray('SolventWeight',W_SOLV,min(mData,nRoots))
    DWSolv%DWZeta = -12345.0_wp
  else
    if (DWSolv%DWZeta == Zero) then
      if (IPCMROOT > 0) then
        W_SOLV(IPCMROOT) = One
      else
        if (ProgName(1:6) == 'rasscf') W_SOLV(1:nRoots) = Weight_RASSCF(1:nRoots)
        if (ProgName(1:4) == 'mclr') W_SOLV(1:nRoots) = Weight_MCLR(1:nRoots)
      end if
    else if (DWSolv%DWZeta < Zero) then
      !! fixed averaging
      call DWSol_fixed(istate,jstate)
      do i=1,nRoots
        if ((i == istate) .or. (i == jstate)) then
          wgt = Half
        else
          wgt = Zero
        end if
        W_SOLV(i) = wgt
      end do
    else if (DWSolv%DWZeta > Zero) then
      DWSolv%do_DW = .true.
    end if
  end if

end subroutine DWSol_init

!-----------------------------------------------------------------------

! should be called somewhere in RASSCF or MCLR after nRoots and
! IPCMROOT are determined
subroutine DWSCF_init(mode,nRoots_)

  integer(kind=iwp), intent(in) :: mode, nRoots_
  integer(kind=iwp) :: idum
  real(kind=wp) :: rdum

  nRoots = nRoots_

  if (mode == 1) then
    !! call from RASSCF, nothing is done
  else if (mode == 2) then
    !! call from MCLR, read from RunFile(?)
    call Get_iScalar('DWTypeSCF',idum)
    call Get_dScalar('DWZetaSCF',rdum)
    DWSCF%DWRoot = ibits(idum,16,16)
    DWSCF%DWType = ibits(idum,0,16)
    DWSCF%DWZeta = rdum
  end if

  DWSCF%do_DW = .false.
  if (DWSCF%DWROOT /= 0) then
    write(u6,*) 'DW-MCSCF is enabled'
    DWSCF%do_DW = .true.
    if (DWSCF%DWType == -99) then
      write(u6,*) 'DWTYpe has not been specified.'
      write(u6,*) 'The default value DWTYpe = 0 will be used.'
      DWSCF%DWType = 0
    end if
    if (DWSCF%DWZeta == Zero) then
      select case (DWSCF%DWType)
        case (-1,0,1)
          DWSCF%DWZeta = One
      end select
    end if
  end if

end subroutine DWSCF_init

!-----------------------------------------------------------------------

subroutine DWSol_DWRO(LuInput,nRoots_,i_all)

  integer(kind=iwp), intent(in) :: LuInput, i_all
  integer(kind=iwp), intent(inout) :: nRoots_
  integer(kind=iwp) :: i, iError, iSum
  character(len=180) :: KWord
  integer(kind=iwp), allocatable :: IROOT(:), Temp1(:)
  real(kind=wp), allocatable :: W_local(:)
  !integer(kind=iwp), external :: nToken
  character(len=180), external :: Get_Ln

  ! Determine the roots to be used for solvation by reading RFROOT
  !
  !i_all = 0
  !call Get_I1(1,nRoots_)
  !call Get_I1(2,lRoots_) !! this is not used
  !if (nToken(KWord_) > 3) call Get_I1(3,i_all)

  call mma_allocate(W_local,nRoots_,Label='W_local')
  call mma_allocate(IROOT,nRoots_,Label='IROOT')

  W_local(1:nRoots_) = Zero
  IROOT(1:nRoots_) = 0

  if (i_all == 1) then
    do i=1,nRoots_
      iroot(i) = i
      W_local(i) = One/real(nRoots_,kind=wp)
    end do
  else
    KWord = Get_Ln(LuInput)
    read(KWord,*,iostat=iError) (IROOT(I),I=1,nRoots_)
    if (iError /= 0) call Error(iError)
    if (nRoots_ == 1) then
      W_local(1) = One
    else
      KWord = Get_Ln(LuInput)

      call mma_allocate(Temp1,nRoots_,Label='Temp1')
      read(KWord,*,iostat=iError) (Temp1(I),I=1,nRoots_)
      if (iError /= 0) call Error(iError)

      iSum = 0
      do i=1,nRoots_
        iSum = iSum+Temp1(i)
      end do
      do i=1,nRoots_
        if (Temp1(i) == 0) then
          W_local(i) = Zero
        else
          W_local(i) = real(Temp1(i),kind=wp)/real(iSum,kind=wp)
        end if
      end do
      call mma_deallocate(Temp1)
    end if
  end if

  call Put_dArray('SolventWeight',W_local,nRoots_)

  ! Set IPCMROOT
  if (i_all == 1) then
    nRoots_ = 0
  else
    nRoots_ = maxloc(W_local(1:nRoots_),1)
  end if

  call mma_deallocate(W_local)
  call mma_deallocate(IROOT)

contains

  subroutine Error(rc)

    integer(kind=iwp), intent(in) :: rc

    if (rc > 0) then
      write(u6,*) 'DWSol_DWRO: Error while reading input'
    else
      write(u6,*) 'DWSol_DWRORdInp: Premature end of input file'
    end if
    write(u6,'(A,A)') 'Last command:',KWord
    call Abend()

  end subroutine Error

end subroutine DWSol_DWRO

!-----------------------------------------------------------------------

subroutine DWSol_final()

  call mma_deallocate(W_SOLV)

end subroutine DWSol_final

!-----------------------------------------------------------------------

subroutine DWSCF_final()

  integer(kind=iwp) :: idum
  real(kind=wp) :: rdum

  if (DWSCF%do_DW) then
    !! Save some parameters for MCLR
    idum = DWSCF%DWType
    call mvbits(DWSCF%DWRoot,0,16,idum,16)
    rdum = DWSCF%DWZeta
  else
    idum = 0
    rdum = Zero
  end if

  call Put_iScalar('DWTypeSCF',idum)
  call Put_dScalar('DWZetaSCF',rdum)

end subroutine DWSCF_final

!-----------------------------------------------------------------------

subroutine DWSol_wgt(mode,ENER,weight)

  integer(kind=iwp), intent(in) :: mode
  real(kind=wp), intent(in) :: ENER(*)
  real(kind=wp), intent(out), optional :: weight(*)
  integer(kind=iwp) :: i
  real(kind=wp) :: Ealpha, Ebeta, Egamma, wgt, Wtot, xi_ab, xi_ag
  type(type_DW), pointer :: DWlocal
  real(kind=wp), allocatable :: W_local(:)

  select case (mode)
    case (1)
      !! DW-MCSCF
      DWlocal => DWSCF
    case (2)
      !! DW solvation
      DWlocal => DWSolv
    !case (3)
    !  !! DW CASPT2?
    case default
      nullify(DWlocal)
  end select

  if (DWlocal%DWZeta <= Zero) return

  !! dynamical weighting
  call mma_allocate(W_local,nRoots,Label='W_local')

  !! Normalization
  Wtot = Zero
  Ealpha = ENER(DWlocal%DWRoot)
  do i=1,nRoots
    Egamma = ENER(i)
    xi_ag = Ealpha-Egamma
    wgt = DWSol_func(xi_ag,DWlocal)
    Wtot = Wtot+wgt
  end do

  W_local = Zero
  do i=1,nRoots
    Ebeta = ENER(i)
    xi_ab = Ealpha-Ebeta
    wgt = DWSol_func(xi_ab,DWlocal)
    W_local(i) = wgt/Wtot
  end do

  select case (mode)
    case (1)
      weight(1:nRoots) = W_local(1:nRoots)
    case (2)
      W_SOLV(1:nRoots) = W_local(1:nRoots)
  end select

  call mma_deallocate(W_local)

end subroutine DWSol_wgt

!-----------------------------------------------------------------------

function DWSol_func(xx,DWlocal)

  real(kind=wp) :: DWSol_func
  real(kind=wp), intent(in) :: xx
  type(type_DW), intent(in) :: DWlocal

  DWSol_func = Zero
  select case (DWlocal%DWType)
    case (-1)
      !! the oldest (?) DW-CASSCF (J. Chem. Phys. 120, 7281 (2004)
      DWSol_func = cosh(xx/DWlocal%DWZeta)**2
    case (0)
      !! new (?) DW-CASSCF: J. Chem. Phys. 141, 171102 (2014)
      if (xx <= Zero) then
        DWSol_func = One/nRoots
      else if (xx <= DWlocal%DWZeta) then
        DWSol_func = One-Three*(xx/DWlocal%DWZeta)**2+Two*(xx/DWlocal%DWZeta)**3
      else
        DWSol_func = Zero
      end if
    case (1)
      !! Boltzmann factor (XDW-CASPT2 with DWType = 1)
      DWSol_func = exp(-DWlocal%DWZeta*xx**2)
    case default
      write(u6,*) 'Unrecognized DWType in DWSol...'
      call abend()
  end select

  return

end function DWSol_func

!-----------------------------------------------------------------------

subroutine DWSol_fixed(istate,jstate)

  integer(kind=iwp), intent(out) :: istate, jstate
  integer(kind=iwp) :: DWZetaInt

  DWZetaInt = int(DWSolv%DWZeta,kind=iwp)
  if (real(DWZetaInt,kind=wp) /= DWSolv%DWZeta) DWZetaInt = 0
  select case (DWZetaInt)
    case (-2)
      istate = 1
      jstate = 2
    case (-6)
      istate = 2
      jstate = 3
    case (-12)
      istate = 3
      jstate = 4
    case (-20)
      istate = 4
      jstate = 5
    case (-30)
      istate = 5
      jstate = 6
    case (-42)
      istate = 6
      jstate = 7
    case (-56)
      istate = 7
      jstate = 8
    case (-72)
      istate = 8
      jstate = 9
    case (-90)
      istate = 9
      jstate = 10
    case default
      write(u6,*) 'Unrecognized negative DWZeta ...'
      istate = 0
      jstate = 0
  end select

end subroutine DWSol_fixed

!-----------------------------------------------------------------------

subroutine DWSol_der(mode,DEROMG,DERHII,ENER,weight)

  integer(kind=iwp), intent(in) :: mode
  real(kind=wp), intent(in) :: DEROMG(:), ENER(:)
  !! partial derivative (pseudo-density, more precisely) of H_{II}
  real(kind=wp), intent(inout) :: DERHII(:)
  real(kind=wp), intent(in), optional :: weight(1:nRoots)
  integer(kind=iwp) :: i, j, k
  real(kind=wp) :: Ealpha, Ebeta, Egamma, Scal
  type(type_DW), pointer :: DWlocal
  real(kind=wp), allocatable :: W_local(:)

  select case (mode)
    case (1)
      !! DW-MCSCF
      DWlocal => DWSCF
    case (2)
      !! DW solvation
      DWlocal => DWSolv
    case default
      nullify(DWlocal)
  end select

  DERHII(1:nRoots) = Zero
  if (DWlocal%DWZeta <= Zero) return

  call mma_allocate(W_local,nRoots,Label='W_local')

  select case (mode)
    case (1)
      !! DW-MCSCF
      W_local(1:nRoots) = weight(1:nRoots)
    case (2)
      !! DW solvation
      W_local(1:nRoots) = W_SOLV(1:nRoots)
  end select

  i = DWlocal%DWRoot
  Ealpha = ENER(i)

  if (DWlocal%DWType == 1) then
    do j=1,nRoots
      Ebeta = ENER(j)
      Scal = -Two*DWlocal%DWZeta*W_local(j)*(Ealpha-Ebeta)*DEROMG(j)
      DERHII(i) = DERHII(i)-Scal
      DERHII(j) = DERHII(j)+Scal

      do k=1,nRoots
        Egamma = ENER(k)
        Scal = Two*DWlocal%DWZeta*W_local(j)*W_local(k)*(Ealpha-Egamma)*DEROMG(j)
        DERHII(i) = DERHII(i)-Scal
        DERHII(k) = DERHII(k)+Scal
      end do
    end do
  end if

  call mma_deallocate(W_local)

end subroutine DWSol_Der

end module DWSol

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SolveA(AlfMat,AlfMatI,dLambda,dMullig,lMax
     &                 ,ARaw,BRaw,dA,iPrint,AboveMul,ddUpper,ddLower)
      Implicit Real*8 (a-h,o-z)

      Dimension AlfMat(4),AlfMatI(4),ARaw(2,2),BRaw(2),Beta(2),dA(2)
      Dimension dtA(2),dMullig((lMax*(lMax**2+6*lMax+11)+6)/6)

      Logical AboveMul(2)
      Logical Yeps(2)

*
*-- Which elements can be non-zero? Too low magnitude of multipoles
*   and they are screened.
*
      nDim=0
      Do iMull=1,2
        If(AboveMul(iMull)) then
          Yeps(iMull)=.true.
          nDim=nDim+1
          Beta(nDim)=BRaw(iMull)
        Else
          Yeps(iMull)=.false.
        Endif
      Enddo
      If(iPrint.ge.10) then
        Call RecPrt('Beta',' ',Beta,nDim,1)
      Endif

*
*-- Shuffle around, and create a matrix for exponents with non-zero
*   factors.
*
      kaunt=0
      Do i=1,2
        Do j=1,2
          If(Yeps(i).and.Yeps(j)) then
            kaunt=kaunt+1
            If(i.eq.j) then
              AlfMat(kaunt)=ARaw(max(i,j),min(i,j))*(1.0d0+dLambda)
            Else
              AlfMat(kaunt)=ARaw(max(i,j),min(i,j))
            Endif
          Endif
        Enddo
      Enddo

*
*-- Invert and solve.
*
      Call MInv(AlfMat,AlfMatI,Ising,Det,nDim)
      call dcopy_(nDim,[0.0d0],0,dtA,1)
      Call dGeMV_('N',nDim,nDim,1.0d0,AlfMatI,nDim,Beta,1,0.0d0,dtA,1)

*
*-- Optional printing.
*
      If(iPrint.ge.10) then
        Call RecPrt('Alfa',' ',AlfMat,nDim,nDim)
        Call RecPrt('InverseA',' ',AlfMatI,nDim,nDim)
        Call RecPrt('deltatA',' ',dtA,nDim,1)
      Endif

*
*-- Damp large steps since such steps can take the optimization
*   too far away and put it in a region with very small derivatives,
*   and there things turns into baloney.
*
      If(dtA(1).lt.ddLower) dtA(1)=ddLower
      If(dtA(2).lt.ddLower) dtA(2)=ddLower
      If(dtA(1).gt.ddUpper) dtA(1)=ddUpper
      If(dtA(2).gt.ddUpper) dtA(2)=ddUpper

*
*-- Extend to full dimension.
*
      kaunt=0
      Do i=1,2
        If(Yeps(i)) then
          kaunt=kaunt+1
          dA(i)=dtA(kaunt)
        Else
          dA(i)=0.0d0
        Endif
      Enddo

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(dMullig)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function CHO_ISAO(IAO)
!
! Purpose: return symmetry of AO number IAO (in global list).

use Cholesky, only: IBAS, nSym
#ifdef _DEBUGPRINT_
use Cholesky, only: LuPri, nBasT
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: CHO_ISAO
integer(kind=iwp), intent(in) :: IAO
integer(kind=iwp), external :: CHO_IRANGE
#ifdef _DEBUGPRINT_
character(len=*), parameter :: SECNAM = 'CHO_ISAO'

if ((IAO > NBAST) .or. (IAO < 1)) then
  write(LUPRI,'(//,1X,A,A,I10)') SECNAM,': AO index out of bounds: ',IAO
  write(LUPRI,'(A,I10,A,/)') 'Maximum possible: NBAST = ',NBAST,'(from common block)'
  if (NBAST < 1) then
    call CHO_QUIT('Initialization error detected in '//SECNAM,102)
  else
    call CHO_QUIT('Internal error detected in '//SECNAM,103)
  end if
end if
#endif

CHO_ISAO = CHO_IRANGE(IAO,IBAS,NSYM,.false.)

end function CHO_ISAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3wrhead
c
c     this routine write head of ther output file
c     parameters transported through cmm common
c
#include "t31.fh"
c
c     help variables
c
       integer nhelp,nhelp1,nhelp2
c
c1    write title
c
      if (noop.eq.1) then
      write(6,'(6X,A)') ' No operation is required'
      write(6,'(6X,A)') ' Happy Landing'
      Call Finish(0)
      end if
c
CGG       do 10 nhelp=1,ntit
CGG       write(6,9) title(nhelp)
CGG 10     continue
CGG 9      format (A72)
CGG       write(6,*)
c
c2    write occupations and matrix multiplication tablaux
c
       write(6,11) (norb(nhelp),nhelp=1,nsym)
 11     format (' NORB ',8(i3,2x))
       write(6,12) (noa(nhelp),nhelp=1,nsym)
 12     format (' NOA  ',8(i3,2x))
       write(6,13) (nob(nhelp),nhelp=1,nsym)
 13     format (' NOB  ',8(i3,2x))
       write(6,14) (nva(nhelp),nhelp=1,nsym)
 14     format (' NVA  ',8(i3,2x))
       write(6,15) (nvb(nhelp),nhelp=1,nsym)
 15     format (' NVB  ',8(i3,2x))
c
       if (fullprint.gt.1) then
       write(6,*)
       write(6,*)
       write(6,17)
 17     format (' MATRIX MULTIPLICATION TABLE')
       write(6,*)
       write(6,18) (nhelp,nhelp=1,nsym)
 18     format (' IRREP #',9x,8(i3,2x))
       write(6,*)
       do 19 nhelp1=1,nsym
       write(6,20) nhelp1,(mmul(nhelp1,nhelp),nhelp=1,nsym)
 19     continue
 20     format (' IRREP #',i3,6x,8(i3,2x))
       write(6,*)
       end if
c
       write(6,*)
       write(6,16) nsym
 16     format (' NUMBER OF IRREPS             :',i3)
       write(6,161) ispin
 161    format (' MULTIPLICITY                 :',i3)
       write(6,162) lsym
 162    format (' OVERALL SYMMETRY STATE       :',i3)
c
c4    write type of triples
c
       if (typt3.eq.0) then
       write(6,31)
 31     format (' METHOD                       : CCSD')
       else if (typt3.eq.1) then
       write(6,32)
 32     format (' METHOD                       : CCSD+T(CCSD)')
       else if (typt3.eq.2) then
       write(6,33)
 33     format (' METHOD                       : CCSD+T(CCSD)',
     &  '+<T3(1)WT1> = CCSD(T)' )
       else if (typt3.eq.3) then
       write(6,34)
 34     format (' METHOD                       : CCSD+T(CCSD)',
     &  '+<T3(1)WT1>+<T3(1)UT2> = CCSD(T)' )
       end if
c
c5    write type of fok division
c
       if (typden.eq.0) then
       write(6,41)
       else if (typden.eq.1) then
       write(6,42)
       else
       write(6,43)
       end if
 41     format (' TYPE OF DENOMINATOR          : DIAGONAL')
 43     format (' TYPE OF DENOMINATOR          : ORBITAL ENERGIES')
 42     format (' TYPE OF DENOMINATOR          : (FAA+FBB)/2')
c
c
c6    write orbital energies per symmetry
c
       if (fullprint.gt.0) then
       write(6,*)
       write(6,51)
 51     format (' LIST OF ORBITAL ENERGIES')
       write(6,*)
c
       nhelp2=1
       do nhelp=1,nsym
       write(6,54) nhelp
 54     format (' IRREDUCIBLE REPRESENTATION NO:',i2)
       do nhelp1=1,norb(nhelp)
       write(6,55) nhelp1,eps(nhelp2)
 55     format (' ORBITAL NO:',i3,5x,f16.10)
       nhelp2=nhelp2+1
       end do
       end do
       write(6,*)
       end if
c
c8    spin adaptation
c
       if (keysa.eq.0) then
       write(6,81)
       else if (keysa.eq.1) then
       write(6,82)
       else if (keysa.eq.2) then
       write(6,83)
       else if (keysa.eq.3) then
       write(6,84)
       else if (keysa.eq.4) then
       write(6,85)
       end if
 81     format (' SPIN ADAPTATION             : NONE ')
 82     format (' SPIN ADAPTATION             : T2 DDVV ')
 83     format (' SPIN ADAPTATION             : T2 DDVV + T1 DV ')
 84     format (' SPIN ADAPTATION             : T1 AND T2 FULL ')
 85     format (' SPIN ADAPTATION             : T2 FULL WITHOUT SDVS')
c
c9    type file whre CCSD results are
       write(6,91) filerst
 91     format (' CCSD RESULTS LOAD FROM FILE : ',a6)
c
c10   write matrix multiplication performance
c
       if (mchntyp.eq.1) then
       write(6,101)
       else if (mchntyp.eq.2) then
       write(6,102) slim
       end if
 101    format (' PREFERENCE MATRIX MULT.     : NORMAL')
 102    format (' PREFERENCE MATRIX MULT.     : TRANSP ; LIMIT =',d12.5)
c
c11   write denominator shifts
       write(6,111) shifto
       write(6,112) shiftv
 111    format (' DENOMINATOR SHIFT FOR OCC.  : ',d12.5)
 112    format (' DENOMINATOR SHIFT FOR VIRT. : ',d12.5)
c
c12   write workspace
c
c      if (maxspace.eq.0) then
c      write(6,121)
c      else
c      write(6,122) maxspace
c      end if
c121    format (' MAXIMAL ALLOWED WORK SPACE  : Unlimited')
c122    format (' MAXIMAL ALLOWED WORK SPACE  : ',i10)
c
c13   level of printing
c
       if (fullprint.eq.0) then
       write(6,131)
 131    format (' LEVEL OF OUTPUT PRINTING    : MINIMAL')
       else if (fullprint.eq.1) then
       write(6,132)
 132    format (' LEVEL OF OUTPUT PRINTING    : MEDIUM')
       else
       write(6,133)
 133    format (' LEVEL OF OUTPUT PRINTING    : MAXIMAL')
       end if
c14   I/O handling
c
       if (iokey.eq.1) then
       write(6,141)
 141    format (' INPUT/OUTPUT HANDLING       : Standard SQ ')
       else
       write(6,142)
 142    format (' INPUT/OUTPUT HANDLING       : Molcas4  DA ')
       end if
c
       if (mhkey.eq.1) then
       write(6,151)
 151    format (' MATRIX HANDLING             : ESSL        ')
       else
       write(6,152)
 152    format (' MATRIX HANDLING             : Fortran code')
       end if
c
c20   Print parameters of IJ cycle segmentation
c
       if (ijsegkey.eq.0) then
       write(6,201)
 201    format (' IJ CYCLE SEGMENTED          : NO          ')
       else
       write(6,202)
       write(6,203) symimin
       write(6,204) imin
       write(6,205) symjmin
       write(6,206) jmin
       write(6,207) symimax
       write(6,208) imax
       write(6,209) symjmax
       write(6,210) jmax
       write(6,211)
 202    format (' IJ CYCLE SEGMENTED          : YES         ')
 203    format (' SYMI minimal                : ',i4)
 204    format ('    I minimal                : ',i4)
 205    format (' SYMJ minimal                : ',i4)
 206    format ('    J minimal                : ',i4)
 207    format (' SYMI maximal                : ',i4)
 208    format ('    I maximal                : ',i4)
 209    format (' SYMJ maximal                : ',i4)
 210    format ('    J maximal                : ',i4)
 211    format (' Be very careful in using IJSEgmentation technique')
       end if
c
c*    can be added
c
       write(6,*)
       write(6,*)
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRPMAT(XIN,NROW,NCOL,XOUT)
C
C XOUT(I,J) = XIN(J,I)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XIN(NROW,NCOL),XOUT(NCOL,NROW)
C
      DO 200 IROW =1, NROW
        DO 100 ICOL = 1, NCOL
          XOUT(ICOL,IROW) = XIN(IROW,ICOL)
  100   CONTINUE
  200 CONTINUE
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_ChkDia_A4(Diag,Dmax,iSym,nNeg,nNegT,nConv,xM,yM,zM)
C
C     Purpose: check for negative diagonals.
C              Dmax is the max. diagonal (global), used for screening.
C              On exit,
C              nNeg = #negative zeroed diagonals.
C              nNegT = #negative diagonals
C              nConv = #diagonal elements < ThrCom
C              xM = max. element in Diag
C              yM = min. element in Diag
C              zM = max. abs. element in Diag
C
      use ChoSwp, only: IndRed
      Implicit None
      Real*8  Diag(*), Dmax
      Integer iSym, nNeg, nNegT, nConv
      Real*8  xM, yM, zM
#include "cholesky.fh"

      Character*13 SecNam
      Parameter (SecNam = 'Cho_ChkDia_A4')

      Real*8  Tst
      Integer i, j, j1, j2

      nNeg = 0
      nNegT = 0
      nConv = 0
      If (nnBstR(iSym,2) .gt. 0) Then
         xM = -9.9d9
         yM = 9.9d9
      Else
         xM = 0.0d0
         yM = 0.0d0
      End If

      j1 = iiBstR(iSym,2) + 1
      j2 = j1 + nnBstR(iSym,2) - 1
      Do j = j1,j2
         i = IndRed(j,2) ! addr in 1st reduced set
         xM = max(xM,Diag(i))
         yM = min(yM,Diag(i))
         If (Diag(i) .lt. 0.0d0) Then
            nNegT = nNegT + 1
            If (Diag(i) .lt. ThrNeg) Then
               nNeg = nNeg + 1
               If (Diag(i) .lt. TooNeg) Then
                  Write(Lupri,'(A,A,I12,1X,1P,D16.8)')
     &            SecNam,': diagonal too negative: ',i,Diag(i)
                  Write(Lupri,'(A,A)')
     &            SecNam,': shutting down Cholesky decomposition!'
                  Call Cho_Quit('Diagonal too negative in '//SecNam,104)
               End If
               If (Diag(i) .lt. WarNeg) Then
                  Write(Lupri,'(A,A,I12,1X,1P,D16.8,A)')
     &            SecNam,': Negative diagonal: ',i,Diag(i),
     &            ' (zeroed)'
               End If
               Diag(i) = 0.0d0
            End If
         End If
      End Do

      zM = max(abs(xM),abs(yM))

      Do j = j1,j2
         i = IndRed(j,2)
         Tst = sqrt(abs(Diag(i))*Dmax)*Damp(2)
         If (Tst .le. ThrCom) Then
            nConv = nConv + 1
            If (ScDiag) Diag(i) = 0.0d0
         End If
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               1995, Martin Schuetz                                   *
!***********************************************************************

subroutine RdMBPT()
!***********************************************************************
!                                                                      *
!     Read the MBPTOUT file genereated by the SCF program              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1993                                 *
!     modified by:                                                     *
!     M.G. Schuetz                                                     *
!     University of Lund, Sweden, 1995                                 *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use MBPT2_Global, only: CMO, EOrb, nBas, nDsto, nnB
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, iStart, iStart_t, iSym, lthCMO, lthEOr
logical(kind=iwp) :: Found
character(len=24) :: Label
real(kind=wp), allocatable :: CMO_t(:), EOrb_t(:)
logical(kind=iwp), parameter :: Debug = .false.
#include "corbinf.fh"

! Read nSym, nBas, nOrb, nOcc, nFro, CMO and orbital energies from RUNFILE

call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
call Get_iArray('nOrb',nOrb,nSym)
call Get_iArray('nIsh',nOcc,nSym)
call Get_iArray('nFro',nFro,nSym)
if (Debug) then
  write(u6,'(A,8I5)') 'nSym:',nSym
  write(u6,'(A,8I5)') 'nBas:',(nBas(i),i=1,nSym)
  write(u6,'(A,8I5)') 'nOrb:',(nOrb(i),i=1,nSym)
  write(u6,'(A,8I5)') 'nOcc:',(nOcc(i),i=1,nSym)
  write(u6,'(A,8I5)') 'nFro:',(nFro(i),i=1,nSym)
end if
lthCMO = 0
do iSym=1,nSym
  if (nFro(iSym) /= 0) then
    write(u6,*) 'Some orbitals where frozen in the SCF!'
    call Abend()
  end if
  nDel(iSym) = nBas(iSym)-nOrb(iSym)
  nExt(iSym) = nOrb(iSym)-nOcc(iSym)
  nDsto(iSym) = nDel(iSym)
  lthCMO = lthCMO+nBas(iSym)*nOrb(iSym)
end do

call mma_allocate(CMO_t,lthCMO,Label='CMO_t')
call Get_CMO_(CMO_t,lthCMO)
call mma_allocate(CMO,lthCMO,label='CMO')

! set MO coefficients of the deleted orbitals to zero
! Observe that these are not included at all in the basis
iStart = 1
iStart_t = 1
do iSym=1,nSym
  call dcopy_(nOrb(iSym)*nBas(iSym),CMO_t(iStart_t),1,CMO(iStart),1)
  iStart = iStart+nOrb(iSym)*nBas(iSym)
  iStart_t = iStart_t+nOrb(iSym)*nBas(iSym)

  call dcopy_((nBas(iSym)-nOrb(iSym))*nBas(iSym),[Zero],0,CMO(iStart),1)
  iStart = iStart+(nBas(iSym)-nOrb(iSym))*nBas(iSym)
end do
call mma_deallocate(CMO_t)

Label = 'OrbE'
call qpg_dArray(Label,Found,lthEOr)
if ((.not. Found) .or. (lthEOr == 0)) then
  Label = 'Guessorb energies'
  call qpg_dArray(Label,Found,lthEOr)
  if ((.not. Found) .or. (lthEOr == 0)) then
    call SysAbendMsg('RdMBPT','Did not find:',trim(Label))
  end if
end if
call mma_allocate(EOrb_t,lthEOr,label='OrbE')
call Get_dArray(Label,EOrb_t,lthEOr)
nnB = lthEOr
call mma_allocate(EOrb,lthEOr,label='EOrb')

! set energies of the deleted orbitals to zero

iStart = 1
iStart_t = 1
do iSym=1,nSym
  call dcopy_(nOrb(iSym),EOrb_t(iStart_t),1,EOrb(iStart),1)
  iStart = iStart+nOrb(iSym)
  iStart_t = iStart_t+nOrb(iSym)

  call dcopy_(nBas(iSym)-nOrb(iSym),[Zero],0,EOrb(iStart),1)
  iStart = iStart+nBas(iSym)-nOrb(iSym)
end do
call mma_deallocate(EOrb_t)

return

end subroutine RdMBPT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Francesco Aquilante                              *
************************************************************************
      SubRoutine Cho_SOSmp2_Drv(irc,EMP2,CMO,EOcc,EVir)
C
C     Francesco Aquilante, May 2007.
C
C     Purpose: driver for computing the Scaled Opposite-Spin (SOS)
C              MP2 energy correction EMP2
C              using Cholesky (or RI) representation for the
C              two-electron integrals.
C              Input must have been processed and MO coefficients
C              and orbital energies must be passed as arguments.
C
C     Notes:
C
C       - all MO Cholesky vector files generated here are deleted before
C         exit, except for error terminations (i.e. no cleanup actions
C         are taken!)
C
#include "implicit.fh"
      Dimension CMO(*), EOcc(*), EVir(*)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"
#include "WrkSpc.fh"

      Character*3  ThisNm
      Character*14 SecNam
      Parameter (SecNam = 'Cho_SOSmp2_Drv', ThisNm = 'Drv')

      Parameter (Chk_Mem_ChoMP2 = 0.123456789D0, Tol = 1.0D-15)
      Parameter (iFmt = 0)

      Logical Delete, Delete_def
      Parameter (Delete_def = .true.)

#if defined (_DEBUGPRINT_)
      Verbose = .true.
#endif
      If (Verbose) Then
         Call CWTime(CPUTot1,WallTot1)
      End If

C     Initializations.
C     ----------------

      irc = 0

      EMP2 = 0.0d0

      If (Verbose) Then
         Call CWTime(CPUIni1,WallIni1)
      End If

      l_Dum = 1
      Call GetMem('Dummy','Allo','Real',ip_Dum,l_Dum)
      Work(ip_Dum) = Chk_Mem_ChoMP2

      FracMem = 0.0d0 ! no buffer allocated
      Call Cho_X_Init(irc,FracMem)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_X_Init returned ',irc
         Call ChoMP2_Quit(SecNam,'Cholesky initialization error',' ')
      End If

      Call Cho_SOSmp2_Setup(irc)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_SOSmp2_Setup returned ',irc
         Go To 1  ! exit
      End If

      If (Verbose) Then
         Call Cho_SOSmp2_Setup_Prt(irc)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': Cho_SOSmp2_Setup_Prt returned ',irc
            Go To 1  ! exit
         End If
         Call CWTime(CPUIni2,WallIni2)
         Call Cho_PrtTim('Cholesky SOS-MP2 initialization',CPUIni2,
     &                   CPUIni1,WallIni2,WallIni1,iFmt)
      End If

C     Transform Cholesky vectors directly from reduced set to MO
C     representation. Result vectors are stored on disk.
C     Compute also the (ai|ai)^2 diagonal here.
C     ----------------------------------------------------------

      If (Verbose) Then
         Call CWTime(CPUTra1,WallTra1)
      End If
      lDiag = nT1am(1)
      Do iSym = 2,nSym
         lDiag = lDiag + nT1am(iSym)
      End Do
      Call GetMem('Diag','Allo','Real',ipDiag,lDiag)

      Call ChoMP2_TraDrv(irc,CMO,Work(ipDiag),.true.)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': ChoMP2_TraDrv returned ',irc
         Go To 1  ! exit
      End If
C
C     Squaring each diagonal element
C     ------------------------------
      Do ia=0,lDiag-1
         Work(ipDiag+ia)=Work(ipDiag+ia)**2
      End Do
      If (set_cd_thr) ThrMP2=ddot_(lDiag,[1.0d0],0,
     &                                  Work(ipDiag),1)/(5.0d0*lDiag)

      If (Verbose) Then
         Call CWTime(CPUTra2,WallTra2)
         Call Cho_PrtTim('Cholesky MP2 transformation',CPUTra2,CPUTra1,
     &                   WallTra2,WallTra1,iFmt)
      End If

C     Finalize Cholesky info (to release memory).
C     Retain essential info: LuPri, nSym, and NumCho(*).
C     --------------------------------------------------

      nSym_Sav = nSym
      Call iCopy(nSym,NumCho,1,nMP2Vec,1)

      Call Cho_X_Final(irc)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_X_Final returned ',irc
         Go To 1 ! exit
      End If

      LuPri = 6
      nSym  = nSym_Sav
      Call iCopy(nSym,nMP2Vec,1,NumCho,1)

C     Decompose M(ai,bj) = (ai|bj)^2 .
C     Set number of vectors to be used in energy calculation.
C     -------------------------------------------------------

      If (Verbose) Then
         Call CWTime(CPUDec1,WallDec1)
      End If
      Delete = Delete_def ! delete transf. vector files after dec.
      Call Cho_SOSmp2_DecDrv(irc,Delete,Work(ipDiag))
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_SOSmp2_DecDrv returned ',irc
         Call ChoMP2_Quit(SecNam,'SOS-MP2 decomposition failed!',' ')
      End If
      If (Verbose) Then
         Call CWTime(CPUDec2,WallDec2)
         Call Cho_PrtTim('Cholesky SOS-MP2 decomposition',
     &                   CPUDec2,CPUDec1,
     &                   WallDec2,WallDec1,iFmt)
      End If
      Call GetMem('Diag','Free','Real',ipDiag,lDiag)

C     Compute SOS-MP2 energy correction.
C     ----------------------------------

      If (Verbose) Then
         Call CWTime(CPUEnr1,WallEnr1)
      End If
      Delete = Delete_def
      Call Cho_SOSmp2_Energy(irc,EMP2,EOcc,EVir,Delete)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_SOSmp2_Energy returned ',irc
         Go To 1 ! exit
      End If
      If (Verbose) Then
         Call CWTime(CPUEnr2,WallEnr2)
         Call Cho_PrtTim('Cholesky SOS-MP2 energy',
     &                   CPUEnr2,CPUEnr1,
     &                   WallEnr2,WallEnr1,iFmt)
      End If

C     Exit.
C     -----

    1 Diff = abs(Work(ip_Dum)-Chk_Mem_ChoMP2)
      If (Diff .gt. Tol) Then
         Write(6,*) SecNam,': Memory Boundary Error!'
         If (irc .eq. 0) irc = -9999
      End If
      If (Verbose) Then
         Call CWTime(CPUTot2,WallTot2)
         Call Cho_PrtTim('Cholesky SOS-MP2',CPUTot2,CPUTot1,
     &                   WallTot2,WallTot1,iFmt)
      End If
      Call GetMem('Flush','Flush','Real',ip_Dum,l_Dum)
      Call GetMem('Dummy','Free','Real',ip_Dum,l_Dum)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetAt_Localisation(X,nBas,m,XAt,nAtoms,iOpt,nBas_per_Atom,nBas_Start,Norm)

use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nBas, m, nAtoms, iOpt, nBas_per_Atom(nAtoms), nBas_Start(nAtoms)
real(kind=wp), intent(in) :: X(nBas,m)
real(kind=wp), intent(_OUT_) :: XAt(nAtoms,*)
character(len=3), intent(in) :: Norm  ! 'MAX' or 'FRO'
integer(kind=iwp) :: i, i1, i2, iAt, j, j1, j2, jAt
character(len=3) :: myNorm

if ((nBas < 1) .or. (nAtoms < 1)) return

myNorm = Norm
call UpCase(myNorm)

if (iOpt == 1) then
  XAt(:,1:m) = Zero
  if (myNorm == 'MAX') then
    do j=1,m
      do iAt=1,nAtoms
        i1 = nBas_Start(iAt)
        i2 = i1+nBas_per_Atom(iAt)-1
        do i=i1,i2
          XAt(iAt,j) = max(abs(X(i,j)),XAt(iAt,j))
        end do
      end do
    end do
  else if (myNorm == 'FRO') then
    do j=1,m
      do iAt=1,nAtoms
        i1 = nBas_Start(iAt)
        i2 = i1+nBas_per_Atom(iAt)-1
        do i=i1,i2
          XAt(iAt,j) = XAt(iAt,j)+X(i,j)**2
        end do
        XAt(iAt,j) = sqrt(XAt(iAt,j))
      end do
    end do
  end if
else
  if (m /= nBas) then
    call SysAbendMsg('GetAt_Localisation','Fatal error','m != nBas')
  end if
  XAt(:,1:nAtoms) = Zero
  if (myNorm == 'MAX') then
    do jAt=1,nAtoms
      j1 = nBas_Start(jAt)
      j2 = j1+nBas_per_Atom(jAt)-1
      do j=j1,j2
        do iAt=1,nAtoms
          i1 = nBas_Start(iAt)
          i2 = i1+nBas_per_Atom(iAt)-1
          do i=i1,i2
            XAt(iAt,jAt) = max(abs(X(i,j)),XAt(iAt,jAt))
          end do
        end do
      end do
    end do
  else if (myNorm == 'FRO') then
    do jAt=1,nAtoms
      j1 = nBas_Start(jAt)
      j2 = j1+nBas_per_Atom(jAt)-1
      do j=j1,j2
        do iAt=1,nAtoms
          i1 = nBas_Start(iAt)
          i2 = i1+nBas_per_Atom(iAt)-1
          do i=i1,i2
            XAt(iAt,jAt) = XAt(iAt,jAt)+X(i,j)**2
          end do
        end do
      end do
      XAt(:,jAt) = sqrt(XAt(:,jAt))
    end do
  end if
end if

end subroutine GetAt_Localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2002, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GETCNF_LUCIA(KCNF,KTYP,K,ICONF,IREFSM,NEL)
*
* Obtain configuration number K .
* Occupation in KCNF in form of old RASSCF ( doubly occ orbs first)
* Type in KTYP
*
* Adapted for LUCIA Jeppe Olsen, summer of 02
*
      IMPLICIT REAL*8 (A-H,O-Z)

#include "spinfo.fh"
#include "ciinfo.fh"
*
      DIMENSION KCNF(*),ICONF(*)
*. Configuration list is assumed to be in the form used
*. in LUCIA, i.e. doubly occupied orbitals are flagged by
*. a minus
*
      ICNFB1 = 1
      ICNFB2 = 1
      KTYP   = 0
      DO 100 JTYP = 1, NTYP
        JOP = JTYP - 1 + MINOP
        JCL = (NEL-JOP)/2
        JOCC = JOP + JCL
*
        NJCNF = NCNFTP(JTYP,IREFSM)
        IF(K.GE.ICNFB1.AND.K.LE.ICNFB1+NJCNF-1) THEN
          KREL = K - ICNFB1 + 1
          KADD = (KREL-1)*JOCC
          KTYP = JTYP
*. Outdated ....
C         CALL ICOPY(JOCC,ICONF(ICNFB2+KADD),1,KCNF,1)
*
*. Obtain configuration in standard RASSCF form
          IIBOP = 1
          IIBCL = 1
          DO KOCC = 1, JOCC
            KORB = ICONF(ICNFB2+KADD-1+KOCC)
            IF(KORB.LT.0) THEN
*. Doubly occupied orbitals
              KCNF(IIBCL) = ABS(KORB)
              IIBCL = IIBCL + 1
            ELSE
*. Singly occupied orbital
              KCNF(JCL+IIBOP) = KORB
              IIBOP = IIBOP + 1
            END IF
          END DO
        END IF
*
        ICNFB1 = ICNFB1 + NJCNF
        ICNFB2 = ICNFB2 + NJCNF*JOCC
100   CONTINUE
*
      NTEST = 0
      IF(NTEST .NE. 0 ) THEN
        WRITE(6,*) ' Output from GETCNF '
        WRITE(6,*) ' ================== '
        WRITE(6,*) ' Input configuration number : ', K
        WRITE(6,*) ' Corresponding type : ', KTYP
        WRITE(6,*) ' Occupation : '
        NOCC = (NEL+KTYP-1+MINOP)/2
        CALL IWRTMA(KCNF,1,NOCC,1,NOCC)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine XDR_dmatinv(a,n)
! Invert a real square matrix

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: a(n*n)
integer(kind=iwp) :: info1, info2
#ifdef _MOLCAS_MPP_
logical(kind=iwp) :: isCloneQ
#endif
integer(kind=iwp), allocatable :: piv(:)
real(kind=wp), allocatable :: Tmp(:)

#ifdef _MOLCAS_MPP_
call check_parallel_data(a,n*n,isCloneQ,'C')
#endif
call mma_allocate(piv,n,label='piv')
call mma_allocate(Tmp,n,label='tmp')
call dgetrf_(n,n,a(1),n,piv,info1)
call dgetri_(n,a(1),n,piv,Tmp,n,info2)
call mma_deallocate(piv)
call mma_deallocate(Tmp)
#ifdef _MOLCAS_MPP_
if (isCloneQ) then
  call check_parallel_data(a,n*n,isCloneQ,'S')
end if
#endif

return

end subroutine XDR_dmatinv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine HssPrt(Hess,nHess)
      use Symmetry_Info, only: nIrrep, lIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "disp.fh"
#include "disp2.fh"
#include "real.fh"
      Integer  nDisp(0:7)
      Character Label*39
      Real*8     Hess(nHess)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      Ind(idisp,jdisp)=idisp*(idisp-1)/2+jdisp
*                                                                      *
************************************************************************
*                                                                      *
 100  Format (A,A)
      iDisp=0
      Do iIrrep=0,nIrrep-1
           nDisp(iIrrep)=iDisp
           iDisp=iDisp+lDisp(iIrrep)
      End Do
*
      If (nirrep.eq.1) Then
         Write(Label,100) 'Hessian in Irrep ',lIrrep(0)
         Call TriPrt(Label,' ',Hess,ldisp(0))
      Else
         Call GetMem('Temp','ALLO','REAL',ipT,nhess)
         Do iIrrep=0,nIrrep-1
            Write(Label,100) 'Hessian in Irrep ',lIrrep(iIrrep)
            Do i=1,lDisp(iirrep)
               Do j=1,i
                  ii=ind(i,j)-1
                  jj=ind(ndisp(iirrep)+i,ndisp(iirrep)+j)
                  Work(ipT+ii)=Hess(jj)
               End Do
            End Do
            Call TriPrt(Label,' ',Work(ipT),ldisp(iirrep))
         End Do
         Call GetMem('Temp','FREE','REAL',ipT,nhess)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Do_RhoIA(nRho,mGrid,Rho,RhoI,
     &                     RhoA,mRho,TabMO,mAO,nMOs,
     &                     D1mo,nd1mo)
      Implicit Real*8 (a-h,o-z)
      Dimension RhoI(mRho,mGrid),RhoA(mRho,mGrid)
      Dimension TabMO(mAO,mGrid,nMOs)
      Dimension Rho(nRho,mGrid)
      Dimension D1mo(nd1mo)
      Integer iOff_Ash(0:7), iOff_Bas(0:7), iOff_BasAct(0:7)
#include "nq_info.fh"
#include "real.fh"
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      Call FZero(RhoI,mRho*mGrid)
      Call FZero(RhoA,mRho*mGrid)
      jOffA_ = 0
      jOffB_ = 0
      Do iIrrep = 0, mIrrep-1
         iOff_Ash(iIrrep)=jOffA_
         iOff_Bas(iIrrep)=jOffB_
         iOff_BasAct(iIrrep)=jOffB_ + nIsh(iIrrep) + nFro(iIrrep)
         jOffA_=jOffA_+nAsh(iIrrep)
         jOffB_=jOffB_+mBas(iIrrep)
      End Do
*
      NumIsh = 0
      NumAsh = 0
      Do iIrrep=0, mIrrep-1
         NumIsh = NumIsh + nISh(iIrrep)
         NumAsh = NumAsh + nAsh(iIrrep)
      End Do

      If (mRho.eq.1) Then
      Do iGrid = 1, mGrid
      Do iIrrep=0, mIrrep-1
*       Write(6,*) ' nISh',nISh(iIrrep)
       Do i_=1,nISh(iIrrep) + nFro(iIrrep)
        i = iOff_Bas(iIrrep) + i_
          RhoI(1,iGrid) = RhoI(1,iGrid) +
     &                    TabMO(1,iGrid,i)*TabMO(1,iGrid,i)
       End Do         ! i_
      End Do         ! iIrrep
      End Do         ! iGrid
*
      Do kIrrep = 0, mIrrep-1
         Do k_ = 1, nASh(kIrrep)
            k= k_ + iOff_BasAct(kIrrep)
            Do lIrrep = 0, mIrrep-1
               Do l_ = 1, nAsh(lIrrep)
                  l= l_ + iOff_BasAct(lIrrep)
                  kl=iTri(k_ + iOff_Ash(kIrrep) ,
     &                    l_ + iOff_Ash(lIrrep) )
                  Do iGrid = 1, mGrid
                     RhoA(1,iGrid) = RhoA(1,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(1,iGrid,l)
                  End Do     ! iGrid
               End Do      ! l_
            End Do       ! lIrrep
         End Do        ! k_
      End Do        ! kIrrep
      Else If (mRho.eq.4) Then
      Do iGrid = 1, mGrid
      Do iIrrep=0, mIrrep-1
*       Write(6,*) ' nISh',nISh(iIrrep)
       Do i_=1,nISh(iIrrep) + nFro(iIrrep)
        i = iOff_Bas(iIrrep) + i_
          RhoI(1,iGrid) = RhoI(1,iGrid) +
     &                    TabMO(1,iGrid,i)*TabMO(1,iGrid,i)
          RhoI(2,iGrid) = RhoI(2,iGrid) +
     &                    TabMO(1,iGrid,i)*TabMO(2,iGrid,i)
          RhoI(3,iGrid) = RhoI(3,iGrid) +
     &                    TabMO(1,iGrid,i)*TabMO(3,iGrid,i)
          RhoI(4,iGrid) = RhoI(4,iGrid) +
     &                    TabMO(1,iGrid,i)*TabMO(4,iGrid,i)
       End Do         ! i_
      End Do         ! iIrrep
      End Do         ! iGrid
*
      Do kIrrep = 0, mIrrep-1
         Do k_ = 1, nASh(kIrrep)
            k= k_ + iOff_BasAct(kIrrep)
            Do lIrrep = 0, mIrrep-1
               Do l_ = 1, nAsh(lIrrep)
                  l= l_ + iOff_BasAct(lIrrep)
                  kl=iTri(k_ + iOff_Ash(kIrrep) ,
     &                    l_ + iOff_Ash(lIrrep) )
                  Do iGrid = 1, mGrid
                     RhoA(1,iGrid) = RhoA(1,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(1,iGrid,l)
                     RhoA(2,iGrid) = RhoA(2,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(2,iGrid,l)
                     RhoA(3,iGrid) = RhoA(3,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(3,iGrid,l)
                     RhoA(4,iGrid) = RhoA(4,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(4,iGrid,l)
                  End Do     ! iGrid
               End Do      ! l_
            End Do       ! lIrrep
         End Do        ! k_
      End Do        ! kIrrep
      Else If (mRho.eq.6) Then
      Do iGrid = 1, mGrid
      Do iIrrep=0, mIrrep-1
       Do i_=1,nISh(iIrrep) + nFro(iIrrep)
        i = iOff_Bas(iIrrep) + i_
          RhoI(1,iGrid) = RhoI(1,iGrid) +
     &                    TabMO(1,iGrid,i)*TabMO(1,iGrid,i)
          RhoI(2,iGrid) = RhoI(2,iGrid) +
     &                    TabMO(1,iGrid,i)*TabMO(2,iGrid,i)
          RhoI(3,iGrid) = RhoI(3,iGrid) +
     &                    TabMO(1,iGrid,i)*TabMO(3,iGrid,i)
          RhoI(4,iGrid) = RhoI(4,iGrid) +
     &                    TabMO(1,iGrid,i)*TabMO(4,iGrid,i)
*
          RhoI(5,iGrid) = RhoI(5,iGrid) +
     &                    TabMO( 2,iGrid,i)*TabMO( 2,iGrid,i) +
     &                    TabMO( 3,iGrid,i)*TabMO( 3,iGrid,i) +
     &                    TabMO( 4,iGrid,i)*TabMO( 4,iGrid,i)
*
          RhoI(6,iGrid) = RhoI(6,iGrid) + TabMO(1,iGrid,i)*
     &                    ( TabMO( 5,iGrid,i) +
     &                      TabMO( 8,iGrid,i) +
     &                      TabMO(10,iGrid,i) )
       End Do         ! i_
      End Do         ! iIrrep
      End Do         ! iGrid
*
      Do kIrrep = 0, mIrrep-1
         Do k_ = 1, nASh(kIrrep)
            k= k_ + iOff_BasAct(kIrrep)
            Do lIrrep = 0, mIrrep-1
               Do l_ = 1, nAsh(lIrrep)
                  l= l_ + iOff_BasAct(lIrrep)
                  kl=iTri(k_ + iOff_Ash(kIrrep) ,
     &                    l_ + iOff_Ash(lIrrep) )
                  Do iGrid = 1, mGrid
                     RhoA(1,iGrid) = RhoA(1,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(1,iGrid,l)
                     RhoA(2,iGrid) = RhoA(2,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(2,iGrid,l)
                     RhoA(3,iGrid) = RhoA(3,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(3,iGrid,l)
                     RhoA(4,iGrid) = RhoA(4,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(4,iGrid,l)
                     RhoA(5,iGrid) = RhoA(5,iGrid) + D1mo(kl)*(
     &                   TabMO(2,iGrid,k)*TabMO(2,iGrid,l) +
     &                   TabMO(3,iGrid,k)*TabMO(3,iGrid,l) +
     &                   TabMO(4,iGrid,k)*TabMO(4,iGrid,l) )
                     RhoA(6,iGrid) = RhoA(6,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*(
     &                   TabMO( 5,iGrid,k) +
     &                   TabMO( 8,iGrid,k) +
     &                   TabMO(10,iGrid,k) )
                  End Do     ! iGrid
               End Do      ! l_
            End Do       ! lIrrep
         End Do        ! k_
      End Do        ! kIrrep
      Else
         Call WarningMessage(2,
     &              ' Somethings wrong in RhoI,A calculation')
         Call Abend()
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Rho)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine IPO(IPOA,NVIR,MUL,NSYM,KLS,IFT)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NVIR(*), MUL(8,8), NSYM, KLS, IFT
integer(kind=iwp), intent(out) :: IPOA(NSYM+1)
integer(kind=iwp) :: M, N, NSUM

NSUM = 0
if (IFT < 0) then
  do N=1,NSYM
    IPOA(N) = NSUM
    M = MUL(N,KLS)
    NSUM = NSUM+NVIR(N)*NVIR(M)
  end do
else
  if (KLS == 1) then
    do N=1,NSYM
      IPOA(N) = NSUM
      NSUM = NSUM+(NVIR(N)*(NVIR(N)+1))/2
    end do
  else
    do N=1,NSYM
      IPOA(N) = NSUM
      M = MUL(N,KLS)
      if (N > M) then
        NSUM = NSUM+NVIR(N)*NVIR(M)
      end if
    end do
  end if
end if
IPOA(NSYM+1) = NSUM

return

end subroutine IPO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module TwoDat

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

!----------------------------------------------------------------------*
!                                                                      *
! Return codes:                                                        *
!   %good - No error                                                   *
!   %CL01 - file has not been opened                                   *
!   %TC01 - file has not been opened                                   *
!   %TC02 - unknown ordering parameter                                 *
!   %TC03 - illegal number of symmetry operations                      *
!   %RD01 - illegal combination of symmetry labels                     *
!   %RD02 - illegal ordering of symmetry labels                        *
!   %RD03 - inconsistent symmetry batch                                *
!   %RD04 - illegal buffer size                                        *
!   %RD05 - buffer size is to small                                    *
!   %RD06 - unknown option                                             *
!   %RD07 - symmetry block is not available                            *
!   %RD08 - file has not been opened                                   *
!   %RD09 - packing table has not been loaded                          *
!   %RD10 - pq1 out of bounds                                          *
!   %RD11 - bad initialization of genint                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Switches for OpnOrd:                                                 *
!   sNew   - create a new file                                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     Entry points to auxiliary information on 2el. file:              *
!     (AuxTwo)                                                         *
!                                                                      *
!     %Unt  : logical unit number of 2el. integral file                *
!     %Opn  : status identifier (is it opened?)                        *
!     %Dada : disk address of last access                              *
!     %Upk8 : pointer to next integral to unpack                       *
!     %lBf1 : number of left integrals in TWOBUF                       *
!     %Npq  : number of pq pairs per symmetry batch which has not      *
!             been read currently                                      *
!                                                                      *
!     Entry points to table of contents for ordered 2el. integrals:    *
!                                                                      *
!     lTocTwo : length of table of content                             *
!     isId    : location of file identifier                            *
!     isVer   : location of version number                             *
!     isOrd   : location of ordering key                               *
!     isForm  : format of data on disk                                 *
!     isSym   : location of number of irred. representations           *
!     isBas   : first location of basis function counters              *
!     isSkip  : first location of the skip flags                       *
!     isDAdr  : first location of disk addresses for each sym. batch   *
!     isMxDa  : highest disk address written                           *
!     isPkTh  : location of threshold for packing                      *
!     isPkCt  : location of cutof for packing (unused)                 *
!     isPkSc  : location of scaling constant for packing (unused)      *
!     isPkPa  : location of packing key                                *
!     isPkAs  : location of assmbler key (unused)                      *
!     isPkTb  : first location of packing table (unused)               *
!     isFree  : first free location for suplementary information       *
!                                                                      *
!     Parameters for the symmetry block number to batch number         *
!     translation table                                                *
!                                                                      *
!     lBatch  : length of the translation table                        *
!                                                                      *
!     Dummy number used to initialize AuxTwo and TocTwo                *
!                                                                      *
!     iNoNum  : dummy constant = -1                                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! RAMD: save control structures needed if the two-electron integrals   *
!       if random access memory (RAM) is used as disk to keep them.    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     Global Parameters used for the I/O                               *
!                                                                      *
!     lDaRec  : minimal record (in 4Byte words) transferred by         *
!               DAFILE                                                 *
!     nSect   : integer multiple of lDaRec which constitutes the       *
!               standard record length                                 *
!     lStRec  : standard record length                                 *
!     lTop    : each record has its own header of length lTop          *
!                                                                      *
!----------------------------------------------------------------------*

type FInfo_type
  integer(kind=iwp) :: ID = 4098, VN = 1024
end type FInfo_type
type(FInfo_type), parameter :: FInfoTwo = FInfo_type()

type rc_type
  integer(kind=iwp) :: good = 0, &
                       CL01 = 1, &
                       TC01 = 2, &
                       TC02 = 3, &
                       TC03 = 4, &
                       RD01 = 5, &
                       RD02 = 6, &
                       RD03 = 7, &
                       RD04 = 8, &
                       RD05 = 9, &
                       RD06 = 10, &
                       RD07 = 11, &
                       RD08 = 12, &
                       RD09 = 13, &
                       RD10 = 14, &
                       RD11 = 15
end type rc_type
type(rc_type), parameter :: rcTwo = rc_type()

integer(kind=iwp), parameter :: sNew = 0
integer(kind=iwp), parameter :: isId    = 1, &
                                isVer   = isId   +1, &
                                isOrd   = isVer  +1, &
                                isForm  = isOrd  +1, &
                                isSym   = isForm +1, &
                                isBas   = isSym  +1, &
                                isSkip  = isBas  +8, &
                                isDAdr  = isSkip +8, &
                                isMxDa  = isDadr +176, &
                                isPkTh  = isMxDa +1, &
                                isPkCt  = isPkTh +2, &   ! unused
                                isPkSc  = isPkCt +2, &   ! unused
                                isPkPa  = isPkSc +2, &
                                isPkAs  = isPkPa +1, &   ! unused
                                isPkTb  = isPkAs +1, &   ! unused
                                isFree  = isPkTb +4096, &
                                lTocTwo = isFree +10
integer(kind=iwp), parameter :: iNoNum = -1, lBatch = 1296, lDaRec = 1024, nSect = 32, lStRec = nSect*lDaRec, lTop = 4

type AuxTwo_type
  integer(kind=iwp) :: Unt = 0, DaDa = 0, Upk8 = 0, lBf1 = 0, Npq = 0
  logical(kind=iwp) :: Opn = .false.
end type AuxTwo_type

type RAMD_type
  logical(kind=iwp) :: act = .false.
  integer(kind=iwp) :: adr(176) = 0, next = 0
  real(kind=wp) :: ints(8) = Zero
end type RAMD_type

integer(kind=iwp) :: nBatch(lBatch), TocTwo(lTocTwo)
type(AuxTwo_type) :: AuxTwo
type(RAMD_type) :: RAMD

public :: AuxTwo, FInfoTwo, iNoNum, isBas, isDAdr, isForm, isFree, isId, isMxDa, isOrd, isPkPa, isPkTh, isSkip, isSym, isVer, &
          lDaRec, lStRec, lTocTwo, lTop, nBatch, nSect, RAMD, rcTwo, sNew, TocTwo

end module TwoDat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_global_paras

   IMPLICIT NONE
   PUBLIC

!------------------------------------------------------------------------------

   ! We select here the REAL and INTEGER precisions
   !   INTEGER, PARAMETER :: INTK  = SELECTED_INT_KIND(9),           &
   !                         REALK = SELECTED_REAL_KIND(XXX)
   ! Use standard integers and REAL*8 double precision floats
   INTEGER, PARAMETER :: INTK  = KIND(1),                         &
                         REALK = KIND(1D0)

!==============================================================================
! Program-wide global variables |
!===============================!

    ! Unit numbers for IO
   INTEGER(INTK), SAVE :: LUPRI = 6
   INTEGER(INTK), SAVE :: LUINTM = 77
    ! Interface file name (contains moments and co-ordinate data)
   CHARACTER(LEN=7),  SAVE :: INPUT_FILE = 'MM_DATA'
   CHARACTER(LEN=14), SAVE :: INPUT_FILE_HEADER = 'MM_DATA_HEADER'

    ! Flag for verbose printing of run-time statistics
   LOGICAL, SAVE :: fmm_stats_printed = .TRUE.

!==============================================================================
! Global parameters |
!===================!

   REAL(REALK), PARAMETER :: zero   = 0.0_REALK,                        &
                             one    = 1.0_REALK,                        &
                             two    = 2.0_REALK,                        &
                             half   = 0.5_REALK,                        &
                             PI     = 3.14159265358979323846264_REALK,  &
                             ROOTPI = 1.77245385090552_REALK


!------------------------------------------------------------------------------

   ! Branch-free algorithm
   LOGICAL,     PARAMETER :: BRFREE_DF = .TRUE.
   ! minimum charge separation for qTq evaluation
   REAL(REALK), PARAMETER :: EXTENT_MIN_DF = 0.001_REALK

   ! Same centre/extent packing flags
   LOGICAL, PARAMETER :: PACK_RHS_DF = .TRUE.
   LOGICAL, PARAMETER :: PACK_LHS_DF = .FALSE.

    ! Parameters for branch and box structure
!   INTEGER(INTK), PARAMETER :: WS_MIN = 2
   INTEGER(INTK), PARAMETER :: WS_MIN = 1
   LOGICAL,       PARAMETER :: JOIN_BRANCHES = .TRUE.

    ! Parameters for T-list tree sorting
   INTEGER(INTK), PARAMETER :: START_LEN   = 8
   INTEGER(INTK), PARAMETER :: TREE_LENGTH = 50000
   ! MAX_AVG_PER_NODE limits the maximal packing ratio.
   ! there will be never more interactions in the tree than
   ! tree size times MAX_AVG_PER_NODE.
   INTEGER(INTK), PARAMETER :: MAX_AVG_PER_NODE = 15

    ! Noise buffer when testing for classical interactions
 !FIXME: have this passed from clsfmm.h ... used for nothing else!!
   REAL(REALK), PARAMETER :: ZERO_DIST_TOL = 1e-14_REALK

    ! Parameters for contractions and translations
   ! Number of simultaneous T-matrices when using T_CONTRACTOR_MULTI
   INTEGER(INTK), PARAMETER :: TMATM_DF = 25

 !FIXME: clarify the use of these tolerance parameters!!
   REAL(REALK), PARAMETER :: DISTINCT_T_TOL  = 1e-15_REALK
   REAL(REALK), PARAMETER :: EXTENT_TEST_TOL = 1e-15_REALK
   REAL(REALK), PARAMETER :: ZERO_VECT_TOL   = 1e-10_REALK

!------------------------------------------------------------------------------

    ! Parameters to define level depth used in box hierarchy
   INTEGER(INTK), PARAMETER :: TOP_LEVEL = 2
   INTEGER(INTK), PARAMETER :: MAX_LEVEL = 15

!------------------------------------------------------------------------------
!
! Named parameters for coding use (avoidance of "magic" numbers etc.)
!
    ! Named parameters for potential or J-matrix request
   INTEGER(INTK), PARAMETER :: GFC_FMM = 1,  &
                               MD4_FMM = 2,  &
                               FE_FMM = 3

    ! Named parameters for (classical) near-field or far-field phase
   INTEGER(INTK), PARAMETER :: NEAR_FIELD = 1 ,    &
                               FAR_FIELD  = 2

    ! Named parameters for different MM methods implemented
   INTEGER(INTK), PARAMETER :: DO_NULL  = 0 ,     &
                               DO_FQ    = 1 ,     &
                               DO_BQ    = 3 ,     &
                               DO_NlogN = 4 ,     &
                               DO_FMM   = 5

    ! Named parameters for T-pair interaction types
   INTEGER(INTK), PARAMETER :: LHS_raw_RHS_raw = 1,     &
                               LHS_raw_RHS_box = 2,     &
                               LHS_box_RHS_raw = 3,     &
                               LHS_box_RHS_box = 4

    ! Named parameters for T-pair interaction search algorithms
   INTEGER(INTK), PARAMETER :: FQ_LOOPS    = 1,     &
                               GRID_SEARCH = 2,     &
                               TREE_SEARCH = 3

    ! Named parameters for different contractors implemented
   INTEGER(INTK), PARAMETER :: T_CONTRACTOR_DIRECT = 100,        &
                               T_CONTRACTOR_BOUNDARY = 101,      &
                               T_CONTRACTOR_TREE = 102,          &
                               T_CONTRACTOR_SCALE = 104,         &
                               T_CONTRACTOR_SCALE_TREE = 1041,   &
                               T_CONTRACTOR_MULTI = 105,         &
                               T_CONTRACTOR_FULL = 106,          &
                               W_CONTRACTOR_DIRECT = 206,        &
                               W_CONTRACTOR_X = 207,             &
                               W_CONTRACTOR_FAST = 208,          &
                               W_CONTRACTOR_BOUNDARY = 209

    ! Named parameters for different J-builders (contractors) implemented
   INTEGER(INTK), PARAMETER :: J_BUILDER_DIRECT = 1,        &
                               J_BUILDER_TREE = 2

    ! Named parameters for moments used in contraction
   INTEGER(INTK), PARAMETER :: ELECTRONIC_ONLY = 1,        &
                               NUCLEAR_ONLY    = 2,        &
                               ALL_MOMENTS     = 3

    ! Named parameters for T-pair interaction tests
   INTEGER(INTK), PARAMETER :: TEST_EXT     = 1,        &
                               TEST_R_IJ    = 2,        &
                               TEST_NN_EXT  = 3,        &
                               TEST_NN_R_IJ = 4,        &
                               TEST_FF      = 5,        &
                               TEST_LFF     = 6

    ! Named parameters for auxiliary moments
   INTEGER(INTK), PARAMETER :: USE_RAW_QLM   = 0 ,        &
                               USE_T_SYM_QLM = 1

    ! Named parameters for lists available
   INTEGER(INTK), PARAMETER :: NULL_T_BUFFER  = 1 ,        &
                               NULL_W_BUFFER  = 2 ,        &
                               TREE_T_BUFFER  = 3 ,        &
                               TREE_W_BUFFER  = 4 ,        &
                               SKIP_T_BUFFER  = 5 ,        &
                               SKIP_W_BUFFER  = 6 ,        &
                               MULTI_T_BUFFER = 7 ,        &
                               SCALE_T_BUFFER = 8

    ! Sort orders expected by interaction evaluators.
   INTEGER(INTK), PARAMETER :: NO_SORT         = 0 ,       &
                               SORT_BY_SCALE   = 1,        &
                               SORT_BY_RHS_MMS = 2

    ! Named parameters for memory management
   INTEGER(INTK), PARAMETER :: NMEMDIVS = 5
   CHARACTER(LEN=7),  PARAMETER :: NSPACE(NMEMDIVS) = (/ 'raw_qlm',   &
                                                     'raw_Vff',   &
                                                     'box_Vff',   &
                                                     'Vff_tmp',   &
                                                     'box_qlm' /)
   INTEGER(INTK), PARAMETER :: MEM_RAW_QLM = 1,        &
                               MEM_RAW_VFF = 2,        &
                               MEM_BOX_VFF = 3,        &
                               MEM_VFF_TMP = 4,        &
                               MEM_BOX_QLM = 5

!===============================================================================
! Derived types |
!================

    ! Structure for counting raw multipole moments by type
   TYPE fmm_counters
      INTEGER(INTK) :: tot, nuc, elec
   END TYPE fmm_counters

!------------------------------------------------------------------------------

    ! Structure for defining boundary planes (assuming // to axes)
   TYPE fmm_planes
      REAL(REALK) :: xmin,xmax, ymin,ymax, zmin,zmax
   END TYPE fmm_planes

!------------------------------------------------------------------------------

   TYPE LHS_RHS_type
      INTEGER(INTK) :: LHS, RHS
   END TYPE LHS_RHS_type

!------------------------------------------------------------------------------

   TYPE fmm_range
      INTEGER(INTK) :: hi, lo, tot
   END TYPE fmm_range

!------------------------------------------------------------------------------

    ! Complete prescription of MM execution held in "scheme"
   TYPE T_contract_schm
      INTEGER(INTK) :: NF_ID, FF_ID
      INTEGER(INTK) :: NF_T_buffer, FF_T_buffer
      INTEGER(INTK) :: NF_sort_para, FF_sort_para
      INTEGER(INTK) :: LHS_mm_type, RHS_mm_type
   END TYPE T_contract_schm

   TYPE W_contract_schm
      INTEGER(INTK) :: ID         ! general translator
      INTEGER(INTK) :: BR_ID      ! box-to-raw translator
      INTEGER(INTK) :: W_buffer
      INTEGER(INTK) :: sort_para
   END TYPE W_contract_schm

   TYPE scheme_paras
      INTEGER(INTK)         :: job_type
      LOGICAL               :: include_near_field
      INTEGER(INTK)         :: algorithm, phase
      INTEGER               :: NF_T_searcher, FF_T_searcher
      TYPE(T_contract_schm) :: T_con
      TYPE(W_contract_schm) :: W_con
      LOGICAL               :: branch_free
      INTEGER(INTK)         :: raw_lmax, trans_lmax
      INTEGER(INTK)         :: LHS_mm_range, RHS_mm_range
      LOGICAL               :: pack_LHS, pack_RHS
      LOGICAL               :: LHS_dens, RHS_dens
      REAL(REALK)           :: extent_min
      REAL(REALK)           :: grain
      REAL(REALK)           :: dens_screen_thr
      INTEGER(INTK)         :: FEdim
      ! Order of Lagrange interpolating polynomials for finite elements
      INTEGER(INTK)         :: lipn

   END TYPE scheme_paras

!------------------------------------------------------------------------------

    ! Raw (not boxed) multipole moment data structure
   TYPE raw_mm_paras
      REAL(REALK)   :: cntr(3), ext
      INTEGER(INTK) :: batch            ! batch id of unique centres/extents
      INTEGER(INTK) :: id               ! map to raw moments array
      INTEGER(INTK) :: map_up           ! map to boxed multipole moment
      INTEGER(INTK) :: box(3), bra
      REAL(REALK)   :: box_cntr(3)
   END TYPE raw_mm_paras

   TYPE J_index_type
      INTEGER(INTK) :: i_indx, j_indx   ! map to J_matrix elements
   END TYPE J_index_type

   TYPE raw_mm_data
      TYPE(raw_mm_paras), POINTER :: paras(:)
      REAL(REALK),        POINTER :: dens(:)
      REAL(REALK),        POINTER :: qlm(:,:)
      REAL(REALK),        POINTER :: qlm_T(:,:)
      REAL(REALK),        POINTER :: qlm_W(:,:)
      TYPE(J_index_type), POINTER :: J_indices(:)
      TYPE(id_list),      POINTER :: batch_map(:) ! maps raw paras in one batch
   END TYPE raw_mm_data

!------------------------------------------------------------------------------

    ! Boxed multipole moment data structure
   TYPE box_mm_paras
      INTEGER(INTK) :: box(3)
      REAL(REALK)   :: cntr(3)
      INTEGER(INTK) :: bra, level
      INTEGER(INTK) :: map_up            ! map to moment at next level
      REAL(REALK)   :: cntr_up(3)        ! centre of parent box
      INTEGER(INTK) :: id                ! map to moment at this level
   END TYPE box_mm_paras
   TYPE box_mm_data
      TYPE(box_mm_paras), POINTER :: LHS_paras(:)
      TYPE(box_mm_paras), POINTER :: RHS_paras(:)
      ! Just RHS moments (only RHS is built up in box hierarchy)
      REAL(REALK),        POINTER :: qlm_T(:,:)
      REAL(REALK),        POINTER :: qlm_W(:,:)
   END TYPE box_mm_data

!------------------------------------------------------------------------------

    ! Map structure to link packed parameters with all raw moment members
   TYPE id_node
      INTEGER(INTK) :: id
      INTEGER(INTK) :: i_indx, j_indx
      TYPE(id_node), POINTER :: next
   END TYPE id_node

   TYPE id_list
      INTEGER(INTK) :: occ
      TYPE(id_node), POINTER :: head
   END TYPE id_list

!------------------------------------------------------------------------------

    ! Generalised multipole moment parameter structure
   TYPE gen_mm_paras
      TYPE(raw_mm_paras), POINTER :: raw_paras(:)
      TYPE(box_mm_paras), POINTER :: box_paras(:)
   END TYPE gen_mm_paras

!------------------------------------------------------------------------------

   TYPE T_paras
      INTEGER(INTK) :: LHS_lmax, LHS_id
      INTEGER(INTK) :: RHS_lmax, RHS_id
      INTEGER(INTK) :: weight
      REAL(REALK)   :: ratio
   END TYPE T_paras

   TYPE T_pair_single
      TYPE(T_paras) :: paras
      REAL(REALK)   :: r_ab(3)
      INTEGER(INTK) :: lmax, lm_max
      ! Used only for W_pairs when translating to distinguish qlm and Vff modes
      CHARACTER(LEN=1)  :: N_or_T
   END TYPE T_pair_single

   TYPE T_pair_list
      TYPE(T_paras), POINTER :: paras(:)
      REAL(REALK)   :: r_ab(3)
      INTEGER(INTK) :: lmax, lm_max
      INTEGER(INTK) :: LHS_lmax, RHS_lmax
      ! Used only for W_pairs when translating to distinguish qlm and Vff modes
      CHARACTER(LEN=1)  :: N_or_T
   END TYPE T_pair_list

   TYPE T_pair_batch
      TYPE(T_pair_single), POINTER :: items(:)
      INTEGER(INTK) :: ndim
   END TYPE T_pair_batch

    ! Index type for OLD and NEW W_translations
   TYPE old_new
      INTEGER(INTK) :: old, new
   END TYPE old_new

!------------------------------------------------------------------------------
!
!    ! Linked-list shell-pair data structure
!   TYPE fmm_shell_pair_node
!      INTEGER(INTK) :: I,J
!      INTEGER(INTK) :: box(3)
!      REAL(REALK)   :: extent
!      REAL(REALK)   :: centre(3)
!      TYPE(fmm_shell_pair_node), POINTER :: next
!   END TYPE fmm_shell_pair_node
!
!!-----------------------------------------------------------------------------
!
!    ! Shell-pairs are collected into boxes
!   TYPE fmm_boxed_sh_pairs
!      TYPE(box_mm_paras) :: paras
!      TYPE(fmm_shell_pair_node), POINTER :: sh_pairs(:)
!   END TYPE fmm_boxed_sh_pairs
!
!------------------------------------------------------------------------------

    ! O(N) array of non-vanishing shell paris
   TYPE fmm_sh_pairs
      INTEGER(INTK) :: I, J
      REAL(REALK)   :: extent
      REAL(REALK)   :: centre(3)
   END TYPE fmm_sh_pairs

!------------------------------------------------------------------------------

    ! Basis set information from host program
   TYPE fmm_basis
      INTEGER(INTK) :: nbas
      INTEGER(INTK) :: nshells
      INTEGER(INTK) :: maxsgm2
      INTEGER(INTK) :: maxangl
      INTEGER(INTK), POINTER :: KAtom(:)
      INTEGER(INTK), POINTER :: KType(:)
      INTEGER(INTK), POINTER :: KStart(:)
      INTEGER(INTK), POINTER :: KontG(:)
      INTEGER(INTK), POINTER :: KLoc_Car(:)
      INTEGER(INTK), POINTER :: LtuvMin_Car(:)
      INTEGER(INTK), POINTER :: LtuvMax_Car(:)
      INTEGER(INTK), POINTER :: Lt(:)
      INTEGER(INTK), POINTER :: Lu(:)
      INTEGER(INTK), POINTER :: Lv(:)
      REAL(REALK), POINTER :: Centr(:,:)
      REAL(REALK), POINTER :: Expnt(:)
      REAL(REALK), POINTER :: CCoef(:)
   END TYPE fmm_basis

!------------------------------------------------------------------------------

    ! Batch of primitive data for one shell-pair
   TYPE fmm_prim_batch
      REAL(REALK) :: P(3), PA(3), PB(3), PC(3)
      REAL(REALK) :: lo(3), hi(3)
      REAL(REALK) :: ExpntP
      REAL(REALK) :: ExpPHalf
      REAL(REALK) :: PreFactAB
      REAL(REALK) :: CCoefAB
   END TYPE fmm_prim_batch

!------------------------------------------------------------------------------

   TYPE fmm_box_id_type
      INTEGER(INTK) :: id
      REAL(REALK)   :: centre(3)
   END TYPE fmm_box_id_type

!------------------------------------------------------------------------------

END MODULE fmm_global_paras

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine serber_cvb(bikcof,nel,nalf,nbet,ndet,ifns)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nel, nalf, nbet, ndet, ifns
real(kind=wp), intent(inout) :: bikcof(ndet,ifns)
integer(kind=iwp) :: ia, iachek, iantival, ib, indx, iorb, k, l, nc, rc
integer(kind=iwp), allocatable :: ialfs(:), ianti(:), ibets(:), lnocca(:), locca(:), maxspn(:), minspn(:), nkspn(:), xspin(:)
real(kind=wp) :: dum(1)

! Serber spin functions

! For each Rumer spin function we determine (minus) the "antisymmetry"
! number, as explained in [Spin Eigenfunctions, R. Pauncz, Sec. 5.5].

call mma_allocate(minspn,[0,nel],label='minspn')
call mma_allocate(maxspn,[0,nel],label='maxspn')
call mma_allocate(nkspn,[0,nel],label='nkspn')
call mma_allocate(locca,nel,label='locca')
call mma_allocate(lnocca,nel,label='lnocca')
call mma_allocate(xspin,(nel+1)*(nalf+1),label='xspin')
call mma_allocate(ialfs,nalf,label='ialfs')
call mma_allocate(ibets,nbet,label='ibets')
call mma_allocate(ianti,ifns,label='ianti')

! Spin function weight arrays:
do iorb=0,nel
  minspn(iorb) = max(iorb-nalf,0)
  maxspn(iorb) = min(iorb/2,nbet)
end do
call weight_cvb(xspin,minspn,maxspn,nbet,nel)
if (ifns /= xspin((nel+1)*(nbet+1))) then
  write(u6,*) ' Discrepancy in IFNS:',ifns,xspin((nel+1)*(nbet+1))
  call abend_cvb()
end if
nkspn(:) = maxspn(:)
call occupy_cvb(nkspn,nel,locca,lnocca)
! Loop:
indx = 1
! Determine pairings
do
  do ib=1,nbet
    ibets(ib) = locca(ib)
    do ia=nalf,1,-1
      ialfs(ib) = lnocca(ia)
      if (ialfs(ib) < ibets(ib)) then
        do iachek=1,ib-1
          if (ialfs(iachek) == ialfs(ib)) exit
        end do
        if (iachek >= ib) exit
      end if
    end do
  end do

  ianti(indx) = 0
  do ib=1,nbet
    if ((mod(ialfs(ib),2) == 1) .and. (ialfs(ib) == ibets(ib)-1)) ianti(indx) = ianti(indx)-1
  end do
  call loind_cvb(nel,nbet,nkspn,minspn,maxspn,locca,lnocca,indx,xspin,rc)
  if (rc == 0) exit
end do

call mma_deallocate(minspn)
call mma_deallocate(maxspn)
call mma_deallocate(nkspn)
call mma_deallocate(locca)
call mma_deallocate(lnocca)
call mma_deallocate(xspin)
call mma_deallocate(ialfs)
call mma_deallocate(ibets)

! Sort according to decreasing values of IANTI:
nc = 0
do iantival=nbet,0,-1
  do k=1,ifns
    if (ianti(k) == -iantival) then
      nc = nc+1
      ianti(k) = nc
    end if
  end do
end do

do k=1,ifns
  if (ianti(k) /= k) then
    do l=1,ifns
      if (ianti(l) == k) exit
    end do
    if (l > ifns) then
      write(u6,*) ' Error - swap function not found!',k,ianti(k)
      call abend_cvb()
    end if
    call dswap_(ndet,bikcof(:,k),1,bikcof(:,l),1)
    ianti(l) = ianti(k)
    ianti(k) = k
  end if
end do

call mma_deallocate(ianti)

! Orthonormalize:
call schmidtn_cvb(bikcof,ifns,dum,ndet,0)

return

end subroutine serber_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
SUBROUTINE covarMatrix()
  use kriging_mod
  Implicit None
#include "stdalloc.fh"
  integer i,j,i0,i1,j0,j1,k
  Real*8, Allocatable :: diffx_j(:,:), diffx_i(:,:), matFder(:,:),&
                         matSder(:,:), r(:,:,:), d(:,:)
!#define _DEBUGPRINT_

!**********************************************************************
!
! Allocate temporary memory
!
  Call mma_Allocate(diffx_j,nPoints,nPoints,Label="diffx_j")
  Call mma_Allocate(diffx_i,nPoints,nPoints,Label="diffx_i")
  Call mma_Allocate(matFder,nPoints,nPoints,Label="matFder")
  Call mma_Allocate(matSder,nPoints,nPoints,Label="matSder")
  Call mma_Allocate(r,nPoints,nPoints,nInter,Label="r")
  Call mma_Allocate(d,nPoints,nPoints,Label="d")
!
!**********************************************************************
!
! Compute the distances between the sample points using
! the characteristic length.
!
  full_R(:,:) = 0.0D0
  d(:,:) = 0.0D0
  diffx_j(:,:) = 0.0D0
  diffx_i(:,:) = 0
!
  do i=1,nInter

    do k=1,nPoints
      do j=1,nPoints
        r(k,j,i)=(x(i,k)-x(i,j))/l(i)
      end do
    end do

!   Accumulate contributions to the square of the individual distances.

    d(:,:) = d(:,:) + r(:,:,i)**2

#ifdef _DEBUGPRINT_
    Call RecPrt('r',' ',r(1,1,i),nPoints,nPoints)
#endif

  end do
!
!**********************************************************************
!
#ifdef _DEBUGPRINT_
  Call RecPrt('l',' ',l,1,nInter)
  Call RecPrt('x',' ',x,nInter,nPoints)
  Call RecPrt('d',' ',d,nPoints,nPoints)
#endif
!
!**********************************************************************
!**********************************************************************
!
! Now evaluate the covariance function over all the distances. For GEK
! we will need gradients and 2nd order derivatives of the covariance
! function too.
!
! Currently we use the 5/2 Matern function as the covariance function
!
!**********************************************************************
!
! Note that we will evaluate the derivative of the covariance function
! w.r.t d. For the full derivative this has to be complemented by
! the derivative of d w.r.t the individual components of the coordinates.
!
!**********************************************************************
! 1) Evaluate the covariance function for all the distances.
!
  Call matern(d, full_R(1:nPoints,1:nPoints), nPoints, nPoints)
!
! Writing the covariant matrix in GEK (eq 2 of doi:10.1007/s00366-015-0397)
!
!**********************************************************************
!
! 2) Evaluate first derivatives of the covariance function with respect to d at all distances.
!
  Call matderiv(1, d, MatFder, nPoints, nPoints)
!
! Covariant matrix in Gradient Enhanced Kriging (eq 2 of doi:10.1007/s00366-015-0397):
!
! First line and first column derivative in Psi matrix
!
  do i=1,nInter      ! Loop over component of the coordinate to differentiate
!
!   Compute the range of the block in the covariance matrix.
!
    i0 = nPoints + 1 + (i-1)*(nPoints-nD)
    i1 = i0 + (nPoints-nD) - 1
!
!   Do an on-the-fly evaluation of the dervative w.r.t x_i
    diffx_i(1:nPoints,1+nD:nPoints) = -2.0D0*r(1:nPoints,1+nD:nPoints,i)/l(i)
!
!   Writing the 1st row of 1st derivatives with respect the coordinates
!
    full_R(1:nPoints,i0:i1) = matFDer(1:nPoints,1+nD:nPoints)  &
                            * diffx_i(1:nPoints,1+nD:nPoints)

  enddo
! Complete by filling in the transpose blocks

  full_R(nPoints+1:m_t,1:nPoints) = Transpose(Full_R(1:nPoints,nPoints+1:m_t))
!
!**********************************************************************
!
! 3) Evaluate the second derivatives.
!
! Matern second derivative with respect to d
!
  call matderiv(2, d, matSder, nPoints, nPoints)
!
    ! Second derivatives
  do i = 1,nInter
    i0 = nPoints + 1 + (i-1)*(nPoints-nD)
    i1 = i0 + (nPoints-nD) - 1
!
    diffx_i(1+nD:nPoints,1+nD:nPoints) = -2.0D0*r(1+nD:nPoints,1+nD:nPoints,i)/l(i)
!
    do j = i,nInter
      j0 = nPoints + 1 + (j-1)*(nPoints-nD)
      j1 = j0 + (nPoints-nD) - 1
!
      diffx_j(1+nD:nPoints,1+nD:nPoints)  =  2.0D0*r(1+nD:nPoints,1+nD:nPoints,j)/l(j)
!
    !   if differentiating twice on the same dimension
      full_R(i0:i1,j0:j1) = matSder(1+nD:nPoints,1+nD:nPoints) &
                          * diffx_j(1+nD:nPoints,1+nD:nPoints) &
                          * diffx_i(1+nD:nPoints,1+nD:nPoints)

      if (i.eq.j) full_R(i0:i1,j0:j1) = full_R(i0:i1,j0:j1) &
                                      - matFder(1+nD:nPoints,1+nD:nPoints)*(2.0D0/(l(i)*l(j)))

    !   Writing the second derivatives in eq(2)
      if (i.ne.j) full_R(j0:j1,i0:i1) = transpose(Full_r(i0:i1,j0:j1))
    enddo

  enddo
!
!           Add constants to reflect the error in the energy and the
!           gradient, respectively.
!
  do j=1,m_t
    if (j.le.nPoints) then
      Full_R(j,j) = Full_R(j,j) + eps
    else
      Full_R(j,j) = Full_R(j,j) + eps2
    end if
  end do
!
!           defining full_r has strictly positive define sec. 3 of
!           doi:10.1615/Int.J.UncertaintyQuantification.2013006809
  ! full_R = abs(full_R)
#ifdef _DEBUGPRINT_
  Call RecPrt('full_r Orig:','(14E10.2)',full_R,m_t,m_t)
#endif
!
  Call mma_deallocate(diffx_j)
  Call mma_deallocate(diffx_i)
  Call mma_deallocate(matFder)
  Call mma_deallocate(matSder)
  Call mma_deallocate(r)
  Call mma_deallocate(d)
END SUBROUTINE covarMatrix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module vRys_RW

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: MaxRys = 9
integer(kind=iwp) :: iCffR(0:6,MaxRys), iCffW(0:6,MaxRys), iMap(MaxRys), ix0(MaxRys), nMap(MaxRys), nMxRys, nx0(MaxRys)
real(kind=wp), allocatable :: Cff(:), ddx(:), HerR2(:), HerW2(:), TMax(:), x0(:)
integer(kind=iwp), allocatable :: iHerR2(:), iHerW2(:), Map(:)

public :: Cff, ddx, HerR2, HerW2, iCffR, iCffW, iHerR2, iHerW2, iMap, ix0, Map, nMap, nMxRys, nx0, TMax, x0

end module vRys_RW

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkT_T15 (Tp,T2,T11,T12,dimbe,dima,no)
c
c       this routine do:
c       Tp(be',u,a',i) <- 2 t2(be,a,u,i)
c                       - t2(be,a,i,u)+t12(a,u).t11(be,i)/2
c        N.B. mozno sa to da este vylepsit
c
        implicit none
        integer dimbe,dima,no
        real*8 Tp(1:dimbe,1:no,1:dima,1:no)
        real*8 T2(1:dimbe,1:dima,1:no,1:no)
        real*8 T11(1:dimbe,1:no)
        real*8 T12(1:dima,1:no)
c
c       help variables
        integer be,a,u,i
        real*8 c1

        do i=1,no
          do a=1,dima
            do u=1,no
            c1=T12(a,u)
              do be=1,dimbe
                 Tp(be,u,a,i)=2.0d0*T2(be,a,u,i)
     c                       -T2(be,a,i,u)+c1*T11(be,i)
              end do
            end do
          end do
        end do
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Distg1(Temp,Grad,nGrad,IfGrad,IndGrd,iStab,kOp)
!***********************************************************************
!                                                                      *
! Object: trace the gradient of the ERI's with the second order        *
!         density matrix                                               *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!***********************************************************************

use Symmetry_Info, only: nIrrep, iChBas
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(in) :: Temp(9)
integer(kind=iwp), intent(in) :: nGrad, IndGrd(3,4), iStab(4), kOp(4)
real(kind=wp), intent(inout) :: Grad(nGrad)
logical(kind=iwp), intent(in) :: IfGrad(3,4)
integer(kind=iwp) :: iCar, iCent, iCn, iGrad, ij, jCn, kl, nVec
real(kind=wp) :: Fact, PAOg1(12), ps
real(kind=wp), parameter :: Prmt(0:7) = [One,-One,-One,One,-One,One,One,-One]

#ifdef _DEBUGPRINT_
iRout = 239
iPrint = nPrint(iRout)
if (iPrint >= 99) then
  call RecPrt('Accumulated gradient on entrance',' ',Grad,nGrad,1)
  write(u6,*) ' kOp=',kOp
  write(u6,*) ' iStab=',iStab
  call RecPrt('Distg1: Temp',' ',Temp,9,1)
end if
if (iPrint >= 49) write(u6,*) IndGrd
#endif

! Distribute Temp in PAOg1

nVec = 0
do iCar=1,3
  do iCent=1,4
    ij = 3*(iCent-1)+iCar
    if (IfGrad(iCar,iCent)) then
      nVec = nVec+1
      PAOg1(ij) = Temp(nVec)
    else
      PAOg1(ij) = Zero
    end if
  end do
end do

! a) Compute some of the contributions via the translational invariance
! b) Distribute contribution to the gradient.

do iCn=1,4
  do iCar=1,3
    ij = 3*(iCn-1)+iCar

    ! a)

    if (IndGrd(iCar,iCn) < 0) then
      do jCn=1,4
        if ((iCn /= jCn) .and. IfGrad(iCar,jCn)) then
          kl = 3*(jCn-1)+iCar
          PAOg1(ij) = PAOg1(ij)-PAOg1(kl)
        end if
      end do
    end if

    ! b)

    if (IndGrd(iCar,iCn) /= 0) then
      iGrad = abs(IndGrd(iCar,iCn))
      ! Parity due to integration direction
      ps = Prmt(iand(kOp(iCn),iChBas(1+iCar)))
      Fact = ps*real(iStab(iCn),kind=wp)/real(nIrrep,kind=wp)
      Grad(iGrad) = Grad(iGrad)+Fact*PAOg1(ij)
    end if

  end do
end do

#ifdef _DEBUGPRINT_
if (iPrint >= 49) then
  call RecPrt('PAOg1',' ',PAOg1,12,1)
  call RecPrt('Accumulated gradient on exit',' ',Grad,nGrad,1)
end if
#endif

return

end subroutine Distg1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoRPA_MOTra(includeFrozen,includeDeleted)

! Thomas Bondo Pedersen (CTCC,UiO), July 2013.
!
! Transform Cholesky vectors to MO basis.
!
! TODO/FIXME:
! 1. This routine computes all MO blocks (ij, ai, ab), even though
!    we may only need some of them. A more flexible interface would
!    be nice to have. Presumably not a performance issue in RPA,
!    though (remains to be verified).
! 2. For unrestricted calculations, the alpha and beta
!    transformations are done separately, which means that the AO
!    vectors are read twice. Simultaneous transformation would be
!    desirable!

use RPA_globals, only: CMO, nBas, nDel, nFro, nOcc, nOrb, nSym, nVir
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: includeFrozen, includeDeleted
integer(kind=iwp) :: nSpin, iSym, l_lCMO, lnFro, lnOcc, Zeros, lnVir, lnDel, iSpin
character(len=6) BName(2)
integer(kind=iwp), allocatable :: loc(:,:)
real(kind=wp), allocatable :: lCMO(:)
integer(kind=iwp), external :: RPA_iUHF
character(len=*), parameter :: SecNam = 'ChoRPA_MOTra'

nSpin = RPA_iUHF()
if (nSpin == 1) then
  BName(1) = 'MOVECS'
  BName(2) = 'unused'
else if (nSpin == 2) then
  BName(1) = 'MOVECa'
  BName(2) = 'MOVECb'
else
  call RPA_Warn(3,SecNam//': illegal nSpin')
  BName(1) = 'unused'
  BName(2) = 'unused'
end if
l_lCMO = nBas(1)**2
do iSym=2,nSym
  l_lCMO = l_lCMO+nBas(iSym)**2
end do
call mma_allocate(lCMO,l_lCMO,label='locCMO')
call mma_allocate(loc,nSym,5,label='local')
lnFro = 1
lnOcc = 2
Zeros = 3
lnVir = 4
lnDel = 5
loc(:,Zeros) = 0
if (includeFrozen) lnFro = Zeros
if (includeDeleted) lnDel = Zeros

do iSpin=1,nSpin

  ! Set orbital blocks
  if (includeFrozen) then
    do iSym=1,nSym
      loc(iSym,lnOcc) = nFro(iSym,iSpin)+nOcc(iSym,iSpin)
    end do
  else
    loc(:,lnFro) = nFro(:,iSpin)
    loc(:,lnOcc) = nOcc(:,iSpin)
  end if
  if (includeDeleted) then
    do iSym=1,nSym
      loc(:,lnVir-1+iSym) = nVir(iSym,iSpin)+nDel(iSym,iSpin)
    end do
  else
    loc(:,lnVir) = nVir(:,iSpin)
    loc(:,lnDel) = nDel(:,iSpin)
  end if
  ! Reorder CMO array
  call ChoRPA_MOTra_ReorderCMO(nSym,nBas,nOrb,CMO(:,iSpin),lCMO)
  ! Set base name for MO files
  ! Transform Cholesky vectors
  call Cho_MOTra_Inner(lCMO,l_lCMO,nSym,nBas,loc(:,lnFro),loc(:,lnOcc),loc(:,Zeros),loc(:,lnVir),loc(:,lnDel),BName(iSpin), &
                       .false.,0,.false.)

end do

call mma_deallocate(lCMO)
call mma_deallocate(loc)

end subroutine ChoRPA_MOTra

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_SyncNumCho(NumCho,nSym)
!
! Purpose: sync global NumCho_G vector counter. On entry, NumCho is
!          the local counter (unchanged).

use Cholesky, only: Cho_Real_Par, NumCho_G, NumChT_G, tMisc
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, NumCho(nSym)
real(kind=wp) :: c1, c2, w1, w2

if (Cho_Real_Par) then
  call CWTime(c1,w1)
  NumCho_G(1:nSym) = NumCho(1:nSym)
  call Cho_GAIGop(NumCho_G,nSym,'max')
  NumChT_G = sum(NumCho_G(1:nSym))
  call CWTime(c2,w2)
  tMisc(1,5) = tMisc(1,5)+c2-c1
  tMisc(2,5) = tMisc(2,5)+w2-w1
end if

end subroutine Cho_P_SyncNumCho

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine ChkInp_m()
************************************************************************
*                                                                      *
*     Check the input for obvious errors or violation of limits        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "gas.fh"
#include "general.fh"
#include "output_ras.fh"
#include "warnings.fh"
      Parameter (ROUTINE='ChkInp  ')
*----------------------------------------------------------------------*
C Local print level (if any)
      IERR=0
      If ( NTOT.gt.mxOrb ) Then
        Write(LF,*)
        Write(LF,*)          '************ ERROR ******************'
        Call WarningMessage(2,'Too many orbitals.')
        Write(LF,'(1X,A,I8)')'Too many orbitals NTOT=',NTOT
        Write(LF,'(1X,A,I8)')'Limit is MXORB=',MXORB
        Write(LF,*)          '*************************************'
        IERR=1
      End If
      If ( NAC.gt.mxAct ) then
        Write(LF,*)
        Write(LF,*)          '*************** ERROR ***************'
        Call WarningMessage(2,'Too many active orbitals.')
        Write(LF,'(1X,A,I8)')'Too many active orbitals NAC=',NAC
        Write(LF,'(1X,A,I8)')'Limit is MXACT=',MXACT
        Write(LF,*)          '*************************************'
        IERR=1
      Endif
      If ( NIN.gt.mxIna ) then
        Write(LF,*)
        Write(LF,*)          '*************** ERROR ***************'
        Call WarningMessage(2,'Too many inactive orbitals.')
        Write(LF,'(1X,A,I8)')'Too many inactive orbitals NIN=',NIN
        Write(LF,'(1X,A,I8)')'Limit is MXINA=',MXINA
        Write(LF,*)          '*************************************'
        IERR=1
      Endif
      If(NACTEL.gt.2*NAC) then
        Write(LF,*)
        Write(LF,*)'********************* ERROR **********************'
        Call WarningMessage(2,'Too many active electrons.')
        Write(LF,'(1X,A,I6)')'Too many active electrons NACTEL=',NACTEL
        Write(LF,'(1X,A,I6)')
     &             'Cannot be more than 2*Nr of active orbitals=',2*NAC
        Write(LF,*)'**************************************************'
        IERR=1
      Endif
      If(NHOLE1.gt.2*NRS1T) then
        Write(LF,*)
        Write(LF,*)'******************** WARNING *********************'
        Call WarningMessage(1,'Too many holes in Ras1.')
        Write(LF,'(1X,A,I6)')
     &             'You allow too many holes in Ras1 NHOLE1=',NHOLE1
        Write(LF,'(1X,A,I6)')
     &             'Cannot be more than 2*Nr of Ras1 orbitals=',2*NRS1T
        NHOLE1=2*NRS1T
        Write(LF,'(1X,A,I6)')
     &             'NHOLE1 has been reset to ',NHOLE1
        Write(LF,*)'**************************************************'
      Endif
      If(NELEC3.gt.2*NRS3T) then
        Write(LF,*)
        Write(LF,*)'******************** WARNING *********************'
        Call WarningMessage(1,'Too many electrons in Ras3.')
        Write(LF,'(1X,A,I6)')
     &             'You allow too many electrons in Ras3 NELEC3=',NELEC3
        Write(LF,'(1X,A,I6)')
     &             'Cannot be more than 2*Nr of Ras3 orbitals=',2*NRS3T
        NELEC3=2*NRS3T
        Write(LF,'(1X,A,I6)')
     &             'NELEC3 has been reset to ',NELEC3
        Write(LF,*)'**************************************************'
      Endif
      if(.not.iDoGas)then !(DM)
        If(NACTEL.gt.2*(NRS1T+NRS2T)+NELEC3) then
         Write(LF,*)
         Write(LF,*)'********************* ERROR **********************'
         Call WarningMessage(2,'Too many active electrons.')
         Write(LF,'(1X,A,I8)')
     &              'Too many active electrons NACTEL=',NACTEL
         Write(LF,'(1X,A,I8)')
     &              '(Incompatible with RAS restrictions).'
         Write(LF,*)'**************************************************'
         IERR=1
        End If
        If(NACTEL.lt.2*NRS1T-NHOLE1) then
         Write(LF,*)
         Write(LF,*)'********************* ERROR **********************'
         Call WarningMessage(2,'Too few active electrons.')
         Write(LF,'(1X,A,I8)')
     &              'Too few active electrons NACTEL=',NACTEL
         Write(LF,'(1X,A,I8)')
     &              '(Incompatible with RAS restrictions).'
         Write(LF,*)'**************************************************'
         IERR=1
        End If
        If(NHOLE1.eq.0.and.NRS1T.gt.0) then
         Write(LF,*)
         Write(LF,*) '******************* WARNING *******************'
         Call WarningMessage(1,'You allow no holes in Ras1')
         Write(LF,*) 'You allow no holes in Ras1.                    '
         Write(LF,*) 'This may be deliberate, but may give numerical '
         Write(LF,*) 'problems in SXCTL section.'
         Write(LF,*) '***********************************************'
        Endif
        If (NELEC3.eq.0.and.NRS3T.gt.0) then
         Write(LF,*)
         Write(LF,*) '******************* WARNING *******************'
         Call WarningMessage(1,'You allow no electrons in Ras3')
         Write(LF,*) 'You allow no electrons in Ras3.'
         Write(LF,*) 'This may be deliberate, but may give numerical '
         Write(LF,*) 'problems in SXCTL section.'
         Write(LF,*) '***********************************************'
        Endif
* for GAS
      else
       if(nactel.ne.igsoccx(ngas,2))then
        write(lf,*)
        write(lf,*)'**************** ERROR *************************'
        write(lf,*)'nactel not match occupation'
        write(lf,*)'nactel=',nactel,'igsoccx:',igsoccx(ngas,2)
        write(lf,*)'************************************************'
       endif
      endif
      If (NSYM.ne.1 .and. NSYM.ne.2 .and.
     &    NSYM.ne.4 .and. NSYM.ne.8) Then
        Write(LF,*)
        Call WarningMessage(2,'Wrong nr of symmetries.')
        Write(LF,*)          '*************** ERROR ***************'
        Write(LF,'(1X,A,I8)')'Nr of symmetries NSYM=',NSYM
        Write(LF,*)          ' Only possible values are 1,2,4 or 8.'
        Write(LF,*)          '*************************************'
        IERR=1
      End If
      If (IERR.eq.1) Call Quit(_RC_INPUT_ERROR_)

      IERR1=0
      Do iSym=1,nSym
         If ( nBas(iSym).lt.0 ) IERR1=1
         If ( nFro(iSym).lt.0 ) IERR1=1
         If ( nDel(iSym).lt.0 ) IERR1=1
         If ( nOrb(iSym).lt.0 ) IERR1=1
         If ( nISh(iSym).lt.0 ) IERR1=1
         If ( nASh(iSym).lt.0 ) IERR1=1
         If ( nSSh(iSym).lt.0 ) IERR1=1
         If ( nRS1(iSym).lt.0 ) IERR1=1
         If ( nRS2(iSym).lt.0 ) IERR1=1
         If ( nRS3(iSym).lt.0 ) IERR1=1
      End Do
      IERR2=0
      Do iSym=1,nSym
         If ( nBas(iSym).gt.mxBas ) IERR2=1
         If ( nFro(iSym).gt.mxBas ) IERR2=1
         If ( nDel(iSym).gt.mxBas ) IERR2=1
         If ( nOrb(iSym).gt.mxBas ) IERR2=1
         If ( nISh(iSym).gt.mxBas ) IERR2=1
         If ( nASh(iSym).gt.mxBas ) IERR2=1
         If ( nSSh(iSym).gt.mxBas ) IERR2=1
         If ( nRS1(iSym).gt.mxBas ) IERR2=1
         If ( nRS2(iSym).gt.mxBas ) IERR2=1
         If ( nRS3(iSym).gt.mxBas ) IERR2=1
      End Do
      If (IERR1+IERR2.gt.0) Then
        Write(LF,*)
        Write(LF,*)'****************** ERROR *******************'
        Call WarningMessage(2,'Erroneous nr of orbitals.')
        Write(LF,*)'Inappropriate nr of orbitals. One or more of'
        Write(LF,*)'these orbital counts is wrong or too large.'
        If (IERR1.gt.0) Write(LF,*)' Negative values.'
        If (IERR2.gt.0) Write(LF,*)' Extremely large values.'
        Write(LF,'(1X,A,8I4)')
     &   '   All orbitals:',(NBAS(ISYM),ISYM=1,NSYM)
        Write(LF,'(1X,A,8I4)')
     &   '         Frozen:',(NFRO(ISYM),ISYM=1,NSYM)
        Write(LF,'(1X,A,8I4)')
     &   '       Inactive:',(NISH(ISYM),ISYM=1,NSYM)
        Write(LF,'(1X,A,8I4)')
     &   '         Active:',(NASH(ISYM),ISYM=1,NSYM)
        Write(LF,'(1X,A,8I4)')
     &   '          RAS-1:',(NRS1(ISYM),ISYM=1,NSYM)
        Write(LF,'(1X,A,8I4)')
     &   '          RAS-2:',(NRS2(ISYM),ISYM=1,NSYM)
        Write(LF,'(1X,A,8I4)')
     &   '          RAS-3:',(NRS3(ISYM),ISYM=1,NSYM)
        Write(LF,'(1X,A,8I4)')
     &   '      Secondary:',(NSSH(ISYM),ISYM=1,NSYM)
        Write(LF,'(1X,A,8I4)')
     &   '        Deleted:',(NDEL(ISYM),ISYM=1,NSYM)
        Write(LF,'(1X,A,8I4)')
     &   'Basis functions:',(NBAS(ISYM),ISYM=1,NSYM)
        If (IERR1.gt.0) Then
         Write(LF,*)' Have you used a too small basis set?'
        End If
        Write(LF,*)'********************************************'
        Call Quit(_RC_INPUT_ERROR_)
      End If

      IERR=0
      IB0=ISPIN-1
      IA0=(NACTEL-IB0)/2
      IC0=(NAC-IA0-IB0)
      If ( (2*IA0+IB0).ne.NACTEL ) IERR=1
      If ( IA0.lt.0 ) IERR=1
      If ( IB0.lt.0 ) IERR=1
      If ( IC0.lt.0 ) IERR=1
      If (IERR.eq.1) Then
        Write(LF,*)
        Write(LF,*)'******************** ERROR *********************'
        Call WarningMessage(2,'No such wave function.')
        Write(LF,*)'The following combined specifications are wrong.'
        Write(LF,'(1X,A,8I4)')'Nr of active electrons NACTEL=',NACTEL
        Write(LF,'(1X,A,8I4)')'Nr of active orbitals     NAC=',NAC
        Write(LF,'(1X,A,8I4)')'Spin degeneracy         ISPIN=',ISPIN
        Write(LF,*)'There can be no such wave function.'
        Write(LF,*)'************************************************'
        Call Quit(_RC_INPUT_ERROR_)
      End If

      If ( MAXIT.gt.mxIter ) Then
        Write(LF,*)
        Write(LF,*)          '*************** WARNING ****************'
        Call WarningMessage(1,'Too many macro-iterations.')
        Write(LF,*)          'Too many macro-iterations requested.'
        MAXIT=MXITER
        Write(LF,'(1X,A,I8)')'Reset to maximum, new MAXIT=',MAXIT
        Write(LF,*)          '****************************************'
      End If
      If ( MAXJT.gt.(mxCiIt-2) ) Then
        Write(LF,*)
        Write(LF,*)          '*************** WARNING ****************'
        Call WarningMessage(1,'Too many CI-iterations.')
        Write(LF,*)          'Too many CI-iterations requested.'
        MAXJT=mxCiIt-2
        Write(LF,'(1X,A,I8)')'Reset to maximum, new MAXJT=',MAXJT
        Write(LF,*)          '****************************************'
      End If
      If ( ITMAX.gt.MXSXIT ) Then
        Write(LF,*)
        Write(LF,*)          '*************** WARNING ****************'
        Call WarningMessage(1,'Too many SX-iterations.')
        Write(LF,*)          'Too many SX-iterations requested.'
        ITMAX=MXSXIT
        Write(LF,'(1X,A,I8)')'Reset to maximum, new ITMAX=',ITMAX
        Write(LF,*)          '****************************************'
      End If

      THRE =MAX(0.0D0,THRE )
      THRTE=MAX(0.0D0,THRTE)
      THRSX=MAX(0.0D0,THRSX)
      THREN=MAX(0.0D0,THREN)
      THFACT=MAX(0.0D0,THFACT)

      IERR=0
      If ( NROOTS.gt.mxRoot ) IERR=1
      If ( LROOTS.gt.mxRoot ) IERR=1
      If (IERR.eq.1) Then
        Write(LF,*)
        Write(LF,*) '***************** ERROR *****************'
        Call WarningMessage(2,'Max roots exceeded.')
        Write(LF,'(1X,A,I6)')'Input Error: Max roots exceeded.',
     &                        mxRoot
        Write(LF,'(1X,A,I4)')'Nr of CI roots        LROOTS=',LROOTS
        Write(LF,'(1X,A,I4)')'Nr of optimized roots NROOTS=',NROOTS
        Write(LF,*)'************************************************'
        Call Quit(_RC_INPUT_ERROR_)
      End If
      Do i=1,NROOTS
         If ( IROOT(i).lt.0 .or. IROOT(i).gt.LROOTS ) IERR=1
      End Do
      If (IERR.eq.1) Then
        Write(LF,*)
        Write(LF,*) '***************** ERROR *****************'
        Call WarningMessage(2,'Root specifications are wrong.')
        Write(LF,*)'CHKINP Error: Root specifications are wrong.'
        Write(LF,'(1X,A,I4)')'Nr of CI roots        LROOTS=',LROOTS
        Write(LF,'(1X,A,I4)')'Nr of optimized roots NROOTS=',NROOTS
        Write(LF,*)'************************************************'
        Call Quit(_RC_INPUT_ERROR_)
      End If

      IERR=0
      If (NSYM.ne.1 .and. NSYM.ne.2 .and. NSYM.ne.4
     &                              .and. NSYM.ne.8) IERR=1
      If (LSYM.GT.NSYM) IERR=1
      If (IERR.eq.1) Then
        Write(LF,*)
        Write(LF,*) '***************** ERROR *****************'
        Call WarningMessage(2,'Wrong symmetry.')
        Write(LF,'(1X,A,I8)')'CHKINP Error: Wrong symmetry.'
        Write(LF,'(1X,A,I8)')'State symmetry    LSYM=',LSYM
        Write(LF,'(1X,A,I8)')'Point group order NSYM=',NSYM
        Write(LF,*)'************************************************'
        Call Quit(_RC_INPUT_ERROR_)
      End If

      If ( NSEL.LT.LROOTS+1 ) Then
        Write(LF,*)
        Write(LF,*) '***************** WARNING ***************'
        Call WarningMessage(1,'Too small explicit Hamiltonian.')
        Write(LF,*)'CHKINP Warning: Too small explicit Hamiltonian.'
        Write(LF,'(1X,A,I8)')'Nr of CI roots LROOTS=',LROOTS
        Write(LF,'(1X,A,I8)')'You requested NSEL=',NSEL
        NSEL=LROOTS+1
        Write(LF,'(1X,A,I8)')'It has been reset to NSEL=',NSEL
        Write(LF,*)'************************************************'
      End If

      IERR=0
      If ( NHOLE1.lt.0 .and. NRS1T.ne.0 ) IERR=1
      If ( NELEC3.lt.0 .and. NRS3T.ne.0 ) IERR=1
      If ( NACTEL.lt.0 .and. NRS2T.ne.0 ) IERR=1
      If (IERR.eq.1) Then
        Write(LF,*)
        Write(LF,*)          '***************** ERROR *****************'
        Call WarningMessage(2,'Error in RAS specification.')
        Write(LF,*)          'Error in RAS specification.'
        Write(LF,'(1X,A,I8)')'Max holes in Ras1,     NHOLE1=',NHOLE1
        Write(LF,'(1X,A,I8)')'Max electrons in Ras3, NELEC3=',NELEC3
        Write(LF,'(1X,A,I8)')'Nr of active electrons NACTEL=',NACTEL
        Write(LF,*)          '*****************************************'
        Call Quit(_RC_INPUT_ERROR_)
      End If

      If ( IPT2.eq.1 ) Then
        If (NHOLE1.ne.0 .or. NELEC3.ne.0) Then
          Write(LF,*)
          Write(LF,*)'******************* WARNING *******************'
          Call WarningMessage(1,'''Quasi-canonical'' is ignored.')
          Write(LF,*)'You requested quasicanonical orbitals, but this'
          Write(LF,*)'is not possible with a true RASSCF calculation.'
          Write(LF,*)'Your request will be ignored.                  '
          Write(LF,*)'***********************************************'
          IPT2=0
        End If
      End If

CGG Sep 03 Check ALTEr
      If ( NAlter.gt.0 ) Then
        Do iAlter=1,NAlter
          If ( MAlter(iAlter,1).lt.1.or.MAlter(iAlter,1).gt.NSym ) Then
            Write(LF,*)
            Write(LF,*)'***************** ERROR *****************'
            Call WarningMessage(1,'MAlter input is wrong.')
            Write(LF,*)'Wrong symmetry specie in pair ',iAlter
            Write(LF,*)'*****************************************'
            Call Quit(_RC_INPUT_ERROR_)
          EndIf
          If ( MAlter(iAlter,2).lt.1.or.MAlter(iAlter,3).lt.1 ) Then
            Write(LF,*)
            Write(LF,*)'***************** ERROR *****************'
            Call WarningMessage(1,'MAlter input is wrong.')
            Write(LF,*)'Wrong orbital to exchange in pair ',iAlter
            Write(LF,*)'*****************************************'
            Call Quit(_RC_INPUT_ERROR_)
          EndIf
          If ( MAlter(iAlter,2).gt.nBas(MAlter(iAlter,1)) .or.
     &    MAlter(iAlter,3).gt.nBas(MAlter(iAlter,1)) ) Then
            Write(LF,*)
            Write(LF,*)'***************** ERROR *****************'
            Call WarningMessage(1,'MAlter input is wrong.')
            Write(LF,*)'Wrong orbital to exchange in pair ',iAlter
            Write(LF,*)'*****************************************'
            Call Quit(_RC_INPUT_ERROR_)
          EndIf
        EndDo
      EndIf

CBOR  Check INVEC
      If (INVEC.lt.0.or.INVEC.gt.6) then
        Write(LF,*)
        Write(LF,*)'************* ERROR ***************'
* This should be impossible:...
        Call WarningMessage(2,'Keyword for start orbitals is missing.')
        Write(LF,*)'Keyword for start orbitals missing.'
        Write(LF,*)'Use either CORE, LUMORB, or JOBIPH.'
        Write(LF,*)'***********************************'
        Call Quit(_RC_INPUT_ERROR_)
      Endif

* PAM Krapperup Nov 05: Orbital print format.
* First question: Which orbital spaces are eligible for printing?
      IF (OutFmt1.eq.'DEFAULT ') then
* No user selection, so fall back on default choice.
        OutFmt1='FEW     '
      END IF
* Second question: How should they be printed?
      IF (OutFmt2.eq.'DEFAULT ') then
* No user selection, so fall back on default choice.
       IF(NTOT.LT.256) THEN
         OutFmt2='FULL    '
       ELSE
         OutFmt2='COMPACT '
       END IF
      END IF
* Third: has the user provided input for energy/occupation thresholds?
* A negative PROTHR shows no user value was given in input.
      IF (PROTHR.LT.0.0D0) THEN
        IF (OutFmt1.eq.'ALL     ') Then
          PROTHR=0.0D0
          PRETHR=1.0D100
        ELSE
* Else, format is FEW or NOCORE (or NOTHING, but then nothing is printed)
          PROTHR=0.0D0
          PRETHR=0.15D0
        END IF
      END IF
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GenRadQuad_PAM(nR_Eff,mr,Alpha,Process,QuadR,nQuadR)

use nq_Info, only: R_Max
use Constants, only: Zero, One, Two, Three, Four, Ten, Pi
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(out) :: nR_Eff
real(kind=wp), intent(in) :: mr(2), Alpha(2)
integer(kind=iwp), intent(in) :: nQuadR
real(kind=wp), intent(out) :: QuadR(2,nQuadR)
logical(kind=iwp) :: Process
integer(kind=iwp) :: i, iR, k, l_Max, n_High
real(kind=wp) :: a, Alpha_Max, Alpha_Min, C1, C2, Correction, D_m, Dr, Gmma, ggg, h, h_, ln_rn, r1, R_D_0, Relative_Max_Error, rk, &
                 rn
real(kind=wp), external :: G

! Last point at infinity is eliminated

#ifdef _DEBUGPRINT_
write(u6,*) 'New Algorithm (Malmqvist)'
#endif

! Reading of the data
Alpha_Min = Alpha(1)
Alpha_Max = Alpha(2)
l_Max = 2*int(mr(1))
#ifdef _DEBUGPRINT_
write(u6,*) 'l_Max=',l_Max
#endif
Relative_Max_Error = mr(2)
#ifdef _DEBUGPRINT_
write(u6,*) 'Relative_Max_Error=',Relative_Max_Error
#endif

! Compute an approximative R_D_0

Dr = Zero
h = Zero
do k=0,l_Max,l_Max-1
  R_D_0 = Relative_Max_Error/(Ten**k)
  Dr = -log10(R_D_0)

  ! Starting value of h

  h = One/(0.47_wp*Dr+0.93_wp)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute a correct h for the approximative R_D_0

  C1 = Four*sqrt(Two)*Pi
  C2 = Pi**2/Two
  do
    h_ = C2/(-log(Ten**(-Dr)*h/C1))
    if (abs(h_-h) <= 1.0e-4_wp) exit
    h = h_
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Now find h from the correct R_D, i.e. from the highest
  ! angular momentum available.

  Dr = -log10(Relative_Max_Error)
  do
    h_ = C2/(-log(Ten**(-Dr)*(h/C1)*(h/Pi)**(real(k,kind=wp)/Two)*(G((real(k,kind=wp)+Three)/Two)/G(Three/Two))))

#   ifdef _DEBUGPRINT_
    write(u6,*) 'h h_ ',h,h_
#   endif
    if (abs(h_-h) <= 1.0e-5_wp) exit
    h = h_
  end do

# ifdef _DEBUGPRINT_
  if (k == 0) h0 = h
# endif
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute table of R_Max as a function of l

do i=l_Max,0,-2
  D_m = -Four
  if (l_Max == 4) D_m = -2.3_wp
  if (l_Max == 2) D_m = -One
  if (l_Max == 0) D_m = 1.9_wp
  if (l_Max == -2) D_m = 9.1_wp

  ggg = (Two/(real(i,kind=wp)+Three))*(D_m-log(One/Ten**(-Dr)))
  R_Max(i) = sqrt(exp(ggg)/Alpha_Max)
# ifdef _DEBUGPRINT_
  write(u6,*) 'i        =',i
  write(u6,*) 'l_Max    =',l_Max
  write(u6,*) 'ggg      =',ggg
  write(u6,*) 'R_Max(i) =',R_Max(i)
# endif
end do
#ifdef _DEBUGPRINT_
write(u6,*) 'h0,h=',h0,h
#endif

! For hybrid grid use R_Max for l=0 and h for l=l_max
! r1=R_Max(l_Max)
r1 = R_Max(0)
ln_rn = 1.7_wp-log(Alpha_Min)/Two
rn = exp(ln_rn)
Gmma = r1/(exp(h)-One)
n_High = int(log(rn/Gmma+One)/h+One)
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'r1,Alpha_Min    =',r1,Alpha_Min
write(u6,*) 'rn,Alpha_Max    =',rn,Alpha_MAx
write(u6,*) 'h,Dr,n_High     =',h,Dr,n_High
#endif

! Store the radius and the associated weights

iR = 0
do k=0,n_High
  a = real(k,kind=wp)*h
  rk = Gmma*(exp(a)-One)
  ! Note that the point at r=0 is eliminated
  if (rk /= Zero) then
    iR = iR+1
    if (Process) then
      QuadR(1,ir) = rk
      Correction = One

      ! Gregorious correction for points close to the nuclei

      if (k == 0) Correction = 46.0_wp/120.0_wp
      if (k == 1) Correction = 137.0_wp/120.0_wp
      if (k == 2) Correction = 118.0_wp/120.0_wp
      if (k == 3) Correction = 119.0_wp/120.0_wp

      QuadR(2,ir) = h*(rk+Gmma)*Correction
      QuadR(2,ir) = QuadR(1,ir)**2*QuadR(2,ir)
    end if
  end if

end do
! Store the value of the maximum radius to which we should integrate
! for the partitionning and the number of effective radii.
nR_Eff = iR

return

end subroutine GenRadQuad_PAM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_DBGINT_CHO(XINT,NCD,NAB,WRK,LWRK,ERRMAX,ERRMIN,ERRRMS,NCMP,ISHLCD,ISHLAB)
!
! Purpose: calculate integrals in shell quadruple (CD|AB) from
!          Cholesky vectors on disk and compare to those in
!          XINT (for debugging).
!
! NOTE: this is *only* for debugging.

use Index_Functions, only: nTri_Elem
use Cholesky, only: iiBstR, iiBstRSh, IndRed, iSP2F, nBstSh, nnBstR, nnBstRSh, nSym, nSys_call, NumCho
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NCD, NAB, LWRK, ISHLCD, ISHLAB
real(kind=wp), intent(in) :: XINT(NCD,NAB)
real(kind=wp), intent(out) :: WRK(LWRK), ERRMAX, ERRMIN, ERRRMS
integer(kind=iwp), intent(out) :: NCMP
integer(kind=iwp) :: IAB, IBATCH, ICD, ICDAB, ISHLA, ISHLB, ISHLC, ISHLD, ISYM, IVEC, JAB, JCD, JVEC, JVEC1, KAB, KCD, KCDAB, &
                     KCHOAB, KCHOCD, KEND0, KEND1, KEND2, KINT, KOFF1, KOFF2, KREAD, KVEC1, KXINT, LCDABT, LENint, LREAD, LVEC1, &
                     LWRK0, LWRK1, LWRK2, MINM, NABL, NBATCH, NCDL, NSCALL, NUMAB, NUMCD, NUMV, NVEC
real(kind=wp) :: DIFF
character(len=*), parameter :: SECNAM = 'CHO_DBGINT_CHO'
integer(kind=iwp), external :: CHO_LREAD

! Initializations.
! ----------------

call CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.true.)
call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)
ERRMAX = -1.0e12_wp
ERRMIN = 1.0e12_wp
ERRRMS = Zero
NCMP = 0
LCDABT = NCD*NAB

if (ISHLC == ISHLD) then
  NCDL = nTri_Elem(NBSTSH(ISHLC))
else
  NCDL = NBSTSH(ISHLC)*NBSTSH(ISHLD)
end if
if (ISHLA == ISHLB) then
  NABL = nTri_Elem(NBSTSH(ISHLA))
else
  NABL = NBSTSH(ISHLA)*NBSTSH(ISHLB)
end if
if (NCDL > NCD) call CHO_QUIT('NCD error in '//SECNAM,104)
if (NABL > NAB) call CHO_QUIT('NAB error in '//SECNAM,104)
if ((NAB < 1) .or. (NCD < 1)) return

! Save read-call counter.
! -----------------------

NSCALL = NSYS_CALL

! Get a copy of XINT.
! -------------------

KXINT = 1
KEND0 = KXINT+LCDABT
LWRK0 = LWRK-KEND0
if (LWRK0 <= 0) call CHO_QUIT('Insufficient memory in '//SECNAM//' [0]',101)

WRK(1:LCDABT) = reshape(XINT(:,:),[LCDABT])

! Start symmetry loop.
! --------------------

do ISYM=1,NSYM

  NUMCD = NNBSTRSH(ISYM,ISHLCD,2)
  NUMAB = NNBSTRSH(ISYM,ISHLAB,2)

  if ((NUMCD > 0) .and. (NUMAB > 0) .and. (NUMCHO(ISYM) > 0)) then

    ! Allocate space for integrals and for Cholesky reading.
    ! ------------------------------------------------------

    LENint = NUMCD*NUMAB
    LREAD = CHO_LREAD(ISYM,LWRK)
    LVEC1 = NNBSTR(ISYM,2)

    KINT = KEND0
    KREAD = KINT+LENint
    KVEC1 = KREAD+LREAD
    KEND1 = KVEC1+LVEC1
    LWRK1 = LWRK-KEND1+1

    if (LWRK1 <= 0) call CHO_QUIT('Insufficient memory in '//SECNAM,104)

    ! Initialize integral array.
    ! --------------------------

    WRK(KINT:KINT+LENint-1) = Zero

    ! Set up batch over Cholesky vectors.
    ! -----------------------------------

    MINM = NUMCD+NUMAB
    NVEC = min(LWRK1/MINM,NUMCHO(ISYM))
    if (NVEC < 1) call CHO_QUIT('Batch problem in '//SECNAM,104)
    NBATCH = (NUMCHO(ISYM)-1)/NVEC+1

    ! Start batch loop.
    ! -----------------

    do IBATCH=1,NBATCH

      if (IBATCH == NBATCH) then
        NUMV = NUMCHO(ISYM)-NVEC*(NBATCH-1)
      else
        NUMV = NVEC
      end if
      JVEC1 = NVEC*(IBATCH-1)+1

      KCHOCD = KEND1
      KCHOAB = KCHOCD+NUMCD*NUMV
      KEND2 = KCHOAB+NUMAB*NUMV
      LWRK2 = LWRK-KEND2+1

      if (LWRK2 < 0) call CHO_QUIT('Batch error in '//SECNAM,104)

      ! Read vectors.
      ! -------------

      do IVEC=1,NUMV
        JVEC = JVEC1+IVEC-1
        call CHO_GETVEC(WRK(KVEC1),LVEC1,1,JVEC,ISYM,WRK(KREAD),LREAD)
        KOFF1 = KVEC1+IIBSTRSH(ISYM,ISHLCD,2)
        KOFF2 = KCHOCD+NUMCD*(IVEC-1)
        WRK(KOFF2:KOFF2+NUMCD-1) = WRK(KOFF1:KOFF1+NUMCD-1)
        KOFF1 = KVEC1+IIBSTRSH(ISYM,ISHLAB,2)
        KOFF2 = KCHOAB+NUMAB*(IVEC-1)
        WRK(KOFF2:KOFF2+NUMAB-1) = WRK(KOFF1:KOFF1+NUMAB-1)
      end do

      ! Calculate contribution.
      ! -----------------------

      call DGEMM_('N','T',NUMCD,NUMAB,NUMV,One,WRK(KCHOCD),NUMCD,WRK(KCHOAB),NUMAB,One,WRK(KINT),NUMCD)

    end do

    ! Subtract contribution from full shell pair.
    ! -------------------------------------------

    do IAB=1,NUMAB
      JAB = IIBSTR(ISYM,2)+IIBSTRSH(ISYM,ISHLAB,2)+IAB
      KAB = INDRED(INDRED(JAB,2),1)
      do ICD=1,NUMCD
        JCD = IIBSTR(ISYM,2)+IIBSTRSH(ISYM,ISHLCD,2)+ICD
        KCD = INDRED(INDRED(JCD,2),1)
        ICDAB = KINT+NUMCD*(IAB-1)+ICD-1
        KCDAB = KXINT+NCD*(KAB-1)+KCD-1
        WRK(KCDAB) = WRK(KCDAB)-WRK(ICDAB)
      end do
    end do

  end if

end do

! Compare full shell pair.
! ------------------------

do KAB=1,NAB
  do KCD=1,NCD
    KCDAB = KXINT+NCD*(KAB-1)+KCD-1
    DIFF = WRK(KCDAB)
    NCMP = NCMP+1
    if (NCMP == 1) then
      ERRMAX = DIFF
      ERRMIN = DIFF
    else
      if (abs(DIFF) > abs(ERRMAX)) ERRMAX = DIFF
      if (abs(DIFF) < abs(ERRMIN)) ERRMIN = DIFF
    end if
    ERRRMS = ERRRMS+DIFF*DIFF
  end do
end do

! Restore read-call counter.
! --------------------------

NSYS_CALL = NSCALL

end subroutine CHO_DBGINT_CHO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CONF_VERTEX_W(IOCC_MIN,IOCC_MAX,NORB,NEL,IVERTEXW)
! Obtain vertex weights for configuration graph
!
! Jeppe Olsen, October 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NORB, IOCC_MIN(NORB), IOCC_MAX(NORB), NEL
integer(kind=iwp), intent(out) :: IVERTEXW(NORB+1,NEL+1)
integer(kind=iwp) :: IEL, IORB

!write(u6,*) ' CONF_VERTEX : NORB, NEL = ',NORB,NEL
IVERTEXW(:,:) = 0
IVERTEXW(1,1) = 1
do IORB=1,NORB
  !Jesper DO IEL=0,NEL
  do IEL=IOCC_MIN(IORB),IOCC_MAX(IORB)
    !Jesper if ((IOCC_MIN(IORB) <= IEL) .and. (IEL <= IOCC_MAX(IORB))) then

    if (IEL == 0) IVERTEXW(IORB+1,IEL+1) = IVERTEXW(IORB-1+1,IEL+1)

    if (IEL == 1) IVERTEXW(IORB+1,IEL+1) = IVERTEXW(IORB-1+1,IEL+1)+IVERTEXW(IORB-1+1,IEL+1-1)

    if (IEL >= 2) IVERTEXW(IORB+1,IEL+1) = IVERTEXW(IORB-1+1,IEL+1)+IVERTEXW(IORB-1+1,IEL+1-1)+IVERTEXW(IORB-1+1,IEL+1-2)

    !Jesper end if
  end do
end do
! Check whether a configuration has enough singly occupied orbitals
!Jesper ??? call REDUCE_VERTEX_WEIGHTS(IVERTEXW(NORB+1,NEL+1),IVERTEXW,NEL,NORB,IOCC_MIN,IOCC_MAX)

#ifdef _DEBUGPRINT_
write(u6,*) ' Vertex weights as an (NORB+1)*(NEL+1) matrix'
call IWRTMA(IVERTEXW,NORB+1,NEL+1,NORB+1,NEL+1)
#endif

end subroutine CONF_VERTEX_W

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine genprexyz8(preXZ)
      implicit real*8(a-h,o-z)
#include "para.fh"
#include "Molcas.fh"
      Dimension preXZ(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax)
cbs #####################################################################
cbs   additional (-) signs from the (-i) factors  in the
cbs   (-) linear combinations   (see tosigX(Y,Z).f)
cbs #####################################################################
cbs   - + - -   =>   minus
      do M4=-Lmax,-1
      do M3=-Lmax,-1
         do M2= 0,Lmax
c      do M1=-Lmax,-1
c           preXZ(m1,m2,m3,m4)=-preXZ(m1,m2,m3,m4)
            call dscal_(Lmax,-1d0,preXZ(-Lmax,m2,m3,m4),1)
c      enddo
         enddo
      enddo
      enddo
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
*   This file contains Fortran front-ends for the C timing routines:   *
*                                                                      *
*   (void)timingcinit()    : initialization                            *
*   (void)timingc(double elapse,double usercpu,double syscpu)          *
*                          : returns elapse, user cpu                  *
*                            and system cpu times                      *
*                                                                      *
*   (INT)iclock()          : returns (user) cpu clock ticks            *
*   (INT)inc_clock         : returns number of clock ticks per second  *
*                                                                      *
************************************************************************
      Subroutine Timing(CPUA,CPUE,TIOA,TIOE)
************************************************************************
*                                                                      *
*     This subroutine has two entry points. The first, called          *
*     SetTim is used to start a global timer. The second, called       *
*     Timing, returns the cpu time used since the timer has been       *
*     and, in addition the cpu time used since the timer has been      *
*     called the previous time.                                        *
*                                                                      *
*     calling arguments:                                               *
*     CPUA     : Type double precision real, output                    *
*                Cpu time since start of the timer                     *
*     CPUE     : Type double precision real, output                    *
*                CPU time since last call to Timing                    *
*     TIOA     : Type double precision real, output                    *
*                Wall clock time since start of timer                  *
*     TIOE     : Type double precision real, output                    *
*                Wall clock time since last call to timing             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark                                                     *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

#include "SysCtl.fh"
*
      Real*8 CPUA,CPUE,TIOA,TIOE
      REal*8 elapse,usercpu,syscpu

      call timingc(elapse,usercpu,syscpu)
* --- times relative to values in Common /$SysBuf/ --------------------*
      CPUA = usercpu-Heuer(1)
      CPUE = usercpu-Heuer(2)
      TIOA = elapse-Heuer(3)
      TIOE = elapse-Heuer(4)
* --- save current times in the Common /$SysBuf/ ----------------------*
      Heuer(2) = usercpu
      Heuer(4) = elapse
      Return
c
      entry SetTim
      call timingcinit()
      call timingc(elapse,usercpu,syscpu)
      Heuer(1) = usercpu
      Heuer(2) = usercpu
      Heuer(3) = elapse
      Heuer(4) = elapse
      ClkInc=inc_clock()
      Return
      End
c
      Function WallCl()
      Real*8 WallCl,elapse,usercpu,syscpu

      call timingc(elapse,usercpu,syscpu)
      WallCl=elapse
      Return
      End
c
      Function Seconds()
      Real*8 Seconds,elapse,usercpu,syscpu

      call timingc(elapse,usercpu,syscpu)
      Seconds=usercpu
      Return
      End
c
      SubRoutine CWTime(usercpu,elapse)
      Real*8 elapse,usercpu,syscpu

      call timingc(elapse,usercpu,syscpu)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine mk_G(G,GInv,nDimBC)
      use Slapaf_Info, only: dMass, Degen, Smmtrc
      use Slapaf_Parameters, only: Curvilinear, User_Def
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "constants2.fh"
*
      Real*8 G(nDimBC,nDimBC), GInv(nDimBC,nDimBC)
      Logical Auto

      Auto=.Not.User_Def
      nsAtom=SIZE(Smmtrc,2)
*                                                                      *
************************************************************************
*                                                                      *
*     Generate the mass tensor
*
      G(:,:)=Zero
      GInv(:,:)=Zero
      ii = 0
      Do i = 1, nsAtom
         Do ix = 1, 3
            If (Smmtrc(ix,i)) Then
               ii = ii + 1
               If (Auto.and..Not.Curvilinear) Then
                  G(ii,ii) = Degen(ix,i)/dMass(i)
               Else
                  G(ii,ii) = One/(Degen(ix,i)*dMass(i))
               End If
               GInv(ii,ii) = One/(G(ii,ii)*UTOAU)
            End If
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('G (cartesian)',' ',G,nDimBC,nDimBC)
      Call RecPrt('G-1 (cartesian)',' ',GInv,nDimBC,nDimBC)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000-2016, Valera Veryazov                             *
!***********************************************************************

subroutine f_inquire(filename,exists)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: filename
logical(kind=iwp), intent(out) :: exists
integer(kind=iwp) :: lRealName
character(len=256) :: RealName
#ifdef _SOLARIS_
integer(kind=iwp) :: n, irc
character(len=256) :: FTMP1, FTMP2

n = len(filename)
do
  if (filename(n:n) /= ' ') exit
  n = n-1
end do
n = n+1
ftmp1 = filename
ftmp1(n:n) = char(0)
exists = .true.
irc = -1
FTMP2 = ''
call PrgmTranslate(filename,RealName,lRealName)
FTMP1(1:lRealName) = RealName(1:lRealName)
!write(u6,*) 'before fndlnk', FTMP1
call fndlnk(irc,FTMP1,FTMP2)
if (irc /= 0) exists = .false.
#else

call PrgmTranslate(filename,RealName,lRealName)
!write(u6,*) 'Debug inquire:', RealName(1:lRealName)
inquire(file=RealName(1:lRealName),exist=exists)
#endif

return

end subroutine f_inquire

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DataSol(IDSolv)
C
C     Database of optical and physical data for various solvent.
C
      Implicit Real*8 (A-H,O-Z)
#include "rctfld.fh"
      Data One/1.0D0/, Zero/0.0d0/
C
C     Here begins the collection of data for each solvent.
      If(IDSolv.eq. 1) Then
C
C     Water
C
        Eps    = 78.39d0
        EpsInf = 1.776d0
        DerEps = -0.3562d0
        RSolv  = 1.385d0
        VMol   = 18.07d0
        TCE    = 2.57d-4
        STen   = 71.81d0
        DSTen  = 0.650d0
        CMF    = 1.277d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 3.348d-2
        NATyp  = 2
C     Atom O:
        NTT(1)    = 1
        RDiff(1) = 1.5d0
        KT(1)    = DKList(8)
        RWT(1)   = RList(8)
C     Atom H:
        NTT(2)    = 2
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C
      Else If(IDSolv.eq. 2) Then
C
C     Acetonitrile (Warning: RSolv and VMol for this solvent
C                   need to be checked)
C
        Eps    = 36.64d0
        EpsInf = 1.806d0
        DerEps = Zero
        RSolv  = 2.155d0
        VMol   = 53.68d0
        TCE    = 1.192d-3
        STen   = 36.47d0
        DSTen  = 1.373d0
        CMF    = 0.808d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 1.153d-2
        NATyp  = 3
C     Atom C:
        NTT(1)    = 2
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 3
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom N:
        NTT(3)    = 1
        RDiff(3) = 1.6d0
        KT(3)    = DKList(7)
        RWT(3)   = RList(7)
C
      Else If(IDSolv.eq. 3) Then
C
C     Methanol
C
        Eps    = 32.63d0
        EpsInf = 1.758d0
        DerEps = -0.1984d0
        RSolv  = 1.855d0
        VMol   = 40.7d0
        TCE    = 1.182d-3
        STen   = 22.12d0
        DSTen  = 1.154d0
        CMF    = 1.776d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 1.495d-2
        NATyp  = 3
C     Atom C:
        NTT(1)    = 1
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 4
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom O:
        NTT(3)    = 1
        RDiff(3) = 1.5d0
        KT(3)    = DKList(8)
        RWT(3)   = RList(8)
C
      Else If(IDSolv.eq. 4) Then
C
C     Ethanol
C
        Eps    = 24.55d0
        EpsInf = 1.847d0
        DerEps = -0.1510d0
        RSolv  = 2.180d0
        VMol   = 58.7d0
        TCE    = 1.103d-3
        STen   = 21.89d0
        DSTen  = 1.146d0
        CMF    = 1.543d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 1.032d-2
        NATyp  = 3
C     Atom C:
        NTT(1)    = 2
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 6
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom O:
        NTT(3)    = 1
        RDiff(3) = 1.5d0
        KT(3)    = DKList(8)
        RWT(3)   = RList(8)
C
      Else If(IDSolv.eq. 5) Then
C
C     IsoQuinoline
C
        Eps    = 10.43d0
        EpsInf = 1.010d0
        DerEps = Zero
        RSolv  = 3.50d0
        VMol   = 117.27d0
        TCE    = 1.255d-3
        STen   = 26.53d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 5.135d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 9
        RDiff(1) = 1.5d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 7
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom N:
        NTT(3)    = 1
        RDiff(3) = 1.6d0
        KT(3)    = DKList(7)
        RWT(3)   = RList(7)
C
      Else If(IDSolv.eq. 6) Then
C
C     Quinoline
C
        Eps    = 9.03d0
        EpsInf = 1.010d0
        DerEps = Zero
        RSolv  = 3.50d0
        VMol   = 117.27d0
        TCE    = 1.255d-3
        STen   = 26.53d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 5.135d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 9
        RDiff(1) = 1.5d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 7
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom N:
        NTT(3)    = 1
        RDiff(3) = 1.6d0
        KT(3)    = DKList(7)
        RWT(3)   = RList(7)
C
      Else If(IDSolv.eq. 7) Then
C
C     Chloroform
C
        Eps    = 4.90d0
        EpsInf = 2.085d0
        DerEps = Zero
        RSolv  = 2.48d0
        VMol   = 80.7d0
        TCE    = 1.255d-3
        STen   = 26.53d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 7.482d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 1
        RDiff(1) = 2.82d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 1
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom Cl:
        NTT(3)    = 3
        RDiff(3) = 1.79d0
        KT(3)    = DKList(17)
        RWT(3)   = RList(17)
C
      Else If(IDSolv.eq. 8) Then
C
C     EthylEther
C
        Eps    = 4.335d0
        EpsInf = Zero
        DerEps = Zero
        RSolv  = 2.785d0
        VMol   = 103.84d0
        TCE    = 1.617d-3
        STen   = Zero
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 5.799d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 4
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 10
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom O:
        NTT(3)    = 1
        RDiff(3) = 1.50d0
        KT(3)    = DKList(8)
        RWT(3)   = RList(8)
C
      Else If(IDSolv.eq. 9) Then
C
C     MethyleneChloride
C
        Eps    = 8.93d0
        EpsInf = 2.020d0
        DerEps = Zero
        RSolv  = 2.27d0
        VMol   = 64.5d0
        TCE    = 1.367d-3
        STen   = 27.33d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 9.74d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 1
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 2
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom Cl:
        NTT(3)    = 2
        RDiff(3) = 1.79d0
        KT(3)    = DKList(17)
        RWT(3)   = RList(17)
C
      Else If(IDSolv.eq.10) Then
C
C     DiChloroEthane
C
        Eps    = 10.36d0
        EpsInf = 2.085d0
        DerEps = Zero
        RSolv  = 2.505d0
        VMol   = 79.4d0
        TCE    = 1.156d-3
        STen   = 31.54d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 7.576d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 2
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 4
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom Cl:
        NTT(3)    = 2
        RDiff(3) = 1.79d0
        KT(3)    = DKList(17)
        RWT(3)   = RList(17)
C
      Else If(IDSolv.eq.11) Then
C
C     CarbonTetraChloride
C
        Eps    = 2.228d0
        EpsInf = 2.129d0
        DerEps = Zero
        RSolv  = 2.685d0
        VMol   = 96.5d0
        TCE    = 1.270d-3
        STen   = 26.15d0
        DSTen  = 1.436d0
        CMF    = 0.629d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 6.241d-3
        NATyp  = 2
C     Atom C:
        NTT(1)    = 1
        RDiff(1) = 2.82d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom Cl:
        NTT(2)    = 4
        RDiff(2) = 1.79d0
        KT(2)    = DKList(17)
        RWT(2)   = RList(17)
C
      Else If(IDSolv.eq.12) Then
C
C     Benzene
C
        Eps    = 2.247d0
        EpsInf = 2.244d0
        DerEps = Zero
        RSolv  = 2.63d0
        VMol   = 88.91d0
        TCE    = 1.380d-3
        STen   = 28.18d0
        DSTen  = 1.469d0
        CMF    = 0.629d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 6.773d-3
        NATyp  = 2
C     Atom C:
        NTT(1)    = 6
        RDiff(1) = 1.5d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 6
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C
      Else If(IDSolv.eq.13) Then
C
C     Toluene
C
        Eps    = 2.379d0
        EpsInf = 2.232d0
        DerEps = Zero
        RSolv  = 2.82d0
        VMol   = 106.3d0
        TCE    = 1.08d-3
        STen   = 27.92d0
        DSTen  = 1.391d0
        CMF    = 0.679d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 5.665d-3
        NATyp  = 2
C     Atom C:
        NTT(1)    = 7
        RDiff(1) = 1.5d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 8
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C
      Else If(IDSolv.eq.14) Then
C
C     ChloroBenzene
C
        Eps    = 5.621d0
        EpsInf = 2.320d0
        DerEps = Zero
        RSolv  = 2.805d0
        VMol   = 101.79d0
        TCE    = 0.981d-3
        STen   = 32.69d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 5.916d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 6
        RDiff(1) = 1.5d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 5
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom Cl:
        NTT(3)    = 1
        RDiff(3) = 1.79d0
        KT(3)    = DKList(17)
        RWT(3)   = RList(17)
C
      Else If(IDSolv.eq.15) Then
C
C     NitroMethane
C
        Eps    = 38.20d0
        EpsInf = 1.904d0
        DerEps = Zero
        RSolv  = 2.155d0
        VMol   = 53.68d0
        TCE    = 1.192d-3
        STen   = 36.47d0
        DSTen  = 1.373d0
        CMF    = 0.808d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 1.122d-2
        NATyp  = 4
C     Atom C:
        NTT(1)    = 1
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 3
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom N:
        NTT(3)    = 1
        RDiff(3) = 1.6d0
        KT(3)    = DKList(7)
        RWT(3)   = RList(7)
C     Atom O:
        NTT(4)    = 2
        RDiff(4) = 1.5d0
        KT(4)    = DKList(8)
        RWT(4)   = RList(8)
C
      Else If(IDSolv.eq.16) Then
C
C     Heptane
C
        Eps    = 1.92d0
        EpsInf = 1.918d0
        DerEps = Zero
        RSolv  = 3.125d0
        VMol   = 146.56d0
        TCE    = 1.25d-3
        STen   = 19.80d0
        DSTen  = 1.505d0
        CMF    = 0.687d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 4.109d-3
        NATyp  = 2
C     Atom C:
        NTT(1)    = 7
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 16
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C
      Else If(IDSolv.eq.17) Then
C
C     CycloHexane
C
        Eps    = 2.023d0
        EpsInf = 2.028d0
        DerEps = Zero
        RSolv  = 2.815d0
        VMol   = 108.10d0
        TCE    = 1.20d-3
        STen   = 24.38d0
        DSTen  = 1.467d0
        CMF    = 0.621d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 5.571d-3
        NATyp  = 2
C     Atom C:
        NTT(1)    = 6
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 12
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C
      Else If(IDSolv.eq.18) Then
C
C     Aniline
C
        Eps    = 6.89d0
        EpsInf = 2.506d0
        DerEps = Zero
        RSolv  = 2.80d0
        VMol   = 91.15d0
        TCE    = 0.85d-3
        STen   = 42.79d0
        DSTen  = 0.731d0
        CMF    = 0.972d0
C     Atomic parameters for dispersion and repulsion
        Rho    = 6.607d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 6
        RDiff(1) = 1.5d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 7
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom N:
        NTT(3)    = 1
        RDiff(3) = 1.6d0
        KT(3)    = DKList(7)
        RWT(3)   = RList(7)
C
      Else If(IDSolv.eq.19) Then
C
C     Acetone
C
        Eps    = 20.7d0
        EpsInf = 1.841d0
        DerEps = -9.77d-2
        RSolv  = 2.38d0
        VMol   = 73.52d0
        TCE    = 1.42d-3
        STen   = 22.67d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 8.190d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 3
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 6
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom O:
        NTT(3)    = 1
        RDiff(3) = 1.5d0
        KT(3)    = DKList(8)
        RWT(3)   = RList(8)
C
      Else If(IDSolv.eq.20) Then
C
C     TetraHydroFuran
C
        Eps    = 7.58d0
        EpsInf = 1.971d0
        DerEps = Zero
        RSolv  = 2.56d0
        VMol   = 81.11d0
        TCE    = 1.142d-3
        STen   = 26.40d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 7.425d-3
        NATyp  = 3
C     Atom C:
        NTT(1)    = 4
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 8
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom O:
        NTT(3)    = 1
        RDiff(3) = 1.5d0
        KT(3)    = DKList(8)
        RWT(3)   = RList(8)
C
      Else If(IDSolv.eq.21) Then
C
C     DiMethylSulfoxide
C
        Eps    = 46.7d0
        EpsInf = 2.179d0
        DerEps = -0.1902d0
        RSolv  = 2.455d0
        VMol   = 70.94d0
        TCE    = 9.82d-2
        STen   = 42.86d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 8.49d-3
        NATyp  = 4
C     Atom C:
        NTT(1)    = 2
        RDiff(1) = 1.76d0
        KT(1)    = DKList(6)
        RWT(1)   = RList(6)
C     Atom H:
        NTT(2)    = 6
        RDiff(2) = 1.2d0
        KT(2)    = DKList(1)
        RWT(2)   = RList(1)
C     Atom S:
        NTT(3)    = 1
        RDiff(3) = 1.80d0
        KT(3)    = DKList(16)
        RWT(3)   = RList(16)
C     Atom O:
        NTT(4)    = 1
        RDiff(4) = 1.5d0
        KT(4)    = DKList(8)
        RWT(4)   = RList(8)
C
      Else If(IDSolv.eq.22) Then
C
C     Argon
C
C     Warning: the following data are referred to the absolute
C              temperature of 118 K (the highest available). Change
C              the parameter Tabs to this value in actual calculations.
C              To use other temperatures, one has to provide also the
C              corresponding density (in g cm-3) to compute RHO (i.e.
C              the numeral density) and VMol (i.e. the molar volume)
C              properly. Of course, the proper dielectric constant
C              must be provided too.
C
        Tabs   = 118.0d0
        Eps    = 1.430d0
        EpsInf = 1.430d0
        DerEps = Zero
        RSolv  = 1.875d0
        VMol   = 34.29d0
        TCE    = 9.82d-2
        STen   = 42.86d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 1.756d-2
        NATyp  = 1
C     Atom Ar:
        NTT(1)    = 1
        RDiff(1) = 1.875d0
        KT(1)    = DKList(18)
        RWT(1)   = RList(18)
C
      Else If(IDSolv.eq.23) Then
C
C     Krypton
C
C     Warning: the following data are referred to the absolute
C              temperature of 168 K (the highest available). Change
C              the parameter Tabs to this value in actual calculations.
C              To use other temperatures, one has to provide also the
C              corresponding density (in g cm-3) to compute RHO (i.e.
C              the numeral density) and VMol (i.e. the molar volume)
C              properly. Of course, the proper dielectric constant
C              must be provided too.
C
        Tabs   = 168.0d0
        Eps    = 1.519d0
        EpsInf = 1.519d0
        DerEps = Zero
        RSolv  = 2.07d0
        VMol   = 42.71d0
        TCE    = 9.82d-2
        STen   = 42.86d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 1.410d-02
        NATyp  = 1
C     Atom Kr:
        NTT(1)    = 1
        RDiff(1) = 2.07d0
        KT(1)    = DKList(36)
        RWT(1)   = RList(36)
C
      Else If(IDSolv.eq.24) Then
C
C     Xenon
C
C     Warning: the following data are referred to the absolute
C              temperature of 210 K (the highest available). Change
C              the parameter Tabs to this value in actual calculations.
C              To use other temperatures, one has to provide also the
C              corresponding density (in g cm-3) to compute RHO (i.e.
C              the numeral density) and VMol (i.e. the molar volume)
C              properly. Of course, the proper dielectric constant
C              must be provided too.
C
        Tabs   = 210.0d0
        Eps    = 1.706d0
        EpsInf = 1.706d0
        DerEps = Zero
        RSolv  = 2.20d0
        VMol   = 50.38d0
        TCE    = 9.82d-2
        STen   = 42.86d0
        DSTen  = Zero
        CMF    = Zero
C     Atomic parameters for dispersion and repulsion
        Rho    = 1.195d-02
        NATyp  = 1
C     Atom Xe:
        NTT(1)    = 1
        RDiff(1) = 2.20d0
        KT(1)    = DKList(53)
        RWT(1)   = RList(53)
      Endif
C
C---- Use user specified value of the dielectric constant
C
      If (Eps_User.ne.-One) Eps=Eps_User
      If (EpsInf_User.ne.Zero) EpsInf=EpsInf_User
C
      Return
      End
C
      Function RList(IA)
      Implicit Real*8 (A-H,O-Z)
C
C     Assignes Caillet-Claverie's atomic parameters for dispersion and
C     repulsion.
C
      Parameter(MaxIA=110)
      Real*8 RW(MaxIA)
C
      Save RW
      Data RW/
C        H             He
     $ 1.20d+00,      1.28d+00,
C       Li            Be           B               C            N
     $ 0.00d+00,     0.00d+00,    0.00d+00,       1.70d+00,    1.60d+00,
C       O             F            Ne
     $ 1.50d+00,     1.45d+00,    1.38d+00,
C       Na            Mg           Al              Si           P
     $ 1.20d+00,     0.00d+00,    0.00d+00,       0.00d+00,    1.85d+00,
C       S             Cl           Ar
     $ 1.80d+00,     1.76d+00,    1.66d+00,
C       K             Ca
     $ 1.46d+00,     0.00d+00,
C       Sc            Ti           V               Cr           Mn
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Fe            Co           Ni              Cu           Zn
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Ga            Ge           As              Se           Br
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    1.85d+00,
C       Kr
     $ 1.76d+00,
C       Rb            Sr
     $ 0.00d+00,     0.00d+00,
C       Y             Zr           Nb              Mo           Tc
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Ru            Rh              Pd              Ag           Cd
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       In            Sn           Sb              Te           I
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    1.96d+00,
C       Xe
     $ 1.85d+00,
C       Cs            Ba
     $ 0.00d+00,     0.00d+00,
C       La            Ce           Pr              Nd           Pm
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Sm            Eu           Gd              Tb           Dy
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Ho            Er           Tm               Yb           Lu
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Hf
     $ 0.00d+00,
C       Ta            W            Re              Os           Ir
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Pt            Au           Hg              Tl           Pb
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Bi            Po           At              Rn           Fr
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Ra            Ac           Th
     $ 0.00d+00,     0.00d+00,    0.00d+00,
C       Pa            U            Np              Pu           Am
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Cm            Bk           Cf              Es           Fm
     $ 0.00d+00,     0.00d+00,    0.00d+00,       0.00d+00,    0.00d+00,
C       Md
     $ 0.00d+00, 9*0.00d+00 /
C
      If(IA.gt.0.and.IA.le.MaxIA) then
        RList = RW(IA)
      Else
        RList = 0.0D0
        write(6,'(''IA out of range in RList.'')')
        Call Abend()
      EndIf
C
      Return
      End
C
      Function DKList(NumAt)
      Implicit Real*8 (A-H,O-Z)
C
C     Assignes Caillet-Claverie's atomic parameters for dispersion and
C     repulsion.
C
      Parameter(NElem=110)
      Real*8 K(NElem)
      Save K
      Data K/
C        H             He
     $ 1.00d+00,     0.594d+00,
C       Li            Be           B               C            N
     $ 0.000d+00,    0.000d+00,   0.000d+00,     1.000d+00,   1.180d+00,
C       O             F            Ne
     $ 1.360d+00,    1.500d+00,   1.209d+00,
C       Na            Mg           Al              Si           P
     $ 1.400d+00,    0.000d+00,   0.000d+00,     0.000d+00,   2.100d+00,
C       S             Cl           Ar
     $ 2.400d+00,    2.100d+00,   2.127d+00,
C       K             Ca
     $ 2.900d+00,    0.000d+00,
C       Sc            Ti           V               Cr           Mn
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Fe            Co           Ni              Cu           Zn
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Ga            Ge           As              Se           Br
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   2.400d+00,
C       Kr
     $ 2.566d+00,
C       Rb            Sr
     $ 0.000d+00,    0.000d+00,
C       Y             Zr           Nb              Mo           Tc
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Ru            Rh              Pd              Ag           Cd
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       In            Sn           Sb              Te           I
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   3.200d+00,
C       Xe
     $ 0.000d+00,
C       Cs            Ba
     $ 0.000d+00,    0.000d+00,
C       La            Ce           Pr              Nd           Pm
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Sm            Eu           Gd              Tb           Dy
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Ho            Er           Tm               Yb           Lu
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Hf
     $ 0.000d+00,
C       Ta            W            Re              Os           Ir
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Pt            Au           Hg              Tl           Pb
     $ 0.000d+00,    0.000d+00,   0.0005d+00,    0.000d+00,   0.000d+00,
C       Bi            Po           At              Rn           Fr
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Ra            Ac           Th
     $ 0.000d+00,    0.000d+00,   0.000d+00,
C       Pa            U            Np              Pu           Am
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Cm            Bk           Cf              Es           Fm
     $ 0.000d+00,    0.000d+00,   0.000d+00,     0.000d+00,   0.000d+00,
C       Md
     $ 0.000d+00, 9*0.00d+00 /
C
      DKList = K(NumAt)
C
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Mpprop_input(nAtoms,iPol,LNearestAtom,LAllCenters
     &,AveOrb,LLumOrb,Diffuse,dLimmo,Thrs1,Thrs2,nThrs,ThrsMul,iPrint)
*
      Implicit Real*8 (a-h,o-z)
*
#include "MolProp.fh"
#include "warnings.fh"

      Integer      nBondCount(mxAtomMP)
      Character*3  EndKey
*Jose Character*4  TestLabe(0:nAtoms), KWord
      Character*4   KWord
      Character*6  TestLabe(0:nAtoms)
      Character*180 Key, BLine
      Character*180 Get_Ln
      Logical Debug, lTtl, LNearestAtom
      Logical LAllCenters, AveOrb, Diffuse(3)
      Logical LLumorb
      Dimension dLimmo(2)

      External Get_Ln

      Data Debug/.False./

      iStdOut = 6

      Do i = 1, 180
         BLine(i:i) = ' '
      End Do
      Title=BLine

*
*

      LuRd=21
      Call SpoolInp(LuRd)

      Rewind(LuRd)
      Call RdNLst(LuRd,'MPPROP')
*
*     KeyWord directed input
*
 998  lTtl = .False.
!EB 9988 Continue
      Key = Get_Ln(LuRd)
      If (Debug) Write (iStdOut,*) ' Processing:',Key
      KWord = Trim(Key)
      Call UpCase(KWord)
      If (KWord(1:1).eq.'*')    Go To 998
      If (KWord.eq.BLine)       Go To 998
      If (KWord(1:4).eq.'BOND') Go To 981
!      If (KWord(1:4).eq.'METH') Go To 982
      If (KWord(1:4).eq.'TITL') Go To 983
      If (KWord(1:4).eq.'TYPE') Go To 984
      If (KWord(1:4).eq.'POLA') Go To 985
      If (KWord(1:4).eq.'NONE') Go To 986
      If (KWord(1:4).eq.'ALLC') Go To 987
      If (KWord(1:4).eq.'LUMO') Go To 988
      If (KWord(1:4).eq.'DIFF') Go To 989
      If (KWord(1:4).eq.'PRIN') Go To 991
! Keyword added to handle average orbitals
      If (KWord(1:4).eq.'AVER') Go To 7912
*
      If (KWord(1:4).eq.'END ') Go To 997
      iChrct=Len(KWord)
      Last=iCLast(KWord,iChrct)
      Write (6,*)
      Write (6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
      Write (6,*) ' Error in keyword.'
      Call ErrTra
      Call Quit(_RC_INPUT_ERROR_)
      Write (6,*) ' Premature end of input file.'
      Call Quit(_RC_INPUT_ERROR_)
      Write (6,*) ' Error while reading input file.'
 990  Call ErrTra
      Call Quit(_RC_INPUT_ERROR_)
*                                                                      *
************************************************************************
*                                                                      *
* Get the input for bonds
981   LAllCenters=.True.
      Do i=1,MxAtomMP
         nBondCount(i)=0
         NUB(i) = 0
         Do j=1,MxAtomMP
            NBI(i,j) = 0
            BondMat(i,j)=.False.
         EndDo
      EndDo
      Do i=1,nAtoms
         nBonds = 0
         Key = Get_Ln(LuRd)
         m = 1
         Do j=1,nAtoms
            TestLabe(j) = ' '
         EndDo
         Do j=1,180
            EndKey=Key(j:j+2)
            Call UpCase(EndKey)
            If((Key(j:j).eq.' ').or.(Key(j:j).eq.',').or.
     &      (Key(j:j).eq.';')) Then
               If((j.eq.1).and.
     &         ((Key(j:j).eq.';').or.(Key(j:j).eq.','))) Then
                  Write(iStdOut,*)
     &            'Error in input, breaker in first position'
                  Goto 990
               ElseIf(m.lt.j) Then
                  TestLabe(nBonds)=Key(m:j-1)
                  nBonds = nBonds+1
                  m = j+1
               Else
                  m = j+1
               EndIf
            ElseIf (EndKey.eq.'END') Then
               Goto 9811
            EndIf
         EndDo
         Do j=1,nAtoms
            If(TestLabe(0).eq.Labe(j)) Then
               Do k=1,nAtoms
                  Do l=1,nAtoms
                     If(TestLabe(k).eq.Labe(l)) Then
                        BondMat(j,l) = .True.
                        BondMat(l,j) = .True.
                     Else

                     EndIf
                  EndDo
               EndDo
            EndIf
         EndDo
      EndDo
9811  Continue

      Do i=1,nAtoms
         Do j=1,nAtoms
            If(BondMat(i,j)) Then
               NuB(i)=NuB(i)+1
               NBI(i,NuB(i))=j
            EndIf
         EndDo
      EndDo

      Write(iStdOut,*)
      Write(iStdOut,'(10X,A)') '************************'
      Write(iStdOut,'(10X,A)') '**** Bonding matrix ****'
      Write(iStdOut,'(10X,A)') '************************'
      Write(iStdOut,*)
      Write(iStdOut,'(A8,A,A)') 'Atom', '  No bonds', '   Bonding with'
      Do i=1,nAtoms
         Write(iStdOut,'(A8,I6,A11,1000A8)') LABE(I),NUB(I),
     &   (LABE(NBI(I,J)),J=1,NUB(I))
      EndDo
      Write(iStdOut,*)
      Write(iStdOut,*)
      Goto 998

* Set Method level
!982   Key = Get_Ln(LuRd)
!      If (Debug) Write (*,*) ' Processing:',Key
!      Method = Key
!      Call UpCase(Method)
!      If( (Method=='SCF') .or. (Method=='RASSCF') ) Then
!
!      Else
!         Write(*,*) 'The Method Label is not correct'
!         Write(*,*) Method
!         Call Quit(20)
!      EndIf
!      Goto 998
* Set the Title
983   Key = Get_Ln(LuRd)
      If (Debug) Write (iStdOut,*) ' Processing:',Key
      Call UpCase(Key)
      Title=Key
      Goto 998
* Set the specifik atom types
984   Key = Get_Ln(LuRd)
      Call UpCase(Key)
      If (Key(1:3).eq.'END') Then
         Go To 998
      Else
         Read(Key,*) j,iAtomPar(j)
      EndIf
      Goto 984
* Set that local polarizabilities should be calculated
985   Key = Get_Ln(LuRd)
      Read(Key,*) iPol
      Goto 998
* Set the nearest atom calculation to .False.
986   LNearestAtom=.False.
      Goto 998
* Set the average orbital option to .True.
7912  AveOrb=.True.
      iPol=0
      Goto 998
* Set the logical variable that defines if all ceters or not
987   LAllCenters=.True.
      LNearestAtom=.False.
*                                                                      *
************************************************************************
*                                                                      *
*---- Set the bonds to all sites
*---- Get information from input
!      Do i=1,mxAtomMP
!         NuB(i)=0
!         Do j=1,mxAtomMP
!            NBI(i,j)=0
!         End Do
!      End Do
      Do i=1,nAtoms
         NuB(i)=nAtoms-1
         Do j=1,nAtoms-1
            If(j.ge.i) Then
               NBI(i,j)=j+1
               BondMat(i,j+1) = .True.
            Else
               NBI(i,j)=j
               BondMat(i,j) = .True.
            EndIf
         End Do
      End Do
      Goto 998
* Get the vectors from the INPORB file
988   LLumOrb=.True.
      Goto 998

* Obtain diffuse stuff to the MpProp decomposition.
989   Continue
      Key = Get_Ln(LuRd)
      Call UpCase(Key)
      If(Key(1:4).eq.'NUME') then
        Diffuse(1)=.true.
        Diffuse(2)=.true.
9891    Continue
        Key = Get_Ln(LuRd)
        Call UpCase(Key)
        If(Key(1:4).eq.'LIMI') then
          Key = Get_Ln(LuRd)
          Call Get_F(1,dLimmo,2)
        Elseif(Key(1:4).eq.'THRE') then
          Key=Get_Ln(LuRd)
          Call Get_F1(1,Thrs1)
          Call Get_F1(2,Thrs2)
          Call Get_I1(3,nThrs)
          Call Get_F1(4,ThrsMul)
        Elseif(Key(1:4).eq.'END ') then
          GoTo 987 !Not an error, Diffuse implies AllCenters
        Else
          Write(6,*) 'Undefined option for ''DIFFuse'':',Key
          Call FindErrorLine
          Call Quit_OnUserError()
        Endif
        GoTo 9891
      Elseif(Key(1:4).eq.'REXT') then
        Diffuse(1)=.true.
        Diffuse(3)=.true.
      Else
        Write(6,*) 'Undefined option for ''DIFFuse'':',Key
        Call FindErrorLine
        Call Quit_OnUserError()
      Endif
      GoTo 987  !Not an error, Diffuse implies AllCenters

*PrintLevel.
991   Continue
      Key = Get_Ln(LuRd)
      Call UpCase(Key)
      Call Get_I1(1,iPrint)
      GoTo 998

997   Continue
      If(Title.eq.Bline) Then
         Write(iStdOut,*)
         Write(iStdOut,*) ' !!WARNING!! The molecule do not have a name'
         Write(iStdOut,*)
      EndIf

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine rdjobiph_cvb(fnjob)
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "rasdim.fh"
#include "jobiph_j.fh"

c Input parameters :
c ------------------
      character*(*) fnjob               ! subroutine arguments
c      integer mxtit,mxorb,mxroot,mxsym  ! rasdim.fh
c      integer itob,rtoi                 ! SysDef.fh
c Output parameters (in jobiph_j) :
c -------------------
c      integer iadr15_j(15)
c      integer nactel_j,ispin_j,nsym_j,lsym_j,nfro_j(mxsym),
c     >  nish_j(mxsym),nash_j(mxsym),ndel_j(mxsym),
c     >  nbas_j(mxsym)
c       character*(lenin8) name_j(mxorb)
c      integer nconf_j
c       character*2 header_j(72)
c       character*72 title_j(18)
c      real*8 potnuc_j
c      integer lroots_j,
c     >  nroots_j,iroot_j(mxroot),
c     >  nrs1_j(mxsym),nrs2_j(mxsym),nrs3_j(mxsym),
c     >  nhole1_j,nelec3_j,ipt2_j
c      real*8 weight_j(mxroot)
cw
cw    NA                   NORB                NNA              NTASH
cw    NTASQR             NTATRI              NTBAS             NTBSQR
cw    NTBTRI              NTISH             NTISQR             NTITRI
c Local/work parameters :
c -----------------------
c  local / work
      integer lujob
      integer idisk
      logical debug
      data debug/.false./
c      integer iwork        ! WrkSpc.fh

c Read the table of disk adresses :
      lujob=15
      call daname_cvb(lujob,fnjob)
      idisk=0
      call idafile(lujob,2,iadr15_j,15,idisk)
c Read the the system description :
      idisk=iadr15_j(1)
      call WR_RASSCF_Info(lujob,2,idisk,
     >                    nactel_j,ispin_j,nsym_j,lsym_j,nfro_j,
     >                    nish_j,nash_j,ndel_j,
     >                    nbas_j,mxsym,name_j,lenin8*mxorb,
     >                    nconf_j,header_j,144,
     >                    title_j,4*18*mxtit,potnuc_j,lroots_j,
     >                    nroots_j,iroot_j,mxroot,
     >                    nrs1_j,nrs2_j,nrs3_j,
     >                    nhole1_j,nelec3_j,ipt2_j,weight_j)

      if(debug)then
        write(6,*)' Information read from jobiph :'
        write(6,*)' ------------------------------'
        write(6,*)' nactel :',nactel_j
        write(6,*)' ispin  :',ispin_j
        write(6,*)' nsym   :',nsym_j
        write(6,*)' lsym   :',lSym_j
        write(6,*)' nfro   :',nfro_j
        write(6,*)' nish   :',nish_j
        write(6,*)' nash   :',nash_j
        write(6,*)' ndel   :',ndel_j
        write(6,*)' nbas   :',nbas_j
        write(6,*)' name   :'
        do 100 ii=1,mxorb
        if(name_j(ii)(4:4).eq.' ')write(6,*)name_j(ii)
100     continue
        write(6,*)' nconf  :',nconf_j
        write(6,*)' header :',header_j
        write(6,*)' title  :'
        do 200 ii=1,mxtit
        if(len_trim_cvb(title_j(ii)).gt.0)write(6,*)title_j(ii)
200     continue
        write(6,*)' potnuc :',potnuc_j
        write(6,*)' lroots :',lroots_j
        write(6,*)' nroots :',nroots_j
        write(6,*)' iroot  :',iroot_j
        write(6,*)' nrs1   :',nrs1_j
        write(6,*)' nrs2   :',nrs2_j
        write(6,*)' nrs3   :',nrs3_j
        write(6,*)' nhole1 :',nhole1_j
        write(6,*)' nelec3 :',nelec3_j
        write(6,*)' ipt2   :',ipt2_j
        write(6,*)' weight :',weight_j
      endif

      call daclos_cvb(lujob)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine getLIMIT(l1,l2,l3,l4,Lanf,Lend)
      implicit Integer (a-z)
cbs   get the minimum and maximum L-values
cbs   of the the coulomb-potential to interact
cbs   with l1-l4
      lower1=iabs(l1-l3)
      lower2=iabs(l2-l4)
      lupper1=l1+l3
      lupper2=l2+l4
      Lanf=max(lower1,lower2)
      Lend=min(lupper1,lupper2)
cbs     check for parity
      lsum=Lanf+l1+l3
      if (mod(lsum,2).eq.1) Lanf=Lanf+1
      lsum=Lend+l1+l3
      if (mod(lsum,2).eq.1) Lend=Lend-1
cbs   check the other parity
      lsum=Lanf+l2+l4
      if (mod(lsum,2).eq.1) then
      write(6,*) ' error in getLIMIT: '
      write(6,*) ' parity inconsistency for '
      write(6,*) 'l1,l2,l3,l4= ',l1,l2,l3,l4
      Call Abend()
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Deriva(IPrint,NAt,nTs,NEsf,NEsfP,RSolv,Tessera,Vert,Centr,Sphere,ISphe,IntSph,NOrd,NVert,NewSph,DerTes,DerPunt,DerRad, &
                  DerCentr)

use PCM_Arrays, only: MxVert
use Constants, only: Zero, One, Two, Ten, Half, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IPrint, NAt, nTs, NEsf, NEsfP, ISphe(nTs), IntSph(MxVert,nTs), NOrd(NEsfP), NVert(nTs), &
                                 NewSph(2,NEsf)
real(kind=wp), intent(in) :: RSolv
real(kind=wp), intent(inout) :: Tessera(4,nTs), Vert(3,MxVert,nTs), Centr(3,MxVert,nTs), Sphere(4,NEsf)
real(kind=wp), intent(out) :: DerTes(nTs,NAt,3), DerPunt(nTs,NAt,3,3), DerRad(NEsf,NAt,3), DerCentr(NEsf,NAt,3,3)
integer(kind=iwp) :: AlGe(63), Casca(MxVert), I, ICONT, ICoord, idx, II, IJunk, IMAX, IMIN, ITS, JJ, K, LIVEL, LL, N, NESFJ, NS1, &
                     NS2, NSA, NSI, NSJ, NSK, NSUB, NUM, NV
real(kind=wp) :: DDR, DDX, DDY, DDZ, DER, DERP(3), DERPT(3), DERS, DERTS, DISTKI(3), DR, DX, DY, DZ, FAC, FACT, ToBohr

! Compute the derivatives of area and of representative point position
! for each tessera

! Le derivate contengono termini dovuti direttamente allo spostamento
! del centro della sfera NSJ, e termini "mediati" dagli
! spostamenti del centro e dal cambiamento del raggio delle sfere
! "aggiunte" (create da PEDRA, oltre a quelle originarie).
! Chiamiamo ITS la tessera, I la sfera a cui ITS appartiene, J la sfera
! che si muove. Le derivate che cerchiamo sono dS(ITS)/dx(J) e
! dQ(ITS)/dx(J) (indicando con x(J) una qualsiasi coordinata di J.
! Per prima cosa calcoliamo le derivate dell'area e del punto
! rappresentativo delle tessere DIRETTAMENTE tagliate da J, poi di quelle
! che appartengono a J e sono tagliate da altre sfere.
! Poi consideriamo le "sfere aggiunte" che vengono modificate dal
! movimento di J: per ogni sfera aggiunta si esaminano tutte le
! tessere e caso per caso si calcolano le derivate.
!
! In ogni caso le derivate totali dS/dx(J) e dQ/dx(J) si scrivono come una
! combinazione delle seguenti derivate parziali:
!      dS/dR(I)  ;  dS/dz(I)  ;  dS/dR(K)  ;  dS/dz(K)
!      dQ/dR(I)  ;  dQ/dz(I)  ;  dQ/dR(K)  ;  dQ/dz(K)
! dove, ancora una volta, z indica una qualunque coordinata e K un'altra
! sfera (la stessa J o una sfera aggiunta modificata dal movimento
! di J) che taglia S.
!
! NESFJ e' la sfera che sta attorno all'atomo NSJ: se NSJ non ha
! nessuna sfera, NESFJ = 0

! Initialize the derivative arrays
DerTes(:,:,:) = Zero
DerPunt(:,:,:,:) = Zero
DerRad(:,:,:) = Zero
DerCentr(:,:,:,:) = Zero
! The geometric quantities are expected to be in Angstrom
Tessera(1:3,:) = Angstrom*Tessera(1:3,:)
Tessera(4,:) = Angstrom*Angstrom*Tessera(4,:)
Sphere(:,:) = Angstrom*Sphere(:,:)
Vert(:,:,:) = Angstrom*Vert(:,:,:)
Centr(:,:,:) = Angstrom*Centr(:,:,:)

outer: do NSJ=1,NAt
  do ICoord=1,3

    NESFJ = 0
    do I=1,NESFP
      if (NSJ == NORD(I)) NESFJ = I
    end do

    ! Memorizza in DERRAD(NS,NSJ,ICOORD) la derivata del raggio di ogni
    ! sfera NS e in DERCENTR(NS,NSJ,ICOORD,3) le derivate delle
    ! coordinate del centro di NS rispetto alla coord. ICOORD della
    ! sfera NSJ.
    !
    ! Se NS e' una sfera originaria queste derivate sono 0, tranne
    ! DERCENTR(NESFJ,NSJ,ICOORD,ICOORD)=1 :

    DERRAD(1:NESFP,NSJ,ICOORD) = ZERO
    DERCENTR(1:NESFP,NSJ,ICOORD,:) = ZERO
    if (NESFJ /= 0) DERCENTR(NESFJ,NSJ,ICOORD,ICOORD) = One

    ! Se non c'e' nessuna sfera attorno all'atomo NSJ ...
    if (NESFJ == 0) cycle outer

    ! 1) Effetti diretti.
    ! Loop sulle tessere.
    do ITS=1,NTS
      DERTS = ZERO
      DERPT(:) = ZERO
      NV = NVERT(ITS)
      NSI = ISPHE(ITS)
      if (NSI == NESFJ) then
        ! Derivate nel caso I = J

        ! Loop sulle sfere K che intersecano I
        do NSK=1,NESF
          if (NSK == NSI) cycle
          ! ITS ha un lato su K ?
          ICONT = 0
          do N=1,NV
            if (INTSPH(N,ITs) == NSK) ICONT = ICONT+1
          end do
          if (ICONT == 0) cycle
          call dSd(0,ICOORD,NSK,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
          DERTS = DERTS-DERS
          DERPT(:) = DERPT(:)-DERP(:)
        end do
      else
        ! Derivate nel caso I non = J
        !
        !           dS/dx(J), dQ/dx(J)
        ! ITS ha un lato su J ?
        ICONT = 0
        do N=1,NV
          if (INTSPH(N,ITs) == NESFJ) ICONT = ICONT+1
        end do
        if (ICONT >= 1) then
          call dSd(0,ICOORD,NESFJ,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
          DERTS = DERTS+DERS
          DERPT(:) = DERPT(:)+DERP(:)
        end if
      end if
      DERTES(ITS,NSJ,ICOORD) = DERTS
      DERPUNT(ITS,NSJ,ICOORD,:) = DERPT(:)
    end do

    ! 2) Effetti indiretti.
    ! Loop sulle sfere aggiunte
    do NSA=NESFP+1,NESF
      ALGE(:) = 0
      ! Costruiamo l'"albero genealogico" della sfera NSA
      ALGE(1) = NSA
      ALGE(2) = abs(NEWSPH(1,NSA))
      ALGE(3) = abs(NEWSPH(2,NSA))
      LIVEL = 3
      NUM = 2
      do while (NUM < 32)
        NSUB = 1
        do II=LIVEL-NUM+1,LIVEL
          if (ALGE(II) > NESFP) then
            ALGE(LIVEL+NSUB) = abs(NEWSPH(1,ALGE(II)))
            ALGE(LIVEL+NSUB+1) = abs(NEWSPH(2,ALGE(II)))
          end if
          NSUB = NSUB+2
        end do
        NUM = NUM*2
        LIVEL = LIVEL+NUM
      end do
      ! Si accerta che nell'ultimo livello ci siano solo sfere originarie
      do II=34,63
        if (ALGE(II) > NESFP) then
          write(u6,10) NSA,ALGE(II)
        end if
      end do
      ! Quando un elemento di ALGE e' = NESFJ, costruisce la corrispondente
      ! "cascata" di sfere aggiunte che collega NESFJ a NSA
      do LIVEL=2,6
        IMIN = 2**(LIVEL-1)
        IMAX = 2**(LIVEL)-1
        do II=IMIN,IMAX
          if (ALGE(II) /= NESFJ) cycle
          CASCA(:) = 0
          CASCA(1) = NESFJ
          idx = II
          K = 2
          do LL=LIVEL,2,-1
            FACT = (idx-2**(LL-1))*Half
            idx = 2**(LL-2)+int(FACT)
            CASCA(K) = ALGE(idx)
            K = K+1
          end do
          ! Contiamo gli elementi diversi da 0 in CASCA
          ICONT = 0
          do K=1,MxVert
            if (CASCA(K) /= 0) ICONT = ICONT+1
          end do

          ! Costruiamo le derivate composte del raggio e delle coordinate di
          ! NSA (ultimo elemento di CASCA)
          ! rispetto alla coordinata ICOORD di NESFJ (primo elemento di CASCA)
          NS1 = CASCA(1)
          NS2 = CASCA(2)
          call dRdC(NS2,ICOORD,NS1,DR,RSolv,Sphere,NewSph(:,NS2))
          call dCdC(1,ICOORD,NS1,DX,Sphere,NewSph(:,NS2))
          call dCdC(2,ICOORD,NS1,DY,Sphere,NewSph(:,NS2))
          call dCdC(3,ICOORD,NS1,DZ,Sphere,NewSph(:,NS2))
          do I=3,ICONT
            DDR = ZERO
            DDX = ZERO
            DDY = ZERO
            DDZ = ZERO
            NS1 = CASCA(I-1)
            NS2 = CASCA(I)

            ! Derivata del raggio dell'elemento I di CASCA rispetto
            ! alla coord. ICOORD dell'elemento 1 di CASCA
            call dRdR(NS2,NS1,DER,RSolv,Sphere,NewSph(:,NS2))
            DDR = DER*DR
            call dRdC(NS2,1,NS1,DER,RSolv,Sphere,NewSph(:,NS2))
            DDR = DDR+DER*DX
            call dRdC(NS2,2,NS1,DER,RSolv,Sphere,NewSph(:,NS2))
            DDR = DDR+DER*DY
            call dRdC(NS2,3,NS1,DER,RSolv,Sphere,NewSph(:,NS2))
            DDR = DDR+DER*DZ

            ! Derivata della coord. X dell'elemento I di CASCA rispetto
            ! alla coord. ICOORD dell'elemento 1 di CASCA
            call dCdR(1,NS1,DER,Sphere,NewSph(:,NS2))
            DDX = DER*DR
            call dCdC(1,1,NS1,DER,Sphere,NewSph(:,NS2))
            DDX = DDX+DER*DX
            call dCdC(1,2,NS1,DER,Sphere,NewSph(:,NS2))
            DDX = DDX+DER*DY
            call dCdC(1,3,NS1,DER,Sphere,NewSph(:,NS2))
            DDX = DDX+DER*DZ

            ! Derivata della coord. Y dell'elemento I di CASCA rispetto
            ! alla coord. ICOORD dell'elemento 1 di CASCA
            call dCdR(2,NS1,DER,Sphere,NewSph(:,NS2))
            DDY = DER*DR
            call dCdC(2,1,NS1,DER,Sphere,NewSph(:,NS2))
            DDY = DDY+DER*DX
            call dCdC(2,2,NS1,DER,Sphere,NewSph(:,NS2))
            DDY = DDY+DER*DY
            call dCdC(2,3,NS1,DER,Sphere,NewSph(:,NS2))
            DDY = DDY+DER*DZ

            ! Derivata della coord. Z dell'elemento I di CASCA rispetto
            ! alla coord. ICOORD dell'elemento 1 di CASCA
            call dCdR(3,NS1,DER,Sphere,NewSph(:,NS2))
            DDZ = DER*DR
            call dCdC(3,1,NS1,DER,Sphere,NewSph(:,NS2))
            DDZ = DDZ+DER*DX
            call dCdC(3,2,NS1,DER,Sphere,NewSph(:,NS2))
            DDZ = DDZ+DER*DY
            call dCdC(3,3,NS1,DER,Sphere,NewSph(:,NS2))
            DDZ = DDZ+DER*DZ

            DR = DDR
            DX = DDX
            DY = DDY
            DZ = DDZ
          end do

          ! Se NS e' una sfera aggiunta, memorizza le derivate del raggio
          ! e delle coordinate del centro:
          DERRAD(NSA,NSJ,ICOORD) = DR
          DERCENTR(NSA,NSJ,ICOORD,1) = DX
          DERCENTR(NSA,NSJ,ICOORD,2) = DY
          DERCENTR(NSA,NSJ,ICOORD,3) = DZ

          ! Per ogni sfera aggiunta connessa a NESFJ, fa passare tutte le
          ! tessere, calcolando, se e' il caso, le derivate
          do ITS=1,NTS
            DERTS = ZERO
            DERPT(:) = ZERO
            NV = NVERT(ITS)
            NSI = ISPHE(ITS)
            ! Derivate delle tessere appartenenti a NSA
            if (NSI == NSA) then
              ! Derivate relative al raggio di NSI: 1) scaling
              DERTS = Two*Tessera(4,ITS)*DR/Sphere(4,NSI)
              DERPT(1) = (Tessera(1,ITS)-Sphere(1,NSI))*DR/Sphere(4,NSI)
              DERPT(2) = (Tessera(2,ITS)-Sphere(2,NSI))*DR/Sphere(4,NSI)
              DERPT(3) = (Tessera(3,ITS)-Sphere(3,NSI))*DR/Sphere(4,NSI)
              ! Loop sulle altre sfere K che tagliano ITS
              do NSK=1,NESF
                if (NSK == NSI) cycle
                ICONT = 0
                do N=1,NV
                  if (INTSPH(N,ITs) == NSK) ICONT = ICONT+1
                end do
                if (ICONT == 0) cycle
                ! Derivate relative al raggio di NSI: 2) raggio delle altre sfere
                call dSd(1,IJunk,NSK,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
                DERTS = DERTS-DERS*Sphere(4,NSK)*DR/Sphere(4,NSI)
                DERPT(:) = DERPT(:)-DERP(:)*Sphere(4,NSK)*DR/Sphere(4,NSI)
                ! Derivate relative al raggio di NSI: 3) coord. delle altre sfere
                DISTKI(1) = Sphere(1,NSK)-Sphere(1,NSI)
                DISTKI(2) = Sphere(2,NSK)-Sphere(2,NSI)
                DISTKI(3) = Sphere(3,NSK)-Sphere(3,NSI)
                FAC = DR/Sphere(4,NSI)
                do JJ=1,3
                  call dSd(0,JJ,NSK,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
                  if (DISTKI(JJ) /= ZERO) then
                    DERTS = DERTS-FAC*DERS*DISTKI(JJ)
                    DERPT(:) = DERPT(:)-FAC*DERP(:)*DISTKI(JJ)
                  end if
                end do
                ! Derivate relative alle coordinate di NSI
                call dSd(0,1,NSK,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
                DERTS = DERTS-DX*DERS
                DERPT(:) = DERPT(:)-DX*DERP(:)
                call dSd(0,2,NSK,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
                DERTS = DERTS-DY*DERS
                DERPT(:) = DERPT(:)-DY*DERP(:)
                call dSd(0,3,NSK,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
                DERTS = DERTS-DZ*DERS
                DERPT(:) = DERPT(:)-DZ*DERP(:)
              end do
              DERTES(ITS,NSJ,ICOORD) = DERTES(ITS,NSJ,ICOORD)+DERTS
              DERPUNT(ITS,NSJ,ICOORD,:) = DERPUNT(ITS,NSJ,ICOORD,:)+DERPT(:)
            else
              ! Derivate delle tessere tagliate da NSA
              ICONT = 0
              do N=1,NV
                if (INTSPH(N,ITs) == NSA) ICONT = ICONT+1
              end do
              if (ICONT == 0) cycle
              ! Derivate relative al raggio di NSA
              call dSd(1,IJunk,NSA,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
              DERTS = DERS*DR
              DERPT(:) = DERP(:)*DR
              ! Derivate relative alle coordinate di NSA
              call dSd(0,1,NSA,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
              DERTS = DERTS+DX*DERS
              DERPT(:) = DERPT(:)+DX*DERP(:)
              call dSd(0,2,NSA,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
              DERTS = DERTS+DY*DERS
              DERPT(:) = DERPT(:)+DY*DERP(:)
              call dSd(0,3,NSA,DERS,DERP,Tessera(:,ITS),Vert(:,:,ITS),Centr(:,:,ITS),Sphere,NSI,IntSph(:,ITS),NV)
              DERTS = DERTS+DZ*DERS
              DERPT(:) = DERPT(:)+DZ*DERP(:)

              DERTES(ITS,NSJ,ICOORD) = DERTES(ITS,NSJ,ICOORD)+DERTS
              DERPUNT(ITS,NSJ,ICOORD,:) = DERPUNT(ITS,NSJ,ICOORD,:)+DERPT(:)
            end if
          end do
        end do
      end do
    end do

    ! Controlla che nessuna derivata sia eccessiva (per imprecisioni numeriche)
    do ITS=1,NTS
      if (abs(DERTES(ITS,NSJ,ICOORD)) > Ten) then
        if (IPrint >= 2) then
          write(u6,*) 'DERIVATA GEOMETRICA ECCESSIVA TRASCURATA'
          write(u6,*) 'TESSERA, SFERA, COORDINATA',ITS,NESFJ,ICOORD
        end if
        DERTES(ITS,NSJ,ICOORD) = Zero
      end if
    end do

    ! End of loop on atoms and coordinates

  end do
end do outer
! Put the geometric quantities in Bohr again
ToBohr = One/Angstrom
Tessera(1:3,:) = ToBohr*Tessera(1:3,:)
Tessera(4,:) = ToBohr*ToBohr*Tessera(4,:)
Sphere(:,:) = ToBohr*Sphere(:,:)
Vert(:,:,:) = ToBohr*Vert(:,:,:)
Centr(:,:,:) = ToBohr*Centr(:,:,:)

return

10 format(/,'SFERA ',I3,/,'AL LIVELLO 5 LA SFERA',I3," E' AGGIUNTA")

end subroutine Deriva

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine dev2c_2_cvb(v1,cfrom,hessorb,oaa2)
! Calculates V1 EijEkl CFROM

use casvb_global, only: absym, i1alf, i1bet, iafrm, iapr, iato, ibfrm, ibpr, ibto, ixapr, ixbpr, n1a, n1b, nda, ndb, norb, nprorb, &
                        phato, phbto, projcas, sc
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: v1(nda,ndb), cfrom(nda,ndb), oaa2
real(kind=wp), intent(inout) :: hessorb(nprorb,nprorb)
integer(kind=iwp) :: i1, i2, i3, i4, ia, iax, iaxtmp, ib, ibx, ibxtmp, iorb, iprm1, iprm2, itmp, ixa, ixb, jax, jbx, jorb, kax, &
                     kbx, korb, lax, lbx, lorb
real(kind=wp) :: phase, res1, tcof, term

do iprm1=1,nprorb
  i1 = (iprm1-1)/(norb-1)+1
  i2 = iprm1-(i1-1)*(norb-1)
  if (i2 >= i1) i2 = i2+1
  do iprm2=1,iprm1
    i3 = (iprm2-1)/(norb-1)+1
    i4 = iprm2-(i3-1)*(norb-1)
    if (i4 >= i3) i4 = i4+1
    if ((i1 /= i4) .or. (i2 == i3)) then
      iorb = i3
      jorb = i4
      korb = i1
      lorb = i2
    else
      iorb = i1
      jorb = i2
      korb = i3
      lorb = i4
    end if
    res1 = Zero
    if (projcas .and. (.not. sc)) then
      ! 1) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          ! I -> J
          do ixa=ixapr(iax),ixapr(iax+1)-1
            ibx = iapr(ixa)
            ! 2. alpha k -> l
            itmp = iafrm(korb,jax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(kax,ibx)*term
            end if
            ! 2. alpha l -> k
            itmp = iafrm(lorb,iax)
            lax = iato(korb,itmp)
            if (lax /= 0) then
              phase = phato(lorb,itmp)*phato(korb,itmp)
              term = tcof*phase*cfrom(lax,ibx)
              res1 = res1-v1(jax,ibx)*term
            end if
            ! 2. beta  k -> l
            itmp = ibfrm(korb,ibx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(jax,kbx)*term
            end if
            ! 2. beta  l -> k
            itmp = ibfrm(lorb,ibx)
            lbx = ibto(korb,itmp)
            if (lbx /= 0) then
              phase = phbto(lorb,itmp)*phbto(korb,itmp)
              term = tcof*phase*cfrom(iax,lbx)
              res1 = res1-v1(jax,ibx)*term
            end if
          end do
          ! J -> I
          do ixa=ixapr(jax),ixapr(jax+1)-1
            ibx = iapr(ixa)
            ! 2. alpha k -> l
            itmp = iafrm(korb,jax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1-v1(kax,ibx)*term
            end if
            ! 2. alpha l -> k
            itmp = iafrm(lorb,iax)
            lax = iato(korb,itmp)
            if (lax /= 0) then
              phase = phato(lorb,itmp)*phato(korb,itmp)
              term = tcof*phase*cfrom(lax,ibx)
              res1 = res1+v1(jax,ibx)*term
            end if
            ! 2. beta  k -> l
            itmp = ibfrm(korb,ibx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1-v1(jax,kbx)*term
            end if
            ! 2. beta  l -> k
            itmp = ibfrm(lorb,ibx)
            lbx = ibto(korb,itmp)
            if (lbx /= 0) then
              phase = phbto(lorb,itmp)*phbto(korb,itmp)
              term = tcof*phase*cfrom(iax,lbx)
              res1 = res1+v1(jax,ibx)*term
            end if
          end do
        end if
      end do

      if (absym(3)) then
        res1 = Two*res1
      else
        ! 2) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            ! I -> J
            do ixb=ixbpr(ibx),ixbpr(ibx+1)-1
              iax = ibpr(ixb)
              ! 2. beta  k -> l
              itmp = ibfrm(korb,jbx)
              kbx = ibto(lorb,itmp)
              if (kbx /= 0) then
                phase = phbto(korb,itmp)*phbto(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1+v1(iax,kbx)*term
              end if
              ! 2. beta  l -> k
              itmp = ibfrm(lorb,ibx)
              lbx = ibto(korb,itmp)
              if (lbx /= 0) then
                phase = phbto(lorb,itmp)*phbto(korb,itmp)
                term = tcof*phase*cfrom(iax,lbx)
                res1 = res1-v1(iax,jbx)*term
              end if
              ! 2. alpha k -> l
              itmp = iafrm(korb,iax)
              kax = iato(lorb,itmp)
              if (kax /= 0) then
                phase = phato(korb,itmp)*phato(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1+v1(kax,jbx)*term
              end if
              ! 2. alpha l -> k
              itmp = iafrm(lorb,iax)
              lax = iato(korb,itmp)
              if (lax /= 0) then
                phase = phato(lorb,itmp)*phato(korb,itmp)
                term = tcof*phase*cfrom(lax,ibx)
                res1 = res1-v1(iax,jbx)*term
              end if
            end do
            ! J -> I
            do ixb=ixbpr(jbx),ixbpr(jbx+1)-1
              iax = ibpr(ixb)
              ! 2. beta  k -> l
              itmp = ibfrm(korb,jbx)
              kbx = ibto(lorb,itmp)
              if (kbx /= 0) then
                phase = phbto(korb,itmp)*phbto(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1-v1(iax,kbx)*term
              end if
              ! 2. beta  l -> k
              itmp = ibfrm(lorb,ibx)
              lbx = ibto(korb,itmp)
              if (lbx /= 0) then
                phase = phbto(lorb,itmp)*phbto(korb,itmp)
                term = tcof*phase*cfrom(iax,lbx)
                res1 = res1+v1(iax,jbx)*term
              end if
              ! 2. alpha k -> l
              itmp = iafrm(korb,iax)
              kax = iato(lorb,itmp)
              if (kax /= 0) then
                phase = phato(korb,itmp)*phato(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1-v1(kax,jbx)*term
              end if
              ! 2. alpha l -> k
              itmp = iafrm(lorb,iax)
              lax = iato(korb,itmp)
              if (lax /= 0) then
                phase = phato(lorb,itmp)*phato(korb,itmp)
                term = tcof*phase*cfrom(lax,ibx)
                res1 = res1+v1(iax,jbx)*term
              end if
            end do
          end if
        end do
      end if
    else if ((.not. projcas) .and. (.not. sc)) then
      ! 1) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          ! I -> J
          do ixa=ixapr(iax),ixapr(iax+1)-1
            ibx = iapr(ixa)
            ! 2. alpha k -> l
            itmp = iafrm(korb,jax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(kax,ibx)*term
            end if
            ! 2. beta  k -> l
            itmp = ibfrm(korb,ibx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(jax,kbx)*term
            end if
          end do
        end if
      end do

      if (absym(3)) then
        res1 = Two*res1
      else
        ! 2) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            ! I -> J
            do ixb=ixbpr(ibx),ixbpr(ibx+1)-1
              iax = ibpr(ixb)
              ! 2. beta  k -> l
              itmp = ibfrm(korb,jbx)
              kbx = ibto(lorb,itmp)
              if (kbx /= 0) then
                phase = phbto(korb,itmp)*phbto(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1+v1(iax,kbx)*term
              end if
              ! 2. alpha k -> l
              itmp = iafrm(korb,iax)
              kax = iato(lorb,itmp)
              if (kax /= 0) then
                phase = phato(korb,itmp)*phato(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1+v1(kax,jbx)*term
              end if
            end do
          end if
        end do
      end if
    else if (projcas .and. sc) then
      ! 1) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          ! I -> J
          ibx = ndb-iax+1
          ! 2. alpha k -> l
          itmp = iafrm(korb,jax)
          kax = iato(lorb,itmp)
          if (kax /= 0) then
            phase = phato(korb,itmp)*phato(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1+v1(kax,ibx)*term
          end if
          ! 2. alpha l -> k
          itmp = iafrm(lorb,iax)
          lax = iato(korb,itmp)
          if (lax /= 0) then
            phase = phato(lorb,itmp)*phato(korb,itmp)
            term = tcof*phase*cfrom(lax,ibx)
            res1 = res1-v1(jax,ibx)*term
          end if
          ! 2. beta  k -> l
          itmp = ibfrm(korb,ibx)
          kbx = ibto(lorb,itmp)
          if (kbx /= 0) then
            phase = phbto(korb,itmp)*phbto(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1+v1(jax,kbx)*term
          end if
          ! 2. beta  l -> k
          itmp = ibfrm(lorb,ibx)
          lbx = ibto(korb,itmp)
          if (lbx /= 0) then
            phase = phbto(lorb,itmp)*phbto(korb,itmp)
            term = tcof*phase*cfrom(iax,lbx)
            res1 = res1-v1(jax,ibx)*term
          end if
          ! J -> I
          ibx = ndb-jax+1
          ! 2. alpha k -> l
          itmp = iafrm(korb,jax)
          kax = iato(lorb,itmp)
          if (kax /= 0) then
            phase = phato(korb,itmp)*phato(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1-v1(kax,ibx)*term
          end if
          ! 2. alpha l -> k
          itmp = iafrm(lorb,iax)
          lax = iato(korb,itmp)
          if (lax /= 0) then
            phase = phato(lorb,itmp)*phato(korb,itmp)
            term = tcof*phase*cfrom(lax,ibx)
            res1 = res1+v1(jax,ibx)*term
          end if
          ! 2. beta  k -> l
          itmp = ibfrm(korb,ibx)
          kbx = ibto(lorb,itmp)
          if (kbx /= 0) then
            phase = phbto(korb,itmp)*phbto(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1-v1(jax,kbx)*term
          end if
          ! 2. beta  l -> k
          itmp = ibfrm(lorb,ibx)
          lbx = ibto(korb,itmp)
          if (lbx /= 0) then
            phase = phbto(lorb,itmp)*phbto(korb,itmp)
            term = tcof*phase*cfrom(iax,lbx)
            res1 = res1+v1(jax,ibx)*term
          end if
        end if
      end do

      if (absym(3)) then
        res1 = Two*res1
      else
        ! 2) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            ! I -> J
            iax = nda-ibx+1
            ! 2. beta  k -> l
            itmp = ibfrm(korb,jbx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(iax,kbx)*term
            end if
            ! 2. beta  l -> k
            itmp = ibfrm(lorb,ibx)
            lbx = ibto(korb,itmp)
            if (lbx /= 0) then
              phase = phbto(lorb,itmp)*phbto(korb,itmp)
              term = tcof*phase*cfrom(iax,lbx)
              res1 = res1-v1(iax,jbx)*term
            end if
            ! 2. alpha k -> l
            itmp = iafrm(korb,iax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(kax,jbx)*term
            end if
            ! 2. alpha l -> k
            itmp = iafrm(lorb,iax)
            lax = iato(korb,itmp)
            if (lax /= 0) then
              phase = phato(lorb,itmp)*phato(korb,itmp)
              term = tcof*phase*cfrom(lax,ibx)
              res1 = res1-v1(iax,jbx)*term
            end if
            ! J -> I
            iax = nda-jbx+1
            ! 2. beta  k -> l
            itmp = ibfrm(korb,jbx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1-v1(iax,kbx)*term
            end if
            ! 2. beta  l -> k
            itmp = ibfrm(lorb,ibx)
            lbx = ibto(korb,itmp)
            if (lbx /= 0) then
              phase = phbto(lorb,itmp)*phbto(korb,itmp)
              term = tcof*phase*cfrom(iax,lbx)
              res1 = res1+v1(iax,jbx)*term
            end if
            ! 2. alpha k -> l
            itmp = iafrm(korb,iax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1-v1(kax,jbx)*term
            end if
            ! 2. alpha l -> k
            itmp = iafrm(lorb,iax)
            lax = iato(korb,itmp)
            if (lax /= 0) then
              phase = phato(lorb,itmp)*phato(korb,itmp)
              term = tcof*phase*cfrom(lax,ibx)
              res1 = res1+v1(iax,jbx)*term
            end if
          end if
        end do
      end if
    else if ((.not. projcas) .and. sc) then
      ! 1) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          ! I -> J
          ibx = ndb-iax+1
          ! 2. alpha k -> l
          itmp = iafrm(korb,jax)
          kax = iato(lorb,itmp)
          if (kax /= 0) then
            phase = phato(korb,itmp)*phato(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1+v1(kax,ibx)*term
          end if
          ! 2. beta  k -> l
          itmp = ibfrm(korb,ibx)
          kbx = ibto(lorb,itmp)
          if (kbx /= 0) then
            phase = phbto(korb,itmp)*phbto(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1+v1(jax,kbx)*term
          end if
        end if
      end do

      if (absym(3)) then
        res1 = Two*res1
      else
        ! 2) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            ! I -> J
            iax = nda-ibx+1
            ! 2. beta  k -> l
            itmp = ibfrm(korb,jbx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(iax,kbx)*term
            end if
            ! 2. alpha k -> l
            itmp = iafrm(korb,iax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(kax,jbx)*term
            end if
          end if
        end do
      end if
    end if
    hessorb(iprm1,iprm2) = hessorb(iprm1,iprm2)+oaa2*res1
    hessorb(iprm2,iprm1) = hessorb(iprm1,iprm2)
  end do
end do

return

end subroutine dev2c_2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Per-Olof Widmark                                 *
*               1993,1996,1997, Markus P. Fuelscher                    *
*               1996, Luis Serrano-Andres                              *
*               2012, Victor P. Vysotskiy                              *
************************************************************************
      Subroutine DaEras(Lu)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Close unit Lu and remove the file                                *
*                                                                      *
*     calling arguments:                                               *
*     Lu      : integer, input                                         *
*               logical unit number                                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, IBM Sweden, 1991                                   *
*     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
*     L. Serrano-Andres, University of Lund, Sweden, 1996              *
*     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

#include "fio.fh"
      Character*80 Text
      Character*16 TheName
      Data TheName/'DaEras'/


      If ( Trace ) then
        Write (6,*) ' >>> Enter DaEras <<<'
        Write (6,*) ' unit :',Lu
      End If

*     Save calling arguments

      If ( (Lu.le.0) .or. (Lu.gt.MxFile) )
     * Call SysFileMsg(TheName,'MSG: unit', Lu,' ')

      If ( isOpen(Lu).eq.0 )
     * Call SysFileMsg(TheName,'MSG: used', Lu,' ')
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      If(isFiM(Lu).eq.0) then
#endif
        iRc = AixCls(FSCB(Lu))
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      Else
        iRc=FimCls(FSCB(Lu))
      End If
#endif
      If ( iRc.ne.0 ) then
        iRc = AixErr(Text)
        Call SysFileMsg(TheName,'MSG: close', Lu,Text)
      End If
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      If(isFiM(Lu).eq.0) then
#endif
        iRc = AixRm(LuName(Lu))
        If ( iRc.ne.0 ) then
          iRc = AixErr(Text)
        Call SysFileMsg(TheName,'MSG: delete', Lu,Text)
        End If
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      End If
#endif
      isOpen(Lu) = 0

      If ( Multi_File(Lu) ) then
        If ( MaxFileSize.ne.0 ) then
          If ( Trace ) Then
            Write (6,*) ' This is a partitioned data set'
          End If
          Do i = 1,MaxSplitFile-1
            Lu_=MPUnit(i,Lu)
            If ( Lu_.ge.1 ) Then
              If ( isOpen(Lu_).ne.0 ) Then
                iRc = AixCls(FSCB(Lu_))
                If ( iRc.ne.0 ) then
                  iRc = AixErr(Text)
                  Call SysFileMsg(TheName,'MSG: close', Lu_,Text)
                End If
                iRc = AixRm(LuName(Lu_))
                If ( iRc.ne.0 ) then
                  iRc = AixErr(Text)
                  Call SysFileMsg(TheName,'MSG: delete', Lu_,Text)
                End If
                isOpen(Lu_) = 0
              End If
            End If
          End Do
        End If
      End If

      If ( Trace ) then
        Write (6,*) ' >>> Exit DaEras <<<'
      End If


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Init_Tsk2(id,mTask,jOpt,List)

use RI_glob, only: TskList, iOpt, iRsv, nTask
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: id
integer(kind=iwp), intent(in) :: mTask, jOpt, List(*)  ! either nTask or 0 long

nTask = mTask
iOpt = jOpt
if (iOpt == 0) then
  call Init_Tsk(id,nTask)
else if (iOpt == 1) then
  call mma_allocate(TskList,nTask,Label='TskList')
  TskList(1:nTask) = List(1:nTask)
  id = 0
  iRsv = 1
else
  call WarningMessage(2,'Error in Init_Tsk2')
  write(u6,*) 'Init_Tsk2: illegal iOpt value!'
  call Abend()
end if

return

end subroutine Init_Tsk2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine triang(nrow,a)
! Convert a square matrix to triangular in-place.

use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nrow
real(kind=wp), intent(inout) :: a(nrow**2)
integer(kind=iwp) :: i, ij, j, ji
real(kind=wp) :: symm

do i=2,nrow
  do j=1,i-1
    ij = i+(j-1)*nrow
    ji = j+(i-1)*nrow
    symm = Half*(a(ij)+a(ji))
    a(ji) = symm
    a(ij) = symm
  end do
end do
ij = 0
do i=1,nrow
  a(ij+1:ij+i) = a(nrow*(i-1)+1:nrow*(i-1)+i)
  ij = ij+i
end do

end subroutine triang

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
!                             A I X - I / O                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! rc=AixRm(FileName)                                                   *
!                                                                      *
! Erase file with specified file name.                                 *
!                                                                      *
! Input:  FileName - This file will be erased. Given as a character    *
!                    string.                                           *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          S&TC, ACIS, IBM Sweden                                      *
! Written: November 1990                                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! History:                                                             *
!                                                                      *
!***********************************************************************

function AixRm(filename)

use Fast_IO, only: eBlNme, eTlFn
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: AixRm
character(len=*), intent(in) :: filename
integer(kind=iwp) :: n, ltmp, rc
character(len=256) :: tmp, outname
character(len=80) :: ErrTxt
interface
  function AixErr(FileName) bind(C,name='aixerr_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: AixErr
    character(kind=c_char) :: FileName(*)
  end function AixErr
  function c_remove(FileName) bind(C,name='c_remove_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: c_remove
    character(kind=c_char) :: FileName(*)
  end function c_remove
end interface

!----------------------------------------------------------------------*
! Entry to AixRm                                                       *
!----------------------------------------------------------------------*
AixRm = 0
!----------------------------------------------------------------------*
! Strip file name and append string terminator                         *
!----------------------------------------------------------------------*
n = len(filename)
do
  if (filename(n:n) /= ' ') exit
  n = n-1
  if (n <= 0) then
    AixRm = eBlNme
    return
  end if
end do
n = n+1
if (n >= len(tmp)) then
  AixRm = eTlFn
  return
end if
tmp = filename
tmp(n:n) = char(0)
!----------------------------------------------------------------------*
! erase file                                                           *
!----------------------------------------------------------------------*
outname = ' '

call PrgmTranslate(filename,outname,ltmp)
outname(ltmp+1:ltmp+1) = char(0)
rc = c_remove(outname)
if (rc /= 0) then
  AixRm = AixErr(ErrTxt)
  call SysAbendMsg('AixRm','MSG: delete',ErrTxt)
  return
end if
!----------------------------------------------------------------------*
! Finished so return to caller                                         *
!----------------------------------------------------------------------*
return

end function AixRm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Drv_AMFI(Label,ip,lOper,nComp,rHrmt,iChO, iAtmNr2,
     &                    Charge2)
      use iSD_data
      use Basis_Info
      use DKH_Info, only: DKroll
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
      External Rsv_Tsk
#include "Molcas.fh"
#include "angtp.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "nsd.fh"
#include "setup.fh"
#include "para.fh"
      Integer, Allocatable :: iDel(:)
      Real*8, Allocatable :: SOInt(:)
      Real*8 Coor(3)
      Logical EQ, IfTest, Rsv_Tsk
      Character Label*8
      Integer ip(nComp), lOper(nComp), iChO(nComp)
      Integer iAtmNr2(mxdbsc)
      Real*8 Charge2(mxdbsc)
      Data IfTest/.False./
*
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      IfTest=.True.
      Write (6,*) ' In OneEl: Label', Label
      Write (6,*) ' In OneEl: nComp'
      Write (6,'(1X,8I5)') nComp
      Write (6,*) ' In OneEl: lOper'
      Write (6,'(1X,8I5)') lOper
      Write (6,*) ' In OneEl: n2Tri'
      Do iComp = 1, nComp
         ip(iComp) = n2Tri(lOper(iComp))
      End Do
      Write (6,'(1X,8I5)') (ip(iComp),iComp=1,nComp)
#endif
*
      Eta_Nuc=Zero
*
*     Allocate memory for symmetry adapted one electron integrals.
*     Will just store the unique elements, i.e. low triangular blocks
*     and lower triangular elements in the diagonal blocks.
*
      ip(:)=-1
      LenTot=0
      Do iComp = 1, nComp
         ip(iComp)=1+LenTot
         LenInt=n2Tri(lOper(iComp))
         LenTot=LenTot+LenInt+4
      End Do
      Call mma_allocate(SOInt,LenTot,label='SOInt')
      SOInt(:)=Zero
*
*---- Generate list of shell information
*
      Call Nr_Shells(nSkal)
*
*---- Check that there are not several instances of the same center.
*
      nCenter=0
      Do iSkal=1,nSkal
         nCenter=Max(nCenter,iSD(10,iSkal))
         If (iSD(1,iSkal).gt.Lmax) Then
            Write (6,*) ' Shells higher than '
     &                 //Angtp(Lmax)//'-functions not allowed in AMFI.'
            Call Quit_OnUserError()
         End If
         If (iSD(1,iSkal).ge.2.and.iAnd(iSD(9,iSkal),1).ne.1) Then
            Write (6,*) ' Only real spherical harmonics allowed'
            Write (6,*) ' for AMFI.'
            Call Quit_OnUserError()
         End If
      End Do
      Coor(:)=Zero
      Do iCenter=1,nCenter
*
*        Identify which dbsc this center belongs.
*
         iCnttp=0
         Do iSkal=1,nSkal
            If (iSD(10,iSkal).eq.iCenter) Then
               iCnttp=iSD(13,iSkal)
               iCnt  =iSD(14,iSkal)
               Coor(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
            End If
         End Do
*
*        If iCenter is not a center in the current list of shells that
*        is to be processed then test the next iCenter.
*
         If (iCnttp.eq.0) Cycle
*
         Do iSkal=1,nSkal
            If (iSD(13,iSkal).ne.iCnttp .and.
     &          iSD(10,iSkal).ne.iCenter) Then
               jCnttp=iSD(13,iSkal)
               jCnt  =iSD(14,iSkal)
               If (  EQ(Coor, dbsc(jCnttp)%Coor(1,jCnt)) ) Then
                  Write (6,*) 'Multiple instances of the same center!'
                  Write (6,*) 'This is not allowed with AMFI.'
                  Call Quit_OnUserError()
               End If
            End If
         End Do
      End Do
      If (MolWgh.ne.0 .and. MolWgh.ne.2) Then
         Write (6,*) ' AMFI integrals not implemented for symmetry'
     &                //' adaptation a la MOLECULE'
         Call Quit_OnUserError()
      End If
*
*---- Loop over unique center. Observe that multiple shells of the same
*     angular momentum is not allowed.
*
      Lu_AMFI=21
      LUPROP=22
      call molcas_open(Lu_AMFI,'AMFI_INP')
      call molcas_binaryopen_vanilla(LUPROP,'AMFI_INT')
      nCenter_node=0
*
      Call Init_Tsk(id_Tsk,nCenter)
 10   Continue
      If (.Not.Rsv_Tsk(id_Tsk,iCenter)) Go To 11
*     Do iCenter = 1, nCenter
         nCenter_node=nCenter_node+1
*
         Write (Lu_AMFI,'(A)') ' &AMFI &END'
         If (IfTest) Write (6,'(A)') ' &AMFI &END'
*
*------- Find atom type
*
         mdci=0
         Do iCnttp = 1, nCnttp
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               mdci=mdci+1
               If (mdci.eq.iCenter) Then
               If ((.Not.DKroll).and.(.Not.dbsc(iCnttp)%SODK))
     &            Write (Lu_AMFI,'(A)') 'Breit-Pauli'
                  If (IfTest) Then
                  If (.Not.DKroll.and..Not.dbsc(iCnttp)%SODK)
     &            Write (6,'(A)') 'Breit-Pauli'
               End If
                  If (iAtmNr2(iCnttp).ge.1) Then
                     charge_x=DBLE(iAtmNr2(iCnttp))
                  Else If (iAtmNr2(iCnttp).le.0 .and.
     &                Charge2(iCnttp).eq.Zero) Then
                     charge_x=0.0D0
                  Else
                     Write (6,*) 'Drv_AMFI: Invalid basis!'
                     Write (6,*) 'iAtmNr=',iAtmNr2(iCnttp)
                     Write (6,*) 'Charge2=',Charge2(iCnttp)
                     Call Abend()
                  End If
                  If (Nuclear_Model.eq.Gaussian_Type) Then
                     Eta_Nuc=dbsc(iCnttp)%ExpNuc
                  End If
                  Go To 99
               End If
            End Do
         End Do
 99      Continue
*
         If (Nuclear_Model.eq.Gaussian_Type) Then
            Write (Lu_AMFI,'(A)') 'Finite'
            If (IfTest) Write (6,'(A)') 'Finite'
            Write (Lu_AMFI,*) Eta_Nuc
            If (IfTest) Write (6,*) Eta_Nuc
         End If
*
*------- Generate input for each atom
*
         l_max=-1
         Do iSkal = 1, nSkal
            If (iSD(10,iSkal).eq.iCenter)
     &         l_Max=Max(l_Max,iSD(1,iSkal))
         End Do
         If (l_max.gt.LMax) Then
            Write (6,*) 'AMFI integrals only implemented up to '
     &                 //Angtp(Lmax)//'-functions.'
            Call Quit_OnUserError()
         End If
*
*        Check if there are any core orbitals to be deleted
*
         nCore=0
         Do l = 0, l_max
            Do iSkal = 1, nSkal
               If (iSD(10,iSkal).eq.iCenter .and.
     &             iSD( 1,iSkal).eq.l) Then
*
                   iCnttp = iSD(13,iSkal)
                   If (dbsc(iCnttp)%nSOC.ne.0) Then
                      iShl  = dbsc(iCnttp)%iSOC+l
                      jShll  = dbsc(iCnttp)%iPrj+l
*                     nCore=nCore+Shells(jShll)%nBasis
                      nCore=nCore+dbsc(iCnttp)%kDel(l)
                   End If
               End If
            End Do
         End Do
         If (IfTest) Write (6,*) 'nCore: ', nCore
*
*        Set up delete array
*
         If (nCore.ne.0) Then
            lDel=l_Max+1
            Call mma_allocate(iDel,lDel,label='iDel')
            Do l = 0, l_max
               Do iSkal = 1, nSkal
                  If (iSD(10,iSkal).eq.iCenter .and.
     &                iSD( 1,iSkal).eq.l) Then
*
                      iCnttp = iSD(13,iSkal)
                      If (dbsc(iCnttp)%nSOC.ne.0) Then
                         iShll  = dbsc(iCnttp)%iSOC+l
                         jShll  = dbsc(iCnttp)%iPrj+l
*                        iDel(ip_iDel+l)=Shells(jShll)%nBasis
                         iDel(1+l)=dbsc(iCnttp)%kDel(l)
                      End If
                  End If
               End Do
            End Do
            Write (Lu_AMFI,'(A)') 'AIMP'
            Write (Lu_AMFI,*) lDel-1,(iDel(i),i=1,lDel)
            If (IfTest) Write (6,'(A)') 'AIMP'
            If (IfTest) Write (6,*) lDel, (iDel(i),i=1,lDel)
            Call mma_deallocate(iDel)
         End If
*
         Write (Lu_AMFI,'(A)') '     '
         Write (Lu_AMFI,'(3X,F5.1,I4)') charge_x, l_max
         If (IfTest) Write (6,*) charge_x, l_max
*
         Do l = 0, l_max
            Do iSkal = 1, nSkal
               If (iSD(10,iSkal).eq.iCenter .and.
     &             iSD( 1,iSkal).eq.l) Then
*
                   iCnttp = iSD(13,iSkal)
                   If (dbsc(iCnttp)%nSOC.eq.0) Then
*
*                     Use valence basis
*
                      iShll  = dbsc(iCnttp)%iVal+l
                      iCase  = 2
*
                   Else
*
*                     Use special valence basis in case of a ECP where the
*                     normal valence might not be adequate.
*
                      iShll  = dbsc(iCnttp)%iSOC+l
                      nBas_y = iSD( 3,iSkal)
                      iCase = 1
*
                   End If
                   nBas_x = Shells(iShll)%nBasis
                   nExp_x = Shells(iShll)%nExp
*
                   If (IfTest) Write (6,*)  'iShll=',iShll
                   Write (Lu_AMFI,*) nExp_x, nBas_x
                   If (IfTest) Write (6,*) nExp_x, nBas_x
                   Write (Lu_AMFI,*) (Shells(iShll)%Exp(iExp_x),
     &                                  iExp_x=1,nExp_x)
                   If (IfTest) Write (6,*) (Shells(iShll)%Exp(iExp_x),
     &                                       iExp_x=1,nExp_x)
                   Do iExp_x = 1, nExp_x
                      Write (Lu_AMFI,*)
     &                     (Shells(iShll)%Cff_c(iExp_x,iCff_x,iCase),
     &                              iCff_x=1,nBas_x)
                      If (IfTest) Write (6,*)
     &                     (Shells(iShll)%Cff_c(iExp_x,iCff_x,iCase),
     &                              iCff_x=1,nBas_x)
                   End Do
*
               End If
            End Do
         End Do
         Write (Lu_AMFI,'(A)') 'End of Input'
         If (IfTest) Write (6,'(A)') 'End of Input'
*
*
*------- Now call AMFI
*
         Rewind(Lu_AMFI)
         Call AMFI(Lu_AMFI,LUPROP,iCenter)
*
         Rewind(Lu_AMFI)
*
         Go To 10
 11   Continue
      Call Free_Tsk(id_Tsk)
*     End Do
      Close(Lu_AMFI)
*
*---- Now symmetry adopt.
*
      Rewind(LUPROP)
      Call SymTrafo(LUPROP,ip,lOper,nComp,nBas,nIrrep,Label,MolWgh,
     &              SOInt,LenTot)
*
      Close(LUPROP)
*
      Call mma_deallocate(SOInt)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(rHrmt)
         Call Unused_integer_array(iChO)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine appendint_cvb(c,number,iskip)
      implicit real*8 (a-h,o-z)
      character*(*)c
      character*10 format

      ibegin=len_trim_cvb(c)+1+iskip
      iend=len(c)

      format=' '
      if(number.ge.0)then
        limit=0
        do 100 itens=0,99
        limit=limit+9*(10**itens)
        if(number.le.limit)then
          write(format,'(a,i4.4,a)')'(i',itens+1,')'
          write(c(ibegin:iend),format)number
          return
        endif
100     continue
      else
        mnumber=-number
        limit=0
        do 200 itens=0,99
        limit=limit+9*(10**itens)
        if(mnumber.le.limit)then
          write(format,'(a,i4.4,a)')'(a,i',itens+1,')'
          write(c(ibegin:iend),format)'-',mnumber
          return
        endif
200     continue
      endif
      write(6,*)' Number too large in appendint :',number
      call abend_cvb()
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chk_OneHam(nBas)

use qmstat_global, only: MxSymQ
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nBas(MxSymQ)
integer(kind=iwp) :: iopt, irc, iSmLbl, Lu_One, nBT
real(kind=wp) :: dNorm
character(len=8) :: Label_Pure, Label_Read
real(kind=wp), allocatable :: OneP(:), OneR(:)
integer(kind=iwp), external :: IsFreeUnit
real(kind=r8), external :: dnrm2_

Lu_One = IsFreeUnit(49)
Label_Read = 'OneHam  '
Label_Pure = 'OneHam 0'
nBT = nTri_Elem(nBas(1))
call OpnOne(irc,0,'ONEINT',Lu_One)
call mma_allocate(OneR,nBT,label='Read')
call mma_allocate(OneP,nBT,label='Pure')

irc = -1
iopt = 6
iSmLbl = 0
call RdOne(irc,iopt,Label_Read,1,OneR,iSmLbl)
irc = -1
call RdOne(irc,iopt,Label_Pure,1,OneP,iSmLbl)
call ClsOne(irc,Lu_One)

OneP(:) = OneP-OneR

dNorm = dnrm2_(nBT,OneP,1)

if (dNorm > 1.0e-8_wp) then
  write(u6,*)
  write(u6,*)
  write(u6,*) ' WARNING!'
  write(u6,*)
  write(u6,*) '   Your one-electron hamiltonian is not purely vacuum. This means that the Hamiltonian'
  write(u6,*) '   in QmStat can be contaminated. Is this intentional? If not, then make sure that the ONEINT'
  write(u6,*) '   file comes directly from a Seward calculation without any calls from'
  write(u6,*) '   FFPT (or similar) in between.'
  write(u6,*)
  write(u6,*)
end if

call mma_deallocate(OneP)
call mma_deallocate(OneR)

return

end subroutine Chk_OneHam

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,
     &                 maxlab,labs,PrTot,iPL,iPoint,ifallorb)
************************************************************************
*                                                                      *
*     purpose: printing of tables for different tensor properties      *
*                                                                      *
*     Short           logical option for either Short (Short           *
*                     =.true., the total electronic contribution)      *
*                     long (Short=.false., orbital contributions)      *
*                     output                                           *
*     sig             the sign factor for the electronic contri-       *
*                     bution, positive for ndiamagnetic shielding      *
*     nIrrep          the number of irreducible representations        *
*     nBas            the number of functions in each representa-      *
*     (0:nIrrep-1)    tion                                             *
*     nTot            the total number of elements supplied for        *
*                     each component of the property tensor; equal     *
*                     either to 1 (total electronic and total nuc-     *
*                     lear contributions) or to the dimension of       *
*                     the basis set.                                   *
*     Occ(1:nTot)     Occupation numbers for all eigenvectors,         *
*                     a dummy for Short outputs                        *
*     ThrSV           threshold for Occupation numbers; if             *
*                     Occ(i).le.ThrSV the contribution will not        *
*                     be printed                                       *
*     PrEl(1:nTot,    matrix elements for all components 1,2,...,      *
*          1:maxlab)  maxlab, nTot entries for each component          *
*                                                                      *
*     PrNu(1:maxlab)  nuclear contributions for each component         *
*     maxlab          total number of cartesian components             *
*     labs(1:maxlab)  labels for each component                        *
*     TotEl(1:6)      auxiliary storage area                           *
*     PrTot(1:maxlab) Total value for each component                   *
*     iPL             Print level                                      *
*     iPoint          The number of the center                         *
*     ifallorb        logical option for whether the property of       *
*                     all orbitals are printed (and not weighted by    *
*                     occupation number)in property calculation when   *
*                     short=.false. (S.S.Dong, 2018)                   *
*                                                                      *
* 2000 Dept. of Chem. Phys., Univ. of Lund, Sweden                     *
* Modified by S.S.Dong, 2018, Univ. of Minnesota                       *
* - Enable properties to be printed for all orbitals                   *
* (including virtuals) and not weighted by occupation numbers          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Character*4 lbb4
      Character*16 labs(1:maxlab),lab
      Character*132 outlab
      Character*5 lab5
      Logical Short, ifallorb
      Integer nBas(0:nIrrep-1)
      Real*8 Occ(1:nTot), PrEl(1:nTot,1:maxlab),PrNu(1:maxlab),
     &       TotEl(1:6), PrTot(1:maxlab)
      Character Format1*18, Format2*13, Format3*14, Format4*14
*
      Format1='(2i5,f14.8,6f16.8)'
      Format2='(1x,a,6f16.8)'
      Format3='(1x,a,6f16.8/)'
      Format4='(a5,6f16.8)'
      Value=Zero
      Do i = 1, maxlab
         Value=Max(Value,Abs(PrNu(i)))
         Do j = 1, nTot
            Value=Max(Value,Abs(PrEl(j,i)))
         End Do
      End Do
      Value=Max(Value,One)
      nLog10=Max(1,INT(Log10(Value)+One)+1)
      nDec=Min(14-nLog10,8)
      Write(Format1(17:17),'(I1)') nDec
      Write(Format2(12:12),'(I1)') nDec
      Write(Format3(12:12),'(I1)') nDec
      Write(Format4(10:10),'(I1)') nDec
*
      If ((.Not.Short).and.(.Not.ifallorb)) Then
        Write (6,'(A,A,D9.2/)')
     &' orbital contributions printed for occupation numbers',
     &' gt.',ThrSV
      Else if ((.Not.Short).and.ifallorb) Then
        Write (6, '(A)')
     &' orbital properties printed for all occupation numbers'
      End If

*
      Do i = 1, maxlab, 6
*
         Do j=1,132
            outlab(j:j)=' '
         End Do
*
         If (Short) Then
            If (iPL.ge.3) Then
              If (maxlab.gt.1.or.labs(1).ne.'                ') Then
                Write(outlab,'(1x,a,6a16)') 'Component              ',
     &                                   (labs(j),j=i,min(i+5,maxlab))
                Write(6,'(a)') outlab(:mylen(outlab))
              End If
            End If
            jcount=0
            Do j=i,min(i+5,maxlab)
               jcount=jcount+1
               TotEl(jcount)=PrEl(1,j)
            End Do
         Else
            Do j=1,6
               TotEl(j)=Zero
            End Do
            Write (outlab,'(1x,a,6a16)') 'Irrep  Orb   Occupation',
     &                                (labs(j),j=i,min(i+5,maxlab))
            Write(6,'(a)') outlab(:mylen(outlab))
            lbb4='    '
            Write (outlab,'(33a4)') (lbb4,j=1,33)
            lbb4='----'
            lab ='----------------'
            Write (outlab,'(6a4,6a16)') (lbb4,j=1,6),
     &                              (lab,j=i,min(i+5,maxlab))
            Write(6,'(1x,a)') outlab(:mylen(outlab))
            icount=0
            Do ii=0,nIrrep-1
               Do jj=1,nBas(ii)
                  icount=icount+1
                  jcount=0
                  Do j=i,min(i+5,maxlab)
                     jcount=jcount+1
                     If (ifallorb) Then
                       TotEl(jcount)=TotEl(jcount)+PrEl(icount,j)
     &                 *Occ(icount)
                     Else If (.Not.ifallorb) Then
                       TotEl(jcount)=TotEl(jcount)+PrEl(icount,j)
                     End If
                  End Do
                  If (ifallorb.or.(Occ(icount).gt.ThrSV)) Then
                    Write (6,Format1) ii+1,jj,Occ(icount),
     &                         (sig*PrEl(icount,j),j=i,min(i+5,maxlab))
                  End If
               End Do
            End Do
            Write(6,'(1x,a)') outlab(:mylen(outlab))
         End if
*

         Do j=i,min(i+5,maxlab)
            PrTot(j)=sig*TotEl(j-i+1)+PrNu(j)
         End Do
         If (iPL.ge.3.or.(.Not.Short.and.iPL.eq.2)) Then
           Write(6,Format2)    'Total electronic       ',
     &              (sig*TotEl(j-i+1),j=i,min(i+5,maxlab))
           Write(6,Format2)    'Total nuclear          ',
     &              (PrNu(j),j=i,min(i+5,maxlab))
           Write(6,Format3)    'Total                  ',
     &              (PrTot(j),j=i,min(i+5,maxlab))
         Else
           lab5='     '
           If (iPoint.gt.0.and.i.eq.1) Write(lab5,'(I5)') iPoint
           Write(6,Format4) lab5,(PrTot(j),j=i,min(i+5,maxlab))
         End If
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine dev2c_cvb(v1,cfrom,hessorb,oaa2)
! Calculate V1 EijEkl CFROM

use casvb_global, only: iform_ci, n_2el, ndet, nprorb
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: v1(0:ndet), cfrom(0:ndet), hessorb(nprorb,nprorb), oaa2
integer(kind=iwp) :: icfrom

icfrom = nint(cfrom(0))
n_2el = n_2el+1
if (iform_ci(icfrom) /= 0) then
  write(u6,*) ' Unsupported format in DEV2C :',iform_ci(icfrom)
  call abend_cvb()
end if

call dev2c_2_cvb(v1(1:),cfrom(1:),hessorb,oaa2)

return

end subroutine dev2c_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1995, Roland Lindh                                *
************************************************************************
      SubRoutine DrvN1(Grad,Temp,nGrad)
************************************************************************
*                                                                      *
* Object: to compute the molecular gradient contribution due to the    *
*         nuclear repulsion energy.                                    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
*                                                                      *
*             Modified for ECP's and external electric fields, May '95 *
************************************************************************
      use Basis_Info
      use Center_Info
      use PCM_arrays, only: PCM_SQ, PCMTess, MM
      use External_Centers
      use Symmetry_Info, only: iChBas, nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "SysDef.fh"
#include "print.fh"
#include "real.fh"
#include "disp.fh"
#include "rctfld.fh"
#include "status.fh"
      Real*8 A(3), B(3), RB(3), Grad(nGrad), Temp(nGrad), DA(3),
     &       Tempd(3)
      Integer iDCRR(0:7), jCoSet(8,8), iStb(0:7)
      Logical EQ, TstFnc, NoLoop
      Character Lab*80
      iRout = 33
      iPrint = nPrint(iRout)
*     iPrint=15
*
      iIrrep = 0
*
************************************************************************
*                                                                      *
*            Compute the nuclear repulsion contribution                *
*                                                                      *
************************************************************************
*
      call dcopy_(nGrad,[Zero],0,Temp,1)
*
      mdc = 0
*-----Loop over centers with the same charge
      Do iCnttp = 1, nCnttp
         If (dbsc(iCnttp)%Frag) Then
           ZA = dbsc(iCnttp)%FragCharge
         Else
           ZA = dbsc(iCnttp)%Charge
         End If
         If (ZA.eq.Zero) Go To 101
*--------Loop over all unique centers of this group
         Do iCnt = 1, dbsc(iCnttp)%nCntr
            A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
            ndc = 0
            Do jCnttp = 1, iCnttp
               If (dbsc(jCnttp)%Frag) Then
                 ZB = dbsc(jCnttp)%FragCharge
               Else
                 ZB = dbsc(jCnttp)%Charge
               End If
               If (ZB.eq.Zero) Go To 201
               If (dbsc(iCnttp)%pChrg.and.dbsc(jCnttp)%pChrg) Go To 201
               If (dbsc(iCnttp)%Frag.and.dbsc(jCnttp)%Frag) Go To 201
               ZAZB = ZA * ZB
               jCntMx = dbsc(jCnttp)%nCntr
               If (iCnttp.eq.jCnttp) jCntMx = iCnt
               Do jCnt = 1, jCntMx
                  B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
                  Fact = One
*                 Factor due to resticted summation
                  If (EQ(A,B)) Fact = Half
*
*                 Find the DCR for the two centers
*
                  Call DCR(LmbdR,
     &                     dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,
     &                     dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                     iDCRR,nDCRR)
*
                  PreFct = Fact*ZAZB*DBLE(nIrrep)/DBLE(LmbdR)
                  Do iR = 0, nDCRR-1
                     Call OA(iDCRR(iR),B,RB)
                     nOp = NrOpr(iDCRR(iR))
                     If (EQ(A,RB)) Go To 301
                     r12 = Sqrt((A(1)-RB(1))**2 +
     &                          (A(2)-RB(2))**2 +
     &                          (A(3)-RB(3))**2 )
*
*                    The factor u/g will ensure that the value of the
*                    gradient in symmetry adapted and no symmetry basis
*                    will have the same value.
*
                     fab=One
                     dfab=Zero
                     If (dbsc(iCnttp)%ECP) Then
*-----------------------Add contribution from M1 operator
                        Cnt0M1=Zero
                        Cnt1M1=Zero
                        Do iM1xp=1, dbsc(iCnttp)%nM1
                          Gamma =dbsc(iCnttp)%M1xp(iM1xp)
                          CffM1 =dbsc(iCnttp)%M1cf(iM1xp)
                          Cnt0M1=Cnt0M1+(CffM1*Exp(-Gamma*r12**2))
                          Cnt1M1=Cnt1M1+Gamma*(CffM1*Exp(-Gamma*r12**2))
                        End Do
                        fab=fab+Cnt0M1
                        dfab=dfab-Two*r12*Cnt1M1
*-----------------------Add contribution from M2 operator
                        Cnt0M2=Zero
                        Cnt1M2=Zero
                        Do iM2xp=1, dbsc(iCnttp)%nM2
                          Gamma =dbsc(iCnttp)%M2xp(iM2xp)
                          CffM2 =dbsc(iCnttp)%M2cf(iM2xp)
                          Cnt0M2=Cnt0M2+(CffM2*Exp(-Gamma*r12**2))
                          Cnt1M2=Cnt1M2+Gamma*(CffM2*Exp(-Gamma*r12**2))
                        End Do
                        fab=fab+r12*Cnt0M2
                        dfab=dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
                     End If
                     If (dbsc(jCnttp)%ECP) Then
*-----------------------Add contribution from M1 operator
                        Cnt0M1=Zero
                        Cnt1M1=Zero
                        Do iM1xp=1, dbsc(jCnttp)%nM1
                          Gamma =dbsc(jCnttp)%M1xp(iM1xp)
                          CffM1 =dbsc(jCnttp)%M1cf(iM1xp)
                          Cnt0M1=Cnt0M1+(CffM1*Exp(-Gamma*r12**2))
                          Cnt1M1=Cnt1M1+Gamma*(CffM1*Exp(-Gamma*r12**2))
                        End Do
                        fab=fab+Cnt0M1
                        dfab=dfab-Two*r12*Cnt1M1
*-----------------------Add contribution from M2 operator
                        Cnt0M2=Zero
                        Cnt1M2=Zero
                        Do iM2xp=1, dbsc(jCnttp)%nM2
                          Gamma =dbsc(jCnttp)%M2xp(iM2xp)
                          CffM2 =dbsc(jCnttp)%M2cf(iM2xp)
                          Cnt0M2=Cnt0M2+(CffM2*Exp(-Gamma*r12**2))
                          Cnt1M2=Cnt1M2+Gamma*(CffM2*Exp(-Gamma*r12**2))
                        End Do
                        fab=fab+r12*Cnt0M2
                        dfab=dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
                     End If
                     df_dr=(dfab*r12-fab)/r12**2
*
                     If (.Not.dbsc(iCnttp)%pChrg) Then
                     nDisp = IndDsp(mdc+iCnt,iIrrep)
                     igu=nIrrep/dc(mdc+iCnt)%nStab
                     Do iCar = 0, 2
                        dr_dA=(A(iCar+1)-RB(iCar+1))/r12
                        iComp = 2**iCar
                        If ( TstFnc(dc(mdc+iCnt)%iCoSet,
     &                     iIrrep,iComp,dc(mdc+iCnt)%nStab) ) Then
                           nDisp = nDisp + 1
                           If (Direct(nDisp)) Then
                              Temp(nDisp) = Temp(nDisp) +
     &                           One/DBLE(igu) * PreFct *
     &                           dr_dA * df_dr
                           End If
                        End If
                     End Do
                     End If
*
                     If (.Not.dbsc(jCnttp)%pChrg) Then
                     nDisp = IndDsp(ndc+jCnt,iIrrep)
                     igv=nIrrep/dc(ndc+jCnt)%nStab
                     Do iCar = 0, 2
                        dr_dB=-(A(iCar+1)-RB(iCar+1))/r12
                        iComp = 2**iCar
                        If ( TstFnc(dc(ndc+jCnt)%iCoSet,
     &                     iIrrep,
     &                     iComp,dc(ndc+jCnt)%nStab) ) Then
                           nDisp = nDisp + 1
                           If (Direct(nDisp)) Then
                              ps = DBLE(iPrmt(nOp,iChBas(2+iCar)))
                              Temp(nDisp) = Temp(nDisp) +
     &                           ps * One/DBLE(igv) * PreFct *
     &                           dr_dB * df_dr
                           End If
                        End If
                     End Do
                     End If
 301                 Continue
                  End Do
*
               End Do
 201           Continue
               ndc = ndc + dbsc(jCnttp)%nCntr
            End Do
         End Do
 101     Continue
         mdc = mdc + dbsc(iCnttp)%nCntr
      End Do
      If (iPrint.ge.15) Then
         Lab=' The Nuclear Repulsion Contribution'
         Call PrGrad(Lab,Temp,nGrad,ChDisp,5)
      End If
*
      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
************************************************************************
*                                                                      *
*           Compute contribution due to the external field             *
*                                                                      *
************************************************************************
*

      If (.Not.Allocated(XF)) Go To 666
*
      If((nOrd_XF.gt.1).or.(iXPolType.gt.0)) Then
         Call WarningMessage(2,'Error in DrvN1')
         Write(6,*)'Sorry, gradients are not implemented for'
         Write(6,*)'higher XF than dipoles or for polarisabilities'
         Call Quit_OnUserError()
      EndIf

      call dcopy_(nGrad,[Zero],0,Temp,1)
*
      iDum=0
      Do iFd = 1, nXF
         ZA   = XF(4,iFd)
         If(nOrd_XF.eq.0) Then
            DA(1:3)=Zero
         Else
            DA(1:3)= XF(5:7,iFd)
         EndIf
         NoLoop = ZA.eq.Zero .and. DA(1).eq.Zero .and. DA(2).eq.Zero
     &            .and. DA(3).eq.Zero
         If (NoLoop) Go To 102
         A(1:3)=XF(1:3,iFd)
         iChxyz=iChAtm(A)
         Call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)
*
         ndc = 0
         Do jCnttp = 1, nCnttp
            ZB = dbsc(jCnttp)%Charge
            If (ZB.eq.Zero) Go To 202
            If (dbsc(jCnttp)%pChrg) Go To 202
            If (dbsc(jCnttp)%Frag) Go To 202
            ZAZB = ZA * ZB
            Do jCnt = 1, dbsc(jCnttp)%nCntr
               B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
*              Find the DCR for the two centers
*
               Call DCR(LmbdR,
     &                  iStb,nStb,
     &                  dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                  iDCRR,nDCRR)
*
               PreFct = DBLE(nIrrep)/DBLE(LmbdR)
               Do iR = 0, nDCRR-1
                  Call OA(iDCRR(iR),B,RB)
                  nOp = NrOpr(iDCRR(iR))
                  If (EQ(A,RB)) Go To 302
                  r12 = Sqrt((A(1)-RB(1))**2 +
     &                       (A(2)-RB(2))**2 +
     &                       (A(3)-RB(3))**2 )
                  DARB=DA(1)*(A(1)-RB(1))+
     &                 DA(2)*(A(2)-RB(2))+
     &                 DA(3)*(A(3)-RB(3))

*
*                 The factor u/g will ensure that the value of the
*                 gradient in symmetry adapted and no symmetry basis
*                 will have the same value.
*
                  fab0=One
                  fab1=One
                  fab2=Three
                  If (dbsc(jCnttp)%ECP) Then
*--------------------Add contribution from M1 operator
                     Cnt0M1=Zero
                     Cnt1M1=Zero
                     Do iM1xp=1, dbsc(jCnttp)%nM1
                       Gamma = dbsc(jCnttp)%M1xp(iM1xp)
                       CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
                       Cnt0M1= Cnt0M1+(CffM1*Exp(-Gamma*r12**2))
                       Cnt1M1= Cnt1M1+Gamma*(CffM1*Exp(-Gamma*r12**2))
                     End Do
                     fab0=fab0+Cnt0M1-Two*r12**2*Cnt1M1
                     fab1=fab1+Cnt0M1
                     fab2=fab2+Three*Cnt0M1+Two*r12**2*Cnt1M1
*--------------------Add contribution from M2 operator
                     Cnt0M2=Zero
                     Cnt1M2=Zero
                     Do iM2xp=1, dbsc(jCnttp)%nM2
                       Gamma = dbsc(jCnttp)%M2xp(iM2xp)
                       CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
                       Cnt0M2= Cnt0M2+(CffM2*Exp(-Gamma*r12**2))
                       Cnt1M2= Cnt1M2+Gamma*(CffM2*Exp(-Gamma*r12**2))
                     End Do
                     fab0=fab0+Two*(r12*Cnt0M2-r12**3*Cnt1M2)
                     fab1=fab1+r12*Cnt0M2
                     fab2=fab2-Two*(r12*Cnt0M2-r12**3*Cnt1M2)
                  End If
*
                  nDisp = IndDsp(ndc+jCnt,iIrrep)
                  igv=nIrrep/dc(ndc+jCnt)%nStab
                  Do iCar = 0, 2
                     iComp = 2**iCar
                     If ( TstFnc(dc(ndc+jCnt)%iCoSet,
     &                  iIrrep,iComp,dc(ndc+jCnt)%nStab) ) Then
                        nDisp = nDisp + 1
                        If (Direct(nDisp)) Then
                           ps = DBLE(iPrmt(nOp,iChBas(2+iCar)))
                           Temp(nDisp) = Temp(nDisp) +
     &                        ps * One/DBLE(igv) * PreFct * (
     &                        ZAZB*fab0*(A(iCar+1)-RB(iCar+1))/(r12**3)
     &                       +ZB *(fab1*DA(iCar+1)            /(r12**3)
     &                       -DARB*fab2*(A(iCar+1)-RB(iCar+1))/(r12**5))
     &                        )
                        End If
                     End If
                  End Do   ! End loop over cartesian components, iCar
*
 302              Continue
               End Do      ! End loop over DCR operators, iR
*
            End Do         ! End over centers, jCnt
 202        Continue
            ndc = ndc + dbsc(jCnttp)%nCntr
         End Do            ! End over basis set types, jCnttp
 102     Continue
      End Do               ! End of centers of the external field, iFD
      If (iPrint.ge.15) Then
         Lab=' The Nuclear External Electric Field Contribution'
         Call PrGrad(Lab,Temp,nGrad,ChDisp,5)
      End If
*
      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
 666  Continue
*
************************************************************************
*                                                                      *
*          Compute contributions due to the reaction field             *
*                 KirkWood Model                                       *
*                                                                      *
************************************************************************
*
      If (lRF.and..Not.lLangevin.and..Not.PCM) Then
         nCav=(lMax+1)*(lMax+2)*(lMax+3)/6
*
*------- Get the multipole moments
*
         Call Get_dArray('RCTFLD',MM,nCav*2)
         If (iPrint.ge.99) Call RecPrt('Total Multipole Moments',' ',
     &                                 MM(1,1),1,nCav)
         If (iPrint.ge.99) Call RecPrt('Total Electric Field',
     &                                 ' ',MM(1,2),1,nCav)
*
      call dcopy_(nGrad,[Zero],0,Temp,1)
*
      ip = 0
      Do ir = 0, lMax
         Do ix = ir, 0, -1
            Do iy = ir-ix, 0, -1
               iz = ir-ix-iy
               ip = ip + 1
               If (iPrint.ge.99) Write (6,*) ' ix,iy,iz=',ix,iy,iz
*
               mdc = 0
               Do iCnttp = 1, nCnttp
                  If (dbsc(iCnttp)%Charge.eq.Zero) Go To 103
                  If (dbsc(iCnttp)%Frag) Go To 103
                  ZA = dbsc(iCnttp)%Charge
                  If (iPrint.ge.99) Then
                     Write (6,*) ' Charge=',ZA
                     Write (6,*) ' ixyz=',ixyz
                     Call RecPrt(' Centers',' ',
     &                           dbsc(iCnttp)%Coor,3,
     &                           dbsc(iCnttp)%nCntr)
                  End If
                  Do iCnt = 1, dbsc(iCnttp)%nCntr
                     A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)

                     If (ix.eq.0) Then
                        CCoMx =One
                        CCoMxd=Zero
                     Else If (ix.eq.1) Then
                        CCoMx =A(1)
                        CCoMxd=One
                     Else
                        CCoMx =A(1)**ix
                        CCoMxd=DBLE(ix)*A(1)**(ix-1)
                     End If
*
                     If (iy.eq.0) Then
                        CCoMy =One
                        CCoMyd=Zero
                     Else If (iy.eq.1) Then
                        CCoMy =A(2)
                        CCoMyd=One
                     Else
                        CCoMy =A(2)**iy
                        CCoMyd=DBLE(iy)*A(2)**(iy-1)
                     End If
*
                     If (iz.eq.0) Then
                        CCoMz =One
                        CCoMzd=Zero
                     Else If (iz.eq.1) Then
                        CCoMz =A(3)
                        CCoMzd=One
                     Else
                        CCoMz =A(3)**iz
                        CCoMzd=DBLE(iz)*A(3)**(iz-1)
                     End If
                     tempd(1)= MM(ip,2) *ZA * CCoMxd* CCoMy * CCoMz
                     tempd(2)= MM(ip,2) *ZA * CCoMx * CCoMyd* CCoMz
                     tempd(3)= MM(ip,2) *ZA * CCoMx * CCoMy * CCoMzd
                     If (iPrint.ge.99) Then
                        Write (6,*) CCoMx, CCoMy, CCoMz
                        Write (6,*) 'tempd=',tempd
                     End If
*
*                    Distribute gradient
*
                     nDisp=IndDsp(mdc+iCnt,iIrrep)
                     Do iCar = 0, 2
                        iComp = 2**iCar
                        If ( TstFnc(dc(mdc+iCnt)%iCoSet,
     &                     iIrrep,iComp,dc(mdc+iCnt)%nStab) ) Then
                           nDisp = nDisp + 1
                           If (Direct(nDisp)) Then
                              Temp(nDisp) = Temp(nDisp) - Tempd(iCar+1)
                           End If
                        End If
                     End Do

*
                  End Do
 103              Continue
                  mdc = mdc + dbsc(iCnttp)%nCntr
               End Do
*
            End Do
         End Do
      End Do
      If (iPrint.ge.15) Then
         Lab=' The Nuclear Reaction Field (KirkWood) Contribution'
         Call PrGrad(Lab,Temp,nGrad,ChDisp,5)
      End If
*
      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
      Else If(lRF.and.PCM) Then
*
************************************************************************
*                                                                      *
*          Compute contributions due to the reaction field             *
*                      PCM Model                                       *
*                                                                      *
************************************************************************
*
      call dcopy_(nGrad,[Zero],0,Temp,1)
*
*---- Loop over tiles
*
*
      Do iTs = 1, nTs
         ZA   = PCM_SQ(1,iTs)+PCM_SQ(2,iTS)
         NoLoop = ZA.eq.Zero
         ZA = ZA / DBLE(nIrrep)
         If (NoLoop) Go To 112
         A(1:3) = PCMTess(1:3,iTs)
*
*------- Tile only stabilized by the unit operator
*
         nStb=1
         iStb(0)=0
*
         ndc = 0
         Do jCnttp = 1, nCnttp
            ZB = dbsc(jCnttp)%Charge
            If (ZB.eq.Zero) Go To 212
            If (dbsc(jCnttp)%pChrg) Go To 212
            If (dbsc(jCnttp)%Frag) Go To 212
            ZAZB = ZA * ZB
            Do jCnt = 1, dbsc(jCnttp)%nCntr
               B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
*              Find the DCR for the two centers
*
               Call DCR(LmbdR,
     &                  iStb,nStb,
     &                  dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                  iDCRR,nDCRR)
*
               PreFct = ZAZB*DBLE(nIrrep)/DBLE(LmbdR)
               Do iR = 0, nDCRR-1
                  Call OA(iDCRR(iR),B,RB)
                  nOp = NrOpr(iDCRR(iR))
                  If (EQ(A,RB)) Go To 312
                  r12 = Sqrt((A(1)-RB(1))**2 +
     &                       (A(2)-RB(2))**2 +
     &                       (A(3)-RB(3))**2 )
*
*                 The factor u/g will ensure that the value of the
*                 gradient in symmetry adapted and no symmetry basis
*                 will have the same value.
*
                  fab=One
                  dfab=Zero
                  If (dbsc(jCnttp)%ECP) Then
*--------------------Add contribution from M1 operator
                     Cnt0M1=Zero
                     Cnt1M1=Zero
                     Do iM1xp=1, dbsc(jCnttp)%nM1
                       Gamma =dbsc(jCnttp)%M1xp(iM1xp)
                       CffM1 =dbsc(jCnttp)%M1cf(iM1xp)
                       Cnt0M1= Cnt0M1+(CffM1*Exp(-Gamma*r12**2))
                       Cnt1M1= Cnt1M1+Gamma*(CffM1*Exp(-Gamma*r12**2))
                     End Do
                     fab=fab+Cnt0M1
                     dfab=dfab-Two*r12*Cnt1M1
*--------------------Add contribution from M2 operator
                     Cnt0M2=Zero
                     Cnt1M2=Zero
                     Do iM2xp=1, dbsc(jCnttp)%nM2
                       Gamma =dbsc(jCnttp)%M2xp(iM2xp)
                       CffM2 =dbsc(jCnttp)%M2cf(iM2xp)
                       Cnt0M2= Cnt0M2+(CffM2*Exp(-Gamma*r12**2))
                       Cnt1M2= Cnt1M2+Gamma*(CffM2*Exp(-Gamma*r12**2))
                     End Do
                     fab=fab+r12*Cnt0M2
                     dfab=dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
                  End If
                  df_dr=(dfab*r12-fab)/r12**2
*
                  nDisp = IndDsp(ndc+jCnt,iIrrep)
                  igv=nIrrep/dc(ndc+jCnt)%nStab
                  Do iCar = 0, 2
                     dr_dB=-(A(iCar+1)-RB(iCar+1))/r12
                     iComp = 2**iCar
                     If ( TstFnc(dc(ndc+jCnt)%iCoSet,
     &                  iIrrep,iComp,dc(ndc+jCnt)%nStab) ) Then
                        nDisp = nDisp + 1
                        If (Direct(nDisp)) Then
                           ps = DBLE(iPrmt(nOp,iChBas(2+iCar)))
                           Temp(nDisp) = Temp(nDisp) +
     &                        ps * One/DBLE(igv) * PreFct *
     &                        dr_dB * df_dr
                        End If
                     End If
                  End Do   ! End loop over cartesian components, iCar
*
 312              Continue
               End Do      ! End loop over DCR operators, iR
*
            End Do         ! End over centers, jCnt
 212        Continue
            ndc = ndc + dbsc(jCnttp)%nCntr
         End Do            ! End over basis set types, jCnttp
 112     Continue
      End Do               ! End of tiles
*
      If (iPrint.ge.15) Then
         Lab=' The Nuclear Reaction Field (PCM) Contribution'
         Call PrGrad(Lab,Temp,nGrad,ChDisp,5)
      End If
*
      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
*---- Add contribution due to the tiles.
*
      Call FZero(Temp,nGrad)
      Call PCM_Cav_grd(Temp,nGrad)
      If (iPrint.ge.15) Then
         Lab=' The Cavity PCM Contribution'
         Call PrGrad(Lab,Temp,nGrad,ChDisp,5)
      End If
      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
*---- Add contribution due to the electric field on the tiles.
*
      If (Conductor) Then
         Call FZero(Temp,nGrad)
         Call PCM_EF_grd(Temp,nGrad)
         If (iPrint.ge.15) Then
            Lab=' The EF PCM Contribution'
            Call PrGrad(Lab,Temp,nGrad,ChDisp,5)
         End If
         Call DaXpY_(nGrad,-One,Temp,1,Grad,1)
      End If
*
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!               Francesco Aquilante                                    *
!***********************************************************************
!  Cho_X_CheckDiag
!
!> @brief
!>   Check diagonal
!> @author Thomas Bondo Pedersen
!> @modified_by F. Aquilante (add ::OneCenter_ChkDiag)
!> @modified_by T.B. Pedersen (If ``(Cho_1Center)``: \p Err only contains 1-center errors on exit)
!>
!> @details
!> This routine reads and analyzes (histogram and statistics)
!> the exact integral diagonal, computes and analyzes the
!> diagonal from Cholesky vectors,
!> and the difference between the two (exact minus Cholesky).
!>
!> The statistics printed are: minimum value, maximum
!> value, mean value, mean absolute value, variance (wrt mean
!> value), and standard deviation (wrt mean value).
!>
!> On exit:
!>
!> - \p Err(1) = min error
!> - \p Err(2) = max error
!> - \p Err(3) = average error
!> - \p Err(4) = RMS error
!>
!> Return code is ``0`` if successful execution. If \p irc is non-zero,
!> the contents or \p Err are ill-defined.
!> Results will only be printed to output if \c iPrint is ``-5`` or
!> greater.
!>
!> @param[out] irc Return code
!> @param[out] Err min, max, average, and RMS error
!***********************************************************************

subroutine Cho_X_CheckDiag(irc,Err)

use Cholesky, only: Cho_1Center, IPRINT, nnBstRT, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(out) :: Err(4)
integer(kind=iwp) :: i
real(kind=wp), allocatable :: Bin(:), CD(:), Stat(:), XD(:)
integer(kind=iwp), parameter :: iPrThr = -5
character(len=*), parameter :: SecNam = 'Cho_X_CheckDiag'
real(kind=wp), external :: ddot_

! Set return code.
! ----------------

irc = 0
if (nnBstRT(1) < 1) then
  Err(:) = Zero
  return
end if

! Allocations.
! ------------

call mma_allocate(XD,nnBstRT(1),Label='XD')
call mma_allocate(CD,nnBstRT(1),Label='CD')
call mma_allocate(Bin,16,Label='Bin')
call mma_allocate(Stat,7,Label='Stat')

! Set bins for histograms.
! ------------------------

Bin(1) = One
do i=1,size(Bin)-1
  Bin(1+i) = Bin(i)*1.0e-1_wp
end do

! Read exact diagonal.
! --------------------

call Cho_IODiag(XD,2)

! Print histogram of exact diagonal and get statistics.
! -----------------------------------------------------

if (iPrint >= iPrThr) then
  call Cho_Head('Analysis of Exact Integral Diagonal','=',80,u6)
  call Cho_AnaSize(XD,size(XD),Bin,size(Bin),u6)
  call Statistics(XD,size(XD),Stat,1,2,3,4,5,6,7)
  call Cho_PrtSt(XD,size(XD),Stat)
end if

! Calculate Cholesky diagonal.
! ----------------------------

call Cho_X_CalcChoDiag(irc,CD)
if (irc /= 0) then
  write(u6,*) SecNam,': Cho_X_CalcChoDiag returned ',irc
else

  ! Print histogram of Cholesky diagonal and get statistics.
  ! --------------------------------------------------------

  if (iPrint >= iPrThr) then
    call Cho_Head('Analysis of Cholesky Integral Diagonal','=',80,u6)
    call Cho_AnaSize(CD,size(CD),Bin,size(Bin),u6)
    call Statistics(CD,size(CD),Stat,1,2,3,4,5,6,7)
    call Cho_PrtSt(CD,size(CD),Stat)
  end if

  ! Subtract Cholesky diagonal from exact diagonal.
  ! -----------------------------------------------

  XD(:) = XD(:)-CD(:)

  ! Print histogram of difference array and get statistics.
  ! -------------------------------------------------------

  if (iPrint >= iPrThr) then
    call Cho_Head('Analysis of Difference (Exact-Cholesky)','=',80,u6)
    call Cho_AnaSize(XD,size(XD),Bin,size(Bin),u6)
  end if
  call Statistics(XD,size(XD),Stat,1,2,3,4,5,6,7)
  if (iPrint >= iPrThr) call Cho_PrtSt(XD,size(XD),Stat)

  ! Set Err array.
  ! --------------

  Err(1) = Stat(3)
  Err(2) = Stat(4)
  Err(3) = Stat(1)
  Err(4) = sqrt(dDot_(nnBstRT(1),XD,1,XD,1)/real(nnBstRT(1),kind=wp))

  if (iPrint >= iPrThr) then
    write(u6,'(/,1X,A,ES15.6)') 'Minimum error   : ',Err(1)
    write(u6,'(1X,A,ES15.6)') 'Maximum error   : ',Err(2)
    write(u6,'(1X,A,ES15.6)') 'Average error   : ',Err(3)
    write(u6,'(1X,A,ES15.6)') 'RMS error       : ',Err(4)
  end if

  ! Error analysis for the 1-center diagonals only.
  ! If this is a one-center calculation, use statistics from 1-center
  ! diagonals only as elements of Err array.
  ! -----------------------------------------------------------------

  if (nSym == 1) then
    call OneCenter_ChkDiag(XD,size(XD),Stat,iPrint >= iPrThr)
    if (Cho_1Center) then
      Err(1) = Stat(3)
      Err(2) = Stat(4)
      Err(3) = Stat(1)
      Err(4) = sqrt(dDot_(nnBstRT(1),XD,1,XD,1)/real(nnBstRT(1),kind=wp))
    end if
  end if

end if

! Deallocations.
! --------------

call mma_deallocate(Stat)
call mma_deallocate(Bin)
call mma_deallocate(CD)
call mma_deallocate(XD)

end subroutine Cho_X_CheckDiag

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mksymcvb2_cvb(cvb,tconstr,cvbdet)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension cvb(nvb)
      dimension tconstr(nvb*nvb)
      dimension cvbdet(ndetvb)
      save thresh
      data thresh/1.d-15/

c  Constraints on struc coeffs - either symmetry or deleted
      if(iconstruc.gt.0)then
        if(ip(1).ge.0)
     >  write(6,'(/,2a)')' Imposing constraints on ',
     >    'the structure coefficients.'
        call symtrizcvb_cvb(cvb)
        psnrm=ddot_(nvb,cvb,1,cvb,1)
        if(psnrm.lt.thresh)then
          write(6,*)' Fatal error - structure coefficients',
     >      ' null after symmetrization!'
          call abend_cvb()
        endif
        if(ip(1).ge.0)then
          write(6,'(/,a)')' Constrained structure coefficients :'
          write(6,'(a)')' ------------------------------------'
          call vecprint_cvb(cvb,nvb)
        endif
      endif
      call str2vbc_cvb(cvb,cvbdet)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_real_array(tconstr)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

! SVC2010: The following subroutine computes the transformation
! matrices using global arrays rather than replicate arrays.  Currently,
! the maximum memory scales approximately as 3*(NAS**2), which is twice
! what is needed in the replicate routines.  It can be reduced to
! 2*(NAS**2), if the matrix multiplications are rewritten to occur in
! batch mode.  However, unlike in the replicate routine, this amount is
! divided over processors.
#include "compiler_features.h"
#ifdef _MOLCAS_MPP_

subroutine SBDIAG_MPP(ISYM,ICASE,CONDNR,CPU)
! On entry, the DRA metafiles contain the matrices S and B for cases A
! (iCASE=1) en C (iCASE=4).  These symmetric matrices are stored on disk
! in full square format.  The rectangular matrices T are computed, such
! that Sum_(J) [B(I,J)*T(J,MU)] = Sum_(J) [S(I,J)*T(J,MU)*BD(MU)], where
! I,J are in the range (1,NASUP(ISYM,ICASE)) and MU is in the range
! (1,NINDEP(ISYM,ICASE)).  NINDEP is the numerically effective rank of
! S, and the columns of T are orthonormal: Sum_(I,J)
! [S(I,J)*T(J,MU)*T(J,NU)] = Kron(MU,NU).  B is destroyed, and is
! overwritten by BD(MU) and T(I,MU), which is stored in a DRA metafile.

use Index_Functions, only: nTri_Elem
#ifdef _SCALAPACK_
use scalapack_mod, only: GA_PDSYEVX_
#endif
use PrintLevel, only: INSANE
use Para_Info, only: King
use GA_Wrapper, only: DBL_MB, GA_Destroy, GA_NodeId
use EQSOLV, only: IDBMAT, IDSMAT, IDTMAT
use caspt2_global, only: do_grad, do_lindep, idBoriMat, iPrGlb, LUSBT, LUSTD, nStpGrd
use caspt2_module, only: nASup, nISup, Cases, IfDOrtho, ThrShn, ThrShs, nInDep, BMATRIX, BTRANS, BSPECT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iSym, iCase
real(kind=wp), intent(out) :: CondNr, CPU
integer(kind=iwp) :: I, IDB, IDB2, IDS, IDT, IEND, iHi, iLo, IOFF, ISTA, J, jHi, jLo, lDB, LDS, LDV, lg_B, lg_S, lg_ST, lg_T, &
                     lg_V, lg_X, mB, MS, mV, MyRank, NAS, NCOEF, NCOL, NIN, NIS, NTMP
real(kind=wp) :: CPU1, CPU2, CPUE, dTrans, FP, SDiag, SZMAX, SZMIN, TIO, TIOE
logical(kind=iwp) :: bSTAT
character(len=2) :: cCASE, cSYM
real(kind=wp), allocatable :: BD(:), COL(:), COND(:), EIG(:), SCA(:), SD(:), TMP(:), TRANS(:)
#ifndef _SCALAPACK_
integer(kind=iwp) :: Info, NSCRATCH
real(kind=wp) :: WGRONK(2)
real(kind=wp), allocatable :: SCRATCH(:), VEC(:)
#endif
real(kind=wp), external :: PSBMAT_FPRINT, DNRM2_

! Initialize the DRA I/O subsystem with default values.

if ((iCASE /= 1) .and. (iCASE /= 4)) then
  write(u6,*) 'Invalid CASE number used for global SBDIAG, Abort'
  call AbEnd()
end if

write(cCase,'(I2.2)') iCase
write(cSYM,'(I2.2)') iSYM
! Start a long loop over irreps:

CPU = Zero
CONDNR = Zero
NAS = NASUP(ISYM,ICASE)
NIS = NISUP(ISYM,ICASE)
NCOEF = NAS*NIS
if (NCOEF == 0) return

if (IPRGLB >= INSANE) &
  write(u6,'("DEBUG> ",A12,A5,I2,A2,A6,A2,A5,I1)') 'SBDIAG_MPP: ','CASE ',ICASE,' (',CASES(ICASE),') ','SYM ',ISYM

! Allocate memory for the S matrix and read it from disk:
call PSBMAT_GETMEM('S',lg_S,NAS)
call PSBMAT_READ('S',iCase,iSym,lg_S,NAS)
if (IPRGLB >= INSANE) then
  FP = PSBMAT_FPRINT(lg_S,NAS)
  write(u6,'("DEBUG> ",A,ES21.14)') 'SMAT NORM: ',FP
end if

! The S matrices are needed later on by non-global routines.  Take the
! oportunity to save them to LUSBT here.  FIXME: Should be removed once
! full parallelization of use of S matrices is achieved.
if (KING()) then
  NCOL = NAS
  NTMP = nTri_Elem(NAS)
  call mma_allocate(COL,NCOL,Label='COL')
  call mma_allocate(TMP,NTMP,Label='TMP')
  iOFF = 0
  do J=1,NAS
    call GA_Get(lg_S,1,J,J,J,COL,NAS)
    TMP(iOFF+1:iOFF+J) = COL(1:J)
    iOFF = iOFF+J
  end do
  call mma_deallocate(COL)
  IDS = IDSMAT(ISYM,ICASE)
  call DDAFILE(LUSBT,1,TMP,NTMP,IDS)
  call mma_deallocate(TMP)
end if

! Save the diagonal elements from the S matrix for easy access later on.
! FIXME: nicer way to do this?
call mma_allocate(SD,NAS,Label='SD')
SD(:) = Zero
myRank = GA_NodeID()
call GA_Distribution(lg_S,myRank,iLo,iHi,jLo,jHi)
ISTA = max(ILO,JLO)
IEND = min(IHI,JHI)
if (ISTA /= 0) then
  call GA_Access(lg_S,iLo,iHi,jLo,jHi,mS,LDS)
  do I=ISTA,IEND
    SD(I) = DBL_MB(mS+I-ILO+LDS*(I-JLO))
  end do
  call GA_Release(lg_S,iLo,iHi,jLo,jHi)
end if
call GADGOP(SD,NAS,'+')

! Calculate the scaling factors and store them in array SCA.
call mma_allocate(SCA,NAS,Label='SCA')
do I=1,NAS
  SDiag = SD(I)
  if (IFDORTHO) then
    SCA(I) = One
  else
    if (SDiag > THRSHN) then
      SCA(I) = (One+real(I,kind=wp)*3.0e-6_wp)/sqrt(SDiag)
    else
      SCA(I) = Zero
    end if
  end if
end do

! Scale the elements S(I,J) with the factor SCA(I)*SCA(J).
myRank = GA_NodeID()
call GA_Distribution(lg_S,myRank,iLo,iHi,jLo,jHi)
if (iLo /= 0) then
  call GA_Access(lg_S,iLo,iHi,jLo,jHi,mS,LDS)
  call S_SCALE(NAS,SCA,DBL_MB(mS),iLo,iHi,jLo,jHi,LDS)
  call GA_Release_Update(lg_S,iLo,iHi,jLo,jHi)
end if
call GA_Sync()
call TIMING(CPU1,CPUE,TIO,TIOE)

if (IPRGLB >= INSANE) then
  FP = PSBMAT_FPRINT(lg_S,NAS)
  write(u6,'("DEBUG> ",A,ES21.14)') 'SMAT NORM AFTER SCALING: ',FP
end if

call mma_allocate(EIG,NAS,Label='EIG')
EIG(:) = Zero
! Diagonalize the global array S.  Some (old) reports about parallel
! performance recommend PDSYEVX or PDSYEVR as fastest methods if
! eigenvectors are needed (FIXME: should time this).  For the linear
! dependence removal, split eigenvectors in horizontal stripes so that
! each processor has a row window of all column vectors
#ifdef _SCALAPACK_
call PSBMAT_GETMEM('VMAT',lg_V,NAS)
call GA_PDSYEVX_(lg_S,lg_V,EIG,0)
bSTAT = GA_Destroy(lg_S)
#else
! here for the non-ScaLAPACK version: copy matrix to master process,
! diagonalize using the serial DSYEV routine, and copy the resulting
! eigenvectors back to a global array.  Then distribute the eigenvalues.
if (myRank == 0) then
  call mma_allocate(VEC,NAS**2,Label='VEC')
  call GA_Get(lg_S,1,NAS,1,NAS,VEC,NAS)
end if
bSTAT = GA_Destroy(lg_S)
if (myRank == 0) then
  call DSYEV_('V','L',NAS,VEC,NAS,EIG,WGRONK,-1,INFO)
  NSCRATCH = int(WGRONK(1))
  call mma_allocate(SCRATCH,NSCRATCH,Label='SCRATCH')
  call DSYEV_('V','L',NAS,VEC,NAS,EIG,SCRATCH,NSCRATCH,INFO)
  call mma_deallocate(SCRATCH)
end if
call PSBMAT_GETMEM('VMAT',lg_V,NAS)
if (myRank == 0) then
  call GA_Put(lg_V,1,NAS,1,NAS,VEC,NAS)
  call mma_deallocate(VEC)
end if
call GADGOP(EIG,NAS,'+')
#endif

if (IPRGLB >= INSANE) then
  FP = DNRM2_(NAS,EIG,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'SMAT EIGENVALUE NORM: ',FP
end if

NIN = count(EIG(:) >= THRSHS)
NINDEP(ISYM,ICASE) = NIN
if (NIN == 0) then
  call mma_deallocate(SCA)
  call mma_deallocate(EIG)
  call mma_deallocate(SD)
  bSTAT = GA_Destroy(lg_V)
  return
end if

call TIMING(CPU2,CPUE,TIO,TIOE)
CPU = CPU+CPU2-CPU1

call mma_allocate(COND,NIN,Label='COND')
COND(:) = Zero
! Form orthonormal transformation vectors by scaling the eigenvectors.
call GA_Sync()
myRank = GA_NodeID()
call GA_Distribution(lg_V,myRank,iLo,iHi,jLo,jHi)
if (iLo /= 0) then
  call GA_Access(lg_V,iLo,iHi,jLo,jHi,mV,LDV)
  if ((jHi-jLo+1) /= NAS) then
    write(u6,*) 'SBDIAG_MPP: error in striping of lg_V, ABORT'
    call ABEND()
  end if
  call V_SCALE(EIG,SCA(iLo),DBL_MB(mV),iHi-iLo+1,jHi-jLo+1,LDV,NIN,COND)
  call GA_Release_Update(lg_V,iLo,iHi,jLo,jHi)
end if
call GA_Sync()

call mma_deallocate(EIG)
call mma_deallocate(SCA)

! The condition number, after scaling, disregarding linear dep.
! FIXME: adapt to local subroutine for global array lg_V
if (NIN >= 2) then
  call GADGOP(COND,NIN,'+')
  SZMIN = min(1.0e99_wp,minval(COND(:)))
  SZMAX = max(Zero,maxval(COND(:)))
  CONDNR = SZMAX/SZMIN
end if
call mma_deallocate(COND)

! Copy the NIN non-linear dependent eigenvectors to the transformation
! matrix T(NAS,NIN).
call GA_CREATE_STRIPED('H',NAS,NIN,'TMAT',lg_T)
call GA_Copy_Patch('N',lg_V,1,NAS,1,NIN,lg_T,1,NAS,1,NIN)
bStat = GA_Destroy(lg_V)

if (BMATRIX == 'NO') then
  ! In some calculations, we do not use B matrices.
  ! Write the T matrix to disk and exit.  FIXME: This
  ! should be removed when the transformation matrices are stored as disk
  ! resident arrays only.
  if (KING()) then
    call mma_allocate(TRANS,NAS*NIN,Label='TRANS')
    call GA_Get(lg_T,1,NAS,1,NIN,TRANS,NAS)
    if (iPrGlb >= INSANE) then
      dTRANS = dNRM2_(NAS*NIN,TRANS,1)
      write(u6,'("DEBUG> ",A,ES21.14)') 'TMAT NORM: ',dTRANS
    end if
    IDT = IDTMAT(ISYM,ICASE)
    call DDAFILE(LUSBT,1,TRANS,NAS*NIN,IDT)
    call mma_deallocate(TRANS)
  end if
  bStat = GA_Destroy(lg_T)
  return
else if (BTRANS /= 'YES') then
  ! In other calculations, the B matrix is used but not transformed.  We
  ! may need the diagonal active energies, i.e. the diagonal values of B
  ! divided by the diagonal values of S. These are placed where the
  ! eigenvalues would go in ordinary CASPT2.
  call PSBMAT_GETMEM('B',lg_B,NAS)
  call PSBMAT_READ('B',iCase,iSym,lg_B,NAS)
  call mma_allocate(BD,NAS,Label='BD')
  BD(:) = Zero
  myRank = GA_NodeID()
  call GA_Distribution(lg_B,myRank,iLo,iHi,jLo,jHi)
  ISTA = max(ILO,JLO)
  IEND = min(IHI,JHI)
  if (ISTA /= 0) then
    call GA_Access(lg_B,iLo,iHi,jLo,jHi,mB,LDB)
    do I=ISTA,IEND
      BD(I) = DBL_MB(mB+I-ILO+LDB*(I-JLO))
    end do
    call GA_Release(lg_B,iLo,iHi,jLo,jHi)
  end if
  call GADGOP(BD,NAS,'+')
  bStat = GA_Destroy(lg_B)
  BD(:) = BD(:)/(SD(:)+1.0e-15_wp)
  IDB = IDBMAT(ISYM,ICASE)
  call DDAFILE(LUSBT,1,BD,NAS,IDB)
  call mma_deallocate(BD)
  ! Write the transformation matrices after the diagonal values of B.
  ! FIXME: This should be removed when the transformation matrices are
  ! stored as disk resident arrays only.
  if (KING()) then
    call mma_allocate(TRANS,NAS*NIN,Label='TRANS')
    call GA_Get(lg_T,1,NAS,1,NIN,TRANS,NAS)
    if (iPrGlb >= INSANE) then
      dTRANS = dNRM2_(NAS*NIN,TRANS,1)
      write(u6,'("DEBUG> ",A,ES21.14)') 'TMAT NORM: ',dTRANS
    end if
    IDT = IDTMAT(ISYM,ICASE)
    call DDAFILE(LUSBT,1,TRANS,NAS*NIN,IDT)
    call mma_deallocate(TRANS)
  end if
  bStat = GA_Destroy(lg_T)
  return
end if
call mma_deallocate(SD)

! TRANSFORM B MATRIX TO O-N BASIS. BUT FIRST, SAVE O-N VECTORS.
call PSBMAT_WRITE('T',iCase,iSym,lg_T,NAS*NIN)

if (IPRGLB >= INSANE) then
  FP = PSBMAT_FPRINT(lg_T,NAS)
  write(u6,'(1X,A,ES21.14)') 'EIGENVECTOR NORM BEFORE B TRANS: ',FP
end if

call PSBMAT_GETMEM('B',lg_B,NAS)
call PSBMAT_READ('B',iCase,iSym,lg_B,NAS)

if ((do_grad .or. (nStpGrd == 2)) .and. do_lindep) then
  !! The original B matrix is needed in the LinDepLag subroutine
  IDB2 = idBoriMat(ISYM,ICASE)
  call GA_Distribution(lg_B,myRank,iLo,iHi,jLo,jHi)
  call GA_Access(lg_B,iLo,iHi,jLo,jHi,mB,LDB)
  call DDAFILE(LUSTD,1,DBL_MB(mB),(iHi-iLo+1)*(jHi-jLo+1),IDB2)
  call GA_Release(lg_B,iLo,iHi,jLo,jHi)
end if

if (IPRGLB >= INSANE) write(u6,'(1X,A,ES21.14)') 'BMAT NORM: ',FP

! FIXME: Perform transformation of B using horizontal stripes of B or
! vertical stripes of T to reduce memory usage if necessary as indicated
! by the available memory, which is now scaling as approx. 3*(NAS**2).
call GA_CREATE_STRIPED('H',NAS,NIN,'XMAT',lg_X)
call GA_DGEMM('N','N',NAS,NIN,NAS,One,lg_B,lg_T,Zero,lg_X)
bStat = GA_Destroy(lg_B)

call GA_CREATE_STRIPED('H',NIN,NIN,'BMAT',lg_B)
call GA_DGEMM('T','N',NIN,NIN,NAS,One,lg_T,lg_X,Zero,lg_B)
bStat = GA_Destroy(lg_X)
bStat = GA_Destroy(lg_T)

if (IPRGLB >= INSANE) then
  FP = PSBMAT_FPRINT(lg_B,NIN)
  write(u6,'(1X,A,ES21.14)') 'BMAT NORM AFTER TRANS: ',FP
end if

call TIMING(CPU1,CPUE,TIO,TIOE)

! Diagonalize the transformed B matrix.
call mma_allocate(EIG,NIN,Label='EIG')
EIG(:) = Zero
if (BSPECT /= 'YES') then
  ! Use diagonal approxim., if allowed.
  !call GA_Fill(lg_V, Zero)
  call GA_Zero(lg_V)
  ! FIXME: this original code seemed wrong, using uninitialized SD?
  !IDIAG = 1
  !do I=1,NIN
  !  EIG(I) = B(IDIAG)/SD
  !  IDIAG = IDIAG+1+NIN-I
  !end do
  write(u6,*) 'GLOB_SBDIAG: option not implemented'
  call AbEnd()
else
# ifdef _SCALAPACK_
  call GA_CREATE_STRIPED('H',NIN,NIN,'VMAT',lg_V)
  call GA_PDSYEVX_(lg_B,lg_V,EIG,0)
  bStat = GA_Destroy(lg_B)
# else
  if (myRank == 0) then
    call mma_allocate(VEC,NIN**2,Label='VEC')
    call GA_Get(lg_B,1,NIN,1,NIN,VEC,NIN)
  end if
  bSTAT = GA_Destroy(lg_B)
  if (myRank == 0) then
    call dsyev_('V','L',NIN,VEC,NIN,EIG,WGRONK,-1,INFO)
    NSCRATCH = int(WGRONK(1))
    call mma_allocate(SCRATCH,NSCRATCH,Label='SCRATCH')
    call dsyev_('V','L',NIN,VEC,NIN,EIG,SCRATCH,NSCRATCH,INFO)
    call mma_deallocate(SCRATCH)
  end if
  call GA_Sync()
  call GA_CREATE_STRIPED('H',NIN,NIN,'VMAT',lg_V)
  if (myRank == 0) then
    call GA_Put(lg_V,1,NIN,1,NIN,VEC,NIN)
    call mma_deallocate(VEC)
  end if
  call GADGOP(EIG,NIN,'+')
# endif
end if

if (IPRGLB >= INSANE) then
  FP = DNRM2_(NIN,EIG,1)
  write(u6,'(1X,A,ES21.14)') 'BMAT EIGENVALUE NORM: ',FP
end if

! The eigenvalues are written back at same position as the
! original B matrix, which is destroyed:
IDB = IDBMAT(ISYM,ICASE)
call DDAFILE(LUSBT,1,EIG,NIN,IDB)
call mma_deallocate(EIG)

call TIMING(CPU2,CPUE,TIO,TIOE)
CPU = CPU+CPU2-CPU1

! Finally, we must form the composite transformation matrix: T(NAS,NIN)
! matrix on disk * V(NIN*NIN) matrix in core.  FIXME: for now, asume
! there is enough memory for the full transformation, scaling as
! approx. 3*(NAS**2).  Should be determined by the available memory.
call GA_CREATE_STRIPED('H',NAS,NIN,'XMAT',lg_X)
call PSBMAT_READ('T',iCase,iSym,lg_X,NAS*NIN)
call GA_CREATE_STRIPED('H',NAS,NIN,'TMAT',lg_T)
call GA_DGEMM('N','N',NAS,NIN,NIN,One,lg_X,lg_V,Zero,lg_T)
bStat = GA_Destroy(lg_X)
bStat = GA_Destroy(lg_V)

! Write the composite transformation matrix to disk.
call PSBMAT_WRITE('T',iCase,iSym,lg_T,NAS*NIN)

! Additonally, compute S*T and store in on disk for later use by the RHS
! vector utitlities
call PSBMAT_GETMEM('S',lg_S,NAS)
call PSBMAT_READ('S',iCase,iSym,lg_S,NAS)

call GA_CREATE_STRIPED('H',NAS,NIN,'STMAT',lg_ST)
call GA_DGEMM('N','N',NAS,NIN,NAS,One,lg_S,lg_T,Zero,lg_ST)
bStat = GA_Destroy(lg_S)

call PSBMAT_WRITE('M',iCase,iSym,lg_ST,NAS*NIN)
bStat = GA_Destroy(lg_ST)

! For now, also keep the transformation matrix on disk as a
! replicate array.  FIXME: Should be removed later.
if (KING()) then
  call mma_allocate(TRANS,NAS*NIN,Label='TRANS')
  call GA_Get(lg_T,1,NAS,1,NIN,TRANS,NAS)
  dTRANS = dNRM2_(NAS*NIN,TRANS,1)
  if (iPrGlb >= INSANE) write(u6,'("DEBUG> ",A,ES21.14)') 'TMAT NORM: ',dTRANS
  IDT = IDTMAT(ISYM,ICASE)
  call DDAFILE(LUSBT,1,TRANS,NAS*NIN,IDT)
  call mma_deallocate(TRANS)
end if

call ga_sync()
bStat = GA_Destroy(lg_T)

#include "macros.fh"
unused_var(bStat)

end subroutine SBDIAG_MPP

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(SBDIAG_MPP)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine axexsol2_cvb(ap,eigval,eigvec,dum,itdav,maxdav,
     >  solp,solp_res,eig,eig_res)
      implicit real*8 (a-h,o-z)
#include "direct_cvb.fh"
      dimension ap(maxdav,maxdav),eigval(itdav),eigvec(itdav,itdav)
      dimension solp(maxdav),solp_res(maxdav)

      do 100 it=1,itdav
      call fmove_cvb(ap(1,it),eigvec(1,it),itdav)
100   continue

      if(ip.ge.3)then
        write(6,*)' AP matrix :'
        do i=1,itdav
        eigval(i)=eigvec(i,i)
        eigvec(i,i)=eigvec(i,i)+corenrg
        enddo
        call mxprintd_cvb(eigvec,itdav,itdav,0)
        do i=1,itdav
        eigvec(i,i)=eigval(i)
        enddo
      endif

      call mxdiag_cvb(eigvec,eigval,itdav)

      if(ifollow.le.2)then
        iroot=nroot
        jroot=mod(itdav,nroot)
        if(jroot.eq.0)jroot=nroot
        if(itdav.eq.maxdav.or.itdav.eq.nfrdim)jroot=nroot
        iroot=min(itdav,iroot)
        jroot=min(itdav,jroot)
        if(ifollow.eq.1)then
          iroot=itdav-iroot+1
          jroot=itdav-jroot+1
        endif
      elseif(ifollow.eq.3)then
        write(6,*)' Overlap-based root following not yet implemented!'
        call abend_cvb()
      elseif(ifollow.eq.4)then
c  Eigenvalue-based root following -- determine closest root :
        iroot=1
        delmin=abs(eigval(1)-eig)
        do 200 i=1,min(itdav,nroot)
        del=abs(eigval(i)-eig)
        if(del.lt.delmin)then
          delmin=del
          iroot=i
        endif
200     continue
        jroot=iroot
      endif
      eig=eigval(iroot)
      call fmove_cvb(eigvec(1,iroot),solp,itdav)
      eig_res=eigval(jroot)
      call fmove_cvb(eigvec(1,jroot),solp_res,itdav)
      if(ip.ge.2)then
        write(6,'(a)')' Eigenvalues :'
        do i=1,itdav
        eigval(i)=eigval(i)+corenrg
        enddo
        call vecprint_cvb(eigval,itdav)
        do i=1,itdav
        eigval(i)=eigval(i)-corenrg
        enddo
        write(6,'(a,i3,a)')' Eigenvector number',iroot,' :'
        call vecprint_cvb(solp,itdav)
        if(jroot.ne.iroot)then
          write(6,'(a,i3,a)')' Eigenvector number',jroot,' :'
          call vecprint_cvb(solp_res,itdav)
        endif
      endif
      return
c Avoid unused argument warnings
      if (.false.) call Unused_real(dum)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine PrjMm1( &
#                 define _CALLING_
#                 include "mem_interface.fh"
                 )
!***********************************************************************
!                                                                      *
!  Object: to compute the number of reals the kernel routine will      *
!          need for the computation of a matrix element between two    *
!          cartesian Gaussian functions with the total angular momentum*
!          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
!          lr is the order of the operator (this is only used when the *
!          integrals are computed with the Hermite-Gauss quadrature).  *
!                                                                      *
!  Called from: OneEl                                                  *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc, nCnttp, Shells
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: iacore, iAng, iCnttp, icoreb, icores, ip, iShll, ld, nac, nBasisi, ncb, nExpi, nOrder

nOrder = 0
ld = 1
Mem = 0
do iCnttp=1,nCnttp
  if (.not. dbsc(iCnttp)%ECP) cycle
  do iAng=0,dbsc(iCnttp)%nPrj-1
    iShll = dbsc(iCnttp)%iPrj+iAng
    nExpi = Shells(iShll)%nExp
    nBasisi = Shells(iShll)%nBasis
    if ((nExpi == 0) .or. (nBasisi == 0)) cycle

    ip = 0

    nac = nTri_Elem1(la)*nTri_Elem1(iAng)
    ncb = nTri_Elem1(iAng)*nTri_Elem1(lb)

    ip = ip+6*nTri_Elem1(la)*nTri_Elem1(lb) ! final
    ip = ip+4*nac*nExpi ! FA1
    ip = ip+4*ncb*nExpi !FB1
    ip = ip+nExpi*nExpi !Tmp

    nHer = (la+1+iAng+1+ld)/2
    nOrder = max(nHer,nOrder)
    iacore = 6+3*nHer*(la+1+ld)+3*nHer*(iAng+1)+3*nHer*(lr+1)+3*(la+1+ld)*(iAng+1)*(lr+1)+1

    nHer = (lb+1+iAng+1+ld)/2
    nOrder = max(nHer,nOrder)
    icoreb = 6+3*nHer*(lb+1+ld)+3*nHer*(iAng+1)+3*nHer*(lr+1)+3*(lb+1+ld)*(iAng+1)*(lr+1)+1

    icores = max(icoreb,iacore)*nExpi

    Mem = max(Mem,ip+icores)

  end do
end do
nHer = nOrder
!write(u6,*) 'mem',Mem

return

end subroutine PrjMm1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1996, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine SetUp_RW(DoRys,nDiff)
************************************************************************
*                                                                      *
* Object: to setup tables for auxiliary functions to be used direct    *
*         in the recurrence relations of integral form or indirectly   *
*         to compute the Rys roots and weights which are used in the   *
*         recurrence relations of integrand form. For the lower order  *
*         Rys polynomials the roots and weight are computed from expa- *
*         nsion coefficients.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*                                                                      *
*             Unified version August '96, RL.                          *
************************************************************************
      use External_Centers, only: XF, nOrdEF
      use Sizes_of_Seward, only: S
      use Logical_Info, only: GIAO
      Implicit Real*8 (A-H,O-Z)
      Logical DoRys
      Integer nDiff
*
*     Compute max sum of angular momentum index
*
      iAng2 = 4*S%iAngMx
*
*     Set up roots and weights for Hermite polynomials.
*
      Call SetHer(nDiff)
*
*     Set up coefficients for Rys polynomials.
*
*     1) for two-electron integrals
*     2) for external field and nuclear attraction
*
      mRys =(iAng2+2+nDiff)/2
      If (Allocated(XF).or.(nOrdEF.eq.1).or.GIAO)
     &   mRys=Max(mRys,(2*S%iAngMx+1+2+nDiff)/2)
      If (nOrdEF.eq.2) mRys=Max(mRys,(2*S%iAngMx+2+2+nDiff)/2)
      If (DoRys) Call SetUpR(mRys)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SubScr_Dia(ChoVec,nVec,iSym,iLoc,DSPNorm)
C
C     Purpose: compute diagonal from Cholesky vectors and find norm
C              for each shell pair. Needed for screening of vector
C              subtraction. Which norm is used is determined by
C              string DSPNorm:
C
C              DSPNorm = 'Max' : max. element
C              DSPNorm = 'Fro' : Frobenius norm
C
C              Any other norm is taken to be 'Max'.
C
#include "implicit.fh"
      Dimension ChoVec(*)
      Character*(*) DSPNorm
#include "cholesky.fh"
#include "choptr.fh"
#include "chosubscr.fh"
#include "WrkSpc.fh"

      Character*14 SecNam
      Parameter (SecNam = 'Cho_SubScr_Dia')

      Character*3 myDSPNorm

      iiBstRSh(i,j,k)=iWork(ip_iiBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      nnBstRSh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      DSubScr(i)=Work(ip_DSubScr-1+i)

#if defined (_DEBUGPRINT_)
      If (iLoc.lt.1 .or. iLoc.gt.3) Then
         Call Cho_Quit('iLoc error in '//SecNam,104)
      End If
      If (iSym.lt.1 .or. iSym.gt.nSym) Then
         Call Cho_Quit('iSym error in '//SecNam,104)
      End If
      If (.not.Cho_SScreen) Then
         Call Cho_Quit('Cho_SScreen is .False. in '//SecNam,104)
      End If
#endif

C     Initialize and check for early return.
C     --------------------------------------

      Call Cho_dZero(Work(ip_DSubScr),nnBstR(iSym,iLoc))
      Call Cho_dZero(Work(ip_DSPNm),nnShl)
      If (nVec.lt.1 .or. nnBstR(iSym,iLoc).lt.1) return

C     Compute diagonal.
C     -----------------

      Do iVec = 1,nVec
         kOff = nnBstR(iSym,iLoc)*(iVec-1)
         Do iAB = 1,nnBstR(iSym,iLoc)
            Work(ip_DSubScr-1+iAB) = Work(ip_DSubScr-1+iAB)
     &                             + ChoVec(kOff+iAB)*ChoVec(kOff+iAB)
         End Do
      End Do

C     Find diagonal norm in each shell pair.
C     --------------------------------------

      lstr = len(DSPNorm)
      If (lstr .lt. 3) Then
         myDSPNorm = 'MAX'
      Else
         myDSPNorm = DSPNorm(1:3)
         Call UpCase(myDSPNorm)
      End If

#if defined (_DEBUGPRINT_)
      If (lstr .lt. 1) Then
         Write(Lupri,*) SecNam,': input norm: (null string)'
      Else If (lstr .lt. 3) Then
         Write(Lupri,*) SecNam,': input norm: ',DSPNorm,' (incomplete)'
      Else
         Write(Lupri,*) SecNam,': input norm: ',DSPNorm
      End If
      Write(Lupri,*) SecNam,': norm used : ',myDSPNorm
#endif

      If (myDSPNorm .eq. 'MAX') Then
         Do iSP = 1,nnShl
            iAB1 = iiBstRSh(iSym,iSP,iLoc) + 1
            iAB2 = iAB1 + nnBstRSh(iSym,iSP,iLoc) - 1
            Do iAB = iAB1,iAB2
               Work(ip_DSPNm-1+iSP) = max(Work(ip_DSPNm-1+iSP),
     &                                    Work(ip_DSubScr-1+iAB))
            End Do
         End Do
      Else If (myDSPNorm .eq. 'FRO') Then
         Do iSP = 1,nnShl
            iAB1 = iiBstRSh(iSym,iSP,iLoc) + 1
            iAB2 = iAB1 + nnBstRSh(iSym,iSP,iLoc) - 1
            Do iAB = iAB1,iAB2
               Work(ip_DSPNm-1+iSP) = Work(ip_DSPNm-1+iSP)
     &                              + DSubScr(iAB)*DSubScr(iAB)
            End Do
            Work(ip_DSPNm-1+iSP) = sqrt(Work(ip_DSPNm-1+iSP))
         End Do
      Else
         Write(Lupri,*) SecNam,': WARNING: unkown norm: ',DSPNorm
         Write(Lupri,*) SecNam,': WARNING: using max element...'
         Do iSP = 1,nnShl
            iAB1 = iiBstRSh(iSym,iSP,iLoc) + 1
            iAB2 = iAB1 + nnBstRSh(iSym,iSP,iLoc) - 1
            Do iAB = iAB1,iAB2
               Work(ip_DSPNm-1+iSP) = max(Work(ip_DSPNm-1+iSP),
     &                                    Work(ip_DSubScr-1+iAB))
            End Do
         End Do
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine esb_ic_3(symp,Vic,dimp,pqind)
! this routine realizes expansion of symmetry block
! symp,symq,symr,syms <p,q|r,s>  <-> (IJ|KL),
! (for case symp=symr=symq=syms)
! provided such integrals exist
! It finds corresponding (IJ|KL) and expands it to
! matrix vic (prqs)

use ccsort_global, only: fullprint, idis, LUINTM, mbas, NORB, np, nq, nr, ns
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: symp, dimp
real(kind=wp), intent(_OUT_) :: Vic((dimp*(dimp+1)/2)*((dimp*(dimp+1)/2)+1)/2)
integer(kind=iwp), intent(out) :: pqind(mbas,mbas)
#include "tratoc.fh"
integer(kind=iwp) :: i, i1, idis13, ik, ikjl, ilow, ind(4), indtemp, iold, iup, j, j1, jl, jlow, jold, jup, k1, kold, kup, l1, &
                     lold, lup, maxx, ni, nj, nk, nl, nsi, nsj, nsk, nsl
real(kind=wp) :: val1
real(kind=wp), allocatable :: TWO(:)

!I calc pqind

!LD if (dimp >= dimp) then
maxx = dimp
!LD else
!LD   maxx = dimq
!LD end if

do i=1,maxx
  do j=1,maxx
    if (i >= j) then
      pqind(i,j) = i*(i-1)/2+j
    else
      pqind(i,j) = j*(j-1)/2+i
    end if
  end do
end do

!II get address
idis13 = idis(symp,symp,symp)

!III.1 define order of indices

ni = np(symp,symp,symp)
nj = nq(symp,symp,symp)
nk = nr(symp,symp,symp)
nl = ns(symp,symp,symp)

! define NSI,NSJ,NSK,NSL
ind(ni) = symp
ind(nj) = symp
ind(nk) = symp
ind(nl) = symp
NSI = ind(1)
NSJ = ind(2)
NSK = ind(3)
NSL = ind(4)

call mma_allocate(TWO,nTraBuf,label='TWO')

indtemp = nTraBuf+1
KUP = NORB(NSK)
do KOLD=1,KUP
  if (fullprint >= 3) write(u6,*) ' * K ind ',KOLD

  LUP = NORB(NSL)
  if (NSK == NSL) LUP = KOLD
  do LOLD=1,LUP
    if (fullprint >= 3) write(u6,*) ' ** L ind ',LOLD

    ILOW = 1
    if (NSI == NSK) ILOW = KOLD
    IUP = NORB(NSI)
    do IOLD=ILOW,IUP
      if (fullprint >= 3) write(u6,*) ' *** I ind ',IOLD

      JLOW = 1
      if ((NSI == NSK) .and. (IOLD == KOLD)) JLOW = LOLD
      JUP = NORB(NSJ)
      if (NSI == NSJ) JUP = IOLD
      do JOLD=JLOW,JUP
        if (fullprint >= 3) write(u6,*) ' **** J ind ',JOLD

        ! read block of integrals if necessary

        if (indtemp == (nTraBuf+1)) then
          indtemp = 1
          ! read block
          call dDAFILE(LUINTM,2,TWO,nTraBuf,IDIS13)
        end if

        ! write integrals to appropriate positions

        val1 = TWO(indtemp)

        !:1 combination (ij|kl) -> (ij|kl)
        !   since yes1 is always 1, if structure is skipped
        ind(1) = iold
        ind(2) = jold
        ind(3) = kold
        ind(4) = lold
        j1 = ind(nj)
        l1 = ind(nl)
        i1 = ind(ni)
        k1 = ind(nk)

        !:2 def iklj
        ik = pqind(i1,k1)
        jl = pqind(j1,l1)
        if (ik >= jl) then
          ikjl = ik*(ik-1)/2+jl
        else
          ikjl = jl*(jl-1)/2+ik
        end if

        Vic(ikjl) = val1

        indtemp = indtemp+1

      end do
    end do
  end do
end do

call mma_deallocate(TWO)

return

end subroutine esb_ic_3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PolSolv(iDT,iFI,iFP,xx,yy,zz,rr3,xxi,yyi,zzi,Gri
     &,FFp,iCNum,r2inv,difac,nSize)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "WrkSpc.fh"

      Dimension xx(nSize,nSize),yy(nSize,nSize),zz(nSize,nSize)
      Dimension xxi(nSize,nSize),yyi(nSize,nSize),zzi(nSize,nSize)
      Dimension rr3(nSize,nSize),Gri(nSize,nSize)
      Dimension FFp(nSize,3)
      Dimension iDT(3),iFI(3),iFP(3)

*
*-- The field between the solvent molecules are computed as well as
*   the image charge contribtion. Rather basic formules, but keeping
*   track on indeces may be difficult.
*
      Do 741, j=1,nPol
        IndCor=j+(iCnum-1)*Ncent
        Inddt=j+(iCnum-1)*nPol
        Do 742, i=iCnum+1,nPart
          IndCor=IndCor+nCent
          Inddt=Inddt+nPol
          Agr=Sqrs(IndCor) !Sqrs come from geogen.f.
          Skal=Work(iDT(1)+Inddt-1)*Cordst(IndCor,1)
     &        +Work(iDT(2)+Inddt-1)*Cordst(IndCor,2)
     &        +Work(iDT(3)+Inddt-1)*Cordst(IndCor,3)
          Ta=Skal*Agr**2*R2inv
          Tal=-Difac*Ta
          Qimp(Inddt)=tal*agr
*------ Image dipoles: Reflect dipole vector in radial vector. This
*       is vector geometry at its best.
          Dim(IndDt,1)=(Tal*Cordst(IndCor,1)*2
     &                +DiFac*Work(iDt(1)+IndDt-1))*Agr**3
          Dim(IndDt,2)=(Tal*Cordst(IndCor,2)*2
     &                +DiFac*Work(iDt(2)+IndDt-1))*Agr**3
          Dim(IndDt,3)=(Tal*Cordst(IndCor,3)*2
     &                +DiFac*Work(iDt(3)+IndDt-1))*Agr**3
742     Continue
741   Continue
      Do 7432, j=1,3
        Do 7431, i=1+(nPol*iCnum),nSize
          Work(iFi(j)+i-1)=0
7431    Continue
7432  Continue

*
*-- Here the actual fields are computed, both from the explicit
*   solvent and from its image.
*
      Do 743, i=1+(nPol*iCNum),nPart*nPol  !The real part.
        Do 744, j=1+(nPol*iCnum),nPart*nPol
          idel1=(i-1)/nPol
          idel2=(j-1)/nPol
          if(idel1.eq.idel2) GoTo 744
          Skal=xx(i,j)*Work(iDt(1)+i-1)+yy(i,j)*Work(iDt(2)+i-1)
     &        +zz(i,j)*Work(iDt(3)+i-1)
          Skal=Skal*3
          Work(iFi(1)+j-1)=Work(iFi(1)+j-1)-(Work(iDt(1)+i-1)-Skal
     &                    *xx(i,j))*rr3(i,j)
          Work(iFi(2)+j-1)=Work(iFi(2)+j-1)-(Work(iDt(2)+i-1)-Skal
     &                    *yy(i,j))*rr3(i,j)
          Work(iFi(3)+j-1)=Work(iFi(3)+j-1)-(Work(iDt(3)+i-1)-Skal
     &                    *zz(i,j))*rr3(i,j)
744     Continue
743   Continue
      Do 745, i=1+(nPol*iCnum),nPart*nPol  !The image part.
        Do 746, j=1+(nPol*iCnum),nPart*nPol
        Skal=(xxi(i,j)*Dim(i,1)+yyi(i,j)*Dim(i,2)+zzi(i,j)*Dim(i,3))
          Skal=Skal*3
          Work(iFi(1)+j-1)=Work(iFi(1)+j-1)-(Dim(i,1)-Skal*xxi(i,j))
     &             *Gri(i,j)**3-Qimp(i)*xxi(i,j)*Gri(i,j)**2
          Work(iFi(2)+j-1)=Work(iFi(2)+j-1)-(Dim(i,2)-Skal*yyi(i,j))
     &             *Gri(i,j)**3-Qimp(i)*yyi(i,j)*Gri(i,j)**2
          Work(iFi(3)+j-1)=Work(iFi(3)+j-1)-(Dim(i,3)-Skal*zzi(i,j))
     &             *Gri(i,j)**3-Qimp(i)*zzi(i,j)*Gri(i,j)**2
746     Continue
745   Continue

*
*-- Add up the things, and add also the part from the permanent
*   charges.
*
      Do 747, i=1+(nPol*iCnum),nSize
        FFp(i,1)=Work(iFi(1)+i-1)+Work(iFp(1)+i-1)
        FFp(i,2)=Work(iFi(2)+i-1)+Work(iFp(2)+i-1)
        FFp(i,3)=Work(iFi(3)+i-1)+Work(iFp(3)+i-1)
747   Continue

*
*-- The circle is now complete. I left you when I was about to learn
*   and I meet you as the master.
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function NCAlph(MxBond,IAt,NHI,NCSP3I,IAn,NBond,IBond,Chg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: NCAlph
integer(kind=iwp), intent(in) :: MxBond, IAt, NHI, NCSP3I, IAn(*), NBond(*), IBond(MxBond,*)
real(kind=wp), intent(in) :: Chg(*)
integer(kind=iwp) :: ianj, iank, iplj, JAt, jj, KAt, kk, nbj, nbk, NCM1, NCP1, ncsp3j, NHetI, nhetj, nhj

NHetI = 4-NHI-NCSP3I
NCP1 = 0
NCM1 = 0
!write(IOut,'("Atom",I2," NHet=",I1)') IAt,NHetI
do jj=1,4
  JAt = IBond(jj,IAt)
  ianj = ian(JAt)
  nbj = nbond(JAt)
  nhj = 0
  ncsp3j = 0
  nhetj = 0
  iplj = 0
  if ((ianj == 6) .and. (nbj == 4)) then
    do kk=1,4
      KAt = IBond(kk,JAt)
      iank = ian(KAt)
      nbk = nbond(KAt)
      if (iank == 1) NHJ = NHJ+1
      if ((iank == 6) .and. (nbk == 4)) NCSP3J = NCSP3J+1
      if (chg(KAt) > 0.4_wp) iplj = 1
    end do
    NHETJ = 4-NHJ-NCSP3J
    if ((NHetI >= 0) .and. (NHetJ == 0)) NCP1 = NCP1+1
    if ((NHetI == 0) .and. (NHetJ > 0) .and. (iplj == 0)) NCM1 = NCM1+1
  end if
  !write(IOut,*) JAt,NHetJ,NCP1,NCM1
end do
NCAlph = NCP1-NCM1

return

end function NCAlph

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_PrtDia(Diag,Sync,iSyLst,nSyLst,iLoc)
C
C     Purpose: print global diagonal. Diag is the local diagonal and
C              if Sync=.True. the global diagonal is
C              synchronized before printing. Array iSyLst(nSyLst)
C              specifies which symmetry blocks to print, and iLoc points
C              to the memory location of the reduced set index arrays to
C              use for printing (and synchronizing, if requested).
C
      use ChoSwp, only: Diag_G
      Implicit None
      Real*8  Diag(*)
      Logical Sync
      Integer nSyLst
      Integer iSyLst(nSyLst)
      Integer iLoc
#include "cho_para_info.fh"
#include "choglob.fh"

      If (Cho_Real_Par) Then

C        Sync diagonal if requested.
C        ---------------------------

         If (Sync) Then
            Call Cho_P_SyncDiag(Diag,iLoc)
         End If

C        Swap local and global index arrays and use original serial routine
C        to print diagonal.
C        ------------------------------------------------------------------

         Call Cho_P_IndxSwp()
         Call Cho_PrtDia(Diag_G,iSyLst,nSyLst,iLoc)
         Call Cho_P_IndxSwp()

      Else

         Call Cho_PrtDia(Diag,iSyLst,nSyLst,iLoc)

      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RSTOF(IRS2F,N,LRDIM,IRED)
!
! Purpose: set up mapping between reduced set and SO indices
!          (i.e., full storage).
!
! IRS2F(1,irs) = alpha (SO index, not symmmetry reduced)
! IRS2F(2,irs) = beta  (SO index, not symmmetry reduced)

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Cholesky, only: iBas, iShlSO, iSOShl, mmBstRT, nBas, nBstSh, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: N, LRDIM, IRED
integer(kind=iwp), intent(out) :: IRS2F(N,LRDIM)
integer(kind=iwp) :: IA, IB, IRS, ISHLA, ISHLAB, ISHLB, ISYMA, ISYMAB, ISYMB, KA, KB, LA, LAB, LB
character(len=*), parameter :: SECNAM = 'CHO_RSTOF'
integer(kind=iwp), external :: CHO_F2SP, CHO_RS2F

if (N < 2) call CHO_QUIT('Dimension error [1] in '//SECNAM,104)
if (LRDIM /= MMBSTRT) call CHO_QUIT('Dimension error [2] in '//SECNAM,104)
IRS2F(:,1:MMBSTRT) = 0

do ISYMA=1,NSYM
  if (NBAS(ISYMA) > 0) then
    do ISYMB=1,ISYMA-1
      ISYMAB = MUL(ISYMA,ISYMB)
      do KB=1,NBAS(ISYMB)
        IB = IBAS(ISYMB)+KB
        LB = ISHLSO(IB)
        ISHLB = ISOSHL(IB)
        do KA=1,NBAS(ISYMA)
          IA = IBAS(ISYMA)+KA
          LA = ISHLSO(IA)
          ISHLA = ISOSHL(IA)
          if (ISHLA < ISHLB) then
            LAB = NBSTSH(ISHLB)*(LA-1)+LB
          else if (ISHLA == ISHLB) then
            LAB = ITRI(LA,LB)
          else
            LAB = NBSTSH(ISHLA)*(LB-1)+LA
          end if
          ISHLAB = CHO_F2SP(ITRI(ISHLA,ISHLB))
          if (ISHLAB > 0) then
            IRS = CHO_RS2F(LAB,ISHLAB,ISYMAB,IRED)
            if (IRS > 0) then
              IRS2F(1,IRS) = IA
              IRS2F(2,IRS) = IB
            end if
          end if
        end do
      end do
    end do
    ISYMB = ISYMA
    ISYMAB = 1
    do KA=1,NBAS(ISYMA)
      IA = IBAS(ISYMA)+KA
      LA = ISHLSO(IA)
      ISHLA = ISOSHL(IA)
      do KB=1,KA
        IB = IBAS(ISYMB)+KB
        LB = ISHLSO(IB)
        ISHLB = ISOSHL(IB)
        if (ISHLA < ISHLB) then
          LAB = NBSTSH(ISHLB)*(LA-1)+LB
        else if (ISHLA == ISHLB) then
          LAB = ITRI(LA,LB)
        else
          LAB = NBSTSH(ISHLA)*(LB-1)+LA
        end if
        ISHLAB = CHO_F2SP(ITRI(ISHLA,ISHLB))
        if (ISHLAB > 0) then
          IRS = CHO_RS2F(LAB,ISHLAB,ISYMAB,IRED)
          if (IRS > 0) then
            IRS2F(1,IRS) = IA
            IRS2F(2,IRS) = IB
          end if
        end if
      end do
    end do
  end if
end do

end subroutine CHO_RSTOF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TODSC_MCLR(A,NDIM,MBLOCK,IFIL)
! TRANSFER ARRAY DOUBLE PRECISION  A(LENGTH NDIM) TO DISCFIL IFIL IN
! RECORDS WITH LENGTH NBLOCK.

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDIM, MBLOCK, IFIL
real(kind=wp), intent(in) :: A(NDIM)
integer(kind=iwp) :: I, IDUM(1), IMZERO, ISTOP, MMBLOCK, NBACK, NBLOCK, NLABEL, NTRANS, START
real(kind=wp) :: XNORM
real(kind=wp), external :: ddot_
integer(kind=iwp), parameter :: ICRAY = 1, IPACK = 1

!write(u6,*) ' entering TODSC'
if (IPACK /= 0) then
  ! Check norm of A before writing
  XNORM = ddot_(nDim,A,1,A,1)
  if (XNORM == Zero) then
    IMZERO = 1
  else
    IMZERO = 0
  end if
  !write(u6,*) ' I am going to call ITODS'
  MMBLOCK = MBLOCK
  if (MMBLOCK > 1) MMBLOCK = 1
  IDUM(1) = IMZERO
  call ITODS(IDUM,1,MMBLOCK,IFIL)
  !write(u6,*) ' back from ITODS'
  if (IMZERO == 1) return
end if

if ((MBLOCK >= 0) .or. (ICRAY == 1)) then

  NBLOCK = MBLOCK
  if (MBLOCK <= 0) NBLOCK = NDIM
  ISTOP = 0
  NBACK = NDIM
  ! LOOP OVER RECORDS
  do
    if (NBACK <= NBLOCK) then
      NTRANS = NBACK
      NLABEL = -NTRANS
    else
      NTRANS = NBLOCK
      NLABEL = NTRANS
    end if
    START = ISTOP+1
    ISTOP = START+NBLOCK-1
    NBACK = NBACK-NTRANS
    write(IFIL) (A(I),I=START,ISTOP),NLABEL
    if (NBACK == 0) exit
  end do
end if

if ((ICRAY == 0) .and. (MBLOCK < 0) .and. (NDIM > 0)) then
  !call SQFILE(IFIL,1,A,2*NDIM)
  call SysHalt('todsc')
end if

!write(u6,*) ' leaving TODSC'

return

end subroutine TODSC_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine get_Saa(nSym,nBas,nOrb,Smn,nSmn,Xmo,nXmo,Saa,nSaa)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym), nSmn, nXmo, nSaa
real(kind=wp), intent(in) :: Smn(nSmn), Xmo(nXmo)
real(kind=wp), intent(out) :: Saa(nSaa)
integer(kind=iwp) :: iSym, iX, j, jK, jX, jZ, kX, lk, lX, mOb, nBX
real(kind=wp), allocatable :: Z(:)
real(kind=wp), external :: DDot_

mOb = maxval(nBas(:)*nOrb(:))
call mma_allocate(Z,mOb,Label='Z')

iX = 1
kX = 1
lX = 1
do iSym=1,nSym
  nBx = max(1,nBas(iSym))
  call DGEMM_('N','N',nBas(iSym),nOrb(iSym),nBas(iSym),One,Smn(iX),nBx,Xmo(kX),nBx,Zero,Z,nBx)
  do j=0,nOrb(iSym)-1
    jK = nBas(iSym)*j
    lk = kX+jK
    jZ = 1+jK
    jX = lX+j
    Saa(jX) = ddot_(nBas(iSym),Xmo(lk),1,Z(jZ),1)
  end do
  iX = iX+nBas(iSym)**2
  kX = kX+nBas(iSym)*nOrb(iSym)
  lX = lX+nOrb(iSym)
end do
call mma_deallocate(Z)

end subroutine get_Saa

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Felix Plasser                                    *
!***********************************************************************

subroutine wfa(ireturn)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
#include "warnings.h"

#ifdef _WFA_
integer(kind=iwp) :: iLU, ist, ien
character(len=180), external :: Get_Ln
character(len=180) :: Line
character(len=900) :: Inp
#endif

ireturn = _RC_NOT_AVAILABLE_

#ifdef _WFA_
! Read the input file and parse as a string to libwfa
ist = 1
call SpoolInp(iLU)
do while (Line(1:4) /= 'END ')
  Line = Get_ln(iLU)

  ien = ist+len(trim(Line))
  Inp(ist:ien) = trim(Line)
  ist = ien+1

  call Normal(Line)
end do

write(u6,*) 'Starting wavefunction analysis ...'
call wfa_driver(ireturn,Inp)
#else
write(u6,*) 'WFA module not installed!'
#endif

end subroutine wfa

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine ChoMP2_Energy_Org(irc,Delete,EMP2,EOcc,EVir,Wrk,lWrk)
!
! Thomas Bondo Pedersen, Dec. 2004 / Feb. 2005.
!
! Purpose: compute MP2 energy contribution using original (i.e. not
!          sorted according to batches over occupied orbitals)
!          Cholesky vectors on disk.

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Cholesky, only: nSym, NumCho
use ChoMP2, only: ChoAlg, DecoMP2, iFirstS, iMatab, iT1am, LiMatij, LnOcc, LnT1am, lUnit_F, nBatch, nMatab, nMP2Vec, nT1am, nVir, &
                  Verbose, Wref
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
logical(kind=iwp), intent(in) :: Delete
integer(kind=iwp), intent(in) :: lWrk
real(kind=wp), intent(out) :: EMP2, Wrk(lWrk)
real(kind=wp), intent(in) :: EOcc(*), EVir(*)
integer(kind=iwp) :: i, i0, iAdr, iBat, iBatch, ij, iOpt, iSym, iSyma, iSymab, iSymb, iSymi, iSymij, iSymj, iTyp, iVaJi(8), iVec, &
                     iVec0, iVec1, j, jBatch, jVec, kEnd0, kEnd1, kEnd2, kMabij, kOff, kOff1, kOff2, kOffi, kOffj, kOffM, kRead, &
                     kVai, kVbj, kVec, kVecai, kXaibj, kXint, LiT2am(8), LnT2am, lTot, lWrk0, lWrk1, lWrk2, MinMem, Nai, nBat, &
                     Nbj, nEnrVec(8), NumV, NumVec, nVaJi, nVec
real(kind=wp) :: Fac
integer(kind=iwp), parameter :: iDummy = -999999
real(kind=wp), parameter :: X(0:1) = [Zero,One]
character(len=*), parameter :: SecNam = 'ChoMP2_Energy_Org'

irc = 0

! Set number and type of vectors.
! -------------------------------

if (DecoMP2) then
  iTyp = 2
  nEnrVec(1:nSym) = nMP2Vec(1:nSym)
else
  iTyp = 1
  nEnrVec(1:nSym) = NumCho(1:nSym)
end if

! Initialize MP2 energy correction.
! ---------------------------------

EMP2 = Zero
Wref = Zero

! Print header of status table.
! -----------------------------

if (Verbose) call ChoMP2_Energy_Prt(SecNam,0,iDummy)

! Loop over occupied orbital batches.
! -----------------------------------

do iBatch=1,nBatch
  if (Verbose) call ChoMP2_Energy_Prt(SecNam,1,iBatch)
  do jBatch=iBatch,nBatch

    call ChoMP2_Energy_GetInd(LnT2am,LiT2am,iBatch,jBatch)

    kXaibj = 1
    kEnd0 = kXaibj+LnT2am
    lWrk0 = lWrk-kEnd0+1
    if (lWrk0 < 1) call SysAbendMsg(SecNam,'insufficient memory','[0]')

    ! Special code for iBatch=jBatch and ChoAlg=2:
    ! compute M(ab,ij) = (ai|bj) with i<=j using level 3 BLAS.
    ! For ChoAlg=1: use strictly lower triangular storage (=>
    ! level 2 BLAS).
    ! --------------------------------------------------------

    if ((jBatch == iBatch) .and. (ChoAlg == 2)) then

      kMabij = kXaibj  ! rename pointer
      Wrk(kMabij:kMabij+LnT2am-1) = Zero ! initialize

      ! Loop over Cholesky vector symmetries.
      ! -------------------------------------

      do iSym=1,nSym

        Nai = LnT1am(iSym,iBatch)
        if ((Nai > 0) .and. (nEnrVec(iSym) > 0)) then

          ! Reserve memory for reading a single vector.
          ! -------------------------------------------

          kVecai = kEnd0
          kEnd1 = kVecai+nT1am(iSym)
          lWrk1 = lWrk-kEnd1+1

          if (lWrk1 < Nai) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.1]')

          ! Set up batch over Cholesky vectors.
          ! -----------------------------------

          nVec = min(lWrk1/Nai,nEnrVec(iSym))
          if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.2]') ! should not happen
          nBat = (nEnrVec(iSym)-1)/nVec+1

          ! Open Cholesky vector files.
          ! ---------------------------

          call ChoMP2_OpenF(1,iTyp,iSym)

          ! Start vector batch loop.
          ! ------------------------

          do iBat=1,nBat

            if (iBat == nBat) then
              NumVec = nEnrVec(iSym)-nVec*(nBat-1)
            else
              NumVec = nVec
            end if
            iVec1 = nVec*(iBat-1)+1

            ! Set up index arrays for reordered vectors.
            ! ------------------------------------------

            nVaJi = 0
            do iSymi=1,nSym
              iSyma = Mul(iSymi,iSym)
              iVaJi(iSymi) = nVaJi
              nVaJi = nVaJi+nVir(iSyma)*NumVec*LnOcc(iSymi,iBatch)
            end do

            ! Pointer to reordered vectors: kVec.
            ! -----------------------------------

            kVec = kEnd1
            kEnd2 = kVec+nVaJi
            lWrk2 = lWrk-kEnd2+1
            if (lWrk2 < 0) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.3]') ! should not happen

            ! Read one vector at a time and reorder.
            ! --------------------------------------

            iVec0 = iVec1-1
            do iVec=1,NumVec

              iOpt = 2
              lTot = nT1am(iSym)
              iAdr = nT1am(iSym)*(iVec0+iVec-1)+1
              call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVecai),lTot,iAdr)

              do iSymi=1,nSym
                iSyma = Mul(iSymi,iSym)
                i0 = iFirstS(iSymi,iBatch)-1
                do i=1,LnOcc(iSymi,iBatch)
                  kOff1 = kVecai+iT1am(iSyma,iSymi)+nVir(iSyma)*(i0+i-1)
                  kOff2 = kVec+iVaJi(iSymi)+nVir(iSyma)*NumVec*(i-1)+nVir(iSyma)*(iVec-1)
                  Wrk(kOff2:kOff2+nVir(iSyma)-1) = Wrk(kOff1:kOff1+nVir(iSyma)-1)
                end do
              end do

            end do

            ! Compute M(ab,ij) for i<=j.
            ! First do iSymi=iSymj, then iSymi<iSymj.
            ! ---------------------------------------

            do iSymj=1,nSym

              iSymb = Mul(iSymj,iSym)

              if (nVir(iSymb) > 0) then

                do j=1,LnOcc(iSymj,iBatch)
                  do i=1,j

                    ij = LiMatij(iSymj,iSymj,iBatch)+iTri(i,j)

                    kOffi = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(i-1)
                    kOffj = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(j-1)
                    kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

                    call DGEMM_('N','T',nVir(iSymb),nVir(iSymb),NumVec,One,Wrk(kOffi),nVir(iSymb),Wrk(kOffj),nVir(iSymb),One, &
                                Wrk(kOffM),nVir(iSymb))

                  end do
                end do

                do iSymi=1,iSymj-1

                  iSyma = Mul(iSymi,iSym)
                  iSymab = Mul(iSyma,iSymb)
                  iSymij = iSymab

                  if ((LnOcc(iSymi,iBatch) > 0) .and. (nVir(iSyma) > 0)) then

                    do j=1,LnOcc(iSymj,iBatch)
                      do i=1,LnOcc(iSymi,iBatch)

                        ij = LiMatij(iSymi,iSymj,iBatch)+LnOcc(iSymi,iBatch)*(j-1)+i

                        kOffi = kVec+iVaJi(iSymi)+nVir(iSyma)*NumVec*(i-1)
                        kOffj = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(j-1)
                        kOffM = kMabij+LiT2am(iSymij)+nMatab(iSymab)*(ij-1)+iMatab(iSyma,iSymb)

                        call DGEMM_('N','T',nVir(iSyma),nVir(iSymb),NumVec,One,Wrk(kOffi),nVir(iSyma),Wrk(kOffj),nVir(iSymb), &
                                    One,Wrk(kOffM),nVir(iSyma))

                      end do
                    end do

                  end if

                end do
              end if

            end do

          end do

          ! Close Cholesky vector files.
          ! ----------------------------

          call ChoMP2_OpenF(2,iTyp,iSym)

        end if

      end do ! iSym

    else ! level 2 BLAS for diagonal batches.

      ! Loop over Cholesky vector symmetries.
      ! -------------------------------------

      do iSym=1,nSym

        Nai = LnT1am(iSym,iBatch)
        Nbj = LnT1am(iSym,jBatch)
        if ((Nai > 0) .and. (Nbj > 0) .and. (nEnrVec(iSym) > 0)) then

          ! Allocate memory for reading 1 vector.
          ! -------------------------------------

          kRead = kEnd0
          kEnd1 = kRead+nT1am(iSym)
          lWrk1 = lWrk-kEnd1+1
          if (lWrk1 < 1) call SysAbendMsg(SecNam,'insufficient memory','[0.1]')

          ! Setup Cholesky vector batching.
          ! -------------------------------

          if (jBatch == iBatch) then
            MinMem = Nai
          else
            MinMem = Nai+Nbj
          end if
          NumVec = min(lWrk1/MinMem,nEnrVec(iSym))
          if (NumVec < 1) call SysAbendMsg(SecNam,'insufficient memory','[1]')
          nBat = (nEnrVec(iSym)-1)/NumVec+1

          ! Open Cholesky vector file.
          ! --------------------------

          call ChoMP2_OpenF(1,iTyp,iSym)

          ! Cholesky vector batch loop.
          ! ---------------------------

          do iBat=1,nBat

            if (iBat == nBat) then
              NumV = nEnrVec(iSym)-NumVec*(nBat-1)
            else
              NumV = NumVec
            end if
            iVec1 = NumVec*(iBat-1)+1

            kVai = kEnd1
            kVbj = kVai+Nai*NumV
            if (jBatch == iBatch) then
              kEnd2 = kVbj
              kVbj = kVai
            else
              kEnd2 = kVbj+Nbj*NumV
            end if
            lWrk2 = lWrk-kEnd2+1
            if (lWrk2 < 0) call SysAbendMsg(SecNam,'insufficient memory','[2]') ! this would be a bug...

            ! Read vectors, copy out sub-blocks.
            ! ----------------------------------

            do iVec=1,NumV

              jVec = iVec1+iVec-1
              iOpt = 2
              lTot = nT1am(iSym)
              iAdr = nT1am(iSym)*(jVec-1)+1
              call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kRead),lTot,iAdr)
              kOff = kVai+Nai*(iVec-1)
              call ChoMP2_Srt(Wrk(kRead),Wrk(kOff),1,iSym,iBatch)
              if (jBatch /= iBatch) then
                kOff = kVbj+Nbj*(iVec-1)
                call ChoMP2_Srt(Wrk(kRead),Wrk(kOff),1,iSym,jBatch)
              end if

            end do

            ! Compute integral contribution.
            ! ------------------------------

            Fac = X(min((iBat-1),1))
            kXint = kXaibj+LiT2am(iSym)
            if (iBatch == jBatch) then
              call dGeMM_Tri('N','T',Nai,Nai,NumV,One,Wrk(kVai),Nai,Wrk(kVai),Nai,Fac,Wrk(kXint),Nai)
            else
              call DGEMM_('N','T',Nai,Nbj,NumV,One,Wrk(kVai),Nai,Wrk(kVbj),Nbj,Fac,Wrk(kXint),Nai)
            end if

          end do ! Cholesky vector batch

          ! Close Cholesky vector files.
          ! ----------------------------

          call ChoMP2_OpenF(2,iTyp,iSym)

        end if

      end do ! iSym

    end if

    ! Compute contribution to MP2 energy correction.
    ! ----------------------------------------------

    call ChoMP2_Energy_Contr(EMP2,EOcc,EVir,Wrk(kXaibj),LnT2am,LiT2am,iBatch,jBatch)

  end do ! jBatch
  if (Verbose) call ChoMP2_Energy_Prt(SecNam,2,iBatch)
end do ! iBatch

! Finish table.
! -------------

if (Verbose) call ChoMP2_Energy_Prt(SecNam,3,iBatch)

! If requested, delete vector files.
! ----------------------------------

if (Delete) then
  do iSym=1,nSym
    call ChoMP2_OpenF(1,iTyp,iSym)
    call ChoMP2_OpenF(3,iTyp,iSym)
  end do
end if

! Change sign on energy.
! ----------------------

EMP2 = -EMP2

end subroutine ChoMP2_Energy_Org

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CRESTR_GAS( STRING, NSTINI, NSTINO,    NEL,   NORB,
     &                       IORBOF,      Z, NEWORD, LSGSTR, ISGSTI,
     &                       ISGSTO,     TI,    TTO,  NACOB,  IPRNT)
*
* A type of strings containing NEL electrons are given
* set up all possible ways of adding an electron to this type of strings
*
*========
* Input :
*========
* STRING : Input strings containing NEL electrons
* NSTINI : Number of input  strings
* NSTINO : Number of output strings
* NEL    : Number of electrons in input strings
* NORB   : Number of orbitals
* IORBOF : Number of first orbital
* Z      : Lexical ordering matrix for output strings containing
*          NEL + 1 electrons
* NEWORD : Reordering array for N+1 strings
* LSGSTR : .NE.0 => Include sign arrays ISGSTI,ISGSTO of strings
* ISGSTI : Sign array for NEL   strings
* ISGSTO : Sign array for NEL+1 strings
*
*=========
* Output :
*=========
*
*TI      : TI(I,ISTRIN) .gt. 0 indicates that orbital I can be added
*          to string ISTRIN .
*TTO     : Resulting NEL + 1 strings
*          if the string have a negative sign
*          then the phase equals - 1
      IMPLICIT REAL*8           (A-H,O-Z)
      INTEGER STRING,TI,TTO,STRIN2,Z
*.Input
      DIMENSION STRING(NEL,NSTINI),NEWORD(NSTINO),Z(NORB,NEL+1)
      DIMENSION ISGSTI(NSTINI),ISGSTO(NSTINO)
*.Output
      DIMENSION TI(NORB,NSTINI),TTO(NORB,NSTINI)
*.Scratch
      DIMENSION STRIN2(500)
*
      NTEST0 =  1
      NTEST = MAX(IPRNT,NTEST0)
      IF( NTEST .GE. 20 ) THEN
        WRITE(6,*)  ' =============== '
        WRITE(6,*)  ' CRESTR speaking '
        WRITE(6,*)  ' =============== '
        WRITE(6,*)
         WRITE(6,*) ' Number of input electrons ', NEL
      END IF
C?    WRITE(6,*) ' Reorder array NEWORD '
C?    CALL IWRTMA(NEWORD,1,NSTINO,1,NSTINO)
*
      DO ISTRIN = 1,NSTINI
        DO IORB = IORBOF, IORBOF-1+NORB

          IPLACE = 0

          IF(NEL.EQ.0) THEN

            IPLACE = 1

          ELSE IF ( NEL .NE. 0 ) THEN

            DO IEL = 1, NEL
              IF(IEL.EQ.1.AND.STRING(1,ISTRIN).GT.IORB) THEN
                IPLACE = 1
                EXIT
              ELSE IF( (IEL.EQ.NEL.AND.IORB.GT.STRING(IEL,ISTRIN)) .OR.
     &                 (IEL.LT.NEL.AND.IORB.GT.STRING(IEL,ISTRIN).AND.
     &                  IORB.LT.STRING(MIN(NEL,IEL+1),ISTRIN)) ) THEN
                IPLACE = IEL+1
                EXIT
              ELSE IF(STRING(IEL,ISTRIN).EQ.IORB) THEN
                IPLACE = 0
                EXIT
              END IF
            END DO

          END IF
*
          IF(IPLACE==0) CYCLE

*. Generate next string
          DO I = 1, IPLACE-1
             STRIN2(I) = STRING(I,ISTRIN)
          END DO
          STRIN2(IPLACE) = IORB
          DO  I = IPLACE,NEL
            STRIN2(I+1) = STRING(I,ISTRIN)
          END DO
C?        write(6,*) ' updated string (STRIN2) '
C?        call iwrtma(STRIN2,1,NEL+1,1,NEL+1)
          JSTRIN = ISTRNM(STRIN2,NACOB,NEL+1,Z,NEWORD,1)
C?        write(6,*) ' corresponding number ', JSTRIN
*
          TTO(IORB-IORBOF+1,ISTRIN) = JSTRIN
          IIISGN = (-1)**(IPLACE-1)
          IF(LSGSTR.NE.0) IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
          IF(IIISGN .EQ. -1 )
     &      TTO(IORB-IORBOF+1,ISTRIN) = - TTO(IORB-IORBOF+1,ISTRIN)
          TI(IORB-IORBOF+1,ISTRIN ) = IORB

        END DO
*
      END DO
*
      IF ( NTEST .GE. 20) THEN
        MAXPR = 60
        NPR = MIN(NSTINI,MAXPR)
        WRITE(6,*) ' Output from CRESTR : '
        WRITE(6,*) '==================='
*
        WRITE(6,*)
        WRITE(6,*) ' Strings with an electron added  '
        DO ISTRIN = 1, NPR
           WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &     'String..',ISTRIN,' New strings.. ',
     &     (TTO(I,ISTRIN),I = 1,NORB)
        END DO
        DO ISTRIN = 1, NPR
           WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &     'String..',ISTRIN,' orbitals added or removed ' ,
     &     (TI(I,ISTRIN),I = 1,NORB)
        END DO
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine orb2tpstr_sym(NF,NI,N1,N2,N3,NS,ND,TYPESTRING)
!SVC: convert orbital partition info to a typestring array
!     corresponding to a _specific_symmetry_ (so these variables are
!     scalars!!
!     A typestring array consists of characters of 'fi123sd'

use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NF, NI, N1, N2, N3, NS, ND
character, intent(_OUT_) :: typestring(*)
integer(kind=iwp) :: IB, iOff

iOff = 0

do IB=1,NF
  TYPESTRING(iOff+IB) = 'F'
end do
iOff = iOff+NF

do IB=1,NI
  TYPESTRING(iOff+IB) = 'I'
end do
iOff = iOff+NI

do IB=1,N1
  TYPESTRING(iOff+IB) = '1'
end do
iOff = iOff+N1

do IB=1,N2
  TYPESTRING(iOff+IB) = '2'
end do
iOff = iOff+N2

do IB=1,N3
  TYPESTRING(iOff+IB) = '3'
end do
iOff = iOff+N3

do IB=1,NS
  TYPESTRING(iOff+IB) = 'S'
end do
iOff = iOff+NS

do IB=1,ND
  TYPESTRING(iOff+IB) = 'D'
end do

end subroutine orb2tpstr_sym

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_OpenB(iOpt,iSym,iBatch)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: open (iOpt=1), close and keep (iOpt=2), or close and
C              delete (iOpt=3) Cholesky vector files for MP2 program
C              (batch vectors).
C              For iOpt=0, the units are initialized (to -1).
C
      use ChoMP2, only: LnT1am, lUnit
#include "implicit.fh"
#include "cholesky.fh"
#include "chomp2.fh"

      Character*12 SecNam
      Parameter (SecNam = 'ChoMP2_OpenB')

      Character*2 BaseNm
      Parameter (BaseNm = '_I')

      Character*6 BtchNm


C     Initialize units and return for iOpt=0.
C     ---------------------------------------

      If (iOpt .eq. 0) Then
         lUnit(iSym,iBatch) = -1
         Return
      End If

C     Open or close files.
C     --------------------

      If (iOpt .eq. 1) Then
         If (LnT1am(iSym,iBatch) .gt. 0) Then
            If (iBatch .lt. 10) Then
               Write(BtchNm,'(A2,I1,A2,I1)') BaseNm,iSym,'__',iBatch
            Else If (iBatch .lt. 100) Then
               Write(BtchNm,'(A2,I1,A1,I2)') BaseNm,iSym,'_',iBatch
            Else If (iBatch .lt. 1000) Then
               Write(BtchNm,'(A2,I1,I3)')    BaseNm,iSym,iBatch
            Else ! note: due to restriction in filename length...
               Call ChoMP2_Quit(SecNam,'Too many batches',
     &                          '(Current max. is 999)')
               BtchNm = '?!?!?!' ! too avoid compiler warnings...
            End If
            lU = 7
            Call daName_MF_WA(lU,BtchNm)
         Else
            lU = -1
         End If
         lUnit(iSym,iBatch) = lU
      Else If (iOpt .eq. 2) Then
         lU = lUnit(iSym,iBatch)
         If (lU .gt. 0) Then
            Call daClos(lU)
            lUnit(iSym,iBatch) = -1
         End If
      Else If (iOpt .eq. 3) Then
         lU = lUnit(iSym,iBatch)
         If (lU .gt. 0) Then
            Call daEras(lU)
            lUnit(iSym,iBatch) = -1
         End If
      Else
         Call ChoMP2_Quit(SecNam,'iOpt out of bounds',' ')
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Start_Alaska()

use Slapaf_Info, only: iState, Request_Alaska, Request_RASSI
use UnixInfo, only: ProgName
use PrintLevel, only: nPrint
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iEnd, istatus, LuInput, LuSpool, NACstatesOpt(2)
logical(kind=iwp) :: Exists
character(len=len(ProgName)) :: PName
character(len=180) :: Line
character(len=128) :: FileName
character(len=16) :: StdIn, JOB1, JOB2
character(len=8) :: Method
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
! Get the name of the module

PName = ProgName
call Upcase(PName)
PName = adjustl(PName)

iEnd = 1
do
  if (PName(iEnd:iEnd) == ' ') exit
  iEnd = iEnd+1
end do
iEnd = min(iEnd-1,5)
FileName = PName(1:iend)//'INP'

LuInput = 11
LuInput = IsFreeUnit(LuInput)
call StdIn_Name(StdIn)
call Molcas_Open(LuInput,StdIn)

if (Request_RASSI) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Request computation of overlaps.

  if (nPrint(1) >= 6) then
    write(u6,*)
    write(u6,*) ' Slapaf requests the computation of overlaps first!'
    write(u6,*)
  end if

  call Get_cArray('Relax Method',Method,8)
  if ((Method == 'CASPT2') .or. (Method == 'RASPT2')) then
    JOB1 = 'JOBMIX'
  else
    JOB1 = 'JOBIPH'
  end if
  call f_inquire('JOBAUTO',Exists)
  JOB2 = JOB1
  if (Exists) JOB2 = 'JOBAUTO'

  write(LuInput,'(A)') '>ECHO OFF'
  write(LuInput,'(A)') '> export SL_OLD_TRAP=$MOLCAS_TRAP'
  write(LuInput,'(A)') '> export MOLCAS_TRAP=ON'
  write(LuInput,'(A)') ' &RASSI &End'
  write(LuInput,'(A)') 'StOverlaps'
  write(LuInput,'(A)') 'NrOfJobIphs'
  write(LuInput,'(A)') '  2 all'
  write(LuInput,'(A)') 'IphNames'
  write(LuInput,'(A)') '  '//trim(JOB1)
  write(LuInput,'(A)') '  '//trim(JOB2)
  write(LuInput,'(A)') ' End of Input'
  if (JOB1 == 'JOBMIX') then
    write(LuInput,'(A)') '> copy $Project.JobMix JOBAUTO'
  else
    write(LuInput,'(A)') '> copy $Project.JobIph JOBAUTO'
  end if
  write(LuInput,'(A)') '> export MOLCAS_TRAP=$SL_OLD_TRAP'

else if (Request_Alaska) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Request computation of gradients.

  if (nPrint(1) >= 6) then
    call Get_cArray('Relax Method',Method,8)
    write(u6,*)
    write(u6,*) ' Slapaf requests the computation of gradients first!'
    if (iState(2) == 0) then
      write(u6,*) 'Root: ',iState(1)
      if (Method == 'MSPDFT  ') then
        NACstatesOpt(1) = iState(1)
        NACstatesOpt(2) = iState(2)
        call put_iArray('NACstatesOpt    ',NACstatesOpt,2)
        call put_lscalar('CalcNAC_Opt     ',.false.)
      end if
    else
      write(u6,*) 'Roots: ',iState(1),',',iState(2)
      if (Method == 'MSPDFT  ') then
        NACstatesOpt(1) = iState(1)
        NACstatesOpt(2) = iState(2)
        call put_iArray('NACstatesOpt    ',NACstatesOpt,2)
        ! Identify if MECI command in MC-PDFT should be used
        call put_lscalar('CalcNAC_Opt     ',.true.)
      end if
    end if
    write(u6,*)
  end if

  write(LuInput,'(A)') '>ECHO OFF'
  write(LuInput,'(A)') '>export SL_OLD_TRAP=$MOLCAS_TRAP'
  write(LuInput,'(A)') '> export MOLCAS_TRAP=ON'
  write(LuInput,'(A)') ' &Alaska &End'
  write(LuInput,'(A)') 'AUTO'
  if (iState(2) /= 0) then
    write(LuInput,'(A)') 'NAC'
    write(LuInput,'(I5,1X,I5)') iState(1),iState(2)
    write(LuInput,'(A)') 'NoCSF'
  end if
  write(LuInput,'(A)') ' End of Input'
  write(LuInput,'(A)') '> export MOLCAS_TRAP=$SL_OLD_TRAP'
  ! Repeat ECHO OFF, because it may have been turned on by alaska
  write(LuInput,'(A)') '>ECHO OFF'
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Common code.

call f_inquire(Filename,Exists)
if (Exists) then
  LuSpool = 77
  LuSpool = IsFreeUnit(LuSpool)
  call Molcas_Open(LuSpool,Filename)

  do
    read(LuSpool,'(A)',iostat=istatus) Line
    if (istatus < 0) exit
    write(LuInput,'(A)') Line
  end do

  close(LuSpool)

else

  write(LuInput,'(A)') ' &Slapaf &End'
  write(LuInput,'(A)') ' End of Input'

end if
write(LuInput,'(A)') '>ECHO ON'

close(LuInput)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Start_Alaska

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PCM_Driver(iPrint,DMat,V,Q,nTs)
      Implicit Real*8 (A-H,O-Z)
      Real*8 V(2,nTs),Q(2,nTs),DMat(nTs,nTs)
      Data Zero,Half /0.0d0,0.5d0/
*
*     Computes PCM solvation charges given the nuclear and electronic electrostatic
*     potential on each tessera.
*     Modifies nuclear repulsion, one-electron and two electron terms.
*
      call dcopy_(2*nTs,[Zero],0,Q,1)
      Do iTs = 1, nTs
        Do jTs = 1, nTs
           tmp=DMat(iTs,jTs)+DMat(jTs,iTs)
           DMat(iTs,jTs)=Half*tmp
           DMat(jTs,iTs)=Half*tmp
        End Do
      End Do

      Do iTs = 1, nTs
        Do jTs = 1, nTs
*-------- Actual nuclear charge
          Q(1,iTs) = Q(1,iTs) + DMat(iTs,jTs) * V(1,jTs)
*-------- Effective nuclear charge
c_rl      Q(1,iTs) = Q(1,iTs)
c_rl &             + Half*(DMat(iTs,jTs)+DMat(jTs,iTs)) * V(1,jTs)
*-------- Actual electronic charge
          Q(2,iTs) = Q(2,iTs) + DMat(iTs,jTs) * V(2,jTs)
        EndDo
      EndDo

!      do i=1,nTs   ! yma delete later
!        write(*,*)" == V(2,iTs) diff == ",i,V(2,i)
!      end do

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iPrint)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NXTORD(INUM,NELMNT,MNVAL,MXVAL,NONEW)
! An ordered set of numbers INUM(I),I=1,NELMNT is
! given in strictly ascending order. Values of INUM(*) is
! restricted to the interval MNVAL,MXVAL.
!
! Find next higher number.
!
! NONEW = 1 on return indicates that no additional numbers
! could be obtained.
!
! Jeppe Olsen May 1989

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NELMNT, MNVAL, MXVAL
integer(kind=iwp), intent(inout) :: INUM(NELMNT)
integer(kind=iwp), intent(out) :: NONEW
integer(kind=iwp) :: ICMP, IPLACE

#ifdef _DEBUGPRINT_
write(u6,*) ' Initial number in NXTORD'
call IWRTMA(INUM,1,NELMNT,1,NELMNT)
#endif

IPLACE = 0
do
  IPLACE = IPLACE+1
  if (IPLACE < NELMNT) then
    ICMP = INUM(IPLACE+1)
  else
    ICMP = MXVAL+1
  end if
  if (INUM(IPLACE)+1 < ICMP) then
    INUM(IPLACE) = INUM(IPLACE)+1
    NONEW = 0
    exit
  else if (IPLACE < NELMNT) then
    if (IPLACE == 1) then
      INUM(IPLACE) = MNVAL
    else
      INUM(IPLACE) = INUM(IPLACE-1)+1
    end if
  else if (IPLACE == NELMNT) then
    NONEW = 1
    exit
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' New number'
call IWRTMA(INUM,1,NELMNT,1,NELMNT)
#endif

end subroutine NXTORD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine ds_ardlr_act_c1(lin )
!=======================================================================
!ds(7-1) ar(23)-drl(30)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrd=norb_frz+1,lri-1
          lmd=lsm_inn(lrd)
          if(lmd.ne.jml) cycle
          iwdr=just(lri,lri)
          iwdl=jud(lrd)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          w0ds1 =w0_ds(1)
          ni=mod(norb_dz-lrd,2)
          if(ni.eq.0) w0ds1 =-w0ds1
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ds1
            vplp_w1(mpl)=0.d0
          enddo
          call ar_drl_ext_al_new(lin,lrd,lri )
        enddo
      enddo
      return
      end

      subroutine ds_arblbr_act_c1(lin )
!=======================================================================
!ds(7-3) ar(23)-bl(32)-br(31)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmr) cycle
!ds(7-3) ar(23)-bl(32)-br(31)-
          do lrd=norb_frz+1,lri-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jml) cycle
            ijk=lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
            w0ds =w0_ds(3)
            w1ds =w1_ds(3)
            ni=mod(norb_dz-lrj+lri-lrd,2)
            if(ni.eq.0) w0ds =-w0ds
            if(ni.eq.0) w1ds =-w1ds

            iwdr=just(lri,lrj)
            iwdl=jud(lrd)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ds
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ds
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
          enddo
        enddo
      enddo
      return
      end

      subroutine dt_arblbr_act_c1(lin )
!=======================================================================
!dt(14) ar(23)-bl(32)-br(32)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmr) cycle
!dt(14) ar(23)-bl(32)-br(32)-
          do lrd=norb_frz+1,lri-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jml) cycle
            ijk=lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
            w0dt =w0_dt
            w1dt =w1_dt
            ni=mod(norb_dz-lrj+lri-lrd,2)
            if(ni.eq.0) w0dt =-w0dt
            if(ni.eq.0) w1dt =-w1dt

            iwdr=just(lri,lrj)     !
            iwdl=jud(lrd)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dt
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dt
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
          enddo
        enddo
      enddo
      return
      end

      subroutine dv_ar_act_blbr(lin,jk )
!=======================================================================
!dv(23-1) ar(23)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)

        w0dv1=w0_dv(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0dv1=-w0dv1
        iwdl=jud(lri)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0dv1
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0dv1
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
      enddo
      return
      end

      subroutine dv_ar_act_brbr(lin,lrai,lraj )
!=======================================================================
!dv(23-1) ar(23)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle
        ijk=lri-norb_frz+ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)
        intpos=intind_ijka(ijk)

        w0dv1=w0_dv(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0dv1=-w0dv1
        iwdl=jud(lri)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0dv1
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0dv1
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_br_br_ext_ar_new(lin,intpos,isma )
      enddo
      return
      end

      subroutine dv_ar_act_dlr(lin,lra)
!=======================================================================
!dv(23-1) ar(23)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle

        w0dv1=w0_dv(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0dv1=-w0dv1
        iwdl=jud(lri)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0dv1
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0dv1
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_drl_ext_al_new(lin,lri,lra)
      enddo
      return
      end

      subroutine tt_arbl_act_bl(lin,lra)
!=======================================================================
!tt(11-1) (22)ar(23)-bl(32)-
!tt(11-1) ar(23)-c'(22)-bl(32)-
!tt(11-1) ar(23)-bl(32)-c"(22)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
          ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos=intind_ijka(ijk)
          call tt1_ext(lri,lrj,nk,1)
          call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk )
          call tt1_ext(lri,lrj,nk,-1)
          call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk )
        enddo
      enddo
      return
      end

      subroutine tt_drl_act_bl(lin,lra)
!tt(11-2) (22)drl(22)-
!tt(11-2) drl(22)-c"(22)-
!tt(11-3) (22)(22)drl(33)-
!tt(11-3) (22)drl(33)-c"(22)-
!tt(11-3) drl(33)-c"(22)-c"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
        do lri=norb_frz+1,norb_dz
          lmi=lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj=lsm_inn(lrj)
            lmij=mul_tab(lmi,lmj)
            if(lmij.ne.jml) cycle
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_tt(2)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_tt(2)
            enddo
!tt(11-2) (22)drl(22)-
!tt(11-2) drl(22)-c"(22)-
            iwdl=just(lri,lrj)      !
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call drl_bl_ext_ar_new(lin,lri,lra)
            call drl_bl_ext_ar_new(lin,lrj,lra)
!tt(11-3) drl(33)-c"(22)-c"(22)-
!tt(11-3) (22)drl(33)-c"(22)-
!tt(11-3) (22)(22)drl(33)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_tt(3)
              vplp_w1(mpl)=0.d0
            enddo
            if(lra.gt.norb_dz) then
              call drl_bl_sum_ar_new(lin,lri,lrj,lra)
            else
              do lrk=1,norb_dz
                if(lrk.eq.lri) cycle
                if(lrk.eq.lrj) cycle
                call drl_bl_ext_ar_new(lin,lrk,lra)
              enddo
            endif
c            do lrk=1,norb_dz
c              if(lrk.eq.lri) cycle
c              if(lrk.eq.lrj) cycle
c           call drl_bl_ext_ar_new(lin,lrk,lra)
c            enddo
          enddo
        enddo
      return
      end

      subroutine tt_arbl_act_br(lin,lra)
!=======================================================================
!tt(11-1) (22)ar(23)-bl(32)-
!tt(11-1) ar(23)-c'(22)-bl(32)-
!tt(11-1) ar(23)-bl(32)-c"(22)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
          ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos=intind_ijka(ijk)
          call tt1_ext(lri,lrj,nk,1)
          call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
          call tt1_ext(lri,lrj,nk,-1)
          call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
        enddo
      enddo
      return
      end

      subroutine tt_drl_act_br(lin,lra)
!tt(11-2) (22)drl(22)-
!tt(11-2) drl(22)-c"(22)-
!tt(11-3) (22)(22)drl(33)-
!tt(11-3) (22)drl(33)-c"(22)-
!tt(11-3) drl(33)-c"(22)-c"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
        do lri=norb_frz+1,norb_dz
          lmi=lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj=lsm_inn(lrj)
            lmij=mul_tab(lmi,lmj)
            if(lmij.ne.jml) cycle
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_tt(2)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_tt(2)
            enddo
!tt(11-2) (22)drl(22)-
!tt(11-2) drl(22)-c"(22)-
            iwdl=just(lri,lrj)       !
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call drl_br_ext_al_new(lin,lri,lra)
            call drl_br_ext_al_new(lin,lrj,lra)
!tt(11-3) drl(33)-c"(22)-c"(22)-
!tt(11-3) (22)drl(33)-c"(22)-
!tt(11-3) (22)(22)drl(33)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_tt(3)
              vplp_w1(mpl)=0.d0
            enddo
            if(lra.gt.norb_dz) then
             call drl_br_sum_al_new(lin,lri,lrj,lra)
            else
             do lrk=1,norb_dz
                if(lrk.eq.lri) cycle
                if(lrk.eq.lrj) cycle
                call drl_br_ext_al_new(lin,lrk,lra)
              enddo
            endif
c            do lrk=1,norb_dz
c              if(lrk.eq.lri) cycle
c              if(lrk.eq.lrj) cycle
c           call drl_br_ext_al_new(lin,lrk,lra)
c            enddo
          enddo
        enddo
      return
      end

      subroutine st_drl_act_bl(lin,lra)
!st(2-5) (22)drl(12)-
!st(2-6) drl(22)-c"(12)-
!st(2-7) drl(12)-c"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(lmij.ne.jml) cycle
!-------------------------------------------------------------------
!st(2-5) (22)drl(12)-
          iwdl=just(lri,lrj)
          iwdr=iwdl         !
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_st(5)
          enddo
          call drl_bl_ext_ar_new(lin,lrj,lra)
!st(2-6) drl(22)-c"(12)-
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_st(6)
          enddo
          call drl_bl_ext_ar_new(lin,lri,lra)
        enddo
      enddo
      return
      end

      subroutine st_arbl_act_bl(lin,lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz-1
        do lrj=lri+1,norb_dz
          ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos=intind_ijka(ijk)
          call st1_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
          call st2_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
          call st4_ext(lri,lrj,nk,1)
          if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
          call st4_ext(lri,lrj,nk,-1)
          if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
        enddo
      enddo
      return
      end

      subroutine st_drl_act_br(lin,lra)
!st(2-5) (22)drl(12)-
!st(2-6) drl(22)-c"(12)-
!st(2-7) drl(12)-c"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(lmij.ne.jml) cycle
!-------------------------------------------------------------------
!st(2-5) (22)drl(12)-
          iwdl=just(lri,lrj)
          iwdr=iwdl             !
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_st(5)
          enddo
          call drl_br_ext_al_new(lin,lrj,lra)
!st(2-6) drl(22)-c"(12)-
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_st(6)
          enddo
          call drl_br_ext_al_new(lin,lri,lra)
        enddo
      enddo
      return
      end

      subroutine st_arbl_act_br(lin,lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz-1
        do lrj=lri+1,norb_dz
          ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos=intind_ijka(ijk)
          call st1_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          call st2_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
          call st4_ext(lri,lrj,nk,1)
          if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
          call st4_ext(lri,lrj,nk,-1)
          if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
        enddo
      enddo
      return
      end

      subroutine ss_arbl_act_br(lin,lra)
!=======================================================================
!ss(1-3)  ar(13)-bl(20)-
!ss(1-6)  (11)-ar(23)-bl(32)-
!ss(1-7)  ar(13)-c'(21)-bl(32)-
!ss(1-8)  ar(13)-c'(22)-bl(31)-
!ss(1-9)  ar(23)-c'(11)-bl(32)-
!ss(1-11) ar(13)-bl(31)-c"(22)-
!ss(1-12) ar(13)-bl(32)-c"(21)-
!ss(1-13) ar(23)-bl(31)-c"(12)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        do lrj=lri+1,norb_dz
          ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos=intind_ijka(ijk)
!-------------------------------------------------------------------
          call ss2_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          call ss4_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          call ss5_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
          call ss10_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
          call ss14_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
!-------------------------------------------------------------------
        enddo
      enddo
      return
      end

      subroutine ss_drl_act_br(lin,lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
        do lri=norb_frz+1,norb_dz
          lmi=lsm_inn(lri)
          if(jml.eq.1) then
!ss(1-20) drl(33)-c"(00)-
            iwdl=just(lri,lri)
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(20)
              vplp_w1(mpl)=0.d0
            enddo
            if(lri.gt.norb_dz) then
             call drl_br_sum_al_new(lin,lri,0,lri)
            else
             do lrk=1,norb_dz
                if(lrk.eq.lri) cycle
                call drl_br_ext_al_new(lin,lrk,lra)
              enddo
            endif
         endif
          do lrj=lri+1,norb_dz
            lmj=lsm_inn(lrj)
            lmij=mul_tab(lmi,lmj)
            if(lmij.ne.jml) cycle
!ss(1-15) (22)-drl(11)-
            iwdl=just(lri,lrj)
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(15)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(15)
            enddo
            call drl_br_ext_al_new(lin,lrj,lra)
!ss(1-17) drl(22)-c"(11)-
            iwdl=just(lri,lrj)
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(17)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(17)
            enddo
            call drl_br_ext_al_new(lin,lri,lra)
!ss(1-20) drl(33)-c"(22)-c"(11)-
!ss(1-20) (22)drl(33)-c"(11)-
!ss(1-20) (22)(11)drl(33)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(20)
              vplp_w1(mpl)=0.d0
            enddo
            if(lra.gt.norb_dz) then
              call drl_br_sum_al_new(lin,lri,lrj,lra)
            else
              do lrk=1,norb_dz
                if(lrk.eq.lri) cycle
                if(lrk.eq.lrj) cycle
                call drl_br_ext_al_new(lin,lrk,lra)
              enddo
            endif
         enddo
        enddo
      return
      end

      subroutine ts_arbl_act_br(lin,lra)
!=======================================================================
!ts(3) a&r-b^l-  act -b&l ............................................
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
        do lri=norb_frz+1,norb_dz
          do lrj=lri+1,norb_dz
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
            intpos=intind_ijka(ijk)
            call ts1_ext(lri,lrj,nk)
            if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,1)
            call ts2_ext(lri,lrj,nk,1)
            if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
            call ts2_ext(lri,lrj,nk,-1)
            if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
            call ts4_ext(lri,lrj,nk)
            if(nk.ne.0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
          enddo
        enddo
      return
      end

      subroutine ts_arbl_act_bl(lin,lra)
!=======================================================================
!ts(3) a&r-b^l-  act -b&l ............................................
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
        do lri=norb_frz+1,norb_dz
          do lrj=lri+1,norb_dz
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
            intpos=intind_ijka(ijk)
            call ts1_ext(lri,lrj,nk)
            if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
            call ts2_ext(lri,lrj,nk,1)
            if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
            call ts2_ext(lri,lrj,nk,-1)
            if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
            call ts4_ext(lri,lrj,nk)
            if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
          enddo
        enddo
      return
      end

      subroutine ss_drl_act_bl(lin,lra)
!=======================================================================
!ss(1)    act -bl-
!ss(1-16) (11)-drl(22)-
!ss(1-17) drl(22)-c"(11)-
!ss(1-18) drl(11)-c"(22)-
!ss(1-19) drl(12)-c"(21)-
!ss(1-20) drl(33)-c"(11)-c"(22)-
!ss(1-20) (11)drl(33)-c"(22)-
!ss(1-20) (11)(22)drl(33)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
        do lri=norb_frz+1,norb_dz
          lmi=lsm_inn(lri)
          if(jml.eq.1) then
!ss(1-20) drl(33)-c"(00)-
            iwdl=just(lri,lri)
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(20)
              vplp_w1(mpl)=0.d0
            enddo
            if(lra.gt.norb_dz) then
              call drl_bl_sum_ar_new(lin,lri,0,lra)
            else
              do lrk=1,norb_dz
                if(lrk.eq.lri) cycle
                call drl_bl_ext_ar_new(lin,lrk,lra)
              enddo
            endif
c            do lrk=1,norb_dz
c              if(lrk.eq.lri) cycle
c              call drl_bl_ext_ar_new(lin,lrk,lra)
c            enddo
          endif
          do lrj=lri+1,norb_dz
            lmj=lsm_inn(lrj)
            lmij=mul_tab(lmi,lmj)
            if(lmij.ne.jml) cycle
            iwdl=just(lri,lrj)
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
!ss(1-15) (22)-drl(11)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(15)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(15)
            enddo
            call drl_bl_ext_ar_new(lin,lrj,lra)
!ss(1-17) drl(22)-c"(11)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(17)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(17)
            enddo
            call drl_bl_ext_ar_new(lin,lri,lra)
!ss(1-20) drl(33)-c"(22)-c"(11)-
!ss(1-20) (22)drl(33)-c"(11)-
!ss(1-20) (22)(11)-drl(33)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(20)
              vplp_w1(mpl)=0.d0
            enddo
            if(lra.gt.norb_dz) then
              call drl_bl_sum_ar_new(lin,lri,lrj,lra)
            else
              do lrk=1,norb_dz
                if(lrk.eq.lri) cycle
                if(lrk.eq.lrj) cycle
                call drl_bl_ext_ar_new(lin,lrk,lra)
              enddo
            endif
c            do lrk=1,norb_dz
c              if(lrk.eq.lri) cycle
c              if(lrk.eq.lrj) cycle
c              call drl_bl_ext_ar_new(lin,lrk,lra)
c            enddo
          enddo
        enddo
      return
      end

      subroutine ss_arbl_act_bl(lin,lra)
!=======================================================================
!ss(1)    act -bl-
!ss(1-3)  ar(13)-bl(20)-
!ss(1-6)  (11)-ar(23)-bl(32)-
!ss(1-7)  ar(13)-c'(21)-bl(32)-
!ss(1-8)  ar(13)-c'(22)-bl(31)-
!ss(1-9)  ar(23)-c'(11)-bl(32)-
!ss(1-11) ar(13)-bl(31)-c"(22)-
!ss(1-12) ar(13)-bl(32)-c"(21)-
!ss(1-13) ar(23)-bl(31)-c"(12)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        do lrj=lri+1,norb_dz
          ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos=intind_ijka(ijk)
          call ss2_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
          call ss4_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
          call ss5_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
          call ss10_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
          call ss14_ext(lri,lrj,nk)
          if(nk.ne.0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
        enddo
      enddo
      return
      end

      subroutine sd_ar_act_bl(lin,lra)
!sd(6-1) a&r(02)-
!sd(6-2) (22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1 =w0_sd(1)
        w0sd2 =w0_sd(2)
        w0sd4 =w0_sd(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd2 =-w0sd2
          w0sd4 =-w0sd4
        endif
        if(jml.eq.1.and.lmi.eq.jmr) then
!sd(6-1) a&r(02)-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1 )
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1 )
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1 )
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1 )
        endif
!sd(6-2) (22)a&(13)-
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
        enddo
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1 )
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1 )
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1 )
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1 )
        enddo
!sd(6-4) a&r(23)-c'(12)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1 )
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1 )
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1 )
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1 )
        enddo
      enddo
      return
      end

      subroutine sd_ar_act_blbl(lin,jk)
!sd(6-1) a&r(02)-
!sd(6-2) (22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
        w0sd1 =w0_sd(1)
        w0sd2 =w0_sd(2)
        w0sd4 =w0_sd(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd2 =-w0sd2
          w0sd4 =-w0sd4
        endif
!sd(6-1) a&r(02)-
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
           call ar_bl_bl_ext_ar_new(lin,intpos,isma,1 )
          endif
!------------------------------------------------------------------
!sd(6-2) c(22)a&(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
            enddo
            do lrk=norb_frz+1,lri-1
              lmk=lsm_inn(lrk)
              if(lmk.ne.jmr) cycle
              iwdl=just(lrk,lri)
              iwdr=jud(lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
            enddo
!-------------------------------------------------------------------
!sd(6-4) a&r(23)c'(12)-
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
            enddo
            do lrk=lri+1,norb_dz
              lmk=lsm_inn(lrk)
              if(lmk.ne.jmr) cycle
              iwdl=just(lri,lrk)
              iwdr=jud(lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
            enddo
          enddo
        return
      end

      subroutine sd_ar_act_brbr(lin,jk)
!sd(6-1) a&r(02)-
!sd(6-2) (22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
        w0sd1 =w0_sd(1)
        w0sd2 =w0_sd(2)
        w0sd4 =w0_sd(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd2 =-w0sd2
          w0sd4 =-w0sd4
        endif
!sd(6-1) a&r(02)-
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
         call ar_br_br_ext_ar_new(lin,intpos,isma )
          endif
!------------------------------------------------------------------
!sd(6-2) c(22)a&(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
            enddo
            do lrk=norb_frz+1,lri-1
              lmk=lsm_inn(lrk)
              if(lmk.ne.jmr) cycle
              iwdl=just(lrk,lri)
              iwdr=jud(lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_br_br_ext_ar_new(lin,intpos,isma )
            enddo
!-------------------------------------------------------------------
!sd(6-4) a&r(23)c'(12)-
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
            enddo
            do lrk=lri+1,norb_dz
              lmk=lsm_inn(lrk)
              if(lmk.ne.jmr) cycle
              iwdl=just(lri,lrk)
              iwdr=jud(lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_br_br_ext_ar_new(lin,intpos,isma )
            enddo
          enddo
        return
      end

      subroutine sd_ar_act_blbr(lin,jk)
!sd(6-1) a&r(02)-
!sd(6-2) (22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
        w0sd1 =w0_sd(1)
        w0sd2 =w0_sd(2)
        w0sd4 =w0_sd(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd2 =-w0sd2
          w0sd4 =-w0sd4
        endif
!sd(6-1) a&r(02)-
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
          endif
!------------------------------------------------------------------
!sd(6-2) c(22)a&(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
            enddo
            do lrk=norb_frz+1,lri-1
              lmk=lsm_inn(lrk)
              if(lmk.ne.jmr) cycle
              iwdl=just(lrk,lri)
              iwdr=jud(lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
            enddo
!-------------------------------------------------------------------
!sd(6-4) a&r(23)c'(12)-
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
            enddo
            do lrk=lri+1,norb_dz
              lmk=lsm_inn(lrk)
              if(lmk.ne.jmr) cycle
              iwdl=just(lri,lrk)
              iwdr=jud(lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
            enddo
          enddo
        return
      end

      subroutine sd_ar_act_dlr(lin,lra)
!sd(6-1) a&r(02)-
!sd(6-2) (22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1 =w0_sd(1)
        w0sd2 =w0_sd(2)
        w0sd4 =w0_sd(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd2 =-w0sd2
          w0sd4 =-w0sd4
        endif
!sd(6-1) a&r(02)-
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_drl_ext_al_new(lin,lri,lra)
          endif
!------------------------------------------------------------------
!sd(6-2) c(22)a&(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
            enddo
            do lrk=norb_frz+1,lri-1
              lmk=lsm_inn(lrk)
              if(lmk.ne.jmr) cycle
              iwdl=just(lrk,lri)
              iwdr=jud(lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_drl_ext_al_new(lin,lri,lra)
            enddo
!-------------------------------------------------------------------
!sd(6-4) a&r(23)c'(12)-
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
            enddo
            do lrk=lri+1,norb_dz
              lmk=lsm_inn(lrk)
              if(lmk.ne.jmr) cycle
              iwdl=just(lri,lrk)
              iwdr=jud(lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_drl_ext_al_new(lin,lri,lra)
            enddo
          enddo
        return
      end

      subroutine td_ar_act_bl(lin,lra)
!td(13-1) (22)a(23)
!td(13-1) a(23)c'(22)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_td(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
!-------------------------------------------------------------------
!td(13-1) (22)a(23)
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)                   !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1 )
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1 )
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1 )
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1 )
          enddo
!-------------------------------------------------------------------
!td(13-1) a(23)c'(22)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)        !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1 )
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1 )
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1 )
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1 )
          enddo
        enddo
      return
      end

      subroutine td_ar_act_brbr(lin,jk )
!td(13-1) (22)a(23)
!td(13-1) a(23)c'(22)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_td(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
!-------------------------------------------------------------------
!td(13-1) (22)a(23)
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)     !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_br_br_ext_ar_new(lin,intpos,isma )
          enddo
!-------------------------------------------------------------------
!td(13-1) a(23)c'(22)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)     !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_br_br_ext_ar_new(lin,intpos,isma )
          enddo
        enddo
      return
      end

      subroutine td_ar_act_blbl(lin,jk )
!td(13-1) (22)a(23)
!td(13-1) a(23)c'(22)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_td(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
!-------------------------------------------------------------------
!td(13-1) (22)a(23)
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)     !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_bl_ext_ar_new(lin,intpos,isma,1 )
          enddo
!-------------------------------------------------------------------
!td(13-1) a(23)c'(22)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)    !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_bl_ext_ar_new(lin,intpos,isma,1 )
          enddo
        enddo
      return
      end

      subroutine td_ar_act_blbr(lin,jk )
!td(13-1) (22)a(23)
!td(13-1) a(23)c'(22)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_td(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
!-------------------------------------------------------------------
!td(13-1) (22)a(23)
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)    !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
          enddo
!-------------------------------------------------------------------
!td(13-1) a(23)c'(22)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)    !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
          enddo
        enddo
      return
      end

      subroutine td_ar_act_dlr(lin,lra)
!td(13-1) (22)a(23)
!td(13-1) a(23)c'(22)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_td(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
!-------------------------------------------------------------------
!td(13-1) (22)a(23)
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)   !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_drl_ext_al_new(lin,lri,lra)
          enddo
!-------------------------------------------------------------------
!td(13-1) a(23)c'(22)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)     !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_drl_ext_al_new(lin,lri,lra)
          enddo
        enddo
      return
      end

      subroutine dd_drl_act_bl(lin,lra)
!dd(19-2) drl(22)-
!dd(19-3) drl(33)-c"(22)-
!dd(19-3) (22)drl(33)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
      do lrl=norb_frz+1,norb_dz
        lml=lsm_inn(lrl)
        if(lml.ne.jml) cycle
!-------------------------------------------------------------------
         iwdl=jud(lrl)
         iwdr=iwdl
         do mpl=1,mhlp
           iwal=lpnew_lwei(mpl)
           iwar=lpnew_rwei(mpl)
           lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
           lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
         enddo
         w0=w0_dd(2)
         w1=w1_dd(2)
         do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1
         enddo
         call drl_bl_ext_ar_new(lin,lrl,lra)

         w0=w0_dd(3)
         w1=0.d0
         do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1
         enddo
         if(lra.gt.norb_dz) then
          call drl_bl_sum_ar_new(lin,lrl,0,lra)
         else
          do lrk=1,norb_dz
            if(lrk.eq.lrl) cycle
            call drl_bl_ext_ar_new(lin,lrk,lra)
          enddo
         endif
c        do lrk=1,norb_dz
c           if(lrk.eq.lrl) cycle
c           call drl_bl_ext_ar_new(lin,lrk,lra)
c         enddo
       enddo
      return
      end

      subroutine dd_drl_act_br(lin,lra)
!dd(19-2) drl(22)-
!dd(19-3) drl(33)-c"(22)-
!dd(19-3) (22)drl(33)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
      do lrl=norb_frz+1,norb_dz
        lml=lsm_inn(lrl)
        if(lml.ne.jml) cycle
!-------------------------------------------------------------------
         iwdl=jud(lrl)
         iwdr=iwdl
         do mpl=1,mhlp
           iwal=lpnew_lwei(mpl)
           iwar=lpnew_rwei(mpl)
           lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
           lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
         enddo
         w0=w0_dd(2)
         w1=w1_dd(2)
         do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1
         enddo
         call drl_br_ext_al_new(lin,lrl,lra)

         w0=w0_dd(3)
         w1=0.d0
         do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1
         enddo
         do lrk=1,norb_dz
           if(lrk.eq.lrl) cycle
           call drl_br_ext_al_new(lin,lrk,lra)
         enddo
       enddo
      return
      end

      subroutine dd_arbl_act_bl(lin,lra)
!dd(19-1) a&r(23)-b&l(32)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lrl=norb_frz+1,norb_dz-1
        lml=lsm_inn(lrl)
        if(lml.ne.jml) cycle
        do lrr=lrl+1,norb_dz
          lmr=lsm_inn(lrr)
          if(lmr.ne.jmr) cycle
            ijk=lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
            intpos=intind_ijka(ijk)
            w0dd1=w0_dd(1)
            w1dd1=w1_dd(1)
            ni=mod(lrr-lrl,2)
            if(ni.eq.0) w0dd1=-w0_dd(1)
            if(ni.eq.0) w1dd1=-w1_dd(1)
           do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo

            iwdl=jud(lrl)
            iwdr=jud(lrr)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
         call ar_bl_bl_ext_ar_new(lin,intpos,isma,1 )
!-------------------------------------------------------------------
        enddo
      enddo
      return
      end

      subroutine dd_arbl_act_br(lin,lra)
!dd(19-1) a&r(23)-b&l(32)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lrl=norb_frz+1,norb_dz-1
        lml=lsm_inn(lrl)
        if(lml.ne.jml) cycle
        do lrr=lrl+1,norb_dz
          lmr=lsm_inn(lrr)
          if(lmr.ne.jmr) cycle
            ijk=lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
            intpos=intind_ijka(ijk)
            w0dd1=w0_dd(1)
            w1dd1=w1_dd(1)
            ni=mod(lrr-lrl,2)
            if(ni.eq.0) w0dd1=-w0_dd(1)
            if(ni.eq.0) w1dd1=-w1_dd(1)
           do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo

            iwdl=jud(lrl)
            iwdr=jud(lrr)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
!-------------------------------------------------------------------
        enddo
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_CHKINTO(XINT,DIAG,ISYM,NERR,TOL,REPORT)
!
! Purpose: check diagonals in qualified integral columns against
!          original diagonal (read in here).

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: XINT(*), TOL
real(kind=wp), intent(_OUT_) :: DIAG(*)
integer(kind=iwp), intent(in) :: ISYM
integer(kind=iwp), intent(out) :: NERR
logical(kind=iwp), intent(in) :: REPORT
integer(kind=iwp) :: IOPT

IOPT = 2
call CHO_IODIAG(DIAG,IOPT)
call CHO_P_CHKINT(XINT,DIAG,ISYM,NERR,TOL,REPORT)

end subroutine CHO_CHKINTO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine RotateOrbB(CMO,Col,ipLbl,nComp,nBas,nOrb2Loc,
     &                      Maximisation,ThrRot,PctSkp,Debug)
C
C     Author: T.B. Pedersen
C
C     Purpose: rotate orbitals (Jacobi Sweeps) for Boys localisation.
C
      Implicit Real*8 (a-h,o-z)
      Real*8  CMO(nBas,*), Col(nOrb2Loc,2)
      Integer ipLbl(nComp)
      Logical Maximisation, Debug
#include "WrkSpc.fh"
#include "real.fh"

      Character*10 SecNam
      Parameter (SecNam = 'RotateOrbB')

      Character*80 Txt

      xDone = 0.0d0
      If (Debug) iCouple=0
      Do iMO1=1,nOrb2Loc-1
        Do iMO2=iMO1+1,nOrb2Loc

          If (Debug) Then
            iCouple = iCouple + 1
            Write(6,'(A9,I5)') 'Couple n:',iCouple
            Write(6,'(A9,I5)') '    MO1 :',iMO1
            Write(6,'(A9,I5)') '    MO2 :',iMO2
          End If

          iMO_s = iMO1
          iMO_t = iMO2

          Ast = 0.0d0
          Bst = 0.0d0
          Do iComp = 1,nComp
             ip0 = ipLbl(iComp) - 1
             iss = ip0 + nOrb2Loc*(iMO_s-1) + iMO_s
             itt = ip0 + nOrb2Loc*(iMO_t-1) + iMO_t
             ist = ip0 + nOrb2Loc*(iMO_t-1) + iMO_s
             Ast = Ast
     &           + Work(ist)**2
     &           - 2.5d-1*(Work(iss)-Work(itt))**2
             Bst = Bst
     &           + Work(ist)*(Work(iss)-Work(itt))
          End Do

          If ((Ast.eq.0.0d0).and.(Bst.eq.0.0d0)) Then
            cos4alpha=-1.0d0
            sin4alpha=0.0d0
          Else
            cos4alpha=-Ast/sqrt(Ast**2+Bst**2)
            sin4alpha= Bst/sqrt(Ast**2+Bst**2)
          End If
          Tst=abs(cos4alpha)-1.0d0
          If (Tst .gt. 0.0d0) Then
            If (Tst .gt. 1.0d-10) Then
              Write(Txt,'(A,D18.10)') 'Actual: cos4alpha = ',cos4alpha
              Call SysAbendMsg(SecNam,'-1.0d0 < cos4alpha < 1.0d0',
     &                         Txt)
            Else
               If (cos4alpha .lt. 0.0d0) Then
                  cos4alpha=-1.0d0
               Else
                  cos4alpha=1.0d0
               End If
            End If
          End If

          Alpha1=acos(cos4alpha)/4.0d0
          Alpha2=asin(sin4alpha)/4.0d0
          If (Alpha2.lt.0.0d0) Alpha1=Alpha2+PI
          Alpha=Alpha1
          If (.Not.Maximisation) Then
            Gamma_rot=Alpha-PI/4.0d0
          Else
            Gamma_rot=Alpha
          End If
          If (Debug) Then
            Write(6,'(A9,F10.5)') '   Ast :',Ast
            Write(6,'(A9,F10.5)') '   Bst :',Bst
            Write(6,'(A9,F10.5)') 'Alpha1 :',Alpha1
            Write(6,'(A9,F10.5)') 'Alpha2 :',Alpha2
            Write(6,'(A9,F10.5)') ' Gamma :',Gamma_rot
          End If

          Tsts = sin(Gamma_rot)
          Tstc = 1.0d0 - cos(Gamma_rot)
          If (abs(Tsts).gt.ThrRot .or. abs(Tstc).gt.ThrRot) Then
             Call Rot_st(CMO(1,iMO_s),CMO(1,iMO_t),nBas,Gamma_rot,Debug)
             Call UpdateB(Col,nOrb2Loc,ipLbl,nComp,Gamma_rot,
     &                    iMO_s,iMO_t,Debug)
             xDone = xDone + 1.0d0
          End If

         End Do
      End Do

      If (nOrb2Loc .gt. 1) Then
         xOrb2Loc = dble(nOrb2Loc)
         xTotal = xOrb2Loc*(xOrb2Loc-1.0d0)/2.0d0
         PctSkp = 1.0d2*(xTotal-xDone)/xTotal
      Else
         PctSkp = 0.0d0
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine MVeInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: to compute the mass-velocity integrals with the Gauss-       *
!         Hermite quadrature.                                          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, Sweden. February '91                 *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW
use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: ia, ib, iBeta, ipA, ipAOff, ipAxyz, ipB, ipBOff, ipBxyz, ipQxyz, iPrint, iprV2, iprV4, ipRxyz, iRout, nip
logical(kind=iwp) :: ABeq(3)
character(len=80) :: Label

#include "macros.fh"
unused_var(ZInv)
unused_var(lOper)
unused_var(iChO)
unused_var(iStabM)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 190
iPrint = nPrint(iRout)
ABeq(:) = A == RB

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+3)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+3)
ipRxyz = nip
nip = nip+nZeta*3*nHer*(nOrdOp-3)
ipQxyz = nip
nip = nip+nZeta*3*(la+3)*(lb+3)*(nOrdOp-3)
iprV2 = nip
nip = nip+nZeta*3*(la+1)*(lb+1)*2
iprV4 = nip
nip = nip+nZeta*3*(la+1)*(lb+1)
ipA = nip
nip = nip+nZeta
ipB = nip
nip = nip+nZeta
if (nip-1 > nArr*nZeta) then
  call WarningMessage(2,'MVeInt: nip-1 > nArr*nZeta')
  write(u6,*) ' nArr is Wrong! ',nip-1,' > ',nArr*nZeta
  write(u6,*) ' Abend in MVeInt'
  call Abend()
end if

if (iPrint >= 49) then
  call RecPrt(' In MVeInt: A',' ',A,1,3)
  call RecPrt(' In MVeInt: RB',' ',RB,1,3)
  call RecPrt(' In MVeInt: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In MVeInt: P',' ',P,nZeta,3)
  call RecPrt(' In MVeInt: Zeta',' ',Zeta,nZeta,1)
  call RecPrt(' In MVeInt: Roots',' ',HerR(iHerR(nHer)),nHer,1)
  write(u6,*) ' In MVeInt: la,lb=',la,lb
end if

! Compute the cartesian values of the basis functions angular part

call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),la+2,HerR(iHerR(nHer)),nHer,ABeq)
call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),lb+2,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the contribution from the multipole moment operator

ABeq(:) = .false.
call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),nOrdOp-4,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the cartesian components for the multipole moment
! integrals. The integrals are factorized into components.

call Assmbl(Array(ipQxyz),Array(ipAxyz),la+2,Array(ipRxyz),nOrdOp-4,Array(ipBxyz),lb+2,nZeta,HerW(iHerW(nHer)),nHer)

! Compute the cartesian components for the mass-velocity integrals.
! The kinetic energy components are linear combinations of overlap components.

ipAOff = ipA-1
do iBeta=1,nBeta
  Array(ipAOff+1:ipAOff+nAlpha) = Alpha
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB-1
do iBeta=1,nBeta
  Array(ipBOff+1:ipBOff+nAlpha) = Beta(iBeta)
  ipBOff = ipBOff+nAlpha
end do

call MVe(Array(iprV2),Array(iprV4),Array(ipQxyz),la,lb,Array(ipA),Array(ipB),nZeta)

! Combine the cartesian components to the full one electron integral.

call CmbnMV(Array(ipQxyz),nZeta,la,lb,nOrdOp-4,Zeta,rKappa,rFinal,nComp,Array(iprV2),Array(iprV4))

if (iPrint >= 99) then
  do ia=1,nTri_Elem1(la)
    do ib=1,nTri_Elem1(lb)
      write(Label,'(A,I2,A,I2,A)') 'Mass-Velocity(',ia,',',ib,')'
      call RecPrt(Label,' ',rFinal(:,ia,ib,:),nZeta,nComp)
    end do
  end do
end if

return

end subroutine MVeInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c       This package contains following files:
c
c       DefParo2v4
c       DistMemo2v4
c       GetTau
c          GetTauHlp1
c          GetTauHlp2
c       GetChV
c         getChVHlp1
c         getChVHlp2
c         getChVHlp3
c         getChVHlp4
c       VanishT2n
c       ExtractM
c       MakeT2p
c       MakeT2m
c         makeT2pHlp1
c         makeT2pHlp2
c         makeT2pHlp3
c         makeT2ptHlp1
c         makeT2ptHlp2
c         makeT2ptHlp3
c       MakeWw
c         makeWwHlp1
c         makeWwHlp2
c         makeWwHlp3
c         makeWwHlp4
c       MakeT2pd
c         makeT2pdHlp
c       MakeWwd
c         makeWwdHlp1
c         makeWwdHlp2
c        Calc_addSG
c        Calc_addG
c
c        Vint approach routines
c        Mk_T1t
c        ReaW3
c          MkNameV3
c          ReaW3hlp1
c          ReaW3hlp2
c          ReaW3hlp3
c        ReaW4
c          DefW4abcd
c          DefW4abdc
c          DefW4bacd
c          DefW4badc
c          DefW4cdab
c          DefW4dcab
c          DefW4cdba
c          DefW4dcba
c          MkNameV4
c
c        Xo2v4ctl (kokotske meno)
c        InsReqo2v4
c          InsReaW3
c          InsReaW4
c
c
c       ------------------------------------
c
        subroutine DefParo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c                         mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
c
c       This routine do:
c       define parameters in o2v4.fh using NaGrp,NbeGrp,NaSGrp,NbeSgrp
c
c       I/O parameter description:
c       NaGrp    - # of groups in a set (I)
c       NbeGrp   - # of groups in be set (I)
c       NaSGrp   - # of subgroups in each (a)' group (I)
c       NbeSGrp  - # of subgroups in each (be)' group (I)
c       mdGrpa   - # maximal dimension od (a)' group (O)
c       mdGrpbe  - # maximal dimension od (be)' group (O)
c       mdSGrpa  - # maximal dimension od (a)" subgroup (O)
c       mdSGrpbe - # maximal dimension od (be)" subgroup (O)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
c
        integer NaGrp,NbeGrp,NaSGrp,NbeSgrp
        integer mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
c
c       help variables
c
        real*8 rdim
        integer i,j,ij
c
c
c1      define parameters of Groups of a(b) set
c
        rdim=1.0d0*nv/(1.0d0*NaGrp)
c
        Grpalow(1)=1
        Grpaup(1)=NaSGrp
c
        do i=1,NaGrp
c
           if (i.eq.1) then
             UpGrpa(i)=int(rdim*i)
             LowGrpa(i)=1
           else if (i.eq.NaGrp) then
             UpGrpa(i)=nv
             LowGrpa(i)=UpGrpa(i-1)+1
           else
             UpGrpa(i)=int(rdim*i)
             LowGrpa(i)=UpGrpa(i-1)+1
           end if
c
           DimGrpa(i)=(UpGrpa(i)-LowGrpa(i))+1
c
           if (i.gt.1) then
             Grpalow(i)=Grpalow(i-1)+NaSGrp
             Grpaup(i)=Grpaup(i-1)+NaSGrp
           end if
c
        end do
c
c
c2      define parameters of Groups of be(ga) set
c
        rdim=1.0d0*nv/(1.0d0*NbeGrp)
c
        Grpbelow(1)=1
        Grpbeup(1)=NbeSGrp
c
        do i=1,NbeGrp
c
           if (i.eq.1) then
             UpGrpbe(i)=int(rdim*i)
             LowGrpbe(i)=1
           else if (i.eq.NbeGrp) then
             UpGrpbe(i)=nv
             LowGrpbe(i)=UpGrpbe(i-1)+1
           else
             UpGrpbe(i)=int(rdim*i)
             LowGrpbe(i)=UpGrpbe(i-1)+1
           end if
c
           DimGrpbe(i)=(UpGrpbe(i)-LowGrpbe(i))+1
c
           if (i.gt.1) then
             Grpbelow(i)=Grpbelow(i-1)+NbeSGrp
             Grpbeup(i)=Grpbeup(i-1)+NbeSGrp
           end if
c
        end do
c
c
c3      define parameters of SubGroups of a(b) set
c
        ij=0
        do j=1,NaGrp

        rdim=1.0d0*DimGrpa(j)/(1.0d0*NaSGrp)
c
        do i=1,NaSGrp
        ij=ij+1
c
           if (i.eq.1) then
             UpSGrpa(ij)=(LowGrpa(j)-1)+int(rdim*i)
             LowSGrpa(ij)=LowGrpa(j)
           else if (i.eq.NaSGrp) then
             UpSGrpa(ij)=UpGrpa(j)
             LowSGrpa(ij)=UpSGrpa(ij-1)+1
           else
             UpSGrpa(ij)=(LowGrpa(j)-1)+int(rdim*i)
             LowSGrpa(ij)=UpSGrpa(ij-1)+1
           end if
c
          DimSGrpa(ij)=(UpSGrpa(ij)-LowSGrpa(ij))+1
c
        end do
        end do
c
c
c4      define parameters of SubGroups of be(ga) set
c
        ij=0
        do j=1,NbeGrp

        rdim=1.0d0*DimGrpbe(j)/(1.0d0*NbeSGrp)
c
        do i=1,NbeSGrp
        ij=ij+1
c
           if (i.eq.1) then
             UpSGrpbe(ij)=(LowGrpbe(j)-1)+int(rdim*i)
             LowSGrpbe(ij)=LowGrpbe(j)
           else if (i.eq.NbeSGrp) then
             UpSGrpbe(ij)=UpGrpbe(j)
             LowSGrpbe(ij)=UpSGrpbe(ij-1)+1
           else
             UpSGrpbe(ij)=(LowGrpbe(j)-1)+int(rdim*i)
             LowSGrpbe(ij)=UpSGrpbe(ij-1)+1
           end if
c
          DimSGrpbe(ij)=(UpSGrpbe(ij)-LowSGrpbe(ij))+1
c
        end do
        end do
c
c
c5      find maximal dimensions mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
c
        mdGrpa=DimGrpa(1)
        do i=1,NaGrp
          if (DimGrpa(i).gt.mdGrpa) then
          mdGrpa=DimGrpa(i)
          end if
        end do
c
        mdGrpbe=DimGrpbe(1)
        do i=1,NbeGrp
          if (DimGrpbe(i).gt.mdGrpbe) then
          mdGrpbe=DimGrpbe(i)
          end if
        end do
c
        mdSGrpa=DimSGrpa(1)
        do ij=1,NaGrp*NaSGrp
          if (DimSGrpa(ij).gt.mdSGrpa) then
          mdSGrpa=DimSGrpa(ij)
          end if
        end do
c
        mdSGrpbe=DimSGrpbe(1)
        do ij=1,NbeGrp*NbeSGrp
          if (DimSGrpbe(ij).gt.mdSGrpbe) then
          mdSGrpbe=DimSGrpbe(ij)
          end if
        end do
c
c
c6      def L2Names
c
        do i=1,NaGrp
        do j=1,NbeGrp
          call DefParo3v3Hlp1(i,j,'L2',L2Name(i,j))
        end do
        end do
c
c7      def Tmp3Names
c
        do i=1,MaxSGrp
        do j=1,MaxSGrp
          call DefParo3v3Hlp1(i,j,'X3',Tmp3Name(i,j))
        end do
        end do
c
c
        return
        end
c
c       ------------------------------------
c
        subroutine DistMemo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c                 mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,
     c                 PossTau,PossT2n1,PossT2n2,PossT2w,
     c                 PossL11,PossL12,
     c                 PossL21,PossL22,PossL23,PossL24,PossL2W,
     c                 PossH1,PossH2,
     c                 PossM1,PossM2,PossW1,PossW2,PossWw,PossWx,
     c                 PossT,NL2)
c
c       This routine do:
c       define initial possitions of T,L,M and W arrays,
c       described in o2v4ctl routine
c
c
c       I/O parameter description:
c       NaGrp    - # of groups in a set (I)
c       NbeGrp   - # of groups in be set (I)
c       NaSGrp   - # of subgroups in each (a)' group (I)
c       NbeSGrp  - # of subgroups in each (be)' group (I)
c       mdGrpa   - # maximal dimension od (a)' group (I)
c       mdGrpbe  - # maximal dimension od (be)' group (I)
c       mdSGrpa  - # maximal dimension od (a)" subgroup (I)
c       mdSGrpbe - # maximal dimension od (be)" subgroup (I)
c       PossX    - initial possitinos of arrays (O-all)
c       PossT    - next free possition (O)
c       NL2      - # of L2 vectors (O)
c
        implicit none
#include "chcc1.fh"
c
        integer NaGrp,NbeGrp,NaSGrp,NbeSgrp
        integer mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
        integer PossTau,PossT2n1,PossT2n2,PossT2w
        integer PossL11,PossL12
        integer PossH1,PossH2
        integer PossL21,PossL22,PossL23,PossL24,PossL2W
        integer PossM1,PossM2,PossW1,PossW2,PossWw,PossWx
        integer PossT,NL2
c
c       help variables
        integer length,lenab,lenbega
c
c1      Tau
c
        PossTau=possT
        if (NaGrp.eq.1) then
          length=no*no*nv*(nv+1)/2
        else
          length=no*no*mdGrpa*mdGrpa
        end if
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,99) 'DM Tau',PossTau
        end if
c
c2      T2n files
c
        possT2n1=PossT
        if ((NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
          length=no*(no+1)*nv*(nv+1)/4
        else
          length=no*(no+1)*mdSGrpbe*mdSGrpbe/2
        end if
        PossT=PossT+length
c
        possT2n2=PossT
        if ((NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
          length=no*(no-1)*nv*(nv-1)/4
        else
          length=no*(no-1)*mdSGrpbe*mdSGrpbe/2
        end if
        PossT=PossT+length
c
        possT2w=PossT
        if ((NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
          length=no*(no+1)*nv*(nv+1)/4
        else
          length=no*(no+1)*mdSGrpbe*mdSGrpbe/2
        end if
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,99) 'DM T2 ',PossT2n1,PossT2n2,PossT2w
        end if
c
c       L1 files
c
        if (intkey.eq.1) then
c        integral based
          length=0
        else
c        cholesky based
          length=nc*mdGrpa*no
        end if
c
        if (NaGrp.eq.1) then
          PossL11=PossT
          PossL12=PossT
          PossT=PossT+length
        else
          PossL11=PossT
          PossT=PossT+length
          PossL12=PossT
          PossT=PossT+length
        end if
        if (printkey.ge.10) then
        write (6,99) 'DM L1 ',PossL11,PossL12
        end if
c
c       L2 files
c
        if (intkey.eq.1) then
c        integral based
          length=0
        else
c        cholesky based
          length=nc*mdGrpa*mdGrpbe
        end if
c
        if (NaGrp.eq.1) then
          if (NbeGrp.eq.1) then
c         All L2 are identical
            PossL21=PossT
            PossL22=PossT
            PossL23=PossT
            PossL24=PossT
            PossT=PossT+length
            NL2=1
          else
c         L21=L23 and L22=L24
            PossL21=PossT
            PossL23=PossT
            PossT=PossT+length
            PossL22=PossT
            PossL24=PossT
            PossT=PossT+length
            NL2=2
          end if
        else
          if (NbeGrp.eq.1) then
c         L21=L22 and L23=L24
            PossL21=PossT
            PossL22=PossT
            PossT=PossT+length
            PossL23=PossT
            PossL24=PossT
            PossT=PossT+length
            NL2=2
          else
c         all L2 files are different
            PossL21=PossT
            PossT=PossT+length
            PossL22=PossT
            PossT=PossT+length
            PossL23=PossT
            PossT=PossT+length
            PossL24=PossT
            PossT=PossT+length
            NL2=4
          end if
        end if
c
        PossL2W=PossT
        if (intkey.eq.1) then
c        integral based
          length=0
        else
c        cholesky based
        if ((NaGrp.eq.1).and.(NbeGrp.eq.1)) then
          length=nc*nv*(nv+1)/2
        else
          length=nc*mdGrpa*mdGrpbe
        end if
        if ((no*mdGrpbe).gt.length) then
          length=no*mdGrpbe
        end if
        if (nc*no*mdGrpa.gt.length) then
          length=nc*no*mdGrpa
        end if
        end if
c
        PossT=PossT+length
c
        if (printkey.ge.10) then
        write (6,99) 'DM L2 ',PossL21,PossL22,PossL23,PossL24,
     c                       PossL2W
        end if
c
c       H files
c
        length=no*mdSGrpbe
        if (intkey.eq.1) then
          PossH1=PossT
          PossT=PossT+length
          PossH2=PossT
          PossT=PossT+length
        else
          PossH1=PossT
          PossH2=PossT
        end if
        if (printkey.ge.10) then
        write (6,99) 'DM H  ',PossH1,PossH2
        end if
c
c       M files
c
        length=nc*mdSGrpa*mdSGrpbe
c
        if ((NaGrp.eq.1).and.(NaSGrp.eq.1).and.
     c      (NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
c       M1=M2
          PossM1=PossT
          PossM2=PossT
          PossT=PossT+length
        else
c       M files are different
          PossM1=PossT
          PossT=PossT+length
          PossM2=PossT
          PossT=PossT+length
        end if
        if (printkey.ge.10) then
        write (6,99) 'DM M  ',PossM1,PossM2
        end if
c
c       W1,W2 files
c
        if (NaGrp*NaSGrp.eq.1) then
c       W1 and W2 are identical
          length=mdSGrpa*mdSGrpbe*mdSGrpa*mdSGrpbe
          if ((no.gt.mdSGrpbe).and.(intkey.eq.1)) then
          length=mdSGrpa*mdSGrpbe*mdSGrpa*no
          end if
          PossW1=PossT
          PossW2=PossT
          PossT=PossT+length
        else
c       W1 and W2 are different
          length=mdSGrpa*mdSGrpbe*mdSGrpa*mdSGrpbe
          if ((no.gt.mdSGrpbe).and.(intkey.eq.1)) then
          length=mdSGrpa*mdSGrpbe*mdSGrpa*no
          end if
          PossW1=PossT
          PossT=PossT+length
          PossW2=PossT
          PossT=PossT+length
        end if
c
c       Ww file
c
        PossWw=PossT
c
        if ((NaGrp.eq.1).and.(NaSGrp.eq.1)) then
          lenab=nv*(nv+1)/2
        else
          lenab=mdSGrpa*mdSGrpa
        end if
        if ((NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
          lenbega=nv*(nv+1)/2
        else
          lenbega=mdSGrpbe*mdSGrpbe
        end if
c
        length=lenab*lenbega
        if (intkey.eq.1) then
          length=mdSGrpa*mdSGrpbe*mdSGrpa*mdSGrpbe
          if (no.gt.mdSGrpbe) then
          length=mdSGrpa*mdSGrpbe*mdSGrpa*no
          end if
        end if
        PossT=PossT+length
c
c        Wx file
c
        PossWx=PossT
        length=mdSGrpa*mdSGrpbe*mdSGrpa*no
        if (intkey.eq.0) then
          length=0
        end if
        PossT=PossT+length
c
        if (printkey.ge.10) then
        write (6,99) 'DM W  ',PossW1,PossW2,PossWw,PossWx
c
        write (6,99) 'PossT ',PossT
        end if
c
99        format (a7,10(i10,1x))
c
        return
        end
c
c       ------------------------------------
c
        subroutine GetTau (Tau,T1,
     c                     aGrp,bGrp,dima,dimb,adda,addb,lunTau)
c
c       this routine do:
c       1) read the block of T2((a,b)',ij) from T2Name(aGrp,bGrp)
c        2) Make Tau ((a,b)',ij) in T2((a,b)',ij) array
c
c       I/O parameter description:
c       Tau      - array for Tau((a,b),ij) (O)
c       aGrp     - group of a index
c       bGrp     - group of b index
c       dima     - dimension group of a' index
c       dimb     - dimension group of b' index
c       adda     - shift of a' in full virtual space
c       addb     - shift of b' in full virtual space
c       lunTau   - Lun of opened file, where Tau is stored
c
c
        implicit none
#include "chcc1.fh"
#include "chcc_files.fh"
c
        real*8 Tau(1)
        real*8 T1(1)
        integer aGrp,bGrp,dima,dimb,adda,addb,lunTau
c
c       help variables
        integer length
c
c
c1      def legth
c
        if (aGrp.eq.bGrp) then
c       groups of a and b are equal, reading for a'>=b'
          length=no*no*Dima*(Dima+1)/2
        else
c       aGrp>bGrp, reading for a',b' in given groups
          length=no*no*Dima*Dimb
        end if
c
c
c2      read block of T2 amplitudes
c
        call GetX (Tau(1),length,LunTau,T2Name(aGrp,bGrp),1,1)
c
c
c3        make Tau
c
        if (aGrp.ne.bGrp) then
           call GetTauHlp1 (Tau(1),T1(1),dima,dimb,adda,addb,no,nv)
        else
           call GetTauHlp2 (Tau(1),T1(1),dima,adda,no,nv)
        end if


        return
        end
c
c       ------------------------------------
c
        subroutine GetTauHlp1 (Tau,T1,dima,dimb,adda,addb,no,nv)
c
c        Make Tau for aGrp.ne.bGrp
c
        implicit none
        integer dima,dimb,adda,addb,no,nv
        real*8 Tau(1:dima,1:dimb,1:no,1:no)
        real*8 T1(1:nv,1:no)
c
c       help variables
        integer i,j,a,b
        real*8 c
c
c
        do j=1,no
          do i=1,no
            do b=1,dimb
              c=t1(addb+b,j)
              do a=1,dima
                Tau(a,b,i,j)=Tau(a,b,i,j)+c*t1(adda+a,i)
              end do
            end do
          end do
        end do
c
c
        return
        end
c
c       ------------------------------------
c
         subroutine GetTauHlp2 (Tau,T1,dima,adda,no,nv)
c
c        Make Tau for aGrp.eq.bGrp
c
        implicit none
         integer dima,adda,no,nv
        real*8 Tau(1:dima*(dima+1)/2,1:no,1:no)
        real*8 T1(1:nv,1:no)
c
c       help variables
        integer i,j,a,b,ab
        real*8 c
c
c
        do j=1,no
          do i=1,no
            ab=0
            do a=1,dima
              c=t1(adda+a,i)
              do b=1,a
                ab=ab+1
                Tau(ab,i,j)=Tau(ab,i,j)+c*t1(adda+b,j)
              end do
            end do
          end do
        end do
c
c
        return
        end
c
c       ------------------------------------
c
        subroutine GetChV (wrk,wrksize,
     c                     aGrp,bGrp,beGrp,gaGrp,NL2,L2Status,
     c                     pL21,pL22,pL23,pL24,pL2W,
     c                     PossL11,PossL12,LunAux)
c
c       this rotune do:
c       read L2 files from disc file
c*      L21 (m,a',be')
c       L22 (m,a',ga')
c       L23 (m,b',be')
c       L24 (m,b',ga')
c        and completed it by the term
c        L2x (m,c',de') <<- L2(m,c',i) . T1(T)(de',i)
c
c       Routine define pL2x, which are values, which show, which index
c       i (correspondig to L2Status(i,1-3) correspond to ginev L2x.
c       Array L2Status (neaningful only for i=1,NL2) stores informations
c       about really loaded L2's in memory. If some of the blocks were
c       already defined in previous spep(s), they are not readed repetidly.
c
c       N.B.1 Rutina sa da spravit aj trivialne, ze sa pokazde vsetky
c       L21-4 nacitaju, toto riesenie je menej prehladne, ale setri IO
c       N.B.2 Efektivitu ovplyvnuje hlavne, ako vybera rutine getChVHlp2
c       kam sa ma nove L2 nacitat, najma ak ma vybrat, ktory s
c       existujucich rekordov premaze
c
c       I/O parameter description:
c       aGrp, bGrp   - groups of a,b (I)
c       beGrp, GaGrp - groups of be,ga (I)
c       NL2          - real number of L2 declared in memory(1,2or4) (I)
c       L2Status    - L2 status matrix (I/O)
c                     L2Status(i,1) - cGrp
c                     L2Status(i,2) - deGrp
c                     L2Status(i,3) - Poss
c       pL2x        - possition of L2x in L2Status (i.e. index i
c                     in L2Status(i,1-3) for given L2x (O)
c        PossL11     - Possition of L1(m,a',i) (I)
c        PossL12     - Possition of L1(m,b',i) (I)
c       LunAux      - lun for auxiliary reading (I)
c
c
        implicit none
#include "wrk.fh"
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,bGrp,beGrp,gaGrp,NL2
        integer pL21,pL22,pL23,pL24,pL2W,PossL11,PossL12,LunAux
        integer L2Status(1:4,1:3)
c
c       help variables
        integer Used(1:4)
        integer WhatNeedToRead(1:4,1:2)
        integer HowMany
        integer Which(1:4)
        integer Kde(1:4)
        integer i,kery,kam,yes,ToDo
        integer cGrp,deGrp,dimc,dimde,addde
c
        kam=-1 ! dummy initialize
c
c
c1      Define
c         a) what need to be read (WhatNeedToRead)
c         b) How many different L2 need to be defined (HowMany)
c         c) How L21-4 is mapped to the unique ones, that need to
c            be read (Which)
c
        if (aGrp.eq.bGrp) then
          if (beGrp.eq.gaGrp) then
c         case L21=L22=L23=L24
            HowMany=1
            WhatNeedToRead(1,1)=aGrp
            WhatNeedToRead(1,2)=beGrp
            Which(1)=1
            Which(2)=1
            Which(3)=1
            Which(4)=1
          else
c         case L21=L23, L22=L24
            HowMany=2
            WhatNeedToRead(1,1)=aGrp
            WhatNeedToRead(1,2)=beGrp
            WhatNeedToRead(2,1)=aGrp
            WhatNeedToRead(2,2)=gaGrp
            Which(1)=1
            Which(2)=2
            Which(3)=1
            Which(4)=2
          end if
        else
          if (beGrp.eq.gaGrp) then
c         case L21=L22,L23=L24
            HowMany=2
            WhatNeedToRead(1,1)=aGrp
            WhatNeedToRead(1,2)=beGrp
            WhatNeedToRead(2,1)=bGrp
            WhatNeedToRead(2,2)=beGrp
            Which(1)=1
            Which(2)=1
            Which(3)=2
            Which(4)=2
          else
c         all L2s are different
            HowMany=4
            WhatNeedToRead(1,1)=aGrp
            WhatNeedToRead(1,2)=beGrp
            WhatNeedToRead(2,1)=aGrp
            WhatNeedToRead(2,2)=gaGrp
            WhatNeedToRead(3,1)=bGrp
            WhatNeedToRead(3,2)=beGrp
            WhatNeedToRead(4,1)=bGrp
            WhatNeedToRead(4,2)=gaGrp
            Which(1)=1
            Which(2)=2
            Which(3)=3
            Which(4)=4
          end if
        end if
c
c
c2      Load neccesarry L2 from disk
c
c2.1    SetUp
        do i=1,NL2
          Kde(i)=0
          Used(i)=0
        end do
c
1       ToDo=HowMany
c
c2.2    Test, which ones of those, that need to be read are
c       already loaded and where (Kde) and find, how many of
c       L2 need to be readed really (ToDo)
        do i=1,HowMany
          call getChVHlp1
     c    (WhatNeedToRead(i,1),WhatNeedToRead(i,2),yes,NL2,L2Status)
          Kde(i)=yes
          if (yes.ne.0) then
            used(yes)=1
            ToDo=ToDo-1
          end if
        end do
c
c2.3    if there is atleast one L2 to read, read only one
c       and run 2.2 section again
        if (ToDo.gt.0) then
c
c         zistit kere L2 treba nacitat (kery)
          kery=0
          do i=1,HowMany
            if (Kde(i).eq.0) then
              kery=i
            end if
          end do
c
c         found, where to read it (kam)
          call getChVHlp2 (L2Status,NL2,used,kam)
c
c         read L2 (kery) into (kam) (+ expand, f needed)
          L2Status(kam,1)=WhatNeedToRead(kery,1)
          L2Status(kam,2)=WhatNeedToRead(kery,2)
          cGrp=L2Status(kam,1)
          deGrp=L2Status(kam,2)
          call getChVHlp3 (wrk(L2Status(kam,3)),wrk(pL2W),
     c                     L2Status(kam,1),L2Status(kam,2),LunAux)
c
c          Create L2W(i,de') <- T1(de,i)
          dimde=DimGrpbe(deGrp)
          addde=0
          do i=1,deGrp-1
            addde=addde+DimGrpbe(i)
          end do
          call getChVHlp4 (wrk(pL2W),wrk(PossT1o),dimde,addde)
c
c          upgrade L2(m,c',de') <<- - L1(m,c',i). L2W(i,de')
          dimc=DimGrpa(cGrp)
          if (cGrp.eq.aGrp) then
            call mc0c2a3b (nc*dimc,no,no,dimde,nc*dimc,dimde,
     c                     nc*dimc,no,dimde,
     c                     wrk(PossL11),wrk(pL2W),wrk(L2Status(kam,3)))
          else if (cGrp.eq.bGrp) then
            call mc0c2a3b (nc*dimc,no,no,dimde,nc*dimc,dimde,
     c                     nc*dimc,no,dimde,
     c                     wrk(PossL12),wrk(pL2W),wrk(L2Status(kam,3)))
          else
            write (6,*) ' Nieje dobre, c nieje ani a ani b :-( Ch. K.'
            call Abend()
          end if
c
          used(kam)=1
c
          goto 1
        end if
c
c
c3      At this point all neccesarry L2 are read - def pL2x
c
        i=Which(1)
        pL21=Kde(i)
        i=Which(2)
        pL22=Kde(i)
        i=Which(3)
        pL23=Kde(i)
        i=Which(4)
        pL24=Kde(i)
c
c
        return
        end
c
c       ---------------------
c
        subroutine GetChVHlp1 (cGrp,deGrp,yes,NL2,L2Status)
c
c       this routine do:
c       check, if Cholesky vector block cGrp,deGrp is actually situated
c       in the memory as one of L2x
c
c       descrition of parameters:
c       cGrp, deGrp - required Group of c, delta in L2(m,c',de') (I)
c       yes    -  0 - not loaded  (O)
c                 x - loaded, value of L2x (x=1-4)
c       NL2         - Number of L2 arrays really reserved in memory (I)
c       L2Status    - L2 status matrix (I)
c                     L2Status(i,1) - cGrp
c                     L2Status(i,2) - deGrp
c                     L2Status(i,3) - Poss
c
        implicit none
        integer cGrp,deGrp,yes,NL2
        integer L2Status(1:4,1:3)
c
c       help variables
        integer i
c
        yes=0
        do i=1,NL2
        if ((cGrp.eq.L2Status(i,1)).and.(deGrp.eq.L2Status(i,2))) then
        yes=i
        end if
        end do
c
        return
        end
c
c       ---------------------
c
        subroutine GetChVHlp2 (L2Status,NL2,used,kam)
c
c       this routine do:
c       Define, which one of unused L2 arrays allocated in memory
c       will be used for placing newly needed L2x
c       Criteria of present approach:
c       1) First those possitions that are allocated, but never used yet
c       2) if no 1), take first unused in this step, according L2Status
c          N.B. 2) druhy krok moze byt eventuelne vylepseny, zatial
c               takto odflaknute
c
c       description ov variables:
c       L2Status  - L2 Status array (I)
c       NL2       - number of L2 arrays reserver in memory (I)
c       used      - array indicating, which L2x are already used
c                   in this step (those cannot be touched) (I)
c       kam       - index of possition, where new L2 can be placed (O)
c
        implicit none
        integer L2Status(1:4,1:3)
        integer used(1:4)
        integer NL2,kam
c
c       help variables
        integer i
c
c
c1      search, if there are never used possitions
c
        do i=1,NL2
          if (L2Status(i,1).eq.0) then
          kam=i
          return
          end if
        end do
c
c2      find first unused in this step
c
        do i=1,NL2
          if (used(i).eq.0) then
          kam=i
          return
          end if
        end do
c
c       Jaj nieje dobre ak sme sa dostali az sem
        write (6,*) ' Sorry fish getChVHlp2 '
        call Abend()
c
        return
        end
c
c       ---------------------
c
        subroutine GetChVHlp3 (L2,Tmp,cGrp,deGrp,LunAux)
c
c       this routine do:
c       read L2(m,c'de') into L2 from disk file
c       structure of files: for each c',de' one file with
c       name L2Name(cGrp,deGrp)
c       @ citanie zatial odflaknute
c
c       parameter description:
c       L2     - Array for L2 (O)
c       Tmp    - Temporary array of L2 size, used for mapping, if needed
c       xGrp   - Groups of c, delta (I)
c       LunAux - lun for auxiliary reading (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
c
        real*8 L2(1)
        real*8 Tmp(1)
        integer cGrp,deGrp,LunAux
        character*6 LunName
c
c       help variables
        integer length
c
c        nacitanie (+expanzia, ak treba)
        if (cGrp.gt.deGrp) then
          LunName=L2Name(cGrp,deGrp)
          length=nc*DimGrpa(cGrp)*DimGrpbe(deGrp)
          call GetX (L2(1),length,LunAux,LunName,1,1)
        else if (cGrp.eq.deGrp) then
          LunName=L2Name(cGrp,deGrp)
          length=nc*DimGrpa(cGrp)*(DimGrpbe(deGrp)+1)/2
          call GetX (Tmp(1),length,LunAux,LunName,1,1)
          length=DimGrpa(cGrp)*(DimGrpbe(deGrp)+1)/2
          call Exp1 (Tmp(1),L2(1),nc,length,DimGrpa(cGrp))
        else
          LunName=L2Name(deGrp,cGrp)
          length=nc*DimGrpa(cGrp)*DimGrpbe(deGrp)
          call GetX (Tmp(1),length,LunAux,LunName,1,1)
          call Map3_132 (Tmp(1),L2(1),nc,DimGrpbe(deGrp),DimGrpa(cGrp))
        end if
c
        return
        end
c
c       ---------------------
c
        subroutine GetChVHlp4 (H,T1,dima,adda)
c
c       this routine do:
c       Extract H(i,a') <- T1(a,i) for given aGrp
c
c       parameter description:
c       H       - Output file (O)
c       T1      - T1 amplitudes (I)
c       dima    - dimension of given Group (I)
c       adda    - shift of a' in full a set (I)
c
c       N.B. Kvajt odflaknute, je to ExtT1 len transponovane
c
        implicit none
#include "chcc1.fh"
        integer dima,adda
        real*8 T1(1:nv,1:no)
        real*8 H(1:no,1:dima)
c
c       help variables
        integer a,aa,i
c
        do a=1,dima
        aa=adda+a
          do i=1,no
            H(i,a)=T1(aa,i)
          end do
        end do
c
        return
        end
c
c       ------------------------------------
c
        subroutine VanishT2n (T2n1,T2n2,beSGrp,gaSGrp)
c
c       this routine do:
c       vanish space for T2n = T2n(-(+)) (i>(>=)j,(be>(>=)ga)")
c
c       parameter description:
c       T2nx    - arrays for T2+- (O)
c       xSGrp   - SubGroups of be,ga (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 T2n1(1)
        real*8 T2n2(1)
        integer beSGrp,gaSGrp
c
c       help variables
        integer length1,length2
c
c1      calc legths
        if (beSGrp.eq.gaSGrp) then
          length1=no*(no+1)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/4
          length2=no*(no-1)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)-1)/4
        else
          length1=no*(no+1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)/2
          length2=no*(no-1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)/2
        end if
c
c2      vanish
        call mv0zero (length1,length1,T2n1(1))
        call mv0zero (length2,length2,T2n2(1))
c
        return
        end
c
c       ------------------------------------
c
        subroutine GetT2n (T2n1,T2n2,beSGrp,gaSGrp,LunAux)
c
c       this routine do:
c       Read T2n = T2n(-(+)) (i>(>=)j,(be>(>=)ga)")
c        from Tmp3Name(be",ga")
c
c       parameter description:
c       T2nx    - arrays for T2+- (O)
c       xSGrp   - SubGroups of be,ga (I)
c        LunAux  - Lun (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
c
        real*8 T2n1(1)
        real*8 T2n2(1)
        integer beSGrp,gaSGrp,LunAux
c
c       help variables
        integer length1,length2
        character*6 LunName
c
c1      calc legths
        if (beSGrp.eq.gaSGrp) then
          length1=no*(no+1)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/4
        else
          length1=no*(no+1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)/2
        end if
c
        if (beSGrp.eq.gaSGrp) then
          length2=no*(no-1)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)-1)/4
        else
          length2=no*(no-1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)/2
        end if
c
c2      get T2n1, T2n2
        LunName=Tmp3Name(beSGrp,gaSGrp)
        call GetX (T2n1(1),length1,LunAux,LunName,1,0)
        call GetX (T2n2(1),length2,LunAux,LunName,0,1)
c
        return
        end
c
c       ------------------------------------
c
        subroutine ExtractM (M,L2,cGrp,deGrp,cSGrp,deSGrp)
c
c       this routine do:
c       extract M(m,c",de") from L2(m,c',de')
c
c       parameter description:
c       M     - M file (O)
c       L     - L2 file (O)
c       xGrp  - c,delta Group (I)
c       xSGrp - c,delta Group (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 M(*),L2(*)
        integer cGrp,deGrp,cSGrp,deSGrp
c
c       help variables
        integer lenMCpp
        integer possM0,possL20,incL20
        integer i,k,depp
c
c
c1      Initial settings
c
c1.1    def length of mc" block (=increment for possM0)
        lenMCpp=nc*DimSGrpa(cSGrp)
c
c1.2    def possM0
        possM0=1
c
c1.3    def possL20
        PossL20=1
        k=0
        if (deSGrp.gt.Grpbelow(deGrp)) then
          do i=Grpbelow(deGrp),deSGrp-1
            k=k+DimSGrpbe(i)
          end do
        end if
        possL20=PossL20+nc*DimGrpa(cGrp)*k
c
        k=0
        if (cSGrp.gt.Grpalow(cGrp)) then
          do i=Grpalow(cGrp),cSGrp-1
            k=k+DimSGrpa(i)
          end do
        end if
        possL20=PossL20+nc*k
c
c1.4    def increment for possL20
        incL20=dimGrpa(cGrp)*nc
c
c2      cycle over de"
        do depp=1,DimSgrpbe(deSGrp)
c
c2.1      copy block of #mc" size
          call mv0u (lenMCpp,L2(possL20),1,M(possM0),1)
c
c2.2      upgrade possM0 and possL20 for next use
          possM0=possM0+lenMCpp
          possL20=possL20+incL20
c
        end do
c
c
        return
        end
c
c       ------------------------------------
c
        subroutine MakeT2p (T2p,Tau,aGrp,bGrp,aSGrp,bSGrp,keyT)
c
c       this routine do:
c       Make T2p(i>=j,(a>b)" )  = Tau(i,j,(a>=b)")+Tau(j,i,a>=b)")
c                           from  Tau((a>=b)',i,j)
c        or Transposed (T(ab",ij)
c
c       parameter description:
c       T2p    - T2+ array (O)
c       Tau    - Tau array (I)
c       xGrp   - Group of a,b (I)
c       xSGrp  - SubGroup of a,b (I)
c        keyT   - 0 - make T(ij,ab")
c                1 - make T(ab",ij)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 T2p(1)
        real*8 Tau(1)
        integer aGrp,bGrp,aSGrp,bSGrp,keyT
c
c       help variables
        integer dimi,dimij,dimap,dimbp,dimapp,dimbpp,dimabp,dimabpp
c
        dimi=no
        dimij=no*(no+1)/2
c
        dimap=DimGrpa(aGrp)
        dimbp=DimGrpa(bGrp)
        if (aGrp.eq.bGrp) then
          dimabp=dimap*(dimap+1)/2
        else
          dimabp=dimap*dimbp
        end if
c
        dimapp=DimSGrpa(aSGrp)
        dimbpp=DimSGrpa(bSGrp)
        if (aSGrp.eq.bSGrp) then
          dimabpp=dimapp*(dimapp-1)/2
        else
          dimabpp=dimapp*dimbpp
        end if
c
        if (keyT.eq.0) then
c        T+(ij,ab") case
c
        if (aGrp.eq.bGrp) then
          if (aSGrp.eq.bSGrp) then
            call makeT2pHlp1 (T2p(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,0,
     c                        dimi,dimij,dimapp,dimabpp,dimap,dimabp)
          else
            call makeT2pHlp2 (T2p(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,0,
     c                        dimi,dimij,dimapp,dimbpp,dimapp,dimabp)
          end if
        else
          call makeT2pHlp3 (T2p(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,0,
     c                      dimi,dimij,dimapp,dimbpp,dimap,dimbp)
        end if
c
        else
c        T+(ab",ij) case
c
        if (aGrp.eq.bGrp) then
          if (aSGrp.eq.bSGrp) then
            call makeT2ptHlp1 (T2p(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,0,
     c                        dimi,dimij,dimapp,dimabpp,dimap,dimabp)
          else
            call makeT2ptHlp2 (T2p(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,0,
     c                        dimi,dimij,dimapp,dimbpp,dimapp,dimabp)
          end if
        else
          call makeT2ptHlp3 (T2p(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,0,
     c                      dimi,dimij,dimapp,dimbpp,dimap,dimbp)
        end if
c
        end if

c
        return
        end
c
c       ------------------------------------
c
        subroutine MakeT2m (T2m,Tau,aGrp,bGrp,aSGrp,bSGrp,keyT)
c
c       this routine do:
c       Make T2p(i>,(a>b)")  = Tau(i,j,(a>=b)")-Tau(j,i,a>=b)")
c                     from     Tau((a>=b)',i,j)
c        or Transposed (T(ab",ij)
c
c       parameter description:
c       T2m    - T2- array (O)
c       Tau    - Tau array (I)
c       xGrp   - Group of a,b (I)
c       xSGrp  - SubGroup of a,b (I)
c        keyT   - 0 - make T(ij,ab")
c                1 - make T(ab",ij)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 T2m(1)
        real*8 Tau(1)
        integer aGrp,bGrp,aSGrp,bSGrp,keyT
c
c       help variables
        integer dimi,dimij,dimap,dimbp,dimapp,dimbpp,dimabp,dimabpp
c
        dimi=no
        dimij=no*(no-1)/2
c
        dimap=DimGrpa(aGrp)
        dimbp=DimGrpa(bGrp)
        if (aGrp.eq.bGrp) then
          dimabp=dimap*(dimap+1)/2
        else
          dimabp=dimap*dimbp
        end if
c
        dimapp=DimSGrpa(aSGrp)
        dimbpp=DimSGrpa(bSGrp)
        if (aSGrp.eq.bSGrp) then
          dimabpp=dimapp*(dimapp-1)/2
        else
          dimabpp=dimapp*dimbpp
        end if
c
        if (keyT.eq.0) then
c        T-(ij,ab") case
c
        if (aGrp.eq.bGrp) then
          if (aSGrp.eq.bSGrp) then
            call makeT2pHlp1 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                        dimi,dimij,dimapp,dimabpp,dimap,dimabp)
          else
            call makeT2pHlp2 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                        dimi,dimij,dimapp,dimbpp,dimapp,dimabp)
          end if
        else
          call makeT2pHlp3 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                      dimi,dimij,dimapp,dimbpp,dimap,dimbp)
        end if
c
        else
c        T-(ab",ij) case
c
        if (aGrp.eq.bGrp) then
          if (aSGrp.eq.bSGrp) then
            call makeT2ptHlp1 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                        dimi,dimij,dimapp,dimabpp,dimap,dimabp)
          else
            call makeT2ptHlp2 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                        dimi,dimij,dimapp,dimbpp,dimapp,dimabp)
          end if
        else
          call makeT2ptHlp3 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                      dimi,dimij,dimapp,dimbpp,dimap,dimbp)
        end if
c
        end if
c
        return
        end
c
c       ---------------------
c
        subroutine makeT2pHlp1 (T2p,Tau,aGrp,bGrp,aSGrp,bSGrp,key,
     c                          dimi,dimij,dimapp,dimabpp,dimap,dimabp)
c
c       this routine do:
c       define T2(+-)(ij,(ab)") = Tau((ab)',i,j) +- Tau((ab)',j,i)
c       for the case: aGrp=bGrp and aSGrp=bSGrp
c
c       parameter description:
c       T2p     - array for T2+ (O)
c       Tau     - array for Tau (I)
c       xGrp    - Groups of a',b' (I)
c       xSGrp   - SubGroups of a",b" (I)
c       key     - 0 - T2+; 1 = T2- will be produced
c       dimx    - Dimension of i,(i>=j),a",(a>b)",a',(a>=b)' (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,bGrp,aSGrp,bSGrp,key
        integer dimi,dimij,dimapp,dimabpp,dimap,dimabp
        real*8 T2p(1:dimij,1:dimabpp)
        real*8 Tau(1:dimabp,1:dimi,1:dimi)
c
c
c       help variables
        integer i,j,ij,app,bpp,abpp,ap,abp,appAdd,bppAdd
c
c
c1      def appAdd,bppAdd
c
        appAdd=0
        if (aSGrp.ne.Grpalow(aGrp)) then
          do i=Grpalow(aGrp),aSGrp-1
          appAdd=appAdd+DimSGrpa(i)
          end do
        end if
c
        bppAdd=0
        if (bSGrp.ne.Grpalow(bGrp)) then
          do i=Grpalow(bGrp),bSGrp-1
          bppAdd=bppAdd+DimSGrpa(i)
          end do
        end if
c
c
c2      define T2(+,-)
c
        if (key.eq.0) then
c
c2.1    define T2+
        abpp=0
        do app=2,dimapp
        ap=appAdd+app
        abp=ap*(ap-1)/2+bppAdd
        do bpp=1,app-1
        abp=abp+1
        abpp=abpp+1
          ij=0
          do i=1,dimi
          do j=1,i
            ij=ij+1
            T2p(ij,abpp)=Tau(abp,i,j)+Tau(abp,j,i)
          end do
          end do
        end do
        end do
c
        else
c
c2.2    define T2-
        abpp=0
        do app=2,dimapp
        ap=appAdd+app
        abp=ap*(ap-1)/2+bppAdd
        do bpp=1,app-1
        abp=abp+1
        abpp=abpp+1
          ij=0
          do i=2,dimi
          do j=1,i-1
            ij=ij+1
            T2p(ij,abpp)=Tau(abp,i,j)-Tau(abp,j,i)
c           T2p(ij,abpp)=T2c(ap,bpp,i,j)-T2c(ap,bpp,j,i)
          end do
          end do
        end do
        end do
c
        end if
c
        call mv0sv (dimij*dimabpp,dimij*dimabpp,
     c              T2p(1,1),0.5d0)
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_integer(dimap)
        end
c
c       ---------------------
c
        subroutine makeT2pHlp2 (T2p,Tau,aGrp,bGrp,aSGrp,bSGrp,key,
     c                          dimi,dimij,dimapp,dimbpp,dimap,dimabp)
c
c       this routine do:
c       define T2(+-)(ij,(ab)") = Tau((ab)',i,j) +- Tau((ab)',j,i)
c       for the case: aGrp=bGrp but aSGrp>bSGrp
c
c       parameter description:
c       T2p     - array for T2+ (O)
c       Tau     - array for Tau (I)
c       xGrp    - Groups of a',b' (I)
c       xSGrp   - SubGroups of a",b" (I)
c       key     - 0 - T2+; 1 = T2- will be produced
c       dimx    - Dimension of i,(i>=j),a",b",a',(a>=b)' (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,bGrp,aSGrp,bSGrp,key
        integer dimi,dimij,dimapp,dimbpp,dimap,dimabp
        real*8 T2p(1:dimij,1:dimapp,1:dimbpp)
        real*8 Tau(1:dimabp,1:dimi,1:dimi)
c
c
c       help variables
        integer i,j,ij,app,bpp,ap,abp,appAdd,bppAdd
c
c
c1      def appAdd,bppAdd
c
        appAdd=0
        if (aSGrp.ne.Grpalow(aGrp)) then
          do i=Grpalow(aGrp),aSGrp-1
          appAdd=appAdd+DimSGrpa(i)
          end do
        end if
c
        bppAdd=0
        if (bSGrp.ne.Grpalow(bGrp)) then
          do i=Grpalow(bGrp),bSGrp-1
          bppAdd=bppAdd+DimSGrpa(i)
          end do
        end if
c
c
c2      define T2(+,-)
c
        if (key.eq.0) then
c
c2.1    define T2+
        do app=1,dimapp
        ap=appAdd+app
        abp=ap*(ap-1)/2+bppAdd
        do bpp=1,dimbpp
        abp=abp+1
          ij=0
          do i=1,dimi
          do j=1,i
            ij=ij+1
            T2p(ij,app,bpp)=Tau(abp,i,j)+Tau(abp,j,i)
          end do
          end do
        end do
        end do
c
        else
c
c2.2    define T2-
        do app=1,dimapp
        ap=appAdd+app
        abp=ap*(ap-1)/2+bppAdd
        do bpp=1,dimbpp
        abp=abp+1
          ij=0
          do i=2,dimi
          do j=1,i-1
            ij=ij+1
            T2p(ij,app,bpp)=Tau(abp,i,j)-Tau(abp,j,i)
          end do
          end do
        end do
        end do
c
        end if
c
        call mv0sv (dimij*dimapp*dimbpp,dimij*dimapp*dimbpp,
     c              T2p(1,1,1),0.5d0)
c
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_integer(dimap)
        end
c
c       ---------------------
c
        subroutine makeT2pHlp3 (T2p,Tau,aGrp,bGrp,aSGrp,bSGrp,key,
     c                          dimi,dimij,dimapp,dimbpp,dimap,dimbp)
c
c       this routine do:
c       define T2(+-)(ij,(ab)") = Tau((ab)',i,j) +- Tau((ab)',j,i)
c       for the case: aGrp>bGrp (=> aSGrp>bSGrp)
c
c       parameter description:
c       T2p     - array for T2+ (O)
c       Tau     - array for Tau (I)
c       xGrp    - Groups of a',b' (I)
c       xSGrp   - SubGroups of a",b" (I)
c       key     - 0 - T2+; 1 = T2- will be produced
c       dimx    - Dimension of i,(i>=j),a",b",a',b' (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,bGrp,aSGrp,bSGrp,key
        integer dimi,dimij,dimapp,dimbpp,dimap,dimbp
        real*8 T2p(1:dimij,1:dimapp,1:dimbpp)
        real*8 Tau(1:dimap,1:dimbp,1:dimi,1:dimi)
c
c       help variables
        integer i,j,ij,app,bpp,ap,bp,appAdd,bppAdd
c
c
c1      def appAdd,bppAdd
c
        appAdd=0
        if (aSGrp.ne.Grpalow(aGrp)) then
          do i=Grpalow(aGrp),aSGrp-1
          appAdd=appAdd+DimSGrpa(i)
          end do
        end if
c
        bppAdd=0
        if (bSGrp.ne.Grpalow(bGrp)) then
          do i=Grpalow(bGrp),bSGrp-1
          bppAdd=bppAdd+DimSGrpa(i)
          end do
        end if
c
c
c2      define T2(+,-)
c
        if (key.eq.0) then
c
c2.1    define T2+
        do bpp=1,dimbpp
        bp=bppAdd+bpp
        do app=1,dimapp
        ap=appAdd+app
          ij=0
          do i=1,dimi
          do j=1,i
            ij=ij+1
            T2p(ij,app,bpp)=Tau(ap,bp,i,j)+Tau(ap,bp,j,i)
          end do
          end do
        end do
        end do
c
        else
c
c2.2    define T2-
        do bpp=1,dimbpp
        bp=bppAdd+bpp
        do app=1,dimapp
        ap=appAdd+app
          ij=0
          do i=2,dimi
          do j=1,i-1
            ij=ij+1
            T2p(ij,app,bpp)=Tau(ap,bp,i,j)-Tau(ap,bp,j,i)
          end do
          end do
        end do
        end do
c
        end if
c
        call mv0sv (dimij*dimapp*dimbpp,dimij*dimapp*dimbpp,
     c              T2p(1,1,1),0.5d0)
c
c
        return
        end
c
c       ---------------------
c
        subroutine makeT2ptHlp1 (T2p,Tau,aGrp,bGrp,aSGrp,bSGrp,key,
     c                          dimi,dimij,dimapp,dimabpp,dimap,dimabp)
c
c       this routine do:
c       define T2(+-)((ab)",ij) = Tau((ab)',i,j) +- Tau((ab)',j,i)
c       for the case: aGrp=bGrp and aSGrp=bSGrp
c
c       parameter description:
c       T2p     - array for T2+ (O)
c       Tau     - array for Tau (I)
c       xGrp    - Groups of a',b' (I)
c       xSGrp   - SubGroups of a",b" (I)
c       key     - 0 - T2+; 1 = T2- will be produced
c       dimx    - Dimension of i,(i>=j),a",(a>(or>=)b)",a',(a>=b)' (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,bGrp,aSGrp,bSGrp,key
        integer dimi,dimij,dimapp,dimabpp,dimap,dimabp
        real*8 T2p(1:dimabpp,1:dimij)
        real*8 Tau(1:dimabp,1:dimi,1:dimi)
c
c
c       help variables
        integer i,j,ij,app,bpp,abpp,ap,abp,appAdd,bppAdd
c
c
c1      def appAdd,bppAdd
c
        appAdd=0
        if (aSGrp.ne.Grpalow(aGrp)) then
          do i=Grpalow(aGrp),aSGrp-1
          appAdd=appAdd+DimSGrpa(i)
          end do
        end if
c
        bppAdd=0
        if (bSGrp.ne.Grpalow(bGrp)) then
          do i=Grpalow(bGrp),bSGrp-1
          bppAdd=bppAdd+DimSGrpa(i)
          end do
        end if
c
c
c2      define T2(+,-)
c
        if (key.eq.0) then
c
c2.1    define T2+
        ij=0
        do i=1,dimi
        do j=1,i
        ij=ij+1
          abpp=0
          do app=2,dimapp
          ap=appAdd+app
          abp=ap*(ap-1)/2+bppAdd
          do bpp=1,app-1
          abp=abp+1
          abpp=abpp+1
            T2p(abpp,ij)=Tau(abp,i,j)+Tau(abp,j,i)
          end do
          end do
        end do
        end do
c
        else
c
c2.2    define T2-
        ij=0
        do i=2,dimi
        do j=1,i-1
        ij=ij+1
          abpp=0
          do app=2,dimapp
          ap=appAdd+app
          abp=ap*(ap-1)/2+bppAdd
          do bpp=1,app-1
          abp=abp+1
          abpp=abpp+1
            T2p(abpp,ij)=Tau(abp,i,j)-Tau(abp,j,i)
          end do
          end do
        end do
        end do
c
        end if
c
        call mv0sv (dimij*dimabpp,dimij*dimabpp,
     c              T2p(1,1),0.5d0)
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_integer(dimap)
        end
c
c       ---------------------
c
        subroutine makeT2ptHlp2 (T2p,Tau,aGrp,bGrp,aSGrp,bSGrp,key,
     c                          dimi,dimij,dimapp,dimbpp,dimap,dimabp)
c
c       this routine do:
c       define T2(+-)((ab)",ij) = Tau((ab)',i,j) +- Tau((ab)',j,i)
c       for the case: aGrp=bGrp but aSGrp>bSGrp
c
c       parameter description:
c       T2p     - array for T2+ (O)
c       Tau     - array for Tau (I)
c       xGrp    - Groups of a',b' (I)
c       xSGrp   - SubGroups of a",b" (I)
c       key     - 0 - T2+; 1 = T2- will be produced
c       dimx    - Dimension of i,(i>=j),a",b",a',(a>=b)' (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,bGrp,aSGrp,bSGrp,key
        integer dimi,dimij,dimapp,dimbpp,dimap,dimabp
        real*8 T2p(1:dimapp,1:dimbpp,1:dimij)
        real*8 Tau(1:dimabp,1:dimi,1:dimi)
c
c
c       help variables
        integer i,j,ij,app,bpp,ap,abp,appAdd,bppAdd
c
c
c1      def appAdd,bppAdd
c
        appAdd=0
        if (aSGrp.ne.Grpalow(aGrp)) then
          do i=Grpalow(aGrp),aSGrp-1
          appAdd=appAdd+DimSGrpa(i)
          end do
        end if
c
        bppAdd=0
        if (bSGrp.ne.Grpalow(bGrp)) then
          do i=Grpalow(bGrp),bSGrp-1
          bppAdd=bppAdd+DimSGrpa(i)
          end do
        end if
c
c
c2      define T2(+,-)
c
        if (key.eq.0) then
c
c2.1    define T2+
        ij=0
        do i=1,dimi
        do j=1,i
        ij=ij+1
          do app=1,dimapp
          ap=appAdd+app
          abp=ap*(ap-1)/2+bppAdd
          do bpp=1,dimbpp
          abp=abp+1
            T2p(app,bpp,ij)=Tau(abp,i,j)+Tau(abp,j,i)
          end do
          end do
        end do
        end do
c
        else
c
c2.2    define T2-
        ij=0
        do i=2,dimi
        do j=1,i-1
        ij=ij+1
          do app=1,dimapp
          ap=appAdd+app
          abp=ap*(ap-1)/2+bppAdd
          do bpp=1,dimbpp
          abp=abp+1
            T2p(app,bpp,ij)=Tau(abp,i,j)-Tau(abp,j,i)
          end do
          end do
        end do
        end do
c
        end if
c
        call mv0sv (dimij*dimapp*dimbpp,dimij*dimapp*dimbpp,
     c              T2p(1,1,1),0.5d0)
c
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_integer(dimap)
        end
c
c       ---------------------
c
        subroutine makeT2ptHlp3 (T2p,Tau,aGrp,bGrp,aSGrp,bSGrp,key,
     c                          dimi,dimij,dimapp,dimbpp,dimap,dimbp)
c
c       this routine do:
c       define T2(+-)((ab)",ij) = Tau((ab)',i,j) +- Tau((ab)',j,i)
c       for the case: aGrp>bGrp (=> aSGrp>bSGrp)
c
c       parameter description:
c       T2p     - array for T2+ (O)
c       Tau     - array for Tau (I)
c       xGrp    - Groups of a',b' (I)
c       xSGrp   - SubGroups of a",b" (I)
c       key     - 0 - T2+; 1 = T2- will be produced
c       dimx    - Dimension of i,(i>=j),a",b",a',b' (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,bGrp,aSGrp,bSGrp,key
        integer dimi,dimij,dimapp,dimbpp,dimap,dimbp
        real*8 T2p(1:dimapp,1:dimbpp,1:dimij)
        real*8 Tau(1:dimap,1:dimbp,1:dimi,1:dimi)
c
c       help variables
        integer i,j,ij,app,bpp,ap,bp,appAdd,bppAdd
c
c
c1      def appAdd,bppAdd
c
        appAdd=0
        if (aSGrp.ne.Grpalow(aGrp)) then
          do i=Grpalow(aGrp),aSGrp-1
          appAdd=appAdd+DimSGrpa(i)
          end do
        end if
c
        bppAdd=0
        if (bSGrp.ne.Grpalow(bGrp)) then
          do i=Grpalow(bGrp),bSGrp-1
          bppAdd=bppAdd+DimSGrpa(i)
          end do
        end if
c
c
c2      define T2(+,-)
c
        if (key.eq.0) then
c
c2.1    define T2+
        ij=0
        do i=1,dimi
        do j=1,i
        ij=ij+1
          do bpp=1,dimbpp
          bp=bppAdd+bpp
          do app=1,dimapp
          ap=appAdd+app
            T2p(app,bpp,ij)=Tau(ap,bp,i,j)+Tau(ap,bp,j,i)
          end do
          end do
        end do
        end do
c
        else
c
c2.2    define T2-
        ij=0
        do i=2,dimi
        do j=1,i-1
        ij=ij+1
          do bpp=1,dimbpp
          bp=bppAdd+bpp
          do app=1,dimapp
          ap=appAdd+app
            T2p(app,bpp,ij)=Tau(ap,bp,i,j)-Tau(ap,bp,j,i)
          end do
          end do
        end do
        end do
c
        end if
c
        call mv0sv (dimij*dimapp*dimbpp,dimij*dimapp*dimbpp,
     c              T2p(1,1,1),0.5d0)
c
c
        return
        end
c
c       ------------------------------------
c
        subroutine MakeWw (Ww,W1,W2,aSGrp,bSGrp,beSGrp,gaSGrp,key)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c                                     and W2(b",be",a",ga")
c        where index ab" is always a">b" (not a"=b")
c        and   index bega" is be">=ga" for W+ and be">ga" for W-
c       for all cases aSGrp >= bSGrp
c       N.B. for a"=b" W2 is not used (although it is passed through
c            the header (because of uniform shape) but no matter what
c            is there)
c       N.B. rutinky MakeWwHlpx niesu prilis vymakane @
c
c       parameter description:
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       W2     - array for W1(b",be",a",ga") (I)
c       xSGrp  - SubGroup of a",b",be",ga" (I)
c       key    - 1 - calc Ww+, 2 - calc Ww- (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 Ww(1)
        real*8 W1(1)
        real*8 W2(1)
        integer aSGrp,bSGrp,beSGrp,gaSGrp,key
c
c       help variables
        integer dimbe,dimga,dimbega,dima,dimb,dimab
c
c
c1      def dimensions
c
        dimbe=DimSGrpbe(beSGrp)
        dimga=DimSGrpbe(gaSGrp)
        dima=DimSGrpa(aSGrp)
        dimb=DimSGrpa(bSGrp)
c
        if (beSGrp.eq.gaSGrp) then
          if (key.eq.1) then
            dimbega=dimbe*(dimbe+1)/2
          else
            dimbega=dimbe*(dimbe-1)/2
          end if
        else
          dimbega=dimbe*dimga
        end if
c
        if (aSGrp.eq.bSGrp) then
          dimab=dima*(dima-1)/2
        else
          dimab=dima*dimb
        end if
c
c
c2      Make Ww matrix
c
        if (aSGrp.eq.bSGrp) then
          if (beSGrp.eq.gaSGrp) then
            call MakeWwHlp1 (Ww(1),W1(1),
     c                       dima,dimb,dimab,dimbe,dimga,dimbega,key)
          else
            call MakeWwHlp2 (Ww(1),W1(1),
     c                       dima,dimb,dimab,dimbe,dimga,key)
          end if
        else
          if (beSGrp.eq.gaSGrp) then
            call MakeWwHlp3 (Ww(1),W1(1),W2(1),
     c                       dima,dimb,dimbe,dimga,dimbega,key)
          else
            call MakeWwHlp4 (Ww(1),W1(1),W2(1),
     c                       dima,dimb,dimbe,dimga,key)
          end if
        end if
c
c
        return
        end
c
c       ---------------------
c
        subroutine MakeWwHlp1 (Ww,W1,
     c                       dima,dimb,dimab,dimbe,dimga,dimbega,key)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c       for the case a"=b" , be"=ga"
c       N.B. algoritmus nieje prilis vymakany
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       dimx   - dimension of a",b",ab",be",ga",bega" (I)
c       key    - 1 - calc Ww+, 2 - calc Ww- (I)
c
        implicit none
        integer dima,dimb,dimab,dimbe,dimga,dimbega,key
        real*8 Ww(1:dimab,1:dimbega)
        real*8 W1(1:dima,1:dimbe,1:dimb,1:dimga)
c
c       help variables
        integer a,b,ab,be,ga,bega
c
c
        if (key.eq.1) then
          bega=0
          do be=1,dimbe
          do ga=1,be
          bega=bega+1
          ab=0
          do a=2,dima
          do b=1,a-1
          ab=ab+1
            Ww(ab,bega)=W1(a,be,b,ga)+W1(b,be,a,ga)
          end do
          end do
          end do
          end do
        else
          bega=0
          do be=2,dimbe
          do ga=1,be-1
          bega=bega+1
          ab=0
          do a=2,dima
          do b=1,a-1
          ab=ab+1
            Ww(ab,bega)=W1(a,be,b,ga)-W1(b,be,a,ga)
          end do
          end do
          end do
          end do
        end if
c
c        Cely clen ma Faktor 2, tu teda nevydelim 2
c        call mv0sv (dimab*dimbega,dimab*dimbega,
c    c              Ww(1,1),0.5d0)
c
        return
        end
c
c       ---------------------
c
        subroutine MakeWwHlp2 (Ww,W1,
     c                       dima,dimb,dimab,dimbe,dimga,key)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c       for the case a"=b" , be".ne.ga"
c       N.B. algoritmus nieje prilis vymakany
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       dimx   - dimension of a",b",ab",be",ga" (I)
c       key    - 1 - calc Ww+, 2 - calc Ww- (I)
c
        implicit none
        integer dima,dimb,dimab,dimbe,dimga,key
        real*8 Ww(1:dimab,1:dimbe,1:dimga)
        real*8 W1(1:dima,1:dimbe,1:dimb,1:dimga)
c
c       help variables
        integer a,b,ab,be,ga
c
c
        if (key.eq.1) then
          do ga=1,dimga
          do be=1,dimbe
          ab=0
          do a=2,dima
          do b=1,a-1
          ab=ab+1
            Ww(ab,be,ga)=W1(a,be,b,ga)+W1(b,be,a,ga)
          end do
          end do
          end do
          end do
        else
          do ga=1,dimga
          do be=1,dimbe
          ab=0
          do a=2,dima
          do b=1,a-1
          ab=ab+1
            Ww(ab,be,ga)=W1(a,be,b,ga)-W1(b,be,a,ga)
          end do
          end do
          end do
          end do
        end if
c
c        Cely clen ma Faktor 2, tu teda nevydelim 2
c        call mv0sv (dimab*dimbe*dimga,dimab*dimbe*dimga,
c    c              Ww(1,1,1),0.5d0)
c
        return
        end
c
c       ---------------------
c
        subroutine MakeWwHlp3 (Ww,W1,W2,
     c                       dima,dimb,dimbe,dimga,dimbega,key)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c                                     and W2(b",be",a",ga")
c       for the case a".ne.b" , be"=ga"
c       N.B. algoritmus nieje prilis vymakany, prva cast sa da
c            urobit pomodou dcopy
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       W2     - array for W1(b",be",a",ga") (I)
c       dimx   - dimension of a",b",be",ga",be>(>=)ga" (I)
c       key    - 1 - calc Ww+, 2 - calc Ww- (I)
c
        implicit none
        integer dima,dimb,dimbe,dimga,dimbega,key
        real*8 Ww(1:dima,1:dimb,1:dimbega)
        real*8 W1(1:dima,1:dimbe,1:dimb,1:dimga)
        real*8 W2(1:dimb,1:dimbe,1:dima,1:dimga)
c
c       help variables
        integer a,b,be,ga,bega
c
c
        if (key.eq.1) then
          bega=0
          do be=1,dimbe
          do ga=1,be
          bega=bega+1
          do b=1,dimb
          do a=1,dima
            Ww(a,b,bega)=W1(a,be,b,ga)+W2(b,be,a,ga)
          end do
          end do
          end do
          end do
        else
          bega=0
          do be=2,dimbe
          do ga=1,be-1
          bega=bega+1
          do b=1,dimb
          do a=1,dima
            Ww(a,b,bega)=W1(a,be,b,ga)-W2(b,be,a,ga)
          end do
          end do
          end do
          end do
        end if
c
c        Cely clen ma Faktor 2, tu teda nevydelim 2
c        call mv0sv (dima*dimb*dimbega,dima*dimb*dimbega,
c    c              Ww(1,1,1),0.5d0)
c
        return
        end
c
c       ---------------------
c
        subroutine MakeWwHlp4 (Ww,W1,W2,
     c                       dima,dimb,dimbe,dimga,key)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c                                     and W2(b",be",a",ga")
c       for the case a".ne.b" , be".ne.ga"
c       N.B. algoritmus nieje prilis vymakany, prva cast sa da
c            urobit pomodou dcopy
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       W2     - array for W1(b",be",a",ga") (I)
c       dimx   - dimension of a",b",be",ga" (I)
c       key    - 1 - calc Ww+, 2 - calc Ww- (I)
c
        implicit none
        integer dima,dimb,dimbe,dimga,key
        real*8 Ww(1:dima,1:dimb,1:dimbe,1:dimga)
        real*8 W1(1:dima,1:dimbe,1:dimb,1:dimga)
        real*8 W2(1:dimb,1:dimbe,1:dima,1:dimga)
c
c       help variables
        integer a,b,be,ga
c
c
        if (key.eq.1) then
          do ga=1,dimga
          do be=1,dimbe
          do b=1,dimb
          do a=1,dima
            Ww(a,b,be,ga)=W1(a,be,b,ga)+W2(b,be,a,ga)
          end do
          end do
          end do
          end do
        else
          do ga=1,dimga
          do be=1,dimbe
          do b=1,dimb
          do a=1,dima
            Ww(a,b,be,ga)=W1(a,be,b,ga)-W2(b,be,a,ga)
          end do
          end do
          end do
          end do
        end if
c
c        Cely clen ma Faktor 2, tu teda nevydelim 2
c        call mv0sv (dima*dimb*dimbe*dimga,dima*dimb*dimbe*dimga,
c    c              Ww(1,1,1,1),0.5d0)
c
        return
        end
c
c       ------------------------------------
c
        subroutine MakeT2pd (T2p,Tau,aGrp,aSGrp)
c
c       this routine do:
c       Make T2p((a>b)",i>=j )  = Tau(i,j,(a>=b)")+Tau(j,i,a>=b)")
c                           from  Tau((a>=b)',i,j)
c
c       parameter description:
c       T2p    - T2+ array (O)
c       Tau    - Tau array (I)
c       xGrp   - Group of a (I)
c       xSGrp  - SubGroup of a (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 T2p(1)
        real*8 Tau(1)
        integer aGrp,aSGrp
c
c       help variables
        integer dimi,dimij,dimap,dimapp,dimabp
c
        dimi=no
        dimij=no*(no+1)/2
c
        dimap=DimGrpa(aGrp)
        dimabp=dimap*(dimap+1)/2
c
        dimapp=DimSGrpa(aSGrp)
c
c
        call makeT2pdHlp (T2p(1),Tau(1),aGrp,aSGrp,
     c                   dimi,dimij,dimapp,dimap,dimabp)
c
        return
        end
c
c       ---------------------
c
        subroutine makeT2pdHlp (T2p,Tau,aGrp,aSGrp,
     c                          dimi,dimij,dimapp,dimap,dimabp)
c
c       this routine do:
c       define T2(+)((aa)",ij) = Tau((ab)',i,j) + Tau((ab)',j,i)
c       for the case: aGrp=bGrp and aSGrp=bSGrp
c
c       parameter description:
c       T2p     - array for T2+ (O)
c       Tau     - array for Tau (I)
c       xGrp    - Groups of a',b' (I)
c       xSGrp   - SubGroups of a",b" (I)
c       dimx    - Dimension of i,(i>=j),a",a',(a>=b)' (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,aSGrp
        integer dimi,dimij,dimapp,dimap,dimabp
        real*8 T2p(1:dimapp,1:dimij)
        real*8 Tau(1:dimabp,1:dimi,1:dimi)
c
c
c       help variables
        integer i,j,ij,app,ap,abp,appAdd
c
c
c1      def appAdd
c
        appAdd=0
        if (aSGrp.ne.Grpalow(aGrp)) then
          do i=Grpalow(aGrp),aSGrp-1
          appAdd=appAdd+DimSGrpa(i)
          end do
        end if
c
c2        define T2+(aa",ij)
c
        ij=0
        do i=1,dimi
        do j=1,i
        ij=ij+1
          do app=1,dimapp
          ap=appAdd+app
          abp=ap*(ap+1)/2
            T2p(app,ij)=Tau(abp,i,j)+Tau(abp,j,i)
          end do
        end do
        end do
c
        call mv0sv (dimij*dimapp,dimij*dimapp,
     c              T2p(1,1),0.5d0)
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_integer(dimap)
        end
c
c       ------------------------------------
c
        subroutine MakeWwd (Ww,W1,aSGrp,beSGrp,gaSGrp)
c
c       this routine do:
c       Make  Ww(+)((aa)",(bega)") from W1(a",be",a",ga")
c        and   index bega" is be">=ga"
c       for all cases aSGrp >= bSGrp
c       N.B. rutinky MakeWwHlpx niesu prilis vymakane @
c
c       parameter description:
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",a",ga") (I)
c       xSGrp  - SubGroup of a",be",ga" (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 Ww(1)
        real*8 W1(1)
        integer aSGrp,beSGrp,gaSGrp
c
c       help variables
        integer dimbe,dimga,dimbega,dima
c
c
c1      def dimensions
c
        dimbe=DimSGrpbe(beSGrp)
        dimga=DimSGrpbe(gaSGrp)
        dima=DimSGrpa(aSGrp)
c
        if (beSGrp.eq.gaSGrp) then
          dimbega=dimbe*(dimbe+1)/2
        else
          dimbega=dimbe*dimga
        end if
c
c
c2      Make Ww matrix
c
        if (beSGrp.eq.gaSGrp) then
          call MakeWwdHlp1 (Ww(1),W1(1),
     c                   dima,dimbe,dimbega)
        else
          call MakeWwdHlp2 (Ww(1),W1(1),
     c                   dima,dimbe,dimga)
        end if

c
c
        return
        end
c
c       ---------------------
c
        subroutine MakeWwdHlp1 (Ww,W1,
     c                          dima,dimbe,dimbega)
c
c       this routine do:
c       Make  Ww(+)((aa)",(bega)") from W1(a",be",b",ga")
c       for the case beSGrp=gaSGrp
c       N.B. algoritmus nieje prilis vymakany
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       dimx   - dimension of a",ga",bega" (I)
c
        implicit none
        integer dima,dimbe,dimbega
        real*8 Ww(1:dima,1:dimbega)
        real*8 W1(1:dima,1:dimbe,1:dima,1:dimbe)
c
c       help variables
        integer a,be,ga,bega
c
c
          bega=0
          do be=1,dimbe
          do ga=1,be
          bega=bega+1
          do a=1,dima
            Ww(a,bega)=W1(a,be,a,ga)
          end do
          end do
          end do
c
        return
        end
c
c       ---------------------
c
        subroutine MakeWwdHlp2 (Ww,W1,
     c                       dima,dimbe,dimga)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c       for the case a"=b" , beSGrp.ne.gaSGrp
c       N.B. algoritmus nieje prilis vymakany
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       dimx   - dimension of a",be",ga" (I)
c
        implicit none
        integer dima,dimbe,dimga
        real*8 Ww(1:dima,1:dimbe,1:dimga)
        real*8 W1(1:dima,1:dimbe,1:dima,1:dimga)
c
c       help variables
        integer a,be,ga
c
c
CVpV 2014 Fix for Intel Compiler v14.*
#ifdef __INTEL_COMPILER
          do a=1,dima
          do ga=1,dimga
cDEC$ VECTOR UNALIGNED
          do be=1,dimbe
            Ww(a,be,ga)=W1(a,be,a,ga)
          end do
          end do
          end do
#else
          do ga=1,dimga
          do be=1,dimbe
          do a=1,dima
            Ww(a,be,ga)=W1(a,be,a,ga)
          end do
          end do
          end do
#endif
c
        return
        end
c
c        -------------------------
c
        subroutine Calc_addSG (aSGrp,adda)
c
c        calc add constant from SubGroup
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
        integer aSGrp,adda
c
c        help var
        integer i
c
        adda=0
        do i=1,aSgrp-1
          adda=adda+DimSGrpa(i)
        end do
c
        return
        end
c
c        -------------------------
c
        subroutine Calc_addG (aGrp,adda)
c
c        calc add constant from group
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
        integer aGrp,adda
c
c        help var
        integer i
c
        adda=0
        do i=1,agrp-1
          adda=adda+DimGrpa(i)
        end do
c
        return
        end
c
c        -------------------------
c        -------------------------
c
        subroutine  Mk_T1t (T1,H,dimbepp,no,nv,addbepp)
c
c        this routine do:
c        H(i,be") <- T1o(be,i)
c
        implicit none
        integer dimbepp,no,nv,addbepp
        real*8 T1(1:nv,1:no)
        real*8 H(1:no,1:dimbepp)
c
c        help variables
        integer i,bepp
c
        do i=1,no
        do bepp=1,dimbepp
          H(i,bepp)=T1(addbepp+bepp,i)
        end do
        end do
c
        return
        end
c
c        -------------------------
c
        subroutine ReaW3 (Ww,Wx,aSGrp,beSGrp,bSGrp,LunAux)
c
c        this routine do:
c        define Ww(a",be",b",i) <- (a",be"|b",i)
c
c        integrals (a",be"|b",i) are stored in files V3xxyyzz for xx>=yy
c
c        Storing of integrals in V3files
c        do i=1,no
c          record of V3(a"be",b",_i): a">=be",b" for given i
c        end do
c
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aSGrp,beSGrp,bSGrp,LunAux
        real*8 Ww(1)
        real*8 Wx(1)
c
c        help variables
c
        integer dima,dimb,dimbe
        character*8 LunName

c0        def dimensions
c
        dima=DimSGrpa(aSGrp)
        dimb=DimSGrpa(bSGrp)
        dimbe=DimSGrpbe(beSGrp)
c
c
        if (aSGrp.gt.beSGrp) then
c1        case aSGrp>beSGrp, integrals (a",be"|b",i) to be read
c1.1          make Name
          call MkNameV3 (aSGrp,beSGrp,bSGrp,'W3',LunName)
c1.2          read (a",be"|b",i) from V3:(a",be"|b",i)
          call ReaW3hlp1 (Ww,Wx,dima,dimbe,dimb,no,LunName,LunAux)
c
        else if (aSGrp.eq.beSGrp) then
c2        case aSGrp=beSGrp, integrals (a">=be"|b",i)to be read and expand
c2.1          make Name
          call MkNameV3 (aSGrp,beSGrp,bSGrp,'W3',LunName)
c2.2          read (a",be"|b",i) from V3:(a">=be"|b",i)
          call ReaW3hlp2 (Ww,Wx,dima,dimb,no,LunName,LunAux)
c
        else
c3        case aSGrp<beSGrp, integrals (be",a"|b",i) to be read and mapped
c3.1          make Name
          call MkNameV3 (beSGrp,aSGrp,bSGrp,'W3',LunName)
c3.2          read (a",be"|b",i) from V3:(be",a"|b",i)
          call ReaW3hlp3 (Ww,Wx,dima,dimbe,dimb,no,LunName,LunAux)

        end if
c
        return
        end
c
c        -------------------
c
        subroutine MkNameV3 (i,j,k,Schem,Nomen)
c
c       help routine to ReaW3, producing name of V3file
c       ex: Schem='XY', i=1, j=3, k=5 ->  Nomen='XY010305'
c
        implicit none
        integer i,j,k
        character*2 Schem
        character*8 Nomen
c
c       help variables
        character*1 Chr(1:8)
        character*2 digit(1:64)
        character*2 ichr,jchr,kchr
        character*2 baza
        character*8 meno
c
        equivalence (Chr(1),meno)
        equivalence (Chr(1),baza)
        equivalence (Chr(3),ichr)
        equivalence (Chr(5),jchr)
        equivalence (Chr(7),kchr)
c
c
c        quite a porno this piece
        digit(1)='01'
        digit(2)='02'
        digit(3)='03'
        digit(4)='04'
        digit(5)='05'
        digit(6)='06'
        digit(7)='07'
        digit(8)='08'
        digit(9)='09'
        digit(10)='10'
        digit(11)='11'
        digit(12)='12'
        digit(13)='13'
        digit(14)='14'
        digit(15)='15'
        digit(16)='16'
        digit(17)='17'
        digit(18)='18'
        digit(19)='19'
        digit(20)='20'
        digit(21)='21'
        digit(22)='22'
        digit(23)='23'
        digit(24)='24'
        digit(25)='25'
        digit(26)='26'
        digit(27)='27'
        digit(28)='28'
        digit(29)='29'
        digit(30)='30'
        digit(31)='31'
        digit(32)='32'
        digit(33)='33'
        digit(34)='34'
        digit(35)='35'
        digit(36)='36'
        digit(37)='37'
        digit(38)='38'
        digit(39)='39'
        digit(40)='40'
        digit(41)='41'
        digit(42)='42'
        digit(43)='43'
        digit(44)='44'
        digit(45)='45'
        digit(46)='46'
        digit(47)='47'
        digit(48)='48'
        digit(49)='49'
        digit(50)='50'
        digit(51)='51'
        digit(52)='52'
        digit(53)='53'
        digit(54)='54'
        digit(55)='55'
        digit(56)='56'
        digit(57)='57'
        digit(58)='58'
        digit(59)='59'
        digit(60)='60'
        digit(61)='61'
        digit(62)='62'
        digit(63)='63'
        digit(64)='64'
c
c
        baza=Schem
        ichr=digit(i)
        jchr=digit(j)
        kchr=digit(k)
        Nomen=meno
c
        return
        end
c
c        -------------------
c
        subroutine ReaW3hlp1 (Ww,Wx,dima,dimbe,dimb,no,LunName,LunAux)
c
c        this routine do:
c        reconstruct  Ww(a",be',b,i)  for aSGrp>beSGrp
c        from (a",be'|b,i) records in V3 file LunName
c
        implicit none
        integer dima,dimbe,dimb,no,LunAux
        character*8 LunName
        real*8 Ww(1)
        real*8 Wx(1)
c
c        help variables
c
        integer length

*       open (unit=LunAux,file=LunName,form='unformatted')
        Call Molcas_BinaryOpen_Vanilla(LunAux,LunName)
c
        length=dima*dimbe*dimb*no
c
c        read block (a",be'|b,_i)
        call rea_chcc (LunAux,length,Ww(1))
cmp        call mv0zero (length,length,Ww(1))
c
        close (LunAux)
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_real_array(Wx)
        end
c
c        -------------------
c
        subroutine ReaW3hlp2 (Ww,Wx,dima,dimb,no,LunName,LunAux)
c
c        this routine do:
c        reconstruct  Ww(a",be',b,i)  for aSGrp=beSGrp
c        from (a">=be"|b,i) records in V3 file LunName
c
        implicit none
        integer dima,dimb,no,LunAux
        character*8 LunName
        real*8 Ww(1:dima,1:dima,1:dimb,1:no)
        real*8 Wx(*)

c        help variables
c
        integer i,a,be,abebi,b,length

c        read block (a">=be"|b"_i)
        length=(no*dima*(dima+1)*dimb)/2
*       open (unit=LunAux,file=LunName,form='unformatted')
        Call Molcas_BinaryOpen_Vanilla(LunAux,LunName)
        call rea_chcc (LunAux,length,Wx(1))
cmp        call mv0zero (length,length,Wx(1))
        close (LunAux)
c
c          Expand and Set Ww(a",be",b",i) <- Wx(a">=be"|b",i)
        abebi=0
c
        do i=1,no
          do b=1,dimb
          do a=1,dima
          do be=1,a
            abebi=abebi+1
            Ww(a,be,b,i)=Wx(abebi)
            Ww(be,a,b,i)=Wx(abebi)
          end do
          end do
          end do
        end do
c
c
        return
        end
c
c        -------------------
c
        subroutine ReaW3hlp3 (Ww,Wx,dima,dimbe,dimb,no,LunName,LunAux)
c
c        this routine do:
c        reconstruct  Ww(a",be',b,i)  for aSGrp<beSGrp
c        from (be",a"|b,i) records in V3 file LunName
c
        implicit none
        integer dima,dimbe,dimb,no,LunAux
        character*8 LunName
        real*8 Ww(1:dima,1:dimbe,1:dimb,1:no)
        real*8 Wx(*)

c        help variables
c
        integer i,a,be,b,beabi,length
c
c        read block (be",a"|b"_i)
c
        length=dima*dimbe*dimb*no
*       open (unit=LunAux,file=LunName,form='unformatted')
        Call Molcas_BinaryOpen_Vanilla(LunAux,LunName)
        call rea_chcc (LunAux,length,Wx(1))
cmp        call mv0zero (length,length,Wx(1))
        close (LunAux)
c
c          Map Ww(a",be",b",i) <- Wx(be",a"|b"_i)
c
        beabi=0
        do i=1,no
          do b=1,dimb
          do a=1,dima
          do be=1,dimbe
          beabi=beabi+1
            Ww(a,be,b,i)=Wx(beabi)
          end do
          end do
          end do
        end do
c
c
        return
        end
c
c        -------------------
c
        subroutine ReaW4 (W,Wa,aSGrp,bSGrp,cSGrp,dSGrp,LunAux)
c
c        this routine do:
c        Add W(a",b",c",d") <<- (a",b"|c",d") for any a",b",c",d"
c        via reading records W4 (p">=q")>=(r">=s")
c
c        Wa is an auxiliary file
c
c        Structure of records:
c        1) only records for pSGrp>=qSGrp & rSGrp>=sSGrp & pqSGrp>=rsSGrp
c           exists
c        2) in individual records p">=q",r">=s" are stored
c           however p">=q")>=(r">=a") reduction is not yet used
c
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aSGrp,bSGrp,cSGrp,dSGrp,LunAux
        real*8 W(1)
        real*8 Wa(1)
c
c        help variables
        integer abPerm,cdPerm,abcdPerm
        integer abSGrp,cdSGrp,abcdSGrp
        integer abLen,cdLen,abcdLen
        integer dima,dimb,dimc,dimd
        integer pSGrp,qSGrp,rSGrp,sSGrp,dimp,dimq,dimr,dims
        character*10 LunName
        integer i
c
c
c        -------- part I - define basic parameters
c
c1        Def dima,dimb,dimc,dimc
        dima=DimSGrpa(aSGrp)
        dimb=DimSGrpbe(bSGrp)
        dimc=DimSGrpa(cSGrp)
        dimd=DimSGrpbe(dSGrp)
c
c
c        In steps 2.1 - 2.3 also dimp-dims and pSGrp-sSGrp
c2.1        Def abPerm, abSGrp
        if (aSGrp.ge.bSGrp) then
          abPerm=0
          abSGrp=(aSGrp*(aSGrp-1)/2)+bSGrp
          pSGrp=aSGrp
          qSGrp=bSGrp
          dimp=dima
          dimq=dimb
        else
          abPerm=1
          abSGrp=(bSGrp*(bSGrp-1)/2)+aSGrp
          pSGrp=bSGrp
          qSGrp=aSGrp
          dimp=dimb
          dimq=dima
        end if
c
c2.2        Def cdPerm, cdSGrp
        if (cSGrp.ge.dSGrp) then
          cdPerm=0
          cdSGrp=(cSGrp*(cSGrp-1)/2)+dSGrp
          rSGrp=cSGrp
          sSGrp=dSGrp
          dimr=dimc
          dims=dimd
        else
          cdPerm=1
          cdSGrp=(dSGrp*(dSGrp-1)/2)+cSGrp
          rSGrp=dSGrp
          sSGrp=cSGrp
          dimr=dimd
          dims=dimc
        end if
c
c2.3        Def abcdPerm, abcdSGrp
        if (abSGrp.ge.cdSGrp) then
          abcdPerm=0
          abcdSGrp=(abSGrp*(abSGrp-1)/2)+cdSGrp
        else
          abcdPerm=1
          abcdSGrp=(cdSGrp*(cdSGrp-1)/2)+abSGrp
          i=pSGrp
          pSGrp=rSGrp
          rSGrp=i
          i=qSGrp
          qSGrp=sSGrp
          sSGrp=i
          i=dimp
          dimp=dimr
          dimr=i
          i=dimq
          dimq=dims
          dims=i
        end if
c
c
c3.1        Def abLen
        if (aSGrp.eq.bSGrp) then
          abLen=dima*(dima+1)/2
        else
          abLen=dima*dimb
        end if
c
c3.2        Def cdLen
        if (cSGrp.eq.dSGrp) then
          cdLen=dimc*(dimc+1)/2
        else
          cdLen=dimc*dimd
        end if
c
c3.3        Def abcdLen
        abcdLen=abLen*cdLen
c
c
c        -------- part II - read proper integrals (pq|rs) from disc
c
c4        Def proper LunName
        call MkNameV4 (pSGrp,qSGrp,rSGrp,sSGrp,'W4',LunName)
c
c
c5        Read Wa(pqrs) - velka udalost
C       open (unit=LunAux,file=LunName,form='unformatted')
        Call Molcas_BinaryOpen_Vanilla(LunAux,LunName)
        call rea_chcc (LunAux,abcdLen,Wa(1))
        close (LunAux)
c
c
c        -------- part III - Upgrade W(a",b",c",d") from Wx(pqrs)
c        symbolics used: [xy] means xy or yx
c
        if (abcdPerm.eq.0) then
c          case ([ab]|[cd])
c
          if ((abPerm.eq.0).and.(cdPerm.eq.0)) then
c            subcase (ab|cd)
            call DefW4abcd (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else if ((abPerm.eq.0).and.(cdPerm.eq.1)) then
c            subcase (ab|dc)
            call DefW4abdc (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else if ((abPerm.eq.1).and.(cdPerm.eq.0)) then
c            subcase (ba|cd)
            call DefW4bacd (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else
c            subcase (ba|cd)
            call DefW4badc (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          end if
c
        else
c        case ([cd]|[ab])
c
          if ((abPerm.eq.0).and.(cdPerm.eq.0)) then
c            subcase (cd|ab)
            call DefW4cdab (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else if ((abPerm.eq.0).and.(cdPerm.eq.1)) then
c            subcase (cd|ab)
            call DefW4dcab (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else if ((abPerm.eq.1).and.(cdPerm.eq.0)) then
c            subcase (cd|ba)
            call DefW4cdba (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else
c            subcase (dc|ba)
            call DefW4dcba (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          end if
c
        end if
c
c
        return
        end
c
c        -------------------
c
        subroutine DefW4abcd (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (ab|cd)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:abLen,1:cdLen)
c
c        help variables
        integer a,b,c,d,ab,cd
c
        if ((aSGrp.eq.bSGrp).and.(cSGrp.eq.dSGrp)) then
c        case (a=b|c=d)
          do c=2,dimc
          cd=c*(c-1)/2
          do d=1,c-1
          cd=cd+1
            do a=2,dima
            ab=a*(a-1)/2
            do b=1,a-1
            ab=ab+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ab,cd)
              W(b,a,c,d)=W(b,a,c,d)+Wx(ab,cd)
              W(a,b,d,c)=W(a,b,d,c)+Wx(ab,cd)
              W(b,a,d,c)=W(b,a,d,c)+Wx(ab,cd)
            end do
            end do
            do a=1,dima
            ab=a*(a+1)/2
              W(a,a,c,d)=W(a,a,c,d)+Wx(ab,cd)
              W(a,a,d,c)=W(a,a,d,c)+Wx(ab,cd)
            end do
          end do
          end do
c
          do c=1,dimc
          cd=c*(c+1)/2
            do a=2,dima
            ab=a*(a-1)/2
            do b=1,a-1
            ab=ab+1
              W(a,b,c,c)=W(a,b,c,c)+Wx(ab,cd)
              W(b,a,c,c)=W(b,a,c,c)+Wx(ab,cd)
            end do
            end do
            do a=1,dima
            ab=a*(a+1)/2
              W(a,a,c,c)=W(a,a,c,c)+Wx(ab,cd)
            end do
          end do
c
        else if ((aSGrp.eq.bSGrp).and.(cSGrp.ne.dSGrp)) then
c        case (a=b|c,d)
          cd=0
          do d=1,dimd
          do c=1,dimc
          cd=cd+1
            do a=2,dima
            ab=a*(a-1)/2
            do b=1,a-1
            ab=ab+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ab,cd)
              W(b,a,c,d)=W(b,a,c,d)+Wx(ab,cd)
            end do
            end do
            do a=1,dima
            ab=a*(a+1)/2
              W(a,a,c,d)=W(a,a,c,d)+Wx(ab,cd)
            end do
          end do
          end do
c
        else if ((aSGrp.ne.bSGrp).and.(cSGrp.eq.dSGrp)) then
c        case (a,b|c=d)
          do c=2,dimc
          do d=1,c-1
          cd=c*(c-1)/2+d
            ab=0
            do b=1,dimb
            do a=1,dima
            ab=ab+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ab,cd)
              W(a,b,d,c)=W(a,b,d,c)+Wx(ab,cd)
            end do
            end do
          end do
          end do
c
          do c=1,dimc
          cd=c*(c+1)/2
            ab=0
            do b=1,dimb
            do a=1,dima
            ab=ab+1
              W(a,b,c,c)=W(a,b,c,c)+Wx(ab,cd)
            end do
            end do
          end do
c
        else
c        case (a,b|c,d)
          cd=0
          do d=1,dimd
          do c=1,dimc
          cd=cd+1
            ab=0
            do b=1,dimb
            do a=1,dima
            ab=ab+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ab,cd)
            end do
            end do
          end do
          end do
c
        end if
c
c
        return
        end
c
c        ---------------------
c
        subroutine DefW4abdc (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (ab|dc)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:abLen,1:cdLen)
c
c        help variables
        integer a,b,c,d,ab,dc
c
        if (aSGrp.eq.bSGrp) then
c        case (a=b|d,c)
          dc=0
          do c=1,dimc
          do d=1,dimd
          dc=dc+1
            do a=2,dima
            ab=a*(a-1)/2
            do b=1,a-1
            ab=ab+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ab,dc)
              W(b,a,c,d)=W(b,a,c,d)+Wx(ab,dc)
            end do
            end do
            do a=1,dima
            ab=a*(a+1)/2
              W(a,a,c,d)=W(a,a,c,d)+Wx(ab,dc)
            end do
          end do
          end do
c
        else
c        case (a,b|d,c)
          dc=0
          do c=1,dimc
          do d=1,dimd
          dc=dc+1
            ab=0
            do b=1,dimb
            do a=1,dima
            ab=ab+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ab,dc)
            end do
            end do
          end do
          end do
c
        end if
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(cSGrp)
        call Unused_integer(dSGrp)
      end if
        end
c
c        ---------------------
c
        subroutine DefW4bacd (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (ba|cd)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:abLen,1:cdLen)
c
c        help variables
        integer a,b,c,d,ba,cd
c
        if (cSGrp.eq.dSGrp) then
c        case (b,a|c=d)
          do c=2,dimc
          cd=c*(c-1)/2
          do d=1,c-1
          cd=cd+1
            ba=0
            do a=1,dima
            do b=1,dimb
            ba=ba+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ba,cd)
              W(a,b,d,c)=W(a,b,d,c)+Wx(ba,cd)
            end do
            end do
          end do
          end do
c
          do c=1,dimc
          cd=c*(c+1)/2
            ba=0
            do a=1,dima
            do b=1,dimb
            ba=ba+1
              W(a,b,c,c)=W(a,b,c,c)+Wx(ba,cd)
            end do
            end do
          end do
c
        else
c        case (b,a|c,d)
          cd=0
          do d=1,dimd
          do c=1,dimc
          cd=cd+1
            ba=0
            do a=1,dima
            do b=1,dimb
            ba=ba+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ba,cd)
            end do
            end do
          end do
          end do
c
        end if
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(aSGrp)
        call Unused_integer(bSGrp)
      end if
        end
c
c        ---------------------
c
        subroutine DefW4badc (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (ba|dc)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:abLen,1:cdLen)
c
c        help variables
        integer a,b,c,d,ba,dc
c
c        case (b,a|c,d)
          dc=0
          do c=1,dimc
          do d=1,dimd
          dc=dc+1
            ba=0
            do a=1,dima
            do b=1,dimb
            ba=ba+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ba,dc)
            end do
            end do
          end do
          end do
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(aSGrp)
        call Unused_integer(bSGrp)
        call Unused_integer(cSGrp)
        call Unused_integer(dSGrp)
      end if
        end
c
c        ---------------------
c
        subroutine DefW4cdab (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (cd|ab)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:cdLen,1:abLen)
c
c        help variables
        integer a,b,c,d,ab,cd
c
        if ((aSGrp.eq.bSGrp).and.(cSGrp.eq.dSGrp)) then
c        case (c=d|a=b)
          do a=2,dima
          ab=a*(a-1)/2
          do b=1,a-1
          ab=ab+1
            do c=2,dimc
            cd=c*(c-1)/2
            do d=1,c-1
            cd=cd+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(cd,ab)
              W(b,a,c,d)=W(b,a,c,d)+Wx(cd,ab)
              W(a,b,d,c)=W(a,b,d,c)+Wx(cd,ab)
              W(b,a,d,c)=W(b,a,d,c)+Wx(cd,ab)
            end do
            end do
            do c=1,dimc
            cd=c*(c+1)/2
              W(a,b,c,c)=W(a,b,c,c)+Wx(cd,ab)
              W(b,a,c,c)=W(b,a,c,c)+Wx(cd,ab)
            end do
          end do
          end do
c
          do a=1,dima
          ab=a*(a+1)/2
            do c=2,dimc
            cd=c*(c-1)/2
            do d=1,c-1
            cd=cd+1
              W(a,a,c,d)=W(a,a,c,d)+Wx(cd,ab)
              W(a,a,d,c)=W(a,a,d,c)+Wx(cd,ab)
            end do
            end do
            do c=1,dimc
            cd=c*(c+1)/2
              W(a,a,c,c)=W(a,a,c,c)+Wx(cd,ab)
            end do
          end do
c
        else if ((aSGrp.eq.bSGrp).and.(cSGrp.ne.dSGrp)) then
c        case (c,d|a=b)
          do a=2,dima
          ab=a*(a-1)/2
          do b=1,a-1
          ab=ab+1
            cd=0
            do d=1,dimd
            do c=1,dimc
            cd=cd+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(cd,ab)
              W(b,a,c,d)=W(b,a,c,d)+Wx(cd,ab)
            end do
            end do
          end do
          end do
c
          do a=1,dima
          ab=a*(a+1)/2
            cd=0
            do d=1,dimd
            do c=1,dimc
            cd=cd+1
              W(a,a,c,d)=W(a,a,c,d)+Wx(cd,ab)
            end do
            end do
          end do
c
        else if ((aSGrp.ne.bSGrp).and.(cSGrp.eq.dSGrp)) then
c        case (c=d|a,b)
          ab=0
          do b=1,dimb
          do a=1,dima
          ab=ab+1
            do c=2,dimc
            cd=c*(c-1)/2
            do d=1,c-1
            cd=cd+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(cd,ab)
              W(a,b,d,c)=W(a,b,d,c)+Wx(cd,ab)
            end do
            end do
            do c=1,dimc
            cd=c*(c+1)/2
              W(a,b,c,c)=W(a,b,c,c)+Wx(cd,ab)
            end do
          end do
          end do
c
        else
c        case (c,d|a,b)
          ab=0
          do b=1,dimb
          do a=1,dima
          ab=ab+1
            cd=0
            do d=1,dimd
            do c=1,dimc
            cd=cd+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(cd,ab)
            end do
            end do
          end do
          end do
c
        end if
c
c
        return
        end
c
c        ---------------------
c
        subroutine DefW4dcab (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (dc|ab)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:cdLen,1:abLen)
c
c        help variables
        integer a,b,c,d,ab,dc
c
        if (aSGrp.eq.bSGrp) then
c        case (d,c|a=b)
          do a=2,dima
          ab=a*(a-1)/2
          do b=1,a-1
          ab=ab+1
            dc=0
            do c=1,dimc
            do d=1,dimd
            dc=dc+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(dc,ab)
              W(b,a,c,d)=W(b,a,c,d)+Wx(dc,ab)
            end do
            end do
          end do
          end do
c
          do a=1,dima
          ab=a*(a+1)/2
            dc=0
            do c=1,dimc
            do d=1,dimd
            dc=dc+1
              W(a,a,c,d)=W(a,a,c,d)+Wx(dc,ab)
            end do
            end do
          end do
c
        else
c        case (d,c|a,b)
          ab=0
          do b=1,dimb
          do a=1,dima
          ab=ab+1
            dc=0
            do c=1,dimc
            do d=1,dimd
            dc=dc+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(dc,ab)
            end do
            end do
          end do
          end do
c
        end if
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(cSGrp)
        call Unused_integer(dSGrp)
      end if
        end
c
c        -------------------
c
        subroutine DefW4cdba (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (cd|ba)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:cdLen,1:abLen)
c
c        help variables
        integer a,b,c,d,ba,cd
c
        if (cSGrp.eq.dSGrp) then
c        case (c=d|b,a)
          ba=0
          do a=1,dima
          do b=1,dimb
          ba=ba+1
            do c=2,dimc
            cd=c*(c-1)/2
            do d=1,c-1
            cd=cd+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(cd,ba)
              W(a,b,d,c)=W(a,b,d,c)+Wx(cd,ba)
            end do
            end do
            do c=1,dimc
            cd=c*(c+1)/2
              W(a,b,c,c)=W(a,b,c,c)+Wx(cd,ba)
            end do
          end do
          end do
c
        else
c        case (c,d|b,a)
          ba=0
          do a=1,dima
          do b=1,dimb
          ba=ba+1
            cd=0
            do d=1,dimd
            do c=1,dimc
            cd=cd+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(cd,ba)
            end do
            end do
          end do
          end do
c
        end if
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(aSGrp)
        call Unused_integer(bSGrp)
      end if
        end
c
c        -------------------
c
        subroutine DefW4dcba (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (dc|ba)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:cdLen,1:abLen)
c
c        help variables
        integer a,b,c,d,ba,dc
c
c        case (c,d|b,a)
          ba=0
          do a=1,dima
          do b=1,dimb
          ba=ba+1
            dc=0
            do c=1,dimc
            do d=1,dimd
            dc=dc+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(dc,ba)
            end do
            end do
          end do
          end do
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(aSGrp)
        call Unused_integer(bSGrp)
        call Unused_integer(cSGrp)
        call Unused_integer(dSGrp)
      end if
        end
c
c        -------------------
c
        subroutine MkNameV4 (i,j,k,l,Schem,Nomen)
c
c       help routine to ReaW4, producing name of V4file
c       ex: Schem='XY', i=1, j=3, k=5, l=07 ->  Nomen='XY01030507'
c
        implicit none
        integer i,j,k,l
        character*2 Schem
        character*10 Nomen
c
c       help variables
        character*1 Chr(1:10)
        character*2 digit(1:64)
        character*2 ichr,jchr,kchr,lchr
        character*2 baza
        character*10 meno
c
        equivalence (Chr(1),meno)
        equivalence (Chr(1),baza)
        equivalence (Chr(3),ichr)
        equivalence (Chr(5),jchr)
        equivalence (Chr(7),kchr)
        equivalence (Chr(9),lchr)
c
c
c        quite a porno this piece
        digit(1)='01'
        digit(2)='02'
        digit(3)='03'
        digit(4)='04'
        digit(5)='05'
        digit(6)='06'
        digit(7)='07'
        digit(8)='08'
        digit(9)='09'
        digit(10)='10'
        digit(11)='11'
        digit(12)='12'
        digit(13)='13'
        digit(14)='14'
        digit(15)='15'
        digit(16)='16'
        digit(17)='17'
        digit(18)='18'
        digit(19)='19'
        digit(20)='20'
        digit(21)='21'
        digit(22)='22'
        digit(23)='23'
        digit(24)='24'
        digit(25)='25'
        digit(26)='26'
        digit(27)='27'
        digit(28)='28'
        digit(29)='29'
        digit(30)='30'
        digit(31)='31'
        digit(32)='32'
        digit(33)='33'
        digit(34)='34'
        digit(35)='35'
        digit(36)='36'
        digit(37)='37'
        digit(38)='38'
        digit(39)='39'
        digit(40)='40'
        digit(41)='41'
        digit(42)='42'
        digit(43)='43'
        digit(44)='44'
        digit(45)='45'
        digit(46)='46'
        digit(47)='47'
        digit(48)='48'
        digit(49)='49'
        digit(50)='50'
        digit(51)='51'
        digit(52)='52'
        digit(53)='53'
        digit(54)='54'
        digit(55)='55'
        digit(56)='56'
        digit(57)='57'
        digit(58)='58'
        digit(59)='59'
        digit(60)='60'
        digit(61)='61'
        digit(62)='62'
        digit(63)='63'
        digit(64)='64'
c
c
        baza=Schem
        ichr=digit(i)
        jchr=digit(j)
        kchr=digit(k)
        lchr=digit(l)
        Nomen=meno
c
        return
        end
c
c       ------------------------------------
c
c
        subroutine Xo2v4ctl (NvGrp,NvSGrp,LunAux)
c
c!      drajver procesu na testovanie ktory W3/W4 file
c        treba na ktorom node
c        N.B. upraveny drajver o2v4 procesu
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "chcc_parcc.fh"
#include "para_info.fh"
c
        integer NvGrp,NvSGrp,LunAux
c
c        help variables
        integer NaGrp,NbeGrp,NaSGrp,NbeSgrp
        integer mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
c##
        integer aGrp,bGrp,proc,i,j
        integer nJobs,addJobs,actJobs
c
c
c1      Inicializacia premennych (Predbezna)
c
        NaGrp=NvGrp
        NbeGrp=NvGrp
        NaSGrp=NvSGrp
        nbeSGrp=NvSGrp
c
c
c2      define all groups and ssungroup parameters
c
        call DefParo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c                   mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
c
c3        distribute work among nodes (def ABID)
c
        do proc=0,(nProcs-1)
        do aGrp=1,NaGrp
        do bGrp=1,NaGrp
          ABID(proc,aGrp,bGrp)=0
        end do
        end do
        end do
c
c
        if ((nProcs.eq.1).or.(NaGrp.eq.1)) then
c3.1        nP = <1>
c        all jobs to one node
c
          do aGrp=1,NaGrp
          do bGrp=1,NaGrp
            ABID(0,aGrp,bGrp)=1
          end do
          end do
c
c
        else
c3.2        nP = <2, inf)
c        N.B. cele zatial trochu odflaknute, lebo sa neberie do uvahy,
c        ze pre half joby je lepsie ked nadvazuju na plne joby s
c        rovnakymi indexami
c
c3.2.1        Full Jobs
c
          i=(NaGrp*(NaGrp-1))/2
          nJobs=int(i/nProcs)
          addJobs=mod(i,nProcs)
c
c          first nodes: 0-addJobs
c             will have int(N'(N'-1)/2 /nProc)+1 Full Jobs
c          rest nodes: addJobs-nProcs-1
c               will have int(N'(N'-1)/2 /nProc)
c
          proc=0
          actJobs=nJobs
          do aGrp=2,NaGrp
          do bGrp=1,aGrp-1
            ABID(proc,aGrp,bGrp)=1
            actJobs=actJobs-1
            if (actJobs.eq.-1) then
              proc=proc+1
              actJobs=nJobs
            else if (actJobs.eq.0) then
              if (addJobs.gt.0) then
                addJobs=addJobs-1
              else
                proc=proc+1
                actJobs=nJobs
              end if
            end if
          end do
          end do
c
c
c3.2.2        Half Jobs
c
c        distribution of Half Jobs
c          - first distribution - addjobs-nProcs-1
c          - second distribution - addjobs-nProcs-1
c          - other distributions - 0 - nProcs-1
c
          addJobs=mod(i,nProcs)
          proc=addJobs
          j=0
c
          do aGrp=1,NaGrp
            ABID(proc,aGrp,aGrp)=1
            proc=proc+1
            if (proc.eq.nProcs) then
              if (j.eq.0) then
c              first distribution - addjobs-nProcs-1
                proc=addJobs
                j=1
              else if (j.eq.1) then
c              second distribution - addjobs-nProcs-1
                proc=addJobs
                j=2
              else
c              other distributions - 0 - nProcs-1
                proc=0
              end if
            end if
          end do
c
        end if
c
c
c        Printing ABID
        do proc=0,nProcs-1
        if (printkey.ge.10) then
        write (6,*)   ' For myRank = ',proc
        end if
          do aGrp=1,NaGrp
          do bGrp=1,aGrp
          if (ABID(proc,aGrp,bGrp).eq.1) then
          if (printkey.ge.10) then
          write (6,*) '    aGrp,bGrp ',aGrp,bGrp
          end if
          end if
          end do
          end do
        end do
c
c
c
c4      A ideme na to
c
        call InsReqo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c             mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
c
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_integer(LunAux)
        end
c
c       -------------------
c
        subroutine InsReqo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c                   mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
c
c       this routine do:
c        Inspect W3 and W4 files requirements of o2v4 procedure
c        on this node. It checks which of the W3 and W4 files
c        are used on this node
c
        implicit none
#include "chcc1.fh"
#include "chcc_parcc.fh"
#include "para_info.fh"
#include "o2v4.fh"
c
        integer NaGrp,NbeGrp,NaSGrp,NbeSgrp
        integer mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
c
c        help variables
c
        integer aGrp,bGrp,gaGrp,beGrp,aSGrp,bSGrp,gaSGrp,beSGrp
        integer dima,dimb,adda,addb
        integer dimbe,dimga,addbe,addga,addbepp,addgapp
        integer bSGrpUp,gaSGrpUp
        integer LenW3,LenW4
        integer i,j,NSGrp
c
c
c*        Initial Set InqW3,InqW4 = F
        NSGrp=NaGrp*NaSGrp
        do i=1,(NSGrp*(NSGrp+1))/2
          do j=1,NSGrp
          InqW3(i,j)=.False.
          end do
          do j=1,(NSGrp*(NSGrp+1))/2
          InqW4(i,j)=.False.
          end do
        end do
        LenW3=0
        LenW4=0
c
c
c*      cycle over all groups of (a>=b)
        adda=0
        do aGrp=1,naGrp
        dima=DimGrpa(aGrp)
c
c##        test, if on this node atleast one combination with this
c        aGrp is scheduled. Skip if no
        i=0
        do j=1,NaGrp
          i=i+ABID(myRank,aGrp,j)
        end do
        if (i.eq.0) goto 12
c
c
        addb=0
        do bGrp=1,aGrp
        dimb=DimGrpa(bGrp)
c
c##     test, if this a'b' combination is planed to be run on this node
        if (ABID(myRank,aGrp,bGrp).eq.0) goto 11
c
c
cx        cycle over all groups of (be>=ga)
          addbe=0
          do beGrp=1,nbeGrp
          dimbe=DimGrpbe(beGrp)
          addga=0
          do gaGrp=1,beGrp
          dimga=DimGrpbe(gaGrp)
c
c
cxx         cycle over all subgroups of (be>=ga)'
            addbepp=addbe
            do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)
c
            if (beGrp.eq.gaGrp) then
              gaSGrpUp=beSGrp
            else
              gaSGrpUp=GrpbeUp(gaGrp)
            end if
c
            addgapp=addga
            do gaSGrp=GrpbeLow(gaGrp),gaSGrpUp
c
c
cxxx          cycle over all subgroups of (a>=b)'
              do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
              if (aGrp.eq.bGrp) then
                bSGrpUp=aSGrp
              else
                bSGrpUp=GrpaUp(bGrp)
              end if
              do bSGrp=GrpaLow(bGrp),bSGrpUp
c
c
c*              clasical reading or generating of (VV|VV) integrals
c
cxxxx                term W1(a",be",b",ga") <- -(b"ga"|a"i) . T1(i,be")
cxxxx1          Get Ww(b",ga",a",i) (Wx used as Aux)
                call InsReaW3 (bSGrp,gaSGrp,aSGrp,LenW3)
c
cxxxx           Upgrade W1(a",be",b",ga") <<- (a",be"|b",ga")
                call InsReaW4 (aSGrp,beSGrp,bSGrp,gaSGrp,LenW4)
c
c
                if (aSGrp.ne.bSGrp) then
cxxxx                  term W2(b",be",a",ga") <- -(a"ga"|b"i) . T1(i,ga")
cxxxx1            Get Ww(a",ga",b",i) (Wx used as Aux)
                  call InsReaW3 (aSGrp,gaSGrp,bSGrp,LenW3)
c
cxxxx                  term W2(b",be",a",ga") <<- -(b"be"|a"i) . T1(i,ga")
cxxxx1            Get Ww(b",be",a",i) (Wx used as Aux)
                  call InsReaW3 (bSGrp,beSGrp,aSGrp,LenW3)
c
cxxxx             Add W2(b",be",a",ga") <<- (b",be"Ia",ga")
c                  Upgrade:W2, destroy:Ww
                  call InsReaW4 (bSGrp,beSGrp,aSGrp,gaSGrp,LenW4)
                end if
c
c
c
cxxx          end cycle over all subgroups of (a>=b)'
              end do
              end do
c
cxx         end cycle over all subgroups of (be>=ga)'
            addgapp=addgapp+DimSGrpbe(gaSGrp)
            end do
            addbepp=addbepp+DimSGrpbe(beSGrp)
            end do
c
cx        end cycle over all groups of (be>=ga)
          addga=addga+dimga
          end do
          addbe=addbe+dimbe
          end do
c
c*      end cycle over all groups of (a>=b)
11        addb=addb+dimb
        end do
12        adda=adda+dima
        end do
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(NbeSgrp)
        call Unused_integer(mdGrpa)
        call Unused_integer(mdGrpbe)
        call Unused_integer(mdSGrpa)
        call Unused_integer(mdSGrpbe)
      end if
        end
c
c        -------------------------
c
        subroutine InsReaW3 (aSGrp,beSGrp,bSGrp,length)
c
c        this routine do:
c        Check which W3 file corresponds to given combination
c        of indexes,
c        - increase the parameter, checking the overal number of
c        required integrals if these block is conted first time
c        - and set corresponding InqW3 to T
c
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "chcc_parcc.fh"
c
        integer aSGrp,beSGrp,bSGrp,length
c
c        help variables
c
        integer dima,dimb,dimbe
        integer abeSGrp
c
c
c0        def dimensions
c
        dima=DimSGrpa(aSGrp)
        dimb=DimSGrpa(bSGrp)
        dimbe=DimSGrpbe(beSGrp)
c
        if (aSGrp.gt.beSGrp) then
c1        case aSGrp>beSGrp, integrals (a",be"|b",i) to be read
          abeSGrp=(aSGrp*(aSGrp-1)/2)+beSGrp
          if (InqW3(abeSGrp,bSGrp).eqv..False.) then
            InqW3(abeSGrp,bSGrp)=.True.
            length=length+dima*dimbe*dimb*no
          end if
c
        else if (aSGrp.eq.beSGrp) then
c2        case aSGrp=beSGrp, integrals (a">=be"|b",i)to be read and expand
          abeSGrp=(aSGrp*(aSGrp-1)/2)+beSGrp
          if (InqW3(abeSGrp,bSGrp).eqv..False.) then
            InqW3(abeSGrp,bSGrp)=.True.
            length=length+(no*dima*(dima+1)*dimb)/2
          end if
c
        else
c3        case aSGrp<beSGrp, integrals (be",a"|b",i) to be read and mapped
          abeSGrp=(beSGrp*(beSGrp-1)/2)+aSGrp
          if (InqW3(abeSGrp,bSGrp).eqv..False.) then
            InqW3(abeSGrp,bSGrp)=.True.
            length=length+dima*dimbe*dimb*no
          end if
        end if
c
        return
        end
c
c        -------------------
c
        subroutine InsReaW4 (aSGrp,bSGrp,cSGrp,dSGrp,length)
c
c        this routine do:
c        Check which W4 file corresponds to given combination
c        of indexes,
c        - increase the parameter, checking the overal number of
c        required integrals if these block is conted first time
c        - and set corresponding InqW4 to T
c
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "chcc_parcc.fh"
c
        integer aSGrp,bSGrp,cSGrp,dSGrp,length
c
c        help variables
        integer abPerm,cdPerm,abcdPerm
        integer abSGrp,cdSGrp,abcdSGrp
        integer abLen,cdLen,abcdLen
        integer dima,dimb,dimc,dimd
        integer pSGrp,qSGrp,rSGrp,sSGrp,dimp,dimq,dimr,dims
        integer pqSGrp,rsSGrp
        integer i
c
c
c        -------- part I - define basic parameters
c
c1        Def dima,dimb,dimc,dimc
        dima=DimSGrpa(aSGrp)
        dimb=DimSGrpbe(bSGrp)
        dimc=DimSGrpa(cSGrp)
        dimd=DimSGrpbe(dSGrp)
c
c
c        In steps 2.1 - 2.3 also dimp-dims and pSGrp-sSGrp
c2.1        Def abPerm, abSGrp
        if (aSGrp.ge.bSGrp) then
          abPerm=0
          abSGrp=(aSGrp*(aSGrp-1)/2)+bSGrp
          pSGrp=aSGrp
          qSGrp=bSGrp
          dimp=dima
          dimq=dimb
        else
          abPerm=1
          abSGrp=(bSGrp*(bSGrp-1)/2)+aSGrp
          pSGrp=bSGrp
          qSGrp=aSGrp
          dimp=dimb
          dimq=dima
        end if
c
c2.2        Def cdPerm, cdSGrp
        if (cSGrp.ge.dSGrp) then
          cdPerm=0
          cdSGrp=(cSGrp*(cSGrp-1)/2)+dSGrp
          rSGrp=cSGrp
          sSGrp=dSGrp
          dimr=dimc
          dims=dimd
        else
          cdPerm=1
          cdSGrp=(dSGrp*(dSGrp-1)/2)+cSGrp
          rSGrp=dSGrp
          sSGrp=cSGrp
          dimr=dimd
          dims=dimc
        end if
c
c2.3        Def abcdPerm, abcdSGrp
        if (abSGrp.ge.cdSGrp) then
          abcdPerm=0
          abcdSGrp=(abSGrp*(abSGrp-1)/2)+cdSGrp
        else
          abcdPerm=1
          abcdSGrp=(cdSGrp*(cdSGrp-1)/2)+abSGrp
          i=pSGrp
          pSGrp=rSGrp
          rSGrp=i
          i=qSGrp
          qSGrp=sSGrp
          sSGrp=i
          i=dimp
          dimp=dimr
          dimr=i
          i=dimq
          dimq=dims
          dims=i
        end if
c
c
c3.1        Def abLen
        if (aSGrp.eq.bSGrp) then
          abLen=dima*(dima+1)/2
        else
          abLen=dima*dimb
        end if
c
c3.2        Def cdLen
        if (cSGrp.eq.dSGrp) then
          cdLen=dimc*(dimc+1)/2
        else
          cdLen=dimc*dimd
        end if
c
c3.3        Def abcdLen
        abcdLen=abLen*cdLen
c
c
c        -------- part II - read proper integrals (pq|rs) from disc
c
        pqSGrp=(pSGrp*(pSGrp-1)/2)+qSGrp
        rsSGrp=(rSGrp*(rSGrp-1)/2)+sSGrp
c
        if (InqW4(pqSGrp,rsSGrp).eqv..False.) then
          InqW4(pqSGrp,rsSGrp)=.True.
          length=length+abcdLen
        end if
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Sebastian Wouters                                *
!***********************************************************************
! Subroutine to write FCIDUMP file
! Written by Sebastian Wouters, Leuven, Aug 2016

subroutine FCIDUMP_OUTPUT(NACT,NELEC,TWOMS,ISYM,ORBSYM,ECONST,OEI,TEI,LINSIZE,NUM_TEI)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NACT, NELEC, TWOMS, ISYM, ORBSYM(NACT), LINSIZE, NUM_TEI
real(kind=wp), intent(in) :: ECONST, OEI(LINSIZE), TEI(NUM_TEI)
integer(kind=iwp) :: i, j, k, l, ij, kl, ijkl, writeout
integer(kind=iwp), external :: isFreeUnit

writeout = isfreeunit(28)
!open(unit=writeout,file='FCIDUMP_CHEMPS2',action='write',status='replace')
call molcas_open(writeout,'FCIDUMP_CHEMPS2')
write(writeout,'(a11,i3,a7,i3,a5,i2,a1)') ' &FCI NORB=',NACT,',NELEC=',NELEC,',MS2=',TWOMS,','
write(writeout,'(a9)',advance='NO') '  ORBSYM='
do i=1,NACT
  write(writeout,'(i1,a1)',advance='NO') ORBSYM(i),','
end do
write(writeout,*)
write(writeout,'(a7,i1,a1)') '  ISYM=',ISYM,','
write(writeout,'(a2)') ' /'

do i=1,NACT
  do j=1,i
    ij = ((i-1)*i)/2+(j-1)
    do k=1,NACT
      do l=1,k
        kl = ((k-1)*k)/2+(l-1)
        if (kl <= ij) then
          ijkl = 1+(ij*(ij+1))/2+kl
          if (abs(TEI(ijkl)) >= 1.0e-16_wp) then
            write(writeout,'(1x,es23.16e2,i4,i4,i4,i4)') TEI(ijkl),i,j,k,l
          end if
        end if
      end do
    end do
  end do
end do

do i=1,NACT
  do j=1,i
    ij = 1+((i-1)*i)/2+(j-1)
    if (abs(OEI(ij)) >= 1.0e-16_wp) then
      write(writeout,'(1x,es23.16e2,i4,i4,i4,i4)') OEI(ij),i,j,0,0
    end if
  end do
end do

write(writeout,'(1x,es23.16e2,i4,i4,i4,i4)') ECONST,0,0,0,0

close(writeout)

return

end subroutine FCIDUMP_OUTPUT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c  ********************************************************
c  ** Public-domain library routines used by casvb only. **
c  ********************************************************
c  **********************
c  ** EISPACK ROUTINES **
c  **********************
      subroutine casvb_tql2(nm,n,d,e,z,ierr)
c
      integer i,j,k,l,m,n,ii,l1,l2,nm,mml,ierr
      real*8 d(n),e(n),z(nm,n)
      real*8 c,c2,c3,dl1,el1,f,g,h,p,r,s,s2,tst1,tst2,casvb_pythag
c
c     this subroutine is a translation of the algol procedure tql2,
c     num. math. 11, 293-306(1968) by bowdler, martin, reinsch, and
c     wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 227-240(1971).
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a symmetric tridiagonal matrix by the ql method.
c     the eigenvectors of a full symmetric matrix can also
c     be found if  tred2  has been used to reduce this
c     full matrix to tridiagonal form.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        d contains the diagonal elements of the input matrix.
c
c        e contains the subdiagonal elements of the input matrix
c          in its last n-1 positions.  e(1) is arbitrary.
c
c        z contains the transformation matrix produced in the
c          reduction by  tred2, if performed.  if the eigenvectors
c          of the tridiagonal matrix are desired, z must contain
c          the identity matrix.
c
c      on output
c
c        d contains the eigenvalues in ascending order.  if an
c          error exit is made, the eigenvalues are correct but
c          unordered for indices 1,2,...,ierr-1.
c
c        e has been destroyed.
c
c        z contains orthonormal eigenvectors of the symmetric
c          tridiagonal (or full) matrix.  if an error exit is made,
c          z contains the eigenvectors associated with the stored
c          eigenvalues.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the j-th eigenvalue has not been
c                     determined after 30 iterations.
c
c     calls pythag for  sqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      c3 = 0.0d0 ! dummy initialize
      s2 = 0.0d0 ! dummy initialize
      if (n .eq. 1) go to 1001
c
      do 100 i = 2, n
      e(i-1) = e(i)
  100 continue
c
      f = 0.0d0
      tst1 = 0.0d0
      e(n) = 0.0d0
c
      do 240 l = 1, n
         j = 0
         h = abs(d(l)) + abs(e(l))
         if (tst1 .lt. h) tst1 = h
c     .......... look for small sub-diagonal element ..........
         do 110 m = l, n
            tst2 = tst1 + abs(e(m))
            if (tst2 .eq. tst1) go to 120
c     .......... e(n) is always zero, so there is no exit
c                through the bottom of the loop ..........
  110    continue
c
  120    if (m .eq. l) go to 220
  130    if (j .eq. 30) go to 1000
         j = j + 1
c     .......... form shift ..........
         l1 = l + 1
         l2 = l1 + 1
         g = d(l)
         p = (d(l1) - g) / (2.0d0 * e(l))
         r = casvb_pythag(p,1.0d0)
         d(l) = e(l) / (p + sign(r,p))
         d(l1) = e(l) * (p + sign(r,p))
         dl1 = d(l1)
         h = g - d(l)
         if (l2 .gt. n) go to 145
c
         do 140 i = l2, n
         d(i) = d(i) - h
  140    continue
c
  145    f = f + h
c     .......... ql transformation ..........
         p = d(m)
         c = 1.0d0
         c2 = c
         el1 = e(l1)
         s = 0.0d0
         mml = m - l
c     .......... for i=m-1 step -1 until l do -- ..........
         do 200 ii = 1, mml
            c3 = c2
            c2 = c
            s2 = s
            i = m - ii
            g = c * e(i)
            h = c * p
            r = casvb_pythag(p,e(i))
            e(i+1) = s * r
            s = e(i) / r
            c = p / r
            p = c * d(i) - s * g
            d(i+1) = h + s * (c * g + s * d(i))
c     .......... form vector ..........
            do 180 k = 1, n
               h = z(k,i+1)
               z(k,i+1) = s * z(k,i) + c * h
               z(k,i) = c * z(k,i) - s * h
  180       continue
c
  200    continue
c
         p = -s * s2 * c3 * el1 * e(l) / dl1
         e(l) = s * p
         d(l) = c * p
         tst2 = tst1 + abs(e(l))
         if (tst2 .gt. tst1) go to 130
  220    d(l) = d(l) + f
  240 continue
c     .......... order eigenvalues and eigenvectors ..........
      do 300 ii = 2, n
         i = ii - 1
         k = i
         p = d(i)
c
         do 260 j = ii, n
            if (d(j) .ge. p) go to 260
            k = j
            p = d(j)
  260    continue
c
         if (k .eq. i) go to 300
         d(k) = d(i)
         d(i) = p
c
         do 280 j = 1, n
            p = z(j,i)
            z(j,i) = z(j,k)
            z(j,k) = p
  280    continue
c
  300 continue
c
      go to 1001
c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........
 1000 ierr = l
 1001 return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine defvhlp7(r1,v,dimr1a,dimr1bc,dimva,dimvb,dimvc,adda)
! this routine does
! V(a,b,c)abb = R1(a,bc)
! for symb==symc
!
! r1      - r1 matrix (I)
! v       - v matrix (O)
! dimr1a  - dimension of a in R1 (I)
! dimr1bc - dimension of bc in R1 (I)
! dimva   - dimension of a in V (I)
! dimvb   - dimension of b in V (I)
! dimvc   - dimension of c in V (I)
! adda    - additional constant to a (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimr1a, dimr1bc, dimva, dimvb, dimvc, adda
real(kind=wp), intent(in) :: r1(dimr1a,dimr1bc)
real(kind=wp), intent(out) :: v(dimva,dimvb,dimvc)
integer(kind=iwp) :: b, bcr1, c

do c=1,dimvc
  do b=1,dimvb
    !bcr1 = indab(b,c)
    if (b >= c) then
      bcr1 = b*(b-1)/2+c
    else
      bcr1 = c*(c-1)/2+b
    end if
    v(:,b,c) = r1(adda+1:adda+dimva,bcr1)
  end do
end do

return

end subroutine defvhlp7

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ORDINT(IINST,IOUTST,NELMNT,INO)
! ORDER A STRING OF INTEGERS TO ASCENDING ORDER
!
! IINST : INPUT STRING
! IOUTST : OUTPUT STRING
! NELMNT : NUMBER OF INTEGERS
! INO : Mapping array from new to old order
!
! THIS CODE CONTAINS THE OLD ORDER CODE OF JOE GOLAB
! (HE IS HEREBY ACKNOWLEDGED, AND I AM EXCUSED)

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NELMNT, IINST(NELMNT)
integer(kind=iwp), intent(out) :: IOUTST(NELMNT), INO(NELMNT)
integer(kind=iwp) :: I, ISWAP, JOE

if (NELMNT /= 0) then
  IOUTST(:) = IINST(:)
  INO(:) = [(I,I=1,NELMNT)]

  ! BEGIN TO ORDER

  JOE = 1
  I = JOE
  do
    if (I == NELMNT) exit
    if (IOUTST(I) <= IOUTST(I+1)) then
      I = I+1
      cycle
    end if
    JOE = I+1
    do
      ISWAP = IOUTST(I)
      IOUTST(I) = IOUTST(I+1)
      IOUTST(I+1) = ISWAP
      ISWAP = INO(I)
      INO(I) = INO(I+1)
      INO(I+1) = ISWAP
      if (I == 1) exit
      I = I-1
      if (IOUTST(I) <= IOUTST(I+1)) exit
    end do
    I = JOE
  end do

  ! END ORDER
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Result from ORDINT'
write(u6,*)
write(u6,*) ' Input string'
call IWRTMA(IINST,1,NELMNT,1,NELMNT)
write(u6,*) ' Ordered string'
call IWRTMA(IOUTST,1,NELMNT,1,NELMNT)
write(u6,*) ' New to old order'
call IWRTMA(INO,1,NELMNT,1,NELMNT)
#endif

end subroutine ORDINT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine MODens(Dens,Ovlp,nDO,NumD,CMO,nCMO,nD)
************************************************************************
*                                                                      *
*     purpose: Compute density matrix in molecular orbital basis       *
*                                                                      *
*     input:                                                           *
*       Dens    : density matrix differences in AO basis (nDO,NumD)    *
*       Ovlp    : overlap in AO basis of length of length nDO          *
*       CMO     : molecular orbitals coefficients of length nCMO       *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 Dens(nDO,nD,NumD),Ovlp(nDO),CMO(nCMO,nD)
      Real*8, Dimension(:), Allocatable:: DnsS, OvlS, DMoO, Aux1, Aux2
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Call Timing(Cpu1,Tim1,Tim2,Tim3)
*
*---- Allocate memory for squared density matrix
      Call mma_allocate(DnsS,MaxBas**2,Label='DnsS')
*
*---- Allocate memory for squared overlap matrix
      Call mma_allocate(OvlS,MaxBas**2,Label='OvlS')
*
*---- Allocate memory for density matrix in MO basis
      Call mma_allocate(DMoO,MaxOrb*(MaxOrb+1)/2,Label='DMoO')
*
*---- Allocate memory for auxiliary matrix
      Call mma_allocate(Aux1,MaxBxO,Label='Aux1')
*
*---- Allocate memory for auxiliary matrix
      Call mma_allocate(Aux2,MaxBxO,Label='Aux2')
*
*
      DMOMax = Zero
      Do jD = 1, nD
*
#ifdef _DEBUGPRINT_
         Call NrmClc(Dens(1,jD,nDens),nBT,'MoDens','D in AO   ')
         Call NrmClc(Ovlp         ,nBT,'MoDens','Overlap   ')
         Call NrmClc(CMO(1,jD)    ,nBO,'MoDens','CMOs      ')
         Write (6,*) 'nOcc=',(nOcc(i,jD),i=1,nSym)
C        Write (6,'(F16.8)') DXot(MaxBxO,CMO(1,jD),1,CMO(1,jD),1)
#endif
         it   = 1
         id   = 1
         iOvl = 1
         Do iSym = 1, nSym
*
            iiBB = nBas(iSym)*nBas(iSym)
            iiBO = nBas(iSym)*nOrb(iSym)
            iiBT = nBas(iSym)*(nBas(iSym) + 1)/2
*
            If (nOcc(iSym,jD).gt.0.or.(Teee.and.nBas(iSym).gt.0)) Then
               Call DSq(Dens(id,jD,nDens),DnsS,1,nBas(iSym),nBas(iSym))
               Call Square(Ovlp(iOvl),OvlS,1,nBas(iSym),nBas(iSym))
*
               Call DGEMM_('N','N',
     &                     nBas(iSym),nOrb(iSym),nBas(iSym),
     &                     1.0d0,OvlS,nBas(iSym),
     &                           CMO(it,jD),nBas(iSym),
     &                     0.0d0,Aux1,nBas(iSym))
               Call DGEMM_('N','N',
     &                     nBas(iSym),nOrb(iSym),nBas(iSym),
     &                     1.0d0,DnsS,nBas(iSym),
     &                           Aux1,nBas(iSym),
     &                     0.0d0,Aux2,nBas(iSym))
               Call DGEMM_('N','N',
     &                     nBas(iSym),nOrb(iSym),nBas(iSym),
     &                     1.0d0,OvlS,nBas(iSym),
     &                           Aux2,nBas(iSym),
     &                     0.0d0,Aux1,nBas(iSym))
               Call   MxMt(CMO(it,jD),     nBas(iSym),1,
     &                     Aux1,1,nBas(iSym),
     &                     DMoO,
     &                     nOrb(iSym),nBas(iSym))
*
*              Call TriPrt('D(mo)','(8F12.6)',DMoO,nOrb(iSym))
               Do i = nOcc(iSym,jD)+1 , nOrb(iSym)
                  Do j = 1, nOcc(iSym,jD)
                     DMOMax = Max(DMOMax,
     &                        DBLE(nD)*Abs(DMoO(i*(i-1)/2+j)))
                  End Do
               End Do
            End If
*
            it   = it   + iiBO
            id   = id   + iiBT
            iOvl = iOvl + iiBT
         End Do
*
      End Do
*
*---- Deallocate memory
      Call mma_deallocate(Aux2)
      Call mma_deallocate(Aux1)
      Call mma_deallocate(DMoO)
      Call mma_deallocate(OvlS)
      Call mma_deallocate(DnsS)
*
#ifdef _DEBUGPRINT_
      Write(6,*)' DMOMax in MODens',DMOMax
#endif
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld(14) = TimFld(14) + (Cpu2 - Cpu1)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine arrange_orbital()
!****************************************************
!  arrange orbital for ci calculation, in meld and
!  molcas program, the orbitals are arranged as the symmetry
!  block. we transfer them to ci order
! -----
! map_order_orbital    ab ---> ci

use gugaci_global, only: jp2, jp3, logic_assign_actorb, lsm_inn, map_orb_order, max_orb, ng_sm, nlsm_all, norb_all, norb_inn, &
                         norb_number !, norb_dz
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, im, iorb, isum2, isum3, j, la, lr, lr_scf, lr_scf0, lra, lsmorbcount(ng_sm), lsmr, map_tmp(max_orb), ms, nim
logical(kind=iwp) :: logi_norb_inn(norb_all)

logi_norb_inn(1:norb_all) = .false.
iorb = norb_all
do la=1,norb_all
  norb_number(la) = iorb
  iorb = iorb-1
end do

nim = 0
lsmorbcount(1) = nim
do im=2,ng_sm
  nim = nim+nlsm_all(im-1)
  lsmorbcount(im) = nim
end do

if (logic_assign_actorb) then
  do lr=1,norb_inn
    lr_scf = map_orb_order(lr)
    logi_norb_inn(lr_scf) = .true.
  end do
else
  do lr=1,norb_inn
    lsmr = lsm_inn(lr)
    lsmorbcount(lsmr) = lsmorbcount(lsmr)+1
    lr_scf = lsmorbcount(lsmr)
    map_orb_order(lr) = lr_scf
    logi_norb_inn(lr_scf) = .true.
  end do
end if
lr_scf0 = norb_all
la = norb_inn+1
do ms=ng_sm,1,-1
  lr_scf0 = lr_scf0-nlsm_all(ms)
  lr_scf = lr_scf0
  do lra=1,nlsm_all(ms)
    lr_scf = lr_scf+1
    if (logi_norb_inn(lr_scf)) cycle
    map_orb_order(la) = lr_scf
    la = la+1
  end do
end do

isum2 = 0
isum3 = 0
do i=1,ng_sm
  jp2(i) = isum2
  isum2 = isum2+i
  jp3(i) = isum3
  isum3 = isum3+isum2
end do

!iccount = 1
!do lrd=1,norb_inn
!  ipwt(lrd) = iccount
!  iccount = iccount+2
!end do
!lsmorbcount = 0
!do lrd=norb_dz,1,-1
!  lsmid = lsm_inn(lrd)
!  lsmorbcount(lsmid) = lsmorbcount(lsmid)+1
!  ipws(lrd) = (lsmorbcount(lsmid)-1)*3+1
!end do

map_tmp(1:norb_all) = map_orb_order(1:norb_all)
do i=1,norb_all
  do j=1,norb_all
    if (map_tmp(j) == i) then
      map_orb_order(i) = j
      exit
    end if
  end do
end do

return

end subroutine arrange_orbital

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3loopa(oeh,oep,t1a,t1b,nga,ngb,ngc,vblock,energ,isp,LU,ifvo,scored,enx)
!mp subroutine t3loopa(oeh,oep,t1a,t1b,g,nga,ngb,ngc,vblock,energ,
! implemented integer offsets, PV, 16 may 2004.

use ChT3_global, only: nblock, NNOAB, NOAB, NUAB
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: oeh(*), oep(*)
real(kind=wp), intent(inout) :: t1a(*), t1b(*), energ(*)
integer(kind=iwp), intent(in) :: nga, ngb, ngc, vblock, isp, LU(*)
logical(kind=iwp), intent(in) :: ifvo
logical(kind=iwp), intent(out) :: scored
real(kind=wp), intent(out) :: enx
integer(kind=iwp) :: adim, aset, bdim, bset, cdim, cset, iasblock(3), IUHF, n, nug
real(kind=wp), allocatable :: ka(:), la(:), lb(:), lc(:), t3a(:), t3b(:), voa(:), vob(:), voc(:)
real(kind=wp), allocatable, save :: kb(:), kc(:)

N = noab(isp)+nuab(isp)
enx = Zero
scored = .true.
!mp !!!if (.not. lastcall) then
!mp write(u6,*) 'NOAB,NNOAB,NUAB,NNUAB,ICH'
!mp write(u6,*) NOAB,NNOAB,NUAB,NNUAB,ICH
!mp !!!if (energ(isp) == Zero) then
! this is a first entry - initialization (makes no harm if repeated)
nug = nuab(isp)/vblock
if ((nug*vblock) < nuab(isp)) nug = nug+1
!mp write(u6,*) 'first,nug,vblock',nug,vblock,iopt(1)
IUHF = isp
!!if (IOPT(1) == 0) IUHF = 3
iasblock(1) = vblock*vblock*N/nblock
if (iasblock(1)*nblock < vblock*vblock*N) iasblock(1) = iasblock(1)+1
iasblock(2) = nnoab(iuhf)*vblock*N/nblock
if (iasblock(2)*nblock < nnoab(iuhf)*vblock*N) iasblock(2) = iasblock(2)+1
iasblock(3) = nnoab(iuhf)*vblock*vblock/nblock
if (iasblock(3)*nblock < nnoab(iuhf)*vblock*vblock) iasblock(3) = iasblock(3)+1
!mp call w_rescope(G,'G3loopa')
!mp call w_free(g,0,'G3loopa')
! allocations
!mp call w_alloc(ka,noab(isp)*vblock*vblock*n,'kaT3loopa')
call mma_allocate(ka,noab(isp)*vblock*vblock*n,label='loopa_ka')
if (nug /= 1) then
  !mp call w_alloc(kb,noab(isp)*vblock*vblock*n,'kbT3loopa')
  call mma_allocate(kb,noab(isp)*vblock*vblock*n,label='loopa_kb')
  !mp call w_alloc(kc,noab(isp)*vblock*vblock*n,'kcT3loopa')
  call mma_allocate(kc,noab(isp)*vblock*vblock*n,label='loopa_kc')
end if
!mp call w_alloc(la,nnoab(IUHF)*vblock*n,'laT3loopa')
call mma_allocate(la,nnoab(IUHF)*vblock*n,label='loopa_la')
!mp call w_alloc(lb,nnoab(IUHF)*vblock*n,'lbT3loopa')
call mma_allocate(lb,nnoab(IUHF)*vblock*n,label='loopa_lb')
!mp call w_alloc(lc,nnoab(IUHF)*vblock*n,'lcT3loopa')
call mma_allocate(lc,nnoab(IUHF)*vblock*n,label='loopa_lc')
!mp call w_alloc(t3a,vblock*vblock*vblock,'t3aT3loopa')
call mma_allocate(t3a,vblock*vblock*vblock,label='loopa_t3a')
!mp call w_alloc(t3b,vblock*vblock*vblock,'t3bT3loopa')
call mma_allocate(t3b,vblock*vblock*vblock,label='loopa_t3b')
!mp call w_alloc(voa,vblock*vblock*nnoab(IUHF),'voaT3loopa')
call mma_allocate(voa,vblock*vblock*nnoab(IUHF),label='loopa_voa')
!mp call w_alloc(vob,vblock*vblock*nnoab(IUHF),'vobT3loopa')
call mma_allocate(vob,vblock*vblock*nnoab(IUHF),label='loopa_vob')
!mp call w_alloc(voc,vblock*vblock*nnoab(IUHF),'vocT3loopa')
call mma_allocate(voc,vblock*vblock*nnoab(IUHF),label='loopa_voc')
! this is necessary
! prefactors currently a formal allocation
!mp ? call w_alloc(mi,1,'miT3loopa')
!mp ? call w_alloc(mij,1,'T3loopa')

!mp !!!end if     ! energ - initialization
aset = (nga-1)*vblock
adim = min(vblock,nuab(isp)-aset)
bset = (ngb-1)*vblock
bdim = min(vblock,nuab(isp)-bset)
cset = (ngc-1)*vblock
cdim = min(vblock,nuab(isp)-cset)

! case1 nga=ngb=ngc
! if memory is available loops over i,j,k, in subloops can be grouped !!!
if (nga == ngc) then

  !mp call t3_bt_aaa(nug,g(ka),g(ka),g(ka),g(la),g(mi),g(mij),adim,N,noab(isp),nuab(isp),nnoab(iuhf),lu,iasblock,nga,oeh, &
  !mp                oep(aset+1),enx,g(voa),t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),g(t3a),g(t3b),ifvo)
  call t3_bt_aaa(nug,ka,la,adim,N,noab(isp),nnoab(iuhf),lu,iasblock,nga,oeh,oep(aset+1),enx,voa,t1a(noab(isp)*aset+1), &
                 t1b(noab(isp)*aset+1),t3a,t3b,ifvo)

else if (nga == ngb) then
  !mp call t3_bt_aac(nug,g(ka),g(kb),g(kc),g(la),g(lc),g(mi),g(mij),adim,cdim,N,noab(isp),nuab(isp),nnoab(iuhf),lu,iasblock,nga, &
  !mp                ngc,oeh,oep(aset+1),oep(cset+1),enx,g(voa),g(voc),t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1), &
  !mp                t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),g(t3a),g(t3b),ifvo)
  call t3_bt_aac(nug,ka,kc,la,lc,adim,cdim,N,noab(isp),nnoab(iuhf),lu,iasblock,nga,ngc,oeh,oep(aset+1),oep(cset+1),enx,voa,voc, &
                 t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),t3a,t3b,ifvo)
else if (ngb == ngc) then
  !mp call t3_bt_acc(nug,g(ka),g(kb),g(kc),g(la),g(lc),g(mi),g(mij),adim,cdim,N,noab(isp),nuab(isp),nnoab(iuhf),lu,iasblock,nga, &
  !mp                ngc,oeh,oep(aset+1),oep(cset+1),enx,g(voa),g(voc),t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1), &
  !mp                t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),g(t3a),g(t3b),ifvo)
  call t3_bt_acc(nug,ka,kc,la,lc,adim,cdim,N,noab(isp),nnoab(iuhf),lu,iasblock,nga,ngc,oeh,oep(aset+1),oep(cset+1),enx,voa,voc, &
                 t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),t3a,t3b,ifvo)
else
  !mp call t3_bt_abc(nug,g(ka),g(kb),g(kc),g(la),g(lb),g(lc),g(mi),g(mij),adim,bdim,cdim,N,noab(isp),nuab(isp),nnoab(iuhf),lu, &
  !mp                iasblock,nga,ngb,ngc,oeh,oep(aset+1),oep(bset+1),oep(cset+1),enx,g(voa),g(vob),g(voc),t1a(noab(isp)*aset+1), &
  !mp                t1b(noab(isp)*aset+1),t1a(noab(isp)*bset+1),t1b(noab(isp)*bset+1),t1a(noab(isp)*cset+1), &
  !mp                t1b(noab(isp)*cset+1),g(t3a),g(t3b),ifvo)
  call t3_bt_abc(nug,ka,kb,kc,la,lb,lc,adim,bdim,cdim,N,noab(isp),nnoab(iuhf),lu,iasblock,nga,ngb,ngc,oeh,oep(aset+1),oep(bset+1), &
                 oep(cset+1),enx,voa,vob,voc,t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),t1a(noab(isp)*bset+1), &
                 t1b(noab(isp)*bset+1),t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),t3a,t3b,ifvo)
end if   ! cases
energ(isp) = energ(isp)+enx
!mp write(u6,'(A,3(i3,1x),f21.19)') 'nga, ngb, ngc, inc = ',nga,ngb,ngc,enx
!mp
!mp !!!end if  ! lastcall
!mp write(u6,*)
!mp write(u6,*) 'deallocating arrays in t3loopa'
!mp write(u6,*)
call mma_deallocate(voc)
call mma_deallocate(vob)
call mma_deallocate(voa)
call mma_deallocate(t3a)
call mma_deallocate(t3b)
call mma_deallocate(lc)
call mma_deallocate(lb)
call mma_deallocate(la)
if (nug /= 1) then
  call mma_deallocate(kc)
  call mma_deallocate(kb)
end if
call mma_deallocate(ka)

return

end subroutine t3loopa

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
       SubRoutine creqadd_sp(q,G2,idsym,Temp,Scr,n2)
*
*      Constructs the Q matrix
*
       Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "WrkSpc.fh"
#include "Pointers.fh"
       Real*8 Q(nDens2),G2(nna,nna,nna,nna), Temp(n2),Scr(n2)
*                                                                      *
************************************************************************
*                                                                      *
*      Q = (pj|kl)d
*       pi         ijkl
*
       Do iS=1,nSym
          ipS=iEOr(is-1,idsym-1)+1
          If (norb(ips).ne.0) Then
             Do jS=1,nsym
             ijS=iEOR(is-1,js-1)+1
             Do kS=1,nSym
                ls=iEOr(ijs-1,iEor(ks-1,idsym-1))+1
*
                Do kAsh=1,nAsh(ks)
                   kAA=kAsh+nIsh(ks)
                   Do lAsh=1,nAsh(ls)
                      lAA=lAsh+nIsh(ls)
*
                      Call Coul(ipS,jS,kS,lS,kAA,lAA,Temp,Scr)
*
                      Do iAsh=1,nAsh(is)
                         iAA=iAsh+nIsh(is)
                         ipQ=ipMat(ips,is)+(iAA-1)*nOrb(ips)
                         Do jAsh=1,nAsh(js)
                            jAA=jAsh+nIsh(js)
                            ipM=(jAA-1)*nOrb(ipS)+1
*
                            rd=G2(iAsh+na(is),jAsh+na(js),
     &                            kAsh+na(ks),lash+na(ls))
                            call daxpy_(nOrb(ipS),rd,Temp(ipM),1,
     &                                 Q(ipQ),1)
                         End Do
                      End Do
                   End Do
                End Do
*
                End Do
             End Do
          End If
       End Do
*                                                                      *
************************************************************************
*                                                                      *
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DETSTR_MCLR(IDET,IASTR,IBSTR,NEL,NAEL,NBEL,ISGN,IWORK)
! A DETERMINANT,IDET,IS GIVEN AS A SET OF OCCUPIED SPIN ORBITALS,
! POSITIVE NUMBER INDICATES ALPHA ORBITAL AND NEGATIVE NUMBER
! INDICATES BETA ORBITAL.
!
! FIND CORRESPONDING ALPHA STRING AND BETA STRING,
! AND DETERMINE SIGN NEEDED TO CHANGE DETERMINANT
! INTO PRODUCT OF ORDERED ALPHA STRING AND
! BETA STRING
!
! JEPPE OLSEN NOVEMBER 1988

use Index_Functions, only: nTri_Elem
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NEL, NAEL, NBEL
integer(kind=iwp), intent(inout) :: IDET(NEL)
integer(kind=iwp), intent(out) :: IASTR(NAEL), IBSTR(NBEL), ISGN, IWORK(NEL)
integer(kind=iwp) :: ITMP

! FIRST REORDER SPIN ORBITALS IN ASCENDING SEQUENCE
! THIS WILL AUTOMATICALLY SPLIT ALPHA AND BETASTRING

call ORDSTR_MCLR(IDET,IWORK,NEL,ISGN)

! ALPHA STRING IS LAST NAEL ORBITALS
IASTR(:) = IWORK(NBEL+1:NBEL+NAEL)

! BETA  STRING MUST BE COMPLETELY TURNED AROUND
IBSTR(:) = -IWORK(NBEL:1:-1)
! SIGN CHANGE FOR SWITCH OF BETA ORBITALS
iTmp = nTri_Elem(NBEL)
ISGN = ISGN*(-1)**iTmp

#ifdef _DEBUGPRINT_
write(u6,*) ' INPUT DETERMINANT'
call IWRTMA(IDET,1,NEL,1,NEL)
write(u6,*) ' CORRESPONDING ALPHA STRING'
call IWRTMA(IASTR,1,NAEL,1,NAEL)
write(u6,*) ' CORRESPONDING BETA STRING'
call IWRTMA(IBSTR,1,NBEL,1,NBEL)
write(u6,*) ' ISGN FOR SWITCH ',ISGN
#endif

!if (doDMRG .and. doMCLR) then ! yma
!  do I=1,NEL
!    write(117,'(1X,I5)',advance='no') IDET(I)
!  end do
!  write(117,'(A,1X,I2)',advance='no') ' SIGN',ISGN
!end if

end subroutine DETSTR_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_global_paras

use Constants, only: Zero, One, Two, Half, Pi
use Definitions, only: wp, iwp, u5, u6

implicit none
private
public :: INTK, REALK, LUPRI, LURD, LUINTM, fmm_stats_printed, Zero, One, Two, Half, Pi
public :: BRFREE_DF, EXTENT_MIN_DF, PACK_RHS_DF, PACK_LHS_DF, WS_MIN, START_LEN, TREE_LENGTH, MAX_AVG_PER_NODE, ZERO_DIST_TOL, &
          TMATM_DF, DISTINCT_T_TOL, ZERO_VECT_TOL, TOP_LEVEL, MAX_LEVEL
public :: GFC_FMM, MD4_FMM, FE_FMM, NEAR_FIELD, FAR_FIELD, DO_NULL, DO_FQ, DO_BQ, DO_NlogN, DO_FMM, LHS_raw_RHS_raw, &
          LHS_box_RHS_box, T_CONTRACTOR_DIRECT, T_CONTRACTOR_BOUNDARY, T_CONTRACTOR_TREE, T_CONTRACTOR_SCALE, &
          T_CONTRACTOR_SCALE_TREE, T_CONTRACTOR_MULTI, T_CONTRACTOR_FULL, W_CONTRACTOR_DIRECT, W_CONTRACTOR_X, W_CONTRACTOR_FAST, &
          W_CONTRACTOR_BOUNDARY, ELECTRONIC_ONLY, NUCLEAR_ONLY, ALL_MOMENTS, USE_RAW_QLM, USE_T_SYM_QLM, NULL_T_BUFFER, &
          NULL_W_BUFFER, TREE_T_BUFFER, TREE_W_BUFFER, SKIP_T_BUFFER, SKIP_W_BUFFER, MULTI_T_BUFFER, SCALE_T_BUFFER, &
          SORT_BY_SCALE, SORT_BY_RHS_MMS, NSPACE
public :: fmm_counters, fmm_planes, LHS_RHS_type, scheme_paras, raw_mm_paras, raw_mm_data, box_mm_paras, box_mm_data, id_node, &
          id_list, gen_mm_paras, T_paras, T_pair_single, T_pair_list, T_pair_batch, old_new, fmm_sh_pairs, fmm_basis, fmm_prim_batch

!------------------------------------------------------------------------------

! We select here the REAL and INTEGER precisions
!integer(kind=iwp), parameter :: INTK = selected_int_kind(9), &
!                                REALK = selected_real_kind(XXX)
integer(kind=iwp), parameter :: INTK = iwp, &
                                REALK = wp

!==============================================================================
! Program-wide global variables |
!===============================!

! Unit numbers for IO
integer(INTK), save :: LUPRI = u6
integer(INTK), save :: LURD = u5
integer(INTK), save :: LUINTM = 77

! Flag for verbose printing of run-time statistics
logical, save :: fmm_stats_printed = .true.

!==============================================================================
! Global parameters |
!===================!

! Branch-free algorithm
logical, parameter :: BRFREE_DF = .true.
! minimum charge separation for qTq evaluation
real(REALK), parameter :: EXTENT_MIN_DF = 0.001_REALK

! Same centre/extent packing flags
logical, parameter :: PACK_RHS_DF = .true.
logical, parameter :: PACK_LHS_DF = .false.

! Parameters for branch and box structure
!integer(INTK), parameter :: WS_MIN = 2
integer(INTK), parameter :: WS_MIN = 1

! Parameters for T-list tree sorting
integer(INTK), parameter :: START_LEN = 8
integer(INTK), parameter :: TREE_LENGTH = 50000
! MAX_AVG_PER_NODE limits the maximal packing ratio.
! there will be never more interactions in the tree than
! tree size times MAX_AVG_PER_NODE.
integer(INTK), parameter :: MAX_AVG_PER_NODE = 15

! Noise buffer when testing for classical interactions
!FIXME: have this passed from clsfmm.h ... used for nothing else!!
real(REALK), parameter :: ZERO_DIST_TOL = 1.0e-14_REALK

! Parameters for contractions and translations
! Number of simultaneous T-matrices when using T_CONTRACTOR_MULTI
integer(INTK), parameter :: TMATM_DF = 25

!FIXME: clarify the use of these tolerance parameters!!
real(REALK), parameter :: DISTINCT_T_TOL = 1.0e-15_REALK
real(REALK), parameter :: ZERO_VECT_TOL = 1.0e-10_REALK

!------------------------------------------------------------------------------

! Parameters to define level depth used in box hierarchy
integer(INTK), parameter :: TOP_LEVEL = 2
integer(INTK), parameter :: MAX_LEVEL = 15

!------------------------------------------------------------------------------
!
! Named parameters for coding use (avoidance of "magic" numbers etc.)
!

! Named parameters for potential or J-matrix request
integer(INTK), parameter :: GFC_FMM = 1, &
                            MD4_FMM = 2, &
                            FE_FMM = 3

! Named parameters for (classical) near-field or far-field phase
integer(INTK), parameter :: NEAR_FIELD = 1, &
                            FAR_FIELD = 2

! Named parameters for different MM methods implemented
integer(INTK), parameter :: DO_NULL = 0, &
                            DO_FQ = 1, &
                            DO_BQ = 3, &
                            DO_NlogN = 4, &
                            DO_FMM = 5

! Named parameters for T-pair interaction types
integer(INTK), parameter :: LHS_raw_RHS_raw = 1, &
                            !LHS_raw_RHS_box = 2, &
                            !LHS_box_RHS_raw = 3, &
                            LHS_box_RHS_box = 4

! Named parameters for different contractors implemented
integer(INTK), parameter :: T_CONTRACTOR_DIRECT = 100, &
                            T_CONTRACTOR_BOUNDARY = 101, &
                            T_CONTRACTOR_TREE = 102, &
                            T_CONTRACTOR_SCALE = 104, &
                            T_CONTRACTOR_SCALE_TREE = 1041, &
                            T_CONTRACTOR_MULTI = 105, &
                            T_CONTRACTOR_FULL = 106, &
                            W_CONTRACTOR_DIRECT = 206, &
                            W_CONTRACTOR_X = 207, &
                            W_CONTRACTOR_FAST = 208, &
                            W_CONTRACTOR_BOUNDARY = 209

! Named parameters for moments used in contraction
integer(INTK), parameter :: ELECTRONIC_ONLY = 1, &
                            NUCLEAR_ONLY = 2, &
                            ALL_MOMENTS = 3

! Named parameters for auxiliary moments
integer(INTK), parameter :: USE_RAW_QLM = 0, &
                            USE_T_SYM_QLM = 1

! Named parameters for lists available
integer(INTK), parameter :: NULL_T_BUFFER = 1, &
                            NULL_W_BUFFER = 2, &
                            TREE_T_BUFFER = 3, &
                            TREE_W_BUFFER = 4, &
                            SKIP_T_BUFFER = 5, &
                            SKIP_W_BUFFER = 6, &
                            MULTI_T_BUFFER = 7, &
                            SCALE_T_BUFFER = 8

! Sort orders expected by interaction evaluators.
integer(INTK), parameter :: SORT_BY_SCALE = 1, &
                            SORT_BY_RHS_MMS = 2

! Named parameters for memory management
character(len=*), parameter :: NSPACE(5) = ['raw_qlm', &
                                            'raw_Vff', &
                                            'box_Vff', &
                                            'Vff_tmp', &
                                            'box_qlm']

!===============================================================================
! Derived types |
!================

! Structure for counting raw multipole moments by type
type fmm_counters
  integer(INTK) :: tot, nuc, elec
end type fmm_counters

!------------------------------------------------------------------------------

! Structure for defining boundary planes (assuming // to axes)
type fmm_planes
  real(REALK) :: xmin, xmax, ymin, ymax, zmin, zmax
end type fmm_planes

!------------------------------------------------------------------------------

type LHS_RHS_type
  integer(INTK) :: LHS, RHS
end type LHS_RHS_type

!------------------------------------------------------------------------------

! Complete prescription of MM execution held in "scheme"
type T_contract_schm
  integer(INTK) :: NF_ID, FF_ID
  integer(INTK) :: NF_T_buffer, FF_T_buffer
  integer(INTK) :: NF_sort_para, FF_sort_para
  integer(INTK) :: LHS_mm_type, RHS_mm_type
end type T_contract_schm

type W_contract_schm
  integer(INTK) :: ID         ! general translator
  integer(INTK) :: BR_ID      ! box-to-raw translator
  integer(INTK) :: W_buffer
  integer(INTK) :: sort_para
end type W_contract_schm

type scheme_paras
  integer(INTK)         :: job_type
  logical               :: include_near_field
  integer(INTK)         :: algorithm, phase
  integer(INTK)         :: NF_T_searcher, FF_T_searcher
  type(T_contract_schm) :: T_con
  type(W_contract_schm) :: W_con
  logical               :: branch_free
  integer(INTK)         :: raw_lmax, trans_lmax
  integer(INTK)         :: LHS_mm_range, RHS_mm_range
  logical               :: pack_LHS, pack_RHS
  logical               :: LHS_dens, RHS_dens
  real(REALK)           :: extent_min
  real(REALK)           :: grain
  real(REALK)           :: dens_screen_thr
  integer(INTK)         :: FEdim
  ! Order of Lagrange interpolating polynomials for finite elements
  integer(INTK)         :: lipn

end type scheme_paras

!------------------------------------------------------------------------------

! Raw (not boxed) multipole moment data structure
type raw_mm_paras
  real(REALK)   :: cntr(3), ext
  integer(INTK) :: batch            ! batch id of unique centres/extents
  integer(INTK) :: id               ! map to raw moments array
  integer(INTK) :: map_up           ! map to boxed multipole moment
  integer(INTK) :: box(3), bra
  real(REALK)   :: box_cntr(3)
end type raw_mm_paras

type J_index_type
  integer(INTK) :: i_indx, j_indx   ! map to J_matrix elements
end type J_index_type

type raw_mm_data
  type(raw_mm_paras), pointer :: paras(:)
  real(REALK), pointer        :: dens(:)
  real(REALK), pointer        :: qlm(:,:)
  real(REALK), pointer        :: qlm_T(:,:)
  real(REALK), pointer        :: qlm_W(:,:)
  type(J_index_type), pointer :: J_indices(:)
  type(id_list), pointer      :: batch_map(:) ! maps raw paras in one batch
end type raw_mm_data

!------------------------------------------------------------------------------

! Boxed multipole moment data structure
type box_mm_paras
  integer(INTK) :: box(3)
  real(REALK)   :: cntr(3)
  integer(INTK) :: bra, level
  integer(INTK) :: map_up            ! map to moment at next level
  real(REALK)   :: cntr_up(3)        ! centre of parent box
  integer(INTK) :: id                ! map to moment at this level
end type box_mm_paras
type box_mm_data
  type(box_mm_paras), pointer :: LHS_paras(:)
  type(box_mm_paras), pointer :: RHS_paras(:)
  ! Just RHS moments (only RHS is built up in box hierarchy)
  real(REALK), pointer        :: qlm_T(:,:)
  real(REALK), pointer        :: qlm_W(:,:)
end type box_mm_data

!------------------------------------------------------------------------------

! Map structure to link packed parameters with all raw moment members
type id_node
  integer(INTK)          :: id
  integer(INTK)          :: i_indx, j_indx
  type(id_node), pointer :: next
end type id_node

type id_list
  integer(INTK)          :: occ
  type(id_node), pointer :: head
end type id_list

!------------------------------------------------------------------------------

! Generalised multipole moment parameter structure
type gen_mm_paras
  type(raw_mm_paras), pointer :: raw_paras(:)
  type(box_mm_paras), pointer :: box_paras(:)
end type gen_mm_paras

!------------------------------------------------------------------------------

type T_paras
  integer(INTK) :: LHS_lmax, LHS_id
  integer(INTK) :: RHS_lmax, RHS_id
  integer(INTK) :: weight
  real(REALK)   :: ratio
end type T_paras

type T_pair_single
  type(T_paras) :: paras
  real(REALK)   :: r_ab(3)
  integer(INTK) :: lmax, lm_max
  ! Used only for W_pairs when translating to distinguish qlm and Vff modes
  character     :: N_or_T
end type T_pair_single

type T_pair_list
  type(T_paras), pointer :: paras(:)
  real(REALK)            :: r_ab(3)
  integer(INTK)          :: lmax, lm_max
  integer(INTK)          :: LHS_lmax, RHS_lmax
  ! Used only for W_pairs when translating to distinguish qlm and Vff modes
  character              :: N_or_T
end type T_pair_list

type T_pair_batch
  type(T_pair_single), pointer :: items(:)
  integer(INTK)                :: ndim
end type T_pair_batch

! Index type for OLD and NEW W_translations
type old_new
  integer(INTK) :: old, new
end type old_new

!------------------------------------------------------------------------------

! Linked-list shell-pair data structure
!type fmm_shell_pair_node
!  integer(INTK)                      :: I, J
!  integer(INTK)                      :: box(3)
!  real(REALK)                        :: extent
!  real(REALK)                        :: centre(3)
!  type(fmm_shell_pair_node), pointer :: next
!end type fmm_shell_pair_node

!-----------------------------------------------------------------------------

! O(N) array of non-vanishing shell paris
type fmm_sh_pairs
  integer(INTK) :: I, J
  real(REALK)   :: extent
  real(REALK)   :: centre(3)
end type fmm_sh_pairs

!------------------------------------------------------------------------------

! Basis set information from host program
type fmm_basis
  integer(INTK)          :: nbas
  integer(INTK)          :: nshells
  integer(INTK)          :: maxsgm2
  integer(INTK)          :: maxangl
  integer(INTK), pointer :: KAtom(:)
  integer(INTK), pointer :: KType(:)
  integer(INTK), pointer :: KStart(:)
  integer(INTK), pointer :: KontG(:)
  integer(INTK), pointer :: KLoc_Car(:)
  integer(INTK), pointer :: LtuvMin_Car(:)
  integer(INTK), pointer :: LtuvMax_Car(:)
  integer(INTK), pointer :: Lt(:)
  integer(INTK), pointer :: Lu(:)
  integer(INTK), pointer :: Lv(:)
  real(REALK), pointer   :: Centr(:,:)
  real(REALK), pointer   :: Expnt(:)
  real(REALK), pointer   :: CCoef(:)
end type fmm_basis

!------------------------------------------------------------------------------

! Batch of primitive data for one shell-pair
type fmm_prim_batch
  real(REALK) :: P(3), PA(3), PB(3), PC(3)
  real(REALK) :: lo(3), hi(3)
  real(REALK) :: ExpntP
  real(REALK) :: ExpPHalf
  real(REALK) :: PreFactAB
  real(REALK) :: CCoefAB
end type fmm_prim_batch

!------------------------------------------------------------------------------

end module fmm_global_paras

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************

subroutine covarMatrix()

use kriging_mod, only: eps, eps2, full_R, Index_PGEK, l, m_t, nD, nInter, nInter_Eff, nPoints, x
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i, j, i0, i1, j0, j1, k, i_eff, j_eff
real(kind=wp), allocatable :: diffx_j(:,:), diffx_i(:,:), matFder(:,:), matSder(:,:), r(:,:,:), d(:,:)

!**********************************************************************
!
! Allocate temporary memory

call mma_Allocate(diffx_j,nPoints,nPoints,label='diffx_j')
call mma_Allocate(diffx_i,nPoints,nPoints,label='diffx_i')
call mma_Allocate(matFder,nPoints,nPoints,label='matFder')
call mma_Allocate(matSder,nPoints,nPoints,label='matSder')
call mma_Allocate(r,nPoints,nPoints,nInter,label='r')
call mma_Allocate(d,nPoints,nPoints,label='d')

!**********************************************************************
!
! Compute the distances between the sample points using
! the characteristic length.

full_R(:,:) = Zero
d(:,:) = Zero
diffx_j(:,:) = Zero
diffx_i(:,:) = 0

do i=1,nInter

  do k=1,nPoints
    do j=1,nPoints
      r(k,j,i) = (x(i,k)-x(i,j))/l(i)
    end do
  end do

  ! Accumulate contributions to the square of the individual distances.

  d(:,:) = d(:,:)+r(:,:,i)**2

# ifdef _DEBUGPRINT_
  call RecPrt('r',' ',r(:,:,i),nPoints,nPoints)
# endif

end do

!**********************************************************************

#ifdef _DEBUGPRINT_
call RecPrt('l',' ',l,1,nInter)
call RecPrt('x',' ',x,nInter,nPoints)
call RecPrt('d',' ',d,nPoints,nPoints)
#endif

!**********************************************************************
!**********************************************************************
!
! Now evaluate the covariance function over all the distances. For GEK
! we will need gradients and 2nd order derivatives of the covariance
! function too.
!
! Currently we use the 5/2 Matern function as the covariance function
!
!**********************************************************************
!
! Note that we will evaluate the derivative of the covariance function
! w.r.t d. For the full derivative this has to be complemented by
! the derivative of d w.r.t the individual components of the coordinates.
!
!**********************************************************************
! 1) Evaluate the covariance function for all the distances.

call matern(d,full_R(1:nPoints,1:nPoints),nPoints,nPoints)

! Writing the covariant matrix in GEK (eq 2 of doi:10.1007/s00366-015-0397)
!
!**********************************************************************
!
! 2) Evaluate first derivatives of the covariance function with respect to d at all distances.

call matderiv(1,d,MatFder,nPoints,nPoints)

! Covariant matrix in Gradient Enhanced Kriging (eq 2 of doi:10.1007/s00366-015-0397):
!
! First line and first column derivative in Psi matrix

do i_eff=1,nInter_Eff      ! Loop over component of the coordinate to differentiate
  i = Index_PGEK(i_eff)

  ! Compute the range of the block in the covariance matrix.

  i0 = nPoints+1+(i_eff-1)*(nPoints-nD)
  i1 = i0+(nPoints-nD)-1

  ! Do an on-the-fly evaluation of the dervative w.r.t x_i
  diffx_i(1:nPoints,1+nD:nPoints) = -Two*r(1:nPoints,1+nD:nPoints,i)/l(i)

  ! Writing the 1st row of 1st derivatives with respect the coordinates

  full_R(1:nPoints,i0:i1) = matFDer(1:nPoints,1+nD:nPoints)*diffx_i(1:nPoints,1+nD:nPoints)

end do
! Complete by filling in the transpose blocks

full_R(nPoints+1:m_t,1:nPoints) = transpose(Full_R(1:nPoints,nPoints+1:m_t))

!**********************************************************************
!
! 3) Evaluate the second derivatives.
!
! Matern second derivative with respect to d

call matderiv(2,d,matSder,nPoints,nPoints)

! Second derivatives
do i_Eff=1,nInter_Eff
  i = Index_PGEK(i_Eff)
  i0 = nPoints+1+(i_Eff-1)*(nPoints-nD)
  i1 = i0+(nPoints-nD)-1

  diffx_i(1+nD:nPoints,1+nD:nPoints) = -Two*r(1+nD:nPoints,1+nD:nPoints,i)/l(i)

  do j_Eff=i_Eff,nInter_Eff
    j = Index_PGEK(j_Eff)
    j0 = nPoints+1+(j_Eff-1)*(nPoints-nD)
    j1 = j0+(nPoints-nD)-1

    diffx_j(1+nD:nPoints,1+nD:nPoints) = Two*r(1+nD:nPoints,1+nD:nPoints,j)/l(j)

    ! if differentiating twice on the same dimension
    full_R(i0:i1,j0:j1) = matSder(1+nD:nPoints,1+nD:nPoints)*diffx_j(1+nD:nPoints,1+nD:nPoints)*diffx_i(1+nD:nPoints,1+nD:nPoints)

    if (i == j) full_R(i0:i1,j0:j1) = full_R(i0:i1,j0:j1)-matFder(1+nD:nPoints,1+nD:nPoints)*(Two/(l(i)*l(j)))

    ! Writing the second derivatives in eq(2)
    if (i /= j) full_R(j0:j1,i0:i1) = transpose(Full_r(i0:i1,j0:j1))
  end do

end do

! Add constants to reflect the error in the energy and the
! gradient, respectively.

do j=1,m_t
  if (j <= nPoints) then
    Full_R(j,j) = Full_R(j,j)+eps
  else
    Full_R(j,j) = Full_R(j,j)+eps2
  end if
end do

#ifdef _DEBUGPRINT_
call RecPrt('The covariance matrix:','(12(2x,E9.3))',full_R,m_t,m_t)
#endif

call mma_deallocate(diffx_j)
call mma_deallocate(diffx_i)
call mma_deallocate(matFder)
call mma_deallocate(matSder)
call mma_deallocate(r)
call mma_deallocate(d)

end subroutine covarMatrix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ANNSTR_GAS(STRING,NSTINI,NSTINO,NEL,NORB,IORBOF,Z,NEWORD,TI,TTO,NACOB,IEC,LDIM)
! A group of strings containing NEL electrons is given
! Set up all possible ways of removing an electron
!
!========
! Input :
!========
! STRING : Input strings containing NEL electrons
! NSTINI : Number of input  strings
! NSTINO : Number of output strings
! NEL    : Number of electrons in input strings
! NORB   : Number of orbitals
! IORBOF : Number of first orbital
! Z      : Lexical ordering matrix for output strings containing
!          NEL - 1 electrons
! NEWORD : Reordering array for N-1 strings
! LSGSTR : /= 0 => Include sign arrays ISGSTI,ISGSTO of strings
! ISGSTI : Sign array for NEL   strings
! ISGSTO : Sign array for NEL-1 strings
! IEC    : = 1 Extended map, dimension equals number of orbs
! IEC    : = 2 Compact  map, dimension equals number of elecs
! LDIM   : Row dimension (see IEC)
!
!=========
! Output :
!=========
!
!TI      : TI(I,ISTRIN) > 0 indicates that orbital I can be added
!          to string ISTRIN .
!TTO     : Resulting NEL + 1 strings
!          if the string have a negative sign
!          then the phase equals - 1

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSTINI, NEL, STRING(NEL,NSTINI), NSTINO, NORB, IORBOF, Z(NORB,NEL+1), NEWORD(NSTINO), NACOB, IEC, &
                                 LDIM
integer(kind=iwp), intent(out) :: TI(LDIM,NSTINI), TTO(LDIM,NSTINI)
integer(kind=iwp) :: IEL, IIISGN, IORB, IORBABS, IROW, ISTRIN, JSTRIN, STRIN2(500)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I, NPR
#endif
integer(kind=iwp), external :: ISTRNM

#ifdef _DEBUGPRINT_
write(u6,*) ' ==============='
write(u6,*) ' ANNSTR speaking'
write(u6,*) ' ==============='
write(u6,*)
write(u6,*) ' Number of input electrons ',NEL
#endif

do ISTRIN=1,NSTINI
  do IEL=1,NEL
    ! String with electron removed
    STRIN2(1:IEL-1) = STRING(1:IEL-1,ISTRIN)
    STRIN2(IEL:NEL-1) = STRING(IEL+1:NEL,ISTRIN)
    JSTRIN = ISTRNM(STRIN2,NACOB,NEL-1,Z,NEWORD,1)
    !write(u6,*) ' anni-string and number'
    !call IWRTMA(STRIN2,1,NEL-1,1,NEL-1)
    !write(u6,*) ' JSTRIN = ',JSTRIN

    IORBABS = STRING(IEL,ISTRIN)
    IORB = STRING(IEL,ISTRIN)-IORBOF+1
    if (IEC == 1) then
      IROW = IORB
    else
      IROW = IEL
    end if

    TI(IROW,ISTRIN) = -IORBABS
    !TI(IROW,ISTRIN) = -IORB
    TTO(IROW,ISTRIN) = JSTRIN
    !PAM2009 IIISGN = (-1)**(IEL-1)
    IIISGN = 1-2*mod(IEL+1,2)
    !if (LSGSTR /= 0) IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
    if (IIISGN == -1) TTO(IROW,ISTRIN) = -TTO(IROW,ISTRIN)
  end do

end do

#ifdef _DEBUGPRINT_
NPR = min(NSTINI,60)
write(u6,*) 'Output from ANNSTR:'
write(u6,*) '==================='

write(u6,*)
write(u6,*) ' Strings with an electron added or removed'
do ISTRIN=1,NPR
  write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' New strings.. ',(TTO(I,ISTRIN),I=1,LDIM)
end do
do ISTRIN=1,NPR
  write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' orbitals added or removed ',(TI(I,ISTRIN),I=1,LDIM)
end do
#endif

end subroutine ANNSTR_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine put array double data to the runfile.                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: August 2003                                                 *
*                                                                      *
************************************************************************
*  Put_dArray
*
*> @brief
*>   Add/update array data in runfile
*> @author Per-Olof Widmark
*>
*> @details
*> This routine is used to put array data of type
*> ``Real*8`` into the runfile. The data items are
*> identified by the \p label. Below is a list of the
*> data items that are recognized. The labels are
*> case insensitive and significant to 16 characters.
*> (May change to 24 characters.)
*>
*> @warning
*> Naming convention is under development
*> and labels may change to the next version.
*>
*> For development purposes you can use an unsupported
*> label. Whenever such a field is accessed a warning
*> message is printed in the output, to remind the
*> developer to update this routine.
*>
*> List of known labels:
*>
*> - '``Analytic Hessian``'         Analytic Hessian.
*> - '``Center of Charge``'         Nuclear center of charge.
*> - '``Center of Mass``'           Nuclear center of mass.
*> - '``CMO_ab``'
*> - '``D1ao``'                     One particle density matrix, AO basis.
*> - '``D1ao_ab``'
*> - '``D1aoVar``'                  Generalized one particle density matrix, AO basis.
*> - '``D1av``'                     Average one particle density matrix, AO basis.
*> - '``D1mo``'                     One particle density matrix, MO basis.
*> - '``D1sao``'                    One particle spin density matrix, AO basis.
*> - '``D1activeao``'               One particle density matrix, AO basis, active orbitals
*> - '``D2av``'                     Average two particle density matrix for the active space, AO basis.
*> - '``dExcdRa``'                  The potential of the exchange-correlation functional.
*> - '``DLAO``'
*> - '``DLMO``'
*> - '``Effective nuclear Charge``' Effective nuclear charge for each unique atom.
*> - '``FockO_ab``'
*> - '``FockOcc``'                  Generalized Fock matrix, AO basis.
*> - '``GeoNew``'                   Next guess for Cartesian coordinates for the unique atoms.
*> - '``GeoNewPC``'                 Next guess for Cartesian coordinates for the unique point charges.
*> - '``GRAD``'                     Gradient with respect to nuclear displacements, for all unique atoms.
*> - '``Hess``'
*> - '``HF-forces``'                Hellmann--Feynman forces.
*> - '``Last orbitals``'            Last set of orbital computed.
*> - '``LCMO``'
*> - '``MEP-Coor``'                 List of nuclear coordinates along a minimum energy path, for unique atoms.
*> - '``MEP-Energies``'             List of energies along a minimum energy path.
*> - '``MEP-Grad``'                 List of nuclear gradients along a minimum energy path.
*> - '``MP2 restart``'              Information for restarting direct MP2 calculations.
*> - '``Mulliken Charge``'          Mulliken population charges for each unique atom.
*> - '``NEMO TPC``'
*> - '``Nuclear charge``'           Actual nuclear charge for each unique atom.
*> - '``OrbE``'                     SCF orbital energies.
*> - '``OrbE_ab``'
*> - '``P2MO``'
*> - '``PCM Charges``'              Charges for each tessera in the PCM model.
*> - '``PCM Info``'                 Misc. information needed for the PCM model.
*> - '``PLMO``'
*> - '``RASSCF orbitals``'          Last orbitals generated by the RASSCF module.
*> - '``Reaction field``'           Misc. information needed for the Kirkwood model.
*> - '``SCFInfoR``'                 Misc. information needed by the SCF module.
*> - '``SCF orbitals``'             Last orbitals generated by the SCF module.
*> - '``Slapaf Info 2``'            Misc. information needed by the SLAPAF module.
*> - '``Unique Coordinates``'       Cartesian coordinates for the symmetry unique atoms.
*> - '``Last energies``'            Energies for all roots in the last calculation.
*> - '``Dipole moment``'            The last computed dipole moment.
*> - '``MkNemo.vDisp``'             The displacements matrix as specified in the mknemo module.
*> - '``MkNemo.tqCluster``'         The transformation matrix for clusters as specified in the mknemo module.
*> - '``MkNemo.Energies``'          The energies of super-system and clusters as specified in the mknemo module.
*> - '``RASSCF OrbE``'              RASSCF orbital energies.
*> - '``GRD1``'                     MR-CISD gradient state1.
*> - '``GRD2``'                     MR-CISD gradient state2.
*> - '``NADC``'                     MR-CISD NADC vector state1/state2.
*> - '``MR-CISD energy``'           MR-CISD energies state1,state2.
*> - '``NOSEHOOVER``'               Extra-degrees of fredom needed to generated canonical ensemble.
*> - '``T-Matrix``'                 T-Matrix associated with PCO.
*> - '``rInt0``'                    Stored constrained values.
*> - '``Weights``'                  Weights used for alignment and hypersphere constraint.
*> - '``MEP-Lengths``'              Lengths of the MEP steps.
*> - '``MEP-Curvatures``'           Curvatures of the MEP steps.
*> - '``D1ao-``'                    Antisymmetric transition density matrix, in AO
*> - '``P2MOT``'                    "Fake" two-body density needed for MC-PDFT gradient calculations
*>
*> @param[in] Label Name of field
*> @param[in] Data  Data to put on runfile
*> @param[in] nData Length of array
************************************************************************
      Subroutine Put_dArray(Label,Data,nData)
      Implicit None
#include "pg_da_info.fh"
*----------------------------------------------------------------------*
* Arguments                                                            *
*----------------------------------------------------------------------*
      Character*(*) Label
      Integer       nData
      Real*8        Data(nData)
*----------------------------------------------------------------------*
* Define local variables                                               *
*----------------------------------------------------------------------*
      Character*16 RecLab(nTocDA)
      Integer      RecIdx(nTocDA)
      Integer      RecLen(nTocDA)
      Save         RecLab
      Save         RecIdx
      Save         RecLen
*
      Character*16 CmpLab1
      Character*16 CmpLab2
      Integer      nTmp
      Integer      item
      Integer      iTmp
      Integer      i
*----------------------------------------------------------------------*
* Initialize local variables                                           *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
* Do setup if this is the first call.                                  *
*----------------------------------------------------------------------*
      Call ffRun('dArray labels',nTmp,iTmp)
      If(nTmp.eq.0) Then
         Do i=1,nTocDA
            RecLab(i)=' '
            RecIdx(i)=sNotUsed
            RecLen(i)=0
         End Do
*
*        Observe that label is at most 16 characters!
*
*                     1234567890123456
         RecLab(  1)='Analytic Hessian'
         RecLab(  2)='Center of Charge'
         RecLab(  3)='Center of Mass  '
         RecLab(  4)='CMO_ab          '
         RecLab(  5)='D1ao            '
         RecLab(  6)='D1ao_ab         '
         RecLab(  7)='D1aoVar         '
         RecLab(  8)='D1av            '
         RecLab(  9)='D1mo            '
         RecLab( 10)='D1sao           '
         RecLab( 11)='D2av            '
         RecLab( 12)='dExcdRa         '
         RecLab( 13)='DLAO            '
         RecLab( 14)='DLMO            '
         RecLab( 15)='Effective nuclea' !r charge
         RecLab( 16)='FockO_ab        '
         RecLab( 17)='FockOcc         '
         RecLab( 18)='GeoNew          '
         RecLab( 19)='GeoNewPC        '
         RecLab( 20)='GRAD            '
         RecLab( 21)='Hess            '
         RecLab( 22)='HF-forces       '
         RecLab( 23)='Last orbitals   '
         RecLab( 24)='LCMO            '
         RecLab( 25)='MEP-Coor        '
         RecLab( 26)='MEP-Energies    '
         RecLab( 27)='MEP-Grad        '
         RecLab( 28)='MP2 restart     '
         RecLab( 29)='Mulliken Charge '
         RecLab( 30)='NEMO TPC        '
         RecLab( 31)='Nuclear charge  '
         RecLab( 32)='OrbE            '
         RecLab( 33)='OrbE_ab         '
         RecLab( 34)='P2MO            '
         RecLab( 35)='PCM Charges     '
         RecLab( 36)='PCM Info        '
         RecLab( 37)='PLMO            '
         RecLab( 38)='RASSCF orbitals '
         RecLab( 39)='Reaction field  '
         RecLab( 40)='SCFInfoR        '
         RecLab( 41)='SCF orbitals    '
         RecLab( 42)='Slapaf Info 2   '
         RecLab( 43)='Unique Coordinat' !es
         RecLab( 44)='Vxc_ref         '
c mess started here :)
         RecLab( 45)='PotNuc00        '
         RecLab( 46)='h1_raw          '
         RecLab( 47)='h1    XX        '
         RecLab( 48)='HEFF            '
         RecLab( 49)='PotNucXX        '
         RecLab( 50)='Quad_r          '
         RecLab( 51)='RCTFLD          '
         RecLab( 52)='RFrInfo         '
         RecLab( 53)='                '
         RecLab( 54)='DKH_Info        '
         RecLab( 55)='Real_Info       '
         RecLab( 56)='Last orbitals_ab'
         RecLab( 57)='SCFInfoI_ab     '
         RecLab( 58)='SCFInfoR_ab     '
         RecLab( 59)='Transverse      '
         RecLab( 60)='SM              '
         RecLab( 61)='LP_Coor         '
         RecLab( 62)='LP_Q            '
         RecLab( 63)='DFT_TwoEl       '
         RecLab( 64)='Unit Cell Vector'
         RecLab( 65)='SCF orbitals_ab '
         RecLab( 66)='Guessorb        '
         RecLab( 67)='Guessorb energie' !s
         RecLab( 68)='Last energies   '
         RecLab( 69)='LoProp Dens 0   '
         RecLab( 70)='LoProp Dens 1   '
         RecLab( 71)='LoProp Dens 2   '
         RecLab( 72)='LoProp Dens 3   '
         RecLab( 73)='LoProp Dens 4   '
         RecLab( 74)='LoProp Dens 5   '
         RecLab( 75)='LoProp Dens 6   '
         RecLab( 76)='LoProp Integrals'
         RecLab( 77)='MpProp Orb Ener '
         RecLab( 78)='LoProp H0       '
         RecLab( 79)='Dipole moment   '
         RecLab( 80)='RICD_Info       '
         RecLab( 81)='BMtrx           '
         RecLab( 82)='CList           '
         RecLab( 83)='DList           '
         RecLab( 84)='                ' ! Unused
         RecLab( 85)='MkNemo.vDisp    '
         RecLab( 86)='MkNemo.tqCluster'
         RecLab( 87)='MkNemo.Energies '
         RecLab( 88)='MMHessian       '
         RecLab( 89)='Bfn Coordinates '
         RecLab( 90)='Pseudo Coordinat' !es
         RecLab( 91)='Pseudo Charge   '
         RecLab( 92)='RASSCF OrbE     '
         RecLab( 93)='Ref_Geom        '
         RecLab( 94)='LoProp Charge   '
         RecLab( 95)='Initial Coordina' !tes
         RecLab( 96)='Grad State1     '
         RecLab( 97)='Grad State2     '
         RecLab( 98)='NADC            '
         RecLab( 99)='MR-CISD energy  '
         RecLab(100)='Saddle          '
         RecLab(101)='Reaction Vector '
         RecLab(102)='IRC-Coor        '
         RecLab(103)='IRC-Energies    '
         RecLab(104)='IRC-Grad        '
         RecLab(105)='MM Grad         '
         RecLab(106)='Velocities      '
         RecLab(107)='FC-Matrix       '
         RecLab(108)='umass           '
         RecLab(109)='ESO_SINGLE      '
         RecLab(110)='UMATR_SINGLE    '
         RecLab(111)='UMATI_SINGLE    '
         RecLab(112)='ANGM_SINGLE     '
         RecLab(113)='TanVec          '
         RecLab(114)='Nuc Potential   '
         RecLab(115)='RF CASSCF Vector'
         RecLab(116)='Cholesky BkmThr '
         RecLab(117)='NOSEHOOVER      '
         RecLab(118)='T-Matrix        '
         RecLab(119)='rInt0           '
         RecLab(120)='Weights         '
         RecLab(121)='MEP-Lengths     '
         RecLab(122)='MEP-Curvatures  '
         RecLab(123)='Hss_X           '
         RecLab(124)='Hss_Q           '
         RecLab(125)='KtB             '
         RecLab(126)='BMxOld          '
         RecLab(127)='TROld           '
         RecLab(128)='qInt            '
         RecLab(129)='dqInt           '
         RecLab(130)='Fragment_Fock   '
         RecLab(131)='RAmatrixV       '
         RecLab(132)='IAmatrixV       '
         RecLab(133)='AllCIP          '
         RecLab(134)='AllCIPP         '
         RecLab(135)='VenergyP        '
         RecLab(136)='K               '
         RecLab(137)='MMO Coords      '
         RecLab(138)='MMO Grad        '
         RecLab(139)='Hss_upd         '
         RecLab(140)='TR              '
         RecLab(141)='D1ao-           '
         RecLab(142)='ESFS_SINGLE     '
         RecLab(143)='LA Fact         '
         RecLab(144)='primitives      '
         RecLab(145)='Isotopes        ' ! Atom masses in a.u.
         RecLab(146)='P2AO            '
         RecLab(147)='State Overlaps  '
         RecLab(148)='EFP_Coors       ' ! EFP fragment coordinates
         RecLab(149)='DIP1_SINGLE     '
         RecLab(150)='P2MOT           '
         RecLab(151)='ONTOPO          '
         RecLab(152)='ONTOPT          '
         RecLab(153)='OE_OT           '
         RecLab(154)='TEG_OT          '
         RecLab(155)='FI_V            '
         RecLab(156)='FA_V            '
         RecLab(157)='FOCK_PDFT       '
         RecLab(158)='AMFI_SINGLE     '
         RecLab(159)='HAMSOR_SINGLE   '
         RecLab(160)='HAMSOI_SINGLE   '
         RecLab(161)='Last Dipole Mome' !nts
         RecLab(162)='Un_cen Effective' ! Charge
         RecLab(163)='Un_cen Coordinat' !es
         RecLab(164)='ANGMR_NSS       '
         RecLab(165)='ANGMI_NSS       '
         RecLab(166)='EDIPR_NSS       '
         RecLab(167)='EDIPI_NSS       '
         RecLab(168)='SPINR_NSS       '
         RecLab(169)='SPINI_NSS       '
         RecLab(170)='Proj_Coord      '
         RecLab(171)='d1activeao      '
         RecLab(172)='Keep_Coord      '
         RecLab(173)='PCMSph          '
         RecLab(174)='PCMTess         '
         RecLab(175)='Vert            '
         RecLab(176)='Centr           '
         RecLab(177)='SSph            '
         RecLab(178)='PCMDM           '
         RecLab(179)='EF_Centers      '
         RecLab(180)='OAM_Center      '
         RecLab(181)='OMQ_Center      '
         RecLab(182)='DMS_Centers     '
         RecLab(183)='Wel_Info        '
         RecLab(184)='AMP_Center      '
         RecLab(185)='RP_Centers      '
         RecLab(186)='XF              '
         RecLab(187)='rDmp            '
         RecLab(188)='rDmp:A          '
         RecLab(189)='rDmp:S          '
*                     1234567890123456
*
*        If you go beyond 256: update pg_da_info.fh and this line!
         Call cWrRun('dArray labels',RecLab,16*nTocDA)
         Call iWrRun('dArray indices',RecIdx,nTocDA)
         Call iWrRun('dArray lengths',RecLen,nTocDA)
      Else
         Call cRdRun('dArray labels',RecLab,16*nTocDA)
         Call iRdRun('dArray indices',RecIdx,nTocDA)
         Call iRdRun('dArray lengths',RecLen,nTocDA)
      End If
*----------------------------------------------------------------------*
* Locate item                                                          *
*----------------------------------------------------------------------*
      item=-1
      CmpLab1=Label
      Call UpCase(CmpLab1)
      Do i=1,nTocDA
         CmpLab2=RecLab(i)
         Call UpCase(CmpLab2)
         If(CmpLab1.eq.CmpLab2) item=i
      End Do
*
* Do we create a new temporary field?
*
      If(item.eq.-1) Then
         Do i=1,nTocDA
            If(RecLab(i).eq.' ') item=i
         End Do
         If(item.ne.-1) Then
            RecLab(item)=Label
            RecIdx(item)=sSpecialField
            Call cWrRun('dArray labels',RecLab,16*nTocDA)
            Call iWrRun('dArray indices',RecIdx,nTocDA)
         End If
      End If
*
* Is this a temporary field?
*
      If(item.ne.-1) Then
         If(Recidx(item).eq.sSpecialField) Then
            Write(6,*) '***'
            Write(6,*) '*** Warning, writing temporary dArray field'
            Write(6,*) '***   Field: ',Label
            Write(6,*) '***'
#ifndef _DEVEL_
            Call AbEnd()
#endif
         End If
      End If
*----------------------------------------------------------------------*
* Write data to disk.                                                  *
*----------------------------------------------------------------------*
      If(item.eq.-1) Then
         Call SysAbendMsg('put_dArray','Could not locate',Label)
      End If
      Call dWrRun(RecLab(item),Data,ndata)
*     Write(6,*) Data
      If(RecIdx(item).eq.0) Then
         RecIdx(item)=sRegularField
         Call iWrRun('dArray indices',RecIdx,nTocDA)
      End If
      If(RecLen(item).ne.nData) Then
         RecLen(item)=nData
         Call iWrRun('dArray lengths',RecLen,nTocDA)
      End If
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_VECRD(SCR,LSCR,JVEC1,IVEC2,ISYM,
     &                     JNUM,IREDC,MUSED)
C
C     Purpose: read as many vectors as fit into SCR array starting
C              at vector JVEC1 and reading at most until vector IVEC2.
C              On exit, JNUM is the number of vectors read.
C              On entry as well as exit, IREDC identifies the reduced
C              set stored in core (at position "3"; use -1 if none
C              or unkown). Vectors are taken from buffer, if possible.
C
C     NOTE: if no vectors can be read, JNUM=0 and MUSED=0 are returned,
C           but execution is NOT stopped here!!!
C
#include "implicit.fh"
      DIMENSION SCR(LSCR)
#include "cholesky.fh"

      LOGICAL DOREAD

C     Initialize.
C     -----------

      JNUM = 0
      MUSED = 0
      IF (LSCR .LT. 1) RETURN

C     Copy vectors from buffer (if possible).
C     Only relevant for "external" runs (else the vectors are stored in
C     current reduced set).
C     -----------------------------------------------------------------

      IF (RUN_MODE .EQ. RUN_EXTERNAL) THEN
         CALL CHO_VECBUF_RETRIEVE(SCR,LSCR,JVEC1,IVEC2,ISYM,
     &                            JNUM,IREDC,MUSED)
      END IF

C     Read remaining vectors from disk.
C     ---------------------------------

      DOREAD = .TRUE.
      JV1 = JVEC1 + JNUM
      LFT = LSCR  - MUSED
      IF (IVEC2.GE.JV1 .AND. LFT.GT.0) THEN
         KS  = MUSED + 1
         JN  = 0
         MU  = 0
         CALL CHO_VECRD1(SCR(KS),LFT,JV1,IVEC2,ISYM,
     &                   JN,IREDC,MU,DOREAD)
         JNUM  = JNUM  + JN
         MUSED = MUSED + MU
      END IF

      END
      SUBROUTINE CHO_VECRD1(SCR,LSCR,JVEC1,IVEC2,ISYM,
     &                      JNUM,IREDC,MUSED,DOREAD)
C
C     Purpose: read as many vectors as fit into SCR array starting
C              at vector JVEC1 and reading at most until vector IVEC2.
C              On exit, JNUM is the number of vectors read.
C              On entry as well as exit, IREDC identifies the reduced
C              set stored in core (at position "3"; use -1 if none
C              or unkown). If DOREAD=.false. no vectors are actually
C              read in, but JNUM and MUSED are returned as appropriate.
C              Thus, array SCR is not referenced for DOREAD=.false.
C
C     NOTE: if no vectors can be read, JNUM=0 and MUSED=0 are returned,
C           but execution is NOT stopped here!!!
C
      use ChoArr, only: nDimRS
      use ChoSwp, only: InfVec
#include "implicit.fh"
      DIMENSION SCR(LSCR)
      LOGICAL   DOREAD
#include "cholesky.fh"

      external ddot_

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_VECRD1')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

      LOGICAL FULL

      JRED = 0  ! fix compiler warning

      IF (CHO_ADRVEC .EQ. 1) THEN  ! WA addressing

C        Count how many vectors can be read.
C        -----------------------------------

         JNUM = 0
         LTOT = 0
         JVEC = JVEC1 - 1
         FULL = LTOT .GE. LSCR
         IF (.NOT.Allocated(NDIMRS)) THEN
            ILOC = 3 ! use scratch location in reduced index arrays
            DO WHILE ((JVEC.LT.IVEC2) .AND. (.NOT.FULL))
               JVEC = JVEC + 1
               JRED = INFVEC(JVEC,2,ISYM)
               IF (JRED .NE. IREDC) THEN
                  CALL CHO_GETRED(JRED,ILOC,.FALSE.)
                  CALL CHO_SETREDIND(ILOC)
                  IREDC = JRED
               END IF
               LTOT = LTOT + NNBSTR(ISYM,ILOC)
               IF (LTOT .GT. LSCR) THEN
                  JVEC = JVEC - 1
                  LTOT = LTOT - NNBSTR(ISYM,ILOC)
                  FULL = .TRUE.
               ELSE
                  JNUM = JNUM + 1
               END IF
            END DO
         ELSE
            DO WHILE ((JVEC.LT.IVEC2) .AND. (.NOT.FULL))
               JVEC = JVEC + 1
               JRED = INFVEC(JVEC,2,ISYM)
               LTOT = LTOT + NDIMRS(ISYM,JRED)
               IF (LTOT .GT. LSCR) THEN
                  JVEC = JVEC - 1
                  LTOT = LTOT - NDIMRS(ISYM,JRED)
                  FULL = .TRUE.
               ELSE
                  JNUM = JNUM + 1
               END IF
            END DO
         END IF

C        Read vectors (if any).
C        ----------------------

         IF (DOREAD .AND. LTOT.GT.0) THEN
            IOPT = 2
            IADR = INFVEC(JVEC1,3,ISYM)
            CALL DDAFILE(LUCHO(ISYM),IOPT,SCR,LTOT,IADR)
         END IF

      ELSE IF (CHO_ADRVEC .EQ. 2) THEN ! DA adressing

C        Read as many vectors as can be read, one at a time.
C        ---------------------------------------------------

         JNUM = 0
         LTOT = 0
         KSCR = 1
         JVEC = JVEC1 - 1
         FULL = LTOT .GE. LSCR
         IF (.NOT.Allocated(NDIMRS)) THEN
            ILOC = 3 ! use scratch location in reduced index arrays
            DO WHILE ((JVEC.LT.IVEC2) .AND. (.NOT.FULL))
               JVEC = JVEC + 1
               JRED = INFVEC(JVEC,2,ISYM)
               IF (JRED .NE. IREDC) THEN
                  CALL CHO_GETRED(JRED,ILOC,.FALSE.)
                  CALL CHO_SETREDIND(ILOC)
                  IREDC = JRED
               END IF
               LTOT = LTOT + NNBSTR(ISYM,ILOC)
               IF (LTOT .GT. LSCR) THEN
                  JVEC = JVEC - 1
                  LTOT = LTOT - NNBSTR(ISYM,ILOC)
                  FULL = .TRUE.
               ELSE
                  JNUM = JNUM + 1
                  IF (DOREAD) THEN
                     IOPT = 2
                     LENR = NNBSTR(ISYM,ILOC)
                     IADR = INFVEC(JVEC,3,ISYM)
                     CALL DDAFILE(LUCHO(ISYM),IOPT,SCR(KSCR),LENR,IADR)
                     KSCR = KSCR + NNBSTR(ISYM,ILOC)
                  END IF
               END IF
            END DO
         ELSE
            DO WHILE ((JVEC.LT.IVEC2) .AND. (.NOT.FULL))
               JVEC = JVEC + 1
               JRED = INFVEC(JVEC,2,ISYM)
               LTOT = LTOT + NDIMRS(ISYM,JRED)
               IF (LTOT .GT. LSCR) THEN
                  JVEC = JVEC - 1
                  LTOT = LTOT - NDIMRS(ISYM,JRED)
                  FULL = .TRUE.
               ELSE
                  JNUM = JNUM + 1
                  IF (DOREAD) THEN
                     IOPT = 2
                     LENR = NDIMRS(ISYM,JRED)
                     IADR = INFVEC(JVEC,3,ISYM)
                     CALL DDAFILE(LUCHO(ISYM),IOPT,SCR(KSCR),LENR,IADR)
                     KSCR = KSCR + NDIMRS(ISYM,JRED)
                  END IF
               END IF
            END DO
         END IF

      ELSE  ! unknown file addressing

         CALL CHO_QUIT('CHO_ADRVEC error in '//SECNAM,102)
         LTOT = 0 ! dummy assignment to avoid compiler warnings

      END IF

C     Return total memory used for read.
C     ----------------------------------

      MUSED = LTOT

C     Debug print.
C     ------------

      IF (LOCDBG) THEN
         WRITE(LUPRI,*)
         WRITE(LUPRI,*) SECNAM,':'
         WRITE(LUPRI,*) 'Vector addressing: ',CHO_ADRVEC
         WRITE(LUPRI,*) 'DOREAD: ',DOREAD
         IF (JNUM .LT. 1) THEN
            IF (DOREAD) THEN
               WRITE(LUPRI,*) 'No vectors read!'
            ELSE
               WRITE(LUPRI,*) 'No vectors can be read!'
            END IF
         ELSE
            IF (DOREAD) THEN
               WRITE(LUPRI,*) 'Vectors ',JVEC1,' to ',JVEC1+JNUM-1,
     &                        ' of symmetry ',ISYM,' read from unit ',
     &                        LUCHO(ISYM)
               IF (Allocated(NDIMRS)) THEN
                  KOFFV = 1
                  DO IVEC = 1,JNUM
                     JVEC = JVEC1 + IVEC - 1
                     JADR = INFVEC(JVEC,3,ISYM)
                     JRED = INFVEC(JVEC,2,ISYM)
                     XNRM = SQRT(DDOT_(NDIMRS(ISYM,JRED),SCR(KOFFV),1,
     &                                                  SCR(KOFFV),1))
                     WRITE(LUPRI,*) 'Vector:',JVEC,' address: ',JADR,
     &                              ' norm: ',XNRM
                     KOFFV = KOFFV + NDIMRS(ISYM,JRED)
                  END DO
                  NTST = KOFFV - 1
                  IF (NTST .NE. MUSED) THEN
                    CALL CHO_QUIT('Vector dimension error in '//SECNAM,
     &                            104)
                  END IF
               END IF
            ELSE
               WRITE(LUPRI,*) 'Vectors ',JVEC1,' to ',JVEC1+JNUM-1,
     &                        ' of symmetry ',ISYM,' can be read'
            END IF
         END IF
         CALL CHO_FLUSH(LUPRI)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine hymat_2(maxroot,minspace,ndim,kval,mroot,dcrita,eval,
     *                   vcm,indx,th,nxh,vb1,vb2,nxb,vad)
c     *****************************************************************
c     the sub. based on the algorithm of davidson (e.r. davison, j.
c     comp. phys. 17,87 (1975)) for searching the m-th eigenvalue and
c     eigenvector of the symmetric matrix . this sub. is an improved
c     version of the one given by j. weber , r. lacroix and g. wanner
c     in computers & chemistry , 4 , 55 , 1980 .
c     *****************************************************************
      implicit real*8 (a,c,d,e,f,p,h,w,v,t,r)
      !parameter (maxroot=10,minspace=40)
!      common /file_descript/nf1,nf2,nf3,nf4,nf7,nf8,nf9,nf10,
!     *                      nf11,nf13,nf15,nf20
      dimension indx(minspace),vd(minspace),ve(minspace),
     :   vu(minspace,minspace),vp(minspace*(minspace+1)/2),
     :   th(nxh),vb1(nxb),vb2(nxb),vad(ndim)
      dimension eval(maxroot),vcm(ndim*mroot),eeval(maxroot)
      dimension residvb(maxroot),valpha(maxroot),deff(maxroot)
      dimension ecrita(maxroot)
      data depc/1.0e-7/
c**************************************************************
c
c      write(6,*) 'generate vector vb2 from matrix a and vector vb1'
c
c**************************************************************

      ! debugging
      !vb1(1:ndim)=0.d0; vb2(1:ndim)=0.d0
      !vb1(5)=1.d0
      !call abprod2(ndim,1,kval,th,nxh,vb1,vb2,nxb,vad)
      !do i=1,ndim
      !  write(6,"(i8,f18.8)") i,vb2(i)
      !enddo
      !stop 888

      ecrita=1.e-8
      iterat=1
      mrsta=1
      call abprod2(ndim,1,kval,th,nxh,vb1,vb2,nxb,vad)
      call matrmk2(ndim,1,kval,indx,vp,vb1,vb2,nxb)

c==============================================================
      write(6,*)
      l=0
      do k=1,kval
        write(6,1112) (vp(i),i=l+1,l+k)
        l=l+k
      enddo
      write(6,*)
c==============================================================
c
c     write(6,*) 'diagonalization of matrix p(j,j)'
c
c==============================================================
200   iterat=iterat+1
      if(iterat.eq.200) then
        write(6,*) " h0 space fail to converged"
        write(6,*) " program stop"
        call abend()
      endif
      eeval(1:mroot)=eval(1:mroot)
      call hotred(minspace,kval,vp,vd,ve,vu)
      call qlcm(minspace,kval,vd,ve,vu)

      valpha(mrsta:mroot)=0.d0
      do m=mrsta,mroot
        eval(m)=vd(m)
        do k=1,kval
          tm=abs(vu(k,m))
         if(valpha(m).lt.tm) valpha(m)=tm   !max(vu(k,m),k=1,kval)
        enddo
        valpha(m)=1-valpha(m)*valpha(m)
        if(valpha(m).gt.depc) valpha(m)=sqrt(valpha(m))
        deff(m)  =abs(eval(m)-eeval(m))
      enddo
c****************************************************************
c
c     construction of the new approximate eigenvector vcm(n)'
c
c****************************************************************
      ijm=indx(mrsta)
      vcm(ijm+1:ndim*mroot)=0.0d0
      do k=1,kval
        ijb=indx(k)
        do m=mrsta,mroot
          ijm=indx(m)
          vukm=vu(k,m)
          do i=1,ndim
            vcm(ijm+i)=vcm(ijm+i)+vukm*vb1(ijb+i)
          enddo
        enddo
      enddo

      !do i=1,ndim
      !    write(6,"(i8,f18.8)") i, vcm(i)
      !enddo


      write(6,1113) iterat,kval,
     :        (m,eval(m),deff(m),m=mrsta,mroot)
1113  format(2i3,10(2x,i2,f14.8,f14.8))

      nroot=mroot-mrsta+1

      if(kval.eq.mroot*2) goto 10

      mrsta0=mrsta
      do m=mrsta0,mroot
c        if(deff(m).lt.ecrita(m).or.valpha(m).lt.dcrita) then     ! conv
        if(m.eq.mrsta.and.deff(m).lt.ecrita(m)) then              ! conv
c         if(valpha(m).lt.dcrita) then                           ! conve
         mrsta=mrsta+1
        endif
      enddo
c      mrsta=mrsta+mrooted
      nroot=mroot-mrsta+1
      if(mrsta.gt.mroot) then
        write(6,*)
        write(6,*)mroot,' roots are convegenced,after',iterat,' iterat'
        goto 300
      endif

10    mmspace=min(mroot*3+10,ndim)
!      nroot=1             ! bbs debug error?
      if(kval+nroot.gt.mmspace) then

c===== start  reset_basis ======================================

        do m=mrsta,kval
          indxm=indx(m)
          vb1(indxm+1:indxm+ndim)=0.0d0
        enddo
        do m=mrsta,mroot
          ijm=indx(m)
          do k=1,kval
            ijb=indx(k)
            vukm=vu(k,m)
            do l=1,ndim
              vb1(ijm+l)=vb1(ijm+l)+vukm*vb2(ijb+l)  ! h*cm-->vb1
            enddo
          enddo
        enddo
        ijm=indx(mrsta)
        vb2(ijm+1:ijm+ndim*nroot)=vb1(ijm+1:ijm+ndim*nroot)  ! h*cm-->vb
        vb1(ijm+1:ijm+ndim*nroot)=vcm(ijm+1:ijm+ndim*nroot)  !   cm-->vb
        residvb(mrsta:mroot)=0.d0

        mval=mroot
        do m=mrsta,mroot
          ijm=indx(m)
          mval=mval+1
          ijmb1=indx(mval)
          do l=1,ndim
            depcc= eval(m)-vad(l)
            if(abs(depcc).lt.depc) depcc=depc
            tt=vb1(ijmb1+l)
            vb1(ijmb1+l)=(vb2(ijm+l)-vcm(ijm+l)*eval(m))/depcc
            residvb(m)=residvb(m)+vb1(ijmb1+l)*vb1(ijmb1+l)
          enddo
          call orthnor(ndim,mval,dcrita,vb1,nxb)
        enddo

        vb2(indx(mroot+1)+1:indx(kval+1)) =0.d0
        kval=mroot+nroot
        mval=mroot+1
        mn=mroot*(mroot+1)/2
        vp(1:mn)=0.0d0
        mn=0
        do m=1,mroot
          mn=mn+m
          vp(mn)=eval(m)
        enddo
        goto 100
c===== end  reset_basis ======================================
      endif

c
c     form the (j+1)-th approximate vector , vb1(n,j+1)
c
      jib1=indx(kval)
      jicm=indx(mrsta)

      residvb(mrsta:mroot)=0.d0
      do m=mrsta,mroot
        jib1=jib1+ndim
        do k=1,kval
          jib2=indx(k)
          do l=1,ndim
            vb1(jib1+l)=vb1(jib1+l)+vu(k,m)*vb2(jib2+l)
          enddo
        enddo

        do l=1,ndim
          depcc= eval(m)-vad(l)
          if(abs(depcc).lt.depc) depcc=depc
          vb1(jib1+l)=(vb1(jib1+l)-vcm(jicm+l)*eval(m))/depcc
          residvb(m)=residvb(m)+vb1(jib1+l)*vb1(jib1+l)
        enddo
        jicm=jicm+ndim
      enddo
      mval=kval+1
      do m=mrsta,mroot
        kval=kval+1
        call orthnor(ndim,kval,dcrita,vb1,nxb)
      enddo

100   call abprod2(ndim,mval,kval,th,nxh,vb1,vb2,nxb,vad)
      call matrmk2(ndim,mval,kval,indx,vp,vb1,vb2,nxb)

c=====  write out p_matrix =======================================
!      write(6,*)
!      write(nf2,*)
!      l=0
!      do k=1,kval
!        write(6 ,1112) (vp(i),i=l+1,l+k)
!        write(nf2,1112) (vp(i),i=l+1,l+k)
!        l=l+k
!     enddo
!      write(6,*)
c=====  write out p_matrix =======================================

      goto 200
c
300   continue

      ! copy ci vector to VB1
      do m=1,mroot
        ijm=indx(m)
        vb1(ijm+1:ijm+ndim)=vcm(ijm+1:ijm+ndim)
!       write(nf1) eval(m),(vcm(ijm+i),i=1,ndim)
!        write(6,"(5(1x,f18.9),1x,i2)") (vcm(ijm+i),i=1,4),vcm(35)
      enddo

1112  format(2x,20f14.8)

      return
      end

      subroutine matrmk2(n,k1,k2,indx,p,vb1,vb2,nxb)
      implicit real*8  (a-h,o-z)
      dimension p(465),indx(30),vb1(nxb),vb2(nxb)
      do 200 i=k1,k2
      iijj=i*(i-1)/2
      ij=indx(i)
      do 201 j=1,i
      ji=indx(j)
      p(iijj+j)=0.0d0
c--------------------------------------------------------------
      do 202 l=1,n
c-----------------------------------------------------------------
      p(iijj+j)=p(iijj+j)+vb1(ij+l)*vb2(ji+l)
202   continue
201   continue
200   continue
      return
      end

      subroutine abprod2(n,k1,k2,th,nxh,vb1,vb2,nxb,vad)
#include "drt_h.fh"
      dimension th(nxh),vb1(nxb),vb2(nxb),vad(n)
      !real*8,allocatable :: buff(:)
      !allocate(buff(n))
      ij=0
      do j=k1,k2
        ij=indx(j)
        do i=1,n
          vb2(ij+i)=vad(i)*vb1(ij+i)
        enddo
      enddo
c-------------------------------------------------------------------
      do 200 i=2,n
      mn=i*(i-1)/2
      do 201 j=k1,k2
      ij=indx(j)
      do 202 l=1,i-1
      vb2(ij+i)=vb2(ij+i)+th(mn+l)*vb1(ij+l)
      vb2(ij+l)=vb2(ij+l)+th(mn+l)*vb1(ij+i)
202   continue
201   continue
200   continue
c-------------------------------------------------------------------
      return
      end
c
      subroutine orthnor(n,j,dcrita,vb1,nxb)
#include "drt_h.fh"
      dimension vb1(nxb)
      ji=indx(j)
      if(j.eq.1) goto 150
      jm=j-1
      smax2=1.d10
120   smax1=0.0d0
      do 140 l=1,jm
      s=0.0d0
      ij=indx(l)
      do 130 i=1,n
      s=s+vb1(ij+i)*vb1(ji+i)
130   continue
      smax1=max(smax1,abs(s))
      do 141 i=1,n
        vb1(ji+i)=vb1(ji+i)-s*vb1(ij+i)
141   continue
140   continue

      if(smax1.lt.dcrita) goto 150
      if(smax1.gt.smax2) then
         write(6,*) 'dgnalization procedure is non-convergent.'
#ifdef MOLPRO
#else
      call abend()
#endif
#ifdef _XIANEST_
#endif
!        call abend
!         stop
      endif
      smax2=smax1
      goto 120
c     normalization of j-th eigenvector.
150   s=0.0d0
      do 160 i=1,n
      s=s+vb1(ji+i)*vb1(ji+i)
160   continue
      s=sqrt(s)
      do 170 i=1,n
      vb1(ji+i)=vb1(ji+i)/s
170   continue
      return
      end
c

      subroutine norm_a(n,av)  !bv:basis, av:vector for orth and norm
      real*8 av(n),s,ddot_,dcrita
      dcrita=1.0e-10
      smax2=1.d10
      smax1=0.0d0
c     normalization of av_eigenvector.
      s=0.0d0
      s=ddot_(n,av,1,av,1)
      s=sqrt(s)
      s=max(s,dcrita)
      do i=1,n
        av(i)=av(i)/s
      enddo

      return
      end

      subroutine orth_ab(n,av,bv)  !bv:basis, av:vector for orth
      real*8 av(n),bv(n),s,ddot_,dcrita
      dcrita=1.0e-10
      smax2=1.d10
      smax1=0.0d0
c     orthogonalization av,bv
      s=ddot_(n,av,1,bv,1)

      do i=1,n
        av(i)=av(i)-s*bv(i)
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
Subroutine Dispersion_Kriging(x0_,y_,ndimx)
  use kriging_mod
  Implicit None
  Integer ndimx
  Real*8 x0_(ndimx),y_
!
!x0 is the n-dimensional vector of the coordinates for which the dispersion is computed
!
        x0(:) = x0_(:)
        call covarvector(0) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
        call predict(0)
! 95% confidence -> 1.96*sigma
        y_ = 1.96d0*sigma
!
  return
End Subroutine Dispersion_Kriging

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine seths_cvb(arr,n)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n
character(len=*), intent(in) :: arr(n)
integer(kind=iwp) :: i, j, lenarr

call seth_cvb([n],1)
lenarr = len(arr)
do i=1,n
  do j=1,lenarr
    call seth_cvb([ichar(arr(i)(j:j))],1)
  end do
end do

return

end subroutine seths_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_Qualify(Diag,Sync,iShlAB,iSyMax,Mem,Full)
C
C     Purpose: qualify global diagonal elements for decomposition in
C              current reduced set.
C              iShlAB is the shell pair from which to qualify.
C              iSyMax is the symmetry block to which the largest
C              diagonal belongs.
C              Mem is the (total!) max. allowed
C              memory for storing the qualified columns.
C              If no more columns can be qualified on exit,
C              FULL=.true. is returned. On entry, Diag is the local
C              diagonal. The global diagonal is synchronized if
C              Sync=.True. on entry.
C
      use ChoSwp, only: Diag_G
      Implicit None
      Real*8  Diag(*)
      Logical Sync, Full
      Integer iShlAB, iSyMax, Mem
#include "cholesky.fh"
#include "cho_para_info.fh"
#include "choglob.fh"

      Integer iLoc

      Real*8 c1, c2, w1, w2

      Call Cho_Timer(c1,w1)

      If (Cho_Real_Par) Then

C        Sync global diagonal (if requested).
C        ------------------------------------

         If (Sync) Then
            iLoc = 2
            Call Cho_P_SyncDiag(Diag,iLoc)
         End If

C        Swap local and global index arrays and use the original serial
C        routines for qualifying diagonals.
C        --------------------------------------------------------------
C-TODO/FIXME: the memory constraint is then based on the global
C             dimension, thus ensuring that all nodes find the same
C             qualified (and this is absolutely essential!). However,
C             one might find a more clever way of ensuring this....

         Call Cho_P_IndxSwp()
         Call Cho_Qualify(Diag_G,iShlAB,iSyMax,Mem,Full)
         Call Cho_P_IndxSwp()

      Else

         Call Cho_Qualify(Diag,iShlAB,iSyMax,Mem,Full)

      End If

      Call Cho_Timer(c2,w2)
      tMisc(1,1)=tMisc(1,1)+c2-c1
      tMisc(2,1)=tMisc(2,1)+w2-w1

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DENS1T_RPT2(CI1,CI2,SGM1,G1,NLEV)

use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
use Symmetry_Info, only: Mul
use sguga, only: CIS, L2ACT, SGS
use PrintLevel, only: DEBUG
use caspt2_global, only: iPrGlb
use caspt2_module, only: iSCF, MxCI, nActEl, nAshT, nG1, STSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CI1(MXCI), CI2(MXCI)
integer(kind=iwp), intent(in) :: nLev
real(kind=wp), intent(out) :: SGM1(MXCI), G1(NLEV,NLEV)
integer(kind=iwp) :: ID, ISSG, IST, ISTU, ISU, IT, ITASK, IU, LT, LU, NSGM, NTASKS
real(kind=wp) :: GTU
integer(kind=iwp), allocatable :: TASK(:,:)
real(kind=wp), external :: ddot_, dnrm2_

! Purpose: Compute the 1- and 2-electron density matrix
! arrays G1 and G2.
G1(:,:) = Zero

! For the special cases, there is no actual CI-routines involved:
if (ISCF == 2) then
  ! Special code for hi-spin case:
  do IT=1,NASHT
    G1(IT,IT) = One
  end do
else if ((ISCF == 1) .and. (NACTEL > 0)) then
  ! Special code for closed-shell:
  do IT=1,NASHT
    G1(IT,IT) = Two
  end do
else

  ! For the general cases, we use actual CI routine calls, and
  ! have to take account of orbital order.
  ! We will use level inices LT,LU... in these calls, but produce
  ! the density matrices with usual active orbital indices.
  ! Translation tables L2ACT and LEVEL, in caspt2_module

  !-SVC20100311: set up a task table with LT,LU
  nTasks = nLev**2
  call mma_allocate(Task,nTasks,2,Label='TASK')

  iTask = 0
  do LT=1,nLev
    TASK(iTask+1:iTask+nLev,1) = LT
    TASK(iTask+1:iTask+nLev,2) = [(LU,LU=1,nLev)]
    iTask = iTask+nLev
  end do
  if (iTask /= nTasks) write(u6,*) 'ERROR nTasks'

  call Init_Tsk(ID,nTasks)

  !-SVC20100311: BEGIN SEPARATE TASK EXECUTION
  do while (Rsv_Tsk(ID,iTask))
    ! Compute SGM1 = E_UT acting on CI, with T >= U,
    ! i.e., lowering operations. These are allowed in RAS.
    !LTU = 0
    !do LT=1,NLEV
    LT = TASK(iTask,1)
    IST = SGS%ISM(LT)
    IT = L2ACT(LT)
    !do LU=1,LT
    LU = Task(iTask,2)
    !LTU = LTU+1
    !LTU = iTask
    ISU = SGS%ISM(LU)
    IU = L2ACT(LU)
    ISTU = Mul(IST,ISU)
    ISSG = Mul(ISTU,STSYM)
    NSGM = CIS%NCSF(ISSG)
    if (NSGM == 0) cycle
    call GETSGM2(LU,LT,STSYM,CI1,MXCI,SGM1,NSGM)
    if (ISTU == 1) then
      GTU = DDOT_(NSGM,CI2,1,SGM1,1)
      G1(IT,IU) = G1(IT,IU)+GTU
    end if

    !SVC: The master node now continues to only handle task scheduling,
    !     needed to achieve better load balancing. So it exits from the task
    !     list.  It has to do it here since each process gets at least one
    !     task.
  end do
  call Free_Tsk(ID)
  call mma_deallocate(Task)
  call GAdGOP(G1,NG1,'+')
end if

if (iPrGlb >= DEBUG) then
  write(u6,'("DEBUG> ",A)') 'DENS1_RPT2: norms of the density matrices:'
  write(u6,'("DEBUG> ",A,1X,ES21.14)') 'G1:',DNRM2_(NG1,G1,1)
end if

end subroutine DENS1T_RPT2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine TRACI_MASTER(JOBDISK,JOBIPH,CMOMO,lrec)

use CandS, only: ISSM, ISSPC
use lucia_data, only: Deallocate_Local_Arrays, DTOC, IDISK, INT1, IREFSM, kvec3_length, LUC, LUDIA, LUHC, LUSC1, LUSC2, MXNTTS, &
                      MXSOOB, NCSF_PER_SYM, NROOT, NSMOB, NTOOB, NTOOBS, PSSIGN, SDREO, VEC3, XISPSM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(inout) :: JOBDISK
integer(kind=iwp), intent(in) :: JOBIPH
real(kind=wp), intent(in) :: CMOMO(*)
integer(kind=iwp), intent(out) :: LREC(MXNTTS)
integer(kind=iwp) :: I, I_DUMMY(1), IADR, IATP, IBTP, ICOL, IOFF, IROW, ISM, J, JDISK, JROOT, LBLK, LBLOCK, NBATCH, NBLOCK, NCONF, &
                     NDIM, NREC
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IREC, NUM_ELE
#endif
real(kind=wp), allocatable :: LCMOMO(:), LH1SAVE(:), VEC1(:), VEC2(:), VEC4(:)

LBLK = -1
NDIM = NTOOB*NTOOB
NCONF = NCSF_PER_SYM(ISSM)
! JESPER: Should reduce I/O
LBLOCK = max(int(XISPSM(IREFSM,1)),MXSOOB)
if (PSSIGN /= Zero) LBLOCK = int(Two*XISPSM(IREFSM,1))

! The three scratch  blocks
call mma_allocate(VEC1,LBLOCK,Label='VEC1')
call mma_allocate(VEC2,LBLOCK,Label='VEC2')
call mma_allocate(VEC3,KVEC3_LENGTH,Label='VEC3')
call mma_allocate(VEC4,NCONF,Label='VEC4')

! Transfer the CI-vector to LUC

call BLKFO_MIN(ISSM,NREC,LREC)
IDISK(LUC) = 0
JDISK = JOBDISK
do JROOT=1,NROOT
  call DDAFILE(JOBIPH,2,VEC4,NCONF,JDISK)
  call CSDTVC(VEC4,VEC1,1,DTOC,SDREO,ISSM,0)
# ifdef _DEBUGPRINT_
  write(u6,*) 'CI-vector written to disk for root = ',JROOT
  call WRTMAT(VEC1,1,20,1,20)
  write(u6,*) 'Writing this to disk:'
  IOFF = 1
  do IREC=1,NREC
    if (LREC(IREC) >= 0) then
      call WRTMAT(VEC1(IOFF),1,LREC(IREC),1,LREC(IREC))
      IOFF = IOFF+LREC(IREC)
    end if
  end do
# endif
  call TODSCN(VEC1,NREC,LREC,LBLK,LUC)
  I_DUMMY(1) = -1
  call ITODS(I_DUMMY,1,LBLK,LUC)
end do

! MO-MO transformation matrix :
call mma_allocate(LCMOMO,NDIM,Label='LCMOMO')
! Copy of one-electron integrals
call mma_allocate(LH1SAVE,NDIM,Label='LH1SAVE')
! We are going to mess with the one-electron integrals, take a copy
LH1SAVE(:) = INT1(:)
! Set up block structure of CI space
IATP = 1
IBTP = 2
call Z_BLKFO(ISSPC,ISSM,IATP,IBTP,NBATCH,NBLOCK)

call Deallocate_Local_Arrays()

! The input transformation matrix contains a lot of zeros which
! is expected not to be there in Traci_Lucia, so remove them.

LCMOMO(:) = Zero
IOFF = 1
IADR = 1
ICOL = 1
do ISM=1,NSMOB
  if (NTOOBS(ISM) > 0) then
    IROW = ICOL
    do I=1,NTOOBS(ISM)
      IADR = (ICOL-1)*NTOOB+IROW
      do J=1,NTOOBS(ISM)
        LCMOMO(IOFF+NTOOBS(ISM)*(J-1)+I-1) = CMOMO(IADR+J-1)
      end do
      ICOL = ICOL+1
    end do
    IOFF = IOFF+NTOOBS(ISM)**2
  end if
end do

! Now the actual work

IDISK(LUC) = 0
IDISK(LUDIA) = 0
do JROOT=1,NROOT
  IDISK(LUSC1) = 0
  call COPVCD(LUC,LUSC1,VEC1,0,LBLK)
  call COPVCD(LUSC1,LUSC2,VEC1,1,LBLK)

  ! Transform CI vector : Input on LUHC, output on LUDIA (!)
  call COPVCD(LUSC1,LUHC,VEC1,1,LBLK)

  call TRACI_LUCIA(LCMOMO,LUHC,LUDIA,ISSPC,ISSM,VEC1,VEC2)
end do
! End of loop over roots
IDISK(LUDIA) = 0

! Copy CI-vector back to MOLCAS JOBIPH file

do JROOT=1,NROOT
  call FRMDSCN(VEC1,NREC,LBLK,LUDIA)
# ifdef _DEBUGPRINT_
  NUM_ELE = sum(LREC(1:NREC))
  write(u6,*) 'CI-Vector read from disk for root = ',JROOT
  call WRTMAT(VEC1,1,NUM_ELE,1,NUM_ELE)
# endif
  call CSDTVC(VEC2,VEC1,2,DTOC,SDREO,ISSM,0)
  call DDAFILE(JOBIPH,1,VEC2,NCONF,JOBDISK)
  call IFRMDS(I_DUMMY,1,LBLK,LUDIA)
end do
IDISK(LUDIA) = 0

#ifdef _DEBUGPRINT_
do JROOT=1,NROOT
  call WRTVCD(VEC1,LUDIA,0,LBLK)
end do
#endif

! clean up time : copy 1-e integrals back in place
INT1(:) = LH1SAVE(:)

call mma_deallocate(VEC1)
call mma_deallocate(VEC2)
call mma_deallocate(VEC3)
call mma_deallocate(VEC4)
call mma_deallocate(LCMOMO)
call mma_deallocate(LH1SAVE)

end subroutine TRACI_MASTER

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Steven Vancoillie                                *
!***********************************************************************
MODULE DENSITY
  ! implements 1-electron density matrix
  ! implements 2-electron density matrix

  ! Steven Vancoillie, November 2013, Lund

  USE ISO_FORTRAN_ENV, ONLY: REAL64
  USE SECOND_QUANTIZATION
  USE WAVEFUNCTION
  IMPLICIT NONE

CONTAINS

  SUBROUTINE D1_EXC(PSI,D1)
    ! use excitation operator and DDOT to build
    ! the one-electron density matrix
    IMPLICIT NONE
    TYPE(WFN), INTENT(IN) :: PSI
    REAL(REAL64), INTENT(OUT) :: D1(:,:)
    REAL(REAL64), ALLOCATABLE :: SIGMA(:,:)
    INTEGER :: P, Q, IDET, DET, TMP, IRANK
    REAL(REAL64), EXTERNAL :: DDOT_

    ALLOCATE(SIGMA(PSI%NDETA,PSI%NDETB))

    DO Q = 1, PSI%NORB
      DO P = 1, PSI%NORB
        SIGMA = 0.0D0

        DET = LEX_INIT(PSI%NELB,PSI%NORB)
        DO IDET = 1, PSI%NDETB
          TMP = EX1(P,Q,DET)
          IF (TMP.NE.-1) THEN
            IRANK=RANK_(TMP)
            SIGMA(:,IRANK) = SIGMA(:,IRANK) + PSI%COEF(:,IDET) * SIGN(1,TMP)
          END IF
          DET = LEX_NEXT(DET)
        END DO

        DET = LEX_INIT(PSI%NELA,PSI%NORB)
        DO IDET = 1, PSI%NDETA
          TMP = EX1(P,Q,DET)
          IF (TMP.NE.-1) THEN
            IRANK=RANK_(TMP)
            SIGMA(IRANK,:) = SIGMA(IRANK,:) + PSI%COEF(IDET,:) * SIGN(1,TMP)
          END IF
          DET = LEX_NEXT(DET)
        END DO

        D1(P,Q) = DDOT_(PSI%NDETA*PSI%NDETB,SIGMA,1,PSI%COEF,1)
      END DO
    END DO
  END SUBROUTINE D1_EXC

  SUBROUTINE D1_ANN(PSI,D1)
    ! use annihilation operators on bra and ket
    ! combined with matrix multiply to build the
    ! one-electron density matrix
    IMPLICIT NONE
    TYPE(WFN), INTENT(IN) :: PSI
    REAL(REAL64), INTENT(OUT) :: D1(:,:)
    REAL(REAL64), ALLOCATABLE :: BRA(:,:,:), KET(:,:,:)
    INTEGER :: P, NORB
    INTEGER :: IA, IB, MDETA, MDETB, NDETSUB
    INTEGER :: DET, TMP, IRANK
    INTEGER :: F

    NORB=PSI%NORB

    D1=0.0D0

    ! alpha subspace
    MDETA=BINOM_COEF(PSI%NELA-1,PSI%NORB)
    MDETB=PSI%NDETB
    NDETSUB=MDETA*MDETB

    ALLOCATE(BRA(MDETB,MDETA,NORB))
    ALLOCATE(KET(MDETB,MDETA,NORB))

    KET=0.0D0
    DO P=1,NORB
      DET=LEX_INIT(PSI%NELA,NORB)
      DO IA=1,PSI%NDETA
        TMP=ANN(P,DET)
        IF (TMP.NE.-1) THEN
          IRANK=RANK_(TMP)
          F=SIGN(1,TMP)
          DO IB=1,PSI%NDETB
            KET(IB,IRANK,P) = PSI%COEF(IA,IB) * F
          END DO
        END IF
        DET = LEX_NEXT(DET)
      END DO
    END DO
    BRA(:,:,:)=KET

    CALL DGEMM_('T','N',NORB,NORB,NDETSUB,1.0D0,BRA,NDETSUB,KET,NDETSUB,1.0D0,D1,NORB)

    DEALLOCATE(BRA)
    DEALLOCATE(KET)

    ! beta subspace
    MDETA=PSI%NDETA
    MDETB=BINOM_COEF(PSI%NELB-1,PSI%NORB)
    NDETSUB=MDETA*MDETB

    ALLOCATE(BRA(MDETA,MDETB,NORB))
    ALLOCATE(KET(MDETA,MDETB,NORB))

    KET=0.0D0
    DO P = 1, PSI%NORB
      DET=LEX_INIT(PSI%NELB,PSI%NORB)
      DO IB=1,PSI%NDETB
        TMP=ANN(P,DET)
        IF (TMP.NE.-1) THEN
          IRANK=RANK_(TMP)
          F=SIGN(1,TMP)
          DO IA=1,PSI%NDETA
            KET(IA,IRANK,P) = PSI%COEF(IA,IB) * F
          END DO
        END IF
        DET = LEX_NEXT(DET)
      END DO
    END DO
    BRA(:,:,:)=KET

    CALL DGEMM_('T','N',NORB,NORB,NDETSUB,1.0D0,BRA,NDETSUB,KET,NDETSUB,1.0D0,D1,NORB)

    DEALLOCATE(BRA)
    DEALLOCATE(KET)

  END SUBROUTINE D1_ANN

  SUBROUTINE D2_ANN(PSI,D2)
    ! use annihilation operators on bra and ket
    ! combined with matrix multiply to build the
    ! two-electron density matrix
    !
    ! first compute â_s â_q | psi > for all s,q
    ! then use that as both bra and ket to construct
    ! the matrix D(r,p,s,q) = <psi|E_pqrs|psi>
    ! this is done for each spin combination of
    ! the s and q orbitals and then summed
    IMPLICIT NONE
    TYPE(WFN), INTENT(IN) :: PSI
    REAL(REAL64), INTENT(OUT) :: D2(:,:,:,:)
    REAL(REAL64), ALLOCATABLE :: BRA(:,:,:,:), KET(:,:,:,:)
    INTEGER :: P, Q, NORB, NORB2
    INTEGER :: IA, IB, MDETA, MDETB, NDETSUB
    INTEGER :: DETA, DETB, TMPA, TMPB, IRANKA, IRANKB
    INTEGER :: FA, FB

    D2 = 0.0D0

    NORB=PSI%NORB
    NORB2=NORB**2

    ! alpha-alpha subspace
    MDETA=BINOM_COEF(PSI%NELA-2,PSI%NORB)
    MDETB=PSI%NDETB
    NDETSUB=MDETA*MDETB

    ALLOCATE(BRA(MDETB,MDETA,NORB,NORB))
    ALLOCATE(KET(MDETB,MDETA,NORB,NORB))

    KET=0.0D0
    DO P=1,NORB
      DO Q=1,NORB
        DETA=LEX_INIT(PSI%NELA,NORB)
        DO IA=1,PSI%NDETA
          TMPA=ANN2(P,Q,DETA)
          IF (TMPA.NE.-1) THEN
            IRANKA=RANK_(TMPA)
            FA=SIGN(1,TMPA)
            DO IB=1,PSI%NDETB
              KET(IB,IRANKA,P,Q) = PSI%COEF(IA,IB) * FA
            END DO
          END IF
          DETA = LEX_NEXT(DETA)
        END DO
      END DO
    END DO
    BRA(:,:,:,:)=KET

    CALL DGEMM_('T','N',NORB2,NORB2,NDETSUB,1.0D0, &
        & BRA,NDETSUB,KET,NDETSUB,1.0D0,D2,NORB2)

    DEALLOCATE(BRA)
    DEALLOCATE(KET)

    ! beta-beta subspace
    MDETA=PSI%NDETA
    MDETB=BINOM_COEF(PSI%NELB-2,PSI%NORB)
    NDETSUB=MDETA*MDETB
    ALLOCATE(BRA(MDETA,MDETB,NORB,NORB))
    ALLOCATE(KET(MDETA,MDETB,NORB,NORB))

    KET=0.0D0
    DO P=1,NORB
      DO Q=1,NORB
        DETB=LEX_INIT(PSI%NELB,PSI%NORB)
        DO IB=1,PSI%NDETB
          TMPB=ANN2(P,Q,DETB)
          IF (TMPB.NE.-1) THEN
            IRANKB=RANK_(TMPB)
            FB=SIGN(1,TMPB)
            DO IA=1,PSI%NDETA
              KET(IA,IRANKB,P,Q) = PSI%COEF(IA,IB) * FB
            END DO
          END IF
          DETB = LEX_NEXT(DETB)
        END DO
      END DO
    END DO
    BRA(:,:,:,:)=KET

    CALL DGEMM_('T','N',NORB2,NORB2,NDETSUB,1.0D0, &
        & BRA,NDETSUB,KET,NDETSUB,1.0D0,D2,NORB2)

    DEALLOCATE(BRA)
    DEALLOCATE(KET)

    ! alpha beta
    MDETA=BINOM_COEF(PSI%NELA-1,PSI%NORB)
    MDETB=BINOM_COEF(PSI%NELB-1,PSI%NORB)
    NDETSUB=MDETA*MDETB
    ALLOCATE(BRA(MDETB,MDETA,NORB,NORB))
    ALLOCATE(KET(MDETB,MDETA,NORB,NORB))

    KET=0.0D0
    DO P=1,NORB
      DO Q=1,NORB
        DETA=LEX_INIT(PSI%NELA,NORB)
        DO IA=1,PSI%NDETA
          TMPA=ANN(P,DETA)
          IF (TMPA.NE.-1) THEN
            IRANKA=RANK_(TMPA)
            FA=SIGN(1,TMPA)
            DETB=LEX_INIT(PSI%NELB,NORB)
            DO IB=1,PSI%NDETB
              TMPB=ANN(Q,DETB)
              IF (TMPB.NE.-1) THEN
                IRANKB=RANK_(TMPB)
                FB=SIGN(1,TMPB)*(-1)**(PSI%NELA)
                KET(IRANKB,IRANKA,P,Q) = PSI%COEF(IA,IB) * FA * FB
              END IF
              DETB = LEX_NEXT(DETB)
            END DO
          END IF
          DETA = LEX_NEXT(DETA)
        END DO
      END DO
    END DO
    BRA(:,:,:,:)=KET

    CALL DGEMM_('T','N',NORB2,NORB2,NDETSUB,1.0D0, &
        & BRA,NDETSUB,KET,NDETSUB,1.0D0,D2,NORB2)

    DEALLOCATE(BRA)
    DEALLOCATE(KET)

    ! beta alpha
    MDETA=BINOM_COEF(PSI%NELA-1,PSI%NORB)
    MDETB=BINOM_COEF(PSI%NELB-1,PSI%NORB)
    NDETSUB=MDETA*MDETB
    ALLOCATE(BRA(MDETA,MDETB,NORB,NORB))
    ALLOCATE(KET(MDETA,MDETB,NORB,NORB))

    KET=0.0D0
    DO P=1,NORB
      DO Q=1,NORB
        DETB=LEX_INIT(PSI%NELB,NORB)
        DO IB=1,PSI%NDETB
          TMPB=ANN(P,DETB)
          IF (TMPB.NE.-1) THEN
            IRANKB=RANK_(TMPB)
            FB=SIGN(1,TMPB)*(-1)**(PSI%NELA-1)
            DETA=LEX_INIT(PSI%NELA,NORB)
            DO IA=1,PSI%NDETA
              TMPA=ANN(Q,DETA)
              IF (TMPA.NE.-1) THEN
                IRANKA=RANK_(TMPA)
                FA=SIGN(1,TMPA)
                KET(IRANKA,IRANKB,P,Q) = PSI%COEF(IA,IB) * FA * FB
              END IF
              DETA = LEX_NEXT(DETA)
            END DO
          END IF
          DETB = LEX_NEXT(DETB)
        END DO
      END DO
    END DO
    BRA(:,:,:,:)=KET

    CALL DGEMM_('T','N',NORB2,NORB2,NDETSUB,1.0D0, &
        & BRA,NDETSUB,KET,NDETSUB,1.0D0,D2,NORB2)

    DEALLOCATE(BRA)
    DEALLOCATE(KET)

  END SUBROUTINE D2_ANN

END MODULE DENSITY

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gugadrt_njexcit(indjk,ljk,iextbit,nextbit,ivalid,jstep,kttmp,k0)

use gugadrt_global, only: iref_occ, n_ref
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ljk, iextbit, nextbit, jstep, k0
integer(kind=iwp), intent(inout) :: indjk(ljk), kttmp
integer(kind=iwp), intent(out) :: ivalid
integer(kind=iwp) :: i, idxref, inm, itexcit(n_ref), ival, kp

kp = k0
do idxref=1,n_ref
  call upacknod(indjk,idxref,ival,nextbit,iextbit,ljk)
  if (jstep == 1 .or. jstep == 2) then
    if (iref_occ(kp+1,idxref) == 0) ival = ival+1
  end if
  if (jstep == 3) then
    if (iref_occ(kp+1,idxref) == 0) ival = ival+2
    if (iref_occ(kp+1,idxref) == 1) ival = ival+1
  end if
  if (ival > 2) ival = 3
  itexcit(idxref) = ival
end do
inm = minval(itexcit)

if (inm > 2) then
  ivalid = 0
else
  kttmp = inm
  ivalid = 1
  if (jstep /= 0) then
    do i=1,n_ref
      ival = itexcit(i)
      call packnod(indjk,i,ival,nextbit,iextbit,ljk)
    end do
  end if
end if

return

end subroutine gugadrt_njexcit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine caspt2_grad_invaria2(NDPT2,nOLag,DPT2,OLag)
! Compute pseudo-density in the inactive and secondary orbital blocks for MRPT2 methods that are not invariant with respect to
! orbital rotations among inactive and secondary orbitals using the canonical condition of MOs
! See the IPEA-shift implementation for the active block non-invariance, and the sigma^P implementation for the non-invariance
! with respect to rotations in the internally contracted basis

use caspt2_module, only: EPSE, EPSI, nAsh, nBas, nDel, nFro, nIsh, nSsh, nSym
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDPT2, nOLag
real(kind=wp), intent(inout) :: DPT2(NDPT2)
real(kind=wp), intent(in) :: OLag(nOLag)
integer(kind=iwp) :: iMO, iOrb, iSym, jOrb, nAshI, nFroI, nIshI, nOrbI, nSshI
real(kind=wp) :: Tmp

iMO = 1
do iSym=1,nSym
  nOrbI = nBas(iSym)-nDel(iSym)
  nFroI = nFro(iSym)
  nIshI = nIsh(iSym)
  if (nIshI > 0) then
    do iOrb=nFroI+1,nFroI+nIshI
      do jOrb=iOrb+1,nFroI+nIshI
        Tmp = -Half*(OLag(iMO+iOrb-1+nOrbI*(jOrb-1))-OLag(iMO+jOrb-1+nOrbI*(iOrb-1)))/(EPSI(iOrb-nFroI)-EPSI(jOrb-nFroI))
        DPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) = Tmp
        DPT2(iMO+jOrb-1+nOrbI*(iOrb-1)) = Tmp
      end do
    end do
  end if
  nSshI = nSsh(iSym)
  nAshI = nAsh(iSym)
  if (nSshI > 0) then
    do iOrb=nOrbI-nSshI+1,nOrbI
      do jOrb=iOrb+1,nOrbI
        Tmp = -Half*(OLag(iMO+iOrb-1+nOrbI*(jOrb-1))-OLag(iMO+jOrb-1+nOrbI*(iOrb-1)))/ &
              (EPSE(iOrb-nFroI-nIshI-nAshI)-EPSE(jOrb-nFroI-nIshI-nAshI))
        DPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) = Tmp
        DPT2(iMO+jOrb-1+nOrbI*(iOrb-1)) = Tmp
      end do
    end do
  end if
  iMO = iMO+nOrbI*nOrbI
end do

end subroutine caspt2_grad_invaria2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine UpOrb(n,o,w,Orb,Lab)

use Genano_globals, only: MxLqn, iSymBk, pDsym, Center, symlab
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: o, w, Orb(n)
character(len=*), intent(in) :: Lab(n)
integer(kind=iwp) :: i, iBas, iBlk, ind, jBas, indx((MxLqn+1)**2), jndx
real(kind=wp) :: add

indx(:) = 0
do iBas=1,n
  !write(u6,'(a,i5)') '     iBas:',iBas
  if (Lab(iBas)(1:len(Center)) == Center) then
    iBlk = 0
    do i=1,(MxLqn+1)**2
      if (symlab(i) == Lab(iBas)(len(Center)+1:)) iBlk = i
    end do
    !write(u6,'(a,i5)') '       iBlk:',iBlk
    if (iBlk == 0) then
      write(u6,*) 'Unknown basis function: ',Lab(iBas)(len(Center)+1:)
      call Quit_OnUserError()
    end if
    indx(iBlk) = indx(iBlk)+1
    !write(u6,'(a,i5)') '     indx:',indx(iBlk)
    jndx = 0
    do jBas=1,iBas
      !write(u6,'(a,i5)') '       jBas:',jBas
      if (Lab(jBas)(1:len(Center)) == Center) then
        if (Lab(iBas)(len(Center)+1:) == Lab(jBas)(len(Center)+1:)) then
          jndx = jndx+1
          !write(u6,'(a,i5)') '     jndx:',jndx
          ind = jndx+indx(iBlk)*(indx(iBlk)-1)/2+iSymBk(iBlk)-1
          !add = w*o*Cmo(iBas)*Cmo(jBas)
          add = w*o*Orb(iBas)*Orb(jBas)
          pDsym(ind) = pDsym(ind)+add
          !write(u6,'(a,f12.6,a,i5)') 'add',add,' to',ind
        end if
      end if
    end do
  end if
end do

return

end subroutine UpOrb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Christian Ander                                  *
!***********************************************************************

subroutine ts_bfgs(dq,y,H,nH)
!     Hessian update method; TS-BFGS ; Bofill - "Remarks on the
!     Updated Hessian Matrix Methods" 2003.
!
!     Vectors in the article are column vectors.
!
!     Implemented by Christian Ander, 2005, christian@eximius.se
!                                                                      *
!***********************************************************************
!                                                                      *
!     dq    :  Perturbation Geometry      (nH)
!     y     :  Difference in Gradient     (nH)
!     WorkM :  Temporary working matrix   (nH,nH)
!     WorkV :  Temporary working vector   (nH)
!     WorkR :  Temporary working variable (real)
!     H     :  Hessian                    (nH,nH)
!     nH    :  Hessian size               (integer)
!     f,a,b :  Multi-used variables       (real)
!     v,u   :  Multi-used vectors         (nH)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nH
real(kind=wp), intent(in) :: dq(nH), y(nH)
real(kind=wp), intent(inout) :: H(nH,nH)
integer(kind=iwp) :: i
real(kind=wp) :: a, b, f, WorkR
real(kind=wp), allocatable :: u(:), v(:), WorkM(:,:), WorkV(:)
real(kind=wp), external :: ddot_

call mma_allocate(WorkM,nH,nH,label='WorkM')
call mma_allocate(WorkV,nH,label='WorkV')
call mma_allocate(v,nH,label='v')
call mma_allocate(u,nH,label='u')
!                                                                      *
!***********************************************************************
!                                                                      *
! Equation 23 calculates the new Hessian, some simplifications :
!
! H_k+1 = H_k + 1/f (v*u^T + u*v^T - (y^T*dq - dq^T*B*dq)/f * u*u^T)
!
! Where f = (y^T*dq)^2 + (dq^T|B|dq)^2 = a^2 + b^2
! ,     u = y^T*dq*y + (dq^T|B|dq)|B|dq = a*y + b|B|dq
! and   v = y - B*dq (quasi-Newton condition)

#ifdef _DEBUGPRINT_
! Make a comment in logfile
write(u6,*) 'hello from ts_bfgs'
#endif

! Calculation of u = y^T*dq*y + (dq^T|B|dq)|B|dq

! a = y^T * dq

a = DDot_(nH,y,1,dq,1)

! u = y^T*dq*y = a * y

u(:) = a*y(:)

! WorkM = |B|

WorkM(:,:) = abs(H(:,:))

! WorkV = |B|dq

call dGeMV_('N',nH,nH,One,WorkM,nH,dq,1,Zero,WorkV,1)

! b = (dq^T|B|dq) = dq^T * WorkV

b = DDot_(nH,dq,1,WorkV,1)

! u = y^T*dq*y + (dq^T|B|dq)|B|dq = u + b * WorkV

u(:) = u(:)+b*WorkV(:)

! Calculation of f = (y^T*dq)^2 + (dq^T|B|dq)^2 = a^2 + b^2

f = a**2+b**2

! Calculation of v = y - B * dq (quasi-Newton condition)

v(:) = y(:)
call dGeMV_('N',nH,nH,-One,H,nH,dq,1,One,v,1)

! Calculation of equation 23, the new Hessian

! H_k+1 = H_k + 1/f (v*u^T + u*v^T - (a - dq^T*B*dq)/f * u*u^T)

! WorkM = u*u^T

call DGEMM_('N','N',nH,nH,1,One,u,nH,u,1,Zero,WorkM,nH)

! WorkV = dq^T*B

call DGEMM_('N','N',1,nH,nH,One,dq,1,H,nH,Zero,WorkV,1)

! WorkR = (a - dq^T*B*dq)/f = (a - WorkV * dq) / f

WorkR = (a-DDot_(nH,WorkV,1,dq,1))/f

! H_k+1 = H_k + 1/f ( v*u^T + u*v^T - (a - dq^T*B*dq)/f * u*u^T ) =
!         H_k + 1/f ( v*u^T + u*v^T - WorkR * WorkM )

do i=1,nH
  H(:,i) = H(:,i)+One/f*(v(i)*u(:)+u(i)*v(:)-WorkR*WorkM(:,i))
end do

#ifdef _DEBUGPRINT_
! Checking the quasi-Newton condition.

! WorkV = H * dq

call dGeMV_('N',nH,nH,One,H,nH,dq,1,Zero,WorkV,1)

! WorkV = WorkV - y = 0.0

WorkV(:) = WorkV(:)-y(:)
call RecPrt('quasi-Newton',' ',WorkV,1,nH)

write(u6,*) 'good-bye from ts_bfgs'
#endif

call mma_deallocate(WorkM)
call mma_deallocate(WorkV)
call mma_deallocate(v)
call mma_deallocate(u)

return

end subroutine ts_bfgs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE EXTRT_MS_OPEN_OB(IDET_OC,IDET_MS,IDET_OPEN_MS,NEL)
*
* A determinant IDET_OC, IDET_MS is given. Extract spinprojections
* for open shells
*
* Jeppe Olsen, December 2001
*
#include "implicit.fh"
*.input
      INTEGER IDET_OC(NEL),IDET_MS(NEL)
*. Output
      INTEGER IDET_OPEN_MS(*)
*
      IEL = 1
      IOPEN = 0
*. Loop over electrons
 1000 CONTINUE
       IF(IEL.LT.NEL) THEN
         IF(IDET_OC(IEL).NE.IDET_OC(IEL+1)) THEN
*. Single occupied orbital so
            IOPEN = IOPEN + 1
            IDET_OPEN_MS(IOPEN) = IDET_MS(IEL)
            IEL = IEL + 1
          ELSE
            IEL = IEL + 2
          END IF
       ELSE
*. Last electron was not identical to previous, so
*. neccessarily single occupied.
          IOPEN = IOPEN + 1
          IDET_OPEN_MS(IOPEN) = IDET_MS(IEL)
          IEL = IEL + 1
       END IF
      IF(IEL.LE.NEL) GOTO 1000
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Input det, occ and ms '
        CALL IWRTMA(IDET_OC,1,NEL,1,NEL)
        CALL IWRTMA(IDET_MS,1,NEL,1,NEL)
        WRITE(6,*) ' Number of open orbitals = ', IOPEN
        WRITE(6,*) ' Output det : ms of open orbitals '
        CALL IWRTMA(IDET_OPEN_MS,1,IOPEN,1,IOPEN)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

module NEVPT2_E4

! Variables and subroutines relevant to the E*E*E*E contributions
!
! 1. NEVPT2_E4_ZVEC: Construct ZVEC
!    Z_{t,u}^I = \sum_{v,x} (tu|vx) <Phi_I|E_{v,x}|Psi>
! 2. NEVPT2_E4_XYVEC: Construct XVEC and YVEC
!    X_{v,u}^I = <Phi_I|E_{x,u}|Phi_J> Z_{v,x}^J
!    Y_{v,t}^I = <Phi_I|E_{t,x}|Phi_J> Z_{v,x}^J
! 3. NEVPT2_E4_contract1: Contract XVEC and YVEC with <Psi|E_{tu}|I>
!    A_{t,u,y,z} = \sum_I <Psi|E_{tu}|I>*X_{y,z}^I
!    B_{t,u,y,z} = \sum_I <Psi|E_{tu}|I>*Y_{y,z}^I
!    (used for some E*E*E contributions and \tilde{E} terms)
! 4. NEVPT2_E4_contract2: Contract XVEC and YVEC with <I|E_{vx}E_{yz}|Psi>
!    C_{t,u,v,x,y,z} = \sum_I <I|E_{vx}E_{yz}|Psi>*X_{t,u}^I
!    D_{t,u,v,x,y,z} = \sum_I <I|E_{vx}E_{yz}|Psi>*Y_{t,u}^I
!    (why bra state? I defined v,x,y,z of A in a different order?)

! Part 1
! First, construct ZVEC (Z_{t,u}^I)
! - cost: nlev2*sigma1 + nlev2*nzvec*daxpy
! Next, construct XVEC and YVEC
! - cost: nlev*(nlev-1)*sigma1 + 2*nlev*(nlev-1)*nxyvec*daxpy
!
! Part 2
! <Psi|E_{t,u}|I>*X_{v,x}^I and <Psi|E_{t,u}|I>*Y_{v,x}^I
! - cost: nlev2*sigma1 + 2*nlev2*dgemv(nxyvec)
!
! Part 3
! <Psi|E_{t,u}E_{v,x}|I>*X_{y,z}^I and <Psi|E_{t,u}E_{v,x}|I>*Y_{y,z}^I
! - cost: nlev2*(nlev2-1)*sigma1 + 2*nlev2*dgemv(nxyvec,nlev2-1) /2

! Part 3 is clearly the most computationally expensive part, so increase NXYVEC as much as possible.
! On the other hand, we cannot ignore the importance of ZVEC construction.
! NBZ*(nlev2*sigma1 + nlev2*nzvec*daxpy) + NBXY*(nlev*(nlev-1)*sigma1 + 2*nlev*(nlev-1)*nxyvec*daxpy)
! \approx NBZ*nlev2*(sigma1 + nzvec*daxpy) NBXY*nlev2*(sigma1 + 2*nxyvec*daxpy)
! =       nlev2 * [ NBZ*(sigma1 + nzvec*daxpy) + NBXY*(sigma1 + 2*Nxyvec*daxpy) ]
! =       nlev2 * [ (NBZ+NBXY)*sigma1 + (NBZ*nzvec + NBXY*NXYVEC)*daxpy ]
! \approx nlev2 * [ (NBZ+NBXY)*sigma1 + 3*nlev2*daxpy ]
! So, sum of the Z and XY batch should be minimized -> NBZ = NBXY

! define three strategies depending on the available memory
! 1. > 3*nlev2*MXCI --> ZVEC -> XVEC + YVEC -> E(*E) contraction
! 2. > 2*nlev2*MXCI --> ZVEC -> XVEC -> E(*E) contraction -> ZVEC -> YVEC -> E(*E) contraction
! 3. < 2*nlev2*MXCI --> batched 2

! Consider distributed memory strategy
! ... at the moment, no

use Index_Functions, only: iTri, nTri_Elem
use caspt2_module, only: MXCI, NTUVES, STSYM
use sguga, only: CIS, EXS, L2ACT, SGS
use SUPERINDEX, only: KTUV
use Symmetry_Info, only: Mul
use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: ixyzend = 0, ixyzsta = 0, NXY_work = 0, NXYVEC = 0, nxyzdim = 0, NZVEC = 0
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: MAXBUF = 0
#endif
logical(kind=iwp) :: do_xvec = .false., do_yvec = .false.
logical(kind=iwp), parameter :: do_zder = .true.

public :: do_xvec, do_yvec, ixyzend, ixyzsta, NEVPT2_E4_contract1, NEVPT2_E4_contract2, NEVPT2_E4_derivative1, &
          NEVPT2_E4_derivative2, NEVPT2_E4_derivative3, NEVPT2_E4_XYder1, NEVPT2_E4_XYder2, NEVPT2_E4_XYVEC, NEVPT2_E4_ZVEC, &
          NXY_work, NXYVEC, nxyzdim, NZVEC
#ifdef _MOLCAS_MPP_
public :: MAXBUF
#endif

contains

!-----------------------------------------------------------------------

subroutine NEVPT2_E4_ZVEC(NLEV,idx2ij,Gact,CI,ZVEC,WRK)

  integer(kind=iwp), intent(in) :: NLEV, idx2ij(2,NLEV**2)
  real(kind=wp), intent(in) :: Gact(:,:,:,:), CI(:)
  real(kind=wp), intent(inout) :: ZVEC(MXCI,NZVEC)
  real(kind=wp), intent(out) :: WRK(MXCI,NZVEC) !! This is XYVEC outside this subroutine
  integer(kind=iwp) :: ibuf, ID, ip1, ip2, it, itlev, iu, iulev, iv, ivlev, ix, ixlev, nlev2, nTask, nxy
  real(kind=wp) :: scal
  real(kind=wp), allocatable :: Gact_sort(:,:)

  ! Construct ZVEC
  ! Z_{t,u}^I = \sum_{v,x} (tu|vx) <Phi_I|E_{v,x}|Psi>

  if (NXY_work == NLEV) then
    nxy = NLEV*NLEV
  else
    nxy = NLEV*nxyzdim
  end if
  NLEV2 = NLEV**2
  call mma_allocate(Gact_sort,nxy,NZVEC,LABEL='Gact_sort')

  nTask = NLEV2
  call Init_Tsk(ID,nTask)

  ibuf = 0
  Scal = Zero
  do while (Rsv_Tsk(ID,ip2))
    ivlev = idx2ij(1,ip2)
    ixlev = idx2ij(2,ip2)
    !isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
    iv = L2ACT(ivlev)
    ix = L2ACT(ixlev)
    ibuf = ibuf+1
    if (NXY_work == NLEV) then
      do ip1=1,nlev2
        itlev = idx2ij(1,ip1)
        iulev = idx2ij(2,ip1)
        it = L2ACT(itlev)
        iu = L2ACT(iulev)
        Gact_sort(ip1,ibuf) = Gact(it,iu,iv,ix)
      end do
    else
      do itlev=ixyzsta,ixyzend
        do iulev=1,nlev
          !ip1 = ij2idx(ixy_local,iulev_local)
          !itlev = idx2ij(1,ip1)
          !iulev = idx2ij(2,ip1)
          !it = L2ACT(itlev)
          !iu = L2ACT(iulev)
          !Gact_sort(iulev_local) = Gact(it,iu,iv,ix)
          Gact_sort(itlev-ixyzsta+1+nxyzdim*(iulev-1),ibuf) = Gact(itlev,iulev,iv,ix)
        end do
      end do
    end if
    WRK(:,ibuf) = Zero
    call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,STSYM,CI,WRK(:,ibuf))
    if (ibuf == NZVEC) then
      !! Finalize the contribution
      call dgemm_('N','T',MXCI,nxy,ibuf,One,WRK,MXCI,Gact_sort,nxy,Scal,ZVEC,MXCI)
      ibuf = 0
      Scal = One
    end if
  end do
  call Free_Tsk(ID)

  if (ibuf > 0) call dgemm_('N','T',MXCI,nxy,ibuf,One,WRK,MXCI,Gact_sort,nxy,Scal,ZVEC,MXCI)

  ! avoid the 2 GB (?) barrier
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    do ip1=1,NZVEC,MAXBUF
      call GADGOP(ZVEC(:,ip1:),MXCI*min(NZVEC-ip1+1,MAXBUF),'+')
    end do
  end if
# endif

  call mma_deallocate(Gact_sort)

end subroutine NEVPT2_E4_ZVEC

!-----------------------------------------------------------------------

subroutine NEVPT2_E4_XYVEC(iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,ZVEC,XYVEC)

  integer(kind=iwp), intent(in) :: iSym, NLEV, idx2ij(2,NLEV**2), ij2idx(NLEV,NLEV), ipxysta, ipxyend
  real(kind=wp), intent(inout) :: BUFT(:), ZVEC(MXCI,NZVEC), XYVEC(MXCI,NXYVEC,2)
  integer(kind=iwp) :: ID, ip1, ip2, ipxy, issg1, issg2, istu, isvx, it, itlev, iu, iulev, ivlev, ix, ixlev, locx, locy, nlev2, &
                       nsgm1, nTask

  ! Construct XVEC and YVEC
  ! X_{a,b}^I = \sum_{def} (ae|df) \sum_J <I|E_{eb}|J><J|E_{df}|Psi>
  !           = \sum_e \sum_J <I|E_{eb}|J>*(\sum_{df}(ae|df)<J|E_{df}|Psi>)
  !           = \sum_e \sum_J <I|E_{eb}|J>*Z_{ae}^J
  ! X_{v,u}^I = <Phi_I|E_{x,u}|Phi_J> Z_{v,x}^J
  ! Y_{v,t}^I = <Phi_I|E_{t,x}|Phi_J> Z_{v,x}^J

  locx = 1
  locy = 1
  if (do_xvec .and. do_yvec) then
    XYvec(1:MXCI,1:NXYVEC,1:2) = Zero
    locy = 2
  else if (do_xvec .or. do_yvec) then
    XYvec(1:MXCI,1:NXYVEC,1:1) = Zero
    locy = 1
  end if

  NLEV2 = NLEV**2
  nTask = NLEV2
  call Init_Tsk(ID,nTask)
  do while (Rsv_Tsk(ID,ip2))
    ivlev = idx2ij(1,ip2)
    ixlev = idx2ij(2,ip2)
    isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
    issg2 = Mul(isvx,stsym)
    !iv = L2ACT(ivlev)
    ix = L2ACT(ixlev)
    if ((NXY_work /= NLEV) .and. ((ivlev < ixyzsta) .or. (ivlev > ixyzend))) cycle
    do ip1=1,nlev2
      itlev = idx2ij(1,ip1)
      iulev = idx2ij(2,ip1)
      istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
      issg1 = Mul(istu,issg2)
      if (issg1 /= iSym) cycle
      nsgm1 = CIS%ncsf(issg1)
      it = L2ACT(itlev)
      iu = L2ACT(iulev)
      if (((.not. do_xvec) .or. (it /= ix)) .and. ((.not. do_yvec) .or. (iu /= ix))) cycle
      BUFT(1:nsgm1) = Zero
      if (NXY_work == NLEV) then
        call SG_Epq_Psi(SGS,CIS,EXS,ITLEV,IULEV,One,issg2,ZVEC(:,ip2),BUFT)
      else
        call SG_Epq_Psi(SGS,CIS,EXS,ITLEV,IULEV,One,issg2,ZVEC(:,ivlev-ixyzsta+1+nxyzdim*(ixlev-1)),BUFT)
      end if
      ! Etu Evx * (at|vx) -> Xau
      if (do_xvec .and. (it == ix)) then
        if (NXY_work == NLEV) then
          ipxy = ij2idx(ivlev,iulev)
          if ((ipxy >= ipxysta) .and. (ipxy <= ipxyend)) &
            XYvec(1:nsgm1,ipxy-ipxysta+1,locx) = XYvec(1:nsgm1,ipxy-ipxysta+1,locx)+buft(1:nsgm1)
        else
          XYvec(1:nsgm1,ivlev-ixyzsta+1+nxyzdim*(iulev-1),locx) = &
            XYvec(1:nsgm1,ivlev-ixyzsta+1+nxyzdim*(iulev-1),locx)+buft(1:nsgm1)
        end if
      end if
      ! Evx Etu * (ax|tu) -> Yav
      if (do_yvec .and. (iu == ix)) then
        if (NXY_work == NLEV) then
          ipxy = ij2idx(ivlev,itlev)
          if ((ipxy >= ipxysta) .and. (ipxy <= ipxyend)) &
            XYvec(1:nsgm1,ipxy-ipxysta+1,locy) = XYvec(1:nsgm1,ipxy-ipxysta+1,locy)+buft(1:nsgm1)
        else
          XYvec(1:nsgm1,ivlev-ixyzsta+1+nxyzdim*(itlev-1),locy) = &
            XYvec(1:nsgm1,ivlev-ixyzsta+1+nxyzdim*(itlev-1),locy)+buft(1:nsgm1)
        end if
      end if
    end do
  end do
  call Free_Tsk(ID)

# ifdef _MOLCAS_MPP_
  ! avoid the 2 GB (?) barrier
  if (is_real_par()) then
    do ip1=1,NXYVEC,MAXBUF
      call GADGOP(XYvec(:,ip1:,1),MXCI*min(NXYVEC-ip1+1,MAXBUF),'+')
    end do
    if (do_xvec .and. do_yvec) then
      do ip1=1,NXYVEC,MAXBUF
        call GADGOP(XYvec(:,ip1:,2),MXCI*min(NXYVEC-ip1+1,MAXBUF),'+')
      end do
    end if
  end if
# endif

end subroutine NEVPT2_E4_XYVEC

!-----------------------------------------------------------------------

subroutine NEVPT2_E4_contract1(iSym0,iSym,NLEV,idx2ij,ipxysta,ipxyend,BUFT,CI,XYVEC,BA,BC,XYcont)

  integer(kind=iwp), intent(in) :: iSym0, iSym, NLEV, idx2ij(2,NLEV**2), ipxysta, ipxyend
  real(kind=wp), intent(inout) :: BUFT(:), BA(:), BC(:)
  real(kind=wp), intent(in) :: CI(:), XYVEC(MXCI,NXYVEC,2)
  real(kind=wp), intent(out) :: XYcont(:,:,:)
  integer(kind=iwp) :: I, ID, ip1, ipxy, issg1, istu, ISUP, isvx, it, itlev, iu, iulev, iv, ivlev, ix, ixlev, iz, izlev, JSUP, &
                       nlev2, nsgm1, nTask, nxy
  real(kind=wp) :: tmp1, tmp2

  if (NXY_work == NLEV) then
    nxy = ipxyend-ipxysta+1
  else
    nxy = NLEV*nxyzdim
  end if
  NLEV2 = NLEV**2
  XYcont(1:nxy,1:2,1:nlev2) = Zero
  nTask = nlev2
  call Init_Tsk(ID,nTask)
  do while (Rsv_Tsk(ID,ip1))
    itlev = idx2ij(1,ip1)
    iulev = idx2ij(2,ip1)
    istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
    issg1 = Mul(istu,stsym)
    if (issg1 /= iSym) cycle
    nsgm1 = CIS%ncsf(issg1)
    it = L2ACT(itlev)
    iu = L2ACT(iulev)
    BUFT(1:nsgm1) = Zero
    call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,One,STSYM,CI,BUFT(:))
    if (do_xvec .and. do_yvec) then
      call dgemv_('T',nsgm1,nxy,One,XYvec(:,:,1),mxci,BUFT(:),1,Zero,XYcont(:,1,ip1),1)
      call dgemv_('T',nsgm1,nxy,One,XYvec(:,:,2),mxci,BUFT(:),1,Zero,XYcont(:,2,ip1),1)
    else if (do_xvec .and. (.not. do_yvec)) then
      call dgemv_('T',nsgm1,nxy,One,XYvec(:,:,1),mxci,BUFT(:),1,Zero,XYcont(:,1,ip1),1)
    else if ((.not. do_xvec) .and. do_yvec) then
      call dgemv_('T',nsgm1,nxy,One,XYvec(:,:,1),mxci,BUFT(:),1,Zero,XYcont(:,2,ip1),1)
    end if
    do ipxy=ipxysta,ipxyend
      ivlev = idx2ij(1,ipxy)
      ixlev = idx2ij(2,ipxy)
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      ! ----- E*X and E*Y terms
      ! Etu Xvx = Xvx Eut
      if (do_xvec) then
        if (NXY_work == NLEV) then
          tmp1 = XYcont(ipxy-ipxysta+1,1,ip1)
        else
          !if (ivlev == ixy_local) then
          if ((ivlev >= ixyzsta) .and. (ivlev <= ixyzend)) then
            !tmp1 = XYcont(ixlev,1,ip1)
            tmp1 = XYcont(ivlev-ixyzsta+1+nxyzdim*(ixlev-1),1,ip1)
          else
            tmp1 = Zero
          end if
        end if
        if (abs(tmp1) >= 1.0e-12_wp) then
          do izlev=1,nlev
            iz = L2ACT(izlev)
            if ((Mul(SGS%ism(izlev),istu) == iSym0) .and. (Mul(SGS%ism(izlev),isvx) == iSym0)) then
              ! A: A_{zut,vzx} <-- -del(zz) Etu Xvx = -Xvx Eut
              ISUP = KTUV(iZ,iU,iT)-nTUVES(iSYM0)
              JSUP = KTUV(iV,iZ,iX)-nTUVES(iSYM0)
              if (isup >= jsup) then
                I = iTri(ISUP,JSUP)
                BA(I) = BA(I)-tmp1
              end if
              ! A: A_{zut,zvx} <-- -del(zz) Etu Xvx (E*X from tilde{E})
              ISUP = KTUV(iZ,iU,iT)-nTUVES(iSYM0)
              JSUP = KTUV(iZ,iV,iX)-nTUVES(iSYM0)
              if (isup >= jsup) then
                I = iTri(ISUP,JSUP)
                BA(I) = BA(I)+Two*tmp1
              end if
            end if
          end do
        end if
      end if

      if (do_yvec) then
        if (NXY_work == NLEV) then
          tmp2 = XYcont(ipxy-ipxysta+1,2,ip1)
        else
          !if (ivlev == ixy_local) then
          if ((ivlev >= ixyzsta) .and. (ivlev <= ixyzend)) then
            !tmp2 = XYcont(ixlev,2,ip1)
            tmp2 = XYcont(ivlev-ixyzsta+1+nxyzdim*(ixlev-1),2,ip1)
          else
            tmp2 = Zero
          end if
        end if
        if (abs(tmp2) >= 1.0e-12_wp) then
          do izlev=1,nlev
            iz = L2ACT(izlev)
            if ((Mul(SGS%ism(izlev),istu) == iSym0) .and. (Mul(SGS%ism(izlev),isvx) == iSym0)) then
              ! C: A_{zut,vxz} <-- del(zz) Etu Yvx = Yvx Eut
              ISUP = KTUV(iZ,iU,iT)-nTUVES(iSYM0)
              JSUP = KTUV(iV,iX,iZ)-nTUVES(iSYM0)
              if (isup >= jsup) then
                I = iTri(ISUP,JSUP)
                BC(I) = BC(I)+tmp2
              end if
              ! A: A_{zut,zxv} <-- -del(zz) Etu Xvx
              ISUP = KTUV(iZ,iU,iT)-nTUVES(iSYM0)
              JSUP = KTUV(iZ,iX,iV)-nTUVES(iSYM0)
              if (isup >= jsup) then
                I = iTri(ISUP,JSUP)
                BA(I) = BA(I)-Two*tmp2
              end if
            end if
          end do
        end if
      end if
    end do
  end do

  call Free_Tsk(ID)

# ifdef _MOLCAS_MPP_
  if (is_real_par()) call GADGOP(XYcont,nxyvec*2*nlev2,'+')
# endif

end subroutine NEVPT2_E4_contract1

!-----------------------------------------------------------------------

subroutine NEVPT2_E4_contract2(iSym0,iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,XYVEC,BA,BC,XYcont,XYtmp,ZVEC)

  integer(kind=iwp), intent(in) :: iSym0, iSym, NLEV, idx2ij(2,NLEV**2), ij2idx(NLEV,NLEV), ipxysta, ipxyend
  real(kind=wp), intent(inout) :: BUFT(:), BA(:), BC(:)
  real(kind=wp), intent(in) :: CI(:), XYVEC(MXCI,NXYVEC,2), XYcont(:,:,:)
  real(kind=wp), intent(out) :: XYtmp(:,:,:), ZVEC(:,:)
  integer(kind=iwp) :: I, ibufxy, ID, ip1, ip2, ipxy, issg1, issg2, istu, ISUP, isvx, isyz, it, itlev, iu, iulev, iv, ivlev, ix, &
                       ixlev, iy, iylev, iz, izlev, JSUP, nbufxy, nlev2, nsgm1, nsgm2, nTask, nxy
  real(kind=wp) :: tmp1, tmp2
  logical(kind=iwp) :: do_dgemm

  if (NXY_work == NLEV) then
    nxy = ipxyend-ipxysta+1
  else
    !nxy = NLEV
    nxy = NLEV*nxyzdim
  end if
  NLEV2 = NLEV*NLEV
  nsgm2 = 0

  nTask = nlev2
  call Init_Tsk(ID,nTask)
  do while (Rsv_Tsk(ID,ip1))
    iylev = idx2ij(1,ip1)
    izlev = idx2ij(2,ip1)
    isyz = Mul(SGS%ism(iylev),SGS%ism(izlev))
    issg1 = Mul(isyz,stsym)
    nsgm1 = CIS%ncsf(issg1)
    iy = L2ACT(iylev)
    iz = L2ACT(izlev)
    BUFT(1:nsgm1) = Zero
    call SG_Epq_Psi(SGS,CIS,EXS,IYLEV,IZLEV,One,STSYM,CI,BUFT(:))

    if (NXY_work == NLEV) then
      Zvec(1:MXCI,1:nlev2-ip1+1) = Zero
    else
      Zvec(1:MXCI,1:nxy) = Zero
    end if
    !if (NXY_work == 1) XYtmp(:,:,:) = Zero
    !Zvec(1:MXCI,1:nlev2-ip1+1) = Zero
    do_dgemm = .false.
    nbufxy = 0
    ibufxy = ip1
    do ip2=ip1,nlev2
      ivlev = idx2ij(1,ip2)
      ixlev = idx2ij(2,ip2)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      issg2 = Mul(isvx,issg1) ! symmetry of <I|EvxEyz|Psi>
      nbufxy = nbufxy+1
      if (issg2 /= iSym) then
        if ((NXY_work /= NLEV) .and. (nbufxy == nlev)) then
          nsgm2 = CIS%ncsf(iSym)
          if (do_xvec .and. do_yvec) then
            call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,1),NXYVEC)
            call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,2),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,2),NXYVEC)
          else if (do_xvec .and. (.not. do_yvec)) then
            call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,1),NXYVEC)
          else if ((.not. do_xvec) .and. do_yvec) then
            call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,2),NXYVEC)
          end if
          nbufxy = 0
          ibufxy = ip2+1
          Zvec(1:MXCI,1:nxy) = Zero
        end if
        cycle
      end if
      nsgm2 = CIS%ncsf(issg2)
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      if (NXY_work == NLEV) then
        call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,issg1,BUFT(:),ZVEC(1:nsgm2,ip2-ip1+1))
      else
        call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,issg1,BUFT(:),ZVEC(1:nsgm2,nbufxy))
        !if (do_xvec .and. do_yvec) then
        !  call dgemv_('T',nsgm2,nxy,One,XYvec(:,:,1),mxci,ZVEC(:,1),1,Zero,XYtmp(:,ip2-ip1+1,1),1)
        !  call dgemv_('T',nsgm2,nxy,One,XYvec(:,:,2),mxci,ZVEC(:,1),1,Zero,XYtmp(:,ip2-ip1+1,2),1)
        !else if (do_xvec .and. (.not. do_yvec)) then
        !  call dgemv_('T',nsgm2,nxy,One,XYvec(:,:,1),mxci,ZVEC(:,1),1,Zero,XYtmp(:,ip2-ip1+1,1),1)
        !else if ((.not. do_xvec) .and. do_yvec) then
        !  call dgemv_('T',nsgm2,nxy,One,XYvec(:,:,1),mxci,ZVEC(:,1),1,Zero,XYtmp(:,ip2-ip1+1,2),1)
        !end if
        if (nbufxy == nlev) then
          if (do_xvec .and. do_yvec) then
            call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,1),NXYVEC)
            call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,2),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,2),NXYVEC)
          else if (do_xvec .and. (.not. do_yvec)) then
            call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,1),NXYVEC)
          else if ((.not. do_xvec) .and. do_yvec) then
            call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,2),NXYVEC)
          end if
          nbufxy = 0
          ibufxy = ip2+1
          Zvec(1:MXCI,1:nxy) = Zero
        end if
      end if
      do_dgemm = .true.
    end do

    if (NXY_work == NLEV) then
      if ((nlev2-ip1+1 == 0) .or. (nsgm2 == 0) .or. (.not. do_dgemm)) then
        XYtmp(:,:,:) = Zero
      else
        if (do_xvec .and. do_yvec) then
          call dgemm_('T','N',nxy,nlev2-ip1+1,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,:,1),NXYVEC)
          call dgemm_('T','N',nxy,nlev2-ip1+1,nsgm2,One,XYvec(:,:,2),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,:,2),NXYVEC)
        else if (do_xvec .and. (.not. do_yvec)) then
          call dgemm_('T','N',nxy,nlev2-ip1+1,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,:,1),NXYVEC)
        else if ((.not. do_xvec) .and. do_yvec) then
          call dgemm_('T','N',nxy,nlev2-ip1+1,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,:,2),NXYVEC)
        end if
      end if
    else if ((NXY_work /= NLEV) .and. (nbufxy > 0)) then
      if (do_xvec .and. do_yvec) then
        call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,1),NXYVEC)
        call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,2),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,2),NXYVEC)
      else if (do_xvec .and. (.not. do_yvec)) then
        call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,1),NXYVEC)
      else if ((.not. do_xvec) .and. do_yvec) then
        call dgemm_('T','N',nxy,nbufxy,nsgm2,One,XYvec(:,:,1),mxci,ZVEC(:,:),mxci,Zero,XYtmp(:,ibufxy-ip1+1,2),NXYVEC)
      end if
    end if
    do ip2=ip1,nlev2
      ivlev = idx2ij(1,ip2)
      ixlev = idx2ij(2,ip2)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      issg2 = Mul(isvx,issg1) ! symmetry of <I|EvxEyz|Psi>
      if (issg2 /= iSym) cycle
      nsgm2 = CIS%ncsf(issg2)
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      do ipxy=ipxysta,ipxyend
        itlev = idx2ij(1,ipxy)
        iulev = idx2ij(2,ipxy)
        istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
        it = L2ACT(itlev)
        iu = L2ACT(iulev)
        ! ----- E*E*X terms
        if (do_xvec) then
          if (NXY_work == NLEV) then
            tmp1 = XYtmp(ipxy-ipxysta+1,ip2-ip1+1,1)
          else
            !if (itlev == ixy_local) then
            if ((itlev >= ixyzsta) .and. (itlev <= ixyzend)) then
              !tmp1 = XYtmp(iulev,ip2-ip1+1,1)
              tmp1 = XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip1+1,1)
            else
              tmp1 = Zero
            end if
          end if
          if (abs(tmp1) >= 1.0e-12_wp) call Add_MKBNEVAC_Xvec(iv,ix,iy,iz,ivlev,ixlev,isvx,isyz)
        end if
        ! ----- E*E*Y terms
        if (do_yvec) then
          if (NXY_work == NLEV) then
            tmp2 = XYtmp(ipxy-ipxysta+1,ip2-ip1+1,2)
          else! if (NXY_work == 1) then
            !if (itlev == ixy_local) then
            if ((itlev >= ixyzsta) .and. (itlev <= ixyzend)) then
              !tmp2 = XYtmp(iulev,ip2-ip1+1,2)
              tmp2 = XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip1+1,2)
            else
              tmp2 = Zero
            end if
          end if
          if (abs(tmp2) >= 1.0e-12_wp) call Add_MKBNEVAC_Yvec(iv,ix,iy,iz,ivlev,ixlev,isvx,isyz)
        end if
      end do

      if (ip2 /= ip1) then
        ! EyzEvx = EvxEyz + Eyx del(vz) - Evz del(yx)
        ! Note that the index of ipxy for XYcont is reversed
        if ((iv == iz) .and. (iSym == Mul(Mul(SGS%ism(iylev),SGS%ism(ixlev)),STSYM))) then
          ipxy = ij2idx(ixlev,iylev)
          if (do_xvec) XYtmp(1:nxy,ip2-ip1+1,1) = XYtmp(1:nxy,ip2-ip1+1,1)+XYcont(1:nxy,1,ipxy)
          if (do_yvec) XYtmp(1:nxy,ip2-ip1+1,2) = XYtmp(1:nxy,ip2-ip1+1,2)+XYcont(1:nxy,2,ipxy)
        end if
        if ((iy == ix) .and. (iSym == Mul(Mul(SGS%ism(ivlev),SGS%ism(izlev)),STSYM))) then
          ipxy = ij2idx(izlev,ivlev)
          if (do_xvec) XYtmp(1:nxy,ip2-ip1+1,1) = XYtmp(1:nxy,ip2-ip1+1,1)-XYcont(1:nxy,1,ipxy)
          if (do_yvec) XYtmp(1:nxy,ip2-ip1+1,2) = XYtmp(1:nxy,ip2-ip1+1,2)-XYcont(1:nxy,2,ipxy)
        end if

        do ipxy=ipxysta,ipxyend
          itlev = idx2ij(1,ipxy)
          iulev = idx2ij(2,ipxy)
          istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
          it = L2ACT(itlev)
          iu = L2ACT(iulev)
          ! ----- E*E*X terms
          if (do_xvec) then
            if (NXY_work == NLEV) then
              tmp1 = XYtmp(ipxy-ipxysta+1,ip2-ip1+1,1)
            else! if (NXY_work == 1) then
              !if (itlev == ixy_local) then
              if ((itlev >= ixyzsta) .and. (itlev <= ixyzend)) then
                !tmp1 = XYtmp(iulev,ip2-ip1+1,1)
                tmp1 = XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip1+1,1)
              else
                tmp1 = Zero
              end if
            end if
            if (abs(tmp1) >= 1.0e-12_wp) call Add_MKBNEVAC_Xvec(iy,iz,iv,ix,iylev,izlev,isyz,isvx)
          end if
          ! ----- E*E*Y terms
          if (do_yvec) then
            if (NXY_work == NLEV) then
              tmp2 = XYtmp(ipxy-ipxysta+1,ip2-ip1+1,2)
            else! if (NXY_work == 1) then
              !if (itlev == ixy_local) then
              if ((itlev >= ixyzsta) .and. (itlev <= ixyzend)) then
                !tmp2 = XYtmp(iulev,ip2-ip1+1,2)
                tmp2 = XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip1+1,2)
              else
                tmp2 = Zero
              end if
            end if
            if (abs(tmp2) >= 1.0e-12_wp) call Add_MKBNEVAC_Yvec(iy,iz,iv,ix,iylev,izlev,isyz,isvx)
          end if
        end do
      end if
    end do
  end do

  call Free_Tsk(ID)

  contains

  subroutine Add_MKBNEVAC_Xvec(iv_,ix_,iy_,iz_,ivlev_,ixlev_,isvx_,isyz_)

    integer(kind=iwp), intent(in) :: iv_, ix_, iy_, iz_, ivlev_, ixlev_, isvx_, isyz_

    if ((Mul(SGS%ism(ixlev_),isyz_) == iSym0) .and. (Mul(SGS%ism(ivlev_),istu) == iSym0)) then
      ! C: A_{xyz,vtu} <-- Xtu Evx Eyz
      ISUP = KTUV(iX_,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iV_,iT,iU)-nTUVES(iSYM0)
      if (isup >= jsup) then
        I = iTri(ISUP,JSUP)
        BC(I) = BC(I)+tmp1
      end if
    end if
    if ((Mul(SGS%ism(ivlev_),isyz_) == iSym0) .and. (Mul(SGS%ism(ixlev_),istu) == iSym0)) then
      ! A: A_{vyz,xtu} <-- -Xtu Evx Eyz
      ISUP = KTUV(iV_,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iX_,iT,iU)-nTUVES(iSYM0)
      if (isup >= jsup) then
        I = iTri(ISUP,JSUP)
        BA(I) = BA(I)-tmp1
      end if
    end if
    if ((Mul(SGS%ism(iulev),isyz_) == iSym0) .and. (Mul(SGS%ism(itlev),isvx_) == iSym0)) then
      ! A: A_{uyz,txv} <-- -Xtu Evx Eyz
      ISUP = KTUV(iU,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iT,iX_,iV_)-nTUVES(iSYM0)
      if (isup >= jsup) then
        I = iTri(ISUP,JSUP)
        BA(I) = BA(I)-tmp1
      end if
    end if

    return

  end subroutine Add_MKBNEVAC_Xvec

  subroutine Add_MKBNEVAC_Yvec(iv_,ix_,iy_,iz_,ivlev_,ixlev_,isvx_,isyz_)

    integer(kind=iwp), intent(in) :: iv_, ix_, iy_, iz_, ivlev_, ixlev_, isvx_, isyz_

    if ((Mul(SGS%ism(ixlev_),isyz_) == iSym0) .and. (Mul(SGS%ism(ivlev_),istu) == iSym0)) then
      ! C: A_{xyz,vut} <-- -Ytu Evx Eyz
      ISUP = KTUV(iX_,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iV_,iU,iT)-nTUVES(iSYM0)
      if (isup >= jsup) then
        I = iTri(ISUP,JSUP)
        BC(I) = BC(I)-tmp2
      end if
    end if
    if ((Mul(SGS%ism(iulev),isyz_) == iSym0) .and. (Mul(SGS%ism(itlev),isvx_) == iSym0)) then
      ! C: A_{uyz,txv} <-- -Ytu Evx Eyz
      ISUP = KTUV(iU,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iT,iX_,iV_)-nTUVES(iSYM0)
      if (isup >= jsup) then
        I = iTri(ISUP,JSUP)
        BC(I) = BC(I)-tmp2
      end if
    end if
    if ((Mul(SGS%ism(ivlev_),isyz_) == iSym0) .and. (Mul(SGS%ism(ixlev_),istu) == iSym0)) then
      ! A: A_{vyz,xut} <-- +Xtu Evx Eyz
      ISUP = KTUV(iV_,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iX_,iU,iT)-nTUVES(iSYM0)
      if (isup >= jsup) then
        I = iTri(ISUP,JSUP)
        BA(I) = BA(I)+tmp2
      end if
    end if

    return

  end subroutine Add_MKBNEVAC_Yvec

end subroutine NEVPT2_E4_contract2

!-----------------------------------------------------------------------

subroutine NEVPT2_E4_derivative1(iSym0,iSym,NLEV,idx2ij,ipxysta,ipxyend,BDERA,BDERC,XYcont)

  integer(kind=iwp), intent(in) :: iSym0, iSym, NLEV, idx2ij(2,NLEV**2), ipxysta, ipxyend
  real(kind=wp), intent(in) :: BDERA(:,:), BDERC(:,:)
  real(kind=wp), intent(out) :: XYcont(:,:,:)
  integer(kind=iwp) :: ID, ip1, ipxy, issg1, istu, ISUP, isvx, it, itlev, iu, iulev, iv, ivlev, ix, ixlev, iz, izlev, JSUP, nlev2, &
                       nTask, nxy
  real(kind=wp) :: tmp1, tmp2

  if (NXY_work == NLEV) then
    nxy = ipxyend-ipxysta+1
  else
    nxy = NLEV*nxyzdim
  end if
  NLEV2 = NLEV**2
  XYcont(1:nxy,1:2,1:nlev2) = Zero

  nTask = nlev2
  call Init_Tsk(ID,nTask)
  do while (Rsv_Tsk(ID,ip1))
    itlev = idx2ij(1,ip1)
    iulev = idx2ij(2,ip1)
    istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
    issg1 = Mul(istu,stsym)
    if (issg1 /= iSym) cycle
    it = L2ACT(itlev)
    iu = L2ACT(iulev)
    do ipxy=ipxysta,ipxyend
      ivlev = idx2ij(1,ipxy)
      ixlev = idx2ij(2,ipxy)
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      if ((NXY_work /= NLEV) .and. ((ivlev < ixyzsta) .or. (ivlev > ixyzend))) cycle
      ! ----- E*X and E*Y terms
      if (do_xvec) then
        tmp1 = Zero
        do izlev=1,nlev
          iz = L2ACT(izlev)
          if ((Mul(SGS%ism(izlev),istu) == iSym0) .and. (Mul(SGS%ism(izlev),isvx) == iSym0)) then
            ! A: A_{zut,vzx} <-- -del(zz) Etu Xvx = -Xvx Eut
            ISUP = KTUV(iZ,iU,iT)-nTUVES(iSYM0)
            JSUP = KTUV(iV,iZ,iX)-nTUVES(iSYM0)
            tmp1 = tmp1-BDERA(ISUP,JSUP)
            ! A: A_{zut,zvx} <-- -del(zz) Etu Xvx (E*X from tilde{E})
            ISUP = KTUV(iZ,iU,iT)-nTUVES(iSYM0)
            JSUP = KTUV(iZ,iV,iX)-nTUVES(iSYM0)
            tmp1 = tmp1+Two*BDERA(ISUP,JSUP)
          end if
        end do
        if (NXY_work == NLEV) then
          XYcont(ipxy-ipxysta+1,1,ip1) = tmp1
        else if ((ivlev >= ixyzsta) .and. (ivlev <= ixyzend)) then
          XYcont(ivlev-ixyzsta+1+nxyzdim*(ixlev-1),1,ip1) = tmp1
        end if
      end if

      if (do_yvec) then
        tmp2 = Zero
        do izlev=1,nlev
          iz = L2ACT(izlev)
          if ((Mul(SGS%ism(izlev),istu) == iSym0) .and. (Mul(SGS%ism(izlev),isvx) == iSym0)) then
            ! C: A_{zut,vxz} <-- del(zz) Etu Yvx = Yvx Eut
            ISUP = KTUV(iZ,iU,iT)-nTUVES(iSYM0)
            JSUP = KTUV(iV,iX,iZ)-nTUVES(iSYM0)
            tmp2 = tmp2+BDERC(ISUP,JSUP)
            ! A: A_{zut,zxv} <-- -del(zz) Etu Xvx
            ISUP = KTUV(iZ,iU,iT)-nTUVES(iSYM0)
            JSUP = KTUV(iZ,iX,iV)-nTUVES(iSYM0)
            tmp2 = tmp2-Two*BDERA(ISUP,JSUP)
          end if
        end do
        if (NXY_work == NLEV) then
          XYcont(ipxy-ipxysta+1,2,ip1) = tmp2
        else if ((ivlev >= ixyzsta) .and. (ivlev <= ixyzend)) then
          XYcont(ivlev-ixyzsta+1+nxyzdim*(ixlev-1),2,ip1) = tmp2
        end if
      end if
    end do
  end do

  call Free_Tsk(ID)

end subroutine NEVPT2_E4_derivative1

!-----------------------------------------------------------------------

subroutine NEVPT2_E4_derivative2(iSym0,iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,BDERA,BDERC,XYcont,XYcontder,XYder,ZVEC, &
                                 XYtmp)

  integer(kind=iwp), intent(in) :: iSym0, iSym, NLEV, idx2ij(2,NLEV**2), ij2idx(NLEV,NLEV), ipxysta, ipxyend
  real(kind=wp), intent(inout) :: BUFT(:), XYcont(:,:,:), XYcontder(:,:,:), XYder(:,:,:), ZVEC(:,:), XYtmp(:,:,:)
  real(kind=wp), intent(in) :: CI(:), BDERA(:,:), BDERC(:,:)
  integer(kind=iwp) :: ibufxy, ID, ip1, ip2, ip23, ip3, ipxy, issg2, issg3, istu, ISUP, isvx, isyz, it, itlev, iu, iulev, iv, &
                       ivlev, ix, ixlev, iy, iylev, iz, izlev, JSUP, nbufxy, nlev2, nsgm2, nsgm3, nTask, nxy
  real(kind=wp) :: tmp1, tmp2

  if (NXY_work == NLEV) then
    nxy = ipxyend-ipxysta+1
  else
    nxy = NLEV*nxyzdim
  end if
  NLEV2 = NLEV**2

  if (do_xvec .and. do_yvec) then
    XYder(1:mxci,1:nxy,1:2) = Zero
  else if (do_xvec .or. do_yvec) then
    XYder(1:mxci,1:nxy,1:1) = Zero
  end if

  XYcontder(1:nxyvec,1:2,1:nTri_Elem(nlev2)) = Zero
  nTask = nlev2
  call Init_Tsk(ID,nTask)
  do while (Rsv_Tsk(ID,ip3))
    iylev = idx2ij(1,ip3)
    izlev = idx2ij(2,ip3)
    isyz = Mul(SGS%ism(iylev),SGS%ism(izlev))
    issg3 = Mul(isyz,stsym)
    nsgm3 = CIS%ncsf(issg3)
    iy = L2ACT(iylev)
    iz = L2ACT(izlev)
    XYtmp(1:nxy,1:nlev2-ip3+1,1:2) = Zero
    do ip2=ip3,nlev2
      ivlev = idx2ij(1,ip2)
      ixlev = idx2ij(2,ip2)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      issg2 = Mul(isvx,issg3) ! symmetry of <I|EvxEyz|Psi>
      if (issg2 /= iSym) cycle
      nsgm2 = CIS%ncsf(issg2)
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)

      do ipxy=ipxysta,ipxyend
        itlev = idx2ij(1,ipxy)
        iulev = idx2ij(2,ipxy)
        istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
        it = L2ACT(itlev)
        iu = L2ACT(iulev)
        if ((NXY_work /= NLEV) .and. ((itlev < ixyzsta) .or. (itlev > ixyzend))) cycle
        ! ----- E*E*X terms
        if (do_xvec) then
          call Add_MKBNEVAC_Xvec(iv,ix,iy,iz,ivlev,ixlev,isvx,isyz,tmp1)
          if (NXY_work == NLEV) then
            XYtmp(ipxy-ipxysta+1,ip2-ip3+1,1) = XYtmp(ipxy-ipxysta+1,ip2-ip3+1,1)+tmp1
          else
            XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip3+1,1) = XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip3+1,1)+tmp1
          end if
        end if
        ! ----- E*E*Y terms
        if (do_yvec) then
          call Add_MKBNEVAC_Yvec(iv,ix,iy,iz,ivlev,ixlev,isvx,isyz,tmp2)
          if (NXY_work == NLEV) then
            XYtmp(ipxy-ipxysta+1,ip2-ip3+1,2) = XYtmp(ipxy-ipxysta+1,ip2-ip3+1,2)+tmp2
          else
            XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip3+1,2) = XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip3+1,2)+tmp2
          end if
        end if
      end do
      if (ip2 /= ip3) then
        ! EyzEvx = EvxEyz + Eyx del(vz) - Evz del(yx)
        ! Note that the index of ipxy for XYcont is reversed
        do ipxy=ipxysta,ipxyend
          itlev = idx2ij(1,ipxy)
          iulev = idx2ij(2,ipxy)
          istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
          it = L2ACT(itlev)
          iu = L2ACT(iulev)
          if ((NXY_work /= NLEV) .and. ((itlev < ixyzsta) .or. (itlev > ixyzend))) cycle
          ! ----- E*E*X terms
          if (do_xvec) then
            call Add_MKBNEVAC_Xvec(iy,iz,iv,ix,iylev,izlev,isyz,isvx,tmp1)
            if (NXY_work == NLEV) then
              XYtmp(ipxy-ipxysta+1,ip2-ip3+1,1) = XYtmp(ipxy-ipxysta+1,ip2-ip3+1,1)+tmp1
            else
              XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip3+1,1) = XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip3+1,1)+tmp1
            end if
          end if
          ! ----- E*E*Y terms
          if (do_yvec) then
            call Add_MKBNEVAC_Yvec(iy,iz,iv,ix,iylev,izlev,isyz,isvx,tmp2)
            if (NXY_work == NLEV) then
              XYtmp(ipxy-ipxysta+1,ip2-ip3+1,2) = XYtmp(ipxy-ipxysta+1,ip2-ip3+1,2)+tmp2
            else
              XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip3+1,2) = XYtmp(itlev-ixyzsta+1+nxyzdim*(iulev-1),ip2-ip3+1,2)+tmp2
            end if
          end if
          if ((iv == iz) .and. (iSym == Mul(Mul(SGS%ism(iylev),SGS%ism(ixlev)),STSYM))) then
            ip1 = ij2idx(ixlev,iylev)
            if (NXY_work == NLEV) then
              if (do_xvec) XYcont(ipxy-ipxysta+1,1,ip1) = XYcont(ipxy-ipxysta+1,1,ip1)+tmp1
              if (do_yvec) XYcont(ipxy-ipxysta+1,2,ip1) = XYcont(ipxy-ipxysta+1,2,ip1)+tmp2
            else if ((itlev >= ixyzsta) .and. (itlev <= ixyzend)) then
              if (do_xvec) XYcont(itlev-ixyzsta+1+nxyzdim*(iulev-1),1,ip1) = XYcont(itlev-ixyzsta+1+nxyzdim*(iulev-1),1,ip1)+tmp1
              if (do_yvec) XYcont(itlev-ixyzsta+1+nxyzdim*(iulev-1),2,ip1) = XYcont(itlev-ixyzsta+1+nxyzdim*(iulev-1),2,ip1)+tmp2
            end if
          end if
          if ((iy == ix) .and. (iSym == Mul(Mul(SGS%ism(ivlev),SGS%ism(izlev)),STSYM))) then
            ip1 = ij2idx(izlev,ivlev)
            if (NXY_work == NLEV) then
              if (do_xvec) XYcont(ipxy-ipxysta+1,1,ip1) = XYcont(ipxy-ipxysta+1,1,ip1)-tmp1
              if (do_yvec) XYcont(ipxy-ipxysta+1,2,ip1) = XYcont(ipxy-ipxysta+1,2,ip1)-tmp2
            else if ((itlev >= ixyzsta) .and. (itlev <= ixyzend)) then
              if (do_xvec) XYcont(itlev-ixyzsta+1+nxyzdim*(iulev-1),1,ip1) = XYcont(itlev-ixyzsta+1+nxyzdim*(iulev-1),1,ip1)-tmp1
              if (do_yvec) XYcont(itlev-ixyzsta+1+nxyzdim*(iulev-1),2,ip1) = XYcont(itlev-ixyzsta+1+nxyzdim*(iulev-1),2,ip1)-tmp2
            end if
          end if
        end do
      end if
    end do

    BUFT(1:nsgm3) = Zero
    call SG_Epq_Psi(SGS,CIS,EXS,IYLEV,IZLEV,One,STSYM,CI,BUFT(:))

    if (NXY_work == NLEV) then
      Zvec(1:MXCI,1:nlev2-ip3+1) = Zero
    else
      Zvec(1:MXCI,1:nxy) = Zero
    end if
    nbufxy = 0
    ibufxy = ip3
    do ip2=ip3,nlev2
      ivlev = idx2ij(1,ip2)
      ixlev = idx2ij(2,ip2)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      issg2 = Mul(isvx,issg3) ! symmetry of <I|EvxEyz|Psi>
      nsgm2 = CIS%ncsf(issg2)
      nbufxy = nbufxy+1
      !! see contract2, if symmetries are to be actived
      if (issg2 /= iSym) cycle
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      if (NXY_work == NLEV) then
        call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,issg3,BUFT(:),ZVEC(1:nsgm2,ip2-ip3+1))
      else
        call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,issg3,BUFT(:),ZVEC(1:nsgm2,nbufxy))
        if (nbufxy == nlev) then
          if (do_xvec .and. do_yvec) then
            call dgemm_('N','T',MXCI,nxy,nbufxy,One,ZVEC(:,:),MXCI,XYtmp(:,ibufxy-ip3+1,1),NXYVEC,One,XYder(:,:,1),MXCI)
            call dgemm_('N','T',MXCI,nxy,nbufxy,One,ZVEC(:,:),MXCI,XYtmp(:,ibufxy-ip3+1,2),NXYVEC,One,XYder(:,:,2),MXCI)
          else if (do_xvec .and. (.not. do_yvec)) then
            call dgemm_('N','T',MXCI,nxy,nbufxy,One,ZVEC(:,:),MXCI,XYtmp(:,ibufxy-ip3+1,1),NXYVEC,One,XYder(:,:,1),MXCI)
          else if ((.not. do_xvec) .and. do_yvec) then
            call dgemm_('N','T',MXCI,nxy,nbufxy,One,ZVEC(:,:),MXCI,XYtmp(:,ibufxy-ip3+1,2),NXYVEC,One,XYder(:,:,1),MXCI)
          end if
          nbufxy = 0
          ibufxy = ip2+1
          Zvec(1:MXCI,1:nxy) = Zero
        end if
      end if
      !! Compute Xder and Yder and left pre-derivative (something like <I|Evx|J>*Xyz^J)
      ip23 = iTri(ip2,ip3)
      if (do_xvec) XYcontder(1:nxy,1,ip23) = XYcontder(1:nxy,1,ip23)+XYtmp(1:nxy,ip2-ip3+1,1)
      if (do_yvec) XYcontder(1:nxy,2,ip23) = XYcontder(1:nxy,2,ip23)+XYtmp(1:nxy,ip2-ip3+1,2)
    end do

    if (nbufxy > 0) then
      if (do_xvec .and. do_yvec) then
        call dgemm_('N','T',MXCI,nxy,nbufxy,One,ZVEC(:,:),MXCI,XYtmp(:,ibufxy-ip3+1,1),NXYVEC,One,XYder(:,:,1),MXCI)
        call dgemm_('N','T',MXCI,nxy,nbufxy,One,ZVEC(:,:),MXCI,XYtmp(:,ibufxy-ip3+1,2),NXYVEC,One,XYder(:,:,2),MXCI)
      else if (do_xvec .and. (.not. do_yvec)) then
        call dgemm_('N','T',MXCI,nxy,nbufxy,One,ZVEC(:,:),MXCI,XYtmp(:,ibufxy-ip3+1,1),NXYVEC,One,XYder(:,:,1),MXCI)
      else if ((.not. do_xvec) .and. do_yvec) then
        call dgemm_('N','T',MXCI,nxy,nbufxy,One,ZVEC(:,:),MXCI,XYtmp(:,ibufxy-ip3+1,2),NXYVEC,One,XYder(:,:,1),MXCI)
      end if
    end if
  end do

  call Free_Tsk(ID)

# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    call GADGOP(XYcont,nxyvec*2*nlev2,'+')
    call GADGOP(XYcontder,nxyvec*2*nTri_Elem(nlev2),'+')
  end if
# endif

 contains

  subroutine Add_MKBNEVAC_Xvec(iv_,ix_,iy_,iz_,ivlev_,ixlev_,isvx_,isyz_,output)

    integer(kind=iwp), intent(in) :: iv_, ix_, iy_, iz_, ivlev_, ixlev_, isvx_, isyz_
    real(kind=wp), intent(out) :: output
    real(kind=wp) :: val

    val = Zero

    if ((Mul(SGS%ism(ixlev_),isyz_) == iSym0) .and. (Mul(SGS%ism(ivlev_),istu) == iSym0)) then
      ! C: A_{xyz,vtu} <-- Xtu Evx Eyz
      ISUP = KTUV(iX_,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iV_,iT,iU)-nTUVES(iSYM0)
      val = val+BDERC(ISUP,JSUP)
    end if
    if ((Mul(SGS%ism(ivlev_),isyz_) == iSym0) .and. (Mul(SGS%ism(ixlev_),istu) == iSym0)) then
      ! A: A_{vyz,xtu} <-- -Xtu Evx Eyz
      ISUP = KTUV(iV_,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iX_,iT,iU)-nTUVES(iSYM0)
      val = val-BDERA(ISUP,JSUP)
    end if
    if ((Mul(SGS%ism(iulev),isyz_) == iSym0) .and. (Mul(SGS%ism(itlev),isvx_) == iSym0)) then
      ! A: A_{uyz,txv} <-- -Xtu Evx Eyz
      ISUP = KTUV(iU,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iT,iX_,iV_)-nTUVES(iSYM0)
      val = val-BDERA(ISUP,JSUP)
    end if

    output = val

    return

  end subroutine Add_MKBNEVAC_Xvec

  subroutine Add_MKBNEVAC_Yvec(iv_,ix_,iy_,iz_,ivlev_,ixlev_,isvx_,isyz_,output)

    integer(kind=iwp), intent(in) :: iv_, ix_, iy_, iz_, ivlev_, ixlev_, isvx_, isyz_
    real(kind=wp), intent(out) :: output
    real(kind=wp) :: val

    val = Zero

    if ((Mul(SGS%ism(ixlev_),isyz_) == iSym0) .and. (Mul(SGS%ism(ivlev_),istu) == iSym0)) then
      ! C: A_{xyz,vut} <-- -Ytu Evx Eyz
      ISUP = KTUV(iX_,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iV_,iU,iT)-nTUVES(iSYM0)
      val = val-BDERC(ISUP,JSUP)
    end if
    if ((Mul(SGS%ism(iulev),isyz_) == iSym0) .and. (Mul(SGS%ism(itlev),isvx_) == iSym0)) then
      ! C: A_{uyz,txv} <-- -Ytu Evx Eyz
      ISUP = KTUV(iU,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iT,iX_,iV_)-nTUVES(iSYM0)
      val = val-BDERC(ISUP,JSUP)
    end if
    if ((Mul(SGS%ism(ivlev_),isyz_) == iSym0) .and. (Mul(SGS%ism(ixlev_),istu) == iSym0)) then
      ! A: A_{vyz,xut} <-- +Xtu Evx Eyz
      ISUP = KTUV(iV_,iY_,iZ_)-nTUVES(iSYM0)
      JSUP = KTUV(iX_,iU,iT)-nTUVES(iSYM0)
      val = val+BDERA(ISUP,JSUP)
    end if

    output = val

    return

  end subroutine Add_MKBNEVAC_Yvec

end subroutine NEVPT2_E4_derivative2

!-----------------------------------------------------------------------

subroutine NEVPT2_E4_derivative3(iSym,NLEV,idx2ij,ipxysta,ipxyend,BUFT,CI,XYcont,XYder)

  integer(kind=iwp), intent(in) :: iSym, NLEV, idx2ij(2,NLEV**2), ipxysta, ipxyend
  real(kind=wp), intent(inout) :: BUFT(:), XYcont(:,:,:), XYder(:,:,:)
  real(kind=wp), intent(in) :: CI(:)
  integer(kind=iwp) :: ID, ip1, ipxy, issg1, istu, itlev, iulev, nbufxy, nlev2, nsgm1, nTask, nxy

  if (NXY_work == NLEV) then
    nxy = ipxyend-ipxysta+1
  else
    nxy = NLEV*nxyzdim
  end if
  NLEV2 = NLEV**2

  nTask = nlev2
  call Init_Tsk(ID,nTask)
  nbufxy = 0
  do while (Rsv_Tsk(ID,ip1))
    itlev = idx2ij(1,ip1)
    iulev = idx2ij(2,ip1)
    istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
    issg1 = Mul(istu,stsym)
    nbufxy = nbufxy+1
    if (issg1 /= iSym) cycle
    nsgm1 = CIS%ncsf(issg1)
    !it = L2ACT(itlev)
    !iu = L2ACT(iulev)
    BUFT(1:nsgm1) = Zero
    call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,One,STSYM,CI,BUFT(:))
    do ipxy=1,nxy
      ! ----- E*X and E*Y terms
      if (do_xvec .and. do_yvec) then
        XYder(:,ipxy,1) = XYder(:,ipxy,1)+XYcont(ipxy,1,ip1)*BUFT(:)
        XYder(:,ipxy,2) = XYder(:,ipxy,2)+XYcont(ipxy,2,ip1)*BUFT(:)
      else if (do_xvec .and. (.not. do_yvec)) then
        XYder(:,ipxy,1) = XYder(:,ipxy,1)+XYcont(ipxy,1,ip1)*BUFT(:)
      else if ((.not. do_xvec) .and. do_yvec) then
        XYder(:,ipxy,1) = XYder(:,ipxy,1)+XYcont(ipxy,2,ip1)*BUFT(:)
      end if
    end do
  end do

  call Free_Tsk(ID)

# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    do ip1=1,NXYVEC,MAXBUF
      call GADGOP(XYder(:,ip1,1),MXCI*min(NXYVEC-ip1+1,MAXBUF),'+')
    end do
    if (do_xvec .and. do_yvec) then
      do ip1=1,NXYVEC,MAXBUF
        call GADGOP(XYder(:,ip1,2),MXCI*min(NXYVEC-ip1+1,MAXBUF),'+')
      end do
    end if
  end if
# endif

end subroutine NEVPT2_E4_derivative3

!-----------------------------------------------------------------------

subroutine NEVPT2_E4_XYder1(iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,XYder,Gder,Zder)

  integer(kind=iwp), intent(in) :: iSym, NLEV, idx2ij(2,NLEV**2), ij2idx(NLEV,NLEV), ipxysta, ipxyend
  real(kind=wp), intent(inout) :: BUFT(:), Gder(:,:,:,:), Zder(:,:)
  real(kind=wp), intent(in) :: CI(:), XYder(:,:,:)
  integer(kind=iwp) :: ID, ip1, ip2, ipxy, issg1, issg2, istu, isvx, it, itlev, iu, iulev, iv, ivlev, ix, ixlev, iy, iylev, locx, &
                       locy, nlev2, nsgm1, nsgm2, nTask, nxy
  real(kind=wp), allocatable :: BUF1(:), BUF2(:)
  real(kind=wp), external :: ddot_

  locx = 1
  locy = 1
  if (do_xvec .and. do_yvec) then
    locy = 2
  else if (do_xvec .or. do_yvec) then
    locy = 1
  end if

  if (NXY_work == NLEV) then
    nxy = ipxyend-ipxysta+1
  else
    nxy = NLEV*nxyzdim
  end if
  NLEV2 = NLEV**2

  if (do_zder) then
    Zder(1:MXCI,1:nxy) = Zero
    nTask = NLEV2
    call Init_Tsk(ID,nTask)
    do while (Rsv_Tsk(ID,ip2))
      ivlev = idx2ij(1,ip2)
      ixlev = idx2ij(2,ip2)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      issg2 = Mul(isvx,stsym)
      nsgm2 = CIS%ncsf(issg2)
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      if ((NXY_work /= NLEV) .and. ((ivlev < ixyzsta) .or. (ivlev > ixyzend))) cycle
      do ip1=1,nlev2
        itlev = idx2ij(1,ip1)
        iulev = idx2ij(2,ip1)
        istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
        issg1 = Mul(istu,issg2)
        if (issg1 /= iSym) cycle
        nsgm1 = CIS%ncsf(issg1)
        it = L2ACT(itlev)
        iu = L2ACT(iulev)
        if (((.not. do_xvec) .or. (it /= ix)) .and. ((.not. do_yvec) .or. (iu /= ix))) cycle
        BUFT(1:nsgm2) = Zero
        ! X_{v,u}^I = <Phi_I|E_{x,u}|Phi_J> Z_{v,x}^J
        if (do_xvec .and. (it == ix)) then
          if (NXY_work == NLEV) then
            ipxy = ij2idx(ivlev,iulev)
            if ((ipxy >= ipxysta) .and. (ipxy <= ipxyend)) BUFT(1:nsgm2) = BUFT(1:nsgm2)+XYder(1:nsgm2,ipxy-ipxysta+1,locx)
          else
            if ((ivlev >= ixyzsta) .and. (ivlev <= ixyzend)) &
              BUFT(1:nsgm2) = BUFT(1:nsgm2)+XYder(1:nsgm2,ivlev-ixyzsta+1+nxyzdim*(iulev-1),locx)
          end if
        end if
        ! Y_{v,t}^I = <Phi_I|E_{t,x}|Phi_J> Z_{v,x}^J
        if (do_yvec .and. (iu == ix)) then
          if (NXY_work == NLEV) then
            ipxy = ij2idx(ivlev,itlev)
            if ((ipxy >= ipxysta) .and. (ipxy <= ipxyend)) BUFT(1:nsgm2) = BUFT(1:nsgm2)+XYder(1:nsgm2,ipxy-ipxysta+1,locy)
          else
            if ((ivlev >= ixyzsta) .and. (ivlev <= ixyzend)) &
              BUFT(1:nsgm2) = BUFT(1:nsgm2)+XYder(1:nsgm2,ivlev-ixyzsta+1+nxyzdim*(itlev-1),locy)
          end if
        end if
        if (NXY_work == NLEV) then
          call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,One,issg2,BUFT(:),Zder(:,ip2))
        else
          call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,One,issg2,BUFT(:),Zder(:,ivlev-ixyzsta+1+nxyzdim*(ixlev-1)))
        end if
      end do
    end do

  else

    call mma_allocate(BUF1,MXCI,Label='BUF1')
    call mma_allocate(BUF2,MXCI,Label='BUF2')

    !! derivatives of Xvec and Yvec
    nTask = nlev2
    call Init_Tsk(ID,nTask)
    do while (Rsv_Tsk(ID,ip2))
      ivlev = idx2ij(1,ip2)
      ixlev = idx2ij(2,ip2)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      issg2 = Mul(isvx,stsym)
      nsgm2 = CIS%ncsf(issg2)
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      buf1(1:nsgm2) = Zero
      call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,STSYM,CI,buf1(:))
      !! electron repulsion terms
      do ip1=ip2,nlev2
        itlev = idx2ij(1,ip1)
        iulev = idx2ij(2,ip1)
        istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
        issg1 = Mul(istu,issg2)
        if (issg1 /= iSym) cycle
        nsgm1 = CIS%ncsf(issg1)
        it = L2ACT(itlev)
        iu = L2ACT(iulev)
        buf2(1:nsgm1) = Zero
        call SG_Epq_Psi(SGS,CIS,EXS,ITLEV,IULEV,One,issg2,buf1(:),BUF2(:))
        do iylev=1,nlev
          iy = L2ACT(iylev)
          ! Etu Evx * (at|vx) -> Xau
          ipxy = ij2idx(iylev,iulev)
          if (do_xvec) then
            if (NXY_work == NLEV) then
              Gder(iy,it,iv,ix) = Gder(iy,it,iv,ix)+ddot_(nsgm1,XYder(:,ipxy-ipxysta+1,locx),1,buf2(1:nsgm1),1)
            else if ((iylev >= ixyzsta) .and. (iylev <= ixyzsta)) then
              Gder(iy,it,iv,ix) = Gder(iy,it,iv,ix)+ddot_(nsgm1,XYder(:,iylev-ixyzsta+1+nxyzdim*(iulev-1),locx),1,buf2(1:nsgm1),1)
            end if
          end if
          ! Etu Evx * (au|vx) -> Yat
          ipxy = ij2idx(iylev,itlev)
          if (do_yvec) then
            if (NXY_work == NLEV) then
              Gder(iy,iu,iv,ix) = Gder(iy,iu,iv,ix)+ddot_(nsgm1,XYder(:,ipxy-ipxysta+1,locy),1,buf2(1:nsgm1),1)
            else if ((iylev >= ixyzsta) .and. (iylev <= ixyzsta)) then
              Gder(iy,iu,iv,ix) = Gder(iy,iu,iv,ix)+ddot_(nsgm1,XYder(:,iylev-ixyzsta+1+nxyzdim*(itlev-1),locy),1,buf2(1:nsgm1),1)
            end if
          end if
        end do
        if (ip1 /= ip2) then
          ! EvxEtu = EtuEvx + Evu del(tx) - Etx del(vu)
          buft(1:nsgm1) = buf2(1:nsgm1)
          if ((itlev == ixlev) .and. (iSym == Mul(Mul(SGS%ism(iulev),SGS%ism(ivlev)),STSYM))) &
            call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IULEV,+One,STSYM,CI,BUFT(1:nsgm1))
          if ((iulev == ivlev) .and. (iSym == Mul(Mul(SGS%ism(itlev),SGS%ism(ixlev)),STSYM))) &
            call SG_Epq_Psi(SGS,CIS,EXS,ITLEV,IXLEV,-One,STSYM,CI,BUFT(1:nsgm1))
          do iylev=1,nlev
            iy = L2ACT(iylev)
            ! Evx Etu * (av|tu) -> Xat
            ipxy = ij2idx(iylev,ixlev)
            if (do_xvec) then
              if (NXY_work == NLEV) then
                Gder(iy,iv,it,iu) = Gder(iy,iv,it,iu)+ddot_(nsgm1,XYder(:,ipxy-ipxysta+1,locx),1,buft(1:nsgm1),1)
              else if ((iylev >= ixyzsta) .and. (iylev <= ixyzsta)) then
                Gder(iy,iv,it,iu) = Gder(iy,iv,it,iu)+ddot_(nsgm1,XYder(:,iylev-ixyzsta+1+nxyzdim*(ixlev-1),locx),1,buft(1:nsgm1),1)
              end if
            end if
            ! Evx Etu * (ax|tu) -> Yav
            ipxy = ij2idx(iylev,ivlev)
            if (do_yvec) then
              if (NXY_work == NLEV) then
                Gder(iy,ix,it,iu) = Gder(iy,ix,it,iu)+ddot_(nsgm1,XYder(:,ipxy-ipxysta+1,locy),1,buft(1:nsgm1),1)
              else if ((iylev >= ixyzsta) .and. (iylev <= ixyzsta)) then
                Gder(iy,ix,it,iu) = Gder(iy,ix,it,iu)+ddot_(nsgm1,XYder(:,iylev-ixyzsta+1+nxyzdim*(ivlev-1),locy),1,buft(1:nsgm1),1)
              end if
            end if
          end do
        end if
      end do
    end do
    call mma_deallocate(BUF1)
    call mma_deallocate(BUF2)
  end if

  call Free_Tsk(ID)

# ifdef _MOLCAS_MPP_
  if (is_real_par() .and. do_zder) then
    do ip1=1,NXYVEC,MAXBUF
      call GADGOP(Zder(:,ip1),MXCI*min(NXYVEC-ip1+1,MAXBUF),'+')
    end do
  end if
# endif

end subroutine NEVPT2_E4_XYder1

!-----------------------------------------------------------------------

subroutine NEVPT2_E4_XYder2(iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,Gact,XYvec,XYder,XYcont,XYcontder,ZVEC,Zder,CLag,Gder, &
                            XYtmp)

  integer(kind=iwp), intent(in) :: iSym, NLEV, idx2ij(2,NLEV**2), ij2idx(NLEV,NLEV), ipxysta, ipxyend
  real(kind=wp), intent(inout) :: BUFT(:), ZVEC(:,:), CLag(:), Gder(:,:,:,:), XYtmp(:,:,:)
  real(kind=wp), intent(in) :: CI(:), Gact(:,:,:,:), XYvec(:,:,:), XYder(:,:,:), XYcont(:,:,:), XYcontder(:,:,:), Zder(:,:)
  integer(kind=iwp) :: ID, ip1, ip1end, ip1sta, ip2, ip23, ip2_rev, ip3, ip3_rev, ipxy, issg1, issg2, istu, isvx, it, itlev, iu, &
                       iulev, iv, ivlev, ix, ixlev, izlev, locx, locy, nbufxy, nlev2, nsgm1, nsgm2, nTask, nxy
  real(kind=wp), allocatable :: Gact_sort(:), Gder_sort(:)

  locx = 1
  locy = 1
  if (do_xvec .and. do_yvec) then
    locy = 2
  else if (do_xvec .or. do_yvec) then
    locy = 1
  end if

  if (NXY_work == NLEV) then
    nxy = ipxyend-ipxysta+1
  else
    nxy = NLEV*nxyzdim
  end if
  NLEV2 = NLEV**2
  call mma_allocate(Gact_sort,NLEV2,LABEL='Gact_sort')
  call mma_allocate(Gder_sort,NLEV2,LABEL='Gder_sort')

  !! complete the CI derivative
  issg2 = 1
  if (do_zder) then

    nTask = NLEV2
    call Init_Tsk(ID,nTask)

    !ibuf = 0
    !Scal = Zero
    ! Z_{t,u}^I = \sum_{v,x} (tu|vx) <Phi_I|E_{v,x}|Psi>
    do while (Rsv_Tsk(ID,ip2))
      ivlev = idx2ij(1,ip2)
      ixlev = idx2ij(2,ip2)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      issg2 = Mul(isvx,stsym)
      nsgm2 = CIS%ncsf(issg2)
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      !ibuf = ibuf + 1
      BUFT(1:MXCI) = Zero
      call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,STSYM,CI,BUFT(:))
      if (NXY_work == NLEV) then
        !call dgemv_('T',nsgm1,nxy,One,XYvec(:,:,1),mxci,BUFT(:),1,Zero,XYcont(:,1,ip1),1)
        call dgemv_('T',nsgm2,nxy,One,Zder,MXCI,BUFT,1,Zero,Gder_sort,1)
        BUFT(1:nsgm2) = Zero
        do ip1=1,nlev2
          itlev = idx2ij(1,ip1)
          iulev = idx2ij(2,ip1)
          it = L2ACT(itlev)
          iu = L2ACT(iulev)
          !Gact_sort(ip1,ibuf) = Gact(it,iu,iv,ix)
          Gder(it,iu,iv,ix) = Gder(it,iu,iv,ix)+Gder_sort(ip1)
          !call SG_Epq_Psi(SGS,CIS,EXS,IvLEV,IxLEV,Gact(itlev,iulev,ivlev,ixlev),STSYM,Zder(:,ip1),CLag(:))
          Gact_sort(ip1) = Gact(itlev,iulev,ivlev,ixlev)
          !BUFT(1:nsgm2) = BUFT(1:nsgm2) + Gact(itlev,iulev,ivlev,ixlev)*Zder(1:nsgm2,ip1)
        end do
        call dgemv_('N',nsgm2,nlev2,One,Zder(:,:),MXCI,Gact_sort(:),1,Zero,BUFT,1)
        !call SG_Epq_Psi(SGS,CIS,EXS,IvLEV,IxLEV,One,STSYM,BUFT(:),CLag(:))
      else
        call dgemv_('T',nsgm2,nxy,One,Zder,MXCI,BUFT,1,Zero,Gder_sort,1)
        do itlev=ixyzsta,ixyzend
          do iulev=1,nlev
            !ip1 = ij2idx(ixy_local,iulev_local)
            !itlev = idx2ij(1,ip1)
            !iulev = idx2ij(2,ip1)
            it = L2ACT(itlev)
            iu = L2ACT(iulev)
            !Gact_sort(iulev_local) = Gact(it,iu,iv,ix)
            !Gact_sort(itlev-ixyzsta+1+nxyzdim*(iulev-1),ibuf) = Gact(itlev,iulev,iv,ix)
            Gder(it,iu,iv,ix) = Gder(it,iu,iv,ix)+Gder_sort(itlev-ixyzsta+1+nxyzdim*(iulev-1))
            Gact_sort(itlev-ixyzsta+1+nxyzdim*(iulev-1)) = Gact(itlev,iulev,ivlev,ixlev)
          end do
        end do
        BUFT(1:nsgm2) = Zero
        call dgemv_('N',nsgm2,nxy,One,Zder(:,:),MXCI,Gact_sort(:),1,Zero,BUFT,1)
      end if

      ip2_rev = ij2idx(ixlev,ivlev)
      Zbufloop: do ip1sta=ip2_rev,nlev2,nxy
        nbufxy = 0
        ip1end = min(nlev2,ip1sta-1+nxy)
        !if (NXY_work /= NLEV) XYtmp(1:nxy,1:ip1end-ip1sta+1,1:2) = Zero
        !! XYtmp = XYtmp2 outside: XYtmp2(NXYVEC,NLEV2,2)
        if (NXY_work /= NLEV) XYtmp(:,:,:) = Zero
        do ip1=ip1sta,ip1end
          itlev = idx2ij(1,ip1)
          iulev = idx2ij(2,ip1)
          istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
          issg1 = Mul(istu,issg2)
          if (issg1 /= iSym) cycle
          nsgm1 = CIS%ncsf(issg1)
          it = L2ACT(itlev)
          iu = L2ACT(iulev)
          !if (NXY_work == NLEV) then
          nbufxy = nbufxy+1
          ip23 = iTri(ip1,ip2_rev)
          XYtmp(1:nxy,nbufxy,1) = XYcontder(1:nxy,1,ip23)
          XYtmp(1:nxy,nbufxy,2) = XYcontder(1:nxy,2,ip23)
          !else if ((itlev >= ixyzsta) .and. (iulev <= ixyzend)) then
          !  nbufxy = nbufxy+1
          !  ip23 = iTri(ip1,ip2_rev)
          !  !XYtmp(1:nxy,nbufxy,1) = XYcontder(1:nxy,1,ip23)
          !  !XYtmp(1:nxy,nbufxy,2) = XYcontder(1:nxy,2,ip23)
          !  XYtmp(1:nxy,itlev-ixyzsta+1+nxyzdim*(iulev-1),1) = XYcontder(1:nxy,1,ip23)
          !  XYtmp(1:nxy,itlev-ixyzsta+1+nxyzdim*(iulev-1),2) = XYcontder(1:nxy,2,ip23)
          !  nbufxy = nxy
          !end if
        end do

        ZVEC(1:nsgm1,1:nbufxy) = Zero
        if (do_xvec .and. do_yvec) then
          call dgemm_('N','N',nsgm1,nbufxy,nxy,One,XYvec(:,:,1),MXCI,XYtmp(:,:,1),NXYVEC,One,ZVEC(:,:),MXCI)
          call dgemm_('N','N',nsgm1,nbufxy,nxy,One,XYvec(:,:,2),MXCI,XYtmp(:,:,2),NXYVEC,One,ZVEC(:,:),MXCI)
        else if (do_xvec .and. (.not. do_yvec)) then
          call dgemm_('N','N',nsgm1,nbufxy,nxy,One,XYvec(:,:,1),MXCI,XYtmp(:,:,1),NXYVEC,One,ZVEC(:,:),MXCI)
        else if ((.not. do_xvec) .and. do_yvec) then
          call dgemm_('N','N',nsgm1,nbufxy,nxy,One,XYvec(:,:,1),MXCI,XYtmp(:,:,2),NXYVEC,One,ZVEC(:,:),MXCI)
        end if

        nbufxy = 0
        do ip1=ip1sta,ip1end
          itlev = idx2ij(1,ip1)
          iulev = idx2ij(2,ip1)
          istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
          issg1 = Mul(istu,issg2)
          if (issg1 /= iSym) cycle
          nsgm1 = CIS%ncsf(issg1)
          it = L2ACT(itlev)
          iu = L2ACT(iulev)
          !if (NXY_work == NLEV) then
          nbufxy = nbufxy+1
          call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,One,issg1,ZVEC(:,nbufxy),BUFT(:))
          !else if ((itlev >= ixyzsta) .and. (iulev <= ixyzend)) then
          !  nbufxy = nbufxy + 1
          !  !nbufxy = itlev-ixyzsta+1+nxyzdim*(iulev-1)
          !  call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,One,issg1,ZVEC(:,nbufxy),BUFT(:))
          !end if
        end do
      end do Zbufloop

      if (do_xvec .and. do_yvec) then
        call dgemv_('N',nsgm1,nxy,One,XYvec(:,:,1),mxci,XYcont(:,1,ip2),1,One,BUFT(:),1)
        call dgemv_('N',nsgm1,nxy,One,XYvec(:,:,2),mxci,XYcont(:,2,ip2),1,One,BUFT(:),1)
      else if (do_xvec .and. (.not. do_yvec)) then
        call dgemv_('N',nsgm1,nxy,One,XYvec(:,:,1),mxci,XYcont(:,1,ip2),1,One,BUFT(:),1)
      else if ((.not. do_xvec) .and. do_yvec) then
        call dgemv_('N',nsgm1,nxy,One,XYvec(:,:,1),mxci,XYcont(:,2,ip2),1,One,BUFT(:),1)
      end if

      call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,issg2,BUFT(:),CLag)
    end do

  else

    nTask = nlev2
    call Init_Tsk(ID,nTask)
    do while (Rsv_Tsk(ID,ip3))
      ivlev = idx2ij(1,ip3)
      ixlev = idx2ij(2,ip3)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      issg1 = Mul(isvx,issg2)
      if (issg1 /= iSym) cycle
      nsgm1 = CIS%ncsf(issg1)
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      BUFT(1:mxci) = Zero
      do ip2=1,nlev2
        itlev = idx2ij(1,ip2)
        iulev = idx2ij(2,ip2)
        istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
        issg1 = Mul(istu,issg2)
        if (issg1 /= iSym) cycle
        nsgm1 = CIS%ncsf(issg1)
        it = L2ACT(itlev)
        iu = L2ACT(iulev)
        do izlev=1,NLEV
          !! X(z,u) = (zt|vx)*<I|EtuEvx|Psi>
          ipxy = ij2idx(izlev,iulev)
          if (do_xvec .and. (ipxy >= ipxysta) .and. (ipxy <= ipxyend)) &
            call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,Gact(izlev,itlev,ivlev,ixlev),issg2,XYder(:,ipxy-ipxysta+1,locx),BUFT(:))
          !! Y(z,t) = (zu|vx)*<I|EtuEvx|Psi>
          ipxy = ij2idx(izlev,itlev)
          if (do_yvec .and. (ipxy >= ipxysta) .and. (ipxy <= ipxyend)) &
            call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,Gact(izlev,iulev,ivlev,ixlev),issg2,XYder(:,ipxy-ipxysta+1,locy),BUFT(:))
        end do
      end do

      ip3_rev = ij2idx(ixlev,ivlev)
      do ip2=ip3_rev,nlev2
        itlev = idx2ij(1,ip2)
        iulev = idx2ij(2,ip2)
        istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
        issg1 = Mul(istu,issg2)
        if (issg1 /= iSym) cycle
        nsgm1 = CIS%ncsf(issg1)
        it = L2ACT(itlev)
        iu = L2ACT(iulev)
        ip23 = iTri(ip2,ip3_rev)
        do ipxy=1,nxy
          if (do_xvec .and. do_yvec) then
            call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,XYcontder(ipxy,1,ip23),issg1,XYvec(:,ipxy,1),BUFT(:))
            call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,XYcontder(ipxy,2,ip23),issg1,XYvec(:,ipxy,2),BUFT(:))
          else if (do_xvec .and. (.not. do_yvec)) then
            call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,XYcontder(ipxy,1,ip23),issg1,XYvec(:,ipxy,1),BUFT(:))
          else if ((.not. do_xvec) .and. do_yvec) then
            call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,XYcontder(ipxy,2,ip23),issg1,XYvec(:,ipxy,1),BUFT(:))
          end if
        end do
      end do

      if (do_xvec .and. do_yvec) then
        call dgemv_('N',nsgm1,nxy,One,XYvec(:,:,1),mxci,XYcont(:,1,ip3),1,One,BUFT(:),1)
        call dgemv_('N',nsgm1,nxy,One,XYvec(:,:,2),mxci,XYcont(:,2,ip3),1,One,BUFT(:),1)
      else if (do_xvec .and. (.not. do_yvec)) then
        call dgemv_('N',nsgm1,nxy,One,XYvec(:,:,1),mxci,XYcont(:,1,ip3),1,One,BUFT(:),1)
      else if ((.not. do_xvec) .and. do_yvec) then
        call dgemv_('N',nsgm1,nxy,One,XYvec(:,:,1),mxci,XYcont(:,2,ip3),1,One,BUFT(:),1)
      end if

      call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,issg2,BUFT(:),CLag)
    end do
  end if

  call Free_Tsk(ID)

  call mma_deallocate(Gact_sort)
  call mma_deallocate(Gder_sort)

end subroutine NEVPT2_E4_XYder2

end module NEVPT2_E4

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SmAdNa(ArrIn,nb,ArrOut,nop,lOper,IndGrd,iuv,Indx,iDCar,rf,tr)

use Symmetry_Info, only: iChBas, iChTbl, nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nb, nOp(3), lOper, IndGrd(3,4,0:nIrrep-1), iuv(3), Indx(3,4), iDCar
real(kind=wp), intent(in) :: ArrIn(nb,*), rf
real(kind=wp), intent(inout) :: ArrOut(nb,*)
logical(kind=iwp), intent(in) :: tr(4)
integer(kind=iwp) :: i1, i2, iCn, iComp, iIrrep
real(kind=wp) :: Fact, ps
integer(kind=iwp), external :: iPrmt

!iRout = 200
!iPrint = nPrint(iRout)

! Accumulate contributions

iComp = 0
do iIrrep=0,nIrrep-1
  if (btest(lOper,iIrrep)) then
    iComp = iComp+1
    do iCn=1,3
      !if (Indx(idCar,iCn) /= 0) then
      if ((Indgrd(idCar,iCn,iIrrep) /= 0) .and. ((Indx(idcar,icn) > 0) .or. tr(icn))) then
        ! Accumulate contribution to the gradient
        i1 = 0
        i2 = 0
        if (iCn == 1) then
          ps = real(iPrmt(nOp(1),iChBas(1+idCar)),kind=wp)
          Fact = rf*real(iuv(1),kind=wp)/real(nIrrep,kind=wp)
          if (.not. tr(iCn)) then
            i1 = Indx(idCar,iCn)
          else
            if (Indx(idcar,2) > 0) i1 = Indx(idCar,2)
            if (Indx(idCar,3) > 0) i2 = Indx(idCar,3)
            Fact = -Fact
          end if
        else if (iCn == 2) then
          ps = real(iChTbl(iIrrep,nOp(2)),kind=wp)
          ps = ps*real(iPrmt(nOp(2),iChBas(1+idCar)),kind=wp)
          Fact = rf*ps*real(iuv(2),kind=wp)/real(nIrrep,kind=wp)
          if (.not. tr(iCn)) then
            i1 = Indx(idCar,iCn)
          else
            if (Indx(idcar,1) > 0) i1 = Indx(idCar,1)
            if (Indx(idCar,3) > 0) i2 = Indx(idCar,3)
            Fact = -Fact
          end if
        else
          ps = real(iChTbl(iIrrep,nOp(3)),kind=wp)
          ps = ps*real(iPrmt(nOp(3),iChBas(1+idCar)),kind=wp)
          Fact = rf*ps*real(iuv(3),kind=wp)/real(nIrrep,kind=wp)
          if (.not. tr(iCn)) then
            i1 = Indx(idCar,iCn)
          else
            if (Indx(idcar,1) > 0) i1 = Indx(idCar,1)
            if (Indx(idCar,2) > 0) i2 = Indx(idCar,2)
            Fact = -Fact
          end if
        end if
        if (i1 /= 0) ArrOut(:,iComp) = ArrOut(:,iComp)+Fact*ArrIn(:,i1)
        if (i2 /= 0) ArrOut(:,iComp) = ArrOut(:,iComp)+Fact*ArrIn(:,i2)
      end if
    end do
  end if
end do

return

end subroutine SmAdNa

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine Hess(FockC,FockX,rCon,Temp1,Temp2,Temp3,Temp4,idsym,jdisp,idisp)
! Constructs the connection parts that is dependend on the first
! derivative of the connection.

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use MCLR_Data, only: CMO, DspVec, F0SQMO, Hss, ipCM, ipMat, lDisp, nDens
use input_mclr, only: nBas, nOrb, nSym, nTPert
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: FockC(nDens), FockX(nDens), rcon(nDens)
real(kind=wp), intent(out) :: Temp1(nDens), Temp2(nDens), Temp3(nDens)
real(kind=wp), intent(_OUT_) :: temp4(*)
integer(kind=iwp), intent(in) :: idSym, jDisp, iDisp
integer(kind=iwp) :: IndX, iOp, iOpt, iP, iRC, iS, jS, kDisp, mDisp, nIn, nNJ
real(kind=wp) :: Fact
character(len=8) :: Label
real(kind=wp), external :: DDot_

Temp3(:) = FockX(:)
if (btest(ntpert(idisp),3)) then
  do iS=1,nSym
    js = Mul(is,idSym)
    nnj = nOrb(js)!nash(js)+nash(js)
    if (nOrb(is)*nOrb(js) /= 0) call DGEMM_('N','N',nOrb(is),nnj,nnj,-Half,rCon(ipMat(is,js)),nOrb(is),F0SQMO(ipCM(jS)),nOrb(js), &
                                            One,Temp3(ipMat(is,js)),nOrb(is))

  end do
  Temp3(:) = Temp3(:)+Half*FockC(:)
end if

!              xa     ca      xa
! Temp3 = Y = F + 1/2F  -1/2 S  F

nIn = 0
mdisp = sum(lDisp(1:idsym-1))
do iS=1,idsym-1
  nIn = nIn+nTri_Elem(lDisp(is))
end do

do kDisp=1,ldisp(idsym)
  mDisp = mdisp+1
  if (.not. btest(ntpert(mdisp),3)) cycle
  iRC = -1
  iOpt = 0
  Label = 'OvrGrd'
  iOp = ibset(0,idSym)
  call dRdMck(iRC,iOpt,Label,DspVec(mDisp),Temp1,iop)
  if (iRc /= 0) then
    write(u6,*) 'Hess: Error reading MCKINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if
  ip = 1
  do iS=1,nSym
    do jS=1,iS
      if (nOrb(is)*nOrb(jS) /= 0) then
        if (Mul(iS,jS) == idsym) then
          if (is == js) then
            call Square(Temp1(ip),Temp2(ipMat(iS,jS)),1,nBas(is),nBas(is))
            ip = ip+nTri_Elem(nBas(is))
          else
            if (nBas(is)*nBas(js) /= 0) Temp2(ipMat(iS,jS):ipMat(iS,jS)+nBas(iS)*nBas(jS)-1) = Temp1(ip:ip+nBas(iS)*nBas(jS)-1)
            ip = ip+nBas(is)*nBas(js)
          end if
          if (nBas(is)*nBas(js) /= 0) then
            call DGEMM_('T','N',nOrb(iS),nBAs(jS),nBas(iS),One,CMO(ipCM(iS)),nBas(iS),Temp2(ipMat(iS,jS)),nBas(iS),Zero,Temp4, &
                        nOrb(is))
            Temp2(ipMat(is,js):ipMat(is,js)+nBas(is)*nBas(js)-1) = Zero
            call DGEMM_('N','N',nOrb(iS),nOrb(jS),nBas(jS),One,Temp4,nOrb(iS),CMO(ipCM(jS)),nBas(jS),Zero,Temp2(ipMat(iS,jS)), &
                        nOrb(iS))
            if (is /= js) then
              Temp2(ipMat(js,is):ipMat(js,is)+nBas(is)*nBas(js)-1) = Zero
              call DGEMM_('T','T',nOrb(js),nOrb(iS),nBas(js),One,CMO(ipCM(js)),nBas(js),Temp4,nOrb(is),Zero,Temp2(ipMat(js,is)), &
                          nOrb(js))
            end if
          end if
        end if
      end if
    end do
  end do
  Fact = One
  if (kDisp == jDisp) Fact = Two
  Indx = nIn+iTri(kDisp,jDisp)
  Hss(Indx) = Hss(Indx)-fact*ddot_(nDens,Temp2,1,Temp3,1)
end do

end subroutine Hess

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION IOFF_SYM_DIST(ISYM,NGASL,IOFF,MAXVAL,MINVAL)
*
* A ts block of string is given and the individual
* symmetrydisrtributions has been obtained ( for example
* by TS_SYM_PNT)
*
* Obtain offset for symmetrycombination defined by ISYM
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER ISYM(*),IOFF(*),MAXVAL(*),MINVAL(*)
* Address in IOFF is
*     1
*     +  (ISM1-MINVAL(1))
*     +  (ISM2-MINVAL(2))*(MAXVAL(1)-MINVAL(1)+1)
*     +  (ISM3-MINVAL(3))*(MAXVAL(1)-MINVAL(1)+1)*(MAXVAL(2)-MINVAL(2)+1)
*     +
*     +
*     +
*     +  (ISM L-1-MINVAL(L-1))*Prod(i=1,L-2)(MAXVAL(i)-MINVAL(i)+1)
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
       write(6,*) ' Isym, minval, ioff:'
       call iwrtma(isym,1,ngasl,1,ngasl)
       call iwrtma(minval,1,ngasl,1,ngasl)
       call iwrtma(ioff,1,ngasl,1,ngasl)
      END IF
*. Offset for this symmetry distribution in IOFFI
      I = 1
      IMULT = 1
      DO IGAS = 1, NGASL-1
        I = I + (ISYM(IGAS)-MINVAL(IGAS)) * IMULT
        IMULT = IMULT*(MAXVAL(IGAS)-MINVAL(IGAS)+1)
c        write(6,*) ' igas,i,imult ',igas,i,imult
      END DO
c The following IF block is needed for avoinging going outside the IOFF bounds.
c This is possible for certain GAS setups. Test 897 helped in finding this issue.
      IF (I.le.0) THEN
        IOFF_SYM_DIST=0
      ELSE
        IOFF_SYM_DIST=IOFF(I)
      END IF
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Info from IOFF_SYM_DIST'
        WRITE(6,*) ' ======================='
        WRITE(6,*)
        WRITE(6,*) ' Address and offset ',I,IOFF_SYM_DIST
        WRITE(6,*) ' Symmetry distribution : ', (ISYM(J),J=1,NGASL)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine symtrizcvb3_cvb(vecstr,idelstr)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension vecstr(nvb),idelstr(nzrvb)

c  Zero coefficients specified by idelstr :
      if(lzrvb.eq.0)then
        do 100 i=1,nzrvb
        if(idelstr(i).gt.0)vecstr(idelstr(i))=0d0
100     continue
      else
c  if here, idelstr specifies which structures to *keep* :
        if(nzrvb.ge.1)call fzero(vecstr,idelstr(1)-1)
        do 200 ikeep=1,nzrvb-1
        call fzero(vecstr(idelstr(ikeep)+1),
     >    idelstr(ikeep+1)-idelstr(ikeep)-1)
200     continue
      endif
      return
      end
c  *****************************************
c  ** All <-> constrained transformations **
c  *****************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*  IniMem
*
*> @brief
*>   Initialize memory for Molcas
*>
*> @details
*> Initialize memory for Molcas.
************************************************************************
      Subroutine IniMem
      Use stdalloc, only: MxMem
      Implicit Real*8 (A-H,O-Z)
*
#include "SysCtl.fh"
#include "warnings.h"
#include "mama.fh"
#include "WrkSpc.fh"
*
      Interface
        Function allocmem(ref,intof,dblof,chrof,size_)
     &           bind(C,name='allocmem_')
          Use Definitions, only: MOLCAS_C_INT, MOLCAS_C_REAL
          Integer(kind=MOLCAS_C_INT) :: allocmem
          Real(kind=MOLCAS_C_REAL) :: ref(*)
          Integer(kind=MOLCAS_C_INT) :: intof, dblof, chrof, size_
        End Function allocmem
      End Interface
*----------------------------------------------------------------------*
*     Initialize the Common / MemCtl / the first time it is referenced *
*----------------------------------------------------------------------*
      Do i=1,ipCheck
         MemCtl(i)=0
      End Do
      MemCtl(ipStat)   = ON
      MemCtl(ipTrace)  = OFF
      MemCtl(ipQuery)  = OFF
      MemCtl(ipCheck)  = OFF
      MemCtl(ipClear)  = OFF
#ifndef NAGFOR
#ifdef _GARBLE_
      MemCtl(ipCheck)  = ON
      MemCtl(ipClear)  = ON
#endif
#endif
      MemCtl(ipSysOut) = 6

*----------------------------------------------------------------------*
*     Grab from the system a pointer to the dynamic work area          *
*----------------------------------------------------------------------*
      iRc=allocmem(Work,iofint,iofdbl,iofchr,MxMem)
      If ( iRc.ne.0 ) Then
         Write (6,'(A,I3,A)') 'The initialization of the memory '//
     &                        'manager failed ( iRc=',iRc,' ).'
         Call Quit(_RC_MEMORY_ERROR_)
      End If
*----------------------------------------------------------------------*
*     Allocate "dummy" pointers                                        *
*----------------------------------------------------------------------*
      Call GetMem('ip_Dum', 'Allo','REAL',ip_Dummy,  1)
      Call GetMem('ip_iDum','Allo','INTE',ip_iDummy, 1)
*----------------------------------------------------------------------*
*     exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE WRH(LU,NSYM,NBAS,NORB,CMO,OCC,LOCC,TITLE)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NBAS(NSYM),NORB(NSYM),CMO(*),OCC(*)
      CHARACTER*(*) TITLE
      CHARACTER FMT*40
      FMT='(4E20.12)'
*     REWIND (LU)
      KCMO  = 0
      NDIV  = 4
      IF(TITLE(1:1).NE.'*') TITLE='*'//TITLE(:LEN(TITLE)-1)
      If (locc.ne.2) Then
      DO 100 ISYM=1,NSYM
         DO 110 IORB=1,NORB(ISYM)
            WRITE(LU,'(A,I5)') '* Column    ',IORB
            DO 111 IBAS=1,NBAS(ISYM),NDIV
               WRITE(LU,FMT) (CMO(I+KCMO),I=IBAS,MIN(IBAS+3,NBAS(ISYM)))
111         CONTINUE
            KCMO=KCMO+NBAS(ISYM)
110      CONTINUE
100   CONTINUE
      End If
      IF(LOCC.EQ.0) RETURN
      WRITE(LU,'(A)') Title
      KOCC=0
      DO 200 ISYM=1,NSYM
         DO 210 IORB=1,NORB(ISYM),NDIV
            WRITE(LU,FMT) (OCC(I+KOCC),I=IORB,MIN(IORB+3,NORB(ISYM)))
210      CONTINUE
         KOCC=KOCC+NORB(ISYM)
200   CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1995, Roland Lindh                                *
************************************************************************
      SubRoutine DrvN0()
************************************************************************
*                                                                      *
* Object: to compute the nuclear contibutions to the nuclear potential *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
*             Modified for various other contributions May 95', RL     *
************************************************************************
      use external_centers
      use Basis_Info
      use Center_Info
      use Phase_Info
      use Temporary_Parameters, only: Expert
      use Real_Info, only: PotNuc
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 A(3), B(3), RB(3)
      Integer iDCRR(0:7), jCoSet(8,8), iStb(0:7), jStb(0:7)
      Logical EQ, NoLoop
*
      NoLoop=.True.
      iDum=0
      r12_Min=0.0D0
*
*----- Nuclear repulsion, in case of some ECP we include the core electronic
*     contribution (pseudo charges). The interaction of pseudo charges is
*     excluded from the energy term.
*
      PotNuc = Zero
      mdc = 0
      ZB=Zero
      Do iCnttp = 1, nCnttp
         ZA = dbsc(iCnttp)%Charge
         If (dbsc(iCnttp)%Frag) ZA = dbsc(iCnttp)%FragCharge
         If (ZA.eq.Zero) Go To 101
         Do iCnt = 1, dbsc(iCnttp)%nCntr
            A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
            ndc = 0
            Do jCnttp = 1, iCnttp
               If (dbsc(iCnttp)%pChrg.and.dbsc(jCnttp)%pChrg) Go To 201
               If (dbsc(iCnttp)%Frag.and.dbsc(jCnttp)%Frag) Go To 201
               ZB = dbsc(jCnttp)%Charge
               If (dbsc(jCnttp)%Frag) ZB = dbsc(jCnttp)%FragCharge
               If (ZB.eq.Zero) Go To 201
               ZAZB = ZA * ZB
               jCntMx = dbsc(jCnttp)%nCntr
               If (iCnttp.eq.jCnttp) jCntMx = iCnt
               Do jCnt = 1, jCntMx
*                 Introduce factor to ensure that contributions from
*                 A>B are the only to be accumulated.
                  Fact = One
                  If (iCnttp.eq.jCnttp.and.iCnt.eq.jCnt) Fact = Half
                  B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
*                 Find the DCR for the two centers
*
                  Call DCR(LmbdR,
     &                     dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,
     &                     dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                     iDCRR,nDCRR)
*
                  temp = Zero
                  Do iR = 0, nDCRR-1
                     RB(1) = DBLE(iPhase(1,iDCRR(iR)))*B(1)
                     RB(2) = DBLE(iPhase(2,iDCRR(iR)))*B(2)
                     RB(3) = DBLE(iPhase(3,iDCRR(iR)))*B(3)
*                    The index A=RB is illegal.
                     If (.Not.EQ(A,RB)) Then
                        r12 = Sqrt((A(1)-RB(1))**2 +
     &                             (A(2)-RB(2))**2 +
     &                             (A(3)-RB(3))**2 )
                        If (r12.lt.r12_min .and.
     &                      .NOT.Expert ) Then
                           Call WarningMessage(2,
     &                        ' The distance between two centers'
     &                      //' are found to be unphysically too'
     &                      //' short.;'
     &                      //' If you want to persist operate in'
     &                      //' expert mode.')
                           Call Abend()
                        End If
                        fab = One
                        If (dbsc(iCnttp)%ECP) Then
*--------------------------Add contribution from M1 operator
                           Do iM1xp=1, dbsc(iCnttp)%nM1
                             Gamma = dbsc(iCnttp)%M1xp(iM1xp)
                             CffM1 = dbsc(iCnttp)%M1cf(iM1xp)
                             fab = fab + CffM1 * Exp(-Gamma*r12**2)
                           End Do
*--------------------------Add contribution from M2 operator
                           Do iM2xp=1, dbsc(iCnttp)%nM2
                             Gamma = dbsc(iCnttp)%M2xp(iM2xp)
                             CffM2 = dbsc(iCnttp)%M2cf(iM2xp)
                             fab = fab + CffM2*r12*Exp(-Gamma*r12**2)
                           End Do
                        End If
                        If (dbsc(jCnttp)%ECP) Then
*--------------------------Add contribution from M1 operator
                           Do iM1xp=1, dbsc(jCnttp)%nM1
                             Gamma = dbsc(jCnttp)%M1xp(iM1xp)
                             CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
                             fab = fab + CffM1 * Exp(-Gamma*r12**2)
                           End Do
*--------------------------Add contribution from M2 operator
                           Do iM2xp=1, dbsc(jCnttp)%nM2
                             Gamma = dbsc(jCnttp)%M2xp(iM2xp)
                             CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
                             fab = fab + CffM2*r12*Exp(-Gamma*r12**2)
                           End Do
                        End If
*
                        temp = temp + fab/r12
                     Else
*---------------------------turn off checking if in expert mode, for
*wavefunction overlaps
                        if (.NOT.Expert) then
                        If (iCnttp.ne.jCnttp .or.
     &                      iCnt.ne.jCnt          ) Then
                           Call WarningMessage(2,
     &                                 'You have two charges on top '//
     &                                 'of each other!;'//
     &                                 'Correct the input!')
                           Call Quit_OnUserError()
                        End If
                        End If
                     End If
                  End Do
                  PotNuc = PotNuc +
     &                 (Fact*ZAZB*temp*DBLE(nIrrep))/DBLE(LmbdR)
*
                  jxyz = jxyz + 3
               End Do
 201           Continue
               ndc = ndc + dbsc(jCnttp)%nCntr
            End Do
         End Do
 101     Continue
         mdc = mdc + dbsc(iCnttp)%nCntr
      End Do
*
      If (Show) Then
         Write (6,*)
         Write (6,'(11X,A,F16.8,A)')
     &     ' Nuclear Potential Energy        ',PotNuc,' au'
         Write (6,*)
      End If
*
      If (Allocated(XF).and.(nOrd_XF.ge.0)) Then
*
*--------Add contibution for interaction external field and nuclear
*        charges. Here we will have charge-charge, and charge-dipole
*        inteaction.
*
         ZA = Zero
         DAx= Zero
         DAy= Zero
         DAz= Zero
         Qxx= Zero
         Qxy= Zero
         Qxz= Zero
         Qyy= Zero
         Qyz= Zero
         Qzz= Zero
*
         PNX=Zero
         iDum=0
         Do iFd = 1, nXF
            If (nOrd_XF.eq.0) Then
               ZA = XF(4,iFd)
               NoLoop = ZA.eq.Zero
            Else If (nOrd_XF.eq.1) Then
               ZA = XF(4,iFd)
               DAx= XF(5,iFd)
               DAy= XF(6,iFd)
               DAz= XF(7,iFd)
               NoLoop = ZA.eq.Zero  .and.
     &                  DAx.eq.Zero .and.
     &                  DAy.eq.Zero .and.
     &                  DAz.eq.Zero
            Else If (nOrd_XF.eq.2) Then
               ZA = XF(4,iFd)
               DAx= XF(5,iFd)
               DAy= XF(6,iFd)
               DAz= XF(7,iFd)
               Qxx= XF(8,iFd)
               Qxy= XF(9,iFd)
               Qxz= XF(10,iFd)
               Qyy= XF(11,iFd)
               Qyz= XF(12,iFd)
               Qzz= XF(13,iFd)
               NoLoop = ZA.eq.Zero  .and.
     &                  DAx.eq.Zero .and.
     &                  DAy.eq.Zero .and.
     &                  DAz.eq.Zero .and.
     &                  Qxx.eq.Zero .and.
     &                  Qxy.eq.Zero .and.
     &                  Qxz.eq.Zero .and.
     &                  Qyy.eq.Zero .and.
     &                  Qyz.eq.Zero .and.
     &                  Qzz.eq.Zero
            Else
               Call WarningMessage(2,'Option not implemented yet!')
               Call Quit_OnUserError()
            End If
            If (NoLoop) Go To 102
            A(1:3) = XF(1:3,iFd)
            iChxyz=iChAtm(A)
            Call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)
*
            ndc = 0
            Do jCnttp = 1, nCnttp
               ZB = dbsc(jCnttp)%Charge
               If (dbsc(jCnttp)%pChrg) Go To 202
               If (ZB.eq.Zero) Go To 202
               If (dbsc(jCnttp)%Frag) Go To 202
               ZAZB = ZA * ZB
               Do jCnt = 1, dbsc(jCnttp)%nCntr
                  B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
*                 Find the DCR for the two centers
*
                  Call DCR(LmbdR,iStb,nStb,
     &                     dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                     iDCRR,nDCRR)
*
                  temp0= Zero
                  temp1= Zero
                  temp2= Zero
                  Do iR = 0, nDCRR-1
                     RB(1) = DBLE(iPhase(1,iDCRR(iR)))*B(1)
                     RB(2) = DBLE(iPhase(2,iDCRR(iR)))*B(2)
                     RB(3) = DBLE(iPhase(3,iDCRR(iR)))*B(3)
*                    The index A=RB is illegal.
                     If (.Not.EQ(A,RB)) Then
                        ABx=A(1)-RB(1)
                        ABy=A(2)-RB(2)
                        ABz=A(3)-RB(3)
                        r12 = Sqrt(ABx**2 + ABy**2 + ABz**2)
*
                        fab=One
                        If (dbsc(jCnttp)%ECP) Then
*--------------------------Add contribution from M1 operator
                           Do iM1xp=1, dbsc(jCnttp)%nM1
                             Gamma = dbsc(jCnttp)%M1xp(iM1xp)
                             CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
                             fab = fab + CffM1 * Exp(-Gamma*r12**2)
                           End Do
*--------------------------Add contribution from M2 operator
                           Do iM2xp=1, dbsc(jCnttp)%nM2
                             Gamma = dbsc(jCnttp)%M2xp(iM2xp)
                             CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
                             fab = fab + CffM2*r12*Exp(-Gamma*r12**2)
                           End Do
                        End If
                        temp0=temp0+fab/r12
                        If (nOrd_XF.ge.1)
     &                     temp1=temp1-fab*(DAx*ABx
     &                                     +DAy*ABy
     &                                     +DAz*ABz)/r12**3
                        If (nOrd_XF.ge.2) then

                            temp2=temp2+fab*0.5D0*(3.0D0*(Qxx*ABx**2
     &                                     +2.0D0*Qxy*ABx*ABy
     &                                     +2.0D0*Qxz*ABx*ABz
     &                                     +Qyy*ABy**2
     &                                     +2.0D0*Qyz*ABy*ABz
     &                                     +Qzz*ABz**2 )/r12**5
     &                                   -One/r12**3*(Qxx+Qyy+Qzz))
                        EndIf

                    End If
                  End Do
                  PNX = PNX + ( ( ZAZB*temp0 + ZB*(temp1+temp2))
     &                * DBLE(nIrrep) ) / DBLE(LmbdR)
*
               End Do
 202           Continue
               ndc = ndc + dbsc(jCnttp)%nCntr
            End Do
 102        Continue
         End Do
*
         If (Show) Then
            Write (6,'(19X,A,F16.8,A)')
     &                 ' Nuclear-External Field Potential Energy ',
     &                    PNX,' au'
         End If
*
         PotNuc=PotNuc+PNX
*
*--------Add contibution for self interaction of the external field.
*        Here we will have charge-charge, charge-dipole, and dipole-
*        dipole inteaction. This term will only be computed but not
*        added to the acutual nuclear potential energy.

* LU:    in the case when the number of point charges is larger than
*        10^4, the algorith below is extremely slow, as it implies a
*        double loop over all field points (nXF). The resulting value
*        is stored in the RunFile (label='PC Self Energy'), but never
*        used again in the entire MOLCAS code.
*        As a first attempt to optimize this part of the code, we skip
*        the computation of the self interaction of the external field.

         if (nXF.gt.9999) go to 1254

         PXX=Zero

         DAx=Zero
         DAy=Zero
         DAz=Zero
         QAxx=Zero
         QAxy=Zero
         QAxz=Zero
         QAyy=Zero
         QAyz=Zero
         QAzz=Zero
         DBx=Zero
         DBy=Zero
         DBz=Zero
         QBxx=Zero
         QBxy=Zero
         QBxz=Zero
         QByy=Zero
         QByz=Zero
         QBzz=Zero

         iDum=0
         Do iFd = 1, nXF
            If (nOrd_XF.eq.0) Then
               ZA = XF(4,iFd)
               NoLoop = ZA.eq.Zero
            ElseIf (nOrd_XF.eq.1) Then
               ZA = XF(4,iFd)
               DAx= XF(5,iFd)
               DAy= XF(6,iFd)
               DAz= XF(7,iFd)
               NoLoop = ZA.eq.Zero .and. DAx.eq.Zero .and. DAy.eq.Zero
     &              .and. DAz.eq.Zero
            ElseIf (nOrd_XF.eq.2) Then
               ZA = XF(4,iFd)
               DAx= XF(5,iFd)
               DAy= XF(6,iFd)
               DAz= XF(7,iFd)
               QAxx=XF(8,iFd)
               QAxy=XF(9,iFd)
               QAxz=XF(10,iFd)
               QAyy=XF(11,iFd)
               QAyz=XF(12,iFd)
               QAzz=XF(13,iFd)
               NoLoop = ZA.eq.Zero .and. DAx.eq.Zero .and. DAy.eq.Zero
     &              .and. DAz.eq.Zero .and.
     &              QAxx.eq.Zero .and.
     &              QAxy.eq.Zero .and.
     &              QAxz.eq.Zero .and.
     &              QAyy.eq.Zero .and.
     &              QAyz.eq.Zero .and.
     &              QAzz.eq.Zero
            Else
               Call WarningMessage(2,'Option not implemented yet!')
               Call Quit_OnUserError()
            End If


            If (NoLoop) Go To 103
            A(1:3) = XF(1:3,iFd)
            iChxyz=iChAtm(A)
            Call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)
*
            Do jFd = 1, iFd
               If (nOrd_XF.eq.0) Then
                  ZB = XF(4,jFd)
                  NoLoop = ZB.eq.Zero
               ElseIf (nOrd_XF.eq.1) Then
                  ZB = XF(4,jFd)
                  DBx= XF(5,jFd)
                  DBy= XF(6,jFd)
                  DBz= XF(7,jFd)
                  NoLoop=ZB.eq.Zero.and.DBx.eq.Zero .and. DBy.eq.Zero
     &                 .and. DBz.eq.Zero
               ElseIf (nOrd_XF.eq.2) Then
                  ZB = XF(4,jFd)
                  DBx= XF(5,jFd)
                  DBy= XF(6,jFd)
                  DBz= XF(7,jFd)
                  QBxx=XF(8,jFd)
                  QBxy=XF(9,jFd)
                  QBxz=XF(10,jFd)
                  QByy=XF(11,jFd)
                  QByz=XF(12,jFd)
                  QBzz=XF(13,jFd)
                  NoLoop=ZB.eq.Zero.and.DBx.eq.Zero .and. DBy.eq.Zero
     &                 .and. DBz.eq.Zero .and.
     &                 QBxx.eq.Zero .and.
     &                 QBxy.eq.Zero .and.
     &                 QBxz.eq.Zero .and.
     &                 QByy.eq.Zero .and.
     &                 QByz.eq.Zero .and.
     &                 QBzz.eq.Zero
               Else
                  Call WarningMessage(2,'Option not implemented yet!')
                  Call Quit_OnUserError()
               End If

               If (NoLoop) Go To 203
               ZAZB = ZA * ZB
               B(1:3) = XF(1:3,jFd)
               iChxyz=iChAtm(B)
               Call Stblz(iChxyz,mStb,jStb,iDum,jCoSet)
*              Introduce factor to ensure that contributions from
*              A>B are the only to be accumulated.
               Fact = One
               If (iFd.eq.jFd) Fact = Half
*
*              Find the DCR for the two centers
*
               Call DCR(LmbdR,iStb,nStb,jStb,mStb,iDCRR,nDCRR)
*
               temp = Zero
               Do iR = 0, nDCRR-1
                  RB(1) = DBLE(iPhase(1,iDCRR(iR)))*B(1)
                  RB(2) = DBLE(iPhase(2,iDCRR(iR)))*B(2)
                  RB(3) = DBLE(iPhase(3,iDCRR(iR)))*B(3)
                  DRBx  = DBLE(iPhase(1,iDCRR(iR)))*DBx
                  DRBy  = DBLE(iPhase(2,iDCRR(iR)))*DBy
                  DRBz  = DBLE(iPhase(3,iDCRR(iR)))*DBz
                  QRBxx = QBxx
                  QRByy = QByy
                  QRBzz = QBzz
                  QRBxy = DBLE(iPhase(1,iDCRR(iR))
     &                  *iPhase(2,iDCRR(iR)))*QBxy
                  QRBxz = DBLE(iPhase(1,iDCRR(iR))
     &                  *iPhase(3,iDCRR(iR)))*QBxz
                  QRByz = DBLE(iPhase(2,iDCRR(iR))
     &                  *iPhase(3,iDCRR(iR)))*QByz


*                 The index A=RB is illegal.
                  If (.Not.EQ(A,RB)) Then
                     x=A(1)-RB(1)
                     y=A(2)-RB(2)
                     z=A(3)-RB(3)
                     r12 = Sqrt(x**2 + y**2 + z**2 )

                    eZZ=ZAZB*One/r12
                    eDZ=ZB*(-(DAx *x+DAy *y+DAz *z))/r12**3
                    eZD=ZA*(DRBx*x+DRBy*y+DRBz*z)/r12**3
                    eDD=(DAx*DRBx+DAy*DRBy+DAz*DRBz)/r12**3
     &                   -Three*(DAx* x+DAy* y+DAz *z)
     &                   *(DRBx*x+DRBy*y+DRBz*z)/r12**5

                    If(nOrd_XF.lt.2) Then
                       eTOT = eZZ+eZD+eDZ+eDD
                    Else

                    QAsum=(QAxx*x*x+QAyy*y*y+QAzz*z*z+2.0D0*
     &                   (QAxy*x*y+QAxz*x*z+QAyz*y*z))
                    QBsum=(QRBxx*x*x+QRByy*y*y+QRBzz*z*z+2.0D0*
     &                   (QRBxy*x*y+QRBxz*x*z+QRByz*y*z))

*                   Q-Z
                    eZQ=0.5D0*3.0D0/r12**5*ZA*QBsum
     &                   -0.5D0/r12**3*ZA*(QRBxx+QRByy+QRBzz)
                    eQZ=0.5D0*3.0D0/r12**5*ZB*QAsum
     &                   -0.5D0/r12**3*ZB*(QAxx+QAyy+QAzz)

*                   Q-D
                    eDQ=0.5D0*(-15.0D0/r12**7*
     & (DAx*x+DAy*y+DAz*z)*QBsum
     &                   +3.0D0/r12**5*
     &   (3.0D0*DAx*QRBxx*x
     &   +1.0D0*DAy*QRBxx*y
     &   +1.0D0*DAz*QRBxx*z
     &   +2.0D0*DAx*QRBxy*y
     &   +2.0D0*DAy*QRBxy*x
     &   +2.0D0*DAx*QRBxz*z
     &   +2.0D0*DAz*QRBxz*x
     &   +1.0D0*DAx*QRByy*x
     &   +3.0D0*DAy*QRByy*y
     &   +1.0D0*DAz*QRByy*z
     &   +2.0D0*DAy*QRByz*z
     &   +2.0D0*DAz*QRByz*y
     &   +1.0D0*DAx*QRBzz*x
     &   +1.0D0*DAy*QRBzz*y
     &   +3.0D0*DAz*QRBzz*z))

                    eQD=-0.5D0*(-15.0D0/r12**7*
     & (DRBx*x+DRBy*y+DRBz*z)*QAsum
     &                   +3.0D0/r12**5*
     &   (3.0D0*DRBx*QAxx*x
     &   +1.0D0*DRBy*QAxx*y
     &   +1.0D0*DRBz*QAxx*z
     &   +2.0D0*DRBx*QAxy*y
     &   +2.0D0*DRBy*QAxy*x
     &   +2.0D0*DRBx*QAxz*z
     &   +2.0D0*DRBz*QAxz*x
     &   +1.0D0*DRBx*QAyy*x
     &   +3.0D0*DRBy*QAyy*y
     &   +1.0D0*DRBz*QAyy*z
     &   +2.0D0*DRBy*QAyz*z
     &   +2.0D0*DRBz*QAyz*y
     &   +1.0D0*DRBx*QAzz*x
     &   +1.0D0*DRBy*QAzz*y
     &   +3.0D0*DRBz*QAzz*z))

*                   Q-Q (divided into two lines because of Fortran lim)
                    eQQ=0.25D0*(105.0D0/r12**9 * QAsum*QBsum
     &                   -15.0D0/r12**7*
     &  (6.0D0*QAxx*QRBxx*x*x+6.0D0*QAxx*QRBxy*x*y+6.0D0*QAxx*QRBxz*x*z
     &  +1.0D0*QAxx*QRByy*x*x+1.0D0*QAxx*QRByy*y*y+2.0D0*QAxx*QRByz*y*z
     &  +1.0D0*QAxx*QRBzz*x*x+1.0D0*QAxx*QRBzz*z*z+6.0D0*QAxy*QRBxx*x*y
     &  +4.0D0*QAxy*QRBxy*x*x+4.0D0*QAxy*QRBxy*y*y+4.0D0*QAxy*QRBxz*y*z
     &  +6.0D0*QAxy*QRByy*x*y+4.0D0*QAxy*QRByz*x*z+2.0D0*QAxy*QRBzz*x*y
     &  +6.0D0*QAxz*QRBxx*x*z+4.0D0*QAxz*QRBxy*y*z+4.0D0*QAxz*QRBxz*x*x
     &  +4.0D0*QAxz*QRBxz*z*z+2.0D0*QAxz*QRByy*x*z+4.0D0*QAxz*QRByz*x*y
     &  +6.0D0*QAxz*QRBzz*x*z+1.0D0*QAyy*QRBxx*x*x+1.0D0*QAyy*QRBxx*y*y
     &  +6.0D0*QAyy*QRBxy*x*y+2.0D0*QAyy*QRBxz*x*z+6.0D0*QAyy*QRByy*y*y
     &  +6.0D0*QAyy*QRByz*y*z+1.0D0*QAyy*QRBzz*y*y+1.0D0*QAyy*QRBzz*z*z
     &  +2.0D0*QAyz*QRBxx*y*z+4.0D0*QAyz*QRBxy*x*z+4.0D0*QAyz*QRBxz*x*y
     &  +6.0D0*QAyz*QRByy*y*z+4.0D0*QAyz*QRByz*y*y+4.0D0*QAyz*QRByz*z*z
     &  +6.0D0*QAyz*QRBzz*y*z+1.0D0*QAzz*QRBxx*x*x+1.0D0*QAzz*QRBxx*z*z
     &  +2.0D0*QAzz*QRBxy*x*y+6.0D0*QAzz*QRBxz*x*z+1.0D0*QAzz*QRByy*y*y
     & +1.0D0*QAzz*QRByy*z*z+6.0D0*QAzz*QRByz*y*z+6.0D0*QAzz*QRBzz*z*z))

                    eQQ=eQQ+0.25D0*3.0D0/r12**5*
     &   (3.0D0*QAxx*QRBxx
     &   +1.0D0*QAxx*QRByy
     &   +1.0D0*QAxx*QRBzz
     &   +4.0D0*QAxy*QRBxy
     &   +4.0D0*QAxz*QRBxz
     &   +1.0D0*QAyy*QRBxx
     &   +3.0D0*QAyy*QRByy
     &   +1.0D0*QAyy*QRBzz
     &   +4.0D0*QAyz*QRByz
     &   +1.0D0*QAzz*QRBxx
     &   +1.0D0*QAzz*QRByy
     &   +3.0D0*QAzz*QRBzz)

                    eTOT = eZZ+eZD+eDZ+eDD+eZQ+eQZ+eDQ+eQD+eQQ
c                    write(*,*)'eZZ',eZZ
c                    write(*,*)'eDZ',eDZ
c                    write(*,*)'eZD',eZD
c                    write(*,*)'eDD',eDD
c                    write(*,*)'eZQ',eZQ
c                    write(*,*)'eQZ',eQZ
c                    write(*,*)'eDQ',eDQ
c                    write(*,*)'eQD',eQD
c                    write(*,*)'eQQ',eQQ
c                    write(*,*)'eTOT',eTOT

                    End If     ! if quadrupoles are present

                    temp=temp+eTOT

                  End If
               End Do
c               PXX = PXX + ( Fact * ( ZAZB*temp0 + ZB*temp1
c     &             + ZA*temp2 + temp3)
c     &             * DBLE(nIrrep) ) / DBLE(LmbdR)
               PXX = PXX + ( Fact * temp
     &             * DBLE(nIrrep) ) / DBLE(LmbdR)

*
 203           Continue
            End Do
 103        Continue
         End Do
*
         If (Show) Then
            Write (6,'(19X,A,F16.8,A)')
     &                 ' External Field Potential Energy         ',
     &                    PXX,' au '
         End If
         Call Put_dScalar('PC Self Energy',PXX)
*
*        PotNuc=PotNuc+PXX
*

         If (Show) Then
            Write (6,*)
            Write (6,*)
            Write (6,'(11X,A,F16.8,A)')
     &     ' Total Nuclear Potential Energy        ',PotNuc,' au'
            Write (6,*)
         End If

1254  Continue
      End If
*
      Call Put_dScalar('PotNuc',PotNuc)
      If (isstructure().eq.1) then
         Call Add_Info('PotNuc',[PotNuc],1,6)
      Else
         Call Add_Info('PotNuc',[PotNuc],1,12)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine getmo_cvb(cmo,ic)

use casvb_global, only: nbas_mo
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: cmo(*)
integer(kind=iwp), intent(in) :: ic
real(kind=wp), allocatable :: cmo2(:,:)

call mma_allocate(cmo2,nbas_mo,nbas_mo,label='cmo2')
if (ic <= 1) then
  call getmo2_cvb(cmo,cmo2,ic)
else
  call getmo2_cvb(cmo2,cmo,ic)
end if
call mma_deallocate(cmo2)

return

end subroutine getmo_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
!                                                                      *
! 2023, Matthew R. Hennefarth - modified lhrot -> si_pdft              *
! 2024, Matthew R. Henenfarth - upgraded to F90                        *
!***********************************************************************

subroutine MSPDFTGrad_Misc(si_pdft,states)
! This subroutine does miscellaneous things needed
! in MS-PDFT gradient calculation.

use mspdftgrad, only: D1aoMS, D1SAOMS, DIDA, F1MS, F2MS, FocMS, FxyMS, P2MOT
use rasscf_global, only: lroots, NACPR2, nTot4
use general_data, only: ispin, ntot1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: si_pdft(lroots,lroots)
integer(kind=iwp), intent(in) :: states(2)
real(kind=wp), allocatable :: r_active_dm1(:), r_casdm2(:), r_fock_occ(:), r_Fxy(:), u_rlx_sq(:)
! r_* : rotated (ie, in final MS-PDFT) eigenbasis quantities (i think...)

! Functions added by Paul Calio for MECI Opt *****
! Original calls are in slapaf_util/start_alasaks.f

call put_iArray('NACstatesOpt',states,2)
! End of stuff added by Paul

call Put_DArray('MS_FINAL_ROT',si_pdft,lRoots**2)
call Put_DArray('F1_PDFT',F1MS,nTot1*lRoots)
call Put_DArray('F2_PDFT',F2MS,NACPR2*lRoots)
call Put_DArray('D1AO_MS',D1AOMS,nTot1*lRoots)
if (ispin /= 1) call Put_DArray('D1SAO_MS',D1SAOMS,nTot1*lRoots)

! Takes the rlxroot column of the rotation matrix and squares it
call mma_allocate(u_rlx_sq,lroots,label='u_rlx_sq')
u_rlx_sq(:) = si_pdft(:,states(1))*si_pdft(:,states(2))

! Then add the matrix for each state to the ground state
! add put the ground state one in the runfile. Do not
! forget to multiply the (R_IK)^2, where K is "jRoot" below

! DIDA(:,lRoots+1) is currently DI
call Put_DArray('MSPDFTD5',DIDA(:,lRoots+1),nTot1)

call mma_allocate(r_fock_occ,ntot1,label='r_fock_occ')
call dgemv_('n',ntot1,lroots,One,FocMS,ntot1,u_rlx_sq,1,Zero,r_fock_occ,1)
call Put_dArray('FockOcc',r_fock_occ,ntot1)
call mma_deallocate(r_fock_occ)

! DIDA is currently DA over intermediate states
! DIDA for prepp
call mma_allocate(r_active_dm1,ntot1,label='r_active_dm1')
call dgemv_('n',ntot1,lroots,One,DIDA(:,:lroots),ntot1,-u_rlx_sq,1,Zero,r_active_dm1,1)
call Put_DArray('MSPDFTD6',r_active_dm1,nTot1)
call mma_deallocate(r_active_dm1)

! FT99 for bk
call mma_allocate(r_Fxy,ntot4,label='r_fxy')
call dgemv_('n',ntot4,lroots,One,FxyMS,ntot4,u_rlx_sq,1,Zero,r_Fxy,1)
call Put_DArray('FxyMS',r_Fxy,nTot4)
call mma_deallocate(r_Fxy)

! P2MOt for active 2RDM
call mma_allocate(r_casdm2,nacpr2,label='r_casdm2')
call dgemv_('n',nacpr2,lroots,One,P2MOt,nacpr2,u_rlx_sq,1,Zero,r_casdm2,1)
call Put_dArray('P2MOt',r_casdm2,NACPR2)
call mma_deallocate(r_casdm2)

call mma_deallocate(u_rlx_sq)

end subroutine MSPDFTGrad_Misc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003-2010, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine Cho_Drv(iReturn)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: driver for the Cholesky decomposition of two-electron
C              integrals. On entry, the integral program must have been
C              initialized and the relevant index info (#irreps, basis
C              functions, shells, etc.) must have been set up.
C
      Implicit None
      Integer iReturn
#include "cholesky.fh"

      iReturn=0
      If (Cho_DecAlg .eq. 5) Then ! parallel two-step algorithm
         Call Cho_Drv_ParTwoStep(iReturn)
      Else
         Call Cho_Drv_Internal(iReturn)
      End If

      End
C
C=======================================================================
C
      SUBROUTINE CHO_DRV_Internal(IRETURN)
C
C     Thomas Bondo Pedersen, 2003-2010.
C
C     Purpose: driver for the Cholesky decomposition of two-electron
C              integrals. On entry, the integral program must have been
C              initialized and the relevant index info (#irreps, basis
C              functions, shells, etc.) must have been set up.
C
C     NOTE: this is the "old" version prior to the parallel two-step
C           algorithm. It is still used for the "old" algorithms.
C
C     Return codes, IRETURN:
C
C        0 -- successful execution
C        1 -- decomposition failed
C        2 -- memory has been out of bounds
C
      USE Para_Info, ONLY: nProcs, Is_Real_Par
      use ChoSwp, only: Diag, Diag_G, Diag_Hidden, Diag_G_Hidden
      use ChoSubScr, only: Cho_SScreen
#include "implicit.fh"
#include "cholesky.fh"
#include "choprint.fh"
#include "stdalloc.fh"

      LOGICAL, PARAMETER:: LOCDBG = .FALSE.
      LOGICAL, PARAMETER:: SKIP_PRESCREEN=.FALSE., ALLOC_BKM=.TRUE.

      LOGICAL LCONV

      CHARACTER(LEN=8), PARAMETER:: SECNAM = 'CHO_DRV_'

      Real*8, PARAMETER:: DUMTST = 0.123456789D0, DUMTOL = 1.0D-15
      Real*8, Allocatable:: Check(:)
      Real*8, Allocatable:: KWRK(:)
      Integer, Allocatable:: KIRS1F(:)

#if defined (_DEBUGPRINT_)
      CALL CHO_PRTMAXMEM('CHO_DRV_ [ENTER]')
#endif

C     Start overall timing.
C     ---------------------

      IF (IPRINT .GE. INF_TIMING) CALL CHO_TIMER(TCPU0,TWALL0)

C     Set return code.
C     ----------------

      IRETURN = 0

C     Make a dummy allocation.
C     ------------------------

      Call mma_allocate(Check,1,Label='Check')
      Check(1) = DUMTST

C     INITIALIZATION.
C     ===============

      ISEC = 1
      IF (IPRINT .GE. INF_TIMING) THEN
         CALL CHO_TIMER(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
      END IF
      CALL CHO_INIT(SKIP_PRESCREEN,ALLOC_BKM)
      CALL CHO_GASYNC()
      IF (IPRINT .GE. INF_TIMING) THEN
         CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
         CALL CHO_PRTTIM('Cholesky initialization',
     &                   TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                   TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                   1)
      END IF
#if defined (_DEBUGPRINT_)
      CALL CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_INIT]')
      IRC = 0
      CALL CHO_DUMP(IRC,LUPRI)
      IF (IRC .NE. 0) THEN
         WRITE(LUPRI,*) SECNAM,': CHO_DUMP returned ',IRC
         CALL CHO_QUIT('[1] Error detected in CHO_DUMP',103)
      END IF
#endif

C     GET DIAGONAL.
C     =============

      ISEC = 2
      IF (IPRINT .GE. INF_TIMING) THEN
         CALL CHO_TIMER(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
         WRITE(LUPRI,'(/,A)')
     &   '***** Starting Cholesky diagonal setup *****'
         CALL CHO_FLUSH(LUPRI)
      END IF
      CALL CHO_GETDIAG(LCONV)
      CALL CHO_GASYNC()
      IF (IPRINT .GE. INF_TIMING) THEN
         CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
         CALL CHO_PRTTIM('Cholesky diagonal setup',
     &                   TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                   TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                   1)
      END IF
#if defined (_DEBUGPRINT_)
      CALL CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_GETDIAG]')
      IRC = 0
      CALL CHO_DUMP(IRC,LUPRI)
      IF (IRC .NE. 0) THEN
         WRITE(LUPRI,*) SECNAM,': CHO_DUMP returned ',IRC
         CALL CHO_QUIT('[2] Error detected in CHO_DUMP',103)
      END IF
      CALL CHO_PRINTLB() ! print vector dimension on each node
#endif

C     DECOMPOSITION.
C     ==============

      ISEC = 3
      IF (LCONV) THEN
         IF (RSTCHO) THEN
            WRITE(LUPRI,'(//,10X,A,A,A,//)')
     &      '***** ',SECNAM,': restarted calculation converged. *****'
            CALL FZERO(TIMSEC(1,ISEC),4)
         ELSE
            WRITE(LUPRI,'(A,A)')
     &      SECNAM,': logical error: converged but not restart?!?!'
            CALL CHO_QUIT('Error in '//SECNAM,103)
         END IF
      ELSE
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
            WRITE(LUPRI,'(/,A)')
     &      '***** Starting Cholesky decomposition *****'
            CALL CHO_FLUSH(LUPRI)
         END IF
         CALL CHO_P_SETADDR()

         IF (CHO_SSCREEN) CALL CHO_SUBSCR_INIT()

         CALL CHO_DECDRV(Diag)
         CALL CHO_GASYNC()
         IF (CHO_DECALG.EQ.2) THEN
            ! generate vectors from map
            CALL CHO_P_OPENVR(2) ! close files
            CALL CHO_P_OPENVR(1) ! re-open (problem on dec-alpha)
            IF (IPRINT .GE. INF_TIMING) THEN
               CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
               CALL CHO_PRTTIM('Cholesky map generation',
     &                         TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                         TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                         2)
            END IF
            IRC = 0
            CALL CHO_X_GENVEC(IRC,Diag)
            CALL CHO_GASYNC()
            IF (IRC .NE. 0) THEN
               WRITE(LUPRI,'(A,A)')
     &         SECNAM,': decomposition failed!'
               WRITE(LUPRI,'(A,A,I9)')
     &         SECNAM,': CHO_X_GENVEC returned ',IRC
               IRETURN = 1
               CALL CHO_QUIT('Error',104)
            END IF
            IF (IPRINT .GE. INF_TIMING) THEN
               CALL CHO_TIMER(TC,TW)
               CALL CHO_PRTTIM('Cholesky vector generation',
     &                         TC,TIMSEC(2,ISEC),
     &                         TW,TIMSEC(4,ISEC),
     &                         2)
            END IF
         END IF
         IF (CHO_SSCREEN) THEN
            CALL CHO_SUBSCR_FINAL()
         END IF
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
            CALL CHO_PRTTIM('Cholesky decomposition',
     &                      TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                      TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                      1)
         END IF
      END IF
#if defined (_DEBUGPRINT_)
      CALL CHO_PRTMAXMEM('CHO_DRV_ [AFTER DECOMPOSITION]')
#endif

C     CHECK DIAGONAL.
C     ===============

      ISEC = 4
      IF (LCONV) THEN
         CALL FZERO(TIMSEC(1,ISEC),4)
      ELSE
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
            WRITE(LUPRI,'(/,A)')
     &      '***** Starting Cholesky diagonal check *****'
            CALL CHO_FLUSH(LUPRI)
         END IF
         Call mma_maxDBLE(LWRK)
         Call mma_allocate(KWRK,LWRK,Label='KWRK')
         CALL CHO_RESTART(Diag,KWRK,LWRK,.TRUE.,LCONV)
         CALL CHO_GASYNC()
         Call mma_deallocate(KWRK)
         IF (.NOT. LCONV) THEN
            WRITE(LUPRI,'(A,A)')
     &      SECNAM,': Decomposition failed!'
            IRETURN = 1
            CALL CHO_QUIT('Decomposition failed!',104)
         END IF
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
            CALL CHO_PRTTIM('Cholesky diagonal check',
     &                      TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                      TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                      1)
         END IF
#if defined (_DEBUGPRINT_)
         CALL CHO_PRTMAXMEM('CHO_DRV_ [AFTER DIAGONAL CHECK]')
#endif
      END IF

C     PARALLEL RUNS: WRITE GLOBAL DIAGONAL TO DISK.
C     =============================================

      CALL CHO_P_WRDIAG()

C     CHECK INTEGRALS.
C     ================

      ISEC = 5
      IF (CHO_INTCHK) THEN
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
            WRITE(LUPRI,'(/,A)')
     &      '***** Starting Cholesky integral check *****'
            CALL CHO_FLUSH(LUPRI)
         END IF
         CALL CHO_DBGINT()
         CALL CHO_GASYNC()
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
            CALL CHO_PRTTIM('Cholesky integral check',
     &                      TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                      TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                      1)
         END IF
#if defined (_DEBUGPRINT_)
         CALL CHO_PRTMAXMEM('CHO_DRV_ [AFTER INTEGRAL CHECK]')
#endif
      ELSE
         CALL FZERO(TIMSEC(1,ISEC),4)
      END IF

C     REORDER VECTORS.
C     ================

      ISEC = 6
      IF (CHO_REORD) THEN
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
            WRITE(LUPRI,'(/,A)')
     &      '***** Starting vector reordering *****'
            CALL CHO_FLUSH(LUPRI)
         END IF
         LIRS1F = NNBSTRT(1)*3
         Call mma_allocate(KIRS1F,LIRS1F,Label='KIRS1F')
         Call mma_maxDBLE(LWRK)
         Call mma_allocate(KWRK,LWRK,Label='KWRK')
         CALL CHO_REOVEC(KIRS1F,3,NNBSTRT(1),KWRK,LWRK)
         CALL CHO_GASYNC()
         Call mma_deallocate(KWRK)
         Call mma_deallocate(KIRS1F)
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
            CALL CHO_PRTTIM('Vector reordering',
     &                      TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                      TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                      1)
         END IF
#if defined (_DEBUGPRINT_)
         CALL CHO_PRTMAXMEM('CHO_DRV_ [AFTER VECTOR REORDERING]')
#endif
      ELSE
         CALL FZERO(TIMSEC(1,ISEC),4)
      END IF

C     FAKE PARALLEL: DISTRIBUTE VECTORS.
C     Note: after this section, InfVec(*,3,*) is changed
C     => vector disk addresses are screwed up!!
C     ==================================================

      ISEC = 7
      IF (CHO_FAKE_PAR .AND. NPROCS.GT.1 .AND. Is_Real_Par()) THEN
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
            WRITE(LUPRI,'(/,A)')
     &      '***** Starting vector distribution *****'
            CALL CHO_FLUSH(LUPRI)
         END IF
         CALL CHO_PFAKE_VDIST()
         CALL CHO_P_WRRSTC(XNPASS)
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
            CALL CHO_PRTTIM('Vector distribution',
     &                      TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                      TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                      1)
         END IF
#if defined (_DEBUGPRINT_)
         CALL CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_PFAKE_VDIST]')
#endif
      ELSE
         CALL FZERO(TIMSEC(1,ISEC),4)
      END IF

C     FINALIZATIONS.
C     ==============

      ISEC = 8
      IF (IPRINT .GE. INF_TIMING) THEN
         CALL CHO_TIMER(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
         WRITE(LUPRI,'(/,A)')
     &   '***** Starting Cholesky finalization *****'
         CALL CHO_FLUSH(LUPRI)
      END IF
      CALL CHO_TRCIDL_FINAL()
      CALL CHO_FINAL(.True.)
      CALL CHO_GASYNC()
      IF (IPRINT .GE. INF_TIMING) THEN
         CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
         CALL CHO_PRTTIM('Cholesky finalization',
     &                   TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                   TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                   1)
      END IF
#if defined (_DEBUGPRINT_)
      CALL CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_FINAL]')
#endif

C     STATISTICS.
C     ===========

      IF (IPRINT .GE. 1) THEN
         ISEC = 9
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
            WRITE(LUPRI,'(/,A)')
     &      '***** Starting Cholesky statistics *****'
            CALL CHO_FLUSH(LUPRI)
         END IF
         CALL CHO_P_STAT()
         CALL CHO_GASYNC()
         IF (IPRINT .GE. INF_TIMING) THEN
            CALL CHO_TIMER(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
            CALL CHO_PRTTIM('Cholesky statistics',
     &                      TIMSEC(2,ISEC),TIMSEC(1,ISEC),
     &                      TIMSEC(4,ISEC),TIMSEC(3,ISEC),
     &                      1)
         END IF
      END IF
#if defined (_DEBUGPRINT_)
      CALL CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_STAT]')
#endif

C     Close vector and reduced storage files as well as restart files.
C     Deallocate all memory and test bound.
C     Print total timing.
C     ----------------------------------------------------------------

      CALL CHO_P_OPENVR(2)

      TST = DUMTST - Check(1)
      IF (ABS(TST) .GT. DUMTOL) THEN
         WRITE(LUPRI,*) SECNAM,': memory has been out of bounds!!!'
         CALL CHO_FLUSH(LUPRI)
         IRETURN = 2
      END IF

      If (Allocated(Diag_Hidden)) Call mma_deallocate(Diag_Hidden)
      If (Allocated(Diag_G_Hidden)) Call mma_deallocate(Diag_G_Hidden)
      DIag   => Null()
      Diag_G => Null()
      Call mma_deallocate(Check)

      IF (IPRINT .GE. INF_TIMING) THEN
         CALL CHO_TIMER(TCPU1,TWALL1)
         CALL CHO_PRTTIM('Cholesky procedure',TCPU1,TCPU0,
     &                   TWALL1,TWALL0,1)
      END IF

#if defined (_DEBUGPRINT_)
      CALL CHO_PRTMAXMEM('CHO_DRV_ [EXIT]')
#endif

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines:
c
c     t3grc0
c     minusa
c     setb
c     stz
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
       subroutine cct3_t3grc0 (nind,typ,typp,typq,typr,typs,stot,
     & poss0,posst,mapd,mapi)
c
c     nind   - number of indexes (I)
c     typ    - typ of mediate (I)
c     typp   - typ of index p (I)
c     typq   - typ of index q (I)
c     typr   - typ of index r (I)
c     typs   - typ of index s (I)
c     stot   - overall symetry of the mediate (I)
c     poss0  - initil possition of mediate (I)
c     posst  - final possition of the mediate (O)
c     mapd   - direct map of the mediate (O)
c     mapi   - inverse map of the mediate (O)
c
c     this routine defines mapd and mapi for given intermediat
c     it can done exactly the same maps like grc0 in CCSD
c     plus additional types of mediates are introduced:
c     type    meaning
c     5     p>q>r,s ; also p>q>r
c     6     p,q>r>s
c     7     p>=q,r,s ; also p>=q,r; p>=q
c     8          p,q>=r,s ; also p,q>=s
c     9     p,q,q>=s
c     10     p>=q,r>=s
c     11     p>=q>=r,s ; also p>=q>=r
c     12     p,q>=r>=s
c
c     currently, these new types are implemented only for nind=3
c
c     !N.B. (this routine cannot run with +OP2)
c     N.B. this routine do not test stupidities
c
c
       integer nind,typ,typp,typq,typr,typs,stot,poss0,posst
c
#include "t31.fh"
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer sp,sq,sr,ss,spq,spqr
       integer nsymq,nsymr
       integer poss,i,nhelp1,nhelp2,nhelp3,nhelp4
       integer rsk1,rsk2

c     To fix some compiler warnings

      ss=0
      poss=0
      rsk1=0
      rsk2=0
      i=0
c
c     vanishing mapi files
c
       do nhelp1=1,nsym
       do nhelp2=1,nsym
       do nhelp3=1,nsym
       mapi(nhelp3,nhelp2,nhelp1)=0
       end do
       end do
       end do
c
       if (nind.eq.1) then
c
c     matrix A(p)
c
       i=1
       poss=poss0
       sp=mmul(stot,1)
c
       nhelp1=dimm(typp,sp)
c
c     def mapi
       mapi(1,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       mapd(i,2)=nhelp1
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=0
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
       else if (nind.eq.2) then
c
c     matrix A(p,q)
c
       i=1
       poss=poss0
c
       do 100 sp=1,nsym
c
       sq=mmul(stot,sp)
       if ((typ.eq.1).and.(sp.lt.sq)) then
c     Meggie out
       goto 100
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
c
c     def mapi
       mapi(sp,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2
       end if
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 100    continue
c
       else if (nind.eq.3) then
c
c     matrix A(p,q,r)
c
c     def reucion sumations keys : rsk1 for pq, rsk2 for qr
c
       if (typ.eq.0) then
       rsk1=0
       rsk2=0
       else if (typ.eq.1) then
       rsk1=1
       rsk2=0
       else if (typ.eq.2) then
       rsk1=0
       rsk2=1
       else if (typ.eq.5) then
       rsk1=1
       rsk2=1
       else if (typ.eq.7) then
       rsk1=1
       rsk2=0
       else if (typ.eq.8) then
       rsk1=0
       rsk2=1
       else if (typ.eq.11) then
       rsk1=1
       rsk2=1
       end if
c
       i=1
       poss=poss0
c
       do 200 sp=1,nsym
       if (rsk1.eq.1) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 201 sq=1,nsymq
       spq=mmul(sp,sq)
c
       sr=mmul(stot,spq)
       if ((rsk2.eq.1).and.(sq.lt.sr)) then
c     Meggie out
       goto 201
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
c
c     def mapi
       mapi(sp,sq,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)*nhelp3/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2-1)/2
       else if (typ.eq.5) then
       if (sp.eq.sr) then
       mapd(i,2)=nhelp1*(nhelp1-1)*(nhelp1-2)/6
       else if (sp.eq.sq) then
       mapd(i,2)=nhelp1*(nhelp1-1)*nhelp3/2
       else if (sq.eq.sr) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3
       end if
       else if ((typ.eq.7).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1+1)*nhelp3/2
       else if ((typ.eq.8).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2+1)/2
       else if (typ.eq.11) then
       if (sp.eq.ss) then
       mapd(i,2)=nhelp1*(nhelp1+1)*(nhelp1+2)/6
       else if (sp.eq.sq) then
       mapd(i,2)=nhelp1*(nhelp1+1)*nhelp3/2
       else if (sq.eq.sr) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2+1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3
       end if
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3
       end if
c
c     def sym p,q,r
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 201    continue
 200    continue
c
       else if (nind.eq.4) then
c
c     matrix A(p,q,r,s)
c
       i=1
       poss=poss0
c
       do 300 sp=1,nsym
       if ((typ.eq.1).or.(typ.eq.4)) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 301 sq=1,nsymq
       spq=mmul(sp,sq)
       if (typ.eq.2) then
       nsymr=sq
       else
       nsymr=nsym
       end if
c
       do 302 sr=1,nsymr
       spqr=mmul(spq,sr)
c
       ss=mmul(stot,spqr)
       if (((typ.eq.3).or.(typ.eq.4)).and.(sr.lt.ss)) then
c     Meggie out
       goto 302
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
       nhelp4=dimm(typs,ss)
c
c     def mapi
       mapi(sp,sq,sr)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp3-1)*nhelp4/2
       else if ((typ.eq.3).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else if (typ.eq.4) then
       if ((sp.eq.sq).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*(nhelp4-1)/4
       else if (sp.eq.sq) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if (sr.eq.ss) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
c
c     def sym p,q,r,s
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=ss
c
       poss=poss+mapd(i,2)
       i=i+1
c
 302    continue
 301    continue
 300    continue
c
       end if

c
       posst=poss
c
c     definition of other coll
c
       mapd(0,1)=typp
       mapd(0,2)=typq
       mapd(0,3)=typr
       mapd(0,4)=typs
       mapd(0,5)=i-1
       mapd(0,6)=typ
c
       return
       end
c
c     -----------------------------
c
       subroutine minusa (wrk,wrksize,
     & mapda,factor)
c
c     this routine do
c     A = factor . A
c
c     mapda  - direct map of A m(I/O)
c     factor - numerical factor (I)
c
c     N.B. this routine should be done using matrix operations

#include "wrk.fh"
       integer mapda(0:512,1:6)
       real*8 factor
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3
c
c
c1    def the lenght of the mediate
       nhelp1=mapda(0,5)
       nhelp3=mapda(nhelp1,1)+mapda(nhelp1,2)-mapda(1,1)
c
c2    def initial possition
       nhelp2=mapda(1,1)
c
c3    refactoring
       do 100 nhelp1=nhelp2,nhelp2+nhelp3-1
       wrk(nhelp1)=factor*wrk(nhelp1)
 100    continue
c
       return
       end
c
c     -----------------------------
c
       subroutine setb (wrk,wrksize,
     & mapda,mapdb,factor)
c
c     this routine do
c     B = factor . A
c
c     mapda  - direct map of A (I)
c     mapdb  - direct map of B (I)
c     factor - numerical factor (I)
c
c     mediate B must have defined maps, and their must be
c     of identicat type as those for A. If they are not defined,
c     use grc0 before setb
c
c     N.B. this routine should be done using matrix operations

#include "wrk.fh"
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       real*8 factor
c
c     help variables
c
       integer possa0,possb0,lenght,nhelp
c
c
c1    def the lenght of the mediate
       nhelp=mapda(0,5)
       lenght=mapda(nhelp,1)+mapda(nhelp,2)-mapda(1,1)
       if (lenght.eq.0) return
c
c2    def initial possitions
       possa0=mapda(1,1)
       possb0=mapdb(1,1)
c
c3    set B=f.A
       do 100 nhelp=0,lenght-1
       wrk(possb0+nhelp)=factor*wrk(possa0+nhelp)
 100    continue
c
       return
       end
c
c     -------------------------------------
c
       subroutine stz (wrk,wrksize,
     & mapda)
c
c     this routine vanish A
c     A = 0
c
c     mapda  - direct map of A m(I/O)
c
c     N.B. this routine should be done using matrix operations

#include "wrk.fh"
       integer mapda(0:512,1:6)
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3
c
c
c1    def the lenght of the mediate
       nhelp1=mapda(0,5)
       nhelp3=mapda(nhelp1,1)+mapda(nhelp1,2)-mapda(1,1)
c
c2    def initial possition
       nhelp2=mapda(1,1)
c
c3    refactoring
       do 100 nhelp1=nhelp2,nhelp2+nhelp3-1
       wrk(nhelp1)=0.0d0
 100    continue
c
       return
       end
c
c     -------------------------------------
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2003, Valera Veryazov                                  *
*               2016, Roland Lindh                                     *
************************************************************************
      SubRoutine DIIS_i(CInter,nCI,TrDh,TrDP,TrDD,nTr,nD,iOpt_DIIS,Ind)
************************************************************************
*                                                                      *
*     purpose: density matrix optimization                             *
*                                                                      *
*              EDIIS optimization:                                     *
*                   K. N. Kudin, G. E. Scuseria, and E. Cances         *
*                   JCP, 116, , 8255 (2002)                            *
*                   doi: 10.1063/1.1470195                             *
*                                                                      *
*     input:                                                           *
*       TrDh    : Traces of D(i)*h of size (nTr)                       *
*       TrDP    : Traces of D(i)*P(j) of size (nTr,nTr)                *
*       TrDD    : Traces of D(i)*D(j) of size (nTr,nTr)                *
*                                                                      *
*     output:                                                          *
*       CInter  : Interpolation coefficients of length nCI             *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*     calls to: Optim                                                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: UHF - V.Veryazov, 2003                                  *
*                                                                      *
************************************************************************
      use SpinAV, only: Do_SpinAV
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 CInter(nCI,nD),TrDh(nTr,nTr,nD),TrDP(nTr,nTr,nD),
     &                      TrDD(nTr,nTr,nD)
*
*---- Define local variables
      Real*8 Eline(MxOptm,2),Equad(MxOptm**2,2),DD(MxOptm**2,2)
      Integer Ind(MxOptm)
*define _NEW_CODE_
#ifdef _NEW_CODE_
      Logical Ignore
#endif
*     Save Eline,Equad
      Real*8 EPred(MxIter+1), h, r_SO
      Save h, EPred
      Data h/0.35D0/
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Call Timing(Cpu1,Tim1,Tim2,Tim3)
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'E_pred=',(EPred(i),i=1,iter)
      If (nD.eq.1) Then
         Write (6,*) 'E_actu=',(Elst(i,1),i=1,iter)
      Else
         Write (6,*) 'E_actu=',(Elst(i,1)+Elst(i,2),i=1,iter)
      End If
#endif
      If (iOpt_DIIS.eq.1) Then
         AccCon = 'EDIIS    '
      Else
         AccCon = 'ADIIS    '
      End If
*
#ifdef _NEW_CODE_
      Do i = kOptim, 1, -1
         Ind(i)=0
*
         tmp0= Zero
         Do j = 1, iter
*
            Ignore=.False.
            Do k = kOptim, i+1, -1
               Ignore = Ignore .or. Ind(k).eq.j
            End Do
            If (Ignore) Cycle
*
            tmp = Zero
            Do iD = 1, nD
               tmp = tmp + Elst(j,iD)
            End Do
*
            If (tmp.lt.tmp0) Then
               tmp=tmp0
               Ind(i)=j
            End If
*
         End Do
      End Do
#else
      Do i = 1, kOptim
         Ind(i) = iter-kOptim+i
      End Do
#endif
*
      Do iD = 1, nD
*
*        EDIIS optimization, doi:10.1063/1.1470195, Eq. (8)
*
*        Noticed the change in sign - in optim the quadratic terms,
*        however, are added in the evaluation of Eq. (8). Additionally,
*        the paper is written in a spin-orbital notation. A factor of
*        1/2 for the two-electron term is assumed and does not need to
*        be included.
*
         If (iOpt_DIIS.eq.1) Then
*
            Do i=1,kOptim
               ii = Ind(i)
               Eline(i,iD)=Elst(ii,iD)
               Do j=1,kOptim
                  jj= Ind(j)
                  DiFi=TrDh(ii,ii,iD)+TrDP(ii,ii,iD)
                  DiFj=TrDh(ii,ii,iD)+TrDP(ii,jj,iD)
                  DjFi=TrDh(jj,jj,iD)+TrDP(jj,ii,iD)
                  DjFj=TrDh(jj,jj,iD)+TrDP(jj,jj,iD)
                  Equad(kOptim*(i-1)+j,iD)=
     &             -Half*(DiFi-DiFj-DjFi+DjFj)
                  DD(kOptim*(i-1)+j,iD)=TrDD(ii,jj,iD)
               End Do
            End Do
*
         Else
*
*        ADIIS optimization (Eq. 7). We arbitrarily set E(Dn) to zero.
*        The option is not tested yet.
*
            kk = iter ! This needs to be properly set!
            Do i=1,kOptim
               ii = Ind(i)
               DiFn=TrDh(ii,ii,iD)+TrDP(ii,kk,iD)
               DnFn=TrDh(kk,kk,iD)+TrDP(kk,kk,iD)
               Eline(i,iD)= DiFn-DnFn
               Do j=1,kOptim
                  jj = Ind(j)
                  DiFj=TrDh(ii,ii,iD)+TrDp(ii,jj,iD)
                  DnFj=TrDh(kk,kk,iD)+TrDp(kk,jj,iD)
                  Equad(kOptim*(i-1)+j,iD)=  DiFj-DiFn-DnFj+DnFn
                  DD(kOptim*(i-1)+j,iD)=TrDD(ii,jj,iD)
               End Do
            End Do
*
         End If
*
      End Do
*
*     Tweak for UHF
*
      If (nD.eq.2) Then
         Do i=1,kOptim
            tmp_a =Eline(i,1)
            tmp_b =Eline(i,2)
            Eline(i,1) = tmp_a + tmp_b
            Eline(i,2) = tmp_a
            Do j=1,kOptim
               tmp_a = Equad(kOptim*(i-1)+j,1)
               tmp_b = Equad(kOptim*(i-1)+j,2)
               Equad(kOptim*(i-1)+j,1) = tmp_a + tmp_b
               Equad(kOptim*(i-1)+j,2) = tmp_a
            End Do
         End Do
      End If
*
************************************************************************
*
      If(kOptim.ge.3) Then
         BigOne=Zero
         BigTwo=Zero
         Do iD = 1, nD
            Do i=2,kOptim
               Do j=1,i-1
                  BigOne=Max(BigOne,Abs(Eline(i,iD)-Eline(j,iD)))
               End Do
            End Do
            Do i=1,kOptim
               Do j=1,kOptim
                  BigTwo=Max(BigTwo,Abs(Equad(i+(j-1)*kOptim,iD)))
               End Do
            End Do
         End Do
         Big=Max(BigOne,BigTwo)
         If(Big.lt.1.0d-8) Then
            EmConv=.true.
            WarnPocc=.true.
         Else
            EmConv=.false.
            WarnPocc=.false.
         End If
         If (Do_SpinAV) Then ! it is not a diagnostic in this case
            WarnPocc=.false.
         EndIf
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Find interpolation coefficients with the constaints
*
*     Sum_i c_i = 1
*
*     0 =< c_i =< 1
*
      Call Optim(E_Pred,Eline,Equad,CInter(1,1),kOptim,kOptim)
      EPred(iter+1)=E_Pred
*
#ifdef _DEBUGPRINT_
         Write(6,*)' Interpolation coefficients:'
         Write(6,'(5f16.8)')(CInter(i,1), i = 1, kOptim)
#endif
*
*     Temporary fix for UHF
*
      If (nD.eq.2) Call DCopy_(nCI,CInter(1,1),1,CInter(1,2),1)
*
#ifdef _DEBUGPRINT_
      Write(6,*)' Interpolation coefficients:'
      Write(6,'(5f16.8)')(CInter(i,1), i = 1, kOptim)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Update the trust radius, h, by checking to which degree previous
*     interpolations estimated the next energy correctly.
*
*     The first two energies have not been predicted!
*
      If (iter.gt.3) Then
         E_Pred=EPred(iter)
         E_n1 = Zero
         E_n  = Zero
         Do iD = 1, nD
            E_n1 = E_n1 + Elst(iter,iD)
            E_n  = E_n  + Elst(iter-1,iD)
         End Do
*
#ifdef _DEBUGPRINT_
         Write (6,*) 'iter=',iter
         Write (6,*) 'Energy of iter  =',E_n1
         Write (6,*) 'E_pred of iter  =',E_Pred
         Write (6,*) 'Energy of iter-1=',E_n
         Write (6,*)
#endif
*
*        In some cases the DIIS will come out with a set to
*        coefficient which corresponds to the last density. In this
*        case the E_Pred(i+1)=E(i). We add a small number to avoid
*        dividing with zero.
*
         r_SO = (E_n1 - E_n)/(E_Pred - E_n + 1.0D-12 )
      Else
         r_SO = One
      End If
*
*     Update the trust radius according to this ad hoc scheme.
*
      If (r_SO.ge.0.75D0) Then
         h = 1.2D0 * h
*     Else If (r_SO.ge.0.25D0) Then
*        h = 1.0D0 * h
      Else If (r_SO.lt.0.25D0) Then
         h = 0.7D0 * h
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Find the reference density for the density with the
*     lowest energy.
*
      E_Min=Zero
      n_min = 0
      n1    = 0
      Do i=1,kOptim
         E_tot=Zero
         Do iD = 1, nD
            E_tot = E_tot + Elst(Ind(i),iD)
         End Do
         If (E_tot.lt.E_Min) Then
            n1    = n_min
            n_min = i
            E_Min = E_tot
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the square of the trace of the difference between the
*     reference density and the new interpolated density.
*
      If (.false.) Then
      nn = Ind(n_min)
      r2 = Zero
      Do i = 1, kOptim
         ii = Ind(i)
         Do j = 1, kOptim
            jj = Ind(j)
            Do iD = 1, nD
               r2 = r2 + CInter(i,iD)*CInter(j,iD) *
     &              (TrDD(ii,jj,iD)-TrDD(nn,jj,iD)
     &              -TrDD(ii,nn,iD)+TrDD(nn,nn,iD))
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Perform a RS-DIIS interpolation if required
*
      If (Sqrt(r2).gt.h) Then
         Write (6,*) 'Apply optimization with step restriction'
         Write (6,*) 'r,h =', Sqrt(r2),h
         Call Abend()
         Call Optim2(E_Pred,Eline,Equad,DD,CInter(1,1),kOptim,kOptim,
     &               n_min,n1,r2)
         EPred(iter+1)=E_Pred
*
*        Temporary fix for UHF
*
         If (nD.eq.2) Call DCopy_(nCI,CInter(1,1),1,CInter(1,2),1)
*
      End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Check that the coefficients sum up correctly.
*
      Do iD = 1, nD
         CSum = Zero
         Do i = 1, kOptim
            CSum = CSum + CInter(i,iD)
         End Do
         If (Abs(CSum - One).gt.1.0D-5) Then
            Write (6,*) 'diis_i: Abs(CSum - One).gt.1.0D-5'
            Write (6,*) 'CSum=',CSum
            Call Abend()
         End If
*
*        If the coefficient for the last density is zero we are in
*        problem.
*
         If (CInter(kOptim,iD).eq.Zero.and.kOptim.gt.2.and.
     &       CInter(kOptim-1,iD).eq.One) Then
            Write (6,*) 'DIIS_I optimization failed!'
*           Write (6,*) 'iD=',iD
*           Write (6,*) (CInter(i,iD),i=1,kOptim)
            CInter(kOptim,iD)=1.0D-6
            CInter(kOptim,iD-1)=One-1.0D-6
*           EmConv=.True.
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld( 6) = TimFld( 6) + (Cpu2 - Cpu1)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************
!***********************************************************************
!*                                                                     *
!*  PERMVB := Permute orbitals in V1 according to IPERM.               *
!*  PERMCI := Permute orbitals in V1 according to IPERM.               *
!*                                                                     *
!*  V1 is either full CI vector (NDET), or just                        *
!*  VB determinants (NDETVB).                                          *
!*                                                                     *
!***********************************************************************

subroutine permci_cvb(v1,iperm)
! Permutes orbitals in V1 according to IPERM.

use casvb_global, only: iapr, ixapr, nda, ndet, ndetvb, norb
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: v1(0:*)
integer(kind=iwp), intent(in) :: iperm(norb)
integer(kind=iwp) :: ialg, iv1, mavailr, v2len
logical(kind=iwp) :: vb
real(kind=wp), allocatable :: v2(:)

vb = .false.
if (vb) then
  v2len = ndetvb
else
  call mma_maxDBLE(mavailr)
  if (mavailr >= ndet) then
    ialg = 1
    v2len = ndet
  else
    ialg = 2
    v2len = nda
  end if
end if
call mma_allocate(v2,v2len,label='v2')
if (vb) then
  iv1 = 0
else
  iv1 = 1
end if
call permvb2_cvb(v1(iv1),iperm,vb,iapr,ixapr,v2,ialg)

call mma_deallocate(v2)

return

end subroutine permci_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_W1 (W1,aSGrp,beSGrp,bSGrp,gaSGrp)
c
c        cek W1
        implicit none
#include "chcc1.fh"
        integer aSGrp,beSGrp,bSGrp,gaSGrp
        real*8 W1(1:16*31,1:16*33)
c
        integer a,b,be,ga,bad,ap,bp,bep,gap,ab,bega
        real*8 s
c
        if (aSGrp.eq.2) then
          ap=nv/2
        else
          ap=0
        end if
c
        if (bSGrp.eq.2) then
          bp=nv/2
        else
          bp=0
        end if
c
        if (gaSGrp.eq.2) then
          gap=nv/2
        else
          gap=0
        end if
c
        if (beSGrp.eq.2) then
          bep=nv/2
        else
          bep=0
        end if
c
        bad=0
        bega=0
        do be=1,nv/2
        do ga=1,be
        bega=bega+1
        ab=0
        do a=2,nv/2
        do b=1,a-1
        ab=ab+1
          s=(Q4(ap+a,bep+be,bp+b,gap+ga)
     c      +Q4(ap+a,gap+ga,bp+b,bep+be))/1
          if (abs(W1(ab,bega)-s).gt.1.0d-10) then
          bad=bad+1
c          write (6,99) a,b,be,ga,ab,bega,s,W1(a,be,ga)
c99        format(4(i2,1x),2(i6,1x),2(f15.10))
          end if
        W1(ab,bega)=s
        end do
        end do
        end do
        end do
c
        if (bad.eq.0) then
        write (6,*) ' Chck W OK ', bad
        else
        write (6,*) ' Chck W Bug !!!!!!! ', bad
        end if
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine finale (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3,
     & lunt2o1,lunt2o2,lunt2o3)
c
c     this routine do
c     1)  FI2   f1(a,e) <- -0.5 sum(m) [t1o(a,m) . fok(e,m)]
c     2)  FI4   f1(a,e) <- -sum(m>n,f) [Tap(af,mn) . <ef||mn>]
c
c     3)  FII2  f2(m,i) <- -0.5 sum(m) [fok(m,e) . T1o(e,i)]
c     4)  FII3  f2(m,i) <- sum(e,n) [ <ie||mn> . T1o(e,n)]
c     5)  FII4  f2(m,i) <- sum(n,e>f) [ <ef||mn> . Tap(in,ef)]
c
c     6)  FIII2 f3(e,m) <- sum(n,f) [ <ef||mn> . T1o(n,f) ]
c
c     7)  FIV1 FIV(b,e) <= FI(b,e)
c     8)  FIV2 FIV(b,e) <- -0.5 sum(m) [ T1o(b,m) . FIII(e,m)]
c     9)  T22 T2n(ab,ij) <- P(ab) sum(e) [t2o(ae,ij) . F4(b.e)]
c
c     10) FV1 FV(m,j) <= FII(m,j)
c     11) FV2 FV(m,j)aa  <- -0.5 sum (e) [ FIII(e,m) . T1o(e,j) ]
c     12) T23 T2n(ab,ij) <- - P(ij) sum(m) [T2o(ab,im) . F5(m,j) ]
c
c     13) WI1 w1(mnij) <= <mn||ij>
c     14) W12 w1(mnij) <- P(ij) sum(e) [ <ie||mn> . T1o(e,j) ]
c     15) WI3 w1(mnij) <- sum(e>f) [ <ef||mn> . Tau(ef,ij) ]
c     16) T24 t2n(ab,ij) <- sum(m>n) [ Tau(ab,mn) . W1(mn,ij) ]
c
c     17) T12 t1n(a,i) <- sum(e) [FI(a,e) . T1o(e,i)]
c     18) T13 t1n(a,i) <- - sum(m) [T1o(a,m) . FII(m,i)]
c     19) T14 t1n(a,i) <- sum(me) [ T2o(ae,im) . FIII(e,m)]
c     20) T17 t1n(a,i) <- sum(e,m>n) [ T2o(ae,mn) . <ie||mn> ]
c
c     ..) T22 done ad 9)
c     ..) T23 done ad 12)
c     ..) T24 done as 16)
c     21) T29 t2n(ab,ij) <- -P(a,b) sum(m) [T1o(a,m) . <mb||ij>]
c
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer lunabij1,lunabij2,lunabij3
       integer lunt2o1,lunt2o2,lunt2o3
c
c1
       call contf12 (wrk,wrksize)
c2
       call contf14 (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,lunt2o3)
c3
       call contf22 (wrk,wrksize)
c4
       call contf23 (wrk,wrksize)
c5
       call contf24 (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,lunt2o3)
c6
       call contf32 (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3)
c7,8,9
       call contf4 (wrk,wrksize,
     & lunt2o1,lunt2o2,lunt2o3)
c10,11,12
       call contf5 (wrk,wrksize,
     & lunt2o1,lunt2o2,lunt2o3)
c13,14,15,16
       call contw1 (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,lunt2o3)
c17
       call contt12 (wrk,wrksize)
c18
       call contt13 (wrk,wrksize)
c19,20
       call contt147 (wrk,wrksize,
     & lunt2o1,lunt2o2,lunt2o3)
c21
       call contt29 (wrk,wrksize)
c
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Per Ake Malmqvist                                *
************************************************************************
      SUBROUTINE NONA2(
#define _CALLING_
#include "grd_mck_interface.fh"
     &               )
************************************************************************
* OBJECT: TO COMPUTE THE 2ND DERIVATIVE NONADIABATIC COUPLING
* INTEGRALS, OF TYPE
*     < D/DX CHI_1 | D/DX CHI_2 >
*
*     AUTHOR: PER AKE MALMQVIST, MAX PLANCK INSTITUT F ASTROPHYSIK
*             GARCHING, MUENCHEN NOV 2000
*     AFTER PROGRAMMING PATTERN ESTABLISHED BY ROLAND LINDH
*
************************************************************************
      use Her_RW
      use Center_Info
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"

#include "grd_mck_interface.fh"

*     Local variables

      LOGICAL ABEQ(3)
C The following call parameters are not used:
C IDCNT,ISTABM,NSTABM,ZINV
C They must still be present, because the call parameter list must

      NELEM(LA)=(LA+2)*(LA+1)/2
      ABEQ(1) = A(1).EQ.RB(1)
      ABEQ(2) = A(2).EQ.RB(2)
      ABEQ(3) = A(3).EQ.RB(3)

      NIP = 1
      IPAXYZ = NIP
      NIP = NIP + NZETA*3*NHER*(LA+2)
      IPBXYZ = NIP
      NIP = NIP + NZETA*3*NHER*(LB+2)
      IPRXYZ = NIP
      NIP = NIP + NZETA*3*NHER*(NORDOP+1)
      IPRNXYZ = NIP
      NIP = NIP + NZETA*3*(LA+2)*(LB+2)*(NORDOP+1)
      IPALPH = NIP
      NIP = NIP + NZETA
      IPBETA = NIP
      NIP = NIP + NZETA
      IPSCRT=NIP
      NIP=NIP+NELEM(LA)*NELEM(LB)*NZETA*2


      IF (NIP-1.GT.NARR) THEN
        WRITE(6,*)' NONA2: Too small array.'
        WRITE(6,*)' Submitted array size NARR=',NARR
        WRITE(6,*)' Needed size at least NIP =',NIP
        CALL Abend
      END IF

* COMPUTE THE CARTESIAN VALUES OF THE BASIS FUNCTIONS ANGULAR PART
      CALL CRTCMP(ZETA,P,NZETA,A,ARRAY(IPAXYZ),
     &               LA+1,HerR(iHerR(NHER)),NHER,ABEQ)
      CALL CRTCMP(ZETA,P,NZETA,RB,ARRAY(IPBXYZ),
     &               LB+1,HerR(iHerR(NHER)),NHER,ABEQ)

CPAM: WILL WE NEED THIS??
* COMPUTE THE CONTRIBUTION FROM THE MULTIPOLE MOMENT OPERATOR
      ABEQ(1) = .FALSE.
      ABEQ(2) = .FALSE.
      ABEQ(3) = .FALSE.
      CALL CRTCMP(ZETA,P,NZETA,CCOOR,ARRAY(IPRXYZ),
     &            NORDOP,HerR(iHerR(NHER)),NHER,ABEQ)

* COMPUTE THE PRIMITIVE 1-DIMENSIONAL OVERLAP INTEGRALS.
       CALL ASSMBL(ARRAY(IPRNXYZ),
     &             ARRAY(IPAXYZ),LA+1,
     &             ARRAY(IPRXYZ),NORDOP,
     &             ARRAY(IPBXYZ),LB+1,
     &             NZETA,HerR(iHerW(NHER)),NHER)

* COMBINE THE CARTESIAN COMPONENTS OF THE 2DC MATRIX ELEMENTS
      IP = IPALPH
      DO IBETA = 1, NBETA
         CALL DCOPY_(NALPHA,ALPHA,1,ARRAY(IP),1)
         IP = IP + NALPHA
      END DO
      IP = IPBETA
      DO IALPHA = 1, NALPHA
         CALL DCOPY_(NBETA,BETA,1,ARRAY(IP),NALPHA)
         IP = IP + 1
      END DO
      CALL CMBN2DC(ARRAY(IPRNXYZ),NZETA,LA,LB,ZETA,
     &            RKAPPA,ARRAY(IPSCRT),
     &            ARRAY(IPALPH),ARRAY(IPBETA),
     &            IFGRAD)

* SYMMETRY ADAPT THE 2ND DERIVATIVE COUPLING INTEGRALS
      CALL SYMADO_MCK(ARRAY(IPSCRT),NZETA*NELEM(LA)*NELEM(LB),
     &            FINAL,NROP,
     &            nOP,LOPER,INDGRD,IU,IV,IFGRAD,IDCAR,TRANS)

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_real_array(ZINV)
         CALL Unused_integer(IDCNT)
         CALL Unused_integer_array(ISTABM)
         CALL Unused_integer(NSTABM)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!               2024, Giovanni Li Manni                                *
!***********************************************************************

subroutine CSFDIM_FREE(ISYM)
! Free resources allocated by CSFDIM_GAS

use Data_Structures, only: Deallocate_DT
use lucia_data, only: IBCONF_ALL_SYM_FOR_OCCLS, CFTP, CONF_OCC, CONF_REO, DFTP, DTOC, REO_PTDT, SDREO, SDREO_I, Z_PTDT
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ISYM

call Deallocate_DT(Z_PTDT)
call Deallocate_DT(REO_PTDT)

!LDET = NSD_PER_SYM(ISYM)
!LCONF = 0
!LLCONF = 0
!do IOPEN=0,MAXOP
!  ITYP = IOPEN+1
!  !FIXME: NELEC is undefined
!  ICL = (NELEC-IOPEN)/2
!  LLCONF = LLCONF+NCONF_PER_OPEN(ITYP,ISYM)*(IOPEN+ICL)
!end do
!LCONF = max(LCONF,LLCONF)

call mma_deallocate(DFTP)
call mma_deallocate(CFTP)
call mma_deallocate(DTOC)

call mma_deallocate(CONF_OCC(ISYM)%A)
call mma_deallocate(CONF_REO(ISYM)%A)

call mma_deallocate(SDREO_I(ISYM)%A)
nullify(SDREO)

call mma_deallocate(IBCONF_ALL_SYM_FOR_OCCLS)

end subroutine CSFDIM_FREE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine Darwin(Zeta,P,nZeta,A,Axyz,la,RB,Bxyz,lb, Final,
     &                  iStabM,nStabM,nComp,rKappa)
************************************************************************
*                                                                      *
* Object: to compoute the 1-electron Darwin contact term.              *
*                                                                      *
*     Author: Roland Lindh, Dept. Of Theoretical Chemistry,            *
*             University of Lund, Sweden, February '91                 *
************************************************************************
      use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "constants.fh"
#include "print.fh"
#include "real.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp),
     &       rKappa(nZeta),
     &       Axyz(nZeta,3,0:la), Bxyz(nZeta,3,0:lb),
     &       Zeta(nZeta), P(nZeta,3), A(3), RB(3), C(3), TC(3)
      Integer iStabM(0:nStabM-1), iDCRT(0:7)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
      iRout = 170
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In Darwin: rKappa',' ',rKappa,nZeta,1)
         Call RecPrt(' In Darwin: Zeta',' ',Zeta,nZeta,1)
         Call RecPrt(' In Darwin: P',' ',P,nZeta,3)
      End If
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nComp,[Zero],0,Final,1)
*
      kdc = 0
      Do 500 kCnttp = 1, nCnttp
         Do 501 kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
            Do 502 lDCRT = 0, nDCRT-1
               Call OA(iDCRT(lDCRT),C,TC)
*
*--------------Compute the value of the angular components associated
*              to the basis functions centered on the first center.
*
               call dcopy_(nZeta*3,[One],0,Axyz(1,1,0),1)
               If (la.eq.0) Go To 60
*
               Do 20 iCar = 1, 3
*
                  Do 30 iZeta = 1, nZeta
                     Axyz(iZeta,iCar,1) =TC(iCar) -A(iCar)
 30               Continue
*
                  Do 40 ia = 2, la
                     Do 50 iZeta = 1, nZeta
                        Axyz(iZeta,iCar,ia) = Axyz(iZeta,iCar,1) *
     &                                        Axyz(iZeta,iCar,ia-1)
 50                  Continue
 40               Continue
*
 20            Continue
 60            Continue
*
*--------------Compute the value of the angular components associated to
*              the basis functions centered on the second center.
*
               call dcopy_(nZeta*3,[One],0,Bxyz(1,1,0),1)
*
*--------------Modify z-component to carry the charge and the exponetial
*              contribution.
*
               Do 210 iZeta = 1, nZeta
                  Bxyz(iZeta,3,0) = dbsc(kCnttp)%Charge *
     &                Exp ( -Zeta(iZeta) * ( (TC(1)-P(iZeta,1))**2 +
     &                                       (TC(2)-P(iZeta,2))**2 +
     &                                       (TC(3)-P(iZeta,3))**2 ))
 210           Continue
               If (lb.eq.0) Go To 61
*
               Do 21 iCar = 1, 3
*
                  Do 31 iZeta = 1, nZeta
                     Bxyz(iZeta,iCar,1) =TC(iCar) -RB(iCar)
 31               Continue
*
                  Do 41 ib = 2, lb
                     Do 51 iZeta = 1, nZeta
                        Bxyz(iZeta,iCar,ib) = Bxyz(iZeta,iCar,1) *
     &                                        Bxyz(iZeta,iCar,ib-1)
 51                  Continue
 41               Continue
 21            Continue
*
*--------------Modify z-components with the exponential contribution
*
               Do 32 ib = 1, lb
                  Do 42 iZeta = 1, nZeta
                     Bxyz(iZeta,3,ib) = Bxyz(iZeta,3,ib) *
     &                                  Bxyz(iZeta,3,0)
 42               Continue
 32            Continue
*
 61            Continue
*
*--------------Combine contributions from the varoius angular
*              components.
*
               Do 100 ixa = la, 0, -1
               Do 101 ixb = lb, 0, -1
                  Do 110 iya = la-ixa, 0, -1
                     iza = la-ixa-iya
                     ipa = Ind(la,ixa,iza)
                  Do 111 iyb = lb-ixb, 0, -1
                     izb = lb-ixb-iyb
                     ipb = Ind(lb,ixb,izb)
                     Do 130 iZeta = 1, nZeta
                        Final(iZeta,ipa,ipb,1) =
     &                     Final(iZeta,ipa,ipb,1) + Fact *
     &                                Axyz(iZeta,1,ixa) *
     &                                Axyz(iZeta,2,iya) *
     &                                Axyz(iZeta,3,iza) *
     &                                Bxyz(iZeta,1,ixb) *
     &                                Bxyz(iZeta,2,iyb) *
     &                                Bxyz(iZeta,3,izb)
 130                 Continue
 111              Continue
 110              Continue
 101           Continue
 100           Continue

 502        Continue
 501     Continue
         kdc = kdc + dbsc(kCnttp)%nCntr
 500  Continue
*
*     Factor from operator (pi/(2*c**2), c=137.036 au)
*
*     Factor = Pi * One2C2
      Factor = Pi / (Two* CONST_C_IN_AU_ **2)
      Do 140 ipa = 1, nElem(la)
         Do 141 ipb = 1, nELem(lb)
            Do 142 iZeta = 1, nZeta
               Final(iZeta,ipa,ipb,1) = rKappa(iZeta) *
     &          Factor * Final(iZeta,ipa,ipb,1)
 142        Continue
 141     Continue
 140  Continue
*
*     Call GetMem(' Exit Darwin ','LIST','REAL',iDum,iDum)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per Ake Malmqvist                                *
!               1992, Roland Lindh                                     *
!***********************************************************************

subroutine SetHer(nDiff)
!***********************************************************************
!                                                                      *
! Object: to set up the roots and weights of the Hermite polynomials   *
!         for the evaluation of one-electron integrals.                *
!                                                                      *
!    Authors: Per-AAke Malmqvist and Roland Lindh,                     *
!             March 1992.                                              *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW, MaxHer, nPrp
use Sizes_of_Seward, only: S
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half, Pi
use Definitions, only: wp, iwp
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nDiff
integer(kind=iwp) :: i_0, i_1, IDEG, IDH, iHer, IR, IROOT, IW, j, j_0, K, n_1, n_2, nMem
real(kind=wp) :: Alpha, CORR, DELTA, HDER, R, RSUM, W, X, Z
real(kind=wp), allocatable :: Beta(:), BInv(:), Herm(:)

! 1) Hermite-Gauss
! 2) Rys-Gauss (asymptotic formula)

n_1 = (2*S%iAngMx+nPrp+2+nDiff)/2
n_2 = 4*S%iAngMx+2+nDiff

if (allocated(HerR) .and. (max(n_1,n_2) <= MaxHer)) then
  return
else if (allocated(HerR)) then
  call Free_HerRW()
end if
MaxHer = max(n_1,n_2)
call mma_allocate(iHerR,MaxHer,label='iHerR')
iHerR(1) = 1
call mma_allocate(iHerW,MaxHer,label='iHerW')
iHerW(1) = 1

! Set up square of roots and weights for Hermite polynomials

nMem = (MaxHer*MaxHer+MaxHer)/2
call mma_Allocate(HerR,nMem,label='HerR')
HerR(:) = Zero
call mma_allocate(HerW,nMem,label='HerW')
HerW(:) = Zero
call mma_allocate(Beta,MaxHer,label='Beta')
call mma_allocate(BInv,MaxHer,label='BInv')
call mma_allocate(Herm,MaxHer+1,label='Herm')
Herm(:) = Zero
do K=1,MaxHer
  Beta(K) = sqrt(Half*K)
end do
BInv(:) = One/Beta
HerR(iHerR(1)) = Zero
HerR(iHerR(1)+2) = sqrt(HALF)
HerR(iHerR(1)+1) = -HerR(iHerR(1)+2)
HerW(iHerW(1)) = sqrt(PI)
HerW(iHerW(1)+1) = HerW(iHerW(1))*HALF
HerW(iHerW(1)+2) = HerW(iHerW(1)+1)
Herm(1) = One/sqrt(HerW(iHerW(1)))
do iHer=2,MaxHer
  i_1 = (iHer*iHer-iHer)/2
  iHerR(iHer) = iHerR(1)+i_1
  iHerW(iHer) = iHerW(1)+i_1
end do

Alpha = BInv(1)
do IDEG=3,MaxHer
  i_0 = (IDEG*IDEG-IDEG)/2
  IR = iHerR(1)-1+i_0
  IW = iHerW(1)-1+i_0
  IDH = IDEG/2
  i_1 = IR+IDH+1
  X = Half*(HerR(i_1-IDEG+1)-HerR(i_1-IDEG))
  HerR(i_1) = Zero
  do IROOT=2,IDEG,2
    j_0 = IROOT/2
    R = HerR(IR-IDEG+1+j_0)-X
    HerR(IR+j_0) = R
    HerR(IR+IDEG+1-j_0) = -R
  end do
  do IROOT=1,IDH
    Z = HerR(IR+IROOT)
    CORR = Zero
    do j=1,ideg
      if (j /= iroot) CORR = CORR+(One/Z-HerR(IR+J))
    end do
    do
      Herm(2) = Z*Herm(1)*Alpha
      do K=1,IDEG-1
        Herm(K+2) = (Z*Herm(K+1)-Beta(K)*Herm(K))*BInv(K+1)
      end do
      HDER = Two*Beta(IDEG)*Herm(IDEG)
      DELTA = -Herm(IDEG+1)/(HDER-CORR*Herm(IDEG+1))
      Z = Z+DELTA
      if (abs(DELTA) <= 1.0e-8_wp) exit
      if (abs(DELTA) > 1.0e8_wp) then
        call WarningMessage(1,'Warning: large value in sether')
        !write(u6,*) delta
      end if
    end do
    HerR(IR+IROOT) = Z
    HerR(IR+IDEG+1-IROOT) = -Z
  end do
  do IROOT=1,IDH+1
    Z = HerR(IR+IROOT)
    Herm(2) = Z*Herm(1)*Alpha
    RSUM = Herm(1)**2
    RSUM = RSUM+Herm(2)**2
    do K=1,IDEG-2
      Herm(K+2) = (Z*Herm(K+1)-Beta(K)*Herm(K))*BInv(K+1)
      RSUM = RSUM+Herm(K+2)**2
    end do
    W = One/RSUM
    HerW(IW+IROOT) = W
    HerW(IW+IDEG+1-IROOT) = W
  end do
end do
call mma_deallocate(Beta)
call mma_deallocate(BInv)
call mma_deallocate(Herm)

#ifdef _DEBUGPRINT_
call TriPrt(' Hermite roots',' ',HerR(iHerR(1)),MaxHer)
call TriPrt(' Hermite weights',' ',HerW(iHerW(1)),MaxHer)
write(u6,*) ' MaxHer=',MaxHer,nPrp,S%iAngMx
#endif

return

end subroutine SetHer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Bingbing Suo                                     *
************************************************************************
c 28 dec 2007 -bsuo- the initial vectors for davidson diagnolazation are
c                    the vectors obtained by diagnol h0 space will be us
c                    initial vector for mrci calculation.
c 18 jul 2007 -bsuo- multi-root calculation is revised to perform calcul
c                    nci_dim*mroot>max_civector, the roots are calculated
c                    by one, old subroutine for davidson diagonalization
c                    deleted. the subroutines to init the initial vector
c                    revised.
c 15 mar 2007 -bsuo- new method for multi-root calculation finished
c 23 feb 2007 -bsuo- revised by suo bing for multi-root calculation
c
c this module consains some routines to calculate the segmentation
c value of the partial loops,information of the molecular orbital
c and the davidson diagonalization calculation
c
c*************************************************
      subroutine mole_inf()
c*************************************************
#include "drt_h.fh"
      common /thresh/ vthreen,vthrealp,vthreresid
      character*72  title(mxtit)
      parameter ( ncmd=9 )
      character*4 command,cmd(ncmd)
      character*72  line
      Data Cmd /'TITL','NRRO','MAXI','CPRO','PTHR',
     &          'CONV','PROR','REST',
#ifdef MOLPRO
#else
     &          'END '/
#endif
#ifdef _XIANEST_
     &         '$END'/
#endif
      logical logic_restart
#ifdef MOLPRO
#else
      call rdnlst(5,"GUGACI")
#endif

c init some program control logic variables
c trandional davidson diagnolization method is used
      logic_tdav=.true.
      logic_inivec_read=.false.
      logic_calpro=.false.
      cm_cri=0.05
      pror=0.0001
c set the default convergence threshhold
      vthreen=1.d-8
      vthrealp=1.d-6
      vthreresid=1.d-8
      mroot=1
      maxciiter=30
      ntit=0
10    read(5,'(a)',end=991) line
      command=line(1:8)
      call upcase(command)
      if ( command(1:1).eq.'*' ) goto 10
#ifdef _XIANEST_
      if(command(1:4).eq."$MRC") goto 10
#endif
      if (command.eq.' ') goto 10
      jcmd=0
      do icmd=1,ncmd
         if ( command.eq.cmd(icmd) ) jcmd=icmd
      end do
20    goto ( 100, 200, 300, 400, 500, 600,
     &       700, 800, 900
     &       ) jcmd
      write (6,*) 'input: illegal keyword'
      write (6,'(a,a)') 'command=',command
#ifdef MOLPRO
#else
      call abend()
#endif
#ifdef _XIANEST_
#endif
*
*---  process title    command ----------------------------------------*
 100  continue
      read(5,'(a)',end=991) line
      command=line(1:8)
      call upcase(command)
      if ( command(1:1).eq.'*' ) goto 100
      jcmd=0
      do icmd=1,ncmd
         if ( command.eq.cmd(icmd) ) jcmd=icmd
      end do
      if ( jcmd.ne.0 ) goto 20
      ntit=ntit+1
      if ( ntit.le.mxtit ) title(ntit)=line
      goto 100
*
*---  process nrroot command ----------------------------------------*
 200  continue
      read(5,'(a)',end=991) line
      if(line(1:1).eq."*") goto 200
      read(line,*,err=992) mroot
      goto 10

*
*---  process Maxiterations command ------------------------------------
 300  continue
      read(5,'(a)',end=991) line
      if(line(1:1).eq."*") goto 300
      read(line,*,err=992) maxciiter
      goto 10

*
*---  process Calculate property command -------------------------------
 400  continue
      logic_calpro=.true.
      goto 10

*
*---  process Thresh print command -------------------------------------
 500  continue
      read(5,'(a)',end=991) line
      if(line(1:1).eq."*") goto 500
      read(line,*,err=992) cm_cri
      goto 10
*
*---  process Convergence threshold command ----------------------------
 600  continue
      read(5,'(a)',end=991) line
      if(line(1:1).eq."*") goto 600
      read(line,*,err=992) vthreen,vthrealp,vthreresid
      goto 10
*
*---  process print orbital command ------------------------------------
 700  continue
      read(5,'(a)',end=991)  line
      if(line(1:1).eq."*") goto 700
      read(line,*,err=992) pror
      goto 10


*---  process restart command ------------------------------------------
 800  continue
      logic_restart=.true.
      goto 10

*--- End of GUGACI input ----------------------*
 900  continue

      call mole_inf_molcas()
      return
991   write (6,*) 'input: end of input file encountered'
      write (6,'(a,a)') 'last command: ',command
#ifdef _XIANEST_
#endif
#ifdef MOLPRO
#else
      call abend()
#endif
992   write (6,*) 'input: error while reading input!'
      write (6,'(a,a)') 'last command: ',command
#ifdef _XIANEST_
#endif
#ifdef MOLPRO
#else
      call abend()
#endif
      end

      subroutine mole_inf_molcas()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "files_gugaci.fh"
      common /thresh/ vthreen,vthrealp,vthreresid
      common /mcorb/ lsmorb(max_orb),noidx(8)
      dimension lsmtmp(maxgdm)
      dimension idum(1)

c      open(nf1,file="drt.inp")
c      read(nf1,*)
c      read(nf1,*) mroot,mth_eigen,kin
c      read(nf1,*) n_electron, spin, ng_sm, ns_sm, cm_cri
c      read(nf1,*) nlsm_all(1:ng_sm)
c      read(nf1,*) nlsm_frz(1:ng_sm)
c      read(nf1,*) nlsm_dbl(1:ng_sm)
c      read(nf1,*) nlsm_act(1:ng_sm)
c      read(nf1,*) log_thre
! merge into molcas
c write date into cidrt for ci calculation
      noidx=0
      idisk=0
      call idafile(ludrt,2,noidx,2,idisk)
! group symmetry
      call idafile(ludrt,2,idum,1,idisk)
      ng_sm=idum(1)
! state symmetry
      call idafile(ludrt,2,idum,1,idisk)
      ns_sm=idum(1)
! number of roots to be cal
      call idafile(ludrt,2,idum,1,idisk)
      nroot=idum(1)
! number of corelation electrons
      call idafile(ludrt,2,idum,1,idisk)
      n_electron=idum(1)
! number of active electrons
      call idafile(ludrt,2,idum,1,idisk)
      nactel=idum(1)
! spin symmetry of the state, 2s+1
      call idafile(ludrt,2,idum,1,idisk)
      ispin=idum(1)
! dbl orb
      call idafile(ludrt,2,nlsm_dbl,8,idisk)
! act orb
      call idafile(ludrt,2,nlsm_act,8,idisk)
! all correlated orb
      call idafile(ludrt,2,nlsm_all,8,idisk)
! num. basis
      call idafile(ludrt,2,nlsm_bas,8,idisk)
      spin=(ispin-1)/2.d0

      norb_frz=0
      norb_act=0
      norb_dz=0
      norb_all=0
      noidx=0
      idx=0
      ni=0
      do i=1,ng_sm
        norb_frz=norb_frz+nlsm_frz(i)
        norb_dbl=norb_dbl+nlsm_dbl(i)
        norb_act=norb_act+nlsm_act(i)
        nlsm_inn(i)=nlsm_frz(i)+nlsm_dbl(i)+nlsm_act(i)
        nlsm_ext(i)=nlsm_all(i)-nlsm_inn(i)
        norb_all=norb_all+nlsm_all(i)
        noidx(i)=idx
        idx=idx+nlsm_all(i)
        lsmorb(ni+1:idx)=i
        ni=idx
      enddo
      norb_inn=norb_frz+norb_dbl+norb_act
      norb_ext=norb_all-norb_inn
      norb_dz=norb_dbl+norb_frz

      nstart_act=norb_dz+1
      ngw1=0
      ngw2=0
      ngw3=0
      ngw1(1)=0
      ngw2(1)=0
      ngw2(2)=0
      ngw3(1)=0
      ngw3(2)=0
      ngw3(3)=0
      do i=1,norb_all
        ngw2(i+2) = ngw2(i+1)+i
        ngw3(i+3) = ngw3(i+2)+ngw2(i+2)
        ngw4(i+4) = ngw4(i+3)+ngw3(i+3)
      enddo
      nabc=norb_ext-2+ngw2(norb_ext-1)+ngw3(norb_ext)

      iorb=0
      do i=1,ng_sm
        do j=1,nlsm_frz(i)
          iorb=iorb+1
          lsm_inn(iorb)=i
        enddo
      enddo
      do i=1,ng_sm
        do j=1,nlsm_dbl(i)
          iorb=iorb+1
          lsm_inn(iorb)=i
        enddo
      enddo
      do i=1,ng_sm
        do j=1,nlsm_act(i)
          iorb=iorb+1
          lsm_inn(iorb)=i
        enddo
      enddo

      nact_sm=1
      do im=1,norb_inn
        if(lsm_inn(im).gt.nact_sm) nact_sm=lsm_inn(im)
      enddo

      norb_all_tmp=0
      do ngsm=1,ng_sm
        norb_all_tmp=norb_all_tmp+nlsm_all(ngsm)
      enddo
      if(norb_all_tmp.ne.norb_all) then
        write(6,*)'  input num.of orbital err! check again!'
#ifdef MOLPRO
#else
      call abend()
#endif
#ifdef _XIANEST_
#endif
      endif

      do l=1,norb_inn
        lr=norb_all-l+1
        lsm(lr)=lsm_inn(l)
      enddo

      lr=0
      int_dd_offset(1:8,1:8)=0
      do im=1,ng_sm
        im_lr_sta=0
        do iml=1,ng_sm
          imr=mul_tab(im,iml)
          if ( imr .gt. iml ) cycle
          int_dd_offset(iml,imr)=im_lr_sta
          int_dd_offset(imr,iml)=im_lr_sta
          if(iml.eq.imr)im_lr_sta=im_lr_sta+
     :           nlsm_ext(iml)*(nlsm_ext(iml)-1)/2
          if(iml.ne.imr)im_lr_sta=im_lr_sta+
     :           nlsm_ext(iml)*nlsm_ext(imr)
        enddo
        do l=1,nlsm_ext(im)
          lr=lr+1
          lsm(lr)=im
        enddo
      enddo
      lsm_inn(norb_inn+1)=lsm(norb_ext)

      logic_mr=.false.
      logic_mrelcas=.false.
      logic_assign_actorb=.false.

      call idafile(ludrt,2,idum,1,idisk)
      imrcas_case=idum(1)
      if(imrcas_case.eq.2) then
        logic_mr=.true.
        call idafile(ludrt,2,idum,1,idisk)
        n_ref=idum(1)
        do i=1,n_ref
          call idafile(ludrt,2,iref_occ(1,i),norb_inn,idisk)
        enddo
      endif
      if(imrcas_case.eq.4) then
        logic_mrelcas=.true.
      endif

      do i=1,ng_sm   !norb_inn
         lsmtmp(i)=0
      enddo
      do i=1,norb_inn
         lsmtmp(lsm_inn(i))=lsmtmp(lsm_inn(i))+1
      enddo

      itmp=0
      do i=1,ng_sm
         ibsm_ext(i)=itmp+1
         itmp=itmp+nlsm_ext(i)
         iesm_ext(i)=itmp
      enddo

c****************************************************
#ifdef _DEBUG
      idebug=1
      if(idebug.eq.1) then
        write(6,1001)
        write(6,1002) norb_all,norb_frz,norb_dz,norb_inn,norb_ext
        write(6,1002) nlsm_all(1:ng_sm)
        write(6,1002) nlsm_frz(1:ng_sm)
        write(6,1002) nlsm_dbl(1:ng_sm)
        write(6,1002) nlsm_inn(1:ng_sm)
        write(6,1002) nlsm_ext(1:ng_sm)
        write(6,*) "lsm inn, imrcas_case",imrcas_case
        write(6,1002) lsm_inn(1:norb_inn)
        write(6,*) "lsm all",norb_all
        write(6,1002) (lsm(i),i=norb_all,1,-1)
      endif
1001  format(1x,"all frz dz inn ext")
1002  format(8(1x,i3))
#endif
c*****************************************************

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetChVHlp2(L2Status,NL2,used,kam)
! this routine does:
! Define, which one of unused L2 arrays allocated in memory
! will be used for placing newly needed L2x
! Criteria of present approach:
! 1) First those positions that are allocated, but never used yet
! 2) if no 1), take first unused in this step, according L2Status
!    N.B. 2) druhy krok moze byt eventuelne vylepseny, zatial
!         takto odflaknute
!
! description of variables:
! L2Status  - L2 Status array (I)
! NL2       - number of L2 arrays reserved in memory (I)
! used      - array indicating, which L2x are already used
!             in this step (those cannot be touched) (I)
! kam       - index of position, where new L2 can be placed (O)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: L2Status(4,3), NL2, used(4)
integer(kind=iwp), intent(out) :: kam
integer(kind=iwp) :: i

!1 search, if there are never used positions

do i=1,NL2
  if (L2Status(i,1) == 0) then
    kam = i
    return
  end if
end do

!2 find first unused in this step

do i=1,NL2
  if (used(i) == 0) then
    kam = i
    return
  end if
end do

! Jaj nieje dobre ak sme sa dostali az sem
write(u6,*) ' Sorry fish getChVHlp2 '
call Abend()

return

end subroutine GetChVHlp2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Giovanni Ghigo                                   *
!***********************************************************************
!  Mem_Est
!
!> @brief
!>   The routine makes an estimation of the optimal memory allocation and defines the
!>   maximum number of Cholesky vectors to transform both for the main (\p nVec) and
!>   the inner (\p nFVec) batch procedures
!> @author Giovanni Ghigo
!>
!> @param[in]  iSymL Symmetry of the Cholesky vector
!> @param[out] nVec  Number of Cholesky vectors to transform in the batch procedure
!> @param[out] nFVec Number of Cholesky vectors to transform in the inner batch procedure
!***********************************************************************

subroutine Mem_Est(iSymL,nVec,nFVec)
!***********************************************************************
! Author :  Giovanni Ghigo                                             *
!           Torino University, Italy                                   *
!           January-February, July 2005                                *
!----------------------------------------------------------------------*
! Routine for the estimation of the memory usage and the number (nVec) *
! of Cholesky Vectors transformable.                                   *
! The routine also define (calling Def_TCVx) which TCVx create.        *
!***********************************************************************

use Cho_Tra, only: IfTest, nAsh, nBas, nIsh, nOrb, nSsh, nSym, NumCho, TCVXist
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iSymL
integer(kind=iwp), intent(out) :: nVec, nFVec
integer(kind=iwp) :: I, iSym, iSymA, iSymAI, iSymB, iSymBJ, iSymI, iSymJ, jSym, Len_ABSq, Len_XAb, Len_XAj, Len_XAu, Len_XBi, &
                     Len_XBt, Len_YAb, Len_YAj, Len_YAu, LenCHFV, LenTCVx, LenTmpTra, MaxInt, MaxNum, MaxSize, MaxSlice, MemAlloc, &
                     MemFree, MemFree0, MemMin, MemPerVec2, MEMX, Nab, Naj, Nau, Nbi, Nbt, Nij, Niu, Nji, Njt, nN_AB, nN_Ex1, &
                     nN_Ex2, nN_IJ, Ntj, Ntu, Nui, Nut
character(len=16) :: Frmt1, Frmt3

nVec = 0  ! Nr. of transformable vectors for batch.
nFVec = 0 ! Nr. of full vectors for inner transformation batch

! Memory for Reading (will change when reading reduced set)
LenCHFV = 0   ! Mem for Full Vectors (p.v. = per vector)
! Memory for Transformation
LenTCVx = 0   ! Mem for TCVx (p.v.)
LenTmpTra = 0 ! Mem for First-half Transformation
! Memory for Generation
MaxInt = 0    ! Mem for integrals
MaxSlice = 0  ! Mem for Lx (p.v.)

! Memory for Transformation
Nij = 0  ! A
Nji = 0  ! A"
Ntj = 0  ! B
Nui = 0  ! B"
Naj = 0  ! C
Nbi = 0  ! C"
Ntu = 0  ! D
Nut = 0  ! D"
Nau = 0  ! E
Nbt = 0  ! E"
Nab = 0  ! F
Njt = 0  ! G
Niu = 0  ! G"

do iSym=1,nSym
  if (nBas(iSym) > 0) then
    do jSym=1,iSym
      if ((nBas(jSym) > 0) .and. (Mul(iSym,jSym) == iSymL)) then

        Len_YAj = 0  ! iSym=jSym: A, B, C
        Len_YAu = 0  ! iSym=jSym: D, E
        Len_YAb = 0  ! iSym=jSym: F
        Len_XAj = 0  ! iSym=/=jSym: A/A", B, C
        Len_XAu = 0  ! iSym=/=jSym: D/D", E
        Len_XAb = 0  ! iSym=/=jSym: F
        Len_XBi = 0  ! iSym=/=jSym: B",C"
        Len_XBt = 0  ! iSym=/=jSym: E"
        Len_ABSq = 0 ! Squared CHFV

        call Def_TCVx(iSym,jSym)

        if (iSym == jSym) then

          ! TCV-A :
          if (TCVXist(1,iSym,jSym)) then
            Len_YAj = nBas(iSym)*nIsh(jSym)
            Nij = Nij+nIsh(iSym)*nIsh(jSym)
          end if
          ! TCV-B :
          if (TCVXist(2,iSym,jSym)) then
            Len_YAj = nBas(iSym)*nIsh(jSym)
            Ntj = Ntj+(nAsh(iSym)*nIsh(jSym))
            ! TCV-G :
            Njt = Njt+(nIsh(jSym)*nAsh(iSym))
          end if
          ! TCV-C :
          if (TCVXist(3,iSym,jSym)) then
            Len_YAj = nBas(iSym)*nIsh(jSym)
            Naj = Naj+nSsh(iSym)*nIsh(jSym)
          end if
          ! TCV-D :
          if (TCVXist(4,iSym,jSym)) then
            Len_YAu = nBas(iSym)*nAsh(jSym)
            Ntu = Ntu+nAsh(iSym)*nAsh(jSym)
          end if
          ! TCV-E :
          if (TCVXist(5,iSym,jSym)) then
            Len_YAu = nBas(iSym)*nAsh(jSym)
            Nau = Nau+nSsh(iSym)*nAsh(jSym)
          end if
          ! TCV-F :
          if (TCVXist(6,iSym,jSym)) then
            Len_YAb = nBas(iSym)*nSsh(jSym)
            Nab = Nab+nSsh(iSym)*nssh(jSym)
          end if

          LenCHFV = LenCHFV+(nBas(iSym)*(nBas(jSym)+1)/2)
          Len_ABSq = nBas(iSym)*nBas(jSym)
          LenTmpTra = max(LenTmpTra,(Len_ABSq+Len_YAj+Len_YAu+Len_YAb))

        else

          ! TCV-A :
          if (TCVXist(1,iSym,jSym)) then
            Len_XAj = nBas(iSym)*nIsh(jSym)
            Nij = Nij+(nIsh(iSym)*nIsh(jSym))
            Nji = Nji+(nIsh(jSym)*nIsh(iSym))
          end if
          ! TCV-B :
          if (TCVXist(2,iSym,jSym)) then
            Len_XAj = nBas(iSym)*nIsh(jSym)
            Ntj = Ntj+(nAsh(iSym)*nIsh(jSym))
            ! TCV-G :
            Njt = Njt+(nIsh(jSym)*nAsh(iSym))
          end if
          if (TCVXist(2,jSym,iSym)) then
            Len_XBi = nBas(jSym)*nIsh(iSym)
            Nui = Nui+(nAsh(jSym)*nIsh(iSym))
            ! TCV-G :
            Niu = Niu+(nIsh(iSym)*nAsh(jSym))
          end if
          ! TCV-C :
          if (TCVXist(3,iSym,jSym)) then
            Len_XAj = nBas(iSym)*nIsh(jSym)
            Naj = Naj+nSsh(iSym)*nIsh(jSym)
          end if
          if (TCVXist(3,jSym,iSym)) then
            Len_XBi = nBas(jSym)*nIsh(iSym)
            Nbi = Nbi+nSsh(jSym)*nIsh(iSym)
          end if
          ! TCV-D :
          if (TCVXist(4,iSym,jSym)) then
            Len_XAu = nBas(iSym)*nAsh(jSym)
            Ntu = Ntu+(nAsh(iSym)*nAsh(jSym))
            Nut = Nut+(nAsh(jSym)*nAsh(iSym))
          end if
          ! TCV-E :
          if (TCVXist(5,iSym,jSym)) then
            Len_XAu = nBas(iSym)*nAsh(jSym)
            Nau = Nau+nSsh(iSym)*nAsh(jSym)
          end if
          if (TCVXist(5,jSym,iSym)) then
            Len_XBt = nBas(jSym)*nAsh(iSym)
            Nbt = Nbt+nSsh(jSym)*nAsh(iSym)
          end if
          ! TCV-F :
          if (TCVXist(6,iSym,jSym)) then
            Len_XAb = nBas(iSym)*nSsh(jSym)
            Nab = Nab+nSsh(iSym)*nSsh(jSym)
          end if

          LenCHFV = LenCHFV+(nBas(iSym)*nBas(jSym))
          LenTmpTra = max(LenTmpTra,(Len_XAj+Len_XAu+Len_XAb+Len_XBi+Len_XBt))

        end if

      end if
    end do ! jSym
  end if
end do ! iSym

LenTCVx = Nij+Nji+Ntj+Nui+Naj+Nbi+Ntu+Nut+Nau+Nbt+Nab+Niu+Njt

! Memory for Generation
do iSymI=1,nSym
  do iSymJ=1,iSymI
    do iSymA=1,nSym
      do iSymB=1,iSymA
        iSymAI = Mul(iSymA,iSymI)
        iSymBJ = Mul(iSymB,iSymJ)
        call LenInt(iSymI,iSymJ,iSymA,iSymB,nN_IJ,nN_AB,nN_Ex1,nN_Ex2)
        if ((iSymAI == iSymL) .and. (iSymBJ == iSymL) .and. (nN_IJ*nN_AB > 0)) then
          MaxInt = max(MaxInt,max(nN_AB,max(nN_Ex1,2*nN_Ex2)))
          MaxSlice = max(MaxSlice,nOrb(iSymA)+nOrb(iSymB))
        end if
      end do
    end do
  end do
end do

call mma_maxDBLE(MEMX)
MemFree0 = max(MEMX-MEMX/10,0)

MemPerVec2 = LenTCVx+MaxSlice

MemMin = LenCHFV+LenTmpTra+LenTCVx+MaxSlice+2*MaxInt
MemFree = MemFree0-MemMin

nVec = min((MemFree/MemPerVec2+1),NumCho(iSymL))
MemFree = MemFree-(nVec-1)*MemPerVec2
nFVec = min((MemFree/LenCHFV+1),NumCho(iSymL))
MemAlloc = MemMin+(nVec-1)*MemPerVec2+(nFVec-1)*LenCHFV

if ((.not. IfTest) .and. (nVec == NumCho(iSymL)) .and. (nFVec > 0)) return

MaxNum = max(MemFree0,MemAlloc)
MaxSize = max(9,int(log10(real(MaxNum,kind=wp)))+1)
write(Frmt1,'(I16)') MaxSize
Frmt1 = '(A,1X,I'//trim(adjustl(Frmt1))//')'
write(Frmt3,'(I16)') MaxSize-5
Frmt3 = '(A,1X,I'//trim(adjustl(Frmt3))//',A)'

write(u6,*)
write(u6,'(20A3)') ('---',I=1,20)
write(u6,105) ' MEM for TRANSF/GENER of VECTORS in Sym:',iSymL
write(u6,*)
write(u6,Frmt1) ' Mem (p.v.) for CHFV            :',LenCHFV
write(u6,Frmt1) ' Tmp Mem for transformation     :',LenTmpTra
write(u6,Frmt1) ' Mem (p.v.) for TCVx            :',LenTCVx
write(u6,Frmt1) ' Max Tmp Mem (p.v.) for generat.:',MaxSlice
write(u6,Frmt1) ' Max Mem for Integrals (twice)  :',2*MaxInt
write(u6,Frmt1)
write(u6,Frmt1) ' TOTAL AVAILABLE MEMORY         :',MemFree0
write(u6,Frmt1) ' Minimal Memory required        :',MemMin
write(u6,Frmt1) ' Memory Required by generation  :',(nVec-1)*MemPerVec2
write(u6,Frmt1) ' Memory Available for transform.:',MemFree
write(u6,Frmt1) ' Memory Required by transform.  :',(nFVec-1)*LenCHFV
write(u6,Frmt1) ' TOTAL ALLOCATED MEMORY         :',MemAlloc
write(u6,Frmt1) ' Unemployed memory              :',MemFree0-MemAlloc
write(u6,*)
write(u6,120) ' Max nr. of Transformed vectors  :',nVec
write(u6,120) ' Max nr. of vectors in sub-batch :',nFVec
write(u6,120) ' Total Number of Cholesky vectors:',NumCho(iSymL)
write(u6,*)
write(u6,*) 'ESTIMATED MEMORY REQUIREMENTS'
write(u6,Frmt3) '  Minimum:',2+MemMin/119000,' MB'
write(u6,Frmt3) '  Normal :',2+(MemMin+MemPerVec2*(NumCho(iSymL)-1))/119000,' MB'
write(u6,Frmt3) '  Maximum:',2+(MemMin+(MemPerVec2+LenCHFV)*(NumCho(iSymL)-1))/119000,' MB'
write(u6,'(20A3)') ('---',I=1,20)
write(u6,*)
call XFlush(u6)
if (nVec < NumCho(iSymL)) then
  write(u6,*) ' Batch procedure used. Increase memory if possible!'
  write(u6,*)
  write(u6,'(20A3)') ('---',I=1,20)
  call XFlush(u6)
end if

return

105 format(A,1X,I1)
120 format(A,1X,I6)

end subroutine Mem_Est

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_mult(wrk,wrksize,ninda,nindb,nindc,nindsum,a,ssa,b,ssb,c,ssc,rc)
! ninda   - # of indices in matrix A (Input)
! nindb   - # of indices in matrix B (Input)
! nindc   - # of indices in matrix C (Input, for test)
! nindsum - # of summation indices   (Input)
! a       - A  (Input)
! ssa     - overall symmetry state of matrix A (Input)
! b       - B  (Input)
! ssb     - overall symmetry state of matrix B (Input)
! c       - C  (Output)
! ssc     - overall symmetry state of matrix C (Input/Output)
!
! This routine realizes matrix-matrix and matrix-vector multiplications
! A(indA)*B(indB)=C(indC) or A(indA)*B(indB)=Y(indC)
!
! N.B.
! ninda, nindb, and nindsum are independent,
! nindc is tested if it is in agreement with previous ones - for test
! typA, typB are tested if they are in mutual agreement
!
! Table of implemented processes
!
! nindA   nindB  nindsum =>nindC        Operation               Implemented
!
! 4       4       4       0     A(pqrs)*B(pqrs)  =S             Not yet
! 4       4       3       2     A(p,qrs)*B(qrs,t)=C(p,t)          Yes
! 4       4       2       4     A(pq,rs)*B(rs,tu)=C(pq,tu)        Yes
! 4       4       1       6     A(pqr,s)*B(s,tuv)=C(pqr,tuv)      No
! 4       4       0       8     A(pqrs)*B(tuvz)=C(pqrs,tuvz)      No
!
! 4       3       3       1     A(p,qrs)*B(qrs)  =Y(p)            Yes
! 4       3       2       3     A(pq,rs)*B(rs,t) =C(pq,t)         Yes
! 4       3       1       5     A(pqr,s)*B(s,tu) =C(pqr,tu)       No
! 4       3       0       7     A(pqrs)*B(tuv)   =C(pqrs,tuv)     No
!
! 4       2       2       2     A(pq,rs)*B(pq)   =Y(pq)           Yes
! 4       2       1       4     A(pqr,s)*B(s,t)  =C(pqr,t)        Yes
! 4       2       0       6     A(pqrs)*B(tu)    =C(pqrs,tu)      No
!
! 4       1       1       3     A(pqr,s)*B(s)    =Y(pqr)        Not yet
! 4       1       0       5     A(pqrs)*B(t)     =C(pqrs,t)       No
!
! 3       4       3       1     A(pqr) *B(pqr,s) =Y(s)          Not need
! 3       4       2       3     A(p,qr)*B(qr,st) =C(p,st)         Yes
! 3       4       1       5     A(pq,r)*B(r,stu) =C(pq,stu)       No
! 3       4       0       7     A(pqr)*B(stuv) =C(pqr,stuv)       No
!
! 3       3       3       0     A(pqr) *B(pqr)   =S             Not yet
! 3       3       2       2     A(p,qr)*B(qr,s)  =C(p,s)          Yes
! 3       3       1       4     A(pq,r)*B(r,st)  =C(pq,st)        Yes
! 3       3       0       6     A(pqr) *B(stu)   =C(pqrmstu)      No
!
! 3       2       2       1     A(p,qr)*B(qr)    =Y(p)            Yes
! 3       2       1       3     A(pq,r)*B(r,s)   =C(pq,s)         Yes
! 3       2       0       5     A(pqr) *B(st)    =C(pqr,st)       No
!
! 3       1       1       2     A(pq,r)*B(r)     =Y(pq)         Not yet
! 3       1       0       4     A(pqr) *B(s)     =C(pqr,s)        No
!
! 2       4       2       2     A(pq) *B(pq,rs)  =Y(rs)         Not need
! 2       4       1       4     A(p,q)*B(q,rst)  =C(p,rst)        Yes
! 2       4       0       6     A(pq) *B(rstu)   =C(pq,rstu)      No
!
! 2       3       2       1     A(pq) *B(pq,r)   =Y(r)          Not need
! 2       3       1       3     A(p,q)*B(q,rs)   =C(p,rs)         Yes
! 2       3       0       5     A(pq) *B(rst)    =C(pq,rst)       No
!
! 2       2       2       0     A(pq) *B(pq)     =S             Not yet
! 2       2       1       2     A(p,q)*B(q,r)    =C(p,r)          Yes
! 2       2       0       4     A(pq) *B(rs)     =C(pq,rs)        No
!
! 2       1       1       1     A(p,q)*B(q)      =Y(p)          Not yet
! 2       1       0       3     A(pq) *B(r)      =C(pq,r)         No
!
! 1       4       1       3     A(p)*B(p,qrs)    =Y(qrs)        Not need
! 1       4       0       5     A(p)*B(qrst)     =C(p,qrst)       No
!
! 1       3       1       2     A(p)*B(p,qr)     =Y(qr)         Not need
! 1       3       0       4     A(p)*B(qrs)      =C(p,qrs)        No
!
! 1       2       1       1     A(p)*B(p,q)      =Y(q)          Not need
! 1       2       0       3     A(p)*B(qr)       =C(p,qr)         No
!
! 1       1       1       0     A(p)*B(p)        =S             Not yet
! 1       1       0       2     A(p)*B(q)        =C(p,q)          No
!
! Legend used in error messages:
! NCI = Not Currently Implemented
! Stup= Stupidity
! @   = improper value

use CCT3_global, only: Map_Type, mmul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, ninda, nindb, nindc, nindsum, ssa, ssb
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: a, b
type(Map_Type), intent(inout) :: c
integer(kind=iwp), intent(out) :: ssc, rc
integer(kind=iwp) :: ix, mvec(4096,7), typa, typb

rc = 0
ssc = mmul(ssa,ssb)
typa = a%d(0,6)
typb = b%d(0,6)

if (ninda == 4) then

  ! ****** nind A = 4  ******

  if (nindb == 4) then

    !44 *** nind A =4, B=4

    if (nindsum == 1) then
      ! RC=1 : nindA=4, nindB=4, nindsum=1 (too large metiate, NCI)
      rc = 1
      return

    else if (nindsum == 2) then

      ! case A(pqrs)*B(rstu)=C(pqtu)

      ! tests

      if (nindc /= 4) then
        ! RC=2 : nindA=4, nindB=4, nindsum=2 (# of ind. in C is not 4, Stup)
        rc = 2
        return
      end if

      if (typa == 2) then
        ! RC=3 : nindA=4, nindB=4, nindsum=2 (typA is 2, Stup)
        rc = 3
        return
      end if

      if (typb == 2) then
        ! RC=4 : nindA=4, nindB=4, nindsum=2 (typB is 2, Stup)
        rc = 4
        return
      end if

      if ((typa == 3) .or. (typa == 4)) then
        ! there is  r>s in A
        if ((typb == 4) .or. (typb == 1)) then
          ! OK
        else
          ! RC=5 : nindA=4, nindB=4, nindsum=2 (typA incompatible with typB , Stup)
          rc = 5
          return
        end if
      else
        ! there is no r>s in A
        if ((typb == 4) .or. (typb == 1)) then
          ! RC=5 : nindA=4, nindB=4, nindsum=2 (typA incompatible with typB , Stup)
          rc = 5
          return
        else
          ! OK
        end if
      end if

      ! call cct3_grc44c and multc0

      call cct3_grc44c(a,b,c,mvec,ssa,ssb,2,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 3) then

      ! case A(pqrs)*B(qrst)=C(pt)

      ! tests

      if (nindc /= 2) then
        ! RC=6 : nindA=4, nindB=4, nindsum=3 (# of ind. in C is not 2, Stup)
        rc = 6
        return
      end if

      if (typa == 1) then
        ! RC=7 : nindA=4, nindB=4, nindsum=3 (typA is 1, Stup)
        rc = 7
        return
      end if

      if (typb == 3) then
        ! RC=8 : nindA=4, nindB=4, nindsum=3 (typB is 3, Stup)
        rc = 8
        return
      end if

      if ((typa == 2) .and. (typb /= 1)) then
        ! RC=9 : nindA=4, nindB=4, nindsum=3 (typA incomp. with typB, Stup)
        rc = 9
        return
      end if

      if ((typa == 3) .and. (typb /= 2)) then
        ! RC=9 : nindA=4, nindB=4, nindsum=3 (typA incomp. with typB, Stup)
        ! like in previous case
        rc = 9
        return
      end if

      ! call cct3_grc44c and multc0

      call cct3_grc44c(a,b,c,mvec,ssa,ssb,1,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 4) then
      ! RC=10: nindA=4, nindB=4, nindsum=4 (NCI)
      rc = 10
      return

    else
      ! RC=11: nindA=4, nindB=4, nindsum=@ (Stup)
      rc = 11
      return
    end if

  else if (nindb == 3) then

    !43 *** nind A =4, B=3

    if (nindsum == 3) then

      ! case A(pqrs)*B(qrs)=Y(p)

      ! tests

      if (nindc /= 1) then
        ! RC=12: nindA=4, nindB=3, nindsum=3 (# of index in C is not 1, Stup)
        rc = 12
        return
      end if

      if ((typa == 1) .or. (typa == 4)) then
        ! RC=13: nindA=4, nindB=3, nindsum=3 (typA is 1 or 4, Stup)
        rc = 13
        return
      end if

      if ((typa == 2) .and. (typb /= 1)) then
        ! RC=14: nindA=4, nindB=3, nindsum=3 (typA incomp. with typB, Stup)
        rc = 14
        return
      end if

      if ((typa == 3) .and. (typb /= 2)) then
        ! RC=14: nindA=4, nindB=3, nindsum=3 (typA incomp. with typB, Stup)
        ! like in previous case
        rc = 14
        return
      end if

      ! call cct3_grc43y and multy0

      call cct3_grc43y(a,b,c,mvec,ssa,ssb,ix)

      call cct3_multy0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 2) then

      ! case A(pqrs)*B(rst)=C(pqt)

      ! tests

      if (nindc /= 3) then
        ! RC=15: nindA=4, nindB=3, nindsum=2 (# of index in C is not 3, Stup)
        rc = 15
        return
      end if

      if (typa == 2) then
        ! RC=16: nindA=4, nindB=3, nindsum=2 (typA is 2, Stup)
        rc = 16
        return
      end if

      if (typb == 2) then
        ! RC=17: nindA=4, nindB=3, nindsum=2 (typB is 2, Stup)
        rc = 17
        return
      end if

      if (((typa == 3) .or. (typa == 4)) .and. (typb /= 1)) then
        ! RC=18: nindA=4, nindB=3, nindsum=2 (typA incomp. with typB, Stup)
        rc = 18
        return
      end if

      ! call cct3_grc43c and multc0

      call cct3_grc43c(a,b,c,mvec,ssa,ssb,2,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 1) then
      ! RC=19: nindA=4, nindB=3, nindsum=1 (too large mediate, NCI)
      rc = 19
      return

    else
      ! RC=20: nindA=4, nindB=3, nindsum=@ (Stup)
      rc = 20
      return
    end if

  else if (nindb == 2) then

    !42 *** nind A =4, B=2

    if (nindsum == 1) then

      ! case A(pqr,s)*B(s,t)=C(pqr,t)

      ! tests

      if (nindc /= 4) then
        ! RC=21: nindA=4, nindB=2, nindsum=1 (# of index in C is not 4, Stup)
        rc = 21
        return
      end if

      if ((typa == 3) .or. (typa == 4)) then
        ! RC=22: nindA=4, nindB=2, nindsum=1 (typA is 3 or 4, Stup)
        rc = 22
        return
      end if

      if (typb == 1) then
        ! RC=23: nindA=4, nindB=2, nindsum=1 (typA is 1, Stup)
        rc = 23
        return
      end if

      ! call cct3_grc42c and multc0

      call cct3_grc42c(a,b,c,mvec,ssa,ssb,3,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 2) then

      ! case A(pqrs)*B(rs)=Y(pq)

      ! tests

      if (nindc /= 2) then
        ! RC=24: nindA=4, nindB=2, nindsum=2 (# of index in C is not 2, Stup)
        rc = 24
        return
      end if

      if (typa == 2) then
        ! RC=25: nindA=4, nindB=2, nindsum=2 (typA is 2, Stup)
        rc = 25
        return
      end if

      if (((typa == 3) .or. (typa == 4)) .and. (typb /= 1)) then
        ! RC=26: nindA=4, nindB=2, nindsum=2 (typA incomp. with typB, Stup)
        rc = 26
        return
      end if

      ! call cct3_grc42y and multy0

      call cct3_grc42y(a,b,c,mvec,ssa,ssb,ix)

      call cct3_multy0(wrk,wrksize,mvec,ix,c,1)

    else
      ! RC=27: nindA=4, nindB=2, nindsum=@ (Stup)
      rc = 27
      return
    end if

  else if (nindb == 1) then

    !41 *** nind A =4, B=1

    ! RC=28: nindA=4, nindB=1 (NCI)
    rc = 28
    return

  else

    !4@ *** nind A =4, B=@

    ! RC=29  : nindA=4, nindB=@ (Stup)
    rc = 29
    return
  end if

else if (ninda == 3) then

  ! ****** nind A = 3  ******

  if (nindb == 4) then

    !34 *** nind A =3, B=4

    if (nindsum == 1) then
      ! RC=30: nindA=3, nindB=4, nindsum=1 (too large mediate, NCI)
      rc = 30
      return

    else if (nindsum == 2) then

      ! case A(p,qr)*B(qr,st)=C(p,st)

      ! tests

      if (nindc /= 3) then
        ! RC=31: nindA=3, nindB=4, nindsum=2 (# of ind. in C is not 3, Stup)
        rc = 31
        return
      end if

      if (typa == 1) then
        ! RC=32: nindA=3, nindB=4, nindsum=2 (typA is 1, Stup)
        rc = 32
        return
      end if

      if (typb == 2) then
        ! RC=33: nindA=3, nindB=4, nindsum=2 (typB is 2, Stup)
        rc = 33
        return
      end if

      if (((typb == 1) .or. (typb == 4)) .and. (typa /= 2)) then
        ! RC=34: nindA=3, nindB=4, nindsum=2 (typA incomp. with typB, Stup)
        rc = 34
        return
      end if

      ! call cct3_grc34c and multc0

      call cct3_grc34c(a,b,c,mvec,ssa,ssb,1,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 3) then
      ! RC=35: nindA=3, nindB=4, nindsum=3 (NCI)
      rc = 35
      return
    end if

  else if (nindb == 3) then

    !33 *** nind A =3, B=3

    if (nindsum == 1) then

      ! case A(pq,r)*B(r,st)=A(pq,st)

      ! tests

      if (nindc /= 4) then
        ! RC=36: nindA=3, nindB=3, nindsum=1 (# of ind. in C is not 4, Stup)
        rc = 36
        return
      end if

      if (typa == 2) then
        ! RC=37: nindA=3, nindB=3, nindsum=1 (typA is 2, Stup)
        rc = 37
        return
      end if

      if (typb == 1) then
        ! RC=38: nindA=3, nindB=3, nindsum=1 (typB is 1, Stup)
        rc = 38
        return
      end if

      ! call cct3_grc34c and multc0

      call cct3_grc34c(a,b,c,mvec,ssa,ssb,2,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 2) then

      ! case A(p,qr)*B(rq,s)=C(p,s)

      ! tests

      if (nindc /= 2) then
        ! RC=39: nindA=3, nindB=3, nindsum=2 (# of ind. in C is not 2, Stup)
        rc = 39
        return
      end if

      if (typa == 1) then
        ! RC=40: nindA=3, nindB=3, nindsum=2 (typA is 1, Stup)
        rc = 40
        return
      end if

      if (typb == 2) then
        ! RC=41: nindA=3, nindB=3, nindsum=2 (typB is 2, Stup)
        rc = 41
        return
      end if

      if ((typa == 2) .and. (typb /= 1)) then
        ! RC=42: nindA=3, nindB=3, nindsum=2 (typA incomp. with typB, Stup)
        rc = 42
        return
      end if

      ! call cct3_grc33c and multc0

      call cct3_grc33c(a,b,c,mvec,ssa,ssb,1,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 3) then
      ! RC=43: nindA=3, nindB=3, nindsum=3 (NCI)
      rc = 43
      return
    end if

  else if (nindb == 2) then

    !32 *** nind A =3, B=2

    if (nindsum == 1) then

      ! case A(pq,r)*B(r,s)=C(pq,s)

      ! tests

      if (nindc /= 3) then
        ! RC=44: nindA=3, nindB=2, nindsum=1 (# of ind. in C is not 3, Stup)
        rc = 44
        return
      end if

      if (typa == 2) then
        ! RC=45: nindA=3, nindB=2, nindsum=1 (typA is 2, Stup)
        rc = 45
        return
      end if

      if (typb == 1) then
        ! RC=46: nindA=3, nindB=2, nindsum=1 (typB is 1, Stup)
        rc = 46
        return
      end if

      ! call cct3_grc32c and multc0

      call cct3_grc32c(a,b,c,mvec,ssa,ssb,2,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 2) then

      ! case A(p,qr)*B(qr)=C(p)

      ! tests

      if (nindc /= 1) then
        ! RC=47: nindA=3, nindB=2, nindsum=2 (# of ind. in C is not 1, Stup)
        rc = 47
        return
      end if

      if (typa == 1) then
        ! RC=48: nindA=3, nindB=2, nindsum=2 (typA is 1, Stup)
        rc = 48
        return
      end if

      if ((typb == 1) .and. (typa /= 2)) then
        ! RC=49: nindA=3, nindB=2, nindsum=2 (typA incomp. with typB, Stup)
        rc = 49
        return
      end if

      ! call cct3_grc32y and multy0

      call cct3_grc32y(a,b,c,mvec,ssa,ssb,ix)

      call cct3_multy0(wrk,wrksize,mvec,ix,c,1)

    else
      ! RC=50: nindA=3, nindB=2, nindsum=@ (Stup)
      rc = 50
      return
    end if

  else if (nindb == 1) then

    !31 *** nind A =3, B=1

    ! RC=51: nindA=3, nindB=1 (NCI)
    rc = 51
    return

  else

    !3@ *** nind A =3, B=@

    ! RC=52: nindA=3, nindB=@ (Stup)
    rc = 52
    return
  end if

else if (ninda == 2) then

  ! ****** nind A = 2  ******

  if (nindb == 4) then

    !24 *** nind A =2, B=4

    if (nindsum == 1) then

      ! case A(p,q)*B(q,rst)=C(p,rst)

      ! tests

      if (nindc /= 4) then
        ! RC=53: nindA=2, nindB=4, nindsum=1 (# of ind. in C is not 4, Stup)
        rc = 53
        return
      end if

      if (typa == 1) then
        ! RC=54: nindA=2, nindB=4, nindsum=1 (typA is 1, Stup)
        rc = 54
        return
      end if

      if ((typb == 1) .or. (typb == 4)) then
        ! RC=55: nindA=2, nindB=4, nindsum=1 (typB is 1 or 4, Stup)
        rc = 55
        return
      end if

      ! call cct3_grc24c and multc0

      call cct3_grc24c(a,b,c,mvec,ssa,ssb,1,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 2) then
      ! RC=56: nindA=2, nindB=4, nindsum=2 (NCI)
      rc = 56
      return

    else
      ! RC=57: nindA=2, nindB=4, nindsum=@ (Stup)
      rc = 57
      return
    end if

  else if (nindb == 3) then

    !23 *** nind A =2, B=3

    if (nindsum == 1) then

      ! case A(p,q)*B(q,rs)=C(p,rs)

      ! tests

      if (nindc /= 3) then
        ! RC=58: nindA=2, nindB=3, nindsum=1 (# of ind. in C is not 3, Stup)
        rc = 58
        return
      end if

      if (typa == 1) then
        ! RC=59: nindA=2, nindB=3, nindsum=1 (typA is 1, Stup)
        rc = 59
        return
      end if

      if (typb == 1) then
        ! RC=60: nindA=2, nindB=3, nindsum=1 (typB is 1, Stup)
        rc = 60
        return
      end if

      ! call cct3_grc23c and multc0

      call cct3_grc23c(a,b,c,mvec,ssa,ssb,1,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 2) then
      ! RC=61: nindA=2, nindB=3, nindsum=2 (NCI)
      rc = 61
      return

    else
      ! RC=62: nindA=2, nindB=3, nindsum=@ (Stup)
      rc = 62
      return
    end if

  else if (nindb == 2) then

    !22 *** nind A =2, B=2

    if (nindsum == 1) then

      ! case A(p,q)*B(q,r)=C(p,r)

      ! tests

      if (nindc /= 2) then
        ! RC=63: nindA=2, nindB=2, nindsum=1 (# of ind. in C is not 2, Stup)
        rc = 63
        return
      end if

      if (typa == 1) then
        ! RC=64: nindA=2, nindB=2, nindsum=1 (typA is 1, Stup)
        rc = 64
        return
      end if

      if (typb == 1) then
        ! RC=65: nindA=2, nindB=2, nindsum=1 (typB is 1, Stup)
        rc = 65
        return
      end if

      ! call cct3_grc22c and multc0

      call cct3_grc22c(a,b,c,mvec,ssa,ssb,1,ix)

      call cct3_multc0(wrk,wrksize,mvec,ix,c,1)

    else if (nindsum == 2) then
      ! RC=66: nindA=2, nindB=2, nindsum=2 (NCI)
      rc = 66
      return

    else
      ! RC=67: nindA=2, nindB=2, nindsum=@ (Stup)
      rc = 67
      return
    end if

  else if (nindb == 1) then

    !21 *** nind A =2, B=1

    ! RC=68: nindA=2, nindB=1 (NCI)
    rc = 68
    return

  else

    !2@ *** nind A =2, B=@

    ! RC=69: nindA=2, nindB=@
    rc = 69
    return
  end if

else if (ninda == 1) then

  ! ****** nind A = 1  ******

  !1x RC=70: nind=1 (NCI)
  rc = 70
  return

else

  ! ****** nind A = @  ******

  !@x RC=71: inproper nindA
  rc = 71
  return
end if

return

end subroutine cct3_mult

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
************************************************************************
*                                                                      *
* PER SIEGBAHN                                                         *
* MARGARETA BLOMBERG                                                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY                                  *
* UNIVERSITY OF LUND                                                   *
* SWEDEN                                                               *
*                                                                      *
************************************************************************
      SUBROUTINE CPF(IRETURN)
************************************************************************
*                                                                      *
*                                C P F                                 *
* MODIFIED TO IBM BY ROLAND LINDH 02/17/88                             *
* MODIFIED TO MOLCAS-2 BY ROLAND LINDH 03/26/91                        *
* MODIFIED TO MOLCAS-3 BY M.P. FUELSCHER 08/31/93                      *
* MODIFIED TO MOLCAS-4 BY P.A. MALMQVIST AND N.W.MORTIARTY 10/25/96    *
* MODIFIED TO MOLCAS 4.1 BY R. LINDH 02/24/98 (Multi fileing)          *
************************************************************************
C
C     UNITS USED IN THE PROGRAM
C     UNIT  5 , INPUT
C     UNIT  6 , OUTPUT
C     UNIT 10 , SYMBOLIC FORMULAS
C     UNIT 50 , TRANSFORMED MO 2-EL INTEGRALS
C     UNIT 60 , SORTED AIBJ, ABIJ AND AIJK INTEGRALS
C     UNIT 70 , SORTED IJKL AND ABCI INTEGRALS
C     UNIT 80 , SORTED ABCD INTEGRALS
C     UNIT 17 , ONE ELECTRON INTEGRALS
C     UNIT 19 , (Formatted sequential!) CPF-ORBITALS OUT
C     UNIT 25 , FOCK MATRIX AND DIAGONAL CSF MATRIX ELEMENTS
C     UNIT 26 , CI VECTOR
C     UNIT 27 , SCRATCH IN IIJJ
C     UNIT 30 ,
C
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "files_cpf.fh"
#include "WrkSpc.fh"
*
*     Prologue
*
*     CALL SETTIM
C     CALL HELLO
*
*     (Workspace allocated in Start() )
*
      Call GetMem('WrkSpc','Max ','Real',MemOff,MEMORY)
      MEMORY=INT(MEMORY*0.80D0)
      Call GetMem('WrkSpc','Allo','Real',MemOff,MEMORY)
*
*     Open files
*
      Lu_CIGuga=10
      CALL DANAME(Lu_CIGuga,'CIGUGA')
      Lu_TraInt=50
      CALL DANAME_MF(Lu_TraInt,'TRAINT')
      Lu_TraOne=17
      CALL DANAME(Lu_TraOne,'TRAONE')
      Lu_CI=26
      CALL DANAME(Lu_CI,'CPFVECT')
      Lu_CPFORB=19
C Temporaries:
      Lu_TiABIJ=60
      CALL DANAME_MF(Lu_TiABIJ,'TIABIJ')
      Lu_TiABCI=70
      CALL DANAME_MF(Lu_TiABCI,'TIABCI')
      Lu_TiABCD=80
      CALL DANAME_MF(Lu_TiABCD,'TIABCD')
      Lu_25=25
      CALL DANAME(Lu_25,'FT25F001')
      Lu_27=27
      CALL DANAME(Lu_27,'FT27F001')
      Lu_30=30
      CALL DANAME(Lu_30    ,'FT30F001')
*
*     Body
*
      iMemOff=ip_of_iWork_d(Work(MemOff))
      CALL SDCI_CPF(Work(MemOff),iWork(iMemOff),MEMORY)
*
*     Deallocate the workspace
*
      Call GetMem('WrkSpc','Free','Real',MemOff,MEMORY)
*
*     Epilogue, end
*
*                                                                      *
************************************************************************
*                                                                      *
*     Close open dafiles
*
      CALL DACLOS(Lu_CIGuga)
      CALL DACLOS(Lu_TraInt)
      CALL DACLOS(Lu_TraOne)
      CALL DACLOS(Lu_CI)
      CALL DACLOS(Lu_TiABIJ)
      CALL DACLOS(Lu_TiABCI)
      CALL DACLOS(Lu_TiABCD)
      CALL DACLOS(Lu_25)
      CALL DACLOS(Lu_27)
      CALL DACLOS(Lu_30)
*                                                                      *
************************************************************************
*                                                                      *
      CALL FASTIO('STATUS')
      IRETURN=0
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LnSrch(Energy,q,dq,g,nInter,nIter,dqHdq)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 Energy(nIter),   A(0:4), Projg(2),
     &        q(nInter,nIter), g(nInter,nIter),
     &       dq(nInter,nIter), B(4,0:3), FVal(4)
      Logical RC
*
      iRout=200
      iPrint=nPrint(iRout)
      If (iPrint.ge.99) Then
         Write (6,*) ' Enter LnSrch'
         Write (6,*) 'dqHdq=',dqHdq
         Call RecPrt('LnSrch: Energy',' ', Energy,1,nIter)
         Call RecPrt('LnSrch: q',' ', q,nInter,nIter)
         Call RecPrt('LnSrch:dq',' ',dq,nInter,nIter)
         Call RecPrt('LnSrch: g',' ', g,nInter,nIter)
      End If
*
      Thr=1.0d-12
      A(0)=Zero
*
      iNew=nIter
      iOld=nIter-1
*
*     1) Quartic search, -0.5 <= Xmin <= 0.5
*     2) Cubic search, -1.5 <= Xmin <= 1.5
*     3) E(iNew) is the best, no action
*     4) E(iNew) is not the best,
*        XMin=0.0 between iNew and the Best point
*
*---- Quartic line search
*
      Projg(1)=-DDot_(nInter,q(1,iNew),1,g(1,iOld),1)
     &         +DDot_(nInter,q(1,iOld),1,g(1,iOld),1)
      Projg(2)=-DDot_(nInter,q(1,iNew),1,g(1,iNew),1)
     &         +DDot_(nInter,q(1,iOld),1,g(1,iNew),1)
      A(3)=-(Two*(Energy(iNew)-Energy(iOld))
     &    +(Projg(2)+Projg(1)))
      A(1)= (Energy(iNew)-Energy(iOld))
     &    - (One/Four) * A(3)
*     Write (*,*) ' Projg(1),Projg(2),A(3),A(1)=',
*    &              Projg(1),Projg(2),A(3),A(1)
*
*---- Test the gradient difference
*
      Test1=Projg(2)-Projg(1)
*     Write (*,*) ' Test1=',Test1
      If (Test1.lt.Thr) Then
         If (iPrint.ge.6)
     &      Write (6,*) '-- Line search failed, negative curvature'
         Return
      End If
*
*---- Now check if data is consistent with the condition that
*     the second derivative is zero at the minimum.
*
      Test2=Test1**2-Three*A(3)**2
*     Write (*,*) ' Test2=',Test2
      If (Test2.lt.Zero) Then
         If (iPrint.ge.6)
     &      Write (6,*)
     &       '-- Quartic line search failed, nonzero 2nd derivative'
         Go To 100
      End If
*
      A(2)=(Sqrt(Test2)+Test1)/Four
      If (A(2).lt.Thr) Then
         If (iPrint.ge.6)
     &     Write (6,*)
     &       '-- Quartic line search failed, A(2) too small'
         Go To 100
      End If
*
      A(4)=Half*(Test1-Test2)
      nOrder=4
      XStart=Zero
      XLow=-Half
      XHi = Half
      Go To 500
*
*---- Cubic line search
*
*     Range: -0.5 - 0.5
*
 100  Continue
      If (iPrint.ge.6) Write (6,*) '-- Cubic line search'
      FVal(1)=Energy(iOld)
      FVal(2)=Energy(iNew)
      FVal(3)=Projg(1)
      FVal(4)=Projg(2)
*     B=Zero
      x0=One
      x1=Half
      x2=x1*Half
      x3=x2*Half
      x0g=Zero
      x1g=One
      x2g=Two*x1
      x3g=Three*x2
      Fact=One
      ii=1
      jj=3
      Do i = 1, 2
         Fact=-One*Fact
         B(ii,0)=x0
         B(ii,1)=Fact*x1
         B(ii,2)=x2
         B(ii,3)=Fact*x3
         B(jj,0)=x0g
         B(jj,1)=x1g
         B(jj,2)=Fact*x2g
         B(jj,3)=x3g
         ii = ii + 1
         jj = jj + 1
      End Do
      nOrder=3
*     Call RecPrt('B-Matrix',' ',B,4,4)
*     Call RecPrt('FVal',' ',FVal,4,1)
      Call Gauss(nOrder+1,nOrder+1,B,A,FVal)
*     Call RecPrt('A-Coefficients',' ',A,4,1)
      XStart=Zero
      XLow = -One
      XHi  =  Two+Half
*
 500  Continue
      Call Find_Min(nOrder,XStart,A,XMin,RC,XLow,XHi,ENew)
*     Write (*,*) 'ENew=',ENew
      If (.Not.RC) Then
*        Write (*,*) 'RC=.False.'
         Return
      End If
      If (Test2.lt.Zero) Then
         dqHdq=ENew-Energy(nIter)
      Else
         dqHdq=ENew
      End If
      XMin=XMin+Half
      If (iPrint.ge.6) Write (6,*) 'Minimum found at -->',XMin,'<--'
*                                                                      *
************************************************************************
*                                                                      *
*---- Update vectors in accordance with the result
*
*.... Compute the displacement iOld -> iNew
*
      call dcopy_(nInter,          q(1,iNew  ),1,dq(1,iNew-1),1)
      Call DaXpY_(nInter,-One,     q(1,iOld  ),1,dq(1,iNew-1),1)
      Call DScal_(nInter,XMin,    dq(1,iNew-1),1)
      dqdq=DDot_(nInter,          dq(1,iNew-1),1,dq(1,iNew-1),1)
*
*.... Compute the new q
*
      call dcopy_(nInter,          q(1,iOld  ),1, q(1,iNew  ),1)
      Call DaXpY_(nInter,One,     dq(1,iNew-1),1, q(1,iNew  ),1)
*
*.... Update the gradient
*
      Call DScal_(nInter,XMin,     g(1,iNew  ),1)
      Call DaXpY_(nInter,One-XMin, g(1,iOld  ),1, g(1,iNew  ),1)
      gdq=-DDot_(nInter,           g(1,iNew  ),1,dq(1,iNew-1),1)
      Call DaXpY_(nInter,gdq/dqdq,dq(1,iNew-1),1, g(1,iNew  ),1)
*
*.... Update the displacement nIter-1 -> nIter
*
      call dcopy_(nInter,          q(1,iNew  ),1,dq(1,iNew-1),1)
      Call DaXpY_(nInter,-One,     q(1,iNew-1),1,dq(1,iNew-1),1)
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.99) Then
         Call RecPrt('LnSrch: q',' ', q,nInter,nIter)
         Call RecPrt('LnSrch:dq',' ',dq,nInter,nIter)
         Call RecPrt('LnSrch: g',' ', g,nInter,nIter)
         Write (6,*) ' Exit LnSrch'
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RSMXMN_MCLR(MAXEL,MINEL,NORB1,NORB2,NORB3,NEL,MIN_1,MAX_1,MIN_3,MAX_3)
! Construct accumulated MAX and MIN arrays for a RAS set of strings

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NORB1, NORB2, NORB3, NEL, MIN_1, MAX_1, MIN_3, MAX_3
integer(kind=iwp), intent(out) :: MAXEL(NORB1+NORB2+NORB3), MINEL(NORB1+NORB2+NORB3)
integer(kind=iwp) :: IORB, MAX1A, MAX2A, MAX3A, MIN1A, MIN2A, MIN3A, NORB

! accumulated max and min in each of the three spaces
! (required max and min at final orbital in each space)
MIN1A = MIN_1
MAX1A = MAX_1

MIN2A = NEL-MAX_3
MAX2A = NEL-MIN_3

MIN3A = NEL
MAX3A = NEL

NORB = NORB1+NORB2+NORB3
do IORB=1,NORB
  if (IORB <= NORB1) then
    MINEL(IORB) = max(MIN1A+IORB-NORB1,0)
    MAXEL(IORB) = min(IORB,MAX1A)
  else if ((NORB1 < IORB) .and. (IORB <= (NORB1+NORB2))) then
    MINEL(IORB) = max(MIN2A+IORB-NORB1-NORB2,0)
    if (NORB1 > 0) MINEL(IORB) = max(MINEL(IORB),MINEL(NORB1))
    MAXEL(IORB) = min(IORB,MAX2A)
  else if (IORB > NORB1+NORB2) then
    MINEL(IORB) = max(MIN3A+IORB-NORB,0)
    if (NORB1+NORB2 > 0) MINEL(IORB) = max(MINEL(IORB),MINEL(NORB1+NORB2))
    MAXEL(IORB) = min(IORB,MAX3A)
  end if
end do

return

end subroutine RSMXMN_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DWDER(OMGDER,HEFF,SLag)
! Computes the derivative of weight factor in XDW-CASPT2

use caspt2_module, only: DWTYPE, NSTATE, ZETA
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: OMGDER(nState,nState), HEFF(nState,nState)
real(kind=wp), intent(inout) :: SLag(nState,nState)
integer(kind=iwp) :: ilStat, jlStat, klStat
real(kind=wp) :: Dag, Dbg, DERAB, DERAC, DEROMG, Ealpha, Ebeta, Egamma, Factor, Hag, Hbg, Scal

do ilStat=1,nState
  Ebeta = HEFF(ilStat,ilStat)
  do jlStat=1,nState
    Ealpha = HEFF(jlStat,jlStat)

    Factor = Zero
    do klStat=1,nState
      Egamma = HEFF(klStat,klStat)
      if (DWType == 1) then
        Factor = Factor+exp(-zeta*(Ealpha-Egamma)**2)
      else if (DWType == 2) then
        Factor = Factor+exp(-zeta*(Ealpha/HEFF(jlStat,klStat))**2)
      else if (DWType == 3) then
        Dag = abs(Ealpha-Egamma)+1.0e-9_wp
        Hag = abs(HEFF(jlStat,klStat))
        Factor = Factor+exp(-zeta*Dag/(sqrt(Hag)+tiny(Hag)))
      end if
    end do

    DEROMG = OMGDER(ilStat,jlStat)

    !! derivative of alpha-beta
    if (DWType == 1) then
      DERAB = exp(-ZETA*(Ealpha-Ebeta)**2)/Factor
      Scal = -Two*ZETA*DERAB*(Ealpha-Ebeta)*DEROMG
      SLag(jlStat,jlStat) = SLag(jlStat,jlStat)+Scal
      SLag(ilStat,ilStat) = SLag(ilStat,ilStat)-Scal
    else if (DWType == 2) then
      DERAB = exp(-ZETA*(Ealpha/HEFF(jlStat,ilStat))**2)/Factor
      DERAB = DERAB*Two*DEROMG*ZETA*(Ealpha/HEFF(jlStat,ilStat))**2
      Scal = -DERAB/Ealpha
      SLag(jlStat,jlStat) = SLag(jlStat,jlStat)+Scal
      Scal = +DERAB/HEFF(jlStat,ilStat)
      SLag(jlStat,ilStat) = SLag(jlStat,ilStat)+Scal
    else if (DWType == 3) then
      Dag = abs(Ealpha-Ebeta)+1.0e-9_wp
      Hag = abs(HEFF(jlStat,ilStat))
      DERAB = exp(-ZETA*Dag/(sqrt(Hag)+tiny(Hag)))/Factor
      DERAB = -ZETA*DERAB*Dag/(sqrt(Hag)+tiny(Hag))*DEROMG
      Scal = DERAB/Dag
      if (Ealpha-Ebeta <= Zero) Scal = -Scal
      SLag(jlStat,jlStat) = SLag(jlStat,jlStat)+Scal
      SLag(ilStat,ilStat) = SLag(ilStat,ilStat)-Scal
      Scal = -DERAB/(sqrt(Hag)+tiny(Hag))/sqrt(Hag)*Half
      if (HEFF(jlStat,ilStat) <= Zero) Scal = -Scal
      SLag(jlStat,ilStat) = SLag(jlStat,ilStat)+Scal
    end if

    !! derivative of alpha-gamma
    do klStat=1,nState
      Egamma = HEFF(klStat,klStat)
      if (DWtype == 1) then
        DERAC = exp(-ZETA*(Ealpha-Ebeta)**2)/(Factor*Factor)*exp(-ZETA*(Ealpha-Egamma)**2)
        Scal = Two*ZETA*DERAC*(Ealpha-Egamma)*DEROMG
        SLag(jlStat,jlStat) = SLag(jlStat,jlStat)+Scal
        SLag(klStat,klStat) = SLag(klStat,klStat)-Scal
      else if (DWType == 2) then
        DERAC = exp(-ZETA*(Ealpha/HEFF(jlStat,klStat))**2)/Factor*exp(-ZETA*(Ealpha/HEFF(jlStat,ilStat))**2)/Factor
        DERAC = -DERAC*Two*DEROMG*ZETA*(Ealpha/HEFF(jlStat,klStat))**2
        Scal = -DERAC/Ealpha
        SLag(jlStat,jlStat) = SLag(jlStat,jlStat)+Scal
        Scal = +DERAC/HEFF(jlStat,klStat)
        SLag(jlStat,klStat) = SLag(jlStat,klStat)+Scal
      else if (DWType == 3) then
        Dbg = abs(Ealpha-Egamma)+1.0e-9_wp
        Hbg = abs(HEFF(jlStat,klStat))
        DERAC = exp(-ZETA*Dag/(sqrt(Hag)+tiny(Hag)))/Factor*exp(-ZETA*Dbg/(sqrt(Hbg)+tiny(Hbg)))/Factor
        DERAC = ZETA*DERAC*Dbg/(sqrt(Hbg)+tiny(Hbg))*DEROMG
        Scal = DERAC/Dbg
        if (Ealpha-Egamma <= Zero) Scal = -Scal
        SLag(jlStat,jlStat) = SLag(jlStat,jlStat)+Scal
        SLag(klStat,klStat) = SLag(klStat,klStat)-Scal
        Scal = -DERAC/(sqrt(Hbg)+tiny(Hbg))/sqrt(Hbg)*Half
        if (HEFF(jlStat,klStat) <= Zero) Scal = -Scal
        SLag(jlStat,klStat) = SLag(jlStat,klStat)+Scal
      end if
    end do
  end do
end do

return

end subroutine DWDER

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine ChoMP2_Energy_GetInd(LnT2am,LiT2am,iBatch,jBatch)
C
C     Thomas Bondo Pedersen, Dec. 2004 / Feb. 2005.
C
C     Purpose: setup (ai|bj) index arrays for batch i,j.
C              For iBatch=jBatch and ChoAlg=2, (ai|bj) is stored as
C              the matrix M(ab,ij) with i<=j.
C
      Implicit None
      Integer LnT2am, iBatch, jBatch
      Integer LiT2am(8)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"

      Integer iSym
      Integer LnT1am, LnMatij, i, j

      Character*14 String
      Character*20 SecNam
      Parameter (SecNam = 'ChoMP2_Energy_GetInd')

      LnT1am(i,j)=iWork(ip_LnT1am-1+nSym*(j-1)+i)
      LnMatij(i,j)=iWork(ip_LnMatij-1+nSym*(j-1)+i)

      If (iBatch .eq. jBatch) Then
         LnT2am = 0
         If (ChoAlg .eq. 1) Then
            Do iSym = 1,nSym
               LiT2am(iSym) = LnT2am
               LnT2am = LnT2am
     &                + LnT1am(iSym,iBatch)*(LnT1am(iSym,iBatch)+1)/2
            End Do
         Else If (ChoAlg .eq. 2) Then
            Do iSym = 1,nSym
               LiT2am(iSym) = LnT2am
               LnT2am = LnT2am
     &                + nMatab(iSym)*LnMatij(iSym,iBatch)
            End Do
         Else
            Write(String,'(A8,I6)') 'ChoAlg =',ChoAlg
            Call ChoMP2_Quit(SecNam,'ChoAlg out-of-bounds error!',
     &                       String)
         End If
      Else
         LnT2am = 0
         Do iSym = 1,nSym
            LiT2am(iSym) = LnT2am
            LnT2am = LnT2am + LnT1am(iSym,iBatch)*LnT1am(iSym,jBatch)
         End Do
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C  THIS ROUTINE PERFORMS A SPLINE FIT TO A SET OF POINTS (XFIT,YFIT).  C
C  IT INTERPOLATES A SET OF POINTS (XINT,YINT), AND LOCATES ALL        C
C  EXTREME VALUES (XEXT,YEXT) AND DETERMINES THE TYPE (IEXT).          C
C  VARIOUS TYPES OF BOUNDARY CONDITIONS CAN BE CHOOSEN (IBOUND),       C
C  AT PRESENT IBOUND=1 AND 2 ARE IMPLEMENTED.                          C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE SPLINE(XFIT,YFIT,NFIT,XINT,YINT,NINT,XEXT,YEXT,IEXT,
     *   NEXT,IBOUND)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
      Parameter (ndim=5000)
C NFIT, NINT ARE INPUT ONLY
      DIMENSION XFIT(NFIT),YFIT(NFIT),XINT(NINT),YINT(NINT)
C NEXT IS INPUT (DIMENSION BOUND) AND OUTPUT (NR OF EXTREMA).
      DIMENSION XEXT(NEXT),YEXT(NEXT),IEXT(NEXT),T0(2)
C      CHARACTER*12 TEXT(3)
      DATA ZERO,ONE,TWO,THREE/0.0D0,1.0D0,2.0D0,3.0D0/
C      DATA TEXT/'MAX. POINT','SADDLE POINT','MIN. POINT'/
      IF(NFIT.GT.NDIM) Then
        Write(6,*)'SPLINE Error: NFIT.gt.NDIM.'
        Write(6,'(1x,a,2I8)')'NFIT,NDIM:',NFIT,NDIM
        Call Abend
      End If
      NOS=NFIT-1
      Call GetMem('MatA','Allo','Real',indexA,nfit*nfit)
      Call GetMem('VecH','Allo','Real',indexH,ndim)
      Call GetMem('VecD','Allo','Real',indexD,ndim)
      Call GetMem('VecC','Allo','Real',indexC,ndim)
      Call GetMem('VecB','Allo','Real',indexB,ndim)
      DO 10 I=0,nfit*nfit-1
         Work(indexA+I)=ZERO
10    CONTINUE
      DO 20 I=1,NOS
         Work(indexH+I-1)=XFIT(I+1)-XFIT(I)
         Work(indexD+I-1)=(YFIT(I+1)-YFIT(I))/Work(indexH+I-1)
20    CONTINUE
      if(IBOUND.eq.1) goto 100
      if(IBOUND.eq.2) goto 200
      Write(6,*)'SPLINE Error: IBOUND should be 1 or 2.'
      Write(6,'(1x,a,2I8)')'But IBOUND=',IBOUND
      Call Abend
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C  IBOUND=1:                                                           C
C  BOTH END POINTS ARE EXTRAPOLATED WITH STRAIGHT LINES.               C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
100   CONTINUE
      Work(indexA)=TWO*Work(indexH)
      Work(indexA+nfit)=Work(indexH)
      Work(indexB)=THREE*Work(indexH)*Work(indexD)
      Work(indexA+nfit*nfit-nfit-1)=Work(indexH+NOS-1)
      Work(indexA+nfit*nfit-1)=TWO*Work(indexH+NOS-1)
      Work(indexB+nfit-1)=THREE*Work(indexH+NOS-1)*Work(indexD+NOS-1)
      DO 110 I=2,NOS
         Work(indexA+(I-2)*nfit+I-1)=Work(indexH+I-1)
         Work(indexA+(I-1)*nfit+I-1)=
     *       TWO*(Work(indexH+I-1)+Work(indexH+I-2))
         Work(indexA+I*nfit+I-1)=Work(indexH+I-2)
         Work(indexB+I-1)=THREE*(Work(indexH+I-2)*Work(indexD+I-1)+
     *        Work(indexH+I-1)*Work(indexD+I-2))
110   CONTINUE
      Call Dminv(nfit,nfit,Work(indexA))
      DO 120 I=1,NFIT
         SUM=ZERO
         DO 121 J=1,NFIT
            SUM=SUM+Work(indexA+(J-1)*nfit+I-1)*Work(indexB+J-1)
121      CONTINUE
         Work(indexC+I-1)=SUM
120   CONTINUE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C  PERFORM INTERPOLATION (EXTRAPOLATION).                              C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      DO 130 IP=1,NINT
         IF(XINT(IP).LT.XFIT(1)) THEN
            YINT(IP)=YFIT(1)+Work(indexC)*(XINT(IP)-XFIT(1))
         ELSE IF(XINT(IP).GT.XFIT(NFIT)) THEN
            YINT(IP)=YFIT(NFIT)+
     *               Work(indexC+nfit-1)*(XINT(IP)-XFIT(NFIT))
         ELSE
            NS=1
131         IF(XINT(IP).GT.XFIT(NS+1)) THEN
               NS=NS+1
               GOTO 131
            END IF
            T=(XINT(IP)-XFIT(NS))/Work(indexH+NS-1)
            T1=ONE-T
            YINT(IP)=T*YFIT(NS+1)+T1*YFIT(NS)+
     *         Work(indexH+NS-1)*T*T1*
     *         (T1*(Work(indexC+NS-1)-Work(indexD+NS-1))-
     *         T*(Work(indexC+NS)-Work(indexD+NS-1)))
         END IF
130   CONTINUE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C  LOCATE ALL EXTREMUM POINTS.                                         C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      NEXT=0
      DO 150 NS=1,NOS
         A2=THREE*(Work(indexC+NS-1)+Work(indexC+NS)-
     *      TWO*Work(indexD+NS-1))
         A1=TWO*(THREE*Work(indexD+NS-1)-
     *      TWO*Work(indexC+NS-1)-Work(indexC+NS))
         A0=Work(indexC+NS-1)
         B1=TWO*A2
         B0=A1
         IF(abs(A2).GT.(abs(A1)+abs(A0))*1.0D-3) THEN
***** A2 LARGE *****
            P=-A1/A2/TWO
            Q=A0/A2
            S=P*P-Q
            IF(abs(S).LT.1.0D-10) THEN
***** DOUBLE ROOT *****
               IT=2
               T=P
               IF(T.GE.ZERO.AND.T.LE.ONE) THEN
                  X=XFIT(NS)+T*Work(indexH+NS-1)
                  Y=YFIT(NS)+Work(indexH+NS-1)*
     *              T*(A0+T*(A1/TWO+T*A2/THREE))
C                 WRITE(6,2001) TEXT(IT),X,Y
C2001  FORMAT(1X,A,'  X=',E12.5,' ,  Y=',E12.5)
                  NEXT=NEXT+1
                  XEXT(NEXT)=X
                  YEXT(NEXT)=Y
                  IEXT(NEXT)=IT
               END IF
            ELSE IF(S.GT.ZERO) THEN
***** TWO ROOTS *****
               T0(1)=P+sqrt(S)
               T0(2)=P-sqrt(S)
               DO 151 I=1,2
                  T=T0(I)
                  IF(T.GE.ZERO.AND.T.LE.ONE) THEN
                     SE=B0+T*B1
                     X=XFIT(NS)+T*Work(indexH+NS-1)
                     Y=YFIT(NS)+
     *                 Work(indexH+NS-1)*T*(A0+T*(A1/TWO+T*A2/THREE))
                     IT=1
                     IF(SE.GT.ZERO) IT=3
C                    WRITE(6,2001) TEXT(IT),X,Y
                     NEXT=NEXT+1
                     XEXT(NEXT)=X
                     YEXT(NEXT)=Y
                     IEXT(NEXT)=IT
                  END IF
151            CONTINUE
            END IF
         ELSE IF(abs(A1).GE.0.9D0*abs(A0)) THEN
***** A2 SMALL *****
            T=-A0/A1
            T=-(A0+A2*T*T)/A1
            T=-(A0+A2*T*T)/A1
            T=-(A0+A2*T*T)/A1
            IF(T.GE.ZERO.AND.T.LE.ONE) THEN
               IT=1
               IF(B0.GT.ZERO) IT=3
               X=XFIT(NS)+T*Work(indexH+NS-1)
               Y=YFIT(NS)+work(indexH+NS-1)*T*(A0+T*(A1/TWO+T*A2/THREE))
C              WRITE(6,2001) TEXT(IT),X,Y
               NEXT=NEXT+1
               XEXT(NEXT)=X
               YEXT(NEXT)=Y
               IEXT(NEXT)=IT
            END IF
         END IF
150   CONTINUE
      Call GetMem('MatA','Free','Real',indexA,nfit*nfit)
      Call GetMem('VecH','Free','Real',indexH,ndim)
      Call GetMem('VecD','Free','Real',indexD,ndim)
      Call GetMem('VecC','Free','Real',indexC,ndim)
      Call GetMem('VecB','Free','Real',indexB,ndim)
      RETURN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C  IBOUND=2:                                                           C
C  EXTRAPOLATION TO PLUS INFINITY IS DONE WITH A STRAIGHT              C
C  HORIZONTAL LINE.                                                    C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
200   CONTINUE
#if 0
!IFG IBOUND=2 implemented, but never used
      Work(indexA+nfit*nfit-1)=ONE
      Work(indexB+nfit-1)=ZERO
      Work(indexA+(NOS-1)*nfit+NOS-1)=TWO
      Work(indexA+(nfit-1)*nfit+NOS-1)=ONE
      Work(indexB+NOS-1)=THREE*Work(indexD+NOS-1)
      DO 210 I=2,NOS
         Work(indexA+(I-2)*nfit+I-2)=Work(indexH+I-1)
         Work(indexA+(I-1)*nfit+I-2)=
     *       TWO*(Work(indexH+I-1)+Work(indexH+I-2))
         Work(indexA+I*nfit+I-2)=Work(indexH+I-2)
         Work(indexB+I-2)=THREE*(Work(indexH+I-2)*Work(indexD+I-1)+
     *          Work(indexH+I-1)*Work(indexD+I-2))
210   CONTINUE
      Call Dminv(nfit,nfit,Work(indexA))
      DO 220 I=1,NFIT
         SUM=ZERO
         DO 221 J=1,NFIT
            SUM=SUM+Work(indexA+(J-1)*nfit+I-1)*Work(indexB+J-1)
221      CONTINUE
         Work(indexC+I-1)=SUM
220   CONTINUE
      S1=Work(indexC)
      S2=(Work(indexC)+TWO*Work(indexC+1)-
     *   THREE*Work(indexD))/Work(indexH)
      C2=-S2/S1
      C1=S2/C2/C2/EXP(-C2*XFIT(1))
      C0=YFIT(1)-C1*EXP(-C2*XFIT(1))
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C  PERFORM INTERPOLATION (EXTRAPOLATION).                              C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      DO 230 IP=1,NINT
         IF(XINT(IP).LT.XFIT(1)) THEN
            YINT(IP)=C0+C1*EXP(-C2*XINT(IP))
         ELSE IF(XINT(IP).GT.XFIT(NFIT)) THEN
            YINT(IP)=YFIT(NFIT)+
     *               Work(indexC+nfit-1)*(XINT(IP)-XFIT(NFIT))
         ELSE
            NS=1
231         IF(XINT(IP).GT.XFIT(NS+1)) THEN
               NS=NS+1
               GOTO 231
            END IF
            T=(XINT(IP)-XFIT(NS))/Work(indexH+NS-1)
            T1=ONE-T
            YINT(IP)=T*YFIT(NS+1)+T1*YFIT(NS)+
     *         Work(indexH+NS-1)*T*T1*
     *         (T1*(Work(indexC+NS-1)-Work(indexD+NS-1))-
     *         T*(Work(indexC+NS)-Work(indexD+NS-1)))
         END IF
230   CONTINUE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C  LOCATE ALL EXTREMUM POINTS.                                         C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      NEXT=0
      DO 250 NS=1,NOS
         A2=THREE*(Work(indexC+NS-1)+Work(indexC+NS)-
     *      TWO*Work(indexD+NS-1))
         A1=TWO*(THREE*Work(indexD+NS-1)-
     *      TWO*Work(indexC+NS-1)-Work(indexC+NS))
         A0=Work(indexC+NS-1)
         B1=TWO*A2
         B0=A1
         IF(abs(A2).GT.(abs(A1)+abs(A0))*1.0D-3) THEN
***** A2 LARGE *****
            P=-A1/A2/TWO
            Q=A0/A2
            S=P*P-Q
            IF(abs(S).LT.1.0D-10) THEN
***** DOUBLE ROOT *****
               IT=2
               T=P
               IF(T.GE.ZERO.AND.T.LE.ONE) THEN
                  X=XFIT(NS)+T*Work(indexH+NS-1)
                  Y=YFIT(NS)+
     *              Work(indexH+NS-1)*T*(A0+T*(A1/TWO+T*A2/THREE))
C                 WRITE(6,2001) TEXT(IT),X,Y
                  NEXT=NEXT+1
                  XEXT(NEXT)=X
                  YEXT(NEXT)=Y
                  IEXT(NEXT)=IT
               END IF
            ELSE IF(S.GT.ZERO) THEN
***** TWO ROOTS *****
               T0(1)=P+sqrt(S)
               T0(2)=P-sqrt(S)
               DO 251 I=1,2
                  T=T0(I)
                  IF(T.GE.ZERO.AND.T.LE.ONE) THEN
                     SE=B0+T*B1
                     X=XFIT(NS)+T*Work(indexH+NS-1)
                     Y=YFIT(NS)+
     *                 Work(indexH+NS-1)*T*(A0+T*(A1/TWO+T*A2/THREE))
                     IT=1
                     IF(SE.GT.ZERO) IT=3
C                    WRITE(6,2001) TEXT(IT),X,Y
                     NEXT=NEXT+1
                     XEXT(NEXT)=X
                     YEXT(NEXT)=Y
                     IEXT(NEXT)=IT
                  END IF
251            CONTINUE
            END IF
         ELSE IF(abs(A1).GE.0.9D0*abs(A0)) THEN
***** A2 SMALL *****
            T=-A0/A1
            T=-(A0+A2*T*T)/A1
            T=-(A0+A2*T*T)/A1
            T=-(A0+A2*T*T)/A1
            IF(T.GE.ZERO.AND.T.LE.ONE) THEN
               IT=1
               IF(B0.GT.ZERO) IT=3
               X=XFIT(NS)+T*Work(indexH+NS-1)
               Y=YFIT(NS)+Work(indexH+NS-1)*T*(A0+T*(A1/TWO+T*A2/THREE))
C              WRITE(6,2001) TEXT(IT),X,Y
               NEXT=NEXT+1
               XEXT(NEXT)=X
               YEXT(NEXT)=Y
               IEXT(NEXT)=IT
            END IF
         END IF
250   CONTINUE
      Call GetMem('MatA','Free','Real',indexA,nfit*nfit)
      Call GetMem('VecH','Free','Real',indexH,ndim)
      Call GetMem('VecD','Free','Real',indexD,ndim)
      Call GetMem('VecC','Free','Real',indexC,ndim)
      Call GetMem('VecB','Free','Real',indexB,ndim)
      RETURN
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OffAtom(C1,C2,C3,C4,C5)

use Constants, only: Angstrom, deg2rad
use Constants, only: Half
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: C1(3), C2(3), C3(3)
real(kind=wp), intent(out) :: C4(3), C5(3)
real(kind=wp) :: D(3), E(3), LD, LE, U(3), V(3)
real(kind=wp), parameter :: R = 0.2767_wp/Angstrom, Theta = 36.72_wp*deg2rad

D(:) = (C2+C3)*Half-C1
LD = sqrt(D(1)**2+D(2)**2+D(3)**2)
D(:) = D/LD

U(:) = C2-C1
V(:) = C3-C1
E(1) = U(2)*V(3)-V(2)*U(3)
E(2) = U(3)*V(1)-V(3)*U(1)
E(3) = U(1)*V(2)-V(1)*U(2)
LE = sqrt(E(1)**2+E(2)**2+E(3)**2)
E(:) = E/LE

C4(:) = C1+R*(cos(Theta)*D+sin(Theta)*E)
C5(:) = C1+R*(cos(Theta)*D-sin(Theta)*E)

return

end subroutine OffAtom

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      real*8 function edirac (n,j,Z,c)
c
c*************************************************************************
c
c   This SR belongs to the test suite 'parser2'
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*************************************************************************
c
      implicit none
c
      real*8 n,j,Z,c
c
      edirac = 0.0d0
      edirac = (Z/c) * 1.d0/(n-(j+0.5d0) +
     *                   sqrt((j+0.5d0)*(j+0.5d0)-(Z*Z)/(c*c)))
      edirac = c*c / sqrt(1.d0+edirac*edirac)
      edirac = edirac - c*c
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Stefano Battaglia                                *
************************************************************************

* Load the CI vector of state Istate from LUCIEX into memory
      subroutine loadCI(CI, Istate)
      implicit real(8) (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
      real(8) CI(Nconf)
      integer ID, Istate

* Skip over states
      ID=IDCIEX
      do I=1,Istate-1
        call ddafile(LUCIEX,0,CI,Nconf,ID)
      end do

* Load the CI array
      call ddafile(LUCIEX,2,CI,Nconf,ID)

      return
      end


************************************************************************


* write the CI vector of state Istate from memory into LUCIEX
      subroutine writeCI(CI, Istate)
      implicit real(8) (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
      real(8) CI(Nconf)
      integer ID, Istate

* Skip over states
      ID=IDCIEX
      do I=1,Istate-1
        call ddafile(LUCIEX,0,CI,Nconf,ID)
      end do

* Write the CI array
      call ddafile(LUCIEX,1,CI,Nconf,ID)

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CREIPH
C
C     RASSCF program: version IBM 3090: input section
C
C     Purpose: to set up an result file (JOBIPH = 15) where the most
C              important results of the calculation are collected as
C              an interphase to other programs. JOBIPH is a direct
C              acces file where the first record is a table of content.
C              The address to this record is zero. The table of content
C              has presently the length 15 and is stored in
C              COMMON/INTAUX/ as IADR15(15).
C     Subsections of JOBIPH:
C     IADR15(1):  List of input data written here with WR_RASSCF_Info
C     IADR15(2):  Molecular orbitals first written here and then updated
C                 at the end of SXCTL in each MCSCF itration.
C                 To be used as starting orbitals for restarts|
C                 Modified finally by NEWORB to pseudo-nat orbitals
C                 Average occupation numbers appended.
C     IADR15(3):  density matrices for active orbitals
C                 (4 matrices per root)
C                 D  : one-body density matrix
C                 DS : spin density matrix
C                 P  : symmetric two-body density matrix
C                 PA : antsymmetric two-body density matrix
C     IADR15(4):  The CI-vectors corresponding to the LROOTS lowest
C                 roots written in CICTL after each iteration.
C     IADR15(5):  The Fock matrix for the occupied orbitals.
C                 written in FOCKOC at the end of the calculation.
C     IADR15(6):  Energies given in array ENER(10,50) in COMMON/RELAUX/.
C     IADR15(7):  Convergence parameters in array CONV(6,50) in RELAUX.
C     IADR15(8):  Not used
C     IADR15(9):  Canonical MO's constructed and written in FCKPT2 at
C                 the end of the calculation.
C     IADR15(10): Inactive Fock matrix for CASPT2 in MO basis
C                 Note: Frozen and deleted orbitals not included,
C                 Modified to include the CASPT2 matrix FP 900608 (BOR)
C     IADR15(11): The diagonal of the CASPT Fock matrix.
C     IADR15(12): Natural orbitals for the final wave functions.
C                 Note: These orbitals do not correspond to the same
C                 CI wave function and should only be used to compute
C                 properties.
C                 One set of orbitals is stored for each root.
C                 Each set of NO's is followed by a record
C                 containing the corresponding occupation numbers.
C     IADR15(13): One-body spin density matrices (one for each root)
C     IADR15(14): Spin orbitals for the final wave functions.
C                 Note: These orbitals do not correspond to the same
C                 CI wave function and should only be used to compute
C                 spin properties.
C                 One set of orbitals for each root in an average
C                 calculation. Stored sequentially (891219).
C                 Each set of NO's is followed by a record
C                 containing the corresponding occupation numbers.
C     IADR15(15): First unwritten disk address, if positive;
C                 If = -1, it means a new JOBIPH structure is used,
C                 same as before, except:
C     IADR15(16): First unwritten disk address (new layout),
C     IADR15(17): Effective Hamiltonian, written here by MS-CASPT2,
C                 LROOTS**2 elements, Fortran standard layout.
C     IADR15(18): Table that translates between levels and absolute
C                 orbital indices, setup by setsxci.
C     IADR15(19)--IADR15(30): Presently unused.
C     ********** IBM 3090 MOLCAS Release 90 02 22 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "WrkSpc.fh"
#include "general.fh"
#include "sxci.fh"
      Dimension Dum(1)


      DO I=1,15
       IADR15(I)=0
      END DO
C Dummy write table of contents.
C New layout scheme; length is 30 integers.
      IAD15=0
      CALL IDAFILE(JOBIPH,1,IADR15,30,IAD15)
      IADR15(1)=IAD15
C
C     DUMMY WRITE THE REMAINING RECORDS TO OBTAIN ADDRESSES
C
      CALL WR_RASSCF_Info(JOBIPH,1,iAD15,NACTEL,ISPIN,NSYM,STSYM,
     &            NFRO,NISH,NASH,NDEL,NBAS,MxSym,
     &            NAME,LENIN8*mxOrb,NCONF,HEADER,144,
     &            TITLE,4*18*mxTit,POTNUC,LROOTS,NROOTS,
     &            IROOT,MxRoot,NRS1,NRS2,NRS3,
     &            NHOLE1,NELEC3,IPT2,WEIGHT)
      IADR15(2)=IAD15
C
      CALL DDAFILE(JOBIPH,0,DUM,NTOT2,IAD15)
      CALL DDAFILE(JOBIPH,0,DUM,NTOT,IAD15)
      IADR15(3)=IAD15
      Do i = 1,lRoots
        Call DDafIle(JOBIPH,0,Dum,NACPAR,IAD15)
        Call DDafIle(JOBIPH,0,Dum,NACPAR,IAD15)
        Call DDafIle(JOBIPH,0,Dum,NACPR2,IAD15)
        Call DDafIle(JOBIPH,0,Dum,NACPR2,IAD15)
      End Do
      IADR15(4)=IAD15
      Do i = 1,lRoots
        Call DDafIle(JOBIPH,0,Dum,nConf,IAD15)
      End Do
      IADR15(5)=IAD15
      NFOCK=0
      DO ISYM=1,NSYM
       NOO=NISH(ISYM)+NASH(ISYM)
       NFOCK=NFOCK+NOO**2
      END DO
      CALL DDAFILE(JOBIPH,0,DUM,NFOCK,IAD15)
      IADR15(6)=IAD15
      CALL DDAFILE(JOBIPH,0,DUM,mxRoot*mxIter,IAD15)
      IADR15(7)=IAD15
      CALL DDAFILE(JOBIPH,0,DUM,6*mxIter,IAD15)
      IADR15(8)=IAD15
      IADR15(9)=IAD15
      CALL DDAFILE(JOBIPH,0,DUM,NTOT2,IAD15)
      IADR15(10)=IAD15
      CALL DDAFILE(JOBIPH,0,DUM,NTOT3,IAD15)
      CALL DDAFILE(JOBIPH,0,DUM,NTOT3,IAD15)
      IADR15(11)=IAD15
      CALL DDAFILE(JOBIPH,0,DUM,NORBT,IAD15)
      IADR15(12)=IAD15
      Do i = 1,lRoots
        CALL DDAFILE(JOBIPH,0,DUM,NTOT2,IAD15)
        CALL DDAFILE(JOBIPH,0,DUM,NTOT,IAD15)
      End Do
      IADR15(13)=IAD15
      IADR15(14)=IAD15
      Do i=1,lroots
        CALL DDAFILE(JOBIPH,0,DUM,NTOT2,IAD15)
        CALL DDAFILE(JOBIPH,0,DUM,NTOT,IAD15)
      End Do
C New layout scheme:
      IADR15(15)=-1
      CALL GETMEM('HEFF','ALLO','REAL',LHEFF,LROOTS**2)
      DO J=1,LROOTS
       DO I=1,LROOTS
        WORK(LHEFF-1+I+LROOTS*(J-1))=0.0D0
       END DO
       WORK(LHEFF-1+J+LROOTS*(J-1))=1.0D12
      END DO
      IADR15(17)=IAD15
      CALL DDAFILE(JOBIPH,1,WORK(LHEFF),LROOTS**2,IAD15)
      CALL GETMEM('HEFF','FREE','REAL',LHEFF,LROOTS**2)
      IADR15(18)=IAD15
CSVC: translates levels to orbital index (L2ACT in caspt2)
      CALL IDAFILE(JOBIPH,1,IDXSX,mxAct,IAD15)
CSVC: translates orbital index to levels (LEVEL in caspt2)
      CALL IDAFILE(JOBIPH,1,IDXCI,mxAct,IAD15)
      DO I=19,30
       IADR15(I)=0
      END DO
C First unused disk address at IADR(16):
      IADR15(16)=IAD15
C
C     Write table of content: IADR15
C
      IAD15=0
      CALL IDAFILE(JOBIPH,1,IADR15,30,IAD15)
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ORBORD(NSMOB,MXPOBS,NR4TP,NDEOBS,NINOBS,NR0OBS,NACOBS,
     &                  NRSOBS,NR4OBS,NOCOBS,NTOOBS,
     &                  IREOST,IREOTS,ISFTO,ITFSO,IPRNT,IBSO,
     &                  NTSOB,IBTSOB,ITSOB,NOBPTS,IOBPTS,MXPR4T,
     &                  ISMFSO,ITPFTO,NOBPT)
*
* Obtain Reordering arrays for orbitals
* ( See note below for assumed ordering )
*
* =====
* Input
* =====
*  NSMOB  : Number of orbital symmetries
*  MXPOBS : MAx number of orbital symmetries
*  NR4TP  : Number of RAS4 types
*  NDEOBS : Number of deleted orbitals per symmetry
*  NINOBS : Number of inactive  orbitals per symmetry
*  NR0OBS : Number of RAS 0 (core ) orbitals per symmetry
*  NACOBS : Number of Active orbitals per symmetry
*  NRSOBS : Number of orbitals per symmetry in RAS1,RAS2,RAS3
*  NR4OBS : Number of RAS 4 orbitals per symmetry and type
*  NOCOBS : Number of occupied orbitals per symmetry
*  NTOOBS : Number of orbitals per symmetry,all types
*
* ======
* Output
* ======
*  IREOST : Reordering array symmetry => type
*  IREOTS : Reordering array type     => symmetry
*  ISFTO  : Symmetry array for type ordered orbitals
*  ITFSO  : Type array for symmetry ordered orbitals( not activated )
*  IBSO   : First orbital of given symmetry ( symmetry ordered )
*  NTSOB  : Number of active orbitals of give RAS type and SYM
*  IBTSOB : Off set for active orbitals of given RAS type and SYM
*  ITSOB  : Orbitals of given RAS type and sym
*
*  NOBPTS : Number of orbitals per subtype and symmetry
*  IOBPTS : Off sets for orbitals of given subtype and symmetry
*           ordered according to input integrals
*
* ISMFSO  : Symmetry of orbitals, symmetry ordereing
* ITPFTO  : Type of orbital, type ordering
* Jeppe Olsen, Winter 1991
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION NDEOBS(*),NINOBS(*),NR0OBS(*),NACOBS(*),
     &          NRSOBS(MXPOBS,3),NR4OBS(MXPOBS,*),NOCOBS(*),NTOOBS(*)
*. Output
      DIMENSION IREOST(*),IREOTS(*),ISFTO(*),ITFSO(*),IBSO(*)
      DIMENSION ISMFSO(*),ITPFTO(*)
      DIMENSION NTSOB(3,*),IBTSOB(3,*),ITSOB(*)
      DIMENSION NOBPTS(6+MXPR4T,*),IOBPTS(6+MXPR4T,*)
      DIMENSION NOBPT(6+MXPR4T)

* ==========================
* Note on order of orbitals
* ==========================
*
* The orbitals are supposed to be imported ordered symmetry-type
* ordered as
* Loop over symmetries of orbitals
*   Inactive  of this symmetry
*   Core      of this symmetry
*   RAS1      of this symmetry
*   RAS2      of this symmetry
*   RAS3      of this symmetry
*   Secondary of this symmetry
*   Deleted   of this symmetry
* End of loop over symmetries
*
* Internally the orbitals are reordered to type symmetry order
* where the outer loop os over types and the inner loop is
* over symmetries.The types are arranged as
*  Ras1
*  Ras2
*  Ras3
*  Core
*  Secondary
*  Inactive
*  Deleted orbitals
*
*
* Active orbitals
*
      IAC = 0
      IBSM  =0 ! dummy intitialize
      NPREVS=0 ! dummy initialize
      IORB  =0 ! dummy initialize
      DO 11 IRS = 1, 3
      DO 10 ISM = 1,NSMOB
        IF(ISM.EQ.1) THEN
          IBSM = 1
        ELSE
          IBSM = IBSM + NTOOBS(ISM-1)
        END IF
        IF(IRS.EQ.1) THEN
          NPREVS = NINOBS(ISM)+NR0OBS(ISM)
          IORB = NRSOBS(ISM,1)
        ELSE IF(IRS.EQ.2) THEN
          NPREVS = NINOBS(ISM)+NR0OBS(ISM)+NRSOBS(ISM,1)
          IORB = NRSOBS(ISM,2)
        ELSE IF(IRS.EQ.3) THEN
          NPREVS = NINOBS(ISM)+NR0OBS(ISM)+NRSOBS(ISM,1)+NRSOBS(ISM,2)
          IORB = NRSOBS(ISM,3)
        END IF
        DO 9 IIAC = 1, IORB
*. Type ordered index
          IAC = IAC + 1
*. Symmetry ordered index
          IACS = IBSM + NPREVS - 1 + IIAC
          ISFTO(IAC) = ISM
C         ISMFSO(IACS) = ISM
          ITPFTO(IAC) = IRS
*         ITFSO(IACS) = IRS
          IREOST(IACS) = IAC
          IREOTS(IAC) = IACS

    9   CONTINUE
   10 CONTINUE
   11 CONTINUE
      NACOB = IAC
C?    write(6,*) ' IAC ',IAC
*
*. RAS 0 orbitals
*
      IR0 = NACOB
      DO 20 ISM = 1,NSMOB
        IF(ISM.EQ.1) THEN
          IBSM = 1
        ELSE
          IBSM = IBSM + NTOOBS(ISM-1)
        END IF
        NPREVS = NINOBS(ISM)
        DO 19 IIR0 = 1, NR0OBS(ISM)
*. Type ordered index
          IR0 = IR0 + 1
*. Symmetry ordered index
          IR0S = IBSM + NPREVS - 1 + IIR0
          ISFTO(IR0) = ISM
*         ITFSO(IR0S) = 4
          IREOST(IR0S) = IR0
          IREOTS(IR0) = IR0S
   19   CONTINUE
   20 CONTINUE
      NR0OB = IR0 - NACOB
C?    write(6,*) ' IR0 ',IR0
*
*. RAS 4 orbitals
*
      IR4 = NACOB+NR0OB
      DO 30 ISM = 1,NSMOB
        IF(ISM.EQ.1) THEN
          IBSM = 1
        ELSE
          IBSM = IBSM + NTOOBS(ISM-1)
        END IF
        NPREVS = NINOBS(ISM)+NR0OBS(ISM)+NACOBS(ISM)
        DO 29 ITP = 1, NR4TP
        DO 28 IIR4 = 1, NR4OBS(ISM,ITP)
*. Type ordered index
          IR4 = IR4 + 1
*. Symmetry ordered index
          IR4S = IBSM + NPREVS - 1 + IIR4
          ISFTO(IR4) = ISM
*         ITFSO(IR4S) = 5
          IREOST(IR4S) = IR4
          IREOTS(IR4) = IR4S
   28   CONTINUE
   29   CONTINUE
   30 CONTINUE
      NR4OB = IR4 - NACOB - NR0OB
C?    write(6,*) ' IR4 ',IR4
*
*. Inactive orbitals
*
      IIN = NACOB+NR0OB+NR4OB
      DO 40 ISM = 1,NSMOB
        IF(ISM.EQ.1) THEN
          IBSM = 1
        ELSE
          IBSM = IBSM + NTOOBS(ISM-1)
        END IF
        NPREVS = 0
        DO 39 IIIN = 1, NINOBS(ISM)
*. Type ordered index
          IIN = IIN + 1
*. Symmetry ordered index
          IINS = IBSM + NPREVS - 1 + IIIN
          ISFTO(IIN) = ISM
*         ITFSO(IINS) = 6
          IREOST(IINS) = IIN
          IREOTS(IIN) = IINS
   39   CONTINUE
   40 CONTINUE
      NINOB = IIN - NACOB - NR0OB - NR4OB
C?    write(6,*) ' IIN   ',IIN
*
*. Deleted orbitals
*
      IDE = NACOB+NR0OB+NR4OB+NINOB
      DO 50 ISM = 1,NSMOB
        IF(ISM.EQ.1) THEN
          IBSM = 1
        ELSE
          IBSM = IBSM + NTOOBS(ISM-1)
        END IF
        IR4 = 0
        DO 45 ITP = 1, NR4TP
          IR4 = IR4 + NR4OBS(ISM,ITP)
   45   CONTINUE

        NPREVS = NINOBS(ISM)+NR0OBS(ISM)+NACOBS(ISM)+IR4
        DO 49 IIDE = 1, NDEOBS(ISM)
*. Type ordered index
          IDE = IDE + 1
*. Symmetry ordered index
          IDES = IBSM + NPREVS - 1 + IIDE
          ISFTO(IDE) = ISM
*         ITFSO(IDES) = 7
          IREOST(IDES) = IDE
          IREOTS(IDE) = IDES
   49   CONTINUE
   50 CONTINUE
      NTOOB = IDE
C?    write(6,*) ' IDE ', IDE
*
      IOFF = 1
      DO 100 ISM = 1, NSMOB
       IBSO(ISM) = IOFF
       IOFF = IOFF + NTOOBS(ISM)
  100 CONTINUE
*
* ==================
* NTSOB,IBTSOB,ITSOB
* ==================
*
      IOFF = 1
      DO 300 I123 = 1, 3
        DO 200 ISM = 1, NSMOB
          NTSOB(I123,ISM) = NRSOBS(ISM,I123)
          IBTSOB(I123,ISM) = IOFF
          CALL ISTVC2(ITSOB(IOFF),IOFF-1,1,NRSOBS(ISM,I123))
          IOFF = IOFF + NRSOBS(ISM,I123)
  200   CONTINUE
  300 CONTINUE
*
* =====================
* NOBPTS NOBPT IOBPTS
* =====================
*
*. Loop over types in input order
      Call iCopy(NR4TP+6,[0],0,NOBPT,1)
      LORB  = 0 ! dummy initialize
      IOTYPE= 0 ! dummy initialize
      DO 2000 ISMOB = 1, NSMOB
        LSMOB = 0
        DO 1000 ITYPE = 1, NR4TP + 6
          IF(ITYPE.EQ.1) THEN
*.Inactive ( frozen in normal notation )
            LORB = NINOBS(ISMOB)
            IOTYPE = 5+NR4TP
          ELSE IF(ITYPE.EQ.2) THEN
*.RAS0 ( inactive in normal notation
            LORB = NR0OBS(ISMOB)
            IOTYPE = 4
          ELSE IF (ITYPE.EQ.3) THEN
*.RAS1
            LORB = NRSOBS(ISMOB,1)
            IOTYPE = 1
          ELSE IF (ITYPE.EQ.4) THEN
*.RAS2
            LORB = NRSOBS(ISMOB,2)
            IOTYPE = 2
          ELSE IF (ITYPE.EQ.5) THEN
*.RAS3
            LORB = NRSOBS(ISMOB,3)
            IOTYPE = 3
          ELSE IF (ITYPE.GE.6.AND.ITYPE.LE.6+NR4TP-1) THEN
*.RAS4
            LORB = NR4OBS(ISMOB,ITYPE-5)
            IOTYPE = ITYPE -1
          ELSE IF (ITYPE.EQ.6+NR4TP) THEN
*. deleted orbitals
            LORB = NDEOBS(ISMOB)
            IOTYPE = ITYPE
          END IF
          IOBPTS(IOTYPE,ISMOB) = LSMOB+1
          NOBPTS(IOTYPE,ISMOB) = LORB
          NOBPT(IOTYPE) = NOBPT(IOTYPE)+LORB
          LSMOB = LSMOB + LORB
 1000   CONTINUE
 2000 CONTINUE
*
* =======
* ISMFSO
* =======
*
      IORB = 0
      DO ISM = 1, NSMOB
        DO IOB = 1, NTOOBS(ISM)
          IORB = IORB + 1
          ISMFSO(IORB) = ISM
        END DO
      END DO
*
      NTEST = 0
      NTEST = MAX(IPRNT,NTEST)
      IF( NTEST .NE. 0 ) THEN
        WRITE(6,*) ' ==================='
        WRITE(6,*) ' Output from ORBORD '
        WRITE(6,*) ' ==================='
        WRITE(6,*) ' Symmetry of orbitals , type ordered '
        CALL IWRTMA(ISFTO,1,NTOOB,1,NTOOB)
        WRITE(6,*) ' Symmetry => type reordering array '
        CALL IWRTMA(IREOST,1,NTOOB,1,NTOOB)
        WRITE(6,*) ' Type => symmetry reordering array '
        CALL IWRTMA(IREOTS,1,NTOOB,1,NTOOB)
        WRITE(6,*) ' IBSO array '
        CALL IWRTMA(IBSO,1,NSMOB,1,NSMOB)
*
        WRITE(6,*) ' NTSOB array : '
        CALL IWRTMA(NTSOB,3,NSMOB,3,NSMOB)
        WRITE(6,*) ' IBTSOB array '
        CALL IWRTMA(IBTSOB,3,NSMOB,3,NSMOB)
        WRITE(6,*) ' ITSOB '
        CALL IWRTMA(ITSOB,1,NACOB,1,NACOB)
*
        WRITE(6,*) ' NOBPTS '
        CALL IWRTMA(NOBPTS,6+NR4TP,NSMOB,6+MXPR4T,MXPOBS)
        WRITE(6,*) ' NOBPT '
        CALL IWRTMA(NOBPTS,6+NR4TP,1,6+MXPR4T,1)
        WRITE(6,*) ' IOBPTS '
        CALL IWRTMA(IOBPTS,6+NR4TP,NSMOB,6+MXPR4T,MXPOBS)
*
        WRITE(6,*) ' ISFTO array : '
        CALL IWRTMA(ISFTO,1,NTOOB,1,NTOOB)
*       WRITE(6,*) ' ITFSO array : '
*       CALL IWRTMA(ITFSO,1,NTOOB,1,NTOOB)
*
        WRITE(6,*) ' ISMFSO array : '
        CALL IWRTMA(ISMFSO,1,NTOOB,1,NTOOB)
        WRITE(6,*) ' ITPFTO array : '
        CALL IWRTMA(ITPFTO,1,NTOOB,1,NTOOB)
      END IF
*

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) Then
         CALL Unused_integer_array(NOCOBS)
         CALL Unused_integer_array(ITFSO)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1973, Nelson H. F. Beebe                               *
************************************************************************
      SUBROUTINE CHO_OUTPAK(AMATRX,NROW,NCTL,LUPRI)
C.......................................................................
C
C OUTPAK PRINTS A REAL SYMMETRIC MATRIX STORED IN ROW-PACKED LOWER
C
C TRIANGULAR FORM (SEE DIAGRAM BELOW) IN FORMATTED FORM WITH NUMBERED
C
C ROWS AND COLUMNS.  THE INPUT IS AS FOLLOWS:
C
C        AMATRX(*)...........PACKED MATRIX
C
C        NROW................NUMBER OF ROWS TO BE OUTPUT
C
C        NCTL................CARRIAGE CONTROL FLAG: 1 FOR SINGLE SPACE,
C                                                   2 FOR DOUBLE SPACE,
C                                                   3 FOR TRIPLE SPACE.
C
C THE MATRIX ELEMENTS ARE ARRANGED IN STORAGE AS FOLLOWS:
C
C        1
C        2    3
C        4    5    6
C        7    8    9   10
C       11   12   13   14   15
C       16   17   18   19   20   21
C       22   23   24   25   26   27   28
C       AND SO ON.
C
C OUTPAK IS SET UP TO HANDLE 6 COLUMNS/PAGE WITH A 6F20.14 FORMAT
C FOR THE COLUMNS.  IF A DIFFERENT NUMBER OF COLUMNS IS REQUIRED, CHANGE
C FORMATS 1000 AND 2000, AND INITIALIZE KCOL WITH THE NEW NUMBER OF
C COLUMNS.
C
C AUTHOR:  NELSON H.F. BEEBE, QUANTUM THEORY PROJECT, UNIVERSITY OF
C          FLORIDA, GAINESVILLE
C..........VERSION = 09/05/73/03
C.......................................................................
C
#include "implicit.fh"
      DIMENSION AMATRX(*)
      INTEGER BEGIN
      CHARACTER*1 ASA(3),BLANK,CTL
      CHARACTER   PFMT*20, COLUMN*8
      PARAMETER (ZERO=0.D00, KCOLP=4, KCOLN=6)
      PARAMETER (FFMIN=1.D-3, FFMAX = 1.D3)
      DATA COLUMN/'Column  '/, ASA/' ', '0', '-'/, BLANK/' '/
C
      IF (NCTL .LT. 0) THEN
         KCOL = KCOLN
      ELSE
         KCOL = KCOLP
      END IF
      MCTL = ABS(NCTL)
      IF ((MCTL.LE.3).AND.(MCTL.GT.0)) THEN
         CTL = ASA(MCTL)
      ELSE
         CTL = BLANK
      END IF
C
      J = NROW*(NROW+1)/2
      AMAX = ZERO
      DO 5 I=1,J
         AMAX = MAX( AMAX, ABS(AMATRX(I)) )
    5 CONTINUE
      IF (AMAX .EQ. ZERO) THEN
         WRITE (LUPRI,'(/T6,A)') 'Zero matrix.'
         GO TO 200
      END IF
      IF (FFMIN .LE. AMAX .AND. AMAX .LE. FFMAX) THEN
C        use F output format
         PFMT = '(A1,I7,2X,8F15.8)'
      ELSE
C        use 1PD output format
         PFMT = '(A1,I7,2X,1P,8D15.6)'
      END IF
C
C LAST IS THE LAST COLUMN NUMBER IN THE ROW CURRENTLY BEING PRINTED
C
      LAST = MIN(NROW,KCOL)
C
C BEGIN IS THE FIRST COLUMN NUMBER IN THE ROW CURRENTLY BEING PRINTED.
C
C.....BEGIN NON STANDARD DO LOOP.
      BEGIN= 1
 1050 NCOL = 1
         WRITE (LUPRI,1000) (COLUMN,I,I = BEGIN,LAST)
         DO 40 K = BEGIN,NROW
            KTOTAL = (K*(K-1))/2 + BEGIN - 1
            DO 10 I = 1,NCOL
               IF (AMATRX(KTOTAL+I) .NE. ZERO) GO TO 20
   10       CONTINUE
            GO TO 30
   20       WRITE (LUPRI,PFMT) CTL,K,(AMATRX(J+KTOTAL),J=1,NCOL)
   30       IF (K .LT. (BEGIN+KCOL-1)) NCOL = NCOL + 1
   40    CONTINUE
         LAST = MIN(LAST+KCOL,NROW)
         BEGIN= BEGIN + NCOL
      IF (BEGIN.LE.NROW) GO TO 1050
  200 CONTINUE
      RETURN
C
 1000 FORMAT (/12X,6(3X,A6,I4,2X),(3X,A6,I4))
C2000 FORMAT (A1,'Row',I4,2X,1P,8D15.6)
C2000 FORMAT (A1,I7,2X,1P,8D15.6)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Roland Lindh                                     *
!***********************************************************************

subroutine GET_EFP()

use, intrinsic :: iso_c_binding, only: c_int
use EFP_Module, only: ABC, Coor_Type, EFP_Coors, Frag_Type, lEFP, nEFP_Coor, nEFP_Fragments
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: CoorType

call Get_lScalar('EFP',lEFP)
if (lEFP) then
  call Get_iScalar('nEFP_fragments',nEFP_fragments)
  call Get_iScalar('nEFP_Coor',nEFP_Coor)
  call Get_iScalar('Coor_Type',CoorType)
  Coor_Type = int(CoorType,c_int)

  call mma_allocate(FRAG_type,nEFP_fragments,label='FRAG_type')
  call Get_cArray('FRAG_Type',FRAG_Type,180*nEFP_fragments)

  call mma_allocate(ABC,3,nEFP_fragments,label='ABC')
  call Get_cArray('ABC',ABC,180*3*nEFP_fragments)

  call mma_allocate(EFP_Coors,nEFP_Coor,nEFP_fragments,label='EFP_Coors')
  call Get_dArray('EFP_COORS',EFP_COORS,nEFP_Coor*nEFP_fragments)
end if

return

end subroutine GET_EFP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_W4
     c  (W4,dima,dimbe,dimb,dimga,adda,addbe,addb,addga)
c    c  (W4,dima,dimga,dimb,dimbe,adda,addga,addb,addbe)
c
c        this routine test W4
c
        implicit none
#include "chcc1.fh"
        integer dima,dimbe,dimb,dimga,adda,addbe,addb,addga
         real*8 W4(1:dima,1:dimbe,1:dimb,1:dimga)
c        real*8 W4(1:dima,1:dimga,1:dimb,1:dimbe)
c
c        help var
        integer a,b,be,ga,i,bad,ntot
        real*8 s
c
        bad=0
        ntot=0
c
        do ga=1,dimga
        do b=1,dimb
        do be=1,dimbe
        do a=1,dima
          s=Q4(a+adda,be+addbe,b+addb,ga+addga)
          s=0.0d0
           do i=1,no
             s=s-Q3(a+adda,be+addbe,b+addb,i)*T1c(ga+addga,i)
             s=s-Q3(b+addb,ga+addga,a+adda,i)*T1c(be+addbe,i)
           end do
           if (abs(W4(a,be,b,ga)-s).gt.1.0d-10) then
c          if (abs(W4(a,ga,b,be)-s).gt.1.0d-10) then
            bad=bad+1
c            W4(a,be,b,ga)=s
          end if
          ntot=ntot+1
        end do
        end do
        end do
        end do
c
        write (6,*) ' W4 test ',bad,ntot
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine BMtrx_Cartesian(nsAtom,nDimBC,nIter,mTtAtm,
     &                           mTR,TRVec,EVal,Hss_x,nQQ,nWndw)
      use Slapaf_Info, only: Cx, Gx, qInt, dqInt, KtB, BMx, Degen,
     &                       AtomLbl, Smmtrc
      use Slapaf_Parameters, only: Redundant, MaxItr, BSet, HSet, PrQ,
     &                             lOld
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
      Real*8 TRVec(nDimBC,mTR)
      Real*8 Eval(3*mTtAtm*(3*mTtAtm+1)/2)
      Real*8 Hss_x((3*mTtAtm)**2)
      Real*8, Allocatable:: EVec(:), Hi(:,:), iHi(:), Degen2(:)
      Integer, Allocatable:: Ind(:)

*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('BMtrx_Cartesian: TRVec',' ',TRVec,nDimBC,mTR)
      Call RecPrt('BMtrx_Cartesian: Degen',' ',Degen,3,SIZE(Degen,2))
      Call RecPrt('BMtrx_Cartesian: Hss_x',' ',Hss_x,3*mTtAtm,3*mTtAtm)
#endif
*
*-----Recompute the B matrix once each macroIteration, this is
*     not done if a numerical Hessian is computed.
*                                                                      *
************************************************************************
*                                                                      *
*     R E D U N D A N T  C A R T E S I A N  C O O R D S
*
      If (Redundant) Then
         nQQ = nDimBC
         If (Allocated(qInt).and.SIZE(qInt,1)/=nQQ) Then
            Call mma_deallocate(qInt)
            Call mma_deallocate(dqInt)
         End If
         If (.NOT.Allocated(qInt)) Then
            Call mma_allocate(qInt,nQQ,MaxItr,Label='qInt')
            Call mma_allocate(dqInt,nQQ,MaxItr,Label='dqInt')
            qInt(:,:) = Zero
            dqInt(:,:) = Zero
         End If
         Call mma_allocate(EVec,nDimBC**2,Label='EVec')
         EVec(:)=Zero
         call dcopy_(nDimBC,[One],0,EVec,nDimBC+1)
*                                                                      *
************************************************************************
*                                                                      *
*------- Move over the eigenvectors putting to BMx
*
         Call mma_allocate(BMx,3*nsAtom,nQQ,Label='BMx')
         BMX(:,:)=Zero
         ipFrom = 1
         Call BPut(EVec(ipFrom),nDimBC,BMx,3*nsAtom,Smmtrc,nQQ,Degen)
#ifdef _DEBUGPRINT_
         Call RecPrt('In Bmtrx: B',' ',BMx,3*nsAtom,nQQ)
#endif
*                                                                      *
************************************************************************
*                                                                      *
         If (PrQ.and.nsAtom.le.5) Call List2('Cartesian Redundant',
     &                                    AtomLbl,BMx,nsAtom,nQQ,Smmtrc)
*                                                                      *
************************************************************************
*                                                                      *
*------- Project the model Hessian with respect to rotations and
*        translations. The eigenvalues are shifted to large positive
*        eigenvalues to effectively remove any displacements in the
*        rotational and translations directions and to make sure that
*        the matrix is not singular.
*
         Call mma_allocate(Ind,nDimBC,Label='Ind')
         iInd=0
         Do i = 1, 3*nsAtom
            iAtom = (i+2)/3
            ixyz = i - (iAtom-1)*3
            If (Smmtrc(ixyz,iAtom)) Then
               iInd=iInd+1
               Ind(iInd)=i
            End If
         End Do
*
*        Compute H|i>
*
         Call mma_allocate(Hi,nDimBC,mTR,Label='Hi')
         Call mma_allocate(iHi,mTR,Label='iHi')
         Hi(:,:)=Zero
*
         Do j = 1, mTR
            Do i = 1, nDimBC
               Temp = 0.0D0
               Do k = 1, nDimBC
                  kx = Ind(k)
                  iAtom = (kx+2)/3
                  ixyz = kx - (iAtom-1)*3
                  ik=(i-1)*nDimBC+k
                  Temp = Temp
     &                 + Hss_X(ik) * Sqrt(Degen(ixyz,iAtom))
     &                 * TRVec(k,j)
               End Do
               Hi(i,j) = Temp
            End Do
         End Do
*        Call RecPrt('Hi',' ',Hi,nDimBC,mTR)
         Do iTR = 1, mTR
            iHi(iTR) = DDot_(nDimBC,TRVec(1,iTR),1,Hi(:,iTR),1)
         End Do
*        Call RecPrt('iHi',' ',iHi,mTR,1)
*
         Do i = 1, nDimBC
            ix = Ind(i)
            iAtom = (ix+2)/3
            ixyz = ix - (iAtom-1)*3
            Do j = 1, i
               jx = Ind(j)
               jAtom = (jx+2)/3
               jxyz = jx - (jAtom-1)*3
               ij = (j-1)*nDimBC + i
               ji = (i-1)*nDimBC + j
               Temp = Half*(Hss_x(ij)+Hss_x(ji))
*define UNIT_MM
#ifndef UNIT_MM
*
*              Here we shift the eigenvectors corresponding to
*              translations and rotations to a large positive values.
*
               Do iTR = 1, mTR
                  Omega = 1.0D+5
                  Hii   = iHi(iTR)
                  Temp = Temp
     &                 + Sqrt(Degen(ixyz,iAtom)) * (
     &                 - TRVec(i,iTR) * Hi(j,iTR)
     &                 - Hi(i,iTR) * TRVec(j,iTR)
     &                 + TRVec(i,iTR) * (Omega+Hii) * TRVec(j,iTR)
     &                                     )* Sqrt(Degen(jxyz,jAtom))
               End Do
#endif
*
               Hss_X(ij)=Temp
               Hss_X(ji)=Temp
            End Do
         End Do
         Call mma_deallocate(iHi)
         Call mma_deallocate(Hi)
         Call mma_deallocate(Ind)
*
*        Clean up the gradient wrt translational and rotational
*        component.
*
*        |g> = |g> - Sum(TR) |i><i|g>
*
         If (BSet) Then
*
*           Call RecPrt('Gx',' ',Gx(:,:,nIter),1,3*nsAtom)
*           Call RecPrt('TRVec',' ',TRVec,nDimBC,mTR)
*
            Do iTR = 1, mTR
*
*              <i|g>
*
               Temp=0.0D0
               iInd=0
               Do iAtom = 1, nsAtom
               Do j = 1, 3
                  If (Smmtrc(j,iAtom)) Then
                     iInd=iInd+1
                     Temp = Temp + Degen(j,iAtom)*Gx(j,iAtom,nIter)
     &                                     *TRVec(iInd,iTR)
                  End If
               End Do
               End Do
*
               iInd=0
               Do iAtom = 1, nsAtom
               Do j = 1, 3
                  If (Smmtrc(j,iAtom)) Then
                     iInd=iInd+1
                     Gx(j,iAtom,nIter) = Gx(j,iAtom,nIter)
     &                                 - TRVec(iInd,iTR)*Temp
                  End If
               End Do
               End Do
*
            End Do
*
*           Call RecPrt('Gx',' ',Gx(:,:,nIter),1,3*nsAtom)
*
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
*     N O N - R E D U N D A N T  C A R T E S I A N  C O O R D S
*
         nQQ=nDimBC - mTR
         If (.NOT.Allocated(qInt)) Then
            Call mma_allocate(qInt,nQQ,MaxItr,Label='qInt')
            Call mma_allocate(dqInt,nQQ,MaxItr,Label='dqInt')
            qInt(:,:) = Zero
            dqInt(:,:) = Zero
         End If
*
*------- Project the model Hessian with respect to rotations and
*        translations. The eigenvalues are shifted to negative
*        eigenvalues.
*
         Call mma_allocate(Ind,nDimBC,Label='Ind')
         iInd=0
         Do i = 1, 3*nsAtom
            iAtom = (i+2)/3
            ixyz = i - (iAtom-1)*3
            If (Smmtrc(ixyz,iAtom)) Then
               iInd=iInd+1
               Ind(iInd)=i
            End If
         End Do
*
*        Compute H|i>
*
         Call mma_allocate(Hi,nDimBC,mTR,Label='Hi')
         Call mma_allocate(iHi,mTR,Label='iHi')
         Hi(:,:)=Zero
*
         Do j = 1, mTR
            Do i = 1, nDimBC
               Temp = 0.0D0
               Do k = 1, nDimBC
                  kx = Ind(k)
                  kAtom = (kx+2)/3
                  kxyz = kx - (kAtom-1)*3
                  ik=(i-1)*nDimBC+k
                  Temp = Temp
     &                 + Hss_X(ik) * Sqrt(Degen(kxyz,kAtom))
     &                 * TRVec(k,j)
               End Do
               Hi(i,j) = Temp
            End Do
         End Do
         Do iTR = 1, mTR
            iHi(iTR) = DDot_(nDimBC,TRVec(1,iTR),1,Hi(:,iTR),1)
         End Do
#ifdef _DEBUGPRINT_
         Call RecPrt('Hi',' ',Hi,nDimBC,mTR)
         Call RecPrt('iHi',' ',iHi,mTR,1)
#endif
*
         Do i = 1, nDimBC
            ix = Ind(i)
            iAtom = (ix+2)/3
            ixyz = ix - (iAtom-1)*3
            Do j = 1, i
               jx = Ind(j)
               jAtom = (jx+2)/3
               jxyz = jx - (jAtom-1)*3
               ijTri=i*(i-1)/2 + j
               ij = (j-1)*nDimBC + i
               ji = (i-1)*nDimBC + j
               EVal(ijTri) = Half*(Hss_X(ij)+Hss_X(ji))
*
*              Here we shift the eigenvectors corresponding to tran-
*              lations and rotations down to negative faked eigen-
*              values.
*
               Do iTR = 1, mTR
                  Omega = -DBLE(iTR)
                  Hii   = iHi(iTR)
                  Eval(ijTri) = Eval(ijTri)
     &                 + Sqrt(Degen(ixyz,iAtom)) * (
     &                 - TRVec(i,iTR) * Hi(j,iTR)
     &                 - Hi(i,iTR) * TRVec(j,iTR)
     &                 + TRVec(i,iTR) * (Omega+Hii) * TRVec(j,iTR)
     &                                     )* Sqrt(Degen(jxyz,jAtom))
               End Do
*
               Hss_X(ij)=EVal(ijTri)
               Hss_X(ji)=EVal(ijTri)
            End Do
         End Do
         Call mma_deallocate(iHi)
         Call mma_deallocate(Hi)
         Call mma_deallocate(Ind)
#ifdef _DEBUGPRINT_
         Call TriPrt(' The Projected Model Hessian','(5G20.10)',
     &               EVal,nDimBC)
         Call RecPrt(' The Projected Model Hessian','(5G20.10)',
     &               Hss_x,nDimBC,nDimBC)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        Compute the eigen vectors for the Cartesian Hessian
*
         Call mma_allocate(EVec,(3*mTtAtm)**2,Label='EVec')
         Call Hess_Vec(mTtAtm,EVal,EVec,nsAtom,nDimBC)
*                                                                      *
************************************************************************
*                                                                      *
*------- Move over the eigenvectors putting to BMx
*
         Call mma_allocate(BMx,3*nsAtom,3*nsAtom,Label='BMx')
         BMx(:,:)=Zero
         ipFrom = 1 + mTR*nDimBC
         Call BPut(EVec(ipFrom),nDimBC,BMx,3*nsAtom,Smmtrc,nQQ,Degen)
#ifdef _DEBUGPRINT_
         Call RecPrt('In Bmtrx: B',' ',BMx,3*nsAtom,nQQ)
#endif
*                                                                      *
************************************************************************
*                                                                      *
         If (PrQ.and.nsAtom.le.5)
     &      Call List2('Cartesian Approximate Normal Modes',
     &                  AtomLbl,BMx,nsAtom,nQQ,Smmtrc)
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      If (HSet.and..NOT.lOld) Then
         Call mma_allocate(KtB,nDimBC,nQQ,Label='KtB')
*
         Call mma_allocate(Degen2,nDimBC,Label='Degen2')
         i=0
         Do ix = 1, 3*nsAtom
            iAtom = (ix+2)/3
            ixyz = ix - (iAtom-1)*3
            If (Smmtrc(ixyz,iAtom)) Then
               i = i + 1
               Degen2(i) = Degen(ixyz,iAtom)
            End If
         End Do
*
         call dcopy_(nDimBC*nQQ,EVec(ipFrom),1,KtB,1)
         Do iInter = 1, nQQ
            Do iDim = 1, nDimBC
               KtB(iDim,iInter) = KtB(iDim,iInter) / Sqrt(Degen2(iDim))
            End Do
         End Do
         Call mma_deallocate(Degen2)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(EVec)
*                                                                      *
************************************************************************
*                                                                      *
*
*---- Compute the value and gradient vectors in the new basis.
*
      Call ValANM(nsAtom,nQQ,nIter,BMx,Degen,qInt,Cx,'Values',nWndw)
      If (BSet) Call ValANM(nsAtom,nQQ,nIter,BMx,Degen,
     &                      dqInt,Gx,'Gradients',nWndw)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Markus P. Fuelscher                              *
************************************************************************
* SubRecPrt
*
*> @brief
*>   Print a triangular matrix
*> @author M. P. F&uuml;lscher, Lund, 1992
*>
*> @details
*> Print a square matrix stored in packed, lower triangular storage mode.
*>
*> @param[in] Title   String containing a title
*> @param[in] FmtIn   String containing a format
*> @param[in] A       Triangular matrix to be printed
*> @param[in] N       Dimension of matrix \p A
************************************************************************
      Subroutine TriPrt(Title,FmtIn,A,N)
      Implicit Real*8 (A-H,O-Z)
#include "standard_iounits.fh"
      Character*(*) Title
      Character*(*) FmtIn
      Dimension A(N*(N+1)/2)
      Integer StrnLn
      Parameter (lPaper=120)
      Character*(lPaper) Line
      Character*20 FMT
*----------------------------------------------------------------------*
      If (N.le.0) Return
*----------------------------------------------------------------------*
#ifdef _DEBUGPRINT_
      Call TrcPrt(Title,FmtIn,A,1,N*(N+1)/2)
      Return
#endif
*----------------------------------------------------------------------*
*     print the title                                                  *
*----------------------------------------------------------------------*
      lTitle=StrnLn(Title)
      If ( lTitle.gt.0 ) then
         Do 10 i=1,lPaper
             Line(i:i)=' '
10       Continue
         lLeft=1
         Do 20 i=lTitle,1,-1
            If ( Title(i:i).ne.' ' ) lLeft=i
20       Continue
         lLeft=lLeft-1
         Do 25 i=1,lPaper
            If ( i+lLeft.le.lTitle ) Line(i:i)=Title(i+lLeft:i+lLeft)
25       Continue
         Write(LuWr,*)
         Write(LuWr,'(2X,A)') Line
c         Do 30 i=1,StrnLn(Line)
c            Line(i:i)='-'
c30       Continue
c         Write(LuWr,'(2X,A)') Line
         Write(LuWr,'(2X,A,I5,A,I5)') 'mat. size = ',N,'x',N
      End If
*----------------------------------------------------------------------*
*     determine the printing format                                    *
*----------------------------------------------------------------------*
      lFmt=StrnLn(FmtIn)
      If ( lFmt.ne.0 ) then
         FMT=FmtIn
      Else
         Amax=A(1)
         Amin=A(1)
         Do 40 i=1,N*(N+1)/2
            Amax=Max(Amax,A(i))
            Amin=Min(Amin,A(i))
40       Continue
         If (Amax.ne.0.0D0) Then
           Pmax=Log10(Abs(Amax))
           iPmax=Int(1d0+Pmax)
           iPmax=Max(1,iPmax)
         Else
           iPmax=1
         End If
         If (Amin.ne.0.0D0) Then
           Pmin=Log10(Abs(Amin))
           iPmin=Int(1d0+Pmin)
           iPmin=Max(1,iPmin)
         Else
           iPmin=1
         End If
         nDigit=24
         nDecim=Min(16,ABS(nDigit-Max(iPmin,iPmax)))
         If ( Amax.lt.0d0 ) iPmax=iPmax+1
         If ( Amin.lt.0d0 ) iPmin=iPmin+1
         lNumbr=Max(iPmin,iPmax)+nDecim+2
         nCols=10
         lLine=nCols*lNumbr
         If ( lLine.gt.lPaper ) then
            If ( lLine.le.lPaper+nCols .and. nDecim.gt.1 ) then
               nDecim=nDecim-1
               lNumbr=Max(iPmin,iPmax)+nDecim
               lItem=Max(lNumbr,lPaper/nCols)
            Else
               nCols=5
               lItem=Max(lNumbr,lPaper/nCols)
            End If
         Else
            lItem=lNumbr
         End If
         Write(FMT,'(A,   I4.4,  A, I4.4,  A, I4.4,   A)')
     &             '(2X,',nCols,'F',lItem,'.',nDecim,')'
      End if
*----------------------------------------------------------------------*
*     print the data                                                   *
*----------------------------------------------------------------------*
      Write(LuWr,*)
      jEnd=0
      Do 60 i=1,N
         jStart=jEnd+1
         jEnd=jEnd+i
         Write(LuWr,FMT)(A(j),j=jStart,jEnd)
60    Continue
*----------------------------------------------------------------------*
*     End procedure                                                    *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine CkAltD(K_Lap,DD,NG)
!-----------------------------------------------------------------------
! Function : Check the alternation of array DD
!-----------------------------------------------------------------------

use ReMez_mod, only: IW
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: K_Lap
real(kind=wp), intent(in) :: DD(82)
logical(kind=iwp), intent(out) :: NG
integer(kind=iwp) :: I, IDimEnd
real(kind=wp) :: A

IDimEnd = 2*K_Lap
NG = .false.

do I=1,IDimEnd
  A = DD(I)*DD(I+1)
  if (A >= Zero) then
    NG = .true.
    write(IW,'(A,I3)') 'DD sign is wrong at I =',I
  end if
end do

return

end subroutine CkAltD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               1993, Per-Olof Widmark                                 *
!               1999, Niclas Forsberg                                  *
!               Per Ake Malmqvist                                      *
!***********************************************************************

!module IOTools

!contains

subroutine MulaRdNLst(iUnit,NameIn)
!  Locate the beginning of an input stream
!  (similar to FORTRAN NAMELIST read known to some systems)
!
!  Calling arguments:
!    iUnit  : Type integer, input - FORTRAN unit number
!    NameIn : Type character string, input - Character string marking the beginning of the input
!
!  Written by:
!    M.P. Fuelscher and P.O. Widmark
!    University of Lund, Sweden, 1993
!
!  Slightly modified by:
!    Niclas Forsberg, 1999

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iUnit
character(len=*), intent(in) :: NameIn
integer(kind=iwp) :: istatus, lStdNam
character(len=80) :: Line
character(len=8) :: StdNam
integer(kind=iwp), external :: StrnLn

! Convert the Name to internal standard format.
call StdFmt(NameIn,StdNam)
lStdNam = StrnLn(StdNam)

! Read until an input Line is located which starts with
! the string, Name, not before the second column
do while (.true.)
  read(iUnit,'(A80)',iostat=istatus) Line
  if (istatus < 0) then
    write(u6,*) 'MulaRdNLst error: Could not locate input.'
    write(u6,*) 'Looking for: &'//StdNam
    call Quit_OnUserError()
  end if
  call UpCase(Line)
  Line = adjustl(Line)
  if ((Line(1:1) == '&') .and. (Line(2:lStdNam+1) == StdNam(1:lStdNam))) exit
end do

end subroutine MulaRdNLst

subroutine WordPos(k,InLine,iStart,iStop)
!  Purpose:
!    Return the position (iStart,iStop) of the first word after position k in InLine.
!
!  Input:
!    k        : Integer - the first position after keyword in the string InLine.
!    InLine   : Character string.
!
!  Output:
!    iStart   : Integer - the position of the first non-blank character after position k in InLine.
!    iStop,k  : Integer - the position of the first blank character after position iStart in InLine.

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: k
character(len=*), intent(in) :: InLine
integer(kind=iwp), intent(out) :: iStart, iStop
integer(kind=iwp) :: Length
character :: Ch

Length = len(InLine)
Ch = InLine(k:k)
do while ((Ch == ' ') .and. (k < Length))
  k = k+1
  Ch = InLine(k:k)
end do
if (k+1 >= Length) then
  iStart = Length
  iStop = Length
  return
end if
iStart = k
k = k+1
Ch = InLine(k:k)
do while ((Ch /= ' ') .and. (k < Length))
  k = k+1
  Ch = InLine(k:k)
end do
iStop = k-1

end subroutine WordPos

subroutine KeyWord(nUnit,KeyWd,rwnd,Exists)
!  Purpose:
!    Read from a file until a line contains the string KeyWd.
!
!  Input:
!    nUnit     : Unit to read from.
!    KeyWd     : Character string - keyword.
!    rwnd      : Logical.
!
!  Output:
!    File      : Next line in the file contains the data connected with the keyword KeyWd.
!
!  Calls:
!    MulaRdNlst
!    Normalize

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nUnit
character(len=*), intent(in) :: KeyWd
logical(kind=iwp), intent(in) :: rwnd
logical(kind=iwp), intent(out) :: Exists
integer(kind=iwp) :: BlInd, i, istatus, KLen
character(len=80) :: InLine, OutLine
character(len=32) :: TmpKey

InLine = KeyWd
call Normalize(InLine,OutLine)
! Index of first blank character from the end:
BlInd = 81
do i=80,1,-1
  if (Outline(i:i) /= ' ') exit
  BlInd = i
end do
if (BlInd > 80) then
  write(u6,*) 'KEYWORD: KeyWd is too long.'
  write(u6,*) 'KeyWd:',KeyWd
  write(u6,*) 'After normalization (OutLine):'
  write(u6,*) OutLine
  call abend()
end if
Exists = .false.
if (BlInd == 1) return

KLen = BlInd-1
TmpKey = OutLine(1:KLen)

if (rwnd) then
  rewind(nUnit)
  call MulaRdNlst(nUnit,'MULA')
end if

read(nUnit,'(a80)',iostat=istatus) InLine
if (istatus == 0) then
  call Normalize(InLine,OutLine)
  do while (OutLine(1:KLen) /= TmpKey(1:KLen))
    read(nUnit,'(a80)',iostat=istatus) InLine
    if (istatus /= 0) exit
    call Normalize(InLine,OutLine)
  end do
end if
if (istatus > 0) then
  write(u6,*) ' I/O error on unit nUnit=',nUnit
  call abend()
end if
Exists = OutLine(1:KLen) == TmpKey(1:KLen)

return

end subroutine KeyWord

function StrToDble(InString)
!  Purpose:
!    Convert a number in string InString to Real.
!
!  Input:
!    InString   : Character string.
!
!  Output:
!    xNum       : Real.

use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: StrToDble
character(len=*), intent(in) :: InString
integer(kind=iwp) :: length
real(kind=wp) :: xNum
character(len=2) :: TwoDigits
character(len=1) :: OneDigit

length = len(InString)
write(u6,*) ' The string is:',InString
write(u6,*) ' Its length is:',length
if (length < 10) then
  write(OneDigit,'(i1)') length
  write(u6,*) '   OneDigit is:',OneDigit
  write(u6,*) ' The format is:','(f'//OneDigit//'.0)'
  read(InString,'(f'//OneDigit//'.0)') xnum
else
  write(TwoDigits,'(i2)') length
  write(u6,*) '  TwoDigits is:',TwoDigits
  write(u6,*) ' The format is:','(f'//TwoDigits//'.0)'
  read(InString,'(f'//TwoDigits//'.0)') xNum
end if
StrToDble = xNum

end function StrToDble

function iStrToInt(InLine)
!  Purpose:
!    Convert a number in string InLine to integer.
!
!  Input:
!    InLine   : Character string.
!
!  Output:
!    num      : Integer.

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iStrToInt
character(len=*), intent(in) :: InLine
integer(kind=iwp) :: i, isum, length, nPos, num
logical(kind=iwp) :: minus
character :: ch

length = len(InLine)

! Convert from string to integer.
isum = 0
i = 0
minus = .false.
do nPos=length,1,-1
  if (InLine(nPos:nPos) == '-') then
    minus = .true.
  else
    ch = InLine(nPos:nPos)
    isum = isum+(index('0123456789',ch)-1)*10**(i)
    i = i+1
  end if
end do

if (minus) then
  num = -isum
else
  num = isum
end if

iStrToInt = num

end function iStrToInt

subroutine Normalize(line,line2)
!  Purpose:
!    Convert a string to uppercase characters.
!
!  Input:
!    line     : Character string.
!
!  Output:
!    line2    : Character string - uppercase letters.
!
!  Written by:
!    P-AA Malmquist,
!    Dept. of Theoretical Chemistry, Lund University.

use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: line
character(len=*), intent(out) :: line2
integer(kind=iwp), parameter :: ntrans = 256
integer(kind=iwp) :: i, icalled = 0, ista, itrans(ntrans), j, len1, len2, len2max
logical(kind=iwp) :: wrdend
character :: ch
character(len=*), parameter :: lcase = 'abcdefghijklmnopqrstuvwxyz', &
                               ucase = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'

! Set up character transformation table:
if (icalled == 0) then
  do i=1,ntrans
    itrans(i) = i
  end do
  do j=1,len(lcase)
    i = ichar(lcase(j:j))
    itrans(i) = ichar(ucase(j:j))
  end do
end if
len1 = len(line)
len2max = len(line2)
ista = 0
! Find first non-blank character, at position ista.
do i=1,len1
  ch = line(i:i)
  if (ch /= ' ') then
    ista = i
    exit
  end if
end do
line2 = ' '
if (ista == 0) return
wrdend = .false.
len2 = 0
do i=ista,len1
  ch = line(i:i)
  if (ch /= ' ') then
    if (wrdend) then
      if (len2 > len2max-1) then
        write(u6,*) ' WARNING: Line truncated in NORMALIZE.'
        exit
      end if
      line2(len2+1:len2+1) = ' '
      len2 = len2+1
    end if
    if (len2 > len2max-1) then
      write(u6,*) ' WARNING: Line truncated in NORMALIZE.'
      exit
    end if
    ch = char(itrans(ichar(ch)))
    line2(len2+1:len2+1) = ch
    len2 = len2+1
    wrdend = .false.
  else
    wrdend = .true.
  end if
end do

return

end subroutine Normalize

!end module IOTools

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************
!  Geogen
!
!> @brief
!>   Generate the new configuration in typical random manner
!> @author A. Ohrn
!>
!> @details
!> The creator of random geometries in typical Monte-Carlo fashion.
!> The changes made are:
!>
!> 1. The dielectric radius is modified
!> 2. Each coordinate *except* the \c iSta-1 -th molecule is changed
!> 3. All molecules (with the above exception) are rotated around the oxygen (which approximately equals the CM)
!> 4. Every molecule except the fixed ones are rotated slightly around one of the global \f$ x \f$-, \f$ y \f$- or \f$ z \f$-axes;
!>    the purpose of this is to emulate a rotation of the central molecule and therefore make the system more dynamic.
!>
!> @param[in,out] Ract     The dielectric radius on input and the slightly perturbed radius on output
!> @param[out]    Rold     Stores the input dielectric radius
!> @param[in]     iCNum    How many solvent places that are taken up by the QM-molecule
!> @param[in]     iQ_Atoms
!***********************************************************************

subroutine Geogen(Ract,Rold,iCNum,iQ_Atoms)

use qmstat_global, only: CordIm, Cordst, DelFi, DelR, delX, Diel, DipIm, iSeed, iSta, nCent, nCha, nPart, nPol, OldGeo, Sqrs, Qim, &
                         Qimp, Qmeq, QmProd, Qsta, xyzMyp
use Constants, only: Zero, One, Two, Three, Ten, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Ract
real(kind=wp), intent(out) :: Rold
integer(kind=iwp), intent(in) :: iCNum, iQ_Atoms
integer(kind=iwp) :: i, ii, iImage, ij, Ind, iQsta, j, k
real(kind=wp) :: A, A2, B, CB, Cx, Cy, Cz, DiFac, Dx, q, qq, S2, SB, Sqrts2, x, xNy, y, yNy, z, zNy
real(kind=wp), external :: Random_Molcas

!----------------------------------------------------------------------*
! Store old configuration.                                             *
!----------------------------------------------------------------------*
OldGeo(:,:) = Cordst
!----------------------------------------------------------------------*
! Query which type of simulation this is, and if quantum then change   *
! the quantum molecule.                                                *
!----------------------------------------------------------------------*
if (Qmeq .or. QmProd) then !Which coordinates to keep fixed.
  iSta = iCNum+1  !This sees to that the QM-molecule is excluded from the moves below.
  do j=1,3
    Dx = delX*(Random_Molcas(iSeed)-Half)
    Cordst(j,1:iQ_Atoms) = Cordst(j,1:iQ_Atoms)+Dx !Move QM-mol.
  end do
end if
!----------------------------------------------------------------------*
! Obtain the random-stuff and make small geometry change.              *
!----------------------------------------------------------------------*
Rold = Ract
Ract = Ract+(Random_Molcas(iSeed)-Half)*DelR !Change in cavity radius
do i=iSta,nPart !Which molecules to give new coordinates.
  ij = (i-1)*nCent
  do j=1,3
    Dx = DelX*(Random_Molcas(iSeed)-Half)
    Cordst(j,ij+1:ij+nCent) = Cordst(j,ij+1:ij+nCent)+Dx !Make translation
  end do
  Cx = Cordst(1,ij+1) !The oxygen, around which we rotate
  Cy = Cordst(2,ij+1)
  Cz = Cordst(3,ij+1)
  B = (Random_Molcas(iSeed)-Half)*DelFi
  CB = cos(B)
  SB = sin(B)
  do k=2,nCent !Rotate around the oxygen in yz-plane, i.e. around x-axis.
    y = Cordst(2,ij+k)-Cy
    z = Cordst(3,ij+k)-Cz
    yNy = y*CB+z*SB !This is a rotation matrix
    zNy = z*CB-y*SB
    Cordst(2,ij+k) = yNy+Cy
    Cordst(3,ij+k) = zNy+Cz
  end do
  B = (Random_Molcas(iSeed)-Half)*DelFi
  CB = cos(B)
  SB = sin(B)
  do k=2,nCent !And now rotate in xz-plane
    x = Cordst(1,ij+k)-Cx
    z = Cordst(3,ij+k)-Cz
    xNy = x*CB+z*SB
    zNy = z*CB-x*SB
    Cordst(1,ij+k) = xNy+Cx
    Cordst(3,ij+k) = zNy+Cz
  end do
  B = (Random_Molcas(iSeed)-Half)*DelFi
  CB = cos(B)
  SB = sin(B)
  do k=2,nCent  !To your surprise, here we rotate in the xy-plane
    x = Cordst(1,ij+k)-Cx
    y = Cordst(2,ij+k)-Cy
    xNy = x*CB+y*SB
    yNy = y*CB-x*SB
    Cordst(1,ij+k) = xNy+Cx
    Cordst(2,ij+k) = yNy+Cy
  end do
end do
! Here all other water molecules rotate around one of the three axes,
! except the ones we fix, which in a QM-simulation is the quantum particle.
A = Random_Molcas(iSeed)
B = (Random_Molcas(iSeed)-Half)*DelFi/Ten
CB = cos(B)
SB = sin(B)
if (A*Three <= One) then !make it random whether we rotate around x, y or z.
  do i=iSta,nPart
    ij = (i-1)*nCent
    do k=1,nCent
      ii = ij+k
      Cy = Cordst(2,ii)
      Cz = Cordst(3,ii)
      Cordst(2,ii) = Cy*CB+Cz*SB
      Cordst(3,ii) = Cz*CB-Cy*SB
    end do
  end do
else if (A*Three <= Two) then
  do i=iSta,nPart
    ij = (i-1)*nCent
    do k=1,nCent
      ii = ij+k
      Cx = Cordst(1,ii)
      Cz = Cordst(3,ii)
      Cordst(1,ii) = Cx*CB+Cz*SB
      Cordst(3,ii) = CB*Cz-SB*Cx
    end do
  end do
else
  do i=iSta,nPart
    ij = (i-1)*nCent
    do k=1,nCent
      ii = ij+k
      Cx = Cordst(1,ii)
      Cy = Cordst(2,ii)
      Cordst(1,ii) = Cx*CB+Cy*SB
      Cordst(2,ii) = CB*Cy-SB*Cx
    end do
  end do
end if
!----------------------------------------------------------------------*
! Generate the image points that correspond with the new coordinates.  *
! We follow Friedman. Since no image is created here for the qm-       *
! molecule, start with query.                                          *
!----------------------------------------------------------------------*
Ind = 0 !The SM-defaults.
iImage = 1
if (Qmeq .or. QmProd) then
  Ind = iCNum*nCent !Makes sure that the first slots in CordIm are empty
  iImage = iSta
end if
iQsta = nCent-nCha+1
A2 = Ract**2
DiFac = -(Diel-One)/(Diel+One)
xyzMyp(:) = Zero
do i=iImage,nPart
  do j=1,nCent
    Ind = Ind+1
    S2 = Zero
    do k=1,3
      S2 = S2+Cordst(k,Ind)**2
    end do
    S2 = A2/S2
    Sqrts2 = sqrt(S2)
    Sqrs(Ind) = Sqrts2
    if (j <= nPol) then
      QImp(Ind) = Zero
      DipIm(:,Ind) = Zero
    end if
    if (j >= iQsta) then
      qq = Qsta(j-nCent+nCha)
      q = DiFac*Sqrts2*qq
      Qim(Ind) = q
    else
      qq = Zero
      Qim(Ind) = Zero
    end if
    xyzMyp(:) = xyzMyp-qq*Cordst(:,Ind) !Total dipole of the cavity; used in polink.
    CordIm(:,Ind) = Cordst(:,Ind)*S2
  end do
end do

!----------------------------------------------------------------------*
! Exit.                                                                *
!----------------------------------------------------------------------*
return

end subroutine Geogen

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NRed(ArrIn,ArrOut,nX,nDim,Smmtrc)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nX, nDim
real(kind=wp), intent(in) :: ArrIn(nX)
real(kind=wp), intent(out) :: ArrOut(nDim)
logical(kind=iwp), intent(in) :: Smmtrc(nX)
integer(kind=iwp) :: i_Dim, iX

i_Dim = 0
do iX=1,nX
  if (Smmtrc(iX)) then
    i_Dim = i_Dim+1
    ArrOut(i_Dim) = ArrIn(iX)
  end if
end do
if (i_Dim /= nDim) then
  write(u6,*) 'In NRed: i_Dim /= nDim'
  call Abend()
end if
!call RecPrt('ArrIn',' ',ArrIn,nX,1)
!call RecPrt('ArrOut',' ',ArrOut,nDim,1)

return

end subroutine NRed

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine t3wresult (symi,symj,i,j,eaaa,eaab,eabb,ebbb)
c
c       this routine write:
c       0) value od SymiMin,Imin,SymJmin,Jmin from which
c          accumilation started
c       1) value of SymI,SymJ,I,J
c       2) present stage of energies
c       into T3tEne file and overwrite previous values
c
#include "t31.fh"
c
        integer symi,symj,i,j
        real*8 eaaa,eaab,eabb,ebbb
c
c       help variable
c
        integer lun
c
        lun=1
        Call Molcas_Open(lun,'T3tEne')
*       open (unit=lun,file='T3tEne')
c
        write (lun,97) symimin,imin,symjmin,jmin
        write (lun,98) symi,symj
        write (lun,98) i,j
        write (lun,99) eaaa
        write (lun,99) eaab
        write (lun,99) eabb
        write (lun,99) ebbb
c
97      format (2x,4(i4,2x))
98      format (2x,2(i4,2x))
99      format (2x,f22.16)
c
        close (lun)
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine makeT2pHlp1(T2p,Tau,aGrp,bGrp,aSGrp,bSGrp,key,dimi,dimij,dimapp,dimabpp,dimabp)
! this routine does:
! define T2(+-)(ij,(ab)") = Tau((ab)',i,j) +- Tau((ab)',j,i)
! for the case: aGrp=bGrp and aSGrp=bSGrp
!
! parameter description:
! T2p   - array for T2+ (O)
! Tau   - array for Tau (I)
! xGrp  - Groups of a',b' (I)
! xSGrp - SubGroups of a",b" (I)
! key   - 0 - T2+; 1 = T2- will be produced
! dimx  - Dimension of i,(i>=j),a",(a>b)",a',(a>=b)' (I)

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimSGrpa, GrpaLow
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: aGrp, bGrp, aSGrp, bSGrp, key, dimi, dimij, dimapp, dimabpp, dimabp
real(kind=wp), intent(out) :: T2p(dimij,dimabpp)
real(kind=wp), intent(in) :: Tau(dimabp,dimi,dimi)
integer(kind=iwp) :: abp, abpp, ap, app, appAdd, bpp, bppAdd, i, ij

!1 def appAdd,bppAdd

appAdd = 0
if (aSGrp /= Grpalow(aGrp)) then
  do i=Grpalow(aGrp),aSGrp-1
    appAdd = appAdd+DimSGrpa(i)
  end do
end if

bppAdd = 0
if (bSGrp /= Grpalow(bGrp)) then
  do i=Grpalow(bGrp),bSGrp-1
    bppAdd = bppAdd+DimSGrpa(i)
  end do
end if

!2 define T2(+,-)

if (key == 0) then

  !2.1 define T2+
  abpp = 0
  do app=2,dimapp
    ap = appAdd+app
    abp = nTri_Elem(ap-1)+bppAdd
    do bpp=1,app-1
      abp = abp+1
      abpp = abpp+1
      ij = 0
      do i=1,dimi
        T2p(ij+1:ij+i,abpp) = Tau(abp,i,1:i)+Tau(abp,1:i,i)
        ij = ij+i
      end do
    end do
  end do

else

  !2.2 define T2-
  abpp = 0
  do app=2,dimapp
    ap = appAdd+app
    abp = nTri_Elem(ap-1)+bppAdd
    do bpp=1,app-1
      abp = abp+1
      abpp = abpp+1
      ij = 0
      do i=2,dimi
        T2p(ij+1:ij+i-1,abpp) = Tau(abp,i,1:i-1)-Tau(abp,1:i-1,i)
        !T2p(ij+1:ij+i-1,abpp) = T2c(ap,bpp,i,1:i-1)-T2c(ap,bpp,1:i-1,i)
        ij = ij+i-1
      end do
    end do
  end do

end if

T2p(:,:) = Half*T2p(:,:)

return

end subroutine makeT2pHlp1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013-2015, Ignacio Fdez. Galvan                        *
!***********************************************************************
!  MEP_Dir
!
!> @brief
!>   Compute the new reference structure and initial coordinates for the next MEP point
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Compute the new reference structure (and direction) and initial geometry
!> for the next MEP point optimization (using the Gonz&aacute;lez--Schlegel or
!> M&uacute;ller--Brown method).
!> Calculate some properties of the path (length and curvature) between the previous
!> and current MEP points.
!> All calculations are done in weighted coordinates (mass-weighted by default).
!>
!> @param[in,out] Cx            Cartesian coordinates in all iterations
!> @param[in]     Gx            Cartesian gradient in all iterations
!> @param[in]     nAtom         Number of symmetry-unique atoms
!> @param[in]     iMEP          Number of this MEP point
!> @param[in]     iOff_iter     Iteration of the previous MEP point
!> @param[in]     iPrint        Print level
!> @param[in]     IRCRestart    Flag to mark the start of a backward IRC search
!> @param[out]    ResGrad       Residual gradient
!> @param[out]    BadConstraint Flag to signal constraint problems
!***********************************************************************

subroutine MEP_Dir(Cx,Gx,nAtom,iMEP,iOff_iter,iPrint,IRCRestart,ResGrad,BadConstraint)

use Symmetry_Info, only: nIrrep
use Slapaf_Info, only: dMEPStep, IRC, iter, MEP, MEP_Algo, MEP_Type, MEPNum, MF, nLambda, nMEP, RefGeo, rMEP, Weights
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtom, iMEP, iOff_iter, iPrint
real(kind=wp), intent(inout) :: Cx(3*nAtom,iter+1)
real(kind=wp), intent(in) :: Gx(3*nAtom,iter+1)
logical(kind=iwp), intent(in) :: IRCRestart
real(kind=wp), intent(out) :: ResGrad
logical(kind=iwp), intent(out) :: BadConstraint
integer(kind=iwp) :: iAd, iAtom, iDum(1), iLambda, iOff, iPrev_iter, ixyz, LudRdX, nCoor, nCoor_, nLambda_
real(kind=wp) :: ConstraintAngle, Curvature, dd, dDir, dDisp, dGrad, dPostDir, dPostDirGrad, dPrevDir, dPrevDirDisp, dPrevDirGrad, &
                 dPrevDirPostDir, drd, Fact, PathAngle, PathLength, TWeight, xWeight
real(kind=wp), allocatable :: Cen(:,:), Cur(:), Dir(:,:), Disp(:,:), drdx(:,:), Grad(:,:), PLn(:), PostDir(:,:), PrevDir(:,:)
integer(kind=iwp), external :: iDeg
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
nCoor = 3*nAtom
iPrev_iter = max(iOff_iter,1)
call mma_allocate(PrevDir,3,nAtom,Label='PrevDir')
call mma_allocate(PostDir,3,nAtom,Label='PostDir')
call mma_allocate(Disp,3,nAtom,Label='Disp')
call mma_allocate(Grad,3,nAtom,Label='Grad')
call mma_allocate(Dir,3,nAtom,Label='Dir')
call mma_allocate(Cen,3,nAtom,Label='Cen')

! Obtain some useful vectors:
! PrevDir: difference between ref. structure and previous MEP point
! PostDir: difference between current MEP point and ref. structure
! Disp:    difference between current and previous MEP points
! Grad:    gradient at current MEP point

if (iter > 1) then
  PrevDir(:,:) = RefGeo(:,:)-reshape(Cx(:,iPrev_iter),[3,nAtom])
  PostDir(:,:) = reshape(Cx(:,iter),[3,nAtom])-RefGeo(:,:)
  Disp(:,:) = PrevDir(:,:)+PostDir(:,:)
else
  PrevDir(:,:) = Zero
  PostDir(:,:) = Zero
  Disp(:,:) = Zero
end if
Grad(:,:) = reshape(Gx(:,iter),[3,nAtom])

! Normalize the vectors in weighted coordinates
! and compute some angles that provide information on the path
! shape and quality.
! Note that gradient and coordinates transform differently

TWeight = Zero
dPrevDir = Zero
dPostDir = Zero
dDisp = Zero
dGrad = Zero
dPostDirGrad = Zero
dPrevDirGrad = Zero
dPrevDirDisp = Zero
dPrevDirPostDir = Zero
iOff = 0
do iAtom=1,nAtom
  Fact = real(iDeg(Cx(1+iOff,iter)),kind=wp)
  xWeight = Weights(iAtom)
  TWeight = TWeight+Fact*xWeight
  do ixyz=1,3
    dPrevDir = dPrevDir+Fact*xWeight*PrevDir(ixyz,iAtom)**2
    dPostDir = dPostDir+Fact*xWeight*PostDir(ixyz,iAtom)**2
    dDisp = dDisp+Fact*xWeight*Disp(ixyz,iAtom)**2
    dGrad = dGrad+Fact*Grad(ixyz,iAtom)**2/xWeight
    dPostDirGrad = dPostDirGrad+Fact*PostDir(ixyz,iAtom)*Grad(ixyz,iAtom)
    dPrevDirGrad = dPrevDirGrad+Fact*PrevDir(ixyz,iAtom)*Grad(ixyz,iAtom)
    dPrevDirDisp = dPrevDirDisp+Fact*xWeight*PrevDir(ixyz,iAtom)*Disp(ixyz,iAtom)
    dPrevDirPostDir = dPrevDirPostDir+Fact*xWeight*PrevDir(ixyz,iAtom)*PostDir(ixyz,iAtom)
    iOff = iOff+1
  end do
end do
dPrevDir = sqrt(dPrevDir)
dPostDir = sqrt(dPostDir)
dDisp = sqrt(dDisp)
dGrad = sqrt(dGrad)
if (dPrevDir > Zero) PrevDir(:,:) = PrevDir(:,:)/dPrevDir
if (dPostDir > Zero) PostDir(:,:) = PostDir(:,:)/dPostDir
if (dDisp > Zero) Disp(:,:) = Disp(:,:)/dDisp
if (dGrad > Zero) Grad(:,:) = Grad(:,:)/dGrad
! Any zero vector is assumed to be parallel to any other
if (dPostDir*dGrad > Zero) then
  dPostDirGrad = dPostDirGrad/(dPostDir*dGrad)
else
  dPostDirGrad = One
end if
if (dPrevDir*dGrad > Zero) then
  dPrevDirGrad = dPrevDirGrad/(dPrevDir*dGrad)
else
  dPrevDirGrad = One
end if
if (dPrevDir*dDisp > Zero) then
  dPrevDirDisp = dPrevDirDisp/(dPrevDir*dDisp)
else
  dPrevDirDisp = One
end if
if (dPrevDir*dPostDir > Zero) then
  dPrevDirPostDir = dPrevDirPostDir/(dPrevDir*dPostDir)
else
  dPrevDirPostDir = One
end if
! A negative curvature means there is no appropriate value
Curvature = -1.0e-12_wp
PathLength = dDisp/sqrt(TWeight)
if (MEP .and. (MEP_Type == 'SPHERE    ')) then
  ! The curvature is the inverse radius of the circle tangent to
  ! both the current and previous MEP points
  ! The path length is the arc length between these points
  if (One-dPrevDirPostDir > Zero) Curvature = (One-dPrevDirPostDir)/sqrt(One-dPrevDirPostDir**2)/sqrt(dPrevDir*dPostDir/TWeight)
  if (Curvature > Zero) PathLength = acos(dPrevDirPostDir)/Curvature
end if

! Store the length and curvature values, and print results

call mma_allocate(PLn,nMEP+1,Label='PLn')
call mma_allocate(Cur,nMEP+1,Label='Cur')
if (iMEP >= 1) then
  call Get_dArray('MEP-Lengths   ',PLn,nMEP+1)
  call Get_dArray('MEP-Curvatures',Cur,nMEP+1)
  if (IRC == -1) then
    PLn(1+iMEP) = -PathLength
  else
    PLn(1+iMEP) = PathLength
  end if
  Cur(1+iMEP) = Curvature
  call Put_dArray('MEP-Lengths   ',PLn,nMEP+1)
  call Put_dArray('MEP-Curvatures',Cur,nMEP+1)
  if ((iMEP >= 1) .and. (iPrint >= 5)) then
    if (MEP_Type == 'TRANSVERSE') then
      ConstraintAngle = acos(dPrevDirGrad)/deg2rad
    else
      ConstraintAngle = acos(dPostDirGrad)/deg2rad
    end if
    if (MEP) then
      PathAngle = acos(dPrevDirPostDir)/deg2rad
    else
      PathAngle = acos(-dPrevDirDisp)/deg2rad
    end if
    ResGrad = dGrad
    write(u6,*)
    write(u6,'(a)') ' Last IRC/MEP step (in weighted coordinates / sqrt(total weight))'
    write(u6,'(a)') ' --------------------------------------------------------'
    write(u6,100) 'Residual gradient size:',ResGrad,'hartree/bohr'
    write(u6,100) 'Angle with constraint surface:',ConstraintAngle,'degrees'
    write(u6,100) 'Path angle:',PathAngle,'degrees'
    if (Curvature >= Zero) write(u6,100) 'Path curvature:',Curvature,'bohr^(-1)'
    write(u6,100) 'Path length:',PathLength,'bohr'
  end if
else
  PLn(:) = Zero
  Cur(:) = Zero
  call Put_dArray('MEP-Lengths   ',PLn,nMEP+1)
  call Put_dArray('MEP-Curvatures',Cur,nMEP+1)
end if
call mma_deallocate(PLn)
call mma_deallocate(Cur)

! Do not mess with the geometry or reference if the next iteration
! will be the start of a reverse IRC search.

if (.not. IRCRestart) then

  ! The new direction for the MEP should be the gradient in weighted
  ! coordinates, but this may break additional constraints if they
  ! exist, and the gradient may be close to zero.
  ! Instead, we will use the direction that, on convergence, should
  ! be parallel to the gradient when there are no other constraints.
  ! Note that we could be following the gradient uphill

  if (MEP_Type == 'TRANSVERSE') then
    ! In the TRANSVERSE case, PrevDir is the vector parallel to the
    ! gradient, but following this will never change the hyperplane
    ! orientation.
    ! We will try using a linear combination of PrevDir and Disp
    !   dp  = Disp.PrevDir
    !   Dir = dp*Disp + a*(PrevDir-dp*Disp)
    !       = a*PrevDir + (1-a)*dp*Disp
    ! Try different values for Fact (the "a" above).
    ! I believe the true MEP direction should be more slanted from
    ! the plane normal (PrevDir) than the Disp vector, therefore
    ! a negative value is probably better.
    Fact = -Half
    Dir(:,:) = Fact*PrevDir(:,:)+(One-Fact)*dPrevDirDisp*Disp(:,:)
  else
    ! In the SPHERE case, PostDir is the vector to use
    Dir(:,:) = PostDir(:,:)
  end if

  ! Special cases

  if (iMEP == 0) then
    if (IRC == 0) then
      ! In the initial iteration of a MEP, use the initial direction
      call Get_dArray('Transverse',Dir(:,:),nCoor)
    else
      ! In the initial iteration of an IRC branch, use the reaction vector
      Dir(:,:) = MF(:,:)
    end if
  end if

  ! Project any additional constraints out of the direction vector
  ! The constraint vectors are read from the dRdX file

  LudRdX = 30
  call DaName(LudRdX,'dRdX')
  iAd = 0
  call iDaFile(LudRdX,2,iDum,1,iAd)
  nLambda_ = iDum(1)
  call iDaFile(LudRdX,2,iDum,1,iAd)
  nCoor_ = iDum(1)
  call mma_allocate(drdx,nCoor_,nLambda_,Label='drdx')
  call dDaFile(LudRdX,2,drdx,nLambda_*nCoor_,iAd)
  call DaClos(LudRdX)
  do iLambda=1,nLambda
    if (iLambda /= MEPnum) then
      dd = dDot_(nCoor,drdx(:,iLambda),1,drdx(:,iLambda),1)
      drd = dDot_(nCoor,drdx(:,iLambda),1,Dir(:,:),1)
      Dir(:,:) = Dir(:,:)-drd/dd*reshape(drdx(:,iLambda),[3,nAtom])
    end if
  end do
  call mma_deallocate(drdx)

  ! Compute the length of the direction vector in weighted coordinates

  dDir = Zero
  iOff = 0
  do iAtom=1,nAtom
    Fact = real(iDeg(Cx(1+iOff,iter)),kind=wp)
    xWeight = Weights(iAtom)
    do ixyz=1,3
      dDir = dDir+Fact*xWeight*Dir(ixyz,iAtom)**2
      iOff = iOff+1
    end do
  end do
  dDir = sqrt(dDir)

  ! According to the Gonzalez-Schlegel method, the reference point
  ! is half-step away in the search direction.
  ! First set the new reference point (except for rMEP) and then
  ! compute the new starting structure at the full step distance
  ! For an IRC first step, keep the initial structure as reference

  Fact = dMEPStep*sqrt(TWeight)/dDir
  Cen(:,:) = reshape(Cx(:,iter),[3,nAtom])
  if (MEP_Algo == 'GS') then
    if ((IRC == 0) .or. (iMEP /= 0)) call Find_Distance(Cx(:,iter),Cen(:,:),Dir(:,:),Half*Fact,Half*dMEPStep,nAtom,BadConstraint)
    if (.not. rMEP) call Put_dArray('Ref_Geom',Cen(:,:),nCoor)
    call Find_Distance(Cen(:,:),Cx(:,iter+1),Dir(:,:),Half*Fact,Half*dMEPStep,nAtom,BadConstraint)
  else if (MEP_Algo == 'MB') then
    if (.not. rMEP) call Put_dArray('Ref_Geom',Cx(1,iter),nCoor)
    call Find_Distance(Cx(:,iter),Cx(:,iter+1),Dir(:,:),Fact,dMEPStep,nAtom,BadConstraint)
  end if

  ! Randomly displace the new geometry 1/20th of the MEP distance
  ! to try to break symmetry

  if (nIrrep == 1) then
    call Random_Vector(nCoor,Disp(:,:),.true.)
    dDir = Zero
    iOff = 0
    do iAtom=1,nAtom
      xWeight = Weights(iAtom)
      do ixyz=1,3
        dDir = dDir+xWeight*Disp(ixyz,iAtom)**2
        iOff = iOff+1
      end do
    end do
    Fact = dMEPStep*sqrt(TWeight/dDir)
    Cx(:,iter+1) = Cx(:,iter+1)+0.05_wp*Fact*reshape(Disp(:,:),[nCoor])
  end if
  call Put_dArray('Transverse',Dir(:,:),nCoor)
  if (iter == 1) BadConstraint = .false.
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(PrevDir)
call mma_deallocate(PostDir)
call mma_deallocate(Disp)
call mma_deallocate(Grad)
call mma_deallocate(Dir)
call mma_deallocate(Cen)

return

100 format(1X,A30,1X,F12.6,1X,A)

end subroutine MEP_Dir

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine output11 (unit,sscounter,ssorder1,ssorder2,ssorder3,
     *                     ss,sschar,termcounter,termleng,termorder,
     *                     dtcoeff,term)
c
c****************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 19.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*****************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer unit,sscounter,ssorder1,ssorder2,ssorder3,termcounter,
     *        termleng(maxoperators),termorder(maxoperators,3)
      REAL*8 dtcoeff(maxoperators)
#if defined(_MOLCAS_) || defined(MOLPRO)
      integer term(*)
      character*(maxlength) termstr
#else
      character*(maxlength) term(maxoperators)
#endif
      character*(4) ss
      character*(9) sschar
      integer j
c
      write (unit,1001) ss,sschar,ssorder1,ssorder2,ssorder3,sscounter
1001  format ('***',/A4,1X,A9,1X,I2,1X,I2,1X,I2,2X,I7)
      do 10 j=1,sscounter
#if defined(_MOLCAS_) || defined(MOLPRO)
        call get_dkoperators_i(j,termstr,term)
        write (unit,2001) j,termleng(j),termorder(j,1),termorder(j,2),
     *                    termorder(j,3),termstr(1:termleng(j)),
     *                    dtcoeff(j)
#else
        write (unit,2001) j,termleng(j),termorder(j,1),termorder(j,2),
     *                    termorder(j,3),term(j)(1:termleng(j)),
     *                    dtcoeff(j)
#endif
2001    format (I7,2X,I3,3X,I2,1X,I2,1X,I2,1X,A90,4X,F17.14)
  10  continue
      write (unit,3001)
3001  format (/2X)
c
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(termcounter)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine recover_exch_HAM_from_Naoya_ITO(n1,n2,J,HAM)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n1, n2
complex(kind=wp), intent(in) :: J(n1-1,-(n1-1):n1-1,n2-1,-(n2-1):n2-1)
complex(kind=wp), intent(out) :: HAM(n1,n1,n2,n2)
integer(kind=iwp) :: k1, k2, l1, l2, q1, q2
real(kind=wp) :: C01, C02
complex(kind=wp), allocatable :: O1(:,:), O2(:,:), OO(:,:,:,:), OW(:,:,:,:), W1(:,:), W2(:,:), WO(:,:,:,:), WW(:,:,:,:)

!-----------------------------------------------------------------------
! recover the original HAMILTONIAN using the J parameters
!=======================================================================
call mma_allocate(O1,n1,n1,'operator O1')
call mma_allocate(O2,n2,n2,'operator O2')
call mma_allocate(W1,n1,n1,'operator W1')
call mma_allocate(W2,n2,n2,'operator W2')
call mma_allocate(OO,n1,n1,n2,n2,'operator OO')
call mma_allocate(OW,n1,n1,n2,n2,'operator WO')
call mma_allocate(WO,n1,n1,n2,n2,'operator OW')
call mma_allocate(WW,n1,n1,n2,n2,'operator WW')
HAM(:,:,:,:) = cZero
do k1=1,n1-1
  do q1=0,k1
    do k2=1,n2-1
      do q2=0,k2
        ! generate the operator matrix K=ik, Q=iq, dimension=na
        call ITO(n1,k1,q1,C01,O1,W1)
        call ITO(n2,k2,q2,C02,O2,W2)
        ! generate coupled operators:
        do l1=1,n2
          do l2=1,n2
            OO(:,:,l1,l2) = O1(:,:)*O2(l1,l2)
            OW(:,:,l1,l2) = O1(:,:)*W2(l1,l2)
            WO(:,:,l1,l2) = W1(:,:)*O2(l1,l2)
            WW(:,:,l1,l2) = W1(:,:)*W2(l1,l2)
          end do
        end do
        ! compute the exchange Hamiltonian:
        if ((q1 == 0) .and. (q2 == 0)) then
          HAM(:,:,:,:) = HAM(:,:,:,:)+J(k1,0,k2,0)*OO(:,:,:,:)
        else if ((q1 == 0) .and. (q2 /= 0)) then
          HAM(:,:,:,:) = HAM(:,:,:,:)+J(k1,0,k2,q2)*OO(:,:,:,:)+J(k1,0,k2,-q2)*OW(:,:,:,:)
        else if ((q1 /= 0) .and. (q2 == 0)) then
          HAM(:,:,:,:) = HAM(:,:,:,:)+J(k1,q1,k2,0)*OO(:,:,:,:)+J(k1,-q1,k2,0)*WO(:,:,:,:)
        else if ((q1 /= 0) .and. (q2 /= 0)) then
          HAM(:,:,:,:) = HAM(:,:,:,:)+J(k1,q1,k2,q2)*OO(:,:,:,:)+J(k1,q1,k2,-q2)*OW(:,:,:,:)+J(k1,-q1,k2,q2)*WO(:,:,:,:)+ &
                         J(k1,-q1,k2,-q2)*WW(:,:,:,:)
        end if
      end do !q
    end do !k
  end do !q
end do !k

call mma_deallocate(O1)
call mma_deallocate(O2)
call mma_deallocate(W1)
call mma_deallocate(W2)
call mma_deallocate(OO)
call mma_deallocate(OW)
call mma_deallocate(WO)
call mma_deallocate(WW)

return

end subroutine recover_exch_HAM_from_Naoya_ITO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_RESETCNF
C
C     Purpose: reset configuration of decomposition to that read from
C              restart file. Original configuration will be saved in
C              restart common block.
C
      IMPLICIT NONE
#include "cholesky.fh"

      CALL CHO_DSWAP(THRCOM,XTHRCOM)
      CALL CHO_DSWAP(THRDIAG,XTHRDIAG)
      CALL CHO_DSWAP(DAMP(1),XDAMP(1))
      CALL CHO_DSWAP(DAMP(2),XDAMP(2))
      CALL CHO_DSWAP(SPAN,XSPAN)
      CALL CHO_DSWAP(THRNEG,XTHRNEG)
      CALL CHO_DSWAP(WARNEG,XWARNEG)
      CALL CHO_DSWAP(TOONEG,XTOONEG)
      CALL CHO_LSWAP(SCDIAG,XSCDIAG)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NatOrb_RASSCF(CMOO,SCR1,SCR2,SMAT,CMON,OCCN)
! RASSCF program: version IBM-3090: Output section
!
! PURPOSE: Calculation of natural orbitals from the
!          density matrix. These orbitals are written onto JOBIPH
!          in position IADR15(12), followed by the occupation
!          numbers in IADR15(13).
!          The calculation is performed for each of the NROOT
!          density matrices obtained in an average CASSCF calc.
!          Called from MAIN before OUTCTL
!
!      ****** IBM 3090 MOLCAS Release: 90 02 22 ******

use Index_Functions, only: nTri_Elem
use rasscf_global, only: iADR15, KSDFT, lRoots, NACPAR, NACPR2
use PrintLevel, only: DEBUG, USUAL
use output_ras, only: IPRLOC
use general_data, only: JOBIPH, NASH, NBAS, NFRO, NISH, NSYM, NTOT, NTOT2
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMOO(*)
real(kind=wp), intent(_OUT_) :: SCR1(*), SCR2(*), SMAT(*), CMON(*), OCCN(*)
integer(kind=iwp) :: I, IB, IBAS, ID, iDisk, IEND, II, IO, iOff, iPrLev, IST, iSTMO, ISTMO1, ISYM, J, jDisk, kRoot, NA1, NAO, NB, &
                     NB2, NFI

IPRLEV = IPRLOC(7)
iDisk = IADR15(12)
jDisk = IADR15(3)

do kRoot=1,lRoots
  if ((KSDFT == 'SCF') .and. (IPRLEV >= USUAL)) then
    write(u6,*)
    write(u6,'(6X,A,I3)') 'Natural orbitals and occupation numbers for root',kRoot
  end if
  call DDaFile(JOBIPH,2,SCR1,NACPAR,jDisk)
  call DDaFile(JOBIPH,0,SCR1,NACPAR,jDisk)
  call DDaFile(JOBIPH,0,SCR1,NACPR2,jDisk)
  call DDaFile(JOBIPH,0,SCR1,NACPR2,jDisk)
  call DBLOCK(SCR1)

  OCCN(1:NTOT) = Zero
  CMON(1:NTOT2) = CMOO(1:NTOT2)

  ID = 0
  ISTMO1 = 0
  IB = 0
  do ISYM=1,NSYM
    NB = NBAS(ISYM)
    NFI = NFRO(ISYM)+NISH(ISYM)
    NAO = NASH(ISYM)
    NB2 = NB**2
    NA1 = nTri_Elem(NAO)
    IO = IB+NFI
    ISTMO = ISTMO1+NB*NFI

    ! set occupation number of frozen and inactive orbitals

    OCCN(IB+1:IB+NFI) = Two

    ! Diagonalize the density matrix and transform orbitals

    if (NAO > 0) then
      call unitmat(SCR2,NAO)
      call JACOB(SCR1(ID+1),SCR2,NAO,NAO)
      II = 0
      do I=1,NAO
        II = II+I
        OCCN(IO+I) = SCR1(II+ID)
      end do
      IST = IO+1
      IEND = IO+NAO
      if ((KSDFT == 'SCF') .and. (IPRLEV >= USUAL)) write(u6,'(6X,A3,I2,A1,10F11.6,/,(12X,10F11.6))') 'sym',iSym,':', &
                                                                                                      (OCCN(I),I=IST,IEND)
      call DGEMM_('N','N',NB,NAO,NAO,One,CMOO(ISTMO+1),NB,SCR2,NAO,Zero,CMON(ISTMO+1),NB)
    end if

    ID = ID+NA1
    ISTMO1 = ISTMO1+NB2
    IB = IB+NB
  end do

  ! ORTHOGONALIZE NEW MO'S

  call SUPSCH(SMAT,CMOO,CMON)
  call ORTHO_RASSCF(SMAT,SCR1,CMON,SCR2)

  ! Place NOs wrt decreasing order of OCCN
  !***  GLM commented it off for this reordering is not consistent
  !GLM throughout Molcas
  !
  !iOff = 0
  !jOff = 0
  !do iSym=1,nSym
  !  NB = nBas(iSym)
  !  NAO = nAsh(iSym)
  !  IA = 1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
  !  JA = 1+jOff+nFro(iSym)+nIsh(iSym)
  !  call Order_Arrays('decr',CMON(IA),NB,NAO,OCCN(JA),SCR1)
  !  iOff = iOff+NB**2
  !  jOff = jOff+NB
  !end do

  if (IPRLEV >= DEBUG) then
    write(u6,*)
    write(u6,*) ' CMON in NATORB_RASSCF after ORDER_ARRAYS'
    write(u6,*) ' ---------------------'
    write(u6,*)
    ioff = 0
    do iSym=1,nSym
      iBas = nBas(iSym)
      if (iBas /= 0) then
        write(u6,*) 'Sym =',iSym
        do i=1,iBas
          write(u6,*) (CMON(ioff+iBas*(i-1)+j),j=1,iBas)
        end do
        iOff = iOff+(iBas*iBas)
      end if
    end do
  end if

  ! Write new molecular orbitals and occupation numbers to JOBIPH

  call DDAFILE(JOBIPH,1,CMON,NTOT2,iDisk)
  call DDAFILE(JOBIPH,1,OCCN,NTOT,iDisk)
end do

end subroutine NatOrb_RASSCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_REOVC1(IRS2F,N,LRDIM,WRK,LWRK)
!
! Purpose: reorder Cholesky vectors on disk to full storage.

use Symmetry_Info, only: Mul
use Cholesky, only: iiBstR, LuPri, NABPK, NNBST, nnBstR, nSys_call, nSym, NumCho
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, LRDIM, IRS2F(N,LRDIM), LWRK
real(kind=wp), intent(inout) :: WRK(LWRK)
integer(kind=iwp) :: I, IAB, IBATCH, ICOUNT, IOFF(8,8), IRS, ISYM, ISYMA, ISYMB, IVEC, IVEC1, KCHO1, KCHO2, KOFF, KOFF1, KREAD, &
                     LOFF, LREAD, MINMEM, NBATCH, NSCALL, NUMV, NVEC
character(len=*), parameter :: SECNAM = 'CHO_REOVC1'

if (N < 3) call CHO_QUIT('Dimension error in '//SECNAM,104)

! Save read-call counter.
! -----------------------

NSCALL = NSYS_CALL

! Make rs1 the "current" reduced set (for reading).
! -------------------------------------------------

call CHO_RSCOPY(1,2)

! Loop over Cholesky vector symmetries.
! -------------------------------------

do ISYM=1,NSYM
  if (NUMCHO(ISYM) > 0) then

    ! Open files.
    ! -----------

    call CHO_OPFVEC(ISYM,1)

    ! Set up vector batch.
    ! --------------------

    MINMEM = NNBSTR(ISYM,2)+NNBST(ISYM)
    if (MINMEM < 1) then
      write(LUPRI,*) SECNAM,': MINMEM = ',MINMEM
      call CHO_QUIT('NNBST error in '//SECNAM,104)
      NVEC = 0
    else
      NVEC = min(LWRK/MINMEM,NUMCHO(ISYM))
    end if

    if (NVEC < 1) then
      write(LUPRI,*) SECNAM,': NVEC   = ',NVEC
      write(LUPRI,*) SECNAM,': LWRK   = ',LWRK
      write(LUPRI,*) SECNAM,': MINMEM = ',MINMEM
      write(LUPRI,*) SECNAM,': NUMCHO = ',NUMCHO(ISYM)
      write(LUPRI,*) SECNAM,': ISYM   = ',ISYM
      call CHO_QUIT('Batch error in '//SECNAM,101)
      NBATCH = 0
    else
      NBATCH = (NUMCHO(ISYM)-1)/NVEC+1
    end if

    ! Start batch loop over vectors.
    ! ------------------------------

    do IBATCH=1,NBATCH

      if (IBATCH == NBATCH) then
        NUMV = NUMCHO(ISYM)-NVEC*(NBATCH-1)
      else
        NUMV = NVEC
      end if
      IVEC1 = NVEC*(IBATCH-1)+1

      ! Read batch of reduced vectors.
      ! ------------------------------

      KCHO1 = 1
      KREAD = KCHO1+NNBSTR(ISYM,2)*NUMV
      LREAD = LWRK-KREAD+1
      call CHO_GETVEC(WRK(KCHO1),NNBSTR(ISYM,2),NUMV,IVEC1,ISYM,WRK(KREAD),LREAD)

      ! Reorder.
      ! --------

      KCHO2 = KREAD
      IOFF(:,:) = 0
      ICOUNT = KCHO2-1
      do ISYMB=1,NSYM
        ISYMA = MUL(ISYMB,ISYM)
        if (ISYMA >= ISYMB) then
          IOFF(ISYMA,ISYMB) = ICOUNT
          IOFF(ISYMB,ISYMA) = ICOUNT
          ICOUNT = ICOUNT+NABPK(ISYMA,ISYMB)*NUMV
        end if
      end do

      WRK(KCHO2:KCHO2+NNBST(ISYM)*NUMV-1) = Zero
      do IVEC=1,NUMV
        KOFF1 = KCHO1+NNBSTR(ISYM,2)*(IVEC-1)-1
        do IRS=1,NNBSTR(ISYM,2)
          I = IIBSTR(ISYM,2)+IRS
          ISYMA = IRS2F(1,I)
          ISYMB = IRS2F(2,I)
          IAB = IRS2F(3,I)
          KOFF = KOFF1+IRS
          LOFF = IOFF(ISYMA,ISYMB)+NABPK(ISYMA,ISYMB)*(IVEC-1)+IAB
          WRK(LOFF) = WRK(KOFF)
        end do
      end do

      ! Write full vectors to disk.
      ! ---------------------------

      do ISYMB=1,NSYM
        ISYMA = MUL(ISYMB,ISYM)
        if (ISYMA >= ISYMB) then
          KOFF = IOFF(ISYMA,ISYMB)+1
          call CHO_WRFVEC(WRK(KOFF),ISYMA,ISYMB,IVEC1,NUMV)
        end if
      end do

    end do

    ! Close files.
    ! ------------

    call CHO_OPFVEC(ISYM,2)

  end if
end do

! Restore read-call counter.
! --------------------------

NSYS_CALL = NSCALL

end subroutine CHO_REOVC1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION CHO_LREAD(ISYM,LWRK)
C
C     Purpose: return a reasonable scratch space dimension for reading
C              previous vectors using cho_getvec.
C
      use ChoSwp, only: InfVec
#include "implicit.fh"
#include "cholesky.fh"

      INTEGER MNVECRS1
      PARAMETER (MNVECRS1 = 5)

      IF (CHO_IOVEC .EQ. 1) THEN
         IF (NVECRS1(ISYM).LT.1 .AND. NUMCHO(ISYM).GT.0) THEN
            NVECRS1(ISYM) = 1
            JVEC = 1
            IRED = INFVEC(JVEC,2,ISYM)
            DO WHILE (JVEC .LT. NUMCHO(ISYM))
               JVEC = JVEC + 1
               JRED = INFVEC(JVEC,2,ISYM)
               IF (JRED .EQ. IRED) THEN
                  NVECRS1(ISYM) = NVECRS1(ISYM) + 1
               ELSE
                  JVEC = NUMCHO(ISYM)
               END IF
            END DO
         END IF
         LEN1 = LWRK/3 - 1
         LEN2 = MAX(NVECRS1(ISYM),MNVECRS1)*NNBSTR(ISYM,1)
         LEN3 = MIN(LEN1,LEN2)
         LMIN = 2*NNBSTR(ISYM,1)
         CHO_LREAD = MAX(LEN3,LMIN) + 1
      ELSE IF (CHO_IOVEC.EQ.2 .OR. CHO_IOVEC.EQ.3 .OR. CHO_IOVEC.EQ.4)
     & THEN
         LEN1 = LWRK/3 - 1
         LMIN = 2*NNBSTR(ISYM,1)
         CHO_LREAD = MAX(LEN1,LMIN) + 1
      ELSE
         CHO_LREAD = 2*NNBSTR(ISYM,1)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PROPCT()
      IMPLICIT REAL*8 (A-H,O-Z)
*PAM04      DIMENSION HWork(*)
      CHARACTER*8 FNAME,LABEL
c      CHARACTER*8 REMARK
      CHARACTER*30 REMARK
      CHARACTER*100 REALNAME
#include "SysDef.fh"
#include "mrci.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      DIMENSION DUMMY(1),IDUMMY(7,8)
      REAL*8, ALLOCATABLE :: PROP(:,:,:)
*
*      LCMO=LPRP
*      LCNO=LCMO+NCMO
*      LOCC=LCNO+NCMO
*      LTDAO=LOCC+NBAST
*      LDAO=LTDAO
*      LAFOLD=LDAO+NBAST**2
*      LSFOLD=LAFOLD+NBTRI
*      LPINT =LSFOLD+NBTRI
*      LSCR  =LPINT+NBTRI+4
*      NSCR=MAX(NBTRI,NBMAX**2)
*      LTOP  =LSCR+NSCR-1
      CALL GETMEM('CMO','ALLO','REAL',LCMO,NCMO)
      CALL GETMEM('CNO','ALLO','REAL',LCNO,NCMO)
      CALL GETMEM('OCC','ALLO','REAL',LOCC,NBAST)
      CALL GETMEM('DAO','ALLO','REAL',LDAO,NBAST**2)
      LTDAO=LDAO
      CALL GETMEM('AFOLD','ALLO','REAL',LAFOLD,NBTRI)
      CALL GETMEM('SFOLD','ALLO','REAL',LSFOLD,NBTRI)
      CALL GETMEM('PINT','ALLO','REAL',LPINT,NBTRI+4)
      NSCR=MAX(NBTRI,NBMAX**2)
      CALL GETMEM('SCR','ALLO','REAL',LSCR,NSCR)
C LOOP OVER OPERATORS:
      IOPT=8
      NPROP=0
      DO 98 I=1,100
C PICK UP OPERATOR LABELS FROM ONE-ELECTRON FILE:
        LABEL='UNDEF'
        CALL iRDONE(IRTC,1+IOPT,LABEL,IPC,IDUMMY,ISYMLB)
        IF(IRTC.NE.0) GOTO 99
        IOPT=16
CPAM96        IF(IAND(1,ISYMLB).EQ.0) GOTO 98
        IF(MOD(ISYMLB,2).EQ.0) GOTO 98
        NPROP=NPROP+1
        PNAME(NPROP)=LABEL
        IPCOMP(NPROP)=IPC
        PTYPE(NPROP)='HERM'
        IF(LABEL.EQ.'VELOCITY') PTYPE(NPROP)='ANTI'
        IF(LABEL.EQ.'ANGMOM  ') PTYPE(NPROP)='ANTI'
98    CONTINUE
99    CONTINUE
      CALL MMA_ALLOCATE(PROP,NRROOT,NRROOT,NPROP,'PROP')
      CALL DCOPY_(NRROOT*NRROOT*NPROP,[0.0D00],0,PROP,1)
      IDDMO=0
      DO 100 ISTATE=1,NRROOT
C PICK UP DMO
*PAM04        CALL dDAFILE(LUEIG,2,HWork(LDMO),NBTRI,IDDMO)
        CALL dDAFILE(LUEIG,2,Work(LDMO),NBTRI,IDDMO)
C PICK UP CMO
        IDISK=ITOC17(1)
        CALL dDAFILE(LUONE,2,Work(LCMO),NCMO,IDISK)
C COMPUTE & WRITE NATURAL ORBITALS
*PAM04        CALL NATORB_MRCI(HWork(LCMO),HWork(LDMO),HWork(LCNO),
        CALL NATORB_MRCI(Work(LCMO),Work(LDMO),Work(LCNO),
     *                   Work(LOCC),Work(LSCR))
        WRITE(FNAME,'(A5,I2.2)')'CIORB',ISTATE
        REALNAME=FNAME
*PAM04        IF(ISTATE.EQ.1) Call Add_Info('CI_DENS1',HWork(LDMO),1,5)
        IF(ISTATE.EQ.1) Call Add_Info('CI_DENS1',Work(LDMO),1,5)
        REMARK='* MRCI  '
c** Gusarov , include 1st root acpf energy to CiOrb file:
c         IF(ICPF.EQ.1) REMARK='* ACPF  '
        IF(ICPF.EQ.1)
     &  write(REMARK,'(8H* ACPF  ,f22.16)') ESMALL(1)+ESHIFT
c
        CALL WRVEC(REALNAME,LUVEC,'CO',NSYM,NBAS,NBAS,
     &  Work(LCNO), Work(LOCC), Dummy, iDummy,REMARK)
        WRITE(6,*)
        WRITE(6,'(A,I2)')' NATURAL ORBITALS OF STATE NR. ',ISTATE
        WRITE(6,*)' FULL SET OF ORBITALS ARE SAVED ON FILE ',REALNAME
        CALL PRORB(Work(LCNO),Work(LOCC))
        WRITE(6,*)' ',('*',I=1,70)
C CREATE DAO
        CALL MKDAO(Work(LCNO),Work(LOCC),Work(LDAO))
C CALL PMATEL TO CALCULATE CHARGES AND PROPERTIES.
C PUT PROPERTIES INTO APPROPRIATE MATRICES.
        CALL PMATEL (ISTATE,ISTATE,PROP,Work(LPINT),Work(LSCR),
     *               Work(LCNO),Work(LOCC),
     *               Work(LSFOLD),Work(LAFOLD),Work(LDAO))
100   CONTINUE
C ENERGIES SAVED FROM PREVIOUS OUTPUT REPEATED HERE FOR CONVENIENCE:
      WRITE(6,*)
      WRITE(6,*)' SUMMARY OF ENERGIES:'
      DO 987 ISTA=1,NRROOT,4
        IEND=MIN(ISTA+3,NRROOT)
        WRITE(6,'(1X,A,I8,3I16)')
     *  '               ROOT:',(I,I=ISTA,IEND)
        WRITE(6,'(1X,A,4F16.8)')
     *  '       TOTAL ENERGY:',(ENGY(I,1),I=ISTA,IEND)
        IF(ICPF.EQ.0) THEN
          WRITE(6,'(1X,A,4F16.8)')
     *  'DAVIDSON CORRECTION:',(ENGY(I,2),I=ISTA,IEND)
          WRITE(6,'(1X,A,4F16.8)')
     *  '    ACPF CORRECTION:',(ENGY(I,3),I=ISTA,IEND)
      END IF
      WRITE(6,*)
987   CONTINUE
* ---------------------------------------------------
*PAM Grep-able energy output for convenience:
      WRITE(6,*)
      WRITE(6,*)' Energies, machine-readable format:'
      IF (ICPF.EQ.0) THEN
        DO I=1,NRROOT
         WRITE(6,'(1X,A,I3,3(5X,A,F16.8))')
     &     ' CI State ',I,'Total energy:',ENGY(I,1),
     &     'QDav:',ENGY(I,2),'QACPF:',ENGY(I,3)
        END DO
      ELSE
        DO I=1,NRROOT
         WRITE(6,'(1X,A,I3,5X,A,F16.8)')
     &     ' ACPF State ',I,'Total energy:',ENGY(I,1)
        END DO
      END IF
      WRITE(6,*)
* ---------------------------------------------------
      IF(NPROP.GT.0) THEN
C WRITE EXPECTATION VALUES:
        WRITE(6,*)
        WRITE(6,*)' EXPECTATION VALUES OF VARIOUS OPERATORS:'
        WRITE(6,*)
     *  '(Note: Electronic multipoles include a negative sign.)'
        DO 110 IPROP=1,NPROP
          IF(PTYPE(IPROP).EQ.'ANTI') GOTO 110
          DO 105 ISTA=1,NRROOT,4
            IEND=MIN(ISTA+3,NRROOT)
            WRITE(6,*)
            WRITE(6,'(1X,A,A8,A,I4)')
     *    '   PROPERTY :',PNAME(IPROP),
     *    '   COMPONENT:',IPCOMP(IPROP)
            WRITE(6,'(1X,A,3F16.8)')
     *    '    GAUGE ORIGIN:',(PORIG(I,IPROP),I=1,3)
            WRITE(6,'(1X,A,I8,3I16)')
     *    '            ROOT:',(I,I=ISTA,IEND)
            WRITE(6,'(1X,A,4F16.8)')
     *    '      ELECTRONIC:',(PROP(I,I,IPROP),I=ISTA,IEND)
            WRITE(6,'(1X,A,4F16.8)')
     *    '         NUCLEAR:',(PNUC(IPROP),I=ISTA,IEND)
            WRITE(6,'(1X,A,4F16.8)')
     *    '           TOTAL:',(PNUC(IPROP)+PROP(I,I,IPROP),I=ISTA,IEND)
105       CONTINUE
110     CONTINUE
        WRITE(6,*)
      END IF
      IF(ITRANS.EQ.0) GOTO 1000
      DO 200 ISTATE=2,NRROOT
        DO 201 JSTATE=1,ISTATE-1
C PICK UP TDMA
*PAM04        CALL dDAFILE(LUEIG,2,HWork(LTDMO),NBAST**2,IDDMO)
        CALL dDAFILE(LUEIG,2,Work(LTDMO),NBAST**2,IDDMO)
C CREATE TDAO
*PAM04        CALL MKTDAO(HWork(LCMO),HWork(LTDMO),HWork(LTDAO),HWork(LSCR))
        CALL MKTDAO(Work(LCMO),Work(LTDMO),Work(LTDAO),Work(LSCR))
C CALL PMATEL TO CALCULATE TRANSITION PROPERTIES
C PUT PROPERTIES INTO APPROPRIATE MATRICES.
        IF(NPROP.EQ.0) GOTO 201
        CALL PMATEL (ISTATE,JSTATE,PROP,Work(LPINT),Work(LSCR),
     *               Work(LCNO),Work(LOCC),
     *               Work(LSFOLD),Work(LAFOLD),Work(LTDAO))
201     CONTINUE
200   CONTINUE
      IF(NPROP.EQ.0) GOTO 1000
C WRITE PROPERTY MATRICES.
      WRITE(6,*)
      WRITE(6,*)' MATRIX ELEMENTS OF VARIOUS OPERATORS:'
      WRITE(6,*)' (INCLUDING ANY NUCLEAR CONTRIBUTIONS)'
      DO 298 IPROP=1,NPROP
        DO 299 I=1,NRROOT
          PROP(I,I,IPROP)=PROP(I,I,IPROP)+PNUC(IPROP)
299     CONTINUE
298   CONTINUE
      DO 300 IPROP=1,NPROP
        DO 301 ISTA=1,NRROOT,4
          IEND=MIN(ISTA+3,NRROOT)
          WRITE(6,*)
          WRITE(6,'(1X,A,A8,A,I4)')
     *    '   PROPERTY :',PNAME(IPROP),
     *    '   COMPONENT:',IPCOMP(IPROP)
          WRITE(6,'(1X,A,3F16.8)')
     *    '    GAUGE ORIGIN:',(PORIG(I,IPROP),I=1,3)
          WRITE(6,'(1X,A,I8,3I16)')
     *    '            ROOT:',(I,I=ISTA,IEND)
          DO 310 J=1,NRROOT
            WRITE(6,'(15X,I2,4F16.8)')
     *        J,(PROP(J,I,IPROP),I=ISTA,IEND)
310       CONTINUE
301     CONTINUE
300   CONTINUE
      WRITE(6,*)
1000  CONTINUE
      CALL GETMEM('CMO','FREE','REAL',LCMO,NCMO)
      CALL GETMEM('CNO','FREE','REAL',LCNO,NCMO)
      CALL GETMEM('OCC','FREE','REAL',LOCC,NBAST)
      CALL GETMEM('DAO','FREE','REAL',LDAO,NBAST**2)
      CALL GETMEM('AFOLD','FREE','REAL',LAFOLD,NBTRI)
      CALL GETMEM('SFOLD','FREE','REAL',LSFOLD,NBTRI)
      CALL GETMEM('PINT','FREE','REAL',LPINT,NBTRI+4)
      CALL GETMEM('SCR','FREE','REAL',LSCR,NSCR)
      CALL MMA_DEALLOCATE(PROP)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Bjorn O. Roos                                    *
************************************************************************
*--------------------------------------------*
* 1987  B. O. ROOS                           *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND, SWEDEN                 *
*--------------------------------------------*
      Subroutine tr2NsB(CMO,X1,X2,pqrs,TUrs,lBuf,MAXRS)
C
C SECOND ORDER TWO-ELECTRON TRANSFORMATION ROUTINE
C
C THIS ROUTINE IS CALLED FOR EACH SYMMETRY BLOCK OF INTEGRALS
C (ISP,ISQ,ISR,ISS) WITH ISP.GE.ISQ AND ISR.GE.ISS.
C P,Q,R,S are SO indices.
C A,B are MO indices, counting only non-frozen and non-deleted.
C T,U are occupied MO indices, only non-frozen and non-deleted.
C INTEGRALS (AB/TU) ARE ALWAYS GENERATED
C EXCHANGE INTEGRALS (AT/BU) ARE GENERATED AS FOLLOWS:
C (AT/BU) IF ISP.GE.ISR
C (AT/UB) IF ISP.GT.ISS AND ISP.NE.ISQ
C (TA/BU) IF ISQ.GT.ISR AND ISP.NE.ISQ
C (TA/UB) IF ISQ.GE.ISS AND ISP.NE.ISQ
C
C     ********** IBM-3090 RELEASE 87 09 14 **********
C     Replace MXMA with DGEMM P-AA Malmqvist 1992-05-06.
C
*
*     This and tr2NsB routines trasform non-squared AO integrals. The
*     transformed MO integrals are stored as the same as Tr2Sq
*     subroutine does.
*
      Implicit real*8(a-h,o-z)
CPAM98      COMMON/INTTRA/ISP,ISQ,ISR,ISS,NBP,NBQ,NBR,NBS,NBPQ,NBRS,IRRST,
CPAM98     &              NOCP,NOCQ,NOCR,NOCS,NPQ,LADX,LRUPQ,LURPQ,LTUPQ,
CPAM98     &              NOP,NOQ,NOR,NOS,LMOP,LMOQ,LMOR,LMOS,LMOP2,LMOQ2,
CPAM98     &              LMOR2,LMOS2,IAD13,ITP,ITQ,ITR,ITS

#include "rasdim.fh"
#include "caspt2.fh"
#include "trafo.fh"
#include "intgrl.fh"

#include "SysDef.fh"
      DIMENSION CMO(NCMO)
      Dimension X1(*),X2(*)
      Dimension PQRS(*),TURS(*)

      icc=NOCP*NOCQ*NOR*NOS

      If(ISP.gt.ISR)then


      NSYMP=NSYM*(NSYM+1)/2
      NOTU=NOCP*NOCQ
      IF(ISP.EQ.ISQ) NOTU=(NOCP**2+NOCP)/2

C SORT OF PARTIALLY TRANSFORMED INTEGRALS (TU/RS) ON UNIT LUHLF3
      IPQMX3=NBRS
      IF(NBRS*NOTU.GT.LTUPQ) THEN
       IPQMX3=LTUPQ/NOTU
c      WRITE(*,*)'OUT OF CORE SORT FOR INTEGRALS (TU/RS)',IPQMX3,nbrs
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,TURS,IPQMX3,IAD3S)
      ENDIF
      IAD3=0
      IOUT3=0

c MaxRS should be given
      IRS=0
      LRS=0
      NRS=0
      Kread=0
      Nread=NBRS/MaxRS
      Nrest=mod(NBRS,MaxRS)
      If(Nrest.eq.0)then
       Nrest=MaxRS
      Else
       Nread=Nread+1
      Endif

       If(icc.ne.0)then

c Loop over r,s pair
        Do NR=1,NBR
         NumRS=NBS
         If(ISR.eq.ISS)NumRS=NR
         Do NS=1,NumRS
          IRS=IRS+1

c Loop over p,q pair
          If(LRS.eq.NRS)then
           Kread=Kread+1
           IPQ=0
           LPQ=0
           NPQ=0
           iRc=0
           iOpt=1
           IRSST=1-NBRS
           Do NP=1,NBP
            NumPQ=NBQ
            If(ISP.eq.ISQ)NumPQ=NP
            Do NQ=1,NumPQ
             IPQ=IPQ+1

c  Read integrals (pq,rs)
             If(LPQ.eq.NPQ) then
              Call Rdord(iRc,iOpt,ISP,ISQ,ISR,ISS,X1,lBuf,nPQ)
              IF(IRC.GT.1) THEN
                WRITE(6,*)' ERROR RETURN CODE IRC=',IRC
                WRITE(6,*)' FROM RDORD, CALLED FROM TRA2.'
                CALL Abend
              END IF
              iOpt=2
              LPQ=0
              IRSST=1-NBRS
             Endif
             LPQ=LPQ+1
             IRSST=IRSST+NBRS
c Here, we have all the (pq,rs) for this p,q pair
c Copy X1 and construct (pq,rs) for this p,q pair
             Length=MaxRS
             If(Kread.eq.Nread)Length=Nrest
             call dcopy_(Length,X1(IRSST+MaxRS*(Kread-1)),1,
     &                         PQRS(IPQ),NBPQ)
c End of loop over p,q pair
            Enddo
           Enddo
           LRS=0
           NRS=Length
          Endif
          LRS=LRS+1

c Transfer for this r,s pair
          If(ISP.eq.ISQ)then
           Call Square(PQRS(NBPQ*(LRS-1)+1),X2,1,NBP,NBP)
c (pq,rs) -> (pU,rs)
           CALL DGEMM_('T','N',
     &                 NBP,NOCQ,NBQ,
     &                 1.0d0,X2,NBQ,
     &                 CMO(LMOQ2),NBQ,
     &                 0.0d0,X1,NBP)
c (pU,rs) -> (TU,rs)
           CALL MXMT(X1,       NBP,1,
     &               CMO(LMOP2),1,NBP,
     &               X2,
     &               NOCP,NBP)
          Else
           call dcopy_(NBPQ,PQRS(NBPQ*(LRS-1)+1),1,X2,1)
c (pq,rs) -> (pU,rs)
           CALL DGEMM_('T','N',
     &                 NBP,NOCQ,NBQ,
     &                 1.0d0,X2,NBQ,
     &                 CMO(LMOQ2),NBQ,
     &                 0.0d0,X1,NBP)
c (pU,rs) -> (TU,rs)
           CALL DGEMM_('T','N',
     &                 NOCQ,NOCP,NBP,
     &                 1.0d0,X1,NBP,
     &                 CMO(LMOP2),NBP,
     &                 0.0d0,X2,NOCQ)
          Endif
c Store buffer
          IF(IRS.GT.IPQMX3) THEN
           IRS=1
cvv           DO I=1,NOTU
cvv            CALL dDAFILE(LUHLF3,1,TURS(1+IPQMX3*(I-1)),IPQMX3,IAD3)
cvv           Enddo
         CALL dDAFILE(LUHLF3,1,TURS,IPQMX3*NOTU,IAD3)
          ENDIF
c Sorting
          call dcopy_(NOTU,X2,1,TURS(IRS),IPQMX3)
c End of loop over r,s pair
         Enddo
        Enddo
c Store the last buffer
        IF(IPQMX3.LT.NBRS) THEN
cvv         DO I=1,NOTU
cvv          CALL dDAFILE(LUHLF3,1,TURS(1+IPQMX3*(I-1)),IPQMX3,IAD3)
cvv         Enddo
        CALL dDAFILE(LUHLF3,1,TURS,IPQMX3*NOTU,IAD3)
        ENDIF
       Endif

       If(icc.ne.0)then
        ISPQRS=((ISP**2-ISP)/2+ISQ-1)*NSYMP+(ISR**2-ISR)/2+ISS
        IAD2M(1,ISPQRS)=IAD13
        ITU=0
c Loop over t,u pair
        Do NT=1,NOCP
         Num=NOCQ
         If(ISP.eq.ISQ)Num=NT
         Do NU=1,Num
          IPQST=1+NBRS*ITU
          ITU=ITU+1
c Read buffer
          IF(IPQMX3.LT.NBRS) THEN
           Call RBuf_tra2(LUHLF3,TURS,NBRS,IPQMX3,NOTU,ITU,IPQST,IAD3S)
          ENDIF
          If(ISR.eq.ISS)then
c  Square
           Call Square(TURS(IPQST),X2,1,NBR,NBR)
c  (TU,rs) -> (TU,sB)
           CALL DGEMM_('T','N',
     &                 NBR,NOS,NBS,
     &                 1.0d0,X2,NBS,
     &                 CMO(LMOS2),NBS,
     &                 0.0d0,X1,NBR)
c  (TU,sB) -> (TU,AB)
           CALL MXMT(X1,       NBR,1,
     &               CMO(LMOR2),1,NBR,
     &               X2,
     &               NOR,NBR)
           IX2=(NOR*NOR+NOR)/2
          Else
           call dcopy_(NBRS,TURS(IPQST),1,X2,1)
c  (TU,rs) -> (TU,As)
           CALL DGEMM_('T','N',
     &                 NBR,NOS,NBS,
     &                 1.0d0,X2,NBS,
     &                 CMO(LMOS2),NBS,
     &                 0.0d0,X1,NBR)
c  (TU,As) -> (TU,AB)
           CALL DGEMM_('T','N',
     &                 NOS,NOR,NBR,
     &                 1.0d0,X1,NBR,
     &                 CMO(LMOR2),NBR,
     &                 0.0d0,X2,NOS)
           IX2=NOR*NOS
          Endif
c  Store (TU,AB) of this t,u pair
C
C       WRITE THESE BLOCK OF INTEGRALS ON LUINTM
C
          CALL GADSum(X2,IX2)
          CALL dDAFILE(LUINTM,1,X2,IX2,IAD13)
c End of Loop over t,u pair
         Enddo
        Enddo
       Endif
      Endif

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AT34R(N,ISIZE,CHARGE,SMAT,V,H,EV2,MULT,BU,P,G,EIG,SINV,REVT,AUX,OVE,EW,E,AA,RR,TT,iprint,VEXTT,PVPT,EVN1,RE1R,AUXI,W1W1)
! INPUT: SMAT  OVERLAP MATRIX
!        V     POTENTIAL
!        H     RELATIVISTIC KINETIC ENERGY
!        EV2   PVP INTEGRALS

use DKH_Info, only: cLightAU, IRELMP
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, iprint
integer(kind=iwp), intent(inout) :: ISIZE
real(kind=wp), intent(in) :: CHARGE, SMAT(ISIZE)
real(kind=wp), intent(inout) :: V(ISIZE), EV2(ISIZE)
real(kind=wp), intent(inout) :: H(ISIZE), BU(ISIZE), P(ISIZE), G(ISIZE), EIG(N,N), SINV(N,N), REVT(N,N), AUX(N,N), OVE(N,N), &
                                EW(N), E(N), AA(N), RR(N), TT(N), VEXTT(ISIZE), PVPT(ISIZE), EVN1(N,N), RE1R(N,N), AUXI(N,N), &
                                W1W1(N,N)
integer(kind=iwp), intent(out) :: MULT(N)
integer(kind=iwp) :: I, IJ, J, K
real(kind=wp) :: CON, CON2, CR, PREA, RATIO, TV1, TV2, TV3, TV4, VELIT

!call PRMAT(u6,SMAT,N,0,'SMAT    ')
VELIT = cLightAU
ISIZE = N*(N+1)/2
PREA = 1/(VELIT*VELIT)
CON2 = PREA+PREA
CON = One/PREA
MULT(1) = 0
do I=1,N
  MULT(I+1) = MULT(I)+I
end do

! SCHMIDT-ORTHOGONALIZE OVERLAP MATRIX

call SOG(N,SMAT,SINV,P,OVE,EW)
call SQUARE(SMAT,OVE,1,N,N)

!-----------------------------------------------------------------------
! MATRIX REPRESENTATION CALCULATED FROM NONRELATIVISTIC T MATRIX
!-----------------------------------------------------------------------
call DIAG_DKH(H,N,EIG,EW,SINV,AUX,0)
if (iprint >= 10) then
  write(u6,*) ' eigenvalues in at34r'
  write(u6,*) (ew(i),i=1,n)
end if
do I=1,N

  ! IF T SUFFICIENTLY SMALL, USE SERIES EXPANSION TO AVOID CANCELLATION

  TT(I) = EW(I)
  RATIO = EW(I)/VELIT
  if (RATIO > 0.02_wp) then
    EW(I) = CON*(sqrt(One+CON2*EW(I))-One)
  else
    TV1 = EW(I)
    TV2 = -TV1*EW(I)*PREA*Half
    TV3 = -TV2*EW(I)*PREA
    TV4 = -TV3*EW(I)*PREA*1.25_wp
    EW(I) = TV1+TV2+TV3+TV4
  end if
  E(I) = EW(I)+CON
end do
!-----------------------------------------------------------------------
! CALCULATE REVERSE TRANSFORMATION
!-----------------------------------------------------------------------

! CALCULATE TRANSFORMATION MATRICES

do I=1,N
  do J=1,N
    AUX(I,J) = Zero
    do K=I,N
      AUX(I,J) = AUX(I,J)+SINV(I,K)*EIG(K,J)
    end do
  end do
end do
do I=1,N
  do J=1,N
    REVT(I,J) = Zero
    do K=1,N
      REVT(I,J) = REVT(I,J)+OVE(I,K)*AUX(K,J)
    end do
  end do
end do
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    H(IJ) = Zero
    do K=1,N
      H(IJ) = H(IJ)+REVT(I,K)*REVT(J,K)*EW(K)
    end do
  end do
end do
if (IRELMP /= 11) then
  do I=1,N
    AA(I) = sqrt((CON+E(I))/(Two*E(I)))
    RR(I) = sqrt(CON)/(CON+E(I))
  end do
else if (IRELMP == 11) then  ! RESC
  do I=1,N
    AA(I) = (sqrt(One+CON*TT(I)*Two/((CON+E(I))*(CON+E(I)))))/(CON+E(I))  ! O OPERATOR
    RR(I) = sqrt(CON)/(CON+E(I))  ! Q OPERATOR
  end do
end if

! BEYOND THIS POINT, OVE IS USED AS SCRATCH ARRAY

! TRANSFORM V TO T-BASIS

call TRSM_DKH(V,SINV,G,N,AUX,OVE)
call TRSM_DKH(G,EIG,BU,N,AUX,OVE)

!MULTIPLY

if (IRELMP /= 11) then

  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      P(IJ) = -BU(IJ)*CHARGE
      VEXTT(IJ) = P(IJ) ! KEEP T-BASIS VEXT INTO VEXTT FOR HIGHER-ORDER DK
      BU(IJ) = P(IJ)*AA(I)*AA(J)
      EVN1(I,J) = BU(IJ)
      EVN1(J,I) = EVN1(I,J)
    end do
  end do

else if (IRELMP == 11) then

  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      P(IJ) = -BU(IJ)*CHARGE
      BU(IJ) = VELIT*P(IJ)*(sqrt(RR(I)*RR(J))*AA(I)/AA(J)+sqrt(RR(J)*RR(I))*AA(J)/AA(I))
    end do
  end do

end if

call TRSMT(BU,REVT,V,N,AUX,OVE)

! PVP INTEGRALS

call TRSM_DKH(EV2,SINV,G,N,AUX,OVE)
call TRSM_DKH(G,EIG,BU,N,AUX,OVE)

! MULTIPLY

if (IRELMP /= 11) then
  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      G(IJ) = -BU(IJ)*CHARGE
      PVPT(IJ) = G(IJ) ! KEEP T-BASIS PVP INTO PVPT FOR HIGHER-ORDER DK
      BU(IJ) = G(IJ)*AA(I)*RR(I)*AA(J)*RR(J)
      EVN1(I,J) = EVN1(I,J)+BU(IJ)
      EVN1(J,I) = EVN1(I,J)
    end do
  end do
else if (IRELMP == 11) then
  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      G(IJ) = -BU(IJ)*CHARGE
      BU(IJ) = G(IJ)*(RR(I)*RR(J)*AA(I)/AA(J)+RR(J)*RR(I)*AA(J)/AA(I))*Half
    end do
  end do
end if
call TRSMT(BU,REVT,EV2,N,AUX,OVE)
!call PRMAT(6,EV2,N,0,'PVPFULL ')
V(1:ISIZE) = V(1:ISIZE)+EV2(1:ISIZE)

if ((IRELMP /= 1) .and. (IRELMP /= 11)) then

  ! CALCULATE EVEN2 OPERATOR

  !call PRMAT(u6,TT,N,1,'TT      ')
  !call PRMAT(u6,E,N,1,'E       ')
  call EVEN2(N,P,G,E,AA,RR,TT,EIG,AUX,OVE,W1W1)

  ! TRANSFORM BACK

  call TRSMT(G,REVT,EV2,N,AUX,OVE)
  V(1:ISIZE) = V(1:ISIZE)+EV2(1:ISIZE)

  if ((IRELMP /= 0) .and. (IRELMP /= 2)) then  ! DK2

    ! CALCULATE EVEN3 OPERATOR

    call EVEN3(N,P,G,E,AA,RR,TT,EIG,AUX,OVE,EVN1,VEXTT,PVPT,RE1R,W1W1,AUXI)

    ! TRANSFORM BACK FOR DK3

    call TRSMT(G,REVT,EV2,N,AUX,OVE)
    V(1:ISIZE) = V(1:ISIZE)+EV2(1:ISIZE)

    if (IRELMP /= 3) then  ! DK3

      ! More to come here

    end if
  end if
end if

CR = 1/CHARGE
do I=1,ISIZE
  V(I) = -V(I)*CR
end do
!call PRMAT(u6,BU,N,0,'TOTAL H ')

return

end subroutine AT34R

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************

subroutine Dispersion_Kriging(x0_,y_,ndimx)

use kriging_mod, only: nSet, sigma, x0
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ndimx
real(kind=wp), intent(in) :: x0_(ndimx)
real(kind=wp), intent(out) :: y_(nSet)
real(kind=wp), parameter :: invnormal = 1.9599639845400542355_wp

!x0 is the n-dimensional vector of the coordinates for which the dispersion is computed

x0(:) = x0_(:)
call covarvector(0) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
call predict(0)
! 95% confidence -> 1.96*sigma
y_(:) = invnormal*sigma(1:nSet)

return

end subroutine Dispersion_Kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Freq2(nIter,Grdn,Shift,nInter,Delta,Stop,
     &                qInt,ANM,nAtom,dMass)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
      Real*8 Grdn(nInter,nIter), Shift(nInter,nIter),
     &       qInt(nInter,nIter+1), dMass(nAtom)
      Logical Stop, ANM
*
      iRout = 183
      iPrint = nPrint(iRout)
*
*-----Compute new parameters for numerical differentiation.
*
      Stop = .False.
      Call NwShft(Shift,nInter,Grdn,nIter,Delta,qInt)
      If (iPrint.gt.6) Then
         Write (6,*) ' Accumulate the gradient for yet one',
     &         ' parameter set'
         Write (6,*)
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(ANM)
         Call Unused_real_array(dMass)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       SubRoutine FockGen_sp(d_0,rDens1,rdens2,Fock,fockout,idsym)
************************************************************************
*                                                                      *
*   Constructs active fockmatrix and Q matrix                          *
*                                                                      *
*   Input: rkappa : Rotation matrix                                    *
*          idsym  : symmetry of perturbation                           *
*                                                                      *
*                                                                      *
*   Output:MO     :MO integrals                                        *
*          Fock   :Fock matrix (one index transformed integrals)       *
*          MOtilde:MO (one index transformed integrals)                *
*                                                                      *
************************************************************************
      Implicit Real*8(a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
#include "WrkSpc.fh"
      Real*8 Fock(nDens2),fockout(*),
     &       rdens2(*),rDens1(nna,nna)
      Parameter ( half  = 0.5d0 )
      Parameter ( two  = 2.0d0 )
      Parameter ( one  = 1.0d0 )
      Parameter ( nd  = 1 )
*                                                                      *
************************************************************************
*                                                                      *
*
*     Coulomb term: F  =2(pk|ji)d
*                    kp          ij
*
      call dcopy_(nDens2,[0.0d0],0,Fock,1)
*
      n1=0
      Do iS = 1, nSym
         n1=Max(n1,nBas(iS))
      End Do
      n2=n1**2
      Call GetMem('ip_MO','Allo','Real',ip_MO,n2)
      Call GetMem('ipScr','Allo','Real',ipScr,n2)
*
      Do ips=1,nSym
         Do ks=1,nSym
            Do is=1,nSym
               jS=iEor(iEor(ips-1,ks-1),is-1)+1
*
*              Exchange term   F = -(pk|ji)d     (i>j)
*                               pl          kj
*
               If (iEOr(ips-1,iS-1)+1.eq.iDsym .and.
     &             nBas(ipS).gt.0) Then
                  Do iB=1,nIsh(iS)
                     Do jA=1,nAsh(jS)
                        jAA=jA+nIsh(js)
*
                        Call Coul(ipS,kS,iS,jS,iB,jAA,
     &                            Work(ip_MO),Work(ipScr))
*
                        Do kA=1,nAsh(ks)
                           kAA=kA+nIsh(kS)
*
                           ipM=ip_MO+(kAA-1)*nBas(ipS)
                           ipF=ipMat(ipS,iS)+nBas(ipS)*(iB-1)
                           rd=rDens1(jA+nA(jS),kA+nA(ks))
                           Call DaXpY_(nBas(ipS),-rd,
     &                                Work(ipM),1,Fock(ipF),1)
                        End Do
                     End Do
                  End Do
               End If
*
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Do iS=1,nSym
         If (nBas(iS).gt.0) Then
            jS=iEOr(is-1,iDSym-1)+1
            Do iA=1,nAsh(is)
               Do jA=1,nAsh(js)
                  rd=rDens1(iA+nA(iS),jA+nA(js))
                  ip1=nBas(iS)*(nIsh(is)+iA-1)+ipCM(is)-1
                  ip2=nBas(iS)*(nIsh(js)+jA-1) +ipmat(is,js)
                 Call DaxPy_(nBAs(iS),Rd,Work(ipFIMO+ip1),1,Fock(ip2),1)
               End Do
            End Do
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call CreQADD_sp(Fock,rdens2,idsym,Work(ip_MO),Work(ipScr),n2)
      Call Free_Work(ipScr)
      Call Free_Work(ip_MO)

*
      Do iS=1,nSym
         js=iEOR(is-1,idsym-1)+1
         If (nbas(is)*nBas(js).ne.0)
     &   Call DGESUB(Fock(ipMat(is,js)),nBas(is),'N',
     &               Fock(ipMat(js,is)),nBas(js),'T',
     %               FockOut(ipMat(is,js)),nBas(is),
     &               nBas(is),nBas(js))
      End Do
      Call DScal_(ndens2,2.0d0,FockOut,1)
      If (idsym.eq.1) Call Add2(Fockout,d_0)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Markus P. Fuelscher                              *
!               1995, Martin Schuetz                                   *
!               2004,2005, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine RdInp(CMO,Eall,Eocc,Eext,iTst,ESCF)
!***********************************************************************
!                                                                      *
!     Locate input stream and read commands                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     modified by MGS                                                  *
!                 TBP                                                  *
!     University of Lund, Sweden, 1992/95, 2004/05.                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

#include "intent.fh"

use MBPT2_Global, only: DelGhost, DoCholesky, DoDF, DoLDF, iDel, iFro, iPL, NamAct, nBas, nDel1, nDel2, nFro1, nFro2, nTit, &
                        Thr_ghs, Title
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(_OUT_) :: CMO(*), Eall(*), Eocc(*), Eext(*)
integer(kind=iwp), intent(out) :: iTst
real(kind=wp), intent(out) :: ESCF
integer(kind=iwp) :: i, iCom, iCount, iDNG, iDummy(1), iErr, iExt, iLow, iOrb, ip, iostatus, iPrt, iSym, iUpp, j, jCom, jDel, &
                     jFro, jOcc, l_Occup, LC, LEE, LEO, LSQ, Lu_orb, LuSpool, nExtT, nFre, nOccT
logical(kind=iwp) :: FrePrt, ERef_UsrDef, DecoMP2_UsrDef, DNG, NoGrdt, lTit, lFro, lFre, lDel, lSFro, lSDel, lExt, lPrt, LumOrb, &
                     Skip
character(len=4) :: Command
character(len=8) :: emiloop, inGeo
character(len=80) :: VecTitle
character(len=100) :: ProgName
character(len=180) :: Line
integer(kind=iwp), allocatable :: SQ(:)
real(kind=wp), allocatable :: C(:), EE(:), EO(:), Occup(:)
character(len=*), parameter :: ComTab(39) = ['TITL','FROZ','DELE','SFRO','SDEL','EXTR','PRIN','TEST','PRPT','LUMO', &
                                             'EREF','VIRA','T1AM','GRDT','LAPL','GRID','BLOC','CHOA','DECO','NODE', &
                                             'THRC','SPAN','MXQU','PRES','CHKI','FORC','VERB','NOVE','FREE','PREC', &
                                             'SOSM','OEDT','OSFA','LOVM','DOMP','FNOM','GHOS','NOGR','END ']
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: ChoMP2_ChkPar, Reduce_Prt
character(len=100), external :: Get_SuperName
character(len=180), external :: Get_Ln
#include "chomp2_cfg.fh"
#include "corbinf.fh"
#include "warnings.h"
#include "Molcas.fh"

!----------------------------------------------------------------------*
!     Locate "start of input"                                          *
!----------------------------------------------------------------------*
lTit = .false.
lFro = .false.
lFre = .false.
lDel = .false.
lSFro = .false.
lSDel = .false.
lExt = .false.
lPrt = .false.
LovMP2 = .false.
DoMP2 = .false.
FNOMP2 = .false.
LumOrb = .false.
all_vir = .false.
DoT1amp = .false.
ESCF = Zero
Thr_ghs = Half
DelGHost = .false.
ERef_UsrDef = .false.
DecoMP2_UsrDef = .false.
nActa = 0
call Put_iScalar('mp2prpt',0)

! copy input from standard input to a local scratch file

LuSpool = 17
call SpoolInp(LuSpool)
rewind(LuSpool)
call RdNLst(LuSpool,'MBPT2')
!----------------------------------------------------------------------*
!     Define default values                                            *
!----------------------------------------------------------------------*
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0

if (DoCholesky) then
  ChoAlg = 2
else
  ChoAlg = -999999
end if
DecoMP2 = Decom_Def
ThrMP2 = -huge(ThrMP2)
SpanMP2 = Span_Def
MxQualMP2 = MxQual_Def
ChkDecoMP2 = .false.
ForceBatch = .false.
if (iPL >= 3) then
  Verbose = .true.
else
  Verbose = .false.
end if
! Scaled Opposite-Spin MP2
SOS_mp2 = .false.
set_cd_thr = .true.
OED_Thr = 1.0e-8_wp
C_os = 1.3_wp
EOSMP2 = Zero
! Frozen natural orbitals
DoFNO = .false.
! MP2-gradient/1pdm
DoDens = .false.
DoGrdt = .false.
NoGrdt = .false.
NoGamma = .false.
! Laplace transform
Laplace = .false.
Laplace_nGridPoints = 0
Laplace_BlockSize = Laplace_BlockSize_Def
! LDF settings
if (DoLDF) then
  SOS_MP2 = .true.
  Laplace = .true.
end if

nTit = 0
iTst = 0
!nTstP = -1
iPrt = 0
nFro1(:) = 0
nFro2(:) = 0
nDel1(:) = 0
nDel2(:) = 0
call Get_iArray('Non valence orbitals',nFro1,nSym)
nFre = 0
!----------------------------------------------------------------------*
!     Read the input stream line by line and identify key command      *
!----------------------------------------------------------------------*
Skip = .false.
jCom = 0
outer: do
  if (.not. Skip) then
    Line = Get_Ln(LuSpool)
    call StdFmt(Line,Command)
    jCom = 0
    do iCom=1,size(ComTab)
      if (Command == ComTab(iCom)) jCom = iCom
    end do
    if (jCom == 0) then
      write(u6,*) 'RdInp: Illegal keyword!'
      write(u6,'(A,A)') 'Command=',Command
      call Abend()
    end if
  end if
  Skip = .false.
  !--------------------------------------------------------------------*
  !     Branch to the processing of the command sections               *
  !--------------------------------------------------------------------*
  select case (ComTab(jCom))

    case ('TITL')
      !---- Process the "TITL" input card -----------------------------*
      if (lTit) then
        write(u6,*) 'RdInp: Error while reading input!'
        write(u6,*) 'Title option already processed!'
        write(u6,'(A,A)') 'Last read line:',Line
        call Abend()
      end if
      lTit = .true.
      do
        Line = Get_Ln(LuSpool)
        call StdFmt(Line,Command)
        jCom = 0
        do iCom=1,size(ComTab)
          if (Command == ComTab(iCom)) jCom = iCom
        end do
        if (jCom /= 0) then
          Skip = .true.
          cycle outer
        end if
        nTit = nTit+1
        if (nTit > size(Title)) exit
        Title(nTit) = Line(1:len(Title))
      end do

    case ('FROZ')
      !---- Process the "FROZ" input card -----------------------------*
      if (lFre .or. lFro) then
        write(u6,*) 'RdInp: Error while reading input!'
        if (lFro) write(u6,*) 'Frozen option already processed!'
        if (lFre) write(u6,*) 'Freeze option and Frozen option are incompatible!'
        write(u6,'(A,A)') 'Last read line:',Line
        call Abend()
      end if
      lFro = .true.
      Line = Get_Ln(LuSpool)

      write(u6,*)
      write(u6,'(A)') 'WARNING!'
      write(u6,'(A)') 'Default frozen orbitals as non valence orbitals is overwritten by user input.'
      write(u6,'(A,8I4)') 'Default values:',(nFro1(iSym),iSym=1,nSym)
      write(u6,*)

      read(Line,*,iostat=iostatus) (nFro1(iSym),iSym=1,nSym)
      if (iostatus > 0) call error()

    case ('DELE')
      !---- Process the "DELE" input card -----------------------------*
      if (lDel) then
        write(u6,*) 'RdInp: Error while reading input!'
        write(u6,*) 'Delete option already processed!'
        write(u6,'(A,A)') 'Last read line:',Line
        call Abend()
      end if
      lDel = .true.
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) (nDel1(iSym),iSym=1,nSym)
      if (iostatus > 0) call error()

    case ('SFRO')
      !---- Process the "SFRO" input card -----------------------------*
      if (lSFro) then
        write(u6,*) 'RdInp: Error while reading input!'
        write(u6,*) 'SFrozen option already processed!'
        write(u6,'(A,A)') 'Last read line:',Line
        call Abend()
      end if
      lSFro = .true.
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) (nFro2(iSym),iSym=1,nSym)
      if (iostatus > 0) call error()
      call mma_allocate(iFro,8,maxval(nFro2),label='iFro')
      iFro(:,:) = 0
      do iSym=1,nSym
        Line = Get_Ln(LuSpool)
        read(Line,*,iostat=iostatus) (iFro(iSym,iOrb),iOrb=1,nFro2(iSym))
        if (iostatus > 0) call error()
      end do

    case ('SDEL')
      !---- Process the "SDEL" input card -----------------------------*
      if (lSDel) then
        write(u6,*) 'RdInp: Error while reading input!'
        write(u6,*) 'SDelete option already processed!'
        write(u6,'(A,A)') 'Last read line:',Line
        call Abend()
      end if
      lSDel = .true.
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) (nDel2(iSym),iSym=1,nSym)
      if (iostatus > 0) call error()
      call mma_allocate(iDel,8,maxval(nDel2),label='iDel')
      iDel(:,:) = 0
      do iSym=1,nSym
        Line = Get_Ln(LuSpool)
        read(Line,*,iostat=iostatus) (iDel(iSym,iOrb),iOrb=1,nDel2(iSym))
        if (iostatus > 0) call error()
      end do

    case ('EXTR')
      !---- Process the "Extract" input card --------------------------*
      if (lExt) then
        write(u6,*) 'RdInp: Error while reading input!'
        write(u6,*) 'Extract option already processed!'
        write(u6,'(A,A)') 'Last read line:',Line
        call Abend()
      end if
      write(u6,*) 'RdInp: EXTRACT option is redundant and is ignored!'

    case ('PRIN')
      !---- Process the "Print" input card ----------------------------*
      if (lPrt) then
        write(u6,*) 'RdInp: Error while reading input!'
        write(u6,*) 'Print option already processed!'
        write(u6,'(A,A)') 'Last read line:',Line
        call Abend()
      end if
      lPrt = .true.
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) iPrt
      if (iostatus > 0) call error()

    case ('TEST')
      !---- Process the "Test" input card -----------------------------*
      iTst = 1

    !case ('TSTP')
    !  !---- Process the "TSTP" input card -----------------------------*
    !  iTst = 1
    !  Line = Get_Ln(LuSpool)
    !  read(Line,*,iostat=iostatus) nTstP
    !  if (iostatus > 0) call error()

    case ('PRPT')
      !---- Process the "PRPT" input card -----------------------------*
      call Put_iScalar('mp2prpt',1)
      DoDens = .true.
      NoGamma = .true.

    case ('LUMO')
      !---- Process the "LUMO" input card -----------------------------*
      LumOrb = .true.

    case ('EREF')
      !---- Process the "EREF" input card -----------------------------*
      if (.not. LumOrb) then
        write(u6,*) 'RdInp: Error while reading input!'
        write(u6,*) 'EREF can be used only with LumOrb.'
        write(u6,*) '(Note: LumOrb keyword must precede EREF)'
        call Abend()
      end if
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) ESCF
      if (iostatus > 0) call error()
      ERef_UsrDef = .true.

    case ('VIRA')
      !---- Process the "VIRA" input card -----------------------------*
      all_Vir = .true.

    case ('T1AM')
      !---- Process the "T1AM" input card -----------------------------*
      DoT1amp = .true.
      if (.not. DoCholesky) then
        write(u6,*) 'RdInp: T1AM is available only with Cholesky/RI .'
        call Abend()
      end if

    case ('GRDT')
      !---- Process the "GRDT" input card -----------------------------*
      call Put_iScalar('mp2prpt',2)
      DoDens = .true.
      DoGrdt = .true.

    case ('LAPL')
      !---- Process the "LAPLace" input card --------------------------*
      ! Laplace transform with default or previously specified grid.
      Laplace = .true.

    case ('GRID')
      !---- Process the "GRID" input card -----------------------------*
      ! Read number of Laplace grid points (activates Laplace as well)
      Laplace = .true.
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) Laplace_nGridPoints
      if (iostatus > 0) call error()
      Laplace_nGridPoints = max(0,Laplace_nGridPoints)
      if (Laplace_nGridPoints > Laplace_mGridPoints) then
        call WarningMessage(2,'Input Error')
        write(u6,'(A,I6)') 'Number of Laplace grid points specified:',Laplace_nGridPoints
        write(u6,'(A,I6)') 'Max allowed:                            ',Laplace_mGridPoints
        call Quit(_RC_INPUT_ERROR_)
      end if

    case ('BLOC')
      !---- Process the "BLOC" input card -----------------------------*
      ! Read vector block size for CD/DF-Laplace-SOS-MP2
      ! (Activates Laplace as well)
      Laplace = .true.
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) Laplace_BlockSize
      if (iostatus > 0) call error()
      Laplace_BlockSize = max(0,Laplace_BlockSize)
      if (Laplace_BlockSize == 0) then
        Laplace_BlockSize = Laplace_BlockSize_Def
      end if

    case ('CHOA')
      !---- Process the "CHOAlgorithm" input card ---------------------*
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) ChoAlg
      if (iostatus > 0) call error()
      if (ChoAlg < 0) then
        ChoAlg = 0
      else if (ChoAlg > 2) then
        ChoAlg = 2
      end if

    case ('DECO')
      !---- Process the "DECOmpose MP2 integrals" input card ----------*
      DecoMP2 = .true.
      DecoMP2_UsrDef = .true.

    case ('NODE')
      !---- Process the "NODEcomposition of MP2 integrals" input card -*
      DecoMP2 = .false.
      DecoMP2_UsrDef = .true.

    case ('THRC','PREC')
      !---- Process the "THRCholesky" input card ----------------------*
      !---- Process the "PRECision" input card (= "THRCholesky" card) -*
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) ThrMP2
      if (iostatus > 0) call error()
      set_cd_thr = .false.

    case ('SPAN')
      !---- Process the "SPAN" input card -----------------------------*
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) SpanMP2
      if (iostatus > 0) call error()

    case ('MXQU')
      !---- Process the "MXQUal" input card ---------------------------*
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) MxQualMP2
      if (iostatus > 0) call error()
      if (MxQualMP2 < 1) MxQualMP2 = MxQual_Def

    case ('PRES')
      !---- Process the "PRESort input card (OBSOLETE) ----------------*

    case ('CHKI')
      !---- Process the "CHKI" input card -----------------------------*
      ChkDecoMP2 = .true.

    case ('FORC')
      !---- Process the "FORCebatching" input card --------------------*
      ForceBatch = .true.

    case ('VERB')
      !---- Process the "VERBose" input card --------------------------*
      Verbose = .true.

    case ('NOVE')
      !---- Process the "NOVErbose" input card ------------------------*
      Verbose = .false.

    case ('FREE')
      !---- Process the "FREEze" input card  --------------------------*
      if (lFre .or. lFro) then
        write(u6,*) 'RdInp: Error while reading input!'
        if (lFre) write(u6,*) 'Freeze option already processed!'
        if (lFro) write(u6,*) 'Frozen option and Freeze option are incompatible!'
        write(u6,'(A,A)') 'Last read line:',Line
        call Abend()
      end if

      write(u6,*)
      write(u6,'(A)') 'WARNING!'
      write(u6,'(A)') 'Default frozen orbitals as non valence orbitals is overwritten by user input.'
      write(u6,'(A,8I4)') 'Default values:',(nFro1(iSym),iSym=1,nSym)
      write(u6,*)
      nFro1(:) = 0

      lFre = .true.
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) nFre
      if (iostatus > 0) call error()

    case ('SOSM')
      !---- Process the "SOSMp2" input card ---------------------------*
      SOS_MP2 = .true.
      if (.not. DoLDF) then
        DecoMP2 = .true.
        if (ChoMP2_ChkPar()) then
          call WarningMessage(2,'SOS-MP2 is not implemented for parallel runs. !! SORRY !!')
          call Quit(_RC_NOT_AVAILABLE_)
        end if
      end if

    case ('OEDT')
      !---- Process the "OEDThreshold" input card ---------------------*
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) OED_Thr
      if (iostatus > 0) call error()

    case ('OSFA')
      !---- Process the "OSFActor" input card -------------------------*
      Line = Get_Ln(LuSpool)
      read(Line,*,iostat=iostatus) C_os
      if (iostatus > 0) call error()

    case ('LOVM')
      !---- Process the "LovMP2" input card ---------------------------*
      if (.not. DoCholesky) then
        write(u6,*)
        write(u6,*) '********************* ERROR ***********************'
        write(u6,*) ' LovMP2 not implemented with conventional ERIs.'
        write(u6,*) ' Please, use Cholesky or RI options.'
        write(u6,*) '***************************************************'
        call Abend()
      else
        LovMP2 = .true.
      end if
      read(LuSpool,*) nActa,ThrLov
      ! nActa = number of active atoms
      ! ThrLov = threshold for orbital selection

      if ((ThrLov < Zero) .or. (ThrLov >= One)) then
        write(u6,*) ' Threshold out of range! Must be in [0,1[ '
        call Abend()
      end if
      ! namAct = names of active atoms (symm. indep. centers)
      call mma_allocate(NamAct,nActa,label='NamAct')
      do
        read(LuSpool,'(A)',iostat=iostatus) Line
        if (iostatus < 0) call error()
        if ((Line(1:1) /= '*') .and. (Line /= '')) exit
      end do
      call UpCase(Line)
      do i=1,nActa
        if (Line == '') call error()
        Line = adjustl(Line)
        j = index(Line,' ')
        namAct(i) = Line(1:j-1)
        Line(1:j-1) = ''
      end do

    case ('DOMP')
      !---- Process the "DoMP2" input card ----------------------------*
      DoMP2 = .true.

    case ('FNOM')
      !---- process the "FNOM" input card -----------------------------*
      if (.not. DoCholesky) then
        write(u6,*)
        write(u6,*) '********************* ERROR ***********************'
        write(u6,*) ' FNO-MP2 not implemented with conventional ERIs.   '
        write(u6,*) ' Please, use Cholesky or RI options.'
        write(u6,*) '***************************************************'
        call Abend()
      else
        FnoMP2 = .true.
      end if
      read(LuSpool,*) vkept

      if ((vkept <= Zero) .or. (vkept > One)) then
        write(u6,*) ' Requested fraction of virtual space out of range! '
        write(u6,*) ' Must be in ]0,1] '
        call Abend()
      end if

    case ('GHOS')
      !---- process the "GHOSt" input card ----------------------------*
      ! Removal of GHOST virtual space
      do
        read(LuSpool,'(A)',iostat=iostatus) Line
        if (iostatus < 0) call error()
        if ((Line(1:1) /= '*') .and. (Line /= '')) exit
      end do
      read(Line,*,iostat=iostatus) Thr_ghs
      if (iostatus > 0) call error()
      if ((thr_ghs < Zero) .or. (thr_ghs >= One)) then
        write(u6,*) ' GHOST threshold out of range! Must be in [0,1[ '
        call Abend()
      end if
      DelGHost = .true.

    case ('NOGR')
      !---  Process the "NOGR" input card -----------------------------*
      NoGrdt = .true.

    case default
      exit

  end select
end do outer
!----------------------------------------------------------------------*
!     "End of input"                                                   *
!----------------------------------------------------------------------*

if (.not. allocated(NamAct)) call mma_allocate(NamAct,nActa,label='NamAct')
if (.not. allocated(iFro)) call mma_allocate(iFro,8,0,label='iFro')
if (.not. allocated(iDel)) call mma_allocate(iDel,8,0,label='iDel')

! Postprocessing for SOS-MP2 and Laplace
if (SOS_MP2) then
  if (.not. (DoCholesky .or. DoDF .or. DoLDF)) then
    call WarningMessage(2,'SOS-MP2 only implemented for CD/DF/LDF')
    call Quit(_RC_INPUT_ERROR_)
  end if
end if
if (Laplace) then
  if (.not. (DoCholesky .or. DoDF .or. DoLDF)) then
    call WarningMessage(2,'Laplace transformation only implemented for CD/DF/LDF')
    call Quit(_RC_INPUT_ERROR_)
  end if
  if (.not. SOS_MP2) then
    call WarningMessage(2,'Laplace transformation only implemented for CD/DF/LDF-SOS-MP2')
    call Quit(_RC_INPUT_ERROR_)
  end if
  if (.not. DecoMP2_UsrDef) then
    ! SOS-MP2 without Laplace automatically turns on DecoMP2.
    ! With Laplace, however, we should use the same default
    ! as for standard MP2. So, change back to default unless
    ! the user explicitly asked for something else.
    DecoMP2 = Decom_Def
  end if
  if (DoDens .or. DoGrdt) then
    call WarningMessage(2,'Laplace transformation is incompatible with PRPT/GRDT')
    call Quit(_RC_INPUT_ERROR_)
  end if
end if

! Check if the calculation is inside a loop and make analytical
! gradients default in this case

! Numerical gradients requested in GATEWAY
call Qpg_iScalar('DNG',DNG)
if (DNG) then
  call Get_iScalar('DNG',iDNG)
  DNG = iDNG == 1
end if
DNG = NoGrdt .or. DNG

! Inside LAST_ENERGY we do not need analytical gradients
ProgName = Get_SuperName()
if (ProgName(1:11) == 'last_energy') DNG = .true.

! Inside NUMERICAL_GRADIENT override input!
if (ProgName(1:18) == 'numerical_gradient') then
  call Put_iScalar('mp2prpt',0)
  DNG = .true.
  DoDens = .false.
  DoGrdt = .false.
end if

if (nSym == 1) then
  call GetEnvF('EMIL_InLoop',emiloop)
  if (emiloop == ' ') emiloop = '0'
  call GetEnvF('MOLCAS_IN_GEO',inGeo)
  if ((emiloop(1:1) /= '0') .and. (inGeo(1:1) /= 'Y') .and. (.not. DNG)) then
    call Put_iScalar('mp2prpt',2)
    DoDens = .true.
    DoGrdt = .true.
  end if
end if

if (LumOrb) then
  Lu_orb = 7
  call DaName(Lu_orb,'INPORB')
  l_Occup = nOrb(1)
  do iSym=2,nSym
    l_Occup = l_Occup+nOrb(iSym)
  end do
  call mma_allocate(Occup,l_Occup,label='Occup')
  call RDVEC('INPORB',Lu_orb,'COE',nSym,nBas,nOrb,CMO,Occup,Eall,iDummy,VecTitle,0,iErr)
  if (iErr /= 0) then
    write(u6,'(A,I4)') 'ERROR: RdVec returned code',iErr
    call Abend()
  end if
  call DaClos(Lu_orb)
  write(u6,*)
  write(u6,*) ' Input Orbitals read from INPORB: ',VecTitle
  if (.not. ERef_UsrDef) then
    write(u6,*) ' WARNING: reference energy read from RunFile'
    write(u6,*) '          (may not correspond to orbitals)'
    call Get_dScalar('SCF energy',Escf)
  end if
  write(u6,*)
  iErr = 0
  ip = 0
  do iSym=1,nSym
    iCount = 0
    do i=1,nOrb(iSym)
      ip = ip+1
      if (abs(Occup(ip)) > 1.0e-14_wp) iCount = iCount+1
    end do
    if (iCount /= nOcc(iSym)) then
      iErr = iErr+1
      write(u6,'(A,I2,A,I6,A,I6)') 'WARNING: number of occupied orbitals in symmetry',iSym,' is',iCount, &
                                   ' according to INPORB; from RunFile:',nOcc(iSym)
    end if
  end do
  if (iErr /= 0) then
    write(u6,'(A,A)') 'WARNING: occupation mismatch between RunFile and INPORB. ','RunFile occupation will be used:'
    write(u6,'(8I6)') (nOcc(iSym),iSym=1,nSym)
    iErr = 0
  end if
  call mma_deallocate(Occup)
else
  call Get_dScalar('SCF energy',Escf)
end if

if (lFre .and. (nFre > 0)) then ! freeze lowest occupied orbitals
  FrePrt = iPrt > 0
  call Freezer(Eall,nFre,nFro,nFro1,nOcc,nBas,nSym,FrePrt)
end if
do iSym=1,nSym
  nFro(iSym) = nFro(iSym)+nFro1(iSym)
  nOcc(iSym) = nOcc(iSym)-nFro1(iSym)
  nDel(iSym) = nDel(iSym)+nDel1(iSym)
  nExt(iSym) = nExt(iSym)-nDel1(iSym)
  nOrb(iSym) = nOrb(iSym)-nDel1(iSym)
end do
call Put_iArray('nFroPT',NFRO,NSYM)
call Put_iArray('nDelPT',NDEL,NSYM)
jOcc = 0
iExt = 0
iCount = 0
nOccT = 0
nExtT = 0
do i=1,nSym
  nOccT = nOccT+nOcc(i)
  nExtT = nExtT+nExt(i)
end do

do iSym=1,nSym
  iLow = iCount+nFro(iSym)+1
  iUpp = iLow+nOcc(iSym)-1
  do i=iLow,iUpp
    jOcc = jOcc+1
    Eocc(jOcc) = Eall(i)
  end do
  iLow = iUpp+1
  iUpp = iLow+nExt(iSym)-1
  do i=iLow,iUpp
    iExt = iExt+1
    Eext(iExt) = Eall(i)
  end do
  iCount = iCount+nBas(iSym)
end do
iCount = 0

if (DoDens) then
  jFro = 0
  jDel = 0
  do iSym=1,nSym

    iLow = iCount+1
    iUpp = iLow+nFro(iSym)-1
    do i=iLow,iUpp
      jFro = jFro+1
      EOcc(jFro+nOccT) = Eall(i)
    end do
    iLow = iCount+nFro(iSym)+nOcc(iSym)+nExt(iSym)+1
    iUpp = iLow+nDel(iSym)-1
    do i=iLow,iUpp
      jDel = jDel+1
      Eext(jDel+nExtT) = Eall(i)
    end do
    iCount = iCount+nBas(iSym)
  end do
end if
if (lSFro .or. lSDel) then
  LC = 0
  LEO = 0
  LEE = 0
  LSQ = 0
  do iSym=1,nSym
    LC = LC+nBas(iSym)**2
    LSQ = max(LSQ,nBas(iSym))
    LEO = LEO+nOcc(iSym)
    LEE = LEE+nExt(iSym)
  end do
  call mma_allocate(C,LC,label='C')
  call mma_allocate(EO,LEO,label='EO')
  call mma_allocate(EE,LEE,label='EE')
  call mma_allocate(SQ,LSQ,label='SQ')
  C(:) = CMO(1:LC)
  EO(:) = Eocc(1:LEO)
  EE(:) = Eext(1:LEE)
  call FrzDel(nFro2,iFro,Eocc,EO,nDel2,iDel,Eext,EE,CMO,C,SQ)
  call mma_deallocate(C)
  call mma_deallocate(EO)
  call mma_deallocate(EE)
  call mma_deallocate(SQ)
end if
!----------------------------------------------------------------------*
!     Normal termination                                               *
!----------------------------------------------------------------------*

! remove local copy of standard input

call Close_LuSpool(LuSpool)

if (LumOrb .and. DoT1amp) then
  write(u6,'(/,A)') 'ERROR!  Keywords incompatibility.'
  write(u6,'(/,A)') 'Both LUMOrb and T1AM were selected.'
  write(u6,'(/,A)') '***  I must shut down MBPT2 ! ***'
  call Abend()
end if

if (all_Vir .and. DoMP2) then
  write(u6,'(/,A)') 'WARNING!'
  write(u6,'(/,A)') 'Both VirAll and DoMP2 were selected.'
  write(u6,'(/,A)') '***  I turn off DoMP2 ! ***'
  DoMP2 = .false.
end if

! turn off decomposition for parallel runs.

if (DecoMP2 .and. ChoMP2_ChkPar()) then
  write(u6,'(/,A)') 'WARNING!'
  write(u6,'(A)') 'Decomposition of MP2 integrals is not possible. Turning off decomposition.'
  DecoMP2 = .false.
end if

call xFlush(u6)

return

contains

subroutine error()
  !--------------------------------------------------------------------*
  !     Error Exit                                                     *
  !--------------------------------------------------------------------*
  write(u6,*) 'RdInp: Error while reading input!'
  write(u6,'(A,A)') 'Last read line:',Line
  call Abend()
end subroutine error

end subroutine RdInp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Cho_VecTransp(Vec,Jin,Jfi,iSym,iRed,iPass)
#if defined (_MOLCAS_MPP_)
      Use Para_Info, Only: MyRank, nProcs
      use ChoSwp, only: InfVec_G, IndRed
      use ChoArr, only: iL2G
#endif
      Implicit Real*8 (a-h,o-z)
      Real*8   Vec(*)
      Integer  Jin, Jfi, iSym, iRed, iPass

      Character*13 SecNam
      Parameter (SecNam = 'Cho_VecTransp')

#if defined (_MOLCAS_MPP_)
#include "cho_para_info.fh"
#include "cholesky.fh"
#include "choglob.fh"
#include "stdalloc.fh"
#include "mafdecls.fh"

#ifndef _GA_
#include "WrkSpc.fh"
#endif

      Logical LocDbg
#if defined (_DEBUGPRINT_)
      Parameter (LocDbg = .true.)
#else
      Parameter (LocDbg = .false.)
#endif


      External  ga_create_irreg, ga_destroy
      Logical   ga_create_irreg, ga_destroy, ok
      Integer   g_a
CVVP:2014 DGA is here
#ifndef _GA_
      Logical   ga_create_local
      Integer   ga_local_woff,nelm,iGAL
      External  ga_local_woff,ga_create_local
#endif
      Integer, Allocatable:: Map(:), iAdrLG(:,:), iVecR(:),
     &                       nRSL(:), MapRS2RS(:)
      Real*8, Allocatable:: VecR(:,:)
***************************************************************

      If (.not.Cho_Real_Par) Then
         If (LocDbg) Then
            Write(6,'(A,A,A)') 'Illegal call to ',SecNam,':'
            Write(6,*)
     &      'Should only be called in parallel, but Cho_Real_Par = ',
     &      Cho_Real_Par
         End If
         Call Cho_Quit('Illegal call to '//SecNam,103)
      End If

      If (iRed .eq. 2) Then
         jRed=3
      Else If (iRed .eq. 3) Then
         jRed=2
      Else
         Call Cho_Quit('iRed must be 2 or 3 in '//SecNam,104)
      End If
      nRS_l = nnBstR(iSym,iRed)   ! local  red set dimension
      nRS_g = nnBstR_G(iSym,iRed) ! global red set dimension
      nV = Jfi - Jin + 1
      nVR = 0

      call mma_allocate(iVecR,nV,Label='iVecR')
      Call cho_p_distrib_vec(Jin,Jfi,iVecR,nVR)
      Call mma_allocate(VecR,nRS_g,nVR+1,Label='VecR')

      Call mma_allocate(nRSL,nProcs,Label='nRSL')
      nRSL(:)=0
      nRSL(1+MyRank) = nRS_l  ! MyRank starts from 0
      Call Cho_GAIGOP(nRSL,nProcs,'+')

      MxRSL=nRSL(1)
      Do i=2,nProcs
         MxRSL=max(MxRSL,nRSL(i))
      End Do
      Call mma_allocate(iAdrLG,MxRSL,nProcs,Label='iAdrLG')

      Call mma_allocate(Map,nProcs,Label='Map')
      nProcs_eff = 0
      iStart = 1
      myStart = 0
      Do i=1,nProcs
         If (nRSL(i) .gt. 0) Then
            nProcs_eff = nProcs_eff + 1
            Map(nProcs_eff) = iStart
            If ((i-1) .eq. myRank) myStart = iStart
            iStart = iStart + nRSL(i)
         End If
      End Do

      If (LocDbg) Then
         Write(LuPri,*)
         Write(LuPri,*) SecNam,': debug info.'
         Write(LuPri,*) '#nodes: ',nProcs,'  myRank: ',myRank
         Write(LuPri,*) '#contributing nodes: ',nProcs_eff
         Write(LuPri,*) 'Symmetry block: ',iSym
         Write(LuPri,*) 'On this node:'
         Write(LuPri,*) 'Vector dimension : ',nRS_l
         Write(LuPri,*) 'Number of vectors: ',nV,' (',Jin,'-',Jfi,')'
         Write(LuPri,*) 'Global vector dimension : ',nRS_g
         Write(LuPri,*) 'Number of global vectors: ',nVR
         Write(Lupri,*) 'MAP:'
         Write(LuPri,*) (map(i),i=1,nProcs_eff)
      End If
CVVP:2014 Local rather than Global
#ifdef _GA_
      ok = ga_create_irreg(mt_dbl,nRS_g,nV,'Ga_Vec',Map,
     &                     nProcs_eff,1,1,g_a)
#else
      ok = ga_create_local(mt_dbl,nRS_g,nV,'Ga_Vec',g_a)
#endif
      If (.not. ok) Call Cho_Quit(SecNam//': ga_create_irreg error',101)

      If (nRS_l .gt. 0) Then
         myEnd = myStart + nRS_l - 1
#ifdef _GA_
         Call ga_put(g_a,myStart,myEnd,1,nV,Vec,nRS_l)
#else
CVVP:2014 the minimal latency and scalable putC call
         Call ga_putc(g_a,myStart,myEnd,1,nV,Vec,nRS_l)
#endif
      End If
#ifndef _GA_
      nelm=nRS_g*nV
      iGAL=ga_local_woff(g_a)
      Call Cho_GAdGOP(Work(iGAL),nelm,'+')
#else
      Call Cho_GASync()
#endif
      Jin0 = Jin - 1
      Do i=1,nVR
         jv=iVecR(i) - Jin0
#ifdef _GA_
         Call ga_get(g_a,1,nRS_g,jv,jv,VecR(:,i),nRS_g)
#else
CVVP:2014 the minimal latency and scalable getC call
         Call ga_getc(g_a,1,nRS_g,jv,jv,VecR(:,i),nRS_g)
#endif
      End Do

      ok = ga_destroy(g_a)
      If (.not. ok) Call Cho_Quit(SecNam//': ga_destroy error',101)

C --- write the reordered vec on disk

      Call Cho_P_IndxSwp()
      irc=-1
      Call Cho_X_RSCopy(irc,1,jRed)
      If (irc .ne. 0) Then
         Call Cho_Quit(SecNam//
     &                 ': Non-zero return code from Cho_X_RSCopy',
     &                 104)
      End If

      Call mma_allocate(MapRS2RS,nnBstR(iSym,1),Label='MapRS2RS')
      Call Cho_RS2RS(mapRS2RS,SIZE(mapRS2RS),jRed,iRed,iPass,iSym)
      Call Cho_P_IndxSwp()

      iAdrLG(:,:)=0
      Do i = 1,nRS_l
         i1 = IndRed(iiBstR(iSym,iRed)+i,iRed) ! addr in local rs1
         j1 = iL2G(i1) ! addr in global rs1
         j = mapRS2RS(j1-iiBstR_G(iSym,1)) ! addr in glob. rs
         iAdrLG(i,myRank+1) = j
      End Do
      Call Cho_GAIGOP(iAdrLG,SIZE(iAdrLG),'+')

      Call mma_deallocate(MapRS2RS)

      If (LocDbg) Then
         iCount=0
         Do iNode=1,nProcs
            Do iRSL=1,nRSL(iNode)
               iCount=iCount+1
            End Do
         End Do
         If (iCount .ne. nRS_g) Then
            Call Cho_Quit('nRSL error in '//SecNam,104)
         End If
      End If

      Do j=1,nVR
         Call dCopy_(nRS_g,VecR(:,j),1,VecR(:,nVr+1),1)
         iCount=0
         Do iNode=1,nProcs
            Do iRSL=1,nRSL(iNode)
               VecR(iAdrLG(iRSL,iNode),j)=VecR(1+iCount,nVR+1)
               iCount=iCount+1
            End Do
         End Do
      End Do

      If (CHO_ADRVEC .ne. 1) THEN ! only WA files!!
         Call Cho_Quit('CHO_ADRVEC error in '//SecNam,102)
      Else ! write to disk and update InfVec_G(*,3,iSym)
         iVec1=myNumCho(iSym)+1
         lTot=nRS_g*nVR
         If (lTot .gt. 0) Then
            iOpt=1
            iAdr=InfVec_G(iVec1,3,iSym)
            Call dDAfile(LuCho_G(iSym),iOpt,VecR,lTot,iAdr)
         End If
         Do iVec = 1,nVR
            jVec = iVec1 + iVec - 1
            If (jVec .lt. MaxVec) Then
               InfVec_G(jVec+1,3,iSym)= InfVec_G(jVec,3,iSym) + nRS_g
            End If
         End Do
         LastV = myNumCho(iSym) + nVR
         If (LastV .gt. MaxVec) Then
            Call Cho_Quit('Max. number of vectors exceeded in '//SecNam,
     &                    104)
         End If
      End If
      myNumCho(iSym) = myNumCho(iSym) + nVR

C --- deallocations

      Call mma_deallocate(Map)
      Call mma_deallocate(iAdrLG)
      Call mma_deallocate(nRSL)
      Call mma_deallocate(VecR)
      Call mma_deallocate(iVecR)
#else
      Call Cho_Quit(SecNam//
     &              ' should never be called in serial installation',
     &              103)
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Vec)
         Call Unused_integer(Jin)
         Call Unused_integer(Jfi)
         Call Unused_integer(iSym)
         Call Unused_integer(iRed)
         Call Unused_integer(iPass)
      End If
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ncset_cvb(ic)

use casvb_global, only: istackrep
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ic
integer(kind=iwp) :: nc_zeroed, nconvinone
logical(kind=iwp), external :: istkprobe_cvb

if (istkprobe_cvb(istackrep)) then
  call istkpop_cvb(istackrep,nc_zeroed)
  call istkpop_cvb(istackrep,nconvinone)
  if ((ic == 0) .or. (ic == 1)) then
    nconvinone = nconvinone+1
  else if (ic > 1) then
    nconvinone = 0
    nc_zeroed = 1
  else
    nconvinone = -1
    nc_zeroed = 1
  end if
  call istkpush_cvb(istackrep,nconvinone)
  call istkpush_cvb(istackrep,nc_zeroed)
end if

return

end subroutine ncset_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2016,2017, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine OptClc(CInter,nCI,nD,Ind,nInd)
!***********************************************************************
!                                                                      *
! purpose: calculate optimal density matrix and two-electron hamil-    *
!          tonial as well as optimal difference from interpolation     *
!          or extrapolation coefficients.                              *
!                                                                      *
! input:                                                               *
!   Dens    : density matrices (nDT,NumDT)                             *
!   TwoHam  : two-electron hamiltonian matrices (nDT,NumDT)            *
!   Vxc     : external potential       matrices (nDT,NumDT)            *
!   CInter  : interpolation coefficients (nCI)                         *
!                                                                      *
! output:                                                              *
!   Dens and TwoHam                                                    *
!                                                                      *
!***********************************************************************

use InfSCF, only: Dens, iDisk, kOptim, MapDns, nBT, nDens, TwoHam, Vxc
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCI, nD, nInd, Ind(nInd)
real(kind=wp), intent(in) :: CInter(nCI,nD)
integer(kind=iwp) :: i, iD, iMap, Iter_D, MatNO
real(kind=wp) :: C
real(kind=wp), allocatable :: DnsTmp(:,:), TwoTmp(:,:), VxcTmp(:,:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
!                                                                      *
! Allocate memory for matrices that contribute to the optimal one
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
if (kOptim == 1) return
call mma_allocate(DnsTmp,nBT,nD,Label='DnsTmp')
call mma_allocate(TwoTmp,nBT,nD,Label='TwoTmp')
call mma_allocate(VxcTmp,nBT,nD,Label='VxcTmp')
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Accumulate linear combinations in position iPsLst
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Start with the last iteration
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
iter_d = Ind(kOptim)

iMap = MapDns(iter_d)
if (iMap < 0) then
  call RWDTG(-iMap,DnsTmp,nBT*nD,'R','DENS  ',iDisk,size(iDisk,1))
  call RWDTG(-iMap,TwoTmp,nBT*nD,'R','TWOHAM',iDisk,size(iDisk,1))
  call RWDTG(-iMap,VxcTmp,nBT*nD,'R','dVxcdR',iDisk,size(iDisk,1))
else
  DnsTmp(:,:) = Dens(:,:,iMap)
  TwoTmp(:,:) = TwoHam(:,:,iMap)
  VxcTmp(:,:) = Vxc(:,:,iMap)
end if

do iD=1,nD

  C = CInter(kOptim,iD)
  DnsTmp(:,iD) = C*DnsTmp(:,iD)
  TwoTmp(:,iD) = C*TwoTmp(:,iD)
  VxcTmp(:,iD) = C*VxcTmp(:,iD)

end do

Dens(:,:,nDens) = DnsTmp(:,:)
TwoHam(:,:,nDens) = TwoTmp(:,:)
Vxc(:,:,nDens) = VxcTmp(:,:)

do i=1,kOptim-1
  C = CInter(i,1)
  MatNo = Ind(i)

  iMap = MapDns(MatNo)
  if (iMap < 0) then
    call RWDTG(-iMap,DnsTmp,nBT*nD,'R','DENS  ',iDisk,size(iDisk,1))
    call RWDTG(-iMap,TwoTmp,nBT*nD,'R','TWOHAM',iDisk,size(iDisk,1))
    call RWDTG(-iMap,VxcTmp,nBT*nD,'R','dVxcdR',iDisk,size(iDisk,1))
  else
    DnsTmp(:,:) = Dens(:,:,iMap)
    TwoTmp(:,:) = TwoHam(:,:,iMap)
    VxcTmp(:,:) = Vxc(:,:,iMap)
  end if

  do iD=1,nD
    C = CInter(i,iD)
    Dens(:,iD,nDens) = Dens(:,iD,nDens)+C*DnsTmp(:,iD)
    TwoHam(:,iD,nDens) = TwoHam(:,iD,nDens)+C*TwoTmp(:,iD)
    Vxc(:,iD,nDens) = Vxc(:,iD,nDens)+C*VxcTmp(:,iD)
  end do

end do ! i

! Deallocate memory

call mma_deallocate(DnsTmp)
call mma_deallocate(TwoTmp)
call mma_deallocate(VxcTmp)

#ifdef _DEBUGPRINT_
call NrmClc(Dens(1,1,nDens),nBT*nD,'OptClc','D in iPsLst. ')
call NrmClc(TwoHam(1,1,nDens),nBT*nD,'OptClc','T in iPsLst. ')
call NrmClc(Vxc(1,1,nDens),nBT*nD,'OptClc','V in iPsLst. ')
#endif
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*
return

end subroutine OptClc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MLTSCA(IMLTOP,LST1,NLST1,LST2,NLST2,X,nX,F,nF,Y,nY)
! Given two lists with entries LST1(4,ITEM), ITEM=1,NLST1, the
! four entries called L11,L12,L13,L14 for short, for a given
! item, and with V1=VAL1(L14), and similar for the other list,
! compute, for IMLTOP=0 or 1 respectively,
!     X(L11,L21) := Add V1*V2*F(L12,L22)*Y(L13,L23)
!  or Y(L13,L23) := Add V1*V2*F(L12,L22)*X(L11,L21)
! or for IMLTOP=2, compute
!     F(L12,L22) := Add V1*V2*X(L11,L21)*Y(L13,L23)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, MyRank, nProcs
#endif
use Sigma_data, only: INCF1, INCF2, INCX1, INCX2, INCY1, INCY2, NFSCA, VAL1, VAL2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IMLTOP, NLST1, LST1(4,NLST1), NLST2, LST2(4,NLST2), nX, nF, nY
real(kind=wp), intent(inout) :: X(nX), F(nF), Y(nY)
integer(kind=iwp) :: I_F, ILST1, ILST1_IOFF, ILST1_SKIP, ILST2, IX, IY, L11, L12, L13, L14, L21, L22, L23, L24
real(kind=wp) :: V1, V2

!SVC: determine outer loop properties
#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  ILST1_IOFF = MYRANK+1
  ILST1_SKIP = NPROCS
else
#endif
  ILST1_IOFF = 1
  ILST1_SKIP = 1
#ifdef _MOLCAS_MPP_
end if
#endif

if (IMLTOP == 0) then
  do ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
    L11 = LST1(1,ILST1)
    L12 = LST1(2,ILST1)
    L13 = LST1(3,ILST1)
    L14 = LST1(4,ILST1)
    V1 = VAL1(L14)
    do ILST2=1,NLST2
      L21 = LST2(1,ILST2)
      L22 = LST2(2,ILST2)
      L23 = LST2(3,ILST2)
      L24 = LST2(4,ILST2)
      V2 = VAL2(L24)
      IX = 1+INCX1*(L11-1)+INCX2*(L21-1)
      I_F = 1+INCF1*(L12-1)+INCF2*(L22-1)
      IY = 1+INCY1*(L13-1)+INCY2*(L23-1)
      X(IX) = X(IX)+V1*V2*F(I_F)*Y(IY)
    end do
  end do
else if (IMLTOP == 1) then
  do ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
    L11 = LST1(1,ILST1)
    L12 = LST1(2,ILST1)
    L13 = LST1(3,ILST1)
    L14 = LST1(4,ILST1)
    V1 = VAL1(L14)
    do ILST2=1,NLST2
      L21 = LST2(1,ILST2)
      L22 = LST2(2,ILST2)
      L23 = LST2(3,ILST2)
      L24 = LST2(4,ILST2)
      V2 = VAL2(L24)
      IX = 1+INCX1*(L11-1)+INCX2*(L21-1)
      I_F = 1+INCF1*(L12-1)+INCF2*(L22-1)
      IY = 1+INCY1*(L13-1)+INCY2*(L23-1)
      Y(IY) = Y(IY)+V1*V2*F(I_F)*X(IX)
    end do
  end do
else
  do ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
    L11 = LST1(1,ILST1)
    L12 = LST1(2,ILST1)
    L13 = LST1(3,ILST1)
    L14 = LST1(4,ILST1)
    V1 = VAL1(L14)
    do ILST2=1,NLST2
      L21 = LST2(1,ILST2)
      L22 = LST2(2,ILST2)
      L23 = LST2(3,ILST2)
      L24 = LST2(4,ILST2)
      V2 = VAL2(L24)
      IX = 1+INCX1*(L11-1)+INCX2*(L21-1)
      I_F = 1+INCF1*(L12-1)+INCF2*(L22-1)
      IY = 1+INCY1*(L13-1)+INCY2*(L23-1)
      F(I_F) = F(I_F)+V1*V2*X(IX)*Y(IY)
    end do
  end do
end if

NFSCA = NFSCA+4*NLST1*NLST2

end subroutine MLTSCA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine RdAB
      use Arrays, only: CMO
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"
#include "stdalloc.fh"
#include "Input.fh"
#include "SysDef.fh"
      Character*8 Label
#include "disp_mclr.fh"
*
*
      Perturbation='NONE'
*
      If (MCKINLEY) Then
       LABEL='TDISP'
       iRc=-1
       iOpt=0
       Call RdMck(iRC,iOpt,Label,idum,ntpert,idum)
       If (iRC.ne.0) Then
          Write (6,*) 'RdAB: Error reading MCKINT'
          Write (6,'(A,A)') 'Label=',Label
          Call Abend
       End If
       LABEL='PERT'
       iRc=-1
       iOpt=0
       Call cRdMck(iRC,iOpt,Label,idum,Perturbation,idum)
       If (iRC.ne.0) Then
          Write (6,*) 'RdAB: Error reading MCKINT'
          Write (6,'(A,A)') 'Label=',Label
          Call Abend
       End If
      End If
*

      If (iMethod.eq.1) Then
         Call Get_dScalar('Last energy',ESCF)
         Call Get_iArray('nIsh',nIsh,nSym)
         Call Get_iArray('nDel',nDel,nSym)
*----------------------------------------------------------------------*
*     Precompute the total sum of variables and size of matrices       *
*----------------------------------------------------------------------*
         ntIsh=0
         ntItri=0
         ntIsqr=0
         ntBsqr=0
         Length=0
         Do iSym=1,nSym
            ntIsh=ntIsh+nIsh(iSym)
            ntItri=ntItri+nIsh(iSym)*(nIsh(iSym)+1)/2
            ntIsqr=ntIsqr+nIsh(iSym)*nIsh(iSym)
            ntbSQR=ntbsqr+nbas(isym)**2
            norb(isym)=nbas(isym)-ndel(isym)
            Length=Length+nBas(iSym)*nOrb(iSym)
         End Do
         Call mma_allocate(CMO,Length,Label='CMO')
         Call Get_CMO(CMO,Length)
      End If

*
      If (MCKINLEY) Then
         Label='ldisp   '
         iRc=-1
         iOpt=0
         Call RdMck(iRc,iOpt,label,idum,ldisp,idum)
         If (iRC.ne.0) Then
            Write (6,*) 'RdAB: Error reading MCKINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend
         End If
         nDisp=0
         Do iS=1,nSym
            nDisp=nDisp+lDisp(iS)
         End Do
         If (ndisp.ne.0) Then
            Label='Chdisp  '
            iRc=-1
            iOpt=0
            Call cRdmck(iRc,iOpt,label,idum,ChDisp(1),idum)
            If (iRC.ne.0) Then
               Write (6,*) 'RdAB: Error reading MCKINT'
               Write (6,'(A,A)') 'Label=',Label
               Call Abend
            End If
         End if
      End If
*
      If (PT2) Then
         Call icopy(nsym,[0],0,ldisp,1)
         ldisp(1)=1
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_INT_1(IJ,KL,XINT,LINT,LOCPRT)
C
C     Purpose: calculate shell-quadruple (IJ|KL) and return
C              them in XINT.
C
C     Notes:
C        LOCPRT: flag for printing the shell quadruple to output;
C                output format differs depending on IFCSEW.
C
      use ChoArr, only: nBstSh, iSP2F
      IMPLICIT REAL*8 (A-H,O-Z)
      EXTERNAL Integral_WrOut_Cho
      REAL*8   XINT(LINT)
      LOGICAL  LOCPRT
#include "itmax.fh"
#include "cholesky.fh"

      CHARACTER*13 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_INT_1')

      ITRI(I,J) = MAX(I,J)*(MAX(I,J)-3)/2 + I + J

C     Initializations.
C     ----------------

      CALL CHO_INVPCK(ISP2F(IJ),I,J,.TRUE.)
      CALL CHO_INVPCK(ISP2F(KL),K,L,.TRUE.)

      SHCD = IJ
      SHAB = KL
      SHC = I
      SHD = J
      SHA = K
      SHB = L

C     Calculate integrals.
C     --------------------

      CALL EVAL_IJKL(I,J,K,L,XINT,LINT,Integral_WrOut_Cho)

C     Print integrals.
C     ----------------

      IF (LOCPRT) THEN

         IF (IFCSEW.EQ.1) THEN

            WRITE(LUPRI,'(//,5X,A,A,4I5,A)')
     &      SECNAM,': shell quadruple ',I,J,K,L,':'

            NUMI = NBSTSH(I)
            NUMJ = NBSTSH(J)
            NUMK = NBSTSH(K)
            NUML = NBSTSH(L)
            IF (I .EQ. J) THEN
               NUMIJ = NUMI*(NUMJ + 1)/2
            ELSE
               NUMIJ = NUMI*NUMJ
            END IF

            IF (K .EQ. L) THEN
               DO LL = 1,NUML
                  DO KK = 1,LL
                     KKLL = ITRI(KK,LL)
                     IF (I .EQ. J) THEN
                        DO JJ = 1,NUMJ
                           DO II = 1,JJ
                              IIJJ = ITRI(II,JJ)
                              KOFF = NUMIJ*(KKLL - 1) + IIJJ
                              WRITE(LUPRI,*)
     &                        '(',I,J,K,L,') [',II,JJ,KK,LL,'] = ',
     &                        XINT(KOFF)
                           END DO
                        END DO
                     ELSE
                        DO JJ = 1,NUMJ
                           DO II = 1,NUMI
                              IIJJ = NUMI*(JJ - 1) + II
                              KOFF = NUMIJ*(KKLL - 1) + IIJJ
                              WRITE(LUPRI,*)
     &                        '(',I,J,K,L,') [',II,JJ,KK,LL,'] = ',
     &                        XINT(KOFF)
                           END DO
                        END DO
                     END IF
                  END DO
               END DO
            ELSE
               DO LL = 1,NUML
                  DO KK = 1,NUMK
                     KKLL = NUMK*(LL - 1) + KK
                     IF (I .EQ. J) THEN
                        DO JJ = 1,NUMJ
                           DO II = 1,JJ
                              IIJJ = ITRI(II,JJ)
                              KOFF = NUMIJ*(KKLL - 1) + IIJJ
                              WRITE(LUPRI,*)
     &                        '(',I,J,K,L,') [',II,JJ,KK,LL,'] = ',
     &                        XINT(KOFF)
                           END DO
                        END DO
                     ELSE
                        DO JJ = 1,NUMJ
                           DO II = 1,NUMI
                              IIJJ = NUMI*(JJ - 1) + II
                              KOFF = NUMIJ*(KKLL - 1) + IIJJ
                              WRITE(LUPRI,*)
     &                        '(',I,J,K,L,') [',II,JJ,KK,LL,'] = ',
     &                        XINT(KOFF)
                           END DO
                        END DO
                     END IF
                  END DO
               END DO
            END IF

         ELSE IF (IFCSEW.EQ.2 .OR. IFCSEW.EQ.3) THEN

            CALL CHO_PRTINT(IJ,KL,XINT,LINT)

         ELSE

            WRITE(LUPRI,*) SECNAM,': IFCSEW=',IFCSEW
            CALL CHO_QUIT(SECNAM//': IFCSEW out of bounds!',103)

         END IF

      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE REO_GASDET(IBLOCK,NBLOCK,ISYM,IREO)
*
* Create reorder array for determinants : configuration order => Ab order
*
*
* Jeppe Olsen, November 2001, from GASANA
*
*
#include "implicit.fh"
*
* =====
*.Input
* =====
*
#include "mxpdim.fh"
#include "orbinp.fh"
#include "strbas.fh"
#include "cicisp.fh"
#include "cstate.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "csm.fh"
#include "WrkSpc.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "cprnt.fh"
#include "spinfo_lucia.fh"
#include "glbbas.fh"
*
      DIMENSION IBLOCK(8,NBLOCK)
*
*. Output
      INTEGER IREO(*)

c      write(6,*)'nconf_per_open in reo_gasdet'
c      call iwrtma(nconf_per_open,1,4,1,4)
*
** Specifications of internal space
*
      NTEST = 000
      NTEST = MAX(NTEST,IPRDIA)
* Type of alpha and beta strings
      IATP = 1
      IBTP = 2
*
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
      NEL= NAEL+NBEL
*
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)

*
*
**. Info on block structure of space
*
*
*Space for alpha and beta strings
      CALL GETMEM('KLASTR','ALLO','INTE',KLASTR,MXNSTR*NAEL)
      CALL GETMEM('KLBSTR','ALLO','INTE',KLBSTR,MXNSTR*NBEL)
*. Space for constructing arc weights for configurations
      CALL GETMEM('ZSCR  ','ALLO','INTE',KLZSCR,(NOCOB+1)*(NEL+1))
      CALL GETMEM('Z     ','ALLO','INTE',KLZ,NOCOB*NEL*2)
      CALL GETMEM('OCMIN ','ALLO','INTE',KLOCMIN,NOCOB)
      CALL GETMEM('OCMAX ','ALLO','INTE',KLOCMAX,NOCOB)
*. Occupation and projections of a given determinant
C??? Jesper      CALL MEMMAN(KLDET_OC,NOCOB,'ADDL  ',1,'CONF_O')
      CALL GETMEM('CONF_O','ALLO','INTE',KLDET_OC,NAEL+NBEL)
      CALL GETMEM('CONF_M','ALLO','INTE',KLDET_MS,NAEL+NBEL)
C??? Jesper      CALL MEMMAN(KLDET_MS,NOCOB,'ADDL  ',1,'CONF_M')
      CALL GETMEM('CONF_M','ALLO','INTE',KLDET_VC,NOCOB)

*
*     KIB_OCCLS removed from the argument list, since it's not defined
*
*     / Jesper Wisborg Krogh, 2005-06-22
      CALL REO_GASDET_S(    IREO,
     &                  IWORK(KNSTSO(IATP)),
     &                 IWORK(KNSTSO(IBTP)),NOCTPA,NOCTPB,MXPNGAS,IOCTPA,
     &                    IOCTPB,  NBLOCK,  IBLOCK,    NAEL,    NBEL,
     &                 IWORK(KLASTR),IWORK(KLBSTR),NSMST,NELFSPGP,
*
     &                  NMXOCCLS,    NGAS,IWORK(KIOCLS),NTOOB,  NOBPT,
     &                  IWORK(KDFTP),
     &                  IB_CONF_REO,
     &                  iwork(kiconf_reo(isym)),
     &                  nconf_tot,
*
     &                  ib_conf_reo,
     &                     maxop,
     &                  nconf_per_open(1,isym),
     &                  IB_SD_FOR_OPEN,
     &                  IWORK(KLZSCR),
*
     &                  IWORK(KLZ),
     &                  IWORK(KLOCMIN),
     &                  IWORK(KLOCMAX),
     &                  IWORK(KLDET_OC),
     &                  IWORK(KLDET_MS),
*
     &                  IWORK(KLDET_VC),iWORK,KZ_PTDT,KREO_PTDT, MINOP,
     &                  IBCONF_ALL_SYM_FOR_OCCLS,PSSIGN,NPDTCNF)
*
      CALL GETMEM('KLASTR','FREE','INTE',KLASTR,MXNSTR*NAEL)
      CALL GETMEM('KLBSTR','FREE','INTE',KLBSTR,MXNSTR*NBEL)
      CALL GETMEM('ZSCR  ','FREE','INTE',KLZSCR,(NOCOB+1)*(NEL+1))
      CALL GETMEM('Z     ','FREE','INTE',KLZ,NOCOB*NEL*2)
      CALL GETMEM('OCMIN ','FREE','INTE',KLOCMIN,NOCOB)
      CALL GETMEM('OCMAX ','FREE','INTE',KLOCMAX,NOCOB)
      CALL GETMEM('CONF_O','FREE','INTE',KLDET_OC,NAEL+NBEL)
      CALL GETMEM('CONF_M','FREE','INTE',KLDET_MS,NAEL+NBEL)
      CALL GETMEM('CONF_M','FREE','INTE',KLDET_VC,NOCOB)
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
************************************************************************
      SubRoutine Cntrct(First,
     &                  Coef1,n1,m1,Coef2,n2,m2,
     &                  Coef3,n3,m3,Coef4,n4,m4,
     &                  ACInt,mabMin,mabMax,mcdMin,mcdMax,
     &                  Scrtch,nScrtch,ACOut,
     &                  IndZet,lZeta,IndEta,lEta)
************************************************************************
*                                                                      *
* Object: to transform the integrals from primitives to contracted     *
*         basis functions. The subroutine will do both complete and    *
*         incomplete transformations.                                  *
*                                                                      *
* Author:     Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
*
*-----Cache size
*
#include "lCache.fh"
      Real*8 Coef1(n1,m1), Coef2(n2,m2), Coef3(n3,m3), Coef4(n4,m4),
     &       ACInt(n1*n2*n3*n4,(mabMax-mabMin+1)*(mcdMax-mcdMin+1)),
     &       Scrtch(nScrtch),
     &       ACOut((mabMax-mabMin+1)*(mcdMax-mcdMin+1),m1*m2*m3*m4)
      Logical First
      Integer IndZet(lZeta), IndEta(lEta)
*
      iRout = 18
      iPrint = nPrint(iRout)
*
      mabcd=(mabMax-mabMin+1)*(mcdMax-mcdMin+1)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
         Call RecPrt('Cntrct: Coef1',' ',Coef1,n1,m1)
         Call RecPrt('Cntrct: Coef2',' ',Coef2,n2,m2)
         Call RecPrt('Cntrct: Coef3',' ',Coef3,n3,m3)
         Call RecPrt('Cntrct: Coef4',' ',Coef4,n4,m4)
         Call RecPrt('Cntrct: [a0|c0]',' ',ACInt,lZeta,lEta*mabcd)
         Write (6,*) 'IndZet=',IndZet
         Write (6,*) 'IndEta=',IndEta
      If (.not.First)
     &   Call RecPrt(' In Cntrct: Partial (a0|c0)',' ',
     &               ACOut,mabcd,m1*m2*m3*m4)
#endif
*     The idea here is to make the transformation in subblocks
*     (size=IncVec) to minimize cache faults. We split the range of
*     the compound index such that the contraction coefficients
*     (Coef1{n1,m1} & Coef2{n2,m2}), the first quater transformed block
*     {n2,IncVec}, for a fixed m1 index, and the half transformed block
*     {IncVec,m1,m2} fit into a fixed cache size.
*
*-----Reduce for contraction matrices and 3/4th
      nCache_ = (3*lCache)/4 - n1*m1 - n2*m2
*     Compute the size of the first quarter and half transformed block.
      lsize =  n1*n2 + n2*m1
*     The length of the compound index
      nVec = lEta*mabcd
*     Compute the size of the increment of which we will run the
*     compound index. It is the largest of 1 or the
      IncVec = Min(Max(1,nCache_/lsize),nVec)
*     Pointer to the full block of half transformed integrals
*     {nVec*m1*m2}
      ipA3 = 1
*     Pointer to the first quater transformed block {n1*IncVec}
      ipA2 = ipA3 + nVec*m1*m2
*define _CHECK_
#ifdef _CHECK_
      If (nVec*m1*m2+n2*IncVec.gt.nScrtch) Then
         Write (6,*) 'Cntrct: Memory failure 1'
         Write (6,*) 'nVec*m1*m2(A3)=',nVec*m1*m2
         Write (6,*) 'n2*IncVec(A2)=',n2*IncVec
         Write (6,*) 'n2,IncVec=',n2,IncVec
         Write (6,*) 'nVec,lsize=',nVec,lSize
         Write (6,*) 'n1,n2,m1  =',n1, n2, m1
         Write (6,*) 'nScrtch=',nScrtch
         Call Abend()
      End If
#endif
*
      Call CntHlf(Coef1,m1,n1,Coef2,m2,n2,lZeta,nVec,
     &            .True.,IncVec,ACInt,Scrtch(ipA2),Scrtch(ipA3),
     &            IndZet)
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Call RecPrt('Halftransformed',' ',
     &                       Scrtch(ipA3),nVec,m1*m2)
#endif
*
      nCache_ = (3*lCache)/4 - n3*m3 - n4*m4
      lsize = n3*n4 + n4*m3
      nVec = mabcd*m1*m2
      IncVec = Min(Max(1,nCache_/lsize),nVec)
#ifdef _CHECK_
      If (nVec*m3*m4+n4*IncVec.gt.nScrtch) Then
         Write (6,*) 'Cntrct: Memory failure 2'
         Call Abend()
      End If
#endif
*
      Call CntHlf(Coef3,m3,n3,Coef4,m4,n4,lEta,nVec,
     &            First,IncVec,Scrtch(ipA3),Scrtch(ipA2),ACOut,
     &            IndEta)
      First = .False.
*
#ifdef _DEBUGPRINT_
      Call RecPrt(' In Cntrct: (a0|c0) ',' ',
     &            ACOut,mabcd,m1*m2*m3*m4)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine kotani_cvb(bikcof,ndet,ifns)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ndet, ifns
real(kind=wp), intent(inout) :: bikcof(ndet,ifns)
integer(kind=iwp) :: k
real(kind=wp) :: dum(1)

! Kotani spin functions (generated by Gram-Schmidt orthonormalization of the Rumer functions)
call schmidtn_cvb(bikcof,ifns,dum,ndet,0)
do k=1,ifns/2
  call dswap_(ndet,bikcof(:,k),1,bikcof(:,ifns+1-k),1)
end do

return

end subroutine kotani_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine unpackk_ic_3(i,vint,ndimvi,Vic)
! this routine vint(j,k,l) = <i,j|k,l>
! for given i from incore (reduced) expanded block Vic
! ie. symp=symq=symr=syms
!
! i      - value of pivot index (I)
! vint   - array of integrals (O)
! ndimvi - (norb(symi)) (I)
! Vic    - incore expanded block of integrals (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: i, ndimvi
real(kind=wp), intent(out) :: vint(ndimvi,ndimvi,ndimvi)
real(kind=wp), intent(in) :: Vic((ndimvi*(ndimvi+1)/2)*(ndimvi*(ndimvi+1)/2+1)/2)
integer(kind=iwp) :: ik, ikjl, j, jl, k, l

do k=1,ndimvi

  ! def ik
  if (i >= k) then
    ik = i*(i-1)/2+k
  else
    ik = k*(k-1)/2+i
  end if

  jl = 0
  do j=1,ndimvi
    do l=1,j

      ! def jl
      jl = jl+1

      ! def ikjl
      if (ik >= jl) then
        ikjl = ik*(ik-1)/2+jl
      else
        ikjl = jl*(jl-1)/2+ik
      end if

      vint(j,k,l) = Vic(ikjl)
      vint(l,k,j) = Vic(ikjl)

    end do
  end do
end do

return

end subroutine unpackk_ic_3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Init(DoPairs,Verbose,irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: initialization of the LDF code.
C
C     Return codes:
C        irc=-1: user input error
C        irc=0: success
C        irc=1: internal error
C        irc=2: general unclassified error
C
C     Initialization must be considered failed if irc is non-zero.
C
      Implicit None
      Logical DoPairs
      Logical Verbose
      Integer irc
#include "localdf.fh"
#include "localdf_print.fh"
#include "WrkSpc.fh"

      Character*8 SecNam
      Parameter (SecNam='LDF_Init')

      Integer nTask
      Parameter (nTask=4)

      Character*17 Task(nTask)

      Logical Timing

      Integer nSym, nShell_Valence, nShell_Auxiliary
      Integer ip_T, l_T, iTask

      Real*8 tC0, tW0, tC1, tW1

      Integer  LDF_nBasSh
      External LDF_nBasSh

      Integer i, j
      Integer iTime
      iTime(i,j)=ip_T-1+2*(j-1)+i

      ! Init return code
      irc=0

      ! Check for symmetry (symmetry not implemented)
      Call Get_iScalar('nSym',nSym)
      If (nSym.ne.1) Then
         Write(6,'(A,A)')
     &   SecNam,': Local DF not implemented with symmetry!'
         irc=-1
         Return
      End If

      ! Init timing
      Timing=iPrint.ge.Inf_DetailedTiming
      If (Timing) Then
         l_T=2*nTask
         Call GetMem('LDFINIT','Allo','Real',ip_T,l_T)
         Call Cho_dZero(Work(ip_T),l_T)
      Else
         l_T=0
         ip_T=0
      End If

      ! Get a fresh start with Seward.
      ! Get number of valence and auxiliary shells.
      If (Timing) Call CWTime(tC0,tW0)
      Call LDF_CleanSheet(nShell_Valence,nShell_Auxiliary)
      If (Timing) Then
         Call CWTime(tC1,tW1)
         iTask=1
         Task(iTask)='Seward Init......'
         Work(iTime(1,iTask))=tC1-tC0
         Work(iTime(2,iTask))=tW1-tW0
      End If

      ! Set global basis and shell info
      ! nShell_Valence and nShell_Auxiliary are saved in
      ! localdf_bas.fh in this routine.
      If (Timing) Call CWTime(tC0,tW0)
      Call LDF_SetSh(nShell_Valence,nShell_Auxiliary,Verbose,irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': LDF_SetSh returned code',irc
         irc=1
         Return
      End If
      If (Timing) Then
         Call CWTime(tC1,tW1)
         iTask=2
         Task(iTask)='Shell Info.......'
         Work(iTime(1,iTask))=tC1-tC0
         Work(iTime(2,iTask))=tW1-tW0
      End If

      ! Initilize atom info: shells, aux shells, and coordinates on each
      ! atom.
      If (Timing) Call CWTime(tC0,tW0)
      Call LDF_SetAtomInfo(Verbose,irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': LDF_SetAtomInfo returned code',irc
         irc=1
         Return
      End If
      If (Timing) Then
         Call CWTime(tC1,tW1)
         iTask=3
         Task(iTask)='Atom Info........'
         Work(iTime(1,iTask))=tC1-tC0
         Work(iTime(2,iTask))=tW1-tW0
      End If

      ! Initialize atom pair info
      If (Timing) Call CWTime(tC0,tW0)
      If (DoPairs) Then
         Call LDF_SetAtomPairInfo(UseUniqueAtomPairs,Verbose,irc)
         If (irc.ne.0) Then
            Write(6,'(A,A,I8)')
     &      SecNam,': LDF_SetAtomPairInfo returned code',irc
            irc=1
            Return
         End If
      End If
      If (Timing) Then
         Call CWTime(tC1,tW1)
         iTask=4
         Task(iTask)='Atom Pair Info...'
         Work(iTime(1,iTask))=tC1-tC0
         Work(iTime(2,iTask))=tW1-tW0
      End If

      ! Print timing
      If (Timing) Then
         Write(6,'(/,A)')
     &   'Detailed Timing of LDF Initialization (CPU,Wall in s):'
         Do iTask=1,nTask
            Write(6,'(A17,1X,F7.1,1X,F7.1)')
     &      Task(iTask),Work(iTime(1,iTask)),Work(iTime(2,iTask))
         End Do
         Call xFlush(6)
         Call GetMem('LDFINIT','Free','Real',ip_T,l_T)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

function Golden(ax,bx,cx,f,tol_x,tol_f,xmin,rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,Scratch_New, &
                Scratch_Org,iPrint_Errors)

use Constants, only: One, Three, Five, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: Golden
real(kind=wp), intent(in) :: ax, bx, cx, tol_x, tol_f
real(kind=wp), intent(out) :: xmin
! External function f and its arguments
real(kind=wp), external :: f
integer(kind=iwp), intent(in) :: ij, l, nij, lMax, nElem, nAtoms, nPert, iPrint_Errors
real(kind=wp), intent(in) :: rMP(nij,0:nElem), xnrMP(nij,nElem), EC(3,nij), R_ij(3), C_o_C(3)
real(kind=wp), intent(out) :: xrMP(nij,nElem), xxrMP(nij,nElem), Scratch_New(nij*(2+lMax+1)), Scratch_Org(nij*(2+lMax+1))
real(kind=wp), intent(inout) :: AC(3,nij)
real(kind=wp) :: f2, f3, x1, x2, x3, x4
real(kind=wp), parameter :: Ratio = Half*(Three-sqrt(Five)), RM = One-Ratio

x1 = ax
x4 = cx
if (abs(cx-bx) > abs(bx-ax)) then
  x2 = bx
  x3 = RM*bx+Ratio*cx
else
  x2 = RM*bx+Ratio*ax
  x3 = bx
end if
f2 = f(x2,rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,Scratch_New,Scratch_Org,iPrint_Errors)
f3 = f(x3,rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,Scratch_New,Scratch_Org,iPrint_Errors)
do while ((abs(x4-x1) > tol_x*(abs(x1)+abs(x2))) .and. (abs(f3-f2) > tol_f*(abs(f2)+abs(f3))))
  if (f2 < f3) then
    x4 = x3
    x3 = x2
    f3 = f2
    x2 = RM*x3+Ratio*x1
    f2 = f(x2,rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,Scratch_New,Scratch_Org,iPrint_Errors)
  else
    x1 = x2
    x2 = x3
    f2 = f3
    x3 = RM*x2+Ratio*x4
    f3 = f(x3,rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,Scratch_New,Scratch_Org,iPrint_Errors)
  end if
end do
if (f2 < f3) then
  xmin = x2
  Golden = f2
else
  xmin = x3
  Golden = f3
end if

end function Golden

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine ONEEL_GUGA()

use guga_global, only: IADD10, ICH, IJ, ILIM, IOUT, IWAY, J1, J2, LN, Lu_10, MXVERT, NBUF, NMAT, NSM
use guga_util_global, only: COP, ICOP1, nCOP
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: I, ISTOP, IT1, IT2, ITT, ITYP, J, K, KJL, KJS, KM, NI, NK, NSI, NSK
logical(kind=iwp) :: first

IOUT = 0
NMAT = 0
ITYP = 0
do NK=1,LN
  do NI=1,NK
    K = ICH(NK)
    I = ICH(NI)
    if (K <= I) then
      K = ICH(NI)
      I = ICH(NK)
    end if
    NSK = NSM(K)
    KJS = IJ(K+1)+1
    KJL = IJ(K)
    NSI = NSM(I)
    if (NSI /= NSK) cycle
    IOUT = IOUT+1
    ICOP1(IOUT) = 0
    if (IOUT >= NBUF) then
      ICOP1(nCOP+1) = NBUF
      call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT = NMAT+NBUF
      IOUT = 0
    end if
    IOUT = IOUT+1
    !ICOP1(IOUT) = I+2**10*K
    ICOP1(IOUT) = ior(I,ishft(K,10))
    if (IOUT >= NBUF) then
      ICOP1(nCOP+1) = NBUF
      call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT = NMAT+NBUF
      IOUT = 0
    end if
    if (I == K) cycle
    do ITT=1,ILIM
      IT1 = (ITT-1)*MXVERT
      IT2 = IT1
      do J=KJS,KJL
        IWAY(K) = 1
        do
          KM = K
          J2(KM+1) = J
          J1(KM+1) = J
          call LOOP1(KM,ISTOP,IT1,IT2)
          if (ISTOP == 1) exit
          first = .true.
          do
            if (first) then
              KM = KM-1
              IWAY(KM) = 1
              first = .false.
            end if
            if (KM /= I) then
              call LOOP5(KM,ISTOP,IT1,IT2)
              if (ISTOP == 0) then
                first = .true.
                cycle
              end if
            else
              IWAY(I) = 1
              do
                KM = I
                call LOOP3(KM,ISTOP,IT1,IT2)
                if (ISTOP == 1) exit
                call COMP(I,J,ITYP,I,IT1,IT2)
              end do
            end if
            KM = KM+1
            if (KM == K) exit
          end do
        end do
      end do
    end do
  end do
end do
ICOP1(nCOP+1) = IOUT
call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
NMAT = NMAT+IOUT
ICOP1(nCOP+1) = -1
call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
write(u6,100) NMAT

return

100 format(/6X,'COEFFICIENTS FOR IJ',I11)

end subroutine ONEEL_GUGA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SCLDIA(A,FACTOR,NDIM,IPACK)
*
* scale diagonal of square matrix A
*
* IPACK = 0 : full matrix
* IPACK .NE. 0 : Lower triangular packed matrix
*                assumed packed columnwise !!!!
      IMPLICIT REAL*8 (A-H,O-Z)
*
      DIMENSION A(*)
*
      IF( IPACK .EQ. 0 ) THEN
        DO 100 I = 1,NDIM
          II = (I-1)*NDIM + I
          A(II) = A(II) * FACTOR
  100   CONTINUE
      ELSE
        II = 1
        DO 200 I = 1, NDIM
          A(II) = A(II) * FACTOR
          II = II + NDIM - I + 1
  200   CONTINUE
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Roland Lindh                                     *
************************************************************************
      Subroutine BackTrans_K(U,X,Y,nInter,nIter)
      Implicit None
      Integer nInter, nIter
      Real*8 U(nInter,nInter), X(nInter,nIter), Y(nInter,nIter)
*
*     Call RecPrt('U',' ',U,nInter,nInter)
*     Call RecPrt('X',' ',X,nInter,nIter)
      Call DGEMM_('N','N',nInter,nIter,nInter,
     &            1.0D0,U,nInter,
     &                  X,nInter,
     &            0.0D0,Y,nInter)
*     Call RecPrt('Y',' ',Y,nInter,nIter)
*
      End Subroutine BackTrans_K
*
      Subroutine BackTrans_K2(U,X,Y,nInter,nIter)
      Implicit None
      Integer nInter, nIter
      Real*8 U(nInter,nInter), X(nInter,nIter), Y(nInter,nIter)
*
*     Call RecPrt('U',' ',U,nInter,nInter)
*     Call RecPrt('X',' ',X,nInter,nIter)
      Call DGEMM_('N','T',nInter,nIter,nInter,
     &            1.0D0,X,nInter,
     &                  U,nInter,
     &            0.0D0,Y,nInter)
*     Call RecPrt('Y',' ',Y,nInter,nIter)
*
      End Subroutine BackTrans_K2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine InpCtl_GenANO()

use Genano_globals, only: nSets, iProj, kRfSet, nPrim, nCore, kSet, isUHF, thr, wSet, wc0, wc1, rowise, lftdeg, rydgen, Center, &
                          Title
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: LuIn, i, err
logical(kind=iwp) :: RdHead, done
character(len=72) :: Key, KeyIn
integer(kind=iwp), external :: IsFreeUnit

Title = 'Atom'
RdHead = .false.
nSets = 1
Center = 'ANO '
thr = 1.0e-8_wp
wc0 = Zero
wc1 = Zero
kRfSet = 1
rowise = .false.
lftdeg = .false.
rydgen = .false.
iProj = 0
nPrim(:) = 0
nCore(:) = 0
call mma_allocate(wSet,1,label='wSet')
wSet(1) = One
kSet = 0
isUHF = 0
!-----------------------------------------------------------------------
LuIn = IsFreeUnit(11)
call SpoolInp(LuIn)
call RdNlst(LuIn,'GENANO')
!-----------------------------------------------------------------------
done = .false.
do
  read(LuIn,'(a)',iostat=err) KeyIn
  if (err /= 0) exit
  Key = KeyIn
  !write(u6,*) 'echo> ',KeyIn
  call zlcase(Key)
  if (Key(1:1) == '*') then
    !continue
  else if (Key == ' ') then
    !continue
  else if (Key == 'title') then
    RdHead = .true.
  else if (Key == 'sets') then
    RdHead = .false.
    read(LuIn,*,iostat=err) nSets
    if (err /= 0) then
      write(u6,*) 'Error while reading input, keyword: ',trim(Key)
      call Quit_OnUserError()
    end if
    if (allocated(wSet)) call mma_deallocate(wSet)
    call mma_allocate(wSet,nSets,label='wSet')
    wSet(:) = One/nSets
  else if (Key == 'center') then
    RdHead = .false.
    read(LuIn,'(a)',iostat=err) Center
    if (err /= 0) then
      write(u6,*) 'Error while reading input, keyword: ',trim(Key)
      call Quit_OnUserError()
    end if
    call Upcase(Center)
  else if ((Key == 'no threshold') .or. (Key == 'nothreshold')) then
    read(LuIn,*,iostat=err) thr
    if (err /= 0) then
      write(u6,*) 'Error while reading input, keyword: ',trim(Key)
      call Quit_OnUserError()
    end if
  else if ((Key == 'row wise') .or. (Key == 'rowwise')) then
    RdHead = .false.
    rowise = .true.
  else if ((Key == 'lift degeneracy') .or. (Key == 'liftdegeneracy')) then
    RdHead = .false.
    lftdeg = .true.
  else if (Key == 'rydberg') then
    RdHead = .false.
    rydgen = .true.
  else if (Key == 'weights') then
    RdHead = .false.
    read(LuIn,*) (wSet(i),i=1,nSets)
  else if ((Key == 'orbitalweights') .or. (Key == 'orbital weights')) then
    read(LuIn,*) wc0,wc1
    !write(u6,'(a,f12.6)') 'inpctl: wc0',wc0
    !write(u6,'(a,f12.6)') 'inpctl: wc1',wc1
  else if (Key == 'project') then
    RdHead = .false.
    iProj = 1
  else if (Key == 'project 1') then
    RdHead = .false.
    iProj = 1
  else if (Key == 'project 2') then
    RdHead = .false.
    iProj = 2
  else if (Key == 'end of input') then
    RdHead = .false.
    done = .true.
  else if (RdHead) then
    if (Title == 'Atom') Title = KeyIn
    write(u6,*) trim(KeyIn)
  else
    write(u6,*) '*** Illegal keyword: ',KeyIn
    call Quit_OnUserError()
  end if
  if (done) exit
end do

return

end subroutine InpCtl_GenANO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Name(Element)

use Isotopes, only: PTab
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
character(len=2), intent(_OUT_) :: Element(*)
integer(kind=iwp) :: i, iElement_Nr, nAtoms
real(kind=wp), allocatable :: Chrg(:)

call Get_iScalar('Unique atoms',nAtoms)
call mma_Allocate(Chrg,nAtoms)

call Get_dArray('Nuclear charge',Chrg,nAtoms)

do i=1,nAtoms
  iElement_Nr = int(Chrg(i))
  if ((iElement_Nr >= lbound(PTab,1)) .and. (iElement_Nr <= ubound(PTab,1))) then
    Element(i) = PTab(iElement_Nr)
  else
    Element(i) = ' X'
  end if
end do
call mma_deallocate(Chrg)

return

end subroutine Get_Name

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************

subroutine ClrRunCache()

use RunFile_data, only: DS_cache, IS_cache, num_DS_init, num_IS_init
use Constants, only: Zero

implicit none

DS_cache(1:num_DS_init)%val = Zero
DS_cache(1:num_DS_init)%lab = ''
num_DS_init = 0

IS_cache(1:num_DS_init)%val = 0
IS_cache(1:num_DS_init)%lab = ''
num_IS_init = 0

return

end subroutine ClrRunCache

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine rotder(nmass,xmass,currxyz,ref123,trans,rotang,
     &   rotvec,rotmat,norder,dRVdXYZ,d2RVdXYZ2)
      implicit none
#include "stdalloc.fh"
      Integer nmass,norder
      real*8 xMass(nMass),CurrXYZ(3,nMass),Ref123(3,nMass)
      real*8 trans(3),RotAng,RotVec(3), RotMat(3,3)
      real*8 dRVdXYZ(3,3*nMass)
      real*8 d2RVdXYZ2(3,3*nMass,3*nMass)
* Local variables:
      Integer i,imass,ip,ip1,ip2,ipk,ipk1,ipk2
      Integer iter,j,j1,j2,k,k1,k2
      real*8 dRVdA(3,3),d2RVdA2(3,3,3),d3RVdA3(3,3,3,3)
      real*8 d4RVdA4(3,3,3,3,3)
      real*8 TotMass,MOI(3,3),MOIInv(3,3)
      real*8 Sum,Trace,SMat(3,3)
c     real*8 G(3,3),det,detinv
      real*8 Sayvetz2(3),RotErr,SmallRot(3)
      real*8 umat(3,3),vmat(3,3),sval(3),wTmp(100)
      real*8, dimension(:,:), allocatable :: Curr123,tmp
      real*8, dimension(:,:,:), allocatable :: dAdXYZ
*
      Call mma_allocate(Curr123,3,nMass,label='Curr123')
      Call mma_allocate(tmp,3,3*nMass,label='tmp')
      Call mma_allocate(dAdXYZ,3,3,nMass,label='dAdXYZ')

* Compute the Center-of-Mass coordinates.
* These are the same as the translation vector.
      Trans(1)=0.0D0
      Trans(2)=0.0D0
      Trans(3)=0.0D0
      TotMass=0.0D0
      do imass=1,nmass
        TotMass=TotMass+xMass(imass)
        Trans(1)=Trans(1)+xMass(imass)*CurrXYZ(1,imass)
        Trans(2)=Trans(2)+xMass(imass)*CurrXYZ(2,imass)
        Trans(3)=Trans(3)+xMass(imass)*CurrXYZ(3,imass)
      end do
      Trans(1)=Trans(1)/TotMass
      Trans(2)=Trans(2)/TotMass
      Trans(3)=Trans(3)/TotMass
* A lengthy piece of code determines the exact orientation
* of the internal frame. This is defined by Sayvetz conditions
* using a reference conformation. The procedure is iterative.
* At least an approximate rotation vector is assumed to be
* known when entering the Subroutine.
* Given rotation vector (''BigOmega'' in formulas),
* compute scalar rotation angle, and rotation matrix.
      RotAng=sqrt(RotVec(1)**2+RotVec(2)**2+RotVec(3)**2)
      Call mkRotMat(RotVec,RotMat)
      iter=0
  10  Continue
      iter=iter+1
      if(iter.ge.100) then
c       Call Quit_OnConvError()
        Call WarningMessage(1,
     &       'Warning: Convergence problem in the internal frame')
        goto 11
      end if
* compute cartesian position vectors in the co-moving frame:
* (Note: Inverse rotation matrix = transpose)
      do imass=1,nmass
       do i=1,3
        sum=0.0D0
        do j=1,3
         sum=sum+RotMat(j,i)*(CurrXYZ(j,imass)-Trans(j))
        end do
        Curr123(i,imass)=sum
       end do
      end do
* Compute the Moments-of-Inertia matrix. The asymmetrical
* one, used for Sayvetz conditions.
      call dcopy_(3*nmass,Ref123,1,tmp,1)
      Do imass=1,nMass
       Do i=1,3
        tmp(i,imass)=xMass(iMass)*tmp(i,imass)
       End Do
      End Do
      Call DGEMM_('N','T',3,3,nmass,1.0D0,tmp,3,Curr123,3,0.0D0,SMat,3)
      Trace=(SMat(1,1)+SMat(2,2)+SMat(3,3))
      do i=1,3
       do j=1,3
        MOI(i,j)=-SMat(i,j)
       end do
       MOI(i,i)=Trace-SMat(i,i)
      end do
* Invert the MOI-matrix.
c     G(1,1)=MOI(2,2)*MOI(3,3)-MOI(2,3)*MOI(3,2)
c     G(2,1)=MOI(3,2)*MOI(1,3)-MOI(3,3)*MOI(1,2)
c     G(3,1)=MOI(1,2)*MOI(2,3)-MOI(1,3)*MOI(2,2)
c     G(1,2)=MOI(2,3)*MOI(3,1)-MOI(2,1)*MOI(3,3)
c     G(2,2)=MOI(3,3)*MOI(1,1)-MOI(3,1)*MOI(1,3)
c     G(3,2)=MOI(1,3)*MOI(2,1)-MOI(1,1)*MOI(2,3)
c     G(1,3)=MOI(2,1)*MOI(3,2)-MOI(2,2)*MOI(3,1)
c     G(2,3)=MOI(3,1)*MOI(1,2)-MOI(3,2)*MOI(1,1)
c     G(3,3)=MOI(1,1)*MOI(2,2)-MOI(1,2)*MOI(2,1)
c     Det=MOI(1,1)*G(1,1)+MOI(2,1)*G(2,1)+MOI(3,1)*G(3,1)
c     DetInv=1.0D0/Det
c     MOIInv(1,1)=G(1,1)*DetInv
c     MOIInv(2,1)=G(1,2)*DetInv
c     MOIInv(3,1)=G(1,3)*DetInv
c     MOIInv(1,2)=G(2,1)*DetInv
c     MOIInv(2,2)=G(2,2)*DetInv
c     MOIInv(3,2)=G(2,3)*DetInv
c     MOIInv(1,3)=G(3,1)*DetInv
c     MOIInv(2,3)=G(3,2)*DetInv
c     MOIInv(3,3)=G(3,3)*DetInv
* (use the Moore-Penrose pseudoinverse, to deal with linear systems)
      call dgesvd_('A','A',3,3,MOI,3,sval,umat,3,vmat,3,wTmp,100,i)
      Do i=1,3
        If (Abs(sval(i)).gt.1.0d-12) Then
          call dscal_(3,1.0d0/sval(i),umat(1,i),1)
        Else
          call dcopy_(3,[0.0d0],0,umat(1,i),1)
        End If
      End Do
      Call dgemm_('T','T',3,3,3,1.0d0,vmat,3,umat,3,0.0d0,MOIInv,3)
* Determine small rotation that zeroes the Sayvetz rotational conditions
*      write(*,*)' Determine small rotation. First compute Sayvetz2:'
      do i=1,3
       j=1+mod(i,3)
       k=1+mod(j,3)
       sum=0.0D0
       do imass=1,nMass
        sum=sum+xMass(imass)*(Ref123(j,imass)*Curr123(k,imass)-
     &                       Ref123(k,imass)*Curr123(j,imass))
       end do
       Sayvetz2(i)=sum
      end do
      RotErr=0.0D0
      do i=1,3
       sum=0.0D0
       do j=1,3
        sum=sum+MOIInv(j,i)*Sayvetz2(j)
       end do
       SmallRot(i)=+sum
       RotErr=RotErr+sum**2
      end do
      RotErr=sqrt(RotErr)
* Limiting step size:
      If(RotErr.gt.1.0D0) then
        SmallRot(1)=SmallRot(1)/RotErr
        SmallRot(2)=SmallRot(2)/RotErr
        SmallRot(3)=SmallRot(3)/RotErr
        RotErr=1.0D0
      End If
* Apply this rotation to the rotation matrix:
      Call updRotMat(SmallRot,RotMat)
      if(RotErr.gt.1.0D-12) goto 10
  11  continue
* Now RotMat is converged. Recompute RotVec, RotAng.
      Call Mat2Vec(RotMat,RotVec,RotAng)
* Derivatives w.r.t A(i), of global rotation parameters RotVec
* Note: A(i) is the dual vector of the antisymmetric part of the
* asymmetrically defined MOI matrix, with frozen orientation.
* RotVec is the rotation parameter array necessary to make MOI
* symmetrical.
      call rotder4(norder,SMat,RotVec,dRVdA,d2RVdA2,d3RVdA3,d4RVdA4)
* Note that A(i) is exactly linear in atom coordinates.
* Definition of A(i) is as follows:
*    A(1)=sum( xMass(imass)*(Ref123(2,imass)*Curr123(3,imass)-
*                            Ref123(3,imass)*Curr123(2,imass)) )
*    A(2)=sum( xMass(imass)*(Ref123(3,imass)*Curr123(1,imass)-
*                            Ref123(1,imass)*Curr123(3,imass)) )
*    A(3)=sum( xMass(imass)*(Ref123(1,imass)*Curr123(2,imass)-
*                            Ref123(2,imass)*Curr123(1,imass)) )
* First, compute derivatives without accounting for COM motion:
      do ip=1,nmass
       do k=1,3
        dAdXYZ(1,k,ip)=xmass(ip)*
     &          (RotMat(k,3)*Ref123(2,ip)-RotMat(k,2)*Ref123(3,ip))
        dAdXYZ(2,k,ip)=xmass(ip)*
     &          (RotMat(k,1)*Ref123(3,ip)-RotMat(k,3)*Ref123(1,ip))
        dAdXYZ(3,k,ip)=xmass(ip)*
     &          (RotMat(k,2)*Ref123(1,ip)-RotMat(k,1)*Ref123(2,ip))
       end do
      end do
* Correction for COM motion: (Theoretically, this makes no
* difference to the results, but why not...)
      do i=1,3
       do k=1,3
        sum=0.0d0
        do ip=1,nmass
         sum=sum+dAdXYZ(i,k,ip)
        end do
        do ip=1,nmass
         dAdXYZ(i,k,ip)=dAdXYZ(i,k,ip)-(xMass(ip)/TotMass)*sum
        end do
       end do
      end do
* Finally,transform dXdA, etc, into derivatives w.r.t atom coordinates:
*  dRVdXYZ(i,k,ip)= sum dRVdA(i,j)*dAdXYZ(j,k,ip)
*  d2RVdXYZ2(i,k1,ip1,k2,ip2)=
*    sum d2RVdA2(i,j1,j2)*dAdXYZ(j1,k1,ip1)*dAdXYZ(j2,k2,ip2)
*  and so on.. Note: A is linear in nuclear coordinates.
      If (nOrder.ge.1) Then
      do i=1,3
       do ip=1,nMass
        do k=1,3
         ipk=k+3*(ip-1)
         sum=0.0D0
         do j=1,3
          sum=sum+dRVdA(i,j)*dAdXYZ(j,k,ip)
         end do
         dRVdXYZ(i,ipk)=sum
        end do
       end do
      end do
      End If
      If (nOrder.ge.2) Then
      do i=1,3
       do j1=1,3
        do ip2=1,nMass
         do k2=1,3
          ipk2=k2+3*(ip2-1)
          sum=0.0D0
          do j2=1,3
           sum=sum+d2RVdA2(i,j1,j2)*dAdXYZ(j2,k2,ip2)
          end do
          tmp(j1,ipk2)=sum
         end do
        end do
       end do
       do ipk2=1,3*nMass
        do ip1=1,nMass
         do k1=1,3
          ipk1=k1+3*(ip1-1)
          sum=0.0D0
          do j1=1,3
           sum=sum+tmp(j1,ipk2)*dAdXYZ(j1,k1,ip1)
          end do
          d2RVdXYZ2(i,ipk1,ipk2)=sum
         end do
        end do
       end do
      end do
      End If
      Call mma_deallocate(Curr123)
      Call mma_deallocate(tmp)
      Call mma_deallocate(dAdXYZ)
      return
      end
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine rotder4(norder,S,X,dXdA,d2XdA2,d3XdA3,d4XdA4)
      implicit none
* Call arguments:
      integer norder
      real*8 S(3,3)
      real*8 X(3),dXdA(3,3),d2XdA2(3,3,3),d3XdA3(3,3,3,3)
      real*8 d4XdA4(3,3,3,3,3)
* Local variables:
      integer i,i1,i2,i3,ia,ib,ic,id,j,k,l,m,n
      real*8 c0,c1,c2,Q,cs,sn,sum,XN
      real*8 dc0dQ,d2c0dQ2,d3c0dQ3,d4c0dQ4
      real*8 dc1dQ,d2c1dQ2,d3c1dQ3,d4c1dQ4
      real*8 dc2dQ,d2c2dQ2,d3c2dQ3,d4c2dQ4
      real*8 dc0dX(3),d2c0dX2(3,3),d3c0dX3(3,3,3),d4c0dX4(3,3,3,3)
      real*8 dc1dX(3),d2c1dX2(3,3),d3c1dX3(3,3,3),d4c1dX4(3,3,3,3)
      real*8 dc2dX(3),d2c2dX2(3,3),d3c2dX3(3,3,3),d4c2dX4(3,3,3,3)
      real*8 U(3,3),dUdX(3,3,3),d2UdX2(3,3,3,3),d3UdX3(3,3,3,3,3)
      real*8 d4UdX4(3,3,3,3,3,3)
      real*8 S0(3,3)
      real*8 dPdX(3,3,3),d2PdX2(3,3,3,3),d3PdX3(3,3,3,3,3)
      real*8 d4PdX4(3,3,3,3,3,3)
      real*8 dAdX(3,3),d2AdX2(3,3,3),d3AdX3(3,3,3,3)
      real*8 d4AdX4(3,3,3,3,3)
c     real*8 T(3,3),det,detinv
      real*8 tmp1(3),tmp2(3,3),tmp3(3,3,3),tmp4(3,3,3,3)
      real*8 tmp5(3,3,3,3,3),tmp5A(3,3,3,3,3)
      real*8 umat(3,3),vmat(3,3),sval(3),wTmp(100)
*
      d2c0dQ2=0.0D0 ! Dummy initialize
      d2c1dQ2=0.0D0 ! Dummy initialize
      d2c2dQ2=0.0D0 ! Dummy initialize
      d3c0dQ3=0.0D0 ! Dummy initialize
      d3c1dQ3=0.0D0 ! Dummy initialize
      d3c2dQ3=0.0D0 ! Dummy initialize
      d4c0dQ4=0.0D0 ! Dummy initialize
      d4c1dQ4=0.0D0 ! Dummy initialize
      d4c2dQ4=0.0D0 ! Dummy initialize
*
      Q=X(1)**2+X(2)**2+X(3)**2
      XN=sqrt(Q)
*                                                                      *
************************************************************************
*                                                                      *
      if (Q.lt.0.5D0) then
* Use a Taylor expansion:
        c0=1.D0-(Q/2.D0)
     &    *(1.D0-(Q/12.D0)*(1.D0-(Q/30.D0)*(1.D0-(Q/56.D0))))
        c1=(1.D0-(Q/6.D0)
     &    *(1.D0-(Q/20.D0)*(1.D0-(Q/42.D0)*(1.D0-(Q/72.D0)))))
        c2=(1.D0-(Q/12.D0)
     &    *(1.D0-(Q/30.D0)*(1.D0-(Q/56.D0)*(1.D0-(Q/90.D0)))))/2.D0
        dc0dQ=-(1.D0-(Q/6.D0)
     &       *(1.D0-(Q/20.D0)*(1.D0-(Q/42.D0)*(1.D0-(Q/72.D0)))))/2.D0
        dc1dQ=-(1.D0-(Q/10.D0)*(1.D0-(Q/28.D0)*(1.D0-(Q/54.D0))))/6.D0
        dc2dQ=-(1.D0-(Q/30.D0)
     &       *(2.D0-(Q/56.D0)*(3.D0-(Q/90.D0)*4.D0)))/24.D0
       if (norder.le.1) goto 101
        d2c0dQ2=(1.D0-(Q/10.D0)*(1.D0-(Q/28.D0)*(1.D0-(Q/54.D0))))/12.D0
        d2c1dQ2=(1.D0-(Q/14.D0)*(1.D0-(Q/36.D0)*(1.D0-(Q/66.D0))))/60.D0
        d2c2dQ2= (1.D0-(Q/56.D0)
     &         *(3.D0-(Q/90.D0)*(6.D0-(Q/132.D0)*10.D0)))/360.D0
       if (norder.le.2) goto 101
        d3c0dQ3=-(1.D0-(Q/14.D0)
     &         *(1.D0-(Q/36.D0)*(1.D0-(Q/66.D0))))/120.D0
        d3c1dQ3=-(1.D0-(Q/18.D0)
     &         *(1.D0-(Q/44.D0)*(1.D0-(Q/78.D0))))/840.D0
        d3c2dQ3=-(1.D0-(Q/90.D0)*(4.D0-(Q/132.D0)*10.D0))/6720.D0
       if (norder.le.3) goto 101
        d4c0dQ4=(1.D0-(Q/18.D0)
     &         *(1.D0-(Q/44.D0)*(1.D0-(Q/78.D0))))/1680.D0
        d4c1dQ4=(1.D0-(Q/22.D0)
     &         *(1.D0-(Q/52.D0)*(1.D0-(Q/90.D0))))/15120.D0
        d4c2dQ4= (1.D0-(Q/132.D0)*(5.D0-(Q/182.D0)*15.D0))/151200.D0
 101  continue
      else
       cs=cos(XN)
       sn=sin(XN)
       c0=cs
       c1=sn/XN
       c2=(1.0D0-cs)/(XN**2)
       dc0dQ=-sn/(2.D0*XN)
       dc1dQ=-(sn-XN*cs)/(2.D0*XN**3)
       dc2dQ=(-2.D0+2.D0*cs+XN*sn)/(2.D0*XN**4)
       if (norder.le.1) goto 102
       d2c0dQ2=(sn-XN*cs)/(4.D0*XN**3)
       d2c1dQ2=-(3.D0*XN*cs-(3.D0-Q)*sn)/(4.D0*XN**5)
       d2c2dQ2=(8.D0-(8.D0-XN**2)*cs-5.D0*XN*sn)/(4.D0*XN**6)
       if (norder.le.2) goto 102
       d3c0dQ3=(3.D0*XN*cs-(3.D0-Q)*sn)/(8.D0*XN**5)
       d3c1dQ3=-((15.D0-6.D0*Q)*sn-XN*(15.D0-Q)*cs)/(8.D0*XN**7)
       d3c2dQ3=(-48.D0+(48.D0-9.D0*XN**2)*cs+XN*(33.D0-XN**2)*sn)
     &        /(8.D0*XN**8)
       if (norder.le.3) goto 102
       d4c0dQ4=((15.D0-6.D0*Q)*sn-XN*(15.D0-Q)*cs)/(16.D0*XN**7)
       d4c1dQ4=((105.D0-Q*(45.D0-Q))*sn-XN*(105.D0-10.D0*Q)*cs)
     &        /(16.D0*XN**9)
       d4c2dQ4=(384.D0-(384.D0-87.D0*XN**2+XN**4)*cs
     &        -XN*(279.D0-14.D0*XN**2)*sn)/(16.D0*XN**10)
 102  continue
      end if
      do i=1,3
       dc0dX(i)=2.D0*dc0dQ*X(i)
       dc1dX(i)=2.D0*dc1dQ*X(i)
       dc2dX(i)=2.D0*dc2dQ*X(i)
      end do
      if (norder.le.1) goto 103
      do j=1,3
       do i=1,3
        d2c0dX2(i,j)=4.D0*d2c0dQ2*X(i)*X(j)
        d2c1dX2(i,j)=4.D0*d2c1dQ2*X(i)*X(j)
        d2c2dX2(i,j)=4.D0*d2c2dQ2*X(i)*X(j)
       end do
      end do
      do i=1,3
       d2c0dX2(i,i)=d2c0dX2(i,i)+2.D0*dc0dQ
       d2c1dX2(i,i)=d2c1dX2(i,i)+2.D0*dc1dQ
       d2c2dX2(i,i)=d2c2dX2(i,i)+2.D0*dc2dQ
      end do
      if (norder.le.2) goto 103
      do k=1,3
       do j=1,3
        do i=1,3
         d3c0dX3(i,j,k)=8.D0*d3c0dQ3*X(i)*X(j)*X(k)
         d3c1dX3(i,j,k)=8.D0*d3c1dQ3*X(i)*X(j)*X(k)
         d3c2dX3(i,j,k)=8.D0*d3c2dQ3*X(i)*X(j)*X(k)
        end do
       end do
      end do
      do i=1,3
       do j=1,3
        d3c0dX3(i,i,j)=d3c0dX3(i,i,j)+4.D0*d2c0dQ2*X(j)
        d3c0dX3(i,j,i)=d3c0dX3(i,j,i)+4.D0*d2c0dQ2*X(j)
        d3c0dX3(j,i,i)=d3c0dX3(j,i,i)+4.D0*d2c0dQ2*X(j)
        d3c1dX3(i,i,j)=d3c1dX3(i,i,j)+4.D0*d2c1dQ2*X(j)
        d3c1dX3(i,j,i)=d3c1dX3(i,j,i)+4.D0*d2c1dQ2*X(j)
        d3c1dX3(j,i,i)=d3c1dX3(j,i,i)+4.D0*d2c1dQ2*X(j)
        d3c2dX3(i,i,j)=d3c2dX3(i,i,j)+4.D0*d2c2dQ2*X(j)
        d3c2dX3(i,j,i)=d3c2dX3(i,j,i)+4.D0*d2c2dQ2*X(j)
        d3c2dX3(j,i,i)=d3c2dX3(j,i,i)+4.D0*d2c2dQ2*X(j)
       end do
      end do
      if (norder.le.3) goto 103
      do l=1,3
       do k=1,3
        do j=1,3
         do i=1,3
          d4c0dX4(i,j,k,l)=16.D0*d4c0dQ4*X(i)*X(j)*X(k)*X(l)
          d4c1dX4(i,j,k,l)=16.D0*d4c1dQ4*X(i)*X(j)*X(k)*X(l)
          d4c2dX4(i,j,k,l)=16.D0*d4c2dQ4*X(i)*X(j)*X(k)*X(l)
         end do
        end do
       end do
      end do
      do k=1,3
       do j=1,3
        do i=1,3
         d4c0dX4(i,i,j,k)=d4c0dX4(i,i,j,k)+8.D0*d3c0dQ3*X(j)*X(k)
         d4c0dX4(i,j,i,k)=d4c0dX4(i,j,i,k)+8.D0*d3c0dQ3*X(j)*X(k)
         d4c0dX4(i,j,k,i)=d4c0dX4(i,j,k,i)+8.D0*d3c0dQ3*X(j)*X(k)
         d4c0dX4(j,i,i,k)=d4c0dX4(j,i,i,k)+8.D0*d3c0dQ3*X(j)*X(k)
         d4c0dX4(j,i,k,i)=d4c0dX4(j,i,k,i)+8.D0*d3c0dQ3*X(j)*X(k)
         d4c0dX4(j,k,i,i)=d4c0dX4(j,k,i,i)+8.D0*d3c0dQ3*X(j)*X(k)
         d4c1dX4(i,i,j,k)=d4c1dX4(i,i,j,k)+8.D0*d3c1dQ3*X(j)*X(k)
         d4c1dX4(i,j,i,k)=d4c1dX4(i,j,i,k)+8.D0*d3c1dQ3*X(j)*X(k)
         d4c1dX4(i,j,k,i)=d4c1dX4(i,j,k,i)+8.D0*d3c1dQ3*X(j)*X(k)
         d4c1dX4(j,i,i,k)=d4c1dX4(j,i,i,k)+8.D0*d3c1dQ3*X(j)*X(k)
         d4c1dX4(j,i,k,i)=d4c1dX4(j,i,k,i)+8.D0*d3c1dQ3*X(j)*X(k)
         d4c1dX4(j,k,i,i)=d4c1dX4(j,k,i,i)+8.D0*d3c1dQ3*X(j)*X(k)
         d4c2dX4(i,i,j,k)=d4c2dX4(i,i,j,k)+8.D0*d3c2dQ3*X(j)*X(k)
         d4c2dX4(i,j,i,k)=d4c2dX4(i,j,i,k)+8.D0*d3c2dQ3*X(j)*X(k)
         d4c2dX4(i,j,k,i)=d4c2dX4(i,j,k,i)+8.D0*d3c2dQ3*X(j)*X(k)
         d4c2dX4(j,i,i,k)=d4c2dX4(j,i,i,k)+8.D0*d3c2dQ3*X(j)*X(k)
         d4c2dX4(j,i,k,i)=d4c2dX4(j,i,k,i)+8.D0*d3c2dQ3*X(j)*X(k)
         d4c2dX4(j,k,i,i)=d4c2dX4(j,k,i,i)+8.D0*d3c2dQ3*X(j)*X(k)
        end do
       end do
      end do
      do j=1,3
       do i=1,3
        d4c0dX4(i,i,j,j)=d4c0dX4(i,i,j,j)+4.D0*d2c0dQ2
        d4c0dX4(i,j,i,j)=d4c0dX4(i,j,i,j)+4.D0*d2c0dQ2
        d4c0dX4(i,j,j,i)=d4c0dX4(i,j,j,i)+4.D0*d2c0dQ2
        d4c1dX4(i,i,j,j)=d4c1dX4(i,i,j,j)+4.D0*d2c1dQ2
        d4c1dX4(i,j,i,j)=d4c1dX4(i,j,i,j)+4.D0*d2c1dQ2
        d4c1dX4(i,j,j,i)=d4c1dX4(i,j,j,i)+4.D0*d2c1dQ2
        d4c2dX4(i,i,j,j)=d4c2dX4(i,i,j,j)+4.D0*d2c2dQ2
        d4c2dX4(i,j,i,j)=d4c2dX4(i,j,i,j)+4.D0*d2c2dQ2
        d4c2dX4(i,j,j,i)=d4c2dX4(i,j,j,i)+4.D0*d2c2dQ2
       end do
      end do
 103  continue
* The unitary matrix U=exp(XMat), and its derivatives.
* Here, X is the matrix with elements XMat(i,j)=eps(i,k,j)*X(k)
* First term, cos(X)*delta(i,j):
      do i=1,3
       do j=1,3
        U(i,j)=0.0d0
       end do
       U(i,i)=c0
      end do
      do k=1,3
      do i=1,3
       do j=1,3
        dUdX(i,j,k)=0.0d0
       end do
       dUdX(i,i,k)=dc0dX(k)
      end do
      end do
      if (norder.le.1) goto 201

      do k=1,3
      do l=1,3
      do i=1,3
       do j=1,3
        d2UdX2(i,j,k,l)=0.0d0
       end do
       d2UdX2(i,i,k,l)=d2c0dX2(k,l)
      end do
      end do
      end do
      if (norder.le.2) goto 201
      do k=1,3
      do l=1,3
      do m=1,3
      do i=1,3
       do j=1,3
        d3UdX3(i,j,k,l,m)=0.0d0
       end do
       d3UdX3(i,i,k,l,m)=d3c0dX3(k,l,m)
      end do
      end do
      end do
      end do
      if (norder.le.3) goto 201
      do k=1,3
      do l=1,3
      do m=1,3
      do n=1,3
      do i=1,3
       do j=1,3
        d4UdX4(i,j,k,l,m,n)=0.0d0
       end do
       d4UdX4(i,i,k,l,m,n)=d4c0dX4(k,l,m,n)
      end do
      end do
      end do
      end do
      end do
 201  continue
* Second term, (sin(X)/X)*eps(i,k,j)*X(k):
      do i1=1,3
       i2=1+mod(i1,3)
       i3=1+mod(i2,3)
       U(i1,i3)=U(i1,i3)+c1*X(i2)
       U(i3,i1)=U(i3,i1)-c1*X(i2)
       do k=1,3
        dUdX(i1,i3,k)=dUdX(i1,i3,k)+dc1dX(k)*X(i2)
        dUdX(i3,i1,k)=dUdX(i3,i1,k)-dc1dX(k)*X(i2)
       end do
       dUdX(i1,i3,i2)=dUdX(i1,i3,i2)+c1
       dUdX(i3,i1,i2)=dUdX(i3,i1,i2)-c1
       if (norder.le.1) goto 202
       do k=1,3
        do l=1,3
         d2UdX2(i1,i3,k,l)=d2UdX2(i1,i3,k,l)+d2c1dX2(k,l)*X(i2)
         d2UdX2(i3,i1,k,l)=d2UdX2(i3,i1,k,l)-d2c1dX2(k,l)*X(i2)
        end do
       end do
       do k=1,3
        d2UdX2(i1,i3,i2,k)=d2UdX2(i1,i3,i2,k)+dc1dX(k)
        d2UdX2(i3,i1,i2,k)=d2UdX2(i3,i1,i2,k)-dc1dX(k)
        d2UdX2(i1,i3,k,i2)=d2UdX2(i1,i3,k,i2)+dc1dX(k)
        d2UdX2(i3,i1,k,i2)=d2UdX2(i3,i1,k,i2)-dc1dX(k)
       end do
       if (norder.le.2) goto 202
       do k=1,3
        do l=1,3
         do m=1,3
          d3UdX3(i1,i3,k,l,m)=d3UdX3(i1,i3,k,l,m)+d3c1dX3(k,l,m)*X(i2)
          d3UdX3(i3,i1,k,l,m)=d3UdX3(i3,i1,k,l,m)-d3c1dX3(k,l,m)*X(i2)
         end do
        end do
       end do
       do k=1,3
        do l=1,3
         d3UdX3(i1,i3,i2,k,l)=d3UdX3(i1,i3,i2,k,l)+d2c1dX2(k,l)
         d3UdX3(i3,i1,i2,k,l)=d3UdX3(i3,i1,i2,k,l)-d2c1dX2(k,l)
         d3UdX3(i1,i3,k,i2,l)=d3UdX3(i1,i3,k,i2,l)+d2c1dX2(k,l)
         d3UdX3(i3,i1,k,i2,l)=d3UdX3(i3,i1,k,i2,l)-d2c1dX2(k,l)
         d3UdX3(i1,i3,k,l,i2)=d3UdX3(i1,i3,k,l,i2)+d2c1dX2(k,l)
         d3UdX3(i3,i1,k,l,i2)=d3UdX3(i3,i1,k,l,i2)-d2c1dX2(k,l)
        end do
       end do
       if (norder.le.3) goto 202
       do k=1,3
        do l=1,3
         do m=1,3
          do n=1,3
           d4UdX4(i1,i3,k,l,m,n)=
     &                   d4UdX4(i1,i3,k,l,m,n)+d4c1dX4(k,l,m,n)*X(i2)
           d4UdX4(i3,i1,k,l,m,n)=
     &                   d4UdX4(i3,i1,k,l,m,n)-d4c1dX4(k,l,m,n)*X(i2)
          end do
         end do
        end do
       end do
       do k=1,3
        do l=1,3
         do m=1,3
          d4UdX4(i1,i3,i2,k,l,m)=d4UdX4(i1,i3,i2,k,l,m)+d3c1dX3(k,l,m)
          d4UdX4(i3,i1,i2,k,l,m)=d4UdX4(i3,i1,i2,k,l,m)-d3c1dX3(k,l,m)
          d4UdX4(i1,i3,k,i2,l,m)=d4UdX4(i1,i3,k,i2,l,m)+d3c1dX3(k,l,m)
          d4UdX4(i3,i1,k,i2,l,m)=d4UdX4(i3,i1,k,i2,l,m)-d3c1dX3(k,l,m)
          d4UdX4(i1,i3,k,l,i2,m)=d4UdX4(i1,i3,k,l,i2,m)+d3c1dX3(k,l,m)
          d4UdX4(i3,i1,k,l,i2,m)=d4UdX4(i3,i1,k,l,i2,m)-d3c1dX3(k,l,m)
          d4UdX4(i1,i3,k,l,m,i2)=d4UdX4(i1,i3,k,l,m,i2)+d3c1dX3(k,l,m)
          d4UdX4(i3,i1,k,l,m,i2)=d4UdX4(i3,i1,k,l,m,i2)-d3c1dX3(k,l,m)
         end do
        end do
       end do
 202   continue
      end do
* Third term,((1-cos(X))/X**2)*X(i)*X(j):
      do i=1,3
       do j=1,3
        U(i,j)=U(i,j)+c2*X(i)*X(j)
        do k=1,3
         dUdX(i,j,k)=dUdX(i,j,k)+dc2dX(k)*X(i)*X(j)
        end do
        dUdX(i,j,i)=dUdX(i,j,i)+c2*X(j)
        dUdX(i,j,j)=dUdX(i,j,j)+c2*X(i)
       end do
      end do
      if (norder.le.1) goto 203
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          d2UdX2(i,j,k,l)=d2UdX2(i,j,k,l)+d2c2dX2(k,l)*X(i)*X(j)
         end do
         d2UdX2(i,j,i,k)=d2UdX2(i,j,i,k)+dc2dX(k)*X(j)
         d2UdX2(i,j,j,k)=d2UdX2(i,j,j,k)+dc2dX(k)*X(i)
         d2UdX2(i,j,k,i)=d2UdX2(i,j,k,i)+dc2dX(k)*X(j)
         d2UdX2(i,j,k,j)=d2UdX2(i,j,k,j)+dc2dX(k)*X(i)
        end do
        d2UdX2(i,j,i,j)=d2UdX2(i,j,i,j)+c2
        d2UdX2(i,j,j,i)=d2UdX2(i,j,j,i)+c2
       end do
      end do
      if (norder.le.2) goto 203
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          do m=1,3
           d3UdX3(i,j,k,l,m)=d3UdX3(i,j,k,l,m)+d3c2dX3(k,l,m)*X(i)*X(j)
          end do
          d3UdX3(i,j,i,k,l)=d3UdX3(i,j,i,k,l)+d2c2dX2(k,l)*X(j)
          d3UdX3(i,j,j,k,l)=d3UdX3(i,j,j,k,l)+d2c2dX2(k,l)*X(i)
          d3UdX3(i,j,k,i,l)=d3UdX3(i,j,k,i,l)+d2c2dX2(k,l)*X(j)
          d3UdX3(i,j,k,j,l)=d3UdX3(i,j,k,j,l)+d2c2dX2(k,l)*X(i)
          d3UdX3(i,j,k,l,i)=d3UdX3(i,j,k,l,i)+d2c2dX2(k,l)*X(j)
          d3UdX3(i,j,k,l,j)=d3UdX3(i,j,k,l,j)+d2c2dX2(k,l)*X(i)
         end do
         d3UdX3(i,j,i,j,k)=d3UdX3(i,j,i,j,k)+dc2dX(k)
         d3UdX3(i,j,j,i,k)=d3UdX3(i,j,j,i,k)+dc2dX(k)
         d3UdX3(i,j,i,k,j)=d3UdX3(i,j,i,k,j)+dc2dX(k)
         d3UdX3(i,j,j,k,i)=d3UdX3(i,j,j,k,i)+dc2dX(k)
         d3UdX3(i,j,k,i,j)=d3UdX3(i,j,k,i,j)+dc2dX(k)
         d3UdX3(i,j,k,j,i)=d3UdX3(i,j,k,j,i)+dc2dX(k)
        end do
       end do
      end do
      if (norder.le.3) goto 203
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          do m=1,3
           do n=1,3
            d4UdX4(i,j,k,l,m,n)=d4UdX4(i,j,k,l,m,n)+
     &                          d4c2dX4(k,l,m,n)*X(i)*X(j)
           end do
           d4UdX4(i,j,i,k,l,m)=d4UdX4(i,j,i,k,l,m)+d3c2dX3(k,l,m)*X(j)
           d4UdX4(i,j,j,k,l,m)=d4UdX4(i,j,j,k,l,m)+d3c2dX3(k,l,m)*X(i)
           d4UdX4(i,j,k,i,l,m)=d4UdX4(i,j,k,i,l,m)+d3c2dX3(k,l,m)*X(j)
           d4UdX4(i,j,k,j,l,m)=d4UdX4(i,j,k,j,l,m)+d3c2dX3(k,l,m)*X(i)
           d4UdX4(i,j,k,l,i,m)=d4UdX4(i,j,k,l,i,m)+d3c2dX3(k,l,m)*X(j)
           d4UdX4(i,j,k,l,j,m)=d4UdX4(i,j,k,l,j,m)+d3c2dX3(k,l,m)*X(i)
           d4UdX4(i,j,k,l,m,i)=d4UdX4(i,j,k,l,m,i)+d3c2dX3(k,l,m)*X(j)
           d4UdX4(i,j,k,l,m,j)=d4UdX4(i,j,k,l,m,j)+d3c2dX3(k,l,m)*X(i)
          end do
          d4UdX4(i,j,i,j,k,l)=d4UdX4(i,j,i,j,k,l)+d2c2dX2(k,l)
          d4UdX4(i,j,i,k,j,l)=d4UdX4(i,j,i,k,j,l)+d2c2dX2(k,l)
          d4UdX4(i,j,i,k,l,j)=d4UdX4(i,j,i,k,l,j)+d2c2dX2(k,l)
          d4UdX4(i,j,k,i,j,l)=d4UdX4(i,j,k,i,j,l)+d2c2dX2(k,l)
          d4UdX4(i,j,k,i,l,j)=d4UdX4(i,j,k,i,l,j)+d2c2dX2(k,l)
          d4UdX4(i,j,k,l,i,j)=d4UdX4(i,j,k,l,i,j)+d2c2dX2(k,l)
          d4UdX4(i,j,j,i,k,l)=d4UdX4(i,j,j,i,k,l)+d2c2dX2(k,l)
          d4UdX4(i,j,j,k,i,l)=d4UdX4(i,j,j,k,i,l)+d2c2dX2(k,l)
          d4UdX4(i,j,j,k,l,i)=d4UdX4(i,j,j,k,l,i)+d2c2dX2(k,l)
          d4UdX4(i,j,k,j,i,l)=d4UdX4(i,j,k,j,i,l)+d2c2dX2(k,l)
          d4UdX4(i,j,k,j,l,i)=d4UdX4(i,j,k,j,l,i)+d2c2dX2(k,l)
          d4UdX4(i,j,k,l,j,i)=d4UdX4(i,j,k,l,j,i)+d2c2dX2(k,l)
         end do
        end do
       end do
      end do
 203  continue
* The matrix S (which should be symmetrical) is the product
* S=S0*U=S0*exp(X) with X given as input arguments to this Subroutine.
* Need to compute S0=S*U(transpose):
      do i=1,3
       do j=1,3
        sum=0.0D0
        do k=1,3
         sum=sum+S(i,k)*U(j,k)
        end do
        S0(i,j)=sum
       end do
      end do
* The matrix product P=S0*U, where now U is used as an expansion in
* the variables X, and its derivatives:
      do i=1,3
       do j=1,3
*       sum=0.0D0
*       do i1=1,3
*        sum=sum+S0(i,i1)*U(i1,j)
*       end do
*       P(i,j)=sum
        do k=1,3
         sum=0.0D0
         do i1=1,3
          sum=sum+S0(i,i1)*dUdX(i1,j,k)
         end do
         dPdX(i,j,k)=sum
        end do
       end do
      end do
      if (norder.le.1) goto 301
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          sum=0.0D0
          do i1=1,3
           sum=sum+S0(i,i1)*d2UdX2(i1,j,k,l)
          end do
          d2PdX2(i,j,k,l)=sum
         end do
        end do
       end do
      end do
      if (norder.le.2) goto 301
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          do m=1,3
           sum=0.0D0
           do i1=1,3
            sum=sum+S0(i,i1)*d3UdX3(i1,j,k,l,m)
           end do
           d3PdX3(i,j,k,l,m)=sum
          end do
         end do
        end do
       end do
      end do
      if (norder.le.3) goto 301
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          do m=1,3
           do n=1,3
            sum=0.0D0
            do i1=1,3
             sum=sum+S0(i,i1)*d4UdX4(i1,j,k,l,m,n)
            end do
            d4PdX4(i,j,k,l,m,n)=sum
           end do
          end do
         end do
        end do
       end do
      end do
 301  continue
* The vector A is the dual of the antisymmetric part of P:
*       A(1)=P(3,2)-P(2,3)
*       A(2)=P(1,3)-P(3,1)
*       A(3)=P(2,1)-P(1,2)
        do i=1,3
         dAdX(1,i)=dPdX(3,2,i)-dPdX(2,3,i)
         dAdX(2,i)=dPdX(1,3,i)-dPdX(3,1,i)
         dAdX(3,i)=dPdX(2,1,i)-dPdX(1,2,i)
         if (norder.le.1) goto 304
         do j=1,3
          d2AdX2(1,i,j)=d2PdX2(3,2,i,j)-d2PdX2(2,3,i,j)
          d2AdX2(2,i,j)=d2PdX2(1,3,i,j)-d2PdX2(3,1,i,j)
          d2AdX2(3,i,j)=d2PdX2(2,1,i,j)-d2PdX2(1,2,i,j)
          if (norder.le.2) goto 303
          do k=1,3
           d3AdX3(1,i,j,k)=d3PdX3(3,2,i,j,k)-d3PdX3(2,3,i,j,k)
           d3AdX3(2,i,j,k)=d3PdX3(1,3,i,j,k)-d3PdX3(3,1,i,j,k)
           d3AdX3(3,i,j,k)=d3PdX3(2,1,i,j,k)-d3PdX3(1,2,i,j,k)
           if (norder.le.3) goto 302
           do l=1,3
            d4AdX4(1,i,j,k,l)=d4PdX4(3,2,i,j,k,l)-d4PdX4(2,3,i,j,k,l)
            d4AdX4(2,i,j,k,l)=d4PdX4(1,3,i,j,k,l)-d4PdX4(3,1,i,j,k,l)
            d4AdX4(3,i,j,k,l)=d4PdX4(2,1,i,j,k,l)-d4PdX4(1,2,i,j,k,l)
           end do
 302       continue
          end do
 303      continue
         end do
 304     continue
        end do
* Finally, we have obtained derivatives of A w.r.t X.
* So now we can obtain derivatives of the inverse mapping.
* This will require the inverse T of the matrix dAdX:
c     T(1,1)=dAdX(2,2)*dAdX(3,3)-dAdX(3,2)*dAdX(2,3)
c     T(2,1)=dAdX(3,2)*dAdX(1,3)-dAdX(1,2)*dAdX(3,3)
c     T(3,1)=dAdX(1,2)*dAdX(2,3)-dAdX(2,2)*dAdX(1,3)
c     T(1,2)=dAdX(2,3)*dAdX(3,1)-dAdX(3,3)*dAdX(2,1)
c     T(2,2)=dAdX(3,3)*dAdX(1,1)-dAdX(1,3)*dAdX(3,1)
c     T(3,2)=dAdX(1,3)*dAdX(2,1)-dAdX(2,3)*dAdX(1,1)
c     T(1,3)=dAdX(2,1)*dAdX(3,2)-dAdX(3,1)*dAdX(2,2)
c     T(2,3)=dAdX(3,1)*dAdX(1,2)-dAdX(1,1)*dAdX(3,2)
c     T(3,3)=dAdX(1,1)*dAdX(2,2)-dAdX(2,1)*dAdX(1,2)
c     det=dAdX(1,1)*T(1,1)+dAdX(2,1)*T(2,1)+dAdX(3,1)*T(3,1)
c     detInv=1.0D0/det
*  First derivatives dXdA(j,i):
c     do i=1,3
c      do ia=1,3
c       dXdA(ia,i)=DetInv*T(i,ia)
c      end do
c     end do
* Use the Moore-Penrose pseudoinverse instead
      call dgesvd_('A','A',3,3,dAdX,3,sval,umat,3,vmat,3,wTmp,100,i)
      Do i=1,3
        If (Abs(sval(i)).gt.1.0d-12) Then
          call dscal_(3,1.0d0/sval(i),umat(1,i),1)
        Else
          call dcopy_(3,[0.0d0],0,umat(1,i),1)
        End If
      End Do
      Call dgemm_('T','T',3,3,3,1.0d0,vmat,3,umat,3,0.0d0,dXdA,3)
*  Second derivatives d2XdA(ic,j,k)
      if (norder.le.1) goto 401
      do i=1,3
       do k=1,3
        do ia=1,3
         sum=0.0D0
         do ib=1,3
          sum=sum+d2AdX2(i,ia,ib)*dXdA(ib,k)
         end do
         tmp1(ia)=sum
        end do
        do j=1,3
         sum=0.0D0
         do ia=1,3
          sum=sum+tmp1(ia)*dXdA(ia,j)
         end do
         tmp3(i,j,k)=sum
        end do
       end do
      end do
      do ic=1,3
       do j=1,3
        do k=1,3
         sum=0.0D0
         do i=1,3
          sum=sum+dXdA(ic,i)*tmp3(i,j,k)
         end do
         d2XdA2(ic,j,k)=-sum
        end do
       end do
      end do
*  Third derivatives d3XdA3(id,j,k,l)
      if (norder.le.2) goto 401
      do i=1,3
       do l=1,3
        do ia=1,3
         do ib=1,3
          sum=0.0D0
          do ic=1,3
           sum=sum+d3AdX3(i,ia,ib,ic)*dXdA(ic,l)
          end do
          tmp1(ib)=sum
         end do
         do k=1,3
          sum=0.0D0
          do ib=1,3
           sum=sum+tmp1(ib)*dXdA(ib,k)
          end do
          tmp2(ia,k)=sum
         end do
        end do
        do j=1,3
         do k=1,3
          sum=0.0D0
          do ia=1,3
           sum=sum+tmp2(ia,k)*dXdA(ia,j)
          end do
          tmp4(i,j,k,l)=sum
         end do
        end do
       end do
      end do
      do id=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          sum=0.0D0
          do i=1,3
           sum=sum+dXdA(id,i)*tmp4(i,j,k,l)
          end do
          d3XdA3(id,j,k,l)=-sum
         end do
        end do
       end do
      end do
      do i=1,3
       do j=1,3
        do ib=1,3
         sum=0.0D0
         do ia=1,3
          sum=sum+d2AdX2(i,ia,ib)*dXdA(ia,j)
         end do
         tmp1(ib)=sum
        end do
        do k=1,3
         do l=1,3
          sum=0.0D0
          do ib=1,3
           sum=sum+tmp1(ib)*d2XdA2(ib,k,l)
          end do
          tmp4(i,j,k,l)=sum
         end do
        end do
       end do
      end do
      do ic=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          sum=d3XdA3(ic,j,k,l)
          do i=1,3
           sum=sum-DXDA(ic,i)*
     &             (tmp4(i,j,k,l)+tmp4(i,k,l,j)+tmp4(i,l,j,k))
          end do
          d3XdA3(ic,j,k,l)=sum
         end do
        end do
       end do
      end do
*  Fourth derivatives d4XdA4(id,j,k,l,m)
      if (norder.le.3) goto 401
      do i=1,3
       do ia=1,3
        do ib=1,3
         do ic=1,3
          do m=1,3
           sum=0.0d0
           do id=1,3
            sum=sum+d4AdX4(i,ia,ib,ic,id)*dXdA(id,m)
           end do
           tmp2(ic,m)=sum
          end do
         end do
         do m=1,3
          do l=1,3
           sum=0.0d0
           do ic=1,3
            sum=sum+tmp2(ic,m)*dXdA(ic,l)
           end do
           tmp3(ib,l,m)=sum
          end do
         end do
        end do
        do m=1,3
         do l=1,3
          do k=1,3
           sum=0.0d0
           do ib=1,3
            sum=sum+tmp3(ib,l,m)*dXdA(ib,k)
           end do
           tmp4(ia,k,l,m)=sum
          end do
         end do
        end do
       end do
       do m=1,3
        do l=1,3
         do k=1,3
          do j=1,3
           sum=0.0d0
           do ia=1,3
            sum=sum+tmp4(ia,k,l,m)*dXdA(ia,j)
           end do
           tmp5(i,j,k,l,m)=sum
          end do
         end do
        end do
       end do
       do l=1,3
        do m=1,3
         do ia=1,3
          do ib=1,3
           sum=0.0d0
           do ic=1,3
            sum=sum+d3AdX3(i,ia,ib,ic)*d2XdA2(ic,l,m)
           end do
           tmp1(ib)=sum
          end do
          do k=1,3
           sum=0.0d0
           do ib=1,3
            sum=sum+tmp1(ib)*dXdA(ib,k)
           end do
           tmp2(ia,k)=sum
          end do
         end do
         do k=1,3
          do j=1,3
           sum=0.0d0
           do ia=1,3
            sum=sum+tmp2(ia,k)*dXdA(ia,j)
           end do
           tmp5A(i,j,k,l,m)=sum
          end do
         end do
        end do
       end do
       do j=1,3
        do k=1,3
         do l=1,3
          do m=1,3
           tmp5(i,j,k,l,m)=tmp5(i,j,k,l,m)+tmp5A(i,j,k,l,m)+
     &          tmp5A(i,j,l,k,m)+tmp5A(i,k,l,j,m)+tmp5A(i,j,m,k,l)+
     &          tmp5A(i,k,m,j,l)+tmp5A(i,l,m,j,k)
          end do
         end do
        end do
       end do
       do j=1,3
        do ib=1,3
         sum=0.0d0
         do ia=1,3
          sum=sum+d2AdX2(i,ia,ib)*dXdA(ia,j)
         end do
         tmp2(j,ib)=sum
        end do
        do k=1,3
         do l=1,3
          do m=1,3
           sum=0.0d0
           do ib=1,3
            sum=sum+tmp2(j,ib)*d3XdA3(ib,k,l,m)
           end do
           tmp5A(i,j,k,l,m)=sum
          end do
         end do
        end do
       end do
       do j=1,3
        do m=1,3
         do l=1,3
          do k=1,3
       tmp5(i,j,k,l,m)=tmp5(i,j,k,l,m)+tmp5A(i,j,k,l,m)+
     &       tmp5A(i,k,l,m,j)+tmp5A(i,l,m,j,k)+tmp5A(i,m,j,k,l)
          end do
         end do
        end do
       end do
       do j=1,3
        do m=1,3
         do ib=1,3
          sum=0.0D0
          do ia=1,3
           sum=sum+d2AdX2(i,ia,ib)*d2XdA2(ia,j,m)
          end do
          tmp1(ib)=sum
         end do
         do l=1,3
          do k=1,3
           sum=0.0D0
           do ib=1,3
            sum=sum+tmp1(ib)*d2XdA2(ib,k,l)
           end do
           tmp5A(i,j,k,l,m)=sum
          end do
         end do
        end do
       end do
       do m=1,3
        do j=1,3
         do l=1,3
          do k=1,3
           tmp5(i,j,k,l,m)=tmp5(i,j,k,l,m)+tmp5A(i,j,k,l,m)+
     &                  tmp5A(i,j,k,m,l)+tmp5A(i,j,m,l,k)
          end do
         end do
        end do
       end do
      end do
      do id=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          do m=1,3
           sum=0.0D0
           do i=1,3
            sum=sum+dXdA(id,i)*tmp5(i,j,k,l,m)
           end do
           d4XdA4(id,j,k,l,m)=-sum
          end do
         end do
        end do
       end do
      end do
 401  continue
      return
      end
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine mat2vec(RotMat,RotVec,RotAng)
      implicit real*8 (a-h,o-z)
      parameter (Pi=3.14159265358979323846D0)
      dimension RotMat(3,3),RotVec(3)
      trace=RotMat(1,1)+RotMat(2,2)+RotMat(3,3)
      x1=0.5D0*(RotMat(3,2)-RotMat(2,3))
      x2=0.5D0*(RotMat(1,3)-RotMat(3,1))
      x3=0.5D0*(RotMat(2,1)-RotMat(1,2))
      sr=sqrt(x1**2+x2**2+x3**2)
      cr=0.5D0*(trace-1.0d0)
      if(0.05D0*cr.gt.sr) then
        tn=sr/cr
        tn2=tn**2
* cos(theta) is positive, C is theta/sin(theta)
        C=(45045.0D0-tn2*(15015.0D0-tn2*(9009.0D0-tn2*(6435.0D0-
     &   tn2*(5005.0D0-tn2*(4095.0D0-tn2*3465.0D0))))))/(45045.0D0*cr)
        RotVec(1)=x1*C
        RotVec(2)=x2*C
        RotVec(3)=x3*C
        RotAng   =sr*C
      else if(-0.05D0*abs(cr).gt.sr.and.sr.gt.0.0D0) then
        tn=-sr/cr
        tn2=tn**2
* cos(theta) is negative, sin(theta) is positive (always),
* Pimth is (Pi-theta)
        Pimth=tn*(45045.0D0-tn2*(15015.0D0-tn2*(9009.0D0-tn2*(6435.0D0-
     &   tn2*(5005.0D0-tn2*(4095.0D0-tn2*3465.0D0))))))/45045.0D0
        RotAng   =Pi-Pimth
        RotVec(1)=(x1/sr)*RotAng
        RotVec(2)=(x2/sr)*RotAng
        RotVec(3)=(x3/sr)*RotAng
      else if (sr.ne.0.0D0) then
        RotAng=atan2(sr,cr)
        RotVec(1)=RotAng*(x1/sr)
        RotVec(2)=RotAng*(x2/sr)
        RotVec(3)=RotAng*(x3/sr)
      else
        RotVec(1)=0.0D0
        RotVec(2)=0.0D0
        RotVec(3)=0.0D0
        RotAng   =0.0D0
      end if
      return
      end
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine mkRotMat(rotvec,rotmat)
      implicit real*8 (a-h,o-z)
      real*8 RotMat(3,3)
      real*8 RotVec(3)
*
C     Call RecPrt('mkRotMat: RotVec',' ',RotVec,1,3)
*
      Q=RotVec(1)**2+RotVec(2)**2+RotVec(3)**2
      XN=sqrt(Q)
      if (Q.lt.0.01D0) then
        c0=1.d0-(Q/2.d0)
     &    *(1.d0-(Q/12.d0)*(1.d0-(Q/30.d0)*(1.d0-(Q/56.d0))))
        c1=1.d0-(Q/6.d0)
     &    *(1.d0-(Q/20.d0)*(1.d0-(Q/42.d0)*(1.d0-(Q/72.d0))))
        c2=(1.d0-(Q/12.d0)
     &    *(1.d0-(Q/30.d0)*(1.d0-(Q/56.d0)*(1.d0-(Q/90.d0)))))/2.d0
      else
       cs=cos(XN)
       sn=sin(XN)
       c0=cs
       c1=sn/XN
       c2=(1.0D0-cs)/(XN**2)
      end if
      RotMat(1,1)=c0
      RotMat(2,2)=c0
      RotMat(3,3)=c0
      RotMat(3,2)= c1*RotVec(1)
      RotMat(1,3)= c1*RotVec(2)
      RotMat(2,1)= c1*RotVec(3)
      RotMat(2,3)=-c1*RotVec(1)
      RotMat(3,1)=-c1*RotVec(2)
      RotMat(1,2)=-c1*RotVec(3)
      do i=1,3
       do j=1,3
        RotMat(i,j)=RotMat(i,j)+c2*RotVec(i)*RotVec(j)
       end do
      end do
      do i=1,3
       do j=1,3
        sum=0.0d0
        if (i.eq.j) sum=-1.0D0
        do k=1,3
         sum=sum+RotMat(i,k)*RotMat(j,k)
        end do
        if(abs(sum).gt.1.0D-10) then
         Call WarningMessage(2,'Error in RotDer')
         write(6,*)' MKROTMAT: ON check sum error=',sum
         Call Abend()
        end if
       end do
      end do
      return
      end
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine updRotMat(SmallRot,RotMat)
      implicit real*8 (a-h,o-z)
      dimension SmallRot(3),RotMat(3,3)
      dimension tmp(3,3),SmallMat(3,3)
      Call mkRotMat(SmallRot,SmallMat)
      do i=1,3
       do j=1,3
        sum=0.0D0
        do k=1,3
         sum=sum+RotMat(i,k)*SmallMat(k,j)
        end do
        tmp(i,j)=sum
       end do
      end do
      do i=1,3
       do j=1,3
        RotMat(i,j)=tmp(i,j)
       end do
      end do
* Check for orthonormality:
      do i=1,3
       do j=1,3
        sum=0.0d0
        if (i.eq.j) sum=-1.0D0
        do k=1,3
         sum=sum+RotMat(i,k)*RotMat(j,k)
        end do
        if(abs(sum).gt.1.0D-10) then
         write(6,*)' UPDROTMAT ON check sum error:',sum
        end if
       end do
      end do
      return
      end
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine moveit(nmass,currxyz,ref123,trans,rotvec)
      implicit real*8 (a-h,o-z)
      real*8 U(3,3)
      real*8 CurrXYZ(3,nMass)
      real*8 Ref123(3,nMass)
      real*8 RotVec(3)
      real*8 Trans(3)
      Call mkRotMat(RotVec,U)
      do imass=1,nmass
       do i=1,3
        sum=Trans(i)
        do j=1,3
         sum=sum+U(i,j)*Ref123(j,imass)
        end do
        CurrXYZ(i,imass)=sum
       end do
      end do
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LUCIA2MOLCAS(KICONF_OCC_LUCIA,KSDREO_I,NDET_LUCIA,NCSASM_LUCIA,NDTASM_LUCIA,NCNASM_LUCIA,MXPCSM,MXPORB,NCONF_PER_OPEN, &
                        NPDTCNF,NPCSCNF,nCSF_HEXS_LUCIA)
! Transfer arguments to the common blocks used by MOLCAS.

use csfbas, only: CONF, CTS, maxop_lucia, NAEL, NBEL
use splitcas_data, only: iDimBlockA
use general_data, only: ISPIN, NACTEL, NELEC3, NHOLE1, NRS1, NRS2, NSEL, NSYM, STSYM
use spinfo, only: I_ELIMINATE_GAS_MOLCAS, MINOP, MS2, NCNASM, NCNFTP, NCSASM, NCSF_HEXS, NCSFTP, NDET, NDTASM, NDTFTP, NTYP
use Molcas, only: MxSym
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: KICONF_OCC_LUCIA(*), KSDREO_I(*), NDET_LUCIA, MXPCSM, NCSASM_LUCIA(MXPCSM), NDTASM_LUCIA(MXPCSM), &
                                 NCNASM_LUCIA(MXPCSM), MXPORB, NCONF_PER_OPEN(MXPORB+1,MXPCSM), NPDTCNF(MXPORB+1), &
                                 NPCSCNF(MXPORB+1), nCSF_HEXS_LUCIA
integer(kind=iwp) :: ICL, IOPEN, ISYM, ITYP, LCONF, LDET, LLCONF, NEL2MN, NEL2MX, NORB1, NORB2

NDTASM(1:MxSym) = NDTASM_LUCIA(1:MxSym)
NCSASM(1:MxSym) = NCSASM_LUCIA(1:MxSym)
NCNASM(1:MxSym) = NCNASM_LUCIA(1:MxSym)
if (NSEL > NCSASM(STSYM)) NSEL = NCSASM(STSYM)
! For small calculations - Lasse/MGD
nCSF_HEXS = nCSF_HEXS_LUCIA
if ((I_ELIMINATE_GAS_MOLCAS > 0) .and. (NSEL > nCSF_HEXS)) NSEL = nCSF_HEXS

if (iDimBlockA > NCSASM(STSYM)) then
  write(u6,*) ''
  write(u6,*) '******************** WARNING *********************'
  write(u6,*) ' AA-Block dimension selected is bigger than the'
  write(u6,*) ' number  of CSFs reachable  within the selected'
  write(u6,*) ' Active Space. The code automatically  reset it'
  write(u6,*) ' to the number  of  CSFs. You  are  allowed  to'
  write(u6,*) ' decrease  this  number  in  your input and run'
  write(u6,*) ' again the calculation.'
  write(u6,'(1X,A,I5)') ' AA-Block dimension selected:',iDimBlockA
  iDimBlockA = NCSASM(STSYM)
  write(u6,'(1X,A,I5)') ' AA-Block dimension reset:',iDimBlockA
  write(u6,*) '**************************************************'
  write(u6,*) ''
end if

! SET INITIAL VALUES FOR LOOP COUNTERS AND ARRAY SIZES

! TOTAL NO. ORBITALS
MS2 = iSpin-1
NORB1 = sum(NRS1(1:NSYM))
NORB2 = sum(NRS2(1:NSYM))
! MIN. AND MAX. NO. OF EL IN RAS2
NEL2MX = NACTEL-2*NORB1+NHOLE1
NEL2MN = NACTEL-2*NORB1-NELEC3
NEL2MX = min(NEL2MX,2*NORB2)
if (NEL2MN < 0) NEL2MN = 0
! TOTAL NO. OF ALPHA AND BETA EL.
NAEL = (MS2+NACTEL)/2
NBEL = (NACTEL-MS2)/2
! MIN. AND MAX. NO. OF PROTOTYPE CSFS (= MIN. AND. MAX. OPEN ORBS.)
MINOP = abs(MS2)

NTYP = maxop_lucia-MINOP+1
NCNFTP(1:NTYP,1:MxSym) = NCONF_PER_OPEN(MINOP+1:maxop_lucia+1,1:MxSym)
NDTFTP(1:NTYP) = NPDTCNF(MINOP+1:maxop_lucia+1)
NCSFTP(1:NTYP) = NPCSCNF(MINOP+1:maxop_lucia+1)

! Memory needed to store ICONF array
LCONF = 0
LDET = 0
do ISYM=1,NSYM
  LLCONF = 0
  do ITYP=1,NTYP
    IOPEN = ITYP+MINOP-1
    ICL = (NACTEL-IOPEN)/2
    LLCONF = LLCONF+NCNFTP(ITYP,ISYM)*(IOPEN+ICL)
  end do
  LCONF = max(LCONF,LLCONF)
  LDET = max(LDET,NDTASM(ISYM))
end do

call mma_allocate(CONF,LCONF,label='CONF')
call mma_allocate(CTS,LDET,label='CTS')

CONF(:) = KICONF_OCC_LUCIA(1:LCONF)

CTS(:) = KSDREO_I(1:LDET)

NDET = NDET_LUCIA

end subroutine LUCIA2MOLCAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Giovanni Li Manni                                      *
************************************************************************
      Real*8 Function Comp_d(Weights,mGrid,Rho,nRho,iSpin,T_X,iSwitch)
************************************************************************
*                                                                      *
* Object: integrate densities (alpha, beta, total, gradients....)      *
*         the object integrated is dictaded by iSwitch value:          *
*         iSwitch = 0  .... total density                              *
*         iSwitch = 1  .... alpha density                              *
*         iSwitch = 2  .... beta density                               *
*                                                                      *
* Author: G. Li Manni... taking Sir R. Lindh as model                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Weights(mGrid), Rho(nRho,mGrid)
*
      Comp_d=Zero
      Rho_min=T_X*1.0D-2
************************************************************************
*     iSpin=1
************************************************************************
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
           d_alpha=Rho(1,iGrid)
           if(iSwitch.eq.1) then
             DTot=d_alpha
           else if(iSwitch.eq.2) then
             DTot=d_alpha
           else !if(iSwitch.eq.0) then
             DTot=Two*d_alpha
           end if
           If (DTot.lt.T_X) Go To 199
           Comp_d = Comp_d + DTot*Weights(iGrid)
 199       Continue
         End Do
************************************************************************
*     iSpin=/=1
************************************************************************
      Else
        Do iGrid = 1, mGrid
          d_alpha=Max(Rho_min,Rho(1,iGrid))
          d_beta =Max(Rho_min,Rho(2,iGrid))
          if(iSwitch.eq.1) then
            DTot=d_alpha
          else if(iSwitch.eq.2) then
            DTot=d_beta
          else !if(iSwitch.eq.0) then
            DTot=d_alpha+d_beta
          end if
          If (DTot.lt.T_X) Go To 299
          Comp_d = Comp_d + DTot*Weights(iGrid)
 299      Continue
        End Do
      End If
************************************************************************
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine chop7_cvb()

use casvb_global, only: cvbdet, cvbsspn, cvbstot, cvbtry, dvbdet, evbdet, gjorb, gjorb2, gjorb3, icase7, ndetvb, norb, nvb, &
                        orbinv, orbstry, owrk2, release, sorbs, vbdet
use stdalloc, only: mma_allocate, mma_deallocate

implicit none

if (release(7)) then
  call mma_deallocate(orbinv,safe='*')
  call mma_deallocate(sorbs,safe='*')
  call mma_deallocate(owrk2,safe='*')
  call mma_deallocate(gjorb%r,safe='*')
  call mma_deallocate(gjorb%i1,safe='*')
  call mma_deallocate(gjorb%i2,safe='*')
  call mma_deallocate(gjorb2%r,safe='*')
  call mma_deallocate(gjorb2%i1,safe='*')
  call mma_deallocate(gjorb2%i2,safe='*')
  call mma_deallocate(gjorb3%r,safe='*')
  call mma_deallocate(gjorb3%i1,safe='*')
  call mma_deallocate(gjorb3%i2,safe='*')
  call mma_deallocate(cvbstot,safe='*')
  call mma_deallocate(cvbsspn,safe='*')
  call mma_deallocate(cvbdet,safe='*')
  call mma_deallocate(dvbdet,safe='*')
  call mma_deallocate(evbdet,safe='*')
  call mma_deallocate(orbstry)
  call mma_deallocate(cvbtry)
  call mma_deallocate(vbdet)
end if
release(7) = .true.
release(8) = .false.

if ((icase7 == 1) .or. (icase7 == 2) .or. (icase7 == 3)) then
  !FIXME: These deallocations should not be necessary
  call mma_deallocate(orbinv,safe='*')
  call mma_deallocate(sorbs,safe='*')
  call mma_deallocate(owrk2,safe='*')
  call mma_deallocate(gjorb%r,safe='*')
  call mma_deallocate(gjorb%i1,safe='*')
  call mma_deallocate(gjorb%i2,safe='*')
  call mma_deallocate(gjorb2%r,safe='*')
  call mma_deallocate(gjorb2%i1,safe='*')
  call mma_deallocate(gjorb2%i2,safe='*')
  call mma_deallocate(gjorb3%r,safe='*')
  call mma_deallocate(gjorb3%i1,safe='*')
  call mma_deallocate(gjorb3%i2,safe='*')
  call mma_deallocate(cvbstot,safe='*')
  call mma_deallocate(cvbsspn,safe='*')
  call mma_deallocate(cvbdet,safe='*')
  call mma_deallocate(dvbdet,safe='*')
  call mma_deallocate(evbdet,safe='*')
  call mma_allocate(orbinv,norb,norb,label='orbinv')
  call mma_allocate(sorbs,norb,norb,label='sorbs')
  call mma_allocate(owrk2,norb,norb,label='owrk2')
  call mma_allocate(gjorb%r,norb,norb,label='gjorb%r')
  call mma_allocate(gjorb%i1,norb,label='gjorb%i1')
  call mma_allocate(gjorb%i2,2,norb*norb,label='gjorb%i2')
  call mma_allocate(gjorb2%r,norb,norb,label='gjorb2%r')
  call mma_allocate(gjorb2%i1,norb,label='gjorb2%i1')
  call mma_allocate(gjorb2%i2,2,norb*norb,label='gjorb2%i2')
  call mma_allocate(gjorb3%r,norb,norb,label='gjorb3%r')
  call mma_allocate(gjorb3%i1,norb,label='gjorb3%i1')
  call mma_allocate(gjorb3%i2,2,norb*norb,label='gjorb3%i2')
  call mma_allocate(cvbstot,nvb,label='cvbstot')
  call mma_allocate(cvbsspn,nvb,label='cvbsspn')
  call mma_allocate(cvbdet,ndetvb,label='cvbdet')
  call mma_allocate(dvbdet,ndetvb,label='dvbdet')
  call mma_allocate(evbdet,ndetvb,label='evbdet')
end if

!FIXME: These deallocations should not be necessary
call mma_deallocate(orbstry,safe='*')
call mma_deallocate(cvbtry,safe='*')
call mma_deallocate(vbdet,safe='*')
call mma_allocate(orbstry,norb,norb,label='orbstry')
call mma_allocate(cvbtry,ndetvb,label='cvbtry')
call mma_allocate(vbdet,ndetvb,label='vbdet')

return

end subroutine chop7_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRWF(SGS,CIS,ISYCI,CI,CITHR)

use sguga, only: CIStruct, SGStruct
use Symmetry_Info, only: MUL, nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(in) :: CIS
integer(kind=iwp), intent(in) :: ISYCI
real(kind=wp), intent(in) :: CI(*), CITHR
integer(kind=iwp) :: IC1, ICDPOS, ICDWN, ICONF, ICUP, ICUPOS, IDW0, IDWN, IDWNSV, ISY, ISYDWN, ISYUP, IUP, IUW0, K, KNXT, KOCLAB, &
                     KOCSZ, KPAD1, KPAD2, LEV, MV, NCI, NDWN, NNN, NUP
real(kind=wp) :: COEF
character(len=80) :: LINE
integer(kind=iwp), allocatable :: ICS(:)
logical(kind=iwp), parameter :: SGINFO = .true.
character, parameter :: CODE(0:3) = ['0','u','d','2']

! -- NOTE: THIS PRWF ROUTINE USES THE CONVENTION THAT CI BLOCKS
! -- ARE MATRICES CI(I,J), WHERE THE   F I R S T   INDEX I REFERS TO
! -- THE   U P P E R   PART OF THE WALK.
! -- THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
!    WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.

call mma_allocate(ICS,SGS%nLev,Label='ICS')

! Size of occup/spin coupling part of line:
write(u6,*) ' Occupation of active orbitals, and spin coupling'
write(u6,*) ' of open shells. (u,d: Spin up or down).'
LINE = ''
K = 0
ISY = 0
do LEV=1,SGS%nLev
  if (ISY /= SGS%ISM(LEV)) then
    ISY = SGS%ISM(LEV)
    K = K+1
  end if
  K = K+1
end do
KOCLAB = 10
KOCSZ = max(K,KOCLAB)
KPAD1 = (KOCSZ-KOCLAB)/2
KPAD2 = (KOCSZ-K)/2
if (SGINFO) write(u6,*) ' SGUGA info is (Midvert:IsyUp:UpperWalk/LowerWalk)'
LINE(1:7) = '  Conf '
K = 7
if (SGINFO) then
  LINE(8:22) = '  SGUGA info   '
  K = 22
end if
LINE(K+KPAD1:K+KPAD1+9) = 'Occupation'
K = K+KOCSZ
LINE(K:K+23) = '       Coef       Weight'
write(u6,*) LINE
LINE = ''

! -- THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
!    WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.
do MV=1,CIS%nMidV
  do ISYUP=1,nIrrep
    NCI = CIS%NOCSF(ISYUP,MV,ISYCI)
    if (NCI == 0) cycle
    NUP = CIS%NOW(1,ISYUP,MV)
    ISYDWN = MUL(ISYUP,ISYCI)
    NDWN = CIS%NOW(2,ISYDWN,MV)
    ICONF = CIS%IOCSF(ISYUP,MV,ISYCI)
    IUW0 = 1-CIS%nIpWlk+CIS%IOW(1,ISYUP,MV)
    IDW0 = 1-CIS%nIpWlk+CIS%IOW(2,ISYDWN,MV)
    IDWNSV = 0
    do IDWN=1,NDWN
      do IUP=1,NUP
        ICONF = ICONF+1
        COEF = CI(ICONF)
        ! -- SKIP OR PRINT IT OUT?
        if (abs(COEF) < CITHR) cycle
        if (IDWNSV /= IDWN) then
          ICDPOS = IDW0+IDWN*CIS%nIpWlk
          ICDWN = CIS%ICase(ICDPOS)
          ! -- UNPACK LOWER WALK.
          NNN = 0
          do LEV=1,SGS%MidLev
            NNN = NNN+1
            if (NNN == 16) then
              NNN = 1
              ICDPOS = ICDPOS+1
              ICDWN = CIS%ICase(ICDPOS)
            end if
            IC1 = ICDWN/4
            ICS(LEV) = ICDWN-4*IC1
            ICDWN = IC1
          end do
          IDWNSV = IDWN
        end if
        ICUPOS = IUW0+CIS%nIpWlk*IUP
        ICUP = CIS%ICase(ICUPOS)
        ! -- UNPACK UPPER WALK:
        NNN = 0
        do LEV=SGS%MidLev+1,SGS%nLev
          NNN = NNN+1
          if (NNN == 16) then
            NNN = 1
            ICUPOS = ICUPOS+1
            ICUP = CIS%ICase(ICUPOS)
          end if
          IC1 = ICUP/4
          ICS(LEV) = ICUP-4*IC1
          ICUP = IC1
        end do
        ! -- PRINT IT!
        write(LINE(1:7),'(I6,1X)') ICONF
        K = 7
        if (SGINFO) then
          LINE(K+1:K+1) = '('
          write(LINE(K+2:K+3),'(I2)') MV
          LINE(K+4:K+4) = ':'
          write(LINE(K+5:K+5),'(I1)') ISYUP
          LINE(K+6:K+6) = ':'
          write(LINE(K+7:K+9),'(I3)') IUP
          LINE(K+10:K+10) = '/'
          write(LINE(K+11:K+13),'(I3)') IDWN
          LINE(K+14:K+14) = ')'
          K = K+14
        end if
        KNXT = K+KOCSZ
        K = K+KPAD2
        ISY = 0
        do LEV=1,SGS%nLev
          if (ISY /= SGS%ISM(LEV)) then
            ISY = SGS%ISM(LEV)
            K = K+1
            LINE(K:K) = ' '
          end if
          K = K+1
          LINE(K:K) = CODE(ICS(LEV))
        end do
        K = KNXT
        K = K+1
        LINE(K:K+4) = '     '
        K = K+5
        write(LINE(K:K+7),'(F8.5)') COEF
        K = K+8
        LINE(K:K+4) = '     '
        K = K+5
        write(LINE(K:K+7),'(F8.5)') COEF**2
        write(u6,*) LINE(1:K+7)
      end do
    end do
  end do
end do
write(u6,*)
write(u6,*) repeat('*',80)

call mma_deallocate(ICS)

end subroutine PRWF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine vRysRW(la,lb,lc,ld,Arg,Root,Weight,nArg,nRys)
************************************************************************
*                                                                      *
*  Object: to compute the roots and weights of the Rys polynomials.    *
*          This is done with two approximations. For low arguments     *
*          we will use a 6'th order polynomial and for high arguments  *
*          we will use the asymptotic formulas which are based on the  *
*          roots and weight of Hermite polynomials.                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             September '90                                            *
************************************************************************
      use vRys_RW
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "FMM.fh"
      Real*8 Arg(nArg), Root(nRys,nArg), Weight(nRys,nArg), Tmax_
*
      iRout = 78
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Call RecPrt('In vRysRW:Arg',' ',Arg,nArg,1)
#endif
      labcd=1
*
      If (nRys.gt.nMxRys) Then
          Call WarningMessage(2,
     &            'vRysrw: nRys in vRysRW is larger than nMxRys!')
          Write (6,*) ' nRys  =',nRys
          Write (6,*) ' nMxRys=',nMxRys
          Call Abend()
      End If
*
*  For the FMM we use the asymptotic limit to compute the
*  multipole-component of the integrals
*
      TMax_=TMax(nRys)
      If (asymptotic_Rys) TMax_=1.0D99
*
      If (nRys.eq.1) Then
      labcd=la+lb+lc+ld
      If (labcd.eq.0) Then
         Call Rys01(Arg,nArg,Weight,Map(iMap(1)),nMap(1),
     &              x0(ix0(1)),nx0(1),Cff(iCffW(6,1)),
     &              Cff(iCffW(5,1)),Cff(iCffW(4,1)),Cff(iCffW(3,1)),
     &              Cff(iCffW(2,1)),
     &              Cff(iCffW(1,1)),Cff(iCffW(0,1)),ddx(nRys),
     &              HerW2(iHerW2(1)),TMax_)
      Else
         Call Rys11(Arg,nArg,Root,Weight,
     &              Map(iMap(1)),nMap(1),
     &              x0(ix0(1)),nx0(1),Cff(iCffR(6,1)),
     &              Cff(iCffR(5,1)),Cff(iCffR(4,1)),Cff(iCffR(3,1)),
     &              Cff(iCffR(2,1)),Cff(iCffR(1,1)),Cff(iCffR(0,1)),
     &              Cff(iCffW(6,1)),Cff(iCffW(5,1)),Cff(iCffW(4,1)),
     &              Cff(iCffW(3,1)),Cff(iCffW(2,1)),Cff(iCffW(1,1)),
     &              Cff(iCffW(0,1)),ddx(nRys),
     &              HerW2(iHerW2(1)),HerR2(iHerR2(1)),TMax_)
      End If
*
      Else If (nRys.eq.2) Then
      Call Rys22(Arg,nArg,Root,Weight,
     &           Map(iMap(2)),nMap(2),
     &           x0(ix0(2)),nx0(2),Cff(iCffR(6,2)),
     &           Cff(iCffR(5,2)),Cff(iCffR(4,2)),Cff(iCffR(3,2)),
     &           Cff(iCffR(2,2)),Cff(iCffR(1,2)),Cff(iCffR(0,2)),
     &           Cff(iCffW(6,2)),Cff(iCffW(5,2)),Cff(iCffW(4,2)),
     &           Cff(iCffW(3,2)),Cff(iCffW(2,2)),Cff(iCffW(1,2)),
     &           Cff(iCffW(0,2)),ddx(nRys),
     &           HerW2(iHerW2(2)),HerR2(iHerR2(2)),TMax_)
*
      Else If (nRys.eq.3) Then
      Call Rys33(Arg,nArg,Root,Weight,
     &           Map(iMap(3)),nMap(3),
     &           x0(ix0(3)),nx0(3),Cff(iCffR(6,3)),
     &           Cff(iCffR(5,3)),Cff(iCffR(4,3)),Cff(iCffR(3,3)),
     &           Cff(iCffR(2,3)),Cff(iCffR(1,3)),Cff(iCffR(0,3)),
     &           Cff(iCffW(6,3)),Cff(iCffW(5,3)),Cff(iCffW(4,3)),
     &           Cff(iCffW(3,3)),Cff(iCffW(2,3)),Cff(iCffW(1,3)),
     &           Cff(iCffW(0,3)),ddx(nRys),
     &           HerW2(iHerW2(3)),HerR2(iHerR2(3)),TMax_)
*
      Else If (nRys.eq.4) Then
      Call Rys44(Arg,nArg,Root,Weight,
     &           Map(iMap(4)),nMap(4),
     &           x0(ix0(4)),nx0(4),Cff(iCffR(6,4)),
     &           Cff(iCffR(5,4)),Cff(iCffR(4,4)),Cff(iCffR(3,4)),
     &           Cff(iCffR(2,4)),Cff(iCffR(1,4)),Cff(iCffR(0,4)),
     &           Cff(iCffW(6,4)),Cff(iCffW(5,4)),Cff(iCffW(4,4)),
     &           Cff(iCffW(3,4)),Cff(iCffW(2,4)),Cff(iCffW(1,4)),
     &           Cff(iCffW(0,4)),ddx(nRys),
     &           HerW2(iHerW2(4)),HerR2(iHerR2(4)),TMax_)
*
      Else If (nRys.eq.5) Then
      Call Rys55(Arg,nArg,Root,Weight,
     &           Map(iMap(5)),nMap(5),
     &           x0(ix0(5)),nx0(5),Cff(iCffR(6,5)),
     &           Cff(iCffR(5,5)),Cff(iCffR(4,5)),Cff(iCffR(3,5)),
     &           Cff(iCffR(2,5)),Cff(iCffR(1,5)),Cff(iCffR(0,5)),
     &           Cff(iCffW(6,5)),Cff(iCffW(5,5)),Cff(iCffW(4,5)),
     &           Cff(iCffW(3,5)),Cff(iCffW(2,5)),Cff(iCffW(1,5)),
     &           Cff(iCffW(0,5)),ddx(nRys),
     &           HerW2(iHerW2(5)),HerR2(iHerR2(5)),TMax_)
*
      Else If (nRys.eq.6) Then
      Call Rys66(Arg,nArg,Root,Weight,
     &           Map(iMap(6)),nMap(6),
     &           x0(ix0(6)),nx0(6),Cff(iCffR(6,6)),
     &           Cff(iCffR(5,6)),Cff(iCffR(4,6)),Cff(iCffR(3,6)),
     &           Cff(iCffR(2,6)),Cff(iCffR(1,6)),Cff(iCffR(0,6)),
     &           Cff(iCffW(6,6)),Cff(iCffW(5,6)),Cff(iCffW(4,6)),
     &           Cff(iCffW(3,6)),Cff(iCffW(2,6)),Cff(iCffW(1,6)),
     &           Cff(iCffW(0,6)),ddx(nRys),
     &           HerW2(iHerW2(6)),HerR2(iHerR2(6)),TMax_)
*
      Else If (nRys.eq.7) Then
      Call Rys77(Arg,nArg,Root,Weight,
     &           Map(iMap(7)),nMap(7),
     &           x0(ix0(7)),nx0(7),Cff(iCffR(6,7)),
     &           Cff(iCffR(5,7)),Cff(iCffR(4,7)),Cff(iCffR(3,7)),
     &           Cff(iCffR(2,7)),Cff(iCffR(1,7)),Cff(iCffR(0,7)),
     &           Cff(iCffW(6,7)),Cff(iCffW(5,7)),Cff(iCffW(4,7)),
     &           Cff(iCffW(3,7)),Cff(iCffW(2,7)),Cff(iCffW(1,7)),
     &           Cff(iCffW(0,7)),ddx(nRys),
     &           HerW2(iHerW2(7)),HerR2(iHerR2(7)),TMax_)
*
      Else If (nRys.eq.8) Then
      Call Rys88(Arg,nArg,Root,Weight,
     &           Map(iMap(8)),nMap(8),
     &           x0(ix0(8)),nx0(8),Cff(iCffR(6,8)),
     &           Cff(iCffR(5,8)),Cff(iCffR(4,8)),Cff(iCffR(3,8)),
     &           Cff(iCffR(2,8)),Cff(iCffR(1,8)),Cff(iCffR(0,8)),
     &           Cff(iCffW(6,8)),Cff(iCffW(5,8)),Cff(iCffW(4,8)),
     &           Cff(iCffW(3,8)),Cff(iCffW(2,8)),Cff(iCffW(1,8)),
     &           Cff(iCffW(0,8)),ddx(nRys),
     &           HerW2(iHerW2(8)),HerR2(iHerR2(8)),TMax_)
*
      Else If (nRys.eq.9) Then
      Call Rys99(Arg,nArg,Root,Weight,
     &           Map(iMap(9)),nMap(9),
     &           x0(ix0(9)),nx0(9),Cff(iCffR(6,9)),
     &           Cff(iCffR(5,9)),Cff(iCffR(4,9)),Cff(iCffR(3,9)),
     &           Cff(iCffR(2,9)),Cff(iCffR(1,9)),Cff(iCffR(0,9)),
     &           Cff(iCffW(6,9)),Cff(iCffW(5,9)),Cff(iCffW(4,9)),
     &           Cff(iCffW(3,9)),Cff(iCffW(2,9)),Cff(iCffW(1,9)),
     &           Cff(iCffW(0,9)),ddx(nRys),
     &           HerW2(iHerW2(9)),HerR2(iHerR2(9)),TMax_)
*
      Else
      Call WarningMessage(2,
     &            ' vRysRW: nRys in vRysRW is larger than MaxRys!')
      Call Abend()
*
      End If
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         If (labcd.ne.0)
     &      Call Recprt(' In vRysRW: Roots ',' ',Root  ,nRys,nArg)
         Call Recprt(' In vRysRW: Weight',' ',Weight,nRys,nArg)
      End If
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA_Warn(Level,Message)

! Thomas Bondo Pedersen (CTCC,UiO), July 2013.
!
! Level <= 1 --- issue warning with message Message and return.
! Level >= 2 --- issue warning with message Message and quit.
!                Error codes used in xQuit:
!                Level=2: _RC_INPUT_ERROR_
!                Level=3: _RC_INTERNAL_ERROR_
!                Level>3: _RC_GENERAL_ERROR_

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Level
character(len=*), intent(in) :: Message
#include "warnings.h"
integer(kind=iwp) :: iLevel, rc

if (Level <= 1) then
  iLevel = max(Level,0)
  rc = 0
else
  iLevel = 2
  if (Level == 2) then
    rc = _RC_INPUT_ERROR_
  else if (Level == 3) then
    rc = _RC_INTERNAL_ERROR_
  else
    rc = _RC_GENERAL_ERROR_
  end if
end if
call WarningMessage(iLevel,Message)
call xFlush(u6)
if (rc /= 0) then
  call xQuit(rc)
end if

end subroutine RPA_Warn

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Markus P. Fuelscher                              *
!               2012, Giovanni Li Manni                                *
!***********************************************************************

subroutine Sort_Cdet(N,Idx,X)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Sort CI-coefficients in determinant basis and change phase       *
!                                                                      *
!     calling arguments:                                               *
!     N       : integer                                                *
!               dimension of the CI-vector                             *
!     Idx     : integer                                                *
!               reordering indices                                     *
!     X       : real*8                                                 *
!               CI-vector                                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     G. Li Manni on 03 Feb 2012 on a desperate situation for saving   *
!     time!                                                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1999                                 *
!                                                                      *
! It was a great piece of code for those times when memory was a very  *
! big issue! Nowadays only time is important!                          *
!***********************************************************************
!do i=1,N                                                              *
!  i_old = i                                                           *
!  i_new = abs(Idx(i_old))                                             *
!  do while (i_new > i)                                                *
!    i_old = i_new                                                     *
!    i_new = abs(Idx(i_old))                                           *
!  end do                                                              *
!  if (i_new == i) then                                                *
!    i_old = i                                                         *
!    X_old = X(i_old)                                                  *
!    i_new = abs(Idx(i_old))                                           *
!    X_new = X(i_new)                                                  *
!    alpha = real(sign(1,Idx(i_old)),kind=wp)                          *
!    do while (i_new > i)                                              *
!      X(i_new) = alpha*X_old                                          *
!      i_old = i_new                                                   *
!      X_old = X_new                                                   *
!      i_new = abs(Idx(i_old))                                         *
!      X_new = X(i_new)                                                *
!      alpha = real(sign(1,Idx(i_old)),kind=wp)                        *
!    end do                                                            *
!    X(i) = alpha*X_old                                                *
!  end if                                                              *
!end do                                                                *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, Idx(N)
real(kind=wp), intent(inout) :: X(N)
integer(kind=iwp) :: i, i_new
real(kind=wp) :: alpha
real(kind=wp), allocatable :: ReoSDs(:)

call mma_allocate(ReoSDs,N,label='ReordSDs')
do i=1,N
  i_new = abs(Idx(i))
  alpha = real(sign(1,Idx(i)),kind=wp)
  ReoSDs(i_new) = alpha*X(i)
end do
X(:) = ReoSDs(:)
call mma_deallocate(ReoSDs)

return

end subroutine Sort_Cdet

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine InsReaW3(aSGrp,beSGrp,bSGrp,length)
! this routine does:
! Check which W3 file corresponds to given combination of indices,
! - increase the parameter, checking the overall number of
!   required integrals if these block is conted first time
! - and set corresponding InqW3 to T

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimSGrpa, DimSGrpbe, InqW3, no
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: aSGrp, beSGrp, bSGrp
integer(kind=iwp), intent(inout) :: length
integer(kind=iwp) :: abeSGrp, dima, dimb, dimbe

!0 def dimensions

dima = DimSGrpa(aSGrp)
dimb = DimSGrpa(bSGrp)
dimbe = DimSGrpbe(beSGrp)

if (aSGrp > beSGrp) then
  !1 case aSGrp>beSGrp, integrals (a",be"|b",i) to be read
  abeSGrp = nTri_Elem(aSGrp-1)+beSGrp
  if (.not. InqW3(abeSGrp,bSGrp)) then
    InqW3(abeSGrp,bSGrp) = .true.
    length = length+dima*dimbe*dimb*no
  end if

else if (aSGrp == beSGrp) then
  !2 case aSGrp=beSGrp, integrals (a">=be"|b",i)to be read and expand
  abeSGrp = nTri_Elem(aSGrp-1)+beSGrp
  if (.not. InqW3(abeSGrp,bSGrp)) then
    InqW3(abeSGrp,bSGrp) = .true.
    length = length+no*nTri_Elem(dima)*dimb
  end if

else
  !3 case aSGrp<beSGrp, integrals (be",a"|b",i) to be read and mapped
  abeSGrp = nTri_Elem(beSGrp-1)+aSGrp
  if (.not. InqW3(abeSGrp,bSGrp)) then
    InqW3(abeSGrp,bSGrp) = .true.
    length = length+dima*dimbe*dimb*no
  end if
end if

return

end subroutine InsReaW3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine EdmistonRuedenberg(Functional,CMO,Thrs,ThrRot,ThrGrad,
     &                              nBas,nOrb2Loc,nFro,
     &                              nSym,nMxIter,
     &                              Maximisation,Converged,Debug,Silent)
C
C     Author: T.B. Pedersen
C
C     Purpose: Edmiston-Ruedenberg localisation of occupied orbitals.
C
      Implicit Real*8 (a-h,o-z)
      Real*8  CMO(*)
      Integer nBas(nSym), nOrb2Loc(nSym), nFro(nSym)
      Logical Maximisation, Converged, Debug, Silent
#include "WrkSpc.fh"

      Character*18 SecNam
      Parameter (SecNam = 'EdmistonRuedenberg')

      Character*80 Txt

C     Symmetry is NOT allowed.
C     ------------------------

      If (nSym .ne. 1) Then
         Call SysAbendMsg(SecNam,'Symmetry not implemented!','Sorry!')
      End If

C     Initializations.
C     ----------------

      Functional = -9.9D9

      nBasT     = nBas(1)
      nOrb2LocT = nOrb2Loc(1)
      nFroT     = nFro(1)

      Converged = .False.

      irc = -1
      FracMem = 0.3d0 ! 30 percent of memory used as vector buffer
      Call Cho_X_Init(irc,FracMem)
      If (irc .ne. 0) Then
         Write(Txt,'(A,I6)') 'Cho_X_Init returned',irc
         Call SysAbendMsg(SecNam,'Cholesky initialization error:',Txt)
      End If

C     Localise orbitals.
C     ------------------

      kOffC = nBasT*nFroT + 1
      Call EdmistonRuedenberg_Iter(Functional,CMO(kOffC),Thrs,ThrRot,
     &                             ThrGrad,
     &                             nBasT,nOrb2LocT,nMxIter,
     &                             Maximisation,Converged,Debug,
     &                             Silent)

C     Finalizations.
C     --------------

      irc = -1
      Call Cho_X_Final(irc)
      If (irc .ne. 0) Then
         Write(Txt,'(A,I6)') 'Cho_X_Final returned',irc
         Call SysAbendMsg(SecNam,'Cholesky finalization error:',Txt)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_SetAddr_2(InfRed,InfVec,MaxRed,MaxVec,N2,nSym,irc)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: MaxRed, MaxVec, N2, nSym
integer(kind=iwp), intent(inout) :: InfRed(MaxRed), InfVec(MaxVec,N2,nSym)
integer(kind=iwp), intent(out) :: irc

irc = 0

if (MaxRed > 0) then
  InfRed(1) = 0
else
  irc = 1
  return
end if

if ((MaxVec > 0) .and. (N2 >= 4)) then
  InfVec(1,3:4,1:nSym) = 0
else
  irc = 2
  return
end if

end subroutine Cho_P_SetAddr_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine reprt2_cvb(orbs,cvb,
     >  civec,civb,civbs,civbh,citmp,
     >  sstruc,sstruc2,
     >  orbinv,sorbs,owrk,gjorb,gjorb2,gjorb3,
     >  cvbstot,cvbsspn,cvbdet,dvbdet,evbdet,
     >  dmat,occ)
      implicit real*8 (a-h,o-z)
      logical make_sstruc
c ... Files/Hamiltonian available ...
      logical, external :: valid_cvb,ifcasci_cvb,ifhamil_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "formats_cvb.fh"
      dimension orbs(norb,norb),cvb(nvb)
      dimension civec(ndet),civb(ndet)
      dimension civbs(ndet),civbh(ndet),citmp(ndet)
      dimension sstruc(nvb,nvb),sstruc2(nvb,nvb)
      dimension orbinv(norb,norb),sorbs(norb,norb),owrk(norb,norb)
      dimension gjorb(*),gjorb2(*),gjorb3(*)
      dimension cvbstot(nvb),cvbsspn(nvb)
      dimension cvbdet(ndetvb),dvbdet(ndetvb),evbdet(ndetvb)
      dimension dmat(norb,norb),occ(norb)

      if(ip(5).ge.1)then
        call report_cvb(orbs,norb)
        write(6,'(/,a)')' Structure coefficients :'
        write(6,'(a)')' ------------------------'
        call vecprint_cvb(cvb,nvb)
      endif

c First save CI vector
      call str2vbc_cvb(cvb,cvbdet)
      call vb2cic_cvb(cvbdet,civb)
      call gaussj_cvb(orbs,gjorb)
      call applyt_cvb(civb,gjorb)
      call proj_cvb(civb)
      call cinorm2_cvb(civb,cnrm)
      call ciscale_cvb(civb,one/cnrm)
      call symweight_cvb(civb,civb,wsym)

c Save VB wavefunction
      call setsavvb_cvb(savvb)
      if(valid_cvb(savvb))then
        if(ip(5).ge.1)then
          write(6,'(a)')' '
          call prtfid_cvb(' Saving VB wavefunction to ',savvb)
        endif
        call putguess_cvb(orbs,cvb,savvb)
      endif
      call putci_cvb(civb)
      call fzero(dmat,norb*norb)
      call onedens_cvb(civb,civb,dmat,.true.,0)
c  Before overwriting CIVB/CIVEC get SVB :
      if(lcalcsvb)then
        call cidot_cvb(civec,civb,svb)
        call untouch_cvb('SVB')
      endif
      if(lcalcevb)then
        call cicopy_cvb(civb,civbh)
        call applyh_cvb(civbh)
        call cidot_cvb(civb,civbh,evb)
        evb=evb+corenrg
        call untouch_cvb('EVB')
c  ESYM needed for variational calculation
        call symweight_cvb(civb,civbh,esym)
        do 100 i=1,nirrep
        if(wsym(i).gt.1d-10)then
          esym(i)=esym(i)/wsym(i)+corenrg
        else
          esym(i)=zero
        endif
100     continue
      endif
      if(lcalcsvb.and.ip(5).ge.1)then
        write(6,'(a)')' '
        write(6,formE)' Svb :      ',svb
        if((lcalcevb.and.ip(5).ge.1).or.
     >    (icrit.eq.2.and.ip(3).lt.0.and.ip(5).ge.1))
     >    write(6,formE)' Evb :      ',evb
      else
        if((lcalcevb.and.ip(5).ge.1).or.
     >    (icrit.eq.2.and.ip(3).lt.0.and.ip(5).ge.1))then
          write(6,'(a)')' '
          write(6,formE)' Evb :      ',evb
        endif
      endif
      if(variat.and.(.not.endvar))return

      call makegjorbs_cvb(orbs,gjorb,gjorb2,gjorb3)
      call makecivbs_cvb(civbs,orbs,gjorb,gjorb2,gjorb3,cvbdet)

      call ciscale_cvb(civbs,one/cnrm)
      call dscal_(nvb,one/cnrm,cvb,1)
      call dscal_(ndetvb,one/cnrm,cvbdet,1)
      call finalresult_cvb()
c -- Analysis
      if(.not.lcalccivbs)then
c  CIVBS has been evaluated previously (NB. based on unnormalized CVB) :
        call ciscale_cvb(civbs,one/cnrm)
        call ci2vbg_cvb(civbs,dvbdet)
      else
        call cicopy_cvb(civb,civbs)
        call transp_cvb(orbs,owrk,norb,norb)
        call gaussj_cvb(owrk,gjorb2)
        call applyt_cvb(civbs,gjorb2)
        call ci2vbg_cvb(civbs,dvbdet)
      endif
      call vb2strg_cvb(dvbdet,cvbstot)
      sum1=ddot_(nvb,cvb,1,cvbstot,1)
      call vb2strg_cvb(cvbdet,cvbsspn)
      sum2=ddot_(nvb,cvb,1,cvbsspn,1)
      if((ip(5).ge.1.and.ivbweights.lt.0)
     >  .or.(ivbweights.ge.0.and.mod(ivbweights,2).eq.1))then
        write(6,'(/,a)')' Chirgwin-Coulson weights of structures :'
        write(6,'(a)')' ----------------------------------------'
        write(6,formVBWnorm) ' VB spin+space (norm ',sum1,') :'
        do i=1,nvb
        dvbdet(i)=cvb(i)*cvbstot(i)/sum1
        enddo
        call vecprint_cvb(dvbdet,nvb)
        if(sum2.lt.1d3)then
          write(6,formVBWnorm)' VB spin only  (norm ',sum2,') :'
        else
          formVBWnorm(4:4)='e'
          write(6,formVBWnorm)' VB spin only  (norm ',sum2,') :'
          formVBWnorm(4:4)='f'
        endif
        do i=1,nvb
        dvbdet(i)=cvb(i)*cvbsspn(i)/sum2
        enddo
        call vecprint_cvb(dvbdet,nvb)
      endif
      make_sstruc=(ivbweights.gt.1.or.ishstruc.eq.1)
      if(make_sstruc)then
        if(.not.proj)then
          call mxattb_cvb(orbs,orbs,norb,norb,norb,sorbs)
          call gaussj_cvb(sorbs,gjorb3)
        else
          call gaussj_cvb(orbs,gjorb)
          call transp_cvb(orbs,owrk,norb,norb)
          call gaussj_cvb(owrk,gjorb2)
        endif
        do 7200 k=1,nvb
        call fzero(sstruc(1,k),nvb)
        sstruc(k,k)=1d0
        call str2vbf_cvb(sstruc(1,k),dvbdet)
        call vb2cif_cvb(dvbdet,civb)
        if(.not.proj)then
          call applyt_cvb(civb,gjorb3)
        else
          call applyt_cvb(civb,gjorb)
          call proj_cvb(civb)
          call applyt_cvb(civb,gjorb2)
        endif
        call ci2vbg_cvb(civb,dvbdet)
        call vb2strg_cvb(dvbdet,sstruc(1,k))
7200    continue
        do 7220 k=1,nvb
        do 7221 l=k+1,nvb
        sstruc(k,l)=.5d0*(sstruc(k,l)+sstruc(l,k))
        sstruc(l,k)=sstruc(k,l)
7221    continue
7220    continue
      endif

      if(ivbweights.gt.1)then
c  --  VB analysis Lowdin and Inverse  - begin  --
        if(mod(ivbweights,8).gt.3)then
          write(6,'(/,a)')
     >      ' Inverse-overlap weights of structures :'
          write(6,'(a)')
     >      ' ---------------------------------------'
          call fmove_cvb(sstruc,sstruc2,nvb*nvb)
          call mxinv_cvb(sstruc2,nvb)
c  Use DVBDET for weights :
          sum=zero
          do 7300 k=1,nvb
          dvbdet(k)=cvb(k)*cvb(k)/sstruc2(k,k)
          sum=sum+dvbdet(k)
7300      continue
          write(6,formVBWnorm)' VB spin+space (norm ',sum,') :'
          call dscal_(nvb,one/sum,dvbdet,1)
          call vecprint_cvb(dvbdet,nvb)
        endif

        if(mod(ivbweights,4).gt.1)then
          write(6,'(/,a)')
     >      ' Weights of Lowdin-orthogonalized structures :'
          write(6,'(a)')
     >      ' ---------------------------------------------'
          call fmove_cvb(sstruc,sstruc2,nvb*nvb)
c  Normalise overlap matrix before square root :
c  Use CVBDET for normalized structure coefficients :
          call fmove_cvb(cvb,cvbdet,nvb)
          do 7400 k=1,nvb
          fac=sqrt(sstruc2(k,k))
          cvbdet(k)=fac*cvbdet(k)
          fac=one/fac
          call dscal_(nvb,fac,sstruc2(1,k),1)
          call dscal_(nvb,fac,sstruc2(k,1),nvb)
          sstruc2(k,k)=one
7400      continue

          call mxsqrt_cvb(sstruc2,nvb,1)
c  Use DVBDET for weights :
          call mxatb_cvb(sstruc2,cvbdet,nvb,nvb,1,dvbdet)
          sum=zero
          do 7500 k=1,nvb
          dvbdet(k)=dvbdet(k)*dvbdet(k)
          sum=sum+dvbdet(k)
7500      continue
          write(6,formVBWnorm) ' VB spin+space (norm ',sum,') :'
          call dscal_(nvb,one/sum,dvbdet,1)
          call vecprint_cvb(dvbdet,nvb)
        endif
      endif
c  --  VB analysis Lowdin and Inverse  - end    --

c  Spin correlation analysis
c  Transform spin -> det to cater for non-orthogonal spin basis
      if(sij.and.sc)then
        call str2vbc_cvb(cvb,cvbdet)
        call str2vbg_cvb(cvbstot,dvbdet)
        call str2vbg_cvb(cvbsspn,evbdet)
        call scorr_cvb(cvbdet,dvbdet,evbdet)
      endif

c  Weights of CASSCF vector in VB basis
      if(lciweights)then
        if(.not.ifcasci_cvb())then
          write(6,'(2a)')' Warning - no CIWEIGHTS without CASSCF',
     >      ' vector.'
        else
          call str2vbc_cvb(cvb,cvbdet)
          call vb2cic_cvb(cvbdet,civb)
          call ciweight_cvb(civec,civbs,civb,citmp,civbh,
     >      orbs,sorbs,orbinv,owrk,gjorb,gjorb2,gjorb3)
        endif
      endif

      if(ishstruc.eq.1)then
        write(6,'(/,a)')' Overlap matrix between structures :'
        write(6,'(a)')  ' -----------------------------------'
        call mxprintd_cvb(sstruc,nvb,nvb,0)
        if(ifhamil_cvb())then
          call gaussj_cvb(orbs,gjorb)
          call transp_cvb(orbs,owrk,norb,norb)
          call gaussj_cvb(owrk,gjorb2)
          do 7250 k=1,nvb
          call fzero(sstruc2(1,k),nvb)
          sstruc2(k,k)=1d0
          call str2vbf_cvb(sstruc2(1,k),dvbdet)
          call vb2cif_cvb(dvbdet,civb)
          call applyt_cvb(civb,gjorb)
          call proj_cvb(civb)
          call applyh_cvb(civb)
          call proj_cvb(civb)
          call applyt_cvb(civb,gjorb2)
          call ci2vbg_cvb(civb,dvbdet)
          call vb2strg_cvb(dvbdet,sstruc2(1,k))
7250      continue
          do 7270 k=1,nvb
          do 7271 l=k+1,nvb
          sstruc2(k,l)=.5d0*(sstruc2(k,l)+sstruc2(l,k))
          sstruc2(l,k)=sstruc2(k,l)
7271      continue
7270      continue
          write(6,'(/,a)')' Hamiltonian matrix between structures :'
          write(6,'(a)')  ' ---------------------------------------'
          call mxprintd_cvb(sstruc2,nvb,nvb,0)
          call mxgendiag_cvb(sstruc2,sstruc,dvbdet,nvb)
          nr_print=min(20,nvb)
          if(nr_print.lt.nvb)
     >      write(6,'(/,a,i4,a)')' Printing',nr_print,' lowest roots:'
          do 7290 iroot=1,nr_print
          write(6,formroot)' Root no.',iroot,' energy=',dvbdet(iroot),
     >      ' :'
          call vecprint_cvb(sstruc2(1,iroot),nvb)
7290      continue
        endif
      endif

      call dscal_(nvb,cnrm,cvb,1)

      if(ip(5).ge.1.and.nirrep.gt.1)then
        write(6,'(/,a)')
     >    ' Symmetry contributions to total VB wavefunction :'
        write(6,'(a)')
     >    ' -------------------------------------------------'
        iimx=min(4,nirrep)
        write(6,formSymW)' Irreps 1 to',iimx,' :',(wsym(ii),ii=1,iimx)
        if(nirrep.gt.4)then
          iimx=min(8,nirrep)
          write(6,formSymW)' Irreps 5 to',iimx,' :',(wsym(ii),ii=5,iimx)
        endif
        if(lcalcevb)then
          write(6,'(/,a)')
     >      ' Energies for components > 1d-10 :'
          write(6,'(a)')
     >      ' ---------------------------------'
          iimx=min(4,nirrep)
          write(6,formSymW)' Irreps 1 to',iimx,' :',(esym(ii),ii=1,iimx)
          if(nirrep.gt.4)then
            iimx=min(8,nirrep)
            write(6,formSymW)' Irreps 5 to',iimx,' :',
     >        (esym(ii),ii=5,iimx)
          endif
        endif
      endif
      if(ip(5).ge.1)then
        write(6,'(/,a)')' One-electron density :'
        write(6,'(a)')' ----------------------'
        call mxprint_cvb(dmat,norb,norb,0)
        call mxdiag_cvb(dmat,occ,norb)
c  Sort NOs in order of increasing occ. numbers :
        do 8000 iorb=1,norb/2
        call dswap_(norb,dmat(1,iorb),1,dmat(1,norb+1-iorb),1)
        swp=occ(iorb)
        occ(iorb)=occ(norb+1-iorb)
        occ(norb+1-iorb)=swp
8000    continue
        write(6,'(/,a)')' Natural orbitals :'
        write(6,'(a)')' ------------------'
        call mxprint_cvb(dmat,norb,norb,0)
        write(6,'(/,a)')' Occupation numbers :'
        write(6,'(a)')' --------------------'
        call mxprint_cvb(occ,1,norb,0)
        occ_nel=0d0
        do i=1,norb
        occ_nel=occ_nel+occ(i)
        enddo
        if(abs(occ_nel-DBLE(nel)).gt..1d0)then
          write(6,*)' Error, sum of occupation numbers not equal to ',
     >      'number of electrons :',occ_nel,nel
          call abend_cvb()
        endif
      endif
      call molden_cvb()
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine makegjorbs_cvb(orbs)
! Construct Gauss-Jordan factorizations of ORBS, ORBS transpose,
! and overlap matrix corresonding to ORBS:

use casvb_global, only: gjorb, gjorb2, gjorb3, norb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: orbs(norb,norb)
real(kind=wp), allocatable :: owrk(:,:)

call mma_allocate(owrk,norb,norb,label='owrk')

call gaussj_cvb(orbs,gjorb)

call trnsps(norb,norb,orbs,owrk)
call gaussj_cvb(owrk,gjorb2)

call mxattb_cvb(orbs,orbs,norb,norb,norb,owrk)
call gaussj_cvb(owrk,gjorb3)

call mma_deallocate(owrk)

return

end subroutine makegjorbs_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DistMemPerm (PossT)
c
c       This routine do:
c       define initial possitions of Permanent
c
c       PossT    - initial and last possition (I/O)
c
        implicit none
#include "chcc1.fh"
c
        integer PossT
c
c       help variables
        integer length,nbas(1)
c
c
c1.1    Foo file
        length=no*no
        PossFoo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Foo ',PossFoo,length
        end if
c
c1.2    Fvo file
        length=no*nv
        PossFvo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Fvo ',PossFvo,length
        end if
c
c1.3    Fvv file
        length=nv*nv
        PossFvv=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Fvv ',PossFvv,length
        end if
c
c
c2      OE file
c
        call Get_iArray('nBas',nBas,1)
        length=nbas(1)
c
        PossOE=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM OE ',PossOE,length
        end if
c
c
c3.1    T1o file
        length=no*nv
        PossT1o=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM T1o ',PossT1o,length
        end if
c
c3.2    T1n file
        length=no*nv
        PossT1n=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM T1n ',PossT1n,length
        end if
c
c
c4.1    Hoo file
        length=no*no
        PossHoo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Hoo ',PossHoo,length
        end if
c
c4.2    Hvo file
        length=no*nv
        PossHvo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Hvo ',PossHvo,length
        end if
c
c4.3    Hvv file
        length=nv*nv
        PossHvv=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Hvv ',PossHvv,length
        end if
c
c
c5.1    Goo file
        length=no*no
        PossGoo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Goo ',PossGoo,length
        end if
c
c5.2    Hvv file
        length=nv*nv
        PossGvv=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Gvv ',PossGvv,length
        end if
c
c6.1    A files @@ A file medzi fixnymi je na zamyslenie (lebo je o4)
        length=no*no*no*(no+1)/2
        PossA=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM A   ',PossA,length
        end if
        if (intkey.eq.0) then
          PossAex=PossT
          PossT=PossT+length
          if (printkey.ge.10) then
          write (6,*) 'DM Aex ',PossAex,length
          end if
        else
          PossAex=PossT
        end if
c
c
comega  PossFree - Possition of the space, where work arrays started
        PossFree=PossT
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MODOP(OP1,NOP2,OP2,NOP3,OP3)
! Purpose: Modify the coefficients in OP1 and OP2, using the
! input values of OP2 and OP3, so that the operators can be
! calculated using products of elementary excitation
! operators rather than normal-ordered products.

use Index_Functions, only: iTri, nTri_Elem, nTri3_Elem
use caspt2_module, only: NACTEL, NASHT
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NOP2, NOP3
real(kind=wp), intent(inout) :: OP1(NASHT,NASHT), OP2(NOP2)
real(kind=wp), intent(in) :: OP3(NOP3)
integer(kind=iwp) :: I, I_N, IJ, IJKL, IJKLMN, IL, IND, J, K, KL, KN, L, M, MN, N
real(kind=wp) :: X

if (NACTEL > 2) then

  do I=1,NASHT
    do J=1,NASHT
      IJ = I+NASHT*(J-1)
      do K=1,NASHT
        do L=1,NASHT
          KL = K+NASHT*(L-1)
          if (KL > IJ) cycle

          do M=1,NASHT
            do N=1,NASHT
              MN = M+NASHT*(N-1)
              if (MN > KL) cycle
              IJKLMN = nTri3_Elem(IJ-1)+nTri_Elem(KL-1)+MN
              X = OP3(IJKLMN)
              if (abs(X) < 1.0e-15_wp) cycle

              if (K == J) then
                IL = I+NASHT*(L-1)
                IND = iTri(IL,MN)
                OP2(IND) = OP2(IND)-X
                if (M == L) OP1(I,N) = OP1(I,N)-X
              end if

              if (M == J) then
                I_N = I+NASHT*(N-1)
                IND = iTri(I_N,KL)
                OP2(IND) = OP2(IND)-X
              end if

              if (M == L) then
                KN = K+NASHT*(N-1)
                IND = iTri(KN,IJ)
                OP2(IND) = OP2(IND)-X
              end if

            end do
          end do

        end do
      end do
    end do
  end do

end if

if (NACTEL > 1) then

  do I=1,NASHT
    do J=1,NASHT
      IJ = I+NASHT*(J-1)
      do K=1,NASHT
        do L=1,NASHT
          KL = K+NASHT*(L-1)
          if (KL > IJ) cycle

          if (J == K) then
            IJKL = iTri(IJ,KL)
            OP1(I,L) = OP1(I,L)-OP2(IJKL)
          end if

        end do
      end do
    end do
  end do

end if

end subroutine MODOP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine tred2(nm,n,a,d,e,z)
! this subroutine is a translation of the algol procedure tred2,
! num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
! handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
!
! this subroutine reduces a real symmetric matrix to a
! symmetric tridiagonal matrix using and accumulating
! orthogonal similarity transformations.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.
!
!    n is the order of the matrix.
!
!    a contains the real symmetric input matrix.  only the
!      lower triangle of the matrix need be supplied.
!
! on output
!
!    d contains the diagonal elements of the tridiagonal matrix.
!
!    e contains the subdiagonal elements of the tridiagonal
!      matrix in its last n-1 positions.  e(1) is set to zero.
!
!    z contains the orthogonal transformation matrix
!      produced in the reduction.
!
!    a and z may coincide.  if distinct, a is unaltered.
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n
real(kind=wp), intent(inout) :: a(nm,n)
real(kind=wp), intent(out) :: d(n), e(n), z(nm,n)
integer(kind=iwp) :: i, ii, j, jp1, l
real(kind=wp) :: f, g, h, hh, scl

do i=1,n

  z(i:n,i) = a(i:n,i)

  d(i) = a(n,i)
end do

! .......... for i=n step -1 until 2 do -- ..........
do ii=2,n
  i = n+2-ii
  l = i-1
  h = Zero
  ! .......... scale row (algol tol then not needed) ..........
  scl = sum(abs(d(1:l)))

  if (scl == Zero) then
    e(i) = d(l)

    d(1:l) = z(l,1:l)
    z(i,1:l) = Zero
    z(1:l,i) = Zero

  else

    d(1:l) = d(1:l)/scl
    h = h+sum(d(1:l)**2)

    f = d(l)
    g = -sign(sqrt(h),f)
    e(i) = scl*g
    h = h-f*g
    d(l) = f-g
    ! .......... form a*u ..........
    e(1:l) = Zero

    do j=1,l
      f = d(j)
      z(j,i) = f
      g = e(j)+z(j,j)*f
      jp1 = j+1

      g = g+sum(z(jp1:l,j)*d(jp1:l))
      e(jp1:l) = e(jp1:l)+z(jp1:l,j)*f

      e(j) = g
    end do
    ! .......... form p ..........
    e(1:l) = e(1:l)/h
    f = sum(e(1:l)*d(1:l))

    hh = f/(h+h)
    ! .......... form q ..........
    e(1:l) = e(1:l)-hh*d(1:l)
    ! .......... form reduced a ..........
    do j=1,l
      f = d(j)
      g = e(j)

      z(j:l,j) = z(j:l,j)-f*e(j:l)-g*d(j:l)

      d(j) = z(l,j)
      z(i,j) = Zero
    end do

  end if

  d(i) = h
end do
! .......... accumulation of transformation matrices ..........
do i=2,n
  l = i-1
  z(n,l) = z(l,l)
  z(l,l) = One
  h = d(i)

  if (h /= Zero) then
    d(1:l) = z(1:l,i)/h

    do j=1,l
      g = Zero

      g = sum(z(1:l,i)*z(1:l,j))

      z(1:l,j) = z(1:l,j)-g*d(1:l)
    end do
  end if

  z(1:l,i) = Zero

end do

d(:) = z(n,:)
z(n,:) = Zero

z(n,n) = One
e(1) = Zero

return

end subroutine tred2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine percentzero (wrk,wrksize,
     & mapd,pz)
c
c     this routine test % of small elements in meditate, decribed by mpd
c
c     mapd - direct map of required mediate (I)
c
#include "wrk.fh"
       integer mapd(0:512,1:6)
       real*8  pz
c
c     help variables
c
       integer poss,length
       integer nhelp,nzero
       real*8 zerolim
c
c     def length, poss, zerolim
c
       poss=mapd(1,1)
       nhelp=mapd(0,5)
       length=mapd(nhelp,1)+mapd(nhelp,2)-mapd(1,1)
       zerolim=1.0d-6
c
       if (length.gt.0) then
       nzero=0
       do 100 nhelp=poss,poss+length-1
       if (abs(wrk(nhelp)).lt.zerolim) then
       nzero=nzero+1
       end if
 100    continue
       pz = dble(100*nzero)/dble(length)
       else
       pz=1.0d0
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Ben Swerts                                             *
************************************************************************
      SubRoutine Drvg_FAIEMP(Grad,Temp,nGrad)
************************************************************************
*                                                                      *
*  Object: driver for the derivatives of central-fragment              *
*          two-electron integrals. The four outermost loops            *
*          will controll the type of the two-electron integral, eg.    *
*          (ss|ss), (sd|pp), etc. The next four loops will generate    *
*          list of symmetry distinct centers that do have basis func-  *
*          tions of the requested type.                                *
*                                                                      *
*     Author: Ben Swerts                                               *
*                                                                      *
*     based on Drvg1                                                   *
************************************************************************
      use k2_setup
      use iSD_data
      use k2_arrays, only: ipZeta, ipiZet, Mem_DBLE, Aux, Sew_Scr
      use Basis_Info
      use Sizes_of_Seward, only:S
      use Real_Info, only: CutInt
      use Symmetry_Info, only: nIrrep
      Implicit None
      External King, Rsv_GTList, MPP
#include "itmax.fh"
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "disp.fh"
#include "nsd.fh"
#include "setup.fh"
*     Local arrays
      Integer  nGrad
      Real*8   Coor(3,4), Grad(nGrad), Temp(nGrad)
      Integer  iAnga(4), iCmpa(4), iShela(4),iShlla(4),
     &         iAOV(4), istabs(4), iAOst(4), JndGrd(3,4), iFnc(4)
      Integer  nHrrTb(0:iTabMx,0:iTabMx,2)
      Logical  EQ, Shijij, AeqB, CeqD, lDummy,
     &         DoGrad, DoFock, Indexation,
     &         JfGrad(3,4), ABCDeq, No_Batch, King, Rsv_GTList, MPP,
     &         FreeK2, Verbose, Triangular
      Character*7 Format*72
      Logical  lNoSkip
      Integer  nBas_Valence(0:7)
*
      Integer  iSD4(0:nSD,4)
      Integer  MemMax,MemPrm
      save     MemPrm
*
      Integer  iRout,iPrint,nBT,nBVT,idum,idum1,i,j,iAng,iBasi,iBasn
      Integer  iS,jS,iBasAO,iBsInc,iCar,ijklA,ijS,Indij,iOpt,ijMax
      Integer  ip_ij,ipEI,ipEta,ipiEta,ipMem1,ipMem2,ipP,ipQ
      Integer  iPrem,iPren,ipxA,ipxB,ipxG,ipxD,ipZi,Mem1,Mem2,iPrimi
      Integer  iPrInc,ipTMax,jAng,iSh,jBasAO,jBasj,jBasn,jBsInc
      Integer  jPrInc,k2ij,k2kl,jPrimj,kBasAO,kBasn,kBask,kBsInc
      Integer  kBtch,klS,kPrimk,kPrInc,kS,lBasAO,lBasl,lBasn
      Integer  lBsInc,lPriml,lPrInc,mBtch,lS,mdci,mdcj,mdck,mdcl
      Integer  MemPSO,nab,ncd,nDCRR,nDCRS,nEta,nHmab,nHmcd,nHrrab
      Integer  nij,nijkl,nPairs,nQuad,nRys,nSkal,nSkal_Fragments
      Integer  nSkal_Valence,nSO,nZeta,nBtch
      Real*8   TMax,PMax,ExFac,CoulFac,Aint,Count,P_Eff,Prem,Pren
      Real*8   TCpu1,TCpu2,ThrAO,TMax_all,TskHi,TskLw,TWall1,TWall2
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      TMax(i,j)=Work((j-1)*nSkal+i+ipTMax-1)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 203
      iPrint = nPrint(iRout)
      iFnc(1)=0
      iFnc(2)=0
      iFnc(3)=0
      iFnc(4)=0
      PMax=Zero
      idum=0
      idum1=0
      ExFac=One
      CoulFac=One
*
*     Handle both the valence and the fragment basis set
*
      Call Set_Basis_Mode('Valence')
      Call Nr_Shells(nSkal_Valence)
      Call Set_Basis_Mode('WithFragments')
      Call SetUp_iSD
      nBT = 0
      nBVT = 0
      do i = 0, nIrrep - 1
        nBas_Valence(i) = nBas(i)
        nBVT = nBVT + nBas(i)*(nBas(i)+1)/2
        nBas(i) = nBas(i) + nBas_Frag(i)
        nBT = nBT + nBas(i)*(nBas(i)+1)/2
      enddo
*                                                                      *
************************************************************************
*                                                                      *
*-----Precompute k2 entities.
*
      Indexation=.False.
      DoFock=.False.
      DoGrad=.True.
      ThrAO=Zero
      Call SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
      mSkal=nSkal
      nPairs=nSkal*(nSkal+1)/2
      nQuad =nPairs*(nPairs+1)/2
      Pren = Zero
      Prem = Zero
      nSkal_Fragments=nSkal-nSkal_Valence
      If(iPrint.ge.99) write(6,*) 'nSkal, nSkal_Valence, nSkal_Frag = ',
     &                             nSkal, nSkal_Valence, nSkal_Fragments
*                                                                      *
************************************************************************
*                                                                      *
*-----Prepare handling of the combined two-particle density.
*
      Call PrepP_FAIEMP(nBas_Valence, nBT, nBVT)
*                                                                      *
************************************************************************
*                                                                      *
      MxPrm = 0
      Do iAng = 0, S%iAngMx
         MxPrm = Max(MxPrm,S%MaxPrm(iAng))
      End Do
      nZeta = MxPrm * MxPrm
      nEta  = MxPrm * MxPrm
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      Call GetMem('TMax','Allo','Real',ipTMax,nSkal**2)
      Call Shell_MxSchwz(nSkal,Work(ipTMax))
      TMax_all=Zero
      Do iS = 1, nSkal
         Do jS = 1, iS
            TMax_all=Max(TMax_all,TMax(iS,jS))
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Create list of non-vanishing pairs
*
      Call GetMem('ip_ij','Allo','Inte',ip_ij,nSkal*(nSkal+1))
      nij=0
      Do iS = 1, nSkal
         Do jS = 1, iS
            If (TMax_All*TMax(iS,jS).ge.CutInt) Then
               nij = nij + 1
               iWork((nij-1)*2+ip_ij  )=iS
               iWork((nij-1)*2+ip_ij+1)=jS
            End If
         End Do
      End Do
      P_Eff=DBLE(nij)
*                                                                      *
************************************************************************
*                                                                      *
*-------Compute FLOP's for the transfer equation.
*
        Do iAng = 0, S%iAngMx
           Do jAng = 0, iAng
              nHrrab = 0
              Do i = 0, iAng+1
                 Do j = 0, jAng+1
                    If (i+j.le.iAng+jAng+1) Then
                       ijMax = Min(iAng,jAng)+1
                       nHrrab = nHrrab + ijMax*2+1
                    End If
                 End Do
              End Do
              nHrrTb(iAng,jAng,1)=nHrrab
              nHrrTb(jAng,iAng,1)=nHrrab
           End Do
        End Do
*                                                                      *
************************************************************************
*                                                                      *
      Triangular=.True.
      Call Alloc_TList(Triangular,P_Eff)
      Call Init_TList(Triangular,P_Eff)
      Call Init_PPList
      Call Init_GTList
      iOpt=0
      call dcopy_(nGrad,[Zero],0,Temp,1)
      If (iPrint.ge.15) Call PrGrad(' In Drvg_FAIEMP: Total Grad (1)',
     &                              Grad,nGrad,ChDisp,iprint)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_MaxDBLE(MemMax)
      Call mma_allocate(Sew_Scr,MemMax,Label='Sew_Scr')
      ipMem1=1
*                                                                      *
************************************************************************
*                                                                      *
*     big loop over individual tasks, distributed over individual nodes
   10 Continue
*     make reservation of a task on global task list and get task range
*     in return. Function will be false if no more tasks to execute.
      If (.Not.Rsv_GTList(TskLw,TskHi,iOpt,lDummy)) Go To 11
*
*     Now do a quadruple loop over shells
*
      ijS = Int((One+sqrt(Eight*TskLw-Three))/Two)
      iS = iWork((ijS-1)*2+ip_ij)
      jS = iWork((ijS-1)*2+ip_ij+1)
      klS = Int(TskLw-DBLE(ijS)*(DBLE(ijS)-One)/Two)
      kS = iWork((klS-1)*2+ip_ij)
      lS = iWork((klS-1)*2+ip_ij+1)
      Count=TskLw
      Call CWTime(TCpu1,TWall1)
  13  Continue
         If (Count-TskHi.gt.1.0D-10) Go To 12
*
         Aint=TMax(iS,jS)*TMax(kS,lS)

         lNoSkip = AInt.ge.CutInt
* only calculate needed integrals and only update the valence part of the
* Fock matrix (iS > nSkal_Valence, lS <= nSkal_Valence, jS and kS
* belonging to different regions)
         If(jS.le.nSkal_Valence) Then
           lNoSkip = lNoSkip.and.kS.gt.nSkal_Valence
         Else
           lNoSkip = lNoSkip.and.kS.le.nSkal_Valence
         End If
         lNoSkip = lNoSkip.and.lS.le.nSkal_Valence
         if(.Not.lNoSkip) Go To 14
*                                                                      *
************************************************************************
*                                                                      *
         Call Gen_iSD4(iS, jS, kS, lS,iSD,nSD,iSD4)
         Call Size_SO_block_g(iSD4,nSD,nSO,No_batch)
         If (No_batch) Go To 140
*
         Call Int_Prep_g(iSD4,nSD,Coor,Shijij,iAOV,iStabs)
*
*                                                                      *
************************************************************************
*                                                                      *
*       --------> Memory Managment <--------
*
*        Compute memory request for the primitives, i.e.
*        how much memory is needed up to the transfer
*        equation.
*
         Call MemRys_g(iSD4,nSD,nRys,MemPrm)
*                                                                      *
************************************************************************
*                                                                      *
         ABCDeq=EQ(Coor(1,1),Coor(1,2)) .and.
     &          EQ(Coor(1,1),Coor(1,3)) .and.
     &          EQ(Coor(1,1),Coor(1,4))
         ijklA=iSD4(1,1)+iSD4(1,2)
     &        +iSD4(1,3)+iSD4(1,4)
         if(nIrrep.eq.1.and.ABCDeq.and.Mod(ijklA,2).eq.1
     &     .and.iPrint.gt.15) write(6,*) 'ABCDeq & ijklA'
         If (nIrrep.eq.1.and.ABCDeq.and.Mod(ijklA,2).eq.1)
     &      Go To 140
*                                                                      *
************************************************************************
*                                                                      *
*        Decide on the partioning of the shells based on the
*        available memory and the requested memory.
*
*        Now check if all blocks can be computed and stored at
*        once.
*

         Call SOAO_g(iSD4,nSD,nSO,
     &               MemPrm, MemMax,
     &               iBsInc,jBsInc,kBsInc,lBsInc,
     &               iPrInc,jPrInc,kPrInc,lPrInc,
     &               ipMem1,ipMem2, Mem1,  Mem2,
     &               iPrint,iFnc, MemPSO)
         iBasi    = iSD4(3,1)
         jBasj    = iSD4(3,2)
         kBask    = iSD4(3,3)
         lBasl    = iSD4(3,4)
*                                                                      *
************************************************************************
*                                                                      *
         Call Int_Parm_g(iSD4,nSD,iAnga,
     &                 iCmpa,iShlla,iShela,
     &                 iPrimi,jPrimj,kPrimk,lPriml,
     &                 indij,k2ij,nDCRR,k2kl,nDCRS,
     &                 mdci,mdcj,mdck,mdcl,AeqB,CeqD,
     &                 nZeta,nEta,ipZeta,ipZI,
     &                 ipP,ipEta,ipEI,ipQ,ipiZet,ipiEta,
     &                 ipxA,ipxB,ipxG,ipxD,l2DI,nab,nHmab,ncd,nHmcd,
     &                 nIrrep)
*                                                                      *
************************************************************************
*                                                                      *
*        Scramble arrays (follow angular index)
*
         Do iCar = 1, 3
            Do iSh = 1, 4
               JndGrd(iCar,iSh) = iSD4(15+iCar,iSh)
               If (iAnd(iSD4(15,iSh),2**(iCar-1)) .eq.
     &             2**(iCar-1)) Then
                  JfGrad(iCar,iSh) = .True.
               Else
                  JfGrad(iCar,iSh) = .False.
               End If
            End Do
         End Do
*
         Do 400 iBasAO = 1, iBasi, iBsInc
           iBasn=Min(iBsInc,iBasi-iBasAO+1)
           iAOst(1) = iBasAO-1
         Do 410 jBasAO = 1, jBasj, jBsInc
           jBasn=Min(jBsInc,jBasj-jBasAO+1)
           iAOst(2) = jBasAO-1
*
         Do 420 kBasAO = 1, kBask, kBsInc
           kBasn=Min(kBsInc,kBask-kBasAO+1)
           iAOst(3) = kBasAO-1
         Do 430 lBasAO = 1, lBasl, lBsInc
           lBasn=Min(lBsInc,lBasl-lBasAO+1)
           iAOst(4) = lBasAO-1
*
*----------Get the 2nd order density matrix in SO basis.
*
           nijkl = iBasn*jBasn*kBasn*lBasn
           Call PGet0(iCmpa,
     &                iBasn,jBasn,kBasn,lBasn,Shijij,
     &                iAOV,iAOst,nijkl,Sew_Scr(ipMem1),nSO,
     &                iFnc(1)*iBasn,iFnc(2)*jBasn,
     &                iFnc(3)*kBasn,iFnc(4)*lBasn,MemPSO,
     &                Sew_Scr(ipMem2),Mem2,iS,jS,kS,lS,nQuad,PMax)
           If (AInt*PMax.lt.CutInt) Go To 430
*
*----------Compute gradients of shell quadruplet
*
           Call TwoEl_g(Coor,
     &          iAnga,iCmpa,iShela,iShlla,iAOV,
     &          mdci,mdcj,mdck,mdcl,nRys,
     &          Data_k2(k2ij),nab,nHmab,nDCRR,
     &          Data_k2(k2kl),ncd,nHmcd,nDCRS,Pren,Prem,
     &          iPrimi,iPrInc,jPrimj,jPrInc,
     &          kPrimk,kPrInc,lPriml,lPrInc,
     &          Shells(iSD4(0,1))%pCff(iPrimi,iBasAO),iBasn,
     &          Shells(iSD4(0,2))%pCff(jPrimj,jBasAO),jBasn,
     &          Shells(iSD4(0,3))%pCff(kPrimk,kBasAO),kBasn,
     &          Shells(iSD4(0,4))%pCff(lPriml,lBasAO),lBasn,
     &          Mem_DBLE(ipZeta),Mem_DBLE(ipZI),Mem_DBLE(ipP),nZeta,
     &          Mem_DBLE(ipEta), Mem_DBLE(ipEI),Mem_DBLE(ipQ),nEta,
     &          Mem_DBLE(ipxA),Mem_DBLE(ipxB),
     &          Mem_DBLE(ipxG),Mem_DBLE(ipxD),Temp,nGrad,
     &          JfGrad,JndGrd,Sew_Scr(ipMem1), nSO,Sew_Scr(ipMem2),Mem2,
     &          Aux,nAux,Shijij)
*
*
            If (iPrint.ge.15)
     &         Call PrGrad(' In Drvg_FAIEMP: Grad',
     &                  Temp,nGrad,ChDisp,iPrint)
*
 430     Continue
 420     Continue
*
 410     Continue
 400     Continue
*
 140     Continue
*
 14      Continue
         Count=Count+One
         klS = klS + 1
         If (klS.gt.ijS) Then
            ijS = ijS + 1
            klS = 1
         End If
         iS = iWork((ijS-1)*2+ip_ij  )
         jS = iWork((ijS-1)*2+ip_ij+1)
         kS = iWork((klS-1)*2+ip_ij  )
         lS = iWork((klS-1)*2+ip_ij+1)
         Go To 13
*
*     Task endpoint
 12   Continue
      Call CWTime(TCpu2,TWall2)
      Call SavTim(4,TCpu2-TCpu1,TWall2-Twall1)
      Call SavStat(1,One,'+')
      Call SavStat(2,TskHi-TskLw+One,'+')
      Go To 10
 11   Continue
*     End of big task loop
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Sew_Scr)
      Call Free_GTList
      Call Free_PPList
      Call Free_TList
      Call GetMem('ip_ij','Free','Inte',ip_ij,nSkal*(nSkal+1))
      Call GetMem('TMax','Free','Real',ipTMax,nSkal**2)
*                                                                      *
************************************************************************
*                                                                      *
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*                                                                      *
************************************************************************
*                                                                      *
      Call Sync_Data(Pren,Prem,nBtch,mBtch,kBtch)
*
      iPren=3+Max(1,Int(Log10(Pren+0.001D+00)))
      iPrem=3+Max(1,Int(Log10(Prem+0.001D+00)))
      Write (Format,'(A,I2,A,I2,A)') '(A,F',iPren,
     &           '.0,A,F',iPrem,'.0,A)'
      If (iPrint.ge.6) Then
      Write (6,Format)
     &   ' A total of', Pren,' entities were prescreened and',
     &                  Prem,' were kept.'
      End If
* Accumulate the final results
      Call DScal_(nGrad,Half,Temp,1)
      If(iPrint.ge.15) Call PrGrad('The FAIEMP 2-electron Contribution',
     &                             Temp,nGrad,ChDisp,iPrint)
      call daxpy_(nGrad,One,Temp,1,Grad,1)
*
      Call Free_iSD()
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Integer Function iDeg(Coor)
************************************************************************
*                                                                      *
* Object: to compute the degeneracy of a coordinate.                   *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             March '91                                                *
************************************************************************
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Coor(3), Cx(3,8), r(3)
      Logical New
*
      iDeg = 1
      Cx(:,1) = Coor(:)
      Do i = 1, nIrrep-1
         r(1)=One
         If (iAnd(iOper(i),1).ne.0) r(1)=-One
         r(2)=One
         If (iAnd(iOper(i),2).ne.0) r(2)=-One
         r(3)=One
         If (iAnd(iOper(i),4).ne.0) r(3)=-One
         x=r(1)*Coor(1)
         y=r(2)*Coor(2)
         z=r(3)*Coor(3)
         New=.True.
         Do j = 1, iDeg
            If(New .and. x.eq.Cx(1,j)
     &             .and. y.eq.Cx(2,j)
     &             .and. z.eq.Cx(3,j)) New=.False.
         End Do
         If (New) Then
            iDeg=iDeg+1
            Cx(1,iDeg)=x
            Cx(2,iDeg)=y
            Cx(3,iDeg)=z
         End If
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Daoling Peng                                     *
!***********************************************************************

subroutine XDR_Ham(nbas,isize,jsize,imethod,paratyp,dkhorder,xorder,inS,inK,inV,inpVp,inUL,inUS,clight)
! Implementation of the scalar-relativistic
!    Arbitrary Order  DKH (Douglas-Kroll-Hess)
!    eXact Decoupling X2C (eXact-2-Component)
!    eXact Decoupling BSS (Barysz-Sadlej-Snijders)
! transformations for Hamiltonian and property integrals
!
! Written by Daoling Peng, ETH Zurich, 2011
!
!
! Reference to the generalized arbitrary/infinite-order DKH method:
!
!    A. Wolf, M. Reiher, B.A. Hess, J. Chem. Phys. 117 (2002) 9215-9226
!    M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 2037-2047   partI   [Theory]
!    M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 10945-10956 partII  [Algorithm]
!    A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064102      partIII [Properties-Theory]
!    A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064103      partIV  [Properties-Implementation]
!    D. Peng, K. Hirao,  J.Chem.Pyhs. 130 (2009) 044102      [Polynomial cost algorithm]
!
! Reference to the exact decoupling X2C method:
!
!    W. Kutzelnigg, W. Liu, J.Chem.Phys. 123 (2005) 241102   [Theory]
!    W. Liu, D. Peng, J.Chem.Phys. 125 (2006) 044102         [Implementation]
!    D. Peng, W. Liu, Y. Xiao, L. Cheng, J.Chem.Phys. 127 (2007) 104106   [Implementation]
!
! Reference to the exact decoupling BSS method:
!
!    M. Barysz, A. J. Sadlej, J. G. Snijders, Int.J.QuantumChem. 65 (1997) 225-239   [Theory]
!    D. Kedziera, M. Barysz, Chem.Phys.Lett. 446 (2007) 176-181   [Non-iterative scheme]
!
!  ---------------------------------------------------------------------
!
!  Input:
!
!     nbas         number of basis functions ( dimension of matrix )
!     isize        =nbas*(nbas+1)/2  number of elements in triangle matrix
!     jsize        =nbas*nbas number of elements in square matrix
!     imethod      { 1 : DKH, 2 : X2C, 3 : BSS }
!     paratyp      parameterization of DKH unitary transformation
!     dkhorder     order of DKH for Hamiltonian
!     xorder       order of DKH for property integrals
!                  >0, do transformation for exact decoupling methods
!     clight       speed of light in atomic unit
!     inS(isize)   overlap matrix
!     inV(isize)   external potential
!     inpVp(isize) matrix representation of <pxVpx>+<pyVpy>+<pzVpz>
!     inK(isize)   non-relativistic kinetic matrix <p**2>/2
!
!  Output
!
!     inK(isize)   relativistic transformed one-electron Hamiltonian matrix
!     inUL(jsize)  store the relativistic transformation matrix ( Large component part )
!     inUS(jsize)  store the relativistic transformation matrix ( Small component part )

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nbas, isize, jsize, imethod, paratyp, dkhorder, xorder
real(kind=wp), intent(in) :: inS(isize), inV(isize), inpVp(isize), clight
real(kind=wp), intent(inout) :: inK(isize)
real(kind=wp), intent(out) :: inUL(jsize), inUS(jsize)
integer(kind=iwp) :: i, j, k
real(kind=wp), allocatable :: sK(:,:), sS(:,:), sV(:,:), pVp(:,:)

! Convert triangle matrices to square matrices

call mma_allocate(sK,nbas,nbas,label='skin')
call mma_allocate(sS,nbas,nbas,label='sSS')
call mma_allocate(sV,nbas,nbas,label='sV')
call mma_allocate(pVp,nbas,nbas,label='spVp')
k = 0
do i=1,nbas
  do j=1,i
    k = k+1
    sK(j,i) = inK(k)
    sS(j,i) = inS(k)
    sV(j,i) = inV(k)
    pVp(j,i) = inpVp(k)
    if (i /= j) then
      sK(i,j) = inK(k)
      sS(i,j) = inS(k)
      sV(i,j) = inV(k)
      pVp(i,j) = inpVp(k)
    end if
  end do
end do

! Calculate relativistic one-electron Hamiltonian

if (imethod == 2) then

  ! Call X2C driver

  call x2c_ts1e(nbas,sS,sK,sV,pVp,inUL,inUS,clight)
else if (imethod == 3) then

  ! Call BSS driver

  call bss_ts1e(nbas,sS,sK,sV,pVp,inUL,inUS,clight)
else if (imethod == 1) then

  ! Call arbitrary order DKH driver

  call dkh_ts1e(nbas,sS,sK,sV,pVp,inUL,inUS,clight,dkhorder,xorder,paratyp)
end if

! Copy relativistic one-electron Hamiltonian back to inK

k = 0
do i=1,nbas
  do j=1,i
    k = k+1
    inK(k) = sV(j,i)
  end do
end do

! Free temp memories

call mma_deallocate(sK)
call mma_deallocate(sS)
call mma_deallocate(sV)
call mma_deallocate(pVp)

return

end subroutine XDR_Ham

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DMinvCI_sa(ipSigma,rout,S)

use ipPage, only: ipin, W
use MCLR_Data, only: ipCI, ipDia, nConf1
use input_mclr, only: ERASSCF, nCSF, nRoots, State_Sym
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ipSigma
real(kind=wp), intent(out) :: rout(nCSF(State_Sym),nRoots)
real(kind=wp), intent(in) :: S(nRoots,nRoots,nRoots)
integer(kind=iwp) :: iR, jR, k
real(kind=wp) :: alpha(nRoots), rcoeff(nRoots)
real(kind=wp), external :: DDot_

!                                  -1           -1
!                             (H -E) |0><0|(H -E) |Sigma>
!                -1             0            0
! |rNew> = (H - E) |Sigma> - -----------------------------
!            0                               -1
!                                    <0|(H -E) |0>
!                                         0

if (nconf1 > 1) then
  call ipin(ipdia)
  call ipin(ipsigma)
  k = 0
  do iR=1,nRoots
    rout(:,iR) = W(ipSigma)%A(k+1:k+nCSF(State_Sym))/(W(ipdia)%A(1:nCSF(State_Sym))-ERASSCF(iR))
    k = k+nCSF(State_Sym)
  end do
  do iR=1,nRoots

    !We = weight(iR)
    call ipin(ipCI)
    do jR=1,nRoots
      rcoeff(jR) = ddot_(nconf1,rout(:,iR),1,W(ipCI)%A(1+(jR-1)*nCSF(State_Sym)),1)
    end do

    do jR=1,nRoots
      alpha(jR) = sum(S(jR,:,iR)*rcoeff(:))
    end do

    do jR=1,nRoots
      rout(:,iR) = rout(:,iR)- &
                   W(ipCI)%A((jR-1)*nCSF(State_Sym)+1:jR*nCSF(State_Sym))*alpha(jR)/(W(ipdia)%A(1:nCSF(State_Sym))-ERASSCF(iR))
    end do
    !if (abs(Weight(iR)) > 1.0e-9_wp) rout(:,iR) = rout(:,iR)/Weight(iR)

  end do
else
  rout(:,:) = Zero
end if

end subroutine DMinvCI_sa

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Daoling Peng                                     *
************************************************************************
C----------------------------------------------------------------------|
      subroutine XDR_Ham(nbas,isize,jsize,imethod,paratyp,dkhorder,
     &                   xorder,inS,inK,inV,inpVp,inUL,inUS,clight)
C
C  ------------------------------------------------------------------------------------------
C
C  Implementation of the scalar-relativistic
C     Arbitrary Order  DKH (Douglas-Kroll-Hess)
C     eXact Decoupling X2C (eXact-2-Component)
C     eXact Decoupling BSS (Barysz-Sadlej-Snijders)
C  transformations for Hamiltonian and property integrals
C
C  Written by Daoling Peng, ETH Zurich, 2011
C
C
C  Reference to the generalized arbitrary/infinite-order DKH method:
C
C     A. Wolf, M. Reiher, B.A. Hess, J. Chem. Phys. 117 (2002) 9215-9226
C     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 2037-2047   partI   [Theory]
C     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 10945-10956 partII  [Algorithm]
C     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064102      partIII [Properties-Theory]
C     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064103      partIV  [Properties-Implementation]
C     D. Peng, K. Hirao,  J.Chem.Pyhs. 130 (2009) 044102      [Polynomial cost algorithm]
C
C  Reference to the exact decoupling X2C method:
C
C     W. Kutzelnigg, W. Liu, J.Chem.Phys. 123 (2005) 241102   [Theory]
C     W. Liu, D. Peng, J.Chem.Phys. 125 (2006) 044102         [Implementation]
C     D. Peng, W. Liu, Y. Xiao, L. Cheng, J.Chem.Phys. 127 (2007) 104106   [Implementation]
C
C  Reference to the exact decoupling BSS method:
C
C     M. Barysz, A. J. Sadlej, J. G. Snijders, Int.J.QuantumChem. 65 (1997) 225-239   [Theory]
C     D. Kedziera, M. Barysz, Chem.Phys.Lett. 446 (2007) 176-181   [Non-iterative scheme]
C
C  ----------------------------------------------------------------------------------------------
C
C  Input:
C
C     nbas         number of basis functions ( dimension of matrix )
C     isize        =nbas*(nbas+1)/2  number of elements in triangle matrix
C     jsize        =nbas*nbas number of elements in square matrix
C     imethod      { 1 : DKH, 2 : X2C, 3 : BSS }
C     paratyp      parameterization of DKH unitary transformation
C     dkhorder     order of DKH for Hamiltonian
C     xorder       order of DKH for property integrals
C                  >0, do transformation for exact decoupling methods
C     clight       speed of light in atomic unit
C     inS(isize)   overlap matrix
C     inV(isize)   external potential
C     inpVp(isize) matrix representation of <pxVpx>+<pyVpy>+<pzVpz>
C     inK(isize)   non-relativistic kinetic matrix <p**2>/2
C
C  Output
C
C     inK(isize)   relativistic transformed one-electron Hamiltonian matrix
C     inUL(jsize)  store the relativistic transformation matrix ( Large component part )
C     inUS(jsize)  store the relativistic transformation matrix ( Small component part )
C
C  -----------------------------------------------------------------------------------------
C
      implicit none
#include "WrkSpc.fh"
C Input variables
      integer nbas,isize,jsize,imethod,paratyp,dkhorder,xorder
      Real*8 clight
      Real*8 inS(isize),inV(isize),inpVp(isize)
C Input/Output variables
      Real*8 inK(isize)
C Output variables
      Real*8 inUL(jsize),inUS(jsize)
C Local variables
      integer nn,i,j,k
      integer jS,jK,jV,jpVp
C
C Convert triangle matrices to square matrices
C
      nn = nbas*nbas+4
      call getmem('skin ','ALLOC','REAL',jK   ,nn)
      call getmem('sSS  ','ALLOC','REAL',jS   ,nn)
      call getmem('sV   ','ALLOC','REAL',jV   ,nn)
      call getmem('spVp ','ALLOC','REAL',jpVp ,nn)
      k = 0
      do i=1,nbas
        do j=1,i
          k = k + 1
          Work(jK + j-1 + (i-1)*nbas ) = inK(k)
          Work(jS + j-1 + (i-1)*nbas ) = inS(k)
          Work(jV + j-1 + (i-1)*nbas ) = inV(k)
          Work(jpVp + j-1 + (i-1)*nbas ) = inpVp(k)
          if(i.ne.j)then
            Work(jK + i-1 + (j-1)*nbas ) = inK(k)
            Work(jS + i-1 + (j-1)*nbas ) = inS(k)
            Work(jV + i-1 + (j-1)*nbas ) = inV(k)
            Work(jpVp + i-1 + (j-1)*nbas ) = inpVp(k)
          end if
        end do
      end do
C
C Calculate relativistic one-electron Hamiltonian
C
      if(imethod.eq.2)then
C
C Call X2C driver
C
        call x2c_ts1e(nbas,Work(jS),Work(jK),Work(jV),Work(jpVp),
     &                inUL,inUS,clight )
      else if(imethod.eq.3)then
C
C Call BSS driver
C
        call bss_ts1e(nbas,Work(jS),Work(jK),Work(jV),Work(jpVp),
     &                inUL,inUS,clight )
      else if(imethod.eq.1)then
C
C Call arbitrary order DKH driver
C
        call dkh_ts1e(nbas,Work(jS),Work(jK),Work(jV),Work(jpVp),
     &                inUL,inUS,clight,dkhorder,xorder,paratyp )
      end if
C
C Copy relativistic one-electron Hamiltonian back to inK
C
      k=0
      do i=1,nbas
        do j=1,i
          k=k+1
          inK(k)=Work(jV+j-1+(i-1)*nbas)
        end do
      end do
C
C Free temp memories
C
      call getmem('skin ','FREE','REAL',jK   ,nn)
      call getmem('sSS  ','FREE','REAL',jS   ,nn)
      call getmem('sV   ','FREE','REAL',jV   ,nn)
      call getmem('spVp ','FREE','REAL',jpVp ,nn)
C
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
************************************************************************
      Subroutine Update_sl_(kIter,iInt,nFix,nInter,qInt,Shift,
     &                     Grad,iOptC,Beta,Beta_Disp,Lbl,GNrm,
     &                     Energy,UpMeth,ed,Line_Search,Step_Trunc,
     &                     nLambda,iRow_c,nsAtom,AtomLbl,
     &                     mxdc,jStab,nStab,BMx,Smmtrc,nDimBC,
     &                     rLambda,Cx,GrdMax,StpMax,GrdLbl,StpLbl,
     &                     iNeg,nLbl,Labels,nLabels,FindTS,TSC,nRowH,
     &                     nWndw,Mode,MF,
     &                     iOptH,HUpMet,mIter,GNrm_Threshold,IRC,
     &                     dMass,HrmFrq_Show,CnstWght,Curvilinear,
     &                     Degen,Kriging_Hessian,qBeta,iOpt_RS,
     &                     First_MicroIteration,Iter,qBeta_Disp)
************************************************************************
*     Object: to update coordinates                                    *
*                                                                      *
*    Input:                                                            *
*      kIter          : iteration counter                              *
*      iInt           : number of internal coordinates to vary         *
*      nFix           : number of frozen internal coordinates          *
*      nInter         : total number of internal coordinates           *
*      qInt(*,kIter)  : the internal coordinates                       *
*      Shift(*,kIter) : the shift of the internal coordinates          *
*      Grad(*,kIter)  : the gradient in the internal coordinates       *
*      iOptC          : option flag for update methods                 *
*      Beta           : damping factor step length                     *
*      Beta_Disp      : damping factor variance                        *
*      Lbl            : character labels for internal coordinates      *
*      nLbl           : length of Lbl                                  *
*      GNrm           : the norm of the gradient in each iteration     *
*      Energy         : the energy of each iteration                   *
*      Line_Search    : logical flag for line search                   *
*      nLambda        : number of constraints                          *
*      iRow_c         : number of lines on the UDC file                *
*      nsAtom         : number of symmetry unique atoms                *
*      AtomLbl        : character string with atom labels              *
*      mxdc           : max number of nsAtom                           *
*      jStab          : integer list of stabilizers                    *
*      nStab          : number of stabilizers                          *
*      BMx            : the so-called Wilson B matrix                  *
*      Smmtrc         : logical flag for symmetry properties           *
*      nDimBC         : dimension of redundant coordinates(?)          *
*      rLambda        : vector for Lagrange multipliers                *
*      Cx             : Cartesian coordinates                          *
*      iNeg           : Hessian index                                  *
*      Labels         : character string of primitive int. coord.      *
*      nLabels        : length of Labels                               *
*      CnstWght       : constraints weight                             *
*                                                                      *
*    OutPut:                                                           *
*      qInt(*,kIter+1): the internal coordinates to be used in the     *
*                       next iteration                                 *
*      UpMeth         : character label with update method abrivation  *
*      ed             : estimated energy change to the next point      *
*      Step_Trunc     : character label to denote truncation type      *
*      GrdMax         : largest gradient component                     *
*      StpMax         : largest step component                         *
*      GrdLbl         : character label of component with GrdMax       *
*      StpLbl         : character label of component with StpLbl       *
*                                                                      *
*                                                                      *
*     Author: Roland Lindh                                             *
*             2000                                                     *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
      Real*8 qInt(nInter,kIter+1), Shift(nInter,kIter),
     &       Grad(nInter,kIter), GNrm(kIter), Energy(kIter),
     &       dMass(nsAtom), BMx(3*nsAtom,3*nsAtom),
     &       rLambda(nLambda,kIter+1), Degen(3*nsAtom), MF(3*nsAtom),
     &       Cx(3*nsAtom,kIter+1)
      Integer jStab(0:7,nsAtom), nStab(nsAtom),
     &        iNeg(2)
*    &        iNeg(2), jNeg(2)
      Logical Line_Search, Smmtrc(3*nsAtom),FindTS, TSC, HrmFrq_Show,
     &        Found, Curvilinear, Kriging_Hessian, First_MicroIteration,
     &        Corrected
      Character Lbl(nLbl)*8, GrdLbl*8, StpLbl*8, Step_Trunc,
     &          Labels(nLabels)*8, AtomLbl(nsAtom)*(LENIN), UpMeth*6,
     &          HUpMet*6, File1*8, File2*8
      Real*8, Allocatable:: Hessian(:,:), Wess(:,:), AMat(:), dg(:),
     &                      RHS(:), ErrVec(:,:), EMtrx(:,:)
      Integer, Allocatable:: Pvt(:), Index(:)
      iRout=153
      iPrint=nPrint(iRout)
      Lu=6
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (Lu,*)'Update_:iOpt_RS,Beta,Beta_Disp=',
     &                     iOpt_RS,Beta,Beta_Disp
      Call RecPrt('Update_: qInt',' ',qInt,nInter,kIter)
      Call RecPrt('Update_: Shift',' ',Shift,nInter,kIter-1)
      Call RecPrt('Update_: GNrm',' ',GNrm,kIter,1)
#endif
*
      GrdMax=Zero
      StpMax=Zero
*
      mInter=nInter
      Step_Trunc='N'
      nA = (Max(mInter,kIter)+1)**2
      Call mma_Allocate(AMat,nA,Label='AMat')
      Call mma_Allocate(dg,mInter,Label='dg')
      Call mma_Allocate(Pvt,kIter+1,Label='Pvt')
      Call mma_Allocate(Index,kIter,Label='Index')
      Call mma_Allocate(ErrVec,mInter,(kIter+1),Label='ErrVec')
      Call mma_Allocate(EMtrx,kIter+1,kIter+1,Label='EMtrx')
      Call mma_Allocate(RHS,kIter+1)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Generate the Hessian in internal coordinates and then update it
*     according to some Hessian update method (BFGS, MSP, etc.)
*
*
      Call mma_Allocate(Hessian,nInter,nInter,Label='Hessian')
      If (Kriging_Hessian) Then
         iOptH_ = iOr(8,iAnd(iOptH,32))
      Else
         Call Mk_Hss_Q()
         iOptH_ = iOptH
      End If
      Call Get_dArray('Hss_Q',Hessian,nInter**2)
*
*     Perform the Hessian update, in case of GEK it essentially will
*     modify the Hessian if it is needed to guide 2nd order
*     optimization towards a minimum or a TS.
*
#ifdef _DEBUGPRINT_
      Write (Lu,*)
      Write (Lu,*)
      Write (Lu,*) ' *** Updating the molecular Hessian ***'
      Write (Lu,*)
#endif
      iRout=154
      jPrint=nPrint(iRout)
      Call Update_H(nWndw,Hessian,nInter,
     &              mIter,iOptC,Mode,MF,
     &              Shift(1,kIter-mIter+1),Grad(1,kIter-mIter+1),
     &              iNeg,iOptH_,HUpMet,nRowH,jPrint,GNrm(kIter),
     &              GNrm_Threshold,nsAtom,IRC,.True.,Corrected)
      If (Corrected) Step_Trunc='#'
*
*     Call RecPrt('Update_sl_: Hessian',' ',Hessian,nInter,nInter)
*     Write (6,*) 'After corrections'
*     Call DiagMtrx(Hessian,nInter,jNeg)
*
*     Save the number of internal coordinates on the runfile.
*
      Call Put_iScalar('No of Internal coordinates',mInter)
*
*     Save the force constant matrix on the runfile.
*
      Call Put_dArray('Hess',Hessian,mInter**2)
*
*     Optional frequency analysis
*
      iDo_dDipM=0
      If (HrmFrq_Show) Call GF_on_the_fly(iDo_DipM)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*---- If this is a constrained optimization with the goal of finding a
*     transition state and we have one negative eigenvalue of the
*     Hessian then shift over to Mode Following RF to find the TS.
*
*     If TSConstraints were given, merge them with global constraints if
*     they exist, unless we are in TS regime.
*     If TS constraints were not given, remove global constraints when in
*     TS regime.
*
      Call qpg_darray('TanVec',Found,nRP)
      If (FindTS.and.First_MicroIteration) Then
         File1='UDC'
         File2='TSC'
         If (.not.TSC) File2=''
         If (iNeg(1).ge.1 ) Then
            If ((GNrm(kIter).le.GNrm_Threshold).or.Found) Then
*              Change to MFRF optimization.
               Mask=1+2+4+8+16+32+64+256+512+1024+2048+8192
               iOptC=iAnd(iOptC,Mask)
               Call Put_lScalar('TS Search',.True.)
               If (TSC) Then
                  File2=''
               Else
                  File1=''
               End If
            End If
         End If
         Call Merge_Constraints(File1,File2,'UDC',nLambda,iRow_c)
         Call Fix_UDC(iRow_c,nLambda,AtomLbl,nsAtom,nStab,.False.)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If ( nLambda.eq.0) Then
         M=3*nsAtom
         N=nInter
         NRHS=1
         Call Allocate_Work(ip_Tmp,M)
*
*        Iterate to avoid too large displacement in cartesians.
*        If the maximum displacement is more than 2*Beta, reduce the step.
*
*        Initial setup to ensure fCart=1.0 at first iteration.
         rInter=Beta
         fCart=Ten
         rCart=fCart*rInter
         nLoop=0
         Do While (rCart.ge.Two*Beta)
            nLoop=nLoop+1
            If (nLoop.gt.10) Exit
            If (rCart.gt.rInter) Then
              fCart=fCart*rInter/rCart
            Else
              fCart=fCart*0.9D0
            End If
            mInter=nInter+nLambda
            nA = (Max(mInter,kIter)+1)**2
*                                                                      *
************************************************************************
*                                                                      *
            gBeta=One
            xBeta=One
            gg_last=Beta
            dxdx_last=Beta
            Sf=Sqrt(Two)
            If (iOpt_RS.eq.0) Then
               kStart=Max(1,kIter-4)
               iEnd=kIter
            Else
               kStart=Max(1,Iter-4)
               iEnd=Iter
            End If
            Thr=1.0D-6
            Do iIter = kStart, iEnd
*
               If (iIter.ne.kIter) Then
                  dxdx=
     &             Sqrt(DDot_(mInter,Shift(1,iIter),1,Shift(1,iIter),1))
*
                  If (dxdx.lt.0.75D0*dxdx_last.and.
     &                dxdx.lt.(Beta-Thr)) Then
*                    Increase trust radius
C                    xBeta=xBeta*Sf
                     xBeta=Min(Two,xBeta*Sf)
                  Else If (dxdx.gt.1.25D0*dxdx_last.or.
     &                     dxdx.ge.(Beta+Thr)) Then
*                    Reduce trust radius
                     xBeta=Max(One/Five,xBeta/Sf)
                  End If
                  dxdx_last=dxdx
               End If
*
               gg=Sqrt(DDot_(nInter-nLambda,Grad(1,iIter),1,
     &                                     Grad(1,iIter),1))
               If (gg.lt.0.75D0*gg_last.and.gg.lt.(Beta-Thr)) Then
*                 Increase trust radius
C                 gBeta=gBeta*Sf
                  gBeta=Min(Two,gBeta*Sf)
               Else If (gg.gt.1.25D0*gg_last.or.gg.ge.(Beta+Thr)) Then
*                 Reduce trust radius
                  gBeta=Max(One/Five,gBeta/Sf)
               End If
               gg_last=gg
*
            End Do
            tBeta= Max(Beta*Min(xBeta,gBeta),Beta/Ten)
C           Write (6,*) 'tBeta=',tBeta
*                                                                      *
************************************************************************
*                                                                      *
*---------- Compute updated geometry in Internal coordinates
*
            fact=One
            qBeta=fCart*tBeta
            Thr_RS=1.0D-7
            Do
               Call Newq(qInt,mInter,kIter,Shift,Hessian,Grad,
     &                   ErrVec,EMtrx,RHS,
     &                   Pvt,dg,AMat,nA,
     &                   ed,iOptC,qBeta,nFix,Index,UpMeth,
     &                   Energy,Line_Search,Step_Trunc,Thr_RS)
               If (Step_Trunc.eq.'N') Step_Trunc=' '
               If (iOpt_RS.eq.0) Exit
*
               qInt(:,kIter+1)=qInt(:,kIter)+Shift(:,kIter)
               Call Dispersion_Kriging_Layer(qInt(1,kIter+1),Disp,
     &                                       nInter)
#ifdef _DEBUGPRINT_
               Write (6,*) 'Disp,Beta_Disp=',Disp,Beta_Disp
#endif
               fact=Half*fact
               qBeta=Half*qBeta
               If ((One-disp/Beta_Disp.gt.1.0D-3)) Exit
               If ((fact.lt.1.0D-5) .or. (disp.lt.Beta_Disp)) Exit
               Step_Trunc='*'
            End Do
#ifdef _DEBUGPRINT_
               Write (6,*) 'Step_Trunc=',Step_Trunc
#endif
*
            Call MxLbls(GrdMax,StpMax,GrdLbl,StpLbl,mInter,
     &                  Grad(1,kIter),Shift(1,kIter),Lbl)
*
*---------- Set shift vector to zero for frozen internal coordinates.
*
            If (nFix.gt.0)
     &         Call dcopy_(nFix,[Zero],0,Shift(iInt+1,kIter),1)
*
*           Rough conversion to Cartesians
*
            Call Eq_Solver('T',M,N,NRHS,BMx,Curvilinear,Degen,
     &                     Shift(1,kIter),Work(ip_Tmp))
            rInter=Sqrt(dDot_(N,Shift(1,kIter),1,Shift(1,kIter),1))
            rCart=Zero
            Do i=ip_Tmp,ip_Tmp+nsAtom-1
               rCart=Max(rCart,
     &                   Sqrt(dDot_(3,Work(i),nsAtom,Work(i),nsAtom)))
            End Do
         End Do
         Call Free_Work(ip_Tmp)
         Call Put_dScalar('Max error',Zero)
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
*        Optimization with constraints using Lagrangian technique.
*
*        Allocate memory for the new arrays
*
         Call Getmem('ipR',   'Allo','Real',ipR,nLambda*kIter)
         Call Getmem('ipdRdq','Allo','Real',ipdRdq,nInter*nLambda*kIter)
         Call Getmem('ipT',   'Allo','Real',ipT,nInter*nInter)
         Call FZero(Work(ipT),nInter**2)
         Call Getmem('ipdy',  'Allo','Real',ipdy,nLambda)
         Call GetMem('dx',    'Allo','Real',ipdx,(nInter-nLambda)*kIter)
         Call FZero(Work(ipdx),(nInter-nLambda)*kIter)
         Call GetMem('dEdq_', 'Allo','Real',ipdEdq_,nInter*kIter)
         Call GetMem('du',    'Allo','Real',ipdu,nInter)
         Call GetMem('x','Allo','Real',ipx,(nInter-nLambda)*(kIter+1))
         Call FZero(Work(ipx),(nInter-nLambda)*(kIter+1))
         Call GetMem('dEdx','Allo','Real',ipdEdx,(nInter-nLambda)*kIter)
         Call mma_allocate(Wess,nInter-nLambda,nInter-nLambda,
     &                     Label='Wess')
         Wess(:,:)=0.0D0
         Call GetMem('Energy','Allo','Real',ipEnergy,kIter)
*
         call dcopy_(kIter,Energy,1,Work(ipEnergy),1)
*
         If (mInter.gt.nLbl) Then
            Call WarningMessage(2,'Update_Sl: mInter.gt.nLbl')
            Write (6,*) 'mInter=',mInter
            Write (6,*) 'nLbl=',nLbl
            Call Abend()
         End If
*
         nBVec=iRow_c-nLambda-1
         If (nBVec.gt.nLabels) Then
            Call WarningMessage(2,'Update_Sl: nBVec.gt.nLabels')
            Write (6,*) 'nBVec=',nBVec
            Write (6,*) 'nLabels=',nLabels
            Call Abend()
         End If
         Call GetMem('dBMx', 'Allo','Real',ipdBMx,nLambda*(3*nsAtom)**2)
         Call GetMem('BMx',  'Allo','Real',ipBMx,3*nsAtom*nLambda)
*
         Call GetMem('BVec', 'Allo','Real',ipBVec,3*nsAtom*nBVec)
         Call GetMem('Value','Allo','Real',ipValue,nBVec)
         Call GetMem('Value0','Allo','Real',ipValue0,nBVec)
         Call GetMem('cInt', 'Allo','Real',ipcInt,nLambda)
         Call GetMem('cInt0','Allo','Real',ipcInt0,nLambda)
         Call GetMem('Mult', 'Allo','Real',ipMult,nBVec**2)
         Call GetMem('iFlip','Allo','Inte',ip_iFlip,nBVec)
         Call GetMem('dBVec','Allo','Real',ipdBVec,nBVec*(3*nsAtom)**2)
*
*        Compute the constraints
*
         n1=3*nsAtom
         n2=n1**2
         ip_drdq=ipdrdq
         Do lIter = 1, kIter
            Call DefInt2(Work(ipBVec),Work(ipdBVec),nBVec,Labels,
     &                   Work(ipBMx),nLambda,nsAtom,iRow_c,
     &                   Work(ipValue),Work(ipcInt),Work(ipcInt0),
     &                   Lbl(nInter+1),AtomLbl,Cx(1,lIter),
     &                   (lIter.eq.kIter).and.First_MicroIteration,
     &                   jStab,nStab,mxdc,
     &                   Work(ipMult),Smmtrc,nDimBC,Work(ipdBMx),
     &                   Work(ipValue0),lIter,iWork(ip_iFlip),dMass)
*
*           Assemble r
*
            iOff = ipr + (lIter-1)*nLambda
            Do j = 0, nLambda-1
               Ci=Work(ipcInt+j)-Work(ipcInt0+j)
               Work(iOff)=Ci
               iOff = iOff + 1
            End Do
*
*           Assemble dr/dq: Solve  B dr/dq = dr/dx
*
            ip_drdq=ipdrdq+(lIter-1)*nInter*nLambda
            Call FZero(Work(ip_drdq),nInter*nLambda)
*           Call RecPrt('BMx',' ',BMx,n1,nInter)
*           Call RecPrt('Work(ipBMx)',' ',Work(ipBMx),n1,nLambda)
*
            M=n1
            N=nInter
            NRHS=nLambda
*
*           Temporary fix of the dC/dx vector which always
*           is propted up with the full degeneracy factor.
*
            If (.NOT.Curvilinear) Then
               Do iLambda=1,nLambda
                  Do i = 1, n1
                     ij = (iLambda-1)*n1 + i -1
                     Work(ij+ipBMx)=Work(ij+ipBMx)/Degen(i)
                  End Do
               End Do
            End If
            LudRdX=30
            Call DaName(LudRdX,'dRdX')
            iAd=0
            Call iDaFile(LudRdX,1,[nLambda],1,iAd)
            Call iDaFile(LudRdX,1,[n1],1,iAd)
            Call dDaFile(LudRdX,1,Work(ipBMx),nLambda*n1,iAd)
            Call DaClos(LudRdX)
            Call Eq_Solver('N',M,N,NRHS,BMx,Curvilinear,Degen,
     &                     Work(ipBMx),Work(ip_drdq))
*           Call RecPrt('drdq',' ',Work(ip_drdq),nInter,nLambda)
*
         End Do     ! lIter
         Call GetMem('dBVec','Free','Real',ipdBVec,nBVec*(3*nsAtom)**2)
         Call GetMem('iFlip','Free','Inte',ip_iFlip,nBVec)
         Call GetMem('Mult', 'Free','Real',ipMult,nBVec**2)
         Call GetMem('cInt0','Free','Real',ipcInt0,nLambda)
         Call GetMem('cInt', 'Free','Real',ipcInt,nLambda)
         Call GetMem('Value0','Free','Real',ipValue0,nBVec)
         Call GetMem('Value','Free','Real',ipValue,nBVec)
         Call GetMem('BVec', 'Free','Real',ipBVec,3*nsAtom*nBVec)
*
         If (iPrint.ge.99) Then
            Call RecPrt('r',' ',Work(ipr),nLambda,kIter)
            Call RecPrt('drdq',' ',Work(ipdrdq),nInter*nLambda,kIter)
            Call RecPrt('dC/dx',' ',Work(ipBMx),n1,nLambda)
            Call RecPrt('dQ/dx',' ',BMx,n1,nInter)
            Do i = 1, nLambda
               jpx=ipdBMx+(i-1)*n2
               Write (6,*) ' iLambda=',i
               Call RecPrt('d2C/dx2',' ',Work(jpx),n1,n1)
            End Do
            If (Curvilinear) Call dBPrint(nInter,nDimBC)
         End If
         Call GetMem('BMx',  'Free','Real',ipBMx,3*nsAtom*nLambda)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- Assemble d^2C/dQ^2
*
*        The expression is written as
*
*        dQ/dx * d^2C/dQ^2 * dQ/dx = d^2C/dx^2 - Sum (d^2Q/dx^2 * dC/dQ)
*
*        Solve first for y in
*                dQ/dx y = d^2C/dx^2 - Sum (d^2Q/dx^2 x dC/dQ)
*
#ifdef _NEW_CODE_
*        Compute Sum (d^2Q/dx^2 * dC/dQ)
*
         Call GetMem('d2Qdx2_dCdQ','Allo','Real',ip_QC,
     &                nDimBC**2*nLambda)
         If (Curvilinear)
     &      Call dBMult(Work(ip_drdq),Work(ip_QC),nInter,nDimBC,nLambda)
         Call RecPrt('Work(ip_drdq)',' ',Work(ip_drdq),n1,1)
         Call RecPrt('Work(ip_QC)',' ',Work(ip_QC),nDimBC**2,nLambda)
*
*        Subtract the term d^2C/dx^2
*
         Do k = 1, nLambda
            j = 0
            Do jx = 1, n1
               If (Smmtrc(jx)) Then
                  j = j + 1
*
                  i=0
                  Do ix = 1, n1
                     If (Smmtrc(ix)) Then
                        i = i + 1
                        ijk = (k-1)*n2 + (jx-1)*n1 + ix-1 + ipdBMx
                        ijk1= (k-1)*nDimBC**2 + (j-1)*nDimBC
     &                      + i-1 + ip_QC
                        Work(ijk) = Work(ijk) - Work(ijk1)
                     End If
                  End Do
               End If
            End Do
         End Do
         Call Free_Work(ip_QC)
#endif
*
         Call GetMem('Scr2','Allo','Real',ipScr2,nInter*n1*nLambda)
         Call GetMem('Scr1','Allo','Real',ipScr1,nInter*n1*nLambda)
*        Call RecPrt('d^2C/dx^2',' ',Work(ipdBMx),n2,nLambda)
*
*        Temporary fix of the d^2C/dx^2 vector which always
*        is propted up with the full degeneracy factor.
*
         If (.NOT.Curvilinear) Then
            Do k = 1, nLambda
               Do j = 1, n1
                  Do i = 1, n1
                     ijk = (k-1)*n2 + (j-1)*n1 + i-1 + ipdBMx
                     Work(ijk)=Work(ijk)/(Degen(i)*Degen(j))
                  End Do
               End Do
            End Do
         End If
*
         M=3*nsAtom
         N=nInter
         NRHS=n1*nLambda
*        Call RecPrt('dQ/dx',' ',BMx,n1,nInter)
         Call Eq_Solver('N',M,N,NRHS,BMx,Curvilinear,Degen,
     &                  Work(ipdBMx),Work(ipScr1))
         Call GetMem('dBMx', 'Free','Real',ipdBMx,nLambda*(3*nsAtom)**2)
         Call TRNSPS(nInter,n1*nLambda,Work(ipScr1),Work(ipScr2))
*        Call RecPrt('Scr1',' ',Work(ipScr2),n1*nLambda,nInter)
*
*        Followed by solve for x in B x = y^T for which x = d^2r/dq^2
*
         M=3*nsAtom
         N=nInter
         NRHS=nLambda*nInter
         Call Eq_Solver('N',M,N,NRHS,BMx,Curvilinear,Degen,
     &                  Work(ipScr2),Work(ipScr1))
         Call Free_Work(ipScr2)
         Call GetMem('d2L','Allo','Real',ipd2L,nInter*nInter*nLambda)
         Call TRNSPS(nInter*nLambda,nInter,Work(ipScr1),Work(ipd2L))
         Call Free_Work(ipScr1)
*        Call RecPrt('ipd2L',' ',Work(ipd2L),nInter**2,nLambda)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- Compute updated geometry in Internal coordinates
*
         Mode_=0
         M=3*nsAtom
         N=nInter
         NRHS=1
         Call Allocate_Work(ip_Tmp,M)
*
*        Iterate to avoid too large displacement in cartesians.
*        If the maximum displacement is more than 2*Beta, reduce the step.
*
*        Initial setup to ensure fCart=1.0 at first iteration.
         Thr_RS=1.0D-7
         rInter=Beta
         fCart=Ten
         rCart=fCart*rInter
         nLoop=0
         Do While (rCart.ge.Two*Beta)
            nLoop=nLoop+1
            If (nLoop.gt.100) Exit
            If (rCart.gt.rInter) Then
              fCart=fCart*rInter/rCart
            Else
              fCart=fCart*0.9D0
            End If
            qBeta=fCart*Beta
            Call Con_Opt(Work(ipr),Work(ipdrdq),Work(ipT),Grad,
     &                rLambda,qInt,Shift,Work(ipdy),Work(ipdx),
     &                Work(ipdEdq_),Work(ipdu),Work(ipx),Work(ipdEdx),
     &                Wess,GNrm(kIter),
     &                nWndw,Hessian,nInter,kIter,
     &                iOptC,Mode_,MF,iOptH_,HUpMet,jPrint,
     &                Work(ipEnergy),nLambda,mIter,nRowH,
     &                ErrVec,EMtrx,RHS,Pvt,
     &                dg,AMat,nA,ed,qBeta,qBeta_Disp,nFix,
     &                Index,UpMeth,Line_Search,Step_Trunc,Lbl,
     &                GrdLbl,StpLbl,GrdMax,StpMax,Work(ipd2L),nsAtom,
     &                IRC,CnstWght,iOpt_RS,Thr_RS,iter)
            If (iOpt_RS.eq.1) Exit
*
*           Rough conversion to Cartesians
*
            Call Eq_Solver('T',M,N,NRHS,BMx,Curvilinear,Degen,
     &                     Shift(1,kIter),Work(ip_Tmp))
            rInter=Sqrt(dDot_(N,Shift(1,kIter),1,Shift(1,kIter),1))
            rCart=Zero
            Do i=ip_Tmp,ip_Tmp+nsAtom-1
               rCart=Max(rCart,
     &                   Sqrt(dDot_(3,Work(i),nsAtom,Work(i),nsAtom)))
            End Do
         End Do
         Call Free_Work(ip_Tmp)
*
         If (iPrint.ge.99) Then
            Write (Lu,*)
            Write (Lu,*) '********************************************'
            Write (Lu,*) '* Lagrange multipliers for the constraints *'
            Write (Lu,*) '********************************************'
            Write (Lu,'(1X,A,2X,ES13.6)')
     &          (Lbl(nInter+iInt),-One*rLambda(iInt,mIter),
     &           iInt=1,nLambda)
            Write (Lu,*)
         End If
*
         Call Free_Work(ipd2L   )
         Call Free_Work(ipEnergy)
         Call mma_Deallocate(Wess)
         Call Free_Work(ipdEdx  )
         Call Free_Work(ipx     )
         Call Free_Work(ipdu    )
         Call Free_Work(ipdEdq_ )
         Call Free_Work(ipdx    )
         Call Free_Work(ipdy    )
         Call Free_Work(ipT     )
         Call Free_Work(ipdrdq  )
         Call Free_Work(ipr     )
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_Deallocate(Hessian)
      Call mma_Deallocate(RHS)
      Call mma_Deallocate(EMtrx)
      Call mma_Deallocate(ErrVec)
      Call mma_Deallocate(Index)
      Call mma_Deallocate(Pvt)
      Call mma_Deallocate(dg)
      Call mma_Deallocate(AMat)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DistMemChck(PosV1,PosV2,PosV3,PosT)
! Dimensions for DistMemCheck
! dimensions: V1 - no*nv*nv2, nv2*nv2
!             V2 - nc*nv2
!             V3 - nc*nv*no

use Index_Functions, only: nTri_Elem
use chcc_global, only: nc, no, nv, PosFree
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: PosV1, PosV2, PosV3, PosT
integer(kind=iwp) :: len_

PosT = PosFree

PosV1 = PosT
len_ = no*nv*nTri_Elem(nv)
if (nTri_Elem(nv)**2 > len_) len_ = nTri_Elem(nv)**2
PosT = PosT+len_

PosV2 = PosT
len_ = nc*nTri_Elem(nv)
PosT = PosT+len_

PosV3 = PosT
len_ = nc*no*nv

PosT = PosT+len_

write(u6,*) ' Pos ChCk',PosV1,PosV2,PosV3,PosT

return

end subroutine DistMemChck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Routine for the case where both centres are diffuse. Since these
! formulas are pretty nasty and apparently with little general
! structure, each type of interaction is hard-coded.
subroutine ABBoth(iLA,iLB,dMulA,dKappa,Rho,RhoA,RhoB,Rinv,lTooSmall,Colle)

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

! Maximum multipole implemented
#define _MxM_ 2

implicit none
integer(kind=iwp), intent(in) :: iLA, iLB
real(kind=wp), intent(in) :: dMulA(nTri_Elem1(_MxM_)), dKappa, Rho, RhoA, RhoB, Rinv
logical(kind=iwp), intent(in) :: lTooSmall
real(kind=wp), intent(out) :: Colle(3)
real(kind=wp) :: Ex, ExA, ExB, Pi1, Pi2, Sigma, Width
real(kind=wp), external :: CoulT0_1, CoulT0_2, CoulT0_4, CoulT0_5, CoulTN_1, CoulTN_2, CoulTN_4, CoulTN_5
#include "warnings.h"

! To calculate the interaction Sigma is the product of both multipoles
! in A and in B but since we need potential, field and field gradient
! for the QM system whe do not multiply for multipoles in B, but we
! have to take into account to move the result for the original
! coordinate system in QmStat.

Colle(:) = Zero

if ((iLA == 0) .and. (iLB == 0)) then
  ! s-s interaction. There is only sigma-components, hence simple.

  Sigma = dMulA(1)
  if (lTooSmall) then
    Ex = exp(-Two*Rho)
    Colle(1) = Sigma*CoulT0_1(Rho,Rinv,Ex)
  else
    ExA = exp(-Two*RhoA)
    ExB = exp(-Two*RhoB)
    Colle(1) = Sigma*CoulTN_1(RhoA,RhoB,dKappa,Rinv,ExA,ExB)
  end if

else if ((iLA == 1) .and. (iLB == 0)) then
  ! s-p interaction. Only the z-component of the dipole interacts
  ! through a sigma-interaction with the s-distribution. Observe
  ! that in the case that iLA > iLB, then the formulas by Roothan
  ! has to be reversed, i.e. RhoA and RhoB change place and
  ! Kappa changes sign.

  Sigma = dMulA(3)
  if (lTooSmall) then
    Ex = exp(-Two*Rho)
    Colle(1) = Sigma*CoulT0_2(Rho,Rinv,Ex)
  else
    ExA = exp(-Two*RhoA)
    ExB = exp(-Two*RhoB)
    Colle(1) = Sigma*CoulTN_2(RhoB,RhoA,-dKappa,Rinv,ExB,ExA)
  end if
else if ((iLA == 0) .and. (iLB == 1)) then
  Sigma = dMulA(1)
  if (lTooSmall) then
    Ex = exp(-Two*Rho)
    Colle(1) = Sigma*CoulT0_2(Rho,Rinv,Ex)
  else
    ExA = exp(-Two*RhoA)
    ExB = exp(-Two*RhoB)
    Colle(1) = Sigma*CoulTN_2(RhoA,RhoB,dKappa,Rinv,ExA,ExB)
  end if

else if ((iLA == 1) .and. (iLB == 1)) then
  ! p-p interaction. The z-z combination gives a sigma-interaction,
  ! and the x-x and y-y combinations give pi-interactions.

  ! The sigma-component.

  Sigma = dMulA(3)
  if (lTooSmall) then
    Ex = exp(-Two*Rho)
    Colle(1) = Sigma*CoulT0_4(Rho,Rinv,Ex)
  else
    ExA = exp(-Two*RhoA)
    ExB = exp(-Two*RhoB)
    Colle(1) = Sigma*CoulTN_4(RhoA,RhoB,dKappa,Rinv,ExA,ExB)
  end if

  ! The two pi-components.

  Pi1 = dMulA(1)
  Pi2 = dMulA(2)
  if (lTooSmall) then
    Ex = exp(-Two*Rho)
    Width = CoulT0_5(Rho,Rinv,Ex)
    Colle(2) = Pi1*Width
    Colle(3) = Pi2*Width
  else
    ExA = exp(-Two*RhoA)
    ExB = exp(-Two*RhoB)
    Width = CoulTN_5(RhoA,RhoB,dKappa,Rinv,ExA,ExB)
    Colle(2) = Pi1*Width
    Colle(3) = Pi2*Width
  end if

else
  ! Higher angular momentum interactions.

  write(u6,*) 'Too high angular momentum'
  write(u6,*) 'at least you start to implement.'
  call Quit(_RC_IO_ERROR_READ_)
end if

return

end subroutine ABBoth

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_TrcIdl_Update(IAmIdle)
C
C     Thomas Bondo Pedersen, May 2010.
C
C     Update array for tracing idle processors
C
      Implicit None
      Logical IAmIdle
#include "choptr2.fh"
#include "cho_para_info.fh"
#include "WrkSpc.fh"
#if defined (_DEBUGPRINT_)
#include "cholesky.fh"
#endif

#if defined (_DEBUGPRINT_)
      If (l_Idle.lt.1 .or. .not.Trace_Idle) Then
         Write(LuPri,'(A)')
     &   'Cho_TrcIdl_Update should not be called in this run!'
         Write(LuPri,*) 'Trace_Idle=',Trace_Idle
         Write(LuPri,'(A,2I10)')
     &   'ip_Idle,l_Idle=',ip_Idle,l_Idle
         Call Cho_Quit('Illegal call to Cho_TrcIdl_Update',103)
      End If
#endif

      If (IAmIdle) Then
         If (Cho_Real_Par) Then
            iWork(ip_Idle+myRank)=iWork(ip_Idle+myRank)+1
         Else
            iWork(ip_Idle)=iWork(ip_Idle)+1
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Per Ake Malmqvist                                *
!               1989, Bjorn O. Roos                                    *
!               1991,1993, Markus P. Fuelscher                         *
!               1991,1993, Jeppe Olsen                                 *
!               1998, Roland Lindh                                     *
!               2016, Andrew M. Sand                                   *
!               2024, Matthew R. Hennefarth                            *
!***********************************************************************

subroutine mcpdft(ireturn)

use Fock_util_global, only: DoCholesky
use timers, only: TimeInput, TimeOutput, TimeTotal, TimeTrans
use write_pdft_job, only: writejob
use PrintLevel, only: DEBUG, INSANE, TERSE
use mcpdft_output, only: iPrLoc
use mcpdft_input, only: mcpdft_options, parse_input
use mspdft_util, only: replace_diag
use mspdft, only: heff, mspdft_init, mspdft_finalize
use wadr, only: FockOcc
use general_data, only: nelec3, nhole1, ntot1, ntot2
use rasscf_global, only: ExFac, IPR, lRoots, lSquare, NACPR2, nFint
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iReturn
#include "warnings.h"
integer(kind=iwp) :: iPrLev, iRC, state
logical(kind=iwp) :: dscf
real(kind=wp) :: dum1, dum2, dum3, time1(2), time2(2)
character(len=8) :: Method
real(kind=wp), allocatable :: cmo(:), D1A(:), D1I(:), e_mcscf(:), e_states(:), FA(:), FI(:), PUVX(:), tuvx(:)

call StatusLine('MCPDFT:',' Just started.')
IRETURN = _RC_ALL_IS_WELL_

! Local print level in this routine:
IPRLEV = IPRLOC(1)

! Default option switches and values, and initial data.
call mcpdft_init()

call parse_input()

! Local print level in this routine:
IPRLEV = IPRLOC(1)

call open_files_mcpdft(DSCF)

! Some preliminary input data:
call Rd1Int()
if (.not. DSCF) call Rd2Int_RASSCF()

! Process the input:
call Proc_InpX(DSCF,iRc)

! Delayed checks
! (This should be in mcpdft_init, but nhole1, nelec3 are set in proc_inpx)
if (mcpdft_options%grad) then
  if ((nhole1 > 0) .or. (nelec3 > 1)) then
    call WarningMessage(2,'MC-PDFT gradients with a RASSCF wave function not supported')
    write(u6,*) ' ************* ERROR **************'
    write(u6,*) ' MC-PDFT gradients are not         '
    write(u6,*) ' implemented with RASSCF           '
    write(u6,*) ' **********************************'
    call Quit_OnUserError()
  end if
end if

! If something goes wrong in proc_inp:
if (iRc /= _RC_ALL_IS_WELL_) then
  if (IPRLEV >= TERSE) then
    call WarningMessage(2,'Input processing failed.')
    write(u6,*) ' MC-PDFT Error: Proc_Inp failed unexpectedly.'
  end if
  IRETURN = iRc
  return
end if

! Local print level may have changed:
IPRLEV = IPRLOC(1)

if (mcpdft_options%mspdft) call mspdft_init()

call InpPri_m()

! Get start orbitals
call mma_allocate(CMO,NTOT2,Label='CMO')
call ReadVc_m(CMO)

! Allocate core space for dynamic storage of data
! Really just determine size of 2-e integrals
call ALLOC()

call Timing(dum1,dum2,time1(1),dum3)
TimeInput = time1(1)

! This needs to be put somehwere else...
call mma_allocate(FockOcc,nTot1,Label='FockOcc')

! - Read in the CASSCF Energy from JOBIPH file.
call mma_allocate(e_mcscf,lroots,Label='e_mcscf')
e_mcscf(:) = Zero
call ref_energy(e_mcscf,lroots)

! Transform two-electron integrals and compute at the same time
! the Fock matrices FI and FA
call Timing(dum1,dum2,time2(1),dum3)

! so this does 2 things, first it puts the integrals
! into the file LUINTM, the second is that we write
! the integrals to the runfile anyways for mspdft grad

if (mcpdft_options%grad .and. mcpdft_options%mspdft) then
  call mma_allocate(D1I,NTOT2,Label='D1I')
  call mma_allocate(D1A,NTOT2,Label='D1A')
  call mma_allocate(FI,NTOT1,Label='FI')
  call mma_allocate(FA,NTOT1,Label='FA')
  call mma_allocate(puvx,nfint,label='PUVX')
  call mma_allocate(TUVX,NACPR2,Label='TUVX')
  D1I(:) = Zero
  D1A(:) = Zero
  IPR = 0
  if (IPRLOC(2) == DEBUG) IPR = 5
  if (IPRLOC(2) == INSANE) IPR = 10
  call TRACTL2(CMO,PUVX,TUVX,D1I,FI,D1A,FA,IPR,lSquare,ExFac)
  call Put_dArray('TwoEIntegral',PUVX,nFINT)
  call mma_deallocate(PUVX)
  call mma_deallocate(FI)
  call mma_deallocate(FA)
  call mma_deallocate(TUVX)
  call mma_deallocate(D1I)
  call mma_deallocate(D1A)
end if

call Timing(dum1,dum2,time2(2),dum3)
TimeTrans = TimeTrans+time2(2)-time2(1)

! This is where MC-PDFT actually computes the PDFT energy for each state
! only after 500 lines of nothing above...
call mma_allocate(e_states,lroots,label='e_states')
call compute_mcpdft_energy(CMO,e_mcscf,e_states)
call mma_deallocate(CMO)

call Timing(dum1,dum2,time1(1),dum3)

! pdft energy now stored in e_states

if (mcpdft_options%wjob .and. (.not. mcpdft_options%mspdft)) call writejob(e_states,lroots)

if (mcpdft_options%mspdft) then
  Method = 'MSPDFT'
  call replace_diag(heff,e_states,lroots)
  call mspdft_finalize(lroots)
else
  Method = 'MCPDFT'
  ! The following put_* calls should be combined with the MS-PDFT
  ! ones if a gradient call is initiated...
  call put_darray('Last energies',e_states,lroots)
  if (mcpdft_options%grad) then
    call put_dscalar('Last energy',e_states(mcpdft_options%rlxroot))
    call put_iscalar('Relax CASSCF root',mcpdft_options%rlxroot)
    call put_carray('MCLR Root','****************',16)
  end if
  if (iprlev >= TERSE) then
    do state=1,lroots
      call PrintResult(u6,'(6X,A,I3,A,F16.8)','MCPDFT root number',state,' Total energy:',[e_states(state)],1)
    end do
  end if
end if
if ((nhole1 > 0) .or. (nelec3 > 0)) Method(7:8) = '-R'
call Put_cArray('Relax Method',Method,8)

!***********************************************************************
!*****************         Closing up MC-PDFT        *******************
!***********************************************************************

! release SEWARD
call ClsSew()

! Finalize Cholesky information if initialized
if (DoCholesky) then
  call Cho_X_Final(irc)
  if (irc /= 0) then
    write(u6,*) 'MC-PDFT: Cho_X_Final fails with return code ',irc
    write(u6,*) ' Try to recover. Calculation continues.'
  end if
end if

! Release  some memory allocations
call mma_deallocate(FockOcc)
call mma_deallocate(e_mcscf)
call mma_deallocate(e_states)

call StatusLine('MCPDFT:','Finished.')
if (IPRLEV >= 2) write(u6,*)

call Timing(dum1,dum2,time1(2),dum3)
TimeTotal = time1(2)
TimeOutput = TimeOutput+time1(2)-time1(1)
if (IPRLEV >= 3) then
  call PrtTim()
  call FastIO('STATUS')
end if

call close_files_mcpdft()

end subroutine mcpdft

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_maxDG(SDG,nnSkal,MxBasSh)
************************************************************************
*     Compute Sqrt(Abs( (mu,nu|mu,nu) ) )                              *
*     Make a list of the largest such element for each shell-pair      *
*     Store in SDG.                                                    *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Integer nnSkal, MxBasSh
      Real*8 SDG(nnSkal)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      iRS2F(i,j) = iWork(ip_iRS2F-1+2*(j-1)+i)
      ISOSHL(I) = IWORK(ip_iSOShl-1+I)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
*                                                                      *
************************************************************************
*                                                                      *
      Call FZero(SDG(1),nnSkal)
*
      iLoc=1 ! point to 1st reduced set in index arrays
      CALL GETMEM('diagI','Allo','Real',ipDIAG,NNBSTRT(iLoc))
*
*     Read the diagonal of the integrals, (mu,nu|mu,nu)
*
      CALL CHO_IODIAG(Work(ipDIAG),2)
*
      Do jSym=1,nSym
*
         Do jRab=1,nnBstR(jSym,iLoc)
*
            kRab = iiBstr(jSym,iLoc) + jRab ! already in 1st red set
*
            iag   = iRS2F(1,kRab)  !global address
            ibg   = iRS2F(2,kRab)
*
            iaSh = iSOShl(iag) ! shell to which it belongs
            ibSh = iSOShl(ibg)
*
            iabSh= iTri(iaSh,ibSh)
*
            SDG(iabSh)= Max(SDG(iabSh),sqrt(abs(Work(ipDIAG+kRab-1))))
*
         End Do  ! jRab loop
      End Do
*
      CALL GETMEM('diagI','Free','Real',ipDIAG,NNBSTRT(1))
*
      MxBasSh = MxOrSh
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Roland Lindh                                     *
!***********************************************************************

subroutine Set_Breit(n)

use Breit, only: nOrdOp, nComp
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n

nOrdOp = n
if (nOrdOp == 0) then
  nComp = 1
else
  nComp = 6
end if

end subroutine Set_Breit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine orthcvb_cvb(c,nparm1)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension c(*)

      ioffs=nparm1-nprvb+1
      if(nfrag.le.1)then
        call daxpy_(nprvb,-ddot_(nprvb,work(lv(2)),1,c(ioffs),1)/cvbnrm,
     >    work(lv(2)),1,c(ioffs),1)
      else
        ifr_off=0
        do 100 ifrag=1,nfrag
        call daxpy_(nvb_fr(ifrag),
     >    -ddot_(nvb_fr(ifrag),work(ifr_off+lv(2)),1,c(ifr_off+ioffs),1)
     >    /cvbnrm_fr(ifrag),
     >   work(ifr_off+lv(2)),1,c(ifr_off+ioffs),1)
        ifr_off=ifr_off+nvb_fr(ifrag)
100     continue
      endif
      return
      entry orthcvb_init_cvb()
      if(nfrag.le.1)then
        cvbnrm=ddot_(nvb,work(lv(2)),1,work(lv(2)),1)
      else
        ifr_off=0
        do 200 ifrag=1,nfrag
        cvbnrm_fr(ifrag)=ddot_(nvb_fr(ifrag),work(ifr_off+lv(2)),1,
     >    work(ifr_off+lv(2)),1)
        ifr_off=ifr_off+nvb_fr(ifrag)
200     continue
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  CD_Tester
*
*> @brief
*>   Test the decomposition modules
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Runs and tests the output from the general Cholesky decomposers
*> ::ChoDec (out-of-core) and ::CD_InCore (in-core). The positive
*> definite matrix to which \p ip_PDM points should be stored as a
*> lower triangle.
*>
*> Error codes:
*> - \p irc = ``-1``: \p n non-positive (&rarr; nothing done)
*> - \p irc =  ``0``: all OK
*> - \p irc =  ``1``: error in ::ChoDec
*> - \p irc =  ``2``: error in ::CD_InCore
*> - \p irc =  ``3``: error in both
*>
*> @param[out] irc     Return code
*> @param[in]  PDM     matrix in \p Work
*> @param[in]  n       Dimension of matrix (\p n &times; \p n)
*> @param[in]  Verbose Print flag
************************************************************************
      SubRoutine CD_Tester(irc,PDM,n,Verbose)
      use CDTHLP
      Implicit Real*8 (a-h,o-z)

      Integer irc, n
      Real*8 PDM(n*(n+1)/2)
      External CD_Tester_Col
      External CD_Tester_Vec
      Logical  Verbose

      Character(LEN=9), Parameter:: SecNam = 'CD_Tester'

      Logical Restart
      Real*8, Allocatable:: Diag(:), Buf(:), Qual(:), ES(:)
      Integer, Allocatable:: Pivot(:), iQual(:)

#include "stdalloc.fh"

      irc = 0
      If (n .lt. 1) Then
         If (Verbose) Then
            Write(6,*) SecNam,': nothing tested! Dimension is: n = ',n
            Call xFlush(6)
         End If
         Go To 1
      End If

C     Test ChoDec.
C     ============

      Restart = .false.
      Thr     = 1.0d-12
      Span    = 1.0d-2
      MxQual  = max(n/10,1)
      NumCho  = 0

      irc_sav = irc
      If (Verbose) Then
         Write(6,*)
         Write(6,*) '          >>>>>>>>>>>><<<<<<<<<<<<'
         Write(6,*) '          >>>> Testing ChoDec <<<<'
         Write(6,*) '          >>>>>>>>>>>><<<<<<<<<<<<'
         Write(6,*)
         Call xFlush(6)
      End If

      Call mma_allocate(Mat,n*n,Label='Mat')
      Call mma_allocate(Vec,n*n,Label='Vec')

      l_Buf   = n*(n+MxQual)
      l_Qual  = n*(MxQual+1)
      l_ES    = 6
      l_Pivot = n
      l_iQual = MxQual

      Call mma_allocate(Buf,l_Buf,Label='Buf')
      Call mma_allocate(Diag,n,Label='Diag')
      Call mma_allocate(Qual,l_Qual,Label='Qual')
      Call mma_allocate(ES,l_ES,Label='ES')
      Call mma_allocate(Pivot,l_Pivot,Label='Pivot')
      Call mma_allocate(iQual,l_iQual,Label='iQual')

      Call CD_Tester_CPPF(PDM,Mat,n)
      Call CD_Tester_Diag(PDM,Diag,n)
      jrc = 0
      Call ChoDec(CD_Tester_Col,CD_Tester_Vec,
     &            Restart,Thr,Span,MxQual,
     &            Diag,Qual,Buf,Pivot,iQual,
     &            n,l_Buf,ES,NumCho,jrc)
      If (jrc .eq. 0) Then
         Call DGEMM_('N','T',n,n,NumCho,
     &              -1.0d0,Vec,n,
     &                     Vec,n,
     &               1.0d0,Mat,n)
         Call CD_Tester_ES(Mat,n,ES)
         Call CD_Tester_Diff(Mat,n,ES(4))
         Call CD_Tester_Final(jrc,NumCho,n,Thr,ES,Verbose)
         If (jrc .ne. 0) Then
            irc = irc + 1
         End If
      Else
         If (Verbose) Then
            Write(6,*) SecNam,': ChoDec returned error code ',jrc
            Write(6,*) '<=> decomposition failed, no test performed!'
            Call xFlush(6)
         End If
         irc = irc + 1
      End If
      If (Verbose) Then
         If (irc .eq. irc_sav) Then
            Write(6,*) 'ChoDec succeeded....'
         Else
            Write(6,*) 'ChoDec failed....'
         End If
         Call xFlush(6)
      End If

C     Test in-core decomposition.
C     ===========================

      If (Verbose) Then
         irc_sav = irc
         Write(6,*)
         Write(6,*) '          >>>>>>>>>>>><<<<<<<<<<<<<<<'
         Write(6,*) '          >>>> Testing CD_InCore <<<<'
         Write(6,*) '          >>>>>>>>>>>><<<<<<<<<<<<<<<'
         Write(6,*)
         Call xFlush(6)
      End If

      Call CD_Tester_CPPF(PDM,Mat,n)
      jrc    = 0
      NumCho = 0
      Call CD_InCore(Mat,n,Vec,n,NumCho,Thr,jrc)
      If (jrc .eq. 0) Then
         Call CD_Tester_CPPF(PDM,Mat,n)
         Call DGEMM_('N','T',n,n,NumCho,
     &              -1.0d0,Vec,n,
     &                     Vec,n,
     &               1.0d0,Mat,n)
         Call CD_Tester_ES(Mat,n,ES)
         Call CD_Tester_Diff(Mat,n,ES(4))
         Call CD_Tester_Final(jrc,NumCho,n,Thr,ES,Verbose)
         If (jrc .ne. 0) Then
            irc = irc + 2
         End If
      Else
         If (Verbose) Then
            Write(6,*) SecNam,': CD_InCore returned error code ',jrc
            Write(6,*) '<=> decomposition failed, no test performed!'
            Call xFlush(6)
         End If
         irc = irc + 2
      End If
      If (Verbose) Then
         If (irc .eq. irc_sav) Then
            Write(6,*) 'CD_InCore succeeded....'
         Else
            Write(6,*) 'CD_InCore failed....'
         End If
         Write(6,*)
         Call xFlush(6)
      End If

      Call mma_deallocate(iQual)
      Call mma_deallocate(Pivot)
      Call mma_deallocate(ES)
      Call mma_deallocate(Qual)
      Call mma_deallocate(Diag)
      Call mma_deallocate(Buf)
      Call mma_deallocate(Vec)
      Call mma_deallocate(Mat)

    1   Continue
      End SubRoutine CD_Tester

      SubRoutine CD_Tester_Col(Col,nDim,iCol,nCol,Buf,lBuf)
      use CDTHLP, only: Mat
*     Implicit None
      Integer nDim, nCol, lBuf
      Real*8 Col(nDim,nCol), Buf(lBuf)
      Integer iCol(nCol)

      Integer i, kOff

      Do i = 1,nCol
         kOff = 1 + nDim*(iCol(i) - 1)
         Call dCopy_(nDim,Mat(kOff),1,Col(1,i),1)
      End Do

      Return
#ifdef _WARNING_WORKAROUND_
C Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Buf)
      End if
#endif
      End SubRoutine CD_Tester_Col

      SubRoutine CD_Tester_Vec(iVec1,nVec,Buf,lBuf,nDim,iOpt)
      use CDTHLP, only: Vec
      Implicit None
      Integer iVec1, nVec, lBuf, nDim, iOpt
      Real*8 Buf(lBuf)

      Integer kOff, lTot

      Character*13 SecNam
      Parameter (SecNam = 'CD_Tester_Vec')

      If (iOpt .eq. 1) Then
         kOff = 1 + nDim*(iVec1 - 1)
         lTot = nDim*nVec
         Call dCopy_(lTot,Buf,1,Vec(kOff),1)
      Else If (iOpt .eq. 2) Then
         kOff = 1 + nDim*(iVec1 - 1)
         lTot = nDim*nVec
         Call dCopy_(lTot,Vec(kOff),1,Buf,1)
      Else
         Write(6,*)
         Write(6,*) 'WARNING! WARNING! WARNING! WARNING!'
         Write(6,*) SecNam,': illegal option: iOpt = ',iOpt
         Write(6,*) 'WARNING! WARNING! WARNING! WARNING!'
         Write(6,*)
         Call xFlush(6)
      End If

      End SubRoutine CD_Tester_Vec
C
      SubRoutine CD_Tester_CPPF(PDM,X,n)
      Implicit None
      Integer n
      Real*8  PDM(n*(n+1)/2), X(n,n)

      Integer i, j, iTri
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2+i+j

      Do j = 1,n
         X(j,j) = PDM(iTri(j,j))
         Do i = j+1,n
            X(i,j) = PDM(iTri(i,j))
            X(j,i) = X(i,j)
         End Do
      End Do

      End SubRoutine CD_Tester_CPPF
C
      SubRoutine CD_Tester_Diag(PDM,Diag,n)
      Implicit None
      Integer n
      Real*8  PDM(n*(n+1)/2), Diag(n)

      Integer i, ii

      Do i = 1,n
         ii = i*(i-3)/2 + 2*i
         Diag(i) = PDM(ii)
      End Do

      End SubRoutine CD_Tester_Diag
C
      SubRoutine CD_Tester_Diff(X,n,Err)
      Implicit None
      Integer n
      Real*8  X(n*n), Err(3)

      Integer i
      Real*8  xn2

      If (n .lt. 1) Then
         Err(1) =  9.876543210d15
         Err(2) = -9.876543210d15
         Err(3) =  9.876543210d15
      Else
         Err(1) = x(1)
         Err(2) = x(1)
         Err(3) = x(1)*x(1)
         Do i = 2,n*n
            Err(1) = min(Err(1),x(i))
            Err(2) = max(Err(2),x(i))
            Err(3) = Err(3) + x(i)*x(i)
         End Do
         xn2 = dble(n)*dble(n)
         Err(3) = Err(3)/xn2
      End If

      End SubRoutine CD_Tester_Diff
C
      SubRoutine CD_Tester_Final(irc,NumCho,n,Thr,Err,Verbose)
      Implicit None
      Integer irc, NumCho, n
      Real*8  Thr, Err(6)
      Logical Verbose

      Character*15 SecNam
      Parameter (SecNam = 'CD_Tester_Final')

      irc = 0

      If (Verbose) Then
         Write(6,*)
         Write(6,*) 'Final results from ',SecNam,':'
         Write(6,*) 'Matrix dimension: ',n
         Write(6,*) 'Number of vecs. : ',NumCho
         Write(6,*) 'Threshold       : ',Thr
         Write(6,*) 'Min. Diag. err. : ',Err(1)
         Write(6,*) 'Max. Diag. err. : ',Err(2)
         Write(6,*) 'RMS  Diag. err. : ',Err(3)
         Write(6,*) 'Min. Matr. err. : ',Err(4)
         Write(6,*) 'Max. Matr. err. : ',Err(5)
         Write(6,*) 'RMS  Matr. err. : ',Err(6)
      End If

      If (NumCho.lt.0 .or. NumCho.gt.n) Then
         irc = -1
         If (Verbose) Then
            Write(6,*) '>>> NumCho out of bounds!'
         End If
         Return
      End If

      If (abs(Err(1)) .gt. Thr) Then
         irc = irc + 1
         If (Verbose) Then
            Write(6,*) '>>> LARGE MINIMUM DIAGONAL ERROR: ',Err(1)
         End If
      End If
      If (abs(Err(2)) .gt. Thr) Then
         irc = irc + 1
         If (Verbose) Then
            Write(6,*) '>>> LARGE MAXIMUM DIAGONAL ERROR: ',Err(2)
         End If
      End If
      If (abs(Err(3)) .gt. Thr) Then
         irc = irc + 1
         If (Verbose) Then
            Write(6,*) '>>> LARGE RMS     DIAGONAL ERROR: ',Err(3)
         End If
      End If
      If (abs(Err(4)) .gt. Thr) Then
         irc = irc + 1
         If (Verbose) Then
            Write(6,*) '>>> LARGE MINIMUM MATRIX   ERROR: ',Err(4)
         End If
      End If
      If (abs(Err(5)) .gt. Thr) Then
         irc = irc + 1
         If (Verbose) Then
            Write(6,*) '>>> LARGE MAXIMUM MATRIX   ERROR: ',Err(5)
         End If
      End If
      If (abs(Err(6)) .gt. Thr) Then
         irc = irc + 1
         If (Verbose) Then
            Write(6,*) '>>> LARGE RMS     MATRIX   ERROR: ',Err(6)
         End If
      End If

      If (Verbose) Call xFlush(6)

      End SubRoutine CD_Tester_Final
C
      SubRoutine CD_Tester_ES(X,n,Err)
      Implicit None
      Integer n
      Real*8  X(n,n), Err(3)
      Integer i

      If (n .lt. 1) Then
         Err(1) =  9.876543210d15
         Err(2) = -9.876543210d15
         Err(3) =  9.876543210d15
      Else
         Err(1) = X(1,1)
         Err(2) = X(1,1)
         Err(3) = X(1,1)*X(1,1)
         Do i = 1,n
            Err(1) = min(Err(1),X(i,i))
            Err(2) = max(Err(2),X(i,i))
            Err(3) = Err(3) + X(i,i)*X(i,i)
         End Do
         Err(3) = sqrt(Err(3)/dble(n))
      End If

      End SubRoutine CD_Tester_ES

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mkgrd_cvb(civb,civb2,grad,dvbdet,np,doorb)
      implicit real*8 (a-h,o-z)
      logical doorb
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension civb(ndet),civb2(ndet),grad(npr),dvbdet(ndetvb)

      call fzero(grad,nprorb)
      if(doorb)call onedens_cvb(civb,civb2,grad,.false.,1)
      if(strucopt)then
        call ci2vbg_cvb(civb2,dvbdet)
        if(np-nprorb.eq.nvb)then
          call vb2strg_cvb(dvbdet,grad(nprorb+1))
        elseif(np-nprorb.lt.nvb)then
          i1 = mstackrz_cvb(nvb)
          call vb2strg_cvb(dvbdet,w(i1))
          call fmove_cvb(w(i1),w(lv(5)),np-nprorb)
          call mfreer_cvb(i1)
        else
          write(6,*)' Error in mkgrd - np-nprorb > nvb :',np,nprorb,nvb
        endif
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Banner(Lines,nLines,nWidth)
!***********************************************************************
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             May '91                                                  *
!***********************************************************************

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nLines, nWidth
character(len=*), intent(in) :: Lines(nLines)
integer(kind=iwp), parameter :: MxWdth = 132
character(len=MxWdth-2) :: Line
character(len=72) :: frmt
integer(kind=iwp) :: i, iEnd, iFrst, j, jEnd, jFrst, Length, mWidth, nChar, nSplit

mWidth = nWidth
nChar = len(Lines(1))
if (nChar+2 > mWidth) mWidth = nChar+2
mWidth = min(MxWdth-2,mWidth)
write(frmt,'(A,i3,A)') '(1X,A',mWidth,')'
Line(1:mWidth) = repeat('*',mWidth)
write(u6,frmt) Line
Line(2:mWidth-1) = repeat(' ',mWidth-2)
write(u6,frmt) Line
do i=1,nLines
  do j=1,nChar
    if (Lines(i)(j:j) /= ' ') exit
  end do
  iFrst = j
  do j=nChar,iFrst,-1
    if (Lines(i)(j:j) /= ' ') exit
  end do
  iEnd = j
  Line(2:mWidth-1) = repeat(' ',mWidth-2)
  Length = iEnd-iFrst+1
  nSplit = (mWidth-2-Length)/2
  jFrst = 1+nSplit+1
  jEnd = jFrst+Length-1
  Line(jFrst:jEnd) = Lines(i)(iFrst:iEnd)
  write(u6,frmt) Line
end do

Line(2:mWidth-1) = repeat(' ',mWidth-2)
write(u6,frmt) Line
Line(2:mWidth-1) = repeat('*',mWidth-2)
write(u6,frmt) Line

return

end subroutine Banner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************
subroutine UnzipD1(D1Unzip,D1MO,nD1MO)

use nq_Info, only: NASHT
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: D1Unzip(NASHT,NASHT)
integer(kind=iwp), intent(in) :: nD1MO
real(kind=wp), intent(in) :: D1MO(nD1MO)
integer(kind=iwp) :: iLoc, iv, ix

D1Unzip(:,:) = Zero
do iv=1,NASHT
  do ix=1,iv-1
    iLoc = (iv-1)*iv/2+ix
    D1Unzip(ix,iv) = Half*D1MO(iLoc)
    D1Unzip(iv,ix) = D1Unzip(ix,iv)
  end do
  ix = iv
  iLoc = (iv+1)*iv/2
  D1Unzip(ix,iv) = Half*D1MO(iLoc)
end do

return

end subroutine UnzipD1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993,2000, Markus P. Fuelscher                         *
!               1993, Per-Olof Widmark                                 *
!***********************************************************************

subroutine INIPKR8(PkAcc,PkMode)
!***********************************************************************
!                                                                      *
!     purpose: initial step for the packing and unpacking              *
!              routines. It has to be called prior to any calls to     *
!              the subroutines PKR8 and UPKR8. This routine determines *
!              the number of bytes which can be stripped of from a     *
!              given double precision number,i.e. the least significant*
!              bytes are replaced by zero) such that the resulting     *
!              absolute error is smaller than a given threshold.       *
!                                                                      *
!    Calling parameters:                                               *
!    PkAcc  : desired packing accuracy                                 *
!    PkMode : This is a flag to turn packing on and off                *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher and P. O. Widmark                                 *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     replacement of packing routines                                  *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 2000                                 *
!                                                                      *
!***********************************************************************

use Pack_mod, only: Init_do_setup_d, Init_do_setup_e, Init_do_setup_l, isPack, PkThrs
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: PkAcc
logical(kind=iwp), intent(in) :: PkMode

!----------------------------------------------------------------------*
! Packing is disabled on the C90 due to the CRAY specific data         *
! representation.                                                      *
!----------------------------------------------------------------------*

#ifdef _CRAY_C90_
#define _PKMODE_ .false.
#include "macros.fh"
unused_var(PkMode)
#else
#define _PKMODE_ PkMode
#endif

!----------------------------------------------------------------------*
! initialize the packing table                                         *
!----------------------------------------------------------------------*

PkThrs = PkAcc
isPack = _PKMODE_

Init_do_setup_e = 1
Init_do_setup_d = 1
Init_do_setup_l = 1

return

end subroutine INIPKR8

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine Proc_Inp(DSCF,lOPTO,iRc)

      use stdalloc, only : mma_allocate, mma_deallocate
      use fortran_strings, only : to_upper, operator(.in.)
#ifdef _DMRG_
! module dependencies
      use qcmaquis_interface_cfg
      use qcmaquis_interface, only: qcmaquis_interface_init,
     &        remove_comment, qcmaquis_interface_set_param,
     &        qcmaquis_interface_stdout
      use active_space_solver_cfg, only: as_solver_inp_proc
#ifdef _MOLCAS_MPP_
      use Para_Info, Only: mpp_procid, mpp_nprocs
#endif
#endif
      use csfbas, only: CONF, KCFTP
      use Fock_util_global, only: DoCholesky
      use write_orbital_files, only: OrbFiles, write_orb_per_iter
      use fcidump, only: DumpOnly
      use fcidump_reorder, only: ReOrInp, ReOrFlag
      use fciqmc, only: DoEmbdNECI, DoNECI, tGUGA_in
      use fciqmc_read_RDM, only: tHDF5_RDMs, MCM7
      use CC_CI_mod, only: Do_CC_CI
      use spin_correlation, only: orb_range_p, orb_range_q, same_orbs
      use orthonormalization, only : ON_scheme, ON_scheme_values
      use fciqmc_make_inp, only : trial_wavefunction, pops_trial,
     &  t_RDMsampling, RDMsampling,
     &  totalwalkers, Time, nmCyc, memoryfacspawn,
     &  realspawncutoff, diagshift, definedet, semi_stochastic
#ifdef _HDF5_
      use mh5, only: mh5_is_hdf5, mh5_open_file_r, mh5_exists_attr,
     &               mh5_exists_dset, mh5_fetch_attr, mh5_fetch_dset,
     &               mh5_close_file
#endif
      use KSDFT_Info, only: CoefR, CoefX
      use OFembed, only: Do_OFemb,KEonly, OFE_KSDFT,
     &                   ThrFThaw, Xsigma, dFMD
      use CMS, only: iCMSOpt,CMSGiveOpt,CMSGuessFile
      Implicit Real*8 (A-H,O-Z)
#include "SysDef.fh"
#include "rasdim.fh"
#include "warnings.h"
#include "WrkSpc.fh"
#include "gas.fh"
#include "rasscf.fh"
#include "input_ras.fh"
#include "splitcas.fh"
#include "bk_approx.fh"
#include "general_mul.fh"
#include "output_ras.fh"
#include "orthonormalize.fh"
#include "casvb.fh"
#include "pamint.fh"
* Lucia-stuff:
#include "ciinfo.fh"
#include "spinfo.fh"
#include "lucia_ini.fh"
#include "rasscf_lucia.fh"
*^ needed for passing kint1_pointer
*
*
      Character*180  Line
      Character*8 NewJobIphName
      logical lExists, RunFile_Exists, RlxRCheck
* Some strange extra logical variables...
      logical lOPTO
      logical DSCF
      logical RF_On
      logical Langevin_On
      logical PCM_On
      Integer ipTemp1,ipTemp2,ipTemp3
* (SVC) added for treatment of alter and supsym
      Dimension iMAlter(MaxAlter,2)
      Integer IPRGLB_IN, IPRLOC_IN(7)

#ifdef _DMRG_
* DMRG-NEVPT2 variables: MPS compression, 4-RDM evaluation
#include "nevptp.fh"
#endif
      Logical DBG, exist

#include "chotime.fh"
#include "chopar.fh"

      Integer IScratch(10)
* Label informing on what type of data is available on an INPORB file.
      Character*8 InfoLbl
* Local NBAS_L, NORB_L .. avoid collision with items in common.
      DIMENSION NBAS_L(8),NORB_L(8)
      DIMENSION NFRO_L(8),NISH_L(8),NRS1_L(8),NRS2_L(8)
      DIMENSION NRS3_L(8),NSSH_L(8),NDEL_L(8)
#ifdef _HDF5_
      character(len=1), allocatable :: typestring(:)
#endif
* TOC on JOBOLD (or JOBIPH)
      DIMENSION IADR19(15)

      Character*180 Get_LN
      External Get_LN
      Real*8   Get_ExFac
      External Get_ExFac
      Character*100 ProgName, Get_SuperName
      External Get_SuperName
      Character*72 ReadStatus
      Character*72 JobTit(mxTit)
      Character*256 myTitle
      Character*8 MaxLab
      Logical, External :: Is_First_Iter
      Dimension Dummy(1)
      Character*(LENIN8*mxOrb) lJobH1
      Character*(2*72) lJobH2

      integer :: start, step, length

      character(len=50) :: ON_scheme_inp, uppercased
      character(len=:), allocatable :: buffer

#ifdef _DMRG_
!     dmrg(QCMaquis)-stuff
      Character*256 CurrDir
      Character*72 ProjectName
      integer              :: LRras2_dmrg(8)
      integer, allocatable :: initial_occ(:,:)
      character(len=20)    :: guess_dmrg
!     dmrg(QCMaquis)-stuff
#endif

      Intrinsic INDEX,NINT,DBLE,SQRT

C...Dongxia note for GAS:
C   No changing about read in orbital information from INPORB yet.

      DoFaro = .FALSE.

#ifdef _DMRG
* Leon: Prepare 4-RDM calculations for (CD)-DMRG-NEVPT2 at the end of the calculation
      DoNEVPT2Prep = .FALSE.
!     If this is set to 0, MPS compression is disabled
      MPSCompressM = 0
#endif
* NN.14 Block DMRG flag
      DoBlockDMRG = .false.
#ifdef _ENABLE_CHEMPS2_DMRG_
! Quan.16: CheMPS2 default flags
      chemps2_restart=.false.
      chemps2_lrestart=0
      davidson_tol = 1.0d-7
      chemps2_blb = 0.5d-2
      max_sweep = 8
      chemps2_noise = 0.05
      max_canonical = max_sweep*5
#endif
* Init HFOCC array containing user defined occupancies for the active orbitals.
* This array is used by DMRG codes (Block as well as CheMPS2).
* Terefore I took it out of any ifdef preprocessing flag.

      do i = 1, MxAct
        hfocc(i) = 0
      end do

#ifdef _ENABLE_DICE_SHCI_
      dice_stoc = .false.
      nref_dice = 1
      dice_eps1 = 1.0d-4
      dice_eps2 = 1.0d-5
      dice_sampleN = 200
      dice_iter = 20
      dice_restart = .false.
#endif

*    SplitCAS related variables declaration  (GLMJ)
      DoSplitCAS= .false.
      NumSplit  = .false.
      EnerSplit = .false.
      PerSplit  = .false.
      FOrdSplit = .false.
*    BK type of approximation (GLMJ)
      DoBKAP    = .false.

* ======================================================================
*   QCMaquis flags
* ======================================================================
      dofcidump      =   .false.

* ======================================================================

*    GAS flag, means the INPUT was GAS
      iDoGas = .false.

*     The compiler thinks NASHT could be undefined later (after 100)
      NASHT=0


      DBG=.false.
      NAlter=0
      iRc=_RC_ALL_IS_WELL_

* Note: During process of keywords, there is either a call to ChkIfKey
* once any input data for that keyword has been processed, to check that
* there are no unrecognized keywords (misspelled? syntactic error?)
* following; or if the keyword should not be followed by any data,
* then for the same purpose, a call of the kind
*       Call SetPos(LUInput,'ATOM',Line,iRc)
*       Call ChkIfKey()
* This is really the only safe way to make warnings for such events
* the way the input is parsed and processed for the moment.
* Start by checking for extraneous input following any of these
* keywords (misspelled or nonsyntactic usage)
      If (KeyCORE) Then
        Call SetPos(LUInput,'CORE',Line,iRc)
        Call ChkIfKey()
      End If
      If (KeyINPO) Then
        Call SetPos(LUInput,'INPO',Line,iRc)
        Call ChkIfKey()
      End If
      If (KeyJOBI) Then
        Call SetPos(LUInput,'JOBI',Line,iRc)
        Call ChkIfKey()
      End If
      If (KeyLUMO) Then
        Call SetPos(LUInput,'LUMO',Line,iRc)
        Call ChkIfKey()
      End If
      If (KeyCIRE) Then
        Call SetPos(LUInput,'CIRE',Line,iRc)
        Call ChkIfKey()
      End If
* They had to be tested here, since the key flags may be modified later.
*
* ====================================================================
* The outdated INPORB keyword now means just the same as LUMORB
* Will be deleted soon.
      KeyLUMO=KEYLUMO .or. KeyINPO
* ====================================================================
*
* How was the program called?
*PAM 2009  For some particular types of calculations, the input is to be
* disregarded or overridden, as follows (Roland, esp. numerical diff):
      If(KeyEXPE) Then
       Call SetPos(LUInput,'EXPE',Line,iRc)
       Call ChkIfKey()
      Else
        ProgName=Get_SuperName()
        IfVB=0
        If (ProgName(1:6).eq.'rasscf') Then
* For geometry optimizations use the old CI coefficients.
         If (.Not.Is_First_Iter()) Then
           KeyCIRE=.true.
           KeyFILE=.false.
         End If
        Else If (ProgName(1:5).eq.'casvb') Then
         IfVB=2
        Else If (ProgName(1:6).eq.'loprop') Then
         KeyCIRE=.true.
         KeyFILE=.false.
        Else If (ProgName(1:11).eq.'last_energy') Then
         KeyCIRE=.true.
         KeyFILE=.false.
        Else If (ProgName(1:18).eq.'numerical_gradient') Then
         KeyCIRE=.true.
         KeyFILE=.false.
        End If
      End If
*PAM2009 Also, CIRESTART would normally also imply that orbitals are
*to be taken from JOBIPH or JOBOLD:
      If(.not.KeyEXPE) Then
        If(KeyCIRE) Then
         KeyLUMO=.false.
         KeyINPO=.false.
         KeyJOBI=.true.
        End If
      End If

* Check PRINT command
      If (KeyPRIN) Then
       Call SetPos(LUInput,'PRIN',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading after PRINT keyword.'
       Read(LUInput,*,End=9910,Err=9920)
     &          LF,IPRGLB_IN,(IPRLOC_IN(I),I=1,7)
       ReadStatus=' O.K. reading info of PRINT keyword.'
       Call SetPrLev(LF,IPRGLB_IN,IPRLOC_IN)
       If (IPRLOC(1).GE.DEBUG) Then
        Write(6,*)' PROC_INP: Print levels have been set:'
        Write(6,*)'    Global print level IPRGLB=',IPRGLB
        Write(6,*)'    Local print levels by section:'
        Write(6,*)'             Input section, IPRLOC(1)=',IPRLOC(1)
        Write(6,*)'    Transformation section, IPRLOC(2)=',IPRLOC(2)
        Write(6,*)'                CI section, IPRLOC(3)=',IPRLOC(3)
        Write(6,*)'          Super-CI section, IPRLOC(4)=',IPRLOC(4)
        Write(6,*)'            Output section, IPRLOC(6)=',IPRLOC(6)
        Write(6,*)'          Property section, IPRLOC(7)=',IPRLOC(7)
       End If
       Call ChkIfKey()
      End If

* Local print level in this routine:
      IPRLEV=IPRLOC(1)
* Short, for use with IF-statements at debugging print level:
      DBG=DBG .or. (IPRLEV.GE.DEBUG)

      If (DBG) Then
        Write(6,*)' Trace of input processing in PROC_INP:'
      End If

* ====================================================================
* Check IfVB flag
* If (IFVB.eq.2) -- Then bypass a lot of processing:
      If (DBG) Write(6,*)' Valence-Bond flag IfVB=',IfVB
      if(ifvb.eq.2)then
        if(JOBIPH.le.0) Then
          JOBIPH=IsFreeUnit(15)
          call daname(JOBIPH,"JOBIPH")
        end if
* Special input routine:
        If (DBG) Write(6,*)' IfVB=2, so Call Readin_VB'
        Call Readin_vb()
        If (DBG) Write(6,*)' Back from Readin_VB'
        If (DBG) Write(6,*)' Bypass usual input processing, GoTo 100!'
      endif
      if(ifvb.eq.2) GoTo 100

* ====================================================================
      If (DBG) Write(6,*)' Check if VB keyword was given.'
      If (KeyVB) Then
       If (DBG) Write(6,*)' Yes it was!'
*---  Process vb   command --------------------------------------------*
       Call SetPos(LUInput,'VB  ',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       If (DBG) Write(6,*)' so Call CVBInp_CVB.'
       call cvbinp_rvb(1,LUInput)
       If (DoCholesky) then
        Call WarningMessage(2,'CASVB cannot do Cholesky or RI/DF.')
        Call Quit(_RC_INPUT_ERROR_)
       End If
       If (DBG) Write(6,*)' Set IfVB=1.'
       ifvb=1
       If (DBG) Write(6,*)' Asked for CASVB calc.'
      End If

* ====================================================================
      If (KeyTITL) Then
*---  process TITLE    command ----------------------------------------*
       Call SetPos(LUInput,'TITL',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Title(1)=Trim(Get_Ln(LUInput))
       If (DBG) Then
         Write(6,*)' PROC_INP: Title line:'
         Write(6,*) Title(1)
       End If
       Call ChkIfKey()
      End If

* ====================================================================
*---  Check if there is any runfile:
      Call F_Inquire('RUNFILE',RunFile_Exists)
      If (DBG) Write(6,*)' Inquire about RUNFILE.'
      IF (RunFile_Exists) Then
       If (DBG) Write(6,*)' Yes, there is one.'
       NSYM=0
       Call qpg_iScalar('nSym',lExists)
       IF (lExists) Then
        Call Get_iScalar('nSym',nSym)
        Call Get_iArray('nBas',nBas,nSym)
        If (DBG) Then
          Write(6,*)' The following information exists on runfile:'
          Write(6,*)' Nr of symmetries, NSYM:',NSYM
          Write(6,*)' Nr of basis functions/symmetry:'
          Write(6,'(1x,8I5)')(NBAS(I),I=1,NSYM)
          Call XFlush(6)
        End If
       ELSE
        Call WarningMessage(2,'No symmetry info on runfile.')
        Write(6,*)' There seems to be no information about symmetry'
        Write(6,*)' on the runfile! This is an unexpected error.'
        Call Quit(_RC_IO_ERROR_READ_)
       END IF
      ELSE
       Call WarningMessage(2,'Cannot find runfile.')
       Write(6,*)' PROC_INP: Cannot find RUNFILE. This is an'//
     &           ' unexpected error.'
        Call Quit(_RC_IO_ERROR_READ_)
      END IF

* PAM03: Local variable IORBDATA=0 as long as no explicit orbital specifications have
* been set by the user input.
* iOrbData=0: no orbital space data is specified
*          1: user input has defined orbital spaces
*          2: specifications from runfile, or JOBOLD or JOBIPH file
*          3: specifications from orbital file
      iOrbData=0
      INVEC=0
* INVEC=0, no source for orbitals (yet)
*       1, CORE command: compute orbitals from scratch.
*       2, read from starting orbitals file in INPORB format.
*       3, take from JOBOLD, or JOBIPH file
* RASSCF will read CMO arrays by READVC call after return from PROC_INP
* Inside readvc, if INVEC is still 0, it will be changed to 4, 5, or 6:
*       4, take from an HDF5 file
*       5, take rasscf orbitals from runfile
*       6, take scf orbitals from runfile
*       7, take guessorb orbitals from runfile
* iOverWr: If orbital coefficient arrays (CMO:s) are read from INPORB
* file, then iOverWr=0 means that the arrays are reordered by typeindex.
* iOverWr=1 means do not reorder by typeindex.
      iOverWr=0

*--- Where should orbital be read (if at all)?
      If (DBG) Write(6,*)' Where to read orbitals? '
      StartOrbFile='INPORB'
      If (KeyFILE) Then
       If (DBG) Then
         Write(6,*)' Reading file name for start orbitals.'
       End If
       Call SetPos(LUInput,'FILE',Line,iRc)
       Line=Get_Ln(LUInput)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Call ChkIfKey()
       If (DBG) Then
         Write(6,*) ' Calling fileorb with filename='
         Write(6,*) Line
       End If
       call fileorb(Line,StartOrbFile)
#ifdef _HDF5_
       if (mh5_is_hdf5(StartOrbFile)) then
         KeyLUMO=.false.
         KeyTYPE=.false.
         KeyH5OR=.true.
         If (KeyCIRE) Then
           Write(6,*) ' CIRE keyword given, but FILE is an HDF5 format.'
           Write(6,*) ' I will switch off CIRE and use H5CI instead!'
           KeyH5CI=.true.
           KeyCIRE=.false.
           KeyJOBI=.false.
         End If
       else
         If (KeyCIRE) Then
           Write(6,*) ' CIRE keyword given, FILE will be ignored!'
         Else
           KeyLUMO=.true.
         End If
       end if
#else
       If (KeyCIRE) Then
         Write(6,*) ' CIRE keyword given, FILE will be ignored!'
       Else
         KeyLUMO=.true.
       End If
#endif
      End If
      If (DBG) Then
         Write(6,*)' StartOrbFile='
         Write(6,*) StartOrbFile
         call xflush(6)
      End If

* ============================================================================
* The JOBIPH file, following decisions from the Torre Normanna labour camp:
* Default, the file name is 'JOBIPH'.
* However, if keyword IPHNAME was used, then the name was given in input.
* Also, if instead the keyword NEWIPH was given, then a new name will be
* chosen as the first not-already-used name in the sequence
* 'JOBIPH', 'JOBIPH01', 'JOBIPH02', etc.
      If (DBG) Write(6,*)' Present name of JOBIPH file is ',IPHNAME
*---  Process NEWIPH command (P A Malmqvist Sep 06)------------------------*
      If (KeyNEWI) Then
       If (DBG) Then
        Write(6,*)' A fresh JOBIPH file will be used.'
       End If
       IPHNAME='ToBeFoun'
      End If
*---  process IPHNAME command (P A Malmqvist Sep 06)------------------------*
      If (KeyIPHN) Then
       If (DBG) Then
        Write(6,*)' Reading file name for JOBIPH file.'
       End If
       Call SetPos(LUInput,'IPHN',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading IPHNAME string.'
       Read(LUInput,*,End=9910,Err=9920) IPHNAME
       ReadStatus=' O.K. after reading IPHNAME string.'
       Call UpCase(IPHNAME)
      End If
* The JOBIPH file:
      IF(IPHNAME.EQ.'ToBeFound') THEN
* Choose a new jobiph name.
       Call F_Inquire('JOBIPH',lExists)
       IF (.not.lExists) THEN
        IPHNAME='JOBIPH'
       ELSE
        DO I=1,99
         write(NewJobIphName,'(a6,i2.2)') 'JOBIPH',I
         Call F_Inquire(NewJobIphName,lExists)
* Choose first non-existent file
         IF(.not.lExists) goto 12
        END DO
        Write(LF,*)
        Write(LF,*)'******************************************'
        Write(LF,*)' Sorry, all possible JOBIPH names in this '
        Write(LF,*)' directory already in use. Program stops. '
        Write(LF,*)'******************************************'
        Call Abend()
  12    Continue
        IPHNAME=NewJobIphName
       END IF
      END IF
      If (DBG) Then
        Write(6,*) ' Name of JOBIPH file is'
        Write(6,*) IPHNAME
      End If
* Finally, we know the name. Open jobiph file. If another file is already
* opened with this identifier close it.
      if(JOBIPH.gt.0) Then
        Call DaClos(JOBIPH)
        JOBIPH=-1
      end if
      JOBIPH=IsFreeUnit(15)
      CALL DANAME(JOBIPH,IPHNAME)

* ========================================================================
*  If orbital files should be produced, several keywords are relevant:
*---  Process OUTPRINT command -----
      If (KeyOUTP) Then
       If (DBG) Write(6,*) ' OUTPRINT command was given:'
       Call SetPos(LUInput,'OUTP',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading OUTPRINT line.'
       Read(LUInput,*,End=9910,Err=9920) Line
       ReadStatus=' O.K. after reading OUTPRINT line.'
       Call UpCase(Line)
       If ( Index(Line,'VERY').ne.0 ) OutFmt1='NOTHING '
       If ( Index(Line,'BRIE').ne.0 ) OutFmt1='FEW     '
       If ( Index(Line,'LONG').ne.0 ) OutFmt1='ALL     '
       If ( Index(Line,'NOTH').ne.0 ) OutFmt1='NOTHING '
       If ( Index(Line,'FEW' ).ne.0 ) OutFmt1='FEW     '
       If ( Index(Line,'NOCO').ne.0 ) OutFmt1='NOCORE  '
       If ( Index(Line,'ALL' ).ne.0 ) OutFmt1='ALL     '
       If ( Index(Line,'COMP').ne.0 ) OutFmt2='COMPACT '
       If ( Index(Line,'FULL').ne.0 ) OutFmt2='FULL    '
       If (OutFmt1.eq.'DEFAULT '.and.OutFmt2.eq.'DEFAULT ') Then
        Call WarningMessage(1,'Error in ''OUTP'' command?')
        Write(LF,*)' Input line is:'
        Write(LF,*) Line
        Write(LF,*)' Did not understand ''OUTP'' input. Ignored.'
       End If
      End If
*---  Process PROR (Print levels for orbitals) command --- (new!) -----*
      If (KeyPROR) Then
       If (DBG) Write(6,*) ' PRORB command was given:'
       Call SetPos(LUInput,'PROR',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading PRORB input.'
       Read(LUInput,*,End=9910,Err=9920) PRETHR,PRO
       ReadStatus=' O.K. after reading PRORB input.'
       PROTHR=MAX(0.0D0,PRO)
      End If
*---  Process ORBL keyword: Orbital listing
      If (KeyORBL) Then
       If (DBG) Write(6,*) ' ORBL (Orbital listing):'
       Call SetPos(LUInput,'ORBL',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading ORBL input.'
       Read(LUInput,*,End=9910,Err=9920) Line
       ReadStatus=' O.K. after reading ORBL input.'
       Call UpCase(Line)
       If ( Index(Line,'VERY').ne.0 ) OutFmt1='NOTHING '
       If ( Index(Line,'BRIE').ne.0 ) OutFmt1='FEW     '
       If ( Index(Line,'LONG').ne.0 ) OutFmt1='ALL     '
       If ( Index(Line,'NOTH').ne.0 ) OutFmt1='NOTHING '
       If ( Index(Line,'FEW' ).ne.0 ) OutFmt1='FEW     '
       If ( Index(Line,'NOCO').ne.0 ) OutFmt1='NOCORE  '
       If ( Index(Line,'ALL' ).ne.0 ) OutFmt1='ALL     '
       If (OutFmt1.eq.'DEFAULT ') Then
        Call WarningMessage(1,'Error in ''ORBL'' command?')
        Write(LF,*)' Input line is:'
        Write(LF,*) Line
        Write(LF,*)' Did not understand ''OUTL'' input. Ignored.'
       End If
      End If
*---  Process ORBA keyword: Orbital Appearance
      If (KeyORBA) Then
       If (DBG) Write(6,*) ' ORBA (Orbital appearance):'
       Call SetPos(LUInput,'ORBA',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading ORBA input.'
       Read(LUInput,*,End=9910,Err=9920) Line
       ReadStatus=' O.K. after reading ORBA input.'
       Call UpCase(Line)
       If ( Index(Line,'COMP').ne.0 ) OutFmt2='COMPACT '
       If ( Index(Line,'FULL').ne.0 ) OutFmt2='FULL    '
       If (OutFmt2.eq.'DEFAULT ') Then
        Call WarningMessage(1,'Error in ''OUTA'' command?')
        Write(LF,*)' Input line is:'
        Write(LF,*) Line
        Write(LF,*)' Did not understand ''OUTA'' input. Ignored.'
       End If
      End If
*---  Process MAXO keyword: Max nr of state-specific orbital files produced
      If (KeyMAXO) Then
       If (DBG) Write(6,*) ' MAXORB command:'
       Call SetPos(LUInput,'MAXO',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading MAXO input.'
       Read(LUInput,*,End=9910,Err=9920) MAXORBOUT
       ReadStatus=' O.K. after reading MAXO input.'
      End If
      If (DBG) Then
        Write(6,*) ' Orbital print levels are'
        Write(6,*) '   for energy, PRETHR=',PRETHR
        Write(6,*) '   for occup , PROTHR=',PROTHR
        Write(6,*) ' Orbital listing flag is: ',OutFmt1
        Write(6,*) ' Orbital appearance flag: ',OutFmt2
         Write(6,*) ' Max nr of state-specific orbital files is ',
     &                MAXORBOUT
      End If
* ========================================================================
*---  Process OUTORBITALS command (Which kind of orbitals)---------*
      If (KeyOUTO) Then
       Call SetPos(LUInput,'OUTO',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading OUTO input.'
       Read(LUInput,*,End=9910,Err=9920) Line
       ReadStatus=' O.K. after reading OUTO input.'
       Call UpCase(Line)
       iOrbTyp=0
       If ( Index(Line,'AVER').ne.0 ) iOrbTyp=1
       If ( Index(Line,'CANO').ne.0 ) iOrbTyp=2
       If ( Index(Line,'NATU').ne.0 ) iOrbTyp=3
       If ( Index(Line,'SPIN').ne.0 ) iOrbTyp=4
       If(iOrbTyp.eq.0) then
         Write(LF,*)' The line after keyword ''OUTORBITALS'' is'
         Write(LF,*)' not understood. That line begins:'
         Write(LF,'(1x,a60)') line(1:60)
         Write(LF,*)' This input is IGNORED.'
       End If
       If (iOrbTyp.eq.2) IPT2=1
       If (iOrbTyp.eq.3 .or. iOrbTyp.eq.4) Then
         ReadStatus=' Failure reading nOrbRoot after OUTO keyword.'
         Read(LUInput,*,End=9910,Err=9920) nOrbRoot
         ReadStatus=' O.K. after reading nOrbRoot after OUTO keyword.'
       End If
      End If
       If (DBG) Then
         Write(6,*) ' OUTORBITALS command specified orbital type ',
     &                iOrbTyp
         IF(iOrbTyp.eq.1) Write(6,*) ' Meaning: Average'
         IF(iOrbTyp.eq.2) Write(6,*) ' Meaning: Canonical'
         IF(iOrbTyp.eq.3) Write(6,*) ' Meaning: Natural'
         IF(iOrbTyp.eq.4) Write(6,*) ' Meaning: Spin orbitals.'
         If (iOrbTyp.eq.3 .or. iOrbTyp.eq.4) Then
          Write(6,*) ' Max state for printing this orbital type ',
     &                nOrbRoot
         End If
       End If
*---  Process ORDER command (SVC Feb 06)-------------------------------*
      If (KeyORDE) Then
       If (DBG) Write(6,*) ' ORDER command was used.'
       Call SetPos(LUInput,'ORDE',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure after reading ORDER keyword.'
       Read(LUInput,*,End=9910,Err=9920) IFORDE
       ReadStatus=' O.K. after reading ORDER keyword.'
       IORDEM=1
       If (DBG) Then
        Write(6,*) ' IFORDE, IORDEM=',IFORDE,IORDEM
       End If
      End If
*---  Process PRSP command --------------------------------------------*
      If (KeyPRSP) Then
       If (DBG) Write(6,*) ' PRSPIN command was used.'
       ISPDEN=1
      End If
*---  Process IVO command --------------------------------------------*
      If (KeyIVO) Then
       If (DBG) Write(6,*) ' IVO command was used.'
       kIvo=.true.
      End If
* ========================================================================
*  If ORBONLY keyword was used, then the JOBIPH file should be used
* only to produce orbital files, then the program stops.
*---  Process ORBO command -( new! generate orbitals from jobiph, only)*
      If (KeyORBO) Then
       iOrbOnly=1
       Call OrbFiles(JOBIPH,IPRLEV)
       If(JOBIPH.gt.0) Then
         Call DaClos(JOBIPH)
         JOBIPH=-1
       End If
* Nothing more to be done, so return.
       iReturn=_RC_ALL_IS_WELL_
       Call xQuit(iReturn)
      End If
*
*---  Process ALTEr command (G. Ghigo Sep 03)--------------------------*
      If (KeyALTE) Then
       If (DBG) Write(6,*) ' ALTER command has been used.'
       Call SetPos(LUInput,'ALTE',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure after reading ALTER keyword.'
       Read(LUInput,*,End=9910,Err=9920) NAlter
       ReadStatus=' O.K. after reading ALTER keyword.'
       If ( NAlter.gt.MaxAlter ) Then
        Write(MaxLab,*) MaxAlter
        MaxLab=AdjustL(MaxLab)
        Write(LF,*)
        Call WarningMessage(2,'Alter: too many orbital pairs.')
        Write(LF,*) ' ************* ERROR **************'
        Write(LF,*) ' ALTEr: Too many pairs of orbitals '
        Write(LF,*) ' to exchange (max '//Trim(MaxLab)//').'
        Write(LF,*) ' **********************************'
        Call Abend()
       End If
       Do iAlter=1,NAlter
        ReadStatus=' Failure reading data after ALTER keyword.'
        Read(LUInput,*,End=9910,Err=9920) (MAlter(iAlter,i),i=1,3)
        ReadStatus=' O.K. after reading data after ALTER keyword.'
       END DO
* (SVC) get absolute orbital values for the alterations so that
* iMAlter is symmetry independent
       If (DBG) Write(6,*)' ''Absolute'' iMAlter indices:'
       Do iAlter=1,NAlter
        iEnd=0
        iStart=1
        Do iSym=1,MAlter(iAlter,1)
          iStart=iEnd+1
          iEnd=iEnd+nBas(iSym)
        End Do
        iMAlter(iAlter,1)=MAlter(iAlter,2)+iStart-1
        iMAlter(iAlter,2)=MAlter(iAlter,3)+iStart-1
        If (DBG) Write(6,'(1x,2I5)')
     &                          iMAlter(iAlter,1),iMAlter(iAlter,2)
       End Do
      End If
*---  Process ATOM command (P A Malmqvist Apr 07)----------------------*
      If(KeyATOM) Then
       PURIFY='ATOM    '
       ISUPSM=1
       Call SetPos(LUInput,'ATOM',Line,iRc)
       Call ChkIfKey()
      End If
*---  Process LINEAR command (P A Malmqvist Apr 05)--------------------*
      If(KeyLINE) Then
       PURIFY='LINEAR'
       ISUPSM=1
       Call SetPos(LUInput,'LINE',Line,iRc)
       Call ChkIfKey()
      End If
      If (DBG) Write(6,*) ' Purify=',PURIFY

*---  process KSDF command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if KSDFT was requested.'
      If (KeyKSDF) Then
       If (DBG) Write(6,*) ' KSDFT command was given.'
       PamGen=.False.
       PamGen1=.False.
       DFTFOCK='CAS '
       Call SetPos(LUInput,'KSDF',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Read(LUInput,*,End=9910,Err=9920) Line
       Call UpCase(Line)
       If (Line(1:4).eq.'ROKS') DFTFOCK='ROKS'
       If (Line(1:6).eq.'CASDFT') DFTFOCK='DIFF'
       Read(LUInput,*,End=9910,Err=9920) Line
       KSDFT=Line(1:80)
       Call UpCase(KSDFT)
       l_casdft = KSDFT(1:2).eq.'T:' .or. KSDFT(1:3).eq.'FT:'
       If (.NOT.l_casdft) GoTo 9920
       If (IPRLOC(1).GE.DEBUG.and.l_casdft)
     &     write(6,*) ' MCPDFT with functional:', KSDFT
      ExFac=Get_ExFac(KSDFT)
*---  Process DFCF command --------------------------------------------*
      If (KeyDFCF) Then
       If (DBG) Write(6,*) ' DFCF (dens. func. coeff) command was used.'
       Call SetPos(LUInput,'DFCF',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading DF coeff after DFCF keyword.'
       Read(LUInput,*,End=9910,Err=9920) CoefX,CoefR
       ReadStatus=' O.K. after reading DF coeff after DFCF keyword.'
       If (DBG) Then
        Write(6,*) ' Density functional exchange coeff, CoefX=',CoefX
        Write(6,*) ' Density functional correlation coeff, CoefRE=',
     &                                                          CoefR
       End If
       Call ChkIfKey()
      End If
*
*******
*
* Read numbers, and coefficients for rasscf potential calculations:
* nPAM  - number of potentials
* ipPAM - list of potentials
* CPAM  - coeffcients of potentials
* PamGen - switch to generate grid of Rho, grad ....., ......
*
*******
       If ( KSDFT(1:3).eq.'PAM') Then
        If ( KSDFT(4:4).eq.'G') PamGen =.True.
        If ( KSDFT(4:4).eq.'G') PamGen1=.False.
        call dcopy_(nPAMintg,[0.0d0],0,CPAM,1)
        ReadStatus=' Failure reading data following KSDF=PAM.'
        Read(LUInput,*,End=9910,Err=9920) nPAM
        ReadStatus=' O.K. after reading data following KSDF=PAM.'
*        Write(LF,*) ' Number included exponent in PAM=',nPAM
        Do iPAM=1,nPAM
          ReadStatus=' Failure reading data following KSDF=PAM.'
          Read(LUInput,*,End=9910,Err=9920) Line
          ReadStatus=' O.K.after reading data following KSDF=PAM.'
          Call RdPAM(Line,ipPAM(iPAM),CPAM(iPAM))
        End Do
       End If
       Call ChkIfKey()
      End If
*---  Process CION command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if CIONLY case.'
      If (KeyCION) Then
       If (DBG) Write(6,*) ' CIONLY keyword was used.'
       iCIonly=1
       Call SetPos(LUInput,'CION',Line,iRc)
       Call ChkIfKey()
      End If
*---  Process ROST command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if ROtSTate case.'
      If (KeyROST) Then
       If (DBG) Write(6,*) ' ROtSTate keyword was used.'
       iRotPsi=1
       Call SetPos(LUInput,'ROST',Line,iRc)
       Call ChkIfKey()
      End If
*---  Process XMSI command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if XMSI case.'
      If (KeyXMSI) Then
       If (DBG) Write(6,*) ' XMSI keyword was used.'
       iRotPsi=1
       IXMSP=1
       Call SetPos(LUInput,'XMSI',Line,iRc)
       Call ChkIfKey()
      End If
*---  Process CMSI command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if CMSI case.'
      If (KeyCMSI) Then
       If (DBG) Write(6,*) ' CMSI keyword was used.'
       iRotPsi=1
       ICMSP=1
       Call SetPos(LUInput,'CMSI',Line,iRc)
       Call ChkIfKey()
      End If
*---  Process CMSS command --------------------------------------------*
      CMSStartMat='XMS'
      If (KeyCMSS.and.(iCMSP.eq.1)) Then
       If (DBG) Then
         Write(6,*)' Reading CMS inital rotation matrix'
       End If
       Call SetPos(LUInput,'CMSS',Line,iRc)
       Line=Get_Ln(LUInput)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Call ChkIfKey()
       If (DBG) Then
         Write(6,*) ' Reading CMS starting rotation matrix from'
         Write(6,*) trim(Line)
       End If
       if(.not.(trim(Line).eq.'XMS'))  then
         CMSGuessFile=trim(Line)
         CMSStartMat=CMSGuessFile
         call F_Inquire(trim(CMSStartMat),lExists)
         if(.not.lExists) then
           write(LF,'(6X,A,A)') trim(CMSStartMat),
     &' is not found. Use XMS intermediate states as initial guess.'
           CMSStartMat='XMS'
         end if
C         call fileorb(Line,CMSStartMat)
       end if
      End If
*---  Process CMSO command --------------------------------------------*
      If (KeyCMSO.and.(iCMSP.eq.1)) Then
       If (DBG) Then
         Write(6,*) 'Inputting CMS optimization option'
       End If
       Call SetPos(LUInput,'CMSO',Line,iRc)
       Line=Get_Ln(LUInput)
       CALL Upcase(Line)
       If(Line(1:4).eq.'NEWT') Then
        iCMSOpt=1
       Else If(Line(1:4).eq.'JACO') Then
        iCMSOpt=2
       Else
        ReadStatus='Wrong value assigned to keyword CMSO'
        GoTo 9920
       End If
       CMSGiveOpt=.true.
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       If (DBG) Then
        Write(6,*) ' CMS Optimization Option',iCMSOpt
       End If
       Call ChkIfKey()
      End If
*---  Process CMMA command --------------------------------------------*
      If (KeyCMMA) Then
       If (DBG) Write(6,*) ' CMS Max Cylces keyword was given.'
       Call SetPos(LUInput,'CMMA',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data following CMMA keyword.'
       Read(LUInput,*,End=9910,Err=9920) ICMSIterMax
       ReadStatus=' O.K. reading data following CMMA keyword.'
       If (DBG) Then
        Write(6,*) ' Max nr of CMS cycles',ICMSIterMax
       End If
       Call ChkIfKey()
      End If
*---  Process CMMI command --------------------------------------------*
      If (KeyCMMI) Then
       If (DBG) Write(6,*) ' CMS Min Cylces keyword was given.'
       Call SetPos(LUInput,'CMMI',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data following CMMI keyword.'
       Read(LUInput,*,End=9910,Err=9920) ICMSIterMin
       ReadStatus=' O.K. reading data following CMMI keyword.'
       If (DBG) Then
        Write(6,*) ' Min nr of CMS cycles',ICMSIterMin
       End If
       Call ChkIfKey()
      End If
*---  Process CMTH command --------------------------------------------*
      If (KeyCMTH) Then
       If (DBG) Write(6,*) ' CMS Threshold keyword was given.'
       Call SetPos(LUInput,'CMTH',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data following CMTH keyword.'
       Read(LUInput,*,End=9910,Err=9920) CMSThreshold
       ReadStatus=' O.K. reading data following CMTH keyword.'
       If (DBG) Then
        Write(6,*) ' CMS threshold',CMSThreshold
       End If
       Call ChkIfKey()
      End If
*---  Process RFPE command ----- (new!) -------------------------------*
      If(KeyRFPE) Then
       If (DBG) Then
        Write(6,*) ' RFPERT (Response Field Perturbation)'
       End If
       RFpert=.true.
       Call SetPos(LUInput,'RFPE',Line,iRc)
       Call ChkIfKey()
      End If
*---  Process NONE command --( non-equilibrium reaction field )--------*
      If(KeyNONE) Then
       If (DBG) Write(6,*) ' Non-equilibrium response'
       NonEq = .True.
       Call SetPos(LUInput,'NONE',Line,iRc)
       Call ChkIfKey()
      End If
*---  Process RFRO command --------------------------------------------*
      If(KeyRFRO) Then
       Call SetPos(LUInput,'RFRO',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading IPCMROOT after RFROOT keyword.'
       Read(LUInput,*,End=9910,Err=9920) IPCMROOT
       ReadStatus=' O.K. reading IPCMROOT after RFROOT keyword.'
*
*      Check that the root value is not changed explicitly by input
*
       jPCMRoot=iPCMRoot
       Call Qpg_iScalar('RF0CASSCF root',Exist)
       If (Exist) Then
          CALL Get_iScalar('RF0CASSCF root',jPCMRoot)
       Else
          CALL Put_iScalar('RF0CASSCF root',iPCMRoot)
       End If
*
       If (jPCMRoot.ne.iPCMRoot) Then
*         Write (*,*) 'iPCMRoot changed by explicitly by input.'
*
*         Value changed explicitly by input. Accept the new value.
*
          CALL Put_iScalar('RF CASSCF root',iPCMRoot)
          CALL Put_iScalar('RF0CASSCF root',iPCMRoot)
          Call Qpg_dArray("RF CASSCF Vector",Exist,mConf)
          If (Exist) Then
             Call Allocate_Work(ipRF,mConf)
             Call FZero(Work(ipRF),mConf)
             Call Put_dArray("RF CASSCF Vector",Work(ipRF),mConf)
             Call Free_Work(ipRF)
          End If
*
       Else
*
*         Value not explicitly changed by input. See if it is
*         changed by the RunFile, if it exists there.
*
          Call Qpg_iScalar('RF CASSCF root',Exist)
          If (Exist) Then
             CALL Get_iScalar('RF CASSCF root',iPCMRoot)
          Else
             CALL Put_iScalar('RF CASSCF root',iPCMRoot)
          End If
*
       End If
*
       If (DBG) Then
        Write(6,*) ' RFROOT command was given.'
        Write(6,*) ' Response field for root number ',IPCMROOT
       End If
       Call ChkIfKey()
      End If
*---  Process CIRF command --------------------------------------------*
      If(KeyCIRF) Then
       Call SetPos(LUInput,'CIRF',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' O.K. reading after keyword CIRF.'
       Read(LUInput,*,End=9910,Err=9920) ICIRFROOT
       ReadStatus=' O.K. reading after keyword CIRF.'
       Call ChkIfKey()
       If (DBG) Then
        Write(6,*) ' CIRFROOT command was given.'
        Write(6,*) ' Response field will follow CISE root: ',ICIRFROOT
       End If
      End If
*---  Process SSCR command --------------------------------------------*
      if (KeySSCR) then
        if (DBG) write(6,*) ' SSCR command was given.'
        call setpos(luinput,'SSCR',line,irc)
        If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
        line=get_ln(luinput)
        line(80:80)='0'
        ReadStatus=' Failure reading after KeySSCR keyword.'
        read(line,*,err=9920,end=9920) norbs, same_orbs
        ReadStatus=' O.K reading after KeySSCR keyword.'

        if (norbs >= mxOrb) then
          write(6,'(a)', advance="no") 'SSCR error:'
          write(6,*) "number of spatial orbitals exceeds maximum"
          write(6,'(a,i4)') "norbs = ", norbs
          write(6,'(a)') new_line('a')
          call abend()
        end if

        call mma_allocate(orb_range_p,norbs)
        call mma_allocate(orb_range_q,norbs)

        if (same_orbs /= 1) then
          Line=Get_Ln(LUInput)
          readstatus=' failure reading after SSCR keyword.'
          read(Line,*) (orb_range_p(i), i = 1, norbs)
          Line=Get_Ln(LUInput)
          read(Line,*) (orb_range_q(j), j = 1, norbs)

          if (size(orb_range_p) /= size(orb_range_q)) then
            write(6,'(a)', advance="no") 'SSCR error:'
            write(6,*) "numbers of spatial orbitals do not match"
            write(6,*) "orb_range_p has length ", size(orb_range_p)
            write(6,*) "orb_range_q has length ", size(orb_range_q)
            write(6,'(a)') new_line('a')
            call abend()
          end if

          do i = 1, norbs
            do j = 1, norbs
              if (i < j) then
                if (orb_range_p(i) == orb_range_p(j)) then
                  write(6,'(a)', advance="no") 'SSCR error:'
                  write(6,*) 'first range contains duplicates.'
                  write(6,'(*(i4))') orb_range_p
                  write(6,'(a)') new_line('a')
                  call abend()
                end if
                if (orb_range_q(i) == orb_range_q(j)) then
                  write(6,'(a)', advance="no") 'SSCR error:'
                  write(6,*) 'second range contains duplicates.'
                  write(6,'(*(i4))') orb_range_q
                  write(6,'(a)') new_line('a')
                  call abend()
                end if
              end if
            end do
          end do
        else
            do i = 1, norbs
              orb_range_p(i) = i
              orb_range_q(i) = i
            end do
        end if
      call ChkIfKey()
      end if
*---  Process CIRO command --------------------------------------------*
      If (DBG) Write(6,*) ' Check for CIROOTS command.'
      IF(KeyCIRO) Then
       If (DBG) Write(6,*) ' CIROOTS command was given.'
       Call SetPos(LUInput,'CIRO',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
        Line=Get_Ln(LUInput)
CBOR.. Modification 001011
        Line(80:80)='0'
        ReadStatus=' Failure reading after CIROOTS keyword.'
        Read(Line,*,Err=9920,End=9920) NROOTS,LROOTS,iall
        ReadStatus=' O.K reading after CIROOTS keyword.'
        If (NROOTS.GT.MXROOT) Then
          WRITE(6,*) "Error: number of roots exceeds maximum"
          WRITE(6,*) "NROOTS = ", NROOTS
          WRITE(6,*) "MXROOT = ", MXROOT
          CALL AbEnd()
        End If
        if(iall.eq.1) then
         Do i=1,NROOTS
          iroot(i)=i
          WEIGHT(i)=1.d0/DBLE(NROOTS)
         END DO
        Else
CBOR.. End modification 001011
         Line=Get_Ln(LUInput)
         ReadStatus=' Failure reading after CIROOTS keyword.'
         Read(Line,*,Err=9920,End=9920) (IROOT(I),I=1,NROOTS)
         ReadStatus=' O.K.after CIROOTS keyword.'
         Call dCopy_(mxRoot,[0.0D0],0,WEIGHT,1)
         If ( NROOTS.eq.1 ) then
           WEIGHT(1)=1.0D0
         Else
           Call GetMem('Temp1','Allo','Inte',ipTemp1,NROOTS)
           Line=Get_Ln(LUInput)
           ReadStatus=' Failure reading after CIROOTS keyword.'
           Read(Line,*,Err=9920) (iWork(ipTemp1+i-1),i=1,NROOTS)
           ReadStatus=' O.K.after CIROOTS keyword.'
           iSum=0
           Do i=1,NROOTS
              iSum=iSum+iWork(ipTemp1+i-1)
           End Do
           Do i=1,NROOTS
              WEIGHT(i)=DBLE(iWork(ipTemp1+i-1))/DBLE(iSum)
           End Do
           Call GetMem('Temp1','Free','Inte',ipTemp1,NROOTS)
         End If
        End If
        If (DBG) Then
         Write(6,*) ' Nr of roots in CI: LROOTS=',LROOTS
         Write(6,*) ' Nr of roots optimized by super-CI: '//
     &    'NROOTS=',NROOTS
         If (iAll.eq.1) Then
          Write(6,*)' (Equal-weighted)'
         Else
          Write(6,*)' Weights:'
          Do i1=1,NROOTS,10
           i2=min(NROOTS,i1+9)
           write(6,'(1x,10f8.4)')(WEIGHT(i),i=i1,i2)
          End Do
         End If
        End If
       Call ChkIfKey()
      END IF
*---  Process RLXR command --------------------------------------------*
      If(KeyRLXR) Then
       Call SetPos(LUInput,'RLXR',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' O.K. reading after keyword RLXR.'
       Read(LUInput,*,End=9910,Err=9920) IRLXROOT
       ReadStatus=' O.K. reading after keyword RLXR.'
       Call ChkIfKey()
       If (DBG) Then
        Write(6,*) ' RLXROOT command was given.'
        Write(6,*) ' State for SLAPAF to handle: ',IRLXROOT
       End If
       If (.not.Any(iRoot(1:LROOTS).eq.IRLXROOT)) Then
        Write(6,*) ' The selected root is not among those available.'
        Call AbEnd()
       End If
      End If
*
*
CIgorS 29-4-2010 Begin
*---  Process MDRL command --------------------------------------------*
      If(KeyMDRL) Then
         If(KeyRLXR) Then
            Write(6,*) ' RLXROOT keyword was given before MDRLXROOT.'
            Write(6,*) ' Since these keywords are mutually exclusive'
            Write(6,*) ' please check the input and read the manual.'
            GoTo 9910
         End If
         Call SetPos(LUInput,'MDRL',Line,iRc)
         If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
         Call Qpg_iScalar('Relax CASSCF root',RlxRCheck)
         If (RlxRCheck) THEN
            CALL Get_iScalar('Relax CASSCF root',iRlxRoot)
            If (DBG) Then
               Write(6,*) ' An existing relax root was found.'
               Write(6,*) ' The MDRLXROOT value is ignored.'
            End If
         Else
            ReadStatus=' Failure reading relaxroot number IRLXROOT.'
            Read(LUInput,*,End=9910,Err=9920) IRLXROOT
            ReadStatus=' O.K. after reading relaxroot number IRLXROOT.'
            Call ChkIfKey()
            If (.not.Any(iRoot(1:LROOTS).eq.IRLXROOT)) Then
             Write(6,*) ' The selected root is not among those'//
     &                  ' available.'
             Call AbEnd()
            End If
         End If
         If (DBG) Then
            Write(6,*) ' MDRLxroot command was given.'
            Write(6,*) ' DYNAMIX will follow the root: ',IRLXROOT
         End If
      End If
CIgorS End
*
*---  Process CISE command --- (changed!) -----------------------------*
      If (DBG) Write(6,*) ' Check for CISELECT command.'
      If(KeyCISE) Then
       If (DBG) Then
        Write(6,*) ' CISELECT keyword was given.'
        Write(6,*) ' This input is awkward. Let''s find up'
        Write(6,*) ' a better way to do things.'
       End If
       ICICH=1
       Call SetPos(LUInput,'CISE',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Do i=1,NROOTS
         ReadStatus=' Failure reading after CISELECT keyword.'
         Read(LUInput,*,End=9910,Err=9920) kRef
         ReadStatus=' O.K. reading after CISELECT keyword.'
         If(kRef.gt.mxRef) Then
            Call WarningMessage(1,'CISElect input is wrong.')
            Write(LF,*) 'Number of CSF''s in CiSelect is out of bounds'
            Write(LF,'(a,i3,a,i3)') 'Specified:',kRef,', Max is',mxRef
            Write(LF,'(a,i3)') 'Standard fixup, value set to',mxRef
            kRef=mxRef
         End If
         ReadStatus=' Failure reading after CISELECT keyword.'
         Read(LUInput,*,End=9910,Err=9920) (ICI(i,iRef),iRef=1,kRef)
         Read(LUInput,*,End=9910,Err=9920) (CCI(i,iRef),iRef=1,kRef)
         ReadStatus=' O.K. reading after CISELECT keyword.'
         dSum=0.0d0
         Do iRef=1,kRef
            dSum=dSum+CCI(i,iRef)**2
         End Do
         Do iRef=1,kRef
            CCI(i,iRef)=CCI(i,iRef)/sqrt(dSum)
         End Do
         Do iRef=kRef+1,mxRef
            CCI(i,iRef)=0.0d0
            ICI(i,iRef)=0
         End Do
       End Do
       Call ChkIfKey()
      End If
*
*
*---  Process ALPH command --------------------------------------------*
      If (KeyALPH) Then
       If (DBG) Write(6,*)' The ALPH keyword was used.'
       Call SetPos(LUInput,'ALPH',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after ALPH keyword.'
       Read(LUInput,*,End=9910,Err=9920) iAlphaBeta
       ReadStatus=' O.K. after reading data after ALPH keyword.'
       If (iAlphaBeta.lt.0) iAlphaBeta=-1
       If (iAlphaBeta.gt.0) iAlphaBeta=1
       If (DBG) Then
        If (iAlphaBeta.eq.1) Write(6,*)' Read alpha orbitals from UHF'
        If (iAlphaBeta.eq.-1) Write(6,*)' Read beta orbitals from UHF'
       End If
       Call ChkIfKey()
      End If
*
* =========   Input source for orbitals: =============================*
* INVEC=0 is used to indicate if any source of orbitals has been
* identified.
* iOrbData=0 is used to indicate if any source of orbital type
* information -- inactive, ras1, etc -- has been identified.


      If (DBG) Write(6,*) ' Check for input source of orbitals.'
      If (DBG) Then
       Write(6,*)'KeyCORE,KeyJOBI,KeyLUMO:',KeyCORE,KeyJOBI,KeyLUMO
      End If
* Handle multiple keywords:
      If (KeyCORE) Then
        KeyJOBI=.false.
        KeyLUMO=.false.
      Else If (KeyJOBI) Then
        KeyLUMO=.false.
      End if
* Only one of these should have been selected.
      If (DBG) Then
       Write(6,*)'KeyCORE,KeyJOBI,KeyLUMO:',KeyCORE,KeyJOBI,KeyLUMO
      End If

* CORE is probably becoming obsolete.
*---  Process CORE command --------------------------------------------*
      If (KeyCORE) Then
       If (DBG) Write(6,*)' CORE command was used.'
        IF (IPRLEV.ge.VERBOSE) Write(LF,*)
     &     ' Start orbitals will be computed from scratch.'
       INVEC=1
      End If

*---  Process JOBI command --------------------------------------------*
      If (KeyJOBI) Then
       If (DBG) Write(6,*)' JOBIPH command was used.'
       Call f_Inquire('JOBOLD',lExists)
       If (lExists) Then
        IF (IPRLEV.ge.VERBOSE) Write(LF,*)
     &     ' Orbitals will be taken from the old jobiph file.'
        INVEC=3
       Else
        Call f_Inquire(IPHNAME,lExists)
        If (lExists) Then
         IF (IPRLEV.ge.VERBOSE) Write(LF,*)
     &     ' Orbitals will be taken from the jobiph file.'
         INVEC=3
        End If
       End If
       If (INVEC.eq.0) Then
        If (IPRLEV.ge.TERSE) Then
          Call WarningMessage(2,'JOBIPH input is wrong.')
          Write(6,*)' Keyword JOBIPH was used, but the ''JOBOLD'' file'
          Write(6,*)' does not exist. The ''JOBIPH'' file named'
          Write(6,*) IPHNAME
          Write(6,*)'also does not exist. This is a fatal error.'
          GoTo 9930
        End If
       End If
      End If

*---  Process H5OR command --------------------------------------------*
      If (KeyH5OR) Then
#ifdef _HDF5_
        KeyLUMO=.false.
        KeyTYPE=.false.
        iOverwr = merge(1, 0, any([KeyRAS1, KeyRAS2, KeyRAS3,
     &                             KeyFROZ, KeyINAC, KeyDELE]))
        mh5id = mh5_open_file_r(StartOrbFile)
*     read basic attributes
        call mh5_fetch_attr(mh5id, 'NSYM', NSYM_L)
        if (nsym.ne.nsym_l) then
          write (6,*) 'Number of symmetries on HDF5 file does not'
          write (6,*) 'match the number of symmetries on the'
          write (6,*) 'RunFile, calculation will stop now.'
          call Quit(_RC_INPUT_ERROR_)
        end if
        call mh5_fetch_attr(mh5id, 'NBAS', NBAS_L)
        ierr=0
        do isym=1,nsym
          if (nbas(isym).ne.nbas_l(isym)) ierr=1
        end do
        if (ierr.eq.1) then
          write (6,*) 'Number of basis functions on HDF5 file does not'
          write (6,*) 'match the number of basis functions on the'
          write (6,*) 'RunFile, calculation will stop now.'
          call Quit(_RC_INPUT_ERROR_)
        end if
*     orbitals available?
        select case (iAlphaBeta)
          case (1)
            Line='MO_ALPHA_VECTORS'
          case (-1)
            Line='MO_BETA_VECTORS'
          case default
            Line='MO_VECTORS'
        end select
        if (mh5_exists_dset(mh5id, trim(Line))) then
          inVec=4
        end if
*     typeindex data available?
        select case (iAlphaBeta)
          case (1)
            Line='MO_ALPHA_TYPEINDICES'
          case (-1)
            Line='MO_BETA_TYPEINDICES'
          case default
            Line='MO_TYPEINDICES'
        end select
        if (mh5_exists_dset(mh5id, trim(Line))) then
          iOrbData=3
          call mma_allocate(typestring, sum(nbas(1:nsym)))
          call mh5_fetch_dset(mh5id, trim(Line), typestring)
          call tpstr2orb(nsym_l,nbas_l,typestring,
     $            nfro_l,nish_l, nrs1_l,nrs2_l,nrs3_l, nssh_l,ndel_l)
          call mma_deallocate(typestring)
        end if
*     CI requested?
        if (KeyH5CI) then
          if (         mh5_exists_dset(mh5id, 'CI_VECTORS')
     $            .and.mh5_exists_attr(mh5id, 'NROOTS')) then
            call mh5_fetch_attr(mh5id, 'NROOTS', lroots_l)
            if (lroots_l.ne.lroots) then
              write (6,*) 'Number of CI roots on file does not'
              write (6,*) 'match the number requested by the user,'
              write (6,*) 'so no CI vectors will be read from'
              write (6,*) StartOrbFile
              iCIRST=0
            else
              iCIRST=1
            end if
          else
            write (6,*) 'The required fields CI_VECTORS and/or NROOTS'
            write (6,*) 'are missing from the HDF5 file supplied by'
            write (6,*) 'the user. As a result, to continue,'
            write (6,*) 'no CI vectors will be read from'
            write (6,*) StartOrbFile
            iCIRST=0
          end if
        end if
        call mh5_close_file(mh5id)
#else
        write (6,*) 'The format of the start orbital file was'
        write (6,*) 'specified by the user as HDF5, but this'
        write (6,*) 'is not implemented in this installation.'
        call Quit(_RC_INPUT_ERROR_)
#endif
      End If

*---  Process LUMO command --------------------------------------------*
      InfoLbl='        '
      If (KeyLUMO) Then
       If (DBG) Then
          Write(6,*)' LUMORB command was used.'
          Write(6,*)' Name of orbital file, StartOrbFile='
          Write(6,*) StartOrbFile
       End If
       Call ChkVec(StartOrbFile,inporb_version,NSYM_L,
     &                                   NBAS_L,NORB_L,InfoLbl,iRc1)
       If(iRc1.ne._RC_ALL_IS_WELL_) Then
        If (IPRLEV.ge.TERSE) Then
         Call WarningMessage(1,'LUMORB input error.')
         Write(6,*)' Keyword LUMORB used with file name StartOrbFile='
         Write(6,*) StartOrbFile
         Write(6,*)' but that file cannot be used. Perhaps it does'
         Write(6,*)' not exist?'
        End If
        iOverWr=1
       Else
        If (DBG) Then
         Write(6,*)' The file may be used to read input orbitals.'
         Write(6,*)' It is of type INPORB version ',inporb_version
         Write(6,*)' The information label is: ',InfoLbl
        End If
* Check that symmetry and basis function information match the runfile:
        IERR=0
        If(NSYM.ne.NSYM_L) THEN
         IERR=1
        Else
         DO ISYM=1,NSYM
          IF(NBAS(ISYM).ne.NBAS_L(ISYM))IERR=2
         END DO
        End If
        IF (IERR.ne. 0) Then
         Call WarningMessage(2,'Mismatch in start orbital file.')
         Write(6,*)' ERROR: Start orbital file name is '
         Write(6,*) StartOrbFile
         Write(6,*)' That file is a valid orbital file.'
         Write(6,*)' Version:',inporb_version
         Write(6,*)' But some information does not match.'
         IF(IERR.eq.1) Then
          Write(6,*)' In the file, nr of symmetries is =',NSYM_L
          Write(6,*)' but according to the runfile, it is=',NSYM
         ELSE IF(IERR.eq.2) Then
          Write(6,*)' In the file, nr of basis functions/symm is'
          Write(6,'(1x,8I5)')(NBAS_L(I),I=1,NSYM)
          Write(6,*)' but RUNFILE claims it is'
          Write(6,'(1x,8I5)')(NBAS(I),I=1,NSYM)
         End If
         Write(6,*)' Is it an old file left in workspace by mistake?'
         GOTO 9930
        End If

* This also implies that information on orbital types could be
* taken from typeindex on orbital file:
        if (('I' .in. to_upper(trim(InfoLbl)))
     &      .and. .not. any([KeyRAS1, KeyRAS2, KeyRAS3,
     &                       KeyFROZ, KeyINAC, KeyDELE])) then
          iOrbData=3
          iOverWr=0
          If (DBG) Then
           Write(6,*)' This means we may take orbital specifications'
           Write(6,*)' from the file, so set iOrbData=3, iOverWr=0.'
           Write(6,*)' The orbital spaces are read from typeindex.'
          End If
* We will also take the opportunity to find the orbital spaces size
* according to typeindex, for possible need below:
          Call GetMem('TypeIdx','Allo','Inte',ipType,mxOrb)
          LuStartOrb=19
          Call RdVec(StartOrbFile,LuStartOrb,'IA',NSYM_L,NBAS_L,NBAS_L,
     &            Dummy,Dummy,Dummy,iWork(ipType),myTitle,0,iErr)
          call tpidx2orb(NSYM_L,NBAS_L,
     $            iWork(ipType),
     $            NFRO_L,NISH_L,NRS1_L,NRS2_L,NRS3_L,NSSH_L,NDEL_L)
          Call GetMem('TypeIdx','Free','Inte',ipType,mxOrb)
          If (DBG) Then
           Write(6,*)' From RDTPIDX, we get:'
           Write(6,'(1x,A16,8I4)')' NBAS_L:',(NBAS_L(I),I=1,NSYM_L)
           Write(6,'(1x,A16,8I4)')' NORB_L:',(NORB_L(I),I=1,NSYM_L)
           Write(6,'(1x,A16,8I4)')' NFRO_L:',(NFRO_L(I),I=1,NSYM_L)
           Write(6,'(1x,A16,8I4)')' NISH_L:',(NISH_L(I),I=1,NSYM_L)
           Write(6,'(1x,A16,8I4)')' NRS1_L:',(NRS1_L(I),I=1,NSYM_L)
           Write(6,'(1x,A16,8I4)')' NRS2_L:',(NRS2_L(I),I=1,NSYM_L)
           Write(6,'(1x,A16,8I4)')' NRS3_L:',(NRS3_L(I),I=1,NSYM_L)
           Write(6,'(1x,A16,8I4)')' NSSH_L:',(NSSH_L(I),I=1,NSYM_L)
           Write(6,'(1x,A16,8I4)')' NDEL_L:',(NDEL_L(I),I=1,NSYM_L)
          End If
        Else
          iOverWr=1
        End If
       End If
       INVEC=2
      End If
      If (DBG) Write(6,*)' The INVEC    code is now',INVEC
      If (DBG) Write(6,*)' The iOrbData code is now',iOrbData
*
* =====================================================================
*
*---  Process TYPEindex command ---------------------------------------*
      If (DBG) Write(6,*)' Was TYPEINDEX requested?'
      If (KeyTYPE) Then
       Call SetPos(LUInput,'TYPE',Line,iRc)
       Call ChkIfKey()
       If (DBG) Then
        Write(6,*)' TYPEINDEX command was used.'
        Write(6,*)' The size of orbital spaces should be read from'
        Write(6,*)' typeindex in starting orbital file.'
       End If
       If( index(InfoLbl,'i').gt.0  .or. index(InfoLbl,'I').gt.0) Then
         iOrbData=3
         iOverwr=0
         IF(IPRLEV.ge.VERBOSE)
     &    Write(LF,*)' Orbital specification will be taken '//
     &               'from orbital file'
         Call GetMem('TypeIdx','Allo','Inte',ipType,mxOrb)
         LuStartOrb=19
         Call RdVec(StartOrbFile,LuStartOrb,'IA',NSYM_L,NBAS_L,NBAS_L,
     &           Dummy,Dummy,Dummy,iWork(ipType),myTitle,0,iErr)
         call tpidx2orb(NSYM_L,NBAS_L,
     $           iWork(ipType),
     $           NFRO_L,NISH_L,NRS1_L,NRS2_L,NRS3_L,NSSH_L,NDEL_L)
         Call GetMem('TypeIdx','Free','Inte',ipType,mxOrb)
         IERR=0
         IF (NSYM_L.ne.NSYM) IERR=1
         IF(IERR.eq.0) THEN
          DO ISYM=1,NSYM
           IF(NBAS(ISYM).ne.NBAS_L(ISYM))IERR=1
          END DO
         END IF
         IF (IERR.ne.0 .or. DBG) THEN
          Write(LF,*)
          Write(LF,'(6X,A)')'Specifications read from runfile:'
          Write(LF,'(6X,A)')'----------------------------------------'
          Write(LF,*)
          Write(LF,'(6X,A,T47,8I4)') 'Symmetry species',
     &                                (iSym,iSym=1,NSYM)
          Write(LF,'(6X,A,T47,8I4)') 'Number of basis functions',
     &                                (NBAS(iSym),iSym=1,NSYM)
          Write(LF,*)
          Write(LF,'(6X,A)')'Specifications read from orbital file:'
          Write(LF,'(6X,A)')'----------------------------------------'
          Write(LF,*)
          Write(LF,'(6X,A,T47,8I4)') 'Symmetry species',
     &                                (iSym,iSym=1,NSYM_L)
          Write(LF,'(6X,A,T47,8I4)') 'Frozen orbitals',
     &                                (NFRO_L(iSym),iSym=1,NSYM_L)
          Write(LF,'(6X,A,T47,8I4)') 'Inactive orbitals',
     &                                (NISH_L(iSym),iSym=1,NSYM_L)
          Write(LF,'(6X,A,T47,8I4)') 'RAS1 orbitals',
     &                                (NRS1_L(iSym),iSym=1,NSYM_L)
          Write(LF,'(6X,A,T47,8I4)') 'RAS2 orbitals',
     &                                (NRS2_L(iSym),iSym=1,NSYM_L)
          Write(LF,'(6X,A,T47,8I4)') 'RAS3 orbitals',
     &                                (NRS3_L(iSym),iSym=1,NSYM_L)
          Write(LF,'(6X,A,T47,8I4)') 'Secondary orbitals',
     &                                (NSSH_L(iSym),iSym=1,NSYM_L)
          Write(LF,'(6X,A,T47,8I4)') 'Deleted orbitals',
     &                                (NDEL_L(iSym),iSym=1,NSYM_L)
          Write(LF,'(6X,A,T47,8I4)') 'Number of basis functions',
     &                                (NBAS_L(iSym),iSym=1,NSYM_L)
          Write(LF,*)
         END IF
         IF (IERR.ne.0 .and.IPRLEV.ge.TERSE) THEN
          Write(6,*)' Orbital specifications were to be read from'
          Write(6,*)' orbital file, but there is mismatch with'
          Write(6,*)' some data on the runfile!'
          Write(6,*)' Orbital file name is:'
          Write(6,*) StartOrbFile
          iOrbData=0
         ELSE
          DO ISYM=1,NSYM
           NFRO(ISYM)=NFRO_L(ISYM)
           NISH(ISYM)=NISH_L(ISYM)
           NRS1(ISYM)=NRS1_L(ISYM)
           NRS2(ISYM)=NRS2_L(ISYM)
           NRS3(ISYM)=NRS3_L(ISYM)
           NSSH(ISYM)=NSSH_L(ISYM)
           NDEL(ISYM)=NDEL_L(ISYM)
          END DO
         END IF
       Else
        If (DBG) Write(6,*)' Typeindex cannot be read!'
       End If
      End If
      If (DBG) Write(6,*)' The iOrbData code is now',iOrbData

* =======================================================================
* Explicit orbital sizes input:
* Save a copy of current iorbdata first:
      iod_save=iorbdata
*---  Process FROZ command --------------------------------------------*
      If (KeyFROZ) Then
       If (DBG) Write(6,*) ' FROZEN keyword was given.'
       Call SetPos(LUInput,'FROZ',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading after FROZEN keyword.'
       Read(LUInput,*,End=9910,Err=9920) (NFRO(ISYM),ISYM=1,NSYM)
       ReadStatus=' O.K. reading after FROZEN keyword.'
       Call Get_iScalar('nSym',i)
       Call Put_iArray('nFro',nFro,i)
       If (DBG) Then
        Write(6,*) ' Nr of Frozen orbitals requested:'
        Write(6,'(1x,8i5)')(NFRO(i),i=1,NSYM)
       End If
       IORBDATA=1
      End If
*---  Process INAC command --------------------------------------------*
      If (KeyINAC) Then
       If (DBG) Write(6,*) ' INACTIVE keyword was given.'
       Call SetPos(LUInput,'INAC',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading after INACTIVE keyword.'
       Read(LUInput,*,End=9910,Err=9920) (NISH(ISYM),ISYM=1,NSYM)
       ReadStatus=' O.K. reading after INACTIVE keyword.'
       If (DBG) Then
        Write(6,*) ' Nr of Inactive orbitals requested:'
        Write(6,'(1x,8i5)')(NISH(i),i=1,NSYM)
       End If
       IORBDATA=1
      End If
*
*---  Process RAS1 command --------------------------------------------*
      If (KeyRAS1) Then
       If (DBG) Write(6,*) ' RAS1 keyword was given.'
       Call SetPos(LUInput,'RAS1',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading after RAS1 keyword.'
       Read(LUInput,*,End=9910,Err=9920) (NRS1(ISYM),ISYM=1,NSYM)
       ReadStatus=' O.K. reading after RAS1 keyword.'
       If (DBG) Then
        Write(6,*) ' Nr of RAS1 orbitals requested:'
        Write(6,'(1x,8i5)')(NRS1(i),i=1,NSYM)
       End If
       IORBDATA=1
      End If
*
*---  Process RAS2 command --------------------------------------------*
      If (KeyRAS2) Then
       If (DBG) Write(6,*) ' RAS2 keyword was given.'
       Call SetPos(LUInput,'RAS2',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading after RAS2 keyword.'
       Read(LUInput,*,End=9910,Err=9920) (NRS2(ISYM),ISYM=1,NSYM)
       ReadStatus=' O.K. reading after RAS2 keyword.'
       If (DBG) Then
        Write(6,*) ' Nr of Ras2 orbitals requested:'
        Write(6,'(1x,8i5)')(NRS2(i),i=1,NSYM)
       End If
       IORBDATA=1
      End If
*
*---  Process RAS3 command --------------------------------------------*
      If (KeyRAS3) Then
       If (DBG) Write(6,*) ' RAS3 keyword was given.'
       Call SetPos(LUInput,'RAS3',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading after RAS3 keyword.'
       Read(LUInput,*,End=9910,Err=9920) (NRS3(ISYM),ISYM=1,NSYM)
       ReadStatus=' O.K. reading after RAS3 keyword.'
       If (DBG) Then
        Write(6,*) ' Nr of Ras3 orbitals requested:'
        Write(6,'(1x,8i5)')(NRS3(i),i=1,NSYM)
       End If
       IORBDATA=1
      End If
*
*---  Process GASS command --------------------------------------------*
      If (KeyGASS) Then
       if(DBG) write(6,*) 'GAS is actived'
       call setpos(luinput,'GASS',line,irc)
       if(irc.ne._RC_ALL_IS_WELL_) goto 9810
       read(luinput,*,end=9910,err=9920) NGAS
       do igas=1,ngas
         read(luinput,*,end=9910,err=9920)
     &    (ngssh(igas,isym),isym=1,nsym)
         read(luinput,*,end=9910,err=9920)
     &    (igsoccx(igas,mm),mm=1,2)
       end do
       iDoGas = .true.
       iorbdata=1
      end if
*
*---  Process DELE command --------------------------------------------*
      If (KeyDELE) Then
       If (DBG) Write(6,*) ' DELETED keyword was given.'
       Call SetPos(LUInput,'DELE',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading after DELETED keyword.'
       Read(LUInput,*,End=9910,Err=9920) (NDEL(ISYM),ISYM=1,NSYM)
       ReadStatus=' O.K. after reading after DELETED keyword.'
       If (DBG) Then
        Write(6,*) ' Nr of Deleted orbitals requested:'
        Write(6,'(1x,8i5)')(NDEL(i),i=1,NSYM)
       End If
       IORBDATA=1
      End If

      IF (IORBDATA.eq.1 .and. IPRLEV.ge.VERBOSE) THEN
       Write(LF,*)' Orbital specification was read from input.'
      END IF
      IF (IOD_SAVE.eq.3 .and. IORBDATA.eq.1) THEN
* See if the input matches the values on file
       IERR=0
       DO ISYM=1,NSYM
        IF(NFRO(ISYM).ne.NFRO_L(ISYM))IERR=1
        IF(NISH(ISYM).ne.NISH_L(ISYM))IERR=1
        IF(NRS1(ISYM).ne.NRS1_L(ISYM))IERR=1
        IF(NRS2(ISYM).ne.NRS2_L(ISYM))IERR=1
        IF(NRS3(ISYM).ne.NRS3_L(ISYM))IERR=1
        IF(NSSH(ISYM).ne.NSSH_L(ISYM))IERR=1
        IF(NDEL(ISYM).ne.NDEL_L(ISYM))IERR=1
       END DO
       IF(IERR.eq.0) THEN
        IF (IORBDATA.eq.1 .and. IPRLEV.ge.VERBOSE) THEN
         Write(LF,*)' However, input matches the typeindex on the'
         Write(LF,*)' starting orbitals file. Therefore, accept'
         Write(LF,*)' the typeindex information for sorting.'
         iOrbData=3
         iOverWr=0
        END IF
       END IF
      END IF
      IF(IORBDATA.eq.3) THEN
       DO ISYM=1,NSYM
        NFRO(ISYM)=NFRO_L(ISYM)
        NISH(ISYM)=NISH_L(ISYM)
        NRS1(ISYM)=NRS1_L(ISYM)
        NRS2(ISYM)=NRS2_L(ISYM)
        NRS3(ISYM)=NRS3_L(ISYM)
        NSSH(ISYM)=NSSH_L(ISYM)
        NDEL(ISYM)=NDEL_L(ISYM)
       END DO
      END IF
* =======================================================================
* If IORBDATA is still 0, lets hope there is information on the runfile.
* Exception: If this is a CIRESTART, it must be taken from the JOBIPH
* (or JOBOLD) file.
      IF (IORBDATA.EQ.0) THEN
       IF(IPRLEV.ge.VERBOSE)
     &          Write(LF,*)' No explicit orbital specs in user input.'
       IF(KeyCIRE) Then
        IF(IPRLEV.ge.VERBOSE) Then
         Write(LF,*)' This is a CIRESTART case, so take them from'
         Write(LF,*)' the JOBIPH or JOBOLD file.'
        End If
        IORBDATA=2
        IF(IPRLEV.ge.VERBOSE)
     &    Write(LF,*)' Orbital specs taken from JOBIPH or JOBOLD.'
        IAD19=0
        iJOB=0
        Call f_Inquire('JOBOLD',lExists)
        If (lExists) iJOB=1
        if(JOBOLD.le.0) Then
          JOBOLD=20
        end if
        If (iJOB.eq.1) Then
           Call DaName(JOBOLD,'JOBOLD')
        Else
           If (IPRLEV.ge.TERSE) then
              Call WarningMessage(1,'JOBOLD not found, using JOBIPH.')
           End If
           If (JOBIPH.gt.0) Then
              JOBOLD=JOBIPH
           Else
              Call DaName(JOBOLD,'JOBIPH')
           End If
        End If
        Call IDaFile(JOBOLD,2,IADR19,10,IAD19)
* PAM Jan 2014 -- do not take POTNUC from JOBIPH; take it directly
* from runfile, where it was stored by seward.
        iAd19=iAdr19(1)
        CALL WR_RASSCF_Info(JobOld,2,iAd19,NACTEL,ISPIN,NSYM,STSYM,
     &                      NFRO,NISH,NASH,NDEL,NBAS,
     &                      mxSym,lJobH1,LENIN8*mxOrb,NCONF,
     &                      lJobH2,2*72,JobTit,4*18*mxTit,
     &                      POTNUCDUMMY,LROOTS,NROOTS,IROOT,mxRoot,
     &                      NRS1,NRS2,NRS3,NHOLE1,NELEC3,IPT2,WEIGHT)
       ELSE
        IF(IPRLEV.ge.VERBOSE) Then
         Write(LF,*)' This is not a CIRESTART case, so take them from'
         Write(LF,*)' the RUNFILE.'
        End If
        Call qpg_iArray('nAsh',lExists,nItems)
        IF (lExists .and. nItems.eq.nSym) THEN
         Call Get_iArray('nFro',nFro,nSym)
         Call Get_iArray('nISh',nISh,nSym)
         Call Get_iArray('nASh',nRS2,nSym)
         Call Get_iArray('nDel',nDel,nSym)
         IORBDATA=2
        END IF
       END IF
      End If
*---  complete orbital specifications ---------------------------------*
      Do iSym=1,nSym
        if(.not.iDoGas)then
          nash(isym)=nrs1(isym)+nrs2(isym)+nrs3(isym)
        else
          NASH(ISYM)=SUM(NGSSH(1:NGAS,ISYM))
        end if
        NORB(ISYM)=NBAS(ISYM)-NFRO(ISYM)-NDEL(ISYM)
        NSSH(ISYM)=NORB(ISYM)-NISH(ISYM)-NASH(ISYM)
      End Do
*---  Related data for sizes, etc.
      NTOT=0
      NTOT1=0
      NTOT2=0
      NO2M=0
      NISHT=0
      NASHT=0
      NDELT=0
      NFROT=0
      NSEC=0
      NORBT=0
      NTOT3=0
      NTOTSP=0
      NTOT4=0
      NRS1T=0 ! for RASSCF
      NRS2T=0
      NRS3T=0
c      Call FZero(NGSSH_tot,ngas)
c      do igas=1,ngas
c        NGSSH_tot(igas) = SUM(NGSSH(IGAS,1:NSYM))
c      end do
c      if(dbg) then
c        write(6,*) 'NGSSH_tot(igas):'
c        write(6,*) (NGSSH_tot(igas),igas=1,ngas)
c      end if
      DO ISYM=1,NSYM
         NTOT=NTOT+NBAS(ISYM)
         NTOT1=NTOT1+NBAS(ISYM)*(NBAS(ISYM)+1)/2
         NTOT2=NTOT2+NBAS(ISYM)**2
         NO2M=MAX(NO2M,NBAS(ISYM)**2)
         NRS1T=NRS1T+NRS1(ISYM)  ! for RAS
         NRS2T=NRS2T+NRS2(ISYM)
         NRS3T=NRS3T+NRS3(ISYM)
         NFROT=NFROT+NFRO(ISYM)
         NISHT=NISHT+NISH(ISYM)
         NASHT=NASHT+NASH(ISYM)
         NDELT=NDELT+NDEL(ISYM)
         NSEC=NSEC+NSSH(ISYM)
         NORBT=NORBT+NORB(ISYM)
         NTOT3=NTOT3+(NORB(ISYM)+NORB(ISYM)**2)/2
         NTOTSP=NTOTSP+(NASH(ISYM)*(NASH(ISYM)+1)/2)
         NTOT4=NTOT4+NORB(ISYM)**2
      END DO
      NACPAR=(NASHT+NASHT**2)/2
      NACPR2=(NACPAR+NACPAR**2)/2
* NASHT is called NAC in some places:
      NAC=NASHT
* Same, NISHT, NIN:
      NIN=NISHT
      NFR=NFROT
      If (DBG) Write(6,*)' The iOrbData code is now',iOrbData
* =======================================================================
* Compute effective nuclear charge.
* Identical to nr of protons for conventional basis sets only, not ECP.
      Call Get_iScalar('Unique atoms',nNuc)
      Call GetMem('EffNChrg','Allo','Real',ipENC,nNuc)
      Call Get_dArray('Effective nuclear Charge',Work(ipENC),nNuc)
      TEffNChrg=0.0D0
      Call GetMem('nStab','Allo','Inte',ipStab,nNuc)
      Call Get_iArray('nStab',iWork(ipStab),nNuc)
      do i=1,nNuc
       TEffNChrg=TEffNChrg+Work(ipENC-1+i)*DBLE(nSym/iWork(ipStab-1+i))
      end do
      Call GetMem('nStab','Free','Inte',ipStab,nNuc)
      Call GetMem('EffNChrg','Free','Real',ipENC,nNuc)
      If (DBG) Write(6,*)
     &             ' Effective nuclear charge is TEffNChrg=',TEffNChrg
      TotChrg=0.0D0
      If (DBG) Write(6,*)' Set TotChrg=',TotChrg
*---  Process NACT command --------------------------------------------*
      IF(KeyNACT) Then
C Cannot set the number of inactive orbitals if explicitly given or
C or if there is symmetry
       If(KeyCHAR.and.(KeyINAC.or.(NSYM.gt.1))) Then
        If(IPRLEV.ge.TERSE) Then
          call WarningMessage(1,
     &      'CHARGE and NACTEL are only compatible if '//
     &      'INACTIVE is not given and the symmetry group is C1. '//
     &      'Hence the CHARGE command will be ignored.')
        End If
        KeyCHAR=.false.
       End If
       If (DBG) Write(6,*) ' NACTEL keyword was given.'
       Call SetPos(LUInput,'NACT',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Line=Get_Ln(LUInput)
       ReadStatus=' Failure reading data after NACTEL keyword.'
       Read(Line,*,Err=9920,End=123) NACTEL,NHOLE1,NELEC3
       GoTo 124
123    Read(Line,*,Err=9920,End=9920) NACTEL
       NHOLE1=0
       NELEC3=0
124    Continue
       ReadStatus=' O.K. after reading data after NACTEL keyword.'
       If (DBG) Write(6,*) ' NACTEL,NHOLE1,NELEC3:',NACTEL,NHOLE1,NELEC3
C Only set total charge here if not explicitly given
       If(.not.KeyCHAR) Then
        TotChrg=TEffNChrg-DBLE(2.0D0*(NISHT+NFROT)+NACTEL)
        If (DBG) Write(6,*) ' TotChrg=',TotChrg
       EndIf
       Call Put_iScalar('nActel',NACTEL)
       Call ChkIfKey()
      End If
*---  Process CHARGE command --------------------------------------------*
      IF(KeyCHAR) Then
       If (DBG) Write(6,*) ' CHARGE command was given.'
       Call SetPos(LUInput,'CHAR',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Line=Get_Ln(LUInput)
       ReadStatus=' Failure reading charge after CHARGE keyword.'
       Read(Line,*,Err=9920) NCHRG
       ReadStatus=' O.K. reading charge after CHARGE keyword.'
       If (DBG) Write(6,*) ' Total charge is ',NCHRG
       TotChrg=DBLE(NCHRG)
       Call ChkIfKey()
C If both CHAR and NACT where given, set the inactive and secondary
C orbitals accordingly
       If (KeyNACT) Then
         NISHT_old=NISHT
         NISHT=(INT(TEffNChrg-TotChrg+0.5D0)-NACTEL)/2-NFROT
         NISH(1)=NISHT
         NIN=NISHT
         NSEC=NSEC-(NISHT-NISHT_old)
         NSSH(1)=NSEC
       End If
      End If
* The NINT function is unreliable on Cygwin gfortran, use INT:
* Nr of electrons should be positive integer, so this is probably safe:
      NACTEL=INT(TEffNChrg-TotChrg+0.5D0)-2*(NISHT+NFROT)
      Call Put_iScalar('nActel',NACTEL)
      If (DBG) Then
        write(6,*)' Compute NActEl from  other data:'
        write(6,*)'     TEffNChrg=',TEffNChrg
        write(6,*)'       TotChrg=',TotChrg
        write(6,*)'       NISHT  =',NISHT
        write(6,*)'       NFROT  =',NFROT
        write(6,*)' Resulting NActEl=',NActEl
      End If
*---  Process RASSCF command ------------------------------------------*
      IF(KeyRASS) Then
       If (DBG) Write(6,*) ' RASSCF keyword was given.'
       Call SetPos(LUInput,'RASS',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Line=Get_Ln(LUInput)
       ReadStatus=' Failure reading data after RASSCF keyword.'
       Read(Line,*,Err=9920,End=9920) NHOLE1,NELEC3
       ReadStatus=' O.K. reading data after RASSCF keyword.'
       Call ChkIfKey()
      End If
* =======================================================================
*---  Process SPIN command --------------------------------------------*
      If (DBG) Write(6,*)' Determine spin value:'
      IF(KeySPIN) Then
       If (DBG) Write(6,*) ' SPIN command was given.'
       Call SetPos(LUInput,'SPIN',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Line=Get_Ln(LUInput)
       ReadStatus=' Failure reading spin after SPIN keyword.'
       Read(Line,*,Err=9920) ISPIN
       ReadStatus=' O.K. reading spin after SPIN keyword.'
       If (DBG) Then
         Write(6,*) ' Spin multiplicity is ',ISPIN
         S=0.5D0*DBLE(ISPIN-1)
         Write(6,*) '  i.e. SPIN=',S
       End If
       Call ChkIfKey()
* If ISPIN has not been set, use some value that may have been set
* in runfile (e.g., UHF, or previous calculation)
      ELSE
        If (DBG) Write(6,*) ' No SPIN command was given.'
        Call qpg_iscalar('ISPIN',lExists)
        if(lExists) then
          Call get_iscalar('ISPIN',ISPIN)
          If (DBG) Write(6,*) ' Runfile has ISPIN=',ISPIN
        else
          If (DBG) Write(6,*) ' Runfile does not know ISPIN.'
          Call qpg_dscalar('UHFSPIN',lExists)
          if(lExists) then
           Call get_dscalar('UHFSPIN',SUHF)
           ISPIN=NINT(1.0D0+2.0D0*SUHF)
           If (DBG) Write(6,*) ' Runfile has UHFSPIN=',SUHF
          else
* or, last chance fallback, guess on singlet or doublet:
           If (DBG) Write(6,*) ' Runfile does not know UHFSPIN.'
           ISPIN=1
           IF(NACTEL.ne.2*(NACTEL/2)) ISPIN=2
           If(IPRLEV.ge.TERSE) Then
            Call WarningMessage(1,'Had to guess the spin.')
            Write(6,*)' Warning: no input and no reliable source'
            Write(6,*)' for the spin multiplicity.'
            Write(6,*)' Guess ISPIN=',ISPIN
           End If
          end if
        end if
      END IF
      Call put_iscalar('ISPIN',ISPIN)
* If spin is zero, do not compute and print spin density:
      IF (ISPIN.EQ.1) THEN
        ISPDEN=0
      END IF
* =======================================================================
      if (KeyDMPO) DumpOnly = .true.
* =======================================================================
      if (KeyReOr) then
        if(DBG) write(6,*) 'Orbital Reordering (REOR) is activated'
        call setpos(luinput, 'REOR', line, irc)
        if(irc /= _RC_ALL_IS_WELL_) goto 9810
        ReadStatus=' Failure reading ReOrFlag after REOR keyword.'
        read(luinput,*,end=9910,err=9920) ReOrFlag
        ReadStatus=' O.K. reading ReOrFlag after REOR keyword.'
        if (ReOrFlag < -1 .OR. ReOrFlag == 1) then
          call WarningMessage(2, 'Invalid flag for reordering. '//
     &      "n==0: Don't reorder. "//
     &      "n>=2: User defined permutation with n changed elements. "//
     &      "n==-1: Use GAS sorting scheme. ")
          GoTo 9930
        else if (ReOrFlag >= 2) then
          call mma_allocate(ReOrInp, ReOrFlag)
          ReadStatus=' Failure reading ReOrInp after REOR keyword.'
          read(luinput,*,end=9910,Err=9920)(ReOrInp(i),i=1,ReOrFlag)
          ReadStatus=' O.K. reading ReOrInp after REOR keyword.'
        else if ((ReOrFlag .eq. -1) .and. (.not. KeyGASS)) then
          call WarningMessage(2, 'If GAS is not used, a permutation '//
     & 'for orbital reordering has to be specified.')
          GoTo 9930
        end if
      end if
      if (KeyORTH) then
        call setpos(luinput,'ORTH',line,irc)
        if(irc.ne._RC_ALL_IS_WELL_) goto 9810
        read(luinput,*,end=9910,err=9920) ON_scheme_inp
        uppercased = to_upper(trim(ON_scheme_inp))
        if ('CANO' .in. uppercased) then
          ON_scheme%val = ON_scheme_values%Canonical
        else if ('LOWD' .in. uppercased) then
          ON_scheme%val = ON_scheme_values%Lowdin
        else if ('GRAM' .in. uppercased) then
          ON_scheme%val = ON_scheme_values%Gram_Schmidt
        else if ('NO_O' .in. uppercased) then
          ON_scheme%val = ON_scheme_values%No_ON
        else
          call WarningMessage(2, 'Invalid ORTH keyword')
          goto 9930
        end if
      end if
      if (KeyPERI) then
        write_orb_per_iter = .true.
      end if
*---  Process NECI commands -------------------------------------------*
      if (KeyNECI) then
        if(DBG) write(6, *) 'NECI is actived'
        DoNECI = .true.

        if (KeyDMPO) then
          call WarningMessage(2, 'NECI and DMPOnly are mutually '//
     &        'exclusive.')
          GoTo 9930
        end if
*----------------------------------------------------------------------------------------
        if(KeyEMBD) then
          DoEmbdNECI = .true.
#ifndef _NECI_
          call WarningMessage(2, 'EmbdNECI is given in input, '//
     &'so the embedded NECI should be used. Unfortunately MOLCAS was '//
     &'not compiled with embedded NECI. Please use -DNECI=ON '//
     &'for compiling or use an external NECI.')
#endif
        end if
*----------------------------------------------------------------------------------------
        if (KeyMCM7) then
            MCM7 = .true.
            if(DBG) write(6, *) 'M7 CASSCF activated.'
        end if
*----------------------------------------------------------------------------------------
        if (KeyH5DM) then
            tHDF5_RDMs = .true.
            if(DBG) write(6, *) 'RDMs will be read from HDF5 files'
            if (.not. KeyNECI .or. .not. KeyMCM7) then
              call WarningMessage(2, 'H5DM requires NECI/M7 keyword!')
              GoTo 9930
            end if
        end if
*----------------------------------------------------------------------------------------
        if (KeyGUGA) then
            tGUGA_in = .true.
            if(DBG) write(6, *) 'spin-free GUGA-NECI RDMs are actived'
            if (.not. KeyNECI) then
              call WarningMessage(2, 'GUGA requires NECI keyword!')
              GoTo 9930
            end if
        end if
*--- This block is to process the DEFINEDET -------------------
        if(KeyDEFI) then
          call setpos(luinput,'DEFI',line,irc)
          call mma_allocate(buffer,2000)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          ReadStatus = ' Failure reading Definedet.'
          Read(luinput,'(A)',end=9910,Err=9920) buffer
          ReadStatus = ' O.K. reading Definedet.'
          call mma_allocate(definedet,len_trim(buffer))
          definedet(:) = trim(buffer)
          call mma_deallocate(buffer)
          write(6,*)'definedet read in proc_inp of size:', nactel
          write(6,*) definedet
        end if
        if(KeyTOTA) then
          call setpos(luinput,'TOTA',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          ReadStatus = ' Failure reading totalwalkers.'
          read(luinput,*,end=9910,err=9920) totalwalkers
          ReadStatus = ' O.K. reading totalwalkers.'
        else
          call WarningMessage(2, 'TOTAlwalkers required for NECI.')
          goto 9930
        end if
        if(count([KeyRDML, (KeyRDMS .and. KeyCALC)]) /= 1)then
          call WarningMessage(2, 'RDMLinspace, '//
     &      'and (RDMSamplingiters + CALCrdmonfly) '//
     &      'are mutually exclusive, but one is required.')
          goto 9930
        else if (KeyRDML) then
          call setpos(luinput,'RDML',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920)
     &      RDMsampling%start, RDMsampling%n_samples, RDMsampling%step
        else if (KeyRDMS .or. KeyCALC) then
          if (.not. (KeyRDMS .and. KeyCALC)) then
            call WarningMessage(2, 'RDMSamplingiters '//
     &        'and CALCrdmonfly are both required.')
            goto 9930
          end if
          call setpos(luinput,'RDMS',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) start

          call setpos(luinput,'CALC',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) length, step
          RDMsampling = t_RDMsampling(start, length / step, step)
        end if
        if(KeyDIAG) then
          call setpos(luinput,'DIAG',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) diagshift
        end if
        if(KeyTIME) then
          call setpos(luinput,'TIME',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) Time
        end if
        if(KeyNMCY) then
          call setpos(luinput,'NMCY',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) nmCyc
        end if
        if(KeyREAL) then
          call setpos(luinput,'REAL',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) realspawncutoff
        end if
        if(KeyTRIA) then
          call setpos(luinput,'TRIA',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) trial_wavefunction
        end if
        if(KeyPOPS) then
          call setpos(luinput,'POPS',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) pops_trial
        end if
        if(KeySEMI) then
          call setpos(luinput,'SEMI',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) semi_stochastic
        end if
        if(KeyMEMO) then
          call setpos(luinput,'MEMO',line,irc)
          if(irc.ne._RC_ALL_IS_WELL_) goto 9810
          read(luinput,*,end=9910,err=9920) memoryfacspawn
        end if
        ! call fciqmc_option_check(iDoGas, nGSSH, iGSOCCX)
      end if

      if (KeyCCCI) then
        if(DBG) write(6, *) 'CC-CI is actived'
        Do_CC_CI = .true.

        if (KeyDMPO) then
          call WarningMessage(2, 'CC-CI and DMPOnly are mutually '//
     &        'exclusive.')
          GoTo 9930
        end if
      end if
*
* =======================================================================
      IF(KeySYMM) Then
*---  Process SYMM command --------------------------------------------*
       If (DBG) Write(6,*) ' SYMMETRY command was given.'
       Call SetPos(LUInput,'SYMM',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Line=Get_Ln(LUInput)
       ReadStatus=' Failure reading symmetry index after SYMM keyword.'
       Read(Line,*,Err=9920) STSYM
       ReadStatus=' O.K. reading symmetry index after SYMM keyword.'
       If (DBG) Write(6,*) ' State symmetry index ',STSYM
       Call ChkIfKey()
* If STSYM has not been set, normally it should be defaulted to 1.
* Exception: if this is a high-spin OS case, these often require STSYM.ne.1:
      ELSE
        STSYM=1
        IF(ISPIN.eq.NASHT+1) THEN
         DO ISYM=1,NSYM
          NA=NASH(ISYM)
          IF(NA.ne.2*(NA/2)) STSYM=MUL(STSYM,ISYM)
         END DO
        END IF
      END IF
      Call put_iscalar('STSYM',STSYM)
      If (DBG) Write(6,*)' State symmetry STSYM=',STSYM
*
* =======================================================================
*
*---  Process CIRE command --------------------------------------------*
      If (KeyCIRE) Then
       If (DBG) Write(6,*) ' CIRESTART keyword was given.'
       ICIRST=1
      End If
*
*---  Process HOME command (root homing in SXCI part)------------------*
      If (KeyHOME) Then
       SXSEL='HOMING  '
       If (DBG) Write(6,*) ' HOME (Root Homing) keyword was given.'
        Call SetPos(LUInput,'HOME',Line,iRc)
        Call ChkIfKey()
      End If
*
*---  Process SUPS command ---*
      If (KeySUPS) Then
       If (DBG) Write(6,*) ' SUPS (Supersymmetry) keyword was given.'
       Call SetPos(LUInput,'SUPS',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Call GetMem('Temp1','Allo','Inte',ipTemp1,mxOrb)
       ISUPSM=1
       iOffset=0
       Do iSym=1,nSym
          ReadStatus=' Failure reading data following SUPS keyword.'
          Read(LUInput,*,End=9910,Err=9920) nGrp
          ReadStatus=' O.K. after reading data following SUPS keyword.'
          Do iGrp=1,nGrp
             Call RdSups(LUInput,kOrb,iWork(ipTemp1))
             Do iOrb=1,kOrb
                IXSYM(iWork(ipTemp1+iOrb-1)+iOffset)=iGrp
             End Do
          End Do
          iOffset=iOffset+nBas(iSym)
       End Do
       Call GetMem('Temp1','Free','Inte',ipTemp1,mxOrb)
* (SVC) If both ALTER and SUPS keyword has been used, then change the IXSYM
* arrays according to the changed orbital ordering given in ALTER.
       Do iAlter=1,NAlter
         iChng1=IXSYM(iMAlter(iAlter,1))
         iChng2=IXSYM(iMAlter(iAlter,2))
         IXSYM(iMAlter(iAlter,1))=iChng2
         IXSYM(iMAlter(iAlter,2))=iChng1
       End Do
       Call ChkIfKey()
      End If
*
* --- Process HEXS command
      IF (KEYHEXS) THEN
        IF(DBG) WRITE(6,*) ' HEXS (Highly excited states)'//
     &                       ' keyword was given. '
       Call SetPos(LUInput,'HEXS',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       I_ELIMINATE_GAS_MOLCAS = 1
       ReadStatus=' Failure reading data following HEXS keyword.'
       Read(LUInput,*,End=9910,Err=9920) N_ELIMINATED_GAS_MOLCAS
       ReadStatus=' O.K. after reading data following HEXS keyword.'
         ReadStatus=' Failure reading data following HEXS keyword.'
         Read(LUInput,*,End=9910,Err=9920)
     &   (IELIMINATED_IN_GAS_MOLCAS(I),I=1,N_ELIMINATED_GAS_MOLCAS)
         ReadStatus=' O.K. after reading data following HEXS keyword.'
      END IF
*
* --- Process DEXS command
* At the moment same array as HEXS is being used
* If HEXS and DEXS should be used together rename one these arrays
*
      IF (KEYDEXS) THEN
        IF(DBG) WRITE(6,*) ' DEXS (Doubly excited states)'//
     &                       ' keyword was given. '
       Call SetPos(LUInput,'DEXS',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       I_ELIMINATE_GAS_MOLCAS = 2
       ReadStatus=' Failure reading data following HEXS keyword.'
       Read(LUInput,*,End=9910,Err=9920) N_ELIMINATED_GAS_MOLCAS
       ReadStatus=' O.K. after reading data following HEXS keyword.'
         ReadStatus=' Failure reading data following HEXS keyword.'
         Read(LUInput,*,End=9910,Err=9920)
     &   (IELIMINATED_IN_GAS_MOLCAS(I),I=1,N_ELIMINATED_GAS_MOLCAS)
         ReadStatus=' O.K. after reading data following HEXS keyword.'
      END IF
*
*---  Process HROO command ---
      IF (KEYHROO) THEN
        IF(DBG) WRITE(6,*) ' HROO (Hidden roots)'//
     &                       ' keyword was given. '
       Call SetPos(LUInput,'HROO',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data following HROO keyword.'
       Read(LUInput,*,End=9910,Err=9920) hRoots
       ReadStatus=' O.K. after reading data following HROO keyword.'
      END IF
*---  Process NKEE command ---
      IF (KEYNKEE) THEN
        IF(DBG) WRITE(6,*) ' NKEE (nr of kept vectors)'//
     &                       ' keyword was given. '
       Call SetPos(LUInput,'NKEE',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data following NKEE keyword.'
       Read(LUInput,*,End=9910,Err=9920) n_keep
       ReadStatus=' O.K. after reading data following NKEE keyword.'
       If (n_keep.lt.lRoots) Then
        Call WarningMessage(2,
     &   'nkeep must be at least equal to the number of roots')
        Call Quit(_RC_INPUT_ERROR_)
       EndIf
      END IF
*
*---  Process CLEA command ---
      If (KeyCLEA) Then
       If (DBG) Write(6,*) ' CLEAN (Orbital Cleaning) keyword.'
       If (DBG) Write(6,*) ' (Awkward input -- replace??).'
       Call SetPos(LUInput,'CLEA',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Call GetMem('Temp1','Allo','Inte',ipTemp1,mxOrb)
       Call GetMem('Temp2','Allo','Inte',ipTemp2,mxOrb)
       Call GetMem('Temp3','Allo','Inte',ipTemp3,mxOrb)
       ICLEAN=1
       nClean=0
       Do iSym = 1, nSym
          nClean=nClean+nBas(iSym)**2
       End Do
       Call GetMem('CleanMask','Allo','INTE',ipCleanmask,nClean)
       iOffset = ipCleanMask-1
       Do iSym=1,nSym
         mBas = nBas(iSym)
         Do i = 1,mBas
           ii = (i-1)*mBas
           Do j = 1,mBas
             ij = j+ii+iOffset
             iWork(ij) = 0
           End Do
         End Do
         ReadStatus=' Failure reading data following CLEAN keyword.'
         Read(LUInput,*,End=9910,Err=9920) nGrp
         ReadStatus=' O.K. after reading data following CLEAN keyword.'
         Do iGrp = 1,nGrp
          Call RdSups(LUInput,mOrb,iWork(ipTemp1))
          Call RdSups(LUInput,nCof,iWork(ipTemp2))
          Call RdSups(LUInput,mCof,iWork(ipTemp3))
          Do i = 1,mBas
            ii = (i-1)*mBas
            is_in_Group = 0
            Do j = 1,mOrb
              If ( iWork(ipTemp1+j-1).eq.i ) is_in_Group = 1
            End Do
            If ( is_in_Group.eq.1 ) then
              Do k = 1,nCof
                ij = iWork(ipTemp2+k-1)+ii+iOffset
                iWork(ij) = 1
              End Do
            Else
              Do k = 1,mCof
                ij = iWork(ipTemp3+k-1)+ii+iOffset
                iWork(ij) = 1
              End Do
            End If
          End Do
         End Do
         iOffset = iOffset+mBas*mBas
       End Do
       Call GetMem('Temp1','Free','Inte',ipTemp1,mxOrb)
       Call GetMem('Temp2','Free','Inte',ipTemp2,mxOrb)
       Call GetMem('Temp3','Free','Inte',ipTemp3,mxOrb)
       Call ChkIfKey()
      End If
*
*---  Process CHOL command (Cholesky Default Input, F.Aquilante Sept 04)
      If (KeyCHOL) Then
       If (DBG) Write(6,*) ' CHOLESKY keyword was given.'
       DoCholesky=.True.
       Call SetPos(LUInput,'CHOL',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Call Cho_rasscf_rdInp(.True.,LUInput)
      End If
*
*---  Process CHOI command (Cholesky Custom Input, F.Aquilante)
* Cholesky with user-defined settings.
      If (KeyCHOI) Then
       If (DBG) Write(6,*) ' CHOINPUT keyword was given.'
       DoCholesky=.True.
       Call SetPos(LUInput,'CHOI',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Call Cho_rasscf_rdInp(.False.,LUInput)
      End If
*
*---  Process ITER command --------------------------------------------*
      If (KeyITER) Then
       If (DBG) Write(6,*) ' ITERATIONS keyword was given.'
       Call SetPos(LUInput,'ITER',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data following ITER keyword.'
       Read(LUInput,*,End=9910,Err=9920) MAXIT,ITMAX
       ReadStatus=' O.K. reading data following ITER keyword.'
       If (DBG) Then
        Write(6,*) ' Max nr of RASSCF (macro) iterations MAXIT=',MAXIT
        Write(6,*) ' Max nr of orbital optimization iter ITMAX=',ITMAX
        If (KeyCION) Then
         Write(6,*)
     &  ' (Irrelevant, since the CIONLY keyword was also given)'
        End If
       End If
       Call ChkIfKey()
      End If
*
*---  Process CRPR command --------------------------------------------*
      If (KeyCRPR) Then
       If (DBG) Write(6,*) ' CRPR (Core Projector) keyword was used.'
       Call SetPos(LUInput,'CRPR',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading core orbital after CRPR keyword.'
       Read(LUInput,*,End=9910,Err=9920) ITCORE, CORESHIFT
       ReadStatus=' O.K. reading core orbital after CRPR keyword.'
       IfCRPR=.true.
       If (DBG) Write(6,*) ' Core orbital is number ITCORE'
       Call ChkIfKey()
      End If
*
*
*---  Process LEVS command --------------------------------------------*
      If (KeyLEVS) Then
       If (DBG) Write(6,*) ' LEVS (Level Shift) keyword was used.'
       Call SetPos(LUInput,'LEVS',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading level shift after LEVSHFT keyword.'
       Read(LUInput,*,End=9910,Err=9920) LVSHFT
       ReadStatus=' O.K. reading level shift after LEVSHFT keyword.'
       If (DBG) Write(6,*) ' Level shift LVSHFT (Re*8!!) =',LVSHFT
       Call ChkIfKey()
      End If

*
*---  Process THRS command --------------------------------------------*
      If (KeyTHRS) Then
       If (DBG) Write(6,*) ' THRS (Thresholds) command was used.'
       Call SetPos(LUInput,'THRS',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading thresholds after THRS keyword.'
       Read(LUInput,*,End=9910,Err=9920) THRE,THRTE,THRSX
       ReadStatus=' O.K. after reading thresholds after THRS keyword.'
*tbp, may 2013: no altering of thre with Cholesky
*tbp   If (DoCholesky.and.IPRLEV.GE.TERSE) then
*tbp     write(6,*)'*** Detected Cholesky or RI/DF calculation'
*tbp     write(6,*)' BUT user specified value of ThrE will be used.'//
*tbp &             ' ThrE= ',THRE
*tbp   End If
       If (DBG) Then
        Write(6,*) ' Threshold for energy change,    THRE =',THRE
        Write(6,*) ' Threshold for orbital rotation, THRTE=',THRTE
        Write(6,*) ' Threshold for max BLB element,  THRSX=',THRSX
       End If
       Call ChkIfKey()
      End If
*
*---  Process TIGH command --------------------------------------------*
      If (KeyTIGH) Then
       If (DBG) Write(6,*) ' TIGHT (Tight CI convergence)  used.'
       KTIGHT=1
       Call SetPos(LUInput,'TIGH',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after TIGHT keyword.'
       Read(LUInput,*,End=9910,Err=9920) THREN,THFACT
       ReadStatus=' O.K. reading data after TIGHT keyword.'
       If (DBG) Then
        Write(6,*) ' CI energy threshold in 1st iter, THREN=',THREN
        Write(6,*) ' CI Threshold/Energy change =    THFACT=',THFACT
       End If
       Call ChkIfKey()
      End If
*
* Use of quasi-newton ci/orbital coupling?
* Commands QUNE or NOQUNE:
      If (KeyNOQU) Then
        NQUNE=0
        If (DBG) Write(6,*) ' NOQUNE keyword: QUNE is disabled.'
        Call SetPos(LUInput,'NOQU',Line,iRc)
        Call ChkIfKey()
      Else If (KeyQUNE) Then
        If (DBG) Write(6,*) ' QUNE keyword: QUNE is enabled.'
        NQUNE=1
        Call SetPos(LUInput,'QUNE',Line,iRc)
        Call ChkIfKey()
      Else
* Default is to use QUNE, unless this is some kind of DFT:
       If (KeyKSDF) Then
         NQUNE=0
         If (DBG) Write(6,*) ' DFT calculation: QUNE is disabled.'
       Else
         NQUNE=1
         If (DBG) Write(6,*) ' QUNE is enabled by default.'
       End If
      End If
*
*---  Process AVER command --------------------------------------------*
      If (KeyAVER) Then
       If (DBG) Write(6,*) ' AVER (Symmetry averaging) is used.'
       If (DBG) Write(6,*) ' This is probably becoming obsolete.'
       Call SetPos(LUInput,'AVER',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after KAVER keyword.'
       Read(LUInput,*,End=9910,Err=9920) KAVER,(KSYM(I),I=1,2*KAVER)
       ReadStatus=' O.K. after reading data after KAVER keyword.'
       If (KAVER.ne.1 .and. KAVER.ne.2) Then
        If (IPRLEV.GE.TERSE) Then
         write(6,*)' AVER keyword used with inappropriate numbers'
         write(6,*)' and is ignored.'
        End If
        KAVER=0
        KeyAVER=.FALSE.
       End if
       If (DBG) Then
        Write(6,*) ' Averaging (blindly) density matrices of symmetry'
        Write(6,*) ' labels ',KSYM(1),' and ',KSYM(2)
        If (KAVER.eq.2) Then
         Write(6,*) ' and also labels ',KSYM(3),' and ',KSYM(4)
        End If
       End If
       Call ChkIfKey()
      End If
*
*---  Process CIMX command --------------------------------------------*
      If (KeyCIMX) Then
       If (DBG) Write(6,*) ' Keyword CIMX was used.'
       Call SetPos(LUInput,'CIMX',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after CIMX keyword.'
       Read(LUInput,*,End=9910,Err=9920) MAXJT
       ReadStatus=' O.K. after reading data after CIMX keyword.'
       If (DBG) Write(6,*) ' Max nr of CI iterations MAXJT=',MAXJT
       Call ChkIfKey()
      End If
*
*---  Process SDAV command --------------------------------------------*
      If (KeySDAV) Then
       If (DBG) Then
         Write(6,*) ' SDAV (Size of explicit Hamiltonian matrix)'
       End If
       Call SetPos(LUInput,'SDAV',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after SDAV keyword.'
       Read(LUInput,*,End=9910,Err=9920) NSEL
       ReadStatus=' O.K. after reading data after SDAV keyword.'
       If (DBG) Write(6,*) ' Size is NSEL=',NSEL
       Call ChkIfKey()
      End If
*
*---  Process OFEM commands for Orbital-Free embedding -------------*
      If (KeyOFEM) Then
       If (DBG) Then
         Write(6,*) ' OFEM (Orbital-Free Embedding activated)'
       End If
       Do_OFemb=.true.
       Call SetPos(LuInput,'OFEM',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after OFEM keyword.'
       Read(LUInput,'(A)',End=9910,Err=9920) OFE_KSDFT
       ReadStatus=' O.K. after reading data after OFEM keyword.'
       Call UpCase(OFE_KSDFT)
       OFE_KSDFT = adjustl(OFE_KSDFT)
       write(6,*)
       write(6,*)  '  --------------------------------------'
       write(6,*)  '   Orbital-Free Embedding Calculation'
       write(6,*)  '  --------------------------------------'
       If (OFE_KSDFT(1:4).eq.'LDTF') Then
        write(6,*) '    T_nad potential   : Thomas-Fermi    '
       Else
        write(6,*) '    T_nad potential   : ',OFE_KSDFT(1:4)
       EndIf
       If (KEonly) Then
        write(6,*) '    Exc_nad potential :  None           '
       Else
        write(6,*) '    Exc_nad potential : ',OFE_KSDFT(6:10)
       EndIf
       write(6,*)  '  --------------------------------------'
       write(6,*)
       DFTFOCK='SCF '
      EndIf
      If (KeyFTHA) Then
       Call SetPos(LuInput,'FTHA',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after FTHA keyword.'
       Read(LUInput,*,End=9910,Err=9920) ThrFThaw
       ReadStatus=' O.K. after reading data after FTHA keyword.'
      EndIf
      If (KeyDFMD) Then
       Call SetPos(LuInput,'DFMD',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after DFMD keyword.'
       Read(LUInput,*,End=9910,Err=9920) dFMD, Xsigma
       ReadStatus=' O.K. after reading data after DFMD keyword.'
c       Write(6,'(A,F6.3)') '  Fract. correl. potent. DFMD=',dFMD
c       write(6,*)          '  --------------------------------------'
       If (dFMD+Xsigma.lt.0.0d0) Then
        write(6,*)' *** Warning: arguments to DFMD must be nonnegative!'
        write(6,*)' ***          I will take their ABS !!! '
        dFMD=abs(dFMD)
        Xsigma=abs(Xsigma)
       EndIf
      EndIf
*
*---  Process BKAP command for BK type of approximation
*     (Giovanni Li Manni J.:GLMJ) Nov 2011                -------------*
      If (KeyBKAP) Then
       DoBKAP = .true.
       Call SetPos(LUInput,'BKAP',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after BKAP keyword.'
       Read(LUInput,*,End=9910,Err=9920) NGASBK
       Read(LUInput,*,End=9910,Err=9920)(IOCCPSPC(IGAS,1),IGAS=1,NGASBK)
       Read(LUInput,*,End=9910,Err=9920)(IOCCPSPC(IGAS,2),IGAS=1,NGASBK)
       ReadStatus=' O.K. reading data after BKAP keyword.'
       If (DBG) Then
         write(6,*) ' BKAP: BK-type of approximation in action'
         write(6,*) ' Min and Max for subspace with exact Hamiltonian '
         write(6,*) ' =============================================== '
         write(6,*) ' NGASBK :',NGASBK
         write(6,*) '              Min. Occ.      Max. Occ.           '
         Do IGAS = 1, NGASBK
           write(6,'(A,I2,10X,I3,9X,I3)')
     &     '   GAS',IGAS,IOCCPSPC(IGAS,1),IOCCPSPC(IGAS,2)
         End do
       End If
      End If
*
*---  Process SPLI command for SplitCAS calculations
*     (Giovanni Li Manni J.:GLMJ)                         -------------*
      If (KeySPLI) Then
       If (DBG) Then
         Write(6,*) ' SPLI (Activation SplitCAS)'
       End If
       DoSplitCAS = .true.
       EnerSplit  = .true.
       iDimBlockA = 0
**** The energy gap (GapSpli) is in eV ****
       GapSpli    = 13.61
       lrootSplit= 1
       thrSplit = 1.0d-6
       MxIterSplit = 50
       Call SetPos(LUInput,'SPLI',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
      End If
*
*---  Process NUSP command for Numerical SplitCAS param. (GLMJ) --------*
      If (KeyNUSP) Then
       If (DBG) Then
         Write(6,*)' NUSP - Manual Setting of Numerical SplitCAS Param.'
       End If
       EnerSplit  = .false.
       NumSplit  = .true.
       Call SetPos(LUInput,'NUSP',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after NUSP keyword.'
       Read(LUInput,*,End=9910,Err=9920)
     *              lrootSplit,iDimBlockA,MxIterSplit
       ReadStatus=' O.K. reading data after NUSP keyword.'
*       Read(LUInput,*,End=9910,Err=9920) lrootSplit
*       Read(LUInput,*,End=9910,Err=9920) iDimBlockA
*       Read(LUInput,*,End=9910,Err=9920) MxIterSplit
       ReadStatus=' Failure reading data after NUSP keyword.'
       Read(LUInput,*,End=9910,Err=9920) ThrSplit
       ReadStatus=' O.K. reading data after NUSP keyword.'
       If (DBG) then
         Write(6,*) ' Root to be opt. in SplitCAS = ', lrootSplit
         Write(6,*) ' AA block size in SplitCAS = ',iDimBlockA
         Write(6,*) ' Max iteration in SplitCAS = ', MxIterSplit
         Write(6,*) ' Root to be opt. in SplitCAS = ', ThrSplit
       end if
      End If
*
*---  Process ENSP command for Energetical SplitCAS param. (GLMJ) -----*
      If (KeyENSP) Then
       If (DBG) Then
         Write(6,*)
     *   ' ENSP - Manual Setting of Energetical SplitCAS Param.'
       End If
       EnerSplit  = .true.
       NumSplit  = .false.
       iDimBlockA = 0
       Call SetPos(LUInput,'ENSP',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after ENSP keyword.'
       Read(LUInput,*,End=9910,Err=9920)
     *              lrootSplit,GapSpli,MxIterSplit
       ReadStatus=' O.K. reading data after ENSP keyword.'
*       Read(LUInput,*,End=9910,Err=9920) lrootSplit
*       Read(LUInput,*,End=9910,Err=9920) iDimBlockA
*       Read(LUInput,*,End=9910,Err=9920) MxIterSplit
       ReadStatus=' Failure reading data after ENSP keyword.'
       Read(LUInput,*,End=9910,Err=9920) ThrSplit
       ReadStatus=' O.K. reading data after ENSP keyword.'
       If (DBG) Write(6,*) ' Root to be opt. in SplitCAS = ', lrootSplit
       If (DBG) Write(6,*) ' Energy gap in SplitCAS = ', GapSpli
       If (DBG) Write(6,*) ' Max iteration in SplitCAS = ', MxIterSplit
       If (DBG) Write(6,*) ' Root to be opt. in SplitCAS = ', ThrSplit
      End If
*
*---  Process PESP command for Percentage SplitCAS param. (GLMJ) ------*
      If (KeyPESP) Then
       If (DBG) Then
         Write(6,*)
     *   ' PESP - Manual Setting of Percentage SplitCAS Param.'
       End If
       EnerSplit  = .false.
       PerSplit  = .true.
       NumSplit  = .false.
       iDimBlockA = 0
       Call SetPos(LUInput,'PESP',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after PESP keyword.'
       Read(LUInput,*,End=9910,Err=9920)
     *              lrootSplit,PercSpli,MxIterSplit
       Read(LUInput,*,End=9910,Err=9920) ThrSplit
       ReadStatus=' O.K. reading data after PESP keyword.'
       If (DBG) Write(6,*) ' Root to be opt. in SplitCAS = ', lrootSplit
       If (DBG) Write(6,*) ' Percentage in SplitCAS = ', PercSpli
       If (DBG) Write(6,*) ' Max iteration in SplitCAS = ', MxIterSplit
       If (DBG) Write(6,*) ' Root to be opt. in SplitCAS = ', ThrSplit
      End If
*
*------- Process FOSP command for First Order SplitCAS Approx. (GLMJ) -*
      If (KeyFOSP) Then
       If (DBG) Then
         Write(6,*)
     *   ' FOSP - First Order SplitCAS Approx.'
       End If
       FOrdSplit  = .true.
      End If
*
*---  Process OPTO keyword: Optimal Output for RASSCF/CASPT2
*                           optimizations - GG Nov 2008.
      If (KeyOPTO) Then
       If (DBG) Then
        Write(6,*) ' OPTO keyword was used.'
        Write(6,*) '(Optimal Output for RASSCF/CASPT2)'
       End If
       lOPTO=.True.
       Call SetPos(LUInput,'OPTO',Line,iRc)
       Call ChkIfKey()
      End If
*
*---  Process SXDAmp command ------------------------------------------*
      If (KeySXDA) Then
       If (DBG) Write(6,*)' SXDAMPING was requested.'
       Call SetPos(LUInput,'SXDA',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after SXDAMP keyword.'
       Read(LUInput,*,End=9910,Err=9920) SXDamp
       ReadStatus=' O.K. after reading data after SXDAMP keyword.'
       If (DBG) Write(6,*)' Parameter SXDamp=',SXDamp
       Call ChkIfKey()
      End If
*
*---  Process LOWM command ---
      If (KeyLOWM) Then
       If (DBG) Then
         Write(6,*)' LOWM keyword was used to force the CI routines'
         Write(6,*)' to use Slater Determinants for low M and not M=S'
       End If
       LOWMS=1
       Call SetPos(LUInput,'LOWM',Line,iRc)
       Call ChkIfKey()
      End If
*
*---  Process LOWD keyword: Turn on Lowdin orthonormalization of CMOs
      If (KeyLOWD) Then
       If (DBG) Then
         Write(6,*)' LOWDIN orthonormalization was requested'
         Write(6,*)' but from Jan 12 2010 that is default anyway.'
       End If
       Lowdin_ON=.True.
       Call SetPos(LUInput,'LOWD',Line,iRc)
       Call ChkIfKey()
      End If
*
*---  Process PRWF command --------------------------------------------*
      If (KeyPRWF) Then
       If (DBG) Write(6,*)' The PRWF keyword was used.'
       Call SetPos(LUInput,'PRWF',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after PRWF keyword.'
       Read(LUInput,*,End=9910,Err=9920) PRWTHR
       ReadStatus=' O.K. after reading data after PRWF keyword.'
       If (DBG) Write(6,*)' Print CI coefficients larger than PRWTHR=',
     &                     PRWTHR
       Call ChkIfKey()
      End If
*
*---  Process PRSD command --------------------------------------------*
      If (KeyPRSD) Then
       If (DBG) Write(6,*)' The PRSD keyword was used.'
       Call SetPos(LUInput,'PRSD',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       If (DBG) Write(6,*)' Print determinant expansions of CSFs'
       Call ChkIfKey()
      End If
*
*---  Process FCIDUMP command -----------------------------------------*
      If (KeyFCID) Then
!      activate the DMRG interface in RASSCF (dummy here since we stop after FCIDUMP)
       DOFCIDUMP = .true.
       if(.not.KeyDMRG) KeyDMRG = .true.
       Call SetPos(LUInput,'FCID',Line,iRc)
       Call ChkIfKey()
      End If
#if !defined _ENABLE_BLOCK_DMRG_ && !defined _ENABLE_CHEMPS2_DMRG_
*
* ======================================================================
*          start of QCMaquis DMRG input section
* =======================================================================
#ifdef _DMRG_
      If(keyDMRG .or. doDMRG)then
        if(.not.doDMRG)then
          Call SetPos(LUInput,'DMRG',Line,iRc)
          Call ChkIfKey()
        end if
        !> DMRG flag
        doDMRG=.true.
        LRras2_dmrg(1:8) = 0
        !> LRras2 = Ras2 as the default
        do i=1,nsym
          LRras2_dmrg(i) = NRS2(i)
        end do
        !> initial guess setup
        guess_dmrg(1:7) = 'DEFAULT'
        call mma_allocate(initial_occ,nrs2t,nroots); initial_occ = 0
      end if
*
*---  Process RGIN command (QCMaquis Custom Input) --------------------*
      If (KeyRGIN) Then
        If (DBG) Write(6,*) ' RGINPUT keyword was given.'
        If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
        Call SetPos(LUInput,'RGIN',Line,iRc)

        if(.not.KeyDMRG)then
          if(.not.doDMRG)then
            Call WarningMessage(2,'Error in input processing.')
            Write(6,*)' PROC_INP: the keyword DMRG is not present but'
            Write(6,*)' is required to enable the DMRG internal keyword'
            Write(6,*)' section RGInput.'
            iRc=_RC_INPUT_ERROR_
            Go to 9900
          end if
        end if

        nr_lines = 0
        call qcmaquis_rdinp(LuInput,1,nr_lines)
        Call SetPos(LUInput,'RGIN',Line,iRc)
        call qcmaquis_rdinp(LuInput,2,nr_lines)

      End if
*
*---  Process SOCC command (state occupation for initial guess in DMRG)
      If (KeySOCC) Then
        If (DBG) Write(6,*) ' SOCC keyword was given.'
        If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
        Call SetPos(LUInput,'SOCC',Line,iRc)

        if(keyDMRG.or.doDMRG)then
          call socc_dmrg_rdinp(LuInput,initial_occ,nrs2t,nroots)
          guess_dmrg(1:7) = 'HF     '
        end if
      End if
#endif
*
*-- Leon: Process NEVP(t2prep) keyword, prepare for 4-RDM calculation
*--- for (CD)-DMRG-NEVPT2
      If (KeyNEVP) Then
        If (DBG) Write(6,*) ' NEVP(t2prep) keyword was given.'
        If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
#ifdef _DMRG_
        if(.not.KeyDMRG.and..not.doDMRG)then
          Call WarningMessage(2,'Error in input processing.')
          Write(6,*)' PROC_INP: the keyword DMRG is not present or'
          Write(6,*)' DMRG not activated but is required to enable'
          Write(6,*)' the NEVP keyword.'
          iRc=_RC_INPUT_ERROR_
          Go to 9900
        end if

        DoNEVPT2Prep = .TRUE.
        Call SetPos(LUInput,'NEVP',Line,iRc)
        Line=Get_Ln(LUInput)
        call UpCase(Line)
        If (Index(Line,'EVRD').ne.0) then
         Call WarningMessage(2,'Warning,EvRDM keyword is deprecated.')
         Write(6,*) ('RDM evaluation is done in NEVPT2 module now')
        end if

#else
        Call WarningMessage(2,'Error in input processing.')
        Write(6,*) ('MOLCAS was compiled without QCMaquis support.')
        Write(6,*) ('Thus, no DMRG-NEVPT2 calculations are possible.')
        iRc=_RC_INPUT_ERROR_
        Go to 9900
#endif
      End If

#ifdef _DMRG_
      !> sanity checks
      !> a. DMRG requested but mandatory keywords not set at all
      if((KeyDMRG .or. doDMRG) .and.
     &   (.not.KeyRGIN .and. .not.as_solver_inp_proc))then
        Call WarningMessage(2,'Error in input processing.')
        Write(6,*)' PROC_INP: the keyword RGINput is not present but'
        Write(6,*)' is required for QCMaquis DMRG calculations in order'
        Write(6,*)' to set compulsory DMRG internal parameters as'
        Write(6,*)' for example:'
        Write(6,*)' max_bond_dimension, conv_thresh and nsweeps.'
        Write(6,*)' See the QCMaquis manual for further details.'
        iRc=_RC_INPUT_ERROR_
        Go to 9900
      end if
      !> b. DMRG requested so check that ALL mandatory keywords have been set
      if((KeyDMRG .or. doDMRG).and.(KeyRGIN.or.as_solver_inp_proc))then
        nr_lines = dmrg_input%nr_qcmaquis_input_lines
        call qcmaquis_rdinp(LuInput,3,nr_lines)
        if(nr_lines <= 0)then
          iRc=_RC_INPUT_ERROR_
          Go to 9900
        end if
      end if
#endif
* ======================================================================
*          end of QCMaquis DMRG input section
* ======================================================================
#endif
*
*---  Process FARO command --------------------------------------------*
      If (KeyFARO) Then
        DoFaro = .TRUE.
      End If
*
*---  Process NOCA command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if NOCALC case.'
      If (KeyNOCA) Then
       If (DBG) Write(6,*) ' NOCALC keyword was used.'
       INOCALC=1
       Call SetPos(LUInput,'NOCA',Line,iRc)
       Call ChkIfKey()
      End If
*
*---  Process SAVE command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if SAVE_EXP case.'
      If (KeySAVE) Then
       If (DBG) Write(6,*) ' SAVE_EXP keyword was used.'
       ISAVE_EXP=1
       Call SetPos(LUInput,'SAVE',Line,iRc)
       Call ChkIfKey()
      End If
*
*---  Process EXPA command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if EXPAND case.'
      If (KeyEXPA) Then
       If (DBG) Write(6,*) ' EXPAND keyword was used.'
       IEXPAND=1
       Call SetPos(LUInput,'EXPA',Line,iRc)
       Call ChkIfKey()
      End If
*
*---  Process DMRG command --------------------------------------------*
#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_
      If (KeyDMRG) Then
* NN.14 FIXME: When DMRG option is disabled at compilation,
*       this should give an error, but just ignored for the time.
       If (DBG) Then
         Write(6,*) ' DMRG (Use DMRG algorithm instead of FCI)'
       End If
       Call SetPos(LUInput,'DMRG',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after DMRG keyword.'
       Read(LUInput,*,End=9910,Err=9920) MxDMRG
       ReadStatus=' O.K. after reading data after DMRG keyword.'
       If (DBG) Write(6,*) ' Nr. of states=',MxDMRG
       DoBlockDMRG=.True.
       Call ChkIfKey()
      End If
*
*---  Process 3RDM command --------------------------------------------*
      If (Key3RDM) Then
       If (DBG) Then
         Write(6,*) ' 3RDM (Compute 3RDM for DMRG-Cu4-CASPT2)'
       End If
       Do3RDM=.True.
#ifdef _ENABLE_CHEMPS2_DMRG_
       iOrbTyp = 2
       IPT2 = 1
       Write(6,*)
     & 'CHEMPS2> 3-RDM and F4-RDM require PseudoCanonical orbitals'
       Write(6,*) 'CHEMPS2> Automatically set: OUTOrbitals = CANOnical'
       if (KeySUPS) then
         write(6,*) 'CHEMPS2> Bug using SYPSym and 3RDM, disable SUPSym'
         Call Abend()
       endif
#endif
       Call SetPos(LUInput,'3RDM',Line,iRc)
       Call ChkIfKey()
      End If

#ifdef _ENABLE_CHEMPS2_DMRG_
*
*---  Process DAVT command --------------------------------------------*
      If (KeyDAVT) Then
       Call SetPos(LUInput,'DAVT',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after DAVT keyword.'
       Read(LUInput,*,End=9910,Err=9920) davidson_tol
       ReadStatus=' O.K. after reading data after DAVT keyword.'
       Call ChkIfKey()
      End If
*
*---  Process CHRE command --------------------------------------------*
      If (KeyCHRE) Then
       If (DBG) Then
         Write(6,*) ' Restart in CheMPS2'
       End If
       chemps2_restart=.True.
       Call SetPos(LUInput,'CHRE',Line,iRc)
       Call ChkIfKey()
      End If
*
*---  Process CHBL command --------------------------------------------*
      If (KeyCHBL) Then
       Call SetPos(LUInput,'CHBL',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after CHBL keyword.'
       Read(LUInput,*,End=9910,Err=9920) chemps2_blb
       ReadStatus=' O.K. after reading data after CHBL keyword.'
       Call ChkIfKey()
      End If
*
*---  Process MXSW command --------------------------------------------*
      If (KeyMXSW) Then
       Call SetPos(LUInput,'MXSW',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after MXSW keyword.'
       Read(LUInput,*,End=9910,Err=9920) max_sweep
       ReadStatus=' O.K. after reading data after MXSW keyword.'
       Call ChkIfKey()
      End If
*
*---  Process NOIS command --------------------------------------------*
      If (KeyNOIS) Then
       Call SetPos(LUInput,'NOIS',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after NOIS keyword.'
       Read(LUInput,*,End=9910,Err=9920) chemps2_noise
       ReadStatus=' O.K. after reading data after NOIS keyword.'
       Call ChkIfKey()
      End If
*
*---  Process DMRE command --------------------------------------------*
      If (KeyDMRE) Then
       Call SetPos(LUInput,'DMRE',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after DMRE keyword.'
       Read(LUInput,*,End=9910,Err=9920) chemps2_lrestart
       ReadStatus=' O.K. after reading data after DMRE keyword.'
       Call ChkIfKey()
      End If
*
*---  Process MXCA command --------------------------------------------*
      If (KeyMXCA) Then
       Call SetPos(LUInput,'MXCA',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after MXCA keyword.'
       Read(LUInput,*,End=9910,Err=9920) max_canonical
       ReadStatus=' O.K. after reading data after MXCA keyword.'
       Call ChkIfKey()
      End If
*
#endif

#endif
*---  Process HFOC command --------------------------------------------*
* This keyword is to specify a user customized orbs occupancies guess.
* It is used by Block and CheMPS2... but it could be useful for other codes.
* Therefore it is now outside the ifdef Block or CheMPS2.
      If (KeyHFOC) Then
       Write(6,*) ' HFOC keyword was given.'
       Call SetPos(LUInput,'HFOC',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading after HFOC keyword.'
       write(6,*) 'NASHT, mxact = ', NASHT, mxact
       Read(LUInput,*,End=9910,Err=9920) (hfocc(i),i=1,NASHT)
       ReadStatus=' O.K. reading after HFOC keyword.'
       write(6,*)'HFOCC read in proc_inp of size:', NASHT
       write(6,*)(hfocc(i),i=1,NASHT)
      End If

#ifdef _ENABLE_DICE_SHCI_
*---  Process DICE command --------------------------------------------*
      If (KeyDICE) Then
       DoBlockDMRG = .True.
       Write(6,*) 'DICE> (semistochastic) heat bath configuration ',
     & 'interaction (SHCI)'
       Call SetPos(LUInput,'DICE',Line,iRc)
       Call ChkIfKey()
      End If
*---  Process STOC command --------------------------------------------*
      If (KeySTOC) Then
       Dice_Stoc=.True.
       Write(6,*) 'DICE> Using semistochastic algorithm',
     & 'interaction (SHCI)'
       Call SetPos(LUInput,'STOC',Line,iRc)
       Call ChkIfKey()
      End If
*---  Process DIOC command --------------------------------------------*
      DICEOCC = ''
      If (KeyDIOC) Then
       Call SetPos(LUInput,'DIOC',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after DIOC keyword.'
       Read(LUInput,*,End=9910,Err=9920) nref_dice
       do iref_dice=1,nref_dice
          Read(LUInput,'(A)',End=9910,Err=9920) diceocc(iref_dice)
          call molcas2dice(diceocc(iref_dice))
       enddo
       ReadStatus=' O.K. after reading data after DIOC keyword.'
       Call ChkIfKey()
      End If
*---  Process EPSI command --------------------------------------------*
      If (KeyEPSI) Then
       If (DBG) Write(6,*) ' EPS (Thresholds) command was used.'
       Call SetPos(LUInput,'EPS',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading thresholds after EPSI keyword.'
       Read(LUInput,*,End=9910,Err=9920) dice_eps1,dice_eps2
       ReadStatus=' O.K. after reading thresholds after EPSI keyword.'
       Call ChkIfKey()
      End If
*---  Process SAMP command --------------------------------------------*
      If (KeySAMP) Then
       Call SetPos(LUInput,'SAMP',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after SAMP keyword.'
       Read(LUInput,*,End=9910,Err=9920) dice_sampleN
       ReadStatus=' O.K. after reading data after SAMP keyword.'
       Call ChkIfKey()
      End If
*---  Process DITE command --------------------------------------------*
      If (KeyDITE) Then
       Call SetPos(LUInput,'DITE',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure reading data after DITE keyword.'
       Read(LUInput,*,End=9910,Err=9920) dice_iter
       ReadStatus=' O.K. after reading data after DITE keyword.'
       Call ChkIfKey()
      End If
*---  Process DIRE command --------------------------------------------*
      If (KeyDIRE) Then
       dice_restart=.True.
       Call SetPos(LUInput,'DIRE',Line,iRc)
       Call ChkIfKey()
      End If
#endif

*---  All keywords have been processed ------------------------------*

      If (.not.KeyINAC) Then
        If (Sum(nIsh(:nSym)).eq.0)
     &    Call WarningMessage(1,
     &      'The number of inactive orbitals is zero. '//
     &      'Do you really want this?')
      End If

      IF (IfCRPR) Then
* Core shift using a fixed projection operator.
        NCRVEC=NBAS(1)
        Call GetMem('CRVEC','Allo','Real',LCRVEC,NCRVEC)
        N=NBAS(1)
        NCRPROJ=(N*(N+1)*(N**2+N+2))/8
        Call GetMem('CRPROJ','Allo','Real',LCRPROJ,NCRPROJ)
      END IF
************************************************************************
* Generate artificial splitting or RAS into GAS for parallel blocking  *
************************************************************************
      IF (.NOT.IDOGAS) THEN
* SVC: convert CAS/RAS to general GAS description here, then we only
* need to copy it for lucia later, which always uses GAS description.
        NGSSH(1,1:NSYM)=NRS1(1:NSYM)
        NGSSH(2,1:NSYM)=NRS2(1:NSYM)
        NGSSH(3,1:NSYM)=NRS3(1:NSYM)
        IGSOCCX(1,1) = MAX(2*SUM(NRS1(1:NSYM))-NHOLE1,0)
        IGSOCCX(1,2) = 2*SUM(NRS1(1:NSYM))
        IGSOCCX(2,1) = NACTEL - NELEC3
        IGSOCCX(2,2) = NACTEL
        IGSOCCX(3,1) = NACTEL
        IGSOCCX(3,2) = NACTEL
      END IF
*                                                                      *
************************************************************************
*                                                                      *
*     Select default root for geometry optimization
*
      If (NROOTS.gt.1.and.irlxroot.eq.0)  Then
*
*        Check if multi state SA-CASSCF
*
         nW = 0
         Do iR = 1, LROOTS
            If (WEIGHT(iR).ne.0.0D0) nW = nW + 1
         End Do
         If (nW.ne.1) Then
            iRlxRoot=iroot(LROOTS)
         Else
            Do iR = 1, LROOTS
               If (WEIGHT(iR).ne.0.0D0) iRlxRoot=iroot(iR)
            End Do
         End If
      End If
      If (NROOTS.eq.1.or.LROOTS.eq.1) iRlxRoot=iRoot(1)
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute IZROT. IZROT is a matrix (lower triangular over the -----*
*     active space), which specifies which t,u rotations should be
*     avoided, since the orbitals belong to the same RAS space.
*     This is the only way the RAS concept is explicitly used in the
*     SX section of the program.
      ITU=0
      DO ISYM=1,NSYM
        NAO=NASH(ISYM)
*
        IF(DOBKAP)THEN
*.Giovanni... BK stuff SplitCAS related. We want to treat RAS CI space as CAS.
          DO NT=2,NAO
            DO NU=1,NT-1
              ITU=ITU+1
              IZROT(ITU)=1
            END DO
          END DO
        ELSE
*
*
*
          DO NT=2,NAO
            DO NU=1,NT-1
              ITU=ITU+1
              IZROT(ITU)=0
CSVC: check if NU<NT are included in the same gas space
              NGSSH_LO=0
              DO IGAS=1,NGAS
                NGSSH_HI=NGSSH_LO+NGSSH(IGAS,ISYM)
                IF (NU.GT.NGSSH_LO.AND.NT.LE.NGSSH_HI) THEN
                  IZROT(ITU)=1
                END IF
                NGSSH_LO=NGSSH_HI
              END DO
            END DO
          END DO
        END IF
      END DO
*
      Call Put_iArray('nIsh',nIsh,nSym)
      Call Put_iArray('nAsh',nAsh,nSym)
      Call Put_iScalar('Multiplicity',ISPIN)
*
*---  Initialize Cholesky information if requested
      if (DoCholesky)then
         Call Cho_X_init(irc,ChFracMem)
         if (irc.ne.0) Go To 9930
      endif

* ===============================================================

 100  CONTINUE
*PAM Jump here in case of CASVB (IFVB.eq.2)
      If (DBG) Write(6,*)' After 100 CONTINUE.'

*PAM July 2007 Check in case of CI restart:
      If (DBG) Write(6,*)' Check if CI-Restart.'
      If (KeyCIRE) Then
* Test read:
        If (DBG) Write(6,*)' Yes it is!'
        iJOB=-1
        Call f_Inquire('JOBOLD',lExists)
        If (lExists) Then
           If (DBG) Write(6,*)' ''JOBOLD'' exists.'
           iJOB=1
        Else
           Call f_Inquire(IPHNAME,lExists)
           If (lExists) Then
             iJOB=0
             If (DBG) Write(6,*)' No ''JOBOLD'', but JOBIPH exists.'
             If (DBG) Write(6,*)' It is named ',IPHNAME
           End If
        End If
        If (iJOB.eq.1.or.iJOB.eq.0) Then
           if(JOBOLD.le.0) Then
             JOBOLD=20
           end if
           If (iJOB.eq.1) Then
              Call DaName(JOBOLD,'JOBOLD')
           Else
              Call DaName(JOBOLD,IPHNAME)
           End If
           IDisk=0
           Call IDaFile(JOBOLD,99,IScratch,10,IDisk)
           If(JOBOLD.gt.0.and.JOBOLD.ne.JOBIPH) Then
             Call DaClos(JOBOLD)
             JOBOLD=-1
           Else If (JOBOLD.gt.0) Then
             JOBOLD=-1
           End If
        Else
           IScratch(1)=0
        End If
        If (IScratch(1).eq.0) Then
C Test read failed. JOBOLD cannot be used.
          Write(6,*)' Test read shows that there is no usable interface'
          Write(6,*)' file, necessary for the requested CI restart.'
          Write(6,*)' Most probable reason: the user has forgotten to'
          Write(6,*)' provide this file. The program will continue,'
          Write(6,*)' but there can be no CI restart.'
          ICIRST=0
        End If
      End If
*PAM July 2007 End of addition
* ===============================================================
*
*     Initialize seward
*
      If (DBG) Write(6,*)' Initialize seward.'
      nDiff = 0
      If (DSCF           .or.
     &    RF_On()        .or.
     &    Langevin_On()  .or.
     &    PCM_On()       .or.
     &    Do_OFEmb       .or.
     &    KSDFT.ne.'SCF'     )
     &    Call IniSew(DSCF.or.Langevin_On().or.PCM_On(),nDiff)
* ===============================================================
#ifdef _DMRG_
      domcpdftDMRG = l_casdft .and. doDMRG
      twordm_qcm = domcpdftDMRG.or.(.not.KeyCION)
#endif

      ! Setup part for DMRG calculations
#ifdef _DMRG_
      if(keyDMRG .or. doDMRG)then
      call getenv("Project", ProjectName)
      call getenv("CurrDir", CurrDir)
      ! Initialize the new interface

        call qcmaquis_interface_init(
     &    nactel,
     &    sum(nrs2),
     &    ispin-1, ! in QCMaquis spins start with 0
     &    stsym-1, ! in QCMaquis irreps start with 0
     &    nsym,
     &    nrs2,
     &    qcmaquis_param%conv_thresh,
     &    qcmaquis_param%M,
     &    qcmaquis_param%num_sweeps,
     &    trim(CurrDir)//"/"//trim(ProjectName),
     &    twordm_qcm,
     &    nroots,
     &    lroots,
     &    iroot,
     &    thre,
     &    weight,
#ifdef _MOLCAS_MPP_
     &    mpp_nprocs,
     &    mpp_procid,
#endif
     &    initial_occ)
       ! TODO: Support sweep_bond_dimension!
       ! This is an optional parameter to qcmaquis_interface_init not used here yet
       ! For now, it is set by the following qcmaquis_interface_set_param

        ! Read in the parameters
        ! Loop over the lines of qcmaquis input, ignore the comments
        do ii = 1, size(dmrg_input%qcmaquis_input)/2
            ij = 2*ii
            call remove_comment(dmrg_input%qcmaquis_input(ij-1), "//")
            call remove_comment(dmrg_input%qcmaquis_input(ij), "//")

            call qcmaquis_interface_set_param(
     &               trim(dmrg_input%qcmaquis_input(ij-1)),
     &               trim(dmrg_input%qcmaquis_input(ij)))
        end do

      call qcmaquis_interface_stdout(trim(ProjectName)//".QCMaquis.log")
      end if
#endif
*
*
*     Check the input data
*
      If (DBG) Then
        Write(6,*)' Call ChkInp.'
        Call XFlush(6)
      End If
      Call ChkInp()
* ===============================================================
*
*     In DMRG-CASSCF, skip GUGA and LUCIA settings
      NCONF=1
      If(DoBlockDMRG) GoTo 9000
* ===============================================================
*
*     Construct the Guga tables
*
      if (.not. (DoNECI .or. Do_CC_CI .or. DumpOnly)) THEN
*  right now skip most part of gugactl for GAS, but only call mknsm.
        if (.not.iDoGas) then
! DMRG calculation no need the GugaCtl subroutine
#ifdef _DMRG_
          if(KeyDMRG .or. doDMRG)then
            call mma_deallocate(initial_occ)
            GoTo 9000
          else
#endif
            Call Timing(Eterna_1,Swatch,Swatch,Swatch)
            If (DBG) Write(6,*)' Call GugaCtl'
            Call GugaCtl
            Call Timing(Eterna_2,Swatch,Swatch,Swatch)
#ifdef _DMRG_
          end if
#endif
        else  ! if iDoGas
          call mknsm
        end if
      END IF
* ===============================================================
*
*     Construct the determinant tables
*
      If (DBG) Write(6,*)' Construct the determinant tables.'
      MS2 = iSpin - 1
*
* Set variables needed in Lucia_Ini
*
      Call iCopy(mxGAS*mxSym,ngssh,1,ngssh_Molcas,1)
      Call iCopy(mxGAS*2,igsoccx,1,igsoccx_Molcas,1)
      Call iCopy(nSym,norb,1,norb_Molcas,1)
      Call iCopy(nSym,nbas,1,nbas_Molcas,1)
      Call iCopy(nSym,nish,1,nish_Molcas,1)
      potnuc_Molcas    = potnuc
      thre_Molcas      = thre
      nsym_Molcas      = nsym
      nactel_Molcas    = nactel
      ms2_Molcas       = ms2
      ispin_Molcas     = ispin
      lsym_Molcas      = stsym
      NHOLE1_Molcas    = NHOLE1
      NELEC3_Molcas    = NELEC3
      itmax_Molcas     = itmax
      rtoi_Molcas      = rtoi
      nroots_Molcas    = Max(nroots,lRoots)
      ipt2_Molcas      = ipt2
      iprci_molcas     = iprloc(3)
      ngas_molcas      = ngas
      INOCALC_MOLCAS   = INOCALC
      ISAVE_EXP_MOLCAS = ISAVE_EXP
      IEXPAND_MOLCAS   = IEXPAND
*
* And call Lucia_Ini to initialize LUCIA
*
* Combinations don't work for CASVB (at least yet)!
      If (ifvb .ne. 0) iSpeed(1) = 0
*
      if(.not. (KeyDMRG .or. DoNECI .or. Do_CC_CI .or. DumpOnly)) then
! switch on/off determinants
#ifdef _DMRG_
        if(.not.doDMRG)then
#endif
* Initialize LUCIA and determinant control
          Call StatusLine('RASSCF:','Initializing Lucia...')
          CALL Lucia_Util('Ini',iDummy,iDummy,Dummy)
* to get number of CSFs for GAS
          nconf=0
          do i=1,mxsym
            nconf=nconf+ncsasm(i)
          end do
#ifdef _DMRG_
        end if
#endif
      end if

      ISCF=0
      IF (ISPIN.EQ.NAC+1.AND.NACTEL.EQ.NAC) ISCF=1
      IF (ISPIN.EQ.1.AND.NACTEL.EQ.2*NAC)   ISCF=1
      IF (ISCF.EQ.1) THEN
         NCONF=1
         MAXJT=1
      END IF
*
*     If the CI-root selectioning option has been specified translate
*     the reference configuration numbers from the split graph GUGA
*     to the symmetric group numbering
*
* ===============================================================
      IF (ICICH.EQ.1) THEN
        CALL GETMEM('UG2SG','ALLO','INTE',LUG2SG,NCONF)
        CALL UG2SG(NROOTS,NCONF,NAC,NACTEL,STSYM,IPR,
     *             CONF,IWORK(KCFTP),IWORK(LUG2SG),
     *             ICI,JCJ,CCI,MXROOT)
        CALL GETMEM('UG2SG','FREE','INTE',LUG2SG,NCONF)
      END IF
* ===============================================================

      ! faroald initializations
      IF (DOFARO) THEN
        IF (NSYM.GT.1) THEN
          WRITE(6,'(1X,A)') 'FARO keyword was used, but NSYM > 1,'
          WRITE(6,'(1X,A)') 'switching to LUCIA as the CI backend.'
          DOFARO=.FALSE.
        ELSE
          WRITE(6,'(1X,A)') '**EXPERIMENTAL**'
          WRITE(6,'(1X,A)') 'CI backend is FAROALD instead of LUCIA.'
          WRITE(6,'(1X,A)') '**EXPERIMENTAL**'
          CALL FAROALD_INIT(NACTEL,NASH(1),ISPIN)
          CALL CITRANS_INIT(NACTEL,NASH(1),ISPIN)
        END IF
      END IF

      Go to 9000
*
*---  Error exits -----------------------------------------------------*
9810  CONTINUE
      If (IPRLEV.ge.TERSE) Then
       Call WarningMessage(2,'Error in input preprocessing.')
       Write(6,*)' PROC_INP: A keyword was found during prescanning'
       Write(6,*)' the input file, but when later trying to locate'
       Write(6,*)' this input, it could not be found. Something has'
       Write(6,*)' happened to the input file, or else there is some'
       Write(6,*)' strange program error.'
       iRc=_RC_INPUT_ERROR_
      End If
      Go to 9900

9910  CONTINUE
      Call WarningMessage(2,'End of input file during preprocessing.')
      Call WarningMessage(2,ReadStatus)
      If (IPRLEV.ge.TERSE) Write(6,*)' Error exit 9910 from PROC_INP.'
      iRc=_RC_INPUT_ERROR_
      Go to 9900
*
9920  CONTINUE
      Call WarningMessage(2,'Read error during input preprocessing.')
      Call WarningMessage(2,ReadStatus)
      If (IPRLEV.ge.TERSE) Write(6,*)' Error exit 9920 from PROC_INP.'
      iRc=_RC_INPUT_ERROR_
      Go to 9900
*
9930  CONTINUE
      Call WarningMessage(2,'Error during input preprocessing.')
      Call WarningMessage(2,ReadStatus)
      If (IPRLEV.ge.TERSE) Then
         Write(6,*)' Error exit 9930 from PROC_INP.'
         Write(6,*)' Check previous messages in the output'
         Write(6,*)' to find the reason.'
      End If
      iRc=_RC_INPUT_ERROR_
      Go to 9900

*---  Normal exit -----------------------------------------------------*
9000  CONTINUE
      If (DBG) Write(6,*)' Normal exit from PROC_INP.'
      Return
*---  Abnormal exit ---------------------------------------------------*
9900  CONTINUE
      If (DBG) Write(6,*)' Abnormal exit from PROC_INP.'
      Return

      end subroutine proc_inp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ABSTR_TO_ORDSTR( IA_OC, IB_OC,  NAEL,  NBEL,IDET_OC,
     &                           IDET_SP,ISIGN)
*
* An alpha string (IA) and a betastring (IB) is given.
* Combine these two strings to give an determinant with
* orbitals in ascending order. For doubly occupied orbitals
* the alphaorbital is given first.
* The output is given as IDET_OC : Orbital occupation (configuration )
*                        IDET_SP : Spin projections

* The phase required to change IA IB into IDET is computes as ISIGN
*
* Jeppe Olsen, November 2001
*
#include "implicit.fh"
*. Input
      INTEGER IA_OC(NAEL),IB_OC(NBEL)
*. Output
      INTEGER IDET_OC(NAEL+NBEL)
      INTEGER IDET_SP(NAEL+NBEL)
*
      NEXT_AL = 1
      NEXT_BE = 1
      NEXT_EL = 0
      ISIGN = 1
*. Loop over next electron in outputstring
      DO NEXT_EL = 1, NAEL+NBEL
       IF(NEXT_AL.LE.NAEL.AND.NEXT_BE.LE.NBEL) THEN
*
         IF(IA_OC(NEXT_AL).LE.IB_OC(NEXT_BE)) THEN
*. Next electron is alpha electron
           IDET_OC(NEXT_EL) = IA_OC(NEXT_AL)
           IDET_SP(NEXT_EL) = +1
           NEXT_AL = NEXT_AL + 1
         ELSE
*. Next electron is beta electron
           IDET_OC(NEXT_EL) = IB_OC(NEXT_BE)
           IDET_SP(NEXT_EL) = -1
           NEXT_BE = NEXT_BE + 1
           ISIGN = ISIGN*(-1)**(NAEL-NEXT_AL+1)
         END IF
       ELSE IF(NEXT_BE.GT.NBEL) THEN
*. Next electron is alpha electron
           IDET_OC(NEXT_EL) = IA_OC(NEXT_AL)
           IDET_SP(NEXT_EL) = +1
           NEXT_AL = NEXT_AL + 1
       ELSE IF(NEXT_AL.GT.NAEL) THEN
*. Next electron is beta electron
           IDET_OC(NEXT_EL) = IB_OC(NEXT_BE)
           IDET_SP(NEXT_EL) = -1
           NEXT_BE = NEXT_BE + 1
           ISIGN = ISIGN*(-1)**(NAEL-NEXT_AL+1)
       END IF
      END DO
*    ^ End of loop over electrons in outputlist
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' ABSTR to ORDSTR : '
        WRITE(6,*) ' ================= '
        WRITE(6,*) ' Input alpha and beta strings '
        CALL IWRTMA(IA_OC,1,NAEL,1,NAEL)
        CALL IWRTMA(IB_OC,1,NBEL,1,NBEL)
        WRITE(6,*) ' Configuration '
        CALL IWRTMA(IDET_OC,1,NAEL+NBEL,1,NAEL+NBEL)
        WRITE(6,*) ' Spin projections '
        CALL IWRTMA(IDET_SP,1,NAEL+NBEL,1,NAEL+NBEL)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FMAT_CHO(CMO,NCMO,FIAO,FAAO,HONE,NHONE,FIMO,NFIMO,FIFA,NFIFA)
! THIS ROUTINE IS USED IF THE TWO-ELECTRON INTEGRALS ARE
! REPRESENTED BY CHOLESKY VECTORS:
! TRANSFORM FOCK MATRICES COMPUTED BY TRACHO
! TO MO BASIS FOR USE IN CASPT2.

use Index_Functions, only: nTri_Elem
use caspt2_module, only: NBAS, NBTRI, NFRO, NORB, notri, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NCMO, NHONE, NFIMO, NFIFA
real(kind=wp), intent(in) :: CMO(NCMO), FIAO(NBTRI), FAAO(NBTRI), HONE(NHONE)
real(kind=wp), intent(out) :: FIMO(NFIMO), FIFA(NFIFA)
integer(kind=iwp) :: I, IFAO, IJ, IOFMO, ISYM, LSC, LSCI, NB, NBBMX, NBOMX, NF, NO, NO_X, NOOMX
real(kind=wp), allocatable :: SCR1(:), SCR2(:), SCR3(:)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ISTLT
real(kind=wp), allocatable :: FAMO(:)
#endif

FIMO(:) = Zero
FIFA(:) = Zero ! initially used as FAMO

NBBMX = maxval(NBAS(1:NSYM)**2)
NBOMX = maxval(NBAS(1:NSYM)*NORB(1:NSYM))
NOOMX = maxval(NORB(1:NSYM)**2)

call mma_allocate(SCR1,NBBMX,LABEL='SCR1')
call mma_allocate(SCR2,NBOMX,LABEL='SCR2')
call mma_allocate(SCR3,NOOMX,LABEL='SCR3')

IFAO = 1
IOFMO = 0
LSC = 1
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  if (NB == 0) cycle
  NO = NORB(ISYM)
  NO_X = max(1,NO)
  NF = NFRO(ISYM)
  LSCI = LSC+NF*NB
  ! The inactive Fock matrix:
  call SQUARE(FIAO(IFAO),SCR1,NB,1,NB)
  call DGEMM_('N','N',NB,NO,NB,One,SCR1,NB,CMO(LSCI),NB,Zero,SCR2,NB)
  call DGEMM_('T','N',NO,NO,NB,One,CMO(LSCI),NB,SCR2,NB,Zero,SCR3,NO_X)
  IJ = 0
  do I=1,NO
    FIMO(IOFMO+IJ+1:IOFMO+IJ+I) = SCR3(I:I+NO*(I-1):NO)
    IJ = IJ+I
  end do
  ! The active Fock matrix:
  call SQUARE(FAAO(IFAO),SCR1,NB,1,NB)
  call DGEMM_('N','N',NB,NO,NB,One,SCR1,NB,CMO(LSCI),NB,Zero,SCR2,NB)
  call DGEMM_('T','N',NO,NO,NB,One,CMO(LSCI),NB,SCR2,NB,Zero,SCR3,NO_X)
  IJ = 0
  do I=1,NO
    FIFA(IOFMO+IJ+1:IOFMO+IJ+I) = SCR3(I:I+NO*(I-1):NO)
    IJ = IJ+I
  end do
  IFAO = IFAO+nTri_Elem(NB)
  IOFMO = IOFMO+nTri_Elem(NO)
  LSC = LSC+NB**2
end do

call mma_deallocate(SCR1)
call mma_deallocate(SCR2)
call mma_deallocate(SCR3)

FIMO(1:NoTri) = FIMO(:)+HONE(:)
FIFA(1:NoTri) = FIMO(:)+FIFA(:)

#ifdef _DEBUGPRINT_
write(u6,*) '      INACTIVE FOCK MATRIX IN MO BASIS'
ISTLT = 1
do ISYM=1,NSYM
  NO = NORB(ISYM)
  if (NO > 0) then
    write(u6,'(6X,A,I2)') ' SYMMETRY SPECIES:',ISYM
    call TRIPRT(' ',' ',FIMO(ISTLT),NO)
    ISTLT = ISTLT+nTri_Elem(NO)
  end if
end do

call mma_allocate(FAMO,nFIMO,Label='FAMO')
FAMO(:) = FIFA(:)-FIMO(:)
write(u6,*) '        ACTIVE FOCK MATRIX IN MO BASIS'
ISTLT = 1
do ISYM=1,NSYM
  NO = NORB(ISYM)
  if (NO > 0) then
    write(u6,'(6X,A,I2)') ' SYMMETRY SPECIES:',ISYM
    call TRIPRT(' ',' ',FAMO(ISTLT),NO)
    ISTLT = ISTLT+nTri_Elem(NO)
  end if
end do
call mma_deallocate(FAMO)

write(u6,*) '      TOTAL FOCK MATRIX IN MO BASIS'
ISTLT = 1
do ISYM=1,NSYM
  if (NORB(ISYM) > 0) then
    write(u6,'(6X,A,I2)') ' SYMMETRY SPECIES:',ISYM
    call TRIPRT(' ',' ',FIFA(ISTLT),NORB(ISYM))
    ISTLT = ISTLT+nTri_Elem(NORB(ISYM))
  end if
end do

#endif

end subroutine FMAT_CHO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine OpnFls_RASSCF(DSCF,DoCholesky)
************************************************************************
*                                                                      *
*     Open files.                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
#include "qnctl.fh"
      Logical DSCF,test,DoCholesky
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*---  define logical unit numbers -------------------------------------*
*...  Molecular orbital input file  this variable is not used
*...  File is opened and closed i.e. around calls to rdvec.
*      LUStartOrb=19
*...  Job interface unit (-1 shows it has not been opened!)
      JOBIPH=-1
*...  Old RASSCF job interface for input MO's and CI vector
      JOBOLD=-1
*...  AO one-electron integrals
      LUONEL=16
*...  AO two-electron integrals
      LUINTA=40
*...  MO two-electron integrals
      LUINTM=13
*...  Temporary unit used for QUNE update
      LUQUNE=27
*...  Temporary unit for diagonalization
      LUDAVID=37
*...  general purpose communication file COMFILE
*     Note: subr. GetInf uses unit 33 as logical unit
      LUCOM=30
* Opening the JOBIPH file is delayed till after input processing at end
* of READIN_RASSCF. Only then is file name known.

*---  open the ORDINT file --------------------------------------------*
      call f_Inquire('ORDINT',test)
      Call DecideOnDirect(.True.,test,DSCF,DoCholesky)
      If ( .not. DSCF .And. .Not.DoCholesky) then
        iRc=-1
        iOpt=0
        Call OpnOrd(iRc,iOpt,'ORDINT',LUINTA)
        If ( iRc.ne.0 ) Then
          Write(LF,*)'RASSCF tried to open a file (ORDINT) containing'
          Write(LF,*)'two-electron integrals, but failed. Something'
          Write(LF,*)'is wrong with the file. Most probably it is'
          Write(LF,*)'simply missing: Please check. It should have'
          Write(LF,*)'been created by SEWARD. Perhaps it is in the'
          Write(LF,*)'wrong directory?'
          Call Abend()
        End If
      Else
        call f_Inquire('RUNFILE',test)
        If ( .not.test ) Then
          Write(LF,*)'RASSCF tried to open a file (RUNFILE) containing'
          Write(LF,*)'data from previous program steps. Something'
          Write(LF,*)'is wrong with the file. Most probably it is'
          Write(LF,*)'simply missing: Please check. It should have'
          Write(LF,*)'been created by SEWARD.'
          Call Abend()
        End If
      End If
*---  open the file carrying the transfromed two-electron integrals ---*
      Call DaName(LUINTM,'TRAINT')
*---  open the DAVID file carrying temporary CI and sigma vectors -----*
*     Note the unit number is defined in the general.fh file
      Call DaName(LuDavid,'TEMP01')
*---  open the file carrying the hessian update vectors ---------------*
      Call DaName(LuQune,'TEMP02')
*
* Open file for storage of information on CI-iterations
*
      IterFile = IsFreeUnit(10)
      call molcas_open(IterFile,'CIITER')
c      Open(Unit=IterFile,Status='Unknown',Form='Formatted',
c     &     File='CIITER')
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine RHS_td(Temp1,Temp2,Temp3,Temp4,Temp5,Temp6,rKappa,ipst,iDisp,lOper,CMO,jdisp,CI)
!***********************************************************************
!                                                                      *
!    Purpose:                                                          *
!            Read the perturbed fock operator and one electron         *
!            hamiltonian from disk and add the connection part         *
!            to the hessian.                                           *
!                                                                      *
!     In :                                                             *
!                loper : Symmetry operator for perurbation             *
!                idisp : Perturbation component                        *
!     Out                                                              *
!                rKappa: Preconditioned RHS for the perturbation       *
!                                                                      *
!     Temporary                                                        *
!                Temp1,Temp2,Temp3...                                  *
!                                                                      *
! Author: Anders Bernhardsson, 1995                                    *
!         Theoretical Chemistry, University of Lund                    *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use ipPage, only: ipin, W
use MCLR_Data, only: DspVec, G1t, G2sq, ipCI, ipCM, ipMat, ipMatBA, ipMatLT, n2Dens, nA, nCMO, nConf1, nDens, nMBA
use MCLR_procedures, only: CISigma_td
use input_mclr, only: Debug, iMethod, nAsh, nBas, nIsh, nSym, nTPert, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: Temp1(nDens), Temp2(nDens), Temp3(nDens), Temp4(nDens), Temp5(nDens), Temp6(nDens), rKappa(nDens)
integer(kind=iwp), intent(in) :: ipst, iDisp, lOper, jdisp
real(kind=wp), intent(in) :: CMO(nCMO)
logical(kind=iwp), intent(in) :: CI
integer(kind=iwp) :: iAsh, iDSym, ii, ij, iOp, iOpt, ip, iRC, iS, jAsh, jS
real(kind=wp) :: Dij, E2_TD, Ena, rDum(1)
character(len=8) :: Label
real(kind=wp), allocatable :: FiX(:), MOT(:), MOT2(:), MOX(:)

!                                                                      *
!***********************************************************************
!                                                                      *
debug = .true.
iRC = -1
idsym = loper+1
iOpt = 0
iOp = ibset(0,loper)

!----------------------------------------------------------------------*

! Read in connection matrix
! and transform it to MO basis

if (btest(ntpert(idisp),3)) then
  Label = 'OVRGRD'
  call dRdMCK(iRC,iOpt,Label,DspVec(iDisp),Temp6,iop)
  if (iRc /= 0) then
    write(u6,*)
    write(u6,*) ' *** Error in subroutine RHS_TD ***'
    write(u6,*) ' Error when reading OVRGRD from MCKINT'
    write(u6,*)
    return
  end if
  ip = 1
  do iS=1,nSym
    do jS=1,is
      if (Mul(iS,jS) == loper+1) then
        if (nBas(is)*nBas(js) /= 0) then
          if (is == js) then
            call Square(Temp6(ipMatLT(is,js)),Temp5,1,nBas(is),nBas(is))
            ip = ip+nTri_Elem(nBas(is))
          else
            Temp5(1:nBas(iS)*nBas(jS)) = Temp6(ipMatLt(is,js):ipMatLt(is,js)+nBas(iS)*nBas(jS)-1)
          end if
          call DGEMM_('T','N',nBas(iS),nBas(jS),nBas(iS),One,CMO(ipCM(iS)),nBas(iS),Temp5,nBas(iS),Zero,Temp4,nBas(iS))
          call DGEMM_('N','N',nBas(is),nBas(jS),nBAs(jS),One,Temp4,nBas(iS),CMO(ipCM(jS)),nBas(jS),Zero,Temp1(ipMat(iS,jS)), &
                      nBas(is))
          if (is /= js) then
            call DGEMM_('T','T',nBas(jS),nBas(iS),nBAs(jS),One,CMO(ipCM(jS)),nBas(js),Temp5,nBas(iS),Zero,Temp4,nBas(jS))
            call DGEMM_('N','N',nBas(js),nBas(iS),nBas(iS),One,Temp4,nBas(jS),CMO(ipCM(iS)),nBas(iS),Zero,Temp1(ipMat(jS,iS)), &
                        nBas(jS))
          end if

        end if
      end if
    end do
  end do
end if

!----------------------------------------------------------------------*

! Read in derivative of hamiltonian

if (iMethod == 2) then
  call mma_allocate(MOX,n2Dens,Label='MOX')
else
  call mma_allocate(MOX,1,Label='MOX')  ! Dummy allocation
end if
MOX(:) = Zero
call mma_allocate(FiX,nDens,Label='FiX')
call IntX(FIX,Temp6,Temp5,Temp4,Temp3,rkappa,MOX,loper,idisp)

!----------------------------------------------------------------------*

!             C O N N E C T
!
!        {kappa MO}           F({D,k}){F,k}
!                                             ~
! Area for one index transformed integrals (pj|kl)

if (btest(ntpert(idisp),3)) then
  if (iMethod == 2) then
    call mma_allocate(MOT,nmba,Label='MOT')
    call mma_allocate(MOT2,nmba,Label='MOT2')
    MOT(:) = Zero
    MOT2(:) = Zero

    ! kappa rmo Fi Fa

    ! IFG: this was outside "if (imethod == 2)",
    !      probably a bug? ipmot & ipmot2 would be uninitialized
    call r2ElInt(Temp1,MOT,MOT2,Temp3,Temp4,iDSym,One,-Half,0)
    MOT(:) = MOT(:)+MOT2(:)
    call mma_deallocate(MOT2)
  end if
  ! ix  ix  ~i
  Temp6(:) = Zero
  ! F  =F  + F
  FIX(:) = FIX(:)+Temp3(:)

  if (iMethod == 2) call CreQ_td(Temp5,MOT,G2sq,loper+1)

  do iS=1,nSym
    jS = Mul(iS,loper+1)
    ! F~=2*Fi~
    Temp6(ipMat(js,is):ipMat(js,is)+nIsh(is)*nBas(js)-1) = Temp6(ipMat(js,is):ipMat(js,is)+nIsh(is)*nBas(js)-1)+ &
                                                           Two*Temp3(ipMat(js,is):ipMat(js,is)+nIsh(is)*nBas(js)-1)
    if (iMethod == 2) then
      ! F~=F~+2*FA~
      Temp6(ipMat(js,is):ipMat(js,is)+nIsh(is)*nBas(js)-1) = Temp6(ipMat(js,is):ipMat(js,is)+nIsh(is)*nBas(js)-1)+ &
                                                             Two*Temp4(ipMat(js,is):ipMat(js,is)+nIsh(is)*nBas(js)-1)
      do iAsh=1,nAsh(iS)
        do jAsh=1,nAsh(is)
          Dij = G1t(iTri(iash+nA(is),jAsh+nA(is)))

          ! F~=F~+DFi~

          ii = ipMat(js,is)+nBas(js)*(nish(is)+iAsh-1)
          ij = ipMat(js,is)+nBas(js)*(nish(is)+jAsh-1)
          Temp6(ij:ij+nBas(jS)-1) = Temp6(ij:ij+nBas(jS)-1)+Dij*Temp3(ii:ii+nBas(jS)-1)
        end do
      end do
      ! F~=F~+Q~
      Temp6(ipMat(js,is)+nBas(js)*nIsh(is):ipMat(js,is)+nBas(js)*(nIsh(is)+nAsh(is))-1) = &
        Temp6(ipMat(js,is)+nBas(js)*nIsh(is):ipMat(js,is)+nBas(js)*(nIsh(is)+nAsh(is))-1)+ &
        Temp5(ipMatba(js,is):ipMatba(js,is)+nAsh(is)*nBas(js)-1)
    end if
  end do ! is

! Calculate connection contribution to hessian

end if ! ntpert
call Hess(Temp6,rkappa,Temp1,Temp3,Temp4,Temp5,Temp2,loper+1,jdisp,idisp)

! F=F~+Fx
if (btest(ntpert(idisp),3)) rKappa(:) = rKappa(:)+Temp6(:)

! Add connection to 2el MO integrals

! Adds (pb|cd) to triangular (ab|cd)
if ((iMethod == 2) .and. btest(ntpert(idisp),2)) call ABXpY(MOT,MOX,idsym)

if (CI) then
  if (btest(ntPert(idisp),3)) then
    call CiSigma_td(0,State_Sym,Mul(State_sym,idsym),Fix,nDens,MOX,size(MOX),rdum,1,ipCI,ipst,'N',.true.)
  else
    call CiSigma_td(0,State_Sym,Mul(State_sym,idsym),Fix,nDens,rdum,1,rdum,1,ipCI,ipst,'N',.false.)
  end if

  call ipin(ipST)
  if (idsym == 1) then
    EnA = E2_td(Fix,MOX,idsym-1,idisp)
    call ipin(ipCI)
    W(ipST)%A(1:nConf1) = W(ipST)%A(1:nConf1)-Ena*W(ipCI)%A(1:nConf1)
  end if
  W(ipST)%A(1:nConf1) = Two*W(ipST)%A(1:nConf1)
end if

Temp1(:) = Two*rKappa(:)

do iS=1,nSym
  js = Mul(is,loper+1)
  if (nbas(is)*nBas(js) /= 0) &
    call DGESUB(Temp1(ipMat(is,js)),nBas(is),'N',Temp1(ipMat(js,is)),nBas(js),'T',rKappa(ipMat(is,js)),nBas(is),nBas(is),nBas(js))
end do

call mma_deallocate(FIX)
call mma_deallocate(MOX)
call mma_deallocate(MOT,safe='*')

end subroutine RHS_td

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Leon Freitag                                     *
*               2017, Stefan Knecht                                    *
************************************************************************
****************
* This is the wrapper for Celestino Angeli's NEVPT2 code, modified for
* DMRG and Cholesky support
* Author: Leon Freitag, ETH Zurich
* last modifications: S. Knecht, ETH Zurich, August 2017
****************
      subroutine nevpt2(iReturn)

        use koopro4QD
        use qdnevpt_core
        use nevpt2wfn          ! wfn file
        use nevpt_header       ! header
        use nevpt2_cfg         ! input variables
        use info_state_energy  ! energies
        use info_orbital_space ! orbital space info

        implicit none

        integer iReturn
        real*4            :: t13                      ! dummy variables for the koopro4QD call
        logical,parameter :: rel_ham        = .false. ! rel_ham and t13
        logical,parameter :: from_molcas    = .true.
        logical           :: nevpth5_exists = .true.

        character(len=256):: refwfnfile

        !> initialize
        refwfnfile = ''

        !> print NEVPT2 header
        do_dmrg_pt = .true.
        call print_nevpt_header(rel_ham)
        call xflush(6)

        !> read and process input
        call rdinput(refwfnfile)
        call xflush(6)

        !> read and process input
        call pt2init(refwfnfile)
        call xflush(6)


        if (.not.skip_koopro_molcas) then
          write (6,'(/a )') " Calculating the Koopmans' matrices"
          write (6,'( a )') " ----------------------------------"
          call koopro4QD_driver(rel_ham,t13,from_molcas)
          call xflush(6)
        else
          write (6,*) "Skipping the calculation of Koopmans' matrices."
          inquire(file='nevpt.h5',exist=nevpth5_exists)
          if (.not.(nevpth5_exists)) then
            call WarningMessage(1,"Requested to skip the Koopmans'"//
     &     " matrix calculation step but nevpt.h5 file not found!")
            call Abend()
          end if
        end if
        write (6,'(/a )') " Starting NEVPT2 perturbation summation"
        write (6,'( a )') " --------------------------------------"
        call qdnevpt(rel_ham,t13,from_molcas)
        call xflush(6)

        !> store the PT2 energy and effective hamiltonian on the wavefunction file
        call nevpt2wfn_estore()

        ! Test verification, a tolerance of 10^-6 is assumed for the test
        call Add_Info('E_SC_NEVPT2',e2mp,nr_states,6)
        if (.not.no_pc) then
          call Add_Info('E_PC_NEVPT2',e2en,nr_states,6)
        end if

        !> clean up and free memory
        call pt2close

        iReturn = 0
      end subroutine nevpt2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetAtomicLabels()
C
C     Thomas Bondo Pedersen, March 2011.
C
C     Purpose: set atomic labels in ldf_atomiclabels
C              To unset (deallocation), call LDF_UnsetAtomicLabels().
C
C     After this routine, call LDF_GetAtomicLabel(A,Label) to retrieve
C     the four-character label Label representing atom A.
C
      Use ldf_atomiclabels, only: AtomicLabels
      Use stdalloc, only: mma_allocate, mma_deallocate
      Implicit None
#include "WrkSpc.fh"
#include "localdf_bas.fh"

      Integer  LDF_nAtom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nAtom, LDF_nShell_Atom, LDF_lShell_Atom
      Integer  LDF_GetLenIn8

      Integer LenIn8
      Integer l_Temp
      Integer ip_SB, l_SB
      Integer n
      Integer iShell
      Integer A
      Integer nS
      Integer j
#if defined (_DEBUGPRINT_)
      Integer ip
      Integer iS
      Integer ii
#endif

      Integer i
      Integer nBasSh
      Integer iSB
      Character, Allocatable :: Temp(:)
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iSB(i)=iWork(ip_SB-1+i)

      If (allocated(AtomicLabels)) Return
      call mma_allocate(AtomicLabels,LDF_nAtom())
      LenIn8=LDF_GetLenIn8()
      If (LenIn8.lt.8) Then
         Call WarningMessage(2,'LDF_SetAtomicLabels: LenIn8 < 8')
         Call LDF_Quit(1)
      End If
      l_Temp=LenIn8*nBas_Valence
      Call mma_allocate(Temp,l_Temp,label='LDFALTmp')
      Call Get_cArray('Unique Basis Names',Temp,l_Temp)
      l_SB=nShell_Valence
      Call GetMem('LDFALSB','Allo','Inte',ip_SB,l_SB)
      n=0
      Do iShell=1,nShell_Valence
         iWork(ip_SB-1+iShell)=n
         n=n+nBasSh(iShell)
      End Do
      If (n.ne.nBas_Valence) Then
         Call WarningMessage(2,'LDF_SetAtomicLabels: n != nBas_Valence')
         Call LDF_Quit(1)
      End If
      Do A=1,LDF_nAtom()
         nS=LDF_nShell_Atom(A)
         If (nS.gt.0) Then
            iShell=iWork(LDF_lShell_Atom(A))
            Do j=1,4
               AtomicLabels(A)(j:j) = Temp(LenIn8*iSB(iShell)+j)
            End Do
#if defined (_DEBUGPRINT_)
            ip=LDF_lShell_Atom(A)-1
            Do iS=1,nS
               iShell=iWork(ip+iS)
               Do ii=0,nBasSh(iShell)-1
                  Do j=1,4
                     If (Temp(LenIn8*(iSB(iShell)+ii)+j).ne.
     &                   AtomicLabels(A)(j:j)) Then
                        Call WarningMessage(2,
     &                        'LDF_SetAtomicLabels: Bfn label mismatch')
                        Write(6,'(A,I10)') 'Atom=',A
                        Call LDF_Quit(1)
                     End If
                  End Do
               End Do
            End Do
#endif
         Else
            Call WarningMessage(2,'LDF_SetAtomicLabels: nS < 1')
            Write(6,'(A,I10)') 'Atom=',A
            Call LDF_Quit(1)
         End If
      End Do
      Call GetMem('LDFALSB','Free','Inte',ip_SB,l_SB)
      call mma_deallocate(Temp)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_GetAtomicLabel(A,Label)
C
C     Thomas Bondo Pedersen, March 2011.
C
C     Purpose: return label representing atom A.
C              'NONE' is returned if labels are not set.
C
      Use ldf_atomiclabels, only: AtomicLabels
      Implicit None
      Integer A
      Character*4 Label
#include "WrkSpc.fh"

      If (.not.allocated(AtomicLabels)) Then
         Label='NONE'
      Else
         Label = AtomicLabels(A)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_UnsetAtomicLabels()
C
C     Thomas Bondo Pedersen, March 2011.
C
C     Purpose: unset atomic labels in ldf_atomiclabels
C
      Use ldf_atomiclabels, only: AtomicLabels
      Use stdalloc, only: mma_deallocate
      Implicit None

      If (allocated(AtomicLabels)) Call mma_deallocate(AtomicLabels)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_PrintAtomicLabels()
      Implicit None
      Integer  LDF_nAtom
      External LDF_nAtom

      Character*4 Label
      Integer A

      Do A=1,LDF_nAtom()
         Call LDF_GetAtomicLabel(A,Label)
         Write(6,'(A,I10,A,A)') 'Atom=',A,' Label=',Label
      End Do
      Call xFlush(6)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer Function LDF_GetLenIn8()
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
      LDF_GetLenIn8=LENIN8
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION IFRMR(WORK,IROFF,IELMNT)
*
* An integer array is stored in real array WORK,
* starting from WORK(IROFF). Obtain element
* IELMNT of this array
*
      INTEGER WORK(*)
*
#include "irat.fh"
*. offset when work is integer array
      IIOFF = 1 + IRAT * (IROFF-1)
      IFRMR = WORK(IIOFF-1+IELMNT)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine change6_cvb()

use casvb_global, only: icase6, icrit, ifinish, imethod, norb, npr, nprorb, nprvb, nvb, strucopt
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: changed
logical(kind=iwp), external :: chpcmp_cvb ! ... Change of dimensioning variables ...

changed = .false.
if (changed) call touch_cvb('CIFREE')

nprorb = norb*(norb-1)
if (strucopt) then
  nprvb = nvb
  npr = nprorb+nvb
else if (.not. ((imethod == 4) .or. (imethod == 6))) then
  nprvb = 0
  npr = nprorb
else
  npr = 0
end if
if (chpcmp_cvb(npr)) changed = .true.
if ((.not. ((imethod == 4) .or. (imethod == 6))) .and. (ifinish == 0)) then
  ! Standard 2nd-order procedure:
  icase6 = 1
else if ((imethod == 4) .and. (icrit == 1) .and. (ifinish == 0)) then
  ! Overlap-based Davidson
  icase6 = 2
else if ((imethod == 4) .and. (icrit == 2) .and. (ifinish == 0)) then
  ! Energy-based Davidson
  icase6 = 3
else if ((imethod == 6) .or. (ifinish == 1) .or. (ifinish == 2)) then
  ! No arrays needed
  icase6 = 4
else
  icase6 = 5
end if
if (chpcmp_cvb(icase6)) changed = .true.
if (changed) call touch_cvb('MEM6')

return

end subroutine change6_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine NAGrd(
#define _CALLING_
#include "grd_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: to compute the gradient of the nuclear attraction integrals. *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             October '91                                              *
************************************************************************
      Use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
*     For normal nuclear attraction
      External TNAI1, Fake, Cff2D
*     Finite nuclei
      External TERI1, ModU2, vCff2D
#include "Molcas.fh"
#include "real.fh"
#include "print.fh"
#include "disp.fh"

#include "grd_interface.fh"

*     Local variables
      Integer iDCRT(0:7)
      Logical TstFnc, TF
#ifdef _PATHSCALE_
      Save Fact
#endif
      Real*8 Coori(3,4), CoorAC(3,2), C(3), TC(3)
      Integer iAnga(4), JndGrd(3,4), lOp(4), iuvwx(4)
      Logical JfGrad(3,4)
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,
     &                       dc(mdc)%nStab)
*
      iRout = 150
      iPrint = nPrint(iRout)
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Write (6,*) ' In NAGrd: nArr=',nArr
         nDAO = nElem(la) * nElem(lb)
         Call RecPrt('DAO',' ',DAO,nZeta,nDAO)
      End If
#endif
*
      nRys=nHer
*
      nip = 1
      ipA = nip
      nip = nip + nAlpha*nBeta
      ipB = nip
      nip = nip + nAlpha*nBeta
      ipDAO = nip
      nip = nip + nAlpha*nBeta*nElem(la)*nElem(lb)
      If (nip-1.gt.nZeta*nArr) Then
         Write (6,*) ' nip-1.gt.nZeta*nArr'
         Call Abend()
      End If
      nArray = nZeta*nArr - nip +1
*
      iIrrep = 0
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = 0
      iAnga(4) = 0
      call dcopy_(3,A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
      If (la.ge.lb) Then
         call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
         call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      lOp(1) = kOp(1)
      lOp(2) = kOp(2)
*
      ipAOff = ipA
      Do iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
      End Do
*
      ipBOff = ipB
      Do iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
      End Do
*
*     Modify the density matrix with the prefactor
*
      nDAO = nElem(la) * nElem(lb)
      If (Nuclear_Model.eq.Point_Charge) Then
         Do iDAO = 1, nDAO
            Do iZeta = 1, nZeta
               Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
               DAO(iZeta,iDAO) = Fact * DAO(iZeta,iDAO)
            End Do
         End Do
      End If
C     If (iPrint.ge.99) Call RecPrt('DAO',' ',DAO,nZeta,nDAO)
*
*-----Loop over nuclear centers
*
      kdc = 0
      Do kCnttp = 1, nCnttp
         If (dbsc(kCnttp)%Charge.eq.Zero) Go To 111
         Do kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3)=dbsc(kCnttp)%Coor(1:3,kCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = -dbsc(kCnttp)%Charge*DBLE(nStabM) / DBLE(LmbdT)
*
*           Modify the density matrix with prefactors in case of finite nuclei
*
            If (Nuclear_Model.eq.Gaussian_Type) Then
               Eta=dbsc(kCnttp)%ExpNuc
               rKappcd=TwoP54/Eta
*              Tag on the normalization factor of the nuclear Gaussian
               Fact=Fact*(Eta/Pi)**(Three/Two)
               jpDAO=ipDAO
               Do iDAO = 1, nDAO
                  Do iZeta = 1, nZeta
*                    On flight modification of Kappa
                     rKappab=TwoP54*rKappa(iZeta)/Zeta(iZeta)
                     Array(jpDAO)=Fact*DAO(iZeta,iDAO)*rKappab*rKappcd
     &                           *Sqrt(One/(Zeta(iZeta)+Eta))
                     jpDAO=jpDAO+1
                  End Do
               End Do
            Else If (Nuclear_Model.eq.Point_Charge) Then
               Call DYaX(nZeta*nDAO,Fact,DAO,1,Array(ipDAO),1)
            Else
               Write (6,*) 'NaGrd: Fermi type nuclear distribution not '
     &                   //'implemented yet!'
               Call Abend()
            End If
            iuvwx(3) = dc(kdc+kCnt)%nStab
            iuvwx(4) = dc(kdc+kCnt)%nStab
            Call ICopy(6,IndGrd,1,JndGrd,1)
            Do i = 1, 3
               Do j = 1, 2
                  JfGrad(i,j) = IfGrad(i,j)
               End Do
            End Do
*
*-----------Derivatives with respect to the operator is computed via the
*           translational invariance.
*
            nDisp = IndDsp(kdc+kCnt,iIrrep)
            Do iCar = 0, 2
               iComp = 2**iCar
               If ( TF(kdc+kCnt,iIrrep,iComp) .and.
     &              .Not.dbsc(kCnttp)%Frag .and.
     &              .Not.dbsc(kCnttp)%pChrg ) Then
                  nDisp = nDisp + 1
                  If (Direct(nDisp)) Then
*--------------------Reset flags for the basis set centers so that we
*                    will explicitly compute the derivatives with
*                    respect to those centers. Activate flag for the
*                    third center so that its derivative will be comp-
*                    uted by the translational invariance.
                     JndGrd(iCar+1,1) = Abs(JndGrd(iCar+1,1))
                     JndGrd(iCar+1,2) = Abs(JndGrd(iCar+1,2))
                     JndGrd(iCar+1,3) = -nDisp
                     JfGrad(iCar+1,1) = .True.
                     JfGrad(iCar+1,2) = .True.
                     JfGrad(iCar+1,3) = .False.
                  Else
                     JndGrd(iCar+1,3) = 0
                     JfGrad(iCar+1,3) = .False.
                  End If
               Else
                  JndGrd(iCar+1,3) = 0
                  JfGrad(iCar+1,3) = .False.
               End If
            End Do
*-----------No derivatives with respect to the fourth center.
            Call ICopy(3,[0],0,JndGrd(1,4),1)
            JfGrad(1,4) = .False.
            JfGrad(2,4) = .False.
            JfGrad(3,4) = .False.
            mGrad = 0
            Do iCar = 1, 3
               Do i = 1, 2
                  If (JfGrad(iCar,i)) mGrad = mGrad + 1
               End Do
            End Do
C           If (iPrint.ge.99) Write (6,*) ' mGrad=',mGrad
            If (mGrad.eq.0) Go To 101
*
            Do lDCRT = 0, nDCRT-1
               lOp(3) = NrOpr(iDCRT(lDCRT))
               lOp(4) = lOp(3)
               Call OA(iDCRT(lDCRT),C,TC)
               call dcopy_(3,TC,1,CoorAC(1,2),1)
               call dcopy_(3,TC,1,Coori(1,3),1)
               call dcopy_(3,TC,1,Coori(1,4),1)
*
*
               If (Nuclear_Model.eq.Gaussian_Type) Then
                  Eta=dbsc(kCnttp)%ExpNuc
                  EInv=One/Eta
                  Call Rysg1(iAnga,nRys,nZeta,
     &                       Array(ipA),Array(ipB),[One],[One],
     &                       Zeta,ZInv,nZeta,[Eta],[EInv],1,
     &                       P,nZeta,TC,1,Coori,Coori,CoorAC,
     &                       Array(nip),nArray,
     &                       TERI1,ModU2,vCff2D,
     &                       Array(ipDAO),nDAO,Grad,nGrad,
     &                       JfGrad,JndGrd,lOp,iuvwx)
               Else If (Nuclear_Model.eq.Point_Charge) Then
                  Call Rysg1(iAnga,nRys,nZeta,
     &                       Array(ipA),Array(ipB),[One],[One],
     &                       Zeta,ZInv,nZeta,[One],[One],1,
     &                       P,nZeta,TC,1,Coori,Coori,CoorAC,
     &                       Array(nip),nArray,
     &                       TNAI1,Fake,Cff2D,
     &                       Array(ipDAO),nDAO,Grad,nGrad,
     &                       JfGrad,JndGrd,lOp,iuvwx)
               Else
*...more to come...
               End If
*
C              Call RecPrt('In NaGrd: Grad',' ',Grad,nGrad,1)
            End Do
 101     Continue
         End Do
 111     kdc = kdc + dbsc(kCnttp)%nCntr
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Final)
         Call Unused_real_array(Ccoor)
         Call Unused_integer(nOrdOp)
         Call Unused_integer_array(lOper)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************

subroutine PROTOCSF(NPEL,MLTPL,NPCSFSZ,IPCSFCP)
! Return a table with all possible CSF's with NPEL electrons
! coupled to give a total spin multiplicity MLTPL.
! The order of the resulting CSF's is consistent with the
! index function,
!  Index=1+Sum(j) NGENE(j-1,2*S_j+2)
! where the sum is over only the up-coupled orbitals j,
! S_j is the accumulated spin, summed over orbitals <= j,
! and NGENE(N,2*S+1) is in general the number of genealogical
! couplings of N electrons to obtain spin S.

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NPEL, MLTPL, NPCSFSZ
integer(kind=iwp), intent(out) :: IPCSFCP(NPEL,NPCSFSZ)
integer(kind=iwp) :: ISP2, N, ND, NPCSF, NPELD, NPELU, NU
integer(kind=iwp), parameter :: DWNCPL = 0, UPCPL = 1
integer(kind=iwp), external :: NGENE

if (NPEL == 0) return
ISP2 = MLTPL-1
if (ISP2 < 0) return
if (ISP2 > NPEL) return
NPELU = (NPEL+ISP2)/2
NPELD = (NPEL-ISP2)/2
if (NPELU < NPELD) return
if (NPELU+NPELD /= NPEL) return
IPCSFCP(1:NPELU,1) = UPCPL
if (NPELU == NPEL) return
IPCSFCP(NPELU+1:NPEL,1) = DWNCPL

NPCSF = NGENE(NPEL,MLTPL)
if (NPCSF > NPCSFSZ) then
  write(u6,*) ' Too small space allocated in PROTOCSF. Input:'
  write(u6,'(1x,a,3i6)') ' NPEL,MLTPL,NPCSFSZ:',NPEL,MLTPL,NPCSFSZ
  write(u6,'(1x,a,i12)') ' Required NPCSFSZ is',NPCSF
  call ABEND()
end if

NPCSF = 1
if (NPEL <= 2) return
outer: do
  N = 0
  NU = 0
  do
    N = N+1
    if (N > NPEL) exit outer
    if (IPCSFCP(N,NPCSF) == UPCPL) NU = NU+1
    ND = N-NU
    if ((IPCSFCP(N,NPCSF) /= UPCPL) .and. (NU /= ND)) exit
  end do
  IPCSFCP(1:NU-1,NPCSF+1) = UPCPL
  IPCSFCP(NU:N-1,NPCSF+1) = DWNCPL
  IPCSFCP(N,NPCSF+1) = UPCPL
  IPCSFCP(N+1:NPEL,NPCSF+1) = IPCSFCP(N+1:NPEL,NPCSF)
  NPCSF = NPCSF+1
end do outer

end subroutine PROTOCSF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine pulse(H0,Ht,time,pcount)
!***********************************************************************
! Purpose :  construct the time-dependent hamiltonian
!                        Ht = H0 + dipole*E_field(time)
!            argument 'pcount' is for storage of pulse
!            if pcount=-1 then current value of pulse is not stored
!***********************************************************************

use rhodyn_data, only: amp, dipole_basis, flag_acorrection, linear_chirp, lu_pls, N_pulse, omega, out_pulse, out_t, phi, &
                       power_shape, pulse_type, pulse_vec, pulse_vector, sigma, taushift
use mh5, only: mh5_put_dset
use Constants, only: Zero, Two, cZero, pi, auToFs
use Definitions, only: wp, iwp

implicit none
complex(kind=wp), intent(in) :: H0(:,:)
complex(kind=wp), intent(out) :: Ht(:,:)
real(kind=wp), intent(in) :: time
integer(kind=iwp), intent(in) :: pcount
integer(kind=iwp) :: i
real(kind=wp) :: omega_local, t_local, temp_vec(6)
complex(kind=wp) :: E_field(3)

E_field(:) = cZero

do i=1,N_pulse
  t_local = time-taushift(i)
  omega_local = omega(i)+linear_chirp*t_local
  pulse_vec(:) = pulse_vector(i,:)

  ! sine^N pulse
  ! A\vec{e}\sin^n(\pi(t-t_0)/(2\sigma))\sin{(\Omega(t-t_0)+\varphi_0)}
  ! duration of the pulse equals 2\sigma
  if (pulse_type(1:3) == 'SIN') then
    if (abs(t_local) <= sigma(i)) then
      E_field = E_field+amp(i)*pulse_vec*sin(pi*t_local/(Two*sigma(i)))**power_shape*sin(omega_local*t_local+phi(i))
      ! correction due to vector potential derivative [Paramonov_JPCA_2012]:
      ! -A\vec{e}\pi/(2\sigma\Omega)
      !     \sin(\pi(t-t_0)/(\sigma))\cos{(\Omega(t-t_0)+\varphi_0)}
      ! only for sine square shape form
      if (flag_acorrection .and. (power_shape == 2)) then
        E_field = E_field-amp(i)*pulse_vec*pi/(2*sigma(i)*omega_local)*sin(pi*t_local/sigma(i))*cos(omega_local*t_local+phi(i))
      !else
      !  E_field = Zero
      end if
    end if

  ! cos^N pulse:
  ! A\vec{e}\cos^n(\pi(t-t_0)/(2\sigma))\sin{(\Omega(t-t_0)+\varphi_0)}
  ! duration of the pulse equals 2\sigma
  else if (pulse_type(1:3) == 'COS') then
    if (abs(t_local) <= sigma(i)) then
      E_field = E_field+amp(i)*pulse_vec*cos(pi*t_local/(Two*sigma(i)))**power_shape*sin(omega_local*t_local+phi(i))
      ! correction is the same as in sine case, but with different choice of
      ! vector potential, here vector potential is given:
      ! -\vec{e}\frac{A}{\Omega} \cos^2(\pi(t-t_0)/(2\sigma))
      !     \cos{(\Omega(t-t_0)+\varphi_0)}
      ! only for cosine square shape form
      if (flag_acorrection .and. (power_shape == 2)) then
        E_field = E_field-amp(i)*pulse_vec*pi/(2*sigma(i)*omega_local)*sin(pi*t_local/sigma(i))*cos(omega_local*t_local+phi(i))
      !else
      !  E_field = Zero
      end if
    end if

  ! gaussian pulse
  ! A\vec{e}exp{-(t-t_0)^2/(2\sigma^2)}\sin{(\Omega(t-t_0)+\varphi_0)}
  else if (pulse_type == 'GAUSS') then
    E_field = E_field+amp(i)*pulse_vec*exp(-t_local**2/(2*sigma(i)**2))*sin(omega_local*t_local+phi(i))
    ! correction due to vector potential derivative:
    ! \vec{e}\frac{A(t-t_0)}{\sigma^2\Omega}
    !     \exp{-(t-t_0)^2/(2\sigma)^2}\cos{(\Omega(t-t_0) + \varphi_0)}
    if (flag_acorrection) then
      E_field = E_field+amp(i)*pulse_vec*t_local/(sigma(i)**2*omega_local)*exp(-t_local**2/(2*sigma(i)**2))* &
                cos(omega_local*t_local+phi(i))
    end if

  ! monochromatic pulse
  ! A\vec{e}\sin{(\Omega(t-t_0)+\varphi_0)}
  else if (pulse_type == 'MONO') then
    E_field = amp(i)*pulse_vec*sin(omega_local*(time-taushift(i))+phi(i))

  ! explicitly polarized pulses
  ! think of more clever definition
  else if (pulse_type == 'MONO_R_CIRCLE') then
    E_field(1) = amp(i)*sin(omega(i)*time+phi(i))
    E_field(2) = Amp(1)*cos(omega(i)*time+phi(i))
    E_field(3) = Zero

  else if (pulse_type == 'MONO_L_CIRCLE') then
    E_field(1) = amp(i)*cos(omega(i)*time+phi(i))
    E_field(2) = amp(i)*sin(omega(i)*time+phi(i))
    E_field(3) = Zero

  else if (pulse_type == 'GAUSS_R_CIRCLE') then
    E_field(1) = amp(i)*sin(omega(i)*time+phi(i))*exp(-(time-taushift(i))**2/(Two*sigma(i)**2))
    E_field(2) = amp(i)*cos(omega(i)*time+phi(i))*exp(-(time-taushift(i))**2/(Two*sigma(i)**2))
    E_field(3) = Zero

  else if (pulse_type == 'GAUSS_L_CIRCLE') then
    E_field(1) = amp(i)*cos(omega(i)*time+phi(i))*exp(-(time-taushift(i))**2/(Two*sigma(i)**2))
    E_field(2) = amp(i)*sin(omega(i)*time+phi(i))*exp(-(time-taushift(i))**2/(Two*sigma(i)**2))
    E_field(3) = Zero
  end if
end do

! saving pulse to files
if (pcount >= 0) then
  write(lu_pls,'(7(g25.15e3,2x))') time*auToFs,(real(E_field(i)),aimag(E_field(i)),i=1,3)
  do i=1,3
    temp_vec(2*i-1) = real(E_field(i))
    temp_vec(2*i) = aimag(E_field(i))
  end do
  call mh5_put_dset(out_pulse,temp_vec,[1,6],[pcount-1,0])
  call mh5_put_dset(out_t,[time*auToFs],[1],[pcount-1])
end if

! update Hamiltonian H0 to Ht adding
! scalar product of E_field and dipole moment
Ht = H0
do i=1,3
  Ht(:,:) = Ht(:,:)+dipole_basis(:,:,i)*E_field(i)
end do

end subroutine pulse

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Roland Lindh                                     *
************************************************************************
      Subroutine USOTRANS(USOR,USOI,NSS,
     &                    EigVec,MSTATE,
     &                    VSOR,VSOI)
      use rassi_global_arrays, only: JBNUM
      IMPLICIT Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      Integer NSS, MSTATE
      Real*8 USOR(NSS,NSS), USOI(NSS,NSS), EigVec(MSTATE,MSTATE)
      Real*8 VSOR(NSS,NSS), VSOI(NSS,NSS)
      Integer, Allocatable:: MAPST(:,:)
      REAL*8 tmp_R, tmp_I
      Integer ISTATE, JOB, MPLET, MSPROJ, ISS, JSS, JSS_, KSS, KSS_
*                                                                      *
************************************************************************
*                                                                      *
*     Before we start we need to backtransform the coefficients of the
*     SO states from the basis of the SF states which diagonalize the
*     SF Hamiltonian to the basis of the original SF states. This since
*     all transition moments, whether or retrived from disk or
*     recomputed, are in the basis of the original SF states.
*
C Mapping from spin states to spin-free state:
      Call mma_allocate(MAPST,nSS,3,Label='MAPST')
      ISS=0
      DO ISTATE=1,MSTATE
         JOB=JBNUM(ISTATE)
         MPLET=MLTPLT(JOB)
         DO MSPROJ=-MPLET+1,MPLET-1,2
            ISS=ISS+1
            MAPST(ISS,1)=ISTATE
            MAPST(ISS,2)=MPLET
            MAPST(ISS,3)=MSPROJ
       END DO
      END DO
*
*     Let us transform the coefficients in USOR and USOI
*
      Do iSS = 1, nSS
         Do JSS = 1, nSS
            tmp_R=0.0D0
            tmp_I=0.0D0
            jSS_=MAPST(JSS,1)
            Do kSS = 1, nSS
               If (MAPST(kss,2).ne.MAPST(jss,2)) Cycle
               If (MAPST(kss,3).ne.MAPST(jss,3)) Cycle
               kSS_=MAPST(kSS,1)
               tmp_R=tmp_R + USOR(kSS,iSS)*EigVec(jss_,kSS_)
               tmp_I=tmp_I + USOI(kSS,iSS)*EigVec(jss_,kSS_)
            End Do
            VSOR(JSS,ISS)=tmp_R
            VSOI(JSS,ISS)=tmp_I
         End Do
      End Do
      Call mma_deallocate(MAPST)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End Subroutine USOTRANS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Int_Prep_g(iSD4,nSD,Coor,Shijij,iAOV,iStabs)
      Use Basis_Info
      Implicit Real*8 (a-h,o-z)
*
      Integer iSD4(0:nSD,4)
*
      Real*8  Coor(3,4)
      Integer iAOV(4), iStabs(4)
      Logical  Shijij
*
      iCnttp=iSD4(13,1)
      iCnt  =iSD4(14,1)
      jCnttp=iSD4(13,2)
      jCnt  =iSD4(14,2)
      kCnttp=iSD4(13,3)
      kCnt  =iSD4(14,3)
      lCnttp=iSD4(13,4)
      lCnt  =iSD4(14,4)
*
      If (dbsc(iCnttp)%Aux) Then
         Coor(1:3,1)=dbsc(jCnttp)%Coor(1:3,jCnt)
      Else
         Coor(1:3,1)=dbsc(iCnttp)%Coor(1:3,iCnt)
      End If
      Coor(1:3,2)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
      If (dbsc(kCnttp)%Aux) Then
         Coor(1:3,3)=dbsc(lCnttp)%Coor(1:3,lCnt)
      Else
         Coor(1:3,3)=dbsc(kCnttp)%Coor(1:3,kCnt)
      End If
      Coor(1:3,4)=dbsc(lCnttp)%Coor(1:3,lCnt)
*
      Shijij= iSD4(11,1).eq.iSD4(11,3).and.
     &        iSD4(11,2).eq.iSD4(11,4)
*
      Do iQuad = 1, 4
         iAOV(iQuad)   = iSD4( 7,iQuad)
         iStabs(iQuad) = iSD4(10,iQuad)
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine prwf_vibrot(ndim,R)
      Implicit Real*8 (A-H,O-Z)
C Print the value of (unnormalized) vibrational wave functions.
CPAM97 For MOLCAS-4
C
#include "dimensions.fh"
      Parameter(nemax=nVib_Max,ndimmx=5000,lwork=nemax*ndimmx)
#include "intinp.fh"
#include "stdalloc.fh"
      Allocatable Vib(:)
      Dimension R(*)
*

      Call mma_allocate(Vib,lwork,label='Vib')

      write(6,*)
      Call CollapseOutput(1,'PRINTOUT OF VIBRATIONAL WAVE FUNCTIONS')
      write(6,*)

      ne1=nvib1+1
      ndim1=ndim+1
      nwork=ne1*ndim1
      ierr=0
      If(nwork.gt.lwork) then
        write(6,*)' PRWF_VibRot: Local work space too small.'
        write(6,*)' Please increase LWORK and recompile.'
        write(6,*)' Need at least:',nwork
        ierr=ierr+1
      End If
      If(ne1.gt.nemax) then
        write(6,*)' PRWF_VibRot: Local work space too small.'
        write(6,*)' Please increase NEMAX and recompile.'
        write(6,*)' Need at least:',ne1
        ierr=ierr+1
      End If
      If(ndim1.gt.ndimmx) then
        write(6,*)' PRWF_VibRot: Local work space too small.'
        write(6,*)' Please increase NDIMMX and recompile.'
        write(6,*)' Need at least:',ndim1
        ierr=ierr+1
      End If
      If(ierr.gt.0) Call Abend

C Loop over rotational quantum numbers
      Do J1=J1A,J2A
       Jad1=J1-J1A+1
       Write(6,'(1x,a,i3)')' Rotational quantum number J=',J1

C Read vibrational functions for this J-value.
       ist=1
       iadr1=iad12(Jad1)
       Do nv=1,ne1
        Call DDafile(Vibwvs,2,Vib(ist),ndim1,iadr1)
        ist=ist+ndim1
       End Do

C Write out the wave functions:
       do nvsta=0,ne1-1,5
         nvend=min(nvsta+4,ne1-1)
         write(6,*)
         write(6,'(5x,a12,8x,''v='',5(i2,13x))')
     &         'Radial dist.',(nv,nv=nvsta,nvend)
         do i=1,ndim
           write(6,'(1x,f12.6,5x,5f15.8)') r(i),
     &         (vib(i+ndim1*nv),nv=nvsta,nvend)
         end do
       end do

C End of loop over J1.
      end do
      Call CollapseOutput(0,'PRINTOUT OF VIBRATIONAL WAVE FUNCTIONS')
      write(6,*)
      Call mma_deallocate(Vib)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine faroald_init(nactel,nasht,ispin)
! The initialization subroutine lives outside of the
! faroald module so that it can be called separately.
! It fills in the necessary global data in the module,
! in preparation for the sigma_update routine.

use faroald, only: ex1_a, ex1_b, ex1_init, max_ex1a, max_ex1b, max_ex2a, max_ex2b, max_LRs, mult, my_ndet, my_nel, my_norb, ndeta, &
                   ndetb, nela, nelb, nhoa, nhob
use faroald, only: mma_allocate ! with extensions for ex1_struct
use second_quantization, only: binom_coef, rank_init
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nactel, nasht, ispin

my_nel = nactel
my_norb = nasht
mult = ispin

! compute alpha/beta subsets
nela = (my_nel+(mult-1))/2
nhoa = my_norb-nela
nelb = (my_nel-(mult-1))/2
nhob = my_norb-nelb
ndeta = binom_coef(nela,my_norb)
ndetb = binom_coef(nelb,my_norb)
my_ndet = ndeta*ndetb

! initialize binomial tables needed for ranking
call rank_init()

! number of possible non-destructive single excitations
max_ex1a = nela*(nhoa+1)
max_ex1b = nelb*(nhob+1)

! The number of non-vanishing elements in F is the number of
! non-vanashing single and double excitations from a string, and
! computed as the number of strings which differ in two, one, or zero
! spin orbitals from a given string.
max_ex2a = (nela*(nela-1)*(nhoa)*(nhoa-1))/4+nela*nhoa+1
max_ex2b = (nelb*(nelb-1)*(nhob)*(nhob-1))/4+nelb*nhob+1

! For sigma1, we use an excitation table for the beta strings.
call mma_allocate(ex1_b,max_ex1b,ndetb,label='ex1_b')
call ex1_init(nelb,my_norb,ex1_b)

! For sigma2, we use an excitation table for the alpha strings, unless
! Ms = 0 (mult = 1), as for singlet spins sigma2 is not computed and
! just taken as the transpose of sigma1.
if (mult /= 1) then
  call mma_allocate(ex1_a,max_ex1a,ndeta,label='ex1_a')
  call ex1_init(nela,my_norb,ex1_a)
end if

! For sigma3, we need to construct a list of determinant couples L(i)
! = E_pq R(i) for a given p and q for the alpha strings. This is done
! by a subroutine that takes L, R, and sgn arrays. The maximum size of
! these arrays is when p=q, at which point the number of couples is:
max_LRs = binom_coef(nela-1,my_norb-1)

end subroutine faroald_init

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine magnetization_pa(exch,nLoc,nM,nH,nneq,neq,neqv,nCenter,nTempMagn,nDir,nDirZee,nDirTot,nss,nexch,iopt,LUZee,nsymm,ngrid, &
                            TempMagn,hexp,mexp,hmin,hmax,em,zJ,thrs,dirX,dirY,dirZ,dir_weight,w,dipexch,s_exch,dipso,s_so,eso, &
                            hinput,r_rot,XLM,ZLM,XRM,ZRM,zeeman_energy,compute_Mdir_vector,m_paranoid,m_accurate,smagn,mem,doplot)
! constants defining the sizes
!  NM : number of states included in the exchange Zeeman matrix, ( Nex <= exch)
!  exch, nLoc, nH, nCenter, nTempMagn, nDir, nDirZee, nDirTot, nneq, neqv, neq, nss, nexch, iopt, mem, LUZee, hinput,
!  zeeman_energy, compute_Mdir_vector, m_paranoid, m_accurate, smagn, doplot, R_ROT, W
! exchange energies printed out in the previous part
!  ESO
! spin-orbit energies from ANISO files
!  Hexp, Mexp, thrs, XLM, ZLM, XRM, ZRM, dirX, dirY, dirZ, dir_weight, TempMagn, zJ, hmin, hmax, em, DIPEXCH, S_EXCH, dipso, s_so
!
! exchange data:
!  Wex : Zeeman exchange energies
!  Zex : exchange statistical sum, Boltzmann distribution
!  Sex : spin magnetisation, from the exchange block;
!  Mex : magnetisation, from the exchange block
! data for individual sites (all states):
!  ZL : local statistical sum, Boltzmann distribution
!  WL : Zeeman local energies
!  SL : spin magnetisation, from the local sites, using ALL states ;
!  ML : magnetisation, from local sites, using ALL states;
! data for individual sites (only states that enter exchange):
!  ZR : local statistical sum, Boltzmann distribution, using only Nexch states
!  WR : Zeeman local reduced energies, using only Nexch states;
!  SR : spin magnetisation, from the local sites, using only Nexch states ;
!  MR : magnetisation, from local sites, using only Nexch states;
!  ZRT, ZLT, MRT, MLT, SRT, SLT
! data for total system:
!  ZT : total statistical sum, Boltzmann distribution
!  ST : total spin magnetisation,
!  MT : total magnetisation
! magnetic field strength and orientation data:
!  dltH, H, dHX, dHY, dHZ, dHW
! total average M and average S data:
!  MAV, SAV, MVEC, SVEC

use Lebedev_quadrature, only: order_table
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten, mBohr, rNAVO
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: exch, nLoc, nM, nH, nneq, neq(nneq), neqv, nCenter, nTempMagn, nDir, nDirZee, nDirTot, nss(nneq), &
                                 nexch(nneq), iopt, LUZee(nDirZee), nsymm, ngrid, mem
real(kind=wp), intent(in) :: TempMagn(nTempMagn), Hexp(nH), Mexp(nH,nTempMagn), hmin, hmax, em, zJ, thrs, dirX(nDir), dirY(nDir), &
                             dirZ(nDir), dir_weight(nDirZee,3), W(exch), ESO(nneq,nLoc), R_ROT(nneq,neqv,3,3), &
                             XLM(nCenter,nTempMagn,3,3), ZLM(nCenter,nTempMagn), XRM(nCenter,nTempMagn,3,3), ZRM(nCenter,nTempMagn)
complex(kind=wp), intent(in) :: DIPEXCH(3,exch,exch), S_EXCH(3,exch,exch), dipso(nneq,3,nLoc,nLoc), s_so(nneq,3,nLoc,nLoc)
logical(kind=iwp), intent(in) :: hinput, zeeman_energy, compute_Mdir_vector, m_paranoid, m_accurate, smagn, doplot
integer(kind=iwp) :: I, ibuf, iDir, iH, IM, isite, it, itEnd, J, k, mem_local, n, nP
real(kind=wp) :: dltH
character(len=15) :: lbl_X, lbl_Y, lbl_Z
real(kind=wp), allocatable :: dHW(:), dHX(:), dHY(:), dHZ(:), ESO_TMP(:), H(:), MAV(:,:), Mex(:,:), ML(:,:,:), MLT(:,:,:), &
                              MR(:,:,:), MRT(:,:,:), MT(:,:,:), MVEC(:,:,:,:), SAV(:,:), Sex(:,:), SL(:,:,:), SLT(:,:,:), &
                              SR(:,:,:), SRT(:,:,:), ST(:,:,:), SVEC(:,:,:,:), Wex(:), WL(:,:), WR(:,:), Zex(:), ZL(:,:), &
                              ZLT(:,:), ZR(:,:), ZRT(:,:), ZT(:,:)
complex(kind=wp), allocatable :: dipso_tmp(:,:,:), s_so_tmp(:,:,:)
real(kind=wp), parameter :: cm3tomB = rNAVO*mBohr/Ten ! in cm3 * mol-1 * T
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
integer(kind=iwp) :: l
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: DBG = _DBG_
real(kind=wp), external :: dev, dnrm2_

#ifndef _DEBUGPRINT_
#include "macros.fh"
unused_var(mem)
#endif

write(u6,*)
write(u6,'(A)') repeat('%',96)
write(u6,'(40X,A)') 'CALCULATION OF THE MOLAR MAGNETIZATION'
write(u6,'(A)') repeat('%',96)
write(u6,*)
!----------------------------------------------------------------------
mem_local = 0
#ifdef _DEBUGPRINT_
write(u6,*) 'MAGN:        nM=',nM
write(u6,*) 'MAGN:      exch=',exch
write(u6,*) 'MAGN:      nLoc=',nLoc
write(u6,*) 'MAGN: nTempMagn=',nTempMagn
#endif

! Zeeman exchange energy spectrum
call mma_allocate(Wex,nM,'Wex')
mem_local = mem_local+size(Wex)*RtoB

! exchange statistical sum, Boltzmann distribution
call mma_allocate(Zex,nTempMagn,'Zex')
mem_local = mem_local+size(Zex)*RtoB
! spin magnetisation, from the exchange block
call mma_allocate(Sex,3,nTempMagn,'Sex')
mem_local = mem_local+size(Sex)*RtoB
! magnetisation, from the exchange block
call mma_allocate(Mex,3,nTempMagn,'Mex')
mem_local = mem_local+size(Mex)*RtoB

! local statistical sum, Boltzmann distribution
call mma_allocate(ZL,nTempMagn,nneq,'ZL')
mem_local = mem_local+size(ZL)*RtoB
! spin magnetisation, from the local sites, using ALL states
call mma_allocate(SL,3,nTempMagn,nneq,'SL')
mem_local = mem_local+size(SL)*RtoB
! magnetisation, from local sites, using ALL states
call mma_allocate(ML,3,nTempMagn,nneq,'ML')
mem_local = mem_local+size(ML)*RtoB

! local statistical sum, Boltzmann distribution, using only Nexch states
call mma_allocate(ZR,nTempMagn,nneq,'ZR')
mem_local = mem_local+size(ZR)*RtoB
! spin magnetisation, from the local sites, using only Nexch states
call mma_allocate(SR,3,nTempMagn,nneq,'SR')
mem_local = mem_local+size(SR)*RtoB
! magnetisation, from local sites, using only Nexch states
call mma_allocate(MR,3,nTempMagn,nneq,'MR')
mem_local = mem_local+size(MR)*RtoB

! Zeeman local energies
call mma_allocate(WL,nLoc,nneq,'WL')
mem_local = mem_local+size(WL)*RtoB
! Zeeman local reduced energies, using only Nexch states
call mma_allocate(WR,nLoc,nneq,'WR')
mem_local = mem_local+size(WR)*RtoB

! ZRT(nCenter,nTempMagn)
call mma_allocate(ZRT,nCenter,nTempMagn,'ZRT')
mem_local = mem_local+size(ZRT)*RtoB
! ZLT(nCenter,nTempMagn)
call mma_allocate(ZLT,nCenter,nTempMagn,'ZLT')
mem_local = mem_local+size(ZLT)*RtoB
! MRT(nCenter,3,nTempMagn)
call mma_allocate(MRT,nCenter,3,nTempMagn,'MRT')
mem_local = mem_local+size(MRT)*RtoB
! MLT(nCenter,3,nTempMagn)
call mma_allocate(MLT,nCenter,3,nTempMagn,'MLT')
mem_local = mem_local+size(MLT)*RtoB
! SRT(nCenter,3,nTempMagn)
call mma_allocate(SRT,nCenter,3,nTempMagn,'SRT')
mem_local = mem_local+size(SRT)*RtoB
! SLT(nCenter,3,nTempMagn)
call mma_allocate(SLT,nCenter,3,nTempMagn,'SLT')
mem_local = mem_local+size(SLT)*RtoB

! total statistical sum, Boltzmann distribution
call mma_allocate(ZT,nH,nTempMagn,'ZT')
mem_local = mem_local+size(ZT)*RtoB
! total spin magnetisation
call mma_allocate(ST,3,nH,nTempMagn,'ST')
ST(:,:,:) = Zero
mem_local = mem_local+size(ST)*RtoB
! total magnetisation
call mma_allocate(MT,3,nH,nTempMagn,'MT')
mem_local = mem_local+size(MT)*RtoB
! total spin magnetisation
call mma_allocate(SAV,nH,nTempMagn,'SAV')
SAV(:,:) = Zero
mem_local = mem_local+size(SAV)*RtoB
! total magnetisation
call mma_allocate(MAV,nH,nTempMagn,'MAV')
MAV(:,:) = Zero
mem_local = mem_local+size(MAV)*RtoB
! total spin magnetisation vector
call mma_allocate(SVEC,nDirTot,nTempMagn,nH,3,'SVEC')
mem_local = mem_local+size(SVEC)*RtoB
! total magnetisation vector
call mma_allocate(MVEC,nDirTot,nTempMagn,nH,3,'MVEC')
mem_local = mem_local+size(MVEC)*RtoB

! orientation of the field
call mma_allocate(dHX,nDirTot,'dHX')
call mma_allocate(dHY,nDirTot,'dHY')
call mma_allocate(dHZ,nDirTot,'dHZ')
call mma_allocate(dHW,nDirTot,'dHW')
mem_local = mem_local+size(dHX)*RtoB
mem_local = mem_local+size(dHY)*RtoB
mem_local = mem_local+size(dHZ)*RtoB
mem_local = mem_local+size(dHW)*RtoB

call mma_allocate(H,nH,'H  field')
mem_local = mem_local+size(H)*RtoB
#ifdef _DEBUGPRINT_
write(u6,*) 'MAGN:  memory allocated (local):'
write(u6,*) 'mem_local=',mem_local
write(u6,*) 'MAGN:  memory allocated (total):'
write(u6,*) 'mem_total=',mem+mem_local
#endif
!-----------------------------------------------------------------------
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
nP = order_table(nsymm,ngrid)

call hdir(nDir,nDirZee,dirX,dirY,dirZ,dir_weight,nP,nsymm,ngrid,nDirTot,dHX,dHY,dHZ,dHW)
call Add_Info('MR_MAGN  dHX',dHX,min(5,nDirTot),10)
call Add_Info('MR_MAGN  dHY',dHY,min(5,nDirTot),10)
call Add_Info('MR_MAGN  dHZ',dHZ,min(5,nDirTot),10)
call Add_Info('MR_MAGN  dWX',dHW,min(5,nDirTot),10)
#ifdef _DEBUGPRINT_
write(u6,'(A,F10.6)') '        zJ = ',zJ
write(u6,'(A,F10.6)') '      thrs = ',thrs
write(u6,'(A,   I6)') '      iopt = ',iopt
write(u6,'(A, 10I6)') '     nss(i)=',(nss(i),i=1,nneq)
write(u6,'(A, 10I6)') '   nexch(i)=',(nexch(i),i=1,nneq)
write(u6,'(A,   I6)') '  nTempMagn= ',nTempMagn
write(u6,'(A      )') 'TempMagn(i)='
write(u6,'(10F10.6)') (TempMagn(i),i=1,nTempMagn)
write(u6,*) 'm_paranoid =',m_paranoid
write(u6,*) 'm_accurate =',m_accurate
write(u6,*) '     smagn =',smagn
do k=1,nneq
  write(u6,'(A,i6)') 'site ',k
  write(u6,'(A,i2,A)') 'ESO(',k,')'
  write(u6,'(10F12.6)') (ESO(k,i),i=1,nss(k))
  write(u6,'(A,i2,A)') 'S_SO(',k,')'
  do i=1,nss(k)
    do j=1,nss(k)
      write(u6,'(3(2F15.10,3x))') (s_so(k,l,i,j),l=1,3)
    end do
  end do
  write(u6,'(A,i2,A)') 'DIPSO(',k,')'
  do i=1,nss(k)
    do j=1,nss(k)
      write(u6,'(3(2F15.10,3x))') (dipso(k,l,i,j),l=1,3)
    end do
  end do
end do !k
#endif

write(u6,'(2X,A,i3,A)') 'Molar magnetization will be calculated in ',nH,' points, equally distributed in magnetic field range'
write(u6,'(2X,F4.1,1x,a,1X,F4.1,a,5(F6.3,a))') HMIN,'--',HMAX,' T., at the following temperatures:'
do i=1,nTempMagn,10
  j = min(nTempMagn,i+9)
  write(u6,'(10(F8.4,A))') (TempMagn(k),' K.;',k=i,j)
end do
write(u6,'(2X,A,I4,A)') 'Powder molar magnetization will be averaged on ',nP,' directions of the applied magnetic field.'
write(u6,'(2x,10A)') ('--------',i=1,10)
if (nsymm == 1) then
  write(u6,'(23x,A)') 'Lebedev-Laikov grid on a hemisphere:'
  write(u6,'(38x,A)') 'z >= 0;'
else if (nsymm == 2) then
  write(u6,'(23x,A)') 'Lebedev-Laikov grid on a 4th-of-a-sphere:'
  write(u6,'(34x,A)') 'x >= 0; z >= 0;'
else if (nsymm == 3) then
  write(u6,'(23x,A)') 'Lebedev-Laikov grid on a 8th-of-a-sphere:'
  write(u6,'(30x,A)') 'x >= 0; y >= 0; z >= 0;'
end if
write(u6,'(2x,10A)') ('--------',i=1,10)
write(u6,'(2x,A,12x,A,2(18x,A),16x,A)') 'Nr.','x','y','z','weight'
do i=1,nP
  write(u6,'(i4,2x,4(F18.12,1x))') i,dHX(i+nDir+nDirZee),dHY(i+nDir+nDirZee),dHZ(i+nDir+nDirZee),dHW(i+nDir+nDirZee)
end do
write(u6,'(2x,10A)') ('--------',i=1,10)
write(u6,'(2X,A)') 'The cut-off energy for the exact diagonalization of the Zeeman Hamiltonian is:'
write(u6,'(2x,a,F15.9,A)') 'E = ',EM,' cm(-1).'
if (NM < 10) then
  write(u6,'(2X,A,i2,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 10) .and. (NM < 100)) then
  write(u6,'(2X,A,i3,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 100) .and. (NM < 1000)) then
  write(u6,'(2X,A,i4,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 1000) .and. (NM < 10000)) then
  write(u6,'(2X,A,i5,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
end if
if (m_accurate) then
  write(u6,'(2x,A)') 'The contribution of local excited states  is computed exactly.'
  if ((zJ /= Zero) .and. m_paranoid .and. (nTempMagn > 1)) then
    write(u6,'(2x,A)') 'The average spin is computed exactly for each temperature point.'
  else if ((zJ /= Zero) .and. (.not. m_paranoid) .and. (nTempMagn > 1)) then
    write(u6,'(2x,A,F9.3)') 'The average spin is computed exactly only for the temperature point T= ',maxval(TempMagn(:))
    write(u6,'(2x,A     )') 'We consider this to be a good approximation.'
  end if
else
  if ((zJ /= Zero) .and. m_paranoid .and. (nTempMagn > 1)) then
    write(u6,'(2x,A)') 'The average spin is computed exactly for each temperature point.'
  else if ((zJ /= Zero) .and. (.not. m_paranoid) .and. (nTempMagn > 1)) then
    write(u6,'(2x,A,F9.3)') 'The average spin is computed exactly only for the temperature  point T= ',TempMagn(1)
    write(u6,'(2x,A)') 'We consider this to be a good approximation.'
    write(u6,'(2x,A)') 'Use MPAR keyword to compute average spin exactly, for each temperature point, in case higher accuracy '// &
                       'is needed.'
  end if
  write(u6,'(2x,A)') 'The contribution of local excited states  is computed approximately (by using the susceptibility data). '
end if
if (compute_Mdir_vector) then
  write(u6,'(2x,A,i2,a)') 'The magnetization vector for ',nDir,' directions of the applied magnetic field will be calculated.'
else
  write(u6,'(2X,A)') 'The magnetization vector was not calculated.'
end if
if (zeeman_energy) then
  write(u6,'(2x,A,i2,a)') 'The Zeeman splitting for ',nDirZee,' directions of the applied magnetic field will be calculated.'
  write(u6,'(2x,a)') 'The Zeeman energies for each direction of the applied magnetic field are written in files "energy_XX.txt".'
# ifdef _DEBUGPRINT_
  do i=1,nDirZee
    write(u6,'(A,I4,A,I4)') 'LuZee(',i,' )=',LUZee(i)
  end do
# endif
else
  write(u6,'(2X,A)') 'Computation of the Zeeman splitting was not requested.'
end if
!if (maxval(TempMagn) < W(exch)) then
!  write(u6,'(2x,A)') 'Contribution to molar magnetization coming from local excited states is taken into account.'
!else
!  write(u6,'(2x,A)') 'Contribution to molar magnetization coming from local excited states is NOT taken into account.'
!  write(u6,'(2x,A)') 'TMAG is requesting to compute magnetization at a larger temperature than the highest exchange state.'
!  write(u6,'(2x,A)') 'Please include more states into the exchange coupling.'
!end if

! /// opening the loop over the field points
do iH=1,nH
  ! /// ----------------------------------------------------------------
  if (HINPUT) then
    H(iH) = HEXP(iH)
    if (H(iH) == Zero) H(iH) = 0.0001_wp
  else
    DLTH = (HMAX-HMIN)/real(nH-1,kind=wp)
    if (iH == 1) then
      H(iH) = HMIN+0.0001_wp
    else
      H(iH) = HMIN+DLTH*real(iH-1,kind=wp)
    end if
    if (H(iH) == Zero) H(iH) = 0.0001_wp
  end if

# ifdef _DEBUGPRINT_
  write(u6,'(A,i0,A,F10.5)') 'MAGNETIZATION::  H(',iH,') = ',H(iH)
# endif

  ! ///  opening the loop over different directions of the magnetic field
  do IM=1,NDIRTOT
    ZL(:,:) = Zero
    ZR(:,:) = Zero
    SL(:,:,:) = Zero
    ML(:,:,:) = Zero
    SR(:,:,:) = Zero
    MR(:,:,:) = Zero
#   ifdef _DEBUGPRINT_
    write(u6,'(A,F20.10)') 'zJ = ',zJ
#   endif
    ! exchange magnetization:
    call MAGN(exch,NM,dHX(iM),dHY(iM),dHZ(iM),H(iH),W,zJ,THRS,DIPEXCH,S_EXCH,nTempMagn,TempMagn,smagn,Wex,Zex,Sex,Mex,m_paranoid, &
              DBG)
#   ifdef _DEBUGPRINT_
    write(u6,'(A,3F11.7)') 'MEX:',(Mex(l,1),l=1,3)
#   endif
    if (IM == 1) then
      call Add_Info('MEX_MAGN    ',[dnrm2_(3*nTempMagn,Mex,1)],1,8)
      call Add_Info('MR_MAGN  Wex',[dnrm2_(nM,Wex,1)],1,8)
    end if
    ! compute local magnetizations:
    if (m_accurate) then
      do i=1,nneq
        ! all states:
        if (NSS(i) > NEXCH(i)) then
          call mma_allocate(ESO_TMP,nss(i),label='ESO_TMP')
          call mma_allocate(dipso_tmp,3,nss(i),nss(i),label='dipso_tmp')
          call mma_allocate(s_so_tmp,3,nss(i),nss(i),label='s_so_tmp')
          ESO_TMP(:) = ESO(i,1:NSS(i))
          dipso_tmp(:,:,:) = DIPSO(i,:,1:NSS(i),1:NSS(i))
          s_so_tmp(:,:,:) = S_SO(i,:,1:NSS(i),1:NSS(i))
          ! this check is to avoid the unnecessary computation, in cases when no local excited states are present
          call MAGN(NSS(i),NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),H(iH),ESO_TMP,zJ,THRS,dipso_tmp,s_so_tmp,nTempMagn,TempMagn,smagn, &
                    WL(1:NEXCH(i),i),ZL(:,i),SL(:,:,i),ML(:,:,i),m_paranoid,DBG)
          call mma_deallocate(ESO_TMP)
          call mma_deallocate(dipso_tmp)
          call mma_deallocate(s_so_tmp)
          if (IM == 2) call Add_Info('MR_MAGN  WL',[dnrm2_(nexch(i),WL(:,i),1)],1,8)
#         ifdef _DEBUGPRINT_
          write(u6,'(A,I2,A,3F11.7)') 'ML: site',i,' : ',(ML(l,1,i),l=1,3)
#         endif
          call mma_allocate(ESO_TMP,nexch(i),label='ESO_TMP')
          call mma_allocate(dipso_tmp,3,nexch(i),nexch(i),label='dipso_tmp')
          call mma_allocate(s_so_tmp,3,nexch(i),nexch(i),label='s_so_tmp')
          ESO_TMP(:) = ESO(i,1:NEXCH(i))
          dipso_tmp(:,:,:) = DIPSO(i,:,1:NEXCH(i),1:NEXCH(i))
          s_so_tmp(:,:,:) = S_SO(i,:,1:NEXCH(i),1:NEXCH(i))
          ! only local "exchange states":
          call MAGN(NEXCH(i),NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),H(iH),ESO_TMP,zJ,THRS,dipso_tmp,s_so_tmp,nTempMagn,TempMagn,smagn, &
                    WR(1:NEXCH(i),i),ZR(:,i),SR(:,:,i),MR(:,:,i),m_paranoid,DBG)
          call mma_deallocate(ESO_TMP)
          call mma_deallocate(dipso_tmp)
          call mma_deallocate(s_so_tmp)
          if (IM == 2) call Add_Info('MR_MAGN  WR',[dnrm2_(nexch(i),WR(:,i),1)],1,8)
#         ifdef _DEBUGPRINT_
          write(u6,'(A,I2,A,3F11.7)') 'MR: site',i,' : ',(MR(l,1,i),l=1,3)
#         endif
        end if
      end do

      if (IM == 3) then
        call Add_Info('ML_MAGN',[dnrm2_(3*nTempMagn*nneq,ML,1)],1,8)
        call Add_Info('MR_MAGN',[dnrm2_(3*nTempMagn*nneq,MR,1)],1,8)
      end if

      ! expand the basis and rotate local vectors to the general
      ! coordinate system:
      MRT(:,:,:) = Zero
      MLT(:,:,:) = Zero
      SRT(:,:,:) = Zero
      SLT(:,:,:) = Zero
      isite = 0
      do i=1,NNEQ
        do j=1,NEQ(i)
          isite = isite+1
          ! statistical distributions
          ZLT(isite,:) = ZL(:,i)
          ZRT(isite,:) = ZR(:,i)
          ! magnetizations:
          !  use R_rot matrices, which have determinant +1.
          !  note that  R_lg matrices have arbitrary determinant.
          do iT=1,nTempMagn
            do n=1,3
              MLT(isite,:,iT) = MLT(isite,:,iT)+r_rot(i,j,:,n)*ML(n,iT,i)
              SLT(isite,:,iT) = SLT(isite,:,iT)+r_rot(i,j,:,n)*SL(n,iT,i)
              MRT(isite,:,iT) = MRT(isite,:,iT)+r_rot(i,j,:,n)*MR(n,iT,i)
              SRT(isite,:,iT) = SRT(isite,:,iT)+r_rot(i,j,:,n)*SR(n,iT,i)
            end do
          end do
        end do ! j, neq(i)
      end do ! i, nneq
      ZRT(isite:,:) = Zero
      ZLT(isite:,:) = Zero
    end if ! m_accurate

    ! compute the total magnetizations according to the derived formulas:
    if (m_accurate) then
      do iT=1,nTempMagn
        if (smagn) call MSUM(nCenter,Sex(:,iT),Zex(iT),SLT(:,:,iT),ZLT(:,iT),SRT(:,:,iT),ZRT(:,iT),iopt,ST(:,iH,iT),ZT(iH,iT))
        call MSUM(nCenter,Mex(:,iT),Zex(iT),MLT(:,:,iT),ZLT(:,iT),MRT(:,:,iT),ZRT(:,iT),iopt,MT(:,iH,iT),ZT(iH,iT))
      end do
    else
      ! add the contribution from local excited states using the approximate X*H expression:
      do iT=1,nTempMagn
        do isite=1,nCenter
          MRT(isite,:,iT) = H(iH)*(XRM(isite,iT,:,1)*dHX(iM)+XRM(isite,iT,:,2)*dHY(iM)+XRM(isite,iT,:,3)*dHZ(iM))/cm3tomB
          MLT(isite,:,iT) = H(iH)*(XLM(isite,iT,:,1)*dHX(iM)+XLM(isite,iT,:,2)*dHY(iM)+XLM(isite,iT,:,3)*dHZ(iM))/cm3tomB
        end do
        if (smagn) then
          SRT(:,:,:) = Zero
          SLT(:,:,:) = Zero
          call MSUM(nCenter,Sex(:,iT),Zex(iT),SLT(:,:,iT),ZLM(:,iT),SRT(:,:,iT),ZRM(:,iT),iopt,ST(:,iH,iT),ZT(iH,iT))
        end if
        call MSUM(nCenter,Mex(:,iT),Zex(iT),MLT(:,:,iT),ZLM(:,iT),MRT(:,:,iT),ZRM(:,iT),iopt,MT(:,iH,iT),ZT(iH,iT))
      end do
    end if
    !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    ! print out hte Zeeman eigenstates
    if (zeeman_energy) then
      if ((iH == 1) .and. (iM == nDir+1)) &
        write(u6,'(A)') 'Energies of the Zeeman Hamiltonian for the following directions of the applied field:'
      if ((iH == 1) .and. (iM > nDir) .and. (iM <= nDir+nDirZee)) then
        write(u6,'(A,I3,A,3F10.6,3x,5A)') 'direction Nr.',iM-nDir,' : ',dHX(iM),dHY(iM),dHZ(iM),'written in file "zeeman_energy_', &
                                          char(48+mod((iM-nDir)/100,10)),char(48+mod((iM-nDir)/10,10)),char(48+mod(iM-nDir,10)), &
                                          '.txt".'
        write(LUZee(iM-nDir),'(A,3F24.15)') '# direction of the applied magnetic field:',dHX(iM),dHY(iM),dHZ(iM)
        write(LuZee(iM-nDir),'(A,6x,A,1000(I4,6x) )') '# H(T)',' State =>',(i,i=1,nm)
      end if

      if ((iM > nDir) .and. (iM <= nDir+nDirZee)) write(LUZee(iM-nDir),'(F8.4,1000F10.3)') H(IH),(Wex(I),I=1,NM)
    end if !zeeman_energy
    ! ------------------------------------------------------------------
    ! computing the AVERAGE MOMENTS calculated at different temperatures
    ! (TempMagn(i))
    do iT=1,nTempMagn
      MVEC(iM,iT,iH,:) = MT(:,iH,iT)
      SVEC(iM,iT,iH,:) = ST(:,iH,iT)
    end do !iT

    ! accumulate contributions:
    MAV(iH,:) = MAV(iH,:)+dHW(iM)*(dHX(iM)*MT(1,iH,:)+dHY(iM)*MT(2,iH,:)+dHZ(iM)*MT(3,iH,:))
    SAV(iH,:) = SAV(iH,:)+dHW(iM)*(dHX(iM)*ST(1,iH,:)+dHY(iM)*ST(2,iH,:)+dHZ(iM)*ST(3,iH,:))
    ! ///  closing the loops over field strengths and directions
  end do ! iM
end do ! iH
! Close Zeeman files, if opened
if (Zeeman_Energy) then
  do i=1,nDirZee
    close(LUZee(i))
  end do
end if

! -------------------------------------------------------------------
! WRITING SOME OF THE OUTPUT....
! -------------------------------------------------------------------
if (smagn) then
  do iT=1,nTempMagn
    !write(u6,*)
    do iDir=1,nDir+nDirZee
      !write(u6,*)
      write(u6,'(A,A,1x,A)') '--------|','------------------------------------------------------------|', &
                             '|------------------------------------------------------------|'
      write(u6,'(A,i3,26x,A,1x,A,60x,A)') 'Direction of the applied magnetic field:',iDir,'|','|','|'
      write(u6,'(A,F18.14,44x,A,1x,A,60x,A)') 'proj X=',dHX(iDIR),'|','|','|'
      write(u6,'(A,F18.14,44x,A,1x,A,60x,A)') 'proj Y=',dHY(iDir),'|','|','|'
      write(u6,'(A,F18.14,44x,A,1x,A,60x,A)') 'proj Z=',dHZ(iDir),'|','|','|'
      write(u6,'(A,F7.4,A,41x,A,1x,A,60x,A)') 'Temperature = ',TempMagn(iT),' kelvin','|','|','|'
      write(u6,'(A,A,1x,A)') '--------|','------------------------------------------------------------|', &
                             '|------------------------------------------------------------|'
      write(u6,'(2x,A,12x,2A,1x,A,10x,2A)') 'Field |','Magnetization Vector            |','   Total Magn. |','|', &
                                            'Spin Magnetization Vector         |','   Total Magn. |'
      write(u6,'(5A,1x,5A)') '--------|','--- proj X ---|','--- proj Y ---|','--- proj Z ---|','- in this dir.-|', &
                             '|--- proj X ---|','--- proj Y ---|','--- proj Z ---|','- in this dir.-|'
      do iH=1,nH
        write(u6,'(F7.3,1x,A,3(ES13.6,1x,A),ES14.7,1x,A,1x,A,3(ES13.6,1x,A),ES14.7,1x,A)') &
          H(iH),'|',MVEC(iDir,iT,iH,1),' ',MVEC(iDir,iT,iH,2),' ',MVEC(iDir,iT,iH,3),'|', &
          (MVEC(iDir,iT,iH,1)*dHX(iDir)+MVEC(iDir,iT,iH,2)*dHY(iDir)+MVEC(iDir,iT,iH,3)*dHZ(iDir)),'|','|',SVEC(iDir,iT,iH,1),' ', &
          SVEC(iDir,iT,iH,2),' ',SVEC(iDir,iT,iH,3),'|', &
          (SVEC(iDir,iT,iH,1)*dHX(iDir)+SVEC(iDir,iT,iH,2)*dHY(iDir)+SVEC(iDir,iT,iH,3)*dHZ(iDir)),'|'
      end do
      write(u6,'(A,A,1x,A)') '--------|','------------------------------------------------------------|', &
                             '|------------------------------------------------------------|'
    end do !iDir
  end do !iT

else

  do iT=1,nTempMagn
    do iDir=1,nDir+nDirZee
      write(u6,'(2A)') '--------|','------------------------------------------------------------|'
      write(u6,'(A,i3,26x,A)') 'Direction of the applied magnetic field:',iDir,'|'
      write(u6,'(A,F18.14,44x,A)') 'proj X=',dHX(iDIR),'|'
      write(u6,'(A,F18.14,44x,A)') 'proj Y=',dHY(iDir),'|'
      write(u6,'(A,F18.14,44x,A)') 'proj Z=',dHZ(iDir),'|'
      write(u6,'(A,F7.4,A,41x,A)') 'Temperature = ',TempMagn(iT),' kelvin','|'
      write(u6,'(2A)') '--------|','------------------------------------------------------------|'
      write(u6,'(2x,A,12x,2A)') 'Field |','Magnetization Vector            |','   Total Magn. |'
      write(u6,'(5A)') '--------|','--- proj X ---|','--- proj Y ---|','--- proj Z ---|','- in this dir.-|'
      do iH=1,nH
        write(u6,'(F7.3,1x,A,3(ES13.6,1x,A),ES14.7,1x,A)') &
          H(iH),'|',MVEC(iDir,iT,iH,1),' ',MVEC(iDir,iT,iH,2),' ',MVEC(iDir,iT,iH,3),'|', &
          (MVEC(iDir,iT,iH,1)*dHX(iDir)+MVEC(iDir,iT,iH,2)*dHY(iDir)+MVEC(iDir,iT,iH,3)*dHZ(iDir)),'|'
      end do
      write(u6,'(2A)') '--------|','------------------------------------------------------------|'
    end do !iDir

  end do !iT
end if !(smagn)
! ---------------------------------------------------------------------
! COMPUTING THE STANDARD DEVIATION OF THE MAGNETIZATION
!if (HINPUT) then
!  do iT=1,nTempMagn
!    STDEV(iT) = dev(nH,MAV(:,iT),Mexp(:,iT))
!  end do
!end if

write(u6,*)
write(u6,'(15X,A)') 'HIGH-FIELD POWDER MAGNETIZATION'
write(u6,'(20X,A)') '(Units: Bohr magneton)'
write(u6,*)
do iT=1,nTempMagn,5
  iTEnd = min(nTempMagn,iT+4)
  write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
  write(u6,'(A,11(F10.3,A))') '    H(T)   |STATISTICAL SUM|',(TempMagn(i),' K.  |',i=iT,iTEnd)
  write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
  do iH=1,nH
    write(u6,'(F10.6,1X,A,F14.7,1x,A,11(f14.10,1x,A))') H(iH),'|',ZT(iH,1),'|',(MAV(iH,i),'|',i=iT,iTEnd)
  end do
  write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
  if (HINPUT) then
    write(u6,'(A,15x,A, 11(f14.10,1x,A) )') 'ST.DEV.M   |','|',(dev(nH,MAV(:,i),Mexp(:,i)),'|',i=iT,iTEnd)
    write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
  end if
end do
if (smagn) then
  write(u6,*)
  write(u6,'(15X,A)') 'HIGH-FIELD POWDER SPIN MAGNETIZATION'
  write(u6,'(20X,A)') '(Units: Bohr magneton)'
  write(u6,*)
  do iT=1,nTempMagn,5
    iTEnd = min(nTempMagn,iT+4)
    write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
    write(u6,'(A,11(F10.3,A))') '   H(T)   |STATISTICAL SUM|',(TempMagn(i),' K.  |',i=iT,iTEnd)
    write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
    do iH=1,nH
      write(u6,'(F10.6,1X,A,F14.7,1x,A,11(f14.10,1x,A))') H(iH),'|',ZT(iH,1),'|',(SAV(iH,i),'|',i=iT,iTEnd)
    end do
    write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
  end do
end if !smagn
! add some verification:
call Add_Info('MR_MAGN',[dnrm2_(3*nTempMagn*nneq,MR,1)],1,8)
call Add_Info('MR_MAGN',[dnrm2_(3*nTempMagn*nneq,MR,1)],1,8)
call Add_Info('MR_MAGN',[dnrm2_(3*nTempMagn*nneq,MR,1)],1,8)

call Add_Info('H_MAGN       ',[dnrm2_(nH,H,1)],1,6)
call Add_Info('MAGN_AVERAGED',[dnrm2_(nH*nTempMagn,MAV,1)],1,6)
call Add_Info('ZTL_MAGN',[dnrm2_(nH*nTempMagn,ZT,1)],1,8)
do iH=1,nH
  write(lbl_X,'(A,i3)') 'MAGN_VECT X ',iH
  write(lbl_Y,'(A,i3)') 'MAGN_VECT Y ',iH
  write(lbl_Z,'(A,i3)') 'MAGN_VECT Z ',iH
  ibuf = nDirTot*nTempMagn
  call Add_Info(lbl_X,[dnrm2_(ibuf,MVEC(:,:,iH,1),1)],1,8)
  call Add_Info(lbl_Y,[dnrm2_(ibuf,MVEC(:,:,iH,2),1)],1,8)
  call Add_Info(lbl_Z,[dnrm2_(ibuf,MVEC(:,:,iH,3),1)],1,8)
end do

!-------------------------  PLOTs -------------------------------------!
if (DoPlot) then
  if (hinput) then
    call plot_MH_with_Exp(nH,H,nTempMagn,TempMagn,MAV,Mexp)
  else
    call plot_MH_no_Exp(nH,H,nTempMagn,TempMagn,MAV)
  end if

  !if (zeeman_energy) call plot_zeeman(nH,nM,nDirZee,H,LuZee )
end if
!------------------------- END PLOTs ----------------------------------!

!-----------------------------------------------------------------------
call mma_deallocate(Wex)
call mma_deallocate(Zex)
call mma_deallocate(Sex)
call mma_deallocate(Mex)
call mma_deallocate(ZL)
call mma_deallocate(SL)
call mma_deallocate(ML)
call mma_deallocate(ZR)
call mma_deallocate(SR)
call mma_deallocate(MR)
call mma_deallocate(WL)
call mma_deallocate(WR)
call mma_deallocate(ZRT)
call mma_deallocate(ZLT)
call mma_deallocate(MRT)
call mma_deallocate(MLT)
call mma_deallocate(SRT)
call mma_deallocate(SLT)
call mma_deallocate(ZT)
call mma_deallocate(ST)
call mma_deallocate(MT)
call mma_deallocate(SAV)
call mma_deallocate(MAV)
call mma_deallocate(SVEC)
call mma_deallocate(MVEC)
call mma_deallocate(dHX)
call mma_deallocate(dHY)
call mma_deallocate(dHZ)
call mma_deallocate(dHW)

call mma_deallocate(H)

return

end subroutine magnetization_pa

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DETCTL_GAS()

use CandS, only: ICSM, ICSPC, ISSM, ISSPC
use lucia_data, only: Allocate_Local_Arrays, CBLTP, CI1BT, CIBT, CLBT, CLEBT, CONF_OCC, Deallocate_Local_Arrays, IADVICE, &
                      IBSPGPFTP, IDC, IGSOCC, IPHGAS, IPRCIX, IREFSM, kvec3_length, LCSBLK, MAX_STR_OC_BLK, MAX_STR_SPGP, &
                      Memory_Needed_Lucia, MNHL, MXINKA, MXNSTR, MXNTTS, MXPCSM, MXPNGAS, MXPNSMST, MXPORB, MXSOOB, MXTSOB, &
                      NCONF_PER_OPEN, NCONF_PER_SYM, NCSF_HEXS, NCSF_PER_SYM, NELEC, NELFSPGP, NELFTP, NGAS, NHLFSPGP, NIRREP, &
                      NOBPT, NOBPTS, NOCOB, NOCSF, NOCTYP, NPCSCNF, NPDTCNF, NSD_PER_SYM, NSMOB, NSTFSMSPGP, NSTSO, NTOOB, PSSIGN, &
                      SDREO_I, XISPSM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: IATP, IATPM1, IATPM2, IBASSPC(1), IBTP, IBTPM1, IBTPM2, INTSCR, IOCCLS(1), IOCTPA, IOCTPB, JSYM, LBLOCK, &
                     LSCR12, LSCR2, LSCR3, LZ, LZSCR, MAXA, MAXA1, MAXB, MAXB1, MAXI, MAXIK, MAXK, MX_NSPII, MXADKBLK, &
                     MXADKBLK_AS, MXCIJA, MXCIJAB, MXCIJB, MXCJ, MXCJ_ALLSYM, MXSTBL, MXSTBL0, MXSXBL, NAEL, NBATCH, NBEL, NBLOCK, &
                     NDET, NEL, NOCCLS, NOCTPA, NOCTPB, NTTS
integer(kind=iwp), allocatable :: BASSPC(:), KLOCCLS(:), LCIOIO(:), SVST(:)
integer(kind=iwp), external :: IMNMX

! Set variables in Module cands
JSYM = IREFSM
ICSM = JSYM
ISSM = JSYM
ICSPC = 1
ISSPC = 1
! Set NDET
NDET = int(XISPSM(JSYM,1))
! Number of occupation classes
IATP = 1
IBTP = 2
NEL = NELFTP(IATP)+NELFTP(IBTP)
call OCCLS(1,NOCCLS,IOCCLS,NEL,NGAS,IGSOCC(:,1),IGSOCC(:,2),0,IBASSPC,NOBPT)
! and then the occupation classes
call mma_allocate(KLOCCLS,NGAS*NOCCLS,Label='KLOCCLS')
call mma_allocate(BASSPC,NOCCLS,Label='BASSPC')
call OCCLS(2,NOCCLS,KLOCCLS,NEL,NGAS,IGSOCC(:,1),IGSOCC(:,2),1,BASSPC,NOBPT)
call mma_deallocate(BASSPC)
if (NOCSF == 0) then
  ! Initial information on CSF expansion
  call CSFDIM_GAS(KLOCCLS,NOCCLS,JSYM)
  ! Prototype dets and csf's and CSF'SD matrices
  call CSDTMT_GAS()
end if
! Allocate memory for diagonalization
!if (ISIMSYM == 0) then
LBLOCK = MXSOOB
!else
!  LBLOCK = MXSOOB_AS
!end if
LBLOCK = max(LBLOCK,LCSBLK)
! JESPER : Should reduce I/O
!PAM06 LBLOCK = MAX(XISPSM(IREFSM,1),real(MXSOOB,kind=wp))
LBLOCK = max(int(XISPSM(IREFSM,1)),MXSOOB)
if (PSSIGN /= Zero) LBLOCK = int(Two*XISPSM(IREFSM,1))

! Information about block structure- needed by new PICO2 routine.
! Memory for partitioning of C vector
IATP = 1
IBTP = 2
NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)
NTTS = MXNTTS
call Allocate_Local_Arrays(NTTS,NIRREP)
! Additional info required to construct partitioning

call mma_allocate(LCIOIO,NOCTPA*NOCTPB,Label='LCIOIO')

call IAIBCM(ICSPC,LCIOIO)
call mma_allocate(SVST,1,Label='SVST')
call ZBLTP(jsym,NIRREP,IDC,CBLTP,SVST)
call mma_deallocate(SVST)

! Batches  of C vector
call PART_CIV2(IDC,NSTSO(IATP)%A,NSTSO(IBTP)%A,NOCTPA,NOCTPB,NIRREP,LCIOIO,jsym,NBATCH,CLBT,CLEBT,CI1BT,CIBT,0)
! Number of BLOCKS
NBLOCK = CI1BT(NBATCH)+CLBT(NBATCH)-1
! Length of each block
call EXTRROW(CIBT,8,8,NBLOCK,CI1BT)
if (NEL > 0) call CNFORD_GAS(KLOCCLS,NOCCLS,jsym,SDREO_I(jsym)%A,CIBT,NBLOCK)

call Deallocate_Local_Arrays()
! If PICO2/SBLOCK are used, three blocks are used in PICO2, so
!
! Sblock is used in general nowadays so,
! Largest block of strings in zero order space
MXSTBL0 = MXNSTR
! type of alpha and beta strings
IATP = 1
IBTP = 2
! alpha and beta strings with an electron removed
IATPM1 = 3
IBTPM1 = 4
! alpha and beta strings with two electrons removed
IATPM2 = 5
IBTPM2 = 6

NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)
! Largest number of strings of given symmetry and type
MAXA = 0
if (NAEL >= 1) then
  MAXA1 = IMNMX(NSTSO(IATPM1)%A,NIRREP*NOCTYP(IATPM1),2)
  MAXA = max(MAXA,MAXA1)
  if (NAEL >= 2) then
    MAXA1 = IMNMX(NSTSO(IATPM2)%A,NIRREP*NOCTYP(IATPM2),2)
    MAXA = max(MAXA,MAXA1)
  end if
end if
MAXB = 0
if (NBEL >= 1) then
  MAXB1 = IMNMX(NSTSO(IBTPM1)%A,NIRREP*NOCTYP(IBTPM1),2)
  MAXB = max(MAXB,MAXB1)
  if (NBEL >= 2) then
    MAXB1 = IMNMX(NSTSO(IBTPM2)%A,NIRREP*NOCTYP(IBTPM2),2)
    MAXB = max(MAXB,MAXB1)
  end if
end if

MXSTBL = max(MAXA,MAXB,MXSTBL0)

if (IPRCIX >= 2) write(u6,*) ' Largest block of strings with given symmetry and type',MXSTBL
! Largest number of resolution strings and spectator strings
! that can be treated simultaneously
MAXI = min(MXINKA,MXSTBL)
MAXK = min(MXINKA,MXSTBL)
! scratch space for projected matrices and a CI block

! Scratch space for CJKAIB resolution matrices
! Size of C(Ka,Jb,j),C(Ka,KB,ij)  resolution matrices
IOCTPA = IBSPGPFTP(IATP)
IOCTPB = IBSPGPFTP(IBTP)
call MXRESCPH(LCIOIO,IOCTPA,IOCTPB,NOCTPA,NOCTPB,NIRREP,NSTFSMSPGP,MXPNSMST,NSMOB,MXPNGAS,NGAS,NOBPTS,MAXK,NELFSPGP,MXCJ,MXCIJA, &
              MXCIJB,MXCIJAB,MXSXBL,MXADKBLK,IPHGAS,NHLFSPGP,MNHL,IADVICE,MXCJ_ALLSYM,MXADKBLK_AS,MX_NSPII)

call mma_deallocate(LCIOIO)

if (IPRCIX >= 2) then
  write(u6,*) 'DETCTL : MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL',MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL
  write(u6,*) ' MXADKBLK, MXADKBLK_AS',MXADKBLK,MXADKBLK_AS
end if
!if (ISIMSYM == 1) then
!  MXCJ = MAX(MXCJ_ALLSYM,MX_NSPII)
!  MXADKBLK_AS = MXADKBLK
!end if
! Using hardwired routines, MXCIJAB also used
LSCR2 = max(MXCJ,MXCIJA,MXCIJB,MXCIJAB,MX_NSPII)
if (IPRCIX >= 2) write(u6,*) ' Space for two resolution matrices ',2*LSCR2
LSCR12 = max(LBLOCK,2*LSCR2)

KVEC3_LENGTH = max(LSCR12,2*LBLOCK)

! Calculate how much memory the sigma routines needs.

! Memory needed in Sigma_Master
MEMORY_NEEDED_LUCIA = KVEC3_LENGTH
! Memory needed in MV7
MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA+2*1+NOCTPA*NOCTPB+NIRREP+11*MXNTTS
!if ((IDC == 3) .or. (IDC == 4)) MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA+NIRREP
! Memory needed in SBLOCK
! Largest active orbital block belonging to given type and symmetry
MXTSOB = max(0,maxval(NOBPTS(1:NGAS,1:NSMOB)))
INTSCR = max(MXTSOB**4,NTOOB**2)
! vectors able to hold strings of given sym and type
MAXIK = max(MAXI,MAXK)
LSCR3 = max(MXADKBLK,MAXIK*MXTSOB*MXTSOB,MXNSTR)
! Space for four blocks of string occupations and arrays of
! reordering arrays
! Also used to hold an NORB*NORB matrix
LZSCR = (max(NAEL,NBEL)+3)*(NOCOB+1)+2*NOCOB+NOCOB*NOCOB
LZ = (max(NAEL,NBEL)+2)*NOCOB
MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA+NOCTPA**2+NOCTPB**2+2*NIRREP**2+2*INTSCR+3*NOCTPA*NOCTPB+NIRREP+8*LSCR3+12*NTTS+ &
                      MAX_STR_OC_BLK+2*MAX_STR_SPGP+2*LZ+LZSCR
!if ((IDC == 3) .or. (IDC == 4))  MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA+NIRREP
!if (ISIMSYM == 0) then
MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA+4*MAX_STR_SPGP
!end iF

call LUCIA2MOLCAS(CONF_OCC(jsym)%A,SDREO_I(jsym)%A,ndet,ncsf_per_sym,nsd_per_sym,nconf_per_sym,mxpcsm,mxporb,nconf_per_open, &
                  npdtcnf,npcscnf,nCSF_HEXS)

call mma_deallocate(KLOCCLS)

end subroutine DETCTL_GAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 07, 2022, created this file.               *
!*****************************************************************

subroutine PrintCMSIter(iStep,Qnew,Qold,RMat,lRoots)

use CMS, only: iCMSOpt, LargestQaaGrad, NCMSScale, NPosHess
use Constants, only: deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iStep, lRoots
real(kind=wp), intent(in) :: Qnew, Qold, RMat(lRoots**2)
real(kind=wp) :: Diff

!write(u6,*) 'iteration information'
Diff = Qnew-Qold
if (iCMSOpt == 2) then

  if (lRoots == 2) then
    write(u6,'(6X,I4,8X,F6.1,9X,F16.8,5X,ES16.4E3)') iStep,asin(RMat(3))/deg2rad,Qnew,Diff
  else
    write(u6,'(6X,I4,2X,F14.8,2X,ES14.4E3)') iStep,Qnew,Diff
  end if

else

  !if (lRoots == 2) then
  !  write(u6,'(6X,I4,8X,F6.1,9X,F16.8,5X,ES16.4E3)') iStep,asin(RMat(3))/deg2rad,Qnew,Diff
  !else
  if (NCMSScale > 0) then
    write(u6,'(6X,I4,2X,F14.8,2X,ES12.2E3,2X,I5,2X,ES14.4E3,3X,A3,I1)') iStep,Qnew,Diff,nPosHess,LargestQaaGrad,'1E-',NCMSScale
  else
    write(u6,'(6X,I4,2X,F14.8,2X,ES12.2E3,2X,I5,2X,ES14.4E3,3X,A3)') iStep,Qnew,Diff,nPosHess,LargestQaaGrad,'1.0'
  end if
  !end if

end if

return

end subroutine PrintCMSIter

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
* ALL SUBROUTINE HERE HAVE THE PURPOSE TO PUT OR GET NUMBERS ON/FROM
* STARTFILES AND SAMPFILES.
*
      Subroutine Get8(Ract,Etot)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "WrkSpc.fh"

      Character Head*200

      iDisk=0
      Call DaName(iLuStIn,StFilIn)
      Call WrRdSim(iLuStIn,2,iDisk,iTcSim,64,Etot,Ract,nPart,Gamold
     &,GaOld,Esub)
      iDisk=iTcSim(1)
*
*---- In this loop we read the coordinates. The construction of Cordst
*     makes this loop necessary. Maybe we should consider going to
*     dynamic allocation.
*
      Do 1020, i=1,3
        Call GetMem('CTemp','Allo','Real',iCT,nPart*nCent)
        Call dDaFile(iLuStIn,2,Work(iCT),nPart*nCent,iDisk)
        Do 1021, j=1,nCent*nPart
          Cordst(j,i)=Work(iCT+j-1)
1021    Continue
        Call GetMem('CTemp','Free','Real',iCT,nPart*nCent)
        iDisk=iTcSim(i+1)
1020  Continue
      Call DaClos(iLuStIn)
*
*---- If requested, print initial coordinates.
*
      If(iPrint.ge.10) then
        Write(Head,*)'Coordinates read from startfile.'
        Call Cooout(Head,Cordst,nPart,nCent)
      Endif

      Return
      End


      Subroutine Get9(Ract,Coord,info_atom,iQ_Atoms,iDiskSa)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "WrkSpc.fh"

      Dimension Coord(MxAt*3)
      Dimension info_atom(MxAt)
      Character Head*200

      Call WrRdSim(iLuSaIn,2,iDiskSa,iTcSim,64,Etot,Ract,nPart,Gamold
     &,GaOld,Esub)
      iDiskSa=iTcSim(1)
      Do 1022, i=1,3
        Call GetMem('CTemp','Allo','Real',iCT,nPart*nCent)
        Call dDaFile(iLuSaIn,2,Work(iCT),nPart*nCent,iDiskSa)
        Do 1023, j=1,nCent*nPart
          Cordst(j,i)=Work(iCT+j-1)
1023    Continue
        Call GetMem('CTemp','Free','Real',iCT,nPart*nCent)
        iDiskSa=iTcSim(i+1)
1022  Continue
*
*---- We dummy-read the induced dipoles from the sampfile.
*
*      Call GetMem('Dummy','Allo','Real',iDum,nPart*nPol)
*      Do 1777, i=1,3
*        Call dDaFile(iLuSaIn,2,Work(iDum),nPol*nPart,iDiskSa)
*1777  Continue
*      Call GetMem('Dummy','Free','Real',iDum,nPart*nPol)
*
*---- And now we place the QM-molecule in proper place and set some
*     numbers to zero or one so we only collect configurations from
*     the sampfile.
*
      Call PlaceIt9(Coord,Cordst,info_atom,iQ_Atoms)
      delX=0
      delFi=0
      delR=0
      nMacro=1
      nMicro=1
*
*---- Some printing if requested.
*
      If(iPrint.ge.15) then
        Write(Head,*)'Coordinates after substitution in configuration r'
     &//'ead from sampfile.'
        Call Cooout(Head,Cordst,nPart,nCent)
      Endif

      Return
      End


      Subroutine Put9(Etot,Ract,iDT,iHowMSamp,Gamma,Gam,Esav,iDisk)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "WrkSpc.fh"

      Dimension iDT(3)
      Character Head*200

      iHowMSamp=iHowMSamp+1
      iDiskOld=iDisk
      Call WrRdSim(iLuSaUt,1,iDisk,iTcSim,64,Etot,Ract,nPart
     &            ,Gamma,Gam,Esav)  !A header
      iTcSim(1)=iDisk
      Do 1024, i=1,3
        Call GetMem('CTemp','Allo','Real',iCT,nPart*nCent)
        Do 1025, j=1,nCent*nPart
          Work(iCT+j-1)=Cordst(j,i)
1025    Continue
        Call dDaFile(iLuSaUt,1,Work(iCT),nPart*nCent,iDisk)
                 !The solvent coordinates.
        Call GetMem('CTemp','Free','Real',iCT,nPart*nCent)
        iTcSim(i+1)=iDisk
1024  Continue
*      Do 777, i=1,3
*        Call dDaFile(iLuSaUt,1,-Work(iDT(i)),nPart*nPol,iDisk)
*777   Continue                             !Induced dipoles.
*      iTcSim(5)=iDisk
      iDiskHead=iDiskOld
      Call WrRdSim(iLuSaUt,1,iDiskHead,iTcSim,64,Etot,Ract,nPart
     &            ,Gamma,Gam,Esav) !Put header again, but
                         !now with a
                    !meaningful iTcSim vector that contains
             !the table of content which simplifies reading

      If(iPrint.ge.15) then
        Write(Head,*)' Coordinates put on sampfile.'
        Call Cooout(Head,Cordst,nPart,nCent)
      Endif

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(iDT)
      End


      Subroutine Put8(Ract,Etot,Gamma,Gam,Esav)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "WrkSpc.fh"

      Character Head*200

      Call DaName(iLuStUt,StFilUt)  !Here follows a general output
      iDisk=0                   !to the startfile.
      Call WrRdSim(iLuStUt,1,iDisk,iTcSim,64,Etot,Ract,nPart,Gamma
     &            ,Gam,Esav)
      iTcSim(1)=iDisk
      Do 1010,i=1,3  !In this loop the coordinates are put on file.
                     !The loop is needed due to how Cordst is
                     !statically allocated.
        Call GetMem('CTemp','Allo','Real',iCT,nPart*nCent)
        Do 1011,j=1,nPart*nCent
          Work(iCT+j-1)=Cordst(j,i)
1011    Continue
        Call dDaFile(iLuStUt,1,Work(iCT),nPart*nCent,iDisk)
        iTcSim(1+i)=iDisk
        Call GetMem('CTemp','Free','Real',iCT,nPart*nCent)
1010  Continue
      iDisk=0
      Call WrRdSim(iLuStUt,1,iDisk,iTcSim,64,Etot,Ract,nPart,Gamma
     &            ,Gam,Esav)
      Call DaClos(iLuStUt)
      If(iPrint.ge.10) then  !Print the stored configuration.
        Write(Head,*)' Coordinates put on the startfile solvent configu'
     &//'ration.'
        Call Cooout(Head,Cordst,nPart,nCent)
      Endif

      Return
      End

***********************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2022, Jie J. Bao                                       *
************************************************************************
******************************************************************
* history:                                                       *
* Jie J. Bao, on May. 19, 2022, created this file.               *
******************************************************************
************************************************************************
      Subroutine PrintMat2(FileName,MatInfo,Matrix,NRow,NCol,
     &                     LenName,LenInfo,Trans)


*     This subroutine is to replace PrintMat in the long run.
*     Matrix is now a nRow*nCol array.
*     Note that the column index is the fast running index in Fortran,
*     so when TRANS='T', it prints the matrix by proceeding with the
*     fast-running index.

      INTEGER NRow,NCol,LenName
      CHARACTER(Len=LenName)::FileName
      CHARACTER(Len=LenInfo)::MatInfo
      CHARACTER(Len=1)::Trans
      CHARACTER(Len=80)::PrtFmt
      Real*8,DIMENSION(NRow*NCol)::Matrix

      INTEGER LU,IsFreeUnit,IRow,ICol,iOff
      External IsFreeUnit

      IF(LenName.gt.0) THEN
      LU=100
      LU=IsFreeUnit(LU)
      CALL Molcas_Open(LU,FileName)
      ELSE
      LU=6
      END IF
      IF(Trans.eq.'T') THEN
       WRITE(PrtFmt,'(A1,I5,A14)')
     & '(',NCol,'(E24.14E4,1X))'
       DO IRow=1,NRow
        iOff=(IRow-1)*nCol
        write(LU,PrtFmt)
     &  (Matrix(iOff+ICol),ICol=1,NCol)
       END DO
      ELSE
       WRITE(PrtFmt,'(A1,I5,A14)')
     & '(',NRow,'(E24.14E4,1X))'
       DO ICol=1,NCol
        write(LU,PrtFmt)
     & (Matrix((iRow-1)*nCol+iCol),IRow=1,NRow)
       END DO
      END IF
      WRITE(LU,*)MatInfo
      IF(LenName.gt.0) THEN
       Close(LU)
      END IF
      RETURN
      End Subroutine

******************************************************
      Subroutine ReadMat2(FileName,MatInfo,Matrix,NRow,NCol,
     &LenName,LenInfo,Trans)

*     This subroutine is to replace ReadMat in the long run.
      INTEGER NRow,NCol,LenName
      CHARACTER(Len=LenName)::FileName
      CHARACTER(Len=LenInfo)::MatInfo
      CHARACTER(Len=1)::Trans
      Real*8,DIMENSION(NRow*NCol)::Matrix

      INTEGER LU,IsFreeUnit,IRow,ICol,iOff
      External IsFreeUnit

      IF(LenName.gt.0) THEN
       LU=100
       LU=IsFreeUnit(LU)
       CALL Molcas_Open(LU,FileName)
      ELSE
       LU=6
      END IF
      IF(Trans.eq.'T') THEN
       DO IRow=1,NRow
        iOff=(IRow-1)*nCol
        read(LU,*) (Matrix(iOff+ICol),ICol=1,NCol)
       END DO
      ELSE
       DO ICol=1,NCol
        read(LU,*) (Matrix((iRow-1)*nCol+iCol),IRow=1,NRow)
       END DO
      END IF
      Read(LU,*)MatInfo
      IF(LenName.gt.0) THEN
       Close(LU)
      END IF
      RETURN
      End Subroutine
******************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine restart_check(Ifrestart,input_to_read,input_file_name,nT,nH,nTempMagn,nDir,nDirZee,nMult,GRAD)
! this routine looks into the file "single_aniso.input" for the "RESTart" keyword

use Constants, only: Zero
use Definitions, only: wp, iwp, u5, u6

implicit none
logical(kind=iwp), intent(out) :: Ifrestart, GRAD
integer(kind=iwp), intent(out) :: input_to_read, nT, nH, nTempMagn, nDir, nDirZee, nMult
character(len=180), intent(out) :: input_file_name
integer(kind=iwp) :: i, istatus, linenr, mg, ncut, nk
real(kind=wp) :: encut_rate, rdummy
logical(kind=iwp) :: KeyENCU, KeyERAT, KeyHEXP, KeyHINT, KeyMVEC, KeyNCUT, KeyTMAG, KeyZEEM
character(len=280) :: line, tmp

Ifrestart = .false.
input_to_read = 0
GRAD = .false.
nH = 0
nT = 0
nMult = 0
nDirZee = 0
nDir = 0
nk = 0
mg = 0
ncut = 0
encut_rate = Zero
nTempMagn = 0
input_file_name = 'aniso.input'
!origin_of_data_file = 'xxxxxxxx'

!KeyREST = .false.
!KeyTEXP = .false.
KeyHEXP = .false.
KeyHINT = .false.
!KeyTINT = .false.
KeyTMAG = .false.
KeyMVEC = .false.
KeyZEEM = .false.
!KeyMLTP = .false.
KeyNCUT = .false.
KeyENCU = .false.
KeyERAT = .false.
!KeyGRAD = .false.
!KeyDATA = .false.

!=========== End of default settings====================================
rewind(u5)
do
  read(u5,'(A180)',iostat=istatus) LINE
  if (istatus < 0) then
    write(u6,*) ' -- READIN: Unexpected End of input file.'
    return
  end if
  call NORMAL(LINE)
  if (LINE(1:7) == '&SINGLE') exit
end do
LINENR = 0
do
  read(u5,'(A280)',iostat=istatus) line
  if (istatus < 0) then
    write(u6,*) ' -- READIN: Unexpected End of input file.'
    return
  end if
  LINENR = LINENR+1
  call NORMAL(LINE)
  if ((LINE(1:1) == '*') .or. (LINE == ' ')) cycle

  select case (LINE(1:4))
    case ('END ','    ')
      exit

    case ('REST')
      Ifrestart = .true.
      !KeyREST = .true.
      read(u5,*) input_to_read
      input_file_name = 'aniso.input'
#     ifdef _DEBUGPRINT_
      write(u6,*) input_to_read
#     endif
      if ((input_to_read == 2) .or. (input_to_read == 3) .or. (input_to_read == 4)) then
        backspace(u5)
        read(u5,*) input_to_read,tmp
#       ifdef _DEBUGPRINT_
        write(u6,*) tmp
#       endif
        input_file_name = trim(tmp)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'restart_check: REST, input_file_name='
        write(u6,*) input_file_name
#       endif
      end if
      LINENR = LINENR+1

    case ('DATA')
      Ifrestart = .true.
      !KeyDATA = .true.
      read(u5,*) tmp
      input_file_name = trim(tmp)
      input_to_read = 6
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: DATA, input_file_name='
      write(u6,*) input_file_name
#     endif
      LINENR = LINENR+1

    case ('TEXP')
      read(u5,*) nT
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: TEXP, nT=',nT
#     endif
      !KeyTEXP = .true.
      LINENR = LINENR+1

    case ('GRAD')
      !KeyGRAD = .true.
      GRAD = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check:  GRAD = ',GRAD
#     endif
      LINENR = LINENR+1

    case ('HEXP')
      read(u5,*) nTempMagn,(rdummy,i=1,nTempMagn)
      read(u5,*) nH
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: HEXP, nH=',nH
      write(u6,*) 'restart_check: HEXP, nTempMagn=',nTempMagn
#     endif
      KeyHEXP = .true.
      LINENR = LINENR+2

    case ('HINT')
      read(u5,*) rdummy,rdummy,nH
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: HINT, nH=',nH
#     endif
      KeyHINT = .true.
      LINENR = LINENR+1

    case ('TINT')
      read(u5,*) rdummy,rdummy,nT
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: HINT, nT=',nT
#     endif
      !KeyTINT = .true.
      LINENR = LINENR+1

    case ('TMAG')
      read(u5,*) nTempMagn
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: TMAG, nTempMagn=',nTempMagn
#     endif
      KeyTMAG = .true.
      LINENR = LINENR+1

    case ('MVEC')
      read(u5,*) nDir
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: MVEC, nDir=',nDir
#     endif
      KeyMVEC = .true.
      LINENR = LINENR+1

    case ('ZEEM')
      read(u5,*) nDirZee
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: ZEEM, nDirZee=',nDirZee
#     endif
      KeyZEEM = .true.
      LINENR = LINENR+1

    case ('MLTP')
      read(u5,*) nMult
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: MLTP, nMult=',nMult
#     endif
      !KeyMLTP = .true.
      LINENR = LINENR+1

    case ('NCUT')
      read(u5,*) NCUT
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: NCUT, NCUT=',NCUT
#     endif
      KeyNCUT = .true.
      LINENR = LINENR+1

    case ('ENCU')
      read(u5,*) NK,MG
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: ENCU, NK, MG=',NK,MG
#     endif
      LINENR = LINENR+1
      KeyENCU = .true.

    case ('ERAT')
      read(u5,*) encut_rate
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: ERAT, encut_rate=',encut_rate
#     endif
      KeyERAT = .true.
      LINENR = LINENR+1

  end select
end do

#include "macros.fh"
unused_var(rdummy)

! These variables are read, but never used for anything
unused_var(nk)
unused_var(mg)
unused_var(ncut)
unused_var(encut_rate)

write(u6,'(5X,A)') 'restart_check: NO ERROR WAS LOCATED WHILE READING INPUT'

!write(u6,*) 'KeyREST=',KeyREST
!write(u6,*) 'KeyTEXP=',KeyTEXP
!write(u6,*) 'KeyHEXP=',KeyHEXP
!write(u6,*) 'KeyHINT=',KeyHINT
!write(u6,*) 'KeyTINT=',KeyTINT
!write(u6,*) 'KeyTMAG=',KeyTMAG
!write(u6,*) 'KeyMVEC=',KeyMVEC
!write(u6,*) 'KeyZEEM=',KeyZEEM
!write(u6,*) 'KeyMLTP=',KeyMLTP
!write(u6,*) 'KeyNCUT=',KeyNCUT
!write(u6,*) 'KeyENCU=',KeyENCU
!write(u6,*) 'KeyERAT=',KeyERAT
!write(u6,*) 'KeyGRAD=',KeyGRAD

!write(u6,*) 'LOGLINE=',KeyTMAG .or. KeyZEEM .or. KeyMVEC .or. KeyHINT .or. KeyHEXP .or. KeyNCUT .or. KeyENCU .or. KeyERAT

if (KeyTMAG .or. KeyZEEM .or. KeyMVEC .or. KeyHINT .or. KeyHEXP .or. KeyNCUT .or. KeyENCU .or. KeyERAT) then
  if (nTempMagn == 0) nTempMagn = 1
  if (nH == 0) nH = 21
end if
if (nT == 0) nT = 301

!write(u6,*) 'nTempMagn=',nTempMagn
!write(u6,*) 'nH       =',nH
!write(u6,*) 'nT       =',nT

return

end subroutine restart_check

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984, Per Ake Malmqvist                                *
!***********************************************************************

subroutine LU2(NDIMEN,NBLOCK,NSIZE,CXA,CYB,SCR)
! GIVES A SIMULTANEOUS LU-PARTITIONING OF MATRICES CXA,CYB IN THE
! SENSE THAT CXA*X = L1*U1 AND CYB*X = L2*U2, WHERE X IS A BLOCK
! UNITARY MATRIX. X IS NEVER FORMED, BUT AT EACH STEP SUCH A
! TRANSFORMATION IS APPLIED THAT THE LU PARTITIONING CAN BE
! APPLIED IN AN OPTIMAL WAY -- THIS IS REFERRED TO AS A
! UNITARY PSEUDO-PIVOTATION. MATRICES CXA AND CYB ARE DESTROYED,
! AND WILL CONTAIN THE NONTRIVIAL ELEMENTS OF THE TRIANGULAR
! MATRICES.
!                                        ( MALMQUIST 84-01-16 )

use Constants, only: One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NDIMEN, NBLOCK, NSIZE(NBLOCK)
real(kind=wp), intent(inout) :: CXA(NDIMEN,NDIMEN), CYB(NDIMEN,NDIMEN), SCR(NDIMEN)
integer(kind=iwp) :: I, IBLOCK, IEND, II, ISTA, NTOT
real(kind=wp) :: S, S1, S2, S3, X, X1, X2
real(kind=wp), parameter :: THR = 1.0e-6_wp

NTOT = sum(NSIZE(:))
if (NTOT /= NDIMEN) write(u6,*) ' ERROR: NTOT /= NDIMEN IN LU2.'
IEND = 0
do IBLOCK=1,NBLOCK
  ISTA = IEND+1
  IEND = IEND+NSIZE(IBLOCK)
  do II=ISTA,IEND
    S1 = sum(CXA(II,II:IEND)**2)
    S2 = sum(CYB(II,II:IEND)**2)
    S3 = sum(CXA(II,II:IEND)*CYB(II,II:IEND))
    if ((S1 < THR) .or. (S2 < THR)) then
      write(u6,*) ' RASSI CANNOT CONTINUE. THE PROBLEM AT HAND'
      write(u6,*) ' IS PROBABLY NOT SOLUBLE. THE TWO ORBITAL'
      write(u6,*) ' SPACES ARE TOO DISSIMILAR.'
      write(u6,*) ' LU PARTITIONING IS TROUBLESOME. DIAGONAL'
      write(u6,*) ' ELEMENT NR.',II,' IS TOO SMALL:'
      write(u6,*) ' IN MATRIX CXA IT IS',sqrt(S1)
      write(u6,*) ' IN MATRIX CYB IT IS',sqrt(S2)
      write(u6,*) ' EVEN AFTER OPTIMAL PIVOT-TRANSFORMATION.'
      call ABEND()
    end if
    X1 = One/sqrt(S1)
    X2 = One/sign(sqrt(S2),S3)
    SCR(II:IEND) = X1*CXA(II,II:IEND)+X2*CYB(II,II:IEND)
    S = Two*(One+X1*X2*S3)
    X = One/sign(sqrt(S),SCR(II))
    SCR(II:IEND) = X*SCR(II:IEND)
    X = One/(One+SCR(II))
    do I=1,IEND
      S2 = sum(CXA(I,II+1:IEND)*SCR(II+1:IEND))
      S = S2+CXA(I,II)*SCR(II)
      S2 = CXA(I,II)+X*S2
      CXA(I,II) = S
      CXA(I,II+1:IEND) = CXA(I,II+1:IEND)-S2*SCR(II+1:IEND)
    end do
    do I=1,IEND
      S2 = sum(CYB(I,II+1:IEND)*SCR(II+1:IEND))
      S = S2+CYB(I,II)*SCR(II)
      S2 = CYB(I,II)+X*S2
      CYB(I,II) = S
      CYB(I,II+1:IEND) = CYB(I,II+1:IEND)-S2*SCR(II+1:IEND)
    end do
    X = One/CXA(II,II)
    do I=II+1,IEND
      CXA(I,II) = X*CXA(I,II)
      CXA(I,II+1:NTOT) = CXA(I,II+1:NTOT)-CXA(I,II)*CXA(II,II+1:NTOT)
    end do
    X = One/CYB(II,II)
    do I=II+1,IEND
      CYB(I,II) = X*CYB(I,II)
      CYB(I,II+1:NTOT) = CYB(I,II+1:NTOT)-CYB(I,II)*CYB(II,II+1:NTOT)
    end do
  end do
end do

end subroutine LU2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_Stat_ParentDiag()
C
C     Thomas Bondo Pedersen, February 2006.
C
C     Purpose: print statistics about the diagonals from which the
C              Cholesky vectors are computed. I.e., whether they are
C              one-center or two-center diagonals. Does not work with
C              symmetry!
C
      use ChoSwp, only: InfVec
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "stdalloc.fh"

      Character(LEN=19), Parameter:: SecNam = 'Cho_Stat_ParentDiag'

      Character(LEN=LENIN8) AtomLabel(MxBas)

      Logical Debug

      Integer, External:: Cho_iSumElm

      Integer, Parameter:: numAt = 6
      Real*8  Ratio(numAt)
      Real*8  RClass(3)
      Integer iClass(4)
      Integer nPseudo

      Integer, Allocatable:: nBas_per_Atom(:)
      Integer, Allocatable:: nBas_Start(:)
      Integer, Allocatable:: iBF2Atom(:)
      Real*8,  Allocatable:: Coord(:,:)
      Integer, Allocatable:: mapRS2F(:,:)
      Integer, Allocatable:: nPC1(:)
      Real*8,  Allocatable:: RC2(:)

C     Set debug flag.
C     ---------------

#if defined (_DEBUGPRINT_)
      Debug = .True.
#else
      Debug = .False.
#endif

C     Symmetry not allowed.
C     ---------------------

      If (nSym .ne. 1) Return

C     Check if anything to do.
C     ------------------------

      If (NumCho(1) .ne. NumChT) Then
         Call SysAbendMsg(SecNam,'NumChT .ne. NumCho(1)',' ')
      End If
      If (NumChT .lt. 1) Return

C     Get number of atoms.
C     --------------------

C     Call Get_nAtoms_All(nAtom)
      Call Get_iScalar('Bfn Atoms',nAtom)
      Call Get_iScalar('Pseudo atoms',nPseudo)

C     Get atomic labels and basis function labels.
C     --------------------------------------------

      Call Get_cArray('Unique Basis Names',AtomLabel,LENIN8*nBasT)

C     Allocate and get index arrays for indexation of basis functions on
C     each atom.
C     ------------------------------------------------------------------

      Call mma_allocate(nBas_per_Atom,nAtom,Label='nBas_per_Atom')
      Call mma_allocate(nBas_Start,nAtom,Label='nBas_Start')
      Call BasFun_Atom(nBas_per_Atom,nBas_Start,
     &                 AtomLabel,nBasT,nAtom,Debug)

C     Allocate and get nuclear coordinates.
C     -------------------------------------

      Call mma_allocate(Coord,3,nAtom,Label='Coord')
C     Call Get_dArray('Unique Coordinates',Coord,3*nAtom)
      Call Get_dArray('Bfn Coordinates',Coord,3*nAtom)

C     Allocate and set mapping from basis function to atom.
C     -----------------------------------------------------

      Call mma_Allocate(iBF2Atom,nBasT,Label='iBF2Atom')
      Do iAtom = 1,nAtom
         i1 = nBas_Start(iAtom)
         i2 = i1 + nBas_per_Atom(iAtom) - 1
         Do i = i1,i2
            iBF2Atom(i) = iAtom
         End Do
      End Do

      If (Debug) Then
         Write(Lupri,*)
         Write(Lupri,*) SecNam,': mapping from basis function to atom:'
         Do i = 1,nBasT
            Write(Lupri,*) 'Basis function ',i,' is centered on atom ',
     &                     iBF2Atom(i),' labeled ',AtomLabel(i)(1:LENIN)
         End Do
      End If

C     Allocate and set mapping from 1st reduced set to full storage.
C     --------------------------------------------------------------

      Call mma_allocate(mapRS2F,2,nnBstRT(1),Label='mapRS2F')
      Call Cho_RStoF(mapRS2F,2,nnBstRT(1),1)

C     Allocate counters.
C     ------------------

      Call mma_allocate(nPC1,nAtom,Label='nPC1')
      Call mma_allocate(RC2,NumChT,Label='RC2')

C     Compute statistics.
C     -------------------

      Rmin = 1.0d15
      Rmax = -1.0d15
      Rave = 0.0d0
      nPC1(:)=0
      RC2(:)=0.0D0
      Do iVec = 1,NumChT
         iRS1 = InfVec(iVec,1,1)
         iA = mapRS2F(1,iRS1)
         iB = mapRS2F(2,IRS1)
         iAtA = iBF2Atom(iA)
         iAtB = iBF2Atom(iB)
         If (iAtA .eq. iAtB) Then
            nPC1(iAtA) = nPC1(iAtA) + 1
         Else
            R = sqrt((Coord(1,iAtA)-Coord(1,iAtB))**2
     &              +(Coord(2,iAtA)-Coord(2,iAtB))**2
     &              +(Coord(3,iAtA)-Coord(3,iAtB))**2)
            RC2(iVec) = R
            Rmin = min(Rmin,R)
            Rmax = max(Rmax,R)
            Rave = Rave + R
         End If
      End Do
      nTot1 = Cho_iSumElm(nPC1,nAtom)
      nTot2 = NumChT - nTot1
      If (nTot2 .gt. 0) Then
         Rave = Rave/dble(nTot2)
      Else If (nTot2 .lt. 0) Then
         Call SysAbendMsg(SecNam,'Setup error!','nTot2 < 0')
      End If

C     Print overall statisctics.
C     --------------------------

      Write(Lupri,'(//,2X,A,/,2X,A)')
     & 'Parent Diagonals','----------------'
      Write(Lupri,'(/,A,I9,A,F7.2,A)')
     & 'Number of vectors from 1-center diagonals:',nTot1,
     & ' (',1.0d2*dble(nTot1)/dble(NumChT),'%)'
      Write(Lupri,'(A,I9,A,F7.2,A)')
     & 'Number of vectors from 2-center diagonals:',nTot2,
     & ' (',1.0d2*dble(nTot2)/dble(NumChT),'%)'

C     Print statistics for 1-center vectors.
C     --------------------------------------

      Write(Lupri,'(/,1X,A)')
     & 'Vectors from 1-center diagonals:'
      nBatch = (nAtom-nPseudo-1)/numAt + 1 ! exclude pseudo-atoms
      Do iBatch = 1,nBatch
         If (iBatch .eq. nBatch) Then
!           exclude pseudo-atoms
            nAt = nAtom - nPseudo - numAt*(nBatch-1)
         Else
            nAt = numAt
         End If
         iAt0 = numAt*(iBatch-1)
         iAt1 = iAt0 + 1
         iAt2 = iAt0 + nAt
         Do i = 1,nAt
            iAt = iAt0 + i
            If (nBas_per_Atom(iAt) .lt. 1) Then
               If (nPC1(iAt) .gt. 0) Then
                  Call SysAbendMsg(SecNam,
     &                 'No basis functions, but >0 vectors !?!?',' ')
               End If
               Ratio(i) = 0.0d0
            Else
               Ratio(i) = dble(nPC1(iAt))/dble(nBas_per_Atom(iAt))
            End If
         End Do
         Write(Lupri,'(/,A,6(6X,A))')
     &   'Label              ',
     &    (AtomLabel(nBas_Start(i))(1:LENIN),i=iAt1,iAt2)
         Write(Lupri,'(A,6(1X,I9))')
     &   'Center no.         ',(i,i=iAt1,iAt2)
         Write(Lupri,'(A,6(1X,I9))')
     &   'Vectors (M)        ',(nPC1(i),i=iAt1,iAt2)
         Write(Lupri,'(A,6(1X,I9))')
     &   'Basis functions (N)',(nBas_per_Atom(i),i=iAt1,iAt2)
         Write(Lupri,'(A,6(1X,F9.2))')
     &   'Ratio (M/N)        ',(Ratio(i),i=1,nAt)
         If (iBatch .ne. nBatch) Write(Lupri,*)
      End Do

C     Print statistics for 2-center vectors.
C     --------------------------------------

      If (nTot2 .gt. 0) Then
         Write(Lupri,'(/,1X,A)')
     &   'Vectors from 2-center diagonals:'
         RClass(1) = Rave - (Rave-Rmin)/2.0d0
         RClass(2) = Rave
         RClass(3) = Rave + (Rmax-Rave)/2.0d0
         Call iCopy(4,[0],0,iClass,1)
         nChk = 0
         Do iVec = 1,NumChT
            If (RC2(iVec) .gt. 0.0d0) Then
               nChk = nChk + 1
               If (RC2(iVec) .le. RClass(1)) Then
                  iClass(1) = iClass(1) + 1
               Else If (RC2(iVec) .le. RClass(2)) Then
                  iClass(2) = iClass(2) + 1
               Else If (RC2(iVec) .le. RClass(3)) Then
                  iClass(3) = iClass(3) + 1
               Else
                  iClass(4) = iClass(4) + 1
               End If
            End If
         End Do
         If (nChk .ne. nTot2) Then
C FAQ
C --- Replace the call to SysAbendMsg with just a warning.
C
C            Call SysAbendMsg(SecNam,'nChk .ne. nTot2',' ')
C
C --- TODO/FIX  figure out if with ghost atoms is just a mistmatch
C               or there is really a bug
C
            write(6,*) SecNam//': Warning! (nChk .ne. nTot2); could be',
     &' due to the presence of ghost atoms.'
         End If
         Write(Lupri,'(/,A,1P,3D15.5)')
     &   'Min, average, and max center distance: ',Rmin,Rave,Rmax
         Write(Lupri,'(A,D12.2,A,I9)')
     &   '#vectors with center distance                R <= ',
     &   RClass(1),': ',iClass(1)
         Write(Lupri,'(A,D12.2,A,D12.2,A,I9)')
     &   '#vectors with center distance ',RClass(1),' < R <= ',
     &   RClass(2),': ',iClass(2)
         Write(Lupri,'(A,D12.2,A,D12.2,A,I9)')
     &   '#vectors with center distance ',RClass(2),' < R <= ',
     &   RClass(3),': ',iClass(3)
         Write(Lupri,'(A,D12.2,A,12X,A,I9)')
     &   '#vectors with center distance ',RClass(3),' < R    ',
     &   ': ',iClass(4)
      End If

C     Deallocations.
C     --------------

      Call mma_deallocate(RC2)
      Call mma_deallocate(nPC1)
      Call mma_deallocate(mapRS2F)
      Call mma_deallocate(iBF2Atom)
      Call mma_deallocate(Coord)
      Call mma_deallocate(nBas_Start)
      Call mma_deallocate(nBas_per_Atom)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GSBBD2B_LUCIA(   RHO2,  RHO2S,  RHO2A,   IASM,   IATP,
     &                            IBSM,   IBTP,    NIA,    NIB,   JASM,
     &                            JATP,   JBSM,   JBTP,    NJA,    NJB,
     &                           IAGRP,  IBGRP,   NGAS,   IAOC,   IBOC,
     &                            JAOC,   JBOC,     SB,     CB,  ADSXA,
*
     &                          STSTSX,MXPNGAS, NOBPTS, IOBPTS,   MAXK,
     &                              I1,   XI1S,     I2,   XI2S,     I3,
     &                            XI3S,     I4,   XI4S,      X,  NSMOB,
     &                           NSMST,  NSMSX,  NSMDX, MXPOBS, IUSEAB,
     &                           CJRES,  SIRES,   NORB, NTESTG, SCLFAC,
*
     &                         S2_TERM1, IPACK)
*
* SUBROUTINE GSBBD2B_LUCIA --> 52
*
*
* alpha-beta contribution to two-particle density matrix
* from given c-block and s-block.
*
* S2_TERM1 = - <L!a+i alpha a+jbeta a i beta a j alpha !R>
* =====
* Input
* =====
*
* IASM,IATP : Symmetry and type of alpha  strings in sigma
* IBSM,IBTP : Symmetry and type of beta   strings in sigma
* JASM,JATP : Symmetry and type of alpha  strings in C
* JBSM,JBTP : Symmetry and type of beta   strings in C
* NIA,NIB : Number of alpha-(beta-) strings in sigma
* NJA,NJB : Number of alpha-(beta-) strings in C
* IAGRP : String group of alpha strings
* IBGRP : String group of beta strings
* IAEL1(3) : Number of electrons in RAS1(3) for alpha strings in sigma
* IBEL1(3) : Number of electrons in RAS1(3) for beta  strings in sigma
* JAEL1(3) : Number of electrons in RAS1(3) for alpha strings in C
* JBEL1(3) : Number of electrons in RAS1(3) for beta  strings in C
* CB   : Input C block
* ADSXA : sym of a+, a+a => sym of a
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
* NTSOB  : Number of orbitals per type and symmetry
* IBTSOB : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* NSMOB,NSMST,NSMSX : Number of symmetries of orbitals,strings,
*       single excitations
* MAXK   : Largest number of inner resolution strings treated at simult.
* IPACK  : Should we pack the density?
*
*
* ======
* Output
* ======
* SB : updated sigma block
*
* =======
* Scratch
* =======
*
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* I2, XI2S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* X : Space for block of two-electron integrals
*
* Jeppe Olsen, Fall of 1996
*
*
*
      USE Para_Info, ONLY: MyRank, nProcs
      IMPLICIT REAL*8(A-H,O-Z)
#include "WrkSpc.fh"
#include "loff.fh"
*. General input
      INTEGER ADSXA(MXPOBS,MXPOBS),STSTSX(NSMST,NSMST)
      INTEGER NOBPTS(MXPNGAS,*),IOBPTS(MXPNGAS,*)
*.Input
      DIMENSION CB(*),SB(*)
      LOGICAL IPACK
*. Output
      DIMENSION RHO2(*),RHO2S(*),RHO2A(*)
*.Scratch
      DIMENSION I1(*),XI1S(*),I2(*),XI2S(*)
      DIMENSION I3(*),XI3S(*),I4(*),XI4S(*)
      DIMENSION X(*)
      DIMENSION CJRES(*),SIRES(*)
*.Local arrays
      DIMENSION ITP(20),JTP(20),KTP(20),LTP(20)

      DIMENSION IAOC(*),JAOC(*),IBOC(*),JBOC(*)
*

      NTESTL = 000
      NTEST = MAX(NTESTL,NTESTG)
      IF(NTEST.GE.500) THEN
        WRITE(6,*) ' ================== '
        WRITE(6,*) ' GSBBD2B speaking '
        WRITE(6,*) ' ================== '
      END IF
      !WRITE(6,*) ' NJAS NJB = ',NJA,NJB
      !WRITE(6,*) ' IAGRP IBGRP = ', IAGRP,IBGRP
      !WRITE(6,*) ' MXPNGAS = ', MXPNGAS
      !WRITE(6,*) ' NSMOB = ', NSMOB

*
*. Symmetry of allowed excitations
      IJSM = STSTSX(IASM,JASM)
      KLSM = STSTSX(IBSM,JBSM)
      IF(IJSM.EQ.0.OR.KLSM.EQ.0) GOTO 9999
      IF(NTEST.GE.600) THEN
        write(6,*) ' IASM JASM IJSM ',IASM,JASM,IJSM
        write(6,*) ' IBSM JBSM KLSM ',IBSM,JBSM,KLSM
      END IF
*.Types of SX that connects the two strings
      CALL SXTYP_GAS(   NKLTYP,      KTP,      LTP,     NGAS,     IBOC,
     &                    JBOC)
      CALL SXTYP_GAS(   NIJTYP,      ITP,      JTP,     NGAS,     IAOC,
     &                    JAOC)
      IF(NIJTYP.EQ.0.OR.NKLTYP.EQ.0) GOTO 9999
* Repeated allocation/deallocation inside ADSTN_GAS has been
* outerlooped to here. KLOFFI added to call parameters of
* ADSTN_GAS. PAM March 2006.
      CALL GETMEM('KLOFFI','ALLO','REAL',KLOFFI,LOFFI)
      Call FZero(Work(KLOFFI),LOFFI)

      DO 2001 IJTYP = 1, NIJTYP
        ITYP = ITP(IJTYP)
        JTYP = JTP(IJTYP)
        DO 1940 ISM = 1, NSMOB
          JSM = ADSXA(ISM,IJSM)
          IF(JSM.EQ.0) GOTO 1940
          ntest=00 !yjma
          if(ntest.ge.1500) write(6,*) ' ISM JSM ', ISM,JSM
          IOFF = IOBPTS(ITYP,ISM)
          JOFF = IOBPTS(JTYP,JSM)
          NI = NOBPTS(ITYP,ISM)
          NJ = NOBPTS(JTYP,JSM)
          IF(NI.EQ.0.OR.NJ.EQ.0) GOTO 1940
*. Generate annihilation mappings for all Ka strings
*. a+j!ka> = +/-/0 * !Ja>
          CALL ADSTN_GAS(  KLOFFI,     JSM,    JTYP,    JATP,    JASM,
     &                      IAGRP,      I1,    XI1S,  NKASTR,    IEND,
     &                      IFRST,   KFRST,    KACT,  SCLFAC)
          IF (NKASTR.EQ.0) GOTO 1940
*. a+i!ka> = +/-/0 * !Ia>
          ONE    = 1.0D0
          CALL ADSTN_GAS(  KLOFFI,     ISM,    ITYP,    IATP,    IASM,
     &                      IAGRP,      I3,    XI3S,  NKASTR,    IEND,
     &                      IFRST,   KFRST,    KACT,  ONE   )
          IF (NKASTR.EQ.0) GOTO 1940
*. Compress list to common nonvanishing elements
          IDOCOMP = 1
          IF(IDOCOMP.EQ.1) THEN
C             COMPRS2LST(I1,XI1,N1,I2,XI2,N2,NKIN,NKOUT)
              CALL COMPRS2LST(     I1,   XI1S,     NJ,     I3,   XI3S,
     &                             NI, NKASTR, NKAEFF)
          ELSE
              NKAEFF = NKASTR
          END IF

*. Loop over batches of KA strings
          NKABTC=0
          DO
            NKABTC=NKABTC+NPROCS
            NKABTCSZ=MAX(NKAEFF-1,0)/NKABTC+1
            IF (NKABTCSZ.LE.MAXK) EXIT
          END DO
*
          DO 1801 IKABTC = 1+MYRANK, NKABTC, NPROCS
            KABOT = (IKABTC-1)*NKABTCSZ + 1
            KATOP = MIN(KABOT+NKABTCSZ-1,NKAEFF)
            LKABTC = KATOP-KABOT+1
            IF (LKABTC.LE.0) EXIT
*. Obtain C(ka,J,JB) for Ka in batch
            DO JJ = 1, NJ
              CALL GET_CKAJJB(     CB,     NJ,    NJA,  CJRES, LKABTC,
     &                            NJB,
     &                             JJ,
     &                        I1(KABOT+(JJ-1)*NKASTR),
     &                        XI1S(KABOT+(JJ-1)*NKASTR))
*
            END DO
*. Obtain S(ka,i,Ib) for Ka in batch
            DO II = 1, NI
              CALL GET_CKAJJB(     SB,     NI,    NIA,  SIRES, LKABTC,
     &                            NIB,
     &                             II,
     &                        I3(KABOT+(II-1)*NKASTR),
     &                        XI3S(KABOT+(II-1)*NKASTR))
*
            END DO
*
            DO 2000 KLTYP = 1, NKLTYP
              KTYP = KTP(KLTYP)
              LTYP = LTP(KLTYP)
*
              DO 1930 KSM = 1, NSMOB
                LSM = ADSXA(KSM,KLSM)
                IF(LSM.EQ.0) GOTO 1930
                KOFF = IOBPTS(KTYP,KSM)
                LOFF = IOBPTS(LTYP,LSM)
                NK = NOBPTS(KTYP,KSM)
                NL = NOBPTS(LTYP,LSM)
*. If IUSEAB is used, only terms with i.ge.k will be generated so
                IKORD = 0
                IF(IUSEAB.EQ.1.AND.ISM.GT.KSM) GOTO 1930
                IF(IUSEAB.EQ.1.AND.ISM.EQ.KSM.AND.ITYP.LT.KTYP)
     &          GOTO 1930
                IF(IUSEAB.EQ.1.AND.ISM.EQ.KSM.AND.ITYP.EQ.KTYP) IKORD=1
*
                IF(NK.EQ.0.OR.NL.EQ.0) GOTO 1930
*. Obtain all connections a+l!Kb> = +/-/0!Jb>
                ONE = 1.0D0
                CALL ADSTN_GAS( KLOFFI,    LSM,   LTYP,   JBTP,   JBSM,
     &                           IBGRP,     I2,   XI2S, NKBSTR,   IEND,
     &                           IFRST,  KFRST,   KACT, ONE   )
                IF(NKBSTR.EQ.0) GOTO 1930
*. Obtain all connections a+k!Kb> = +/-/0!Ib>
                CALL ADSTN_GAS( KLOFFI,    KSM,   KTYP,   IBTP,   IBSM,
     &                           IBGRP,     I4,   XI4S, NKBSTR,   IEND,
     &                           IFRST,  KFRST,   KACT,    ONE)
                IF(NKBSTR.EQ.0) GOTO 1930
*
*. Update two-electron density matrix
*  Rho2b(ij,kl) =  Sum(ka)S(Ka,i,Ib)<Ib!Eb(kl)!Jb>C(Ka,j,Jb)
*
                ZERO = 0.0D0
                CALL SETVEC(X,ZERO,NI*NJ*NK*NL)
*
                CALL ABTOR2(  SIRES,  CJRES, LKABTC,    NIB,    NJB,
     &                       NKBSTR,      X,     NI,     NJ,     NK,
     &                           NL, NKBSTR,     I4,   XI4S,     I2,
     &                         XI2S,  IKORD)
*. contributions to Rho2(ij,kl) has been obtained, scatter out
              !call wrtmat(x,ni*nj,nk*nl,ni*nj,nk*nl)
*. Contribution to S2
                IF(KTYP.EQ.JTYP.AND.KSM.EQ.JSM.AND.
     &            ITYP.EQ.LTYP.AND.ISM.EQ.LSM) THEN
                  DO I = 1, NI
                    DO J = 1, NJ
                      IJ = (J-1)*NI+I
                      JI = (I-1)*NJ+J
                      NIJ = NI*NJ
                      S2_TERM1 = S2_TERM1-X((JI-1)*NIJ+IJ)
                    END DO
                  END DO
                END IF

                CALL ADTOR2(   RHO2,  RHO2S,  RHO2A,      X,      2,
     &                           NI,   IOFF,     NJ,   JOFF,     NK,
     &                         KOFF,     NL,   LOFF,   NORB,  IPACK)

!              write(6,*) ' updated density matrix B ',"norb = ",norb
!         write(6,*) ' offset ',"IOFF,JOFF,KOFF,LOFF",IOFF,JOFF,KOFF,LOFF
!              call prsym(rho2s,NORB*(NORB+1)/2)

 1930         CONTINUE
 2000       CONTINUE
 1801     CONTINUE
*. End of loop over partitioning of alpha strings
 1940   CONTINUE
 2001 CONTINUE
* This 'flush' outerlooped here. Was previously inside ADSTN_GAS.
      CALL GETMEM('KLOFFI','FREE','REAL',KLOFFI,LOFFI)
*
 9999 CONTINUE
*
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NSMSX)
        CALL Unused_integer(NSMDX)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016, Roland Lindh                                     *
************************************************************************
*     This module contains the most-important globally-allocated arrays*
*     in the SCF program.                                              *
*                                                                      *
************************************************************************
      Module SCF_Arrays
#ifdef _FDE_
      Real*8, Dimension(:), Allocatable:: Emb
#endif
      Real*8, Dimension(:), Allocatable:: Ovrlp, OneHam, EDFT, KntE,
     &                                    Darwin, MssVlc
      Real*8, Dimension(:,:,:), Allocatable:: TwoHam, Vxc, Dens
      Real*8, Dimension(:,:), Allocatable:: CMO, TrM, Fock, Lowdin,
     &                                      OccNo, EOrb, HDiag
      Real*8, Dimension(:,:), Allocatable:: TrDh, TrDP, TrDD, CInter
      End Module SCF_Arrays

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine symtrizorbs_cvb(orbs)

use casvb_global, only: corth, formAD, ifxorb, iorts, ipr, irels, nijrel, norb, nort, north, relorb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: orbs(norb,norb)
integer(kind=iwp) :: icon, ierr, ioffs, iok, iorb, iorbmax, iort, iortorb, irel, j, jorb, jorbmax, jortorb, niprev, njprev, nortorb
real(kind=wp) :: a, b, c, c1, c2, cnrmi, cnrmj, cpm, cpp, d, discrpm, discrpp, dum(1), faci, facj, s, s1, s2, s3, smax, sovr
integer(kind=iwp), allocatable :: ihlp(:), ihlp2(:), ihlp3(:), iprev(:), jprev(:)
real(kind=wp), allocatable :: updi(:), updj(:)
real(kind=wp), parameter :: hund = 100.0_wp, thresh = 1.0e-10_wp
real(kind=wp), external :: ddot_

ioffs = 1
do iorb=1,norb
  if (north(iorb) /= 0) call schmidtd_cvb(corth(:,ioffs),north(iorb),orbs(:,iorb),1,dum,norb,0)
  ioffs = ioffs+north(iorb)
end do

call mma_allocate(ihlp,norb,label='ihlp')

! Now enforce orthogonality between specified orbitals:
! -----------------------------------------------------
ihlp(:) = -1
do iort=1,nort
  do j=1,2
    iorb = iorts(j,iort)
    ihlp(iorb) = min(north(iorb),norb)
  end do
end do
! Check feasibility
do irel=1,nijrel
  if (ihlp(irels(1,irel)) /= -1) then
    write(u6,'(a,i3)') ' WARNING - cannot perform orthogonalizations involving orbital ',irels(1,irel)
    write(u6,'(a,i3)') ' because this orbital is generated by symmetry operations from orbital ',irels(2,irel)
    write(u6,'(a)') ' Please simplify orthogonality constraints.'
    call abend_cvb()
  end if
end do
! Set up order of orthogonalization - first help arrays:
call mma_allocate(ihlp2,norb,label='ihlp2')
call mma_allocate(ihlp3,norb,label='ihlp3')
ihlp2(:) = 0
ihlp3(:) = 0
nortorb = 0
do icon=norb,0,-1
  do iorb=1,norb
    if (ihlp(iorb) == icon) then
      nortorb = nortorb+1
      ihlp2(nortorb) = iorb
      ihlp3(iorb) = nortorb
    end if
  end do
end do

call mma_deallocate(ihlp)
call mma_allocate(iprev,norb,label='iprev')
call mma_allocate(jprev,norb,label='jprev')
call mma_allocate(updi,norb,label='updi')
call mma_allocate(updj,norb,label='updj')

! Loop all pairs that may be orthogonalized
do iortorb=1,nortorb
  iorb = ihlp2(iortorb)
  ! Create list of previous orthonormalisations involving IORB
  niprev = 0
  do iort=1,nort
    if (iorts(1,iort) == iorb) then
      if (ihlp3(iorts(2,iort)) < iortorb) then
        niprev = niprev+1
        iprev(niprev) = iorts(2,iort)
      end if
    else if (iorts(2,iort) == iorb) then
      if (ihlp3(iorts(1,iort)) < iortorb) then
        niprev = niprev+1
        iprev(niprev) = iorts(1,iort)
      end if
    end if
  end do
  do jortorb=iortorb+1,nortorb
    jorb = ihlp2(jortorb)
    ! Create list of previous orthonormalisations involving JORB
    iok = 0
    njprev = 0
    do iort=1,nort
      if (iorts(1,iort) == jorb) then
        if (ihlp3(iorts(2,iort)) < iortorb) then
          njprev = njprev+1
          jprev(njprev) = iorts(2,iort)
        else if (ihlp3(iorts(2,iort)) == iortorb) then
          iok = 1
        end if
      else if (iorts(2,iort) == jorb) then
        if (ihlp3(iorts(1,iort)) < iortorb) then
          njprev = njprev+1
          jprev(njprev) = iorts(1,iort)
        else if (ihlp3(iorts(1,iort)) == iortorb) then
          iok = 1
        end if
      end if
    end do
    if (iok == 0) cycle
    sovr = ddot_(norb,orbs(:,iorb),1,orbs(:,jorb),1)
    if (abs(sovr) >= thresh) then
      ! Now ready to orthogonalise
      ! Update vectors
      call updvec_cvb(updi,iorb,jorb,niprev,iprev,orbs,north,corth)
      cnrmi = ddot_(norb,updi,1,updi,1)
      if (ifxorb(iorb) == 1) cnrmi = Zero
      call updvec_cvb(updj,jorb,iorb,njprev,jprev,orbs,north,corth)
      cnrmj = ddot_(norb,updj,1,updj,1)
      if (ifxorb(jorb) == 1) cnrmj = Zero

      if ((cnrmi > thresh) .and. (cnrmj > thresh)) then
        faci = One/sqrt(cnrmi)
        updi(:) = faci*updi(:)
        facj = One/sqrt(cnrmj)
        updj(:) = facj*updj(:)
        s1 = ddot_(norb,updi,1,orbs(:,jorb),1)
        s2 = ddot_(norb,updj,1,orbs(:,iorb),1)
        s3 = ddot_(norb,updi,1,updj,1)
        ! Initialize cpp & cpm to suppress compiler warning ...
        cpp = Zero
        cpm = Zero
        ! Same magnitudes of updates, either ++ or +-:
        if (abs(s3) > thresh) then
          a = s3
          b = s1+s2
          c = sovr
          discrpp = b*b-four*a*c
          if (discrpp >= Zero) then
            c1 = (-b+sqrt(discrpp))/(Two*a)
            c2 = (-b-sqrt(discrpp))/(Two*a)
            if (abs(c1) < abs(c2)) cpp = c1
            if (abs(c2) <= abs(c1)) cpp = c2
          else
            cpp = hund
          end if
          a = -s3
          b = s1-s2
          discrpm = b*b-four*a*c
          if (discrpm >= Zero) then
            c1 = (-b+sqrt(discrpm))/(Two*a)
            c2 = (-b-sqrt(discrpm))/(Two*a)
            if (abs(c1) < abs(c2)) cpm = c1
            if (abs(c2) <= abs(c1)) cpm = c2
          else
            cpm = hund
          end if
        else
          if (abs(s1+s2) > thresh) then
            cpp = sovr/(s1+s2)
          else
            cpp = hund
          end if
          if (abs(s1-s2) > thresh) then
            cpm = sovr/(s1+s2)
          else
            cpm = hund
          end if
        end if
        if (abs(cpp) < abs(cpm)) then
          c = cpp
        else
          c = cpm
        end if
        if ((c == hund) .or. (abs(s2+c*s3) < thresh)) then
          write(u6,'(a,2i3)') ' Could not orthogonalize orbitals',iorb,jorb
          write(u6,'(a)') ' Please simplify orthogonality constraints.'
          call abend_cvb()
        end if
        d = -(sovr+c*s1)/(s2+c*s3)
        updi(:) = c*updi(:)
        orbs(:,iorb) = orbs(:,iorb)+updi(:)
        updj(:) = d*updj(:)
        orbs(:,jorb) = orbs(:,jorb)+updj(:)
      else if (cnrmi > thresh) then
        faci = One/sqrt(cnrmi)
        updi(:) = faci*updi(:)
        s1 = ddot_(norb,updi,1,orbs(:,jorb),1)
        c = -sovr/s1
        updi(:) = c*updi(:)
        orbs(:,iorb) = orbs(:,iorb)+updi(:)
      else if (cnrmj > thresh) then
        facj = One/sqrt(cnrmj)
        updj(:) = facj*updj(:)
        s2 = ddot_(norb,updj,1,orbs(:,iorb),1)
        d = -sovr/s2
        updj(:) = d*updj(:)
        orbs(:,jorb) = orbs(:,jorb)+updj(:)
      else
        write(u6,'(a,2i3)') ' Could not orthogonalize orbitals',iorb,jorb
        write(u6,'(a)') ' Please simplify orthogonality constraints.'
        call abend_cvb()
      end if
    end if
    niprev = niprev+1
    iprev(niprev) = jorb
  end do
end do

call mma_deallocate(ihlp2)
call mma_deallocate(ihlp3)
call mma_deallocate(iprev)
call mma_deallocate(jprev)
call mma_deallocate(updi)
call mma_deallocate(updj)

ierr = 0
call nize_cvb(orbs,norb,dum,norb,0,ierr)
smax = -One
do iort=1,nort
  iorb = iorts(1,iort)
  jorb = iorts(2,iort)
  s = abs(ddot_(norb,orbs(:,iorb),1,orbs(:,jorb),1))
  if (s > smax) then
    smax = s
    iorbmax = iorb
    jorbmax = jorb
  end if
end do
if ((ipr(3) >= 2) .and. (smax > 1.0e-10_wp)) then
  write(u6,'(a,2i3)') ' Maximum overlap for orthogonalized orbitals :',iorbmax,jorbmax
  write(u6,formAD) ' Value : ',ddot_(norb,orbs(:,iorbmax),1,orbs(:,jorbmax),1)
end if

do irel=1,nijrel
  iorb = irels(1,irel)
  jorb = irels(2,irel)
  call mxatb_cvb(relorb(:,:,irel),orbs(:,jorb),norb,norb,1,orbs(:,iorb))
end do

return

end subroutine symtrizorbs_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Jesper Norell                                    *
!               2018, Joel Creutzberg                                  *
!               2023, Ignacio Fdez. Galvan                             *
!***********************************************************************

! Subroutine to correctly bunch together spin-free Dyson orbitals
! and pass them to the molden_dysorb interface for .molden export

! IFG: Added DysOrb export, not sure it's correct

subroutine WRITEDYS(DYSAMPS,SFDYS,NZ,ENERGY)

use Cntrl, only: DYSEXPSF, NSTATE
use Symmetry_Info, only: nIrrep
use rassi_data, only: NBASF
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NZ
real(kind=wp), intent(in) :: DYSAMPS(NSTATE,NSTATE), SFDYS(NZ,NSTATE,NSTATE), ENERGY(NSTATE)
integer(kind=iwp) :: DYSCIND, ISTATE, JSTATE, LUNIT, ORBNUM
character(len=80) :: TITLE
character(len=30) :: Filename
real(kind=wp), allocatable :: AMPS(:), CMO(:), DYSEN(:)
integer(kind=iwp), external :: IsFreeUnit

!+++  J. Creutzberg, J. Norell  - 2018 (.molden export )

! In principle we should here take into account the diagonalization
! matrix from RASSCF. This will only rarely be needed for regular
! Dyson calculations so we will leave it out for now.

call mma_allocate(CMO,NZ*NSTATE,Label='CMO')
call mma_allocate(DYSEN,NSTATE,Label='DYSEN')
call mma_allocate(AMPS,NSTATE,Label='AMPS')

do JSTATE=1,DYSEXPSF

  ! For each initial state JSTATE up to DYSEXPSF we will gather all the obtained Dysorbs
  ! and export to a shared .molden file
  DYSCIND = 0 ! Orbital coeff. index
  ORBNUM = 0 ! Dysorb index for given JSTATE
  CMO(:) = Zero ! Orbital coefficients
  DYSEN(:) = Zero ! Orbital energies
  AMPS(:) = Zero ! Transition amplitudes (shown as occupations)

  do ISTATE=JSTATE+1,NSTATE

    if (DYSAMPS(JSTATE,ISTATE) > 1.0e-5_wp) then
      CMO(DYSCIND+1:DYSCIND+NZ) = SFDYS(:,ISTATE,JSTATE)
      DYSCIND = DYSCIND+NZ
      ORBNUM = ORBNUM+1
      DYSEN(ORBNUM) = ENERGY(ISTATE)-ENERGY(JSTATE)
      AMPS(ORBNUM) = DYSAMPS(JSTATE,ISTATE)*DYSAMPS(JSTATE,ISTATE)
    end if

  end do ! ISTATE

  ! If at least one orbital was found, export it/them
  if (ORBNUM > 0) then
    write(filename,'(A,I0)') 'MD_DYS.SF.',JSTATE
    call Molden_DysOrb(filename,DYSEN,AMPS,CMO,ORBNUM,NZ)

    write(filename,'(A,I0)') 'DYSORB.SF.',JSTATE
    LUNIT = IsFreeUnit(50)
    write(TITLE,'(A,I0)') '* Spin-free Dyson orbitals for state ',JSTATE
    call WRVEC_DYSON(filename,LUNIT,nIrrep,NBASF,ORBNUM,CMO,AMPS,DYSEN,trim(TITLE),NZ)
    close(LUNIT)
  end if

end do ! JSTATE

call mma_deallocate(CMO)
call mma_deallocate(DYSEN)
call mma_deallocate(AMPS)

end subroutine WRITEDYS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function ioemrg2_cvb(ia1,na1,ia2,na2,ia12)

use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp) :: ioemrg2_cvb
integer(kind=iwp), intent(in) :: na1, ia1(na1), na2, ia2(na2)
integer(kind=iwp), intent(_OUT_) :: ia12(*)
integer(kind=iwp) :: ioe, n1, n12, n2

n1 = 1
n2 = 1
ioe = 0
n12 = 1
do
  if (n1 > na1) then
    ioemrg2_cvb = 1-2*mod(ioe,2)
    ia12(n12:n12+na2-n2) = ia2(n2:na2)
    exit
  else if (n2 > na2) then
    ioe = ioe+(na1-n1+1)*na2
    ioemrg2_cvb = 1-2*mod(ioe,2)
    ia12(n12:n12+na1-n1) = ia1(n1:na1)
    exit
  end if
  if (ia1(n1) < ia2(n2)) then
    ioe = ioe+n2-1
    ia12(n12) = ia1(n1)
    n1 = n1+1
    n12 = n12+1
  else if (ia1(n1) > ia2(n2)) then
    ia12(n12) = ia2(n1)
    n2 = n2+1
    n12 = n12+1
  else if (ia1(n1) == ia2(n2)) then
    ioemrg2_cvb = 0
    exit
  end if
end do

return

end function ioemrg2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
* From: D.R. Yarkony, J. Phys. Chem. A 105 (2001) 6277-6293
* and: J. Chem. Theory Comput. 12 (2016) 3636-3653
************************************************************************
      Subroutine CI_Summary(Lu)
      use Slapaf_Info, only: Gx, Gx0, NAC, Energy
      use Slapaf_Parameters, only: CallLast, iter
      Implicit None
      Integer Lu, n, i
      Real*8, Dimension(:), Allocatable :: g, h, tmp
      Real*8 gg, hh, gh, sg, sh, dgh, deltagh, beta_ang, norm_g, norm_h,
     &       st, srel, shead, peaked, bif, aux
      Real*8, External :: dDot_
      Character(Len=2) LabA
      Character(Len=40) Description
#include "stdalloc.fh"
#include "real.fh"
*
      n=3*SIZE(Gx,2)
      Call mma_Allocate(g,n)
      Call mma_Allocate(h,n)
*
*     Compute the orthogonal branching vectors
*     Note that d(E1-E0)/dx is stored, but we want to use d((E1-E0)/2)/dx
*     (and forces instead of gradients)
*
      gg=dDot_(n,Gx0(1,1,iter),1,Gx0(1,1,iter),1)*Quart
      hh=dDot_(n,NAC,1,NAC,1)
      gh=-dDot_(n,Gx0(1,1,iter),1,NAC,1) !Factor 2 included
      beta_ang=Atan2(gh,gg-hh)*Half
      Call dCopy_(n,Gx0(1,1,iter),1,g,1)
      Call dScal_(n,-Half*Cos(beta_ang),g,1)
      Call dAxpY_(n,Sin(beta_ang),NAC,1,g,1)
      Call dCopy_(n,NAC,1,h,1)
      Call dScal_(n,Cos(beta_ang),h,1)
      Call dAxpY_(n,Half*Sin(beta_ang),Gx0(1,1,iter),1,h,1)
      gg=dDot_(n,g,1,g,1)
      hh=dDot_(n,h,1,h,1)
      norm_g=Sqrt(gg)
      norm_h=Sqrt(hh)
      If (norm_g.gt.1.0D-12) Then
        Call dScal_(n,One/norm_g,g,1)
      Else
        Call dCopy_(n,[Zero],0,g,1)
      End If
      If (norm_h.gt.1.0D-12) Then
        Call dScal_(n,One/norm_h,h,1)
      Else
        Call dCopy_(n,[Zero],0,h,1)
      End If
*     Ensure that the asymmetry will be positive
*     this fixes which vector is x and which is y
      If (hh.gt.gg) Then
        Call SwapVe(g,h,n)
        aux=gg
        gg=hh
        hh=aux
        aux=norm_g
        norm_g=norm_h
        norm_h=aux
      End If
      sg=-dDot_(n,Gx(1,1,iter),1,g,1)
      sh=-dDot_(n,Gx(1,1,iter),1,h,1)
*     Ensure that the tilt heading will be in the first quadrant
*     this fixes the signs of the x and y vectors
      If (sg.lt.Zero) Then
        sg=Abs(sg)
        Call DScal_(n,-One,g,1)
      End If
      If (sh.lt.Zero) Then
        sh=Abs(sh)
        Call DScal_(n,-One,h,1)
      End If
      st=Sqrt(sg**2+sh**2)
      dgh=Sqrt((gg+hh)/Two)
      LabA=''
      deltagh=gg-hh
      If ((gg+hh).gt.1.0D-12) Then
        deltagh=deltagh/(gg+hh)
      Else
        LabA=' *'
      End If
      If (dgh.gt.1.0D-12) Then
        srel=st/dgh
      Else
        srel=Zero
      End If
      shead=Atan2(sh,sg)
*
*     peaked/sloped, bifurcating/single-path parameters
*
      peaked=srel**2/(One-deltagh**2)*(One-deltagh*Cos(Two*shead))
      bif=((One+deltagh)*Cos(shead)**2)**(One/Three)
      bif=bif+((One-deltagh)*Sin(shead)**2)**(One/Three)
      bif=(srel/(Two*deltagh))**(Two/Three)*bif
      Description=''
      If (peaked.lt.1) Then
        Description=Trim(Description)//'peaked (P<1)'
      Else If (peaked.gt.1) Then
        Description=Trim(Description)//'sloped (P>1)'
      Else
        Description=Trim(Description)//'* (P=1)'
      End If
      If (bif.lt.1) Then
        Description=Trim(Description)//' bifurcating (B<1)'
      Else If (bif.gt.1) Then
        Description=Trim(Description)//' single-path (B>1)'
      Else
        Description=Trim(Description)//' * (B=1)'
      End If
*
*     Disable Last_Energy to prevent further rotations
*
      CallLast=.False.
*
      Write(Lu,*)
      Call CollapseOutput(1,'Conical Intersection Characterization')
      Write(Lu,'(3X,A)')    '-------------------------------------'
      Write(Lu,*)
      Write(Lu,*) 'See: J. Chem. Theory Comput. 12 (2016) 3636-3653'
      Write(Lu,*)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('Gradient difference','',Gx0(1,1,iter),n,1)
      Call RecPrt('Coupling vector','',NAC,n,1)
      Call RecPrt('Average gradient','',Gx(1,1,iter),n,1)
      Write(Lu,100) 'Beta angle:',beta_ang
      Write(Lu,*)
#endif
      Write(Lu,100) 'Pitch (delta_gh):',dgh,' Eh/a0'
      Write(Lu,100) 'Asymmetry (Delta_gh):',deltagh,Trim(LabA)
#ifdef _DEBUGPRINT_
      Write(Lu,100) 'Total tilt (s):',st,' Eh/a0'
#endif
      Write(Lu,100) 'Relative tilt (sigma=s/delta_gh):',srel
      Write(Lu,100) 'Tilt heading (theta_s):',shead
      Write(Lu,*)
      Write(Lu,101) 'P:',peaked
      Write(Lu,101) 'B:',bif
      Write(Lu,101) 'Type: '//Trim(Description)
      Write(Lu,*)
      Write(Lu,*) 'Local linear representation:'
      Call mma_Allocate(tmp,n)
      Do i=1,SIZE(Gx,2)
        tmp(0*SIZE(Gx,2)+i) = g((i-1)*3+1)
        tmp(1*SIZE(Gx,2)+i) = g((i-1)*3+2)
        tmp(2*SIZE(Gx,2)+i) = g((i-1)*3+3)
      End Do
      Call RecPrt('Local x','',tmp,SIZE(Gx,2),3)
      Do i=1,SIZE(Gx,2)
        tmp(0*SIZE(Gx,2)+i) = h((i-1)*3+1)
        tmp(1*SIZE(Gx,2)+i) = h((i-1)*3+2)
        tmp(2*SIZE(Gx,2)+i) = h((i-1)*3+3)
      End Do
      Call RecPrt('Local y','',tmp,SIZE(Gx,2),3)
      Write(Lu,*)
      Write(Lu,110) Energy(iter),sg,sh
      Write(Lu,120) Two*dgh,deltagh
      Call mma_Deallocate(tmp)
      Call CollapseOutput(0,'Conical Intersection Characterization')
100   Format (5X,A,T40,ES12.5,A)
101   Format (5X,A,T11,ES12.5)
110   Format (5X,'Average energy: ',F15.8,' + ',F12.8,'*x + ',
     &        F12.8,'*y')
120   Format (5X,
     &        'Energy difference: ',F12.8,'*sqrt(r^2 + ',F12.8,'*t)',
     &        /,10X,'r^2 = x^2 + y^2',/,10X,'t = x^2 - y^2')
*
      Call mma_Deallocate(g)
      Call mma_Deallocate(h)
      Return
*
      End Subroutine CI_Summary

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Last_Energy(ireturn)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "timtra.fh"
#include "real.fh"
      Character*8 Method
      Logical Do_ESPF, StandAlone, FoundLastEn
*                                                                      *
************************************************************************
*                                                                      *
      ireturn=99
*
*     Get information regarding the last method used
*
      Call qpg_cArray('LastEnergyMethod',FoundLastEn,lengthlast)
      If (FoundLastEn) Then
         Call Get_cArray('LastEnergyMethod',Method,8)
      Else
         Call Get_cArray('Relax Method',Method,8)
      EndIf
*
      Call DecideOnESPF(Do_ESPF)
*
*
      If (Method(5:7) .eq. 'SCF'    .OR.
     &    Method(1:6) .eq. 'KS-DFT' .OR.
     &    Method(1:6) .eq. 'CASSCF' .OR.
     &    Method(1:6) .eq. 'RASSCF' .OR.
     &    Method(1:6) .eq. 'CASPT2' .OR.
     &    Method(1:5) .eq. 'MBPT2'  .OR.
     &    Method(1:5) .eq. 'CCSDT'  .OR.
     &    Method(1:4) .eq. 'CHCC'   .OR.
     &    Method(1:6) .eq. 'MCPDFT' .OR.
#ifdef _DMRG_
     &    Method(1:7) .eq. 'DMRGSCF'.OR.
#endif
     &    Method(1:4) .eq. 'CHT3'   .OR.
     &    Method(1:8) .eq. 'EXTERNAL') Then
         Continue
      Else
         Write (6,'(A,A,A)') 'Last Energy for ',Method,
     &                    ' is not implemented yet.'
         Call Abend()
      End If

      If (Method(1:6).eq.'MCPDFT') Do_ESPF=.false.
*
*                                                                      *
************************************************************************
*                                                                      *
*     Compute integrals
*
      Call StartLight('seward')
      Call Disable_Spool()
      Call Seward(ireturn)
      If (iReturn .ne. 0) Then
         Write(6,*) 'Last_Energy failed ...'
         Write(6,*)'Seward returned with return code, rc = ',iReturn
         Call Abend()
      End If
*
*     Compute ESPF
*
      If (Do_ESPF) Then
         Call StartLight('espf')
         Call Disable_Spool()
         StandAlone=.True.
         Call ESPF(ireturn,StandAlone)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*)'Espf returned with return code, rc = ',iReturn
            Call Abend()
         End If
      End If
*
*     Compute the wave function
*
      If ((Method(5:7) .eq. 'SCF' .and. Method(1:4) .ne. 'DMRG') .OR.
     &    Method(1:6) .eq. 'KS-DFT' .OR.
     &    Method(1:5) .eq. 'MBPT2' . OR.
     &    Method(1:4) .eq. 'CHCC' . OR.
     &    Method(1:4) .eq. 'CHT3') Then
         Call StartLight('scf')
         Call Disable_Spool()
         Call xml_open('module',' ',' ',0,'scf')
         Call SCF(iReturn)
         Call xml_close('module')
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'SCF returned with return code, rc = ',iReturn
            Call Abend()
         End If
      Else If (Method(1:6) .eq. 'RASSCF' .OR.
     &             Method(1:6) .eq. 'CASSCF' .OR.
     &             Method(1:6) .eq. 'CASPT2' .OR.
     &             Method(1:6) .eq. 'MCPDFT' .OR.
     &             Method(1:5) .eq. 'CCSDT') Then
         Call StartLight('rasscf')
         Call Disable_Spool()
         Call RASSCF(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'RASSCF returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
#ifdef _DMRG_
      Else If (Method(1:7) .eq. 'DMRGSCF') Then
         Call StartLight('dmrgscf')
         Call Disable_Spool()
         Call DMRGSCF(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'DMRGSCF returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
#endif
      Else If (Method(1:8) .eq. 'EXTERNAL') Then
         Call StartLight('false')
         Call Disable_Spool()
         Call False_program(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'FALSE returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
      End If
*
      If (Method(1:5) .eq. 'MBPT2') Then
         Call StartLight('mbpt2')
         Call Disable_Spool()
         Call MP2_Driver(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'MBPT2 returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
      End If
*
      If (Method(1:5) .eq. 'CCSDT') Then
         Call StartLight('motra')
         Call Disable_Spool()
         Call Motra(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'Motra returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
*
         Call StartLight('ccsdt')
         Call Disable_Spool()
         Call CCSDT(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'CCSDT returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
      End If
*
      If (Method(1:4) .eq. 'CHCC' .OR.
     &    Method(1:4) .eq. 'CHT3') Then
         Call StartLight('chcc')
         Call Disable_Spool()
         Call CHCC(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'CHCC returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
      End If
*
      If (Method(1:4) .eq. 'CHT3') Then
         Call StartLight('cht3')
         Call Disable_Spool()
         Call CHT3(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'CHT3 returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
      End If
*
      If (Method(1:6) .eq. 'CASPT2') Then
         Call StartLight('caspt2')
         Call Disable_Spool()
         Call CASPT2(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'CASPT2 returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
      End If
*
      If (Method(1:6) .eq. 'MCPDFT') Then
         Call StartLight('mcpdft')
         Call Disable_Spool()
         Call mcpdft(ireturn)
         If (iReturn .ne. 0) Then
            Write(6,*) 'Last_Energy failed ...'
            Write(6,*) 'MC-PDFT returned with return code, rc = ',
     &                  iReturn
            Call Abend()
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
       nfld_tim  = 0
       nfld_stat = 0
*                                                                      *
************************************************************************
*                                                                      *
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  quaterRotation
!
!> @brief
!>   Performs the rotation of \p U in \p V via the quaternion \p Q
!> @author Y. Carissan
!>
!> @details
!> Performs the rotation of \p U in \p V via the quaternion \p Q.
!>
!> @param[in]  Q Quaternion used for the rotation
!> @param[in]  U Vector to be rotated
!> @param[out] V Vector rotated
!***********************************************************************

subroutine quaterRotation(Q,U,V)

use Constants, only: One, Two
use Definitions, only: wp, r8

implicit none
real(kind=wp), intent(in) :: Q(0:3), U(3)
real(kind=wp), intent(out) :: V(3)
real(kind=wp) :: T(3), C1, C2, C3
real(kind=r8), external :: ddot_

call CheckQuater(Q)
call Cross(Q(1:3),U,T)         ! T = Q x U

C1 = Two*Q(0)**2-One           ! C1 = 2 * Q(0)^2 - 1
C2 = Two*Q(0)                  ! C2 = 2 * Q(0)
C3 = Two*ddot_(3,Q(1:3),1,U,1) ! C3 = 2 * Q.U
V(:) = C1*U(:)-C2*T(:)+C3*Q(1:3)

return

end subroutine quaterRotation

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Analyze_Q(iQ_Atoms)

use qmstat_global, only: iLuSaIn, iTcSim, nAtom, nCent, nPart, SaFilIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms
integer(kind=iwp) :: i, iCNum, iCStart, iDiskSa, iDiskTemp, iDum(1), iH, iHMax, iHowMSamp, ind, iSamp, j, k, l
real(kind=wp) :: dist, dist2, dR, Dum, Etot, Ract
real(kind=wp), allocatable :: Co(:,:), gR(:,:,:)
integer(kind=iwp), parameter :: iHUltraMax = 1000
#include "warnings.h"

Dum = Zero
!----------------------------------------------------------------------*
! Some numbers and defaults.                                           *
!----------------------------------------------------------------------*
iHMax = 0
iCStart = (((iQ_Atoms-1)/nAtom)+1)*nCent+1
iCNum = iCStart/nCent
dR = 0.1_wp
!----------------------------------------------------------------------*
! Just say what we are doing.                                          *
!----------------------------------------------------------------------*
call NiceOutPut('AAA')
!----------------------------------------------------------------------*
! Open sampfile. Get some numbers about how many sampled etc.          *
!----------------------------------------------------------------------*
call DaName(iLuSaIn,SaFilIn)
iDiskSa = 0
call iDaFile(iLuSaIn,2,iDum,1,iDiskSa)
iHowMSamp = iDum(1)
iDiskTemp = iDiskSa
call WrRdSim(iLuSaIn,2,iDiskSa,iTCSim,64,Etot,Ract,nPart,Dum,Dum,Dum)
iDiskSa = iDiskTemp
!----------------------------------------------------------------------*
! Say something about these numbers to the user.                       *
!----------------------------------------------------------------------*
write(u6,*)
write(u6,*) 'The sampfile ',SaFilIn,' contains ',iHowMSamp,' sampled configurations.'
write(u6,*) 'Total number of particles:',nPart
!----------------------------------------------------------------------*
! BEGIN ANALYZING!                                                     *
!----------------------------------------------------------------------*
call mma_allocate(gR,iQ_Atoms,nAtom,iHUltraMax,label='gR')
gR(:,:,:) = Zero
do iSamp=1,iHowMSamp
  !--------------------------------------------------------------------*
  ! Begin by getting the coordinates for this configuration. They are  *
  ! stored in Co(:,i) where i=1 means x-coordinate, i=2 y-coordinate   *
  ! and i=3 z-coordinate.                                              *
  !--------------------------------------------------------------------*
  call WrRdSim(iLuSaIn,2,iDiskSa,iTcSim,64,Etot,Ract,nPart,Dum,Dum,Dum)
  iDiskSa = iTcSim(1)
  call mma_allocate(Co,nPart*nCent,3,label='Coordinates')
  call dDafile(iLuSaIn,2,Co,3*nPart*nCent,iDiskSa)
  !--------------------------------------------------------------------*
  ! Once we have coordinates, lets compute some distances and start    *
  ! building various distribution functions.                           *
  !--------------------------------------------------------------------*
  do i=1,iQ_Atoms
    do j=1,nAtom
      do k=1,nPart-iCNum
        dist2 = Zero
        do l=1,3
          ind = iCStart+(j-1)+(k-1)*nCent
          dist2 = dist2+(Co(i,l)-Co(ind,l))**2
        end do
        dist = sqrt(dist2)
        iH = int((dist+dR*Half)/dR)
        if (iH > iHMax) then
          iHMax = iH
          if (iH > iHUltraMax) then
            write(u6,*)
            write(u6,*) 'Too fine sections for g(r). Increase section size or allocate more memory.'
            call Quit(_RC_INTERNAL_ERROR_)
          end if
        end if
        gR(i,j,iH) = gR(i,j,iH)+One/dist2
      end do
    end do
  end do
  !--------------------------------------------------------------------*
  ! End loop over sampled configurations.                              *
  !--------------------------------------------------------------------*
  call mma_deallocate(Co)
end do
!----------------------------------------------------------------------*
! Time to generate a nice output.                                      *
!----------------------------------------------------------------------*
write(u6,*)
write(u6,*) 'SUMMARY OF RESULTS FOR SAMPFILE ANALYSIS.'
write(u6,*)
do i=1,iQ_Atoms
  write(u6,*)
  write(u6,*) 'Quantum atom ',i
  write(u6,'(5X,A,5X,5(A,I2,1X))') 'Separation',('Solvent atom',k,k=1,nAtom)
  do iH=1,iHMax
    write(u6,'(F15.7,5(F15.7))') dR*iH,gR(i,:,iH)
  end do
end do

call mma_deallocate(gR)

call DaClos(iLuSaIn)

return

end subroutine Analyze_Q

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function iChxyz(Coord,iGen,nGen)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Coord(3)
integer(kind=iwp), intent(in) :: nGen, iGen(nGen)
integer(kind=iwp) :: iCar, iChCar(3), iChxyz

call ChCar(iChCar,iGen,nGen)

iChxyz = 0
do iCar=1,3
  if (Coord(iCar) /= Zero) iChxyz = iChxyz+iChCar(iCar)
end do

return

end function iChxyz

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Roland Lindh                                     *
************************************************************************
      SubRoutine IniSew(DSCF,nDiff)
************************************************************************
*     Author: Roland Lindh, Dept. of Chemical Physics,                 *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "SysDef.fh"
#include "nsd.fh"
#include "setup.fh"
#include "status.fh"
*
      Logical DSCF
*
      If (Seward_Status.eq.Active) Then
         Call ClsSew()
         Call xRlsMem_Ints()
      End If
*
      Call Seward_Init()
*
      Call GetInf(DSCF,nDiff)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Steven Vancoillie                                *
************************************************************************
* Molcas task manager
* Steven Vancoillie, june 2015
*   Reimplementation of the task manager routines
*   based solely on atomic read+increment operations on
*   a global task counter.
*
*   For GA, we use the ga_read_inc function, and for DGA
*   we use the gtsk_nxtval function. The latter has a special
*   "gtsk_nxtval_even" sibling for better performance. It is
*   only used when both MPI and DGA are active. The routines
*   that use this special flavour can be found in the second
*   part of the file.
*
*   The task lists are stacked, and have to be freed in
*   the order of last initialized = freed first!

      block data block_tsk
        implicit none
#include "tsk.fh"
        data list_counter/0/
      end

      subroutine init_tsk(id,n)
#ifdef _MOLCAS_MPP_
      use Para_Info, only: Is_Real_Par
#endif
      implicit none
#include "tsk.fh"
#ifdef _MOLCAS_MPP_
#  include "global.fh"
#  include "mafdecls.fh"
#endif
      integer :: id, n

#ifdef _debug_trace_
#endif

      if (list_counter.eq.mxtsklst) then
        call sysabendmsg ('init_tsk',
     &    'no free task lists available',' ')
      end if
      list_counter = list_counter + 1

      id = list_counter
      ntasks(id) = n
#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
        if (.not.ga_create(MT_INT,1,1,'gltskl',0,0,task_counter(id)))
     &    call sysabendmsg ('init_tsk',
     &      'failed to create global task list',' ')
#  if !defined (_GA_)
        call ga_zero(task_counter(id))
        call gtsk_setup(id,task_counter(id))
#  else
        call ga_fill(task_counter(id),1)
#  endif
      else
        task_counter(id) = 1
      endif
#else
      task_counter(id) = 1
#endif

#ifdef _debug_trace_
#endif
      end

      subroutine free_tsk(id)
#ifdef _MOLCAS_MPP_
      use Para_Info, only: Is_Real_Par
#endif
      implicit none
#include "tsk.fh"
#ifdef _MOLCAS_MPP_
#  include "global.fh"
#endif
      integer :: id

#ifdef _debug_trace_
#endif

      if (list_counter.eq.0) then
        call sysabendmsg ('free_tsk',
     &    'attempting to free a non-existent task list.',' ')
      end if
      if (id .ne. list_counter) then
        call sysabendmsg ('free_tsk',
     &    'only stack-based task lists are supported.',' ')
      end if
#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
        if (.not.ga_destroy(task_counter(id)))
     &    call sysabendmsg ('free_tsk',
     &      'failed to destroy global task list.',' ')
#  if !defined (_GA_)
        call gtsk_reset(id)
#  endif
      end if
#endif
      list_counter = list_counter - 1

#ifdef _debug_trace_
#endif
      end

      logical function rsv_tsk(id,task)
#ifdef _MOLCAS_MPP_
      use Para_Info, only: Is_Real_Par
#endif
      implicit none
#include "tsk.fh"
#ifdef _MOLCAS_MPP_
#  include "global.fh"
#endif
      integer :: id, task

#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
* (atomically) read+increment next task number
#  if !defined (_GA_)
        task = gtsk_nxtval(id,1)
#  else
        task = ga_read_inc(task_counter(id),1,1,1)
#  endif
      else
        task = task_counter(id)
        task_counter(id) = task_counter(id) + 1
      endif
#else
      task = task_counter(id)
      task_counter(id) = task_counter(id) + 1
#endif
      rsv_tsk = task.le.ntasks(id)
      end

*****************************************************************
* The "even" flavour of the task routines just give each process
* a spread of numbers just as they would do with a loop stride.
*****************************************************************
      subroutine init_tsk_even(id,n)
#ifdef _MOLCAS_MPP_
      use Para_Info, only: MyRank, Is_Real_Par
#endif
      implicit none
#include "tsk.fh"
      integer :: id, n

#ifdef _debug_trace_
#endif

      if (list_counter.eq.mxtsklst) then
        call sysabendmsg ('init_tsk_even',
     &    'no free task lists available',' ')
      end if
      list_counter = list_counter + 1

      id = list_counter
      ntasks(id) = n
#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
        task_counter(id) = myrank + 1
      else
        task_counter(id) = 1
      endif
#else
      task_counter(id) = 1
#endif

#ifdef _debug_trace_
#endif
      end

      subroutine free_tsk_even(id)
      implicit none
#include "tsk.fh"
      integer :: id

#ifdef _debug_trace_
#endif

      if (list_counter.eq.0) then
        call sysabendmsg ('free_tsk_even',
     &    'attempting to free a non-existent task list.',' ')
      end if
      if (id .ne. list_counter) then
        call sysabendmsg ('free_tsk_even',
     &    'only stack-based task lists are supported.',' ')
      end if
      list_counter = list_counter - 1

#ifdef _debug_trace_
#endif
      end

      logical function rsv_tsk_even(id,task)
#ifdef _MOLCAS_MPP_
      use Para_Info, only: nProcs, Is_Real_Par
#endif
      implicit none
#include "tsk.fh"
      integer :: id, task

#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
        task = task_counter(id)
* the next task is a stride of <nprocs> away
        task_counter(id) = task_counter(id) + nprocs
      else
        task = task_counter(id)
        task_counter(id) = task_counter(id) + 1
      endif
#else
      task = task_counter(id)
      task_counter(id) = task_counter(id) + 1
#endif
      rsv_tsk_even = task.le.ntasks(id)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ExScf(iCStart,nBaseQ,nBaseC,nCnC_C,iQ_Atoms
     &                ,nAtomsCC,Ax,Ay,Az,itri,Smat,SmatPure,InCutOff
     &                ,ipAOSum)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "qm1.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension Smat(MxOT),CorTemp(3),nCnC_C(MxBasC)
      Dimension SmatPure(MxOT)
      Dimension Inside(MxAt,3)
      Logical Inside,NearBy,InCutOff

*----------------------------------------------------------------------*
* Deduce how much the QM-molecule is translated from its position as   *
* definied in Seward.                                                  *
*----------------------------------------------------------------------*
      Ax=Cordst(1,1)-outxyz(1,1)
      Ay=Cordst(1,2)-outxyz(1,2)
      Az=Cordst(1,3)-outxyz(1,3)
*----------------------------------------------------------------------*
* Rotate solvent orbitals and make AO integration.                     *
*----------------------------------------------------------------------*
      s90um=0.0d0
      Cut_ExSq1=Cut_Ex1**2
      Cut_ExSq2=Cut_Ex2**2
      nOrbSize=iOrb(1)*iOrb(2)
      nV2size=iOrb(2)*nBaseC
      nAObaseSize=nBaseQ*nBaseC
      nStorlek=iOrb(1)*nBaseC
      Call GetMem('RotOrb','Allo','Real',iV2,nV2size)
      Call GetMem('Sint','Allo','Real',ipAOint,nAObaseSize)
      Call GetMem('Sintpar','Allo','Real',ipAOintpar,nAObaseSize)
      Call GetMem('OvlMO','Allo','Real',iOvlMO,nOrbSize)
      Call GetMem('Intermed','Allo','Real',iInte,nStorlek)
      Call GetMem('OvlMOpure','Allo','Real',iOPure,nOrbSize)
      Call GetMem('OvlMOene','Allo','Real',iOvlMOE,nOrbSize)
      Call GetMem('AUX','Allo','Real',ipAUX,iOrb(1)**2)
      Call GetMem('AUXp','Allo','Real',ipAUXp,iOrb(1)**2)
      Call GetMem('AUXtri','Allo','Real',ipAUXtri,iTri)
*Jose****************************************************************
      If(lExtr(8)) then
         nAOqMOcl=nBaseQ*iOrb(2)
         iAOAOTri=nBaseQ*(nBaseQ+1)/2
         Call GetMem('qAOclMOOvl','Allo','Real',iAOMOOvl,nAOqMOcl)
         Call GetMem('qAOclMOOvlE','Allo','Real',iAOMOOvlE,nAOqMOcl)
         Call GetMem('AuxAOp','Allo','Real',ipAOAUX,nBaseQ**2)
         Call GetMem('AuxAOpTri','Allo','Real',ipAOAUXtri,iAOAOTri)
      Endif
*     Call GetMem('SumOvlAOQ','Allo','Real',ipAOSum,iAOAOTri)
*********************************************************************
      InCutOff=.false.
      Do 575, i=1,iTri
        Smat(i)=0
        SmatPure(i)=0
575   Continue
      nInsideCut=0
      Do 501, N=iCStart-1,nCent*(nPart-1),nCent
*
*-- Initialize.
*
        dist_sw=1D20
        r3=1D20
        Do 11, i=1,MxAt
          Inside(i,1)=.false.
          Inside(i,2)=.false.
          Inside(i,3)=.false.
11      Continue
        NearBy=.false.
*-----Loop over atoms.
        Do 511, inwm=1,iQ_Atoms
          Do 512, k=1,3
            CorTemp(k)=(Cordst(N+1,k)-Cordst(inwm,k))**2
512       Continue
          r2=CorTemp(1)+CorTemp(2)+CorTemp(3)
          dist_sw=min(dist_sw,r2)
          DH1=0.0d0 !Distances for the inner cut-off. Also include the
          DH2=0.0d0  !hydrogens.
          Do 513, k=1,3
            DH1=DH1+(Cordst(N+2,k)-Cordst(inwm,k))**2
            DH2=DH2+(Cordst(N+3,k)-Cordst(inwm,k))**2
513       Continue
          r3temp1=min(DH1,DH2)
          r3temp2=min(r3temp1,r2)
          r3=min(r3,r3temp2)
*----Check if this atom-atom pair inside
          If(r2.lt.Cut_ExSq1) then
            Inside(inwm,1)=.true.
            NearBy=.true.
          Endif
          If(DH1.lt.Cut_ExSq1) then
            Inside(inwm,2)=.true.
            NearBy=.true.
          Endif
          If(DH2.lt.Cut_ExSq1) then
            Inside(inwm,3)=.true.
            NearBy=.true.
          Endif
511     Continue
*
*-- Now make the cut-off test.
*
        If(.not.NearBy) Go To 501
        If(r3.lt.Cut_ExSq2) then !Inner cut-off.
          InCutOff=.true.
        Endif
        nInsideCut=nInsideCut+1

*
*-- Make the AO-AO overlap integration.
*
        Call AOIntegrate(iCStart,nBaseQ,nBaseC,Ax,Ay,Az,nCnC_C
     &          ,iQ_Atoms,nAtomsCC,ipAOint,ipAOintpar,iV2,N,lmax
     &          ,Inside)

*
*-- Transform to MO-MO overlap.
*
        Call Dgemm_('T','N',iOrb(1),nBaseC,nBaseQ,ONE,Work(iV1)
     &    ,nBaseQ,Work(ipAOint),nBaseQ,ZERO,Work(iInte),iOrb(1))
        Call Dgemm_('N','N',iOrb(1),iOrb(2),nBaseC,ONE,Work(iInte)
     &    ,iOrb(1),Work(iV2),nBaseC,ZERO,Work(iOvlMO),iOrb(1))
        call dcopy_(nOrbSize,[ZERO],iZERO,Work(iOvlMOE),iONE)
        Do 5751, i=1,iOrb(2)
          ind=iOrb(1)*(i-1)
          Call DaxPy_(iOrb(1),c_orbene(i),Work(iOvlMO+ind),iONE
     &              ,Work(iOvlMOE+ind),iONE)
5751    Continue
*
***Jose
      If(lExtr(8)) then
        Call Dgemm_('N','N',nBaseQ,iOrb(2),nBaseC,ONE,Work(ipAOint)
     &    ,nBaseQ,Work(iV2),nBaseC,ZERO,Work(iAOMOOvl),nBaseQ)
        call dcopy_(nAOqMOcl,[ZERO],iZERO,Work(iAOMOOvlE),iONE)
        Do 5761, i=1,iOrb(2)
          ind=nBaseQ*(i-1)
          Call DaxPy_(nBaseQ,c_orbene(i),Work(iAOMOOvl+ind),iONE
     &              ,Work(iAOMOOvlE+ind),iONE)
5761    Continue
      Endif
********************
*
*-- If you are interested, print some bla bla bla.
*
        If(iPrint.ge.29) then
          Write(6,*)
          Write(6,*)'OVERLAP BETWEEN QM-SYSTEM AND SOLVENT MOLECULE '
     &,N/nCent
          Write(6,*)'QM-MO  SOLV-MO  OVERLAP'
          call dcopy_(iOrb(1)*iOrb(2),Work(iOvlMO),iONE
     &              ,Work(iOPure),iONE)
          Do 54599, i=0,iOrb(1)-1
            Do 54699, j=0,iOrb(2)-1
              Write(6,8888)i+1,j+1,Work(iOPure+i+j*iOrb(1))
54699       Continue
54599     Continue
8888      Format(I3,'    ',I3,'       ',F12.10)
        Endif

*
*-- Construct the perturbation and accumulate pure overlap for
*   subsequent construction of higher order term.
*
        Call Dgemm_('N','T',iOrb(1),iOrb(1),iOrb(2),exrep2
     &            ,Work(iOvlMO),iOrb(1),Work(iOvlMOE),iOrb(1),ZERO
     &            ,Work(ipAUX),iOrb(1))
        Call SqToTri_Q(Work(ipAUX),Work(ipAUXtri),iOrb(1))
        Call DaxPy_(iTri,ONE,Work(ipAUXtri),iONE,Smat,iONE)
        Call Dgemm_('N','T',iOrb(1),iOrb(1),iOrb(2),ONE
     &            ,Work(iOvlMO),iOrb(1),Work(iOvlMO),iOrb(1),ZERO
     &            ,Work(ipAUXp),iOrb(1))
        Call SqToTri_Q(Work(ipAUXp),Work(ipAUXtri),iOrb(1))
        Call DaxPy_(iTri,ONE,Work(ipAUXtri),iONE,SmatPure,iONE)

*Jose*********************************
      If(lExtr(8)) then
        Call Dgemm_('N','T',nBaseQ,nBaseQ,iOrb(2),exrep2
     &            ,Work(iAOMOOvl),nBaseQ,Work(iAOMOOvlE),nBaseQ,ZERO
     &            ,Work(ipAOAUX),nBaseQ)
        Call SqToTri_Q(Work(ipAOAUX),Work(ipAOAUXtri),nBaseQ)
        Call DaxPy_(iAOAOTri,ONE,Work(ipAOAUXtri),iONE,Work(ipAOSum)
     &            ,iONE)
      Endif
**************************************
*
*-- This solvent molecule ends now!
*
501   Continue

      Call GetMem('RotOrb','Free','Real',iV2,nV2size)
      Call GetMem('Sint','Free','Real',ipAOint,nAObaseSize)
      Call GetMem('Sintpar','Free','Real',ipAOintpar,nAObaseSize)
      Call GetMem('OvlMO','Free','Real',iOvlMO,nOrbSize)
      Call GetMem('Intermed','Free','Real',iInte,nStorlek)
      Call GetMem('OvlMOpure','Free','Real',iOPure,nOrbSize)
      Call GetMem('OvlMOene','Free','Real',iOvlMOE,nOrbSize)
      Call GetMem('AUX','Free','Real',ipAUX,iOrb(1)**2)
      Call GetMem('AUXp','Free','Real',ipAUXp,iOrb(1)**2)
      Call GetMem('AUXtri','Free','Real',ipAUXtri,iTri)
*Jose****************************************************************
      If(lExtr(8)) then
        Call GetMem('qAOclMOOvl','Free','Real',iAOMOOvl,nAOqMOcl)
        Call GetMem('qAOclMOOvlE','Free','Real',iAOMOOvlE,nAOqMOcl)
        Call GetMem('AuxAOp','Free','Real',ipAOAUX,nBaseQ**2)
        Call GetMem('AuxAOpTri','Free','Real',ipAOAUXtri,iAOAOTri)
      Endif
*********************************************************************

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SXTYP_GAS(NSXTYP,ITP,JTP,NGAS,ILTP,IRTP)
! Two supergroups are given. Find single excitations that connects
! these supergroups
!
! Jeppe Olsen, July 1995

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: NSXTYP
integer(kind=iwp), intent(_OUT_) :: ITP(*), JTP(*)
integer(kind=iwp), intent(in) :: NGAS, ILTP(NGAS), IRTP(NGAS)
integer(kind=iwp) :: IANNI, IAS, ICREA, NANNI, NCREA
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ISX
#endif

! Some dummy initializations
ICREA = 0 ! jwk-cleanup
IANNI = 0 ! jwk-cleanup
! Differences between occupations :
NCREA = 0
NANNI = 0
do IAS=1,NGAS
  if (ILTP(IAS) > IRTP(IAS)) then
    NCREA = NCREA+ILTP(IAS)-IRTP(IAS)
    ICREA = IAS
  else if (IRTP(IAS) > ILTP(IAS)) then
    NANNI = NANNI+IRTP(IAS)-ILTP(IAS)
    IANNI = IAS
  end if
end do

if (NCREA > 1) then
  ! Sorry : No single excitation connects
  NSXTYP = 0
else if (NCREA == 1) then
  ! Supergroups differ by one sngle excitation.
  NSXTYP = 1
  ITP(1) = ICREA
  JTP(1) = IANNI
else if (NCREA == 0) then
  ! Supergroups are identical, connects with all diagonal excitations.
  NSXTYP = 0
  do IAS=1,NGAS
    if (IRTP(IAS) /= 0) then
      NSXTYP = NSXTYP+1
      ITP(NSXTYP) = IAS
      JTP(NSXTYP) = IAS
    end if
  end do
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from SXTYP_GAS :'
write(u6,*) ' ======================='
write(u6,*) ' Input left  supergroup'
call IWRTMA(ILTP,1,NGAS,1,NGAS)
write(u6,*) ' Input right supergroup'
call IWRTMA(IRTP,1,NGAS,1,NGAS)
write(u6,*) ' Number of connecting single excitations ',NSXTYP
if (NSXTYP /= 0) then
  write(u6,*) ' Connecting single excitations'
  do ISX=1,NSXTYP
    write(u6,*) ITP(ISX),JTP(ISX)
  end do
end if
#endif

end subroutine SXTYP_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine Get_Temp(Label,Temp,nTemp)
       Implicit Real*8 (a-h,o-z)

       Real*8        Temp(nTemp)
       Character*(*) Label

       Call NameRun('.RUNTMP')
       Call Get_dArray(Label,Temp,nTemp)
       Call NameRun('#Pop')

       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MSTOW1(NSYM,NLEV,NVERT,NMIDV,NIPWLK,NWALK,MIDLEV,ICS,NOW,IOW,IWALK,IUP,IDOWN,MAW,MWS2W)
! Purpose: From the list of packed up- and downwalks, construct
! the table MWS2W, such that MAW sums can be translated to the
! corresponding walks of the Split-GUGA.

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NSYM, NLEV, NVERT, NMIDV, NIPWLK, NWALK, MIDLEV, NOW(2,NSYM,NMIDV), IOW(2,NSYM,NMIDV), &
                                 IWALK(NIPWLK*NWALK), IUP(NVERT,0:3), IDOWN(NVERT,0:3), MAW(NVERT,0:3)
integer(kind=iwp), intent(out) :: ICS(NLEV), MWS2W(NWALK)
integer(kind=iwp) :: IC, IDOFF, IDV, IDW, IDWTOT, ISYDWN, ISYUP, IUOFF, IUV, IUW, IUWTOT, LEV, MS, MV, NDWN, NUP

do MV=1,NMIDV
  do ISYUP=1,NSYM
    NUP = NOW(1,ISYUP,MV)
    if (NUP == 0) cycle
    IUOFF = IOW(1,ISYUP,MV)/NIPWLK
    do IUW=1,NUP
      IUWTOT = IUOFF+IUW
      ! Unpack upper walk to ICS()
      call UPKWLK(NLEV-MIDLEV,NIPWLK,1,IWALK(1+NIPWLK*(IUWTOT-1)),ICS(MIDLEV+1))
      MS = 0
      IUV = 1
      do LEV=NLEV,MIDLEV+1,-1
        IC = ICS(LEV)
        MS = MS+MAW(IUV,IC)
        IUV = IDOWN(IUV,IC)
      end do
      MWS2W(MS) = IUWTOT
    end do
  end do
end do

do MV=1,NMIDV
  do ISYDWN=1,NSYM
    NDWN = NOW(2,ISYDWN,MV)
    if (NDWN == 0) cycle
    IDOFF = IOW(2,ISYDWN,MV)/NIPWLK
    do IDW=1,NDWN
      IDWTOT = IDOFF+IDW
      ! Unpack lower walk to ICS()
      call UPKWLK(MIDLEV,NIPWLK,1,IWALK(1+NIPWLK*(IDWTOT-1)),ICS)
      MS = 0
      IDV = NVERT
      do LEV=1,MIDLEV
        IC = ICS(LEV)
        IUV = IUP(IDV,IC)
        MS = MS+MAW(IUV,IC)
        IDV = IUV
      end do
      MWS2W(MS) = IDWTOT
    end do
  end do
end do

end subroutine MSTOW1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine check_loops(nv,vblock,nla,nlb)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nv, vblock
integer(kind=iwp), intent(out) :: nla, nlb
integer(kind=iwp) :: nga, ngb, ngc, nuga

nuga = nv/vblock
!mp! pridavok
if ((nuga*vblock) < nv) nuga = nuga+1

nla = 0
do nga=1,nuga
  do ngb=1,nga
    do ngc=1,ngb
      nla = nla+1
    end do
  end do
end do

nlb = 0
do nga=1,nuga
  do ngb=1,nga
    do ngc=1,nuga
      nlb = nlb+1
    end do
  end do
end do

return

end subroutine check_loops

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine DoZeta(Alpha,nAlpha,Beta,nBeta,A,B,P,Zeta,rKappa,
     &                  ZInv,Alpha_,Beta_,Ind_Pair)
************************************************************************
*                                                                      *
* Object : to compute P and kappa.                                     *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*             May '90, modified for integral cutoff.                   *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN.                              *
*             June '91, modified for k2 loop.                          *
*             January '92, modified for gradient calculations.         *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Alpha(nAlpha), Beta(nBeta), Zeta(nAlpha*nBeta),
     &       Alpha_(nAlpha*nBeta), Beta_(nAlpha*nBeta),
     &       ZInv(nAlpha*nBeta), A(3), B(3),
     &       P(nAlpha*nBeta,3), rKappa(nAlpha*nBeta)
      Integer Ind_Pair(nAlpha*nBeta+1)
*
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt(' In DoZeta:Alpha',' ',Alpha,nAlpha,1)
      Call RecPrt(' In DoZeta:Beta',' ',Beta,nBeta,1)
#endif
*
      AB2=(A(1)-B(1))**2+(A(2)-B(2))**2+(A(3)-B(3))**2
      Do iBeta = 1, nBeta
         Do iAlpha = 1, nAlpha
            iZeta = nAlpha*(iBeta-1) + iAlpha
            Zeta  (iZeta)=Alpha(iAlpha)+Beta(iBeta)
            Alpha_(iZeta)=Alpha(iAlpha)
            Beta_ (iZeta)=Beta(iBeta)
            ZInv  (iZeta)=One/Zeta(iZeta)
            Tmp0=ZInv(iZeta)
            Tmp1=TwoP54*Exp(-Alpha(iAlpha)*Beta(iBeta)*AB2*Tmp0)*Tmp0
            If (Tmp1.lt.1.0D-99) Tmp1=1.0D-99
            rKappa(iZeta) = Tmp1
            P(iZeta,1) = (Alpha(iAlpha)*A(1)+Beta(iBeta)*B(1))*Tmp0
            P(iZeta,2) = (Alpha(iAlpha)*A(2)+Beta(iBeta)*B(2))*Tmp0
            P(iZeta,3) = (Alpha(iAlpha)*A(3)+Beta(iBeta)*B(3))*Tmp0
            Ind_Pair(iZeta)=iZeta
         End Do
      End Do
      Ind_Pair(nAlpha*nBeta+1)=nAlpha*nBeta
*
*     Sort from Large to Small
*
      nZeta=nAlpha*nBeta
*define _New_Code_
#ifdef _New_Code_
      Do iZeta = 1, nZeta-1
         Tmp1 = rKappa(iZeta)
         Do jZeta = iZeta+1, nZeta
            If (Tmp1.lt.rKappa(jZeta)) Then
               Tmp1 = rKappa(jZeta)
               Tmp2 = Zeta(iZeta)
               Zeta(iZeta)=Zeta(jZeta)
               Zeta(jZeta)=Tmp2
               Tmp2 = Alpha_(iZeta)
               Alpha_(iZeta)=Alpha_(jZeta)
               Alpha_(jZeta)=Tmp2
               Tmp2 = Beta_ (iZeta)
               Beta_ (iZeta)=Beta_ (jZeta)
               Beta_ (jZeta)=Tmp2
               Tmp2 = ZInv  (iZeta)
               ZInv  (iZeta)=ZInv  (jZeta)
               ZInv  (jZeta)=Tmp2
               Tmp2 = rKappa(iZeta)
               rKappa(iZeta)=rKappa(jZeta)
               rKappa(jZeta)=Tmp2
               Tmp2 = P(iZeta,1)
               P(iZeta,1)=P(jZeta,1)
               P(jZeta,1)=Tmp2
               Tmp2 = P(iZeta,2)
               P(iZeta,2)=P(jZeta,2)
               P(jZeta,2)=Tmp2
               Tmp2 = P(iZeta,3)
               P(iZeta,3)=P(jZeta,3)
               P(jZeta,3)=Tmp2
               iTmp = Ind_Pair(iZeta)
               Ind_Pair(iZeta)=Ind_Pair(jZeta)
               Ind_Pair(jZeta)=iTmp
            End If
         End Do
      End Do
#endif
*
#ifdef _DEBUGPRINT_
      Call RecPrt(' In DoZeta: Kappa',' ',rKappa,nZeta,1)
      Call RecPrt(' In DoZeta: P',' ',P,nZeta,3)
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine WfCtl_SA(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,
     &                    iRHSDisp,converged,iPL)
************************************************************************
*                                                                      *
*                                                                      *
*     called from: MCLR                                                *
*                                                                      *
*                                                                      *
************************************************************************
      use Exp, only: Exp_Close
      use ipPage, only: W
      Implicit Real*8 (a-h,o-z)
*
#include "stdalloc.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "dmrginfo_mclr.fh"

      Logical CI
#include "crun_mclr.fh"
      Character*8   Fmt2
      Integer iKapDisp(nDisp),isigDisp(nDisp)
      Integer iRHSDisp(nDisp)
      Integer iCIDisp(nDisp),iCIsigDisp(nDisp)
      Integer opOut
      Logical lPrint,converged(8)
      Real*8 rchc(mxroot)
      Real*8 rdum(1)
      Real*8, Allocatable:: Kappa(:), dKappa(:), Sigma(:),
     &                      Temp3(:), Temp4(:),
     &                      Sc1(:), Sc2(:), Fancy(:)

*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
      Call StatusLine(' MCLR:',
     &                ' Computing Lagrangian multipliers for SA-CASSCF')
*

      lPaper=132
      lLine =120
      left=(lPaper-lLine)/2
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
*----------------------------------------------------------------------*

      iDis=0
*
      fail=.false.
      Do i=1,8
       Converged(i)=.true.
      end do
*MGD I think this is nice when printed...
      lprint=.true.
      reco=-One
      Lu_50=50
      If (SAVE) CALL DANAME(Lu_50,'RESIDUALS')
      If (SAVE) Then
         Write (6,*) 'WfCtl_SA: SAVE option not implemented'
         Call Abend()
      End If
      If (iAnd(kprint,2).eq.2) lprint=.true.
      isym=1
      nconf1=ncsf(State_Sym)

      CI=.false.
      If (iMethod.eq.2.and.nconf1.gt.0) CI=.true.

*          Initiate CSF <-> SD
           Call InCSFSD(iEor(iSym-1,State_Sym-1)+1,
     &                  State_sym,.false.)
*
*
*          Calculate length of the density, Fock and Kappa matrix etc
*          notice that this matrices are not necessarily symmetric.
*          Store pointers.
*
*          Input:
*                 iSym: Symmetry of perturbation
*
*          Output: Commonblocks (Pointers.fh)
*
      nConf3=nint(Max(xispsm(State_SYM,1),xispsm(State_SYM,1)))

      Call Setup_MCLR(iSym)

*
*     Determine if we should page CI vectors
*                                [2]
*     Calculate the diagonal of E    and store in core/disc
*
      Call mma_allocate(FANCY,nroots**3,Label='FANCY')
      Call CIDia_SA(State_Sym,rCHC,Fancy)

      irc=ipOut(ipdia)
*
*     Allocate disk/memory space
*
*
*     This areas should be addressed through ipIn
*     ipOut will page them out to disk and free the memory area
*     if page mode is used
*
*     opOut will release the memory area without update the disk
*
      ipS1 =ipGet(nconf3*nroots)
      ipS2 =ipGet(nconf3*nroots)
      ipST =ipGet(nconf3*nroots)
      ipCIT=ipGet(nconf1*nroots)
      ipCId=ipGet(nconf1*nroots)
*
      npre2=npre(isym)
      ipPre2=ipGet(npre2)
      irc=ipIn(ipPre2)
      If (TwoStep.and.(StepType.eq.'RUN2')) Then
         ! fetch data from LuQDAT and skip the call to "Prec"
         Call ddafile(LuQDAT,2,W(ipPre2)%Vec,npre2,iaddressQDAT)
      Else
         Call Prec(W(ipPre2)%Vec,isym)
         irc=ipOut(ippre2)
         If (TwoStep.and.(StepType.eq.'RUN1')) Then
            ! save the computed data in "Prec" to LuQDAT and skip the
            ! following part of this function
            irc=ipIn(ipPre2)
            Call ddafile(LuQDAT,1,W(ipPre2)%Vec,npre2,iaddressQDAT)
            Go To 193
         End If
      End If
*
*
*     OK START WORKING
*
*     idisp=1
      jspin=0
*
*     Allocate areas for scratch and state variables
*
      Call mma_allocate(Kappa,nDens2+6,Label='Kappa')
      Call mma_allocate(dKappa,nDens2+6,Label='dKappa')
      Call mma_allocate(Sigma,nDens2+6,Label='Sigma')
      Call mma_allocate(Temp3,nDens2+6,Label='Temp3')
      Call mma_allocate(Temp4,nDens2+6,Label='Temp4')
      Call mma_allocate(Sc1,nDens2+6,Label='Sc1')
      Call mma_allocate(Sc2,nDens2+6,Label='Sc2')
*
      do iDisp=1,nDisp
         Kappa(1:nDens2)=Zero
         dKappa(1:nDens2)=Zero
         Sigma(1:nDens2)=Zero
*
*-----------------------------------------------------------------------------
*
*     Calculate RHS for the perturbation
*
*-----------------------------------------------------------------------------
*
*     (T1,T2,T3,T4,T5,T6,T7,Kappa1,CI1)
*
      If (debug) Then
         If (isNAC) Then
            Write(6,*)'States: ',NACstates(1),NACstates(2)
         Else
            Write(6,*)'State: ',irlxroot
         EndIf
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
      If (isNAC) Then
        Call RHS_NAC(Temp4)
      Else
        Call RHS_SA(Temp4)
      End If
*
      irc=opOut(ipci)
*
      If (lprint) Write(6,*)
     &      '       Iteration       Delta           Res(kappa)     '//
     &      '  Res(CI)          DeltaK           DeltaC'
      iLen=nDensC
      iRHSDisp(iDisp)=iDis
      Call Compress(Temp4,Sigma,iSym)
      r1=ddot_(nDensc,Sigma,1,Sigma,1)
      If(debug)Write(6,*) 'Hi how about r1',r1
      Call dDaFile(LuTemp,1,Sigma,iLen,iDis)
*
      irc=ipIn(ipCIT)
      irc=ipIn(ipST)
      irc=ipIn(ipCID)
      call dcopy_(nConf1*nroots,[Zero],0,W(ipCIT)%Vec,1)
      call dcopy_(nConf1*nroots,[Zero],0,W(ipST)%Vec,1)
      call dcopy_(nConf1*nroots,[Zero],0,W(ipCID)%Vec,1)
      irc=ipOut(ipCIT)
      Call DSCAL_(nDensC,-One,Sigma,1)
*
      irc=ipIn(ipPre2)
      Call DMInvKap(W(ipPre2)%Vec,Sigma,nDens2+6,
     &              Kappa,nDens2+6,Temp3,nDens2+6,
     &              isym,iter)

      irc=opOut(ippre2)
      r2=ddot_(ndensc,Kappa,1,Kappa,1)
      If(debug)Write(6,*) 'In that case I think that r2 should be:',r2
      If (r2.gt.r1) Write(6,*) 'Warning ',
     &    ' perturbation number ',idisp,' might diverge'
*
      call dcopy_(ndensC,Kappa,1,dKappa,1)
*
      deltaC=Zero
      irc=ipOut(ipcid)
      deltaK=ddot_(nDensC,Kappa,1,Sigma,1)
      Kappa(1:nDens)=Zero
      delta=deltac+deltaK
      delta0=delta
      iter=1
      If (delta.eq.Zero) Goto 300
*-----------------------------------------------------------------------
*
200   Continue
*
         Call TimesE2(dKappa,ipCId,1,reco,jspin,ipS2,Temp4,ipS1)
*
*-----------------------------------------------------------------------
*
*                   delta
*        rAlpha=------------
*               dKappa:dSigma
*
*-----------------------------------------------------------------------
*
         rAlphaK=Zero
         rAlphaK=ddot_(nDensC,Temp4,1,dKappa,1)
         rAlphaC=Zero
         irc=ipIn(ipS1)
         irc=ipIn(ipCId)
         rAlphaC=ddot_(nConf1*nroots,W(ipS1)%Vec,1,W(ipCId)%Vec,1)
         rAlpha=delta/(rAlphaK+rAlphaC)
*
*-------------------------------------------------------------------*
*
*        Kappa=Kappa+rAlpha*dKappa
         Call DaxPy_(nDensC,ralpha,dKappa,1,Kappa,1)
*        Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa
         Call DaxPy_(nDensC,-ralpha,Temp4,1,Sigma,1)
         resk=sqrt(ddot_(nDensC,Sigma,1,Sigma,1))
         resci=Zero
         irc=ipIn(ipCIT)
         Call DaXpY_(nConf1*nroots,ralpha,W(ipCId)%Vec,1,W(ipCIT)%Vec,1)
         irc=ipOut(ipcit)
*        ipST =ipST -rAlpha*ipS1         ipST=RHS-A*ipCIT
         irc=ipIn(ipS1)
         irc=ipIn(ipST)
         Call DaXpY_(nConf1*nroots,-ralpha,W(ipS1)%Vec,1,W(ipST)%Vec,1)
         irc=opOut(ipS1)
         irc=ipIn(ipST)
         resci=sqrt(ddot_(nconf1*nroots,W(ipST)%Vec,1,W(ipST)%Vec,1))

*-------------------------------------------------------------------*
*
*        Precondition......
*           -1
*        S=M  Sigma
*
         irc=opOut(ipcid)

         irc=ipIn(ipS2)
         Call DMinvCI_SA(ipST,W(ipS2)%Vec,rdum(1),isym,Fancy)
         irc=opOut(ipci)
         irc=opOut(ipdia)

         irc=ipIn(ipPre2)
         Call DMInvKap(W(ipPre2)%Vec,Sigma,nDens2+6,
     &                 Sc2,nDens2+6,Sc1,nDens2+6,
     &                 iSym,iter)
         irc=opOut(ippre2)
*
*-------------------------------------------------------------------*
*             s:Sigma (k+1)     s:Sigma (k+1)
*        Beta=-------        =  -------------
*              delta  (k)        s:Sigma (k)
*
*        delta=s:sigma
*
*        dKappa=s+Beta*dKappa
*
         deltaC=ddot_(nConf1*nroots,W(ipST)%Vec,1,W(ipS2)%Vec,1)
         irc=ipOut(ipST)
*
         deltaK=ddot_(nDensC,Sigma,1,Sc2,1)
         If (.not.CI) Then
            rBeta=deltaK/delta
            delta=deltaK
            Call DScal_(nDensC,rBeta,dKappa,1)
            Call DaXpY_(nDensC,One,Sc2,1,dKappa,1)
         Else
            rbeta=(deltac+deltaK)/delta
            delta=deltac+deltaK
            irc=ipIn(ipCID)
            Call DScal_(nConf1*nroots,rBeta,W(ipCID)%Vec,1)
            Call DScal_(nDensC,rBeta,dKappa,1)
            Call DaXpY_(nConf1*nroots,One,W(ipS2)%Vec,1,W(ipCID)%Vec,1)
            Call DaXpY_(nDensC,One,Sc2,1,dKappa,1)
            irc=opOut(ipS2)
            irc=ipOut(ipCID)
         End If

*    ######  #    #  #####        #####    ####    ####
*    #       ##   #  #    #       #    #  #    #  #    #
*    #####   # #  #  #    #       #    #  #       #
*    #       #  # #  #    #       #####   #       #  ###
*    #       #   ##  #    #       #       #    #  #    #
*    ######  #    #  #####        #        ####    ####
*
*-------------------------------------------------------------------*
*
*
         res=Zero ! dummy initialize
         If (iBreak.eq.1) Then
            If (abs(delta).lt.abs(Epsilon**2*delta0)) Goto 300
         Else If (iBreak.eq.2) Then
            res=sqrt(resk**2+resci**2)
            if (doDMRG) res=sqrt(resk**2)
            If (res.lt.abs(epsilon)) Goto 300
         Else
            If (abs(delta).lt.abs(Epsilon**2*delta0).and.
     &          res.lt.abs(epsilon))  Goto 300
         End If
         If (iter.ge.niter) goto 210
         If (lprint)
     &   Write(6,Fmt2//'I7,4X,ES17.9,ES17.9,ES17.9,ES17.9,ES17.9)')
     &          iter,delta/delta0,resk,resci,deltac,deltak
         iter=iter+1
*
         Goto 200
*
************************************************************************
*
 210     Continue
         Write(6,Fmt2//'A,I4,A)')
     &         'No convergence for perturbation no: ',
     &          idisp,'. Increase Iter.'
         converged(isym)=.false.
         fail=.true.
         Goto 310
 300  Continue
      If (iPL.ge.2) Then
          Write(6,Fmt2//'A,I4,A,I4,A)')
     &          'Perturbation no: ',idisp,' converged in ',
     &          iter-1,' steps.'
      End If
      irc=ipnout(-1)
*
 310  Continue
      If (iPL.ge.2) Write(6,*)
      iLen=ndensC
      iKapDisp(iDisp)=iDis
      Call dDaFile(LuTemp,1,Kappa,iLen,iDis)
      iSigDisp(iDisp)=iDis
      Call dDaFile(LuTemp,1,Sigma,iLen,iDis)
      ilen=nconf1*nroots
      iCIDisp(iDisp)=iDis
*
      irc=ipin(ipCIT)
      Call dDaFile(LuTemp,1,W(ipCIT)%Vec,iLen,iDis)
*
**MGD This last call seems unused, so I comment it
*
*      Call TimesE2(Kappa,ipCIT,1,reco,jspin,ipS2,
*     &             Temp4,ipS2)
      iCISigDisp(iDisp)=iDis
      irc=ipin(ipST)
      Call dDaFile(LuTemp,1,W(ipST)%Vec,iLen,iDis)
      end do ! iDisp
*
      Call mma_deallocate(Temp4)
      Call mma_deallocate(Temp3)
      Call mma_deallocate(Sigma)
      Call mma_deallocate(dKappa)
      Call mma_deallocate(Kappa)
      Call mma_deallocate(Sc2)
      Call mma_deallocate(Sc1)
*
*     Free all memory and remove from disk all data
*     related to this symmetry
*
193   Continue
      Call mma_deallocate(Fancy)

      irc=ipclose(ipdia)
      If (.not.CI) irc=ipclose(ipPre2)
*
      Call Exp_Close()

      If (debug) Then
      Write(6,*)  '****************************************'//
     &            '****************************************'
      Write(6,*)
      End If
      if(doDMRG)then  ! yma
        call dmrg_spc_change_mclr(RGras2(1:8),nash)
        call dmrg_spc_change_mclr(RGras2(1:8),nrs2)
      end if
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

      Subroutine TimesE2(Kap,ipCId,isym,reco,jspin,ipS2,KapOut,ipCiOut)
      use ipPage, only: w
      Implicit Real*8(a-h,o-z)
#include "stdalloc.fh"
#include "Pointers.fh"
#include "dmrginfo_mclr.fh"
#include "real.fh"
#include "Input.fh"
      Integer opOut
      Real*8 Kap(*),KapOut(*)
      Real*8 rdum(1)
      Real*8, Allocatable:: Temp3(:), Temp4(:),
     &                      Sc1(:), Sc2(:), Sc3(:), RMOAA(:)
*
      Call mma_allocate(RMOAA,n2Dens,Label='RMOAA')
      Call mma_allocate(Sc1,nDens2,Label='Sc1')
      Sc1(:)=Zero
      Call mma_allocate(Sc2,nDens2,Label='Sc2')
      Call mma_allocate(Sc3,nDens2,Label='Sc3')
      Call mma_allocate(Temp3,nDens2,Label='Temp3')
      Call mma_allocate(Temp4,nDens2,Label='Temp4')
*
      if(doDMRG)then ! yma
        call dmrg_spc_change_mclr(RGras2(1:8),nash)
        call dmrg_spc_change_mclr(RGras2(1:8),nrs2)
      end if
      Call Uncompress(Kap,Sc1,isym)

! Integral derivative !yma
      Call RInt_generic(SC1,rmoaa,rdum,
     &                 Sc2,
     &                 Temp3,Temp4,Sc3,
     &                 isym,reco,jspin)

      Call Kap_CI(Temp4,nDens2,rmoaa,n2Dens,ipCIOUT)
      Call Ci_Ci(ipcid,ipS2)
      Call CI_KAP(ipCid,Sc1,Sc3,isym)

      Call DZaXpY(nDens,One,Sc2,1,Sc3,1,Sc1,1)
*
      Call Compress(Sc1,KapOut,isym)   ! ds
*     Call RecPrt('Ex',' ',KapOut,ndensC,1)
*
      irc=ipin(ipS2)
      irc=ipin(ipCIOUT)
      Call DaXpY_(nConf1*nroots,One,
     &               W(ipS2)%Vec,1,
     &               W(ipCIOUT)%Vec,1)
      irc=opOut(ipCId)

*
      Call mma_deallocate(Temp4)
      Call mma_deallocate(Temp3)
      Call mma_deallocate(Sc3)
      Call mma_deallocate(Sc2)
      Call mma_deallocate(Sc1)
      Call mma_deallocate(rmoaa)

      if(doDMRG)then  ! yma
        call dmrg_spc_change_mclr(LRras2(1:8),nash)
      end if
*
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_Drv_ParTwoStep(irc)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: Parallel two-step decomposition of two-electron
C              integrals.
C
      Implicit None
      Integer irc
#include "choprint.fh"
#include "cholesky.fh"
#include "chosew.fh"
#include "chosubscr.fh"
#include "chosimri.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer ip_Err, l_Err
      Integer iSec, kDiag
      Integer ip_Start, l_Start
      Integer BlockSize_Bak, iPrint_Bak, Cho_IOVec_Bak, N1_VecRD_Bak
      Integer N2_VecRd_Bak
      Integer Cho_DecAlg_Bak
      Integer nSys_Call_Bak, nDGM_Call_Bak
      Integer iSym, n, ni, nj, nnBlock, i1
      Integer ip_NVT, l_NVT
      Integer ip_nBlock, l_nBlock
      Integer nB, nB_Max
      Integer ip_Z, l_Z
      Integer ip_nVBlock, l_nVBlock
      Integer ip_iV1Block, l_iV1Block
      Integer ip_ZBlock, l_ZBLock
      Integer iBlock, jBlock, ijBlock
      Integer MinQual_Bak, MaxQual_Bak, N1_Qual_Bak, N2_Qual_Bak
      Integer MxShPr_Bak, iAlQua_Bak
      Integer N_Subtr_Bak
      Integer Mode_Screen_Bak, Cho_DecAlg_Def_Bak, ModRst_Bak

      Real*8 tCPU0,  tCPU1,  tC0, tC1
      Real*8 tWall0, tWall1, tW0, tW1
      Real*8 C0, C1, W0, W1
      Real*8 DumTst, DumTol
      Real*8 Thr_PreScreen_Bak, ThrDiag_Bak, Frac_ChVBuf_Bak, SSTau_Bak
      Real*8 Thr_SimRI_Bak, Tol_DiaChk_Bak
      Real*8 TimSec_Bak(4,nSection)
      Real*8 tInteg_Bak(2,nInteg)
      Real*8 tDecom_Bak(2,nDecom)
      Real*8 tMisc_Bak(2,nMisc)
      Real*8 Byte

      Logical lConv, Free_Z
      Logical Cho_1Center_Bak, Cho_No2Center_Bak, Cho_PreScreen_Bak
      Logical ScDiag_Bak, Cho_SScreen_Bak, Cho_SimRI_Bak, HaltIt_Bak
      Logical Did_DecDrv_Bak
      Logical Cho_UseAbs_Bak, Cho_DiaChk_Bak, Cho_Fake_Par_Bak
      Logical Cho_SimP_Bak, Cho_ReOrd_Bak, ChkOnly_Bak
      Logical Cho_IntChk_Bak, Cho_MinChk_Bak, Cho_TrcNeg_Bak
      Logical Cho_TstScreen_Bak, RstDia_Bak, RstCho_Bak
      Logical Trace_Idle_Bak

      Character*18 SecNam
      Character*4 myName
      Character*2 Unt

      Parameter (SecNam='Cho_Drv_ParTwoStep')
      Parameter (myName='DPTS')
      Parameter (DumTst=0.123456789d0, DumTol=1.0d-15)

      Integer NVT, nBlock, iTri
      Integer i, j
      NVT(i)=iWork(ip_NVT-1+i)
      nBlock(i)=iWork(ip_nBlock-1+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

C     Preliminaries.
C     ==============

#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem('Start of '//SecNam)
#endif

      ! Start overall timing
      If (iPrint .ge. Inf_Timing) Call Cho_Timer(tCPU0,tWall0)

      ! Init return code
      irc=0

      ! make a dummy allocation (used to flush memory later)
      l_Start=1
      Call GetMem('DrvDum','Allo','Real',ip_Start,l_Start)
      Work(ip_Start)=DumTst

      ! init local variables
      kDiag = 0
      lConv = .False.

C     Initialization.
C     ===============

      iSec=1
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(1,iSec),TimSec(3,iSec))
      End If
      Call Cho_Init(.False.,.True.)
      Call Cho_GASync()
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(2,iSec),TimSec(4,iSec))
         Call Cho_PrtTim('Cholesky initialization',
     &                   TimSec(2,iSec),TimSec(1,iSec),
     &                   TimSec(4,iSec),TimSec(3,iSec),
     &                   1)
      End If
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem(SecNam//': After init')
#endif

C     Get diagonal.
C     =============

      iSec=2
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(1,iSec),TimSec(3,iSec))
         Write(LuPri,'(/,A)')
     &   '***** Starting Cholesky diagonal setup *****'
         Call Cho_Flush(LuPri)
      End If
      Call Cho_GetDiag(kDiag,lConv)
      Call Cho_GASync()
      If (lConv) Then
         ! restart is not possible, so it can not be converged!!
         Write(LuPri,'(A,A)')
     &   SecNam,': logical error: converged but not restart?!?!'
         Call Cho_Quit('Error in '//SecNam,103)
      End If
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(2,iSec),TimSec(4,iSec))
         Call Cho_PrtTim('Cholesky diagonal setup',
     &                   TimSec(2,iSec),TimSec(1,iSec),
     &                   TimSec(4,iSec),TimSec(3,iSec),
     &                   1)
      End If
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem(SecNam//': After diagonal')
#endif

C     Cholesky decomposition in two steps.
C     ====================================

      ! Time the rest as "decomposition driver"
      Call Cho_Timer(C0,W0)

      iSec=3
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(1,iSec),TimSec(3,iSec))
         Write(LuPri,'(/,A)')
     &   '***** Starting Cholesky decomposition *****'
         Call Cho_Flush(LuPri)
      End If

      ! Perform first CD step: get parent diagonals and Z vectors.
      ! Z vectors contain more elements than needed at this stage!
      ! (more elements than vectors). The final Z vectors are obtained
      ! below (Cho_GetZ).
      Call Cho_P_SetAddr()
      Call Cho_DecDrv(Work(kDiag))
      Call Cho_GASync()
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(tC1,tW1)
         Call Cho_PrtTim('Cholesky map generation',
     &                   tC1,TimSec(1,iSec),
     &                   tW1,TimSec(3,iSec),
     &                   2)
      End If
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem(SecNam//': After 1st step')
#endif

      ! Shut down and re-initialize.
      ! This is done to get rid of the vast amount of different data
      ! generated by the parallel decomposition in particular.
      ! In addition, it will make it easier to use the vector calculator
      ! externally (i.e. after seward execution)
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(tC0,tW0)
      End If
      Call dCopy_(4*nSection,TimSec,1,Timsec_Bak,1)
      Call dCopy_(2*nInteg,tInteg,1,tInteg_Bak,1)
      Call dCopy_(2*nDecom,tDecom,1,tDecom_Bak,1)
      Call dCopy_(2*nMisc,tMisc,1,tMisc_Bak,1)
      Trace_Idle_Bak=Trace_Idle
      Cho_UseAbs_Bak=Cho_UseAbs
      Cho_DiaChk_Bak=Cho_DiaChk
      Cho_Fake_Par_Bak=Cho_Fake_Par
      Cho_SimP_Bak=Cho_SimP
      Cho_ReOrd_Bak=Cho_ReOrd
      ChkOnly_Bak=ChkOnly
      Cho_IntChk_Bak=Cho_IntChk
      Cho_MinChk_Bak=Cho_MinChk
      Cho_TrcNeg_Bak=Cho_TrcNeg
      Cho_TstScreen_Bak=Cho_TstScreen
      RstDia_Bak=RstDia
      RstCho_Bak=RstCho
      Mode_Screen_Bak=Mode_Screen
      Cho_DecAlg_Def_Bak=Cho_DecAlg_Def
      ModRst_Bak=ModRst
      N_Subtr_Bak=N_Subtr
      Did_DecDrv_Bak=Did_DecDrv
      HaltIt_Bak=HaltIt
      Tol_DiaChk_Bak=Tol_DiaChk
      Cho_1Center_Bak=Cho_1Center
      Cho_No2Center_Bak=Cho_No2Center
      Cho_PreScreen_Bak=Cho_PreScreen
      Thr_PreScreen_Bak=Thr_PreScreen
      ThrDiag_Bak=ThrDiag
      ScDiag_Bak=ScDiag
      MinQual_Bak=MinQual
      MaxQual_Bak=MaxQual
      N1_Qual_Bak=N1_Qual
      N2_Qual_Bak=N2_Qual
      MxShPr_Bak=MxShPr
      iAlQua_Bak=iAlQua
      Cho_IOVec_Bak=Cho_IOVec
      Frac_ChVBuf_Bak=Frac_ChVBuf
      Cho_SScreen_Bak=Cho_SScreen
      SStau_Bak=SStau
      Cho_SimRI_Bak=Cho_SimRI
      Thr_SimRI_Bak=Thr_SimRI
      Cho_DecAlg_Bak=Cho_DecAlg
      BlockSize_Bak=BlockSize
      iPrint_Bak=iPrint
      Cho_IOVec_Bak=Cho_IOVec
      N1_VecRd_Bak=N1_VecRd
      N2_VecRd_Bak=N2_VecRd
      nSys_Call_Bak=nSys_Call
      nDGM_Call_Bak=nDGM_Call
      Call Cho_P_WrDiag()
      Call Cho_Final(.True.)
      Call Cho_P_OpenVR(2)
      If (Abs(DumTst-Work(ip_Start)) .gt. DumTol) Then
         Write(LuPri,*) SecNam,': memory has been out of bounds [1]'
         irc=2
         Go To 1 ! flush memory and return
      End If
      Call GetMem('DrvDum','Flus','Real',ip_Start,l_Start)
      Call Cho_X_Init(irc,0.0d0)
      If (irc .ne. 0) Then
         Write(LuPri,*) SecNam,': Cho_X_Init returned code ',irc
         irc = 1
         Go To 1 ! flush memory and return
      End If
      If (Cho_1Center) Then
         If (l_iAtomShl.lt.1) Then
            l_iAtomShl=nShell
            Call GetMem('iAtomShl','Allo','Inte',ip_iAtomShl,l_iAtomShl)
            Call Cho_SetAtomShl(irc,iWork(ip_iAtomShl),l_iAtomShl)
            If (irc.ne.0) Then
               Write(LuPri,'(A,A,I8)')
     &         SecNam,': Cho_SetAtomShl returned code',irc
               irc=1
               Go To 1 ! flush memory and return
            End If
         End If
      End If
      Call dCopy_(4*nSection,TimSec_Bak,1,Timsec,1)
      Call dCopy_(2*nInteg,tInteg_Bak,1,tInteg,1)
      Call dCopy_(2*nDecom,tDecom_Bak,1,tDecom,1)
      Call dCopy_(2*nMisc,tMisc_Bak,1,tMisc,1)
      Trace_Idle=Trace_Idle_Bak
      Cho_UseAbs=Cho_UseAbs_Bak
      Cho_DiaChk=Cho_DiaChk_Bak
      Cho_Fake_Par=Cho_Fake_Par_Bak
      Cho_SimP=Cho_SimP_Bak
      Cho_ReOrd=Cho_ReOrd_Bak
      ChkOnly=ChkOnly_Bak
      Cho_IntChk=Cho_IntChk_Bak
      Cho_MinChk=Cho_MinChk_Bak
      Cho_TrcNeg=Cho_TrcNeg_Bak
      Cho_TstScreen=Cho_TstScreen_Bak
      RstDia=RstDia_Bak
      RstCho=RstCho_Bak
      Mode_Screen=Mode_Screen_Bak
      Cho_DecAlg_Def=Cho_DecAlg_Def_Bak
      ModRst=ModRst_Bak
      N_Subtr=N_Subtr_Bak
      Did_DecDrv=Did_DecDrv_Bak
      HaltIt=HaltIt_Bak
      Tol_DiaChk=Tol_DiaChk_Bak
      Cho_1Center=Cho_1Center_Bak
      Cho_No2Center=Cho_No2Center_Bak
      Cho_PreScreen=Cho_PreScreen_Bak
      Thr_PreScreen=Thr_PreScreen_Bak
      ThrDiag=ThrDiag_Bak
      ScDiag=ScDiag_Bak
      MinQual=MinQual_Bak
      MaxQual=MaxQual_Bak
      N1_Qual=N1_Qual_Bak
      N2_Qual=N2_Qual_Bak
      N1_VecRd=N1_VecRd_Bak
      N2_VecRd=N2_VecRd_Bak
      MxShPr=MxShPr_Bak
      iAlQua=iAlQua_Bak
      Cho_IOVec=Cho_IOVec_Bak
      Frac_ChVBuf=Frac_ChVBuf_Bak
      Cho_SScreen=Cho_SScreen_Bak
      SStau=SStau_Bak
      Cho_SimRI=Cho_SimRI_Bak
      Thr_SimRI=Thr_SimRI_Bak
      Cho_DecAlg=Cho_DecAlg_Bak
      BlockSize=BlockSize_Bak
      iPrint=iPrint_Bak
      Cho_IOVec=Cho_IOVec_Bak
      N1_VecRd=N1_VecRd_Bak
      N2_VecRd=N2_VecRd_Bak
      nSys_Call=nSys_Call_Bak
      nDGM_Call=nDGM_Call_Bak
      ! Allocate memory for extracting integral columns directly in
      ! reduced set from Seward. Set Seward interface to 3 (to treat
      ! columns shell pair-wise).
      IFCSEW=3
      l_iShP2RS=2*Mx2Sh
      l_iShP2Q=l_iShP2RS
      Call GetMem('ShP2RS','Allo','Inte',ip_iShP2RS,l_iShP2RS)
      Call GetMem('ShP2Q','Allo','Inte',ip_iShP2Q,l_iShP2Q)
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(tC1,tW1)
         Call Cho_PrtTim('Cholesky reinitialization',tC1,tC0,tW1,tW0,2)
      End If
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem(SecNam//': After re-init')
#endif

      ! Get Z vectors in core
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(tC0,tW0)
      End If
      l_NVT=nSym
      Call GetMem('TotV','Allo','Inte',ip_NVT,l_NVT)
      Call Cho_X_GetTotV(iWork(ip_NVT),l_NVT)
      Call Cho_ZMem(irc,l_Z,iWork(ip_NVT),l_NVT,iPrint.ge.Inf_Timing,
     &              .True.)
      If (irc.ne.0) Then
         Write(LuPri,'(A,A,I6)')
     &   SecNam,': Cho_ZMem returned code',irc
         If (irc.eq.999) Then
            If (iPrint.lt.Inf_Timing) Then
               Call Cho_ZMem(irc,l_Z,iWork(ip_NVT),l_NVT,.True.,.False.)
            End If
            Call GetMem('ZMax','Max ','Real',ip_Z,l_Z)
            Call Cho_Word2Byte(l_Z,8,Byte,Unt)
            Write(LuPri,'(A,I12,A,F7.3,1X,A,A)')
     &      'Largest available memory block:',l_Z,' words (',
     &      Byte,Unt,')'
            Write(LuPri,'(A)')
     &      '=> INSUFFICIENT MEMORY FOR STORING Z VECTORS!'
            Write(LuPri,'(/,A,/,A)')
     &      'You have the following options:',
     &      '(a) Increase available memory (MOLCAS_MEM),'
            Write(LuPri,'(A)')
     &      'and/or'
            Write(LuPri,'(A,/,A,A,/,A,/,A,/,A,/,A)')
     &      '(b) -SERIAL EXECUTION:',
     &      '       Use the serial two-step algorithm by specifying ',
     &      'the keywords',
     &      '          ChoInput',
     &      '          TwoStep',
     &      '          EndChoInput',
     &      '       in Seward input.'
            Write(LuPri,'(A,/,A,A,/,A,/,A,/,A,/,A,/,A)')
     &      '    -PARALLEL EXECUTION:',
     &      '       Use the parallel one-step algorithm by specifying ',
     &      'the keywords',
     &      '          ChoInput',
     &      '          OneStep',
     &      '          Parallel',
     &      '          EndChoInput',
     &      '       in Seward input.'
            Call Cho_Quit(SecNam//': Insufficient memory for Z vectors',
     &                    101)
         End If
         irc=1
         Go To 1 ! flush memory and return
      End If
      Call GetMem('Z','Allo','Real',ip_Z,l_Z)
      l_nBlock=nSym
      Call GetMem('nBlock','Allo','Inte',ip_nBlock,l_nBlock)
      nB_Max=0
      Do iSym=1,nSym
         nB=(NVT(iSym)-1)/BlockSize+1
         nB_Max=max(nB_Max,nB)
         iWork(ip_nBlock-1+iSym)=nB
      End Do
      l_nVBlock=nB_Max*nSym
      l_iV1Block=nB_Max*nSym
      Call GetMem('nVBlock','Allo','Inte',ip_nVBlock,l_nVBlock)
      Call GetMem('iV1Block','Allo','Inte',ip_iV1Block,l_iV1Block)
      Call iZero(iWork(ip_nVBlock),l_nVBlock)
      Call iZero(iWork(ip_iV1Block),l_iV1Block)
      Do iSym=1,nSym
         i1=1
         Do iBlock=1,nBlock(iSym)-1
            iWork(ip_nVBlock-1+nB_Max*(iSym-1)+iBlock)=BlockSize
            iWork(ip_iV1Block-1+nB_Max*(iSym-1)+iBlock)=i1
            i1=i1+BlockSize
         End Do
         iWork(ip_nVBlock-1+nB_Max*(iSym-1)+nBlock(iSym))=NVT(iSym)
     &                                       -BlockSize*(nBlock(iSym)-1)
         iWork(ip_iV1Block-1+nB_Max*(iSym-1)+nBlock(iSym))=i1
      End Do
      nnBlock=nB_Max*(nB_Max+1)/2
      l_ZBlock=nnBlock*nSym
      Call GetMem('ZBlock','Allo','Inte',ip_ZBlock,l_ZBlock)
      Call iZero(iWork(ip_ZBlock),l_ZBlock)
      n=ip_Z
      Do iSym=1,nSym
         Do jBlock=1,nBlock(iSym)
            nj=iWork(ip_nVBlock-1+nB_Max*(iSym-1)+jBlock)
            ijBlock=iTri(jBlock,jBlock)
            iWork(ip_ZBlock-1+nnBlock*(iSym-1)+ijBlock)=n
            n=n+nj*(nj+1)/2
            Do iBlock=jBlock+1,nBlock(iSym)
               ni=iWork(ip_nVBlock-1+nB_Max*(iSym-1)+iBlock)
               ijBlock=iTri(iBlock,jBlock)
               iWork(ip_ZBlock-1+nnBlock*(iSym-1)+ijBlock)=n
               n=n+ni*nj
            End Do
         End Do
      End Do
      Call Cho_GetZ(irc,
     &              iWork(ip_NVT),l_NVT,
     &              iWork(ip_nBlock),l_nBlock,
     &              iWork(ip_nVBlock),nB_Max,nSym,
     &              iWork(ip_iV1Block),nB_Max,nSym,
     &              iWork(ip_ZBlock),nnBlock,nSym)
      If (irc .ne. 0) Then
         Write(LuPri,*) SecNam,': Cho_GetZ returned code ',irc
         irc = 1
         Go To 1 ! flush memory and return
      End If
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(tC1,tW1)
         Call Cho_PrtTim('Cholesky Z vector fetching',tC1,tC0,tW1,tW0,
     &                   2)
      End If
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem(SecNam//': After GetZ')
#endif

      ! Perform second step: calculation of Cholesky vectors from Z
      ! vectors and integrals.
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(tC0,tW0)
      End If
      Free_Z=.True. ! let Cho_X_CompVec deallocate Z array
      Call Cho_X_CompVec(irc,
     &                   iWork(ip_NVT),l_NVT,
     &                   iWork(ip_nBlock),l_nBlock,
     &                   iWork(ip_nVBlock),nB_Max,nSym,
     &                   iWork(ip_iV1Block),nB_Max,nSym,
     &                   iWork(ip_ZBlock),nnBlock,nSym,
     &                   Free_Z)
      If (irc .ne. 0) Then
         Write(LuPri,*) SecNam,': Cho_X_CompVec returned code ',irc
         irc = 1
         Go To 1 ! flush memory and return
      End If
      ! Write restart files
      Call Cho_PTS_WrRst(irc,iWork(ip_NVT),l_NVT)
      If (irc .ne. 0) Then
         Write(LuPri,*) SecNam,': Cho_PTS_WrRst returned code ',irc
         irc = 1
         Go To 1 ! flush memory and return
      End If
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(tC1,tW1)
         Call Cho_PrtTim('Cholesky vector generation',tC1,tC0,tW1,tW0,
     &                   2)
      End If

      ! Final timing of decomposition section
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(2,iSec),TimSec(4,iSec))
         Call Cho_PrtTim('Cholesky decomposition',
     &                   TimSec(2,iSec),TimSec(1,iSec),
     &                   TimSec(4,iSec),TimSec(3,iSec),
     &                   1)
      End If

      ! time as "decomposition driver"
      Call Cho_Timer(C1,W1)
      tDecDrv(1)=C1-C0
      tDecDrv(2)=W1-W0
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem(SecNam//': After 2nd step.')
#endif

C     Check diagonal.
C     ===============

      iSec=4
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(1,iSec),TimSec(3,iSec))
         Write(LuPri,'(/,A)')
     &   '***** Starting Cholesky diagonal check *****'
         Call Cho_Flush(LuPri)
      End If
      l_Err=4
      Call GetMem('DiaErr','Allo','Real',ip_Err,l_Err)
      iPrint_Bak=iPrint
      If (iPrint.lt.Inf_Pass) Then
         iPrint=-99999999 ! suppress printing in Cho_X_CheckDiag
      End If
      Call Cho_X_CheckDiag(irc,Work(ip_Err))
      iPrint=iPrint_Bak
      If (irc .ne. 0) Then
         Write(LuPri,*) SecNam,': Cho_X_CheckDiag returned code ',irc
         irc = 1
         Go To 1 ! flush memory and return
      End If
      If (Work(ip_Err+1) .gt. ThrCom) Then
         Write(LuPri,'(/,A)')
     &   'Cholesky decomposition failed!'
         Write(LuPri,'(3X,A,1P,D15.6)')
     &   'Largest integral diagonal..',Work(ip_Err+1)
         Write(LuPri,'(3X,A,1P,D15.6)')
     &   'Decomposition threshold....',ThrCom
         irc=1
         Go To 1 ! flush memory and return
      End If
      Call GetMem('DiaErr','Free','Real',ip_Err,l_Err)
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(2,iSec),TimSec(4,iSec))
         Call Cho_PrtTim('Cholesky diagonal check',
     &                   TimSec(2,iSec),TimSec(1,iSec),
     &                   TimSec(4,iSec),TimSec(3,iSec),
     &                   1)
      End If
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem(SecNam//': After diagonal check.')
#endif

C     Finalization.
C     =============

      iSec=8
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(1,iSec),TimSec(3,iSec))
         Write(LuPri,'(/,A)')
     &   '***** Starting Cholesky finalization *****'
         Call Cho_Flush(LuPri)
      End If
      Call Cho_TrcIdl_Final()
      Call Cho_PTS_Final(iWork(ip_NVT),l_NVT)
      If (iPrint .ge. Inf_Timing) Then
         Call Cho_Timer(TimSec(2,iSec),TimSec(4,iSec))
         Call Cho_PrtTim('Cholesky finalization',
     &                   TimSec(2,iSec),TimSec(1,iSec),
     &                   TimSec(4,iSec),TimSec(3,iSec),
     &                   1)
      End If
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem(SecNam//': After finalization')
#endif

C     Statistics.
C     ===========

      If (iPrint. ge. 1) Then
         iSec = 9
         If (iPrint .ge. Inf_Timing) Then
            Call Cho_Timer(TimSec(1,iSec),TimSec(3,iSec))
            Write(LuPri,'(/,A)')
     &      '***** Starting Cholesky statistics *****'
            Call Cho_Flush(LUPRI)
         End If
         Call Cho_PTS_Stat()
         Call Cho_GASync()
         If (iPrint .ge. Inf_Timing) Then
            Call Cho_Timer(TimSec(2,iSec),TimSec(4,iSec))
            Call Cho_PrtTim('Cholesky statistics',
     &                      TimSec(2,iSec),TimSec(1,iSec),
     &                      TimSec(4,iSec),TimSec(3,iSec),
     &                      1)
         End If
      End If
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem(SecNam//': After statistics')
#endif

C     Wrap it up and return.
C     ======================

      ! Close vector and restart files
      Call Cho_OpenVR(2,2)

      ! error termination point
    1 Continue
      ! flush memory
      If (Abs(DumTst-Work(ip_Start)) .gt. DumTol) Then
         Write(LuPri,*) SecNam,': memory has been out of bounds [2]'
         irc=2
      End If
      Call GetMem('DrvDum','Flus','Real',ip_Start,l_Start)
      Call GetMem('DrvDum','Free','Real',ip_Start,l_Start)

      ! Print total timing
      If (iPrint.ge.Inf_Timing .and. irc.eq.0) Then
         Call Cho_Timer(tCPU1,tWall1)
         Call Cho_PrtTim('Cholesky Procedure',tCPU1,tCPU0,
     &                   tWall1,tWall0,1)
      End If

      Call Cho_Flush(LuPri)
#if defined (_DEBUGPRINT_)
      Call Cho_PrtMaxMem('End of '//SecNam)
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fetch_neq(nneq,neq,nexch)

use Definitions, only: iwp, u5, u6

implicit none
integer(kind=iwp), intent(inout) :: nneq, neq(nneq), nexch(nneq)
integer(kind=iwp) :: i, istatus, LineNr
logical(kind=iwp) :: ab_initio_all
character(len=72) :: LINE

#include "macros.fh"

#ifdef _DEBUGPRINT_
write(u6,'(A)') 'Enter fetch_neq'
write(u6,'(A,i3)') 'fetch_neq:  nneq=',nneq
#endif

neq = 0
nexch = 0
!=========== End of default settings====================================
rewind(u5)
do
  read(u5,'(A72)',iostat=istatus) LINE
  if (istatus < 0) then
    call Error(2)
#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'Exit fetch_neq'
#   endif
    return
  end if
# ifdef _DEBUGPRINT_
  write(u6,'(A)') LINE
# endif
  call NORMAL(LINE)
  if (LINE(1:5) == '&POLY') exit
end do
LINENR = 0

do
  call xFlush(u6)
  read(u5,'(A72)',iostat=istatus) LINE
  if (istatus < 0) then
    call Error(2)
    exit
  end if
  LINENR = LINENR+1
  call NORMAL(LINE)
  if ((LINE(1:1) == '*') .or. (LINE == ' ')) cycle
  if (LINE(1:3) == 'END') exit

  if (LINE(1:4) == 'NNEQ') then
    ! number of non-equivalent centers; type of all centers
    read(u5,*,iostat=istatus) NNEQ,ab_initio_all
    if (istatus /= 0) then
      call Error(1)
      exit
    end if
    unused_var(ab_initio_all)
#   ifdef _DEBUGPRINT_
    write(u6,'(A,i4,A,L2)') 'NNEQ=',NNEQ,' ab_initio_all=',ab_initio_all
#   endif
    ! number of equivalent centers of type "i"
    read(u5,*,iostat=istatus) (NEQ(i),i=1,Nneq)
    if (istatus /= 0) then
      call Error(1)
      exit
    end if
#   ifdef _DEBUGPRINT_
    write(u6,'(A,100I4)') 'NEQ(I)=',(NEQ(i),i=1,nneq)
#   endif
    ! number of RASSI wf for exchange
    read(u5,*,iostat=istatus) (Nexch(i),i=1,Nneq)
    if (istatus /= 0) then
      call Error(1)
      exit
    end if
#   ifdef _DEBUGPRINT_
    write(u6,'(A,100I4)') 'NExch(I)=',(NExch(i),i=1,nneq)
#   endif
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,'(A)') 'Exit fetch_neq'
#endif

return

contains

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  select case (code)
    case (1)
      write(u6,*) ' FETCH_NEQ: Error reading "poly_aniso.input" '
      write(u6,*) ' near line nr.',LINENR+1
    case (2)
      write(u6,*) ' FETCH_NEQ: Unexpected End of input file.'
  end select

end subroutine Error

end subroutine fetch_neq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Exp1 (A,B,dimi,dim2,dime)
c
c       this routine do:
c       expand A(i,pq) -> B(i,p,q)
c       for matrices, where A(i,pq)=A(i,qp)
c
c       parameter description:
c       A       - input matrix (I)
c       B       - outpun matrix (O)
c       dimi    - first dimension in A,B (I)
c       dim2    - # of pq (I)
c       dimf    - # of p (also q) (I)
c
        implicit none
        integer dimi,dim2,dime
        real*8 A(1:dimi,1:dim2)
        real*8 B(1:dimi,1:dime,1:dime)
c
c       help variables
        integer i,p,q,pq
c
        pq=0
        do p=1,dime
        do q=1,p
        pq=pq+1
c
          do i=1,dimi
            B(i,p,q)=A(i,pq)
          end do
c
          do i=1,dimi
            B(i,q,p)=A(i,pq)
          end do
c
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Ben Swerts                                             *
*               2016, Liviu Ungur                                      *
************************************************************************
      Subroutine FragPMmG(nHer,MemFrag,la,lb,lr)
************************************************************************
*  Object: to compute the number of real*8 the kernal routine will     *
*          need for the computation of a matrix element between two    *
*          cartesian Gaussin functions with the total angular momentum *
*          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
*          lr is the order of the operator (this is only used when the *
*          integrals are computed with the Hermite-Gauss quadrature).  *
*                                                                      *
*  Called from: OneEl_g                                                *
*                                                                      *
*  author: Ben Swerts                                                  *
*  modified: Liviu Ungur                                               *
*  based on PrjMmG                                                     *
*                                                                      *
************************************************************************
      Use Basis_Info
      Implicit None
      Integer nHer,MemFrag,la,lb,lr
      Integer i,nElem,nOrder,maxDensSize
      Integer iCnttp,jCnttp,iAng,jAng,iShll,jShll
      Integer ip,nac,ncb, nExpi, nExpj
      Integer nBasisi, nBasisj
*
      nElem(i) = (i+1)*(i+2)/2
*
      nOrder = 0
      MemFrag = 0
      maxDensSize = 0
c  largest possible fragment energy weighted density matrix
      Do iCnttp = 1, nCnttp
        If(dbsc(iCnttp)%nFragType.gt.0)
     &  maxDensSize = Max( maxDensSize,
     &                     dbsc(iCnttp)%nFragDens
     &                   *(dbsc(iCnttp)%nFragDens+1)/2 )
      End Do
c
      Do iCnttp = 1, nCnttp
      If (.Not.dbsc(iCnttp)%Frag) cycle  ! Go To 1960
*
         Do iAng = 0, dbsc(iCnttp)%nVal-1
         iShll = dbsc(iCnttp)%iVal + iAng
         nExpi=Shells(iShll)%nExp
         nBasisi=Shells(iShll)%nBasis
         If (nExpi.eq.0 .or. nBasisi.eq.0) cycle !Go To 1966
*
            Do jCnttp = iCnttp, nCnttp
* still figure out how to loop only over the centers belonging to the
* same fragment (keep track of mdc?) ! still to be done !!!
            If (.Not.dbsc(jCnttp)%Frag) cycle !Go To 1970
*
               Do jAng = 0, dbsc(jCnttp)%nVal-1
               jShll = dbsc(jCnttp)%iVal + jAng
               nExpj=Shells(jShll)%nExp
               nBasisj=Shells(jShll)%nBasis
               If (nExpj.eq.0 .or. nBasisj.eq.0) cycle
!              Go To 1976
*
               ip =  2 * maxDensSize
              nac =  4 * nElem(la) * nElem(iAng)
               ip = ip + nExpi * nac
               ip = ip + 3 * nExpi
               ip = ip + nExpi
               ip = ip + nExpi
               ip = ip + nExpi
             nHer = ((la+1)+iAng+2)/2
           nOrder = Max(nHer,nOrder)
               ip = ip + nExpi * 3 * nHer * (la+2)
               ip = ip + nExpi * 3 * nHer * (iAng+1)
               ip = ip + nExpi * 3 * nHer * (lr+1)
               ip = ip + nExpi * 3 * nHer * (la+2)*(iAng+1)*(lr+1)
               ip = ip + nExpi
*
          MemFrag = Max(MemFrag,ip)
               ip = ip - nExpi
     &            * (6 + 3*nHer*((la+2) + (iAng+1) + (lr+1)
     &            + (la+2)*(iAng+1)*(lr+1)) + 1)
*
              ncb = 4*nElem(jAng)*nElem(lb)
               ip = ip + nExpj*ncb
               ip = ip + 3 * nExpj
               ip = ip + nExpj
               ip = ip + nExpj
               ip = ip + nExpj
             nHer = ((lb+1)+jAng+2)/2
           nOrder = Max(nHer,nOrder)
               ip = ip + nExpj*3*nHer*(lb+2)
               ip = ip + nExpj*3*nHer*(jAng+1)
               ip = ip + nExpj*3*nHer*(lr+1)
               ip = ip + nExpj*3*nHer*(lb+2)*(jAng+1)*(lr+1)
               ip = ip + nExpj
*
          MemFrag = Max(MemFrag,ip)
               ip = ip - nExpj
     &            * (6 + 3*nHer*((lb+2) + (jAng+1) + (lr+1)
     &            +  (lb+2)*(jAng+1)*(lr+1)) + 1)
*
               ip = ip + Max(Max(nExpi,nBasisj)*nac,
     &                      ncb*nBasisj)
          MemFrag = Max(MemFrag,ip)
*
c 1976          Continue
               Enddo  !jAng

c 1970       Continue
            Enddo  !jCnttp

c 1966    Continue
         Enddo !iAng

c 1960 Continue
      Enddo ! iCnttp
      nHer = nOrder
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PolRas(Dist,DistIm,DT,FI,FP,Fil,iCStart,iTriState,VMat,Smat,DiFac,Ract,icnum,Energy,NVarv,STC,Haveri,iQ_Atoms,ExpVal, &
                  Poli)

use qmstat_global, only: ChaNuc, CT, dCIRef, HmatSOld, HmatState, iCIInd, iExtr_Eig, lCiSelect, lExtr, nCent, nCIRef, nEqState, &
                         nPart, nPol, nState, qTot, xyzMyI, xyzMyP, xyzMyQ, xyzQuQ
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms, iCStart, iTriState, icnum
real(kind=wp), intent(in) :: Dist(nCent,nCent,nTri_Elem(nPart-icnum-1)), DistIm(nCent,nPart-icnum,nCent,nPart-icnum), &
                             FP(3,nPol*nPart), Fil(nPol*nPart,3,nTri_Elem(iQ_Atoms),10), VMat(iTriState), Smat(iTriState), DiFac, &
                             Ract
real(kind=wp), intent(inout) :: DT(3,nPol*nPart), Energy
real(kind=wp), intent(out) :: FI(3,nPol*nPart), STC(nState,nState), ExpVal(4,nState), Poli(nTri_Elem(iQ_Atoms),10)
integer(kind=iwp), intent(out) :: NVarv
logical(kind=iwp), intent(out) :: Haveri
integer(kind=iwp) :: iDum, iErr, nFound, nPolCent, nQMCent
real(kind=wp) :: Dummy, Egun, PolFac, R2inv, Rinv
logical(kind=iwp) :: JaNej
real(kind=wp), allocatable :: EEigen(:), FFp(:,:), Gri(:,:), RoMatSt(:), rr3(:,:), Scratch(:,:), VpolMat(:), xx(:,:), xxi(:,:), &
                              yy(:,:), yyi(:,:), zz(:,:), zzi(:,:)

! Allocate and initialize the eigenvector matrix with the unit matrix.

STC(:,:) = Zero
call dcopy_(nState,[One],0,STC,nState+1)

! Define some numbers.

nQMCent = nTri_Elem(iQ_Atoms)
nPolCent = nPart*nPol
Rinv = One/Ract
R2inv = Rinv**2
PolFac = DiFac/Ract**3
Egun = Zero

! Compute distances and vectors needed for solving the polarization
! equations. Observe the use of a memory allocator before the call
! to polprep. This is to conserve memory but without having to
! rewrite the entire polprep routine (written originally with
! static allocations). A future project is to rewrite polprep.

call mma_allocate(xx,nPolCent,nPolCent,label='xx')
call mma_allocate(yy,nPolCent,nPolCent,label='yy')
call mma_allocate(zz,nPolCent,nPolCent,label='zz')
call mma_allocate(xxi,nPolCent,nPolCent,label='ixx')
call mma_allocate(yyi,nPolCent,nPolCent,label='iyy')
call mma_allocate(zzi,nPolCent,nPolCent,label='izz')
call mma_allocate(rr3,nPolCent,nPolCent,label='irr3')
call mma_allocate(Gri,nPolCent,nPolCent,label='iGri')
xx(:,:) = Zero
yy(:,:) = Zero
zz(:,:) = Zero
xxi(:,:) = Zero
yyi(:,:) = Zero
zzi(:,:) = Zero
rr3(:,:) = Zero
Gri(:,:) = Zero
call PolPrep(Dist,DistIm,xx,yy,zz,rr3,xxi,yyi,zzi,Gri,iCNum,nPolCent)

! Polarization loop commencing.

call mma_allocate(FFp,nPolCent,3,label='FFp')
call mma_allocate(RoMatSt,nTri_Elem(nState),label='RoMatSt')
call mma_allocate(VpolMat,nTri_Elem(nState),label='VpolMat')
call mma_allocate(EEigen,nState,label='EEigen')
NVarv = 0
do
  NVarv = NVarv+1
  Energy = Zero
  call PolSolv(DT,FI,FP,xx,yy,zz,rr3,xxi,yyi,zzi,Gri,FFp,iCNum,r2Inv,DiFac,nPolCent)
  call DensiSt(RomatSt,STC,nEqState,nState,nState)
  call Polins(Energy,nPolCent,nQMCent,Fil,VpolMat,FFp,PolFac,poli,xyzMyQ,xyzMyI,xyzMyP,iCstart,iQ_Atoms,qTot,ChaNuc,RoMatSt, &
              xyzQuQ,CT)

  ! Assemble the Hamiltonian matrix.

  HmatState(:) = HmatSOld+Vmat+VpolMat+SMat
  Energy = Half*Energy

  ! Diagonalize the bastard. Eigenvalues are sorted and the relevant eigenvalue is added to total energy.

  call mma_allocate(Scratch,nState,nState,label='Scratch')
  call Diag_Driver('V','A','L',nState,HMatState,Scratch,nState,Dummy,Dummy,iDum,iDum,EEigen,STC,nState,1,-1,'J',nFound,iErr)
  if (lCiSelect) call CiSelector(nEqState,nState,STC,nCIRef,iCIInd,dCIRef)
  Energy = Energy+EEigen(nEqState)
  call mma_deallocate(Scratch)

  ! Check if polarization loop has converged.

  call HaveWeConv(iCNum,iCStart,iQ_Atoms,nPolCent,DT,FFp,xyzMyI,Egun,Energy,NVarv,JaNej,Haveri)
  if (Haveri .or. JaNej) exit
end do

! Deallocate.

call mma_deallocate(FFp)
call mma_deallocate(RoMatSt)
call mma_deallocate(VpolMat)
call mma_deallocate(EEigen)
call mma_deallocate(xx)
call mma_deallocate(yy)
call mma_deallocate(zz)
call mma_deallocate(xxi)
call mma_deallocate(yyi)
call mma_deallocate(zzi)
call mma_deallocate(rr3)
call mma_deallocate(Gri)

! If expectation values are extracted, make a detour.

if (lExtr(6)) call Expectus('RASSI',HmatSOld,Vmat,VpolMat,Smat,STC,nState,lExtr(4),iExtr_Eig,ExpVal)

! Is it dead? It's terminated!

return

end subroutine PolRas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Cavitation(DoDeriv,ToAng,nAt,nS,nTs,GCavP,VMol,TAbs,
     &                      TCE,RSolv,Sphere,Tessera,iSphe)
      Implicit Real*8 (A-H,O-Z)
      Logical DoDeriv
C
C     Compute cavitation energy given the cavity.
C
#include "WrkSpc.fh"
      Dimension Sphere(4,*),Tessera(4,*),iSphe(*)
*
      Call GetMem('CavSph'  ,'Allo','Real',ip_CavS,nS      )
      Call GetMem('dCav'    ,'Allo','Real',ip_dCav,3*nAt   )
      Call GetMem('ExpArea' ,'Allo','Real',ip_EA  ,nS      )
      Call GetMem('dExpArea','Allo','Real',ip_dEA ,3*nAt*nS)
      Call FZero(Work(ip_CavS),nS)
      Call FZero(Work(ip_dCav),3*nAt)
      Call FZero(Work(ip_EA),nS)
      Call FZero(Work(ip_dEA),3*nAt*nS)
*
*     Put some quantity in Angstrom
      Call DScal_(nS,ToAng,Sphere(4,1),4)
      Call DScal_(nTs,ToAng*ToAng,Tessera(4,1),4)
*
*     Compute the exposed area for each sphere
      Do iTs = 1, nTs
        iS = iSphe(iTs)
        Work(ip_EA-1+iS) = Work(ip_EA-1+iS) + Tessera(4,iTs)
      End Do
*
      Call Cavitation_(nAt,nS,VMol,TAbs,TCE,RSolv,GCavP,Work(ip_CavS),
     &                 Work(ip_dCav),Sphere,Work(ip_EA),Work(ip_dEA),
     &                 DoDeriv)
*
*     Revert to a.u.
      ToAU = 1.0d0 / ToAng
      Call DScal_(nS,ToAU,Sphere(4,1),4)
      Call DScal_(nTs,ToAU*ToAU,Tessera(4,1),4)
*
      Call GetMem('dExpArea','Free','Real',ip_dEA ,3*nAt*nS)
      Call GetMem('ExpArea' ,'Free','Real',ip_EA  ,nS      )
      Call GetMem('dCav'    ,'Free','Real',ip_dCav,3*nAt   )
      Call GetMem('CavSph'  ,'Free','Real',ip_CavS,nS      )
*
      Return
      End
      Subroutine Cavitation_(NAtoms,NSph,VMol,TAbs,TCE,RSolv,
     $  GCavP,PCvSph,dCav,Sphere,Ae,dAe,DoDeriv)
      Implicit Real*8 (A-H,O-Z)
      Logical DoDeriv
C
C     Compute cavitation energy given the cavity.
C
      Real*8 Sphere(4,*),Ae(*),dAe(3,NAtoms,*),PCvSph(*),dCav(3,*)
C     Save Zero,One,Two,Three,Four,F4Pt5,F1000,GC,Avgdr,CEKM
      Save Zero,One,Two,Three,Four,F4Pt5,F1000,GC,Avgdr
      Data Zero,One,Two,Three,Four,F4Pt5,F1000/0.0d0,1.0d0,2.0d0,3.0d0,
     $  4.0d0,4.5d0,1.0d3/
C     Data GC,Avgdr,CEKM/1.9865d0,0.60228d0,0.0014389d0/
      Data GC,Avgdr/1.9865d0,0.60228d0/
C
      PI     = Four * ATan(One)
      TPI    = Two  * PI
      FPI    = Two  * TPI
      DiSolv = Two  * RSolv
C
C     Cavitation Energy:  R.A. Pierotti, Chem.Rev. 76,717,(1976).
C
C     The cavitation energy is now computed for each sphere of the
C     cavity. The values are scaled for the exposed surface of each
C     sphere and summed irrespective of the number of cavities.
C     The derivative of the cavitation energy wrt nuclear coordinates
C     is also computed. To this end the Pierotti cavitation energy for
C     each sphere is stored in the array PCvSph(ISph).
C
      DENum = Avgdr/VMol
      RT    = GC*TAbs/F1000
      YP    = DENum*FPI*RSolv**3/Three
      YM    = YP/(One-YP)
      DYP   = -TCE*YP
      DYM   = -TCE*YM/(One-YP)
C
C     Loop on spheres.
C
      GCavP = Zero
      Do 50 ISph = 1, NSph
        RSph = Sphere(4,ISph)
        R    = RSph/RSolv
        DR   = TCE*R/Three
C
C       Pierotti's cavitation free energy for the single sphere.
C
        G = -log(One-YP) + F4Pt5*YM**2*R**2 + Three*YM*R*(R+One)
        G = RT*G
        PCvSph(ISph) = G
        AExpsd = Ae(ISph)
        ATotal = FPI*RSph*RSph
        Frac   = AExpsd/ATotal
        GCavP  = GCavP + G*Frac
   50 Continue
C
C     Computation of derivatives wrt nuclear coordinates according to
C     the modification of Claverie to the Pierotti approach.
C
C     Loop on atoms, coordinates, tesserae and then spheres.
C
      If(DoDeriv) Then
        Do 70 ISph = 1, NSph
          RSph = Sphere(4,ISph)
          Fact = PCvSph(ISph) / ( FPI * RSph * RSph )
          Do 80 IAtom = 1, NAtoms
            Do 90 Ixyz = 1, 3
              dCav(Ixyz,IAtom) =
     $          dCav(Ixyz,IAtom) + Fact*dAe(Ixyz,IAtom,ISph)
   90       Continue
   80     Continue
   70   Continue
      EndIf
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SG_CXInit(SGS,CIS,EXS)

use sguga, only: CIStruct, EXStruct, MkCoup, MkSeg, NrCoup, SGStruct
use stdalloc, only: mma_deallocate

implicit none
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(out) :: CIS
type(EXStruct), intent(out) :: EXS

CIS%nMidV = SGS%MVEnd-SGS%MVSta+1
CIS%nIpWlk = 1+(SGS%MidLev-1)/15
CIS%nIpWlk = max(CIS%nIpWlk,1+(SGS%nLev-SGS%MidLev-1)/15)

! Calculate segment values, and MVL and MVR tables:

call MkSeg(SGS,CIS,EXS)

! Various offset tables:

call NrCoup(SGS,CIS,EXS)

! Computed in NrCoup:

call MkCoup(SGS,CIS,EXS)

call mma_deallocate(CIS%ISgm)
call mma_deallocate(CIS%VSgm)
call mma_deallocate(CIS%IVR)

end subroutine SG_CXInit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine FckAcc_NoSym(iCmp,jCmp,kCmp,lCmp,Shijij,iShell,nijkl,AOInt,FMat,DMat,nDens,iAO,iAOst,iBas,jBas,kBas,lBas,ExFac)
!***********************************************************************
!                                                                      *
!  Object: to accumulate contributions from the AO integrals directly  *
!          to the symmetry adapted Fock matrix.                        *
!                                                                      *
!          The indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!          In addition to this complication we have that the order of  *
!          indices in the integrals are not ordered canonically but    *
!          rather in an order such that the contraction step will be   *
!          optimal. Hence, special care has to be taken when tracing   *
!          the density with the integrals so that both entities have   *
!          the same order.                                             *
!                                                                      *
!          The Fock matrix is computed in lower triangular form.       *
!                                                                      *
!          The density matrix is not folded if the shell indices and   *
!          the angular indices are identical.                          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden. February '93                            *
!***********************************************************************

use Index_Functions, only: iTri
use SOAO_Info, only: iAOtSO
use Gateway_Info, only: CutInt
use Constants, only: Zero, One, Four, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iCmp, jCmp, kCmp, lCmp, iShell(4), nijkl, nDens, iAO(4), iAOst(4), iBas, jBas, kBas, lBas
logical(kind=iwp), intent(in) :: Shijij
real(kind=wp), intent(in) :: AOInt(nijkl,iCmp,jCmp,kCmp,lCmp), DMat(nDens), ExFac
real(kind=wp), intent(inout) :: FMat(nDens)
integer(kind=iwp) :: i, i1, i2, i3, i4, ij, ik, il, iSO, j, jk, jl, jSO, k, kl, kSO, l, lSO, nijkl_
real(kind=wp) :: AOijkl, D_jk, D_jl, D_kl, F_jk, F_jl, F_kl, Fac, Fac_C, Fac_E
logical(kind=iwp) :: Shij, Shkl

!write(u6,*) DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1),DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One,0)
!if (iPrint >= 49) &
!  write(u6,*) ' FckAcc:AOIn',DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1),DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One,0)

! Quadruple loop over elements of the basis functions angular
! description. Loops are reduced to just produce unique SO integrals
! Observe that we will walk through the memory in AOInt in a
! sequential way.

Shij = (iShell(1) == iShell(2))
Shkl = (iShell(3) == iShell(4))

Fac = One
if (Shij) Fac = Fac*Half
if (Shkl) Fac = Fac*Half
if (Shijij) Fac = Fac*Half
Fac_C = Four*Fac
Fac_E = -Fac*ExFac

do i1=1,iCmp
  iSO = iAOtSO(iAO(1)+i1,0)+iAOst(1)
  do i2=1,jCmp
    jSO = iAOtSO(iAO(2)+i2,0)+iAOst(2)
    do i3=1,kCmp
      kSO = iAOtSO(iAO(3)+i3,0)+iAOst(3)
      do i4=1,lCmp
        lSO = iAOtSO(iAO(4)+i4,0)+iAOst(4)

        nijkl_ = 0
        do l=lSO,lSO+lBas-1
          do k=kSO,kSO+kBas-1
            kl = iTri(k,l)
            D_kl = DMat(kl)*Fac_C
            F_kl = Zero

            do j=jSO,jSO+jBas-1
              jk = iTri(j,k)
              jl = iTri(j,l)
              D_jl = DMat(jl)*Fac_E
              D_jk = DMat(jk)*Fac_E
              F_jl = Zero
              F_jk = Zero
              do i=iSO,iSO+iBas-1
                nijkl_ = nijkl_+1
                AOijkl = AOInt(nijkl_,i1,i2,i3,i4)
                if (abs(AOijkl) < CutInt) cycle
                ij = iTri(i,j)
                ik = iTri(i,k)
                il = iTri(i,l)

                FMat(ij) = FMat(ij)+AOijkl*D_kl
                F_kl = F_kl+AOijkl*DMat(ij)

                FMat(ik) = FMat(ik)+AOijkl*D_jl
                F_jl = F_jl+AOijkl*DMat(ik)
                FMat(il) = FMat(il)+AOijkl*D_jk
                F_jk = F_jk+AOijkl*DMat(il)

              end do
              FMat(jl) = FMat(jl)+F_jl*Fac_E
              FMat(jk) = FMat(jk)+F_jk*Fac_E
            end do
            FMat(kl) = FMat(kl)+F_kl*Fac_C
          end do
        end do

      end do
    end do
  end do
end do

end subroutine FckAcc_NoSym

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine setiaprtot_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "malloc_cvb.fh"
      dimension dum1(1), dum2(1)

      k1=mstackr_cvb(nda*ndb)
      call dpci2vb_cvb(w(k1),dum1,dum2,0,dum3,4)
      call setiaprtot2_cvb(w(k1),
     >  iw(ll(11)),iw(ll(12)),iw(ll(13)),iw(ll(14)),npvb,
     >  nda,ndb)
      call mfreer_cvb(k1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Victor P. Vysotskiy                              *
************************************************************************

*  GetMem
*
*> @brief
*>   A simple work space manager, used by all programs in MOLCAS
*> @author Victor P. Vysotskiy
*>
*> @details
*> \p NameIn, \p KeyIn, and \p TypeIn are strings of any size. They are
*> not case sensitive, and only the four first letters matter.
*> If KeyIn is '``allo``' (or '``ALLO``' or ...) then ::GETMEM will return the
*> position of a previously unused piece of workspace, capable of holding
*> at least \p LENGTH items, and register that piece as being in use.
*> If \p TypeIn is '``Real``', the items will be accessible in
*> \c WORK(IPOS) ... ``WORK(IPOS-1+LENGTH)``.
*> If \p TypeIn is '``Inte``', the items will be accessible in
*> \c IWORK(IPOS) ... ``IWORK(IPOS-1+LENGTH)``.
*> If \p TypeIn is '``Sngl``', the items will be accessible in
*> \c SWORK(IPOS) ... ``SWORK(IPOS-1+LENGTH)``.
*> If \p KeyIn is '``Free``', the piece will be returned to the free pool.
*> If \p KeyIn is '``Chec``', the boundaries of all allocated pieces will be
*> checked to see if the contents of guardian words, surrounding each
*> piece, are intact or not.
*> If \p KeyIn is '``List``', the allocated fields will be tabulated.
*> If \p KeyIn is '``Max``', there will be no allocation made, but the length
*> of the largest allocatable field is returned.
*> \p NameIn has no function, except that the user provides a label to the
*> field, which is used in error prints or listings.
*>
*> @note
*> An include file, WrkSpc.fh, declares commons ``/WrkSpc/`` and
*> ``/cWrkSpc/``. The first common contains three arrays,
*> \c WORK, \c SWORK and \c IWORK, which  are equivalenced. The vector, \c CWORK,
*> belongs to the second common.
*> ::GETMEM uses calls to the Molcas's MA memory allocator routines.
*>
*> @param[in]     NameIn Arbitrary label
*> @param[in]     KeyIn  ``Allo`` / ``Free`` / ``Check`` / ``List`` / ``Max``
*> @param[in]     TypeIn ``Real`` / ``Inte`` / ``Char`` / ``Sngl``
*> @param[in,out] iPos   Position
*> @param[in,out] Length Nr of items
************************************************************************
      Subroutine GetMem (NameIn,KeyIn,TypeIn,iPos,Length)
************************************************************************
*                                                                      *
* History: Victor P. Vysotskiy                                         *
*    2012: Native Molcas's Memory Allocator; Thread safety             *
*                                                                      *
************************************************************************

#include "SysCtl.fh"
#include "warnings.fh"
#include "WrkSpc.fh"
#include "mama.fh"
#ifdef _OPENMP
      Include 'omp_lib.h'
#endif
*
*
      Character*(*) NameIn,KeyIn,TypeIn
      Character*8   FldNam,eopr,eoprcc,elbl,etyp
      Character*4   Key,VarTyp
      Integer       c_getmem
      External      c_getmem
#ifdef _GARBLE_
      Character*5   xKey
      Logical       SkipGarble
#endif

*----------------------------------------------------------------------*
*     Initialize the Common / MemCtl / the first time it is referenced *
*----------------------------------------------------------------------*
      If ( MemCtl(ipStat).ne.ON ) then
         Call IniMem()
      End if
*----------------------------------------------------------------------*
*     read default parameters from Common / MemCtl /                   *
*----------------------------------------------------------------------*
      iW=MemCtl(ipSysOut)
      If ( MemCtl(ipTrace).eq.ON ) then
         Write(iW,*) ' <<< Entering GetMem 5.0 >>>'
         Write(iW,'(A,2X,A4)') ' Clear  =      ',MemCtl(ipClear)
         Write(iW,'(A,2X,A4)') ' Key    =    ',KeyIn
         Write(iW,'(A,2X,A4)') ' Name   =    ',NameIn
         Write(iW,'(A,2X,A4)') ' Type   =    ',TypeIn
         Write(iW,'(A,I12)') ' length =    ',Length
         Write(iW,'(A,I12)') ' iPos   =    ',iPos
      End If
*----------------------------------------------------------------------*
*     convert input strings to standard format                         *
*----------------------------------------------------------------------*
      Call StdFmt(NameIn,FldNam)
      Call StdFmt(KeyIn,Key)
      Call StdFmt(TypeIn,VarTyp)
*----------------------------------------------------------------------*
*     prepare passed values to the C char format                       *
*----------------------------------------------------------------------*
      elbl=FldNam
      elbl(8:8)=char(0)
      eopr=Key
      eopr(8:8)=char(0)
      etyp=VarTyp
      etyp(8:8)=char(0)
      eoprcc='CHECK'
      eoprcc(8:8)=char(0)

*----------------------------------------------------------------------*
*     Trace memory                                                     *
*----------------------------------------------------------------------*
      If (MemCtl(ipCheck).eq.ON .or. MemCtl(ipTrace).eq.ON) Then
         iRc=c_getmem(elbl,eoprcc,etyp,ip_iDummy,ip_iDummy)
      End If
#ifdef _GARBLE_
*----------------------------------------------------------------------*
*     Skip garble                                                      *
*----------------------------------------------------------------------*
      Call StdFmt(KeyIn,xKey)
      If ((xKey.eq.'ALLON').or.(xKey.eq.'RGSTN')) Then
        SkipGarble = .True.
      Else
        SkipGarble = .False.
      End If
#endif
*----------------------------------------------------------------------*
*     Allocate new memory                                              *
*----------------------------------------------------------------------*

      If(Key.ne.'ALLO') iPos=iPos-kind2goff(VarTyp)
      iRc=c_getmem(elbl,eopr,etyp,iPos,Length)
      If(iRc.lt.0) Then
        If ( Key.eq.'ALLO' ) Then
          Write (6,'(A)')
     &         'MMA failed to allocate a memory block.'
        Else If ( Key.eq.'FREE' ) Then
          Write (6,'(A)')
     &         'MMA failed to release the memory block for further use.'
          iRc=c_getmem(elbl,eoprcc,etyp,ip_iDummy,ip_iDummy)
        Else
          Write (6,*)
        End If
        Go To 777
      End If

      If ( Key.eq.'ALLO' .or. Key.eq.'LENG'.or.
     > Key.eq.'FLUS'. or. Key.eq.'MAX' .or.
     > Key.eq.'CHEC'.or.Key.eq.'LIST' .or.
     > Key.eq.'RGST') Then
         iPos=iPos+kind2goff(VarTyp)
*----------------------------------------------------------------------*
*     Release a memory block or return length or decrease length       *
*----------------------------------------------------------------------*
      End If

#ifdef _GARBLE_
      If ( Key.eq.'ALLO' .or. Key.eq.'RGST') Then
        If (.not. SkipGarble) Call Garble(iPos,Length,VarTyp)
      End If
#endif

      Return
*
 777  Continue
      Call Quit(_RC_MEMORY_ERROR_)

      End




      function kind2goff(var)
#include "mama.fh"
      character*(4) var
      kind2goff=0
      if(var.eq.'INTE') kind2goff=iofint
      if(var.eq.'REAL') kind2goff=iofdbl
      if(var.eq.'CHAR') kind2goff=iofchr
      if(var.eq.'SNGL') kind2goff=iofsgl
      return
      end

#ifdef _GARBLE_
      subroutine garble(ipos,length,vartyp)
      implicit none
*include "SysDef.fh"
#include "WrkSpc.fh"
      integer :: ipos, length
      character(len=*) :: vartyp
      real*8, parameter ::    dgarbage(1) = [0.730432726d308]
      integer, parameter ::   igarbage(1) = [730432726]
      real*4, parameter ::    sgarbage(1) = [0.730432726e38]
      character, parameter :: cgarbage = 'x'

      integer i

      select case(vartyp)
      case ('REAL')
        call dcopy_(length,dgarbage,0,work(ipos),1)
      case ('INTE')
        call icopy(length,igarbage,0,iwork(ipos),1)
      case ('SNGL')
        call scopy_(length,sgarbage,0,swork(ipos),1)
      case ('CHAR')
*       ndouble = length / rtob
*       call dcopy_(ndouble,dgarbage,0,cwork(ipos),1)
*       do i = ndouble * rtob + 1, length
        do i = 1, length
          cwork(ipos+i-1) = cgarbage
        end do
      end select
      end subroutine
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Jonna Stalring                                   *
!***********************************************************************

subroutine rddj(G1r,G1Q,G2r,iestate)
! Jonna 000411
!
! Reads the one and two electron densities for estate
! and returns them in rectangular and single triangular storage

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: LuJob
use input_mclr, only: iTOC, ntAsh
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: G1r(*), G1Q(*), G2r(*)
integer(kind=iwp), intent(in) :: iestate
integer(kind=iwp) :: i, iB, iDij, iDkl, iIJKL, iR, iRij, iRijkl, iRkl, jB, jDisk, kB, lB, nG1, nG2
real(kind=wp) :: Fact, rdum(1)
real(kind=wp), allocatable :: G2Q(:)

ng1 = nTri_Elem(ntash)
ng2 = nTri_Elem(ng1)

call mma_allocate(G2Q,ng2,Label='G2Q')

! Read one and two el dens for state iestate

iR = iestate
jdisk = itoc(3)
do i=1,iR-1
  call dDaFile(LUJOB,0,rdum,ng1,jDisk)
  call dDaFile(LUJOB,0,rdum,ng1,jDisk)
  call dDaFile(LUJOB,0,rdum,Ng2,jDisk)
  call dDaFile(LUJOB,0,rdum,Ng2,jDisk)
end do
call dDaFile(LUJOB,2,G1q,ng1,jDisk)
call dDaFile(LUJOB,0,rdum,ng1,jDisk)
call dDaFile(LUJOB,2,G2Q,Ng2,jDisk)
call dDaFile(LUJOB,0,rdum,Ng2,jDisk)

! Make one el rectangular and two el singel triang.

do iB=1,ntash
  do jB=1,ntash
    iDij = iTri(ib,jB)
    iRij = jb+(ib-1)*ntash
    do kB=1,ntash
      do lB=1,ntash
        iDkl = iTri(kB,lB)
        iRkl = lb+(kb-1)*ntash
        fact = One
        if ((iDij >= iDkl) .and. (kB == lB)) fact = Two
        if ((iDij < iDkl) .and. (iB == jB)) fact = Two
        iijkl = iTri(iDij,iDkl)
        iRijkl = iTri(iRij,iRkl)
        G2R(iRijkl) = Fact*G2Q(iijkl)
      end do
    end do
  end do
end do
do iB=1,ntash
  do jB=1,ntash
    G1R(iB+(jB-1)*ntash) = G1Q(iTri(iB,jB))
  end do
end do

call mma_deallocate(G2Q)

end subroutine rddj

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine upper_case_cvb(line,lenline)
      implicit real*8 (a-h,o-z)
      character*(*) line

      ichar_Aa=ichar('A')-ichar('a')
      do 100 ich=1,lenline
      if(line(ich:ich).ge.'a'.and.line(ich:ich).le.'z')
     >  line(ich:ich)=char(ichar(line(ich:ich))+ichar_Aa)
100   continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_QUIT(STRING,IERR)
C
C     Purpose: echo message STRING and abort execution.
C
#include "implicit.fh"
      CHARACTER*(*) STRING
#include "cholesky.fh"
      WRITE(LUPRI,'(//,1X,A)') '***'
      IF (IERR.EQ.0 .OR. IERR.EQ.100) THEN
         WRITE(LUPRI,'(1X,A)')
     &   '*** Execution stopped by Cholesky Decomposition Utility'
         WRITE(LUPRI,'(1X,A,A)')
     &   '*** Message: ',STRING
      ELSE
         WRITE(LUPRI,'(1X,A)')    '*** Error in Cholesky Core Routine'
         WRITE(LUPRI,'(1X,A,A)')  '*** Message: ',STRING
         WRITE(LUPRI,'(1X,A,I5)') '*** Code   : ',IERR
      END IF
      WRITE(LUPRI,'(1X,A,//)') '***'
      CALL CHO_TRANSLATEERRORCODE(IERR,MOLCASCODE)
      CALL QUIT(MOLCASCODE)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_CALCINT_4(XINT,LINT,ISHLCD,ISHLAB)
!
! Purpose: calculate qualified integral columns from
!          shell quadruple (ISHLC ISHLD|ISHLA ISHLB).
!
! Version 4: avoid storage of full shell quadruple in interface to
!            seward; get qualified directly as in Version 2 and 3!
!            Changes from Version 3:
!            - only one shell quadruple is computed (not an entire
!              column).

use Cholesky, only: INF_IN2, IPRINT, iSP2F, LuPri, NCOLAB, nSym, TINTEG
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LINT, ISHLCD, ISHLAB
real(kind=wp), intent(inout) :: XINT(LINT)
integer(kind=iwp) :: ILOC, IRC, ISHLA, ISHLB, ISHLC, ISHLD, NAB(8)
real(kind=wp) :: C1, C2, W1, W2
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_MCA_CALCINT_4'

! Set mapping from shell pair AB to qualified columns.
! ----------------------------------------------------

IRC = 0
ILOC = 2
call CHO_SETSHP2Q_2(IRC,ILOC,ISHLAB,NAB)
if (IRC /= 0) then
  write(LUPRI,*) SECNAM,': CHO_SETSHP2Q_2 returned ',IRC
  call CHO_QUIT('Error termination in '//SECNAM,IRC)
end if

! Print.
! ------

if (IPRINT >= INF_IN2) then
  call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)
  call CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.true.)
  NCOLAB = sum(NAB(1:NSYM))
  write(LUPRI,'(/,A,I5,1X,I5,A,I5,1X,I5,A,I9,A)') 'Calculating shell quadruple (',ISHLC,ISHLD,'|',ISHLA,ISHLB,'):',NCOLAB, &
                                                  ' columns have been qualified'
  write(LUPRI,'(A)') repeat('=',89)
end if

! Set mapping from shell pair CD to reduced set.
! ----------------------------------------------

IRC = 0
ILOC = 2
call CHO_SETSHP2RS_2(IRC,ILOC,ISHLCD,NAB)
if (IRC /= 0) then
  write(LUPRI,*) SECNAM,': CHO_SETSHP2RS_2 returned ',IRC
  call CHO_QUIT('Error termination in '//SECNAM,IRC)
end if

! Calculate integrals.
! --------------------

call CWTIME(C1,W1)
call CHO_MCA_INT_1(ISHLCD,ISHLAB,XINT,LINT,LOCDBG .or. (IPRINT >= 100))
call CWTIME(C2,W2)
TINTEG(1,1) = TINTEG(1,1)+C2-C1
TINTEG(2,1) = TINTEG(2,1)+W2-W1

end subroutine CHO_MCA_CALCINT_4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Assg2(g2,nT,nRys,la,lb,lc,ld,xyz2D0,xyz2D1,xyz2D2,
     &                 IfHss,Index1,Index2,ng,nh,PAO)
************************************************************************
*                                                                      *
* Object: to assemble the gradients of the ERI's.                      *
*                                                                      *
*     Author: Anders Bernhardsson                                      *
*             Dept. of Theoretical Chemistry,                          *
*             University of Lund, SWEDEN                               *
*             March '95                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
c#include "print.fh"
#include "real.fh"
#include "itmax.fh"
#include "iavec.fh"
      Real*8 g2(78),PAO(nt,(la+1)*(la+2)/2,
     &                     (lb+1)*(lb+2)/2,
     &                     (lc+1)*(lc+2)/2,
     &                     (ld+1)*(ld+2)/2),
     &       xyz2D0(nRys,nT,0:la+2,0:lb+2,0:lc+2,0:ld+2,3),
     &       xyz2D1(nRys,nT,0:la  ,0:lb  ,0:lc  ,0:ld  ,9),
     &       xyz2D2(nRys,nT,0:la  ,0:lb  ,0:lc  ,0:ld  ,18)
      Logical IfHss(4,3,4,3)
      Integer Index2(2,6,3),Index1(3,3),ng(3),nh(3)
*
*     Statement functions
*
      nElem(i) = (i+1)*(i+2)/2
      Ind(Icent,Icar,Jcent,jCar)=((iCent-1)*3+iCar-1)*
     &                            ((iCent-1)*3+iCar)/2+
     &                             (jCent-1)*3+jCar
*
*define _DEBUGPRINT_
c     iRout = 248
c     iPrint = nPrint(iRout)
      call dcopy_(78,[Zero],0,g2,1)
#ifdef _DEBUGPRINT_
      Call RecPrt('Assg2: g2(0)',' ',g2,1,78)
#endif
      ii = la*(la+1)*(la+2)/6
      jj = lb*(lb+1)*(lb+2)/6
      kk = lc*(lc+1)*(lc+2)/6
      ll = ld*(ld+1)*(ld+2)/6
      kcar = 0 ! dummy initialize
*
*       First we construct the non diagonal derivatives
*
       Do 90 iCar=1,3
        Do 95 jCar=1,3
*
*        Determine the permutation of the cartesian indexes
*

        If (jCar.eq.iCar)  Goto 94
          If (iCar*jCar.eq.2) Kcar=3
          If (iCar*jCar.eq.6) kCar=1
          If (iCar*jCar.eq.3) KCar=2
*
*      Loop over the atomic centre, in order
*      that the intgrals are calculated in.
*

          Do 100 iDer=1,ng(iCar)
           Do 110 jDer=1,ng(jCar)
            iCent=Index1(iDer,iCar)
            jCent=Index1(jDer,jCar)
*
            If (IfHss(iCent,iCar,jCent,jCar)) Then
             I=Ind(iCent,iCar,jCent,jCar)
             ix1=(iDer-1)*3+iCar
             ix2=(jDer-1)*3+jCar
*
*           Loop over angular momentas
*
             Do 120 ipd=1,nelem(ld)
              id1= ixyz(iCar,ll+ipd)
              id2 =ixyz(jCar,ll+ipd)
              id3= ixyz(kCar,ll+ipd)
              Do 130 ipc=1,nelem(lc)
               ic1= ixyz(iCar,kk+ipc)
               ic2 =ixyz(jCar,kk+ipc)
               ic3= ixyz(kCar,kk+ipc)
                Do 140 ipb=1,nelem(lb)
                ib1= ixyz(iCar,jj+ipb)
                ib2 =ixyz(jCar,jj+ipb)
                ib3= ixyz(kCar,jj+ipb)
                Do 150 ipa=1,nelem(la)
                 ia1= ixyz(iCar,ii+ipa)
                 ia2 =ixyz(jCar,ii+ipa)
                 ia3= ixyz(kCar,ii+ipa)
*
*       Loop over Rys-polynomia and exponents of the
*       basis set!
*
                 tmp=0.0D0
                 Do it=1,nt
                  Do iRys=1,nRys
                   tmp=tmp+
     &               PAO(iT,ipa,ipb,ipc,ipd)*
     &               xyz2D0(iRys,iT,ia3,ib3,ic3,id3,kCar)*
     &               xyz2D1(iRys,iT,ia1,ib1,ic1,id1,ix1)*
     &               xyz2D1(iRys,iT,ia2,ib2,ic2,id2,ix2)
                  End Do
                 End Do
                 g2(I) = g2(I) + tmp
 150            Continue
 140           Continue
 130          Continue
 120         Continue
             End If
 110        Continue
 100       Continue
  94       Continue
  95      Continue
  90     Continue
#ifdef _DEBUGPRINT_
      Call RecPrt('Assg2: g2 non-diagonal',' ',g2,1,78)
#endif
*
*             Then construct the diagonal derivatives
*
       Do 200 iCar=1,3
        jCar=Mod(iCar,3)+1
        kCar=Mod(jCar,3)+1
          Do 210  iDer=1,nh(iCar)
            ix1=(iDer-1)*3+iCar
            iCent=Index2(1,iDer,iCar)
            jCent=Index2(2,iDer,iCar)
            If (IfHss(iCent,iCar,jCent,iCar)) Then
            I=Ind(iCent,iCar,jCent,iCar)
*
            Do 220 ipd=1,nelem(ld)
              id1= ixyz(iCar,ll+ipd)
              id2 =ixyz(jCar,ll+ipd)
              id3= ixyz(kCar,ll+ipd)

             Do 230 ipc=1,nelem(lc)
              ic1= ixyz(iCar,kk+ipc)
              ic2 =ixyz(jCar,kk+ipc)
              ic3= ixyz(kCar,kk+ipc)

              Do 240 ipb=1,nelem(lb)
              ib1= ixyz(iCar,jj+ipb)
              ib2 =ixyz(jCar,jj+ipb)
              ib3= ixyz(kCar,jj+ipb)
               Do 250 ipa=1,nelem(la)
                ia1= ixyz(iCar,ii+ipa)
                ia2 =ixyz(jCar,ii+ipa)
                ia3= ixyz(kCar,ii+ipa)
*
                tmp=0.0D0
                Do it=1,nt
                  Do iRys=1,nRys
                    tmp = tmp +
     &              PAO(iT,ipa,ipb,ipc,ipd)*
     &              xyz2D0(iRys,iT,ia2,ib2,ic2,id2,jCar)*
     &              xyz2D0(iRys,iT,ia3,ib3,ic3,id3,kCar)*
     &              xyz2D2(iRys,iT,ia1,ib1,ic1,id1,ix1)
                 End Do
                End Do
                g2(I)=g2(I)+tmp
*
 250           Continue
 240          Continue
 230         Continue
 220        Continue
            End If
 210       Continue
 200     Continue
#ifdef _DEBUGPRINT_
      Call RecPrt('Assg2: g2 full',' ',g2,1,78)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine xabort(rc)
! this routine aborts the process(es) with rc

#ifdef _MOLCAS_MPP_
use mpi, only: MPI_COMM_WORLD
use Para_Info, only: Is_Real_Par
use Definitions, only: MPIInt
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: rc
#ifdef _MOLCAS_MPP_
integer(kind=MPIInt) :: rc4, ierr4
#else
#include "macros.fh"
unused_var(rc)
#endif

#ifdef _MOLCAS_MPP_
if (is_real_par()) then
  ! unlike abort, mpi_abort does not print a backtrace,
  ! so we do it manually here
  call xbacktrace()
  rc4 = int(rc,kind=MPIInt)
  call mpi_abort(MPI_COMM_WORLD,rc4,ierr4)
else
#endif

#if defined (__GNUC__) || defined(__INTEL_COMPILER)
  call abort()
#else
  stop 'Molcas aborted...'
#endif

#ifdef _MOLCAS_MPP_
end if
#endif

return

end subroutine xabort

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001-2016, Valera Veryazov                             *
!***********************************************************************

subroutine finish(rc)
! Gracefully shuts down a program module.
! After everything is closed properly, xquit is
! called to do the actual termination.

use warnings, only: MaxWarnMess
use Symmetry_Info, only: Symmetry_Info_Free
use Isotopes, only: Free_Isotopes
#ifndef _HAVE_EXTRA_
use Prgm, only: prgmfree
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: rc
integer(kind=iwp) :: idum

call Symmetry_Info_Free()
call Free_Isotopes()

call fin_run_use()
#ifndef _HAVE_EXTRA_
call prgmfree()
#endif

call GetMem('Finish','LIST','REAL',iDum,0)
call GetMem('Finish','TERM','REAL',iDum,0)

call StatusLine('Happy landing','')
if (MaxWarnMess > 1) call WarningMessage(1,'There were warnings during the execution;Please, check the output with care!')

#ifdef _HAVE_EXTRA_
call prgmfree()
#endif
call AixCheck()
call xml_close('module')

#ifdef _DELAYED_
call close_BLAS()
#endif

call xquit(rc)

end subroutine finish

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine o10a_cvb(nparm1)
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
#include "direct_cvb.fh"
#include "opt2_cvb.fh"

      call ddnewopt_cvb()
      have_solved_it=.false.

      ixp=mstackr_cvb(nparm)
      call fmove_cvb(w(ix(2)),w(ixp),nparm)
      call ddproj_cvb(w(ixp),nparm)
      cnrm1=dnrm2_(n_div,w(ixp),1)
      cnrm2=dnrm2_(nparm-n_div,w(n_div+ixp),1)
      if(cnrm1.gt.cnrm2)then
        call ddguess_cvb(w(ixp),n_div,0)
        if(cnrm2.gt.1d-8)
     >    call ddguess_cvb(w(n_div+ixp),nparm-n_div,n_div)
      else
        call ddguess_cvb(w(n_div+ixp),nparm-n_div,n_div)
        if(cnrm1.gt.1d-8)call ddguess_cvb(w(ixp),n_div,0)
      endif
      call ddrhs_cvb(w(ixp),nparm,0)
      call mfreer_cvb(ixp)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(nparm1)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PtAdd(H0,RR,nSize,Temp,nTemp)
!***********************************************************************
!                                                                      *
!     Objective: Construct the modified Hamiltonian                    *
!                                                                      *
!***********************************************************************

use FFPT_Global, only: LCumulate, nBas, nSym, ComStk
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSize, nTemp
real(kind=wp), intent(out) :: H0(nSize)
real(kind=wp), intent(inout) :: RR(nSize), Temp(nTemp)
character(len=8) :: Label
integer(kind=iwp) :: idum(1), iComp, iOpt, iOpt1, iOpt2, iRc, iSyLbl, nInts
logical(kind=iwp), parameter :: Debug = .false.

!----------------------------------------------------------------------*
!                                                                      *
!     Start procedure                                                  *
!     Read nuclear attraction and kinteic energy integrals.            *
!     Combine them to generate the one-electron Hamiltonian.           *
!     Finally read the overlap matrix.                                 *
!                                                                      *
!----------------------------------------------------------------------*

iOpt1 = 1
iOpt2 = 2
iComp = 1
iSyLbl = nSym
if (LCumulate) then
  Label = 'OneHam  '
  write(u6,*)
  write(u6,*) 'Adding perturbation cumulatively'
  write(u6,*)
else
  Label = 'OneHam 0'
end if
iRc = -1
call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
nInts = idum(1)
if (iRc /= 0) then
  write(u6,*) 'PtAdd: Error reading ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
if (nInts+4 /= nSize) then
  write(u6,*) 'PtAdd: nInts+4.ne.nSize',nInts+4,nSize
  call Abend()
end if
iRc = -1
call RdOne(iRc,iOpt2,Label,iComp,H0,iSyLbl)
if (Debug) then
  call PrDiOp('One Hamiltonian intgrl',nSym,nBas,H0)
  write(u6,*) 'PotNuc=',H0(nInts+4)
end if

!----------------------------------------------------------------------*
!     Loop over all possible commands and branch to "special purpose"  *
!     subroutines to add perturbations.                                *
!----------------------------------------------------------------------*

call PtRela(H0,nSize,Temp,nTemp)
call PtDipo(H0,nSize,Temp,nTemp)
call PtQuad(H0,RR,nSize,Temp,nTemp)
call PtOkt0(H0,RR,nSize,Temp,nTemp)
call PtEfld(H0,nSize,Temp,nTemp)
call PtEfgr(H0,nSize,Temp,nTemp)
call PtGLbl(H0,nSize,Temp,nTemp)

!----------------------------------------------------------------------*
!     If the user have requested a local (a la LoProp) perturbation    *
!     then make some modifications to the perturbation matrix.         *
!----------------------------------------------------------------------*

if (ComStk(4,0,0,0)) call SelectLoc(H0,nSize)

!----------------------------------------------------------------------*
!     Terminate procedure                                              *
!----------------------------------------------------------------------*

if (Debug) then
  call PrDiOp('Core Hamiltonian',nSym,nBas,H0)
  write(u6,*) 'PotNuc=',H0(nInts+4)
end if
iRc = -1
iOpt = 0
iComp = 1
Label = 'OneHam  '
call WrOne(iRc,iOpt,Label,iComp,H0,iSyLbl)
if (iRc /= 0) then
  write(u6,*) 'PtAdd: Error writing to ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
!call Put_PotNuc(H0(nInts+4))
call Put_dScalar('PotNuc',H0(nInts+4))

!----------------------------------------------------------------------*
!     Normal Exit                                                      *
!----------------------------------------------------------------------*

return

end subroutine PtAdd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NEWCNFTAB(NEL,NORB,MINOP,MAXOP,LSYM,NGAS,NGASORB,NGASLIM,IFORM,ICASE)

use Index_Functions, only: nTri_Elem, nTri_Elem1
use rassi_global_arrays, only: CnfTab1, CnfTab2
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NEL, NORB, MINOP, MAXOP, LSYM, NGAS, NGASORB(nIrrep,NGAS), NGASLIM(2,NGAS), IFORM, ICASE
integer(kind=iwp) :: IFPOSS, IGAS, IPOS, ISUM, ISYM, KCNFEND, KCNFSTA, KINFO, L, LENCNF, MXO, NCLS, NCNF, NNCNF1, NNCNF2, NOCC, &
                     NOPN, NTAB
integer(kind=iwp), allocatable :: NCNF1(:), NCNF2(:)
integer(kind=iwp), pointer :: CnfTab(:)

! Note how input parameter LSYM is used: If non-zero, only those configurations
! with symmetry label LSYM are selected. But if LSYM=0, they are all selected.
! We must figure out sizes before allocating the new configuration table.
! Set up a table NCNF1(nIrrep,NPOS) with NPOS=nTri_Elem1(NEL)
NNCNF1 = nIrrep*nTri_Elem1(NEL)
call mma_allocate(NCNF1,NNCNF1,Label='NCNF1')
! We need also a table NCNF2, temporarily. Need to know mx nr of active orbitals
! in any GAS subspace:
MXO = 0
do IGAS=1,NGAS
  ISUM = sum(NGASORB(1:nIrrep,IGAS))
  MXO = max(MXO,ISUM)
end do
NNCNF2 = nIrrep*nTri_Elem1(MXO)
call mma_allocate(NCNF2,NNCNF2,Label='NCNF2')
call NRCNF1(NEL,NORB,NGAS,NGASLIM,NGASORB,NCNF1,MXO,NCNF2)
call mma_deallocate(NCNF2)

! NCNF1(ISYM,IPOS) contains the number of possible configurations for symmetry
! label ISYM, nr of closed shells NCLS, and nr of open shells NOPN. The latter
! are combined as pair index IPOS=1+NOPN+nTri_Elem(NOCC) with NOCC=NCLS+NOPN

! Header (See below for contents):
NTAB = 10
! NGASORB array:
NTAB = NTAB+(nIrrep+1)*(NGAS+1)
! NGASLIM array:
NTAB = NTAB+2*NGAS
! Save offset to INFO table for later use:
KINFO = NTAB+1
! INFO array:
NTAB = NTAB+3*nIrrep*(MAXOP-MINOP+1)
! Save offset to configuration arrays for later use:
KCNFSTA = NTAB+1
! Configuration arrays:
do NOPN=MINOP,min(2*NORB-NEL,NEL,MAXOP)
  NCLS = (NEL-NOPN)/2
  if (NCLS < 0) cycle
  if (2*NCLS+NOPN /= NEL) cycle
  NOCC = NCLS+NOPN
  if (NOCC > NORB) cycle
  do ISYM=1,nIrrep
    NCNF = 0
    if ((LSYM >= 1) .and. (LSYM <= nIrrep)) then
      IPOS = 1+NOPN+nTri_Elem(NOCC)
      NCNF = NCNF1(ISYM+nIrrep*(IPOS-1))
    end if
    LENCNF = NOCC
    if (IFORM == 2) LENCNF = NORB
    if (IFORM == 3) LENCNF = (NOCC+3)/4
    if (IFORM == 4) LENCNF = (NORB+14)/15
    NTAB = NTAB+NCNF*LENCNF
  end do
end do

! Sizes and offsets are known. Now, we can allocate the table:
select case (ICASE)
  case (1)
    call mma_allocate(CnfTab1,NTAB,Label='CnfTab1')
    CnfTab => CnfTab1(:)
  case (2)
    call mma_allocate(CnfTab2,NTAB,Label='CnfTab2')
    CnfTab => CnfTab2(:)
  case default
    call ABEND()
    CnfTab => CnfTab1(:) ! dummy
end select

! Enter header:
CnfTab(1) = NTAB
CnfTab(2) = 37
CnfTab(3) = NEL
CnfTab(4) = NORB
CnfTab(5) = MINOP
CnfTab(6) = MAXOP
CnfTab(7) = nIrrep
CnfTab(8) = LSYM
CnfTab(9) = NGAS
CnfTab(10) = IFORM
! Enter copy of NGASORB array:
do IGAS=1,NGAS
  ISUM = 0
  do ISYM=1,nIrrep
    L = 11+ISYM+(nIrrep+1)*IGAS
    CnfTab(L) = NGASORB(ISYM,IGAS)
    ISUM = ISUM+NGASORB(ISYM,IGAS)
  end do
  CnfTab(11+(nIrrep+1)*IGAS) = ISUM
end do
do ISYM=0,nIrrep
  ISUM = 0
  do IGAS=1,NGAS
    L = 11+ISYM+(nIrrep+1)*IGAS
    ISUM = ISUM+CnfTab(L)
  end do
  CnfTab(11+ISYM) = ISUM
end do
L = 10+(nIrrep+1)*(NGAS+1)
! Enter copy of NGASLIM array:
do IGAS=1,NGAS
  L = L+1
  CnfTab(L) = NGASLIM(1,IGAS)
  L = L+1
  CnfTab(L) = NGASLIM(2,IGAS)
end do
! Construct and enter INFO table.
! The INFO table has a relative pointer to configuration arrays:
KCNFEND = KCNFSTA-1
do NOPN=MINOP,MAXOP
  NCLS = (NEL-NOPN)/2
  IFPOSS = 1
  if (NCLS < 0) IFPOSS = 0
  if (2*NCLS+NOPN /= NEL) IFPOSS = 0
  if (NCLS+NOPN > NORB) IFPOSS = 0
  if (IFPOSS == 0) then
    do ISYM=1,nIrrep
      ! No such configuration is possible.
      !INFO(1,ISYM,NOPN) = NCNF
      CnfTab(KINFO+0+3*(ISYM-1+nIrrep*(NOPN-MINOP))) = 0
      !INFO(2,ISYM,NOPN) = NTAB+1
      CnfTab(KINFO+1+3*(ISYM-1+nIrrep*(NOPN-MINOP))) = -1
      !INFO(3,ISYM,NOPN) = LENCNF
      CnfTab(KINFO+2+3*(ISYM-1+nIrrep*(NOPN-MINOP))) = 0
    end do
  else
    NOCC = NCLS+NOPN
    do ISYM=1,nIrrep
      NCNF = 0
      ! If LSYM=0, all symmetry labels will be accepted. Else, only
      ! those with ISYM=LSYM.
      if ((LSYM == 0) .or. (ISYM == LSYM)) then
        IPOS = 1+NOPN+nTri_Elem(NOCC)
        NCNF = NCNF1(ISYM+nIrrep*(IPOS-1))
      end if
      if (NCNF == 0) then
        ! INFO(1,ISYM,NOPN) = NCNF
        CnfTab(KINFO+0+3*(ISYM-1+nIrrep*(NOPN-MINOP))) = 0
        ! INFO(2,ISYM,NOPN) = NTAB+1
        CnfTab(KINFO+1+3*(ISYM-1+nIrrep*(NOPN-MINOP))) = -1
        ! INFO(3,ISYM,NOPN) = LENCNF
        CnfTab(KINFO+2+3*(ISYM-1+nIrrep*(NOPN-MINOP))) = 0
      else
        LENCNF = NOCC
        if (IFORM == 2) LENCNF = NORB
        if (IFORM == 3) LENCNF = (NOCC+3)/4
        if (IFORM == 4) LENCNF = (NORB+14)/15
        ! The relative pointer into this configuration array:
        KCNFSTA = KCNFEND+1
        KCNFEND = KCNFEND+NCNF*LENCNF
        ! INFO(1,ISYM,NOPN) = NCNF
        CnfTab(KINFO+0+3*(ISYM-1+nIrrep*(NOPN-MINOP))) = NCNF
        ! INFO(2,ISYM,NOPN) = NTAB+1
        CnfTab(KINFO+1+3*(ISYM-1+nIrrep*(NOPN-MINOP))) = KCNFSTA
        ! INFO(3,ISYM,NOPN) = LENCNF
        CnfTab(KINFO+2+3*(ISYM-1+nIrrep*(NOPN-MINOP))) = LENCNF
        CnfTab(KCNFSTA:KCNFSTA+NCNF*LENCNF-1) = 0
      end if
    end do
  end if
end do
! The NCNF1 array is no longer needed.
call mma_deallocate(NCNF1)

! Finally, only now when we know where to store each (ISYM,NOPN) block of
! configurations, can we compute the actual configuration arrays:
call MKCONF(CnfTab)
nullify(CnfTab)

end subroutine NEWCNFTAB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000-2016, Valera Veryazov                             *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Author:   Valera Veryazov 2000-2016                                  *
!           Theoretical Chemistry                                      *
!           Lund University                                            *
!           Sweden                                                     *
!                                                                      *
!***********************************************************************
!  MolcasControl
!
!> @brief
!>   Query a string from the control file
!> @author V. Veryazov
!>
!> @details
!> Only lines started from ``!`` are in use.
!>
!> If user modified molcas.control file
!> (by placing ``!`` instead of ``#``)
!> return a value of the field (as a string)
!> and mark the label as a comment,
!> else return blank value.
!>
!> Usage:
!>
!> \code
!> Call MolcasControl('SHUTDOWN',Val)
!> if (Val == 'YES') Call abend()
!> \endcode
!>
!> @side_effects
!> file molcas.control
!>
!> @param[in]  Label Query string
!> @param[out] Val   Returned value
!***********************************************************************

subroutine MolcasControl(Label,Val)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: Label
character(len=*), intent(out) :: Val
character(len=80) :: Line(20)
character(len=*), parameter :: filename = 'molcas.control'
integer(kind=iwp) :: i, ic, iLine, Lu, stat
logical(kind=iwp) :: Exists, Modify
integer(kind=iwp), external :: StrnLn

Val = ' '
Modify = .false.
call f_inquire(filename,Exists)
if (.not. Exists) return
Lu = 1
call molcas_open(Lu,filename)
iLine = 1
do
  read(Lu,'(a)',iostat=stat) Line(iLine)
  if (stat /= 0) exit
  if (Line(iLine)(1:1) == '!') Modify = .true.
  iLine = iLine+1
  if (iLine >= size(Line)) exit
end do

close(Lu)

if (.not. Modify) return

call molcas_open(Lu,filename)
do ic=1,iLine-1
  if (Line(ic)(1:1) == '!') then
    i = index(Line(ic)(2:),'=')
    if (i > 0) then
      if (Line(ic)(2:i) == Label) then
        Line(ic)(1:1) = '#'
        Modify = .true.
        Val = Line(ic)(i+2:)
      end if
    end if
  end if
  i = StrnLn(Line(ic))
  write(Lu,'(a)') Line(ic)(1:i)
end do
close(Lu)

return

end subroutine MolcasControl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
      Subroutine ComputeFunc(nAtoms,nOrb2Loc,PA,Functional,Debug)
c
c     Author: Y. Carissan
c
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "real.fh"
      Real*8 PA(nOrb2Loc,nOrb2Loc,nAtoms)
      Logical Debug
c
      Functional=Zero
      Do iAt=1,nAtoms
        Do iMO_s=1,nOrb2Loc
          Functional=Functional+PA(iMO_s,iMO_s,iAt)**2
        End Do
      End Do
c
      If (Debug) Then
         Write(6,*) 'ComputeFunc: Functional: ',Functional
      End If
c
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine get_dm0()
!***********************************************************************
!
!  Purpose : to get the initial density matrix in CSF basis
!            which used in propagation!
!
!***********************************************************************

use rhodyn_data, only: CSF2SO, DM0, DTOC, E, E_SF, E_SO, flag_so, ipglob, k_B, lroots, lrootstot, N, N_Populated, nconf, nconftot, &
                       ndet, ndet_tot, NState, p_style, prep_dm_i, prep_dm_r, runmode, sint, T, U_CI
use rhodyn_utils, only: transform, dashes
use mh5, only: mh5_put_dset
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, j, k, ii, jj, kk, lu !temporary io unit
complex(kind=wp) :: Z
complex(kind=wp), allocatable :: DET2CSF(:,:), DM0_bas(:,:), temp_dm(:)
integer(kind=iwp), external :: isFreeUnit

if (ipglob > 3) write(u6,*) 'Begin get_dm0'

if ((p_style == 'SO_THERMAL') .and. (T == 0)) then
  p_style = 'SO'
end if
if ((p_style == 'SF_THERMAL') .and. (T == 0)) then
  p_style = 'SF'
end if

if (runmode /= 4) then
  call mma_allocate(DM0,nconftot,nconftot)
else ! in charge migration case prepare DM in SF/SO basis
  call mma_allocate(DM0,lrootstot,lrootstot)
end if
DM0 = cZero

! If populate DET, read the transform matrix from DET to CSF to DET2CSF
if (p_style == 'DET') then
  call mma_allocate(DET2CSF,ndet_tot,nconftot)
  DET2CSF = cZero
  ii = 0
  jj = 0
  kk = 0
  do i=1,N
    if (i == 1) then
      ii = 0
    else
      ii = nconf(i-1)
    end if
    do j=1,ndet(i)
      jj = jj+1
      do k=1,nconf(i)
        kk = ii+kk
        DET2CSF(jj,kk) = DTOC(j,k,i)
      end do
    end do
  end do
end if

! Construct the initial density matrix for populating

if (flag_so) then
  select case (p_style)
    case ('CSF')
      if ((N_Populated > nconftot) .or. (N_populated <= 0)) then
        call dashes()
        write(u6,*) 'WARNING!!! Nr of the populated states',N_populated,' read from the input file is wrong'
        call dashes()
        call abend()
      end if
      if (runmode /= 4) then
        DM0(N_Populated,N_Populated) = cOne
      else
        call mma_allocate(DM0_bas,nconftot,nconftot)
        DM0_bas = cZero
        DM0_bas(N_Populated,N_Populated) = cOne
        write(u6,*) 'DM element ',N_populated,' set to 1'
        call transform(DM0_bas,CSF2SO,DM0)
      end if

    case ('DET')
      call mma_allocate(DM0_bas,ndet_tot,ndet_tot)
      DM0_bas = cZero
      if ((N_Populated > ndet_tot) .or. (N_populated <= 0)) then
        call dashes()
        write(u6,*) 'WARNING!!! Nr of the populated states',N_populated,' read from the input file is wrong'
        call dashes()
        call abend()
      end if
      DM0_bas(N_Populated,N_Populated) = cOne
      call transform(DM0_bas,DET2CSF,DM0)
      call mma_deallocate(DET2CSF)

    case ('SF')
      call mma_allocate(DM0_bas,lrootstot,lrootstot)
      DM0_bas = cZero
      if ((N_Populated > lrootstot) .or. (N_populated <= 0)) then
        call dashes()
        write(u6,*) 'WARNING!!! Nr of the populated is wrong'
        call dashes()
        call abend()
      end if
      DM0_bas(N_Populated,N_Populated) = cOne
      call transform(DM0_bas,cmplx(U_CI,kind=wp),DM0,.false.)

    case ('SO')
      call mma_allocate(DM0_bas,lrootstot,lrootstot)
      DM0_bas = cZero
      if ((N_Populated > lrootstot) .or. (N_populated <= 0)) then
        call dashes()
        write(u6,*) 'WARNING!!! Nr of the populated states',N_populated,' read from the input file is wrong'
        call dashes()
        call abend()
      end if
      DM0_bas(N_Populated,N_Populated) = cOne
      call transform(DM0_bas,CSF2SO,DM0,.false.)

    case ('SO_THERMAL')
      if (ipglob > 3) then
        call dashes()
        write(u6,*) 'Printout the SO eigenvalues'
        write(u6,sint) 'Number of the SO states:',lrootstot
        call dashes()
        do i=1,10
          write(u6,*) E_SO(i)
        end do
      end if
      Z = cZero
      do i=1,lrootstot
        Z = Z+exp(-(E_SO(i)-E_SO(1))/(k_B*T))
      end do
      call mma_allocate(DM0_bas,lrootstot,lrootstot)
      DM0_bas = cZero
      if (ipglob > 3) then
        call dashes()
        write(u6,*) 'I            E_SO(I)-E_SO(1)               exp(-(E_SO(I)-E_SO(1))/(k_B*T)),   '// &
                    'exp(-(E_SO(I)-E_SO(1))/(k_B*T))/Z'
        call dashes()
        do i=1,20
          write(u6,*) i,E_SO(i)-E_SO(1),exp(-(E_SO(i)-E_SO(1))/(k_B*T)),exp(-(E_SO(i)-E_SO(1))/(k_B*T))/Z
        end do
      end if
      do i=1,lrootstot
        DM0_bas(i,i) = exp(-(E_SO(i)-E_SO(1))/(k_B*T))/Z
      end do
      if (runmode /= 4) then
        call transform(DM0_bas,CSF2SO,DM0,.false.)
      else
        DM0(:,:) = DM0_bas
      end if
    case default
      write(u6,*) 'Population style ',p_style,' is not recognized'
      call abend()
  end select

else
  ! SO is off
  ! has not checked yet
  select case (p_style)
    case ('CSF')
      if ((N_Populated > nconftot) .or. (N_populated <= 0)) then
        call dashes()
        write(u6,*) 'WARNING!!! Nr of the populated states',N_populated,'read from the input file is wrong'
        call dashes()
        call abend()
      end if
      if (runmode /= 4) then
        DM0(N_Populated,N_Populated) = cOne
      else
        call mma_allocate(DM0_bas,nconftot,nconftot)
        DM0_bas = cZero
        DM0_bas(N_Populated,N_Populated) = cOne
        write(u6,*) 'DM element ',N_populated,' set to 1'
        ! transform right to SF basis for propagation
        call transform(DM0_bas,cmplx(U_CI,kind=wp),DM0)
      end if

    case ('DET')
      call mma_allocate(DM0_bas,ndet_tot,ndet_tot)
      DM0_bas = cZero
      if ((N_Populated > NDET_TOT) .or. (N_populated <= 0)) then
        call dashes()
        write(u6,*) 'WARNING!!! Nr of the populated states',N_populated,' read from the input file is wrong'
        call dashes()
        call abend()
      end if
      DM0_bas(N_Populated,N_Populated) = cOne
      call transform(DM0_bas,DET2CSF,DM0)
      call mma_deallocate(DET2CSF)

    case ('SF')
      call mma_allocate(DM0_bas,lrootstot,lrootstot)
      DM0_bas = cZero
      if ((N_Populated > lrootstot) .or. (N_populated <= 0)) then
        call dashes()
        write(u6,*) 'WARNING!!! Nr of the populated states',N_populated,' read from the input file is wrong'
        call dashes()
        call abend()
      end if
      DM0_bas(N_Populated,N_Populated) = cOne
      call transform(DM0_bas,cmplx(U_CI,kind=wp),DM0,.false.)

    case ('SO')
      call dashes()
      write(u6,*) 'WARNING! IF IFSO=OFF, CAN NOT POPULATE SO STATE'
      call dashes()
      call abend()

    case ('SF_THERMAL')
      ! Construct the total eigenvalue of SF states to E_SF
      ii = 0
      do i=1,N
        do j=1,lroots(i)
          ii = ii+1
          E_SF(ii) = E(i,j)
        end do
      end do
      Z = cZero
      do i=1,nconftot
        Z = Z+exp(-(E_SF(i)-E_SF(1))/(k_B*T))
      end do
      call mma_allocate(DM0_bas,lrootstot,lrootstot)
      DM0_bas = cZero
      call dashes()
      write(u6,*) ' I               (E_SF(I)-E_SF(1))/(k_B*T)              exp(-(E_SF(I)-E_SF(1))/(k_B*T))  '// &
                  'exp(-(E_SF(I)-E_SF(1))/(k_B*T))/Z'
      call dashes()
      do i=1,nconftot
        write(u6,*) i,(E_SF(i)-E_SF(1))/(k_B*T),exp(-(E_SF(i)-E_SF(1))/(k_B*T)),exp(-(E_SF(i)-E_SF(1))/(k_B*T))/Z
        DM0_bas(i,i) = exp(-(E_SF(i)-E_SF(1))/(k_B*T))/Z
      end do
      call transform(DM0_bas,cmplx(U_CI,kind=wp),DM0,.false.)
    case default
      write(u6,*) 'Population style ',p_style,' is not recognized'
      call abend()
  end select
end if !ifso

! it will be transformed as usual further
if (p_style == 'FROMFILE') then
  call mma_allocate(temp_dm,NState)
  lu = isFreeUnit(11)
  call molcas_open(lu,'INDENS')
  do i=1,NState
    do j=1,Nstate
      read(lu,'(E16.8)',advance='no') temp_dm(j)
    end do
    DM0(i,:) = temp_dm
    read(lu,*)
  end do
  close(lu) ! close INDENS file
  call mma_deallocate(temp_dm)
end if

if (allocated(DM0_bas)) call mma_deallocate(DM0_bas)

! Printout the initial density matrix to SDPREP in CSF basis
! not CM case
if (runmode /= 4) then
  if (ipglob > 3) then
    call dashes()
    write(u6,*) 'The initial density matrix is saved in SDPREP'
    call dashes()
  end if
  call mh5_put_dset(prep_dm_r,real(DM0))
  call mh5_put_dset(prep_dm_i,aimag(DM0))
end if

if (ipglob > 3) write(u6,*) 'End get_dm0'

end subroutine get_dm0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014,2015, Ignacio Fdez. Galvan                        *
!***********************************************************************
!  Preprocess_UDC
!
!> @brief
!>   Quickly read the constraints to take some decisions
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Process the constraints in the \p Lu file, but just to find out whether
!> some constraints are present and their values.
!> This is used for:
!>   - Detecting if the "EDIFF" constraint is present and with a zero value,
!>     in which case a conical intersection algorithm could be activated
!>     (depending on the symmetry and spin in the runfile).
!>   - Detecting if any constraint is explicitly declared as "soft",
!>     this is recommended for some TS searches with numerical differentiation.
!>   - Detecting whether an explicit MEP/IRC constraint has been included,
!>     this will probably give problems.
!>
!> @param[in]  Lu     Unit number of the file with the constraints
!> @param[in]  iPrint Print level
!***********************************************************************

subroutine Preprocess_UDC(Lu,iPrint)

use Slapaf_Info, only: EDiffZero, iState, lSoft, MEP_Type, MEPCons, NADC, NADC
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Lu, iPrint
integer(kind=iwp) :: Error, i, iPos, j, nLines
real(kind=wp) :: EDiffValue
logical(kind=iwp) :: MECI_via_SLAPAF
character(len=180) :: EDiffName, Line1, Line2
character(len=180), external :: Get_Ln

EDiffName = ''
EDiffZero = .false.
iState(1) = 0
iState(2) = 0
MECI_via_SLAPAF = .false.

! An arbitrary initial value given to EDiffValue, this value is
! irrelevant since the only thing that matters is whether it is 0.0

EDiffValue = One

! Ugly hack to be able to restore the file to its original position
! (since Get_Ln may read more than one line)
! Count the lines until the end of the file and backspace

nLines = 0
do
  read(Lu,'(A)',IOSTAT=Error) Line1
  nLines = nLines+1
  if (Error /= 0) exit
end do
do i=1,nLines
  backspace(Lu)
end do

! Read the primitive constraints

! First read until the "VALUES" line
! Each line is split at the "=" sign by auto,
! so read two lines if there is no "=" sign

do
  Line1 = Get_Ln(Lu)
  call UpCase(Line1)
  Line1 = adjustl(Line1)
  if (Line1(1:4) == 'VALU') exit
  iPos = index(Line1,'=')
  if (iPos > 0) then
    Line2 = Line1(iPos+1:)
    Line1 = Line1(:iPos-1)
  else
    Line2 = Get_Ln(Lu)
    call UpCase(Line2)
  end if
  Line2 = adjustl(Line2)
  ! If a primitive is defined as "EDIFF", save its name
  if (Line2(1:4) == 'EDIF') then
    EDiffName = Line1
    iPos = index(Line2,' ')
    Line2 = Line2(iPos+1:)
    read(Line2,*,IOSTAT=Error) i
    if (Error /= 0) i = 0
    iPos = index(Line2,' ')
    Line2 = Line2(iPos+1:)
    read(Line2,*,IOSTAT=Error) j
    if (Error /= 0) j = 0
    iState(1) = max(i,j)
    iState(2) = min(i,j)
  end if
  ! If a primitive of the same type as that used by MEP/IRC
  ! is defined, signal it.
  if (Line2(1:4) == MEP_Type(1:4)) MEPCons = .true.
end do

! Now read the constraint values

! Read until the "END" line
! Each line is split at the "=" sign by auto,
! so read two lines if there is no "=" sign

do
  Line1 = Get_Ln(Lu)
  call UpCase(Line1)
  Line1 = adjustl(Line1)
  ! Read continuation lines
  do while (index(Line1,'&') /= 0)
    Line1 = Get_Ln(Lu)
    call UpCase(Line1)
    Line1 = adjustl(Line1)
  end do
  if (Line1(1:4) == 'END ') exit
  iPos = index(Line1,'=')
  if (iPos > 0) then
    Line2 = Line1(iPos+1:)
    Line1 = Line1(:iPos-1)
  else
    Line2 = Get_Ln(Lu)
    call UpCase(Line2)
  end if
  ! If the name matches the "EDIFF" primitive, read the value
  if (Line1 == EDiffName) then
    read(Line2,*,IOSTAT=Error) EDiffValue
    if (Error /= 0) EDiffValue = One
  end if
  ! If the constraint is explicitly "soft"
  if (index(Line2,'SOFT') /= 0) lSoft = .true.
end do

! Return the file to its original position
! (cannot use REWIND because this may be the full input for slapaf)
! First advance to the end of file and then backspace

do
  read(Lu,'(A)',IOSTAT=Error) Line1
  if (Error /= 0) exit
end do
do i=1,nLines
  backspace(Lu)
end do

! If an "EDIFF" constraint is being used with a value exactly 0.0,
! this may be a conical intersection search.
! If there is no "EDIFF" at all, there's no use computing NACs

if (EDiffValue == Zero) then
  EDiffZero = .true.
  MECI_via_SLAPAF = .true.
  call put_lscalar('MECI_via_SLAPAF ',MECI_via_SLAPAF)
  if (iPrint >= 6) then
    write(u6,*) 'Energy difference constraint with zero value.'
    write(u6,*) 'This may be a conical intersection search.'
  end if
else if (EDiffName(1:4) /= '    ') then
  if (iPrint >= 6) then
    write(u6,*) 'Energy difference constraint with non-zero value.'
    write(u6,*) 'This will not be a conical intersection search.'
  end if
else
  NADC = .false.
end if

end subroutine Preprocess_UDC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine PCMMmg(nRys,MnPCMG,la,lb,lr)
      Integer iAng(4)
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      nOrdOp=lr
      iAng(1) = la
      iAng(2) = lb
      iAng(3) = nOrdOp
      iAng(4) = 0
      Call MemRg1(iAng,nRys,MemTmp)
      MnPCMG = MemTmp + 2 + nElem(la)*nElem(lb)*nElem(nOrdOp)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Reord_chcc(wrk,wrksize,NaGrpR,NaSGrpR,NchBlk,LunAux)
! This routine does:
! 1) Read local CD1 file of Cholesky vectors from MC
! 2) Reorder ChV from pq,mloc to mloc,pq
!     Make L0-L2 files (local, dimensioned as ncLoc)
!     (if needed: (JoinLkey=1)
! 3) Make I0-I3 integrals
!    Calc E MP2
!     Make T20 (fist estimation (ai|jb)/Dijab
!     Make L0-L2 files (Global, dimensioned as nc)
!     (if needed: (JoinLkey=2)
!
!  for integral based approach (intkey=1)
!  5.1) W3 (vv|vo) integrals
!  5.2) W4 (vv|vv) integrals
!  5.3) Make L0-L2 files (Global, dimensioned as nc)
!     (if needed: JoinLkey=3)

!1 Structure of files, where selected group of (pq|rs) are
!  stored (V'O|OO) - I1 ; (V'O|V'O) - I2 ; (V'V'|OO) - I3
!
!  (IJ |KL)  I0intg
!
!  (A'I|JK)  I1inxx xx - Group of A'
!
!  (A'I|B'J) I2xxyy xx - Group of A'
!                   yy - Group of B'
!
!  (A'B'|IJ) I3xxyy xx - Group of A'
!                   yy - Group of B'
!
!2 Structure of Cholesky vector files
!
!  L0(m,IJ)    L0vctr  I>=J
!
!  L1(m,I ,A') L1vcxx xx - Group of A'
!@@   kokot som, ze som to takto urobil, prerobit na L(m,a,i) to treba
!
!  L2(m,A'B')  L2xxyy xx - Group of A', A'>=B'
!                     yy - Group of B'
!
!3 Structure of Amplitude file
!  t2(A'B',I,J)  T2xxyy xx - Group of A'
!                       yy - Group of B'
!
! Memory requirements:
!  cholesky:
! V1   - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm;  oom}
! V2   - max {ov'ov'; v'v'm, ov'm; oom}
! V3   - max {ov'm; oom}
! V4   -      oom
!  integral based:
! V1   - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm; oom; V"V"V"V"}
! V2   - max {ov'ov'; v'v'm, ov'm; oom}
! V3   - max {ov'm; oom; V'V'M}
! V4   - oom
! M1   - V"V"m
! M2   - max {V"V"M; OV"M)

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimGrpa, DimGrpaR, DimSGrpa, generkey, GrpaLow, GrpaUp, I0Name, I1Name, I2Name, I3Name, intkey, JoinLkey, &
                       L0Name, L1Name, L2Name, nc, nfr, no, nv, PosFoo, PosFree, PosFvo, PosFvv, PosOE, printkey, T2Name
#ifdef _MOLCAS_MPP_
use chcc_global, only: InqW3, InqW4, NChLoc, W34DistKey
use Para_Info, only: MyRank
#endif
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, NaGrpR, NaSGrpR, NChBlk, LunAux
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: abGrp, abSGrp, adda, addapp, addb, addbpp, addc, addcpp, addd, adddpp, aGrp, aSGrp, bGrp, bSGrp, bSGrpUp, &
                     cdGrp, cdSGrp, cGrp, ChLow, ChUp, cSGrp, dGrp, dim_1, dima, dimab, dimabpp, dimapp, dimb, dimbpp, dimc, &
                     dimcd, dimcdpp, DimCh(100), dimci, dimcpp, dimd, dimdpp, dimij, dSGrp, dSGrpUp, i, idisk, idum(1), LunChVF, &
                     maxdim, mdGrpa, mdGrpbe, mdSGrpa, mdSGrpbe, NaGrp, NaSGrp, NbeGrp, NbeSgrp, nbs, NCh, ncLoc, nOrbE, Nv4Ints, &
                     PosM1, PosM2, PosT, PosV1, PosV2, PosV3, PosV4, PosX, w3abcy, w3aby, w4abcdy, w4aby
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: NSGrp
#endif
real(kind=wp) :: e2, e2os
logical(kind=iwp) :: Found
character(len=24) :: Label
character(len=10) :: LunName10
character(len=8) :: LunName8
character(len=6) :: LunName
integer(kind=iwp), external :: isfreeunit

! Def parameters
call DefParReord(NaGrpR,maxdim)
NaGrp = NaGrpR
NaSGrp = NaSGrpR
NbeGrp = NaGrpR
NbeSGrp = NaSGrpR
call DefParo2v4(NaGrp,NbeGrp,NaSGrp,NbeSgrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
if (printkey >= 10) write(u6,*) ' Maxdim',maxdim,mdSGrpa

! Distribute memory
PosT = PosFree
call DistMemReord(maxdim,mdSGrpa,NchBlk,PosV1,PosV2,PosV3,PosV4,PosM1,PosM2,PosT)
if (printkey >= 10) write(u6,*) ' Last Value :',PosT,wrksize
if (PosT > wrksize) then
  !mp write(u6,*) ' Nieje dobre - Reord_chcc, Dr. Ch. Kokotopuloss',
  write(u6,*) ' Not Enough memory in Reord_chcc step! Increase large and/or small segmentation ', &
              real(PosT,kind=wp)/real(wrksize,kind=wp)
  call abend()
end if

! Get Orbital energies

!nOrbE = nfr+no+nv ! wrong size if ndel/=0
call Get_iArray('nBas',idum,1) ! must read always nBas fr runf
nOrbE = idum(1)
Label = 'OrbE'
call qpg_dArray(Label,Found,nOrbE)
if ((.not. Found) .or. (nOrbE == 0)) call SysAbendMsg('get_orbe','Did not find:',Label)
call Get_dArray(Label,wrk(PosOE),nOrbE)
if (printkey >= 10) then ! toto som si nie isty
  do i=1,nfr+no+nv
    write(u6,*) i,wrk(PosOE+i-1)
  end do
end if

! skip frozen OE
PosOE = PosOE+nfr

! Make Foo,Fvv,Fov
! N.B. Ked bude OE(q) ine ako Fqq,  alebo F nediagonalny,
!      bude treba urobit inak

dim_1 = no*no
wrk(PosFoo:PosFoo+dim_1-1) = Zero
dim_1 = nv*nv
wrk(PosFvv:PosFvv+dim_1-1) = Zero
dim_1 = nv*no
wrk(PosFvo:PosFvo+dim_1-1) = Zero

! Escape, if Reord is not needed

if (generkey == 0) return

! ------- part 1, read  data form _CD file
!         and distributed in the form L(p',q',m') ------

! open _CD file and initialize parameters

!mp <new 21/04/09
LunChVF = 80
LunChVF = isfreeunit(LunChVF)
!mp >
call DaName_mf_wa(LunChVF,'CD1tmp')

#ifdef _MOLCAS_MPP_
ncLoc = NChLoc(myRank)
#else
ncLoc = nc
#endif

Nch = 1
ChLow = 1
ChUp = NChBlk
DimCh(1) = ChUp-ChLow+1
idisk = 1
!mp
if (printkey >= 10) then
  write(u6,*)
  write(u6,*) 'ncLoc ',ncLoc
  write(u6,*)
end if
!mp

!* read the block into V1(p,q,m') from _CD1
do
  dim_1 = (no+nv)*(no+nv)*DimCh(NCh)
  if (printkey >= 10) write(u6,*) 'Read _CD1',DimCh(NCh),dim_1,idisk
  call ddafile(LunChVF,2,wrk(PosV1),dim_1,idisk)

  !1.1 Extract L0(ij,m')

  dimc = DimCh(NCh)
  nbs = no+nv
  dimij = nTri_Elem(no)
  call Ext_L0(wrk(PosV1),wrk(PosV2),no,dimij,dimc,nbs)

  LunName = L0Name
  dim_1 = dimij*dimc
  if (ChLow == 1) then
    call SaveX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
  else
    call SaveX(wrk(PosV2),dim_1,LunAux,LunName,3,1)
  end if

  !1.2 Extract L1(i,a',m')

  adda = 0
  do aGrp=1,NaGrpR
    dima = DimGrpaR(aGrp)

    dimc = DimCh(NCh)
    nbs = no+nv
    call Ext_L1(wrk(PosV1),wrk(PosV2),no,dima,dimc,adda+no,nbs)

    LunName = L1Name(aGrp)
    dim_1 = dima*no*dimc
    if (ChLow == 1) then
      call SaveX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
    else
      call SaveX(wrk(PosV2),dim_1,LunAux,LunName,3,1)
    end if

    adda = adda+dima
  end do

  !1.3 Extract L2(a'b',m')

  adda = 0
  do aGrp=1,NaGrpR
    dima = DimGrpaR(aGrp)

    addb = 0
    do bGrp=1,aGrp
      dimb = DimGrpaR(bGrp)

      dimc = DimCh(NCh)
      nbs = no+nv
      if (aGrp == bGrp) then
        dimab = nTri_Elem(dima)
        call Ext_L2s(wrk(PosV1),wrk(PosV2),dima,dimab,dimc,adda+no,addb+no,nbs)
      else
        dimab = dima*dimb
        call Ext_L2u(wrk(PosV1),wrk(PosV2),dima,dimb,dimc,adda+no,addb+no,nbs)
      end if

      LunName = L2Name(aGrp,bGrp)
      dim_1 = dimab*dimc
      if (ChLow == 1) then
        call SaveX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
      else
        call SaveX(wrk(PosV2),dim_1,LunAux,LunName,3,1)
      end if

      addb = addb+dimb
    end do
    adda = adda+dima
  end do

  !* Upgrade parameters, if needed
  if (ChUp >= ncLoc) exit
  Nch = Nch+1
  ChLow = ChLow+DimCh(Nch-1)
  if ((ChUp+NChBlk) > ncLoc) then
    ChUp = ncLoc
  else
    ChUp = ChUp+NChBlk
  end if
  DimCh(Nch) = ChUp-ChLow+1
end do

! close _CD file

call DaClos(LunChVF)

! ------- part 2, read data in the form L(p',q',m')
!         and redistributed in the form L(m,p'q')   --------

!2.1 Reorder L0(ij,m') to L0(ml,ij)

LunName = L0Name
dimij = nTri_Elem(no)

!2.1.1 get L0(ij,ml) into V1(ij,ml)

if (NCh == 1) then
  ! all in one
  dim_1 = dimij*ncLoc
  call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

else if (NCh == 2) then
  ! all in two
  PosX = PosV1
  dim_1 = dimij*DimCh(1)
  call GetX(wrk(PosX),dim_1,LunAux,LunName,1,0)
  PosX = PosV1+dim_1
  dim_1 = dimij*DimCh(2)
  call GetX(wrk(PosX),dim_1,LunAux,LunName,0,1)

else
  ! more than 2 records
  PosX = PosV1
  dim_1 = dimij*DimCh(1)
  call GetX(wrk(PosX),dim_1,LunAux,LunName,1,0)
  do i=2,NCh-1
    PosX = PosX+dim_1
    dim_1 = dimij*DimCh(i)
    call GetX(wrk(PosX),dim_1,LunAux,LunName,0,0)
  end do
  PosX = PosX+dim_1
  dim_1 = dimij*DimCh(NCh)
  call GetX(wrk(PosX),dim_1,LunAux,LunName,0,1)

end if

!2.1.2 map V1(ij,ml) -> V2(ml,ij)

call Map2_21(wrk(PosV1),wrk(PosV2),dimij,ncLoc)

!2.1.3 write L0 = V2(ml,ij) back into file

dim_1 = dimij*ncLoc
call SaveX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

!2.2 Reorder L1(i,a',m') to L1(ml,i,a')

do aGrp=1,NaGrpR
  dima = DimGrpaR(aGrp)
  LunName = L1Name(aGrp)

  !2.2.1 get L1(i,a',ml) into V1(i,a',ml)

  if (NCh == 1) then
    ! all in one
    dim_1 = no*dima*ncLoc
    call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

  else if (NCh == 2) then
    ! all in two
    PosX = PosV1
    dim_1 = no*dima*DimCh(1)
    call GetX(wrk(PosX),dim_1,LunAux,LunName,1,0)
    PosX = PosV1+dim_1
    dim_1 = no*dima*DimCh(2)
    call GetX(wrk(PosX),dim_1,LunAux,LunName,0,1)

  else
    ! more than 2 records
    PosX = PosV1
    dim_1 = no*dima*DimCh(1)
    call GetX(wrk(PosX),dim_1,LunAux,LunName,1,0)
    do i=2,NCh-1
      PosX = PosX+dim_1
      dim_1 = no*dima*DimCh(i)
      call GetX(wrk(PosX),dim_1,LunAux,LunName,0,0)
    end do
    PosX = PosX+dim_1
    dim_1 = no*dima*DimCh(NCh)
    call GetX(wrk(PosX),dim_1,LunAux,LunName,0,1)

  end if

  !2.2.2 map V1(i,a',ml) -> V2(ml,i,a')

  call Map2_21(wrk(PosV1),wrk(PosV2),no*dima,ncLoc)

  !2.2.3 write L1 = V2(ml,i,a') back into file

  dim_1 = no*dima*ncLoc
  call SaveX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

end do

!2.3 Reorder L2(a'b',m') to L2(ml,a'b')

do aGrp=1,NaGrpR
  dima = DimGrpaR(aGrp)
  do bGrp=1,aGrp
    dimb = DimGrpaR(bGrp)
    if (aGrp == bGrp) then
      dimab = nTri_Elem(dima)
    else
      dimab = dima*dimb
    end if
    LunName = L2Name(aGrp,bGrp)

    !2.3.1  get L2(a'b',ml) into V1(a'b',ml)

    if (NCh == 1) then
      ! all in one
      dim_1 = dimab*ncLoc
      call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

    else if (NCh == 2) then
      ! all in two
      PosX = PosV1
      dim_1 = dimab*DimCh(1)
      call GetX(wrk(PosX),dim_1,LunAux,LunName,1,0)
      PosX = PosV1+dim_1
      dim_1 = dimab*DimCh(2)
      call GetX(wrk(PosX),dim_1,LunAux,LunName,0,1)

    else
      ! more than 2 records
      PosX = PosV1
      dim_1 = dimab*DimCh(1)
      call GetX(wrk(PosX),dim_1,LunAux,LunName,1,0)
      do i=2,NCh-1
        PosX = PosX+dim_1
        dim_1 = dimab*DimCh(i)
        call GetX(wrk(PosX),dim_1,LunAux,LunName,0,0)
      end do
      PosX = PosX+dim_1
      dim_1 = dimab*DimCh(NCh)
      call GetX(wrk(PosX),dim_1,LunAux,LunName,0,1)

    end if

    !2.3.2 map V1(a'b',ml) -> V2(ml,a'b')

    call Map2_21(wrk(PosV1),wrk(PosV2),dimab,ncLoc)

    !2.3.3 write L2 = V2(ml,a'b') back into file

    dim_1 = dimab*ncLoc
    call SaveX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

  end do
end do

!2.4 reconstructing L0-L2 (Global, m=nc) ---
!    from Local L0-L2 (ml=NChLoc(myRank))
!    if needed (JoinLKey=1)

if (JoinLkey == 1) then
  if (ncLoc < nc) then
    call JoinLvec(wrk,wrksize,PosV1,PosV2,NaGrpR,LunAux)
    ncLoc = nc
  end if
end if

! ------- part 3, produce I integrals from Cholesky vectors
!
!3.1 Generate I0(ij,kl)

!3.124.1 read V4(ml,ij) <- L0(ml,ij)
LunName = L0name
dimij = nTri_Elem(no)
call GetX(wrk(PosV4),ncLoc*dimij,LunAux,LunName,1,1)

!3.1.2 V1(ij,kl) = V4(T)(ml,ij) . V4(ml,kl)
dim_1 = dimij*dimij
wrk(PosV1:PosV1+dim_1-1) = Zero
call mc0c1at3b(ncLoc,dimij,ncLoc,dimij,dimij,dimij,dimij,ncLoc,dimij,wrk(PosV4),wrk(PosV4),wrk(PosV1))

#ifdef _MOLCAS_MPP_
!## Synchronizacny bod
!3.1.3 Allreduce V1
if (ncLoc < nc) then
  dim_1 = dimij*dimij
  call gadgop(wrk(PosV1),dim_1,'+')
end if
#endif

!3.1.4 write V1(ij,kl)
LunName = I0name
dim_1 = dimij*dimij
call SaveX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

!3.23 generate I1(a'i,jk), I2(a'i,b'j) :-)

e2 = Zero
e2os = Zero

addb = 0
do bGrp=1,NaGrpR
  dimb = DimGrpaR(bGrp)

  !3.23.2 read V2(ml,i,b') <- L1(ml,i,b')
  LunName = L1name(bGrp)
  dim_1 = ncLoc*no*dimb
  call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

  !3.23.3 Map V3(ml,b',i) <- V2(ml,i,b')
  call Map3_132(wrk(PosV2),wrk(PosV3),ncLoc,no,dimb)

  !3.2.4 calc V1(b',i,kl) <<- V3(T)(ml,b',i) . V4(ml,kl)
  !Bug dim_1 = no*dima*dimij
  dim_1 = no*dimb*dimij
  wrk(PosV1:PosV1+dim_1-1) = Zero
  call mc0c1at3b(ncLoc,dimb*no,ncLoc,dimij,dimb*no,dimij,dimb*no,ncLoc,dimij,wrk(PosV3),wrk(PosV4),wrk(PosV1))

# ifdef _MOLCAS_MPP_
  !## Synchronizacny bod
  !3.2.5 Allreduce V1
  if (ncLoc < nc) then
    dim_1 = no*dimb*dimij
    call gadgop(wrk(PosV1),dim_1,'+')
  end if
# endif

  !3.2.6 write V1(b',i,kl)
  LunName = I1name(bGrp)
  dim_1 = no*dimb*dimij
  call SaveX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

  adda = 0
  do aGrp=1,NaGrpR
    dima = DimGrpaR(aGrp)
    if (printkey >= 10) write(u6,*) aGrp,bGrp,dima,dimb

    !3.3.4 read V1(ml,i,a)
    LunName = L1name(aGrp)
    dim_1 = ncLoc*no*dima
    call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

    !3.3.5 Map V2(ml,a',i) <- V1(ml,i,a')
    call Map3_132(wrk(PosV1),wrk(PosV2),ncLoc,no,dima)

    !3.3.6 V1(a',i,b',j) <<- V2(T)(ml,a',i) . V3(ml,b',j)
    dim_1 = no*no*dima*dimb
    wrk(PosV1:PosV1+dim_1-1) = Zero
    call mc0c1at3b(ncLoc,dima*no,ncLoc,dimb*no,dima*no,dimb*no,dima*no,ncLoc,dimb*no,wrk(PosV2),wrk(PosV3),wrk(PosV1))

#   ifdef _MOLCAS_MPP_
    !## Synchronizacny bod
    !3.3.7 Allreduce V1
    if (ncLoc < nc) then
      dim_1 = no*no*dima*dimb
      call gadgop(wrk(PosV1),dim_1,'+')
    end if
#   endif

    !3.3.8 write V1(a',i,b',j)
    LunName = I2name(aGrp,bGrp)
    dim_1 = no*dima*no*dimb
    call SaveX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

    !3.3.x cierny vypocet E2
    call CVE2(wrk(PosV1),wrk(PosOE),dima,dimb,adda+no,addb+no,no,e2,e2os)

    !3.3.x Make V2(ab',i,j) <- V1(a',i,b',j)/Dijab
    if (aGrp == bGrp) then
      call MkT20p(wrk(PosV2),wrk(PosV1),wrk(PosOE),dima,adda+no,no)
    else
      call MkT20u(wrk(PosV2),wrk(PosV1),wrk(PosOE),dima,dimb,adda+no,addb+no,no)
    end if

    !3.3.x Save V2 - T2(0) into T2Name
    LunName = T2Name(aGrp,bGrp)
    if (aGrp == bGrp) then
      dim_1 = nTri_Elem(dima)*no*no
    else
      dim_1 = dima*dimb*no*no
    end if
    call SaveX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

    adda = adda+dima
  end do

  addb = addb+dimb
end do

write(6,*)
write(u6,92) ' E2 MP2    :',e2
write(u6,92) ' E2 ss     :',e2-e2os
write(u6,92) ' E2 os     :',e2os
write(u6,*)

!3.4 generate I3(a'b'|ij)

adda = 0
do aGrp=1,NaGrpR
  dima = DimGrpaR(aGrp)

  addb = 0
  do bGrp=1,aGrp
    dimb = DimGrpaR(bGrp)

    !3.4.2 read V2(ml,a'b')
    LunName = L2name(aGrp,bGrp)
    if (aGrp == bGrp) then
      dimab = nTri_Elem(dima)
    else
      dimab = dima*dimb
    end if
    call GetX(wrk(PosV2),ncLoc*dimab,LunAux,LunName,1,1)

    !3.4.3 V1(a'b',ij) <<- V2(T)(ml,a'b') . V4(ml,ij)
    wrk(PosV1:PosV1+dimab*dimij-1) = Zero
    call mc0c1at3b(ncLoc,dimab,ncLoc,dimij,dimab,dimij,dimab,ncLoc,dimij,wrk(PosV2),wrk(PosV4),wrk(PosV1))

#   ifdef _MOLCAS_MPP_
    !## Synchronizacny bod
    !3.4.4 Allreduce V1
    if (ncLoc < nc) then
      dim_1 = dimij*dimab
      call gadgop(wrk(PosV1),dim_1,'+')
    end if
#   endif

    !3.4.5 write V1(a',i,b',j)
    LunName = I3name(aGrp,bGrp)
    dim_1 = dimij*dimab
    call SaveX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

    adda = adda+dima
  end do

  addb = addb+dimb
end do

!3.5 reconstructing L0-L2 (Global, m=nc) ---
!    from Local L0-L2 (ml=NChLoc(myRank))
!    if needed (JoinLKey=2)

if (JoinLkey == 2) then
  if (ncLoc < nc) then
    call JoinLvec(wrk,wrksize,PosV1,PosV2,NaGrpR,LunAux)
    ncLoc = nc
  end if
end if

! in W3 and W4 files are not generated, finish
if (intkey == 0) return

! ------- part 5, produce (vv|vo) and (vv|vv) integrals
!         for integral based approach
!         all terminology in o2v4 language
!
! Extra cost: Mult. read - Na*(Na+1)/2 . L2(m,cd)
!                        - Na*(Na+1)/2 . L1(m,ci)
!
! N.B.
! - Ak je L2 uz spojene (ncLoc=nc) a W34DistKey=1
!   potom sa obskakuju ani nepisu tie kombinacie, ktore na
!   tomto node netreba (vhodne pre velke nProcs aj pri rychlej
!   sieti, pre pomalu siet aj pre mensie nProcs)
! - Ak L2 este nieje spojene (ncLoc<nc) a W34DistKey=1
!   potom sa nic neobskakuje, vsetky W3 a W4 sa pocitaju
!   a allreducuju, ale sa nepisu na disk ak ich na tomto
!   node netreba, cim sa setri miesto
!   (vhodne pre mensie nProcs a rychlu siet)
! - Ak L2 este nieje spojene (ncLoc<nc) a W34DistKey=0
!   potom sa nic neobskakuje, vsetky W3 a W4 sa pocitaju
!   a allreducuju, a pisu sa na disk vsade,
!   cim sa nesetri miesto, ale vsade su vsetky W3,4
!   (zbytocny pripad, pokial sa nechceme hrat s load-ballance
!   a nepotrebujeme mat vsade vsetko)
! - Paralelny pripad (ncLoc=nc) a W34DistKey=0
!   bude pocitat iba kokot
! - Osetrene na paralelny Nprocs=1, aj na skalarny case

#ifdef _MOLCAS_MPP_

if (W34DistKey == 1) then
  ! case: Ditributed W34 files
  !*.1 make a map, which W3 and W4 files are needed on this node
  !    i.e. def InqW3, InqW4
  call Xo2v4ctl(NaGrp,NaSGrp)

else
  ! case: All W34 files on each node
  !*.1 set InqW3,InqW4 - True
  NSGrp = NaGrp*NaSGrp
  InqW3(1:nTri_Elem(NSGrp),1:NSGrp) = .true.
  InqW4(1:nTri_Elem(NSGrp),1:nTri_Elem(NSGrp)) = .true.

end if

#endif

Nv4Ints = 0

! cycle over a'>=b' groups
adda = 0
do aGrp=1,NaGrp
  dima = DimGrpa(aGrp)
  addb = 0
  do bGrp=1,aGrp
    dimb = DimGrpa(bGrp)
    abGrp = nTri_Elem(aGrp-1)+bGrp

    if (printkey >= 10) write(u6,*) ' W3 + W4 ',aGrp,bGrp

    ! test, if at least one file of W3/W4 integrals
    ! needs to be calculated on this node for given a',b'
    ! skip, if there is nothing to calculate for this a'b'
    ! on this node and L is joined (ncLoc=nc)
    call DefW34y(aGrp,bGrp,w3aby,w4aby,NaGrp)
    if ((w3aby+w4aby /= 0) .or. (ncLoc /= nc)) then

      ! read V2(ml,a'b') = L2(ml,a'b')
      LunName = L2name(aGrp,bGrp)
      if (aGrp == bGrp) then
        dimab = nTri_Elem(dima)
      else
        dimab = dima*dimb
      end if
      call GetX(wrk(PosV2),ncLoc*dimab,LunAux,LunName,1,1)

      ! ---- Part 5.1 - Generation of (ab|ci) integrals ----
      !      (Svincaja morda)

      ! skip, if there is no W3 file to calculate for this a'b'
      ! on this node and L is joined (ncLoc=nc)
      if ((w3aby /= 0) .or. (ncLoc /= nc)) then

        ! cycle over c' groups
        addc = 0
        do cGrp=1,NaGrp
          dimc = DimGrpa(cGrp)

          ! test, if at least one file of W3 integrals
          ! needs to be calculated on this node for given a',b',c'
          ! and skip, if there is nothing to calculate for this a',b',c'
          ! on this node and L is joined (ncLoc=nc)
          call DefW3y(aGrp,bGrp,cGrp,w3abcy)
          if ((w3abcy /= 0) .or. (ncLoc /= nc)) then

            ! Get V3(ml,c',i)
            ! Read V1(ml,i,c') <- L1(ml,i,c)
            dimci = dimc*no
            LunName = L1Name(cGrp)
            call GetX(wrk(PosV1),ncLoc*dimci,LunAux,LunName,1,1)
            ! Map V3(ml,c',i) <- V1(ml,i,c')
            call Map3_132(wrk(PosV1),wrk(PosV3),ncLoc,no,dimc)

            ! cycle over a">=b" subgroups
            addapp = 0
            do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
              dimapp = DimSGrpa(aSGrp)
              if (aGrp == bGrp) then
                bSGrpUp = aSGrp
              else
                bSGrpUp = GrpaUp(bGrp)
              end if
              addbpp = 0
              do bSGrp=GrpaLow(bGrp),bSGrpUp
                dimbpp = DimSGrpa(bSGrp)
                abSGrp = nTri_Elem(aSGrp-1)+bSGrp

                ! Extract M1(ml,a"b") <- V2(ml,a'b')
                if (aSGrp == bSGrp) then
                  dimabpp = nTri_Elem(dimapp)
                else
                  dimabpp = dimapp*dimbpp
                end if
                call Ext_W4(wrk(PosV2),wrk(PosM1),ncLoc,dima,dimb,dimab,dimapp,dimbpp,dimabpp,addapp,addbpp,aGrp,bGrp,aSGrp,bSGrp)

                ! cycle over c" subgroups
                addcpp = 0
                do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
                  dimcpp = DimSGrpa(cSGrp)

#                 ifdef _MOLCAS_MPP_
                  ! skip, if W3(a"b",c"i) is not needed on this node
                  ! and L is joined (ncLoc=nc)
                  if ((InqW3(abSGrp,cSGrp)) .or. (ncLoc /= nc)) then
#                 endif

                    ! Extract M2(ml,c",i) <- V3(ml,c',i)
                    call Ext_W3(wrk(PosV3),wrk(PosM2),ncLoc,no,dimc,dimcpp,addcpp)

                    ! Calc V1(a"b",c"i) <- M1(T)(ml,a"b") . M2(ml,c",i)
                    dim_1 = dimcpp*no
                    wrk(PosV1:PosV1+dimabpp*dim_1-1) = Zero
                    call mc0c1at3b(ncLoc,dimabpp,ncLoc,dim_1,dimabpp,dim_1,dimabpp,ncLoc,dim_1,wrk(PosM1),wrk(PosM2),wrk(PosV1))

#                   ifdef _MOLCAS_MPP_
                    !## Synchronizacny bod
                    ! Allreduce V1
                    if (ncLoc < nc) then
                      dim_1 = dimabpp*dimcpp*no
                      call gadgop(wrk(PosV1),dim_1,'+')
                    end if
                    ! skip, if W3(a"b",c"i) is not needed on this node
                    if (InqW3(abSGrp,cSGrp)) then
#                   endif

                      ! Create Proper LunName8
                      call MkNameV3(aSGrp,bSGrp,cSGrp,'W3',LunName8)

                      ! Write integral block to proper file
                      !open(unit=LunAux,file=LunName8,form='unformatted')
                      call MOLCAS_BinaryOpen_Vanilla(LunAux,LunName8)
                      call wri_chcc(LunAux,dimabpp*dimcpp*no,wrk(PosV1))
                      close(LunAux)
#                 ifdef _MOLCAS_MPP_
                    end if
                  end if
#                 endif

                  ! end cycle over c" subgroups
                  addcpp = addcpp+dimcpp
                end do

                ! end cycle over a">=b" subgroups
                addbpp = addbpp+dimbpp
              end do
              addapp = addapp+dimapp
            end do
          end if

          ! end cycle over c' groups
          addc = addc+dimc
        end do
      end if

      ! ---- Part 5.2 - Generation of (ab|cd) integrals ----
      !     (Kobyljacaja sraka)

      ! skip, if there is no W4 file to calculate for this a'b'
      ! on this node and L is joined (ncLoc=nc)
      if ((w4aby /= 0) .or. (ncLoc /= nc)) then

        ! cycle over c'>=d' groups
        addc = 0
        do cGrp=1,NaGrp
          dimc = DimGrpa(cGrp)
          addd = 0
          do dGrp=1,cGrp
            dimd = DimGrpa(dGrp)
            cdGrp = nTri_Elem(cGrp-1)+dGrp
            if (cGrp <= aGrp) then

              ! test, if at least one file of W4 integrals
              ! needs to be calculated on this node for given a',b',c',d'
              ! and skip, if there is nothing to calculate for this
              ! a',b',c',d' on this node and L is joined (ncLoc=nc)
              call DefW4y(aGrp,bGrp,cGrp,dGrp,w4abcdy)
              if ((w4abcdy /= 0) .or. (ncLoc /= nc)) then

                ! read V3(ml,c'd') = L2(ml,c'd')
                if (abGrp == cdGrp) then
                  dimcd = dimab
                  wrk(PosV3:PosV3+ncLoc*dimcd-1) = wrk(PosV2:PosV2+ncLoc*dimcd-1)
                else
                  LunName = L2name(cGrp,dGrp)
                  if (cGrp == dGrp) then
                    dimcd = nTri_Elem(dimc)
                  else
                    dimcd = dimc*dimd
                  end if
                  call GetX(wrk(PosV3),ncLoc*dimcd,LunAux,LunName,1,1)
                end if

                ! cycle over a">=b" subgroups
                addapp = 0
                do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
                  dimapp = DimSGrpa(aSGrp)
                  if (aGrp == bGrp) then
                    bSGrpUp = aSGrp
                  else
                    bSGrpUp = GrpaUp(bGrp)
                  end if
                  addbpp = 0
                  do bSGrp=GrpaLow(bGrp),bSGrpUp
                    dimbpp = DimSGrpa(bSGrp)
                    abSGrp = nTri_Elem(aSGrp-1)+bSGrp

                    ! test, if at least one file of W4 integrals
                    ! needs to be calculated on this node for given a",b",c',d'
                    ! and skip, if there is nothing to calculate for this
                    ! a",b",c',d' on this node and L is joined (ncLoc=nc)
                    call DefW4y2(aSGrp,bSGrp,cGrp,dGrp,w4abcdy)
                    if ((w4abcdy /= 0) .or. (ncLoc /= nc)) then

                      ! Extract M1(ml,a"b") <- V2(ml,a'b')
                      if (aSGrp == bSGrp) then
                        dimabpp = nTri_Elem(dimapp)
                      else
                        dimabpp = dimapp*dimbpp
                      end if
                      call Ext_W4(wrk(PosV2),wrk(PosM1),ncLoc,dima,dimb,dimab,dimapp,dimbpp,dimabpp,addapp,addbpp,aGrp,bGrp,aSGrp, &
                                  bSGrp)

                      ! cycle over c">=d" subgroups
                      addcpp = 0
                      do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
                        dimcpp = DimSGrpa(cSGrp)
                        if (cGrp == dGrp) then
                          dSGrpUp = cSGrp
                        else
                          dSGrpUp = GrpaUp(dGrp)
                        end if
                        adddpp = 0
                        do dSGrp=GrpaLow(dGrp),dSGrpUp
                          dimdpp = DimSGrpa(dSGrp)
                          cdSGrp = nTri_Elem(cSGrp-1)+dSGrp
                          if (cdSGrp <= abSGrp) then

#                           ifdef _MOLCAS_MPP_
                            ! skip, if W4(a"b",c"d") is not needed on this node
                            ! and L is joined (ncLoc=nc)
                            if ((InqW4(abSGrp,cdSGrp)) .or. (ncLoc /= nc)) then
#                           endif

                              ! Extract M2(ml,a"b") <- V3(ml,a'b')
                              if (cSGrp == dSGrp) then
                                dimcdpp = nTri_Elem(dimcpp)
                              else
                                dimcdpp = dimcpp*dimdpp
                              end if
                              call Ext_W4(wrk(PosV3),wrk(PosM2),ncLoc,dimc,dimd,dimcd,dimcpp,dimdpp,dimcdpp,addcpp,adddpp,cGrp, &
                                          dGrp,cSGrp,dSGrp)

                              ! Calc V1(a"b",c"d") <- M1(T)(ml,a"b") . M2(ml,c"d")
                              dim_1 = dimabpp*dimcdpp
                              wrk(PosV1:PosV1+dim_1-1) = Zero
                              call mc0c1at3b(ncLoc,dimabpp,ncLoc,dimcdpp,dimabpp,dimcdpp,dimabpp,ncLoc,dimcdpp,wrk(PosM1), &
                                             wrk(PosM2),wrk(PosV1))

#                             ifdef _MOLCAS_MPP_
                              !## Synchronizacny bod
                              ! Allreduce V1
                              if (ncLoc < nc) then
                                dim_1 = dimabpp*dimcdpp
                                call gadgop(wrk(PosV1),dim_1,'+')
                              end if
                              ! skip, if W4(a"b",c"d") not needed on this node
                              if (InqW4(abSGrp,cdSGrp)) then
#                             endif

                                ! Def proper LunName10
                                call MkNameV4(aSGrp,bSGrp,cSGrp,dSGrp,'W4',LunName10)

                                ! Write integral block to proper file
                                !open(unit=LunAux,file=LunName10,form='unformatted')
                                call MOLCAS_BinaryOpen_Vanilla(LunAux,LunName10)
                                call wri_chcc(LunAux,dimabpp*dimcdpp,wrk(PosV1))
                                close(LunAux)
                                Nv4Ints = Nv4Ints+dimabpp*dimcdpp
#                           ifdef _MOLCAS_MPP_
                              end if
                            end if
#                           endif
                          end if

                          ! end cycle over c">=d" subgroups
                          adddpp = adddpp+dimdpp
                        end do
                        addcpp = addcpp+dimcpp
                      end do
                    end if

                    ! end cycle over a">=b" subgroups
                    addbpp = addbpp+dimbpp
                  end do
                  addapp = addapp+dimapp
                end do
              end if
            end if

            ! end cycle over c'>=d' groups
            addd = addd+dimd
          end do
          addc = addc+dimc
        end do
      end if
    end if

    ! end cycle over a'>=b' groups
    addb = addb+dimb
  end do
  adda = adda+dima
end do

write(u6,*) ' V4 ints compressing factor: ',real(nv*nv*nv*nv,kind=wp)/Nv4Ints

!5.3 reconstructing L0-L2 (Global, m=nc) ---
!    if needed (JoinLKey=3)

if (JoinLkey == 3) then
  if (ncLoc < nc) then
    call JoinLvec(wrk,wrksize,PosV1,PosV2,NaGrpR,LunAux)
    ncLoc = nc
  end if
end if

return

92 format(a12,1x,f15.12)

end subroutine Reord_chcc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RToCore(F,nBeta,ishll,lb,iAng,nveccb)

!***********************************************************************
!
! Transformation kernel to atomic orbitals in normalized spherical harmonics
!
!***********************************************************************
! @parameter F The cartesian components of <A|core>
! @parameter nBeta Number of exponents
! @parameter ishll Shell number for ECP
! @parameter lb angular momenta Ket
! @parameter iAng angular momenta core
! @parameter nveccb Number of derivatives
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Real_Spherical, only: ipSph, RSph
use Basis_Info, only: Shells
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: F(*)
integer(kind=iwp), intent(in) :: nBeta, ishll, lb, iAng, nveccb
integer(kind=iwp) :: nBasisi, ncb, nExpi
real(kind=wp), allocatable :: Tmp1(:), Tmp2(:)

!***********************************************************************
ncb = nTri_Elem1(lb)*nTri_Elem1(iang)
nExpi = Shells(iShll)%nExp
nBasisi = Shells(iShll)%nBasis
call mma_allocate(TMP1,nExpi*ncb*nVecCB*nBeta,Label='Tmp1')
call mma_allocate(TMP2,nExpi*ncb*nVecCB*nBeta,Label='Tmp2')

! And (almost) the same thing for the righthand side, form
! KjCb from kjcb
! 1) jcb,K = k,jcb * k,K

call DGEMM_('T','N',nBeta*ncb*nVecCB,nBasisi,nExpi,One,F,nExpi,Shells(iShll)%pCff,nExpi,Zero,Tmp1,nBeta*ncb*nVecCB)

! 2) j,cbK -> cbK,j

call DgeTMo(Tmp1,nBeta,nBeta,ncb*nVecCB*nBasisi,Tmp2,ncb*nVecCB*nBasisi)

! 3) bKj,C = c,bKj * c,C

call DGEMM_('T','N',nTri_Elem1(lb)*nVecCB*nBasisi*nBeta,(2*iAng+1),nTri_Elem1(iAng),One,Tmp2,nTri_Elem1(iAng),RSph(ipSph(iAng)), &
            nTri_Elem1(iAng),Zero,Tmp1,nTri_Elem1(lb)*nVecCB*nBasisi*nBeta)

! 4) b,KjC -> KjC,b

call DgeTMo(Tmp1,nTri_Elem1(lb)*nVecCB,nTri_Elem1(lb)*nVecCB,nBasisi*nBeta*(2*iAng+1),F,nBasisi*nBeta*(2*iAng+1))

call mma_deallocate(Tmp2)
call mma_deallocate(Tmp1)

return

end subroutine RToCore

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Min_Mult_Error(EC,A,B,Ci,Cj,rMP,xrMP,xxrMP,xnrMP,lMax,nij,nElem,iAtom,jAtom,nAtoms,nPert,C_o_C,Scratch_New,Scratch_Org, &
                          iPlot,T_Value,iWarning,Num_Warnings)

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: lMax, nij, nElem, iAtom, jAtom, nAtoms, nPert, iPlot
real(kind=wp), intent(in) :: EC(3,nij), Ci(3), Cj(3), rMP(nij,0:nElem-1,0:nPert-1), xnrMP(nij,nElem), C_o_C(3)
real(kind=wp), intent(inout) :: A(3,nij), B(3,nij)
real(kind=wp), intent(out) :: xrMP(nij,nElem), xxrMP(nij,nElem), Scratch_New(nij*(2+lMax+1)), Scratch_Org(nij*(2+lMax+1)), T_Value
integer(kind=iwp), intent(inout) :: iWarning, Num_Warnings
integer(kind=iwp) :: i, ij, iPrint_Errors, iSlope, iSlope_old, l, num_min
real(kind=wp) :: ax, bx, cx, Delta, Delta_Error, Delta_Orig, Error, Error_Best, Error_old, fa, fb, fc, R_ij(3), t_best, t_final, &
                 t_max, t_min, t_temp
real(kind=wp), parameter :: Error_Threshold = 1.0e-12_wp, Delta_Threshold = 1.0e-12_wp
real(kind=wp), external :: Error_for_t, Golden

ij = iAtom*(iAtom-1)/2+jAtom
iPrint_Errors = 0
l = lMax-1
do i=1,3
  R_ij(i) = Cj(i)-Ci(i)
end do

t_min = Zero
t_max = Zero
do i=1,3
  if (R_ij(i) /= Zero) then
    t_min = (Ci(i)-EC(i,ij))/R_ij(i)
    t_max = (Cj(i)-EC(i,ij))/R_ij(i)
  end if
end do
Delta_Orig = 0.1_wp
Delta = Delta_Orig

! Check the range of possible t-values for minima

num_min = 0
iSlope = 0
if (iPlot == 1) then
  write(u6,*)
  write(u6,*) 'iAtom, jAtom = ',iAtom,jAtom
end if
t_temp = t_min
Error_Best = -One
Error_Old = Zero
t_best = Zero
do
  Error = Error_for_t(t_temp,rMP,xrMP,xxrMP,xnrMP,EC,A,R_ij,C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,Scratch_New,Scratch_Org, &
                      iPrint_Errors)
  if (iPlot == 1) then
    write(u6,'(1X,A,F5.2,F16.12)') 't, Error = ',t_temp,Error
    call xFlush(u6)
  end if
  Delta_Error = Error-Error_Old
  Error_Old = Error
  iSlope_Old = iSlope
  if (abs(Delta_Error) < Error_Threshold) then
    iSlope = 0
  else if (Delta_Error < Zero) then
    iSlope = -1
  else
    iSlope = 1
  end if
  if ((iSlope_Old < 0) .and. (iSlope >= 0)) then
    num_min = num_min+1
  end if
  if ((Error < Error_Best) .or. (Error_Best < Zero)) then
    Error_Best = Error
    t_best = t_temp
  end if
  t_temp = t_temp+Delta*0.1_wp
  if (t_temp > t_max+Delta*0.01_wp) exit
end do

! Any warnings from scan?

if (num_min > 1) then
  iWarning = 1
  Num_Warnings = Num_Warnings+1
end if

! Find minima with Golden Section Search
!
! (It's assumed that the error function is either constant or has at
! least one minima somewhere, although not necessarily within the
! allowed range).

ax = t_best
bx = t_best+Delta
! First make an initial bracketing of the minima
call mnBrak(ax,bx,cx,fa,fb,fc,Error_for_t,rMP,xrMP,xxrMP,xnrMP,EC,A,R_ij,C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,Scratch_New, &
            Scratch_Org,iPrint_Errors)

if (abs(fa-fc) < Error_Threshold) then
  iWarning = 4
  Num_Warnings = Num_Warnings+1
  t_final = Zero
else
  Error = Golden(ax,bx,cx,Error_for_t,Delta_Threshold,Error_Threshold,t_final,rMP,xrMP,xxrMP,xnrMP,EC,A,R_ij,C_o_C,ij,l,nij,lMax, &
                 nElem,nAtoms,nPert,Scratch_New,Scratch_Org,iPrint_Errors)
end if

! Check that the minima is within the allowed range

if (t_final > t_max) then
  t_final = t_max
  iWarning = 2
  Num_Warnings = Num_Warnings+1
else if (t_final < t_min) then
  t_final = t_min
  iWarning = 2
  Num_Warnings = Num_Warnings+1
end if

T_value = t_final
B(1,ij) = EC(1,ij)+t_final*R_ij(1)
B(2,ij) = EC(2,ij)+t_final*R_ij(2)
B(3,ij) = EC(3,ij)+t_final*R_ij(3)

return

end subroutine Min_Mult_Error

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Reset_ThrGrd(nAtom,nDim,dMass,Smmtrc,
     &                 Degen,nIter,Cx,mTtAtm,iAnr,DDV_Schlegel,iOptC,
     &                 rHidden,ThrGrd)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 dMass(nAtom), Degen(3*nAtom), Cx(3*nAtom,nIter)
      Integer iANr(nAtom)
      Logical Smmtrc(3*nAtom),DDV_Schlegel,Found
*                                                                      *
************************************************************************
*                                                                      *
      Call qpg_dArray('Saddle',Found,nSaddle)
      If (.NOT.Found) Return
      iIter = nIter           ! Normal Computation
*                                                                      *
************************************************************************
*                                                                      *
*---- Find the translational and rotational eigenvectors for the
*     current structure.
*
      Call Allocate_Work(ipTR,18*nAtom)
      Call FZero(Work(ipTR),18*nAtom)
*
      Call TRPGen(nDim,nAtom,Cx(1,iIter),Degen,Smmtrc,mTR,dMass,.False.,
     &            Work(ipTR))
*
*     Call RecPrt('Work(ipTR)',' ',Work(ipTR),nDim,mTR)
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('TabAI','Allo','Inte',ip_TabAI,2*mTtAtm)
      Call GetMem('Vect','Allo','Real',ipVec,3*mTtAtm*nDim)
      Call GetMem('AN','Allo','Inte',ipAN,mTtAtm)
      Call GetMem('Coor','Allo','Real',ipCoor,3*mTtAtm)
*
*-----Generate Grand atoms list
*
      Call GenCoo(Cx(1,iIter),nAtom,Work(ipCoor),
     &            mTtAtm,Work(ipVec),Smmtrc,nDim,iAnr,iWork(ipAN),
     &            iWork(ip_TabAI),Degen)
*
*---- Are there some hidden frozen atoms ?
*
      nHidden = 0
      nMDstep = 0
      If (rHidden.ge.Two) Call Hidden(mTtAtm,ipCoor,ipAN,nHidden,
     &                                rHidden,nMDstep)
*
*-----Generate bond list
*
      ThrB=0.0D0  ! dummy
      mTtAtm = mTtAtm+nHidden
      Call Box(Work(ipCoor),mTtAtm,iWork(ipAN),iOptC,
     &         ddV_Schlegel,ip_TabB,ip_TabA,nBonds,nMax,ThrB)
      mTtAtm = mTtAtm-nHidden
*                                                                      *
************************************************************************
*                                                                      *
*     If there are some bond types 2, and we are in saddle
*     far from the TS, let us get a reduced threshold to avoid
*     wasting our time
*
      Call Allocate_Work(ipTmp,nSaddle)
      Call Get_dArray('Saddle',Work(ipTmp),nSaddle)
      Found=.false.
      If (Work(ipTmp+nSaddle-2).gt.0.50d0) Then
         Do i=0,nBonds-1
            If (iWork(ip_TabB+3*i+2).eq.2) Then
               Found=.true.
               Go To 20
            EndIf
         End Do
 20      Continue
         If (Found) Then
*           ThrGrd=0.03D0
            ThrGrd=Ten*ThrGrd
            Call WarningMessage(1,
     &             'Molecule composed of many fragments '//
     &             'Convergence threshold reduced')
         EndIf
      EndIf
      Call Free_Work(ipTmp)
*
      Call Free_iWork(ip_TabA)
      Call Free_iWork(ip_TabB)
      Call GetMem('Coor','Free','Real',ipCoor,3*mTtAtm)
      Call GetMem('AN','Free','Inte',ipAN,mTtAtm)
      Call GetMem('Vect','Free','Real',ipVec,3*mTtAtm*nDim)
      Call GetMem('TabAI','Free','Inte',ip_TabAI,2*mTtAtm)
      Call Free_Work(ipTR)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine nevint(nAshT,INT1,INT2,Hbar,Htilde)

use Index_Functions, only: iTri, nTri_Elem
use CHOVEC_IO, only: NVLOC_CHOBATCH
use caspt2_global, only: FIMO
use caspt2_module, only: IfChol, NAES, NASH, NBSQT, NBTCH, NBTCHES, NISH, NORB, NSYM
use Symmetry_Info, only: Mul
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAshT
real(kind=wp), intent(out) :: INT1(nAshT,nAshT), INT2(nAshT,nAshT,nAshT,nAshT), Hbar(nAshT,nAshT), Htilde(nAshT,nAshT)
integer(kind=iwp) :: iAshI, IB, IB1, IB2, IBEND, IBGRP, IBSTA, IBUF, iOffi, iOffK, iOffp, iOffQ, ISYI, ISYK, iSym, iSymT, iSymU, &
                     iSymV, iSymVX, iSymX, ISYP, ISYQ, IT, ITABS, ITTOT, IU, IUABS, IUTOT, IV, IVABS, IVTOT, IX, IXABS, IXTOT, &
                     jAshI, jSym, kAshI, LBRASM, LKETSM, MXBGRP, MXPIQK, NADDBUF, NBGRP, NBRASM, NCHOBUF, NFIMOES, NFNXT, NI, NK, &
                     nKet, NKETSM, NP, NPI, NQ, NQK, NTUVX, NUMERR, NV
real(kind=wp) :: Scal, tmp
integer(kind=iwp), allocatable :: BGRP(:,:)
real(kind=wp), allocatable :: KET(:), PIQK(:), WRK1(:), WRK2(:)
integer(kind=iwp), parameter :: Inactive = 1, Active = 2, Virtual = 3

INT1(:,:) = Zero
INT2(:,:,:,:) = Zero
Hbar(:,:) = Zero
Htilde(:,:) = Zero

NFNXT = 0
do iSym=1,nSym
  NFIMOES = NFNXT
  NFNXT = NFNXT+nTri_Elem(nOrb(iSym))
  if (nAsh(iSym) == 0) cycle
  do IU=1,nAsh(iSym)
    IUTOT = nIsh(iSym)+IU
    IUABS = IU+nAes(iSym)
    do IT=IU,nAsh(iSym)
      ITTOT = nIsh(iSym)+IT
      ITABS = IT+nAes(iSym)
      IBUF = NFIMOES+iTri(ITTOT,IUTOT)
      tmp = FIMO(IBUF)
      INT1(ITABS,IUABS) = tmp
      INT1(IUABS,ITABS) = tmp
    end do
  end do
end do

Hbar(:,:) = INT1(:,:)
Htilde(:,:) = INT1(:,:)

call mma_allocate(WRK1,NBSQT,Label='WRK1')
call mma_allocate(WRK2,NBSQT,Label='WRK2')

! Two-Electron Integral

!iSymA = 1
!iSymI = 1
!iSymB = 1
!iSymJ = 1
if (IfChol) then
  NTUVX = NASHT**4
  do JSYM=1,NSYM
    IB1 = NBTCHES(JSYM)+1
    IB2 = NBTCHES(JSYM)+NBTCH(JSYM)

    MXBGRP = IB2-IB1+1
    if (MXBGRP <= 0) cycle
    call mma_allocate(BGRP,2,MXBGRP,Label='BGRP')
    IBGRP=1
    do IB=IB1,IB2
     BGRP(:,IBGRP) = IB
     IBGRP=IBGRP+1
    end do
    NBGRP = MXBGRP

    call MEMORY_ESTIMATE(JSYM,BGRP,NBGRP,NCHOBUF,MXPIQK,NADDBUF)
    call mma_allocate(PIQK,MXPIQK,Label='PIQK')
    !call mma_allocate(BRA,NCHOBUF,Label='BRA')
    call mma_allocate(KET,NCHOBUF,Label='KET')
    do IBGRP=1,NBGRP

      IBSTA = BGRP(1,IBGRP)
      IBEND = BGRP(2,IBGRP)

      NV = sum(NVLOC_CHOBATCH(IBSTA:IBEND))

      !! int2(tuvx) = (tu|vx)
      !! This can be computed without frozen orbitals
      call Get_Cholesky_Vectors(Active,Active,JSYM,KET,size(KET),nKet,IBSTA,IBEND)

      LBRASM = 1
      do ISYI=1,NSYM
        NI = NASH(ISYI)
        iOffi = NAES(iSYI)
        if (NI == 0) cycle
        ISYP = Mul(ISYI,JSYM)
        NP = NASH(ISYP)
        iOffp = NAES(iSYP)
        if (NP == 0) cycle
        NPI = NP*NI
        NBRASM = NPI*NV
        LKETSM = 1
        do ISYK=1,NSYM
          NK = NASH(ISYK)
          iOffK = NAES(iSYK)
          if (NK == 0) cycle
          ISYQ = Mul(ISYK,JSYM)
          NQ = NASH(ISYQ)
          iOffQ = NAES(iSYQ)
          if (NQ == 0) cycle
          NQK = NQ*NK
          NKETSM = NQK*NV

          if (NPI*NQK > mxPIQK) then
            write(u6,*) 'NPIQK larger than mxPIQK in TUVX, bug?'
            call AbEnd()
          end if
          call DGEMM_('N','T',NPI,NQK,NV,One,KET(LBRASM),NPI,KET(LKETSM),NQK,Zero,PIQK,NPI)
          call ADDTUVX(NP,NI,NQ,NK,NASHT,iOffP,iOffI,iOffQ,iOffK,INT2,nTUVX,PIQK,NPI*NQK,NUMERR)
          LKETSM = LKETSM+NKETSM
        end do
        LBRASM = LBRASM+NBRASM
      end do

    !if (IBGRP == 1) then
    !  SCAL = Zero
    !else
    !  SCAL = One
    !call DGEMM_('N','T',NASH(JSYM)**2,NASH(JSYM)**2,NV,One ,KET,NASH(JSYM)**2,KET,NASH(JSYM)**2,SCAL,INT2,NASH(JSYM)**2)
    end do
    call mma_deallocate(PIQK)
    !call mma_deallocate(BRA)
    call mma_deallocate(KET)
    call mma_deallocate(BGRP)
  end do
# ifdef _MOLCAS_MPP_
  if (is_real_par()) call GADGOP(INT2,nAshT**4,'+')
# endif
else
  do iSymX=1,nSym
    do iSymV=1,nSym
      iSymVX = Mul(iSymV,iSymX)
      do iSymU=1,nSym
        iSymT = Mul(iSymU,iSymVX)
        do IX=1,nAsh(iSymX)
          IXTOT = nIsh(iSymX)+IX
          IXABS = IX+nAes(iSymX)
          do IV=1,nAsh(iSymV)
            IVTOT = nIsh(iSymV)+IV
            IVABS = IV+nAes(iSymV)
            call Coul(iSymT,iSymU,iSymV,iSymX,IVTOT,IXTOT,WRK1,WRK2)
            do IU=1,nAsh(iSymU)
              IUTOT = nIsh(iSymU)+IU
              IUABS = IU+nAes(iSymU)
              do IT=1,nAsh(iSymT)
                ITTOT = nIsh(iSymT)+IT
                ITABS = IT+nAes(iSymT)
                IBUF = ITTOT+nOrb(iSymT)*(IUTOT-1)
                INT2(ITABS,IUABS,IVABS,IXABS) = WRK1(IBUF)
                !write(u6,'(4i3,f20.10)') itabs,iuabs,ivabs,ixabs,wrk1(ibuf)
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end if
call mma_deallocate(WRK1)
call mma_deallocate(WRK2)

!do isymt=1,nasht
!  do isymu=1,nasht
!    do isymv=1,nasht
!      do isymx=1,nasht
!        write(u6,'(4i3,f20.10)') isymt,isymu,isymv,isymx,int2(isymt,isymu,isymv,isymx)
!      end do
!    end do
!  end do
!end do

! Construct Hbar^eff (after Eq. (A13)) and Htilde

do iAshI=1,NASHT ! nAsh(iSym)
  do jAshI=1,NASHT ! nAsh(iSym)
    Scal = Zero
    do kAshI=1,NASHT ! nAsh(iSym)
      Scal = Scal+INT2(kAshI,jAshI,kAshI,iAshI)
    end do
    Hbar(iAshI,jAshI) = Hbar(iAshI,jAshI)-Half*Scal
    Htilde(iAshI,jAshI) = Htilde(iAshI,jAshI)-Scal
  end do
end do

return

end subroutine nevint

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_1VecRd_SP(Vec,lVec,jVec,iSym,LstSP,nSP,iRedC,iLoc)
!
! Purpose: read vector jVec, sym. iSym, from disk. Read only
!          components from shell pairs in list LstSP. Use scratch
!          location iLoc to set index arrays. On input, iRedC
!          specifies the reduced set available at location iLoc:
!          specify -1 if not set (or unknown). On exit, iRedC
!          identifies the reduced set for which indices are
!          available at location iLoc. NOTE: only WA files!!

use Cholesky, only: Cho_AdrVec, iiBstRSh, InfVec, LuCho, LuPri, nnBstRSh, NumCho
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lVec, jVec, iSym, nSP, LstSP(nSP), iLoc
real(kind=wp), intent(out) :: Vec(lVec)
integer(kind=iwp), intent(inout) :: iRedC
integer(kind=iwp) :: iAdr, iAdr0, iOpt, irc, iRed, iShlAB, iSP, kV, lTot
character(len=*), parameter :: SecNam = 'Cho_1VecRd_SP'
integer(kind=iwp), external :: Cho_P_LocalSP

! Return if no vectors are available on disk.
! -------------------------------------------

if (NumCho(iSym) < 1) return

! Check that vector storage mode is word-addressable (WA).
! --------------------------------------------------------

if (Cho_AdrVec /= 1) then
  write(Lupri,*) SecNam,': WA address mode is required!'
  write(Lupri,*) 'Cho_AdrVec is: ',Cho_AdrVec,' (should be 1)'
  call Cho_Quit('WA address mode is required in '//SecNam,104)
end if

! Get reduced set of this vector.
! -------------------------------

if ((jVec > 0) .and. (jVec <= NumCho(iSym))) then
  iRed = InfVec(jVec,2,iSym)
else
  call Cho_Quit('Red. set error in '//SecNam,104)
  iRed = -999999
end if

! Set reduced set (if needed).
! ----------------------------

if (iRedC /= iRed) then
  call Cho_X_SetRed(irc,iLoc,iRed)
  if (irc /= 0) then
    write(Lupri,*) SecNam,': Cho_X_SetRed returned ',irc
    call Cho_Quit('Error in '//SecNam,104)
  end if
  iRedC = iRed
end if

! Read vector elements.
! ---------------------

iAdr0 = InfVec(jVec,3,iSym)
kV = 1
do iSP=1,nSP
  iShlAB = Cho_P_LocalSP(LstSP(iSP))
  iOpt = 2
  lTot = nnBstRSh(iSym,iShlAB,iLoc)
  iAdr = iAdr0+iiBstRSh(iSym,iShlAB,iLoc)
  call dDAFile(LuCho(iSym),iOpt,Vec(kV),lTot,iAdr)
  kV = kV+lTot
end do

end subroutine Cho_1VecRd_SP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkabpqmap(abmap,syma,symb,rc)
! this routine prepares abmap

use ccsort_global, only: mbas, NORB, NSYM, nvb, reclen
use Symmetry_Info, only: Mul
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: abmap(mbas,mbas,8)
integer(kind=iwp), intent(in) :: syma, symb
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: a, b, bup, irec, lengthpq, nrecc, nrest, symab, symp, symq

rc = 0

!T test, if there are any ab pair

if (nvb(syma)*nvb(symb) == 0) then
  rc = 1
  ! RC=1 : there are no ab pair in this symmetry
  return
end if

! def initial address

irec = 1
symab = mul(syma,symb)

! loop over all combinations

do symp=1,nsym
  symq = mul(symab,symp)

  ! define number of records, required to store this block
  ! and determine shift in initial positions

  lengthpq = norb(symp)*norb(symq)
  nrecc = int(lengthpq/reclen)
  nrest = lengthpq-nrecc*reclen
  if (nrest > 0) nrecc = nrecc+1

  do a=1,nvb(syma)

    if (syma == symb) then
      bup = a
    else
      bup = nvb(symb)
    end if

    do b=1,bup

      abmap(a,b,symp) = irec
      irec = irec+nrecc

    end do
  end do
end do

return

end subroutine mkabpqmap

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine RdCmo
      Implicit Real*8 (a-h,o-z)
#include "parm.fh"
#include "common.fh"
      Character*6 OneInt,NatOrb,RunFile
      Character*72 line
      Dimension Dummy(1),iDummy(1)
*----------------------------------------------------------------------*
      If(isUHF.eq.1) Then
         Call dCopy_(MxCmo, Cmo2,1, Cmo,1)
         Call dCopy_(MxBasX, Occ2,1, Occ,1)
         Return
      End If
*----------------------------------------------------------------------*
      iSymOne=1
      kSet=kSet+1
      OneInt='ONE'
      NatOrb='NAT'
      RunFile='RUN'
      Write(OneInt(4:6),'(i3.3)') kSet
      Write(NatOrb(4:6),'(i3.3)') kSet
      Write(RunFile(4:6),'(i3.3)') kSet
      Call NameRun(RunFile)
*----------------------------------------------------------------------*
      Write(6,*)
      Write(6,*) '--------------------------------------------------'
      Write(6,*)
      Write(6,'(a,i3,a,f7.3)') ' Adding density matrix',kSet,
     &                         ' with weight',wSet(kSet)
      Write(6,*)
      Write(6,*) 'Reading one-el. file: ',OneInt
      Lu_One=2
      Call OpnOne(irc,0,OneInt,Lu_One)
      Call get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      nDim=0
      Do iSym = 1, nSym
         nDim=nDim+nBas(iSym)
      End Do
      Call Get_cArray('Unique Basis Names',Name,(LENIN8)*nDim)
      Call ClsOne(irc,0)
      Write(6,'(a,i5)') ' nSym:',nSym
      Write(6,'(a,8i5)') ' nBas:',(nBas(i),i=1,nSym)
*     Write(6,'(a,1x,a)') (Name(1,i),Name(2,i),i=1,nDim)
*----------------------------------------------------------------------*
* hack to fix Rolands inconsistent labels
      Do i=1,nDim
         If(Name(i)(LENIN3:LENIN3).eq.'s') Name(i)(LENIN1:LENIN3)='01s'
         If(Name(i)(LENIN3:LENIN3).eq.'p') Name(i)(LENIN1:LENIN3)='02p'
         If(Name(i)(LENIN3:LENIN3).eq.'d') Name(i)(LENIN1:LENIN3)='03d'
         If(Name(i)(LENIN3:LENIN3).eq.'f') Name(i)(LENIN1:LENIN3)='04f'
         If(Name(i)(LENIN3:LENIN3).eq.'g') Name(i)(LENIN1:LENIN3)='05g'
         If(Name(i)(LENIN3:LENIN3).eq.'h') Name(i)(LENIN1:LENIN3)='06h'
         If(Name(i)(LENIN3:LENIN3).eq.'i') Name(i)(LENIN1:LENIN3)='07i'
         If(Name(i)(LENIN3:LENIN3).eq.'k') Name(i)(LENIN1:LENIN3)='08k'
      End Do
*     Write(6,'(a,1x,a)') (Name(1,i),Name(2,i),i=1,nDim)
*----------------------------------------------------------------------*
      IF(kSet.eq.1) Then
         Call Init_GenANO
      Else
         Call Check_genano
      End If
*----------------------------------------------------------------------*
      If(kSet.eq. kRfSet) Then
         Lu_One=2
         Call OpnOne(irc,0,OneInt,Lu_One)
         Call RdOne(irc,6,'Mltpl  0',1,Cmo,iSymOne)
         Call CpOvlp(Cmo,Ssym)
         Call ClsOne(irc,0)
      End If
*----------------------------------------------------------------------*
      Write(6,*)
      Write(6,*) 'Reading orbital file: ',NatOrb
      Lu_=17
      Call chk_vec_UHF(NatOrb,Lu_,isUHF)
      If(isUHF.eq.1) Then
         Call rdvec_(NatOrb,Lu_,'CO',1,nSym,nBas,nBas,
     &     Cmo,Cmo2, Occ, Occ2, Dummy, Dummy,
     &     iDummy,line,0,iErr,iWFtype)
         Write(6,'(a)') '***'
         Write(6,'(a)') '*** rdcmo: fix reading of eps for uhf!!!'
         Write(6,'(a)') '***'
      Else
         Call RdVec(NatOrb,Lu_,'COE',nSym,nBas,nBas,
     &      Cmo,occ, eps, iDummy, line,0, iErr)
      End If
      Write(6,*) 'Orbital set: ',line(:mylen(line))
*----------------------------------------------------------------------*
      If(lftdeg) Then
         indx=1
         Do 100 iSym=1,nSym
            Do 110 iOrb=1,nBas(iSym)
               occ(indx)=(1.0d0+1.0d-3/iOrb)*occ(indx)
               indx=indx+1
110         Continue
100      Continue
      End If
*----------------------------------------------------------------------*
      If(rydgen) Then
         Call RdVec(NatOrb,Lu_,'COE',nSym,nBas,nBas,
     &      Cmo,occ, eps, iDummy, line,0, iErr)
         eps0=1.0d6
         indx=1
         Do 200 iSym=1,nSym
            Do 210 iOrb=1,nBas(iSym)
               If(occ(indx).lt.1.0d-2) Then
                  eps0=Min(eps0,eps(indx))
               End If
               indx=indx+1
210         Continue
200      Continue
*        Write(6,'(a,f12.6)') 'eps0',eps0
         indx=1
         Do 300 iSym=1,nSym
            Do 310 iOrb=1,nBas(iSym)
               If(occ(indx).gt.1.0d-2) Then
                  occ(indx)=0.0d0
               Else If(eps(indx).lt.0.0d0) Then
                  eta=exp(6.9d0*(eps(indx)/eps0-1.0d0))
*                 Write(6,'(a,2f12.6)') 'eps/eta',eps(indx),eta
                  occ(indx)=eta
               Else
                  occ(indx)=0.0d0
               End If
               indx=indx+1
310         Continue
300      Continue
      End If
*----------------------------------------------------------------------*
      Call NameRun('#Pop')
      Return
*----------------------------------------------------------------------*
      Write(6,*) 'Error while reading vector file'
      Call Quit_OnUserError()
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ADADST_GAS(    IOB,  IOBSM,  IOBTP,   NIOB,    JOB,
     &                        JOBSM,  JOBTP,   NJOB,  ISPGP,    ISM,
     &                          ITP,   KMIN,   KMAX,     I1,   XI1S,
     &                          LI1,     NK,   IEND,  IFRST,  KFRST,
     &                          I12,    K12, SCLFAC)
*
*
*
* Obtain mappings
* a+IORB a+ JORB !KSTR> = +/-!ISTR>
* In the form
* I1(KSTR) =  ISTR if a+IORB a+ JORB !KSTR> = +/-!ISTR> , ISTR is in
* ISPGP,ISM,IGRP.
* (numbering relative to TS start)
*. Only excitations IOB. GE. JOB are included
* The orbitals are in GROUP-SYM IOBTP,IOBSM, JOBTP,JOBSM respectively,
* and IOB (JOB) is the first orbital to be used, and the number of orbitals
* to be checked is NIOB ( NJOB).
*
* Only orbital pairs IOB .gt. JOB are included
*
* The output is given in I1(KSTR,I,J) = I1 ((KSTR,(J-1)*NIOB + I)
*
* Above +/- is stored in XI1S
* Number of K strings checked is returned in NK
* Only Kstrings with relative numbers from KMIN to KMAX are included
*
* If IEND .ne. 0 last string has been checked
*
* Jeppe Olsen , August of 95
*
* ======
*. Input
* ======
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
*./BIGGY
#include "WrkSpc.fh"
*./ORBINP/
#include "orbinp.fh"
#include "strinp.fh"
#include "strbas.fh"
#include "cgas.fh"
#include "gasstr.fh"
*. Local scratch
      COMMON/HIDSCR/KLOCSTR(4),KLREO(4),KLZ(4),KLZSCR
      COMMON/SSAVE/NELIS(4), NSTRKS(4)
*
* =======
*. Output
* =======
*
      INTEGER I1(*)
      DIMENSION XI1S(*)
*
      INTEGER IDUM_ARR(1)
*
      NTEST = 000
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' ====================== '
        WRITE(6,*) ' ADADST_GAS in service '
        WRITE(6,*) ' ====================== '
        WRITE(6,*)
        WRITE(6,*) ' IOB,IOBSM,IOBTP ', IOB,IOBSM,IOBTP
        WRITE(6,*) ' JOB,JOBSM,JOBTP ', JOB,JOBSM,JOBTP
      END IF
*
C?    IF(SCLFAC.NE.1.0D0) THEN
C?      WRITE(6,*) 'Problemo, ADADST '
C?      WRITE(6,*) ' SCLFAC = ',SCLFAC
C?    END IF

*
*. Internal affairs
*
      IF(I12.LE.4.AND.K12.LE.2) THEN
        KLLOC = KLOCSTR(K12)
        KLLZ = KLZ(I12)
        KLLREO = KLREO(I12)
      ELSE
        WRITE(6,*) ' ADST_GAS : Illegal value of I12 = ', I12
*        STOP' ADST_GAS : Illegal value of I12  '
        CALL SYSABENDMSG('lucia_util/adst_gas','Internal error',' ')
        RETURN
      END IF

*
*. Supergroup and symmetry of K strings
*
      ISPGPABS = IBSPGPFTP(ITP)-1+ISPGP
      CALL NEWTYP(ISPGPABS,1,IOBTP,K1SPGPABS)
      CALL NEWTYP(K1SPGPABS,1,JOBTP,KSPGPABS)
      CALL SYMCOM(2,0,IOBSM,K1SM,ISM)
      CALL SYMCOM(2,0,JOBSM,KSM,K1SM)
      IF(NTEST.GE.100) WRITE(6,*)
     & ' K1SM,K1SPGPABS,KSM,KSPGPABS : ',
     &   K1SM,K1SPGPABS,KSM,KSPGPABS
* In ADADS1_GAS we need : Occupation of KSTRINGS
*                         lexical => Actual order for I strings
* Generate if required
*
      IF(IFRST.NE.0) THEN
*.. Generate information about I strings
*. Arc weights for ISPGP
        NTEST2 = NTEST
        CALL WEIGHT_SPGP(iWORK(KLLZ),NGAS,NELFSPGP(1,ISPGPABS),
     &                      NOBPT,iWORK(KLZSCR),NTEST2)
        NELI = NELFTP(ITP)
        NELIS(I12) = NELI
*. Reorder array for I strings
        CALL GETSTR_TOTSM_SPGP(    ITP,  ISPGP,    ISM,   NELI,  NSTRI,
     &                         IWORK(KLLOC),NOCOB,1,
     &                         iWORK(KLLZ),IWORK(KLLREO))
      END IF
      NELK = NELIS(I12) - 2
      IF(KFRST.NE.0) THEN
*. Generate occupation of K STRINGS
       CALL GETSTR_TOTSM_SPGP(      1,KSPGPABS,   KSM,  NELK, NSTRK,
     &                        IWORK(KLLOC),NOCOB,   0,IDUM_ARR,IDUM_ARR)
       NSTRKS(K12) = NSTRK
      END IF
*
      NSTRK = NSTRKS(K12)
*
      IIOB = IOBPTS(IOBTP,IOBSM) + IOB - 1
      JJOB = IOBPTS(JOBTP,JOBSM) + JOB - 1
      CALL ADADS1_GAS(       NK,       I1,     XI1S,      LI1,     IIOB,
     &                     NIOB,     JJOB,     NJOB,iWORK(KLLOC),  NELK,
     &                    NSTRK,iWORK(KLLREO),iWORK(KLLZ),NOCOB, KMAX,
     &                     KMIN,     IEND,   SCLFAC)
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_OpenF(iOpt,iTyp,iSym)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: open (iOpt=1), close and keep (iOpt=2), or close and
C              delete (iOpt=3) Cholesky vector files for MP2 program
C              (full vectors).
C              For iOpt=0, the units are initialized (to -1).
C              iTyp=1: transformed Cholesky vectors.
C              iTyp=2: vectors from (ai|bj) decomposition.
C
#include "implicit.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"
#include "WrkSpc.fh"

      Character*12 SecNam
      Parameter (SecNam = 'ChoMP2_OpenF')

      Character*3 BaseNm
      Character*4 FullNm

      If (iTyp.lt.1 .or. iTyp.gt.nTypF) Then
         Call ChoMP2_Quit(SecNam,'iTyp error',' ')
      End If

C     Initialize units and return for iOpt=0.
C     ---------------------------------------

      If (iOpt .eq. 0) Then
         lUnit_F(iSym,iTyp) = -1
         Return
      End If

C     Open or close files.
C     --------------------

      If (iOpt .eq. 1) Then
         If ((nT1am(iSym).gt.0) .or.
     &       (DoDens .and. (nPQ_prod(iSym).gt.0))) Then
            If (lUnit_F(iSym,iTyp) .lt. 1) Then
               Call ChoMP2_GetBaseNm(BaseNm,iTyp)
               Write(FullNm,'(A3,I1)') BaseNm,iSym
               lUnit_F(iSym,iTyp) = 7
               Call daName_MF_WA(lUnit_F(iSym,iTyp),FullNm)
            End If
         Else
            lUnit_F(iSym,iTyp) = -1
         End If
      Else If (iOpt .eq. 2) Then
         If (lUnit_F(iSym,iTyp) .gt. 0) Then
            Call daClos(lUnit_F(iSym,iTyp))
            lUnit_F(iSym,iTyp) = -1
         End If
      Else If (iOpt .eq. 3) Then
         If (lUnit_F(iSym,iTyp) .gt. 0) Then
            Call daEras(lUnit_F(iSym,iTyp))
            lUnit_F(iSym,iTyp) = -1
         End If
      Else
         Call ChoMP2_Quit(SecNam,'iOpt out of bounds',' ')
      End If

      End
      SubRoutine ChoMP2_GetBaseNm(BaseNm,iTyp)
      Implicit None
      Character*3 BaseNm
      Integer     iTyp

      If (iTyp .eq. 1) Then
         BaseNm = '_AI'
      Else If (iTyp .eq. 2) Then
         BaseNm = '_CD'
      Else
         BaseNm = '_un'
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine projects out specified vectors from the density matrix. *
! The procedure is to read the projection orbitals, generate a         *
! complimentary space, and orthonormalize it. Then the density matrix  *
! is transformed into this representation, the corresponding matrix    *
! are zeroed out, and transformed back to AO representaion.            *
!                                                                      *
!======================================================================*
!                                                                      *
! NOTE: The transformations and orthonormalizations are done as        *
!       (On^4) processes and not as O(n^3) processed due to a lazy     *
!       programmer. I will rewrite this when I get the time.           *
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine Proj1()

use Genano_globals, only: MxLqn, nPrim, iSymBk, Ssym, tDsym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: err, i, iB, iBlk, iLqn, ind, indT, iO, iShell, j, jB, jO, Lu, nB, nO
real(kind=wp) :: s
real(kind=wp), allocatable :: pOrb(:,:), DAO(:,:), DMO(:,:), Sc(:,:), Ovlp(:,:)
integer(kind=iwp), external :: IsFreeUnit

Lu = IsFreeUnit(17)
call molcas_open(Lu,'PROJ')
iBlk = 0
!--- Loop over l quantum number ---*
do iLqn=0,MxLqn
  read(Lu,*,iostat=err) nB,nO
  if (err /= 0) exit
  if (nB*nO <= 0) cycle
  if (nB /= nPrim(iLqn)) then
    write(u6,*) 'Project: inconsistency in number of functions'
    call Abend()
  end if
  call mma_allocate(pOrb,nB,nB,label='pOrb')
  call mma_allocate(DAO,nB,nB,label='DAO')
  call mma_allocate(DMO,nB,nB,label='DMO')
  call mma_allocate(Sc,nB,nB,label='Sc')
  call mma_allocate(Ovlp,nB,nB,label='Ovlp')
  do iB=1,nB
    read(Lu,*) (pOrb(iB,iO),iO=1,nO)
  end do
  !--- Generate complementary space ---*
  do iB=1,nB
    do iO=nO+1,nB
      pOrb(iB,iO) = cos(Pi*iO*iB/nB)
    end do
  end do
  !write(u6,'(a,i5)') ' Projection orbitals',iLqn
  !do iB=1,nB
  !  write(u6,'(1x,6f12.6)') (pOrb(iB,iO)),iO=1,nO)
  !end do
  !--- Loop over m quantum number ---*
  do iShell=-iLqn,iLqn
    iBlk = iBlk+1
    !write(u6,'(a,2i5)') ' Density matrix block',iLqn,iShell
    !call Triprt(' ','(6f12.6)',tDsym(iSymBk(iBlk)),nPrim(iLqn))
    !write(u6,'(a,2i5)') ' Overlap matrix block',iLqn,iShell
    !call Triprt(' ','(6f12.6)',Ssym(iSymBk(iBlk)),nPrim(iLqn))
    !--- Copy and square D and S ---*
    do i=1,nB
      do j=1,nB
        indT = min(i,j)+max(i,j)*(max(i,j)-1)/2
        DAO(i,j) = tDsym(iSymBk(iBlk)-1+indT)
        Ovlp(i,j) = Ssym(iSymBk(iBlk)-1+indT)
      end do
    end do
    !--- Orthonormalize orbitals ---*
    do iO=1,nB
      s = Zero
      do iB=1,nB
        do jB=1,nB
          s = s+pOrb(iB,iO)*ovlp(iB,jB)*pOrb(jB,iO)
        end do
      end do
      s = One/sqrt(s)
      do iB=1,nB
        pOrb(iB,iO) = s*pOrb(iB,iO)
      end do
      do jO=iO+1,nB
        s = Zero
        do iB=1,nB
          do jB=1,nB
            s = s+pOrb(iB,iO)*ovlp(iB,jB)*pOrb(jB,jO)
          end do
        end do
        do iB=1,nB
          pOrb(iB,jO) = pOrb(iB,jO)-s*pOrb(iB,iO)
        end do
      end do
    end do
    !--- Transform to MO basis ---*
    do iB=1,nB
      do iO=1,nB
        s = Zero
        do jB=1,nB
          s = s+ovlp(iB,jB)*pOrb(jB,iO)
        end do
        Sc(iB,iO) = s
      end do
    end do
    do iO=1,nB
      do jO=1,nB
        s = Zero
        do iB=1,nB
          do jB=1,nB
            s = s+Sc(iB,iO)*DAO(iB,jB)*Sc(jB,jO)
          end do
        end do
        DMO(iO,jO) = s
      end do
    end do
    !--- Project ---*
    do iO=1,nO
      do jO=1,nB
        DMO(iO,jO) = Zero
        DMO(jO,iO) = Zero
      end do
    end do
    !--- Transform back to AO ---*
    ind = 0
    do iB=1,nB
      do jB=1,iB
        ind = ind+1
        s = Zero
        do iO=1,nB
          do jO=1,nB
            s = s+pOrb(iB,iO)*DMO(iO,jO)*pOrb(jB,jO)
          end do
        end do
        tDsym(iSymBk(iBlk)-1+ind) = s
      end do
    end do
    call mma_deallocate(pOrb)
    call mma_deallocate(DAO)
    call mma_deallocate(DMO)
    call mma_deallocate(Sc)
    call mma_deallocate(Ovlp)
    !--- ---*
    !write(u6,'(a,2i5)') ' Density matrix block',iLqn,iShell
    !call Triprt(' ','(6f12.6)',tDsym(iSymBk(iBlk)),nPrim(iLqn))
  end do
end do
!--- Finished ---*
close(Lu)

return

end subroutine Proj1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PROPCT()

use mrci_global, only: DMO, ENGY, ESHIFT, ESMALL, ICPF, IPCOMP, ITOC17, ITRANS, LUEIG, LUONE, LUVEC, NBAS, NBAST, NBMAX, NBTRI, &
                       NCMO, NRROOT, NPROP, NSYM, PNAME, PNUC, PORIG, PTYPE, TDMO
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: I, IDDMO, IDISK, IDUMMY(7,8), IEND, IOPT, IPC, IPROP, IRTC, ISTA, ISTATE, ISYMLB, J, JSTATE, NSCR
real(kind=wp) :: DUMMY(1)
character(len=100) :: REALNAME
character(len=30) :: REMARK
character(len=8) :: FNAME, LABEL
real(kind=wp), allocatable :: AFOLD(:), CMO(:), CNO(:), DAO(:,:), OCC(:), PINT(:), PROP(:,:,:), SCR(:), SFOLD(:)

call mma_allocate(CMO,NCMO,label='CMO')
call mma_allocate(CNO,NCMO,label='CNO')
call mma_allocate(OCC,NBAST,label='OCC')
call mma_allocate(DAO,NBAST,NBAST,label='DAO')
call mma_allocate(AFOLD,NBTRI,label='AFOLD')
call mma_allocate(SFOLD,NBTRI,label='SFOLD')
call mma_allocate(PINT,NBTRI+4,label='PINT')
NSCR = max(NBTRI,NBMAX**2)
call mma_allocate(SCR,NSCR,label='SCR')
! LOOP OVER OPERATORS:
IOPT = 8
NPROP = 0
do I=1,100
  ! PICK UP OPERATOR LABELS FROM ONE-ELECTRON FILE:
  LABEL = 'UNDEF'
  call iRDONE(IRTC,1+IOPT,LABEL,IPC,IDUMMY,ISYMLB)
  if (IRTC /= 0) exit
  IOPT = 16
  if (mod(ISYMLB,2) == 0) cycle
  NPROP = NPROP+1
  PNAME(NPROP) = LABEL
  IPCOMP(NPROP) = IPC
  PTYPE(NPROP) = 'HERM'
  if (LABEL == 'VELOCITY') PTYPE(NPROP) = 'ANTI'
  if (LABEL == 'ANGMOM  ') PTYPE(NPROP) = 'ANTI'
end do
call mma_allocate(PROP,NRROOT,NRROOT,NPROP,'PROP')
PROP(:,:,:) = Zero
IDDMO = 0
do ISTATE=1,NRROOT
  ! PICK UP DMO
  call dDAFILE(LUEIG,2,DMO,NBTRI,IDDMO)
  ! PICK UP CMO
  IDISK = ITOC17(1)
  call dDAFILE(LUONE,2,CMO,NCMO,IDISK)
  ! COMPUTE & WRITE NATURAL ORBITALS
  call NATORB_MRCI(CMO,DMO,CNO,OCC,SCR)
  write(FNAME,'(A5,I2.2)') 'CIORB',ISTATE
  REALNAME = FNAME
  if (ISTATE == 1) call Add_Info('CI_DENS1',DMO,1,5)
  REMARK = '* MRCI  '
  !** Gusarov , include 1st root acpf energy to CiOrb file:
  if (ICPF == 1) write(REMARK,'("* ACPF  ",f22.16)') ESMALL(1)+ESHIFT

  call WRVEC(REALNAME,LUVEC,'CO',NSYM,NBAS,NBAS,CNO,OCC,Dummy,iDummy,REMARK)
  write(u6,*)
  write(u6,'(A,I2)') ' NATURAL ORBITALS OF STATE NR. ',ISTATE
  write(u6,*) ' FULL SET OF ORBITALS ARE SAVED ON FILE ',REALNAME
  call PRORB(CNO,OCC)
  write(u6,*) ' ',('*',I=1,70)
  ! CREATE DAO
  call MKDAO(CNO,OCC,DAO)
  ! CALL PMATEL TO CALCULATE CHARGES AND PROPERTIES.
  ! PUT PROPERTIES INTO APPROPRIATE MATRICES.
  call PMATEL(ISTATE,ISTATE,PROP,PINT,SCR,CNO,OCC,SFOLD,AFOLD,DAO)
end do
! ENERGIES SAVED FROM PREVIOUS OUTPUT REPEATED HERE FOR CONVENIENCE:
write(u6,*)
write(u6,*) ' SUMMARY OF ENERGIES:'
do ISTA=1,NRROOT,4
  IEND = min(ISTA+3,NRROOT)
  write(u6,'(1X,A,I8,3I16)') '               ROOT:',(I,I=ISTA,IEND)
  write(u6,'(1X,A,4F16.8)') '       TOTAL ENERGY:',(ENGY(I,1),I=ISTA,IEND)
  if (ICPF == 0) then
    write(u6,'(1X,A,4F16.8)') 'DAVIDSON CORRECTION:',(ENGY(I,2),I=ISTA,IEND)
    write(u6,'(1X,A,4F16.8)') '    ACPF CORRECTION:',(ENGY(I,3),I=ISTA,IEND)
  end if
  write(u6,*)
end do
! ---------------------------------------------------
!PAM Grep-able energy output for convenience:
write(u6,*)
write(u6,*) ' Energies, machine-readable format:'
if (ICPF == 0) then
  do I=1,NRROOT
    write(u6,'(1X,A,I3,3(5X,A,F16.8))') ' CI State ',I,'Total energy:',ENGY(I,1),'QDav:',ENGY(I,2),'QACPF:',ENGY(I,3)
  end do
else
  do I=1,NRROOT
    write(u6,'(1X,A,I3,5X,A,F16.8)') ' ACPF State ',I,'Total energy:',ENGY(I,1)
  end do
end if
write(u6,*)
! ---------------------------------------------------
if (NPROP > 0) then
  ! WRITE EXPECTATION VALUES:
  write(u6,*)
  write(u6,*) ' EXPECTATION VALUES OF VARIOUS OPERATORS:'
  write(u6,*) '(Note: Electronic multipoles include a negative sign.)'
  do IPROP=1,NPROP
    if (PTYPE(IPROP) == 'ANTI') cycle
    do ISTA=1,NRROOT,4
      IEND = min(ISTA+3,NRROOT)
      write(u6,*)
      write(u6,'(1X,A,A8,A,I4)') '   PROPERTY :',PNAME(IPROP),'   COMPONENT:',IPCOMP(IPROP)
      write(u6,'(1X,A,3F16.8)') '    GAUGE ORIGIN:',(PORIG(I,IPROP),I=1,3)
      write(u6,'(1X,A,I8,3I16)') '            ROOT:',(I,I=ISTA,IEND)
      write(u6,'(1X,A,4F16.8)') '      ELECTRONIC:',(PROP(I,I,IPROP),I=ISTA,IEND)
      write(u6,'(1X,A,4F16.8)') '         NUCLEAR:',(PNUC(IPROP),I=ISTA,IEND)
      write(u6,'(1X,A,4F16.8)') '           TOTAL:',(PNUC(IPROP)+PROP(I,I,IPROP),I=ISTA,IEND)
    end do
  end do
  write(u6,*)
end if
if (ITRANS /= 0) then
  do ISTATE=2,NRROOT
    do JSTATE=1,ISTATE-1
      ! PICK UP TDMA
      call dDAFILE(LUEIG,2,TDMO,NBAST**2,IDDMO)
      ! CREATE TDAO
      call MKTDAO(CMO,TDMO,DAO,SCR)
      ! CALL PMATEL TO CALCULATE TRANSITION PROPERTIES
      ! PUT PROPERTIES INTO APPROPRIATE MATRICES.
      if (NPROP /= 0) call PMATEL(ISTATE,JSTATE,PROP,PINT,SCR,CNO,OCC,SFOLD,AFOLD,DAO)
    end do
  end do
  if (NPROP /= 0) then
    ! WRITE PROPERTY MATRICES.
    write(u6,*)
    write(u6,*) ' MATRIX ELEMENTS OF VARIOUS OPERATORS:'
    write(u6,*) ' (INCLUDING ANY NUCLEAR CONTRIBUTIONS)'
    do IPROP=1,NPROP
      do I=1,NRROOT
        PROP(I,I,IPROP) = PROP(I,I,IPROP)+PNUC(IPROP)
      end do
    end do
    do IPROP=1,NPROP
      do ISTA=1,NRROOT,4
        IEND = min(ISTA+3,NRROOT)
        write(u6,*)
        write(u6,'(1X,A,A8,A,I4)') '   PROPERTY :',PNAME(IPROP),'   COMPONENT:',IPCOMP(IPROP)
        write(u6,'(1X,A,3F16.8)') '    GAUGE ORIGIN:',(PORIG(I,IPROP),I=1,3)
        write(u6,'(1X,A,I8,3I16)') '            ROOT:',(I,I=ISTA,IEND)
        do J=1,NRROOT
          write(u6,'(15X,I2,4F16.8)') J,(PROP(J,I,IPROP),I=ISTA,IEND)
        end do
      end do
    end do
    write(u6,*)
  end if
end if
call mma_deallocate(CMO)
call mma_deallocate(CNO)
call mma_deallocate(OCC)
call mma_deallocate(DAO)
call mma_deallocate(AFOLD)
call mma_deallocate(SFOLD)
call mma_deallocate(PINT)
call mma_deallocate(SCR)
call MMA_DEALLOCATE(PROP)

return

end subroutine PROPCT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! NOTE: THE FOLLOWING ROUTINE MAY NOT BE VECTORIZED.
! THERE IS A COMPILER BUG ON FORTRAN VERSION 2.2.0 (JUNE 1987).
! WRONG RESULTS PRODUCED EVEN ON VECTORIZED LEVEL 1.

subroutine MKCXAL(NDIMEN,TRAL,CXAL)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDIMEN
real(kind=wp), intent(in) :: TRAL(NDIMEN,NDIMEN)
real(kind=wp), intent(out) :: CXAL(NDIMEN,NDIMEN)
integer(kind=iwp) :: I, K
real(kind=wp) :: SUMMA

call unitmat(CXAL,NDIMEN)
do K=1,NDIMEN
  do I=1,K-1
    SUMMA = sum(CXAL(I,1:K-1)*TRAL(1:K-1,K))
    CXAL(I,K) = -SUMMA/TRAL(K,K)
  end do
  do I=K,NDIMEN
    if (I == K) then
      SUMMA = -One
    else
      SUMMA = TRAL(I,K)
    end if
    SUMMA = SUMMA+sum(CXAL(I,1:K-1)*TRAL(1:K-1,K))
    CXAL(I,K) = -SUMMA/TRAL(K,K)
  end do
end do

end subroutine MKCXAL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine o7b2_cvb(nparm,dx,
     >  dxnrm,grdnrm,close2conv)
      implicit real*8 (a-h,o-z)
      logical skip
      logical close2conv
#include "opt_cvb.fh"
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

#include "opt2_cvb.fh"
      external asonc7_cvb,ddres2upd7_cvb
      dimension dx(nparm)
      save one,resthr_old
      data one/1d0/

      if(.not.close2conv)then
        resthr_use=1d-5
      else
        resthr_use=5d-2*grdnrm
        resthr_use=min(1d-5,resthr_use)
        resthr_use=max(1d-9,resthr_use)
      endif
      skip=(resthr_use.eq.resthr_old.and.have_solved_it)
      resthr_old=resthr_use
      if(skip)goto 100
      call axex_cvb(asonc7_cvb,ddres2upd7_cvb,dx,
     >  resthr_use,ioptc2,iter2,fx_exp)
      have_solved_it=.true.
      exp=.5d0*fx_exp

      if(ip.ge.2)write(6,'(2a,i4)')' Number of iterations for ',
     >  'direct diagonalization :',iter2

      if(ioptc2.ne.0)then
        write(6,*)' Direct diagonalization not converged!'
        call abend_cvb()
      endif

      if(ip.ge.2)then
        write(6,'(a)')' Eigenvector to be followed :'
        call vecprint_cvb(dx,nparm+1)
      endif
      if(abs(dx(1)).gt.1d-8)then
        fac1=one/dx(1)
      else
        fac1=sign(one,dx(1))
      endif
      call dscal_(nparm,fac1,dx(1),1)
      do 200 i=1,nparm
      dx(i)=dx(i+1)
200   continue
100   dxnrm=dnrm2_(nparm,dx,1)
      if(.not.close2conv)then
        ipu=1
      else
        ipu=2
      endif
      if(dxnrm.gt.hh.or.scalesmall(ipu))then
        call dscal_(nparm,hh/dxnrm,dx,1)
        dxnrm=hh
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mk_iSO2Ind(iSO2Sh,iSO2Ind,nSO,nShell)

use Basis_Info, only: nBas_Aux
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nSO, iSO2Sh(nSO), nShell
integer(kind=iwp), intent(out) :: iSO2Ind(nSO)
integer(kind=iwp) :: iB, iIrrep, iSh, iSO
integer(kind=iwp), allocatable :: nTemp(:)

call mma_allocate(nTemp,nShell,Label='nTemp')

iSO = 0
! Loop over the irreps
do iIrrep=0,nIrrep-1

  nTemp(:) = 0
  ! Loop over the canonical index of the auxiliary functions, starting from 1 for the first irrep.
  do iB=1,nBas_Aux(iIrrep)
    iSO = iSO+1
    iSh = iSO2Sh(iSO)  ! Pick up the corresponding shell index
    nTemp(iSh) = nTemp(iSh)+1  ! Increment the count of basis functions for shell ish
    ! This table translates the global index of a basis function, iSO, to the local index of the shell to which it belongs.
    iSO2Ind(iSO) = nTemp(iSh)
  end do

end do

call mma_deallocate(nTemp)

end subroutine Mk_iSO2Ind

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine ChoRPA_MOTra(includeFrozen,includeDeleted)
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Transform Cholesky vectors to MO basis.
C
C     TODO/FIXME:
C     1. This routine computes all MO blocks (ij, ai, ab), even though
C        we may only need some of them. A more flexible interface would
C        be nice to have. Presumably not a performance issue in RPA,
C        though (remains to be verified).
C     2. For unrestricted calculations, the alpha and beta
C        transformations are done separately, which means that the AO
C        vectors are read twice. Simultaneous transformation would be
C        desirable!
C
      Implicit None
      Logical includeFrozen, includeDeleted
#include "rpa_data.fh"
#include "WrkSpc.fh"

      Character*12 SecNam
      Parameter (SecNam='ChoRPA_MOTra')

      Integer  RPA_iUHF
      External RPA_iUHF

      Character*6 BName(2)

      Integer nSpin
      Integer iSym
      Integer ip_lCMO, l_lCMO
      Integer ip, l
*     Integer ip_lnBas
*     Integer ip_lnOrb
      Integer ip_lnFro
      Integer ip_lnOcc
      Integer ip_Zeros
      Integer ip_lnVir
      Integer ip_lnDel
      Integer iSpin

      nSpin=RPA_iUHF()
      If (nSpin.eq.1) Then
         BName(1)='MOVECS'
         BName(2)='unused'
      Else If (nSpin.eq.2) Then
         BName(1)='MOVECa'
         BName(2)='MOVECb'
      Else
         Call RPA_Warn(3,SecNam//': illegal nSpin')
         BName(1)='unused'
         BName(2)='unused'
      End If
      l_lCMO=nBas(1)**2
      Do iSym=2,nSym
         l_lCMO=l_lCMO+nBas(iSym)**2
      End Do
      Call GetMem('locCMO','Allo','Real',ip_lCMO,l_lCMO)
      l=5*nSym
      Call GetMem('local','Allo','Inte',ip,l)
      ip_lnFro=ip
      ip_lnOcc=ip+nSym
      ip_Zeros=ip+2*nSym
      ip_lnVir=ip+3*nSym
      ip_lnDel=ip+4*nSym
      Call iZero(iWork(ip_Zeros),nSym)
      If (includeFrozen) ip_lnFro=ip_Zeros
      If (includeDeleted) ip_lnDel=ip_Zeros

      Do iSpin=1,nSpin

         ! Set orbital blocks
         If (includeFrozen) Then
            Do iSym=1,nSym
               iWork(ip_lnOcc-1+iSym)=nFro(iSym,iSpin)+nOcc(iSym,iSpin)
            End Do
         Else
            Call iCopy(nSym,nFro(1,iSpin),1,iWork(ip_lnFro),1)
            Call iCopy(nSym,nOcc(1,iSpin),1,iWork(ip_lnOcc),1)
         End If
         If (includeDeleted) Then
            Do iSym=1,nSym
               iWork(ip_lnVir-1+iSym)=nVir(iSym,iSpin)+nDel(iSym,iSpin)
            End Do
         Else
            Call iCopy(nSym,nVir(1,iSpin),1,iWork(ip_lnVir),1)
            Call iCopy(nSym,nDel(1,iSpin),1,iWork(ip_lnDel),1)
         End If
         ! Reorder CMO array
         Call ChoRPA_MOTra_ReorderCMO(nSym,nBas,nOrb,
     *                                nFro(1,iSpin),nOcc(1,iSpin),
     *                                nVir(1,iSpin),nDel(1,iSpin),
     *                                Work(ip_CMO(iSpin)),Work(ip_lCMO))
         ! Set base name for MO files
         ! Transform Cholesky vectors
         Call Cho_MOTra_(Work(ip_lCMO),l_lCMO,nSym,
     *                   nBas,nOrb,
     *                  iWork(ip_lnFro),iWork(ip_lnOcc),iWork(ip_Zeros),
     *                   iWork(ip_lnVir),iWork(ip_lnDel),
     *                   BName(iSpin),.false.,0,.false.)

      End Do

      Call GetMem('local','Free','Inte',ip,l)
      Call GetMem('locCMO','Free','Real',ip_lCMO,l_lCMO)

      End
************************************************************************
      Subroutine ChoRPA_MOTra_ReorderCMO(nSym,nBas,nOrb,nFro,nOcc,
     *                                   nVir,nDel,CMOinp,CMOout)
      Implicit None
      Integer nSym
      Integer nBas(nSym)
      Integer nOrb(nSym)
      Integer nFro(nSym)
      Integer nOcc(nSym)
      Integer nVir(nSym)
      Integer nDel(nSym)
      Real*8  CMOinp(*)
      Real*8  CMOout(*)

      Integer iSym, ip1, ip2, l

      ip1=1
      ip2=1
      Do iSym=1,nSym
         l=nBas(iSym)*nOrb(iSym)
         Call dCopy_(l,CMOinp(ip1),1,CMOout(ip2),1)
         Call fZero(CMOout(ip2+l),nBas(iSym)*nBas(iSym)-l)
         ip1=ip1+l
         ip2=ip2+nBas(iSym)*nBas(iSym)
      End Do

c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(nDel)
         Call Unused_integer_array(nFro)
         Call Unused_integer_array(nOcc)
         Call Unused_integer_array(nVir)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine SORT_mat(irc,nDim,nVec,iD_A,nSym,lu_A0,mode,lScr,Scr,Diag)
!***********************************************************************
!                                                                      *
!     Author:  F. Aquilante                                            *
!                                                                      *
!***********************************************************************

use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nSym, nDim(nSym), lScr
integer(kind=iwp), intent(inout) :: nVec(nSym), lu_A0(nSym)
integer(kind=iwp), intent(_OUT_) :: iD_A(*)
character(len=7), intent(in) :: mode
real(kind=wp), intent(out) :: Scr(lScr)
real(kind=wp), intent(inout) :: Diag(*)
integer(kind=iwp) :: is, iSym, lu_A
! 19112013VVP: The threshold changed from 1.0e-14_wp to 1.0e-12_wp
real(kind=wp), parameter :: Thr = 1.0e-12_wp
character(len=6) :: Name_A

!write(u6,*) 'Mode=',Mode
irc = 0
if (mode == 'GePivot') then  ! returns iD_A
  is = 1
  do iSym=1,nSym
    if (nDim(iSym) == 0) cycle
    lu_A = 7
    write(Name_A,'(A4,I2.2)') 'ZMAT',iSym-1
    call DaName_MF_WA(lu_A,Name_A)
    !call RecPrt('Diag',' ',Diag(iS),1,nDim(iSym))
    call get_pivot_idx(Diag(is),nDim(iSym),nVec(iSym),lu_A0(iSym),lu_A,iD_A(is),Scr,lScr,Thr)
    call DaEras(lu_A) ! we do not need it
    !call RecPrt('Diag',' ',Diag(iS),1,nDim(iSym))
    is = is+nDim(iSym)
  end do
else if (mode == 'DoPivot') then ! store full-pivoted UT A-matrix
  is = 1
  do iSym=1,nSym
    if (nVec(iSym) /= 0) then
      lu_A = 7
      write(Name_A,'(A4,I2.2)') 'AMAT',iSym-1
      call DaName_MF_WA(lu_A,Name_A)
      call Pivot_mat(nDim(iSym),nVec(iSym),lu_A0(iSym),lu_A,iD_A(is),Scr,lScr)
      call DaEras(lu_A0(iSym))
      lu_A0(iSym) = lu_A
    end if
    is = is+nDim(iSym)
  end do

else if (mode == 'Restore') then !store squared Q-mat (col. piv.)
  is = 1
  do iSym=1,nSym
    if (nVec(iSym) /= 0) then
      lu_A = 7
      write(Name_A,'(A4,I2.2)') 'QVEC',iSym-1
      call DaName_MF_WA(lu_A,Name_A)
      call Restore_mat(nDim(iSym),nVec(iSym),lu_A0(iSym),lu_A,iD_A(is),Scr,lScr,.false.)
      call DaEras(lu_A0(iSym))
      lu_A0(iSym) = lu_A
    end if
    is = is+nDim(iSym)
  end do

else
  write(u6,*) ' SORT_mat: invalid mode! '
  irc = 66
end if

return

end subroutine SORT_mat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_DRV()
C
C     Purpose: MOLCAS interface to Cholesky decomposition driver.
C
      use ChoArr, only: MySP
#include "implicit.fh"
#include "cholesky.fh"
#include "stdalloc.fh"

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_DRV')

      LOGICAL INDEXATION, DOFOCK, DOGRAD
      LOGICAL VERBOSE, FREEK2

      CALL STATUSLINE('Seward: ','Cholesky decomposition of ERIs')

C     Initialize integral program (this does some memory
C     allocations; thus, DO NOT move this.
C     --------------------------------------------------

#if defined (_DEBUGPRINT_)
      CALL CHO_PRESCR(CUTINT1,THRINT1)
#endif

      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
      NSHELL     = -1
      INDEXATION = .TRUE.
      THRAO      = 0.0D0
      DOFOCK     = .FALSE.
      DOGRAD     = .FALSE.
      CALL SETUP_INTS(NSHELL,INDEXATION,THRAO,DOFOCK,DOGRAD)

#if defined (_DEBUGPRINT_)
      CALL CHO_PRESCR(CUTINT2,THRINT2)
      WRITE(LUPRI,*) SECNAM,': CutInt before Setup_Ints: ',CUTINT1
      WRITE(LUPRI,*) SECNAM,': CutInt after  Setup_Ints: ',CUTINT2
      WRITE(LUPRI,*) SECNAM,': ThrInt before Setup_Ints: ',THRINT1
      WRITE(LUPRI,*) SECNAM,': ThrInt after  Setup_Ints: ',THRINT2
      IF (CUTINT2.NE.CUTINT1 .OR. THRINT2.NE.THRINT1) THEN
         CALL CHO_QUIT('Initialization error in '//SECNAM,102)
      END IF
#endif

C     Start the Cholesky decomposition program.
C     -----------------------------------------

      ICODE = 0
      CALL CHO_DRV(ICODE)
      IF (ICODE .NE. 0) THEN
         WRITE(LUPRI,*) SECNAM,': decomposition driver returned code ',
     &                  ICODE
         CALL CHO_QUIT('Decomposition failed!',104)
      END IF

C     Finalize integral program.
C     --------------------------

      VERBOSE = .FALSE.
      FREEK2  = .TRUE.
      CALL TERM_INTS(VERBOSE,FREEK2)

C     Halt execution if requested.
C     ----------------------------

      IF (HALTIT) THEN
         WRITE(LUPRI,*) SECNAM,': halting execution after ',
     &                  'decomposition as requested...'
         CALL GASYNC
         CALL CHO_QUIT('End of Test (in '//SECNAM//')',100)
      END IF

      CALL GASYNC()
      Call Free_iSD()

      If (Allocated(MySP)) Call mma_deallocate(MySP)
      Call Cho_X_dealloc(irc)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine Preciaa(iB,iS,jS,nd,rOut,nbaj,fockii,fockai,focki,focka,fock,Sgn,A_J,A_K,Scr,nScr)
!***********************************************************************
!     Change Fock(i) ne Fock(j)
!                                           [2]
!     Calculates the diagonal submatrix of E    that couple
!
!     kappa               with   kappa                for a
!          kinactive,active           kinactive,active
!
!     single inactive index.
!     Used for preconditioner.
!
!     See Olsen,Yeager, Joergensen:
!      "Optimization and characterization of an MCSCF state"
!
!     Called by prec
!
!     ib,is       :       inactive index for the submatrix
!     js          :       symmetry of active,active
!     rOut        :       Submatrix
!
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: G1t, G2t, nA
use input_mclr, only: nAsh, nBas, nIsh, nSym
use Constants, only: Two, Three, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iB, iS, jS, nd, nbaj, nScr
real(kind=wp), intent(inout) :: rout(*)
real(kind=wp), intent(in) :: fockii, fockai, focki(nbaj,nbaj), focka(nbaj,nbaj), fock(nbaj,nbaj), Sgn
real(kind=wp), intent(out) :: A_J(nScr), A_K(nScr), Scr(nScr)
integer(kind=iwp) :: i, iAC, iBC, ip1, ip2, jA, jAA, jB, jBB, jC, jCC, jD, jDD, jjA, jjB, jjC, jjD, kS, nTri
real(kind=wp) :: AABB, ABAB, ABCB, ACBB, BBCB, BCBB, rDens, rDens1, rDens2, rFock

!                                                                      *
!***********************************************************************
!                                                                      *
nTri = nTri_Elem(nd)
!                                                                      *
!***********************************************************************
!                                                                      *
do kS=1,nSym

  if (nAsh(kS) /= 0) call Coul(kS,kS,iS,iS,iB,iB,A_J,Scr)

  do jC=1,nAsh(kS)
    jjC = JC+nA(kS)
    jCC = jC+nIsh(kS)

    call Coul(kS,iS,kS,iS,jCC,iB,A_K,Scr)

    do jD=1,nAsh(kS)
      jjD = JD+nA(kS)
      jDD = jD+nIsh(kS)

      ip1 = (jDD-1)*nBas(kS)+jCC
      ip2 = (iB-1)*nBas(kS)+jDD
      aabb = A_J(ip1)
      abab = A_K(ip2)

      do jA=1,nAsh(jS)
        jjA = jA+nA(jS)
        do jB=1,jA
          jjB = jB+nA(jS)
          i = nTri-iTri(nd-jA+1,nd-jB+1)+1

          rDens1 = Sgn*G2t(iTri(iTri(jjC,jjD),iTri(jjB,jjA)))
          rDens2 = Sgn*G2t(iTri(iTri(jjB,jjD),iTri(jjC,jjA)))

          rout(i) = rout(i)+Two*rDens1*aabb+Four*rDens2*abab

        end do
      end do
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (nAsh(jS) /= 0) then
  call Exch(jS,iS,jS,iS,iB,iB,A_K,Scr)
  call Coul(jS,jS,iS,iS,iB,iB,A_J,Scr)
end if

do jA=1,nAsh(jS)
  jAA = jA+nA(jS)
  jjA = jA+nIsh(jS)

  do jB=1,jA
    jBB = jB+nA(jS)
    jjB = jB+nIsh(jS)
    i = nTri-iTri(nd-jA+1,nd-jB+1)+1

    do jC=1,nAsh(jS)
      jCC = jC+nA(jS)
      jjC = jC+nIsh(jS)
      iBC = (jjC-1)*nBas(jS)+jjB
      BCbb = A_J(iBC)
      BbCb = A_K(iBC)
      iAC = (jjC-1)*nBas(jS)+jjA
      ACbb = A_J(iAC)
      AbCb = A_K(iAC)

      rDens1 = -Sgn*G1t(iTri(jAA,jCC))
      rDens2 = -Sgn*G1t(iTri(jBB,jCC))
      if (jAA == jCC) rDens1 = rdens1+Sgn
      if (jBB == jCC) rDens2 = rdens2+Sgn

      rout(i) = rout(i)+Two*rdens1*(Three*BbCb-BCbb)+Two*rdens2*(Three*AbCb-ACbb)

    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
rFock = Sgn*(Fockii+FockAi)
i = 0 ! dummy initialize
do jA=1,nAsh(jS)
  jAA = jA+nA(jS)
  jjA = jA+nIsh(js)
  do jB=1,JA
    jBB = jB+nA(jS)
    jjB = jB+nIsh(js)
    i = nTri-iTri(nd-jA+1,nd-jB+1)+1
    rDens = G1t(iTri(jbb,jAA))
    rout(i) = rout(i)+Sgn*(Two*rdens*Fockii+Two*(Two*Focki(jjA,jjB)+Two*FockA(jjA,jjB)-Fock(jjB,jjA)))
  end do
  rout(i) = rout(i)-Four*rFock
end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Preciaa

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MXRESCPH(     IAB,  IOCTPA,  IOCTPB,  NOCTPA,  NOCTPB,
     &                       NSMST,NSTFSMSPGP,MXPNSMST, NSMOB,MXPTOB,
     &                       NTPOB,   NTSOB,  NTESTG,   MXPKA, NEL1234,
     &                        MXCJ,  MXCIJA,  MXCIJB, MXCIJAB,  MXSXBL,
     &                    MXADKBLK,  IPHGAS,NHLFSPGP,    MNHL, IADVICE,
*
     &                    MXCJ_ALLSYM,MXADKBLK_AS,MX_NSPII)
*
* Find largest dimension of matrix C(Ka,Ib,J)
* Find largest dimension of matrix C(ij,Ka,Ib)
* Find largest dimension of matrix C(ij,Ia,Kb)
* Find largest dimension of matrix C(ij,Ka,Kb)
* Find largest dimension of matrix S(P,Ia,I,K) for a single K-string
*
* Particle hole version : hole electrons added, particle elec removed
*
* Largest block of single excitations MXSXBL

*. Input
* IAB :allowed combination of alpha and beta supergroups
* IOCPTA : Number of first active alpha supergroup
* IOCPTB : Number of first active beta  supergroup
* NOCTPA : Number of active alpha supergroups
* NOCTPB : Number of active alpha supergroups
*
* Version of Jan 98 : IPHGAS added

      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION IAB(NOCTPA,NOCTPB)
      DIMENSION NSTFSMSPGP(MXPNSMST,*)
      DIMENSION NTSOB(MXPTOB,NSMOB)
      DIMENSION NEL1234(MXPTOB,*)
      DIMENSION IPHGAS(*)
      INTEGER NHLFSPGP(*)
*
      NTESTL = 000
      NTEST = MAX(NTESTG,NTESTL)
      IF(NTEST.GE.100) WRITE(6,*) ' MXRESC : MXPKA ', MXPKA
*
* matrix C(j,Ka,Ib)
*
      MXKAB = 0
      MXCJ = 0
      MXCJ_ALLSYM = 0
      MXADKBLK = 0
      MXADKBLK_AS = 0
      MX_NSPII = 0
      DO IAORC= 1,2
      DO 100 IATP = 1, NOCTPA
        IATPABS = IATP + IOCTPA-1
        DO 200 IBTP = 1, NOCTPB
          IBTPABS = IBTP + IOCTPB - 1

          IF(IAB(IATP,IBTP).NE.0) THEN
            IF(NTEST.GE.100)
     &      WRITE(6,*) ' allowed IATP,IBTP', IATP,IBTP
            MXB = 0
            ITOTB = 0
            DO 210 ISM = 1, NSMST
              MXB =MAX(MXB,NSTFSMSPGP(ISM,IBTPABS))
              ITOTB = ITOTB + NSTFSMSPGP(ISM,IBTPABS)
  210       CONTINUE
            IF(NTEST.GE.100) WRITE(6,*) ' MXB,ITOTB = ', MXB,ITOTB
            DO 300 IOBTP = 1, NTPOB
*. No K strings obtained from creation in particle space
              IF(IAORC.EQ.2.AND.IPHGAS(IOBTP).EQ.1) GOTO 300
*. type of K string obtained
              CALL NEWTYP(IATPABS,IAORC,IOBTP,KATP)
              IF(NTEST.GE.100)
     &        WRITE(6,*) ' IOBTP KATP ',IOBTP,KATP
*. addi constraint to avoid calc with long columns and few rows
*. Works only in connection with active advice routine !
              IF(KATP.GT.0) THEN
                IF(IAORC.EQ.1.AND.IADVICE.EQ.1.AND.
     &          NHLFSPGP(IBTPABS)+NHLFSPGP(KATP).LT.MNHL.AND.
     &          NHLFSPGP(IATPABS).GT.(NHLFSPGP(IBTPABS)+1)) THEN
C                 WRITE(6,*) ' N-1 hole space eliminated '
C                 WRITE(6,*) ' IOBTP,IBTPABS,KATP',
C    &            IOBTP,IBTPABS,KATP
                  KATP = 0
                END IF
              END IF
*
              IF(KATP.GT.0) THEN
C                    DIM_SPII(IASPGRP,IBSPGRP,IOBTP,IAB,IAC,NSPII)
C               CALL DIM_SPII(IATPABS,IBTPABS,IOBTP,1,IAORC,NSPII)
C               MX_NSPII = MAX(MX_NSPII,NSPII)
                MX_NSPII = 0
              END IF

              IF(KATP.GT.0) THEN
                MXKA = 0
                DO 310 KSM = 1, NSMST
                  MXKA = MAX(MXKA,NSTFSMSPGP(KSM,KATP))
  310           CONTINUE
                IF(NTEST.GE.100) WRITE(6,*) ' MXKA = ',MXKA
                MXKAO = MXKA
                IF(MXPKA .GT. 0 .AND. MXKA .GT. MXPKA)
     &          MXKA= MXPKA
                MXSOB = 0
                NSOB_AS = 0
                DO 320 ISMOB = 1, NSMOB
                  MXSOB = MAX(MXSOB,NTSOB(IOBTP,ISMOB))
                  NSOB_AS = NSOB_AS + NTSOB(IOBTP,ISMOB)
  320           CONTINUE
                IF(NTEST.GE.100) WRITE(6,*) ' MXSOB = ', MXSOB
*
                MXADKBLK = MAX(MXADKBLK,MXSOB*MXKAO)
                MXADKBLK_AS = MAX(MXADKBLK_AS,NSOB_AS*MXKAO)
                LCJBLK = MXSOB*MXKA*MXB
                LCJBLK_ALLSYM = NSOB_AS*MXKA*ITOTB

                IF(LCJBLK.GT.MXCJ) THEN
                  MXCJ = LCJBLK
                  IATP_MX = IATP
                  IBTP_MX = IBTP
                  KATP_MX = KATP
                  IOBTP_MX = IOBTP
                END IF
                MXCJ_ALLSYM = MAX(MXCJ_ALLSYM,LCJBLK_ALLSYM)
                MXKAB = MAX(MXKAB,MXKA)
*
              END IF
  300       CONTINUE
          END IF
  200   CONTINUE
  100 CONTINUE
      END DO
*     ^ End of anni/crea map
*
* matrix C(j,Ia,Kb)
*
      DO IAORC = 1, 2
      DO IATP = 1, NOCTPA
        IATPABS = IATP + IOCTPA-1
        DO IBTP = 1, NOCTPB
          IBTPABS = IBTP + IOCTPB - 1

          IF(IAB(IATP,IBTP).NE.0) THEN
            IF(NTEST.GE.100)
     &      WRITE(6,*) ' allowed IATP,IBTP', IATP,IBTP
            MXA = 0
            ITOTA = 0
            DO ISM = 1, NSMST
              MXA =MAX(MXA,NSTFSMSPGP(ISM,IATPABS))
              ITOTA = ITOTA + NSTFSMSPGP(ISM,IATPABS)
            END DO
            IF(NTEST.GE.100) WRITE(6,*) ' MXA = ', MXA
            DO IOBTP = 1, NTPOB
*. type of K string obtained by removing one elec of type IOPBTP from IATP
              IF(IAORC.EQ.2.AND.IPHGAS(IOBTP).EQ.1) GOTO 2812
              CALL NEWTYP(IBTPABS,IAORC,IOBTP,KBTP)
              IF(NTEST.GE.100)
     &        WRITE(6,*) ' IOBTP KBTP ',IOBTP,KBTP
              IF(KBTP.GT.0) THEN
                IF(IAORC.EQ.1.AND.IADVICE.EQ.1.AND.
     &          NHLFSPGP(IATPABS)+NHLFSPGP(KBTP).LT.MNHL.AND.
     &          NHLFSPGP(IBTPABS).GT.NHLFSPGP(IATPABS)+1) THEN
C                 WRITE(6,*) ' N-1 hole space eliminated '
C                 WRITE(6,*) ' IOBTP,IATPABS,KBTP',
C    &            IOBTP,IATPABS,KBTP
                  KBTP = 0
                END IF
              END IF
              IF(KBTP.GT.0) THEN
C               CALL DIM_SPII(IATPABS,IBTPABS,IOBTP,2,IAORC,NSPII)
C               MX_NSPII = MAX(MX_NSPII,NSPII)
                MX_NSPII = 0
              END IF
*
              IF(KBTP.GT.0) THEN
                MXKB = 0
                DO KSM = 1, NSMST
                  MXKB = MAX(MXKB,NSTFSMSPGP(KSM,KBTP))
                END DO
                IF(NTEST.GE.100) WRITE(6,*) ' MXKB = ',MXKB
                MXKBO = MXKB
                IF(MXPKA .GT. 0 .AND. MXKB .GT. MXPKA)
     &          MXKB= MXPKA
                MXSOB = 0
                NSOB_AS = 0
                DO ISMOB = 1, NSMOB
                  MXSOB = MAX(MXSOB,NTSOB(IOBTP,ISMOB))
                  NSOB_AS = NSOB_AS + NTSOB(IOBTP,ISMOB)
                END DO
                IF(NTEST.GE.100) WRITE(6,*) ' MXSOB = ', MXSOB
*
                MXADKBLK = MAX(MXADKBLK,MXSOB*MXKBO)
                MXADKBLK_AS = MAX(MXADKBLK_AS,NSOB_AS*MXKBO)
CJULY29         LCJBLK = MXSOB*MXKB*MXB
                LCJBLK = MXSOB*MXKB*MXA
                LCJBLK_ALLSYM = NSOB_AS*MXKB*ITOTA
                MXCJ = MAX(MXCJ,LCJBLK)
                MXCJ_ALLSYM = MAX(MXCJ_ALLSYM,LCJBLK_ALLSYM)
                MXKAB = MAX(MXKAB,MXKB)
*
              END IF
 2812       CONTINUE
            END DO
          END IF
        END DO
      END DO
      END DO
*     ^ End of loop over creation/annihilation
      IF(NTEST.GT.100) THEN
        WRITE(6,*) 'MXRESC : MXADKBLK,MXCJ ', MXADKBLK,MXCJ
        WRITE(6,*) ' MXCJ_ALLSYM = ', MXCJ_ALLSYM
      END IF
*
* matrix C(ij,Ka,Ib)
* both Ka and Ib blocked
*
      MXCIJA = 0
      DO  IATP = 1, NOCTPA
        IATPABS = IATP + IOCTPA -1
        DO  IBTP = 1, NOCTPB
          IBTPABS = IBTP + IOCTPB - 1

          IF(IAB(IATP,IBTP).NE.0) THEN
            MXIB = 0
            DO  ISM = 1, NSMST
              MXIB = MAX(MXIB,NSTFSMSPGP(ISM,IBTPABS))
            END DO
            IF(MXIB.GT.MXPKA) MXIB = MXPKA
            IF(NTEST.GE.100) WRITE(6,*) ' MXIB = ', MXIB
            DO IAORC = 1, 2
            DO  IOBTP = 1, NTPOB
*. type of K string obtained by removing one elec of type IOPBTP from IATP
              CALL NEWTYP(IATPABS,IAORC,IOBTP,K1ATP)
*. No N+1 mappings for particle spaces
              IF(IAORC.EQ.2.AND.IPHGAS(IOBTP).EQ.1) K1ATP = 0
              IF(NTEST.GE.100)
     &        WRITE(6,*) ' IOBTP K1ATP ',IOBTP,K1ATP
              IF(K1ATP.GT.0) THEN
                MXISOB = 0
                DO ISMOB = 1, NSMOB
                  MXISOB = MAX(MXISOB,NTSOB(IOBTP,ISMOB))
                END DO
                IF(NTEST.GE.100) WRITE(6,*) ' MXISOB = ', MXISOB
                DO JAORC = 1, 2
                DO JOBTP = 1, NTPOB
*  type of K string obtained by removing one elec of type JOPBTP from K1ATP
                  CALL NEWTYP(K1ATP,JAORC,JOBTP,KATP)
                  IF(JAORC.EQ.2.AND.IPHGAS(JOBTP).EQ.1) KATP = 0
                  IF(KATP.GT.0) THEN
                    MXKA = 0
                    DO KSM = 1, NSMST
                      MXKA = MAX(MXKA,NSTFSMSPGP(KSM,KATP))
                    END DO
                    IF(NTEST.GE.100) WRITE(6,*) ' MXKA = ',MXKA
                    IF(MXPKA .GT. 0 .AND. MXKA .GT. MXPKA)
     &              MXKA= MXPKA
                    MXJSOB = 0
                    DO JSMOB = 1, NSMOB
                      MXJSOB = MAX(MXJSOB,NTSOB(JOBTP,JSMOB))
                    END DO
                    IF(NTEST.GE.100) WRITE(6,*) ' MXJSOB = ', MXJSOB
*
                    LBLK = MXISOB*MXJSOB*MXKA*MXIB
                    MXCIJA = MAX(MXCIJA,LBLK)
                  END IF
                END DO
                END DO
*               ^ End of loop over JOBTP, JAORC
              END IF
            END DO
            END DO
*           ^ End of loop over IOBTP, IAORC
          END IF
        END DO
      END DO
*
      IF(NTEST.GE.10) THEN
        WRITE(6,*) 'MXRESC : MXCIJA ', MXCIJA
      END IF
*
*
* matrix C(ij,Ia,kb)
* both Ka and Ib blocked
*
      MXCIJB = 0
      DO  IATP = 1, NOCTPA
        IATPABS = IATP + IOCTPA - 1
        DO  IBTP = 1, NOCTPB
          IBTPABS = IBTP + IOCTPB - 1
          IF(IAB(IATP,IBTP).NE.0) THEN
            MXIA = 0
            DO  ISM = 1, NSMST
              MXIA = MAX(MXIA,NSTFSMSPGP(ISM,IATPABS ))
            END DO
            IF(MXIA.GT.MXPKA) MXIA = MXPKA
            IF(NTEST.GE.100) WRITE(6,*) ' MXIA = ', MXIA
            DO IAORC = 1, 2
            DO  IOBTP = 1, NTPOB
*. type of K string obtained by removing one elec of type IOPBTP from IBTP
              CALL NEWTYP(IBTPABS,IAORC,IOBTP,K1BTP)
              IF(NTEST.GE.100)
     &        WRITE(6,*) ' IOBTP K1BTP ',IOBTP,K1BTP
              IF(IAORC.EQ.2.AND.IPHGAS(IOBTP).EQ.1)K1BTP = 0
              IF(K1BTP.GT.0) THEN
                MXISOB = 0
                DO ISMOB = 1, NSMOB
                  MXISOB = MAX(MXISOB,NTSOB(IOBTP,ISMOB))
                END DO
                IF(NTEST.GE.100) WRITE(6,*) ' MXISOB = ', MXISOB
                DO JAORC = 1, 2
                DO JOBTP = 1, NTPOB
*  type of K string obtained by removing one elec of type JOPBTP from K1ATP
                  CALL NEWTYP(K1BTP,JAORC,JOBTP,KBTP)
                  IF(JAORC.EQ.2.AND.IPHGAS(JOBTP).EQ.1) KBTP = 0
                  IF(KBTP.GT.0) THEN
                    MXKB = 0
                    DO KSM = 1, NSMST
                      MXKB = MAX(MXKB,NSTFSMSPGP(KSM,KBTP))
                    END DO
                    IF(NTEST.GE.100) WRITE(6,*) ' MXKB = ',MXKB
                    IF(MXPKA .GT. 0 .AND. MXKB .GT. MXPKA)
     &              MXKB= MXPKA
                    MXJSOB = 0
                    DO JSMOB = 1, NSMOB
                      MXJSOB = MAX(MXJSOB,NTSOB(JOBTP,JSMOB))
                    END DO
                    IF(NTEST.GE.100) WRITE(6,*) ' MXJSOB = ', MXJSOB
*
                    LBLK = MXISOB*MXJSOB*MXKB*MXIA
                    MXCIJB = MAX(MXCIJB,LBLK)
                  END IF
                END DO
                END DO
*               ^ End of loop over JOBTP,JAORC
              END IF
            END DO
            END DO
*           ^ End of loop over IOBTP,IAORC
          END IF
        END DO
      END DO
*
      IF(NTEST.GT.10) THEN
        WRITE(6,*) 'MXRESC : MXCIJB ', MXCIJB
      END IF
*
*
* matrix C(ij,Ka,kb)
* both Ka and Kb blocked
*
*. Modified : Only used if at most two elecs in i and j
*.            No batching
*.            Used for hardwired few electron code
      MXCIJAB = 0
      MXKACTEL = 1
      DO  IATP = 1, NOCTPA
        IATPABS = IATP + IOCTPA - 1
        DO  IBTP = 1, NOCTPB
          IBTPABS = IBTP + IOCTPB - 1
          IF(IAB(IATP,IBTP).NE.0) THEN
            DO  IOBTP = 1, NTPOB
*. type of Ka string obtained by removing one elec of type IOPBTP from IATP
              CALL NEWTYP(IATPABS,1,IOBTP,KATP)
              IF(NTEST.GE.100)
     &        WRITE(6,*) ' IOBTP KATP ',IOBTP,KATP
C           NEL1234(JOBTP,IATPABS)
              IF(KATP.GT.0) THEN
                IF(NEL1234(IOBTP,KATP).GT.MXKACTEL) KATP = 0
              END IF
              IF(KATP.GT.0) THEN
                MXKA = 0
                DO KSM = 1, NSMST
                  MXKA = MAX(MXKA,NSTFSMSPGP(KSM,KATP))
                END DO
                IF(NTEST.GE.100) WRITE(6,*) ' MXKA = ',MXKA
*. No partitioning
C               IF(MXPKA .GT. 0 .AND. MXKA .GT. MXPKA) MXKA= MXPKA

                MXISOB = 0
                DO ISMOB = 1, NSMOB
                  MXISOB = MAX(MXISOB,NTSOB(IOBTP,ISMOB))
                END DO
                IF(NTEST.GE.100) WRITE(6,*) ' MXISOB = ', MXISOB
                DO JOBTP = 1, NTPOB
*  type of K string obtained by removing one elec of type JOPBTP from IBTP
                  CALL NEWTYP(IBTPABS,1,JOBTP,KBTP)
                  IF(KBTP.GT.0) THEN
                    IF(NEL1234(JOBTP,KBTP).GT.MXKACTEL) KBTP = 0
                  END IF
                  IF(KBTP.GT.0) THEN
                    MXKB = 0
                    DO KSM = 1, NSMST
                      MXKB = MAX(MXKB,NSTFSMSPGP(KSM,KBTP))
                    END DO
                    IF(NTEST.GE.100) WRITE(6,*) ' MXKB = ',MXKB
*. No partitioning
C                   IF(MXPKA .GT. 0 .AND. MXKB .GT. MXPKA) MXKB= MXPKA
                    MXJSOB = 0
                    DO JSMOB = 1, NSMOB
                      MXJSOB = MAX(MXJSOB,NTSOB(JOBTP,JSMOB))
                    END DO
                    IF(NTEST.GE.100) WRITE(6,*) ' MXJSOB = ', MXJSOB
*
                    LBLK = MXISOB*MXJSOB*MXKB*MXKA
                    MXCIJAB = MAX(MXCIJAB,LBLK)
                  END IF
                END DO
              END IF
            END DO
          END IF
        END DO
      END DO
*
*
* Largest block of single excitations :
* Strings of given type and sym, orbitals of given type and sym
*
* Largest block of creations : a+i !kstring> where K string is
* obtained as single annihilations
      MXSXBL = 0
*. For alpha strings :
      DO  IATP = 1, NOCTPA
        IATPABS = IATP + IOCTPA - 1
        MXIA = 0
        DO  ISM = 1, NSMST
          MXIA = MAX(MXIA,NSTFSMSPGP(ISM,IATPABS))
        END DO
        IF(NTEST.GE.100) WRITE(6,*) ' MXIA = ', MXIA
*. Orbitals to be removed
        DO  JOBTP = 1, NTPOB
*. Is this removal allowed ??
          CALL NEWTYP(IATPABS,1,JOBTP,KATP)
          IF(NTEST.GE.100)
     &    WRITE(6,*) ' JOBTP KATP ',JOBTP,KATP
          IF(KATP.GT.0) THEN
*. Number of possible choices of J orbitals
            MXJOB = 0
            DO JSMOB = 1, NSMOB
               MXJOB = MAX(MXJOB,NTSOB(JOBTP,JSMOB))
            END DO
            MXJOB = MIN(MXJOB,NEL1234(JOBTP,IATPABS))
            IF(NTEST.GE.100) WRITE(6,*) ' MXJOB = ', MXJOB
*. Then  : add an electron
            DO IOBTP = 1, NTPOB
*  Allowed ?
              CALL NEWTYP(KATP,2,IOBTP,JATP)
              IF(JATP.GT.0) THEN
                MXIOB = 0
                DO ISMOB = 1, NSMOB
                  MXIOB = MAX(MXIOB,NTSOB(IOBTP,ISMOB))
                END DO
*
                MXSXBL = MAX(MXSXBL,MXIOB*MXJOB*MXIA)
              END IF
            END DO
          END IF
        END DO
      END DO
*
*. For beta  strings :
      DO  IBTP = 1, NOCTPB
        IBTPABS = IBTP + IOCTPB - 1
        MXIB = 0
        DO  ISM = 1, NSMST
          MXIB = MAX(MXIB,NSTFSMSPGP(ISM,IBTPABS))
        END DO
        IF(NTEST.GE.100) WRITE(6,*) ' MXIB = ', MXIB
*. Orbitals to be removed
        DO  JOBTP = 1, NTPOB
*. Is this removal allowed ??
          CALL NEWTYP(IBTPABS,1,JOBTP,KBTP)
          IF(NTEST.GE.100)
     &    WRITE(6,*) ' JOBTP KBTP ',JOBTP,KBTP
          IF(KBTP.GT.0) THEN
*. Number of possible choices of J orbitals
            MXJOB = 0
            DO JSMOB = 1, NSMOB
               MXJOB = MAX(MXJOB,NTSOB(JOBTP,JSMOB))
            END DO
            MXJOB = MIN(MXJOB,NEL1234(JOBTP,IBTP))
            IF(NTEST.GE.100) WRITE(6,*) ' MXJOB = ', MXJOB
*. Then  : add an electron
            DO IOBTP = 1, NTPOB
*  Allowed ?
              CALL NEWTYP(KBTP,2,IOBTP,JBTP)
              IF(JATP.GT.0) THEN
                MXIOB = 0
                DO ISMOB = 1, NSMOB
                  MXIOB = MAX(MXIOB,NTSOB(IOBTP,ISMOB))
                END DO
*
                MXSXBL = MAX(MXSXBL,MXIOB*MXJOB*MXIA)
              END IF
            END DO
          END IF
        END DO
      END DO
*
      IF(NTEST.GT.10) THEN
        WRITE(6,*) 'MXRESC: MXSXBL : ', MXSXBL
        WRITE(6,*) ' MXRESC_PH : MXKAB = ', MXKAB
        WRITE(6,*) ' Info on largest C(Ka,j,Jb) block'
        WRITE(6,*) ' IATP_MX, IBTP_MX, KATP_MX, IOBTP_MX ',
     &               IATP_MX, IBTP_MX, KATP_MX, IOBTP_MX
        WRITE(6,*) ' MX_NSPII = ', MX_NSPII
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Ben Swerts                                             *
!               2016, Liviu Ungur                                      *
!***********************************************************************

subroutine MakeDens(nBas,nOrb,Cff,OrbEn,EnergyWeight,Dens)
!***********************************************************************
!                                                                      *
!     purpose: Compute (energy weighted) density matrix in AO basis    *
!                                                                      *
!     input:                                                           *
!       nBas    : number of basis functions                            *
!       nOrb    : number of orbitals                                   *
!       Cff     : molecular orbital coefficients                       *
!       OrbEn   : molecular orbital energies                           *
!       EnergyWeight : if .true. do energy weighting                   *
!                                                                      *
!     output:                                                          *
!       Dens    : density matrix in triangular storage                 *
!                                                                      *
!     called from: Drv2El_FAIEMP                                       *
!                  FragPInt                                            *
!                                                                      *
!     written by: B. Swerts                                            *
!     modified by L. Ungur                                             *
!     simplified version of scf/done_scf.f                             *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBas, nOrb
real(kind=wp), intent(in) :: Cff(nBas*nOrb), OrbEn(nOrb)
logical(kind=iwp), intent(in) :: EnergyWeight
real(kind=wp), intent(out) :: Dens(nBas*(nBas+1)/2)
integer(kind=iwp) :: i, Ind, ij, iRow, iCol
real(kind=wp) :: energy, rSum
logical(kind=iwp) :: DBG

energy = One

DBG = .false.
if (DBG) write(u6,*) 'MakeDens:  EnergyWeight',EnergyWeight
if (DBG) call xFlush(u6)
if (DBG) write(u6,*) 'MakeDens:  nBas=',nBas
if (DBG) call xFlush(u6)
if (DBG) write(u6,*) 'MakeDens:  nOrb=',nOrb
if (DBG) call xFlush(u6)
if (DBG) write(u6,*) 'MakeDens: OrbEn=',(OrbEn(i),i=1,nOrb)
if (DBG) call xFlush(u6)
if (DBG) write(u6,*) 'MakeDens:   Cff=',(Cff(i),i=1,nBas*nOrb)
if (DBG) call xFlush(u6)

do iRow=1,nBas
  rSum = Zero
  ij = -1
  do i=1,nOrb
    ij = ij+1
    if (EnergyWeight) energy = OrbEn(i)
    rSum = rSum+energy*Cff(iRow+ij*nBas)*Cff(iRow+ij*nBas)
  end do
  Ind = iRow*(iRow-1)/2
  Dens(Ind+iRow) = Two*rSum

  do iCol=1,iRow-1
    rSum = Zero
    ij = -1
    do i=1,nOrb
      ij = ij+1
      if (EnergyWeight) energy = OrbEn(i)
      rSum = rSum+energy*Cff(iRow+ij*nBas)*Cff(iCol+ij*nBas)
    end do
    Dens(Ind+iCol) = Four*rSum
  end do
end do
if (DBG) call TriPrt('Dens in MakeDens',' ',Dens,nBas)
if (DBG) call xFlush(u6)

return

end subroutine MakeDens

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
       SubRoutine creq2(q,G2,idSym,Temp,Scr,n2)
*
*      Constructs the Q matrix
*
       Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
       Real*8 Q(nDens2),G2(*),Temp(n2),Scr(n2)
*                                                                      *
************************************************************************
*                                                                      *
       itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*      Q = (pj|kl)d
*       pi         ijkl
*
       call dcopy_(ndens2,[0.0d0],0,Q,1)
*
       Do iS=1,nSym
          ipS=iEOr(is-1,idsym-1)+1
          If (norb(ips).ne.0) Then
             Do jS=1,nsym
                ijS=iEOR(is-1,js-1)+1
                Do kS=1,nSym
                   ls=iEOr(ijs-1,ks-1)+1
*
                   Do kAsh=1,nAsh(ks)
                      Do lAsh=1,nAsh(ls)
                         ikl=itri(lAsh+nA(lS),kAsh+nA(kS))
*
                         Call Coul(ipS,jS,kS,lS,
     &                             nIsh(kS)+kAsh,nIsh(lS)+lAsh,Temp,Scr)
*
                         Do iAsh=1,nAsh(is)
                            ipQ=ipMatba(ipS,iS)+nOrb(ipS)*(iAsh-1)
                            Do jAsh=1,nAsh(jS)
                               iij=iTri(iAsh+nA(iS),jAsh+nA(jS))
                               ipG=iTri(iij,ikl)
                               ipI = (nIsh(jS)+jAsh-1)*nOrb(ipS) + 1
*
                              call daxpy_(nOrb(ipS),G2(ipG),Temp(ipI),1,
     &                                   Q(ipQ),1)
*
                            End Do
                         End Do
                      End Do
                   End Do
*
                End Do
             End Do
          End If
       End Do
*                                                                      *
************************************************************************
*                                                                      *
       Return
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Real*8 Function CovRadT(i)
      Implicit Real*8 (a-h,o-z)
#include "covradt_data.fh"
*
      If (i.gt.92) Then
*        Write (*,*) 'CovRadT: i.gt.92'
         CovRadT=1.50d0
      Else
         CovRadT=CovRadT_(i)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Roland Lindh                                     *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

!#define _DEBUGPRINT_
subroutine yHx(X,Y,nXY)
!***********************************************************************
!                                                                      *
!     purpose: multiply an approximation of the orbital Hessian times  *
!              a trial vector, X.                                      *
!                                                                      *
!     Y = H(approximate) x  X                                          *
!                                                                      *
!***********************************************************************

use InfSCF, only: FockMO, nFro, nOcc, nOrb, nSym, OrbType
use Constants, only: Zero, One, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nXY
real(kind=wp), target, intent(in) :: X(nXY)
real(kind=wp), target, intent(out) :: Y(nXY)
integer(kind=iwp) :: iD, iOcc, iOff_F, iOff_XY, iSym, iVir, jOcc, jVir, nD, nOccmF, nOrbmF
real(kind=wp) :: Hij, Tmp
real(kind=wp), parameter :: Hii_Max = One, Hii_Min = 0.05_wp
real(kind=wp), pointer :: Fock(:,:), XP(:,:), YP(:,:)

!----------------------------------------------------------------------*

!write(u6,*)
!call NrmClc(FockMO,SIZE(FockMO),'yHx','FockMO(:,:)')
!call NrmClc(X,SIZE(X),'yHx','X(:)')
!call RecPrt('yHx: FockMO',' ',FockMO,Size(FockMO,1),Size(FockMO,2))
!call RecPrt('yHx: X',' ',X,1,Size(X))

nD = size(FockMO,2)
iOff_XY = 0
do iD=1,nD

  iOff_F = 0
  do iSym=1,nSym

    ! loop over all occ orbitals in sym block

    ! number of Occupied, excluding frozen
    nOccmF = nOcc(iSym,iD)-nFro(iSym)
    ! number of Orbitals, excluding frozen
    nOrbmF = nOrb(iSym)-nFro(iSym)

    Fock(1:nOrb(iSym),1:nOrb(iSym)) => FockMO(iOff_F+1:iOff_F+nOrb(iSym)**2,iD)
    XP(nOccmF+1:nOrbmF,1:nOccmF) => X(iOff_XY+1:iOff_XY+nOccmF*(nOrbmF-nOccmF))
    YP(nOccmF+1:nOrbmF,1:nOccmF) => Y(iOff_XY+1:iOff_XY+nOccmF*(nOrbmF-nOccmF))

    do iOcc=1,nOccmF
      do iVir=nOccmF+1,nOrbmF

        Tmp = Zero
        do jOcc=1,nOccmF
          do jVir=nOccmF+1,nOrbmF

            Hij = Zero
            if ((OrbType(iVir,iD) == OrbType(iOcc,iD)) .and. (OrbType(jVir,iD) == OrbType(jOcc,iD)) .and. &
                (OrbType(iVir,iD) == OrbType(jOcc,iD))) then

              if ((iVir == jVir) .and. (iOcc == jOcc)) then
                Hij = (Four*(Fock(iVir,jVir)-Fock(iOcc,jOcc))/real(nD,kind=wp))

                if (Hij < Zero) then
                  !write (u6,*) 'Hii<0.0, Hii=',Hij
                  Hij = max(Hii_Max,abs(Hij))
                else if (abs(Hij) < Hii_Min) then
                  !write(u6,*) 'Abs(Hii)<0.05, Hii=',Hij
                  !write(u6,*) 'jVir,jOcc=',jVir,jOcc
                  !write(u6,*) 'Fock(jOcc,jOcc)=',Fock(jOcc,jOcc)
                  !write(u6,*) 'Fock(jVir,jVir)=',Fock(jVir,jVir)
                  Hij = Hii_Min
                end if

              else if ((iVir == jVir) .and. (iOcc /= jOcc)) then
                Hij = (Four*(-Fock(iOcc,jOcc))/real(nD,kind=wp))
              else if ((iOcc == jOcc) .and. (iVir /= jVir)) then
                Hij = (Four*(Fock(iVir,jVir))/real(nD,kind=wp))
              end if
              Tmp = Tmp+Hij*XP(jVir,jOcc)

            end if

          end do  ! jVir
        end do    ! jOcc
        YP(iVir,iOcc) = Tmp

      end do  ! iVir
    end do    ! iOcc

    nullify(Fock,XP,YP)
    iOff_XY = iOff_XY+nOccmF*(nOrbmF-nOccmF)
    iOff_F = iOff_F+nOrb(iSym)**2

  end do ! iSym
end do ! iD
#ifdef _DEBUGPRINT_
call NrmClc(Y,size(Y),'yHx','Y(:)')
call RecPrt('yHx: Y',' ',Y,1,size(Y))
#endif

#undef _DEBUGPRINT_
end subroutine yHx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SUBROUTINE STSTSM_MCLR(STSTSX,STSTDX,NSMST)
*
* construct  STSTSX and STSTDX giving
* symmetry of sx (dx) connecting two given string symmetries
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER STSTSX(NSMST,NSMST),STSTDX(NSMST,NSMST)
*
      DO 100 ILSTSM = 1, NSMST
        DO 50 IRSTSM = 1, NSMST
          CALL SYMCOM_MCLR(1,5,ISXSM,IRSTSM,ILSTSM)
          CALL SYMCOM_MCLR(1,6,IDXSM,IRSTSM,ILSTSM)
          STSTSX(ILSTSM,IRSTSM) = ISXSM
          STSTDX(ILSTSM,IRSTSM) = IDXSM
   50   CONTINUE
  100 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' STSTSM : STSTSX, STSTDX '
        CALL IWRTMA(STSTSX,NSMST,NSMST,NSMST,NSMST)
        CALL IWRTMA(STSTDX,NSMST,NSMST,NSMST,NSMST)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Giovanni Ghigo                                   *
************************************************************************
      Subroutine MkExSB12(iAddSB,LenSB,
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden & Torino University, Italy         *
*           February 2005                                              *
*----------------------------------------------------------------------*
* Purpuse:  Generation of the SubBlock(1,2) (p,q inactive,active) of   *
*           two-electron integral matrix for each i,j occupied couple. *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Logical SameLx

*   - SubBlock 1 2
      LenSB = nIsh(iSymA) * nAsh(iSymB)
      Call GetMem('SB','Allo','Real',iAddSB,LenSB)

*     Build Lx
      Call GetMem('Lx','Allo','Real',iAddLx0,nIsh(iSymA)*numV)
      LxType=0
      iIx=0
      SameLx=.False.
      Call MkL1(iSymA,iSymI,iI,numV, LxType,iIx, iAddLx0,SameLx)

*     Build Ly
      Call GetMem('Ly','Allo','Real',iAddLy0,nAsh(iSymB)*numV)
      Call MkL2(iSymB,iSymJ,iJ,numV, LxType,iIx, iAddLy0,SameLx)

*     Generate the SubBlock
      Call DGEMM_('N','T',nAsh(iSymB),nIsh(iSymA),numV,1.0d0,
     &    Work(iAddLy0),nAsh(iSymB), Work(iAddLx0),nIsh(iSymA),
     &                     0.0d0,Work(iAddSB),nAsh(iSymB) )

      Call GetMem('Ly','Free','Real',iAddLy0,nAsh(iSymB)*numV)
      Call GetMem('Lx','Free','Real',iAddLx0,nIsh(iSymA)*numV)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine XDR_mkutls(n,TL,TS,Tr,Bk,A,B,R,UL,US,M1,M2,M3,M4)
! Evaluate transform matrices in non-orthogonal basis space

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: TL(n,n), TS(n,n), Tr(n,n), Bk(n,n), A(n), B(n), R(n)
real(kind=wp), intent(out) :: UL(n,n), US(n,n), M1(n,n), M2(n,n), M3(n,n), M4(n,n)
integer(kind=iwp) :: i

do i=1,n
  M1(:,i) = Tr(:,i)*A(i)
  M2(:,i) = Tr(:,i)*A(i)*R(i)
end do
call dmxma(n,'N','N',M1,TL,M3,One)
call dmxma(n,'N','N',M2,TS,M4,One)
M3(:,:) = M3(:,:)-M4(:,:)
call dmxma(n,'N','N',M3,Bk,UL,One)

do i=1,n
  M1(:,i) = Tr(:,i)*B(i)
  M2(:,i) = Tr(:,i)*B(i)/R(i)
end do
call dmxma(n,'N','N',M1,TL,M3,One)
call dmxma(n,'N','N',M2,TS,M4,One)
M3(:,:) = M3(:,:)+M4(:,:)
call dmxma(n,'N','N',M3,Bk,US,One)

return

end subroutine XDR_mkutls

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine cnfsort_cvb(iconfs,nconf1,nel1,ioncty,iconfs2)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


      dimension iconfs(noe,nconf1),ioncty(nconf1),iconfs2(noe,nconf1)

      mnion1=nel1/2
      mxion1=0
      do 100 iconf=1,nconf1
      ion=0
      do 200 iorb=1,norb
      if(iconfs(iorb,iconf).eq.2)ion=ion+1
200   continue
      ioncty(iconf)=ion
      if(ion.lt.mnion1)mnion1=ion
      if(ion.gt.mxion1)mxion1=ion
100   continue
      jconf=0
      do 300 ion=mnion1,mxion1
      do 301 iconf=1,nconf1
      if(ioncty(iconf).eq.ion)then
        jconf=jconf+1
        call imove_cvb(iconfs(1,iconf),iconfs2(1,jconf),noe)
      endif
301   continue
300   continue
      if(jconf.ne.nconf1)then
        write(6,*)' Error in cnfsort - jconf not same as nconf1 :',
     >    jconf,nconf1
        call abend_cvb()
      endif
        call imove_cvb(iconfs2,iconfs,noe*nconf1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_grc0 (nind,typ,typp,typq,typr,typs,stot,
     & poss0,posst,mapd,mapi)
c
c     this routine defines mapd and mapi for given intermediat
c
c     !N.B. (this routine cannot run with +OP2)
c
       integer nind,typ,typp,typq,typr,typs,stot,poss0,posst
c
#include "t31.fh"
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer sp,sq,sr,ss,spq,spqr
       integer nsymq,nsymr
       integer poss,i,nhelp1,nhelp2,nhelp3,nhelp4
c
c     To fix some compiler warnings
      poss=0
      i=0
c     vanishing mapi files
c
       do nhelp1=1,nsym
       do nhelp2=1,nsym
       do nhelp3=1,nsym
       mapi(nhelp3,nhelp2,nhelp1)=0
       end do
       end do
       end do
c
       if (nind.eq.1) then
c
c     matrix A(p)
c
       i=1
       poss=poss0
       sp=mmul(stot,1)
c
       nhelp1=dimm(typp,sp)
c
c     def mapi
       mapi(1,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def length
       mapd(i,2)=nhelp1
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=0
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
       else if (nind.eq.2) then
c
c     matrix A(p,q)
c
       i=1
       poss=poss0
c
       do 100 sp=1,nsym
c
       sq=mmul(stot,sp)
       if ((typ.eq.1).and.(sp.lt.sq)) then
c     Meggie out
       goto 100
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
c
c     def mapi
       mapi(sp,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def length
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2
       end if
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 100    continue
c
       else if (nind.eq.3) then
c
c     matrix A(p,q,r)
c
       i=1
       poss=poss0
c
       do 200 sp=1,nsym
       if (typ.eq.1) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 201 sq=1,nsymq
       spq=mmul(sp,sq)
c
       sr=mmul(stot,spq)
       if ((typ.eq.2).and.(sq.lt.sr)) then
c     Meggie out
       goto 201
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
c
c     def mapi
       mapi(sp,sq,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def length
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)*nhelp3/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3
       end if
c
c     def sym p,q,r
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 201    continue
 200    continue
c
       else if (nind.eq.4) then
c
c     matrix A(p,q,r,s)
c
       i=1
       poss=poss0
c
       do 300 sp=1,nsym
       if ((typ.eq.1).or.(typ.eq.4)) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 301 sq=1,nsymq
       spq=mmul(sp,sq)
       if (typ.eq.2) then
       nsymr=sq
       else
       nsymr=nsym
       end if
c
       do 302 sr=1,nsymr
       spqr=mmul(spq,sr)
c
       ss=mmul(stot,spqr)
       if (((typ.eq.3).or.(typ.eq.4)).and.(sr.lt.ss)) then
c     Meggie out
       goto 302
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
       nhelp4=dimm(typs,ss)
c
c     def mapi
       mapi(sp,sq,sr)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def length
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp3-1)*nhelp4/2
       else if ((typ.eq.3).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else if (typ.eq.4) then
       if ((sp.eq.sq).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*(nhelp4-1)/4
       else if (sp.eq.sq) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if (sr.eq.ss) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
c
c     def sym p,q,r,s
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=ss
c
       poss=poss+mapd(i,2)
       i=i+1
c
 302    continue
 301    continue
 300    continue
c
       end if

c
       posst=poss
c
c     definition of other coll
c
       mapd(0,1)=typp
       mapd(0,2)=typq
       mapd(0,3)=typr
       mapd(0,4)=typs
       mapd(0,5)=i-1
       mapd(0,6)=typ
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NEWSCTAB(MINOP,MAXOP,MLTPL,MS2,ICASE)
      use definitions, only: iwp, u6
      use stdalloc, only: mma_allocate
      use rassi_global_arrays, only: TRANS1, TRANS2, TRANS
      use rassi_global_arrays, only: SPNTAB1, SPNTAB2, SPNTAB
      IMPLICIT NONE
      INTEGER(KIND=IWP), INTENT(IN):: MINOP,MAXOP,MLTPL,MS2, ICASE

      INTEGER(KIND=IWP), PARAMETER :: ASPIN=1, BSPIN=0
      INTEGER(KIND=IWP), PARAMETER :: UPCPL=1,DWNCPL=0, NULLPTR=-1
      INTEGER(KIND=IWP) IBLK,IOPEN,KSPCPL,KSPDET,LTRANS,LTRANS0,NA,NBLK,
     &                  NCP,ND,NSPCPL,NSPDET,NTAB,NTRANS,NB
      INTEGER(KIND=IWP), EXTERNAL:: NGENE,NOVERM

      IF(MLTPL-MS2.LT.1 .OR. MLTPL+MS2.LT.1) THEN
      WRITE(u6,*)'NewSCTab: Contradictory values of MLTPL vs. MS2.'
      WRITE(u6,*)
     &        'The function was invoked with the following arguments:'
      WRITE(u6,'(1X,A,I9)')' MINOP:',MINOP
      WRITE(u6,'(1X,A,I9)')' MAXOP:',MAXOP
      WRITE(u6,'(1X,A,I9)')' MLTPL:',MLTPL
      WRITE(u6,'(1X,A,I9)')' MS2  :',MS2
      CALL ABEND()
      END IF

C Run through construction loop twice. First get size of table
C and total nr of transformation coefficients:
      NSPCPL=0
      NSPDET=0
      NTRANS=0
      IBLK=0
      DO IOPEN=MINOP,MAXOP
        IBLK=IBLK+1
        NCP=NGENE(IOPEN,MLTPL)
        IF(NCP.EQ.0) CYCLE
        NA=(IOPEN+MS2)/2
        ND=NOVERM(IOPEN,NA)
        NSPCPL=NSPCPL+IOPEN*NCP
        NSPDET=NSPDET+IOPEN*ND
        NTRANS=NTRANS+ND*NCP
      END DO
      NBLK=IBLK
      NTAB=8+6*NBLK+NSPCPL+NSPDET
C The spincoupling table will be NTAB integers long, and there
C will be NTRANS spin-coupling coefficients (real*8).
C The table consists of 8 header words, then an array (6,NBLK)
C with pointers and sizes to the spin coupling, spin determinant
C and spin-coupling coefficient arrays, and finally the
C spin coupling and spin determinant arrays themselves.
C The transformation coefficients are real*8 data and stored
C in a separate array.
      SELECT CASE(ICASE)
      CASE (1)
         CALL mma_allocate(SPNTAB1,NTAB,Label='SPNTAB1')
         SPNTAB=>SPNTAB1(:)
         CALL mma_allocate(TRANS1,NTRANS,Label='TRANS1')
         TRANS=>TRANS1(:)
      CASE (2)
         CALL mma_allocate(SPNTAB2,NTAB,Label='SPNTAB2')
         SPNTAB=>SPNTAB2(:)
         CALL mma_allocate(TRANS2,NTRANS,Label='TRANS2')
         TRANS=>TRANS2(:)
      CASE DEFAULT
      END SELECT
      KSPCPL=9+6*NBLK
      KSPDET=KSPCPL+NSPCPL
C Table size
      SPNTAB(1)=NTAB
C Table type identifier
      SPNTAB(2)=47
C Spin multiplicity
      SPNTAB(3)=MLTPL
C Spin projection
      SPNTAB(4)=MS2
C Min and max nr of open shells
      SPNTAB(5)=MINOP
      SPNTAB(6)=MAXOP
C Associated workspace array for Re*8 data (transf matrices)
      SPNTAB(7)=-1 ! not used
      SPNTAB(8)=NTRANS
C Individual information for each separate nr of open shells:
      NTAB=6
      NTRANS=0
      IBLK=0
      LTRANS0=1
      LTRANS=1
      DO IOPEN=MINOP,MAXOP
        IBLK=IBLK+1
        NCP=NGENE(IOPEN,MLTPL)
        NA=(IOPEN+MS2)/2
        NB= IOPEN-NA
        IF(NCP.GT.0) THEN
          ND=NOVERM(IOPEN,NA)
          SPNTAB(9+(IBLK-1)*6)=IOPEN
          SPNTAB(10+(IBLK-1)*6)=NCP
          SPNTAB(11+(IBLK-1)*6)=ND
C Compute spin couplings:
          CALL PROTOCSF(IOPEN,MLTPL,NCP,SPNTAB(KSPCPL:))
          SPNTAB(12+(IBLK-1)*6)=KSPCPL
C Compute spin determinants:
          CALL PROTOSD(NA,NB,ND,SPNTAB(KSPDET:))
          SPNTAB(13+(IBLK-1)*6)=KSPDET
C Compute spin coupling coefficients:
          CALL PROTOT(IOPEN,ND,SPNTAB(KSPDET:),NCP,
     &                      SPNTAB(KSPCPL:),TRANS(LTRANS:))
          SPNTAB(14+(IBLK-1)*6)=LTRANS-LTRANS0+1
          KSPCPL=KSPCPL+IOPEN*NCP
          KSPDET=KSPDET+IOPEN*ND
          LTRANS=LTRANS+ND*NCP
        ELSE
          SPNTAB(9+(IBLK-1)*6)=IOPEN
          SPNTAB(10+(IBLK-1)*6)=0
          SPNTAB(11+(IBLK-1)*6)=0
          SPNTAB(12+(IBLK-1)*6)=NULLPTR
          SPNTAB(13+(IBLK-1)*6)=NULLPTR
          SPNTAB(14+(IBLK-1)*6)=NULLPTR
        END IF
      END DO

      nullify(TRANS,SPNTAB)

      END SUBROUTINE NEWSCTAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_Energ
c
c        calc energy from T1c and t2c
c
        implicit none
#include "chcc1.fh"
c
c        help var
        integer i,j,a,b
        real*8 e
c
        e=0.0d0
c
        do j=1,no
        do i=1,no
        do b=1,nv
        do a=1,nv
          e=e+(2.0d0*Q21(a,i,b,j)-Q21(a,j,b,i))*
     c        (T2c(a,b,i,j)+T1c(a,i)*T1c(b,j))
        end do
        end do
        end do
        end do
c
        write (6,*) ' Energia Checkeroo',e
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Jie J. Bao                                       *
************************************************************************
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Aug. 06, 2020, created this file.               *
* ****************************************************************
      Subroutine SolveforRHS(Fock,CICSF,AXkzx,AXPzx,bk,bP)
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"
****** Output
      Real*8,DIMENSION(nDens2+6)::Fock
      Real*8,DIMENSION(nconf1*nroots)::CICSF
****** Input
      Real*8,DIMENSION(nDens2)::AXkzx
      Real*8,DIMENSION(NConf1*nRoots)::AXPzx
      Real*8,DIMENSION(nDens2)::bk
      Real*8,DIMENSION(nConf1*nRoots)::bP
****** Assistants
      INTEGER nRow

*****  Orbital Rotation Part
      nRow=nDens2
      CALL FZero(Fock,nDens2)
      CALL DCopy_(nRow,Axkzx,1,Fock,1)
      CALL DAXPY_(nRow,1.0d0,bk,1,Fock,1)

****** State-CSF Rotation Part
      nRow=nRoots*nConf1
      CALL FZero(CICSF,nRow)
      CALL DCopy_(nRow,AXPzx,1,CICSF,1)
      CALL DAXPY_(nRow,-1.0d0,bP,1,CICSF,1)

      RETURN
      END SUBROUTINE
******************************************************

******************************************************
      subroutine SolveforzX(zX,AXX,bX)
      use stdalloc, only : mma_allocate, mma_deallocate
      use cmslag,   only : ResQaaLag2
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"
#include "warnings.h"
****** Output
      Real*8,DIMENSION((nRoots-1)*nRoots/2)::zX
****** Input
      Real*8,DIMENSION((nRoots-1)*nRoots/2)::bX
      Real*8,DIMENSION(((nRoots-1)*nRoots/2)**2)::AXX
****** Assistants
      Real*8,DIMENSION(:),Allocatable::EigVal,bxscr,zXscr,Scr
      Real*8 TwoPi
      INTEGER NDim,nSPair,iPair,nScr,INFO


      NDim=((nRoots-1)*nRoots/2)
      nSPair=nDim
      TwoPi=2.0d0*Pi
      ResQaaLag2=0.0d0
      CALL mma_allocate(EigVal,nDim)
      CALL mma_allocate(bxScr ,nDim)
      CALL mma_allocate(zXScr ,nDim)

      CALL GetDiagScr(nScr,AXX,EigVal,nDim)
      CALL mma_allocate(Scr   ,nScr)

      CALL DSYEV_('V','U',nDim,AXX,nDim,EigVal,Scr,nScr,INFO)

      CALL DGEMM_('n','n',1,nDim,nDim,1.0d0,bx,1,AXX,nDim,
     &                                0.0d0,bxScr,1)


      DO iPair=1,nDim
       zxScr(iPair)=-bxScr(iPair)/EigVal(iPair)
       IF(Abs(zxScr(iPair)).gt.TwoPi) THEN
        zxScr(iPair)=0.0d0
        ResQaaLag2=ResQaaLag2+bxScr(iPair)**2
       END IF
      END DO

      write(6,'(6X,A37,2X,ES17.9)')
     & 'Residual in Qaa Lagrange Multipliers:',SQRT(ResQaaLag2)
      IF(ResQaaLag2.gt.epsilon**2) THEN
        write(6,*)
        write(6,'(6X,A)')
     &    'ERROR: RESIDUAL(S) FOR INTERMEDIATE STATE TOO BIG!'
        write(6,*)
        write(6,'(6X,A)')
     &    'This may come from a linear molecular or a linear'
        write(6,'(6X,A)')
     &    'fragment.'
        write(6,'(6X,A)')
     &    'CMS-PDFT Lagrange multipliers are not solved.'
        CALL WarningMessage(2,
     &    'Residual in Lagrange Multipliers for Qaa Too Big')
        CALL Quit(_RC_EXIT_EXPECTED_)
      END IF

      CALL DGEMM_('n','t',    1,nSPair,nSPair,
     &            1.0d0,zXScr,1,AXX,nSPair,
     &            0.0d0,zx   ,1)

      CALL mma_deallocate(EigVal)
      CALL mma_deallocate(bxScr )
      CALL mma_deallocate(zXScr )
      CALL mma_deallocate(Scr   )
      RETURN
      END SUBROUTINE
******************************************************
******************************************************
      Subroutine GetQaaFock(FOccMO,P2MOt,GDMat,zX,nP2)
      use stdalloc, only : mma_allocate, mma_deallocate
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"
******Input
      Real*8,DIMENSION((nRoots-1)*nRoots/2)::zX
      Real*8,DIMENSION(nRoots*(nRoots+1)/2,nnA,nnA)::GDMat
      Real*8,DIMENSION(nP2)::P2MOt
******Output
      Real*8,DIMENSION(nDens2)::FOccMO
******For Debugging
      INTEGER NPUVX
      Real*8,DIMENSION(:),Allocatable::PUVX
      INTEGER,DIMENSION(ntAsh,ntAsh,ntAsh,ntAsh)::IndTUVX
      INTEGER,DIMENSION(ntBas,ntAsh,ntAsh,ntAsh)::IndPUVX
      Logical debug2
******Auxiliaries
      Real*8,DIMENSION(:),Allocatable::G1r,G2r,G2q,Fock,T,PQaa
      INTEGER K,L,nG2r,IKL,IKL2,IKK,ILL
************************************************************************
*                                                                      *
       itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
      ng1=itri(ntash,ntash)
      ng2=itri(ng1,ng1)

      nG1r=ntash**2
      nG2r=(nG1r+1)*nG1r/2
      CALL mma_allocate(Fock,nDens2)
      CALL mma_allocate(T,nDens2)
      CALL mma_allocate(G1r,nG1r)
      CALL mma_allocate(G2r,nG2r)
      CALL mma_allocate(G2q,ng2)
      CALL mma_allocate(PQaa,ng2)
      Debug2=.false.
      CALL FZero(PQaa,nP2)
      CALL FZero(G1r,nG1r)
      CALL FZero(G2r,nG2r)

******************

      IF(Debug2) THEN
      CALL Get_PUVXLen(NPUVX)
      CALL mma_allocate(PUVX,NPUVX)
      CALL Get_Two_Ind(IndPUVX,IndTUVX)
      END IF

      DO K=1,nRoots
       IKK=(K+1)*K/2
       Do L=1,K-1
        ILL=(L+1)*L/2
        IKL=(K-1)*K/2+L
        IKL2=(K-1)*(K-2)/2+L
        CALL QaaP2MO(G2q,ng2,GDMat,IKL,IKK,ILL)
        IF(Debug2) CALL QaaVerif(G2q,ng2,PUVX,NPUVX,IndTUVX)
        CALL G2qtoG2r(G2r,G2q,nG2,nG2r)
        Call daxpy_(ng2,zX(IKL2),G2q,1,PQaa,1)
       End Do
      END DO


      CALL Daxpy_(nG2,1.0d0,PQaa,1,P2MOt,1)
      CALL Put_P2MOt(P2MOt,nG2)

      CALL G2qtoG2r(G2r,PQaa,nG2,nG2r)
      CALL FockGen(0.0d0,G1r,G2r,T,Fock,1)
      Call DAxPy_(nDens2,1.0d0,T,1,FOccMO,1)
      IF(Debug2) Call mma_deallocate(PUVX)
      CALL mma_deallocate(Fock)
      CALL mma_deallocate(T)
      CALL mma_deallocate(G1r)
      CALL mma_deallocate(G2r)
      CALL mma_deallocate(G2q)
      CALL mma_deallocate(PQaa)
      RETURN
      End Subroutine
******************************************************

******************************************************
      Subroutine G2qtoG2r(G2r,G2q,nG2,nG2r)
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"
      INTEGER nG2,nG2r
      Real*8,DIMENSION(nG2 )::G2q
      Real*8,DIMENSION(nG2r)::G2r
      INTEGER iB,jB,iDij,iRij,iDkl,iRkl,iijkl,iRijkl
      Real*8 Fact
       itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      Do iB=1,ntash
       Do jB=1,ntash
        iDij=iTri(ib,jB)
        iRij=jb+(ib-1)*ntash
        Do kB=1,ntash
         Do lB=1,ntash
          iDkl=iTri(kB,lB)
          iRkl=lb+(kb-1)*ntash
          fact=One
          if(iDij.ge.iDkl .and. kB.eq.lB) fact=Two
          if(iDij.lt.iDkl .and. iB.eq.jB) fact=Two
          iijkl=itri(iDij,iDkl)
          iRijkl=itri(iRij,iRkl)
          G2r(iRijkl)=Fact*G2q(iijkl)
         End Do
        End Do
       End Do
      End Do
      RETURN
      End Subroutine
******************************************************

******************************************************
      Subroutine QaaVerif(G2q,ng2,PUVX,NPUVX,IndTUVX)
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"
      INTEGER nG2,nPUVX
      Real*8,DIMENSION(nG2)::G2q
      Real*8,DIMENSION(NPUVX)::PUVX
      INTEGER,DIMENSION(ntAsh,ntAsh,ntAsh,ntAsh)::IndTUVX
      INTEGER I,J,K,L,IJKL,lMax
      Real*8 dQdX

      ijkl=0
      dQdX=0.0d0
      do i=1,nna
        do j=1,i
          do k=1,i
            if(i.eq.k) then
              lmax = j
            else
              lmax = k
            end if
            do l=1,lmax
              ijkl = ijkl + 1
              dQdX=dQdX+G2q(ijkl)*PUVX(IndTUVX(I,J,K,L))
            end do
          end do
        end do
      end do

      write(6,*) 'dQdX in QaaVerif=',dQdX

      RETURN
      End Subroutine
******************************************************

******************************************************
      Subroutine QaaP2MO(G2q,ng2,GDMat,IKL,IKK,ILL)
      use stdalloc, only : mma_allocate, mma_deallocate
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"
******  Input
      INTEGER nG2,IKL,IKK,ILL
      Real*8,DIMENSION(nRoots*(nRoots+1)/2,nnA,nnA)::GDMat
******  Output
      Real*8,DIMENSION(nG2)::G2q
******  Auxiliaries
      INTEGER i,j,k,l,ij,kl,ijkl,nD
      Real*8 Fact
      Real*8,DIMENSION(:),Allocatable::Dsum,Ddif
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)

******* Calculating dQ_aa/dX_KL, original purpose of this subroutine
      nD=nnA*(nnA+1)/2
      CALL mma_allocate(Dsum,nD)
      CALL mma_allocate(Ddif,nD)
      DO i=1,nnA
       Do j=1,i
        ij=iTri(i,j)
        Dsum(ij)=GDMat(IKL,i,j)+GDMat(IKL,j,i)
        Ddif(ij)=GDMat(IKK,i,j)-GDMat(ILL,i,j)
       End Do
      END DO
       ijkl=0
       do i=1,nna
         do j=1,i
           ij = iTri(i,j)
           do k=1,i
             if(i.eq.k) then
               lmax = j
             else
               lmax = k
             end if
             do l=1,lmax
               kl = iTri(k,l)
               ijkl = ijkl + 1
               fact=0.5d0
               if(k.eq.l) fact=0.25d0
               G2q(ijkl)=
     & fact*(Dsum(ij)*Ddif(kl)+Dsum(kl)*Ddif(ij))*2.0d0
             end do
           end do
         end do
       end do
      CALL mma_deallocate(Dsum)
      CALL mma_deallocate(Ddif)
      RETURN
      End Subroutine

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Do_Lebedev(L_Eff,mPt,ipR)
************************************************************************
*                                                                      *
*     Computes datas useful for the angular quadrature.                *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "nq_info.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Parameter (nSet=11)
      Integer Lebedev_order(nSet), Lebedev_npoints(nSet)
      Data Lebedev_order/5,7,11,17,23,29,35,41,47,53,59/
      Data Lebedev_npoints/14,26,50,110,194,302,434,590,770,974,1202/
*                                                                      *
************************************************************************
*                                                                      *
*---- Generate angular grid a la Lebedev
*
      Do iSet = 1, nSet
         If (Lebedev_order(iSet).eq.L_Eff) Then
            mPt=Lebedev_npoints(iSet)
            Call GetMem('AngRW','Allo','Real',ipR,4*mPt)
            Call GetMem('temp','Allo','Real',iptemp,4*mPt)
*
            iOffR=iptemp
            iOffW=iOffR+3*mPt
            Call Lebedev(Work(iOffR),Work(iOffW),nPt,mPt,L_Eff)
            If (nPt.ne.mPt) Then
               Call WarningMessage(2,'Lebedev_Grid: nPt.ne.mPt')
               Write (6,*) 'nPt=',nPt
               Write (6,*) 'mPt=',mPt
               Call Abend()
            End If
            Call DScal_(nPt,Four*Pi,Work(iOffW),1)
*
            Call DGEMM_('N','N',
     &                  3,nPt,3,
     &                  1.0d0,Work(ip_O),3,
     &                  Work(iOffR),3,
     &                  0.0d0,Work(ipR),4)
            call dcopy_(nPt,Work(iOffW  ),1,Work(ipR+3),4)
*
            Call GetMem('temp','Free','Real',iptemp,4*nPt)
*
            Go To 99
*
         End If
      End Do
      Write (6,'(A,I3)') 'Failed to find a Lebedev grid of order', L_EFF
      Write (6,'(A)') 'Available orders are:'
      Write (6,'(11(1X,I3))') (Lebedev_order(i),i=1,nSet)
      Call Abend()
*                                                                      *
************************************************************************
*                                                                      *
 99   Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      Subroutine Precabi(ib,is,js,ir,nd,rOut,nba,
     &                   focki,focka,fock,sign,
     &                   A_J,A_K,Scr,nScr)
************************************************************************
*                                          [2]                         *
*     Calculates the diagonal submatrix of E    that couple            *
*                                                                      *
*     kappa           with   kappa                for a                *
*          kactive,virtual        kactive,inactive                     *
*                                                                      *
*     single active index.                                             *
*     Used for preconditioner.                                         *
*                                                                      *
*     See Olsen,Yeager, Joergensen:                                    *
*      "Optimization and characterization of an MCSCF state"           *
*                                                                      *
*     Called by prec                                                   *
*                                                                      *
*     ib,is         :        active index for the submatrix            *
*     js           :        symmetry of inact,virtual                  *
*     rOut          :         Submatrix                                *
*                                                                      *
************************************************************************
      use Arrays, only: G1t, G2t
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
      Real*8 Fock(nba,nba),Focki(nba,nba),FockA(nba,nba),rOut(*),
     &       A_J(nScr),A_K(nScr),Scr(nScr)
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      iTri1(i,j)=nTri-itri(nd-Min(i,j)+1,nd-Min(i,j)+1)
     &          +Max(i,j)-Min(i,j)+1
*                                                                      *
************************************************************************
*                                                                      *
      nTri=itri(nd,nd)
*
      jVert=nOrb(js)-nIsh(js)-nAsh(js)
      If (jVert.eq.0) Return
*
      nO=nAsh(js)+nIsh(js)
      iAA=nA(is)+ib
      itAA=itri(iAA,iAA)
*                                                                      *
************************************************************************
*                                                                      *
      Do kS=1,nSym
         Do kA=1,nAsh(kS)
            kAA=kA+nA(ks)
            kkA=kA+nIsh(ks)
            Do lA=1,nAsh(kS)
               lAA=lA+nA(ks)
               llA=lA+nIsh(ks)
*
               Call Coul(jS,jS,kS,kS,kkA,llA,A_J,Scr)
               Call Exch(jS,kS,jS,kS,kkA,llA,A_K,Scr)
*
               Do jB=1,nIsh(jS)
                  ip=itri1(jB,nd-jVert+1)
*
                  Fact1=-2.0d0*G2t(itri(itAA,itri(kAA,lAA)))
                  Fact2=-4.0d0*
     &                 G2t(itri(itri(iAA,kAA),itri(iAA,lAA)))
*
                  If (kaa.eq.iaa)
     &               Fact2=Fact2+8.0d0*G1t(itri(iAA,lAA))
                  If (laa.eq.iaa)
     &               Fact1=Fact1-2.0d0*G1t(itri(iAA,kAA))
                  If (laa.eq.iaa)
     &               Fact2=Fact2-2.0d0*G1t(itri(iAA,kAA))
*
                  ivj=(jB-1)*nBas(jS)+no+1
                  Call DaXpY_(jVert,Sign*Fact1,
     &                       A_J(ivj),1,
     &                       rout(ip),1) ! ????
                  Call DaXpY_(jVert,Sign*Fact2,
     &                       A_K(ivj),1,
     &                       rout(ip),1)
*
               End Do
*
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Do jB=1,nIsh(jS)
         ip=itri1(jB,nd-jVert+1)
         Fact=(2.0d0-2.0d0*G1t(itAA))
         Call DaxPy_(jVert,Sign*Fact,FockI(nO+1,jB),1,rOut(ip),1)
         Fact=2.0d0
         Call DaxPy_(jVert,Sign*Fact,FockA(nO+1,jB),1,rOut(ip),1)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(ir)
        Call Unused_real_array(fock)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_ZMem(irc,l_Z,NVT,l_NVT,DoPrint,DoCheck)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: compute dimension of Z vector array and print it to
C              output (if requested through DoPrint). Check if there
C              is sufficient memory at this point (if DoCheck).
C
C     Return codes:
C
C     irc=-1 : Input error (debug only)
C     irc=0  : All ok
C     irc=1  : Negative length of Z vector array (could be integer
C              overflow)
C     irc=999: Insufficient memory for Z vectors (only if DoCheck)
C
      Implicit None
      Integer irc
      Integer l_Z
      Integer l_NVT
      Integer NVT(l_NVT)
      Logical DoPrint, DoCheck
#include "cholesky.fh"

#if !defined (_I8_) || defined (_DEBUGPRINT_)
      Character*8 SecNam
      Parameter (SecNam='Cho_ZMem')
#endif
      Character*2 Unt
      Integer iSym, ip_Mx, l_Mx
      Real*8 Byte, xl_Z
      Real*8 Word(8)

#if defined (_DEBUGPRINT_)
      If (l_NVT .lt. nSym) Then
         irc=-1
         l_Z=-999999
         Return
      End If
#endif

      irc=0

      xl_Z=0.0d0
      Do iSym=1,nSym
         Word(iSym)=DBLE(NVT(iSym))*(DBLE(NVT(iSym))+1.0d0)/2.0d0
         xl_Z=xl_Z+Word(iSym)
      End Do
      l_Z=INT(xl_Z)

      If (DoPrint) Then
         Call Cho_Head('Z Vector Storage Requirements','-',80,LuPri)
         Write(LuPri,*)
         Do iSym=1,nSym
            Call Cho_RWord2Byte(Word(iSym),Byte,Unt)
            Write(LuPri,'(A,I2,A,I8,A,F8.3,1X,A,A)')
     &      'Symmetry',iSym,':   ',INT(Word(iSym)),' words (',
     &      Byte,Unt,')'
         End Do
         Write(LuPri,'(A)')
     &   '------------------------------------------'
         Call Cho_RWord2Byte(xl_Z,Byte,Unt)
         Write(LuPri,'(A,I8,A,F8.3,1X,A,A)')
     &   'Total:        ',l_Z,' words (',Byte,Unt,')'
      End If

#if !defined (_I8_) || defined (_DEBUGPRINT_)
      If (l_Z .lt. 0) Then
         Write(Lupri,'(A,A)')
     &   SecNam,': dimension of Z vector array is negative!'
         Write(Lupri,'(A,I8)') 'l_Z=',l_Z
         If (xl_Z .gt. 0.0d0) Then
            Write(LuPri,'(A)') 'This seems to be an integer overflow!'
            Call Cho_RWord2Byte(xl_Z,Byte,Unt)
            Write(LuPri,'(A,1P,D15.6,A,D15.6,1X,A,A)')
     &      'In double precision, xl_Z=',xl_Z,
     &      ' words (',Byte,Unt,')'
         End If
         irc=1
         Return
      End If
#endif

      If (DoCheck) Then
         Call GetMem('ChkZ','Max ','Real',ip_Mx,l_Mx)
         If (l_Z.gt.l_Mx) Then
            irc=999
            Return
         End If
      End If

      End
      SubRoutine Cho_RWord2Byte(Word,Byte,Unt)
      Implicit None
      Real*8  Word
      Real*8  Byte
      Character*2 Unt

      Byte = Word*8.0d0
      Unt  = 'b '
      If (ABS(Byte) .gt. 1.0d3) Then
         Byte = Byte/1.024d3
         Unt  = 'kb'
         If (ABS(Byte) .gt. 1.0d3) Then
            Byte = Byte/1.024d3
            Unt  = 'Mb'
            If (ABS(Byte) .gt. 1.0d3) Then
               Byte = Byte/1.024d3
               Unt  = 'Gb'
               If (ABS(Byte) .gt. 1.0d3) Then
                  Byte = Byte/1.024d3
                  Unt  = 'Tb'
               End If
            End If
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grow_t2_fblocked1(t2,tmp,dima,dimb,no,lasta,lastb,length1,length2)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, no, lasta, lastb, length1, length2
real(kind=wp), intent(inout) :: t2(length1,length2,no,no)
real(kind=wp), intent(in) :: tmp(dima,dimb,no,no)
integer(kind=iwp) :: b, i, j

!mp write(u6,*) 'lasta+dima, length1 ',lasta+dima,length1
!mp write(u6,*) 'lastb+dimb, length2 ',lastb+dimb,length2

!mp write(u6,'(A,2(i10,x),i3)') 'length1, length2, no ',length1,length2,no
!mp write(u6,'(A,4(i3,x))') 'dima, dimb, lasta, lastb',dima,dimb,lasta,lastb

!mp ij = 0
!mp do i=2,no
!mp   do j=1,i-1
!mp     ij = ij+1
do i=1,no
  do j=1,no
    do b=1,dimb

      !mp t2(lasta+1:lasta+dima,lastb+b,ij) = tmp(:,b,i,j)-tmp(:,b,j,i)
      t2(lasta+1:lasta+dima,lastb+b,i,j) = tmp(:,b,i,j)

    end do
  end do
end do

return

end subroutine grow_t2_fblocked1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************
!#define _DEBUGPRINT_

Module Phase_Info
Implicit None
Integer ::iPhase(3,0:7)=Reshape ([ 1, 1, 1,-1, 1, 1, 1,-1, &
                                   1,-1,-1, 1, 1, 1,-1,-1, &
                                   1,-1, 1,-1,-1,-1,-1,-1], [3,8])
End Module Phase_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine OvrMmH(nHer,MmOvrH,la,lb,lr)
*
      nHer=(la+lb+1+4)/2
      MmOvrH = 3*nHer*(la+3) +
     &        3*nHer*(lb+3) +
     &        3*nHer +
     &        3*(la+3)*(lb+3) + 2
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lr)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine QMPosition(EHam,Cordst,Coord,Forcek,dLJrep,Ract,iQ_Atoms)

use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: EHam
integer(kind=iwp), intent(in) :: iQ_Atoms
real(kind=wp), intent(in) :: Cordst(3,iQ_Atoms), Coord(3), Forcek, dLJrep, Ract
integer(kind=iwp) :: iAt
real(kind=wp) :: dDepart, Diff, R

! First the harmonic potential that keeps QM close to centre.

dDepart = (Cordst(1,1)-Coord(1))**2+(Cordst(2,1)-Coord(2))**2+(Cordst(3,1)-Coord(3))**2
EHam = Forcek*Half*dDepart

! Second the repulsion with boundary that keeps QM away from boundary.

do iAt=1,iQ_Atoms
  R = Cordst(1,iAt)**2+Cordst(2,iAt)**2+Cordst(3,iAt)**2
  R = sqrt(R)
  Diff = Ract-R
  EHam = EHam+(dLJRep/Diff)**12
end do

return

end subroutine QMPosition

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000-2016, Valera Veryazov                             *
************************************************************************
******************************************************************************
*                                                                            *
* Author:   Valera Veryazov 2000-2016                                        *
*           Theoretical Chemistry                                            *
*           Lund University                                                  *
*           Sweden                                                           *
*                                                                            *
******************************************************************************

      Subroutine HBomb(x,ia,ib)
      Real*8 x
      Dimension x(*)
c  Generate some exception...
      x(ia*ib)=1.0
      x(ia*(-ib))=1.0
      x(1)=7.0/Dble(ia+ib)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_SetShP2RS_2(irc,iLoc,iShlAB,nAB)
!
! Purpose: set mapping from shell pair iShlAB to reduced shell pair
!          Based on reduced set stored at location iLoc = 2 or 3.
!          If a non-zero code (irc) is returned, nothing has been
!          set!!

use Index_Functions, only: nTri_Elem
use Cholesky, only: iiBstR, iiBstRSh, IndRed, iOff_Batch, iShP2RS, iSP2F, MySP, nBstSh, nnBstRSh, nSym
#ifdef _DEBUGPRINT_
use Cholesky, only: IndRSh, LuPri
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iLoc, iShlAB, nAB(*)
integer(kind=iwp) :: iAB, iAB1, iAB2, iShlA, iShlB, iSym, jAB, kAB, l_iShP2RS, lTst, NumAB
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: nErr
character(len=*), parameter :: SecNam = 'Cho_SetShP2RS_2'
#endif

! Check allocations.
! ------------------

call Cho_InvPck(iSP2F(mySP(iShlAB)),iShlA,iShlB,.true.)
if (iShlA == iShlB) then
  NumAB = nTri_Elem(nBstSh(iShlA))
else
  NumAB = nBstSh(iShlA)*nBstSh(iShlB)
end if
lTst = 2*NumAB
l_iShP2RS = 0
if (allocated(iShP2RS)) l_iShP2RS = size(iShP2RS)
if ((l_iShP2RS < 1) .or. (l_iShP2RS < lTst)) then
  irc = 102
  return
end if

! Check iLoc.
! -----------

if ((iLoc < 2) .or. (iLoc > 3)) then
  irc = 104
  return
end if

! Set mapping array.
! iShP2RS(1,AB) = index in current reduced set, symmetry reduced.
! iShP2RS(2,AB) = symmetry block.
! Zeros are returned if the element AB is not a member of the
! current reduced set.
! ---------------------------------------------------------------

iShP2RS(:,1:NumAB) = 0

do iSym=1,nSym
  if (nAB(iSym) > 0) then
    iAB1 = iiBstRSh(iSym,iShlAB,iLoc)+1
    iAB2 = iAB1+nnBstRSh(iSym,iShlAB,iLoc)-1
    do iAB=iAB1,iAB2
      jAB = IndRed(iiBstR(iSym,iLoc)+iAB,iLoc) ! addr in 1st rs
      kAB = IndRed(jAB,1) ! addr in full shell pair
#     ifdef _DEBUGPRINT_
      nErr = 0
      if (IndRSh(jAB) /= iSP2F(mySP(iShlAB))) then
        write(LuPri,*) SecNam,': inconsistent shell pairs!'
        write(LuPri,*) SecNam,': from input: ',iSP2F(mySP(iShlAB)),'  from IndRsh: ',IndRSh(jAB)
        nErr = nErr+1
      end if
      if ((kAB < 1) .or. (kAB > NumAB)) then
        write(LuPri,*) SecNam,': shell pair address error!'
        write(LuPri,*) SecNam,': kAB = ',kAB
        write(LuPri,*) SecNam,': min and max allowed: 1 ',NumAB
        nErr = nErr+1
      end if
      if (nErr /= 0) then
        write(LuPri,*) SecNam,': Shell A, B, AB: ',iShlA,iShlB,iShlAB
        write(LuPri,*) SecNam,': iLoc: ',iLoc
        write(LuPri,*) SecNam,': symmetry block: ',iSym
        write(LuPri,*) SecNam,': red. set address, first and current: ',jAB,iiBstR(iSym,iLoc)+iAB
        call Cho_Quit('Error detected in '//SecNam,104)
      end if
#     endif
      iShP2RS(1,kAB) = iOff_Batch(iSym,iShlAB)+iAB-iAB1+1
      iShP2RS(2,kAB) = iSym
    end do
  end if
end do

! Set return code 0: all ok!
! --------------------------

irc = 0

end subroutine Cho_SetShP2RS_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine MinDns(Dens,mBT,NumD,XCff,ltXCff,nD)
************************************************************************
*                                                                      *
*     purpose: Compute minimized density difference                    *
*                                                                      *
*     input:                                                           *
*       Dens    : a few last density matrix differences (mBT,NumD)     *
*                                                                      *
*     output:                                                          *
*       XCff    : coefficients (ltXCff==iDMin)                         *
*                                                                      *
*     called from: DMat, OptClc                                        *
*                                                                      *
*     calls to: RWDTG, Gauss                                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Integer ltXCff
*
      Real*8, Target:: Dens(mBT,nD,NumD)
      Real*8 XCff(ltXCff,nD)
*
*---- Define local variables
      Real*8 BVec(MxIter,2)
      Real*8, Dimension(:,:,:), Allocatable :: AMat
      Real*8, Dimension(:,:), Allocatable, Target:: DRow, DCol
      Real*8, Dimension(:,:), Pointer:: pDR, pDC
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*
      Call mma_allocate(DRow,nBT,nD,Label='DRow')
      Call mma_allocate(DCol,nBT,nD,Label='DCol')
      Call mma_allocate(AMat,MxIter,MxIter,2,label='AMat')
      Call FZero(XCff,ltXCff*nD)
      Call FZero(AMat,2*MxIter**2)
      Call FZero(BVec,2*MxIter   )
*
      iter_d=iter-iter0
*
*     Allow a maximum of 10 densities in the minimization process to
*     improve the numerical accuracy. This will also reduce the I/O.
*
*     iStart = iter_d - iDMin
      iStart = Max(1,iter_d - 9)
#ifdef _DEBUGPRINT_
      Write (6,*) 'iter_d,iStart=',iter_d,iStart
#endif
*
      jRow=0
      Do iRow = iStart, iter_d - 1
         jRow = jRow + 1
*
         iR = MapDns(iRow)
         If (iR.lt.0) Then
            Call RWDTG(-iR,DRow,nBT*nD,'R','DENS  ',iDisk,MxDDsk)
            pDR => DRow
         Else
            pDR => Dens(1:mBT,1:nD,iR)
         End If
*
#ifdef _DEBUGPRINT_
         Call NrmClc(pDR,nBT*nD,'MinDns','pDR')
#endif
         Do iD = 1, nD
            AMat(jRow,jRow,iD) = DDot_(nBT,pDR(:,iD),1,pDR(:,iD),1)
            BVec(jRow,iD) = DDot_(nBT,pDR(:,iD),1,Dens(1,iD,iPsLst),1)
         End Do ! iD
*
         jCol = 0
         Do iCol = iStart, iRow - 1
            jCol = jCol + 1
*
            iC = MapDns(iCol)
            If (iC.lt.0) Then
               Call RWDTG(-iC,DCol,nBT*nD,'R','DENS  ',iDisk,MxDDsk)
               pDC => DCol
            Else
               pDC => Dens(1:mBT,1:nD,iC)
            End If
*
            Do iD = 1, nD
               AMat(jRow,jCol,iD) = DDot_(nBT,pDR(:,iD),1,pDC(:,iD),1)
               AMat(jCol,jRow,iD) = AMat(jRow,jCol,iD)
            End Do ! iD
*
            Nullify(pDC)
*
         End Do ! iCol
         Nullify(pDR)
      End Do ! iRow
*
      Do iD = 1, nD
*
*----    Remove linear dependences from A-matrix
         Call RmLDep(AMat(1,1,iD),MxIter,iter_d-iStart)
*
*----    Get minimization coefficients
         Call DGEMM_('N','N',
     &               iter_d-iStart,1,iter_d-iStart,
     &               1.0d0,AMat(1,1,iD),MxIter,
     &                     BVec(1,iD),iter_d-iStart,
     &               0.0d0,XCff(iStart,iD),iter_d-iStart)
#ifdef _DEBUGPRINT_
         Write(6,*)' Coefficients minimizing density difference:'
         Write(6,'(5f16.8)')(XCff(i,iD),i=1,iter_d-1)
         Write(6,*)
#endif
*
      End Do ! iD
*
*---- Construct minimized density
      Do iMat = iter_d - 1, iStart, -1
*
         iM = MapDns(iMat)
         If (iM.lt.0) Then
            Call RWDTG(-iM,DRow,nBT*nD,'R','DENS  ',iDisk,MxDDsk)
            pDR => DRow
         Else
            pDR => Dens(1:mBT,1:nD,iM)
         End If

         Do iD = 1, nD
            XC = - XCff(iMat,iD)
            call daxpy_(nBT,XC,pDR(:,iD),1,Dens(1,iD,iPsLst),1)
         End Do ! iD
*
      End Do ! iMat
*
      Call mma_deallocate(AMat)
      Call mma_deallocate(DCol)
      Call mma_deallocate(DRow)

      end subroutine MinDns


      SubRoutine RmLDep(AMat,lDm,lth)
************************************************************************
*                                                                      *
*     purpose: Remove linear dependencies                              *
*                                                                      *
*     input:                                                           *
*       AMat    : matrix with linear dependencies (lDm,lDm)            *
*                                                                      *
*     output:                                                          *
*       AMat    : inverted matrix without linear dependencies (lDm,lDm)*
*                                                                      *
*     called from: MinDns                                              *
*                                                                      *
*     calls to:                                                        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 AMat(lDm,lDm)
*
*     Local variables
*
      Real*8, Dimension(:), Allocatable:: ATri, EVec, EVal, Scr
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*
      lthT = lth*(lth + 1)/2
      lthS = lth*lth
      Call mma_allocate(ATri,lthT,Label='ATri')
      Call mma_allocate(EVec,lthS,Label='EVec')
      Call mma_allocate(EVal,lth ,Label='EVal')
*
*---- Put a unit matrix into the eigenvectors work space
      call dcopy_(lthS,[Zero],0,EVec,      1)
      call dcopy_(lth, [One], 0,EVec,lth + 1)
*
*---- Copy trialangular part of AMat to work space
      ij = 1
      Do i = 1, lth
         call dcopy_(i,AMat(i,1),lDm,ATri(ij),1)
         ij = ij + i
      End Do
#ifdef _DEBUGPRINT_
      Write(6,*)' Squared A-matrix in RmLDep:'
      Do i = 1, lth
         Write(6,'(5(2x,e12.6))')(AMat(i,j),j=1,lth)
      End Do
      Write(6,*)' Triangular A-matrix:'
      Write(6,'(5(2x,e12.6))')(ATri(i),i=1,lthT)
#endif
*
*---- Diagonalize
      Call mma_allocate(Scr,lth**2,Label='Scr')
      Dummy=0.0D0
      iDum=0
      Call Diag_Driver('V','A','L',lth,ATri,Scr,lth,
     &                 Dummy,Dummy,iDum,iDum,EVal,EVec,
     &                 lth,1,0,'J',nFound,iErr)
      Call mma_deallocate(Scr)
#ifdef _DEBUGPRINT_
      Write(6,*)' Eigenvalues of A-matrix in RLnDep:'
      Write(6,'(5(2x,e12.6))')(EVal(i),i=1,lth)
#endif
*
*---- Form the inverse
      Call dCopy_(lDm*lth,[Zero],0,AMat,1)
      Do i = 1, lth
         If (EVal(i).gt.1.0d-12) Then
            AMat(i,i) = 1.0d+00/EVal(i)
         Else
*           Write(*,*)' Eigenvalue',i,' smaller then 1.0e-12'
            AMat(i,i) = Zero
         End If
      End Do
      Call mma_allocate(Scr,lthS,Label='Scr')
      Call DGEMM_('N','T',
     &            lth,lth,lth,
     &            1.0d0,AMat,lDm,
     &                  EVec,lth,
     &            0.0d0,Scr,lth)
      Call DGEMM_('N','N',
     &            lth,lth,lth,
     &            1.0d0,EVec,lth,
     &                  Scr,lth,
     &            0.0d0,AMat,lDm)
      Call mma_deallocate(Scr)
*
      Call mma_deallocate(EVal)
      Call mma_deallocate(EVec)
      Call mma_deallocate(ATri)
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine hroot(x,nn,dpn,pn1,eps)
c                  improves the approximate root  x
c                in addition we also obtain
c                    dpn = derivative of h(n) at x
c                    pn1 = value of h(n-1) at x
c
      implicit real*8 (a-h,o-z)
c
c     # iter = 5 sufficient for 8-byte accuracy up to nn = 7
      do 14 iter=1,10
        call hrecur(p,dp,pn1,x,nn)
        d  = p/dp
        x  = x - d
        if( abs(d).le.eps ) go to 16
   14 continue
   16 dpn = dp
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine JACOB(ARRAY,VECS,NDIM,LENVEC)
!subroutine JACOBI(ARRAY,VECS,NDIM,LENVEC)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One, Two, Four, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NDIM, LENVEC
real(kind=wp), intent(inout) :: ARRAY(*), VECS(LENVEC,*)
integer(kind=iwp) :: I, Ierr, II, J, JJ, k, k0, k1, k2, k3, kk, kleft, kmax, kmin, NDTRI, NR, NROT, NSUBD, NSWEEP
real(kind=wp) :: AAIJ, Aii0, Aii1, Aii2, Aii3, Ajj0, Ajj1, Ajj2, Ajj3, Ak0i, Ak0j, Ak1i, Ak1j, Ak2i, Ak2j, Ak3i, Ak3j, ARII, ARIJ, &
                 ARJJ, C0i, C0j, C1i, C1j, C2i, C2j, C3i, C3j, CS, CS2, DIFF, DUM, SBDMAX, SGN, SHIFT, SN, SN2, SUBDAC, Temp, TN, &
                 VNSUM
logical(kind=iwp) :: IFTEST
real(kind=wp), parameter :: EPS = 1.0e-16_wp, EPS2 = 1.0e-30_wp

IfTest = .false.
#ifdef _DEBUGPRINT_
IfTest = .true.
#endif

if (NDIM <= 1) return
! A shift is applied. Use a representative diagonal value:
NDTRI = nTri_Elem(NDIM)
SHIFT = Half*(ARRAY(1)+ARRAY(NDTRI))
!SHIFT = real(nint(SHIFT),kind=wp) Why?
II = 0
do I=1,NDIM
  II = II+I
  ARRAY(II) = ARRAY(II)-SHIFT
end do

! Sanity test:
call CHK4NAN(NDTRI,Array,Ierr)
if (IERR /= 0) call ABEND()

if (IFTEST) then
  write(u6,*) ' JACOBI test prints:'
  write(u6,*) ' NSWEEP = Nr of sweeps'
  write(u6,*) ' NR     = Rotations this sweep'
  write(u6,*) ' NROT   = Nr of 2-rotations (Accum)'
  write(u6,*) ' VNSUM  = von Neumann''s sum'
  write(u6,*) ' SBDMAX = Largest subdiag element in this sweep.'
  write(u6,*) '   NSWEEP   NR     NROT       VNSUM               SBDMAX'

  SBDMAX = Zero
  VNSUM = Zero
  do I=2,NDIM
    II = nTri_Elem(I-1)
    do J=1,I-1
      ARIJ = ARRAY(II+J)
      VNSUM = VNSUM+ARIJ**2
      SBDMAX = max(SBDMAX,abs(ARIJ))
    end do
  end do
  write(u6,'(A,2G20.12)') ' Initial values:        ',VNSUM,SBDMAX
end if

! NSWEEP counts number of sweeps over subdiagonal elements.
NSWEEP = 0
! NROT counts total number of 2x2 rotations
NROT = 0

! Head of loop over sweeps
do
  NSWEEP = NSWEEP+1
  ! NR: Nr of 2x2 rotations in this sweep
  NR = 0

  SUBDAC = Zero
  NSUBD = 0
  do I=2,NDIM
    II = nTri_Elem(I-1)
    do J=1,I-1
      !TEST do IMJ=1,NDIM-1
      !TEST   do I=IMJ+1,NDIM
      !TEST     II = nTri_Elem(I-1)
      !TEST     J = I-IMJ
      JJ = nTri_Elem(J-1)
      ARIJ = ARRAY(II+J)
      AAIJ = abs(ARIJ)
      ARII = ARRAY(II+I)
      ARJJ = ARRAY(JJ+J)
      DIFF = ARII-ARJJ
      SGN = One
      if (DIFF < Zero) then
        DIFF = -DIFF
        SGN = -SGN
      end if
      SUBDAC = SUBDAC+AAIJ
      NSUBD = NSUBD+1
      ! Decide if we should rotate: SUBDAC is accumulated sum of abs of subdiag
      ! values. Therefore, we are certain that they are distributed around the
      ! value SUBDAC/NSUBD. Skip rotations that are too small compared to average:
      if (real(NSUBD,kind=wp)*AAIJ <= Half*SUBDAC) cycle
      ! Or, if the resulting rotation would be insignificant compared to DIFF:
      if (AAIJ <= EPS*DIFF) cycle
      ! Or, if the resulting rotation would be insignificant in absolute size:
      if (AAIJ <= EPS2) cycle
      ! Determine size of 2x2 rotation:
      NR = NR+1
      DUM = DIFF+sqrt(DIFF**2+Four*AAIJ**2)
      TN = Two*SGN*ARIJ/DUM
      CS = One/sqrt(One+TN**2)
      SN = CS*TN
      ! TN,CS,SN=TAN,COS AND SIN OF ROTATION ANGLE.
      ! The following partially unrolled loops are written by Markus Fuelscher
      kmin = 1
      kmax = j-1
      kleft = mod(kmax-kmin+1,4)
      if (kleft == 1) then
        Aii1 = ARRAY(ii+1)
        Ajj1 = ARRAY(jj+1)
        ARRAY(ii+1) = SN*Ajj1+CS*Aii1
        ARRAY(jj+1) = CS*Ajj1-SN*Aii1
      else if (kleft == 2) then
        Ajj1 = ARRAY(jj+1)
        Ajj2 = ARRAY(jj+2)
        Aii1 = ARRAY(ii+1)
        Aii2 = ARRAY(ii+2)
        ARRAY(ii+1) = SN*Ajj1+CS*Aii1
        ARRAY(ii+2) = SN*Ajj2+CS*Aii2
        ARRAY(jj+1) = CS*Ajj1-SN*Aii1
        ARRAY(jj+2) = CS*Ajj2-SN*Aii2
      else if (kleft == 3) then
        Ajj1 = ARRAY(jj+1)
        Ajj2 = ARRAY(jj+2)
        Ajj3 = ARRAY(jj+3)
        Aii1 = ARRAY(ii+1)
        Aii2 = ARRAY(ii+2)
        Aii3 = ARRAY(ii+3)
        ARRAY(ii+1) = SN*Ajj1+CS*Aii1
        ARRAY(ii+2) = SN*Ajj2+CS*Aii2
        ARRAY(ii+3) = SN*Ajj3+CS*Aii3
        ARRAY(jj+1) = CS*Ajj1-SN*Aii1
        ARRAY(jj+2) = CS*Ajj2-SN*Aii2
        ARRAY(jj+3) = CS*Ajj3-SN*Aii3
      end if
      kmin = kmin+kleft
      do k=kmin,kmax,4
        Ajj0 = ARRAY(jj+k+0)
        Ajj1 = ARRAY(jj+k+1)
        Ajj2 = ARRAY(jj+k+2)
        Ajj3 = ARRAY(jj+k+3)
        Aii0 = ARRAY(ii+k+0)
        Aii1 = ARRAY(ii+k+1)
        Aii2 = ARRAY(ii+k+2)
        Aii3 = ARRAY(ii+k+3)
        ARRAY(ii+k+0) = SN*Ajj0+CS*Aii0
        ARRAY(ii+k+1) = SN*Ajj1+CS*Aii1
        ARRAY(ii+k+2) = SN*Ajj2+CS*Aii2
        ARRAY(ii+k+3) = SN*Ajj3+CS*Aii3
        ARRAY(jj+k+0) = CS*Ajj0-SN*Aii0
        ARRAY(jj+k+1) = CS*Ajj1-SN*Aii1
        ARRAY(jj+k+2) = CS*Ajj2-SN*Aii2
        ARRAY(jj+k+3) = CS*Ajj3-SN*Aii3
      end do
      kmin = j+1
      kmax = i-1
      kleft = mod(kmax-kmin+1,4)
      kk = jj+j
      if (kleft == 1) then
        k0 = kk
        Ak0j = ARRAY(k0+j)
        Aii0 = ARRAY(ii+kmin+0)
        ARRAY(ii+kmin+0) = SN*Ak0j+CS*Aii0
        ARRAY(kk+j) = CS*Ak0j-SN*Aii0
        kk = k0+kmin
      else if (kleft == 2) then
        k0 = kk
        k1 = k0+kmin
        Ak0j = ARRAY(k0+j)
        Ak1j = ARRAY(k1+j)
        Aii0 = ARRAY(ii+kmin+0)
        Aii1 = ARRAY(ii+kmin+1)
        ARRAY(k0+j) = CS*Ak0j-SN*Aii0
        ARRAY(k1+j) = CS*Ak1j-SN*Aii1
        ARRAY(ii+kmin+0) = SN*Ak0j+CS*Aii0
        ARRAY(ii+kmin+1) = SN*Ak1j+CS*Aii1
        kk = k1+kmin+1
      else if (kleft == 3) then
        k0 = kk
        k1 = k0+kmin
        k2 = k1+kmin+1
        Ak0j = ARRAY(k0+j)
        Ak1j = ARRAY(k1+j)
        Ak2j = ARRAY(k2+j)
        Aii0 = ARRAY(ii+kmin+0)
        Aii1 = ARRAY(ii+kmin+1)
        Aii2 = ARRAY(ii+kmin+2)
        ARRAY(k0+j) = CS*Ak0j-SN*Aii0
        ARRAY(k1+j) = CS*Ak1j-SN*Aii1
        ARRAY(k2+j) = CS*Ak2j-SN*Aii2
        ARRAY(ii+kmin+0) = SN*Ak0j+CS*Aii0
        ARRAY(ii+kmin+1) = SN*Ak1j+CS*Aii1
        ARRAY(ii+kmin+2) = SN*Ak2j+CS*Aii2
        kk = k2+kmin+2
      end if
      kmin = kmin+kleft
      do k=kmin,kmax,4
        k0 = kk
        k1 = k0+k
        k2 = k1+k+1
        k3 = k2+k+2
        Ak0j = ARRAY(k0+j)
        Ak1j = ARRAY(k1+j)
        Ak2j = ARRAY(k2+j)
        Ak3j = ARRAY(k3+j)
        Aii0 = ARRAY(ii+k+0)
        Aii1 = ARRAY(ii+k+1)
        Aii2 = ARRAY(ii+k+2)
        Aii3 = ARRAY(ii+k+3)
        ARRAY(k0+j) = CS*Ak0j-SN*Aii0
        ARRAY(k1+j) = CS*Ak1j-SN*Aii1
        ARRAY(k2+j) = CS*Ak2j-SN*Aii2
        ARRAY(k3+j) = CS*Ak3j-SN*Aii3
        ARRAY(ii+k+0) = SN*Ak0j+CS*Aii0
        ARRAY(ii+k+1) = SN*Ak1j+CS*Aii1
        ARRAY(ii+k+2) = SN*Ak2j+CS*Aii2
        ARRAY(ii+k+3) = SN*Ak3j+CS*Aii3
        kk = k3+k+3
      end do
      kmin = i+1
      kmax = NDIM
      kleft = mod(kmax-kmin+1,4)
      kk = ii+i
      if (kleft == 1) then
        k0 = kk
        Ak0j = ARRAY(k0+j)
        Ak0i = ARRAY(k0+i)
        ARRAY(k0+j) = CS*Ak0j-SN*Ak0i
        ARRAY(k0+i) = SN*Ak0j+CS*Ak0i
        kk = k0+kmin
      else if (kleft == 2) then
        k0 = kk
        k1 = k0+kmin
        Ak0j = ARRAY(k0+j)
        Ak0i = ARRAY(k0+i)
        Ak1j = ARRAY(k1+j)
        Ak1i = ARRAY(k1+i)
        ARRAY(k0+j) = CS*Ak0j-SN*Ak0i
        ARRAY(k0+i) = SN*Ak0j+CS*Ak0i
        ARRAY(k1+j) = CS*Ak1j-SN*Ak1i
        ARRAY(k1+i) = SN*Ak1j+CS*Ak1i
        kk = k1+kmin+1
      else if (kleft == 3) then
        k0 = kk
        k1 = k0+kmin
        k2 = k1+kmin+1
        Ak0j = ARRAY(k0+j)
        Ak0i = ARRAY(k0+i)
        Ak1j = ARRAY(k1+j)
        Ak1i = ARRAY(k1+i)
        Ak2j = ARRAY(k2+j)
        Ak2i = ARRAY(k2+i)
        ARRAY(k0+j) = CS*Ak0j-SN*Ak0i
        ARRAY(k0+i) = SN*Ak0j+CS*Ak0i
        ARRAY(k1+j) = CS*Ak1j-SN*Ak1i
        ARRAY(k1+i) = SN*Ak1j+CS*Ak1i
        ARRAY(k2+j) = CS*Ak2j-SN*Ak2i
        ARRAY(k2+i) = SN*Ak2j+CS*Ak2i
        kk = k2+kmin+2
      end if
      kmin = kmin+kleft
      do k=kmin,kmax,4
        k0 = kk
        k1 = k0+k
        k2 = k1+k+1
        k3 = k2+k+2
        Ak0j = ARRAY(k0+j)
        Ak0i = ARRAY(k0+i)
        Ak1j = ARRAY(k1+j)
        Ak1i = ARRAY(k1+i)
        Ak2j = ARRAY(k2+j)
        Ak2i = ARRAY(k2+i)
        Ak3j = ARRAY(k3+j)
        Ak3i = ARRAY(k3+i)
        ARRAY(k0+j) = CS*Ak0j-SN*Ak0i
        ARRAY(k0+i) = SN*Ak0j+CS*Ak0i
        ARRAY(k1+j) = CS*Ak1j-SN*Ak1i
        ARRAY(k1+i) = SN*Ak1j+CS*Ak1i
        ARRAY(k2+j) = CS*Ak2j-SN*Ak2i
        ARRAY(k2+i) = SN*Ak2j+CS*Ak2i
        ARRAY(k3+j) = CS*Ak3j-SN*Ak3i
        ARRAY(k3+i) = SN*Ak3j+CS*Ak3i
        kk = k3+k+3
      end do
      ! Update the diagonal elements of A
      Temp = Two*CS*SN*ARIJ
      CS2 = CS**2
      SN2 = SN**2
      ARRAY(jj+j) = SN2*ARII+CS2*ARJJ-Temp
      ARRAY(ii+j) = Zero
      ARRAY(ii+i) = CS2*ARII+SN2*ARJJ+Temp
      ! Update rows/columns of the eigenvectors VECS
      kmin = 1
      kmax = LENVEC
      kleft = mod(kmax-kmin+1,4)
      if (kleft == 1) then
        C1j = VECS(1,j)
        C1i = VECS(1,i)
        VECS(1,i) = SN*C1j+CS*C1i
        VECS(1,j) = CS*C1j-SN*C1i
      else if (kleft == 2) then
        C1j = VECS(1,j)
        C2j = VECS(2,j)
        C1i = VECS(1,i)
        C2i = VECS(2,i)
        VECS(1,i) = SN*C1j+CS*C1i
        VECS(2,i) = SN*C2j+CS*C2i
        VECS(1,j) = CS*C1j-SN*C1i
        VECS(2,j) = CS*C2j-SN*C2i
      else if (kleft == 3) then
        C1j = VECS(1,j)
        C2j = VECS(2,j)
        C3j = VECS(3,j)
        C1i = VECS(1,i)
        C2i = VECS(2,i)
        C3i = VECS(3,i)
        VECS(1,i) = SN*C1j+CS*C1i
        VECS(2,i) = SN*C2j+CS*C2i
        VECS(3,i) = SN*C3j+CS*C3i
        VECS(1,j) = CS*C1j-SN*C1i
        VECS(2,j) = CS*C2j-SN*C2i
        VECS(3,j) = CS*C3j-SN*C3i
      end if
      kmin = kmin+kleft
      do k=kmin,kmax,4
        C0j = VECS(k+0,j)
        C1j = VECS(k+1,j)
        C2j = VECS(k+2,j)
        C3j = VECS(k+3,j)
        C0i = VECS(k+0,i)
        C1i = VECS(k+1,i)
        C2i = VECS(k+2,i)
        C3i = VECS(k+3,i)
        VECS(k+0,i) = SN*C0j+CS*C0i
        VECS(k+1,i) = SN*C1j+CS*C1i
        VECS(k+2,i) = SN*C2j+CS*C2i
        VECS(k+3,i) = SN*C3j+CS*C3i
        VECS(k+0,j) = CS*C0j-SN*C0i
        VECS(k+1,j) = CS*C1j-SN*C1i
        VECS(k+2,j) = CS*C2j-SN*C2i
        VECS(k+3,j) = CS*C3j-SN*C3i
      end do
      ! End of code by Markus Fuelscher

    end do
  end do
  NROT = NROT+NR

  if (IFTEST) then
    SBDMAX = Zero
    VNSUM = Zero
    do I=2,NDIM
      II = nTri_Elem(I-1)
      do J=1,I-1
        ARIJ = ARRAY(II+J)
        VNSUM = VNSUM+ARIJ**2
        SBDMAX = max(SBDMAX,abs(ARIJ))
      end do
    end do
    write(u6,'(3I8,2G20.12)') NSWEEP,NR,NROT,VNSUM,SBDMAX
  end if

  ! CHECK IF CONVERGED:
  if (NR == 0) exit
end do

! The shifted diagonal values are restored:
II = 0
do I=1,NDIM
  II = II+I
  ARRAY(II) = ARRAY(II)+SHIFT
end do

! STOP
return

end subroutine JACOB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gugainit()
! default value for performing ci calculation

use gugadrt_global, only: ludrt, ng_sm, nlsm_all, nlsm_bas, nlsmddel, nlsmedel
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), parameter :: maxmolcasorb = 5000
integer(kind=iwp) :: i, idisk, idum(1), idx, idx_idisk(64), lenrd, lucimo, luonemo, nbas(8), nc, ncone(64), ndel(8), nfro(8), &
                     norb(8), nsym
character(len=8) :: fncimo, fndrt, fnonemo
real(kind=wp) :: dum(1)
real(kind=wp), allocatable :: cmo(:)
character, allocatable :: bsbl(:)

fnonemo = 'TRAONE'
fndrt = 'CIDRT'
fncimo = 'CIMO'
luonemo = 30
ludrt = 31
lucimo = 32

call daname(lucimo,fncimo)
call daname(ludrt,fndrt)
!call molcas_open(ludrt,fndrt)
! open file traone to read orbital informations
call daname(luonemo,fnonemo)
!call molcas_open(luonemo,fnonemo)
idisk = 0
call idafile(luonemo,2,ncone,64,idisk)
call ddafile(luonemo,2,dum,1,idisk)
!ecor = dum(1)
call idafile(luonemo,2,idum,1,idisk)
nsym = idum(1)
call idafile(luonemo,2,nbas,8,idisk)
call idafile(luonemo,2,norb,8,idisk)
call idafile(luonemo,2,nfro,8,idisk)
call idafile(luonemo,2,ndel,8,idisk)
lenrd = 2*4*maxmolcasorb
call mma_allocate(bsbl,lenrd,label='bsbl')
call cdafile(luonemo,2,bsbl,lenrd,idisk)
nc = 0
do i=1,nsym
  nc = nc+nbas(i)**2
end do
call mma_allocate(cmo,nc,label='cmo')
call ddafile(luonemo,2,cmo,nc,idisk)

idx = 0
call idafile(lucimo,1,idx_idisk,64,idx)
idx_idisk(2) = idx
call cdafile(lucimo,1,bsbl,lenrd,idx)
idx_idisk(3) = idx
call ddafile(lucimo,1,cmo,nc,idx)
idx_idisk(4) = idx
idx = 0
call idafile(lucimo,1,idx_idisk,64,idx)

call mma_deallocate(bsbl)
call mma_deallocate(cmo)

call daclos(lucimo)
call daclos(luonemo)
nlsm_bas(1:8) = nbas(1:8)
nlsmddel(1:8) = nfro(1:8)
nlsmedel(1:8) = ndel(1:8)

!write(u6,'(a4,1x,8(2x,i8))') 'ncon',ncone(1:8)
!write(u6,*) 'idisk : ', idisk
!write(u6,'(a4,1x,f18.9)') 'ecor',ecor
!write(u6,'(a4,1x,i8)') 'nsym',nsym
!write(u6,'(a4,1x,8(2x,i8))') 'nbas',nbas(1:8)
!write(u6,'(a4,1x,8(2x,i8))') 'norb',norb(1:8)
!write(u6,'(a4,1x,8(2x,i8))') 'nfro',nfro(1:8)
!write(u6,'(a4,1x,8(2x,i8))') 'ndel',ndel(1:8)

ng_sm = nsym
nlsm_all(1:8) = norb(1:8)

return

end subroutine gugainit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SUSCEPTIBILITY(NSS,ESO,S_SO,DIPSO,nT,nTempMagn,T,tmin,tmax,XTexp,zJ,tinput,chiT_theta,doplot,iPrint,mem)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! this routine calculates the magnetic susceptibility and all related to it values.
! the units are cgsemu: cm^3*k/mol
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Three, Ten, cm_s, hPlanck, kBoltzmann, mBohr, rNAVO
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: nss, nT, nTempMagn, iprint, mem
real(kind=wp), intent(in) :: eso(nss), T(nT+nTempMagn), tmin, tmax, XTexp(nT+nTempMagn), zJ
complex(kind=wp), intent(in) :: s_so(3,nss,nss), dipso(3,nss,nss)
logical(kind=iwp), intent(in) :: tinput, doplot
real(kind=wp), intent(out) :: chit_theta(nT+nTempMagn)
integer(kind=iwp) :: ic, im, info, it, j, jc, jm, jT, mem_local
real(kind=wp) :: a_dir(3,3), a_inv(3,3), det, gtens(3), maxes(3,3), WT(3), XMM(3,3), XSM(3,3), XSS(3,3), xxm, XZJ(3,3), Zst, ZT(3,3)
character(len=50) :: label
real(kind=wp), allocatable :: chi_theta_1(:), chit(:), chit_tens(:,:,:), chit_theta_tens(:,:,:), zstat1(:)
real(kind=wp), parameter :: coeff_X = rNAVO*mBohr**2/kBoltzmann/Ten, &
                            boltz_k = kBoltzmann/(cm_s*hPlanck) ! boltzmann constant in cm-1*K-1
real(kind=wp), external :: dev

! constants used in this subrutine
mem_local = 0

write(u6,*)
write(u6,'(A)') repeat('%',95)
write(u6,'(35X,A)') 'CALCULATION OF THE MAGNETIC SUSCEPTIBILITY'
write(u6,'(A)') repeat('%',95)

write(u6,*)
if (TINPUT) then
  write(u6,'(5X,A)') 'Temperature dependence of the magnetic susceptibility calculated according '
  write(u6,'(5X,A)') 'to experimental values provided in the input'
else
  write(u6,'(5X,A)') 'Temperature dependence of the magnetic susceptibility calculated in'
  write(u6,'(5x,I3,a,f4.1,a,f6.1,a)') nT,' points, equally distributed in temperature range',Tmin,' ---',Tmax,' K.'
end if
write(u6,'(5X,A)') 'The algorithm employed for XT=f(T) in this section is based on the zero magnetic field limit.'
if (doplot) write(u6,'(5X,A)') 'The GNUPLOT script and corresponding images are generated in $WorkDir'
write(u6,*)
!-----------------------------------------------------------------------
if (iPrint > 2) then
  write(u6,*) 'Tmin       =',tmin
  write(u6,*) 'Tmax       =',tmax
  write(u6,*) '  nT       =',nT
  write(u6,*) '  nTempMagn=',nTempMagn
  write(u6,*) 'Temperature:',T(:)
  write(u6,*) 'ESO:',ESO(:)
  call prMom('SUSC: input  S_SO(l,i,j):',S_SO,nss)
  call prMom('SUSC: input DIPSO(l,i,j):',DIPSO,nss)
  call atens(DIPSO,nss,gtens,maxes,2)
end if
!-----------------------------------------------------------------------
! ***********************************************************
! *     Powder averaged high-T limit of susceptibility      *
! *                   and g-tensor                          *
! ***********************************************************
!ee = Zero
!ee_2 = Zero
!do Iss=1,NSS
!  do Jss=1,NSS
!    do ic=1,3
!      ee = ee+real(conjg(DipSO(ic,Iss,Jss))*DipSO(ic,Iss,Jss))
!      if ((Iss <= 4) .and. (Jss <=4)) ee_2 = ee_2+real(conjg(DipSO(ic,Iss,Jss))*DipSO(ic,Iss,Jss))
!    end do ! ic
!  end do ! Jss
!end do ! Iss
!chiT_high = coeff_X*ee/real(NSS,kind=wp)/Three
!SS1 = real(IGSM-1)**2*Quart+real(IGSM-1)*Half
!chiT_high_2 = coeff_X*ee_2/Twelve
!g_high = sqrt(chiT_high/(coeff_X*SS1/Three))
!g_high_2 = sqrt(chiT_high_2/(coeff_X*SS1/Three))
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
call mma_allocate(chiT,nT+nTempMagn,'chiT')
call mma_allocate(Zstat1,nT+nTempMagn,'Zstat1')
call mma_allocate(chi_theta_1,nT+nTempMagn,'chi_theta_1')
call mma_allocate(chiT_tens,3,3,nT+nTempMagn,'chiT_tens')
mem_local = mem_local+size(chiT)*RtoB
mem_local = mem_local+size(Zstat1)*RtoB
mem_local = mem_local+size(chi_theta_1)*RtoB
mem_local = mem_local+size(chiT_tens)*RtoB

if (zJ == 0) then
  if (iPrint > 2) then
    write(u6,*) 'SUSC:  zJ = 0'
    write(u6,*) 'SUSC:  memory allocated (local):'
    write(u6,*) 'mem_local=',mem_local
    write(u6,*) 'SUSC:  memory allocated (total):'
    write(u6,*) 'mem_total=',mem+mem_local
  end if

  do iT=1,nT+nTempMagn
    ! compute XT tensor for this temperature:
    call chi(DipSO,DipSO,Eso,Nss,T(iT),Zst,XMM)
    if (iPrint > 2) then
      write(u6,'(A,9F12.6)') 'XMM:',XMM(:,:)
      write(u6,'(A,9F12.6)') 'chiT:',coeff_X*(XMM(1,1)+XMM(2,2)+XMM(3,3))/Three,Zst
    end if

    !XMM(:,:) = coeff_X*XMM(:,:)
    chiT_tens(:,:,iT) = coeff_X*XMM(:,:)

    !chiT_tens(:,:,iT) = XMM(:,:)
    ! compute the powder XT for this temperature:
    chiT(iT) = coeff_X*(XMM(1,1)+XMM(2,2)+XMM(3,3))/Three

    if (abs(chit(iT)) < 1.0e-20_wp) chit(iT) = 1.0e-20_wp

    chit_theta(iT) = chiT(iT)
    chi_theta_1(iT) = T(iT)/chiT(iT)
    Zstat1(iT) = Zst
  end do
else  ! i.e. when zJ /= Zero
  if (iPrint > 2) write(u6,*) 'SUSC:  zJ \= 0'
  ! allocate matrices:
  call mma_allocate(chiT_theta_tens,3,3,nT+nTempMagn,'XTT')
  ! initialize:
  mem_local = mem_local+size(chiT_theta_tens)*RtoB
  if (iPrint > 2) then
    write(u6,*) 'SUSC:  memory allocated (local):'
    write(u6,*) 'mem_local=',mem_local
    write(u6,*) 'SUSC:  memory allocated (total):'
    write(u6,*) 'mem_total=',mem+mem_local
  end if

  do iT=1,nT+nTempMagn
    ! compute tensors:
    call chi(DipSO,DipSO,Eso,Nss,T(it),Zst,XMM)
    call chi(S_SO,DipSO,Eso,Nss,T(it),Zst,XSM)
    call chi(S_SO,S_SO,Eso,Nss,T(it),Zst,XSS)
    ! form the A_dir matrix:
    ! A_dir(:,:) = 1(:,:)*kB*T(iT)-zJ*XSS(:,:)
    call unitmat(A_dir,3)
    A_dir(:,:) = Boltz_k*T(iT)*A_dir(:,:)-zJ*XSS(:,:)
    ! invert it:
    call REVERSE(A_dir,A_inv,DET)

    do ic=1,3
      do jc=1,3
        ! compute the trace of the product XSM*A*XSM
        xxm = Zero
        do im=1,3
          do jm=1,3
            xxm = xxm+XSM(im,ic)*A_inv(im,jm)*XSM(jm,jc)
          end do
        end do
        ! add this contribution to the total susceptibility tensor
        XZJ(ic,jc) = XMM(ic,jc)+zJ*xxm
      end do ! jc
    end do ! ic

    ! Scale the tensors by coeff_X factor:
    XMM(:,:) = coeff_X*XMM(:,:)
    XZJ(:,:) = coeff_X*XZJ(:,:)
    ! place the tensors in the corresponding part of the "big" arrays:
    chiT_tens(:,:,iT) = XMM(:,:)
    chiT_theta_tens(:,:,iT) = XZJ(:,:)
    ! compute powder:
    chiT(iT) = (XMM(1,1)+XMM(2,2)+XMM(3,3))/Three
    chiT_theta(iT) = (XZJ(1,1)+XZJ(2,2)+XZJ(3,3))/Three

    if (abs(chit(iT)) < 1.0e-20_wp) chit(iT) = 1.0e-20_wp
    if (abs(chiT_theta(iT)) < 1.0e-20_wp) chiT_theta(iT) = 1.0e-20_wp

    chi_theta_1(iT) = T(iT)/chiT_theta(iT)
    Zstat1(iT) = Zst
  end do ! iT
end if ! zJ

!  WRITING SOME OF THE OUTPUT...

write(u6,'(/)')
write(u6,'(A)') '     |     T      | Statistical |    CHI*T    |    CHI*T    |     CHI     |    1/CHI    |'
write(u6,'(A)') '     |            |  Sum (Z)    |    (zJ=0)   |             |             |             |'
write(u6,'(A)') '     |            |             |             |             |             |             |'
write(u6,'(A)') '-----|----------------------------------------------------------------------------------|'
write(u6,'(A)') 'Units|   kelvin   |    ---      |  cm3*K/mol  |  cm3*K/mol  |   cm3/mol   |   mol/cm3   |'
write(u6,'(A)') '-----|----------------------------------------------------------------------------------|'

do iT=1,nT
  jT = iT+nTempMagn
  write(u6,'(A,F11.6,A,ES12.5,A,F12.8,A,F12.8,A,ES12.5,A,ES12.5,A)') '     |',T(jT),' |',zstat1(jT),' |',chiT(jT),' |', &
                                                                     chiT_theta(jT),' |',chiT_theta(jT)/T(jT),' |', &
                                                                     chi_theta_1(jT),' |'
end do
write(u6,'(A)') '-----|----------------------------------------------------------------------------------|'

if (TINPUT) then
  write(u6,'(/)')
  write(u6,'(5X,A      )') 'STANDARD DEVIATION OF THE CALCULATED MAGNETIC SUSCEPTIBILITY'
  write(u6,'(5X,A,F12.7)') 'FROM EXPERIMENTAL VALUES PROVIDED IN THE INPUT FILE IS:', &
                           dev(nT,chit_theta(1+nTempMagn:),XTexp(1+nTempMagn:))

end if

!-------------------------  PLOTs -------------------------------------!
write(label,'(A)') 'no_field'
if (DoPlot) then
  if (tinput) then
    call plot_XT_with_Exp(label,nT,T(1+nTempMagn:),chit_theta(1+nTempMagn:),XTexp(1+nTempMagn:))
  else
    call plot_XT_no_Exp(label,nT,T(1+nTempMagn:),chit_theta(1+nTempMagn:))
  end if
end if
!---------------------- END PLOTs -------------------------------------!

! print out the main VAN VLECK SUSCEPTIBILITY TENSOR, its main values and main axes:
if (zJ == Zero) then

  write(u6,'(/)')
  write(u6,'(2A)') repeat('-',110),'|'
  write(u6,'(31X,A,22x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR FOR zJ = 0,  in cm3*K/mol','|'
  write(u6,'(2A)') repeat('-',110),'|'
  write(u6,'(A   )') '     T(K)   |   |          Susceptibility Tensor      |    Main Values  |'// &
                     '               Main Axes             |'
  do iT=1,nT
    jT = iT+nTempMagn
    info = 0
    call DIAG_R2(chiT_tens(:,:,jT),3,info,wt,zt)
    write(u6,'(A)') '------------|---|------- x --------- y --------- z ---|-----------------|------ x --------- y ---------'// &
                    ' z ----|'
    write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | x |',(chiT_tens(1,j,jT),j=1,3),' |  X:',wt(1),'|', &
                                                    (zt(j,1),j=1,3),'|'
    write(u6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),'| y |',(chiT_tens(2,j,jT),j=1,3),' |  Y:',wt(2),'|', &
                                                             (zt(j,2),j=1,3),'|'
    write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | z |',(chiT_tens(3,j,jT),j=1,3),' |  Z:',wt(3),'|', &
                                                    (zt(j,3),j=1,3),'|'
  end do
  write(u6,'(2A)') repeat('-',110),'|'

else ! zJ /= Zero

  write(u6,'(/)')
  write(u6,'(2A)') repeat('-',110),'|'
  write(u6,'(31X,A,F7.4,15x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR FOR zJ = ',zJ,',  in cm3*K/mol','|'
  write(u6,'(2A)') repeat('-',110),'|'
  write(u6,'(A)') '     T(K)   |   |          Susceptibility Tensor      |    Main Values  |               Main Axes             |'
  do iT=1,nT
    jT = iT+nTempMagn
    info = 0
    call DIAG_R2(chiT_theta_tens(:,:,jT),3,info,wt,zt)
    write(u6,'(A)') '------------|---|------- x --------- y --------- z ---|-----------------|------ x --------- y ---------'// &
                    ' z ----|'
    write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | x |',(chiT_theta_tens(1,j,jT),j=1,3),' |  X:',wt(1),'|', &
                                                    (zt(j,1),j=1,3),'|'
    write(u6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),'| y |',(chiT_theta_tens(2,j,jT),j=1,3),' |  Y:',wt(2),'|', &
                                                             (zt(j,2),j=1,3),'|'
    write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | z |',(chiT_theta_tens(3,j,jT),j=1,3),' |  Z:',wt(3),'|', &
                                                    (zt(j,3),j=1,3),'|'
  end do
  write(u6,'(2A)') repeat('-',110),'|'
  call mma_deallocate(chiT_theta_tens)
end if ! zJ

!write(u6,'(/)')
!write(u6,'(10A)') (('------------'),K=1,10)
!write(u6,'(5X,A)') 'MAGNETIC SUSCEPTIBILITY IN THE DIRECTION OF THE MAIN MAGNETIC AXES'
!write(u6,'(10A)') (('------------'),K=1,10)
!write(u6,*)
!write(u6,'(7X,A)') 'T(K)         gx          gy          gz'
!write(u6,*)
!do iT=1,nT
!  write(u6,'(4X,F6.1,6X,3(F8.4,4X))') T(iT),(ChiT_main(iT,ic),ic=1,3)
!end do
! saving some information for tests:

call Add_Info('Temperature',T,nT+nTempMagn,5)
call Add_Info('CHIT',chiT,nT+nTempMagn,5)
call Add_Info('CHIT_THETA',chiT_theta,nT+nTempMagn,5)

call mma_deallocate(Zstat1)
call mma_deallocate(chiT_tens)
call mma_deallocate(chiT)
call mma_deallocate(chi_theta_1)

return

end subroutine SUSCEPTIBILITY

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
cmp      SUBROUTINE t3loopa(oeh,oep,t1a,t1b,g,nga,ngb,ngc,vblock,energ,
      SUBROUTINE t3loopa(oeh,oep,t1a,t1b,nga,ngb,ngc,vblock,energ,
     $ isp,LU,ifvo,lastcall,scored,jjj,enx)
C  implemented integer offsets, PV, 16 may 2004.
      IMPLICIT NONE
#include "ndisk.fh"
#include "WrkSpc.fh"
cmp      real*8 g(*),energ(*),oeh(*),oep(*),enx,t1a(*),t1b(*)
      real*8 energ(*),oeh(*),oep(*),enx,t1a(*),t1b(*)
      integer nug
      integer isp,vblock,n,lu(*),nga,ngb,ngc,adim,bdim,cdim
      INTEGER iasblock(3),aset,bset,cset
      CHARACTER ich*1
      logical ifvo,lastcall,scored
      INTEGER IOPT,NOAB,NNOAB,NUAB,NNUAB,IUHF
cmp
        integer jjj
cmp
      COMMON/UHF/NOAB(2),NNOAB(3),NUAB(2),NNUAB(3),ICH(3)
      COMMON/IOIND/IOPT(96)
      integer ka,kb,kc,la,lb,lc,t3a,t3b,voa,vob,voc,mi,mij
      SAVE      ka,kb,kc,la,lb,lc,t3a,t3b,voa,vob,voc,mi,mij,
     $     iasblock,iuhf,nug
C
      N=noab(isp)+nuab(isp)
      enx=0.d0
        scored=.true.
cmp!!!  if (lastcall) goto 321
cmp     write (6,*) 'NOAB,NNOAB,NUAB,NNUAB,ICH'
cmp     write (6,*) NOAB,NNOAB,NUAB,NNUAB,ICH
cmp!!!      if(energ(isp).eq.0.d0)then
C this is a first entry - initialization (makes no harm if reapeated)
      nug=nuab(isp)/vblock
      if((nug*vblock).lt.nuab(isp))nug=nug+1
cmp      write(6,*)'first,nug,vblock',nug,vblock,iopt(76)
      IUHF=isp
      !!IF(IOPT(76).eq.0)IUHF=3
      iasblock(1)=vblock*vblock*N/nblock
      if((iasblock(1)*nblock).lt.(vblock*vblock*N))
     $                                    iasblock(1)=iasblock(1)+1
      iasblock(2)=nnoab(iuhf)*vblock*N/nblock
      if((iasblock(2)*nblock).lt.(nnoab(iuhf)*vblock*N))
     $iasblock(2)=iasblock(2)+1
      iasblock(3)=nnoab(iuhf)*vblock*vblock/nblock
      if((iasblock(3)*nblock).lt.(nnoab(iuhf)*vblock*vblock))
     $iasblock(3)=iasblock(3)+1
cmp      call w_rescope(G,'G3loopa')
cmp      call w_free(g,0,'G3loopa')
c  allocations
cmp      call w_alloc(ka,noab(isp)*vblock*vblock*n,'kaT3loopa')
      call GetMem('loopa_ka','Allo','Real',ka,noab(isp)*vblock*vblock*n)
      if(nug.ne.1)then
cmp      call w_alloc(kb,noab(isp)*vblock*vblock*n,'kbT3loopa')
      call GetMem('loopa_kb','Allo','Real',kb,noab(isp)*vblock*vblock*n)
cmp      call w_alloc(kc,noab(isp)*vblock*vblock*n,'kcT3loopa')
      call GetMem('loopa_kc','Allo','Real',kc,noab(isp)*vblock*vblock*n)
      endif
cmp      call w_alloc(la,nnoab(IUHF)*vblock*n,'laT3loopa')
      call GetMem('loopa_la','Allo','Real',la,nnoab(IUHF)*vblock*n)
cmp      call w_alloc(lb,nnoab(IUHF)*vblock*n,'lbT3loopa')
      call GetMem('loopa_lb','Allo','Real',lb,nnoab(IUHF)*vblock*n)
cmp      call w_alloc(lc,nnoab(IUHF)*vblock*n,'lcT3loopa')
      call GetMem('loopa_lc','Allo','Real',lc,nnoab(IUHF)*vblock*n)
cmp      call w_alloc(t3a,vblock*vblock*vblock,'t3aT3loopa')
      call GetMem('loopa_t3a','Allo','Real',t3a,vblock*vblock*vblock)
cmp      call w_alloc(t3b,vblock*vblock*vblock,'t3bT3loopa')
      call GetMem('loopa_t3b','Allo','Real',t3b,vblock*vblock*vblock)
cmp      call w_alloc(voa,vblock*vblock*nnoab(IUHF),'voaT3loopa')
      call GetMem('loopa_voa','Allo','Real',
     & voa,vblock*vblock*nnoab(IUHF))
cmp      call w_alloc(vob,vblock*vblock*nnoab(IUHF),'vobT3loopa')
      call GetMem('loopa_vob','Allo','Real',
     & vob,vblock*vblock*nnoab(IUHF))
cmp      call w_alloc(voc,vblock*vblock*nnoab(IUHF),'vocT3loopa')
      call GetMem('loopa_voc','Allo','Real',
     & voc,vblock*vblock*nnoab(IUHF))
C  this is necessary
C  prefactors currently a formal allocation
cmp ?      call w_alloc(mi,1,'miT3loopa')
cmp ?      call w_alloc(mij,1,'T3loopa')
      call GetMem('loopa_mi','Allo','Real',mi,1)
      call GetMem('loopa_mij','Allo','Real',mij,1)

cmp!!!      endif     ! energ - initialization
      aset=(nga-1)*vblock
      adim=min(vblock,nuab(isp)-aset)
      bset=(ngb-1)*vblock
      bdim=min(vblock,nuab(isp)-bset)
      cset=(ngc-1)*vblock
      cdim=min(vblock,nuab(isp)-cset)
C
C case1 nga=ngb=ngc
C if memory is available loops over i,j,k, in subloops can be grouped !!!
      if(nga.eq.ngc) then
C
cmp      call t3_bt_aaa(nug,g(ka),g(ka),g(ka),g(la),g(mi),g(mij),
      call t3_bt_aaa(nug,Work(ka),Work(ka),Work(ka),Work(la),
     &Work(mi),Work(mij),
     $adim,N,noab(isp),nuab(isp),nnoab(iuhf),lu,iasblock,nga,oeh,
     $oep(aset+1),enx,Work(voa),
     $t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),Work(t3a),Work(t3b),
     &ifvo)
cmp     $oep(aset+1),enx,g(voa),
cmp     $t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),g(t3a),g(t3b),ifvo)
C
      elseif(nga.eq.ngb)then
cmp      call t3_bt_aac(nug,g(ka),g(kb),g(kc),g(la),g(lc),g(mi),g(mij),
      call t3_bt_aac(nug,Work(ka),Work(kb),Work(kc),Work(la),Work(lc),
     &Work(mi),Work(mij),
     $adim,cdim,N,noab(isp),nuab(isp),nnoab(iuhf),lu,iasblock,nga,ngc,
     $oeh,oep(aset+1),oep(cset+1),enx,Work(voa),Work(voc),
     $t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),
     $t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),
     $Work(t3a),Work(t3b),ifvo)
cmp     $oeh,oep(aset+1),oep(cset+1),enx,g(voa),g(voc),
cmp     $t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),
cmp     $t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),
cmp     $g(t3a),g(t3b),ifvo)
      elseif(ngb.eq.ngc)then
cmp      call t3_bt_acc(nug,g(ka),g(kb),g(kc),g(la),g(lc),g(mi),g(mij),
      call t3_bt_acc(nug,Work(ka),Work(kb),Work(kc),Work(la),Work(lc),
     &Work(mi),Work(mij),
     $adim,cdim,N,noab(isp),nuab(isp),nnoab(iuhf),lu,iasblock,nga,ngc,
     $oeh,oep(aset+1),oep(cset+1),enx,Work(voa),Work(voc),
     $t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),
     $t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),
     $Work(t3a),Work(t3b),ifvo)
cmp     $oeh,oep(aset+1),oep(cset+1),enx,g(voa),g(voc),
cmp     $t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),
cmp     $t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),
cmp     $g(t3a),g(t3b),ifvo)
      else
cmp      call t3_bt_abc(nug,g(ka),g(kb),g(kc),g(la),g(lb),g(lc),g(mi),
cmp     $g(mij),adim,bdim,cdim,N,noab(isp),nuab(isp),nnoab(iuhf),lu,
      call t3_bt_abc(nug,Work(ka),Work(kb),Work(kc),Work(la),Work(lb),
     &Work(lc),Work(mi),
     $Work(mij),adim,bdim,cdim,N,noab(isp),nuab(isp),nnoab(iuhf),lu,
     $iasblock,nga,ngb,ngc,
     $oeh,oep(aset+1),oep(bset+1),oep(cset+1),enx,Work(voa),Work(vob),
     &Work(voc),
     $t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),t1a(noab(isp)*bset+1),
     $t1b(noab(isp)*bset+1),t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),
     $Work(t3a),Work(t3b),ifvo)
cmp     $oeh,oep(aset+1),oep(bset+1),oep(cset+1),enx,g(voa),g(vob),g(voc),
cmp     $t1a(noab(isp)*aset+1),t1b(noab(isp)*aset+1),t1a(noab(isp)*bset+1),
cmp     $t1b(noab(isp)*bset+1),t1a(noab(isp)*cset+1),t1b(noab(isp)*cset+1),
cmp     $g(t3a),g(t3b),ifvo)
      endif   ! cases
      energ(isp)=energ(isp)+enx
cmp     write (*,'(A,i5,x,3(i3,1x),f21.19)') 'Tsk, nga, ngb, ngc, inc = ',
cmp     & jjj,nga,ngb,ngc,enx
cmp
c321     continue
cmp        write (6,*)
cmp        write (6,*) 'deallocating arrays in t3loopa'
cmp        write (6,*)
      call GetMem('loopa_mij','Free','Real',mij,1)
      call GetMem('loopa_mi','Free','Real',mi,1)
      call GetMem('loopa_voc','Free','Real',
     & voc,vblock*vblock*nnoab(IUHF))
      call GetMem('loopa_vob','Free','Real',
     & vob,vblock*vblock*nnoab(IUHF))
      call GetMem('loopa_voa','Free','Real',
     & voa,vblock*vblock*nnoab(IUHF))
      call GetMem('loopa_t3b','Free','Real',t3b,vblock*vblock*vblock)
      call GetMem('loopa_t3a','Free','Real',t3a,vblock*vblock*vblock)
      call GetMem('loopa_lc','Free','Real',lc,nnoab(IUHF)*vblock*n)
      call GetMem('loopa_lb','Free','Real',lb,nnoab(IUHF)*vblock*n)
      call GetMem('loopa_la','Free','Real',la,nnoab(IUHF)*vblock*n)
      if(nug.ne.1)then
      call GetMem('loopa_kc','Free','Real',kc,noab(isp)*vblock*vblock*n)
      call GetMem('loopa_kb','Free','Real',kb,noab(isp)*vblock*vblock*n)
      endif
      call GetMem('loopa_ka','Free','Real',ka,noab(isp)*vblock*vblock*n)
cmp
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_logical(lastcall)
        call Unused_integer(jjj)
      end if
      end

      subroutine t3_bt_aaa(nug,ka,kb,kc,la,mi,mij,adim,N,noab,
     $nuab,nnoab,lu,iasblock,nga,oeh,oep,enx,voa,t1a,t1b,t3a,t3b,ifvo)
      implicit none
      real*8 one,zero
      parameter (one=1.d0,zero=0.d0)
      integer a,b,c,aa,ab,bc,ac
      real*8 XX,YY,enx,den,dena,denb,denc
      integer ndim,adim,noab,nuab,i,j,k,nga,iasblock(3),lu(2),N
      integer ias,nga_offset,nug_offset,jk,ij,ik,ii,jj,nug,nnoab
      logical ifvo
      real*8  ka(adim*(adim-1)/2,N,*),kb(*),kc(*)
      real*8  la(N*adim,nnoab),mi(*),mij(*)
!!      real*8  lb(N,adim,nnoab),lc(N,adim,nnoab)
      real*8  t3a(adim*(adim-1)/2,adim),t3b(adim*(adim-1)/2,adim)
!!      real*8  mi(adim*(adim-1)/2,adim,noab),mij(*)
      real*8  voa(adim*(adim-1)/2,nnoab)
      real*8  t1a(noab,*),t1b(noab,*),oeh(noab),oep(adim)
C
      if(adim.eq.1)return
cmp       write(6,*)'enter_aaa enx,nga,',nga,enx
      ndim=adim*(adim-1)/2
      call zeroma(t3b,1,ndim*adim)
      nug_offset=iasblock(1)*nug*(nug+1)/2
      ias=iasblock(2)*(nga-1)+1
      call multi_readir(la,nnoab*adim*N,lu(2),ias)
      ias=iasblock(2)*nug+iasblock(3)*(nga*(nga+1)/2-1)+1
      call multi_readir(voa,nnoab*ndim,lu(2),ias)
C
      nga_offset=iasblock(1)*(nga*(nga+1)/2-1)+1
         do i=1,noab
         ias=(i-1)*nug_offset+nga_offset
         call multi_readir(ka(1,1,i),N*ndim,lu(1),ias)
         enddo
         do i=3,noab
         ii=(i-1)*N*ndim+1
         jk=0
         do j=2,i-1
         jj=(j-1)*N*ndim+1
         ij=(i-1)*(i-2)/2+j
         ik=(i-1)*(i-2)/2
         do k=1,j-1
         jk=jk+1
         ik=ik+1
C  K_ab^ir x L_rc^jk
         call DGEMM_('N','N',ndim,adim,N,one,ka(1,1,i),ndim,la(1,jk),N,
     $                     zero,t3a,ndim)
C  K_ab^kr x L_rc^ij
         call DGEMM_('N','N',ndim,adim,N,one,ka(1,1,k),ndim,la(1,ij),N,
     $                     one,t3a,ndim)
C  -K_ab^jr x L_rc^ik
         call DGEMM_('N','N',ndim,adim,N,-one,ka(1,1,j),ndim,la(1,ik),N,
     $                     one,t3a,ndim)
         den=oeh(i)+oeh(j)+oeh(k)
         do a=3,adim
         aa=(a-1)*(a-2)/2
         dena=den-oep(a)
         bc=0
         do b=2,a-1
         denb=dena-oep(b)
         ab=aa+b
         do c=1,b-1
         bc=bc+1
         denc=denb-oep(c)
         ac=aa+c
         xx=t3a(ab,c)+t3a(bc,a)-t3a(ac,b)
         yy=xx/denc
         enx=enx+yy*xx
         t3b(ab,c)=yy
         t3b(bc,a)=yy
         t3b(ac,b)=-yy
         enddo
         enddo
         enddo
C ccsd(T) part vvoo*t3
         call DGEMM_('N','N',1,adim,ndim,one,voa(1,ij),1,
     $  t3b,ndim,one,t1a(k,1),noab)
         call DGEMM_('N','N',1,adim,ndim,one,voa(1,jk),1,
     $  t3b,ndim,one,t1a(i,1),noab)
         call DGEMM_('N','N',1,adim,ndim,-one,voa(1,ik),1,
     $  t3b,ndim,one,t1a(j,1),noab)
C ccsd(T) part t2*t3
         if(ifvo) then
         call DGEMM_('N','N',1,adim,ndim,one,ka(1,i,j),1,
     $  t3b,ndim,one,t1b(k,1),noab)
         call DGEMM_('N','N',1,adim,ndim,one,ka(1,j,k),1,
     $  t3b,ndim,one,t1b(i,1),noab)
         call DGEMM_('N','N',1,adim,ndim,-one,ka(1,i,k),1,
     $  t3b,ndim,one,t1b(j,1),noab)
         endif
         enddo !k
         enddo !j
         enddo !i
         return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real_array(kb)
        call Unused_real_array(kc)
        call Unused_real_array(mi)
        call Unused_real_array(mij)
        call Unused_integer(nuab)
      end if
         end

      subroutine t3_bt_aac(nug,ka,kb,kc,la,lc,mi,mij,adim,cdim,
     $N,noab,nuab,nnoab,lu,iasblock,nga,ngc,oeh,oepa,oepc,enx,voa,voc,
     $t1aa,t1ba,t1ac,t1bc,t3a,t3b,ifvo)
      implicit none
      real*8 one,zero,sumt3
      logical ifvo
      parameter (one=1.d0,zero=0.d0)
      integer nadim,adim,noab,nuab,i,j,k,nga,iasblock(3),lu(2),N
      integer ias,nga_offset,ngc_offset,nug_offset,jk,ij,ik,ncdim,cdim
      integer a,b,c,ab,nug,nnoab,ngc,iasci,iasai !,kaka
      real*8 dena,denb,denc,xx,yy
      real*8  ka(adim*(adim-1)/2,n,*),kc(adim*cdim,n,*),kb(*),
     $la(N*adim,nnoab),lc(N*cdim,nnoab)
!!      real*8  lb(N,adim,nnoab),lc(N,adim,nnoab)
      real*8  t3a(cdim,*),t3b(cdim,adim,*),t1ac(noab,*),t1bc(noab,*)
      real*8  mi(*),mij(*),voa(adim*(adim-1)/2,*),voc(adim*cdim,*)
      real*8  t1aa(noab,*),t1ba(noab,*),enx,oeh(noab),oepa(adim),den
      real*8  oepc(cdim)
C
      sumt3=0.d0
      if(adim.eq.1)return
      nadim=adim*(adim-1)/2
      ncdim=adim*cdim
      nug_offset=iasblock(1)*nug*(nug+1)/2
      ias=iasblock(2)*(nga-1)+1
      call multi_readir(la,nnoab*adim*N,lu(2),ias)
      ias=iasblock(2)*(ngc-1)+1
      call multi_readir(lc,nnoab*cdim*N,lu(2),ias)
C reads vvoo
      nga_offset=iasblock(3)*(nga*(nga-1)/2+nga-1)+1
      ngc_offset=iasblock(3)*(nga*(nga-1)/2+ngc-1)+1
      ias=iasblock(2)*nug+nga_offset
      call multi_readir(voa,nnoab*nadim,lu(2),ias)
      ias=iasblock(2)*nug+ngc_offset
      call multi_readir(voc,nnoab*ncdim,lu(2),ias)
C
      nga_offset=iasblock(1)*(nga*(nga-1)/2+nga-1)+1
      ngc_offset=iasblock(1)*(nga*(nga-1)/2+ngc-1)+1
      do i=1,noab
      iasci=(i-1)*nug_offset+ngc_offset
      call multi_readir(kc(1,1,i),N*ncdim,lu(1),iasci)
      iasai=(i-1)*nug_offset+nga_offset
      call multi_readir(ka(1,1,i),N*nadim,lu(1),iasai)
      enddo
         do i=3,noab
         jk=0
         do j=2,i-1
         ij=(i-1)*(i-2)/2+j
         ik=(i-1)*(i-2)/2
         do k=1,j-1
         jk=jk+1
         ik=ik+1
!!         write(6,'(9I5)')i,j,k,iasai,iasaj,iasak,iasci,iascj,iasck
C  K_ab^ir x L_rc^jk
      call DGEMM_('T','T',cdim,nadim,N,one, lc(1,jk),N,ka(1,1,i),nadim,
     $                     zero,t3a,cdim)
C  K_ab^kr x L_rc^ij
      call DGEMM_('T','T',cdim,nadim,N,one, lc(1,ij),N,ka(1,1,k),nadim,
     $                     one,t3a,cdim)
C  -K_ab^jr x L_rc^ik
      call DGEMM_('T','T',cdim,nadim,N,-one,lc(1,ik),N,ka(1,1,j),nadim,
     $                     one,t3a,cdim)
C  K_bc^ir x L_ra^jk
      call DGEMM_('N','N',ncdim,adim,N,one,kc(1,1,i),ncdim,la(1,jk),N,
     $                     zero,t3b,ncdim)
C  K_bc^kr x L_ra^ij
      call DGEMM_('N','N',ncdim,adim,N,one,kc(1,1,k),ncdim,la(1,ij),N,
     $                     one,t3b,ncdim)
C  -K_bc^jr x L_ra^ik
      call DGEMM_('N','N',ncdim,adim,N,-one,kc(1,1,j),ncdim,la(1,ik),N,
     $                     one,t3b,ncdim)
!!
       ab=0
      do a=2,adim
      do b=1,a-1
      ab=ab+1
      call daxpy_(cdim,-1.d0,t3b(1,a,b),1,t3a(1,ab),1)
      call daxpy_(cdim,1.d0,t3b(1,b,a),1,t3a(1,ab),1)
      enddo
      enddo
         den=oeh(i)+oeh(j)+oeh(k)
      ab=0
c!      kaka=0
      do a=2,adim
      dena=den-oepa(a)
      do b=1,a-1
      ab=ab+1
      denb=dena-oepa(b)
      do c=1,cdim
      denc=denb-oepc(c)
c!      ab=ab+1
c!      kaka=kaka+1
c!      xx=t3a(ab,1)
      xx=t3a(c,ab)
      yy=xx/denc
      sumt3=sumt3+xx
      enx=enx+yy*xx
c!      t3a(ab,1)=yy
      t3a(c,ab)=yy
c!      write (*,*) ab,t3a(ab,1)
c!      write (*,*) kaka,t3a(c,ab)
      enddo
      enddo
      enddo
      call expa2_uhf(t3a,cdim,adim,-1,t3b)
C ccsd(T) part vvoo*t3
         call DGEMM_('N','T',1,cdim,nadim, one,voa(1,ij),1,
     $  t3a,cdim,one,t1ac(k,1),noab)
         call DGEMM_('N','T',1,cdim,nadim, one,voa(1,jk),1,
     $  t3a,cdim,one,t1ac(i,1),noab)
         call DGEMM_('N','T',1,cdim,nadim,-one,voa(1,ik),1,
     $  t3a,cdim,one,t1ac(j,1),noab)
         call DGEMM_('N','N',1,adim,ncdim,-one,voc(1,ij),1,
     $  t3b,ncdim,one,t1aa(k,1),noab)
         call DGEMM_('N','N',1,adim,ncdim,-one,voc(1,jk),1,
     $  t3b,ncdim,one,t1aa(i,1),noab)
         call DGEMM_('N','N',1,adim,ncdim, one,voc(1,ik),1,
     $  t3b,ncdim,one,t1aa(j,1),noab)
C ccsd(T) part t2*t3
         if(ifvo) then
         call DGEMM_('N','T',1,cdim,nadim, one,ka(1,i,j),1,
     $  t3a,cdim,one,t1bc(k,1),noab)
         call DGEMM_('N','T',1,cdim,nadim, one,ka(1,j,k),1,
     $  t3a,cdim,one,t1bc(i,1),noab)
         call DGEMM_('N','T',1,cdim,nadim,-one,ka(1,i,k),1,
     $  t3a,cdim,one,t1bc(j,1),noab)
         call DGEMM_('N','N',1,adim,ncdim,-one,kc(1,i,j),1,
     $  t3b,ncdim,one,t1ba(k,1),noab)
         call DGEMM_('N','N',1,adim,ncdim,-one,kc(1,j,k),1,
     $  t3b,ncdim,one,t1ba(i,1),noab)
         call DGEMM_('N','N',1,adim,ncdim, one,kc(1,i,k),1,
     $  t3b,ncdim,one,t1ba(j,1),noab)
         endif
          enddo !k
         enddo !j
         enddo !i
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real_array(kb)
        call Unused_real_array(mi)
        call Unused_real_array(mij)
        call Unused_integer(nuab)
      end if
      end

       subroutine t3_bt_abc(nug,ka,kb,kc,la,lb,lc,mi,mij,adim,bdim,
     $cdim,N,noab,nuab,nnoab,lu,iasblock,nga,ngb,ngc,oeh,oepa,oepb,
     $oepc,enx,voa,vob,voc,t1aa,t1ba,t1ab,t1bb,t1ac,t1bc,t3a,t3b,ifvo)
      implicit none
      real*8 one,zero,ddot_,enx,den,dena,denb,denc
      parameter (one=1.d0,zero=0.d0)
      logical ifvo
      integer nadim,adim,bdim,nbdim,cdim,ncdim,noab,nuab,i,j,k
      integer nga,ngb,ngc,N,iasblock(3),lu(2),jk,ij,ik,ac,ca,a,b,c
      integer ias,iasai,iasbi,iasci
c     integer iasaj,iasak,iascj,iasck
      integer nga_offset,ngb_offset,ngc_offset,nug_offset,nug,nnoab
      real*8  ka(adim*bdim,N,*),kb(bdim*cdim,N,*),kc(adim*cdim,N,*)
      real*8  la(N*adim,nnoab),lb(N*bdim,nnoab),lc(N*cdim,nnoab)
      real*8  t1aa(noab,*),t1ba(noab,*),t1ab(noab,*),t1bb(noab,*)
      real*8  mi(*),t1ac(noab,*),t1bc(noab,*)
      real*8  mij(*),voa(adim*bdim,*),vob(bdim*cdim,*),voc(adim*cdim,*)
      real*8  oeh(noab),oepa(adim),oepb(bdim),oepc(cdim),t3a(*),t3b(*)
C
!!       write(6,*)'enter_abc enx,nga,ngb,ngc',nga,ngb,ngc,enx
      nadim=adim*bdim
      nbdim=bdim*cdim
      ncdim=adim*cdim
      nug_offset=iasblock(1)*nug*(nug+1)/2
C reads la's
      ias=iasblock(2)*(nga-1)+1
      call multi_readir(la,nnoab*adim*N,lu(2),ias)
      ias=iasblock(2)*(ngb-1)+1
      call multi_readir(lb,nnoab*bdim*N,lu(2),ias)
      ias=iasblock(2)*(ngc-1)+1
      call multi_readir(lc,nnoab*cdim*N,lu(2),ias)
C reads vvoo
      nga_offset=iasblock(3)*(nga*(nga-1)/2+ngb-1)+1
      ngb_offset=iasblock(3)*(ngb*(ngb-1)/2+ngc-1)+1
      ngc_offset=iasblock(3)*(nga*(nga-1)/2+ngc-1)+1
      ias=iasblock(2)*nug+nga_offset
      call multi_readir(voa,nnoab*nadim,lu(2),ias)
      ias=iasblock(2)*nug+ngb_offset
      call multi_readir(vob,nnoab*nbdim,lu(2),ias)
      ias=iasblock(2)*nug+ngc_offset
      call multi_readir(voc,nnoab*ncdim,lu(2),ias)
C
      nga_offset=iasblock(1)*(nga*(nga-1)/2+ngb-1)+1
      ngb_offset=iasblock(1)*(ngb*(ngb-1)/2+ngc-1)+1
      ngc_offset=iasblock(1)*(nga*(nga-1)/2+ngc-1)+1
      do i=1,noab
      iasci=(i-1)*nug_offset+ngc_offset
      call multi_readir(kc(1,1,i),N*ncdim,lu(1),iasci)
      iasbi=(i-1)*nug_offset+ngb_offset
      call multi_readir(kb(1,1,i),N*nbdim,lu(1),iasbi)
      iasai=(i-1)*nug_offset+nga_offset
      call multi_readir(ka(1,1,i),N*nadim,lu(1),iasai)
      enddo
         do i=3,noab
         jk=0
         do j=2,i-1
         ij=(i-1)*(i-2)/2+j
         ik=(i-1)*(i-2)/2
         do k=1,j-1
         jk=jk+1
         ik=ik+1
C  K_ba^ir x L_rc^jk
       call DGEMM_('N','N',nadim,cdim,N,one,ka(1,1,i),nadim,lc(1,jk),N,
     $                     zero,t3a,nadim)
C  K_ba^kr x L_rc^ij
       call DGEMM_('N','N',nadim,cdim,N,one,ka(1,1,k),nadim,lc(1,ij),N,
     $                     one,t3a,nadim)
C  -K_ba^jr x L_rc^ik
       call DGEMM_('N','N',nadim,cdim,N,-one,ka(1,1,j),nadim,lc(1,ik),N,
     $                     one,t3a,nadim)
C  -K_ca^ir x L_rb^jk   ! in the matrix as b,c,a
       call DGEMM_('T','T',bdim,ncdim,N,-one,lb(1,jk),N,kc(1,1,i),ncdim,
     $                     zero,t3b,bdim)
C  -K_ca^kr x L_rb^ij
       call DGEMM_('T','T',bdim,ncdim,N,-one,lb(1,ij),N,kc(1,1,k),ncdim,
     $                     one ,t3b,bdim)
C  K_ca^jr x L_rb^ik
       call DGEMM_('T','T',bdim,ncdim,N,one,lb(1,ik),N,kc(1,1,j),ncdim,
     $                     one ,t3b,bdim)
!!
         ac=1-bdim
         do a=1,adim
         ca=(a-1)*bdim+1-nadim
         do c=1,cdim
         ac=ac+bdim
         ca=ca+nadim
         call daxpy_(bdim,1.d0,t3a(ca),1,t3b(ac),1)
         enddo
         enddo
C  K_cb^ir x L_ra^jk   ! in the matrix as b,c,a
       call DGEMM_('N','N',nbdim,adim,N,one,kb(1,1,i),nbdim,la(1,jk),N,
     $                                  zero,t3a,nbdim)
C  K_cb^kr x L_ra^ij
       call DGEMM_('N','N',nbdim,adim,N,one,kb(1,1,k),nbdim,la(1,ij),N,
     $                                  one ,t3a,nbdim)
C  -K_cb^jr x L_ra^ik
       call DGEMM_('N','N',nbdim,adim,N,-one,kb(1,1,j),nbdim,la(1,ik),N,
     $                                  one ,t3a,nbdim)
         den=oeh(i)+oeh(j)+oeh(k)
         ac=1
         do a=1,adim
         ca=(a-1)*nbdim+1
         do c=1,cdim
         call daxpy_(bdim,1.d0,t3a(ca),cdim,t3b(ac),1)
         ac=ac+bdim
         ca=ca+1
         enddo
         enddo
         call dcopy_(cdim*bdim*adim,t3b,1,t3a,1)
          ac=0
         do a=1,adim
         dena=den-oepa(a)
         do c=1,cdim
         denc=dena-oepc(c)
         do b=1,bdim
         denb=denc-oepb(b)
         ac=ac+1
         t3b(ac)=t3b(ac)/denb
         enddo
         enddo
         enddo
         enx=enx+ddot_(cdim*bdim*adim,t3b,1,t3a,1)
         call ex23(t3b,t3a,bdim,cdim,adim,1)
C t3a  bac
C blok1   voa ka
         call DGEMM_('N','N',1,cdim,nadim, one,voa(1,ij),1,
     $  t3a,nadim,one,t1ac(k,1),noab)
         call DGEMM_('N','N',1,cdim,nadim, one,voa(1,jk),1,
     $  t3a,nadim,one,t1ac(i,1),noab)
         call DGEMM_('N','N',1,cdim,nadim,-one,voa(1,ik),1,
     $  t3a,nadim,one,t1ac(j,1),noab)
C blok 2 t3b bca
            call DGEMM_('N','T',1,bdim,ncdim,-one, voc(1,ij),1,
     $  t3b,bdim,one,t1ab(k,1),noab)
            call DGEMM_('N','T',1,bdim,ncdim,-one, voc(1,jk),1,
     $  t3b,bdim,one,t1ab(i,1),noab)
            call DGEMM_('N','T',1,bdim,ncdim,one,voc(1,ik),1,
     $  t3b,bdim,one,t1ab(j,1),noab)
            if(ifvo)then
             call DGEMM_('N','N',1,cdim,nadim, one,ka(1,i,j),1,
     $  t3a,nadim,one,t1bc(k,1),noab)
             call DGEMM_('N','N',1,cdim,nadim, one,ka(1,j,k),1,
     $  t3a,nadim,one,t1bc(i,1),noab)
             call DGEMM_('N','N',1,cdim,nadim,-one,ka(1,i,k),1,
     $  t3a,nadim,one,t1bc(j,1),noab)
            call DGEMM_('N','T',1,bdim,ncdim,-one, kc(1,i,j),1,
     $  t3b,bdim,one,t1bb(k,1),noab)
            call DGEMM_('N','T',1,bdim,ncdim,-one, kc(1,j,k),1,
     $  t3b,bdim,one,t1bb(i,1),noab)
            call DGEMM_('N','T',1,bdim,ncdim, one,kc(1,i,k),1,
     $  t3b,bdim,one,t1bb(j,1),noab)
             endif
C part 3 acb in t3b
            call transm(t3a,t3b,bdim,ncdim)
              call DGEMM_('N','T',1,adim,nbdim,one, vob(1,ij),1,
     $  t3b,adim,one,t1aa(k,1),noab)
               call DGEMM_('N','T',1,adim,nbdim,one, vob(1,jk),1,
     $  t3b,adim,one,t1aa(i,1),noab)
               call DGEMM_('N','T',1,adim,nbdim,-one,vob(1,ik),1,
     $  t3b,adim,one,t1aa(j,1),noab)
               if(ifvo)then
               call DGEMM_('N','T',1,adim,nbdim,one,  kb(1,i,j),1,
     $  t3b,adim,one,t1ba(k,1),noab)
               call DGEMM_('N','T',1,adim,nbdim,one,  kb(1,j,k),1,
     $  t3b,adim,one,t1ba(i,1),noab)
               call DGEMM_('N','T',1,adim,nbdim,-one, kb(1,i,k),1,
     $  t3b,adim,one,t1ba(j,1),noab)
               endif
         enddo !k
         enddo !j
         enddo !i
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real_array(mi)
        call Unused_real_array(mij)
        call Unused_integer(nuab)
      end if
      end

      subroutine t3_bt_acc(nug,ka,kb,kc,la,lc,mi,mij,adim,cdim,
     $N,noab,nuab,nnoab,lu,iasblock,nga,ngc,oeh,oepa,oepc,enx,voa,voc,
     $t1aa,t1ba,t1ac,t1bc,t3a,t3b,ifvo)
      implicit none
      real*8 one,zero,sumt3
      parameter (one=1.d0,zero=0.d0)
      logical ifvo
      integer nadim,adim,noab,nuab,i,j,k,nga,iasblock(3),lu(2),N
      integer ias,nga_offset,ngc_offset,nug_offset,jk,ij,ik,ncdim,cdim
      integer a,b,c,bc,abc,nug,nnoab,ngc,iasci,iasai
      real*8  ka(adim*cdim,N,*),kc(cdim*(cdim-1)/2,N,*),kb(*)
      real*8  t3a(cdim,cdim,*),t3b(*),t1ac(noab,*),t1bc(noab,*)
      real*8  lc(N*cdim,nnoab),la(N*adim,nnoab)
      real*8  mi(*),mij(*),voa(adim*cdim,*),voc(cdim*(cdim-1)/2,*)
      real*8  t1aa(noab,*),t1ba(noab,*),enx,oeh(noab),oepa(adim)
      real*8  oepc(cdim),den,dena,denb,denc,xx,yy
C
      sumt3=0.d0
      if(cdim.eq.1)return
      ncdim=cdim*(cdim-1)/2
      nadim=adim*cdim
      nug_offset=iasblock(1)*nug*(nug+1)/2
      ias=iasblock(2)*(nga-1)+1
      call multi_readir(la,nnoab*adim*N,lu(2),ias)
      ias=iasblock(2)*(ngc-1)+1
      call multi_readir(lc,nnoab*cdim*N,lu(2),ias)
C reads vvoo
      nga_offset=iasblock(3)*(nga*(nga-1)/2+ngc-1)+1
      ngc_offset=iasblock(3)*(ngc*(ngc-1)/2+ngc-1)+1
      ias=iasblock(2)*nug+nga_offset
      call multi_readir(voa,nnoab*nadim,lu(2),ias)
      ias=iasblock(2)*nug+ngc_offset
      call multi_readir(voc,nnoab*ncdim,lu(2),ias)
C
      nga_offset=iasblock(1)*(nga*(nga-1)/2+ngc-1)+1
      ngc_offset=iasblock(1)*(ngc*(ngc-1)/2+ngc-1)+1
      do i=1,noab
      iasci=(i-1)*nug_offset+ngc_offset
      call multi_readir(kc(1,1,i),N*ncdim,lu(1),iasci)
      iasai=(i-1)*nug_offset+nga_offset
      call multi_readir(ka(1,1,i),N*nadim,lu(1),iasai)
      enddo
      do i=3,noab
         jk=0
         do j=2,i-1
         ij=(i-1)*(i-2)/2+j
         ik=(i-1)*(i-2)/2
         do k=1,j-1
         jk=jk+1
         ik=ik+1
C  K_ab^ir x L_rc^jk   (stored as   c,b,a)
        call DGEMM_('T','T',cdim,nadim,N,one, lc(1,jk),N,
     $  ka(1,1,i),nadim,zero,t3a,cdim)
C  K_ab^kr x L_rc^ij
        call DGEMM_('T','T',cdim,nadim,N,one, lc(1,ij),N,ka(1,1,k),
     $              nadim,one,t3a,cdim)
C  -K_ab^jr x L_rc^ik
        call DGEMM_('T','T',cdim,nadim,N,-one,lc(1,ik),N,ka(1,1,j),
     $              nadim,one,t3a,cdim)
C
C  K_bc^ir x L_ra^jk
        call DGEMM_('N','N',ncdim,adim,N,one,kc(1,1,i),ncdim,la(1,jk),N,
     $                     zero,t3b,ncdim)
C  K_bc^kr x L_ra^ij
        call DGEMM_('N','N',ncdim,adim,N,one,kc(1,1,k),ncdim,la(1,ij),N,
     $                     one,t3b,ncdim)
C  -K_bc^jr x L_ra^ik
        call DGEMM_('N','N',ncdim,adim,N,-one,kc(1,1,j),ncdim,
     &        la(1,ik),N,
     $                     one,t3b,ncdim)
!!
         den=oeh(i)+oeh(j)+oeh(k)
         abc=0
         do a=1,adim
      dena=den-oepa(a)
       bc=0
      do b=2,cdim
      denb=dena-oepc(b)
      do c=1,b-1
      denc=denb-oepc(c)
      bc=bc+1
      abc=abc+1
      xx=t3b(abc)-t3a(b,c,a)+t3a(c,b,a)
      yy=xx/denc
      t3b(abc)=yy
      sumt3=sumt3+xx
      enx=enx+yy*xx
      enddo
      enddo
      enddo
      call expa1_uhf(t3b,adim,cdim,-1,t3a)
C t3a  bac
C blok1   voa ka
            call DGEMM_('N','T',1,cdim,nadim,-one,voa(1,ij),1,
     $  t3a,cdim,one,t1ac(k,1),noab)
            call DGEMM_('N','T',1,cdim,nadim,-one,voa(1,jk),1,
     $  t3a,cdim,one,t1ac(i,1),noab)
            call DGEMM_('N','T',1,cdim,nadim, one,voa(1,ik),1,
     $  t3a,cdim,one,t1ac(j,1),noab)
C blok 2 t3b bca
            call DGEMM_('N','N',1,adim,ncdim,one, voc(1,ij),1,
     $  t3b,ncdim,one,t1aa(k,1),noab)
            call DGEMM_('N','N',1,adim,ncdim,one, voc(1,jk),1,
     $  t3b,ncdim,one,t1aa(i,1),noab)
            call DGEMM_('N','N',1,adim,ncdim,-one,voc(1,ik),1,
     $  t3b,ncdim,one,t1aa(j,1),noab)
            if(ifvo)then
            call DGEMM_('N','T',1,cdim,nadim,-one,ka(1,i,j),1,
     $  t3a,cdim,one,t1bc(k,1),noab)
            call DGEMM_('N','T',1,cdim,nadim,-one,ka(1,j,k),1,
     $  t3a,cdim,one,t1bc(i,1),noab)
            call DGEMM_('N','T',1,cdim,nadim, one,ka(1,i,k),1,
     $  t3a,cdim,one,t1bc(j,1),noab)
            call DGEMM_('N','N',1,adim,ncdim,one, kc(1,i,j),1,
     $  t3b,ncdim,one,t1ba(k,1),noab)
            call DGEMM_('N','N',1,adim,ncdim,one, kc(1,j,k),1,
     $  t3b,ncdim,one,t1ba(i,1),noab)
            call DGEMM_('N','N',1,adim,ncdim,-one,kc(1,i,k),1,
     $  t3b,ncdim,one,t1ba(j,1),noab)
            endif
         enddo !k
         enddo !j
         enddo !i
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real_array(kb)
        call Unused_real_array(mi)
        call Unused_real_array(mij)
        call Unused_integer(nuab)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Move_EC(rMP,EC,lMax,nij,nElem,Coor,nAtoms,Q_Nuc,C_o_C,nPert,Bond_Threshold,iANr,T_Values,iT_Sets,iWarnings, &
                   Num_Warnings,Opt_Method,iPlot)

use stdalloc, only: mma_allocate, mma_deallocate
use Real_Spherical, only: Sphere, Sphere_Free
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lMax, nij, nElem, nAtoms, nPert, iANr(nAtoms), iPlot
real(kind=wp), intent(inout) :: rMP(nij,0:nElem-1,0:nPert-1), EC(3,nij)
real(kind=wp), intent(in) :: Coor(3,nAtoms), Q_Nuc(nAtoms), C_o_C(3), Bond_Threshold
real(kind=wp), intent(out) :: T_Values(nij)
integer(kind=iwp), intent(inout) :: iT_Sets(nij), Num_Warnings
integer(kind=iwp), intent(out) :: iWarnings(nij)
character(len=12) :: Opt_Method
integer(kind=iwp) :: iAtom, ii, ij, iPert, jAtom, jj
real(kind=wp) :: CX(3), Dipole_Rot_A, Dipole_Rot_B, Dipole_Rot_AB, R_A, R_B
logical(kind=iwp) :: Bond_OK, Check_Bond
real(kind=wp), allocatable :: A(:,:), B(:,:), Scratch_New(:), Scratch_Org(:), xnrMP(:,:), xrMP(:,:), xxrMP(:,:)

call Sphere(lMax)

call mma_allocate(B,3,nij,label='B')
call mma_allocate(xnrMP,nij,nElem,label='xnrMP')

B(:,:) = Zero

xnrMP(:,:) = Zero
ij = 0
do iAtom=1,nAtoms
  do jAtom=1,iAtom
    ij = ij+1
    if (iAtom == jAtom) then
      xnrMP(ij,1) = Q_nuc(iAtom)
      CX(1) = Coor(1,iAtom)
      CX(2) = Coor(2,iAtom)
      CX(3) = Coor(3,iAtom)
      call ReExpand(xnrMP,nij,nElem,CX,C_o_C,ij,lMax)
    end if
  end do
end do

call mma_allocate(A,3,nij,label='A')
call mma_allocate(xrMP,nij,nElem,label='xrMP')
call mma_allocate(xxrMP,nij,nElem,label='xxrMP')
call mma_allocate(Scratch_Org,nij*(2+lMax+1),label='Scratch_Org')
call mma_allocate(Scratch_New,nij*(2+lMax+1),label='Scratch_New')

do iAtom=1,nAtoms
  ii = iAtom*(iAtom+1)/2
  do jAtom=iAtom,1,-1
    jj = jAtom*(jAtom+1)/2
    ij = iAtom*(iAtom-1)/2+jAtom
    A(:,:) = EC(:,:)

    if (iAtom == jAtom) then
      ! Atomic domain
      ! Do nothing for now - put appropriate expresion in later.
      iT_sets(ij) = 1
      T_values(ij) = Zero
      B(:,ij) = EC(:,ij)
      !?? end if
    else
      ! Bond domain
      !
      ! Check whether bond is too long - if so skip it.

      Bond_OK = Check_Bond(EC(:,ii),EC(:,jj),iANr(iAtom),iANr(jAtom),Bond_Threshold)
      if (.not. Bond_OK) then
        T_values(ij) = Zero
        B(:,ij) = EC(:,ij)
      else

        ! Bond is real bond - proceed

        iT_sets(ij) = 1
        if (Opt_Method(1:9) == 'Multipole') then
          call Rotate_Dipole(rMP,EC,nij,nElem,nPert,ij,ii,jj,Dipole_Rot_A,Dipole_Rot_B,Dipole_Rot_AB,R_A,R_B)

          call Find_Dipole_Center(rMP(ii,0,0),rMP(jj,0,0),Dipole_Rot_A,Dipole_Rot_B,xnrMP(ii,1),xnrMP(jj,1),R_A,R_B,T_Values(ij), &
                                  iPlot)

          B(:,ij) = EC(:,ij)+T_Values(ij)*(EC(:,jj)-EC(:,ii))
        else
          call Min_Mult_Error(EC,A,B,EC(:,ii),EC(:,jj),rMP,xrMP,xxrMP,xnrMP,lMax,nij,nElem,iAtom,jAtom,nAtoms,nPert,C_o_C, &
                              Scratch_New,Scratch_Org,iPlot,T_Values(ij),iWarnings(ij),Num_Warnings)
        end if
      end if

    end if
  end do
end do

call mma_deallocate(A)
call mma_deallocate(xrMP)
call mma_deallocate(xxrMP)
call mma_deallocate(xnrMP)
call mma_deallocate(Scratch_Org)
call mma_deallocate(Scratch_New)

do ij=1,nij
  do iPert=0,nPert-1
    call ReExpand(rMP(:,:,iPert),nij,nElem,EC(:,ij),B(:,ij),ij,lMax)
  end do
end do
EC(:,:) = B(:,:)

call mma_deallocate(B)

call Sphere_Free()

return

end subroutine Move_EC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Merge_Lists(Mode,nAt)
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
      Character*1 Mode
      Logical Found
      Real*8, Dimension(:,:), Allocatable :: rList
      Integer, Dimension(:,:), Allocatable :: iList
*                                                                      *
************************************************************************
*                                                                      *
*     Get the sizes of the arrays on the runfile. Same size for both
*     files.
*
      Call qpg_iArray('Slapaf Info 1',Found,n1)
      Call qpg_dArray('Slapaf Info 2',Found,n2)
*                                                                      *
************************************************************************
*                                                                      *
*     Loop over both files and pick up the fields and pick up pointers,
*     and interations counts.
*
      ip_Dummy=-1
      i_R  = 0
      ipEner_R= ip_Dummy
      ipCx_R  = ip_Dummy
      ipGx_R  = ip_Dummy
      i_P  = 0
      ipEner_P= ip_Dummy
      ipCx_P  = ip_Dummy
      ipGx_P  = ip_Dummy
*
      Call mma_allocate(iList,n1,2,label='iList')
      Call mma_allocate(rList,n2,2,label='rList')
      Call NameRun('RUNREAC')
      Call Get_iArray('Slapaf Info 1',iList(1,1),n1)
      Call Get_dArray('Slapaf Info 2',rList(1,1),n2)
      i_R=1
      iter_R  =     iList(2,1)
      ipEner_R= 1 + iList(5,1)
      ipCx_R  = 1 + iList(6,1)
      ipGx_R  = 1 + iList(7,1)
      Call NameRun('RUNPROD')
      Call Get_iArray('Slapaf Info 1',iList(1,2),n1)
      Call Get_dArray('Slapaf Info 2',rList(1,2),n2)
      i_P=2
      iter_P  =     iList(2,2)
      ipEner_P= 1 + iList(5,2)
      ipCx_P  = 1 + iList(6,2)
      ipGx_P  = 1 + iList(7,2)
*                                                                      *
************************************************************************
*                                                                      *
*     Translate into generic variables, _1=from, _2=to.

      If (Mode.eq.'R') Then
         i_1 = i_P
         iter_1=iter_P
         ipEner_1=ipEner_P
         ipCx_1=ipCx_P
         ipGx_1=ipGx_P
*
         i_2 = i_R
         iter_2=iter_R
         ipEner_2=ipEner_R
         ipCx_2=ipCx_R
         ipGx_2=ipGx_R
      Else
         i_1 = i_R
         iter_1=iter_R
         ipEner_1=ipEner_R
         ipCx_1=ipCx_R
         ipGx_1=ipGx_R
*
         i_2 = i_P
         iter_2=iter_P
         ipEner_2=ipEner_P
         ipCx_2=ipCx_P
         ipGx_2=ipGx_P
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Start moving stuff around
*
*     Update iteration counter
*
      iter_3=iter_2+1
      iList(2,i_2)=iter_3
      iOff_1=(iter_1-1)*3*nAt
      iOff_2=(iter_2-1)*3*nAt
      iOff_3=(iter_3-1)*3*nAt
*
*     Move the last item(s) in the "to" file up one step.
*
      rList(ipEner_2+iter_3-1,i_2)=rList(ipEner_2+iter_2-1,i_2)
      call dcopy_(3*nAt,rList(ipCx_2+iOff_2,i_2),1,
     &                  rlist(ipCx_2+iOff_3,i_2),1)
      call dcopy_(3*nAt,rList(ipGx_2+iOff_2,i_2),1,
     &                  rlist(ipGx_2+iOff_3,i_2),1)
*
*     Copy the last item(s) in the "from" file into the
*     second last position of the "to" file.
*
      rList(ipEner_2+iter_2-1,i_2)=rList(ipEner_1+iter_1-1,i_1)
      call dcopy_(3*nAt,rList(ipCx_1+iOff_1,i_1),1,
     &                  rlist(ipCx_2+iOff_2,i_2),1)
      call dcopy_(3*nAt,rList(ipGx_1+iOff_1,i_1),1,
     &                  rlist(ipGx_2+iOff_2,i_2),1)
*                                                                      *
************************************************************************
*                                                                      *
*     Write out the stuff on the appropriate run file.
*
      If (Mode.eq.'R') Then
         Call NameRun('RUNREAC')
      Else
         Call NameRun('RUNPROD')
      End If
*
      Call Put_iArray('Slapaf Info 1',iList(1,i_2),n1)
      Call Put_dArray('Slapaf Info 2',rList(1,i_2),n2)
      Call qpg_iScalar('iOff_Iter',Found)
      If (Found) Then
         Call Get_iScalar('iOff_Iter',iOff_Iter)
         Call Put_iScalar('iOff_Iter',iOff_Iter+1)
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
*     Deallocate the memory allocations.
*
      Call mma_deallocate(rList)
      Call mma_deallocate(iList)
*                                                                      *
************************************************************************
*                                                                      *
*     Open the default run file.
*
      Call NameRun('RUNFILE')
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_SetShP2Q_2(irc,iLoc,iShlAB,nAB)
!
! Purpose: set mapping from shell pair iShlAB to qualified
!          columns within current reduced set (stored at location
!          iLoc = 2 or 3).
!          If a non-zero code (irc) is returned, nothing has been
!          set!!

use Index_Functions, only: nTri_Elem
use Cholesky, only: IndRed, IndRSh, iQuAB, iShP2Q, iSP2F, nBstSh, nQual, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc, nAB(nSym)
integer(kind=iwp), intent(in) :: iLoc, iShlAB
integer(kind=iwp) :: iAB, iQ, iShlA, iShlB, iSym, jAB, kAB, kShlAB, l_iShP2Q, lTst, NumAB

! Check allocations.
! ------------------

call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.true.)
if (iShlA == iShlB) then
  NumAB = nTri_Elem(nBstSh(iShlA))
else
  NumAB = nBstSh(iShlA)*nBstSh(iShlB)
end if
lTst = 2*NumAB
l_iShP2Q = 0
if (allocated(iShP2Q)) l_iShP2Q = size(iShP2Q)
if ((l_iShP2Q < 1) .or. (l_iShP2Q < lTst)) then
  irc = 102
  return
end if

! Check iLoc.
! -----------

if ((iLoc < 2) .or. (iLoc > 3)) then
  irc = 104
  return
end if

! Set mapping array.
! iShP2Q(1,AB) = index among qualified, symmetry reduced.
! iShP2Q(2,AB) = symmetry block.
! Zeros are returned if the element AB is not qualified.
! -------------------------------------------------------

iShP2Q(:,1:NumAB) = 0
nAB(:) = 0

do iSym=1,nSym
  do iQ=1,nQual(iSym)
    iAB = iQuAB(iQ,iSym) ! addr in curr. red. set
    jAB = IndRed(iAB,iLoc)  ! addr in 1st red. set
    kShlAB = IndRSh(jAB)  ! shell pair (full)
    if (kShlAB == iSP2F(iShlAB)) then
      kAB = IndRed(jAB,1) ! addr in full shell pair
      iShP2Q(1,kAB) = iQ
      iShP2Q(2,kAB) = iSym
      nAB(iSym) = nAB(iSym)+1
    end if
  end do
end do

! Set return code 0: all ok!
! --------------------------

irc = 0

end subroutine Cho_SetShP2Q_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SubRoutine ChoMP2_rhslagr_1(EOcc,EVir,EFro,EDel,Xaibj,
     &                            LnPQRSprod,LiPQRSprod,iBatch,jBatch,
     &                            nOccLeftI,nOccLeftJ,
     &                            nOrbLeftI,nOrbLeftJ,
     &                            nFroLeftI,nFroLeftJ)
*     This will calculate the righthandside of the mp2lagrangian.
*
#include "implicit.fh"
      Real*8 EOcc(*), EVir(*),EFro(*),EDel(*), Xaibj(LnPQRSprod)
      Integer LiPQRSprod(8)
      Integer nOccLeftI(8),nOccLeftJ(8)
      Integer nOrbLeftI(8),nOrbLeftJ(8)
      Integer nFroLeftI(8),nFroLeftJ(8)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"
#include "WrkSpc.fh"
*
      Character*10  ThisNm
      Character*17 SecNam
      Parameter (SecNam = 'ChoMP2_rhslagr_1', ThisNm = 'rhslagr_1')
*
      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
      iDensVir(i,j,k) = ip_Density(k) +
     &                         nFro(k) + nOcc(k) +  j-1 +
     &                        (nOrb(k) + nDel(k))*
     &                        (i + nFro(k) + nOcc(k) -1)
      iWDensVir(i,j,k) = ip_WDensity(k) +
     &                         nFro(k) + nOcc(k) + j-1
     &                      + (nOrb(k) + nDel(k))
     &                      * (i + nFro(k) + nOcc(k) - 1)
      iDensVirFro(i,j,k) = ip_Density(k) +
     &                         nFro(k) + nOcc(k) + nVir(k) + j-1 +
     &                        (nOrb(k) + nDel(k))*
     &                        (i + nFro(k) + nOcc(k) -1)
      iWDensVirFro(i,j,k) = ip_WDensity(k) +
     &                         nFro(k) + nOcc(k) + nVir(k) + j-1 +
     &                        (nOrb(k) + nDel(k))*
     &                        (i + nFro(k) + nOcc(k) -1)
      iDensFroVir(i,j,k) = ip_Density(k) +
     &                         nFro(k) + nOcc(k) + j-1 +
     &                        (nOrb(k) + nDel(k))
     &                      * (i + nFro(k) + nOcc(k) + nVir(k) - 1)
      iWDensOcc(i,j,k) = ip_WDensity(k)
     &                    +  j + nFro(k) -1
     &                    + (nOrb(k) + nDel(k))
     &                    * (i + nFro(k) -1)
      iWDensOccFro(i,j,k) = ip_WDensity(k)
     &                    +  j-1
     &                    + (nOrb(k) + nDel(k))
     &                    * (i + nFro(k) -1)

      iDensOcc(i,j,k) = ip_Density(k) +
     &                        nFro(k) + j-1 + (nOrb(k)+nDel(k))
     &                                      * (i + nFro(k)-1)
      iDensFroOcc(i,j,k) = ip_Density(k) +
     &                            j-1 + nFro(k) + (nOrb(k)+nDel(k))
     &                                * (i-1)
      iDensOccFro(i,j,k) = ip_Density(k) +
     &                            j-1 + (nOrb(k)+nDel(k))
     &                                * (i + nFro(k) -1)
      iMp2Lagr(i,j,k) = ip_Mp2Lagr(k) +
     &                          j-1 + (nOcc(k)+nFro(k))*(i-1)
      iWDensVactOcc(i,j,k) = ip_WDensity(k) +
     &                           j-1
     &                        + (nOrb(k) + nDel(k))
     &                        * (i + nFro(k) + nOcc(k) - 1)
      iFirstS(i,j)=iWork(ip_FirstS-1+nSym*(j-1)+i)
      LnBatOrb(i,j)=iWork(ip_LnBatOrb-1+nSym*(j-1)+i)
      LiPQprod(i,j,k) = iWork(ip_LiPQprod-1+
     &                        nSym*nSym*(k-1)+nSym*(j-1)+i)
      LnPQprod(i,j)=iWork(ip_LnPQprod-1+nSym*(j-1)+i)
*
      Do iSymBJ = 1,nSym
         iSymAI = iSymBJ
         iSymCI = iSymBJ
         iSymKB = iSymBJ
         iSymKI = iSymAI
********************************************************************
****   Common code for Pab, Wab, Lagr(3) and PaB
********************************************************************
         Do iSymJ = 1,nSym
            iSymB = MulD2h(iSymJ,iSymBJ)
            LjOrb = Min(LnBatOrb(iSymJ,jBatch)-nFroLeftJ(iSymJ),
     &                  nOccLeftJ(iSymJ)-nFroLeftJ(iSymJ))
            Do Lj = 1, LjOrb
               If(nFroLeftJ(iSymJ) .gt. 0) Then
                  iJ = Lj
               Else
                  iJ = iFirstS(iSymJ,jBatch) + Lj - nFro(iSymJ) - 1
               End If
               Do iB = 1,nVir(iSymB)
                  Lbj = LiPQprod(iSymB,iSymJ,jBatch)
     &                + (nFro(iSymB) + nOcc(iSymB)
     &                +  nVir(iSymB) + nDel(iSymB))
     &                * (Lj + nFroLeftJ(iSymJ) -1)
     &                + iB + nFro(iSymB) + nOcc(iSymB)
                  Do iSymI = 1 , nSym
                     iSymA = MulD2h(iSymI,iSymAI)
                     iSymAJ = MulD2h(iSymA,iSymJ)
                     iSymBI = iSymAJ
                     iSymKJ = iSymBI
                     iSymP = iSymA
                     LiOrb = min(LnBatOrb(iSymI,iBatch)
     &                     - nFroLeftI(iSymI),
     &                       nOccleftI(iSymI)-nFroLeftI(iSymI))
                      Do Li = 1, LiOrb
                        If(nFroLeftI(iSymI) .gt. 0) Then
                           iI = Li
                        Else
                           iI  = iFirstS(iSymI,iBatch) - nFro(iSymI)
     &                      + Li - 1
                        End If
                        Lbi = LiPQprod(iSymB,iSymI,iBatch)
     &                      + (nFro(iSymB) + nOcc(iSymB)
     &                      +  nVir(iSymB) + nDel(iSymB))
     &                      * (Li + nFroLeftI(iSymI)-1)
     &                      + iB + nFro(iSymB) + nOcc(iSymB)
                        Do iA = 1, nVir(iSymA)
                           Lai = LiPQprod(iSymA,iSymI,iBatch)
     &                         + (nOcc(iSymA) + nVir(iSymA)
     &                         +  nFro(iSymA) + nDel(iSymA))
     &                         * (Li + nFroLeftI(iSymI) - 1)
     &                         + iA + nFro(iSymA) + nOcc(iSymA)
                           Laj = LiPQprod(iSymA,iSymJ,jBatch)
     &                         + (nOcc(iSymA) + nVir(iSymA)
     &                         +  nFro(iSymA) + nDel(iSymA))
     &                         * (Lj + nFroLeftJ(iSymJ) - 1)
     &                         + iA + nFro(iSymA) + nOcc(iSymA)
*
*     Construct the T_iajb (common for all terms)
*
                           Dnom1 = EOcc(iOcc(iSymI) + iI)
     &                              - EVir(iVir(iSymA) + iA)
     &                              + EOcc(iOcc(iSymJ) + iJ)
     &                              - EVir(iVir(iSymB) + iB)
                           If(iBatch.eq.jBatch) Then
                              ip_iajb = LiPQRSprod(iSymAI)
     &                                + iTri(Lai,Lbj)
                              ip_ibja = LiPQRSprod(iSymBI)
     &                                + iTri(Lbi,Laj)
                           Else
                              ip_iajb = LiPQRSprod(iSymAI)
     &                                + LnPQprod(iSymAI,iBatch)
     &                                * (Lbj-1) + Lai
                              ip_ibja = LiPQRSprod(iSymBI)
     &                                + LnPQprod(iSymBI,iBatch)
     &                                * (Laj-1) + Lbi
                              End If
                              T1 = 4.0d0*Xaibj(ip_iajb)
                              T1 = (T1 - 2.0d0*Xaibj(ip_ibja))
     &                           / Dnom1
*     Here we calculate the MP2-energy
                              EMP2_Dens = EMP2_Dens
     &                                  + 0.5d0*T1*Xaibj(ip_iajb)
                           Do iP = 1, nOrb(iSymP) + nDel(iSymP)
                              Lpi = LiPQprod(iSymP,iSymI,iBatch)
     &                            + (nOcc(iSymP) + nVir(iSymP)
     &                            +  nFro(iSymP) + nDel(iSymP))
     &                            * (Li + nFroLeftI(iSymI) - 1) + iP
                              Lpj =  LiPQprod(iSymP,iSymJ,jBatch)
     &                            + (nOcc(iSymP) + nVir(iSymP)
     &                            +  nFro(iSymP) + nDel(iSymP))
     &                            * (Lj + nFroLeftJ(iSymJ) - 1) + iP
                              If(iBatch.eq.jBatch) Then
                                 ip_ipjb = LiPQRSprod(iSymBJ)
     &                                   + iTri(Lpi,Lbj)
                                 ip_jpib = 0
                              Else
                                 ip_ipjb = LiPQRSprod(iSymBJ)
     &                                   + LnPQprod(iSymBJ,iBatch)
     &                                   * (Lbj-1) + Lpi
                                 ip_jpib = LiPQRSprod(iSymBI)
     &                                   + LnPQprod(iSymBI,iBatch)
     &                                   * (Lpj-1) + Lbi
                              End If
                              X2 = Xaibj(ip_ipjb)
*******************************************************************
*        Calculate P_Ca frozen virtual - active virtual
*******************************************************************
                              If(iP.gt. nFro(iSymP) + nOcc(iSymP)
     &                                + nVir(iSymP)) Then
                                 iCFroz = iP - nFro(iSymP) - nOcc(iSymP)
     &                                  - nVir(iSymP)
                                 Dnom2 = EVir(iVir(iSymA) + iA) -
     &                                   EDel(iDel(iSymP) + iCFroz)
                                 Work(iDensVirFro(iA,iCFroz,iSymP)) =
     &                                Work(iDensVirFro(iA,iCFroz,iSymP))
     &                                + T1*X2/Dnom2
                                 Work(iDensFroVir(iCFroz,iA,iSymA)) =
     &                                Work(iDensFroVir(iCFroz,iA,iSymA))
     &                                + T1*X2/Dnom2
                                 Work(iWDensVirFro(iA,iCFroz,iSymP)) =
     &                               Work(iWDensVirFro(iA,iCFroz,iSymP))
     &                               - 2.0d0 * T1*X2
***************** The 2 ON THE ROW ABOVE IS QUESTIONABLE *****'''' ***
*                 Write(6,*) 'index Dens', iDensFroVir(iCFroz,iA,iSymA) -
*     &                                    ip_Density(iSymA)
*                 Write(6,*) 'Value', Work(iDensFroVir(iCFroz,iA,iSymA))
*     &                                + 2.0d0 * T1*X2/Dnom2
*                        Write(6,*) 'xicjb', X2
*                        Write(6,*) 'EDiffbc',Dnom2
*                        Write(6,*) 'E_a', EVir(iVir(iSymA) + iA)
*                        Write(6,*) 'E:B', EDel(iDel(iSymP) + iCFroz)
*                        Write(6,*) 'Tij', T1
*                        Write(6,*) 'iB, iC',
*     &                             iCFroz+nOcc(iSymP) -nFro(iSymP), iB
*                        Write(6,*) 'iI, iJ', iI, iJ
*******************************************************************
*         Calculate P_ab active vir - active vir
*******************************************************************
                              Else If(iP .gt. nFro(iSymP) + nOcc(iSymP))
     &                             Then
                                 iC = iP - nFro(iSymP) - nOcc(iSymP)
                                 Dnom2 = + EOcc(iOcc(iSymI) + iI)
     &                                   - EVir(iVir(iSymP) + iC)
     &                                   + EOcc(iOcc(iSymJ) + iJ)
     &                                   - EVir(iVir(iSymB) + iB)
                                 Work(iDensVir(iA,iC,iSymP)) =
     &                                Work(iDensVir(iA,iC,iSymP))
     &                                + T1*X2/Dnom2
                                 Work(iWDensVir(iA,iC,iSymP)) =
     &                                Work(iWDensVir(iA,iC,iSymP))
     &                                - 2.0d0 * T1*X2
*******************************************************************
*        Calculate Lagr(3)_ai  active virtual - all occupied
*******************************************************************
                              Else
                                 iK = iP
                                Work(iMp2Lagr(iA,iK,iSymP))=
     &                                Work(iMp2Lagr(iA,iK,iSymP))
     &                                   - T1*X2
                                Work(iWDensVactOcc(iA,iK,iSymP)) =
     &                               Work(iWDensVactOcc(iA,iK,iSymP))
     &                               - 4.0d0 * T1*X2
                              End If
*
* ------------------------- Debugging comments --------------------------
*                              If(iP.gt. nFro(iSymP) + nOcc(iSymP)
*     &                             .and. (ip .le. nFro(iSymP) +
*     &                              nOcc(iSymP) + nVir(iSymP))) Then
*                                 Write(6,*) 'AIBJC',iA,iI,iB,iJ,iC
*                                 Write(6,*) 'Symm',iSymA,iSymI,iSymB,
*     &                                             iSymJ,iSymP
*                                 Write(6,*) 'Dnom1', Dnom1
*                                Write(6,*) 'Dnom2', Dnom2
*                                 Write(6,*) 'iajb', Xaibj(ip_iajb)
*                                 Write(6,*) 'ibja', Xaibj(ip_ibja)
*                                 Write(6,*) 'icjb', Xaibj(ip_ipjb)
*                                 Write(6,*) 'Bidrag T',T1*X2/dnom2
*                              Write(6,*) 'adress',iDensVir(iA,iC,iSymP)-
*     &                                    ip_Density(1)
*                              End If
*-------------------------------------------------------------------------
* ------------------------- Debugging comments --------------------------
*                              If(iP .le. nFro(iSymP) + nOcc(iSymP)) Then
*                                 Write(6,*) 'AIBJK',iA,iI,iB,iJ,iK
*                                 Write(6,*) 'Symm',iSymA,iSymI,iSymB,
*     &                                             iSymJ,iSymP
*                                 Write(6,*) 'Dnom2', Dnom2
*                                 Write(6,*) 'iajb', Xaibj(ip_iajb)
*                                 Write(6,*) 'ibja', Xaibj(ip_ibja)
*                                 Write(6,*) 'ibjk', Xaibj(ip_ipjb)
*                                 If(iBatch.ne.jBatch) Then
*                                    Write(6,*) 'ikjb', Xaibj(ip_jpib)
*                                  Write(6,*) 'Bidrag U',U1*U2
*                                 EndIf
*                                 Write(6,*) 'Bidrag T', T1*T2
*                                 Write(6,*) 'adress',
*     &                                      iMp2Lagr(iA,iK,iSymP)-
*     &                                               ip_Mp2Lagr(1)
*                              End If
* ------------------------------------------------------------------------
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do

***************************************************************************
****  Common code for Pij, Wij(I), Lagr(4) and PiJ
***************************************************************************
*
*     To avoid compiler warnings
*         iKfroz = 0
*         iK = 0

         Do iSymA = 1, nSym
            iSymI = MulD2h(iSymA,iSymAI)
            LaOrb = Min(LnBatOrb(iSymA,iBatch)-nOccLeftI(iSymA),
     &                  nOrbLeftI(iSymA)-nOccLeftI(iSymA))
             Do La = 1, LaOrb
               If(nOccLeftI(iSymA).gt.0) Then
                  iA = La
               Else
                  iA = iFirstS(iSymA,iBatch) - nFro(iSymA) - nOcc(iSymA)
     &               + La-1
               End If
               Do iI = 1, nOcc(iSymI)
                  Lai = LiPQprod(iSymI,iSymA,iBatch)
     &                + (nOcc(iSymI) + nVir(iSymI)
     &                +  nFro(iSymI) + nDel(iSymI))
     &                * (La + nOccLeftI(iSymA)-1)
     &                + iI + nFro(iSymI)
                  Do iSymJ = 1, nSym
                     iSymB = MulD2h(iSymJ,iSymBJ)
                     iSymAJ = MulD2h(iSymA,iSymJ)
                     iSymBI = iSymAJ
                     iSymP = iSymJ
                     LbOrb = Min(LnBatOrb(iSymB,jBatch)
     &                     - nOccLeftJ(iSymB),
     &                       nOrbLeftJ(iSymB)-nOccLeftJ(iSymB))
                     Do Lb = 1, LbOrb
                        If(nOccLeftJ(iSymB).gt.0) Then
                           iB = Lb
                        Else
                           iB = iFirstS(iSymB,jBatch)
     &                        - nFro(iSymB) - nOcc(iSymB) + Lb-1
                        End If
                        Lbi = LiPQprod(iSymI,iSymB,jBatch)
     &                      + (nOcc(iSymI) + nVir(iSymI)
     &                      +  nFro(iSymI) + nDel(iSymI))
     &                      * (Lb+nOccLeftJ(iSymB)-1)
     &                      + iI + nFro(iSymI)
                        Do iJ = 1, nOcc(iSymJ)
                           Lbj = LiPQprod(iSymJ,iSymB,jBatch)
     &                         + (nOcc(iSymJ) + nVir(iSymJ)
     &                         +  nFro(iSymJ) + nDel(iSymJ))
     &                         * (Lb+nOccLeftJ(iSymB)-1)
     &                         + iJ + nFro(iSymJ)
                           Laj = LiPQprod(iSymJ,iSymA,iBatch)
     &                         + (nOcc(iSymJ) + nVir(iSymJ)
     &                         +  nFro(iSymJ) + nDel(iSymJ))
     &                         * (La+nOccLeftI(iSymA)-1)
     &                         + iJ + nFro(iSymJ)
                           Dnom1 = EOcc(iOcc(iSymI) + iI)
     &                           - EVir(iVir(iSymA) + iA)
     &                           + EOcc(iOcc(iSymJ) + iJ)
     &                           - EVir(iVir(iSymB) + iB)
                           If(iBatch.eq.jBatch) Then
                              ip_iajb = LiPQRSprod(iSymAI)
     &                                + iTri(Lai,Lbj)
                              ip_ibja = LiPQRSprod(iSymBI)
     &                                + iTri(Lbi,Laj)
                           Else
                              ip_iajb = LiPQRSprod(iSymAI)
     &                                + LnPQprod(iSymAI,iBatch)
     &                                * (Lbj-1) + Lai
                              ip_ibja = LiPQRSprod(iSymBI)
     &                                + LnPQprod(iSymBI,iBatch)
     &                                * (Lbi-1) + Laj
                           End If
                           T1 = 4.0D0*Xaibj(ip_iajb)
                           T1 = (T1-2.0D0*Xaibj(ip_ibja))
     &                            / Dnom1
                           Do iP = 1, nOrb(iSymP) + nDel(iSymP)
*
                              Lbp = LiPQprod(iSymP,iSymB,jBatch)
     &                            + (nOcc(iSymP) + nVir(iSymP)
     &                            +  nFro(iSymP) + nDel(iSymP))
     &                            * (Lb+nOccLeftJ(iSymB)-1)
     &                            + iP
                              Lap = LiPQprod(iSymP,iSymA,iBatch)
     &                            + (nOcc(iSymP) + nVir(iSymP)
     &                            +  nFro(iSymP) + nDel(iSymP))
     &                            * (La+nOccLeftI(iSymA)-1)
     &                            + iP
                              If(iBatch.eq.jBatch) Then
                                 ip_iapb = LiPQRSprod(iSymAI)
     &                                   + iTri(Lai,Lbp)
                              Else
                                 ip_iapb = LiPQRSprod(iSymAI)
     &                                   + LnPQprod(iSymAI,iBatch)
     &                                   * (Lbp-1) + Lai
                              End If
*
                              X2 = Xaibj(ip_iapb)
*******************************************************************
*        Calculate P_Pj frozen occupied - active occupied
*******************************************************************
                              If(ip .le. nFro(iSymP)) Then
                                 iKFroz = iP
                                 Dnom2 = EOcc(iOcc(iSymI) + iI)
     &                                 - EFro(iFro(iSymP) + iKFroz)
                                 Work(iDensFroOcc(iKFroz, iJ,iSymJ)) =
     &                             Work(iDensFroOcc(iKFroz,iJ,iSymJ))
     &                             + T1*X2/Dnom2
                                 Work(iDensOccFro(iJ,iKFroz,iSymJ)) =
     &                             Work(iDensOccFro(iJ,iKFroz,iSymJ))
     &                             + T1*X2/Dnom2
                                 Work(iWDensOccFro(iJ,iKFroz,iSymP)) =
     &                             Work(iWDensOccFro(iJ,iKFroz,iSymP))
     &                             - 2.0d0 * T1*X2
*******************************************************************
*         Calculate P_ij active occ - active occ
*******************************************************************
                              Else If(iP .le. nFro(iSymP)
     &                                      + nOcc(iSymP)) Then
                                 iK = iP - nFro(iSymP)
                                 Dnom2 = EOcc(iOcc(iSymI) + iI)
     &                                  - EVir(iVir(iSymA) + iA)
     &                                  + EOcc(iOcc(iSymP) + iK)
     &                                  - EVir(iVir(iSymB) + iB)
                                 Work(iDensOcc(iJ,iK,iSymP)) =
     &                                Work(iDensOcc(iJ,iK,iSymP))
     &                                - T1*X2/Dnom2
                                 Work(iWDensOcc(iJ,iK,iSymP)) =
     &                             Work(iWDensOcc(iJ,iK,iSymP))
     &                             - 2.0d0 * T1*X2
*******************************************************************
*        Calculate Lagr(4)_ai all virtual - active occupied
*******************************************************************
                              Else
                                 iC = iP - nFro(iSymP) - nOcc(iSymP)
                                 Work(iMp2Lagr(iC,iJ+nFro(iSymJ),
     &                                iSymJ)) =
     &                           Work(iMp2Lagr(iC,iJ+nFro(iSymJ),iSymJ))
     &                                + T1*X2
                              End If

* ------------------------- Debugging comments --------------------------
*                           If((iP .gt. nFro(iSymP)).and.
*     &                        (iP .le. nFro(iSymP)+nOcc(iSymP))) Then
*                              Write(6,*) 'AIBJK',iA,iI,iB,iJ,iK
*                              Write(6,*) 'Symm',iSymA,iSymI,iSymB,
*     &                                          iSymJ,iSymP
*                              Write(6,*) 'Dnom1', Dnom1
*                              Write(6,*) 'Dnom2', Dnom2
*                              Write(6,*) 'iajb', Xaibj(ip_iajb)
*                              Write(6,*) 'ibja', Xaibj(ip_ibja)
*                              Write(6,*) 'iakb', Xaibj(ip_iapb)
*                              Write(6,*) 'Bidrag', T1*T2
*                              Write(6,*) 'adress',iDensOcc(iJ,iK,iSymP)-
*     &                                            ip_Density(1)
*                           End If
* ----------------------------------------------------------------------
* ------------------------- Debugging comments -------------------------
*                              Write(6,*) 'AIBJC',iA,iI,iB,iJ,iC
*                              Write(6,*) 'Symm',iSymA,iSymI,iSymB,
*     &                                          iSymJ,iSymC
*                              Write(6,*) 'Dnom1', Dnom1
*                              Write(6,*) 'aibj', Xaibj(ip_iajb)
*                              Write(6,*) 'biaj', Xaibj(ip_ibja)
*                              Write(6,*) 'iacb', Xaibj(ip_iacb)
*                              If(iBatch.ne.jBatch) Then
*                                 Write(6,*) 'iacb', Xaibj(ip_ibca)
*                                 Write(6,*) 'Bidrag U', U1*U2
*                              End If
*                              Write(6,*) 'Bidrag T', T1*T2
*                              Write(6,*) 'adress',iMp2Lagr(iC,iJ,iSymJ)-
*     &                                   ip_Mp2Lagr(1)
*------------------------------------------------------------------------
*
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Input_RAS

use Definitions, only: iwp

implicit none
private

! Logical unit number for reading input:
integer(kind=iwp) :: LuInput
! Used for input processing
integer(kind=iwp), parameter :: NKeys = 149
! Logical flags, to check whether a keyword has been used in the input:
logical(kind=iwp) :: KeyFlags(0:NKeys)
! Actual keywords
character(len=4), parameter :: CMD(nKeys) = ['ALTE','ATOM','CHAR','CHOI','CHOL','CIMX','CION','CIRE','CIRO','CISE','CLEA','CORE', &
                                             'DELE','END ','FILE','FROZ','HOME','INAC','INPO','IPHN','ITER','JOBI','FUNC','LEVS', &
                                             'LINE','LOWD','LOWM','LUMO','MAXO','NACT','NEWI','NONE','NOQU','OPTO','ORBA','ORBL', &
                                             'ORBO','ORDE','OUTO','OUTP','PRIN','PROR','PRSP','PRWF','QUNE','RAS1','RAS2','RAS3', &
                                             'GASS','RFPE','CIRF','RFRO','RLXR','RASS','SDAV','SPIN','SUPS','SXDA','SYMM','THRS', &
                                             'TIGH','TITL','TYPE','VB  ','EXPE','    ','    ','    ','    ','FOSP','MDRL','OFEM', &
                                             'FTHA','DFMD','    ','ALPH','FARO','DMRG','3RDM','NECI','TOTA','TIME','NMCY','CALC', &
                                             'RDMS','REAL','DEFI','DIAG','EMBD','SOCC','RGIN','PRSD','FCID','NOCA','SAVE','EXPA', &
                                             'H5OR','H5CI','HEXS','HEUR','DMPO','NEVP','HFOC','DAVT','CHRE','CHBL','MXSW','NOIS', &
                                             'DMRE','MXCA','DEXS','HROO','TDM ','DFCF','NKEE','REOR','TRIA','POPS','SEMI','MEMO', &
                                             'IVO ','CRPR','RDML','ORTH','CCCI','ROST','XMSI','CMSI','CMMA','CMMI','CMTH','GUGA', &
                                             'CMSS','CMSO','PERI','SSCR','MCM7','WRMA','DICE','STOC','EPSI','SAMP','DITE','DIRE', &
                                             'DIOC','PPT2','NDPT','RGRA','STAV']

public :: CMD, Key, KeyFlags, LuInput, NKeys, SetKey

contains

pure function Key(Keyword)

  logical(kind=iwp) :: Key
  character(len=*), intent(in) :: Keyword
  integer(kind=iwp) :: i

  do i=1,nKeys
    if (Keyword == Cmd(i)) then
      Key = KeyFlags(i)
      return
    end if
  end do
  Key = .false.

end function Key

subroutine SetKey(Keyword,Val)

  use Definitions, only: u6

  character(len=*), intent(in) :: Keyword
  logical(kind=iwp), intent(in) :: Val
  integer(kind=iwp) :: i

  do i=1,nKeys
    if (Keyword == Cmd(i)) then
      KeyFlags(i) = Val
      return
    end if
  end do

  write(u6,*) 'Keyword "',trim(Keyword),'" is unknown.'
  call Abend()

end subroutine SetKey

end module Input_RAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Victor P. Vysotskiy                              *
************************************************************************
      Subroutine NIdiag_New(H,U,n,nv,iOpt)
************************************************************************
*                                                                      *
* This routine is a wrapper that calls appropriate LAPACK routines to  *
* perform diagonalization of symmetric matrices stored in lower        *
* triangular form.                                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Victor P. Vysotskiy                                         *
*          Lund university, Sweden                                     *
* Written  2013                                                        *
*                                                                      *
************************************************************************
      Implicit None
*----------------------------------------------------------------------*
* Dummy arguments                                                      *
* n    - Dimension of matrix                                           *
* nv   - Length of eigenvectors nv>=n                                  *
* H    - Matrix to be diagonalized                                     *
* U    - Eigenvectors                                                  *
* iOpt - Option flag, for future improvements.                         *
*----------------------------------------------------------------------*
#include "WrkSpc.fh"
      External OrbPhase
      Integer n,nv,iOpt
      Real*8  H(*),U(nv,n)
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Integer ipDIA,ipOFF,ipTAU,ipIWRK,ipWork,ipEVL,ipIPSZ,ipHDUP
      Integer lrwrk,liwrk,lh,info,I,M
      Real*8  abstol,dlamch_, Tmp, OrbPhase
      External dlamch_
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      If (n.eq.0) Return
#ifdef _DEBUGPRINT_
      Write(6,*) "New nidiag"
#endif
      Call FZero(U,nv*n)

      lh=n*(n+1)/2
      liwrk=10*n
      lrwrk=20*n

      Call GetMem('DIA','ALLO','REAL',ipDIA,n)
      Call GetMem('EVL','ALLO','REAL',ipEVL,n)
      Call GetMem('OFF','ALLO','REAL',ipOFF,(n-1))
      Call GetMem('TAU','ALLO','REAL',ipTAU,(n-1))
      Call GetMem('IPSZ','ALLO','INTE',ipIPSZ,2*n)
      Call GetMem('IWRK','ALLO','INTE',ipIWRK,liwrk)
      Call GetMem('RWRK','ALLO','REAL',ipWORK,lrwrk)
      Call GetMem('HDUP','ALLO','REAL',ipHDUP,lh)

      call dcopy_(lh,H,1,Work(ipHDUP),1)

      info=0
      call dsptrd_('U',n,Work(ipHDUP),Work(ipDIA),Work(ipOFF),
     &Work(ipTAU),info)

      If(info.ne.0) Then
#ifdef _DEBUGPRINT_
         Write(6,'(A,I4)')"Failed to tridiagonalize matrix",
     &   info
#endif
         Go To 10
      End If
#if defined(_ACML_) && defined(__PGI)
      CALL ILAENVSET(10,'X','X',0,0,0,0,1,INFO)
      CALL ILAENVSET(11,'X','X',0,0,0,0,1,INFO)
#endif
      abstol=dlamch_('Safe minimum')
      info=0
      call dstevr_('V','A',n,Work(ipDIA),Work(ipOFF),
     &Work(ip_Dummy),Work(ip_Dummy),iWork(ip_iDummy),
     &iWork(ip_iDummy),abstol,M,Work(ipEVL),U,nv,
     &iWork(ipIPSZ),Work(ipWORK),lrwrk,iWork(ipIWRK),
     &liwrk,info)

      If(info.ne.0) Then
#ifdef _DEBUGPRINT_
         Write(6,'(A,I4)') "Failed to diagonalize matrix",
     &   info
#endif
         Go To 10
      End If

      call dopmtr_('Left','U','N',N,N,Work(ipHDUP),Work(ipTAU),
     &U,nv,Work(ipWork),info)

      If(info.ne.0) Then
#ifdef _DEBUGPRINT_
        Write(6,'(A,I4)') "Failed to back transform vectors",
     &  info
#endif
        Go To 10
      End If

      call dcopy_(lh,Work(ipHDUP),1,H,1)

      Do I=1,N
         H((I*(I+1))/2)=Work(ipEVL+I-1)
      End Do

10    Continue
      Call GetMem('DIA','FREE','REAL',ipDIA,n)
      Call GetMem('EVL','FREE','REAL',ipEVL,n)
      Call GetMem('OFF','FREE','REAL',ipOFF,(n-1))
      Call GetMem('TAU','FREE','REAL',ipTAU,(n-1))
      Call GetMem('IPSZ','FREE','INTE',ipIPSZ,2*n)
      Call GetMem('RWRK','FREE','REAL',ipWORK,lrwrk)
      Call GetMem('IWRK','FREE','INTE',ipIWRK,liwrk)
      Call GetMem('HDUP','FREE','REAL',ipHDUP,n*(n+1)/2)

      if(info.ne.0) Then
#ifdef _DEBUGPRINT_
         Write(6,'(A)')
     &   "Using the old Givens rot. based routine"
#endif
         Call NIdiag(H,U,n,nv,iOpt)
      End If
*
      Do i = 1, n
         Tmp = OrbPhase(U(1,i),nv)
      End Do
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1996, Roland Lindh                      *
!               1990, IBM                                              *
!               1995, Martin Schuetz                                   *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Drv2El_dscf(Dens,TwoHam,nDens,nDisc,FstItr)
!***********************************************************************
!                                                                      *
!  Object: driver for two-electron integrals. The four outermost loops *
!          will control the type of the two-electron integral, e.g.    *
!          (ss|ss), (sd|pp), etc. The next four loops will generate    *
!          list of symmetry distinct centers that do have basis func-  *
!          tions of the requested type.                                *
!                                                                      *
!          Dens is the folded lower triangular of the 1st order        *
!               density matrix.                                        *
!          Twoham is the lower triangular of the two-electron contri-  *
!               bution to the Fock matrix.                             *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for k2 loop. August '91                         *
!             Modified for direct SCF. January '93                     *
!             Modified to minimize overhead for calculations with      *
!             small basis sets and large molecules. Sept. '93          *
!             Modified by M.Schuetz @teokem.lu.se :                    *
!             parallel region split off in drvtwo.f, April '95         *
!             Modified by R. Lindh  @teokem.lu.se :                    *
!             total repacking of code September '96                    *
!***********************************************************************

use IOBUF, only: lBuf
use Basis_Info, only: dbsc
use Gateway_Info, only: CutInt, ThrInt
use RICD_Info, only: Do_DCCD
use iSD_data, only: iSD
use Int_Options, only: Disc, Disc_Mx, DoFock, DoIntegrals, Exfac, FckNoClmb, FckNoExch, Quad_ijkl, Thize, W2Disc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Four, Eight, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDens, nDisc
real(kind=wp), target, intent(inout) :: Dens(nDens), TwoHam(nDens)
logical(kind=iwp), intent(inout) :: FstItr
integer(kind=iwp), parameter :: nTInt = 1
integer(kind=iwp) :: iCnttp, ijS, iOpt, iS, jCnttp, jS, kCnttp, klS, kS, lCnttp, lS, mDens, nIJ, nSkal
real(kind=wp) :: A_Int, Dtst, P_Eff, PP_Count, PP_Eff, PP_Eff_Delta, S_Eff, ST_Eff, T_Eff, ThrAO, TInt(nTInt), TMax_All, TskHi, &
                 TskLw
logical(kind=iwp) :: DoGrad, Indexation, Semi_Direct, Triangular
character(len=72) :: SLine
integer(kind=iwp), allocatable :: Pair_Index(:,:)
real(kind=wp), allocatable :: DMax(:,:), TMax(:,:)
procedure(int_wrout) :: No_Routine
logical(kind=iwp), external :: Rsv_GTList

!                                                                      *
!***********************************************************************
!                                                                      *
SLine = 'Computing 2-electron integrals'
call StatusLine('Seward: ',SLine)
!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Basis_Mode('Valence')
call Setup_iSD()
Int_PostProcess => No_Routine
!                                                                      *
!***********************************************************************
!                                                                      *
! Set variables in module Int_Options
DoIntegrals = .false.
DoFock = .true.
FckNoExch = ExFac == Zero
W2Disc = .false.     ! Default value
! Disc_Mx = file size in Real 128=1024/8
Disc_Mx = real(nDisc,kind=wp)*128.0_wp
! Subtract for the last buffer
Disc_Mx = Disc_Mx-lBuf
Disc = Zero        ! Default value
!                                                                      *
!***********************************************************************
!                                                                      *
! Set up for partial SO/AO integral storage.

! nDisc = file size in kbyte from input
Semi_Direct = (nDisc /= 0)
if (Semi_Direct) call Init_SemiDSCF(FstItr,Thize,Cutint)
!                                                                      *
!***********************************************************************
!                                                                      *
! Desymmetrize differential densities.
! Observe that the desymmetrized 1st order density matrices are
! canonical, i.e. the relative order of the indices are canonically
! ordered.

call DeDe_SCF(Dens,TwoHam,nDens,mDens)
!                                                                      *
!***********************************************************************
!                                                                      *
Indexation = .false.
ThrAO = Zero           ! Do not modify CutInt
DoGrad = .false.

call SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
!                                                                      *
!***********************************************************************
!                                                                      *
TskHi = Zero
TskLw = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute entities for prescreening at shell level

call mma_allocate(TMax,nSkal,nSkal,Label='TMax')
call Shell_MxSchwz(nSkal,TMax)
TMax_all = Zero
do iS=1,nSkal
  do jS=1,iS
    if (Do_DCCD .and. (iSD(10,iS) /= iSD(10,jS))) cycle
    TMax_all = max(TMax_all,TMax(iS,jS))
  end do
end do
call mma_allocate(DMax,nSkal,nSkal,Label='DMax')
call Shell_MxDens(Dens,DMax,nSkal)
!                                                                      *
!***********************************************************************
!                                                                      *
! Create list of non-vanishing pairs

call mma_allocate(Pair_Index,2,nSkal*(nSkal+1),Label='ip_ij')
nij = 0
do iS=1,nSkal
  do jS=1,iS
    if (Do_DCCD .and. (iSD(10,iS) /= iSD(10,jS))) cycle
    if (TMax_All*TMax(iS,jS) >= CutInt) then
      nij = nij+1
      Pair_Index(1,nij) = iS
      Pair_Index(2,nij) = jS
    end if
  end do
end do
P_Eff = real(nij,kind=wp)
!                                                                      *
!***********************************************************************
!                                                                      *
! For distributed parallel SCF initiate (sequential code is special
! case when the number of nodes in the mpp is 1).
!
! 1: Task list (tlist)
! 2: Private priority list (pplist)
! 3: Global task list (gtlist)

if (FstItr) then
  Triangular = .true.
  call Init_TList(Triangular,P_Eff)
  call Init_PPList()
  call Init_GTList()
else
  call ReInit_PPList(Semi_Direct)
  call ReInit_GTList()
end if
iOpt = 0
if ((.not. FstItr) .and. Semi_direct) iOpt = 2

PP_Eff = P_Eff**2
PP_Eff_delta = 0.1_wp*PP_Eff
PP_Count = Zero

! big loop over individual tasks, distributed over individual nodes

do
  ! make reservation of a task on global task list and get task range
  ! in return. Function will be false if no more tasks to execute.

  if (.not. Rsv_GTList(TskLw,TskHi,iOpt,W2Disc)) exit

  call Mode_SemiDSCF(W2Disc)

  ! Now do a quadruple loop over shells

  ijS = int((One+sqrt(Eight*TskLw-Three))/Two)
  klS = int(TskLw-real(ijS,kind=wp)*(real(ijS,kind=wp)-One)/Two)
  Quad_ijkl = TskLw

  Quad_ijkl = Quad_ijkl-One
  klS = klS-1
  do
    Quad_ijkl = Quad_ijkl+One
    if (Quad_ijkl-TskHi > 1.0e-10_wp) exit
    klS = klS+1
    if (klS > ijS) then
      ijS = ijS+1
      klS = 1
    end if
    iS = Pair_Index(1,ijS)
    jS = Pair_Index(2,ijS)
    kS = Pair_Index(1,klS)
    lS = Pair_Index(2,klS)

    ! Logic to avoid computing integrals in a mixed muonic and electronic basis.

    iCnttp = iSD(13,iS)
    jCnttp = iSD(13,jS)
    if (dbsc(iCnttp)%fMass /= dbsc(jCnttp)%fMass) cycle
    kCnttp = iSD(13,kS)
    lCnttp = iSD(13,lS)
    if (dbsc(kCnttp)%fMass /= dbsc(lCnttp)%fMass) cycle
    S_Eff = real(ijS,kind=wp)
    T_Eff = real(klS,kind=wp)
    ST_Eff = S_Eff*(S_Eff-One)*Half+T_Eff

    if (ST_Eff >= PP_Count) then
      write(SLine,'(A,F5.2,A)') 'Computing 2-electron integrals,',ST_Eff/PP_Eff,'% done so far.'
      call StatusLine('Seward: ',SLine)
      PP_Count = PP_Count+PP_Eff_delta
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    A_int = TMax(iS,jS)*TMax(kS,lS)

    if (Semi_Direct) then

      ! No density screening in semi-direct case!
      ! Cutint: Threshold for Integrals. In semi-direct case, this
      !         must be the final threshold used in the last scf
      !         iteration
      ! Thrint: Threshold for Density screening. This the actual
      !         threshold
      !         for the current iteration

      if (A_Int < CutInt) cycle

    else

      if (FckNoClmb) then
        Dtst = max(DMax(is,ls)/Four,DMax(is,ks)/Four,DMax(js,ls)/Four,DMax(js,ks)/Four)
      else if (FckNoExch) then
        Dtst = max(DMax(is,js),DMax(ks,ls))
      else
        Dtst = max(DMax(is,ls)/Four,DMax(is,ks)/Four,DMax(js,ls)/Four,DMax(js,ks)/Four,DMax(is,js),DMax(ks,ls))
      end if

      if (A_int*Dtst < ThrInt) cycle

    end if

    if (Do_DCCD .and. (iSD(10,iS) /= iSD(10,kS))) cycle
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    call Eval_IJKL(iS,jS,kS,lS,TInt,nTInt)

  end do

  ! Task endpoint

  if (Semi_Direct) then
    if (W2Disc) then
      call Put_QLast()
    else
      call Pos_QLast(Disc)
    end if
  end if

end do
! End of big task loop
!                                                                      *
!***********************************************************************
!                                                                      *
!                         E P I L O G U E                              *
!                                                                      *
!***********************************************************************
!                                                                      *
if (Semi_Direct) call Close_SemiDSCF()
FstItr = .false.

call mma_deallocate(Pair_Index)
call mma_deallocate(DMax)
call mma_deallocate(TMax)

call Term_Ints()

call Free_DeDe(Dens,TwoHam,nDens)
nullify(Int_PostProcess)

! Broadcast contributions to the Fock matrix

call Sync_TH(TwoHam,nDens)
!                                                                      *
!***********************************************************************
!                                                                      *
!MAW start
!call fmm_call_get_J_matrix(nDens,1,dens,TwoHam)
!MAW end
call Free_iSD()
!call Init_Int_Options()    ?

end subroutine Drv2El_dscf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine hqr(nm,n,low,igh,h,wr,wi,ierr)
! this subroutine is a translation of the algol procedure hqr,
! num. math. 14, 219-231(1970) by martin, peters, and wilkinson.
! handbook for auto. comp., vol.ii-linear algebra, 359-371(1971).
!
! this subroutine finds the eigenvalues of a real
! upper hessenberg matrix by the qr method.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.
!
!    n is the order of the matrix.
!
!    low and igh are integers determined by the balancing
!      subroutine  balanc.  if  balanc  has not been used,
!      set low=1, igh=n.
!
!    h contains the upper hessenberg matrix.  information about
!      the transformations used in the reduction to hessenberg
!      form by  elmhes  or  orthes, if performed, is stored
!      in the remaining triangle under the hessenberg matrix.
!
! on output
!
!    h has been destroyed.  therefore, it must be saved
!      before calling  hqr  if subsequent calculation and
!      back transformation of eigenvectors is to be performed.
!
!    wr and wi contain the real and imaginary parts,
!      respectively, of the eigenvalues.  the eigenvalues
!      are unordered except that complex conjugate pairs
!      of values appear consecutively with the eigenvalue
!      having the positive imaginary part first.  if an
!      error exit is made, the eigenvalues should be correct
!      for indices ierr+1,...,n.
!
!    ierr is set to
!      zero       for normal return,
!      j          if the limit of 30*n iterations is exhausted
!                 while the j-th eigenvalue is being sought.
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated september 1989.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------
!
!  RESTORED CORRECT INDICES OF LOOPS (200,210,230,240). (9/29/89 BSG)

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n, low, igh
real(kind=wp), intent(inout) :: h(nm,n)
real(kind=wp), intent(out) :: wr(n), wi(n)
integer(kind=iwp), intent(out) :: ierr
integer(kind=iwp) :: en, enm2, i, itn, its, j, k, l, ll, m, mm, mp2, na, nroot
real(kind=wp) :: norm, p, q, r, s, t, tst1, tst2, w, x, y, zz
logical(kind=iwp) :: notlas

ierr = 0
norm = Zero
k = 1
l = 0     ! dummy initialize
m = 0     ! dummy initialize
p = Zero  ! dummy initialize
q = Zero  ! dummy initialize
r = Zero  ! dummy initialize
nroot = 0 ! dummy initialize
! .......... store roots isolated by balanc and compute matrix norm ..........
do i=1,n

  do j=k,n
    norm = norm+abs(h(i,j))
  end do

  k = i
  if ((i >= low) .and. (i <= igh)) cycle
  wr(i) = h(i,i)
  wi(i) = Zero
end do

en = igh
t = Zero
itn = 30*n
do
  ! .......... search for next eigenvalues ..........
  if (en < low) return
  its = 0
  na = en-1
  enm2 = na-1
  do
    ! .......... look for single small sub-diagonal element for l=en step -1 until low do -- ..........
    do ll=low,en
      l = en+low-ll
      if (l == low) exit
      s = abs(h(l-1,l-1))+abs(h(l,l))
      if (s == Zero) s = norm
      tst1 = s
      tst2 = tst1+abs(h(l,l-1))
      if (tst2 == tst1) exit
    end do
    ! .......... form shift ..........
    x = h(en,en)
    if (l == en) then
      nroot = 1
      exit
    end if
    y = h(na,na)
    w = h(en,na)*h(na,en)
    if (l == na) then
      nroot = 2
      exit
    end if
    if (itn == 0) then
      ! .......... set error -- all eigenvalues have not converged after 30*n iterations ..........
      ierr = en
      return
    end if
    if ((its == 10) .or. (its == 20)) then
      ! .......... form exceptional shift ..........
      t = t+x

      do i=low,en
        h(i,i) = h(i,i)-x
      end do

      s = abs(h(en,na))+abs(h(na,enm2))
      x = 0.75_wp*s
      y = x
      w = -0.4375_wp*s*s
    end if
    its = its+1
    itn = itn-1
    ! .......... look for two consecutive small sub-diagonal elements.
    !            for m=en-2 step -1 until l do -- ..........
    do mm=l,enm2
      m = enm2+l-mm
      zz = h(m,m)
      r = x-zz
      s = y-zz
      p = (r*s-w)/h(m+1,m)+h(m,m+1)
      q = h(m+1,m+1)-zz-r-s
      r = h(m+2,m+1)
      s = abs(p)+abs(q)+abs(r)
      p = p/s
      q = q/s
      r = r/s
      if (m == l) exit
      tst1 = abs(p)*(abs(h(m-1,m-1))+abs(zz)+abs(h(m+1,m+1)))
      tst2 = tst1+abs(h(m,m-1))*(abs(q)+abs(r))
      if (tst2 == tst1) exit
    end do

    mp2 = m+2

    do i=mp2,en
      h(i,i-2) = Zero
      if (i == mp2) cycle
      h(i,i-3) = Zero
    end do
    ! .......... double qr step involving rows l to en and columns m to en ..........
    do k=m,na
      notlas = k /= na
      if (k /= m) then
        p = h(k,k-1)
        q = h(k+1,k-1)
        r = Zero
        if (notlas) r = h(k+2,k-1)
        x = abs(p)+abs(q)+abs(r)
        if (x == Zero) cycle
        p = p/x
        q = q/x
        r = r/x
      end if
      s = sign(sqrt(p*p+q*q+r*r),p)
      if (k == m) then
        if (l /= m) h(k,k-1) = -h(k,k-1)
      else
        h(k,k-1) = -s*x
      end if
      p = p+s
      x = p/s
      y = q/s
      zz = r/s
      q = q/p
      r = r/p
      if (notlas) then
        ! .......... row modification ..........
        do j=k,EN
          p = h(k,j)+q*h(k+1,j)+r*h(k+2,j)
          h(k,j) = h(k,j)-p*x
          h(k+1,j) = h(k+1,j)-p*y
          h(k+2,j) = h(k+2,j)-p*zz
        end do

        j = min(en,k+3)
        ! .......... column modification ..........
        do i=L,j
          p = x*h(i,k)+y*h(i,k+1)+zz*h(i,k+2)
          h(i,k) = h(i,k)-p
          h(i,k+1) = h(i,k+1)-p*q
          h(i,k+2) = h(i,k+2)-p*r
        end do
      else
        ! .......... row modification ..........
        do j=k,EN
          p = h(k,j)+q*h(k+1,j)
          h(k,j) = h(k,j)-p*x
          h(k+1,j) = h(k+1,j)-p*y
        end do

        j = min(en,k+3)
        ! .......... column modification ..........
        do i=L,j
          p = x*h(i,k)+y*h(i,k+1)
          h(i,k) = h(i,k)-p
          h(i,k+1) = h(i,k+1)-p*q
        end do
      end if

    end do
  end do

  if (nroot == 1) then
    ! .......... one root found ..........
    wr(en) = x+t
    wi(en) = Zero
    en = na
  else if (nroot == 2) then
    ! .......... two roots found ..........
    p = (y-x)*Half
    q = p*p+w
    zz = sqrt(abs(q))
    x = x+t
    if (q < Zero) then
      ! .......... complex pair ..........
      wr(na) = x+p
      wr(en) = x+p
      wi(na) = zz
      wi(en) = -zz
    else
      ! .......... real pair ..........
      zz = p+sign(zz,p)
      wr(na) = x+zz
      wr(en) = wr(na)
      if (zz /= Zero) wr(en) = x-w/zz
      wi(na) = Zero
      wi(en) = Zero
    end if
    en = enm2
  end if
end do

return

end subroutine hqr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1987, Per Ake Malmqvist                                *
!***********************************************************************

subroutine MKSXY(CMO1,CMO2,SXY)
! PURPOSE: FORM THE OVERLAP MATRIX SXY FOR ORBITAL BASES CMO1, CMO2.
! CODED 1987-02-18, P-AA M.

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use Symmetry_Info, only: nIrrep
use rassi_data, only: NBASF, NCMO, NOSH, NSXY
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CMO1(NCMO), CMO2(NCMO)
real(kind=wp), intent(out) :: SXY(NSXY)
integer(kind=iwp) :: ICMO, ICMP, IOPT, IRC, ISXY, ISY, ISYLAB, LSZZ1, NB, NO, NPROD, NSSQ, NSZZ
character(len=8) :: LABEL
real(kind=wp), allocatable :: PROD(:), SSQ(:), SZZ(:)

! CALCULATE SIZE AND ALLOCATE A FIELD SZZ FOR OVERLAP MATRIX
! IN COMMON BASIS SET (TRIANGULAR), SSQ TEMPORARY STORAGE
! FOR EACH OF ITS SYMMETRY BLOCKS (SQUARE), AND PROD FOR
! INTERMEDIATE MATRIX PRODUCTS.
NSZZ = sum(nTri_Elem(NBASF(1:nIrrep)))
NSSQ = maxval(NBASF(1:nIrrep)**2)
NPROD = maxval(NOSH(1:nIrrep)*NBASF(1:nIrrep))
call mma_allocate(SZZ,NSZZ,Label='SZZ')
call mma_allocate(SSQ,NSSQ,Label='SSQ')
call mma_allocate(PROD,NPROD,Label='PROD')
! READ OVERLAP MATRIX SZZ:
IRC = -1
IOPT = ibset(ibset(0,sNoOri),sNoNuc)
ICMP = 1
ISYLAB = 1
LABEL = 'MLTPL  0'
call RDONE(IRC,IOPT,LABEL,ICMP,SZZ,ISYLAB)
if (IRC /= 0) then
  write(u6,*)
  write(u6,*) '      *** ERROR IN SUBROUTINE MKSXY ***'
  write(u6,*) '     OVERLAP INTEGRALS ARE NOT AVAILABLE'
  write(u6,*)
  call ABEND()
end if
!  LOOP OVER SYMMETRIES:
LSZZ1 = 1
ISXY = 1
ICMO = 1
do ISY=1,nIrrep
  NB = NBASF(ISY)
  if (NB == 0) cycle
  NO = NOSH(ISY)
  if (NO /= 0) then
    call SQUARE(SZZ(LSZZ1),SSQ,1,NB,NB)
    ! PROD:=SSQ*CMO2
    call DGEMM_('N','N',NB,NO,NB,One,SSQ,NB,CMO2(ICMO),NB,Zero,PROD,NB)
    ! SXY:=(CMO1(TRANSP))*PROD
    call DGEMM_('T','N',NO,NO,NB,One,CMO1(ICMO),NB,PROD,NB,Zero,SXY(ISXY),NO)
    ISXY = ISXY+NO**2
    ICMO = ICMO+NO*NB
  end if
  LSZZ1 = LSZZ1+nTri_Elem(NB)
end do
call mma_deallocate(SZZ)
call mma_deallocate(SSQ)
call mma_deallocate(PROD)

end subroutine MKSXY

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine OutPut_MCLR(iKapDisp,isigdisp,iCiDisp,iCiSigDisp,iRHSDisp,iRHSCIDisp,converged)
!***********************************************************************
!                                                                      *
! Contracts the response coefficient to the hessian                    *
!                                                                      *
! Input                                                                *
!       iKapDisp   : Disk locations of solutions to respons equation   *
!       iSigDisp   : Disk locations of RHS                             *
!       iCIDisp    : Disk locations of CI Soulutions to response       *
!       iCISigDisp : Disk locations of RHS                             *
!       nHess      : Length of hessian                                 *
!                                                                      *
! Output to disk                                                       *
!                                                                      *
!       RespHess : Hessian etc                                         *
!       Hess     : Hessian etc                                         *
!                                                                      *
! Author: Anders Bernhardsson, 1996                                    *
!         Theoretical Chemistry, University of Lund                    *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use MckDat, only: sLength
use ipPage, only: ipclose, ipget, ipin, W
use MCLR_Data, only: Hss, lDisp, LuTEMP, nConf1, nDensC, nHess, XISPSM
use input_mclr, only: Coor, Debug, iMethod, lCalc, McKinley, nCSF, nDisp, nSym, nTPert, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iKapDisp(nDisp), isigdisp(nDisp), iCiDisp(nDisp), iCiSigDisp(nDisp), iRHSDisp(nDisp), &
                                 iRHSCiDisp(nDisp)
logical(kind=iwp), intent(in) :: converged(8)
integer(kind=iwp) :: iDis, iDisk, iDisp, iDum, ielec(3), iLen, Indx, iOpt, ipCIP1, ipCIP2, ipRP1, ipRP2, ipSP, iRC, iSym, jDisp, &
                     jSpin, kDisp, kSpin, kSym, ldisp2(8), Length, Lu_10, mSym, nConfm, nHss, Pstate_sym
logical(kind=iwp) :: CI
real(kind=wp) :: Fact, Pola(6), rTempC1, rTempC2, rTempC3, rTempK1, rTempK2, rTempK3
character(len=8) :: Label
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ip
logical(kind=iwp) :: elec_On
character(len=20) :: Label2
#endif
integer(kind=iwp), allocatable :: DegDisp(:), NrDisp(:)
real(kind=wp), allocatable :: EG(:), ELEC(:), ELOUT(:), Hess(:), Hess2(:), Kap1(:), Kap2(:), RHss(:), rKap1(:), rKap2(:), sKap(:), &
                              Temp(:)
integer(kind=iwp), external :: IsFreeUnit
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *

#ifdef _DEBUGPRINT_
debug = .true.
#else
debug = .false.
#endif
nHss = size(Hss)
nhess = nTri_Elem(nDisp)
call mma_allocate(RHss,nHss,Label='RHss')
RHss(:) = Zero

!----------------------------------------------------------------------*
!
! Ok construct hessian
!
!----------------------------------------------------------------------*

mSym = 0
kSym = 0
idum = 1
idisp = 0
do iSym=1,nSym

  ! Calculate length of the density, Fock and Kappa matrix etc
  ! notice that this matrixes not necessary are symmetric.
  ! Store pointers.
  !
  ! Input:
  ! iSym : Symmetry of perturbation
  !
  ! Output: Commonblocks (Pointers.fh)

  call Setup_MCLR(iSym)
  PState_SYM = Mul(State_Sym,iSym)
  nconfM = max(ncsf(PState_Sym),nint(xispsm(Pstate_Sym,1)))
  nconf1 = ncsf(PState_Sym)
  CI = .false.
  if ((iMethod == 2) .and. (nconf1 > 0)) CI = .true.
  if (CI .and. (nconf1 == 1) .and. (isym == 1)) CI = .false.

  ! Allocate areas for scratch and state variables

  call mma_allocate(Kap1,nDensC,Label='Kap1')
  call mma_allocate(Kap2,nDensC,Label='Kap2')
  call mma_allocate(sKap,nDensC,Label='sKap')
  call mma_allocate(rkap1,nDensC,Label='rKap1')
  call mma_allocate(rkap2,nDensC,Label='rKap2')

  if (CI) then
    ipcip1 = ipget(nconfM)
    ipcip2 = ipget(nconfM)
    ipsp = ipget(nconfM)
    iprp2 = ipget(nconfM)
    iprp1 = ipget(nconfM)
  end if

  !                            [2]
  ! Calculate the diagonal of E    and store in core/disc

  do jDisp=1,lDisp(iSym)
    iDisp = iDisp+1
    jspin = 0
    if (btest(nTPert(idisp),0)) jSpin = 1
    if (jspin == 0) then
      nconf1 = ncsf(Pstate_sym)
    else
      nconf1 = nint(xispsm(Pstate_Sym,1))
    end if

    !------------------------------------------------------------------*
    !                                                                  *
    !    Read response from disk                                       *
    !                                                                  *
    !------------------------------------------------------------------*

    iDisk = iKapDisp(iDisp)

    ! If disk address =/= -1 arrays on file.

    if (iDisk /= -1) then
      Length = nDensC
      call dDaFile(LuTemp,2,Kap1,Length,iDisk)
      iDisk = iSigDisp(iDisp)
      call dDaFile(LuTemp,2,SKap,Length,iDisk)
      iDisk = iRHSDisp(iDisp)
      call dDaFile(LuTemp,2,rKap1,Length,iDisk)
      SKap(:) = -SKap(:)-rKap1(:)

      !call Recprt('ORB-RHS',' ',rKap1,nDensC,1)
      !write(u6,*) 'ddot orb-resp',ddot_(nDensC,Kap1,1,Kap1,1)
      !write(u6,*) 'ddot orb-sigma',ddot_(nDensC,SKap,1,SKap,1)
      !write(u6,*) 'ddot orb-rhs',ddot_(nDensC,rKap1,1,rKap1,1)

      call GADSum(Kap1,Length)
      call GADSum(SKap,Length)
      call GADSum(rKap1,Length)

      if (CI) then
        ilen = nconf1
        idis = iCIDisp(iDisp)
        call ipin(ipCIp1)
        call dDaFile(LuTemp,2,W(ipCIp1)%A,iLen,iDis)
        idis = iCISigDisp(idisp)
        call ipin(ipSp)
        call dDaFile(LuTemp,2,W(ipSp)%A,iLen,iDis)
        idis = iRHSCIDisp(idisp)
        call ipin(iprp1)
        call dDaFile(LuTemp,2,W(iprp1)%A,iLen,iDis)
        call ipin(ipSp)
        call ipin(iprp1)
        W(ipSp)%A(1:nConf1) = -W(ipSp)%A(1:nConf1)-W(iprp1)%A(1:nConf1)

        !write(u6,*) 'ddot ci-resp',ddot_(nConf1,W(ipcip1)%A,1,W(ipcip1)%A,1)
        !write(u6,*) 'ddot ci-sigma',ddot_(nConf1,W(ipSp)%A,1,W(ipSp)%A,1)
        !write(u6,*) 'ddot ci-rhs',ddot_(nConf1,W(iprp1)%A,1,W(iprp1)%A,1)

        call GADSum(W(ipCIp1)%A,iLen)
        call GADSum(W(ipSp)%A,iLen)
        call GADSum(W(ipRp1)%A,iLen)
      end if

    else

      Length = nDensC
      Kap1(1:Length) = Zero
      call GADSum(Kap1,Length)
      sKap(1:Length) = Zero
      call GADSum(SKap,Length)
      rKap1(1:Length) = Zero
      call GADSum(rKap1,Length)

      if (CI) then

        ilen = nconf1
        call ipin(ipCIp1)
        W(ipCIp1)%A(1:iLen) = Zero
        call GADSum(W(ipCIp1)%A,iLen)
        call ipin(ipSp)
        W(ipSp)%A(1:iLen) = Zero
        call GADSum(W(ipSp)%A,iLen)
        call ipin(ipRp1)
        W(ipRp1)%A(1:iLen) = Zero
        call GADSum(W(ipRp1)%A,iLen)

      end if

    end if

    !*******************************************************************

    do kDisp=1,jdisp

      !         (x) (2) (y)   (x) (y)    (y) (x)
      ! E    = k   E   k   + F   k   +  F   k
      !  Resp

      kspin = 0
      if (btest(nTPert(kdisp+ksym),0)) kSpin = 1
      if (kspin == 0) then
        nconf1 = ncsf(PState_Sym)
      else
        nConf1 = nint(xispsm(Pstate_Sym,1))
      end if
      if (.not. lCalc(kDisp+ksym)) cycle

      !write(u6,*) 'kDisp+kSym',kDisp+kSym
      !write(u6,*) 'iKapDisp(kdisp+ksym)',iKapDisp(kdisp+ksym)

      iDisk = iKapDisp(kDisp+kSym)
      if (iDisk /= -1) then
        Length = nDensC
        call dDaFile(LuTemp,2,Kap2,Length,iDisk)
        iDisk = iRHSDisp(kDisp+kSym)
        call dDaFile(LuTemp,2,rKap2,Length,iDisk)

        call GASync()
        call GADSum(Kap2,Length)
        call GADSum(rKap2,Length)

        if (CI) then
          ilen = nconf1
          idis = iCIDisp(kDisp+ksym)
          call ipin(ipCIp2)
          call dDaFile(LuTemp,2,W(ipCIp2)%A,iLen,iDis)
          idis = iRHSCIDisp(kdisp+ksym)
          call ipin(iprp2)
          call dDaFile(LuTemp,2,W(iprp2)%A,iLen,iDis)
          call ipin(ipsp)
          rTempc1 = DDot_(nConf1,W(ipCIp2)%A,1,W(ipsp)%A,1)

          call GASync() ! <----------------- NOTE!
          call GADSum(W(ipCIp2)%A,iLen)
          call GADSum(W(iprp2)%A,iLen)

        else
          rtempc1 = Zero
        end if

      else

        call GASync()
        Length = nDensC
        Kap2(1:Length) = Zero
        call GADSum(Kap2,Length)
        rKap2(1:Length) = Zero
        call GADSum(rKap2,Length)
        if (CI) then
          ilen = nconf1
          call GASync()   ! <----------------- NOTE!
          call ipin(ipCIp2)
          W(ipCIp2)%A(1:iLen) = Zero
          call GADSum(W(ipCIp2)%A,iLen)
          call ipin(iprp2)
          W(iprp2)%A(1:iLen) = Zero
          call GADSum(W(iprp2)%A,iLen)
          call ipin(ipsp)
          rTempc1 = DDot_(nConf1,W(ipCIp2)%A,1,W(ipsp)%A,1)
        else
          rtempc1 = Zero
        end if

      end if

      rTempk1 = DDot_(nDensC,Kap2,1,SKap,1)

      Fact = One
      if (kdisp == jdisp) Fact = Two
      rTempk2 = Fact*DDot_(nDensC,Kap1,1,rKap2,1)
      if (kdisp /= jdisp) then
        rtempk3 = DDot_(nDensC,rKap1,1,Kap2,1)
      else
        rTempk3 = Zero
      end if
      if (CI) then
        Fact = One
        if (kdisp == jdisp) Fact = Two
        call ipin(ipCip1)
        call ipin(iprp2)
        rTempc2 = Fact*DDot_(nConf1,W(ipCip1)%A,1,W(iprp2)%A,1)
        if (kdisp /= jdisp) then
          call ipin(iprp1)
          call ipin(ipCIp2)
          rtempc3 = DDot_(nConf1,W(iprp1)%A,1,W(ipCIp2)%A,1)
        else
          rTempc3 = Zero
        end if
      else
        rtempc2 = Zero
        rtempc3 = Zero
      end if

      !write(u6,*) kdisp,jdisp
      !write(u6,*) rTempk1,rtempk2,rtempk3
      !write(u6,*) rtempc1,rtempc2,rtempc3

      Indx = mSym+iTri(kDisp,jDisp)

      Rhss(Indx) = Rhss(Indx)+rTempk1+rtempk2+rtempk3+rtempc1+rtempc2+rtempc3

    end do

    !*******************************************************************

  end do
  kSym = kSym+lDisp(iSym)
  mSym = mSym+nTri_Elem(lDisp(iSym))

  ! Free areas for scratch and state variables

  call mma_deallocate(rKap2)
  call mma_deallocate(rKap1)
  call mma_deallocate(sKap)
  call mma_deallocate(Kap2)
  call mma_deallocate(Kap1)
  if (CI) call ipclose(ipcip1)
end do

call mma_allocate(Hess,nHss,Label='Hess')
Hess(:) = Zero
call mma_allocate(Hess2,nHss,Label='Hess2')
call mma_allocate(Temp,nHss,Label='Temp')
Temp(:) = Zero
call mma_allocate(ELEC,3*ndisp,Label='ELEC')
ELEC(:) = Zero
call mma_allocate(EG,3*ndisp,Label='EG')
call mma_allocate(ELOUT,3*ndisp,Label='ELOUT')
call ipclose(-1)

!----------------------------------------------------------------------*
!
!     OK now when we have out Hessian, what should we do with it!
!
!----------------------------------------------------------------------*

! If a basis set is dependent on perturbation add terms
! constructed in mckinley.

pola(:) = Zero
idum = 1
iopt = ibset(0,sLength)
irc = 3*ndisp
Label = 'DOTELGR'
call drdMCk(irc,iopt,LaBeL,idum,EG,idum)
call GADsum(Hss,nHss)
Hess2(:) = Hss(:)
#ifdef _DEBUGPRINT_
elec_On = .true.
if (irc /= 0) elec_On = .false.
if (debug) then
  ip = 1
  do iSym=1,nSym
    write(label2,'(A,I2)') 'CHessian symmetry',iSym
    if (lDisp(iSym) /= 0) call TriPrt(label2,' ',Hess2(ip),lDisp(iSym))
    ip = ip+nTri_Elem(ldisp(isym))
  end do
end if

if (debug) then
  call MMSORT2(HESS2,ELEC,pola,ielec)
  call Recprt('CONN',' ',Elec,3*nDisp,1)
end if

!write(u6,*) 'I am here 1'
call Recprt('Rhss','(5G20.10)',RHss,nhss,1)
call Recprt('Hss','(5G20.10)',Hss,nHss,1)
#endif

Hess2(1:mSym) = Hess2(1:mSym)+RHss(1:mSym)

#ifdef _DEBUGPRINT_
if (debug) then
  call MMSORT2(RHSS,ELEC,pola,ielec)
  call Recprt('RESP',' ',Elec,3*nDisp,1)
end if
#endif

call MMSORT2(HESS2,ELEC,pola,ielec)

#ifdef _DEBUGPRINT_
if (debug) then
  call Recprt('R+C',' ',Elec,3*nDisp,1)
  ip = 1
  do iSym=1,nSym
    write(label2,'(A,I2)') 'Hessian symmetry',iSym
    if (lDisp(iSym) /= 0) call TriPrt(label2,' ',Hess2(ip),lDisp(iSym))
    ip = ip+nTri_Elem(ldisp(isym))
  end do
end if
#endif

call mmSort(Hess2,Hess,ldisp2)

if (McKinley) then

  iRC = -1
  iOpt = 0
  Label = 'StatHess'
  call dRdMck(iRC,iOpt,Label,idum,Temp,idum)
  if (iRC /= 0) then
    write(u6,*) 'OutPut: Error reading MCKINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if

# ifdef _DEBUGPRINT_
  if (debug) then
    ip = 1
    do iSym=1,nSym
      write(label2,'(a,i2)') 'SHessian symmetry',iSym
      if (lDisp2(iSym) /= 0) call TriPrt(label2,' ',Temp(ip),lDisp2(iSym))
      ip = ip+nTri_Elem(ldisp2(isym))
    end do
  end if
# endif
  Hess(1:mSym) = Hess(1:mSym)+Temp(1:mSym)
end if
#ifdef _DEBUGPRINT_
if (debug) then
  ip = 1
  do iSym=1,nSym
    write(label2,'(a,i2)') 'Hessian symmetry',iSym
    if (lDisp2(iSym) /= 0) call TriPrt(label2,' ',Hess(ip),lDisp2(iSym))
    ip = ip+nTri_Elem(ldisp2(isym))
  end do
end if
#endif

if (McKinley) then
  iRC = -1
  iOpt = 0
  Label = 'Hess'
  call dWrMck(iRC,iOpt,Label,iDum,Hess,iDum)
  if (iRC /= 0) then
    write(u6,*) 'OutPut: Error writing to MCKINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if
  call Put_iScalar('No of Internal coordinates',ldisp2(1))
  call Put_AnalHess(Hess,nTri_Elem(ldisp2(1)))
end if

if (.true.) then
  iRC = -1
  iOpt = 0
  call mma_allocate(NrDisp,ndisp,Label='NrDisp')
  Label = 'NRCTDISP'
  call RdMck(irc,iopt,Label,idum,NrDisp,idum)
  iRC = -1
  iOpt = 0
  call mma_allocate(DegDisp,ndisp,Label='DegDisp')
  Label = 'DegDisp'
  call RdMck(irc,iopt,Label,idum,DegDisp,idum)
  if (iRC /= 0) then
    write(u6,*) 'OutPut: Error reading RELAX'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if

  !if (debug) call HssPrt_MCLR(DegDisp,Hess,ldisp2)
  !call Recprt('hess',' ',Hess,nhss,1)

  ELEC(:) = ELEC(:)-EG(:)
# ifdef _DEBUGPRINT_
  if (debug .and. elec_On) call Recprt('ELEC-ST',' ',EG,3*nDisp,1)
  if (debug .and. elec_On) call Recprt('ELEC-TOT',' ',Elec,3*nDisp,1)
# endif

  Lu_10 = 10
  Lu_10 = IsFreeUnit(Lu_10)
  call molcas_open(lu_10,'UNSYM')
  !open(unit=Lu_10,file='UNSYM')

  if (Mckinley) then
    call FreqAnal(DegDisp,NrDisp,Hess,converged,ELEC,ielec,elout,ldisp2,Lu_10)
    call Niclas(Hess,coor,Lu_10)
  end if
  write(u6,*)
  write(u6,*)
  write(u6,*) '************************************'
  write(u6,*) '*                                  *'
  write(u6,*) '*       Polarizabilities           *'
  write(u6,*) '*                                  *'
  write(u6,*) '************************************'
  write(u6,*)
  write(u6,*)
  call Add_Info('POLARIZABILITIES',Pola,6,2)

  ! Go from energy derivative to polarizability, there is a difference
  ! in the sign in the definition.

  Pola(:) = -Pola(:)

  call TriPrt(' ',' ',Pola,3)
  close(Lu_10)
  call mma_deallocate(NrDisp)
  call mma_deallocate(DegDisp)
end if
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

call mma_deallocate(ELOUT)
call mma_deallocate(EG)
call mma_deallocate(ELEC)
call mma_deallocate(Temp)
call mma_deallocate(Hess2)
call mma_deallocate(Hess)
call mma_deallocate(RHss)

end subroutine OutPut_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine TRDNS2O(IVEC,JVEC,DPT2,MDPT2,NDPT2,SCAL)
! Add to the block-off-diag parts of transition density matrix,
!    DPT2(p,q) = Add <IVEC| E(p,q) |JVEC>.
! i.e. inact/act, inact/virt and act/virt submatrices only,
! where IVEC, JVEC stands for the 1st-order perturbed CASPT2
! wave functions stored as vectors nr IVEC, JVEC on LUSOLV.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use EQSOLV, only: IfCoup
use fake_GA, only: GA_Arrays
use caspt2_global, only: LISTS
use caspt2_module, only: FockType, G1SecIn, nActEl, nAsh, nASup, nInDep, nIsh, nISup, nOrb, nSsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC, MDPT2
real(kind=wp), intent(inout) :: DPT2(MDPT2)
integer(kind=iwp), intent(inout) :: NDPT2
real(kind=wp), intent(in) :: SCAL
integer(kind=iwp) :: iCase1, iCase2, idoff, idpq, idqp, iLoop, iMltOp, ip, iq, iSta, iSym, iSym1, iSym2, lScr, lScr2, lVec1, &
                     lVec2, na, nas1, nas2, ni, nis1, nis2, nLoop, no, nVec1, nVec2, nWec1
real(kind=wp) :: Fact
real(kind=wp), allocatable :: SCR(:), WEC1(:)
#ifdef _MOLCAS_MPP_
real(kind=wp), allocatable :: TMP1(:), TMP2(:)
#endif

! If the G1 correction to the Fock matrix is used, then the
! inactive/virtual coupling elements (which are non-zero for the
! case of average CASSCF) cannot be used in the CASPT2 equations.
if ((FOCKTYPE == 'G1') .and. (.not. G1SECIN)) then
  IFCOUP(12,5) = 0
  IFCOUP(13,5) = 0
end if

NDPT2 = sum(NORB(1:NSYM)**2)

! Loop over ordering: First, <IVEC|...|JVEC>, then reverse.
! For each order, compute the upper-triangular blocks.
! For true density matrices, use symmetry of D-matrix.

! Transform to standard representation, contravariant form.
call PTRTOC(0,IVEC,IVEC)
if (IVEC /= JVEC) call PTRTOC(0,JVEC,JVEC)
NLOOP = 2
if (IVEC == JVEC) NLOOP = 1
do ILOOP=1,NLOOP
  !if (ILOOP == 1) then
  !  IBRA = IVEC
  !  IKET = JVEC
  !else
  !  IBRA = JVEC
  !  IKET = IVEC
  !end if

  ! Loop over types and symmetry block of VEC1 vector:
  do ICASE1=1,13
    do ISYM1=1,NSYM
      if (NINDEP(ISYM1,ICASE1) == 0) cycle
      NIS1 = NISUP(ISYM1,ICASE1)
      NAS1 = NASUP(ISYM1,ICASE1)
      NVEC1 = NIS1*NAS1
      if (NVEC1 == 0) cycle
      ! Form VEC1 from the BRA vector, transformed to covariant form.
      call RHS_ALLO(NAS1,NIS1,LVEC1)
      call RHS_SCAL(NAS1,NIS1,LVEC1,Zero)
      if (ICASE1 <= 11) then
        call RHS_ALLO(NAS1,NIS1,LSCR)
        call RHS_READ(NAS1,NIS1,LSCR,ICASE1,ISYM1,IVEC) !! IBRA)
        if ((IVEC /= JVEC) .and. (ILOOP == 1)) then
          if (SCAL /= One) call RHS_SCAL(NAS1,NIS1,LSCR,SCAL)
          call RHS_ALLO(NAS1,NIS1,LSCR2)
          call RHS_READ(NAS1,NIS1,LSCR2,ICASE1,ISYM1,JVEC)
          call RHS_DAXPY(NAS1,NIS1,One,LSCR2,LSCR)
          call RHS_FREE(LSCR2)
        end if
        call RHS_STRANS(NAS1,NIS1,One,LSCR,LVEC1,ICASE1,ISYM1)
        call RHS_FREE(LSCR)
      else
        call RHS_READ(NAS1,NIS1,LVEC1,ICASE1,ISYM1,IVEC) !! IBRA)
        if ((IVEC /= JVEC) .and. (ILOOP == 1)) then
          if (SCAL /= One) call RHS_SCAL(NAS1,NIS1,LVEC1,SCAL)
          call RHS_ALLO(NAS1,NIS1,LSCR2)
          call RHS_READ(NAS1,NIS1,LSCR2,ICASE1,ISYM1,JVEC)
          call RHS_DAXPY(NAS1,NIS1,One,LSCR2,LVEC1)
          call RHS_FREE(LSCR2)
        end if
      end if
      ! Form WEC1 from VEC1, if needed.
      NWEC1 = 0
      FACT = One/real(max(1,NACTEL),kind=wp)
      if (ICASE1 == 1) NWEC1 = NASH(ISYM1)*NISH(ISYM1)
      if (ICASE1 == 4) NWEC1 = NASH(ISYM1)*NSSH(ISYM1)
      if ((ICASE1 == 5) .and. (ISYM1 == 1)) NWEC1 = NIS1
      if (NWEC1 > 0) then
        call mma_allocate(WEC1,NWEC1,Label='WEC1')
        WEC1(:) = Zero
        IMLTOP = 1
#       ifdef _MOLCAS_MPP_
        if (IS_REAL_PAR()) then
          call mma_allocate(TMP1,NVEC1,Label='TMP1')
          call RHS_GET(NAS1,NIS1,LVEC1,TMP1)
          if (ICASE1 == 1) then
            call SPEC1A(IMLTOP,FACT,ISYM1,TMP1,NVEC1,WEC1,NWEC1)
          else if (ICASE1 == 4) then
            call SPEC1C(IMLTOP,FACT,ISYM1,TMP1,NVEC1,WEC1,NWEC1)
          else if ((ICASE1 == 5) .and. (ISYM1 == 1)) then
            call SPEC1D(IMLTOP,FACT,TMP1,NVEC1,WEC1,NWEC1)
          end if
          call mma_deallocate(TMP1)
        else
#       endif
          if (ICASE1 == 1) then
            call SPEC1A(IMLTOP,FACT,ISYM1,GA_Arrays(LVEC1)%A,size(GA_Arrays(LVEC1)%A),WEC1,NWEC1)
          else if (ICASE1 == 4) then
            call SPEC1C(IMLTOP,FACT,ISYM1,GA_Arrays(LVEC1)%A,size(GA_Arrays(LVEC1)%A),WEC1,NWEC1)
          else if ((ICASE1 == 5) .and. (ISYM1 == 1)) then
            call SPEC1D(IMLTOP,FACT,GA_Arrays(LVEC1)%A,size(GA_Arrays(LVEC1)%A),WEC1,NWEC1)
          end if
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      else
        NWEC1 = 1
        call mma_allocate(WEC1,NWEC1,Label='WEC1')
      end if
      ! Note: WEC1 is identical to <IBRA| E(p,q) |0> for the cases
      ! (p,q)=(t,i), (a,t), and (a,i), resp.
      do ICASE2=ICASE1+1,13
        if (IFCOUP(ICASE2,ICASE1) == 0) cycle
        do ISYM2=1,NSYM
          if (NINDEP(ISYM2,ICASE2) == 0) cycle
          NIS2 = NISUP(ISYM2,ICASE2)
          NAS2 = NASUP(ISYM2,ICASE2)
          NVEC2 = NIS2*NAS2
          if (NVEC2 == 0) cycle
          call RHS_ALLO(NAS2,NIS2,LVEC2)
          call RHS_READ(NAS2,NIS2,LVEC2,ICASE2,ISYM2,IVEC) !! IKET)
          if ((IVEC /= JVEC) .and. (ILOOP == 2)) then
            if (SCAL /= One) call RHS_SCAL(NAS2,NIS2,LVEC2,SCAL)
            call RHS_ALLO(NAS2,NIS2,LSCR2)
            call RHS_READ(NAS2,NIS2,LSCR2,ICASE2,ISYM2,JVEC)
            call RHS_DAXPY(NAS2,NIS2,One,LSCR2,LVEC2)
            call RHS_FREE(LSCR2)
          end if
#         ifdef _MOLCAS_MPP_
          if (IS_REAL_PAR()) then
            call mma_allocate(TMP1,NVEC1,Label='TMP1')
            call mma_allocate(TMP2,NVEC2,Label='TMP2')
            call RHS_GET(NAS1,NIS1,LVEC1,TMP1)
            call RHS_GET(NAS2,NIS2,LVEC2,TMP2)
            call OFFDNS(ISYM1,ICASE1,ISYM2,ICASE2,WEC1,NWEC1,TMP1,nVEC1,DPT2,mDPT2,TMP2,nVEC2,LISTS,size(LISTS))
            call mma_deallocate(TMP1)
            call mma_deallocate(TMP2)
          else
#         endif
            call OFFDNS(ISYM1,ICASE1,ISYM2,ICASE2,WEC1,NWEC1,GA_Arrays(LVEC1)%A,size(GA_Arrays(LVEC1)%A),DPT2,MDPT2, &
                        GA_Arrays(LVEC2)%A,size(GA_Arrays(LVEC2)%A),LISTS,size(LISTS))
#         ifdef _MOLCAS_MPP_
          end if
#         endif
          call RHS_FREE(LVEC2)
        end do
      end do
      call RHS_FREE(LVEC1)
      call mma_deallocate(WEC1)
    end do
  end do

end do

call GADGOP(DPT2,NDPT2,'+')

if (IVEC /= JVEC) then
  ! Transpose the density matrix.
  call mma_allocate(SCR,NDPT2,Label='SCR')
  ISTA = 1
  do ISYM=1,NSYM
    NO = NORB(ISYM)
    call TRNSPS(NO,NO,DPT2(ISTA),SCR)
    DPT2(ISTA:ISTA+NO**2-1) = SCR(1:NO**2)
    ISTA = ISTA+NO**2
  end do
  call mma_deallocate(SCR)
end if

! Transform vectors back to eigenbasis of H0(diag).
call PTRTOSR(1,IVEC,IVEC)
if (IVEC /= JVEC) call PTRTOSR(1,JVEC,JVEC)
if (IVEC == JVEC) then
  ! Fill in lower-triangular block elements by symmetry.
  IDOFF = 0
  do ISYM=1,NSYM
    NI = NISH(ISYM)
    NA = NASH(ISYM)
    NO = NORB(ISYM)
    do IP=1,NI+NA
      do IQ=NI+1,NO
        IDPQ = IDOFF+IP+NO*(IQ-1)
        IDQP = IDOFF+IQ+NO*(IP-1)
        DPT2(IDQP) = DPT2(IDPQ)
      end do
    end do
    IDOFF = IDOFF+NO**2
  end do
end if

end subroutine TRDNS2O

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  ChoLoc
!
!> @brief
!>   Cholesky decompose density to obtain Cholesky localized orbitals
!> @author T. B. Pedersen
!>
!> @details
!> Localize orbitals by Cholesky decomposition of the density
!> matrix. The threshold should be set such that the
!> decomposition is essentially exact (e.g. ``1.0e-12_wp``). If not, you
!> might risk that the localization fails (non-zero return code),
!> since the number of Cholesky vectors will be less than the
!> number of occupied (\p nOcc) molecular orbitals. On sucessful
!> completion, \p irc = ``0`` is returned.
!>
!> @note
!> The density matrix is destroyed during the localization!
!>
!> @param[out]    irc  Return code
!> @param[in,out] Dens Density matrix
!> @param[out]    CMO  Cholesky MO coefficients
!> @param[in]     Thrs Threshold for decomposition
!> @param[out]    xNrm Total norm of Cholesky vectors
!> @param[in]     nBas Number of basis functions
!> @param[in]     nOcc Number of occupied orbitals
!***********************************************************************

subroutine ChoLoc(irc,Dens,CMO,Thrs,xNrm,nBas,nOcc)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nBas, nOcc
real(kind=wp), intent(inout) :: Dens(nBas,nBas)
real(kind=wp), intent(out) :: CMO(nBas,nOcc), xNrm
real(kind=wp), intent(in) :: Thrs
integer(kind=iwp) :: nVec
character(len=*), parameter :: SecNam = 'ChoLoc'
real(kind=wp), external :: ddot_

irc = 0
xNrm = -huge(xNrm)

nVec = 0
call CD_InCore(Dens,nBas,CMO,nOcc,nVec,Thrs,irc)
if (irc /= 0) then
  write(u6,*) SecNam,': CD_InCore returned ',irc
  return
else if (nVec /= nOcc) then
  write(u6,*) SecNam,': nVec /= nOcc'
  write(u6,*) '   nVec,nOcc = ',nVec,nOcc
  irc = 1
  return
end if

xNrm = sqrt(dDot_(nBas*nOcc,CMO,1,CMO,1))

end subroutine ChoLoc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Darwin(Zeta,P,nZeta,A,Axyz,la,RB,Bxyz,lb,rFinal,iStabM,nStabM,nComp,rKappa)
!***********************************************************************
!                                                                      *
! Object: to compoute the 1-electron Darwin contact term.              *
!                                                                      *
!     Author: Roland Lindh, Dept. Of Theoretical Chemistry,            *
!             University of Lund, Sweden, February '91                 *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Zero, One, Half, Pi, c_in_au
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nStabM, iStabM(0:nStabM-1), nComp
real(kind=wp), intent(in) :: Zeta(nZeta), P(nZeta,3), A(3), RB(3), rKappa(nZeta)
real(kind=wp), intent(out) :: Axyz(nZeta,3,0:la), Bxyz(nZeta,3,0:lb), rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nComp)
#include "print.fh"
integer(kind=iwp) :: ia, ib, iCar, iDCRT(0:7), ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyb, iza, izb, kCnt, kCnttp, kdc, lDCRT, &
                     LmbdT, nDCRT
real(kind=wp) :: C(3), Fact, Factor, TC(3)

iRout = 170
iPrint = nPrint(iRout)
if (iPrint >= 99) then
  call RecPrt(' In Darwin: rKappa',' ',rKappa,nZeta,1)
  call RecPrt(' In Darwin: Zeta',' ',Zeta,nZeta,1)
  call RecPrt(' In Darwin: P',' ',P,nZeta,3)
end if

rFinal(:,:,:,:) = Zero

kdc = 0
do kCnttp=1,nCnttp
  if (dbsc(kCnttp)%Aux .or. dbsc(kCnttp)%ECP .or. dbsc(kcnttp)%Frag) exit
  do kCnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    do lDCRT=0,nDCRT-1
      call OA(iDCRT(lDCRT),C,TC)

      ! Compute the value of the angular components associated
      ! to the basis functions centered on the first center.

      Axyz(:,:,0) = One

      if (la /= 0) then
        do iCar=1,3

          Axyz(:,iCar,1) = TC(iCar)-A(iCar)

          do ia=2,la
            Axyz(:,iCar,ia) = Axyz(:,iCar,1)*Axyz(:,iCar,ia-1)
          end do

        end do
      end if

      ! Compute the value of the angular components associated to
      ! the basis functions centered on the second center.

      Bxyz(:,:,0) = One

      ! Modify z-component to carry the charge and the exponential contribution.

      Bxyz(:,3,0) = dbsc(kCnttp)%Charge*exp(-Zeta*((TC(1)-P(:,1))**2+(TC(2)-P(:,2))**2+(TC(3)-P(:,3))**2))

      if (lb /= 0) then
        do iCar=1,3

          Bxyz(:,iCar,1) = TC(iCar)-RB(iCar)

          do ib=2,lb
            Bxyz(:,iCar,ib) = Bxyz(:,iCar,1)*Bxyz(:,iCar,ib-1)
          end do
        end do

        ! Modify z-components with the exponential contribution

        do ib=1,lb
          Bxyz(:,3,ib) = Bxyz(:,3,ib)*Bxyz(:,3,0)
        end do
      end if

      ! Combine contributions from the various angular components.

      do ixa=la,0,-1
        do ixb=lb,0,-1
          do iya=la-ixa,0,-1
            iza = la-ixa-iya
            ipa = C_Ind(la,ixa,iza)
            do iyb=lb-ixb,0,-1
              izb = lb-ixb-iyb
              ipb = C_Ind(lb,ixb,izb)
              rFinal(:,ipa,ipb,1) = rFinal(:,ipa,ipb,1)+Fact*Axyz(:,1,ixa)*Axyz(:,2,iya)*Axyz(:,3,iza)*Bxyz(:,1,ixb)* &
                                    Bxyz(:,2,iyb)*Bxyz(:,3,izb)
            end do
          end do
        end do
      end do

    end do
  end do
  kdc = kdc+dbsc(kCnttp)%nCntr
end do

! Factor from operator (pi/(2*c**2), c=137.036 au)

Factor = Pi*Half/c_in_au**2
do ipa=1,nTri_Elem1(la)
  do ipb=1,nTri_Elem1(lb)
    rFinal(:,ipa,ipb,1) = rKappa*Factor*rFinal(:,ipa,ipb,1)
  end do
end do

return

end subroutine Darwin

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NQGrid_Init()
      Implicit Real*8 (A-H,O-Z)
#include "grid_on_disk.fh"
      Integer Other_Type
      Parameter (Other_Type=2)
*                                                                      *
************************************************************************
*                                                                      *
*     Make the grid file dirty
*
*---- Open the file.
      Lu_Grid=77
      Call DaName_MF_WA(Lu_Grid,'NQGRID')
*
*---- Write the status flag and disk addresses fo the sets.
*
      iDisk_Set(Final)=-1
      iDisk_Set(Intermediate)=-1
      G_S(Final)=Regenerate
      G_S(Intermediate)=Regenerate
      Old_Functional_Type=Other_Type
*
      iDisk_Grid=0
      Call iDaFile(Lu_Grid,1,G_S,5,iDisk_Grid)
*
      iDisk_Set(Final)=iDisk_Grid
      iDisk_Set(Intermediate)=iDisk_Grid
*
      iDisk_Grid=0
      Call iDaFile(Lu_Grid,1,G_S,5,iDisk_Grid)
*
      Call DaClos(Lu_Grid)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ZEEM_SA(N,H,dX,dY,dZ,W,M,sM,S,zJ,WM,ZM,DBG,RWORK,HZEE,WORK,W_c)

use Index_Functions, only: iTri, nTri_Elem
use Constants, only: Zero, cZero, cOne, cm_s, hPlanck, mBohr
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: H, dX, dY, dZ, W(N), S(3), zJ
complex(kind=wp), intent(in) :: M(3,N,N), sM(3,N,N)
real(kind=wp), intent(out) :: WM(N), RWORK(3*N-2)
complex(kind=wp), intent(out) :: ZM(N,N), HZEE(nTri_Elem(N)), WORK(2*N-1), W_c(N)
logical(kind=iwp), intent(in) :: DBG
integer(kind=iwp) :: i, info, j
complex(kind=wp) :: dX_c, dY_c, dZ_c, H_c, mB_c, P, R, RP, S_c(3), zJ_c
real(kind=wp), parameter :: mB = mBohr/(cm_s*hPlanck) ! in cm-1*T-1

! initialization

WM(:) = Zero
RWORK(:) = Zero
ZM(:,:) = cZero
HZEE(:) = cZero
WORK(:) = cZero

info = 0
if (DBG) then
  write(u6,'(A,4ES20.10)') 'dX,dY,dZ,H =',dX,dY,dZ,H
  write(u6,'(A,4ES20.10)') 'Sx,y,z=',S(1),S(2),S(3)
  write(u6,*) 'zJ = ',zJ
end if

! initialize
H_c = H*cOne
dX_c = dX*cOne
dY_c = dY*cOne
dZ_c = dZ*cOne
zJ_c = zJ*cOne
mB_c = mB*cOne
W_c(:) = W(:)*cOne
S_c(:) = S(:)*cOne

if (DBG) then
  write(u6,*) ' H_c = ',H_c
  write(u6,*) 'dX_c = ',dX_c
  write(u6,*) 'dY_c = ',dY_c
  write(u6,*) 'dZ_c = ',dZ_c
  write(u6,*) 'zJ_c = ',zJ_c
  write(u6,*) 'mB_c = ',mB_c
end if

! build the Zeeman Hamiltonian
if (abs(zJ) < tiny(zJ)) then
  ! zJ = 0

  do i=1,N
    do j=1,i
      R = dX_c*M(1,j,i)+dY_c*M(2,j,i)+dZ_c*M(3,j,i)

      HZEE(iTri(i,j)) = HZEE(iTri(i,j))-mB_c*H_c*R

    end do
  end do

else ! zJ /= 0

  do i=1,N
    do j=1,i
      R = dX_c*M(1,j,i)+dY_c*M(2,j,i)+dZ_c*M(3,j,i)

      P = dX_c*SM(1,j,i)*S_c(1)+dY_c*SM(2,j,i)*S_c(2)+dZ_c*SM(3,j,i)*S_c(3)

      RP = mB_c*H_c*R+zJ_c*P

      HZEE(iTri(i,j)) = HZEE(iTri(i,j))-RP
    end do
  end do

end if ! zJ

! add diagonal energies:
do i=1,N
  HZEE(iTri(i,i)) = HZEE(iTri(i,i))+W_c(i)
end do

if (DBG) then
  write(u6,'(A)') 'HZEE:'
  do i=1,N
    do j=1,i
      write(u6,'(2i3,2x,100(2ES16.8,2x))') i,j,HZEE(iTri(i,j))
    end do
  end do
end if
! diagonalization
call zhpev_('V','U',N,HZEE,WM,ZM,N,WORK,RWORK,INFO)

if (DBG) then
  do i=1,N
    write(u6,'(A,i3,A,F20.13,A,i2,A,99(2F16.10,1x))') 'WM(',i,')=',WM(i)!,' ZM(j,',i,'):',(ZM(j,i),j=1,N)
  end do
end if

return

end subroutine ZEEM_SA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! Module_calcu  Completed LOOP multiply MOs and partly complete DM1 and

! SUBROUTINE lp10_arbrbr_ext_calcuvalue_G
! SUBROUTINE lp11_arblbr_ext_calcuvalue_G
! SUBROUTINE lp12_arblbl_ext_calcuvalue_G
! SUBROUTINE lp9_drlbl_ext_calcuvalue_wyb_G
! SUBROUTINE lp_ar_coe_sd_calcuvalue_wyb_G
! SUBROUTINE lp_ar_coe_td_calcuvalue_wyb_G
! SUBROUTINE lp_ar_coe_dv_calcuvalue_wyb_G
! SUBROUTINE lp_arbr_ext_svtv_calcuvalue_wyb_G
! SUBROUTINE lp_drr_ext_svtv_calcuvalue_wyb_G
! SUBROUTINE lp_arbl_ext_ss_calcuvalue_G
! SUBROUTINE lp_arbl_ext_st_calcuvalue_G
! SUBROUTINE lp_arbl_ext_ts_calcuvalue_G
! SUBROUTINE lp_arbl_ext_tt_calcuvalue_G
! SUBROUTINE lp_arbl_ext_dd_calcuvalue_G
! SUBROUTINE lp_drl_ext_SS_calcuvalue_G
! SUBROUTINE lp_drl_ext_ST_calcuvalue_G
! SUBROUTINE lp_drl_ext_TS_calcuvalue_G
! SUBROUTINE lp_drl_ext_TT_calcuvalue_G
! SUBROUTINE lp_drl_ext_dd_calcuvalue_wyb_G
! SUBROUTINE lp678_ext_wyb_calcuvalue_G_1
! SUBROUTINE lp678_ext_wyb_calcuvalue_G_2
! SUBROUTINE lp_drl_sum_SS_calcuvalue_G
! SUBROUTINE lp_drl_sum_TT_calcuvalue_G
! SUBROUTINE lp8_drlbr_sum_calcuvalue_wyb_G
! SUBROUTINE lp9_drlbl_sum_calcuvalue_wyb_G
! SUBROUTINE gsd_ext_sequence_G

subroutine lp_drl_ext_SS_calcuvalue_G(lri,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, logic_g2g4a, ng_sm, norb_number, value_lpext, &
                         value_lpext1, w0_plp, w0g2a, w0g36a, w1_plp, w1g2a, w1g36a
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ibend, ibsta, ira, irb, ivalue, lmb, lra, lrb, nxo
real(kind=wp) :: w0lp, w1lp

ivalue = 0

! G2G4b
if (logic_g2g4a) then
  w0lp = w0_plp*w0g2a
  w1lp = w1_plp*w1g2a

  do lmb=1,ng_sm
    ibsta = ibsm_ext(lmb)
    ibend = iesm_ext(lmb)
    do irb=ibsta,ibend
      lrb = norb_number(irb)
      do ira=ibsta,irb-1
        lra = norb_number(ira)

        ivalue = ivalue+2
        ! Drl -- B^lA^r =4_3
        call TRANS_IJKL_INTPOS(lra,lrb,lri,lri,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = -Two*w0lp

        call TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = (w0lp-w1lp)

      end do
    end do
  end do
end if

w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a

do lmb=1,ng_sm
  ibsta = ibsm_ext(lmb)
  ibend = iesm_ext(lmb)
  do irb=ibsta,ibend
    lrb = norb_number(irb)
    do ira=ibsta,irb-1
      lra = norb_number(ira)
      ivalue = ivalue+1

      call TRANS_IJKL_INTPOS(lra,lrb,lri,lri,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = -Two*w0lp

      call TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
      index_lpext1(ivalue) = NXO
      value_lpext1(ivalue) = (w0lp-w1lp)

    end do
  end do
end do
nlp_value = ivalue

end subroutine lp_drl_ext_SS_calcuvalue_G

subroutine lp_drl_ext_ST_calcuvalue_G(lri,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, ism_g1415, logic_g1415, logic_g2g4b, ng_sm, norb_number, &
                         value_lpext, value_lpext1, w1_plp, w1g14a, w1g36a, w1g4b
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ira, irb, isma, ismb, ivalue, lmb, lra, lrb, nxo
real(kind=wp) :: w1lp

ivalue = 0
! G1415
if (logic_g1415) then

  w1lp = w1_plp*w1g14a
  !=========================lyb=========================================
  ! THE W1LP SHOULD BE MULTIPLED BY TWO,BECAUSE WE JUST USE HALF OF THEM
  ! IS H*C CALCULATIONS, ???

  w1lp = w1lp*Two

  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        lra = norb_number(ia)

        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w1lp

        call TRANS_IJKL_INTPOS(lrb,LRI,lrb,LRI,NXO)

        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = -w1lp

      end do
    end do
  end do
end if

! G2G4b
if (logic_g2g4b) then
  w1lp = w1_plp*w1g4b
  do lmb=1,ng_sm
    ibsta = ibsm_ext(lmb)
    ibend = iesm_ext(lmb)
    do irb=ibsta,ibend
      lrb = norb_number(irb)
      do ira=ibsta,irb-1
        lra = norb_number(ira)

        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = -w1lp

        ivalue = ivalue+1
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w1lp

      end do
    end do
  end do
end if

w1lp = w1_plp*w1g36a
do lmb=1,ng_sm
  ibsta = ibsm_ext(lmb)
  ibend = iesm_ext(lmb)
  do irb=ibsta,ibend
    lrb = norb_number(irb)
    do ira=ibsta,irb-1
      lra = norb_number(ira)
      ivalue = ivalue+1
      call TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = -w1lp
    end do
  end do
end do
nlp_value = ivalue

end subroutine lp_drl_ext_ST_calcuvalue_G

subroutine lp_drl_ext_TT_calcuvalue_G(lri,n1415_value,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, ism_g1415, logic_g1415, ng_sm, norb_number, value_lpext, &
                         value_lpext1, w0_plp, w0g14a, w0g15a, w0g36a, w1_plp, w1g14a, w1g15a, w1g36a
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: n1415_value, nlp_value
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ira, irb, isma, ismb, ivalue, lmb, lra, lrb, nxo
real(kind=wp) :: w014, w015, w0lp, w114, w115, w14lp, w15lp, w1lp

ivalue = 0
! G1415
if (logic_g1415) then

  w014 = w0_plp*w0g14a
  w114 = w1_plp*w1g14a
  w015 = w0_plp*w0g15a
  w115 = w1_plp*w1g15a

  w14lp = w014-w114
  w15lp = w015-w115
  !=========================lyb=========================================
  ! THE W1LP SHOULD BE MULTIPLED BY TWO,BECAUSE WE JUST USE HALF OF THEM
  ! IS H*C CALCULATIONS, ???

  w14lp = w14lp*Two
  w15lp = w15lp*Two

  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        lra = norb_number(ia)
        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w15lp
        call TRANS_IJKL_INTPOS(lrb,LRI,lrb,LRI,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = w14lp
      end do
    end do
  end do
end if

n1415_value = ivalue

w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a

do lmb=1,ng_sm
  ibsta = ibsm_ext(lmb)
  ibend = iesm_ext(lmb)
  do irb=ibsta,ibend
    lrb = norb_number(irb)
    do ira=ibsta,irb-1
      lra = norb_number(ira)
      ivalue = ivalue+1

      call TRANS_IJKL_INTPOS(lra,lrb,lri,lri,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = -Two*w0lp

      call TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
      index_lpext1(ivalue) = NXO
      value_lpext1(ivalue) = (w0lp-w1lp)

    end do
  end do
end do
nlp_value = ivalue

end subroutine lp_drl_ext_TT_calcuvalue_G

subroutine lp_drl_SUM_TT_calcuvalue_G(lri,n1415_value,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, ism_g1415, logic_g1415, ng_sm, norb_number, value_lpext, &
                         value_lpext1, w0_plp, w0g14a, w0g15a, w0g36a, w1_plp, w1g14a, w1g15a
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: n1415_value, nlp_value
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ira, irb, isma, ismb, ivalue, lmb, lra, lrb, nxo
real(kind=wp) :: w014, w015, w0lp, w114, w115, w14lp, w15lp

ivalue = 0
! G1415
if (logic_g1415) then

  w014 = w0_plp*w0g14a
  w114 = w1_plp*w1g14a
  w015 = w0_plp*w0g15a
  w115 = w1_plp*w1g15a

  w14lp = w014-w114
  w15lp = w015-w115
  !=========================lyb=========================================
  ! THE W1LP SHOULD BE MULTIPLED BY TWO,BECAUSE WE JUST USE HALF OF THEM
  ! IS H*C CALCULATIONS, ???

  w14lp = w14lp*Two
  w15lp = w15lp*Two
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        lra = norb_number(ia)
        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w15lp
        call TRANS_IJKL_INTPOS(lrb,LRI,lrb,LRI,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = w14lp
      end do
    end do
  end do
end if

n1415_value = ivalue

w0lp = w0_plp*w0g36a

do lmb=1,ng_sm
  ibsta = ibsm_ext(lmb)
  ibend = iesm_ext(lmb)
  do irb=ibsta,ibend
    lrb = norb_number(irb)
    do ira=ibsta,irb-1
      lra = norb_number(ira)
      ivalue = ivalue+1
      call TRANS_IJKL_INTPOS(lra,lrb,lri,lri,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = -Two*w0lp
      call TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
      index_lpext1(ivalue) = NXO
      value_lpext1(ivalue) = w0lp
    end do
  end do
end do
nlp_value = ivalue

end subroutine lp_drl_SUM_TT_calcuvalue_G

subroutine lp_drl_ext_TS_calcuvalue_G(lri,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, ism_g1415, logic_g1415, logic_g2g4a, ng_sm, norb_number, &
                         value_lpext, value_lpext1, w1_plp, w1g14a, w1g2a, w1g36a
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ira, irb, isma, ismb, ivalue, lmb, lra, lrb, nxo
real(kind=wp) :: w1lp

ivalue = 0
! G1415
if (logic_g1415) then

  w1lp = w1_plp*w1g14a
  !=========================lyb=========================================
  ! THE W1LP SHOULD BE MULTIPLED BY TWO,BECAUSE WE JUST USE HALF OF THEM
  ! IS H*C CALCULATIONS, ???

  w1lp = w1lp*Two
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        lra = norb_number(ia)
        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w1lp
        call TRANS_IJKL_INTPOS(lrb,LRI,lrb,LRI,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = -w1lp
      end do
    end do
  end do
end if

! G2G4b
if (logic_g2g4a) then
  !w0lp = w0_plp*w0g2a
  w1lp = w1_plp*w1g2a

  !valuelptmp1 = w0lp
  !w0lp = w0lp-w1lp
  !w1lp = -valuelptmp1*Two
  !valuelptmp1 = ww0lp
  !ww0lp = ww0lp-ww1lp
  !ww1lp = -valuelptmp1*Two

  do lmb=1,ng_sm
    ibsta = ibsm_ext(lmb)
    ibend = iesm_ext(lmb)
    do irb=ibsta,ibend
      lrb = norb_number(irb)
      do ira=ibsta,irb-1
        lra = norb_number(ira)

        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = -w1lp

        ivalue = ivalue+1
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w1lp
      end do
    end do
  end do
end if

w1lp = w1_plp*w1g36a

do lmb=1,ng_sm
  ibsta = ibsm_ext(lmb)
  ibend = iesm_ext(lmb)
  do irb=ibsta,ibend
    lrb = norb_number(irb)
    do ira=ibsta,irb-1
      lra = norb_number(ira)
      ivalue = ivalue+1
      call TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = -w1lp
    end do
  end do
end do
nlp_value = ivalue

end subroutine lp_drl_ext_TS_calcuvalue_G

subroutine lp_arbl_ext_st_calcuvalue_G(lri,lrj,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, ism_g1415, logic_g13, logic_g1415, logic_g2g4a, &
                         logic_g2g4b, lsm_inn, ng_sm, norb_ext, norb_number, value_lpext, value_lpext1, w0_plp, w0g13a, w0g14a, &
                         w0g15a, w0g2a, w0g2b, w0g36a, w0g36b, w0g4a, w0g4b, w1_plp, w1g14a, w1g15a, w1g2a, w1g2b, w1g36a, w1g36b, &
                         w1g4a, w1g4b
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, isma, ismb, ivalue, lra, lrb, lsma, lsmb, lsmi, lsmij, lsmj, nxo
real(kind=wp) :: valuelptmp1, w0lp, w1lp, ww0lp, ww1lp

ivalue = 0
! G1415
if (logic_g1415) then

  w0lp = w0_plp*w0g14a
  w1lp = w1_plp*w1g14a
  ww0lp = w0_plp*w0g15a
  ww1lp = w1_plp*w1g15a

  valuelptmp1 = w0lp
  w0lp = w0lp-w1lp
  w1lp = -valuelptmp1*Two
  valuelptmp1 = ww0lp
  ww0lp = ww0lp-ww1lp
  ww1lp = -valuelptmp1*Two

  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        lra = norb_number(ia)

        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(LRJ,lrb,LRI,lrb,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w0lp
        call TRANS_IJKL_INTPOS(LRJ,LRI,lrb,lrb,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = w1lp

        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(LRJ,lra,LRI,lra,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = ww0lp
        call TRANS_IJKL_INTPOS(LRJ,LRI,lra,lra,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = ww1lp
      end do
    end do
  end do
end if
! G13
if (logic_g13) then
  w0lp = w0g13a*w0_plp
  do ia=1,norb_ext
    lra = norb_number(ia)

    ivalue = ivalue+1
    call TRANS_IJKL_INTPOS(LRJ,lra,LRI,lra,NXO)
    index_lpext(ivalue) = NXO
    value_lpext(ivalue) = w0lp
    call TRANS_IJKL_INTPOS(LRJ,LRI,lra,lra,NXO)
    index_lpext1(ivalue) = NXO
    value_lpext1(ivalue) = -w0lp*Two

    ivalue = ivalue+1
    index_lpext(ivalue) = 0
    index_lpext1(ivalue) = 0

  end do
end if

lsmi = lsm_inn(lri)
lsmj = lsm_inn(lrj)
lsmij = Mul(lsmi,lsmj)

! G2G4a
if (logic_g2g4a) then

  w0lp = w0_plp*w0g2a
  w1lp = w1_plp*w1g2a
  ww0lp = w0_plp*w0g4a
  ww1lp = w1_plp*w1g4a

  valuelptmp1 = w0lp
  w0lp = w0lp-w1lp
  w1lp = -valuelptmp1*Two
  valuelptmp1 = ww0lp
  ww0lp = ww0lp-ww1lp
  ww1lp = -valuelptmp1*Two

  do lsmb=1,ng_sm
    lsma = Mul(lsmij,lsmb)
    if (lsma > lsmb) cycle
    ibsta = ibsm_ext(lsmb)
    ibend = iesm_ext(lsmb)
    iasta = ibsm_ext(lsma)
    iaend = iesm_ext(lsma)
    if (lsmb == lsma) ibsta = ibsta+1
    do ib=ibsta,ibend
      LRB = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        LRA = norb_number(ia)
        ! ArBl -- B^lA^r =12
        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w0lp
        call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = w1lp
        ! ArBl -- B^rA^l =11
        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = ww0lp
        call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = ww1lp
      end do
    end do
  end do
else

  ! G2G4b
  if (logic_g2g4b) then

    w0lp = w0_plp*w0g2b
    w1lp = w1_plp*w1g2b
    ww0lp = w0_plp*w0g4b
    ww1lp = w1_plp*w1g4b

    valuelptmp1 = w0lp
    w0lp = w0lp-w1lp
    w1lp = -valuelptmp1*Two
    valuelptmp1 = ww0lp
    ww0lp = ww0lp-ww1lp
    ww1lp = -valuelptmp1*Two

    do lsmb=1,ng_sm
      lsma = Mul(lsmij,lsmb)
      if (lsma > lsmb) cycle
      ibsta = ibsm_ext(lsmb)
      ibend = iesm_ext(lsmb)
      iasta = ibsm_ext(lsma)
      iaend = iesm_ext(lsma)
      if (lsmb == lsma) ibsta = ibsta+1
      do ib=ibsta,ibend
        LRB = norb_number(ib)
        do ia=iasta,min(iaend,ib-1)
          LRA = norb_number(ia)
          ! ArBl -- B^lA^r =12
          ivalue = ivalue+1
          call TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
          index_lpext(ivalue) = NXO
          value_lpext(ivalue) = ww0lp
          call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
          index_lpext1(ivalue) = NXO
          value_lpext1(ivalue) = ww1lp
          ! ArBl -- B^rA^l =11
          ivalue = ivalue+1
          call TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
          index_lpext(ivalue) = NXO
          value_lpext(ivalue) = w0lp
          call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
          index_lpext1(ivalue) = NXO
          value_lpext1(ivalue) = w1lp
        end do
      end do
    end do

  end if

end if
! G36a

w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a
valuelptmp1 = w0lp
w0lp = w0lp-w1lp
w1lp = -valuelptmp1*Two
do lsmb=1,ng_sm
  lsma = Mul(lsmij,lsmb)
  if (lsma > lsmb) cycle
  ibsta = ibsm_ext(lsmb)
  ibend = iesm_ext(lsmb)
  iasta = ibsm_ext(lsma)
  iaend = iesm_ext(lsma)
  if (lsmb == lsma) ibsta = ibsta+1
  do ib=ibsta,ibend
    LRB = norb_number(ib)
    do ia=iasta,min(iaend,ib-1)
      LRA = norb_number(ia)
      ! ArBl -- B^lA^r =12
      ivalue = ivalue+1
      call TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = w0lp
      call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
      index_lpext1(ivalue) = NXO
      value_lpext1(ivalue) = w1lp
    end do
  end do
end do
! G36b

w0lp = w0_plp*w0g36b
w1lp = w1_plp*w1g36b
valuelptmp1 = w0lp
w0lp = w0lp-w1lp
w1lp = -valuelptmp1*Two
do lsmb=1,ng_sm
  lsma = Mul(lsmij,lsmb)
  if (lsma > lsmb) cycle
  ibsta = ibsm_ext(lsmb)
  ibend = iesm_ext(lsmb)
  iasta = ibsm_ext(lsma)
  iaend = iesm_ext(lsma)
  if (lsmb == lsma) ibsta = ibsta+1
  do ib=ibsta,ibend
    LRB = norb_number(ib)
    do ia=iasta,min(iaend,ib-1)
      LRA = norb_number(ia)
      ivalue = ivalue+1
      ! ArBl -- B^rA^l =11
      call TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = w0lp
      call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
      index_lpext1(ivalue) = NXO
      value_lpext1(ivalue) = w1lp
    end do
  end do
end do
nlp_value = ivalue

end subroutine lp_arbl_ext_st_calcuvalue_G

subroutine lp10_arbrbr_ext_calcuvalue_G(intentry,isma,nlp_value)

use gugaci_global, only: ibsm_ext, index_lpext, index_lpext1, intind_ijka, lsm_inn, ngw2, ngw3, nlsm_ext, norb_frz, norb_inn, &
                         norb_number, value_lpext, value_lpext1, w0_sdplp, w0_sdplp25, w0g25, w1_sdplp, w1_sdplp25
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: intentry, isma
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ijk, ira, ivalue, lra, lri, lritmp, lrj, lrjtmp, lrk, lrktmp, lsmi, lsmij, lsmj, lsmk, m_ia, next_sta, nxo

w0_sdplp25 = (w0_sdplp-w1_sdplp)*w0g25
w1_sdplp25 = (w0_sdplp+w1_sdplp)*w0g25

outer: do LRITMP=NORB_FRZ+1,norb_inn-2
  lsmi = lsm_inn(LRITMP)
  do LRJTMP=LRITMP+1,norb_inn-1
    lsmj = lsm_inn(LRJTMP)
    lsmij = Mul(lsmi,lsmj)
    do LRKTMP=LRJTMP+1,norb_inn
      lsmk = lsm_inn(LRKTMP)
      if (Mul(lsmij,lsmk) /= isma) cycle
      IJK = LRITMP-NORB_FRZ+NGW2(LRJTMP-NORB_FRZ)+NGW3(LRKTMP-NORB_FRZ)
      if (INTIND_IJKA(IJK) == intentry) then
        LRI = LRITMP
        LRJ = LRJTMP
        LRK = LRKTMP
        exit outer
      end if
    end do
  end do
end do outer

next_sta = ibsm_ext(isma)-1

ivalue = 0
do m_ia=1,nlsm_ext(isma)
  ira = m_ia+next_sta
  LRA = norb_number(ira)
  ivalue = ivalue+1
  call TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRJ,NXO)
  index_lpext(ivalue) = NXO
  value_lpext(ivalue) = w0_sdplp25
  call TRANS_IJKL_INTPOS(LRA,LRJ,LRK,LRI,NXO)
  index_lpext1(ivalue) = NXO
  value_lpext1(ivalue) = w1_sdplp25
end do
nlp_value = ivalue

end subroutine lp10_arbrbr_ext_calcuvalue_G

subroutine lp11_arblbr_ext_calcuvalue_G(intentry,isma,nlp_value)

use gugaci_global, only: ibsm_ext, index_lpext, index_lpext1, intind_ijka, lsm_inn, ngw2, ngw3, nlsm_ext, norb_frz, norb_inn, &
                         norb_number, value_lpext, value_lpext1, w0_sdplp, w0_sdplp25, w0g25, w1_sdplp, w1_sdplp25
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: intentry, isma
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ijk, ira, ivalue, lra, lri, lritmp, lrj, lrjtmp, lrk, lrktmp, lsmi, lsmij, lsmj, lsmk, m_ia, next_sta, nxo

w0_sdplp25 = (w0_sdplp-w1_sdplp)*w0g25
w1_sdplp25 = -Two*w0_sdplp*w0g25

outer: do LRITMP=NORB_FRZ+1,norb_inn-2
  lsmi = lsm_inn(LRITMP)
  do LRJTMP=LRITMP+1,norb_inn-1
    lsmj = lsm_inn(LRJTMP)
    lsmij = Mul(lsmi,lsmj)
    do LRKTMP=LRJTMP+1,norb_inn
      lsmk = lsm_inn(LRKTMP)
      if (Mul(lsmij,lsmk) /= isma) cycle
      IJK = LRITMP-NORB_FRZ+NGW2(LRJTMP-NORB_FRZ)+NGW3(LRKTMP-NORB_FRZ)
      if (INTIND_IJKA(IJK) == intentry) then
        LRI = LRITMP
        LRJ = LRJTMP
        LRK = LRKTMP
        exit outer
      end if
    end do
  end do
end do outer
next_sta = ibsm_ext(isma)-1

ivalue = 0
do m_ia=1,nlsm_ext(isma)
  ira = m_ia+next_sta
  LRA = norb_number(ira)
  ivalue = ivalue+1
  call TRANS_IJKL_INTPOS(LRA,LRJ,LRK,LRI,NXO)
  index_lpext(ivalue) = NXO
  value_lpext(ivalue) = w0_sdplp25
  call TRANS_IJKL_INTPOS(LRA,LRK,LRJ,LRI,NXO)
  index_lpext1(ivalue) = NXO
  value_lpext1(ivalue) = w1_sdplp25
end do
nlp_value = ivalue

end subroutine lp11_arblbr_ext_calcuvalue_G

subroutine lp12_arblbl_ext_calcuvalue_G(intentry,isma,nlp_value)

use gugaci_global, only: ibsm_ext, index_lpext, index_lpext1, intind_ijka, lsm_inn, ngw2, ngw3, nlsm_ext, norb_frz, norb_inn, &
                         norb_number, value_lpext, value_lpext1, w0_sdplp, w0_sdplp25, w0g25, w1_sdplp, w1_sdplp25
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: intentry, isma
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ijk, ira, ivalue, lra, lri, lritmp, lrj, lrjtmp, lrk, lrktmp, lsmi, lsmij, lsmj, lsmk, m_ia, next_sta, nxo

w0_sdplp25 = (w0_sdplp-w1_sdplp)*w0g25
w1_sdplp25 = -Two*w0_sdplp*w0g25

outer: do LRITMP=NORB_FRZ+1,norb_inn-2
  lsmi = lsm_inn(LRITMP)
  do LRJTMP=LRITMP+1,norb_inn-1
    lsmj = lsm_inn(LRJTMP)
    lsmij = Mul(lsmi,lsmj)
    do LRKTMP=LRJTMP+1,norb_inn
      lsmk = lsm_inn(LRKTMP)
      if (Mul(lsmij,lsmk) /= isma) cycle
      IJK = LRITMP-NORB_FRZ+NGW2(LRJTMP-NORB_FRZ)+NGW3(LRKTMP-NORB_FRZ)
      if (INTIND_IJKA(IJK) == intentry) then
        LRI = LRITMP
        LRJ = LRJTMP
        LRK = LRKTMP
        exit outer
      end if
    end do
  end do
end do outer

next_sta = ibsm_ext(isma)-1

ivalue = 0
do m_ia=1,nlsm_ext(isma)
  ira = m_ia+next_sta
  LRA = norb_number(ira)
  ivalue = ivalue+1
  call TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRJ,NXO)
  index_lpext(ivalue) = NXO
  value_lpext(ivalue) = w0_sdplp25
  call TRANS_IJKL_INTPOS(LRA,LRK,LRJ,LRI,NXO)
  index_lpext1(ivalue) = NXO
  value_lpext1(ivalue) = w1_sdplp25
end do
nlp_value = ivalue

end subroutine lp12_arblbl_ext_calcuvalue_G

subroutine lp9_drlbl_ext_calcuvalue_G(lri,lrk,isma)

use gugaci_global, only: ibsm_ext, index_lpext, index_lpext1, nlsm_ext, norb_number, value_lpext, value_lpext1, w0_sdplp, &
                         w0_sdplp25, w0g25, w1_sdplp, w1_sdplp25
use Constants, only: Two
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrk, isma
integer(kind=iwp) :: ira, ivalue, lra, m_ia, next_sta, nxo

next_sta = ibsm_ext(isma)-1
w0_sdplp25 = (w0_sdplp-w1_sdplp)*w0g25
w1_sdplp25 = -Two*w0_sdplp*w0g25

ivalue = 0

do m_ia=1,nlsm_ext(isma)
  ira = m_ia+next_sta
  LRA = norb_number(ira)
  ivalue = ivalue+1
  call TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
  index_lpext(ivalue) = NXO
  value_lpext(ivalue) = w0_sdplp25
  call TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
  index_lpext1(ivalue) = NXO
  value_lpext1(ivalue) = w1_sdplp25
end do

end subroutine lp9_drlbl_ext_calcuvalue_G

subroutine lp8_drlbr_sum_calcuvalue_G(lri,lrk,isma,nv)

use gugaci_global, only: ibsm_ext, index_lpext, index_lpext1, nlsm_ext, norb_number, value_lpext, value_lpext1, w0_sdplp, &
                         w0_sdplp25, w0g25, w1_sdplp25
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrk, isma
integer(kind=iwp), intent(out) :: nv
integer(kind=iwp) :: ira, ivalue, lra, m_ia, next_sta, nxo

next_sta = ibsm_ext(isma)-1

w0_sdplp25 = w0_sdplp*w0g25
w1_sdplp25 = 2*w0_sdplp*w0g25

ivalue = 0
do m_ia=1,nlsm_ext(isma)
  ira = m_ia+next_sta
  LRA = norb_number(ira)
  ivalue = ivalue+1
  call TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
  index_lpext(ivalue) = NXO
  value_lpext(ivalue) = w0_sdplp25
  call TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
  index_lpext1(ivalue) = NXO
  value_lpext1(ivalue) = -w1_sdplp25
end do
nv = ivalue

end subroutine lp8_drlbr_sum_calcuvalue_G

subroutine lp9_drlbl_sum_calcuvalue_G(lri,lrk,isma,nv)

use gugaci_global, only: ibsm_ext, index_lpext, index_lpext1, nlsm_ext, norb_number, value_lpext, value_lpext1, w0_sdplp, &
                         w0_sdplp25, w0g25, w1_sdplp25
use Constants, only: Two
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrk, isma
integer(kind=iwp), intent(out) :: nv
integer(kind=iwp) :: ira, ivalue, lra, m_ia, next_sta, nxo

next_sta = ibsm_ext(isma)-1
w0_sdplp25 = w0_sdplp*w0g25
w1_sdplp25 = -Two*w0_sdplp*w0g25

ivalue = 0
do m_ia=1,nlsm_ext(isma)
  ira = m_ia+next_sta
  LRA = norb_number(ira)
  ivalue = ivalue+1
  call TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
  index_lpext(ivalue) = NXO
  value_lpext(ivalue) = w0_sdplp25
  call TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
  index_lpext1(ivalue) = NXO
  value_lpext1(ivalue) = w1_sdplp25
end do
nv = ivalue

end subroutine lp9_drlbl_sum_calcuvalue_G

subroutine gsd_ext_sequence_G(iltype,ilsm,irsm,lri)

use gugaci_global, only: ibsm_ext, icano_nnend, icano_nnsta, icnt_base, iesm_ext, iseg_downwei, isegdownwei, m_jc, m_jd, ng_sm
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iltype, ilsm, irsm, lri
integer(kind=iwp) :: ic, icano_nn, icend, icsta, ilnodedownwei, indl, isma, ismb, ismnoded, ismnodes

ismnodes = ilsm
ismnoded = irsm
indl = 0 !?
if (iltype == 2) indl = 1+ismnodes
if (iltype == 3) indl = 9+ismnodes
if (iltype == 4) indl = 17+ismnodes
ilnodedownwei = iseg_downwei(indl)
isegdownwei = ilnodedownwei
icano_nnsta = 1
icnt_base = 0
icsta = ibsm_ext(ismnoded)
icend = iesm_ext(ismnoded)
m_jc = 0

do ic=icsta,icend
  m_jd = ic
  m_jc = ic-icsta+1
  icano_nn = m_jc
  icano_nnend = icano_nn
  do ismb=1,ismnoded-1
    isma = Mul(ismnodes,ismb)
    if (isma > ismb) cycle
    call g31_diffsym_G(lri,isma,ismb)
  end do

  ismb = ismnoded
  isma = Mul(ismnodes,ismb)
  if (isma == ismb) then
    call gsd_samesym_aaa_G(lri,isma)
  else if (isma < ismb) then
    call gsd_diffsamesym_abb_G(lri,isma,ismb)
  end if

  do ismb=ismnoded+1,ng_sm
    isma = Mul(ismnodes,ismb)
    if (isma > ismb) cycle
    if (ismnoded > isma) then
      call g32a_diffsym_G(lri,isma,ismb)
    else if (ismnoded == isma) then
      call gsd_diffsamesym_aab_G(lri,isma,ismb)
    else
      call g32b_diffsym_G(lri,isma,ismb)
    end if
  end do

  if ((ismnodes == 1) .and. (iltype == 4)) then
    call gsd_arlp_s1_G(lri)
  end if
  icnt_base = icnt_base+ilnodedownwei
end do

end subroutine gsd_ext_sequence_G

subroutine lp678_ext_calcuvalue_G(lri,lrk,isma,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, nlsm_ext, norb_number, value_lpext, w0_sdplp, w0_sdplp25, &
                         w0g25
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrk, isma
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ia, iaend, iasta, ilpvalue, lra, nxo

w0_sdplp25 = w0_sdplp*w0g25
ilpvalue = 0
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
do ia=iasta,iaend
  LRA = norb_number(ia)
  ilpvalue = ilpvalue+1
  call TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
  index_lpext(ilpvalue) = NXO
  value_lpext(ilpvalue) = w0_sdplp25
  index_lpext1(ilpvalue) = 0
end do
nlp_value = nlsm_ext(isma)

end subroutine lp678_ext_calcuvalue_G

subroutine lp_ar_coe_calcuvalue_G(idtu,isma,lri,lrj,nlp_value,lpcoe,nlp_value1)

use gugaci_global, only: ibsm_ext, ican_a, index_lpext3, index_lpext4, index_lpext5, jb_sys, logic_dh, nlsm_ext, norb_dz, &
                         norb_inn, norb_number, value_lpext3, value_lpext4, value_lpext5, w0_sdplp, w0_sdplp25, w0g25
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idtu, isma, lri, lrj, lpcoe(norb_dz+1:norb_inn)
integer(kind=iwp), intent(out) :: nlp_value, nlp_value1
integer(kind=iwp) :: icoe, idorb, ilpvalue, ilpvalue1, iorb, iorbs, ira, kcoe, lend, lra, lsta, m_ia, ndorb, next_sta, nia, nocc, &
                     nsorb, nxo
real(kind=wp) :: tcoe

next_sta = ibsm_ext(isma)-1
w0_sdplp25 = w0_sdplp*w0g25
ilpvalue = 0

if (idtu == 100) then
  lsta = lri
  lend = norb_inn
  ilpvalue1 = 0
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    NIA = ICAN_A(LRA)+LRI
    ilpvalue = ilpvalue+1
    index_lpext5(ilpvalue) = NIA
    value_lpext5(ilpvalue) = w0_sdplp25

    ilpvalue1 = 0
    do iorb=lsta,lend
      KCOE = lpcoe(iorb)
      call NEOC(KCOE,NOCC,TCOE)

      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25*nocc*tcoe
      call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
      index_lpext4(ilpvalue,ilpvalue1) = NXO
      value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*nocc

    end do
  end do
  nlp_value = nlsm_ext(isma)
  nlp_value1 = ilpvalue1
  return
end if

if (idtu == 51) then
  lsta = lri
  lend = norb_DZ
  ilpvalue1 = 0
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    NIA = ICAN_A(LRA)+LRI
    ilpvalue = ilpvalue+1
    index_lpext5(ilpvalue) = NIA
    value_lpext5(ilpvalue) = w0_sdplp25

    ilpvalue1 = 0
    if (LOGIC_DH) then
      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25
      index_lpext4(ilpvalue,ilpvalue1) = 0

      do idorb=lsta+1,lend
        ilpvalue1 = ilpvalue1+1
        call TRANS_IJKL_INTPOS(LRA,idorb,LRI,idorb,NXO)
        index_lpext3(ilpvalue,ilpvalue1) = NXO
        value_lpext3(ilpvalue,ilpvalue1) = -w0_sdplp25
        call TRANS_IJKL_INTPOS(LRA,LRI,idorb,idorb,NXO)
        index_lpext4(ilpvalue,ilpvalue1) = NXO
        value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*Two

      end do
    end if
    iorbs = max(norb_dz+1,lri)
    do iorb=iorbs,norb_inn
      Kcoe = lpcoe(iorb)
      call NEOC(KCOE,NOCC,TCOE)
      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25*nocc*tcoe
      call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
      index_lpext4(ilpvalue,ilpvalue1) = NXO
      value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*nocc
    end do
  end do
  nlp_value = nlsm_ext(isma)
  nlp_value1 = ilpvalue1
  return
end if

if ((idtu == 25) .or. (idtu == 43)) then
  ilpvalue1 = 0
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    NIA = ICAN_A(LRA)+LRI
    ilpvalue = ilpvalue+1
    index_lpext5(ilpvalue) = NIA
    value_lpext5(ilpvalue) = w0_sdplp25

    ilpvalue1 = 0

    ilpvalue1 = ilpvalue1+1
    call TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
    index_lpext3(ilpvalue,ilpvalue1) = NXO
    value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25
    index_lpext4(ilpvalue,ilpvalue1) = 0

    do idorb=lri+1,norb_dz
      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,idorb,LRI,idorb,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = -w0_sdplp25
      call TRANS_IJKL_INTPOS(LRA,LRI,idorb,idorb,NXO)
      index_lpext4(ilpvalue,ilpvalue1) = NXO
      value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*Two
    end do
    iorbs = max(norb_dz+1,lri)
    do iorb=iorbs,norb_inn
      Kcoe = lpcoe(iorb)
      call NEOC(KCOE,NOCC,TCOE)
      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25*nocc*tcoe
      call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
      index_lpext4(ilpvalue,ilpvalue1) = NXO
      value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*nocc
    end do
  end do
  nlp_value = nlsm_ext(isma)
  nlp_value1 = ilpvalue1
  return
end if

if (idtu == 26) then
  lsta = lri
  lend = norb_DZ
  ilpvalue1 = 0
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    NIA = ICAN_A(LRA)+LRI
    ilpvalue = ilpvalue+1
    index_lpext5(ilpvalue) = NIA
    value_lpext5(ilpvalue) = w0_sdplp25

    ilpvalue1 = 0

    if (LOGIC_DH) then
      do idorb=lsta+1,lend
        ilpvalue1 = ilpvalue1+1
        call TRANS_IJKL_INTPOS(LRA,idorb,LRI,idorb,NXO)
        index_lpext3(ilpvalue,ilpvalue1) = NXO
        value_lpext3(ilpvalue,ilpvalue1) = -w0_sdplp25
        call TRANS_IJKL_INTPOS(LRA,LRI,idorb,idorb,NXO)
        index_lpext4(ilpvalue,ilpvalue1) = NXO
        value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*Two
      end do
    end if
    do iorb=norb_dz+1,norb_inn
      Kcoe = lpcoe(iorb)
      call NEOC(KCOE,NOCC,TCOE)
      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25*nocc*tcoe
      call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
      index_lpext4(ilpvalue,ilpvalue1) = NXO
      value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*nocc
    end do
  end do
  nlp_value = nlsm_ext(isma)
  nlp_value1 = ilpvalue1
  return
end if
if ((idtu == 28) .or. (idtu == 46)) then
  nsorb = 1
  ndorb = norb_DZ-lri-1
  icoe = 0
  if (ndorb > 0) nsorb = 1
  if (idtu == 28) icoe = -(JB_SYS+2)
  if (idtu == 46) icoe = 0
  ilpvalue1 = 0
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    NIA = ICAN_A(LRA)+LRI
    ilpvalue = ilpvalue+1
    index_lpext5(ilpvalue) = NIA
    value_lpext5(ilpvalue) = w0_sdplp25

    ilpvalue1 = 0

    ilpvalue1 = ilpvalue1+1
    call TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
    index_lpext3(ilpvalue,ilpvalue1) = NXO
    value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25
    index_lpext4(ilpvalue,ilpvalue1) = 0

    if (nsorb > 0) then
      do iorb=lri+1,norb_dz
        if (iorb == lrj) then
          ilpvalue1 = ilpvalue1+1
          call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
          index_lpext3(ilpvalue,ilpvalue1) = NXO
          value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25*icoe
          call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
          index_lpext4(ilpvalue,ilpvalue1) = NXO
          value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25
        end if
        if (iorb /= lrj) then
          ilpvalue1 = ilpvalue1+1
          call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
          index_lpext3(ilpvalue,ilpvalue1) = NXO
          value_lpext3(ilpvalue,ilpvalue1) = -w0_sdplp25
          call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
          index_lpext4(ilpvalue,ilpvalue1) = NXO
          value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*Two
        end if
      end do
    end if
    do iorb=norb_dz+1,norb_inn
      Kcoe = lpcoe(iorb)
      call NEOC(KCOE,NOCC,TCOE)
      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25*nocc*tcoe
      call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
      index_lpext4(ilpvalue,ilpvalue1) = NXO
      value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*nocc
    end do
  end do
  nlp_value = nlsm_ext(isma)
  nlp_value1 = ilpvalue1
  return
end if
if ((idtu == 57) .or. (idtu == 29)) then
  nsorb = 1
  ndorb = norb_DZ-lri-1
  if (ndorb > 0) nsorb = 1
  if (idtu == 29) then
    icoe = JB_SYS
  else ! if (idtu == 57)
    icoe = -1
  end if
  ilpvalue1 = 0
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    NIA = ICAN_A(LRA)+LRI
    ilpvalue = ilpvalue+1
    index_lpext5(ilpvalue) = NIA
    value_lpext5(ilpvalue) = w0_sdplp25

    ilpvalue1 = 0

    ilpvalue1 = ilpvalue1+1
    call TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
    index_lpext3(ilpvalue,ilpvalue1) = NXO
    value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25
    index_lpext4(ilpvalue,ilpvalue1) = 0

    if (nsorb > 0) then
      do iorb=lri+1,norb_dz
        if (iorb == lrj) then
          ilpvalue1 = ilpvalue1+1
          call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
          index_lpext3(ilpvalue,ilpvalue1) = NXO
          value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25*icoe
          call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
          index_lpext4(ilpvalue,ilpvalue1) = NXO
          value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25
        end if
        if (iorb /= lrj) then
          ilpvalue1 = ilpvalue1+1
          call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
          index_lpext3(ilpvalue,ilpvalue1) = NXO
          value_lpext3(ilpvalue,ilpvalue1) = -w0_sdplp25
          call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
          index_lpext4(ilpvalue,ilpvalue1) = NXO
          value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*Two
        end if
      end do
    end if

    do iorb=norb_dz+1,norb_inn
      Kcoe = lpcoe(iorb)
      call NEOC(KCOE,NOCC,TCOE)
      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25*nocc*tcoe
      call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
      index_lpext4(ilpvalue,ilpvalue1) = NXO
      value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*nocc
    end do
  end do
  nlp_value = nlsm_ext(isma)
  nlp_value1 = ilpvalue1
  return
end if
!=======================================================================
if ((idtu == 55) .or. (idtu == 73)) then    !(11)(23)=55 (11)(13)=75
  ilpvalue1 = 0
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    NIA = ICAN_A(LRA)+LRI
    ilpvalue = ilpvalue+1
    index_lpext5(ilpvalue) = NIA
    value_lpext5(ilpvalue) = w0_sdplp25

    ilpvalue1 = 0

    ilpvalue1 = ilpvalue1+1
    call TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
    index_lpext3(ilpvalue,ilpvalue1) = NXO
    value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25
    index_lpext4(ilpvalue,ilpvalue1) = 0
    do idorb=lri+1,norb_dz
      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,idorb,LRI,idorb,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = -w0_sdplp25
      call TRANS_IJKL_INTPOS(LRA,LRI,idorb,idorb,NXO)
      index_lpext4(ilpvalue,ilpvalue1) = NXO
      value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*Two
    end do
    iorbs = max(norb_dz+1,lri)
    do iorb=iorbs,norb_inn
      Kcoe = lpcoe(iorb)
      call NEOC(KCOE,NOCC,TCOE)
      ilpvalue1 = ilpvalue1+1
      call TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
      index_lpext3(ilpvalue,ilpvalue1) = NXO
      value_lpext3(ilpvalue,ilpvalue1) = w0_sdplp25*nocc*tcoe
      call TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
      index_lpext4(ilpvalue,ilpvalue1) = NXO
      value_lpext4(ilpvalue,ilpvalue1) = w0_sdplp25*nocc
    end do
  end do
  nlp_value = nlsm_ext(isma)
  nlp_value1 = ilpvalue1
  return
end if

end subroutine lp_ar_coe_calcuvalue_G

subroutine lp_arbl_ext_dd_calcuvalue_G(lri,lrj,iml,imr,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, int_dd_drl, logic_g49a, logic_g49b, logic_g50, &
                         norb_number, value_lpext, value_lpext1, w0_plp, w0gdd, w1_plp, w1gdd
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, iml, imr
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ira, irb, ivalue, lra, lrb, nlbf, nlef, nrbf, nref, nxo
real(kind=wp) :: valuetmp1, w0lp, w1lp

nlbf = ibsm_ext(iml)
nlef = iesm_ext(iml)
nrbf = ibsm_ext(imr)
nref = iesm_ext(imr)

w0lp = w0_plp*w0gdd
w1lp = w1_plp*w1gdd
valuetmp1 = w0lp
w0lp = w0lp-w1lp
w1lp = -valuetmp1*Two
ivalue = 0
! G50
if (logic_g50) then
  if (logic_g49b) then

    do ira=nlbf,nlef
      lra = norb_number(ira)
      ivalue = ivalue+1
      call TRANS_IJKL_INTPOS(lrj,lra,lri,lra,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = w0lp
      call TRANS_IJKL_INTPOS(lrj,lri,lra,lra,NXO)
      index_lpext1(ivalue) = NXO
      value_lpext1(ivalue) = w1lp
    end do
  end if

  ivalue = ivalue+int_dd_drl

  do irb=nlbf,nlef
    lrb = norb_number(irb)
    !lsmb = lsm(irb)
    do ira=nlbf,irb-1
      lra = norb_number(ira)
      !lsma = lsm(ira)
      !lsmba = Mul(lsmb,lsma)
      ivalue = ivalue+1
      call TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = w0lp
      call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
      index_lpext1(ivalue) = NXO
      value_lpext1(ivalue) = w1lp
    end do
  end do
  do irb=nlbf,nlef
    lrb = norb_number(irb)
    !lsmb = lsm(irb)
    do ira=nlbf,irb-1
      lra = norb_number(ira)
      !lsma = lsm(ira)
      !lsmba = Mul(lsmb,lsma)
      ivalue = ivalue+1
      call TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = w0lp
      call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
      index_lpext1(ivalue) = NXO
      value_lpext1(ivalue) = w1lp
    end do
  end do

else
  ivalue = ivalue+int_dd_drl
  if (logic_g49a) then
    ! G49a:Bl_Ar  line=12
    do irb=nrbf,nref
      lrb = norb_number(irb)
      do ira=nlbf,nlef
        lra = norb_number(ira)

        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w0lp
        call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = w1lp
      end do
    end do
  else
    ! G49b:Br_Al  line=11
    do irb=nlbf,nlef
      lrb = norb_number(irb)
      do ira=nrbf,nref
        lra = norb_number(ira)

        ivalue = ivalue+1
        call TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
        index_lpext(ivalue) = NXO
        value_lpext(ivalue) = w0lp
        call TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
        index_lpext1(ivalue) = NXO
        value_lpext1(ivalue) = w1lp
      end do
    end do
  end if
end if
nlp_value = ivalue

end subroutine lp_arbl_ext_dd_calcuvalue_G

subroutine lp_drl_ext_dd_calcuvalue_G(lri,iml,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, int_dd_drl, logic_g49b, nlsm_ext, norb_number, &
                         value_lpext, value_lpext1, w0_plp, w0gdd, w1_plp, w1gdd
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, iml
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: iaend, iasta, ira, irb, ivalue, jvalue, lra, lrb, mloop, nliml, nxo
real(kind=wp) :: w0lp, w1lp

w0lp = w0_plp*w0gdd
w1lp = w1_plp*w1gdd
nliml = nlsm_ext(iml)
iasta = ibsm_ext(iml)
iaend = iesm_ext(iml)

ivalue = 0
if (logic_g49b) then
  do ira=iasta,iaend
    lra = norb_number(ira)
    ivalue = ivalue+1
    call TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
    index_lpext(ivalue) = NXO
    value_lpext(ivalue) = -w1lp*Two
    index_lpext1(ivalue) = 0
  end do
end if
mloop = nliml*(nliml-1)/2

ivalue = ivalue+int_dd_drl
jvalue = 0
do irb=iasta,iaend
  lrb = norb_number(irb)
  do ira=iasta,irb-1
    lra = norb_number(ira)
    ivalue = ivalue+1
    jvalue = ivalue+mloop
    call TRANS_IJKL_INTPOS(lra,LRI,lrb,LRI,NXO)
    index_lpext(ivalue) = NXO
    value_lpext(ivalue) = w0lp-w1lp
    index_lpext(jvalue) = index_lpext(ivalue)
    value_lpext(jvalue) = value_lpext(ivalue)

    call TRANS_IJKL_INTPOS(lra,lrb,LRI,LRI,NXO)
    index_lpext1(ivalue) = NXO
    value_lpext1(ivalue) = -Two*w0lp
    index_lpext1(jvalue) = index_lpext1(ivalue)
    value_lpext1(jvalue) = value_lpext1(ivalue)
  end do
end do
nlp_value = jvalue

end subroutine lp_drl_ext_dd_calcuvalue_G

subroutine lp_arbr_ext_svtv_calcuvalue_G(lri,lrj,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, logic_g13, lsm_inn, ng_sm, norb_ext, norb_number, &
                         value_lpext, value_lpext1, w0_plp, w0g13a, w0g36a, w1_plp, w1g36a
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ic, icend, icsta, id, idend, idsta, ivalue, jc, jd, lrc, lsmc, lsmd, lsmi, lsmij, lsmj, nxo
real(kind=wp) :: valuelptmp1, w0lp, w1lp

ivalue = 0
lsmi = lsm_inn(lri)
lsmj = lsm_inn(lrj)
lsmij = Mul(lsmi,lsmj)
! G36a
w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a
valuelptmp1 = w0lp
w0lp = w0lp-w1lp
w1lp = valuelptmp1+w1lp
! ArBr -- B^rA^r =10
do lsmc=1,ng_sm
  lsmd = Mul(lsmij,lsmc)
  if (lsmd > lsmc) cycle
  icsta = ibsm_ext(lsmc)
  icend = iesm_ext(lsmc)
  idsta = ibsm_ext(lsmd)
  idend = iesm_ext(lsmd)
  if (lsmc == lsmd) icsta = icsta+1
  do ic=icsta,icend
    jc = norb_number(ic)
    do id=idsta,min(idend,ic-1)
      jd = norb_number(id)
      ivalue = ivalue+1
      call TRANS_IJKL_INTPOS(jd,lri,lrj,jc,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = w0lp
      call TRANS_IJKL_INTPOS(jd,lrj,jc,lri,NXO)
      index_lpext1(ivalue) = NXO
      value_lpext1(ivalue) = w1lp
    end do
  end do
end do
! G36b
! G1415
if (logic_g13) then

  w0lp = w0g13a*(w0_plp+w1_plp)
  do ic=1,norb_ext
    lrc = norb_number(ic)
    ivalue = ivalue+1
    call TRANS_IJKL_INTPOS(lrj,lrc,lri,lrc,NXO)
    index_lpext(ivalue) = NXO
    value_lpext(ivalue) = w0lp
    index_lpext1(ivalue) = 0
  end do
end if
nlp_value = ivalue

end subroutine lp_arbr_ext_svtv_calcuvalue_G

subroutine lp_drr_ext_svtv_calcuvalue_G(lri,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, logic_g13, ng_sm, norb_all, norb_inn, norb_number, &
                         value_lpext, w0_plp, w0g13a, w0g36a, w1_plp
use Constants, only: Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ibend, ibsta, ira, irb, ivalue, lmb, lra, lrb, nxo
real(kind=wp) :: w0lp

ivalue = 0
! G36a
w0lp = (w0_plp+w1_plp)*w0g36a
do lmb=1,ng_sm
  ibsta = ibsm_ext(lmb)
  ibend = iesm_ext(lmb)
  do irb=ibsta,ibend
    lrb = norb_number(irb)
    do ira=ibsta,irb-1
      lra = norb_number(ira)
      ivalue = ivalue+1
      call TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
      index_lpext(ivalue) = NXO
      value_lpext(ivalue) = w0lp
      index_lpext1(ivalue) = 0
    end do
  end do
end do

if (logic_g13) then
!=======================================================================
! Drr-DRR
! w0lp=Two*w0lp but not One*w0lp is based on that the non-diagonal
! just uses the non-triangle <Ci|H|Cj> which designates that I > J.

  w0lp = Half*w0_plp*w0g13a
  w0lp = Two*w0lp
  do LRA=NORB_ALL,NORB_INN+1,-1
    ivalue = ivalue+1
    call TRANS_IJKL_INTPOS(LRA,lri,LRA,lri,NXO)
    index_lpext(ivalue) = NXO
    value_lpext(ivalue) = w0lp
    index_lpext1(ivalue) = 0
  end do
end if
nlp_value = ivalue

end subroutine lp_drr_ext_svtv_calcuvalue_G

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine rdioff_cvb(ifield,file_id,ioffset)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      parameter (nbuf=50)
      dimension ioff(nbuf)

      if(ifield.gt.nbuf)then
        write(6,*)' ifield too large in rdioff :',ifield,nbuf
        call abend_cvb()
      endif
      call rdi_cvb(ioff,nbuf,file_id,0)
      ioffset=ioff(ifield)
      return
      end
      subroutine wrioff_cvb(ifield,file_id,ioffset)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      parameter (nbuf=50)
      dimension ioff(nbuf)
      if(ifield.gt.nbuf)then
        write(6,*)' ifield too large in wrioff :',ifield,nbuf
        call abend_cvb()
      endif
      if(tstfile_cvb(file_id))then
        call rdi_cvb(ioff,nbuf,file_id,0)
      else
        call izero(ioff,nbuf)
      endif
      ioff(ifield)=ioffset
      call wri_cvb(ioff,nbuf,file_id,0)
      return
      end
      subroutine rdioff1_cvb(ioffset)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      parameter (nbuf=50)
c      dimension ioff(nbuf)
      ioffset=ihlf_cvb(nbuf)
      return
      end
c
c  Low-level CASVB IO routines
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GetNextFfield(nextfld,fldname,nOrdOpf,ncmp,
     *                         force,lforce)
      Implicit Real*8 (A-H,O-Z)
      Character*(*) fldname
      Dimension force(lforce)
      nextfld=0
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_character(fldname)
         Call Unused_integer(nOrdOpf)
         Call Unused_integer(ncmp)
         Call Unused_real_array(force)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GauBon(MaxT,XE,YE,ZE,RE,IntSph,
     +           NV,NS,PTS,CCC,PP,AREA,IPRINT)
      IMPLICIT REAL*8 (A-H,O-Z)
      Parameter(MxVert=20)
      Dimension XE(*),YE(*),ZE(*),RE(*),IntSph(MxVert,*)
      DIMENSION P1(3),P2(3),P3(3),U1(3),U2(3)
      DIMENSION PTS(3,MxVert),CCC(3,MxVert),PP(3)
      Save Zero, One
      DATA ZERO/0.00D0/, One/1.0d0/
      PI = 4.0D+00*ATan(1.0D+00)
C
C     Sfrutta il teorema di Gauss-Bonnet per calcolare l'area
C     della tessera con vertici PTS(3,NV). Consideriamo sempre
C     che il lato N della tessera e' quello compreso tra i vertici
C     N e N+1 (oppure NV e 1). In CCC(3,NV) sono le posizioni dei
C     centri degli archi che sottendono i vari lati della tessera.
C     La formula di Gauss-Bonet per le sfere e':
C            Area=R^2[2pi+S(Phi(N)cosT(N))-S(Beta(N))]
C     dove Phi(N) e' la lunghezza d'arco (in radianti) del lato N,
C     T(N) e' l'angolo polare del lato N, Beta(N) l'angolo esterno
C     relativo al vertice N.
C
C     Questa SUBROUTINE viene chiamata anche da VOLCHG (in calcoli con
C     dielettrico non omogeneo) per calcolare l'area delle tessere
C     proiettate sulle relative "sfere del centro di carica": in questo caso
C     i vertici della tessera sono in PTS, i centri degli archi (tutti
C     coincidenti con il centro di carica) sono in CCC e il punto
C     rappresentativo e' in PP. La cosa piu' importante e' che NS < 0.
C
      Small = 1.d-35
      TPI=2*PI
      N0 = 0 ! dummy initialize
      N2 = 0 ! dummy initialize
C
C     Calcola la prima sommatoria
      SUM1 = 0.D0
      DO 100 N = 1, NV
      X1 = PTS(1,N) - CCC(1,N)
      Y1 = PTS(2,N) - CCC(2,N)
      Z1 = PTS(3,N) - CCC(3,N)
      IF(N.LT.NV) THEN
        X2 = PTS(1,N+1) - CCC(1,N)
        Y2 = PTS(2,N+1) - CCC(2,N)
        Z2 = PTS(3,N+1) - CCC(3,N)
      ELSE
        X2 = PTS(1,1) - CCC(1,N)
        Y2 = PTS(2,1) - CCC(2,N)
        Z2 = PTS(3,1) - CCC(3,N)
      ENDIF
      DNORM1 = X1*X1 + Y1*Y1 + Z1*Z1
      DNORM2 = X2*X2 + Y2*Y2 + Z2*Z2
      SCAL = X1*X2 + Y1*Y2 + Z1*Z2
      COSPHIN = SCAL / (sqrt(DNORM1*DNORM2))
      IF(COSPHIN.GT.1.D0) COSPHIN = 1.D0
      PHIN = ACOS(COSPHIN)
C
C     Normalmente NS>0, ma se GAUBON e' stata chiamata da VOLCHG NS<0
C
      IF(NS.GT.0) THEN
C     NSFE1 e' la sfera con cui la sfera NS si interseca (eventualmente)
        NSFE1 = INTSPH(N,MaxT)
        X1 = XE(NSFE1) - XE(NS)
        Y1 = YE(NSFE1) - YE(NS)
        Z1 = ZE(NSFE1) - ZE(NS)
      ELSE
        X1 = 0
        Y1 = 0
        Z1 = 0
      ENDIF
      DNORM1 = sqrt(X1*X1 + Y1*Y1 + Z1*Z1)
      IF(DNORM1.EQ.ZERO) DNORM1 = 1.D0
      IF(NS.GT.0) THEN
        X2 = PTS(1,N) - XE(NS)
        Y2 = PTS(2,N) - YE(NS)
        Z2 = PTS(3,N) - ZE(NS)
      ELSE
        X2 = PTS(1,N) - CCC(1,1)
        Y2 = PTS(2,N) - CCC(2,1)
        Z2 = PTS(3,N) - CCC(3,1)
      ENDIF
      DNORM2 = sqrt(X2*X2 + Y2*Y2 + Z2*Z2)
      COSTN = (X1*X2+Y1*Y2+Z1*Z2)/(DNORM1*DNORM2)
      SUM1 = SUM1 + PHIN * COSTN
 100  CONTINUE
C
C     Calcola la seconda sommatoria: l'angolo esterno Beta(N) e'
C     definito usando i versori (u(N-1),u(N)) tangenti alla sfera
C     nel vertice N lungo le direzioni dei lati N-1 e N:
C                cos( Pi-Beta(N) )=u(N-1)*u(N)
C            u(N-1) = [V(N) x (V(N) x V(N-1))]/NORM
C            u(N) = [V(N) x (V(N) x V(N+1))]/NORM
C     dove V(I) e' il vettore posizione del vertice I RISPETTO AL
C     CENTRO DELL'ARCO CHE SI STA CONSIDERANDO.
C
      SUM2 = 0.D0
C     Loop sui vertici
      DO 200 N = 1, NV
      DO 2000 JJ = 1, 3
      P1(JJ) = 0.D0
      P2(JJ) = 0.D0
      P3(JJ) = 0.D0
 2000 continue
      N1 = N
      IF(N.GT.1) N0 = N - 1
      IF(N.EQ.1) N0 = NV
      IF(N.LT.NV) N2 = N + 1
      IF(N.EQ.NV) N2 = 1
C     Trova i vettori posizione rispetto ai centri corrispondenti
C     e i versori tangenti
C
C     Lato N0-N1:
      DO 2010 JJ = 1, 3
      P1(JJ) = PTS(JJ,N1) - CCC(JJ,N0)
      P2(JJ) = PTS(JJ,N0) - CCC(JJ,N0)
 2010 continue
C
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2020 JJ = 1, 3
      P2(JJ) = P3(JJ)
 2020 continue
      CALL VECP(P1,P2,P3,DNORM3)
      If(DNorm3.lt.Small) DNorm3 = One
      DO 2030 JJ = 1, 3
      U1(JJ) = P3(JJ)/DNORM3
 2030 continue
C
C     Lato N1-N2:
      DO 2040 JJ = 1, 3
      P1(JJ) = PTS(JJ,N1) - CCC(JJ,N1)
      P2(JJ) = PTS(JJ,N2) - CCC(JJ,N1)
 2040 continue
C
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2050 JJ = 1, 3
      P2(JJ) = P3(JJ)
 2050 continue
      CALL VECP(P1,P2,P3,DNORM3)
      If(DNorm3.lt.Small) DNorm3 = One
      DO 2060 JJ = 1, 3
      U2(JJ) = P3(JJ)/DNORM3
 2060 continue
C
      BETAN = ACOS(U1(1)*U2(1)+U1(2)*U2(2)+U1(3)*U2(3))
      SUM2 = SUM2 + (PI - BETAN)
 200  CONTINUE
C     Calcola l'area della tessera
      IF(NS.GT.0) THEN
        AREA = RE(NS)*RE(NS)*(TPI + SUM1 - SUM2)
      ELSE
        RR2 = (PTS(1,1)-CCC(1,1))**2+(PTS(2,1)-CCC(2,1))**2+
     *        (PTS(3,1)-CCC(3,1))**2
        AREA = RR2*(TPI + SUM1 - SUM2)
      ENDIF
      IF(NS.GT.0) THEN
C     Trova il punto rappresentativo (come media dei vertici)
      DO 2070 JJ = 1, 3
      PP(JJ) = 0.D0
 2070 continue
      DO 2080 I = 1, NV
      PP(1) = PP(1) + (PTS(1,I)-XE(NS))
      PP(2) = PP(2) + (PTS(2,I)-YE(NS))
      PP(3) = PP(3) + (PTS(3,I)-ZE(NS))
 2080 continue
      DNORM = 0.D0
      DO 2090 JJ = 1, 3
      DNORM = DNORM + PP(JJ)*PP(JJ)
 2090 continue
      PP(1) = XE(NS) + PP(1) * RE(NS) / sqrt(DNORM)
      PP(2) = YE(NS) + PP(2) * RE(NS) / sqrt(DNORM)
      PP(3) = ZE(NS) + PP(3) * RE(NS) / sqrt(DNORM)
      ENDIF
C
C     A causa delle approssimazioni numeriche, l'area di alcune piccole
C     tessere puo' risultare negativa, e viene in questo caso trascurata
      IF(AREA.LT.0.D0) THEN
        AREA = 0.D0
        IF(IPRINT.GE.1) WRITE(6,1000)NS
 1000   FORMAT(/,'ATTENTION: THE SURFACE OF A TESSERA IN SPHERE ',I3,
     *  ' IS NEGLECTED')
      ENDIF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008,2009, Giovanni Ghigo                              *
!***********************************************************************

! Contains:
!   ISC_Rho
!   ISC_Ene
!   ISC_Rate
!   ISC_FCval

!  InterSystem Crossing rate evaluation: "Engine" routines
!  Author: Giovanni Ghigo
!          Dip. Chimica Generale e Chimica Organica, Torino (ITALY)
!          28 Dec-08 - 06 Jan-09

subroutine ISC_Rho(iPrint,nOsc,new_n_max,dRho,energy1,energy2,minQ,dMinWind0,nMaxQ,harmfreq1,harmfreq2)
! Calculate State Density  dRho  GG 30-Dec-08
! Formula (86) taken from  M. Bixon, J. Jortner  JCP,48,715 (1969)

use Constants, only: Zero, One, Two, Six, Twelve, Half, Pi, auTocm, auToeV
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, nOsc
integer(kind=iwp), intent(out) :: new_n_max, minQ, nMaxQ(nOsc)
real(kind=wp), intent(out) :: dRho
real(kind=wp), intent(in) :: energy1, energy2, dMinWind0, harmfreq1(nOsc), harmfreq2(nOsc)
integer(kind=iwp) :: i, iOsc, jOsc
real(kind=wp) :: avFreq, avFreqSq, dAlpha, dBeta, dDn, dEtha, dFE, dLambda, dMaxFreq2, dMinFreq2, dMinWind, dZPE1, dZPE2, GE1, &
                 GE2, T0

if (iPrint >= 2) then
  write(u6,*)
  write(u6,*) ' State Density data:'
  write(u6,*) ' ============================================'
end if

dMinWind = dMinWind0
if (dMinWind == Zero) dMinWind = One
minQ = 0
dRho = Two/Pi
dRho = sqrt(dRho*nOsc)
dRho = dRho*(One-One/(Twelve*nOsc))
avFreq = Zero
avFreqSq = Zero
dLambda = One
dZPE1 = Zero
dZPE2 = Zero
dMinFreq2 = 1.0e99_wp
dMaxFreq2 = Zero
do iOsc=1,nOsc
  avFreq = avFreq+harmfreq2(iOsc)
  avFreqSq = avFreqSq+(harmfreq2(iOsc))**2
  dZPE1 = dZPE1+Half*harmfreq1(iOsc)
  dZPE2 = dZPE2+Half*harmfreq2(iOsc)
  dMinFreq2 = min(dMinFreq2,harmfreq2(iOsc))
  dMaxFreq2 = max(dMaxFreq2,harmfreq2(iOsc))
end do
GE1 = energy1+dZPE1
GE2 = energy2+dZPE2
T0 = abs(GE2-GE1)
avFreq = avFreq/nOsc
avFreqSq = avFreqSq/nOsc

do jOsc=1,nOsc
  dLambda = dLambda*harmfreq2(jOsc)/avFreq
end do
new_n_max = int(Half+(GE1-GE2)/dMinFreq2)
dAlpha = avFreqSq/(avFreq**2)
dBeta = ((nOsc-1)*(nOsc-2)*dAlpha-nOsc**2)/(Six*nOsc)
dEtha = abs(GE1-GE2)/dZPE2
dRho = dRho/avFreq
dRho = dRho*dAlpha
dRho = dRho/(1+dEtha)
dDn = (One+(Two/dEtha))
dDn = dDn**(dEtha/Two)
dDn = dDn*(One+(dEtha/Two))
dDn = dDn**nOsc
dRho = dRho*dDn
dFE = (One+dEtha)**2
dFE = (One-One/dFE)**dBeta
dRho = dRho*dFE

do jOsc=1,nOsc
  nMaxQ(jOsc) = int(Half+(T0+dMinWind/dRho)/harmfreq2(jOsc))
end do
minQ = int(Half+(T0-dMinWind/dRho)/dMaxFreq2)
if (minQ < 0) then
  write(u6,*)
  write(u6,*) ' ***** ERROR ******'
  write(u6,*) ' Window too large !'
  write(u6,*) ' ******************'
  call Quit_OnUserError()
end if

if (iPrint >= 2) then
  write(u6,'(a,f11.6,a)') '  T_0  = ',T0,' (au)'
  write(u6,'(a,f11.3,a)') '  T_0  = ',T0*auTocm,' (cm-1)'
  write(u6,'(a,f11.3,a)') '  T_0  = ',T0*auToeV,' (eV)'
  write(u6,'(a,d14.3,a)') '  State Density (dRho) = ',dRho,' (au-1)'
  write(u6,'(a,g14.3,a)') '  State Density (dRho) = ',dRho/auTocm,' (cm)'
  write(u6,'(a,g17.9,a)') '  1/dRho = ',auTocm/dRho,' (cm-1)'
  write(u6,'(a,f7.3,a)') '  Expansion factor =',dMinWind
  write(u6,'(a,g17.9,a)') '  Window = (+/-)',Half*dMinWind*auTocm/dRho,' (cm-1)'
end if
if (iPrint >= 3) then
  write(u6,*) ' Maximum quantum numbers:',(nMaxQ(i),i=1,nOsc)
  write(u6,*) ' Minimum quantum number: ',minQ
  write(u6,*) ' Suggested n_max (new_n_max)=',new_n_max
  write(u6,*)
end if
call XFlush(u6)

return

end subroutine ISC_Rho

subroutine ISC_Ene(iPrint,nOsc,max_nOrd,nYes,nMat,nTabDim,GE1,GE2,harmfreq1,harmfreq2,x_anharm1,x_anharm2,dMinWind,dRho,lVec)
! Calculate Energy of Levels  GG 30-Dec-08 - 08-Jan-09

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, auTocm
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, nOsc, max_nOrd, nTabDim, nMat(0:nTabDim,nOsc)
integer(kind=iwp), intent(inout) :: nYes, lVec(0:nTabDim)
real(kind=wp), intent(in) :: GE1, GE2, harmfreq1(nOsc), harmfreq2(nOsc), x_anharm1(nOsc,nOsc), x_anharm2(nOsc,nOsc), dRho
real(kind=wp), intent(inout) :: dMinWind
integer(kind=iwp) :: i, iOrd, j, l_harm, loc_n_max, nYes_start
real(kind=wp) :: dEne, dWlow, dWup
logical(kind=iwp) :: lUpdate
integer(kind=iwp), allocatable :: level1(:), level2(:), lTVec(:)
real(kind=wp), allocatable :: EneMat(:)

if (dMinWind == Zero) then
  lUpDate = .true.
  dMinWind = One
else
  lUpDate = .false.
end if
call mma_allocate(lTVec,[0,max_nOrd],label='lTVec')
lTVec(:) = lVec(0:max_nOrd)

! Energy calculation

if (iPrint >= 4) then
  write(u6,*)
  write(u6,*) ' States in the preliminar window :'
  if (nOsc <= 24) then
    write(u6,'(a,108a)') '  ',('=',i=1,108)
    write(u6,*) '     jOrd    ene/au    ene/cm-1 Vibrational quantum numbers'
    write(u6,'(a,108a)') '  ',('-',i=1,108)
  else
    write(u6,'(a,36a)') '  ',('=',i=1,36)
    write(u6,*) '        #    jOrd   ene/au      ene/cm-1'
    write(u6,'(a,36a)') '  ',('-',i=1,36)
  end if
  call XFlush(u6)
end if

call mma_allocate(level1,nOsc,label='level1')
call mma_allocate(level2,nOsc,label='level2')
call mma_allocate(EneMat,[0,max_nOrd],label='EneMat')
level1(:) = 0
do iOrd=0,max_nOrd
  if (lVec(iOrd) == 1) then
    level2(:) = nMat(iOrd,:)
    l_harm = nOsc
    call TransEnergy(GE1,x_anharm1,harmfreq1,level1,GE2,x_anharm2,harmfreq2,level2,dEne,l_harm)
    EneMat(iOrd) = dEne
    if (iPrint >= 4) then
      if (nOsc <= 24) then
        loc_n_max = 0
        do j=1,nOsc
          loc_n_max = loc_n_max+nMat(iOrd,j)
        end do
        write(u6,'(a2,i8,f11.6,f11.4,i4,a2,24i3)') ' ',iOrd,dEne,dEne*auTocm,loc_n_max,': ',(nMat(iOrd,j),j=1,nOsc)
      else
        write(u6,'(a2,i8,f11.6,f11.4,i4        )') ' ',iOrd,dEne,dEne*auTocm,loc_n_max
      end if
    end if
  end if
end do

! Energy selection

if (iPrint >= 3) then
  write(u6,*)
  write(u6,*) ' States in the window :'
  if (nOsc <= 24) then
    write(u6,'(a,108a)') '  ',('=',i=1,108)
    write(u6,*) '     jOrd    ene/au    ene/cm-1 Vibrational quantum numbers'
    write(u6,'(a,108a)') '  ',('-',i=1,108)
  else
    write(u6,'(a,36a)') '  ',('=',i=1,36)
    write(u6,*) '        #    jOrd   ene/au      ene/cm-1'
    write(u6,'(a,36a)') '  ',('-',i=1,36)
  end if
  call XFlush(u6)
end if

nYes_start = nYes
do
  dWlow = Half*dMinWind/dRho
  dWup = dWlow
  do iOrd=0,max_nOrd
    lVec(iOrd) = lTVec(iOrd)
    if (lVec(iOrd) == 1) then
      dEne = EneMat(iOrd)
      if ((dEne < -dWlow) .or. (dEne > dWup)) then
        lVec(iOrd) = 0
        nYes = nYes-1
      else
        lVec(iOrd) = 1
        if (iPrint >= 3) then
          if (nOsc <= 24) then
            loc_n_max = 0
            do j=1,nOsc
              loc_n_max = loc_n_max+nMat(iOrd,j)
            end do
            write(u6,'(a2,i8,f11.6,f11.4,i4,a2,24i3)') ' ',iOrd,dEne,dEne*auTocm,loc_n_max,': ',(nMat(iOrd,j),j=1,nOsc)
          else
            write(u6,'(a2,i8,f11.6,f11.4,i4        )') ' ',iOrd,dEne,dEne*auTocm,loc_n_max
          end if
        end if
      end if
    end if
  end do
  if ((nYes > 1) .or. (.not. lUpDate)) exit
  dMinWind = dMinWind+One
  nYes = nYes_start
end do

call mma_deallocate(lTVec)
call mma_deallocate(level1)
call mma_deallocate(level2)
call mma_deallocate(EneMat)

if (iPrint >= 3) then
  if (nOsc <= 30) write(u6,'(a,108a)') '  ',('-',i=1,108)
  if (nOsc > 30) write(u6,'(a,36a)') '  ',('-',i=1,36)
  write(u6,'(a,f12.9,a,f12.9,a)') '  Window: ',-dWlow,' / ',dWup,' (au)'
  write(u6,'(a,f12.6,a,f12.6,a)') '  Window: ',-dWlow*auTocm,' / ',dWup*auTocm,' (cm-1)'
end if
if (iPrint >= 2) then
  write(u6,*) ' Final number of States=',nYes
end if
if ((dMinWind > One) .and. lUpDate .and. (iPrint >= 1)) then
  write(u6,*)
  write(u6,*) ' *** Warning: Expansion factor has been set to ',dMinWind
  write(u6,*)
end if
call XFlush(u6)

return

end subroutine ISC_Ene

subroutine ISC_Rate(iPrint,nOsc,max_nOrd,iMaxYes,nYes,dMinWind,VibWind2,C1,C2,W2,det0,det1,det2,C,W,r01,r02,nTabDim,nMat,nInc, &
                    nDec,m_max,n_max,FC00,dRho)
! Estimate ISC rate  GG 30-Dec-08

use mula_global, only: hbarcm, TranDip
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Pi, auTocm
use Definitions, only: wp, iwp, u6, ItoB

implicit none
integer(kind=iwp), intent(inout) :: nTabDim
integer(kind=iwp), intent(in) :: iPrint, nOsc, iMaxYes, nYes, VibWind2(nYes), nMat(0:nTabDim,nOsc), nInc(0:iMaxYes,nOsc), &
                                 nDec(0:iMaxYes,nOsc), m_max, n_max
integer(kind=iwp), intent(out) :: max_nOrd
real(kind=wp), intent(in) :: dMinWind, C1(nOsc,nOsc), C2(nOsc,nosc), W2(nOsc,nOsc), det0, det1, det2, C(nOsc,nOsc), W(nOsc,nOsc), &
                             r01(nOsc), r02(nOsc), dRho
real(kind=wp), intent(out) :: FC00
integer(kind=iwp) :: ii, m_max_ord, max_nInc, mx_max_ord, n_max_ord, nvTabDim, nx_max_ord
real(kind=wp) :: const, dLT, dRate, dSoc, dSum
real(kind=wp), allocatable :: FCWind2(:)
integer(kind=iwp), parameter :: MB = 1048576

call TabDim(n_max,nOsc,nvTabDim)
max_nOrd = nvTabDim-1
call TabDim(m_max,nOsc,nvTabDim)
m_max_ord = nvTabDim-1
call TabDim(min(n_max,m_max+1),nOsc,nvTabDim)
mx_max_ord = nvTabDim-1
call TabDim(min(m_max,n_max+1),nOsc,nvTabDim)
nx_max_ord = nvTabDim-1
call TabDim(n_max-1,nOsc,nvTabDim)
max_nInc = nvTabDim-1
call TabDim(n_max,nOsc,nvTabDim)
n_max_ord = nvTabDim-1

mx_max_ord = 0 ! CGGn
if (iPrint >= 3) write(u6,*) ' Memory allocated for U matrix:',(n_max_ord+1)*(mx_max_ord+1),' words,  ', &
                             (n_max_ord+1)*(mx_max_ord+1)*ItoB/MB,' MB.'
call XFlush(u6)

call mma_allocate(FCWind2,nYes,label='FCWind2')
call ISC_FCval(iPrint,iMaxYes,nTabDim,C1,det1,r01,C2,W2,det2,r02,m_max_ord,n_max_ord,mx_max_ord,max_nInc,nx_max_ord,nMat,nInc, &
               nDec,C,W,det0,FC00,nOsc,nYes,VibWind2,FCWind2)

const = Two*Pi/hbarcm
if (iPrint >= 4) then
  write(u6,*)
  write(u6,*) '  const =',const
  write(u6,*) '  dRho/cm =',dRho/auTocm
  write(u6,*) '  const*dRho=',const*dRho/auTocm
end if
const = const*dRho/auTocm

dSum = Zero
do ii=1,nYes
  dSum = dSum+FCWind2(ii)**2
end do
call mma_deallocate(FCWind2)

dSoc = Zero
do ii=1,3
  dSOC = dSOC+TranDip(ii)**2
end do

dRate = const*dSum*dSoc/dMinWind
dLT = One/dRate

if (iPrint >= 3) then
  write(u6,*) '  Sum of squares of FC factors =',dSum
  write(u6,*) '  Root-square of the sum =',sqrt(dSum)
  write(u6,*) '  dSOC =',dSOC
end if

if (iPrint >= 1) then
  write(u6,*)
  write(u6,*) ' InterSystem Crossing rate constant:'
  write(u6,*) ' ===================================='
  write(u6,'(a,e10.2,a)') '  ISC Rate Constant  ',dRate,' sec-1'
  write(u6,'(a,e10.2,a)') '  Lifetime           ',dLT,' sec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' msec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' microsec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' nsec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' psec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' fsec'
  write(u6,*) ' ------------------------------------'
  write(u6,*)
  write(u6,*)
  call XFlush(u6)
end if

return

end subroutine ISC_Rate

!  InterSystem Crossing rate evaluation: Multidimensional Franck-Condon
!  Modified copy of FCval by Giovanni Ghigo.
!  Dip. Chimica Generale e Chimica Organica, Torino (ITALY)
!  28-Dec-08 - 06-Jan-09 ; June 2009

subroutine ISC_FCval(iPrint,iMaxYes,nTabDim,C1,det1,r01,C2,W2,det2,r02,max_mOrd,max_nOrd,max_nOrd2,max_nInc,max_nInc2,nMat,nInc, &
                     nDec,C,W,det0,FC00,nOsc,nYes,VibWind2,FCWind2)

use mula_global, only: ndim1, ndim2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, iMaxYes, max_mOrd, max_nOrd, max_nOrd2, max_nInc2, nOsc, nMat(0:ndim1,ndim2), &
                                 nInc(0:iMaxYes,nOsc), nDec(0:iMaxYes,nOsc), nYes, VibWind2(nYes)
integer(kind=iwp), intent(out) :: nTabDim
real(kind=wp), intent(in) :: C1(nOsc,nOsc), det1, r01(nOsc), C2(nOsc,nOsc), W2(nOsc,nOsc), det2, r02(nOsc), C(nOsc,nOsc), &
                             W(nOsc,nOsc), det0
integer(kind=iwp), intent(inout) :: max_nInc
real(kind=wp), intent(out) :: FC00, FCWind2(nYes)
integer(kind=iwp) :: i, ii, iOrd, j, jOrd, kOsc, kOsc_start, loc_n_max, lOsc, n, nMaxMat
real(kind=wp) :: const, det, dFC, FC00_exp
real(kind=wp), allocatable :: A2(:,:), A2B2T(:,:), Alpha(:,:), Alpha1(:,:), Alpha2(:,:), B2(:,:), Beta(:,:), d2(:), L(:,:), &
                              r_temp1(:), r_temp2(:), sqr(:), temp(:,:), temp1(:,:), temp2(:,:), U(:,:)
real(kind=wp), external :: Ddot_

!write(u6,*) 'CGGt[ISC_FCval] Enter'
!write(u6,*) '                nYes = ',nYes
!write(u6,*) '                VibWind2 :',(VibWind2(i),i=1,nYes)
!write(u6,*) '            L matrix:',max_mOrd,max_nInc2
!write(u6,*) '            U matrix:',max_nOrd,max_nOrd2
!do i=0,iMaxYes
!  write(u6,*) (nInc(i,j),j=1,nOsc)
!end do
!call XFlush(u6)

! Initialize.
nMaxMat = max(max_mOrd+1,max_nOrd+1)
!write(u6,*) '            nMaxMat=',nMaxMat
nTabDim = max(nMaxMat,8)
!write(u6,*) '            nTabDim=',nTabDim
call mma_allocate(temp,nOsc,nOsc,label='temp')
call mma_allocate(temp1,nOsc,nOsc,label='temp1')
call mma_allocate(temp2,nOsc,nOsc,label='temp2')

! Setup sqr table.
n = nTabDim+1
call mma_allocate(sqr,[0,n],label='sqr')
do i=0,nTabDim+1
  sqr(i) = sqrt(real(i,kind=wp))
end do

! Calculate alpha1, alpha2 and alpha.
!write(u6,*) 'CGGt[FCVal] Calculate alpha(s)'
!call XFlush(u6)
call mma_allocate(Alpha,nOsc,nOsc,label='Alpha')
call mma_allocate(Alpha1,nOsc,nOsc,label='Alpha1')
call mma_allocate(Alpha2,nOsc,nOsc,label='Alpha2')
call DGEMM_('T','N',nOsc,nOsc,nOsc,Half,C1,nOsc,C1,nOsc,Zero,Alpha1,nOsc)
call DGEMM_('T','N',nOsc,nOsc,nOsc,Half,C2,nOsc,C2,nOsc,Zero,Alpha2,nOsc)
temp(:,:) = Alpha1+Alpha2
Alpha(:,:) = Half*temp

!call xxDgemul(C,nOsc,'T',C,nOsc,'N',alpha,nOsc,nOsc,nOsc,nOsc)
!alpha(:,:) = Half*alpha

! Calculate C using a Cholesky factorization of 2*alpha.
!call Cholesky(temp,C)

! Calculate W.
!W(:,:) = Zero
!do i=1,nOsc
!  W(i,i) = One
!end do
!temp(:,:) = C
!call Dool_MULA(temp,W,det0)

! Calculate r00.
call mma_allocate(r_temp1,nOsc,label='r_temp1')
call mma_allocate(r_temp2,nOsc,label='r_temp2')

! Calculate beta.
!write(u6,*) 'CGGt[FCVal] Calculate beta.'
!call XFlush(u6)
call mma_allocate(Beta,nOsc,nOsc,label='Beta')
do i=1,nOsc
  do j=1,nOsc
    temp1(j,i) = C1(i,j)
  end do
  !write(u6,*) 'CGGt C1(',i,',j)=',(C1(i,jj),jj=1,nOsc)
end do
!call XFlush(u6)
temp1(:,:) = Alpha1
temp(:,:) = Two*Alpha

call Dool_MULA(temp,nOsc,nOsc,temp1,nOsc,nOsc,det)
call DGEMM_('N','N',nOsc,nOsc,nOsc,One,Alpha2,nOsc,temp1,nOsc,Zero,Beta,nOsc)

call mma_deallocate(Alpha1)
call mma_deallocate(Alpha2)

! Calculate FC00.
!r_temp1(:) = r02-r01
r_temp1(:) = r01-r02

call DGEMM_('N','N',nOsc,1,nOsc,One,Beta,nOsc,r_temp1,nOsc,Zero,r_temp2,nOsc)
FC00_exp = Ddot_(nOsc,r_temp1,1,r_temp2,1)
FC00 = (sqrt(det1)*sqrt(det2)/det0)*exp(-FC00_exp)
!write(u6,*) 'CGGt[FCVal] FC00_exp,FC00=',FC00_exp,FC00
!call XFlush(u6)

call mma_deallocate(Beta)

! Calculate A, B and d matrices.
call mma_allocate(A2,nOsc,nOsc,label='A2')
call mma_allocate(B2,nOsc,nOsc,label='B2')
call mma_allocate(d2,nOsc,label='d2')

call DGEMM_('N','N',nOsc,nOsc,nOsc,One,C2,nOsc,W,nOsc,Zero,A2,nOsc)
call DGEMM_('T','T',nOsc,nOsc,nOsc,One,W2,nOsc,C,nOsc,Zero,temp,nOsc)
B2(:,:) = A2-temp

const = -sqr(8)
call DGEMM_('T','N',nOsc,1,nOsc,const,W2,nOsc,r_temp2,nOsc,Zero,d2,nOsc)

! Calculate A1B1T and A2B2T.
call mma_allocate(A2B2T,nOsc,nOsc,label='A2B2T')

call DGEMM_('N','T',nOsc,nOsc,nOsc,One,A2,nOsc,B2,nOsc,Zero,A2B2T,nOsc)

! Initialize L matrix.
call mma_allocate(L,[0,max_mOrd],[0,max_nInc2],label='L')
L(:,:) = Zero
L(0,0) = One

! If max_mOrd > 0 then set up L(m,0).
if (max_mOrd > 0) then
  write(u6,*) '*****************************************'
  write(u6,*) ' Hot initial state not implemented yet !'
  write(u6,*) '*****************************************'
  write(u6,*)
  call Quit_OnUserError()
end if

! Initialize U matrix.
!write(u6,*) 'CGGt[FCVal] Initialize U matrix.'
!call XFlush(u6)
call mma_allocate(U,[0,max_nOrd],[0,max_nOrd2],label='U')
U(:,:) = Zero
U(0,0) = One
!GGt -------------------------------------------------------------------
!do kOsc=1,nOsc
!  write(u6,*) 'CGGt[FCVal] d2(..)=',d2(kOsc)
!  call XFlush(u6)
!end do
!GGt -------------------------------------------------------------------

! If max_nOrd > 0 then set up U(n,0).
!write(u6,*) 'CGGt[FCVal] max_nOrd > 0 then set up U(n,0).'
!call XFlush(u6)
do kOsc=1,nOsc
  !write(u6,*) 'CGGt[FCVal] nInc(0,kOsc)=',nInc(0,kOsc)
  !call XFlush(u6)
  !write(u6,*) 'CGGt[FCVal] d2(..)=',d2(kOsc)
  !call XFlush(u6)
  U(nInc(0,kOsc),0) = d2(kOsc)
end do
!write(u6,*) 'CGGt[FCVal] max_nInc=',max_nInc
!write(u6,*) 'CGGt[FCVal]  iMaxYes=',iMaxYes
!call XFlush(u6)
max_nInc = min(max_nInc,iMaxYes)
if (max_nInc > 0) then
  do iOrd=1,max_nInc
    !write(u6,*) '              iOrd=',iOrd
    !call XFlush(u6)
    kOsc_start = nOsc
    do while ((nMat(iOrd,kOsc_start) == 0) .and. (kOsc_start > 1))
      kOsc_start = kOsc_start-1
    end do
    do kOsc=kOsc_start,nOsc
      do lOsc=1,nOsc
        !write(u6,*) 'iOrd,kOsc_start,kOsc,lOsc==',iOrd,kOsc_start,kOsc,lOsc
        !call XFlush(u6)
        if (nMat(iOrd,lOsc) > 0) then

          U(nInc(iOrd,kOsc),0) = U(nInc(iOrd,kOsc),0)+sqr(nMat(iOrd,lOsc))*A2B2T(kOsc,lOsc)*U(nDec(iOrd,lOsc),0)
        end if
      end do

      U(nInc(iOrd,kOsc),0) = (U(nInc(iOrd,kOsc),0)+d2(kOsc)*U(iOrd,0))/sqr(nMat(nInc(iOrd,kOsc),kOsc))
    end do
  end do
end if

! Use recursion formula to obtain the rest of U.
!write(u6,*) '            Use recursion ... rest of U.'
!write(u6,*) '            max_nOrd2=',max_nOrd2
!call XFlush(u6)
do jOrd=1,max_nOrd2
  lOsc = nOsc
  do while ((nMat(jOrd,lOsc) == 0) .and. (lOsc > 1))
    lOsc = lOsc-1
  end do
  do iOrd=0,max_nOrd
    do kOsc=1,nOsc
      if (nMat(iOrd,kOsc) > 0) then
        !write(u6,*) '              ',iOrd,kOsc,nMat(iOrd,kOsc)
        U(iOrd,jOrd) = U(iOrd,jOrd)+sqr(nMat(iOrd,kOsc))/sqr(nMat(jOrd,lOsc))*A2(kOsc,lOsc)*U(nDec(iOrd,kOsc),nDec(jOrd,lOsc))
      end if
    end do
  end do
end do

call mma_deallocate(A2)
call mma_deallocate(B2)
call mma_deallocate(d2)
call mma_deallocate(A2B2T)

! Calculate Franck-Condon factors.
if (iPrint >= 3) then
  write(u6,*) ' Franck-Condon factors for States in the Window:'
  write(u6,'(a,36a)') '  ',('=',i=1,36)
  write(u6,*) '     #     jOrd   FC factor     jSum'
  write(u6,'(a,36a)') '  ',('-',i=1,36)
end if
do ii=1,nYes
  jOrd = VibWind2(ii)
  dFC = FC00*L(0,0)*U(jOrd,0)
  FCWind2(ii) = dFC
  if (iPrint >= 3) then
    loc_n_max = 0
    do j=1,nOsc
      loc_n_max = loc_n_max+nMat(jOrd,j)
    end do
    write(u6,'(a2,i5,i9,e15.6,a2,i4)') ' ',ii,jOrd,FCWind2(ii),' ',loc_n_max
  end if
end do
if (iPrint >= 3) then
  write(u6,'(a,36a)') '  ',('-',i=1,36)
  write(u6,*) ' FC_00 =',FC00
  write(u6,*)
end if

if (iPrint >= 4) then
  write(u6,*)
  write(u6,*) ' Full Franck-Condon factors (FC_00=',FC00,'):'
  write(u6,*) ' =================================================='
  write(u6,*) '    jOrd   FC            level'
  write(u6,*) ' --------------------------------------------------'
  do jOrd=0,max_nOrd
    loc_n_max = 0
    do j=1,nOsc
      loc_n_max = loc_n_max+nMat(jOrd,j)
    end do
    dFC = FC00*L(0,0)*U(jOrd,0)
    write(u6,'(a,i8,e15.6,a2,i4,a2,24i3)') ' ',jOrd,dFC,' ',loc_n_max,' ',(nMat(jOrd,j),j=1,nOsc)
  end do
  write(u6,*) ' --------------------------------------------------'
end if
!GGt -------------------------------------------------------------------

call mma_deallocate(L)
call mma_deallocate(U)
call mma_deallocate(Alpha)
call mma_deallocate(sqr)
call mma_deallocate(temp)
call mma_deallocate(temp1)
call mma_deallocate(temp2)
call mma_deallocate(r_temp1)
call mma_deallocate(r_temp2)

!write(u6,*) 'CGGt[FCVal] Exit'
!call XFlush(u6)

end subroutine ISC_FCval

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine oneexc_cvb(cfrom,cto,vij,diag,iPvb)

use casvb_global, only: iform_ci, ndet, norb, projcas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: cfrom(0:ndet)
real(kind=wp), intent(inout) :: cto(0:ndet), vij(*)
logical(kind=iwp), intent(in) :: diag
integer(kind=iwp), intent(in) :: iPvb
integer(kind=iwp) :: icfrom, icto, idens, nvij
real(kind=wp), allocatable :: vij2(:)

idens = 0
icfrom = nint(cfrom(0))
icto = nint(cto(0))

if (iform_ci(icfrom) /= 0) then
  write(u6,*) ' Unsupported format in ONEEXC/ONEDENS :',iform_ci(icfrom)
  call abend_cvb()
else if (iform_ci(icto) /= 0) then
  write(u6,*) ' Unsupported format in ONEEXC/ONEDENS :',iform_ci(icto)
  call abend_cvb()
end if

call oneexc2_cvb(cfrom(1:),cto(1:),vij,diag,idens,iPvb)

! If projcas and iPvb=0 we asume the normal density/1-ex. is required:
if (projcas .and. (iPvb /= 0)) then
  if (diag) then
    nvij = norb*norb
  else
    nvij = norb*(norb-1)
  end if
  call mma_allocate(vij2,nvij,label='vij2')
  if (idens == 0) then
    vij2(:) = -vij(1:nvij)
  else
    vij2(:) = Zero
  end if
  call oneexc2_cvb(cfrom(1:),cto(1:),vij2,diag,idens,3-iPvb)
  if (idens == 1) vij(1:nvij) = vij(1:nvij)-vij2(:)
  call mma_deallocate(vij2)
end if

return

end subroutine oneexc_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ORBINF_MCLR(NIRREP,NSMOB,NRAS1,NRAS2,NRAS3,
     &                  MXR4tp,IPRNT)
*
* Obtain information about orbitals from shell information
*
* =====
* input
* =====
* Shell and symmetry information in /LUCINP/
*
* ======
* Output
* ======
* Orbital information in /ORBINP/
*
      DIMENSION NRAS1(NIRREP),NRAS2(NIRREP),NRAS3(NIRREP)
      DIMENSION ITFSO(1)
*
#include "detdim.fh"
#include "orbinp_mclr.fh"
*
*
      NTEST = 0000
      NTEST = MAX(NTEST,IPRNT)
************************************************
*                                              *
* Part 1 : From shell format to orbital format *
*                                              *
************************************************
      DO 10 IPIRR = 1, MXPIRR
        NOSPIR(IPIRR) = 1
        IOSPIR(1,IPIRR) = IPIRR
10    CONTINUE
*
* 2 : Shell information to orbital information for each group of orbital
*
*. RAS1
      Call iCopy(3*MXPOBS,[0],0,NRSOBS,1)
      NORB1 = 0
      DO 20 IRREP = 1, NIRREP
        DO 30 ISM = 1, NOSPIR(IRREP)
          IISM = IOSPIR(ISM,IRREP)
          NRSOBS(IISM,1) = NRSOBS(IISM,1) + NRAS1(IRREP)
          NORB1 = NORB1 + NRAS1(IRREP)
30      CONTINUE
20    CONTINUE
*. RAS2

      NORB2 = 0
      DO 40 IRREP = 1, NIRREP
        DO 50 ISM = 1, NOSPIR(IRREP)
          IISM = IOSPIR(ISM,IRREP)
          NRSOBS(IISM,2) = NRSOBS(IISM,2) + NRAS2(IRREP)
          NORB2 = NORB2 + NRAS2(IRREP)
50      CONTINUE
40    CONTINUE

*. RAS3
      NORB3 = 0
      DO 60 IRREP = 1, NIRREP
        DO 70 ISM = 1, NOSPIR(IRREP)
          IISM = IOSPIR(ISM,IRREP)
          NRSOBS(IISM,3) = NRSOBS(IISM,3) + NRAS3(IRREP)
          NORB3 = NORB3 + NRAS3(IRREP)
70      CONTINUE
60    CONTINUE
*. Inactive, RAS0, RAS4, deleted
      NORB4=0
      NORB0=0
      NINOB=0
      NDEOB=0
      DO 80 IRREP = 1, NIRREP
        DO 90 ISM = 1, NOSPIR(IRREP)
          IISM = IOSPIR(ISM,IRREP)
          NINOBS(IISM) = 0
          NDEOBS(IISM) = 0
          NR0OBS(1,IISM) = 0
          DO 100 IPR4T = 1 , MXPR4T
             NR4OBS(IISM,IPR4T)=0
100       CONTINUE
90      CONTINUE
80    CONTINUE
*. Active, occupied  and total number of orbitals
      NACOB = NORB1+NORB2+NORB3
      NOCOB = NACOB+NINOB+NORB0+NORB4
      NTOOB = NOCOB + NDEOB
      DO 110 ISMOB = 1, NSMOB
         NACOBS(ISMOB)=NRSOBS(ISMOB,1)
     &                +NRSOBS(ISMOB,2)
     &                +NRSOBS(ISMOB,3)
         NOCOBS(ISMOB)=NACOBS(ISMOB)
         NTOOBS(ISMOB)=NACOBS(ISMOB)
110   CONTINUE
*
      IF(NTEST.GT.0) THEN
        WRITE(6,*)
        WRITE(6,*) ' ORBINF speaking'
        WRITE(6,*) ' ==============='
        WRITE(6,*) ' Number of orbitals per symmetry + total '
        WRITE(6,'(1H ,A,10I4,8X,I3)')
     *  '     Ras1             ',(NRSOBS(I,1),I=1,NSMOB),NORB1
        WRITE(6,'(1H ,A,10I4,8X,I3)')
     *  '     Ras2             ',(NRSOBS(I,2),I=1,NSMOB),NORB2
        WRITE(6,'(1H ,A,10I4,8X,I3)')
     *  '     Ras3             ',(NRSOBS(I,3),I=1,NSMOB),NORB3
        WRITE(6,'(1H ,A,10I4,8X,I3)')
     *  '     Active           ',(NACOBS(I),I=1,NSMOB),NACOB
        WRITE(6,'(1H ,A,10I4,8X,I3)')
     *  '     Total            ',(NTOOBS(I),I=1,NSMOB),NTOOB
      END IF
*. Offsets for orbitals of given symmetry
      ITOOBS(1) = 1
      DO 500 ISMOB = 2, NSMOB
        ITOOBS(ISMOB) = ITOOBS(ISMOB-1)+NTOOBS(ISMOB-1)
500   CONTINUE
*
      IF(NTEST.GT.0) THEN
        WRITE(6,*) ' Offsets for orbital of given symmetry '
        CALL IWRTMA(ITOOBS,1,NSMOB,1,NSMOB)
      END IF
********************************************
*                                          *
* Part 2 : Reordering arrays for orbitals  *
*                                          *
********************************************
      CALL ORBORD(NSMOB,MXPOBS,MXR4TP,NDEOBS,NINOBS,NR0OBS,NACOBS,
     *     NRSOBS,NR4OBS,NOCOBS,NTOOBS,IREOST,IREOTS,ISMFTO,ITFSO,IPRNT,
     *     IBSO,NTSOB,IBTSOB,ITSOB,NOBPTS,IOBPTS,MXPR4T,
     *     ISMFSO,ITPFTO,NOBPT)
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_multiple_T_worker

   USE fmm_global_paras

   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_get_SPLTSQ_T_matrices,   &
             fmm_get_FLTSQ_T_matrices,    &
             fmm_contract_multi_Tq

CONTAINS

!------------------------------------------------------------------------------
! Get sparse (l+j <= LMAX), lower-triangular, square-based T-matrix
!FIXME: would be nice to allow possibility of building rectangular-based too

   SUBROUTINE fmm_get_SPLTSQ_T_matrices(ndim,LMAX,r_ab,T_matrix)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: ndim, LMAX
      REAL(REALK),   INTENT(IN)  :: r_ab(:,:)
      REAL(REALK),   INTENT(OUT) :: T_matrix(:,:,:)

      REAL(REALK) :: I_sh(ndim,(1+LMAX)**2)

      CALL fmm_generate_I(ndim,LMAX,r_ab,I_sh)
      CALL fmm_generate_T(ndim,LMAX,.FALSE.,I_sh,T_matrix)

   END SUBROUTINE fmm_get_SPLTSQ_T_matrices

!------------------------------------------------------------------------------
! Get full (all elements built), lower-triangular, square T-matrix

   SUBROUTINE fmm_get_FLTSQ_T_matrices(ndim,LMAX,r_ab,T_matrix)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: ndim, LMAX
      REAL(REALK),   INTENT(IN)  :: r_ab(:,:)
      REAL(REALK),   INTENT(OUT) :: T_matrix(:,:,:)

      REAL(REALK) :: I_sh(ndim,(1+2*LMAX)**2)

      CALL fmm_generate_I(ndim,2_INTK*LMAX,r_ab,I_sh)
      CALL fmm_generate_T(ndim,LMAX,.TRUE.,I_sh,T_matrix)

   END SUBROUTINE fmm_get_FLTSQ_T_matrices

!------------------------------------------------------------------------------

   SUBROUTINE fmm_generate_I(ndim,LMAX,r_ab,I_sh)

      ! Subroutine to generate Scaled Irregular solid harmonics
      ! See page 416, "Molecular Electronic Structure Theory".
      !--------------------------------------------------------
      ! I_sh(M,L)  == COS component of I_sh(M,L)
      ! I_sh(-M,L) == SIN component of I_sh(-M,L)
      ! where L and M are positive
      ! Note that I_sh(0,L) == COS component of I_sh(0,L) !
      ! In fact we combine (l,m) into a single index and
      ! we assume the order 0, -1,1,+1, -2,-1,0,+1,+2 ...
      !--------------------------------------------------------

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX, NDIM
      REAL(REALK),   INTENT(IN)  :: r_ab(:,:)
      REAL(REALK),   INTENT(OUT) :: I_sh(:,:)

      REAL(REALK)   :: r_minus2(NDIM)
      INTEGER(INTK) :: L,m, i,j,k,p,q,u, sign_L , n, p1,q1, m1
      REAL(REALK)   :: var1, var2, var3, rmin2

      r_minus2(:) = one/(r_ab(:,1)**2 + r_ab(:,2)**2 + r_ab(:,3)**2)

      IF (LMAX==0) THEN
         I_sh(:,1) = SQRT(r_minus2(:))
         RETURN
      END IF

      I_sh(:,1) =  SQRT(r_minus2(:))
      I_sh(:,2) = -r_ab(:,2)*r_minus2(:)*I_sh(:,1)
      I_sh(:,3) =  r_ab(:,3)*r_minus2(:)*I_sh(:,1)
      I_sh(:,4) = -r_ab(:,1)*r_minus2(:)*I_sh(:,1)

      ! Now iterate higher order terms
      sign_L = -1
      DO L = 2, LMAX

         sign_L = -sign_L
         i = (L+1)*(L+1)
         j = L*L+1
         p = j-2*L+1
         q = j-1
         p1 = p
         q1 = q
         p = p+L-1
         q = L*(L-3)+3
         u = q+L-2
         k = i-L
         m1 = L-1

         DO n = 1, ndim

            rmin2 = r_minus2(n)
            var1 = (2*L-1)*rmin2
            var2 = var1*r_ab(n,2)*sign_L
            var3 = var1*r_ab(n,1)
            I_sh(n,i) = var2*I_sh(n,p1) - var3*I_sh(n,q1)
            I_sh(n,j) = var2*I_sh(n,q1) + var3*I_sh(n,p1)
            var2 = var1*r_ab(n,3)

            DO m = 0, L-2
               var3 = (u-m*m)*rmin2
               I_sh(n,k+m) = var2*I_sh(n,p+m) - var3*I_sh(n,q+m)
               I_sh(n,k-m) = var2*I_sh(n,p-m) - var3*I_sh(n,q-m)
            END DO

            I_sh(n,k+m1) = var2*I_sh(n,p+m1)
            I_sh(n,k-m1) = var2*I_sh(n,p-m1)

         end do

      END DO

   END SUBROUTINE fmm_generate_I

!------------------------------------------------------------------------------

   SUBROUTINE fmm_generate_T(ndim,LMAX,TOLMAX,I_sh,T_matrix)

   ! Subroutine to generate Real Interaction Matrix for
   ! given point from Irregular Solid Harmonics (I_sh)
   ! cf Helgaker et. al. pp 415
   !-----------------------------------------------------------------------
   !  T_cos_cos(lm,jk) = 2*{I_cos(l+j,m+k) + (-1)^k*I_cos(l+j,m-k)}  etc.
   !
   ! Note we only write the non-zero elements here, and the precise form
   ! depends on the function JMAX passed in
   !-----------------------------------------------------------------------
   !FIXME: can optimise for j=l by noting that if we build just lower
   ! triangular, we need only half the elements there

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX, NDIM
      LOGICAL,       INTENT(IN)  :: TOLMAX
      REAL(REALK),   INTENT(IN)  :: I_sh(:,:)
      REAL(REALK),   INTENT(OUT) :: T_matrix(:,:,:)

      INTEGER(INTK) :: sign_m
      INTEGER(INTK) :: L,J,k,m, q, pp,qq, u, Jlast

      IF (LMAX==0) THEN
         T_matrix(:,1,1) = two*I_sh(:,1)  ! NB scaling to make T symmetric
         RETURN
      END IF

      L_loop: DO L = 0, LMAX
         qq = L*(L+1) +1

         IF (tolmax) THEN
            Jlast = LMAX
         ELSE
            Jlast = LMAX - L
         END IF

         J_loop: DO J = L, Jlast
            pp = J*(J+1) +1
            u = 1+(L+J)*(L+J+1)

            sign_m = -1
            positive_m: DO m = 0, L
               q = qq+m
               sign_m = -sign_m

               ! cos-cos terms
               !---------------

               DO k = 0, MIN(m,J)
                  IF (BTEST(k,0)) THEN
                     T_matrix(:,pp+k,q) = I_sh(:,u+m+k) - I_sh(:,u+m-k)
                  ELSE
                     T_matrix(:,pp+k,q) = I_sh(:,u+m+k) + I_sh(:,u+m-k)
                  END IF
               END DO
               IF (sign_m > 0) THEN
                  DO k = m+1, J
                     T_matrix(:,pp+k,q) = I_sh(:,u+m+k) + I_sh(:,u-m+k)
                  END DO
               ELSE
                  DO k = m+1, J
                     T_matrix(:,pp+k,q) = I_sh(:,u+m+k) - I_sh(:,u-m+k)
                  END DO
               END IF

               ! cos-sin terms
               !---------------

               IF (sign_m > 0) THEN
                  DO k = -J, MIN(-m-1,-1)
                     T_matrix(:,pp+k,q) = I_sh(:,u+(m+k)) + I_sh(:,u+(-(m-k)))
                  END DO
                  DO k = MAX(-J,-m), MIN(-m,-1)
                     T_matrix(:,pp+k,q) = I_sh(:,u+(-(m-k)))
                  END DO
                  DO k = -1, MAX(-m+1,-J), -1
                     IF (BTEST(k,0)) THEN
                        T_matrix(:,pp+k,q) =   I_sh(:,u+(-(m+k)))    &
                                             + I_sh(:,u+(-(m-k)))
                     ELSE
                        T_matrix(:,pp+k,q) = - I_sh(:,u+(-(m+k)))    &
                                             + I_sh(:,u+(-(m-k)))
                     END IF
                  END DO
               ELSE
                  DO k = -J, MIN(-m-1,-1)
                     T_matrix(:,pp+k,q) = I_sh(:,u+(m+k)) - I_sh(:,u+(-(m-k)))
                  END DO
                  DO k = MAX(-J,-m), MIN(-m,-1)
                     T_matrix(:,pp+k,q) = - I_sh(:,u+(-(m-k)))
                  END DO
                  DO k = -1, MAX(-m+1,-J), -1
                     IF (BTEST(k,0)) THEN
                        T_matrix(:,pp+k,q) = - I_sh(:,u+(-(m+k)))   &
                                             - I_sh(:,u+(-(m-k)))
                     ELSE
                        T_matrix(:,pp+k,q) =   I_sh(:,u+(-(m+k)))   &
                                             - I_sh(:,u+(-(m-k)))
                     END IF
                  END DO
               END IF

            END DO  positive_m

            sign_m = 1
            negative_m: DO m = -1, -L, -1
               q = qq+m
               sign_m = -sign_m

               ! sin-cos terms
               !---------------

               k = MIN(J,-m)
               IF (BTEST(k,0)) THEN
                  T_matrix(:,pp+k,q) = - I_sh(:,u+(m-k))
               ELSE
                  T_matrix(:,pp+k,q) =   I_sh(:,u+(m-k))
               END IF

               DO k = 0, MIN((-m-1),J)
                  IF (BTEST(k,0)) THEN
                     T_matrix(:,pp+k,q) = I_sh(:,u+(m+k)) - I_sh(:,u+(m-k))
                  ELSE
                     T_matrix(:,pp+k,q) = I_sh(:,u+(m+k)) + I_sh(:,u+(m-k))
                  END IF
               END DO

               IF (sign_m > 0) THEN
                  DO k = J, (-m+1), -1
                     IF (BTEST(k,0)) THEN
                        T_matrix(:,pp+k,q) =   I_sh(:,u+(-(m+k)))   &
                                             - I_sh(:,u+(m-k))
                     ELSE
                        T_matrix(:,pp+k,q) = - I_sh(:,u+(-(m+k)))   &
                                             + I_sh(:,u+(m-k))
                     END IF
                  END DO
               ELSE
                  DO k = J, (-m+1), -1
                     IF (BTEST(k,0)) THEN
                        T_matrix(:,pp+k,q) = - I_sh(:,u+(-(m+k)))   &
                                             - I_sh(:,u+(m-k))
                     ELSE
                        T_matrix(:,pp+k,q) =   I_sh(:,u+(-(m+k)))   &
                                             + I_sh(:,u+(m-k))
                     END IF
                  END DO
               END IF

               ! sin-sin terms
               !---------------

               IF (sign_m > 0) THEN
                  DO k = -J, m
                     IF (BTEST(k,0)) THEN
                        T_matrix(:,pp+k,q) =   I_sh(:,u+(-(m+k)))   &
                                             - I_sh(:,u+(m-k))
                     ELSE
                        T_matrix(:,pp+k,q) = - I_sh(:,u+(-(m+k)))   &
                                             + I_sh(:,u+(m-k))
                     END IF
                  END DO
                  DO k = -1, MAX(-J,m+1), -1
                     IF (BTEST(k,0)) THEN
                        T_matrix(:,pp+k,q) =   I_sh(:,u+(-(m+k)))   &
                                             + I_sh(:,u+(-(m-k)))
                     ELSE
                        T_matrix(:,pp+k,q) = - I_sh(:,u+(-(m+k)))   &
                                             + I_sh(:,u+(-(m-k)))
                     END IF
                  END DO
               ELSE
                  DO k = -J, m
                     IF (BTEST(k,0)) THEN
                        T_matrix(:,pp+k,q) = - I_sh(:,u+(-(m+k)))   &
                                             - I_sh(:,u+(m-k))
                     ELSE
                        T_matrix(:,pp+k,q) =   I_sh(:,u+(-(m+k)))   &
                                             + I_sh(:,u+(m-k))
                     END IF
                  END DO
                  DO k = -1, MAX(-J,m+1), -1
                     IF (BTEST(k,0)) THEN
                        T_matrix(:,pp+k,q) = - I_sh(:,u+(-(m+k)))   &
                                             - I_sh(:,u+(-(m-k)))
                     ELSE
                        T_matrix(:,pp+k,q) =   I_sh(:,u+(-(m+k)))   &
                                             - I_sh(:,u+(-(m-k)))
                     END IF
                  END DO
               END IF

            END DO  negative_m
         END DO     J_loop
      END DO        L_loop

! Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(ndim)
   END SUBROUTINE fmm_generate_T

!------------------------------------------------------------------------------

   FUNCTION fmm_contract_multi_Tq(LMAX,vect,T_mats,ndim)

     IMPLICIT NONE
     INTEGER(INTK), INTENT(IN) :: LMAX, ndim
     REAL(REALK),   INTENT(IN) :: vect(:)
     REAL(REALK),   INTENT(IN) :: T_mats(:,:,:)
     REAL(REALK) :: fmm_contract_multi_Tq(ndim,(LMAX+1)**2)

     INTEGER(INTK) :: L, p,q,r,s ,u, qmin,qmax
     REAL(REALK) :: fac

     ! first do L=0 terms
     p = (LMAX+1)*(LMAX+1)

     fac = half*vect(1)
     DO r = 1, ndim
        fmm_contract_multi_Tq(r,1) = fac*T_mats(r,1,1)
     END DO

     DO s = 2, p
     fac = half*vect(s)
        DO r = 1, ndim
           fmm_contract_multi_Tq(r,1) = fmm_contract_multi_Tq(r,1)    &
                                       + fac*T_mats(r,s,1)
        END DO
     END DO

     fac = vect(1)
     DO s = 2, p
        DO r = 1, ndim
           fmm_contract_multi_Tq(r,s) = fac*T_mats(r,s,1)
        END DO
     END DO

     contract: DO L = 1, LMAX

        u = L*(L+1) +1
        p = (LMAX-L+1)*(LMAX-L+1)

        qmin = u-L
        qmax = MIN( u+L, p )

        qloop: DO q = qmin, qmax

           DO s = q, p
           CALL DAXPY_(ndim,vect(s),T_mats(1,s,q:),1,fmm_contract_multi_Tq(1,q),1)
           END DO

           fac = vect(q)
           DO s = q+1, p
              DO r = 1, ndim
                 fmm_contract_multi_Tq(r,s) = fmm_contract_multi_Tq(r,s)    &
                                             + fac*T_mats(r,s,q)
              END DO
           END DO

        END DO qloop

        fmm_contract_multi_Tq(:,u) = half*fmm_contract_multi_Tq(:,u)    ! m=0

     END DO contract

   END FUNCTION fmm_contract_multi_Tq

!------------------------------------------------------------------------------

END MODULE fmm_multiple_T_worker

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Yoshio Nishimoto                                 *
!***********************************************************************
!
! (Preconditioned) Conjugate Gradient Squared (CGS) method
!
! Ref: Sonneveld, P. SIAM J. Sci. Stat. Comput. 1989, 10, 36-52.
!      Itoh, S.; Sugihara, M. Trans. Jpn. Soc. Ind. Appl. Math. 2013, 23, 253-286.
! The preconditioning comes from Algorithm 4 in the second ref (Japanese literature).
!
! CGS does not assume the electronic Hessian is symmetric positive definite.
! The electronic Hessian is non-symmetric if PCM or dynamically weighted things are used, so CGS is preferred.
! Note, however, that CGS requires twice more computation per iteration and memory.
! Unfortunately, CGS requires more iteration than the halve with CG.
! The actual calculation is done in cgs_x.F90.

module cgs_mod

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none

! Activate the CGS method
! This option can perhaps be useful for non-PCM runs as well in some difficult cases
logical(kind=iwp) :: CGS = .false.

! Algorithm number written in Itoh, S. et al (above)
! BiCG algorithms are not implemented mainly because the transpose of the Hessian is not available
! PCGS = 4: the standard preconditioning
! PCGS = 5: an additional preconditioning before the loop
! Other algorithms are not implemented. Algorithm 5 may improve the convergence but I do not know.
integer(kind=iwp), parameter :: PCGS = 4

type CGS_type
  !! CI rotations
  integer(kind=iwp) :: ipPvec, ipQvec, ipUvec, ipR0
  !! orbital rotations
  real(kind=wp), allocatable :: Pvec(:), Qvec(:), Uvec(:), R0(:)
end type CGS_type

type(CGS_type) :: CGSvec

contains

!-----------------------------------------------------------------------

subroutine CGS_init(nconf1,nRoots,nDens2)

  use ipPage, only: ipget

  integer(kind=iwp), intent(in) :: nconf1, nRoots, nDens2

  if ((PCGS /= 4) .and. (PCGS /= 5)) then
    write(u6,*) 'The selected CGS algorithm is not implemented'
    call abend()
  end if

  call mma_allocate(CGSvec%Pvec,nDens2+6,Label='Pvec')
  call mma_allocate(CGSvec%Qvec,nDens2+6,Label='Qvec')
  call mma_allocate(CGSvec%Uvec,nDens2+6,Label='Uvec')
  call mma_allocate(CGSvec%R0,nDens2+6,Label='R0')

  CGSvec%ipPvec = ipGet(nconf1*nroots)
  CGSvec%ipQvec = ipGet(nconf1*nroots)
  CGSvec%ipUvec = ipGet(nconf1*nroots)
  CGSvec%ipR0 = ipGet(nconf1*nroots)

end subroutine CGS_init

!-----------------------------------------------------------------------

subroutine CGS_final()

  implicit none

  call mma_deallocate(CGSvec%Pvec)
  call mma_deallocate(CGSvec%Qvec)
  call mma_deallocate(CGSvec%Uvec)
  call mma_deallocate(CGSvec%R0)

end subroutine CGS_final

end module cgs_mod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE PRWF1_CP2(NOCSF,IOCSF,NOW,IOW,ISYCI,CI,THR,nMidV)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp, u6
      use gugx, only: SGS, CIS
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM, ISPIN, PRSD
      use gugx, only: MxLev
      IMPLICIT None
      Integer(kind=iwp), Intent(In):: ISYCI, nMidV
      integer(kind=iwp), intent(in):: NOCSF(NSYM,NMIDV,NSYM),
     &                                IOCSF(NSYM,NMIDV,NSYM)
      integer(kind=iwp), intent(in):: NOW(2,NSYM,NMIDV),
     &                                IOW(2,NSYM,NMIDV)
      real(kind=wp), intent(in):: CI(*), THR

      CHARACTER(LEN=256) LINE
      CHARACTER(LEN=1) :: CODE(0:3)=['0','u','d','2']
      integer(kind=iwp) ICS(MXLEV)
      integer(kind=iwp) :: nLev, nIpWlk
      integer(kind=iwp), ALLOCATABLE:: LEX(:)
      real(kind=wp) COEF
      integer(kind=iwp) IC1, ICDPOS, ICDWN, ICONF, ICUP, ICUPOS, IDW0,
     &                  IDWN, IDWNSV, IMS, ISY, ISYDWN, ISYUP, IUP,
     &                  IUW0, K, LENCSF, LEV, MV, NCI, NDWN, NNN, NUP

      nLev  = SGS%nLev
      nIpWlk= CIS%nIpWlk

C -- NOTE: THIS PRWF ROUTINE USES THE CONVENTION THAT CI BLOCKS
C -- ARE MATRICES CI(I,J), WHERE THE   F I R S T   INDEX I REFERS TO
C -- THE   U P P E R   PART OF THE WALK.

C SVC: set up a CSF string length as LENCSF
      LINE=' '
      LENCSF=0
      ISY=0
      DO LEV=1,NLEV
        IF(ISY/=SGS%ISM(LEV)) THEN
          ISY=SGS%ISM(LEV)
          LENCSF=LENCSF+1
        END IF
        LENCSF=LENCSF+1
      END DO
      LENCSF=MIN(LENCSF,256)
      LENCSF=MAX(LENCSF,10)


C Size of occup/spin coupling part of line:
      WRITE(u6,*)' Occupation of active orbitals, and spin coupling'
      WRITE(u6,*)' of open shells. (u,d: Spin up or down).'
      WRITE(u6,*)' SGUGA info is (Midvert:IsyUp:UpperWalk/LowerWalk)'
      LINE(1:10)='Occupation'
      WRITE(u6,'(2X,A10,2X,A16,2X,A,2(2X,A13))')
     & 'Conf','SGUGA info      ',LINE(1:LENCSF),
     & 'Coefficient','Weight'

C     SVC2010:
C     allocate scratch memory for determinant expansion
      IF (PRSD) THEN
        CALL mma_allocate(LEX,NLEV,LABEL='LEX')
      END IF

      LINE=' '

C -- THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
C    WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.
      DO MV=1,NMIDV
        DO ISYUP=1,NSYM
          NCI=NOCSF(ISYUP,MV,ISYCI)
          IF(NCI==0) Cycle
          NUP=NOW(1,ISYUP,MV)
          ISYDWN=Mul(ISYUP,ISYCI)
          NDWN=NOW(2,ISYDWN,MV)
          ICONF=IOCSF(ISYUP,MV,ISYCI)
          IUW0=1-NIPWLK+IOW(1,ISYUP,MV)
          IDW0=1-NIPWLK+IOW(2,ISYDWN,MV)
          IDWNSV=0
          DO IDWN=1,NDWN
            DO IUP=1,NUP
              ICONF=ICONF+1
              COEF=CI(ICONF)
C -- SKIP OR PRINT IT OUT?
              IF(ABS(COEF)<THR) Cycle
              IF(IDWNSV/=IDWN) THEN
                ICDPOS=IDW0+IDWN*NIPWLK
                ICDWN=CIS%ICASE(ICDPOS)
C -- UNPACK LOWER WALK.
                NNN=0
                DO LEV=1,SGS%MIDLEV
                  NNN=NNN+1
                  IF(NNN==16) THEN
                    NNN=1
                    ICDPOS=ICDPOS+1
                    ICDWN=CIS%ICASE(ICDPOS)
                  END IF
                  IC1=ICDWN/4
                  ICS(LEV)=ICDWN-4*IC1
                  ICDWN=IC1
                End Do
                IDWNSV=IDWN
              END IF
              ICUPOS=IUW0+NIPWLK*IUP
              ICUP=CIS%ICASE(ICUPOS)
C -- UNPACK UPPER WALK:
              NNN=0
              DO LEV=SGS%MIDLEV+1,NLEV
                NNN=NNN+1
                IF(NNN==16) THEN
                  NNN=1
                  ICUPOS=ICUPOS+1
                  ICUP=CIS%ICASE(ICUPOS)
                END IF
                IC1=ICUP/4
                ICS(LEV)=ICUP-4*IC1
                ICUP=IC1
              END DO
C -- PRINT IT!
              K=0
              ISY=0
              DO LEV=1,NLEV
                IF(ISY/=SGS%ISM(LEV)) THEN
                  ISY=SGS%ISM(LEV)
                  K=K+1
                  LINE(K:K)=' '
                END IF
                K=K+1
                LINE(K:K)=CODE(ICS(LEV))
              END DO
              WRITE(u6,"(2X,I10,2X,'(',I2,':',I1,':',I4,'/',I4,')',
     &       2X,A,2(2X,F13.6))")
     &               ICONF,MV,ISYUP,IUP,IDWN,
     &               LINE(1:LENCSF),COEF,COEF**2
C     SVC2010 experimental: add determinant expansion
              IF (PRSD) THEN
c     Specify projected spin in half integer units
C     Default: use maximum spin projection
               IMS = ISPIN-1
               WRITE(u6,*)
               CALL EXPCSF (ICS, NLEV, IMS, LEX, coef, 0)
               WRITE(u6,*)
              ENDIF
            End Do
          End Do
        End Do
      End Do

C     SVC2010: free scratch for determinant expansion
      IF (PRSD) CALL mma_deallocate(LEX)
      WRITE(u6,*)

      END SUBROUTINE PRWF1_CP2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GF_Harmonic_Frequencies(G,GInv,Tmp1,Tmp2,
     &                                   EVec,EVal,RedM,iNeg,nX,mInter)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "constants2.fh"
      Real*8 G(nX**2),GInv(nX**2), Tmp1(mInter,mInter), Tmp2(nX**2),
     &       EVec(2*mInter,mInter),  EVal(2*mInter), RedM(mInter)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute eigenvectors and eigenfunctions
*
      Call FZero(Tmp1,mInter**2)
      call dcopy_(nX,[One],0,Tmp1,mInter+1)
      Call NIDiag_new(Tmp2,Tmp1,mInter,mInter,0)
*
      Call FZero(EVal,2*mInter)
      Call FZero(EVec,2*mInter**2)
*
*     Move over eigenvalue and eigenvectors, note that the eigenvectors
*     are transformed back to Cartesian coordinates from mass-weighted
*     Cartesians.
*
      Do iX = 1, mInter
         iiT= iX*(iX+1)/2
         EVal((iX-1)*2+1)=Tmp2(iiT)
         call dcopy_(mInter,Tmp1(1,iX),1,EVec(1,iX),2)
*
         r2 = Zero
         Do jX = 1, mInter
            jj = (jX-1)*mInter + jX
            tmp=EVec((jX-1)*2+1,iX)
            tmp=tmp*Sqrt(G(jj))
            EVec((jX-1)*2+1,iX)=tmp
            r2 = r2 + tmp**2
         End Do
         Call DScal_(mInter,One/Sqrt(r2),EVec(1,iX),2)
      End Do
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('EVal',' ',EVal,2,mInter)
      Call RecPrt('EVec',' ',EVec,mInter*2,mInter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute the harmonic frequencies
*                                                                      *
************************************************************************
*                                                                      *
      iNeg=0
      Do iHarm = 1, 2*mInter, 2
         jHarm = (iHarm+1)/2
         temp = EVal(iHarm)
*
*        Fix imaginary frequencies
*
         If (temp.ge.Zero) Then
            EVal(jHarm) = Sqrt(temp)*autocm
         Else
            iNeg=iNeg+1
            EVal(jHarm) = -Sqrt(Abs(temp))*autocm
         End If
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Converted EVal',' ',EVal,1,mInter)
#endif
*
*-----Normalize over the metric of the masses
*
      Do iHarm = 1, mInter
         call dcopy_(mInter,EVec(1,iHarm),2,Tmp1,1)
         Call DGEMM_('N','N',
     &               mInter,1,mInter,
     &               1.0d0,GInv,mInter,
     &               Tmp1,mInter,
     &               0.0d0,Tmp2,mInter)
         r2=DDot_(mInter,Tmp1,1,Tmp2,1)
         RedM(iHarm)=r2
         r2=One/Sqrt(r2)
         Call DScal_(mInter,r2,EVec(1,iHarm),2)
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Normal coordinates (Q)',' ', EVec,mInter*2,mInter)
#endif
*
*-----Order, from low to high. Put translations and rotations last.
*
      Do iHarm = 1, mInter-1
         Test_i=EVal(iHarm)
         If (Abs(Test_i).lt.1.0D-3) Test_i = 1.0D+5
         Do jHarm = iHarm+1, mInter
            Test_j=EVal(jHarm)
            If (Abs(Test_j).lt.1.0D-3) Test_j = 1.0D+5
            If (Test_j.lt.Test_i) Then
               rlow=Test_i
               Test_i=Test_j
               Test_j=rlow
               rlow=EVal(iHarm)
               EVal(iHarm)=EVal(jHarm)
               EVal(jHarm)=rLow
               rlow=RedM(iHarm)
               RedM(iHarm)=RedM(jHarm)
               RedM(jHarm)=rLow
               Call DSwap_(mInter,EVec(1,iHarm),2,EVec(1,jHarm),2)
            End If
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Frequencies (cm-1)',' ',EVal,1,mInter)
      Call RecPrt('Reduced masses (u)',' ',RedM,1,mInter)
      Call RecPrt('Normal Coordinates',' ',EVec,mInter*2,mInter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,2021, Roland Lindh                                *
!***********************************************************************

subroutine SymAdp_Full(SOIntegrals,nSOInt,list_s,nlist_s,Fact,ndc,nD)
!***********************************************************************
!                                                                      *
! Object: to transform the one-electron matrix elements from AO basis  *
!         to SO basis.                                                 *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January 1991                                             *
!***********************************************************************

use iSD_data, only: iSD
use Basis_Info, only: nBas
use Symmetry_Info, only: iChTbl, nIrrep
use SOAO_Info, only: iAOtSO
use nq_Grid, only: Dens_AO, iBfn_Index
use Index_Functions, only: iTri
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSOInt, nlist_s, list_s(2,nlist_s), ndc, nD
real(kind=wp), intent(inout) :: SOIntegrals(nSOInt,nD)
real(kind=wp), intent(in) :: Fact(ndc,ndc)
integer(kind=iwp) :: iAO, iBfn, iBfn_, iCmp, ilist_s, indAO1, Indij, iPnt, iShell, iSkal, iSO, iSO1, j1, jBfn, jBfn_, jlist_s, &
                     jShell, jSkal, jSO, kDCRE, kDCRR, loper, mBfn, mdci, mdcj, nBfn, nOp(2)
real(kind=wp) :: xa, xaxb, xb
integer(kind=iwp), allocatable :: BasList(:,:)
integer(kind=iwp), external :: iPntSO, NrOpr

!                                                                      *
!***********************************************************************
!                                                                      *
nBfn = size(iBfn_Index,2)
call mma_Allocate(BasList,2,nBfn,Label='BasList')
loper = 1
do j1=0,nIrrep-1
  iPnt = iPntSO(j1,j1,lOper,nbas)

  ! Pick up only basis functions which contribute to (j1,j1)
  mBfn = 0
  do iBfn=1,nBfn
    ilist_s = iBfn_Index(2,iBfn)
    iCmp = iBfn_Index(3,iBfn)
    indAO1 = iBfn_Index(6,iBfn)
    iSkal = list_s(1,ilist_s)
    iAO = iSD(7,iSkal)
    iSO1 = iAOtSO(iAO+iCmp,j1)
    if (iSO1 < 0) cycle
    mBfn = mBfn+1
    BasList(1,mBfn) = iBfn
    BasList(2,mBfn) = iSO1+IndAO1-1
  end do

  do iBfn_=1,mBfn
    iBfn = BasList(1,iBfn_)
    iSO = BasList(2,iBfn_)

    ilist_s = iBfn_Index(2,iBfn)
    iSkal = list_s(1,ilist_s)
    kDCRE = list_s(2,ilist_s)
    mdci = iSD(10,iSkal)
    iShell = iSD(11,iSkal)
    nOp(1) = NrOpr(kDCRE)
    xa = real(iChTbl(j1,nOp(1)),kind=wp)

    do jBfn_=1,iBfn_
      jBfn = BasList(1,jBfn_)
      jSO = BasList(2,jBfn_)

      jlist_s = iBfn_Index(2,jBfn)
      jSkal = list_s(1,jlist_s)
      kDCRR = list_s(2,jlist_s)
      mdcj = iSD(10,jSkal)
      jShell = iSD(11,jSkal)
      nOp(2) = NrOpr(kDCRR)
      xb = real(iChTbl(j1,nOp(2)),kind=wp)

      xaxb = xa*xb
      if ((iShell == jShell) .and. (nOp(1) /= nOp(2)) .and. (iSO == jSO)) xaxb = xaxb*Two

      Indij = iPnt+iTri(iSO,jSO)

      SOIntegrals(Indij,:) = SOIntegrals(Indij,:)+Fact(mdci,mdcj)*xaxb*Dens_AO(iBfn,jBfn,:)

    end do ! jBfn
  end do   ! iBfn
end do     ! j1
call mma_deAllocate(BasList)

return

end subroutine SymAdp_Full

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine hdir(nDir,nDirZee,dirX,dirY,dirZ,dir_weight,nP,nsymm,ngrid,nDirTot,dHX,dHY,dHZ,dHW)
! this routine generates the directions of the applied magnetic
! field according to Lebedev-Laikov grids using the the given parameters (nsymm, ngrid)

use Lebedev_quadrature, only: ld_by_rule
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDir, nDirZee, nP, nsymm, ngrid, nDirTot
real(kind=wp), intent(in) :: dirX(nDir), dirY(nDir), dirZ(nDir), dir_weight(nDirZee,3)
real(kind=wp), intent(out) :: dHX(nDirTot), dHY(nDirTot), dHZ(nDirTot), dHW(nDirTot)
real(kind=wp) :: X(nP), Y(nP), Z(nP), W(nP)

if ((nDirTot-nDir-nDirZee-nP) /= 0) then
  write(u6,'(A   )') 'the number of directions of applied magnetic field is not consistent:'
  write(u6,'(A,i4)') 'nDir    = ',nDir
  write(u6,'(A,i4)') 'nDirZee = ',nDirZee
  write(u6,'(A,i4)') 'nP      = ',nP
  write(u6,'(A,i4)') 'nDirTot = ',nDirTot
  write(u6,'(A,i4)') 'The rule is :'
  write(u6,'(A   )') 'nDir + nDirZee + nP = nDirTot'
  call xFlush(u6)
  call abend()
end if

dHX(1:nDir) = dirX(:)
dHY(1:nDir) = dirY(:)
dHZ(1:nDir) = dirZ(:)

dHX(nDir+1:nDir+nDirZee) = dir_weight(:,1)
dHY(nDir+1:nDir+nDirZee) = dir_weight(:,2)
dHZ(nDir+1:nDir+nDirZee) = dir_weight(:,3)

dHW(1:nDir+nDirZee) = Zero

call ld_by_rule(nSymm,nGrid,X,Y,Z,W)

dHX(nDir+nDirZee+1:nDir+nDirZee+nP) = X(:)
dHY(nDir+nDirZee+1:nDir+nDirZee+nP) = Y(:)
dHZ(nDir+nDirZee+1:nDir+nDirZee+nP) = Z(:)
dHW(nDir+nDirZee+1:nDir+nDirZee+nP) = W(:)

return

end subroutine hdir

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine red2full(XLT,nXLT,Xab,nXab)

use Index_Functions, only: iTri, nTri_Elem
use Cholesky, only: iBas, iiBstR, IndRed, iRS2F, nBas, nnBstR, nSym
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nXLT, nXab
real(kind=wp), intent(inout) :: XLT(nXLT)
real(kind=wp), intent(in) :: Xab(nXab)
integer(kind=iwp) :: iab, iag, ias, ibg, ibs, iLoc, iRab, IS, ISLT(8), ISYM, iSyma, jRab, jSym, kRab, kto, NB
integer(kind=iwp), external :: cho_isao

! Select table column for use with caspt2:
iLoc = 3
! jSym=1 always: Used for density matrices.
jSym = 1
! Offsets to symmetry block in the LT matrix
IS = 0
do ISYM=1,NSYM
  ISLT(ISYM) = IS
  NB = NBAS(ISYM)
  IS = IS+nTri_Elem(NB)
end do

do jRab=1,nnBstR(jSym,iLoc)
  kRab = iiBstr(jSym,iLoc)+jRab
  iRab = IndRed(kRab,iLoc)
  iag = iRS2F(1,iRab)
  ibg = iRS2F(2,iRab)
  iSyma = cho_isao(iag)
  ias = iag-ibas(iSyma)
  ibs = ibg-ibas(iSyma)
  iab = iTri(ias,ibs)
  kto = isLT(iSyma)+iab
  XLT(kto) = XLT(kto)+Xab(jRab)
end do

end subroutine red2full

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine espf (ireturn,StandAlone)
      use Real_Spherical
      use Basis_Info, only: nBas
      use Symmetry_Info, only: VarR, VarT, Symmetry_Info_Dmp
      Implicit Real*8 (A-H,O-Z)
*
* ESPF Module
*
#include "espf.fh"
*
#include "nsd.fh"
#include "disp.fh"
#include "setup.fh"
#include "status.fh"
#include "print.fh"
#include "nac.fh"
      Character Label*8
      Logical Forces,Show_espf,StandAlone,DoTinker,DoGromacs,DynExtPot
      Logical lMorok,DoDirect,isNAC_tmp
      Dimension idum(1)
      Logical :: Close_Seward
*
      iReturn=99
*
*-----Print
*
      iPL = iPL_espf()
      Close_Seward=.False.
*
* Some warnings
*
      Call Get_iScalar('nSym',nSym)
      If (nSym.gt.1) Then
         Write(6,'(A)')' Symmetry cannot be used together with ESPF.'
         Call Quit_OnUserError()
       End If
*
* Set on the System Bit 11
*
      Call Get_iScalar('System Bitswitch',iOption)
      iOption=iOr(iOption,2**11)
      Call Put_iScalar('System Bitswitch',iOption)
*
* Some initializations
*
      Call espf_init(natom,nAtQM,ipCord,ipIsMM,ipExt)
      ipMltp = ip_Dummy
      nGrdPt = 0
      ipGrid = ip_Dummy
      ipDGrd = ip_Dummy
      isNAC_tmp = isNAC
*
* Read the input and compute the external potential
*
      Call StatusLine(' espf:',' Reading input')
      Call ReadIn_ESPF(natom,ipCord,ipExt,MltOrd,iRMax,DeltaR,Forces,
     &                Show_espf,ipIsMM,StandAlone,iGrdTyp,DoTinker,
     &                DoGromacs,DynExtPot,ipMltp,natMM,lMorok,DoDirect,
     &                ipGradCl,EnergyCl)
*
* If the present calculation does not use ESPF but the Direct scheme
*
      If (DoDirect) Then
         Call No_ESPF(natom,Forces,DoTinker)
         Goto 98
      End If
*
      nMult = MltOrd * nAtQM
      If (iPL.ge.2) Write(6,'(/,A,I2,A,i4,A,i6)')
     &   ' Number of ESPF operators (nMult=',MltOrd,' * nAtQM=',
     &     nAtQM,'): ',nMult
*
* Compute the grid around the molecule
*
      Call StatusLine(' espf:',' Making the grid')
      If (iGrdTyp.eq.1) Then
         If(nGrdPt.eq.0) Call MkGrid(natom,ipCord,ipGrid,nGrdPt,iRMax,
     &      DeltaR,Forces,ipIsMM,-iGrdTyp,ipDGrd,nAtQM)
         Call GetMem('ESPF_Grid','ALLO','REAL',ipGrid,3*nGrdPt)
         Call MkGrid(natom,ipCord,ipGrid,nGrdPt,iRMax,DeltaR,Forces,
     &     ipIsMM,iGrdTyp,ipDGrd,nAtQM)
         If (iPL.ge.2) Then
            Write(6,'(A)') ' PNT Grid (Warning: no grid derivatives)'
            Write(6,'(A)') ' (C. Chipot and J. Angyan,'//
     &                     ' Henri Poincare University, Nancy, France)'
            Write(6,'(5X,I5,A)') nGrdPt,' grid points'
         End If
      Else
         Call MkGrid(natom,ipCord,ipGrid,nGrdPt,iRMax,DeltaR,Forces,
     &      ipIsMM,iGrdTyp,ipDGrd,nAtQM)
         If (iPL.ge.2) Then
            Write(6,'(A)')' GEPOL Grid, using United Atoms radii'
            Write(6,'(5X,I5,A)') nGrdPt,' grid points'
         End If
      End If
*
*     If this is a standalone call to &ESPF, there are 2 options:
*        1) static external potential: compute here the ESPF contributions
*        2) dynamic external potential: nothing more to compute here
*
      If (StandAlone .and. DynExtPot) Goto 98
*
* Compute the cartesian tensor T, TtT^-1, [TtT^-1]Tt
* and B=ExtPot[TtT^-1]Tt
* Tt means the transpose of T
*
      iSize1 = nMult * nGrdPt
      iSize2 = nMult * nMult
      iSize3 = nMult * Max(nMult,nGrdPt)
      Call GetMem('CartTensor','Allo','Real',ipT,iSize1)
      Call GetMem('TT','Allo','Real',ipTT,iSize2)
      Call GetMem('TTT','Allo','Real',ipTTT,iSize3)
      Call GetMem('ExtPot*TTT','Allo','Real',ipB,nGrdPt)
      Call InitB(nMult,natom,nAtQM,nGrdPt,ipCord,ipGrid,ipT,ipTT,ipTTT,
     &           ipExt,ipB,ipIsMM)
      Call GetMem('DerivB','Allo','Real',ipDB,nGrdPt*3*nAtQM)
      Call InitDB(nMult,natom,nAtQM,nGrdPt,ipCord,ipGrid,ipT,ipTT,
     &           ipTTT,ipExt,ipDB,ipIsMM,iRMax,DeltaR,iGrdTyp,ipDGrd)
      If (iGrdTyp.eq.2 .and. ipDGrd.ne.ip_Dummy)
     &   Call GetMem('ESPF_DGrid','Free','Real',ipDGrd,3*nGrdPt*3*nAtQM)
*
* Here we must distinguish between an energy run and a gradient run
*
      If (.not.Forces) Then
         Call StatusLine(' espf:',' Computing energy components')
         Call Get_iArray('nBas',nBas,nSym)
         nBas0 = nBas(0)
         nSize = nBas0*(nBas0+1)/2 + 4
         Call Allocate_Work(ipH,nSize)
         iComp = 1
         iSyLbl = 1
         Label = 'OneHam  '
         iRc = -1
         Call iRdOne(iRc,1,Label,iComp,idum,iSyLbl)
         nInts=idum(1)
         If (iRc.ne.0) Then
            Write (6,'(A)')' ESPF: Error reading ONEINT'
            Write (6,'(A,A8)')' Label = ',Label
            Call Abend()
         End If
         If (nInts+4.ne.nSize) Then
            Write (6,'(A,2I5)')' ESPF: nInts+4.ne.nSize',nInts+4,nSize
            Call Abend()
         End If
         iRc = -1
         Call RdOne(iRc,0,Label,iComp,Work(ipH),iSyLbl)
         Call Get_dScalar('PotNuc',RepNuc)
         Call espf_energy(nBas0,natom,nGrdPt,ipExt,ipGrid,ipB,
     &                    Work(ipH),nSize-4,RepNuc,EnergyCl,DoTinker,
     &                    DoGromacs,DynExtPot)
         Call Put_dScalar('PotNuc',RepNuc)
         Call WrOne(iRc,0,Label,iComp,Work(ipH),iSyLbl)
         If (iRC.ne.0) then
            Write (6,*)'ESPF: Error writing to ONEINT'
            Write (6,'(A,A8)')'Label=',Label
            Call Abend()
         End If
         Call Free_Work(ipH)
         If (iPL.ge.3) Write(6,*) 'The 1-e hamiltonian is now updated.'
         If (iPL.ge.2) Write(6,'(A,F16.10)')
     &                 ' Nuclear energy, including Ext Pot = ',RepNuc
      Else
         Call StatusLine(' espf:',' Computing gradient components')
         Call espf_grad(natom,nGrdPt,ipExt,ipGrid,ipB,ipDB,ipIsMM,
     &                  ipGradCl,DoTinker,DoGromacs)
         If (ipMltp.eq.ip_Dummy)
     &      Call GetMem('ESPFMltp','Allo','Real',ipMltp,nMult)
         Call espf_mltp(natom,MltOrd,nMult,nGrdPt,ipTTT,ipMltp,ipGrid,
     &                  ipIsMM,ipExt,iPL)
      End If
      Close_Seward=.True.
*
98    Continue
*
* Save data in the ESPF.DATA file
*
      Call espf_write(MltOrd,iRMax,DeltaR,iGrdTyp,nGrdPt,DoTinker,
     &                DoGromacs,lMorok,ipMltp,nMult,ipIsMM,natom,
     &                Show_espf,Forces,DoDirect)
*
* Exit
*
      isNAC = isNAC_tmp
      If (.not. (StandAlone .and. DynExtPot)) Then
         Call GetMem('DerivB','FREE','REAL',ipDB,nGrdPt*3*nAtQM)
         Call GetMem('CartTensor','FREE','REAL',ipT,iSize1)
         Call GetMem('TT','FREE','REAL',ipTT,iSize2)
         Call GetMem('TTT','FREE','REAL',ipTTT,iSize3)
         Call GetMem('ExtPot*TTT','FREE','REAL',ipB,nGrdPt)
      End If
      If (ipMltp.ne.ip_Dummy)
     &   Call GetMem('ESPFMltp','FREE','REAL',ipMltp,nMult)
      If (ipGrid.ne.ip_Dummy)
     &   Call GetMem('ESPF_Grid','FREE','REAL',ipGrid,3*nGrdPt)
      Call GetMem('AtomCoord','FREE','REAL',ipCord,3*natom)
      Call GetMem('ExtPot','FREE','REAL',ipExt,natom*MxExtPotComp)
      Call GetMem('IsMM for atoms','Free','Inte',ipIsMM,natom)
      If (DoGromacs.and.Forces) Then
         Call GetMem('GradCl','FREE','REAL',ipGradCl,3*natom)
      End If
*
*     Slapaf needs to know that the gradient is NOT translational
*     and rotational invariant.
*
      If (.not.Forces .and. natMM.gt.0) Then
         VarR = .true.
         VarT = .true.
         Call Symmetry_Info_Dmp()
      End If
      If (Close_Seward) Call ClsSew()
*
      iReturn=0
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Union(iU,nU,iV,nV,iR,iM,nM)
      Implicit Real*8 (A-H,O-Z)
      Integer   iU(nU),  iV(nV), iM(8)
      Logical RinT_
*
*        M is formed as U union RU
*
      Call iCopy(nU,iU,1,iM,1) ! copy the first elements
      nM = nU
      Do i = 1, nV
         iRV = iEor(iR,iV(i))
         If (.Not.RinT_(iM,nM,iRV)) Then
            nM = nM + 1
            iM(nM) = iRV
         End If
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine A_3C_Qv_s(A_3C,Qv,Rv,nMuNu,nI,nK,QMode)
!***********************************************************************
!                                                                      *
!     Author:  F. Aquilante                                            *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nMuNu, nI, nK
real(kind=wp), intent(in) :: A_3C(nMuNu,*), Qv(nI,nK)
real(kind=wp), intent(inout) :: Rv(nMuNu,*)
character, intent(in) :: QMode

if (QMode == 'N') then

  call DGEMM_('N','N',nMuNu,nK,nI,One,A_3C,nMuNu,Qv,nI,Zero,Rv,nMuNu)

else if (QMode == 'T') then

  call DGEMM_('N','T',nMuNu,nI,nK,One,A_3C,nMuNu,Qv,nI,One,Rv,nMuNu)  ! note that Rv is accumulated

else

  call WarningMessage(2,'A_3C_Qv_s: illegal QMode!')
  call Abend()
end if

return

end subroutine A_3C_Qv_s

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SORTA(BUFS,INDS,ISAB,BUFBI,BIAC,BICA,NINTGR)
      IMPLICIT REAL*8 (A-H,O-Z)
      External COUNT
#include "SysDef.fh"
#include "warnings.fh"
#include "mrci.fh"
      DIMENSION BUFS(NBITM1,NCHN1)
      DIMENSION INDS(NBITM1+2,NCHN1)
      DIMENSION BUFBI(KBUFF1)
      DIMENSION BIAC(ISMAX),BICA(ISMAX)
      DIMENSION ISAB(*)
C SORTS INTEGRALS (AB/CI)
C FOR FIXED B,I ALL A,C
C FIRST CHAIN FOR IJKL
      DIMENSION NORB0(9)
      CALL COUNT(NINTGR,NSYM,NORB,MUL)
      IF(IPRINT.GE.6) WRITE(6,1234)NINTGR
      CALL XFLUSH(6)
 1234 FORMAT(//6X,'NUMBER OF TWO-ELECTRON INTEGRALS',I10)

      IAD50=0
      CALL iDAFILE(LUTRA,2,iTraToc,nTraToc,IAD50)
      IBOFF1=RTOI*NBITM1
      IBBC1=IBOFF1+NBITM1+1
      IBDA1=IBBC1+1

      IDISK=0
      ICHK=0
      DO 5 IREC=1,NCHN1
*        INDOUT(IBBC1+(IREC-1)*RTOI*NBSIZ1)=0
*        INDOUT(IBDA1+(IREC-1)*RTOI*NBSIZ1)=-1
       INDS(NBITM1+1,IREC)=0
       INDS(NBITM1+2,IREC)=-1
5     CONTINUE
      NORB0(1)=0
      DO 4 I=1,NSYM
        NORB0(I+1)=NORB0(I)+NORB(I)
4     CONTINUE
C
C TWO-ELECTRON INTEGRALS
C
      DO 313 NSP=1,NSYM
       NOP=NORB(NSP)
       DO 312 NSQ=1,NSP
        NSPQ=MUL(NSP,NSQ)
        NOQ=NORB(NSQ)
        DO 311 NSR=1,NSP
         NSPQR=MUL(NSPQ,NSR)
         NOR=NORB(NSR)
         NSSM=NSR
         IF(NSR.EQ.NSP)NSSM=NSQ
         DO 310 NSS=1,NSSM
          IF(NSS.NE.NSPQR)GO TO 310
          NOS=NORB(NSS)
          NORBP=NOP*NOQ*NOR*NOS
          IF(NORBP.EQ.0)GO TO 310
          CALL dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
          IOUT=0
          DO 309 NV=1,NOR
           NXM=NOS
           IF(NSR.EQ.NSS)NXM=NV
           DO 308 NX=1,NXM
            NTM=1
            IF(NSP.EQ.NSR)NTM=NV
            DO 307 NT=NTM,NOP
             NUMIN=1
             IF(NSP.EQ.NSR.AND.NT.EQ.NV)NUMIN=NX
             NUMAX=NOQ
             IF(NSP.EQ.NSQ)NUMAX=NT
             DO 306 NU=NUMIN,NUMAX
              IOUT=IOUT+1
              IF(IOUT.GT.NTIBUF) THEN
                CALL dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
                IOUT=1
              END IF
              FINI=TIBUF(IOUT)
              NI=ICH(NORB0(NSP)+NT)
              IF(NI.LE.0) GOTO 306
              NJ=ICH(NORB0(NSQ)+NU)
              IF(NJ.LE.0) GOTO 306
              NK=ICH(NORB0(NSR)+NV)
              IF(NK.LE.0) GOTO 306
              NL=ICH(NORB0(NSS)+NX)
              IF(NL.LE.0) GOTO 306
C ORDER THESE INDICES CANONICALLY
              IF(NI.LT.NJ) THEN
                M=NI
                NI=NJ
                NJ=M
              END IF
              IF(NK.LT.NL) THEN
                M=NK
                NK=NL
                NL=M
              END IF
              IF(NI.LT.NK) THEN
                M=NK
                NK=NI
                NI=M
                M=NL
                NL=NJ
                NJ=M
              ELSE IF((NI.EQ.NK).AND.(NJ.LT.NL)) THEN
                M=NL
                NL=NJ
                NJ=M
              END IF
              IF(NI.LE.LN)GO TO 109
              IF(NK.LE.LN)GO TO 306
              IF(IFIRST.NE.0)GO TO 306
              IF(NJ.LE.LN)GO TO 42
              IF(NL.GT.LN)GO TO 306
C ABCI
      NA=NI-LN
      NB=NJ-LN
      NC=NK-LN
      NI=NL
      GO TO 108
42    CONTINUE
      IF(NL.LE.LN) GOTO 306
C CIAB
      NA=NK-LN
      NB=NL-LN
      NC=NI-LN
      NI=NJ
108   NIB=(NI-1)*NVIRT+NB+1
*      IPOS=INDOUT(IBBC1+(NIB-1)*RTOI*NBSIZ1)+1
*      INDOUT(IBBC1+(NIB-1)*RTOI*NBSIZ1)=IPOS
      IPOS=INDS(NBITM1+1,NIB)+1
      INDS(NBITM1+1,NIB)=IPOS
*      BUFOUT(IPOS+(NIB-1)*NBSIZ1)=FINI
*      INDOUT(IBOFF1+IPOS+(NIB-1)*RTOI*NBSIZ1)=(NA-1)*NVIRT+NC
      BUFS(IPOS,NIB)=FINI
      INDS(IPOS,NIB)=(NA-1)*NVIRT+NC
      IF(IPOS.GE.NBITM1) THEN
        JDISK=IDISK
*        CALL dDAFILE(Lu_60,1,INDOUT(1+(NIB-1)*RTOI*NBSIZ1),NBSIZ1,IDISK)
        CALL iDAFILE(Lu_60,1,INDS(1,NIB),NBITM1+2,IDISK)
        CALL dDAFILE(Lu_60,1,BUFS(1,NIB),NBITM1,IDISK)
*        INDOUT(IBDA1+(NIB-1)*RTOI*NBSIZ1)=JDISK
*        INDOUT(IBBC1+(NIB-1)*RTOI*NBSIZ1)=0
        INDS(NBITM1+1,NIB)=0
        INDS(NBITM1+2,NIB)=JDISK
      END IF
      IF(NA.EQ.NB)GO TO 306
      NAT=NA
      NA=NB
      NB=NAT
      NIB=(NI-1)*NVIRT+NB+1
*      IPOS=INDOUT(IBBC1+(NIB-1)*RTOI*NBSIZ1)+1
*      INDOUT(IBBC1+(NIB-1)*RTOI*NBSIZ1)=IPOS
      IPOS=INDS(NBITM1+1,NIB)+1
      INDS(NBITM1+1,NIB)=IPOS
*      BUFOUT(IPOS+(NIB-1)*NBSIZ1)=FINI
*      INDOUT(IBOFF1+IPOS+(NIB-1)*RTOI*NBSIZ1)=(NA-1)*NVIRT+NC
      BUFS(IPOS,NIB)=FINI
      INDS(IPOS,NIB)=(NA-1)*NVIRT+NC
      IF(IPOS.GE.NBITM1) THEN
        JDISK=IDISK
*        CALL dDAFILE(Lu_60,1,INDOUT(1+(NIB-1)*RTOI*NBSIZ1),NBSIZ1,IDISK)
        CALL iDAFILE(Lu_60,1,INDS(1,NIB),NBITM1+2,IDISK)
        CALL dDAFILE(Lu_60,1,BUFS(1,NIB),NBITM1,IDISK)
*        INDOUT(IBDA1+(NIB-1)*RTOI*NBSIZ1)=JDISK
*        INDOUT(IBBC1+(NIB-1)*RTOI*NBSIZ1)=0
        INDS(NBITM1+1,NIB)=0
        INDS(NBITM1+2,NIB)=JDISK
      END IF
      GOTO 306
C IJKL
109   IIJ=IROW(NI)+NJ
      KL=IROW(NK)+NL
      IJKL=IIJ*(IIJ-1)/2+KL
      IJ=1
*      IPOS=INDOUT(IBBC1+(IJ-1)*RTOI*NBSIZ1)+1
*      INDOUT(IBBC1+(IJ-1)*RTOI*NBSIZ1)=IPOS
      IPOS=INDS(NBITM1+1,IJ)+1
      INDS(NBITM1+1,IJ)=IPOS
*      BUFOUT(IPOS+(IJ-1)*NBSIZ1)=FINI
*      INDOUT(IBOFF1+IPOS+(IJ-1)*RTOI*NBSIZ1)=IJKL
      BUFS(IPOS,IJ)=FINI
      INDS(IPOS,IJ)=IJKL
      IF(IPOS.EQ.NBITM1) THEN
        JDISK=IDISK
*        CALL dDAFILE(Lu_60,1,INDOUT(1+(IJ-1)*RTOI*NBSIZ1),NBSIZ1,IDISK)
        CALL iDAFILE(Lu_60,1,INDS(1,IJ),NBITM1+2,IDISK)
        CALL dDAFILE(Lu_60,1,BUFS(1,IJ),NBITM1,IDISK)
*        INDOUT(IBDA1+(IJ-1)*RTOI*NBSIZ1)=JDISK
*        INDOUT(IBBC1+(IJ-1)*RTOI*NBSIZ1)=0
        INDS(NBITM1+1,IJ)=0
        INDS(NBITM1+2,IJ)=JDISK
      END IF
306          CONTINUE
307         CONTINUE
308        CONTINUE
309       CONTINUE
310      CONTINUE
311     CONTINUE
312    CONTINUE
313   CONTINUE
C EMPTY LAST BUFFERS
      If ( NChn1.gt.mChain ) then
        WRITE(6,*)'SORTA Error: NCHN1 > MCHAIN (See code).'
        CALL QUIT(_RC_GENERAL_ERROR_)
      End If
      DO 150 I=1,NCHN1
        JDISK=IDISK
*        CALL dDAFILE(Lu_60,1,INDOUT(1+(I-1)*RTOI*NBSIZ1),NBSIZ1,IDISK)
        CALL iDAFILE(Lu_60,1,INDS(1,I),NBITM1+2,IDISK)
        CALL dDAFILE(Lu_60,1,BUFS(1,I),NBITM1,IDISK)
        LASTAD(I)=JDISK
150   CONTINUE
C IJKL
      IDISK=0
      IBUFIJ=0
      ISRTAD=-1
      IADR=LASTAD(1)
201   CONTINUE
*      CALL dDAFILE(Lu_60,2,INDOUT,NBSIZ1,IADR)
      CALL iDAFILE(Lu_60,2,INDS,NBITM1+2,IADR)
      CALL dDAFILE(Lu_60,2,BUFS,NBITM1,IADR)
*      LENGTH=INDOUT(IBBC1)
*      IADR=INDOUT(IBDA1)
      LENGTH=INDS(NBITM1+1,1)
      IADR=INDS(NBITM1+2,1)
      DO 202 I=1,LENGTH
        IBUFIJ=IBUFIJ+1
*        VALSRT(IBUFIJ)=BUFOUT(I)
*        INDSRT(IBUFIJ)=INDOUT(IBOFF1+I)
        VALSRT(IBUFIJ)=BUFS(I,1)
        INDSRT(IBUFIJ)=INDS(I,1)
        IF(IBUFIJ.LT.NSRTMX)GO TO 202
        NSRTCN=NSRTMX
        JDISK=IDISK
*
        INDSRT(NSRTMX+1)=NSRTCN
        INDSRT(NSRTMX+2)=ISRTAD
        CALL dDAFILE(Lu_70,1,VALSRT,NSRTMX,IDISK)
        CALL iDAFILE(Lu_70,1,INDSRT,NSRTMX+2,IDISK)
*
        ISRTAD=JDISK
        IBUFIJ=0
202   CONTINUE
      IF(IADR.NE.-1) GO TO 201
C EMPTY LAST BUFFER
      NSRTCN=IBUFIJ
      JDISK=IDISK
*
      INDSRT(NSRTMX+1)=NSRTCN
      INDSRT(NSRTMX+2)=ISRTAD
      CALL dDAFILE(Lu_70,1,VALSRT,NSRTMX,IDISK)
      CALL iDAFILE(Lu_70,1,INDSRT,NSRTMX+2,IDISK)
*
      LASTAD(1)=JDISK
C ABCI
      IAD15=IDISK
      IADABCI=IAD15
      INSOUT=0
      IADD10=IAD10(4)
      CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IN=2
      NSAVE=ICOP1(IN)
100   NI=NSAVE
      IOUT=0
110   IN=IN+1
      IF(IN.GT.LEN) THEN
        CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
        CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
        LEN=ICOP1(nCOP+1)
        IF(LEN.LE.0)GO TO 6
        IN=1
      END IF
      IF(ICHK.NE.0)GO TO 460
      IF(ICOP1(IN).EQ.0) THEN
        ICHK=1
      ELSE
        IOUT=IOUT+1
      END IF
      GO TO 110
460   ICHK=0
      NSAVE=ICOP1(IN)
6     CONTINUE
      NIB=1+(NI-1)*NVIRT
C LOOP OVER VIRTUAL ORBITAL INDEX B:
      DO 20 NB=1,NVIRT
        NSIB=MUL(NSM(LN+NB),NSM(NI))
        INS=NVPAIR(NSIB)
        IF(INS.NE.0) THEN
          CALL FZERO(BIAC,INS)
          CALL FZERO(BICA,INS)
        END IF
        NIB=NIB+1
C READ & PROCESS INTEGRAL BUFFERS ON UNIT 14:
        IADR=LASTAD(NIB)
203     CONTINUE
*        CALL dDAFILE(Lu_60,2,INDOUT,NBSIZ1,IADR)
        CALL iDAFILE(Lu_60,2,INDS,NBITM1+2,IADR)
        CALL dDAFILE(Lu_60,2,BUFS,NBITM1,IADR)
*        LENGTH=INDOUT(IBBC1)
*        IADR=INDOUT(IBDA1)
        LENGTH=INDS(NBITM1+1,1)
        IADR=INDS(NBITM1+2,1)
        DO 204 KK=1,LENGTH
*          INND=INDOUT(IBOFF1+KK)
          INND=INDS(KK,1)
          NA=(INND-1)/NVIRT+1
          NC=INND-(NA-1)*NVIRT
          IACS=ISAB(NA+(NC-1)*NVIRT)
*          BIAC(IACS)=BIAC(IACS)+BUFOUT(KK)
          BIAC(IACS)=BIAC(IACS)+BUFS(KK,1)
*          IF(NA.GT.NC)BICA(IACS)=BICA(IACS)-BUFOUT(KK)
*          IF(NA.LT.NC)BICA(IACS)=BICA(IACS)+BUFOUT(KK)
          IF(NA.GT.NC)BICA(IACS)=BICA(IACS)-BUFS(KK,1)
          IF(NA.LT.NC)BICA(IACS)=BICA(IACS)+BUFS(KK,1)
204     CONTINUE
        IF(IADR.NE.-1) GO TO 203
        DO 72 ILOOP=0,1
        INSB=INS
73      INB=KBUFF1-INSOUT
        INUMB=INSB
        IF(INSB.GT.INB)INUMB=INB
        IST=INS-INSB+1
        IF(ILOOP.EQ.0)CALL DCOPY_(INUMB,BIAC(IST),1,BUFBI(INSOUT+1),1)
        IF(ILOOP.EQ.1)CALL DCOPY_(INUMB,BICA(IST),1,BUFBI(INSOUT+1),1)
        INSOUT=INSOUT+INUMB
        IF(INSOUT.GT.KBUFF1) THEN
          WRITE(6,*) 'SortA: INSOUT.GT.KBUFF1'
          WRITE(6,*) 'INSOUT=',INSOUT
          WRITE(6,*) 'KBUFF1=',KBUFF1
          CALL ABEND
        END IF
        IF(INSOUT.EQ.KBUFF1) THEN
          CALL dDAFILE(Lu_70,1,BUFBI,KBUFF1,IAD15)
          INSOUT=0
        END IF
        INSB=INSB-INUMB
        IF(INSB.GT.0)GO TO 73
72      CONTINUE
20    CONTINUE
      IF(LEN.GE.0)GO TO 100
C EMPTY LAST BUFFER IF NOT EMPTY
      IF(INSOUT.GT.0) CALL dDAFILE(Lu_70,1,BUFBI,KBUFF1,IAD15)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Jeppe Olsen                                      *
*               1989, Markus P. Fuelscher                              *
*               Giovanni Li Manni                                      *
************************************************************************
      SUBROUTINE DiagOrd(PHPCSF,PHPCNF,IPORDCSF,IPORDCNF,MXPDIM,
     *                  condition,iter,
     *                  DTOC,IPRODT,ICONF,
     *                  IREFSM,ONEBOD,ECORE,NACTOB,
     *                  SCR,NCONF,NEL,NAEL,NBEL,
     *                  TUVX,NTEST,ExFac,IREOTS)

C     Obtain primary subspace and obtain
C     explicit representation of hamilton matrix in subspace
C
C     ARGUMENTS :
C     ===========
C     PHPCSF     : Diagonal hamilton matrix elements in CSF (output)
C     PHPCNF     : Diagonal hamilton matrix elements in CNF (output)
C     IPORDCSF: index array containing energetic order in CSF (output)
C     IPORDCNF: index array containing energetic order in CNF (output)
C     IPCSF   : CSF's defining subspace (input)
C     IPCNF   : Configurations defining subspace (input)
C     MXPDIM  : Largest allowed dimension of subspace (Input)
C     DTOC    : Transformation matrix between CSF's and DET's (input)
C     IPRODT  : Prototype determinants (input)
C     ICONF   : List of configurations  (input)
C     IREFSM  : symmetry of considered CI space (input)
C     Onebod  : one body hamilton matrix in rectangular form (input)
C     ECORE   : Core energy (input)
C     NACTOB  : Number of active orbitals (input)
C     SCR     : Scratch array of length ????
C     NCONF   : Number of configurations of symmetry IREFSM
C     NPCNF   : = NCONF
C     NPCSF   : = MXPDIM
C     TUVX    : Two-electron integrals (MO space)
*
*     IREOTS : Type => symmetry reordering array
C

************ Author: GLMJ ****************
*   history:
C     Jeppe Olsen , Summer of '89
C     adapted to DETRAS by M.P. Fuelscher, Oktober 1989
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "spinfo.fh"
#include "splitcas.fh"
C
      DIMENSION PHPCSF(*),PHPCNF(*)
C      DIMENSION IPCSF(*),IPCNF(*)
      DIMENSION IPORDCSF(*),IPORDCNF(*)
      DIMENSION DTOC(*),IPRODT(*),ICONF(*)
      DIMENSION ONEBOD(*),SCR(*)
      DIMENSION TUVX(*), IREOTS(*)

      CALL DIAGORD_INTERNAL(SCR)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE DIAGORD_INTERNAL(SCR)
      USE ISO_C_BINDING
      REAL*8, TARGET :: SCR(*)
      INTEGER, POINTER :: iSCR(:)
      ICSFMN = 0 ! dummy initialize to avoid warning

* construct the diagonal array out of the Hamiltonian matrix

      MXCSFC = 0
      DO ITYP = 1, NTYP
        MXCSFC = MAX(MXCSFC,NCSFTP(ITYP))
      END DO
*
      KLFREE = 1
      KLCONF = KLFREE
      KLFREE = KLFREE+NEL
      KRCONF = KLFREE
      KLFREE = KLFREE+NEL
      KLPHPS = KLFREE
      KLFREE = KLFREE+MXCSFC*MXCSFC
      KLSCRS = KLFREE
      KLFREE = KLFREE+MXCSFC
      KLCSFO = KLFREE
      KLFREE = KLFREE+MXPDIM
      KLCNFO = KLFREE
      KLFREE = KLFREE+NCONF
*
      IILB = 1
      DO ICNL = 1, NCONF
*       write(*,*) 'IILB', IILB
        CALL C_F_POINTER(C_LOC(SCR(KLCONF)),iSCR,[1])
        CALL GETCNF_LUCIA(iSCR,ILTYP,ICNL,ICONF,IREFSM,
     &                    NEL)
        NULLIFY(iSCR)
*        CALL GETCNF_LUCIA(SCR(KLCONF),ILTYP,IPCNF(ICNL),ICONF,IREFSM,
*     &                    NEL)
        NCSFL = NCSFTP(ILTYP)
*       write(*,*)'NCSFL = ', NCSFL
*       call xflush(6)
        CALL C_F_POINTER(C_LOC(SCR(KLCONF)),iSCR,[1])
        CALL CNHCN(iSCR,ILTYP,iSCR,ILTYP,SCR(KLPHPS),
     &             SCR(KLFREE),NAEL,NBEL,ECORE,
     &             ONEBOD,IPRODT,DTOC,NACTOB,TUVX,NTEST,ExFac,IREOTS)
        NULLIFY(iSCR)
        DO IIL = 1, NCSFL
          IILACT = IILB-1+IIL
          ILRI = IIL*IIL
          PHPCSF(IILACT) = SCR(KLPHPS-1+ILRI)
*          write(*,*) 'IILACT, ILRI = ',IILACT, ILRI
*          write(*,*)'PHPCSF(IILACT)', PHPCSF(IILACT)
*          call xflush(6)
          SCR(KLSCRS-1+IIL)= SCR(KLPHPS-1+ILRI)
        END DO
        XMAX = -FNDMNX(SCR(KLSCRS),NCSFL,2)
        PHPCNF(ICNL)= XMAX
*        write(*,*)'PHPCNF(IILACT)', PHPCNF(ICNL)
*          call xflush(6)
        IILB = IILB + NCSFL
      END DO
************************ ORDERING ***************************
      Acc = 1.0d-13
      XMAX = FNDMNX(PHPCNF,NCONF,2)
      RefSplit = -XMAX
      NPCSF = 0
      NPCNF = 0
* To avoid warnings:
        iTmpDimBlockACNF = 0
        iTmpDimBlockA    = 0

C      IFINIT = 0
400   CONTINUE
      XMIN = XMAX + 1.0D0
      IMIN = 0
      IICNF = 1
      IICSF = 1
      DO ITYP = 1, NTYP
        NJCNF = NCNFTP(ITYP,IREFSM)
        NIRREP = NCSFTP(ITYP)
        DO ICNF = 1,NJCNF
          IF( PHPCNF(IICNF)+Acc.LT.XMIN ) THEN
            XMIN = PHPCNF(IICNF)
            IMIN = IICNF
*            write(*,*)'IMIN         :', IMIN
            ICSFMN = IICSF
            NCSFMN = NIRREP
          END IF
          IICNF = IICNF + 1
          IICSF = IICSF + NIRREP
        END DO
      END DO
*      write(*,*)'XMIN         :', XMIN
*      write(*,*)'NPCSF+NCSFMN :', NPCSF+NCSFMN
C      IF( (NPCSF+NCSFMN).LE. MXPDIM ) THEN
        SCR(KLCNFO+NPCNF) = PHPCNF(IMIN)
        NPCNF = NPCNF + 1
        IPORDCNF(NPCNF) = IMIN
*        write(*,*)'NPCNF, IPORDCNF(NPCNF) :', NPCNF,IPORDCNF(NPCNF)
        CALL ISTVC2(IPORDCSF(NPCSF+1),ICSFMN-1,1,NCSFMN)
*        write(*,*) 'IPORDCSF(NPCSF) :',(IPORDCSF(NPCSF+i),i=1,NCSFMN)
*        call IVCPRT('IPORDCSF(NPCSF) :',' ', IPORDCSF(NPCSF+1),NCSFMN)
        NPCSF = NPCSF + NCSFMN

        if (iter.eq.1) then
         if (EnerSplit) then
           if ((PHPCNF(IMIN)-RefSplit).le.condition) then
             iDimBlockACNF = NPCNF
             iDimBlockA = NPCSF
           end if
         else if ( PerSplit ) then
           if ((REAL(NPCSF)/REAL(MXPDIM))*1.0d2.le.condition+Acc) then
             iDimBlockACNF = NPCNF
             iDimBlockA = NPCSF
           end if
         end if
        else
           if (NPCNF.le.iDimBlockACNF) then
             iTmpDimBlockACNF = NPCNF
             iTmpDimBlockA = NPCSF
           end if
        end if

        PHPCNF(IMIN) = XMAX + 1.0D0
        IF( (NPCNF.LT.NCONF) ) GOTO 400

        if (iter.ne.1) then
          iDimBlockACNF = iTmpDimBlockACNF
          iDimBlockA = iTmpDimBlockA
*          write(6,*) 'iDimBlockACNF, iDimBlockACSF',
*     &              iDimBlockACNF,iDimBlockA
        end if
C      ELSE
*       No space for this configuration , remove previous
*       configurations with the same diagonal value
C        IFINIT = 1
C        IICNF = NPCNF+1
C  600     CONTINUE
C        IICNF = IICNF - 1
C        DIAVAL = PHPCNF(IPORDCNF(IICNF))
C        IF( ABS(DIAVAL-XMIN).LE.1.0D-10) THEN
C          NPCNF = NPCNF -1
C          CALL GETCNF_LUCIA(SCR(KLFREE),ITYP,IPCNF(IICNF),
C     &                ICONF,IREFSM,NEL)
*          CALL GETCNF_LUCIA(PHPCNF(NCONF+1),ITYP,IPCNF(IICNF),
*     &                ICONF,IREFSM,NEL)
C          NPCSF = NPCSF - NCSFTP(ITYP)
C          GOTO 600
C        END IF
C      END IF
C      IF( (IFINIT.EQ.0) .AND. (NPCNF.LT.NCONF) ) GOTO 400

      do i=0,MXPDIM-1
        SCR(KLCSFO+i) = PHPCSF(IPORDCSF(i+1))
      end do

      call dcopy_(NCONF, SCR(KLCNFO),1,PHPCNF,1)
      call dcopy_(MXPDIM,SCR(KLCSFO),1,PHPCSF,1)

C        WRITE(6,*) ' OUTPUT from DiagOrd '
C        WRITE(6,*) ' ================== '
C        WRITE(6,*)
C     &  ' Number of Configurations in primary subspace ',NCONF
C        WRITE(6,*)
C     &  ' Number of CSFs in primary subspace ',MXPDIM
C        WRITE(6,*) ' Configurations included : '
C        CALL IWRTMA(IPORDCNF,1,NCONF,1,NCONF)
C        WRITE(6,*) ' CSFs included : '
C        CALL IWRTMA(IPORDCSF,1,MXPDIM,1,MXPDIM)
C        write(6,*) 'Ordered Diagonal array in CSF basis :'
C        do i = 1, MXPDIM
*          write(6,*) PHPCSF(IPORDCSF(i))
C          write(6,*) PHPCSF(i)
C        end do
C        write(6,*) 'Ordered Diagonal array in CNF basis :'
C        do i = 1, NCONF
C          write(6,*) PHPCNF(i)
C        end do

      RETURN
      END SUBROUTINE DIAGORD_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine setmocom_cvb()

use casvb_global, only: iact_mo, nact_mo, nbas_mo, nbasf_mo, nbasi_mo, nbasisq_mo, nbassqf_mo, nbassqi_mo, nsym_mo
use jobiph_j, only: nash_j, nbas_j, nfro_j, nish_j, nsym_j
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i, ii, j
logical(kind=iwp), parameter :: debug = .false.

nsym_mo = nsym_j
nbasi_mo(:) = nbas_j(:)

nbas_mo = 0
nbasisq_mo = 0
do i=1,8
  nbassqi_mo(i) = nbasi_mo(i)*nbasi_mo(i)
  nbasf_mo(i) = nbas_mo
  nbassqf_mo(i) = nbasisq_mo
  nbas_mo = nbas_mo+nbasi_mo(i)
  nbasisq_mo = nbasisq_mo+nbassqi_mo(i)
end do

nact_mo = 0
do i=1,8
  do j=1,nash_j(i)
    nact_mo = nact_mo+1
    iact_mo(nact_mo) = nbasf_mo(i)+nfro_j(i)+nish_j(i)+j
  end do
end do

if (debug) then
  write(u6,*) ' MO interface'
  write(u6,*) ' ------------'
  write(u6,*) ' nsym    :',nsym_mo
  write(u6,*) ' nbas    :',nbas_mo
  write(u6,*) ' nbasisq :',nbasisq_mo
  write(u6,*) ' nbasi   :',nbasi_mo
  write(u6,*) ' nbassqi :',nbassqi_mo
  write(u6,*) ' nbasf   :',nbasf_mo
  write(u6,*) ' nbassqf :',nbassqf_mo
  write(u6,*) ' nact    :',nact_mo
  write(u6,*) ' iact    :',(iact_mo(ii),ii=1,nact_mo)
end if

return

end subroutine setmocom_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ZSTINF_GAS()
! Set up common block /STINF/ from information in /STINP/
!
!=========
! Input
!=========
! Information in /CGAS/ and /GASSTR/
!
!======================
! Output (in /STINF/)
!====================
! ISTAC (MXPSTT,2) : string type obtained by creating (ISTAC(ITYP,2))
!                    or annihilating (ISTAC(ITYP,1)) an electron
!                    from a string of type  ITYP . A zero indicates
!                    that this mapping is not included
!                    Only strings belonging to the same
!                    Orbital group are mapped
!                    mapped
! Input
! Only the first element, i.e. ISTAC  is defined

use lucia_data, only: IBGPSTR, ISTAC, NGAS, NGPSTR
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use lucia_data, only: MXPSTT, NGRP
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IGAS, IGRP, IIGRP, MGRP

! *****************************************************************
! Mappings between strings with the same type ISTTP index, +/- 1 el
! *****************************************************************
ISTAC(:,:) = 0
do IGAS=1,NGAS
  ! groups for a given gas spaces goes with increasing number of orbitals,
  ! so the first space does not have any creation mapping
  ! and the last space does not have any annihilation mapping

  MGRP = NGPSTR(IGAS)
  do IGRP=1,MGRP
    IIGRP = IGRP+IBGPSTR(IGAS)-1
    ! Annihilation map is present : IIGRP => IIGRP - 1
    if (IGRP /= 1) ISTAC(IIGRP,1) = IIGRP-1
    ! Creation map is present : IIGRP => IIGRP + 1
    if (IGRP /= MGRP) ISTAC(IIGRP,2) = IIGRP+1
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Type - type mapping array ISTAC'
write(u6,*) ' ==============================='
call IWRTMA(ISTAC,NGRP,2,MXPSTT,2)
#endif

end subroutine ZSTINF_GAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExtT1(H,T1,dima,adda)
! this routine does:
! Extract H(a',i) <- T1(a,i) for given aGrp
!
! parameter description:
! H    - Output file (O)
! T1   - T1 amplitudes (I)
! dima - dimension of given Group (I)
! adda - shift of a' in full a set (I)
!
! N.B. Kvajt odflaknute

use chcc_global, only: no, nv
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, adda
real(kind=wp), intent(out) :: H(dima,no)
real(kind=wp), intent(in) :: T1(nv,no)

H(:,:) = T1(adda+1:adda+dima,:)

return

end subroutine ExtT1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,1998, Jeppe Olsen                                 *
*               2017, Roland Lindh                                     *
************************************************************************
      SUBROUTINE NATORB_LUCIA(   RHO1,  NSMOB, NTOPSM, NACPSM, NINPSM,
     &                          ISTOB,   XNAT, RHO1SM, OCCNUM,  NACOB,
     &                            SCR, IPRDEN)
*
* Obtain natural orbitals in symmetry blocks
*
* Jeppe Olsen, June 1994
*              Modification, Oct 94
*              Last modification, Feb. 1998 (reorder deg eigenvalues)
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION RHO1(NACOB,NACOB)
      DIMENSION ISTOB(*)
      DIMENSION NTOPSM(NSMOB), NACPSM(NSMOB),NINPSM(NSMOB)
*. Output
      DIMENSION RHO1SM(*),OCCNUM(*),XNAT(*)
*. Scratch ( Largest symmetry block )
      DIMENSION SCR(*)
*
      NTESTL = 0000
      NTEST = MAX(NTESTL,IPRDEN)
*. To get rid of annoying and incorrect compiler warnings
      IOBOFF = 0
      IMTOFF = 0
*. IOBOFF : Offset for active orbitals in symmetry order
      DO ISMOB = 1, NSMOB
        LOB = NACPSM(ISMOB)
        IF(ISMOB.EQ.1) THEN
          IOBOFF = NINPSM(1)+1
          IMTOFF = 1
        ELSE
          IOBOFF =
     &    IOBOFF + NTOPSM(ISMOB-1)-NINPSM(ISMOB-1)+NINPSM(ISMOB)
          IMTOFF = IMTOFF + NACPSM(ISMOB-1)**2
        END IF
        LOB = NACPSM(ISMOB)
*
*. Extract symmetry block of density matrix
*
        DO IOB = IOBOFF,IOBOFF + LOB-1
           DO JOB = IOBOFF,IOBOFF + LOB-1
*. Corresponding type indices
             IOBP = ISTOB(IOB)
             JOBP = ISTOB(JOB)
             RHO1SM(IMTOFF-1+(JOB-IOBOFF)*LOB+IOB-IOBOFF+1)
     &     = RHO1(IOBP,JOBP)
           END DO
        END DO
*
        IF(NTEST.GE.2 ) THEN
          WRITE(6,*)
          WRITE(6,*) ' Density matrix for symmetry  = ', ISMOB
          WRITE(6,*) ' ======================================='
          WRITE(6,*)
          CALL WRTMAT(RHO1SM(IMTOFF),LOB,LOB,LOB,LOB)
        END IF
*. Pack and diagonalize
C      TRIPAK(AUTPAK,APAK,IWAY,MATDIM,NDIM)
        CALL TRIPAK(RHO1SM(IMTOFF),SCR,1,LOB,LOB)
        ONEM = -1.0D0
*. scale with -1 to get highest occupation numbers as first eigenvectors
        CALL SCALVE(SCR,ONEM,LOB*(LOB+1)/2)
        Call DCopy_(LOB**2,[0.0D0],0,XNAT(IMTOFF),1)
        Call DCopy_(LOB,[1.0D0],0,XNAT(IMTOFF),1+LOB)
        Call NIDiag(SCR,XNAT(IMTOFF),LOB,LOB)
        Call JACORD(SCR,XNAT(IMTOFF),LOB,LOB)
*
        DO  I = 1, LOB
          OCCNUM(IOBOFF-1+I) = - SCR(I*(I+1)/2)
        END DO
*. Order the degenerate eigenvalues so diagonal terms are maximized
        TESTY = 1.0D-11
        DO IOB = 2, LOB
          IF(ABS(OCCNUM(IOBOFF-1+IOB)-OCCNUM(IOBOFF-2+IOB))
     &       .LE.TESTY) THEN
            XII   = ABS(XNAT(IMTOFF-1+(IOB-1)  *LOB+IOB  ))
            XI1I1 = ABS(XNAT(IMTOFF-1+(IOB-1-1)*LOB+IOB-1))
            XII1  = ABS(XNAT(IMTOFF-1+(IOB-1-1)*LOB+IOB  ))
            XI1I  = ABS(XNAT(IMTOFF-1+(IOB-1)  *LOB+IOB-1))
*
            IF( XI1I.GT.XII.AND.XII1.GT.XI1I1 ) THEN
*. interchange orbital IOB and IOB -1
              CALL SWAPVE(XNAT(IMTOFF+(IOB-1)*LOB),
     &                    XNAT(IMTOFF+(IOB-1-1)*LOB),LOB)
              SS = OCCNUM(IOBOFF-1+IOB-1)
              OCCNUM(IOBOFF-1+IOB-1) = OCCNUM(IOBOFF-1+IOB)
              OCCNUM(IOBOFF-1+IOB)   = SS
              IF (NTEST .GE. 1)
     &           write(6,*) ' Orbitals interchanged ',
     &                      IOBOFF-1+IOB,IOBOFF-2+IOB
            END IF
          END IF
        END DO
*
        IF(NTEST.GE.1) THEN
          WRITE(6,*)
          WRITE(6,*)
     &    ' Natural occupation numbers for symmetry = ', ISMOB
          WRITE(6,*)
     &    ' ==================================================='
          WRITE(6,*)
          CALL WRTMAT(OCCNUM(IOBOFF),1,LOB,1,LOB)
          IF(NTEST.GE.2 ) THEN
            WRITE(6,*)
            WRITE(6,*) ' Corresponding Eigenvectors '
            WRITE(6,*)
            CALL WRTMAT(XNAT(IMTOFF),LOB,LOB,LOB,LOB)
          END IF
        END IF
      END DO
*. ( End of loop over orbital symmetries )
*
      RETURN
      END
*
CADDE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               1996, Martin Schuetz                                   *
!               2017, Roland Lindh                                     *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

!#define _DEBUGPRINT_
subroutine TraClc_i(iterLw,nD)
!***********************************************************************
!                                                                      *
! purpose: compute traces                                              *
!                                                                      *
! input:                                                               *
!   Dens    : a few last density matrix differences (nDT,NumDT)        *
!   TwoHam  : a few last two-electron hamiltonians (nDT,NumDT)         *
!   OneHam  : one-electron hamiltonian of length nDT                   *
!   iterLw  : lowest iteration count ...                               *
!             traces are computed from iterLw...iter                   *
!                                                                      *
! output:                                                              *
!   TrDh    : Traces of dD(i)*h of size (nTr)                          *
!   TrDP    : Traces of dD(i)*dP(j) of size (nTr,nTr)                  *
!   TrDD    : Traces of dD(i)*dD(j) of size (nTr,nTr)                  *
!                                                                      *
! called from: OptClc                                                  *
!                                                                      *
! calls to: RWDTG                                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Written by:                                                          *
! P.O. Widmark, M.P. Fuelscher and P. Borowski                         *
! University of Lund, Sweden, 1992                                     *
! modified by M. Schuetz, 1996                                         *
! - traces are recomputed for all iterations between iterLw & iter     *
!                                                                      *
!***********************************************************************

use InfSCF, only: Dens, iDisk, iDKeep, Iter, MapDns, nBT, OneHam, TrDD, TrDh, TrDP, TwoHam, Vxc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IterLw, nD
integer(kind=iwp) :: i, iD, ii, iPos, iPosL
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iC, iR
#endif
real(kind=wp), allocatable, target :: Aux1(:,:), Aux2(:,:), Aux3(:,:)
real(kind=wp), pointer :: pDens(:,:), pTwoHam(:,:), pVxc(:,:)
real(kind=wp), external :: DDot_

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

if (iDKeep < 0) return

!----------------------------------------------------------------------*
!                                                                      *
! Expand the DFT contribution around the reference density             *
! i.e. the last density.                                               *
!                                                                      *
! Note that for ii larger than 1 that the stored density is the        *
! density difference between the two last iterations.                  *
!                                                                      *
!----------------------------------------------------------------------*

! Loop over densities to interpolate over

do ii=iterLw,iter
  !                                                                    *
  !--------------------------------------------------------------------*
  !                                                                    *
  ! Get the one-particle density_ii
  !                                                                    *
  !--------------------------------------------------------------------*
  !                                                                    *
  ! Get pointer to the density

  iPosL = MapDns(ii)

  if (iPosL <= 0) then

    ! If not in memory pick up from disk

    call mma_allocate(Aux1,nBT,nD,Label='Aux1',safe='*')

    ! Pick up the density matrix and external potential

    call RWDTG(-iPosL,Aux1,nBT*nD,'R','DENS  ',iDisk,size(iDisk,1))
    pDens => Aux1
  else
    pDens => Dens(1:nBT,1:nD,iPosL)
  end if

  do iD=1,nD

    ! Trace the one-electron density with the one-electron Hamiltonian.

    TrDh(ii,ii,iD) = DDot_(nBT,pDens(:,iD),1,OneHam,1)

  end do ! iD

  nullify(pDens)
  !                                                                    *
  !--------------------------------------------------------------------*
  !                                                                    *
end do ! ii
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *

#ifdef _DEBUGPRINT_
do iD=1,nD
  write(u6,'(a)') 'traclc: TrDh'
  write(u6,'(6f16.8)') (TrDh(ii,ii,iD),ii=1,iter)
end do
#endif
call mma_deallocate(Aux1,safe='*')
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
do ii=iterLw,iter

  iPosL = MapDns(ii)
  do iD=1,nD

    ! Trace the two-electron contribution of the Fock matrix with
    ! the density. Diagonal terms.

    if (iPosL > 0) then
      TrDP(ii,ii,iD) = DDot_(nBT,Dens(1,iD,iPosL),1,TwoHam(1,iD,iPosL),1)+DDot_(nBT,Dens(1,iD,iPosL),1,Vxc(1,iD,iPosL),1)
      TrDD(ii,ii,iD) = DDot_(nBT,Dens(1,iD,iPosL),1,Dens(1,iD,iPosL),1)
    else
      write(u6,'(a)') 'traclc: should not happen!!!'
      TrDP(ii,ii,iD) = Zero
      call Abend()
    end if
  end do ! iD

  do i=1,ii-1

    ! Get pointer to density

    iPos = MapDns(i)
    if (iPos <= 0) then
      if (.not. allocated(Aux1)) then
        call mma_allocate(Aux1,nBT,nD,Label='Aux1')
        call mma_allocate(Aux2,nBT,nD,Label='Aux2')
        call mma_allocate(Aux3,nBT,nD,Label='Aux3')
      end if
      call RWDTG(-iPos,Aux1,nBT*nD,'R','TWOHAM',iDisk,size(iDisk,1))
      call RWDTG(-iPos,Aux2,nBT*nD,'R','dVxcdR',iDisk,size(iDisk,1))
      call RWDTG(-iPos,Aux3,nBT*nD,'R','DENS  ',iDisk,size(iDisk,1))
      pTwoHam => Aux1
      pVxc => Aux2
      pDens => Aux3
    else
      pTwoHam => TwoHam(1:nBT,1:nD,iPos)
      pVxc => Vxc(1:nBT,1:nD,iPos)
      pDens => Dens(1:nBT,1:nD,iPos)
    end if

    do iD=1,nD
      TrDP(i,ii,iD) = DDot_(nBT,Dens(1,iD,iPosL),1,pTwoHam(:,iD),1)
      TrDP(ii,i,iD) = TrDP(i,ii,iD)
      TrDP(i,ii,iD) = TrDP(i,ii,iD)+DDot_(nBT,Dens(1,iD,iPosL),1,pVxc(:,iD),1)
      TrDP(ii,i,iD) = TrDP(ii,i,iD)+DDot_(nBT,Vxc(1,iD,iPosL),1,pDens(:,iD),1)
      TrDD(i,ii,iD) = DDot_(nBT,Dens(1,iD,iPosl),1,pDens(:,iD),1)
      TrDD(ii,i,iD) = TrDD(i,ii,iD)

    end do ! iD

#   ifdef _DEBUGPRINT_
    do iD=1,nD
      write(u6,*) 'iteration:',ii
      write(u6,'(a)') 'traclc: TrDh'
      do iR=1,ii
        write(u6,'(6f16.8)') TrDh(iR,iR,iD)
      end do
      write(u6,'(a)') 'traclc: TrDP'
      do iR=1,ii
        write(u6,'(6f16.8)') (TrDP(iR,iC,iD),iC=1,ii)
      end do
      write(u6,'(a)') 'traclc: TrDD'
      do iR=1,ii
        write(u6,'(6f16.8)') (TrDD(iR,iC,iD),iC=1,ii)
      end do
    end do ! iD
#   endif
    nullify(pTwoHam,pVxc,pDens)

  end do ! i

end do ! ii

if (allocated(Aux1)) then
  call mma_deallocate(Aux1)
  call mma_deallocate(Aux2)
  call mma_deallocate(Aux3)
end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*
return

#undef _DEBUGPRINT_
end subroutine TraClc_i

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Thomas J. Duignan                                *
!               2021, Rulin Feng                                       *
!***********************************************************************

subroutine repmat(idbg,bInt,sInt,donorm)

use Basis_Info, only: dbsc, nBas, nCnttp
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: idbg
real(kind=wp), intent(in) :: bInt(*)
real(kind=wp), intent(_OUT_) :: sInt(*)
logical(kind=iwp), intent(in) :: donorm
#include "Molcas.fh"
#include "itmax.fh"
#include "rinfo.fh"
integer(kind=iwp) :: ip, istart, jp, kp, nAngrMax, nAtomTot, nc, np, nrBasTot
real(kind=wp) :: finish, kpp
logical(kind=iwp) :: New_Center, New_l, New_m, Old_Center, Old_l
integer(kind=iwp), allocatable :: icaddr(:), ihelp(:,:), mcaddr(:), numb(:), numc(:)
real(kind=wp), allocatable :: fin(:,:), mag(:,:), pa(:), scr(:,:), u2c(:,:), u2ct(:,:)
integer(kind=iwp) :: i, ia, iBas, ibasL, ic, icnt, iCnttp, icon, iCont, ilarge, indb, indbL, ipbasL, iPrim, iPrint, ismall, iSym, &
                     j, jbas, jbasL, jcon, jpbasL, jPrim, k, ka, kbias, kc, kcL, la, mp, nSym, numck, numcl
real(kind=wp) :: sum_

! contracted basis, atomic basis functions
!
! symmetry info
!
! lant(i): number of atoms in i:th symmetry bf
! expand the coefficient matrix into symmetry basis set
! auxiliary
! icaddr(i): adresses in coeff for a symmetry adapted function

!do i=1,12640
!  write(67,'(d25.14)') bint(i)
!end do
nSym = nIrrep
iPrint = 0
if ((iprint >= 10) .or. (idbg > 0)) then
  write(idbg,*) ' in repmat',nsym
  write(idbg,*) nSym,(nBas(i),i=0,nsym-1)
  write(idbg,*) nSym,(nrBas(i),i=1,nsym)
end if

nAtomTot = 0
do iCnttp=1,nCnttp
  nAtomTot = nAtomTot+dbsc(iCnttp)%nCntr
end do
nAngrMax = 0
do ia=1,nAtomTot
  nAngrMax = max(nAngrMax,nAngr(ia)+1)
end do
call mma_allocate(ihelp,nAtomTot,nAngrMax,label='ihelp')

! set up pointer

k = 0
ia = 0  ! center index
ka = 0  ! shell index
do iCnttp=1,nCnttp
  do icnt=1,dbsc(iCnttp)%nCntr
    ia = ia+1
    do la=1,nAngr(ia)+1
      ka = ka+1
      ihelp(ia,la) = k
      k = k+nPrimr(ka)*nBasisr(ka)
    end do
  end do
end do
if ((iPrint >= 10) .or. (idbg > 0)) then
  write(idbg,*) ' Help vector'
  ia = 0
  do iCnttp=1,nCnttp
    do icnt=1,dbsc(iCnttp)%nCntr
      ia = ia+1
      write(idbg,'(10i5)') (ihelp(ia,j),j=1,nAngr(ia)+1)
    end do
  end do
end if

nrBasTot = 0
do iSym=1,nSym
  nrBasTot = nrBasTot+nrBas(iSym)
end do
call mma_allocate(icaddr,nrBasTot,label='icaddr')
call mma_allocate(mcaddr,nrBasTot,label='mcaddr')
call mma_allocate(numb,nrBasTot,label='numb')
call mma_allocate(numc,nrBasTot,label='numc')
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over irreps

k = 0
do iSym=1,nSym
  numck = 1
  numcl = 0
  kbias = 0

  ! Loop over basis functions in irrep

  do iCont=1,nrBas(iSym)
    k = k+1
    if (iCont > 1) then
      New_Center = icent(k) /= icent(k-1)
      New_l = lnang(k) /= lnang(k-1)
      New_m = lmag(k) /= lmag(k-1)
      if (New_m) kbias = kbias-numc(k-1)
      if ((New_Center) .or. New_l) kbias = 0
    end if
    kbias = kbias+1
    ka = 0
    ia = 0
    do iCnttp=1,nCnttp
      do iCnt=1,dbsc(iCnttp)%nCntr
        ia = ia+1
        do la=1,nAngr(ia)+1
          ka = ka+1
          Old_Center = icent(k) == ia
          Old_l = lnang(k) == (la-1)
          if (idbg > 0) write(idbg,*) ' at numck',k,ia,icent(k),la-1,lnang(k),ia,New_Center,New_l
          if (Old_Center .and. Old_l) then
            numc(k) = nBasisr(ka)
            numb(k) = nPrimr(ka)
            icaddr(k) = ihelp(ia,la)+(kbias-1)*nPrimr(ka)
            if ((k > 1) .and. (kbias == 1)) numck = numcl+numck
            mcaddr(k) = numck
            numcl = nPrimr(ka)
          end if
        end do  ! la
      end do    ! iCnt
    end do      ! iCnttp
  end do        ! iCont
end do          ! iSym
call mma_deallocate(ihelp)
k = 0
if ((iPrint >= 10) .or. (idbg > 0)) then
  ic = 0
  ip = 0
  do iSym=1,nSym
    write(idbg,*) ' symmetry',iSym
    write(idbg,*) ' numb'
    write(idbg,'(20i4)') (numb(i+ic),i=1,nrBas(iSym))
    write(idbg,*) ' numc'
    write(idbg,'(20i4)') (numc(i+ic),i=1,nrBas(iSym))
    write(idbg,*) ' Pointer to contraction vector'
    write(idbg,'(20i4)') (icaddr(i+ic),i=1,nrBas(iSym))
    write(idbg,*) ' mcaddr'
    write(idbg,'(20i4)') (mcaddr(i+ic),i=1,nrBas(iSym))
    ic = ic+nrBas(iSym)
    ip = ip+nBas(iSym-1)
  end do
end if
! debugdebug
!write(u6,*) (rCof(i),i=1,4)
! debugdebug

! transform

if (donorm) then
  kc = 0
  kcL = 0
  ibasL = 0
  indbL = 0
  kp = 0
  do iSym=1,nSym
    ! loop over contracted
    do iBas=1,nrBas(iSym)
      ibasL = ibasL+1
      jbasL = kcL
      do jbas=1,ibas
        jbasL = jbasL+1
        kc = kc+1
        sum_ = Zero
        ipbasL = mcaddr(ibasL)-1
        ! loop over primitives in this contracted function
        do iPrim=1,numb(ibasL)
          ipbasL = ipbasL+1
          jpbasL = mcaddr(jbasL)-1
          do jPrim=1,numb(jbasL)
            jpbasL = jpbasL+1
            ilarge = max(ipbasL,jpbasL)
            ismall = min(ipbasL,jpbasL)
            kp = kp+1
            indb = indbL+(ilarge*(ilarge-1))/2+ismall
            sum_ = sum_+bint(indb)*rCof(icaddr(ibasL)+iPrim)*rCof(icaddr(jbasL)+jPrim)
            if (idbg > 0) then
              write(idbg,*) indb,icaddr(ibasL)+iPrim,icaddr(jbasL)+jPrim
              write(idbg,*) bint(indb),rCof(icaddr(ibasL)+iPrim),rCof(icaddr(jbasL)+jPrim)
            end if
          end do  ! jprim
        end do    ! iprim
        sint(kc) = sum_
        !write(66,'(d25.14)') sum_
      end do
    end do
    kcL = kcL+nrBas(iSym)
    indbL = indbL+(nBas(iSym-1)*(nBas(iSym-1)+1))/2
    !if (idbg > 0) write(idbg,*) ipbasL,jpbasL,kp
  end do

else

  np = nBas(0)
  nc = nrBas(1)
  ! Scratch to square the mag ints and contract
  call mma_allocate(mag,np,np)
  call mma_allocate(u2c,np,nc)
  call mma_allocate(u2ct,nc,np)
  call mma_allocate(scr,np,nc)
  call mma_allocate(fin,nc,nc)
  call mma_allocate(pa,np)

  mag(:,:) = Zero
  u2c(:,:) = Zero
  u2ct(:,:) = Zero
  scr(:,:) = Zero
  fin(:,:) = Zero
  pa(:) = Zero

  ! Square the uncontracted ints
  mp = 0
  do ip=1,np
    do jp=1,ip
      mp = mp+1
      mag(jp,ip) = bint(mp)
      ! Suboptimal
      mag(ip,jp) = bint(mp)
    end do
  end do

  ! Construct contraction matrix
  do icon=1,nc
    istart = mcaddr(icon)-1
    do iprim=1,numb(icon)
      !write(u6,'(A,4I5,F14.10)') 'u2c loop',icon,iprim,istart,icaddr(icon),rCof(icaddr(icon)+iprim)
      u2c(istart+iprim,icon) = rCof(icaddr(icon)+iprim)
    end do
  end do

  ! U2C.T * UNCON * U2C => CON
  u2ct(:,:) = transpose(u2c)

  ! Since dgemm_ is causing trouble and this is trivial
  do iprim=1,np
    do icon=1,nc
      kpp = Zero
      pa(:) = u2ct(icon,:)*mag(:,iprim)
      do ip=1,np
        kpp = kpp+pa(ip)
      end do
      scr(iprim,icon) = kpp
    end do
  end do

  kp = 0
  do icon=1,nc
    do jcon=1,nc
      pa(:) = u2c(:,icon)*scr(:,jcon)
      kpp = Zero
      do ip=1,np
        kpp = kpp+pa(ip)
      end do
      fin(icon,jcon) = kpp
    end do
  end do

  kp = 0
  do icon=1,nc
    do jcon=1,icon
      kp = kp+1
      sint(kp) = fin(icon,jcon)
    end do
  end do

  call mma_deallocate(mag)
  call mma_deallocate(u2c)
  call mma_deallocate(u2ct)
  call mma_deallocate(scr)
  call mma_deallocate(fin)
  call mma_deallocate(pa)

  call cpu_time(finish)

end if !donorm

call mma_deallocate(icaddr)
call mma_deallocate(mcaddr)
call mma_deallocate(numb)
call mma_deallocate(numc)

return

end subroutine repmat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DistMemSum(maxdim,PosV1,PosV2,PosV3,PosH1,PosH2,PosT)
! This routine does:
! define initial positions of V and H
! used in summary routine

use chcc_global, only: no, printkey
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: maxdim
integer(kind=iwp), intent(out) :: PosV1, PosV2, PosV3, PosH1, PosH2
integer(kind=iwp), intent(inout) :: PosT
integer(kind=iwp) :: length

!1 V files

length = no*no*maxdim*maxdim
PosV1 = PosT
PosT = PosT+length
PosV2 = PosT
PosT = PosT+length
PosV3 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,99) 'DM V ',PosV1,PosV2,PosV3,length

!2 H files

length = no*maxdim
PosH1 = PosT
PosT = PosT+length
PosH2 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,99) 'DM H ',PosH1,PosH2,PosV3,length

if (printkey >= 10) write(u6,99) 'PosT ',PosT

return

99 format(a7,10(i10,1x))

end subroutine DistMemSum

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Fake(U2,mT,nRys,ZEInv)
!***********************************************************************
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             May '90                                                  *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mT, nRys
real(kind=wp), intent(inout) :: U2(mT,nRys)
real(kind=wp), intent(in) :: ZEInv(mT)

#include "macros.fh"
unused_var(U2)
unused_var(ZEInv)

return

end subroutine Fake

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!ifdef _DEBUGPRINT_
subroutine exccoupl()

use Index_Functions, only: nTri_Elem
use frenkel_global_vars, only: doexch, eNucB, excl, iTyp, jTyp, nestla, nestlb, valst
use Symmetry_Info, only: nIrrep
use Molcas, only: MxRoot
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: a, b, dimn, I, iAddr, iState, jState, kState, lState, LuT, LuT1, LuT2, LuT_, LuTX1, LuTX2, LuTX4, LWK1, LWK2, &
                     lWKX, nAtoms, nijkl, nstat1, nstat2, run
real(kind=wp) :: AB_Nuc, Discrim, EANucB, EBNucA, EECoupl, exCoupl, rlWKX(1), Vnn_AB
logical(kind=iwp) :: states1, states2, WK_C_exists, WK_X_exists
character(len=13) :: filnam1, filnam2, filnam3, filnam4, filnam5, filnam6, filnam9
character(len=1) :: labi, labj
real(kind=wp), allocatable :: Charge(:), Frenkelunknwn(:), rBvA(:), WK1(:), WKX1(:), WKX2(:)
integer(kind=iwp), external :: isFreeUnit
real(kind=wp), external :: DDot_

call StatusLine('RASSI: ','Starting Excitonic Coupling Section')
LuT_ = 10
labi = 'A'
labj = 'B'
if (iTyp == 0) then
  write(u6,*) ' MONA or MONB keyword missing!'
  call Abend()
else
  jTyp = 1+mod(iTyp,2) ! 1 or 2
  if (jTyp == 1) then
    labi = 'B'
    labj = 'A'
  end if
end if
write(u6,*)
write(u6,*) ' ************************************************'
write(u6,*) '  Excitonic couplings section:'
write(u6,*)
write(u6,*) '   ( v:  eA*eB + eA*nucB + eB*nucA + nucA*nucB )'
write(u6,*) ' ************************************************'
write(u6,*)

call mma_allocate(rBvA,nTri_Elem(mxroot),Label='Wnn_ab')
rBvA(:) = Zero
! read in <rhoB|VnucA> from already renamed and saved RunFile called rhoBnucA
call NameRun('AUXRFIL1')
call Get_dArray('<rhoB|VnucA>',rBvA,nTri_Elem(mxroot))
call Get_iScalar('Unique atoms',nAtoms)
call mma_allocate(Charge,nAtoms,Label='Zcharge')
call Get_dArray('Effective nuclear Charge',Charge,nAtoms)
VNN_AB = Zero
call NameRun('AUXRFIL2')
call PotNuc_nad(nIrrep,nAtoms,Charge,VNN_AB)
#ifdef _DEBUGPRINT_
write(u6,*) 'VNN_AB (nuc-nuc interaction)',VNN_AB
#endif
call mma_deallocate(Charge)
call NameRun('#Pop')    ! switch back to old RUNFILE

! read in number of states on each monomer
LuT_ = 10
write(filnam5,'(A,I1)') 'states_',iTyp
inquire(file=filnam5,exist=states1)
LuT = isFreeUnit(LuT_)
call molcas_open(LuT,filnam5)
read(LuT,*) nstat1
close(LuT)

write(filnam6,'(A,I1)') 'states_',jTyp
inquire(file=filnam6,exist=states2)
LuT = isFreeUnit(LuT_)
call molcas_open(LuT,filnam6)
read(LuT,*) nstat2
close(LuT)

if (EXCL) then
  dimn = nstat1*nstat2
  write(u6,*) 'dimn EXCL',nstat1*nstat2
else
  dimn = 1+(nstat1-1)+(nstat2-1)
end if
! allocate array with more entries than needed first
call mma_allocate(Frenkelunknwn,nTri_Elem(dimn))
Frenkelunknwn(:) = Zero

if (DoExch) then
  LuTX4 = isFreeUnit(LuT_)
  write(filnam9,'(A)') 'nRedX'
  call DANAME(LuTX4,filnam9)
  iAddr = 0
  call dDaFile(LuTX4,2,rlWKX,1,iAddr)
  lWKX = int(rlWKX(1),kind=iwp)
  call DACLOS(LuTX4)
end if

nijkl = 0

b = 0
a = 0
run = 0
! loop over I
do istate=1,nstat1
  ! loop over K
  do kstate=1,nstat2
    if ((istate /= 1) .or. (kstate /= 1)) then
      if (EXCL) then
        if ((all(nestla /= istate)) .or. (all(nestlb /= kstate))) cycle
      else
        if ((istate <= valst) .and. (kstate <= valst)) cycle
        if ((istate > valst) .and. (kstate > valst)) cycle
      end if
    end if
    b = b+1
    a = 0
    ! loop over J
    do jstate=1,nstat1
      ! Start Coulomb term
      if (istate > jstate) then
        write(filnam1,'(A,I1,A,I3.3,A,I3.3)') 'WK_C',iTyp,'_',istate,'_',jstate
      else
        write(filnam1,'(A,I1,A,I3.3,A,I3.3)') 'WK_C',iTyp,'_',jstate,'_',istate
      end if
      inquire(file=filnam1,exist=WK_C_exists)
      LuT1 = isFreeUnit(LuT_)
      call molcas_open(LuT1,filnam1)
      read(LuT1,*) lWK1
      call mma_allocate(WK1,2*lWK1,Label='WK12')
      read(LuT1,*) (WK1(i),i=1,lWK1)
      ! End Coulomb term
      ! Start-Exchange-term
      if (DoExch) then
        if (istate > jstate) then
          write(filnam3,'(A,I1,I2.2,I2.2)') 'X',iTyp,istate,jstate
        else
          write(filnam3,'(A,I1,I2.2,I2.2)') 'X',iTyp,jstate,istate
        end if
        inquire(file=filnam3,exist=WK_X_exists)
        LuTX1 = isFreeUnit(LuT_)
        call DANAME(LuTX1,filnam3)
        iAddr = 0
        call mma_allocate(WKX1,lWKX)
        iAddr = 0
        call dDaFile(LuTX1,2,WKX1,lWKX,iAddr)
        call DACLOS(LuTX1)
      end if
      ! End-Exchange-term

      ! loop over L
      do lstate=1,nstat2
        if ((jstate /= 1) .or. (lstate /= 1)) then
          if (EXCL) then
            if ((all(nestla /= jstate)) .or. (all(nestlb /= lstate))) cycle
          else
            if ((jstate <= valst) .and. (lstate <= valst)) cycle
            if ((jstate > valst) .and. (lstate > valst)) cycle
          end if
        end if
        a = a+1
        if (a <= b) then
          if (kstate > lstate) then
            write(filnam2,'(A,I1,A,I3.3,A,I3.3)') 'WK_C',jTyp,'_',KSTATE,'_',LSTATE
          else
            write(filnam2,'(A,I1,A,I3.3,A,I3.3)') 'WK_C',jTyp,'_',LSTATE,'_',KSTATE
          end if
          inquire(file=filnam2,exist=WK_C_exists)
          if (WK_C_exists) then
            AB_nuc = Zero
            eBnucA = Zero
            if (istate == jstate) eBnucA = rBvA(nTri_Elem(kstate-1)+lstate)
            eAnucB = Zero
            if (kstate == lstate) then
              eAnucB = eNucB(nTri_Elem(ISTATE-1)+JSTATE)
              if (istate == jstate) AB_nuc = VNN_AB
            end if

            LuT2 = isFreeUnit(LuT_)
            call molcas_open(LuT2,filnam2)
            read(LuT2,*) lWK2
            if (lWK2 == LWK1) then
              read(LuT2,*) (WK1(lWK1+i),i=1,lWK2)
              eeCoupl = ddot_(lWK1,WK1(1),1,WK1(lWK1+1),1)
#             ifdef _DEBUGPRINT_
              write(u6,*) 'J = ',eeCoupl
#             endif
              ! Start-Exchange-term
              if (DoExch) then
                if (kstate > lstate) then
                  write(filnam4,'(A,I1,I2.2,I2.2)') 'X',jTyp,kstate,lstate
                else
                  write(filnam4,'(A,I1,I2.2,I2.2)') 'X',jTyp,lstate,kstate
                end if
                inquire(file=filnam4,exist=WK_X_exists)

                LuTX2 = isFreeUnit(LuT_)
                call DANAME(LuTX2,filnam4)
                call mma_allocate(WKX2,lWKX)
                iAddr = 0
                call dDaFile(LuTX2,2,WKX2,lWKX,iAddr)
                call DACLOS(LuTX2)

                exCoupl = -Half*ddot_(lWKX,WKX1(1),1,WKX2(1),1)

                call mma_deallocate(WKX2)
#               ifdef _DEBUGPRINT_
                write(u6,*) 'K = ',exCoupl
#               endif
                eeCoupl = eeCoupl+exCoupl
              end if
              ! End-Exchange-term
              write(u6,100) istate,labi,kstate,labj,jstate,labi,lstate,labj,eeCoupl+eAnucB+eBnucA+AB_nuc

              run = run+1
#             ifdef _DEBUGPRINT_
              write(u6,*) 'eeCoupl',eeCoupl,'eAnucB',eAnucB,'eBnucA',eBnucA,'AB_nuc',AB_nuc
#             endif
              ! write into the Frenkel basis matrix (triangular)
              Frenkelunknwn(run) = eeCoupl+eAnucB+eBnucA+AB_nuc
              nijkl = nijkl+1
            else
              write(u6,*) ' Size of WK array mismatch!'
              call abend()
              ! end if lWK2 eq LWK1
            end if
            ! end if WK_C exists
          end if
          ! end if (a <= b)
        end if
        close(LuT2)
        ! end L
      end do
      close(LuT1)
      if (DoExch) call mma_deallocate(WKX1)
      call mma_deallocate(WK1)
      ! end J
    end do
    ! end K
  end do
  ! end I
end do

write(u6,*)
write(u6,*) '  Total Nr of couplings: ',nijkl
write(u6,*) ' ************************************************'
write(u6,*)
! determine dimensions of Hamiltonian
discrim = 1+4*2*nijkl
dimn = int((sqrt(discrim)-One)/2,kind=iwp)
write(u6,'(A,I3.3,A,I3.3)') 'determined Hamiltonian dimensions:',dimn,'x',dimn

call frenkelexc(Frenkelunknwn,dimn,nstat1,nstat2)

call mma_deallocate(Frenkelunknwn)
call mma_deallocate(rBvA)
if (excl) then
  call mma_deallocate(NESTLA)
  call mma_deallocate(NESTLB)
end if

100 format(3X,'<(',I3.3,')',A,'(',I3.3,')',A,'|v|(',I3.3,')',A,'(',I3.3,')',A,'> = ',ES18.8)

end subroutine exccoupl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Get_Coord_New_All
*
*> @brief
*>   Get the new coordinates from RUNFILE
*> @author R. Lindh
*>
*> @details
*> Place Cartesian coordinates (in a.u.) into array \p Coord_All(3,*).
*>
*> @param[out] Coord_All  Array of coordinates
*> @param[in]  nAtoms_All Number of atoms
************************************************************************
      Subroutine Get_Coord_New_All(Coord_All,nAtoms_All)
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
      Real*8 Coord_All(3,nAtoms_All)
      Real*8, Dimension (:,:), Allocatable :: CU
      Interface
        Subroutine Get_Coord_New(CU,nAtoms)
        Real*8, Dimension (:,:), Allocatable :: CU
        Integer nAtoms
        End Subroutine
      End Interface
*
      Call Get_nAtoms_All(nAtoms_Allx)
      If (nAtoms_All.ne.nAtoms_Allx) Then
         Write (6,*) 'Get_Coord_All: nAtoms_All.ne.nAtoms_Allx'
         Write (6,*) 'nAtoms_All=',nAtoms_All
         Write (6,*) 'nAtoms_Allx=',nAtoms_Allx
         Call Abend
      End If
      Call Get_Coord_New(CU,nAtoms)
      Call Get_Coord_All_(CU,nAtoms,Coord_All,nAtoms_All)
      Call mma_deallocate(CU)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine putguess_cvb(orbs,cvb,recn)

use casvb_global, only: endvar, ifmos, ipr, kbasiscvb, nbas_mo, norb, nvb, ploc, variat
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

#include "intent.fh"
implicit none
real(kind=wp), intent(_IN_) :: orbs(norb,*), cvb(*)
real(kind=wp), intent(in) :: recn
integer(kind=iwp) :: i, ierr, ioffs_cvb, ioffs_orbs, ioffs_orbsao, ioffs_orbslao, iorb, kbasiscvb1, nbas_mo1, norb1, nvb1
logical(kind=iwp) :: use_ao
real(kind=wp), allocatable :: a(:,:), b(:,:), c(:), orbsao(:,:)
real(kind=wp), external :: dnrm2_

call wrheader_cvb(recn,norb,nbas_mo,nvb,kbasiscvb,ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)
call rdheader_cvb(recn,norb1,nbas_mo1,nvb1,kbasiscvb1,ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)
do iorb=1,norb
  call wrgspr_cvb(recn,orbs(:,iorb),iorb,norb,1,ierr)
end do
call wrgspr_cvb(recn,cvb,1,nvb,2,ierr)
use_ao = ifmos .and. ((.not. variat) .or. (variat .and. endvar))
if (use_ao) then
  call mma_allocate(orbsao,nbas_mo,norb)
  call mo2ao_cvb(orbs,orbsao,norb)
  do iorb=1,norb
    call wrgspr_cvb(recn,orbsao(:,iorb),iorb,nbas_mo,3,ierr)
  end do
  if (ipr(5) >= 2) then
    write(u6,'(/,a)') ' VB orbitals in AO basis :'
    write(u6,'(a)') ' -------------------------'
    call mxprint_cvb(orbsao,nbas_mo,norb,0)
  end if
  if (ploc) then
    call untested('putguess_cvb: ploc')
    call mma_allocate(a,norb,norb,label='a')
    call mma_allocate(b,norb,norb,label='b')
    call mma_allocate(c,norb,label='c')
    !call getr_plc(a)
    call dgetmi(a,norb,norb)
    call mxatb_cvb(a,orbs,norb,norb,norb,b)
    call lmo2ao_cvb(b,orbsao,norb)
    do iorb=1,norb
      call wrgspr_cvb(recn,orbsao(:,iorb),iorb,nbas_mo,4,ierr)
    end do
    if (ipr(5) >= 2) then
      write(u6,'(/,a)') ' Original localized VB orbitals in AO basis :'
      write(u6,'(a)') ' --------------------------------------------'
      call mxprint_cvb(orbsao,nbas_mo,norb,0)
    end if
    do i=1,norb
      c(i) = dnrm2_(norb,b(:,i),1)
      b(:,i) = b(:,i)/c(i)
    end do
    if (ipr(5) >= 2) then
      write(u6,'(/,a)') ' Norms of original localized VB orbitals :'
      write(u6,'(a)') ' -----------------------------------------'
      call mxprint_cvb(c,1,norb,0)
    end if
    call mma_deallocate(a)
    call mma_deallocate(b)
    call mma_deallocate(c)
  end if
  call mma_deallocate(orbsao)
end if

return

end subroutine putguess_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
************************************************************************
*                                                                      *
*  Subroutine set_thrint:     Puts integral thresholds into info.fh    *
*                                                                      *
************************************************************************
      subroutine set_thrint(thr,cut)
c-----------------------------------------------------------------------
      use Real_Info, only: ThrInt, CutInt
      ThrInt=max(1.d-14,thr)
      CutInt=max(1.d-14,cut)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Roland Lindh                                     *
************************************************************************
      Subroutine Virt_Space(C_Occ,C_Virt,Ovrlp,nBas,nOcc,nVirt)
************************************************************************
*     The generation of starting orbitals suffer from the fact that    *
*     the virtual orbitals are not well defined. This routine is       *
*     supposed to generate a set well defined virtual orbitals from a  *
*     set of well defined occupid orbitals.                            *
************************************************************************
      Implicit None
#include "stdalloc.fh"
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Integer i,j
      Integer ij, iTri
#endif
      Integer nOcc,nVirt,nBas
      Integer iBas, jBas, iOcc, kBas, iVirt, lBas
      Integer mVirt
      Logical Polished
      Real*8 C_Occ(nBas,nOcc), C_Virt(nBas,nVirt),
     &       Ovrlp(nBas*(nBas+1)/2)
      Real*8 tmp
      Real*8, Dimension(:,:), Allocatable:: P, Ovrlp_Sq, EVe, C_tmp
      Real*8, Dimension(:), Allocatable:: PNew, EVa
#ifdef _DEBUGPRINT_
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
      Write (6,*) 'nBas,nOcc,nVirt=',nBas,nOcc,nVirt
      Call RecPrt('C_Occ',' ',C_Occ,nBas,nOcc)
      Call RecPrt('C_Virt',' ',C_Virt,nBas,nVirt)
      Call TriPrt('Ovrlp',' ',Ovrlp,nBas)
      Do iOcc = 1, nOcc
         tmp = 0.0D0
         Do iBas = 1, nBas
            Do jBas = 1, nBas
               ij = iTri(iBas,jBas)
               tmp = tmp + C_Occ(iBas,iOcc)*Ovrlp(ij)*
     &                     C_Occ(jBas,iOcc)
            End Do
         End Do
         Write (6,*) 'iOcc,tmp=',iOcc,tmp
      End Do
      Do iVirt = 1, nVirt
         tmp = 0.0D0
         Do iBas = 1, nBas
            Do jBas = 1, nBas
               ij = iTri(iBas,jBas)
               tmp = tmp + C_Virt(iBas,iVirt)*Ovrlp(ij)*
     &                     C_Virt(jBas,iVirt)
            End Do
         End Do
         Write (6,*) 'iVirt,tmp=',iOcc,tmp
      End Do
#endif
*
      If (nVirt.eq.0) Call Abend()
*
*     Compute S^{1/2}
*
      Call mma_allocate(Ovrlp_Sq,nBas,nBas,Label='Ovrlp_Sq')
      Call mma_allocate(EVa,nBas*(nBas+1)/2,Label='EVa')
      Call mma_allocate(EVe,nBas,nBas,Label='EVe')
      Call FZero(EVe,nBas**2)
      Call DCopy_(nBas,[1.0D0],0,EVe,nBas+1)
      Call DCopy_(nBas*(nBas+1)/2,Ovrlp,1,EVa,1)
      Call NIdiag(EVa,EVe,nBas,nBas,0)
*
      Do iBas = 2, nBas
         EVa(iBas) = EVa(iBas*(iBas+1)/2)
      End Do
*
      Do iBas = 1, nBas
         Do jBas = 1, nBas
            tmp = 0.0D0
            Do kBas = 1, nBas
               tmp = tmp +
     &               EVe(iBas,kBas)*Sqrt(EVa(kBas))*EVe(jBas,kBas)
            End Do
            Ovrlp_Sq(iBas,jBas)=tmp
         End Do
      End Do
*
*     Now transform the the CMOs of the occupied orbitals to an
*     orthonormal basis.
*
      Call mma_allocate(C_tmp,nBas,nOcc,Label='C_tmp')
      Call FZero(C_tmp,nBas*nOcc)
      Call DGEMM_('N','N',
     &            nBas,nOcc,nBas,
     &            1.0D0,Ovrlp_Sq,nBas,
     &                  C_Occ,nBas,
     &            0.0D0,C_tmp,nBas)
*
      Call mma_allocate(P,nBas,nBas,Label='P')
      Call mma_allocate(PNew,nBas,Label='PNew')
*
*     Form the P matrix = 1 - |C(occ)><C(occ)|
*
      Do iBas = 1, nBas
         Do jBas = 1, nBas
            tmp=0.0D0
            If (iBas.eq.jBas) tmp=1.0D0
            Do iOcc = 1, nOcc
               tmp = tmp - C_tmp(iBas,iOcc)*C_tmp(jBas,iOcc)
            End Do
            P(iBas,jBas) = tmp
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('P-mat',' ',P,nBas,nBas)
      Do iBas = 1, nBas
         Write (6,*) 'iBas,P(iBas,iBas)=',iBas,P(iBas,iBas)
      End Do
#endif
*
*     Now, use Cholesky Decomposition to reduce
*     the size of the P-matrix from a nBas x nBas size
*     down to something that is nBas x nVirt
*
      mVirt = 0
      Do kBas = 1, nBas
*
         tmp=0.0D0
         lBas = 0
         Do iBas = 1, nBas
            If (P(iBas,iBas).gt.tmp) Then
               tmp=P(iBas,iBas)
               lBas = iBas
            End If
         End Do
*
*        Pick up a vector and project it against the previous
*
         Call DCopy_(nBas,P(1,lBas),1,PNew,1)
*
*        Normalize PNew
*
         tmp=0.0D0
         Do iBas = 1, nBas
            tmp = tmp + PNew(iBas)**2
         End Do
*
*        Skip if this is a null vector.
*
         If (tmp.lt.1.0D-14) Cycle
*
         tmp=1.0D0/Sqrt(tmp)
         Call DScal_(nBas,tmp,PNew,1)
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*) 'New Trial vector'
         Write (6,*) '================'
         Write (6,*) 'kBas,lBas,tmp=',kBas,lBas,tmp
         Call RecPrt('Normalized PNew',' ',PNew,nBas,1)
#endif
*
*        Polished = .False.
         Polished = .True.
 666     Continue
*
         Do iOcc = 1, nOcc
*
*           From the trial vector eliminate the occupied
*           space
*
            tmp=0.0D0
            Do iBas = 1, nBas
               tmp = tmp + PNew(iBas)*C_tmp(iBas,iOcc)
            End Do
#ifdef _DEBUGPRINT_
            Write (6,*) 'iOcc,tmp=',iOcc,tmp
#endif
*           Form PNew(2) = P(2) - <PNew(1)|Ovrlp|P(2)>PNew(1)
*
            Call DaXpY_(nBas,-tmp,C_Occ(1,iOcc),1,PNew,1)
         End Do
         Do iVirt = 1, mVirt
*
*           From the trial vector eliminate parts which
*           already expressed.
*
            tmp=0.0D0
            Do iBas = 1, nBas
               tmp = tmp + PNew(iBas)*C_Virt(iBas,iVirt)
            End Do
#ifdef _DEBUGPRINT_
            Write (6,*) 'iVirt,tmp=',iVirt,tmp
#endif
*
*           Form PNew(2) = P(2) - <PNew(1)|Ovrlp|P(2)>PNew(1)
*
            Call DaXpY_(nBas,-tmp,C_Virt(1,iVirt),1,PNew,1)
         End Do
*
*        Test that it is not a null vector!
*
         tmp = 0.0D0
         Do iBas = 1, nBas
            tmp = tmp + PNew(iBas)**2
         End Do
#ifdef _DEBUGPRINT_
         Write (6,*) 'Norm after projection:',tmp
         Write (6,*)
#endif
         If (tmp.gt.1.0D-14) Then
            tmp=1.0D0/Sqrt(tmp)
            Call DScal_(nBas,1.0D0/Sqrt(tmp),PNew,1)
            If (.Not.Polished) Then
               Polished=.True.
               Go To 666
            End If
*
            If (tmp.gt.1.0D-14) Then
               If (mVirt+1.gt.nVirt) Then
                  Write (6,*) 'mVirt.gt.nVirt'
                  Write (6,*) 'mVirt=',mVirt
                  Write (6,*) 'nVirt=',nVirt
                  Call Abend()
               End If
               mVirt=mVirt+1
               Call DCopy_(nBas,PNew,1,C_Virt(1,mVirt),1)
*
*              Update the P-matrix.
*
               Do iBas = 1, nBas
                  Do jBas = 1, nBas
                     P(iBas,jBas)=P(iBas,jBas)-PNew(iBas)*PNew(jBas)
                  End Do
               End Do
            End If
         End If
*
         If (mVirt.eq.nVirt) Go To 667
*
      End Do
*
 667  Continue
      Call mma_deallocate(C_tmp)
*
      If (mVirt.ne.nVirt) Then
         Write (6,*) 'mVirt.ne.nVirt'
         Write (6,*) 'mVirt,nVirt=',mVirt,nVirt
         Call Abend()
      End If
*
      Call mma_deallocate(P)
      Call mma_deallocate(PNew)
*
*     Form S^(-1/2)
*
      Do iBas = 1, nBas
         Do jBas = 1, nBas
            tmp = 0.0D0
            Do kBas = 1, nBas
               tmp = tmp +
     &              (EVe(iBas,kBas)*EVe(jBas,kBas))/Sqrt(EVa(kBas))
            End Do
            Ovrlp_Sq(iBas,jBas)=tmp
         End Do
      End Do
      Call mma_deallocate(EVe)
      Call mma_deallocate(EVa)
*
      Call mma_allocate(C_tmp,nBas,nVirt,Label='C_tmp')
      Call DCopy_(nBas*nVirt,C_Virt,1,C_tmp,1)
      Call DGEMM_('N','N',
     &            nBas,nVirt,nBas,
     &            1.0D0,Ovrlp_Sq,nBas,
     &                  C_tmp,nBas,
     &            0.0D0,C_Virt,nBas)
      Call mma_deallocate(C_tmp)
      Call mma_deallocate(Ovrlp_Sq)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('C_Virt(New)',' ',C_Virt,nBas,nVirt)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SIGMA(SGM,AREF,CI,INTSY,INDX,BMN,IBMN,BIAC2,BICA2,BFIN3,ISAB,AC1,AC2,BFIN4,ABIJ,AIBJ,AJBI,ASCR1,BSCR1,FSCR1,FSEC,FOCK, &
                 ASCR2,BSCR2,FSCR2,DBK)

use mrci_global, only: ESHIFT, FIJKL, GFAC, ICPF, IFIRST, IREFX, IREST, ITER, NCONF, NREF, POTNUC
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: SGM(*), BMN(*), BIAC2(*), BICA2(*), BFIN3(*), AC1(*), AC2(*), BFIN4(*), ASCR1(*), BSCR1(*), &
                                FSCR1(*), ASCR2(*), BSCR2(*), FSCR2(*), DBK(*)
real(kind=wp), intent(in) :: AREF(*)
real(kind=wp), intent(inout) :: CI(*), ABIJ(*), AIBJ(*), AJBI(*), FSEC(*), FOCK(*)
integer(kind=iwp), intent(in) :: INTSY(*), INDX(*), ISAB(*)
integer(kind=iwp), intent(_OUT_) :: IBMN(*)
integer(kind=iwp) :: ICSF, IREF, KTYP
real(kind=wp) :: GINV, SQG, SQGP

SGM(1:NCONF) = Zero

call CSFTRA(' CSF',CI,AREF)
SQGP = One
SQG = One
if (ICPF == 1) then
  SQGP = sqrt(GFAC)
  SQG = One/SQGP
  do IREF=1,NREF
    ICSF = IREFX(IREF)
    CI(ICSF) = SQGP*CI(ICSF)
  end do
end if

call DIAGC(INTSY,CI,SGM)
if ((IFIRST == 0) .and. ((IREST == 1) .or. (ITER > 1))) then
  call ABCI(INTSY,INDX,CI,SGM,BMN,IBMN,BIAC2,BICA2,BFIN3)
  call ABCD(INTSY,INDX,ISAB,CI,SGM,AC1,AC2,BFIN4)
end if
call IJKL(INTSY,INDX,CI,SGM,FIJKL)

call FAIBJ(INTSY,INDX,CI,SGM,ABIJ,AIBJ,AJBI,ASCR1,BSCR1,FSCR1,FSEC)

if (ITER > 0) then
  KTYP = 1
  ! Switch KTYP=1 means AI is actually handling AIJK integrals.
  call AI_MRCI(INTSY,INDX,CI,SGM,FOCK,ASCR2,BSCR2,FSCR2,DBK,KTYP)
end if
call FIJ(INTSY,INDX,CI,SGM,FOCK,ASCR2,BSCR2,FSCR2,DBK)

SGM(1:NCONF) = SGM(1:NCONF)+(POTNUC-ESHIFT)*CI(1:NCONF)
if (ICPF == 1) then
  GINV = One/GFAC
  SGM(1:NCONF) = GINV*SGM(1:NCONF)
  do IREF=1,NREF
    ICSF = IREFX(IREF)
    CI(ICSF) = SQG*CI(ICSF)
    SGM(ICSF) = SQGP*SGM(ICSF)
  end do
end if

call CSFTRA('MCSF',SGM,AREF)

return

end subroutine SIGMA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Martin Schuetz                                   *
!               2017, Roland Lindh                                     *
!***********************************************************************

subroutine vOO2OV(v1,nOO,v2,mOV,nD,kOV)

use Interfaces_SCF, only: vOO2OV_inner
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOO, mOV, nD, kOV(nD)
real(kind=wp), intent(in) :: v1(nOO,nD)
real(kind=wp), intent(out) :: v2(mOV)
integer(kind=iwp) :: iD, iEnd, iSt

iEnd = 0
v2(:) = Zero
do iD=1,nD
  if (kOV(iD) < 1) cycle
  iSt = iEnd+1
  iEnd = iEnd+kOV(iD)
  call vOO2OV_inner(v1(:,iD),nOO,v2(iSt:iEnd),kOV(iD),iD)
end do

end subroutine vOO2OV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  quater
*
*> @brief
*>   Driver for quater
*> @author Y. Carissan
*>
*> @details
*> Driver for quater.
*>
*> @param[out] ireturn return code
************************************************************************
      subroutine quater(ireturn)
      Implicit none
#include "WrkSpc.fh"
#include "debug.fh"
#include "options.fh"
      Real*8 U1(3),U2(3),V1(3),V2(3)
      Real*8 V1best(3),V2best(3)
      Real*8 Q(0:3)
      Integer ireturn

      debug=.false.
      call quaterinit()

      Call RdInput_Quater(U1,U2,V1,V2)

      if (debug) then
        Write(6,*) 'Reference axis'
        Call RecPrt("U1",' ',U1,3,1)
        Call RecPrt("U2",' ',U2,3,1)
        Write(6,*) 'New axis'
        Call RecPrt("V1",' ',V1,3,1)
        Call RecPrt("V2",' ',V2,3,1)
      end if

      call QuaterSolve(U1,U2,V1,V2,Q)

c for test
      Call Add_Info('Quaternion',Q,4,8)
c for test

      if (debug) then
        Write(6,*) 'Normalized Reference axis'
        Call RecPrt("U1",' ',U1,3,1)
        Call RecPrt("U2",' ',U2,3,1)
        Write(6,*) 'Normalized New axis'
        Call RecPrt("V1",' ',V1,3,1)
        Call RecPrt("V2",' ',V2,3,1)
        call QuaterRotation(Q,U1,V1best)
        call QuaterRotation(Q,U2,V2best)
        Call RecPrt("Best V1",' ',V1best,3,1)
        Call RecPrt("Best V2",' ',V2best,3,1)
      end if

      Call GenerateGeoms(Q)

      Call QuaterReport(V1best,V2best,V1,V2)

      Call QuaterFinish()

      ireturn=0

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!               2023, Roland Lindh                                     *
!***********************************************************************

subroutine ChoSCF_Drv(nBSQT,nD,nSym,nBas,DSQ,DLT,DSQ_ab,DLT_ab,FLT,FLT_ab,nFLT,ExFac,FSQ,nOcc,nOcc_ab)
!
! Thomas Bondo Pedersen, September 2010.
!
! This routine calls the original ChoSCF_Drv routine (now
! ChoSCF_Drv_) in case of Cholesky or full DF.

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBSQT, nD, nSym, nBas(nSym), nFLT, nOcc(nSym), nOcc_ab(nSym)
real(kind=wp), intent(in) :: DSQ(*), DLT(*), DSQ_ab(*), ExFac
real(kind=wp), intent(inout) :: DLT_ab(*), FLT(*), FLT_ab(*), FSQ(nBSQT,nD)

!                                                                      *
!***********************************************************************
!                                                                      *

call ChoSCF_Drv_Inner(nD,nSym,nBas,DSQ,DLT,DSQ_ab,DLT_ab,FLT,FLT_ab,nFLT,ExFac,FSQ(:,1),FSQ(:,nD),nOcc,nOcc_ab)

! This is to allow type punning without an explicit interface
contains

subroutine CHOSCF_DRV_Inner(nD,nSym,nBas,W_DSQ,W_DLT,W_DSQ_ab,W_DLT_ab,W_FLT,W_FLT_ab,nFLT,ExFac,W_FSQ,W_FSQ_ab,nOcc,nOcc_ab)

  use Index_Functions, only: iTri
  use InfSCF, only: Algo, Cho_Aufb, CMO, dFKmat, dmpk, nScreen, ReOrd
  use Fock_util_global, only: Deco, Lunit
  use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, Integer_Pointer
  use SpinAV, only: Do_SpinAV
  use Constants, only: Zero, One, Two, Half
  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp), intent(in) :: nD, nSym, nBas(nSym), nFLT
  real(kind=wp), intent(in) :: W_DSQ(*), W_DLT(*), W_DSQ_ab(*), ExFac
  real(kind=wp), intent(inout) :: W_DLT_ab(*), W_FLT(*), W_FLT_ab(*), W_FSQ(*), W_FSQ_ab(*)
  integer(kind=iwp), target, intent(in) :: nOcc(nSym), nOcc_ab(nSym)
  integer(kind=iwp), parameter :: MaxDs = 3
  integer(kind=iwp) :: i, ikk, iSym, j, ja, k, kj, loff1, MinMem(nSym), n2BSF(8,8), nDen, nForb(8,2), nIorb(8,2), nmat, &
                       nnBSF(8,8), numV, numV1, numV2, rc
  real(kind=wp) :: FactC(MaxDs), FactX(MaxDs), Thr, xFac, YMax
  logical(kind=iwp) :: DoCoulomb(MaxDs), DoExchange(MaxDs), ReOrd_Set = .false.
  character(len=512) :: ww
  type(DSBA_Type) :: Cka(2), DDec(2), DLT(1), DSQ(3), FLT(2), FSQ(3), KLT(2), MSQ(3), Vec(2)
  type(Integer_Pointer) :: pNocc(3)
  integer(kind=iwp), allocatable, target :: nVec(:,:)

  rc = 0
  Lunit(:) = -1
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  if (REORD .and. (.not. ReOrd_Set)) then
    call Cho_X_ReOVec(rc)
    ReOrd_Set = .true.
  end if

  if (nD == 1) then
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    call mma_allocate(nVec,nSym,1,Label='nVec')
    nDen = 1
    DoCoulomb(1) = .true.
    DoExchange(1) = (ExFac /= Zero) ! no SCF-exchange in pure DFT
    FactC(1) = One
    FactX(1) = ExFac ! ExFac used for hybrid functionals

    xFac = ExFac

    call Allocate_DT(DLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_DLT)
    call Allocate_DT(DSQ(1),nBas,nBas,nSym,Ref=W_DSQ)
    call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FLT)
    ! trick to use already allocated memory
    call Allocate_DT(KLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FSQ)
    call Allocate_DT(FSQ(1),nBas,nBas,nSym,Ref=W_FSQ)

    if (ExFac == Zero) then
      call CHO_FOCK_DFT_RED(rc,DLT,FLT)
      call Error_check(rc)
    else

      if (DECO) then !use decomposed density

        xFac = ExFac*Half

        call set_nnBSF(nSym,nBas,nnBSF,n2BSF)

        call Allocate_DT(Vec(1),nBas,nBas,nSym)
        call Allocate_DT(DDec(1),nBas,nBas,nSym)
        DDec(1)%A0(:) = DSQ(1)%A0(:)

        do i=1,nSym
          if (nBas(i) > 0) then
            Ymax = Zero
            do ja=1,nBas(i)
              Ymax = max(Ymax,DDec(1)%SB(i)%A2(ja,ja))
            end do
            Thr = 1.0e-8_wp*Ymax
            call CD_InCore(DDec(1)%SB(i)%A2,nBas(i),Vec(1)%SB(i)%A2,nBas(i),NumV,Thr,rc)
            call Error_check(rc)
            nVec(i,1) = NumV
            if ((NumV /= nOcc(i)) .and. (.not. Do_SpinAV) .and. (.not. Cho_Aufb)) then
              write(ww,'(a,i6,a,i6,a,i6,a,i6,a,f6.4)') &
                'Warning! The number of occupied from the decomposition of the density matrix is ',numV,' in symm. ',i, &
                ';Expected value = ',nOcc(i),'; Max diagonal of the density in symm. ',i,' is equal to ',Ymax
              call WarningMessage(1,trim(ww))
            end if
          else
            nVec(i,1) = 0
          end if
        end do
        call Deallocate_DT(DDec(1))

        pNocc(1)%I1(1:) => nVec(:,1) ! occup. numbers

        call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=Vec(1)%A0)

        FactX(1) = Half*ExFac ! ExFac used for hybrid functionals

      else

        pNocc(1)%I1(1:) => nOcc(:) ! occup. numbers

        call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=CMO(:,1))

      end if

      call CHOSCF_MEM(nSym,nBas,nD,DoExchange,pNocc,ALGO,REORD,MinMem,loff1)
      !                                                                *
      !*****************************************************************
      !                                                                *
      select case (ALGO)

        case (1)
          !                                                            *
          !*************************************************************
          !                                                            *
          FactX(1) = Half*ExFac

          if (REORD) then
            call CHO_FOCKTWO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,FactC,FactX,DLT,DSQ,FLT,FSQ,pNocc,MinMem)
          else
            call CHO_FOCKTWO_RED(rc,nBas,nDen,DoCoulomb,DoExchange,FactC,FactX,DLT,DSQ,FLT,FSQ,pNocc,MinMem)
          end if
          !                                                            *
          !*************************************************************
          !                                                            *
        case (2)
          !                                                            *
          !*************************************************************
          !                                                            *
          if (DECO) then
            FactX(1) = Half*ExFac ! vectors are scaled by construction
          else
            FactX(1) = ExFac ! MOs coeff. are not scaled
          end if

          if (REORD) then
            call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
          else
            call CHO_FMO_RED(rc,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
          end if
          !                                                            *
          !*************************************************************
          !                                                            *
        case (3)

          nIorb(1:nSym,1) = pNocc(1)%I1(1:nSym)
          call Allocate_DT(Cka(1),nIorb(:,1),nBas,nSym)

          do iSym=1,nSym
            if (nBas(iSym)*nIorb(iSym,1) /= 0) then
              do ikk=1,nIorb(iSym,1)
                Cka(1)%SB(iSym)%A2(ikk,:) = MSQ(1)%SB(iSym)%A2(:,ikk)
              end do
            end if
            nForb(iSym,1) = 0
          end do

          call CHO_FSCF(rc,nDen,FLT,nForb,nIorb,Cka(1),DLT,xFac)

          call Deallocate_DT(Cka(1))
          !                                                            *
          !*************************************************************
          !                                                            *
        case (4)

          nForb(1:nSym,1) = 0
          nIorb(1:nSym,1) = pNocc(1)%I1(1:nSym)

          call CHO_LK_SCF(rc,nDen,FLT,KLT,nForb,nIorb,MSQ,DLT,FactX(1),nSCReen,dmpk,dFKmat)

          !                                                            *
          !*************************************************************
          !                                                            *
        case default
          !                                                            *
          !*************************************************************
          !                                                            *
          rc = 99
          write(u6,*) 'Illegal Input. Specified Cholesky Algorithm= ',ALGO
          call QUIT(rc)
          !                                                            *
          !*************************************************************
          !                                                            *
      end select
      !                                                                *
      !*****************************************************************
      !                                                                *
      call Error_check(rc)

      if (DECO) call Deallocate_DT(Vec(1))

      if ((ALGO < 3) .and. (ExFac /= Zero)) call CHO_SUM(rc,nSym,nBas,nD,DoExchange,FLT,FSQ)

    end if

    !-------------------------------------------------------------------
    call GADSum(FLT(1)%A0,nFLT)

    nullify(pNocc(1)%I1)
    call Deallocate_DT(MSQ(1))
    call Deallocate_DT(FSQ(1))
    call Deallocate_DT(DSQ(1))
    call Deallocate_DT(KLT(1))
    call Deallocate_DT(FLT(1))
    call Deallocate_DT(DLT(1))
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  else   !  UHF calculation
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    call mma_allocate(nVec,nSym,2,Label='nVec')
    nDen = 3
    ! ========== Assign a truth table ==================

    ! Density(1) is Dalpha + Dbeta in a LT storage
    DoCoulomb(1) = .true.
    DoExchange(1) = .false.
    FactC(1) = One

    ! Density(2) is Dalpha in a SQ storage
    DoCoulomb(2) = .false.
    DoExchange(2) = (ExFac /= Zero)

    ! Density(3) is Dbeta in a SQ storage
    DoCoulomb(3) = .false.
    DoExchange(3) = (ExFac /= Zero)

    ! Occupation numbers
    !call get_iarray('nIsh',nOcc,nSym)
    !call get_iarray('nIsh beta',nOcc_ab,nSym)

    ! Compute the total density Dalpha + Dbeta
    W_DLT_ab(1:nFLT) = W_DLT_ab(1:nFLT)+W_DLT(1:nFLT)

    call Allocate_DT(DLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_DLT_ab)
    ! alpha density SQ
    call Allocate_DT(DSQ(2),nBas,nBas,nSym,Ref=W_DSQ)
    ! beta  density SQ
    call Allocate_DT(DSQ(3),nBas,nBas,nSym,Ref=W_DSQ_ab)

    ! Coulomb (... Falpha LT)
    call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FLT)
    ! (... Fbeta LT)
    call Allocate_DT(FLT(2),nBas,nBas,nSym,aCase='TRI',Ref=W_FLT_ab)

    ! alpha exchange (... Falpha SQ)
    call Allocate_DT(FSQ(2),nBas,nBas,nSym,Ref=W_FSQ)
    ! beta exchange (... Fbeta SQ)
    call Allocate_DT(FSQ(3),nBas,nBas,nSym,Ref=W_FSQ_ab)

    ! trick to use already allocated work
    call Allocate_DT(KLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FSQ)
    call Allocate_DT(KLT(2),nBas,nBas,nSym,aCase='TRI',Ref=W_FSQ_ab)

    FactX(2) = ExFac ! UHF SQ-density is not scaled
    FactX(3) = ExFac

    if (ExFac == Zero) then
      call CHO_FOCK_DFT_RED(rc,DLT,FLT)
      call Error_check(rc)
    else

      if (DECO) then !use decomposed density

        call set_nnBSF(nSym,nBas,nnBSF,n2BSF)

        call Allocate_DT(Vec(1),nBas,nBas,nSym)
        call Allocate_DT(Vec(2),nBas,nBas,nSym)

        call Allocate_DT(DDec(1),nBas,nBas,nSym)
        call Allocate_DT(DDec(2),nBas,nBas,nSym)
        DDec(1)%A0(:) = DSQ(2)%A0(:)
        DDec(2)%A0(:) = DSQ(3)%A0(:)

        do i=1,nSym
          if (nBas(i) > 0) then
            Ymax = Zero
            do ja=1,nBas(i)
              Ymax = max(Ymax,DDec(1)%SB(i)%A2(ja,ja))
            end do
            Thr = 1.0e-8_wp*Ymax
            call CD_InCore(DDec(1)%SB(i)%A2,nBas(i),Vec(1)%SB(i)%A2,nBas(i),NumV1,Thr,rc)
            call Error_check(rc)
            nVec(i,1) = NumV1
            if ((NumV1 /= nOcc(i)) .and. (.not. Do_SpinAV) .and. (.not. Cho_Aufb)) then
              write(ww,'(a,i6,a,i6,a,i6,a,i6,a,f6.4)') &
                'Warning! The number of occupied from the decomposition of the ALPHA dens. matrix is ',numV1,' in symm. ',i, &
                ';Expected value = ',nOcc(i),';Max diagonal of the alpha density in symmetry ',i,' is equal to ',Ymax
              call WarningMessage(1,trim(ww))
            end if

            Ymax = Zero
            do ja=1,nBas(i)
              Ymax = max(Ymax,DDec(2)%SB(i)%A2(ja,ja))
            end do
            Thr = 1.0e-8_wp*Ymax
            call CD_InCore(DDec(2)%SB(i)%A2,nBas(i),Vec(2)%SB(i)%A2,nBas(i),NumV2,Thr,rc)
            call Error_check(rc)
            nVec(i,2) = NumV2
            if ((NumV2 /= nOcc_ab(i)) .and. (.not. Do_SpinAV) .and. (.not. Cho_Aufb)) then
              write(ww,'(a,i6,a,i6,a,i6,a,i6,a,f6.4)') &
                'Warning! The number of occupied from the decomposition of the BETA dens. matrix is ',numV2,' in symm. ',i, &
                ';Expected value = ',nOcc_ab(i),';Max diagonal of the beta density in symmetry ',i,' is equal to ',Ymax
              call WarningMessage(1,trim(ww))
            end if
          else
            nVec(i,1) = 0
            nVec(i,2) = 0
          end if
        end do

        call deallocate_DT(DDec(2))
        call deallocate_DT(DDec(1))

        pNocc(1)%I1(1:) => nVec(:,1) ! dummy
        pNocc(2)%I1(1:) => nVec(:,1) ! alpha occup. numbers
        pNocc(3)%I1(1:) => nVec(:,2) ! beta occup. numbers

        call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=Vec(1)%A0)
        call Allocate_DT(MSQ(2),nBas,nBas,nSym,Ref=Vec(1)%A0)
        call Allocate_DT(MSQ(3),nBas,nBas,nSym,Ref=Vec(2)%A0)
      else
        pNocc(1)%I1(1:) => nOcc(:) ! dummy assignement
        pNocc(2)%I1(1:) => nOcc(:) ! occup. numbers alpha MOs
        pNocc(3)%I1(1:) => nOcc_ab(:) ! occup. numbers beta MOs

        call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=CMO(:,1))
        call Allocate_DT(MSQ(2),nBas,nBas,nSym,Ref=CMO(:,1))
        call Allocate_DT(MSQ(3),nBas,nBas,nSym,Ref=CMO(:,2))

      end if

      call CHOSCF_MEM(nSym,nBas,nD,DoExchange,pNocc,ALGO,REORD,MinMem,loff1)

      select case (ALGO)

        case (1)

          if (REORD) then
            call CHO_FOCKTWO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,FactC,FactX,DLT,DSQ,FLT,FSQ,pNocc,MinMem)
          else
            call CHO_FOCKTWO_RED(rc,nBas,nDen,DoCoulomb,DoExchange,FactC,FactX,DLT,DSQ,FLT,FSQ,pNocc,MinMem)
          end if

        case (2)

          if (REORD) then
            call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
          else
            call CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
          end if

        case (3)

          nIorb(1:nSym,1) = pNocc(2)%I1(1:nSym)
          nIorb(1:nSym,2) = pNocc(3)%I1(1:nSym)
          call Allocate_DT(Cka(1),nIorb(:,1),nBas,nSym)
          call Allocate_DT(Cka(2),nIorb(:,2),nBas,nSym)

          do iSym=1,nSym
            if (nBas(iSym)*nIorb(iSym,1) /= 0) then
              do ikk=1,nIorb(iSym,1)
                Cka(1)%SB(iSym)%A2(ikk,:) = MSQ(2)%SB(iSym)%A2(:,ikk)
              end do
            end if
            if (nBas(iSym)*nIorb(iSym,2) /= 0) then
              do ikk=1,nIorb(iSym,2)
                Cka(2)%SB(iSym)%A2(ikk,:) = MSQ(3)%SB(iSym)%A2(:,ikk)
              end do
            end if
            nForb(iSym,1) = 0
            nForb(iSym,2) = 0
          end do

          nMat = 2  ! alpha and beta Fock matrices

          call CHO_FSCF(rc,nMat,FLT,nForb,nIorb,Cka,DLT,ExFac)

          call Deallocate_DT(Cka(2))
          call Deallocate_DT(Cka(1))

        case (4)

          nMat = 2  ! alpha and beta Fock matrices

          nForb(1:nSym,:) = 0
          nIorb(1:nSym,1) = pNocc(2)%I1(1:nSym)
          nIorb(1:nSym,2) = pNocc(3)%I1(1:nSym)

          call CHO_LK_SCF(rc,nMat,FLT,KLT,nForb,nIorb,MSQ(2:3),DLT,FactX(2),nSCReen,dmpk,dFKmat)

        case default

          rc = 99
          write(u6,*) 'Illegal Input. Specified Cholesky Algorithm= ',ALGO
          call QUIT(rc)
      end select

      call Error_check(rc)

      if (DECO) call deallocate_DT(Vec(2))
      if (DECO) call deallocate_DT(Vec(1))

    end if

    ! To get the Fbeta in LT storage ----

    if ((ALGO < 3) .or. (ExFac == Zero)) FLT(2)%A0(:) = FLT(1)%A0(:)

    ! Accumulates Coulomb and Exchange contributions
    if ((ALGO < 3) .and. (ExFac /= Zero)) call CHO_SUM(rc,nSym,nBas,nD,DoExchange,FLT,FSQ)

    !-------------------------------------------------------------------
    call GADSum(FLT(1)%A0,nFLT)
    call GADSum(FLT(2)%A0,nFLT)

    ! --- Restore the Beta-density matrix ---
    ! Copy the lower triangular of DSQ(3))
    ! and pack the off-diagonal elements

    do isym=1,nsym
      do j=1,nBas(isym)
        do k=j,nBas(isym)
          kj = iTri(k,j)
          if (j == k) then
            DLT(1)%SB(iSym)%A1(kj) = DSQ(3)%SB(iSym)%A2(k,j)
          else ! packing of the matrix
            DLT(1)%SB(iSym)%A1(kj) = Two*DSQ(3)%SB(iSym)%A2(k,j)
          end if
        end do
      end do
    end do

    nullify(pNocc(1)%I1,pNocc(2)%I1,pNocc(3)%I1)
    call Deallocate_DT(MSQ(3))
    call Deallocate_DT(MSQ(2))
    call Deallocate_DT(MSQ(1))
    call Deallocate_DT(DSQ(3))
    call Deallocate_DT(DSQ(2))
    call Deallocate_DT(FSQ(3))
    call Deallocate_DT(FSQ(2))
    call Deallocate_DT(KLT(2))
    call Deallocate_DT(KLT(1))
    call Deallocate_DT(FLT(2))
    call Deallocate_DT(FLT(1))
    call Deallocate_DT(DLT(1))
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *

  call Error_check(rc)

  call mma_deallocate(nVec)

  return

end subroutine ChoSCF_Drv_Inner

subroutine Error_check(rc)

  integer(kind=iwp), intent(in) :: rc

  if (rc /= 0) then
    write(u6,*) 'CHOSCF_DRV. Non-zero return code.'
    call QUIT(rc)
  end if

end subroutine Error_check

end subroutine ChoSCF_Drv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine asc2ab2_cvb(detvec,nvec,nel,nalf,nbet,ndet)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nvec, nel, nalf, nbet, ndet
real(kind=wp), intent(inout) :: detvec(ndet,nvec)
integer(kind=iwp) :: inddet, iorb, rc
integer(kind=iwp), allocatable :: locc(:), maxdet(:), mindet(:), nkdet(:), xdet(:,:)
real(kind=wp), external :: party_cvb

call mma_allocate(mindet,[0,nel],label='mindet')
call mma_allocate(maxdet,[0,nel],label='maxdet')
call mma_allocate(nkdet,[0,nel],label='nkdet')
call mma_allocate(xdet,[0,nel],[0,nalf],label='xdet')
call mma_allocate(locc,nel,label='locc')

do iorb=0,nel
  mindet(iorb) = max(iorb-nbet,0)
  maxdet(iorb) = min(iorb,nalf)
end do
call weight_cvb(xdet,mindet,maxdet,nalf,nel)
nkdet(:) = maxdet(:)
call occupy_cvb(nkdet,nel,locc,locc(nalf+1))
inddet = 1
do
  detvec(inddet,:) = party_cvb(locc,nel)*detvec(inddet,:)
  call loind_cvb(nel,nalf,nkdet,mindet,maxdet,locc,locc(nalf+1),inddet,xdet,rc)
  if (rc == 0) exit
end do

call mma_deallocate(mindet)
call mma_deallocate(maxdet)
call mma_deallocate(nkdet)
call mma_deallocate(xdet)
call mma_deallocate(locc)

return

end subroutine asc2ab2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1992,1994,1996, Roland Lindh                      *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Tcrtnc(Coef1,n1,m1,Coef2,n2,m2,
     &                  Coef3,n3,m3,Coef4,n4,m4,
     &                  ACInt,mabcd,Scrtch,nScr,ACOut,
     &                  IndZet,lZeta,IndEta,lEta)
************************************************************************
*                                                                      *
* Object: to transform the integrals from primitives to contracted     *
*         basis functions. The subroutine will do both complete and    *
*         incomplete transformations.                                  *
*                                                                      *
*         Observe that ACInt and ACOut may overlap!!!!                 *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified to back transformation, January '92.            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
*
*---- Cache size
*
#include "lCache.fh"
      Real*8 Coef1(n1,m1), Coef2(n2,m2), Coef3(n3,m3), Coef4(n4,m4),
     &       ACInt(m1*m2*m3*m4,mabcd), Scrtch(nScr),
     &       ACOut(lZeta*lEta,mabcd)
      Integer IndZet(lZeta), IndEta(lEta)
*
      iRout = 18
      iPrint = nPrint(iRout)
      iPrint = 000000 !yma

*
!#ifdef _DEBUGPRINT_  !yma
      If (iPrint.ge.19) Call WrCheck('Tcrtnc:P(AB|CD)',ACInt,
     &                                m1*m2*m3*m4*mabcd)
      If (iPrint.ge.99) Then
         Call RecPrt(' In Tcrtnc: P(ab|cd)',' ',ACInt,mabcd,m1*m2*m3*m4)
         Call RecPrt(' Coef1',' ',Coef1,n1,m1)
         Call RecPrt(' Coef2',' ',Coef2,n2,m2)
         Call RecPrt(' Coef3',' ',Coef3,n3,m3)
         Call RecPrt(' Coef4',' ',Coef4,n4,m4)
         Write (6,*) n1, n2, n3, n4
      End If
!#endif
*
*---- Reduce for contraction matrix
      nCache = (3*lCache)/4 - n3*m3 - n4*m4
      lsize= m3*m4 + m3*n4
      nVec = m1*m2*mabcd
      IncVec = Min(Max(1,nCache/lsize),nVec)
      ipA3=1
      ipA2=ipA3 + nVec*lEta
*
*define _CHECK_
#ifdef _CHECK_
      If (nVec*lEta+n4*m3*IncVec.gt.nScr) Then
         Write (6,*) 'Tcrtnc: Memory failure 1'
         Write (6,*) 'n4*IncVec*m3(A2)=',n4*IncVec*m3
         Write (6,*) 'nVec*lEta(A3)=',nVec*lEta
         Write (6,*) 'n4,IndVec,m3=',n4,IndVec,m3
         Write (6,*) 'nVec,lEta=',nVec,lEta
         Write (6,*) 'nScr=',nScr
         Call Abend()
      End If
#endif

      Call TncHlf(Coef3,m3,n3,Coef4,m4,n4,lEta,nVec,
     &            IncVec,ACInt,Scrtch(ipA2),Scrtch(ipA3),IndEta)
*
      nCache = (3*lCache)/4 - n1*m1 - n2*m2
      lsize = m1*m2 + m1*n2
      nVec = mabcd*lEta
      IncVec = Min(Max(1,nCache/lsize),nVec)
*
#ifdef _CHECK_
      If (nVec*m1*m2+n2*IncVec*m1.gt.nScr) Then
         Write (6,*) 'Tcrtnc: Memory failure 2'
         Write (6,*) 'nVec*m1*m2(A1)=',nVec*m1*m2
         Write (6,*) 'n2*IncVec*m1(A2)=',n2*IncVec*m1
         Write (6,*) 'nVec,m1,m2=',nVec,m1,m2
         Write (6,*) 'n2,IncVec,m1=',n2,IncVec,m1
         Write (6,*) 'nScr=',nScr
         Call Abend()
      End If
#endif
*
      Call TncHlf(Coef1,m1,n1,Coef2,m2,n2,lZeta,nVec,
     &            IncVec,Scrtch(ipA3),Scrtch(ipA2),ACOut,IndZet)
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.59)
     &  Call RecPrt(' In Tcrtnc: P(ab|cd) ',' ',ACOut,mabcd,lZeta*lEta)
      If (iPrint.ge.19) Call WrCheck('Tcrtnc:P(ab|cd)',ACOut,
     &                                lZeta*lEta*mabcd)
#endif
*
*     Call GetMem('Tcrtnc','CHECK','REAL',iDum,iDum)
      Return
      End
      Subroutine Tnchlf(Coeff1,nCntr1,nPrm1,Coeff2,nCntr2,nPrm2,
     &                  lZeta,nVec,IncVec,A1,A2,A3,Indij)
************************************************************************
*                                                                      *
* Object: to do a half transformation. The loop over the two matrix-   *
*         matrix multiplications is segmented such that the end of the *
*         intermediate matrix will not push the start of the same out  *
*         from the cache.                                              *
*                                                                      *
* Author:     Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*                                                                      *
*             Modified to decontraction May 1996, by R. Lindh          *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 Coeff1(nPrm1,nCntr1), Coeff2(nPrm2,nCntr2),
     &       A1(nVec,nCntr1,nCntr2), A2(nPrm2,IncVec,nCntr1),
     &       A3(lZeta,nVec)
      Logical Seg1, Seg2
      Integer Indij(lZeta)
*
*-----Check if the basis set is segmented
*
      Seg1=.False.
      Do iPrm1 = nPrm1, 1, -1
         Do iCntr1 = nCntr1, 1, -1
            If (Coeff1(iPrm1,iCntr1).eq.Zero) Then
               Seg1=.True.
               Go To 10
            End If
         End Do
      End Do
 10   Continue
*
      Seg2=.False.
      Do iPrm2 = nPrm2, 1, -1
         Do iCntr2 = nCntr2, 1, -1
            If (Coeff2(iPrm2,iCntr2).eq.Zero) Then
               Seg2=.True.
               Go To 20
            End If
         End Do
      End Do
 20   Continue
*
*-----Set output matrix to zero
*
      Call FZero(A3,nVec*lZeta)
*
*-----Loop sectioning
*
      Do iiVec = 1, nVec, IncVec
         mVec = Min(IncVec,nVec-iiVec+1)
*--------Set intermediate matrix to zero
         Call FZero(A2,nPrm2*IncVec*nCntr1)
*
         If (Seg2) Then
*
*-----First quarter transformation, (x,AB) -> (b,x,a)
*
      Do iPrm2 = 1, nPrm2
         Do iCntr2 = 1, nCntr2
*-----------Check for zero due to segmented basis
            If (Abs(Coeff2(iPrm2,iCntr2)).gt.Zero) Then
               Do iCntr1 = 1, nCntr1
                  Do iVec = 1, mVec
                     A2(iPrm2,iVec,iCntr1) = A2(iPrm2,iVec,iCntr1) +
     &                 Coeff2(iPrm2,iCntr2)
     &                 *A1(iVec+iiVec-1,iCntr1,iCntr2)
                  End Do
               End Do
            End If
         End Do
      End Do
*
         Else    ! Seg2
*
      Do iPrm2 = 1, nPrm2
         Do iCntr2 = 1, nCntr2
            Do iCntr1 = 1, nCntr1
               Do iVec = 1, mVec
                  A2(iPrm2,iVec,iCntr1) = A2(iPrm2,iVec,iCntr1) +
     &              Coeff2(iPrm2,iCntr2)
     &              *A1(iVec+iiVec-1,iCntr1,iCntr2)
               End Do
            End Do
         End Do
      End Do
*
         End If   ! Seg2
*
         If (Seg1) Then
*
*-----Second quarter transformation
*
         Do iCntr1 = 1, nCntr1
            Do iZeta = 1, lZeta
               iPrm2=(Indij(iZeta)-1)/nPrm1 + 1
               iPrm1=Indij(iZeta)-(iPrm2-1)*nPrm1
*--------------Check for zero due to segmented basis
               If (Abs(Coeff1(iPrm1,iCntr1)).gt.Zero) Then
                  ijZeta=(iPrm2-1)*nPrm1 + iPrm1
                  Do iVec = iiVec, iiVec+mVec-1
                     A3(iZeta,iVec) = A3(iZeta,iVec) +
     &                 Coeff1(iPrm1,iCntr1)*
     &                 A2(iPrm2,iVec-iiVec+1,iCntr1)
                  End Do ! iVec
               End If
            End Do       ! iZeta
         End Do          ! iCntr1
*
         Else
*
*-----Second quarter transformation
*
         Do iCntr1 = 1, nCntr1
            Do iZeta = 1, lZeta
               iPrm2=(Indij(iZeta)-1)/nPrm1 + 1
               iPrm1=Indij(iZeta)-(iPrm2-1)*nPrm1
               Do iVec = iiVec, iiVec+mVec-1
                  A3(iZeta,iVec) = A3(iZeta,iVec) +
     &              Coeff1(iPrm1,iCntr1)*
     &              A2(iPrm2,iVec-iiVec+1,iCntr1)
               End Do ! iVec
            End Do    ! iZeta
         End Do       ! iCntr1
*
      End If
*
*-----End of loop sectioning
*
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRCTL_MCLR
      use Arrays, only: CMO
*
*     Two-electron integral transformation program: control section
*
*     Purpose: Set up of memory locations (decide if out of core is
*              needed. Loop over symmetry blocks of AO integrals.
*              The transformation routine TRAMO is called for each
*              symmetry block of integrals.
*
      IMPLICIT REAL*8 (A-H,O-Z)
*

#include "Input.fh"
      PARAMETER (LIOTAB=512*512)
#include "Pointers.fh"
#include "stdalloc.fh"
#include "Files_mclr.fh"
      integer toca(8,8,8),tocb(36,8),tocc(5,36,8)
      Save toca,tocB,tocc
      Integer, Allocatable:: Hlf1(:,:)
      Real*8, Allocatable:: Buffer(:)
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*
      CALL DANAME_wa(LUTRI1,FNTRI1)
      CALL DANAME_wa(LUTRI2,FNTRI2)
      CALL DANAME_wa(LUTRI3,FNTRI3)
      CALL DANAME_wa(LUTRI4,FNTRI4)
      CALL DANAME_wa(LUTRI5,FNTRI5)
      Call iCopy(8**3,[-1],0,toca,1)
      Call iCopy(8*36,[-1],0,tocb,1)
      Call iCopy(8*36,[-1],0,tocc,1)
      IAD14=0
      IAD13=0
      IAD23=0
      IAD24=0
      IAD34=0
      Call mma_allocate(Hlf1,LIOTAB,4,Label='Hlf1')
*
*     Precompute start points
*
*
*     Loop over quadruples of symmetries (nsp,nsq,nsr,nss)
*     Note that the integrals on LUTWOAO have to be sorted in the
*     same order as the loop structure below.
*
      Call mma_maxDBLE(MEMX)
      MEMX = MAX(MEMX-MEMX/10,0)
      Call mma_allocate(Buffer,MEMX,Label='Buffer')
      ipB=1
      IBATCH=0
      DO 104 iSP=1,NSYM
        NBP=NBAS(iSP)
        NAP=NASH(iSP)+nish(isp)
        nDP=nFro(iSP)!+nDel(iSP)
        DO 103 iSQ=1,iSP
          NBQ=NBAS(iSQ)
          NAQ=NASH(iSQ)+nish(isq)
          nDQ=nFro(iSQ)!+nDel(iSQ)
          NSPQ=IEOR(iSP-1,iSQ-1)+1
          DO 102 iSR=1,NSYM
            NBR=NBAS(iSR)
            NAR=NASH(iSR)+nish(isr)
            nDR=nFro(iSR)!+nDel(iSR)
            NSPQR=IEOR(NSPQ-1,iSR-1)+1
            DO 101 iSS=1,iSR
              NBS=NBAS(iSS)
              NAS=NASH(iSS)+nIsh(iSS)
              nDS=nFro(iSS)!+nDel(iSS)
              NSPQRS=IEOR(NSPQR-1,iSS-1)+1
*
*             Check the loop conditions and skip transformation step
*             if possible
*
              NORBP=NAP*NAQ+NAR*NAS+NAP*NAR+NAP*NAS+NAQ*NAR+NAQ*NAS
              NBPQRS=NBP*NBQ*NBR*NBS
              IF( NSPQRS.NE.1 ) GOTO 101
              IBATCH=IBATCH+1
              IF( NORBP.EQ.0 ) GOTO 101
              IF( NBPQRS.EQ.0 ) GOTO 101
              IF ( NAR+NAS.eq.0) Goto 101
*
*             Set up dynamic memory
*
              INTBUF=256*256
              ipi=ipB
              LW1=ipi
              NW1=MAX(NBP*NBQ,NBR*NBS)
              ipi=ipi+nw1
              LW2=ipi
              NW2=MAX(nBR*nAS,nAQ*nBP)
              ipi=ipi+nw2
              lw3=ipi
              NW3=MAX(nAR*nBS,nBQ*nAP)
              ipi=ipi+nw3
              lw4=ipi
              NW4=NAR*NAS
              ipi=ipi+nw4
              lw5=ipi
              NW5=MEMX-nw1-nw2-nw3-nw4
              iSPQ=iTri(iSR,iSS)
              iSRS=Max(iSP,iSQ)
              If (nAR*nAS.ne.0)
     &        TocB(iSPQ,iSRS)=iAD34
              If (nAQ*nAS.ne.0)
     &        TOCA(iSP,iSQ,iSR)=iAD24
              If (iSR.ne.iSS.and.nAQ*nAR.ne.0)
     &         TOCA(iSP,iSQ,iSS)=iAD23
              If (iSP.ne.iSQ.and.nAP*nAS.ne.0)
     &         TOCA(iSQ,iSP,iSR)=iAD14
              If (iSP.ne.iSQ.and.iSR.ne.iSS.and.nAP*nAR.ne.0)
     &         TOCA(iSQ,iSP,iSS)=iAD13
*
*             transform the symmetry block (ISP,ISQ|ISR,ISS)
*
              CALL TRAMO_MCLR
     &                   (INTBUF,
     &                   Buffer(LW1:LW1+NW1-1),NW1,
     &                   Buffer(LW2:LW2+NW2-1),NW2,
     &                   Buffer(LW3:LW3+NW3-1),NW3,
     &                   Buffer(LW4:LW4+NW4-1),NW4,
     &                   Buffer(LW5:LW5+NW5-1),NW5,
     &                   nBP,nBQ,nBR,nBS,iSP,iSQ,iSR,iSS,
     &                   nAP,nAQ,nAR,nAS,
     &                   CMO(ipCM(iSP)+nBP*nDP),
     &                   CMO(ipCM(iSQ)+nBQ*nDQ),
     &                   CMO(ipCM(iSR)+nBR*nDR),
     &                   CMO(ipCM(iSS)+nBS*nDS),
     &                   iAD13,iAD14,iAD23,iAD24,iAD34,
     &                   TocC(1,iSPQ,iSRS),
     &                   Hlf1(:,1),Hlf1(:,2),
     &                   Hlf1(:,3),Hlf1(:,4), LIOTAB)

*
*             End of loop over quadruples of symmetries
*
101         CONTINUE
102       CONTINUE
103     CONTINUE
104   CONTINUE
*
      CALL mma_deallocate(Buffer)
      Call mma_deallocate(Hlf1)
      Call DAName_wa(LUHLF2,FNHLF2)
      Call DAName_wa(LUHLF3,FNHLF3)
      Call DaEras(LUHLF2)
      Call DaEras(LUHLF3)
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine PickMO(COUT,nOut,nAcO,icmp,iBasi,iBasn,jBasj,jBasn,
     &                  kBask,kBasn,lBasl,lBasn,iaoii)
      use Basis_Info, only: nBas
      use SOAO_Info, only: iAOtSO
      use pso_stuff
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "etwas.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 COUT(nOut)
      Integer iCmp(4),iBas(4),nBs(4)
      Integer iTwoj(0:7),iAOii(4)
      Data iTwoj/1,2,4,8,16,32,64,128/
*
      iBas(1)=iBasi
      iBas(2)=jBasj
      iBas(3)=kBask
      iBas(4)=lBasl
      nBs(1)=iBasn
      nBs(2)=jBasn
      nBs(3)=kBasn
      nBs(4)=lBasn
      ip2=1
      nA=0
      Do iIrrep=0,nIrrep-1
          nA=nA+nAsh(iIrrep)
      End Do
      Do iCnt=3,4
         ipC=0
         Do iIrrep=0,nIrrep-1
            iOrb=nIsh(iIrrep)
            Do iAsh=1,nAsh(iIrrep)
               jj=iCmp(iCnt)
               Do i1=1,jj
                  iSO=iAOtSO(iAOii(iCnt)+i1,iIrrep)+iBas(iCnt)-1
                  If (iSO>0) Then
                     ip1=ipC+(iOrb+iAsh-1)*nBas(iIrrep)+iSO
                     call dcopy_(nBs(iCnt),CMO(ip1,1),1,COUT(ip2),1)
                  Else
                     call dcopy_(nBs(iCnt),[0.0d0],0,COUT(ip2),1)
                  End If
                  ip2=ip2+nBs(iCnt)
               End Do
            End Do
            ipc=ipc+nBas(iIrrep)**2
         End Do
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nAcO)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Roland Lindh                                     *
************************************************************************
      Subroutine TraClc_x(kOptim,opQNR,FrstDs,QNR1st,CInter,nCI,nD,
     &                    nOV,Lux,iter,memRsv,LLx)
      Implicit None
#include "real.fh"
#include "stdalloc.fh"
      Integer kOptim,nCI,nD,nOV,Lux,iter,memRsv,LLx
      Logical opQNR, FrstDs, QNR1st
      Real*8 CInter(nCI,nD)
      Real*8, Dimension(:,:), Allocatable:: Xn
*
      If (kOptim.eq.1) Return
*
*     Extrapolation case. Here we either work with
*
*     gradients: energy derivatives w.r.t the antisymmetric matrix, X,
*                which defines the orbital rotations, exp[P(X)]
*     or
*
*     displacements: del = -H^(-1)g, where g=dE/dX_m
*
      If (.NOT.opQNR) Then
*
*------  only DIIS, compute gradients
*
         If (FrstDs) Then
*           On first iteration compute all gradients and put them on
*           file.
            Call GrdClc('All',opQNR)
            FrstDs=.FALSE.
         Else
*           Compute just the last one.
            Call GrdClc('Lst',opQNR)
         End If
*
      Else If (QNR1st.AND.opQNR) Then
*
*------  1st QNR step, reset kOptim to 1
*
         kOptim = 1
         CInter(1,1) = One
         CInter(1,nD) = One
*
*        init 1st orb rot parameter X1 (set it to zero)
         Call mma_allocate(Xn,nOV,nD,Label='Xn')
         Call FZero(Xn,nOV*nD)
*        and store it on appropriate LList
         Call PutVec(Xn,nOV*nD,Lux,iter,MemRsv,'NOOP',LLx)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
         Write (6,*) 'TraClc_x: Initiate X(n), iter=',iter
         Call RecPrt('TraClc_x: X(n)',' ',Xn,1,nOV*nD)
         Write (6,*) 'TraClc_x: compute all gradients, call GrdClc'
#endif
         Call mma_deallocate(Xn)
*
*        compute actual gradient
         Call GrdClc('All',opQNR)
*
         QNR1st=.FALSE.
*
      Else If(opQNR) Then
*
*        Note that the required displacements are actually computed in
*        linser!
*
         Call GrdClc('Lst',opQNR)
*
      Else
*
         Write (6,*) 'TraClc_x: Illegal option'
         Call Abend()
*
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mreorg(wrk,wrksize,symp,symq,symr,typp,typq,typr,pospv2,posqv2,posrv2,typpv2,typqv2,typrv2,typv3,posv20,posv30,fact)
! this routine is up level routine for mreorg1 (also more detailed
! description can be found there).
! #2 must be of type 0, #3 can be 0, and 2
! this routine only prepares some constants, required by ireorg1,
! that can be deduced form input data - dimp,dimqr,dimt-dimv
!
! symp-r     - symmetries of p-r (I)
! typp-r     - types of indices p-r in V2 (I)
! posp-rv2   - positions of p-r ind. in V2 (I)
! typp-rv2   - types of indices, corresponding to p-r in V2 (I)
! typv3      - type of V3 (0,2) (I)
! posv20,30  - initial positions of V2 and V3 in wrk (I)
! fact       - multiplication factors (usually +-1.0) (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, symp, symq, symr, typp, typq, typr, pospv2, posqv2, posrv2, typpv2, typqv2, typrv2, &
                                 typv3, posv20, posv30
real(kind=wp), intent(inout) :: wrk(wrksize)
real(kind=wp), intent(in) :: fact
integer(kind=iwp) :: dimp, dimqr, ind(4), mhelp, nhelp, rc

! define dimensions of V2

call ireorg2(symp,typpv2,nhelp,rc)
ind(pospv2) = nhelp
call ireorg2(symq,typqv2,nhelp,rc)
ind(posqv2) = nhelp
call ireorg2(symr,typrv2,nhelp,rc)
ind(posrv2) = nhelp

! def dimp,dimqr

call ireorg2(symp,typp,dimp,rc)

call ireorg2(symq,typq,nhelp,rc)
call ireorg2(symr,typr,mhelp,rc)

if ((typv3 == 2) .and. (symq == symr)) then
  dimqr = (nhelp*(nhelp-1))/2
else
  dimqr = nhelp*mhelp
end if

! use mreorg1

call mreorg1(symp,symq,symr,typp,typq,typr,pospv2,posqv2,posrv2,typpv2,typqv2,typrv2,typv3,wrk(posv20),wrk(posv30),fact,dimp, &
             dimqr,ind(1),ind(2),ind(3))

return

end subroutine mreorg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
c  *******************************************
c  ** Front-end routines for INPUT and MAIN **
c  *******************************************
      subroutine casvb(ireturn)
      implicit real*8 (a-h,o-z)
#include "rasscf_lucia.fh"
C
      call cvbinp_cvb(0,5)
      call cvbmn_cvb(0)
      call make_close_cvb(1)
      ireturn=0
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1997, Jeppe Olsen                                 *
!               2015, Lasse Kragh Soerensen                            *
!***********************************************************************

subroutine RASSG3(CB,SB,NBATS,LBATS,I1BATS,IBATS,LUC,LUHC,I_AM_OUT,N_ELIMINATED_BATCHES)
! Direct RAS routine employing combined MOC/n-1 resolution method
!
! Jeppe Olsen   Winter of 1991
!               May 1997 : Connected to SBLOCK
!
! Lasse Soerensen October 2015
!                 Do not calculate unwanted batches for highly
!                 excited states.

use lucia_data, only: IDISK
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: CB(*)
real(kind=wp), intent(_OUT_) :: SB(*)
integer(kind=iwp), intent(in) :: NBATS, LBATS(*), I1BATS(*), IBATS(8,*), LUC, LUHC, I_AM_OUT(*), N_ELIMINATED_BATCHES
integer(kind=iwp) :: DUM(1), I, I_AM_NOT_WANTED, IEND, ILEN, IOFF, ISBLK, ISBOFF, ISTA, JBATS, NSB
integer(kind=iwp), allocatable :: SBOFF(:), SBSIZ(:)

#ifdef _DEBUGPRINT_
write(u6,*) ' ================='
write(u6,*) ' RASSG3 speaking :'
write(u6,*) ' ================='
write(u6,*) ' RASSG3 : NBATS = ',NBATS
#endif

!SVC: Compute offsets of a sigma batch in the sigma array.
!     The batches used inside sblock(s) use a batch size corresponding
!     to the 'expanded form' as computed inside part_civ2. This is
!     stored inside 7th element of IBATS. Later, the size that needs to
!     be actually written to disc uses the 'packed form', stored inside
!     the 8th element of IBATS. This also computes the total size NSB.

call mma_allocate(SBSIZ,NBATS,Label='SBSIZ')
call mma_allocate(SBOFF,NBATS,Label='SBOFF')

NSB = 0
do JBATS=1,NBATS
  ISTA = I1BATS(JBATS)
  IEND = I1BATS(JBATS)+LBATS(JBATS)-1
  SBSIZ(JBATS) = sum(IBATS(7,ISTA:IEND))
  NSB = NSB+SBSIZ(JBATS)
end do
SBOFF(1) = 1
do JBATS=2,NBATS
  SBOFF(JBATS) = SBOFF(JBATS-1)+SBSIZ(JBATS-1)
end do

!SVC: the entire sigma array is zeroed here, because each process will
!     zero only its own sigma blocks, and we need to do a global sum
!     operations later to combine blocks before writing.
SB(1:NSB) = Zero

do JBATS=1,NBATS

  ! Lasse addition start
  ! MGD here we try to remove the whole batch if possible
  ! later, we will put to zero individual blocks in case
  ! the batch had a mix of maximum and non-maximum occupation
  ! and thus survived this test

  I_AM_NOT_WANTED = 0
  do ISBLK=I1BATS(JBATS),I1BATS(JBATS)+LBATS(JBATS)-1
    I_AM_NOT_WANTED = 0
    do I=1,N_ELIMINATED_BATCHES
      if (I_AM_OUT(I) == ISBLK) then
        I_AM_NOT_WANTED = 1
        exit
      end if
    end do
    if (I_AM_NOT_WANTED == 0) exit
  end do
  if (I_AM_NOT_WANTED == 1) cycle

  ! Lasse addition end


  ISBOFF = SBOFF(JBATS)
  ! Obtain sigma for batch of blocks
  call SBLOCK(LBATS(JBATS),IBATS(1,I1BATS(JBATS)),1,CB,SB(ISBOFF),LUC,0,0,0,0,0)

end do

call GADSUM(SB,NSB)
!SVC: Write sigma array to disk here, after sum reduction.
!     The writing is done in consecutive blocks, but since I don't know
!     if this block structure is used internally, I didn't optimize this.
if (LUHC > 0) IDISK(LUHC) = 0
do JBATS=1,NBATS
  ISBOFF = SBOFF(JBATS)
  do ISBLK=I1BATS(JBATS),I1BATS(JBATS)+LBATS(JBATS)-1
    IOFF = IBATS(6,ISBLK)
    ILEN = IBATS(8,ISBLK)
    DUM(1) = ILEN
    call ITODS(DUM,1,-1,LUHC)
    !MGD zero afterwards since it is easier
    I_AM_NOT_WANTED = 0
    do I=1,N_ELIMINATED_BATCHES
      if (I_AM_OUT(I) == ISBLK) then
        I_AM_NOT_WANTED = 1
        exit
      end if
    end do
    if (I_AM_NOT_WANTED == 1) SB(ISBOFF-1+IOFF:ISBOFF-1+IOFF+ILEN-1) = Zero

    call TODSC(SB(ISBOFF-1+IOFF),ILEN,-1,LUHC)
  end do
end do

call mma_deallocate(SBSIZ)
call mma_deallocate(SBOFF)

DUM(1) = -1
call ITODS(DUM,1,-1,LUHC)

#ifdef _DEBUGPRINT_
write(u6,*) ' Final S-vector on disc'
call WRTVCD(SB,LUHC,1,-1)
#endif

end subroutine RASSG3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CD_AInv_Inner(n,m,ADiag,Lu_A,Lu_Q,Thr_CD)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n, Lu_A
integer(kind=iwp), intent(out) :: m
real(kind=wp), intent(inout) :: ADiag(n)
integer(kind=iwp), intent(inout) :: Lu_Q
real(kind=wp), intent(in) :: Thr_CD
integer(kind=iwp) :: iAddr, iAddr_, iOff, kCol, kQm, lAm, LinDep, lQm, lScr, Lu_Z, MaxMem, MaxMem2, mb, mQm, nAm, nB, nBfn2, &
                     nBfnTot, nDim, nMem, nQm, nQm_full, nScr, nVec, nXZ
real(kind=wp) :: a, b, Thr, ThrQ
logical(kind=iwp) :: Out_of_Core
integer(kind=iwp), allocatable :: iADiag(:)
real(kind=wp), allocatable :: Scr(:), Z(:), X(:)
real(kind=wp), allocatable, target :: Qm(:), Am(:), Q_k(:), A_k(:)
real(kind=wp), pointer :: Q_l(:), A_l(:)

nScr = 3*n
call mma_maxDBLE(MaxMem)
lScr = min(MaxMem,nScr)
call mma_allocate(Scr,lScr,Label='Scr')
call mma_allocate(iADiag,n,Label='iADiag')

nDim = n

Thr = Thr_CD*0.1_wp
Lu_Z = 7
call DaName_MF_WA(Lu_Z,'ZMAT09')
call Get_Pivot_idx(ADiag,nDim,nVec,Lu_A,Lu_Z,iADiag,Scr,lScr,Thr)
m = nVec
if (nDim /= nVec) then
  write(u6,*)
  write(u6,*) 'Detected lin. dep. in the auxiliary basis'
  write(u6,'(A,I6)') ' # of aux. bfns before lin. dep. removal: ',nDim
  write(u6,'(A,I6)') ' # of aux. bfns after  lin. dep. removal: ',nVec
end if

call Pivot_Mat(nDim,nVec,Lu_A,Lu_Z,iADiag,Scr,lScr)

call mma_deallocate(Scr)

!***********************************************************************
!     A-vectors are now on disk. Go ahead and compute the Q-vectors!
!***********************************************************************

ThrQ = Thr_CD*0.1_wp ! Threshold for Inv_Cho_Factor

nB = nVec
if (nB /= 0) then
  nQm = nTri_Elem(nB)

  nXZ = nB
  nQm_full = nTri_Elem(nB)

  Out_of_Core = 2*nQm_full+5*nXZ > MaxMem

  if (Out_Of_Core) then
    mQm = (nQm*MaxMem-5*nXZ)/(2*nQm_full)
    a = One
    b = -Two*real(mQm,kind=wp)
    mB = int(-a*Half+sqrt((a*Half)**2-b))
    kQm = nTri_Elem(mB)
    if (kQm > mQm) then
      call WarningMessage(2,'Error in CD_AInv_Inner')
      write(u6,*) 'kQm > mQm!'
      write(u6,*) 'MaxMem=',MaxMem
      write(u6,*) 'nQm,mQm,kQm=',nQm,mQm,kQm
      write(u6,*) 'nB,mB=',nB,mB
      call Abend()
    end if
  else
    mB = nB
    kQm = nQm
  end if

  lQm = kQm
  lAm = lQm

  if (lQm < 1) then
    call WarningMessage(2,'Error in CD_AInv_Inner')
    write(u6,*) 'lQm < 1'
    call Abend()
  end if

  ! Some of memory for scratch arrays for Inv_Cho_Factor
  ! Allocate memory for the A- and Q-vectors and initialize.

  lScr = nXZ
  call mma_allocate(Scr,lScr,Label='Scr')
  call mma_allocate(Qm,lQm,Label='Qm')
  call mma_allocate(Am,lAm,Label='Am')
  call mma_allocate(A_k,nXZ,Label='A_k')
  call mma_allocate(Q_k,nXZ,Label='Q_k')
  call mma_allocate(X,nXZ,Label='X')
  call mma_allocate(Z,nXZ,Label='Z')

  Am(:) = Zero
  Qm(:) = Zero
  !                                                                    *
  !--------------------------------------------------------------------*
  !                                                                    *
  ! Process the A_ks to generate Q_ks.

  iAddr = 0
  nMem = mB
  do kCol=1,nB

    iAddr_ = iAddr
    if (kCol <= nMem) then
      iOff = nTri_Elem(kCol-1)
      ! Point to A_k in Am
      A_l(1:kCol) => Am(iOff+1:iOff+kCol)
      if (kCol == 1) then
        nAm = nTri_Elem(nMem)
        call dDaFile(Lu_Z,2,Am,nAm,iAddr_)
      end if
      ! Point to Q_k in Qm
      Q_l(1:kCol) => Qm(iOff+1:iOff+kCol)
    else if (kCol > nMem) then
      ! Use special scratch for A_k
      A_l(1:kCol) => A_k(1:kCol)
      call dDaFile(Lu_Z,2,A_l,kCol,iAddr_)
      ! Use special scratch for Q_k
      Q_l(1:kCol) => Q_k(1:kCol)
    end if

    LinDep = 2
    call Inv_Cho_Factor(A_l,kCol,Am,Qm,nMem,Lu_Z,Lu_Q,Scr,lScr,Z,X,ThrQ,Q_l,LinDep)

    if (LinDep /= 0) then
      call WarningMessage(2,'Error in CD_AInv_Inner')
      write(u6,*) 'Inv_Cho_Factor found linear dependence!'
      call Abend()
    end if

    ! Write the new A/Q-vector to file

    iAddr_ = iAddr
    if (kCol == nMem) then
      nQm = nTri_Elem(kCol)
      call dDaFile(Lu_Q,1,Qm,nQm,iAddr)
      call dDaFile(Lu_Z,1,Am,nQm,iAddr_)
    else if (kCol > nMem) then
      call dDaFile(Lu_Q,1,Q_l,kCol,iAddr)
      call dDaFile(Lu_Z,1,A_l,kCol,iAddr_)
    end if

  end do

  nullify(Q_l,A_l)
  call mma_deallocate(X)
  call mma_deallocate(Z)
  call mma_deallocate(Q_k)
  call mma_deallocate(A_k)
  call mma_deallocate(Am)
  call mma_deallocate(Qm)
  call mma_deallocate(Scr)
end if
call DaEras(Lu_Z)
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Sort the Q-matrix back to the original order.

call mma_maxDBLE(MaxMem2)

nBfnTot = n
nBfn2 = n**2
lScr = min(MaxMem2,max(nBfn2,2*nBfnTot))
call mma_allocate(Scr,lScr,Label='Scr')

call Restore_Mat(nDim,nVec,Lu_Q,Lu_A,iADiag,Scr,lScr,.true.)
call DaEras(Lu_Q)
Lu_Q = Lu_A

! Note: after the 'Restore' call to Sort_mat, the Q-matrix is
!       no longer stored as upper-triangular but as squared
!       (zeros have been added because the corresponding argument
!        is set to .true.). The column index is still pivoted.

call mma_deallocate(Scr)
call mma_deallocate(iADiag)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
return

end subroutine CD_AInv_Inner

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE NATCT(H,LIC0)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION H(LIC0)
      Character*72 Header
      Dimension Dummy(1),iDummy(7,8)
*
      NSUM =0
      N2SUM=0
      n2Tri = 0
      nbMax = 0
      DO 9 ISYM=1,NSYM
         nbMax = Max(nbMax,nBas(iSym))
         NSUM =NSUM +NBAS(ISYM)
         N2SUM=N2SUM+NBAS(ISYM)**2
         n2Tri = n2Tri + nBas(iSym)*(nBas(iSym)+1)/2
9     CONTINUE

*     Read MO coefficients
      IDISK=ITOC17(1)
      CALL dDAFILE(Lu_TraOne,2,H(LW(87)),N2SUM,IDISK)
      IF (LW(87)+N2SUM-1.ge.LW(88)) THEN
         WRITE(6,*)
         WRITE(6,'(6X,A)')'*** ERROR IN SUBROUTINE NATCT ***'
         WRITE(6,'(6X,A)')'NO SPACE LEFT TO GENERATE FINAL ORBITALS'
         WRITE(6,*)
      CALL XFLUSH(6)
         Call Abend
      ENDIF
*
*     Loop over irreps and compute natural orbitals
*
      IOCC=LW(90)
      ICMO=LW(87)
      DO 10 M=1,NSYM
*        set occupation number of orbitals prefrozen in MOTRA
         CALL DCOPY_(NBAS(M),[0.0D0],0,H(IOCC),1)
*        skip orbitals prefrozen in MOTRA
         CALL DCOPY_(NPFRO(M),[2.0D0],0,H(IOCC),1)
         CALL NATORB_CPF(H(LW(62)),H(ICMO+NBAS(M)*NPFRO(M)),H(LW(88)),
     &               H(LW(89)),H(LW(89)),H(IOCC+NPFRO(M)),M)
         CALL DCOPY_(NORB(M)*NBAS(M),H(LW(89)),1,
     &              H(ICMO+NBAS(M)*NPFRO(M)),1)
         ICMO=ICMO+NBAS(M)**2
         IOCC=IOCC+NBAS(M)
10    CONTINUE

      LW91A = LW(91)
      LW91B = LW91A + n2Sum
      If (LW91B+n2Tri-1.gt.Lic) Then
         WRITE(6,*) ' Not enough core in NATCT'
      CALL XFLUSH(6)
         Call ErrTra
         Call Abend
      End If
      Call RelEne(ErelMV,ErelDC,nSym,nBas,H(LW(87)),
     *            H(LW(90)),H(LW91A),H(LW91B))

      EREL=ERELMV+ERELDC
      WRITE(6,'(/,5X,A)') 'FIRST ORDER RELATIVISTIC CORRECTIONS'
      WRITE(6,'(5X,A,F17.8)')
     *            'MASS-VELOCITY        ', ErelMV
      WRITE(6,'(5X,A,F17.8)')
     *            '1-EL DARWIN CONTACT  ', ErelDC
      WRITE(6,'(5X,A,F17.8)')
     *            'TOTAL REL. CORRECTION', Erel
      IF (ISDCI.EQ.1) THEN
        WRITE(6,'(5X,A,F17.8)')
     *            'REL. CI ENERGY       ', ETOT+Erel
        WRITE(6,'(5X,A,F17.8)')
     *            'REL. CI+Q ENERGY     ',DETOT+Erel
      ELSE
        WRITE(6,'(5X,A,F17.8)')
     *            'TOTAL REL. ENERGY    ', ETOT+Erel
      END IF
      CALL XFLUSH(6)
      CALL dPRWF(H)
      If (iCPF.eq.1) Then
         Header=' CPF natural orbitals'
      Else If (iSDCI.eq.1) Then
         Header=' SDCI natural orbitals'
      Else If (iNCPF.eq.1) Then
         Header=' ACPF natural orbitals'
      Else
         Header=' MCPF natural orbitals'
      End If
      Call Primo(Header,.True.,.False.,1.0D-4,dum,nSym,nBas,nBas,
     *           Name,Dummy,H(LW(90)),H(LW(87)),-1)
*
*     Read the overlap matrix in ao basis
      iiRC=-1
      iOpt = 6
      Call RdOne(iiRC,iOpt,'MLTPL  0',1,H(LW(91)),iDum)
      If (iiRC.ne.0) Then
         Write (6,*) 'Natct: Error reading overlap matrix!'
         Call Abend
      End If
      Call Charge(nSym,nBas,Name,H(LW(87)),H(LW(90)),H(LW(91)),2,.True.,
     &            .True.)
      Call Prpt_old(nSym,nBas,nSum,n2Sum,H(LW(87)),H(LW(90)),
     *          Lic-LW(92)+1,H(LW(92)))
*
      If (iCPF.eq.1) Then
         Header='* CPF NO COEFS'
      Else If (iSDCI.eq.1) Then
         Header='* SDCI NO COEFS'
      Else If (iNCPF.eq.1) Then
         Header='* ACPF NO COEFS'
      Else
         Header='* MCPF NO COEFS'
      End If
      Call WrVec('CPFORB',Lu_CPFORB,'CO',nSym,nBas,nBas,
     & H(LW(87)), H(LW(90)), Dummy, iDummy, Header)
*
      RETURN
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE dPRWF(H)
      USE ISO_C_BINDING
      REAL*8, TARGET :: H(*)
      INTEGER, POINTER :: iH1(:),iH2(:),iH3(:)
      CALL C_F_POINTER(C_LOC(H(LW(1))),iH1,[1])
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL PRWF_CPF(iH1,iH2,iH3,H(LW(26)))
      NULLIFY(iH1,iH2,iH3)
      END SUBROUTINE dPRWF
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1992,2008, Roland Lindh                           *
!***********************************************************************

subroutine Mk_ChDisp()
!***********************************************************************
!                                                                      *
! Object: To generate the displacement labels
!                                                                      *
! Called from: Gateway
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             September '91                                            *
!                                                                      *
!             Modified to complement GetInf, January '92.              *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp) :: iCar, iCnt, iCnttp, iComp, iDisp, iIrrep, mc, mdc, mDisp, nCnttp_Valence, nDisp(0:7)
logical(kind=iwp) :: TstFnc
integer(kind=iwp), allocatable :: DegDisp(:)
character(len=LenIn6), allocatable :: ChDisp(:)
character, parameter :: xyz(0:2) = ['x','y','z']

!                                                                      *
!***********************************************************************
!                                                                      *
nCnttp_Valence = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux) exit
  nCnttp_Valence = nCnttp_Valence+1
end do

mDisp = 0
mdc = 0
do iCnttp=1,nCnttp_Valence
  if (dbsc(iCnttp)%pChrg) then
    mdc = mdc+dbsc(iCnttp)%nCntr
    cycle
  end if
  do iCnt=1,dbsc(iCnttp)%nCntr
    mdc = mdc+1
    mDisp = mDisp+3*(nIrrep/dc(mdc)%nStab)
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(ChDisp,mDisp,label='ChDisp')
call mma_allocate(DegDisp,mDisp,label='DegDisp')
iDisp = 0
do iIrrep=0,nIrrep-1
  ! Loop over basis function definitions
  mdc = 0
  mc = 1
  nDisp(iIrrep) = 0
  do iCnttp=1,nCnttp_Valence
    ! Loop over unique centers associated with this basis set.
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      ! Loop over the cartesian components
      do iCar=0,2
        iComp = 2**iCar
        if (TstFnc(dc(mdc)%iCoSet,iIrrep,iComp,dc(mdc)%nStab) .and. (.not. dbsc(iCnttp)%pChrg)) then
          iDisp = iDisp+1
          ChDisp(iDisp) = ' '
          write(ChDisp(iDisp)(1:(LenIn6)),'(A,1X,A1)') dc(mdc)%LblCnt(1:LenIn4),xyz(iCar)
          DegDisp(iDisp) = nIrrep/dc(mdc)%nStab
          nDisp(iIrrep) = nDisp(iIrrep)+1
        end if

      end do
      mc = mc+nIrrep/dc(mdc)%nStab
    end do
  end do

end do

if (iDisp /= mDisp) then
  call WarningMessage(2,' Wrong number of symmetry adapted displacements')
  write(u6,*) iDisp,'=/=',mDisp
  call Abend()
end if

call Put_iScalar('nChDisp',iDisp)
call Put_cArray('ChDisp',ChDisp(1),LenIn6*iDisp)
call Put_iArray('nDisp',nDisp,nIrrep)
call Put_iArray('DegDisp',DegDisp,iDisp)
call mma_deallocate(ChDisp)
call mma_deallocate(DegDisp)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Mk_ChDisp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Export1(iFinal,CMO,DA,PA,DAO,Focc)
!***********************************************************************
!                                                                      *
!     purpose: Save all information relevant to geometry               *
!              optimizations                                           *
!                                                                      *
!     calling arguments:                                               *
!     iFinal  : Switch including routing information                   *
!     CMO     : MO coefficients in last CI                             *
!     DA      : 1-density of active orbitals                           *
!     PA      : 2-density of active orbitals                           *
!                                                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1994                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************
!
use gas_data, only: iDoGAS
use rasscf_global, only: DoDMRG, iRLXRoot, KSDFT, NAC, NACPAR, NACPR2, nRoots, ThrSX, ThrTE, Weight
use general_data, only: NACTEL, NSYM, NHOLE1, NELEC3, NASH, NDEL, NFRO, NISH, NTOT1, NTOT2
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iFinal
real(kind=wp), intent(in) :: CMO(*), DA(*), PA(*), DAO(*), Focc(*)
integer(kind=iwp) :: i, iR, iRLXRoot1, iRLXRoot2, iSA, nTemp(8), nW
real(kind=wp) :: Dum(1), Tmp
logical(kind=iwp) :: Found, SCF
character(len=16) :: mstate
character(len=8) :: Method, RlxLbl

!----------------------------------------------------------------------*
!     Save information pertinent to the gradient calculation           *
!----------------------------------------------------------------------*
!...  Add elementary information ......................................*
SCF = .false.
if ((nac == 0) .or. (2*nac == nactel)) SCF = .true.

if (SCF) then
  nTemp(1:nSym) = nAsh(1:nSym)+nIsh(1:nSym)
  call Put_iArray('nIsh',nTemp,nSym)
  nTemp(1:nSym) = 0
  call Put_iArray('nAsh',nTemp,nSym)
else
  call Put_iArray('nIsh',nIsh,nSym)
  call Put_iArray('nAsh',nAsh,nSym)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Find the correct method label

Method = 'CASSCF  '
if (KSDFT /= 'SCF') Method = 'CASDFT  '

! Set flags for State-Average or Single root

if (nRoots /= 1) then

  ! iSA=-1 non-equivalent multi state SA-CASSCF
  ! iSA=0  equivalent multi state SA-CASSCF
  ! iSA=2  single root SA-CASSCF

  Method = 'CASSCFSA'

  ! Check if equal weight SA-CASSCF

  iSA = 0
  do iR=2,nRoots
    if (Weight(1) /= Weight(iR)) iSA = -1
  end do
  if (iSA /= 0) then

    ! Check if SA-CASSCF is optimized for just one root.

    nW = 0
    do iR=1,nRoots
      if (Weight(iR) /= Zero) nW = nW+1
    end do
    if (nW == 1) iSA = 2
  end if
  call Put_iScalar('SA ready',iSA)
  if ((iSA == 0) .or. (iSA == -1)) then
    mstate = '****************'
    call Put_cArray('MCLR Root',mstate,16)
  end if
end if

! Check if it is a RASSCF function and not a CASSCF
if ((nHole1 /= 0) .or. (nElec3 /= 0)) Method(1:1) = 'R'
! Check if it is a GASSCF function
if (iDoGAS) Method(1:1) = 'G'
! Check if it is a DMRGSCF function
if (doDMRG) then
  Method = 'DMRGSCF '
  if (nroots /= 1) Method = 'DMRGSCFS'
end if

call Put_cArray('Relax Method',Method,8)
!                                                                      *
!***********************************************************************
!                                                                      *
call Get_iScalar('nSym',i)
call Put_iArray('nFro',nFro,i)
call Put_iArray('nDel',nDel,i)
!...  Add MO-coefficients .............................................*
call Put_dArray('Last orbitals',CMO,NTOT2)
!...  Add one body density matrix in AO/SO basis ......................*
call Put_dArray('D1ao',DAO,NTOT1)
!...  Remove the variational density if it exists .....................*
call Put_dArray('D1aoVar',DAO,0)
!...  Add one body density matrix in MO, active orbitals only .........*
call Put_dArray('D1mo',DA,NACPAR)
!...  Add two body density matrix in MO basis, active orbitals only ...*
if (.not. SCF) call Put_dArray('P2mo',PA,NACPR2)
!...  Next version of MOLCAS add the state to relax file ..............*
call Qpg_iScalar('Relax Original root',Found)
if (Found) then
  call Get_iScalar('Relax Original root',irlxroot1)
  call Get_iScalar('Relax CASSCF root',irlxroot2)
  if (irlxroot1 == irlxroot2) call Put_iScalar('Relax Original root',irlxroot)
else
  call Put_iScalar('Relax Original root',irlxroot)
end if
call Put_iScalar('Relax CASSCF root',irlxroot)
!...  Remove overlaps (computed by rassi) .............................*
call Put_darray('State Overlaps',Dum,0)
call Put_lscalar('Track Done',.false.)
!...  Add generalized Fock matrix .....................................*
if (ifinal >= 1) then
  call Put_dArray('FockOcc',Focc,ntot1)
  RlxLbl = 'Thrs    '
  tmp = max(thrte,thrsx)
  call put_dscalar(RlxLbl,tmp)
end if
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine Export1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NUMST4_MCLR(NEL,NORB1,NEL1MN,NEL1MX,NORB2,
     &                  NORB3,NEL3MN,NEL3MX,NSTTP)
*
* Number of strings per type for class of strings with
*
* Between NEL1MN AND NEL1MX electrons in the first NORB1 orbitals
* Between NEL3MN AND NEL3MX electrons in the last  NORB3 orbitals
*
      INTEGER NSTTP(*)
      NTEST = 0
      NSTRIN = 0
*
      IF(NTEST.GE.10) THEN
        WRITE(6,*) ' NUMST4 '
        WRITE(6,*) ' NEL NEL1MN NEL1MX NEL3MN NEL3MX '
        WRITE(6,*) NEL,NEL1MN,NEL1MX,NEL3MN,NEL3MX
      END IF
*
      ITPMAX = 0
      DO 100 IEL1 = NEL1MN,MIN(NEL1MX,NORB1,NEL)
        NSTIN1 = IBION(NORB1,IEL1)
        IEL3MN = MAX ( NEL3MN,NEL-(IEL1+NORB2) )
        IEL3MX = MIN ( NEL3MX,NEL-IEL1)
        DO 80 IEL3 = IEL3MN, IEL3MX
         IEL2 = NEL - IEL1-IEL3
         NSTINT = NSTIN1*IBION(NORB2,IEL2)*IBION(NORB3,IEL3)
         NSTRIN = NSTRIN + NSTINT
         ITP = (NEL1MX-IEL1)
     &         * (NEL3MX-NEL3MN+1)
     &         + IEL3-NEL3MN + 1
         NSTTP(ITP) = NSTINT
         ITPMAX= MAX(ITPMAX,ITP)
  80   CONTINUE
 100  CONTINUE
*
      IF( NTEST .GE.1 ) THEN
      WRITE(6,'(/A,I6)') '  Number of strings generated ... ', NSTRIN
         WRITE(6,*)
         WRITE(6,*) ' Largest type number ', ITPMAX
         WRITE(6,*) ' Number of strings per type '
         CALL IWRTMA(NSTTP,1,ITPMAX,1,ITPMAX)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifdef _IN_MODULE_

subroutine Do_GGL(L_Eff,mPt,R)
!***********************************************************************
!                                                                      *
!     Computes data useful for the angular quadrature.                 *
!                                                                      *
!***********************************************************************

use nq_Grid, only: Pax
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: L_Eff
integer(kind=iwp), intent(out) :: mPt
real(kind=wp), allocatable, intent(out) :: R(:,:)
integer(kind=iwp) :: iOff, iPhi, iTheta, nPhi, nTheta
real(kind=wp) :: Cos_Phi, Cos_Theta, Sin_Phi, Sin_Theta, w_Phi, w_Theta, x, y, z
real(kind=wp), allocatable :: Th(:,:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Generate angular grid from Gauss and Gauss-Legendre quadrature
!
!-- Theta (polar angle): 0 <= theta <= pi
!   Gauss-Legendre Quadrature (L_Quad+1)/2 points
!-- Phi (azimuthal angle): 0 <= phi <= 2*pi
!   Gauss-Quadrature (L_Quad+1) points
!
nTheta = (L_Eff+1)/2
nPhi = L_Eff+1

mPt = nTheta*nPhi
call mma_allocate(R,4,mPt,Label='R')

call mma_allocate(Th,2,nTheta,Label='Th')

call GauLeg(-One,One,Th,nTheta)

iOff = 1
do iTheta=1,nTheta
  Cos_Theta = Th(1,iTheta)
  w_Theta = Th(2,iTheta)
  Sin_Theta = sqrt(One-Cos_Theta**2)

  do iPhi=1,nPhi
    call Phi_point(iPhi,nPhi,Cos_Phi,Sin_Phi,w_Phi)

    x = Sin_Theta*Cos_Phi
    y = Sin_Theta*Sin_Phi
    z = Cos_Theta
    R(1,iOff) = Pax(1,1)*x+Pax(1,2)*y+Pax(1,3)*z
    R(2,iOff) = Pax(2,1)*x+Pax(2,2)*y+Pax(2,3)*z
    R(3,iOff) = Pax(3,1)*x+Pax(3,2)*y+Pax(3,3)*z
    R(4,iOff) = w_Theta*w_Phi
    iOff = iOff+1

  end do ! iPhi

end do   ! iTheta

call mma_deallocate(Th)
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Do_GGL

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Matthew R. Hennefarth                            *
!***********************************************************************

subroutine P2_contraction(D1MO,P2MO)

use Index_Functions, only: iTri
use rasscf_global, only: NAC, NACPAR, NACPR2
use Constants, only: One, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: d1mo(NACPAR)
real(kind=wp), intent(out) :: p2mo(NACPR2)
integer(kind=iwp) :: i, ij, ijkl, j, k, kl, l, lmax
real(kind=wp) :: fact

ijkl = 0
do i=1,nac
  do j=1,i
    ij = iTri(i,j)
    do k=1,i
      if (i == k) then
        lmax = j
      else
        lmax = k
      end if
      do l=1,lmax
        kl = iTri(k,l)
        ijkl = ijkl+1
        fact = One
        if (k == l) fact = Half
        p2MO(ijkl) = fact*D1MO(ij)*D1MO(kl)
      end do
    end do
  end do
end do

end subroutine P2_contraction

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE IPO_CPF(IPOA,NVIR,MUL,NSYM,KLS,IFT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IPOA(*),NVIR(*),MUL(8,8)
      NSUM=0
      DO 10 N=1,NSYM
      IPOA(N)=NSUM
      M=MUL(N,KLS)
      IF(IFT.GE.0)GO TO 20
      NSUM=NSUM+NVIR(N)*NVIR(M)
      GO TO 10
20    IF (N-M.LT.0) THEN
        GO TO 10
      ELSE IF (N-M.EQ.0) THEN
        GO TO 11
      ELSE
        GO TO 12
      END IF
11    NSUM=NSUM+NVIR(N)*(NVIR(N)+1)/2
      GO TO 10
12    NSUM=NSUM+NVIR(N)*NVIR(M)
10    CONTINUE
      IPOA(NSYM+1)=NSUM
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine cvbfinit_cvb()

use casvb_global, only: corenrg, iprec, is_set, iwidth, mxaobf
use Molcas, only: MaxBfn
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), parameter :: iset = 1

mxaobf = maxbfn
iprec = 8
iwidth = 110
call formats_cvb()
if (is_set /= iset) then
  ! Initializations below are only carried out once:
  call io_init_cvb()
  corenrg = Zero
end if
is_set = iset

end subroutine cvbfinit_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2008, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine ChoMP2_DecDrv(irc,DelOrig,Diag,CD_Type)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C     * Amplitude extension, Thomas Bondo Pedersen, Dec. 2007/Jan. 2008.
C
C     Purpose: decompose (ai|bj) integrals or
C              amplitudes [(ai|bj)/e(a)-e(i)+e(b)-e(j)]
C              for use in Cholesky MP2 program.
C
C     Arguments:
C     irc...... OUT: return code - if non-zero, decomposition failed.
C               Caller MUST check this!
C     DelOrig.. INP: flag for deleting files with original vectors after
C               decomposition completes.
C     Diag..... INP: integral diagonal (ai|ai) or
C               amplitude diagonal (ai|ai)/2[e(a)-e(i)]
C     CD_Type.. INP: string
C               'Integrals'  - integral decomposition
C               'Amplitudes' - amplitude decomposition
C
C     Other input such as orbital energies are read from mbpt2 include
C     files.
C
C
      use ChoMP2, only: OldVec
#include "implicit.fh"
      External ChoMP2_Col, ChoMP2_Vec
      Integer  irc
      Logical  DelOrig
      Real*8   Diag(*)
      Character*(*) CD_Type
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"
#include "stdalloc.fh"

      Character(LEN=6), Parameter:: ThisNm = 'DecDrv'
      Character(LEN=13), Parameter:: SecNam = 'ChoMP2_DecDrv'

      Logical, Parameter:: Restart = .false.
      Logical Failed, ConventionalCD

      Integer nOption
      Parameter (nOption = 2)

      Character*18 Option

      Integer iClos(2)
      Integer MxCDVec(8)

      Real*8, Allocatable:: ErrStat(:), Bin(:), Qual(:), Buf(:)
      Integer, Allocatable:: iQual(:), iPivot(:)

C     Initializations.
C     ----------------

      irc = 0

#if defined (_DEBUGPRINT_)
      ChkDecoMP2 = .True.
#endif

      If (len(CD_Type) .lt. 1) Then ! input error
         iOption = 0
         Option = 'Unknown !?!?!     '
      Else
         If (CD_Type(1:1).eq.'i' .or. CD_Type(1:1).eq.'I') Then
            iOption = 1
            Option = '(ai|bj) integrals '
         Else If (CD_Type(1:1).eq.'a' .or. CD_Type(1:1).eq.'A') Then
            iOption = 2
            Option = 'MP2 amplitudes    '
         Else
            iOption = nOption + 1
            Option = 'Unknown !?!?!     '
         End If
      End If
      If (iOption.lt.1 .or. iOption.gt.nOption) Then
         irc = -98
         Write(6,*) SecNam,': illegal input option (argument CD_Type)'
         Return
      End If
      iOption_MP2CD = iOption  ! copy to include file chomp2_dec.fh
C-TBP:
C Frankie,
C I use the array MxCDVec(iSym) to decide whether the decomposition
C of a given symmetry block is conventional or "MaxVec":
C ConventionalCD = MxCDVec(iSym).lt.1 .or. MxCDVec(iSym).ge.nT1Am(iSym)
C You may want to calculate the MxCDVec values somewhere else and store
C them in an include-file (say, chomp2_dec.fh).
C For now, I simply define the array here:
      Do iSym = 1,nSym
         MxCDVec(iSym) = nT1Am(iSym)
      End Do

      lErrStat = 3
      Call mma_allocate(ErrStat,lErrStat,Label='ErrStat')
      If (Verbose) Then
         nBin = 18
         Call mma_allocate(Bin,nBin,Label='Bin')
      Else
         nBin  = 0
         Call mma_allocate(Bin,1,Label='Bin')
      End If

      Do iSym = 1,nSym
         nMP2Vec(iSym) = 0
         InCore(iSym)  = .false.
      End Do
      NowSym    = -999999

      If (DelOrig) Then
         iClos(1) = 3  ! signals close and delete original vectors
      Else
         iClos(1) = 2  ! signals close and keep original vectors
      End If
      iClos(2) = 2     ! signals close and keep result vectors

C     Print.
C     ------

      If (Verbose) Then
         Write(6,*)
         Call Cho_Head('Cholesky decomposition of '//Option,'=',80,6)
         Write(6,'(/,1X,A)') 'Configuration of decomposition:'
         Write(6,'(1X,A,1P,D15.6)') 'Threshold: ',ThrMP2
         Write(6,'(1X,A,1P,D15.6)') 'Span     : ',SpanMP2
         If (ChkDecoMP2) Then
            Write(6,'(1X,A)') 'Full decomposition check activated.'
         End If
      End If

C     Start symmetry loop.
C     --------------------

      kOffD = 1
      Do iSym = 1,nSym

         nDim = nT1am(iSym)
         If (nDim.gt.0 .and. NumCho(iSym).gt.0) Then

            ConventionalCD = MxCDVec(iSym).lt.1 .or.
     &                       MxCDVec(iSym).ge.nDim
            If (Verbose .and. nBin.gt.0) Then
               Bin(1) = 1.0D2
               Do iBin = 2,nBin
                  Bin(iBin) = Bin(iBin-1)*1.0D-1
               End Do
               If (ConventionalCD) Then
                  Write(6,'(//,1X,A,I2,A,I9)')
     &     '>>> Conventional Cholesky decomposition of symmetry block ',
     &            iSym,
     &            ', dimension: ',nDim
               Else
                  Write(6,'(//,1X,A,I2,A,I9)')
     &           '>>> MaxVec Cholesky decomposition of symmetry block ',
     &            iSym,
     &            ', dimension: ',nDim
               End If
               Write(6,'(/,1X,A)') 'Analysis of initial diagonal:'
               Call Cho_AnaSize(Diag(kOffD),nDim,Bin,nBin,6)
            End If

C           Open files.
C           -----------

            Do iTyp = 1,2
               Call ChoMP2_OpenF(1,iTyp,iSym)
            End Do

C           Setup decomposition.
C           --------------------

            NowSym = iSym

            If (MxQualMP2 .ne. MxQual_Def) Then ! user-defined
               MxQual = min(max(MxQualMP2,1),nDim)
            Else ! default
               If (nDim .gt. 10) Then
                  MxQual = max(min(nDim/10,MxQualMP2),1)
               Else
                  MxQual = max(min(nDim,MxQualMP2),1)
               End If
            End If
#if !defined (_I8_)
            lTstBuf = (nDim+MxQual)*MxQual
            lTstQua = nDim*(MxQual+1)
            Do While ((lTstBuf.lt.0.or.lTstQua.lt.0) .and. MxQual.gt.0)
               MxQual  = MxQual - 1
               lTstBuf = (nDim+MxQual)*MxQual
               lTstQua = nDim*(MxQual+1)
            End Do
            If (MxQual .lt. 1) Then
               Write(6,*) SecNam,': MxQual causes integer overflow!'
               Write(6,*) SecNam,': parameters:'
               Write(6,*) 'Symmetry block: ',iSym
               Write(6,*) 'Dimension     : ',nDim
               Write(6,*) 'MxQual        : ',MxQual
               irc = -99
               Go To 1 ! exit
            End If
#endif

            Call mma_allocate(Qual,nDim*(MxQual + 1),Label='Qual')
            Call mma_allocate(iQual,MxQual,Label='iQual')
            Call mma_allocate(iPivot,nDim,Label='iPivot')

            Call mma_maxDBLE(lB)
            lBuf = min((nDim+MxQual)*MxQual,lB)
            Left = lB - lBuf
            nInC = Left/nDim
            If (nInC .ge. NumCho(iSym)) Then
               InCore(iSym) = .true.
               lTot = nDim*NumCho(iSym)
               Call mma_allocate(OldVec,lTot,Label='OldVec')
               iOpt = 2
               iAdr = 1
               Call ddaFile(lUnit_F(iSym,1),iOpt,OldVec,lTot,iAdr)
            End If
            Call mma_maxDBLE(lBuf)
            Call mma_allocate(Buf,lBuf,Label='Buf')

C           Decompose this symmetry block.
C           ------------------------------

            Thr  = ThrMP2
            Span = SpanMP2
            If (ConventionalCD) Then
               Call ChoDec(ChoMP2_Col,ChoMP2_Vec,
     &                     Restart,Thr,Span,MxQual,
     &                     Diag(kOffD),Qual,Buf,
     &                     iPivot,iQual,
     &                     nDim,lBuf,
     &                     ErrStat,nMP2Vec(iSym),irc)
               If (irc .ne. 0) Then
                  Write(6,*) SecNam,': ChoDec returned ',irc,
     &                              '   Symmetry block: ',iSym
                  Go To 1 ! exit...
               End If
            Else
               Call ChoDec_MxVec(ChoMP2_Col,ChoMP2_Vec,MxCDVec(iSym),
     &                           Restart,Thr,Span,MxQual,
     &                           Diag(kOffD),Qual,Buf,
     &                           iPivot,iQual,
     &                           nDim,lBuf,
     &                           ErrStat,nMP2Vec(iSym),irc)
               If (irc .ne. 0) Then
                  Write(6,*) SecNam,': ChoDec_MxVec returned ',irc,
     &                              '   Symmetry block: ',iSym
                  Go To 1 ! exit...
               End If
            End If
            XMn = ErrStat(1)
            XMx = ErrStat(2)
            RMS = ErrStat(3)
            If (Verbose) Then
               Write(6,'(/,1X,A)')
     &         '- decomposition completed!'
               Write(6,'(1X,A,I9,A,I9,A)')
     &         'Number of vectors needed: ',nMP2Vec(iSym),
     &         ' (number of AO vectors: ',NumCho(iSym),')'
               If (.not. ConventionalCD) Then
                  Write(6,'(1X,A,I9)')
     &            'Max. number of vectors allowed: ',MxCDVec(iSym)
               End If
               Write(6,'(1X,A)')
     &         'Error statistics for diagonal [min,max,rms]:'
               Write(6,'(1X,1P,3(D15.6,1X))') XMn,XMx,RMS
            End If
            If (ConventionalCD) Then
               Failed = abs(Xmn).gt.Thr .or. abs(XMx).gt.thr .or.
     &                  RMS.gt.Thr
            Else
               Failed = abs(Xmn).gt.Thr
            End If
            If (Failed) Then
               If (.not. Verbose) Then
                  Write(6,'(1X,A)')
     &            'Error statistics for diagonal [min,max,rms]:'
                  Write(6,'(1X,1P,3(D15.6,1X))') XMn,XMx,RMS
               End If
               Write(6,'(A,A,A,A)')
     &         SecNam,': decomposition of ',Option,' failed!'
               irc = -9999
               Go To 1 ! exit
            End If

C           If requested, check decomposition.
C           ----------------------------------

            If (ChkDecoMP2) Then
               Write(6,*)
               Write(6,'(A,A,A)')
     &         SecNam,': Checking decomposition of ',Option
               Write(6,*) 'Symmetry block: ',iSym
               Write(6,*) 'Threshold, Span, MxQual: ',Thr,Span,MxQual
               Write(6,*) 'Error statistics for diagonal [min,max,rms]:'
               Write(6,*)  ErrStat(:)
               Call ChoMP2_DecChk(irc,iSym,Qual,nDim,MxQual,
     &                            Buf,lBuf,ErrStat)
               If (irc .ne. 0) Then
                  If (irc .eq. -123456) Then
                     Write(6,*)
     &                       ' -- Sorry, full decomposition check not ',
     &                       'yet implemented --'
                     irc = 0
                  Else
                     Write(6,*) SecNam,': ChoMP2_DecChk returned ',irc,
     &                                 '   Symmetry block: ',iSym
                     Call ChoMP2_Quit(SecNam,'decomposition failed!',
     &                                ' ')
                  End If
               Else
                  XMn = ErrStat(1)
                  XMx = ErrStat(2)
                  RMS = ErrStat(3)
                  Write(6,'(A,A,A)')
     &            'Error statistics for ',Option,' [min,max,rms]:'
                  Write(6,*) XMn,XMx,RMS
                  Failed = Failed .or. abs(Xmn).gt.Thr .or.
     &                     abs(XMx).gt.Thr .or. RMS.gt.Thr
                  If (ConventionalCD) Then
                     If (Failed) Then
                        Write(6,*) '==> DECOMPOSITION FAILURE <=='
                        irc = -9999
                        Go To 1 ! exit
                     Else
                        Write(6,*) '==> DECOMPOSITION SUCCESS <=='
                     End If
                  Else
                     If (Failed) Then
                        Write(6,*)
     &                  '==> DECOMPOSITION SUCCESS <== (by definition)'
                     Else
                        Write(6,*) '==> DECOMPOSITION SUCCESS <=='
                     End If
                  End If
                  Call xFlush(6)
               End If
            End If

C           Free memory.
C           ------------

            Call mma_deallocate(Buf)
            If (InCore(iSym)) Call mma_deallocate(OldVec)
            Call mma_deallocate(iPivot)
            Call mma_deallocate(iQual)
            Call mma_deallocate(Qual)

C           Close (possibly deleting original) files.
C           -----------------------------------------

            Do iTyp = 1,2
               Call ChoMP2_OpenF(iClos(iTyp),iTyp,iSym)
            End Do

C           Update pointer to diagonal block.
C           ---------------------------------

            kOffD = kOffD + nT1am(iSym)

         Else

            If (Verbose) Then
               Write(6,'(//,1X,A,I2,A)')
     &         '>>> Symmetry block',iSym,' is empty!'
            End If

         End If

      End Do

    1 Continue
      If (irc .ne. 0) Then ! make sure files are closed before exit
         Do iSym = 1,nSym
            Do iTyp = 1,2
               Call ChoMP2_OpenF(2,iTyp,iSym)
            End Do
         End Do
      End If

      Call mma_deallocate(Bin)
      Call mma_deallocate(ErrStat)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Morgane Vacher                                   *
!               2017,2018, Ignacio Fdez. Galvan                        *
!***********************************************************************

! Module to handle the COORD keyword in gateway/seward

#include "compiler_features.h"
#define MAXLEN 180
#define iX_ 0
#define iY_ 1
#define iZ_ 2
#define iX 2**iX_
#define iY 2**iY_
#define iZ 2**iZ_
#define iXY iX+iY
#define iXZ iX+iZ
#define iYZ iY+iZ
#define iXYZ iX+iY+iZ

module XYZ

use Definitions, only: wp, iwp

implicit none
private

type XYZAtom
  character(len=MAXLEN) :: Lab
  real(kind=wp) :: Coord(3)
  integer(kind=iwp) :: FileNum
end type XYZAtom

integer(kind=iwp) :: FileNum = 0, Oper(7)
character(len=256) :: BasisAll, Symmetry
character(len=256), allocatable :: BasisSets(:,:)
type(XYZAtom), dimension(:), allocatable :: Geom

public :: Clear_XYZ, Out_Raw, Parse_Basis, Parse_Group, Read_XYZ, Symmetry, Write_SewInp

! Private extensions to mma interfaces

interface cptr2loff
  module procedure xyz_cptr2loff
end interface
interface mma_Allocate
  module procedure xyz_mma_allo_1D, xyz_mma_allo_1D_lim
end interface
interface mma_Deallocate
  module procedure xyz_mma_free_1D
end interface

contains

! Read an XYZ file with molcas extensions
! Rot and Trans are transformations to apply to all coordinates in this file
! If Replace=.T., the coordinates will replace existing ones, but labels will not be changed
subroutine Read_XYZ(Lu,Rot,Trans,Replace)

# ifdef _HDF5_
  use mh5, only: mh5_is_hdf5, mh5_open_file_r, mh5_fetch_attr, mh5_fetch_dset, mh5_close_file
# endif
  use stdalloc, only: mma_allocate, mma_deallocate
  use Constants, only: Zero, One, Angstrom
  use Definitions, only: u6

  integer, intent(in) :: Lu
  real(kind=wp), allocatable, intent(in) :: Rot(:,:,:), Trans(:,:)
  logical(kind=iwp), optional, intent(in) :: Replace
  integer(kind=iwp) :: i, Idx, Error, Lxyz, NumAt
  real(kind=wp) :: Factor, Mat(3,5)
  logical(kind=iwp) :: Found, Rep
  character(len=MAXLEN) :: Line, FName, CurrDir
  type(XYZAtom), allocatable :: ThisGeom(:), TmpGeom(:)
  integer(kind=iwp), external :: IsFreeUnit
# ifdef _HDF5_
# include "Molcas.fh"
  integer(kind=iwp) :: c, Coord_id, j, nSym
  logical(kind=iwp) :: isH5
  real(kind=wp), allocatable :: Coords(:,:)
  character(len=LenIn4), allocatable :: Labels4(:)
  character(len=LenIn), allocatable :: Labels(:)
  isH5 = .false.
# endif

# include "macros.fh"
  unused_proc(mma_allocate(TmpGeom,[0,0]))

  Factor = One
  read(Lu,'(A)') Line
  Line = adjustl(Line)

  ! Try to read a number, if it fails, try to open a file
  ! Note that the slash means end-of-line in list-directed input
  NumAt = -1
  read(Line,*,iostat=Error) NumAt
  ! And make sure there's nothing but numbers in the first word
  ! (the above is not 100% reliable in some compilers)
  do i=1,len(Line)
    if (Line(i:i) == ' ') exit
    Idx = ichar(Line(i:i))
    if ((Idx < ichar('0')) .or. (Idx > ichar('9'))) then
      Error = -1
      exit
    end if
  end do
  if (NumAt < 1) Error = -1
  if (index(Line,'/') > 0) Error = -1
  Lxyz = Lu
  if (Error /= 0) then
    read(Line,'(A)') FName
    Found = .false.
    if (index(Line,'/') == 0) then
      call GetEnvF('CurrDir',CurrDir)
      CurrDir = trim(CurrDir)//'/'//FName
      call F_Inquire(CurrDir,Found)
      if (Found) FName = CurrDir
    end if
    if (.not. Found) call F_Inquire(FName,Found)
    if (Found) then
#     ifdef _HDF5_
      if (mh5_is_hdf5(trim(FName))) then
        isH5 = .true.
      else
#     endif
        Lxyz = IsFreeUnit(Lxyz)
        call Molcas_Open(Lxyz,FName)
        read(Lxyz,'(A)') Line
        read(Line,*,iostat=Error) NumAt
        if (Error /= 0) then
          write(u6,*) 'Error reading file ',trim(FName)
          call Quit_OnUserError()
        end if
#     ifdef _HDF5_
      end if
#     endif
    else
      write(u6,*) 'File ',trim(FName),' not found!'
      call Quit_OnUserError()
    end if
  end if
  ! Each atom has a field indicating the sequential number of the
  ! file it belongs to
  FileNum = FileNum+1

# ifdef _HDF5_
  if (isH5) then
    !*******************************************************************
    ! For HDF5 formatted file
    !*******************************************************************
    write(u6,*) 'Reading xyz coordinates from h5 file '//trim(FName)
    Coord_id = mh5_open_file_r(trim(FName))
    ! check if symmetry was used
    call mh5_fetch_attr(Coord_id,'NSYM',nSym)
    ! read numbers of atoms
    if (nSym > 1) then
      call mh5_fetch_attr(Coord_id,'NATOMS_ALL',NumAt)
    else
      call mh5_fetch_attr(Coord_id,'NATOMS_UNIQUE',NumAt)
    end if
    call mma_allocate(ThisGeom,NumAt,label='ThisGeom')
    call mma_allocate(Labels,NumAt,label='Labels')
    call mma_allocate(Coords,3,NumAt,label='Coords')
    ! read atom labels
    if (nSym > 1) then
      call mma_allocate(Labels4,NumAt,label='Labels4')
      call mh5_fetch_dset(Coord_id,'DESYM_CENTER_LABELS',Labels4)
      do i=1,NumAt
        Labels(i) = Labels4(i)(1:LenIn)
      end do
      call mma_deallocate(Labels4)
    else
      call mh5_fetch_dset(Coord_id,'CENTER_LABELS',Labels)
    end if
    ! remove numbers from labels
    ! (otherwise there will be problems when symmetric structures
    ! are used without symmetry)
    do i=1,NumAt
      do j=1,LenIn
        c = ichar(Labels(i)(j:j))
        if ((c >= ichar('0')) .and. (c <= ichar('9'))) then
          Labels(i)(j:j) = ' '
        end if
      end do
    end do
    ! read atom coordinates
    if (nSym > 1) then
      call mh5_fetch_dset(Coord_id,'DESYM_CENTER_COORDINATES',Coords)
    else
      call mh5_fetch_dset(Coord_id,'CENTER_COORDINATES',Coords)
    end if
    call mh5_close_file(Coord_id)
    ! store data
    do i=1,NumAt
      ThisGeom(i)%Lab = Labels(i)
      ThisGeom(i)%Coord(:) = Coords(:,i)
      ThisGeom(i)%FileNum = FileNum
    end do
    call mma_deallocate(Labels)
    call mma_deallocate(Coords)
  else
# endif
    !*******************************************************************
    ! For .xyz format file
    !*******************************************************************
    call mma_allocate(ThisGeom,NumAt,label='ThisGeom')
    read(Lxyz,'(A)',iostat=Error) Line
    if (Error /= 0) then
      write(u6,*) 'Error reading geometry'
      call Quit_OnUserError()
    end if
    call UpCase(Line)
    ! Units of the coordinates (default angstrom)
    if (max(index(Line,'BOHR'),index(Line,'A.U.')) <= 0) then
      Factor = One/Angstrom
    end if
    do i=1,NumAt
      read(Lxyz,*,iostat=Error) ThisGeom(i)%Lab,ThisGeom(i)%Coord(:)
      if (Error /= 0) then
        write(u6,*) 'Error reading geometry'
        call Quit_OnUserError()
      end if
      ThisGeom(i)%Coord(:) = ThisGeom(i)%Coord(:)*Factor
      ThisGeom(i)%FileNum = FileNum
    end do
    if (Lxyz /= Lu) close(Lxyz)
# ifdef _HDF5_
  end if
# endif

  ! Obtain/read transformation matrix and transform the geometry in this file
  Mat = reshape([One,One,One,One,Zero,Zero,Zero,One,Zero,Zero,Zero,One,Zero,Zero,Zero],shape(Mat))
  Idx = index(' '//Line,' SCALE ')
  if (Idx > 0) then
    read(Line(Idx+5:),*,iostat=Error) Mat(1,1)
    Mat(2,1) = Mat(1,1)
    Mat(3,1) = Mat(1,1)
  end if
  Idx = index(' '//Line,' SCALEX ')
  if (Idx > 0) read(Line(Idx+6:),*,iostat=Error) Mat(1,1)
  Idx = index(' '//Line,' SCALEY ')
  if (Idx > 0) read(Line(Idx+6:),*,iostat=Error) Mat(2,1)
  Idx = index(' '//Line,' SCALEZ ')
  if (Idx > 0) read(Line(Idx+6:),*,iostat=Error) Mat(3,1)
  Idx = index(' '//Line,' ROT ')
  if (Idx > 0) read(Line(Idx+3:),*,iostat=Error) Mat(:,2:4)
  Idx = index(' '//Line,' TRANS ')
  if (Idx > 0) read(Line(Idx+5:),*,iostat=Error) Mat(:,5)
  ! If Rot and Trans are given in the input, they override the inline transformations
  if (allocated(Rot)) then
    Mat(:,2:4) = Rot(:,:,FileNum)
  end if
  Mat(:,2:4) = transpose(Mat(:,2:4))
  if (allocated(Trans)) then
    Mat(:,5) = Trans(:,FileNum)
  end if
  Mat(:,5) = Mat(:,5)*Factor
  call TransformGeom(ThisGeom,Mat)

  Rep = .false.
  if (present(Replace)) Rep = Replace

  if (allocated(Geom)) then
    if (Rep) then
      if (size(ThisGeom) /= size(Geom)) then
        write(u6,*) 'New system size does not match previous one'
        call Quit_OnUserError()
      end if
      do i=1,size(Geom)
        Geom(i)%Coord = ThisGeom(i)%Coord
      end do
      call mma_deallocate(ThisGeom)
    else
      ! Append the just read geometry to the general one
      call move_alloc(Geom,TmpGeom)
      NumAt = size(TmpGeom)+size(ThisGeom)
      call mma_allocate(Geom,NumAt,label='Geom')
      Geom(1:size(TmpGeom)) = TmpGeom(:)
      Geom(size(TmpGeom)+1:) = ThisGeom(:)
      call mma_deallocate(TmpGeom)
      call mma_deallocate(ThisGeom)
    end if
  else
    call move_alloc(ThisGeom,Geom)
  end if

end subroutine Read_XYZ

! Clear allocations
subroutine Clear_XYZ()

  use stdalloc, only: mma_deallocate

  if (allocated(Geom)) call mma_deallocate(Geom)
  if (allocated(BasisSets)) call mma_deallocate(BasisSets)
  FileNum = 0

end subroutine Clear_XYZ

! Write an input file for seward
! Atoms belonging to GhostFiles have no charge
subroutine Write_SewInp(FName,GhostFiles)

  use Constants, only: Zero

  character(len=*), intent(in) :: FName
  integer, intent(in) :: GhostFiles(:)
  integer(kind=iwp) :: i, j, Lu, Num
  logical(kind=iwp) :: Ghost
  character(len=MAXLEN) :: Bas, Lab, New, Old, Sym
  integer(kind=iwp), external :: IsFreeUnit

  Lu = IsFreeUnit(10)
  call Molcas_Open(Lu,FName)
  ! Write symmetry
  if (Symmetry /= '') write(Lu,40) 'Symmetry',trim(Symmetry)
  ! Write the atoms, skipping symmetry-superfluous atoms
  Old = ''
  j = 0
  do i=1,size(Geom)
    if (Geom(i)%FileNum == 0) cycle
    j = j+1
    call SplitLabel(Geom(i)%Lab,Sym,Num,Lab,Bas)
    ! Build an identifier for the basis
    New = trim(Sym)//trim(Lab)//Bas
    Ghost = any(GhostFiles == Geom(i)%FileNum)
    if (Ghost) New = trim(New)//' *'
    ! If there is a change of basis, write the basis
    if (New /= Old) then
      if (i > 1) write(Lu,10) 'End of Basis'
      write(Lu,10) 'Basis Set'
      write(Lu,10) FindBasis(Sym,Lab,Bas)
      if (Ghost) write(Lu,30) 'Charge',Zero
      Old = New
    end if
    ! Add a sequential number if the label had none
    if (Num == 0) Num = j
    write(Lu,20) trim(Sym),Num,Geom(i)%Coord(:)
  end do
  write(Lu,10) 'End of Basis'
  write(Lu,10) 'End of Coord'
  close(Lu)

  10 format(A)
  20 format(A,I0,3(1X,ES30.20E3))
  30 format(A,/,F4.1)
  40 format(A,/,A)

end subroutine Write_SewInp

! Store symmetry-unique atom coordinates in an array
! Output is the number of saved coordinates
function Out_Raw(Array)

  integer(kind=iwp) :: Out_Raw
  real(kind=wp), intent(inout) :: Array(*)
  integer(kind=iwp) :: i, j

  j = 0
  do i=1,size(Geom)
    if (Geom(i)%FileNum == 0) cycle
    Array(j+1:j+3) = Geom(i)%Coord
    j = j+3
  end do
  Out_Raw = j

end function Out_Raw

! Parse the BASIS keyword to store the basis set corresponding to
! each atom + label
subroutine Parse_Basis(Basis)

  use fortran_strings
  use stdalloc, only: mma_allocate, mma_deallocate

  character(len=*), intent(in) :: Basis
  integer(kind=iwp) :: i, Idx, IdxDot, Next, Num

  ! Count number of commas
  Num = count(char_array(trim(Basis)) == ',')+1
  BasisAll = ''
  if (allocated(BasisSets)) call mma_deallocate(BasisSets)
  call mma_allocate(BasisSets,2,Num,label='BasisSets')
  ! For each comma-separated word, split it at the first dot
  ! If the first part is empty, use it as a general basis set
  Idx = 0
  do i=1,Num
    Next = Idx+index(Basis(Idx+1:),',')
    if (Next == Idx) Next = len_trim(Basis)+1
    BasisSets(2,i) = Basis(Idx+1:Next-1)
    IdxDot = index(BasisSets(2,i),'.')
    if (IdxDot == 0) then
      BasisSets(1,i) = ''
    else
      BasisSets(1,i) = adjustl(BasisSets(2,i)(1:IdxDot-1))
      BasisSets(2,i)(1:IdxDot) = ''
    end if
    call UpCase(BasisSets(1,i))
    BasisSets(2,i) = adjustl(BasisSets(2,i))
    if (BasisSets(1,i) == '') BasisAll = BasisSets(2,i)
    Idx = Next
  end do
  if (BasisAll == '') BasisAll = 'ANO-S-MB'

end subroutine Parse_Basis

! Parse the GROUP keyword, detecting the symmetry,
! generating all symmetry operations and adapting
! the symmetry
subroutine Parse_Group(Group,Thr)

  character(len=*), intent(in) :: Group
  real(kind=wp), intent(in) :: Thr
  integer(kind=iwp) :: Error, i, j, k
  character(len=3) :: Gen(3)

  Symmetry = Group
  call UpCase(Symmetry)
  if (Symmetry == 'FULL') then
    call DetectSym(Thr)
  else if ((Symmetry(1:5) == 'NOSYM') .or. (Symmetry == 'E') .or. (Symmetry == 'C1')) then
    Symmetry = ''
  end if
  Gen = ''
  read(Symmetry,*,iostat=Error) Gen
  ! Encode generators
  Oper = 0
  do i=1,3
    if (index(Gen(i),'X') > 0) Oper(i) = Oper(i)+iX
    if (index(Gen(i),'Y') > 0) Oper(i) = Oper(i)+iY
    if (index(Gen(i),'Z') > 0) Oper(i) = Oper(i)+iZ
  end do
  ! Create all combinations
  Oper(4) = ieor(Oper(1),Oper(2))
  Oper(5) = ieor(Oper(1),Oper(3))
  Oper(6) = ieor(Oper(2),Oper(3))
  Oper(7) = ieor(Oper(3),Oper(4))
  ! Remove duplicates
  do i=1,7
    do j=i+1,7
      if (Oper(j) == Oper(i)) Oper(j) = 0
    end do
  end do
  ! Sort descending
  do i=1,7
    do j=i+1,7
      if (Oper(j) >= Oper(i)) then
        k = Oper(j)
        Oper(j) = Oper(i)
        Oper(i) = k
      end if
    end do
  end do
  ! Check and adapt the symmetry
  call AdaptSym(Thr)

end subroutine Parse_Group

! Private procedures follow

! Subroutine to detect the symmetry elements of the system
! The system is *not* translated or rotated
! Only elements of D2h group are tested (i.e. sign inversions of one, two or three axes)
! The result is stored in Symmetry (compatible with molcas-extra)
subroutine DetectSym(Thr)

  use Definitions, only: u6

  real(kind=wp), intent(in) :: Thr
  logical(kind=iwp) :: Op(7)

  Op = .false.
  Op(iX) = CheckOp(iX,Thr)
  Op(iY) = CheckOp(iY,Thr)
  Op(iZ) = CheckOp(iZ,Thr)
  Symmetry = ''
  select case (count(Op))
    case (3,2)
      ! Two or three reflections: all is known
      Op(iXY) = Op(iX) .and. Op(iY)
      Op(iXZ) = Op(iX) .and. Op(iZ)
      Op(iYZ) = Op(iY) .and. Op(iZ)
      Op(iXYZ) = Op(iX) .and. Op(iY) .and. Op(iZ)
      if (Op(iXYZ)) then
        Symmetry = 'x y z'
      else
        if (Op(iXY)) Symmetry = 'xy y'
        if (Op(iXZ)) Symmetry = 'xz z'
        if (Op(iYZ)) Symmetry = 'yz z'
      end if
    case (1)
      ! One reflection: possibly inversion and complementary rotation
      Op(iXYZ) = CheckOp(iXYZ,Thr)
      if (Op(iXYZ)) then
        Op(iXY) = Op(iZ)
        Op(iXZ) = Op(iY)
        Op(iYZ) = Op(iX)
        if (Op(iXY)) Symmetry = 'xy xyz'
        if (Op(iXZ)) Symmetry = 'xz xyz'
        if (Op(iYZ)) Symmetry = 'yz xyz'
      else
        if (Op(iX)) Symmetry = 'x'
        if (Op(iY)) Symmetry = 'y'
        if (Op(iZ)) Symmetry = 'z'
      end if
    case (0)
      ! No reflection: check rotations (only two initially)
      Op(iXY) = CheckOp(iXY,Thr)
      Op(iXZ) = CheckOp(iXZ,Thr)
      if (Op(iXY)) Symmetry = 'xy'
      if (Op(iXZ)) Symmetry = trim(Symmetry)//' xz'
      select case (count(Op))
        case (2,1)
          ! Two or one rotation: the third is known
          Op(iYZ) = Op(iXY) .and. Op(iXZ)
        case (0)
          ! No rotation: check the third, and inversion if necessary
          Op(iYZ) = CheckOp(iYZ,Thr)
          if (.not. Op(iYZ)) Op(iXYZ) = CheckOp(iXYZ,Thr)
          if (Op(iXY)) Symmetry = 'yz'
          if (Op(iXYZ)) Symmetry = 'xyz'
      end select
  end select
  Symmetry = adjustl(Symmetry)
  if (Symmetry /= '') write(u6,10) trim(Symmetry)
  call UpCase(Symmetry)

  10 format(6X,'Found SYMMETRY generators: ',A)

end subroutine DetectSym

! Function to check if a symmetry operation conserves the geometry
function CheckOp(Op,Thr)

  use stdalloc, only: mma_allocate, mma_deallocate
  use Constants, only: Angstrom

  integer(kind=iwp), intent(in) :: Op
  real(kind=wp), intent(in) :: Thr
  integer(kind=iwp) :: i, j, Num
  real(kind=wp) :: Dist, New(3)
  logical(kind=iwp) :: CheckOp, Found
  character(len=MAXLEN) :: Bas, Lab, Sym, SymA, SymB
  logical(kind=iwp), allocatable :: Done(:)

  call mma_allocate(Done,size(Geom),label='Done')
  Done = .false.
  ! For each atom, check if any of the following atoms (including itself)
  ! matches the result of the symmetry operation
  Found = .false.
  outer: do i=1,size(Geom)
    if (Done(i)) cycle
    call SplitLabel(Geom(i)%Lab,Sym,Num,Lab,Bas)
    SymA = trim(Sym)//trim(Lab)
    call UpCase(SymA)
    New = ApplySym(Op,Geom(i)%Coord)
    Found = .false.
    do j=i,size(Geom)
      call SplitLabel(Geom(j)%Lab,Sym,Num,Lab,Bas)
      SymB = trim(Sym)//trim(Lab)
      call UpCase(SymB)
      if (SymB /= SymA) cycle
      Dist = (New(1)-Geom(j)%Coord(1))**2+(New(2)-Geom(j)%Coord(2))**2+(New(3)-Geom(j)%Coord(3))**2
      if (Dist*Angstrom**2 <= Thr**2) then
        Done(j) = .true.
        Found = .true.
        cycle outer
      end if
    end do
    if (.not. Found) exit
  end do outer
  CheckOp = Found
  call mma_deallocate(Done)

end function CheckOp

! Subroutine to "fix" the symmetry, according to the threshold
! Coordinates of the atoms that are close enough are averaged
! Symmetry-superfluous atoms are marked with FileNum=0
subroutine AdaptSym(Thr)

  use Constants, only: Zero, Angstrom
  use Definitions, only: wp, u6

  real(kind=wp), intent(in) :: Thr
  integer(kind=iwp) :: i, j, nOp, Num, Op
  real(kind=wp) :: Aver(3), Dist, New(3)
  logical(kind=iwp) :: Found, Moved, ZeroAxis(3)
  character(len=MAXLEN) :: Bas, Lab, Sym, SymA, SymB

  Moved = .false.
  ! Count the non-trivial operations
  nOp = count(Oper /= 0)+1
  ! For each atom, find all symmetric images to average
  do i=1,size(Geom)
    if (Geom(i)%FileNum == 0) cycle
    call SplitLabel(Geom(i)%Lab,Sym,Num,Lab,Bas)
    SymA = trim(Sym)//trim(Lab)
    call UpCase(SymA)
    Aver = Geom(i)%Coord
    ZeroAxis = .false.
    do Op=1,7
      if (Oper(Op) == 0) exit
      Found = .false.
      do j=i,size(Geom)
        call SplitLabel(Geom(j)%Lab,SymB,Num,Lab,Bas)
        SymB = trim(Sym)//trim(Lab)
        call UpCase(SymB)
        if (SymB /= SymA) cycle
        New = ApplySym(Oper(Op),Geom(j)%Coord)
        Dist = (New(1)-Geom(i)%Coord(1))**2+(New(2)-Geom(i)%Coord(2))**2+(New(3)-Geom(i)%Coord(3))**2
        if (Dist*Angstrom**2 <= Thr**2) then
          Found = .true.
          Aver = Aver+New
          if (j == i) then
            if (btest(Oper(Op),iX_)) ZeroAxis(1) = .true.
            if (btest(Oper(Op),iY_)) ZeroAxis(2) = .true.
            if (btest(Oper(Op),iZ_)) ZeroAxis(3) = .true.
          else
            Geom(j)%FileNum = 0
          end if
          if (Dist > Zero) Moved = .true.
          exit
        end if
      end do
      if (.not. Found) then
        write(u6,*) 'Symmetry operators do not match the geometry'
        call Quit_OnUserError()
      end if
    end do
    ! Make sure the axes that should be zero are exactly zero
    Geom(i)%Coord = merge([Zero,Zero,Zero],Aver/real(nOp,kind=wp),ZeroAxis)
  end do
  if (Moved) call WarningMessage(0,'Warning! XYZ coordinates will be modified to match the specified/detected symmetry. '// &
                                 'Use SYMT = 0.0 if this is not desired.')

end subroutine AdaptSym

! Function to apply a symmetry operation to a 3D-point
! The operation is simply a possible change of sign of each axis
function ApplySym(Op,Coord)

  integer(kind=iwp), intent(in) :: Op
  real(kind=wp), intent(in) :: Coord(3)
  real(kind=wp) :: ApplySym(3)

  ApplySym = Coord
  if (btest(Op,iX_)) ApplySym(1) = -ApplySym(1)
  if (btest(Op,iY_)) ApplySym(2) = -ApplySym(2)
  if (btest(Op,iZ_)) ApplySym(3) = -ApplySym(3)

end function ApplySym

! Subroutine to obtain the different components, of an atom's label
! <Sym><Num>_<Lab>.<Bas>
! Lab and Bas include the _ or .
subroutine SplitLabel(At,Sym,Num,Lab,Bas)

  character(len=*), intent(in) :: At
  character(len=*), intent(out) :: Sym, Lab, Bas
  integer(kind=iwp), intent(out) :: Num
  integer(kind=iwp) :: i, Idx, j, k
  character(len=len(At)) :: String
  character :: c

  String = At
  ! Get the Bas part
  Idx = index(String,'.')
  if (Idx == 0) then
    Idx = len_trim(String)+1
    Bas = ''
  else
    Bas = String(Idx:)
  end if
  String = String(1:Idx-1)
  ! Get the Lab part
  Idx = index(String,'_')
  if (Idx == 0) then
    Idx = len_trim(String)+1
    Lab = ''
  else
    Lab = String(Idx:)
  end if
  Sym = String(1:Idx-1)
  Num = 0
  k = 0
  ! Remove digits and compute Num
  do i=len_trim(Sym),1,-1
    c = Sym(i:i)
    if ((ichar(c) >= ichar('0')) .and. (ichar(c) <= ichar('9'))) then
      read(c,*) j
      Num = Num+j*10**k
      k = k+1
      Sym(i:i) = ' '
    end if
  end do

end subroutine SplitLabel

! Function to find the basis set that applies to a given atom
function FindBasis(AtSym,AtLab,AtBas)

  use Definitions, only: u6

  character(len=*), intent(in) :: AtSym, AtLab, AtBas
  integer(kind=iwp) :: i
  character(len=len(AtSym)) :: UpSym
  character(len=len(AtLab)) :: UpLab
# ifdef ALLOC_ASSIGN
  character(len=:), allocatable :: FindBasis
# else
  character(len=MAXLEN) :: FindBasis
# endif

  ! Prepare for case-insensitive comparisons
  UpSym = AtSym
  call UpCase(UpSym)
  UpLab = AtLab
  call UpCase(UpLab)
  ! Special case: if the Label is "MM", no basis
  if (UpLab == '_MM') then
    FindBasis = trim(AtSym)//'...... / MM'
    return
  end if
  ! If the atoms has a basis specified, nothing else to do
  if (AtBas /= '') then
    FindBasis = trim(AtSym)//trim(AtBas)
    return
  end if
  ! Otherwise, find the basis set that matches the symbol and label
  do i=1,size(BasisSets,2)
    if (trim(UpSym)//UpLab == BasisSets(1,i)) then
      FindBasis = trim(AtSym)//'.'//trim(BasisSets(2,i))
      return
    end if
  end do
  ! If none found, use the general basis
  if (BasisAll == '') then
    write(u6,*) 'No basis found for '//trim(AtSym)//trim(AtLab)
    call Quit_OnUserError()
  end if
  FindBasis = trim(AtSym)//'.'//trim(BasisAll)

end function FindBasis

! Subroutine to transform a geometry according to the matrix M
subroutine TransformGeom(G,M)

  use Definitions, only: r8

  type(XYZAtom), dimension(:), intent(inout) :: G
  real(kind=wp), intent(in) :: M(3,5)
  real(kind=wp) :: Old(3)
  integer(kind=iwp) :: i, j
  real(kind=r8), external :: DDot_

  ! The matrix has 5 colums: scale (1), rotate (2-4), translate (5)
  do i=1,size(G)
    Old(:) = M(:,1)*G(i)%Coord(:)
    do j=1,3
      G(i)%Coord(j) = DDot_(3,Old,1,M(:,j+1),1)
    end do
    G(i)%Coord(:) = G(i)%Coord(:)+M(:,5)
  end do

end subroutine TransformGeom

! Private extensions to mma_interfaces, using preprocessor templates
! (see src/mma_util/stdalloc.f)

! Define xyz_cptr2loff, xyz_mma_allo_1D, xyz_mma_allo_1D_lim, xyz_mma_free_1D
#define _TYPE_ type(XYZAtom)
#  define _FUNC_NAME_ xyz_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ xyz_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'xyz_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

end module XYZ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_L2(L2,dima,dimb,adda,addb)
! this routine tests L2

use chcc_global, only: L1k, L2k, nc, no, T1c
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, adda, addb
real(kind=wp), intent(inout) :: L2(nc,dima,dimb)
integer(kind=iwp) :: a, b, bad, i, m, ntot
real(kind=wp) :: s

bad = 0
ntot = 0

do b=addb+1,addb+dimb
  do a=adda+1,adda+dima
    do m=1,nc

      s = L2k(m,a,b)
      do i=1,no
        s = s-L1k(m,i,a)*T1c(b,i)
      end do

      if (abs(L2(m,a-adda,b-addb)-s) > 1.0e-10_wp) then
        bad = bad+1
        L2(m,a-adda,b-addb) = s
      end if
      ntot = ntot+1

    end do
  end do
end do

write(u6,*) ' L2   ',bad,ntot

return

end subroutine Chck_L2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine applyth_cvb(civbh,orbs)
! Apply T(O) H T(O) to CIVBH:

use casvb_global, only: gjorb, gjorb2, ndet, norb
use Definitions, only: wp

implicit none
real(kind=wp), intent(inout) :: civbh(0:ndet)
real(kind=wp), intent(in) :: orbs(norb,norb)

call makegjorbs_cvb(orbs)

call applyt_cvb(civbh,gjorb)
call proj_cvb(civbh)
call applyh_cvb(civbh)
call applyt_cvb(civbh,gjorb2)

return

end subroutine applyth_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine pa_diagham( exch, npair, i_pair,  nneq,   neq, nexch,
     &                        nmax,  lmax,    eso,  HLIN1, HLIN3, HLIN9,
     &                        HDIP,  HKEX, HDMO, HITO, Dipol,
     &                        DM_exchange, AnisoLines1, AnisoLines3,
     &                        AnisoLines9, KE, JITO_exchange,
     &                        WLIN1, WLIN3, WLIN9, WLIN, WDIP,
     &                        WKEX, WDMO, WITO,  W,     Z  )
c this function builds and diagonalizes the interaction Hamiltonians
      Implicit None
#include "stdalloc.fh"
      Integer, parameter            :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)           :: exch
      Integer, intent(in)           :: npair
      Integer, intent(in)           :: i_pair(npair,2)
      Integer, intent(in)           :: nneq
      Integer, intent(in)           :: neq(nneq)
      Integer, intent(in)           :: nexch(nneq)
      Integer, intent(in)           :: nmax
      Integer, intent(in)           :: lmax
      Logical, intent(in)           :: Dipol
      Logical, intent(in)           :: KE
      Logical, intent(in)           :: DM_exchange
      Logical, intent(in)           :: AnisoLines1
      Logical, intent(in)           :: AnisoLines3
      Logical, intent(in)           :: AnisoLines9
      Logical, intent(in)           :: JITO_exchange
      Real(kind=8), intent(in)     :: eso(nneq,nmax)
      Complex(kind=8), intent(in)  :: HLIN1(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in)  :: HLIN3(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in)  :: HLIN9(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in)  :: HDIP(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in)  :: HKEX(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in)  :: HDMO(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in)  :: HITO(npair,nmax,nmax,nmax,nmax)
      ! output data:
      Real(kind=8), intent(out)    :: wlin(exch) ! total 1+3+9
      Real(kind=8), intent(out)    :: wlin1(exch)
      Real(kind=8), intent(out)    :: wlin3(exch)
      Real(kind=8), intent(out)    :: wlin9(exch)
      Real(kind=8), intent(out)    :: wdip(exch)
      Real(kind=8), intent(out)    :: wkex(exch)
      Real(kind=8), intent(out)    :: wdmo(exch)
      Real(kind=8), intent(out)    :: wito(exch)

      Real(kind=8), intent(out)    :: w(exch)
      Complex(kind=8), intent(out) :: Z(exch,exch)
c local variables
      Complex(kind=8), allocatable :: HTOT(:,:)
      Integer, allocatable :: nind(:,:), intc(:), ibas(:,:), icoord(:)
      Integer  :: nb1, nb2, lb1, lb2, i1, i2, is1, is2,
     &            js1, js2, nb, i, j, l, lp, lb
      Integer  :: norder
      external :: norder
c diag:
      Integer          :: info, lwork
      Real(kind=8), allocatable :: rwork(:) !rwork(3*exch-2)
      Complex(kind=8), allocatable :: work(:) !work(2*exch-1)
c allocate memory and initialize variables:
      If( exch >= 0 ) Then
         Call mma_allocate(HTOT,exch,exch,'HTOT')
         Call mma_allocate(WORK,(2*exch-1),'WORK')
         If( lmax >= 0 ) Then
            Call mma_allocate(ibas,exch,lmax,'ibas')
         End If
         Call mma_allocate(rwork,(3*exch-2),'rwork')
      End If

      If( lmax >= 0 ) Then
         Call mma_allocate(nind,lmax,2,'nind')
         Call mma_allocate(intc,lmax,'intc')
         Call mma_allocate(icoord,lmax,'icoord')
      End If
      Call zcopy_(exch*exch, [(0.0_wp,0.0_wp)],0,Z,1)
      Call dcopy_(exch,[0.0_wp],0,w,1)
      Call dcopy_(exch,[0.0_wp],0,wlin,1)
      Call dcopy_(exch,[0.0_wp],0,wlin1,1)
      Call dcopy_(exch,[0.0_wp],0,wlin3,1)
      Call dcopy_(exch,[0.0_wp],0,wlin9,1)
      Call dcopy_(exch,[0.0_wp],0,wdip,1)
      Call dcopy_(exch,[0.0_wp],0,wkex,1)
      Call dcopy_(exch,[0.0_wp],0,wdmo,1)
      Call dcopy_(exch,[0.0_wp],0,wito,1)

c generate the tables:
      l=0
      Call icopy(2*lmax,[0],0,nind,1)
      Do i=1,nneq
        Do j=1,neq(i)
          l=l+1
          nind(l,1)=i
          nind(l,2)=j
        End Do
      End Do

      Call icopy(lmax,[0],0,intc,1)
      intc(1)=1
      If (lmax.gt.1) Then
        Do i=2,lmax
          i1=nind(i-1, 1)
          intc(i)=intc(i-1)*nexch(i1)
        End Do
      End If

      Call icopy(exch*lmax,[0],0,ibas,1)
      Do nb=1,exch
        nb1=nb-1
        Do i=1,lmax
          ibas(nb, lmax-i+1)= nb1 / intc(lmax-i+1)
          nb1=nb1-ibas(nb,lmax-i+1)*intc(lmax-i+1)
        End Do
      End Do
c build the interaction Hamiltonians
!----------------------------------------------------------------------!
      If( AnisoLines1 ) Then
        Call zcopy_(exch*exch, [(0.0_wp,0.0_wp)],0,HTOT,1)
        Do nb1 = 1,exch
          Do lp = 1,npair
            Call icopy(lmax,[0],0,icoord,1)
            Do i = 1,lmax
              icoord(i) = ibas(nb1,i)
            End Do

            lb1 = i_pair(lp ,1)
            lb2 = i_pair(lp ,2)
            i1  =   nind(lb1,1)
            i2  =   nind(lb2,1)
            is1 = icoord(lb1) + 1
            is2 = icoord(lb2) + 1
            Do js1 = 1, nexch(i1)
              icoord(lb1) = js1 - 1
              Do js2 = 1, nexch(i2)
                icoord(lb2) = js2 - 1
                nb2 = norder(icoord,intc,lmax)
                HTOT(nb1,nb2)=HTOT(nb1,nb2) + HLIN1(lp,is1,js1,is2,js2)
              End Do ! js2
            End Do ! js1
          End Do ! lp

          l=0
          lb=1
          Do i = 1, nneq
            Do j = 1, neq(i)
              l = l + 1
              If( l.eq.lb ) Then
                HTOT(nb1,nb1)=HTOT(nb1,nb1) +
     &                        cmplx( eso(i,ibas(nb1,lb)+1), 0.0_wp, wp )
                If((lb+1).le.(lmax)) lb=lb+1
              End If
            End Do !j
          End Do !i
        End Do !nb1
        ! diagonalize
        info=0
        lwork=0
        lwork=2*exch-1
        Call dcopy_((3*exch-2),[0.0_wp],0,rwork,1)
        Call zcopy_((2*exch-1),[(0.0_wp,0.0_wp)],0,WORK,1)
        Call zheev('n','u',exch,htot,exch,wlin1,work,lwork,rwork,info)
      End If



!----------------------------------------------------------------------!
      If( AnisoLines3 ) Then
        Call zcopy_(exch*exch, [(0.0_wp,0.0_wp)],0,HTOT,1)
        Do nb1 = 1,exch
          Do lp = 1,npair
            Call icopy(lmax,[0],0,icoord,1)
            Do i = 1,lmax
              icoord(i) = ibas(nb1,i)
            End Do

            lb1 = i_pair(lp ,1)
            lb2 = i_pair(lp ,2)
            i1  =   nind(lb1,1)
            i2  =   nind(lb2,1)
            is1 = icoord(lb1) + 1
            is2 = icoord(lb2) + 1
            Do js1 = 1, nexch(i1)
              icoord(lb1) = js1 - 1
              Do js2 = 1, nexch(i2)
                icoord(lb2) = js2 - 1
                nb2 = norder(icoord,intc,lmax)
                HTOT(nb1,nb2)=HTOT(nb1,nb2) + HLIN3(lp,is1,js1,is2,js2)
              End Do ! js2
            End Do ! js1
          End Do ! lp

          l=0
          lb=1
          Do i = 1, nneq
            Do j = 1, neq(i)
              l = l + 1
              If( l.eq.lb ) Then
                HTOT(nb1,nb1)=HTOT(nb1,nb1) +
     &                        cmplx( eso(i,ibas(nb1,lb)+1), 0.0_wp, wp )
                If((lb+1).le.(lmax)) lb=lb+1
              End If
            End Do !j
          End Do !i
        End Do !nb1
        ! diagonalize
        info=0
        lwork=0
        lwork=2*exch-1
        Call dcopy_((3*exch-2),[0.0_wp],0,rwork,1)
        Call zcopy_((2*exch-1),[(0.0_wp,0.0_wp)],0,WORK,1)
        Call zheev('n','u',exch,htot,exch,wlin3,work,lwork,rwork,info)
      End If



!----------------------------------------------------------------------!
      If( AnisoLines9 ) Then
        Call zcopy_(exch*exch, [(0.0_wp,0.0_wp)],0,HTOT,1)
        Do nb1 = 1,exch
          Do lp = 1,npair
            Call icopy(lmax,[0],0,icoord,1)
            Do i = 1,lmax
              icoord(i) = ibas(nb1,i)
            End Do

            lb1 = i_pair(lp ,1)
            lb2 = i_pair(lp ,2)
            i1  =   nind(lb1,1)
            i2  =   nind(lb2,1)
            is1 = icoord(lb1) + 1
            is2 = icoord(lb2) + 1
            Do js1 = 1, nexch(i1)
              icoord(lb1) = js1 - 1
              Do js2 = 1, nexch(i2)
                icoord(lb2) = js2 - 1
                nb2 = norder(icoord,intc,lmax)
                HTOT(nb1,nb2)=HTOT(nb1,nb2) + HLIN9(lp,is1,js1,is2,js2)
              End Do ! js2
            End Do ! js1
          End Do ! lp

          l=0
          lb=1
          Do i = 1, nneq
            Do j = 1, neq(i)
              l = l + 1
              If( l.eq.lb ) Then
                HTOT(nb1,nb1)=HTOT(nb1,nb1) +
     &                        cmplx( eso(i,ibas(nb1,lb)+1), 0.0_wp, wp )
                If((lb+1).le.(lmax)) lb=lb+1
              End If
            End Do !j
          End Do !i
        End Do !nb1
        ! diagonalize
        info=0
        lwork=0
        lwork=2*exch-1
        Call dcopy_((3*exch-2),[0.0_wp],0,rwork,1)
        Call zcopy_((2*exch-1),[(0.0_wp,0.0_wp)],0,WORK,1)
        Call zheev('n','u',exch,htot,exch,wlin9,work,lwork,rwork,info)
      End If



!----------------------------------------------------------------------!
      If( AnisoLines1.OR.AnisoLines3.OR.AnisoLines9 ) Then
        Call zcopy_(exch*exch, [(0.0_wp,0.0_wp)],0,HTOT,1)
        Do nb1 = 1,exch
          Do lp = 1,npair
            Call icopy(lmax,[0],0,icoord,1)
            Do i = 1,lmax
              icoord(i) = ibas(nb1,i)
            End Do

            lb1 = i_pair(lp ,1)
            lb2 = i_pair(lp ,2)
            i1  =   nind(lb1,1)
            i2  =   nind(lb2,1)
            is1 = icoord(lb1) + 1
            is2 = icoord(lb2) + 1
            Do js1 = 1, nexch(i1)
              icoord(lb1) = js1 - 1
              Do js2 = 1, nexch(i2)
                icoord(lb2) = js2 - 1
                nb2 = norder(icoord,intc,lmax)
                HTOT(nb1,nb2)=HTOT(nb1,nb2) + HLIN1(lp,is1,js1,is2,js2)
     &                                      + HLIN3(lp,is1,js1,is2,js2)
     &                                      + HLIN9(lp,is1,js1,is2,js2)
              End Do ! js2
            End Do ! js1
          End Do ! lp

          l=0
          lb=1
          Do i = 1, nneq
            Do j = 1, neq(i)
              l = l + 1
              If( l.eq.lb ) Then
                HTOT(nb1,nb1)=HTOT(nb1,nb1) +
     &                        cmplx( eso(i,ibas(nb1,lb)+1), 0.0_wp, wp )
                If((lb+1).le.(lmax)) lb=lb+1
              End If
            End Do !j
          End Do !i
        End Do !nb1
        ! diagonalize
        info=0
        lwork=0
        lwork=2*exch-1
        Call dcopy_((3*exch-2),[0.0_wp],0,rwork,1)
        Call zcopy_((2*exch-1),[(0.0_wp,0.0_wp)],0,WORK,1)
        Call zheev('n','u',exch,htot,exch,wlin,work,lwork,rwork,info)
      End If



!----------------------------------------------------------------------!
      If(Dipol) Then
        Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,HTOT,1)
        Do nb1 = 1,exch
          Do lp = 1,npair
            Call icopy(lmax,[0],0,icoord,1)
            Do i = 1,lmax
              icoord(i) = ibas(nb1,i)
            End Do

            lb1 = i_pair(lp ,1)
            lb2 = i_pair(lp ,2)
            i1  =   nind(lb1,1)
            i2  =   nind(lb2,1)
            is1 = icoord(lb1) + 1
            is2 = icoord(lb2) + 1
            Do js1 = 1, nexch(i1)
              icoord(lb1) = js1 - 1
              Do js2 = 1, nexch(i2)
                icoord(lb2) = js2 - 1
                nb2 = norder(icoord,intc,lmax)
                HTOT(nb1,nb2)=HTOT(nb1,nb2) + HDIP(lp,is1,js1,is2,js2)
              End Do ! js2
            End Do ! js1
          End Do ! lp
          l=0
          lb=1
          Do i = 1, nneq
            Do j = 1, neq(i)
              l = l + 1
              If( l.eq.lb ) Then
                ! kind=8, complex double precision
                HTOT(nb1,nb1)=HTOT(nb1,nb1)+
     &                        cmplx(eso(i,ibas(nb1,lb)+1),0.0_wp,wp)
                If((lb+1).le.(lmax)) lb=lb+1
              End If
            End Do !j
          End Do !i
        End Do !nb1
        ! diagonalize
        info=0
        lwork=0
        lwork=2*exch-1
        Call dcopy_((3*exch-2),[0.0_wp],0,rwork,1)
        Call zcopy_((2*exch-1),[(0.0_wp,0.0_wp)],0,WORK,1)
        Call zheev('n','u',exch,htot,exch,wdip,work,lwork,rwork,info)
      End If



!----------------------------------------------------------------------!
      If( DM_exchange ) Then
        Call zcopy_(exch*exch, [(0.0_wp,0.0_wp)],0,HTOT,1)
        Do nb1 = 1,exch
          Do lp = 1,npair
            Call icopy(lmax,[0],0,icoord,1)
            Do i = 1,lmax
              icoord(i) = ibas(nb1,i)
            End Do

            lb1 = i_pair(lp ,1)
            lb2 = i_pair(lp ,2)
            i1  =   nind(lb1,1)
            i2  =   nind(lb2,1)
            is1 = icoord(lb1) + 1
            is2 = icoord(lb2) + 1
            Do js1 = 1, nexch(i1)
              icoord(lb1) = js1 - 1
              Do js2 = 1, nexch(i2)
                icoord(lb2) = js2 - 1
                nb2 = norder(icoord,intc,lmax)
                HTOT(nb1,nb2)=HTOT(nb1,nb2) + HDMO(lp,is1,js1,is2,js2)
              End Do ! js2
            End Do ! js1
          End Do ! lp

          l=0
          lb=1
          Do i = 1, nneq
            Do j = 1, neq(i)
              l = l + 1
              If( l.eq.lb ) Then
                HTOT(nb1,nb1)=HTOT(nb1,nb1) +
     &                        cmplx( eso(i,ibas(nb1,lb)+1), 0.0_wp, wp )
                If((lb+1).le.(lmax)) lb=lb+1
              End If
            End Do !j
          End Do !i
        End Do !nb1
        ! diagonalize
        info=0
        lwork=0
        lwork=2*exch-1
        Call dcopy_((3*exch-2),[0.0_wp],0,rwork,1)
        Call zcopy_((2*exch-1),[(0.0_wp,0.0_wp)],0,WORK,1)
        Call zheev('n','u',exch,htot,exch,wdmo,work,lwork,rwork,info)
      End If



!----------------------------------------------------------------------!
      If(KE) Then
        Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,HTOT,1)
        Do nb1 = 1,exch
          Do lp = 1,npair
            Call icopy(lmax,[0],0,icoord,1)
            Do i = 1,lmax
              icoord(i) = ibas(nb1,i)
            End Do

            lb1 = i_pair(lp ,1)
            lb2 = i_pair(lp ,2)
            i1  =   nind(lb1,1)
            i2  =   nind(lb2,1)
            is1 = icoord(lb1) + 1
            is2 = icoord(lb2) + 1
            Do js1 = 1, nexch(i1)
              icoord(lb1) = js1 - 1
              Do js2 = 1, nexch(i2)
                icoord(lb2) = js2 - 1
                nb2 = norder(icoord,intc,lmax)
                HTOT(nb1,nb2)=HTOT(nb1,nb2) + HKEX(lp,is1,js1,is2,js2)
              End Do ! js2
            End Do ! js1
          End Do ! lp
        End Do !nb1
        ! diagonalize
        info=0
        lwork=0
        lwork=2*exch-1
        Call dcopy_((3*exch-2),[0.0_wp],0,rwork,1)
        Call zcopy_((2*exch-1),[(0.0_wp,0.0_wp)],0,WORK,1)
        Call zheev('n','u',exch,htot,exch,wkex,work,lwork,rwork,info)
      End If



!----------------------------------------------------------------------!
      If(JITO_exchange) Then
        Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,HTOT,1)
        Do nb1 = 1,exch
          Do lp = 1,npair
            Call icopy(lmax,[0],0,icoord,1)
            Do i = 1,lmax
              icoord(i) = ibas(nb1,i)
            End Do

            lb1 = i_pair(lp ,1)
            lb2 = i_pair(lp ,2)
            i1  =   nind(lb1,1)
            i2  =   nind(lb2,1)
            is1 = icoord(lb1) + 1
            is2 = icoord(lb2) + 1
            Do js1 = 1, nexch(i1)
              icoord(lb1) = js1 - 1
              Do js2 = 1, nexch(i2)
                icoord(lb2) = js2 - 1
                nb2 = norder(icoord,intc,lmax)
                HTOT(nb1,nb2)=HTOT(nb1,nb2) + HITO(lp,is1,js1,is2,js2)
              End Do ! js2
            End Do ! js1
          End Do ! lp
        End Do !nb1
        ! diagonalize
        info=0
        lwork=0
        lwork=2*exch-1
        Call dcopy_((3*exch-2),[0.0_wp],0,rwork,1)
        Call zcopy_((2*exch-1),[(0.0_wp,0.0_wp)],0,WORK,1)
        Call zheev('n','u',exch,htot,exch,wito,work,lwork,rwork,info)
      End If



!----------------------------------------------------------------------!
      !cccccccc  total Hamiltonian cccccccc
      Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,HTOT,1)
      Do nb1 = 1,exch
        Do lp = 1,npair
          Call icopy(lmax,[0],0,icoord,1)
          Do i = 1,lmax
            icoord(i) = ibas(nb1,i)
          End Do

          lb1 = i_pair(lp ,1)
          lb2 = i_pair(lp ,2)
          i1  =   nind(lb1,1)
          i2  =   nind(lb2,1)
          is1 = icoord(lb1) + 1
          is2 = icoord(lb2) + 1
          Do js1 = 1, nexch(i1)
            icoord(lb1) = js1 - 1
            Do js2 = 1, nexch(i2)
              icoord(lb2) = js2 - 1
              nb2 = norder(icoord,intc,lmax)

              HTOT(nb1,nb2)= HTOT(nb1,nb2)
     &                     + HLIN1(lp,is1,js1,is2,js2)
     &                     + HLIN3(lp,is1,js1,is2,js2)
     &                     + HLIN9(lp,is1,js1,is2,js2)
     &                     +  HDIP(lp,is1,js1,is2,js2)
     &                     +  HKEX(lp,is1,js1,is2,js2)
     &                     +  HITO(lp,is1,js1,is2,js2)
            End Do ! js2
          End Do ! js1
        End Do ! lp

        If(.not.KE) Then
          l=0
          lb=1
          Do i = 1, nneq
            Do j = 1, neq(i)
              l = l + 1
              If( l.eq.lb ) Then
                !kind=8, complex double precision
                HTOT(nb1,nb1)=HTOT(nb1,nb1)+
     &                        cmplx(eso(i,ibas(nb1,lb)+1),0.0_wp,wp)
                If((lb+1).le.(lmax)) lb=lb+1
              End If
            End Do !j
          End Do !i
        End If ! .not. KE
      End Do !nb1
c diagonalize
      info =0
      lwork=0
      lwork=2*exch-1
      Call dcopy_((3*exch-2),[0.0_wp],0,rwork,1)
      Call zcopy_((2*exch-1),[(0.0_wp,0.0_wp)],0,WORK,1)
      Call zheev('v','u',exch,htot,exch,w,work,lwork,rwork,info)
      If (info.eq.0) Then
         Call zcopy_(exch*exch,htot,1,Z,1)
      Else
         Write(6,'(A,i10)') 'DIAG:  non-zero Return: INFO=', info
      End If

!----------------------------------------------------------------------!
! deallocate memory:
      If( exch >= 0 ) Then
         Call mma_deallocate(HTOT)
         Call mma_deallocate(WORK)
         If( lmax >= 0 ) Then
            Call mma_deallocate(ibas)
         End If
         Call mma_deallocate(rwork)
      End If

      If( lmax >= 0 ) Then
         Call mma_deallocate(nind)
         Call mma_deallocate(intc)
         Call mma_deallocate(icoord)
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************
!SVC: compute RHS elements "on demand". If we have access to all the
! Cholesky vectors, we can just instruct a process to compute its own
! block of RHS elements, computing the integrals directly. This is much
! more computationally intensive, but should scale much better since we
! go from a badly scaling scatter algorithm to no communication at all.
! This also eliminates the need for the GA library in creating the RHS.
! FIXME: optimizations needed, remove double computation of integrals

subroutine RHSOD(IVEC)

use PrintLevel, only: VERBOSE
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use caspt2_global, only: iPrGlb
#ifdef _DEBUGPRINT_
use caspt2_module, only: NASUP, NISUP, NSYM
use Definitions, only: wp
#endif
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iVec
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ICASE, ISYM, lg_W, NAS, NIS
real(kind=wp) :: DNRM2
real(kind=wp), external :: RHS_DDot
#endif

if (IPRGLB >= VERBOSE) write(u6,'(1X,A)') ' Using RHS on-demand algorithm'

#ifdef _MOLCAS_MPP_
if (.not. Is_Real_Par()) then
  write(u6,'(1X,A)') 'RHSOD: error: fake parallel not supported'
  call AbEnd()
end if
#endif

call RHSOD_A(IVEC)
call RHSOD_B(IVEC)
call RHSOD_C(IVEC)
call RHSOD_D(IVEC)
call RHSOD_E(IVEC)
call RHSOD_F(IVEC)
call RHSOD_G(IVEC)
call RHSOD_H(IVEC)

#ifdef _DEBUGPRINT_
! compute and print RHS fingerprints
write(u6,'(1X,A4,1X,A3,1X,A18)') 'Case','Sym','Fingerprint'
write(u6,'(1X,A4,1X,A3,1X,A18)') '====','===','==========='
do ICASE=1,13
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (NAS*NIS /= 0) then
      call RHS_ALLO(NAS,NIS,lg_W)
      call RHS_READ(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
      DNRM2 = RHS_DDOT(NAS,NIS,lg_W,lg_W)
      write(u6,'(1X,I4,1X,I3,1X,F18.11)') ICASE,ISYM,DNRM2
    end if
  end do
end do
#endif

end subroutine RHSOD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Johan Lorentzon                                  *
!               1993, Jeppe Olsen                                      *
!               1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Rd2Int(iPL)
!***********************************************************************
!                                                                      *
!     Read header of the two-electron integral file                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     J. Lorentzon, J. Olsen and M.P. Fuelscher                        *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use input_mclr, only: CasInt, nBas, nSkip, nSym, TimeDep
use Molcas, only: MxSym
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPL
integer(kind=iwp) :: iRC, iSym, nBasX(mxSym), nSymX, ntSkip
logical(kind=iwp) :: SqSym

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
iRc = -1
call GetOrd(iRc,SqSym,nSymX,nBasX,nSkip)
if (iRc /= 0) then
  write(u6,*) 'Rd2Int: Error reading ORDINT'
  call Abend()
end if
if (iPL >= 2) then
  if (SqSym) write(u6,*) 'OrdInt status: squared'
  if (.not. SqSym) write(u6,*) 'OrdInt status: non-squared'
end if
if (nSymX /= nSym) then
  write(u6,*) 'Rd2Int: nSymX /= nSym'
  write(u6,*) 'nSymX,nSym=',nSymX,nSym
  call Abend()
end if
do iSym=1,nSym
  if (nBas(iSym) /= nBasX(iSym)) then
    write(u6,*) 'Rd2Int: nBas(iSym) /= nBasX(iSym)'
    write(u6,*) 'nBas(iSym),nBasX(iSym)=',nBas(iSym),nBasX(iSym)
    call Abend()
  end if
end do
ntSkip = sum(nSkip(1:nSym))
if (ntSkip /= 0) then
  write(u6,*) 'Rd2Int: ntSkip /= 0'
  write(u6,*) 'ntSkip=',ntSkip
  call Abend()
end if
if ((.not. SqSym) .and. (.not. TimeDep)) then
  CASINT = .true.
else
  CASINT = .false.
end if
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine Rd2Int

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Module PSO_Stuff
      Logical lPSO,lsa, Case_3C, Case_2C, Case_mp2
      Integer nnP(0:7), iOff_ij2K(8),npos(0:7,3),ipAOrb(0:7,2)
      Real*8, Allocatable:: DMdiag(:,:), Thpkl(:), G2(:,:), CMO(:,:),
     &                      Txy(:,:), V_k(:,:), U_k(:), Z_p_k(:,:),
     &                      G1(:,:), D0(:,:), DVar(:,:), DS(:), DSVar(:)
      Integer, Allocatable:: ij2K(:)
      Integer nG2, mG2
      Integer nG1, mG1
      Integer mCMO, kCMO
      Integer nDens, mDens
      Integer n_Txy, m_Txy
      Integer n_ij2K
      Integer nZ_p_k
      Integer nV_K, nSOs1
      Integer iD0Lbl
      End Module PSO_Stuff

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1998  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE COMMWEW(IVEC,JVEC,DCOM)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "stdalloc.fh"
      DIMENSION DCOM(NASHT,NASHT)
      REAL*8, ALLOCATABLE :: CBLK(:), TBLK(:), SMAT(:)

C This subroutine is one of the components needed to compute the active/active
C transition density matrix elements for the two first-order vectors IVEC and
C JVEC.
C Adds, into the matrix DCOM, a correction obtained by commutation relations.
C Present assumption: The two vectors nr. IVEC and JVEC, stored on LUSOLV,
C are both in contravariant representation. Possibly, IVEC equals JVEC.

      DO ICASE=1,11
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          NCBLK=NAS*NIS
CTEST       WRITE(*,*)' COMMWEW ISYM,ICASE:',ISYM,ICASE
CTEST       WRITE(*,*)'                NAS:',NAS
CTEST       WRITE(*,*)'                NIS:',NIS
CTEST       WRITE(*,*)'              NCBLK:',NCBLK
          IF(NCBLK.EQ.0) GOTO 200
C Allocate CBLK, TBLK
          CALL MMA_ALLOCATE(CBLK,NCBLK)
          CALL MMA_ALLOCATE(TBLK,NCBLK)
C First, read in the ICASE, ISYM block of coefficients from JVEC into CBLK:
C Note carefully, this is not a mistake: vector JVEC into CBLK it is!
          CALL RDBLKC(ISYM,ICASE,JVEC,CBLK)
C Allocate overlap matrix:
          NS=(NAS*(NAS+1))/2
          CALL MMA_ALLOCATE(SMAT,NS)
          IDS=IDSMAT(ISYM,ICASE)
C          CALL DAFILE(LUSBT,2,SMAT,RtoI*NS,IDS)
          CALL DDAFILE(LUSBT,2,SMAT,NS,IDS)
C Compute TBLK as the covariant representation of vector JVEC, by multiplying
C with the overlap matrix. Then get rid of the overlap matrix.
          CALL DCOPY_(NCBLK,[0.0D0],0,TBLK,1)
          CALL TRIMUL(NAS,NIS,1.0D00,SMAT,CBLK,NAS,TBLK,NAS)
          CALL MMA_DEALLOCATE(SMAT)
C Finally, if IVEC not equals JVEC, read in the contravariant block of vector
C IVEC into CBLK:
          IF(IVEC.NE.JVEC) THEN
            CALL RDBLKC(ISYM,ICASE,IVEC,CBLK)
          END IF
C Finally, branch to the appropriate code section:
          GOTO(1,2,3,4,5,6,7,8,9,10,11) ICASE

C Case 1 code section:
   1  CONTINUE
      K000=NTUVES(ISYM)

      DO ISYMX=1,NSYM
        NAX=NASH(ISYMX)
        DO IX=1,NAX
          IXABS=NAES(ISYMX)+IX
          DO IY=1,NAX
            IYABS=NAES(ISYMX)+IY

            SUM=0.0D0
            ISYMTU=MUL(ISYMX,ISYM)
            DO ITABS=1,NASHT
              ISYMT=IASYM(ITABS)
              ISYMU=MUL(ISYMT,ISYMTU)
              DO IU=1,NASH(ISYMU)
                IUABS=NAES(ISYMU)+IU

                IYTU=KTUV(IYABS,ITABS,IUABS)-K000
                IXTU=KTUV(IXABS,ITABS,IUABS)-K000
                ITYU=KTUV(ITABS,IYABS,IUABS)-K000
                ITXU=KTUV(ITABS,IXABS,IUABS)-K000
                ITUY=KTUV(ITABS,IUABS,IYABS)-K000
                ITUX=KTUV(ITABS,IUABS,IXABS)-K000

                DO IIS=1,NIS
                  SUM=SUM+CBLK(IXTU+NAS*(IIS-1))
     &                                *TBLK(IYTU+NAS*(IIS-1))
                  SUM=SUM+CBLK(ITXU+NAS*(IIS-1))
     &                                *TBLK(ITYU+NAS*(IIS-1))
                  SUM=SUM-CBLK(ITUY+NAS*(IIS-1))
     &                                *TBLK(ITUX+NAS*(IIS-1))
                END DO

              END DO
            END DO
            DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

          END DO
        END DO
      END DO
      GOTO 100

C Case 2 code section:
   2  CONTINUE
      DO ISYMX=1,NSYM
        NAX=NASH(ISYMX)
        DO IX=1,NAX
          IXABS=NAES(ISYMX)+IX
          DO IY=1,NAX
            IYABS=NAES(ISYMX)+IY

            SUM=0.0D0
            ISYMT=MUL(ISYMX,ISYM)
            DO IT=1,NASH(ISYMT)
              ITABS=NAES(ISYMT)+IT
              IF(ITABS.GE.IXABS) THEN
                IXT=KTGEU(ITABS,IXABS)-NTGEUES(ISYM)
              ELSE
                IXT=KTGEU(IXABS,ITABS)-NTGEUES(ISYM)
              END IF
              IF(ITABS.GE.IYABS) THEN
                IYT=KTGEU(ITABS,IYABS)-NTGEUES(ISYM)
              ELSE
                IYT=KTGEU(IYABS,ITABS)-NTGEUES(ISYM)
              END IF
              PARTSUM=0.0d0
              DO IIS=1,NIS
                PARTSUM=PARTSUM+CBLK(IXT+NAS*(IIS-1))
     &                               *TBLK(IYT+NAS*(IIS-1))
              END DO
              IF(ITABS.EQ.IXABS) PARTSUM=2.0D0*PARTSUM
              SUM=SUM+PARTSUM
            END DO
            DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

          END DO
        END DO
      END DO
      GOTO 100

C Case 3 code section:
   3  CONTINUE
      DO ISYMX=1,NSYM
        NAX=NASH(ISYMX)
        DO IX=1,NAX
          IXABS=NAES(ISYMX)+IX
          DO IY=1,NAX
            IYABS=NAES(ISYMX)+IY

            SUM=0.0D0
            ISYMT=MUL(ISYMX,ISYM)
            DO IT=1,NASH(ISYMT)
              ITABS=NAES(ISYMT)+IT
              IF(ITABS.EQ.IXABS) GOTO 390
              IF(ITABS.EQ.IYABS) GOTO 390
              IF(ITABS.GT.IXABS) THEN
                IXT=KTGTU(ITABS,IXABS)-NTGTUES(ISYM)
                SGN=1.0d0
              ELSE
                IXT=KTGTU(IXABS,ITABS)-NTGTUES(ISYM)
                SGN=-1.0d0
              END IF
              IF(ITABS.GT.IYABS) THEN
                IYT=KTGTU(ITABS,IYABS)-NTGTUES(ISYM)
              ELSE
                IYT=KTGTU(IYABS,ITABS)-NTGTUES(ISYM)
                SGN=-SGN
              END IF
              PARTSUM=0.0d0
              DO IIS=1,NIS
                PARTSUM=PARTSUM+CBLK(IXT+NAS*(IIS-1))
     &                                *TBLK(IYT+NAS*(IIS-1))
              END DO
              SUM=SUM+SGN*PARTSUM

 390          CONTINUE
            END DO
            DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

          END DO
        END DO
      END DO
      GOTO 100

C Case 4 code section:
   4  CONTINUE
      K000=NTUVES(ISYM)

      DO ISYMX=1,NSYM
        NAX=NASH(ISYMX)
        DO IX=1,NAX
          IXABS=NAES(ISYMX)+IX
          DO IY=1,NAX
            IYABS=NAES(ISYMX)+IY

            SUM=0.0D0
            ISYMTU=MUL(ISYMX,ISYM)
            DO ITABS=1,NASHT
              ISYMT=IASYM(ITABS)
              ISYMU=MUL(ISYMT,ISYMTU)
              DO IU=1,NASH(ISYMU)
                IUABS=NAES(ISYMU)+IU

                IYTU=KTUV(IYABS,ITABS,IUABS)-K000
                IXTU=KTUV(IXABS,ITABS,IUABS)-K000
                ITYU=KTUV(ITABS,IYABS,IUABS)-K000
                ITXU=KTUV(ITABS,IXABS,IUABS)-K000
                ITUY=KTUV(ITABS,IUABS,IYABS)-K000
                ITUX=KTUV(ITABS,IUABS,IXABS)-K000

                DO IIS=1,NIS
                  SUM=SUM-CBLK(IYTU+NAS*(IIS-1))
     &                         *TBLK(IXTU+NAS*(IIS-1))
                  SUM=SUM+CBLK(ITXU+NAS*(IIS-1))
     &                         *TBLK(ITYU+NAS*(IIS-1))
                  SUM=SUM-CBLK(ITUY+NAS*(IIS-1))
     &                         *TBLK(ITUX+NAS*(IIS-1))
                END DO

              END DO
            END DO
            DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

          END DO
        END DO
      END DO
      GOTO 100

C Case 5 code section:
   5  CONTINUE
      NAS1=NAS/2

      DO ISYMX=1,NSYM
        NAX=NASH(ISYMX)
        DO IX=1,NAX
          IXABS=NAES(ISYMX)+IX
          DO IY=1,NAX
            IYABS=NAES(ISYMX)+IY

            SUM=0.0D0
            ISYMT=MUL(ISYMX,ISYM)
            DO IT=1,NASH(ISYMT)
              ITABS=NAES(ISYMT)+IT
              IXT1=KTU(IXABS,ITABS)-NTUES(ISYM)
              IYT1=KTU(IYABS,ITABS)-NTUES(ISYM)
              ITX1=KTU(ITABS,IXABS)-NTUES(ISYM)
              ITY1=KTU(ITABS,IYABS)-NTUES(ISYM)
              IXT2=IXT1+NAS1
              IYT2=IYT1+NAS1
              ITX2=ITX1+NAS1
              ITY2=ITY1+NAS1
              DO IIS=1,NIS
                SUM=SUM+CBLK(IXT1+NAS*(IIS-1))
     &                      *TBLK(IYT1+NAS*(IIS-1))
                SUM=SUM-CBLK(ITY1+NAS*(IIS-1))
     &                      *TBLK(ITX1+NAS*(IIS-1))
                SUM=SUM+CBLK(IXT2+NAS*(IIS-1))
     &                      *TBLK(IYT2+NAS*(IIS-1))
                SUM=SUM-CBLK(ITY2+NAS*(IIS-1))
     &                      *TBLK(ITX2+NAS*(IIS-1))
              END DO
            END DO
            DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

          END DO
        END DO
      END DO
      GOTO 100

C Case 6 code section:
   6  CONTINUE
      NAX=NASH(ISYM)
      DO IX=1,NAX
        IXABS=NAES(ISYM)+IX
        DO IY=1,NAX
          IYABS=NAES(ISYM)+IY

          SUM=0.0D0
          DO IIS=1,NIS
            SUM=SUM+CBLK(IX+NAS*(IIS-1))
     &                      *TBLK(IY+NAS*(IIS-1))
          END DO
          DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

        END DO
      END DO
      GOTO 100

C Case 7 code section:
   7  CONTINUE
      NAX=NASH(ISYM)
      DO IX=1,NAX
        IXABS=NAES(ISYM)+IX
        DO IY=1,NAX
          IYABS=NAES(ISYM)+IY

          SUM=0.0D0
          DO IIS=1,NIS
            SUM=SUM+CBLK(IX+NAS*(IIS-1))
     &                   *TBLK(IY+NAS*(IIS-1))
          END DO
          DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

        END DO
      END DO
      GOTO 100

C Case 8 code section:
   8  CONTINUE
      DO ISYMX=1,NSYM
        NAX=NASH(ISYMX)
        DO IX=1,NAX
          IXABS=NAES(ISYMX)+IX
          DO IY=1,NAX
            IYABS=NAES(ISYMX)+IY

            SUM=0.0D0
            ISYMT=MUL(ISYMX,ISYM)
            DO IT=1,NASH(ISYMT)
              ITABS=NAES(ISYMT)+IT
              IF(ITABS.GE.IXABS) THEN
                IXT=KTGEU(ITABS,IXABS)-NTGEUES(ISYM)
              ELSE
                IXT=KTGEU(IXABS,ITABS)-NTGEUES(ISYM)
              END IF
              IF(ITABS.GE.IYABS) THEN
                IYT=KTGEU(ITABS,IYABS)-NTGEUES(ISYM)
              ELSE
                IYT=KTGEU(IYABS,ITABS)-NTGEUES(ISYM)
              END IF
              PARTSUM=0.0d0
              DO IIS=1,NIS
                PARTSUM=PARTSUM-CBLK(IYT+NAS*(IIS-1))
     &                       *TBLK(IXT+NAS*(IIS-1))
              END DO
              IF(ITABS.EQ.IYABS) PARTSUM=2.0D0*PARTSUM
              SUM=SUM+PARTSUM

            END DO
            DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

          END DO
        END DO
      END DO
      GOTO 100

C Case 9 code section:
   9  CONTINUE
      DO ISYMX=1,NSYM
        NAX=NASH(ISYMX)
        DO IX=1,NAX
          IXABS=NAES(ISYMX)+IX
          DO IY=1,NAX
            IYABS=NAES(ISYMX)+IY

            SUM=0.0D0
            ISYMT=MUL(ISYMX,ISYM)
            DO IT=1,NASH(ISYMT)
              ITABS=NAES(ISYMT)+IT
              IF(ITABS.EQ.IXABS) GOTO 990
              IF(ITABS.EQ.IYABS) GOTO 990
              IF(ITABS.GT.IXABS) THEN
                IXT=KTGTU(ITABS,IXABS)-NTGTUES(ISYM)
                SGN=1.0d0
              ELSE
                IXT=KTGTU(IXABS,ITABS)-NTGTUES(ISYM)
                SGN=-1.0d0
              END IF
              IF(ITABS.GT.IYABS) THEN
                IYT=KTGTU(ITABS,IYABS)-NTGTUES(ISYM)
              ELSE
                IYT=KTGTU(IYABS,ITABS)-NTGTUES(ISYM)
                SGN=-SGN
              END IF
              PARTSUM=0.0d0
              DO IIS=1,NIS
                PARTSUM=PARTSUM-CBLK(IYT+NAS*(IIS-1))
     &                               *TBLK(IXT+NAS*(IIS-1))
              END DO
              SUM=SUM+SGN*PARTSUM

 990          CONTINUE
            END DO
            DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

          END DO
        END DO
      END DO
      GOTO 100

C Case 10 code section:
  10  CONTINUE
      NAX=NASH(ISYM)
      DO IX=1,NAX
        IXABS=NAES(ISYM)+IX
        DO IY=1,NAX
          IYABS=NAES(ISYM)+IY

          SUM=0.0D0
          DO IIS=1,NIS
            SUM=SUM-CBLK(IY+NAS*(IIS-1))
     &                   *TBLK(IX+NAS*(IIS-1))
          END DO
          DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

        END DO
      END DO
      GOTO 100

C Case 11 code section:
  11  CONTINUE
      NAX=NASH(ISYM)
      DO IX=1,NAX
        IXABS=NAES(ISYM)+IX
        DO IY=1,NAX
          IYABS=NAES(ISYM)+IY

          SUM=0.0D0
          DO IIS=1,NIS
            SUM=SUM-CBLK(IY+NAS*(IIS-1))
     &                   *TBLK(IX+NAS*(IIS-1))
          END DO
          DCOM(IXABS,IYABS)=DCOM(IXABS,IYABS)+SUM

        END DO
      END DO
      GOTO 100


 100  CONTINUE
      CALL MMA_DEALLOCATE(CBLK)
      CALL MMA_DEALLOCATE(TBLK)

 200  CONTINUE

C Here ends the loops over ISYM and ICASE.
        END DO
      END DO

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Print_qEVec2(nH,EVal,EVec)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nH
real(kind=wp), intent(in) :: EVal(nTri_Elem(nH)), EVec(nH,nH)
integer(kind=iwp) :: iiQQ, iLines, IncQQ, iq, iQQ, j, Lu_UDIC, mQQ
character(len=120) :: Temp
character(len=14) :: cLbl
character(len=14), allocatable :: qLbl(:)
integer(kind=iwp), external :: IsFreeUnit

! Skip Primitive Coords

Lu_UDIC = IsFreeUnit(91)
Temp = 'UDIC'
call molcas_open(Lu_UDIC,Temp)
do
  read(Lu_UDIC,'(A)') Temp
  call UpCase(Temp)
  if (Temp(1:4) == 'VARY') exit
end do

! Read Internal Coords Labels

call mma_allocate(qLbl,nH,Label='qLbl')

do iLines=1,nH
  read(Lu_UDIC,'(A)') Temp
  call UpCase(Temp)
  if (Temp(1:3) == 'FIX') cycle
  cLbl = ' '
  do j=1,14
    if ((Temp(j:j) == ' ') .or. (Temp(j:j) == '=')) exit
    cLbl(j:j) = Temp(j:j)
  end do
  qLbl(iLines) = cLbl
end do

IncQQ = 5
do iiQQ=1,nH,IncQQ
  mQQ = min(nH,iiQQ+IncQQ-1)
  write(u6,*)
  write(u6,'(14X,5I10)') (iQQ,iQQ=iiQQ,mQQ)
  write(u6,'(1X,A,5F10.6)') 'Eigenvalues   ',(EVal(nTri_Elem(iQQ)),iQQ=iiQQ,mQQ)
  write(u6,*)
  do iq=1,nH
    write(u6,'(1X,A,5F10.6)') qLbl(iq),EVec(iq,iiQQ:mQQ)
  end do
  write(u6,*)
end do

call mma_deallocate(qLbl)

close(Lu_UDIC)

return

end subroutine Print_qEVec2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dkh_ts1e(n,s,t,v,w,ul,us,clight,dkord,xord,dkparam)
! Evaluate the arbitrary order DKH Hamiltonian ( and transform matrices ul & us )

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
! v : store the transformed relativistic one-electron Hamiltonian
integer(kind=iwp), intent(in) :: n, dkord, xord, dkparam
real(kind=wp), intent(in) :: s(n,n), t(n,n), w(n,n), clight
real(kind=wp), intent(inout) :: v(n,n)
real(kind=wp), intent(out) :: ul(n,n), us(n,n)
integer(kind=iwp) :: word, vord, n2
real(kind=wp), allocatable :: Tr(:,:), Bk(:,:), El(:,:), ES(:,:), OL(:,:), OS(:,:), Ep(:), E0(:), KC(:,:), Ws(:,:,:), Co(:), &
                              MW(:,:,:), ZW(:,:,:,:), SCo(:), XL(:,:), XS(:,:)

! Transform Hamiltonian matrix to the free-particle Foldy-Wouthuysen picture

call mma_allocate(Tr,n,n,label='Tr')
call mma_allocate(Bk,n,n,label='Back')
call mma_allocate(EL,n,n,label='mEL')
call mma_allocate(ES,n,n,label='mES')
call mma_allocate(OL,n,n,label='mOL')
call mma_allocate(OS,n,n,label='mOS')
call mma_allocate(Ep,n,label='Ep')
call mma_allocate(E0,n,label='E0')
call mma_allocate(KC,n,3,label='KC')
call XDR_fpFW(n,s,t,v,w,Tr,Bk,EL,ES,OL,OS,Ep,E0,KC(:,1),KC(:,2),KC(:,3),clight)

! Call DKH transformation routines

! number of W matrices needed
word = max(dkord/2,xord)
! order of DKH needed, since high Xorder may need more transformation than DKHorder (for Hamiltonian)
vord = max(dkord,word*2)
call mma_allocate(Ws,n,n,xord*2,label='Wsav')
call mma_allocate(Co,max(4,vord),label='Cof')
! calculate expansion coefficient of general unitary transformation ( in terms of anti-Hermitian W )
call dkh_cofu(vord,dkparam,Co)

if (dkparam == 2) then
  ! special routine for EXP parameterization ( with fewer matrix multiplication than general routine )
  call mma_allocate(MW,n,n,5,label='NWork')
  call mma_allocate(ZW,n,n,vord,3,label='NNWork')
  MW(:,:,:) = Zero
  ZW(:,:,:,:) = Zero
  call AODKHEXP(n,vord,xord,dkord,Ep,E0,EL,ES,OL,MW(:,:,1),MW(:,:,2),MW(:,:,3),MW(:,:,4),MW(:,:,5),ZW(:,:,:,1),ZW(:,:,:,2), &
                ZW(:,:,:,3),Ws)
  call mma_deallocate(MW)
  call mma_deallocate(ZW)
else
  ! general parameterization routine
  call mma_allocate(SCo,vord,label='Cof2')
  call mma_allocate(MW,n,n,6,label='Mat')
  call mma_allocate(ZW,n,n,vord,10,label='Mat2')
  call dkh_ham(n,dkord,xord,vord,EL,ES,OL,OS,Ep,E0,Co,Sco,MW(:,:,1),MW(:,:,2),MW(:,:,3),MW(:,:,4),MW(:,:,5),MW(:,:,6),ZW(:,:,:,1), &
               ZW(:,:,:,2),ZW(:,:,:,3),ZW(:,:,:,4),ZW(:,:,:,5),ZW(:,:,:,6),ZW(:,:,:,7),ZW(:,:,:,8),ZW(:,:,:,9),ZW(:,:,:,10),Ws)
  call mma_deallocate(SCo)
  call mma_deallocate(MW)
  call mma_deallocate(ZW)
end if

! Calculate the transform matrices

if (xord > 0) then
  call mma_allocate(XL,n,n,label='fpUL')
  call mma_allocate(XS,n,n,label='fpUS')
  n2 = n+n
  call mma_allocate(MW,n2,n2,3,label='TmpZ')
  ! obtain transform matrices ( XL and XS )in fpFW picture
  call dkh_geneu(n,n2,xord,Co,Ws,XL,XS,MW(:,:,1),MW(:,:,2),MW(:,:,3))
  call mma_deallocate(MW)

  call mma_allocate(MW,n,n,4,label='TmpM')
  ! convert to original basis picture
  call XDR_mkutls(n,XL,XS,Tr,Bk,KC(:,1),KC(:,2),KC(:,3),ul,us,MW(:,:,1),MW(:,:,2),MW(:,:,3),MW(:,:,4))
  call mma_deallocate(MW)
  call mma_deallocate(XL)
  call mma_deallocate(XS)
end if

! Back transform Hamiltonian matrix to original non-orthogonal basis picture

call dmxma(n,'C','N',Bk,EL,ES,One)
call dmxma(n,'N','N',ES,Bk,v,One)

! Free temp memories

call mma_deallocate(Co)
call mma_deallocate(Ws)
call mma_deallocate(Tr)
call mma_deallocate(Bk)
call mma_deallocate(EL)
call mma_deallocate(ES)
call mma_deallocate(OL)
call mma_deallocate(OS)
call mma_deallocate(Ep)
call mma_deallocate(E0)
call mma_deallocate(KC)

return

end subroutine dkh_ts1e

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoLSOSMP2_Energy_Fll1(N,w,t,EOcc,EVir,Delete,EMP2,irc)
!
! Thomas Bondo Pedersen, December 2012.
!
! Compute Laplace-SOS-MP2 energy correction from full Cholesky
! vectors (i.e., not batched), reading the vectors only once
! at the expense of memory.

use Symmetry_Info, only: Mul
use Cholesky, only: nSym, NumCho
use ChoMP2, only: DecoMP2, iOcc, iT1am, iVir, Laplace_BlockSize, Laplace_nGridPoints, lUnit_f, nBatch, nMP2Vec, nOcc, nT1am, nVir
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: w(N), t(N), EOcc(*), EVir(*)
logical(kind=iwp), intent(in) :: Delete
real(kind=wp), intent(out) :: EMP2
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: a, i, iAddr, iBlock, iClos, iOpt, ip0, ip1, ipi, ipj, iSym, iSyma, iSymi, iTyp, iVec, jBlock, l_Tot, l_X, &
                     Nai, nBlock, nEnrVec(8), nVeci, nVecj, q
real(kind=wp) :: Eq, tq
real(kind=wp), allocatable :: V(:,:), X(:)
real(kind=wp), external :: dDot_

! init return code
irc = 0

! init energy
EMP2 = Zero

! check input (incl. common block variables)
if (nBatch /= 1) then
  irc = -1
  return
end if
if (N /= Laplace_nGridPoints) then
  irc = -2
  return
end if
if (Laplace_BlockSize < 1) then
  irc = -3
  return
end if

! determine if files are to be deleted after use
if (Delete) then
  iClos = 3
else
  iClos = 2
end if

! set number and type of vectors
if (DecoMP2) then
  iTyp = 2
  nEnrVec(1:nSym) = nMP2Vec(1:nSym)
else
  iTyp = 1
  nEnrVec(1:nSym) = NumCho(1:nSym)
end if

! compute energy correction
do iSym=1,nSym
  Nai = nT1am(iSym)
  if ((Nai > 0) .and. (nEnrVec(iSym) > 0)) then
    ! set vector block size and allocate X matrix
    l_X = min(Laplace_BlockSize,nEnrVec(iSym))
    l_X = l_X**2
    call mma_allocate(X,l_X,Label='X')
    ! compute number of vector blocks
    nBlock = (nEnrVec(iSym)-1)/Laplace_BlockSize+1
    ! open vector file
    call ChoMP2_OpenF(1,iTyp,iSym)
    ! allocate memory for vectors
    l_Tot = Nai*nEnrVec(iSym)
    call mma_allocate(V,l_Tot,2,Label='V')
    ! Read all vectors
    iOpt = 2
    iAddr = 1
    call dDAFile(lUnit_F(iSym,iTyp),iOpt,V(:,1),l_Tot,iAddr)
    ! loop over Laplace grid
    do q=1,N
      ! init energy for this q
      Eq = Zero
      ! scale grid point by 1/2
      tq = Half*t(q)
      ! scale vectors
      V(:,2) = V(:,1)
      do iVec=1,nEnrVec(iSym)
        ip0 = Nai*(iVec-1)
        do iSymi=1,nSym
          iSyma = Mul(iSym,iSymi)
          ip1 = ip0+iT1am(iSyma,iSymi)
          do i=1,nOcc(iSymi)
            V(ip1+nVir(iSyma)*(i-1)+1:ip1+nVir(iSyma)*i,2) = exp(EOcc(iOcc(iSym)+i)*tq)* &
                                                             V(ip1+nVir(iSyma)*(i-1)+1:ip1+nVir(iSyma)*i,2)
          end do
          do a=1,nVir(iSyma)
            call dScal_(nOcc(iSymi),exp(-EVir(iVir(iSyma)+a)*tq),V(ip1+a,2),nVir(iSyma))
          end do
        end do
      end do
      ! loop over vector blocks to compute
      ! X(J,K) = sum_ai L(ai,J)*L(ai,K)*exp(-(e(a)-a(i))*t(q)/2)
      ! Eq += w(q)*sum_JK [X(J,K)]**2
      do jBlock=1,nBlock
        ipj = 1+Nai*Laplace_BlockSize*(jBlock-1)
        if (jBlock == nBlock) then
          nVecj = nEnrVec(iSym)-Laplace_BlockSize*(nBlock-1)
        else
          nVecj = Laplace_BlockSize
        end if
        do iBlock=jBlock,nBlock
          ipi = 1+Nai*Laplace_BlockSize*(iBlock-1)
          if (iBlock == nBlock) then
            nVeci = nEnrVec(iSym)-Laplace_BlockSize*(nBlock-1)
          else
            nVeci = Laplace_BlockSize
          end if
          call dGEMM_('T','N',nVeci,nVecj,Nai,One,V(ipi,2),Nai,V(ipj,2),Nai,Zero,X,nVeci)
          if (iBlock == jBlock) then
            Eq = Eq+Half*dDot_(nVeci*nVecj,X,1,X,1)
          else
            Eq = Eq+dDot_(nVeci*nVecj,X,1,X,1)
          end if
        end do
      end do
      ! accumulate in EMP2
      EMP2 = EMP2-w(q)*Eq
    end do
    ! deallocate memory
    call mma_deallocate(V)
    call mma_deallocate(X)
    ! close (and possibly delete) vector file
    call ChoMP2_OpenF(iClos,iTyp,iSym)
  end if
end do

! Scale energy (only half of X computed)
EMP2 = Two*EMP2

end subroutine ChoLSOSMP2_Energy_Fll1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Domain_Histogram(iDomain,nAtom,nOcc,Title)
! Thomas Bondo Pedersen, January 2006.
!
! Purpose: print histogram of domain sizes.

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtom, nOcc, iDomain(0:nAtom,nOcc)
character(len=*), intent(in) :: Title
integer(kind=iwp) :: i, i_max, i_min, iC, nC
real(kind=wp) :: Fac, Pct, x_ave
integer(kind=iwp), allocatable :: iCount(:)

if ((nAtom < 1) .or. (nOcc < 1)) return

i_min = iDomain(0,1)
i_max = iDomain(0,1)
x_ave = real(iDomain(0,1),kind=wp)
do i=2,nOcc
  i_min = min(i_min,iDomain(0,i))
  i_max = max(i_max,iDomain(0,i))
  x_ave = x_ave+real(iDomain(0,i),kind=wp)
end do
x_ave = x_ave/real(nOcc,kind=wp)

nC = i_max-i_min+1
call mma_allocate(iCount,nC,label='Dm_Histo')
iCount(:) = 0

call Cho_Head(Title,'=',80,u6)
write(u6,'(/,A,3X,I10,/,A,3X,I10,/,A,F13.2)') 'Minimum size:',i_min,'Maximum size:',i_max,'Average size:',x_ave

do i=1,nOcc
  iC = iDomain(0,i)-i_min+1
  iCount(iC) = iCount(iC)+1
end do

Fac = 1.0e2_wp/real(nOcc,kind=wp)
write(u6,*)
do iC=1,nC
  Pct = Fac*real(iCount(iC),kind=wp)
  write(u6,'(A,I10,A,I10,3X,F7.2,A)') 'Number with size',i_min+iC,':',iCount(iC),Pct,'%'
end do

call mma_deallocate(iCount)

end subroutine Domain_Histogram

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine DCore(OneHam,nOH,CMO,TrMat,nCMO,E_Or,nEOr,mynOcc,Ovrlp)
!***********************************************************************
!                                                                      *
!     purpose: Diagonalize core hamiltonian to get starting orbitals.  *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: MaxBas, MaxBOF, MaxORF, nBas, nBO, nBT, nFro, nnFr, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOH, nCMO, nEOr, mynOcc(*)
real(kind=wp), intent(in) :: OneHam(nOH), TrMat(nCMO), Ovrlp(nOH)
real(kind=wp), intent(out) :: CMO(nCMO), E_Or(nEOr)
integer(kind=iwp) :: iCMO, iDum, iE_Or, iErr, iiBT, ij, iSym, nC, nFound, nOF
real(kind=wp) :: Dummy
integer(kind=iwp), allocatable :: Fermi(:)
real(kind=wp), allocatable :: EiVe(:), OHHl(:), OHSq(:), OHTr(:), OMod(:), Scratch(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Allocate memory for modified one-electron hamoltonian
call mma_allocate(OMod,nBT,Label='OMod')

! Allocate memory for squared one-el. Hamiltonian
call mma_allocate(OHSq,MaxBas**2,Label='OHSq')

! Allocate memory for half-transformed one-el. Hamiltonian
call mma_allocate(OHHl,MaxBOF,Label='OHHl')

! Allocate memory for transformed one-electron Hamiltonian
call mma_allocate(OHTr,nTri_Elem(MaxOrF),Label='OHTr')

! Allocate memory for eigenvectors
call mma_allocate(EiVe,MaxOrF**2,Label='EiVe')

! Allocate memory for info on electronic and muonic basis sets
call mma_allocate(Fermi,nEOr,Label='Fermi')
call Get_iArray('Fermion IDs',Fermi,nEOr)

! Modify one-electron hamiltonian
OMod(:) = OneHam(1:nBT)
if (nnFr > 0) call ModFck(OMod,Ovrlp,nBT,TrMat,nBO,mynOcc)

! Diagonalize core in non-frozen molecular basis
ij = 1
iCMO = 1
iE_Or = 1
do iSym=1,nSym

  iiBT = nTri_Elem(nBas(iSym))
  nOF = nOrb(iSym)-nFro(iSym)

  ! Copy frozen vectors to CMO array
  nC = nFro(iSym)*nBas(iSym)
  if (nC > 0) CMO(iCMO:iCMO+nC-1) = TrMat(iCMO:iCMO+nC-1)

  iCMO = iCMO+nBas(iSym)*nFro(iSym)
  iE_Or = iE_Or+nFro(iSym)

  if (nOF > 0) then

    ! Square one-el. Ham. and transform to orthonormal basis.
    !call Square(OMod(ij),nBas(iSym),OHSq,nBas(iSym))
    call Square(OMod(ij),OHSq,1,nBas(iSym),nBas(iSym))
    call DGEMM_('N','N',nBas(iSym),nOF,nBas(iSym), &
                One,OHSq,nBas(iSym), &
                TrMat(iCMO),nBas(iSym), &
                Zero,OHHl,nBas(iSym))
    call DGEMM_Tri('T','N',nOF,nOF,nBas(iSym), &
                   One,TrMat(iCMO),nBas(iSym), &
                   OHHl,nBas(iSym), &
                   Zero,OHTr,nOF)

    ! Put a unit matrix into the eigenvector matrix
    call unitmat(EiVe,nOF)

    ! Add small random number to the one-electron Hamiltonian
    ! Not done here anymore, done in routine scram called by sorb!

    !if (Scrmbl) then
    !  ind = 1
    !  do i=1,nOF
    !    do j=1,i-1
    !      OHTr(ind) = OHTr(ind)+0.05_wp*Random_Molcas(iseed)
    !      ind = ind+1
    !    end do
    !    ind = ind+1
    !  end do
    !end if

    ! Diagonalize and form orbital energies
    call mma_allocate(Scratch,nOF**2,Label='Scratch')
    Dummy = Zero
    iDum = 0
    call Diag_Driver('V','A','L',nOF,OHTr,Scratch,nOF,Dummy,Dummy,iDum,iDum,E_Or(iE_Or),EiVe,nOF,1,-1,'J',nFound,iErr)
    call mma_deallocate(Scratch)

    ! Transform to AO basis
    call DGEMM_('N','N',nBas(iSym),nOF,nOF, &
                One,TrMat(iCMO),nBas(iSym), &
                EiVe,nOF, &
                Zero,CMO(iCMO),nBas(iSym))

  end if

  ! Update pointers
  iCMO = iCMO+nOF*nBas(iSym)
  iE_Or = iE_Or+nOF
  ij = ij+iiBT

end do

! Deallocate memory
call mma_deallocate(Fermi)
call mma_deallocate(EiVe)
call mma_deallocate(OHTr)
call mma_deallocate(OHHl)
call mma_deallocate(OHSq)
call mma_deallocate(OMod)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine DCore

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PXPMem(nRys,MemPXP,la,lb,lr)
*
*     Statement function for Cartesian index
*
      MemPXP=0
      nRys =0
      Call PXMem(nOrder,Mem,la,lb+1,lr-1)
      MemPXP=Max(MemPXP,Mem)
      nRys =Max(nRys,nOrder)
      If (lb.GT.0) Then
         Call PXMem(nOrder,Mem,la,lb-1,lr-1)
         MemPXP=Max(MemPXP,Mem)
         nRys =Max(nRys,nOrder)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine joinamplitudes (wrk,wrksize)
c
c        this routine join contributions to amplitudes (Tn) from all
c        processors. Sum will be placed back to Tn on all machines
c
c        N.B. FREE ZONE in purpose of this routine is the space of
c       free working files V1-V4, .....
c        (free zone is not used in GA)
c        Since T2 amplitudes are no more then oovv, at most V1-V3 space
c        will be demaged. (acutally V1 and V2 only)
c
        use Para_Info, only: nProcs
        implicit none
c
#include "wrk.fh"
#include "ccsd1.fh"
#include "ccsd2.fh"
c
c        help variables
c
        integer ii,length
CLD        integer ii,length,rc,i
c
        if (nProcs.eq.1) return
c
c1        join t13,t14
c
c1.1    calc overall length of t13 and t14 (they must be one after the other)
        ii=mapdt14(0,5)
        length=mapdt14(ii,1)+mapdt14(ii,2)-posst130
c
c1.2        vanish required part in free zone
c        call mv0zero (length,length,wrk(possv10))
c
c1.3        allreduce t13 and t14 into free zone
c        call MPI_ALLREDUCE (wrk(posst130),wrk(possv10),length,
c    c  MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,rc)
c
c1.4        put joined t13,t14 back to t13,t14 place from free zone
c        do i=0,length-1
c        wrk(posst130+i)=wrk(possv10+i)
c        end do
c
c1.om   allreduge t13,t14 together
        call gadgop (wrk(posst130),length,'+')
c
c
c2        join t21,t22,t23
c
c2.1    calc overall length of t21-t23 (they must be one after the other)
        ii=mapdt23(0,5)
        length=mapdt23(ii,1)+mapdt23(ii,2)-posst210
c
c2.2        vanish required part in free zone
c        call mv0zero (length,length,wrk(possv10))
c
c2.3        allreduce t13 and t14 into free zone
c        call MPI_ALLREDUCE (wrk(posst210),wrk(possv10),length,
c    c  MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,rc)
c
c2.4        put joined t21-t23 back to t21-t23 place from free zone
c        do i=0,length-1
c        wrk(posst210+i)=wrk(possv10+i)
c        end do
c
c2.om   allreduge t21-t23 together
        call gadgop (wrk(posst210),length,'+')
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine pop(time,popcount,dgl_csf,density_csf)
!***********************************************************************
! prints diagonal of the density matrix densityt in reqired basis
! at the current time
!***********************************************************************

use rhodyn_data, only: a_einstein, basis, CSF2SO, d, density0, densityt, dgl, dipole_basis, DM_basis, emiss, flag_dipole, &
                       flag_emiss, lu_csf, lu_dip, lu_sf, lu_so, n_freq, nconftot, Nstate, out_dm_csf, out_dm_sf, out_dm_so, &
                       out_emiss, out_fmt, out_fmt_csf, out_tout, pulse_vec, SO_CI, tmp, U_CI_compl
use rhodyn_utils, only: mult, transform
use mh5, only: mh5_put_dset
use Constants, only: Zero, auToFs
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: time
integer(kind=iwp), intent(in) :: popcount
real(kind=wp), intent(out) :: dgl_csf(nconftot)
complex(kind=wp), intent(out) :: density_csf(nconftot,nconftot)
integer(kind=iwp) :: i, j, l
real(kind=wp) :: norm
character(len=64) :: sline

!   here notation d is dimension of all the basis matrices
!!! density0 (can't be) used as a temporary storage for dm in required basis

write(sline,'(f10.3)') time*auToFs
call StatusLine('SpinDyn current time: ',trim(sline))

call mh5_put_dset(out_tout,[time*auToFs],[1],[popcount-1])

if (basis == 'CSF') then

  if ((DM_basis == 'CSF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'ALL')) then
    ! the density in CSF basis
    dgl_csf = [(real(densityt(i,i)),i=1,d)]
    norm = sum(dgl_csf)
    write(lu_csf,out_fmt) time*auToFs,(dgl_csf(i),i=1,d),norm
    call mh5_put_dset(out_dm_csf,dgl_csf,[1,d],[popcount-1,0])
  end if

  if ((DM_basis == 'SF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) then
    ! transform the density from CSF to SF states basis
    call transform(densityt,U_CI_compl,density0)
    dgl(:) = [(real(density0(i,i)),i=1,d)]
    norm = sum(dgl)
    write(lu_sf,out_fmt) time*auToFs,(dgl(i),i=1,d),norm
    call mh5_put_dset(out_dm_sf,dgl,[1,d],[popcount-1,0])
  end if

  if ((DM_basis == 'SO') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) then
    ! transform the density from CSF to SO states basis
    call transform(densityt,CSF2SO,density0)
    dgl(:) = [(real(density0(i,i)),i=1,d)]
    norm = sum(dgl)
    write(lu_so,out_fmt) time*auToFs,(dgl(i),i=1,d),norm
    call mh5_put_dset(out_dm_so,dgl,[1,d],[popcount-1,0])
  end if

else if (basis == 'SF') then

  if ((DM_basis == 'CSF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'ALL')) then
    ! transform the density from SF to CSF states basis
    call transform(densityt,U_CI_compl,density_csf,.false.)
    dgl_csf = [(real(density_csf(i,i)),i=1,nconftot)]
    norm = sum(dgl_csf)
    write(lu_csf,out_fmt_csf) time*auToFs,(dgl_csf(i),i=1,nconftot),norm
    call mh5_put_dset(out_dm_csf,dgl_csf,[1,nconftot],[popcount-1,0])
  end if

  if ((DM_basis == 'SF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) then
    ! the density in SF basis
    dgl(:) = [(real(densityt(i,i)),i=1,d)]
    norm = sum(dgl)
    write(lu_sf,out_fmt) time*auToFs,(dgl(i),i=1,d),norm
    call mh5_put_dset(out_dm_sf,dgl,[1,d],[popcount-1,0])
  end if

  if ((DM_basis == 'SO') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) then
    ! transform the density from SF to SO states basis
    call transform(densityt,SO_CI,density0)
    dgl(:) = [(real(density0(i,i)),i=1,d)]
    norm = sum(dgl)
    write(lu_so,out_fmt) time*auToFs,(dgl(i),i=1,d),norm
    call mh5_put_dset(out_dm_so,dgl,[1,d],[popcount-1,0])
  end if

else if (basis == 'SO') then

  if ((DM_basis == 'CSF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'ALL')) then
    ! transform the density from SO to CSF states basis
    call transform(densityt,CSF2SO,density_csf,.false.)
    dgl_csf = [(real(density_csf(i,i)),i=1,nconftot)]
    norm = sum(dgl_csf)
    write(lu_csf,out_fmt_csf) time*auToFs,(dgl_csf(i),i=1,nconftot),norm
    call mh5_put_dset(out_dm_csf,dgl_csf,[1,nconftot],[popcount-1,0])
  end if

  if ((DM_basis == 'SF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) then
    ! transform the density from SO to SF states basis
    call transform(densityt,SO_CI,density0,.false.)
    dgl(:) = [(real(density0(i,i)),i=1,d)]
    norm = sum(dgl)
    write(lu_sf,out_fmt) time*auToFs,(dgl(i),i=1,d),norm
    call mh5_put_dset(out_dm_sf,dgl,[1,d],[popcount-1,0])
  end if

  if ((DM_basis == 'SO') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) then
    ! the density in SO basis
    dgl(:) = [(real(densityt(i,i)),i=1,d)]
    norm = sum(dgl)
    write(lu_so,out_fmt) time*auToFs,(dgl(i),i=1,d),norm
    call mh5_put_dset(out_dm_so,dgl,[1,d],[popcount-1,0])
  end if
end if

! time-dependent dipole moment
! pulse_vec is used as storage for tr(rho d)
if (flag_dipole) then
  do i=1,3
    call mult(densityt,dipole_basis(:,:,i),tmp)
    dgl(:) = [(real(tmp(i,i)),i=1,d)]
    pulse_vec(i) = sum(dgl)
  end do
  write(lu_dip,'(7(g25.15e3,2x))') time*auToFs,(real(pulse_vec(i)),aimag(pulse_vec(i)),i=1,3)
end if

! emission spectra
if (flag_emiss) then
  ! in dgl the SOC populations are left
  l = 1
  emiss = Zero
  do j=1,(Nstate-1)
    do i=(j+1),Nstate
      emiss(l) = a_einstein(i,j)*dgl(i)
      l = l+1
    end do
  end do
  call mh5_put_dset(out_emiss,emiss,[1,n_freq],[popcount-1,0])
end if

end subroutine pop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine XCff2D(iDum1,iDum2,nRys,
     &                  Zeta,ZInv,rDum3,rDum4,nT,
     &                  Coori,CoorAC,P,Q,
     &                  la,lb,lc,ld,
     &                  U2,PAQP,QCPQ,B10,B00,lac,B01)
************************************************************************
*                                                                      *
* Object: to compute the coefficients in the three terms recurrence    *
*         relation of the 2D-integrals.                                *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
* Modified loop structure for RISC 1991 R. Lindh, Dept. of Theoretical *
* Chemistry, University of Lund, Sweden.                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 Zeta(nT), ZInv(nT),
     &       Coori(3,4), CoorAC(3,2),
     &       P(nT,3), Q(nT,3), U2(nRys,nT),
     &       PAQP(nRys,nT,3), QCPQ(nRys,nT,3),
     &       B10(nRys,nT,3),
     &       B00(nRys,nT,3),
     &       B01(nRys,nT,3)
*     Local arrays
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Character*30 Label
#endif
      Logical AeqB, CeqD, EQ, lB10, lB00, lB01
*
      iRout = 14
      iPrint = nPrint(iRout)
*
#ifdef _DEBUGPRINT_
      iPrint=99
      If (iPrint.ge.99) Then
         Call RecPrt(' In XCff2D: Coori',' ',Coori,3,4)
         Call RecPrt(' In XCff2D: P',' ',P,nT,3)
         Call RecPrt(' In XCff2D: Q',' ',Q,nT,3)
      End If
#endif
      AeqB = EQ(Coori(1,1),Coori(1,2))
      CeqD = EQ(Coori(1,3),Coori(1,4))
*
      nabMax=la+lb
      ncdMax=ld+lc
      h12 = Half
*
*---- Compute B10, B00, and B01
*
      lB10=.False.
      lB00=.False.
      lB01=.False.
      If (nabMax.gt.1) Then
         lB10=.True.
         Do 10 iT = 1, nT
            Do 31 iRys = 1, nRys
                  B10(iRys,iT,1) = ( h12 -
     &              h12 * U2(iRys,iT))*ZInv(iT)
 31         Continue
 10      Continue
         call dcopy_(nRys*nT,B10(1,1,1),1,B10(1,1,2),1)
         call dcopy_(nRys*nT,B10(1,1,1),1,B10(1,1,3),1)
      End If
      If (lac.ne.0) Then
         lB00=.True.
         call dcopy_(nRys*nT,U2(1,1),1,B00(1,1,1),1)
         call dcopy_(nRys*nT,U2(1,1),1,B00(1,1,2),1)
         call dcopy_(nRys*nT,U2(1,1),1,B00(1,1,3),1)
      End If
      If (ncdMax.gt.1) Then
         lB01=.True.
         Do iT = 1, nT
            Do iRys = 1, nRys
               B01(iRys,iT,1) = Two * Zeta(iT) * U2(iRys,iT)
            End Do
         End Do
         call dcopy_(nRys*nT,B01(1,1,1),1,B01(1,1,2),1)
         call dcopy_(nRys*nT,B01(1,1,1),1,B01(1,1,3),1)
      End If
*
      If (nabMax.ne.0 .and. ncdMax.ne.0) Then
         If (.Not.AeqB .and. CeqD) Then
            Do 300 iCar = 1, 3
               Do 310 iT = 1, nT
                  Do 330 iRys = 1, nRys
                     PAQP(iRys,iT,iCar) =
     &                   P(iT,iCar) - CoorAC(iCar,1) +
     &                   (U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar)))
                     QCPQ(iRys,iT,iCar) = - Two * Zeta(iT) *
     &                   (U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar)))
 330              Continue
 310           Continue
 300        Continue
         Else
            Do 400 iCar = 1, 3
               Do 410 iT = 1, nT
                  Do 430 iRys = 1, nRys
                     PAQP(iRys,iT,iCar) =
     &                   (U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar)))
                     QCPQ(iRys,iT,iCar) = - Two * Zeta(iT) *
     &                   (U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar)))
 430              Continue
 410           Continue
 400        Continue
         End If
      Else If (nabMax.ne.0) Then
         If (.Not.AeqB) Then
            Do 101 iCar = 1, 3
               Do 111 iT = 1, nT
                  Do 131 iRys = 1, nRys
                     PAQP(iRys,iT,iCar) =
     &                   P(iT,iCar) - CoorAC(iCar,1) +
     &                   U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar))
 131              Continue
 111           Continue
 101        Continue
         Else
            Do 201 iCar = 1, 3
               Do 211 iT = 1, nT
                  Do 231 iRys = 1, nRys
                     PAQP(iRys,iT,iCar) =
     &                    U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar))
 231              Continue
 211           Continue
 201        Continue
         End If
      Else If (ncdMax.ne.0) Then
         Do 202 iCar = 1, 3
            Do 212 iT = 1, nT
               Do 232 iRys = 1, nRys
                  QCPQ(iRys,iT,iCar) = Two * Zeta(iT) *
     &                U2(iRys,iT) * (P(iT,iCar)-Q(iT,iCar))
 232              Continue
 212        Continue
 202     Continue
      End If
#ifdef _DEBUGPRINT_
      If (la+lb.gt.0) Then
         Write (Label,'(A)') ' PAQP(x)'
         Call RecPrt(Label,' ',PAQP(1,1,1),nRys,nT)
         Write (Label,'(A)') ' PAQP(y)'
         Call RecPrt(Label,' ',PAQP(1,1,2),nRys,nT)
         Write (Label,'(A)') ' PAQP(z)'
         Call RecPrt(Label,' ',PAQP(1,1,3),nRys,nT)
      End If
      If (lc+ld.gt.0) Then
         Write (Label,'(A)') ' QCPQ(x)'
         Call RecPrt(Label,' ',QCPQ(1,1,1),nRys,nT)
         Write (Label,'(A)') ' QCPQ(y)'
         Call RecPrt(Label,' ',QCPQ(1,1,2),nRys,nT)
         Write (Label,'(A)') ' QCPQ(z)'
         Call RecPrt(Label,' ',QCPQ(1,1,3),nRys,nT)
      End If
      If (nabMax.ne.0) Then
         Write (Label,'(A)') ' B10(x)'
         Call RecPrt(Label,' ',B10(1,1,1),nRys,nT)
         Write (Label,'(A)') ' B10(y)'
         Call RecPrt(Label,' ',B10(1,1,2),nRys,nT)
         Write (Label,'(A)') ' B10(z)'
         Call RecPrt(Label,' ',B10(1,1,3),nRys,nT)
      End If
      If (lac.ne.0) Then
         Write (Label,'(A)') ' B00(x)'
         Call RecPrt(Label,' ',B00(1,1,1),nRys,nT)
         Write (Label,'(A)') ' B00(y)'
         Call RecPrt(Label,' ',B00(1,1,2),nRys,nT)
         Write (Label,'(A)') ' B00(z)'
         Call RecPrt(Label,' ',B00(1,1,3),nRys,nT)
      End If
      If (ncdMax.ne.0) Then
         Write (Label,'(A)') ' B01(x)'
         Call RecPrt(Label,' ',B01(1,1,1),nRys,nT)
         Write (Label,'(A)') ' B01(y)'
         Call RecPrt(Label,' ',B01(1,1,2),nRys,nT)
         Write (Label,'(A)') ' B01(z)'
         Call RecPrt(Label,' ',B01(1,1,3),nRys,nT)
      End If
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iDum1)
         Call Unused_integer(iDum2)
         Call Unused_real(rDum3)
         Call Unused_real(rDum4)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_VecBuf_Final()
!
! Purpose: deallocate and finalize vector buffer.

use Cholesky, only: CHVBFI, CHVBUF, ip_CHVBFI_SYM, ip_CHVBUF_SYM, l_CHVBFI_SYM, l_CHVBUF_SYM, nSym, nVec_in_Buf
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(CHVBUF,safe='*')
call mma_deallocate(CHVBFI,safe='*')

ip_ChVBuf_Sym(1:nSym) = 0
l_ChVBuf_Sym(1:nSym) = 0
ip_ChVBFI_Sym(1:nSym) = 0
l_ChVBFI_Sym(1:nSym) = 0
nVec_in_Buf(1:nSym) = 0

end subroutine Cho_VecBuf_Final

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Jeppe Olsen                                      *
************************************************************************
      FUNCTION ISYMSTR(ISYM,NSTR)
*
* Symmetry of product of NSTR string symmetries
*
* works currently only for D2H and subgroups
*
* Jeppe Olsen, 1998
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
#include "multd2h.fh"
*. Input
      INTEGER ISYM(*)
*
      IF(NSTR.EQ.0) THEN
        IISYM = 1
      ELSE
        IISYM = ISYM(1)
        DO JSTR = 2, NSTR
           IISYM = MULTD2H(IISYM,ISYM(JSTR))
        END DO
      END IF
*
      ISYMSTR = IISYM
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  translategeom
*
*> @brief
*>   Performs the translation of geometry 2 to geometry 1
*> @author Y. Carissan
*>
*> @details
*> Performs the translation of geometry 2 to
*> geometry 1 and stores the result in geometry 3.
************************************************************************
      subroutine translategeom(Vtrans, nat, Geom1, Geom2)
      implicit none
#include "real.fh"
      Integer nat,iat
      Real*8 Vtrans(3)
      Real*8 Geom1(3,nat)
      Real*8 Geom2(3,nat)

      Do iat=1,nat
        call dcopy_(3,Geom1(1,iat),1,Geom2(1,iat),1)
        Call Daxpy_(3,One,Vtrans,1,Geom2(1,iat),1)
      End do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TODSC(A,NDIM,MBLOCK,IFIL)
! TRANSFER ARRAY REAL*8 A(LENGTH NDIM) TO DISCFIL IFIL IN
! RECORDS WITH LENGTH NBLOCK.

use lucia_data, only: IDISK
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NDIM, MBLOCK, IFIL
real(kind=wp), intent(_IN_) :: A(NDIM)
integer(kind=iwp) :: IDUMMY(1), IMZERO, IPACK, ISCR(2), ISTOP, MMBLOCK, NBACK, NBLOCK, NLABEL, NTRANS, START
real(kind=wp) :: XNORM
real(kind=wp), external :: dDot_

IPACK = 1
if (IPACK /= 0) then
  ! Check norm of A before writing
  XNORM = dDot_(NDIM,A,1,A,1)
  if (XNORM == Zero) then
    IMZERO = 1
  else
    IMZERO = 0
  end if
  MMBLOCK = MBLOCK
  if (MMBLOCK > 2) MMBLOCK = 2

  ISCR(1) = IMZERO
  ! No packing
  ISCR(2) = 0
  call ITODS(ISCR,2,2,IFIL)
  if (IMZERO == 1) return
end if

NBLOCK = MBLOCK
if (MBLOCK <= 0) NBLOCK = NDIM
ISTOP = 0
NBACK = NDIM
! LOOP OVER RECORDS
do
  if (NBACK <= NBLOCK) then
    NTRANS = NBACK
    NLABEL = -NTRANS
  else
    NTRANS = NBLOCK
    NLABEL = NTRANS
  end if
  START = ISTOP+1
  ISTOP = START+NBLOCK-1
  NBACK = NBACK-NTRANS
  call DDAFILE(IFIL,1,A(START),ISTOP-START+1,IDISK(IFIL))
  IDUMMY(1) = NLABEL
  call IDAFILE(IFIL,1,IDUMMY,1,IDISK(IFIL))
  if (NBACK == 0) exit
end do

end subroutine TODSC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RSMXMN_LUCIA(  MAXEL,  MINEL,  NORB1,  NORB2,  NORB3,
     &                            NEL,   MIN1,   MAX1,   MIN3,   MAX3,
     &                          NTEST)
*
* Construct accumulated MAX and MIN arrays for a RAS set of strings
*
      IMPLICIT REAL*8           ( A-H,O-Z)
      DIMENSION  MINEL(*),MAXEL(*)
*
      NORB = NORB1 + NORB2 + NORB3
*. accumulated max and min in each of the three spaces
*. ( required max and min at final orbital in each space )
COLD  MIN1A = MIN1
      MIN1A = MAX(MIN1,NEL-MAX3-NORB2)
      MAX1A = MAX1
*
      MIN2A = NEL - MAX3
      MAX2A = NEL - MIN3
*
      MIN3A = NEL
      MAX3A = NEL
*
      DO 100 IORB = 1, NORB
        IF(IORB .LE. NORB1 ) THEN
          MINEL(IORB) = MAX(MIN1A+IORB-NORB1,0)
          MAXEL(IORB) = MIN(IORB,MAX1A)
        ELSE IF ( NORB1.LT.IORB .AND. IORB.LE.(NORB1+NORB2)) THEN
          MINEL(IORB) = MAX(MIN2A+IORB-NORB1-NORB2,0)
          IF(NORB1 .GT. 0 )
     &    MINEL(IORB) = MAX(MINEL(IORB),MINEL(NORB1))
          MAXEL(IORB) = MIN(IORB,MAX2A)
        ELSE IF ( IORB .GT. NORB1 + NORB2 ) THEN
          MINEL(IORB) = MAX(MIN3A+IORB-NORB,0)
          IF(NORB1+NORB2 .GT. 0 )
     &    MINEL(IORB) = MAX(MINEL(IORB),MINEL(NORB1+NORB2))
          MAXEL(IORB) = MIN(IORB,MAX3A)
        END IF
  100 CONTINUE
*
      IF( NTEST .GE. 100 ) THEN
        WRITE(6,*) ' Output from RSMXMN '
        WRITE(6,*) ' ================== '
        WRITE(6,*) ' MINEL : '
        CALL IWRTMA(MINEL,1,NORB,1,NORB)
        WRITE(6,*) ' MAXEL : '
        CALL IWRTMA(MAXEL,1,NORB,1,NORB)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Stefano Battaglia                                *
!***********************************************************************

#include "compiler_features.h"
#ifdef _DMRG_

subroutine read_integrals()

use, intrinsic :: iso_c_binding, only: c_int
use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use printLevel, only: debug
use rasscf_global, only: Emy
use qcmaquis_interface, only: qcmaquis_interface_optimize, qcmaquis_interface_remove_param, qcmaquis_interface_set_state, &
                              qcmaquis_interface_update_integrals_C
use caspt2_global, only: FIMO, iPrGlb
use caspt2_module, only: nAsh, nAshT, nFro, nIsh, nOrb, nOsh, nState, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: arr_size, max_index2, n, NACPAR, offset, t, t_nAsh, t_nFro, t_nIsh, t_nOrb, t_nOsh, tSym, tuSym, u, u_nAsh, &
                     u_nFro, u_nIsh, u_nOrb, u_nOsh, uSym, v, v_nAsh, v_nIsh, v_nOsh, vSym, x, x_nAsh, x_nIsh, x_nOsh, xSym
integer(c_int), allocatable :: indices(:)
real(kind=wp), allocatable :: ERI(:,:), SCR(:,:), values(:)
real(kind=wp), parameter :: threshold = 1.0e-16_wp

! indices, values: Arrays that get passed to QCMaquis
! arr_size, max_index2: calculate the size of the arrays
! offset: Offset for values and indices array

write(u6,*) '=== QCM: Rotating Orbitals to SS === '

if (iPrGlb >= debug) then
  write(u6,*) 'ERI in MO-basis'
  write(u6,*) '---------------'
end if

NACPAR = nTri_Elem(nAshT)

! calculate the maximum size of the integral array, can be less b/c of symmetry
max_index2 = nTri_Elem(NACPAR)

! core energy + one-electron integrals + two-electron integrals
arr_size = 1+max_index2+nTri_Elem(max_index2)
call mma_allocate(indices,4*arr_size)
indices(:) = 0
call mma_allocate(values,arr_size)
values(:) = Zero

! Two Body
offset = 1
do tSym=1,nSym
  t_nFro = nFro(tSym)
  t_nIsh = nIsh(tSym)
  t_nAsh = nAsh(tSym)
  t_nOsh = nOsh(tSym)
  t_nOrb = nOrb(tSym)

  do uSym=1,tSym
    u_nFro = nFro(uSym)
    u_nIsh = nIsh(uSym)
    u_nAsh = nAsh(uSym)
    u_nOsh = nOsh(uSym)
    u_nOrb = nOrb(uSym)
    tuSym = Mul(tSym,uSym)

    call mma_allocate(ERI,t_nOrb,u_nOrb,Label='ERI')
    call mma_allocate(SCR,t_nOrb,u_nOrb,Label='SCR')
    ERI(:,:) = Zero
    SCR(:,:) = Zero

    if (iPrGlb >= debug) then
      write(u6,*) ' tSym = ',tSym,' uSym = ',uSym
      write(u6,*) ' t_nFro = ',t_nFro,' u_nFro = ',u_nFro
      write(u6,*) ' t_nIsh = ',t_nIsh,' u_nIsh = ',u_nIsh
      write(u6,*) ' t_nAsh = ',t_nAsh,' u_nAsh = ',u_nAsh
      write(u6,*) ' t_nOsh = ',t_nOsh,' u_nOsh = ',u_nOsh
      write(u6,*) ' t_nOrb = ',t_nOrb,' u_nOrb = ',u_nOrb
    end if

    do vSym=1,nSym
      v_nIsh = nIsh(vSym)
      v_nAsh = nAsh(vSym)
      v_nOsh = nOsh(vSym)
      xSym = Mul(tuSym,vSym)

      ! only totally symmetric integrals are different from zero
      if (xSym <= vSym) then
        x_nIsh = nIsh(xSym)
        x_nAsh = nAsh(xSym)
        x_nOsh = nOsh(xSym)

        write(u6,*) ' vSym = ',vSym,' xSym = ',xSym
        write(u6,*) ' v_nIsh = ',v_nIsh,' x_nIsh = ',x_nIsh
        write(u6,*) ' v_nAsh = ',v_nAsh,' x_nAsh = ',x_nAsh
        write(u6,*) ' v_nOsh = ',v_nOsh,' x_nOsh = ',x_nOsh

        ! loop over active orbital indices only
        do v=v_nIsh+1,v_nOsh
          do x=v,x_nOsh
            call coul(tSym,uSym,vSym,xSym,v,x,ERI,SCR)
            do t=v,t_nOsh
              do u=t,u_nOsh
                if ((v == t) .and. (u < x)) cycle
                if (abs(ERI(t,u)) < threshold) cycle
                values(offset) = ERI(t,u)
                indices(4*(offset-1)+1:4*(offset-1)+4) = [int(v-v_nIsh,kind=c_int),int(x-x_nIsh,kind=c_int), &
                                                          int(t-t_nIsh,kind=c_int),int(u-u_nIsh,kind=c_int)]
                offset = offset+1
              end do
            end do
          end do
        end do
      end if
      call mma_deallocate(ERI)
      call mma_deallocate(SCR)
    end do
  end do
end do

! One Body
do vSym=1,nSym
  v_nIsh = nIsh(vSym)
  v_nAsh = nAsh(vSym)
  v_nOsh = nOsh(vSym)
  do v=v_nIsh+1,v_nOsh
    do x=x_nIsh+1,v
      n = iTri(v,x)
      t = max(v,x)
      u = min(v,x)
      if (abs(FIMO(n)) < threshold) cycle
      values(offset) = FIMO(n)
      indices(4*(offset-1)+1:4*(offset-1)+4) = [int(t-v_nIsh,kind=c_int),int(u-v_nIsh,kind=c_int),0_c_int,0_c_int]
      offset = offset+1
    end do
  end do
end do

! Core Energy
offset = offset+1
values(offset) = EMY
indices(4*(offset-1)+1:4*(offset-1)+4) = 0_c_int

! Rotate MPS wavefunction to new orbitals
call qcmaquis_interface_update_integrals_C(indices,values,int(offset,kind=c_int))
do n=1,NSTATE
  call qcmaquis_interface_remove_param('MEASURE[trans1rdm]')
  call qcmaquis_interface_remove_param('MEASURE[trans2rdm]')
  call qcmaquis_interface_remove_param('MEASURE[trans3rdm]')

  call qcmaquis_interface_set_state(int(n-1,c_int))
  call qcmaquis_interface_optimize()
end do

call mma_deallocate(indices)
call mma_deallocate(values)

end subroutine read_integrals

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(read_integrals)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per Ake Malmqvist                                *
*               1992, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Ortho_RASSCF(SMAT,SCRATCH,CMO,TEMP)
************************************************************************
*                                                                      *
*     purpose: Orthogonalize MOs (one symmetry block at a time)        *
*                                                                      *
*     calling arguments:                                               *
*     Smat    : overlap matrix                                         *
*     CMO     : MO-coefficients                                        *
*     Temp    : temporary work space                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.-AA. Malmqvist and M.P. Fuelscher                              *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (A-H,O-Z)
*
#include "rasdim.fh"
#include "warnings.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
#include "orthonormalize.fh"
      Parameter (ROUTINE='ORTHO   ')
*
      Dimension Smat(*),SCRATCH(*),CMO(*),Temp(*)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     Read overlap matrix SMAT:
*
      i_Rc=0
      i_Opt=6
      i_Component=1
      i_SymLbl=1
      Call RdOne(i_Rc,i_Opt,'Mltpl  0',i_Component,Smat,i_SymLbl)
      If ( i_Rc.ne.0 ) Then
        Write(LF,*)' ORTHO could not read overlaps from ONEINT.'
        Write(LF,*)' RASSCF is trying to orthonormalize orbitals but'
        Write(LF,*)' could not read overlaps from ONEINT. Something'
        Write(LF,*)' is wrong with the file, or possibly with the'
        Write(LF,*)' program. Please check.'
        Call Quit(_RC_IO_ERROR_READ_)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Orthonormalize symmetry blocks:
*
      ip_Smat=1
      ip_CMO=1
      Do  iSym=1,nSym
         iBas=nBas(iSym)
         iOcc=iBas-nDel(iSym)
         If ( iBas.gt.0 ) then
*
            Call SQUARE(SMAT(ip_Smat),Temp,1,iBas,iBas)
*
C           Call RecPrt('S',' ',Temp,iBas,iBas)
C           Call RecPrt('CMO',' ',CMO(ip_CMO),iBas,iBas)

            If (Lowdin_ON) Then
*
* --- compute C^T*S*C = W  (overlap in MO basis)
*
               Call DGEMM_('T','N',
     &                     iOcc,iBas,iBas,
     &                     1.0d0,CMO(ip_CMO),iBas,
     &                     Temp,iBas,
     &                     0.0d0,SCRATCH,iOcc)
               Call DGEMM_('N','N',
     &                     iOcc,iOcc,iBas,
     &                     1.0d0,SCRATCH,iOcc,
     &                     CMO(ip_CMO),iBas,
     &                     0.0d0,Temp,iOcc)
*
* --- compute W^-1/2
*
               Call Lowdin(Temp,SCRATCH,iOcc)
*
* --- compute C' = C*W^-1/2
*
               Call DGEMM_('N','N',
     &                     iBas,iOcc,iOcc,
     &                     1.0d0,CMO(ip_CMO),iBas,
     &                     SCRATCH,iOcc,
     &                     0.0d0,Temp,iBas)

* PAM March 2016: Probable bugfix needed (Thanks, Liviu!)
* not affecting any tests (!)
* by adding the following line:
              CALL DCOPY_(iBas*iOcc,Temp,1,CMO(ip_CMO),1)
            Else

               Call ORTHO1(Temp,CMO(ip_CMO),SCRATCH,iBas,iOcc)
            End If
*
C           Call RecPrt('CMO',' ',CMO(ip_CMO),iBas,iBas)
*
            ip_Smat=ip_Smat+(iBas*iBas+iBas)/2
            ip_CMO=ip_CMO+iBas*iBas
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine Copy_JobIph(InFile,OutFile)
! This is very nasty routine, actually a temporary hack!!!
! should be replaced to a proper copy of JobIph files!

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: InFile, OutFile
integer(kind=iwp) :: ierr

call fcopy(InFile,OutFile,ierr)
if (iErr /= 0) call abend()
!Junk = 'cp -p '//File1(1:lFile1)//' '//File2(1:lFile2)

return

end subroutine Copy_JobIph

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Gen_Prim_Density_Matrix(nBas,nPrim,D_p,nOcOb,oNum,oCof)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBas, nPrim, nOcOb
real(kind=wp), intent(out) :: D_p(nPrim*(nPrim+1)/2)
real(kind=wp), intent(in) :: oNum(nBas), oCof(nBas,nPrim)
integer(kind=iwp) :: i, k, l

D_p(:) = Zero
do k=1,nPrim
  do l=1,k
    do i=1,nOcOb
      D_p(k*(k-1)/2+l) = D_p(k*(k-1)/2+l)+oNum(i)*oCof(i,k)*oCof(i,l)
    end do
  end do
end do

return

end subroutine Gen_Prim_Density_Matrix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ortelim_cvb(trprm,iorts,irots,sorbs,nc,npr1,norbprm,nrem)

use casvb_global, only: ndrot, norb, nort
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iorts(2,nort), irots(2,ndrot), nc, npr1, norbprm
real(kind=wp), intent(inout) :: trprm(npr1,npr1)
real(kind=wp), intent(in) :: sorbs(norb,norb)
integer(kind=iwp), intent(out) :: nrem
integer(kind=iwp) :: iorb, iort, irot, jorb, ki, kj, korb
real(kind=wp) :: dum(1)
real(kind=wp), allocatable :: tmp(:,:)

call mma_allocate(tmp,norbprm,max(nc+nort+ndrot,norbprm),label='tmp')
tmp(:,:) = Zero
tmp(:,1:nc) = trprm(1:norbprm,1:nc)
do iort=1,nort
  iorb = iorts(1,iort)
  jorb = iorts(2,iort)
  do korb=1,norb
    ki = korb+(iorb-1)*(norb-1)
    if (korb > iorb) ki = ki-1
    kj = korb+(jorb-1)*(norb-1)
    if (korb > jorb) kj = kj-1
    if (korb /= iorb) tmp(ki,iort+nc) = sorbs(korb,jorb)
    if (korb /= jorb) tmp(kj,iort+nc) = sorbs(korb,iorb)
  end do
end do
do irot=1,ndrot
  iorb = irots(1,irot)
  jorb = irots(2,irot)
  do korb=1,norb
    ki = korb+(iorb-1)*(norb-1)
    if (korb > iorb) ki = ki-1
    kj = korb+(jorb-1)*(norb-1)
    if (korb > jorb) kj = kj-1
    if (korb /= iorb) tmp(ki,irot+nc+nort) = sorbs(korb,jorb)
    if (korb /= jorb) tmp(kj,irot+nc+nort) = -sorbs(korb,iorb)
  end do
end do
call span_cvb(tmp,nc+nort+ndrot,nrem,dum,norbprm,0)
call compl_cvb(tmp,nrem,norbprm)

trprm(:,:) = Zero
trprm(1:norbprm,1:norbprm) = tmp(1:norbprm,1:norbprm)

call mma_deallocate(tmp)

return

end subroutine ortelim_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_Stat()

use Cholesky, only: Cho_Real_Par, LuRed, LuRed_G, nSym, NumCho, NumCho_G, NumChT, NumChT_G
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iTmp, jTmp

if (Cho_Real_Par) then
  call Cho_P_IndxSwp()
  call iSwap(nSym,NumCho,1,NumCho_G,1)
  jTmp = NumChT
  NumChT = NumChT_G
  iTmp = LuRed
  LuRed = LuRed_G
  call Cho_Stat()
  LuRed = iTmp
  NumChT = jTmp
  call iSwap(nSym,NumCho,1,NumCho_G,1)
  call Cho_P_IndxSwp()
else
  call Cho_Stat()
end if

end subroutine Cho_P_Stat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c       This file contains following routines:
c     unpackab1
c     unpackab2
c       unpckhelp1
c       unpckhelp2
c       unpckhelp3
c       unpckhelp4
c       unpckhelp5
c       unpckhelp6
c       unpckhelp7
c
c     saverest1
c     saverest2
c
c       files for stacking:
c     unpackab3
c       unpckhelp8
c       unpckhelp9
c       unpckhelp10
c       unpckhelp11
c
c     --------------------
c     --------------------
c
       subroutine unpackab1 (wrk,wrksize,
     & mapdn,mapin,mapdr1,mapir1,
     & mapdr2,mapir2,mapdr3,mapir3,mapdr4,mapir4,ssn,key,aeqb)
c
c     mapdn - direct map matrix corresponding to N (Input)
c     mapin - direct map matrix corresponding to N (Input)
c     mapdr1- inverse map matrix corresponding to R1 (Input)
c     mapir1- inverse map matrix corresponding to R1 (Input)
c     mapdr2- inverse map matrix corresponding to R2 (Input)
c     mapir2- inverse map matrix corresponding to R2 (Input)
c     mapdr3- inverse map matrix corresponding to R3 (Input)
c     mapir3- inverse map matrix corresponding to R3 (Input)
c     mapdr4- inverse map matrix corresponding to R4 (Input)
c     mapir4- inverse map matrix corresponding to R4 (Input)
c     ssn   - overall symmtry state of N (Input)
c     key   - define state of _a,_b  key   a, b (Input)
c     1    S  S
c     2    V  S
c     3    S  V
c     4    V  V
c     aqeb  - aqeb=0 if a.ne.b; =1 if a=b (Input)
c
c     this routine unpack: N _a_b (p,q) = <ab|pq>              key  aeqb
c     N _a_b (p,q) a>=b-bb  -> R1 _a,_b(ef)aaaa = <ab||ef>      4    0
c     -> R2 _a,_b(ef)bbbb = <ab||ef>     1-4   0
c     -> R3 _a,_b(e,f)abab = <ab||ef>    3,4   0,1
c     -> R4 _b,_a(e,f)abab = <ba||fe>    2,4   0,1
c
c     !N.B. mylim, ze pri II.3;II.4;III.3;III.4 maju byt possn +--+ a nie ++++
c     ako su terazky
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer mapdn(0:512,1:6)
       integer mapdr1(0:512,1:6)
       integer mapdr2(0:512,1:6)
       integer mapdr3(0:512,1:6)
       integer mapdr4(0:512,1:6)
c
       integer mapin(1:8,1:8,1:8)
       integer mapir1(1:8,1:8,1:8)
       integer mapir2(1:8,1:8,1:8)
       integer mapir3(1:8,1:8,1:8)
       integer mapir4(1:8,1:8,1:8)
c
       integer ssn,key,aeqb
c
c     help variables
c
       integer symp,symq,dimp,dimq,dime,dimf,dimef,lenghtn
       integer ir1,ir2,ir3,ir4,possr1,possr2,possr3,possr4
       integer possn,in,inp,inm,possnp,possnm
c
       do 1000 symp=1,nsym
       symq=mmul(ssn,symp)
c
       in=mapin(symp,1,1)
       lenghtn=mapdn(in,2)
c
       if (lenghtn.eq.0) goto 1000
c
       if (symp.eq.symq) then
c     symp=symq
c
       possn=mapdn(in,1)
       dimp=dimm(5,symp)
c
cI.1  def R1 - _a_b(ef)aaaa
c
       if ((key.eq.4).and.(aeqb.eq.0)) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dimef=mapdr1(ir1,2)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp1 (wrk(possn),wrk(possr1),dimp,dimef,noa(symp),
     &                  nva(symp))
       end if
       end if
c
cI.2  def R2 - _a_b(ef)bbbb
c
       if (aeqb.eq.0) then
       ir2=mapir2(symp,1,1)
       possr2=mapdr2(ir2,1)
       dimef=mapdr2(ir2,2)
       if (mapdr2(ir2,2).gt.0) then
       call unpckhelp1 (wrk(possn),wrk(possr2),dimp,dimef,nob(symp),
     &                  nvb(symp))
       end if
       end if
c
cI.3  def R3 - _a_b(e,f)abab
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir3=mapir3(symp,1,1)
       possr3=mapdr3(ir3,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr3(ir3,2).gt.0) then
       call unpckhelp3 (wrk(possn),wrk(possr3),dimp,dimp,dime,
     & dimf,noa(symp),nva(symp),nob(symq),nvb(symq))
       end if
       end if
c
cI.4  def R4 - _b_a(e,f)abab
c
       if (((key.eq.3).or.(key.eq.4)).and.(aeqb.eq.0)) then
       ir4=mapir4(symp,1,1)
       possr4=mapdr4(ir4,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr4(ir4,2).gt.0) then
       call unpckhelp4 (wrk(possn),wrk(possr4),dimp,dimp,dime,
     & dimf,noa(symp),nva(symp),nob(symq),nvb(symq))
       end if
       end if
c
       else if (symp.gt.symq) then
c     symp > symq
c
       inp=mapin(symp,1,1)
       inm=mapin(symq,1,1)
       possnp=mapdn(inp,1)
       possnm=mapdn(inm,1)
       dimp=dimm(5,symp)
       dimq=dimm(5,symq)
c
cII.1 def R1 - _a_b(ef)aaaa
c
       if (key.eq.4) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(3,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp2 (wrk(possnp),wrk(possnm),wrk(possr1),dimp,dimq,
     &                  dime,dimf,
     & noa(symp),nva(symp),noa(symq),nva(symq))
       end if
       end if
c
cII.2 def R2 - _a_b(ef)bbbb
c
       ir2=mapir2(symp,1,1)
       possr2=mapdr2(ir2,1)
       dime=dimm(4,symp)
       dimf=dimm(4,symq)
       if (mapdr2(ir2,2).gt.0) then
       call unpckhelp2 (wrk(possnp),wrk(possnm),wrk(possr2),dimp,dimq,
     &                  dime,dimf,
     & nob(symp),nvb(symp),nob(symq),nvb(symq))
       end if
c
cII.3 def R3 - _a_b(e,f)abab
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir3=mapir3(symp,1,1)
       possr3=mapdr3(ir3,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr3(ir3,2).gt.0) then
       call unpckhelp3 (wrk(possnp),wrk(possr3),dimp,dimq,dime,dimf,
     & noa(symp),nva(symp),nob(symq),nvb(symq))
       end if
       end if
c
cII.4 def R4 - _b_a(e,f)abab
c
       if ((key.eq.3).or.(key.eq.4)) then
       ir4=mapir4(symq,1,1)
       possr4=mapdr4(ir4,1)
       dime=dimm(3,symq)
       dimf=dimm(4,symp)
       if (mapdr4(ir4,2).gt.0) then
       call unpckhelp4 (wrk(possnp),wrk(possr4),dimp,dimq,dime,dimf,
     & noa(symq),nva(symq),nob(symp),nvb(symp))
       end if
       end if
c
       else
c     symp < symq
c%
       inp=mapin(symp,1,1)
       inm=mapin(symq,1,1)
       possnp=mapdn(inp,1)
       possnm=mapdn(inm,1)
       dimp=dimm(5,symp)
       dimq=dimm(5,symq)
c
cIII.1def R1 - _a_b(ef)aaaa -no operation
cIII.2def R2 - _a_b(ef)bbbb -no operation
c
cIII.3def R3 - _a_b(e,f)abab
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir3=mapir3(symp,1,1)
       possr3=mapdr3(ir3,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr3(ir3,2).gt.0) then
       call unpckhelp3 (wrk(possnp),wrk(possr3),dimp,dimq,dime,dimf,
     & noa(symp),nva(symp),nob(symq),nvb(symq))
       end if
       end if
c
cIII.4def R4 - _b_a(e,f)abab
c
       if ((key.eq.3).or.(key.eq.4)) then
       ir4=mapir4(symq,1,1)
       possr4=mapdr4(ir4,1)
       dime=dimm(3,symq)
       dimf=dimm(4,symp)
       if (mapdr4(ir4,2).gt.0) then
       call unpckhelp4 (wrk(possnp),wrk(possr4),dimp,dimq,dime,dimf,
     & noa(symq),nva(symq),nob(symp),nvb(symp))
       end if
       end if
c
c%
       end if
c
 1000   continue
c
       return
       end
c
c     --------------------
c
       subroutine unpackab2 (wrk,wrksize,
     & mapdn,mapin,mapdr1,mapir1,mapdr2,mapir2,
     &                       mapdr3,mapir3,
     & mapdr4,mapir4,mapdr5,mapir5,mapdr6,mapir6,ssn,key,aeqb)
c
c     mapdn - direct map matrix corresponding to N (Input)
c     mapin - direct map matrix corresponding to N (Input)
c     mapdr1- inverse map matrix corresponding to R1 (Input)
c     mapir1- inverse map matrix corresponding to R1 (Input)
c     mapdr2- inverse map matrix corresponding to R2 (Input)
c     mapir2- inverse map matrix corresponding to R2 (Input)
c     mapdr3- inverse map matrix corresponding to R3 (Input)
c     mapir3- inverse map matrix corresponding to R3 (Input)
c     mapdr4- inverse map matrix corresponding to R4 (Input)
c     mapir4- inverse map matrix corresponding to R4 (Input)
c     mapdr5- inverse map matrix corresponding to R4 (Input)
c     mapir5- inverse map matrix corresponding to R4 (Input)
c     mapdr6- inverse map matrix corresponding to R4 (Input)
c     mapir6- inverse map matrix corresponding to R4 (Input)
c     ssn   - overall symmtry state of N (Input)
c     key   - define state of _a,_b  key   a, b (Input)
c     1    S  S
c     2    V  S
c     3    S  V
c     4    V  V
c     aqeb  - aqeb=0 if a.ne.b; =1 if a=b (Input)
c
c     this routine unpack: N _a_b (p,q) = <ab|pq>              key   aeqb
c     N _a_b (p,q) a>=b-aa  -> R1 _a,_b(j,e)aaaa = <ab||je>     4     0
c     -> R2 _a,_b(j,e)bbbb = <ab||je>    1-4    0
c     -> R3 _a,_b(j,e)abab = <ab||je>    3,4   0,1
c     -> R4 _b,_a(j,e)abab = <ba||je>    2,4   0,1
c     -> R5 _a,_b(j,e)abba = <ab||je>    3,4   0,1
c     -> R6 _b,_a(j,e)abba = <ba||je>    2,4   0,1
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer mapdn(0:512,1:6)
       integer mapdr1(0:512,1:6)
       integer mapdr2(0:512,1:6)
       integer mapdr3(0:512,1:6)
       integer mapdr4(0:512,1:6)
       integer mapdr5(0:512,1:6)
       integer mapdr6(0:512,1:6)
c
       integer mapin(1:8,1:8,1:8)
       integer mapir1(1:8,1:8,1:8)
       integer mapir2(1:8,1:8,1:8)
       integer mapir3(1:8,1:8,1:8)
       integer mapir4(1:8,1:8,1:8)
       integer mapir5(1:8,1:8,1:8)
       integer mapir6(1:8,1:8,1:8)
c
       integer ssn,key,aeqb
c
c     help variables
c
       integer symp,symq,dimp,dimq,dime,dimj
       integer in,inm,inp,ir1,ir2,ir3,ir4,ir5,ir6
       integer possn,possnp,possnm,possr1,possr2,possr3,possr4,possr5,
     & possr6
       integer lenghtn
c
       do 1000 symp=1,nsym
       symq=mmul(ssn,symp)
c
       in=mapin(symp,1,1)
       lenghtn=mapdn(in,2)
c
       if (lenghtn.eq.0) goto 1000
c
       if (symp.eq.symq) then
c     symp=symq
c
       possn=mapdn(in,1)
       dimp=dimm(5,symp)
c
cI.1  def R1 - _a_b(j,e)aaaa
c
       if ((key.eq.4).and.(aeqb.eq.0)) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dimj=noa(symp)
       dime=nva(symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp5 (wrk(possn),wrk(possr1),dimp,dimj,dime,
     & 0,noa(symp),noa(symp),nva(symp))
       end if
       end if
c
cI.2  def R2 - _a_b(j,e)bbbb
c
       if (aeqb.eq.0) then
       ir2=mapir2(symp,1,1)
       possr2=mapdr2(ir2,1)
       dimj=nob(symp)
       dime=nvb(symq)
       if (mapdr2(ir2,2).gt.0) then
       call unpckhelp5 (wrk(possn),wrk(possr2),dimp,dimj,dime,
     & 0,nob(symp),nob(symp),nvb(symp))
       end if
       end if
c
cI.3  def R3 - _a_b(j,e)abba
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir3=mapir3(symp,1,1)
       possr3=mapdr3(ir3,1)
       dimj=nob(symp)
       dime=nva(symq)
       if (mapdr3(ir3,2).gt.0) then
       call unpckhelp7 (wrk(possn),wrk(possr3),dimp,dimp,dimj,
     & dime,0,nob(symp),noa(symq),nva(symq))
       end if
       end if
c
cI.4  def R4 - _b_a(j,e)abba
c
       if (((key.eq.3).or.(key.eq.4)).and.(aeqb.eq.0)) then
       ir4=mapir4(symp,1,1)
       possr4=mapdr4(ir4,1)
       dimj=nob(symp)
       dime=nva(symq)
       if (mapdr4(ir4,2).gt.0) then
       call unpckhelp6 (wrk(possn),wrk(possr4),dimp,dimp,dimj,
     & dime,0,nob(symp),noa(symq),nva(symq))
       end if
       end if
c
cI.5  def R5 - _a_b (j,e)abab
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir5=mapir5(symp,1,1)
       possr5=mapdr5(ir5,1)
       dimj=noa(symp)
       dime=nvb(symq)
       if (mapdr5(ir5,2).gt.0) then
       call unpckhelp3 (wrk(possn),wrk(possr5),dimp,dimp,dimj,
     & dime,0,noa(symp),nob(symq),nvb(symq))
       end if
       end if
c
cI.6  def R6 - _b_a(j,e)abab
c
       if (((key.eq.3).or.(key.eq.4)).and.(aeqb.eq.0)) then
       ir6=mapir6(symp,1,1)
       possr6=mapdr6(ir6,1)
       dimj=noa(symp)
       dime=nvb(symq)
       if (mapdr6(ir6,2).gt.0) then
       call unpckhelp4 (wrk(possn),wrk(possr6),dimp,dimp,dimj,
     & dime,0,noa(symp),nob(symq),nvb(symq))
       end if
       end if
c
       else
c     symp.ne.symq
c
       inp=mapin(symp,1,1)
       inm=mapin(symq,1,1)
       possnp=mapdn(inp,1)
       possnm=mapdn(inm,1)
       dimp=dimm(5,symp)
       dimq=dimm(5,symq)
c
cII.1 def R1 - _a_b(j,e)aaaa
c
       if (key.eq.4) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dimj=noa(symp)
       dime=nva(symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp2 (wrk(possnp),wrk(possnm),wrk(possr1),dimp,dimq,
     &                  dimj,dime,
     & 0,noa(symp),noa(symq),nva(symq))
       end if
       end if
c
cII.2 def R2 - _a_b(j,e)bbbb
c
       ir2=mapir2(symp,1,1)
       possr2=mapdr2(ir2,1)
       dimj=nob(symp)
       dime=nvb(symq)
       if (mapdr2(ir2,2).gt.0) then
       call unpckhelp2 (wrk(possnp),wrk(possnm),wrk(possr2),dimp,dimq,
     &                  dimj,dime,
     & 0,nob(symp),nob(symq),nvb(symq))
       end if
c
cII.3 def R3 - _a_b(j,e)abba
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir3=mapir3(symq,1,1)
       possr3=mapdr3(ir3,1)
       dimj=nob(symq)
       dime=nva(symp)
       if (mapdr3(ir3,2).gt.0) then
       call unpckhelp7 (wrk(possnp),wrk(possr3),dimp,dimq,dimj,dime,
     & 0,nob(symq),noa(symp),nva(symp))
       end if
       end if
c
cII.4 def R4 - _b_a(j,e)abba
c
       if ((key.eq.3).or.(key.eq.4)) then
       ir4=mapir4(symp,1,1)
       possr4=mapdr4(ir4,1)
       dimj=nob(symp)
       dime=nva(symq)
       if (mapdr4(ir4,2).gt.0) then
       call unpckhelp6 (wrk(possnp),wrk(possr4),dimp,dimq,dimj,dime,
     & 0,nob(symp),noa(symq),nva(symq))
       end if
       end if
c
cII.5 def R5 - _a_b(j,e)abab
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir5=mapir5(symp,1,1)
       possr5=mapdr5(ir5,1)
       dimj=noa(symp)
       dime=nvb(symq)
       if (mapdr5(ir5,2).gt.0) then
       call unpckhelp3 (wrk(possnp),wrk(possr5),dimp,dimq,dimj,dime,
     & 0,noa(symp),nob(symq),nvb(symq))
       end if
       end if
c
cII.6 def R6 - _b_a(j,e)abab
c
       if ((key.eq.3).or.(key.eq.4)) then
       ir6=mapir6(symq,1,1)
       possr6=mapdr6(ir6,1)
       dimj=noa(symq)
       dime=nvb(symp)
       if (mapdr6(ir6,2).gt.0) then
       call unpckhelp4 (wrk(possnp),wrk(possr6),dimp,dimq,dimj,dime,
     & 0,noa(symq),nob(symp),nvb(symp))
       end if
       end if
c
       end if
c
 1000   continue
c
       return
       end
c
c     --------------------
c
       subroutine unpckhelp1 (a,b,dimp,dimef,eadd,noe)
c
c     this routine do:
c     b(ef) = a(pe,qf)-a(qf,pe) for symp=symq
c
       integer dimp,dimef,eadd,noe
       real*8 a(1:dimp,1:dimp)
       real*8 b(1:dimef)
c
c     help variables
       integer pe,qf,ef
c
       ef=0
       do 100 pe=eadd+2,eadd+noe
       do 101 qf=eadd+1,pe-1
       ef=ef+1
       b(ef)=a(pe,qf)-a(qf,pe)
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine unpckhelp2 (ap,am,b,dimp,dimq,dime,dimf,eadd,noe,fadd,
     &                        nof)
c
c     this routine do:
c     b(e,f) = a(pe,qf)-a(qf,pe) for symp>symq
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof
       real*8 ap(1:dimp,1:dimq)
       real*8 am(1:dimq,1:dimp)
       real*8 b(1:dime,1:dimf)
c
c     help variables
       integer pe,qf,f
c
       do 100 qf=fadd+1,fadd+nof
       f=qf-fadd
       do 101 pe=eadd+1,eadd+noe
       b(pe-eadd,f)=ap(pe,qf)-am(qf,pe)
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine unpckhelp3 (a,b,dimp,dimq,dime,dimf,eadd,noe,fadd,nof)
c
c     this routine do:
c     b(e,f) = a(pe,qf)
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof
       real*8 a(1:dimp,1:dimq)
       real*8 b(1:dime,1:dimf)
c
c     help variables
       integer pe,qf,f
c
       do 100 qf=fadd+1,fadd+nof
       f=qf-fadd
       do 101 pe=eadd+1,eadd+noe
       b(pe-eadd,f)=a(pe,qf)
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine unpckhelp4 (a,b,dimp,dimq,dime,dimf,eadd,noe,fadd,nof)
c
c     this routine do:
c     b(e,f) =  a(pf,qe)
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof
       real*8 a(1:dimp,1:dimq)
       real*8 b(1:dime,1:dimf)
c
c     help variables
       integer qe,pf,f
c
       do 100 pf=fadd+1,fadd+nof
       f=pf-fadd
       do 101 qe=eadd+1,eadd+noe
       b(qe-eadd,f)=a(pf,qe)
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine unpckhelp5 (a,b,dimp,dimj,dime,jadd,noj,eadd,noe)
c
c     this routine do:
c     b(j,e) = a(pj,qe)-a(qe,pj) for symp=symq
c
       integer dimp,dime,dimj,eadd,noe,jadd,noj
       real*8 a(1:dimp,1:dimp)
       real*8 b(1:dimj,1:dime)
c
c     help variables
       integer pj,qe,e
c
       do 100 qe=eadd+1,eadd+noe
       e=qe-eadd
       do 101 pj=jadd+1,jadd+noj
       b(pj-jadd,e)=a(pj,qe)-a(qe,pj)
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine unpckhelp6 (a,b,dimp,dimq,dime,dimf,eadd,noe,fadd,nof)
c
c     this routine do:
c     b(e,f) = -a(pe,qf)
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof
       real*8 a(1:dimp,1:dimq)
       real*8 b(1:dime,1:dimf)
c
c     help variables
       integer pe,qf,f
c
       do 100 qf=fadd+1,fadd+nof
       f=qf-fadd
       do 101 pe=eadd+1,eadd+noe
       b(pe-eadd,f)=-a(pe,qf)
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine unpckhelp7 (a,b,dimp,dimq,dime,dimf,eadd,noe,fadd,nof)
c
c     this routine do:
c     b(e,f) =  -a(pf,qe)
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof
       real*8 a(1:dimp,1:dimq)
       real*8 b(1:dime,1:dimf)
c
c     help variables
       integer qe,pf,f
c
       do 100 pf=fadd+1,fadd+nof
       f=pf-fadd
       do 101 qe=eadd+1,eadd+noe
       b(qe-eadd,f)=-a(pf,qe)
 101    continue
 100    continue
c
       return
       end
c
c     -------------------------
c
       subroutine saverest1 (wrk,wrksize,
     & lunrst)
c
c     this routine save restart informations:
c     t13,t14,t21,t22,t23
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer lunrst
c
c     help variables
c
       integer rc
c
c0    return if need
       if (keyrst.eq.0) return
c
c1    rewind tape
       call filemanager (2,lunrst,rc)
c
c2    write T1aa
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt13,mapit13,rc)
c
c3    write T1bb
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt14,mapit14,rc)
c
c4    write T2aaaa
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt21,mapit21,rc)
c
c5    write T2bbbb
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt22,mapit22,rc)
c
c6    write T2abab
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt23,mapit23,rc)
c
       return
       end
c
c     -------------------------
c
       subroutine saverest2 (lunrst,energy,niter,iokey,daddr)
c
c     this routine save restart informations:
c     energy, niter
c     to prepaired possition in lunrst
c

#include "SysDef.fh"
       integer lunrst,niter,iokey,daddr
       real*8 energy
c
c1    write energy,niter
       if (iokey.eq.1) then
c      Fortran IO
       write (lunrst) energy,niter
c
       else
c      MOLCAS IO
       call ddafile (lunrst,1,[energy],1,daddr)
       call idafile (lunrst,1,[niter],1,daddr)
       end if
c
       return
       end
c
c     -------------------------
c
c       files for stacking:
c     unpackab3
c       unpckhelp8
c       unpckhelp9
c       unpckhelp10
c       unpckhelp11
c
c     --------------------
c
       subroutine unpackab3 (wrk,wrksize,
     & mapdn,mapin,mapdr1,mapir1,ssn,nabnow,possab0,lentotab,key)
c
c     mapdn - direct map matrix corresponding to N (Input)
c     mapin - direct map matrix corresponding to N (Input)
c     mapdr1- inverse map matrix corresponding to R1 (Input)
c     mapir1- inverse map matrix corresponding to R1 (Input)
c     ssn   - overall symmtry state of N (Input)
c     nabnow- #of b indexes stored in stack (dimension of stack)
c     possab0 - real possition of AB_stack (I)
c     lentotab- lenrgth of one record in stack (per one b ind) (I)
c     key   - key, specifying which integrals need to be defined (I)
c       this routine unpack: N _a_b (p,q) = <ab|pq>              key
c       N _a_b (p,q) a>=b-bb  -> R1 _a,_b(ef)aaaa = <ab||ef>      1
c                             -> R1 _a,_b(ef)bbbb = <ab||ef>      2
c                             -> R1 _a,_b(e,f)abab = <ab||ef>     3
c                             -> R1 _b,_a(e,f)abab = <ba||fe>     4
c
c     !N.B. mylim, ze pri II.3;II.4;III.3;III.4 maju byt possn +--+ a nie ++++
c     ako su terazky
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer mapdn(0:512,1:6)
       integer mapin(1:8,1:8,1:8)
       integer mapdr1(0:512,1:6)
       integer mapir1(1:8,1:8,1:8)
c
       integer ssn,key,nabnow,possab0,lentotab
c
c     help variables
c
       integer symp,symq,dimp,dimq,dime,dimf,dimef,lenghtn
       integer ir1,possr1,bb
       integer possn,in,inp,inm,possnp,possnm
c
c
       do 2000 bb=1,nabnow
c
c
       do 1000 symp=1,nsym
       symq=mmul(ssn,symp)
c
       in=mapin(symp,1,1)
       lenghtn=mapdn(in,2)
c
       if (lenghtn.eq.0) goto 1000
c
       if (symp.eq.symq) then
c     symp=symq
c
cold   possn=mapdn(in,1)
       possn=possab0+(mapdn(in,1)-mapdn(1,1))+(bb-1)*lentotab
       dimp=dimm(5,symp)
c
cI.1  def R1 - _a_b(ef)aaaa
c
       if (key.eq.1) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dimef=(dimm(3,symp)*(dimm(3,symp)-1))/2
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp8 (wrk(possn),wrk(possr1),dimp,dimef,noa(symp),
     &                  nva(symp),bb,nabnow)
       end if
       end if
c
cI.2  def R1 - _a_b(ef)bbbb
c
       if (key.eq.2) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dimef=(dimm(4,symp)*(dimm(4,symp)-1))/2
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp8 (wrk(possn),wrk(possr1),dimp,dimef,nob(symp),
     &                  nvb(symp),bb,nabnow)
       end if
       end if
c
cI.3  def R1 - _a_b(e,f)abab
c
       if (key.eq.3) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp10(wrk(possn),wrk(possr1),dimp,dimp,dime,
     & dimf,noa(symp),nva(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
cI.4  def R1 - _b_a(e,f)abab
c
       if (key.eq.4) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp11(wrk(possn),wrk(possr1),dimp,dimp,dime,
     & dimf,noa(symp),nva(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
       else if (symp.gt.symq) then
c     symp > symq
c
       inp=mapin(symp,1,1)
       inm=mapin(symq,1,1)
cold   possnp=mapdn(inp,1)
       possnp=possab0+(mapdn(inp,1)-mapdn(1,1))+(bb-1)*lentotab
cold   possnm=mapdn(inm,1)
       possnm=possab0+(mapdn(inm,1)-mapdn(1,1))+(bb-1)*lentotab
       dimp=dimm(5,symp)
       dimq=dimm(5,symq)
c
cII.1 def R1 - _a_b(ef)aaaa
c
       if (key.eq.1) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(3,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp9 (wrk(possnp),wrk(possnm),wrk(possr1),dimp,dimq,
     &                  dime,dimf,
     & noa(symp),nva(symp),noa(symq),nva(symq),bb,nabnow)
       end if
       end if
c
cII.2 def R1 - _a_b(ef)bbbb
c
       if (key.eq.2) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(4,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp9 (wrk(possnp),wrk(possnm),wrk(possr1),dimp,dimq,
     &                  dime,dimf,
     & nob(symp),nvb(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
cII.3 def R1 - _a_b(e,f)abab
c
       if (key.eq.3) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp10(wrk(possnp),wrk(possr1),dimp,dimq,dime,dimf,
     & noa(symp),nva(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
cII.4 def R4 - _b_a(e,f)abab
c
       if (key.eq.4) then
       ir1=mapir1(symq,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symq)
       dimf=dimm(4,symp)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp11(wrk(possnp),wrk(possr1),dimp,dimq,dime,dimf,
     & noa(symq),nva(symq),nob(symp),nvb(symp),bb,nabnow)
       end if
       end if
c
       else
c     symp < symq
c%

       inp=mapin(symp,1,1)
       inm=mapin(symq,1,1)
cold   possnp=mapdn(inp,1)
cold   possnm=mapdn(inm,1)
       possnp=possab0+(mapdn(inp,1)-mapdn(1,1))+(bb-1)*lentotab
       possnm=possab0+(mapdn(inm,1)-mapdn(1,1))+(bb-1)*lentotab
       dimp=dimm(5,symp)
       dimq=dimm(5,symq)
c
cIII.1def R1 - _a_b(ef)aaaa -no operation
cIII.2def R1 - _a_b(ef)bbbb -no operation
c
cIII.3def R1 - _a_b(e,f)abab
c
       if (key.eq.3) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp10(wrk(possnp),wrk(possr1),dimp,dimq,dime,dimf,
     & noa(symp),nva(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
cIII.4def R3 - _b_a(e,f)abab
c
       if (key.eq.4) then
       ir1=mapir1(symq,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symq)
       dimf=dimm(4,symp)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp11(wrk(possnp),wrk(possr1),dimp,dimq,dime,dimf,
     & noa(symq),nva(symq),nob(symp),nvb(symp),bb,nabnow)
       end if
       end if
c
c%
       end if
c
 1000   continue
 2000   continue
c
       return
       end
c
c     --------------------
c
       subroutine unpckhelp8 (a,b,dimp,dimef,eadd,noe,bb,dimb)
c
c     this routine do:
c     b(ef,_Bb) = a(pe,qf)-a(qf,pe) for symp=symq
c
       integer dimp,dimef,eadd,noe,bb,dimb
       real*8 a(1:dimp,1:dimp)
       real*8 b(1:dimef,1:dimb)
c
c     help variables
       integer pe,qf,ef
c
       ef=0
       do 100 pe=eadd+2,eadd+noe
       do 101 qf=eadd+1,pe-1
       ef=ef+1
       b(ef,bb)=a(pe,qf)-a(qf,pe)
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine unpckhelp9 (ap,am,b,dimp,dimq,dime,dimf,eadd,noe,fadd,
     &                        nof,bb,dimb)
c
c     this routine do:
c     b(e,f,_Bb) = a(pe,qf)-a(qf,pe) for symp>symq
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof,bb,dimb
       real*8 ap(1:dimp,1:dimq)
       real*8 am(1:dimq,1:dimp)
       real*8 b(1:dime,1:dimf,1:dimb)
c
c     help variables
       integer pe,qf,f
c
       do 100 qf=fadd+1,fadd+nof
       f=qf-fadd
       do 101 pe=eadd+1,eadd+noe
       b(pe-eadd,f,bb)=ap(pe,qf)-am(qf,pe)
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine unpckhelp10(a,b,dimp,dimq,dime,dimf,eadd,noe,fadd,nof,
     c                        bb,dimb)
c
c     this routine do:
c     b(e,f,_Bb) = a(pe,qf)
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof,bb,dimb
       real*8 a(1:dimp,1:dimq)
       real*8 b(1:dime,1:dimf,1:dimb)
c
c     help variables
       integer pe,qf,f
c
       do 100 qf=fadd+1,fadd+nof
       f=qf-fadd
       do 101 pe=eadd+1,eadd+noe
       b(pe-eadd,f,bb)=a(pe,qf)
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine unpckhelp11(a,b,dimp,dimq,dime,dimf,eadd,noe,fadd,nof,
     c                        bb,dimb)
c
c     this routine do:
c     b(e,f,_Bb) =  a(pf,qe)
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof,bb,dimb
       real*8 a(1:dimp,1:dimq)
       real*8 b(1:dime,1:dimf,1:dimb)
c
c     help variables
       integer qe,pf,f
c
       do 100 pf=fadd+1,fadd+nof
       f=pf-fadd
       do 101 qe=eadd+1,eadd+noe
       b(qe-eadd,f,bb)=a(pf,qe)
 101    continue
 100    continue
c
       return
       end
c
c     -------------------------
c
        subroutine prmap (mapd,mapi)
c

       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
       integer ii,i,j
       ii=mapd(0,5)
       do i=0,ii
       write (6,99) i,(mapd(i,j),j=1,6)
99      format (i3,6x,i10,1x,5(i6,1x))
       end do
c
        write (6,*) mapi(1,1,1),mapi(2,1,1)
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Diag_Driver(JobZ, Range, UpLo, nDim, Triangular, Aux,
     &                       lDimAux, vLower, vUpper, iLower, iUpper,
     &                       EigVal, EigVec, lDimVec, iUnit_Matrix,
     &                       iSort, Method, nFound, Ierr)
      Implicit None
#include "WrkSpc.fh"
* Input/Output variables
      Real*8 EigVal, EigVec, Aux, vLower, vUpper, Triangular
      Integer nDim, iLower, iUpper, nFound, iErr, lDimAux, lDimVec
      Integer iUnit_Matrix, iSort
      Character JobZ, Range, UpLo, Method
      Dimension EigVal(*), EigVec(*), Aux(*), Triangular(*)
* Local Variables
      Real*8 Tollerance
      Integer iMethod, nDim2, iSize, lWork, liWork,liW(2),liErr(2)
* Scratch and pointers to scratch arrays
      Real*8 Work_L(1)
      Integer lScr, liScr, iSuppZ
* External Functions ..
      Logical            lSame
      Real*8             dLamCh_
      External           lSame, dLamCh_
*
* Sizes for arrays
*
      nDim2 = nDim * nDim
      iSize = nDim * (nDim + 1) / 2
*
* Determine which algorithm to use
*
      iMethod = 0
      If (lSame(Method, 'A')) Then
         iMethod = 0
      Else If (lSame(Method, 'Q')) Then
         iMethod = 1
      Else If (lSame(Method, 'J')) Then
         iMethod = 2
      Else
         Write(6,*) '!!! Diag_Driver called with an unknown method: ',
     &              Method
         Write(6,*) '!!! Supported methods: Q, J, and A'
         Write(6,*) '    Method = ''',Method,''''
         Call Abend()
      End If
*
      If (iMethod .le. 1) Then
*
* Use the QL algorithm (dSyevR)
*
         Call Square(Triangular,Aux,lDimAux,1,nDim)
         Call dCopy_(nDim2,[0.0D0],0,EigVec,1)
         Call dCopy_(nDim,[1.0D0],0,EigVec,nDim+1)
*
* Determine safe tollerance for dSyevR
*
         Tollerance = dLamCh_( 'Safe minimum' )
*
* Determine optimal sizes of scratch arrays
*
         CALL GetMem('ISUPPZ  ','ALLO','INTE',iSuppZ,2*nDim)
         lWork  = -1
         liWork = -1
CC AOM 03.08.2005 - Added LiW(2), otherwise on Opteron crashed
CC AOM 04.08        Also added liErr for the same reason
         call dsyevr_(JobZ, Range, UpLo, nDim, Aux, lDimAux, vLower,
     &               vUpper, iLower, iUpper, Tollerance, nFound, EigVal,
     &               EigVec, lDimVec, iWork(iSuppZ), Work_L, lWork,
     &               liW, liWork, liErr(1))
         lWork = Int(Work_L(1))
         liWork = liW(1)
*
* Allocate scratch arrays
*
         CALL GetMem('SCRATCH ','ALLO','REAL',lScr,lWork)
         CALL GetMem('ISCRATCH','ALLO','INTE',liScr,liWork)
*
* Run actual QL routine
*
         call dsyevr_(JobZ, Range, UpLo, nDim, Aux, lDimAux, vLower,
     &               vUpper, iLower, iUpper, Tollerance, nFound, EigVal,
     &               EigVec, lDimVec, iWork(iSuppZ), Work(lScr), lWork,
     &               iWork(liScr), liWork, liErr(1))
         iErr=liErr(1)
*
* Free scratch
*
         CALL GetMem('SCRATCH ','FREE','REAL',lScr,lWork)
         CALL GetMem('ISCRATCH','FREE','INTE',liScr,liWork)
         CALL GetMem('ISUPPZ  ','FREE','INTE',iSuppZ,2*nDim)
*
* Check for convergence
*
         If (iErr .ne. 0) Then
            Write(6,*) '!!! No Convergence in the QL algorithm.'
            If (lSame(Method, 'A')) Then
               Write(6,*) '!!! Trying Jacobi instead.'
               Write(6,*) '!!! Warning: This might be very slow.'
               iMethod = 2
            Else
               Call Abend()
            End If
         Else
            Call Chk4NAN(nDim**2,EigVec,Ierr)
            If (iErr .gt. 0) Then
               Write(6,*) 'At least one of the eigenvectors found with'
               Write(6,*) 'DSYEVR contained a NAN.'
               If (lSame(Method, 'A')) Then
                  Write(6,*) 'Trying Jacobi instead.'
                  Write(6,*) 'Warning: This might be very slow.'
                  iMethod = 2
               Else
                  Call Abend()
               End If
            End If
         End If
      End If
      If (iMethod .eq. 2) Then
*
* Use the Jacobi algorithm
*
         Call dCopy_(iSize,Triangular,1,Aux,1)
         If (iUnit_Matrix .eq. 1) Then
            Call dCopy_(nDim2,[0.0D0],0,EigVec,1)
            Call dCopy_(nDim,[1.0D0],0,EigVec,nDim+1)
         End If
         Call Jacob(Aux,EigVec,nDim,lDimVec)
         Call vEig(nDim,Aux,EigVal)
      End If
*
* Sort the eigenvalues and eigenvectors?
*
      If (iSort .eq. 1) Then
         Call JacOrd2(EigVal, EigVec, nDim, lDimVec)
      Else If (iSort .eq. -1) Then
         Call SortEig(EigVal, EigVec, nDim, lDimVec)
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetT2n(T2n1,T2n2,beSGrp,gaSGrp,LunAux)
! this routine does:
! Read T2n = T2n(-(+)) (i>(>=)j,(be>(>=)ga)")
! from Tmp3Name(be",ga")
!
! parameter description:
! T2nx    - arrays for T2+- (O)
! xSGrp   - SubGroups of be,ga (I)
! LunAux  - Lun (I)

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimSGrpbe, Tmp3Name, no
use Definitions, only: wp, iwp

#include "intent.fh"
implicit none
real(kind=wp), intent(_OUT_) :: T2n1(*), T2n2(*)
integer(kind=iwp), intent(in) :: beSGrp, gaSGrp, LunAux
integer(kind=iwp) :: length1, length2
character(len=6) :: LunName

!1 calc lengths
if (beSGrp == gaSGrp) then
  length1 = nTri_Elem(no)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/2
else
  length1 = nTri_Elem(no)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
end if

if (beSGrp == gaSGrp) then
  length2 = nTri_Elem(no-1)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)-1)/2
else
  length2 = nTri_Elem(no-1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
end if

!2 get T2n1, T2n2
LunName = Tmp3Name(beSGrp,gaSGrp)
call GetX(T2n1,length1,LunAux,LunName,1,0)
call GetX(T2n2,length2,LunAux,LunName,0,1)

return

end subroutine GetT2n

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************
      SubRoutine ChoMP2g_Reord_R(irc,Wrk,lWrk)
*
*      Jonas Bostrom, Apr 2010
*
*      Purpose: To reorder R-vectors so it is practical to access
*               one ia-piece at the time.

      use ChoMP2, only: AdrR1, AdrR2
#include "implicit.fh"
#include "chomp2g.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"
#include "cholesky.fh"
#include "choorb.fh"
*
      Character Fname*5
      Real*8 Wrk(lWrk)
*
      Character*7  ThisNm
      Character*15 SecNam
      Parameter (SecNam = 'ChoMP2g_Reord_r', ThisNm = 'Reord_r')
*
      MulD2h(i,j)=iEor(i-1,j-1) + 1
*
      iTypR = 2
      iVecOV = 6
      maxvalue = 1000

*     Do not delete vectors
*     ---------------------
      iClos = 2

      iSeed = 7
      LuRInv(1) = IsFreeUnit(iSeed)
      Write(Fname,'(A4,I1)') 'TMPV',4
      Call DaName_MF_WA(LuRInv(1),Fname)
*
      LuRInv(2) = IsFreeUnit(iSeed)
      Write(Fname,'(A4,I1)') 'TMPV',5
      Call DaName_MF_WA(LuRInv(2),Fname)

      iAdr1 = 1
      iAdr2 = 1
      Do iSymI = 1, nSym
         Do iSymA = 1, nSym
            iSym = MulD2h(iSymA,iSymI)
            Do iI = 1, nOcc(iSymI)
               AdrR1(iSymA,iSymI,iI) = iAdr1
               iAdr1 = iAdr1 + nVir(iSymA)*nMP2Vec(iSym)
            End Do
            Do iA = 1, nVir(iSymA)
               AdrR2(iSymA,iSymI,iA) = iAdr2
               iAdr2 = iAdr2 + nOcc(iSymI)*nMP2Vec(iSym)
            End Do
         End Do
      End Do
*
      Do iSym = 1, nSym
         If(nMP2Vec(iSym) .eq. 0) Go To 10
         nVec = Min(maxvalue,nMP2Vec(iSym))
         If(nVec .lt. 1) Then
            Call ChoMP2_Quit(SecNam,'Insufficient memory','[1]')
         End If
         nBatR = (nMP2Vec(iSym)-1)/nVec + 1

*        Allocate memory for Ria-vectors
*        -------------------------------

         lRia = nMoMo(iSym,iVecOV)*nVec
         kRia1 = 1
         kEndRia1 = kRia1 + lRia

         kRia2 = kEndRia1

*        Open Cholesky amplitude vectors
*        -------------------------------
         Call ChoMP2_OpenF(1,iTypR,iSym)

         Do iBat = 1, nBatR
            If(iBat .eq. nBatR) Then
               NumVec = nMP2Vec(iSym) - nVec*(nBatR-1)
            Else
               NumVec = nVec
            End If
            iVec = nVec*(iBat-1) + 1

*           Read Amplitude vectors
*           ----------------------
            iOpt = 2
            lTot = nMoMo(iSym,iVecOV)*NumVec
            iAdr = nMoMo(iSym,iVecOV)*(iVec-1) + 1
            Call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia1),lTot,iAdr)

            Do iVec1 = 1, NumVec
               Do iSymI = 1, nSym
                  iSymA = MulD2h(iSymI,iSym)
                  Do iI = 1, nOcc(iSymI)
                     ioffset1 = (iI-1)*nVir(iSymA)+iT1am(iSymA,iSymI) +
     &                         (iVec1-1)*nMoMo(iSym,iVecOV)
                     iOffset2 = (iVec1-1)*nVir(iSymA) +
     &                          (iI-1)*NumVec*nVir(iSymA) +
     &                           iT1am(iSymA,iSymI)*NumVec
                     Call dCopy_(nVir(iSymA),Wrk(kRia1+iOffset1),1,
     &                                      Wrk(kRia2+iOffset2),1)
                  End Do
               End Do
            End Do

*           Put the reordered vectors on disk
            iOpt = 1
            Do iSymI = 1, nSym
               iSymA = MulD2h(iSymI,iSym)
               Do iI = 1, nOcc(iSymI)
                  lTot = nVir(iSymA)*NumVec
                  iAdr = AdrR1(iSymA,iSymI,iI)
     &                 + (iVec-1)*nVir(iSymA)
                  iOffset2 = (iI-1)*NumVec*nVir(iSymA) +
     &                        iT1am(iSymA,iSymI)*NumVec
                  Call dDaFile(LuRInv(1),iOpt, Wrk(kRia2+iOffSet2),
     &                         lTot,iAdr)
               End Do
            End Do



         End Do                 !iBat
         Do iBat = 1, nBatR
            If(iBat .eq. nBatR) Then
               NumVec = nMP2Vec(iSym) - nVec*(nBatR-1)
            Else
               NumVec = nVec
            End If
            iVec = nVec*(iBat-1) + 1

*           Read Amplitude vectors
*           ----------------------
            iOpt = 2
            lTot = nMoMo(iSym,iVecOV)*NumVec
            iAdr = nMoMo(iSym,iVecOV)*(iVec-1) + 1
            Call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia1),lTot,iAdr)
*
            Do iSymI = 1, nSym
               iSymA = MulD2h(iSymI,iSym)
               Do iI = 1, nOcc(iSymI)
                  Do iA = 1, nVir(iSymA)

                     iOffSet1 = iA-1 + (iI-1)*nVir(iSymA)
     &                        + iT1am(iSymA,iSymI)
                     iOffSet2 = iI-1 + (iA-1)*NumVec*nOcc(iSymI)
     &                        + iT1am(iSymA,iSymI)*NumVec
                     Call dCopy_(NumVec,Wrk(kRia1+iOffset1),
     &                          nMoMo(iSym,iVecOV),Wrk(kRia2+iOffset2),
     &                          nOcc(iSymI))
                  End Do
               End Do
            End Do
*
*           Put the reordered vectors on disk
            iOpt = 1
            Do iSymI = 1, nSym
               iSymA = MulD2h(iSymI,iSym)
               Do iA = 1, nVir(iSymA)
                  lTot = nOcc(iSymI)*NumVec
                  iAdr = AdrR2(iSymA,iSymI,iA)
     &                 + (iVec-1)*nOcc(iSymI)
                  iOffset2 = (iA-1)*NumVec*nOcc(iSymI) +
     &                        iT1am(iSymA,iSymI)*NumVec
                  Call dDaFile(LuRInv(2),iOpt, Wrk(kRia2+iOffset2),
     &                         lTot,iAdr)
               End Do
            End Do



         End Do                 !iBat

         Call ChoMP2_OpenF(iClos,iTypR,iSym)


 10      Continue
      End Do !iSym

      Call DaClos(LuRInv(1))
      Call DaClos(LuRInv(2))

c Avoid unused argument warnings
      If (.False.) Call Unused_integer(irc)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines:
c     daopen
c     daread
c     dawrite
c     mkabpqmap
c     mkampqmap
c     abpack
c     ampack
c     addintab
c     mkampq
c     vf
c
c     ----------------------------------------
c
       subroutine daopen (name,lun,recl,nrec)
c
c     this routine open direct acces file
c
c     name  - name of the file A8 (I)
c     lun   - logical unit number (I)
c     recl - record lenght in R8 (I)
c     nrec  - number of records (if needed) (I)
c
       integer lun,recl,nrec
       character*8 name
c
c     help variables
c
       integer recln,f_iostat
       logical is_error
c
#ifdef _DECAXP_
       recln=recl*2
#else
       recln=recl*8
#endif
c
       call molcas_open_ext2(lun,name,'direct','unformatted',
     &  f_iostat,.true.,recln,'unknown',is_error)
c       open (unit=lun,file=name,form='unformatted',access='direct',
c     & recl=recln)
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(nrec)
       end
c
c     ------------------------------
c
       subroutine daread (lun,irec0,vector,lenght,recl)
c
c     this routine read vector with required lenght from
c     opened direct access file lun starting from record number
c     irec0
c     lun   - logical unit of direct access file (I)
c     irec0 - initial recored number (I)
c     vector- vector (O)
c     lenght- number of R8 data to be readed (I)
c     recl  - lenght of one record in lun  in R8 (I)
c
       real*8 vector(1:lenght)
       integer lun,irec0,lenght,recl
c
c     help variables
c
       integer ilow,iup,need,irec,i
c
       if (lenght.eq.0) then
       return
       end if
c
c*    def need,ilow,iup,irec
c
       need=lenght
       ilow=1
       iup=0
       irec=irec0
c
 1      if (recl.ge.need) then
       iup=iup+need
       else
       iup=iup+recl
       end if
c
       read (lun,rec=irec) (vector(i),i=ilow,iup)
c
       need=need-(iup-ilow+1)
       irec=irec+1
       ilow=ilow+recl
c
       if (need.gt.0) goto 1
c
       return
       end
c
c     ------------------------
c
       subroutine dawrite (lun,irec0,vector,lenght,recl)
c
c     this routine write vector with required lenght to
c     opened direct access file lun starting from record number
c     irec0
c
c     lun   - logical unit of direct access file (I)
c     irec0 - initial recored number (I)
c     vector- vector (I)
c     lenght- number of R8 data to be readed (I)
c     recl  - lenght of one record in lun in R8 (I)
c
       real*8 vector(1:lenght)
       integer lun,irec0,lenght,recl
c
c     help variables
c
       integer ilow,iup,need,irec,i
c
       if (lenght.eq.0) then
       return
       end if
c
c*    def need,ilow,iup,irec
c
       need=lenght
       ilow=1
       irec=irec0
       iup=0
c
 1     if (recl.ge.need) then
       iup=iup+need
       else
       iup=iup+recl
       end if
c
       write (lun,rec=irec) (vector(i),i=ilow,iup)
c
       need=need-(iup-ilow+1)
       irec=irec+1
       ilow=ilow+recl
c
       if (need.gt.0) goto 1
c
       return
       end
c
c     ------------------------
c
       subroutine mkabpqmap (abmap,syma,symb,rc)
c
c     this routine prepair abmap
c
#include "reorg.fh"
#include "ccsort.fh"
c
       integer abmap(1:mbas,1:mbas,1:8)
       integer syma,symb,rc
c
c     help variables
c
       integer a,b,bup,symp,symq,symab
       integer lenghtpq,nrecc,nrest,irec
c
cT    test, if there are any ab pair
c
       if (nvb(syma)*nvb(symb).eq.0) then
       rc=1
c     RC=1 : there are no ab pair in this symmetry
       return
       else
       rc=0
       end if
c
c*    def initial address
c
       irec=1
       symab=mul(syma,symb)
c
c*    loop over all combinations
c
       do 100 symp=1,nsym
       symq=mul(symab,symp)
c
c*    define number of records, required to store this block
c     and determine shift in initial possitions
c
       lenghtpq=norb(symp)*norb(symq)
       nrecc=int(lenghtpq/recl)
       nrest=lenghtpq-nrecc*recl
       if (nrest.gt.0) then
       nrecc=nrecc+1
       end if
c
       do 101 a=1,nvb(syma)
c
       if (syma.eq.symb) then
       bup=a
       else
       bup=nvb(symb)
       end if
c
       do 102 b=1,bup
c
       abmap(a,b,symp)=irec
       irec=irec+nrecc
c
 102    continue
 101    continue
 100    continue
c
       return
       end
c
c     ------------------------
c
       subroutine mkampqmap (ammap,syma,rc)
c
c     this routine prepair ammap
c
#include "reorg.fh"
#include "ccsort.fh"
c
       integer syma,rc
       integer ammap(1:mbas,1:8,1:8)
c
c     help variables
c
       integer a,symp,symq,symm,symam
       integer lenghtmpq,nrecc,nrest,irec
c
cT    test, if there are any a in this symmtry
c
       if (nvb(syma).eq.0) then
       rc=1
c     RC=1 : there are no a in this symmetry
       return
       else
       rc=0
       end if
c
c*    def initial address
c
       irec=1
c
c*    loop over all combinations
c
       do 100 symm=1,nsym
       symam=mul(syma,symm)
       do 101 symp=1,nsym
       symq=mul(symam,symp)
c
c*    define number of records, required to store this block
c     and determine shift in initial possitions
c
       lenghtmpq=noa(symm)*norb(symp)*norb(symq)
       nrecc=int(lenghtmpq/recl)
       nrest=lenghtmpq-nrecc*recl
       if (nrest.gt.0) then
       nrecc=nrecc+1
       end if
c
       do 102 a=1,nvb(syma)
c
       ammap(a,symm,symp)=irec
       irec=irec+nrecc
c
 102    continue
 101    continue
 100    continue
c
       return
       end
c
c     --------------------------
c
       subroutine abpack (wrk,wrksize,
     & syma,symb,symp,symq,a,vint,ndimv1,ndimv2,
     & ndimv3,abmap)
c
c     this routine pack corresponding parts to ab direct acc. file
c     from given integrals <_a,bb,p,q> readed in vint
c
c     syma  - irrep of first index (I)
c     symb  - irrep of 2.nd index (I)
c     symp  - irrep of p (I)
c     symq  - irrep of q (I)
c     a- pivot virtual index (counted in nvb set) (I)
c     vint  - array of integrals <_a,bb,p,q> (I)
c     ndimv1- 1.st dimension of vint - norb(symb) (I)
c     ndimv2- 2.nd dimension of vint - norb(symp) (I)
c     ndimv3- 3.rd dimension of vint - norb(symq) (I)
c     abmap - map for storing of addresses in DA file TEMPDA1 (I)
c
#include "wrk.fh"
#include "ccsort.fh"
#include "reorg.fh"
c
       integer syma,symb,symp,symq,a,ndimv1,ndimv2,ndimv3
       real*8 vint(1:ndimv1,1:ndimv2,1:ndimv3)
       integer abmap(1:mbas,1:mbas,1:8)
c
c     help variables
c
       integer p,q,pq,irec0,lenght,b,bup,bvint
c
cT    if there are no ab pair, or no integrals in _a_bpq block return
c
       if (nvb(syma)*nvb(symb)*norb(symp)*norb(symq).eq.0) then
       return
       end if
c
c*    def lenght of _a_b(p,q) block
c
       lenght=norb(symp)*norb(symq)
c
       if (syma.eq.symb) then
       bup=a
       else
       bup=nvb(symb)
       end if
c
c*    cycle over b for given a
c
       do 1000 b=1,bup
       bvint=nob(symb)+b
c
c*    map _a_b(pq) block into #v3
c
       pq=poss30-1
       do 100 q=1,norb(symq)
       do 101 p=1,norb(symp)
       pq=pq+1
       wrk(pq)=vint(bvint,p,q)
 101    continue
 100    continue
c
c*    put this block to iappropriate possition in direct acces file
c
       irec0=abmap(a,b,symp)
       call dawrite (lunda1,irec0,wrk(poss30),lenght,recl)
c
 1000   continue
c
       return
       end
c
c     --------------------------
c
       subroutine ampack (wrk,wrksize,
     & syma,symm,symp,symq,a,vint,ndimv1,ndimv2,ndimv3,
     & ammap)
c
c     this routine pack corresponding parts to ab direct acc. file
c     from given integrals <_a,bb,p,q> readed in vint
c
c     syma  - irrep of first index (I)
c     symm  - irrep of 2.nd index - m (I)
c     symp  - irrep of p (I)
c     symq  - irrep of q (I)
c     a- pivot virtual index (counted in nvb set) (I)
c     vint  - array of integrals <_a,mm,p,q> (I)
c     ndimv1- 1.st dimension of vint - norb(symb) (I)
c     ndimv2- 2.nd dimension of vint - norb(symp) (I)
c     ndimv3- 3.rd dimension of vint - norb(symq) (I)
c     ammap - map for storing of addresses in DA file TEMPDA2 (I)
c
#include "wrk.fh"
#include "ccsort.fh"
#include "reorg.fh"
c
       integer syma,symm,symp,symq,a,ndimv1,ndimv2,ndimv3
       real*8 vint(1:ndimv1,1:ndimv2,1:ndimv3)
       integer ammap(1:mbas,1:8,1:8)
c
c     help variables
c
       integer m,p,q,pq,irec0,lenght
c
cT    if there are no a, or no integrals in _a_mpq block return
c
       if (nvb(syma)*noa(symm)*norb(symp)*norb(symq).eq.0) then
       return
       end if
c
c*    def lenght of _a(m,p,q) block
c
       lenght=noa(symm)*norb(symp)*norb(symq)
c
c*    map _a(mpq) block into #v3
c
       pq=poss30-1
c
       do 100 q=1,norb(symq)
       do 101 p=1,norb(symp)
       do 102 m=1,noa(symm)
       pq=pq+1
       wrk(pq)=vint(m,p,q)
 102    continue
 101    continue
 100    continue
c
c*    put this block to iappropriate possition in direct acces file
c
       irec0=ammap(a,symm,symp)
       call dawrite (lunda2,irec0,wrk(poss30),lenght,recl)
c
       return
       end
c
c     ------------------------
c
       subroutine addintab (wrk,wrksize,
     & syma,symb,abmap)
c
c     this routine add contribution to opened INTAB1 file,
c     comming from ab syma,symb
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       integer syma,symb
       integer abmap(1:mbas,1:mbas,1:8)
c
c     help variables
c
       integer nhelp,lenght,symp,symq,symab,irec0,poss3
       integer poss,a,b,bup,ii,rc
c
c*    def symab
       symab=mul(syma,symb)
c
c*    make mapd3,mapi3 for <_a_b|pq>
c
c**   set mapi3=0 (partly)
c
       do 100 nhelp=1,nsym
       do 101 symq=1,nsym
       do 102 symp=1,nsym
       mapi3(symp,symq,nhelp)=0
 102    continue
 101    continue
 100    continue
c
c**   def 0-th row
c
       mapd3(0,1)=5
       mapd3(0,2)=5
       mapd3(0,3)=0
       mapd3(0,4)=0
       mapd3(0,5)=nsym
       mapd3(0,6)=0
c
c**   def other rows
c
       poss=poss30
       do 200 ii=1,nsym
c
       symp=ii
       symq=mul(symab,symp)
       lenght=norb(symp)*norb(symq)
       mapd3(ii,1)=poss
       mapd3(ii,2)=lenght
       mapd3(ii,3)=symp
       mapd3(ii,4)=symq
       mapd3(ii,5)=1
       mapd3(ii,6)=1
       mapi3(symp,1,1)=ii
       poss=poss+lenght
c
 200    continue
c
c*    write mapd,mapi to INTAB
       call dawrtmap (lunab,mapd3,mapi3,rc)
c
cT    if there are no _a_b,pq integrals in this symab,
c     skip sumation over ab
c
       if ((mapd3(nsym,1)+mapd3(nsym,2)).eq.poss30) then
       return
       end if
c
c*    loop over a,b
c
       do 1000 a=1,nvb(syma)
c
       if (syma.eq.symb) then
       bup=a
       else
       bup=nvb(symb)
       end if
c
       do 1001 b=1,bup
c
c**   loop over symp
c
       do 500 symp=1,nsym
c
c***  def irec0 for this a,b,symp in TEMPDA1
       irec0=abmap(a,b,symp)
c
c***  def corresponding possition and lenght in #3
       ii=mapi3(symp,1,1)
       poss3=mapd3(ii,1)
       lenght=mapd3(ii,2)
c
c***  read this block to #3
       if (lenght.gt.0) then
       call daread (lunda1,irec0,wrk(poss3),lenght,recl)
       end if
c
 500    continue
c
c**   since there must be some integrals, write them to TEMPAB
c
       call deflenght (mapd3,lenght)
       call dawri (lunab,lenght,wrk(poss30))
c
 1001   continue
 1000   continue
c
       return
       end
c
c     ------------------------
c
       subroutine mkampq (wrk,wrksize,
     & a,syma,ammap)
c
c     this routine reconstruct #2 V2<_a,m|p,q> from corresponding TEMPDA2 file
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       integer a,syma
       integer ammap(1:mbas,1:8,1:8)
c
c     help variables
c
       integer symm,symp,symq,symam
       integer iiv2,lenght,poss,irec0
c
c*    loops over symmetry combinations
       do 100 symm=1,nsym
       symam=mul(syma,symm)
       do 101 symp=1,nsym
       symq=mul(symam,symp)
c
c*    def initioal record possition in TEMPDA2
c     and corresponding possition and lenght in wrk (#2)
c
       irec0=ammap(a,symm,symp)
       iiv2=mapi2(symm,symp,1)
       poss=mapd2(iiv2,1)
       lenght=mapd2(iiv2,2)
c
       if (lenght.gt.0) then
       call daread (lunda2,irec0,wrk(poss),lenght,recl)
       end if
c
 101    continue
 100    continue
c
       return
       end
c
c     ------------------------
c
       subroutine vf (name,lun)
c
c      this routine open file vanisf file with a given name
c      name - name of the vanished file (I)
c      lun  - lun number with which file will be opened (I)
c
       character*8 name
       integer lun
c
       call molcas_open(lun,name)
c       open (unit=lun,file=name)
       write (lun,*) ' File scratched'
       close (lun)
c
       return
       end
c
c     ------------------------
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine TWOCT(C,S,W,THET,ENP,EPP,ABIJ,AIBJ,AJBI,BUFAB,A,B,F,FSEC,FIJKL,BUFIJ,BMN,IBMN,AC1,AC2,BUFAC)

use cpf_global, only: ICPF, IFIRST, ILIM, INCPF, INDX, IRC, ISAB, ITER, ISDCI, JSY
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: C(*), S(*), W(*), EPP(*), ABIJ(*), AIBJ(*), AJBI(*), FSEC(*)
real(kind=wp), intent(_OUT_) :: BUFAB(*), A(*), B(*), F(*), FIJKL(*), BUFIJ(*), BMN(*), AC1(*), AC2(*), BUFAC(*)
real(kind=wp), intent(in) :: THET(*), ENP(*)
integer(kind=iwp), intent(_OUT_) :: IBMN(*)

if ((ISDCI /= 0) .or. (ICPF /= 0) .or. (INCPF /= 0)) then
  ! CPF, ACPF AND SDCI
  if (ITER /= 1) then
    call DIAGC_CPF(JSY,C,S)
    if (IFIRST == 0) call ABCI_CPF(JSY,INDX,C,S,BMN,IBMN,AC1,AC2,BUFAC)
    call IJKL_CPF(JSY,INDX,C,S,FIJKL,BUFIJ,ENP,EPP)
    if (IFIRST == 0) call ABCD_CPF(JSY,INDX,ISAB,C,S,AC1,AC2,BUFAC)
  end if
  call FAIBJ_CPF(JSY,INDX,C,S,ABIJ,AIBJ,AJBI,BUFAB,A,B,F,FSEC,ENP,EPP)
else
  ! MCPF
  if (ITER /= 1) then
    call MDIAGC(JSY,C,S,W,THET,ENP,IRC(ILIM))
    if (IFIRST == 0) call MABCI(JSY,INDX,C,S,BMN,IBMN,AC1,AC2,BUFAC,W,THET,ENP,IRC(ILIM))
    call MIJKL(JSY,INDX,C,S,FIJKL,BUFIJ,W,THET,ENP,EPP,IRC(ILIM))
    if (IFIRST == 0) call MABCD(JSY,INDX,ISAB,C,S,AC1,AC2,BUFAC,W,THET,ENP,IRC(ILIM))
  end if
  call MFAIBJ(JSY,INDX,C,S,ABIJ,AIBJ,AJBI,BUFAB,A,B,F,FSEC,W,THET,ENP,EPP,IRC(ILIM))
end if

return

end subroutine TWOCT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE COUL(ISYP,ISYQ,ISYI,ISYJ,II,IJ,ERI,SCR)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "standard_iounits.fh"
      DIMENSION ERI(*), SCR(*)
      LOGICAL TRANSP
      LOGICAL TRIANG

#include "intgrl.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "blksize.fh"

C Return a matrix ERI(IP,IQ) of two-electron integrals (pq,ij).
C IP=1..NORB(ISYP), IQ=1..NORB(ISYQ),1<=II<=NOSH(ISYI),
C 1<=IJ<=NOSH(ISYJ). Normal Fortran storage order.

      NDIM2M=(NSYMZ*(NSYMZ+1))/2
        TRANSP=.false.
        TRIANG=.false.
      IF(ISYP.GE.ISYQ) THEN
        ISY1=ISYP
        ISY2=ISYQ
        TRANSP=.true.
c        TYPE='TRANSPOS'
        IF(ISYP.EQ.ISYQ) then
        TRIANG=.true.
        endif
c        IF(ISYP.EQ.ISYQ) TYPE='TRIANGUL'
      ELSE
        ISY1=ISYQ
        ISY2=ISYP
c        TYPE='NORMAL  '
      END IF
      IF(ISYI.GE.ISYJ) THEN
        ISY3=ISYI
        ISY4=ISYJ
        I3=II
        I4=IJ
        IF(ISYI.EQ.ISYJ .AND. II.LT.IJ) THEN
          I3=IJ
          I4=II
        END IF
      ELSE
        ISY3=ISYJ
        ISY4=ISYI
        I3=IJ
        I4=II
      END IF

C Disk address to symmetry block:
      IS12=(ISY1*(ISY1-1))/2+ISY2
      IS34=(ISY3*(ISY3-1))/2+ISY4
      IDISK=IAD2M(1,IS12+NDIM2M*(IS34-1))

C Record number, in symmetry block:
      I34=I4+NOSHZ(ISY4)*(I3-1)
      IF(ISY3.EQ.ISY4) I34=(I3*(I3-1))/2+I4

C Buffer sizes:
      NO1=NORBZ(ISY1)
      NO2=NORBZ(ISY2)
      NBUF=NO1*NO2
      IF(TRIANG) NBUF=(NBUF+NO1)/2
      IF(NBUF.EQ.0) RETURN

C Address update for earlier records, then read:
      IDISK=IDISK+NBUF*(I34-1)
*
      IF(.not.TRANSP) THEN
        CALL dDAFILE(LUINTMZ,2,ERI,NBUF,IDISK)
      ELSE
        CALL dDAFILE(LUINTMZ,2,SCR,NBUF,IDISK)
*
        IF(.not.TRIANG) THEN
          CALL TRNSPS(NO2,NO1,SCR,ERI)
        ELSE
          CALL SQUARE(SCR,ERI,NO1,1,NO1)
        END IF
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine GradLoop(Heff,Ueff,H0,U0,H0Sav,nState)
! Gradient loop for MS-CASPT2 variants
! Usually, we do not solve the CASPT2 equation again; the excitation
! amplitude etc. have been stored on disk (should be avoided, though)
! in the first loop (for energy) and are restored in the second loop
! below (by calling SavGradParams)

use PrintLevel, only: USUAL, VERBOSE
use EQSOLV, only: iRHS, iVecC, iVecC2, iVecR, iVecW, iVecX
use caspt2_global, only: do_grad, IDSAVGRD, iPrGlb, iStpGrd
use caspt2_module, only: CPUEIG, CPUFG3, CPUFMB, CPUGIN, CPUGRD, CPUINT, CPULCS, CPUNAD, CPUOVL, CPUPCG, CPUPRP, CPUPT2, CPURHS, &
                         CPUSBM, CPUSCA, CPUSER, CPUSGM, CPUSIN, CPUVEC, Energy, IfChol, IfDens, IfDW, IfMSCoup, IfProp, IfRMS, &
                         IfXMS, iRlxRoot, jState, mState, nGroup, nGroupState, PT2Method, TIOEIG, TIOFG3, TIOFMB, TIOGIN, TIOGRD, &
                         TIOINT, TIOLCS, TIONAD, TIOOVL, TIOPCG, TIOPRP, TIOPT2, TIORHS, TIOSBM, TIOSCA, TIOSER, TIOSGM, TIOSIN, &
                         TIOVEC
use SC_NEVPT2, only: Do_FIC
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nState
real(kind=wp), intent(inout) :: Heff(nState,nState), Ueff(nState,nState), H0(nState,nState), U0(nState,nState), H0Sav(nState,nState)
integer(kind=iwp) :: ICONV, IGROUP, ISTATE, JSTATE_OFF, LAXITY
real(kind=wp) :: CPE, CPTF0, CPTF11, CPTF12, CPTF13, CPTF14, CPUTOT, TIOE, TIOTF0, TIOTF11, TIOTF12, TIOTF13, TIOTF14, TIOTOT
character(len=60) :: STLNE2
integer(kind=iwp), external :: Cho_X_GetTol

! Effective Hamiltonian: Heff, Ueff
! Zeroth-order Hamiltonian: H0, U0, H0Sav
! Timers: CPTF0, CPTF11, CPTF12, CPTF13, CPTF14, TIOTF0, TIOTF11, TIOTF12, TIOTF13, TIOTF14, CPE, CPUTOT, TIOE, TIOTOT
! Indices: ISTATE, IGROUP, JSTATE_OFF
! Convergence check: ICONV
! For verification only: LAXITY

IDSAVGRD = 0

if (iStpGrd == 0) then
  ! just for verification
  LAXITY = 8
  if (IfChol) LAXITY = Cho_X_GetTol(LAXITY)
  call Add_Info('E_MSPT2',ENERGY,nState,LAXITY)
end if

iStpGrd = 2

! For (X)Multi-State, a long loop over root states.
! The states are ordered by group, with each group containing a number
! of group states for which GRPINI is called.
JSTATE_OFF = 0
stateloop2: do IGROUP=1,NGROUP

  if (IPRGLB >= USUAL) then
    write(STLNE2,'(A,1X,I3)') trim(PT2Method)//' computation for group',IGROUP
    call CollapseOutput(1,trim(STLNE2))
    write(u6,*)
  end if

  call GRPINI(IGROUP,NGROUPSTATE(IGROUP),JSTATE_OFF,HEFF,H0,U0,nState)

  if (do_grad) call CNSTFIFAFIMO(1)

  do ISTATE=1,NGROUPSTATE(IGROUP)
    JSTATE = JSTATE_OFF+ISTATE

    call TIMING(CPTF0,CPE,TIOTF0,TIOE)
    !call STINI(JSTATE)
    call RHS_INIT() !! somehow
    call SavGradParams(2,IDSAVGRD)
    call SavGradParams2(2,UEFF,U0,H0,nState)
    if ((IFXMS .and. IFDW) .or. IFRMS) H0(:,:) = H0Sav(:,:)
    call TIMING(CPTF11,CPE,TIOTF11,TIOE)
    CPUSIN = CPTF11-CPTF0
    TIOSIN = TIOTF11-TIOTF0

    ! Solve CASPT2 equation system and compute corr energies.
    if (IPRGLB >= USUAL) then
      write(u6,'(A)') repeat('*',80)
      write(u6,'(2X,A)') trim(PT2Method)//' EQUATION SOLUTION (SECOND RUN)'
      write(u6,'(A)') repeat('*',80)
    end if

    write(STLNE2,'(A,I0)') 'Solve '//trim(PT2Method)//' eqs. for state ',MSTATE(JSTATE)
    call StatusLine('CASPT2: ',STLNE2)
    call EQCTL2(ICONV)

    ! Save the final caspt2 energy in the global array ENERGY():
    !ENERGY(JSTATE) = E2TOT

    call TIMING(CPTF12,CPE,TIOTF12,TIOE)
    CPUPT2 = CPTF12-CPTF11
    TIOPT2 = TIOTF12-TIOTF11

    ! Orbitals, properties:
    ! if the dens keyword is used, need accurate density and
    ! for that the serial LUSOLV file is needed, in that case copy
    ! the distributed LURHS() to LUSOLV here.
    if (IFDENS .or. (do_grad .and. ((iRlxRoot == MSTATE(JSTATE)) .or. IFMSCOUP))) then
      if (do_FIC) then
        call PCOLLVEC(IRHS,0)
        call PCOLLVEC(IVECX,0)
        call PCOLLVEC(IVECR,0)
        call PCOLLVEC(IVECC,1)
        call PCOLLVEC(IVECC2,1)
        call PCOLLVEC(IVECW,1)
      end if
    end if

    if (IFPROP .or. (do_grad .and. ((IRLXroot == MSTATE(JSTATE)) .or. IFMSCOUP))) then

      call PRPCTL(0,UEFF,U0,nState)

    else
      if (IPRGLB >= USUAL) then
        write(u6,*)
        write(u6,*) '  (Skipping property calculation,'
        write(u6,*) '   use PROP keyword to activate)'
      end if
    end if

    call TIMING(CPTF13,CPE,TIOTF13,TIOE)
    CPUPRP = CPTF13-CPTF12
    TIOPRP = TIOTF13-TIOTF12

    call TIMING(CPTF14,CPE,TIOTF14,TIOE)
    CPUGRD = CPTF14-CPTF13
    TIOGRD = TIOTF14-TIOTF13

    CPUTOT = CPTF14-CPTF0
    TIOTOT = TIOTF14-TIOTF0

    call Iter_Timing()

    ! End of long loop over states in the group
  end do

  if (IPRGLB >= USUAL) then
    call CollapseOutput(0,trim(STLNE2))
    write(u6,*)
  end if
  ! End of long loop over groups
  JSTATE_OFF = JSTATE_OFF+NGROUPSTATE(IGROUP)
end do stateloop2

contains

subroutine Iter_Timing()

  if (ISTATE == 1) then
    CPUTOT = CPUTOT+CPUGIN
    TIOTOT = TIOTOT+TIOGIN
  else
    CPUGIN = Zero
    TIOGIN = Zero
    CPUFMB = Zero
    TIOFMB = Zero
    CPUINT = Zero
    TIOINT = Zero
  end if

  if (IPRGLB >= VERBOSE) then
    write(u6,*)
    write(u6,'(A,I6)') '  CASPT2 TIMING INFO FOR STATE ',MSTATE(JSTATE)
    write(u6,*)
    write(u6,'(A)') '                         cpu time  (s)  wall time (s) '
    write(u6,'(A)') '                         -------------  ------------- '
    write(u6,*)
    write(u6,'(A,2F14.2)') '  Group initialization  ',CPUGIN,TIOGIN
    write(u6,'(A,2F14.2)') '  - Fock matrix build   ',CPUFMB,TIOFMB
    write(u6,'(A,2F14.2)') '  - integral transforms ',CPUINT,TIOINT
    write(u6,'(A,2F14.2)') '  State initialization  ',CPUSIN,TIOSIN
    write(u6,'(A,2F14.2)') '  - density matrices    ',CPUFG3,TIOFG3
    write(u6,'(A,2F14.2)') '  CASPT2 equations      ',CPUPT2,TIOPT2
    write(u6,'(A,2F14.2)') '  - H0 S/B matrices     ',CPUSBM,TIOSBM
    write(u6,'(A,2F14.2)') '  - H0 S/B diag         ',CPUEIG,TIOEIG
    write(u6,'(A,2F14.2)') '  - H0 NA diag          ',CPUNAD,TIONAD
    write(u6,'(A,2F14.2)') '  - RHS construction    ',CPURHS,TIORHS
    write(u6,'(A,2F14.2)') '  - PCG solver          ',CPUPCG,TIOPCG
    write(u6,'(A,2F14.2)') '    - scaling           ',CPUSCA,TIOSCA
    write(u6,'(A,2F14.2)') '    - lin. comb.        ',CPULCS,TIOLCS
    write(u6,'(A,2F14.2)') '    - inner products    ',CPUOVL,TIOOVL
    write(u6,'(A,2F14.2)') '    - basis transforms  ',CPUVEC,TIOVEC
    write(u6,'(A,2F14.2)') '    - sigma routines    ',CPUSGM,TIOSGM
    write(u6,'(A,2F14.2)') '  - array collection    ',CPUSER,TIOSER
    write(u6,'(A,2F14.2)') '  Properties            ',CPUPRP,TIOPRP
    write(u6,'(A,2F14.2)') '  MS coupling           ',CPUGRD,TIOGRD
    write(u6,'(A,2F14.2)') ' Total time             ',CPUTOT,TIOTOT
    write(u6,*)
  end if

end subroutine Iter_Timing

end subroutine GradLoop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SqM(a,b,n)
      integer n,i,j,ij
      Real*8 a(*),b(n,n)
      ij=0
      Do i=1,n
       Do j=i,n
        ij=ij+1
        B(i,j)=A(ij)
        B(j,i)=A(ij)
       End Do
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DiagMtrx(H,nH,iNeg)

use Index_Functions, only: nTri_Elem
use PrintLevel, only: nPrint
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nH
real(kind=wp), intent(in) :: H(nH,nH)
integer(kind=iwp), intent(out) :: iNeg
integer(kind=iwp) :: i, ij, iPrint, iRout, j, LuTmp, nq, nQQ
real(kind=wp) :: SumHii
logical(kind=iwp) :: Exists
character(len=16) :: filnam
real(kind=wp), allocatable :: EVal(:), EVec(:), qEVec(:), rK(:)

iRout = 21
iPrint = nPrint(iRout)

call mma_allocate(EVal,nTri_Elem(nH),Label='EVal')
call mma_allocate(EVec,nH**2,Label='EVec')

! Copy elements for H

SumHii = Zero
do i=1,nH
  do j=1,i
    ij = nTri_Elem(i-1)+j
    EVal(ij) = H(i,j)
  end do
  SumHii = SumHii+H(i,i)
end do
!write(u6,*) ' SumHii=',SumHii

! Set up a unit matrix

call unitmat(EVec,nH)

! Compute eigenvalues and eigenvectors

call NIDiag_new(EVal,EVec,nH,nH)
call Jacord(EVal,EVec,nH,nH)

! Print out the result

iNeg = 0
do i=1,nH
  if (EVal(nTri_Elem(i)) < Zero) iNeg = iNeg+1
end do
if (iprint > 5) then
  write(u6,*)
  write(u6,*) '*****************************************************************'
  write(u6,*) '* Eigenvalues and Eigenvectors of the Hessian                   *'
  write(u6,*) '*****************************************************************'
end if

filnam = 'SPCINX'
call f_Inquire(filnam,Exists)

if (Exists .and. (iprint > 5)) then

  ! Read linear combinations from disc

  LuTmp = 11
  call molcas_binaryopen_Vanilla(luTmp,filnam)
  !open(luTmp,File=filnam,Form='unformatted',Status='unknown')
  rewind(LuTmp)

  read(LuTmp) nq,nQQ

  if (nQQ == nH) then

    call mma_allocate(rK,nq*nQQ,Label='rK')
    call mma_allocate(qEVec,nq*nH,Label='qEVec')

    call Print_qEVec(EVec,nH,EVal,nq,rK,qEVec,LuTmp)

    call mma_deallocate(qEVec)
    call mma_deallocate(rK)

  else

    write(u6,*)
    write(u6,*) 'Eigenvalues of the Hessian'
    write(u6,*)
    write(u6,'(1X,10F10.5)') (EVal(nTri_Elem(i)),i=1,nH)
    write(u6,*)
    write(u6,*) 'Eigenvectors of the Hessian'
    write(u6,*)
    do i=1,nH
      write(u6,'(1X,10F10.5)') (EVec((j-1)*nH+i),j=1,nH)
    end do
  end if

  close(LuTmp)

else if (iprint > 5) then

  call Print_qEVec2(nH,EVal,EVec)

end if

call mma_deallocate(EVec)
call mma_deallocate(EVal)

end subroutine DiagMtrx

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_multiple_T_worker

use fmm_global_paras, only: INTK, REALK, One, Two, Half

implicit none
private
! Public procedures
public :: fmm_get_SPLTSQ_T_matrices, &
          fmm_get_FLTSQ_T_matrices, &
          fmm_contract_multi_Tq

contains

!------------------------------------------------------------------------------
! Get sparse (l+j <= LMAX), lower-triangular, square-based T-matrix
!FIXME: would be nice to allow possibility of building rectangular-based too

subroutine fmm_get_SPLTSQ_T_matrices(ndim,LMAX,r_ab,T_matrix)

  implicit none
  integer(INTK), intent(in) :: ndim, LMAX
  real(REALK), intent(in)   :: r_ab(:,:)
  real(REALK), intent(out)  :: T_matrix(:,:,:)

  real(REALK) :: I_sh(ndim,(1+LMAX)**2)

  call fmm_generate_I(ndim,LMAX,r_ab,I_sh)
  call fmm_generate_T(LMAX,.false.,I_sh,T_matrix)

end subroutine fmm_get_SPLTSQ_T_matrices

!------------------------------------------------------------------------------
! Get full (all elements built), lower-triangular, square T-matrix

subroutine fmm_get_FLTSQ_T_matrices(ndim,LMAX,r_ab,T_matrix)

  implicit none
  integer(INTK), intent(in) :: ndim, LMAX
  real(REALK), intent(in)   :: r_ab(:,:)
  real(REALK), intent(out)  :: T_matrix(:,:,:)

  real(REALK) :: I_sh(ndim,(1+2*LMAX)**2)

  call fmm_generate_I(ndim,2*LMAX,r_ab,I_sh)
  call fmm_generate_T(LMAX,.true.,I_sh,T_matrix)

end subroutine fmm_get_FLTSQ_T_matrices

!------------------------------------------------------------------------------

subroutine fmm_generate_I(ndim,LMAX,r_ab,I_sh)

  ! Subroutine to generate Scaled Irregular solid harmonics
  ! See page 416, "Molecular Electronic Structure Theory".
  !--------------------------------------------------------
  ! I_sh(M,L)  == COS component of I_sh(M,L)
  ! I_sh(-M,L) == SIN component of I_sh(-M,L)
  ! where L and M are positive
  ! Note that I_sh(0,L) == COS component of I_sh(0,L) !
  ! In fact we combine (l,m) into a single index and
  ! we assume the order 0, -1,1,+1, -2,-1,0,+1,+2 ...
  !--------------------------------------------------------

  implicit none
  integer(INTK), intent(in) :: LMAX, NDIM
  real(REALK), intent(in)   :: r_ab(:,:)
  real(REALK), intent(out)  :: I_sh(:,:)

  real(REALK) :: r_minus2(NDIM)
  integer(INTK) :: L, m, i, j, k, p, q, u, sign_L, n, p1, q1, m1
  real(REALK) :: var1, var2, var3, rmin2

  r_minus2(:) = one/(r_ab(:,1)**2+r_ab(:,2)**2+r_ab(:,3)**2)

  if (LMAX == 0) then
    I_sh(:,1) = sqrt(r_minus2(:))
    return
  end if

  I_sh(:,1) = sqrt(r_minus2(:))
  I_sh(:,2) = -r_ab(:,2)*r_minus2(:)*I_sh(:,1)
  I_sh(:,3) = r_ab(:,3)*r_minus2(:)*I_sh(:,1)
  I_sh(:,4) = -r_ab(:,1)*r_minus2(:)*I_sh(:,1)

  ! Now iterate higher order terms
  sign_L = -1
  do L=2,LMAX

    sign_L = -sign_L
    i = (L+1)*(L+1)
    j = L*L+1
    p = j-2*L+1
    q = j-1
    p1 = p
    q1 = q
    p = p+L-1
    q = L*(L-3)+3
    u = q+L-2
    k = i-L
    m1 = L-1

    do n=1,ndim

      rmin2 = r_minus2(n)
      var1 = (2*L-1)*rmin2
      var2 = var1*r_ab(n,2)*sign_L
      var3 = var1*r_ab(n,1)
      I_sh(n,i) = var2*I_sh(n,p1)-var3*I_sh(n,q1)
      I_sh(n,j) = var2*I_sh(n,q1)+var3*I_sh(n,p1)
      var2 = var1*r_ab(n,3)

      do m=0,L-2
        var3 = (u-m*m)*rmin2
        I_sh(n,k+m) = var2*I_sh(n,p+m)-var3*I_sh(n,q+m)
        I_sh(n,k-m) = var2*I_sh(n,p-m)-var3*I_sh(n,q-m)
      end do

      I_sh(n,k+m1) = var2*I_sh(n,p+m1)
      I_sh(n,k-m1) = var2*I_sh(n,p-m1)

    end do

  end do

end subroutine fmm_generate_I

!------------------------------------------------------------------------------

subroutine fmm_generate_T(LMAX,TOLMAX,I_sh,T_matrix)

! Subroutine to generate Real Interaction Matrix for
! given point from Irregular Solid Harmonics (I_sh)
! cf Helgaker et. al. pp 415
!-----------------------------------------------------------------------
!  T_cos_cos(lm,jk) = 2*{I_cos(l+j,m+k) + (-1)^k*I_cos(l+j,m-k)}  etc.
!
! Note we only write the non-zero elements here, and the precise form
! depends on the function JMAX passed in
!-----------------------------------------------------------------------
!FIXME: can optimise for j=l by noting that if we build just lower
! triangular, we need only half the elements there

  implicit none
  integer(INTK), intent(in) :: LMAX
  logical, intent(in)       :: TOLMAX
  real(REALK), intent(in)   :: I_sh(:,:)
  real(REALK), intent(out)  :: T_matrix(:,:,:)

  integer(INTK) :: sign_m
  integer(INTK) :: L, J, k, m, q, pp, qq, u, Jlast

  if (LMAX == 0) then
    T_matrix(:,1,1) = two*I_sh(:,1)  ! NB scaling to make T symmetric
    return
  end if

  L_loop: do L=0,LMAX
    qq = L*(L+1)+1

    if (tolmax) then
      Jlast = LMAX
    else
      Jlast = LMAX-L
    end if

    J_loop: do J=L,Jlast
      pp = J*(J+1)+1
      u = 1+(L+J)*(L+J+1)

      sign_m = -1
      positive_m: do m=0,L
        q = qq+m
        sign_m = -sign_m

        ! cos-cos terms
        !---------------

        do k=0,min(m,J)
          if (btest(k,0)) then
            T_matrix(:,pp+k,q) = I_sh(:,u+m+k)-I_sh(:,u+m-k)
          else
            T_matrix(:,pp+k,q) = I_sh(:,u+m+k)+I_sh(:,u+m-k)
          end if
        end do
        if (sign_m > 0) then
          do k=m+1,J
            T_matrix(:,pp+k,q) = I_sh(:,u+m+k)+I_sh(:,u-m+k)
          end do
        else
          do k=m+1,J
            T_matrix(:,pp+k,q) = I_sh(:,u+m+k)-I_sh(:,u-m+k)
          end do
        end if

        ! cos-sin terms
        !---------------

        if (sign_m > 0) then
          do k=-J,min(-m-1,-1)
            T_matrix(:,pp+k,q) = I_sh(:,u+(m+k))+I_sh(:,u+(-(m-k)))
          end do
          do k=max(-J,-m),min(-m,-1)
            T_matrix(:,pp+k,q) = I_sh(:,u+(-(m-k)))
          end do
          do k=-1,max(-m+1,-J),-1
            if (btest(k,0)) then
              T_matrix(:,pp+k,q) = I_sh(:,u+(-(m+k)))+I_sh(:,u+(-(m-k)))
            else
              T_matrix(:,pp+k,q) = -I_sh(:,u+(-(m+k)))+I_sh(:,u+(-(m-k)))
            end if
          end do
        else
          do k=-J,min(-m-1,-1)
            T_matrix(:,pp+k,q) = I_sh(:,u+(m+k))-I_sh(:,u+(-(m-k)))
          end do
          do k=max(-J,-m),min(-m,-1)
            T_matrix(:,pp+k,q) = -I_sh(:,u+(-(m-k)))
          end do
          do k=-1,max(-m+1,-J),-1
            if (btest(k,0)) then
              T_matrix(:,pp+k,q) = -I_sh(:,u+(-(m+k)))-I_sh(:,u+(-(m-k)))
            else
              T_matrix(:,pp+k,q) = I_sh(:,u+(-(m+k)))-I_sh(:,u+(-(m-k)))
            end if
          end do
        end if

      end do positive_m

      sign_m = 1
      negative_m: do m=-1,-L,-1
        q = qq+m
        sign_m = -sign_m

        ! sin-cos terms
        !---------------

        k = min(J,-m)
        if (btest(k,0)) then
          T_matrix(:,pp+k,q) = -I_sh(:,u+(m-k))
        else
          T_matrix(:,pp+k,q) = I_sh(:,u+(m-k))
        end if

        do k=0,min((-m-1),J)
          if (btest(k,0)) then
            T_matrix(:,pp+k,q) = I_sh(:,u+(m+k))-I_sh(:,u+(m-k))
          else
            T_matrix(:,pp+k,q) = I_sh(:,u+(m+k))+I_sh(:,u+(m-k))
          end if
        end do

        if (sign_m > 0) then
          do k=J,(-m+1),-1
            if (btest(k,0)) then
              T_matrix(:,pp+k,q) = I_sh(:,u+(-(m+k)))-I_sh(:,u+(m-k))
            else
              T_matrix(:,pp+k,q) = -I_sh(:,u+(-(m+k)))+I_sh(:,u+(m-k))
            end if
          end do
        else
          do k=J,(-m+1),-1
            if (btest(k,0)) then
              T_matrix(:,pp+k,q) = -I_sh(:,u+(-(m+k)))-I_sh(:,u+(m-k))
            else
              T_matrix(:,pp+k,q) = I_sh(:,u+(-(m+k)))+I_sh(:,u+(m-k))
            end if
          end do
        end if

        ! sin-sin terms
        !---------------

        if (sign_m > 0) then
          do k=-J,m
            if (btest(k,0)) then
              T_matrix(:,pp+k,q) = I_sh(:,u+(-(m+k)))-I_sh(:,u+(m-k))
            else
              T_matrix(:,pp+k,q) = -I_sh(:,u+(-(m+k)))+I_sh(:,u+(m-k))
            end if
          end do
          do k=-1,max(-J,m+1),-1
            if (btest(k,0)) then
              T_matrix(:,pp+k,q) = I_sh(:,u+(-(m+k)))+I_sh(:,u+(-(m-k)))
            else
              T_matrix(:,pp+k,q) = -I_sh(:,u+(-(m+k)))+I_sh(:,u+(-(m-k)))
            end if
          end do
        else
          do k=-J,m
            if (btest(k,0)) then
              T_matrix(:,pp+k,q) = -I_sh(:,u+(-(m+k)))-I_sh(:,u+(m-k))
            else
              T_matrix(:,pp+k,q) = I_sh(:,u+(-(m+k)))+I_sh(:,u+(m-k))
            end if
          end do
          do k=-1,max(-J,m+1),-1
            if (btest(k,0)) then
              T_matrix(:,pp+k,q) = -I_sh(:,u+(-(m+k)))-I_sh(:,u+(-(m-k)))
            else
              T_matrix(:,pp+k,q) = I_sh(:,u+(-(m+k)))-I_sh(:,u+(-(m-k)))
            end if
          end do
        end if

      end do negative_m
    end do J_loop
  end do L_loop

end subroutine fmm_generate_T

!------------------------------------------------------------------------------

function fmm_contract_multi_Tq(LMAX,vect,T_mats,ndim)

  implicit none
  integer(INTK), intent(in) :: LMAX, ndim
  real(REALK), intent(in)   :: vect(:)
  real(REALK), intent(in)   :: T_mats(:,:,:)

  real(REALK) :: fmm_contract_multi_Tq(ndim,(LMAX+1)**2)
  integer(INTK) :: L, p, q, r, s, u, qmin, qmax
  real(REALK) :: fac

  ! first do L=0 terms
  p = (LMAX+1)*(LMAX+1)

  fac = half*vect(1)
  do r=1,ndim
    fmm_contract_multi_Tq(r,1) = fac*T_mats(r,1,1)
  end do

  do s=2,p
    fac = half*vect(s)
    do r=1,ndim
      fmm_contract_multi_Tq(r,1) = fmm_contract_multi_Tq(r,1)+fac*T_mats(r,s,1)
    end do
  end do

  fac = vect(1)
  do s=2,p
    do r=1,ndim
      fmm_contract_multi_Tq(r,s) = fac*T_mats(r,s,1)
    end do
  end do

  contract: do L=1,LMAX

    u = L*(L+1)+1
    p = (LMAX-L+1)*(LMAX-L+1)

    qmin = u-L
    qmax = min(u+L,p)

    qloop: do q=qmin,qmax

      do s=q,p
        call DAXPY_(ndim,vect(s),T_mats(1,s,q:),1,fmm_contract_multi_Tq(1,q),1)
      end do

      fac = vect(q)
      do s=q+1,p
        do r=1,ndim
          fmm_contract_multi_Tq(r,s) = fmm_contract_multi_Tq(r,s)+fac*T_mats(r,s,q)
        end do
      end do

    end do qloop

    fmm_contract_multi_Tq(:,u) = half*fmm_contract_multi_Tq(:,u)    ! m=0

  end do contract

end function fmm_contract_multi_Tq

!------------------------------------------------------------------------------

end module fmm_multiple_T_worker

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016, Steven Vancoillie                                *
*               2017, Stefan Knecht                                    *
************************************************************************
! author: S. Knecht (modified version of pt2wfn.f in CASPT2 written by
!                    S. Vancoillie)
!***********************************************************************
      module nevpt2wfn
      integer :: pt2wfn_id
      logical :: pt2wfn_is_h5 = .False.
      integer :: pt2wfn_refene, pt2wfn_energy_sc, pt2wfn_energy_pc
      integer :: pt2wfn_mocoef!, pt2wfn_occnum, pt2wfn_orbene
      integer :: pt2wfn_heff_sc, pt2wfn_heff_pc
      integer :: pt2wfn_heff_evc_sc, pt2wfn_heff_evc_pc
      integer :: pt2wfn_ref_checkpoint
      save

      contains

      subroutine nevpt2wfn_init(create_h5)
!     Create a wavefunction file and replace any existing .wfn file
      use refwfn
      use nevpt2_cfg
      use info_state_energy  ! energies, effective Hamiltonian
      use info_orbital_space ! orbital specifications read from JobIph
      implicit none
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "pt2_guga.fh"
      logical, intent(in)       :: create_h5
#ifdef _HDF5_
#  include "mh5.fh"
      integer :: dsetid, i
      character(len=1), allocatable :: typestring(:)
#endif

      If (refwfn_active) Then
        Call WarningMessage(2,'Active reference wavefunction file, '//
     &    'cannot create new PT2 wavefunction file, aborting!')
        Call AbEnd
      End If

#ifdef _HDF5_
      If (create_h5) Then
        pt2wfn_is_h5 = .True.

      !> create a new wavefunction file!
        pt2wfn_id = mh5_create_file('NEVPT2WFN')

      !> set module type
        call mh5_init_attr (pt2wfn_id,'MOLCAS_MODULE', 'NEVPT2')

      !> copy basic molecular information to the HDF5 file
        call run2h5_molinfo(pt2wfn_id)
        call one2h5_ovlmat(pt2wfn_id, nsym, nbas)
        call one2h5_fckint(pt2wfn_id, nsym, nbas)
        call one2h5_crtmom(pt2wfn_id, nsym, nbas)

      !> set wavefunction type
        call mh5_init_attr (pt2wfn_id,'CI_TYPE', 'CAS')

      !> general wavefunction attributes
        call mh5_init_attr (pt2wfn_id,'SPINMULT', nSpin)
        call mh5_init_attr (pt2wfn_id,'LSYM', lSym)
        call mh5_init_attr (pt2wfn_id,'NACTEL', nr_active_electrons)
        call mh5_init_attr (pt2wfn_id,'NHOLE1', 0)
        call mh5_init_attr (pt2wfn_id,'NELEC3', 0)
        call mh5_init_attr (pt2wfn_id,'NCONF',  1)
        call mh5_init_attr (pt2wfn_id,'NSTATES', nr_states)

      !> keep it for compatibility
        call mh5_init_attr (pt2wfn_id,'L2ACT', 1, [MXLEV], L2ACT)
        call mh5_init_attr (pt2wfn_id,'A2LEV', 1, [MXLEV], LEVEL)

      !> molecular orbital type index
        call mma_allocate(typestring, nbast)
        call orb2tpstr(NSYM,NBAS,
     $        NFRO,NISH,NRAS1,NRAS2,NRAS3,NSSH,NDEL,
     $        typestring)
        dsetid = mh5_create_dset_str(pt2wfn_id,
     $        'MO_TYPEINDICES', 1, [NBAST],1)
        call mh5_init_attr(dsetid, 'description',
     $        'Type index of the molecular orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
        call mh5_put_dset(dsetid, typestring)
        call mma_deallocate(typestring)
        call mh5_close_dset(dsetid)

      !> roots
!       call mh5_init_attr (pt2wfn_id,
!    $        'STATE_ROOTID', 1, [nr_states], MultGroup%state)

      !> setup dummy root to state translation
        root2state = 0
        do i=1,nr_states
          root2state(i)=i
        end do

        call mh5_init_attr (pt2wfn_id,
     $        'STATE_ROOTID', 1, [nr_states], root2state)

      !> setup dummy root to state translation - part 2 -
        root2state = 0
        do i=1,nr_states
          root2state(i) = MultGroup%state(i)
        end do

        call mh5_init_attr (pt2wfn_id,
     $        'ROOT2STATE', 1, [nr_states], ROOT2STATE)

      !> reference energy (for each state)
        pt2wfn_refene = mh5_create_dset_real (pt2wfn_id,
     $        'STATE_REFWF_ENERGIES', 1, [nr_states])
        call mh5_init_attr(pt2wfn_refene, 'description',
     $        'Reference energy for each state, '//
     $        'arranged as array of [nr_states]')

      !> PT2 energy (SC for each state)
      pt2wfn_energy_sc = mh5_create_dset_real (pt2wfn_id,
     $      'STATE_PT2_ENERGIES_SC', 1, [nr_states])
      call mh5_init_attr(pt2wfn_energy_sc, 'description',
     $      'PT2 energy (SC) for each state, '//
     $      'arranged as array of [nr_states]')
      !> effective Hamiltonian (SC)
        pt2wfn_heff_sc = mh5_create_dset_real(pt2wfn_id,
     &        'H_EFF_SC', 2, [nr_states, nr_states])
        call mh5_init_attr(pt2wfn_heff_sc, 'description',
     &        'Effective QD-NEVPT2 hamiltonian (SC), '//
     &        'arranged as matrix of size [nr_states,nr_states]')

      !> molecular orbital coefficients
        pt2wfn_mocoef = mh5_create_dset_real(pt2wfn_id,
     $        'MO_VECTORS', 1, [NBSQT])
        call mh5_init_attr(pt2wfn_mocoef, 'description',
     $        'Coefficients of the average orbitals, '//
     $        'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')

      if(.not.no_pc)then
        !> PT2 energy (PC for each state) - default
        pt2wfn_energy_pc = mh5_create_dset_real (pt2wfn_id,
     $        'STATE_PT2_ENERGIES', 1, [nr_states])
        call mh5_init_attr(pt2wfn_energy_pc, 'description',
     $        'PT2 energy (PC) for each state, '//
     $        'arranged as array of [nr_states]')
        !> effective Hamiltonian (PC) - default
        pt2wfn_heff_pc = mh5_create_dset_real(pt2wfn_id,
     &        'H_EFF', 2, [nr_states, nr_states])
        call mh5_init_attr(pt2wfn_heff_pc, 'description',
     &        'Effective QD-NEVPT2 hamiltonian (PC), '//
     &        'arranged as matrix of size [nr_states,nr_states]')

      end if

#ifdef _DMRG_
        !> maximum allowed filename length is equal to MH5_MAX_LBL_LEN=256
        pt2wfn_ref_checkpoint = mh5_create_dset_str(pt2wfn_id,
     $        'QCMAQUIS_CHECKPOINT', 1, [nr_states], 256)
        call mh5_init_attr(pt2wfn_ref_checkpoint,'description',
     $        'QCMaquis checkpoint directory names for each root'//
     $        ' in [nr_states].')
#endif
      Else
#endif
        pt2wfn_is_h5 = .False.
#ifdef _HDF5_
      End If
#endif
      end subroutine

      subroutine nevpt2wfn_data
#ifdef _DMRG_
      use qcmaquis_info
#endif
      use refwfn
      use nevpt2_cfg, only : MultGroup
      implicit none
#include "rasdim.fh"
#include "caspt2.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
#  include "mh5.fh"
      real*8, allocatable :: BUF(:)
      integer :: IDISK
#ifdef _DMRG_
      integer :: i
#endif

      If (pt2wfn_is_h5) Then
        call mma_allocate(BUF,NCMO)
        IDISK = 0
        CALL DDAFILE(LUONEM,2,BUF,NCMO,IDISK)
        call mh5_put_dset_array_real(pt2wfn_mocoef,BUF)
        call mma_deallocate(BUF)
#ifdef _DMRG_
        if(allocated(qcm_group_names))then
          do i = 1, size(MultGroup%State)
            call mh5_put_dset_array_str(
     &           pt2wfn_ref_checkpoint,
     &           qcm_group_names(1)%states(MultGroup%State(i)),
     &           [1],
     &           [i-1]
     &          )
          end do
        end if
#endif

      End If
#endif
      end subroutine

      subroutine nevpt2wfn_estore()
      use refwfn
      use nevpt2_cfg
      use info_state_energy  ! energies + effective Hamiltonian
      implicit none
#ifdef _HDF5_
#  include "mh5.fh"

      If (pt2wfn_is_h5) Then
        !> reference energies aka DMRG-SCF energies
        call mh5_put_dset_array_real(pt2wfn_refene, e)
        call mh5_put_dset_array_real(pt2wfn_energy_sc, psimp)
        !> effective Hamiltonian
        call mh5_put_dset_array_real(pt2wfn_heff_sc,e2mp)
        if(.not.no_pc)then
          !> single-state PC energies
          call mh5_put_dset_array_real(pt2wfn_energy_pc, psien)
          !> effective PC Hamiltonian
          call mh5_put_dset_array_real(pt2wfn_heff_pc,e2en)
        end if
      End If
#endif
      end subroutine nevpt2wfn_estore

      subroutine nevpt2wfn_close
#ifdef _DMRG_
      use qcmaquis_info
#endif
      implicit none
#ifdef _HDF5_
      if (pt2wfn_is_h5) then
        call mh5_close_file(pt2wfn_id)
        pt2wfn_is_h5 = .False.
        pt2wfn_id    = -1
#ifdef _DMRG_
        call qcmaquis_info_deinit
#endif

      end if
#endif
      end subroutine

      end module nevpt2wfn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MODOP(OP1,NOP2,OP2,NOP3,OP3)
      use definitions, only: iwp, wp
      use caspt2_module, only: NASHT, NACTEL
      IMPLICIT None

      integer(kind=iwp), intent(in):: NOP2, NOP3
      real(kind=wp), intent(inout):: OP1(NASHT,NASHT),OP2(NOP2)
      real(kind=wp), intent(in):: OP3(NOP3)

      integer(kind=iwp) I,J,K,L,IJ,KL,M,N,MN,IJKLMN,IL,IN,KN,IND,IJKL
      real(kind=wp) X
C Purpose: Modify the coefficients in OP1 and OP2, using the
C input values of OP2 and OP3, so that the operators can be
C calculated using products of elementary excitation
C operators rather than normal-ordered products.


      IF (NACTEL>2) THEN

      DO I=1,NASHT
       DO J=1,NASHT
        IJ=I+NASHT*(J-1)
        DO K=1,NASHT
         DO L=1,NASHT
          KL=K+NASHT*(L-1)
          IF(KL.GT.IJ) CYCLE

          DO M=1,NASHT
           DO N=1,NASHT
            MN=M+NASHT*(N-1)
            IF(MN.GT.KL) CYCLE
            IJKLMN=((IJ+1)*IJ*(IJ-1))/6+(KL*(KL-1))/2+MN
            X=OP3(IJKLMN)
            IF(ABS(X).LT.1.0D-15) CYCLE

            IF(K.EQ.J) THEN
              IL=I+NASHT*(L-1)
              IF(IL.GE.MN) THEN
                IND=(IL*(IL-1))/2+MN
              ELSE
                IND=(MN*(MN-1))/2+IL
              END IF
              OP2(IND)=OP2(IND)-X
              IF(M.EQ.L) THEN
                OP1(I,N)=OP1(I,N)-X
              END IF
            END IF

            IF(M.EQ.J) THEN
              IN=I+NASHT*(N-1)
              IF(IN.GE.KL) THEN
                IND=(IN*(IN-1))/2+KL
              ELSE
                IND=(KL*(KL-1))/2+IN
              END IF
              OP2(IND)=OP2(IND)-X
            END IF

            IF(M.EQ.L) THEN
              KN=K+NASHT*(N-1)
              IF(KN.GE.IJ) THEN
                IND=(KN*(KN-1))/2+IJ
              ELSE
                IND=(IJ*(IJ-1))/2+KN
              END IF
              OP2(IND)=OP2(IND)-X
            END IF

           END DO
          END DO

         END DO
        END DO
       END DO
      END DO

      END IF

      IF(NACTEL>1) THEN

      DO I=1,NASHT
       DO J=1,NASHT
        IJ=I+NASHT*(J-1)
        DO K=1,NASHT
         DO L=1,NASHT
          KL=K+NASHT*(L-1)
          IF(KL.GT.IJ) CYCLE

          IF(J.EQ.K) THEN
            IJKL=(IJ*(IJ-1))/2+KL
            OP1(I,L)=OP1(I,L)-OP2(IJKL)
          END IF

         END DO
        END DO
       END DO
      END DO

      END IF

      END SUBROUTINE MODOP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2007, Roland Lindh                                *
!***********************************************************************

subroutine PGet1_RI3(PAO,ijkl,nPAO,iCmp,iAO,iAOst,jBas,kBas,lBas,kOp,DSO,DSO_Var,nDSO,ExFac,CoulFac,PMax,V_K,U_K,mV_k,ZpK,nnP1, &
                     nSA,nAct)
!***********************************************************************
!  Object: to assemble the 2nd order density matrix of a SCF wave      *
!          function from the 1st order density.                        *
!                                                                      *
!          The indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             January '92.                                             *
!                                                                      *
!             Modified for 3-center RI gradients, March 2007           *
!***********************************************************************

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use Basis_Info, only: nBas
use SOAO_Info, only: iAOtSO
use pso_stuff, only: AOrb, lPSO, lSA, Thpkl
use Data_Structures, only: V1
use RI_glob, only: BklK, BMP2, CijK, CilK, CMOi, iAdrCVec, iMP2prpt, LuBVector, LuCVector, nChOrb, nIJR, nKdens, nYmnij, tbvec, &
                   Yij, Ymnij
#ifdef _DEBUGPRINT_
use RI_glob, only: iOff_Ymnij
#endif
use Constants, only: Zero, One, Two, Half, Quart
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: ijkl, nPAO, iCmp(4), iAO(4), iAOst(4), jBas, kBas, lBas, kOp(4), nDSO, mV_k, nnP1, nSA, nAct(0:7)
real(kind=wp), intent(out) :: PAO(ijkl,nPAO), PMax
real(kind=wp), intent(in) :: DSO(nDSO,nSA), DSO_Var(nDSO), ExFac, CoulFac, V_k(mV_k,nSA), U_k(mV_k), ZpK(nnP1,mV_K,*)
integer(kind=iwp) :: i, i2, i3, i4, iAdr, ij, ijBas, ijk, ik, ik1, ik2, il, il1, il2, ileft, imo, iMO1, iMO2, iMOleft, iMOright, &
                     indexB, Indkl, iOff1, iPAO, irc, iright, iSO, iThpkl, iUHF, iVec, iVec_, j, jAOj, jC, jik, jmo, jSkip(4), &
                     jSO, jSO_off, jSOj, jSym, k, kAct, kAOk, kmo, kSO, kSOk, kSym, lAct, lAOl, lBVec, lCVec, lda, lda1, lda2, &
                     lSO, lSOl, lSym, n2J, nijkl, nik, nj(4), nj2, njk, nk, nKBas, nLBas, nnk, NumOrb(4)
real(kind=wp) :: Cpu, Cpu1, Cpu2, ExFac_, Fac, fact, Factor, temp, tmp, Wall, Wall1, Wall2
logical(kind=iwp) :: Found
real(kind=wp), pointer :: Xki(:), Xli(:)
type(V1) :: Xki2(2), Xki3(2), Xli2(2), Xli3(2)
real(kind=wp), external :: Compute_B
real(kind=r8), external :: dDot_

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
iComp = 1
call PrMtrx('DSO     ',[iD0Lbl],iComp,1,D0)
write(u6,*)
write(u6,*) 'Distribution of Ymnij'
iSym = 1
if (nYmnij(iSym,1) > 0) then
  write(u6,*) 'iSym=',iSym
  do i=iOff_Ymnij(iSym,1)+1,iOff_Ymnij(iSym,1)+nYmnij(iSym,1)
    write(u6,*) 'Ymnij=',Ymnij(1)%A(i)
  end do
end if
write(u6,*) 'jbas,kbas,lbas=',jBas,kBas,lBas
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! DeSymP will compensate for degeneracy due to permutational
! symmetry. We will have to compensate for that here!

call CWTime(Cpu1,Wall1)

iOff1 = nBas(0)
Fac = Quart
PMax = Zero
iPAO = 0

jSym = 1
kSym = 1
lSym = Mul(jSym,kSym)
NumOrb(1) = nChOrb(kSym-1,1)

call Qpg_iScalar('SCF mode',Found)
if (Found) then
  call Get_iScalar('SCF mode',iUHF) ! either 0 or 1
else
  iUHF = 0
end if

! Test if we have any exchange contribution of significance

ExFac_ = ExFac
if (ExFac_ /= 0) then

  ! Pick up the number of MOs which passed the threshold test.

  nj2 = 0
  do iSO=1,nKdens
    jSkip(iSO) = 0
    nj(iSO) = nYmnij(jSym,iSO)
    NumOrb(iSO) = nChOrb(kSym-1,iSO)

    ! If all included skip presceening.

    ! trick for skipping unnecessary overhead
    if (-nj(iSO) == NumOrb(iSO)) then
      jSkip(iSO) = 1
      nj(iSO) = NumOrb(iSO)
    end if

    ! If all excluded process only for Coulombic contributions.

    nj2 = nj2+nj(iSO)
  end do
  if ((nj2 == 0) .and. (.not. lPSO)) ExFac_ = Zero
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if ((ExFac_ /= Zero) .and. (NumOrb(1) > 0) .and. (iMP2prpt /= 2) .and. (.not. lPSO) .and. (iUHF == 0)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! HF and Hybrid DFT

  ! number of functions in the kS and lS shell

  nKBas = kBas*iCmp(3)
  nLBas = lBas*iCmp(4)

  kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
  lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)

  ! Pointers to the full list of the X_mu,i elements.

  lda = size(CMOi(1)%SB(1)%A2,1)
  ik = 1+lda*(kSO-1)
  il = 1+lda*(lSO-1)
  Xki(1:) => CMOi(1)%SB(1)%A1(ik:)
  Xli(1:) => CMOi(1)%SB(1)%A1(il:)

  ! Collect the X_mu,i which survived the prescreening.
  ! Replace the pointers above, i.e. Xki, Xli.

  if ((nj(1) <= NumOrb(1)) .and. (jSkip(1) == 0)) then

    ! Note that the X_mu,i are stored as X_i,mu!

    imo = 1
    do k=1,nj(1)
      kmo = Ymnij(1)%A(k) ! CD-MO index

      ! Pick up X_mu,i for all mu's that belong to shell k

      call dcopy_(nKBas,Xki(kmo:),NumOrb(1),Yij(imo,1,1),nj(1))

      ! Pick up X_mu,i for all mu's that belong to shell l

      call dcopy_(nLBas,Xli(kmo:),NumOrb(1),Yij(imo,2,1),nj(1))

      imo = imo+1
    end do
    ! Reset pointers!
    Xki(1:nj(1)*nKBas) => Yij(1:nj(1)*nKBas,1,1)
    Xli(1:nj(1)*nLBas) => Yij(1:nj(1)*nLBas,2,1)
  else if (nj(1) > NumOrb(1)) then
    call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
    call Abend()
  end if

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
    jSO_off = jSO-iOff1

    ! Read a block of C_kl^J

    lCVec = nIJR(kSym,lSym,1)*jBas ! Block size
    iAdr = nIJR(kSym,lSym,1)*(jSO_off-1)+iAdrCVec(jSym,kSym,1)
    call dDaFile(LuCVector(jSym,1),2,CijK,lCVec,iAdr)

    ! Extract only those C_kl^Js for which we deem k and l to
    ! belong to the shell-pair and to be of significance.

    if ((nj(1) <= NumOrb(1)) .and. (jSkip(1) == 0)) then
      ij = 1
      do j=1,nj(1)
        jmo = Ymnij(1)%A(j)
        do i=1,nj(1)
          imo = Ymnij(1)%A(i)
          jC = imo+NumOrb(1)*(jmo-1)
          call dcopy_(jBas,CijK(jC),NumOrb(1)**2,CilK(ij),nj(1)**2)
          ij = ij+1
        end do
      end do
      n2j = nj(1)**2*jBas
      CijK(1:n2j) = CilK(1:n2j)
    end if

    ! Transform according to Eq. 16 (step 4) and generate B_kl^J

    ! E(jK,m) = Sum_i C(i,jK)' * X(i,m)

    call dGEMM_('T','N',nj(1)*jBas,nKBas,nj(1),One,CijK,nj(1),Xki,nj(1),Zero,CilK,nj(1)*jBas)

    ! B(Km,n) = Sum_j E(j,Km)' * X(j,n)

    call dGEMM_('T','N',jBas*nKBas,nLBas,nj(1),One,CilK,nj(1),Xli,nj(1),Zero,BklK,jBas*nKBas)

    do i3=1,iCmp(3)
      kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
      do i4=1,iCmp(4)
        lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

        iPAO = iPAO+1
        nijkl = 0

        do lAOl=0,lBas-1
          lSOl = lSO+lAOl
          do kAOk=0,kBas-1
            kSOk = kSO+kAOk

            indexB = (kAOk+(i3-1)*kBas)*jBas+(lAOl+(i4-1)*lBas)*nKBas*jBas
            Indkl = iTri(kSOk,lSOl)

            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-iOff1
              nijkl = nijkl+1
              indexB = indexB+1

              ! Coulomb contribution: V_k(j)*D(kl)

              temp = CoulFac*V_k(jSOj,1)*DSO(Indkl,1)

              ! Exchange contribution: B(K,m,n)

              temp = temp-ExFac_*Half*BklK(indexB)

              PMax = max(PMax,abs(temp))
              PAO(nijkl,iPAO) = Fac*temp
            end do
          end do
        end do
      end do
    end do
  end do
  nullify(Xki,Xli)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((ExFac_ /= Zero) .and. (NumOrb(1) > 0) .and. (iMP2prpt /= 2) .and. (.not. lPSO) .and. (iUHF == 1)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! UHF and Hybrid UDFT

  ! number of functions in the kS and lS shell

  nKBas = kBas*iCmp(3)
  nLBas = lBas*iCmp(4)

  kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
  lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)

  ! Pointers to the full list of the X_mu,i elements.

  do iSO=1,2
    if (nIJR(kSym,lSym,iSO) /= 0) then

      lda = size(CMOi(iSO)%SB(1)%A2,1)
      ik = 1+lda*(kSO-1)
      il = 1+lda*(lSO-1)
      Xki2(iSO)%A(1:) => CMOi(iSO)%SB(1)%A1(ik:)
      Xli2(iSO)%A(1:) => CMOi(iSO)%SB(1)%A1(il:)

      ! Collect the X_mu,i which survived the prescreening.
      ! Replace the pointers above, i.e. Xki, Xli.

      if ((nj(iSO) <= NumOrb(iSO)) .and. (jSkip(iSO) == 0)) then

        ! Note that the X_mu,i are stored as X_i,mu!

        imo = 1
        do k=1,nj(iSO)
          kmo = Ymnij(iSO)%A(k) ! CD-MO index

          ! Pick up X_mu,i for all mu's that belong to shell k

          call dcopy_(nKBas,Xki2(iSO)%A(kmo:),NumOrb(iSO),Yij(imo,1,iSO),nj(iSO))

          ! Pick up X_mu,i for all mu's that belong to shell l

          call dcopy_(nLBas,Xli2(iSO)%A(kmo:),NumOrb(iSO),Yij(imo,2,iSO),nj(iSO))

          imo = imo+1
        end do
        ! Reset pointers!
        Xki2(iSO)%A(1:nj(iSO)*nKBas) => Yij(1:nj(iSO)*nKBas,1,iSO)
        Xli2(iSO)%A(1:nj(iSO)*nLBas) => Yij(1:nj(iSO)*nLBas,2,iSO)
      else if (nj(iSO) > NumOrb(iSO)) then
        call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
        call Abend()
      end if
    end if
  end do

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
    jSO_off = jSO-iOff1

    Factor = Zero

    do iSO=1,2
      if ((nIJR(kSym,lSym,iSO) /= 0) .and. (nj(iSO) /= 0)) then

        ! Read a block of C_kl^J

        lCVec = nIJR(kSym,lSym,iSO)*jBas ! Block size
        iAdr = nIJR(kSym,lSym,iSO)*(jSO_off-1)+iAdrCVec(jSym,kSym,iSO)
        call dDaFile(LuCVector(jSym,iSO),2,CijK,lCVec,iAdr)

        ! Extract only those C_kl^Js for which we deem k and l to
        ! belong to the shell-pair and to be of significance.

        if ((nj(iSO) <= NumOrb(iSO)) .and. (jSkip(iSO) == 0)) then
          ij = 1
          do j=1,nj(iSO)
            jmo = Ymnij(iSO)%A(j)
            do i=1,nj(iSO)
              imo = Ymnij(iSO)%A(i)
              jC = imo+NumOrb(iSO)*(jmo-1)
              call dcopy_(jBas,CijK(jC),NumOrb(iSO)**2,Cilk(ij),nj(iSO)**2)
              ij = ij+1
            end do
          end do
          n2j = nj(iSO)**2*jBas
          CijK(1:n2j) = CilK(1:n2j)
        end if

        ! Transform according to Eq. 16 (step 4) and generate B_kl^J

        ! E(jK,m) = Sum_i C(i,jK)' * X(i,m)

        call dGEMM_('T','N',nj(iSO)*jBas,nKBas,nj(iSO),One,CijK,nj(iSO),Xki2(iSO)%A,nj(iSO),Zero,CilK,nj(iSO)*jBas)

        ! B(Km,n) = Sum_j E(j,Km)' * X(j,n)

        call dGEMM_('T','N',jBas*nKBas,nLBas,nj(iSO),One,CilK,nj(iSO),Xli2(iSO)%A,nj(iSO),Factor,BklK,jBas*nKBas)
        Factor = One
      end if
    end do

    do i3=1,iCmp(3)
      kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
      do i4=1,iCmp(4)
        lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

        iPAO = iPAO+1
        nijkl = 0

        do lAOl=0,lBas-1
          lSOl = lSO+lAOl
          do kAOk=0,kBas-1
            kSOk = kSO+kAOk

            indexB = (kAOk+(i3-1)*kBas)*jBas+(lAOl+(i4-1)*lBas)*nKBas*jBas
            Indkl = iTri(kSOk,lSOl)

            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-iOff1
              nijkl = nijkl+1
              indexB = indexB+1

              ! Coulomb contribution: V_k(j)*D(kl)

              temp = CoulFac*V_k(jSOj,1)*DSO(Indkl,1)

              ! Exchange contribution: B(K,m,n)

              temp = temp-ExFac_*BklK(indexB)

              PMax = max(PMax,abs(temp))
              PAO(nijkl,iPAO) = Fac*temp
            end do
          end do
        end do
      end do
    end do
  end do
  do iSO=1,2
    nullify(Xki2(iSO)%A,Xli2(iSO)%A)
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((ExFac_ /= Zero) .and. (NumOrb(1) > 0) .and. (iMP2prpt /= 2) .and. lPSO .and. (.not. LSA)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! CASSCF case

  ! number of functions in the kS and lS shell

  nKBas = kBas*iCmp(3)
  nLBas = lBas*iCmp(4)

  kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
  lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)

  ! Pointers to the full list of the X_mu,i elements.

  lda = size(CMOi(1)%SB(1)%A2,1)
  ik = 1+lda*(kSO-1)
  il = 1+lda*(lSO-1)
  Xki(1:) => CMOi(1)%SB(1)%A1(ik:)
  Xli(1:) => CMOi(1)%SB(1)%A1(il:)

  ! Collect the X_mu,i which survived the prescreening.
  ! Replace the pointers above, i.e. Xki, Xli.

  if ((nj(1) <= NumOrb(1)) .and. (jSkip(1) == 0) .and. (nj(1) /= 0)) then

    ! Note that the X_mu,i are stored as X_i,mu!

    imo = 1
    do k=1,nj(1)
      kmo = Ymnij(1)%A(k)

      ! Pick up X_mu,i for all mu's that belong to shell k

      call dcopy_(nKBas,Xki(kmo:),NumOrb(1),Yij(imo,1,1),nj(1))

      ! Pick up X_mu,i for all mu's that belong to shell l

      call dcopy_(nLBas,Xli(kmo:),NumOrb(1),Yij(imo,2,1),nj(1))

      imo = imo+1
    end do
    ! Reset pointers!
    Xki(1:nj(1)*nKBas) => Yij(1:nj(1)*nKBas,1,1)
    Xli(1:nj(1)*nLBas) => Yij(1:nj(1)*nLBas,2,1)
  else if (nj(1) > NumOrb(1)) then
    call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
    call Abend()
  end if

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
    jSO_off = jSO-iOff1

    ! Read a block of C_kl^J

    lCVec = nIJR(kSym,lSym,1)*jBas ! Block size
    iAdr = nIJR(kSym,lSym,1)*(jSO_off-1)+iAdrCVec(jSym,kSym,1)
    call dDaFile(LuCVector(jSym,1),2,CijK,lCVec,iAdr)

    ! Extract only those C_kl^Js for which we deem k and l to
    ! belong to the shell-pair and to be of significance.

    if (nj(1) /= 0) then
      if ((nj(1) <= NumOrb(1)) .and. (jSkip(1) == 0)) then
        ij = 1
        do j=1,nj(1)
          jmo = Ymnij(1)%A(j)
          do i=1,nj(1)
            imo = Ymnij(1)%A(i)
            jC = imo+NumOrb(1)*(jmo-1)
            call dcopy_(jBas,CijK(jC),NumOrb(1)**2,CilK(ij),nj(1)**2)
            ij = ij+1
          end do
        end do
        n2j = nj(1)**2*jBas
        CijK(1:n2j) = CilK(1:n2j)
      end if

      ! Transform according to Eq. 16 (step 4) and generate B_kl^J

      ! E(jK,m) = Sum_i C(i,jK)' * X(i,m)

      call dGEMM_('T','N',nj(1)*jBas,nKBas,nj(1),One,CijK,nj(1),Xki,nj(1),Zero,CilK,nj(1)*jBas)

      ! B(Km,n) = Sum_j E(j,Km)' * X(j,n)

      call dGEMM_('T','N',jBas*nKBas,nLBas,nj(1),One,CilK,nj(1),Xli,nj(1),Zero,BklK,jBas*nKBas)

    else
      BklK(1:jBas*nKBas*nLBas) = Zero
    end if

    ! Active term

    do jAOj=0,jBas-1
      jSOj = jSO_off+jAOj
      do i4=1,iCmp(4)
        lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
        do lAOl=0,lBas-1
          lSOl = lSO+lAOl
          do kAct=1,nAct(kSym-1)
            tmp = ddot_(kact,Zpk(iTri(kAct,1),jSOj,1),1,AOrb(1)%SB(1)%A2(:,lSOl),1)

            do lAct=kAct+1,nAct(lSym-1)
              tmp = tmp+Zpk(iTri(lAct,kAct),jSOj,1)*AOrb(1)%SB(1)%A2(lAct,lSOl)
            end do
            CilK(kAct) = tmp
          end do

          do i3=1,iCmp(3)
            kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
            iThpkl = jAOj+(i3-1)*kBas*jBas+(lAOl+(i4-1)*lBas)*nKBas*jBas+1
            lda = size(AOrb(1)%SB(1)%A2,1)
            ik = 1+lda*(kSO-1)
            call dGeMV_('T',nAct(kSym-1),kBas,One,AOrb(1)%SB(1)%A1(ik:),nAct(kSym-1),Cilk,1,Zero,Thpkl(iThpkl),jBas)
          end do
        end do
      end do
    end do

    do i3=1,iCmp(3)
      kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
      do i4=1,iCmp(4)
        lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

        iPAO = iPAO+1
        nijkl = 0

        do lAOl=0,lBas-1
          lSOl = lSO+lAOl
          do kAOk=0,kBas-1
            kSOk = kSO+kAOk

            iThpkl = (kAOk+(i3-1)*kBas)*jBas+(lAOl+(i4-1)*lBas)*nKBas*jBas
            indexB = iThpkl
            Indkl = iTri(kSOk,lSOl)

            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-iOff1
              nijkl = nijkl+1
              indexB = indexB+1
              iThpkl = iThpkl+1

              ! Coulomb contribution: V_k(j)*D(kl)

              temp = CoulFac*V_k(jSOj,1)*DSO(Indkl,1)

              ! Exchange contribution: B(K,m,n)

              temp = temp-ExFac_*Half*Bklk(indexB)

              ! Active space contribution: Sum_p Z(p,K)*Th(p,m,n)

              temp = temp+Thpkl(iThpkl)

              PMax = max(PMax,abs(temp))
              PAO(nijkl,iPAO) = Fac*temp
            end do
          end do
        end do
      end do
    end do
  end do
  nullify(Xki,Xli)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((ExFac_ /= Zero) .and. (iMP2prpt /= 2) .and. lPSO .and. lSA) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! SA-CASSCF case

  ! number of functions in the kS and lS shell

  nKBas = kBas*iCmp(3)
  nLBas = lBas*iCmp(4)

  kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
  lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)

  ! Pointers to the full list of the X_mu,i elements.

  do iSO=1,2
    if (nIJR(kSym,lSym,iSO) /= 0) then
      iMOleft = iSO
      iMOright = iSO+2

      lda1 = size(CMOi(iSO)%SB(1)%A2,1)
      lda2 = size(CMOi(iSO+2)%SB(1)%A2,1)
      ik1 = 1+lda1*(kSO-1)
      ik2 = 1+lda2*(kSO-1)
      il1 = 1+lda1*(lSO-1)
      il2 = 1+lda2*(lSO-1)

      Xki2(iSO)%A(1:) => CMOi(iSO+2)%SB(1)%A1(ik2:)
      Xki3(iSO)%A(1:) => CMOi(iSO)%SB(1)%A1(ik1:)
      Xli2(iSO)%A(1:) => CMOi(iSO)%SB(1)%A1(il1:)
      Xli3(iSO)%A(1:) => CMOi(iSO+2)%SB(1)%A1(il2:)

      ! Collect the X_mu,i which survived the prescreening.
      ! Replace the pointers above, i.e. Xki, Xli.

      if ((nj(iMOright) <= NumOrb(iMOright)) .and. (jSkip(iMOright) == 0)) then

        ! Note that the X_mu,i are stored as X_i,mu!

        imo = 1
        do k=1,nj(iMOright)
          kmo = Ymnij(iMOright)%A(k) ! CD-MO index

          ! Pick up X_mu,i for all mu's that belong to shell k

          call dcopy_(nKBas,Xki2(iSO)%A(kmo:),NumOrb(iMOright),Yij(imo,1,iMOright),nj(iMOright))

          call dcopy_(nLBas,Xli3(iSO)%A(kmo:),NumOrb(iMOright),Yij(imo,2,iMOright),nj(iMOright))

          imo = imo+1
        end do
        ! Reset pointers!
        nk = nj(iMOright)
        Xki2(iSO)%A(1:nk*nKBas) => Yij(1:nk*nKBas,1,iMOright)
        Xli3(iSO)%A(1:nk*nLBas) => Yij(1:nk*nLBas,2,iMOright)
      else if (nj(iMOright) > NumOrb(iMOright)) then
        call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
        call Abend()
      end if

      if ((nj(iMOleft) <= NumOrb(iMOleft)) .and. (jSkip(iMOleft) == 0)) then

        imo = 1
        do k=1,nj(iMOleft)
          kmo = Ymnij(iMOleft)%A(k) ! CD-MO index

          ! Pick up X_mu,i for all mu's that belong to shell l

          call dcopy_(nLBas,Xli2(iSO)%A(kmo:),NumOrb(iMOleft),Yij(imo,2,iMOleft),nj(iMOleft))

          call dcopy_(nKBas,Xki3(iSO)%A(kmo:),NumOrb(iMOleft),Yij(imo,1,iMOleft),nj(iMOleft))
          imo = imo+1
        end do
        nk = nj(iMOleft)
        Xli2(iSO)%A(1:nk*nLBas) => Yij(1:nk*nLBas,2,iMOleft)
        Xki3(iSO)%A(1:nk*nKBas) => Yij(1:nk*nKBas,1,iMOleft)
      else if (nj(iMOleft) > NumOrb(iMOleft)) then
        call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
        call Abend()
      end if
    end if
  end do

  do i2=1,iCmp(2)

    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
    jSO_off = jSO-iOff1

    Factor = Zero

    do iSO=1,2
      iMOleft = iSO
      iMOright = iSO+2
      if ((nIJR(kSym,lSym,iSO) /= 0) .and. (nj(iMOright) /= 0) .and. (nj(iMOleft) /= 0)) then

        ! Read a block of C_kl^J

        lCVec = nIJR(kSym,lSym,iSO)*jBas ! Block size
        iAdr = nIJR(kSym,lSym,iSO)*(jSO_off-1)+iAdrCVec(jSym,kSym,iSO)
        call dDaFile(LuCVector(jSym,iSO),2,CijK,lCVec,iAdr)

        ! Extract only those C_kl^Js for which we deem k and l to
        ! belong to the shell-pair and to be of significance.

        !MGD skipped jSkip() since not used and complicated in this case
        if ((nj(iMOright) <= NumOrb(iMOright)) .or. (nj(iMOleft) <= NumOrb(iMOleft))) then
          ij = 1
          do j=1,nj(iMOleft)
            jmo = Ymnij(iMOleft)%A(j)
            do i=1,nj(iMOright)
              imo = Ymnij(iMOright)%A(i)
              jC = imo+NumOrb(iMOright)*(jmo-1)
              call dcopy_(jBas,CijK(jC),NumOrb(iMOright)*NumOrb(iMOleft),CilK(ij),nj(iMOright)*nj(iMOleft))
              ij = ij+1
            end do
          end do
          n2j = nj(iMOright)*nj(iMOleft)*jBas
          CijK(1:n2j) = CilK(1:n2j)
        end if

        ! Transform according to Eq. 16 (step 4) and generate B_kl^J

        ! E(jK,m) = Sum_i C(i,jK)' * X(i,m)

        call dGEMM_('T','N',nj(iMOleft)*jBas,nKBas,nj(iMOright),One,CijK,nj(iMOright),Xki2(iSO)%A,nj(iMOright),Zero,CilK, &
                    nj(iMOleft)*jBas)

        ! B(Km,n) = Sum_j E(j,Km)' * X(j,n)

        call dGEMM_('T','N',jBas*nKBas,nLBas,nj(iMOleft),One,CilK,nj(iMOleft),Xli2(iSO)%A,nj(iMOleft),Factor,BklK,jBas*nKBas)
        Factor = One

        ! Add transpose

        ! Transpose Cijk->Cjik
        do ijBas=1,jBas
          nnk = nj(iMOleft)*nj(iMOright)*(ijBas-1)

          do ileft=1,nj(iMOleft)
            njk = nj(iMOright)*(ileft-1)+nnk

            do iright=1,nj(iMOright)
              nik = nj(iMOleft)*(iright-1)+nnk

              ijk = iright+njk
              jik = ileft+nik

              CilK(jik) = CijK(ijk)
            end do
          end do
        end do

        ! E(iK,m) = Sum_j C(j,iK)' * X(j,m)

        call dGEMM_('T','N',nj(iMOright)*jBas,nKBas,nj(iMOleft),One,CilK,nj(iMOleft),Xki3(iSO)%A,nj(iMOleft),Zero,CijK, &
                    nj(iMOright)*jBas)

        ! B(Km,n) = Sum_j E(i,Km)' * X(i,n)

        call dGEMM_('T','N',jBas*nKBas,nLBas,nj(iMOright),One,CijK,nj(iMOright),Xli3(iSO)%A,nj(iMOright),Factor,BklK,jBas*nKBas)
      end if
    end do

    ! Active term

    Thpkl(1:jBas*nKBas*nLBas) = Zero
    do iVec=1,4
      iMO1 = 1
      iMO2 = 1
      iVec_ = iVec
      fact = One
      if (iVec == 2) iMO2 = 2
      if (iVec == 3) fact = Two
      if (iVec == 4) then
        iMO1 = 2
        iVec_ = 2
      end if

      do jAOj=0,jBas-1
        jSOj = jSO_off+jAOj
        do i4=1,iCmp(4)
          lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
          do lAOl=0,lBas-1
            !lSOl = lSO+lAOl-1
            lSOl = lSO+lAOl
            do kAct=1,nAct(kSym-1)
              tmp = ddot_(kact,Zpk(iTri(kAct,1),jSOj,iVec_),1,AOrb(iMO1)%SB(1)%A2(:,lSOl),1)
              do lAct=kAct+1,nAct(lSym-1)
                tmp = tmp+Zpk(iTri(lAct,kAct),jSOj,iVec_)*AOrb(iMO1)%SB(1)%A2(lAct,lSOl)
              end do
              CilK(kAct) = tmp
            end do

            do i3=1,iCmp(3)
              kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
              iThpkl = jAOj+(i3-1)*kBas*jBas+(lAOl+(i4-1)*lBas)*nKBas*jBas+1
              lda = size(AOrb(iMO2)%SB(1)%A2,1)
              ik = 1+lda*(kSO-1)
              call dGeMV_('T',nAct(kSym-1),kBas,fact,AOrb(iMO2)%SB(1)%A1(ik:),nAct(kSym-1),Cilk,1,One,Thpkl(iThpkl),jBas)
            end do
          end do
        end do
      end do
    end do

    do i3=1,iCmp(3)
      kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
      do i4=1,iCmp(4)
        lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

        iPAO = iPAO+1
        nijkl = 0

        do lAOl=0,lBas-1
          lSOl = lSO+lAOl
          do kAOk=0,kBas-1
            kSOk = kSO+kAOk

            iThpkl = (kAOk+(i3-1)*kBas)*jBas+(lAOl+(i4-1)*lBas)*nKBas*jBas
            indexB = iThpkl
            Indkl = iTri(kSOk,lSOl)

            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-iOff1
              nijkl = nijkl+1
              indexB = indexB+1
              iThpkl = iThpkl+1

              ! SA-CASSCF Coulomb contribution

              temp = CoulFac*(V_k(jSOj,1)*DSO(Indkl,2)+V_k(jSOj,2)*DSO(Indkl,1)+V_k(jSOj,3)*DSO(Indkl,4)+V_k(jSOj,4)*DSO(Indkl,3)+ &
                              V_k(jSOj,1)*DSO(Indkl,5)+V_k(jSOj,5)*DSO(Indkl,1))

              ! Exchange contribution: B(K,m,n)

              temp = temp-Factor*ExFac_*Half*BklK(indexB)

              ! Active space contribution: Sum_p Z(p,K)*Th(p,m,n)

              temp = temp+Thpkl(iThpkl)

              PMax = max(PMax,abs(temp))
              PAO(nijkl,iPAO) = Fac*temp
            end do
          end do
        end do
      end do
    end do
  end do
  do iSO=1,2
    nullify(Xki2(iSO)%A,Xki3(iSO)%A,Xli2(iSO)%A,Xli3(iSO)%A)
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((ExFac_ /= Zero) .and. (NumOrb(1) > 0) .and. (iMP2prpt == 2)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! MP2 case

  nKBas = kBas*iCmp(3)
  nLBas = lBas*iCmp(4)

  kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
  lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)

  lda = size(CMOi(1)%SB(1)%A2,1)
  ik = 1+lda*(kSO-1)
  il = 1+lda*(lSO-1)
  Xki(1:) => CMOi(1)%SB(1)%A1(ik:)
  Xli(1:) => CMOi(1)%SB(1)%A1(il:)

  if ((nj(1) <= NumOrb(1)) .and. (jSkip(1) == 0)) then
    imo = 1
    do k=1,nj(1)
      kmo = Ymnij(1)%A(k)
      call dcopy_(nKBas,Xki(kmo:),NumOrb(1),Yij(imo,1,1),nj(1))
      call dcopy_(nLBas,Xli(kmo:),NumOrb(1),Yij(imo,2,1),nj(1))
      imo = imo+1
    end do
    Xki(1:nj(1)*nKBas) => Yij(1:nj(1)*nKBas,1,1)
    Xli(1:nj(1)*nLBas) => Yij(1:nj(1)*nLBas,2,1)
  else if (nj(1) > NumOrb(1)) then
    call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
    call Abend()
  end if

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
    jSO_off = jSO-iOff1

    lCVec = nIJR(kSym,lSym,1)*jBas
    iAdr = nIJR(kSym,lSym,1)*(jSO_off-1)+iAdrCVec(jSym,kSym,1)
    call dDaFile(LuCVector(jSym,1),2,CijK,lCVec,iAdr)

    if ((nj(1) <= NumOrb(1)) .and. (jSkip(1) == 0)) then
      ij = 1
      do j=1,nj(1)
        jmo = Ymnij(1)%A(j)
        do i=1,nj(1)
          imo = Ymnij(1)%A(i)
          jC = imo+NumOrb(1)*(jmo-1)
          call dcopy_(jBas,CijK(jC),NumOrb(1)**2,CilK(ij),nj(1)**2)
          ij = ij+1
        end do
      end do
      n2j = nj(1)**2*jBas
      CijK(1:n2j) = CilK(1:n2j)
    end if

    ! C(jK,m) = sum_i C(i,jK)' * X(i,m)

    call dGEMM_('T','N',nj(1)*jBas,nKBas,nj(1),One,CijK,nj(1),Xki,nj(1),Zero,CilK,nj(1)*jBas)

    ! B(Km,n) = sum_j C(j,Km)' * X(j,n)

    call dGEMM_('T','N',jBas*nKBas,nLBas,nj(1),One,CilK,nj(1),Xli,nj(1),Zero,BklK,jBas*nKBas)

    lBVec = nBas(0)*nBas(0)*jBas
    do i=1,2
      iAdr = 1+nBas(0)*nBas(0)*(jSO_off-1)
      call dDaFile(LuBVector(i),2,Bmp2(:,i),lBVec,iAdr)
    end do

    do i3=1,iCmp(3)
      kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
      do i4=1,iCmp(4)
        lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

        iPAO = iPAO+1
        nijkl = 0

        do lAOl=0,lBas-1
          lSOl = lSO+lAOl
          do kAOk=0,kBas-1
            kSOk = kSO+kAOk

            indexB = (kAOk+(i3-1)*kBas)*jBas+(lAOl+(i4-1)*lBas)*nKBas*jBas
            Indkl = iTri(kSOk,lSOl)

            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-iOff1
              nijkl = nijkl+1
              indexB = indexB+1

              ! Coulomb contribution: V_k(j)*D(kl)

              temp = CoulFac*(V_k(jSOj,1)*DSO(Indkl,1)+U_k(jSOj)*DSO(Indkl,1)+V_k(jSOj,1)*(DSO_Var(Indkl)-DSO(indkl,1))+ &
                              Compute_B(irc,kSOk,lSOl,jAOj,iOff1,2))

              ! Exchange contribution: B(K,m,n)

              temp = temp-ExFac_*Half*(BklK(indexB)+Compute_B(irc,kSOk,lSOl,jAOj,iOff1,1))
              !temp = temp-ExFac_*Half*Compute_B(irc,kSOk,lSOl,jAOj,iOff1,1)

              PMax = max(PMax,abs(temp))
              PAO(nijkl,iPAO) = Fac*temp
            end do
          end do
        end do
      end do
    end do
  end do
  nullify(Xki,Xli)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Pure DFT or case when no exhange

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
    do i3=1,iCmp(3)
      kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
      do i4=1,iCmp(4)
        lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

        iPAO = iPAO+1
        nijkl = 0

        do lAOl=0,lBas-1
          lSOl = lSO+lAOl
          do kAOk=0,kBas-1
            kSOk = kSO+kAOk

            Indkl = iTri(kSOk,lSOl)

            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-iOff1
              nijkl = nijkl+1

              ! Coulomb contribution: V_k(j)*D(kl)

              temp = CoulFac*V_k(jSOj,1)*DSO(Indkl,1)
              !temp = Zero

              PMax = max(PMax,abs(temp))
              PAO(nijkl,iPAO) = Fac*temp
            end do
          end do
        end do
      end do
    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *

if (iPAO /= nPAO) then
  write(u6,*) ' Error in PGet1_RI3!'
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt(' In PGet1_RI3:PAO ',' ',PAO,ijkl,nPAO)
do i=1,ijkl
  write(u6,*) DDot_(nPAO,PAO(i,1),ijkl,PAO(i,1),ijkl)
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(Cpu2,Wall2)
Cpu = Cpu2-Cpu1
Wall = Wall2-Wall1
tbvec(1) = tbvec(1)+Cpu
tbvec(2) = tbvec(2)+Wall

return

end subroutine PGet1_RI3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c  ********************************************************
c  ** Public-domain library routines used by casvb only. **
c  ********************************************************
c  **********************
c  ** EISPACK ROUTINES **
c  **********************
      subroutine balanc(nm,n,a,low,igh,scale)
c
      integer i,j,k,l,m,n,nm,igh,low,iexc
      real*8 a(nm,n),scale(n)
      real*8 c,f,g,r,s,b2,radix
      logical noconv
c
c     this subroutine is a translation of the algol procedure balance,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine balances a real matrix and isolates
c     eigenvalues whenever possible.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the input matrix to be balanced.
c
c     on output
c
c        a contains the balanced matrix.
c
c        low and igh are two integers such that a(i,j)
c          is equal to zero if
c           (1) i is greater than j and
c           (2) j=1,...,low-1 or i=igh+1,...,n.
c
c        scale contains information determining the
c           permutations and scaling factors used.
c
c     suppose that the principal submatrix in rows low through igh
c     has been balanced, that p(j) denotes the index interchanged
c     with j during the permutation step, and that the elements
c     of the diagonal matrix used are denoted by d(i,j).  then
c        scale(j) = p(j),    for j = 1,...,low-1
c                 = d(j,j),      j = low,...,igh
c                 = p(j)         j = igh+1,...,n.
c     the order in which the interchanges are made is n to igh+1,
c     then 1 to low-1.
c
c     note that 1 is returned for igh if igh is zero formally.
c
c     the algol procedure exc contained in balance appears in
c     balanc  in line.  (note that the algol roles of identifiers
c     k,l have been reversed.)
c
c     Questions and comments should be directed to Alan K. Cline,
c     Pleasant Valley Software, 8603 Altus Cove, Austin, TX 78759.
c     Electronic mail to cline@cs.utexas.edu.
c
c     this version dated january 1989. (for the IBM 3090vf)
c
c     ------------------------------------------------------------------
c
      radix = 16.0d0
c
      b2 = radix * radix
      k = 1
      l = n
      go to 100
c     .......... in-line procedure for row and
c                column exchange ..........
   20 scale(m) = j
      if (j .eq. m) go to 50
c
      do 30 i = 1, l
         f = a(i,j)
         a(i,j) = a(i,m)
         a(i,m) = f
   30 continue
c
      do 40 i = k, n
         f = a(j,i)
         a(j,i) = a(m,i)
         a(m,i) = f
   40 continue
c
   50 go to (80,130), iexc
c     .......... search for rows isolating an eigenvalue
c                and push them down ..........
   80 if (l .eq. 1) go to 280
      l = l - 1
c     .......... for j=l step -1 until 1 do -- ..........
  100 do 120 j = l, 1, -1
c
         do 110 i = 1, l
            if (i .eq. j) go to 110
            if (a(j,i) .ne. 0.0d0) go to 120
  110    continue
c
         m = l
         iexc = 1
         go to 20
  120 continue
c
      go to 140
c     .......... search for columns isolating an eigenvalue
c                and push them left ..........
  130 k = k + 1
c
  140 do 170 j = k, l
c
         do 150 i = k, l
            if (i .eq. j) go to 150
            if (a(i,j) .ne. 0.0d0) go to 170
  150    continue
c
         m = k
         iexc = 2
         go to 20
  170 continue
c     .......... now balance the submatrix in rows k to l ..........
      do 180 i = k, l
      scale(i) = 1.0d0
  180 continue
c     .......... iterative loop for norm reduction ..........
  190 noconv = .false.
c
      do 270 i = k, l
         c = 0.0d0
         r = 0.0d0
c
         do 200 j = k, l
            if (j .eq. i) go to 200
            c = c + abs(a(j,i))
            r = r + abs(a(i,j))
  200    continue
c     .......... guard against zero c or r due to underflow ..........
         if (c .eq. 0.0d0 .or. r .eq. 0.0d0) go to 270
         g = r / radix
         f = 1.0d0
         s = c + r
  210    if (c .ge. g) go to 220
         f = f * radix
         c = c * b2
         go to 210
  220    g = r * radix
  230    if (c .lt. g) go to 240
         f = f / radix
         c = c / b2
         go to 230
c     .......... now balance ..........
  240    if ((c + r) / f .ge. 0.95d0 * s) go to 270
         g = 1.0d0 / f
         scale(i) = scale(i) * f
         noconv = .true.
c
         do 250 j = k, n
         a(i,j) = a(i,j) * g
  250    continue
c
         do 260 j = 1, l
         a(j,i) = a(j,i) * f
  260    continue
c
  270 continue
c
      if (noconv) go to 190
c
  280 low = k
      igh = l
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Rotate_Dipole(rMP, EC, nij, nElem, nPert, ij, ii, jj,
     &                         Dipole_Rot_A,Dipole_Rot_B,Dipole_Rot_AB,
     &                         R_A,R_B)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 rMP(nij,0:nElem-1,0:nPert-1), EC(3,nij), E_Bond(3)
      Real*8 T(3,3), R_test(3), R_Q(3,3), Tmp(3,3),
     &       rMu_AB(3), rMu_A(3), rMu_B(3)
*
* The three dipole components for the bond
c      Print *,'Test 0'
c      Call xFlush(6)
      x_my=rMP(ij,1,0)
      y_my=rMP(ij,2,0)
      z_my=rMP(ij,3,0)
* Vector from ii to jj.
      x_R =   EC(1,ii) - EC(1,jj)
      y_R =   EC(2,ii) - EC(2,jj)
      z_R =   EC(3,ii) - EC(3,jj)
      T_R =Sqrt(x_R**2+y_R**2+z_R**2)
C??      Write (6,*) 'My=',x_my,y_my,z_my
C??      Write (6,*) 'R=',x_R,y_R,z_R
* Unit vector in the direction from ii to jj
      E_Bond(1)=x_r/T_R
      E_Bond(2)=y_r/T_R
      E_Bond(3)=z_r/T_R
* Get transformation matrix (T) that rotates the coordinate system to align with the bond
      Call GS(E_bond,1,T,3,.True.,.False.)
      Call RecPrt('T-matrix',' ',T,3,3)
*
      Call RecPrt('EC(*,ij) origional',' ',EC(1,ij),1,3)
      Call RecPrt('EC(*,ii) origional',' ',EC(1,ii),1,3)
      Call RecPrt('EC(*,jj) origional',' ',EC(1,jj),1,3)
* Rotate EC(1,ij) to the new coordinate system
      Call DGEMM_('T','N',
     &            3,1,3,
     &            1.0d0,T,3,
     &            EC(1,ij),3,
     &            0.0d0,R_test,3)
      Call RecPrt('EC(Bond system)',' ',R_Test,1,3)
*
* Rotate the dipole moment for the bond and ii and jj to the new coordinate system
      tmp(1,1)=rMP(ij,1,0)
      tmp(2,1)=rMP(ij,2,0)
      tmp(3,1)=rMP(ij,3,0)
      Call DGEMM_('T','N',
     &            3,1,3,
     &            1.0d0,T,3,
     &            tmp,nij,
     &            0.0d0,rMu_AB,3)
      Call RecPrt('rMu_AB',' ',rMu_AB,1,3)
      tmp(1,1)=rMP(ii,1,0)
      tmp(2,1)=rMP(ii,2,0)
      tmp(3,1)=rMP(ii,3,0)
      Call DGEMM_('T','N',
     &            3,1,3,
     &            1.0d0,T,3,
     &            tmp,nij,
     &            0.0d0,rMu_A,3)
      Call RecPrt('rMu_A',' ',rMu_A,1,3)
      tmp(1,1)=rMP(jj,1,0)
      tmp(2,1)=rMP(jj,2,0)
      tmp(3,1)=rMP(jj,3,0)
      Call DGEMM_('T','N',
     &            3,1,3,
     &            1.0d0,T,3,
     &            tmp,nij,
     &            0.0d0,rMu_B,3)
      Call RecPrt('rMu_B',' ',rMu_B,1,3)
*
      R_Q(1,1)=rMP(ij,4,0)
      R_Q(1,2)=half*rMP(ij,5,0)
      R_Q(1,3)=half*rMP(ij,6,0)
      R_Q(2,2)=rMP(ij,7,0)
      R_Q(2,3)=half*rMP(ij,8,0)
      R_Q(3,3)=rMP(ij,9,0)
      R_Q(2,1)=R_Q(1,2)
      R_Q(3,1)=R_Q(1,3)
      R_Q(3,2)=R_Q(2,3)
      Call RecPrt('R_Q',' ',R_Q,3,3)
      Call DGEMM_('N','T',
     &            3,3,3,
     &            1.0d0,R_Q,3,
     &            T,3,
     &            0.0d0,tmp,3)
      Call DGEMM_('N','N',
     &            3,3,3,
     &            1.0d0,T,3,
     &            tmp,3,
     &            0.0d0,R_Q,3)
      Call RecPrt('R_Q',' ',R_Q,3,3)
      QQ=R_Q(3,3)-Half*(R_Q(1,1)+R_Q(2,2))
      R_Test(3)=R_Q(3,3)/(Two*QQ) + R_Test(3)
      Call RecPrt('EC(Bond system) New',' ',R_Test,1,3)
*
      Call DGEMM_('N','N',
     &            3,3,3,
     &            1.0d0,T,3,
     &            R_Test,3,
     &            0.0d0,tmp,3)
      Call RecPrt('EC New',' ',tmp,1,3)
      Write (6,*)
* Store the relavant data
      Dipole_Rot_A  = rMu_A(3)
      Dipole_Rot_B  = rMu_B(3)
      Dipole_Rot_AB = rMu_AB(3)
C      R_A           = 0.0D0
C      R_B           = T_R
* Rotate EC(1,ii) to the new coordinate system
      Call DGEMM_('T','N',
     &            3,1,3,
     &            1.0d0,T,3,
     &            EC(1,ii),3,
     &            0.0d0,R_test,3)
      Call RecPrt('EC(ii)',' ',R_Test,1,3)
      R_temp        = R_Test(3)
* Rotate EC(1,jj) to the new coordinate system
      Call DGEMM_('T','N',
     &            3,1,3,
     &            1.0d0,T,3,
     &            EC(1,jj),3,
     &            0.0d0,R_test,3)
      Call RecPrt('EC(jj)',' ',R_Test,1,3)
* Put A in origo, and R_B the appropriate distance away.
      R_B           = R_Test(3) - R_temp
      R_A           = 0.0D0
      write(6, *)'Dipoles = ',Dipole_Rot_A,Dipole_Rot_B,Dipole_Rot_AB
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Stefano Battaglia                                *
************************************************************************
      SUBROUTINE Backtransform(Heff,Ueff,U0)
      IMPLICIT REAL*8 (A-H,O-Z)
C Back-transform Heff and Ueff to the basis of the original
C CASSCF states.
#include "rasdim.fh"
#include "caspt2.fh"
#include "stdalloc.fh"
      real(8) Heff(Nstate,Nstate),Ueff(Nstate,Nstate),U0(Nstate,Nstate)
      real(8),allocatable :: U0transpose(:,:),Utmp(:,:)


      if (IFXMS.or.IFRMS) then

* First we need to back-transform the effective Hamiltonian in the
* basis of original CASSCF states by U0 * Heff * U0^T
* Note that in the case of a normal MS-CASPT2 this and the next step
* do not have any effect on Heff and Ueff
        call mma_allocate(U0transpose,Nstate,Nstate,Label='U0transpose')
        call trnsps(Nstate,Nstate,U0,U0transpose)
        call transmat(Heff,U0transpose,Nstate)
        call mma_deallocate(U0transpose)

* Compute transformation matrix that diagonalizes the effective
* Hamiltonian expressed in the basis of original CASSCF states,
* i.e. simply combine the two transf matrices: Ueff = U0 * Ueff
        call mma_allocate(Utmp,Nstate,Nstate,Label='Utmp')
        call dgemm_('N','N',Nstate,Nstate,Nstate,
     &               1.0d0,U0,Nstate,Ueff,Nstate,
     &               0.0d0,Utmp,Nstate)
        Ueff=Utmp
        call mma_deallocate(Utmp)

      end if


      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_CheckDiagFromZ(irc,NVT,l_NVT,nBlock,l_nBlock,nV,l_nV1,l_nV2,iV1,l_iV11,l_iV12,ip_Z,l_Z1,l_Z2,Z,l_Z,Report)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: Check integral diagonal from Z vectors:
!
!          (J|J) = sum[K=1,J] Z(J,K)*Z(J,K)
!
!          Return codes
!          irc=0: all is fine
!          irc<0: too negative diagonals encountered, but otherwise
!                 calculation seems converged
!          irc>0: calculation not converged

use Index_Functions, only: iTri
use Cholesky, only: LuPri, nnBstRT, nSym, ThrCom, ThrNeg, TOONEG, WARNEG
use Cholesky_procedures, only: Cho_X_GetIP_InfVec
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: l_NVT, NVT(l_NVT), l_nBlock, nBlock(l_nBlock), l_nV1, l_nV2, nV(l_NV1,l_NV2), l_iV11, l_iV12, &
                                 iV1(l_iV11,l_iV12), l_Z1, l_Z2, ip_Z(l_Z1,l_Z2), l_Z
real(kind=wp), intent(in) :: Z(l_Z)
logical(kind=iwp), intent(in) :: Report
integer(kind=iwp) :: iD, iSym, J_inBlock, jBlock, J, K_inBlock, kblock, kOffZ, n1, n2, n3, n4, n5, nTot
real(kind=wp) :: Damax, Damin, Dmax, Dmin
integer(kind=iwp), pointer :: InfVct(:,:,:)
real(kind=wp), allocatable :: IntDia(:)
character(len=*), parameter :: SecNam = 'Cho_CheckDiagFromZ'

! Get pointer to global InfVec array
call Cho_X_getIP_InfVec(InfVcT)

! Allocate memory for exact integral diagonal
call mma_allocate(IntDia,nnBstRT(1),Label='IntDia')

! Read diagonal
call Cho_IODiag(IntDia,2)

! Subtract Z vector contributions
do iSym=1,nSym
  do kBlock=1,nBlock(iSym)
    do K_inBlock=1,nV(kBlock,iSym)
      kOffZ = ip_Z(iTri(kBlock,kBlock),iSym)-1
      do J_inBlock=K_inBlock,nV(kBlock,iSym)
        J = iV1(kBlock,iSym)+J_inBlock-1
        iD = InfVcT(J,1,iSym)
        IntDia(iD) = IntDia(iD)-Z(kOffZ+iTri(J_inBlock,K_inBlock))**2
      end do
    end do
    do jBlock=kBlock+1,nBlock(iSym)
      do K_inBlock=1,nV(kBlock,iSym)
        kOffZ = ip_Z(iTri(jBlock,kBlock),iSym)-1+nV(jBlock,iSym)*(K_inBlock-1)
        do J_inBlock=1,nV(jBlock,iSym)
          J = iV1(jBlock,iSym)+J_inBlock-1
          iD = InfVcT(J,1,iSym)
          IntDia(iD) = IntDia(iD)-Z(kOffZ+J_inBlock)**2
        end do
      end do
    end do
  end do
end do

! Total number of vectors
! ...should equal number of converged diagonals
nTot = sum(NVT(1:nSym))

! Count diagonals smaller than threshold
n1 = 0
n2 = 0
n3 = 0
n4 = 0
n5 = 0
Dmax = -9.0e9_wp
Damax = Zero
Dmin = 9.0e9_wp
Damin = 9.0e9_wp
do iSym=1,nSym
  do J=1,NVT(iSym)
    iD = InfVcT(J,1,iSym)
    Dmax = max(Dmax,IntDia(iD))
    Damax = max(Damax,abs(IntDia(iD)))
    Dmin = min(Dmin,IntDia(iD))
    Damin = min(Damin,abs(IntDia(iD)))
    if (IntDia(iD) <= ThrCom) n1 = n1+1
    if (IntDia(iD) < Zero) n2 = n2+1
    if (IntDia(iD) < ThrNeg) n3 = n3+1
    if (IntDia(iD) < WarNeg) n4 = n4+1
    if (IntDia(iD) < TooNeg) n5 = n5+1
  end do
end do

! Write a report if requested
if (Report) then
  call Cho_Head(SecNam//': Report on (J|J) Diagonal from Z','=',80,LuPri)
  write(LuPri,'(/,A,I8)') 'Total dimension of diagonal............',nnBstRT(1)
  write(LuPri,'(A,I8)') 'Number of Cholesky vectors.............',nTot
  write(LuPri,'(A,I8)') 'Converged diagonals....................',n1
  write(LuPri,'(A,I8)') 'Unconverged diagonals..................',nTot-n1
  write(LuPri,'(A,I8)') 'Negative diagonals.....................',n2
  write(LuPri,'(A,I8)') 'Neg. diag. that would be zeroed........',n3
  write(LuPri,'(A,I8)') 'Neg. diag. that would cause warning....',n4
  write(LuPri,'(A,I8)') 'Neg. diag. that would cause crash......',n5
  write(LuPri,'(A,ES15.6)') 'Max diagonal...........................',Dmax
  write(LuPri,'(A,ES15.6)') 'Min diagonal...........................',Dmin
  write(LuPri,'(A,ES15.6)') 'Max abs diagonal.......................',Damax
  write(LuPri,'(A,ES15.6)') 'Min abs diagonal.......................',Damin
end if

! Deallocation
call mma_deallocate(IntDia)

! Set return code and return
if (n1 == nTot) then
  if (n5 /= 0) then
    irc = -10
  else
    irc = 0
  end if
else
  irc = 10
end if

end subroutine Cho_CheckDiagFromZ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      module refwfn
      Implicit None
      Logical :: refwfn_active = .False.
      Character(Len=128) :: refwfn_filename
      Integer :: refwfn_id
      Logical, public :: refwfn_is_h5
      Integer :: IADR15(30)
      External Get_ProgName
      Character*100 ProgName, Get_ProgName
      Save

      Contains

************************************************************************
      Subroutine refwfn_init(Filename)
************************************************************************
      Implicit None
      Character(Len=*) :: Filename
      Integer :: I, IAD15

#ifdef _HDF5_
#  include "mh5.fh"
#endif
      refwfn_is_h5 = .False.

      ProgName = Get_ProgName()
      If (refwfn_active) Then
        write(6,*) ' trying to activate refwfn twice, aborting!'
        call abend
      Else
        refwfn_active = .True.
      End If

* if not a standard filename, call fileorb??
      If (FileName.ne.'JOBIPH') Then
        call fileorb(Filename,refwfn_filename)
      Else
        refwfn_filename = 'JOBIPH'
      End If

#ifdef _HDF5_
      If (mh5_is_hdf5(refwfn_filename)) Then
        refwfn_is_h5 = .True.
        write(6,'(1X,A)') 'wavefunction data from HDF5 file:'
        write(6,'(3X,A)') TRIM(refwfn_filename)
        refwfn_id = mh5_open_file_r(refwfn_filename)
      Else
#endif
        refwfn_is_h5 = .False.
* Assume reference wavefunction is stored as JobIph format
        refwfn_id=15
        CALL DANAME(refwfn_id,refwfn_filename)
* Read table of contents into IADR15() array.
* There are two possible different layouts, 15 or 30 integers:
        IAD15=0
        CALL IDAFILE(refwfn_id,2,IADR15,15,IAD15)
        IF(IADR15(15).EQ.-1) THEN
          IAD15=0
          CALL IDAFILE(refwfn_id,2,IADR15,30,IAD15)
        ELSE
          DO I=16,30
            IADR15(I)=0
          END DO
          Call WarningMessage(1,'Old JOBIPH file layout.')
        END IF
#ifdef _HDF5_
      End If
#endif
      End Subroutine

************************************************************************
      Subroutine refwfn_close
************************************************************************
      Implicit None
#ifdef _HDF5_
#  include "mh5.fh"
#endif

#ifdef _HDF5_
      If (refwfn_is_h5) Then
        call mh5_close_file(refwfn_id)
      Else
#endif
        call DaClos(refwfn_id)
#ifdef _HDF5_
      End If
#endif
      refwfn_active = .False.
      End SUbroutine

************************************************************************
      Subroutine refwfn_info
************************************************************************
CSVC: initialize the reference wavefunction info
#ifdef _DMRG_
      use qcmaquis_info
#endif
      Implicit None
#include "rasdim.fh"
#include "caspt2.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
#  include "mh5.fh"
      character(Len=1), allocatable :: typestring(:)
#endif
      Integer iSym, ref_nSym, ref_nBas(mxSym)
      Real*8 :: Weight(mxRoot)
      Integer IAD15

      If (.NOT.refwfn_active) Then
        Write(6,*) ' refwfn not yet activated, aborting!'
        call abend
      End If

#ifdef _HDF5_
      If (refwfn_is_h5) Then
*     general wavefunction attributes
*        call mh5_fetch_attr (refwfn_id, 'TITLE', Title)
        call mh5_fetch_attr (refwfn_id,'SPINMULT', iSpin)
        call mh5_fetch_attr (refwfn_id,'NSYM', ref_nSym)
        call mh5_fetch_attr (refwfn_id,'LSYM', lSym)
        call mh5_fetch_attr (refwfn_id, 'NBAS', ref_nBas)

        call mh5_fetch_attr (refwfn_id,'NACTEL', nActEl)
        call mh5_fetch_attr (refwfn_id,'NHOLE1', nHole1)
        call mh5_fetch_attr (refwfn_id,'NELEC3', nEle3)
        call mh5_fetch_attr (refwfn_id,'NCONF',  nConf)
        call mh5_fetch_attr (refwfn_id,'NSTATES', nRoots)
        call mh5_fetch_attr (refwfn_id,'NROOTS', lRoots)
        call mh5_fetch_attr (refwfn_id,'STATE_ROOTID', iRoot)
        call mh5_fetch_attr (refwfn_id,'STATE_WEIGHT', Weight)

        call mma_allocate (typestring, sum(ref_nbas(1:nsym)))
        call mh5_fetch_dset (refwfn_id, 'MO_TYPEINDICES', typestring)
        call tpstr2orb (ref_nsym,ref_nbas,typestring,
     $          nfro,nish,nras1,nras2,nras3,nssh,ndel)
        nash = nras1 + nras2 + nras3
        call mma_deallocate (typestring)
!       Leon 14/6/2017 -- do not read CI vectors if NEVPT2 is attempted
!       because for now we only support DMRG-NEVPT2
        if (ProgName(1:6).eq.'caspt2') then
          If (.not.mh5_exists_dset(refwfn_id, 'CI_VECTORS')) Then
          Write(6,'(1X,A)') 'The HDF5 file does not contain CI vectors,'
          Write(6,'(1X,A)') 'make sure it was created by rasscf/caspt2.'
            Call AbEnd()
          End If
        End If
        If (.not.mh5_exists_dset(refwfn_id, 'MO_VECTORS')) Then
        Write(6,'(1X,A)') 'The HDF5 file does not contain MO vectors,'
        Write(6,'(1X,A)') 'make sure it was created by'//
     &                    ' rasscf/caspt2/nevpt2.'
          Call AbEnd()
        End If
        IFQCAN=0
#ifdef _DMRG_
        If(mh5_exists_dset(refwfn_id, 'QCMAQUIS_CHECKPOINT')) Then
          call qcmaquis_info_init(1,nroots,-1)
          call mh5_fetch_dset_array_str(refwfn_id,
     &       'QCMAQUIS_CHECKPOINT', qcm_group_names(1)%states)
        end if
#endif
      Else
#endif
C Sizes in the GSLIST is counted in INTEGERS.
C Note that the title field in the JOBIPH file is not used for anything
C in this program, it is just a dummy read.
C Another title field is read from input a little later, it is called
C TITLE2. That one is printed out in PRINP_CASPT2.
        IAD15=IADR15(1)
        CALL WR_RASSCF_Info(refwfn_id,2,iAd15,
     &                      NACTEL,ISPIN,REF_NSYM,LSYM,
     &                      NFRO,NISH,NASH,NDEL,REF_NBAS,8,
     &                      NAME,LENIN8*MXORB,NCONF,HEADER,144,
     &                      TITLE,4*18*mxTit,POTNUC,
     &                      LROOTS,NROOTS,IROOT,MXROOT,NRAS1,
     &                      NRAS2,NRAS3,NHOLE1,NELE3,IFQCAN,
     &                      Weight)
      nssh = ref_nbas - nfro - nish - nash - ndel
#ifdef _HDF5_
      End If
#endif
      If (nSym.ne.ref_nSym) Then
        write(6,*) ' Number of irreps of the reference wavefunction'
        write(6,*) ' does not match the data on the RunFile, abort!'
        Call AbEnd
      Else
        Do iSym=1,nSym
          If (nBas(iSym).ne.ref_nBas(iSym)) Then
            write(6,*) ' Number of basis functions of the reference'
            write(6,*) ' wavefunction does not match the data on the'
            write(6,*) ' RunFile, abort!'
            Call AbEnd
          End If
        End Do
      End If
      End Subroutine

************************************************************************
      subroutine refwfn_data
************************************************************************
CSVC: initialize the reference wavefunction data
      Implicit None
#include "rasdim.fh"
#include "caspt2.fh"
#include "pt2_guga.fh"
#include "WrkSpc.fh"
#ifdef _HDF5_
#  include "mh5.fh"
#endif

      Integer :: I, IAD15, II, IDISK, ID

      Real*8 :: Root_Energies(mxRoot)
      Real*8 :: AEMAX, E
      Integer :: IAD, LEJOB, NEJOB, IT, NMAYBE, ISNUM

      If (.NOT.refwfn_active) Then
        Write(6,*) ' refwfn not yet activated, aborting!'
        call abend
      End If

*---  Read the MO coefficients from HDF5/JOBIPH and store on LUONEM
      NCMO=NBSQT
      CALL GETMEM('LCMORAS','ALLO','REAL',LCMORAS,NCMO)
#ifdef _HDF5_
      If (refwfn_is_h5) Then
        call mh5_fetch_dset_array_real(refwfn_id,
     &       'MO_VECTORS', WORK(LCMORAS))
      Else
#endif
        IAD15=IADR15(9)
        IF(IFQCAN.EQ.0) IAD15=IADR15(2)
        CALL DDAFILE(refwfn_id,2,WORK(LCMORAS),NCMO,IAD15)
#ifdef _HDF5_
        End If
#endif
      IEOF1M=0
      IDISK=IEOF1M
      IAD1M(1)=IDISK
      CALL DDAFILE(LUONEM,1,WORK(LCMORAS),NCMO,IDISK)
      CALL GETMEM('LCMORAS','FREE','REAL',LCMORAS,NCMO)
      IEOF1M=IDISK

C IDCIEX: Present EOF on LUCIEX.
      ID=IDCIEX
C Skip when using cumulant reconstruction of (3-,) 4-RDM
!     Leon 14/6/2017 -- do not read CI vectors if NEVPT2 is attempted
!     because for now we only support DMRG-NEVPT2
      if (ProgName(1:6).eq.'caspt2') then
        IF((.Not.DoCumulant).AND.(ISCF.EQ.0)) THEN
          CALL GETMEM('LCI','ALLO','REAL',LCI,NCONF)
          DO I=1,NSTATE
            ISNUM=MSTATE(I)
#ifdef _HDF5_
            If (refwfn_is_h5) Then
*---  Read the CI coefficients from the HDF5 file
              call mh5_fetch_dset_array_real(refwfn_id,'CI_VECTORS',
     $             Work(LCI),[nconf,1],[0,ISNUM-1])
            Else
#endif
*---  Read the CI coefficients from the JOBIPH file
              IDISK=IADR15(4)
              DO II=1,ISNUM-1
                CALL DDAFILE(refwfn_id,0,WORK(LCI),NCONF,IDISK)
              END DO
              CALL DDAFILE(refwfn_id,2,WORK(LCI),NCONF,IDISK)
#ifdef _HDF5_
            End If
#endif
C Copy selected vectors to LUCI:
            CALL DDAFILE(LUCIEX,1,WORK(LCI),NCONF,ID)
          END DO
C Disk address = present EOF on LUCIEX.
C IDTCEX = Disk address to transformed CI.
          IF(ORBIN.EQ.'TRANSFOR') THEN
            IDTCEX=ID
C Dummy writes:
            DO II=1,NSTATE
              CALL DDAFILE(LUCIEX,0,WORK(LCI),NCONF,ID)
            END DO
          ELSE
            IDTCEX=IDCIEX
          END IF
          CALL GETMEM('LCI','FREE','REAL',LCI,NCONF)
        ELSE
* If this is Closed-shell or Hi-spin SCF case
* Just in case...
          IF (.Not.DoCumulant .and. (NSTATE.ne.1 .or. NCONF.ne.1)) THEN
            write(6,*)' readin_caspt2: A Closed-shell or Hi-spin SCF'
            write(6,*)' but nr of states is: NSTATE=', NSTATE
            write(6,*)' and nr of CSFs is    NCONF= ', NCONF
            write(6,*)' Program error?? Must stop.'
            CALL ABEND
          END IF
* This should be solved elsewhere in the code...just for the now,
* make a write of a CI vector to LUCIEX, so other routines do not get
* their knickers into a twist:
          NCONF=1
          CALL GETMEM('LCI','ALLO','REAL',LCI,NCONF)
          WORK(LCI)=1.0D0
          CALL DDAFILE(LUCIEX,1,WORK(LCI),NCONF,ID)
          CALL GETMEM('LCI','FREE','REAL',LCI,NCONF)
        END IF
      End If
C Now, the selected original CASCI expansions are on LUCIEX
C beginning from disk address 0.

CSVC: read the L2ACT and LEVEL arrays
#ifdef _HDF5_
      If (refwfn_is_h5) Then
        call mh5_fetch_attr (refwfn_id,'L2ACT', L2ACT)
        call mh5_fetch_attr (refwfn_id,'A2LEV', LEVEL)
      Else
#endif
        IAD15=IADR15(18)
        CALL IDAFILE(refwfn_id,2,L2ACT,mxAct,IAD15)
        CALL IDAFILE(refwfn_id,2,LEVEL,mxAct,IAD15)
#ifdef _HDF5_
      End If
#endif

#ifdef _HDF5_
      If (refwfn_is_h5) Then
        call mh5_fetch_dset_array_real(refwfn_id,
     &         'ROOT_ENERGIES', ROOT_ENERGIES)
      Else
#endif
*PAM 2015: We will no longer recompute the RASSCF energies
* but just assume they can be obtained from the JOBIPH file.
* There is table with unknown length with all energies from
* all iterations (!) there.
        NEJOB=MXROOT*MXITER
        CALL GETMEM('EJOB','ALLO','REAL',LEJOB,NEJOB)
        IAD=IADR15(6)
        CALL DDAFILE(refwfn_id,2,WORK(LEJOB),NEJOB,IAD)
C Note that there is no info on nr of iterations
C so we cannot know what energies to pick...
C Let us make a guess: The correct set of energy values in the
C table of energies/iteration is the last one with not all zeroes.
        NMAYBE=0
        DO IT=1,MXITER
          AEMAX=0.0D0
          DO I=1,MXROOT
            E=WORK(LEJOB+MXROOT*(IT-1)+(I-1))
            AEMAX=MAX(AEMAX,ABS(E))
          END DO
          IF(ABS(AEMAX).LE.1.0D-12) GOTO 11
          NMAYBE=IT
        END DO
11      CONTINUE
        IF(NMAYBE.EQ.0) THEN
          WRITE(6,*)' PT2INI tried to read energies from the'
          WRITE(6,*)' JOBIPH file, but could not find any.'
          CALL ABEND()
        END IF
* And then put the energies into the Hamiltonian matrix,
* unless already filled in by the EFFE keyword
        DO I=1,mxRoot
          Root_Energies(I)=WORK(LEJOB+MXROOT*(NMAYBE-1)+(I-1))
        END DO
* No more use for the array EJOB.
        CALL GETMEM('EJOB','FREE','REAL',LEJOB,NEJOB)
#ifdef _HDF5_
      End If
#endif
!     Leon: MSTATE(I) is initialised only in caspt2
!     if it's initialised somewhere else, feel free to change the line below
      if (ProgName(1:6).eq.'caspt2') then
        DO I=1,NSTATE
          REFENE(I)=ROOT_ENERGIES(MSTATE(I))
        END DO
      else
!       since it isn't initialised, we just assume that we need the states in the
!       same order as they're written on JobIph
!       Apparently, nstates is also initialised in caspt2 only, but nroots is
!       available from here, so we use nroots
!       > stknecht: initialize nstate here nevertheless - can be used in nevpt2 initialization as well
        nstate = nroots
        refene(1:nroots)=ROOT_ENERGIES(1:nroots)
      end if
      End Subroutine

      End Module

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Move_Prop(rMP,EC,lMax,nElem,nAtoms,nPert,nij,iANr,Bond_Threshold)
! Distributes the contributions from the bonds that doesn't fulfill the requirement
! Bond_Length <= Bond_Threshold*(Bragg_Slater(iAtom)+Bragg_Slater(jAtom) to the
! two atoms involved in the bond.
!
! Polarizabilities are moved in the Move_Polar subroutine!

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lMax, nElem, nAtoms, nPert, nij, iANr(nAtoms)
real(kind=wp), intent(inout) :: rMP(nij,0:nElem-1,0:nPert-1)
real(kind=wp), intent(in) :: EC(3,nij), Bond_Threshold
integer(kind=iwp) :: iAtom, iElem, ii, ij, iPert, jAtom, jj
logical(kind=iwp) :: Bond_OK, Check_Bond

do iAtom=2,nAtoms
  ii = iAtom*(iAtom+1)/2
  do jAtom=1,iAtom-1
    jj = jAtom*(jAtom+1)/2
    Bond_Ok = Check_Bond(EC(1,ii),EC(1,jj),iANr(iAtom),iANr(jAtom),Bond_Threshold)
    if (.not. Bond_OK) then
      ij = iAtom*(iAtom-1)/2+jAtom
      do iPert=0,nPert-1

        ! First move half of the bond properties to iAtom

        do iElem=0,nElem-1
          rMP(ij,iElem,iPert) = rMP(ij,iElem,iPert)*Half
        end do

        call ReExpand(rMP(1,0,iPert),nij,nElem,EC(1,ij),EC(1,ii),ij,lMax)

        do iElem=0,nElem-1
          rMP(ii,iElem,iPert) = rMP(ii,iElem,iPert)+rMP(ij,iElem,iPert)
        end do

        ! Then move the other half of the bond properties to jAtom

        call ReExpand(rMP(1,0,iPert),nij,nElem,EC(1,ii),EC(1,jj),ij,lMax)

        do iElem=0,nElem-1
          rMP(jj,iElem,iPert) = rMP(jj,iElem,iPert)+rMP(ij,iElem,iPert)
        end do

        ! Set local properties to zero

        rMP(ij,:,iPert) = Zero
      end do
    end if
  end do
end do

return

end subroutine Move_Prop

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Kap_CI(h1,nh1,h2,nh2,ipS1)

use ipPage, only: ipin, W
use MCLR_Data, only: ipCI, nConf1
use MCLR_procedures, only: CISigma_sa
use input_mclr, only: nCSF, nRoots, State_Sym
use ISRotation, only: unequal_SA
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nh1, nh2, ipS1
real(kind=wp), intent(in) :: h1(nh1), h2(nh2)
integer(kind=iwp) :: i, j
real(kind=wp) :: rDum(1)
real(kind=wp), allocatable :: R(:,:)
real(kind=wp), external :: DDot_

call CISigma_sa(0,state_sym,state_sym,h1,nh1,h2,nh2,rdum,1,ipCI,ipS1,.true.)

call ipin(ipS1)
call ipin(ipCI)

W(ipS1)%A(1:nroots*ncsf(STATE_SYM)) = Two*W(ipS1)%A(1:nroots*ncsf(STATE_SYM))

! if not equally state-averaged, do not project out the internal space contributions here
if (unequal_SA) return

call mma_allocate(R,nroots,nroots,label='R')

do i=1,nroots
  do j=1,nroots
    R(i,j) = ddot_(nconf1,W(ipS1)%A(1+nconf1*(i-1)),1,W(ipCI)%A(1+nconf1*(j-1)),1)
  end do
end do

do i=1,nroots
  do j=1,nroots
    W(ipS1)%A((j-1)*nconf1+1:j*nconf1) = W(ipS1)%A((j-1)*nconf1+1:j*nconf1)-R(i,j)*W(ipCI)%A((i-1)*nconf1+1:i*nconf1)
  end do
end do

call mma_deallocate(R)

end subroutine Kap_CI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine Find_Distance(Ref,Point,Dir,Fact,Dist,nAtom,
     &                         BadConstraint)
      Implicit None
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "info_slapaf.fh"
#include "sbs.fh"
      Integer, Intent(In) :: nAtom
      Real*8, Intent(In) :: Ref(3*nAtom),Dir(3*nAtom),Fact,Dist
      Real*8, Intent(Out) :: Point(3*nAtom)
      Logical, Intent(Out) :: BadConstraint
      Real*8, Allocatable :: OldRef(:),Dummy(:)
      Real*8 :: R,CurFact,PrevR,Correct
      Real*8, Parameter :: Thr = 1.0d-6
      Integer :: nCoor,i
      Logical :: Invar
*                                                                      *
************************************************************************
*                                                                      *
      Invar=(iAnd(iSBS,2**7).eq.0).and.(iAnd(iSBS,2**8).eq.0)
      nCoor=3*nAtom
      Call mma_allocate(OldRef,nCoor)
      Call mma_allocate(Dummy,nCoor)
      Call dCopy_(nCoor,Work(ipRef),1,OldRef,1)
      Call dCopy_(nCoor,Ref,1,Work(ipRef),1)

      R=Zero
      CurFact=Zero
      Correct=Fact
      i=0
      Do While (Abs(One-R/Dist).gt.Thr)

*       Add the scaled direction vector
        CurFact=CurFact+Correct
        Call dCopy_(nCoor,Ref,1,Point,1)
        Call daXpY_(nCoor,CurFact,Dir,1,Point,1)

*       Align and measure distance
        PrevR=R
        Call Align(Point,Ref,nAtom)
        If (MEP_Type.eq.'SPHERE') Then
          Call SphInt(Point,nAtom,ip_Dummy,R,Dummy,
     &                .False.,.False.,'dummy   ',Work(ip_Dummy),.False.)
        Else If (MEP_Type.eq.'TRANSVERSE') Then
          Call Transverse(Point,nAtom,R,Dummy,
     &                .False.,.False.,'dummy   ',Work(ip_Dummy),.False.)
        End If

*       Stop if too many iterations or if the constraint is moving
*       in the wrong direction
        i=i+1
        If (i.gt.5.or.Correct*(R-PrevR).lt.Zero) Exit
        Correct=(One-R/Dist)*Fact
      End Do
      BadConstraint=(Abs(One-R/Dist).gt.Thr)

      Call dCopy_(nCoor,OldRef,1,Work(ipRef),1)
      Call mma_deallocate(OldRef)
      Call mma_deallocate(Dummy)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End Subroutine Find_Distance

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Virt_Space(C_Occ,C_Virt,Ovrlp,nBas,nOcc,nVirt)
!***********************************************************************
!     The generation of starting orbitals suffers from the fact that   *
!     the virtual orbitals are not well defined. This routine is       *
!     supposed to generate a set of well-defined virtual orbitals from *
!     a set of well-defined occupied orbitals.                         *
!***********************************************************************

use Index_Functions, only: nTri_Elem
#ifdef _DEBUGPRINT_
use Index_Functions, only: iTri
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBas, nOcc, nVirt
real(kind=wp), intent(in) :: C_Occ(nBas,nOcc), Ovrlp(nTri_Elem(nBas))
real(kind=wp), intent(inout) :: C_Virt(nBas,nVirt)
integer(kind=iwp) :: iBas, iOcc, iVirt, jBas, kBas, lBas, mVirt
real(kind=wp) :: tmp
real(kind=wp), allocatable :: C_tmp(:,:), EVa(:), EVe(:,:), Ovrlp_Sq(:,:), P(:,:), PNew(:)
real(kind=wp), parameter :: thr = 1.0e-14_wp
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ij

write(u6,*) 'nBas,nOcc,nVirt=',nBas,nOcc,nVirt
call RecPrt('C_Occ',' ',C_Occ,nBas,nOcc)
call RecPrt('C_Virt',' ',C_Virt,nBas,nVirt)
call TriPrt('Ovrlp',' ',Ovrlp,nBas)
do iOcc=1,nOcc
  tmp = Zero
  do iBas=1,nBas
    do jBas=1,nBas
      ij = iTri(iBas,jBas)
      tmp = tmp+C_Occ(iBas,iOcc)*Ovrlp(ij)*C_Occ(jBas,iOcc)
    end do
  end do
  write(u6,*) 'iOcc,tmp=',iOcc,tmp
end do
do iVirt=1,nVirt
  tmp = Zero
  do iBas=1,nBas
    do jBas=1,nBas
      ij = iTri(iBas,jBas)
      tmp = tmp+C_Virt(iBas,iVirt)*Ovrlp(ij)*C_Virt(jBas,iVirt)
    end do
  end do
  write(u6,*) 'iVirt,tmp=',iOcc,tmp
end do
#endif

! Compute S^{1/2}

call mma_allocate(Ovrlp_Sq,nBas,nBas,Label='Ovrlp_Sq')
call mma_allocate(EVa,nTri_Elem(nBas),Label='EVa')
call mma_allocate(EVe,nBas,nBas,Label='EVe')
call unitmat(EVe,nBas)
EVa(:) = Ovrlp(1:nTri_Elem(nBas))
call NIdiag(EVa,EVe,nBas,nBas)

do iBas=2,nBas
  EVa(iBas) = EVa(nTri_Elem(iBas))
end do

do iBas=1,nBas
  do jBas=1,nBas
    Ovrlp_Sq(iBas,jBas) = sum(EVe(iBas,:)*sqrt(EVa(1:nBas))*EVe(jBas,:))
  end do
end do

! Now transform the CMOs of the occupied orbitals to an orthonormal basis.

call mma_allocate(C_tmp,nBas,nOcc,Label='C_tmp')
call DGEMM_('N','N',nBas,nOcc,nBas,One,Ovrlp_Sq,nBas,C_Occ,nBas,Zero,C_tmp,nBas)

call mma_allocate(P,nBas,nBas,Label='P')
call mma_allocate(PNew,nBas,Label='PNew')

! Form the P matrix = 1 - |C(occ)><C(occ)|

call unitmat(P,nBas)
call DGEMM_('N','T',nBas,nBas,nOcc,-One,C_tmp,nBas,C_tmp,nBas,One,P,nBas)
#ifdef _DEBUGPRINT_
call RecPrt('C_tmp',' ',C_tmp,nBas,nOcc)
call RecPrt('P-mat',' ',P,nBas,nBas)
do iBas=1,nBas
  write(u6,*) 'iBas,P(iBas,iBas)=',iBas,P(iBas,iBas)
end do
#endif

! Now, use Cholesky Decomposition to reduce
! the size of the P-matrix from a nBas x nBas size
! down to something that is nBas x nVirt

mVirt = 0
do kBas=1,nBas

  tmp = Zero
  lBas = 0
  do iBas=1,nBas
    if (P(iBas,iBas) > tmp) then
      tmp = P(iBas,iBas)
      lBas = iBas
    end if
  end do

  ! Pick up a vector and project it against the previous

  PNew(:) = P(:,lBas)

  ! Normalize PNew

  tmp = sum(PNew(:)**2)

  ! Skip if this is a null vector.

  if (tmp < thr) cycle

  PNew(:) = PNew(:)/sqrt(tmp)
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'New Trial vector'
  write(u6,*) '================'
  write(u6,*) 'kBas,lBas,tmp=',kBas,lBas,tmp
  call RecPrt('Normalized PNew',' ',PNew,nBas,1)
# endif

  do iOcc=1,nOcc

    ! From the trial vector eliminate the occupied space

    tmp = sum(PNew(:)*C_tmp(:,iOcc))
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iOcc,tmp=',iOcc,tmp
#   endif
    ! Form PNew(2) = P(2) - <PNew(1)|Ovrlp|P(2)>PNew(1)

    PNew(:) = PNew(:)-tmp*C_Occ(:,iOcc)
  end do
  do iVirt=1,mVirt

    ! From the trial vector eliminate parts which are already expressed.

    tmp = sum(PNew(:)*C_Virt(:,iVirt))
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iVirt,tmp=',iVirt,tmp
#   endif

    ! Form PNew(2) = P(2) - <PNew(1)|Ovrlp|P(2)>PNew(1)

    PNew(:) = PNew(:)-tmp*C_Virt(:,iVirt)
  end do

  ! Test that it is not a null vector!

  tmp = sum(PNew(:)**2)
# ifdef _DEBUGPRINT_
  write(u6,*) 'Norm after projection:',tmp
  write(u6,*)
# endif
  if (tmp > thr) then
    PNew(:) = PNew(:)/sqrt(tmp)

    mVirt = mVirt+1
    C_Virt(:,mVirt) = PNew(:)

    ! Update the P-matrix.

    do jBas=1,nBas
      P(:,jBas) = P(:,jBas)-PNew(:)*PNew(jBas)
    end do
  end if

  if (mVirt == nVirt) exit

end do

call mma_deallocate(C_tmp)
call mma_deallocate(P)
call mma_deallocate(PNew)

if (mVirt /= nVirt) then
  write(u6,*) 'mVirt /= nVirt'
  write(u6,*) 'mVirt,nVirt=',mVirt,nVirt
  call Abend()
end if

! Form S^(-1/2)

do iBas=1,nBas
  do jBas=1,nBas
    Ovrlp_Sq(iBas,jBas) = sum(EVe(iBas,:)*EVe(jBas,:)/sqrt(EVa(1:nBas)))
  end do
end do
call mma_deallocate(EVe)
call mma_deallocate(EVa)

call mma_allocate(C_tmp,nBas,nVirt,Label='C_tmp')
C_tmp(:,:) = C_Virt(:,:)
call DGEMM_('N','N',nBas,nVirt,nBas,One,Ovrlp_Sq,nBas,C_tmp,nBas,Zero,C_Virt,nBas)
call mma_deallocate(C_tmp)
call mma_deallocate(Ovrlp_Sq)

#ifdef _DEBUGPRINT_
call RecPrt('C_Virt(New)',' ',C_Virt,nBas,nVirt)
#endif

end subroutine Virt_Space

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Valera Veryazov                                  *
************************************************************************
************************************************************************
*                                                                      *
*     purpose:                                                         *
*       general purpose routine for printing nice messages             *
*       with simple reformatting:                                      *
*           \n and long string converted to new line                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     V.Veryazov University of Lund, 2001                              *
*                                                                      *
************************************************************************
c       call SysPutsStart()
c       call SysPuts('MOL;CAS\n\nmolcas is a quantum '//
c     6  'chemistry software developed by scientists to be '//
c     6   'used by scientists. It is not primarily a commercial '//
c     6   'product and it is not sold in order to produce a '//
c     6   'fortune for its owner (the Lund University).',' ',' ')
c       call SysPutsEnd()
c       end
*
      Subroutine SysPuts(str,str1,str2)
      Character*(*) str,str1,str2
      Character *512 Junk
c because of bug in g77 we can't just concatenate strings and
c  had to have limited length of the string
      iTooLong=60
      iLongEnough=50
      call mycat(Junk,str,str1,str2)
      mlen=mylen(Junk)
      mleni=mlen
      ipos=1
c  check is '\n' .eq. <CR>?
      icr=len('\n')-1
      icr1=0
100   j=100000
      ii=index(Junk(ipos:mleni),'\n')
      if(ii.gt.0) j=min(j,ii)
      iii=index(Junk(ipos:mleni),';')
      if(iii.gt.0) j=min(j,iii)
      if(j.eq.ii.and.ii.gt.0) icr1=icr
      if(j.eq.iii.and.iii.gt.0) icr1=0
      if(j.eq.100000) j=0
      i=j
      if(i.gt.iTooLong.or.(i.eq.0.and.mlen.gt.iTooLong)) then
         ij=index(Junk(ipos+iLongEnough:mleni),' ')
         if(ij.eq.0)then
            call SysDumpStr(Junk(ipos:mleni))
            if(i.eq.0) return
         else
            ij=ij+iLongEnough-1
            call SysDumpStr(Junk(ipos:ipos+ij))
         endif
         ipos=ipos+ij+1
         mlen=mlen-ij-1
         goto 100
      endif
      if(i.eq.0) then
         call SysDumpStr(Junk(ipos:mleni))
         return
      endif
      call SysDumpStr(Junk(ipos:ipos+i-2))
      ipos=ipos+i+icr1
      mlen=mlen-i-icr1
      if(mlen.gt.0) goto 100
      return
      end
************************************************************************
      subroutine  SysDumpStr(str)
      character*(*) str
      character fmt*20
      iTooLong=60
      i=len(str)
      if(i.gt.iTooLong+8) then
c oops! too long
      write (6,'(a,a)')   ' ###    ',str
      return
      endif
      i=iTooLong+8-i
      if (i.eq.0) then
        fmt = '(a,a,a)'
      else
        write(fmt,'(a, i2,a)') '(a,a,',i,'x,a)'
      endif
      write (6,fmt) ' ###    ',str,' ###'
      return
      end

************************************************************************
      subroutine mycat(Junk,str0,str1,str2)
c
c  Junk=str0//str1//str2
c
      Character*(*) Junk,str0,str1,str2
      maxlen=len(Junk)

      Junk=' '
      ile=1
      il=mylen(str0)
      if (il.gt.0) then
         ils=1
         ile=il+1
         if(ile.gt.maxlen) goto 100
         Junk(ils:ile)=str0(1:il)
      end if
      il=mylen(str1)
      if (il.gt.0) then
         ils=ile+1
         ile=ile+il
         if(ile.gt.maxlen) goto 100
        Junk(ils:ile)=str1(1:il)
      end if
      il=mylen(str2)
      if (il.gt.0) then
         ils=ile+1
         ile=ile+il
         if(ile.gt.maxlen) goto 100
        Junk(ils:ile)=str2(1:il)
      end if
      return
100     write(6,*) ' too long strings to concatenate: '
        write(6,*) str0,str1,str2
        return
      end
************************************************************************
      function mylen(s)
c
c  return real length of the string without spaces...
c
      Character*(*) s
      il=len(s)
      if(il.eq.0) then
      mylen=0
      return
      endif
      do i=il,1,-1
       if(s(i:i).ne.' ') then
        mylen=i
       return
       endif
      enddo
      mylen=0
      return
      end
************************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module general_data

! common logical unit numbers
!
! LUStartOrb : MO-coefficients and occupation numbers
!              (formatted ASCI file, input)
! JOBIPH     : MO-coefficients and occupation numbers etc.
!              (binary, output)
! JOBOLD     : MO-coefficients and occupation numbers etc.
!              (binary, input)
! LUONEL     : one-electron integrals in AO basis
!              (binary, input)
! LUINTA     : two-electron integrals in AO basis
!              (binary, input)
! LUINTM     : two-electron integrals in MO basis
!              (binary, temporary)
! LUQUNE     : orbital gradients
!              (binary, temporary)
! LUDAVID    : Intermediate results of the diagonalization
!              (binary, temporary)

use Molcas, only: MxSym
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: MAXALTER = 16
integer(kind=iwp) :: INVEC, ISPIN, ITERFILE, JOBIPH, JOBOLD, LUDAVID, LUINTA, LUINTM, LUONEL, LUQUNE, LUStartOrb, &
                     MALTER(MAXALTER,3), NACTEL, NALTER, NASH(mxSym), NBAS(mxSym), NCONF, NCRVEC, NDEL(mxSym), NDELT, NELEC3, &
                     NFRO(mxSym), NFROT, NHOLE1, NISH(mxSym), NORB(mxSym), NRS1(mxSym), NRS1T, NRS2(mxSym), NRS2T, NRS3(mxSym), &
                     NRS3T, NSEL, NSSH(mxSym), NSYM, NTOT, NTOT1, NTOT2, NTOTSP, STSYM
real(kind=wp) :: SXDAMP
character(len=256) :: StartOrbFile
logical(kind=iwp) :: Lowdin_ON
integer(kind=iwp), allocatable :: CleanMask(:)
real(kind=wp), allocatable :: CRPROJ(:), CRVEC(:)

public :: CleanMask, CRPROJ, CRVEC, INVEC, ISPIN, ITERFILE, JOBIPH, JOBOLD, Lowdin_ON, LUDAVID, LUINTA, LUINTM, LUONEL, LUQUNE, &
          LUStartOrb, MALTER, MAXALTER, NACTEL, NALTER, NASH, NBAS, NCONF, NCRVEC, NDEL, NDELT, NELEC3, NFRO, NFROT, NHOLE1, NISH, &
          NORB, NRS1, NRS1T, NRS2, NRS2T, NRS3, NRS3T, NSEL, NSSH, NSYM, NTOT, NTOT1, NTOT2, NTOTSP, StartOrbFile, STSYM, SXDAMP

end module general_data

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine HaveWeConv(iCNum,iCStart,iQ_Atoms,Indma,iDT,FFp,xyzMyI
     &,Egun,Energy,NVarv,JaNej,Haveri)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "WrkSpc.fh"

      Dimension iDT(3)
      Dimension FFp(npol*npart,3),xyzMyI(3)
      Logical JaNej,Haveri

*----------------------------------------------------------------------*
* With the new and the old induced dipoles, check if we have converged.*
* We also have energy check.                                           *
*----------------------------------------------------------------------*
      JaNej=.true.
      Haveri=.false.
      Diffab=0
      xyzMyi(1)=0
      xyzMyi(2)=0
      xyzMyi(3)=0
      Do 821, i=1+(nPol*iCnum),IndMa
        k=i-((i-1)/nPol)*nPol
        Do 822, l=1,3
          Dtil=FFp(i,l)*Pol(k)
          Diff=Abs(Work(iDT(l)+i-1)-Dtil)
          If(Diff.gt.Diffab) Diffab=Diff
          xyzMyi(l)=xyzMyi(l)+Dtil
          Work(iDT(l)+i-1)=Dtil  !This is the quantities that has
                !changed during the iteration and that through FFp
                !includes the effect of the polarization of the
                !QM-molecule. It enters the iteration above, unless
                !we have converged.
822     Continue
821   Continue
      Egtest=Egun-Energy
      Egun=Energy
      If(nVarv.ge.itMax) then  !itMax is from input or default.
        Write(6,*)
        Write(6,*)'  No convergence for the induced dipoles.'
        Write(6,*)'  Difference remaining after ',nVarv,' iterations: '
     &,Diffab
        Haveri=.true.
        iPrint=10
        Do 842, j=icstart,npart*ncent,ncent
          distmin=1000.0d0
          kmin=0
          imin=0
          Do 841, i=1,iq_atoms
            Do 843, k=0,ncent-1
              dist=sqrt((cordst(i,1)-cordst(j+k,1))**2
     &            +(cordst(i,2)-cordst(j+k,2))**2
     &            +(cordst(i,3)-cordst(j+k,3))**2)
              if(dist.lt.distmin) then
                distmin=dist
                imin=i
                kmin=k
              endif
843         Continue
841       Continue
         Write(6,*)'solv.',j,'iq_atom',imin,'center',kmin+1
     &            ,'dist',distmin
842     Continue
        Write(6,*)
        GoTo 9898
      Endif
      If(abs(egtest).gt.Enelim) JaNej=.false.
      If(Diffab.gt.PolLim) JaNej=.false.

9898  Continue

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GTJK_MCLR(RJ,RK)
! PURPOSE: GET ALL INTEGRALS COULOMB AND EXCHANGE INTEGRALS
!          WITH THE CHARGE DISTRIBUTION JK

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: Int2, NACOB
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: RJ(NACOB,NACOB), RK(NACOB,NACOB)
integer(kind=iwp) :: NT, NTUJ, NTUK, NU

! FORM THE COULOMB (RJ) AND EXCHANGE (RK) INTEGRAL MATRICES FROM
! THE TWO-ELECTRON INTEGRAL LIST

do NT=1,NACOB
  do NU=1,NT
    NTUK = iTri(nTri_Elem(nt),nTri_Elem(nu))
    RJ(NT,NU) = INT2(NTUK)
    RJ(NU,NT) = INT2(NTUK)

    NTUJ = nTri_Elem(iTri(nt,nu))
    RK(NT,NU) = INT2(NTUJ)
    RK(NU,NT) = INT2(NTUJ)
  end do
end do

end subroutine GTJK_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PPGrd( &
#                define _CALLING_
#                include "grd_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: to compute pseudo potential gradient integrals               *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Symmetry_Info, only: iOper
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp), parameter :: lproju = 9, imax = 100, kcrs = 1
integer(kind=iwp) :: i, ia, iAlpha, ib, iBeta, iCar, iCmp, iCnttp, iDCRT(0:7), iExp, iIrrep, iOff, iplalbm, iplalbp, iplamlb, &
                     iplaplb, ipRef, iPrint, iRout, iSh, iStrt, iuvwx(4), iVec, iZeta, JndGrd(3,4), kCnt, kdc, kSh, kShEnd, &
                     kShStr, lcr(kcrs), lDCRT, LmbdT, lOp(4), mGrad, nArray, ncr(imax), ncrr, nDAO, nDCRT, nDisp, &
                     nkcrl(lproju+1,kcrs), nkcru(lproju+1,kcrs), nlalbm, nlalbp, nlamlb, nlaplb, npot, nPP_S
real(kind=wp) :: C(3), ccr(imax), Fact, TC(3), zcr(imax)
character(len=80) :: Label
logical(kind=iwp) EQ, JfGrad(3,4)
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"
logical(kind=iwp), external :: TF

#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(P)
unused_var(nHer)
unused_var(Ccoor(1))
unused_var(nOrdOp)

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 122
iPrint = nPrint(iRout)

nDAO = nTri_Elem1(la)*nTri_Elem1(lb)
iIrrep = 0
iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
lOp(1) = iOper(kOp(1))
lOp(2) = iOper(kOp(2))
!                                                                      *
!***********************************************************************
!                                                                      *
! Memory managment

nArray = 0
ipRef = 1

! la+1, lb

nlaplb = max(nTri_Elem1(la+1),nTri_Elem1(lb))**2
iplaplb = ipRef+2*nArray
nArray = nArray+nlaplb

! la-1, lb

if (la > 0) then
  nlamlb = max(nTri_Elem1(la-1),nTri_Elem1(lb))**2
else
  nlamlb = 0
end if
iplamlb = ipRef+2*nArray
nArray = nArray+nlamlb

! la, lb+1

nlalbp = max(nTri_Elem1(la),nTri_Elem1(lb+1))**2
iplalbp = ipRef+2*nArray
nArray = nArray+nlalbp

! la, lb-1

if (lb > 0) then
  nlalbm = max(nTri_Elem1(la),nTri_Elem1(lb-1))**2
else
  nlalbm = 0
end if
iplalbm = ipRef+2*nArray
nArray = nArray+nlalbm

if (nArray > nZeta*nArr) then
  write(u6,*) 'nArray > nZeta*nArr'
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
kdc = 0
do iCnttp=1,nCnttp
  if (iCnttp > 1) kdc = kdc+dbsc(iCnttp-1)%nCntr
  if (dbsc(iCnttp)%Charge == Zero) cycle
  if (dbsc(iCnttp)%nPP == 0) cycle
  !AOM< Get the "true" (non SO) shells
  nPP_S = 0
  do kSh=dbsc(iCnttp)%iPP,dbsc(iCnttp)%iPP+dbsc(iCnttp)%nPP-1
    if (Shells(kSh)%nExp <= 0) cycle
    ncrr = int(Shells(kSh)%Exp(1))
    if (ncrr <= 500) nPP_S = nPP_S+1
  end do
  if (nPP_S == 0) cycle
  !AOM>

  npot = 0
  kShStr = dbsc(iCnttp)%iPP
  !AOM kShEnd = kShStr+dbsc(iCnttp)%nPP-1
  kShEnd = kShStr+nPP_S-1
  if (dbsc(iCnttp)%nPP-1 > lproju) then
    write(u6,*) 'dbsc(iCnttp)%nPP-1 > lproju'
    !AOM write(u6,*) 'dbsc(iCnttp)%nPP   =',dbsc(iCnttp)%nPP
    write(u6,*) 'dbsc(iCnttp)%nPP   =',nPP_S
    write(u6,*) 'lproju             =',lproju
    call Abend()
  end if
  !AOM lcr(kcrs) = dbc(iCnttp)%nPP-1
  lcr(kcrs) = nPP_S-1
  iSh = 0
  iOff = 1
  do kSh=kShStr,kShEnd
    iSh = iSh+1
    nkcrl(iSh,kcrs) = iOff
    nkcru(iSh,kcrs) = iOff+Shells(ksh)%nExp/3-1
    iOff = iOff+Shells(kSh)%nExp/3
    if (nPot > imax) then
      write(u6,*) ' Pseudo: nPot > imax'
      write(u6,*) '         nPot=',nPot
      write(u6,*) '         imax=',imax
      call Abend()
    end if
    iStrt = 1
    do iExp=1,Shells(kSh)%nExp/3
      npot = npot+1
      ncr(npot) = int(Shells(kSh)%Exp(iStrt))
      zcr(npot) = Shells(kSh)%Exp(iStrt+1)
      ccr(npot) = Shells(kSh)%Exp(iStrt+2)
      iStrt = iStrt+3
    end do
  end do
  !write(u6,*) 'ncr',(ncr(i),i=1,npot)
  !write(u6,*) 'zcr',(zcr(i),i=1,npot)
  !write(u6,*) 'ccr',(ccr(i),i=1,npot)
  !write(u6,*) 'nkcrl',(nkcrl(i,1),i=1,iSh)
  !write(u6,*) 'nkcru',(nkcru(i,1),i=1,iSh)

  do kCnt=1,dbsc(iCnttp)%nCntr
    C(1:3) = dbsc(iCnttp)%Coor(1:3,kCnt)

    ! Find the DCR for M and S

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    iuvwx(3) = dc(kdc+kCnt)%nStab
    iuvwx(4) = dc(kdc+kCnt)%nStab
    JndGrd(:,1:2) = IndGrd
    JfGrad(:,1:2) = IfGrad

    nDisp = IndDsp(kdc+kCnt,iIrrep)
    do iCar=0,2
      JfGrad(iCar+1,3) = .false.
      iCmp = 2**iCar
      if (TF(kdc+kCnt,iIrrep,iCmp) .and. (.not. dbsc(iCnttp)%pChrg)) then
        nDisp = nDisp+1
        if (Direct(nDisp)) then
          JndGrd(iCar+1,1) = abs(JndGrd(iCar+1,1))
          JndGrd(iCar+1,2) = abs(JndGrd(iCar+1,2))
          JndGrd(iCar+1,3) = -nDisp
          JfGrad(iCar+1,1) = .true.
          JfGrad(iCar+1,2) = .true.
        else
          JndGrd(iCar+1,3) = 0
        end if
      else
        JndGrd(iCar+1,3) = 0
      end if
    end do
    JndGrd(:,4) = 0
    JfGrad(:,4) = .false.
    mGrad = 0
    do iCar=1,3
      do i=1,2
        if (JfGrad(iCar,i)) mGrad = mGrad+1
      end do
    end do
    if (mGrad == 0) cycle

    do lDCRT=0,nDCRT-1
      lOp(3) = iDCRT(lDCRT)
      lOp(4) = lOp(3)
      call OA(iDCRT(lDCRT),C,TC)
      if (EQ(A,RB) .and. EQ(A,TC)) cycle
      !                                                                *
      !*****************************************************************
      !                                                                *
      iZeta = 0
      do iBeta=1,nBeta
        do iAlpha=1,nAlpha
          iZeta = iZeta+1

          ! la+1, lb

          call FZero(Array(iplaplb),nlaplb)
          call Pseudo(Alpha(iAlpha),A(1),A(2),A(3),la+2,Beta(iBeta),RB(1),RB(2),RB(3),lb+1,Array(iplaplb),nlaplb,max(la+2,lb+1), &
                      ccr,zcr,nkcrl,nkcru,lcr,ncr,TC(1),TC(2),TC(3),npot)

          ! la-1, lb

          if (la > 0) then
            call FZero(Array(iplamlb),nlamlb)
            call Pseudo(Alpha(iAlpha),A(1),A(2),A(3),la,Beta(iBeta),RB(1),RB(2),RB(3),lb+1,Array(iplamlb),nlamlb,max(la,lb+1),ccr, &
                        zcr,nkcrl,nkcru,lcr,ncr,TC(1),TC(2),TC(3),npot)
          end if

          ! la, lb+1

          call FZero(Array(iplalbp),nlalbp)
          call Pseudo(Alpha(iAlpha),A(1),A(2),A(3),la+1,Beta(iBeta),RB(1),RB(2),RB(3),lb+2,Array(iplalbp),nlalbp,max(la+1,lb+2), &
                      ccr,zcr,nkcrl,nkcru,lcr,ncr,TC(1),TC(2),TC(3),npot)

          ! la, lb-1

          if (lb > 0) then
            call FZero(Array(iplalbm),nlalbm)
            call Pseudo(Alpha(iAlpha),A(1),A(2),A(3),la+1,Beta(iBeta),RB(1),RB(2),RB(3),lb,Array(iplalbm),nlalbm,max(la+1,lb),ccr, &
                        zcr,nkcrl,nkcru,lcr,ncr,TC(1),TC(2),TC(3),npot)
          end if

          ! Assemble gradient and store in rFinal.

          call Assemble_PPGrd(rFinal,nZeta,la,lb,iZeta,Alpha(iAlpha),Beta(iBeta),Array(iplaplb),Array(iplamlb),Array(iplalbp), &
                              Array(iplalbm),JfGrad)

        end do ! iAlpha
      end do   ! iBeta

      !AOM<
      if (abs(Fact-One) > 1.0e-7_wp) call dscal_(nAlpha*nBeta*nTri_Elem1(la)*nTri_Elem1(lb)*mGrad,Fact,rFinal,1)
      !AOM>
      if (iPrint >= 99) then
        write(u6,*) ' Result in PPGrd'
        write(u6,*) JfGrad
        do ia=1,nTri_Elem1(la)
          do ib=1,nTri_Elem1(lb)
            do iVec=1,mGrad
              write(Label,'(A,I2,A,I2,A)') ' rFinal(',ia,',',ib,')'
              call RecPrt(Label,' ',rFinal(:,ia,ib,1,iVec),nAlpha,nBeta)
            end do
          end do
        end do
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Distribute contributions to the gradient

      call Distg1X(rFinal,DAO,nZeta,nDAO,mGrad,Grad,nGrad,JfGrad,JndGrd,iuvwx,lOp)

    end do ! lDCRT
!                                                                      *
!***********************************************************************
!                                                                      *
  end do   ! kCnt
end do     ! iCnttp
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine PPGrd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module guga_util_global

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: nCOP = 600, nIOCR = 20000
integer(kind=iwp) :: IAD10(9), ICOP1(nCOP+1) = 0
real(kind=wp) :: COP(nCOP) = Zero

public :: COP, IAD10, ICOP1, nCOP, nIOCR

end module guga_util_global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Roland Lindh                                     *
!***********************************************************************

subroutine Overlap(mGrid,iSpin)
!***********************************************************************
!      Author:Roland Lindh, Department of Chemical Physics, University *
!             of Lund, SWEDEN. November 2000                           *
!***********************************************************************

use nq_Grid, only: F_xc, Rho, vRho
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mGrid, iSpin
integer(kind=iwp) :: iGrid
real(kind=wp) :: d_alpha, d_beta, DTot, Rho_Min
real(kind=wp), parameter :: T_x = 1.0e-20_wp

!                                                                      *
!***********************************************************************
!                                                                      *

vRho(:,:) = Zero
Rho_Min = T_X*1.0e-2_wp
if (iSpin == 1) then
  ! iSpin=1
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do iGrid=1,mGrid

    d_alpha = Rho(1,iGrid)
    DTot = Two*d_alpha
    if (DTot < T_X) cycle

    ! Accumulate contributions to the integrated density

    F_xc(iGrid) = F_xc(iGrid)+Dtot

    vRho(1,iGrid) = One

  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  ! iSpin=/=1
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do iGrid=1,mGrid

    d_alpha = max(Rho_min,Rho(1,iGrid))
    d_beta = max(Rho_min,Rho(2,iGrid))
    DTot = d_alpha+d_beta
    if (DTot < T_X) cycle

    ! Accumulate contributions to the integrated density

    F_xc(iGrid) = F_xc(iGrid)+Dtot

    vRho(1,iGrid) = One
    vRho(2,iGrid) = One

  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Overlap

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine KnEInt_GIAO(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,
     &                       P,Final,nZeta,nIC,nComp,la,lb,A,RB,nHer,
     &                       Array,nArr,Ccoor,nOrdOp,lOper,iChO,
     &                       iStabM,nStabM,
     &                       PtChrg,nGrid,iAddPot)
************************************************************************
*                                                                      *
* Object: to compute the kinetic energy integrals with the Gauss-      *
*         Hermite quadrature.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Modified to multipole moments November '90               *
************************************************************************
      use Her_RW
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
*
#include "rmat_option.fh"
#include "rmat.fh"
*
#include "print.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nIC),
     &       Zeta(nZeta), ZInv(nZeta), Alpha(nAlpha), Beta(nBeta),
     &       rKappa(nZeta), P(nZeta,3), A(3), RB(3), TC(3),
     &       Array(nZeta*nArr), Ccoor(3)
      Integer lOper(nComp), iStabM(0:nStabM-1), iStabO(0:7),
     &        iDCRT(0:7), iChO(nComp)
      Logical ABeq(3)
*
*     Statement function for Cartesian index
*
      nElem(i) = (i+1)*(i+2)/2
*     Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*     iOff(ixyz) = ixyz*(ixyz+1)*(ixyz+2)/6
*     Index(ixyz,ix,iz) = Ind(ixyz,ix,iz) + iOff(ixyz)
*
      iRout = 150
      iPrint = nPrint(iRout)
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+2)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+2)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp+2)
      ipQxyz = nip
      nip = nip + nZeta*3*(la+2)*(lb+2)*(nOrdOp+2)
      ipTxyz = nip
      nip = nip + nZeta*3*(la+1)*(lb+1)*(nOrdOp+2)
      ipWxyz = nip
      nip = nip + nZeta*3*(la+1)*(lb+1)*2
      ipA = nip
      nip = nip + nZeta
      ipB = nip
      nip = nip + nZeta
      ipFnl = nip
      nip = nip + nZeta*nElem(la)*nElem(lb)*nComp
*                                                                      *
************************************************************************
*                                                                      *
      If (nip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'KNEInt: nip-1.gt.nArr*nZeta')
         Write (6,*) 'nip=',nip
         Write (6,*) 'nArr,nZeta=',nArr,nZeta
         Call  Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In KnEInt: A',' ',A,1,3)
         Call RecPrt(' In KnEInt: RB',' ',RB,1,3)
         Call RecPrt(' In KnEInt: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In KnEInt: P',' ',P,nZeta,3)
         Write (6,*) ' In KnEInt: la,lb=',la,lb
      End If
*                                                                      *
************************************************************************
*                                                                      *
      llOper = lOper(1)
      Do iComp = 2, nComp
         llOper = iOr(llOper,lOper(iComp))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la+1,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb+1,HerR(iHerR(nHer)),nHer,ABeq)
*
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
      Do lDCRT = 0, nDCRT-1
         Call OA(iDCRT(lDCRT),CCoor,TC)
*
*        Compute the contribution from the multipole moment operator
*
         ABeq(1) = .False.
         ABeq(2) = .False.
         ABeq(3) = .False.
         Call CrtCmp(Zeta,P,nZeta,TC,Array(ipRxyz),
     &               nOrdOp+1,HerR(iHerR(nHer)),nHer,ABeq)
*
*        Compute the cartesian components for the multipole moment
*        integrals. The integrals are factorized into components.
*
         Call Assmbl(Array(ipQxyz),
     &               Array(ipAxyz),la+1,
     &               Array(ipRxyz),nOrdOp+1,
     &               Array(ipBxyz),lb+1,
     &               nZeta,HerW(iHerW(nHer)),nHer)
*
*        Compute the cartesian components for the kinetic energy
*        integrals. The kinetic energy components are linear
*        combinations of overlap components.
*
         ipAOff = ipA
         Do iBeta = 1, nBeta
            call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
            ipAOff = ipAOff + nAlpha
         End Do
*
         ipBOff = ipB
         Do iAlpha = 1, nAlpha
            call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
            ipBOff = ipBOff + 1
         End Do
*
         Call Kntc_GIAO(Array(ipTxyz),Array(ipQxyz),Array(ipWxyz),
     &                  la,lb,nOrdOp,
     &                  Array(ipA),Array(ipB),nZeta)
*
*        Combine the cartesian components to the full one electron
*        integral.
*
         nB=3
         Call CmbnKE_GIAO(Array(ipQxyz),nZeta,la,lb,nOrdOp,Zeta,rKappa,
     &                    Array(ipFnl),nComp/nB,nB,Array(ipTxyz),
     &                    Array(ipWxyz),A,RB,TC)
*
*        Accumulate contributions
*
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array(ipFnl),nZeta,la,lb,nComp,Final,nIC,
     &               nOp         ,lOper,iChO,One)
*
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_real(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine TRDACT(IVEC,JVEC,DTU)
! Add to the active-active block of transition density matrix,
!    D(t,u) = Add <IVEC| E(t,u) |JVEC> = <0| W1T E(t,u) W2 |0>
! where t,u are active indices. IVEC and JVEC are integer labels,
! denoting sets of coefficients stored on LUSOLV. These are assumed
! to be contravariant representations of the wave operators W1 and W2,
! in the notation of the comments.

use Index_Functions, only: nTri_Elem, nTri3_Elem
use sguga, only: SGS
use caspt2_global, only: IDTCEX, LUCIEX
use caspt2_module, only: iASym, iSCF, jState, MxCI, nAes, nAsh, nAshT, nAshT, nConf, nSym, STSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC
real(kind=wp), intent(inout) :: DTU(NASHT,NASHT)
integer(kind=iwp) :: I, ID, ISYM, ISYMT, ITABS, ITLEV, IU, IUABS, IULEV, nLev, NOP1, NOP2, NOP3
real(kind=wp) :: OCCNUM, OP0, SCP
integer(kind=iwp), allocatable :: IATOG(:)
real(kind=wp), allocatable :: TRDCI(:), TRDOP1(:), TRDOP2(:), TRDOP3(:), TRDSGM(:), TRDTMP(:)
real(kind=wp), external :: DDOT_

nLev = SGS%nLev

! (1): Compute a representation of the operator PCAS*W1T*W2
NOP1 = NASHT**2
NOP2 = nTri_Elem(NOP1)
NOP3 = nTri3_Elem(NOP1)
call MMA_ALLOCATE(TRDOP1,NOP1)
call MMA_ALLOCATE(TRDOP2,NOP2)
call MMA_ALLOCATE(TRDOP3,NOP3)
call MKWWOP(IVEC,JVEC,OP0,TRDOP1,NOP2,TRDOP2,NOP3,TRDOP3)

! (2): Compute the state vector |Temp> = (PCAS*W1T*W2) |0>
! First modify the coefficients, see subroutine MODOP.
call MODOP(TRDOP1,NOP2,TRDOP2,NOP3,TRDOP3)
call MMA_ALLOCATE(TRDTMP,NCONF)
call MMA_ALLOCATE(TRDCI,NCONF)
if (ISCF == 0) then
  ID = IDTCEX(JSTATE)
  call DDAFILE(LUCIEX,2,TRDCI,NCONF,ID)
else
  TRDCI(1) = One
end if
TRDTMP(:) = Zero
call HAM3(OP0,TRDOP1,NOP2,TRDOP2,NOP3,TRDOP3,STSYM,TRDCI,TRDTMP,nCONF)
! No more need for the operators:
call MMA_DEALLOCATE(TRDOP1)
call MMA_DEALLOCATE(TRDOP2)
call MMA_DEALLOCATE(TRDOP3)

! (3) compute <0| E(t,u) W1T W2 |0> as <Sigma_ut| Temp>, and add to DTU

if (ISCF == 0) then
  ! Create reorder table giving the GUGA level, i.e. CI-coupling
  ! ordinal number of each active orbital.
  call mma_allocate(IATOG,NLEV,Label='IATOG')
  ITABS = 0
  do ISYM=1,NSYM
    do I=1,NLEV
      if (SGS%ISM(I) == ISYM) then
        ITABS = ITABS+1
        IATOG(ITABS) = I
      end if
    end do
  end do
  call MMA_ALLOCATE(TRDSGM,MXCI)
  do ITABS=1,NASHT
    ISYMT = IASYM(ITABS)
    ITLEV = IATOG(ITABS)
    do IU=1,NASH(ISYMT)
      IUABS = NAES(ISYMT)+IU
      IULEV = IATOG(IUABS)
      call GETSGM2(IULEV,ITLEV,STSYM,TRDCI,NCONF,TRDSGM,NCONF)
      SCP = DDOT_(NCONF,TRDSGM,1,TRDTMP,1)
      DTU(ITABS,IUABS) = DTU(ITABS,IUABS)+SCP
    end do
  end do
  call MMA_DEALLOCATE(TRDSGM)
  call MMA_DEALLOCATE(IATOG)
else
  OCCNUM = Two
  if (ISCF == 2) OCCNUM = One
  do ITABS=1,NASHT
    DTU(ITABS,ITABS) = DTU(ITABS,ITABS)+OCCNUM
  end do
end if
! No more need for CI array
call MMA_DEALLOCATE(TRDCI)
! No more need for the TMP state vector
call MMA_DEALLOCATE(TRDTMP)

! (4): Add the correction <0| [W1T,E(tu)] W2 |0>.
call COMMWEW(IVEC,JVEC,DTU)

end subroutine TRDACT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FRMDSC2(ARRAY,NDIM,MBLOCK,IFILE,IMZERO,I_AM_PACKED,NO_ZEROING)
! TRANSFER ARRAY FROM DISC FILE IFILE
!
! Version allowing zero and packed blocks
!
! If NO_ZEROING = 1, the elements of zero blocks
! are not set to zero, the routine just returns with
! IMZERO = 1

use lucia_data, only: IDISK
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NDIM, MBLOCK, IFILE, NO_ZEROING
real(kind=wp), intent(out) :: ARRAY(NDIM)
integer(kind=iwp), intent(out) :: IMZERO
integer(kind=iwp), intent(inout) :: I_AM_PACKED
integer(kind=iwp), parameter :: LPBLK = 50000
integer(kind=iwp) :: IBASE, IDUMMY(1), IELMNT, IPACK, IPAK(LPBLK), IREST, ISCR(2), ISTOP, LBATCH, LBATCHP, NBATCH, NBLOCK
real(kind=wp) :: XPAK(LPBLK)

IMZERO = 0

IPACK = 1
if (IPACK /= 0) then
  ! Read if ARRAY is zero
  !MMBLOCK = MBLOCK
  !if (MMBLOCK >= 2) MMBLOCK = 2
  !    IFRMDS(ISCR,2,MMBLOCK,IFILE)
  call IFRMDS(ISCR,2,2,IFILE)
  IMZERO = ISCR(1)
  I_AM_PACKED = ISCR(2)
  if (IMZERO == 1) then
    if (NO_ZEROING == 0) ARRAY(:) = Zero
    return
  end if
end if

if (I_AM_PACKED == 1) then
  ARRAY(:) = Zero
  ! Loop over packed records of dimension LPBLK
  NBATCH = 0
  !1000 continue
  ! The next LPBLK elements
  LBATCH = -2**30
  do
    NBATCH = NBATCH+1
    if (NBATCH /= 1) LBATCHP = LBATCH
    ! Read next batch
    call IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
    LBATCH = IDUMMY(1)
    if (LBATCH > 0) then
      call IDAFILE(IFILE,2,IPAK,LBATCH,IDISK(IFILE))
      call DDAFILE(IFILE,2,XPAK,LBATCH,IDISK(IFILE))
    end if
    call IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
    ISTOP = IDUMMY(1)
    do IELMNT=1,LBATCH
      if ((IPAK(IELMNT) <= 0) .or. (IPAK(IELMNT) > NDIM)) then
        write(u6,*) ' FRMDSC : Problemo IELMNT = ',IELMNT
        write(u6,*) ' IPAK(IELMNT) = ',IPAK(IELMNT)
        write(u6,*) ' LBATCH IFILE  = ',LBATCH,IFILE
        if (NBATCH == 1) then
          write(u6,*) ' NBATCH = 1'
        else
          write(u6,*) ' NBATCH, LBATCHP',NBATCH,LBATCHP
        end if
        write(u6,*) ' NDIM,IMZERO = ',NDIM,IMZERO
        !stop ' problem in FRMDSC'
        call SYSABENDMSG('lucia_util/frmdsc','Internal error','')
      end if
      ARRAY(IPAK(IELMNT)) = XPAK(IELMNT)
    end do
    if (ISTOP /= 0) exit
  end do
  ! End of loop over records of truncated elements
else if (I_AM_PACKED == 0) then
  NBLOCK = MBLOCK
  if (MBLOCK <= 0) NBLOCK = NDIM
  IREST = NDIM
  IBASE = 0
  do
    if (IREST > NBLOCK) then
      call DDAFILE(IFILE,2,ARRAY(IBASE+1),NBLOCK,IDISK(IFILE))
      IBASE = IBASE+NBLOCK
      IREST = IREST-NBLOCK
    else
      call DDAFILE(IFILE,2,ARRAY(IBASE+1),IREST,IDISK(IFILE))
      IREST = 0
    end if
    call IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
    if (IREST <= 0) exit
  end do

end if

end subroutine FRMDSC2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine PrIte(QNR,CMO,mBB,nD,Ovrlp,mBT,OccNo,mmB)
************************************************************************
*                                                                      *
*     purpose: Print out informations in every iteration               *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      use InfSO
      Implicit Real*8 (a-h,o-z)
      Real*8 CMO(mBB,nD), Ovrlp(mBT), OccNo(mmB,nD)
      Logical QNR
      Real*8 :: Shift=0.0D0
      Logical :: Set_Shift=.False.
      Save Shift, Set_Shift
*
#include "mxdm.fh"
#include "infscf.fh"
      character cEDiff, cDMOMax, cFMOMax,cDltNrm

      If(iterprlv.gt.0) Then
         Write(6,*)
         Write(6,'(a)') '*******************'
         Write(6,'(a,i3,a)') '** Iteration ',iter,' **'
         Write(6,'(a)') '*******************'
         Write(6,*)
         Write(6,'(a,f10.2)') 'Cpu time [sec]        ',CpuItr
         If(AccCon.eq.'None' .or. AccCon.eq.'NoneDa') Then
            Write(6,'(a)') 'No convergence acceleration'
         Else If(AccCon.eq.'EDIIS'.or.AccCon.eq.'ADIIS') Then
            Write(6,'(a)') 'Convergence is accelerated by damping'
         Else If(AccCon.eq.'QNRc1D') Then
            Write(6,'(2a)') 'Convergence is accelerated by QNR with ',
     &                     'c1-DIIS'
         Else If(AccCon.eq.'QNRc2D') Then
            Write(6,'(2a)') 'Convergence is accelerated by QNR with ',
     &                     'c2-DIIS'
         Else
            Write(6,'(2a)') 'Convergence accelerations is ',AccCon
         End If
         Write(6,*)
         Write(6,'(a,f16.8)') 'Total energy          ',EneV
         Write(6,'(a,f16.8)') 'One electron energy   ',E1V
         Write(6,'(a,f16.8)') 'Two electron energy   ',E2V
         If(Abs(Ediff).gt.Ethr .or. iter.le.1) Then
            Write(6,'(a,f16.8)') 'Energy difference     ',Ediff
         Else
            Write(6,'(a,f16.8,a)') 'Energy difference     ',Ediff,
     &                             ' is converged'
         End If
         If(QNR) Then
            If(DltNrm.gt.DltNth) Then
               Write(6,'(a,f16.8)') 'Delta norm            ',DltNrm
            Else
               Write(6,'(a,f16.8,a)') 'Delta norm            ',DltNrm,
     &                                ' is converged'
            End If
         Else
            If(Abs(DMOMax).gt.Dthr) Then
               Write(6,'(a,f16.8)') 'Max offdiagonal Dij   ',DMOmax
            Else
               Write(6,'(a,f16.8,a)') 'Max offdiagonal Dij   ',DMOmax,
     &                                ' is converged'
            End If
         End If
         If(Abs(FMOMax).gt.Fthr) Then
            Write(6,'(a,f16.8)') 'Max offdiagonal Fij   ',FMOmax
         Else
            Write(6,'(a,f16.8,a)') 'Max offdiagonal Fij   ',FMOmax,
     &                             ' is converged'
         End If
         Write(6,'(a,f16.8)') 'D-norm                ',Sqrt(Dnorm)
         Write(6,'(a,f16.8)') 'T-norm                ',Sqrt(Tnorm)
         If(iterprlv.ge.2) Then
            Call MulPop(CMO,mBB,nD,Ovrlp,mBT,OccNo,mmB)
         End If
      Else If(jPrint.ge.2) Then
         If (.Not.Set_Shift) Then
            If (ABS(EneV).gt.1.0D3) Then
               Shift=DBLE(INT(Abs(EneV)/1.0D3))*1.0D3
               Write(6,*)
               Write(6,'(1X,A,f10.0,A)') 'The total and one-electron'//
     &                                 ' energies are shifted'//
     &                                 ' by a value of ',Shift,' a.u.'
               Write(6,*)
            End If
            Set_Shift=.True.
         End If
         cEDiff=' '
         If (Abs(Ediff).gt.Ethr) cEDiff='*'
         cFMOMax=' '
         If (Abs(FMOMax).gt.Fthr) cFMOMax='*'
         If (QNR) Then
            cDltNrm=' '
            If (DltNrm.gt.DltNth) cDltNrm='*'
            Write(6,'(1X,i3,3f16.9,1x,3(e10.2,a1,1x),2e11.2,3x,A,f6.0)')
     &            Iter,EneV+Shift,E1V+Shift,
     &            E2V,EDiff,cEDiff,DltNrm,cDltNrm,
     &            FMOMax,cFMOMax,
     &            Sqrt(DNorm),Sqrt(TNorm),
     &            AccCon,CpuItr
         Else
            cDMOMax=' '
            If (Abs(DMOMax).gt.Dthr) cDMOMax='*'
            Write(6,'(1X,i3,3f16.9,1x,3(e10.2,a1,1x),2e11.2,3x,A,f6.0)')
     &            Iter,EneV+Shift,E1V+Shift,
     &            E2V,EDiff,cEDiff,DMOMax,cDMOMax,
     &            FMOMax,cFMOMax,
     &            Sqrt(DNorm),Sqrt(TNorm),
     &            AccCon,CpuItr

         End If
      End If

      End subroutine prite

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine WEIGHT_mclr(Z,NEL,NORB1,NORB2,NORB3,MNRS1,MXRS1,MNRS3,MXRS3,ISCR)
! construct vertex weights
!
! Reverse lexical ordering is used for restricted space

use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: Z(*), ISCR(*)
integer(kind=iwp), intent(in) :: NEL, NORB1, NORB2, NORB3, MNRS1, MXRS1, MNRS3, MXRS3
integer(kind=iwp) :: KLFREE, KLMAX, KLMIN, KW, NORB

NORB = NORB1+NORB2+NORB3

KLFREE = 1
KLMAX = KLFREE
KLFREE = KLFREE+NORB

KLMIN = KLFREE
KLFREE = KLFREE+NORB

KW = KLFREE
KLFREE = KW+(NEL+1)*(NORB+1)
! Max and min arrays for strings
call RSMXMN_MCLR(ISCR(KLMAX),ISCR(KLMIN),NORB1,NORB2,NORB3,NEL,MNRS1,MXRS1,MNRS3,MXRS3)
! Arc weights
call GRAPW(ISCR(KW),Z,ISCR(KLMIN),ISCR(KLMAX),NORB,NEL)

return

end subroutine WEIGHT_mclr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Init_RctFld(NonEq,iCharge)

use Index_Functions, only: nTri3_Elem1
use Langevin_arrays, only: Cavxyz, Davxyz, DField, Dip, DipEF, Field, Grid, PolEF, Ravxyz
use external_centers, only: iXPolType, nXF
use rctfld_module, only: lAtAto, lLangevin, lMax, MaxA, MaxB, MaxC, MM, nCavxyz, nGrid, NonEQ_Ref, PCM, RadLat, Scala, Scalb, &
                         Scalc, TK
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: NonEq
integer(kind=iwp), intent(inout) :: iCharge
integer(kind=iwp) :: mMM, nABC, nPolComp

tK = 1.0e-99_wp ! Boltzman factor, initial set to 0 K
if (allocated(MM)) return
mMM = nTri3_Elem1(lMax)
call mma_allocate(MM,mMM,2,Label='MM')
MM(:,:) = Zero
if (iXPolType > 0) nGrid = nXF
if (lLangevin .or. (iXPolType > 0)) then
  if (lLangevin) then
    maxa = int(radlat/scala)
    maxb = int(radlat/scalb)
    maxc = int(radlat/scalc)
    nabc = (2*maxa+2)*(2*maxb+2)*(2*maxc+2)
    nGrid = nGrid+nabc*latato
  end if
  if (iXPolType == 2) then
    nPolComp = 6
  else
    nPolComp = 1
  end if
  call mma_allocate(Field,4,nGrid,Label='Field')
  call mma_allocate(dField,4,nGrid,Label='dField')
  call mma_allocate(Dip,3,nGrid,Label='Dip')
  call mma_allocate(PolEf,nPolComp,nGrid,Label='PolEf')
  call mma_allocate(DipEf,nGrid,Label='DipEf')
  call mma_allocate(Grid,3,nGrid,Label='Grid')

  nCavxyz = mMM
  call mma_allocate(davxyz,nCavxyz,Label='davxyz')
  call mma_allocate(cavxyz,nCavxyz,Label='cavxyz')
  call mma_allocate(ravxyz,nCavxyz,Label='ravxyz')
end if
if (.not. PCM) NonEq_Ref = NonEq
call Init_PCM(NonEq,iCharge)

return

end subroutine Init_RctFld

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ANNSTR_GAS( STRING, NSTINI, NSTINO,    NEL,   NORB,
     &                       IORBOF,      Z, NEWORD, LSGSTR, ISGSTI,
     &                       ISGSTO,     TI,    TTO,  NACOB,    IEC,
     &                         LDIM,  IPRNT)
*
* A group of strings containing NEL electrons is given
* Set up all possible ways of removing an electron
*
*========
* Input :
*========
* STRING : Input strings containing NEL electrons
* NSTINI : Number of input  strings
* NSTINO : Number of output strings
* NEL    : Number of electrons in input strings
* NORB   : Number of orbitals
* IORBOF : Number of first orbital
* Z      : Lexical ordering matrix for output strings containing
*          NEL - 1 electrons
* NEWORD : Reordering array for N-1 strings
* LSGSTR : .NE.0 => Include sign arrays ISGSTI,ISGSTO of strings
* ISGSTI : Sign array for NEL   strings
* ISGSTO : Sign array for NEL-1 strings
* IEC    : = 1 Extended map, dimension equals number of orbs
* IEC    : = 2 Compact  map, dimension equals number of elecs
* LDIM   : Row dimension ( see IEC)
*
*=========
* Output :
*=========
*
*TI      : TI(I,ISTRIN) .gt. 0 indicates that orbital I can be added
*          to string ISTRIN .
*TTO     : Resulting NEL + 1 strings
*          if the string have a negative sign
*          then the phase equals - 1
      IMPLICIT REAL*8           (A-H,O-Z)
      INTEGER STRING,TI,TTO,STRIN2,Z
*.Input
      DIMENSION STRING(NEL,NSTINI),NEWORD(NSTINO),Z(NORB,NEL+1)
      DIMENSION ISGSTI(NSTINI),ISGSTO(NSTINO)
*.Output
      DIMENSION TI(LDIM,NSTINI),TTO(LDIM,NSTINI)
*.Scratch
      DIMENSION STRIN2(500)
*
      NTEST0 =  1
      NTEST = MAX(IPRNT,NTEST0)
      IF( NTEST .GE. 20 ) THEN
        WRITE(6,*)  ' =============== '
        WRITE(6,*)  ' ANNSTR speaking '
        WRITE(6,*)  ' =============== '
        WRITE(6,*)
         WRITE(6,*) ' Number of input electrons ', NEL
      END IF
*
      DO 1000 ISTRIN = 1,NSTINI
        DO 100 IEL = 1, NEL
*. String with electron removed
          DO JEL = 1, IEL-1
           STRIN2(JEL) = STRING(JEL,ISTRIN)
          END DO
          DO JEL = IEL+1, NEL
           STRIN2(JEL-1) = STRING(JEL,ISTRIN)
          END DO
          JSTRIN = ISTRNM(STRIN2,NACOB,NEL-1,Z,NEWORD,1)
C?        WRITE(6,*) ' anni-string and number '
C?        CALL IWRTMA(STRIN2,1,NEL-1,1,NEL-1)
C?        WRITE(6,*) ' JSTRIN = ', JSTRIN
*
          IORBABS = STRING(IEL,ISTRIN)
          IORB = STRING(IEL,ISTRIN)-IORBOF+1
          IF(IEC.EQ.1) THEN
            IROW = IORB
          ELSE
            IROW = IEL
          END IF
*
          TI(IROW,ISTRIN ) = -IORBABS
C         TI(IROW,ISTRIN ) = -IORB
          TTO(IROW,ISTRIN) = JSTRIN
*PAM2009          IIISGN = (-1)**(IEL-1)
          IIISGN = 1-2*MOD(IEL+1,2)
          IF(LSGSTR.NE.0)
     &    IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
          IF(IIISGN .EQ. -1 )
     &    TTO(IROW,ISTRIN) = - TTO(IROW,ISTRIN)
  100   CONTINUE
*
 1000 CONTINUE
*
      IF ( NTEST .GE. 20) THEN
        MAXPR = 60
        NPR = MIN(NSTINI,MAXPR)
        WRITE(6,*) ' Output from ANNSTR : '
        WRITE(6,*) '==================='
*
        WRITE(6,*)
        WRITE(6,*) ' Strings with an electron added or removed'
        DO ISTRIN = 1, NPR
           WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &     'String..',ISTRIN,' New strings.. ',
     &     (TTO(I,ISTRIN),I = 1,LDIM)
        END DO
        DO ISTRIN = 1, NPR
           WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &     'String..',ISTRIN,' orbitals added or removed ' ,
     &     (TI(I,ISTRIN),I = 1,LDIM)
        END DO
      END IF
*
      RETURN
      END
*
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_X_CompVec(irc,
     &                         NVT,l_NVT,
     &                         nBlock,l_nBlock,
     &                         nV,l_nV1,l_nV2,
     &                         iV1,l_iV11,l_iV12,
     &                         ip_Z,l_Z1,l_Z2,
     &                         Free_Z)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: Compute Cholesky vectors from Z vectors in core
C              and integrals computed on the fly:
C
C              L(uv,J) = 1/Z(J,J)
C                      * [ (uv|J) - sum[K=1,J-1] L(uv,K)*Z(J,K) ]
C
C     NVT(i): total number of Cholesky vectors (all nodes), sym. i
C     nBlock(i): number of vector blocks, sym. i
C     nV(i,j): number of vectors in block i of sym. j
C     iV1(i,j): index of first vector in block i of sym. j
C     ip_Z(i,j): pointer to Z block i of sym. j
C
C     If (Free_Z): Z array will be de-allocated here using ip_Z(1,1) as
C     start point of the array - i.e. assuming that the Z blocks are
C     stored as one coherent array. If this is not the case, simply put
C     Free_Z=.False. Letting this routine deallocate Z maximizes the
C     memory available for vector distribution.
C
C     Vectors are distributed across nodes and stored according to
C     reduced set 1 (all of them!).
C
      Implicit None
      Integer irc
      Integer l_NVT
      Integer l_nBlock
      Integer l_nV1, l_nV2
      Integer l_iV11, l_iV12
      Integer l_Z1, l_Z2
      Integer NVT(l_NVT)
      Integer nBlock(l_nBlock)
      Integer nV(l_NV1,l_NV2)
      Integer iV1(l_IV11,l_iV12)
      Integer ip_Z(l_Z1,l_Z2)
      Logical Free_Z
#include "cholesky.fh"
#include "choptr.fh"
#include "chosew.fh"
#include "WrkSpc.fh"
#include "choprint.fh"

      Character*2  Unt
      Character*13 SecNam
      Parameter (SecNam='Cho_X_CompVec')

      Integer N2
      Parameter (N2=InfVec_N2)

      Logical  Cho_Rsv_Tsk
      External Cho_Rsv_Tsk

      Integer  Cho_F2SP
      External Cho_F2SP

#if defined (_DEBUGPRINT_)
      Integer nBlock_Max, nnB
      Integer nTot, nTot2
      Integer myDebugInfo
      Parameter (myDebugInfo=100)
      Real*8  Tol
      Parameter (Tol=1.0d-14)
#endif

      Integer iAdr(8)
      Integer iSym, n
      Integer iSP_, iSP_1, iSP_2, iSp, nSP, nSP_Max, nSP_this_batch
      Integer ip_Int, l_Int
      Integer kOff, kOffI, kOffZ
      Integer jBlock, kBlock
      Integer J_inBlock, K_inBlock
      Integer kI, kL, kZ
      Integer ldL, ldZ
      Integer ip_Wrk, l_Wrk
      Integer ip_iQuAB_SAVE, l_iQuAB_SAVE
      Integer MaxQual_SAVE
      Integer ip_InfVec_T
      Integer ip_Zd, l_Zd, incZd
      Integer kZd
      Integer ip_Tmp, l_Tmp
      Integer ip_ListSP, l_ListSP
      Integer iCountSP
      Integer lTot, Left
      Integer ip_BatchDim, l_BatchDim, nBatch

      Real*8 C0, C1, W0, W1
      Real*8 X0, X1, Y0, Y1
      Real*8 Byte, PMem, PDone
      Real*8 TotMem, TotCPU, TotWall

      Integer i, j, k
      Integer IndRSh, iTri, nnBstRSh, InfVcT
#if defined (_DEBUGPRINT_)
      Integer iSP2F
      iSP2F(i)=iWork(ip_iSP2F-1+i)
#endif
      IndRSh(i)=iWork(ip_IndRSh-1+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
      nnBStRSh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      InfVcT(i,j,k)=iWork(ip_InfVec_T-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)

      ! Init return code
      irc=0

#if defined (_DEBUGPRINT_)
      ! Check input
      If (l_NVT.lt.nSym .or. l_nBlock.lt.nSym .or.
     &    l_nV2.lt.nSym .or. l_iV12.lt.nSym .or.
     &    l_Z2.lt.nSym) Then
         irc=-2
         Return
      End If
      nBlock_Max=nBlock(1)
      Do iSym=2,nSym
         nBlock_Max=max(nBlock_Max,nBlock(iSym))
      End Do
      nnB=nBlock_Max*(nBlock_Max+1)/2
      If (l_nV1.lt.nBlock_Max .or. l_iV11.lt.nBlock_Max .or.
     &    l_Z1.lt.nnB) Then
         irc=-1
         Return
      End If
#endif

      ! Parallel runs: open tmp vector files
      Call Cho_XCV_TmpFiles(irc,1)
      If (irc .ne. 0) Then
         Write(LuPri,'(A,A,I8,A)')
     &   SecNam,': [1] Error in Cho_XCV_TmpFiles! (Return code:',irc,')'
         irc=1
         Return
      End If

      ! Get pointer to InfVec array for all vectors
      Call Cho_X_GetIP_InfVec(ip_InfVec_T)

      ! Copy reduced set 1 to location 2.
      ! I.e. make rs1 the "current" reduced set.
      Call Cho_X_RSCopy(irc,1,2)
      If (irc .ne. 0) Then
         Write(LuPri,'(A,A,I8,A)')
     &   SecNam,': Error in Cho_X_RSCopy! (Return code:',irc,')'
         irc=1
         Return
      End If

      ! Allocate tmp array to keep track of which shell pairs are
      ! computed on this node.
      l_Tmp=nnShl
      Call GetMem('XCVTMP','Allo','Inte',ip_Tmp,l_Tmp)

      ! Allocate and set list of parent shell pairs to compute
      ! NOTE: the tmp array allocated above is used here!!!
      Call iZero(iWork(ip_Tmp),nnShl)
      nSP=0
      Do iSym=1,nSym
         Do J=1,NVT(iSym)
            iSP=Cho_F2SP(IndRSh(InfVcT(J,1,iSym))) ! Parent SP
            If (iSP.gt.0 .and. iSP.le.nnShl) Then
               If (iWork(ip_Tmp-1+iSP) .eq. 0) Then
                  nSP=nSP+1
               End If
               iWork(ip_Tmp-1+iSP)=iWork(ip_Tmp-1+iSP)+1
            Else
               Call Cho_Quit(SecNam//': Parent SP error!!',103)
            End If
         End Do
      End Do
      l_ListSP=nSP
      Call GetMem('XCVLSP','Allo','Inte',ip_ListSP,l_ListSP)
      nSP=0
      Do iSP=0,nnShl-1
         If (iWork(ip_Tmp+iSP).gt.0) Then
            iWork(ip_ListSP+nSP)=iSP+1
            nSP=nSP+1
         End If
      End Do
#if defined (_DEBUGPRINT_)
      If (nSP.ne.l_ListSP) Then
         Call Cho_Quit('SP counting error [1] in '//SecNam,103)
      End If
      nTot=NVT(1)
      Do iSym=2,nSym
         nTot=nTot+NVT(iSym)
      End Do
      nTot2=0
      Do i=0,nSP-1
         nTot2=nTot2+iWork(ip_Tmp-1+iWork(ip_ListSP+i))
      End Do
      If (iPrint.ge.myDebugInfo) Then
         Call Cho_Head('Shell pair info from '//SecNam,'*',80,LuPri)
         Write(LuPri,'(/,A,I8,/)')
     &   'Number of shell pairs giving rise to vectors:',nSP
         Do i=0,nSP-1
            iSP=iWork(ip_ListSP+i)
            Call Cho_InvPck(iSP2F(iSP),j,k,.True.)
            Write(Lupri,'(A,I8,A,I4,A,I4,A,I8,A)')
     &      'Shell pair',iSP,' (shells',j,',',k,
     &      ') gives rise to',iWork(ip_Tmp-1+iSP),
     &      ' vectors'
         End Do
         Write(LuPri,'(A,I8,/,A,I8,/,A,I8)')
     &   'Total number of vectors (from SP).................',nTot2,
     &   'Total number of vectors (from NVT)................',nTot,
     &   'Difference........................................',nTot2-nTot
      End If
      If (nTot.ne.nTot2) Then
         Call Cho_Quit('SP counting error [2] in '//SecNam,103)
      End If
#endif

      ! Re-allocate and set qualification arrays
      ip_iQuAB_SAVE=ip_iQuAB
      l_iQuAB_SAVE=l_iQuAB
      MaxQual_SAVE=MaxQual
      MaxQual=NVT(1)
      Do iSym=2,nSym
         MaxQual=max(MaxQual,NVT(iSym))
      End Do
      l_iQuAB=MaxQual*nSym
      Call GetMem('XCViQ2','Allo','Inte',ip_iQuAB,l_iQuAB)
      Do iSym=1,nSym
         nQual(iSym)=NVT(iSym)
         kOff=ip_iQuAB-1+MaxQual*(iSym-1)
         Do J=1,nQual(iSym)
            iWork(kOff+J)=InfVcT(J,1,iSym) ! parent product for vector J
         End Do
      End Do

      ! Modify diagonal of Z matrix
      ! Z(J,J) <- 1/Z(J,J)
      ! If Z memory should not be de-allocated, save a backup of the
      ! diagonal.
      If (Free_Z) Then
         l_Zd=1
         incZd=0
      Else
         l_Zd=NVT(1)
         Do iSym=2,nSym
            l_Zd=l_Zd+NVT(iSym)
         End Do
         incZd=1
      End If
      Call GetMem('XCVZd','Allo','Real',ip_Zd,l_Zd)
      kZd=ip_Zd
      Do iSym=1,nSym
         Do jBlock=1,nBlock(iSym)
            kOffZ=ip_Z(iTri(jBlock,jBlock),iSym)-1
            Do J_inBlock=1,nV(jBlock,iSym)
#if defined (_DEBUGPRINT_)
               ! Check for division by zero or negative diagonal
               ! This would be a bug....
               If (abs(Work(kOffZ+iTri(J_inBlock,J_inBlock))).lt.Tol
     &             .or. Work(kOffZ+iTri(J_inBlock,J_inBlock)).lt.-Tol)
     &         Then
                  Write(LuPri,'(//,A,A)') SecNam,': Ooooops!'
                  Write(LuPri,'(A)')
     &            '....division by small or negative number....'
                  Write(LuPri,'(A,I8)') 'iSym=',iSym
                  Write(LuPri,'(A,I8)') 'jBlock=',jBlock
                  Write(LuPri,'(A,I8)') 'J=',
     &            iV1(jBlock,iSym)+J_inBlock-1
                  Write(LuPri,'(A,1P,D15.6)')
     &            'Z(J,J)=',Work(kOffZ+iTri(J_inBlock,J_inBlock))
                  Write(LuPri,'(A,1P,D15.6)')
     &            'Tolerance=',Tol
                  Call Cho_Quit(
     &            'Division by small or negative number in '//SecNam,
     &            103)
               End If
#endif
               Work(kZd)=Work(kOffZ+iTri(J_inBlock,J_inBlock))
               Work(kOffZ+iTri(J_inBlock,J_inBlock))=1.0d0/Work(kZd)
               kZd=kZd+incZd
            End Do
         End Do
      End Do

      ! Distribute shell pairs across nodes according to dimension
      ! (helps load balance the linear algebra part below)
      Call Cho_XCV_Distrib_SP(iWork(ip_Tmp),l_Tmp,iCountSP)

      ! Allocate batch dimension array
      l_BatchDim=max(iCountSP,1)
      Call GetMem('XCVnBt','Allo','Inte',ip_BatchDim,l_BatchDim)

      ! Allocate offset array for batched SP loop
      l_iOff_Batch=nSym*nnShl
      Call GetMem('XCVOFB','Allo','Inte',ip_iOff_Batch,l_iOff_Batch)

      ! Split remaining memory in two parts.
      ! One for integrals/vectors, one for Seward.
      Call GetMem('XCVMx1','Max ','Real',ip_Wrk,l_Wrk)
      If (l_Wrk.lt.3) Then
         Call Cho_Quit('Insufficient memory in '//SecNam,101)
      End If
      l_Int=INT(DBLE(l_Wrk)*2.0d0/3.0d0)
      Call GetMem('XCVInt','Allo','Real',ip_Int,l_Int)
      Call GetMem('XCVMx2','Max ','Real',ip_Wrk,l_Wrk)
      Call xSetMem_Ints(l_Wrk)

      ! Print
      If (iPrint.ge.Inf_Pass) Then
         Call Cho_Head('Generation of Cholesky vectors','=',80,LuPri)
         Call Cho_Word2Byte(l_Int,8,Byte,Unt)
         Write(LuPri,'(/,A,I12,A,F10.3,1X,A,A)')
     &   'Memory available for integrals/vectors..',l_Int,' (',Byte,Unt,
     &   ')'
         Call Cho_Word2Byte(l_Wrk,8,Byte,Unt)
         Write(LuPri,'(A,I12,A,F10.3,1X,A,A)')
     &   'Memory available for Seward.............',l_Wrk,' (',Byte,Unt,
     &   ')'
         Write(LuPri,'(A,I12)')
     &   'Number of shell pairs, total (nnShl)....',nnShl
         Write(LuPri,'(A,I12)')
     &   'Number of shell pairs, this node........',iCountSP
         Write(LuPri,'(//,65X,A)') 'Time/min'
         Write(LuPri,'(1X,A,5X,A,5X,A,2X,A,10X,A,16X,A,6X,A)')
     &   'Batch','iSP1','iSP2','%Done','Memory','CPU','Wall'
         Write(LuPri,'(A,A)')
     &   '------------------------------------------------------------',
     &   '----------------'
         Call Cho_Flush(LuPri)
         TotMem=0.0d0
         TotCPU=0.0d0
         TotWall=0.0d0
      End If

      ! Compute Cholesky vectors in batched loop over shell pairs
      Call iZero(iAdr,nSym) ! disk addresses
      iSP_1=1
      nBatch=0
      Do While (iSP_1.le.iCountSP)
         If (iPrint.ge.Inf_Pass) Then
            Call Cho_Timer(X0,Y0)
         End If
         ! Set batch info
         Left=l_Int
         nSP_Max=iCountSP-iSP_1+1
         nSP_this_batch=0
         Do While (Left.gt.0 .and. nSP_this_batch.lt.nSP_Max)
            iSP=iSP_1+nSP_this_batch
            n=nnBstRSh(1,iWork(ip_Tmp-1+iSP),2)*NVT(1)
            Do iSym=2,nSym
               n=n+nnBstRSh(iSym,iWork(ip_Tmp-1+iSP),2)*NVT(iSym)
            End Do
            If (n.le.Left) Then
               Left=Left-n
               nSP_this_batch=nSP_this_batch+1
            Else
               Left=0 ! break while loop
            End If
         End Do
         If (nSP_this_batch.lt.1) Then
            Call Cho_Quit(
     &         SecNam//': Insufficient memory for shell pair batch',101)
         End If
         iSP_2=iSP_1+nSP_this_batch-1
         Do iSym=1,nSym
            nDim_Batch(iSym)=0
            Do iSP_=iSP_1,iSP_2
               iSP=iWork(ip_Tmp-1+iSP_)
               iWork(ip_iOff_Batch-1+nSym*(iSP-1)+iSym)=nDim_Batch(iSym)
               nDim_Batch(iSym)=nDim_Batch(iSym)+nnBstRSh(iSym,iSP,2)
            End Do
         End Do
         ! Calculate integrals (uv|J) for uv in shell pair batch and
         ! for all J (shell pairs that give rise to vectors are
         ! listed in ListSP).
         Call Cho_XCV_GetInt(irc,iWork(ip_Tmp-1+iSP_1),nSP_this_batch,
     &                       iWork(ip_ListSP),l_ListSP,
     &                       NVT,l_NVT,Work(ip_Int),l_Int)
         If (irc .ne. 0) Then
            Write(LuPri,'(A,A,I8)')
     &      SecNam,': Cho_XCV_GetInt returned code',irc
            Call Cho_Quit(SecNam//': Error in Cho_XCV_GetInt',104)
         End If
         ! Convert integrals into Cholesky vectors in each symmetry
         Call Cho_Timer(C0,W0)
         kOffI=ip_Int
         Do iSym=1,nSym
            ldL=max(nDim_Batch(iSym),1)
            Do jBlock=1,nBlock(iSym)
               kOffZ=ip_Z(iTri(jBlock,jBlock),iSym)-1
               Do J_inBlock=1,nV(jBlock,iSym)
                  ! Convert integral column into Cholesky vector
                  ! L(uv,J)=(uv|J)/Z(J,J)
                  ! Note that the inverse was taken before the integral
                  ! loop - i.e. Z(J,J) <- 1/Z(J,J)
                  J=iV1(jBlock,iSym)+J_inBlock-1
                  kL=kOffI+nDim_Batch(iSym)*(J-1)
                  Call dScal_(nDim_Batch(iSym),
     &                       Work(kOffZ+iTri(J_inBlock,J_inBlock)),
     &                       Work(kL),1)
                  ! Subtract from subsequent columns in current block
                  ! using BLAS1
                  ! (uv|K) <- (uv|K) - L(uv,J)*Z(K,J), K>J (in jBlock)
                  Do K_inBlock=J_inBlock+1,nV(jBlock,iSym)
                     K=iV1(jBlock,iSym)+K_inBlock-1
                     Call dAXPY_(nDim_Batch(iSym),
     &                    -Work(kOffZ+iTri(K_inBlock,J_inBlock)),
     &                    Work(kL),1,
     &                    Work(kOffI+nDim_Batch(iSym)*(K-1)),1)
                  End Do
               End Do
               ! Subtract from subsequent blocks using BLAS3
               ! (uv|K) <- (uv|K) - sum[J] L(uv,J)*Z(K,J),
               ! K>J (K in kBlock>jBlock containing J)
               kL=kOffI+nDim_Batch(iSym)*(iV1(jBlock,iSym)-1)
               Do kBlock=jBlock+1,nBlock(iSym)
                  kI=kOffI+nDim_Batch(iSym)*(iV1(kBlock,iSym)-1)
                  kZ=ip_Z(iTri(kBlock,jBlock),iSym)
                  ldZ=max(nV(kBlock,iSym),1)
                  Call dGeMM_('N','T',
     &                        nDim_Batch(iSym),nV(kBlock,iSym),
     &                        nV(jBlock,iSym),
     &                        -1.0d0,Work(kL),ldL,Work(kZ),ldZ,
     &                        1.0d0,Work(kI),ldL)
               End Do
            End Do
            nDGM_Call=nDGM_Call+nBlock(iSym)*(nBlock(iSym)-1)/2
            kOffI=kOffI+nDim_Batch(iSym)*NVT(iSym)
         End Do
         Call Cho_Timer(C1,W1)
         tDecom(1,3)=tDecom(1,3)+(C1-C0)
         tDecom(2,3)=tDecom(2,3)+(W1-W0)
         ! Write vectors to temp files
         Call Cho_Timer(C0,W0)
         kL=ip_Int
         Do iSym=1,nSym
            lTot=nDim_Batch(iSym)*NVT(iSym)
            If (lTot.gt.0) Then
               Call DDAFile(LuTmp(iSym),1,Work(kL),lTot,iAdr(iSym))
               kL=kL+lTot
            End If
         End Do
         Call Cho_Timer(C1,W1)
         tDecom(1,2)=tDecom(1,2)+(C1-C0)
         tDecom(2,2)=tDecom(2,2)+(W1-W0)
         ! Print
         If (iPrint.ge.Inf_Pass) Then
            Call Cho_Timer(X1,Y1)
            PDone=1.0d2*DBLE(iSP_2)/DBLE(iCountSP)
            lTot=nDim_Batch(1)*NVT(1)
            Do iSym=2,nSym
               lTot=lTot+nDim_Batch(iSym)*NVT(iSym)
            End Do
            Call Cho_Word2Byte(lTot,8,Byte,Unt)
            PMem=1.0d2*DBLE(lTot)/DBLE(l_Int)
            Write(LuPri,
     &'(I6,1X,I8,1X,I8,1X,F6.1,1X,F10.3,1X,A,A,F7.2,A,1X,F9.2,1X,F9.2)')
     &      nBatch+1,iSP_1,iSP_2,PDone,Byte,Unt,' (',PMem,'%)',
     &      (X1-X0)/6.0d1,(Y1-Y0)/6.0d1
            Call Cho_Flush(LuPri)
            TotMem=TotMem+DBLE(lTot)
            TotCPU=TotCPU+(X1-X0)/6.0d1
            TotWall=TotWall+(Y1-Y0)/6.0d1
         End If
         ! Update counters and save batch dimension
         iSP_1=iSP_1+nSP_this_batch
         iWork(ip_BatchDim+nBatch)=nSP_this_batch
         nBatch=nBatch+1
      End Do
      If (iPrint.ge.Inf_Pass) Then
         Write(LuPri,'(A,A)')
     &   '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ',
     &   '- - - - - - - - '
         Call Cho_RWord2Byte(TotMem,Byte,Unt)
         Write(LuPri,'(32X,F10.3,1X,A,12X,F9.2,1X,F9.2)')
     &   Byte,Unt,TotCPU,TotWall
         Write(LuPri,'(A,A)')
     &   '------------------------------------------------------------',
     &   '----------------'
         Call Cho_Flush(LuPri)
      End If

      ! De-allocate Z matrix or reconstruct diagonal of Z matrix
      ! Z(J,J) <- 1/Z(J,J)
      If (Free_Z) Then
         lTot=NVT(1)*(NVT(1)+1)/2
         Do iSym=2,nSym
            lTot=lTot+NVT(iSym)*(NVT(iSym)+1)/2
         End Do
         Call GetMem('XCVFZ','Free','Real',ip_Z(1,1),lTot)
      Else
         kZd=ip_Zd-1
         Do iSym=1,nSym
            Do jBlock=1,nBlock(iSym)
               kOffZ=ip_Z(iTri(jBlock,jBlock),iSym)-1
               Do J_inBlock=1,nV(jBlock,iSym)
                  J=iV1(jBlock,iSym)+J_inBlock-1
                  Work(kOffZ+iTri(J_inBlock,J_inBlock))=Work(kZd+J)
               End Do
            End Do
            kZd=kZd+NVT(iSym)
         End Do
      End If

      ! Deallocations
      Call xRlsMem_Ints()
      Call GetMem('XCVInt','Free','Real',ip_Int,l_Int)
      Call GetMem('XCVOFB','Free','Inte',ip_iOff_Batch,l_iOff_Batch)
      l_iOff_Batch=0
      Call GetMem('XCVZd','Free','Real',ip_Zd,l_Zd)
      Call GetMem('XCViQ2','Free','Inte',ip_iQuAB,l_iQuAB)
      Call GetMem('XCVLSP','Free','Inte',ip_ListSP,l_ListSP)

      ! Reset qualification array pointers and MaxQual
      ip_iQuAB=ip_iQuAB_SAVE
      l_iQuAB=l_iQuAB_SAVE
      MaxQual=MaxQual_SAVE

      ! Parallel runs: distribute vectors across nodes (store on files)
      ! Serial runs: write vectors to permanent files
      Call Cho_Timer(C0,W0)
      Call Cho_XCV_DistributeVectors(irc,iWork(ip_BatchDim),nBatch,
     &                               iWork(ip_Tmp),iCountSP,NVT,l_NVT)
      If (irc .ne. 0) Then
         Write(LuPri,'(A,A,I8)')
     &   SecNam,': Cho_XCV_DistributeVectors returned code',irc
         Call Cho_Quit(SecNam//': Error in Cho_XCV_DistributeVectors',
     &                 104)
      End If
      Call Cho_Timer(C1,W1)
      tDecom(1,2)=tDecom(1,2)+(C1-C0)
      tDecom(2,2)=tDecom(2,2)+(W1-W0)

      ! Deallocations
      Call GetMem('XCVnBt','Free','Inte',ip_BatchDim,l_BatchDim)
      Call GetMem('XCVTMP','Free','Inte',ip_Tmp,l_Tmp)

      ! Parallel runs: close and erase tmp vector files
      Call Cho_XCV_TmpFiles(irc,3)
      If (irc .ne. 0) Then
         Write(LuPri,'(A,A,I8,A)')
     &   SecNam,': [3] Error in Cho_XCV_TmpFiles! (Return code:',irc,')'
         Call Cho_Quit(SecNam//': Error in Cho_XCV_TmpFiles',104)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C TMP FILE HANDLERS (OPEN, CLOSE, DELETE)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SubRoutine Cho_XCV_TmpFiles(irc,iOpt)
      Implicit None
      Integer irc, iOpt
      irc=0
      If (iOpt.eq.1) Then
         Call Cho_XCV_OpenTmpFiles()
      Else If (iOpt.eq.2) Then
         Call Cho_XCV_CloseAndKeepTmpFiles()
      Else If (iOpt.eq.3) Then
         Call Cho_XCV_CloseAndEraseTmpFiles()
      Else
         irc=1
         Return
      End If
      End
      SubRoutine Cho_XCV_OpenTmpFiles()
      Implicit None
#include "cholesky.fh"
      Integer iSym
      Character*6 Filename
      Do iSym=1,nSym
         LuTmp(iSym)=7
         Write(Filename,'(A4,I2.2)') 'VTMP',iSym
         Call DAName_MF_WA(LuTmp(iSym),Filename)
      End Do
      End
      SubRoutine Cho_XCV_CloseAndKeepTmpFiles()
      Implicit None
#include "cholesky.fh"
      Integer iSym
      Do iSym=1,nSym
         If (LuTmp(iSym).gt.0) Then
            Call DAClos(LuTmp(iSym))
            LuTmp(iSym)=0
         End If
      End Do
      End
      SubRoutine Cho_XCV_CloseAndEraseTmpFiles()
      Implicit None
#include "cholesky.fh"
      Integer iSym
      Do iSym=1,nSym
         If (LuTmp(iSym).gt.0) Then
            Call DAEras(LuTmp(iSym))
            LuTmp(iSym)=0
         End If
      End Do
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine OAMMem(nHer,MemOAM,la,lb,lr)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      Call MltMmP(nOrder,MemOAM,la,lb+1,lr-1)
      nHer = nOrder
      If (lb.gt.0) Then
         Call MltMmP(nOrder,MmMltP,la,lb-1,lr-1)
         MemOAM = Max(MemOAM,MmMltP) + nElem(la)*nElem(lb-1)*3
      End If
      MemOAM = MemOAM + 1 + nElem(la)*nElem(lb+1)*3
      MemOAM = MemOAM + nElem(la)*nElem(lb)*3
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1992,1995, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine ElGrddot( &
#                   define _CALLING_
#                   include "1eldot_mck_interface.fh"
                   )
!***********************************************************************
!                                                                      *
! Object: to compute the multipole moments integrals with the          *
!         Gauss-Hermite quadrature.                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!             Modified to multipole moments November '90               *
!                                                                      *
!             Modified to reaction field calculations July '92         *
!             Modified to gradient calculations May '95                *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Her_RW, only: HerR, HerW, iHerR, iHerW
use Center_Info, only: dc
use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
#include "1eldot_mck_interface.fh"
integer(kind=iwp) :: iBeta, ip, ipAlph, ipAxyz, ipBeta, ipBxyz, ipFinal, ipRnxyz, ipRxyz, ipTemp1, ipTemp2, ipTemp3, ncomp, nip
logical(kind=iwp) :: ABeq(3)

ABeq(1) = A(1) == B(1)
ABeq(2) = A(2) == B(2)
ABeq(3) = A(3) == B(3)

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+2)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+2)
ipRxyz = nip
nip = nip+nZeta*3*nHer*(nOrdOp+1)
ipRnxyz = nip
nip = nip+nZeta*3*(la+2)*(lb+2)*(nOrdOp+1)
ipTemp1 = nip
nip = nip+nZeta
ipTemp2 = nip
nip = nip+nZeta
ipTemp3 = nip
nip = nip+3*nZeta*nHer
ipAlph = nip
nip = nip+nZeta
ipBeta = nip
nip = nip+nZeta
ipFinal = nip
nip = nip+nzeta*nTri_Elem1(la)*nTri_Elem1(lb)*4*6
if (nip-1 > nArr*nZeta) then
  write(u6,*) ' nArr is Wrong! ',nip-1,' > ',nArr*nZeta
  call ErrTra()
  write(u6,*) ' Abend in ElGrddot'
  call Abend()
end if

! Compute the cartesian values of the basis functions angular part

Array(ipTemp1:ipTemp1+nZeta-1) = Zeta**(-Half)

call vCrtCmp(Array(ipTemp1),P,nZeta,A,Array(ipAxyz),la+1,HerR(iHerR(nHer)),nHer,ABeq)
call vCrtCmp(Array(ipTemp1),P,nZeta,B,Array(ipBxyz),lb+1,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the contribution from the multipole moment operator

ABeq(1) = .false.
ABeq(2) = .false.
ABeq(3) = .false.
call vCrtCmp(Array(ipTemp1),P,nZeta,Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the cartesian components for the multipole moment
! integrals. The integrals are factorized into components.

call vAssmbl(Array(ipRnxyz),Array(ipAxyz),la+1,Array(ipRxyz),nOrdOp,Array(ipBxyz),lb+1,nZeta,HerW(iHerW(nHer)),nHer,Array(ipTemp3))

! Combine the cartesian components to the full one electron integral.

ip = ipAlph
do iBeta=1,nBeta
  Array(ip:ip+nAlpha-1) = Alpha
  ip = ip+nAlpha
end do
ip = ipBeta
do iBeta=1,nBeta
  Array(ip:ip+nAlpha-1) = Beta(iBeta)
  ip = ip+nAlpha
end do
ncomp = 4
call Cmbneldot(Array(ipRnxyz),nZeta,la,lb,nOrdOp,Zeta,rKappa,Array(ipFinal),ncomp,Array(ipTemp1),Array(ipTemp2),Array(ipAlph), &
               Array(ipBeta),DAO,dc(mdc)%nStab,dc(ndc)%nStab,nOp,rout,indgrd)

return

end subroutine ElGrddot

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Giovanni Ghigo                                   *
************************************************************************
       Subroutine ZMatrixConverter_GW(LuRd,LuWr,LuOut,nAskAtoms,iErr)
************************************************************************
* Author: Giovanni Ghigo                                               *
*         Torino (Italy)  October-November 2006                        *
*                                                                      *
* This is an adaptation of Subroutine ZMatrixConverter for GateWay     *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "constants.fh"
#include "g_zmatconv.fh"

      nAtoms = 0
      nBase  = 0
      Do i = 1, Num_Elem
        Base(i)   = ' '
        BasAva(i) = .False.
        BasReq(i) = .False.
      EndDo
      Do i = 1, MaxAtoms
        Coords(i,1) = 0.0d0
        Coords(i,2) = 0.0d0
        Coords(i,3) = 0.0d0
      EndDo
      nBasis = 0
      iErr   = 0

* Reading input
      iErr = 0
      Call ZMatReader(LuRd,LuWr,nAtoms,nXAtoms,nBasis,nAskAtoms,iErr)
      If (iErr.NE.0) GoTo 9906
      Write(LuOut,*) nAtoms
      Write(LuOut,'(A)') 'Angstrom'

* Some checks
      If (nAtoms.EQ.0) then
        Write(LuWr,*) 'ERROR: No atom coordinates specified !'
        GoTo 9999
      EndIf

      Call Put_iScalar('N ZMAT',nAtoms+nXAtoms)
      Call Put_cArray('Symbol ZMAT',Symbols(1),(nAtoms+nXAtoms)*5)
      Call Put_iArray('Index ZMAT',iZmat,MaxAtoms*3)
      Call Put_iArray('NAT ZMAT',NAT,nAtoms+nXAtoms)

* Calculate coordinates
      torad = CONST_PI_ / 180.0d0
*     Atom #1
      If (nAtoms+nXAtoms.EQ.1) GoTo 2000
*     Atom #2
      Coords(2,3)=Zmat(2,1)  ! Z(2)=R
      If (nAtoms+nXAtoms.EQ.2) GoTo 2000
*     Atom #3
      If (iZmat(3,1).EQ.1) then
        Coords(3,1)=Zmat(3,1)*SIN(Zmat(3,2)*torad) ! X(2)=R sin(A)
        Coords(3,3)=Zmat(3,1)*COS(Zmat(3,2)*torad) ! Z(3)=R cos(A)
      else
        Coords(3,1)=Zmat(3,1)*SIN(Zmat(3,2)*torad)
        Coords(3,3)=Coords(2,3)-Zmat(3,1)*COS(Zmat(3,2)*torad)
      EndIf
      If (nAtoms+nXAtoms.EQ.3) GoTo 2000
*     Atom #4 ->
      Do iAtom = 4, nAtoms+nXAtoms
        Call ZMatConv(LuWr,iAtom,iErr)
      EndDo
      If (iErr.NE.0) GoTo 9999

*     Check for superposed atoms
2000  Do i = 1, nAtoms+nXAtoms
        If (NAT(i).GT.0) then
          Do j = i+1, nAtoms+nXAtoms
            If (NAT(j).GT.0) then
              r = 0.0d0
              Do k =1, 3
                r = r + (Coords(i,k)-Coords(j,k))**2
              EndDo
              If (r.LT.0.0001d0) GoTo 9907
            EndIf
          EndDo
        EndIf
      EndDo

* Writing

      Do i = 1, nAtoms+nXAtoms
        If (NAT(i).GT.0) Write(LuOut,999) Symbols(i),(Coords(i,k),k=1,3)
      EndDo
999   Format(A5,1X,3(F12.6))
      GoTo 9999

9906  Write(LuWr,*) ' ERROR: Wrong input in Z-Matrix definition !'
      GoTo 9999
9907  Write(LuWr,*) ' ERROR: Superimposed atoms: ',i,j,'  r=',sqrt(r)
      GoTo 9999

9999  Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_CompVec(Diag,xInt,VecK,QDiag,Wrk,lWrk,iSym,iPass)
C
C     Purpose: compute vectors from decomposition of the qualified
C              diagonal integral block. VecK contains the nQual(iSym)
C              vectors from that decomposition. xInt contains the
C              integral columns. The vectors are returned in xInt.
C              Wrk (dimension lWrk) is work space allocated in calling
C              routine. QDiag contains the qualified diagonals.
C
      Implicit Real*8 (a-h,o-z)
      Real*8 Diag(*), xInt(*), VecK(*), QDiag(*), Wrk(lWrk)
#include "cholesky.fh"
#include "choptr.fh"
#include "choprint.fh"
#include "WrkSpc.fh"

      Character*11 SecNam
      Parameter (SecNam = 'Cho_CompVec')

      Logical LocDbg
      Parameter (LocDbg = .False.)

      Integer  Cho_P_IndxParentDiag
      External Cho_P_IndxParentDiag

      IndRed(i,j)=iWork(ip_IndRed-1+mmBstRT*(j-1)+i)

C     Subtract previous vectors.
C     --------------------------

      Call Cho_Subtr(xInt,Wrk,lWrk,iSym)

C     Debug: check diagonal elements in updated integrals.
C     ----------------------------------------------------

      If (Cho_DiaChk .or. LocDbg) Then
         Tol = Tol_DiaChk
         nErr = 0
         Call Cho_P_ChkInt(xINT,Diag,iSym,nErr,Tol,.True.)
         If (nErr .ne. 0) Then
            Write(Lupri,*) SecNam,': ',nErr,' diagonal errors found!'
            Write(Lupri,*) '          Integral pass: ',iPass
            Write(Lupri,*) '          #Tests: ',nQual(iSym)
c           Write(Lupri,*) '          Printing integrals:'
c           Call Cho_Output(xINT,
c    &                      1,nnBstR(iSym,2),1,nQual(iSym),
c    &                      nnBstR(iSym,2),nQual(iSym),1,Lupri)
            Call Cho_Quit('Diagonal errors in '//SecNam,104)
         Else
            Write(Lupri,*) SecNam,': comparison of qual. integrals ',
     &                  'and current diagonal: no errors !'
         End If
      End If

C     Set max. diagonal for screening.
C     --------------------------------

      QDmax = QDiag(1)

C     Compute vectors.
C     ----------------

      Do i = 1,nQual(iSym)

         kOff0 = nnBstR(iSym,2)*(i-1)
         kK0 = nQual(iSym)*(i-1)

C        Compute vector.
C        ---------------

         xC = QDiag(i)
         Fac = 1.0d0/sqrt(abs(xC))
         kOff = kOff0 + 1
         Call dScal_(nnBstR(iSym,2),Fac,xInt(kOff),1)

C        Zero elements corresponding to zero diagonals.
C        ----------------------------------------------

         Do jAB = 1,nnBstR(iSym,2)
            jAB1 = IndRed(iiBstR(iSym,2)+jAB,2)
            If (Diag(jAB1) .eq. 0.0d0) Then
               xInt(kOff0+jAB) = 0.0d0
            End If
         End Do

C        Update diagonal.
C        ----------------

         Do jAB = 1,nnBstR(iSym,2)
            jAB1 = IndRed(iiBstR(iSym,2)+jAB,2)
            kOff = kOff0 + jAB
            Diag(jAB1) = Diag(jAB1) - xInt(kOff)**2
         End Do

C        Update Qdiag.
C        -------------

         Do j = i,nQual(iSym)
            QDiag(j) = QDiag(j) - VecK(kK0+j)**2
         End Do
         OlDiag = QDiag(i)
         QDiag(i) = 0.0d0

C        Get index (1st reduced set) of the parent diagonal for this
C        vector (global index!).
C        -----------------------------------------------------------

         iABG = Cho_P_IndxParentDiag(i,iSym)

C        Zero treated diagonal element.
C        ------------------------------

         Call Cho_P_ZeroDiag(Diag,iSym,iABG)

C        Check for and zero negative diagonals, count converged, and
C        find max. diagonal element.
C        -----------------------------------------------------------

         Call Cho_ChkDia_A4(Diag,QDmax,iSym,nNeg,nNegT,nConv,xM,yM,zM)

C        nnZTot is the total number of zeroed negative diagonals,
C        updated for statistics purposes.
C        --------------------------------------------------------

         nnZTot = nnZTot + nNeg

C        Subtract this vector from remaining integral columns,
C        M([gd],{ab}_j) -= K({ab}_j,i)*L([gd],NumCho+i)
C        -----------------------------------------------------

         kOff = kOff0 + 1
         Do j = i+1,nQual(iSym)
            Fac = -VecK(kK0+j)
            kInt = nnBstR(iSym,2)*(j-1) + 1
            Call dAXPY_(nnBstR(iSym,2),Fac,xInt(kOff),1,xInt(kInt),1)
         End Do

C        Print.
C        ------

         If (iPrint .ge. Inf_Progress) Then
            iVec = NumCho(iSym) + i
            iVecT = NumChT + i
            Do j = i+1,nQual(iSym)
               xM = max(xM,QDiag(j))
            End Do
            Write(Lupri,'(I3,3(1X,I9),2(1X,D11.3),2(1X,I4),1X,D11.3)')
     &      iSym,iVec,iVecT,iABG,xC,OlDiag,nConv,nNeg,xM
         End If

      End Do

      If (iPrint .ge. Inf_Progress) Call Cho_Flush(Lupri)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------
* 1998  PER-AAKE MALMQUIST
* DEPARTMENT OF THEORETICAL CHEMISTRY
* UNIVERSITY OF LUND
* SWEDEN
*--------------------------------------------
* NOTE: This new MKRHS code produces ONLY the
* contravariant components. 980928, P-A Malmqvist
*--------------------------------------------
      SUBROUTINE MKRHS(IVEC)
      use definitions, only: iwp, wp, u6
      use caspt2_global, only:iPrGlb
      use caspt2_global, only: FIMO
      use PrintLevel, only: VERBOSE
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NASHT,NOMX
      IMPLICIT None

      integer(kind=iwp), intent(in):: IVEC

      integer(kind=iwp) NERI, NFIMO
      real(kind=wp), ALLOCATABLE, TARGET:: ERI(:)
      real(kind=wp), POINTER:: ERI0(:), ERI1(:), ERI2(:), SCR(:)

C Set up RHS vector of PT2 Linear Equation System, in vector
C number IVEC of LUSOLV. The coupling matrix elements from the
C root state to the 1st order interacting space are computed, as
C combinations of MO integrals.
C This is the RHS vector in contravariant representation.


      IF (IPRGLB.GE.VERBOSE) THEN
        WRITE(u6,'(1X,A)') ' Using conventional MKRHS algorithm'
      END IF

C INTEGRAL BUFFERS:
      NERI=NOMX**2
      CALL mma_allocate(ERI,3*NERI,Label='ERI')
      ERI0(1:2*NERI)=>ERI(1:2*NERI)
      ERI1(1:NERI)=>ERI(1:NERI)
      ERI2(1:NERI)=>ERI(NERI+1:2*NERI)
      SCR(1:NERI)=>ERI(2*NERI+1:3*NERI)

      IF(NASHT.GT.0) THEN
        NFIMO=SIZE(FIMO)
        CALL MKRHSA(IVEC,FIMO,NFIMO,ERI0,SCR)
        CALL MKRHSB(IVEC,ERI0,SCR)
        CALL MKRHSC(IVEC,FIMO,NFIMO,ERI0,SCR)
        CALL MKRHSD(IVEC,FIMO,NFIMO,ERI1,ERI2,SCR)
        CALL MKRHSE(IVEC,ERI1,ERI2,SCR)
        CALL MKRHSF(IVEC,ERI1,ERI2,SCR)
        CALL MKRHSG(IVEC,ERI1,ERI2,SCR)
      END IF
      CALL MKRHSH(IVEC,ERI1,ERI2,SCR)

      ERI0=>Null()
      ERI1=>Null()
      ERI2=>Null()
      SCR=>Null()
      CALL mma_deallocate(ERI)

      END SUBROUTINE MKRHS

      SUBROUTINE MKRHSA(IVEC,FIMO,NFIMO,ERI,SCR)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: Zero
      USE SUPERINDEX, only: KTUV
      use fake_GA, only: GA_Arrays, Allocate_GA_Array,
     &                            Deallocate_GA_Array
      use caspt2_module, only: NSYM,NORB,NINDEP,NTUV,NISH,NASH,NISH,
     &                         NAES,NTUVES,NACTEL

      IMPLICIT None

      integer(kind=iwp), intent(in)::IVEC, NFIMO
      real(kind=wp), intent(inout):: FIMO(NFIMO), ERI(*), SCR(*)

      integer(kind=iwp) NFNXT,ISYM,NFIMOES,NAS,NIS,NV,NI,LW,ISYMT,
     &                  ISYMUV,ISYMU,ISYMV,IT,ITTOT,ITABS,II,IU,IUTOT,
     &                  IUABS,IV,IVTOT,IVABS,IW1,IW2,IW,IBUF,ICASE
      real(kind=wp) FTI,ONEADD,WTUVI
C Set up RHS vector of PT2 Linear Equation System, in vector
C number IVEC of LUSOLV, for case 1 (VJTU).

      NFNXT=0
      DO ISYM=1,NSYM
        NFIMOES=NFNXT
        NFNXT=NFNXT+(NORB(ISYM)*(NORB(ISYM)+1))/2
        IF(NINDEP(ISYM,1).EQ.0) CYCLE
          NAS=NTUV(ISYM)
          NIS=NISH(ISYM)
          NV=NAS*NIS
          IF(NV.EQ.0) CYCLE
C Set up a matrix FWI(w,i)=FIMO(wi)
          NI=NISH(ISYM)

C Compute W(tuv,i)=(ti,uv) + FIMO(t,i)*delta(u,v)/NACTEL
          LW=Allocate_GA_Array(NV,'WA')
          DO ISYMT=1,NSYM
            ISYMUV=Mul(ISYMT,ISYM)
            DO ISYMU=1,NSYM
              ISYMV=Mul(ISYMU,ISYMUV)
              DO IT=1,NASH(ISYMT)
                ITTOT=IT+NISH(ISYMT)
                ITABS=IT+NAES(ISYMT)
                DO II=1,NI
                  CALL COUL(ISYMU,ISYMV,ISYMT,ISYM,ITTOT,II,ERI,SCR)
                  ONEADD=Zero
                  IF(ISYMT.EQ.ISYM) THEN
                    FTI=FIMO(NFIMOES+(ITTOT*(ITTOT-1))/2+II)
                    ONEADD=FTI/DBLE(MAX(1,NACTEL))
                  END IF
                  DO IU=1,NASH(ISYMU)
                    IUTOT=IU+NISH(ISYMU)
                    IUABS=IU+NAES(ISYMU)
                    DO IV=1,NASH(ISYMV)
                      IVTOT=IV+NISH(ISYMV)
                      IVABS=IV+NAES(ISYMV)
                      IW1=KTUV(ITABS,IUABS,IVABS)-NTUVES(ISYM)
                      IW2=II
                      IW=IW1+NAS*(IW2-1)
                      IBUF=IUTOT+NORB(ISYMU)*(IVTOT-1)
                      WTUVI=ERI(IBUF)
                      IF(IVABS.EQ.IUABS) WTUVI=WTUVI+ONEADD
                      GA_Arrays(LW)%A(IW)=WTUVI
                    END DO
                  END DO
                END DO
              END DO
            END DO
          END DO
C Put W on disk:
          ICASE=1
          CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LW)
          Call Deallocate_GA_Array(LW)
      END DO

      END SUBROUTINE MKRHSA

      SUBROUTINE MKRHSB(IVEC,ERI,SCR)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: Quart, Half, Two
      USE SUPERINDEX, only: KTGEU,KTGTU,KIGEJ,KIGTJ
      use fake_GA, only: GA_Arrays, Allocate_GA_Array,
     &                            Deallocate_GA_Array
      use caspt2_module, only: NSYM,NINDEP,NTGEU,NIGEJ,NTGTU,NIGTJ,
     &                         NASH,NISH,NAES,NTGEUES,NTGTUES,NIGEJES,
     &                         NIES,NORB,NIGTJES
      IMPLICIT None
      integer(kind=iwp), intent(in):: IVEC
      real(kind=wp), Intent(inout):: ERI(*), SCR(*)

      real(kind=wp), parameter:: SQ2=SQRT(Two)
      integer(kind=iwp) ISYM,NINP,NINM,NASP,NISP,NVP,NASM,NISM,NVM,LWP,
     &                  LWM,ISYMT,ISYMU,ISYMI,ISYMJ,IT,ITABS,ITTOT,IU,
     &                  IUABS,IUTOT,ITUP,ITUM,II,IIABS,IJ,IJABS,IBUF,
     &                  IIJP,JWP,IIJM,IWM,ICASE
      real(kind=wp) VALUE

C Set up RHS vector of PT2 Linear Equation System, in vector
C number IVEC of LUSOLV for cases 2 and 3 (VJTI).

C VJTI CASE:
      DO ISYM=1,NSYM
        NINP=NINDEP(ISYM,2)
        NINM=NINDEP(ISYM,3)
        IF(NINP+NINM.EQ.0) CYCLE
          NASP=NTGEU(ISYM)
          NISP=NIGEJ(ISYM)
          NVP=NASP*NISP
          IF(NVP.EQ.0) CYCLE
          NASM=NTGTU(ISYM)
          NISM=NIGTJ(ISYM)
          NVM=NASM*NISM
C   Allocate WP,WM
          LWP=Allocate_GA_Array(NVP,'WBP')
          LWM=Allocate_GA_Array(NVM,'WBM')
C   Let  W(tu,i,j)=(it,ju):
C   WP(tu,ij)=(W(tu,i,j)+W(tu,j,i))*(1-Kron(t,u)/2) /2
C With new normalisation, replace /2 with /(2*SQRT(1+Kron(ij))
C   WM(tu,ij)=(W(tu,i,j)-W(tu,j,i))*(1-Kron(t,u)/2) /2
          DO ISYMT=1,NSYM
            ISYMU=Mul(ISYMT,ISYM)
            IF(ISYMT.LT.ISYMU) CYCLE
            IF(NASH(ISYMT)*NASH(ISYMU).EQ.0) CYCLE
            DO ISYMI=1,NSYM
              ISYMJ=Mul(ISYMI,ISYM)
              IF(NISH(ISYMI)*NISH(ISYMJ).EQ.0) CYCLE
              DO IT=1,NASH(ISYMT)
                ITABS=IT+NAES(ISYMT)
                ITTOT=IT+NISH(ISYMT)
                DO IU=1,NASH(ISYMU)
                  IUABS=IU+NAES(ISYMU)
                  IUTOT=IU+NISH(ISYMU)
                  IF(ITABS.LT.IUABS) EXIT
                  ITUP=KTGEU(ITABS,IUABS)-NTGEUES(ISYM)
                  ITUM=KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
                  CALL EXCH(ISYMI,ISYMT,ISYMJ,ISYMU,
     &                      ITTOT,IUTOT,ERI,SCR)
                  IF(ITABS.NE.IUABS) THEN
                   DO II=1,NISH(ISYMI)
                    IIABS=II+NIES(ISYMI)
                    DO IJ=1,NISH(ISYMJ)
                      IJABS=IJ+NIES(ISYMJ)
                      IBUF=II+NORB(ISYMI)*(IJ-1)
                      VALUE=Half*ERI(IBUF)
                      IF(IIABS.GE.IJABS) THEN
                        IIJP=KIGEJ(IIABS,IJABS)-NIGEJES(ISYM)
                        JWP=ITUP+NASP*(IIJP-1)
                        IF(IIABS.GT.IJABS) THEN
                          GA_Arrays(LWP)%A(JWP)=
     &                       GA_Arrays(LWP)%A(JWP)+VALUE
                          IIJM=KIGTJ(IIABS,IJABS)-NIGTJES(ISYM)
                          IWM=ITUM+NASM*(IIJM-1)
                          GA_Arrays(LWM)%A(IWM)=
     &                       GA_Arrays(LWM)%A(IWM)+VALUE
                        ELSE
                          GA_Arrays(LWP)%A(JWP)=
     &                       GA_Arrays(LWP)%A(JWP)+SQ2*VALUE
                        END IF
                      ELSE
                        IIJP=KIGEJ(IJABS,IIABS)-NIGEJES(ISYM)
                        JWP=ITUP+NASP*(IIJP-1)
                        GA_Arrays(LWP)%A(JWP)=
     &                     GA_Arrays(LWP)%A(JWP)+VALUE
                        IIJM=KIGTJ(IJABS,IIABS)-NIGTJES(ISYM)
                        IWM=ITUM+NASM*(IIJM-1)
                        GA_Arrays(LWM)%A(IWM)=
     &                     GA_Arrays(LWM)%A(IWM)-VALUE
                      END IF
                    END DO
                   END DO
                  ELSE
                   DO II=1,NISH(ISYMI)
                    IIABS=II+NIES(ISYMI)
                    DO IJ=1,NISH(ISYMJ)
                      IJABS=IJ+NIES(ISYMJ)
                      IBUF=II+NORB(ISYMI)*(IJ-1)
                      VALUE=Quart*ERI(IBUF)
                      IF(IIABS.GE.IJABS) THEN
                        IIJP=KIGEJ(IIABS,IJABS)-NIGEJES(ISYM)
                        JWP=ITUP+NASP*(IIJP-1)
                        IF(IIABS.GT.IJABS) THEN
                          GA_Arrays(LWP)%A(JWP)=
     &                       GA_Arrays(LWP)%A(JWP)+VALUE
                        ELSE
                          GA_Arrays(LWP)%A(JWP)=
     &                       GA_Arrays(LWP)%A(JWP)+SQ2*VALUE
                        END IF
                      ELSE
                        IIJP=KIGEJ(IJABS,IIABS)-NIGEJES(ISYM)
                        JWP=ITUP+NASP*(IIJP-1)
                        GA_Arrays(LWP)%A(JWP)=
     &                     GA_Arrays(LWP)%A(JWP)+VALUE
                      END IF
                    END DO
                   END DO
                  END IF
                END DO
              END DO
            END DO
          END DO
C   Put WP on disk
          ICASE=2
          CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LWP)
C  Put WM on disk
          IF(NINM.GT.0) THEN
            ICASE=3
            CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LWM)
          END IF
          Call Deallocate_GA_Array(LWM)
          Call Deallocate_GA_Array(LWP)
      END DO

      END SUBROUTINE MKRHSB

      SUBROUTINE MKRHSC(IVEC,FIMO,NFIMO,ERI,SCR)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      USE SUPERINDEX, only: KTUV
      use fake_GA, only: GA_Arrays, Allocate_GA_Array,
     &                            Deallocate_GA_Array
      use caspt2_module, only: NSYM,NORB,NINDEP,NTUV,NSSH,NASH,NISH,
     &                         NAES,NSSH,NTUVES,NASHT,NACTEL
      IMPLICIT None
      integer(kind=iwp), intent(in):: IVEC, NFIMO
      real(kind=wp), intent(inout):: FIMO(NFIMO),ERI(*), SCR(*)

      integer(kind=iwp) NFNXT,ISYM,NFIMOES,NAS,NIS,NV,LW,ISYMT,
     &                  ISYMUV,ISYMU,ISYMV,IU,IUTOT,IUABS,IV,IVTOT,
     &                  IVABS,IA,IATOT,IT,ITTOT,ITABS,IW1,IW2,IW,IBUF,
     &                  IFIMO,IYABS,IYYW,IYYWA,ICASE
      real(kind=wp) SUM,ONEADD
C Set up RHS vector of PT2 Linear Equation System, in vector
C number IVEC of LUSOLV for case 4 (ATVX).

      NFNXT=0
      DO ISYM=1,NSYM
        NFIMOES=NFNXT
        NFNXT=NFNXT+(NORB(ISYM)*(NORB(ISYM)+1))/2
        IF(NINDEP(ISYM,4).EQ.0) CYCLE
          NAS=NTUV(ISYM)
          NIS=NSSH(ISYM)
          NV=NAS*NIS
          IF(NV.EQ.0) CYCLE

C   Allocate W. Put in W(tuv,a)=(at,uv) +
C             (FIMO(a,t)-sum(y)(ay,yt))*delta(u,v)/NACTEL.
C First, just the two-electron integrals. Later, add correction.

          LW=Allocate_GA_Array(NV,'WC')
          DO ISYMT=1,NSYM
            ISYMUV=Mul(ISYMT,ISYM)
            DO ISYMU=1,NSYM
              ISYMV=Mul(ISYMU,ISYMUV)
              DO IU=1,NASH(ISYMU)
                IUTOT=IU+NISH(ISYMU)
                IUABS=IU+NAES(ISYMU)
                DO IV=1,NASH(ISYMV)
                  IVTOT=IV+NISH(ISYMV)
                  IVABS=IV+NAES(ISYMV)
                  CALL COUL(ISYM,ISYMT,ISYMU,ISYMV,
     &                      IUTOT,IVTOT,ERI,SCR)
                  DO IA=1,NSSH(ISYM)
                    IATOT=IA+NISH(ISYM)+NASH(ISYM)
                    DO IT=1,NASH(ISYMT)
                      ITTOT=IT+NISH(ISYMT)
                      ITABS=IT+NAES(ISYMT)
                      IW1=KTUV(ITABS,IUABS,IVABS)-NTUVES(ISYM)
                      IW2=IA
                      IW=IW1+NAS*(IW2-1)
                      IBUF=IATOT+NORB(ISYM)*(ITTOT-1)
                      GA_Arrays(LW)%A(IW)=ERI(IBUF)
                    END DO
                  END DO
                END DO
              END DO
            END DO
          END DO

          DO IT=1,NASH(ISYM)
            ITTOT=IT+NISH(ISYM)
            ITABS=IT+NAES(ISYM)
            DO IA=1,NSSH(ISYM)
              IATOT=IA+NISH(ISYM)+NASH(ISYM)
              IFIMO=NFIMOES+(IATOT*(IATOT-1))/2+ITTOT
              SUM=FIMO(IFIMO)
              DO IYABS=1,NASHT
                IYYW=KTUV(IYABS,IYABS,ITABS)-NTUVES(ISYM)
                IYYWA=IYYW+NAS*(IA-1)
                SUM=SUM-GA_Arrays(LW)%A(IYYWA)
              END DO
              ONEADD=SUM/DBLE(MAX(1,NACTEL))
              DO ISYMU=1,NSYM
                DO IU=1,NASH(ISYMU)
                  IUABS=IU+NAES(ISYMU)
                  IW1=KTUV(ITABS,IUABS,IUABS)-NTUVES(ISYM)
                  IW2=IA
                  IW=IW1+NAS*(IW2-1)
                  GA_Arrays(LW)%A(IW)=GA_Arrays(LW)%A(IW)+ONEADD
                END DO
              END DO
            END DO
          END DO

C   Put W on disk
          ICASE=4
          CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LW)

          Call Deallocate_GA_Array(LW)
      END DO

      END SUBROUTINE MKRHSC

      SUBROUTINE MKRHSD(IVEC,FIMO,NFIMO,ERI1,ERI2,SCR)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: Zero
      USE SUPERINDEX, only: KTU
      use fake_GA, only: GA_Arrays, Allocate_GA_Array,
     &                            Deallocate_GA_Array
      use caspt2_module, only: NSYM,NINDEP,NSSH,NISH,NTU,NISUP,
     &                         NACTEL,NORB,NAES,NASH,NTUES
      IMPLICIT None
      integer(kind=iwp), intent(in):: IVEC, NFIMO
      real(kind=wp), intent(inout):: FIMO(NFIMO)
      real(kind=wp), intent(inout):: ERI1(*),ERI2(*), SCR(*)

      integer(kind=iwp) IOFF(8)
      integer(kind=iwp) ISYM,IO,ISYMI,NAS1,NAS,NIS,NV,LW,NFSUM,
     &                  NFIMOES,ISYMA,ISYMU,ISYMT,II,IU,IUABS,
     &                  IUTOT,IA,IATOT,IT,ITABS,ITTOT,IWA,IWI,IW1,IW2,
     &                  IBUF1,IBUF2,ICASE
      real(kind=wp) ONEADD,FAI,WAITU
C Set up RHS vector of PT2 Linear Equation System, in vector
C number IVEC of LUSOLV, for case 5, AIVX.

      DO ISYM=1,NSYM
        IF(NINDEP(ISYM,5).EQ.0) CYCLE
C Set up offset table:
          IO=0
          DO ISYMA=1,NSYM
            IOFF(ISYMA)=IO
            ISYMI=Mul(ISYMA,ISYM)
            IO=IO+NSSH(ISYMA)*NISH(ISYMI)
          END DO
C   Allocate W; W subdivided into W1,W2.
          NAS1=NTU(ISYM)
          NAS=2*NAS1
          NIS=NISUP(ISYM,5)
          NV=NAS*NIS
          IF(NV.EQ.0) CYCLE
C Compute W1(tu,ai)=(ai,tu) + FIMO(a,i)*delta(t,u)/NACTEL
C Compute W2(tu,ai)=(ti,au)
          LW=Allocate_GA_Array(NV,'WD')
          NFSUM=0
          DO ISYMI=1,NSYM
            NFIMOES=NFSUM
            NFSUM=NFSUM+(NORB(ISYMI)*(NORB(ISYMI)+1))/2
            ISYMA=Mul(ISYMI,ISYM)
            DO ISYMU=1,NSYM
              ISYMT=Mul(ISYMU,ISYM)
              DO II=1,NISH(ISYMI)
                DO IU=1,NASH(ISYMU)
                  IUABS=IU+NAES(ISYMU)
                  IUTOT=IU+NISH(ISYMU)
                  CALL EXCH(ISYMA,ISYMI,ISYMT,ISYMU,
     &                      II,IUTOT,ERI1,SCR)
                  CALL EXCH(ISYMT,ISYMI,ISYMA,ISYMU,
     &                      II,IUTOT,ERI2,SCR)
                  DO IA=1,NSSH(ISYMA)
                    IATOT=IA+NISH(ISYMA)+NASH(ISYMA)
                    ONEADD=Zero
                    IF(ISYM.EQ.1) THEN
                      FAI=FIMO(NFIMOES+(IATOT*(IATOT-1))/2+II)
                      ONEADD=FAI/DBLE(MAX(1,NACTEL))
                    END IF
                    DO IT=1,NASH(ISYMT)
                      ITABS=IT+NAES(ISYMT)
                      ITTOT=IT+NISH(ISYMT)
                      IWA=KTU(ITABS,IUABS)-NTUES(ISYM)
                      IWI=II+NISH(ISYMI)*(IA-1)+IOFF(ISYMA)
                      IW1=IWA+NAS*(IWI-1)
                      IW2=IW1+NAS1
                      IBUF1=IATOT+NORB(ISYMA)*(ITTOT-1)
                      IBUF2=ITTOT+NORB(ISYMT)*(IATOT-1)
                      WAITU=ERI1(IBUF1)
                      IF(ITABS.EQ.IUABS) WAITU=WAITU+ONEADD
                      GA_Arrays(LW)%A(IW1)=WAITU
                      GA_Arrays(LW)%A(IW2)=ERI2(IBUF2)
                    END DO
                  END DO
                END DO
              END DO
            END DO
          END DO
C   Put W on disk.
          ICASE=5
          CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LW)
          Call Deallocate_GA_Array(LW)
      END DO

      END SUBROUTINE MKRHSD

      SUBROUTINE MKRHSE(IVEC,ERI1,ERI2,SCR)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: half, One, two, three
      USE SUPERINDEX, only: KIGEJ, KIGTJ
      use fake_GA, only: GA_Arrays, Allocate_GA_Array,
     &                            Deallocate_GA_Array
      use caspt2_module, only: NSYM,NINDEP,NISUP,NASH,NISH,NSSH,
     &                         NORB,NIGEJ,NIES,NIGEJES,NIGTJES,NIGTJ
      IMPLICIT NONE
      integer(kind=iwp), intent(in):: IVEC
      real(kind=wp), Intent(inout):: ERI1(*),ERI2(*), SCR(*)

      integer(kind=iwp) IOFF1(8),IOFF2(8)
      real(kind=wp), parameter:: SQ2=SQRT(Two), SQI2=One/SQ2,
     &                           SQ3=SQRT(Three), SQ32=SQ3*SQI2
      integer(kind=iwp) ISYM,IO1,IO2,NAS,NISP,NISM,NVP,NVM,LWP,LWM,
     &                  ISYMA,ISYMI,IT,ITTOT,II,IA,IGEJ,IGTJ,IIABS,
     &                  IATOT,IBUF,IWA,IWIP,JWP,IJ,IJABS,ISYMIJ,ISYMJ,
     &                  IWIM,IWM,ICASE
      real(kind=wp) A, B
*#define _KIGEJ_
*#define _KIGTJ_
*#include "mig_kig.fh"

C Set up RHS vector of PT2 Linear Equation System, in vector
C number IVEC of LUSOLV, for cases 6 and 7 (VJAI).


      DO ISYM=1,NSYM
        IF(NINDEP(ISYM,6)+NINDEP(ISYM,7).EQ.0) CYCLE
C Set up offset table:
          IO1=0
          IO2=0
          DO ISYMA=1,NSYM
            IOFF1(ISYMA)=IO1
            IOFF2(ISYMA)=IO2
            ISYMIJ=Mul(ISYMA,ISYM)
            IO1=IO1+NSSH(ISYMA)*NIGEJ(ISYMIJ)
            IO2=IO2+NSSH(ISYMA)*NIGTJ(ISYMIJ)
          END DO
C   Allocate W with parts WP,WM
          NAS=NASH(ISYM)
          NISP=NISUP(ISYM,6)
          NISM=NISUP(ISYM,7)
          NVP=NAS*NISP
          IF(NVP.EQ.0) CYCLE
          NVM=NAS*NISM
          LWP=Allocate_GA_Array(NVP,'WEP')
          LWM=Allocate_GA_Array(NVM,'WEM')
C  Let W(t,i,j,a)=(aitj)
C   WP(t,ij,a)=  (W(t,i,j,a)+W(t,j,i,a))
C With new normalisation, divide by /SQRT(2+2*Kron(ij))
C   WM(t,ij,a)=3*(W(t,i,j,a)-W(t,j,i,a))
C With new normalisation, divide by /SQRT(6)
          DO ISYMA=1,NSYM
            ISYMIJ=Mul(ISYMA,ISYM)
            DO ISYMI=1,NSYM
              ISYMJ=Mul(ISYMI,ISYMIJ)
              IF(ISYMI.LT.ISYMJ) CYCLE
              DO II=1,NISH(ISYMI)
                IIABS=II+NIES(ISYMI)
                DO IJ=1,NISH(ISYMJ)
                  IJABS=IJ+NIES(ISYMJ)
                  IF(IIABS.LT.IJABS) EXIT
                  CALL EXCH(ISYMA,ISYMI,ISYM,ISYMJ,II,IJ,ERI1,SCR)
                  CALL EXCH(ISYMA,ISYMJ,ISYM,ISYMI,IJ,II,ERI2,SCR)
                  IGEJ=KIGEJ(IIABS,IJABS)-NIGEJES(ISYMIJ)
                  IGTJ=KIGTJ(IIABS,IJABS)-NIGTJES(ISYMIJ)
                  DO IA=1,NSSH(ISYMA)
                    IATOT=IA+NISH(ISYMA)+NASH(ISYMA)
                    DO IT=1,NASH(ISYM)
                      ITTOT=IT+NISH(ISYM)
                      IBUF=IATOT+NORB(ISYMA)*(ITTOT-1)
                      A=ERI1(IBUF)+ERI2(IBUF)
                      IWA=IT
                      IWIP=IA+NSSH(ISYMA)*(IGEJ-1)+IOFF1(ISYMA)
                      JWP=IWA+NAS*(IWIP-1)
                      IF(IIABS.GT.IJABS) THEN
                        GA_Arrays(LWP)%A(JWP)=SQI2*A
                        B=ERI1(IBUF)-ERI2(IBUF)
                        IWIM=IA+NSSH(ISYMA)*(IGTJ-1)+IOFF2(ISYMA)
                        IWM=IWA+NAS*(IWIM-1)
                        GA_Arrays(LWM)%A(IWM)=SQ32*B
                      ELSE
                        GA_Arrays(LWP)%A(JWP)=half*A
                      END IF
                    END DO
                  END DO
                END DO
              END DO
            END DO
          END DO
C   Put WP and WM on disk.
          ICASE=6
          CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LWP)
          IF(NVM.GT.0) THEN
            ICASE=7
            CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LWM)
          END IF
          Call Deallocate_GA_Array(LWP)
          Call Deallocate_GA_Array(LWM)
      END DO

      END SUBROUTINE MKRHSE

      SUBROUTINE MKRHSF(IVEC,ERI1,ERI2,SCR)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only:  half, One, two
      USE SUPERINDEX, only: KTGEU,KAGEB,KTGTU,KAGTB
      use fake_GA, only: GA_Arrays, Allocate_GA_Array,
     &                            Deallocate_GA_Array
      use caspt2_module, only: NSYM,NINDEP,NASUP,NISUP,NASH,NAES,
     &                         NISH,NSSH,NSES,NORB,NTGEUES,NAGEBES,
     &                         NTGTUES,NAGTBES
      IMPLICIT NONE
      integer(kind=iwp), intent(in):: IVEC
      real(kind=wp), Intent(inout):: ERI1(*),ERI2(*), SCR(*)

      real(kind=wp), parameter:: SQ2=SQRT(Two), SQI2=One/SQ2
      integer(kind=iwp) ISYM,NINP,NINM,NASP,NISP,NASM,NISM,NVP,NVM,LWP,
     &                  ISYMA,ISYMB,ISYMT,ISYMU,IT,ITABS,ITTOT,IU,IUABS,
     &                  IUTOT,IA,IAABS,IATOT,IB,IBABS,IBTOT,IBUF,IWAP,
     &                  IWIP,JWP,IWAM,IWIM,IWM,LWM,ICASE
      real(kind=wp) A, B
C Set up RHS vector of PT2 Linear Equation System, in vector
C number IVEC of LUSOLV, for cases 8 and 9 (BVAT).


      DO ISYM=1,NSYM
        NINP=NINDEP(ISYM,8)
        NINM=NINDEP(ISYM,9)
        IF(NINP+NINM.EQ.0) CYCLE
          NASP=NASUP(ISYM,8)
          NISP=NISUP(ISYM,8)
          NASM=NASUP(ISYM,9)
          NISM=NISUP(ISYM,9)
          NVP=NASP*NISP
          IF(NVP.EQ.0) CYCLE
          NVM=NASM*NISM
          LWP=Allocate_GA_Array(NVP,'WFP')
          IF(NVM.GT.0) LWM=Allocate_GA_Array(NVM,'WFM')
C   Let W(t,u,ab)=(aubt)
C   WP(tu,ab)=(W(t,u,ab)+W(u,t,ab))*(1-Kron(t,u)/2) /2
C With new normalisation, replace /2 with /(2*SQRT(1+Kron(ab))
C   WM(tu,ab)=(W(t,u,ab)-W(u,t,ab))*(1-Kron(t,u)/2) /2
          DO ISYMA=1,NSYM
            ISYMB=Mul(ISYMA,ISYM)
            IF(ISYMA.LT.ISYMB) CYCLE
            DO ISYMT=1,NSYM
              ISYMU=Mul(ISYMT,ISYM)
              IF(ISYMT.LT.ISYMU) CYCLE
              DO IT=1,NASH(ISYMT)
                ITABS=IT+NAES(ISYMT)
                ITTOT=IT+NISH(ISYMT)
                DO IU=1,NASH(ISYMU)
                  IUABS=IU+NAES(ISYMU)
                  IUTOT=IU+NISH(ISYMU)
                  IF(ITABS.LT.IUABS) EXIT
                  CALL EXCH(ISYMA,ISYMU,ISYMB,ISYMT,
     &                      IUTOT,ITTOT,ERI1,SCR)
                  CALL EXCH(ISYMA,ISYMT,ISYMB,ISYMU,
     &                      ITTOT,IUTOT,ERI2,SCR)
                  DO IA=1,NSSH(ISYMA)
                    IAABS=IA+NSES(ISYMA)
                    IATOT=IA+NISH(ISYMA)+NASH(ISYMA)
                    DO IB=1,NSSH(ISYMB)
                      IBABS=IB+NSES(ISYMB)
                      IBTOT=IB+NISH(ISYMB)+NASH(ISYMB)
                      IF(IAABS.LT.IBABS) EXIT
                      IBUF=IATOT+NORB(ISYMA)*(IBTOT-1)
                      A=Half*(ERI1(IBUF)+ERI2(IBUF))
                      IF(ITABS.EQ.IUABS) A=Half*A
                      IWAP=KTGEU(ITABS,IUABS)-NTGEUES(ISYM)
                      IWIP=KAGEB(IAABS,IBABS)-NAGEBES(ISYM)
                      JWP=IWAP+NASP*(IWIP-1)
                      IF(IAABS.NE.IBABS) THEN
                        GA_Arrays(LWP)%A(JWP)=A
                        IF(ITABS.NE.IUABS) THEN
                          B=Half*(ERI1(IBUF)-ERI2(IBUF))
                          IWAM=KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
                          IWIM=KAGTB(IAABS,IBABS)-NAGTBES(ISYM)
                          IWM=IWAM+NASM*(IWIM-1)
                          GA_Arrays(LWM)%A(IWM)=B
                        END IF
                      ELSE
                        GA_Arrays(LWP)%A(JWP)=SQI2*A
                      END IF
                    END DO
                  END DO
                END DO
              END DO
            END DO
          END DO
C   Put WP on disk
          ICASE=8
          CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LWP)
          Call Deallocate_GA_Array(LWP)
          IF(NINM.GT.0) THEN
C   Put WM on disk
            ICASE=9
            CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LWM)
          END IF
          IF(NVM.GT.0) Call Deallocate_GA_Array(LWM)
      END DO

      END SUBROUTINE MKRHSF

      SUBROUTINE MKRHSG(IVEC,ERI1,ERI2,SCR)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: half, One, two, three
      USE SUPERINDEX, only: KAGEB,KAGTB
      use fake_GA, only: GA_Arrays, Allocate_GA_Array,
     &                            Deallocate_GA_Array
      use caspt2_module, only: NSYM,NINDEP,NISH,NAGEB,NAGTB,NASH,
     &                         NISUP,NISUP,NSSH,NSES,NORB,NAGEBES,
     &                         NAGTBES
      IMPLICIT NONE
      integer(kind=iwp), intent(in):: IVEC
      real(kind=wp), Intent(inout):: ERI1(*),ERI2(*), SCR(*)

      integer(kind=iwp) IOFF1(8),IOFF2(8)
      real(kind=wp), parameter:: SQ2=SQRT(Two), SQI2=One/SQ2,
     &                           SQ3=SQRT(Three), SQ32=SQ3*SQI2
      integer(kind=iwp) ISYM,IO1,IO2,NAS,NISP,NISM,NVP,NVM,LWP,LWM,
     &                  ISYMA,ISYMB,ISYMAB,ISYMI,IT,ITTOT,II,IA,IAABS,
     &                  IATOT,IB,IBABS,IBTOT,IBUF,IWA,IAGEB,IWIP,JWP,
     &                  IAGTB,IWIM,IWM,ICASE
      real(kind=wp) A,B

C Set up RHS vector of PT2 Linear Equation System, in vector
C number IVEC of LUSOLV, for cases 10 and 11 (BJAT).


      DO ISYM=1,NSYM
        IF(NINDEP(ISYM,10)+NINDEP(ISYM,11).EQ.0) CYCLE
C Set up offset table:
          IO1=0
          IO2=0
          DO ISYMI=1,NSYM
            IOFF1(ISYMI)=IO1
            IOFF2(ISYMI)=IO2
            ISYMAB=Mul(ISYMI,ISYM)
            IO1=IO1+NISH(ISYMI)*NAGEB(ISYMAB)
            IO2=IO2+NISH(ISYMI)*NAGTB(ISYMAB)
          END DO
C   Allocate W with parts WP,WM
          NAS=NASH(ISYM)
          NISP=NISUP(ISYM,10)
          NISM=NISUP(ISYM,11)
          NVP=NAS*NISP
          IF(NVP.EQ.0) CYCLE
          NVM=NAS*NISM
          LWP=Allocate_GA_Array(NVP,'WGP')
          LWM=Allocate_GA_Array(NVM,'WGM')
C   Let  W(t,i,a,b)=(atbi)
C   WP(t,i,ab)=  (W(t,i,a,b)+W(t,i,b,a))
C With new normalisation, divide by /SQRT(2+2*Kron(ab))
C   WM(t,i,ab)=3*(W(t,i,a,b)-W(t,i,b,a))
C With new normalisation, divide by /SQRT(6)
          DO ISYMA=1,NSYM
            DO ISYMB=1,ISYMA
              ISYMAB=Mul(ISYMA,ISYMB)
              ISYMI=Mul(ISYMAB,ISYM)
              DO IT=1,NASH(ISYM)
                ITTOT=IT+NISH(ISYM)
                DO II=1,NISH(ISYMI)
                  CALL EXCH(ISYMA,ISYM ,ISYMB,ISYMI,
     &                      ITTOT,II,ERI1,SCR)
                  CALL EXCH(ISYMA,ISYMI,ISYMB,ISYM ,
     &                      II,ITTOT,ERI2,SCR)
                  DO IA=1,NSSH(ISYMA)
                    IAABS=IA+NSES(ISYMA)
                    IATOT=IA+NISH(ISYMA)+NASH(ISYMA)
                    DO IB=1,NSSH(ISYMB)
                      IBABS=IB+NSES(ISYMB)
                      IBTOT=IB+NISH(ISYMB)+NASH(ISYMB)
                      IF(IAABS.LT.IBABS) EXIT
                      IBUF=IATOT+NORB(ISYMA)*(IBTOT-1)
                      IWA=IT
                      IAGEB=KAGEB(IAABS,IBABS)-NAGEBES(ISYMAB)
                      IWIP=II+NISH(ISYMI)*(IAGEB-1)+IOFF1(ISYMI)
                      JWP=IWA+NAS*(IWIP-1)
                      A=ERI1(IBUF)+ERI2(IBUF)
                      IF(IAABS.NE.IBABS) THEN
                        GA_Arrays(LWP)%A(JWP)=SQI2*A
                        IAGTB=KAGTB(IAABS,IBABS)-NAGTBES(ISYMAB)
                        IWIM=II+NISH(ISYMI)*(IAGTB-1)+IOFF2(ISYMI)
                        IWM=IWA+NAS*(IWIM-1)
                        B=ERI1(IBUF)-ERI2(IBUF)
                        GA_Arrays(LWM)%A(IWM)=SQ32*B
                      ELSE
                        GA_Arrays(LWP)%A(JWP)=half*A
                      END IF
                    END DO
                  END DO
                END DO
              END DO
            END DO
          END DO
C   Put WP and WM on disk.
          ICASE=10
          CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LWP)
          IF(NVM.GT.0) THEN
           ICASE=11
           CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LWM)
          END IF
          Call Deallocate_GA_Array(LWP)
          Call Deallocate_GA_Array(LWM)
      END DO

      END SUBROUTINE MKRHSG

      SUBROUTINE MKRHSH(IVEC,ERI1,ERI2,SCR)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: half, One, two, three
      USE SUPERINDEX, only: KAGEB,KIGEJ,KAGTB,KIGTJ
      use fake_GA, only: GA_Arrays, Allocate_GA_Array,
     &                            Deallocate_GA_Array
      use caspt2_module, only: NSYM,NAGEB,NIGEJ,NAGTB,NIGTJ,NISH,
     &                         NIES,NSES,NSSH,NORB,NASH,NAGEBES,NIGEJES,
     &                         NAGTBES,NIGTJES
      IMPLICIT None
      integer(kind=iwp), intent(in):: IVEC
      real(kind=wp), Intent(inout):: ERI1(*),ERI2(*), SCR(*)

      real(kind=wp), parameter:: SQ2=SQRT(Two), SQI2=One/SQ2,
     &                           SQ3=SQRT(Three)
      integer(kind=iwp) ISYM,NASP,NISP,NVP,NASM,NISM,NVM,LVP,ISYMA,
     &                  ISYMB,ISYMI,ISYMJ,II,IIABS,IJ,IJABS,
     &                  IA,IAABS,IATOT,IB,IBABS,IBTOT,IBUF,IVAP,IVIP,
     &                  IVP,IVAM,IVIM,IVM,LVM,ICASE
      real(kind=wp) A,B

C Set up RHS vector of PT2 Linear Equation System, in vector
C number IVEC of LUSOLV, for cases 12 and 13 (BJAI).

      DO ISYM=1,NSYM
          NASP=NAGEB(ISYM)
          NISP=NIGEJ(ISYM)
          NVP=NASP*NISP
          IF(NVP.EQ.0) CYCLE
          NASM=NAGTB(ISYM)
          NISM=NIGTJ(ISYM)
          NVM=NASM*NISM
          LVP=Allocate_GA_Array(NVP,'WHP')
          IF(NVM.GT.0) LVM=Allocate_GA_Array(NVM,'WHM')
C   VP(ij,ab)=2*((aibj)+(ajbi))
C With new norm., divide by /SQRT(4*(1+Kron(ij))*(1+Kron(ab))
C   VM(ij,ab)=6*((aibj)-(ajbi))
C With new norm., divide by /SQRT(12)
          DO ISYMA=1,NSYM
            ISYMB=Mul(ISYMA,ISYM)
            IF(ISYMA.LT.ISYMB) CYCLE
            DO ISYMI=1,NSYM
              ISYMJ=Mul(ISYMI,ISYM)
              IF(ISYMI.LT.ISYMJ) CYCLE
              DO II=1,NISH(ISYMI)
                IIABS=II+NIES(ISYMI)
                DO IJ=1,NISH(ISYMJ)
                  IJABS=IJ+NIES(ISYMJ)
                  IF(IIABS.LT.IJABS) EXIT
                  CALL EXCH(ISYMA,ISYMI,ISYMB,ISYMJ,II,IJ,ERI1,SCR)
                  CALL EXCH(ISYMA,ISYMJ,ISYMB,ISYMI,IJ,II,ERI2,SCR)
                  DO IA=1,NSSH(ISYMA)
                    IAABS=IA+NSES(ISYMA)
                    IATOT=IA+NISH(ISYMA)+NASH(ISYMA)
                    DO IB=1,NSSH(ISYMB)
                      IBABS=IB+NSES(ISYMB)
                      IF(IAABS.LT.IBABS) EXIT
                      IBTOT=IB+NISH(ISYMB)+NASH(ISYMB)
                      IBUF=IATOT+NORB(ISYMA)*(IBTOT-1)
                      IVAP=KAGEB(IAABS,IBABS)-NAGEBES(ISYM)
                      IVIP=KIGEJ(IIABS,IJABS)-NIGEJES(ISYM)
                      IVP=IVAP+NAGEB(ISYM)*(IVIP-1)
                      A=ERI1(IBUF)+ERI2(IBUF)
                      IF(IIABS.NE.IJABS) THEN
                        IF(IAABS.NE.IBABS) THEN
                          GA_Arrays(LVP)%A(IVP)=A
                          IVAM=KAGTB(IAABS,IBABS)-NAGTBES(ISYM)
                          IVIM=KIGTJ(IIABS,IJABS)-NIGTJES(ISYM)
                          IVM=IVAM+NAGTB(ISYM)*(IVIM-1)
                          B=ERI1(IBUF)-ERI2(IBUF)
                          GA_Arrays(LVM)%A(IVM)=SQ3*B
                        ELSE
                          GA_Arrays(LVP)%A(IVP)=SQI2*A
                        END IF
                      ELSE
                        IF(IAABS.NE.IBABS) THEN
                          GA_Arrays(LVP)%A(IVP)=SQI2*A
                        ELSE
                          GA_Arrays(LVP)%A(IVP)=Half*A
                        END IF
                      END IF
                    END DO
                  END DO
                END DO
              END DO
            END DO
          END DO

          ICASE=12
          CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LVP)
          Call Deallocate_GA_Array(LVP)
          IF(NVM.GT.0) THEN
           ICASE=13
           CALL MKRHS_SAVE(ICASE,ISYM,IVEC,LVM)
           Call Deallocate_GA_Array(LVM)
          END IF
      END DO

      END SUBROUTINE MKRHSH

      SUBROUTINE MKRHS_SAVE(ICASE,ISYM,IVEC,LW)
CSVC: special routine to save the RHS array. MKRHS works in serial, so
C in case of a true parallel run we need to put the local array in a
C global array and then save that to disk in a distributed fashion.
      use definitions, only: iwp
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
      use fake_GA, only: GA_Arrays
#endif
      use caspt2_module, only: NASUP,NISUP
      IMPLICIT None

      integer(kind=iwp), intent(in):: ICASE,ISYM,IVEC,LW

      integer(kind=iwp) NAS, NIS, lg_w

      NAS=NASUP(ISYM,ICASE)
      NIS=NISUP(ISYM,ICASE)

#ifdef _MOLCAS_MPP_
      IF (IS_REAL_PAR()) THEN
        CALL RHS_ALLO(NAS,NIS,lg_W)
        CALL RHS_PUT(NAS,NIS,lg_W,GA_Arrays(LW)%A)
      ELSE
#endif
        lg_W=LW
#ifdef _MOLCAS_MPP_
      END IF
#endif

      CALL RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)

#ifdef _MOLCAS_MPP_
      IF (IS_REAL_PAR()) THEN
        CALL RHS_FREE(lg_W)
      END IF
#endif
      END SUBROUTINE MKRHS_SAVE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Exp1(A,B,dimi,dim_2,dime)
! this routine does:
! expand A(i,pq) -> B(i,p,q)
! for matrices, where A(i,pq)=A(i,qp)
!
! parameter description:
! A       - input matrix (I)
! B       - output matrix (O)
! dimi    - first dimension in A,B (I)
! dim_2   - # of pq (I)
! dimf    - # of p (also q) (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimi, dim_2, dime
real(kind=wp), intent(in) :: A(dimi,dim_2)
real(kind=wp), intent(out) :: B(dimi,dime,dime)
integer(kind=iwp) :: p, pq

pq = 0
do p=1,dime

  B(:,p,1:p-1) = A(:,pq+1:pq+p-1)

  B(:,1:p,p) = A(:,pq+1:pq+p)

  pq = pq+p
end do

return

end subroutine Exp1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PtDipo(H0,nSize,Temp,nTemp)
!***********************************************************************
!                                                                      *
!     Objective: Construct the modified Hamiltonian,                   *
!                i.e., add dipole perturbation operator                *
!                                                                      *
!***********************************************************************

use FFPT_Global, only: nBas, nSym, ComStk, ComVal
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSize, nTemp
real(kind=wp), intent(inout) :: H0(nSize), Temp(nTemp)
character(len=8) :: Label
character(len=20) :: PriLbl
logical(kind=iwp) :: Exec
integer(kind=iwp) :: idum(1), iComp, iOpt1, iOpt2, iRc, iSyLbl, nInts
real(kind=wp) :: Alpha
logical(kind=iwp), parameter :: Debug = .false.

!----------------------------------------------------------------------*
!                                                                      *
!     Start procedure                                                  *
!     Check if the command has been specified on input                 *
!                                                                      *
!----------------------------------------------------------------------*

Exec = .false.
Exec = Exec .or. ComStk(2,1,1,1)
Exec = Exec .or. ComStk(2,1,1,2)
Exec = Exec .or. ComStk(2,1,1,3)
if (.not. Exec) then
  return
end if

!----------------------------------------------------------------------*
!     Loop over all components and add constributions to the           *
!     one-electron Hamiltonian                                         *
!----------------------------------------------------------------------*

do iComp=1,3
  if (ComStk(2,1,1,iComp)) then
    Label = 'MltPl  1'
    iRc = -1
    iOpt1 = 1
    iOpt2 = 2
    iSyLbl = 0
    Alpha = -ComVal(2,1,1,iComp)
    call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
    nInts = idum(1)
    if (iRc /= 0) call error()
    call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
    if (iRc /= 0) call error()
    call CmpInt(Temp,nInts,nBas,nSym,iSyLbl)
    if (Debug) then
      write(u6,'(6X,A,F8.6)') 'weight =',Alpha
      PriLbl = 'MltPl  1; Comp =    '
      write(PriLbl(19:20),'(I2)') iComp
      call PrDiOp(PriLbl,nSym,nBas,Temp)
      write(u6,*) 'Nuclear contribution=',Temp(nInts+4)
    end if
    call daxpy_(nInts,Alpha,Temp,1,H0,1)
    H0(nInts+4) = H0(nInts+4)-Alpha*Temp(nInts+4)
  end if
end do

!----------------------------------------------------------------------*
!     Normal Exit                                                      *
!----------------------------------------------------------------------*

return

contains

!----------------------------------------------------------------------*
!     Error Exit                                                       *
!----------------------------------------------------------------------*
subroutine error()

  write(u6,*) 'PtDipi: Error reading ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()

end subroutine error

end subroutine PtDipo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MpProp(iReturn)
      Implicit Real*8 (a-h,o-z)
*                                                                      *
************************************************************************
*                                                                      *
*     - Include files
#include "MpParam.fh"
#include "WrkSpc.fh"
#include "Address.fh"
#include "MolProp.fh"
C
C Variable definition
C
C     - Molcas part
      Integer nPrim(8), nBas(8)
      Character*8 Label
      Character*80 VTitle
      Character*6 FName
      Character*8 MemLabel
      Logical LNearestAtom
      Logical LAllCenters
      Logical AveOrb, Diffuse(3)
      Logical LFirstRun
      Logical LLumOrb
      Logical Exist
      Dimension dLimmo(2),iDum(1)
*                                                                      *
************************************************************************
*                                                                      *
*     Set some zeroes
      Do i=1,mxAtomMP
       iAtomPar(i)=1
       nub(i)=0
       Do j=1,mxAtomMP
        nbi(i,j)=0
       EndDo
      EndDo
      Do i=1,mxCen
         iBondPar(i)=1
      EndDo
      Do i=1,8
         nPrim(i)=0
         nBas(i)=0
      EndDo
*                                                                      *
************************************************************************
*                                                                      *
*     Set some defaults
!      iPol=1
      LNearestAtom=.True.
      LAllCenters=.False.
      AveOrb=.False.
      LLumOrb=.False.
      Diffuse(1)=.False.
      Diffuse(2)=.False.
      Diffuse(3)=.False.
      dLimmo(1)=0.65d0
      dLimmo(2)=2.0d0
      Thrs1=1d-5
      Thrs2=1d-4
      nThrs=3
      ThrsMul=1d-2
      iPrint=1
*                                                                      *
************************************************************************
*                                                                      *
*---- Get some coords, nuc. charges and labels
*
! Memory debugging
!      Call Setmem('TRACE=ON')
*
* IO check
!      call fastio('TRACE=ON')
*
C     Call Bnnr
      Call Get_cArray('Relax Method',Method,8)
      If(Method.eq.'RHF-SCF') Then
         iPol=1
      ElseIf(Method.eq.'UHF-SCF') Then
         iPol=1
      ElseIf(Method.eq.'MBPT2') Then
         iPol=0
      EndIf
!     Runfile update
!      Call Get_nAtoms(nAtoms)
      Call Get_iScalar('Unique atoms',nAtoms)
      If (nAtoms.gt.mxAtomMP) Then
         Write (6,'(A)')'MPProp: Too many atoms'
         Call Abend()
      End If
!
      Call GetMem('Coord','Allo','Real',ip_Coor,3*nAtoms)
      Call GetMem('Atype','Allo','Real',iAtype,nAtoms)
!     Runfile update
!      Call Get_Coord(Work(ip_Coor),nAtoms)
      Call Get_dArray('Unique Coordinates',Work(ip_Coor),nAtoms*3)

!     Runfile update
!      Call Get_AtomLabel(Labe,nAtoms)
      Call Get_cArray('Unique Atom Names',Labe,LENIN*nAtoms)
!

!     Runfile update
!      Call Get_Charge(Work(iAtype),nAtoms)
      Call Get_dArray('Nuclear charge',Work(iAtype),nAtoms)
!
      Call GetMem('Qnuc','Allo','Real',iQnuc,nAtoms)
!     Runfile update
!      Call Get_Charge_Eff(Work(iQnuc),nAtoms)
      Call Get_dArray('Effective nuclear Charge',Work(iQnuc),nAtoms)
!
      Do i=1,nAtoms
         iAtomType(i) = Int(Work(iAtype+i-1))
         COR(1,i,i) = Work(ip_Coor+(i-1)*3)
         COR(2,i,i) = Work(ip_Coor+(i-1)*3+1)
         COR(3,i,i) = Work(ip_Coor+(i-1)*3+2)
      End Do
      Call Wr_Cord(nAtoms)
      Call GetMem('Atype','Free','Real',iAtype,nAtoms)
      nCenters  = nAtoms*(nAtoms+1)/2
      nSum=nAtoms*6
*                                                                      *
************************************************************************
*
*---- Get information from input

      Call Get_Mpprop_input(nAtoms,iPol,LNearestAtom,LAllCenters,AveOrb,
     &                      LLumOrb,Diffuse,dLimmo,Thrs1,Thrs2,nThrs,
     &                      ThrsMul,iPrint)
*                                                                      *
************************************************************************
*                                                                      *
*---- Read first the size of the contracted basis using the default file
*     ONEINT and COMFILE
*
!     Runfile update
!      Call Get_nSym(nSym)
      Call Get_iScalar('nSym',nSym)
!
!     Runfile update
!      Call Get_nBas(nBas)
      nIrrep = 1
      Call Get_iArray('nBas',nBas,1)
!
      nVec=0
      nOcc=0
      Do iSym = 1, nSym
         nVec = nVec + nBas(iSym)**2
         nOcc = nOcc + nBas(iSym)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Read first the size of the primitiv basis using ONEREL and COMREL
*
!     Runfile update
!      Call Get_nBas(nPrim)
      Call Get_iArray('nBas_Prim',nPrim,1)

      nSize=0
      Do iSym = 1, nSym
         nSize = nSize + nPrim(iSym)*(nPrim(iSym)+1)/2
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Do a dirty trick since the one-intergral file is not explicitly
*     opened.
      Call Put_iArray('nBas',nPrim,1)
C     Call OneBas('PRIM')
*                                                                      *
************************************************************************
*                                                                      *
*---- Read overlap, dipole moment and quadrupole moment integrals
*
*
* Do it general
*
      Do iMltpl = 0, mxMltPl
         Write (label,'(a,i2)') 'PLTPL ',iMltpl
         nComp = (iMltpl+1)*(iMltpl+2)/2
         Write(MemLabel,'(A5,i3.3)') 'MltPl',iMltpl
         Call GetMem(MemLabel,'Allo','Inte',iMltPlAd(iMltpl),nComp)
         nSum=nSum+nComp
         Do iComp = 1, nComp
            irc=-1
            iopt=1
!EB            Call RdOne (irc,iopt,label,iComp,nInt,iSmLbl)
            Call iRdOne (irc,iopt,label,iComp,iDum,iSmLbl)
            If (irc.eq.0) nInt=iDum(1)
            if (irc.ne.0) Then
               If(iComp.ne.1) Then
                  Write (6,'(2A)')'MPProp: Error reading iComp.ne.0 lab'
     &            ,'el=',label
                  Call Abend()
               Else
                  Call GetMem(MemLabel,'Free','Inte',iMltPlAd(iMltpl),
     &            nComp)
                  nMltPl=iMltPl-1
                  nSum=nSum-nComp
                  go to 100
               EndIf
            EndIf
            If (nInt.ne.0) Then
               Write(MemLabel,'(i3.3,i5.5)') iMltpl, iComp
               Call GetMem(MemLabel,'Allo','Real',
     &         iWork(iMltPlAd(iMltpl)+iComp-1),nInt+4)
               nSum=nSum+nInt+4
               irc=-1
               iopt=0
               Call RdOne (irc,iopt,label,iComp,
     &         Work(iWork(iMltPlAd(iMltpl)+iComp-1)),iSmLbl)
            Else
               Write (6,'(2A)')'MPProp: Error reading nInt=0 label='
     &         ,label
               Call Abend()
            End If
            If (irc.ne.0) Then
               Write (6,'(2A)') '2 MPProp: Error reading ',label
               Call Abend()
            End If
!???????????????????????
            If (nInt.ne.0)
     &         Call CmpInt(Work(iWork(iMltPlAd(iMltpl)+iComp-1)),nInt,
     &         nPrim,nIrrep,iSmLbl)
            Do i=1,3
               CordMltPl(i,iMltpl)=
     &         Work(iWork(iMltPlAd(iMltpl))+nInt+i-1)
            End Do
         End Do
      End Do

100   Continue

*                                                                      *
************************************************************************
*                                                                      *
*---- Allocate Memory For Multipoles on Atoms + Atoms and Bonds
*
      Do iMltpl = 0, nMltPl
         nComp = (iMltpl+1)*(iMltpl+2)/2
         Write(MemLabel,'(A5,i3.3)') 'AMtPl',iMltpl
         Call GetMem(MemLabel,'Allo','Real',iAtMltPlAd(iMltpl),
     &   nComp*nAtoms)
         Write(MemLabel,'(A5,i3.3)') 'ABMtP',iMltpl
         Call GetMem(MemLabel,'Allo','Real',iAtBoMltPlAd(iMltpl),
     &   nComp*nCenters)
         Write(MemLabel,'(A5,i3.3)') 'MtPCp',iMltpl
         Call GetMem(MemLabel,'Allo','Real',iAtBoMltPlAdCopy(iMltpl),
     &   nComp*nCenters)
         nSum=nSum+nComp*(nAtoms+nCenters)
         Do i=1,nComp*nAtoms
            Work(iAtMltPlAd(iMltpl)+i-1)=0.0D0
         EndDo
         Do i=1,nComp*nCenters
            Work(iAtBoMltPlAd(iMltpl)+i-1)=0.0D0
         EndDo
      EndDo
*                                                                      *
************************************************************************
*                                                                      *
*---- Read the P-matrix
*
      Label='P_matrix'
      irc=-1
      iopt=1
      iComp=1
!EB      Call RdOne (irc,iopt,label,iComp,nInt,iSmLbl)
      Call iRdOne (irc,iopt,label,iComp,iDum,iSmLbl)
      nInt=iDum(1)
      If (irc.ne.0) Then
         Write (6,'(2A)') 'MPProp: Error getting length of ',
     &                            label
         Write(6,*) 'Length of the vector', nInt, iSmLbl
         Write(6,*) 'irc=',irc
         Call Abend()
      End If
      If (nInt.ne.nSize) Then
         Write (6,*) 'MPProp: nInt.ne.nSize'
         Write (6,*) 'nInt=',nInt
         Write (6,*) 'nSize=',nSize
         Call Abend()
      End If
      irc=-1
      iopt=0

      Call GetMem('CenX','Allo','Real',iCenX,nInt+4)
      Call GetMem('CenY','Allo','Real',iCenY,nInt+4)
      Call GetMem('CenZ','Allo','Real',iCenZ,nInt+4)
      nSum=nSum+nInt*3
*
      iComp=1
      Call RdOne (irc,iopt,label,iComp,Work(iCenX),iSmLbl)
      iComp=2
      Call RdOne (irc,iopt,label,iComp,Work(iCenY),iSmLbl)
      iComp=3
      Call RdOne (irc,iopt,label,iComp,Work(iCenZ),iSmLbl)
*                                                                      *
************************************************************************
*                                                                      *
*     Restore
*
      Call Put_iArray('nBas',nBas,1)
C     Call OneBas('CONT')
*                                                                      *
************************************************************************
*                                                                      *
*     READ TRANSFORMATION MATRIX  nPrim(i)*nBas(i)
*
*     The TM vectors holds the contraction coefficients of each
*     basisset in the primitive base. This means that the columns in the
*     TM are composed of the coefficients for each atomic basefunction
*     and there are nBas(iSym) of them. The coefficients found in each
*     column are exactly the same as in the basisset shifted to the
*     right position in the matrix column. For a hydrogen molecule
*     calculated with 2s function on each atom the first column will
*     look like (c11,c21,...,0,0,...) where the zeros are to delete the
*     primitive gaussians on the "second" hydrogen atom.
*     The second column looks like (c12,c22,...,0,0,...) and the third
*     (0,0,...,c11,c21,...) where in the third column the coefficients
*     are shifted to zero out the "first" hydrogen atom.
*
       nTM=0
       Do iSym = 1, nSym
          nTM = nTM + nBas(iSym)*nPrim(iSym)
       End Do
       Call GetMem('TM','Allo','Real',ip_TM,nTM)
       nSum=nSum+nTM
!      Runfile update
!       Call Get_TPC(Work(ip_TM),nTM)
       Call Get_dArray('NEMO TPC',Work(ip_TM),nTM)
!
*                                                                      *
************************************************************************
*                                                                      *
*---- Read the CMO's and occupation numbers
*
*     CMO's stored as nBas(iSym)*nSO(iSym)
*
      NOCOB=0
      nOcOb_b=0
      If(LLumOrb) Then
        If(Method.eq.'UHF-SCF') Then
          Call GetMem('Vec','Allo','Real',ip_Vec,2*nVec)
          Call GetMem('Occ','Allo','Real',ip_Occ,2*nOcc)
          Call GetMem('Ene','Allo','Real',ip_Ene,2*nOcc)
          nSum=nSum+4*nOcc+2*nVec
        Else
          Call GetMem('Vec','Allo','Real',ip_Vec,nVec)
          Call GetMem('Occ','Allo','Real',ip_Occ,nOcc)
          Call GetMem('Ene','Allo','Real',ip_Ene,2*nOcc)
c                    ! The 2* is for technical reason
          nSum=nSum+2*nOcc+nVec
        EndIf
        Lu_=11
        FName='INPORB'
        If(Method.eq.'UHF-SCF') Then
          Call RdVec_(FName,Lu_,'COE',1,nSym,nBas,nBas,Work(ip_Vec),
     &         Work(ip_Vec+nVec),Work(ip_Occ),Work(ip_Occ+nOcc),
     &         Work(ip_Ene),Work(ip_Ene+nOcc),iDum,VTitle,iWarn,iErr,
     &         iWFtype)
        Else
          Call RdVec(FName,Lu_,'COE',nSym,nBas,nBas,Work(ip_Vec),
     &         Work(ip_Occ),Work(ip_Ene),iDum,VTitle,iWarn,iErr)
        EndIf
        If (Index(VTitle,'IVO').ne.0) Then
          Write (6,*) ' MpProp not implemented for IVO orbitals!'
          Call Abend
        EndIf
!       If(iPol.eq.2) Then
!          Call LauraPol()
!       End If
        If(Method.eq.'UHF-SCF') Then
          Do i=0,nOcc-1
            If (Work(ip_Occ+i).ne.0.0D0) Then
              nOcOb = nOcOb + 1
            End If
          End Do
          Do i=nOcc,2*nOcc-1
            If (Work(ip_Occ+i).ne.0.0D0) Then
              nOcOb_b = nOcOb_b + 1
            End If
          End Do
        Else
          Do i=0,nOcc-1
            If (Work(ip_Occ+i).ne.0.0D0) Then
              nOcOb = nOcOb + 1
            End If
          End Do
        EndIf
*                                                                      *
************************************************************************
*                                                                      *
*---- Project the MO's on the primitive basis
*
        nVec_p=0
        Do iSym = 1, nSym
          nVec_p = nVec_p + nPrim(iSym)*nBas(iSym)
        End Do
        Call GetMem('Vec_p','Allo','Real',ip_Vec_p,nVec_p)
        nSum=nSum+nVec_p
        iOff1=ip_Vec
        iOff2=ip_TM
        iOff3=ip_Vec_p
        Do iSym = 1, nSym
          If (nPrim(iSym).gt.0) Then
            Call DGEMM_('N','N',
     &                  nPrim(iSym),nBas(iSym),nBas(iSym),
     &                  1.0d0,Work(iOff2),nPrim(iSym),
     &                  Work(iOff1),nBas(iSym),
     &                  0.0d0,Work(iOff3),nPrim(iSym))
            iOff1 = iOff1 + nBas(iSym)**2
            iOff2 = iOff2 + nPrim(iSym)*nBas(iSym)
            iOff3 = iOff3 + nPrim(iSym)*nBas(iSym)
          End If
        End Do

        If(Method.eq.'UHF-SCF') Then
          Call GetMem('Vec_p_b','Allo','Real',ip_Vec_p_b,nVec_p)
          nSum=nSum+nVec_p
          iOff1=ip_Vec+nVec
          iOff2=ip_TM
          iOff3=ip_Vec_p_b
          Do iSym = 1, nSym
            If (nPrim(iSym).gt.0) Then
              Call DGEMM_('N','N',
     &                    nPrim(iSym),nBas(iSym),nBas(iSym),
     &                    1.0d0,Work(iOff2),nPrim(iSym),
     &                    Work(iOff1),nBas(iSym),
     &                    0.0d0,Work(iOff3),nPrim(iSym))
              iOff1 = iOff1 + nBas(iSym)**2
              iOff2 = iOff2 + nPrim(iSym)*nBas(iSym)
              iOff3 = iOff3 + nPrim(iSym)*nBas(iSym)
            End If
          End Do
        EndIf
*
        Call GetMem('Ocof','Allo','Real',iOcof,nVec_p)
        nSum=nSum+nVec_p
        Call Get_OCOF(nPrim(1),nBas(1),Work(ip_Vec_p),nVec_p,
     &  Work(iOcof))
        If(Method.eq.'UHF-SCF') Then
          Call GetMem('Ocofb','Allo','Real',iOcof_b,nVec_p)
          nSum=nSum+nVec_p
          Call Get_OCOF(nPrim(1),nBas(1),Work(ip_Vec_p_b),nVec_p,
     &         Work(iOcof_b))
        EndIf
*
        Call Gen_Prim_Density_Matrix(nBas(1),nPrim(1),ip_D_p,nOcOb,
     &       Work(ip_Occ),Work(iOcof))
        If(Method.eq.'UHF-SCF') Then
          Call Gen_Prim_Density_Matrix(nBas(1),nPrim(1),ip_D_p_b,
     &         nOcOb_b,Work(ip_Occ+nOcc),Work(iOcof_b))
        EndIf
      Else
*                                                                      *
************************************************************************
*                                                                      *
*---- If the densities are used for expansion then
*---- Project the densities on the primitive basis
*
!       Get the orbital energy and allocate dubble memory due to UHF calculations
        If(Method.eq.'RHF-SCF') Then
          Call Get_OrbE_mpprop(ip_Ene,nOcc)
        Else
          Call GetMem('OrbE','Allo','Real',ip_Ene,2*nOcc)
          Do iEne=1,2*nOcc
            Work(ip_Ene+iEne-1)=0.0d0
          EndDo
        EndIf
        Call Get_Density_Matrix_mpprop(ip_D,nDens,nBas(1),nSym)
        Write(6,*) 'No polarizability will be calculated'
        iPol=0
        Call Get_Prim_Density_Matrix(ip_D,nBas(1),ip_D_p,nPrim(1),
     &      Work(ip_TM))
        Call Free_Work(ip_D)
      EndIf

*                                                                      *
************************************************************************
*                                                                      *
      Call Get_Prim_Atom_Tab(nAtoms,nPrim(1),Work(ip_Coor),
     &Work(iCenX),Work(iCenY),Work(iCenZ))
*                                                                      *
************************************************************************
*                                                                      *
* Get the SCF or RASSCF energy
!     Runfile update
!      Call Get_Energy(EneV)
      Call Get_dScalar('Last energy',EneV)
!
      Write(6,*)
      Write(6,'(a,f16.8)') ' Total SCF energy ', EneV
      Write(6,*)
      nOrbi = nBas(1)

* If multipoles and polarizability of the bonds should go to
* the atoms they belong to or to the nearest atom
      If(.not.LNearestAtom) Then
         Write(6,*)
         Write(6,*)' I will not move bonds and polarizabilities'
         Write(6,*)' to the nearest atom, just to the bonding pair'
         Write(6,*)
      Else
         Write(6,*)
         Write(6,*)' I WILL move bonds and polarizabilities'
         Write(6,*)' to the nearest atom'
         Write(6,*)
      EndIf

C     Get multipole properties
      LFirstRun=.True.

      Call Get_MpProp(nPrim(1),nBas(1),nAtoms,nCenters,!nOcOb,
!     &nMltPl,Work(ip_Occ),nOcc,Work(iOcof),
     &nMltPl,ip_D_p,
     &Work(iCenX),Work(iCenY),Work(iCenZ),LNearestAtom,
     &LFirstRun,LLumOrb)

      If(Method.eq.'UHF-SCF') Then
         LFirstRun=.False.
         Call Get_MpProp(nPrim(1),nBas(1),nAtoms,nCenters,!nOcOb_b,
!     &        nMltPl,Work(ip_Occ+nOcc),nOcc,Work(iOcof_b),
     &        nMltPl,ip_D_p_b,
     &        Work(iCenX),Work(iCenY),Work(iCenZ),LNearestAtom,
     &        LFirstRun,LLumOrb)
         LFirstRun=.True.
      EndIf

*
*-- If the esteemed user wants to obtain diffuse local distributions,
*   then proceed here. Much of the code is common with LoProp, hence
*   there is first a call to a routine to order some quantaties from
*   MpProp in the same say as in LoProp, then Mother Goose is called.
*
      If(Diffuse(1)) then
        Call StoreMpAsLop(nAtoms,ip_ANr,nBas(1),ip_Ttot,ip_Ttot_Inv
     &                   ,ipMP,nMltPl,ip_EC)
        Call GetMem('ToPoint','Allo','Real',iTP,nAtoms)
        Call CoreToPoint(nAtoms,ipMP,iTP)
        LuYou=IsFreeUnit(81)
        Call OpnFl('DIFFPR',LuYou,Exist)
        Call Diff_MotherGoose(Diffuse,nAtoms,nBas(1),ipMP,ip_Coor
     &                       ,nCenters,ip_EC
     &                       ,ip_ANr,ip_Ttot
     &                       ,ip_Ttot_Inv,nMltPl,iTP,dLimmo
     &                       ,Thrs1,Thrs2,nThrs,iPrint
     &                       ,ThrsMul,LuYou)
        Close(LuYou)
        Call Free_iWork(ip_ANr)
        Call GetMem('T','Free','Real',ip_Ttot,nBas(1)**2)
        Call GetMem('Tinv','Free','Real',ip_Ttot_Inv,nBas(1)**2)
        Call GetMem('ExpCent','Free','Real',ip_EC,3*nAtoms*(nAtoms+1)/2)
        nSize1=nAtoms*(nAtoms+1)/2
        nSize2=(nMltPl*(nMltPl**2+6*nMltPl+11)+6)/6
        Call GetMem('MultMom','Free','Real',ipMP,nSize1*nSize2)
        Call GetMem('ToPoint','Free','Real',iTP,nAtoms)
      Endif
*
*-- End of Diffuse.
*

      If(LLumOrb) Then
C     Get center of charge for each molecular orbital
       Call GetMem('Ocen','Allo','Real',iOcen,3*nOrbi)
       If(Method.eq.'UHF-SCF')
     & Call GetMem('Ocen_b','Allo','Real',iOcen_b,3*nOrbi)
       nSum=nSum+3*nOrbi*2
      EndIf
C     Get polarizabillities if iPol
      Call GetMem('AtPol','Allo','Real',iAtPolAd,nAtoms*6)
      Call GetMem('AtBoPol','Allo','Real',iAtBoPolAd,nCenters*6)
      nSum=nSum+6*(nCenters+nAtoms)
      Do i=0,nAtoms*6-1
         Work(iAtPolAd+i)=0.0D0
      EndDo
      Do i=0,nCenters*6-1
         Work(iAtBoPolAd+i)=0.0D0
      EndDo
      If(iPol.gt.0) Then
!EB         Call Get_OrbCen(nPrim(1),nBas(1),NORBI,Work(iWork(iMltPlAd(0)))
        Call Get_OrbCen(nPrim(1),NORBI,Work(iWork(iMltPlAd(0))),
     &  Work(iOcen),Work(iCenX),Work(iCenY),Work(iCenZ),Work(iOcof))
         If(Method.eq.'UHF-SCF')
     &     Call Get_OrbCen(nPrim(1),NORBI,Work(iWork(iMltPlAd(0))),
     &          Work(iOcen_b),Work(iCenX),Work(iCenY),Work(iCenZ),
     &          Work(iOcof_b))
         If(iPol.eq.1) Then
            If(nOcOb.lt.nOcc) Then
               Call Get_Polar(nPrim(1),nBas(1),nAtoms,nCenters,nOcOb,
!EB     &         Work(ip_Ene),Work(ip_Occ),nOcc,Work(iOcof),Work(iOcen),
     &         Work(ip_Ene),nOcc,Work(iOcof),Work(iOcen),LNearestAtom,
     &         LFirstRun)
               If(Method.eq.'UHF-SCF') Then
                  LFirstRun=.False.
                  Call Get_Polar(nPrim(1),nBas(1),nAtoms,nCenters,
     &            nOcOb_b,Work(ip_Ene+nOcc),nOcc,Work(iOcof_b),
     &            Work(iOcen_b),LNearestAtom,LFirstRun)
               EndIf
            Else
              Write(6,*)
              Write(6,*)'I will not do an analyze of the polarizability'
              Write(6,*)'no of occupied orb. is to large'
              Write(6,*)
              If(Method.eq.'UHF-SCF') Then
                 Write(6,*)' nOcOb nOcOb_b nOcc ',nOcOb,nOcOb_b,nOcc
              Else
                 Write(6,*)' nOcOb nOcc ',nOcOb,nOcc
              EndIf
              Write(6,*)
              iPol=0
            EndIf
         ElseIf(iPol.eq.2) Then
            Call LauraPol()
         EndIf
      End If

C     Write output, the properties
      Call Wr_Prop(nAtoms,nCenters,nBas(1),nMltPl,NOCOB,NOCOB_b,
     &     Work(ip_Ene),Work(ip_Ene+nOcc),iPol,LAllCenters)
*                                                                      *
************************************************************************
*                                                                      *
*     Deallocate Work
*
      Write(6,*)
      Write(6,*) 'Number of allocated real*8 words', nsum
      Write(6,'(a,f6.2,a)') ' That is ',dble(nsum)*8.0/1024.0/1024.0,
     &' MBytes'
      Write(6,*)
      Call Free_Work(ip_D_p)
!      If(iPol.gt.0) Then
         Call GetMem('AtBoPol','Free','Real',iAtBoPolAd,nCenters*6)
         Call GetMem('AtPol','Free','Real',iAtPolAd,nAtoms*6)
!      EndIf
      If(LLumorb) Then
        If(Method.eq.'UHF-SCF') Then
          Call GetMem('Ocen_b','Free','Real',iOcen_b,3*nOrbi)
          Call GetMem('Ocof','Free','Real',iOcof_b,nVec_p)
          Call GetMem('Vec_p','Free','Real',ip_Vec_p_b,nVec_p)
        EndIf
        Call GetMem('Ocen','Free','Real',iOcen,3*nOrbi)
        Call GetMem('Ocof','Free','Real',iOcof,nVec_p)
        Call GetMem('Vec_p','Free','Real',ip_Vec_p,nVec_p)
        Call GetMem('Occ','Free','Real',ip_Occ,nOcc)
        Call GetMem('Vec','Free','Real',ip_Vec,nVec)
      EndIf
      Call GetMem('Ene','Free','Real',ip_Ene,nOcc)
      Call GetMem('TM','Free','Real',ip_TM,nTM)
      Call GetMem('CenZ','Free','Real',iCenZ,nInt+4)
      Call GetMem('CenY','Free','Real',iCenY,nInt+4)
      Call GetMem('CenX','Free','Real',iCenX,nInt+4)
      Do iMltpl = 0, nMltPl
         nComp = (iMltpl+1)*(iMltpl+2)/2
         Write(MemLabel,'(A5,i3.3)') 'AMtPl',iMltpl
         Call GetMem(MemLabel,'Free','Real',iAtMltPlAd(iMltpl),
     &   nComp*nAtoms)
         Write(MemLabel,'(A5,i3.3)') 'ABMtP',iMltpl
         Call GetMem(MemLabel,'Free','Real',iAtBoMltPlAd(iMltpl),
     &   nComp*nCenters)
         Call GetMem(MemLabel,'Free','Real',iAtBoMltPlAdCopy(iMltpl),
     &   nComp*nCenters)
         Do iComp=1,nComp
            Write(MemLabel,'(i3.3,i5.5)') iMltpl, iComp
            Call GetMem(MemLabel,'Free','Real',
     &      iWork(iMltPlAd(iMltpl)+iComp-1),nInt+4)
         EndDo
         Write(MemLabel,'(A5,i3.3)') 'MltPl',iMltpl
         Call GetMem(MemLabel,'Free','Inte',iMltPlAd(iMltpl),nComp)
      EndDo
      Call GetMem('Qnuc','Free','Real',iQnuc,nAtoms)
      Call GetMem('Coord','Free','Real',ip_Coor,3*nAtoms)
      Call GetMem('Coord','Check','Real',ip_Coor,3*nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
      iReturn=0
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT_C136od(T2,X,Y,dimbe,dimga,no)
! this routine does:
! T2n(be',ga',u,v) <-
! C1                + 1/2 X(be',u,ga',v)
! C3                - 1/2 Y(be',u,ga',v)
! C6                - 1   Y(be',v,ga',u)
! for beGrp>gaGrp

use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimbe, dimga, no
real(kind=wp), intent(out) :: T2(dimbe,dimga,no,no)
real(kind=wp), intent(in) :: X(dimbe,no,dimga,no), Y(dimbe,no,dimga,no)
integer(kind=iwp) :: u, v

do v=1,no
  do u=1,no
    T2(:,:,u,v) = (X(:,u,:,v)-Y(:,u,:,v))*Half-Y(:,v,:,u)
  end do
end do

return

end subroutine MkT_C136od

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Freq_Molden(Freq,nFreq,Vectors,nVectors,nSym,Intens,mDisp,RedMas)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nFreq, nVectors, nSym, mDisp(nSym)
real(kind=wp), intent(in) :: Freq(nFreq), Vectors(nVectors), Intens(nFreq), RedMas(nFreq)
integer(kind=iwp) :: iCoor, iCoord, iFreq, Lu_9, nAll_Atoms, nCoord, nUnique_Atoms
real(kind=wp), allocatable :: Coord(:,:), NMode(:,:,:)
character(len=2), allocatable :: Element(:)
integer(kind=iwp), external :: isFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('Freq',' ',Freq,1,nFreq)
call RecPrt('Intens',' ',Intens,1,nFreq)
call RecPrt('Vectors',' ',Vectors,1,nVectors)
write(u6,*) 'mDisp=',mDisp
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Open input file for MOLDEN

Lu_9 = 9
Lu_9 = isFreeUnit(Lu_9)
call molcas_open(Lu_9,'MD_FREQ')
!                                                                      *
!***********************************************************************
!                                                                      *
write(Lu_9,*) '[Molden Format]'
!                                                                      *
!***********************************************************************
!                                                                      *
! Write frequecnies to Molden input file

write(Lu_9,*) '[N_FREQ]'
write(Lu_9,*) nFreq
write(Lu_9,*) '[FREQ]'
do iFreq=1,nFreq
  write(Lu_9,*) Freq(iFreq)
end do
write(Lu_9,*) '[INT]'
do iFreq=1,nFreq
  write(Lu_9,*) Intens(iFreq)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Write coordinates of all centers

call Get_nAtoms_All(nCoord)
call mma_allocate(Coord,3,nCoord,label='Coord')
call Get_Coord_All(Coord,nCoord)
#ifdef _DEBUGPRINT_
call RecPrt('Coord(all)',' ',Coord,3,nCoord)
#endif
call mma_allocate(Element,nCoord,label='Element')
call Get_Name_All(Element)
write(Lu_9,*) '[NATOM]'
write(Lu_9,*) nCoord

write(Lu_9,*) '[FR-COORD]'
do iCoord=1,nCoord
  write(Lu_9,*) Element(iCoord),Coord(:,iCoord)
end do
call mma_deallocate(Coord)
call mma_deallocate(Element)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write normal modes, observe that the order here is the same as
! for the coordinates.

call Get_iScalar('Unique atoms',nUnique_Atoms)
call Get_nAtoms_All(nAll_Atoms)
call mma_allocate(NMode,3,nAll_Atoms,nFreq,label='NMode')
NMode(:,:,:) = Zero
call Get_NMode_All(Vectors,nVectors,nFreq,nUnique_Atoms,NMode,nAll_Atoms,mDisp)
write(Lu_9,*) '[FR-NORM-COORD]'
#ifdef _DEBUGPRINT_
call RecPrt('Normal Modes',' ',NMode,3*nAll_Atoms,nFreq)
#endif
do iFreq=1,nFreq
  write(Lu_9,*) 'vibration ',iFreq
  do iCoor=1,nAll_Atoms
    write(Lu_9,*) NMode(:,iCoor,iFreq)
  end do
end do
call mma_deallocate(NMode)
!                                                                      *
!***********************************************************************
!                                                                      *
! Alessio Valentini 2018 - add reduced masses to freq.molden file
! in order to use this file for computation of initial conditions
! in semiclassical molecular dynamics

write(Lu_9,*) '[RMASS]'
do iFreq=1,nFreq
  write(Lu_9,*) RedMas(iFreq)
end do

close(Lu_9)

return

end subroutine Freq_Molden

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_caspt2_GetBaseNm(BaseNm,iTyp)

use Definitions, only: iwp

implicit none
character(len=3), intent(out) :: BaseNm
integer(kind=iwp), intent(in) :: iTyp

if (iTyp == 1) then
  BaseNm = '_PI'
else if (iTyp == 2) then
  BaseNm = '_PW'
else if (iTyp == 3) then
  BaseNm = '_CD'
else
  BaseNm = '_un'
end if

end subroutine Cho_caspt2_GetBaseNm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SETSXCI_m

      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
#include "output_ras.fh"
#include "sxci_mcpdft.fh"

      DIMENSION IOFF_GSSH(mxgas)
C
C ---------------------------------------------------------
C --  SET INDEX VECTORS FOR CI/SX INTEGRAL ORDERING
C ---------------------------------------------------------
C
      NGSSHT=0
      DO IGAS=1,NGAS
        IOFF_GSSH(IGAS)=NGSSHT
        NGSSHT=NGSSHT+SUM(NGSSH(IGAS,1:NSYM))
      END DO
      ISTOT=0
      DO ISYM=1,NSYM
        DO IGAS=1,NGAS
          DO IGSSH=1,NGSSH(IGAS,ISYM)
            IOFF_GSSH(IGAS)=IOFF_GSSH(IGAS)+1
            ISTOT=ISTOT+1
            IDXCI(ISTOT)=IOFF_GSSH(IGAS)
          END DO
        END DO
      END DO

      DO I=1,ISTOT
        IDXSX(IDXCI(I))=I
      END DO

      IF (IPRGLB.GE.DEBUG)THEN
        WRITE(6,'(1X,A,1X,12I5)')
     &   'REORDERING VECTOR FOR CI',(IDXCI(I),I=1,ISTOT)
        WRITE(6,'(1X,A,1X,12I5)')
     &   'REORDERING VECTOR FOR SX',(IDXSX(I),I=1,ISTOT)
      ENDIF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine change5_cvb()
      implicit real*8 (a-h,o-z)
      logical changed,construc
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "rls_cvb.fh"

c  Dimensioning for symmetry handling :
      changed=.false.
      if(chpcmp_cvb(nsyme))changed=.true.
      if(chpcmp_cvb(ndimrel))changed=.true.
      if(chpcmp_cvb(norbrel))changed=.true.
      if(chpcmp_cvb(nvb))changed=.true.
      if(chpcmp_cvb(nzrvb))changed=.true.
      if(chpcmp_cvb(nort))changed=.true.
      if(chpcmp_cvb(ndrot))changed=.true.

      orbfr_is_unit=(ndimrel.eq.0.and.nfxorb.eq.0
     >  .and.nort.eq.0.and.(.not.plc_const))
c  Set ORBFR_IS_UNIT if optimization method is 'NONE' :
      if(imethod.eq.11)orbfr_is_unit=.true.
      if(lchpcmp_cvb(orbfr_is_unit))changed=.true.
      nfxvbr=nfxvb
      if(lfxvb.eq.1)nfxvbr=nvb-nfxvb
      nzrvbr=nzrvb
      if(lzrvb.eq.1)nzrvbr=nvb-nzrvb
c  NPR arrays -- depend on nature of opt procedure
      construc=((nzrvbr.gt.0).or.
     >          (nfxvbr.gt.0.and.nfxvbr.lt.nvb).or.
     >          (nzeta.gt.0))
      if(construc)then
        if(nvb.gt.20.or..not.strucopt)then
          iconstruc=1
        else
          iconstruc=2
        endif
      else
        iconstruc=0
      endif
      if(chpcmp_cvb(iconstruc))changed=.true.
      if(changed)call touch_cvb('MEM5')
      return

      entry chop5_cvb()
      if(release(5))call mfreer_cvb(ls(1))
      release(5)=.true.
      release(6)=.false.

      ls(1)= mstackr_cvb(nsyme*norb*norb)
      ls(2)= mstacki_cvb(ndimrel)
      ls(3)= mstacki_cvb(norb)
      ls(4)= mstackr_cvb(norb*norb*norb)
      ls(5)= mstacki_cvb(2*(norb-1))
      ls(6)= mstackr_cvb(min(norb-1,norbrel)*norb*norb)
      ls(8)= mstacki_cvb(norb)
      ls(9)= mstacki_cvb(nvb)
      ls(10)= mstacki_cvb(nzrvb)
      ls(11)= mstacki_cvb(2*nort)
      ls(12)= mstacki_cvb(2*ndrot)
      ls(13)= mstacki_cvb(nsyme)
      if(.not.orbfr_is_unit)then
        ls(14)= mstackr_cvb(nprorb*nprorb)
      else
        ls(14)= mstackr_cvb(0)
      endif
      if(iconstruc.eq.2)then
        ls(15)= mstackr_cvb(nvb*nvb)
      else
        ls(15)= mstackr_cvb(0)
      endif
      ls(16)= mstacki_cvb(norb*nzeta)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Upd_FA_m(PUVX,F,D,ExFac)
************************************************************************
*                                                                      *
*     compute FIA, FAA, and FAS from the integral set (pu!vx)          *
*                                                                      *
*     calling arguments:                                               *
*     PUVX    : input, array of real                                   *
*               ERIs with indices (pu!vx)                              *
*               (three active, one general)                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension PUVX(*), F(*), D(*)

#include "rasdim.fh"
#include "general.fh"

      Integer case
      Integer   off_PUVX, off_Dmat, off_Fmat
      Dimension off_PUVX(mxSym), off_Dmat(mxSym), off_Fmat(mxSym)

      iTri(i)=(i*i-i)/2

*     generate offsets

      iStack = 0
      Do iSym = 1,nSym
         off_Dmat(iSym) = iStack
         iAsh = nAsh(iSym)
         iStack = iStack+ (iAsh*iAsh+iAsh)/2
      End Do

      iStack = 0
      Do iSym = 1,nSym
         off_Fmat(iSym) = iStack
         iOrb = nOrb(iSym)
         iStack = iStack+ (iOrb*iOrb+iOrb)/2
      End Do

      iStack = 0
      Do iSym = 1,nSym
        off_PUVX(iSym) = iStack
        iOrb = nOrb(iSym)
        Do jSym = 1,nSym
          jAsh = nAsh(jSym)
          ijSym = 1 + ieor(iSym-1,jSym-1)
          Do kSym = 1,nSym
            kAsh = nAsh(kSym)
            Do lSym = 1,kSym
              lAsh = nAsh(lSym)
              klSym = 1 + ieor(kSym-1,lSym-1)
              If ( ijSym.eq.klSym) then
                kl_Orb_pairs = kAsh*lAsh
                If ( kSym.eq.lSym ) kl_Orb_pairs = (kAsh*kAsh+kAsh)/2
                iStack = iStack + iOrb*jAsh*kl_Orb_pairs
              End If
            End Do
          End Do
        End Do
      End Do

*     clear the subbocks FIA, FAA and FSA

      Do iSym = 1,nSym
        iOrb  = nOrb(iSym)
        iAsh  = nAsh(iSym)
        iIsh  = nIsh(iSym)
        iFoff = off_Fmat(iSym)
        Do iU = iIsh+1,iIsh+iAsh
          Do iP = 1,iU
            iPU = iP + iTri(iU)
            F(iFoff+iPU) = 0.0d0
          End Do
        End Do
        Do iU = iIsh+iAsh+1,iOrb
          Do iP = iIsh+1,iIsh+iAsh
            iPU = iP + iTri(iU)
            F(iFoff+iPU) = 0.0d0
          End Do
        End Do
      End Do

*     generate the subblocks FIA, FAA and FSA

      Do iSym = 1,nSym
        iOrb = nOrb(iSym)
        iAsh = nAsh(iSym)
        iIsh = nIsh(iSym)
        iPUVX = off_PUVX(iSym)
        Do jSym = 1,iSym
          jOrb = nOrb(jSym)
          jAsh = nAsh(jSym)
          jIsh = nIsh(jSym)
          ijSym = 1 + ieor(iSym-1,jSym-1)
          Do kSym = 1,nSym
            kAsh = nAsh(kSym)
            Do lSym = 1,kSym
              lAsh = nAsh(lSym)
              klSym = 1 + ieor(kSym-1,lSym-1)

*             find cases
              case = 4
              If ( iSym.eq.jSym ) case = case-2
              If ( iSym.eq.kSym ) case = case-1

              If ( ijSym.eq.klSym .and.
     &             iAsh*jAsh*kAsh*lAsh.ne.0 ) then

                Goto (100,200,300,400) case

*               symmetry case (II!II)
100             Continue
                iFoff = off_Fmat(iSym)
                iDoff = off_Dmat(iSym)
                Do iV = 1,kAsh
                  Do iX = 1,iV
                    iVX = iTri(iV) + iX
                    DVX = 2.0D0*D(iDoff+iVX)
                    If ( iX.eq.iV ) DVX = D(iDoff+iVX)
                    Do iU = 1,jAsh
                      iUV = iTri(iU) + iV
                      If ( iV.gt.iU ) iUV  = iTri(iV) + iU
                      DUV = ExFac*0.5D0*D(iDoff+iUV)
                      iUX = iTri(iU) + iX
                      If ( iX.gt.iU ) iUX  = iTri(iX) + iU
                      DUX = ExFac*0.5D0*D(iDoff+iUX)
                      If ( iX.eq.iV ) then
                        DUV = ExFac*0.5D0*DUV
                        DUX = ExFac*0.5D0*DUX
                      End If
                      iPUVX = off_PUVX(iSym)
*                     inactive/active block
                      Do iP = 1,iIsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iIsh+iU) + iP
                        F(iFoff+iPU) = F(iFoff+iPU) + DVX*Temp
                        iPV  = iTri(iIsh+iV) + iP
                        F(iFoff+iPV) = F(iFoff+iPV) - DUX*Temp
                        iPX  = iTri(iIsh+iX) + iP
                        F(iFoff+iPX) = F(iFoff+iPX) - DUV*Temp
                      End Do
*                     active/active block and iP<=(iIsh+iU)
                      Do iP = iIsh+1,iIsh+iU
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iIsh+iU) + iP
                        F(iFoff+iPU) = F(iFoff+iPU) + DVX*Temp
                        iPV  = iTri(iIsh+iV) + iP
                        If ( iP.gt.(iIsh+iV) )
     &                  iPV  = iTri(iP) + iIsh + iV
                        F(iFoff+iPV) = F(iFoff+iPV)-ExFac*0.5D0*DUX*Temp
                        If ( iP.eq.(iIsh+iV) )
     &                  F(iFoff+iPV) = F(iFoff+iPV)-ExFac*0.5D0*DUX*Temp
                        iPX  = iTri(iIsh+iX) + iP
                        If ( iP.gt.(iIsh+iX) )
     &                  iPX  = iTri(iP) + iIsh + iX
                        F(iFoff+iPX) = F(iFoff+iPX)-ExFac*0.5D0*DUV*Temp
                        If ( iP.eq.(iIsh+iX) )
     &                  F(iFoff+iPX) = F(iFoff+iPX)-ExFac*0.5D0*DUV*Temp
                      End Do
*                     active/active block and iP>(iIsh+iU)
                      Do iP = iIsh+iU+1,iIsh+iAsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPV  = iTri(iIsh+iV) + iP
                        If ( iP.gt.(iIsh+iV) )
     &                  iPV  = iTri(iP) + iIsh + iV
                        F(iFoff+iPV) = F(iFoff+iPV)-ExFac*0.5D0*DUX*Temp
                        If ( iP.eq.(iIsh+iV) )
     &                  F(iFoff+iPV) = F(iFoff+iPV)-ExFac*0.5D0*DUX*Temp
                        iPX  = iTri(iIsh+iX) + iP
                        If ( iP.gt.(iIsh+iX) )
     &                  iPX  = iTri(iP) + iIsh + iX
                        F(iFoff+iPX) = F(iFoff+iPX)-ExFac*0.5D0*DUV*Temp
                        If ( iP.eq.(iIsh+iX) )
     &                  F(iFoff+iPX) = F(iFoff+iPX)-ExFac*0.5D0*DUV*Temp
                      end Do
*                     active/secondary block
                      Do iP = iIsh+iAsh+1,iOrb
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iP) + iIsh + iU
                        F(iFoff+iPU) = F(iFoff+iPU) + DVX*Temp
                        iPV  = iTri(iP) + iIsh + iV
                        F(iFoff+iPV) = F(iFoff+iPV) - DUX*Temp
                        iPX  = iTri(iP) + iIsh + iX
                        F(iFoff+iPX) = F(iFoff+iPX) - DUV*Temp
                      End Do
                      off_PUVX(iSym) = off_PUVX(iSym) + iOrb
                    End Do
                  End Do
                End Do
                Goto 500

*               symmetry case (II!KK)
200             Continue
                iFoff = off_Fmat(iSym)
                kDoff = off_Dmat(kSym)
                Do iV = 1,kAsh
                  Do iX = 1,iV
                    iVX = iTri(iV) + iX
                    DVX = 2.0D0*D(kDoff+iVX)
                    If ( iX.eq.iV ) DVX = D(kDoff+iVX)
                    Do iU = 1,jAsh
                      iPUVX = off_PUVX(iSym)
*                     inactive/active block
                      Do iP = 1,iIsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iIsh+iU) + iP
                        F(iFoff+iPU) = F(iFoff+iPU) + DVX*Temp
                      End Do
*                     active/active block and iP<=(iIsh+iU)
                      Do iP = iIsh+1,iIsh+iU
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iIsh+iU) + iP
                        F(iFoff+iPU) = F(iFoff+iPU) + DVX*Temp
                      End Do
                      iPUVX = iPUVX + iAsh - iU
*                     active/secondary block
                      Do iP = iIsh+iAsh+1,iOrb
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iP) + iIsh + iU
                        F(iFoff+iPU) = F(iFoff+iPU) + DVX*Temp
                      End Do
                      off_PUVX(iSym) = off_PUVX(iSym) + iOrb
                    End Do
                  End Do
                End Do
                Goto 500

*               symmetry case (IJ!IJ)
300             Continue
                iFoff = off_Fmat(iSym)
                jFoff = off_Fmat(jSym)
                iDoff = off_Dmat(iSym)
                jDoff = off_Dmat(jSym)
                Do iV = 1,kAsh
                  Do iX = 1,lAsh
                    Do iU= 1,jAsh
                      iUX = iTri(iU) + iX
                      If ( iX.gt.iU ) iUX  = iTri(iX) + iU
                      DUX = ExFac*0.5D0*D(jDoff+iUX)
                      iPUVX = off_PUVX(iSym)
*                     inactive/active block
                      Do iP = 1,iIsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPV  = iTri(iIsh+iV) + iP
                        F(iFoff+iPV) = F(iFoff+iPV) - DUX*Temp
                      End Do
*                     active/active block and iP<=(iIsh+iV)
                      Do iP = iIsh+1,iIsh+iV
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPV  = iTri(iIsh+iV) + iP
                        F(iFoff+iPV) = F(iFoff+iPV) - DUX*Temp
                      End Do
                      iPUVX = iPUVX + iAsh - iV
*                     active/secondary block
                      Do iP = iIsh+iAsh+1,iOrb
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPV  = iTri(iP) + iIsh + iV
                        F(iFoff+iPV) = F(iFoff+iPV) - DUX*Temp
                      End Do
                      off_PUVX(iSym) = off_PUVX(iSym) + iOrb
                    End Do
                    Do iU= 1,iAsh
                      iUV = iTri(iU) + iV
                      If ( iV.gt.iU ) iUV  = iTri(iV) + iU
                      DUV = ExFac*0.5D0*D(iDoff+iUV)
                      iPUVX = off_PUVX(jSym)
*                     inactive/active block
                      Do iP = 1,jIsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPX  = iTri(jIsh+iX) + iP
                        F(jFoff+iPX) = F(jFoff+iPX) - DUV*Temp
                      End Do
*                     active/active block and iP<=(jIsh+iX)
                      Do iP = jIsh+1,jIsh+iX
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPX  = iTri(jIsh+iX) + iP
                        F(jFoff+iPX) = F(jFoff+iPX) - DUV*Temp
                      End Do
                      iPUVX = iPUVX + jAsh - iX
*                     active/secondary block
                      Do iP = jIsh+jAsh+1,jOrb
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPX  = iTri(iP) + jIsh + iX
                        F(jFoff+iPX) = F(jFoff+iPX) - DUV*Temp
                      End Do
                      off_PUVX(jSym) = off_PUVX(jSym) + jOrb
                    End Do
                  End Do
                End Do
                Goto 500

*               symmetry case (IJ!KL)
400             Continue
                Do iV = 1,kAsh
                  Do iX = 1,lAsh
                    off_PUVX(iSym) = off_PUVX(iSym) + jAsh*iOrb
                    off_PUVX(jSym) = off_PUVX(jSym) + iAsh*jOrb
                  End Do
                End Do

500             Continue
              End If

            End Do
          End Do
        End Do
      End Do

      Return
      End



      Subroutine Upd_FI_m(PUVX,F,D,ExFac)
************************************************************************
*                                                                      *
*     compute FIA, FAA, and FAS from the integral set (pu!vx)          *
*                                                                      *
*     calling arguments:                                               *
*     PUVX    : input, array of real                                   *
*               ERIs with indices (pu!vx)                              *
*               (three active, one general)                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension PUVX(*), F(*), D(*)

#include "rasdim.fh"
#include "general.fh"
#include "WrkSpc.fh"

      Integer   off_Fmat
      Dimension  off_Fmat(mxSym)
      Integer off_Bas(mxSym),off_ish(mxSym)
      Integer off_BasAsh(mxSym)
      Integer p,q,ipq
      Integer iStack1,iStack2,iStack
      Integer count_tmp

      iTri(i)=(i*i-i)/2

*     generate offsets

************************************************************************
      Call unused_real_array(D)
      Call unused_real_array(PUVX)
      Call unused_real(ExFac)

      istack = 0
      iStack1 = 0
      iStack2 = 0
      Do iSym = 1,nSym
        off_Bas(iSym)    = iStack1
        off_ish(isym)    = iStack2
        off_BasAsh(isym) = iStack1 + nIsh(iSym) + nFro(iSym)
        off_Fmat(iSym) = iStack
        iOrb = nOrb(iSym)
        iStack = iStack+ (iOrb*iOrb+iOrb)/2
        iStack1 = iStack1 + nBas(iSym)
        iStack2 = iStack2 + nIsh(iSym)
      End Do

!count the number of tmp_pot:
      count_tmp = 0

      count_tmp = 0
      do isym=1,nsym
        do jsym=1,nsym
        count_tmp = count_tmp + nIsh(isym)*(nIsh(jsym)+nAsh(jsym))**2
        end do
      end do

      CALL GETMEM('PUVX_TMP','Allo','REAL',iTMPP,count_tmp)
      Call Get_dArray('TEP_I',Work(iTMPP),count_tmp)

      Call wrtmat(Work(iTMPP),1,count_tmp,1,count_tmp)

      Call wrtmat(F,1,ntot1,1,ntot1)
!      Call dcopy_(ntot1,0d0,0,F,1)

      !I am reading them in the same order that they were written:
      !routine nq_util/calc_otpuvx

      !I only need case 3 here, though, right?
      iPUVX = -1
      do isym=1,nsym
        do jsym=1,nsym
          do k=1+off_bas(isym),nish(isym)+off_bas(isym)
      !CASE 1: p and q are inactive
            do p=1+off_bas(jsym),nIsh(jsym)+off_bas(jsym)
              do q=1+off_bas(jsym),nIsh(jsym)+off_bas(jsym)
              iPUVX = iPUVX + 1
              ipq = off_Fmat(jsym) + iTri(p-off_ish(jsym)) + q
              if (q.gt.p) then
                ipq = off_Fmat(jsym) + iTri(q-off_ish(jsym)) + p
              end if
              F(ipq) = F(ipq) + Work(iTMPP + iPUVX)
              end do
            end do
      !CASE 2: p is inactive, q is active
            do p=1+off_bas(jsym),nIsh(jsym)+off_bas(jsym)
              do q=1+off_basash(jsym),nAsh(jsym)+off_basash(jsym)
              ipq = off_Fmat(jsym) + iTri(p-off_ish(jsym)) + q
              if (q.gt.p) then
                ipq = off_Fmat(jsym) + iTri(q-off_ish(jsym)) + p
              end if
              iPUVX = iPUVX + 1
              !F(ipq) = F(ipq) + Work(iTMPP + iPUVX)
              end do
            end do
      !CASE 3: p and q are active
            do p=1+off_basash(jsym),nAsh(jsym)+off_basash(jsym)
              do q=1+off_basash(jsym),nAsh(jsym)+off_basash(jsym)
              ipq = off_Fmat(jsym) + iTri(p-off_ish(jsym)) + q
              if (q.gt.p) then
                ipq = off_Fmat(jsym) + iTri(q-off_ish(jsym)) + p
              end if
              iPUVX = iPUVX + 1
              !F(ipq) = F(ipq) + Work(iTMPP + iPUVX)
              end do
            end do
          end do
        end do
      end do

      CALL GETMEM('PUVX_TMP','FREE','REAL',iTMPP,count_tmp)

!Now to do the one-electron pieces.  We need to add to FI the ii, ia,
!and aa one-electron on-top potentials.

!All of the terms should be included in ONTOPO, I think.  So, just add
!it.
      Call wrtmat(F,1,ntot1,1,ntot1)

      call dcopy_(ntot1,[0.0d0],0,F,1)

      CALL GETMEM('OEPOTS','ALLO','REAL',iTMPP,ntot1)
      Call Get_dArray('ONTOPO',work(iTMPP),NTOT1)
      Call DaXpY_(NTOT1,1.0D0,Work(iTMPP),1,F,1)
      CALL GETMEM('OEPOTS','Free','REAL',iTMPP,ntot1)

      Call wrtmat(F,1,ntot1,1,ntot1)

!Read in the ii/ia part:


************************************************************************

      Return
      End

      Subroutine Upd_FA_CI(PUVX,F,ExFac)

************************************************************************
*                                                                      *
*     compute FIA, FAA, and FAS from the integral set (pu!vx)          *
*                                                                      *
*     calling arguments:                                               *
*     PUVX    : input, array of real                                   *
*               ERIs with indices (pu!vx)                              *
*               (three active, one general)                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension PUVX(*), F(*)

#include "rasdim.fh"
#include "general.fh"

      Integer case
      Integer   off_PUVX, off_Fmat
      Dimension off_PUVX(mxSym), off_Fmat(mxSym)

      iTri(i)=(i*i-i)/2

      Call unused_real(ExFac)

*     generate offsets

      iStack = 0
      Do iSym = 1,nSym
         iAsh = nAsh(iSym)
         iStack = iStack+ (iAsh*iAsh+iAsh)/2
      End Do

      iStack = 0
      Do iSym = 1,nSym
         off_Fmat(iSym) = iStack
         iOrb = nOrb(iSym)
         iStack = iStack+ (iOrb*iOrb+iOrb)/2
      End Do

      iStack = 0
      Do iSym = 1,nSym
        off_PUVX(iSym) = iStack
        iOrb = nOrb(iSym)
        Do jSym = 1,nSym
          jAsh = nAsh(jSym)
          ijSym = 1 + ieor(iSym-1,jSym-1)
          Do kSym = 1,nSym
            kAsh = nAsh(kSym)
            Do lSym = 1,kSym
              lAsh = nAsh(lSym)
              klSym = 1 + ieor(kSym-1,lSym-1)
              If ( ijSym.eq.klSym) then
                kl_Orb_pairs = kAsh*lAsh
                If ( kSym.eq.lSym ) kl_Orb_pairs = (kAsh*kAsh+kAsh)/2
                iStack = iStack + iOrb*jAsh*kl_Orb_pairs
              End If
            End Do
          End Do
        End Do
      End Do

*     clear the subbocks FIA, FAA and FSA

      Do iSym = 1,nSym
        iOrb  = nOrb(iSym)
        iAsh  = nAsh(iSym)
        iIsh  = nIsh(iSym)
        iFoff = off_Fmat(iSym)
        Do iU = iIsh+1,iIsh+iAsh
          Do iP = 1,iU
            iPU = iP + iTri(iU)
            F(iFoff+iPU) = 0.0d0
          End Do
        End Do
        Do iU = iIsh+iAsh+1,iOrb
          Do iP = iIsh+1,iIsh+iAsh
            iPU = iP + iTri(iU)
            F(iFoff+iPU) = 0.0d0
          End Do
        End Do
      End Do

*     generate the subblocks FIA, FAA and FSA

      Do iSym = 1,nSym
        iOrb = nOrb(iSym)
        iAsh = nAsh(iSym)
        iIsh = nIsh(iSym)
        iPUVX = off_PUVX(iSym)
        Do jSym = 1,iSym
          jOrb = nOrb(jSym)
          jAsh = nAsh(jSym)
          jIsh = nIsh(jSym)
          ijSym = 1 + ieor(iSym-1,jSym-1)
          Do kSym = 1,nSym
            kAsh = nAsh(kSym)
            Do lSym = 1,kSym
              lAsh = nAsh(lSym)
              klSym = 1 + ieor(kSym-1,lSym-1)

*             find cases
              case = 4
              If ( iSym.eq.jSym ) case = case-2
              If ( iSym.eq.kSym ) case = case-1

              If ( ijSym.eq.klSym .and.
     &             iAsh*jAsh*kAsh*lAsh.ne.0 ) then

                Goto (100,200,300,400) case

*               symmetry case (II!II)
100             Continue
                iFoff = off_Fmat(iSym)
                Do iV = 1,kAsh
                  Do iX = 1,iV
                    Do iU = 1,jAsh
                      If ( iX.eq.iV ) then
                      End If
                      iPUVX = off_PUVX(iSym)
*                     inactive/active block
                      Do iP = 1,iIsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iIsh+iU) + iP
                        F(iFoff+iPU) = F(iFoff+iPU) + Temp
                        iPV  = iTri(iIsh+iV) + iP
                        F(iFoff+iPV) = F(iFoff+iPV) - Temp
                        iPX  = iTri(iIsh+iX) + iP
                        F(iFoff+iPX) = F(iFoff+iPX) - Temp
                      End Do
*                     active/active block and iP<=(iIsh+iU)
                      Do iP = iIsh+1,iIsh+iU
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iIsh+iU) + iP
                        F(iFoff+iPU) = F(iFoff+iPU) + Temp

                        iPV  = iTri(iIsh+iV) + iP
                        If ( iP.gt.(iIsh+iV) )
     &                  iPV  = iTri(iP) + iIsh + iV
                        !F(iFoff+iPV) = F(iFoff+iPV)-ExFac*0.5D0*Temp
                        !If ( iP.eq.(iIsh+iV) )
     &                  !F(iFoff+iPV) = F(iFoff+iPV)-ExFac*0.5D0*Temp
                        iPX  = iTri(iIsh+iX) + iP
                        If ( iP.gt.(iIsh+iX) )
     &                  iPX  = iTri(iP) + iIsh + iX
                        !F(iFoff+iPX) = F(iFoff+iPX)-ExFac*0.5D0*Temp
                        !If ( iP.eq.(iIsh+iX) )
     &                  !F(iFoff+iPX) = F(iFoff+iPX)-ExFac*0.5D0*Temp
                      End Do
*                     active/active block and iP>(iIsh+iU)
                      Do iP = iIsh+iU+1,iIsh+iAsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPV  = iTri(iIsh+iV) + iP
                        If ( iP.gt.(iIsh+iV) )
     &                  iPV  = iTri(iP) + iIsh + iV
                        !F(iFoff+iPV) = F(iFoff+iPV)-ExFac*0.5D0*Temp
                        !If ( iP.eq.(iIsh+iV) )
     &                  !F(iFoff+iPV) = F(iFoff+iPV)-ExFac*0.5D0*Temp
                        iPX  = iTri(iIsh+iX) + iP
                        If ( iP.gt.(iIsh+iX) )
     &                  iPX  = iTri(iP) + iIsh + iX
                        !F(iFoff+iPX) = F(iFoff+iPX)-ExFac*0.5D0*Temp
                        !If ( iP.eq.(iIsh+iX) )
     &                  !F(iFoff+iPX) = F(iFoff+iPX)-ExFac*0.5D0*Temp
                      end Do
*                     active/secondary block
                      Do iP = iIsh+iAsh+1,iOrb
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iP) + iIsh + iU
                        F(iFoff+iPU) = F(iFoff+iPU) + Temp
                        iPV  = iTri(iP) + iIsh + iV
                        F(iFoff+iPV) = F(iFoff+iPV) - Temp
                        iPX  = iTri(iP) + iIsh + iX
                        F(iFoff+iPX) = F(iFoff+iPX) - Temp
                      End Do
                      off_PUVX(iSym) = off_PUVX(iSym) + iOrb
                    End Do
                  End Do
                End Do
                Goto 500

*               symmetry case (II!KK)
200             Continue
                iFoff = off_Fmat(iSym)
                Do iV = 1,kAsh
                  Do iX = 1,iV
                    Do iU = 1,jAsh
                      iPUVX = off_PUVX(iSym)
*                     inactive/active block
                      Do iP = 1,iIsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iIsh+iU) + iP
                        F(iFoff+iPU) = F(iFoff+iPU) + Temp
                      End Do
*                     active/active block and iP<=(iIsh+iU)
                      Do iP = iIsh+1,iIsh+iU
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iIsh+iU) + iP
                        F(iFoff+iPU) = F(iFoff+iPU) + Temp
                      End Do
                      iPUVX = iPUVX + iAsh - iU
*                     active/secondary block
                      Do iP = iIsh+iAsh+1,iOrb
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPU  = iTri(iP) + iIsh + iU
                        F(iFoff+iPU) = F(iFoff+iPU) + Temp
                      End Do
                      off_PUVX(iSym) = off_PUVX(iSym) + iOrb
                    End Do
                  End Do
                End Do
                Goto 500

*               symmetry case (IJ!IJ)
300             Continue
                iFoff = off_Fmat(iSym)
                jFoff = off_Fmat(jSym)
                Do iV = 1,kAsh
                  Do iX = 1,lAsh
                    Do iU= 1,jAsh
                      iPUVX = off_PUVX(iSym)
*                     inactive/active block
                      Do iP = 1,iIsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPV  = iTri(iIsh+iV) + iP
                        F(iFoff+iPV) = F(iFoff+iPV) - Temp
                      End Do
*                     active/active block and iP<=(iIsh+iV)
                      Do iP = iIsh+1,iIsh+iV
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPV  = iTri(iIsh+iV) + iP
                        F(iFoff+iPV) = F(iFoff+iPV) - Temp
                      End Do
                      iPUVX = iPUVX + iAsh - iV
*                     active/secondary block
                      Do iP = iIsh+iAsh+1,iOrb
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPV  = iTri(iP) + iIsh + iV
                        F(iFoff+iPV) = F(iFoff+iPV) - Temp
                      End Do
                      off_PUVX(iSym) = off_PUVX(iSym) + iOrb
                    End Do
                    Do iU= 1,iAsh
                      iPUVX = off_PUVX(jSym)
*                     inactive/active block
                      Do iP = 1,jIsh
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPX  = iTri(jIsh+iX) + iP
                        F(jFoff+iPX) = F(jFoff+iPX) - Temp
                      End Do
*                     active/active block and iP<=(jIsh+iX)
                      Do iP = jIsh+1,jIsh+iX
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPX  = iTri(jIsh+iX) + iP
                        F(jFoff+iPX) = F(jFoff+iPX) - Temp
                      End Do
                      iPUVX = iPUVX + jAsh - iX
*                     active/secondary block
                      Do iP = jIsh+jAsh+1,jOrb
                        iPUVX = iPUVX + 1
                        Temp = PUVX(iPUVX)
                        iPX  = iTri(iP) + jIsh + iX
                        F(jFoff+iPX) = F(jFoff+iPX) - Temp
                      End Do
                      off_PUVX(jSym) = off_PUVX(jSym) + jOrb
                    End Do
                  End Do
                End Do
                Goto 500

*               symmetry case (IJ!KL)
400             Continue
                Do iV = 1,kAsh
                  Do iX = 1,lAsh
                    off_PUVX(iSym) = off_PUVX(iSym) + jAsh*iOrb
                    off_PUVX(jSym) = off_PUVX(jSym) + iAsh*jOrb
                  End Do
                End Do

500             Continue
              End If

            End Do
          End Do
        End Do
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine locates a field in the runfile.                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund university, Sweden                                     *
! Written: August 2003                                                 *
!                                                                      *
!***********************************************************************

subroutine ffRun(Label,nData,RecTyp)

use RunFile_data, only: rcNotFound, rcOK, TypUnk
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(out) :: nData, RecTyp
integer(kind=iwp) :: iOpt, iRc
character(len=64) :: ErrMsg

!----------------------------------------------------------------------*
! Call extended version routine.                                       *
!----------------------------------------------------------------------*
iRc = rcOK
iOpt = 0
call ffxRun(iRc,Label,nData,RecTyp,iOpt)
if (iRc == rcNotFound) then
  nData = 0
  RecTyp = TypUnk
else if (iRc /= rcOK) then
  write(ErrMsg,'(3a)') 'Error locating field "',Label,'" in runfile'
  call SysAbendMsg('ffRun',ErrMsg,' ')
end if
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine ffRun

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

!***********************************************************************
! Case C (ICASE=4)
!***********************************************************************
subroutine MKSC(DREF,NDREF,PREF,NPREF,NG3,G3,idxG3)

use Index_Functions, only: nTri_Elem
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
#endif
use fake_GA, only: GA_Arrays
use caspt2_global, only: iPrGlb
use caspt2_module, only: NINDEP, NSYM, NTUV
use Definitions, only: wp, iwp, u6, byte

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF, NG3
real(kind=wp), intent(in) :: DREF(NDREF), PREF(NPREF)
real(kind=wp), intent(inout) :: G3(NG3)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: ICASE, IHI, ILO, ISYM, JHI, JLO, LDC, lg_SC, NAS, NIN, NSC
real(kind=wp) :: DSC
real(kind=wp), external :: PSBMAT_FPRINT
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: MC, MSC, MYRANK
real(kind=wp) :: Dummy(1)
#endif

ICASE = 4
! LONG loop over superindex symmetry.
do ISYM=1,NSYM
  NIN = NINDEP(ISYM,ICASE)
  if (NIN == 0) cycle
  NAS = NTUV(ISYM)
  NSC = nTri_Elem(NAS)
  if (NSC <= 0) cycle

  ! Set up the matrix SC(tuv,xyz) defined by the expression
  ! <atuv|cxyz> = dac SC(tuv,xyz)
  ! Formula used:
  !    SC(tuv,xyz)
  !    = Gvutxyz +dyu Gvztx + dyx Gvutz + dtu Gvxyz + dtu dyx Gvz

  call PSBMAT_GETMEM('SC',lg_SC,NAS)

  ! fill in the 3-el parts
# ifdef _MOLCAS_MPP_
  if (IS_REAL_PAR()) then
    MYRANK = GA_NODEID()
    call GA_DISTRIBUTION(LG_SC,MYRANK,ILO,IHI,JLO,JHI)
    if ((JLO /= 0) .and. (JHI-JLO+1 /= NAS)) then
      write(u6,*) 'MKSC: MISMATCH IN RANGE OF THE SUPERINDICES'
      call ABEND()
    end if
    if ((ILO > 0) .and. (JLO > 0)) then
      call GA_ACCESS(LG_SC,ILO,IHI,JLO,JHI,MC,LDC)
      call MKSC_G3_MPP(ISYM,DBL_MB(MC),ILO,NAS,LDC,NG3,G3,IDXG3)
      MSC = LDC*(jHi-jLo+1)
      call MKSC_DP(DREF,NDREF,PREF,NPREF,ISYM,DBL_MB(MC),MSC,ILO,IHI,JLO,JHI,LDC)
      call GA_RELEASE_UPDATE(LG_SC,ILO,IHI,JLO,JHI)
    else
      call MKSC_G3_MPP(ISYM,DUMMY,ILO,NAS,LDC,NG3,G3,IDXG3)
    end if
  else
# endif
    iLo = 1
    iHi = NAS
    jLo = 1
    jHi = NAS
    LDC = 0
    call MKSC_G3(ISYM,GA_Arrays(lg_SC)%A(:),NSC,NG3,G3,IDXG3)
    call MKSC_DP(DREF,NDREF,PREF,NPREF,ISYM,GA_Arrays(lg_SC)%A(:),NSC,ILO,IHI,JLO,JHI,LDC)
# ifdef _MOLCAS_MPP_
  end if
# endif

  call PSBMAT_WRITE('S',iCase,iSYM,lg_SC,NAS)

  if (IPRGLB >= DEBUG) then
    DSC = PSBMAT_FPRINT(lg_SC,NAS)
    write(u6,'("DEBUG> ",A4,1X,I3,1X,ES21.14)') 'C',ISYM,DSC
  end if

  call PSBMAT_FREEMEM(lg_SC)
end do

end subroutine MKSC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRACI_MASTER(JOBDISK,JOBIPH,CMOMO,lrec)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "clunit.fh"
#include "crun.fh"
#include "cicisp.fh"
#include "cstate.fh"
#include "glbbas.fh"
#include "orbinp.fh"
#include "cands.fh"
#include "spinfo_lucia.fh"
#include "lucinp.fh"
#include "rasscf_lucia.fh"
#include "io_util.fh"
*
      LOGICAL IPACK
      DIMENSION LREC(MXNTTS),CMOMO(*)
      DIMENSION IDUMMY(1)
*
      NTEST = 0
      LBLK  = -1
      NDIM  = NTOOB*NTOOB
      IDUM  = 0
      NCONF = NCSF_PER_SYM(ISSM)
* JESPER: Should reduce I/O
      LBLOCK = MAX(INT(XISPSM(IREFSM,1)),MXSOOB)
      IF(PSSIGN.NE.0.0D0) LBLOCK = INT(2.0D0*XISPSM(IREFSM,1))
      IDUM=0
*
*. The three scratch  blocks
C          GET_3BLKS(KVEC1,KVEC2,KC2)
C_REPLACED BY CALLS BELOW      CALL GET_3BLKS(KVEC1,KVEC2,KVEC3)
      CALL GETMEM('VEC1  ','ALLO','REAL',KVEC1,LBLOCK)
      CALL GETMEM('VEC2  ','ALLO','REAL',KVEC2,LBLOCK)
      CALL GETMEM('KC2   ','ALLO','REAL',KVEC3,KVEC3_LENGTH)
      CALL GETMEM('KVEC4 ','ALLO','REAL',KVEC4,NCONF)
*
* Transfer the CI-vector to LUC
*
      CALL BLKFO_MIN(ISSM,NREC,LREC)
      IDISK(LUC)=0
      JDISK = JOBDISK
      DO JROOT = 1,NROOT
         CALL DDAFILE(JOBIPH,2,WORK(KVEC4),NCONF,JDISK)
         CALL CSDTVC(WORK(KVEC4),WORK(KVEC1),1,WORK(KDTOC_POINTER),
     &                    iWORK(KSDREO_POINTER),ISSM,0)
         IF (NTEST .GE. 50) THEN
            Write(6,*) 'CI-vector written to disk for root = ',JROOT
            CALL WRTMAT(WORK(KVEC1),1,20,1,20)
            CALL XFLUSH(6)
            Write(6,*) 'Writing this to disk:'
            IOFF  = 0
            DO IREC = 1, NREC
               IF (LREC(IREC) .GE. 0) THEN
                  CALL WRTMAT(WORK(KVEC1+IOFF),1,LREC(IREC),
     &                  1,LREC(IREC))
                  IOFF = IOFF + LREC(IREC)
               END IF
            END DO
            CALL XFLUSH(6)
         END IF
         CALL TODSCN(WORK(KVEC1),NREC,LREC,LBLK,LUC)
         CALL ITODS([-1],1,LBLK,LUC)
      END DO

*. MO-MO transformation matrix :
      CALL GETMEM('CMOMO ','ALLO','REAL',KLCMOMO,NDIM)
*. Copy of one-electron integrals
      CALL GETMEM('H1SAVE','ALLO','REAL',KLH1SAVE,NDIM)
*. We are going to mess with the one-electron integrals, take a copy
      CALL COPVEC(WORK(KINT1),WORK(KLH1SAVE),NDIM)
*. Set up block structure of CI space
      IATP = 1
      IBTP = 2
      CALL  Z_BLKFO(ISSPC,ISSM,IATP,IBTP,KLCLBT,KLCLEBT,
     &      KLCI1BT,KLCIBT,KLCBLTP,NBATCH,NBLOCK)
      CALL GETMEM('CLBT  ','FREE','INTE',KLCLBT ,MXNTTS)
      CALL GETMEM('CLEBT ','FREE','INTE',KLCLEBT,MXNTTS)
      CALL GETMEM('CI1BT ','FREE','INTE',KLCI1BT,MXNTTS)
      CALL GETMEM('CIBT  ','FREE','INTE',KLCIBT ,8*MXNTTS)
      CALL GETMEM('CBLTP ','FREE','INTE',KLCBLTP,NSMST)
*
* The input transformation matrix contains a lot of zeros which
* is expected not to be there in Traci_Lucia, so remove them.
*
      CALL DCOPY_(NDIM,[0.0D0],0,WORK(KLCMOMO),1)
      IOFF = 0
      IADR = 1
      ICOL = 1
      DO ISM = 1,NSMOB
         IF (NTOOBS(ISM) .GT. 0) THEN
            IROW = ICOL
            DO I = 1,NTOOBS(ISM)
               IADR = (ICOL-1)*NTOOB+IROW
               DO J = 1,NTOOBS(ISM)
                   WORK(KLCMOMO+IOFF+NTOOBS(ISM)*(J-1)+I-1) =
     &                                       CMOMO(IADR+J-1)
               END DO
               ICOL = ICOL + 1
            END DO
            IOFF = IOFF + NTOOBS(ISM)**2
         END IF
      END DO
*
* Now the actual work
*
      IDISK(LUC)=0
      IDISK(LUDIA)=0
      DO JROOT = 1, NROOT
        IDISK(LUSC1)=0
        CALL COPVCD(LUC,LUSC1,WORK(KVEC1),0,LBLK)
        CALL COPVCD(LUSC1,LUSC2,WORK(KVEC1),1,LBLK)
        IPACK = .FALSE.
        DUMMY = 0.0D0
*
*. Transform CI vector : Input on LUHC, output on LUDIA (!)
        CALL COPVCD(LUSC1,LUHC,WORK(KVEC1),1,LBLK)
*
        CALL TRACI_LUCIA(WORK(KLCMOMO),LUHC,LUDIA,ISSPC,ISSM,
     &             WORK(KVEC1),WORK(KVEC2))
      END DO
*     ^ End of loop over roots
      IDISK(LUDIA)=0
*
* Copy CI-vector back to MOLCAS JOBIPH file
*
      DO JROOT = 1,NROOT
         CALL FRMDSCN(WORK(KVEC1),NREC,LBLK,LUDIA)
         IF (NTEST .GE. 50) THEN
            NUM_ELE = 0
            DO IREC = 1,NREC
               NUM_ELE = NUM_ELE + LREC(IREC)
            END DO
            WRITE(6,*) 'CI-Vector read from disk for root = ',JROOT
            CALL WRTMAT(WORK(KVEC1),1,NUM_ELE,1,NUM_ELE)
         END IF
         CALL CSDTVC(WORK(KVEC2),WORK(KVEC1),2,WORK(KDTOC_POINTER),
     &               iWORK(KSDREO_POINTER),ISSM,0)
         CALL DDAFILE(JOBIPH,1,WORK(KVEC2),NCONF,JOBDISK)
         CALL IFRMDS(IDUMMY,1,LBLK,LUDIA)
      END DO
      IDISK(LUDIA)=0
*
      IF(NTEST.GE.100) THEN
        DO JROOT = 1, NROOT
          CALL WRTVCD(WORK(KVEC1),LUDIA,0,LBLK)
          CALL XFLUSH(6)
        END DO
      END IF
*
*. clean up time : copy 1-e integrals back in place
      CALL COPVEC(WORK(KLH1SAVE),WORK(KINT1),NDIM)
*
      CALL GETMEM('VEC1  ','FREE','REAL',KVEC1,LBLOCK)
      CALL GETMEM('VEC2  ','FREE','REAL',KVEC2,LBLOCK)
      CALL GETMEM('KC2   ','FREE','REAL',KVEC3,KVEC3_LENGTH)
      CALL GETMEM('KVEC4 ','FREE','REAL',KVEC4,NCONF)
      CALL GETMEM('CMOMO ','FREE','REAL',KLCMOMO,NDIM)
      CALL GETMEM('H1SAVE','FREE','REAL',KLH1SAVE,NDIM)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Matthew R. Hennefarth                            *
!***********************************************************************
!  ao2mo_1e
!
!> @brief transforms 1 particle integrals from AO to MO
!>
!> @author Matthew R. Hennefarth
!>
!> @param[in] cmo  MO coefficients
!> @param[in] d_ao unscaled, folded 1 particle integral matrix in AO basis
!> @param[in] nSym number of symmetry groups
!> @param[in] nBas number of basis functions per symmetry group
!> @param[in] nOrb number of orbitals per symmetry group
!> @param[in] nFro number of frozen orbitals per symmetry group
!>
!> @param[out] d_mo unscaled, folded 1 particle integral matrix in MO basis
!***********************************************************************

subroutine ao2mo_1e(cmo,d_ao,d_mo,nSym,nBas,nOrb,nFro)

use Index_Functions, only: nTri_Elem
use general_data, only: ntot1, ntot2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: cmo(ntot2), d_ao(ntot1)
real(kind=wp), intent(out) :: d_mo(ntot1)
integer(kind=iwp), intent(in) :: nsym, nbas(nsym), norb(nsym), nfro(nsym)
integer(kind=iwp) :: ibas, ifro, ioff1, ioff2, ioff3, iorb, isym
real(kind=wp), allocatable :: tmp1(:), tmp2(:)

iOff1 = 1
iOff2 = 1
iOff3 = 1
do iSym=1,nSym
  iBas = nBas(iSym)
  iOrb = nOrb(iSym)
  if ((iBas == 0) .or. (iOrb == 0)) cycle
  iFro = nFro(iSym)
  call mma_allocate(Tmp1,iBas*iBas,Label='Tmp1')
  call mma_allocate(Tmp2,iOrb*iBas,Label='Tmp2')
  call Square(d_ao(iOff1),Tmp1,1,iBas,iBas)
  call DGEMM_('N','N',iBas,iOrb,iBas, &
              One,Tmp1,iBas, &
              CMO(iOff2+(iFro*iBas)),iBas, &
              Zero,Tmp2,iBas)
  call DGEMM_Tri('T','N',iOrb,iOrb,iBas, &
                 One,Tmp2,iBas, &
                 CMO(iOff2+(iFro*iBas)),iBas, &
                 Zero,d_mo(iOff3),iOrb)
  call mma_deallocate(Tmp2)
  call mma_deallocate(Tmp1)
  iOff1 = iOff1+nTri_Elem(iBas)
  iOff2 = iOff2+iBas**2
  iOff3 = iOff3+nTri_Elem(iOrb)
end do

end subroutine ao2mo_1e

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Andrew M. Sand                                   *
!***********************************************************************

subroutine WfCtl_pdft(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,iRHSDisp,converged,iPL)
!***********************************************************************
!                                                                      *
!     called from: MCLR                                                *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use ipPage, only: ipclose, ipget, ipin, ipnout, ipout, opout, W
use MCLR_Data, only: Do_Hybrid, ipCI, ipDia, ipMat, IRLXROOT, ISNAC, LuTemp, nAcPar, nAcPr2, NACSTATES, nConf1, nDens, nDensC, &
                     nNA, PDFT_Ratio, WF_Ratio, XISPSM
use MCLR_procedures, only: CISigma_sa
use input_mclr, only: Debug, Eps, ERASSCF, Fail, iBreak, iMethod, kPrint, lSave, nAsh, nBas, nCSF, nDisp, nIter, nRoots, nRs2, &
                      nSym, ntAsh, State_Sym, Weight
use dmrginfo, only: DoDMRG, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iKapDisp(nDisp), isigDisp(nDisp), iCIDisp(nDisp), iCIsigDisp(nDisp), iRHSDisp(nDisp)
logical(kind=iwp), intent(out) :: converged(8)
integer(kind=iwp), intent(in) :: iPL
integer(kind=iwp) :: i, iDis, iDisp, ij, iLen, iOff, ipCID, ipCIT, ipPre2, ipS1, ipS2, ipST, iS, iSym, Iter, j, ji, jS, jSpin, &
                     kSym, Left, lLine, lPaper, Lu_50, nConf3, nG1, nG2, nOrbAct, nPre2, nTri
real(kind=wp) :: Delta, Delta0, DeltaC, DeltaK, Diff, R1, R2, rAlpha, rAlphaC, rAlphaK, rBeta, rDum(1), rE, ReCo, Res, rEsci, &
                 rEsk, TRoot, WScale
logical(kind=iwp) :: CI, cnvrgd, lPrint
character(len=8) :: Fmt2
integer(kind=iwp), allocatable :: iPre(:)
real(kind=wp), allocatable :: dKappa(:), Fancy(:), FMO1(:), FMO1t(:), FMO2t(:), FOSq(:), FOTr(:), FT99(:), Kap_New(:), &
                              Kap_New_Temp(:), Kappa(:), lmroots(:), lmroots_new(:), P2PDFT(:), P2WF(:), rCHC(:), Sc1(:), Sc2(:), &
                              Sigma(:), Temp4(:), Temp5(:), WFOrb(:)
real(kind=wp), external :: DDot_
integer(kind=iwp), external :: niPre, nPre

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
call StatusLine('MCLR: ','Computing Lagrangian multipliers for MC-PDFT')

lPaper = 132
lLine = 120
left = (lPaper-lLine)/2
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
!----------------------------------------------------------------------*

iDis = 0

fail = .false.
Converged(:) = .true.
!MGD I think this is nice when printed...
lprint = .true.
debug = .false.
reco = -One
Lu_50 = 50
if (lSAVE) call DANAME(Lu_50,'RESIDUALS')
if (lSAVE) then
  write(u6,*) 'WfCtl_SA: SAVE option not implemented'
  call Abend()
end if
if (btest(kprint,1)) lprint = .true.
isym = 1
nconf1 = ncsf(State_Sym)

CI = .false.
if ((iMethod == 2) .and. (nconf1 > 0)) CI = .true.

! Initiate CSF <-> SD
call InCSFSD(Mul(iSym,State_Sym),State_sym)

! Calculate length of the density, Fock and Kappa matrix etc
! notice that this matrices are not necessarily symmetric.
! Store pointers.
!
! Input:
!        iSym: Symmetry of perturbation
!
! Output: Commonblocks (Pointers.fh)

nConf3 = nint(max(xispsm(State_SYM,1),xispsm(State_SYM,1)))

call Setup_MCLR(iSym)

! Determine if we should page CI vectors
!                            [2]
! Calculate the diagonal of E    and store in core/disc

call mma_allocate(Fancy,nRoots**3,Label='Fancy')
call mma_allocate(rCHC,nRoots,Label='rCHC')
!____________________
!AMS - what to do here?
! What should rCHC be?  is it computed with E(mcscf) or E(pdft)?
!____________________
call CIDia_SA(State_Sym,rCHC,Fancy)
call mma_deallocate(rCHC)
call ipOut(ipdia)

! Allocate disk/memory space

! This areas should be addressed through ipIn
! ipOut will page them out to disk and free the memory area
! if page mode is used

! opOut will release the memory area without update the disk

ipS1 = ipGet(nconf3*nroots)
ipS2 = ipGet(nconf3*nroots)
ipST = ipGet(nconf3*nroots)
ipCIT = ipGet(nconf1*nroots)
ipCID = ipGet(nconf1*nroots)

call mma_allocate(iPre,nipre(isym),Label='iPre')
npre2 = npre(isym)
ipPre2 = ipGet(npre2)

call ipIn(ipPre2)
call Prec(W(ipPre2)%A,iPre,isym)
call ipOut(ippre2)

! OK START WORKING

!idisp = 1
jspin = 0

! Allocate areas for scratch and state variables

call mma_allocate(Kappa,nDensC,Label='Kappa')
call mma_allocate(dKappa,nDensC,Label='dKappa')
call mma_allocate(Sigma,nDensC,Label='Sigma')
call mma_allocate(Temp4,nDensC,Label='Temp4')
call mma_allocate(Temp5,nDens,Label='Temp5')
call mma_allocate(Sc1,nDens,Label='Sc1')
call mma_allocate(Sc2,nDensC,Label='Sc2')

! I think the lagrange multiplers are independent of the
! displacement, no?
nDisp = 1
do iDisp=1,nDisp
  Kappa(:) = Zero
  dKappa(:) = Zero
  Sigma(:) = Zero

  !---------------------------------------------------------------------
  !
  ! Calculate RHS for the perturbation
  !
  !---------------------------------------------------------------------

  ! (T1,T2,T3,T4,T5,T6,T7,Kappa1,CI1)

  if (debug) then
    if (isNAC) then
      write(u6,*) 'States: ',NACstates(1),NACstates(2)
    else
      write(u6,*) 'State: ',irlxroot
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !AMS - I Think I can skip all of this RHS stuff - I'll read it in below.
  !if (isNAC) then
  !  call RHS_NAC(Temp5,rDum)
  !else
  !  call RHS_SA(Temp5,rDum)
  !end if

  !AMS _____________________________________________________
  ! Read in the Fock operator for the calculation of the CI part of the RHS ipF1 and ipF2.
  nOrbAct = sum(nAsh(1:nSym))
  nTri = 0
  do ksym=1,nsym
    nTri = nTri+nTri_Elem(nBas(ksym))
  end do
  nacpar = nTri_Elem(nOrbAct)
  call mma_allocate(FMO1t,nTri,Label='FMO1t')
  call mma_allocate(FMO1,nDens,Label='FMO1')
  nacpar = nTri_Elem(nnA)
  nacpr2 = nTri_Elem(nacpar)
  call mma_allocate(FMO2t,nacpr2,Label='FMO2t')

  call get_darray('F1_PDFT',FMO1t,nTri)

  ioff = 0
  do iS=1,nSym
    jS = iS
    if (nBas(is)*nBas(jS) /= 0) then
      if (iS == jS) then
        do i=1,nBas(iS)
          do j=1,i
            ioff = ioff+1
            ji = ipMat(is,js)-1+(i-1)*nbas(iS)+j
            FMO1(ji) = FMO1t(ioff)
            if (i /= j) then
              ij = ipMat(is,js)-1+(j-1)*nbas(iS)+i
              FMO1(ij) = FMO1t(ioff)
            end if
          end do
        end do
      else
        do i=1,nBas(iS)
          do j=1,nBas(jS)
            ioff = ioff+1
            ji = ipMat(is,js)-1+(i-1)*nbas(iSym)+j
            FMO1(ji) = FMO1t(ioff)
          end do
        end do
      end if
    end if
  end do

  call get_darray('F2_PDFT',FMO2t,nacpr2)

  call CISigma_sa(0,State_sym,State_sym,FMO1,nDens,FMO2t,size(FMO2t),rdum,1,ipci,ipST,.true.)
  call mma_deallocate(FMO2t)

  troot = (irlxroot-1)
  call ipin(ipST)
  call ipin(ipCI)
  do i=0,nroots-1
    if (i == troot) then
      W(ipST)%A(i*nconf1+1:(i+1)*nconf1) = W(ipST)%A(i*nconf1+1:(i+1)*nconf1)/weight(i+1)
      rE = ddot_(nconf1,W(ipST)%A(1+i*nconf1),1,W(ipCI)%A(1+i*nconf1),1)
      W(ipST)%A(i*nconf1+1:(i+1)*nconf1) = W(ipST)%A(i*nconf1+1:(i+1)*nconf1)-rE*W(ipCI)%A(i*nconf1+1:(i+1)*nconf1)

    else
      W(ipst)%A(i*nconf1+1:(i+1)*nconf1) = Zero
    end if
  end do

  W(ipST)%A(1:nconf1*nroots) = -Two*W(ipST)%A(1:nconf1*nroots)

  ! scaling the CI resp. for PDFT part in HMC-PDFT
  if (Do_Hybrid) W(ipST)%A(1:nconf1*nroots) = PDFT_Ratio*W(ipST)%A(1:nconf1*nroots)

  if (debug) then
    write(u6,*) 'RHS CI part:'
    do iS=1,nconf1*nroots
      write(u6,*) W(ipST)%A(iS)
    end do
  end if

  call mma_deallocate(FMO1t)
  call mma_deallocate(FMO1)

  ! Get the fock matrix needed for the determination of the orbital part of the RHS.

  call mma_allocate(FT99,nDens,Label='FT99')
  FT99(:) = Zero
  Temp5(:) = Zero
  call get_dArray('Fock_PDFT',FT99,nDens)
  do iS=1,nSym
    jS = Mul(iS,1)
    if (nBas(is)*nBas(jS) /= 0) &
      call DGeSub(FT99(ipMat(iS,jS)),nBas(iS),'N',FT99(ipMat(jS,iS)),nBas(jS),'T',Temp5(ipMat(iS,jS)),nBas(iS),nBas(iS),nBas(jS))
  end do
  Temp5(:) = -Two*Temp5(:)

  call mma_deallocate(FT99)
  if (Do_Hybrid) then
    ! scaling the orb resp. for PDFT part in HMC-PDFT
    Temp5(:) = PDFT_Ratio*Temp5(:)
    ! calculating the orb resp. for WF part in HMC-PDFT
    call mma_allocate(WForb,nDens,Label='WForb')
    ! saving Fock matrix for PDFT part in HMC-PDFT
    call mma_allocate(FOTr,nTri,Label='FOTr')
    call Get_dArray_chk('FockOcc',FOTr,nTri)
    ! note that the Fock matrix will be overwritten with the wf one
    ! ini rhs_sa
    call rhs_sa(WForb,rDum,ipS2)
    Temp5(:) = Temp5(:)+WF_Ratio*WForb(:)
    call mma_deallocate(WForb)
  end if

  if (debug) then
    write(u6,*) 'RHS orb part:'
    do iS=1,nDens
      write(u6,*) Temp5(iS)
    end do
  end if

  ! Also, along with this RHS stuff, the Fock_occ array already stored on
  ! the runfile needs to be replaced - switch triangular storage to square
  ! storage:

  if (Do_Hybrid) then
    ng1 = nTri_Elem(ntash)
    ng2 = nTri_Elem(ng1)
    call mma_allocate(FOSq,nDens,Label='FOSq')
    call Get_dArray_chk('FockOcc',FOsq,nDens)

    ! scaling fock for wf part
    ! adding fock for pdft part
    FOsq(1:nTri) = WF_Ratio*FOsq(1:nTri)+PDFT_Ratio*FOtr(:)

    call mma_allocate(P2PDFT,nG2,Label='P2PDFT')
    call mma_allocate(P2WF,nG2,Label='P2WF')

    call Get_dArray_chk('P2MOt',P2PDFT,nG2)
    call Get_dArray_chk('P2mo',P2WF,nG2)
    ! scaling P2 for pdft part'
    ! adding P2 for wf part'
    P2PDFT(:) = PDFT_Ratio*P2PDFT(:)+WF_Ratio*P2WF(:)

    call Put_dArray('P2MOt',P2PDFT,nG2)

    call Put_dArray('FockOcc',FOSq,nDens)

    call mma_deallocate(FOSq)
    call mma_deallocate(FOTr)
    call mma_deallocate(P2PDFT)
    call mma_deallocate(P2WF)

  else
    call mma_allocate(FOSq,nDens,Label='FOSq')
    FOSq(:) = Zero
    call Get_dArray_chk('FockOcc',FOSq,nTri)
    call Put_dArray('FockOcc',FOSq,nDens)

    call mma_deallocate(FOSq)
  end if

  ! This seems to calculate the RHS, at least for the orbital part.
  ! Now, my sigma_0 should be given by
  ! (RHS) - A*Kappa, where Kappa is my initial guess at the solution, x_0.
  ! So, should I be running a "TimesE2"-like subroutine here, to do the
  ! A*Kappa multiplication, before we go on to multiply things by the
  ! preconditioner inverse?
  !___________________________________________________________

  call opOut(ipci)

  if (lprint) write(u6,*) '       Iteration       Delta       Res(kappa)  Res(CI)     DeltaK      DeltaC'
  iLen = nDensC
  iRHSDisp(iDisp) = iDis
  call Compress(Temp5,Sigma,iSym)
  r1 = ddot_(nDensC,Sigma,1,Sigma,1)
  if (debug) write(u6,*) 'Hi how about r1',r1
  call dDaFile(LuTemp,1,Sigma,iLen,iDis)

  call ipIn(ipCIT)
  W(ipCIT)%A(1:nConf1*nroots) = Zero
  call ipIn(ipCID)
  W(ipCID)%A(1:nConf1*nroots) = Zero
  call ipOut(ipCIT)
  Sigma(:) = -Sigma(:)

  deltaC = Zero
  !AMS _________________________________________________________
  ! I need to read in the CI portion of the RHS here.
  if (CI) then
    call ipIn(ipS2)
    call DMinvCI_sa(ipST,W(ipS2)%A,Fancy)
  end if
  call ipin(ipST)
  call ipin(ipCId)
  W(ipCId)%A(1:nconf1*nroots) = W(ipST)%A(1:nconf1*nroots)
  !*******************
  !TRS
  call mma_allocate(lmroots,nroots,Label='lmroots')
  call mma_allocate(lmroots_new,nroots,Label='lmroots_new')
  call mma_allocate(kap_new,nDensC,Label='kap_new')
  call mma_allocate(kap_new_temp,nDensC,Label='kap_new_temp')

  Kap_New(:) = Zero
  Kap_New_Temp(:) = Zero

  call ipin(ipCI)
  call DgeMV_('T',nconf1,nroots,One,W(ipCI)%A,nconf1,W(ipCId)%A(1+(irlxroot-1)*nconf1),1,Zero,lmroots,1)
  ! SA-SA rotations w/in SA space in eigen state basis
  if (debug) call recprt('lmroots',' ',lmroots,1,nroots)
  ! SA-SA rotations w/in SA space in CSF basis
  call dgemv_('N',nconf1,nroots,One,W(ipCI)%A,nconf1,lmroots,1,Zero,W(ipCId)%A(1+(irlxroot-1)*nconf1),1)
  ! SA-SA rotations w/in SA space for new lagrange multipliers
  do i=1,nroots
    if (i == irlxroot) then
      lmroots_new(i) = Zero
    else
      diff = (ERASSCF(i)-ERASSCF(irlxroot))
      wscale = (One/(Two*diff))*(One/weight(i))
      if (debug) then
        write(u6,*) 'diff',diff
        write(u6,*) 'wscale',wscale
        write(u6,*) 'weight',weight(i)
      end if
      lmroots_new(i) = wscale*lmroots(i)
    end if
  end do

  if (debug) call recprt('lmroots_new',' ',lmroots_new,1,nroots)
  ! SA-SA rotations w/in SA space for new lagrange multipliers in csf basis
  call dgemv_('N',nconf1,nroots,One,W(ipCI)%A,nconf1,lmroots_new,1,Zero,W(ipcid)%A(1+(irlxroot-1)*nconf1),1)

  ! First iter of PCG
  call TimesE2_(kap_new,ipCId,1,reco,jspin,ipS2,kap_new_temp,ipS1)

  call DgeMV_('T',nconf1,nroots,One,W(ipCI)%A,nconf1,W(ipST)%A(1+(irlxroot-1)*nconf1),1,Zero,lmroots,1)

  if (debug) then
    write(u6,*) 'lmroots_ipst this should be 1lmroots'
    call recprt('lmroots',' ',lmroots,1,nroots)
  end if

  call ipin(ipS1)
  call DgeMV_('T',nconf1,nroots,One,W(ipCI)%A,nconf1,W(ipS1)%A(1+(irlxroot-1)*nconf1),1,Zero,lmroots,1)

  if (debug) then
    write(u6,*) 'lmroots_ips1 this should be -lmroots'
    call recprt('lmroots',' ',lmroots,1,nroots)
  end if
  ! Initializing some of the elements of the PCG
  ! Modifying the response
  call ipIn(ipS1)
  call ipIn(ipST)
  W(ipST)%A(1:nConf1*nroots) = W(ipST)%A(1:nConf1*nroots)-W(ipS1)%A(1:nConf1*nroots)

  ! Kap part put into  sigma
  Sigma(:) = Sigma(:)-kap_new_temp(:)
  call ipIn(ipCId)
  call ipIn(ipCIT)
  W(ipCIT)%A(1:nConf1*nroots) = W(ipCIT)%A(1:nConf1*nroots)+W(ipCId)%A(1:nConf1*nroots)

  W(ipCId)%A(1:nconf1*nroots) = W(ipST)%A(1:nconf1*nroots)

  call opOut(ipci)
  call opOut(ipdia)

  call ipIn(ipPre2)
  call DMInvKap(W(ipPre2)%A,iPre,Sigma,dKappa,Sc1,iSym,iter)
  call opOut(ippre2)
  r2 = ddot_(nDensC,dKappa,1,dKappa,1)
  if (r2 > r1) write(u6,*) 'Warning perturbation number ',idisp,' might diverge'

  call mma_deallocate(kap_new)
  call mma_deallocate(kap_new_temp)
  call mma_deallocate(lmroots_new)
  !TRS
  !*********************
  call ipin(ipCI)
  call ipin(ipST)
  call DgeMV_('T',nconf1,nroots,One,W(ipci)%A,nconf1,W(ipST)%A(1+(irlxroot-1)*nconf1),1,Zero,lmroots,1)

  if (debug) then
    write(u6,*) 'lmroots_ipst this should be zero'
    call recprt('lmroots',' ',lmroots,1,nroots)
  end if
  call mma_deallocate(lmroots)

  if (CI) then
    call ipin(ipCId)
    deltaC = ddot_(nConf1*nroots,W(ipST)%A,1,W(ipCId)%A,1)
    call ipout(ipcid)
  else
    deltaC = Zero
  end if
  !AMS_______________________________________________

  call ipOut(ipcid)
  deltaK = ddot_(nDensC,dKappa,1,Sigma,1)
  delta = deltac+deltaK
  !write(u6,*) 'deltac and deltak',deltac,deltak
  delta0 = delta
  iter = 1
  ! Naming System:
  ! Kappa: accumulates Lagrange multiplier orbital parts (dKappa * ralpha)
  ! dKappa: orbital input of Hessian matrix-vector;
  ! Temp4: orbital output of Hessian matrix-vector
  ! Sigma: accumulates error vector orbital part
  ! ipCIT: accumulates Lagrange multiplier CI parts (ipCId * ralpha)
  ! ipCId: CI input of Hessian matrix-vector;
  ! ipS1: CI output of Hessian matrix-vector
  ! ipST: accumulates error vector CI part

  !---------------------------------------------------------------------

  cnvrgd = .true.
  do
    if (delta == Zero) exit

    call TimesE2_(dKappa,ipCId,1,reco,jspin,ipS2,Temp4,ipS1)

    !-------------------------------------------------------------------
    !
    !            delta
    ! rAlpha=------------
    !        dKappa:dSigma
    !
    !-------------------------------------------------------------------

    rAlphaK = Zero
    rAlphaK = ddot_(nDensC,Temp4,1,dKappa,1)
    rAlphaC = Zero
    call ipIn(ipS1)
    call ipIn(ipCId)
    rAlphaC = ddot_(nConf1*nroots,W(ipS1)%A,1,W(ipCId)%A,1)

    rAlpha = delta/(rAlphaK+rAlphaC)

    !------------------------------------------------------------------*

    ! Kappa=Kappa+rAlpha*dKappa
    Kappa(:) = Kappa(:)+ralpha*dKappa(:)
    ! Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa
    Sigma(:) = Sigma(:)-ralpha*Temp4(:)
    resk = sqrt(ddot_(nDensC,Sigma,1,Sigma,1))

    resci = Zero
    call ipIn(ipCIT)
    W(ipCIT)%A(1:nConf1*nroots) = W(ipCIT)%A(1:nConf1*nroots)+ralpha*W(ipCId)%A(1:nConf1*nroots)
    call ipOut(ipCIT)
    ! ipST =ipST -rAlpha*ipS1         ipST=RHS-A*ipCIT
    call ipIn(ipS1)
    call ipIn(ipST)
    W(ipST)%A(1:nConf1*nroots) = W(ipST)%A(1:nConf1*nroots)-ralpha*W(ipS1)%A(1:nConf1*nroots)
    call opOut(ipS1)
    resci = sqrt(ddot_(nconf1*nroots,W(ipST)%A,1,W(ipST)%A,1))

    !------------------------------------------------------------------*
    ! Precondition......
    !    -1
    ! S=M  Sigma

    call opOut(ipcid)

    call ipIn(ipS2)
    call DMinvCI_SA(ipST,W(ipS2)%A,Fancy)

    call opOut(ipci)
    call opOut(ipdia)

    call ipIn(ipPre2)
    call DMInvKap(W(ipPre2)%A,iPre,Sigma,Sc2,Sc1,iSym,iter)
    call opOut(ippre2)

    !------------------------------------------------------------------*
    !      s:Sigma (k+1)     s:Sigma (k+1)
    ! Beta=-------        =  -------------
    !       delta  (k)        s:Sigma (k)
    !
    ! delta=s:sigma
    !
    ! dKappa=s+Beta*dKappa

    call ipIn(ipST)
    call ipIn(ipS2)
    deltaC = ddot_(nConf1*nroots,W(ipST)%A,1,W(ipS2)%A,1)

    call ipOut(ipST)

    deltaK = ddot_(nDensC,Sigma,1,Sc2,1)
    if (.not. CI) then
      rBeta = deltaK/delta
      delta = deltaK
      dKappa(:) = rBeta*dKappa(:)+Sc2(:)
    else
      rbeta = (deltac+deltaK)/delta
      delta = deltac+deltaK

      call ipIn(ipCID)
      call ipIn(ipS2)
      W(ipCID)%A(1:nConf1*nroots) = rBeta*W(ipCID)%A(1:nConf1*nroots)+W(ipS2)%A(1:nConf1*nroots)
      dKappa(:) = rBeta*dKappa(:)+Sc2(:)
      call opOut(ipS2)
      call ipOut(ipCID)
    end if

    !  ######  #    #  #####        #####    ####    ####
    !  #       ##   #  #    #       #    #  #    #  #    #
    !  #####   # #  #  #    #       #    #  #       #
    !  #       #  # #  #    #       #####   #       #  ###
    !  #       #   ##  #    #       #       #    #  #    #
    !  ######  #    #  #####        #        ####    ####
    !
    !------------------------------------------------------------------*

    res = Zero ! dummy initialize
    if (iBreak == 1) then
      if (abs(delta) < abs(Eps**2*delta0)) exit
    else if (iBreak == 2) then
      res = sqrt(resk**2+resci**2)
      if (doDMRG) res = sqrt(resk**2)
      if (res < abs(Eps)) exit
    else
      if ((abs(delta) < abs(Eps**2*delta0)) .and. (res < abs(Eps))) exit
    end if
    if (iter >= niter) then
      cnvrgd = .false.
      exit
    end if
    if (lprint) write(u6,Fmt2//'I7,7X,F12.7,F12.7,F12.7,F12.7,F12.7)') iter,delta/delta0,resk,resci,deltac,deltak
    iter = iter+1

  end do

  !*********************************************************************

  if (.not. cnvrgd) then
    write(u6,Fmt2//'A,I4,A)') 'No convergence for perturbation no: ',idisp,'. Increase Iter.'
    converged(isym) = .false.
    fail = .true.
  else
    if (iPL >= 2) then
      write(u6,Fmt2//'I7,7X,F12.7,F12.7,F12.7,F12.7,F12.7)') iter,delta/delta0,resk,resci,deltac,deltak
      write(u6,Fmt2//'A,I4,A,I4,A)') 'Perturbation no: ',idisp,' converged in ',iter-1,' steps.'
    end if
    call ipnout(-1)
  end if

  if (iPL >= 2) write(u6,*)
  if (debug) then
    write(u6,*) 'outputs'
    write(u6,*) 'kappa'
    do i=1,nDensC
      write(u6,*) Kappa(i)
    end do
    call ipin(ipCIT)
    !W(ipCIT)%A(1:nconf1*nroots) = Zero
    write(u6,*) 'cit'
    do i=1,nconf1*nroots
      write(u6,*) W(ipCIT)%A(i)
    end do
  end if

  iLen = nDensC

  iKapDisp(iDisp) = iDis
  call dDaFile(LuTemp,1,Kappa,iLen,iDis)
  iSigDisp(iDisp) = iDis
  call dDaFile(LuTemp,1,Sigma,iLen,iDis)
  ilen = nconf1*nroots
  iCIDisp(iDisp) = iDis

  call ipin(ipCIT)
  call dDaFile(LuTemp,1,W(ipCIT)%A,iLen,iDis)

  !MGD This last call seems unused, so I comment it

  !call TimesE2(Kappa,ipCIT,1,reco,jspin,ipS2,Temp4,ipS2)
  iCISigDisp(iDisp) = iDis
  call ipin(ipST)
  call dDaFile(LuTemp,1,W(ipST)%A,iLen,iDis)
end do

call mma_deallocate(Sc2)
call mma_deallocate(Sc1)
call mma_deallocate(Temp5)
call mma_deallocate(Temp4)
call mma_deallocate(Sigma)
call mma_deallocate(dKappa)
call mma_deallocate(Kappa)
call mma_deallocate(Fancy)

! Free all memory and remove from disk all data
! related to this symmetry

call mma_deallocate(iPre)

call ipclose(ipdia)
if (.not. CI) call ipclose(ipPre2)

if (debug) then
  write(u6,*) '********************************************************************************'
  write(u6,*)
end if
if (doDMRG) then  ! yma
  nash(:) = RGras2(:)
  nrs2(:) = RGras2(:)
end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine WfCtl_pdft

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               2018, Sijia S. Dong                                    *
!***********************************************************************

subroutine Prpt_(nIrrep,nBas,nDim,Occ,n2Tot,Vec,var,Short,iUHF,ifallorb)
!***********************************************************************
!                                                                      *
! Purpose: calculation of expectation values of different              *
!          operators as available on the 'ONEINT' file                 *
!                                                                      *
! Caution: before calling this subroutine one needs to                 *
!          open the ONEINT file                                        *
!                                                                      *
! Calling parameters:                                                  *
!   nIrRep            number of irreducible representations            *
!   nBas(0:nIrRep)    number of basis functions in each repre-         *
!                     sentation                                        *
!   ndim              total number of basis functions                  *
!   occ(ndim,*)       occupation number for all eigenvectors           *
!   ifallorb          logical option for whether the property of       *
!                     all orbitals are printed (and not weighted by    *
!                     occupation number)in property calculation        *
!                     (S.S.Dong, 2018)                                 *
!                                                                      *
! 1991 R. Lindh, Dept. of Theor. Chem. Univ. of Lund, Sweden.          *
! Modified by S.S.Dong, 2018, Univ. of Minnesota                       *
! - Enable properties to be printed for all orbitals                   *
! (including virtuals) and not weighted by occupation numbers          *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nIrrep, nBas(0:nIrrep-1), nDim, n2Tot, iUHF
real(kind=wp), intent(in) :: Occ(nDim,*), Vec(n2Tot,*)
logical(kind=iwp), intent(in) :: var, Short, ifallorb
integer(kind=iwp) :: i, iComp, idum(1), iEF, iOcc, iopt, iPL, iS, irc, iSmLbl, iTol, j, jRC, lpole, maxCen, maxGG, &
                     mBas(0:nIrrep-1), mDim, mInt, nbast, nblock, nCen, nComp, nfblock, nS, tNUC
real(kind=wp) :: C1(3), C2(3)
logical(kind=iwp) :: NxtOpr
character(len=8) :: label
real(kind=wp), allocatable :: Den(:), El(:,:,:), ElSum(:), Nuc(:), NucSum(:), Opr(:)
real(kind=wp), parameter :: Thrs = 1.0e-6_wp
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: Reduce_Prt
#include "hfc_logical.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0

if (iPL >= 2) then
  write(u6,*)
  call CollapseOutput(1,'   Molecular properties:')
  write(u6,'(3X,A)') '   ---------------------'
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
nS = 1
if (Short) then
  mDim = 1
else
  mDim = nDim
  if (iUHF == 1) nS = 2
end if
mBas(:) = nS*nBas(:)
!                                                                      *
!***********************************************************************
!                                                                      *
nblock = 0
do i=0,nirrep-1
  nblock = nblock+nbas(i)*(nbas(i)+1)/2
end do
nfblock = ndim*(ndim+1)/2

!                                                                      *
!***********************************************************************
!                                                                      *
if (Short) then
  ! calculate the density matrix with all off-diagonal elements
  ! multipled by 2

  !if (iUHF ==  0) then
  call mma_allocate(Den,nBlock,label='Den')
  if (var) then
    call Get_D1ao_Var(Den,nBlock)
  else
    call Get_D1ao(Den,nBlock)
  end if
  !end if

end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Scan the ONEINT file for multipole moment operators

call mma_allocate(Opr,nfblock+4,label='Opr')

!write(u6,*) ' Starting scan of ONEINT for multipole moments'
do i=0,99
  NxtOpr = .false.
  nComp = (i+1)*(i+2)/2
  if (allocated(Nuc)) call mma_deallocate(Nuc)
  call mma_allocate(Nuc,nComp,label='Nuc')
  if (allocated(El)) call mma_deallocate(El)
  call mma_allocate(El,mDim,nS,nComp,label='El')

  Nuc(:) = Zero
  El(:,:,:) = Zero
  write(label,'(a,i2)') 'MLTPL ',i
  do iComp=1,nComp
    irc = -1
    iopt = 1
    call iRdOne(irc,iopt,label,iComp,idum,iSmLbl)
    if (irc == 0) mInt = idum(1)
    if (irc /= 0) cycle
    NxtOpr = .true.
    irc = -1
    iopt = 0
    call RdOne(irc,iopt,label,iComp,Opr,iSmLbl)
    if (irc /= 0) cycle
    if (mInt /= 0) call CmpInt(Opr,mInt,nBas,nIrrep,iSmLbl)
    Nuc(iComp) = Opr(mInt+4)
    if (iComp == 1) C1(:) = Opr(mInt+1:mInt+3)
    if (mInt == 0) cycle
    if (Short) then
      call Xprop(short,ifallorb,nIrrep,nBas,nBlock,Den,nDim,Occ(:,1),nblock,Opr,El(:,1,iComp))
    else
      call Xprop(short,ifallorb,nIrrep,nBas,n2Tot,Vec(:,1),nDim,Occ(:,1),nblock,Opr,El(:,1,iComp))
      if (iUHF == 1) call Xprop(short,ifallorb,nIrrep,nBas,n2Tot,Vec(:,2),nDim,Occ(:,2),nblock,Opr,El(:,2,iComp))
    end if
  end do
  if (.not. NxtOpr) exit

  call prop(short,label,C1,C1,nirrep,mBas,nS*mDim,Occ,Thrs,El,Nuc,i,ifallorb)
end do
if (allocated(Nuc)) call mma_deallocate(Nuc)
if (allocated(El)) call mma_deallocate(El)

! Scan 'ONEINT' for magnetic hyperfine integrals

!                                                                      *
!***********************************************************************
!                                                                      *
! This check if the magnetic hypferfine integrals are available
! and only calculates hyperfine tensor matrix for UHF wavefunction
! in C1 symmetry. Since for UHF the spin density matrix is easily
! obtained.

MAG_X2C = .false.
irc = -1
iopt = 1
label = 'MAGXP  1'
iComp = 1
call iRdOne(irc,iopt,label,iComp,idum,iSmLbl)
if (irc == 0) then
  MAG_X2C = .true.
  !if (Method == 'UHF-SCF ') then
  if (iUHF == 1) then
    if (UHF_HFC) then
      if (nIrrep == 1) then
        tNUC = 0
        nbast = nbas(0)
        call Get_iScalar('LP_nCenter',tNUC)
        call cmp_hfc(nbast,tNUC)
      else
        write(u6,'(/,/,6X,A)') 'Skipping Hyperfine tensor matrix for UHF with symmetry'
      end if
    else
      write(u6,'(/,/,6X,A)') 'Skipping Hyperfine tensor matrix'
    end if
  end if
end if

! Scan 'ONEINT' for electric field integrals

!                                                                      *
!***********************************************************************
!                                                                      *

!write(u6,*) ' Starting scan of ONEINT for various elec. field integrals'

do iEF=0,2
  nComp = (iEF+1)*(iEF+2)/2
  if (allocated(Nuc)) call mma_deallocate(Nuc)
  call mma_allocate(Nuc,nComp,label='Nuc')
  if (allocated(El)) call mma_deallocate(El)
  call mma_allocate(El,mDim,nS,nComp,label='El')

  ! create vectors to store the sums of electronic and nuclear components over all centers
  call mma_allocate(ElSum,nComp,label='ElSum')
  call mma_allocate(NucSum,nComp,label='NucSum')
  ElSum(:) = Zero
  NucSum(:) = Zero

  ! loop over different operator origins (max. 99999)

  maxCen = 99999
  nCen = 0
  do i=1,maxCen
    Nuc(:) = Zero
    El(:,:,:) = Zero
    write(label,'(a,i1,i5)') 'EF',iEF,i
    NxtOpr = .false.
    do iComp=1,nComp
      irc = -1
      iopt = 1
      call iRdOne(irc,iopt,label,iComp,idum,iSmLbl)
      if (irc == 0) mInt = idum(1)
      if (irc /= 0) cycle
      NxtOpr = .true.
      irc = -1
      iopt = 0
      call RdOne(irc,iopt,label,iComp,Opr,iSmLbl)
      if (irc /= 0) cycle
      if (mInt /= 0) call CmpInt(Opr,mInt,nBas,nIrrep,iSmLbl)
      Nuc(iComp) = Opr(mInt+4)
      if (iComp == 1) C1(:) = Opr(mInt+1:mInt+3)
      if (mInt == 0) cycle
      if (Short) then
        call Xprop(short,ifallorb,nIrrep,nBas,nBlock,Den,nDim,Occ(:,1),nblock,Opr,El(:,1,iComp))
      else
        call Xprop(short,ifallorb,nIrrep,nBas,n2Tot,Vec(:,1),nDim,Occ(:,1),nblock,Opr,El(:,1,iComp))
        if (iUHF == 1) call Xprop(short,ifallorb,nIrrep,nBas,n2Tot,Vec(:,2),nDim,Occ(:,2),nblock,Opr,El(:,2,iComp))
      end if
    end do
    if (.not. NxtOpr) exit

    call Prop(short,label,C1,C1,nirrep,mBas,nS*mDim,Occ,Thrs,El,Nuc,iEF,ifallorb)
    ! add the components to the sums, and update the total number of centers
    do iComp=1,nComp
      do iS=1,nS
        do iOcc=1,mDim
          ElSum(iComp) = ElSum(iComp)+El(iOcc,iS,iComp)
        end do
      end do
    end do
    NucSum(:) = NucSum(:)+Nuc(:)
    nCen = i
  end do

  if (nCen > 0) then
    ! set the tolerance according to the total number of centers
    ! (assuming error scales with sqrt(ncen))
    if (Label(1:3) == 'EF2') then
      iTol = 4
    else
      iTol = 5
    end if
    iTol = iTol-nint(Half*log10(real(nCen,kind=wp)))
    ! set MAG_X2C to avoid tests of electric field properties when
    ! wavefunction is X2C transformed (there is no way to tell but we
    ! can kind of tell by reading MAG x2c integrals) This is a workaround.
    if (.not. MAG_X2C) then
      write(label,'(a,i1,a)') 'EF',iEF,'   el'
      call Add_Info(label,ElSum,nComp,iTol)
      write(label,'(a,i1,a)') 'EF',iEF,'  nuc'
      call Add_Info(label,NucSum,nComp,iTol)
    end if
  end if
  call mma_deallocate(ElSum)
  call mma_deallocate(NucSum)
end do
if (allocated(Nuc)) call mma_deallocate(Nuc)
if (allocated(El)) call mma_deallocate(El)
!                                                                      *
!***********************************************************************
!                                                                      *

!write(u6,*) ' Starting scan of ONEINT for various contact term integrals'

nComp = 1
call mma_allocate(Nuc,nComp,label='Nuc')
call mma_allocate(El,mDim,nS,nComp,label='El')

! create vectors to store the sums of electronic and nuclear components over all centers
call mma_allocate(ElSum,nComp,label='ElSum')
call mma_allocate(NucSum,nComp,label='NucSum')
ElSum(:) = Zero
NucSum(:) = Zero

! loop over different operator origins (max. 99999)

maxCen = 99999
nCen = 0
do i=1,maxCen
  Nuc(:) = Zero
  El(:,:,:) = Zero
  write(label,'(a,i5)') 'CNT',i
  NxtOpr = .false.

  ! dummy loop, but we keep the structure
  do iComp=1,nComp
    irc = -1
    iopt = 1
    call iRdOne(irc,iopt,label,iComp,idum,iSmLbl)
    if (irc == 0) mInt = idum(1)
    if (irc /= 0) cycle
    NxtOpr = .true.
    irc = -1
    iopt = 0
    call RdOne(irc,iopt,label,iComp,Opr,iSmLbl)
    if (irc /= 0) cycle
    if (mInt /= 0) call CmpInt(Opr,mInt,nBas,nIrrep,iSmLbl)
    Nuc(iComp) = Opr(mInt+4)
    C1(:) = Opr(mInt+1:mInt+3)
    if (mInt == 0) cycle
    if (Short) then
      call Xprop(short,ifallorb,nIrrep,nBas,nBlock,Den,nDim,Occ(:,1),nblock,Opr,El(:,1,iComp))
    else
      call Xprop(short,ifallorb,nIrrep,nBas,n2Tot,Vec(:,1),nDim,Occ(:,1),nblock,Opr,El(:,1,iComp))
      if (iUHF == 1) call Xprop(short,ifallorb,nIrrep,nBas,n2Tot,Vec(:,2),nDim,Occ(:,2),nblock,Opr,El(:,2,iComp))
    end if
  end do
  if (.not. NxtOpr) exit

  call Prop(short,label,C1,C1,nirrep,mBas,nS*mDim,Occ,Thrs,El,Nuc,0,ifallorb)
  ! add the components to the sums, and update the total number of centers
  do iComp=1,nComp
    do iS=1,nS
      do iOcc=1,mDim
        ElSum(iComp) = ElSum(iComp)+El(iOcc,iS,iComp)
      end do
    end do
  end do
  NucSum(:) = NucSum(:)+Nuc(:)
  nCen = i
end do
call mma_deallocate(Nuc)
call mma_deallocate(El)

if (nCen > 0) then
  ! set the tolerance according to the total number of centers
  ! (assuming error scales with sqrt(ncen))
  iTol = 5
  iTol = iTol-nint(Half*log10(real(nCen,kind=wp)))
  if (.not. MAG_X2C) then
    write(label,'(a,a)') 'CNT','   el'
    call Add_Info(label,ElSum,nComp,iTol)
    write(label,'(a,a)') 'CNT','  nuc'
    call Add_Info(label,NucSum,nComp,iTol)
  end if
end if
call mma_deallocate(ElSum)
call mma_deallocate(NucSum)
!                                                                      *
!***********************************************************************
!                                                                      *
!write(u6,*) ' Starting scan of ONEINT diamagnetic shielding'

nComp = 9
lpole = 2
call mma_allocate(Nuc,nComp,label='Nuc')
call mma_allocate(El,mDim,nS,nComp,label='El')

maxGG = 99
maxCen = 99
! loop over different gauge origins (max.99)
do j=1,maxGG
  Nuc(:) = Zero
  El(:,:,:) = Zero
  jRC = 0
  ! loop over different operator origins (max.99)
  do i=1,maxCen
    write(label,'(a,i2,i2)') 'DMS ',j,i
    NxtOpr = .false.
    do iComp=1,nComp
      irc = -1
      iopt = 1
      call iRdOne(irc,iopt,label,iComp,idum,iSmLbl)
      if (irc == 0) mInt = idum(1)
      if (irc /= 0) cycle
      NxtOpr = .true.
      irc = -1
      iopt = 0
      call RdOne(irc,iopt,label,iComp,Opr,iSmLbl)
      if (irc /= 0) cycle
      if (mInt /= 0) call CmpInt(Opr,mInt,nBas,nIrrep,iSmLbl)
      Nuc(iComp) = Opr(mInt+4)
      if (iComp == 1) then
        C1(:) = Opr(mInt+1:mInt+3)
        C2(:) = C1(:)
      else if (iComp == 2) then
        C2(:) = Opr(mInt+1:mInt+3)
      end if
      if (mInt == 0) cycle
      if (Short) then
        call Xprop(short,ifallorb,nIrrep,nBas,nBlock,Den,nDim,Occ(:,1),nblock,Opr,El(:,1,iComp))
      else
        call Xprop(short,ifallorb,nIrrep,nBas,n2Tot,Vec(:,1),nDim,Occ(:,1),nblock,Opr,El(:,1,iComp))
        if (iUHF == 1) call Xprop(short,ifallorb,nIrrep,nBas,n2Tot,Vec(:,2),nDim,Occ(:,2),nblock,Opr,El(:,2,iComp))
      end if
    end do
    if (.not. NxtOpr) exit

    call prop(short,label,C1,C2,nirrep,mBas,nS*mDim,Occ,Thrs,El,Nuc,lpole,ifallorb)
    jRC = 1
  end do
  if (jRC == 0) exit
end do
call mma_deallocate(Nuc)
call mma_deallocate(El)
call mma_deallocate(Opr)
if (Short) call mma_deallocate(Den)

!                                                                      *
!***********************************************************************
!                                                                      *
if (iPL >= 2) then
  call CollapseOutput(0,'   Molecular properties:')
  write(u6,*)
end if

return

end subroutine Prpt_

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRSMT(A,B,C,N,H,W)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(N*(N+1)/2),B(N,N),C(N*(N+1)/2),H(N,N),W(N,N)
C
C     B*A*BT
C
      IJ=0
      DO 10 I=1,N
      DO 11 J=1,I
      IJ=IJ+1
      C(IJ)=0.D0
      W(I,J)=A(IJ)
      W(J,I)=A(IJ)
      H(I,J)=0.D0
      H(J,I)=0.D0
11    CONTINUE
10    CONTINUE
      DO 2 I=1,N
      DO 3 L=1,N
      DO 4 K=1,N
      H(I,L)=B(I,K)*W(K,L)+H(I,L)
4     CONTINUE
3     CONTINUE
2     CONTINUE
      IJ=0
      DO 21 I=1,N
      DO 22 J=1,I
      IJ=IJ+1
      DO 23 L=1,N
      C(IJ)=H(I,L)*B(J,L)+C(IJ)
23    CONTINUE
22    CONTINUE
21    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005,2006, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine PAO_Analysis(D,R,X)
! Thomas Bondo Pedersen, December 2005.
! - revised January 2006 (Thomas Bondo Pedersen).
!
! Purpose: test and analysis of Cholesky PAOs.

use Localisation_globals, only: AnaNrm, BName, MOrig, nAtoms, nBas, nFro, nOrb2Loc, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
real(kind=wp), intent(in) :: D(*), R(*), X(*)
integer(kind=iwp) :: i, iGetVecs, iSym, kC, kCO, kCR, kOff, kOffX, kSX, kX, l_S, l_SX, l_Tst, lDAt, lRAt, lXAt, nB, nB2, nErr, nF, &
                     nFO, nO, nR, nRest, nRO
real(kind=wp) :: xB2, xFO, xNrm, xRMS, xRO
character(len=14) :: FilNam
logical(kind=iwp) :: Debug
integer(kind=iwp), allocatable :: nBas_per_Atom(:), nBas_Start(:)
real(kind=wp), allocatable :: DAt(:), EigI(:), EigR(:), RAt(:), S(:), SX(:), Tst(:), XAt(:)
real(kind=wp), parameter :: Tol = 1.0e-10_wp
character(len=*), parameter :: SecNam = 'PAO_Analysis'
real(kind=r8), external :: ddot_

call Untested('PAO_Analysis')

l_S = nBas(1)**2
do iSym=2,nSym
  l_S = l_S+nBas(iSym)**2
end do
call mma_allocate(S,l_S,label='S')
call GetOvlp_Localisation(S,'Sqr',nBas,nSym)

! Initialization.
! ---------------

Debug = .false.

! Tests:
! 0) RR^T = XX^T = D (check of decomposition)
! 1) Co^TSX = 0 (check that X is orthogonal to the orthogonal
!                complement space).
! 2) C^TSX is non-singular (check that X spans primary space)
! ===========================================================

write(u6,*) 'Testing PAOs...'
nErr = 0

! Test 0.
! -------

l_Tst = nBas(1)**2
do iSym=2,nSym
  l_Tst = max(l_Tst,nBas(iSym)**2)
end do
call mma_allocate(Tst,l_Tst,label='TstDen')

kOff = 1
do iSym=1,nSym
  nB = nBas(iSym)
  nB2 = nB**2
  nF = nFro(iSym)
  nO = nOrb2Loc(iSym)
  call GetDens_Localisation(Tst,R(kOff),nB,nB)
  call dAXPY_(nB2,-One,D(kOff),1,Tst,1)
  if (nB2 > 0) then
    xB2 = One/real(nB2,kind=wp)
    xRMS = sqrt(xB2*dDot_(nB2,Tst,1,Tst,1))
  else
    xRMS = Zero
  end if
  if (xRMS > Tol) then
    write(u6,'(A,A,D16.8,A,I2,A)') SecNam,': ERROR: RMS(D-RR^T) = ',xRMS,' (sym.',iSym,')'
    nErr = nErr+1
  end if
  kOffX = kOff+nB*nF
  call GetDens_Localisation(Tst,X(kOffX),nB,nO)
  call dAXPY_(nB2,-One,D(kOff),1,Tst,1)
  if (nB2 > 0) then
    xB2 = One/real(nB2,kind=wp)
    xRMS = sqrt(xB2*dDot_(nB2,Tst,1,Tst,1))
  else
    xRMS = Zero
  end if
  if (xRMS > Tol) then
    write(u6,'(A,A,D16.8,A,I2,A)') SecNam,': ERROR: RMS(D-XX^T) = ',xRMS,' (sym.',iSym,')'
    nErr = nErr+1
  end if
  kOff = kOff+nB2
end do

! Compute SX.
! -----------

l_SX = nBas(1)*nOrb2Loc(1)
do iSym=2,nSym
  l_SX = l_SX+nBas(iSym)*nOrb2Loc(iSym)
end do
call mma_allocate(SX,l_SX,label='SX')

kOff = 1
kSX = 1
do iSym=1,nSym
  nB = max(nBas(iSym),1)
  kX = kOff+nBas(iSym)*nFro(iSym)
  call DGEMM_('N','N',nBas(iSym),nOrb2Loc(iSym),nBas(iSym),One,S(kOff),nB,X(kX),nB,Zero,SX(kSX),nB)
  kSX = kSX+nBas(iSym)*nOrb2Loc(iSym)
  kOff = kOff+nBas(iSym)*nBas(iSym)
end do

! Test 1.
! First frozen part of orthogonal complement, then the rest.
! ----------------------------------------------------------

kC = 1
kSX = 1
do iSym=1,nSym
  nB = max(nBas(iSym),1)
  nF = max(nFro(iSym),1)
  nRest = nBas(iSym)-nFro(iSym)-nOrb2Loc(iSym)
  nR = max(nRest,1)
  call DGEMM_('T','N',nFro(iSym),nOrb2Loc(iSym),nBas(iSym),One,MOrig(kC),nB,SX(kSX),nB,Zero,Tst,nF)
  nFO = nFro(iSym)*nOrb2Loc(iSym)
  if (nFO > 0) then
    xFO = One/real(nFO,kind=wp)
    xRMS = sqrt(xFO*dDot_(nFO,Tst,1,Tst,1))
  else
    xRMS = Zero
  end if
  if (xRMS > Tol) then
    write(u6,'(A,A,D16.8,A,I2,A)') SecNam,': ERROR: RMS(Co^TSX [Frozen]) = ',xRMS,' (sym.',iSym,')'
    nErr = nErr+1
  end if
  kCR = kC+nBas(iSym)*(nFro(iSym)+nOrb2Loc(iSym))
  call DGEMM_('T','N',nRest,nOrb2Loc(iSym),nBas(iSym),One,MOrig(kCR),nB,SX(kSX),nB,Zero,Tst,nR)
  nRO = nRest*nOrb2Loc(iSym)
  if (nRO > 0) then
    xRO = One/real(nRO,kind=wp)
    xRMS = sqrt(xRO*dDot_(nRO,Tst,1,Tst,1))
  else
    xRMS = Zero
  end if
  if (xRMS > Tol) then
    write(u6,'(A,A,D16.8,A,I2,A)') SecNam,': ERROR: RMS(Co^TSX [Rest]) = ',xRMS,' (sym.',iSym,')'
    nErr = nErr+1
  end if
  kC = kC+nBas(iSym)*nBas(iSym)
  kSX = kSX+nBas(iSym)*nOrb2Loc(iSym)
end do

! Test 2.
! -------

kC = 1
kSX = 1
do iSym=1,nSym
  nB = max(nBas(iSym),1)
  nO = max(nOrb2Loc(iSym),1)
  kCO = kC+nBas(iSym)*nFro(iSym)
  call DGEMM_('T','N',nOrb2Loc(iSym),nOrb2Loc(iSym),nBas(iSym),One,MOrig(kCO),nB,SX(kSX),nB,Zero,Tst,nO)
  call mma_allocate(EigR,nOrb2Loc(iSym),label='EigR')
  call mma_allocate(EigI,nOrb2Loc(iSym),label='EigI')
  iGetVecs = 0
  call Diag_Localisation(Tst,EigR,EigI,nOrb2Loc(iSym),iGetVecs)
  do i=1,nOrb2Loc(iSym)
    xNrm = sqrt(EigR(i)**2+EigI(i)**2)
    if (xNrm < Tol) then
      write(u6,'(A,A,I6,A,A,D16.8,A,I2,A)') SecNam,': ERROR: ||eigenvalue',i,'|| of ','C^TSX = ',xNrm,' (sym.',iSym,')'
      nErr = nErr+1
    end if
  end do
  call mma_deallocate(EigR)
  call mma_deallocate(EigI)
  kC = kC+nBas(iSym)*nBas(iSym)
  kSX = kSX+nBas(iSym)*nOrb2Loc(iSym)
end do

call mma_deallocate(Tst)
call mma_deallocate(SX)

! Overall check.
! --------------

if (nErr /= 0) then
  call SysAbendMsg(SecNam,'PAO localization failed!',' ')
else
  write(u6,*) '...OK!'
end if

! Analysis.
! This part does not work with symmetry.
! ======================================

if (nSym /= 1) then
  write(u6,*)
  write(u6,*) SecNam,': symmetry not implemented for analysis of PAOs. Sorry!'
  return
end if

! Allocate atom based density and CMO matrices.
! ---------------------------------------------

lDAt = nAtoms**2
lRAt = nAtoms*nBas(1)
lXAt = nAtoms*nOrb2Loc(1)
call mma_allocate(DAt,lDAt,label='DAt')
call mma_allocate(RAt,lRAt,label='RAt')
call mma_allocate(XAt,lXAt,label='XAt')

! Allocate and get index arrays for basis functions per atom.
! -----------------------------------------------------------

call mma_allocate(nBas_per_Atom,nAtoms,label='nB_per_Atom')
call mma_allocate(nBas_Start,nAtoms,label='nB_Start')
call BasFun_Atom(nBas_per_Atom,nBas_Start,BName,nBas(1),nAtoms,Debug)

! Generate bitmaps.
! -----------------

call GetAt_Localisation(D,nBas(1),nBas(1),DAt,nAtoms,2,nBas_per_Atom,nBas_Start,AnaNrm)
call GetAt_Localisation(R,nBas(1),nBas(1),RAt,nAtoms,1,nBas_per_Atom,nBas_Start,AnaNrm)
kOffX = nBas(1)*nFro(1)+1
call GetAt_Localisation(X(kOffX),nBas(1),nOrb2Loc(1),XAt,nAtoms,1,nBas_per_Atom,nBas_Start,AnaNrm)
write(FilNam,'(A)') 'PAO_Dnsty1.bmp'
call GenBMp_Loc(DAt,nAtoms,nAtoms,FilNam,'r')
write(FilNam,'(A)') 'PAO_LnDep1.bmp'
call GenBMp_Loc(RAt,nAtoms,nBas(1),FilNam,'r')
write(FilNam,'(A)') 'PAO_Chole1.bmp'
call GenBMp_Loc(XAt,nAtoms,nOrb2Loc(1),FilNam,'r')
write(u6,*) 'Bitmap files have been generated. Norm: ',AnaNrm

! Deallocations.
! --------------

call mma_deallocate(DAt)
call mma_deallocate(RAt)
call mma_deallocate(XAt)
call mma_deallocate(nBas_per_Atom)
call mma_deallocate(nBas_Start)

call mma_deallocate(S)

end subroutine PAO_Analysis

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module abdata

use Definitions, only: wp

implicit none
private

real(kind=wp), allocatable :: atab(:,:), btab(:,:), p0(:), tvalue(:)

public :: atab, btab, close_abdata, p0, read_abdata, tvalue

contains

subroutine read_abdata()

  use Definitions, only: iwp
  use stdalloc, only: mma_allocate

  integer(kind=iwp) :: i, k, lu_abdata, maxdeg, ntab1, ntab2
  character(len=8) :: key
  logical(kind=iwp) :: found_abdata
  character(len=*), parameter :: ABDATA_NAME = 'ABDATA'
  integer(kind=iwp), external :: isFreeUnit

# include "macros.fh"

  call f_Inquire(ABDATA_NAME,found_abdata)
  if (.not. found_abdata) then
    call warningmessage(2,' the abdata file does not exist.')
    call abend()
  end if
  lu_abdata = isFreeUnit(22)
  call molcas_open(lu_abdata,ABDATA_NAME)

  do
    read(lu_abdata,'(a8)') key
    if (key == 'NTAB1, N') exit
  end do
  read(lu_abdata,*) ntab1,ntab2,maxdeg
  call mma_allocate(atab,[0,maxdeg],[ntab1,ntab2],label='atab')
  call mma_allocate(btab,[0,maxdeg],[ntab1,ntab2],label='btab')
  call mma_allocate(p0,[ntab1,ntab2],label='p0')
  call mma_allocate(tvalue,[ntab1,ntab2],label='tvalue')
  do i=ntab1,ntab2
    do
      read(lu_abdata,'(a8)') key
      if (key == 'TAB POIN') exit
    end do
    read(lu_abdata,*) k,tvalue(i),p0(i)
    unused_var(k)
    read(lu_abdata,*)
    read(lu_abdata,*) atab(:,i)
    read(lu_abdata,*)
    read(lu_abdata,*) btab(:,i)
  end do

  close(lu_abdata)

  return

end subroutine read_abdata

subroutine close_abdata()

  use stdalloc, only: mma_deallocate

  if (allocated(atab)) call mma_deallocate(atab)
  if (allocated(btab)) call mma_deallocate(btab)
  if (allocated(p0)) call mma_deallocate(p0)
  if (allocated(tvalue)) call mma_deallocate(tvalue)

end subroutine close_abdata

end module abdata

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefW4abdc(W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)
! define W(a,b,c,d) from (ab|dc)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimc, dimd, abLen, cdLen, aSGrp, bSGrp, cSGrp, dSGrp
real(kind=wp), intent(inout) :: W(dima,dimb,dimc,dimd)
real(kind=wp), intent(in) :: Wx(abLen,cdLen)
integer(kind=iwp) :: a, ab, b, c, dc

#include "macros.fh"
unused_var(cSGrp)
unused_var(dSGrp)

if (aSGrp == bSGrp) then
  ! case (a=b|d,c)
  dc = 0
  do c=1,dimc
    do a=1,dima
      ab = nTri_Elem(a-1)
      W(a,1:a-1,c,:) = W(a,1:a-1,c,:)+Wx(ab+1:ab+a-1,dc+1:dc+dimd)
      W(1:a,a,c,:) = W(1:a,a,c,:)+Wx(ab+1:ab+a,dc+1:dc+dimd)
      ab = ab+a
    end do
    dc = dc+dimd
  end do

else
  ! case (a,b|d,c)
  dc = 0
  do c=1,dimc
    ab = 0
    do b=1,dimb
      W(:,b,c,:) = W(:,b,c,:)+Wx(ab+1:ab+dima,dc+1:dc+dimd)
      ab = ab+dima
    end do
    dc = dc+dimd
  end do

end if

return

end subroutine DefW4abdc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_qlm_builder

   USE fmm_global_paras
   USE fmm_stats
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_get_raw_qlm,             &
             fmm_deallocate_qlm

   ! Public variables
   PUBLIC :: fmm_system_size, fmm_coord_shift

   ! Coordinate translation required to ensure all primitive (x,y,z) positive
   REAL(REALK), SAVE :: fmm_coord_shift(3)

   ! Number of multipole moments written to interface file
   TYPE(fmm_counters), SAVE :: n_mms
   ! Number of AO (contracted) basis functions
   INTEGER(INTK), SAVE :: nbas
   ! (minimum) dimension of a cube which encloses all moments
   REAL(REALK), SAVE :: fmm_system_size

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_raw_qlm(scheme,dens,LHS,RHS)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)  :: scheme
      REAL(REALK),        INTENT(IN)  :: dens(:,:)
      TYPE(raw_mm_data),  INTENT(OUT) :: LHS, RHS
      TYPE(raw_mm_data) :: mm_data
      INTEGER(INTK) :: LMAX

      LMAX = scheme%raw_LMAX

      ! Get all multipole data from program interface
      CALL fmm_get_n_mms_from_file(LMAX)
      CALL fmm_allocate_mms_arrays(LMAX,n_mms%tot,mm_data)
      CALL fmm_read_in_raw_data(dens,mm_data)
      CALL fmm_get_system_size_and_shift(mm_data%paras)
      IF (scheme%branch_free) CALL fmm_make_branch_free_extents(scheme,mm_data)

      ! Assign LHS range multipole data
      CALL fmm_distribute_LHS_RHS_data(LMAX,scheme%LHS_mm_range,mm_data,LHS)
      stat_raw_moms_LHS = SIZE(LHS%paras)
      ! Assign RHS range multipole data
      CALL fmm_distribute_LHS_RHS_data(LMAX,scheme%RHS_mm_range,mm_data,RHS)
      stat_raw_moms_RHS = SIZE(RHS%paras)

      CALL fmm_deallocate_mms_arrays(mm_data)

   END SUBROUTINE fmm_get_raw_qlm

!-------------------------------------------------------------------------------
! Branch-free scheme basically uses CFMM code but we simplify all the
! extents such that they are all the same and only _very_ close interactions
! are avoided (for numerical stability)

   SUBROUTINE fmm_make_branch_free_extents(scheme,mm_data)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)  :: scheme
      TYPE(raw_mm_data),  INTENT(OUT) :: mm_data

      INTEGER(INTK) :: i

      DO i = 1, n_mms%elec
         mm_data%paras(i)%ext = scheme%extent_min
      END DO

   END SUBROUTINE fmm_make_branch_free_extents

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_distribute_LHS_RHS_data(LMAX,mm_range,all_data,sub_data)

      IMPLICIT NONE
      INTEGER(INTK),     INTENT(IN)  :: LMAX, mm_range
      TYPE(raw_mm_data), INTENT(IN)  :: all_data
      TYPE(raw_mm_data), INTENT(OUT) :: sub_data
      INTEGER(INTK) :: foo, i, hi, lo

      lo = 1
      hi = n_mms%tot
      IF (mm_range == NUCLEAR_ONLY)    lo = 1+n_mms%elec
      IF (mm_range == ELECTRONIC_ONLY) hi = n_mms%elec
      foo = hi - lo + 1

      CALL fmm_allocate_mms_arrays(LMAX,foo,sub_data)

      sub_data%qlm(:,:)     = all_data%qlm(:,lo:hi)
      sub_data%dens(:)      = all_data%dens(lo:hi)
      sub_data%paras(:)     = all_data%paras(lo:hi)
      sub_data%J_indices(:) = all_data%J_indices(lo:hi)
      NULLIFY(sub_data%qlm_T)
      NULLIFY(sub_data%qlm_W)

      ! Initialise parameter:moments mapping,
      ! and batch numbers for unique centres
      DO i = 1, foo
         sub_data%paras(i)%id = i
         sub_data%paras(i)%batch = i
      END DO

   END SUBROUTINE fmm_distribute_LHS_RHS_data

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_deallocate_qlm(LHS,RHS)

      IMPLICIT NONE
      TYPE(raw_mm_data), INTENT(OUT) :: LHS, RHS

      CALL fmm_deallocate_mms_arrays(LHS)
      CALL fmm_deallocate_mms_arrays(RHS)

   END SUBROUTINE fmm_deallocate_qlm

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_n_mms_from_file(LMAX_in)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: LMAX_in
      INTEGER(INTK) :: LMAX !, ndim

      ! Read number of electronic moments
      OPEN (UNIT=LUINTM,FILE='multipoles.fmm1header',  &
            STATUS='OLD',ACTION='READ',FORM='UNFORMATTED')
      REWIND (LUINTM)
      READ (LUINTM) LMAX, nbas, n_mms%elec
      CLOSE(UNIT=LUINTM,STATUS='KEEP')

      IF (LMAX /= LMAX_in) THEN
         WRITE(LUPRI,*) LMAX, LMAX_in
         CALL fmm_quit('LMAX inconsistency in MM interface!')
      END IF
      IF (n_mms%elec < 1) CALL fmm_quit('No moments generated!')
!      This test only works for moments build over contracted AO pairs
!      ndim = nbas*(nbas+1)/2
!      IF ( n_mms%elec > ndim ) THEN
!         WRITE(LUPRI,*) LMAX, nbas, ndim, n_mms%elec
!         CALL fmm_quit('Too many moments generated, based on AO number!')
!      END IF

      ! Read number of nuclear moments or potential grid points
      OPEN (UNIT=LUINTM,FILE='multipoles.fmm2header',  &
            STATUS='OLD',ACTION='READ',FORM='UNFORMATTED')
      REWIND (LUINTM)
      READ (LUINTM) n_mms%nuc
      CLOSE(UNIT=LUINTM,STATUS='KEEP')

      n_mms%tot = n_mms%elec + n_mms%nuc
      stat_n_basis = nbas

   END SUBROUTINE fmm_get_n_mms_from_file

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_allocate_mms_arrays(LMAX,ndim,mm_data)

      IMPLICIT NONE
      INTEGER(INTK),     INTENT(IN)  :: LMAX, ndim
      TYPE(raw_mm_data), INTENT(OUT) :: mm_data
      INTEGER(INTK) :: i, foo, alloc_error

      NULLIFY (mm_data%paras, mm_data%dens, mm_data%batch_map)
      NULLIFY (mm_data%qlm, mm_data%qlm_W, mm_data%qlm_T)

      ALLOCATE (mm_data%paras(ndim))
      ALLOCATE (mm_data%J_indices(ndim))

      ! Initialise parameters
      DO i = 1, ndim
         mm_data%paras(i)%cntr = zero
         mm_data%paras(i)%ext = zero
         mm_data%paras(i)%id = 0
         mm_data%paras(i)%batch = 0
         mm_data%paras(i)%map_up = 0
         mm_data%paras(i)%box = 0
         mm_data%paras(i)%bra = 0
         mm_data%paras(i)%box_cntr = zero
         mm_data%J_indices(i)%i_indx = 0
         mm_data%J_indices(i)%j_indx = 0
      END DO

      ALLOCATE (mm_data%dens(ndim))
      foo = (LMAX+1)**2
      WRITE(LUPRI,*) 'mms_arrays: Attempting to allocate',  &
                     MAX(1,foo*ndim*8/1000000), 'MB of memory...'
      ALLOCATE (mm_data%qlm(foo,ndim), STAT=alloc_error)
      IF (alloc_error /= 0) WRITE(LUPRI,*) '... Failed!'

      mm_data%qlm(:,:) = zero  ! only non-zero written explicitly

   END SUBROUTINE fmm_allocate_mms_arrays

!------------------------------------------------------------------------------

   SUBROUTINE fmm_deallocate_mms_arrays(mm_data)

      IMPLICIT NONE
      TYPE(raw_mm_data), INTENT(OUT) :: mm_data
      INTEGER(INTK) :: i

      IF (ASSOCIATED(mm_data%paras)) DEALLOCATE (mm_data%paras)
      IF (ASSOCIATED(mm_data%J_indices)) DEALLOCATE (mm_data%J_indices)
      IF (ASSOCIATED(mm_data%dens)) DEALLOCATE (mm_data%dens)
      IF (ASSOCIATED(mm_data%qlm)) DEALLOCATE (mm_data%qlm)
      IF (ASSOCIATED(mm_data%qlm_T)) DEALLOCATE (mm_data%qlm_T)
      IF (ASSOCIATED(mm_data%qlm_W)) DEALLOCATE (mm_data%qlm_W)

      IF (ASSOCIATED(mm_data%batch_map)) THEN
         DO i = 1, SIZE(mm_data%batch_map)
            CALL free_batch_map(mm_data%batch_map(i)%head)
         END DO
      END IF
      IF (ASSOCIATED(mm_data%batch_map)) DEALLOCATE(mm_data%batch_map)

      NULLIFY (mm_data%paras, mm_data%dens, mm_data%batch_map)
      NULLIFY (mm_data%qlm, mm_data%qlm_W, mm_data%qlm_T)
      NULLIFY (mm_data%J_indices)

   CONTAINS

      RECURSIVE SUBROUTINE free_batch_map(node)

         IMPLICIT NONE
         TYPE(id_node), POINTER :: node
         IF (ASSOCIATED(node%next)) THEN
            CALL free_batch_map(node%next)
         END IF
         DEALLOCATE(node)
         NULLIFY(node)

      END SUBROUTINE free_batch_map

   END SUBROUTINE fmm_deallocate_mms_arrays

!-------------------------------------------------------------------------------
! Read in multipole moment data from interface file.
! In all this MM code we assume the order of moments is:
!   (0),(-1,0,1),(-2,-1,0,1,2)... wrt (L,M)

   SUBROUTINE fmm_read_in_raw_data(dens,mm_data)

      IMPLICIT NONE
      REAL(REALK),       INTENT(IN)  :: dens(:,:)
      TYPE(raw_mm_data), INTENT(OUT) :: mm_data
      REAL(REALK)   :: PX,PY,PZ, SPH
      INTEGER(INTK) :: I,J,L,M, A,B, LM, X

      ! Read electronic multipole moments into core
      OPEN (UNIT=LUINTM,FILE='multipoles.fmm1',STATUS='OLD',  &
            ACTION='READ',FORM='UNFORMATTED')
      REWIND (LUINTM)

      readloop: DO

         READ (LUINTM) I,L,M, A,B, PX,PY,PZ, SPH
         ! EOF marked by record with negative angular momentum
         IF (L < 0) EXIT readloop

!         IF ((L == 0) .AND. (ABS(SPH) > 1.0d-12) )   &
!         WRITE (LUPRI,'(5I4,1X,3F8.4,2E13.4)') I,L,M,A,B,PX,PY,PZ,SPH,dens(A,B)

         IF (A > nbas) CALL fmm_quit('interface file error 0')
         IF (B > nbas) CALL fmm_quit('interface file error 00')
         IF (I < 1) CALL fmm_quit('interface file error 1')
         IF (I > SIZE(mm_data%qlm,2)) CALL fmm_quit('interface error 11')
         IF (((L+1)**2) > SIZE(mm_data%qlm,1)) CALL fmm_quit('interface 156')

          ! Indices to map moments to orbitals in J-matrix
         mm_data%J_indices(I)%i_indx = A
         mm_data%J_indices(I)%j_indx = B
          ! Multipole expansion centre
         mm_data%paras(I)%cntr = (/ PX, PY, PZ /)
          ! See defn of 'extent' in p.424 MEST Helgaker et al
         mm_data%paras(I)%ext  = 0
         LM = L*(L+1) +M +1
         mm_data%dens(I) = dens(A,B)
          ! Components (l,m) of MM without density factorised in
         mm_data%qlm(LM,I) = SPH

      END DO readloop

      CLOSE(UNIT=LUINTM,STATUS='KEEP')

      ! Next read nuclei data: charge and location
      ! This is also used for passing the grid points when
      ! computing an arbitrary potential
      IF (n_mms%nuc == 0) RETURN
      OPEN (UNIT=LUINTM,FILE='multipoles.fmm2',STATUS='OLD',  &
            ACTION='READ',FORM='UNFORMATTED')
      REWIND (LUINTM)

      DO J = 1, n_mms%nuc
         I = n_mms%elec + J
         READ (LUINTM) X,L,M, A,B, PX,PY,PZ, SPH
!         WRITE (LUPRI,'(I4,1X,3F8.4,2E13.4)') I, PX,PY,PZ, SPH
         mm_data%qlm(1,I) = SPH
         mm_data%paras(I)%cntr = (/ PX, PY, PZ /)
      END DO

      mm_data%dens((n_mms%elec+1):) = one
      mm_data%paras((n_mms%elec+1):)%ext = zero         ! point charges
      mm_data%J_indices((n_mms%elec+1):)%i_indx = 0     ! not relevant
      mm_data%J_indices((n_mms%elec+1):)%j_indx = 0     ! not relevant

      CLOSE(UNIT=LUINTM,STATUS='KEEP')

   END SUBROUTINE fmm_read_in_raw_data

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_system_size_and_shift(paras)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(INOUT) :: paras(:)
      REAL(REALK)   :: sys_min(3), sys_max(3)
      INTEGER(INTK) :: i

      sys_min = paras(1)%cntr
      sys_max = paras(1)%cntr
      DO i = 1, SIZE(paras)
         sys_min(:) = MIN(sys_min(:),paras(i)%cntr(:))
         sys_max(:) = MAX(sys_max(:),paras(i)%cntr(:))
      END DO
      fmm_system_size = MAXVAL(sys_max - sys_min)
      IF (fmm_system_size == zero) CALL fmm_quit('zero system size!')

      fmm_coord_shift = sys_min
!      DO i = 1, SIZE(paras)
!         paras(i)%cntr(:) = paras(i)%cntr(:) - sys_min(:)
!      END DO

   END SUBROUTINE fmm_get_system_size_and_shift

!-------------------------------------------------------------------------------

END MODULE fmm_qlm_builder

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_REOVC1(IRS2F,N,LRDIM,WRK,LWRK)
C
C     Purpose: reorder Cholesky vectors on disk to full storage.
C
#include "implicit.fh"
      INTEGER   IRS2F(N,LRDIM)
      DIMENSION WRK(LWRK)
#include "cholesky.fh"
#include "choreo.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_REOVC1')

      INTEGER IOFF(8,8)

      MULD2H(I,J)=IEOR(I-1,J-1)+1

      IF (N .LT. 3) THEN
         CALL CHO_QUIT('Dimension error in '//SECNAM,104)
      END IF

C     Save read-call counter.
C     -----------------------

      NSCALL = NSYS_CALL

C     Make rs1 the "current" reduced set (for reading).
C     -------------------------------------------------

      CALL CHO_RSCOPY(IWORK(ip_IIBSTRSH),IWORK(ip_NNBSTRSH),
     &                IWORK(ip_INDRED),1,2,NSYM,NNSHL,NNBSTRT(1),3)

C     Loop over Cholesky vector symmetries.
C     -------------------------------------

      DO ISYM = 1,NSYM
         IF (NUMCHO(ISYM) .GT. 0) THEN

C           Open files.
C           -----------

            CALL CHO_OPFVEC(ISYM,1)

C           Set up vector batch.
C           --------------------

            MINMEM = NNBSTR(ISYM,2) + NNBST(ISYM)
            IF (MINMEM .LT. 1) THEN
               WRITE(LUPRI,*) SECNAM,': MINMEM = ',MINMEM
               CALL CHO_QUIT('NNBST error in '//SECNAM,104)
               NVEC = 0
            ELSE
               NVEC = MIN(LWRK/MINMEM,NUMCHO(ISYM))
            END IF

            IF (NVEC .LT. 1) THEN
               WRITE(LUPRI,*) SECNAM,': NVEC   = ',NVEC
               WRITE(LUPRI,*) SECNAM,': LWRK   = ',LWRK
               WRITE(LUPRI,*) SECNAM,': MINMEM = ',MINMEM
               WRITE(LUPRI,*) SECNAM,': NUMCHO = ',NUMCHO(ISYM)
               WRITE(LUPRI,*) SECNAM,': ISYM   = ',ISYM
               CALL CHO_QUIT('Batch error in '//SECNAM,101)
               NBATCH = 0
            ELSE
               NBATCH = (NUMCHO(ISYM) - 1)/NVEC + 1
            END IF

C           Start batch loop over vectors.
C           ------------------------------

            DO IBATCH = 1,NBATCH

               IF (IBATCH .EQ. NBATCH) THEN
                  NUMV = NUMCHO(ISYM) - NVEC*(NBATCH - 1)
               ELSE
                  NUMV = NVEC
               END IF
               IVEC1 = NVEC*(IBATCH - 1) + 1

C              Read batch of reduced vectors.
C              ------------------------------

               KCHO1 = 1
               KREAD = KCHO1 + NNBSTR(ISYM,2)*NUMV
               LREAD = LWRK - KREAD + 1
               CALL CHO_GETVEC(WRK(KCHO1),NNBSTR(ISYM,2),NUMV,IVEC1,
     &                         ISYM,WRK(KREAD),LREAD)

C              Reorder.
C              --------

               KCHO2 = KREAD
               CALL CHO_IZERO(IOFF,64)
               ICOUNT = KCHO2 - 1
               DO ISYMB = 1,NSYM
                  ISYMA = MULD2H(ISYMB,ISYM)
                  IF (ISYMA .GE. ISYMB) THEN
                     IOFF(ISYMA,ISYMB) = ICOUNT
                     IOFF(ISYMB,ISYMA) = ICOUNT
                     ICOUNT = ICOUNT + NABPK(ISYMA,ISYMB)*NUMV
                  END IF
               END DO

               CALL CHO_DZERO(WRK(KCHO2),NNBST(ISYM)*NUMV)
               DO IVEC = 1,NUMV
                  KOFF1 = KCHO1 + NNBSTR(ISYM,2)*(IVEC - 1) - 1
                  DO IRS = 1,NNBSTR(ISYM,2)
                     I = IIBSTR(ISYM,2) + IRS
                     ISYMA = IRS2F(1,I)
                     ISYMB = IRS2F(2,I)
                     IAB   = IRS2F(3,I)
                     KOFF  = KOFF1 + IRS
                     LOFF  = IOFF(ISYMA,ISYMB)
     &                     + NABPK(ISYMA,ISYMB)*(IVEC - 1) + IAB
                     WRK(LOFF) = WRK(KOFF)
                  END DO
               END DO

C              Write full vectors to disk.
C              ---------------------------

               DO ISYMB = 1,NSYM
                  ISYMA = MULD2H(ISYMB,ISYM)
                  IF (ISYMA .GE. ISYMB) THEN
                     KOFF = IOFF(ISYMA,ISYMB) + 1
                     CALL CHO_WRFVEC(WRK(KOFF),ISYMA,ISYMB,IVEC1,NUMV)
                  END IF
               END DO

            END DO

C           Close files.
C           ------------

            CALL CHO_OPFVEC(ISYM,2)

         END IF
      END DO

C     Restore read-call counter.
C     --------------------------

      NSYS_CALL = NSCALL

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine Input_Seward(lOPTO)
!***********************************************************************
!                                                                      *
!     Object: to read the input to the integral package.               *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!                                                                      *
!             January '91 additional input for property calculations.  *
!             October '93 split up to RdCtl and SoCtl.                 *
!***********************************************************************

use Sizes_of_Seward, only: S
use Basis_Info, only: nBas
use Gateway_global, only: Test, PrPrt, Primitive_Pass
use Gateway_Info, only: Do_GuessOrb
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: lOPTO
#include "Molcas.fh"
#include "print.fh"
integer(kind=iwp) :: iRout
logical(kind=iwp), save :: Show_Save
logical(kind=iwp), external :: Reduce_Prt
character(len=LenIn), allocatable :: Mamn(:)
integer(kind=iwp), parameter :: nMamn = MaxBfn+MaxBfn_Aux

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 2
!                                                                      *
!***********************************************************************
!                                                                      *
if (Primitive_Pass) then
  Show_Save = Show
else
  Show = Show_Save
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Adjust the print level and some other parameters depending on
! if we are iterating or not.
!
! Set Show to false if Seward is run in property mode.
Show = Show .and. (.not. Prprt)

if (Reduce_Prt() .and. (nPrint(iRout) < 6) .and. (.not. Prprt)) then
  Show = .false.
  Do_GuessOrb = .false.
end if

Show = Show .and. (.not. Primitive_Pass)
Show = Show .or. Test
!                                                                      *
!***********************************************************************
!                                                                      *
! Modify storage of basis functions to be in accordance with a
! calculation in the primitive or contracted basis.

call Flip_Flop(Primitive_Pass)
!                                                                      *
!***********************************************************************
!                                                                      *
! Start of output, collect all output to this routine!

if (Show) call Output1_Seward(lOPTO)
!                                                                      *
!***********************************************************************
!                                                                      *
!-----Generate the SO or AO basis set

call mma_allocate(Mamn,nMamn,label='Mamn')
call SOCtl_Seward(Mamn,nMamn)
!                                                                      *
!***********************************************************************
!                                                                      *
if (Test) then
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Write information on the run file.

if (Primitive_Pass) then
  call Put_iArray('nBas_Prim',nBas,nIrrep)
  call Info2Runfile()
end if
call Put_cArray('Unique Basis Names',Mamn(1),(LENIN8)*S%nDim)
call Put_iArray('nBas',nBas,nIrrep)
call mma_deallocate(Mamn)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Input_Seward

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_APD2IndexIntegrals_11(A,B,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: get integrals (J|K) using atom pair-driven code.
C
C     NOTE: this code is for debugging only and requires that for each
C           atom C,D at least one atom pair can be found for which
C           (a) it contains atom A (C)
C           (b) it has no linear dependence in the linear dependence in
C               the one-center aux space.
C
      Implicit None
      Integer A
      Integer B
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_a2ap.fh"

      Character*25 SecNam
      Parameter (SecNam='LDF_APD2IndexIntegrals_11')

      Integer  LDF_nBasAux_Atom, LDF_nBasAux_Pair
      External LDF_nBasAux_Atom, LDF_nBasAux_Pair

      Integer AC, AC_, iAC, BD, BD_, iBD
      Integer l, nAC, nBD
      Integer ip_Int, l_Int
      Integer nA, iRow0
      Integer nB, iCol0
      Integer K, JK, ip, ip0

      Integer i, j
      Integer A2AP
      Integer AP_Atoms
      Integer AP_1CLinDep
      A2AP(i,j)=iWork(ip_A2AP-1+2*(j-1)+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)

      ! Get an atom pair that contains atom A and another containing C
      Call LDF_SetA2AP()
      AC=0
      l=A2AP(1,A)
      If (l.gt.0) Then
         ip=A2AP(2,A)-1
         iAC=0
         Do While (iAC.lt.l .and. AC.eq.0)
            iAC=iAC+1
            AC_=iWork(ip+iAC)
            If (AP_1CLinDep(1,AC_).eq.0) Then
               AC=AC_
            End If
         End Do
      End If
      If (AC.eq.0) Then
         Write(6,'(A,A,I5,A)')
     &   SecNam,': no atom pair containing atom ',A,
     &   ' has linearly independent one-center functions only!'
         Call WarningMessage(2,SecNam//': Suitable AP not found!')
         Call LDF_Quit(1)
      End If
      BD=0
      l=A2AP(1,B)
      If (l.gt.0) Then
         ip=A2AP(2,B)-1
         iBD=0
         Do While (iBD.lt.l .and. BD.eq.0)
            iBD=iBD+1
            BD_=iWork(ip+iBD)
            If (AP_1CLinDep(1,BD_).eq.0) Then
               BD=BD_
            End If
         End Do
      End If
      If (BD.eq.0) Then
         Write(6,'(A,A,I5,A)')
     &   SecNam,': no atom pair containing atom ',B,
     &   ' has linearly independent one-center functions only!'
         Call WarningMessage(2,SecNam//': Suitable AP not found!')
         Call LDF_Quit(1)
      End If
      Call LDF_UnsetA2AP()

      ! Allocate integral array
      nAC=LDF_nBasAux_Pair(AC)
      nBD=LDF_nBasAux_Pair(BD)
      l_Int=nAC*nBD
      Call GetMem('APD2I_11','Allo','Real',ip_Int,l_Int)

      ! Compute integrals
      Call LDF_ComputeIntegrals_JK_2P(AC,BD,l_Int,Work(ip_Int))

      ! Copy integrals to return
      nA=LDF_nBasAux_Atom(A)
      If (AP_Atoms(1,AC).eq.A) Then
         iRow0=0
      Else If (AP_Atoms(2,AC).eq.A) Then
         iRow0=LDF_nBasAux_Atom(AP_Atoms(1,AC))
      Else
         Call WarningMessage(2,SecNam//': Logical error! [1]')
         Call LDF_Quit(1)
         iRow0=0 ! avoid compiler warning
      End If
      nB=LDF_nBasAux_Atom(B)
      If (AP_Atoms(1,BD).eq.B) Then
         iCol0=0
      Else If (AP_Atoms(2,BD).eq.B) Then
         iCol0=LDF_nBasAux_Atom(AP_Atoms(1,BD))
      Else
         Call WarningMessage(2,SecNam//': Logical error! [2]')
         Call LDF_Quit(1)
         iCol0=0 ! avoid compiler warning
      End If
      l=nA*nB
      If (l.gt.l_xInt_) Then
         Call WarningMessage(2,
     &               SecNam//': Insufficient integral array dimension!')
         Call LDF_Quit(1)
      Else
         JK=0
         ip0=ip_Int-1
         Do K=iCol0+1,iCol0+nB
            ip=ip0+nAC*(K-1)
            Do J=iRow0+1,iRow0+nA
               JK=JK+1
               xInt(JK)=Work(ip+J)
            End Do
         End Do
      End If

      ! Deallocate integral array
      Call GetMem('APD2I_11','Free','Real',ip_Int,l_Int)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_APD2IndexIntegrals_12(A,CD,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: get integrals (J|K) using atom pair-driven code.
C
C     NOTE: this code is for debugging only and requires that for
C           atom A at least one atom pair can be found for which
C           (a) it contains atom A
C           (b) it has no linear dependence in the linear dependence in
C               the one-center aux space.
C
      Implicit None
      Integer A
      Integer CD
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_a2ap.fh"

      Character*25 SecNam
      Parameter (SecNam='LDF_APD2IndexIntegrals_12')

      Integer  LDF_nBasAux_Atom, LDF_nBasAux_Pair
      External LDF_nBasAux_Atom, LDF_nBasAux_Pair

      Integer AB, AB_, iAB, C, D
      Integer ip0, ip, l
      Integer nAB, nCD
      Integer ip_Int, l_Int
      Integer nA, K, JK
      Integer iRow0, iCol0

      Integer i, j
      Integer A2AP
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      A2AP(i,j)=iWork(ip_A2AP-1+2*(j-1)+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Quick return
      If (AP_2CFunctions(1,CD).lt.1) Return

      ! Get an atom pair that contains atom A and another containing C
      Call LDF_SetA2AP()
      AB=0
      l=A2AP(1,A)
      If (l.gt.0) Then
         ip=A2AP(2,A)-1
         iAB=0
         Do While (iAB.lt.l .and. AB.eq.0)
            iAB=iAB+1
            AB_=iWork(ip+iAB)
            If (AP_1CLinDep(1,AB_).eq.0) Then
               AB=AB_
            End If
         End Do
      End If
      If (AB.eq.0) Then
         Write(6,'(A,A,I5,A)')
     &   SecNam,': no atom pair containing atom ',A,
     &   ' has linearly independent one-center functions only!'
         Call WarningMessage(2,SecNam//': Suitable AP not found!')
         Call LDF_Quit(1)
      End If
      Call LDF_UnsetA2AP()

      ! Allocate integral array
      nAB=LDF_nBasAux_Pair(AB)
      nCD=LDF_nBasAux_Pair(CD)
      l_Int=nAB*nCD
      Call GetMem('APD2I_12','Allo','Real',ip_Int,l_Int)

      ! Compute integrals
      Call LDF_ComputeIntegrals_JK_2P(AB,CD,l_Int,Work(ip_Int))

      ! Copy integrals to return
      nA=LDF_nBasAux_Atom(A)
      l=nA*AP_2CFunctions(1,CD)
      If (l.gt.l_xInt_) Then
         Call WarningMessage(2,
     &               SecNam//': Insufficient integral array dimension!')
         Call LDF_Quit(1)
      Else
         If (AP_Atoms(1,AB).eq.A) Then
            iRow0=0
         Else If (AP_Atoms(2,AB).eq.A) Then
            iRow0=LDF_nBasAux_Atom(AP_Atoms(1,AB))
         Else
            Call WarningMessage(2,SecNam//': Logical error!')
            Call LDF_Quit(1)
            iRow0=0 ! avoid compiler warning
         End If
         C=AP_Atoms(1,CD)
         D=AP_Atoms(2,CD)
         If (C.eq.D) Then
            iCol0=LDF_nBasAux_Atom(C)-AP_1CLinDep(1,CD)
         Else
            iCol0=LDF_nBasAux_Atom(C)+LDF_nBasAux_Atom(D)
     &           -AP_1CLinDep(1,CD)
         End If
         JK=0
         ip0=ip_Int-1
         Do K=iCol0+1,iCol0+AP_2CFunctions(1,CD)
            ip=ip0+nAB*(K-1)
            Do J=iRow0+1,iRow0+nA
               JK=JK+1
               xInt(JK)=Work(ip+J)
            End Do
         End Do
      End If

      ! Deallocate integral array
      Call GetMem('APD2I_12','Free','Real',ip_Int,l_Int)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_APD2IndexIntegrals_22(AB,CD,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: get integrals (J|K) using atom pair-driven code.
C
C     NOTE: this code is for debugging only.
C
      Implicit None
      Integer AB
      Integer CD
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*25 SecNam
      Parameter (SecNam='LDF_APD2IndexIntegrals_22')

      Integer  LDF_nBasAux_Pair
      External LDF_nBasAux_Pair

      Integer nAB, nCD
      Integer ip_Int, l_Int
      Integer l, ip, ip0
      Integer JK, K
      Integer iRow0, iCol0

      Integer i, j
      Integer AP_2CFunctions
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Quick return
      If (AP_2CFunctions(1,AB).lt.1 .or. AP_2CFunctions(1,CD).lt.1) Then
         Return
      End If

      ! Allocate integral array
      nAB=LDF_nBasAux_Pair(AB)
      nCD=LDF_nBasAux_Pair(CD)
      l_Int=nAB*nCD
      Call GetMem('APD2I_22','Allo','Real',ip_Int,l_Int)

      ! Compute integrals
      Call LDF_ComputeIntegrals_JK_2P(AB,CD,l_Int,Work(ip_Int))

      ! Copy integrals to return
      l=AP_2CFunctions(1,AB)*AP_2CFunctions(1,CD)
      If (l.gt.l_xInt_) Then
         Call WarningMessage(2,
     &               SecNam//': Insufficient integral array dimension!')
         Call LDF_Quit(1)
      Else
         iRow0=LDF_nBasAux_Pair(AB)-AP_2CFunctions(1,AB)
         iCol0=LDF_nBasAux_Pair(CD)-AP_2CFunctions(1,CD)
         JK=0
         ip0=ip_Int-1
         Do K=iCol0+1,iCol0+AP_2CFunctions(1,CD)
            ip=ip0+nAB*(K-1)
            Do J=iRow0+1,iRow0+AP_2CFunctions(1,AB)
               JK=JK+1
               xInt(JK)=Work(ip+J)
            End Do
         End Do
      End If

      ! Deallocate integral array
      Call GetMem('APD2I_22','Free','Real',ip_Int,l_Int)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine divfok(wrk,wrksize,fa,fb,fk1,fk2,fk3,fk4,fk5,fk6,dp1,dp2,rc)
! this routine divides fok(p,q) -> fk(a,b) + fk(a,i) + f(i,j) + dp(p)
! to diagonal part and rest
!
! map type for:
! fa,fb - fok(p,q)aa,bb
! fk1-6 - f(ab)aa,f(ab)bb,f(ai)aa,f(ai)bb,f(ij)aa,f(ij)bb
! dp1,2 - diagonal part dp(p)a,b
! rc    - return (error) code

use ccsd_global, only: Map_Type, noa, nob, norb, nsym, nva, nvb
use Definitions, only: wp, iwp

implicit none
!1 maps for FOKA,FOKB
!2 maps for FK
!  FK1 - f(a,b)aa
!  FK2 - f(a,b)bb
!  FK3 - f(a,i)aa
!  FK4 - f(a,i)bb
!  FK5 - f(i,j)aa
!  FK6 - f(i,j)bb
!3 maps for DP - diagonal part
!  DP1 - dp(p)a
!  DP2 - dp(p)b
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: fa, fb, fk1, fk2, fk3, fk4, fk5, fk6, dp1, dp2
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: iidp, iidpa, iidpb, iifaa, iifai, iifii, iifok, iifoka, iifokb, posdp, posdpa, posdpb, posfaa, posfai, &
                     posfii, posfok, posfoka, posfokb, rc1, symp

rc = 0

!1 define dp

do symp=1,nsym

  iidpa = dp1%i(symp,1,1)
  posdpa = dp1%d(iidpa,1)
  iidpb = dp2%i(symp,1,1)
  posdpb = dp2%d(iidpb,1)
  iifoka = fa%i(symp,1,1)
  posfoka = fa%d(iifoka,1)
  iifokb = fb%i(symp,1,1)
  posfokb = fb%d(iifokb,1)

  if (norb(symp) > 0) call fokunpck5(symp,wrk(posfoka),wrk(posfokb),wrk(posdpa),wrk(posdpb),norb(symp),rc1)

end do

!2 define faa,fai,fii

do symp=1,nsym
  if (norb(symp) == 0) cycle

  !2.1 alpha case

  iifok = fa%i(symp,1,1)
  iifaa = fk1%i(symp,1,1)
  iifai = fk3%i(symp,1,1)
  iifii = fk5%i(symp,1,1)
  iidp = dp1%i(symp,1,1)

  posfok = fa%d(iifok,1)
  posfaa = fk1%d(iifaa,1)
  posfai = fk3%d(iifai,1)
  posfii = fk5%d(iifii,1)
  posdp = dp1%d(iidp,1)

  call fokunpck1(wrk(posfok),wrk(posdp),norb(symp))
  if (nva(symp) > 0) call fokunpck2(wrk(posfok),wrk(posfaa),norb(symp),nva(symp),noa(symp))
  if ((noa(symp)*nva(symp)) > 0) call fokunpck3(wrk(posfok),wrk(posfai),norb(symp),nva(symp),noa(symp))
  if (noa(symp) > 0) call fokunpck4(wrk(posfok),wrk(posfii),norb(symp),noa(symp))

  !2.2 alpha case

  iifok = fb%i(symp,1,1)
  iifaa = fk2%i(symp,1,1)
  iifai = fk4%i(symp,1,1)
  iifii = fk6%i(symp,1,1)
  iidp = dp2%i(symp,1,1)

  posfok = fb%d(iifok,1)
  posfaa = fk2%d(iifaa,1)
  posfai = fk4%d(iifai,1)
  posfii = fk6%d(iifii,1)
  posdp = dp2%d(iidp,1)

  call fokunpck1(wrk(posfok),wrk(posdp),norb(symp))
  if (nvb(symp) > 0) call fokunpck2(wrk(posfok),wrk(posfaa),norb(symp),nvb(symp),nob(symp))
  if ((nob(symp)*nvb(symp)) > 0) call fokunpck3(wrk(posfok),wrk(posfai),norb(symp),nvb(symp),nob(symp))
  if (nob(symp) > 0) call fokunpck4(wrk(posfok),wrk(posfii),norb(symp),nob(symp))

end do

return

end subroutine divfok

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Print_Basis2()

use Basis_Info, only: dbsc, iCnttp_Dummy, nCnttp, Shells
use Center_Info, only: dc
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
#include "angtp.fh"
#include "print.fh"
integer(kind=iwp) :: i, iAddr, iAng, iAngl, ib, iBas, iBas_Aux, iBas_Frag, iBass, ic, icnt, iCnttp, iExp, iPrim, iPrim_Aux, &
                     iPrim_Frag, iPrimm, iPrint, ir, iRout, irow, iSh, iShell, iShSrt, jExp, jSh, kCmp, kExp, kSh, kShEnd, kShStr, &
                     lSh, mdc, nBasisj, ncr, nExpi, nExpj, nExpk, nSumA, nSumB
logical(kind=iwp) :: lAux, lECP, lFAIEMP, lPam2, lPP, output
real(kind=wp) :: ccr, zcr

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 2
iPrint = nPrint(iRout)

lAux = .false.
lPam2 = .false.
lECP = .false.
lPP = .false.
lFAIEMP = .false.
do i=1,nCnttp
  lAux = lAux .or. dbsc(i)%Aux
  lPAM2 = lPAM2 .or. dbsc(i)%lPAM2
  lECP = lECP .or. dbsc(i)%ECP
  lPP = lPP .or. (dbsc(i)%nPP /= 0)
  lFAIEMP = lFAIEMP .or. dbsc(i)%Frag
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (iPrint >= 6) then
  write(u6,*)
  call CollapseOutput(1,'   Primitive basis info:')
  write(u6,'(3X,A)') '   ---------------------'
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of primitive basis functions

if (iPrint >= 6) then
  write(u6,*)
  write(u6,'(19X,A)') ' *****************************************************'
  write(u6,'(19X,A)') ' ******** Primitive Basis Functions (Valence) ********'
  write(u6,'(19X,A)') ' *****************************************************'
end if
! Loop over distinct shell types
jExp = 0
iPrim = 0
iPrim_Aux = -1
iPrim_Frag = 0
iBas = 0
iBas_Aux = -1
iBas_Frag = 0
iShell = 0
! Loop over basis sets
do iCnttp=1,nCnttp
  mdc = dbsc(iCnttp)%mdci
  output = iPrint >= 6
  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag) output = output .and. (iPrint >= 10) .and. (iCnttp /= iCnttp_Dummy)
  if (output) then
    write(u6,*)
    write(u6,*)
    write(u6,'(A,A)') ' Basis set:',dbsc(iCnttp)%Bsl
  end if
  iShSrt = dbsc(iCnttp)%iVal
  ! Loop over distinct centers
  do icnt=1,dbsc(iCnttp)%nCntr
    mdc = mdc+1
    if (mdc > MxAtom) then
      call WarningMessage(2,'MxAtom too small')
      write(u6,*) 'MxAtom=',MxAtom
      write(u6,*) 'Increase MxAtom in Molcas.fh and recompile the code!'
      call Abend()
    end if
    ! Loop over shells associated with this center
    ! Start with s type shells
    jSh = iShSrt
    do iAng=0,dbsc(iCnttp)%nVal-1
      iShell = iShell+1
      nExpj = Shells(jSh)%nExp
      nBasisj = Shells(jSh)%nBasis
      if ((S%MaxPrm(iAng) > 0) .and. (nExpj > 0) .and. (nBasisj > 0) .and. output .and. (iCnt == 1)) then
        write(u6,*)
        write(u6,*) '                 Type         '
        write(u6,'(19X,A)') AngTp(iAng)
        write(u6,*) '          No.      Exponent    Contraction Coefficients'
      end if

      if ((nBasisj > 0) .and. output) then
        do kExp=1,nExpj
          jExp = jExp+1
          if (iCnt == 1) write(u6,100) jExp,Shells(jSh)%Exp(kExp),(Shells(jSh)%Cff_c(kExp,ib,2),ib=1,nBasisj)
        end do
      end if
      if (iShell > MxShll) then
        call WarningMessage(2,'iShell > MxShll')
        write(u6,*) ' Change MxShll in Molcas.fh and recompile the code!'
        call Abend()
      end if
      kCmp = (iAng+1)*(iAng+2)/2
      if (Shells(jSh)%Prjct) kCmp = 2*iAng+1
      if (nBasisj /= 0) then
        if (Shells(jSh)%Aux) then
          iPrim_Aux = iPrim_Aux+nExpj*kCmp*nIrrep/dc(mdc)%nStab
          iBas_Aux = iBas_Aux+nBasisj*kCmp*nIrrep/dc(mdc)%nStab
        else if (Shells(jSh)%Frag) then
          iPrim_Frag = iPrim_Frag+nExpj*kCmp*nIrrep/dc(mdc)%nStab
          iBas_Frag = iBas_Frag+nBasisj*kCmp*nIrrep/dc(mdc)%nStab
        else
          iPrim = iPrim+nExpj*kCmp*nIrrep/dc(mdc)%nStab
          iBas = iBas+nBasisj*kCmp*nIrrep/dc(mdc)%nStab
        end if
      end if
      jSh = jSh+1
    end do
  end do

end do
if (iBas >= 2*MaxBfn) then
  call WarningMessage(2,'MaxBfn too small')
  write(u6,*) 'Input: Increase 2*MaxBfn to ',iBas
  call Abend()
end if
if (iPrint >= 6) then
  write(u6,*)
  write(u6,*) ' Number of primitives                ',iPrim
  write(u6,*) ' Number of basis functions           ',iBas
  if (lAux .and. (iPrint >= 10)) then
    write(u6,*) ' Number of primitive aux. functions  ',iPrim_Aux
    write(u6,*) ' Number of auxiliary basis functions ',iBas_Aux
  end if
  if (lFAIEMP .and. (iPrint >= 10)) then
    write(u6,*) ' Number of primitive frag. functions ',iPrim_Frag
    write(u6,*) ' Number of fragment basis functions  ',iBas_Frag
  end if
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (lPAM2) then
  write(u6,*)
  write(u6,'(19X,A)') ' *************************************************'
  write(u6,'(19X,A)') ' ******** Primitive Basis Functions (PAM) ********'
  write(u6,'(19X,A)') ' *************************************************'
  do iCnttp=1,nCnttp
    if (dbsc(iCnttp)%lPAM2) then
      !if (iPrint >= 10) then
      write(u6,*)
      write(u6,*)
      write(u6,'(A,A)') ' Basis set:',dbsc(iCnttp)%Bsl
      if (dbsc(iCnttp)%nPAM2 /= -1) then
        write(u6,*)
        write(u6,*) 'Angular momentum of PAM operator: ',AngTp(dbsc(iCnttp)%nPAM2)
        iAddr = 1

        do iAngl=0,dbsc(iCnttp)%nPAM2
          iPrimm = int(dbsc(iCnttp)%PAM2(iAddr))
          iBass = int(dbsc(iCnttp)%PAM2(iAddr+1))
          write(u6,'(A,3x,a1)') ' Ang. moment: ',AngTp(iAngl)
          write(u6,'(A,i4,A,i4)') ' Number of  primitive:',iPrimm,' Number of contracted:',iBass
          write(u6,*)
          write(u6,'(A)') '  N.        Exponents            Coefficent:'

          do ir=0,iPrimm-1
            write(u6,200) ir+1,dbsc(iCnttp)%PAM2(iAddr+2+ir),(dbsc(iCnttp)%PAM2(iAddr+2+iPrimm+ic),ic=ir,(iPrimm)*iBass-1,iPrimm)
          end do

          iAddr = iAddr+2+iPrimm+iPrimm*iBass
        end do
      end if
      !end if
    end if
  end do

end if
!                                                                      *
!***********************************************************************
!                                                                      *
if ((iPrint >= 10) .and. (lECP .or. lPP)) then
  write(u6,*)
  write(u6,'(19X,A)') ' *************************************************'
  write(u6,'(19X,A)') ' ******** Primitive Basis Functions (ECP) ********'
  write(u6,'(19X,A)') ' *************************************************'
  !else
  !  ! start Molcas
  !  if (iPrint < 6) write(u6,*) 'To display basis set information use the key "BSSHOW" in the input.'
  !  if ((lECP .or. lPP) .and. (iPrint < 10)) write(u6,*) 'To display ECP information use the key "ECPSHOW" in the input.'
  !  if (lAUX .and. (iPrint < 10)) write(u6,*) 'To display auxiliary basis information use the key "AUXSHOW" in the input.'
  !end
end if

do iCnttp=1,nCnttp

  ! Pseudo potential type ECP

  if ((dbsc(iCnttp)%nPP /= 0) .and. (iPrint >= 10)) then
    write(u6,*)
    write(u6,*)
    write(u6,'(A,A)') ' Basis set:',dbsc(iCnttp)%Bsl
    write(u6,*)
    write(u6,'(A)') ' Pseudo Potential'
    write(u6,*)
    kShStr = dbsc(iCnttp)%iPP
    kShEnd = kShStr+dbsc(iCnttp)%nPP-1
    lSh = 0
    do kSh=kShStr,kShEnd
      nExpk = Shells(kSh)%nExp
      if (nExpk /= 0) then
        if (lSh == 0) then
          write(u6,'(4X,A)') '  H Potential'
        else
          write(u6,'(4X,A)') AngTp(lSh-1)//'-H Potential'
        end if
      end if
      lSh = lSh+1
      write(u6,'(A)') '  n     Exponent      Coefficient'
      do iExp=1,nExpk,3
        ncr = int(Shells(kSh)%Exp(iExp))
        zcr = Shells(kSh)%Exp(iExp+1)
        ccr = Shells(kSh)%Exp(iExp+2)
        write(u6,'(2x,I1,3X,2F15.10)') ncr,zcr,ccr
      end do
      write(u6,*)

    end do
  end if

  ! Huzinaga type ECP

  if (dbsc(iCnttp)%ECP) then
    if (iPrint >= 10) then
      write(u6,*)
      write(u6,*)
      write(u6,'(A,A)') ' Basis set:',dbsc(iCnttp)%Bsl

      if (dbsc(iCnttp)%nM1 /= 0) then
        write(u6,*)
        write(u6,*) ' M1 operator       Exponent    Contraction Coefficients'
        do irow=1,dbsc(iCnttp)%nM1
          write(u6,'(14X,D16.9,1X,D19.9)') dbsc(iCnttp)%M1xp(irow),dbsc(iCnttp)%M1cf(irow)
        end do
      end if ! if (dbsc(iCnttp)%nM1 /= 0) then

      if (dbsc(iCnttp)%nM2 /= 0) then
        write(u6,*)
        write(u6,*) ' M2 operator       Exponent    Contraction Coefficients'
        do irow=1,dbsc(iCnttp)%nM2
          write(u6,'(14X,D16.9,1X,D19.9)') dbsc(iCnttp)%M2xp(irow),dbsc(iCnttp)%M2cf(irow)
        end do
      end if ! if (dbsc(iCnttp)%nM2 /= 0) then
    end if ! if (iPrint >= 10) then

    ! Projection Basis Set

    iSh = dbsc(iCnttp)%iPrj
    nSumB = 0
    jSh = iSh
    do iAng=0,dbsc(iCnttp)%nPrj-1
      nSumB = nSumB+Shells(jSh)%nBasis
      jSh = jSh+1
    end do
    if ((nSumB /= 0) .and. (iPrint >= 10)) then
      write(u6,*)
      write(u6,*)
      write(u6,*) ' Proj. Operator'
    end if
    do iAng=0,dbsc(iCnttp)%nPrj-1
      if (Shells(iSh)%nBk /= 0) then
        if (iPrint >= 10) then
          write(u6,*)
          write(u6,'(19X,A,A)') '        Angular Type: ',AngTp(iAng)
          write(u6,*) '                   Exponent    Contraction Coefficients'
          write(u6,*)
          write(u6,'(A,18X,8(G12.5),/,5(32X,8(G12.5),/))') '     Bk-values',(Shells(iSh)%Bk(i),i=1,Shells(iSh)%nBk)
          write(u6,'(A,18X,8(G12.5),/,5(32X,8(G12.5),/))') '     Frac.Occ.',(Shells(iSh)%Occ(i),i=1,Shells(iSh)%nBk)
        end if

        do i=1,Shells(iSh)%nBk
          Shells(iSh)%Bk(i) = Shells(iSh)%Bk(i)*Shells(iSh)%Occ(i)
        end do

        if (iPrint >= 10) then
          do kExp=1,Shells(iSh)%nExp
            jExp = jExp+1
            write(u6,300) Shells(ish)%Exp(kExp),(Shells(ish)%Cff_c(kExp,ib,2),ib=1,Shells(iSh)%nBk)
          end do
        end if ! if (iPrint >= 10) then
      end if ! if (Shells(iSh)%nBk /= 0) then
      iSh = iSh+1
    end do ! iAng

    ! Auxiliary core basis

    if (iPrint >= 10) then
      iSh = dbsc(iCnttp)%iSOC
      nSumB = 0
      jSh = iSh
      do iAng=0,dbsc(iCnttp)%nSOC-1
        nSumB = nSumB+Shells(jSh)%nBasis
        jSh = jSh+1
      end do
      if ((nSumB /= 0) .and. (iPrint >= 10)) then
        write(u6,*)
        write(u6,*)
        write(u6,*) ' SOC Basis'
      end if
      do iAng=0,dbsc(iCnttp)%nSOC-1
        if (Shells(iSh)%nBasis /= 0) then
          write(u6,*)
          write(u6,'(19X,A,A)') '        Angular Type: ',AngTp(iAng)
          write(u6,*) '                   Exponent    Contraction Coefficients'
          write(u6,*)
          do kExp=1,Shells(iSh)%nExp
            jExp = jExp+1
            write(u6,400) Shells(iSh)%Exp(kExp),(Shells(iSh)%Cff_c(kExp,ib,1),ib=1,Shells(iSh)%nBasis)
          end do
        end if
        iSh = iSh+1
      end do
    end if ! if (iPrint >= 10) then

    ! Spectral Resolution Basis Set

    if (iPrint >= 10) then
      iSh = dbsc(iCnttp)%iSRO
      nSumA = 0
      jSh = iSh
      do iAng=0,dbsc(iCnttp)%nSRO-1
        nSumA = nSumA+Shells(jSh)%nExp
        jSh = jSh+1
      end do
      if (nSumA /= 0) then
        write(u6,*)
        write(u6,*)
        write(u6,*) ' Spectral Resolution Basis Set'
      end if
      do iAng=0,dbsc(iCnttp)%nSRO-1
        nExpi = Shells(iSh)%nExp
        if (nExpi /= 0) then
          write(u6,*)
          write(u6,'(19X,A,A)') '        Angular Type: ',AngTp(iAng)
          call RecPrt(' Exponents',' ',Shells(iSh)%Exp,nExpi,1)
          if (iPrint >= 11) then
            call RecPrt(' The Akl matrix','(5D20.13)',Shells(iSh)%Akl(1,1,1),nExpi,nExpi)
            call RecPrt(' The Adl matrix','(5D20.13)',Shells(iSh)%Akl(1,1,2),nExpi,nExpi)
          end if
        end if
        iSh = iSh+1
      end do ! iAng
    end if ! if (iPrint >= 10) then
  end if ! if (dbsc(iCnttp)%ECP) then

end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (iPrint >= 6) then
  call CollapseOutput(0,'   Primitive basis info:')
  write(u6,*)
end if

return

100 format(9X,I4,1X,D16.9,10(1X,F10.6),1X,3(/,30X,10(1X,F10.6)))
200 format(i4,1x,f18.12,1x,12(1x,f12.8))
300 format(14X,D16.9,8(G12.5),3(/,30X,8(G12.5)))
400 format(14X,D16.9,10(1X,F10.6),3(/,30X,10(1X,F10.6)))

end subroutine Print_Basis2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ANNSTR(STRING,NSTINI,NSTINO,NEL,NORB,
     &                  Z,NEWORD,LROW,LSGSTR,ISGSTI,ISGSTO,TI,TTO,
     &                  I1TYP,IPRNT)
*
* A set of strings containing NEL electrons are given
* set up all possible ways of annihilating an electron from
* this set of string
*
*========
* Input :
*========
* STRING : Input strings containing NEL electrons
* NSTINI : Number of NEL  strings
* NSTINO : Number of NEL-1 strings
* NEL    : Number of electrons in input strings
* NORB   : Number of orbitals
* Z      : Lexical ordering matrix for output strings containing
*          NEL - 1 electrons
* NEWORD : Reordering array for N-1 strings
* LROW   : Number of rows in output vector
*          = NEL : Information is written in truncated form
*                  row  corresponds to place of electron
*          = NORB: Information is written in expanded form,
*                  row corresponds to full orbital number
* LSGSTI : NE.0 => use ISGSTI,ISGSTO to allow for sign of string
* ISGSTI : Sign array for NEL   strings
* ISGSTO : Sign array for NEL-1 strings
*
*=========
* Output :
*=========
*TI      : Array giving minus orbital annihilated
*          TI(I,ISTRIN).LT.0 : Orbital TI(I,ISTRIN) can be
*          annihilated from string ISTRIN
*TTO     : Resulting NEL - 1 strings
*          if the resulting string has carries a negative sign
*          then the string number is shifted with a NSTINO
*          TTO(I,ISTRIN) = .LE.0 indicates that orbital I cannot be
*                             added to istrin
*          TTO(I,ISTRIN) = LSTRIN.NE.0 indicates that I added to
*                          ISTRIN  gives LSTRIN . If LSTRIN is
*                          nehative
*                          A+(I)!ISTRIN>=-!-LSTRIN> .
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER  STRING,TI,TTO,STRIN2,Z
*.Input
      DIMENSION STRING(NEL,NSTINI),NEWORD(NSTINO),Z(NORB,NEL-1)
      DIMENSION ISGSTI(NSTINI),ISGSTO(NSTINO)
*.Output
      DIMENSION TI(LROW,NSTINI),TTO(LROW,NSTINI)
*.Scratch
      DIMENSION STRIN2(500)
*
      NTEST0 =   0
      NTEST = MAX(NTEST0,IPRNT)
      IF( NTEST .GE.  20 ) THEN
        WRITE(6,*)  ' =============== '
        WRITE(6,*)  ' ANNSTR speaking '
        WRITE(6,*)  ' =============== '
      END IF
      LUOUT = 6
*. Expanded or truncated form
      IF(LROW.EQ.NEL.AND.NEL.NE.NORB)THEN
        IEXPN = 0
      ELSE
        IEXPN = 1
      END IF
*. Loop over input strings
      DO 1000 ISTRIN = 1,NSTINI
*. loop over electrons to be removed
        DO 100 IEL = 1,NEL
          IF(IEXPN.EQ.0) THEN
            IPLACE = IEL
          ELSE
            IPLACE = STRING(IEL,ISTRIN)
          END IF
          DO 30 I = 1, IEL-1
          STRIN2(I) = STRING(I,ISTRIN)
   30     CONTINUE
          DO 40 I = IEL+1,NEL
          STRIN2(I-1) = STRING(I,ISTRIN)
   40     CONTINUE
*. Is new string allowed ?
          ITYPE = IOCTP2_MCLR(STRIN2,NEL-1,I1TYP)
          IF(ITYPE.NE.0) THEN
*                    ISTRNM(IOCC,NORB,NEL,Z,NEWORD,IREORD)
            JSTRIN = ISTRNM(STRIN2,NORB,NEL-1,Z,NEWORD,1)
            TTO(IPLACE,ISTRIN) = JSTRIN
            TI(IPLACE,ISTRIN) = - STRING(IEL,ISTRIN)
            IIISGN = (-1)**(IEL-1)
            IF(LSGSTR.GT.0)
     &      IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
            IF(IIISGN .EQ. -1 ) TTO(IPLACE,ISTRIN) = -TTO(IPLACE,ISTRIN)
          END IF
  100   CONTINUE
 1000 CONTINUE
*
      IF ( NTEST .GE. 20) THEN
        MAXPR = 60
        NPR = MIN(NSTINI,MAXPR)
        WRITE(LUOUT,*) ' Output from ANNSTR : '
        WRITE(LUOUT,*) '==================='
         IF(IEXPN.EQ.0) THEN
           WRITE(LUOUT,*) ' Strings with an electron removed '
         ELSE
           WRITE(LUOUT,*) ' Combined N+1/N-1 string array '
         END IF
         DO 1235 ISTRIN = 1, NPR
            WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &      'String..',ISTRIN,' New strings.. ',
     &      (TTO(I,ISTRIN),I = 1,LROW)
 1235    CONTINUE
*
         WRITE(6,*) ' orbitals removed '
         DO 1236 ISTRIN = 1, NPR
            WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &      'String..',ISTRIN,' orbitals annihilated.. ',
     &      (TI(I,ISTRIN),I = 1,LROW)
 1236    CONTINUE

      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
function ILEX_FOR_CONF_NEW(ICONF,NOCC_ORB,NORB,NEL,IARCW,IDOREO,IREO_new,nconf_op,ib_occls)
! A configuration ICONF of NOCC_ORB orbitals are given
! ICONF(I) = IORB implies IORB is singly occupied
! ICONF(I) = -IORB implies that IORB is doubly occupied
!
! Find lexical address
!
! IF IDOREO /= 0, IREO is used to reorder lexical number
! Jeppe Olsen, November 2001

use Definitions, only: iwp
#ifdef  _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: ILEX_FOR_CONF_NEW
integer(kind=iwp), intent(in) :: NOCC_ORB, ICONF(NOCC_ORB), NORB, NEL, IARCW(NORB,NEL,2), IDOREO, IREO_new(*), nconf_op, ib_occls
integer(kind=iwp) :: IEL, ILEX, IOCC, length, n_ave, n_end, n_fin, n_ini

IEL = 0
ILEX = 1

do IOCC=1,NOCC_ORB
  if (ICONF(IOCC) > 0) then
    IEL = IEL+1
    ILEX = ILEX+IARCW(ICONF(IOCC),IEL,1)
  else if (ICONF(IOCC) < 0) then
    IEL = IEL+2
    ILEX = ILEX+IARCW(-ICONF(IOCC),IEL,2)
  end if
end do

if (IDOREO /= 0) then

  !length = nconf_per_open(2*nocc_orb-nel+1,1)
  length = nconf_op
# ifdef  _DEBUGPRINT_
  write(u6,*) 'in ilex_for_conf_new, check if all is right'
  write(u6,*) 'iconf:',iconf(:)
  write(u6,*) 'ilex and offset:',ilex,ib_occls
  write(u6,*) 'nconf_op =',nconf_op
  write(u6,*) 'ireo_new:'
  call iwrtma(ireo_new,1,length,1,length)
# endif
  !call iwrtma(nconf_per_open,1,4,1,4)
  ! look for the position where the value is ilex
  if (ireo_new(1) == ilex+ib_occls-1) then
    n_fin = 1
  else if (ireo_new(length) == ilex+ib_occls-1) then
    n_fin = length
  else
    n_ini = 1
    n_end = length
    do
      n_ave = (n_ini+n_end)/2
      if (ireo_new(n_ave) == ilex+ib_occls-1) exit
      if (ireo_new(n_ave) < ilex+ib_occls-1) n_ini = n_ave
      if (ireo_new(n_ave) > ilex+ib_occls-1) n_end = n_ave
    end do
    n_fin = n_ave
  end if
  ilex_for_conf_new = n_fin

else
  ILEX_FOR_CONF_NEW = ILEX
end if

#ifdef  _DEBUGPRINT_
write(u6,*) ' Configuration'
call IWRTMA(ICONF,1,NOCC_ORB,1,NOCC_ORB)
write(u6,*) ' new Lexical number = ',ILEX
if (IDOREO /= 0) write(u6,*) ' new Reordered number = ',ILEX_FOR_CONF_NEW
#endif

end function ILEX_FOR_CONF_NEW

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Ignacio Fdez. Galvan                             *
************************************************************************

* Module replacing the code in prgminit.c in molcas-extra

#include "compiler_features.h"
! from getenvc.c
#define MAXSTR 256

!define _DEBUGPRINT_

      Module prgm
      Implicit None
      Private
      Type FileEntry
        Character (Len=MAXSTR) :: Filename
        Character (Len=MAXSTR) :: Shortname
        Character (Len=16) :: Attributes
      End Type FileEntry
      Type(FileEntry), Dimension(:), Allocatable :: FileTable
      Character (Len=MAXSTR) :: WorkDir='', FastDir='', Project='Noname'
      Character (Len=16) :: SlaveDir='', SubDir=''

      Public :: PrgmInitC, PrgmFree, PrgmTranslate_Mod, SetSubDir
#ifndef _GA_
      Public :: IsInMem
#endif

      Contains

      Subroutine PrgmInitC(ModName, l)
      Character (Len=*), Intent(In) :: ModName
      Integer, Intent(In) :: l
      Call PrgmCache()
      Call ReadPrgmFile(ModName)
      Call ReadPrgmFile('global')
      Return
!     Avoid unused argument warnings
      If (.False.) Call Unused_integer(l)
      End Subroutine PrgmInitC

      Subroutine PrgmFree()
      If (Allocated(FileTable)) Deallocate(FileTable)
      End Subroutine PrgmFree

      Subroutine PrgmTranslate_Mod(InStr,l1,OutStr,l2,Par)
      Character (Len=*), Intent(In) :: InStr
      Character (Len=*), Intent(Out) :: OutStr
      Integer, Intent(In) :: Par, l1
      Integer, Intent(Out) :: l2
      Character (Len=Len(InStr)) :: Input
      Character (Len=MAXSTR) :: WD, Ext
      Character (Len=16) :: Attr
      Integer :: Num, Loc
      Logical :: Found, Lustre
      Lustre = .False.
      Input = InStr
      Loc = Index(Input, Char(0))
      If (Loc .gt. 0) Input(Loc:) = ''
#ifdef _DEBUGPRINT_
      Write(6,*) 'Translating ', Trim(Input)
#endif
      Inquire(File=Input,Exist=Found)
      If (Found) Then
#ifdef _DEBUGPRINT_
        Write(6,*) 'File ', Trim(Input), ' exists'
#endif
        OutStr = Input
      Else
        WD = WorkDir
        If (Trim(WD) .eq. '') WD = '.'
        Num = FindFile(Input, FileTable)
        If (Num .gt. 0) Then
#ifdef _DEBUGPRINT_
          Write(6,*) 'File ', Trim(Input), ' found in table: ',
     &               Trim(FileTable(Num)%Filename)
#endif
!         the value of $WorkDir will depend on some attributes,
!         pass it to the ExpandVars function
          Attr = FileTable(Num)%Attributes
          If (Index(Attr, 'f') .gt. 0) WD = FastDir
#ifdef MOLCAS_LUSTRE
          Lustre = (Index(Attr, 'l') .gt. 0)
#endif
          If ((Par .eq. 1) .and. (.not. Lustre)) WD = Trim(WD)//SlaveDir
          OutStr = FileTable(Num)%Filename
          OutStr = ExpandVars(OutStr, Trim(WD)//SubDir)
!         add "extension" to multi files
          If (Index(Attr, '*') .gt. 0) Then
            Ext = Input(Len_Trim(FileTable(Num)%Shortname)+1:)
            OutStr = Trim(OutStr)//Ext
          Else If (Index(Attr, '.') .gt. 0) Then
            Ext = Input(Len_Trim(FileTable(Num)%Shortname)+1:)
            Loc = Index(OutStr, '.', Back=.True.)
            OutStr = ReplaceSubstr(OutStr, Loc, Loc, Trim(Ext)//'.')
          End If
        Else
#ifdef _DEBUGPRINT_
          Write(6,*) 'Assuming $WorkDir/'//Trim(Input)
#endif
          If ((Par .eq. 1)) WD = Trim(WD)//SlaveDir
          OutStr = ExpandVars('$WorkDir/'//Input, Trim(WD)//SubDir)
        End If
      End If
      l2 = Len_Trim(OutStr)
#ifdef _DEBUGPRINT_
      Write(6,*) 'Output: ', Trim(OutStr)
#endif
      Return
!     Avoid unused argument warnings
      If (.False.) Call Unused_integer(l1)
      End Subroutine PrgmTranslate_Mod

      Subroutine SetSubDir(Dir)
      Character (Len=*), Intent(In) :: Dir
      SubDir = Trim(Dir)
      EndSubroutine SetSubDir

#ifndef _GA_
      Function IsInMem(Filename)
      Character (Len=*), Intent(In) :: Filename
      Integer :: IsInMem
!     since FiM is not in OpenMolcas, always return 0
      IsInMem = 0
!     Avoid unused argument warnings
      If (.False.) Call Unused_character(Filename)
      End Function IsInMem
#endif

! Private procedures follow

! Subroutine to read the contents of a .prgm file and append them to FileTable
      Subroutine ReadPrgmFile(ModName)
      Character (Len=*), Intent(In) :: ModName
      Character (Len=MAXSTR) :: Dir, Line
      Character (Len=2*MAXSTR) :: FileName
      Logical :: Found
      Integer :: Lu, Error, Num, i, j, k
      Integer, External :: isFreeUnit
      Type(FileEntry), Dimension(:), Allocatable :: TempTable, NewTable

      If (.Not. Allocated(FileTable)) Allocate(FileTable(0))

#ifdef _DEBUGPRINT_
      Write(6,*) 'ModName: '//Trim(ModName)
#endif

!     ! If other locations are enabled, pymolcas should be changed too
!     ! Or this should be revamped so that pymolcas writes a pre-parsed file
      Call GetEnvF('MOLCAS', Dir)
      Dir = Trim(Dir)//'/data'
      FileName = Trim(Dir)//'/'//Trim(ModName)//'.prgm'
      Inquire(File=FileName,Exist=Found)
      If (Found) Then
#ifdef _DEBUGPRINT_
        Write(6,*) 'FileName: '//Trim(FileName)
#endif
        Lu = isFreeUnit(30)
        Call molcas_open(Lu, Trim(FileName))
        Num = 0
        Do
          Read(Lu,*,IOStat=Error)
          If (Error .ne. 0) Exit
          Num = Num+1
        End Do
        Allocate(TempTable(Num))
        Rewind(Lu)
        Num = 0
        Do
          Read(Lu,'(A)',IOStat=Error) Line
          If (Error .ne. 0) Exit
          Line = AdjustL(Line)
          If (Line(1:1) .eq. '#') Cycle
          If (Index(Line, '(prgm)') .ne. 0) Cycle
          If (Index(Line, '(file)') .eq. 0) Cycle
          Num = Num+1
!         Strip quotes and tabs
          Line = Strip(Line, '"'//Char(9))
          Line = AdjustL(Line(Index(Line,' '):))
          TempTable(Num)%Shortname = Line(:Index(Line,' '))
          Line = AdjustL(Line(Index(Line,' '):))
          TempTable(Num)%Filename = Line(:Index(Line,' '))
          Line = AdjustL(Line(Index(Line,' '):))
          TempTable(Num)%Attributes = Line(:Index(Line,' '))
        End Do
!       Make sure leftover entries are blanked
        Do i=Num+1,Size(TempTable)
          TempTable(i)%Shortname = ''
        End Do
!       Count new unique entries
        j = 0
        Do i=1,Num
          If (FindFile(TempTable(i)%Shortname,
     &                 FileTable, Exact=.True.) .gt. 0) Cycle
          If (FindFile(TempTable(i)%Shortname,
     &                 TempTable(1:i-1), Exact=.True.) .gt. 0) Cycle
          j = j+1
        End Do
        Num = j
!       Merge and update FileTable
        Allocate(NewTable(Size(FileTable)+Num))
        NewTable(1:Size(FileTable)) = FileTable
        k = Size(FileTable)
        Do i=1,Size(TempTable)
          If (TempTable(i)%Shortname .eq. '') Exit
          Num = k+1
          j = FindFile(TempTable(i)%Shortname,
     &                 NewTable(1:k), Exact=.True.)
          If (j .gt. 0) Num=j
          NewTable(Num) = TempTable(i)
          k = Max(k, Num)
        End Do
        Deallocate(FileTable)
        Call Move_Alloc(NewTable, FileTable)
        Deallocate(TempTable)
        Close(Lu)
      End If
#ifdef _DEBUGPRINT_
      Call ReportPrgm()
#endif
      Return
!     Avoid unused argument warnings
      If (.False.) Call ReportPrgm()
      End Subroutine ReadPrgmFile

! Subroutine to print the contents of FileTable
      Subroutine ReportPrgm()
      Character (Len=MAXSTR) :: FmtStr
      Integer, Dimension(2) :: MaxLen
      Integer :: i
      MaxLen = 0
      Do i=1,Size(FileTable)
        MaxLen(1) = Max(MaxLen(1), Len_Trim(FileTable(i)%Shortname))
        MaxLen(2) = Max(MaxLen(2), Len_Trim(FileTable(i)%Filename))
      End Do
      Write(FmtStr,*) '(A',MaxLen(1),',1X,A',MaxLen(2),',1X,"<",A,">")'
      Write(6,*) '===================================='
      Write(6,*) 'Number of entries: ', Size(FileTable)
      Do i=1,Size(FileTable)
      Write(6,FmtStr) FileTable(i)%Shortname, FileTable(i)%Filename,
     &                Trim(FileTable(i)%Attributes)
      End Do
      Write(6,*) '===================================='
      End Subroutine ReportPrgm

! Function to strip all the characters in Chars from String (in any position)
      Function Strip(String, Chars)
      Character (Len=*), Intent(In) :: String
      Character (Len=*), Intent(In) :: Chars
#ifdef ALLOC_ASSIGN
      Character (Len=:), Allocatable :: Strip
#else
      Character (Len=Len(String)) :: Strip
#endif
      Character (Len=Len(String)) :: Tmp
      Integer :: i, j
      j=0
      Do i=1,Len_Trim(String)
        If (Index(Chars, String(i:i)) .ne. 0) Cycle
        j = j+1
        Tmp(j:j) = String(i:i)
      End Do
      Strip = Trim(Tmp(1:j))
      End Function Strip

! Function to find a file, given its Shortname, in a file table
! Returns the index in the table (or 0 if not found)
      Function FindFile(Short, Table, Exact)
      Character (Len=*), Intent(In) :: Short
      Type(FileEntry), Dimension(:), Intent(In) :: Table
      Logical, Optional, Intent(In) :: Exact
      Logical :: FindExact
      Integer :: FindFile, i
      FindFile=0
      If (Present(Exact)) Then
        FindExact = Exact
      Else
        FindExact = .False.
      End If
      Do i=1,Size(Table)
!       an entry matches not only if it's equal, also if
!       the beginning matches and it is a "multi" file
        If (FindExact) Then
          If (Trim(Short) .eq. Trim(Table(i)%Shortname)) Then
            FindFile=i
            Exit
          End If
        Else
          If (Index(Short, Trim(Table(i)%Shortname)) .eq. 1) Then
            If ((Trim(Short) .eq. Trim(Table(i)%Shortname)) .or.
     &          (Index(Table(i)%Attributes, '*') .gt. 0) .or.
     &          (Index(Table(i)%Attributes, '.') .gt. 0)) Then
              FindFile=i
              Exit
            End If
          End If
        End If
      End Do
      End Function

! Function to replace environment variables in a string
! A variable starts with '$' and ends with [ $/.] or the end of the string
      Function ExpandVars(String, WD)
      Character (Len=*), Intent(In) :: String, WD
#ifdef ALLOC_ASSIGN
      Character (Len=:), Allocatable :: ExpandVars
#define LEV Len(ExpandVars)
#else
      Character (Len=MAXSTR) :: ExpandVars
#define LEV Len_Trim(ExpandVars)
#endif
      Character (Len=MAXSTR) :: Var, Val
      Integer :: i, j, Ini, Fin
!     start with a copy of the string, this copy will be modified on the fly
      ExpandVars = String
      Ini = 0
      i = 0
!     scan the string, not using a fixed loop because the length and index
!     will change as replacements are done
      Do
        i = i+1
        If (i .gt. LEV) Exit
!       the $ marks the start of the variable, find the end
!       (by default the end of the string)
        If (ExpandVars(i:i) .eq. '$') Then
          Ini = i
          Fin = LEV
          Do j = i+1, LEV
            If (Index(' $/.', ExpandVars(j:j)) .ne. 0) Then
              Fin = j-1
              Exit
            End If
          End Do
!         get the value of the variable and replace it in the string
          Var = ExpandVars(Ini+1:Fin)
          Select Case (Var)
            Case ('Project')
              Val = Project
            Case ('WorkDir')
              Val = WD
            Case Default
              Call GetEnvF(Var, Val)
              If (Trim(Val) .eq. '') Then
                If (Var .ne. 'SubProject') Val = 'UNK_VAR'
              End If
          End Select
          ExpandVars = ReplaceSubstr(ExpandVars, Ini, Fin, Trim(Val))
!         update the index to continue
          i = Ini + Len_Trim(Val) - 1
        End If
      End Do
      End Function ExpandVars

! Function to replace a substring (between the Ini and Fin positions) with Repl
      Function ReplaceSubstr(String,Ini,Fin,Repl)
      Character (Len=*), Intent(In) :: String, Repl
      Integer, Intent(In) :: Ini,Fin
#ifdef ALLOC_ASSIGN
      Character (Len=:), Allocatable :: ReplaceSubstr
#else
      Character (Len=MAXSTR) :: ReplaceSubstr
#endif
      Integer :: i,j
!     make sure the indices are within limits
      i = Min(Max(1,Ini),Len(String))
      j = Min(Max(1,Fin),Len(String))
      j = Max(i,j)
      ReplaceSubstr = Trim(String(:i-1) // Repl // String(j+1:))
      End Function ReplaceSubstr

! Save some often used variables as module variables, for faster access
      Subroutine PrgmCache
      Integer, External :: mpp_id
      Call GetEnvF('WorkDir', WorkDir)
      Call GetEnvF('FastDir', FastDir)
      Call GetEnvF('Project', Project)
      If (Trim(Project) .eq. '') Project = 'Noname'
      If (mpp_id() .gt. 0) Write(SlaveDir,'(A,I0)') '/tmp_', mpp_id()
      End Subroutine

      End Module prgm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine AI(JTYP,ITAI,L0,L1,L2,L3)

use guga_global, only: COUP, IADD10, ICOUP, ICOUP1, ICH, IJ, IOUT, IRC, IWAY, IX, J1, J2, JNDX, JRC, LN, Lu_10, MXVERT, NBUF, NMAT
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JTYP, L0(*), L1(*), L2(*), L3(*)
integer(kind=iwp), intent(_OUT_) :: ITAI(*)
integer(kind=iwp) :: I, ICP1, ICP2, II, IID, IJJ, IJM, IJS, IN_, IN2, IND, ISTOP, IT1, IT2, ITAIL, ITT1, ITT2, ITURN, ITYP, JJ, &
                     JJD, JMAX, JND1, JND2, JOUT, KM, NI
real(kind=wp) :: CHKSUM
logical(kind=iwp) :: first

IOUT = 0
NMAT = 0
JMAX = 0
do NI=1,LN
  IOUT = IOUT+1
  ICOP1(IOUT) = 0
  JOUT = 0
  if (IOUT >= NBUF) then
    ICOP1(NCOP+1) = NBUF
    call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
    call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
    NMAT = NMAT+NBUF
    IOUT = 0
  end if
  I = ICH(NI)
  IOUT = IOUT+1
  ICOP1(IOUT) = I
  if (IOUT >= NBUF) then
    ICOP1(NCOP+1) = NBUF
    call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
    call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
    NMAT = NMAT+NBUF
    IOUT = 0
  end if
  IJS = IJ(I+1)+1
  IJM = IJ(I)
  if (JTYP == 1) then
    ITURN = 2
    ITT1 = 2
    ITT2 = 1
  else
    ! DOUBLET-VALENCE INTERACTIONS
    ITURN = 1
    ITT1 = 1
    ITT2 = 0
  end if
  do
    IT1 = ITT1*MXVERT
    IT2 = ITT2*MXVERT
    if (ITT1 == 0) then
      JJ = 0
      JJD = 0
    else
      JJ = IRC(ITT1)
      JJD = JRC(ITT1)
    end if
    if (ITT2 == 0) then
      II = 0
      IID = 0
    else
      II = IRC(ITT2)
      IID = JRC(ITT2)
    end if
    ITYP = ITURN
    do IJJ=IJS,IJM
      ITAIL = IX(IT2+IJJ)
      call TAIL(I,IJJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
      IWAY(I) = 1
      do
        KM = I
        J2(KM+1) = IJJ
        J1(KM+1) = IJJ
        call LOOP1(KM,ISTOP,IT1,IT2)
        if (ISTOP == 1) exit
        first = .true.
        do
          if (first) then
            KM = KM-1
            if (KM /= 0) IWAY(KM) = 1
            first = .false.
          end if
          if (KM /= 0) then
            call LOOP5(KM,ISTOP,IT1,IT2)
            if (ISTOP == 0) then
              first = .true.
              cycle
            end if
            KM = KM+1
            if (KM == I) exit
          else
            do IN_=1,ITAIL
              ICP1 = ICOUP(1)+IN_
              JND1 = JNDX(II+ICP1)
              if (JND1 == 0) cycle
              ICP1 = JND1-IID
              IN2 = ITAI(IN_)
              if (IN2 == 0) cycle
              ICP2 = ICOUP1(1)+IN2
              JND2 = JNDX(JJ+ICP2)
              if (JND2 == 0) cycle
              ICP2 = JND2-JJD
              IOUT = IOUT+1
              JOUT = JOUT+1
              if (JOUT > JMAX) JMAX = JOUT
              COP(IOUT) = COUP(1)
              !PAM96 IND = ior(ITYP,ishft(ICP2,6))
              !IND=ITYP+2**6*ICP2
              IND = ior(ITYP,ishft(ICP2,6))
              !PAM96 ICOP1(IOUT) = ior(IND,ishft(ICP1,19))
              !ICOP1(IOUT)=IND+2**19*ICP1
              ICOP1(IOUT) = ior(IND,ishft(ICP1,19))
              if (IOUT < NBUF) cycle
              ICOP1(NCOP+1) = NBUF
              call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
              call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
              NMAT = NMAT+NBUF
              IOUT = 0
            end do
            KM = KM+1
            if (KM == I) exit
          end if
        end do
      end do
    end do
    select case (ITURN)
      case default !(1)
        ! TRIPLET-DOUBLET INTERACTIONS
        ITURN = 2
        ITT1 = 2
        ITT2 = 1
      case (2)
        ! SINGLET-DOUBLET INTERACTIONS
        ITURN = 3
        ITT1 = 3
        ITT2 = 1
      case (3)
        exit
    end select
  end do
end do
ICOP1(NCOP+1) = IOUT
call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
NMAT = NMAT+IOUT
ICOP1(NCOP+1) = -1
call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
CHKSUM = Zero
do I=1,NCOP
  CHKSUM = CHKSUM+COP(I)
end do
call ADD_INFO('GUGA_CHKSUM',[CHKSUM],1,8)
if (JTYP == 0) write(u6,600) NMAT
if (JTYP == 0) then
  return
end if
write(u6,601) NMAT
IAD10(1) = JMAX
write(u6,602) JMAX

return

600 format(/,6X,'COEFFICIENTS FOR AI',I11)
601 format(/,6X,'COEFFICIENTS FOR ABCI',I9)
602 format(6X,'MAXIMUM NUMBER OF ELEMENTS',I6)

end subroutine AI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DFP(B,nDim,Bd,Delta,rGamma)

use Constants, only: Zero, One
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(inout) :: B(nDim,nDim)
real(kind=wp), intent(out) :: Bd(nDim)
real(kind=wp), intent(in) :: Delta(nDim), rGamma(nDim)
integer(kind=iwp) :: i
real(kind=wp) :: dBd, gd
real(kind=wp), parameter :: Thr = 1.0e-8_wp
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('DFP: B',' ',B,nDim,nDim)
!call RecPrt('DFP: Bd',' ',Bd,1,nDim)
call RecPrt('DFP: Gamma',' ',rGamma,1,nDim)
call RecPrt('DFP: Delta',' ',Delta,1,nDim)
#endif
call DGEMM_('N','N',nDim,1,nDim,One,B,nDim,Delta,nDim,Zero,Bd,nDim)
gd = DDot_(nDim,rGamma,1,Delta,1)
dBd = DDot_(nDim,Delta,1,Bd,1)
#ifdef _DEBUGPRINT_
call RecPrt('DFP: Bd',' ',Bd,1,nDim)
write(u6,*) 'gd=',gd
write(u6,*) 'dBd=',dBd
write(u6,*) 'Thr=',Thr
#endif
if (gd < Zero) then
  call MSP(B,rGamma,Delta,nDim)
else
  do i=1,nDim
    B(:,i) = B(:,i)+(rGamma(:)*rGamma(i))/gd-(Bd(:)*Bd(i))/dBd
  end do
end if

#ifdef _DEBUGPRINT_
call RecPrt('DFP: B',' ',B,nDim,nDim)
#endif

return

end subroutine DFP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Tra2B(iSym,jSym,iBas,jBas,iAsh,jAsh,iOrb,jOrb,ikl,nkl,CMO_ip,CMO_jp,CMO_ia,CMO_ja,VXIJ,X2,X3_ip,X3_jp,PUVX_jp,PUVX_ip)
!***********************************************************************
!                                                                      *
!     run the second half of the AO --> MO transformation with         *
!     one active and one general index, i.e.                           *
!     (vx!ij) --> (vx!up)                                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSym, jSym, iBas, jBas, iAsh, jAsh, iOrb, jOrb, ikl, nkl
real(kind=wp), intent(in) :: CMO_ip(iBas*iOrb), CMO_jp(jBas*jOrb), CMO_ia(iBas*iAsh), CMO_ja(jBas*jAsh), VXIJ(*)
real(kind=wp), intent(out) :: X2(*), X3_ip(iAsh,jOrb), X3_jp(jAsh,iOrb)
real(kind=wp), intent(inout) :: PUVX_jp(iOrb,jAsh,nkl), PUVX_ip(jOrb,iAsh,nkl)
integer(kind=iwp) :: i, j

if (jAsh*iOrb /= 0) then
  call DGEMM_('T','N',iBas,jAsh,jBas,One,VXIJ,jBas,CMO_ja,jBas,Zero,X2,iBas)

  call DGEMM_('T','N',jAsh,iOrb,iBas,One,X2,iBas,CMO_ip,iBas,Zero,X3_jp,jAsh)

  do i=1,jAsh
    do j=1,iOrb
      PUVX_jp(j,i,ikl) = X3_jp(i,j)
    end do
  end do
end if

if ((iSym /= jSym) .and. (iAsh*jOrb /= 0)) then
  call DGEMM_('N','N',jBas,iAsh,iBas,One,VXIJ,jBas,CMO_ia,iBas,Zero,X2,jBas)

  call DGEMM_('T','N',iAsh,jOrb,jBas,One,X2,jBas,CMO_jp,jBas,Zero,X3_ip,iAsh)

  do i=1,iAsh
    do j=1,jOrb
      PUVX_ip(j,i,ikl) = X3_ip(i,j)
    end do
  end do
end if

return

end subroutine Tra2B

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Stefano Battaglia                                *
************************************************************************
      subroutine rdminit()

      use definitions, only: iwp, wp
      use constants, only: Zero, One
      use caspt2_global, only:iPrGlb
      use caspt2_global, only: CMO, CMO_Internal, DREF, DMIX, DWGT, NCMO
      use caspt2_global, only: LUONEM
      use PrintLevel, only: DEBUG
      use stdalloc, only: mma_allocate, mma_deallocate
#ifdef _DMRG_
      use qcmaquis_interface, only:qcmaquis_interface_set_state
      use iso_c_binding, only: c_int
      use caspt2_module, only: DMRG, mState
#endif
      use caspt2_module, only: ISCF, nConf, nState, iAd1m
      implicit None


      real(kind=wp), ALLOCATABLE:: CI(:)
      integer(kind=iwp) iDisk, I, J
      real(kind=wp) Wij

      if (IPRGLB>=DEBUG) then
        write(6,*)' Entered rdminit.'
      end if

* Get CASSCF MO coefficients
      call mma_allocate(CMO_Internal,NCMO,Label='CMO_Internal')
      CMO=>CMO_Internal
      IDISK=IAD1M(1)
      call ddafile(LUONEM,2,CMO,NCMO,IDISK)

* Allocate memory for CI vector
      call mma_allocate(CI,Nconf,Label='CI')

* Initialize array of 1-RDMs with zeros
      DMIX(:,:)=Zero

* Start long loop over all states and compute the weighted density
* of each state using the weights in DWGT
      do I=1,Nstate

        if (ISCF/=0) then
* Then we still need the "CI array": It is used in subroutine calls
          CI(1)=One
        else
* Get the CI array
          call loadCI(CI,I)
        end if

        ! compute 1-particle active density matrix GAMMA1
#ifdef _DMRG_
        if (DMRG) then
          ! set state number here because in poly1 we have no reference
          ! to which state we are computing
          if (iPrGlb >= DEBUG) then
            write (6,*) 'STINI setting DMRG state number to ',
     &                   mstate(i)-1
          endif
          ! Convert to the root number despite having
          ! set only the checkpoint file paths for the desired state(s)
          call qcmaquis_interface_set_state(int(mstate(i)-1,c_int))
        end if
#endif


* Compute 1-particle active density matrix GAMMA1
        call POLY1(CI,nConf)
* Restructure GAMMA1 as DREF array, but keep it in DMIX
        call GETDREF(DREF,SIZE(DREF))

* Loop over states to compute the contribution of state I to states J
        do J=1,Nstate
* Retrieve the weight of the contribution of state I to the density
* of state J
          wij = DWGT(I,J)
* Multiply density of state I with weight wij and add it to whatever
* is already in DMIX (contributions of other states already computed)
* and store it in DMIX
          call daxpy_(SIZE(DREF),wij,DREF,1,DMIX(:,J),1)
        end do

* End of long loop over states
      end do

* Deallocate everything
      call mma_deallocate(CMO_Internal)
      nullify(CMO)
      call mma_deallocate(CI)

      end subroutine rdminit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine DCore(OneHam,nOH,CMO,TrMat,nCMO,EOr,nEOr,mynOcc,Ovrlp)
************************************************************************
*                                                                      *
*     purpose: Diagonalize core hamiltonian to get starting orbitals.  *
*                                                                      *
*     input:                                                           *
*       OneHam  : one-electron hamiltonian of length nOH               *
*       TrMat   : matrix transforming to orthonotmal basis of          *
*                 length nCMO                                          *
*                                                                      *
*     output:                                                          *
*       CMO     : starting vectors of length nCMO                      *
*                                                                      *
*     called from: Start1                                              *
*                                                                      *
*     calls to: ModFck, PickUp, Sort                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 OneHam(nOH),CMO(nCMO),TrMat(nCMO),EOr(nEOr), Ovrlp(nOH)
      Integer mynOcc(*)
*
      Real*8, Dimension(:), Allocatable:: OMod, OHSq, OHHl, OHTr, EiVe,
     &                                    Scratch
      Integer, Dimension(:), Allocatable:: Fermi
      Data iseed/13/
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*---- Allocate memory for modified one-electron hamoltonian
      Call mma_allocate(OMod,nBT,Label='OMod')
*
*---- Allocate memory for squared one-el. Hamiltonian
      Call mma_allocate(OHSq,MaxBas**2,Label='OHSq')
*
*---- Allocate memory for half-transformed one-el. Hamiltonian
      Call mma_allocate(OHHl,MaxBOF,Label='OHHl')
*
*---- Allocate memory for transformed one-electron Hamiltonian
      Call mma_allocate(OHTr,MaxOrF*(MaxOrF+1)/2,Label='OHTr')
*
*---- Allocate memory for eigenvectors
      Call mma_allocate(EiVe,MaxOrF**2,Label='EiVe')
*
*---- Allocate memory for info on electronic and muonic basis sets
      Call mma_allocate(Fermi,nEOr,Label='Fermi')
      Call Get_iArray('Fermion IDs',Fermi,nEOr)
*
*
*
*---- Modify one-electron hamiltonian
      call dcopy_(nBT,OneHam,1,OMod,1)
      If (nnFr.gt.0)
     &   Call ModFck(OMod,Ovrlp,nBT,TrMat,nBO,mynOcc)
*
*---- Diagonalize core in non-frozen molecular basis
      ij   = 1
      iCMO = 1
      iEOr = 1
      Do iSym = 1, nSym
*
         iiBT = nBas(iSym)*(nBas(iSym) + 1)/2
         nOF  = nOrb(iSym) - nFro(iSym)
*
*------- Copy frozen vectors to CMO array
         if(nFro(iSym)*nBas(iSym).gt.0) then
          call dcopy_(nFro(iSym)*nBas(iSym),TrMat(iCMO),1,CMO(iCMO),1)
         endif
*
         iCMO = iCMO + nBas(iSym)*nFro(iSym)
         iEOr = iEOr + nFro(iSym)
*
         If (nOF.gt.0) Then
*
*---------- Square one-el. Ham. and transform to orthonormal basis.
*           Call Square(OMod(ij),nBas(iSym),OHSq,nBas(iSym))
            Call Square(OMod(ij),OHSq,1,nBas(iSym),nBas(iSym))
            Call DGEMM_('N','N',
     &                  nBas(iSym),nOF,nBas(iSym),
     &                  1.0d0,OHSq,nBas(iSym),
     &                        TrMat(iCMO),nBas(iSym),
     &                  0.0d0,OHHl,nBas(iSym))
            Call DGEMM_Tri('T','N',nOF,nOF,nBas(iSym),
     &                     1.0D0,TrMat(iCMO),nBas(iSym),
     &                           OHHl,nBas(iSym),
     &                     0.0D0,OHTr,nOF)
*
*---------- Put a unit matrix into the eigenvector matrix
            call dcopy_(nOF*nOF,[Zero],0,EiVe,      1)
            call dcopy_(nOF,    [One], 0,EiVe,nOF + 1)
*
*---------- Add small random number to the one-electron Hamiltonian
*           Not done here anymore, done in routine scram called
*           by sorb!
*
            If (Scrmbl .and. .false.) Then
c               iseed = 13
               ind   = 1
               Do i = 1, nOF
                  Do j = 1, i - 1
                     OHTr(ind) =
     &               OHTr(ind) + 0.050d+00*Random_Molcas(iseed)
                     ind = ind + 1
                  End Do
                  ind = ind + 1
               End Do
            End If
*
*---------- Diagonalize and form orbital energies
            Call mma_allocate(Scratch,nOF**2,Label='Scratch')
            Dummy=0.0D0
            iDum=0
            Call Diag_Driver('V','A','L',nOF,OHTr,
     &                       Scratch,nOF,Dummy,Dummy,iDum,iDum,
     &                       EOr(iEOr),EiVe,nOF,1,-1,'J',nFound,
     &                       iErr)
            Call mma_deallocate(Scratch)
*
*---------- Transform to AO basis
            Call DGEMM_('N','N',
     &                  nBas(iSym),nOF,nOF,
     &                  1.0d0,TrMat(iCMO),nBas(iSym),
     &                        EiVe,nOF,
     &                  0.0d0,CMO(iCMO),nBas(iSym))
*
         End If
*
*------- Update pointers
         iCMO = iCMO + nOF*nBas(iSym)
         iEOr = iEOr + nOF
         ij   = ij   + iiBT
*
      End Do
*
*---- Deallocate memory
      Call mma_deallocate(Fermi)
      Call mma_deallocate(EiVe)
      Call mma_deallocate(OHTr)
      Call mma_deallocate(OHHl)
      Call mma_deallocate(OHSq)
      Call mma_deallocate(OMod)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DERFG3(IFF,NCONF,NLEV,NG3,CI,CLAG,DG1,DG2,DG3,DF1,DF2,DF3,DEPSA,G1,G2)

use Index_Functions, only: nTri_Elem
use PrintLevel, only: DEBUG, VERBOSE
use Symmetry_Info, only: Mul
use sguga, only: CIS, EXS, L2ACT, SGS
use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
use caspt2_global, only: iPrGlb, nbuf1_grad
use caspt2_module, only: EPSA, MxCI, nActEl, nSym, STSym
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, King
use caspt2_global, only: iTasks_grad, nTasks_grad
#endif
use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: IFF, nCONF, NLEV, NG3
real(kind=wp), intent(in) :: CI(nCONF), DG3(NG3), DF3(NG3), G1(NLEV,NLEV), G2(NLEV,NLEV,NLEV,NLEV)
real(kind=wp), intent(inout) :: CLAG(NCONF), DG1(NLEV,NLEV), DG2(NLEV,NLEV,NLEV,NLEV), DF1(NLEV,NLEV), DF2(NLEV,NLEV,NLEV,NLEV), &
                                DEPSA(NLEV,NLEV)
integer(kind=iwp) :: I, IB, IBMN, IBMX, IBUF, IBUF1, ID, IDX, IG3, IG3BK, IG3OFF, IOFFSET, IP1, IP1END, IP1I, IP1MN, IP1MX, &
                     IP1STA, IP2, IP3, IP3MX, IQ1, ISP1, ISSG1, ISSG2, ISTU, ISUBTASK, ISVX, ISYZ, IT, ITASK, iTask_loc, ITLEV, &
                     IU, IULEV, IV, IVLEV, IXLEV, IXLEV0, IY, IYLEV, IZ, IZLEV, J, JDX, MEMMAX, MXTASK, MYBUFFER, MYTASK, NB, &
                     NBTOT, NBUF1, NBUFX, NDAB, NDTU, NLEV2, nMidV, NSGM1, NSGM2, NSUBTASKS, NTASKS, NTRI1, NTRI2
real(kind=wp) :: SCAL, ScalF, ScalG
logical(kind=iwp) :: first
integer(kind=iwp), allocatable :: ICNJ(:), IDX2IJ(:,:), IJ2IDX(:,:), IP1_BUF(:), TASKLIST(:,:)
real(kind=wp), allocatable :: BUF1(:,:), BUF2(:), BUF3(:), BUF4(:), BUFD(:), BUFT(:), BUFX(:,:), DAB(:,:), DTU(:,:), DYZ(:)

! IJ2IDX, IDX2IJ: translation tables for levels i,j to and from pair indices idx

nMidV = CIS%nMidV

! Put in zeroes. Recognize special cases:
if (nlev == 0) return
if (NACTEL == 0) return

! This should not happen, but...
if (NCONF == 0) return

! Here, for regular CAS or RAS cases.

! Special pair index idx2ij allows true RAS cases to be handled:
nlev2 = nlev**2
ntri1 = nTri_Elem(nlev-1)
ntri2 = nTri_Elem(nlev)
call mma_allocate(idx2ij,2,nlev2,Label='idx2ij')
call mma_allocate(ij2idx,nlev,nlev,Label='ij2idx')
idx = 0
do i=1,nlev-1
  do j=i+1,nlev
    idx = idx+1
    ij2idx(i,j) = idx
    idx2ij(1,idx) = i
    idx2ij(2,idx) = j
    jdx = nlev2+1-idx
    ij2idx(j,i) = jdx
    idx2ij(1,jdx) = j
    idx2ij(2,jdx) = i
  end do
end do
do i=1,nlev
  idx = ntri1+i
  ij2idx(i,i) = idx
  idx2ij(1,idx) = i
  idx2ij(2,idx) = i
end do
call mma_allocate(icnj,nlev2,Label='icnj')
do idx=1,nlev2
  i = idx2ij(1,idx)
  j = idx2ij(2,idx)
  jdx = ij2idx(j,i)
  icnj(idx) = jdx
end do
call mma_deallocate(ij2idx)

! Correction to G3: It is now <0| E_tu E_vx E_yz |0>
! Similar for F3 values.
! These corrections are already done in CLagDXA_FG3 and CLagDXC_FG3

! Correction to F2: Some values not computed follow from symmetry
if (IFF == 1) then
  do ip1=1,nlev2-1
    itlev = idx2ij(1,ip1)
    iulev = idx2ij(2,ip1)
    it = L2ACT(itlev)
    iu = L2ACT(iulev)
    do ip3=ip1+1,nlev2
      iylev = idx2ij(1,ip3)
      izlev = idx2ij(2,ip3)
      iy = L2ACT(iylev)
      iz = L2ACT(izlev)
      SCAL = DF2(iy,iz,it,iu)+DF2(it,iu,iy,iz)
      DF2(it,iu,iy,iz) = Zero
      DF2(iy,iz,it,iu) = Scal
    end do
  end do
  !-SVC20100310: took some spurious mirroring of F2 values out
  !-of the loops and put them here, after the parallel section has
  !-finished, so that GAdGOP works correctly.
  do ip1=ntri2+1,nlev2
    itlev = idx2ij(1,ip1)
    iulev = idx2ij(2,ip1)
    it = L2ACT(itlev)
    iu = L2ACT(iulev)
    do ip3=ntri1+1,ip1
      iylev = idx2ij(1,ip3)
      izlev = idx2ij(2,ip3)
      iy = L2ACT(iylev)
      iz = L2ACT(izlev)
      Scal = DF2(iz,iy,iu,it)+DF2(it,iu,iy,iz)
      DF2(it,iu,iy,iz) = Zero
      DF2(iz,iy,iu,it) = Scal
    end do
  end do
  ! Correction to F2: It is now = <0| E_tu H0Diag E_yz |0>
  do iz=1,nlev
    do iy=1,nlev
      do iu=1,nlev
        do it=1,nlev
          DG2(it,iu,iy,iz) = DG2(it,iu,iy,iz)-DF2(it,iu,iy,iz)*(EPSA(iu)+EPSA(iy))
          !! DEPSA-related operations in the preparation step
          !! are done only on the master node
#         ifdef _MOLCAS_MPP_
          if (king()) then
#         endif
            DEPSA(iu,:) = DEPSA(iu,:)-DF2(it,iu,iy,iz)*G2(it,:,iy,iz)
            DEPSA(:,iy) = DEPSA(:,iy)-DF2(it,iu,iy,iz)*G2(it,iu,:,iz)
#         ifdef _MOLCAS_MPP_
          end if
#         endif
        end do
      end do
    end do
  end do
  do iz=1,nlev
    do iu=1,nlev
      do it=1,nlev
        DG1(it,iz) = DG1(it,iz)-EPSA(iu)*DF2(it,iu,iu,iz)
        DF1(it,iz) = DF1(it,iz)-DF2(it,iu,iu,iz)
#       ifdef _MOLCAS_MPP_
        if (king()) then
#       endif
          DEPSA(iu,:) = DEPSA(iu,:)-G1(it,iz)*DF2(it,iu,:,iz)
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      end do
    end do
  end do
end if

! Correction to G2: Some values not computed follow from symmetry
do ip1=1,nlev2-1
  itlev = idx2ij(1,ip1)
  iulev = idx2ij(2,ip1)
  it = L2ACT(itlev)
  iu = L2ACT(iulev)
  do ip3=ip1+1,nlev2
    iylev = idx2ij(1,ip3)
    izlev = idx2ij(2,ip3)
    iy = L2ACT(iylev)
    iz = L2ACT(izlev)
    SCAL = DG2(iy,iz,it,iu)+DG2(it,iu,iy,iz)
    DG2(it,iu,iy,iz) = Zero
    DG2(iy,iz,it,iu) = Scal
  end do
end do
!-SVC20100310: took some spurious mirroring of G2 values out
!-of the loops and put them here, after the parallel section has
!-finished, so that GAdSUM works correctly.
do ip1=ntri2+1,nlev2
  itlev = idx2ij(1,ip1)
  iulev = idx2ij(2,ip1)
  it = L2ACT(itlev)
  iu = L2ACT(iulev)
  do ip3=ntri1+1,ip1
    iylev = idx2ij(1,ip3)
    izlev = idx2ij(2,ip3)
    iy = L2ACT(iylev)
    iz = L2ACT(izlev)
    Scal = DG2(iz,iy,iu,it)+DG2(it,iu,iy,iz)
    DG2(it,iu,iy,iz) = Zero
    DG2(iz,iy,iu,it) = Scal
  end do
end do
! Correction to G2: It is now = <0| E_tu E_yz |0>
do iu=1,nlev
  DG1(:,:) = DG1(:,:)-DG2(:,iu,iu,:)
end do
if (IFF == 1) then
  ! Additional correction terms for F1
  do iU=1,NLEV
    !! With the improved algorithm, symmetrizing the DF1
    !! contribution to DF1 here is somehow required
    DG1(:,iU) = DG1(:,iU)-(DF1(:,iU)+DF1(iU,:))*EPSA(iU)*Half
  end do
# ifdef _MOLCAS_MPP_
  if (king()) then
# endif
    do iT=1,NLEV
      do iU=1,NLEV
        DEPSA(:,:) = DEPSA(:,:)+G2(iT,iU,:,:)*DF1(iT,iU)
      end do
    end do
# ifdef _MOLCAS_MPP_
  end if
# endif
end if

call CLagSym(nLev,DG1,DG2,DF1,DF2,2)

call mma_MaxDBLE(memmax)

! Use *almost* all remaining memory:
!memmax_safe = int(real(memmax,kind=wp)*0.95_wp)

! Buffers to compute CI expansion vectors into:
! <Psi0|E_ip1 | E_ip2 E_ip3|Psi0>
! buf1: bra buffer with E_ip1 excitations of Psi0
!       holds multiple CI vectors (allowed by memory)
! buf2: ket buffer for an E_ip3 excitation of Psi0
! buft: ket buffer for an E_ip2 excitation of E_ip3|Psi0>
! bufd: diagonal matrix elements to compute the F matrix
nbuf1 = nbuf1_grad
ndtu = nbuf1
ndab = nbuf1
nbufx = nlev
call mma_allocate(BUF1,MXCI,NBUF1,Label='BUF1')
call mma_allocate(BUF2,MXCI,Label='BUF2')
call mma_allocate(BUFT,MXCI,Label='BUFT')
call mma_allocate(BUFD,MXCI,Label='BUFD')

call mma_allocate(DTU,MXCI,NDTU,Label='DTU')
call mma_allocate(DYZ,MXCI,Label='DYZ')
call mma_allocate(DAB,MXCI,NDAB,Label='DAB')
call mma_allocate(BUF3,MXCI,Label='BUF3')
call mma_allocate(BUF4,MXCI,Label='BUF4')

call mma_allocate(BUFX,MXCI,NBUFX,Label='BUFX')

!-SVC20100301: calculate maximum number of tasks possible
MXTASK = (NTRI2-1)/NBUF1+1+(NTRI1-1)/NBUF1+1
call mma_allocate(TaskList,mxTask,4,LABEL='TaskList')

if (iPrGlb >= VERBOSE) then
  write(u6,*)
  write(u6,'(2X,A)') 'Constructing derivatives of G3/F3'
  write(u6,'(2X,A,F16.9,A)') ' memory avail: ',real(memmax*RtoB,kind=wp)*1.0e-9_wp,' GB'
  write(u6,'(2X,A,F16.9,A)') ' memory used:  ',real(((3*nbuf1+6+nlev)*MXCI)*RtoB,kind=wp)*1.0e-9_wp,' GB'
  call xFlush(u6)
end if
!call TIMING(CPTF10,CPE,TIOTF10,TIOE)
!CPUT = CPTF10-CPTF0
!WALLT = TIOTF10-TIOTF0
!write(u6,*) 'PREP    : CPU/WALL TIME=',cput,wallt

call mma_allocate(ip1_buf,nlev2,Label='ip1_buf')

iG3OFF = 0
iTask_loc = 1
first = .true.
! A *very* long loop over the symmetry of Sgm1 = E_ut Psi as segmentation.
! This also allows precomputing the Hamiltonian (H0) diagonal elements.
do issg1=1,nsym
  isp1 = Mul(issg1,STSYM)
  nsgm1 = CIS%ncsf(issg1)
  !!BufD_I = \sum_t <I|E_{tt}|I>*f_{tt}
  if (IFF == 1) call H0DIAG_CASPT2(ISSG1,BUFD,nsgm1,CIS%NOW,CIS%IOW,nMidV)

  !-SVC20100301: calculate number of larger tasks for this symmetry, this
  !-is basically the number of buffers we fill with SG_Epq_Psi vectors.
  iTask = 1
  ibuf1 = 0
  do ip1=1,nlev2
    itlev = idx2ij(1,ip1)
    iulev = idx2ij(2,ip1)
    istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
    if (istu == isp1) then
      ibuf1 = ibuf1+1
      ip1_buf(ibuf1) = ip1
      if (ibuf1 == 1) TaskList(iTask,1) = ip1
    end if
    if ((ibuf1 == nbuf1) .or. ((ibuf1 > 0) .and. ((ip1 == ntri2) .or. (ip1 == nlev2)))) then
      TaskList(iTask,2) = ip1_buf(ibuf1)
      TaskList(iTask,3) = ibuf1
      iTask = iTask+1
      ibuf1 = 0
    end if
  end do
  nTasks = iTask
  !write(u6,*) 'nTasks = ',nTasks
  if (ibuf1 == 0) nTasks = nTasks-1
  !-SVC20100309: calculate number of inner loop iteration tasks.
  iOffSet = 0
  do iTask=1,nTasks
    TaskList(iTask,4) = iOffSet
    ip1sta = TaskList(iTask,1)
    ip1end = TaskList(iTask,2)
    ip3mx = ntri2
    if (ip1end <= ntri2) ip3mx = ip1end
    if (ip1sta > ntri2) ip3mx = ntri1
    !write(u6,*) 'iTask = ',iTask
    !write(u6,*) 'start,end=',ip1sta,ip1end
    !write(u6,*) 'ip3mx = ',ip3mx
    !-SVC20100309: Currently -we are going to limit this to the ip3-loop and
    !-leave the ip2-loop intact.  This was based on the large overhead which
    !-was observed for a very large number of small tasks.
    !iOffSet = iOffSet+ip3mx*ntri2-nTri_Elem(ip3mx-1)
    iOffSet = iOffSet+ip3mx
  end do
  nSubTasks = iOffSet
  !write(u6,*) 'nSubTasks = ',nSubTasks

  if (iPrGlb >= VERBOSE) then
    write(u6,'(2X,A,I3,A,I6)') 'Sym: ',issg1,', #Tasks: ',nSubTasks
    call xFlush(u6)
  end if

  if (iPrGlb >= DEBUG) then
    if (nSubTasks > 0) then
      write(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)') '--------','------------','----','---------'
      write(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)') 'task ID ',' ip1 range  ','ip3 ','#elements'
      write(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)') '--------','------------','----','---------'
      call xFlush(u6)
    end if
  end if

  !-SVC20100301: initialize the series of subtasks
  call Init_Tsk(ID,nSubTasks)

  myBuffer = 0

  !! loop start
  do
    !-SVC20100908: first check: can I actually do any task?
    !if (NG3-iG3OFF < nbuf1*ntri2) goto 501
    !-SVC20100831: initialize counter for offset into G3
    !-SVC20100302: BEGIN SEPARATE TASK EXECUTION
    !write(u6,*) rsv_tsk(id,isubtask)
#   ifdef _MOLCAS_MPP_
    if (is_real_par()) then
      !! do the same tasks here and in mkfg3
      iSubTask = iTasks_grad(iTask_loc)
      if (iSubTask == 0) exit
    else
#   endif
      if (.not. Rsv_Tsk(ID,iSubTask)) exit
#   ifdef _MOLCAS_MPP_
    end if
#   endif

    myTask = nTasks
    do iTask=1,nTasks
      iBuf = iSubTask-TaskList(iTask,4)
      if (iBuf <= 0) then
        myTask = iTask-1
        exit
      end if
    end do
    iTask = myTask

    iOffSet = TaskList(iTask,4)

    !-SVC20100310: one task handles a range of ip1 values
    !-that are in the buffer and one ip3 value, for which
    !-a loop over ip2 values is then executed.
    ip1sta = TaskList(iTask,1)
    ip1end = TaskList(iTask,2)
    ip3 = iSubTask-iOffSet

    !-SVC20100301: fill the buffer with sigma vectors if they
    !-have not been computed yet, else just get the number of
    !-sigma vectors in the buffer.
    !write(u6,*) 'myBuffer,iTask = ',myBuffer,iTask
    if (myBuffer /= iTask) then
      !! Compute left derivative and DEPSA contributions before
      !! the TASK is completely switched
      if (.not. first) call LEFT_DEPSA()
      ibuf1 = 0
      do ip1i=ip1sta,ip1end
        itlev = idx2ij(1,ip1i)
        iulev = idx2ij(2,ip1i)
        istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
        it = L2ACT(itlev)
        iu = L2ACT(iulev)
        if (istu == isp1) then
          ibuf1 = ibuf1+1
          ip1_buf(ibuf1) = ip1i
          BUF1(1:nsgm1,ibuf1) = Zero
          call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,One,STSYM,CI,BUF1(:,ibuf1))
        end if
      end do
      myBuffer = iTask
      DTU(1:MXCI,1:ibuf1) = Zero
      DAB(1:MXCI,1:ibuf1) = Zero
      if (first) first = .false.
    else
      ibuf1 = TaskList(iTask,3)
    end if
    !-SVC20100301: necessary batch of sigma vectors is now in the buffer

    ! The ip1 buffer could be the same on different processes
    ! so only compute the G1 contribution when ip3 is 1, as
    ! this will only be one task per buffer.
    if ((issg1 == STSYM) .and. (ip3 == 1)) then
      !! buf1 = <Psi0|E_ip1|I>
      !! <0|E_{tu}I> = <I|E_{ut}|0>
      !write(u6,*) 'ib loop'
      do ib=1,ibuf1
        idx = ip1_buf(ib)
        itlev = idx2ij(1,idx)
        iulev = idx2ij(2,idx)
        it = L2ACT(itlev)
        iu = L2ACT(iulev)
        !write(u6,'('itlev,iulev,it,iu = ',4i3)') itlev,iulev,it,iu
        !! DG1 contribution
        SCAL = DG1(iT,iU)+DG1(iT,iU)
        CLag(1:nsgm1) = CLag(1:nsgm1)+SCAL*BUF1(1:nsgm1,ib)

        if (IFF == 1) then
          !! left derivative of DF1
          DTU(1:nsgm1,ib) = DTU(1:nsgm1,ib)+DF1(it,iu)*BUFD(1:nsgm1)*CI(1:nsgm1)
          !! right derivative of DF1
          CLag(1:nsgm1) = CLag(1:nsgm1)+DF1(it,iu)*BUF1(1:nsgm1,ib)*BUFD(1:nsgm1)
        end if
        !G1(it,iu) = DDOT_(nsgm1,ci,1,work(lto),1)
        !if (IFF /= 0) then
        !  F1sum = sum(CI(1:nsgm1)*work(lto:lto+nsgm1-1)*bufd(1:nsgm1))
        !  F1(it,iu) = F1sum-EPSA(iu)*G1(it,iu)
        !end if
      end do
    end if

    !ip3mx = ntri2
    !if (ip1end <= ntri2) ip3mx = ip1end
    !if (ip1sta > ntri2) ip3mx = ntri1
    !-SVC20100309: loop over ip3, ip2
    !do ip3=1,ip3mx

    !-SVC20100309: PAM's magic formula
    !iCnt = iSubTask-iOffSet
    !ip3 = int(real(ntri2,kind=wp)+OneHalf-sqrt((real(ntri2,kind=wp)+Half)**2-2*iCnt+1.0e-6_wp))
    !ip2 = iCnt-((ip3-1)*ntri2-nTri_Elem(ip3-2)+ip3-1

    !-SVC20100309: use simpler procedure by keeping inner ip2-loop intact

    !write(u6,*) 'ip3 = ',ip3
    !CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
    iq1 = icnj(ip3)
    ! The indices corresponding to pair index p3:
    iylev = idx2ij(1,ip3)
    izlev = idx2ij(2,ip3)
    isyz = Mul(SGS%ism(iylev),SGS%ism(izlev))
    issg2 = Mul(isyz,STSYM)
    nsgm2 = CIS%ncsf(issg2)
    iy = L2ACT(iylev)
    iz = L2ACT(izlev)
    buf2(1:nsgm2) = Zero
    call SG_Epq_Psi(SGS,CIS,EXS,IYLEV,IZLEV,One,STSYM,CI,BUF2)
    DYZ(1:nsgm1) = Zero
    if (issg2 == issg1) then
      buf3(1:nsgm2) = Zero
      do ib=1,ibuf1
        idx = ip1_buf(ib)
        itlev = idx2ij(1,idx)
        iulev = idx2ij(2,idx)
        it = L2ACT(itlev)
        iu = L2ACT(iulev)

        ScalG = DG2(iT,iU,iY,iZ)
        ScalF = DF2(iT,iU,iY,iZ)
        if ((ScalG == Zero) .and. (ScalF == Zero)) cycle

        !! left derivative
        if (IFF == 1) then
          BUFT(1:nsgm1) = (ScalG+ScalF*BUFD(1:nsgm1))*BUF2(1:nsgm1)
          DTU(1:nsgm1,ib) = DTU(1:nsgm1,ib)+BUFT(1:nsgm1)
        else
          DTU(1:nsgm1,ib) = DTU(1:nsgm1,ib)+ScalG*BUF2(1:nsgm1)
        end if

        !! right derivative
        if (IFF == 1) then
          buft(1:mxci) = buf1(1:mxci,ib)
          BUF3(1:nsgm1) = BUF3(1:nsgm1)+(ScalG+ScalF*BUFD(1:nsgm1))*BUFT(1:nsgm1)
        else
          BUF3(1:nsgm1) = BUF3(1:nsgm1)+ScalG*BUF1(1:nsgm1,ib)
        end if

        !! For DEPSA
        if (IFF == 1) DAB(1:nsgm1,ib) = DAB(1:nsgm1,ib)+ScalF*BUF2(1:nsgm1)
      end do
      !! Save for Eyz
      DYZ(1:nsgm2) = DYZ(1:nsgm2)+BUF3(1:nsgm2)
    end if
    nbtot = 0

    !! Prepare for DEPSA for the -epsa(iv) term with square
    iG3bk = iG3OFF
    do ixlev0=1,nlev
      BUFX(1:nsgm1,1:nlev) = Zero
      do ivlev=1,nlev
        call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV0,One,STSYM,BUF2,BUFX(:,ivlev))
      end do
      iG3OFF = iG3bk
      do ip2=ip3,ntri2
        ivlev = idx2ij(1,ip2)
        ixlev = idx2ij(2,ip2)
        isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
        iv = L2ACT(ivlev)
        if (isvx /= Mul(issg1,issg2)) cycle
        !! <I|EvxEyz|0>
        if (IXLEV == IXLEV0) BUFT(1:nsgm1) = BUFX(1:nsgm1,IVLEV)
        !-----------
        ! Max and min values of index p1:
        ip1mx = ntri2
        if (ip3 <= ntri1) then
          ip1mx = nlev2
          if (ip2 > ntri1) ip1mx = iq1
        end if
        ip1mn = max(ip2,ip1sta)
        ip1mx = min(ip1mx,ip1end)
        ! The corresponding locations in the Sgm1 buffer:
        ibmn = 999999
        ibmx = -999999
        do ib=ibuf1,1,-1
          ip1 = ip1_buf(ib)
          if (ip1 >= ip1mn) ibmn = ib
        end do
        do ib=1,ibuf1
          ip1 = ip1_buf(ib)
          if (ip1 <= ip1mx) ibmx = ib
        end do
        nb = ibmx-ibmn+1
        if (nb <= 0) cycle
        if (ixlev /= ixlev0) then
          iG3OFF = iG3OFF+nb
          cycle
        end if

        ! ----- left derivative

        ! BUF3 = (<I|Ett|I>-EPSA(V))*<I|EvxEyz|0> = <I|fEvxEyz|0>
        if (IFF == 1) buf3(1:nsgm1) = (bufd(1:nsgm1)-epsa(iv))*buft(1:nsgm1)
        do ib=1,nb
          iG3 = iG3OFF+ib
          idx = ip1_buf(ibmn-1+ib)

          !! <I|EvxEyz|0>*Dtuvxyz + <I|fEvxEyz|0>*Ftuvxyz
          DTU(1:nsgm1,ibmn+ib-1) = DTU(1:nsgm1,ibmn+ib-1)+DG3(iG3)*BUFT(1:nsgm1)
          if (IFF == 1) then
            DTU(1:nsgm1,ibmn+ib-1) = DTU(1:nsgm1,ibmn+ib-1)+DF3(iG3)*BUF3(1:nsgm1)
            !! DEPSA of the BUFD term
            DAB(1:nsgm1,ibmn+ib-1) = DAB(1:nsgm1,ibmn+ib-1)+DF3(iG3)*BUFT(1:nsgm1)
          end if
        end do

        ! ----- right derivative

        BUF3(1:nsgm1) = Zero
        BUF4(1:nsgm1) = Zero
        !! right derivative (1):
        !! <0|Etu|I>*Dtuvxyz and <0|Etu|I>*Ftuvxyz
        !! <0|EtuEvxEyz|I> -> <I|EzyExvEut|0>
        do ib=1,nb
          iG3 = iG3OFF+ib
          idx = ip1_buf(ibmn-1+ib)

          !! BUF3 = <0|Etu|I>*Dtuvxyz
          BUF3(1:nsgm1) = BUF3(1:nsgm1)+DG3(iG3)*BUF1(1:nsgm1,ibmn+ib-1)
          !! BUFC = <0|Etu|I>*Ftuvxyz
          if (IFF == 1) BUF4(1:nsgm1) = BUF4(1:nsgm1)+DF3(iG3)*BUF1(1:nsgm1,ibmn+ib-1)
        end do

        if (IFF == 1) then
          !! DEPSA of the -EPSA(iv) term
          call DGEMV_('T',nsgm1,NLEV,-One,BUFX,mxci,buf4,1,One,DEPSA(1,IVLEV),1)

          !! Scale the DF3 contribution with the diagonal Fock
          !! and add to the DG3 contribution
          buf3(1:nsgm1) = buf3(1:nsgm1)+buf4(1:nsgm1)*(bufd(1:nsgm1)-epsa(iv))
        end if
        !! right derivative (2): <0|EtuEvx|I>*Dtuvxyz
        call SG_Epq_Psi(SGS,CIS,EXS,IXLEV,IVLEV,One,STSYM,BUF3,DYZ)

        iG3OFF = iG3OFF+nb
        nbtot = nbtot+nb
      end do !! end of ip2 loop
    end do !! end of ixlev0 loop

    !! Complete the right derivative contribution:
    !! <0|EtuEyz|I> and <0|EtuEvxEyz|I>
    call SG_Epq_Psi(SGS,CIS,EXS,IZLEV,IYLEV,One,STSYM,DYZ,CLAG)

    if (iPrGlb >= DEBUG) then
      write(u6,'("DEBUG> ",I8,1X,"[",I4,"..",I4,"]",1X,I4,1X,I9)') iSubTask,ip1sta,ip1end,ip3,nbtot
      call xFlush(u6)
    end if
    iTask_loc = iTask_loc+1

    !SVC: The master node now continues to only handle task scheduling,
    !     needed to achieve better load balancing. So it exits from the task
    !     list.  It has to do it here since each process gets at least one
    !     task.

  end do
  !-SVC20100301: end of the task

  !! Final (the last task) left derivative and DEPSA contributions
  call LEFT_DEPSA()

  !-SVC20100302: no more tasks, wait here for the others, then proceed
  ! with next symmetry
  call Free_Tsk(ID)

  if (iPrGlb >= DEBUG) then
    if (nSubTasks > 0) write(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)') '--------','------------','----','---------'
  end if

! End of sectioning loop over symmetry of Sgm1 wave functions.
end do

#ifdef _MOLCAS_MPP_
if (is_real_par() .and. (iTask_loc-1 /= nTasks_grad)) then
  write(u6,*)
  write(u6,*) 'Somehow, the number of tasks in mkfg3 and derfg3 is not consistent...'
  write(u6,*) 'probably, bug'
  write(u6,*) '# of tasks in  mkfg3 = ',nTasks_grad
  write(u6,*) '# of tasks in derfg3 = ',iTask_loc-1
  call abend()
end if
#endif

call mma_deallocate(idx2ij)
call mma_deallocate(icnj)
call mma_deallocate(ip1_buf)

call mma_deallocate(TASKLIST)
! free CI buffers
call mma_deallocate(BUF1)
call mma_deallocate(BUF2)
call mma_deallocate(BUFT)
call mma_deallocate(BUFD)

call mma_deallocate(DTU)
call mma_deallocate(DYZ)
call mma_deallocate(DAB)
call mma_deallocate(BUF3)
call mma_deallocate(BUF4)

call mma_deallocate(BUFX)

contains

subroutine LEFT_DEPSA()

  integer(kind=iwp) :: IALEVloc, IBLEVloc, ibloc

  do ibloc=1,ibuf1
    idx = ip1_buf(ibloc)
    itlev = idx2ij(1,idx)
    iulev = idx2ij(2,idx)
    !! left derivative
    call SG_Epq_Psi(SGS,CIS,EXS,ITLEV,IULEV,One,STSYM,DTU(1,ibloc),CLAG)
    !! the rest is DEPSA contribution
    if (IFF == 1) then
      do IALEVloc=1,NLEV
        do IBLEVloc=1,NLEV
          BUF2(:) = Zero
          call SG_Epq_Psi(SGS,CIS,EXS,IALEVloc,IBLEVloc,One,STSYM,DAB(1,ibloc),BUF2)
          DEPSA(IALEVloc,IBLEVloc) = DEPSA(IALEVloc,IBLEVloc)+dot_product(BUF1(1:nsgm1,IBloc),BUF2(1:nsgm1))
        end do
      end do
    end if
  end do

end subroutine LEFT_DEPSA

end subroutine DERFG3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TR2CTL(CMO)
*
*     Two-electron integral transformation program: control section
*
*     Purpose: Set up of memory locations (decide if out of core is
*              needed. Loop over symmetry blocks of AO integrals.
*              The transformation routine TRAMO is called for each
*              symmetry block of integrals.
*
      IMPLICIT REAL*8 (A-H,O-Z)
*

#include "motra_global.fh"
#include "trafo_motra.fh"
#include "files_motra.fh"
#include "WrkSpc.fh"
*
      Real*8 CMO(*)
      DIMENSION NBSX(8),KEEP(8),ISTSQ(8)
      Logical FoundTwoEls,DoDirect,DoCholesky,ISQUAR
*
*
*     Set time at start of transformation
*
      CALL SETTIM
*
*     Initiate unit LUTWOMO (two-electron integrals in MO basis)
*
      CALL DANAME_MF(LUTWOMO,FNTWOMO)
      IAD13=0
      Call iCopy(nTraToc,[0],0,iTraToc,1)
      CALL iDAFILE(LUTWOMO,1,iTraToc,nTraToc,IAD13)
*
*     Initiate unit LUTWOAO (two-electron integrals in AO basis)
*
      Call f_Inquire(FnTwoAo,FoundTwoEls)
      Call DecideOnDirect(.False.,FoundTwoEls,DoDirect,DoCholesky)
      If (.not.DoCholesky) CALL OPNORD(IRC,0,FNTWOAO,LUTWOAO)

      CALL GETORD(IRC,ISQUAR,NSYM2,NBSX,KEEP)

*
*     Compare content of 1el and 2el integral file
*
      IF ( NSYM2.NE.NSYM ) THEN
         Write (6,*) 'Tr2Ctl: NSYM2.NE.NSYM'
         Write (6,*) 'NSYM2=',NSYM2
         Write (6,*) 'NSYM=',NSYM
         Call Abend()
      END IF
      DO ISYM=1,NSYM
        NB1=NBAS(ISYM)
        NB2=NBSX(ISYM)
        IF ( NB1.NE.NB2 ) THEN
           Write (6,*) 'Tr2Ctl: NB1.NE.NB2'
           Write (6,*) 'NB1=',NB1
           Write (6,*) 'NB2=',NB2
           Call Abend()
        END IF
      END DO
*
*     Precompute start points
*
      ISTBS=1
      DO 20 ISYM=1,NSYM
        ISTSQ(ISYM)=ISTBS+NBAS(ISYM)*NFRO(ISYM)
        ISTBS=ISTBS+NBAS(ISYM)*NBAS(ISYM)
20    CONTINUE
*
*     Loop over quadruples of symmetries (nsp,nsq,nsr,nss)
*     Note that the integrals on LUTWOAO have to be sorted in the
*     same order as the loop structure below.
*
      If (iPrint.GE.0) WRITE(6,2000)
2000  FORMAT(/7X,'SYMMETRY',2X,'BASIS FUNCTIONS',6X,' ORBITALS',6X,
     *       'INTEGRALS   CPU(SEC)  I/O(SEC)')
      IBATCH=0
      DO 104 NSP=1,NSYM
        NBP=NBAS(NSP)
        NOP=NORB(NSP)
        KEEPP=KEEP(NSP)
        LMOP=ISTSQ(NSP)
        ISP=NSP
        DO 103 NSQ=1,NSP
          NBQ=NBAS(NSQ)
          NOQ=NORB(NSQ)
          KEEPQ=KEEP(NSQ)
          LMOQ=ISTSQ(NSQ)
          NSPQ=IEOR(NSP-1,NSQ-1)+1
          ISQ=NSQ
          DO 102 NSR=1,NSP
            NBR=NBAS(NSR)
            NOR=NORB(NSR)
            KEEPR=KEEP(NSR)
            LMOR=ISTSQ(NSR)
            NSPQR=IEOR(NSPQ-1,NSR-1)+1
            ISR=NSR
            NSSM=NSR
            IF(NSR.EQ.NSP) NSSM=NSQ
            DO 101 NSS=1,NSSM
              NBS=NBAS(NSS)
              NOS=NORB(NSS)
              KEEPS=KEEP(NSS)
              LMOS=ISTSQ(NSS)
              NSPQRS=IEOR(NSPQR-1,NSS-1)+1
              IF( NSPQRS.NE.1 ) GOTO 101
              IBATCH=IBATCH+1
              ISS=NSS
*
*             Check the loop conditions and skip transformation step
*             if possible
*
              KEEPT=KEEPP+KEEPQ+KEEPR+KEEPS
              NORBP=NOP*NOQ*NOR*NOS
              IF( NORBP.EQ.0 ) GOTO 101
              IF( KEEPT.NE.0 ) THEN
                Write (6,*) 'Tr2Ctl: NORBP.NE.0.AND.KEEPT.NE.0'
                Write (6,*) 'NORBP=',NORBP
                Write (6,*) 'KEEPT=',KEEPT
                Call Abend()
              End If
*
*             Define matrix sizes
*
              IF(ISR.EQ.ISS) THEN
                NBPQ=(NBP+NBP**2)/2
                NBRS=(NBR+NBR**2)/2
                NOVX=(NOR+NOR**2)/2
              ELSE
                NBPQ=NBP*NBQ
                NBRS=NBR*NBS
                NOVX=NOR*NOS
              ENDIF
*
*             Set up dynamic memory
*
* INTBUF=Size of output buffer.
*             INTBUF=256*256
              INTBUF=16 * 256*256
              NW1=2*KBUF
              NW2=MAX(INTBUF,NBP*NOQ,NBQ*NOP)
* NW2 is size of 'X1' in TRAMO, used as LBUF in call to RDORD and RDORD_.
* LBUF-1 must be at least 'klB':
              NW2=MAX(NW2,NBRS+1,NBPQ+1)
              NW3=MAX(NBR**2,NBP**2,NOQ*NBP,NOVX)
              NW4=MAX(NBR*NOS,NBQ*NOP)
              CALL GETMEM('OUTBUF','ALLO','REAL',LW1,NW1)
              CALL GETMEM('X1','ALLO','REAL',LW2,NW2)
              CALL GETMEM('X2','ALLO','REAL',LW3,NW3)
              CALL GETMEM('X3','ALLO','REAL',LW4,NW4)
              Call GetMem('iDsk','Allo','Inte',ipiDsk,3*nOVX)
              CALL GETMEM('VXPQ','MAX','REAL',LW5,MEMX)

              If (DoCholesky) Then ! save some space for GenInt
                 MEMX = MAX(MEMX-MEMX/10,0)
              End If

              CALL GETMEM('VXPQ','ALLO','REAL',LW5,MEMX)
*
              IF(MEMX.LT.NOVX) then
                Write (6,*) 'Tr2Ctl: MEMX.LT.NOVX'
                Write (6,*) 'MEMX=',MEMX
                Write (6,*) 'NOVX=',NOVX
                Call Abend()
              End If
*
*             transform the symmetry block (ISP,ISQ|ISR,ISS)
*
              iTraToc(IBATCH)=IAD13
* NW2 is size of 'X1' in TRAMO, used as LBUF in call to RDORD and RDORD_.
              CALL TRAMO(NW2   ,WORK(LW1),nW1,
     &                          WORK(LW2),nW2,
     &                          WORK(LW3),nW3,
     &                          WORK(LW4),nW4,
     &                          WORK(LW5),MEMX,CMO,
     &                          iWork(ipiDsk),nOVX)
              CALL TIMING(CPT,CPE,TIOT,TIOE)
              If (iPrint.GE.0) WRITE(6,2100)
     &    ISP,ISQ,ISR,ISS,NBP,NBQ,NBR,NBS,NOP,NOQ,NOR,NOS,LTUVX,CPE,TIOE
2100          FORMAT(7X,4I2,1X,4I4,2X,4I4,3X,I9,F11.2,F10.2)
              Call Xflush(6)

*
*             Deallocate work space
*
              CALL GETMEM('VXPQ','FREE','REAL',LW5,MEMX)
              Call GetMem('iDsk','Free','Inte',ipiDsk,3*nOVX)
              CALL GETMEM('X3','FREE','REAL',LW4,NW4)
              CALL GETMEM('X2','FREE','REAL',LW3,NW3)
              CALL GETMEM('X1','FREE','REAL',LW2,NW2)
              CALL GETMEM('OUTBUF','FREE','REAL',LW1,NW1)
*
*             End of loop over quadruples of symmetries
*
101         CONTINUE
102       CONTINUE
103     CONTINUE
104   CONTINUE
      CALL TIMING(CPT,CPE,TIOT,TIOE)
      If (iPrint.GE.0) WRITE(6,2200) CPT,TIOT
2200  FORMAT(/6X,' TOTAL CPU TIME(SEC)',F8.2,'TOTAL I/O TIME(SEC)',F8.2)
*
*     Closed LUTWOAO
*
      If (.not.DoCholesky)then
         CALL CLSORD(IRC,0)
      End If
*
*     Write address block to LUTWOMO
*
      IAD13=0
      CALL iDAFILE(LUTWOMO,1,iTraToc,nTraToc,IAD13)
      IF ( IPRINT.GE.5 .OR. DEBUG.NE.0 ) THEN
        WRITE(6,'(6X,2A)')'DISK ADRESSES FOR SYMMETRY BLOCKS OF ',
     *                     'TRANSFORMED TWO-ELECTRON INTEGRALS'
        WRITE(6,'(6X,10I8)')(iTraToc(I),I=1,nTraToc)
      ENDIF

      CALL DACLOS(LUTWOMO)
*
*     exits
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
* This routine projects out specified vectors from the density matrix. *
* The procedure is to read the projection orbitals and perform a       *
* sequence of rank-1 updated to zero out the contributions <c|D|c>.    *
* This procedure does not necessarily produce a complete projection    *
* of the density matrix, and routine 'proj1' is preferable.            *
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine Proj2
      Implicit Real*8 (a-h,o-z)
#include "parm.fh"
#include "common.fh"
      Dimension ProjOrb(MxS*MxS)
      Dimension TmpDens(MxS*MxS)
      Dimension TmpOvlp(MxS*MxS)
      call molcas_open(17,'PROJ')
c      Open(unit=17,file='PROJ',form='FORMATTED')
      iBlk=0
*--- Loop over l quantum number ---*
      Do 100 iLqn=0,MxLqn
*--- Read projection orbitals ---*
         Read(17,*,end=999,err=999) nB,nO
         If(nB*nO.le.0) Go To 100
         If(nB.ne.nPrim(iLqn)) Then
            Write(6,*) 'Project: inconsistency in number of functions'
            Call Abend
         End If
         Do 105 iB=1,nB
            Read(17,*) (ProjOrb(iB+nB*(iO-1)),iO=1,nO)
105      Continue
*         Write(*,'(a,i5)') ' Projection orbitals',iLqn
*         Do 101 iB=1,nB
*            Write(*,'(1x,6f12.6)') (ProjOrb(iB+nB*(iO-1)),iO=1,nO)
*101      Continue
*--- Loop over m quantum number ---*
         Do 110 iShell=-iLqn,iLqn
            iBlk=iBlk+1
*           Write(*,'(a,2i5)') ' Density matrix block',iLqn,iShell
*           Call Triprt(' ','(6F12.6)',tDsym(iSymbk(iBlk)),nPrim(iLqn))
*           Write(*,'(a,2i5)') ' Overlap matrix block',iLqn,iShell
*           Call Triprt(' ','(6F12.6)',Ssym(iSymbk(iBlk)),nPrim(iLqn))
*--- Copy S and D into square form ---*
            Do 111 i=1,nB
            Do 1110 j=1,nB
               indT=min(i,j)+max(i,j)*(max(i,j)-1)/2
               indS=i+nB*(j-1)
               TmpDens(indS)=tDsym(iSymbk(iBlk)-1+indT)
               TmpOvlp(indS)=Ssym(iSymbk(iBlk)-1+indT)
*              Write(*,'(1x,4i5,2f12.6)') i,j,IndT,IndS,
*    &            TmpDens(indS),TmpOvlp(indS)
1110        Continue
111         Continue
*--- Project ---*
            Do 112 iO=1,nO
               eval=0.0d0
               Do 113 iB=1,nB
               Do 1130 jB=1,nB
               Do 1131 kB=1,nB
               Do 1132 lB=1,nB
                  ij=iB+nB*(jB-1)
                  jk=jB+nB*(kB-1)
                  kl=kB+nB*(lB-1)
                  t=ProjOrb(iB+nB*(iO-1))*ProjOrb(lB+nB*(iO-1))
                  t=t*TmpOvlp(ij)
                  t=t*TmpDens(jk)
                  t=t*TmpOvlp(kl)
                  eval=eval+t
1132           Continue
1131           Continue
1130           Continue
113            Continue
               cnorm=0.0d0
               Do 114 iB=1,nB
               Do 1140 jB=1,nB
                  ij=iB+nB*(jB-1)
                  t=ProjOrb(iB+nB*(iO-1))*ProjOrb(jB+nB*(iO-1))
                  t=t*TmpOvlp(ij)
                  cnorm=cnorm+t
1140           Continue
114            Continue
*              Write(*,'(a,f12.6)') ' Eigenvalue ',eval
*              Write(*,'(a,f12.6)') ' Norm       ',cnorm
               eval=eval/cnorm/cnorm
               Do 115 iB=1,nB
               Do 1150 jB=1,nB
                  t=ProjOrb(iB+nB*(iO-1))*ProjOrb(jB+nB*(iO-1))
                  TmpDens(iB+nB*(jB-1))=TmpDens(iB+nB*(jB-1))-eval*t
1150           Continue
115            Continue
112         Continue
*--- Copy back D ---*
            Do 118 i=1,nB
            Do 1180 j=1,nB
               indT=min(i,j)+max(i,j)*(max(i,j)-1)/2
               indS=i+nB*(j-1)
               tDsym(iSymbk(iBlk)-1+indT)=TmpDens(indS)
1180        Continue
118         Continue
*           Write(*,'(a,2i5)') ' Density matrix block',iLqn,iShell
*           Call Triprt(' ','(6F12.6)',tDsym(iSymbk(iBlk)),nPrim(iLqn))
110      Continue
100   Continue
*--- ---*
999   Continue
      Close(unit=17)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkV_Hvv2(Va,V,dima,dimb,no)
! this routine does:
! Va(b',i,j,a') <- 2(a'i|b'j)-(a'j|b'i)  V(b'I|a'J)

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, no
real(kind=wp), intent(out) :: Va(dimb,no,no,dima)
real(kind=wp), intent(in) :: V(dimb,no,dima,no)
integer(kind=iwp) :: a, j

do a=1,dima
  do j=1,no
    Va(:,:,j,a) = Two*V(:,j,a,:)-V(:,:,a,j)
  end do
end do

return

end subroutine MkV_Hvv2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2022, Jie J. Bao                                       *
************************************************************************
      Subroutine CMSOpt(TUVX)
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Apr. 07, 2022, created this file.               *
* ****************************************************************
      use stdalloc, only : mma_allocate, mma_deallocate
      use CMS, only: CMSNotConverged,RGD
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"

      Real*8,DIMENSION(NACPR2)::TUVX
      Real*8,DIMENSION(:),Allocatable::Gtuvx,R,
     &                                 GDstate,GDorbit,
     &                                 Dgstate,Dgorbit
      Real*8,DIMENSION(:,:),Allocatable::RotMat

      INTEGER nTUVX,nGD,lRoots2,NAC2

      CHARACTER(len=16)::VecName
******************************************************************
*     some notes on the arrays:                                  *
*     Gtuvx : two-electron integral, g_tuvx                      *
*     GD    : "generalized 1-e density matrix"                   *
*              GD^KL: transition density matrix from L to K      *
*              GD^KK: density matrix for state K                 *
*     Dg    :  sum_{vx}{GD^KL_vx * g_tuvx}                       *
*     In GDorbit and Dgorbit, the leading index is orbital index;*
*     In GDstate and Dgstate, the leading index is state index.  *
*                                                                *
*     DDg   :  sum_{tuvx}{GD^KL_tu * GD^MN_vx * g_tuvx}          *
*      namely, sum_{tu}{GD^KL_tu * Dg^MN_tu}                     *
******************************************************************

      NAC2=NAC**2
      nTUVX=NAC2**2
      lRoots2=lRoots**2
      nGD=lRoots2*NAC2

      CMSNotConverged=.true.

******Memory Allocation
      CALL mma_allocate(R      ,lRoots2)
      CALL mma_allocate(GDstate,nGD    )
      CALL mma_allocate(Dgstate,nGD    )
      CALL mma_allocate(GDorbit,nGD    )
      CALL mma_allocate(Dgorbit,nGD    )
      CALL mma_allocate(Gtuvx  ,nTUVX  )
      CALL mma_allocate(RGD    ,lRoots2)
      CALL mma_allocate(RotMat ,lRoots,lRoots)

******Calculate generalized density mtrix
      CALL UnzipTUVX(TUVX,Gtuvx,nTUVX)

C      write(6,*) 'Gtuvx matrix'
C      CALL RecPrt(' ',' ',Gtuvx,NAC2,NAC2)

      CALL CalcGD(GDorbit,nGD)
C      write(6,*) 'GD matrix orbital-leading'
C      CALL RecPrt(' ',' ',GDorbit,NAC2,lRoots2)
      CALL CalcDg(Dgorbit,GDorbit,Gtuvx,nGD,nTUVX,NAC,lRoots)
C      write(6,*) 'Dg matrix orbital-leading'
C      CALL RecPrt(' ',' ',Dgorbit,NAC2,lRoots2)

      CALL mma_deallocate(Gtuvx  )

      CALL TransposeMat(Dgstate,Dgorbit,nGD,NAC2,lRoots2)
      CALL TransposeMat(GDstate,GDorbit,nGD,NAC2,lRoots2)

******Load initial rotation matrix
      CALL InitRotMat(RotMat,lRoots,
     &                trim(CMSStartMat),len_trim(CMSStartMat))

      CALL OneDFoil(R,RotMat,lRoots,lRoots)

******Print header of CMS iterations
      CALL CMSHeader(trim(CMSStartMat),len_trim(CMSStartMat))

******Start CMS Optimization
      CMSNotConverged=.true.
      CALL CMSNewton(R,GDorbit,GDstate,Dgorbit,Dgstate,nGD)

******Print end of CMS intermediate-state optimization
      CALL CMSTail()

******Save rotation matrix
      CALL AntiOneDFoil(RotMat,R,lRoots,lRoots)
      VecName='CMS-PDFT'
      CALL PrintMat('ROT_VEC',VecName,RotMat,lroots,lroots,7,16,'T')

******releasing memory
      CALL mma_deallocate(R      )
      CALL mma_deallocate(GDstate)
      CALL mma_deallocate(Dgstate)
      CALL mma_deallocate(GDorbit)
      CALL mma_deallocate(Dgorbit)
      CALL mma_deallocate(RGD    )
      CALL mma_deallocate(RotMat )

******check convergence
      IF(CMSNotConverged) THEN
       Call WarningMessage(2,'CMS Intermediate States Not Converged')
       Call Quit(_RC_NOT_CONVERGED_)
      END IF

      RETURN
      End Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** LINPACK ROUTINES **
!**********************

subroutine DGEDI(A,LDA,N,IPVT,DET,W,JOB)
! DGEDI COMPUTES THE DETERMINANT AND INVERSE OF A MATRIX
! USING THE FACTORS COMPUTED BY DGECO OR DGEFA.
!
! ON ENTRY
!
!    A       real(LDA, N)
!            THE OUTPUT FROM DGECO OR DGEFA.
!
!    LDA     INTEGER
!            THE LEADING DIMENSION OF THE ARRAY  A .
!
!    N       INTEGER
!            THE ORDER OF THE MATRIX  A .
!
!    IPVT    INTEGER(N)
!            THE PIVOT VECTOR FROM DGECO OR DGEFA.
!
!    W       real(N)
!            WORK VECTOR.  CONTENTS DESTROYED.
!
!    JOB     INTEGER
!            = 11   BOTH DETERMINANT AND INVERSE.
!            = 01   INVERSE ONLY.
!            = 10   DETERMINANT ONLY.
!
! ON RETURN
!
!    A       INVERSE OF ORIGINAL MATRIX IF REQUESTED.
!            OTHERWISE UNCHANGED.
!
!    DET     real(2)
!            DETERMINANT OF ORIGINAL MATRIX IF REQUESTED.
!            OTHERWISE NOT REFERENCED.
!            DETERMINANT = DET(1) * 10.0**DET(2)
!            WITH  1.0 <= abs(DET(1)) < 10.0
!            OR  DET(1) == 0.0 .
!
! ERROR CONDITION
!
!    A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS
!    A ZERO ON THE DIAGONAL AND THE INVERSE IS REQUESTED.
!    IT WILL NOT OCCUR IF THE SUBROUTINES ARE CALLED CORRECTLY
!    AND IF DGECO HAS SET RCOND > 0.0 OR DGEFA HAS SET
!    INFO == 0 .
!
! LINPACK. THIS VERSION DATED 08/14/78 .
! CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
!
! SUBROUTINES AND FUNCTIONS
!
! BLAS DSWAP
! FORTRAN ABS,MOD
!
! Updated to Fortran 90+ (Sep. 2023)

use Constants, only: Zero, One, Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LDA, N, IPVT(N), JOB
real(kind=wp), intent(inout) :: A(LDA,N)
real(kind=wp), intent(out) :: DET(2), W(N)
integer(kind=iwp) :: I, J, K, KB, KP1, L, NM1
real(kind=wp) :: T

! COMPUTE DETERMINANT

if (JOB/10 /= 0) then
  DET(1) = One
  DET(2) = Zero
  do I=1,N
    if (IPVT(I) /= I) DET(1) = -DET(1)
    DET(1) = A(I,I)*DET(1)
    ! ...EXIT
    if (DET(1) == Zero) exit
    do
      if (abs(DET(1)) >= One) exit
      DET(1) = Ten*DET(1)
      DET(2) = DET(2)-One
    end do
    do
      if (abs(DET(1)) < Ten) exit
      DET(1) = DET(1)/Ten
      DET(2) = DET(2)+One
    end do
  end do
end if

! COMPUTE INVERSE(U)

if (mod(JOB,10) /= 0) then
  do K=1,N
    A(K,K) = One/A(K,K)
    T = -A(K,K)
    A(1:K-1,K) = T*A(1:K-1,K)
    KP1 = K+1
    if (N < KP1) cycle
    do J=KP1,N
      T = A(K,J)
      A(K,J) = Zero
      A(1:K,J) = A(1:K,J)+T*A(1:K,K)
    end do
  end do

  ! FORM INVERSE(U)*INVERSE(L)

  NM1 = N-1
  if (NM1 >= 1) then
    do KB=1,NM1
      K = N-KB
      KP1 = K+1
      W(KP1:N) = A(KP1:N,K)
      A(KP1:N,K) = Zero
      do J=KP1,N
        T = W(J)
        A(1:N,K) = A(1:N,K)+T*A(1:N,J)
      end do
      L = IPVT(K)
      if (L /= K) call DSWAP_(N,A(1:N,K),1,A(1:N,L),1)
    end do
  end if
end if

return

end subroutine DGEDI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  ContractOvl
*
*> @brief
*>   Compute the overlaps between solvent and solute in contracted basis-functions
*> @author A. Ohrn
*>
*> @details
*> Here the overlap between the QM-region contracted AO-basis
*> functions and the present solvent molecule contracted AO-basis
*> functions are computed. In order to use the fact that we use
*> contracted functions to the maximum, we compute the overlaps with
*> primitive functions only once, then we transform this matrix to
*> all relevant contracted overlaps. After that, the old primitive
*> integrals are discarded and a new set of primitive are computed.
*> This is very nice since ::OverLq is rather slow. The problems we
*> get are that we must use rather elaborate schemes to get right
*> digit in right place.
*>
*> @param[out] Sint     The contracted basis function overlaps
*> @param[out] SintPar  The contracted basis function overlaps with extra atom--atom weights *if* this has been requested by user, otherwise unchanged
*> @param[in]  nBaseQ   Number of AO-basis functions in QM-region
*> @param[in]  nBaseC   Like \p nBaseQ but for solvent
*> @param[in]  N        Which solvent molecule this is
*> @param[in]  nCent    How many centers the solvent molecule has
*> @param[in]  iEl      Number of elements in QM-region
*> @param[in]  nAtomsCC How many solvent atoms
*> @param[in]  iPrint   Print level
************************************************************************
      Subroutine ContractOvl(Sint,SintPar,nBaseQ,nBaseC
     &,N,nCent,iEl,iQ_Atoms,nAtomsCC,iPrint,Inside)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "integral.fh"
#include "WrkSpc.fh"

      Parameter(MxSphAng=2*MxAngqNr-1)
      Dimension Sint(MxBas,MxBasC),SintPar(MxBas,MxBasC)
      Dimension Bori(3),Cori(3),Alf(MxCont),Bet(MxCont)
      Dimension Conkort(MxCont),Donkort(MxCont),ContrI(MxSphAng**2)
      Dimension Inside(MxAt,3)
      Logical Inside

      Const=0
      nSph1=0
      nSph2=0
      iQcontBSAV=0
      iCcontBSAV=0
      iQcontBSAV1=0
      iCcontBSAV1=0
      iQcontBSAV2=0
      iCcontBSAV2=0
      Do 11, iA1=1,iQ_Atoms  !The atoms
        Do 12, iA2=1,nAtomsCC
          If(.not.Inside(iA1,iA2)) then  !when atom-pair too far from
                                       !each other, do this then skip.
            iCcontBSAV=iCcontBSAV+nBonA_C(iA2)
            iCcontBSAV1=iCcontBSAV
            iCcontBSAV2=iCcontBSAV
            If(iA2.eq.nAtomsCC) then
              iQcontBSAV=iQcontBSAV+nBonA_Q(iA1)
              iQcontBSAV1=iQcontBSAV
            Endif
            Go To 12
          Endif
          Do 13, iB1=1,nBA_Q(iA1) !The basis functions on this specific
            Do 14, iB2=1,nBA_C(iA2) !atom
              iQcontB=iQcontBSAV
              Do 15, iNcB1=1,nCBoA_Q(iA1,iB1) !The basis of angular
                iQcontB=iQcontB+1             !type.
                iCcontB=iCcontBSAV
                Bori(1)=BasOri(1,iQcontB) !Suck-out proper coord
                Bori(2)=BasOri(2,iQcontB) !for QM.
                Bori(3)=BasOri(3,iQcontB)
                iqqqQ=iQang(iQcontB)  !Various integers, see qfread
                nExp1=nPrimus(iQcontB) !to understand their meaning.
                nSph1=2*iqqqQ-1
                iChQ=iCharOnBasQ(iQcontB)
                ijk=0
                Do 5411, i=1,nPrimus(iQcontB) !Suck-out the proper
                  Alf(i)=alfa(iQcontB,i)  !exponents for QM-region
                  Conkort(i)=cont(iQcontB,i)
5411            Continue
                Do 16, iNcB2=1,nCBoA_C(iA2,iB2)
                  iCcontB=iCcontB+1
                  Cori(1)=CasOri(1,iCcontB)  !Coord. of the atoms of
                  Cori(2)=CasOri(2,iCcontB)  !this solvent mol.
                  Cori(3)=CasOri(3,iCcontB)
                  iqqqC=iQn(iCcontB)
                  nExp2=mPrimus(iCcontB)
                  nSph2=2*iqqqC-1
                  iChC=iCharOnBasC(iCcontB)
                  ijk=0
                  Do 5412, j=1,mPrimus(iCcontB) !Exponents and stuff.
                    Bet(j)=beta(iCcontB,j)
                    Donkort(j)=dont(iCcontB,j)
5412              Continue
*------ Now call on the routine that computes a block of primitive
*       integrals. So if we are integrating the np-mp overlap we
*       compute ALL primitive p-p integrals, in the first call, then
*       they are merely contracted. This is an economical procedure
*       for both general and ordinary contracted basis sets since all
*       primitve overlaps are needed at some point in the contracted
*       overlaps, the difference between general and ordinary is that
*       in the former primitve overlaps are needed at all instances,
*       while in the latter primitve overlaps are needed only once.
                  If(iNcB1.eq.1.and.iNcB2.eq.1) then
                    Call OverLq(Bori,Cori,Alf,Bet,iqqqQ,iqqqC,nExp1
     &                         ,nExp2,iPSint,Trans)
                  Endif
                  kaunter=0
                  Do 501, i=1,nSph2 !contract
                    Do 502, j=1,nSph1
                      kaunter=kaunter+1
                      DaNumber=0
                      Do 503, iCC=1,nExp2
                        Do 504, iCQ=1,nExp1
                          iindex=(i-1)*nSph1*nExp1+j-1+nSph1*(iCQ-1)
     &                          +nSph1*nExp1*nSph2*(iCC-1)
                          DaNumber=DaNumber+Conkort(iCQ)*Donkort(iCC)
     &                            *Work(iPSint+iindex)
504                     Continue
503                   Continue
                      ContrI(kaunter)=DaNumber
502                 Continue
501               Continue
                  If(iPrint.ge.30) then
                    Write(6,*)'Basis',iQcontB,iCcontB
                    Write(6,*)'Coord.',Bori(1),Bori(2),Bori(3)
                    Write(6,*)'Coord.',Cori(1),Cori(2),Cori(3)
                    Write(6,*)'Alfa',(Alf(i),i=1,nPrimus(iQcontB))
                    Write(6,*)'Beta',(Bet(i),i=1,mPrimus(iCcontB))
                    Write(6,*)'ConQ',(Conkort(i),i=1,nPrimus(iQcontB))
                    Write(6,*)'ConC',(Donkort(i),i=1,mPrimus(iCcontB))
                    Write(6,*)'Angular',iqqqQ,iqqqC
                    Write(6,*)'#primitive',nExp1,nExp2
                    Write(6,*)(ContrI(k),k=1,nSph1*nSph2)
                  Endif
                  kreichner=0
                  Do 5421, iC=1,nSph2
                    Do 5422, iQ=1,nSph1
                    kreichner=kreichner+1
                    Sint(iWoGehenQ(iQcontB,iQ),iWoGehenC(iCcontB,iC))=
     &                                ContrI(kreichner)
5422                Continue
5421              Continue
16              Continue
15            Continue
              iCcontBSAV=iCcontB
         !This vector is allocated in OverLq.
              nSize=nExp1*nExp2*nSph1*nSph2
              Call GetMem('AllPrims','Free','Real',iPSint,nSize)
14          Continue
            iQcontBSAV=iQcontB   !OH NO!, these things have to do with
            iCcontBSAV1=iCcontBSAV  !getting the right number in right
            iCcontBSAV=iCcontBSAV2  !place. This should probably be
13        Continue                !changed sometime to a less cumbersome
          iQcontBSAV1=iQcontBSAV  !method.
          iQcontBSAV=iQcontBSAV2
          iCcontBSAV2=iCcontBSAV1
          iCcontBSAV=iCcontBSAV1
12      Continue
        iQcontBSAV2=iQcontBSAV1
        iQcontBSAV=iQcontBSAV1
        iCcontBSAV=0
        iCcontBSAV1=0
        iCcontBSAV2=0
11    Continue
      If(iPrint.ge.30) then  !Optional print-out.
        Write(6,*)
        Write(6,*)'OVERLAP BETWEEN QM-SYSTEM AND SOLVENT MOLECULE'
     &,N/nCent
        Write(6,*)'QM-AO  SOLV-AO  OVERLAP'
        Do 545, i=1,nBaseQ
          Do 546, j=1,nBaseC
            Write(6,8888)i,j,Sint(i,j)
546       Continue
545     Continue
      Endif
8888  Format(I3,'    ',I3,'       ',F12.10)

      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(SintPar)
        Call Unused_integer(iEl)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine Localise_Iterative(irc,Model,Functional)
! Author: T.B. Pedersen
!
! Purpose: Iterative localisation of orbitals.
!          Models implemented:
!            Pipek-Mezey         [MODEL='PIPE']
!            Boys                [MODEL='BOYS']
!            Edmiston-Ruedenberg [MODEL='EDMI']

use Localisation_globals, only: ChoStart, CMO, Maximisation, BName, nAtoms, nMxIter, nBas, nFro, nOrb2Loc, nSym, Silent, ThrGrad, &
                                ThrRot, Thrs
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
character(len=4), intent(in) :: Model
real(kind=wp), intent(out) :: Functional
#include "debug.fh"
integer(kind=iwp) :: iSym
real(kind=wp) :: Thrs_Save, xNrm
character(len=80) :: Txt
character(len=4) :: myModel
logical(kind=iwp) :: Converged
character(len=*), parameter :: SecNam = 'Localise_Iterative'

irc = 0
Functional = -huge(Functional)
Converged = .false.

! Generate Cholesky start guess, if requested.
! --------------------------------------------

if (ChoStart) then
  Thrs_Save = Thrs
  Thrs = 1.0e-12_wp
  call Localise_Noniterative(irc,'Chol',xNrm)
  if (irc /= 0) then
    write(Txt,'(A,I4)') 'Return code:',irc
    call SysAbendMsg(SecNam,'Localise_Noniterative failed!',Txt)
  end if
  Thrs = Thrs_Save
end if

! Localise.
! ---------

myModel = Model
call UpCase(myModel)
if (myModel == 'PIPE') then
  !if (.not. Silent) then
  write(u6,'(//,1X,A)') 'Pipek-Mezey localisation'
  write(u6,'(1X,A,1X,D12.4,A)') 'Convergence threshold:',Thrs,' (functional)'
  write(u6,'(1X,A,1X,D12.4,A)') 'Convergence threshold:',ThrGrad,' (gradient)'
  write(u6,'(1X,A,1X,D12.4,A)') 'Screening threshold  :',ThrRot,' (orbital rotations)'
  write(u6,'(1X,A,8(1X,I6))') 'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
  write(u6,'(1X,A,8(1X,I6))') 'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
  !end if
  call PipekMezey(Functional,CMO,Thrs,ThrRot,ThrGrad,BName,nBas,nOrb2Loc,nFro,nSym,nAtoms,nMxIter,Maximisation,Converged, &
                  Debug,Silent)
else if (myModel == 'BOYS') then
  !if (.not. Silent) then
  write(u6,'(/,1X,A)') 'Boys localisation'
  write(u6,'(1X,A,1X,D12.4,A)') 'Convergence threshold:',Thrs,' (functional)'
  write(u6,'(1X,A,1X,D12.4,A)') 'Convergence threshold:',ThrGrad,' (gradient)'
  write(u6,'(1X,A,1X,D12.4,A)') 'Screening threshold  :',ThrRot,' (orbital rotations)'
  write(u6,'(1X,A,8(1X,I6))') 'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
  write(u6,'(1X,A,8(1X,I6))') 'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
  !end if
  call Boys(Functional,CMO,Thrs,ThrRot,ThrGrad,nBas,nOrb2Loc,nFro,nSym,nMxIter,Maximisation,Converged,Debug,Silent)
else if (myModel == 'EDMI') then
  !if (.not. Silent) then
  write(u6,'(/,1X,A)') 'Edmiston-Ruedenberg localisation'
  write(u6,'(1X,A,1X,D12.4,A)') 'Convergence threshold:',Thrs,' (functional)'
  write(u6,'(1X,A,1X,D12.4,A)') 'Convergence threshold:',ThrGrad,' (gradient)'
  !write(u6,'(1X,A,1X,D12.4,A)') 'Screening threshold  :',ThrRot,' (orbital rotations)'
  write(u6,'(1X,A,8(1X,I6))') 'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
  write(u6,'(1X,A,8(1X,I6))') 'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
  !end if
  call EdmistonRuedenberg(Functional,CMO,Thrs,ThrRot,ThrGrad,nBas,nOrb2Loc,nFro,nSym,nMxIter,Maximisation,Converged,Debug,Silent)
else
  write(Txt,'(A,A4)') 'Model = ',Model
  call SysAbendMsg(SecNam,'Unknown model',Txt)
end if

if (.not. Converged) then
  irc = 1
  return
end if

end subroutine Localise_Iterative

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_QUALIFY_1(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
!
! Purpose: qualify diagonals ("qualify until full").

use Cholesky, only: DiaMin, iiBstR, iiBstRSh, IndRed, iOffq, iQuAB, MaxQual, nnBstR, nnBstRSh, nQual
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*)
integer(kind=iwp), intent(in) :: ISYM, ISHLAB, MEM
integer(kind=iwp), intent(inout) :: MEM0, LEFT
integer(kind=iwp) :: I, I2, J, MAXQ, NUMQ

if (NNBSTRSH(ISYM,ISHLAB,2) > 0) then
  I = IIBSTR(ISYM,2)+IIBSTRSH(ISYM,ISHLAB,2)
  I2 = I+NNBSTRSH(ISYM,ISHLAB,2)
  MAXQ = min(MAXQUAL-NQUAL(ISYM),LEFT/NNBSTR(ISYM,2))
  NUMQ = 0
  do while ((I < I2) .and. (NUMQ < MAXQ))
    I = I+1
    J = INDRED(I,2)
    if (DIAG(J) >= DIAMIN(ISYM)) then
      NUMQ = NUMQ+1
      iQuAB(IOFFQ(ISYM)+NUMQ,ISYM) = I
    end if
  end do
  NQUAL(ISYM) = NQUAL(ISYM)+NUMQ
  MEM0 = MEM0+NUMQ*NNBSTR(ISYM,2)
  LEFT = MEM-MEM0
end if

end subroutine CHO_QUALIFY_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      Subroutine OpnFls_SCF
************************************************************************
*                                                                      *
*     purpose: Open files needed by SCF                                *
*                                                                      *
*     called from: SCF                                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
#include "file.fh"

#include "mxdm.fh"
#include "infscf.fh"
*
*---- Define local variables
      Logical test

*---  open two-electron integral file ---------------------------------*
      Call f_Inquire(FnOrd,test)
      Call DecideOnDirect(.True.,test,DSCF,DoCholesky)
      If (.Not.DSCF .And. .Not.DoCholesky) Then
*        InVec=0
         iRc=-1
         iOpt=0
         Call OpnOrd(iRC,iOpt,FnOrd,LuOrd)
         If (iRc.ne.0) Then
            Write (6,*) 'OpnFls: Error opening ORDINT'
            Call Abend()
         End If
      End If
*
*---  open DNSMAT, dVxcdR, TWOHAM and GRADIENT ------------------------*
      Call DAName(LuDSt,FnDSt)
      Call DAName(LuOSt,FnOSt)
      Call DAName(LuTSt,FnTSt)
      Call DAName(LuGrd,FnGrd)
*
*---  open 2nd order update files      --------------------------------*
      Call DAName(LuDGd,FnDGd)
      Call DAName(Lux,Fnx)
      Call DAName(LuDel,FnDel)
      Call DAName(Luy,Fny)
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               1996, Per Ake Malmqvist                                *
!***********************************************************************

subroutine Drv1El()
!***********************************************************************
!                                                                      *
! Object: driver for computation of one-electron matrices.             *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January 1991                                             *
!***********************************************************************

use AMFI_Info, only: No_AMFI
use Basis_Info, only: dbsc, nCnttp, PAMexp
use GeoList, only: Centr, Chrg
use MpmC, only: Coor_MpM
use PrpPnt, only: Den, Occ, Vec
use External_Centers, only: Dxyz, AMP_Center, EF_Centers, DMS_Centers, nDMS, nEF, nOrdEF, nOrd_XF, nWel, OAM_Center, OMQ_Center, &
                            Wel_Info, XF
use Symmetry_Info, only: iChBas
use Gateway_global, only: Primitive_Pass, PrPrt, Short, SW_FileOrb
use PAM2, only: iPAMcount, iPAMPrim, kCnttpPAM
use DKH_Info, only: BSS, DKroll
use Sizes_of_Seward, only: S
use Gateway_Info, only: Do_FckInt, DoFMM, EMFR, GIAO, kVector, lAMFI, lMXTC, lRel, NEMO, PotNuc, Vlct
#ifdef _FDE_
use Embedding_Global, only: embInt, embPot, embPotInBasis, embPotPath
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
#include "print.fh"
#include "wldata.fh"
#include "property_label.fh"
#include "oneswi.fh"
#include "warnings.h"
integer(kind=iwp) :: i, i2, i3, iAddr, iAtom_Number, iB, iC, iChO, iChO1, iChO2, iChOx, iChOxx, iChOxy, iChOxz, iChOy, iChOyx, &
                     iChOyy, iChOyz, iChOz, iChOzx, iChOzy, iChOzz, iCnt, iCnttp, iComp, iD, iDisk, iDMS, idum(1), iEF, iLow, &
                     iMltpl, iOpt, iPAMBas, iPAMf, iPAMltpl, iPrint, iRC, iRout, iSym, iSymBx, iSymBy, iSymBz, iSymC, iSymCX, &
                     iSymCXY, iSymCy, iSymCz, iSymD, iSymLx, iSymLy, iSymLz, iSymR(0:3), iSymRx, iSymRy, iSymRz, iSymX, iSymxLx, &
                     iSymxLy, iSymxLz, iSymXY, iSymXZ, iSymY, iSymyLx, iSymyLy, iSymyLz, iSymYZ, iSymZ, iSymzLx, iSymzLy, iSymzLz, &
                     iSyXYZ, iTemp, iTol, iWel, ix, ixyz, iy, iz, jx, jxyz, jy, jz, kCnttpPAM_, lOper, LuTmp, mCnt, mComp, mDMS, &
                     mMltpl, mOrdOp, nB, nComp, nOrdOp, nPAMltpl
real(kind=wp) :: Ccoor(3), dum(1), Fact, rHrmt
logical(kind=iwp) :: lECPnp, lECP, lPAM2np, lPAM2, lPP, lFAIEMP
character(len=8) :: Label
character(len=512) :: FName
integer(kind=iwp), external :: IrrFnc, MltLbl, n2Tri
! ipList: list of pointers to the integrals of each component
!         of the operator
! OperI: list which irreps a particular component of the operator
!        belongs to
! OperC: list the character of each component of the operator
! CoorO: list of origins of the operator, one for each component
integer(kind=iwp), allocatable :: ipList(:), OperI(:), OperC(:), iAtmNr2(:)
real(kind=wp), allocatable :: CoorO(:), Nuc(:), KnE_Int(:), NA_Int(:), FragP(:), OneHam(:), PtEl(:), PtNuc(:), SumEl(:), &
                              SumNuc(:), Charge2(:)
external :: MltInt, KnEInt, MVeInt, VeInt, D1Int, NAInt, EFInt, OAMInt, OMQInt, DMSInt, WelInt, XFdInt, PrjInt, QpVInt, M1Int, &
            M2Int, SROInt, AMPInt, PXPInt, PXInt, VPInt, PPInt, CntInt, EMFInt, MltInt_GIAO, KneInt_GIAO, NAInt_GIAO, &
            dTdmu_Int, PAM2Int, FragPint, P_Int, EPEInt
external :: MltMem, KnEMem, MVeMem, VeMem, D1Mem, NAMem, EFMem, OAMMem, OMQMem, DMSMem, WelMem, XFdMem, PrjMem, QpVMem, M1Mem, &
            M2Mem, SROMem, AMPMem, PXPmem, PXMem, VPMem, PPMem, CntMem, EMFMem, MltMem_GIAO, KneMem_GIAO, NAMem_GIAO, &
            dTdmu_Mem, PAM2Mem, FragPMem, P_Mem, EPEMem
#ifdef _FDE_
! Embedding
integer(kind=iwp) :: iEMb, iunit
real(kind=wp), allocatable :: Emb_Int(:)
integer(kind=iwp), external :: isFreeUnit
external :: embPotKernel, embPotMem
#endif
#ifdef _GEN1INT_
integer(kind=iwp) :: nAtoms, jCnt
external :: DumInt, DumMem ! These won't actually be called, but need to be passed around
#endif

iRout = 131
iPrint = nPrint(iRout)

call StatusLine(' Seward:',' Computing 1-electron integrals')

call Set_Basis_Mode('Valence')
call Setup_iSD()
#ifdef _FDE_
if (embPot) call EmbPotRdRun()
#endif

lPAM2 = .false.
lECP = .false.
lPP = .false.
lFAIEMP = .false.
do i=1,nCnttp
  lPam2 = lPam2 .or. dbsc(i)%lPam2
  lECP = lECP .or. dbsc(i)%ECP
  lPP = lPP .or. (dbsc(i)%nPP /= 0)
  lFAIEMP = lFAIEMP .or. dbsc(i)%Frag
end do

! set center selector in OneSwi to all centers (default)

NDDO = .false.
if (Prprt .and. DKroll) then
  call WarningMessage(2,'Prprt and DKroll options can not be combined!')
  call Quit_OnUserError()
end if

! We will always compute the following one-electron integrals per default.
! 1) Multipole moments up to quadrupole moments
! 2) Kinetic energy
! 3) Nuclear Attraction
! 4) ECP contributions
! 5) One-Electron Hamiltonian
! 6) Mass-Velocity
! 7) Darwin 1-electron contact term

lECPnp = lECP
lPAM2np = lPAM2
if (DKroll .and. Primitive_Pass) then
  lECPnp = .false.
end if
if (Prprt) then
  FName = SW_FileOrb
  call GetDens(trim(FName),short,iPrint)
  call CollapseOutput(1,'   Molecular properties:')
  write(u6,'(3X,A)') '   ---------------------'
  write(u6,*)
end if
!***********************************************************************
!***********************************************************************
!1)                                                                    *
!                                                                      *
!     Multipole Moments starting with the overlap. If SEWARD is run in *
!     the property mode we will skip the overlap integrals.            *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = One
iLow = 0
mMltpl = S%nMltpl
if (Prprt) iLow = 1

! If not Douglas-Kroll and primitive pass do no property integrals

if (Primitive_Pass) then
  iLow = 0
  if (.not. DKroll) mMltpl = -1
end if

do iMltpl=iLow,S%nMltpl
  write(Label,'(A,I2)') 'Mltpl ',iMltpl
  nComp = (iMltpl+1)*(iMltpl+2)/2
  call DCopy_(3,Coor_MPM(1,iMltpl+1),1,Ccoor,1)
  call Allocate_Auxiliary()
  iComp = 0
  do ix=iMltpl,0,-1
    if (mod(ix,2) == 0) then
      iSymX = 1
    else
      ixyz = 1
      iSymX = 2**IrrFnc(ixyz)
      if (Ccoor(1) /= Zero) iSymX = ibset(iSymX,0)
    end if
    do iy=iMltpl-ix,0,-1
      if (mod(iy,2) == 0) then
        iSymY = 1
      else
        ixyz = 2
        iSymY = 2**IrrFnc(ixyz)
        if (Ccoor(2) /= Zero) iSymY = ibset(iSymY,0)
      end if
      iz = iMltpl-ix-iy
      if (mod(iz,2) == 0) then
        iSymZ = 1
      else
        ixyz = 4
        iSymZ = 2**IrrFnc(ixyz)
        if (Ccoor(3) /= Zero) iSymZ = ibset(iSymZ,0)
      end if
      iChO = mod(ix,2)*iChBas(2)+mod(iy,2)*iChBas(3)+mod(iz,2)*iChBas(4)

      OperI(1+iComp) = MltLbl(iSymX,MltLbl(iSymY,iSymZ))
      OperC(1+iComp) = iChO
      call DCopy_(3,Coor_MPM(1,iMltpl+1),1,CoorO(1+iComp*3),1)
      iComp = iComp+1
    end do
  end do

  call MltNuc(CoorO,Chrg,Centr,S%kCentr,Nuc,iMltpl,nComp)
  !--- pow hack
  if (iMltpl == 0) then
    call Put_dScalar('Total Nuclear Charge',Nuc(1))
  end if
  !--- pow hack
  nOrdOp = iMltpl
  call OneEl(MltInt,MltMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Write FMM multipole moments to disk

  if ((.not. Prprt) .and. DoFMM) then
    write(Label,'(A,I2)') 'FMMInt',iMltpl
    call OneEl(MltInt,MltMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

    ! FMM overlap distribution centres:
    ! Pretend they are 1-e integrals with three (x,y,z)
    ! components and write to disk in canonical order

    if (iMltpl == 0) then
      write(Label,'(A)') 'FMMCnX'
      call OneEl(MltInt,MltMem,Label,ipList,OperI,nComp,CoorO,nOrdOp+1,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
      write(Label,'(A)') 'FMMCnY'
      call OneEl(MltInt,MltMem,Label,ipList,OperI,nComp,CoorO,nOrdOp+1,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
      write(Label,'(A)') 'FMMCnZ'
      call OneEl(MltInt,MltMem,Label,ipList,OperI,nComp,CoorO,nOrdOp+1,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! For picture-change corrected integrals.

  if (DKroll .and. Primitive_Pass) then
    write(Label,'(A,I2)') 'pMp   ',iMltpl
    PLabel = 'MltInt'
    call FZero(Nuc,nComp)
    call OneEl(PXPInt,PXPMem,Label,ipList,OperI,nComp,CoorO,nOrdOp+2,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (iMltpl == 0) then
    ! these are overlap integrals...
    ! set center selector in OneSwi to single center...
    NDDO = .true.
    write(Label,'(A,I2)') 'MltplS',iMltpl
    call OneEl(MltInt,MltMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
    ! reset center selector in OneSwi to all centers...
    NDDO = .false.
  end if

  call Deallocate_Auxiliary()

end do
!***********************************************************************
!***********************************************************************
!1a)                                                                   *
!                                                                      *
!     PAM integrals                                                    *
!                                                                      *
!***********************************************************************
!***********************************************************************
if (lPAM2np .and. (.not. Primitive_Pass)) then
  call molcas_open(28,'R_vect')
  PLabel = ' '
  rHrmt = One
  iPAMcount = 1
  do kCnttpPAM_=1,nCnttp

    kCnttpPAM = kCnttpPAM_
    nPAMltpl = dbsc(kCnttpPAM)%nPAM2

    if (nPAMltpl < 0) cycle

    iAddr = 1
    do iPAMltpl=0,nPAMltpl
      nOrdOp = iPAMltpl
      nComp = (iPAMltpl+1)*(iPAMltpl+2)/2
      iPAMPrim = int(dbsc(kCnttpPAM)%PAM2(iAddr))
      iPAMBas = int(dbsc(kCnttpPAM)%PAM2(iAddr+1))

      if ((iPAMBas /= 0) .and. (iPAMPrim /= 0)) then
        Ccoor(:) = Zero
        call Allocate_Auxiliary()
        do iComp=0,nComp-1
          call dcopy_(3,dbsc(kCnttpPAM)%Coor,1,CoorO(1+3*iComp),1)
        end do

        !**** Define symmetry properties of the operator:

        iComp = 0
        do ix=iPAMltpl,0,-1
          if (mod(ix,2) == 0) then
            iSymX = 1
          else
            ixyz = 1
            iSymX = 2**IrrFnc(ixyz)
            if (Ccoor(1) /= Zero) iSymX = ibset(iSymX,0)
          end if
          do iy=iPAMltpl-ix,0,-1
            if (mod(iy,2) == 0) then
              iSymY = 1
            else
              ixyz = 2
              iSymY = 2**IrrFnc(ixyz)
              if (Ccoor(2) /= Zero) iSymY = ibset(iSymY,0)
            end if
            iz = iPAMltpl-ix-iy
            if (mod(iz,2) == 0) then
              iSymZ = 1
            else
              ixyz = 4
              iSymZ = 2**IrrFnc(ixyz)
              if (Ccoor(3) /= Zero) iSymZ = ibset(iSymZ,0)
            end if
            iChO = mod(ix,2)*iChBas(2)+mod(iy,2)*iChBas(3)+mod(iz,2)*iChBas(4)

            OperC(1+iComp) = iChO
            OperI(1+iComp) = 1

            iComp = iComp+1
          end do
        end do

        !**** Loop over basis functions

        call mma_allocate(PAMexp,iPAMPrim,2,label='PAMexp')
        call dcopy_(iPAMPrim,dbsc(kCnttpPAM)%PAM2(iAddr+2),1,PAMexp(1,1),1)
        do iPAMf=1,iPAMBas
          call dcopy_(iPAMPrim,dbsc(kCnttpPAM)%PAM2(iAddr+2+iPAMPrim*iPAMf),1,PAMexp(1,2),1)
          write(Label,'(A,I2.2,I1.1,I2.2)') 'PAM',kCnttpPAM,iPAMltpl,iPAMf

          call dcopy_(nComp,[Zero],0,Nuc,1)

          call OneEl(PAM2Int,PAM2Mem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

          !iPAMcount = iPAMcount+1

        end do
        call mma_deallocate(PAMexp)
        call Deallocate_Auxiliary()
      end if
      iAddr = iAddr+2+iPAMPrim*(iPAMBas+1)
    end do
  end do
  close(28)
end if
!***********************************************************************
!***********************************************************************
!2)                                                                    *
!                                                                      *
!     Kinetic energy, nuclear attraction and ECP/PP integrals          *
!                                                                      *
!     Mass-velocity and One-electron Darwin contact term integrals.    *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = One
nComp = 1

if (.not. Prprt) then
  call Allocate_Auxiliary()
  call dcopy_(3,[Zero],0,CoorO,1)
  OperI(1) = 1
  OperC(1) = iChBas(1)

  Label = 'Kinetic '
  nOrdOp = 2
  call OneEl(KnEInt,KnEMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  nOrdOp = 0

  Label = 'Attract '
  call OneEl(NAInt,NAMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[PotNuc],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

# ifdef _FDE_
  ! Embedding
  if (embPot) then
    Label = 'Embpot '
    call OneEl(EmbPotKernel,EmbPotMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
  end if
# endif

  ! set center selector in OneSwi to two center NA Int...
  NDDO = .true.
  Label = 'AttractS'
  call OneEl(NAInt,NAMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[PotNuc],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
  ! reset center selector in OneSwi to all centers...
  NDDO = .false.
  if (.not. Primitive_Pass) then
    if (lECPnp) then
      Label = 'PrjInt  '
      call OneEl(PrjInt,PrjMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
      Label = 'M1Int   '
      call OneEl(M1Int,M1Mem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
      Label = 'M2Int   '
      call OneEl(M2Int,M2Mem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
      Label = 'SROInt  '
      call OneEl(SROInt,SROMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
    end if
    if (lPP) then
      Label = 'PPInt   '
      call OneEl(PPInt,PPMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
    end if
    if (allocated(XF)) then
      mOrdOp = nOrd_XF
      Label = 'XFdInt  '
      call OneEl(XFdInt,XFdMem,Label,ipList,OperI,nComp,CoorO,mOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
    end if
    if (lRel) then
      Label = 'MassVel '
      nOrdOp = 4
      call OneEl(MVeInt,MVeMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
      Label = 'Darwin  '
      nOrdOp = 0
      call OneEl(D1Int,D1Mem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
    end if
  end if

  call Deallocate_Auxiliary()
end if
!***********************************************************************
!***********************************************************************
!8a)                                                                   *
!                                                                      *
!     Velocity integrals.                                              *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = -One
if (Vlct .and. (.not. Primitive_Pass)) then
  nOrdOp = 1
  Label = 'Velocity'
  nComp = 3
  call Allocate_Auxiliary()
  call dcopy_(3*nComp,[Zero],0,CoorO,1)
  ixyz = 1
  OperI(1) = 2**IrrFnc(ixyz)
  OperC(1) = iChBas(2)
  ixyz = 2
  OperI(1+1) = 2**IrrFnc(ixyz)
  OperC(1+1) = iChBas(3)
  ixyz = 4
  OperI(1+2) = 2**IrrFnc(ixyz)
  OperC(1+2) = iChBas(4)

  call dcopy_(3,[Zero],0,Nuc,1)
  call OneEl(VeInt,VeMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()
end if    ! Vlct
!***********************************************************************
!***********************************************************************
!8b)                                                                   *
!                                                                      *
!     Electromagnetic field radiation integrals.                       *
!                                                                      *
!     Note that the integral is not symmetric or antisymmetric!        *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = -One ! Note used
if (EMFR .and. (.not. Primitive_Pass)) then

  ! The second term in eq. 14 of Bernadotte et al

  nOrdOp = 0
  Label = 'EMFR0'
  nComp = 2
  call Allocate_Auxiliary()
  ! Here we put in the k-vector
  call FZero(CoorO,3*nComp)
  call dcopy_(3,KVector,1,CoorO,1)

  ! The electromagnetic field operator contributes to all
  ! irreducible irreps, hence OperI=255. Since the operator
  ! itself is not symmetry adapted OperC is set to a dummy value.

  OperI(1) = 255
  OperI(1+1) = 255
  OperC(1) = 0 ! Dummy
  OperC(1+1) = 0 ! Dummy

  call dcopy_(nComp,[Zero],0,Nuc,1)
  call OneEl(EMFInt,EMFMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()

  ! The first (dominating) term in eq. 14 of Bernadotte et al

  nOrdOp = 1
  Label = 'EMFR'
  nComp = 12
  call Allocate_Auxiliary()
  ! Here we put in the k-vector
  call FZero(CoorO,3*nComp)
  call dcopy_(3,KVector,1,CoorO,1)

  ! The electromagnetic field operator contributes to all
  ! irreducible irreps, hence OperI=255. Since the operator
  ! itself is not symmetry adapted OperC is set to a dummy value.

  OperI(1) = 255
  OperI(1+1) = 255
  OperI(1+2) = 255
  OperI(1+3) = 255
  OperI(1+4) = 255
  OperI(1+5) = 255
  OperI(1+6) = 255
  OperI(1+7) = 255
  OperI(1+8) = 255
  OperI(1+9) = 255
  OperI(1+10) = 255
  OperI(1+11) = 255
  OperC(1) = 0 ! Dummy
  OperC(1+1) = 0 ! Dummy
  OperC(1+2) = 0 ! Dummy
  OperC(1+3) = 0 ! Dummy
  OperC(1+4) = 0 ! Dummy
  OperC(1+5) = 0 ! Dummy
  OperC(1+6) = 0 ! Dummy
  OperC(1+7) = 0 ! Dummy
  OperC(1+8) = 0 ! Dummy
  OperC(1+9) = 0 ! Dummy
  OperC(1+10) = 0 ! Dummy
  OperC(1+11) = 0 ! Dummy

  call dcopy_(nComp,[Zero],0,Nuc,1)
  call OneEl(EMFInt,EMFMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()
end if    ! EMFR
!***********************************************************************
!***********************************************************************
!9)                                                                    *
!10)                                                                   *
!                                                                      *
!     Electric field integrals.                                        *
!     Electric field gradient integrals.                               *
!                                                                      *
!***********************************************************************
!***********************************************************************
ixyz = 1
iSymX = 2**IrrFnc(ixyz)
ixyz = 2
iSymY = 2**IrrFnc(ixyz)
ixyz = 4
iSymZ = 2**IrrFnc(ixyz)
ixyz = 3
iSymXY = 2**IrrFnc(ixyz)
ixyz = 5
iSymXZ = 2**IrrFnc(ixyz)
ixyz = 6
iSymYZ = 2**IrrFnc(ixyz)
ixyz = 7
iSyXYZ = 2**IrrFnc(ixyz)

PLabel = ' '
rHrmt = One
do nOrdOp=0,nOrdEF

  nComp = (nOrdOp+1)*(nOrdOp+2)/2

  call Allocate_Auxiliary()

  do iEF=1,nEF

    ! Note that this parsing is a bit different here!

    write(Label,'(A,I1,I5)') 'EF',nOrdOp,iEF
    Ccoor(:) = EF_Centers(:,iEF)

    iSymR(0) = 1
    if (Ccoor(1) /= Zero) iSymR(0) = ior(iSymR(0),iSymX)
    if (Ccoor(2) /= Zero) iSymR(0) = ior(iSymR(0),iSymY)
    if (Ccoor(3) /= Zero) iSymR(0) = ior(iSymR(0),iSymZ)
    if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero)) iSymR(0) = ior(iSymR(0),iSymXY)
    if ((Ccoor(1) /= Zero) .and. (Ccoor(3) /= Zero)) iSymR(0) = ior(iSymR(0),iSymXZ)
    if ((Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymR(0) = ior(iSymR(0),iSymYZ)
    if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymR(0) = ior(iSymR(0),iSyXYZ)

    ixyz = 1
    iSym = 2**IrrFnc(ixyz)
    if (Ccoor(1) /= Zero) iSym = ibset(iSym,0)
    iSymR(1) = iSym

    ixyz = 2
    iSym = 2**IrrFnc(ixyz)
    if (Ccoor(2) /= Zero) iSym = ibset(iSym,0)
    iSymR(2) = iSym

    ixyz = 4
    iSym = 2**IrrFnc(ixyz)
    if (Ccoor(3) /= Zero) iSym = ibset(iSym,0)
    iSymR(3) = iSym

    iComp = 0
    do ix=nOrdOp,0,-1
      do iy=nOrdOp-ix,0,-1
        iz = nOrdOp-ix-iy
        iComp = iComp+1

        iSymX = 1
        if (mod(ix,2) /= 0) iSymX = iSymR(1)
        iSymCX = MltLbl(iSymR(0),iSymX)
        iSymY = 1
        if (mod(iy,2) /= 0) iSymY = iSymR(2)
        iSymCXY = MltLbl(iSymCX,iSymY)
        iSymZ = 1
        if (mod(iz,2) /= 0) iSymZ = iSymR(3)

        OperI(1+(iComp-1)) = MltLbl(iSymCXY,iSymZ)
        OperC(1+(iComp-1)) = mod(ix,2)*iChBas(2)+mod(iy,2)*iChBas(3)+mod(iz,2)*iChBas(4)

        call dcopy_(3,Ccoor,1,CoorO(1+(iComp-1)*3),1)
      end do
    end do

    call EFNuc(CoorO,Chrg,Centr,S%kCentr,Nuc,nOrdOp)
    call OneEl(EFInt,EFMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! For picture-change corrected property integrals.

    if (DKroll .and. Primitive_Pass) then
      write(Label,'(A,I1,I5)') 'PP',nOrdOp,iEF
      PLabel = 'EFInt '
      call FZero(Nuc,nComp)
      call OneEl(PXPInt,PXPMem,Label,ipList,OperI,nComp,CoorO,nOrdOp+2,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end do
  call Deallocate_Auxiliary()

  ! For a properties calculation, read the EF values saved in a temp file
  ! and write the sum through Add_Info

  if (PrPrt .and. (nEF > 0)) then
    call mma_allocate(PtEl,nComp,label='PtEl')
    call mma_allocate(PtNuc,nComp,label='PtNuc')
    call mma_allocate(SumEl,nComp,label='SumEl')
    call mma_allocate(SumNuc,nComp,label='SumNuc')
    call FZero(SumEl,nComp)
    call FZero(SumNuc,nComp)
    ! Read and sum the values
    LuTmp = 10
    call DaName(LuTmp,'TMPPRP')
    iDisk = 0
    do iEf=1,nEF
      call dDaFile(LuTmp,2,PtEl,nComp,iDisk)
      call dDaFile(LuTmp,2,PtNuc,nComp,iDisk)
      call DaXpY_(nComp,One,PtEl,1,SumEl,1)
      call DaXpY_(nComp,One,PtNuc,1,SumNuc,1)
    end do
    call DaClos(LuTmp)
    ! set the tolerance according to the total number of centers
    ! (assuming error scales with sqrt(nEF))
    iTol = 5
    iTol = iTol-nint(Half*log10(real(nEF,kind=wp)))
    write(label,'(a,i1,a)') 'EF',nOrdOp,'   el'
    call Add_Info(label,SumEl,nComp,iTol)
    write(label,'(a,i1,a)') 'EF',nOrdOp,'  nuc'
    call Add_Info(label,SumNuc,nComp,iTol)
    call mma_deallocate(PtEl)
    call mma_deallocate(PtNuc)
    call mma_deallocate(SumEl)
    call mma_deallocate(SumNuc)
  end if

end do
!***********************************************************************
!***********************************************************************
!12)                                                                   *
!                                                                      *
!     Orbital angular momentum integrals.                              *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = -One
if (allocated(OAM_Center) .and. (.not. Primitive_Pass)) then
  Label = 'AngMom  '
  nComp = 3
  nOrdOp = 2
  call Allocate_Auxiliary()
  call dcopy_(3,OAM_Center,1,CoorO(1),1)
  call dcopy_(3,OAM_Center,1,CoorO(1+3),1)
  call dcopy_(3,OAM_Center,1,CoorO(1+6),1)
  call dcopy_(3,OAM_Center,1,Ccoor,1)
  ixyz = 1
  iSymX = 2**IrrFnc(ixyz)
  ixyz = 2
  iSymY = 2**IrrFnc(ixyz)
  ixyz = 4
  iSymZ = 2**IrrFnc(ixyz)
  iSymCx = iSymX
  if (Ccoor(1) /= Zero) iSymCx = ibset(iSymCx,0)
  iSymCy = iSymY
  if (Ccoor(2) /= Zero) iSymCy = ibset(iSymCy,0)
  iSymCz = iSymZ
  if (Ccoor(3) /= Zero) iSymCz = ibset(iSymCz,0)

  iSymLx = ior(MltLbl(iSymCy,iSymZ),MltLbl(iSymCz,iSymY))
  iChOx = iChBas(3)+iChBas(4)
  OperI(1) = iSymLx
  OperC(1) = iChOx
  iSymLy = ior(MltLbl(iSymCz,iSymX),MltLbl(iSymCx,iSymZ))
  iChOy = iChBas(4)+iChBas(2)
  OperI(1+1) = iSymLy
  OperC(1+1) = iChOy
  iSymLz = ior(MltLbl(iSymCx,iSymY),MltLbl(iSymCy,iSymX))
  iChOz = iChBas(2)+iChBas(3)
  OperI(1+2) = iSymLz
  OperC(1+2) = iChOz

  call dcopy_(nComp,[Zero],0,Nuc,1)
  call OneEl(OAMInt,OAMMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()
end if   ! OAM_Center
!***********************************************************************
!***********************************************************************
!12b)                                                                  *
!                                                                      *
!     Velocity quadrupole.                                             *
!     (the companion symmetric combination to the angular momentum)    *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = -One
if (Vlct .and. (S%nMltpl >= 2) .and. (.not. Primitive_Pass)) then
  Label = 'MLTPV  2'
  nComp = 6
  nOrdOp = 2
  call Allocate_Auxiliary()

  ! Use origin for quadrupole moment
  call DCopy_(nComp,Coor_MPM(1,3),0,CoorO(1),3)
  call DCopy_(nComp,Coor_MPM(2,3),0,CoorO(1+1),3)
  call DCopy_(nComp,Coor_MPM(3,3),0,CoorO(1+2),3)
  call dCopy_(3,Coor_MPM(1,3),1,Ccoor,1)

  ixyz = 1
  iSymX = 2**IrrFnc(ixyz)
  ixyz = 2
  iSymY = 2**IrrFnc(ixyz)
  ixyz = 4
  iSymZ = 2**IrrFnc(ixyz)
  iSymCx = iSymX
  if (Ccoor(1) /= Zero) iSymCx = ibset(iSymCx,0)
  iSymCy = iSymY
  if (Ccoor(2) /= Zero) iSymCy = ibset(iSymCy,0)
  iSymCz = iSymZ
  if (Ccoor(3) /= Zero) iSymCz = ibset(iSymCz,0)

  ! Calculates QpV_ij = r_i*p_j+p_i*r_j (or rater p -> nabla)

  ! QpVxx
  OperI(1) = MltLbl(iSymCx,iSymX)
  OperC(1) = iChBas(2)
  ! QpVxy
  OperI(1+1) = MltLbl(iSymCx,iSymY)
  OperC(1+1) = iChBas(2)+iChBas(3)
  ! QpVxz
  OperI(1+2) = MltLbl(iSymCx,iSymZ)
  OperC(1+2) = iChBas(2)+iChBas(4)
  ! QpVyy
  OperI(1+3) = MltLbl(iSymCy,iSymY)
  OperC(1+3) = iChBas(3)
  ! QpVyz
  OperI(1+4) = MltLbl(iSymCy,iSymZ)
  OperC(1+4) = iChBas(3)+iChBas(4)
  ! QpVzz
  OperI(1+5) = MltLbl(iSymCz,iSymZ)
  OperC(1+5) = iChBas(4)

  call DCopy_(nComp,[Zero],0,Nuc,1)
  call OneEl(QpVInt,QpVMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()
end if   ! Vlct .and. (S%nMltpl > 2)
!***********************************************************************
!***********************************************************************
!12c)                                                                  *
!                                                                      *
!     Orbital Magnetic Quadrupole integrals.                           *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = -One
if (allocated(OMQ_Center) .and. (.not. Primitive_Pass)) then
  Label = 'OMQ     '
  nComp = 9
  nOrdOp = 3
  call Allocate_Auxiliary()

  call dcopy_(nComp,[OMQ_Center(1)],0,CoorO(1),3)
  call dcopy_(nComp,[OMQ_Center(2)],0,CoorO(1+1),3)
  call dcopy_(nComp,[OMQ_Center(3)],0,CoorO(1+2),3)
  Ccoor(:) = OMQ_Center(:)

  ixyz = 1
  iSymX = 2**IrrFnc(ixyz)
  ixyz = 2
  iSymY = 2**IrrFnc(ixyz)
  ixyz = 4
  iSymZ = 2**IrrFnc(ixyz)
  iSymCx = iSymX
  if (Ccoor(1) /= Zero) iSymCx = ibset(iSymCx,0)
  iSymCy = iSymY
  if (Ccoor(2) /= Zero) iSymCy = ibset(iSymCy,0)
  iSymCz = iSymZ
  if (Ccoor(3) /= Zero) iSymCz = ibset(iSymCz,0)

  iSymLx = ior(MltLbl(iSymCy,iSymZ),MltLbl(iSymCz,iSymY))
  iSymLy = ior(MltLbl(iSymCz,iSymX),MltLbl(iSymCx,iSymZ))
  iSymLz = ior(MltLbl(iSymCx,iSymY),MltLbl(iSymCy,iSymX))

  ! Calculates M_ij = r_j*L_i + L_i*r_j = 2*r_j*L_i + i hbar E_ijk r_k
  ! Since the i hbar is included outside we could do
  ! M_ij = r_j*L_i + L_i*r_j = 2*r_j*L_i + E_ijk r_k
  ! We use all nine components even if we only need 6 of these later.

  ! Mxx
  iSymxLx = MltLbl(iSymCx,iSymLx)
  iChOxx = iChBas(15)
  OperI(1) = iSymxLx
  OperC(1) = iChOxx
  ! Mxy
  iSymxLy = iSymCz
  iChOxy = iChBas(4)
  OperI(1+1) = iSymxLy
  OperC(1+1) = iChOxy
  ! Mxz
  iSymxLz = iSymCy
  iChOxz = iChBas(3)
  OperI(1+2) = iSymxLz
  OperC(1+2) = iChOxz
  ! Myx
  iSymyLx = iSymCz
  iChOyx = iChBas(4)
  OperI(1+3) = iSymyLx
  OperC(1+3) = iChOyx
  ! Myy
  iSymyLy = MltLbl(iSymCy,iSymLy)
  iChOyy = iChBas(15)
  OperI(1+4) = iSymyLy
  OperC(1+4) = iChOyy
  ! Myz
  iSymyLz = iSymCx
  iChOyz = iChBas(4)
  OperI(1+5) = iSymyLz
  OperC(1+5) = iChOyz
  ! Mzx
  iSymzLx = iSymCy
  iChOzx = iChBas(3)
  OperI(1+6) = iSymzLx
  OperC(1+6) = iChOzx
  ! Mzy
  iSymzLy = iSymCx
  iChOzy = iChBas(4)
  OperI(1+7) = iSymzLy
  OperC(1+7) = iChOzy
  ! Mzz
  iSymzLz = MltLbl(iSymCz,iSymLz)
  iChOzz = iChBas(15)
  OperI(1+8) = iSymzLz
  OperC(1+8) = iChOzz

  call DCopy_(nComp,[Zero],0,Nuc,1)
  call OneEl(OMQInt,OMQMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()
end if   ! OMQ_Center
!***********************************************************************
!***********************************************************************
!13)                                                                   *
!                                                                      *
!***********************************************************************
!***********************************************************************
if (DKroll .and. Primitive_Pass) then
  rHrmt = One
  Label = 'pVp     '
  PLabel = 'NAInt '
  nOrdOp = 2
  nComp = 1
  call Allocate_Auxiliary()
  call dcopy_(3,[Zero],0,CoorO,1)
  OperI(1) = 1
  OperC(1) = iChBas(1)

  call dcopy_(nComp,[Zero],0,Nuc,1)
  call OneEl(PXPInt,PXPMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()

  if (BSS) then
    rHrmt = -One
    nOrdOp = 1
    nComp = 3
    call Allocate_Auxiliary()

    call dcopy_(3*nComp,[Zero],0,CoorO,1)
    call dcopy_(3,[Zero],0,Nuc,1)

    ixyz = 1
    OperI(1) = 2**IrrFnc(ixyz)
    OperC(1) = iChBas(2)
    ixyz = 2
    OperI(1+1) = 2**IrrFnc(ixyz)
    OperC(1+1) = iChBas(3)
    ixyz = 4
    OperI(1+2) = 2**IrrFnc(ixyz)
    OperC(1+2) = iChBas(4)

    Label = 'pV      '
    PLabel = 'NAInt '
    call OneEl(PXInt,PXMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

    Label = 'Vp      '
    call OneEl(VPInt,VPMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

    call Deallocate_Auxiliary()
  end if    ! BSS
end if
!***********************************************************************
!***********************************************************************
!14)                                                                   *
!                                                                      *
!     Diamagnetic shielding integrals.                                 *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = One

mDMS = nDMS
if (Primitive_Pass) mDMS = 0

do iDMS=1,mDMS
  write(Label,'(A,I2,I2)') 'DMS ',1,iDMS
  nComp = 9
  nOrdOp = 2
  CCoor(:) = DMS_Centers(:,iDMS)
  call Allocate_Auxiliary()
  iSymC = 1
  if (Ccoor(1) /= Zero) iSymC = ior(iSymC,iSymX)
  if (Ccoor(2) /= Zero) iSymC = ior(iSymC,iSymY)
  if (Ccoor(3) /= Zero) iSymC = ior(iSymC,iSymZ)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero)) iSymC = ior(iSymC,iSymXY)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ior(iSymC,iSymXZ)
  if ((Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ior(iSymC,iSymYZ)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ior(iSymC,iSyXYZ)

  iComp = 0
  iC = 0
  do ix=1,0,-1
    do iy=1-ix,0,-1
      iz = 1-ix-iy
      iC = iC+1
      iChO1 = iChBas(iC+1)
      ixyz = 0
      if (mod(ix,2) /= 0) ixyz = ibset(ixyz,0)
      if (mod(iy,2) /= 0) ixyz = ibset(ixyz,1)
      if (mod(iz,2) /= 0) ixyz = ibset(ixyz,2)
      iSym = 2**IrrFnc(ixyz)
      if (Ccoor(iC) /= Zero) iSym = ibset(iSym,0)
      iD = 0
      do jx=1,0,-1
        do jy=1-jx,0,-1
          jz = 1-jx-jy
          iD = iD+1
          iChO2 = iChBas(iD+1)
          jxyz = 0
          if (mod(jx,2) /= 0) jxyz = ibset(jxyz,0)
          if (mod(jy,2) /= 0) jxyz = ibset(jxyz,1)
          if (mod(jz,2) /= 0) jxyz = ibset(jxyz,2)
          iSymD = 2**IrrFnc(jxyz)
          if (Dxyz(iD) /= Zero) iSymD = ibset(iSymD,0)
          if (iC == iD) then
            i2 = iD+1
            if (i2 > 3) i2 = i2-3
            i3 = iD+2
            if (i3 > 3) i3 = i3-3
            iChO = iand(iChBas(i2+1),iChBas(i3+1))
          else
            iChO = ior(iChO1,iChO2)
          end if
          OperI(1+iComp) = MltLbl(iSymD,MltLbl(iSym,iSymC))
          OperC(1+iComp) = iChO
          call dcopy_(3,Ccoor,1,CoorO(1+iComp*3),1)
          iComp = iComp+1
        end do
      end do
    end do
  end do
  call dcopy_(3,Dxyz,1,CoorO(1+3),1)

  call dcopy_(nComp,[Zero],0,Nuc,1)
  call OneEl(DMSInt,DMSMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()
end do
!***********************************************************************
!***********************************************************************
!15)                                                                   *
!                                                                      *
!     Nuclear attraction integrals for finite centers.                 *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = One
Label = 'Center  '
!***********************************************************************
!***********************************************************************
!16)                                                                   *
!                                                                      *
!     Spherical well integrals.                                        *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = One
if ((.not. Prprt) .and. (.not. Primitive_Pass)) then
  nComp = 1
  iWel = 0
  call Allocate_Auxiliary()
  call dcopy_(3,[Zero],0,CoorO,1)
  OperI(1) = 1
  OperC(1) = iChBas(1)
  do iWel=1,nWel
    r0 = Wel_Info(1,iWel)
    ExpB = Wel_Info(2,iWel)
    write(Label,'(A,I4)') 'Well',iWel
    call OneEl(WelInt,WelMem,Label,ipList,OperI,nComp,CoorO,iWel,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
  end do
  call Deallocate_Auxiliary()
end if  ! .not. Prprt
!***********************************************************************
!***********************************************************************
!5)                                                                    *
!                                                                      *
!     One-electron Hamiltonian integrals.                              *
!                                                                      *
!***********************************************************************
!***********************************************************************
if ((.not. Prprt) .and. (.not. Primitive_Pass)) then
  call mma_allocate(KnE_Int,n2Tri(1)+4,label='KnE_Int')
  call mma_allocate(NA_Int,n2Tri(1)+4,label='NA_Int')
# ifdef _FDE_
  ! Embedding
  if (embpot) call mma_allocate(Emb_Int,n2Tri(1)+4,label='Emb_Int')
# endif
  iOpt = 0
  lOper = 0
  iRC = -1
  Label = 'Kinetic '
  call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
  if (iRC /= 0) then
    call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
    call Quit(_RC_IO_ERROR_READ_)
  end if
  Label = 'Attract '
  lOper = 0
  iRC = -1
  call RdOne(iRC,iOpt,Label,1,NA_Int,lOper)
  if (iRC /= 0) then
    call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
    call Quit(_RC_IO_ERROR_READ_)
  end if
  call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
# ifdef _FDE_
  ! Embedding
  if (embpot) then
    if (embPotInBasis) then
      !write(u6,*) 'ENTER'
      ! If the potential is given in basis set representation it
      ! has not been calculated with a OneEl call and is just read
      ! from file here.
      iunit = isFreeUnit(1)
      call molcas_open(iunit,embPotPath)
      do iEmb=1,n2Tri(1)
        read(iunit,*) Emb_Int(iEmb)
        !write(u6,*) iEmb-1,': ',Emb_Int(iEmb)
      end do
      close(iunit)
    else
      Label = 'embpot  '
      lOper = 0
      iRC = -1
      call RdOne(iRC,iOpt,Label,1,Emb_Int,lOper)
      if (iRC /= 0) then
        call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
        call Quit(_RC_IO_ERROR_READ_)
      end if
    end if
    call DaXpY_(n2Tri(1)+4,One,Emb_Int,1,NA_Int,1)
  end if
# endif

  !--------Add contribution from ECP

  if (lECPnp) then
    Label = 'PrjInt  '
    lOper = 0
    iRC = -1
    call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
    if (iRC /= 0) then
      call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
      call Quit(_RC_IO_ERROR_READ_)
    end if
    call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
    Label = 'M1Int   '
    lOper = 0
    iRC = -1
    call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
    if (iRC /= 0) then
      call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
      call Quit(_RC_IO_ERROR_READ_)
    end if
    call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
    Label = 'M2Int   '
    lOper = 0
    iRC = -1
    call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
    if (iRC /= 0) then
      call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
      call Quit(_RC_IO_ERROR_READ_)
    end if
    call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
    Label = 'SROInt  '
    lOper = 0
    iRC = -1
    call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
    if (iRC /= 0) then
      call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
      call Quit(_RC_IO_ERROR_READ_)
    end if
    call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
  end if   ! lECPnp

  !--------Add contributions from the Pseudo Potential

  if (lPP) then
    Label = 'PPInt   '
    lOper = 0
    iRC = -1
    call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
    if (iRC /= 0) then
      call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
      call Quit(_RC_IO_ERROR_READ_)
    end if
    call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
  end if

  !--------Add contributions from the external field

  if (allocated(XF)) then
    Label = 'XFdInt  '
    lOper = 0
    iRC = -1
    call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
    if (iRC /= 0) then
      call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
      call Quit(_RC_IO_ERROR_READ_)
    end if
    call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
  end if ! XF

  !--------Add contributions from Spherical wells

  if (nWel /= 0) then
    do iWel=1,nWel
      Fact = Wel_Info(3,iWel)
      write(Label,'(A,I4)') 'Well',iWel
      lOper = 0
      iRC = -1
      call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
      if (iRC /= 0) then
        call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
        call Quit(_RC_IO_ERROR_READ_)
      end if
      call DaXpY_(n2Tri(1)+4,Fact,KnE_Int,1,NA_Int,1)
    end do
  end if  ! nWel /= 0

  Label = 'OneHam  '
  if (iPrint >= 10) call PrMtrx(Label,[lOper],1,[1],NA_Int)
  iRC = -1
  call WrOne(iRC,iOpt,Label,1,NA_Int,lOper)
  if (iRC /= 0) then
    call WarningMessage(2,'Drv1El: Error writing ONEINT;Label='//Label)
    call Quit(_RC_IO_ERROR_WRITE_)
  end if

# ifdef _FDE_
  ! Embedding
  if (embpot) then
    Label = 'embpot  '
    iRC = -1
    call WrOne(iRC,iOpt,Label,1,embInt,lOper)
    if (iRC /= 0) then
      call WarningMessage(2,'Drv1El: Error writing ONEINT;Label='//Label)
      call Quit(_RC_IO_ERROR_WRITE_)
    end if
  end if
# endif

  Label = 'OneHam 0'
  iRC = -1
  call WrOne(iRC,iOpt,Label,1,NA_Int,lOper)
  if (iRC /= 0) then
    call WarningMessage(2,'Drv1El: Error writing ONEINT;Label='//Label)
    call Quit(_RC_IO_ERROR_WRITE_)
  end if
  call mma_deallocate(NA_Int)
  call mma_deallocate(KnE_Int)

# ifdef _FDE_
  ! Embedding
  if (embPot) call mma_deallocate(Emb_Int)
# endif
end if
!***********************************************************************
!***********************************************************************
!17)                                                                   *
!                                                                      *
!     Angular momentum products (PAM)                                  *
!                                                                      *
!***********************************************************************
!***********************************************************************
! Hermitized products of angular momentum integrals
! Component(1) is Lx*Lx
! Component(2) is (Lx*Ly+Ly*Lx)/2, etc.
! Coded P-A Malmqvist, Garching, Nov 1996
PLabel = ' '
rHrmt = -One
if (allocated(AMP_Center) .and. (.not. Primitive_Pass)) then
  Label = 'AMProd  '
  nComp = 6
  nOrdOp = 2
  call Allocate_Auxiliary()
  call dcopy_(nComp,[AMP_Center(1)],0,CoorO(1),3)
  call dcopy_(nComp,[AMP_Center(2)],0,CoorO(1+1),3)
  call dcopy_(nComp,[AMP_Center(3)],0,CoorO(1+2),3)
  CCoor(:) = AMP_Center(:)
  ! Symmetry labels iSymX  for operator d/dx, etc.
  ! Symmetry labels iSymLx for operator Lx, etc.
  ! Characters iChOx for operator Lx, etc.
  ixyz = 1
  iSymX = 2**IrrFnc(ixyz)
  ixyz = 2
  iSymY = 2**IrrFnc(ixyz)
  ixyz = 4
  iSymZ = 2**IrrFnc(ixyz)
  iSymCx = iSymX
  if (Ccoor(1) /= Zero) iSymCx = ibset(iSymCx,0)
  iSymCy = iSymY
  if (Ccoor(2) /= Zero) iSymCy = ibset(iSymCy,0)
  iSymCz = iSymZ
  if (Ccoor(3) /= Zero) iSymCz = ibset(iSymCz,0)
  iSymLx = ibset(MltLbl(iSymCy,iSymZ),MltLbl(iSymCz,iSymY))
  iChOx = iChBas(3)+iChBas(4)
  iSymLy = ibset(MltLbl(iSymCz,iSymX),MltLbl(iSymCx,iSymZ))
  iChOy = iChBas(4)+iChBas(2)
  iSymLz = ibset(MltLbl(iSymCx,iSymY),MltLbl(iSymCy,iSymX))
  iChOz = iChBas(2)+iChBas(3)

  ! Symmetry labels and characters of products. Let G be the full
  ! molecular point group, and Gsub=subgroup of G=stabilizer of
  ! gauge origin. The totally symmetric irrep of Gsub can be
  ! decomposed into irreps of G.
  ! Then symmetry label=packed array of bits, one for each irrep
  ! of G. The bit is set, if that irrep is included in the
  ! decomposition of the totally symmetric irrep of Gsub.
  OperI(1) = MltLbl(iSymLx,iSymLx)
  OperI(1+1) = MltLbl(iSymLx,iSymLy)
  OperI(1+2) = MltLbl(iSymLx,iSymLz)
  OperI(1+3) = MltLbl(iSymLy,iSymLy)
  OperI(1+4) = MltLbl(iSymLy,iSymLz)
  OperI(1+5) = MltLbl(iSymLz,iSymLz)
  OperC(1) = 0
  OperC(1+1) = ieor(iChOx,iChOy)
  OperC(1+2) = ieor(iChOx,iChOz)
  OperC(1+3) = 0
  OperC(1+4) = ieor(iChOy,iChOz)
  OperC(1+5) = 0

  call dcopy_(nComp,[Zero],0,Nuc,1)
  call OneEl(AMPInt,AMPMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()
end if
!***********************************************************************
!***********************************************************************
!17)                                                                   *
!                                                                      *
!     Contact term integrals                                           *
!                                                                      *
!***********************************************************************
!***********************************************************************
ixyz = 1
iSymX = 2**IrrFnc(ixyz)
ixyz = 2
iSymY = 2**IrrFnc(ixyz)
ixyz = 4
iSymZ = 2**IrrFnc(ixyz)
ixyz = 3
iSymXY = 2**IrrFnc(ixyz)
ixyz = 5
iSymXZ = 2**IrrFnc(ixyz)
ixyz = 6
iSymYZ = 2**IrrFnc(ixyz)
ixyz = 7
iSyXYZ = 2**IrrFnc(ixyz)
PLabel = ' '
rHrmt = One

mCnt = 0
if (nOrdEF == 2) mCnt = nEF

nComp = 1
nOrdOp = 1
do iCnt=1,mCnt
  write(Label,'(A,I5)') 'Cnt',iCnt
  CCoor(:) = EF_Centers(:,iCnt)
  call Allocate_Auxiliary()

  iSymR(0) = 1
  if (Ccoor(1) /= Zero) iSymR(0) = ior(iSymR(0),iSymX)
  if (Ccoor(2) /= Zero) iSymR(0) = ior(iSymR(0),iSymY)
  if (Ccoor(3) /= Zero) iSymR(0) = ior(iSymR(0),iSymZ)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero)) iSymR(0) = ior(iSymR(0),iSymXY)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(3) /= Zero)) iSymR(0) = ior(iSymR(0),iSymXZ)
  if ((Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymR(0) = ior(iSymR(0),iSymYZ)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymR(0) = ior(iSymR(0),iSyXYZ)

  OperI(1) = iSymR(0)
  OperC(1) = 0

  call dcopy_(nComp,[Zero],0,Nuc,1)
  call OneEl(CntInt,CntMem,Label,ipList,OperI,nComp,Ccoor,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! For picture-change corrected integrals.

  if (DKroll .and. Primitive_Pass) then
    write(Label,'(A,I2)') 'pCp   ',iCnt
    PLabel = 'CntInt'
    call FZero(Nuc,nComp)
    call OneEl(PXPInt,PXPMem,Label,ipList,OperI,nComp,CCoor,nOrdOp+2,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
  end if

  call Deallocate_Auxiliary()
end do

! For a properties calculation, read the CNT values saved in a temp file
! and write the sum through Add_Info

if (PrPrt .and. (mCnt > 0)) then
  call mma_allocate(PtEl,1,label='PtEl')
  call mma_allocate(PtNuc,1,label='PtNuc')
  call mma_allocate(SumEl,1,label='SumEl')
  call mma_allocate(SumNuc,1,label='SumNuc')
  SumEl(1) = Zero
  SumNuc(1) = Zero
  !     Read and sum the values
  LuTmp = 10
  call DaName(LuTmp,'TMPPRP')
  iDisk = 0
  do iCnt=1,mCnt
    call dDaFile(LuTmp,2,PtEl,1,iDisk)
    call dDaFile(LuTmp,2,PtNuc,1,iDisk)
    SumEl(1) = SumEl(1)+PtEl(1)
    SumNuc(1) = SumNuc(1)+PtNuc(1)
  end do
  call DaClos(LuTmp)
  ! set the tolerance according to the total number of centers
  ! (assuming error scales with sqrt(mCnt))
  iTol = 5
  iTol = iTol-nint(Half*log10(real(mCnt,kind=wp)))
  write(label,'(a,a)') 'CNT','   el'
  call Add_Info(label,SumEl,1,iTol)
  write(label,'(a,a)') 'CNT','  nuc'
  call Add_Info(label,SumNuc,1,iTol)
  call mma_deallocate(PtEl)
  call mma_deallocate(PtNuc)
  call mma_deallocate(SumEl)
  call mma_deallocate(SumNuc)
end if
!***********************************************************************
!***********************************************************************
!18)                                                                   *
!                                                                      *
!     Gradient of overlap integrals with respect to the magnetic field *
!                                                                      *
!***********************************************************************
!***********************************************************************
if (GIAO .and. (.not. Primitive_Pass)) then
  PLabel = ' '
  rHrmt = -One
  nB = 3
  iLow = 0
  mMltpl = 0 ! Do only overlap.
  !mMltpl = -1 ! Do only overlap.
  do iMltpl=iLow,mMltpl
    write(Label,'(A,I2)') 'dMP/dB',iMltpl
    mComp = (iMltpl+1)*(iMltpl+2)/2
    nComp = mComp*nB
    call DCopy_(3,Coor_MpM(1,iMltpl+1),1,Ccoor,1)
    call Allocate_Auxiliary()

    iComp = 0
    do ix=iMltpl,0,-1

      !---- Pick up which irrep each of the cartesian components of
      !     the operator belongs to. If the operator is associated
      !     with a center other than origin add the total symmetric
      !     irrep.

      if (mod(ix,2) == 0) then
        iSymX = 1
      else
        ixyz = 1
        iSymX = 2**IrrFnc(ixyz)
        if (Ccoor(1) /= Zero) iSymX = ibset(iSymX,0)
      end if
      do iy=iMltpl-ix,0,-1
        if (mod(iy,2) == 0) then
          iSymY = 1
        else
          ixyz = 2
          iSymY = 2**IrrFnc(ixyz)
          if (Ccoor(2) /= Zero) iSymY = ibset(iSymY,0)
        end if
        iz = iMltpl-ix-iy
        if (mod(iz,2) == 0) then
          iSymZ = 1
        else
          ixyz = 4
          iSymZ = 2**IrrFnc(ixyz)
          if (Ccoor(3) /= Zero) iSymZ = ibset(iSymZ,0)
        end if

        !----- Multiply cartesian components to generate which irreps
        !      the current element of the multipole moment operator
        !      belong to. The lowest significant bit if set indicate that
        !      a particular irrep is included.

        iTemp = MltLbl(iSymX,MltLbl(iSymY,iSymZ))

        iChO = mod(ix,2)*iChBas(2)+mod(iy,2)*iChBas(3)+mod(iz,2)*iChBas(4)

        !----- Now combine with the character of the first derivative
        !      with respect to the magnetic field.

        iSymRx = 2**IrrFnc(1)
        iSymRy = 2**IrrFnc(2)
        iSymRz = 2**IrrFnc(4)

        iB = 1
        iChOx = mod(ix,2)*iChBas(2)+mod(iy+1,2)*iChBas(3)+mod(iz+1,2)*iChBas(4)
        OperC(1+(iB-1)*mComp+iComp) = iChOx
        iSymBx = MltLbl(iSymRy,iSymRz)
        OperI(1+(iB-1)*mComp+iComp) = MltLbl(iTemp,iSymBx)
        call DCopy_(3,Coor_MPM(1,iMltpl+1),1,CoorO(1+((iB-1)*mComp+iComp)*3),1)

        iB = 2
        iChOy = mod(ix+1,2)*iChBas(2)+mod(iy,2)*iChBas(3)+mod(iz+1,2)*iChBas(4)
        OperC(1+(iB-1)*mComp+iComp) = iChOy
        iSymBy = MltLbl(iSymRz,iSymRx)
        OperI(1+(iB-1)*mComp+iComp) = MltLbl(iTemp,iSymBy)
        call DCopy_(3,Coor_MPM(1,iMltpl+1),1,CoorO(1+((iB-1)*mComp+iComp)*3),1)

        iB = 3
        iChOz = mod(ix+1,2)*iChBas(2)+mod(iy+1,2)*iChBas(3)+mod(iz,2)*iChBas(4)
        OperC(1+(iB-1)*mComp+iComp) = iChOz
        iSymBz = MltLbl(iSymRx,iSymRy)
        OperI(1+(iB-1)*mComp+iComp) = MltLbl(iTemp,iSymBz)
        call DCopy_(3,Coor_MPM(1,iMltpl+1),1,CoorO(1+((iB-1)*mComp+iComp)*3),1)

        iComp = iComp+1
      end do
    end do

    ! Zero nuclear contribution.
    call dcopy_(nComp,[Zero],0,Nuc,1)
    call OneEl(MltInt_GIAO,MltMem_GIAO,Label,ipList,OperI,nComp,CoorO,iMltpl,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

    call Deallocate_Auxiliary()

  end do

end if
!***********************************************************************
!***********************************************************************
!19)                                                                   *
!                                                                      *
!     Atomic mean field integrals for spin-orbit calculations          *
!                                                                      *
!***********************************************************************
!***********************************************************************
if (lAMFI .and. (.not. Prprt) .and. (.not. Primitive_Pass)) then
  PLabel = ' '
  rHrmt = -One
  Label = 'AMFI    '
  nComp = 3
  call Allocate_Auxiliary()
  OperI(1) = 2**IrrFnc(6)
  OperC(1) = iChBas(7)
  OperI(1+1) = 2**IrrFnc(5)
  OperC(1+1) = iChBas(6)
  OperI(1+2) = 2**IrrFnc(3)
  OperC(1+2) = iChBas(4)

  ! BP - Turn off AMFI integrals for certain atom types
  !      as requested by the PAMF keyword
  !
  !      Note that Drv_AMFI will only process dbsc of valence type.
  !      Hence the restriction on the loop.

  call mma_allocate(iAtmNr2,nCnttp,Label='iAtmNr2')
  call mma_allocate(Charge2,nCnttp,Label='Charge2')
  do i=1,nCnttp
    iAtmNr2(i) = dbsc(i)%AtmNr
    Charge2(i) = dbsc(i)%Charge

    iAtom_Number = dbsc(i)%AtmNr
    if ((iAtom_Number < 0) .or. (iAtom_Number > size(No_AMFI))) then
      write(u6,*) 'Illegal atom number.'
      write(u6,*) 'Atom number=',iAtom_Number
      call Abend()
    end if
    if (No_AMFI(iAtom_Number)) then
      write(u6,*) 'Disabling AMFI for atom type ',dbsc(i)%AtmNr
      iAtmNr2(i) = 0
      Charge2(i) = Zero
    end if
  end do

  call Drv_AMFI(Label,OperI,nComp,iAtmNr2,Charge2)

  call mma_deallocate(iAtmNr2)
  call mma_deallocate(Charge2)
  call Deallocate_Auxiliary()
end if
!***********************************************************************
!***********************************************************************
!KAMAL,Rulin Update)                                                   *
!                                                                      *
!              GEN1INT                                                 *
!                                                                      *
!***********************************************************************
!***********************************************************************
!!!MXTC
if (lMXTC.and.DKroll.and.Primitive_Pass) then
# ifdef _GEN1INT_
  nOrdOp = 0
  ! Assume symmetric
  rHrmt = One
  nComp = 9
  call Get_nAtoms_All(nAtoms)
  do iCnt = 1, nAtoms
    do jCnt = 1, 2
      if (jCnt == 1) then
        ! Label for lower triangular portion
        write(Label,'(A,I3)') 'MAGXP',iCnt
        write(PLabel,'(A6)') 'MagInt'
      else
        ! Label for upper triangular portion
        write(Label,'(A,I3)') 'MAGPX',iCnt
        write(PLabel,'(A6)') 'MagInt'
      end if
      call Allocate_Auxiliary()
      ! Dummy symmetry indices
      do i=1,nComp
        OperI(i) = 255
        OperC(i) = 0
      end do
      ! Zero nuclear contribution
      call dcopy_(nComp,[Zero],0,Nuc,1)
      ! Compute one electron integrals
      call OneEl(DumInt,DumMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
      call Deallocate_Auxiliary()
    end do
  end do
# else
  call WarningMessage(2,'Drv1El: NO Gen1int interface available!')
  call Abend()
# endif
end if ! lMXTC
!***********************************************************************
!***********************************************************************
!20)                                                                   *
!                                                                      *
!     The gradient of the kinetic energy and the nuclear attraction    *
!     energy with respect to the magnetic field.                       *
!                                                                      *
!***********************************************************************
!***********************************************************************
if (GIAO .and. (.not. Primitive_Pass)) then
  PLabel = ' '
  rHrmt = -One
  nOrdOp = 0
  nComp = 3
  call Allocate_Auxiliary()
  call dcopy_(3*nComp,[Zero],0,CoorO,1)
  ixyz = 1
  OperI(1) = 2**IrrFnc(ixyz)
  OperC(1) = iChBas(2)
  ixyz = 2
  OperI(1+1) = 2**IrrFnc(ixyz)
  OperC(1+1) = iChBas(3)
  ixyz = 4
  OperI(1+2) = 2**IrrFnc(ixyz)
  OperC(1+2) = iChBas(4)

  call dcopy_(3,[Zero],0,Nuc,1)

  Label = 'dT/dB   '
  call OneEl(KneInt_GIAO,KneMem_GIAO,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  nOrdOp = 1
  Label = 'dV/dB   '
  call OneEl(NAInt_GIAO,NAMem_GIAO,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()

  ! Differentiate the generalized kinetic energy operator with respect
  ! to the magnetic moment at the centers.

  nOrdOp = 1
  nComp = 3
  ixyz = 1
  iSymX = 2**IrrFnc(ixyz)
  ixyz = 2
  iSymY = 2**IrrFnc(ixyz)
  ixyz = 4
  iSymZ = 2**IrrFnc(ixyz)
  ixyz = 3
  iSymXY = 2**IrrFnc(ixyz)
  ixyz = 5
  iSymXZ = 2**IrrFnc(ixyz)
  ixyz = 6
  iSymYZ = 2**IrrFnc(ixyz)
  ixyz = 7
  iSyXYZ = 2**IrrFnc(ixyz)

  iEF = 0
  do iCnttp=1,nCnttp
    do iCnt=1,dbsc(iCnttp)%nCntr
      iEF = iEF+1
      write(Label,'(A,I2)') 'dT/dmu',iEF
      CCoor(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
      call Allocate_Auxiliary()
      iSymC = 1
      if (Ccoor(1) /= Zero) iSymC = ior(iSymC,iSymX)
      if (Ccoor(2) /= Zero) iSymC = ior(iSymC,iSymY)
      if (Ccoor(3) /= Zero) iSymC = ior(iSymC,iSymZ)
      if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero)) iSymC = ior(iSymC,iSymXY)
      if ((Ccoor(1) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ior(iSymC,iSymXZ)
      if ((Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ior(iSymC,iSymYZ)
      if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ior(iSymC,iSyXYZ)

      iComp = 0
      do ix=nOrdOp,0,-1
        do iy=nOrdOp-ix,0,-1
          iComp = iComp+1
          iz = nOrdOp-ix-iy
          ixyz = 0
          if (mod(ix,2) /= 0) ixyz = ibset(ixyz,0)
          if (mod(iy,2) /= 0) ixyz = ibset(ixyz,1)
          if (mod(iz,2) /= 0) ixyz = ibset(ixyz,2)
          iSym = 2**IrrFnc(ixyz)
          if (Ccoor(iComp) /= Zero) iSym = ibset(iSym,0)
          OperI(1+(iComp-1)) = MltLbl(iSymC,iSym)
          OperC(1+(iComp-1)) = iChBas(iComp+1)
          call dcopy_(3,Ccoor,1,CoorO(1+(iComp-1)*3),1)
        end do
      end do

      !call EFNuc(CoorO,Chrg,Centr,S%kCentr,Nuc,nOrdOp)

      call OneEl(dTdmu_Int,dTdmu_Mem,Label,ipList,OperI,nComp,CoorO,nOrdOp,Nuc,rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

      call Deallocate_Auxiliary()
    end do
  end do
end if
!***********************************************************************
!***********************************************************************
!21)                                                                   *
!                                                                      *
!     Atomic Fock matrix                                               *
!                                                                      *
!***********************************************************************
!***********************************************************************
PLabel = ' '
rHrmt = One
nComp = 1
nOrdOp = 0
if ((.not. Prprt) .and. (.not. Primitive_Pass) .and. Do_FckInt) then
  call Allocate_Auxiliary()
  call dcopy_(3,[Zero],0,CoorO,1)
  OperI(1) = 1
  OperC(1) = iChBas(1)

  Label = 'FckInt  '
  call Drv_Fck(Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)

  call Deallocate_Auxiliary()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate memory for property calculation.

if (Prprt) then
  if (Short) call mma_deallocate(Den)
  call mma_deallocate(Vec)
  call mma_deallocate(Occ)
  call CollapseOutput(0,'   Molecular properties:')
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Is this the second pass in a relativistic calculation?
! In that case: close ONEINT, open ONEREL, read the pVp
! integrals, close ONEREL, re-open ONEINT, calculate the
! DK integrals in the contracted basis set, transform and
! replace the one-electron integrals on ONEINT.

if (DKroll .and. (.not. Primitive_Pass)) then
  if (BSS) then
    call BSSint()
  else
    call DKRelInt_DP()
  end if
end if
!***********************************************************************
!***********************************************************************
!20)                                                                   *
!                                                                      *
!     Produce information for the NEMO interface.                      *
!                                                                      *
!***********************************************************************
!***********************************************************************
if (NEMO) then
  if (Primitive_Pass) then

    ! Compute p-matrix and put it temporarily on ONEREL.
    PLabel = ' '
    rHrmt = One
    nComp = 3
    nOrdOp = 0
    call Allocate_Auxiliary()
    do iComp=1,nComp
      call dcopy_(3,[Zero],0,CoorO(1+(iComp-1)*3),1)
      OperI(1+(iComp-1)) = 1
      OperC(1+(iComp-1)) = iChBas(1)
    end do

    Label = 'P_matrix'
    call OneEl(P_Int,P_Mem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero,Zero,Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
    call Deallocate_Auxiliary()
  else

    !-------Assemble transformation matrix between the contracted and
    !       the primitive basis.

    call NEMO_Opt1()

  end if
end if
!***********************************************************************
!***********************************************************************
!21)                                                                   *
!                                                                      *
!     Fragment AIEMP integrals: projection and 2-electron interaction  *
!                               integrals contracted with the          *
!                               fragment's density matrices            *
!                                                                      *
!***********************************************************************
!***********************************************************************
if (lFAIEMP .and. (.not. Primitive_Pass)) then
  ! projection integrals
  PLabel = ' '
  rHrmt = One
  nComp = 1
  nOrdOp = 0
  call Allocate_Auxiliary()
  call dcopy_(3,[Zero],0,CoorO,1)
  OperI(1) = 1
  OperC(1) = iChBas(1)
  Label = 'FragProj'
  call OneEl(FragPInt,FragPMem,Label,ipList,OperI,nComp,CoorO,nOrdOp,[Zero],rHrmt,OperC,dum,1,dum,idum,0,0,dum,1,0)
  call Deallocate_Auxiliary()
  ! add the results to the one-electron hamiltonian
  iOpt = 0
  lOper = 0
  iRC = -1
  call mma_allocate(FragP,n2Tri(1)+4,label='FragP')
  call RdOne(iRC,iOpt,Label,1,FragP,lOper)
  if (iRC /= 0) then
    call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
    call Quit(_RC_IO_ERROR_READ_)
  end if
  Label = 'OneHam  '
  lOper = 0
  iRC = -1
  call mma_allocate(OneHam,n2Tri(1)+4,label='OneHam')
  call RdOne(iRC,iOpt,Label,1,OneHam,lOper)
  if (iRC /= 0) then
    call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
    call Quit(_RC_IO_ERROR_READ_)
  end if
  call DaXpY_(n2Tri(1)+4,One,FragP,1,OneHam,1)
  iRC = -1
  call WrOne(iRC,iOpt,Label,1,OneHam,lOper)
  if (iRC /= 0) then
    call WarningMessage(2,'Drv1El: Error writing ONEINT;Label='//Label)
    call Quit(_RC_IO_ERROR_WRITE_)
  end if
  iRC = -1
  Label = 'OneHam 0'
  call WrOne(iRC,iOpt,Label,1,OneHam,lOper)
  if (iRC /= 0) then
    call WarningMessage(2,'Drv1El: Error writing ONEINT;Label='//Label)
    call Quit(_RC_IO_ERROR_WRITE_)
  end if
  call mma_deallocate(FragP)
  call mma_deallocate(OneHam)
  ! 2-electron interaction integrals (are added to the one-electron
  ! hamiltonian locally)
  call Drv2El_FAIEMP()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call Free_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
return

contains

subroutine Allocate_Auxiliary()
  implicit none

  call mma_Allocate(ipList,nComp,label='ipList')
  call mma_Allocate(OperI,nComp,label='OperI')
  call mma_Allocate(OperC,nComp,label='OperC')
  call mma_Allocate(CoorO,3*nComp,label='CoorO')
  call mma_Allocate(Nuc,nComp,label='Nuc')

  return
end subroutine Allocate_Auxiliary

subroutine Deallocate_Auxiliary()
  implicit none

  call mma_Deallocate(OperC)
  call mma_Deallocate(OperI)
  call mma_Deallocate(ipList)
  call mma_Deallocate(CoorO)
  call mma_Deallocate(Nuc)

  return
end subroutine Deallocate_Auxiliary

end subroutine Drv1el

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SUBROUTINE set_nnBSF(nSym,Nbas,nnBSF,n2BSF)

      Implicit Real*8 (a-h,o-z)
      Integer nSym,nBas(8)
      Integer nnBSF(8,8),n2BSF(8,8)



      do j=1,nSym
         do i=j,nSym

            kSym = iEOR(i-1,j-1) + 1

            nnBSF(i,j) = nBas(i)*nBas(j)
     &                 + Min(0,kSym-2)*nBas(i)*(nBas(i)-1)/2

            nnBSF(j,i) = nnBSF(i,j)

            n2BSF(i,j) = nBas(i)*nBas(j)

            n2BSF(j,i) = n2BSF(i,j)

         end do
      end do

      Return
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_GnVc_GenVec(Diag,xInt,lInt,nVecRS,iVecRS,
     &                           mSym,mPass,iPass1,NumPass)
C
C     Purpose: generate Cholesky vectors from raw integral columns.
C
      use ChoArr, only: nDimRS
      use ChoSwp, only: InfVec, IndRed
      use GnVcMp, only: RS2RS
#include "implicit.fh"
      Integer lInt
      Real*8  Diag(*), xInt(lInt)
      Integer mSym,mPass
      Integer nVecRS(mSym,mPass), iVecRS(mSym,mPass)
      Integer iPass1,NumPass
#include "cholesky.fh"
#include "choprint.fh"
#include "stdalloc.fh"

      Character(LEN=15), Parameter:: SecNam = 'Cho_GnVc_GenVec'

      Integer NumCho_OLD(8), iOff1(8), iOff2(8)

      Real*8, Allocatable:: Wrk(:), VecTmp(:)

      mapRS2RS(i,j)=RS2RS(j)%Map(i)

C     Check input.
C     ------------

      If (NumPass .lt. 1) return

      If (mSym .ne. nSym) Then
         Call Cho_Quit('Input error [1] in '//SecNam,103)
      End If

      If (iPass1 .lt. 1) Then
         Call Cho_Quit('Input error [2] in '//SecNam,103)
      End If

      iPass2 = iPass1 + NumPass - 1
      If (iPass2 .gt. mPass) Then
         Call Cho_Quit('Input error [3] in '//SecNam,103)
      End If

      nPass = XnPass
      If (mPass .ne. nPass) Then
         Call Cho_Quit('Input error [4] in '//SecNam,103)
      End If

      NumVec = 0
      Do iPass = iPass1,iPass2
         Do iSym = 1,nSym
            NumVec = NumVec + nVecRS(iSym,iPass)
         End Do
      End Do
      If (NumVec .lt. 1) return ! exit

C     Subtract previous vectors.
C     --------------------------

      Call mma_maxDBLE(l_Wrk)
      Call mma_allocate(Wrk,l_Wrk,Label='Wrk')
      Do iSym = 1,nSym
         kOff = iOff_Col(iSym) + 1
         Call Cho_Subtr(xInt(kOff),Wrk,SIZE(Wrk),iSym)
      End Do
      Call mma_deallocate(Wrk)

C     Initialize vector generation.
C     -----------------------------

      Do iSym = 1,nSym
         iOff1(iSym) = iOff_Col(iSym) + 1
         iOff2(iSym) = iOff_Col(iSym) + 1
      End Do

      l_VecTmp = 0
      Do iPass = iPass1,iPass2
         Do iSym = 1,nSym
            Need = nnBstR(iSym,2)*nVecRS(iSym,iPass)
            l_VecTmp = max(l_VecTmp,Need)
         End Do
      End Do
      MxSubtr = 0
      Do iPass = iPass1,iPass2
         Do iSym = 1,nSym
            nAB = 0
            Do jPass = iPass+1,iPass2
               nAB = nAB + nVecRS(iSym,jPass)
            End Do
            Need = nAB*nVecRS(iSym,iPass)
            MxSubtr = max(MxSubtr,Need)
         End Do
      End Do
      l_VecTmp = max(l_VecTmp,MxSubtr)
      Call mma_allocate(VecTmp,l_VecTmp,Label='VecTmp')

C     Copy reduced set iPass1 to location 3.
C     --------------------------------------

      irc = 0
      Call Cho_X_RSCopy(irc,2,3)
      If (irc .ne. 0) Then
         Write(Lupri,*) SecNam,': Cho_X_RSCopy returned ',irc
         Call Cho_Quit('Error termination in '//SecNam,104)
      End If

C     Decomposition pass loop.
C     ------------------------

      Do iPass = iPass1,iPass2

C        Print header.
C        -------------

         LenLin = 0 ! to avoid compiler warnings
         If (iPrint .ge. INF_PROGRESS) Then
            Call Cho_Head(SecNam//
     &                    ': Generation of Vectors from Map','=',
     &                    80,Lupri)
            Write(Lupri,'(/,A,I5)')
     &      'Integral pass number',iPass
            Write(Lupri,'(A,8I8)')
     &      '#Cholesky vec.: ',(NumCho(iSym),iSym=1,nSym)
            Write(Lupri,'(A,8I8)')
     &      '#qualified    : ',(nVecRS(iSym,iPass),iSym=1,nSym)
            Write(Lupri,'(A,8I8)')
     &      'Current  dim. : ',(nnBstR(iSym,3),iSym=1,nSym)
            Write(Lupri,'(A,8I8)')
     &      'Original dim. : ',(nnBstR(iSym,1),iSym=1,nSym)
            Write(Lupri,'(/,A,/,A,A)')
     &      '           #Vectors             Treated Diagonal',
     &      'Sym.     Sym.     Total     Index     Before      After',
     &      '   Conv. Neg.   New Max'
            LenLin = 79
            Write(Lupri,'(80A)') ('-',i=1,LenLin)
            Call Cho_Flush(Lupri)
            Call iCopy(nSym,NumCho,1,NumCho_OLD,1)
         Else If (iPrint .ge. INF_PASS) Then
            Write(Lupri,'(/,A,I5)')
     &      'Integral pass number',iPass
            Write(LUPRI,'(A,8I8)')
     &      '#Cholesky vec.: ',(NumCho(iSym),iSym=1,nSym)
            Write(LUPRI,'(A,8I8)')
     &      '#qualified    : ',(nVecRS(iSym,iPass),iSym=1,nSym)
            Call Cho_Flush(Lupri)
            Call iCopy(nSym,NumCho,1,NumCho_OLD,1)
         End If

C        Zero entries in integral matrix that are not part of this
C        reduced set.
C        ---------------------------------------------------------

         If (iPass .gt. iPass1) Then
            Do iSym = 1,nSym
               Do iV = 1,nVecRS(iSym,iPass)
                  lTot = nnBstR(iSym,2)
                  VecTmp(1:lTot)=0.0D0
                  lOff0 = iOff1(iSym) + nnBstR(iSym,2)*(iV-1) - 1
                  Do lAB = 1,nnBstR(iSym,3)
                     jAB = IndRed(iiBstR(iSym,3)+lAB,3) - iiBstR(iSym,1)
                     kAB = mapRS2RS(iSym,jAB)
                     VecTmp(kAB) = xInt(lOff0+kAB)
                  End Do
                  Call dCopy_(lTot,VecTmp,1,xInt(lOff0+1),1)
               End Do
            End Do
         End If

C        Write reduced set info for this pass (index arrays are stored
C        at location 3).
C        -------------------------------------------------------------

         Call Cho_P_PutRed(iPass,3)

C        Start symmetry loop.
C        --------------------

         Do iSym = 1,nSym

            If (nVecRS(iSym,iPass) .lt. 1) Go To 100 ! cycle sym. loop

C           Generate vectors for this pass and symmetry.
C           --------------------------------------------

            Do iV = 1,nVecRS(iSym,iPass)

               kOff0 = iOff1(iSym) + nnBstR(iSym,2)*(iV-1) - 1

               iVec = iVecRS(iSym,iPass) + iV - 1
               iAB  = InfVec(iVec,1,iSym) ! addr in 1st red. set

               XC = Diag(iAB)
               If (abs(Diag(iAB)) .gt. 1.0d-14) Then ! TODO/FIXME
                  Fac = 1.0d0/sqrt(abs(Diag(iAB)))
               Else
                  Fac = 1.0d7
               End If
               kOff = kOff0 + 1
               Call dScal_(nnBstR(iSym,2),Fac,xInt(kOff),1)

               Do i = 1,nnBstR(iSym,2)
                  ii = iiBstR(iSym,2) + i
                  jj = IndRed(ii,2)
                  If (Diag(jj) .eq. 0.0d0) Then
                     xInt(kOff0+i) = 0.0d0
                  End If
               End Do

               Do i = 1,nnBstR(iSym,2)
                  ii = iiBstR(iSym,2) + i
                  jj = IndRed(ii,2)
                  Diag(jj) = Diag(jj) - xInt(kOff0+i)*xInt(kOff0+i)
               End Do

               olDiag    = Diag(iAB)
               Diag(iAB) = 0.0d0
               Call Cho_ChkDia(Diag,iSym,xMin,xMax,xM,nNegT,nNeg,nConv)
               nNZTot = nNZTot + nNeg

               kOff1 = kOff0 + 1
               Do jV = iV+1,nVecRS(iSym,iPass)
                  jVec = iVecRS(iSym,iPass) + jV - 1
                  jAB  = InfVec(jVec,1,iSym)
                  kOff2 = iOff1(iSym) + nnBstR(iSym,2)*(jV-1)
                  Fac   = -xInt(kOff0+mapRS2RS(iSym,jAB-iiBstR(iSym,1)))
                  Call dAXPY_(nnBstR(iSym,2),Fac,xInt(kOff1),1,
     &                                          xInt(kOff2),1)
               End Do

               Call Cho_SetVecInf(iVec,iSym,iAB,iPass,3)

               If (iPrint .ge. INF_PROGRESS) Then
                  iVecT = NumChT + iV
              Write(Lupri,'(I3,3(1X,I9),2(1X,D11.3),2(1X,I4),1X,D11.3)')
     &            iSym,iVec,iVecT,iAB,XC,olDiag,nConv,nNeg,xM
               End If

            End Do

C           Subtract contributions to later vectors.
C           ----------------------------------------

            nAB = nQual(iSym)
            Do jPass = iPass1,iPass
               nAB = nAB - nVecRS(iSym,jPass)
            End Do
            If (nAB .gt. 0) Then
               ip_Scr = 1
               iP = iPass
               jVec0 = -1
               Do While (iP.lt.iPass2 .and. jVec0.lt.0)
                  iP = iP +1
                  jVec0 = iVecRS(iSym,iP) - 1
               End Do
               If (jVec0 .lt. 0) Then ! should never happen
                  Call Cho_Quit('jVec0 < 0 in '//SecNam,103)
               End If
               Do iV = 1,nVecRS(iSym,iPass)
                  kOff1 = ip_Scr + nAB*(iV-1) - 1
                  kOff2 = iOff1(iSym) + nnBstR(iSym,2)*(iV-1) - 1
                  Do iAB = 1,nAB
                     jVec = jVec0 + iAB
                     jAB  = InfVec(jVec,1,iSym)
                     kAB  = mapRS2RS(iSym,jAB-iiBstR(iSym,1))
                     VecTmp(kOff1+iAB) = xInt(kOff2+kAB)
                  End Do
               End Do
               kOff1 = iOff1(iSym)
               kOff2 = iOff1(iSym)
     &               + nnBstR(iSym,2)*nVecRS(iSym,iPass)
               Call DGEMM_('N','T',
     &                    nnBstR(iSym,2),nAB,nVecRS(iSym,iPass),
     &                    -1.0d0,xInt(kOff1),nnBstR(iSym,2),
     &                           VecTmp,nAB,
     &                     1.0d0,xInt(kOff2),nnBstR(iSym,2))
            End If

C           Reorder vectors to appropriate reduced set.
C           Skipped for iPass1, as they are already in correct storage.
C           -----------------------------------------------------------

            If (iPass .gt. iPass1) Then
               lTot = nnBstR(iSym,2)*nVecRS(iSym,iPass)
               Call dCopy_(lTot,xInt(iOff1(iSym)),1,VecTmp,1)
               Do iV = 1,nVecRS(iSym,iPass)
                  kOff0 = iOff2(iSym) + nnBstR(iSym,3)*(iV-1) - 1
                  lOff0 = nnBstR(iSym,2)*(iV-1)
                  Do kAB = 1,nnBstR(iSym,3)
                     jAB = IndRed(iiBstR(iSym,3)+kAB,3)
                     lAB = mapRS2RS(iSym,jAB-iiBstR(iSym,1))
                     xInt(kOff0+kAB) = VecTmp(lOff0+lAB)
                  End Do
               End Do
            End If

C           Update vector counters.
C           -----------------------

            NumCho(iSym) = NumCho(iSym) + nVecRS(iSym,iPass)
            NumChT = NumChT + nVecRS(iSym,iPass)

C           Update pointer arrays.
C           iOff1: pointer to integral columns (in xInt).
C           iOff2: pointer to vectors (also in xInt).
C           ---------------------------------------------

            iOff1(iSym) = iOff1(iSym)
     &                  + nnBstR(iSym,2)*nVecRS(iSym,iPass)
            iOff2(iSym) = iOff2(iSym)
     &                  + nnBstR(iSym,3)*nVecRS(iSym,iPass)

C           Cycle point for empty symmetry.
C           -------------------------------

  100       Continue
            If (iPrint .ge. INF_PROGRESS) Call Cho_Flush(Lupri)

         End Do ! symmetry

C        Print.
C        ------

         If (iPrint .ge. INF_PROGRESS) Then
            Do iSym = 1,nSym
               NumCho_OLD(iSym) = NumCho(iSym) - NumCho_OLD(iSym)
            End Do
            Write(Lupri,'(80A)') ('-',I=1,LenLin)
            Write(Lupri,'(A,8I8)')
     &      '#vec. gener.  : ',(NumCho_OLD(iSym),iSym=1,nSym)
            Call Cho_Flush(Lupri)
         Else If (iPrint .GE. INF_PASS) Then
            Do iSym = 1,nSym
               NumCho_OLD(iSym) = NumCho(iSym) - NumCho_OLD(iSym)
            End Do
            Write(Lupri,'(A,8I8)')
     &      '#vec. gener.  : ',(NumCho_OLD(iSym),iSym=1,nSym)
            Call Cho_Flush(Lupri)
         End If

C        Analyze diagonal.
C        -----------------

         If (iPrint .ge. INF_PASS) Then
            Bin1 = 1.0d2
            Step = 1.0d-1
            nBin = 18
            Call Cho_AnaDia(Diag,Bin1,Step,nBin,.false.)
         End If

C        Set next (iPass+1) reduced set at location 2.
C        Reduced set iPass1 is now stored at location 3.
C        -----------------------------------------------

         Call Cho_SetRed(Diag)
         jPass = iPass + 1
         Call Cho_SetRSDim(nDimRS,nSym,MaxRed,jPass,2)
         If (iPrint .ge. INF_PASS) Then
            Call Cho_PrtRed(2)
            Call Cho_Flush(Lupri)
         End If

C        Swap locations so that:
C        location 2 contains reduced set iPass1 and
C        location 3 contains next (iPass+1) reduced set.
C        -----------------------------------------------

         irc = 0
         Call Cho_X_RSSwap(irc,2,3)
         If (irc .ne. 0) Then
            Write(Lupri,*) SecNam,': Cho_X_RSSwap returned ',irc
            Call Cho_Quit('Error termination in '//SecNam,104)
         End If

      End Do ! integral pass

C     Deallocate temporary vector array.
C     ----------------------------------

      Call mma_deallocate(VecTmp)

C     Write vectors to disk.
C     ----------------------

      Call Cho_Timer(C1,W1)
      Do iSym = 1,nSym
         NumVec = nVecRS(iSym,iPass1)
         Do iPass = iPass1+1,iPass2
            NumVec = NumVec + nVecRS(iSym,iPass)
         End Do
         If (NumVec .gt. 0) Then
            iPass = iPass1
            iVec1 = iVecRS(iSym,iPass)
            Do While (iVec1.lt.1 .and. iPass.lt.iPass2)
               iPass = iPass + 1
               iVec1 = iVecRS(iSym,iPass)
            End Do
            If (iVec1 .lt. 1) Then
               Call Cho_Quit('Logical error in '//SecNam,103)
            Else
               Call Cho_PutVec2(xInt(iOff_Col(iSym)+1),NumVec,iVec1,
     &                          iSym)
            End If
         End If
      End Do
      Call Cho_Timer(C2,W2)
      tDecom(1,2) = tDecom(1,2) + C2 - C1
      tDecom(2,2) = tDecom(2,2) + W2 - W1

C     Write restart files.
C     --------------------

      Call Cho_P_WrRstC(iPass2)

C     Store next (iPass2+1) reduced set at location 2.
C     ------------------------------------------------

      irc = 0
      Call Cho_X_RSCopy(irc,3,2)
      If (irc .ne. 0) Then
         Write(Lupri,*) SecNam,': Cho_X_RSCopy returned ',irc
         Call Cho_Quit('Error termination in '//SecNam,104)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ADD_SKAIIB(     SB,     NI,    NIA, SKAIIB,    NKA,
     &                          NIB,      I,   ISCA,   SSCA)
*
* Update Transposed sigma block with contributions for given orbital index j
* from the matrix S(Ka,i,Ib)
*
* S(Ib,Isca(Ka)) =  S(Ib,Isca(Ka)) + Ssca(Ka)*S(Ka,I,Ib)
*
*
* For efficient processing of alpha-beta loop
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
       DIMENSION SKAIIB(*),SSCA(*),ISCA(*)
*. Input and Output
       DIMENSION SB(NIB,NIA)
*
*. To get rid of annoying and incorrect compiler warnings
      ICOFF = 0
*
C     LBLK = 100
      LBLK = 40
      NBLK = NIB/LBLK
      IF(LBLK*NBLK.LT.NIB) NBLK = NBLK + 1
      DO ICBL = 1, NBLK
        IF(ICBL.EQ.1) THEN
          ICOFF = 1
        ELSE
          ICOFF = ICOFF + LBLK
        END IF
        ICEND = MIN(ICOFF+LBLK-1,NIB)
        ICONST = NKA*NI
        IADR0 =  (I-1)*NKA+(ICOFF-1-1)*NKA*NI
        IF(ICEND.GT.ICOFF) THEN
*. Use form with Inner loop over IB
          DO KA  = 1, NKA
            IF(ISCA(KA).NE.0) THEN
              S = SSCA(KA)
              IROW = ISCA(KA)
C             IADR = KA + (I-1)*NKA+(ICOFF-1-1)*NKA*NI
              IADR = IADR0 + KA
              DO IB = ICOFF,ICEND
*. Adress of S(Ka,i,Ib)
                IADR = IADR + ICONST
                SB(Ib,IROW) = SB(Ib,IROW)+S*SKAIIB(IADR)
              END DO
            END IF
          END DO
        ELSE
*. Form with no loop over IB
          DO KA  = 1, NKA
            IF(ISCA(KA).NE.0) THEN
              S = SSCA(KA)
              IROW = ISCA(KA)
              IADR = IADR0 + KA + ICONST
C             DO IB = ICOFF,ICEND
*. Adress of S(Ka,i,Ib)
C               IADR = IADR + ICONST
                SB(ICOFF,IROW) = SB(ICOFF,IROW)+S*SKAIIB(IADR)
C             END DO
            END IF
          END DO
        END IF
*       ^ End of test of ICOFF=ICEND
      END DO
*
      RETURN
      END
C               GET_CKAJJB(CB,NJ,NJA,CJRES,NKABTC,NJB,
C    &                          JJ,I1(1,JJ),XI1S(1,JJ)

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Analysis_Domain(iDomain,QD,f,Coord,AtomLbl,
     &                           nBas_Start,nAtom,nBas,nOcc)
C
C     Thomas Bondo Pedersen, January 2006.
C
C     Purpose: analyze orbital domains.
C
      Implicit Real*8 (a-h,o-z)
      Integer iDomain(0:nAtom,nOcc)
      Real*8  QD(nOcc), f(nOcc), Coord(3,nAtom)
      Character*4 AtomLbl(2,nBas)
      Integer nBas_Start(nAtom)
#include "WrkSpc.fh"

      If (nAtom.lt.1 .or. nOcc.lt.1) Return

      Call Cho_Head('Orbital domain analysis','=',80,6)
      Do i = 1,nOcc
         nAt = iDomain(0,i)
         Rmin = 1.0d15
         Rmax = -1.0d15
         Rave = 0.0d0
         nij = 0
         Do jAt = 1,nAt-1
            jAtom = iDomain(jAt,i)
            Do iAt = jAt+1,nAt
               iAtom = iDomain(iAt,i)
               R = sqrt((Coord(1,iAtom)-Coord(1,jAtom))**2
     &                 +(Coord(2,iAtom)-Coord(2,jAtom))**2
     &                 +(Coord(3,iAtom)-Coord(3,jAtom))**2)
               Rmin = min(Rmin,R)
               Rmax = max(Rmax,R)
               Rave = Rave + R
               nij = nij + 1
            End Do
         End Do
         If (nij .eq. 0) Then
            Rmax = 0.0d0
            Rmin = 0.0d0
         Else
            Rave = Rave/dble(nij)
         End If
         Write(6,'(/,A,I6,A,I6)')
     &   'Orbital domain',i,':  size:',nAt
         Write(6,'(A,1P,2(1X,D15.5))')
     &   '  Charge, completeness function:',QD(i),f(i)
         Write(6,'(A,1P,3(1X,D15.5))')
     &   '  Rmin, Rmax, Rave             :',Rmin,Rmax,Rave
         Do iAt = 1,nAt
            iAtom = iDomain(iAt,i)
            Write(6,'(A,I6,2X,A,1X,3(1X,F12.3))')
     &      '  Atom:',iAtom,AtomLbl(1,nBas_Start(iAtom)),
     &      (Coord(j,iAtom),j=1,3)
         End Do
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine JACORD(HH,EIGVEC,NVEC,NDIM)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NVEC, NDIM
real(kind=wp), intent(inout) :: HH(*), EIGVEC(NDIM,NVEC)
integer(kind=iwp) :: I, II, IMIN, J, JJ, K
real(kind=wp) :: EI, EJ, EMIN, SWAP
real(kind=wp), parameter :: ThrZ = 1.0e-14_wp

do I=1,NVEC-1
  II = nTri_Elem(I)
  EI = HH(II)
  EMIN = EI
  IMIN = I
  do J=I+1,NVEC
    JJ = nTri_Elem(J)
    EJ = HH(JJ)
    if ((EJ >= EMIN) .or. (abs(EJ-EMIN) < ThrZ)) cycle
    EMIN = EJ
    IMIN = J
  end do
  if (IMIN == I) cycle
  HH(II) = EMIN
  JJ = nTri_Elem(IMIN)
  HH(JJ) = EI
  do K=1,NDIM
    SWAP = EIGVEC(K,I)
    EIGVEC(K,I) = EIGVEC(K,IMIN)
    EIGVEC(K,IMIN) = SWAP
  end do
end do

return

end subroutine JACORD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DistMemo3v3chol(maxdim,PosV1,PosV2,PosV3,PosV4,PosH1,PosH2,PosH3,PosH4,PosM1,PosM2,PosM3,PosM4,PosM5,PosK,PosQ,PosT)
! This routine does:
! define initial positions of T,L,M and W arrays,
! used in routine o3v3chol
!
! I/O parameter description:
! maxdim   - maximal dimension of V'
! Posx     - initial positinos of arrays (O-all)
! PosT     - initial and last position (I/O)
!
! requirements of o3v3chol step
! K  - max{v'v'oo}
! Q  - max{v'v'oo}
! V1 - max{v'oo2, mv'v', v'v'oo, mv'o, moo, vv}
! V2 - max{v'ooo, mv'v', v'v'oo, vo}
! V3 - max{mv'o, v'v'oo, v'ooo}
! V4 - max{v'ooo}
! H1 - max{v'o}
! H2 - max{v'o}
! H3 - max{v'o}
! H4 - max{v'o}
! M1 - max{moo}
! M2 - max{mv'o}
! M3 - max{mv'o}
! M4 - max{moo}
! M5 - max{mv'o}

use Index_Functions, only: nTri_Elem
use chcc_global, only: nc, no, nv, printkey
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: maxdim
integer(kind=iwp), intent(out) :: PosV1, PosV2, PosV3, PosV4, PosH1, PosH2, PosH3, PosH4, PosM1, PosM2, PosM3, PosM4, PosM5, PosK, &
                                  PosQ
integer(kind=iwp), intent(inout) :: PosT
integer(kind=iwp) :: length

!1 Q,K (used also as X,Y)

length = no*no*maxdim*maxdim

PosQ = posT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Q  ',PosQ,length
PosK = posT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM K  ',PosK,length

!2.1 V1 file max{v'oo2, mv'v', v'v'oo, mv'o, moo, vv}
length = maxdim*no*nTri_Elem(no)
if (maxdim*maxdim*nc > length) length = maxdim*maxdim*nc
if (no*no*maxdim*maxdim > length) length = no*no*maxdim*maxdim
if (no*nc*maxdim > length) length = no*nc*maxdim
if (no*nc*no > length) length = no*no*nc
if (nv*nv > length) length = nv*nv

PosV1 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V1 ',PosV1,length

!2.2 V2 file - max{v'ooo, mv'v', v'v'oo, vo}

length = no*no*maxdim*maxdim
if (no*no*no*maxdim > length) length = no*no*no*maxdim
if (nc*maxdim*maxdim > length) length = nc*maxdim*maxdim
if (no*nv > length) length = no*nv

PosV2 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V2 ',PosV2,length

!2.2 V3 files - max{mv'o, v'v'oo, v'ooo}

length = no*no*maxdim*maxdim
if (no*no*no*maxdim > length) length = no*no*no*maxdim
if (no*nc*maxdim > length) length = nc*no*maxdim

PosV3 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V3 ',PosV3,length

!2.4 V4 files - max{v'ooo}

length = no*no*no*maxdim

PosV4 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V4 ',PosV4,length

!3 H1-4 files - max{v'o}

length = no*maxdim

PosH1 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM H1 ',PosH1,length
PosH2 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM H2 ',PosH2,length
PosH3 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM H3 ',PosH3,length
PosH4 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM H4 ',PosH4,length

!4 M1-5 files
!  M1 - max{moo}
!  M2 - max{mv'o}
!  M3 - max{mv'o}
!  M4 - max{moo}
!  M5 - max{mv'o}

length = no*no*nc
PosM1 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM M1 ',PosM1,length
length = no*nc*maxdim
PosM2 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM M2 ',PosM2,length
length = no*nc*maxdim
PosM3 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM M3 ',PosM3,length
length = no*nc*no
PosM4 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM M4 ',PosM4,length
length = no*nc*maxdim
PosM5 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM M5 ',PosM5,length

if (printkey >= 10) write(u6,*) 'PosT ',PosT

return

end subroutine DistMemo3v3chol

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine f02agf(a,ia,n,rr,ri,vr,ivr,vi,ivi,intger,ifail)
      implicit real*8 (a-h,o-z)
      logical pair
      dimension a(ia,*),rr(*),ri(*),vr(ivr,*),vi(ivi,*),intger(*)
      save thresh
      data thresh/1.d-8/
      if (ifail.ne.0) Call SysHalt('ifail f02agf')

      if (ia.ne.ivr.or.ia.ne.ivi) Call SysHalt ('f02agf dim')
      call rg(ia,n,a,rr,ri,1,vr,intger,vi,info)
      if (info.ne.0) Call SysHalt ('info f02agf')
      call fzero (vi,n*ivi)
      pair=.false.
      do k=1,n-1
        if (ri(k).ne.0d0.and..not.pair) then
          if (rr(k).ne.rr(k+1)) Call SysHalt ('rr trouble')
          if (abs(ri(k)+ri(k+1)).gt.1d-12) Call SysHalt ('ri trouble')
          pair=.true.
c  If eig value almost real: return real value & vectors :
          if(abs(ri(k)).le.thresh)then
            ri(k)=0.d0
            ri(k+1)=0.d0
          else
            do l=1,n
              vi(l,k)=vr(l,k+1)
              vi(l,k+1)=-vr(l,k+1)
            end do
            do l=1,n
              vr(l,k+1)=vr(l,k)
            end do
          endif
        else
          pair=.false.
        endif
      end do
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Thermo_Driver(UserT,UserP,nUserPT,nsRot,
     &                              EVal,nFreq,lSlapaf)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Integer nUserPT, nsRot, nFreq
      Real*8 UserT(64), UserP, Eval(*)
      Logical lSlapaf ! If .True. then Thermo_Driver called by SLAPAF
      Logical lTest
      lTest = .False.
*
      If (lSlapaf) Then
         Call Get_iScalar('NSYM',nSym)
         If (nSym.ne.1) Then
            Write (6,'(A)') 'WARNING: '
     &                //'No thermochemistry analysis conducted for '
     &           //'numerical frequencies unless no symmetry is used!'
            Return
         End If
      End If
*
      Write(6,*)
      Call CollapseOutput(1,'Thermochemistry')
      Write(6,*)
      Write(6,'(1X,A)')'*********************'
      Write(6,'(1X,A)')'*                   *'
      Write(6,'(1X,A)')'*  THERMOCHEMISTRY  *'
      Write(6,'(1X,A)')'*                   *'
      Write(6,'(1X,A)')'*********************'
      Write(6,*)
*
      If (lTest) then
        Write(6,*)'----------------------------------------------------'
        Write(6,*)'[Thermo_Driver] Input Data:'
        Write(6,*)'    UserP=',UserP,'  nsRot=',nsRot,'nUserPT=',nUserPT
        Write(6,*)'    UserT(1-5)==',(UserT(i),i=1,5)
        Write(6,'(A,I3,A,256F8.2)')'  nFreq=',nFreq,
     &            '  Freq(i)==',(EVal(i),i=1,nFreq)
        Write(6,*)'----------------------------------------------------'
        Call XFlush(6)
      EndIf
*
      Call Rotation(TotalM,TRotA,TRotB,TRotC,nsRot,nAtom,lSlapaf)
      Call Get_iScalar('Multiplicity',iMult)
*
      If (lTest) then
        Write(6,*)' Calling ThermoChem,  iMult=',iMult
        Write(6,*)' UserP=',UserP,'  nsRot=',nsRot,'  nAtom=',nAtom
        Write(6,*)' TotalM,TRotA,TRotB,TRotC==',TotalM,TRotA,TRotB,TRotC
        Write(6,'(A,I3,A,256F8.2)')' nFreq=',nFreq,
     &            '  Freq(i)==',(EVal(i),i=1,nFreq)
        Call XFlush(6)
      EndIf
*
      Call ThermoChem_(UserT,UserP,TotalM,TRotA,TRotB,TRotC,nUserPT,
     &                 nsRot,iMult,nAtom,EVal,nFreq,lSlapaf)
      Call CollapseOutput(0,'Thermochemistry')

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine dqagi(f,bound,inf,epsabs,epsrel,result,abserr,neval,
     *   ier,limit,lenw,last,iwork,work)
c***begin prologue  dqagi
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a3a1,h2a4a1
c***keywords  automatic integrator, infinite intervals,
c             general-purpose, transformation, extrapolation,
c             globally adaptive
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. -k.u.leuven
c***purpose  the routine calculates an approximation result to a given
c            integral   i = integral of f over (bound,+infinity)
c            or i = integral of f over (-infinity,bound)
c            or i = integral of f over (-infinity,+infinity)
c            hopefully satisfying following claim for accuracy
c            abs(i-result).le.max(epsabs,epsrel*abs(i)).
c***description
c
c        integration over infinite intervals
c        standard fortran subroutine
c
c        parameters
c         on entry
c            f      - real*8
c                     function subprogram defining the integrand
c                     function f(x). the actual name for f needs to be
c                     declared e x t e r n a l in the driver program.
c
c            bound  - real*8
c                     finite bound of integration range
c                     (has no meaning if interval is doubly-infinite)
c
c            inf    - integer
c                     indicating the kind of integration range involved
c                     inf = 1 corresponds to  (bound,+infinity),
c                     inf = -1            to  (-infinity,bound),
c                     inf = 2             to (-infinity,+infinity).
c
c            epsabs - real*8
c                     absolute accuracy requested
c            epsrel - real*8
c                     relative accuracy requested
c                     if  epsabs.le.0
c                     and epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
c                     the routine will end with ier = 6.
c
c
c         on return
c            result - real*8
c                     approximation to the integral
c
c            abserr - real*8
c                     estimate of the modulus of the absolute error,
c                     which should equal or exceed abs(i-result)
c
c            neval  - integer
c                     number of integrand evaluations
c
c            ier    - integer
c                     ier = 0 normal and reliable termination of the
c                             routine. it is assumed that the requested
c                             accuracy has been achieved.
c                   - ier.gt.0 abnormal termination of the routine. the
c                             estimates for result and error are less
c                             reliable. it is assumed that the requested
c                             accuracy has not been achieved.
c            error messages
c                     ier = 1 maximum number of subdivisions allowed
c                             has been achieved. one can allow more
c                             subdivisions by increasing the value of
c                             limit (and taking the according dimension
c                             adjustments into account). however, if
c                             this yields no improvement it is advised
c                             to analyze the integrand in order to
c                             determine the integration difficulties. if
c                             the position of a local difficulty can be
c                             determined (e.g. singularity,
c                             discontinuity within the interval) one
c                             will probably gain from splitting up the
c                             interval at this point and calling the
c                             integrator on the subranges. if possible,
c                             an appropriate special-purpose integrator
c                             should be used, which is designed for
c                             handling the type of difficulty involved.
c                         = 2 the occurrence of roundoff error is
c                             detected, which prevents the requested
c                             tolerance from being achieved.
c                             the error may be under-estimated.
c                         = 3 extremely bad integrand behaviour occurs
c                             at some points of the integration
c                             interval.
c                         = 4 the algorithm does not converge.
c                             roundoff error is detected in the
c                             extrapolation table.
c                             it is assumed that the requested tolerance
c                             cannot be achieved, and that the returned
c                             result is the best which can be obtained.
c                         = 5 the integral is probably divergent, or
c                             slowly convergent. it must be noted that
c                             divergence can occur with any other value
c                             of ier.
c                         = 6 the input is invalid, because
c                             (epsabs.le.0 and
c                              epsrel.lt.max(50*rel.mach.acc.,0.5d-28))
c                              or limit.lt.1 or leniw.lt.limit*4.
c                             result, abserr, neval, last are set to
c                             zero. exept when limit or leniw is
c                             invalid, iwork(1), work(limit*2+1) and
c                             work(limit*3+1) are set to zero, work(1)
c                             is set to a and work(limit+1) to b.
c
c         dimensioning parameters
c            limit - integer
c                    dimensioning parameter for iwork
c                    limit determines the maximum number of subintervals
c                    in the partition of the given integration interval
c                    (a,b), limit.ge.1.
c                    if limit.lt.1, the routine will end with ier = 6.
c
c            lenw  - integer
c                    dimensioning parameter for work
c                    lenw must be at least limit*4.
c                    if lenw.lt.limit*4, the routine will end
c                    with ier = 6.
c
c            last  - integer
c                    on return, last equals the number of subintervals
c                    produced in the subdivision process, which
c                    determines the number of significant elements
c                    actually in the work arrays.
c
c         work arrays
c            iwork - integer
c                    vector of dimension at least limit, the first
c                    k elements of which contain pointers
c                    to the error estimates over the subintervals,
c                    such that work(limit*3+iwork(1)),... ,
c                    work(limit*3+iwork(k)) form a decreasing
c                    sequence, with k = last if last.le.(limit/2+2), and
c                    k = limit+1-last otherwise
c
c            work  - real*8
c                    vector of dimension at least lenw
c                    on return
c                    work(1), ..., work(last) contain the left
c                     end points of the subintervals in the
c                     partition of (a,b),
c                    work(limit+1), ..., work(limit+last) contain
c                     the right end points,
c                    work(limit*2+1), ...,work(limit*2+last) contain the
c                     integral approximations over the subintervals,
c                    work(limit*3+1), ..., work(limit*3)
c                     contain the error estimates.
c***references  (none)
c***routines called  dqagie,xerror
c***end prologue  dqagi
c
      real*8 abserr,bound,epsabs,epsrel,f,result,work
      integer ier,inf,iwork,last,lenw,limit,lvl,l1,l2,l3,neval
c
      dimension iwork(limit),work(lenw)
c
      external f
c
c         check validity of limit and lenw.
c
c***first executable statement  dqagi
      ier = 6
      neval = 0
      last = 0
      result = 0.0d+00
      abserr = 0.0d+00
      if(limit.lt.1.or.lenw.lt.limit*4) go to 10
c
c         prepare call for dqagie.
c
      l1 = limit+1
      l2 = limit+l1
      l3 = limit+l2
c
      call dqagie(f,bound,inf,epsabs,epsrel,limit,result,abserr,
     *  neval,ier,work(1),work(l1),work(l2),work(l3),iwork,last)
c
c         call error handler if necessary.
c
       lvl = 0
10    if(ier.eq.6) lvl = 1
      if(ier.ne.0) call xerror('abnormal return from dqagi',26,ier,lvl)
      return
      end
      subroutine dqagie(f,bound,inf,epsabs,epsrel,limit,result,abserr,
     *   neval,ier,alist,blist,rlist,elist,iord,last)
c***begin prologue  dqagie
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a3a1,h2a4a1
c***keywords  automatic integrator, infinite intervals,
c             general-purpose, transformation, extrapolation,
c             globally adaptive
c***author  piessens,robert,appl. math & progr. div - k.u.leuven
c           de doncker,elise,appl. math & progr. div - k.u.leuven
c***purpose  the routine calculates an approximation result to a given
c            integral   i = integral of f over (bound,+infinity)
c            or i = integral of f over (-infinity,bound)
c            or i = integral of f over (-infinity,+infinity),
c            hopefully satisfying following claim for accuracy
c            abs(i-result).le.max(epsabs,epsrel*abs(i))
c***description
c
c integration over infinite intervals
c standard fortran subroutine
c
c            f      - real*8
c                     function subprogram defining the integrand
c                     function f(x). the actual name for f needs to be
c                     declared e x t e r n a l in the driver program.
c
c            bound  - real*8
c                     finite bound of integration range
c                     (has no meaning if interval is doubly-infinite)
c
c            inf    - real*8
c                     indicating the kind of integration range involved
c                     inf = 1 corresponds to  (bound,+infinity),
c                     inf = -1            to  (-infinity,bound),
c                     inf = 2             to (-infinity,+infinity).
c
c            epsabs - real*8
c                     absolute accuracy requested
c            epsrel - real*8
c                     relative accuracy requested
c                     if  epsabs.le.0
c                     and epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
c                     the routine will end with ier = 6.
c
c            limit  - integer
c                     gives an upper bound on the number of subintervals
c                     in the partition of (a,b), limit.ge.1
c
c         on return
c            result - real*8
c                     approximation to the integral
c
c            abserr - real*8
c                     estimate of the modulus of the absolute error,
c                     which should equal or exceed abs(i-result)
c
c            neval  - integer
c                     number of integrand evaluations
c
c            ier    - integer
c                     ier = 0 normal and reliable termination of the
c                             routine. it is assumed that the requested
c                             accuracy has been achieved.
c                   - ier.gt.0 abnormal termination of the routine. the
c                             estimates for result and error are less
c                             reliable. it is assumed that the requested
c                             accuracy has not been achieved.
c            error messages
c                     ier = 1 maximum number of subdivisions allowed
c                             has been achieved. one can allow more
c                             subdivisions by increasing the value of
c                             limit (and taking the according dimension
c                             adjustments into account). however,if
c                             this yields no improvement it is advised
c                             to analyze the integrand in order to
c                             determine the integration difficulties.
c                             if the position of a local difficulty can
c                             be determined (e.g. singularity,
c                             discontinuity within the interval) one
c                             will probably gain from splitting up the
c                             interval at this point and calling the
c                             integrator on the subranges. if possible,
c                             an appropriate special-purpose integrator
c                             should be used, which is designed for
c                             handling the type of difficulty involved.
c                         = 2 the occurrence of roundoff error is
c                             detected, which prevents the requested
c                             tolerance from being achieved.
c                             the error may be under-estimated.
c                         = 3 extremely bad integrand behaviour occurs
c                             at some points of the integration
c                             interval.
c                         = 4 the algorithm does not converge.
c                             roundoff error is detected in the
c                             extrapolation table.
c                             it is assumed that the requested tolerance
c                             cannot be achieved, and that the returned
c                             result is the best which can be obtained.
c                         = 5 the integral is probably divergent, or
c                             slowly convergent. it must be noted that
c                             divergence can occur with any other value
c                             of ier.
c                         = 6 the input is invalid, because
c                             (epsabs.le.0 and
c                              epsrel.lt.max(50*rel.mach.acc.,0.5d-28),
c                             result, abserr, neval, last, rlist(1),
c                             elist(1) and iord(1) are set to zero.
c                             alist(1) and blist(1) are set to 0
c                             and 1 respectively.
c
c            alist  - real*8
c                     vector of dimension at least limit, the first
c                      last  elements of which are the left
c                     end points of the subintervals in the partition
c                     of the transformed integration range (0,1).
c
c            blist  - real*8
c                     vector of dimension at least limit, the first
c                      last  elements of which are the right
c                     end points of the subintervals in the partition
c                     of the transformed integration range (0,1).
c
c            rlist  - real*8
c                     vector of dimension at least limit, the first
c                      last  elements of which are the integral
c                     approximations on the subintervals
c
c            elist  - real*8
c                     vector of dimension at least limit,  the first
c                     last elements of which are the moduli of the
c                     absolute error estimates on the subintervals
c
c            iord   - integer
c                     vector of dimension limit, the first k
c                     elements of which are pointers to the
c                     error estimates over the subintervals,
c                     such that elist(iord(1)), ..., elist(iord(k))
c                     form a decreasing sequence, with k = last
c                     if last.le.(limit/2+2), and k = limit+1-last
c                     otherwise
c
c            last   - integer
c                     number of subintervals actually produced
c                     in the subdivision process
c
c***references  (none)
c***routines called  d1mach,dqelg,dqk15i,dqpsrt
c***end prologue  dqagie
      real*8 abseps,abserr,alist,area,area1,area12,area2,a1,
     *  a2,blist,boun,bound,b1,b2,correc,defabs,defab1,defab2,
     *  dres,d1mach,elist,epmach,epsabs,epsrel,erlarg,erlast,
     *  errbnd,errmax,error1,error2,erro12,errsum,ertest,f,oflow,resabs,
     *  reseps,result,res3la,rlist,rlist2,small,uflow
      integer id,ier,ierro,inf,iord,iroff1,iroff2,iroff3,jupbnd,k,ksgn,
     *  ktmin,last,limit,maxerr,neval,nres,nrmax,numrl2
      logical extrap,noext
c
      dimension alist(limit),blist(limit),elist(limit),iord(limit),
     *  res3la(3),rlist(limit),rlist2(52)
c
      external f
c
c            the dimension of rlist2 is determined by the value of
c            limexp in subroutine dqelg.
c
c
c            list of major variables
c            -----------------------
c
c           alist     - list of left end points of all subintervals
c                       considered up to now
c           blist     - list of right end points of all subintervals
c                       considered up to now
c           rlist(i)  - approximation to the integral over
c                       (alist(i),blist(i))
c           rlist2    - array of dimension at least (limexp+2),
c                       containing the part of the epsilon table
c                       wich is still needed for further computations
c           elist(i)  - error estimate applying to rlist(i)
c           maxerr    - pointer to the interval with largest error
c                       estimate
c           errmax    - elist(maxerr)
c           erlast    - error on the interval currently subdivided
c                       (before that subdivision has taken place)
c           area      - sum of the integrals over the subintervals
c           errsum    - sum of the errors over the subintervals
c           errbnd    - requested accuracy max(epsabs,epsrel*
c                       abs(result))
c           *****1    - variable for the left subinterval
c           *****2    - variable for the right subinterval
c           last      - index for subdivision
c           nres      - number of calls to the extrapolation routine
c           numrl2    - number of elements currently in rlist2. if an
c                       appropriate approximation to the compounded
c                       integral has been obtained, it is put in
c                       rlist2(numrl2) after numrl2 has been increased
c                       by one.
c           small     - length of the smallest interval considered up
c                       to now, multiplied by 1.5
c           erlarg    - sum of the errors over the intervals larger
c                       than the smallest interval considered up to now
c           extrap    - logical variable denoting that the routine
c                       is attempting to perform extrapolation. i.e.
c                       before subdividing the smallest interval we
c                       try to decrease the value of erlarg.
c           noext     - logical variable denoting that extrapolation
c                       is no longer allowed (true-value)
c
c            machine dependent constants
c            ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c           oflow is the largest positive magnitude.
c
c***first executable statement  dqagie
       epmach = d1mach(4)
c
c           test on validity of parameters
c           -----------------------------
c
      ier = 0
      neval = 0
      last = 0
      result = 0.0d+00
      abserr = 0.0d+00
      alist(1) = 0.0d+00
      blist(1) = 0.1d+01
      rlist(1) = 0.0d+00
      elist(1) = 0.0d+00
      iord(1) = 0
*
      correc = 0.0d+00 ! dummy initialize
      erlarg = 0.0d+00 ! dummy initialize
      ertest = 0.0d+00 ! dummy initialize
      small  = 0.0d+00 ! dummy initialize
*
      if(epsabs.le.0.0d+00.and.epsrel.lt.max(0.5d+02*epmach,0.5d-28))
     *  ier = 6
       if(ier.eq.6) go to 999
c
c
c           first approximation to the integral
c           -----------------------------------
c
c           determine the interval to be mapped onto (0,1).
c           if inf = 2 the integral is computed as i = i1+i2, where
c           i1 = integral of f over (-infinity,0),
c           i2 = integral of f over (0,+infinity).
c
      boun = bound
      if(inf.eq.2) boun = 0.0d+00
      call dqk15i(f,boun,inf,0.0d+00,0.1d+01,result,abserr,
     *  defabs,resabs)
c
c           test on accuracy
c
      last = 1
      rlist(1) = result
      elist(1) = abserr
      iord(1) = 1
      dres = abs(result)
      errbnd = max(epsabs,epsrel*dres)
      if(abserr.le.1.0d+02*epmach*defabs.and.abserr.gt.errbnd) ier = 2
      if(limit.eq.1) ier = 1
      if(ier.ne.0.or.(abserr.le.errbnd.and.abserr.ne.resabs).or.
     *  abserr.eq.0.0d+00) go to 130
c
c           initialization
c           --------------
c
      uflow = d1mach(1)
      oflow = d1mach(2)
      rlist2(1) = result
      errmax = abserr
      maxerr = 1
      area = result
      errsum = abserr
      abserr = oflow
      nrmax = 1
      nres = 0
      ktmin = 0
      numrl2 = 2
      extrap = .false.
      noext = .false.
      ierro = 0
      iroff1 = 0
      iroff2 = 0
      iroff3 = 0
      ksgn = -1
      if(dres.ge.(0.1d+01-0.5d+02*epmach)*defabs) ksgn = 1
c
c           main do-loop
c           ------------
c
      do 90 last = 2,limit
c
c           bisect the subinterval with nrmax-th largest error estimate.
c
        a1 = alist(maxerr)
        b1 = 0.5d+00*(alist(maxerr)+blist(maxerr))
        a2 = b1
        b2 = blist(maxerr)
        erlast = errmax
        call dqk15i(f,boun,inf,a1,b1,area1,error1,resabs,defab1)
        call dqk15i(f,boun,inf,a2,b2,area2,error2,resabs,defab2)
c
c           improve previous approximations to integral
c           and error and test for accuracy.
c
        area12 = area1+area2
        erro12 = error1+error2
        errsum = errsum+erro12-errmax
        area = area+area12-rlist(maxerr)
        if(defab1.eq.error1.or.defab2.eq.error2)go to 15
        if(abs(rlist(maxerr)-area12).gt.0.1d-04*abs(area12)
     *  .or.erro12.lt.0.99d+00*errmax) go to 10
        if(extrap) iroff2 = iroff2+1
        if(.not.extrap) iroff1 = iroff1+1
   10   if(last.gt.10.and.erro12.gt.errmax) iroff3 = iroff3+1
   15   rlist(maxerr) = area1
        rlist(last) = area2
        errbnd = max(epsabs,epsrel*abs(area))
c
c           test for roundoff error and eventually set error flag.
c
        if(iroff1+iroff2.ge.10.or.iroff3.ge.20) ier = 2
        if(iroff2.ge.5) ierro = 3
c
c           set error flag in the case that the number of
c           subintervals equals limit.
c
        if(last.eq.limit) ier = 1
c
c           set error flag in the case of bad integrand behaviour
c           at some points of the integration range.
c
        if(max(abs(a1),abs(b2)).le.(0.1d+01+0.1d+03*epmach)*
     *  (abs(a2)+0.1d+04*uflow)) ier = 4
c
c           append the newly-created intervals to the list.
c
        if(error2.gt.error1) go to 20
        alist(last) = a2
        blist(maxerr) = b1
        blist(last) = b2
        elist(maxerr) = error1
        elist(last) = error2
        go to 30
   20   alist(maxerr) = a2
        alist(last) = a1
        blist(last) = b1
        rlist(maxerr) = area2
        rlist(last) = area1
        elist(maxerr) = error2
        elist(last) = error1
c
c           call subroutine dqpsrt to maintain the descending ordering
c           in the list of error estimates and select the subinterval
c           with nrmax-th largest error estimate (to be bisected next).
c
   30   call dqpsrt(limit,last,maxerr,errmax,elist,iord,nrmax)
        if(errsum.le.errbnd) go to 115
        if(ier.ne.0) go to 100
        if(last.eq.2) go to 80
        if(noext) go to 90
        erlarg = erlarg-erlast
        if(abs(b1-a1).gt.small) erlarg = erlarg+erro12
        if(extrap) go to 40
c
c           test whether the interval to be bisected next is the
c           smallest interval.
c
        if(abs(blist(maxerr)-alist(maxerr)).gt.small) go to 90
        extrap = .true.
        nrmax = 2
   40   if(ierro.eq.3.or.erlarg.le.ertest) go to 60
c
c           the smallest interval has the largest error.
c           before bisecting decrease the sum of the errors over the
c           larger intervals (erlarg) and perform extrapolation.
c
        id = nrmax
        jupbnd = last
        if(last.gt.(2+limit/2)) jupbnd = limit+3-last
        do 50 k = id,jupbnd
          maxerr = iord(nrmax)
          errmax = elist(maxerr)
          if(abs(blist(maxerr)-alist(maxerr)).gt.small) go to 90
          nrmax = nrmax+1
   50   continue
c
c           perform extrapolation.
c
   60   numrl2 = numrl2+1
        rlist2(numrl2) = area
        call dqelg(numrl2,rlist2,reseps,abseps,res3la,nres)
        ktmin = ktmin+1
        if(ktmin.gt.5.and.abserr.lt.0.1d-02*errsum) ier = 5
        if(abseps.ge.abserr) go to 70
        ktmin = 0
        abserr = abseps
        result = reseps
        correc = erlarg
        ertest = max(epsabs,epsrel*abs(reseps))
        if(abserr.le.ertest) go to 100
c
c            prepare bisection of the smallest interval.
c
   70   if(numrl2.eq.1) noext = .true.
        if(ier.eq.5) go to 100
        maxerr = iord(1)
        errmax = elist(maxerr)
        nrmax = 1
        extrap = .false.
        small = small*0.5d+00
        erlarg = errsum
        go to 90
   80   small = 0.375d+00
        erlarg = errsum
        ertest = errbnd
        rlist2(2) = area
   90 continue
c
c           set final result and error estimate.
c           ------------------------------------
c
  100 if(abserr.eq.oflow) go to 115
      if((ier+ierro).eq.0) go to 110
      if(ierro.eq.3) abserr = abserr+correc
      if(ier.eq.0) ier = 3
      if(result.ne.0.0d+00.and.area.ne.0.0d+00)go to 105
      if(abserr.gt.errsum)go to 115
      if(area.eq.0.0d+00) go to 130
      go to 110
  105 if(abserr/abs(result).gt.errsum/abs(area))go to 115
c
c           test on divergence
c
  110 if(ksgn.eq.(-1).and.max(abs(result),abs(area)).le.
     * defabs*0.1d-01) go to 130
      if(0.1d-01.gt.(result/area).or.(result/area).gt.0.1d+03.
     *or.errsum.gt.abs(area)) ier = 6
      go to 130
c
c           compute global integral sum.
c
  115 result = 0.0d+00
      do 120 k = 1,last
        result = result+rlist(k)
  120 continue
      abserr = errsum
  130 neval = 30*last-15
      if(inf.eq.2) neval = 2*neval
      if(ier.gt.2) ier=ier-1
  999 return
      end
      subroutine dqelg(n,epstab,result,abserr,res3la,nres)
c***begin prologue  dqelg
c***refer to  dqagie,dqagoe,dqagpe,dqagse
c***routines called  d1mach
c***revision date  830518   (yymmdd)
c***keywords  epsilon algorithm, convergence acceleration,
c             extrapolation
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math & progr. div. - k.u.leuven
c***purpose  the routine determines the limit of a given sequence of
c            approximations, by means of the epsilon algorithm of
c            p.wynn. an estimate of the absolute error is also given.
c            the condensed epsilon table is computed. only those
c            elements needed for the computation of the next diagonal
c            are preserved.
c***description
c
c           epsilon algorithm
c           standard fortran subroutine
c           real*8 version
c
c           parameters
c              n      - integer
c                       epstab(n) contains the new element in the
c                       first column of the epsilon table.
c
c              epstab - real*8
c                       vector of dimension 52 containing the elements
c                       of the two lower diagonals of the triangular
c                       epsilon table. the elements are numbered
c                       starting at the right-hand corner of the
c                       triangle.
c
c              result - real*8
c                       resulting approximation to the integral
c
c              abserr - real*8
c                       estimate of the absolute error computed from
c                       result and the 3 previous results
c
c              res3la - real*8
c                       vector of dimension 3 containing the last 3
c                       results
c
c              nres   - integer
c                       number of calls to the routine
c                       (should be zero at first call)
c
c***end prologue  dqelg
c
      real*8 abserr,delta1,delta2,delta3,d1mach,
     *  epmach,epsinf,epstab,error,err1,err2,err3,e0,e1,e1abs,e2,e3,
     *  oflow,res,result,res3la,ss,tol1,tol2,tol3
      integer i,ib,ib2,ie,indx,k1,k2,k3,limexp,n,newelm,nres,num
      dimension epstab(52),res3la(3)
c
c           list of major variables
c           -----------------------
c
c           e0     - the 4 elements on which the computation of a new
c           e1       element in the epsilon table is based
c           e2
c           e3                 e0
c                        e3    e1    new
c                              e2
c           newelm - number of elements to be computed in the new
c                    diagonal
c           error  - error = abs(e1-e0)+abs(e2-e1)+abs(new-e2)
c           result - the element in the new diagonal with least value
c                    of error
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           oflow is the largest positive magnitude.
c           limexp is the maximum number of elements the epsilon
c           table can contain. if this number is reached, the upper
c           diagonal of the epsilon table is deleted.
c
c***first executable statement  dqelg
      epmach = d1mach(4)
      oflow = d1mach(2)
      nres = nres+1
      abserr = oflow
      result = epstab(n)
      if(n.lt.3) go to 100
      limexp = 50
      epstab(n+2) = epstab(n)
      newelm = (n-1)/2
      epstab(n) = oflow
      num = n
      k1 = n
      do 40 i = 1,newelm
        k2 = k1-1
        k3 = k1-2
        res = epstab(k1+2)
        e0 = epstab(k3)
        e1 = epstab(k2)
        e2 = res
        e1abs = abs(e1)
        delta2 = e2-e1
        err2 = abs(delta2)
        tol2 = max(abs(e2),e1abs)*epmach
        delta3 = e1-e0
        err3 = abs(delta3)
        tol3 = max(e1abs,abs(e0))*epmach
        if(err2.gt.tol2.or.err3.gt.tol3) go to 10
c
c           if e0, e1 and e2 are equal to within machine
c           accuracy, convergence is assumed.
c           result = e2
c           abserr = abs(e1-e0)+abs(e2-e1)
c
        result = res
        abserr = err2+err3
c ***jump out of do-loop
        go to 100
   10   e3 = epstab(k1)
        epstab(k1) = e1
        delta1 = e1-e3
        err1 = abs(delta1)
        tol1 = max(e1abs,abs(e3))*epmach
c
c           if two elements are very close to each other, omit
c           a part of the table by adjusting the value of n
c
        if(err1.le.tol1.or.err2.le.tol2.or.err3.le.tol3) go to 20
        ss = 0.1d+01/delta1+0.1d+01/delta2-0.1d+01/delta3
        epsinf = abs(ss*e1)
c
c           test to detect irregular behaviour in the table, and
c           eventually omit a part of the table adjusting the value
c           of n.
c
        if(epsinf.gt.0.1d-03) go to 30
   20   n = i+i-1
c ***jump out of do-loop
        go to 50
c
c           compute a new element and eventually adjust
c           the value of result.
c
   30   res = e1+0.1d+01/ss
        epstab(k1) = res
        k1 = k1-2
        error = err2+abs(res-e2)+err3
        if(error.gt.abserr) go to 40
        abserr = error
        result = res
   40 continue
c
c           shift the table.
c
   50 if(n.eq.limexp) n = 2*(limexp/2)-1
      ib = 1
      if((num/2)*2.eq.num) ib = 2
      ie = newelm+1
      do 60 i=1,ie
        ib2 = ib+2
        epstab(ib) = epstab(ib2)
        ib = ib2
   60 continue
      if(num.eq.n) go to 80
      indx = num-n+1
      do 70 i = 1,n
        epstab(i)= epstab(indx)
        indx = indx+1
   70 continue
   80 if(nres.ge.4) go to 90
      res3la(nres) = result
      abserr = oflow
      go to 100
c
c           compute error estimate
c
   90 abserr = abs(result-res3la(3))+abs(result-res3la(2))
     *  +abs(result-res3la(1))
      res3la(1) = res3la(2)
      res3la(2) = res3la(3)
      res3la(3) = result
  100 abserr = max(abserr,0.5d+01*epmach*abs(result))
      return
      end
      subroutine dqk15i(f,boun,inf,a,b,result,abserr,resabs,resasc)
c***begin prologue  dqk15i
c***date written   800101   (yymmdd)
c***revision date  830518   (yymmdd)
c***category no.  h2a3a2,h2a4a2
c***keywords  15-point transformed gauss-kronrod rules
c***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
c           de doncker,elise,appl. math. & progr. div. - k.u.leuven
c***purpose  the original (infinite integration range is mapped
c            onto the interval (0,1) and (a,b) is a part of (0,1).
c            it is the purpose to compute
c            i = integral of transformed integrand over (a,b),
c            j = integral of abs(transformed integrand) over (a,b).
c***description
c
c           integration rule
c           standard fortran subroutine
c           real*8 version
c
c           parameters
c            on entry
c              f      - real*8
c                       fuction subprogram defining the integrand
c                       function f(x). the actual name for f needs to be
c                       declared e x t e r n a l in the calling program.
c
c              boun   - real*8
c                       finite bound of original integration
c                       range (set to zero if inf = +2)
c
c              inf    - integer
c                       if inf = -1, the original interval is
c                                   (-infinity,bound),
c                       if inf = +1, the original interval is
c                                   (bound,+infinity),
c                       if inf = +2, the original interval is
c                                   (-infinity,+infinity) and
c                       the integral is computed as the sum of two
c                       integrals, one over (-infinity,0) and one over
c                       (0,+infinity).
c
c              a      - real*8
c                       lower limit for integration over subrange
c                       of (0,1)
c
c              b      - real*8
c                       upper limit for integration over subrange
c                       of (0,1)
c
c            on return
c              result - real*8
c                       approximation to the integral i
c                       result is computed by applying the 15-point
c                       kronrod rule(resk) obtained by optimal addition
c                       of abscissae to the 7-point gauss rule(resg).
c
c              abserr - real*8
c                       estimate of the modulus of the absolute error,
c                       which should equal or exceed abs(i-result)
c
c              resabs - real*8
c                       approximation to the integral j
c
c              resasc - real*8
c                       approximation to the integral of
c                       abs((transformed integrand)-i/(b-a)) over (a,b)
c
c***references  (none)
c***routines called  d1mach
c***end prologue  dqk15i
c
      real*8 a,absc,absc1,absc2,abserr,b,boun,centr,dinf,
     *  d1mach,epmach,f,fc,fsum,fval1,fval2,fv1,fv2,hlgth,
     *  resabs,resasc,resg,resk,reskh,result,tabsc1,tabsc2,uflow,wg,wgk,
     *  xgk
      integer inf,j
      external f
c
      dimension fv1(7),fv2(7),xgk(8),wgk(8),wg(8)
c
c           the abscissae and weights are supplied for the interval
c           (-1,1).  because of symmetry only the positive abscissae and
c           their corresponding weights are given.
c
c           xgk    - abscissae of the 15-point kronrod rule
c                    xgk(2), xgk(4), ... abscissae of the 7-point
c                    gauss rule
c                    xgk(1), xgk(3), ...  abscissae which are optimally
c                    added to the 7-point gauss rule
c
c           wgk    - weights of the 15-point kronrod rule
c
c           wg     - weights of the 7-point gauss rule, corresponding
c                    to the abscissae xgk(2), xgk(4), ...
c                    wg(1), wg(3), ... are set to zero.
c
      data wg(1) / 0.0d0 /
      data wg(2) / 0.1294849661 6886969327 0611432679 082d0 /
      data wg(3) / 0.0d0 /
      data wg(4) / 0.2797053914 8927666790 1467771423 780d0 /
      data wg(5) / 0.0d0 /
      data wg(6) / 0.3818300505 0511894495 0369775488 975d0 /
      data wg(7) / 0.0d0 /
      data wg(8) / 0.4179591836 7346938775 5102040816 327d0 /
c
      data xgk(1) / 0.9914553711 2081263920 6854697526 329d0 /
      data xgk(2) / 0.9491079123 4275852452 6189684047 851d0 /
      data xgk(3) / 0.8648644233 5976907278 9712788640 926d0 /
      data xgk(4) / 0.7415311855 9939443986 3864773280 788d0 /
      data xgk(5) / 0.5860872354 6769113029 4144838258 730d0 /
      data xgk(6) / 0.4058451513 7739716690 6606412076 961d0 /
      data xgk(7) / 0.2077849550 0789846760 0689403773 245d0 /
      data xgk(8) / 0.0000000000 0000000000 0000000000 000d0 /
c
      data wgk(1) / 0.0229353220 1052922496 3732008058 970d0 /
      data wgk(2) / 0.0630920926 2997855329 0700663189 204d0 /
      data wgk(3) / 0.1047900103 2225018383 9876322541 518d0 /
      data wgk(4) / 0.1406532597 1552591874 5189590510 238d0 /
      data wgk(5) / 0.1690047266 3926790282 6583426598 550d0 /
      data wgk(6) / 0.1903505780 6478540991 3256402421 014d0 /
      data wgk(7) / 0.2044329400 7529889241 4161999234 649d0 /
      data wgk(8) / 0.2094821410 8472782801 2999174891 714d0 /
c
c
c           list of major variables
c           -----------------------
c
c           centr  - mid point of the interval
c           hlgth  - half-length of the interval
c           absc*  - abscissa
c           tabsc* - transformed abscissa
c           fval*  - function value
c           resg   - result of the 7-point gauss formula
c           resk   - result of the 15-point kronrod formula
c           reskh  - approximation to the mean value of the transformed
c                    integrand over (a,b), i.e. to i/(b-a)
c
c           machine dependent constants
c           ---------------------------
c
c           epmach is the largest relative spacing.
c           uflow is the smallest positive magnitude.
c
c***first executable statement  dqk15i
      epmach = d1mach(4)
      uflow = d1mach(1)
      dinf = min(1,inf)
c
      centr = 0.5d+00*(a+b)
      hlgth = 0.5d+00*(b-a)
      tabsc1 = boun+dinf*(0.1d+01-centr)/centr
      fval1 = f(tabsc1)
      if(inf.eq.2) fval1 = fval1+f(-tabsc1)
      fc = (fval1/centr)/centr
c
c           compute the 15-point kronrod approximation to
c           the integral, and estimate the error.
c
      resg = wg(8)*fc
      resk = wgk(8)*fc
      resabs = abs(resk)
      do 10 j=1,7
        absc = hlgth*xgk(j)
        absc1 = centr-absc
        absc2 = centr+absc
        tabsc1 = boun+dinf*(0.1d+01-absc1)/absc1
        tabsc2 = boun+dinf*(0.1d+01-absc2)/absc2
        fval1 = f(tabsc1)
        fval2 = f(tabsc2)
        if(inf.eq.2) fval1 = fval1+f(-tabsc1)
        if(inf.eq.2) fval2 = fval2+f(-tabsc2)
        fval1 = (fval1/absc1)/absc1
        fval2 = (fval2/absc2)/absc2
        fv1(j) = fval1
        fv2(j) = fval2
        fsum = fval1+fval2
        resg = resg+wg(j)*fsum
        resk = resk+wgk(j)*fsum
        resabs = resabs+wgk(j)*(abs(fval1)+abs(fval2))
   10 continue
      reskh = resk*0.5d+00
      resasc = wgk(8)*abs(fc-reskh)
      do 20 j=1,7
        resasc = resasc+wgk(j)*(abs(fv1(j)-reskh)+abs(fv2(j)-reskh))
   20 continue
      result = resk*hlgth
      resasc = resasc*hlgth
      resabs = resabs*hlgth
      abserr = abs((resk-resg)*hlgth)
      if(resasc.ne.0.0d+00.and.abserr.ne.0.d0) abserr = resasc*
     * min(0.1d+01,(0.2d+03*abserr/resasc)**1.5d+00)
      if(resabs.gt.uflow/(0.5d+02*epmach)) abserr = max
     * ((epmach*0.5d+02)*resabs,abserr)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DstInf(iStop,Just_Frequencies)

use Symmetry_Info, only: iOper, nIrrep
use Slapaf_Info, only: AtomLbl, Coor, Cx, Dmp_Slapaf, dqInt, Energy, iOptC, iter, lOld_Implicit, Max_Center, MaxItr, MF, mTROld, &
                       Numerical, qInt, RtRnc, SlStop, Weights
use UnixInfo, only: SuperName
use PrintLevel, only: nPrint
use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iStop
logical(kind=iwp), intent(in) :: Just_Frequencies
integer(kind=iwp) :: i, iDo_dDipM, iIrrep, iOff, iPrint, iRout, isAtom, iTemp, j, jsAtom, LOut, Lu_xyz, N_ZMAT, nCoord, nsAtom_p, &
                     nTemp
real(kind=wp) :: r, r_Iter, x1, x2, xWeight, y1, y2, z1, z2
logical(kind=iwp) :: do_fullprintcoords, do_printcoords, Found
character(len=LenIn), allocatable :: LblTMP(:)
character(len=2), allocatable :: Element(:)
real(kind=wp), allocatable :: CC(:,:), Cx_p(:,:), RV(:,:), xyz(:,:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 53
iPrint = nPrint(iRout)
do_printcoords = iPrint >= 5
do_fullprintcoords = ((iPrint > 5) .or. (iStop > 1))
LOut = u6
!                                                                      *
!***********************************************************************
!                                                                      *
! Write information of this iteration to the RLXITR file

call Dmp_Slapaf(SlStop,Just_Frequencies,Energy(1),iter,MaxItr,mTROld,lOld_Implicit,size(Coor,2))

if (SuperName /= 'numerical_gradient') then
  call Put_dArray('qInt',qInt,size(qInt))
  call Put_dArray('dqInt',dqInt,size(dqInt))
end if

if (Just_Frequencies) return
!                                                                      *
!***********************************************************************
!                                                                      *
! Geometry information

if (SlStop .or. do_printcoords) then
  write(LOut,*)
  call CollapseOutput(1,'Geometry section')
  write(LOut,*)
  write(LOut,'(A)') repeat('*',80)
  if (SlStop) then
    write(LOut,*) ' Geometrical information of the final structure'
    r_Iter = real(Iter,kind=wp)
    call Add_Info('GEO_ITER',[r_Iter],1,8)
  else if (do_printcoords) then
    write(LOut,*) ' Geometrical information of the new structure'
  end if
  write(LOut,'(A)') repeat('*',80)
  write(LOut,*)
end if

call Get_iScalar('Pseudo atoms',nsAtom_p)
if (nsAtom_p > 0) then
  call mma_allocate(Cx_p,3,nsAtom_p,Label='Cx_p')
  call Get_dArray('Pseudo Coordinates',Cx_p,3*nsAtom_p)
end if

call mma_Allocate(CC,3,nIrrep*(size(Coor,2)+nsAtom_p),Label='CC')
nTemp = 0
call mma_Allocate(LblTMP,nIrrep*(size(Coor,2)+nsAtom_p),Label='LblTMP')
do isAtom=1,size(Coor,2)+nsAtom_p
  if (isAtom <= size(Coor,2)) then
    x1 = Coor(1,isAtom)
    y1 = Coor(2,isAtom)
    z1 = Coor(3,isAtom)
  else
    jsAtom = isAtom-size(Coor,2)
    x1 = Cx_p(1,jsAtom)
    y1 = Cx_p(2,jsAtom)
    z1 = Cx_p(3,jsAtom)
  end if
  doirrep: do iIrrep=0,nIrrep-1
    x2 = x1
    if (btest(iOper(iIrrep),0)) x2 = -x2
    y2 = y1
    if (btest(iOper(iIrrep),1)) y2 = -y2
    z2 = z1
    if (btest(iOper(iIrrep),2)) z2 = -z2

    ! Check if it is already in the list

    do iTemp=1,nTemp
      r = (x2-CC(1,iTemp))**2+(y2-CC(2,iTemp))**2+(z2-CC(3,iTemp))**2
      if (r == Zero) cycle doirrep
    end do
    nTemp = nTemp+1
    if (nTemp > nIrrep*(size(Coor,2)+nsAtom_p)) then
      call WarningMessage(2,'Error in DstInf')
      write(u6,*) 'nTemp > nIrrep*size(Coor,2)'
      call Abend()
    end if
    CC(1,nTemp) = x2
    CC(2,nTemp) = y2
    CC(3,nTemp) = z2
    if (isAtom <= size(Coor,2)) then
      LblTMP(nTemp) = AtomLbl(isAtom)
    else
      LblTMP(nTemp) = 'PC'
    end if
  end do doirrep
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out the new cartesian symmetry coordinates.

if (SlStop) then
  write(LOut,*) ' NOTE: on convergence the final predicted structure will be printed here.'
  write(LOut,*) ' This is not identical to the structure printed in the head of the output.'
  call OutCoor('* Nuclear coordinates of the final structure / bohr     *',AtomLbl,size(Coor,2),Coor,3,size(Coor,2),.false.)
  call OutCoor('* Nuclear coordinates of the final structure / angstrom *',AtomLbl,size(Coor,2),Coor,3,size(Coor,2),.true.)
else if (Do_PrintCoords) then
  call OutCoor('* Nuclear coordinates for the next iteration / bohr     *',AtomLbl,size(Coor,2),Coor,3,size(Coor,2),.false.)
  call OutCoor('* Nuclear coordinates for the next iteration / angstrom *',AtomLbl,size(Coor,2),Coor,3,size(Coor,2),.true.)
end if

if (nsAtom_p > 0) then
  iOff = nTemp-nsAtom_p+1
  call OutCoor('* Pseudo charge coordinates for the next iteration / bohr     *',LblTMP(iOff),nsAtom_p,Cx_p,3,nsAtom_p,.false.)
  call OutCoor('* Pseudo Charge coordinates for the next iteration / angstrom *',LblTMP(iOff),nsAtom_p,Cx_p,3,nsAtom_p,.true.)
  call mma_deallocate(Cx_p)
end if

if (do_printcoords) then
  call Get_iScalar('N ZMAT',N_ZMAT)
  if (N_ZMAT > 0) call OutZMAT(size(Coor,2),Coor,N_ZMAT)

  if (do_fullprintcoords) then
    if (nTemp >= 2) call Dstncs(LblTMP,CC,nTemp,Angstrom,Max_Center,5)

    if (nTemp >= 3) call Angles(LblTMP,CC,nTemp,Rtrnc,Max_Center)

    if (nTemp >= 4) call Dihedr(LblTMP,CC,nTemp,Rtrnc,Max_Center)
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(LblTMP)
call mma_deallocate(CC)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write the new cartesian symmetry coordinates on GEONEW

call Put_Coord_New(Cx(1,1,iter+1),size(Coor,2))
!                                                                      *
!***********************************************************************
!                                                                      *
! If two runfiles are associated with the calculation update both files.

call f_Inquire('RUNFILE2',Found)
if (Found) then
  call NameRun('RUNFILE2')
  call Put_Coord_New(Cx(1,1,iter+1),size(Coor,2))
  call NameRun('#Pop')
end if

! Update the .Opt.xyz file

if (.not. Numerical) then
  call Get_nAtoms_All(nCoord)
  call mma_allocate(xyz,3,nCoord,Label='xyz')
  call mma_allocate(Element,nCoord,Label='Element')
  call Get_Coord_New_All(xyz,nCoord)
  call Get_Name_All(Element)

  Lu_xyz = IsFreeUnit(11)
  call MOLCAS_Open(Lu_xyz,'XYZ')
  write(Lu_xyz,'(I4)') nCoord
  write(Lu_xyz,*) Energy(1+Iter)
  !write(Lu_xyz,'(A)') 'Coordinates generated by Slapaf'
  do i=1,nCoord
    write(Lu_xyz,'(A2,3F15.8)') Element(i),(Angstrom*xyz(j,i),j=1,3)
  end do
  close(Lu_xyz)
  call mma_deallocate(Element)
  call mma_deallocate(xyz)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! If a transition state optimization put the "reaction" vector
! on the RUNFILE(S)

if ((.not. btest(iOptC,7)) .and. SlStop) then

  call mma_allocate(RV,3,size(Coor,2),Label='RV')
  RV(:,:) = MF(:,:)
  do i=1,size(Coor,2)
    xWeight = Weights(i)
    RV(:,i) = RV(:,i)/xWeight
  end do
  call OutCoor('* The Cartesian Reaction vector                         *',AtomLbl,size(Coor,2),RV,3,size(Coor,2),.true.)

  call f_Inquire('RUNREAC',Found)
  if (Found) then
    call NameRun('RUNREAC')
    call Put_dArray('Reaction Vector',RV,3*size(Coor,2))
    call NameRun('#Pop')
  end if
  call f_Inquire('RUNPROD',Found)
  if (Found) then
    call NameRun('RUNPROD')
    call Put_dArray('Reaction Vector',RV,3*size(Coor,2))
    call NameRun('#Pop')
  end if
  call Put_dArray('Reaction Vector',RV,3*size(Coor,2))
  call mma_deallocate(RV)
  iDo_dDipM = 0
  call GF_on_the_fly(iDo_dDipM)

end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (SlStop .or. do_printcoords) call CollapseOutput(0,'Geometry section')

end subroutine DstInf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Rys2D(xyz2D,nArg,lRys,nabMax,ncdMax,PAWP,QCWQ,
     &                 B10,laa,B00,lac,B01,lcc)
************************************************************************
*                                                                      *
* Object: to compute the 2-dimensional integrals of the Rys            *
*         quadrature. The z components are assumed to be pre-          *
*         conditioned with the weights of the roots of the             *
*         Rys polynomial.                                              *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
* Modified loop structure for RISC 1991 R. Lindh Dept. of Theoretical  *
* Chemistry, University of Lund, Sweden.                               *
* VV: improve loop structure                                           *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 xyz2D(nArg*lRys*3,0:nabMax,0:ncdMax),
     &       PAWP(nArg*lRys*3), QCWQ(nArg*lRys*3),
     &       B10(nArg*lRys*3), B00(nArg*lRys*3),
     &       B01(nArg*lRys*3)
#ifdef _DEBUGPRINT_
      Character*30 Label
#endif
*
      iRout = 15
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      iPrint=99
      If (iPrint.ge.59) Then
         If (nabMax.gt.0) Call RecPrt('PAWP',' ',PAWP,nArg,lRys*3)
         If (ncdMax.gt.0) Call RecPrt('QCWQ',' ',QCWQ,nArg,lRys*3)
         If (laa.ne.0) Call RecPrt(' B10',' ',B10,nArg*lRys,3)
         If (lac.ne.0) Call RecPrt(' B00',' ',B00,nArg*lRys,3)
         If (lcc.ne.0) Call RecPrt(' B01',' ',B01,nArg*lRys,3)
      End If
#endif
*
*     Compute 2D integrals with index (0,0). Observe that the z
*     component already contains the weight factor.
*
      call dcopy_(2*nArg*lRys,[One],0,xyz2D(1,0,0),1)
*
*     Compute 2D integrals with index (i,0)
*
      If (nabMax.ne.0) Then
         Do 201 i = 1, nArg*lRys*3
            xyz2D(i,1,0) = PAWP(i) * xyz2D(i,0,0)
 201     Continue
      End If
      If (nabMax.eq.2) Then
         Do 210 i = 1, nArg*lRys*3
            xyz2D(i,2,0) = PAWP(i) * xyz2D(i,1,0)
     &                       + B10(i) * xyz2D(i,0,0)
 210     Continue
      Else If (nabMax.gt.2) Then
         Do 250 iab = 1, nabMax-1
            Do 260 i = 1, nArg*lRys*3
               temp1 = PAWP(i) * xyz2D(i,iab,0)
               temp2 = Dble(iab) * B10(i) * xyz2D(i,iab-1,0)
               xyz2D(i,iab+1,0) = temp1 + temp2
 260        Continue
 250     Continue
      End If
*
*     Compute 2D integrals with index (0,i)
*
      If (ncdMax.ne.0) Then
         Do 301 i = 1, nArg*lRys*3
            xyz2D(i,0,1) = QCWQ(i) * xyz2D(i,0,0)
 301     Continue
      End If
      If (ncdMax.eq.2) Then
         Do 310 i = 1, nArg*lRys*3
            xyz2D(i,0,2) = QCWQ(i) * xyz2D(i,0,1)
     &                       + B01(i) * xyz2D(i,0,0)
 310     Continue
      Else If (ncdMax.gt.2) Then
         Do 350 icd = 1, ncdMax-1
            Do 360 i = 1, nArg*lRys*3
               temp1 = QCWQ(i) * xyz2D(i,0,icd)
               temp2 = Dble(icd) * B01(i) * xyz2D(i,0,icd-1)
               xyz2D(i,0,icd+1) = temp1 + temp2
 360        Continue
 350     Continue
      End If
*
*     Compute 2D integrals with index (i,j)
*
      If (ncdMax.le.nabMax) Then
         Do 400 icd = 1, ncdMax
            Do 425 i = 1, nArg*lRys*3
               xyz2D(i,1,icd) = PAWP(i) * xyz2D(i,0,icd)
     &                        + Dble(icd) * B00(i) * xyz2D(i,0,icd-1)
 425        Continue
            If (nabMax.eq.2) Then
               Do 420 i = 1, nArg*lRys*3
                  xyz2D(i,2,icd) = PAWP(i) * xyz2D(i,1,icd)
     &                           +  B10(i) * xyz2D(i,0,icd)
     &                           + Dble(icd) *B00(i) *xyz2D(i,1,icd-1)
 420           Continue
            Else If (nabMax.gt.2) Then
               Do 450 iab = 1, nabMax-1
                  Do 460 i = 1, nArg*lRys*3
                     temp1 = PAWP(i) * xyz2D(i,iab,icd)
                     temp2 = Dble(iab) *B10(i) *xyz2D(i,iab-1,icd)
                     temp3 = Dble(icd) *B00(i) *xyz2D(i,iab,icd-1)
                     xyz2D(i,iab+1,icd) = temp1 + temp2 + temp3
 460              Continue
 450           Continue
            End If
 400     Continue
      Else
         Do 500 iab = 1, nabMax
            Do 525 i = 1, nArg*lRys*3
               xyz2D(i,iab,1) = QCWQ(i) *xyz2D(i,iab,0)
     &                        + Dble(iab) *B00(i) *xyz2D(i,iab-1,0)
 525        Continue
            If (ncdMax.eq.2) Then
               Do 520 i = 1, nArg*lRys*3
                  xyz2D(i,iab,2) = QCWQ(i) *xyz2D(i,iab,1)
     &                           + B01(i) *xyz2D(i,iab,0)
     &                           + Dble(iab) *B00(i) *xyz2D(i,iab-1,1)
 520           Continue
            Else If (ncdMax.gt.2) Then
               Do 550 icd = 1, ncdmax-1
                  Do 560 i = 1, nArg*lRys*3
                     temp1 = QCWQ(i) *xyz2D(i,iab,icd)
                     temp2 = Dble(icd) *B01(i) *xyz2D(i,iab,icd-1)
                     temp3 = Dble(iab) *B00(i) *xyz2D(i,iab-1,icd)
                     xyz2D(i,iab,icd+1) = temp1 + temp2 + temp3
 560              Continue

 550           Continue
            End If
 500     Continue

      End If
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Do 600 iab = 0, nabMax
            Do 610 icd = 0, ncdMax
               Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(x)'
               Call RecPrt(Label,' ',
     &                     xyz2D(1,iab,icd),lRys,nArg)
               Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(y)'
               Call RecPrt(Label,' ',
     &                     xyz2D(1+nArg*lRys,iab,icd),lRys,nArg)
               Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(z)'
               Call RecPrt(Label,' ',
     &                     xyz2D(1+2*nArg*lRys,iab,icd),lRys,nArg)
 610        Continue
 600     Continue
      End If
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(laa)
         Call Unused_integer(lac)
         Call Unused_integer(lcc)
      End If
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CSTART(AREF,EREF,CI,ICI)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AREF(NREF,NREF),EREF(NREF),CI(NCONF),ICI(MBUF)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION BUF(nCOP),ISTART(MXROOT)
*
      DO  5 I=1,MXVEC
        IDISKC(I)=-1
        IDISKS(I)=-1
5     CONTINUE
C FIRST, USE THE CI ARRAY TO STORE THE DIAGONAL ELEMENTS:
      IAD25=IAD25S
      DO 10 I=1,NCONF,nCOP
        CALL dDAFILE(Lu_25,2,BUF,nCOP,IAD25)
        NN=MIN(nCOP,NCONF+1-I)
        CALL DCOPY_(NN,BUF,1,CI(I),1)
10    CONTINUE
C THESE ARE DIAGONAL ELEMENTS OF THE ELECTRONIC HAMILTONIAN.
C POTNUC SHOULD BE ADDED. IN ADDITION, WE USE AN ENERGY SHIFT.
C NOTE: DISPLACEMENT 1.0d-4 PROTECTS AGAINST DIVIDE ERRORS.
CPAM: Protect all diag elems. Needed in some weird cases.
C ENERGY SHIFT:
      ESHIFT=EREF(1)
      DO 25 I=1,NCONF
        CI(I)=CI(I)+POTNUC-ESHIFT+1.0D-04
25    CONTINUE
      Call Add_Info('CI_DIAG2',CI(2),1,8)
C REPLACE REFERENCE ENERGIES:
      DO 20 I=1,NREF
        IR=IREFX(I)
        CI(IR)=EREF(I)-ESHIFT-1.0D-04
20    CONTINUE
      IF(ICPF.EQ.1) THEN
        DO 30 IREF=1,NREF
          IR=IREFX(IREF)
          CI(IR)=GFAC*CI(IR)
30      CONTINUE
        GINV=1.0D00/GFAC
        CALL DSCAL_(NCONF,GINV,CI,1)
      END IF
      IDFREE=0
      IDISKD=0
      DO 31 ISTA=1,NCONF,MBUF
        NN=MIN(MBUF,(NCONF+1-ISTA))
        CALL dDAFILE(LUEIG,1,CI(ISTA),NN,IDFREE)
31    CONTINUE
C THEN, SET UP START CI VECTORS IN MCSF BASIS:
      CALL DCOPY_(NCONF,[0.0D00],0,CI,1)
      IF(IREST.EQ.0) THEN
        NNEW=IROOT(NRROOT)
        I1=1
        I2=1
        DO 35 I=1,NNEW
          IF(I.EQ.IROOT(I1)) THEN
            ISTART(NNEW-NRROOT+I1)=I
            I1=I1+1
          ELSE
            ISTART(I2)=I
            I2=I2+1
          END IF
35      CONTINUE
        IF(NNEW.GT.1) THEN
          WRITE(6,*)
     *    ' THE FOLLOWING REFERENCE ROOTS ARE USED AS START VECTORS:'
      CALL XFLUSH(6)
          WRITE(6,'(12(A,I2))') ' ROOTS NR ',ISTART(1),
     *                           (',',ISTART(I),I=2,NNEW-1),
     *                          ', AND ',ISTART(NNEW)
      CALL XFLUSH(6)
          IF(NNEW.GT.NRROOT) THEN
            WRITE(6,*)' (THE FIRST EXTRA ROOT(S) WERE INCLUDED IN'//
     *         'ORDER TO IMPROVE CONVERGENCE)'
      CALL XFLUSH(6)
          END IF
        ELSE
          WRITE(6,'(A,I2,A)') ' ROOT NR ',ISTART(1),
     *                        ' IS USED AS START VECTOR.'
      CALL XFLUSH(6)
        END IF
        DO 40 I=1,NNEW
          ISTA=ISTART(I)
          IR=IREFX(ISTA)
          CI(IR)=1.0D00
          IDISKC(I)=IDFREE
          DO 41 ISTA=1,NCONF,MBUF
            NN=MIN(MBUF,(NCONF+1-ISTA))
            CALL PKVEC(NN,CI(ISTA),ICI)
            CALL iDAFILE(LUEIG,1,ICI,NN,IDFREE)
41        CONTINUE
          CI(IR)=0.0D00
40      CONTINUE
      ELSE
        ID=0
        NNEW=NRROOT
        DO 50 I=1,NRROOT
          CALL dDAFILE(LUREST,2,CI,NCONF,ID)
          CALL CSFTRA('MCSF',CI,AREF)
          IDISKC(I)=IDFREE
          DO 51 ISTA=1,NCONF,MBUF
            NN=MIN(MBUF,(NCONF+1-ISTA))
            CALL PKVEC(NN,CI(ISTA),ICI)
            CALL iDAFILE(LUEIG,1,ICI,NN,IDFREE)
51        CONTINUE
50      CONTINUE
      END IF
      NVTOT=NNEW
      NSTOT=0
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
*  Cho_X_getVtra
*
*> @brief
*>    This routine performs a half-MO-transformation of Cholesky vectors stored in reduced storage
*> @author F. Aquilante
*>
*> @details
*> This routine performs a half-MO-transformation of Cholesky vectors stored in reduced
*> storage. For \p DoRead = ``.true.`` the vectors are read from
*> disk using array \p RedVec as scratch space, whereas for
*> \p DoRead = ``.false.`` the reduced vectors must be supplied in
*> array \p RedVec.
*>
*> Given (\p ChoT),the target arrays of type SBA_Type,
*> the routine performs a half-MO-transformation of \p NUMV Cholesky
*> vectors of compound symmetry \p ISYM starting with
*> vector \p IVEC1 and returns them in the target arrays.
*>
*> - \p iSwap = ``0``: \f$ L(k,b,J) \f$ is returned
*> - \p iSwap = ``1``: \f$ L(a,k,J) \f$ is returned
*> - \p iSwap = ``2``: \f$ L(k,J,b) \f$ is returned
*> - \p iSwap = ``3``: \f$ L(a,J,k) \f$ is returned
*>
*>
*> - \p IREDC: reduced set in core at the moment of the call to the routine.
*>             Can be set to ``-1`` (= unknown or undefined) by the calling routine.
*>
*> @param[out]    irc     return code
*> @param[in,out] RedVec  Vectors stored in reduced set(s) [\p DoRead option off] or scratch space for reading reduced vectors [\p DoRead option on]
*> @param[in]     lRedVec size of the \p RedVec
*> @param[in]     IVEC1   first vector to read
*> @param[in]     NUMV    number of vectors to transform starting from \p IVEC1
*> @param[in]     ISYM    compound symmetry of the Cholesky vectors
*> @param[in]     iSwap   type of the full storage for the half transformed Cholesky vectors
*> @param[in,out] IREDC   reduced set in core
*> @param[in]     nDen    total number of densities to which MOs refer
*> @param[in]     kDen    first density for which the MO transformation has to be performed
*> @param[in]     MOs     the MOs coefficients stored in the data type DSBA_Type, i.e. symmetry blocked.
*> @param[out]    ChoT    the half transformed vectors, symmetry blocked as type SBA_Type
*> @param[in]     DoRead  flag for reading the reduced vectors
************************************************************************
      Subroutine Cho_X_getVtra(irc,RedVec,lRedVec,IVEC1,NUMV,ISYM,
     &                         iSwap,IREDC,nDen,kDen,MOs,ChoT,
     &                         DoRead)
      use Data_Structures, only: DSBA_Type, SBA_Type
      Implicit Real*8 (a-h,o-z)

      Type (DSBA_Type) MOs(nDen)
      Type (SBA_Type) Chot(nDen)

      Dimension RedVec(lRedVec)
      Integer   nDen,kDen
      Logical   DoRead
      Character(LEN=13), Parameter:: SECNAM = 'Cho_X_GetVtra'

#include "real.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"

      MXUSD = 0
      MUSED = 0

C zeroing the target arrays
C--------------------------
      Do jDen=kDen,nDen
         ChoT(jDen)%A0(:)=Zero
      End Do
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      IF (DoRead) THEN
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
       JVEC1 = IVEC1             ! Absolute starting index
       IVEC2 = JVEC1 + NUMV - 1  ! Absolute ending index

       Do While (jVec1.le.iVec2)

        Call CHO_VECRD(RedVec,lRedVec,JVEC1,IVEC2,ISYM,JNUM,IREDC,MUSED)

        MXUSD = MAX(MXUSD,MUSED)

        If (JNUM.le.0 .or. JNUM.gt.(IVEC2-JVEC1+1)) then
           irc=77
           RETURN
        End If

        JVREF = JVEC1 - IVEC1 + 1 ! Relative index

        Call cho_vTra(irc,RedVec,lRedVec,JVREF,JVEC1,JNUM,NUMV,ISYM,
     &                IREDC,iSwap,nDen,kDen,MOs,ChoT)

        if (irc.ne.0) then
           return
        endif

        JVEC1 = jVec1 + JNUM

       End Do  ! end the while loop
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      ELSE ! only MO transformation
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
       JNUM = NUMV
       JVREF= 1
       Call cho_vTra(irc,RedVec,lRedVec,JVREF,IVEC1,JNUM,NUMV,ISYM,
     &               IREDC,iSwap,nDen,kDen,MOs,ChoT)

       if (irc.ne.0) then
          return
       endif
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      END IF
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      irc=0

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! One diffuse, the other not diffuse.
subroutine ABOne(iLdiff,iLpoi,dMul,Ep,R,Rinv,Colle,lDiffA)

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One, Two, Three, Four, Nine, OneHalf
use Definitions, only: wp, iwp, u6

! Maximum multipole implemented
#define _MxM_ 2

implicit none
integer(kind=iwp), intent(in) :: iLdiff, iLpoi
real(kind=wp), intent(in) :: dMul(nTri_Elem1(_MxM_)), Ep, R, Rinv
real(kind=wp), intent(out) :: Colle(3)
logical(kind=iwp), intent(in) :: lDiffA
real(kind=wp) :: DAMP, er, Ex, Pi1, Pi2, Sigma
real(kind=wp), parameter :: d3 = sqrt(Three)
#include "warnings.h"

! The omnipresent exponential and distance-exponent product.

er = Ep*R
Ex = exp(-Two*er)
Colle(:) = Zero

if ((iLdiff == 0) .and. (iLpoi == 0)) then
  ! s-s; see ABBoth for comments on sigma and similar below.

  Sigma = dMul(1)
  DAMP = (One+er)*Ex
  Colle(1) = Sigma*Rinv*(One-DAMP)

else if ((iLdiff == 0) .and. (iLpoi == 1)) then
  ! s-p

  Sigma = dMul(3)
  if (lDiffA) then
    Sigma = dMul(1)
  end if
  DAMP = (One+Two*er+Two*er**2)*Ex
  Colle(1) = Sigma*Rinv**2*(One-DAMP)

else if ((iLdiff == 0) .and. (iLpoi == 2)) then
  ! s-d

  Sigma = dMul(3)
  if (lDiffA) then
    Sigma = dMul(1)
  end if
  DAMP = (One+Two*er+Two*er**2+Four*er**3/Three)*Ex
  Colle(1) = Sigma*Rinv**3*(One-DAMP)

else if ((iLdiff == 1) .and. (iLpoi == 0)) then
  ! p-s

  Sigma = dMul(1)
  if (lDiffA) then
    Sigma = dMul(3)
  end if
  DAMP = (One+Two*er+Two*er**2+er**3)*Ex
  Colle(1) = Sigma*Rinv**2*(One-DAMP)

else if ((iLdiff == 1) .and. (iLpoi == 1)) then
  ! p-p

  Sigma = dMul(3)
  Pi1 = dMul(1)
  Pi2 = dMul(2)
  DAMP = (One+Two*er+Two*er**2+OneHalf*er**3+er**4)*Ex
  Colle(1) = Two*Sigma*Rinv**3*(One-DAMP)
  DAMP = (One+Two*er+Two*er**2+er**3)*Ex
  Colle(2) = Pi1*Rinv**3*(One-DAMP)
  Colle(3) = Pi2*Rinv**3*(One-DAMP)

else if ((iLdiff == 1) .and. (iLpoi == 2)) then
  ! p-d

  Sigma = dMul(3)
  Pi1 = dMul(2)
  Pi2 = dMul(4)
  if (lDiffA) then
    Pi1 = dMul(1)
    Pi2 = dMul(2)
  end if
  DAMP = (One+Two*er+Two*er**2+Four*er**3/Three+Two*er**4/Three+Four*er**5/Nine)*Ex
  Colle(1) = Three*Sigma*Rinv**4*(One-DAMP)
  DAMP = (One+Two*er+Two*er**2+Four*er**3/Three+Two*er**4/Three)*Ex
  Colle(2) = d3*Pi1*Rinv**4*(One-DAMP)
  Colle(3) = d3*Pi2*Rinv**4*(One-DAMP)
  !Colle = Colle1+Colle2+Colle3

else
  ! Higher moments.

  write(u6,*)
  write(u6,*) 'Too high momentum!'
  call Quit(_RC_IO_ERROR_READ_)
end if

return

end subroutine ABOne

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 FUNCTION FNDMNX(VECTOR,NDIM,MINMAX)
C
C     FIND SMALLEST(MINMAX=1) OR LARGEST(MINMAX=2)
C     ABSOLUTE VALUE OF ELEMENTS IN VECTOR
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VECTOR(*)
C
* jwk-cleanup
      RESULT = 0.0D0
      IF(MINMAX.EQ.1) THEN
       RESULT=ABS(VECTOR(1))
       DO 100 I=2,NDIM
        RESULT=MIN(RESULT,ABS(VECTOR(I)))
  100  CONTINUE
      END IF
C
      IF(MINMAX.EQ.2) THEN
       RESULT=ABS(VECTOR(1))
       DO 200 I=2,NDIM
        RESULT=MAX(RESULT,ABS(VECTOR(I)))
  200  CONTINUE
       END IF
C
       FNDMNX=RESULT
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_D1sao_Var(D1Sao,nD1Sao)
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "SysDef.fh"
      Character*24 Label
#ifdef _DEBUGPRINT_
#include "run_common.fh"
#endif
      Logical      Found
      Real*8 D1Sao(nD1Sao)

      Call Get_iScalar('System BitSwitch',iOption)
*
*...  Read the variational 1st order density matrix
*...  density matrix in AO/SO basis
*                                                                      *
************************************************************************
*                                                                      *
      Label='D1saoVar'
      Call qpg_dArray(Label,Found,nDens)
      If(.not.Found .or. nDens.eq.0) Then
         Call Get_D1sao(D1sao,nD1Sao)
      Else
         Call Get_dArray(Label,D1sao,nD1Sao)
      End If
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      if(is_nSym.eq.0) then
       Call get_iScalar('nSym',nSym)
       is_nSym=1
      endif
      if(is_nBas.eq.0) then
       Call Get_iArray('nBas',nBas,nSym)
       is_nBas=1
      endif
      Write(6,*) 'variational 1st order spin density matrix'
      ii=1
      Do iIrrep = 0, nSym - 1
         If (nBas(iIrrep).gt.0) Then
            Write(6,*) 'symmetry block',iIrrep
            Call TriPrt(' ',' ',D1Sao(ii),nBas(iIrrep))
            ii = ii + nBas(iIrrep)*(nBas(iIrrep)+1)/2
         End If
      End Do
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Eval_RMin(Alpha,m,R_H)

use Constants, only: One, Two, Three, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: Eval_RMin
real(kind=wp), intent(in) :: Alpha, R_H
integer(kind=iwp), intent(in) :: m
real(kind=wp) :: D_m, ln_x, R_Min

!write(u6,*) 'Alpha,m,R_H=',Alpha,m,R_H
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute r_1 as a function of m and R_H
!
! Eq(25) R. Lindh, P.-A. Malmqvist, L. Gagliardi,
! TCA, 106:178-187 (2001)

D_m = -Four
if (m == 4) D_m = -2.3_wp
if (m == 2) D_m = -One
if (m == 0) D_m = 1.9_wp
if (m == -2) D_m = 9.1_wp

!x = alpha*(r_1)**2

ln_x = (Two/(real(m,kind=wp)+Three))*(D_m-log(One/R_H))

R_Min = sqrt(exp(ln_x)/Alpha)

Eval_RMin = R_Min
!write(u6,*) 'Eval_RMin=',Eval_RMin
!                                                                      *
!***********************************************************************
!                                                                      *

return

end function Eval_RMin

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
!   ar      =1 (+a^r)     drr     =2 (+d^rr)   drl     =3 (+d^rl)
!   arbr    =4 (+d^rr)    arbl    =5 (+d^rl)   ard_l^r =6 (+a^l)
!   drrb^r  =7 (+a^r)     drlb^r  =8 (+a^l)    drlb^l  =9 (+a^r)
!   arbrb^r =10 (+a^r)    arblb^r =11 (+a^l)   arblb^l =12 (+a^r)
!   drl     =13 (*)
!***********************************************************************

subroutine inner_space_loop_g()

implicit none

!wsc0 = c_time()
call dbl_space_loop_g()
!wsc1 = c_time()
call act_space_cloop_g()
call act_space_ploop_g()
!wsc2 = c_time()
!write(u6,'(2x,2(a5,f12.4))') 'dbl',wsc1-wsc0,'act',wsc2-wsc1

return

end subroutine inner_space_loop_g

subroutine act_space_cloop_g()        ! one sub_drt

use gugaci_global, only: ipae, jpad, jpae, mxnode, ndim, norb_act, nu_ad, nu_ae
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ipae_, jpad_

if (norb_act == 0) return
do ipae_=1,25
  ipae = ipae_ ! ipae is in global module, is this necessary?
  jpae = nu_ae(ipae)
  if (jpae == 0) cycle
  do jpad_=1,mxnode
    jpad = jpad_ ! jpad is in global module, is this necessary?
    if (nu_ad(jpad) == 0) cycle
    call seg_drt()
    if (ndim == 0) cycle
    call copy_to_drtl()
    call cloop_in_act_g()
  end do
end do

return

end subroutine act_space_cloop_g

subroutine act_space_ploop_g()        ! two sub_drt with same ipae

use gugaci_global, only: ipae, jpad, jpadl, jpae, mxnode, ndim, norb_act, nu_ad, nu_ae
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ipae_, jpad_, jpadl_

if (norb_act == 0) return
do ipae_=1,25
  ipae = ipae_ ! ipae is in global module, is this necessary?
  jpae = nu_ae(ipae)
  if (jpae == 0) cycle
  do jpadl_=1,mxnode                               ! jpadl
    jpadl = jpadl_ ! jpadl is in global module, is this necessary?
    if (nu_ad(jpadl) == 0) cycle
    jpad = jpadl
    call seg_drt()
    if (ndim == 0) cycle
    call copy_to_drtl()
    do jpad_=1,mxnode                               !jpadr
      jpad = jpad_ ! jpad is in global module, is this necessary?
      if (nu_ad(jpad) == 0) cycle
      call seg_drt()
      if (ndim == 0) cycle
      !if ((ipae == 18) .and. (jpadl == 2) .and. (jpad == 1)) write(u6,*)
      call ploop_in_act_g()
    end do
  end do
end do

return

end subroutine act_space_ploop_g

subroutine cloop_in_act_g()

use gugaci_global, only: logic_br, lsm_inn, norb_dz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lmi, lmij, lmj, lmk, lml, lrai, lraj, lrak, lral, lsmij, mh

do lrai=norb_dz+1,norb_inn-1
  lmi = lsm_inn(lrai)
  do lraj=lrai+1,norb_inn
    lmj = lsm_inn(lraj)
    lmij = Mul(lmi,lmj)
    !-------------------------------------------------------------------
    ! line=8 d&r&r--d^r^r
    call head_drr_at_given_orb(mh,lrai)
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrai+1,lraj-1)
    call tail_drr_at_given_orb(mh)
    !write(u6,'(6i6)') 8,mh,lrai,lraj,0,0
    if (mh /= 0) call act_cloop_g(8,mh,lrai,lraj,0,0)
    !-------------------------------------------------------------------
    ! line=9 d&r&l--d^r^l
    call head_drl_at_given_orb(mh,lrai)
    call link_c2_to_given_orb(mh,lrai+1,lraj-1)
    call tail_drl_at_given_orb(mh)
    !write(u6,'(6i6)') 9,mh,lrai,lraj,0,0
    if (mh /= 0) call act_cloop_g(9,mh,lrai,lraj,0,0)
    lsmij = Mul(lmi,lmj)
    !-------------------------------------------------------------------
    if (lsmij == 1) then
      !-----------------------------------------------------------------
      ! line=1 a&r--a^r
      call head_ar_at_given_orb(mh,lrai)
      call link_c1_to_given_orb_coe(mh,lrai+1,lraj-1)
      call tail_ar_at_given_orb_coe(mh,lraj)
      !write(u6,'(6i6)') 1,mh,lrai,lraj,0,0
      if (mh /= 0) call act_cloop_g(1,mh,lrai,lraj,0,0)
      !call save_clp(1,mh,lra,0)
      !-----------------------------------------------------------------
      ! line=2 a&r-d^r&l-a^l
      do lrak=lrai+1,lraj-1
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lrak-1)
        call link_d10_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrak+1,lraj-1)
        call tail_al_at_given_orb(mh)
        !write(u6,'(6i6)') 2,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop_g(2,mh,lrai,lraj,lrak,0)
      end do
      !-----------------------------------------------------------------
      ! line=3 a&r-b&r-d^r^r
      do lrak=lraj+1,norb_inn
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b4_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call tail_drr_at_given_orb(mh)
        !write(u6,'(6i6)') 3,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop_g(3,mh,lrai,lraj,lrak,0)
        !---------------------------------------------------------------
        ! line=5 a&r-b&l-d^r^l
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b3_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call tail_drl_at_given_orb(mh)
        !write(u6,'(6i6)') 5,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop_g(5,mh,lrai,lraj,lrak,0)
      end do
      !-----------------------------------------------------------------
      do lrak=norb_dz+1,lrai-1
        ! line=10 d&rr--b^r--a^r
        call head_drr_at_given_orb(mh,lrak)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lrak+1,lrai-1)
        call link_b2_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call tail_ar_at_given_orb(mh)
        !write(u6,'(6i6)') 10,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop_g(10,mh,lrai,lraj,lrak,0)
        !---------------------------------------------------------------
        ! line=11 d&r&l-b^r-a^l
        call head_drl_at_given_orb(mh,lrak)
        call link_c2_to_given_orb(mh,lrak+1,lrai-1)
        call link_b2_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call tail_al_at_given_orb(mh)
        !write(u6,'(6i6)') 11,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop_g(11,mh,lrai,lraj,lrak,0)
        !---------------------------------------------------------------
        ! line=12 d&r&l-b^l-a^r
        call head_drl_at_given_orb(mh,lrak)
        call link_c2_to_given_orb(mh,lrak+1,lrai-1)
        call link_b1_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call tail_ar_at_given_orb(mh)
        !write(u6,'(6i6)') 12,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop_g(12,mh,lrai,lraj,lrak,0)
      end do
    end if
    if (lraj > norb_inn-2) cycle
    do lrak=lraj+1,norb_inn
      lmk = lsm_inn(lrak)
      lmk = Mul(lmij,lmk)
      do lral=lrak+1,norb_inn
        lml = lsm_inn(lral)
        lml = Mul(lmk,lml)
        if (lml /= 1) cycle
        ! line=4  a&r--b&r--b^r--a^r
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b4_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call link_b2_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrak+1,lral-1)
        call tail_ar_at_given_orb(mh)
        !  write(u6,'(6i6)') 4,mh,lrai,lral,lraj,lrak
        if (mh /= 0) call act_cloop_g(4,mh,lrai,lral,lraj,lrak)
        !---------------------------------------------------------------
        ! line=6  a&r--b&l--b^r--a^l
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b3_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call link_b2_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrak+1,lral-1)
        call tail_al_at_given_orb(mh)
        !  write(u6,'(6i6)') 6,mh,lrai,lral,lraj,lrak
        if (mh /= 0) call act_cloop_g(6,mh,lrai,lral,lraj,lrak)
        !---------------------------------------------------------------
        ! line=7 a&r--b&l--b^l--a^r
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b3_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call link_b1_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrak+1,lral-1)
        call tail_ar_at_given_orb(mh)
        !  write(u6,'(6i6)') 7,mh,lrai,lral,lraj,lrak
        if (mh /= 0) call act_cloop_g(7,mh,lrai,lral,lraj,lrak)
        !---------------------------------------------------------------
      end do
    end do
  end do
end do

return

end subroutine cloop_in_act_g

subroutine ploop_in_act_g()

use gugaci_global, only: logic_br, norb_dz, norb_inn
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lrai, lraj, lrak, lral, mh

do lrai=norb_dz+1,norb_inn
  ! line=25 -c"-d^r^r
  logic_br(1) = .true.
  call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
  call tail_drr_at_given_orb(mh)
  if (mh /= 0) call lp_act_tail_g(25,mh,0,lrai)
  !---------------------------------------------------------------------
  ! line=26 -c"-d^r^l
  logic_br(1) = .true.
  call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
  call tail_drl_at_given_orb(mh)
  if (mh /= 0) call lp_act_tail_g(26,mh,0,lrai)
  !=====================================================================
  ! line=23 -c'-a^l
  call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
  call tail_al_at_given_orb(mh)
  if (mh /= 0) call lp_act_tail_g(23,mh,0,0)
  !---------------------------------------------------------------------
  ! line=24 -c'-a^r
  call link_c1_to_given_orb_coe(mh,norb_dz+1,lrai-1)
  call tail_ar_at_given_orb_coe(mh,lrai)
  if (mh /= 0) call lp_act_tail_g(24,mh,0,0)
  !=====================================================================
  do lrak=lrai+1,norb_inn
    !-------------------------------------------------------------------
    ! line=30 -c'-b&r-d^r^r
    call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b4_at_given_orb(mh)
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrai+1,lrak-1)
    call tail_drr_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail_g(30,mh,lrai,0)
    !-------------------------------------------------------------------
    ! line=31 -c'-b&l-d^r^l
    call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b3_at_given_orb(mh)
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrai+1,lrak-1)
    call tail_drl_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail_g(31,mh,lrai,0)
  end do
  !=====================================================================
  do lrak=norb_dz+1,lrai-1
    !-------------------------------------------------------------------
    ! line=35 -c'-d^r&l-a^l
    call link_c1_to_given_orb(mh,norb_dz+1,lrak-1)
    call link_d10_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrak+1,lrai-1)
    call tail_al_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail_g(35,mh,lrak,lrak)
  end do
  !=====================================================================
  do lraj=lrai+1,norb_inn
    !-------------------------------------------------------------------
    ! line=27 -c"-b^r-a^r
    call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b2_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrai+1,lraj-1)
    call tail_ar_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail_g(27,mh,0,lrai)
    !-------------------------------------------------------------------
    ! line=28 -c"-b^l-a^r
    call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b1_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrai+1,lraj-1)
    call tail_ar_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail_g(28,mh,0,lrai)
    !-------------------------------------------------------------------
    ! line=29 -c"-b^r-a^l
    call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b2_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrai+1,lraj-1)
    call tail_al_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail_g(29,mh,0,lrai)
    !-------------------------------------------------------------------
    do lral=lraj+1,norb_inn
      !-----------------------------------------------------------------
      ! line=32 -c'-b&r-c"-b^r-a^r
      call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
      call link_b4_at_given_orb(mh)
      logic_br(1:mh) = .true.
      call link_c2_to_given_orb(mh,lrai+1,lraj-1)
      call link_b2_at_given_orb(mh)
      call link_c1_to_given_orb(mh,lraj+1,lral-1)
      call tail_ar_at_given_orb(mh)
      if (mh /= 0) call lp_act_tail_g(32,mh,lrai,lraj)
      !-----------------------------------------------------------------
      ! line=33 -c'-b&l-c"-b^r-a^l
      call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
      call link_b3_at_given_orb(mh)
      logic_br(1:mh) = .true.
      call link_c2_to_given_orb(mh,lrai+1,lraj-1)
      call link_b2_at_given_orb(mh)
      call link_c1_to_given_orb(mh,lraj+1,lral-1)
      call tail_al_at_given_orb(mh)
      if (mh /= 0) call lp_act_tail_g(33,mh,lrai,lraj)
      !-----------------------------------------------------------------
      ! line=34 -c'-b&l-c"-b^l-a^r
      call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
      call link_b3_at_given_orb(mh)
      logic_br(1:mh) = .true.
      call link_c2_to_given_orb(mh,lrai+1,lraj-1)
      call link_b1_at_given_orb(mh)
      call link_c1_to_given_orb(mh,lraj+1,lral-1)
      call tail_ar_at_given_orb(mh)
      if (mh /= 0) call lp_act_tail_g(34,mh,lrai,lraj)
    end do
  end do
  !---------------------------------------------------------------------
end do

return

end subroutine ploop_in_act_g

subroutine lp_act_tail_g(lin,mh,lrg0,lrs0)

use gugaci_global, only: jpel, jper, jph_, jwl, jwr, line, lpnew_coe, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, lrg, lrs, &
                         mhlp, norb_dz, norb_inn, vplpnew_w0, vplpnew_w1, w0, w1
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, mh, lrg0, lrs0
integer(kind=iwp) :: iorb, mhlp_
integer(kind=iwp), allocatable :: lpcoe(:)

call mma_allocate(lpcoe,[norb_dz+1,norb_inn],label='lpcoe')
line = lin
lrg = lrg0
lrs = lrs0
jph_ = 0
do mhlp_=1,mh
  mhlp = mhlp_ ! mhlp is in global module, is this necessary?
  jpel = lpnew_ltail(mhlp)
  jper = lpnew_rtail(mhlp)
  jwl = lpnew_lwei(mhlp)
  jwr = lpnew_rwei(mhlp)
  w0 = vplpnew_w0(mhlp)
  w1 = vplpnew_w1(mhlp)
  if (line == 24) then
    do iorb=norb_dz+1,norb_inn
      lpcoe(iorb) = lpnew_coe(iorb,mhlp)
    end do
  end if
  call dbl_head_act_tail_g(lpcoe)
end do
call mma_deallocate(lpcoe)

return

end subroutine lp_act_tail_g

subroutine act_cloop_g(lin,mh,lr0,lr,lrg0,lrs0)

use gugaci_global, only: jpel, jper, jph_, jwl, jwr, line, lpnew_coe, lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, &
                         lpnew_rwei, lrg, lrs, mhlp, norb_dz, norb_inn, vplpnew_w0, vplpnew_w1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, mh, lr0, lr, lrg0, lrs0
integer(kind=iwp) :: kcoe, l, mhlp_, nocc, nxo
real(kind=wp) :: tcoe, vlop0, vlop1, wl
integer(kind=iwp), allocatable :: lpcoe(:)

line = lin
lrg = lrg0
lrs = lrs0
do mhlp_=1,mh
  mhlp = mhlp_ ! mhlp is in global module, is this necessary?
  jph_ = lpnew_head(mhlp)
  jpel = lpnew_ltail(mhlp)
  jper = lpnew_rtail(mhlp)
  jwl = lpnew_lwei(mhlp)
  jwr = lpnew_rwei(mhlp)
  vlop0 = vplpnew_w0(mhlp)
  vlop1 = vplpnew_w1(mhlp)

  select case (line)
    case default ! (1)
      !-----------------------------------------------------------------
      call mma_allocate(lpcoe,[norb_dz+1,norb_inn],label='lpcoe')
      do l=norb_dz+1,lr
        lpcoe(l) = lpnew_coe(l,mhlp)
      end do
      !wl = voint(lr0,lr)
      wl = vlop0
      !write(nf2,*) 'ar-ar'
      call prodab_1(2,jph_,jpel,jwl,jwr,0,wl,jper,lr0,lr)
      do l=lr0,lr
        !list = list3(lr0,lr,l)
        kcoe = lpcoe(l)
        !write(nf2,*) 'arw-c-arw'
        call neoc(kcoe,nocc,tcoe)
        !wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
        wl = vlop0*nocc
        call trans_ijkl_intpos(lr,lr0,l,l,nxo)
        !write(nf2,'(4i4)') lr,lr0,l,l
        call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)
        wl = vlop0*nocc*tcoe
        call trans_ijkl_intpos(lr,l,lr0,l,nxo)
        call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

      end do
      !wl = wl*vlop0
      call mma_deallocate(lpcoe)

    case (2)
      !-----------------------------------------------------------------
      wl = vlop0
      !write(nf2,*) 'ar-drl-al'
      !list = list3(lr0,lr,lrg)
      !wl = vlop0*vint_ci(list)
      call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (3)
      !-----------------------------------------------------------------
      wl = vlop0+vlop1
      !write(nf2,*) 'ar-br-drr'
      !list = list3(lr0,lr,lrg)
      !wl = (vlop0+vlop1)*vint_ci(list)

      call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (4)
      !-----------------------------------------------------------------
      wl = vlop0+vlop1
      !write(nf2,*) 'ar-br-br-ar'
      !list = list4(lr0,lrg,lrs,lr)
      !wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list))

      call trans_ijkl_intpos(lr,lrg,lrs,lr0,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)
      wl = vlop0-vlop1
      call trans_ijkl_intpos(lr,lr0,lrg,lrs,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (5)
      !-----------------------------------------------------------------
      wl = vlop0-vlop1
      !write(nf2,*) 'ar-bl-drl'
      !list = list3(lr0,lr,lrg)
      !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

      call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)
      wl = -vlop0*Two
      call trans_ijkl_intpos(lr,lr0,lrg,lrg,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (6)
      !-----------------------------------------------------------------
      wl = vlop0-vlop1
      !list = list4(lr0,lrg,lrs,lr)
      !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)
      !vint_ci(numb) = vfutei(la,lc,lb,ld)
      !vint_ci(numb+1) = vfutei(la,lb,lc,ld)
      !vint_ci(numb+2) = vfutei(la,ld,lc,lb)
      !write(nf2,*) 'ar-bl-br-al'
      call trans_ijkl_intpos(lr,lrg,lrs,lr0,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)
      wl = -vlop0*Two
      call trans_ijkl_intpos(lr,lrs,lrg,lr0,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (7)
      !-----------------------------------------------------------------
      wl = vlop0-vlop1
      !list = list4(lr0,lrg,lrs,lr)
      !wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2)
      !write(nf2,*) 'ar-bl-bl-ar'
      call trans_ijkl_intpos(lr,lr0,lrg,lrs,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)
      wl = -vlop0*Two
      call trans_ijkl_intpos(lr,lrs,lrg,lr0,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (8)
      !-----------------------------------------------------------------
      ! drr-drr
      ! wl=vlop0 but not Half*vlop0 is based on that the non-diagonal
      ! just uses the non-triangle <ci|h|cj> which designates that i > j.
      wl = vlop0

      !wl = vlop0*voint(lr,lr0)*Half
      call trans_ijkl_intpos(lr,lr0,lr,lr0,nxo)
      !write(nf2,*) 'drr-drr'
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (9)
      !-----------------------------------------------------------------
      wl = (vlop0-vlop1)*Two

      ! drl-drl
      !wl = (vlop0-vlop1)*voint(lr,lr0)
      call trans_ijkl_intpos(lr,lr0,lr,lr0,nxo)
      !write(nf2,'(a7,2i4,f18.10)') 'drl-drl',lr,lr0,wl
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (10)
      !-----------------------------------------------------------------
      wl = vlop0+vlop1
      !write(nf2,*) 'drr-br-ar'
      !list = list3(lr0,lr,lrg)
      !wl = (vlop0+vlop1)*vint_ci(list)

      call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (11)
      !-----------------------------------------------------------------
      wl = vlop0-vlop1
      !write(nf2,*) 'drl-br-al'
      !list = list3(lr0,lr,lrg)
      !wl = (vlop0-vlop1)*vint_ci(list)

      call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)

    case (12)
      !-----------------------------------------------------------------
      wl = vlop0-vlop1
      !write(nf2,*) 'drl-bl-ar'
      !list = list3(lr0,lr,lrg)
      !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

      call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)
      wl = -vlop0*Two
      call trans_ijkl_intpos(lr,lr0,lrg,lrg,nxo)
      call prodab_2(2,jph_,jpel,jwl,jwr,0,wl,jper,nxo)
  end select
end do

return

end subroutine act_cloop_g

subroutine dbl_td_act_comp_g(lin,lra)

use gugaci_global, only: jml, jmr, jpel, jper, jud, just, jwl, jwr, lrg, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_td, w1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, list0, list1, lmi, lmk, lri, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0td1, wl0, wl1

! td(13-1) (22)a&(23)
! td(13-1) a&(23)c'(22)
! td(13-2) a&(23)b&r(23)b^r(32)
! td(13-3) a&(23)b&l(32)b^l(23)
! td(13-4) d&r&l(22)b^l(23)
! td(13-5) (22)d&&l(33)b^l(23)
! td(13-5) d&rl(33)c"(22)b^l(23)
! td(13-5) d&rl(33)b^l(23)c'(22)

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_td(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0td1 = -w0td1
  end if

  ! td(13-1) a&(23)c'(22)
  vlop0 = -w0*w0td1
  vlop1 = -w1*w0td1
  call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end do
  ! td(13-1) (22)a&(23)
  vlop0 = w0*w0td1
  vlop1 = w1*w0td1
  call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end do
  !---------------------------------------------------------------------
end do

return

end subroutine dbl_td_act_comp_g

subroutine dbl_ttdd_act_comp_g(lin,lra)

use gugaci_global, only: jml, jmr, jpel, jper, jud, just, jwl, jwr, lrg, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_t1d1, w1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, list0, list1, lmi, lmk, lri, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0td1, wl0, wl1

! t1d1(15-1)  ar(13)-
! t1d1(15-1)  ar(13)-c'(11)-

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_t1d1(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0td1 = -w0td1
  end if
  ! t1d1(15-1)  ar(13)-c'(11)-
  vlop0 = -w0*w0td1
  vlop1 = -w1*w0td1
  call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end do
  ! t1d1(15-1)  (11)ar(13)-
  vlop0 = w0*w0td1
  vlop1 = w1*w0td1
  call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end do
  !---------------------------------------------------------------------
end do

return

end subroutine dbl_ttdd_act_comp_g

subroutine comp_loop_g(line,lr0,lrg,lrs,lr,vlop0,vlop1,wl0,list0,wl1,list1)

use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: line, lr0, lrg, lrs, lr
real(kind=wp), intent(in) :: vlop0, vlop1
integer(kind=iwp), intent(out) :: list0, list1
real(kind=wp), intent(out) :: wl0, wl1
integer(kind=iwp) :: nxo

wl0 = Zero
list0 = 0
wl1 = Zero
list1 = 0
select case (line)
  case default ! (1)
    !-------------------------------------------------------------------
    !do l=norb_dz+1,lr-1
    ! lpcoe(l) = lp_coe(l,mpl)
    !end do
    !lpcoe(lr) = kcoe
    !wl = voint(lr0,lr)
    !do l=lr0,lr
    !  list = list3(lr0,lr,l)
    !  kcoe = lpcoe(l)
    !  call neoc(kcoe,nocc,tcoe)
    !  wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
    !end do
    !wl = wl*vlop0
  case (2)
    !-------------------------------------------------------------------
    wl0 = vlop0
    !lis = =list3(lr0,lr,lrs)   ! lrg
    !wl = vlop0*vint_ci(list)
    !write(nf2,*) 'ar-cw-ar'
    call trans_ijkl_intpos(lr,lrs,lr0,lrs,nxo)
    list0 = nxo

  case (3)
    !-------------------------------------------------------------------
    wl0 = vlop0+vlop1
    !list = list3(lr0,lrg,lr)
    !wl = (vlop0+vlop1)*vint_ci(list)

    call trans_ijkl_intpos(lrg,lr,lr0,lr,nxo)
    list0 = nxo

  case (4)
    !-----------------------------------------------------------
    wl0 = vlop0-vlop1
    !list = list4(lr0,lrg,lrs,lr)
    !wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list))

    call trans_ijkl_intpos(lr,lr0,lrg,lrs,nxo)
    list0 = nxo

    wl1 = vlop0+vlop1
    call trans_ijkl_intpos(lr,lrg,lrs,lr0,nxo)
    list1 = nxo

  case (5)
    !-------------------------------------------------------------------
    wl0 = vlop0-vlop1
    !list = list3(lr0,lrg,lr)
    !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

    call trans_ijkl_intpos(lrg,lr,lr0,lr,nxo)
    list0 = nxo

    wl1 = -Two*vlop0
    call trans_ijkl_intpos(lrg,lr0,lr,lr,nxo)
    list1 = nxo

  case (6)
    !-------------------------------------------------------------------
    wl0 = vlop0-vlop1
    !list = list4(lr0,lrg,lrs,lr)
    !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

    call trans_ijkl_intpos(lr,lrg,lrs,lr0,nxo)
    list0 = nxo
    wl1 = -Two*vlop0
    call trans_ijkl_intpos(lr,lrs,lrg,lr0,nxo)
    list1 = nxo

  case (7)
    !-----------------------------------------------------------
    wl0 = vlop0-vlop1
    !list = list4(lr0,lrg,lrs,lr)
    !wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2)

    call trans_ijkl_intpos(lr,lr0,lrg,lrs,nxo)
    list0 = nxo
    wl1 = -Two*vlop0
    call trans_ijkl_intpos(lr,lrs,lrg,lr0,nxo)
    list1 = nxo

  case (8)
    !-------------------------------------------------------------------
    ! drr-drr
    ! w0lp=Two*w0lp but not One*w0lp is based on that the non-diagonal
    ! just uses the non-triangle <ci|h|cj> which designates that i > j.
    wl0 = vlop0
    !wl = vlop0*voint(lr,lr0)*Half

    call trans_ijkl_intpos(lr,lr0,lr,lr0,nxo)
    list0 = nxo

  case (9)
    !-------------------------------------------------------------------
    wl0 = (vlop0-vlop1)*Two
    !wl = (vlop0-vlop1)*voint(lr,lr0)

    call trans_ijkl_intpos(lr,lr0,lr,lr0,nxo)
    list0 = nxo

  case (10)
    !-------------------------------------------------------------------
    wl0 = vlop0+vlop1
    !list = list3(lrs,lr,lr0)      ! lrg
    !wl = (vlop0+vlop1)*vint_ci(list)

    call trans_ijkl_intpos(lr,lr0,lrs,lr0,nxo)
    list0 = nxo

  case (11)
    !-------------------------------------------------------------------
    wl0 = vlop0-vlop1
    !list = list3(lrs,lr,lr0)      ! lrg
    !wl = (vlop0-vlop1)*vint_ci(list)

    call trans_ijkl_intpos(lr,lr0,lrs,lr0,nxo)
    list0 = nxo

  case (12)
    !-------------------------------------------------------------------
    wl0 = vlop0-vlop1
    !list = list3(lrs,lr,lr0)      ! lrg
    !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

    call trans_ijkl_intpos(lr,lr0,lrs,lr0,nxo)
    list0 = nxo

    wl1 = -Two*vlop0
    call trans_ijkl_intpos(lr,lrs,lr0,lr0,nxo)
    list1 = nxo
end select

return

end subroutine comp_loop_g

subroutine dbl_sd_act_comp_g(lin,lra)
!sd(6-1) a&r(02)-
!sd(6-2) (22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-

use gugaci_global, only: jb_sys, jml, jmr, jpel, jper, jud, just, jwl, jwr, lrg, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_sd, w1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, list0, list1, lmi, lmk, lri, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0sd1, w0sd2, w0sd3, w0sd4, wl0, wl1

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd1 = w0_sd(1)
  w0sd2 = w0_sd(2)
  w0sd3 = w0_sd(3)
  w0sd4 = w0_sd(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd3 = -w0sd3
    w0sd4 = -w0sd4
  end if
  if ((jml == 1) .and. (lmi == jmr)) then
    ! sd(6-1) a&r(02)-
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    vlop0 = w0*w0sd1
    vlop1 = w1*w0sd1
    call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end if
  ! sd(6-2) (22)a&(13)-
  vlop0 = w0*w0sd2
  vlop1 = w1*w0sd2
  call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end do
  ! sd(6-4) a&r(23)-c'(12)-
  vlop0 = -w0*w0sd4
  vlop1 = -w1*w0sd4
  call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end do
  ! sd(6-3) a&r(13)c'(22)-
  if (jb_sys > 0) then
    vlop0 = -w0*w0sd3
    vlop1 = -w1*w0sd3
    call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
    do lrk=lri+1,norb_dz
      lmk = lsm_inn(lrk)
      if (lmk /= jmr) cycle
      iwdl = just(lrk,lri)
      iwdr = jud(lrk)
      !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
      call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
    end do
  end if
end do

return

end subroutine dbl_sd_act_comp_g

subroutine dbl_sdd_act_comp_g(lin,lra)
! sd1(8-1)    ar(01)-
! sd1(8-2)    (11)ar(23)-
! sd1(8-3)    ar(13)-c'(21)-
! sd1(8-4)    ar(23)-c'(11)-

use gugaci_global, only: jb_sys, jml, jmr, jpel, jper, jud, just, jwl, jwr, lrg, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_sd1, w1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, list0, list1, lmi, lmk, lri, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0sd1, w0sd2, w0sd3, w0sd4, wl0, wl1

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd1 = w0_sd1(1)
  w0sd2 = w0_sd1(2)
  w0sd3 = w0_sd1(3)
  w0sd4 = w0_sd1(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd3 = -w0sd3
    w0sd4 = -w0sd4
  end if
  if ((jml == 1) .and. (lmi == jmr)) then
    ! sd1(8-1)    ar(01)-
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    vlop0 = w0*w0sd1
    vlop1 = w1*w0sd1
    call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end if
  ! sd1(8-2)    (11)ar(23)-
  vlop0 = w0*w0sd2
  vlop1 = w1*w0sd2
  call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end do
  ! sd1(8-4)    ar(23)-c'(11)-
  vlop0 = -w0*w0sd4
  vlop1 = -w1*w0sd4
  call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
    call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
    if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
  end do
  ! sd1(8-3)    ar(13)-c'(21)-
  if (jb_sys > 0) then
    vlop0 = -w0*w0sd3
    vlop1 = -w1*w0sd3
    call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,wl1,list1)
    do lrk=lri+1,norb_dz
      lmk = lsm_inn(lrk)
      if (lmk /= jmr) cycle
      iwdl = just(lrk,lri)
      iwdr = jud(lrk)
      !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      !call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
      call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if (list1 /= 0) call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
    end do
  end if
end do

return

end subroutine dbl_sdd_act_comp_g

subroutine ext_space_loop_g()

use gugaci_global, only: iseg_downwei, iseg_sta, iseg_upwei, isegdownwei, isegsta, isegupwei, nu_ae
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: inx, ism

ism = 0
do inx=18,25
  ism = ism+1
  if (nu_ae(inx) == 0) cycle
  isegsta = iseg_sta(inx)
  isegupwei = iseg_upwei(inx)
  isegdownwei = iseg_downwei(inx)
  call g_ss_ext_sequence_g(ism,4)
end do
ism = 0
do inx=10,17
  ism = ism+1
  if (nu_ae(inx) == 0) cycle
  isegsta = iseg_sta(inx)
  isegupwei = iseg_upwei(inx)
  isegdownwei = iseg_downwei(inx)
  call g_tt_ext_sequence_g(ism)
end do
ism = 0
do inx=2,9
  ism = ism+1
  if (nu_ae(inx) == 0) cycle
  isegsta = iseg_sta(inx)
  isegupwei = iseg_upwei(inx)
  isegdownwei = iseg_downwei(inx)
  call g_dd_ext_sequence_g(ism)
end do

return

end subroutine ext_space_loop_g

subroutine dbl_head_act_tail_g(lpcoe)

use gugaci_global, only: jb_sys, jml, jmr, jpad, jpadl, jpel, jper, jud, just, jwl, jwr, kk, line, lrg, lrs, lsm_inn, map_jplr, &
                         norb_dz, norb_frz, norb_inn, ns_sm, w0, w0_d1s, w0_d1t1, w0_d1v, w0_ds, w0_dt, w0_dv, w0_td, w0_vv, w1, &
                         w1_d1s, w1_d1t1, w1_ds, w1_dt, w1_t1v, w1_td, w1_tv
use Symmetry_Info, only: Mul
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lpcoe(norb_dz+1:norb_inn)
integer(kind=iwp) :: imd, imi, imij, imj, itypadl, itypadr, iwdl, iwdr, jmlr, kcoe, l, lmd, lmi, lmij, lmj, lpok, lr, lr0, lra, &
                     lrd, lri, lrj, lrk, ni, nocc, nxo
real(kind=wp) :: tcoe, vlop0, vlop1, w0ds1, w0ds2, w0ds3, w0dv1, w0dv2, w0td1, w0td2, w0td3, w0td4, w0td5, w1ds, w1ds2, w1ds3, &
                 w1td2, w1td3, w1tv, wl

lra = kk(jpel)-1
jml = mod((jpadl-1),8)
jmr = mod((jpad-1),8)
itypadl = (jpadl-1)/8+2
itypadr = (jpad-1)/8+2
if (jml == 0) then
  jml = 8
  itypadl = itypadl-1
end if
if (jmr == 0) then
  jmr = 8
  itypadr = itypadr-1
end if
if (jpadl == 1) itypadl = 1
if (jpad == 1) itypadr = 1
if (jpadl == 1) jml = ns_sm
if (jpad == 1) jmr = ns_sm
jml = Mul(jml,ns_sm)
jmr = Mul(jmr,ns_sm)
jmlr = Mul(jml,jmr)
lpok = map_jplr(itypadl,itypadr)
if (lpok == 0) return

select case (line)
  case default ! (23)
    ! line=23:-a^l<-->ds(7),dds(9),dt(14),ddtt(16)
    select case (lpok)
      case default ! (7)
        ! ds(7-2) ar(23)-bl(31)-br(32)-

        ! ds(7-1) ar(23)-drl(30)-
        do lri=norb_frz+1,norb_dz
          lmi = lsm_inn(lri)
          if (jmr == 1) then
            iwdr = just(lri,lri)
            do lrd=norb_frz+1,lri-1
              lmd = lsm_inn(lrd)
              if (lmd /= jml) cycle
              iwdl = jud(lrd)
              w0ds1 = w0_ds(1)
              ni = mod(norb_dz-lri+lri-lrd,2)
              if (ni == 0) w0ds1 = -w0ds1
              vlop0 = w0*w0ds1
              !list = list3(lrd,lra,lri)
              call trans_ijkl_intpos(lra,lri,lrd,lri,nxo)
              !wl = vlop0*vint_ci(list)
              wl = vlop0
              !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            end do
          end if
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jmr) cycle
            do lrd=norb_frz+1,lri-1
              lmd = lsm_inn(lrd)
              if (lmd /= jml) cycle
              !list = list4(lrd,lri,lrj,lra)
              iwdl = jud(lrd)
              w0ds2 = w0_ds(2)
              w1ds2 = w1_ds(2)
              w0ds3 = w0_ds(3)
              w1ds3 = w1_ds(3)
              ni = mod(norb_dz-lrj+lri-lrd,2)
              if (ni == 0) then
                w0ds2 = -w0ds2
                w1ds2 = -w1ds2
                w0ds3 = -w0ds3
                w1ds3 = -w1ds3
              end if
              ! ds(7-3) ar(23)-bl(32)-br(31)-
              iwdr = just(lri,lrj)
              vlop0 = w0*w0ds3
              vlop1 = w1*w1ds3
              !wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
              wl = vlop0-vlop1
              call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)

              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = -Two*vlop0
              call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)

              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              if (jb_sys > 0) then
                ! ds(7-2) ar(23)-bl(31)-br(32)-         the symmetry problem
                iwdr = just(lrj,lri)
                vlop0 = w0*w0ds2
                vlop1 = w1*w1ds2
                !wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
                wl = vlop0-vlop1
                call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)

                call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
                wl = -Two*vlop0
                call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)

                call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

              end if
            end do
          end do
        end do

      case (9)
        do lri=norb_frz+1,norb_dz
          ! d1s(9-1) ar(13)-drl(30)-
          lmi = lsm_inn(lri)
          do lrd=norb_frz+1,lri-1
            lmd = lsm_inn(lrd)
            if ((lmd == jml) .and. (jmr == 1)) then
              iwdr = just(lri,lri)
              iwdl = jud(lrd)
              w0ds1 = w0_d1s(1)
              ni = mod(norb_dz-lri+lri-lrd,2)
              if (ni == 0) w0ds1 = -w0ds1
              vlop0 = w0*w0ds1
              !list = list3(lrd,lra,lri)
              call trans_ijkl_intpos(lra,lri,lrd,lri,nxo)

              !wl = vlop0*vint_ci(list)          !   3.2
              wl = vlop0
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            end if
            ! d1s(9-4) drl(12)-br(31)-
            if ((jml == lmd) .and. (jmr == Mul(lmd,lmi))) then
              iwdr = just(lrd,lri)
              iwdl = jud(lrd)
              w1ds = w1_d1s(4)
              if (mod(norb_dz-lri,2) == 1) w1ds = -w1ds
              vlop1 = w1*w1ds
              !list = list3(lri,lra,lrd)
              call trans_ijkl_intpos(lra,lrd,lri,lrd,nxo)

              !wl = -vlop1*vint_ci(list)
              wl = -vlop1
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            end if
          end do
        end do
        do lri=norb_frz+1,norb_dz
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            ! d1s(9-3) ar(13)-bl(32)-br(31)-
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jmr) cycle
            do lrd=norb_frz+1,lri-1
              iwdr = just(lri,lrj)
              lmd = lsm_inn(lrd)
              if (lmd /= jml) cycle
              iwdl = jud(lrd)
              w0ds3 = w0_d1s(3)
              w1ds3 = w1_d1s(3)
              ni = mod(norb_dz-lrj+lri-lrd,2)
              if (ni == 0) w0ds3 = -w0ds3
              if (ni == 0) w1ds3 = -w1ds3
              vlop0 = w0*w0ds3
              vlop1 = w1*w1ds3
              !list = list4(lrd,lri,lrj,lra)
              !wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
              wl = vlop0-vlop1
              call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = -Two*vlop0
              call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

              if (jb_sys > 0) then
                !d1s(9-2)   ar(13)-bl(31)-br(32)-   the symmetry problem
                iwdr = just(lrj,lri)
                w0ds3 = w0_d1s(2)
                w1ds3 = w1_d1s(2)
                ni = mod(norb_dz-lrj+lri-lrd,2)
                if (ni == 0) w0ds3 = -w0ds3
                if (ni == 0) w1ds3 = -w1ds3
                vlop0 = w0*w0ds3
                vlop1 = w1*w1ds3
                !list = list4(lrd,lri,lrj,lra)
                !wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
                wl = vlop0-vlop1
                call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
                call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
                wl = -Two*vlop0
                call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)
                call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

              end if
            end do
          end do
        end do

      case (14)
        ! dt(14) ar(23)-bl(32)-br(32)-
        do lri=norb_frz+1,norb_dz-1
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jmr) cycle
            iwdr = just(lri,lrj)
            do lrd=norb_frz+1,lri-1
              lmd = lsm_inn(lrd)
              if (lmd /= jml) cycle
              iwdl = jud(lrd)
              vlop0 = w0*w0_dt
              vlop1 = w1*w1_dt
              ni = mod(lri-lrd+norb_dz-lrj,2)
              if (ni == 0) then
                vlop0 = -vlop0
                vlop1 = -vlop1
              end if
              !list = list4(lrd,lri,lrj,lra)
              !wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1) !1.1
              wl = vlop0-vlop1
              call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = -Two*vlop0
              call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
          end do
        end do

      case (16)
        ! d1t1(16)  ar(13)-bl(31)-br(31)-
        do lri=norb_frz+1,norb_dz-1
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jmr) cycle
            iwdr = just(lri,lrj)
            do lrd=norb_frz+1,lri-1
              lmd = lsm_inn(lrd)
              lmd = Mul(lmd,1)
              if (lmd /= jml) cycle
              iwdl = jud(lrd)
              vlop0 = w0*w0_d1t1
              vlop1 = w1*w1_d1t1
              ni = mod(lri-lrd+norb_dz-lrj,2)
              if (ni == 0) then
                vlop0 = -vlop0
                vlop1 = -vlop1
              end if
              !list = list4(lrd,lri,lrj,lra)
              !wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1) !1.1
              wl = vlop0-vlop1
              call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = -Two*vlop0
              call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
          end do
        end do

      case (1:6,8,10:13,15,17:26)
    end select

  case (24)
    ! line=24:-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        ! sd(6-1) a&r(02)-
        ! sd(6-2) c(22)a&(13)-
        ! sd(6-3) a&r(13)c'(22)-
        ! sd(6-4) a&r(23)c'(12)-
        ! sd(6-5) a&r(23)b&r(13)b^r(32)
        ! sd(6-6) a&r(13)b&r(23)b^r(32)
        ! sd(6-7) a&r(13)b&l(32)b^l(23)
        ! sd(6-8) a&r(23)b&l(32)b^l(13)
        ! sd(6-9) d&r&r(03)b^r(32)
        ! sd(6-10) d&r&l(12)b^l(23)
        ! sd(6-11) d&r&l(22)b^l(13)
        ! sd(6-12) d&r&l(33)b^l(02)
        ! sd(6-13) (22)d&r&l(33)b^l(13)
        ! sd(6-14) d&r&l(33)c"(22)b^l(13)
        ! sd(6-15) d&r&l(33)b^l(13)c'(22)
        ! sd(6-16) d&r&l(33)b^l(23)c'(12)
        ! sd(6-1) a&r(02)-

        call sd_head_dbl_tail_act_g(lra,lpcoe)

      case (8)
        call sdd_head_dbl_tail_act_g(lra,lpcoe)

      case (13)
        ! td(13-1) (22)a&(23)
        ! td(13-1) a&(23)c'(22)
        ! td(13-5) (22)d&&l(33)b^l(23)
        do lri=norb_frz+1,norb_dz
          lmi = lsm_inn(lri)
          if (lmi /= jmlr) cycle
          w0td1 = w0_td(1)
          w0td4 = w0_td(4)
          w0td5 = w0_td(5)
          ni = mod(norb_dz-lri,2)
          if (ni == 1) w0td1 = -w0td1
          if (ni == 1) w0td4 = -w0td4
          if (ni == 1) w0td5 = -w0td5

          ! td(13-1) a&(23)c'(22)
          do lrd=lri+1,norb_dz
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdl = just(lri,lrd)
            iwdr = jud(lrd)
            vlop0 = -w0*w0td1
            !list = list3(lri,lra,lri)
            !wl = voint(lri,lra)+vint_ci(list)             !310,act_coe,610,
            wl = vlop0
            call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lri,lra)
            call trans_ijkl_intpos(lra,lri,lri,lri,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            !list = list3(lri,lra,lrd)
            !wl = wl+vint_ci(list+1)                          !310 c'(22) co
            call trans_ijkl_intpos(lra,lri,lrd,lrd,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            do lr=lri+1,norb_dz
              if (lr == lrd) cycle
              !list = list3(lri,lra,lr)
              !wl = wl+Two*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,coe
              wl = Two*vlop0
              call trans_ijkl_intpos(lra,lri,lr,lr,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = -vlop0
              call trans_ijkl_intpos(lra,lr,lri,lr,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
            do lrk=norb_dz+1,lra
              !list = list3(lri,lra,lrk)
              kcoe = lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              !wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
              wl = vlop0*nocc
              call trans_ijkl_intpos(lra,lri,lrk,lrk,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = vlop0*tcoe*nocc
              call trans_ijkl_intpos(lra,lrk,lri,lrk,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
            !wl = wl*vlop0
            ! td(13-5) d&rl(33)b^l(23)c'(22)
            vlop0 = -w0*w0td5
            do lrk=1,lri-1
              !list = list3(lri,lra,lrk)
              !wl = wl-vlop0*(Two*vint_ci(list+1)-vint_ci(list))
              wl = -vlop0*2
              call trans_ijkl_intpos(lra,lri,lrk,lrk,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = vlop0
              call trans_ijkl_intpos(lra,lrk,lri,lrk,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
            !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          end do
          !---------------------------------------------------------------------
          do lrd=norb_frz+1,lri-1
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdl = just(lrd,lri)
            iwdr = jud(lrd)
            ! td(13-1) (22)a&(23)
            vlop0 = w0*w0td1
            !list = list3(lri,lra,lri)
            !wl = vlop0*(voint(lri,lra)+vint_ci(list))     !310,act_coe,610,
            wl = vlop0
            call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lri,lra)
            call trans_ijkl_intpos(lra,lri,lri,lri,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            do lr=lri+1,norb_dz
              !list = list3(lri,lra,lr)
              !wl = wl+vlop0*(Two*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2
              wl = vlop0*2
              call trans_ijkl_intpos(lra,lri,lr,lr,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = -vlop0
              call trans_ijkl_intpos(lra,lr,lri,lr,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
            do lrk=norb_dz+1,lra
              !list = list3(lri,lra,lrk)
              kcoe = lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              !wl = wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
              wl = vlop0*nocc
              call trans_ijkl_intpos(lra,lri,lrk,lrk,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = vlop0*tcoe*nocc
              call trans_ijkl_intpos(lra,lrk,lri,lrk,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
            !wl = wl*vlop0
            ! td(13-4) d&r&l(22)b^l(23)
            vlop0 = w0*w0td4
            vlop1 = w1*w0td4
            !list = list3(lri,lra,lrd)
            !wl = wl+(vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)
            wl = -Two*vlop0
            call trans_ijkl_intpos(lra,lri,lrd,lrd,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl = vlop0-vlop1
            call trans_ijkl_intpos(lra,lrd,lri,lrd,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            ! td(13-5) d&rl(33)c"(22)b^l(23)
            vlop0 = w0*w0td5
            do lrk=1,lri-1
              if (lrk == lrd) cycle
              !list = list3(lri,lra,lrk)
              !wl = wl+vlop0*(vint_ci(list)-Two*vint_ci(list+1))      !4.3
              wl = -Two*vlop0
              call trans_ijkl_intpos(lra,lri,lrk,lrk,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = vlop0
              call trans_ijkl_intpos(lra,lrk,lri,lrk,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
            !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          end do
        end do

        do lri=norb_frz+1,norb_dz-1
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jml) cycle
            iwdl = just(lri,lrj)

            ! td(13-2) a&(23)b&r(23)b^r(32)
            do lrd=lrj+1,norb_dz
              lmd = lsm_inn(lrd)
              if (lmd /= jmr) cycle
              w0td2 = w0_td(2)
              w1td2 = w1_td(2)
              ni = mod(lrj-lri+norb_dz-lrd,2)
              if (ni == 0) w0td2 = -w0td2
              if (ni == 0) w1td2 = -w1td2

              iwdr = jud(lrd)
              vlop0 = w0*w0td2
              vlop1 = w1*w1td2
              !list = list4(lri,lrj,lrd,lra)
              !wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list))  !1.3
              wl = vlop0-vlop1
              call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = vlop0+vlop1
              call trans_ijkl_intpos(lra,lrj,lrd,lri,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
            ! td(13-3) a&(23)b&l(32)b^l(23)
            do lrd=lri+1,lrj-1
              lmd = lsm_inn(lrd)
              if (lmd /= jmr) cycle
              iwdr = jud(lrd)
              w0td3 = w0_td(3)
              w1td3 = w1_td(3)
              ni = mod(lrd-lri+norb_dz-lrj,2)
              if (ni == 0) w0td3 = -w0td3
              if (ni == 0) w1td3 = -w1td3
              vlop0 = w0*w0td3                !d6-8
              vlop1 = w1*w1td3
              !list = list4(lri,lrd,lrj,lra)
              !wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2)      !1.2

              wl = vlop0-vlop1
              call trans_ijkl_intpos(lra,lri,lrd,lrj,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
              wl = -vlop0*2
              call trans_ijkl_intpos(lra,lrj,lrd,lri,nxo)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            end do
          end do
        end do

      case (15)
        call ttdd_head_dbl_tail_act_g(lra,lpcoe)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !*********************************************************************
          lr0 = lrd
          lr = kk(jpel)-1
          !list = list3(lr0,lr,lr0)
          !wl = vlop0*(voint(lr0,lr)+vint_ci(list))       !310+710
          wl = vlop0

          call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lr0,lr)
          call trans_ijkl_intpos(lr,lr0,lr0,lr0,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          do l=lr0+1,norb_dz
            !list=list3(lr0,lr,l)
            nocc = 2
            tcoe = -Half
            !wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))  !dbl_
            wl = vlop0*nocc
            call trans_ijkl_intpos(lr,lr0,l,l,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl = vlop0*tcoe*nocc
            call trans_ijkl_intpos(lr,l,lr0,l,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          end do
          do l=norb_dz+1,lr
            !list = list3(lr0,lr,l)
            kcoe = lpcoe(l)
            call neoc(kcoe,nocc,tcoe)
            !wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))   !act_c
            wl = vlop0*nocc
            call trans_ijkl_intpos(lr,lr0,l,l,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl = vlop0*tcoe*nocc
            call trans_ijkl_intpos(lr,l,lr0,l,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          end do
          !wl_430 = Zero
          w0dv2 = w0_dv(2)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv2 = -w0dv2
          do lrk=1,lrd-1
            !list = list3(lr0,lr,lrk)
            vlop0 = w0*w0dv2
            !wl_430 = wl_430+vlop0*(vint_ci(list)-Two*vint_ci(list+1))
            wl = vlop0
            call trans_ijkl_intpos(lr,lrk,lr0,lrk,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl = -vlop0*2
            call trans_ijkl_intpos(lr,lr0,lrk,lrk,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          end do
          !wl = wl+wl_430
          !*********************************************************************
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (24)
        ! d1v(24-1) ar(13)-
        ! d1v(24-2) drl(33)-bl(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d24-1
          vlop1 = w1*w0dv1
          !*********************************************************************
          lr0 = lrd
          lr = kk(jpel)-1
          !list = list3(lr0,lr,lr0)
          !wl = vlop0*(voint(lr0,lr)+vint_ci(list))       !310+710
          wl = vlop0
          call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lr0,lr)
          call trans_ijkl_intpos(lr,lr0,lr0,lr0,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          do l=lr0+1,norb_dz
            !list=list3(lr0,lr,l)
            nocc = 2
            tcoe = -Half
            !wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))  !dbl_
            wl = vlop0*nocc
            call trans_ijkl_intpos(lr,lr0,l,l,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl = vlop0*tcoe*nocc
            call trans_ijkl_intpos(lr,l,lr0,l,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          end do
          do l=norb_dz+1,lr
            !list = list3(lr0,lr,l)
            kcoe = lpcoe(l)
            call neoc(kcoe,nocc,tcoe)
            !wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))   !act_c
            wl = vlop0*nocc
            call trans_ijkl_intpos(lr,lr0,l,l,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl = vlop0*tcoe*nocc
            call trans_ijkl_intpos(lr,l,lr0,l,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          end do
          !wl_430 = Zero
          w0dv2 = w0_d1v(2)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv2 = -w0dv2
          do lrk=1,lrd-1
            !list = list3(lr0,lr,lrk)
            vlop0 = w0*w0dv2
            !wl_430 = wl_430+vlop0*(vint_ci(list)-Two*vint_ci(list+1))
            wl = vlop0
            call trans_ijkl_intpos(lr,lrk,lr0,lrk,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl = -vlop0*2
            call trans_ijkl_intpos(lr,lr0,lrk,lrk,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          end do
          !wl = wl+wl_430
          !*********************************************************************
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (25)
    ! line=25:-d^r^r<-->sv(10),tv(17),ttv(18)
    select case (lpok)
      case default ! (10)
        call sv_head_dbl_tail_act_g(lra)

      case (17)
        ! tv(17) ar(23)-br(23)-
        iwdr = 0
        do lri=norb_frz+1,norb_dz
          imi = lsm_inn(lri)
          do lrj=lri,norb_dz
            imj = lsm_inn(lrj)
            imij = Mul(imi,imj)
            if (imij /= jml) cycle
            iwdl = just(lri,lrj)
            vlop1 = w1*w1_tv             !d17 vlop0=0
            !list = list3(lri,lrj,lra)
            !wl = vlop1*vint_ci(list)        !2.1                  !!!!!
            wl = vlop1
            call trans_ijkl_intpos(lrj,lra,lri,lra,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          end do
        end do

      case (18)
        ! t1v(18) ar(13)-br(13)-
        iwdr = 0
        do lri=norb_frz+1,norb_dz
          imi = lsm_inn(lri)
          do lrj=lri,norb_dz
            imj = lsm_inn(lrj)
            imij = Mul(imi,imj)
            if (imij /= jml) cycle
            iwdl = just(lri,lrj)
            vlop1 = w1*w1_t1v             !d18 vlop0=0
            !list = list3(lri,lrj,lra)
            !wl = vlop1*vint_ci(list)        !2.1                  !!!!!
            wl = vlop1
            call trans_ijkl_intpos(lrj,lra,lri,lra,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          end do
        end do

      case (1:9,11:16,19:26)
    end select

  case (26)
    ! line=26:-d^r^l<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(19
    select case (lpok)
      case default ! (1)
        call ss_head_dbl_tail_act_g(lra)

      case (2)
        call st_head_dbl_tail_act_g(lra)

      case (3)
        call ts_head_dbl_tail_act_g(lra)

      case (4)
        call stt_head_dbl_tail_act_g(lra)

      case (5)
        call tts_head_dbl_tail_act_g(lra)

      case (11)
        call tt_head_dbl_tail_act_g(lra)

      case (12)
        call tttt_head_dbl_tail_act_g(lra)

      case (19)
        call dd_head_dbl_tail_act_g(lra)

      case (20)
        call dddd_head_dbl_tail_act_g(lra)

      case (21)
        call dd1_head_dbl_tail_act_g(lra)

      case (22)
        call d1d_head_dbl_tail_act_g(lra)

      case (25)
        ! vv(25) drl(33)-
        if (jwl == jwr) return
        vlop0 = w0*w0_vv             !d25
        wl = Zero
        iwdl = 0
        iwdr = 0
        do lri=1,norb_dz
          !wl = wl+vlop0*voint(lri,lra)
          wl = vlop0
          call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lri,lra)
        end do
        !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)

      case (6:10,13:18,23:24,26)
    end select

  case (27)
    ! line=27:-b^r-a^r<-->sv(10),tv(17),ttv(18)
    select case (lpok)
      case default ! (10)
        call sv_head_dbl_tail_act_g(lra)

      case (17)
        ! tv(17) ar(23)-br(23)-
        iwdr = 0
        do lri=norb_frz+1,norb_dz
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jml) cycle
            w1tv = w1_tv
            if (mod(lrj-lri,2) == 0) w1tv = -w1tv
            iwdl = just(lri,lrj)
            vlop1 = w1*w1tv             !d17
            !list = list4(lri,lrj,lrs,lra)
            !wl = vlop1*(vint_ci(list)-vint_ci(list+2)) !1.3 vlop0=0      !!!!
            !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            wl = vlop1
            call trans_ijkl_intpos(lra,lrj,lrs,lri,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl = -vlop1
            call trans_ijkl_intpos(lra,lri,lrj,lrs,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          end do
        end do

      case (18)
        ! t1v(18) ar(13)-br(13)-
        iwdr = 0
        do lri=norb_frz+1,norb_dz-1
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jml) cycle
            w1tv = w1_t1v
            if (mod(lrj-lri,2) == 0) w1tv = -w1tv
            iwdl = just(lri,lrj)
            vlop1 = w1*w1tv             !d17
            !list = list4(lri,lrj,lrs,lra)
            !wl = vlop1*(vint_ci(list)-vint_ci(list+2)) !1.3 vlop0=0      !!!!
            !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            wl = vlop1
            call trans_ijkl_intpos(lra,lrj,lrs,lri,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl = -vlop1
            call trans_ijkl_intpos(lra,lri,lrj,lrs,nxo)
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          end do
        end do

      case (1:9,11:16,19:26)
    end select

  case (28)
    ! line=28:-b^l-a^r<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(
    select case (lpok)
      case default ! (1)
        call ss_head_dbl_tail_act_g(lra)

      case (2)
        call st_head_dbl_tail_act_g(lra)

      case (3)
        call ts_head_dbl_tail_act_g(lra)

      case (4)
        call stt_head_dbl_tail_act_g(lra)

      case (5)
        call tts_head_dbl_tail_act_g(lra)

      case (11)
        call tt_head_dbl_tail_act_g(lra)

      case (12)
        call tttt_head_dbl_tail_act_g(lra)

      case (19)
        call dd_head_dbl_tail_act_g(lra)

      case (20)
        call dddd_head_dbl_tail_act_g(lra)

      case (21)
        call dd1_head_dbl_tail_act_g(lra)

      case (22)
        call d1d_head_dbl_tail_act_g(lra)

      case (25)
        ! vv(25) drl(33)-
        vlop0 = w0*w0_vv             !d25
        wl = 0.d0
        iwdl = 0
        iwdr = 0
        do lrk=1,norb_dz
          !list = list3(lrs,lra,lrk)
          !wl = wl+vlop0*(vint_ci(list)-Two*vint_ci(list+1))   !4.3 vlop1=0
          wl = vlop0
          call trans_ijkl_intpos(lra,lrk,lrs,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl = -vlop0*2
          call trans_ijkl_intpos(lra,lrs,lrk,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

        end do
        !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)

      case (6:10,13:18,23:24,26)
    end select

  case (29)
    ! line=29:-b^r-a^l<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(
    select case (lpok)
      case default ! (1)
        call ss_head_dbl_tail_act_g(lra)

      case (2)
        call st_head_dbl_tail_act_g(lra)

      case (3)
        call ts_head_dbl_tail_act_g(lra)

      case (4)
        call stt_head_dbl_tail_act_g(lra)

      case (5)
        call tts_head_dbl_tail_act_g(lra)

      case (11)
        call tt_head_dbl_tail_act_g(lra)

      case (12)
        call tttt_head_dbl_tail_act_g(lra)

      case (19)
        call dd_head_dbl_tail_act_g(lra)

      case (20)
        call dddd_head_dbl_tail_act_g(lra)

      case (21)
        call dd1_head_dbl_tail_act_g(lra)

      case (22)
        call d1d_head_dbl_tail_act_g(lra)

      case (25)
        ! vv(25) drl(33)-
        if (jwl >= jwr) return
        vlop0 = w0*w0_vv             !d25
        wl = Zero
        iwdl = 0
        iwdr = 0
        do lrk=1,norb_dz
          !list = list3(lrs,lra,lrk)
          !wl = vlop0*vint_ci(list)      !4.2  vlop1=0         !!!!!
          wl = vlop0
          call trans_ijkl_intpos(lra,lrk,lrs,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do
        !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)

      case (6:10,13:18,23:24,26)
    end select

  case (30)
    ! line=30:-b&r-d^r^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        ! sd(6-3) a&r(13)c'(22)-
        call dbl_sd_act_comp_g(3,lra)

      case (8)
        ! sd(6-3) tmp for spin=0
        !return
        call dbl_sdd_act_comp_g(3,lra)

      case (13)
        call dbl_td_act_comp_g(3,lra)

      case (15)
        call dbl_ttdd_act_comp_g(3,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                   !d23-1
          vlop1 = w1*w0dv1
          !list = list3(lrd,lrg,lra)
          !wl = (vlop0+vlop1)*vint_ci(list)        !2.1       !!!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0+vlop1
          call trans_ijkl_intpos(lrg,lra,lrd,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                   !d23-1
          vlop1 = w1*w0dv1
          !list = list3(lrd,lrg,lra)
          !wl = (vlop0+vlop1)*vint_ci(list)        !2.1
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0+vlop1
          call trans_ijkl_intpos(lrg,lra,lrd,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (31)
    ! line=31:-b&l-d^r^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp_g(5,lra)

      case (8)
        call dbl_sdd_act_comp_g(5,lra)

      case (13)
        call dbl_td_act_comp_g(5,lra)

      case (15)
        call dbl_ttdd_act_comp_g(5,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !list = list3(lrd,lrg,lra)
          !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*(vint_ci(list))   !2.2          !!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0-vlop1
          call trans_ijkl_intpos(lrg,lra,lrd,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl = -vlop0*2
          call trans_ijkl_intpos(lrg,lrd,lra,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !list = list3(lrd,lrg,lra)
          !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*(vint_ci(list))   !2.2          !!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0-vlop1
          call trans_ijkl_intpos(lrg,lra,lrd,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl = -vlop0*2
          call trans_ijkl_intpos(lrg,lrd,lra,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (32)
    ! line=32:-b&r-b^r-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp_g(4,lra)

      case (8)
        call dbl_sdd_act_comp_g(4,lra)

      case (13)
        call dbl_td_act_comp_g(4,lra)

      case (15)
        call dbl_ttdd_act_comp_g(4,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !list = list4(lrd,lrg,lrs,lra)
          !wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list))  !1.3        !!!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0+vlop1
          call trans_ijkl_intpos(lra,lrg,lrs,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl = vlop0-vlop1
          call trans_ijkl_intpos(lra,lrd,lrg,lrs,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !list = list4(lrd,lrg,lrs,lra)
          !wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list))  !1.3        !!!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0+vlop1
          call trans_ijkl_intpos(lra,lrg,lrs,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl = vlop0-vlop1
          call trans_ijkl_intpos(lra,lrd,lrg,lrs,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (33)
    ! line=33:-b&l-b^r-a^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp_g(6,lra)

      case (8)
        call dbl_sdd_act_comp_g(6,lra)

      case (13)
        call dbl_td_act_comp_g(6,lra)

      case (15)
        call dbl_ttdd_act_comp_g(6,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !list = list4(lrd,lrg,lrs,lra)
          !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)  !1.1          !!!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0-vlop1
          call trans_ijkl_intpos(lra,lrg,lrs,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl = -vlop0*2
          call trans_ijkl_intpos(lra,lrs,lrg,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !list = list4(lrd,lrg,lrs,lra)
          !wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)  !1.1          !!!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0-vlop1
          call trans_ijkl_intpos(lra,lrg,lrs,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl = -vlop0*2
          call trans_ijkl_intpos(lra,lrs,lrg,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (34)
    ! line=34:-b&l-b^l-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp_g(7,lra)

      case (8)
        call dbl_sdd_act_comp_g(7,lra)

      case (13)
        call dbl_td_act_comp_g(7,lra)

      case (15)
        call dbl_ttdd_act_comp_g(7,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !list = list4(lrd,lrg,lrs,lra)
          !wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2) !1.2      !!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0-vlop1
          call trans_ijkl_intpos(lra,lrd,lrg,lrs,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl = -vlop0*2
          call trans_ijkl_intpos(lra,lrs,lrg,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !list = list4(lrd,lrg,lrs,lra)
          !wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2) !1.2      !!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          call trans_ijkl_intpos(lra,lrd,lrg,lrs,nxo)
          wl = vlop0-vlop1
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl = -vlop0*2
          call trans_ijkl_intpos(lra,lrs,lrg,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (35)
    ! line=35:-d&r^l-a^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp_g(2,lra)

      case (8)
        call dbl_sdd_act_comp_g(2,lra)

      case (13)
        call dbl_td_act_comp_g(2,lra)

      case (15)
        call dbl_ttdd_act_comp_g(2,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          !list = list3(lrd,lra,lrs)
          !wl = vlop0*vint_ci(list)          !3.2         !!!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0
          call trans_ijkl_intpos(lra,lrs,lrd,lrs,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          !list = list3(lrd,lra,lrg)
          !wl = vlop0*vint_ci(list)          !3.2         !!!!!
          !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl = vlop0
          call trans_ijkl_intpos(lra,lrg,lrd,lrg,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select
end select

return

end subroutine dbl_head_act_tail_g

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ZBLTP(ISMOST,MAXSYM,IDC,ICBLTP,IMMLST)
*
* Generate vector ICBLTP giving type of each block
*
*
* ICBLTP gives type of symmetry block :
* = 0 : symmetry block is not included
* = 1 : symmetry block is included , all OO types
* = 2 : symmetry block is included , lower OO types
*
*. Input
      DIMENSION ISMOST(*),IMMLST(*)
*. Output
      DIMENSION ICBLTP(*)
*. Changed to simplify structure for IDC .le. 2
      IF(IDC.LE.2) THEN
*. No spatial degeneracy
        DO IASYM = 1, MAXSYM
          IBSYM = ISMOST(IASYM)
          IF(IDC.EQ.2.AND.IBSYM.GT.IASYM) THEN
*.Symmetry block excluded
            ICBLTP(IASYM) = 0
          ELSE IF((IDC.EQ.2.AND.IASYM.GT.IBSYM).OR.IDC.EQ.1) THEN
*.Complete symmetry block included
            ICBLTP(IASYM) = 1
          ELSE
*.Lower half  symmetry block included
            ICBLTP(IASYM) = 2
          END IF
        END DO
      ELSE
*. Also spatial degeneracy
      DO 100 IASYM = 1, MAXSYM
*
        IBSYM = ISMOST(IASYM)
        IF(IBSYM .EQ. 0 ) GOTO 100
        IF(((IDC.EQ.2.OR.IDC.EQ.4).AND.(IBSYM.GT.IASYM))
     &                    .OR.
     &       (IDC.EQ.3.AND.IMMLST(IASYM).GT.IASYM)) THEN
*.Symmetry block excluded
          ICBLTP(IASYM) = 0
        ELSE IF((IDC.EQ.2.AND.IASYM.GT.IBSYM)
     &                   .OR.
     &                IDC.EQ.1
     &                   .OR.
     &          (IDC.EQ.3.AND.IASYM.GE.IMMLST(IASYM))) THEN
*.Complete symmetry block included
          ICBLTP(IASYM) = 1
        ELSE
*.Lower half  symmetry block included
          ICBLTP(IASYM) = 2
        END IF
  100 CONTINUE
      END IF
*     ^ End of IDC switch
*
      NTEST = 0
      IF ( NTEST .NE. 0 ) THEN
         WRITE(6,*) ' Block type of symmetry blocks '
         CALL IWRTMA(ICBLTP,1,MAXSYM,1,MAXSYM)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine creates a model fock operator based on atomic orbital   *
* energies.                                                            *
*                                                                      *
* This is a very preliminary routine for testing purposes. It relies   *
* on the basis set being of ANO type.                                  *
*                                                                      *
* Absolutely NOT to be used for production!!!!                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: Oct 2004                                                    *
*                                                                      *
************************************************************************
      Subroutine FockOper(RC,Fock)
      Implicit None
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "commgo.fh"
*----------------------------------------------------------------------*
* Parameters                                                           *
*----------------------------------------------------------------------*
      Integer MxComp
      Parameter ( MxComp = 4 )
*----------------------------------------------------------------------*
* Dummy arguments                                                      *
*----------------------------------------------------------------------*
      Real*8  Fock(*)
      Integer RC
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Logical Debug
      Logical Trace
      Logical Found
      Integer iSym
      Integer iBas
      Integer iOff
      Integer iNuc
      Integer nBasTot
      Integer iUse(MxAtom,MxComp)
      Integer nData
      Integer i,k
      Real*8  energy
*----------------------------------------------------------------------*
* Some setup                                                           *
*----------------------------------------------------------------------*
      Debug=.false.
      Trace=.false.
      If(Trace) Write(6,*) '>>> Entering fockoper'
      RC=0
*----------------------------------------------------------------------*
* Setup various counters.                                              *
*----------------------------------------------------------------------*
      nBasTot=0
      Do iSym=1,nSym
         nBasTot=nBasTot+nBas(iSym)
      End Do
*----------------------------------------------------------------------*
* Is Fock operator on disk?                                            *
*----------------------------------------------------------------------*
      Call Qpg_dArray('Eorb',Found,nData)
      If(Found) Then
         Call Get_dArray('Eorb',Fock,nData)
         If(Debug) Then
            Write(6,*)
            Write(6,*) 'Found Eorb'
            Write(6,'(10F12.6)') (Fock(i),i=1,nData)
            Write(6,*)
         End If
         If(.true.) Return
      End If
      If(.true.) Then
         RC=1
         return
      End If
      Write(6,*) '***'
      Write(6,*) '*** Warning: using built in fock operator'
      Write(6,*) '***'
*----------------------------------------------------------------------*
* Create model Fock operator.                                          *
*----------------------------------------------------------------------*
      iOff=0
      Do iSym=1,nSym
         If(Debug) Then
            Write(6,*) '***'
            Write(6,*) '*** Symmetry',iSym
            Write(6,*) '***'
         End If
         Do i=1,MxAtom
            Do k=1,MxComp
               iUse(i,k)=0
            End Do
         End Do
         Do iBas=1,nBas(iSym)
            iNuc=0
            Do i=1,nNuc
               If(Name(i).eq.Label(iBas+iOff)(1:LENIN)) iNuc=i
            End Do
            If(Debug) Then
               Write(6,'(2(a,i3),3a,i3,f6.2)')
     &            'iSym:',iSym,' iBas:',iBas,
     &            ' = ',Label(iBas+iOff)(1:LENIN),
     &            Label(iBas+iOff)(LENIN1:LENIN8),
     &            iNuc,xCharge(iNuc)
            End If
            If(iNuc.eq.0) Then
               Call SysAbendMsg('fockoper','Fatal','001')
            End If
            energy=0.0d0
            If(Abs(xCharge(iNuc)-1.0d0).lt.1.0d-3) Then
               If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'01s     ') Then
                  iUse(iNuc,1)=iUse(iNuc,1)+1
                  If(iUse(iNuc,1).eq.1) energy=-0.50000d0
               End If
            Else If(Abs(xCharge(iNuc)-3.0d0).lt.1.0d-3) Then
               If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'01s     ') Then
                  iUse(iNuc,1)=iUse(iNuc,1)+1
                  If(iUse(iNuc,1).eq.1) energy=-2.47773d0
                  If(iUse(iNuc,1).eq.2) energy=-0.19632d0
               End If
            Else If(Abs(xCharge(iNuc)-6.0d0).lt.1.0d-3) Then
               If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'01s     ') Then
                  iUse(iNuc,1)=iUse(iNuc,1)+1
                  If(iUse(iNuc,1).eq.1) energy=-11.32554d0
                  If(iUse(iNuc,1).eq.2) energy=-0.70563d0
               Else If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'02px    ')
     &         Then
                  iUse(iNuc,2)=iUse(iNuc,2)+1
                  If(iUse(iNuc,2).eq.1) energy=-0.43335d0
               Else If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'02py    ')
     &         Then
                  iUse(iNuc,3)=iUse(iNuc,3)+1
                  If(iUse(iNuc,3).eq.1) energy=-0.43335d0
               Else If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'02pz    ')
     &         Then
                  iUse(iNuc,4)=iUse(iNuc,4)+1
                  If(iUse(iNuc,4).eq.1) energy=-0.43335d0
               End If
            Else If(Abs(xCharge(iNuc)-7.0d0).lt.1.0d-3) Then
               If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'01s ') Then
                  iUse(iNuc,1)=iUse(iNuc,1)+1
                  If(iUse(iNuc,1).eq.1) energy=-15.62909d0
                  If(iUse(iNuc,1).eq.2) energy=-0.94531d0
               Else If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'02px    ')
     &         Then
                  iUse(iNuc,2)=iUse(iNuc,2)+1
                  If(iUse(iNuc,2).eq.1) energy=-0.56758d0
               Else If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'02py    ')
     &         Then
                  iUse(iNuc,3)=iUse(iNuc,3)+1
                  If(iUse(iNuc,3).eq.1) energy=-0.56758d0
               Else If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'02pz    ')
     &         Then
                  iUse(iNuc,4)=iUse(iNuc,4)+1
                  If(iUse(iNuc,4).eq.1) energy=-0.56758d0
               End If
            Else If(Abs(xCharge(iNuc)-8.0d0).lt.1.0d-3) Then
               If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'01s ') Then
                  iUse(iNuc,1)=iUse(iNuc,1)+1
                  If(iUse(iNuc,1).eq.1) energy=-20.66866d0
                  If(iUse(iNuc,1).eq.2) energy=-1.24433d0
               Else If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'02px    ')
     &         Then
                  iUse(iNuc,2)=iUse(iNuc,2)+1
                  If(iUse(iNuc,2).eq.1) energy=-0.63192d0
               Else If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'02py    ')
     &         Then
                  iUse(iNuc,3)=iUse(iNuc,3)+1
                  If(iUse(iNuc,3).eq.1) energy=-0.63192d0
               Else If(Label(iBas+iOff)(LENIN1:LENIN8).eq.'02pz    ')
     &         Then
                  iUse(iNuc,4)=iUse(iNuc,4)+1
                  If(iUse(iNuc,4).eq.1) energy=-0.63192d0
               End If
            Else
               Call SysAbendMsg('fockoper','Fatal','002')
            End If
            Fock(iOff+iBas)=energy
         End Do
         iOff=iOff+nBas(iSym)
      End Do
*----------------------------------------------------------------------*
* Done, deallocate the rest.                                           *
*----------------------------------------------------------------------*
      If(trace) Write(6,*) '<<< Exiting fockoper'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function qRINT(N,A,C,EXPA)

use welcom, only: binom, kmax
use Constants, only: Zero, One, Half, Pi
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: qRINT
integer(kind=iwp), intent(in) :: N
real(kind=wp) :: A, C, EXPA
integer(kind=iwp) :: I, J, K, NN, nT
real(kind=wp) :: ALF, ARG, BP, Dac, F(kmax+1), FACT, FACT2, GAL, GINT, HINT, PRSUM, START, TAL

qRINT = Zero
NN = N/2+1
!write(u6,*) ' N,NN=',n,nn
BP = Half*C
START = sqrt(Pi)
PRSUM = exp(BP*BP*A+EXPA)
ALF = sqrt(A)
ARG = (BP*ALF)**2
nT = 1
F(:) = Zero
call Auxil([Arg],nT,F,nn-1)
!call RecPrt(' In qRint:Fm',' ',F,nt,nn)
GINT = Zero
Dac = -One
do I=0,N
  TAL = (-BP)**(N-I)*Binom(n,i)
  J = I/2

  if (J*2 == I) then
    Dac = Dac*Half*(real(2*J-1,kind=wp))
    FACT = ALF**(-I-1)*START*DAC
    FACT2 = BP**(I+1)*F(J+1)
    GINT = (FACT-FACT2)*TAL+GINT
  else
    GAL = One
    HINT = Zero
    do K=I-1,0,-2
      HINT = HINT+Half/A*BP**K*exp(-ARG)*GAL
      GAL = Half*real(K,kind=wp)/A*GAL
    end do
    GINT = GINT+TAL*HINT
  end if

  qRINT = GINT*PRSUM
end do

return

end function qRINT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
!***********************************************************************

subroutine MkFock(CMO,nCMO,FIMO,NFIMO,FIFA,nFIFA,DREF,nDREF,HONE,nHONE,INITIATE)

use caspt2_module, only: IfChol
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCMO, nFIMO, nFIFA, nDREF, nHONE
real(kind=wp), intent(in) :: CMO(nCMO), DREF(nDREF)
real(kind=wp), intent(inout) :: FIMO(nFIMO), FIFA(nFIFA), HONE(nHONE)
logical(kind=iwp), intent(inout) :: INITIATE

if (INITIATE) call TraOne(CMO,nCMO,HONE,nHONE)

! Compute the Fock matrix in MO basis for state Jstate
! Fock matrix in MO basis: FIMO, FIFA

if (IfChol) then
  ! INTCTL2 uses TraCho2 to generate the fock matrix in AO basis. Subsequently, FMatCho
  ! transform to the MO basis.
  call INTCTL2(CMO,NCMO,DREF,nDREF,FIFA,nFIFA,HONE,nHONE,FIMO,nFIMO)
else
  ! Matrix elements generated directly from one-ham and two-electron integrals in th MO basis.
  if (Initiate) call TraCtl(nCMO,CMO,0)
  call FMAT_CASPT2(FIFA,nFIFA,FIMO,nFIMO,DREF,nDREF,HONE,nHONE)
end if
INITIATE = .false.

! Modify the Fock matrix if needed (G Family of modifications).
! You don't have to be beautiful to turn me on
call NEWFOCK(FIFA,nFIFA,CMO,NCMO,DREF,nDREF)

end subroutine MkFock

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_dOdx(ZA,RA,nAtoms,T,O,EVal,Rot_Corr,iAtom,iCar,dTdRAi,dMdx,dOdx,Px)

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, iAtom, iCar
real(kind=wp), intent(in) :: ZA(nAtoms), RA(3,nAtoms), T(3), O(3,3), EVal(3), dTdRAi
logical(kind=iwp), intent(in) :: Rot_Corr
real(kind=wp), intent(out) :: dMdx(3,3), dOdx(3,3), Px(3,3)
real(kind=wp) :: Alpha, Beta, Gmma, OtMx(3,3), OtMxO(3,3)
real(kind=wp), parameter :: Thrs = 1.0e-14_wp

!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. Rot_Corr) then
  dOdx(:,:) = Zero
  return
end if

! Differentiate the nuclear charge moment tensor, M.

call Compute_dMdx(ZA,RA,nAtoms,T,iAtom,iCar,dTdRAi,dMdx)

! Form O(t) dMdRAi O

call DGEMM_('T','N',3,3,3,One,O,3,dMdx,3,Zero,OtMx,3)
call DGEMM_('N','N',3,3,3,One,OtMx,3,O,3,Zero,OtMxO,3)

! Compute the off diagonal elements in Px

if (abs(OtMxO(2,3)+OtMxO(3,2)) < Thrs) then
  if (abs(EVal(2)-EVal(3)) < Thrs) then
    Alpha = One
  else
    Alpha = Zero
  end if
else
  if (abs(EVal(2)-EVal(3)) < Thrs) then
    Alpha = huge(Alpha)
  else
    Alpha = -(OtMxO(2,3)+OtMxO(3,2))/(Two*(EVal(2)-EVal(3)))
  end if
end if

if (abs(OtMxO(1,3)+OtMxO(3,1)) < Thrs) then
  if (abs(EVal(3)-EVal(1)) < Thrs) then
    Beta = One
  else
    Beta = Zero
  end if
else
  if (abs(EVal(3)-EVal(1)) < Thrs) then
    Beta = huge(Beta)
  else
    Beta = -(OtMxO(1,3)+OtMxO(3,1))/(Two*(EVal(3)-EVal(1)))
  end if
end if
if (abs(OtMxO(1,2)+OtMxO(2,1)) < Thrs) then
  if (abs(EVal(1)-EVal(2)) < Thrs) then
    Gmma = One
  else
    Gmma = Zero
  end if
else
  if (abs(EVal(1)-EVal(2)) < Thrs) then
    Gmma = huge(Gmma)
  else
    Gmma = -(OtMxO(1,2)+OtMxO(2,1))/(Two*(EVal(1)-EVal(2)))
  end if
end if

Px(:,:) = Zero
Px(1,2) = Gmma
Px(2,1) = -Gmma
Px(1,3) = -Beta
Px(3,1) = Beta
Px(2,3) = Alpha
Px(3,2) = -Alpha

! Finally evaluate dO/dRAi

call DGEMM_('N','N',3,3,3,One,O,3,Px,3,Zero,dOdx(1,1),3)
#ifdef _DEBUGPRINT_
!call RecPrt('M','(3G20.10)',M,3,3)
!call RecPrt('RotGrd: O','(3G20.10)',O,3,3)
!call RecPrt('RotGrd: EVal',' ',EVal,3,1)
!call RecPrt('RotGrd: dMdx','(3G20.10)',dMdx,3,3)
!call RecPrt('RotGrd: OtMxO','(3G20.10)',OtMxO,3,3)
!write(u6,*) 'A,B,G=',Alpha,Beta,Gmma
!call RecPrt('RotGrd: Px','(3G20.10)',Px,3,3)
!call RecPrt('dOdx','(3G20.10)',dOdx,3,3)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Compute_dOdx

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Pr2D(xyz2d,nT,nRys,la,lb,lc,ld,IfGrad,iPrint)

use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nT, nRys, la, lb, lc, ld, iPrint
real(kind=wp), intent(in) :: xyz2d(nT,nRys,0:la+1,0:lb+1,0:lc+1,0:ld+1,3)
logical(kind=iwp), intent(in) :: IfGrad(3,4)
integer(kind=iwp) :: ia, ib, ic, iCar, id, ja, jb, jc, jd
character(len=80) :: Label
character(len=*), parameter :: ch(3) = [',x)',',y)',',z)']
real(kind=r8), external :: DDot_

write(u6,*)
write(u6,*) ' Printing the 2d-integrals'
write(u6,*)

Label = ' '
ja = 0
if (IfGrad(1,1) .or. IfGrad(2,1) .or. IfGrad(3,1)) ja = 1
jb = 0
if (IfGrad(1,2) .or. IfGrad(2,2) .or. IfGrad(3,1)) jb = 1
jc = 0
if (IfGrad(1,3) .or. IfGrad(2,3) .or. IfGrad(3,3)) jc = 1
jd = 0
if (IfGrad(1,4) .or. IfGrad(2,4) .or. IfGrad(3,4)) jd = 1
do ia=0,la+ja
  if (ia > la) jb = 0
  do ib=0,lb+jb
    if ((ia > la) .or. (ib > lb)) jc = 0
    do ic=0,lc+jc
      do id=0,ld+jd
        do iCar=1,3
          if ((ja == 1) .and. (ia == la+ja) .and. (.not. IfGrad(iCar,1))) cycle
          if ((jb == 1) .and. (ib == lb+jb) .and. (.not. IfGrad(iCar,2))) cycle
          if ((jc == 1) .and. (ic == lc+jc) .and. (.not. IfGrad(iCar,3))) cycle
          if ((jd == 1) .and. (id == ld+jd) .and. (.not. IfGrad(iCar,4))) cycle
          write(Label,'(A,4(I1,A))') ' xyz2D0(',ia,',',ib,',',ic,',',id,ch(iCar)
          if (iPrint >= 99) then
            call RecPrt(Label,' ',xyz2d(:,:,ia,ib,ic,id,iCar),nT,nRys)
          else
            write(u6,'(A)') Label
            write(u6,*) DDot_(nT*nRys,xyz2d(:,:,ia,ib,ic,id,iCar),1,xyz2d(:,:,ia,ib,ic,id,iCar),1)
          end if
        end do
      end do
    end do
  end do
end do

return

end subroutine Pr2D

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine map42(a,b,dimp,dimq,dimr,dims,dim_1,dim_2,dim_3,dim_4,p,q,r,nfact)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dimr, dims, dim_1, dim_2, dim_3, dim_4, p, q, r, nfact
real(kind=wp), intent(in) :: a(dimp,dimq,dimr,dims)
real(kind=wp), intent(_OUT_) :: b(dim_1,dim_2,dim_3,dim_4)
integer(kind=iwp) :: pp, qq, rr, ss

if (nfact == 1) then

  ! factor = +1

  !do ss=1,dims
  !  index(s) = ss
  !  do rr=1,dimr
  !    index(r) = rr
  !    do qq=1,dimq
  !      index(q) = qq
  !      do pp=1,dimp
  !        index(p) = pp
  !        b(index(1),index(2),index(3),index(4)) = a(pp,qq,rr,ss)
  !      end do
  !    end do
  !  end do
  !end do

  if (p == 1) then
    ! 1***
    if (q == 2) then
      ! 12**
      if (r == 3) then
        ! 123* (4)
        b(1:dimp,1:dimq,1:dimr,1:dims) = a(:,:,:,:)
      else
        ! 124* (3)
        do rr=1,dimr
          b(1:dimp,1:dimq,1:dims,rr) = a(:,:,rr,:)
        end do
      end if
    else if (q == 3) then
      ! 13**
      if (r == 2) then
        ! 132* (4)
        do ss=1,dims
          do qq=1,dimq
            b(1:dimp,1:dimr,qq,ss) = a(:,qq,:,ss)
          end do
        end do
      else
        ! 134* (2)
        do rr=1,dimr
          do qq=1,dimq
            b(1:dimp,1:dims,qq,rr) = a(:,qq,rr,:)
          end do
        end do
      end if
    else if (q == 4) then
      ! 14**
      if (r == 2) then
        ! 142* (3)
        do qq=1,dimq
          b(1:dimp,1:dimr,1:dims,qq) = a(:,qq,:,:)
        end do
      else
        ! 143* (2)
        do qq=1,dimq
          do rr=1,dimr
            b(1:dimp,1:dims,rr,qq) = a(:,qq,rr,:)
          end do
        end do
      end if
    end if

  else if (p == 2) then
    ! 2***
    if (q == 1) then
      ! 21**
      if (r == 3) then
        ! 213* (4)
        do ss=1,dims
          do rr=1,dimr
            do pp=1,dimp
              b(1:dimq,pp,rr,ss) = a(pp,:,rr,ss)
            end do
          end do
        end do
      else
        ! 214* (3)
        do rr=1,dimr
          do ss=1,dims
            do pp=1,dimp
              b(1:dimq,pp,ss,rr) = a(pp,:,rr,ss)
            end do
          end do
        end do
      end if
    else if (q == 3) then
      ! 23**
      if (r == 1) then
        ! 231* (4)
        do ss=1,dims
          do qq=1,dimq
            do pp=1,dimp
              b(1:dimr,pp,qq,ss) = a(pp,qq,:,ss)
            end do
          end do
        end do
      else
        ! 234* (1)
        do rr=1,dimr
          do qq=1,dimq
            do pp=1,dimp
              b(1:dims,pp,qq,rr) = a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    else if (q == 4) then
      ! 24**
      if (r == 3) then
        ! 243* (1)
        do qq=1,dimq
          do rr=1,dimr
            do pp=1,dimp
              b(1:dims,pp,rr,qq) = a(pp,qq,rr,:)
            end do
          end do
        end do
      else
        ! 241* (3)
        do qq=1,dimq
          do ss=1,dims
            do pp=1,dimp
              b(1:dimr,pp,ss,qq) = a(pp,qq,:,ss)
            end do
          end do
        end do
      end if
    end if

  else if (p == 3) then
    ! 3***
    if (q == 1) then
      ! 31**
      if (r == 2) then
        ! 312* (4)
        do ss=1,dims
          do pp=1,dimp
            b(1:dimq,1:dimr,pp,ss) = a(pp,:,:,ss)
          end do
        end do
      else
        ! 314* (2)
        do rr=1,dimr
          do pp=1,dimp
            b(1:dimq,1:dims,pp,rr) = a(pp,:,rr,:)
          end do
        end do
      end if
    else if (q == 2) then
      ! 32**
      if (r == 1) then
        ! 321* (4)
        do ss=1,dims
          do pp=1,dimp
            do qq=1,dimq
              b(1:dimr,qq,pp,ss) = a(pp,qq,:,ss)
            end do
          end do
        end do
      else
        ! 324* (1)
        do rr=1,dimr
          do pp=1,dimp
            do qq=1,dimq
              b(1:dims,qq,pp,rr) = a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    else if (q == 4) then
      ! 34**
      if (r == 1) then
        ! 341* (2)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,1:dims,pp,qq) = a(pp,qq,:,:)
          end do
        end do
      else
        ! 342* (1)
        do qq=1,dimq
          do pp=1,dimp
            do rr=1,dimr
              b(1:dims,rr,pp,qq) = a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    end if

  else if (p == 4) then
    ! 4***
    if (q == 1) then
      ! 41**
      if (r == 3) then
        ! 413* (2)
        do pp=1,dimp
          do rr=1,dimr
            b(1:dimq,1:dims,rr,pp) = a(pp,:,rr,:)
          end do
        end do
      else
        ! 412* (3)
        do pp=1,dimp
          b(1:dimq,1:dimr,1:dims,pp) = a(pp,:,:,:)
        end do
      end if
    else if (q == 2) then
      ! 42**
      if (r == 1) then
        ! 421* (3)
        do pp=1,dimp
          do ss=1,dims
            do qq=1,dimq
              b(1:dimr,qq,ss,pp) = a(pp,qq,:,ss)
            end do
          end do
        end do
      else
        ! 423* (1)
        do pp=1,dimp
          do rr=1,dimr
            do qq=1,dimq
              b(1:dims,qq,rr,pp) = a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    else if (q == 3) then
      ! 43**
      if (r == 1) then
        ! 431* (2)
        do pp=1,dimp
          do qq=1,dimq
            b(1:dimr,1:dims,qq,pp) = a(pp,qq,:,:)
          end do
        end do
      else
        ! 432* (1)
        do pp=1,dimp
          do qq=1,dimq
            do rr=1,dimr
              b(1:dims,rr,qq,pp) = a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    end if

  end if

else

  ! factor = -1

  !do ss=1,dims
  !  index(s) = ss
  !  do rr=1,dimr
  !    index(r) = rr
  !    do qq=1,dimq
  !      index(q) = qq
  !      do pp=1,dimp
  !        index(p) = pp
  !        b(index(1),index(2),index(3),index(4)) = -a(pp,qq,rr,ss)
  !      end do
  !    end do
  !  end do
  !end do

  if (p == 1) then
    ! 1***
    if (q == 2) then
      ! 12**
      if (r == 3) then
        ! 123* (4)
        b(1:dimp,1:dimq,1:dimr,1:dims) = -a(:,:,:,:)
      else
        ! 124* (3)
        do rr=1,dimr
          b(1:dimp,1:dimq,1:dims,rr) = -a(:,:,rr,:)
        end do
      end if
    else if (q == 3) then
      ! 13**
      if (r == 2) then
        ! 132* (4)
        do ss=1,dims
          do qq=1,dimq
            b(1:dimp,1:dimr,qq,ss) = -a(:,qq,:,ss)
          end do
        end do
      else
        ! 134* (2)
        do rr=1,dimr
          do qq=1,dimq
            b(1:dimp,1:dims,qq,rr) = -a(:,qq,rr,:)
          end do
        end do
      end if
    else if (q == 4) then
      ! 14**
      if (r == 2) then
        ! 142* (3)
        do qq=1,dimq
          b(1:dimp,1:dimr,1:dims,qq) = -a(:,qq,:,:)
        end do
      else
        ! 143* (2)
        do qq=1,dimq
          do rr=1,dimr
            b(1:dimp,1:dims,rr,qq) = -a(:,qq,rr,:)
          end do
        end do
      end if
    end if

  else if (p == 2) then
    ! 2***
    if (q == 1) then
      ! 21**
      if (r == 3) then
        ! 213* (4)
        do ss=1,dims
          do rr=1,dimr
            do pp=1,dimp
              b(1:dimq,pp,rr,ss) = -a(pp,:,rr,ss)
            end do
          end do
        end do
      else
        ! 214* (3)
        do rr=1,dimr
          do ss=1,dims
            do pp=1,dimp
              b(1:dimq,pp,ss,rr) = -a(pp,:,rr,ss)
            end do
          end do
        end do
      end if
    else if (q == 3) then
      ! 23**
      if (r == 1) then
        ! 231* (4)
        do ss=1,dims
          do qq=1,dimq
            do pp=1,dimp
              b(1:dimr,pp,qq,ss) = -a(pp,qq,:,ss)
            end do
          end do
        end do
      else
        ! 234* (1)
        do rr=1,dimr
          do qq=1,dimq
            do pp=1,dimp
              b(1:dims,pp,qq,rr) = -a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    else if (q == 4) then
      ! 24**
      if (r == 3) then
        ! 243* (1)
        do qq=1,dimq
          do rr=1,dimr
            do pp=1,dimp
              b(1:dims,pp,rr,qq) = -a(pp,qq,rr,:)
            end do
          end do
        end do
      else
        ! 241* (3)
        do qq=1,dimq
          do ss=1,dims
            do pp=1,dimp
              b(1:dimr,pp,ss,qq) = -a(pp,qq,:,ss)
            end do
          end do
        end do
      end if
    end if

  else if (p == 3) then
    ! 3***
    if (q == 1) then
      ! 31**
      if (r == 2) then
        ! 312* (4)
        do ss=1,dims
          do pp=1,dimp
            b(1:dimq,1:dimr,pp,ss) = -a(pp,:,:,ss)
          end do
        end do
      else
        ! 314* (2)
        do rr=1,dimr
          do pp=1,dimp
            b(1:dimq,1:dims,pp,rr) = -a(pp,:,rr,:)
          end do
        end do
      end if
    else if (q == 2) then
      ! 32**
      if (r == 1) then
        ! 321* (4)
        do ss=1,dims
          do pp=1,dimp
            do qq=1,dimq
              b(1:dimr,qq,pp,ss) = -a(pp,qq,:,ss)
            end do
          end do
        end do
      else
        ! 324* (1)
        do rr=1,dimr
          do pp=1,dimp
            do qq=1,dimq
              b(1:dims,qq,pp,rr) = -a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    else if (q == 4) then
      ! 34**
      if (r == 1) then
        ! 341* (2)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,1:dims,pp,qq) = -a(pp,qq,:,:)
          end do
        end do
      else
        ! 342* (1)
        do qq=1,dimq
          do pp=1,dimp
            do rr=1,dimr
              b(1:dims,rr,pp,qq) = -a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    end if

  else if (p == 4) then
    ! 4***
    if (q == 1) then
      ! 41**
      if (r == 3) then
        ! 413* (2)
        do pp=1,dimp
          do rr=1,dimr
            b(1:dimq,1:dims,rr,pp) = -a(pp,:,rr,:)
          end do
        end do
      else
        ! 412* (3)
        do pp=1,dimp
          b(1:dimq,1:dimr,1:dims,pp) = -a(pp,:,:,:)
        end do
      end if
    else if (q == 2) then
      ! 42**
      if (r == 1) then
        ! 421* (3)
        do pp=1,dimp
          do ss=1,dims
            do qq=1,dimq
              b(1:dimr,qq,ss,pp) = -a(pp,qq,:,ss)
            end do
          end do
        end do
      else
        ! 423* (1)
        do pp=1,dimp
          do rr=1,dimr
            do qq=1,dimq
              b(1:dims,qq,rr,pp) = -a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    else if (q == 3) then
      ! 43**
      if (r == 1) then
        ! 431* (2)
        do pp=1,dimp
          do qq=1,dimq
            b(1:dimr,1:dims,qq,pp) = -a(pp,qq,:,:)
          end do
        end do
      else
        ! 432* (1)
        do pp=1,dimp
          do qq=1,dimq
            do rr=1,dimr
              b(1:dims,rr,qq,pp) = -a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    end if

  end if

end if

return

end subroutine map42

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine HCSCE(N,H,S,C,E,M)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Solve the secular equations HC=SCE. This routine is part of the  *
!     Davidson diagonalization procedure used to find the lowest roots *
!     of the CI-Hamiltonian. Because of that it is crucial to use      *
!     Schmidt orthogonalization such that the latest vector (in chro-  *
!     nological order) remains unchanged and the previous are ortho-   *
!     gonalized relative to it. It is also important that the input    *
!     data remain unchanged.                                           *
!                                                                      *
!     calling arguments:                                               *
!     N       : Type integer, input.                                   *
!               Dimensions of the secular equations.                   *
!     H       : Type double precision real, input.                     *
!               Hamiltonian in matrix representation.                  *
!     S       : Type double precision real, input.                     *
!               Overlap matrix.                                        *
!     C       : Type double precision real, output.                    *
!               Matrix containing the eigenvectors.                    *
!     E       : Type double precision real, output.                    *
!               Vector containing the eigenvalues.                     *
!     M       : Type integer, output.                                  *
!               This is the number of linearly independent basis       *
!               vectors that span space the metric given by the        *
!               overlap matrix.                                        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher, University of Lund, Sweden, 1993                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: H(N*(N+1)/2), S(N*(N+1)/2), E(N)
real(kind=wp), intent(out) :: C(N,N)
integer(kind=iwp), intent(inout) :: M
integer(kind=iwp) :: i, INFO, MMAX, NSCRATCH
real(kind=wp) :: WGronk(2)
real(kind=wp), allocatable :: Scratch(:), Temp1(:,:), Temp2(:,:), Temp3(:,:), Temp4(:)
!character(len=12) :: method
#include "WrkSpc.fh"
#include "timers.fh"

call Timing(Longines_1,Swatch,Swatch,Swatch)

! PAM 2009: On input, M=max possible orthonormal solutions to HC=SCE
! Save it.
MMAX = M

! allocate temporary work space
call mma_allocate(Temp1,N,N,label='Temp1')
call mma_allocate(Temp2,N,N,label='Temp2')
call mma_allocate(Temp3,N,N,label='Temp3')
call mma_allocate(Temp4,N,label='Temp4')

! make local copies of H and S
call Square(S,Temp1,1,N,N)
call Square(H,Temp2,1,N,N)

! Schmidt orthogonalization
C(:,:) = Zero
do i=1,N
  C(i,i) = One
end do

!write(u6,*) ' HCSCE calling Schmidt.'
!call Schmidt(N,Temp1,C,Temp4,M)
!write(u6,*) ' HCSCE back from Schmidt. M=',M
! PAM 2009: It seems that no provision is made for the case that
! the returned M, = nr of ON vectors produced, is smaller than N?!
! Also, the whole thing looks very inefficient. But I just make
! some provisional changes now (090216).
!write(u6,*) ' HCSCE check eigenvalues. N=',N
!call eigv(N,Temp1)
!write(u6,*) ' HCSCE calling NewGS.'
call NewGS(N,Temp1,C,Temp4,M)
call mma_deallocate(Temp1)
!write(u6,*) ' HCSCE back from NewGS. M=',M
! Possibly in very difficult cases, NewGS produced too many vectors:
M = min(M,MMAX)

! transform H to an orthogonal basis
! PAM 2009: Rewritten, use only M orthogonal vectors
call DGEMM_('N','N',N,M,N,One,Temp2,N,C,N,Zero,Temp3,N)
call DGEMM_('T','N',M,M,N,One,C,N,Temp3,N,Zero,Temp2,M)

! PAM 2009: Replace by DSYEV call.
!method = 'Householder'
!method = 'Jacobi'

! diagonalize and extract eigenvalues
!if (method == 'Jacobi') then
!  call mma_allocate(Temp1,N*(N+1)/2,label='Temp1')
!  do i=1,N
!    do j=1,i
!      Temp1(j+i*(i-1)/2) = Temp2(j,i)
!    end do
!  end do
!  call Jacob(Temp1,C,N,N)
!  call JacOrd(Temp1,C,N,N)
!  do i=1,N
!    E(i) = Temp1(i*(i+1)/2)
!  end do
!  call mma_deallocate(Temp1)
!else if (method == 'Householder') then
!  call Eigen_Molcas(N,Temp2,E,Temp4)
!  call DGEMM_('N','N',N,N,N,One,C,N,Temp2,N,Zero,Temp3,N)
!  call C(:,:) = Temp3(:,:)
!end if
! PAM 2009 Equivalent, DSYEV, note now use just M, not all N:
INFO = 0
call dsyev_('V','L',M,Temp2,M,E,WGRONK,-1,INFO)
NSCRATCH = int(WGRONK(1))
call mma_allocate(Scratch,NSCRATCH,label='SCRATCH')
call dsyev_('V','L',M,Temp2,M,E,Scratch,NSCRATCH,INFO)
call mma_deallocate(Scratch)
call DGEMM_('N','N',N,M,M,One,C,N,Temp2,M,Zero,Temp3,N)
C(:,1:M) = Temp3(:,1:M)

! deallocate temporary work space
call mma_deallocate(Temp2)
call mma_deallocate(Temp3)
call mma_deallocate(Temp4)

call Timing(Longines_2,Swatch,Swatch,Swatch)
Longines_2 = Longines_2-Longines_1
Longines_3 = Longines_3+Longines_2

return

end subroutine HCSCE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1994, Jeppe Olsen                                 *
!***********************************************************************

subroutine ADST(IORB,NORB,ICLS,ISM,IGRP,KMIN,KMAX,I1,XI1S,LI1,NK,IEND)
! Obtain mappings
! a+JORB !KSTR> = +/-!ISTR> for orbitals IORB - IORB+NORB-1
!. All orbitals are assumed to belong to the same TS class
! In the form
! I1(KSTR,JORB) =  ISTR if A+JORB !KSTR> = +/-!ISTR>, ISTR is in
! ICLS,ISM,IGRP.
! (numbering relative to TS start)
!
! Above +/- is stored in XI1S
! Number of K strings checked is returned in NK
! Only Kstrings with relative numbers from KMIN to KMAX are included
! If KMAX = -1, all strings are included
! If all K strings have been searched IEND is set to 1
!
! Jeppe Olsen, Winter of 1991
!              January 1994 : modified to allow for several orbitals

use Str_Info, only: ISTAC, IUNIQMP, NOCTYP, STR
use MCLR_Data, only: ISMFTO, NACOB, NORB1, NORB2
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IORB, NORB, ICLS, ISM, IGRP, KMIN, KMAX, LI1
integer(kind=iwp), intent(_OUT_) :: I1(*)
real(kind=wp), intent(_OUT_) :: XI1S(*)
integer(kind=iwp), intent(out) :: NK, IEND
integer(kind=iwp) :: IMPF, JGRP, LMAP

! Type of mapping
!write(u6,*) ' ADST: IGRP IORB = ',IGRP,IORB

JGRP = IGRP+1
if (IUNIQMP(JGRP) /= JGRP) then
  JGRP = -IUNIQMP(JGRP)
  !write(u6,*) ' Unique string group for mappings ',JGRP
end if

if ((ISTAC(JGRP,1) /= 0) .and. (ISTAC(JGRP,2) /= 0)) then
  ! Full Map
  IMPF = 1
  LMAP = NACOB
else
  ! Only creation map
  IMPF = 0
  LMAP = -1
end if

call ADS1(NK,I1,XI1S,LI1,IORB,NORB,ICLS,ISM,Str(JGRP)%STSTM(:,1),Str(JGRP)%STSTM(:,2),Str(JGRP)%STSTMN,Str(JGRP)%STSTMI,IMPF, &
          LMAP,Str(IGRP)%EL1,Str(IGRP)%EL3,Str(IGRP+1)%EL1,Str(IGRP+1)%EL3,Str(IGRP)%ISTSO,Str(IGRP+1)%ISTSO,Str(IGRP+1)%NSTSO, &
          NOCTYP(IGRP),NOCTYP(IGRP+1),NORB1,NORB2,ISMFTO,KMAX,KMIN,IEND)

end subroutine ADST

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Roland Lindh                                     *
************************************************************************

      SubRoutine Drvg1_RI(Grad,Temp,nGrad)
************************************************************************
*                                                                      *
*     Object: superdriver for gradients for the RI/DF approximation    *
*                                                                      *
*                                                                      *
*     Author: Roland Lindh, Dep. Chem. Phys., Lund University, Sweden  *
*             January '07                                              *
*                                                                      *
************************************************************************
      use Basis_Info, only: nBas, nBas_Aux
      use pso_stuff
      use RICD_Info, only: Do_RI, Cholesky
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "disp.fh"
#include "print.fh"
#include "para_info.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "real.fh"
#include "exterm.fh"
#include "chomp2g_alaska.fh"
*#define _CD_TIMING_
#ifdef _CD_TIMING_
#include "temptime.fh"
#endif
      Real*8 Grad(nGrad), Temp(nGrad)
      Character*6 Fname
      Character*7 Fname2
      Character*8 Method
      Logical Found
      Integer nAct(0:7)
      Real*8, Allocatable:: V_k_new(:,:), U_k_new(:)
*                                                                      *
************************************************************************
*                                                                      *
      DoCholExch = .false.
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu1,TWall1)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 33
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
      Call FZero(Temp,nGrad)
      Call Allocate_Work(ipTemp,nGrad)
*                                                                      *
************************************************************************
*                                                                      *
      BufFrac=0.1D0
      Call Cho_X_Init(irc,BufFrac)
      If (irc.ne.0) Then
         Call WarningMessage(2,' Drvg1_RI: Cho_X_Init failed')
         Call Abend()
      End If
*
********************************************
*
* Decide if its MP2
*
      iMp2Prpt = 0
      Call Get_cArray('Relax Method',Method,8)
      If(Method .eq. 'MBPT2   ') Then
         Call Get_iScalar('mp2prpt',iMp2Prpt)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     In case of the Cholesky approach compute the A and Q matrices.
*
      If (Cholesky.and..Not.Do_RI) Then
*
         If (nIrrep.ne.1) Then
            Call WarningMessage(2,'Error in Drvg1_RI')
            Write (6,*) ' CD gradients with symmetry is not'
     &               //' implemented yet!'
            Call Abend()
         End If
*
         Call Cho_X_CalculateGMat(irc)
         If (iRC.ne.0) Then
            Call WarningMessage(2,'Error in Drvg1_RI')
            Write (6,*) 'Failure during G matrix construction'
            Call Abend()
         End If
*
*        Now compute the Q matrix.
*
*            Note that, as the A matrix is
*            computed in the full-pivoted (rows and columns) storage,
*            also the resulting Q matrix is full-pivoted.
*            This is necessary for the ReMap_V_k to work (see below).
*            In the RI case, only the column pivoting of Q is
*            preserved. One day we may want to unify the two cases.
*
*            (In Cholesky the Q matrix is stored as squared. In RI,
*             it is, in general, rectangular as lin. dep. may occur
*             among its columns).
*
         Call ICopy(nIrrep,NumCho,1,nBas_Aux,1)
         Call GAIGOP(nBas_Aux,nIrrep,'+')
         Call Gen_QVec(nIrrep,nBas_Aux)
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Prepare handling of two-particle density.
*
      Call PrepP
*                                                                      *
************************************************************************
*                                                                      *
* Initialize the number of sets of densities and auxiliary vectors
      nAdens=1
      nAVec=1
      nKdens=1
      nJdens=1
*
      Call Qpg_iScalar('SCF mode',Found)
      If (Found) Then
         Call Get_iScalar('SCF mode',iUHF) ! either 0 or 1
      Else
         iUHF=0
      EndIf
      nKdens=nKdens+iUHF
      nKvec=nKdens
*
      If (lPSO.and.lSA) Then
        nJdens=5
        nKdens=4
        nKVec=2
        nAdens=2
        nAvec=4
      EndIf
*
*MGD Could be more efficient memory-wise when symmetry
*--- Decompose the 2-particle active density matrix
      mAO=0
      If (lPSO) Then
         Call Get_iArray('nAsh',nAct,nIrrep)
         n_Txy=0
         Do ijsym=0,nIrrep-1
           ntmp=0
           Do jSym=0,nIrrep-1
             isym=iEOR(jSym,ijsym)
             If (iSym.gt.jSym) Then
               ntmp=ntmp+nAct(iSym)*nAct(jSym)
             Else if (iSym.eq.jSym) Then
               ntmp=ntmp+nAct(iSym)*(nAct(iSym)+1)/2
             EndIf
           EndDo
           n_Txy=n_Txy+ntmp**2
           mAO=mAO+nAct(ijsym)*nBas(ijsym)
         EndDo
         m_Txy=nAdens
         Call mma_allocate(Txy,n_Txy,nAdens,Label='Txy')
         Call mma_allocate(DMdiag,nG1,nAdens,Label='DMdiag')
         Call GetMem('Tmp','Allo','Real',ipDMtmp,nG1*(nG1+1)/2)
         Call iZero(nnP,nIrrep)
         Call Compute_txy(G1(1,1),nG1,Txy,
     &                   n_Txy,nAdens,nIrrep,DMdiag,
     &                   Work(ipDMtmp),nAct)
         Call GetMem('Tmp','Free','Real',ipDMtmp,nG1*(nG1+1)/2)
      Else
         Call mma_allocate(Txy,1,1,Label='Txy')
         Call mma_allocate(DMdiag,1,1,Label='DMdiag')
      EndIf
      n_ij2K=0
      nZ_p_k=0
      nZ_p_l=0
      nZ_p_k_New=0
      Do i=0,nIrrep-1
         iOff_ij2K(i+1) = n_ij2K
         n_ij2K = n_ij2K + nBas(i)*(nBas(i)+1)/2
         nZ_p_k = nZ_p_k + nnP(i)*nBas_Aux(i)
         nZ_p_l = nZ_p_l + nnP(i)*NumCho(i+1)
         nZ_p_k_New = nZ_p_k_New + nnP(i)*nBas(i)*(nBas(i)+1)/2
      End Do
      If (Do_RI) nZ_p_k=nZ_p_k-nnP(0)
      If (lPSO) Then
         Call mma_allocate(Z_p_k,nZ_p_k,nAvec,Label='Z_p_k')
         Z_p_k(:,:)=Zero
      Else
         Call mma_allocate(Z_p_k,1,1,Label='Z_p_k')
      EndIf
*
*     Preprocess the RI and Q vectors as follows
*
*     Allocate memory for V_k
*
      nV_k=nBas_Aux(0)
      If (Do_RI) nV_k=nV_k-1
*
      nAux_Tot=0
      Do iIrrep = 0, nIrrep-1
         nAux_Tot=nAux_Tot+nBas_Aux(iIrrep)
      End Do
*
*
      call mma_allocate(V_K,nV_k,nJdens,Label='V_k')
      V_k(:,:)=Zero
      If(iMp2prpt .eq. 2) Then
         call mma_allocate(U_K,nV_k,Label='U_k')
         U_k(:)=Zero
      Else
         call mma_allocate(U_K,1,Label='U_k')
      End If
*                    ~
*     1) Compute the V_k vector
*                 ~
*     2) Contract V_k and Q (transpose) vectors producing the V_k
*
*     Note: the above two points apply to Z_p_k as well (active space)
*
      Call GetMem('iVk','Allo','Inte',iVk,nProcs)
      Call GetMem('iZk','Allo','Inte',iZk,nProcs)
      Call IZero(iWork(iVk),nProcs)
      Call IZero(iWork(iZk),nProcs)
      iWork(iVk+myRank) = NumCho(1)*nJdens
      iWork(iZk+myRank) = nZ_p_l*nAvec
      Call GAIGOP(iWork(iVk),nProcs,'+')
      Call GAIGOP(iWork(iZk),nProcs,'+')
      iStart=1
      jStart=1
      Do j=0,nProcs-1
         itmp=iWork(iVk+j)
         iWork(iVk+j)=iStart
         iStart = iStart + itmp
         jtmp=iWork(iZk+j)
         iWork(iZk+j)=jStart
         jStart = jStart + jtmp
      End Do
*
      If(iMp2prpt .eq. 2) Then
         Call GetMem('iUk','Allo','Inte',iUk,nProcs)
         Call IZero(iWork(iUk),nProcs)
         iWork(iUk+myRank) = NumCho(1)
         Call GAIGOP(iWork(iUk),nProcs,'+')
         kStart=1
         Do j = 0,nProcs-1
            kTmp=iWork(iUk+j)
            iWork(iUk+j)=kStart
            kStart = kStart + kTmp
         End Do
      Else
         iUk = ip_iDummy
      End If
*
      Call Compute_AuxVec(iWork(iVk),iWork(iUk),iwork(iZk),
     &                    myRank+1,nProcs)
*                                                                      *
************************************************************************
*                                                                      *

      If (Cholesky.and..Not.Do_RI) Then
*
*              Map from Cholesky auxiliary basis to the full
*              1-center valence product basis.
*
         Call mma_allocate(ij2K,n_ij2K,Label='ij2K')
         ij2K(:)=0
         nV_k_New=nBas(0)*(nBas(0)+1)/2
         Call mma_allocate(V_k_new,nV_k_New,nJdens,Label="V_k_new")
         V_k_new(:,:)=Zero
*
         If (iMp2prpt .eq. 2) Then
            Call mma_allocate(U_k_new,nV_k_New,Label="U_k_new")
            U_k_new(:)=Zero
         End If

*
         Call GetMem('SO_ab','Allo','INTE',ipSO_ab,2*nAux_Tot)
         Call IZero(iWork(ipSO_ab),2*nAux_Tot)
         iOff = 0
         Do iSym = 1, nSym
            ip_List_rs=ip_InfVec+MaxVec*InfVec_N2*(iSym-1)
            Call CHO_X_GET_PARDIAG(iSym,ip_List_rs,iWork(ipSO_ab+iOff))

            If((iSym .eq. 1) .and. (iMp2prpt .eq. 2)) Then
               Call ReMap_U_k(U_k,nV_k,U_k_New,nV_k_New,
     &                        iWork(ipSO_ab))
            End If
            m_ij2K = nBas(iSym-1)*(nBas(iSym-1)+1)/2
            Do i=0,nJDens-1
              Call ReMap_V_k(iSym,V_k(1,1+i),nV_k,
     &                     V_k_new(1,1+i),nV_k_New,
     &                     iWork(ipSO_ab+iOff),ij2K(iOff_ij2K(iSym)+1),
     &                     m_ij2K)
            EndDo
            iOff = iOff + 2*nBas_Aux(iSym-1)
         End Do
*
         nV_k=nV_k_new
*
         Call Free_iWork(ipSO_ab)
         Call mma_deallocate(V_k)
         Call mma_allocate(V_k,nV_k,nJdens,Label='V_k')
         V_k(:,:)=V_k_new(:,:)
         Call mma_deallocate(V_k_new)

         If(iMp2prpt .eq. 2) Then
            Call mma_deallocate(U_k)
            Call mma_allocate(U_k,nV_k,Label='U_k')
            U_k(:)=U_k_new(:)
            Call mma_deallocate(U_k_new)
         End If

*                                                                      *
************************************************************************
*                                                                      *
*        Get the effective list of shell-pairs in case of CD
*
         Call Effective_CD_Pairs(ip_ij2,nij_Eff)
      Else
         ip_ij2 = ip_iDummy
         nij_Eff = 0
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Open C-vector-files if nSym is equal to 1
*
      If(DoCholExch) Then
         Do i=1,nKvec
           Do jSym = 1, nSym
              iSeed = 7 + jSym+(i-1)*nSym
              LuCVector(jSym,i) = IsFreeUnit(iSeed)
              If (i.eq.1) Then
                Write(Fname,'(A4,I1,I1)') 'CVEA',jSym
              ElseIf (i.eq.2) Then
                Write(Fname,'(A4,I1,I1)') 'CVEB',jSym
              EndIf
              Call DANAME_MF_WA(LuCVector(jSym,i),Fname)
            End Do
         End Do
*     Initialize timings
         Do i = 1,2
            tavec(i) = 0.0d0
            tbvec(i) = 0.0d0
         End Do
      End If
      If(imp2prpt.eq.2) Then
         Do i = 1, 2
            iSeed = 8 + nSym
            LuAVector(i) = IsFreeUnit(iSeed)
            Write(Fname2,'(A5,I1)') 'AMP2V', i
            Call DaName_MF_WA(LuAVector(i),Fname2)
            iSeed = 9 + nSym
            LuBVector(i) = IsFreeUnit(iSeed)
            Write(Fname,'(A5,I1)') 'BMP2V', i+2
            Call DaName_MF_WA(LuBVector(i),Fname)
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Compute contributions due to the "2-center" two-electron integrals
*
      Case_2C=.True.
      Call Drvg1_2center_RI(Temp,Work(ipTemp),nGrad,ip_ij2,nij_Eff)
      Call GADGOP(Work(ipTemp),nGrad,'+')
      If (iPrint.ge.15) Call PrGrad(
     &    ' RI-Two-electron contribution - 2-center term',
     &    Work(ipTemp),nGrad,ChDisp,iPrint)
      Call DaXpY_(nGrad,One,Temp,1,Grad,1) ! Move any 1-el contr.
      call dcopy_(nGrad,Work(ipTemp),1,Temp,1)
      Call DScal_(nGrad,-One,Temp,1)
      Case_2C=.False.
*                                                                      *
************************************************************************
*                                                                      *
*     Compute contributions due to the "3-center" two-electron integrals
*
      Case_3C=.True.
      Call Drvg1_3center_RI(Temp,Work(ipTemp),nGrad,ip_ij2,nij_Eff)
      Call GADGOP(Work(ipTemp),nGrad,'+')
      If (iPrint.ge.15) Call PrGrad(
     &    ' RI-Two-electron contribution - 3-center term',
     &    Work(ipTemp),nGrad,ChDisp,iPrint)
      Call DaXpY_(nGrad,Two,Work(ipTemp),1,Temp,1)
      Case_3C=.False.
      If(Allocated(Txy))  Call mma_deallocate(Txy)
      If(Allocated(DMdiag))  Call mma_deallocate(DMdiag)
      Call GetMem('AOrb','Free','Real',ipAOrb(0,1),mAO*nADens)
*                                                                      *
************************************************************************
*                                                                      *
*
      If(DoCholExch) Then
         Do i=1,nKvec
            Do jSym = 1, nSym
               Call DaClos(luCVector(jSym,i))
            EndDo
         End Do
      End If
      If(iMp2prpt .eq. 2) Then
         Do i = 1, 2
            Call DaClos(LuAVector(i))
            Call DaClos(LuBVector(i))
         End Do
      End If


      If (Cholesky.and..Not.Do_RI) Then
         Call Free_iWork(ip_ij2)
         Call mma_deallocate(ij2K)
      End If
      Call CloseP
      Call Free_iWork(iZk)
      Call Free_iWork(iVk)
      If(iMp2prpt .eq. 2) Call Free_iWork(iUk)
      If (Allocated(Z_p_k)) Call mma_deallocate(Z_p_k)
      If (Allocated(V_k)) Call mma_deallocate(V_k)
      If (Allocated(U_k)) Call mma_deallocate(U_k)
      Call Cho_X_Final(irc)
      If (irc.ne.0) Then
         Call WarningMessage(2,' Drvg1_RI: Cho_X_Final failed')
         Call Abend()
      End If
      Call Free_Work(ipTemp)
      If (iPrint.ge.15)  Call PrGrad(
     &    ' RI-Two-electron contribution - Temp',
     &    Temp,nGrad,ChDisp,iPrint)
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu2,TWall2)
      Call SavTim(6,TCpu2-TCpu1,TWall2-TWall1)
*
#ifdef _CD_TIMING_
      Drvg1_CPU = TCpu2-TCpu1
      Drvg1_Wall= TWall2-TWall1
      Write(6,*) '-------------------------'
      Write(6,*) 'Time spent in Cho_get_grad:'
      Write(6,*) 'Wall/CPU',ChoGet_Wall, ChoGet_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Time spent in Mult_Rijk_Qkl:'
      Write(6,*) 'Wall/CPU',rMult_Wall, rMult_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Time spent in Prepp:'
      Write(6,*) 'Wall/CPU',Prepp_Wall, Prepp_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Time spent in Pget_ri2:'
      Write(6,*) 'Wall/CPU',Pget2_Wall, Pget2_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Time spent in Pget_ri3:'
      Write(6,*) 'Wall/CPU',Pget3_Wall, Pget3_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Time spent in Drvg1_ri:'
      Write(6,*) 'Wall/CPU',Drvg1_Wall, Drvg1_CPU
      Write(6,*) '-------------------------'
      Total_Dens_Wall = ChoGet_Wall+rMult_Wall+Prepp_Wall+Pget2_Wall +
     &                  Pget3_Wall
      Total_Dens_CPU = ChoGet_CPU+rMult_CPU+Prepp_CPU+Pget2_CPU +
     &                 Pget3_CPU
      Total_Der_Wall = Drvg1_Wall - Total_Dens_Wall
      Total_Der_CPU = Drvg1_CPU - Total_Dens_CPU
      Total_Der_Wall2 = TwoEl2_Wall + TwoEl3_Wall
      Total_Der_CPU2 = TwoEl2_CPU   + TwoEl3_CPU

      Write(6,*) 'Total Time for Density:'
      Write(6,*) 'Wall/CPU',Total_Dens_Wall, Total_Dens_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Total TIme for 2-center Derivatives:'
      Write(6,*) 'Wall/CPU',Twoel2_Wall, Twoel2_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Total TIme for 3-center Derivatives:'
      Write(6,*) 'Wall/CPU',Twoel3_Wall, Twoel3_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Total Time for Derivatives:'
      Write(6,*) 'Wall/CPU',Total_Der_Wall2, Total_Der_CPU2
      Write(6,*) '-------------------------'
      Write(6,*) 'Derivative check:'
      Write(6,*) 'Wall/CPU',Total_Der_Wall, Total_Der_CPU
      Write(6,*) '-------------------------'
#endif

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dawrtmap(lun,mapd,mapi,rc)
! this routine writes required mapd and mapi to open unformatted file
! with number lun
!
! lun   - Logical unit number of file, where mediate will be stored (Input)
! mapd  - direct map matrix corresponding to given mediate (Input)
! mapi  - inverse map matrix corresponding to given mediate (Input)
! rc    - return (error) code (Output)

use ccsort_global, only: daddr, iokey
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: lun
integer(kind=iwp), intent(_IN_) :: mapd(0:512,6), mapi(8,8,8)
integer(kind=iwp), intent(out) :: rc

rc = 0

!1 write mapd

if (iokey == 1) then
  ! Fortran IO
  write(lun) mapd,mapi

else
  ! MOLCAS IO
  call idafile(lun,1,mapd,3078,daddr(lun))
  call idafile(lun,1,mapi,512,daddr(lun))
end if

return

end subroutine dawrtmap

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Thomas Bondo Pedersen                            *
!***********************************************************************

function Cho_iFindSmallest(iVec,n)
!
! Thomas Bondo Pedersen, June 2007.
!
! Return index of smallest element in array iVec.

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: Cho_iFindSmallest
integer(kind=iwp), intent(in) :: n, iVec(n)
integer(kind=iwp) :: i, imin

if (n < 1) then
  imin = 0
else
  imin = n
  do i=n-1,1,-1
    if (iVec(i) < iVec(imin)) imin = i
  end do
end if

Cho_iFindSmallest = imin

end function Cho_iFindSmallest

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function MorsCre(IMORS,IPOS)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: MorsCre
integer(kind=iwp), intent(in) :: IMORS, IPOS
integer(kind=iwp) :: ISGN
integer(kind=iwp), external :: MorsParity

MorsCre = 999999
if (btest(IMORS,IPOS-1)) return
MorsCre = ibset(IMORS,IPOS-1)
ISGN = MorsParity(IMORS/(2**(IPOS-1)))
MorsCre = ISGN*MorsCre

return

end function MorsCre

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine set_T(nT,nTempMagn,TINPUT,TempMagn,Tmin,Tmax,chit_exp,Texp,T,XTexp)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nT, nTempMagn
logical(kind=iwp), intent(in) :: TINPUT
real(kind=wp), intent(in) :: TempMagn(nTempMagn), Tmin, Tmax, chit_exp(nT), Texp(nT)
real(kind=wp), intent(out) :: T(nT+nTempMagn), XTexp(nT+nTempMagn)
integer(kind=iwp) :: i
real(kind=wp) :: dltt

! set nT, T(i) and XTexp(i) arrays:
T(:) = Zero
XTexp(:) = Zero
!----------------------------------------------------------------------!
if (TINPUT) then
  ! case 1:  T(iT) computed from input values: Texp, and nTempMagn
  !          nTempMagn = 0
  if (nTempMagn > 0) T(1:nTempMagn) = TempMagn(:)
  T(nTempMagn+1:) = Texp(:)
  XTexp(nTempMagn+1:) = chit_exp(:)
else
  ! case 2:  T(iT) computed from input values: Tmin, Tmax, nT
  !          and nTempMagn
  dltt = (tmax-tmin)/real(nT-1,kind=wp)

  T(nTempMagn+1:) = Texp(:)
  XTexp(nTempMagn+1:) = chit_exp(:)

  if (nTempMagn > 0) T(1:nTempMagn) = TempMagn(:)

  T(nTempMagn+1) = 1.0e-4_wp
  do i=2,nT
    T(nTempMagn+i) = Tmin+dltt*real(i-1,kind=wp)
  end do
end if !tinput

!----------------------------------------------------------------------!

! check for T=0 values and replace them
! with a definite nonzero value:
do i=1,nT+nTempMagn
  if (abs(T(i)) <= tiny(T)) T(i) = 1.0e-4_wp
end do

return

end subroutine set_T

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
*               1996, Bjorn O. Roos                                    *
************************************************************************
      SUBROUTINE TRAMO_MCLR(LBUF,X1,n1,X2,n2,X3,n3,X4,n4,
     &                      Buffer,MEMX,
     &                      NBP,NBQ,NBR,NBS,iSP,iSQ,iSR,iSS,
     &                      nAP,nAQ,nAR,nAS,CMP,CMQ,CMR,CMS,
     &                      iAD13,iAD14,iAD23,iAD24,iAD34,len,
     &                      IDAHLF2,IRLHLF2,
     &                      IDAHLF3,IRLHLF3,LIOTAB)
*
*****************************************************************
*                                                               *
*     Purpose: two-electron transformation routine.             *
*              Transformation is made in core if all            *
*              half-transformed integrals fit.                  *
*              Otherwise sorted integrals are written onto      *
*              unit LUHALF.                                     *
*                                                               *
*****************************************************************
*                                                               *
*  Stolen from MOTRA and destroyed by Anders to make it         *
*  possible to generate all sort of combination of transformed  *
*  and untransformed indexes                                    *
*                                                               *
*****************************************************************
*

      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "Files_mclr.fh"
#include "SysDef.fh"
*
      Integer len(5)
      DIMENSION X1(n1),X2(n2),X3(n3),X4(n4),
     &          Buffer(MemX),
     &          CMP(nBP,nAP),CMQ(nBQ,nAQ),
     &          CMR(nBR,nAR),CMS(nBS,nAS)
*
      Integer IDAHLF2(LIOTAB),IRLHLF2(LIOTAB),
     &        IDAHLF3(LIOTAB),IRLHLF3(LIOTAB)
*
      Call TRAMO_MCLR_INTERNAL(Buffer)
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer_array(len)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine TRAMO_MCLR_INTERNAL(Buffer)
      Use Iso_C_Binding
      Real*8, Target :: Buffer(*)
      Integer, Pointer :: iBuffer(:)
      ione=1
      if (nofile) ione=0
*
*     Set some constants
*
      MemXX=MemX-lBuf-1010
      If (ISS.eq.isr) Then
          NBPQ=(NBP+NBP**2)/2
          NBRS=(NBR+NBR**2)/2
          NARS=(NAR+NAR**2)/2
      ELSE
          NBPQ=NBP*NBQ
          NBRS=NBR*NBS
          NARS=NAR*NAS
      ENDIF
      iBUF2=0
      iBUF3=0
      iAD2=0                        ! Disk address for (kL|ij)
      iAD3=0                        ! Disk address for (Kl|ij)
      iPQUT2=0                      ! Index(ij)  in buffer.
      iPQUT3=0                      ! Just one should be enough but...
      iPQUT4=0                      ! ..easy is better than intelligent
      If (iSP.eq.iSQ) Then
       iMax=nBP*(nBP+1)/2
      Else
       iMax=nBP*nBQ               ! Size of buffer
      End If
      Incore=0                    ! First we try to  transform in core
      If (iss.ne.isr) Then
      nBuf=nBR*nAS+nAR*nBS
      Else
      nbuf=nbr*nas
      End if
*
* Buffer needed in the final step in the calculation of the exchange type
* integrals. The factor ten is arbitrary, however a 10 writes to disk per
* batch is acceptable before paging out integrals to disk to increase
* memory, however we dont want to write in to small batches 512 dWords (4k) is
* the lower limit
*
* /*
*    __________________________________
*    |          |           |         |
*    |          |           |         |
*    ----------------------------------
*    |          |           |         |
*    |         -|-----------|---------|
*    ---------------------------------|\
*    |        | |           |         | \
*    | ORDINT | |  (IjkL)   | (Ij|Kl) |  \
*    |----------|           |         |   \ N
*    ----------------------------------   /
*    |          |           |         |  /
*    | (ij|KL)  |  (iJ|kL)  | (iJ|Kl) | /
*    |          |           |         |/
*    ----------------------------------\
*    |          |           |         | \
*    | (ij|Kl)  |  (ij|Kl)  | (ij|Kl) |  \
*    |          |           |         |   \
*    ----------------------------------    nBuf*iMax
*    |          |           |         |   /
*    | (ij|kL)  |  (ij|kL)  | (ij|kL) |  /
*    |          |           |         | /
*    ----------------------------------/
* */
      i1=nAS*(nAP*nBQ*nBR+nAQ*nBP*nBR)
      If (ISP.eq.ISQ) i1=nAS*nAP*nBQ*nBR
      i2=nAR*(nAP*nBQ*nBS+nAQ*nBP*nBS)
      If (ISP.eq.ISQ) i2=nAR*nAP*nBQ*nBS
*     Size of output buffer if all data should fit in memory
      NOUT=max(i1,i2,NARS*nBPQ)
*     NOUT=max(nAS*(nAP*nBQ*nBR+nAQ*nBP*nBR),
*    &      nAR*(nAP*nBQ*nBS+nAQ*nBP*nBS),
*    &      NAR*nAS*nBQ*nBP)
*
*     We wont manage it with less than this
      nLimit=Max(nAP*nBQ+nAQ*nBP,NAR*nAS)
      If (nBuf*iMax+NOUT.le.MemXX) Then
         Incore=0 ! We can do the calculation totally in core
      Else
*       But we dont have enough memory
        Incore=1
        MemXXX=MemXX-nOut
*       So we give each buffer same amount of memory
        iMax=MemXXX/nBuf
*       But we need space to unpack the integrals
        iMax=(MemXXX-iMax)/nBuf
        iMax=(MemXXX-iMax)/nBuf
        iMax=(MemXXX-iMax)/nBuf
        If (iMax.lt.1) Then
           Write (6,*) 'TraMO_MCLR: iMax.lt.1'
           Write (6,*) 'iMax=',iMax
           Call Abend()
        End If
        Call DAName(LUHLF2,FNHLF2)
        Call DAName(LUHLF3,FNHLF3)
      End If
*
*****************************************************************
*
* OK to start with with we need buffers but in the final step
* the only memory we need is a place to load (pq) integrals plus
* unpacking area plus a area of the size n to put the final result
* if we do not have enough memory, we will have a very long nose
*
*****************************************************************
*
      ip2=1                  ! (ij|kL)
      ip3=ip2+iMax*nBR*nAS+1   ! (ij|Kl)
      Buffer(ip3-1)=-99999.0d0
      If (iss.ne.isr) Then
      ip4=ip3+iMax*nBS*nAR+1   ! (ij|KL)
      else
      ip4=ip3+1
      End if
      Buffer(ip4-1)=-99999.0d0
      ipB=ip4+nBPQ*nARS+1      ! Read from ORDINT
      Buffer(ipB-1)=-99999.0d0
*
*****************************************************************
*
*     Start loop over sorted AO-integrals: npq pq-pairs in each buffer
*
*****************************************************************
*
      IPQ=0
      LPQ=0
      NPQ=0
      IRSST=1-NBRS    ! startpoint for present batch of integrals
      iopt=1
*
      If (.not.NOFILE) Then
      DO 10 NP=1,NBP
        NQM=NBQ
        IF(ISP.EQ.ISQ) NQM=NP
        DO 9 NQ=1,NQM
          IPQ=IPQ+1
          IPQUT2=IPQUT2+1
          IPQUT3=IPQUT3+1
          IPQUT4=IPQUT4+1
*
*****************************************************************
*                                                               *
*         Read in a block of integrals  NPQ pq values           *
*                                                               *
*****************************************************************
*
          IF(LPQ.EQ.NPQ.and.(.not.NOFILE)) THEN
            CALL RDORD(IRC,IOPT,ISP,ISQ,ISR,ISS,
     &                 Buffer(ipB),LBUF,NPQ)
            Call GADSum(Buffer(ipB),LBuf)
            If (irc.ne.0) Then
               Write (6,*) 'TraMO_MCLR: error reading ORDINT!'
               Call Abend()
            End If
            IOPT=2
            LPQ=0
            IRSST=1-NBRS
          ENDIF
          LPQ=LPQ+1
          IRSST=IRSST+NBRS
*
*****************************************************************
*                                                               *
*        Start transformation of this pq pair -> (ij|kL) (ijKl) *
*                                                               *
*****************************************************************
*
          If ((nAS*nAR.ne.0).or.(nAS*(nAP+nAQ).ne.0)) Then
            If (iSR.eq.iSS) Then
              CALL SQUARE(Buffer(ipB+IRSST-1),X1,1,NBS,NBS)
              CALL DGEMM_('T','N',
     &                    NBR,NAS,NBS,
     &                    1.0d0,X1,NBS,
     &                    CMS,NBS,
     &                    0.0d0,X2,NBR)
            Else
              CALL DGEMM_('T','N',
     &                    NBR,NAS,NBS,
     &                    1.0d0,Buffer(ipB+IRSST-1),NBS,
     &                    CMS,NBS,
     &                    0.0d0,X2,NBR)
            End If
          End If
*
*****************************************************************
*
*     Sort and save integrals transformed in one index
*     that should be used for exchange type integrals
*
*****************************************************************
*
          If ((nAP+nAQ)*nAS.ne.0) Then
             If (IPQUT2.GT.iMax) Then
               iPQUT2=1
               iST2=1
               Do i=1,nAS*nBR
                  iBuf2=iBuf2+1
                  IF ( iBuf2.GT.LIOTAB ) THEN
                     Write (6,*) 'TraMO_MCLR: iBuf2.GT.LIOTAB'
                     Write (6,*) 'iBuf2,LIOTAB=',iBuf2,LIOTAB
                     Call Abend()
                  ENDIF
                  CALL PKR8(0,iMax,NBYTES,Buffer(ip2+ist2-1),
     &                                    Buffer(ip2+ist2-1))
                  LPKREC=(NBYTES+itob-1)/itob
*                 Save the length of this record
                  IRLHLF2(iBUF2)=LPKREC
*                 Save the address of this record
                  IDAHLF2(iBUF2)=iAD2
                  Call C_F_Pointer(C_Loc(Buffer(ip2+IST2-1)),iBuffer,
     &                             [LPKREC])
                  CALL iDAFILE(LUHLF2,1,iBuffer,LPKREC,IAD2)
                  Nullify(iBuffer)
                  iST2=iST2+iMax
               End Do
             End If
*
             call dcopy_(nAs*nBR,X2,1,Buffer(ip2+iPQUT2-1),iMax)
*
          End If
*****************************************************************
*
          IF(ISR.NE.ISS) THEN
            CALL DGEMM_('N','N',
     &                  NBS,NAR,NBR,
     &                  1.0d0,Buffer(ipB+IRSST-1),NBS,
     &                  CMR,NBR,
     &                  0.0d0,X3,NBS)
*
*****************************************************************
          If ((nAP+nAQ)*nAR.ne.0) Then
            If(IPQUT3.GT.iMax) Then
              IPQUT3=1
              IST3=1
              DO 34 I=1,nAR*nBS
                IBUF3=IBUF3+1
                IF ( IBUF3.GT.LIOTAB ) THEN
                   Write (6,*) 'TraMO_MCLR: iBuf3.GT.LIOTAB'
                   Write (6,*) 'iBuf3,LIOTAB=',iBuf3,LIOTAB
                   Call Abend()
                ENDIF
                CALL PKR8(0,IMAX,NBYTES,Buffer(ip3+IST3-1),
     &                                    Buffer(ip3+IST3-1))
                LPKREC=(NBYTES+itob-1)/itob
                IRLHLF3(IBUF3)=LPKREC
                IDAHLF3(IBUF3)=IAD3
                Call C_F_Pointer(C_Loc(Buffer(ip3+IST3-1)),iBuffer,
     &                           [LPKREC])
                CALL iDAFILE(LUHLF3,1,iBuffer,LPKREC,IAD3)
                Nullify(iBuffer)
                IST3=IST3+iMax
34             CONTINUE
            End If
          End If
*
          call dcopy_(nAR*nBS,X3,1,Buffer(ip3+iPQUT3-1),iMax)
*
          End If
*
*****************************************************************
*
*  Transform to Coulomb type integrals
*
*****************************************************************
*
          If (NAR*NAS.ne.0) Then
          IF(ISR.EQ.ISS) THEN
            CALL MXMT(X2,        NBR,1,
     *                CMR, 1,NBR,
     *                X4,
     *                NAR,NBR)
          ELSE
            CALL DGEMM_('T','N',
     &                  NAS,NAR,NBR,
     &                  1.0d0,X2,NBR,
     &                  CMR,NBR,
     &                  0.0d0,X4,NAS)
          End If
          End If
*
*****************************************************************
*
          If (nARS.ne.0) Then
            call dcopy_(nARS,X4,1,Buffer(ip4+iPQUT4-1),nBPQ)
          End If
*
*****************************************************************
*
9       CONTINUE
10    CONTINUE
*
*
*****************************************************************
*
*     Empty last buffers
*
*****************************************************************
*
      IF(INCORE.EQ.1) THEN
        IST=1
        DO 61 I=1,nBR*nAS
          IBUF2=IBUF2+1
          IF ( IBUF2.GT.LIOTAB ) THEN
             Write (6,*) 'TraMO_MCLR: iBuf2.GT.LIOTAB'
             Write (6,*) 'iBuf2,LIOTAB=',iBuf2,LIOTAB
             Call Abend()
          ENDIF
          CALL PKR8(0,iMax,NBYTES,Buffer(ip2+IST-1),Buffer(ip2+IST-1))
          LPKREC=(NBYTES+itob-1)/ItoB
          IDAHLF2(IBUF2)=IAD2
          IRLHLF2(IBUF2)=LPKREC
          Call C_F_Pointer(C_Loc(Buffer(ip2+IST-1)),iBuffer,[LPKREC])
          CALL iDAFILE(LUHLF2,1,iBuffer,LPKREC,IAD2)
          Nullify(iBuffer)
          IST=IST+IMAX
 61     CONTINUE
        If (iSS.ne.iSR) Then
         IST=1
         DO 71 I=1,nBS*nAR
          IBUF3=IBUF3+1
          IF ( IBUF3.GT.LIOTAB ) THEN
             Write (6,*) 'TraMO_MCLR: iBuf3.GT.LIOTAB'
             Write (6,*) 'iBuf3,LIOTAB=',iBuf3,LIOTAB
             Call Abend()
          ENDIF
          CALL PKR8(0,iMax,NBYTES,Buffer(ip3+IST-1),Buffer(ip3+IST-1))
          LPKREC=(NBYTES+itob-1)/itob
          IDAHLF3(IBUF3)=IAD3
          IRLHLF3(IBUF3)=LPKREC
          Call C_F_Pointer(C_Loc(Buffer(ip3+IST-1)),iBuffer,[LPKREC])
          CALL iDAFILE(LUHLF3,1,iBuffer,LPKREC,IAD3)
          Nullify(iBuffer)
          IST=IST+IMAX
71       CONTINUE
        End If
      End If
      End If ! nofile
      If (NOFILE)  ipqut4=NBPQ
      If (nars.ne.0)
     &  Call dDafile(LUTRI1,iOne,Buffer(ip4),nARS*NBPQ,iAD34)
      If (Buffer(ip3-1).ne.-99999.0d0) Then
         Write (6,*) 'TraMO_MCLR: Buffer(ip3-1).ne.-99999.0d0'
         Write (6,*) 'Buffer(ip3-1)=',Buffer(ip3-1)
         Call Abend()
      End If
      If (Buffer(ip4-1).ne.-99999.0d0) Then
         Write (6,*) 'TraMO_MCLR: Buffer(ip4-1).ne.-99999.0d0'
         Write (6,*) 'Buffer(ip4-1)=',Buffer(ip4-1)
         Call Abend()
      End If
      If (Buffer(ipB-1).ne.-99999.0d0) Then
         Write (6,*) 'TraMO_MCLR: Buffer(ipB-1).ne.-99999.0d0'
         Write (6,*) 'Buffer(ipB-1)=',Buffer(ipB-1)
         Call Abend()
      End If
      If (nAP+nAQ.eq.0) Goto 987
*****************************************************************
*
*     second transformation
*     =====================
*
*    The integrals are transformed and written to disk
*    this is done so that the integrals are written to
*    disk in batches of nB*nB*nA integrals. This is the
*    Least number of integrals that have to match in buffer
*    because we want to write the integrals sorted onto disk
*
*****************************************************************
*
      ipX=ip4
      ipY=ipX+nBR*NAS*nBP*nAQ+1   ! (Ij|kL)
      ipz=ipy+1
      If (isp.ne.isq) ipZ=ipY+nBR*NAS*nBQ*nAP+1
      If (ipz.gt.memx) Then
         Write (6,*) 'TraMO_MCLR: ipz.gt.memx'
         Write (6,*) 'ipz,memx=',ipz,memx
         Call Abend()
      End If
      Buffer(ipX-1)=-99999.0d0
      Buffer(ipY-1)=-99999.0d0
      Buffer(ipZ-1)=-99999.0d0

      IAD2=0
      IAD3=0
      IVX=0
      ii3=0
      ii2=0
      DO 125 NS=1,nAS
        nr2=(NS-1)*NBR*NBP*NAQ
        nr3=(NS-1)*nBR*NBQ*NAP
        If (.not.NoFile) Then
        DO 120 NR=1,nBR
         IPQST=1+NBPQ*IVX
         IVX=IVX+1
         IBUF=IVX
*
*****************************************************************
*
*      Read one buffer of integrals back into core if INCORE=1
*
*****************************************************************
*
         IF(INCORE.EQ.1) THEN
           ipq=0
           MemInt=((nBPQ-1)/iMax+1)*iMax
           MemY=MemXX-MemInt
           ip2=1
           ip5=ip2+((nBPQ-1)/iMax+1)*iMax
           ipX=ip5+iMax+1
           ipY=ipX+nBP*nAQ*nBR*NAS+1
           ipZ=ipY+1
           If (isp.ne.isq) ipZ=ipX+nAQ*NBP*nBR*NAS+1
           Buffer(ipX-1)=-99999.0d0
           Buffer(ipY-1)=-99999.0d0
           Buffer(ipZ-1)=-99999.0d0
           ipq=1
112        CONTINUE
           IAD2=IDAHLF2(IBUF)
           LPKREC=IRLHLF2(IBUF)
           Call C_F_Pointer(C_Loc(Buffer(ip5)),iBuffer,[LPKREC])
           CALL iDAFILE(LUHLF2,2,iBuffer,LPKREC,IAD2)
           Nullify(iBuffer)
           CALL UPKR8(0,iMax,NBYTES,Buffer(ip5),Buffer(ip2+IPQ-1))
           IPQ=IPQ+iMax
           iBuf=iBuf+nAS*nBR
           IF(IPQ.LE.NBPQ) GO TO 112
           IPQST=1
         ENDIF
*
*****************************************************************
*                                                               *
* Transform (ij|kL) -> (Ij|kL) & (iJ|kL)                        *
*                                                               *
*****************************************************************
*
         IF(ISP.EQ.ISQ) THEN
         If (NAQ.ne.0) Then
            CALL SQUARE(Buffer(ip2+IPQST-1), X1,1,NBP, NBQ)
            CALL DGEMM_('T','N',
     &                  NBP,NAQ,NBQ,
     &                  1.0d0,X1,NBQ,
     &                  CMQ,NBQ,
     &                  0.0d0,X2,NBP)
         ENDIF
         ELSE
         If (NAQ.ne.0) Then
            CALL DGEMM_('T','N',
     &                  NBP,NAQ,NBQ,
     &                  1.0d0,Buffer(ip2+IPQST-1),NBQ,
     &                  CMQ,NBQ,
     &                  0.0d0,X2,NBP)
         ENDIF
         If (NAP.ne.0) Then
            CALL DGEMM_('N','N',
     &                  NBQ,NAP,NBP,
     &                  1.0d0,Buffer(ip2+IPQST-1),NBQ,
     &                  CMP,NBP,
     &                  0.0d0,X3,NBQ)
         ENDIF
         ENDIF
*
*****************************************************************
*
*      Move integrals to output buffer
*
*****************************************************************
*

         Do i=0,nAQ-1
           call dcopy_(nBP,X2(i*nBP+1),1,
     &                Buffer(ipX+nr2+i*nBR*nBP),1)
         End Do
         nr2=nr2+nBP

         If (isp.ne.isq) Then
          Do i=0,nAP-1
           call dcopy_(nBQ,X3(i*nBQ+1),1,
     &                Buffer(ipY+nr3+i*nBR*nBQ),1)
          End Do
          nr3=nr3+nBQ
         End If
*
120    CONTINUE
*
*****************************************************************
*
*       Empty last buffers
*
*****************************************************************
*
        End If ! nofile
125    CONTINUE
        If (nAQ.ne.0) Then
*          Call GADSum(Buffer(ipX),nAQ*NAS*NBR*NBP)
           Call dDafile(LUTRI2,ione,Buffer(ipX),
     &                 nAQ*NAS*NBR*NBP,iAD24)
        End If
        If (iSP.ne.iSQ.and.nAP.ne.0) Then
*          Call GADSum(Buffer(ipY),NAP*NAS*NBR*NBQ)
           Call dDafile(LUTRI3,ione,Buffer(ipY),
     &              NAP*NAS*NBR*NBQ,iAD14)
        End If
*

*
*****************************************************************
*
*
*****************************************************************
      If (buffer(ipX-1).ne.-99999.0d0) Then
         Write (6,*) 'TraMO_MCLR: buffer(ipX-1).ne.-99999.0d0'
         Write (6,*) 'buffer(ipX-1)=',buffer(ipX-1)
         Call Abend()
      End If
      If (buffer(ipY-1).ne.-99999.0d0) Then
         Write (6,*) 'TraMO_MCLR: buffer(ipY-1).ne.-99999.0d0'
         Write (6,*) 'buffer(ipY-1)=',buffer(ipY-1)
         Call Abend()
      End If
      If (buffer(ipZ-1).ne.-99999.0d0) Then
         Write (6,*) 'TraMO_MCLR: buffer(ipZ-1).ne.-99999.0d0'
         Write (6,*) 'buffer(ipZ-1)=',buffer(ipZ-1)
         Call Abend()
      End If
      If (iSS.ne.iSR) Then
       ipX=ip4
       Buffer(ipX-1)=-99999.0d0
       ipY=ipX+nAR*NBS*nBP*nAQ+1   ! (Ij|kL)
       Buffer(ipY-1)=-99999.0d0
       ipZ=ipy+1
       if (isp.ne.isq) ipZ=ipY+nAR*NBS*nBQ*nAP+1
       Buffer(ipZ-1)=-99999.0d0
       IVX=0
       DO 225 NR=1,nAR
        nr2=NBP*NBS*(nR-1)*NAQ
        nr3=NBQ*NBS*(nR-1)*NAP
        If (.not.NoFile) Then
        DO 220 NS=1,nBS
         IPQST=1+NBPQ*IVX
         IVX=IVX+1
         IBUF=IVX
*
*****************************************************************
*
*      Read one buffer of integrals back into core if INCORE=1
*
*****************************************************************
*
         IF(INCORE.EQ.1) THEN
           MemInt=((nBPQ-1)/iMax+1)*iMax
           MemY=MemXX-MemInt
           ip2=1
           ip3=ip2
           ip5=ip3+((nBPQ-1)/iMax+1)*iMax
           ipX=ip5+iMax+1
           ipY=ipX+nBP*nAQ*nAR*NBS+1
           ipZ=ipY+nBQ*nAP*NAR*NBS+1
           Buffer(ipX-1)=-99999.0d0
           Buffer(ipY-1)=-99999.0d0
           Buffer(ipZ-1)=-99999.0d0
           IPQ=1
212        CONTINUE
           IAD3=IDAHLF3(IBUF)
           LPKREC=IRLHLF3(IBUF)
           Call C_F_Pointer(C_Loc(Buffer(ip5)),iBuffer,[LPKREC])
           CALL iDAFILE(LUHLF3,2,iBuffer,LPKREC,IAD3)
           Nullify(iBuffer)
           CALL UPKR8(0,iMax,NBYTES,Buffer(ip5),Buffer(ip3+IPQ-1))
           IPQ=IPQ+iMax
           iBuf=iBuf+nAR*nBS
           IF(IPQ.LE.NBPQ) GO TO 212
           IPQST=1
         ENDIF
*
*****************************************************************
*                                                               *
* Transform (ij|kL) -> (Ij|kL) & (iJ|kL)                        *
*                                                               *
*****************************************************************
*
         IF(ISP.EQ.ISQ) THEN
         If (nBQ*nAP.ne.0) Then

            CALL SQUARE(Buffer(ip3+IPQST-1), X1,1,NBQ, NBQ)
            CALL DGEMM_('T','N',
     &                  NBP,NAQ,NBQ,
     &                  1.0d0,X1,NBQ,
     &                  CMQ,NBQ,
     &                  0.0d0,X2,NBP)
*           CALL xxDGEMUL(X1,NBQ,'N',CMP,NBP,'N',
*    &                  X3,NBQ,NBQ,NBP,NAP)
*           Call RecPrt('PqRs',' ',X3,nBQ,nAP)
         ENDIF
         ELSE
         If (nBP*nAQ.ne.0)
     &      CALL DGEMM_('T','N',
     &                  NBP,NAQ,NBQ,
     &                  1.0d0,Buffer(ip3+IPQST-1),NBQ,
     &                  CMQ,NBQ,
     &                  0.0d0,X2,NBP)
         If (nBQ*nAP.ne.0)
     &      CALL DGEMM_('N','N',
     &                  NBQ,NAP,NBP,
     &                  1.0d0,Buffer(ip3+IPQST-1),NBQ,
     &                  CMP,NBP,
     &                  0.0d0,X3,NBQ)
         ENDIF
*
*****************************************************************
*
*      Move integrals to output buffer
*
*****************************************************************
*

         Do i=0,nAQ-1
           call dcopy_(nBP,X2(i*nBP+1),1,
     &                Buffer(ipX+i*nBS*nBP+nr2),1)
         End Do
         nr2=nr2+nBP
         If (iSP.ne.iSQ) Then
          Do i=0,nAP-1
           call dcopy_(nBQ,X3(i*nBQ+1),1,
     &                Buffer(ipY+i*NBS*nBQ+nR3),1)
          End Do
          nr3=nr3+nBQ
         End If
*
220    CONTINUE
      If (buffer(ipX-1).ne.-99999.0d0) Then
         Write (6,*) 'TraMO_MCLR: buffer(ipX-1).ne.-99999.0d0'
         Write (6,*) 'buffer(ipX-1)=',buffer(ipX-1)
         Call Abend()
      End If
      If (buffer(ipY-1).ne.-99999.0d0) Then
         Write (6,*) 'TraMO_MCLR: buffer(ipY-1).ne.-99999.0d0'
         Write (6,*) 'buffer(ipY-1)=',buffer(ipY-1)
         Call Abend()
      End If
      If (buffer(ipZ-1).ne.-99999.0d0) Then
         Write (6,*) 'TraMO_MCLR: buffer(ipZ-1).ne.-99999.0d0'
         Write (6,*) 'buffer(ipZ-1)=',buffer(ipZ-1)
         Call Abend()
      End If

*****************************************************************
*
*      Write buffer to disk (iJ|Kl) & (Ij|Kl)
*
*****************************************************************
*
        End If ! nofile
225     CONTINUE
        If (nAQ.ne.0) Then
*          Call GADSum(Buffer(ipX),nAR*nAQ*nBS*nBP)
           Call dDaFile(LuTri4,ione,Buffer(ipX),
     &                  nAR*nAQ*nBS*nBP,iad23)
        End If
        If (iSP.ne.iSQ.and.nap.ne.0) Then
*          Call GADSum(Buffer(ipY),nAR*nAP*nBS*nBQ)
           Call dDaFile(LuTri5,ione,Buffer(ipY),
     &                  nAR*nAP*nBS*nBQ,iad13)
        End If
       End If
*
 987  Continue
      IF ( INCORE.EQ.1 ) THEN
        CALL DACLOS(LUHLF2)
        CALL DACLOS(LUHLF3)
      END IF
*
      RETURN
      End Subroutine TRAMO_MCLR_INTERNAL
*
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
*               Giovanni Ghigo                                         *
************************************************************************
      SubRoutine Rd_UDIC(iInt,nFix,nRowH)
************************************************************************
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
************************************************************************
      use Slapaf_Parameters, only: iRow
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Character*120 Temp
      character*16 filnam
*
      Lu_UDIC=91
      filnam='UDIC'
      call molcas_open(Lu_UDIC,filnam)
c      Open(Lu_UDIC,File=filnam,Form='FORMATTED',Status='OLD')
      Rewind(Lu_UDIC)
*
*     Find begining of definitions of internal coordinates
*
      Do iLines = 1, iRow
         Read(Lu_UDIC,'(A)') Temp
         Call UpCase(Temp)
         If (Temp(1:4).eq.'VARY') Go To 100
      End Do
      Call WarningMessage(2,' No internal coordinates are defined!')
      Call Quit_OnUserError()
*
 100  Continue
      iInt = 0
      nFix = 0
      nRowH = 0 ! Number of Rows of Hessian Numerically estimated
      Do jLines = iLines+1, iRow
         Read(Lu_UDIC,'(A)') Temp
         Call UpCase(Temp)
         If (Temp(1:3).eq.'FIX') Go To 200
         If (Temp(1:4).eq.'ROWH') then
           kLines = jLines
           Go To 300
         EndIf
*------- Do not count line if continuation character
         If (Index(Temp,'&').eq.0) iInt=iInt+1
      End Do
      Go To 400
*
 200  Continue
      Do kLines = jLines+1, iRow
         Read(Lu_UDIC,'(A)') Temp
         Call UpCase(Temp)
         If (Temp(1:4).eq.'ROWH') Go To 300
*------- Do not count line if continuation character
         If (Index(Temp,'&').eq.0) nFix=nFix+1
      End Do
 300  Do lLines = kLines+1, iRow
         Read(Lu_UDIC,'(A)') Temp
         Call UpCase(Temp)
*------- Do not count line if continuation character
         If (Index(Temp,'&').eq.0) nRowH=nRowH+1
      End Do
 400  Continue
*
      Close(Lu_UDIC)
      Return
      End


      SubRoutine Rd_UDIC_RowH(nInter,nRowH,mRowH)
************************************************************************
*                                                                      *
* Object: Reading the Internal Coordinates required for Numerical      *
*         estimation of single rows and columns of Hessian             *
* Called from: PrePro when nRowH.GT.0                                  *
* Author: Giovanni Ghigo, University of Torino, Italy                  *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Character*8 Labels(nInter)
      Character*8 cLbl
      Character*120 Temp
      Character*16 filnam
      Integer mRowH(nRowH)
*
*
      Lu=6
      Lu_UDIC=91
      filnam='UDIC'
      call molcas_open(Lu_UDIC,filnam)
      Rewind(Lu_UDIC)
      mRowH(:)=0
*
*     Find begining of definitions of internal coordinates
*
 10   Read(Lu_UDIC,'(A)') Temp
      Call UpCase(Temp)
      If (Temp(1:4).ne.'VARY') Go To 10
      Do iLines = 1, nInter
 20      Read(Lu_UDIC,'(A)') Temp
         Call UpCase(Temp)
         If (Temp(1:3).eq.'FIX' ) Go To 20
         cLbl = '        '
         Do j = 1, 120
            If (Temp(j:j).EQ.' ') GoTo 30
            cLbl(j:j) = Temp(j:j)
         Enddo
 30      Labels(iLines) = cLbl
 35      If (Index(Temp,'&').eq.0) GoTo 37
         Read(Lu_UDIC,'(A)') Temp
         GoTo 35
 37   Continue
      EndDo
*
      Read(Lu_UDIC,'(A)') Temp ! Skip ROWH
      Do iRowH = 1 , nRowH
         Read(Lu_UDIC,'(A)') Temp
         Call UpCase(Temp)
         cLbl(1:8) = Temp(1:8)
         Do kLines = 1, nInter
            If (cLbl.eq.Labels(kLines)) then
               mRowH(iRowH) = kLines
               GoTo 40
            EndIf
         EndDo
         Call WarningMessage(2,'Error in rd_udic')
         Write (Lu,*) '**********************************************'
         Write (Lu,*) ' ERROR: Undefined internal ROWH coordinate in '
         Write (Lu,*) ' ',Temp(1:60)
         Write (Lu,*) '**********************************************'
         Call Quit_OnUserError()
 40      Continue
      End Do
      Close(Lu_UDIC)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************

subroutine CalcFckS(FckO,GDMat,FckS)

use Index_Functions, only: iTri, nTri_Elem
use rasscf_global, only: lRoots, nAc
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: FckO(NAC,NAC), GDMat(nTri_Elem(lRoots),NAC,NAC)
real(kind=wp), intent(inout) :: FckS(lRoots,lRoots)
integer(kind=iwp) :: IState, JState

FckS(:,:) = Zero

do IState=1,lRoots
  do JState=1,IState
    FckS(IState,JState) = FckS(IState,JState)+sum(FckO(:,:)*GDMat(iTri(IState,JState),:,:))
    FckS(JState,IState) = FckS(IState,JState)
  end do
end do

!call PrintMat('XMS_Mat','test',FckS,LRoots,LRoots,0,4,'N')

end subroutine CalcFckS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GF_on_the_Fly(iDo_dDipM)

use Symmetry_Info, only: nIrrep
use Slapaf_Info, only: Coor, nDimBC, mTROld
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iDo_dDipM
integer(kind=iwp) :: iCtl, iEl, iNeg, iOff, jSym, lModes, Lu_10, mDisp(8), mSym, mTR, nAtom, nDoF, nInter, nModes, nX
real(kind=wp) :: DipM(3)
real(kind=wp), allocatable :: dDipM(:), EVal(:), EVec(:), IRInt(:), RedMas(:), Temp(:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *

nX = 3*size(Coor,2)
nAtom = size(Coor,2)
nInter = nDimBC-mTROld
mTR = mTROld
nDoF = nDimBC

call mma_allocate(EVec,nX**2,Label='EVec')
call mma_allocate(EVal,nX,Label='EVal')
call mma_allocate(RedMas,nX,Label='RedMas')
call mma_allocate(dDipM,3*nDoF,Label='dDipM')
dDipM(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
DipM(:) = Zero
call GF(nX,nDoF,nInter,EVec,EVal,RedMas,iNeg,dDipM,mTR,nAtom,DipM)

#ifdef _DEBUGPRINT_
call RecPrt('EVec',' ',EVec,nX,nX)
call RecPrt('EVal',' ',EVal,1,nX)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out frequencies and IR intensities

write(u6,10)
write(u6,10) ' Observe that the harmonic oscillator analysis is only valid at stationary points!'
write(u6,10)
write(u6,10) ' Note that rotational and translational degrees have been automatically removed,'
write(u6,10) ' if the energy is invariant to these degrees of freedom.'
write(u6,10)
write(u6,10)
write(u6,10) ' Harmonic frequencies in cm-1'
write(u6,10)
if (iDo_dDipM == 1) then
  write(u6,10) ' IR Intensities in km/mol'
  write(u6,10)
end if
write(u6,10) ' Normal modes in gf_on_the_fly.f '

iOff = 0
iCtl = iDo_dDipM
iEl = 3
jSym = 1

call mma_allocate(Temp,3*nDoF,Label='Temp')

call DGeTMO(dDipM,3,3,nInter,Temp,nInter)

call mma_deallocate(dDipM)

call mma_allocate(IRInt,nDoF,Label='IRInt')

Lu_10 = 10
Lu_10 = IsFreeUnit(Lu_10)
call Molcas_Open(lu_10,'UNSYM')

write(Lu_10,'(A,I1)') '*NORMAL MODES SYMMETRY: ',jsym
call GF_Print(EVal,EVec,Temp,iEl,nDoF,nInter,iCtl,IRInt,RedMas,Lu_10,iOff)

close(Lu_10)
call mma_deallocate(Temp)

call Add_Info('Approx. Freq.',EVal,nInter,1)
!                                                                      *
!***********************************************************************
!                                                                      *
! Save normal modes for later generation of Molden input.

lModes = 0
nModes = 0
lModes = lModes+nInter*nDoF
nModes = nModes+nInter
#ifdef _DEBUGPRINT_
call RecPrt('NModes',' ',EVec,nDoF,nInter)
#endif

if (nIrrep == 1) call Print_Mode_Components(EVec,EVal,nModes,lModes,mDisp)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write stuff on Molden input file

mSym = 1
mDisp(:) = 0
mDisp(1) = nInter
call Freq_Molden(EVal,nModes,EVec,lModes,mSym,IRInt,mDisp,RedMas)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(IRInt)
call mma_deallocate(RedMas)
call mma_deallocate(EVal)
call mma_deallocate(EVec)
!                                                                      *
!***********************************************************************
!                                                                      *
return

10 format(a)

end subroutine GF_on_the_Fly

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MkDisp()
      Use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "disp.fh"
#include "diff.fh"
#include "WrkSpc.fh"
      Logical TstFnc
C Purpose: Pick out the following data from INFO:
C nUqCnt=Nr of unique centers
C nAlCnt  =Nr of centers (total)
C Coor(3,ic), i=1..nUqCnt, The cartesian coordinates (Unique)
C Coor(3,ic), i=1..nAlCnt,   The cartesian coordinates (All)
C iCntId(Key,i), i=1..nAlCnt, Information about centers:
C iCntId(1,ic)=The center type
C iCntId(2,ic)=An offset,=nr of symmetry-unique centers of earlier type
C iCntId(3,ic)=The symmetry-unique center of this type
C iCntId(4,ic)=(Usually 0) The symmetry op. that relates this center
C             to the corresponding symmetry-unique center
C
C nCntDf=Nr of differentiated centers
C ic=iCntDf(iDf), Which center is being differentiated
C The arrays are dynamic, and created here. Pointers and other data
C is kept in common /DIFF/, see file 'diff.fh'.

      nDiff=0
      Call IniSew(.false.,nDiff)

C Sizes:
      nUqCnt=0
      nAlCnt=0
      ic=0
      Do iCnttp=1,nCnttp
        If(.not.dbsc(iCnttp)%pChrg) Then
          Do iCnt=1,dbsc(iCnttp)%nCntr
            ic=ic+1
            nAlCnt=nAlCnt+nIrrep/dc(ic)%nStab
          End Do
          nUqCnt=nUqCnt+dbsc(iCnttp)%nCntr
        End If
      End Do

C NB. We skip completely the 'pseudo-centers' in the loops below.
C Is this correct?
      Call GetMem('Coor','Allo','Real',ipCoor,3*nAlCnt)
      Call GetMem('iCntId','Allo','Inte',ipCntId,4*nAlCnt)
C Present setup: nCntDf=nUqCnt (see notes below)
      nCntDf=nUqCnt
      Call GetMem('iCntDf','Allo','Inte',ipCntDf,nCntDf)

C The nuclear coordinates: First, the symmetry-unique ones.
      nUqCnt=0
      ic=0
      Do iCnttp=1,nCnttp
        If(.not.dbsc(iCnttp)%pChrg) Then
          Do iCnt=1,dbsc(iCnttp)%nCntr
            ic=ic+1
            iWork(ipCntId+0+4*(ic-1))=iCnttp
            iWork(ipCntId+1+4*(ic-1))=nUqCnt
            iWork(ipCntId+2+4*(ic-1))=iCnt
            iWork(ipCntId+3+4*(ic-1))=0
            Work(0+ipCoor+3*(ic-1))=dbsc(iCnttp)%Coor(1,iCnt)
            Work(1+ipCoor+3*(ic-1))=dbsc(iCnttp)%Coor(2,iCnt)
            Work(2+ipCoor+3*(ic-1))=dbsc(iCnttp)%Coor(3,iCnt)
          End Do
          nUqCnt=nUqCnt+dbsc(iCnttp)%nCntr
        End If
      End Do
C Then, the symmetry related nuclei:
      jc=nUqCnt
      Do ic=1,nUqCnt
        iCnttp=iWork(ipCntId+0+4*(ic-1))
        iOff  =iWork(ipCntId+1+4*(ic-1))
        iCnt  =iWork(ipCntId+2+4*(ic-1))
        Do iOpNr=1,nIrrep/dc(ic)%nStab -1
          jc=jc+1
          iWork(ipCntId+0+4*(jc-1))=iCnttp
          iWork(ipCntId+1+4*(jc-1))=iOff
          iWork(ipCntId+2+4*(jc-1))=iCnt
          iOp=dc(ic)%iCoSet(iOpNr,0)
          iWork(ipCntId+3+4*(jc-1))=iOp
          Call OA(iOp,Work(ipCoor+3*(ic-1):ipCoor+3*(ic-1)+2),
     &                Work(ipCoor+3*(jc-1):ipCoor+3*(jc-1)+2))
        End Do
      End Do
      nAlCnt=jc

C At present, we will assume that the differentiated nuclei are simply
C the symmetry-unique centers, in standard seward order:
      nCntDf=nUqCnt
      Do idf=1,nCntDf
        iWork(ipCntDf+iDf-1)=iDf
      End Do

C With this setup, the differentiated center nr I will simply be the
C same as the symmetry-unique center nr I.
C But this setup may change. It is thus important that externally, the
C differentiated nucleus nr iDf will correspond to the symmetry-unique
C center nr ic=iCntDf(I), which is presumably the number it will have
C on the MCKINT file; unless, of curse, ic is larger than nUqCnt,
C in which case the number of the center in the MCKINT file will be
C actually iCntId(2,ic)+iCntId(3,ic), and integrals with have to
C change sign according to iChTbl(iIrrep,iCntId(4,ic)).

      Write(6,*)' MKDISP: Tables of coordinates and displacements.'
      Write(6,*)' Nr of symmetry-unique centers, nUqCnt=',nUqCnt
      Write(6,*)' Nr of centers (total)        , nAlCnt=',nAlCnt
      Write(6,*)' Table over centers: Center, Center Type, Offset'
      Write(6,*)'   Center within its type, Symmetry op.,'
      Write(6,*)'   and coordinates:'
      Write(6,*)'   iC iCnttp iOff iCnt iOp        x'//
     &            '               y               z'
      Do ic=1,nAlCnt
        iCnttp=iWork(ipCntId+0+4*(ic-1))
        iOff  =iWork(ipCntId+1+4*(ic-1))
        iCnt  =iWork(ipCntId+2+4*(ic-1))
        iOp   =iWork(ipCntId+3+4*(ic-1))
        x=Work(0+ipCoor+3*(ic-1))
        y=Work(1+ipCoor+3*(ic-1))
        z=Work(2+ipCoor+3*(ic-1))
        Write(6,'(1x,5I5,3F16.8)')ic,iCnttp,iOff,iCnt,iOp,x,y,z
      End Do
C-------------------------------------------
CTL2004-start
C-------------------------------------------
      mDisp = 0
      mdc = 0
      Do  iCnttp = 1, nCnttp
         Do  iCnt = 1, dbsc(iCnttp)%nCntr
            mdc = mdc + 1
            mDisp = mDisp + 3*(nIrrep/dc(mdc)%nStab)
         End Do
      End Do
      !
      Call ICopy(MxAtom*8,[0],0,IndDsp,1)
      Call ICopy(MxAtom*3,[0],0,InxDsp,1)
      nDisp = 0
      Do iIrrep = 0, nIrrep-1
         lDisp(iIrrep) = 0
*        Loop over basis function definitions
         mdc = 0
         mc  = 1
         Do iCnttp = 1, nCnttp
*           Loop over unique centers associated with this basis set.
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = mdc + 1
               IndDsp(mdc,iIrrep) = nDisp
*              Loop over the cartesian components
               Do iCar = 0, 2
                  iComp = 2**iCar
                  If ( TstFnc(dc(mdc)%iCoSet,
     &                        iIrrep,iComp,dc(mdc)%nStab) ) Then
                     nDisp = nDisp + 1
                     If (nDisp.gt.mDisp) Then
                        Write (6,*) 'nDisp.gt.mDisp'
                        Call AbEnd()
                     End If
                     If (iIrrep.eq.0) InxDsp(mdc,iCar+1) = nDisp
                     lDisp(iIrrep) = lDisp(iIrrep) + 1
                  End If
               End Do
               mc = mc + nIrrep/dc(mdc)%nStab
            End Do
         End Do
      End Do
C-------------------------------------------
CTL2004-end
C-------------------------------------------
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Prop(Short,qplab,cen1,cen2,nIrrep,nBas,nTot,Occ,ThrSV,
     &                PrEl,PrNu,lpole,labs,tmat,temp,ifallorb)
************************************************************************
*                                                                      *
*     purpose: preprocessing of tables for different tensor            *
*              properties                                              *
*                                                                      *
*     Short           logical option for either Short (Short           *
*                     =.true., the total electronic contribution)      *
*                     long (Short=.false., orbital contributions)      *
*                     output                                           *
*     oplab           operator label as defined in SEWARD              *
*     cen1(1:3)       coordinates of centre no.1 (operator)            *
*     cen2(1:3)       coordinates of centre no.2 (gauge)               *
*     nIrrep          the number of irreducible representations        *
*     nBas            the number of functions in each representa-      *
*     (0:nIrrep-1)    tion                                             *
*     nTot            the total number of elements supplied for        *
*                     each component of the property tensor; equal     *
*                     either to 1 (total electronic and total nuc-     *
*                     lear contributions) or to the dimension of       *
*                     the basis set.                                   *
*     Occ(1:nTot)     occupation numbers for all eigenvectors,         *
*                     a dummy for Short outputs                        *
*     ThrSV           threshold for occupation numbers; If             *
*                     Occ(i).le.ThrSV the contribution will not        *
*                     be printed                                       *
*     PrEl(1:nTot,    matrix elements for all components 1,2,...,      *
*          1:maxlab)  maxlab, nTot entries for each component          *
*                     maxlab=(lpole+1)*(lpole+2)/2                     *
*     PrNu(1:maxlab)  nuclear contributions for each component         *
*     labs(1:maxlab)  labels for each component                        *
*     temp(1:maxlab)  auxiliary storage area                           *
*     ifallorb        logical option for whether the property of       *
*                     all orbitals are printed (and not weighted by    *
*                     occupation number)in property calculation when   *
*                     short=.false. (S.S.Dong, 2018)                   *
*                                                                      *
*     lpole is the value for l in l-pole moments                       *
*     allocate integer storage area of the size appropriate            *
*     for the actual lpole value: size as below                        *
*                                                                      *
* 2000 Dept. of Chem. Phys., Univ. of Lund, Sweden                     *
* Modified by S.S.Dong, 2018, Univ. of Minnesota                       *
* - Enable properties to be printed for all orbitals                   *
* (including virtuals) and not weighted by occupation numbers          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "constants2.fh"
#include "real.fh"
#include "WrkSpc.fh"
      parameter (lmax=16)
      Character*3 lab3
      Character*4 lab4
      Character*5 lab5
      Character*8 qplab,oplab
      Character*(lmax) labs(1:(lpole+1)*(lpole+2)/2),lab
      Character*80 Line
      Logical Short, ifallorb
      Integer nBas(0:nIrrep-1)
      Integer Cho_X_GetTol
      External Cho_X_GetTol
      Real*8 cen1(1:3), cen2(1:3), Occ(1:nTot),
     &       PrEl(1:nTot,1:(lpole+1)*(lpole+2)/2),
     &       PrNu(1:(lpole+1)*(lpole+2)/2)
      Real*8 tmat(1:(lpole+1)*(lpole+2)/2,1:(lpole+1)*(lpole+2)/2),
     &       temp(1:(lpole+1)*(lpole+2)/2)
      Character*(lmax) labsAug(1:(lpole+1)*(lpole+2)/2+1)
      Real*8 PrElAug(1:nTot,1:(lpole+1)*(lpole+2)/2+1),
     &       PrNuAug(1:(lpole+1)*(lpole+2)/2+1)
      Real*8 Molecular_Charge
      Save Molecular_Charge
      Data Molecular_Charge/0.0D0/
      Logical StoreInfo, Reduce_Prt
      External Reduce_Prt
*                                                                      *
************************************************************************
*                                                                      *
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0
*                                                                      *
************************************************************************
*                                                                      *
*     Some properties can be calculated at many, many centers,
*     and writing all values through Add_Info affects performance,
*     those will be deactivated and the summation is printed by the
*     calling function.
*     This only affects the call to Add_Info, otherwise the properties
*     are calculated and printed normally
*
      StoreInfo=.True.
*                                                                      *
************************************************************************
*                                                                      *
*
*     decipher the operator label:oplab
*
      oplab=qplab
      Call UpCase(oplab)
      lab4=oplab(1:4)
      If (lab4.eq.'MLTP') Then
         If (lpole.lt.0) Then
            Return
         Else
            Go To 200
         End If
      End If
      If (lab4(1:2).eq.'EF') Go To 300
      If (lab4.eq.'DMS ') Go To 500
      If (lab4(1:3).eq.'PAM') Go To 600
      If (lab4(1:3).eq.'CNT') Go To 700
      If (lab4.eq.'VELO') Return
      If (lab4.eq.'ANGM') Return
*
*     invalid label supplied
*
      Write (6,'(//1x,a,a8,a//)')
     &' The label: *',oplab,'* is not a valid label ... stop'
      Call Quit_OnUserError()
*                                                                      *
************************************************************************
*                                                                      *
*     Multipole moment section ... generate labels for printing
*
  200 Continue
      If (lPole.gt.lMax) Then
         Write(6,*) 'Prop: lPole.gt.lMax'
         Write(6,*) 'lPole=',lPole
         Write(6,*) 'Increase lMax and recompile!'
         Call Abend()
      End If
      ilab=0
      Do ix=lpole,0,-1
         Do iy=lpole-ix,0,-1
            iz=lpole-ix-iy
            ilab=ilab+1
            lab='                '
            Do izz=lmax,lmax-iz+1,-1
               lab(izz:izz)='Z'
            End Do
            Do iyy=lmax-iz,lmax-iz-iy+1,-1
               lab(iyy:iyy)='Y'
            End Do
            Do ixx=lmax-iz-iy,lmax-lpole+1,-1
               lab(ixx:ixx)='X'
            End Do
            labs(ilab)=lab
         End Do
      End Do
*
      maxlab=ilab
      Call GetMem('PrTot','Allo','Real',ipPrTot,maxlab)
*
*     Print cartesian moments
*
*----------------------------------------------------------------------*
      If (iPL.eq.2.and.Short) Then
*----------------------------------------------------------------------*

         Do i = 1, MaxLab
            Work(ipPrTot+i-1)=PrNu(i)-PrEl(1,i)
         End Do
*
*----    New style output
*
         Line=' '
         If (lPole.eq.0) Then
            Line='Charge (e):'
            Fact=1.0D0
         Else If (lPole.eq.1) Then
            Line='Dipole Moment (Debye):'
            Fact=Debye
         Else If (lPole.eq.2) Then
            Line='Quadrupole Moment (Debye*Ang):'
            Fact=Debye*Angstrom
         Else If (lPole.eq.3) Then
            Line='Octupole Moment (Debye*Ang**2):'
            Fact=Debye*Angstrom**2
         Else If (lPole.eq.4) Then
            Line='Hexadecapole Moment (Debye*Ang**3):'
            Fact=Debye*Angstrom**3
         Else
            Line=''
            If (lpole.le.9) Then
               Write (Line,'(I1)') lPole
               iSt=2
            Else
               Write (Line,'(I2)') lPole
               iSt=3
            End If
            Line(iSt:iSt+26)='th-pole Moment (Debye*Ang**'
            iSt=iSt+27
            If (lpole.le.10) Then
               Write(Line(iSt:iSt),'(I1)') lpole-1
               iSt=iSt+1
            Else
               Write(Line(iSt:iSt+1),'(I2)') lpole-1
               iSt=iSt+2
            End If
            Line(iSt:iSt+2)='):'
            Fact=Debye*Angstrom**(lPole-1)
         End If
         Write(6,'(6X,A)') Line(:mylen(Line))
         If (lpole.gt.0) Then
            Write (6,'(6X,A,3F10.4)') 'Origin of the operator (Ang)=',
     &            (cen1(i)*Angstrom,i=1,3)
         End If
         If (lPole.eq.0) Then
            tmp=Work(ipPrTot)
            Write (6,'(6X,A,A,F10.4)')
     &                       labs(1),'=',Work(ipPrTot  )*Fact
            Molecular_Charge=Work(ipPrTot  )*Fact
         Else If (lPole.eq.1) Then
            tmp=Sqrt(Work(ipPrTot  )**2
     &              +Work(ipPrTot+1)**2
     &              +Work(ipPrTot+2)**2)
            Write (6,'(4X,4(A,A,ES12.4))')
     &                       labs(1),'=',Work(ipPrTot  )*Fact,
     &                       labs(2),'=',Work(ipPrTot+1)*Fact,
     &                       labs(3),'=',Work(ipPrTot+2)*Fact,
     &            '           Total','=',tmp*Fact
            If (Abs(Molecular_Charge).gt.0.90D0) Then
               Write(6,'(6X,A)') 'Center of Charge (Ang)'
               X_Coor=Angstrom*(Work(ipPrTot  )/Molecular_Charge)
               Y_Coor=Angstrom*(Work(ipPrTot+1)/Molecular_Charge)
               Z_Coor=Angstrom*(Work(ipPrTot+2)/Molecular_Charge)
               Write (6,'(6X,3(A,A,F14.8))')
     &                       labs(1),'=',X_Coor,
     &                       labs(2),'=',Y_Coor,
     &                       labs(3),'=',Z_Coor
               Molecular_Charge=Zero
            End If
            Call Put_DArray('Dipole moment',Work(ipPrTot),3)
c            Call peek_iScalar('xml opened',isopen)
c            If(isopen.eq.1) Then
               Call xml_dDump('dipole','Dipole moment','Debye',1,
     &                        Work(ipPrTot),3,1)
c            End If
         Else If (lPole.ge.2) Then
            ip_=ipPrTot
            tmp=0.0D0
            Do i = 0, Maxlab-1
               tmp=Max(tmp,ABS(Work(ipPrTot+i)))
            End Do
            ip_=ipPrTot
            Do i = 1, maxlab, 4
               jMax=min(maxlab-i,3)
               Write (6,'(4X,4(A,A,ES12.4))')
     &          (labs(i+j),'=',Work(ip_+j)*Fact,j=0,jMax)
               ip_ = ip_ + 4
            End Do
         End If
         If (lpole.ge.2.and.lpole.le.4) Then
*
*           Transform cartesian moments to multipole moments
*
            inp=0
            Call Tmltpl(inp,lpole,maxlab,labs,1,PrNu,tmat,temp)
            inp=1
            Call Tmltpl(inp,lpole,maxlab,labs,nTot,PrEl,tmat,temp)
            Do i = 1, MaxLab
               Work(ipPrTot+i-1)=PrNu(i)-PrEl(1,i)
            End Do
*
            If (lPole.ge.3) Then
               Write(6,'(6X,A,I1,A)') 'In traceless form (Debye*Ang**',
     &              (lPole-1),')'
            Else
               Write(6,'(6X,A,I1,A)') 'In traceless form (Debye*Ang)'
            End If
            ip_=ipPrTot
            Do i = 1, maxlab, 4
               jMax=min(maxlab-i,3)
               Write (6,'(4X,4(A,A,ES12.4))')
     &          (labs(i+j),'=',Work(ip_+j)*Fact,j=0,jMax)
               ip_ = ip_ + 4
            End Do
*
         End If
*
*----------------------------------------------------------------------*
      Else If (iPL.ge.3.or.(.Not.Short.and.iPL.eq.2)) Then
*----------------------------------------------------------------------*
*
*----    Old style output
*
         If (lpole.eq.0) lab5=' 0-th'
         If (lpole.eq.1) lab5=' 1-st'
         If (lpole.eq.2) lab5=' 2-nd'
         If (lpole.eq.3) lab5=' 3-rd'
         If (lpole.gt.3) Then
           lab3='-th'
           Write (lab5,'(i2,a3)') lpole,lab3
         End If
         Write (6,'(//6x,a5,a,3(f12.8,a))') lab5,
     &         ' cartesian moments: origin at (',
     &         cen1(1),',',cen1(2),',',cen1(3),')'
         Write (6,'(6x,76(''-''))')
         sig=-One
         Call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,
     &              maxlab,labs,Work(ipPrTot),iPL,0,ifallorb)
         If (lpole.eq.1) Then
            Write (6,'(6x,76(''-''))')
            Write(6,'(6x,a,3f16.8,3x,a)')   'Total             ',
     &               (Work(ipPrTot+j)*Debye,j=0,2), 'Debye'
            Call Put_DArray('Dipole moment',Work(ipPrTot),3)
         End If
*
         If (lpole.gt.1.and.lpole.le.4) Then
           Write (6,'(//6x,a,i2,a,3(f12.8,a))') 'Cartesian ',lpole,
     &            '-pole moment: origin at (',
     &            cen1(1),',',cen1(2),',',cen1(3),')'
           Write (6,'(6x,76(''-''))')
*
*          Transform cartesian moments to multipole moments
*
           inp=0
           Call Tmltpl(inp,lpole,maxlab,labs,1,PrNu,tmat,temp)
           inp=1
           Call Tmltpl(inp,lpole,maxlab,labs,nTot,PrEl,tmat,temp)
*
*          Print l-pole cartesian moments
*
           sig=-One
           Call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,
     &                maxlab,labs,Work(ipPrTot),iPL,0,ifallorb)
         End If
*
*----------------------------------------------------------------------*
      Else
*----------------------------------------------------------------------*
         Do i = 1, MaxLab
            Work(ipPrTot+i-1)=PrNu(i)-PrEl(1,i)
         End Do
         If (lpole.eq.1)
     &      Call Put_DArray('Dipole moment',Work(ipPrTot),3)
         If (lpole.ge.2.and.lpole.le.4) Then
*
*           Transform cartesian moments to multipole moments
*
            inp=0
            Call Tmltpl(inp,lpole,maxlab,labs,1,PrNu,tmat,temp)
            inp=1
            Call Tmltpl(inp,lpole,maxlab,labs,nTot,PrEl,tmat,temp)
            Do i = 1, MaxLab
               Work(ipPrTot+i-1)=PrNu(i)-PrEl(1,i)
            End Do
         End If
*----------------------------------------------------------------------*
      End If ! iPL
*----------------------------------------------------------------------*
      Go To 999
*                                                                      *
************************************************************************
*                                                                      *
*     electric field section
*
  300 Continue
      Read (oplab,'(a3,i5)') lab3,icen
*
      If (lab3.eq.'EF0') Then
         MaxLab=1
*        set labels
         labs(1)='                '
*        Print cartesian components of the electric field gradient
*        tensor at the given centre
*
         If (iPL.ge.3.or.(.Not.Short.and.iPL.eq.2)) Then
           Write (6,'(//6x,a,i5,1x,a,3(f12.8,a))')
     &          ' Electric potential:  centre no.',icen,'(',
     &           cen1(1),',',cen1(2),',',cen1(3),')'
           Write (6,'(6x,72(''-''))')
         Else
           If (icen.eq.1) Then
             Write(6,'(//6X,A)') 'Electric potential:'
           End If
         End If
         sig=-One
      End If
      If (lab3.eq.'EF1') Then
         MaxLab=3
*        set labels
         labs(1)='               X'
         labs(2)='               Y'
         labs(3)='               Z'
*        Print cartesian components of the electric field vector
*        at the given centre
*
         If (iPL.ge.3.or.(.Not.Short.and.iPL.eq.2)) Then
           Write (6,'(//6x,a,i5,1x,a,3(f12.8,a))')
     &            ' Electric field:  centre no.',icen,'(',
     &             cen1(1),',',cen1(2),',',cen1(3),')'
           Write (6,'(6x,72(''-''))')
         Else
           If (icen.eq.1) Then
             Write(6,'(//6X,A)') 'Electric field:'
             Write(6,'(5X,6A16)') (labs(i),i=1,MaxLab)
           End If
         End If
         sig=+One
      End If
      If (lab3.eq.'EF2') Then
*        Seven components because we add r*r to the "normal" 6
         MaxLab=7
*        set labels
         labs(1)='  (2*XX-YY-ZZ)/2'
         labs(2)='          1.5*XY'
         labs(3)='          1.5*XZ'
         labs(4)='  (2*YY-ZZ-XX)/2'
         labs(5)='          1.5*YZ'
         labs(6)='  (2*ZZ-XX-YY)/2'
*        Actually, r*r is already stored as the 6th component
*        we now move it to the 7th using the "augmented" arrays
         Do j=1,5
           Do iOcc=1,nTot
             PrElAug(iOcc,j)=PrEl(iOcc,j)
           End Do
           PrNuAug(j)=PrNu(j)
           labsAug(j)=labs(j)
         End Do
         Do iOcc=1,nTot
*          Generate the actual value of the 6th component
           PrElAug(iOcc,6)=-PrEl(iOcc,1)-PrEl(iOcc,4)
           PrElAug(iOcc,7)=PrEl(iOcc,6)
         End Do
         PrNuAug(6)=PrNu(6)
         PrNuAug(7)=Zero
         labsAug(6)=labs(6)
         labsAug(7)='     RR=XX+YY+ZZ'
*
*        Print cartesian components of the electric field gradient
*        tensor at the given centre
*
         If (iPL.ge.3.or.(.Not.Short.and.iPL.eq.2)) Then
           Write (6,'(//6x,a,i5,1x,a,3(f12.8,a))')
     &          ' Electric field gradient:  centre no.',icen,'(',
     &           cen1(1),',',cen1(2),',',cen1(3),')'
           Write (6,'(6x,78(''-''))')
         Else
           If (icen.eq.1) Then
             Write(6,'(//6X,A)') 'Electric field gradient:'
             Write(6,'(5X,6A16)') (labsAug(i),i=1,MaxLab)
           End If
         End If
         sig=+One
      End If
      Call GetMem('PrTot','Allo','Real',ipPrTot,maxlab)
*
*     Print the values using "augmented" arrays if needed
*
      If (Maxlab.eq.7) Then
        Call Prout(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrElAug,PrNuAug,
     &             maxlab,labsAug,Work(ipPrTot),iPL,icen,ifallorb)
        MaxLab=6 ! Reset so call to Add_Info is correct!
*
      Else
        Call Prout(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,
     &             maxlab,labs,Work(ipPrTot),iPL,icen,ifallorb)
      End If
*
      If (lab3.eq.'EF2') Then
         Tmp = Work(ipPrTot+2)
         Work(ipPrTot+2)=Work(ipPrTot+3)
         Work(ipPrTot+3)=Tmp
         If (iPL.ge.3.or.(.Not.Short.and.iPL.eq.2))
     &      Call Print_EigenValues(Work(ipPrTot),3)
         Tmp = Work(ipPrTot+2)
         Work(ipPrTot+2)=Work(ipPrTot+3)
         Work(ipPrTot+3)=Tmp
      End If
*
*     do not write the different electric field components through Add_Info
      StoreInfo=.False.
      Go To 999
*                                                                      *
************************************************************************
*                                                                      *
*     diamagnetic shielding section
*
  500 Continue
      Read (oplab,'(a4,i2,i2)') lab4,icen2,icen1
*
      maxlab=9
      Call GetMem('PrTot','Allo','Real',ipPrTot,maxlab)
*
*     set labels
      labs(1)='   (YO*YG+ZO*ZG)'
      labs(2)='         (XO*YG)'
      labs(3)='         (XO*ZG)'
      labs(4)='         (YO*XG)'
      labs(5)='   (XO*XG+ZO*ZG)'
      labs(6)='         (YO*ZG)'
      labs(7)='         (ZO*XG)'
      labs(8)='         (ZO*YG)'
      labs(9)='   (XO*XG+YO*YG)'
*
*     Print cartesian components of the diamagnetic shielding
*     tensor at the given centre (O=cen1) with the gauge ori-
*     gin a centre G=cen2
*
      Write (6,'(//6x,a,i3,1x,a,3(f12.8,a)/1x,a,3(f12.8,a))')
     &       ' Diamagnetic shielding:   centre no.',icen1,'(',
     &       cen1(1),',',cen1(2),',',cen1(3),')',
     &       '                       gauge origin at (',
     &       cen2(1),',',cen2(2),',',cen2(3),')'
      Write (6,'(6x,78(''-''))')
      sig=+One
      Call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,
     &           labs,Work(ipPrTot),iPL,0,ifallorb)
*                                                                      *
************************************************************************
*                                                                      *
*     PAM section ... generate labels for printing
*
  600 Continue
      ilab=0
      Do ix=lpole,0,-1
         Do iy=lpole-ix,0,-1
            iz=lpole-ix-iy
            ilab=ilab+1
            lab='                '
            Do izz=lmax,lmax-iz+1,-1
               lab(izz:izz)='Z'
            End Do
            Do iyy=lmax-iz,lmax-iz-iy+1,-1
               lab(iyy:iyy)='Y'
            End Do
            Do ixx=lmax-iz-iy,lmax-lpole+1,-1
               lab(ixx:ixx)='X'
            End Do
            labs(ilab)=lab
         End Do
      End Do
*
      maxlab=ilab
      Call GetMem('PrTot','Allo','Real',ipPrTot,maxlab)
*
*     Print cartesian moments
*
      If (lpole.eq.0) lab5=' 0-th'
      If (lpole.eq.1) lab5=' 1-st'
      If (lpole.eq.2) lab5=' 2-nd'
      If (lpole.eq.3) lab5=' 3-rd'
      If (lpole.gt.3) Then
        lab3='-th'
        Write (lab5,'(i2,a3)') lpole,lab3
      End If
      Write (6,'(//6x,a5,a,3(f12.8,a))') lab5,
     &      ' cartesian moments: origin at (',
     &      cen1(1),',',cen1(2),',',cen1(3),')'
      Write (6,'(6x,76(''-''))')
      sig=One
      Call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,
     &           labs,Work(ipPrTot),iPL,0,ifallorb)
*
      If (lpole.gt.1.and.lpole.le.4) Then
        Write (6,'(//6x,a,i2,a,3(f12.8,a))') 'Cartesian ',lpole,
     &         '-pole moment: origin at (',
     &         cen1(1),',',cen1(2),',',cen1(3),')'
        Write (6,'(6x,76(''-''))')
*
*
*
        inp=0
        Call Tmltpl(inp,lpole,maxlab,labs,1,PrNu,tmat,temp)
        inp=1
        Call Tmltpl(inp,lpole,maxlab,labs,nTot,PrEl,tmat,temp)
*
*       Print 0-pole PAM integrals (sig=1 in opposite multipole moments)
*
        sig=One
        Call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,
     &             maxlab,labs,Work(ipPrTot),iPL,0,ifallorb)
      End If
*      Go To 999
*                                                                      *
************************************************************************
*                                                                      *
*     Contact term section
*
  700 Continue
      Read (oplab,'(a3,i5)') lab3,icen
*
      maxlab=1
      Call GetMem('PrTot','Allo','Real',ipPrTot,maxlab)
*
*     set labels
      labs(1)='      Delta(R-C)'
*
      IF (iPL.ge.3.or.(.Not.Short.and.iPL.eq.2)) Then
        Write (6,'(//6x,a,i5,1x,a,3(f12.8,a))')
     &       ' Contact term:  centre no.',icen,'(',
     &        cen1(1),',',cen1(2),',',cen1(3),')'
        Write (6,'(6x,78(''-''))')
      Else
        If (icen.eq.1) Then
          Write(6,'(//6X,A)') 'Contact term:'
          Write(6,'(5X,6A16)') (labs(i),i=1,MaxLab)
        End If
      End If
      sig=+One
      Call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,
     &           labs,Work(ipPrTot),iPL,icen,ifallorb)
*
*     do not write the contact term through Add_Info
      StoreInfo=.False.
*                                                                      *
************************************************************************
*                                                                      *
  999 Continue
      iTol=5
      iTol_E0=8
      iTol_E1=Cho_X_GetTol(iTol_E0)
      iTol = INT( DBLE(iTol) * DBLE(iTol_E1)/DBLE(iTol_E0))
      If (StoreInfo) Call Add_Info(OpLab,Work(ipPrTot),maxlab,iTol)
      Call GetMem('PrTot','Free','Real',ipPrTot,maxlab)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994-1997, Niclas Forsberg                             *
!               1997,2000, Per Ake Malmqvist                           *
!***********************************************************************

!module VibMod

!  Contains:
!    VibFreq        (AtCoord,InterVec,Mass,Hess,harmfreq,eigenVec,qMat,PED,D3,D4,x_anharm,anharmfreq,max_term)
!    CalcS          (AtCoord,InterVec,S)
!    BondStr        (R,i1,i2,j,S)
!    AngBend        (R1,R2,i1,i2,i3,j,S)
!    LinBend        (R1,R2,i1,i2,i3,j,S)
!    Torsion        (R1,R2,R3,i1,i2,i3,i4,j,S)
!    OutOfPl        (R1,R2,R3,i1,i2,i3,i4,j,S)
!    CalcG          (G,Mass,S)
!    NaNChk         (X,k,i,j)
!    Freq_mula      (Hess,G,V,Lambda,B,qMat)
!    CalcGprime     (Gprime,Mass,xvec,InterVec,AtCoord,NumOfAt)
!    CalcGdbleprime (Gdbleprime,Mass,xvec,InterVec,AtCoord,NumOfAt)
!    Anharm         (eigenVec,harmfreq,D3,D4,Gprime,Gdbleprime,x)
!    TransEnergy    (x_anharm,harmfreq,level1,level2)  Result(energy)
!    AnharmonicFreq (x_anharm,harmfreq,anharmfreq)
!    Int_to_Cart1   (InterVec,xvec,AtCoord)
!    Cart_To_Int0   (InterVec,AtCoord,xvec)
!    Cart_To_Int1   (InterVec,AtCoord,xvec,BMatrix)
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

!contains

subroutine VibFreq(AtCoord,xvec,InterVec,Mass,Hess,G,Gprime,Gdbleprime,harmfreq,eigenVec,qMat,PED,D3,D4,x_anharm,anharmfreq, &
                   max_term,nOsc,NumOfAt)
!  Purpose:
!    Calculates the vibrational frequencies of a molecule.
!
!  Input:
!    InterVec   : Integer array
!    Mass       : Real array - masses of the atoms.
!    xvec       : Real array - geometry of molecule in internal coordinates.
!    Hess       : Real two dimensional array - force constant matrix.
!    D3         : Real three dimensional array - third derivatives of potential surface.
!    D4         : Real four dimensional array - fourth derivatives of potential surface.
!    max_term   : Integer - highest power of term in polynomial fit.
!
!  Output:
!    AtCoord    : Real two dimensional array - cartesian coordinates of the atoms.
!    harmfreq   : Real array - contains harmonical frequencies.
!    eigenVec   : Real two dimensional array - contains eigenvectors.
!    qMat       : Real two dimensional array - cartesian displacement vectors.
!    PED        : Real three dimensional array - potential energy distribution.
!    x_anharm   : Real two dimensional array - anharmonicity constants.
!    anharmfreq : Real array - contains anharmonical frequencies.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use mula_global, only: ngdim
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: InterVec(*), max_term, nOsc, NumOfAt
real(kind=wp), intent(inout) :: AtCoord(3,NumOfAt)
real(kind=wp), intent(out) :: xvec(nosc), G(nosc,nosc), Gprime(ngdim,ngdim,ngdim), Gdbleprime(ngdim,ngdim,ngdim,ngdim), &
                              harmfreq(nosc), eigenVec(nosc,nosc), qMat(3*NumOfAt,nOsc), PED(nosc,nosc,nosc), x_anharm(nosc,nOsc), &
                              anharmfreq(nosc)
real(kind=wp), intent(in) :: Mass(NumOfAt), Hess(nOsc,nOsc), D3(ngdim,ngdim,ngdim), D4(ngdim,ngdim,ngdim,ngdim)
integer(kind=iwp) :: NumInt
real(kind=wp) :: dh
real(kind=wp), allocatable :: B(:,:), Lambda(:), V(:,:)

! Initialize.
!D write(u6,*) ' Entered VIBFREQ.'
NumInt = nOsc
!D write(u6,*) ' NumInt:',NumInt
!D write(u6,*) ' NumOfAt:',NumOfAt
call mma_allocate(V,NumInt,NumInt,label='V')
call mma_allocate(B,3*NumOfAt,NumInt,label='B')

call mma_allocate(Lambda,NumInt,label='Lambda')

! Transform coordinates.
xvec(:) = Zero
!D write(u6,*) ' VIBFREQ, calling Cart_to_Int0.'
call Cart_To_Int0(InterVec,AtCoord,xvec,NumOfAt,NumInt)
!D write(u6,*) ' VIBFREQ, back from Cart_to_Int0.'
!D write(u6,*) ' xvec:'
!D write(u6,'(5f16.8)') xvec

! Calculate the contributions to the B matrix for each internal coordinate.
B(:,:) = Zero
!D write(u6,*) ' VIBFREQ, calling CalcS.'
call CalcS(AtCoord,InterVec,B,NumInt,NumOfAt)
!D write(u6,*) ' VIBFREQ, back from CalcS.'

! Calculate G matrix and first and second derivatives of the G matrix.
!D write(u6,*) ' VIBFREQ, calling CalcG.'
call CalcG(G,Mass,B,NumInt,NumOfAt)
!D Write(u6,*) ' VIBFREQ, back from CalcG.'
Gprime(:,:,:) = Zero
Gdbleprime(:,:,:,:) = Zero
if (max_term > 2) then
  dh = 1.0e-3_wp
  call CalcGprime(Gprime,Mass,xvec,InterVec,AtCoord,NumOfAt,dh,NumInt)
  dh = 1.0e-2_wp
  call CalcGdbleprime(Gdbleprime,Mass,xvec,InterVec,AtCoord,NumOfAt,dh,NumInt)
end if

! Given Hess and G, calculate the eigenvalues and eigenvectors of G*Hess.
!D write(u6,*) ' VIBFREQ, calling Freq.'
call Freq_mula(Hess,G,V,Lambda,B,qMat,nOsc,NumOfAt)
!D write(u6,*) ' VIBFREQ, back from Freq.'
!D write(u6,*) ' Lambda:'
!D write(u6,'(5f16.8)') Lambda

! Calculate harmonic frequencies.

harmfreq(:) = sqrt(abs(Lambda))
!D write(u6,*) ' harmfreq:'
!D write(u6,'(5f16.8)') harmfreq
eigenVec(:,:) = V

! Anharmonicity calculations (if we have third and possibly fourth
! derivatives). First calculation of the anharmonicity constants and
! then calculation of the fundamental frequencies.
x_anharm(:,:) = Zero
if (max_term > 2) then
  call Anharm(eigenVec,harmfreq,D3,D4,Gprime,Gdbleprime,x_anharm,nOsc)
  call AnharmonicFreq(x_anharm,harmfreq,anharmfreq,nOsc)
end if

! Calculate potential energy distribution.
call PotDist(Hess,V,Lambda,PED,NumInt,nOsc)

! Free memory space of B, G and V.
call mma_deallocate(B)
call mma_deallocate(V)
call mma_deallocate(Lambda)

end subroutine VibFreq

subroutine BondStr(R,i1,i2,j,S,NumOfAt,NumInt)
!  Purpose:
!    Calculate contribution to the S-matrix due to bond stretching.
!
!  Input:
!    R        : Array of Real -  contains the cartesian coordinates of the bond.
!    i1,i2    : Integer - the number of the atom.
!    j        : Integer - the number of the internal coordinate.
!
!  Output:
!    S        : Real three dimensional array - the contributions to S for the parameters specified in the input.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1994.

use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: R(3)
integer(kind=iwp), intent(in) :: i1, i2, j, NumOfAt, NumInt
real(kind=wp), intent(inout) :: S(3,NumOfAt,NumInt)
integer(kind=iwp) :: k
real(kind=wp) :: SR

! Contributions to S.
SR = sqrt(R(1)**2+R(2)**2+R(3)**2)
do k=1,3
  S(k,i1,j) = -R(k)/SR
  S(k,i2,j) = -S(k,i1,j)
  call NaNChk(S(k,i1,j),k,i1,j)
  call NaNChk(S(k,i2,j),k,i1,j)
end do

end subroutine BondStr

subroutine NaNChk(X,k,i,j)

use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: X
integer(kind=iwp), intent(in) :: k, i, j
character(len=16) :: str1, str2

write(str2,'(G16.8)') X
call Normalize(str2,str1)
if (str1(1:3) == 'NAN') then
  write(u6,*) ' CalcS subroutine produced Not-a-Number!'
  write(u6,*) ' Internal coordinate nr. j=',j
  write(u6,*) ' Atom nr.                i=',i
  write(u6,*) ' Component               k=',k
  write(u6,*) ' S(k,i,j)=',X
end if

return

end subroutine NaNChk

subroutine AngBend(R1,R2,i1,i2,i3,j,S,NumOfAt,NumInt)
!  Purpose:
!    Calculate contribution to the S-matrix due to valence angle bending.
!
!  Input:
!    R1,R2    : Array of Real - contains the cartesian coordinates of the bond.
!    i1,i2,i3 : Integer - the number of the atom.
!    j        : Integer - the number of the internal coordinate.
!
!  Output:
!    S        : Real three dimensional array - the contributions to S for the parameters specified in the input.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1994.

use Constants, only: One
use Definitions, only: wp, iwp, r8

implicit none
real(kind=wp), intent(in) :: R1(3), R2(3)
integer(kind=iwp), intent(in) :: i1, i2, i3, j, NumOfAt, NumInt
real(kind=wp), intent(inout) :: S(3,NumOfAt,NumInt)
integer(kind=iwp) :: k
real(kind=wp) :: CosTheta, F1, F2, F3, F4, F5, NR1(3), NR2(3), SinTheta, SR1, SR2, Theta
real(kind=r8), external :: dDot_

! Unit vectors.
SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
do k=1,3
  NR1(k) = R1(k)/SR1
  NR2(k) = R2(k)/SR2
end do

! Angle Theta.
Theta = acos(dDot_(3,NR1,1,NR2,1))
CosTheta = cos(Theta)
SinTheta = sin(Theta)

! Contributions to S.
F1 = One/(SR1*SinTheta)
S(1,i1,j) = (CosTheta*NR1(1)-NR2(1))*F1
S(2,i1,j) = (CosTheta*NR1(2)-NR2(2))*F1
S(3,i1,j) = (CosTheta*NR1(3)-NR2(3))*F1

F2 = SR1-SR2*CosTheta
F3 = SR2-SR1*CosTheta
F4 = F1/SR2
S(1,i2,j) = (F2*NR1(1)+F3*NR2(1))*F4
S(2,i2,j) = (F2*NR1(2)+F3*NR2(2))*F4
S(3,i2,j) = (F2*NR1(3)+F3*NR2(3))*F4

F5 = One/(SR2*SinTheta)
S(1,i3,j) = (CosTheta*NR2(1)-NR1(1))*F5
S(2,i3,j) = (CosTheta*NR2(2)-NR1(2))*F5
S(3,i3,j) = (CosTheta*NR2(3)-NR1(3))*F5

call NaNChk(S(1,i1,j),1,i1,j)
call NaNChk(S(2,i1,j),2,i1,j)
call NaNChk(S(3,i1,j),3,i1,j)
call NaNChk(S(1,i2,j),1,i2,j)
call NaNChk(S(2,i2,j),2,i2,j)
call NaNChk(S(3,i2,j),3,i2,j)
call NaNChk(S(1,i3,j),1,i3,j)
call NaNChk(S(2,i3,j),2,i3,j)
call NaNChk(S(3,i3,j),3,i3,j)

end subroutine AngBend

subroutine LinBend(R1,R2,i1,i2,i3,j,S,NumOfAt,NumInt)
!  Purpose:
!    Calculate contribution to the S-matrix due to valence angle bending for a linear molecule.
!
!  Input:
!    R1,R2    : Array of Real - contains the cartesian coordinates of the bond.
!    i1,i2,i3 : Integer - the number of the atom.
!    j        : Integer - the number of the internal coordinate.
!
!  Output:
!    S        : Real three dimensional array - the contributions to S for the parameters specified in the input.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1994.

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: R1(3), R2(3)
integer(kind=iwp), intent(in) :: i1, i2, i3, j, NumOfAt, NumInt
real(kind=wp), intent(inout) :: S(3,NumOfAt,NumInt)
real(kind=wp) :: F1, F2, SR1, SR2

! Length of vectors.
SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)

! Contributions to S.
F1 = One/SR1
F2 = One/SR2

S(1,i1,j) = F1
S(2,i1,j) = Zero
S(3,i1,j) = Zero

S(1,i2,j) = -F1-F2
S(2,i2,j) = Zero
S(3,i2,j) = Zero

S(1,i3,j) = F2
S(2,i3,j) = Zero
S(3,i3,j) = Zero

S(1,i1,j+1) = Zero
S(2,i1,j+1) = F1
S(3,i1,j+1) = Zero

S(1,i2,j+1) = Zero
S(2,i2,j+1) = -F1-F2
S(3,i2,j+1) = Zero

S(1,i3,j+1) = Zero
S(2,i3,j+1) = F2
S(3,i3,j+1) = Zero

call NaNChk(S(1,i1,j),1,i1,j)
call NaNChk(S(2,i1,j),2,i1,j)
call NaNChk(S(3,i1,j),3,i1,j)
call NaNChk(S(1,i2,j),1,i2,j)
call NaNChk(S(2,i2,j),2,i2,j)
call NaNChk(S(3,i2,j),3,i2,j)
call NaNChk(S(1,i3,j),1,i3,j)
call NaNChk(S(2,i3,j),2,i3,j)
call NaNChk(S(3,i3,j),3,i3,j)

end subroutine LinBend

subroutine Torsion(R1,R2,R3,i1,i2,i3,i4,j,S,NumOfAt,NumInt)
!  Purpose:
!    Calculate contribution to the S-matrix due to torsion.
!
!  Input:
!    R1,R2,R3 : Array of Real - contains the cartesian coordinates of the bond.
!    i1,i2,
!    i3,i4    : Integer - the number of the atom.
!    j        : Integer - the number of the internal coordinate.
!
!  Output:
!    S        : Real three dimensional array - the contributions to S for the parameters specified in the input.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1994.

use Constants, only: One
use Definitions, only: wp, iwp, r8

implicit none
real(kind=wp), intent(in) :: R1(3), R2(3), R3(3)
integer(kind=iwp), intent(in) :: i1, i2, i3, i4, j, NumOfAt, NumInt
real(kind=wp), intent(inout) :: S(3,NumOfAt,NumInt)
integer(kind=iwp) :: k
real(kind=wp) :: CosTheta1, CosTheta2, F1, F10, F11, F12, F2, F3, F4, F5, F6, F7, F8, F9, NR1(3), NR2(3), NR3(3), SinTheta1, &
                 SinTheta2, SR1, SR2, SR3, Theta1, Theta2
real(kind=r8), external :: dDot_

! Unit vectors.
SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
SR3 = sqrt(R3(1)**2+R3(2)**2+R3(3)**2)
do k=1,3
  NR1(k) = R1(k)/SR1
  NR2(k) = R2(k)/SR2
  NR3(k) = R3(k)/SR3
end do

! Angles Theta1 and Theta2.
Theta1 = acos(-dDot_(3,NR1,1,NR2,1))
Theta2 = acos(-dDot_(3,NR2,1,NR3,1))
CosTheta1 = cos(Theta1)
SinTheta1 = sin(Theta1)
CosTheta2 = cos(Theta2)
SinTheta2 = sin(Theta2)

! Contributions to S.
F1 = One/(SR1*(SinTheta1)**2)
F2 = NR1(2)*NR2(3)-NR1(3)*NR2(2)
F3 = NR1(3)*NR2(1)-NR1(1)*NR2(3)
F4 = NR1(1)*NR2(2)-NR1(2)*NR2(1)
S(1,i1,j) = -F2*F1
S(2,i1,j) = -F3*F1
S(3,i1,j) = -F4*F1

F5 = (SR2-SR1*CosTheta1)/(SR1*SR2*(SinTheta1)**2)
F6 = CosTheta2/(SR2*(SinTheta2)**2)
F7 = NR3(2)*NR2(3)-NR3(3)*NR2(2)
F8 = NR3(3)*NR2(1)-NR3(1)*NR2(3)
F9 = NR3(1)*NR2(2)-NR3(2)*NR2(1)
S(1,i2,j) = F5*F2+F6*F7
S(2,i2,j) = F5*F3+F6*F8
S(3,i2,j) = F5*F4+F6*F9

F10 = (SR2-SR3*CosTheta2)/(SR2*SR3*SinTheta2**2)
F11 = CosTheta1/(SR2*(SinTheta1)**2)
S(1,i3,j) = F10*F7+F11*F2
S(2,i3,j) = F10*F8+F11*F3
S(3,i3,j) = F10*F9+F11*F4

F12 = One/(SR3*(SinTheta2)**2)
S(1,i4,j) = -F7*F12
S(2,i4,j) = -F8*F12
S(3,i4,j) = -F9*F12

call NaNChk(S(1,i1,j),1,i1,j)
call NaNChk(S(2,i1,j),2,i1,j)
call NaNChk(S(3,i1,j),3,i1,j)
call NaNChk(S(1,i2,j),1,i2,j)
call NaNChk(S(2,i2,j),2,i2,j)
call NaNChk(S(3,i2,j),3,i2,j)
call NaNChk(S(1,i3,j),1,i3,j)
call NaNChk(S(2,i3,j),2,i3,j)
call NaNChk(S(3,i3,j),3,i3,j)
call NaNChk(S(1,i1,j),1,i4,j)
call NaNChk(S(2,i1,j),2,i4,j)
call NaNChk(S(3,i1,j),3,i4,j)

end subroutine Torsion

subroutine OutOfPl(R1,R2,R3,i1,i2,i3,i4,j,S,NumOfAt,NumInt)
!  Purpose:
!    Calculate contribution to the S-matrix due to the angle between a bond and a plane defined by two bonds.
!
!  Input:
!    R1,R2,R3 : Array of Real - contains the cartesian coordinates of the bond.
!    i1,i2,
!    i3,i4    : Integer - the number of the atom.
!    j        : Integer - the number of the internal coordinate.
!
!  Output:
!    S        : Real three dimensional array - the contributions to S for the parameters specified in the input.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1994.

use Constants, only: One
use Definitions, only: wp, iwp, r8

implicit none
real(kind=wp), intent(in) :: R1(3), R2(3), R3(3)
integer(kind=iwp), intent(in) :: i1, i2, i3, i4, j, NumOfAt, NumInt
real(kind=wp), intent(inout) :: S(3,NumOfAt,NumInt)
integer(kind=iwp) :: k
real(kind=wp) :: CosPhi, CosTheta, Dot, F0(3), F1, F10, F11, F12, F13, F14, F15, F2, F3, F4, F5, F6, F7, F8, F9, NR1(3), NR2(3), &
                 NR3(3), Phi, SinTheta, SR1, SR2, SR3, TanPhi, Theta
real(kind=r8), external :: Ddot_

! Unit vectors.
SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
SR3 = sqrt(R3(1)**2+R3(2)**2+R3(3)**2)
do k=1,3
  NR1(k) = R1(k)/SR1
  NR2(k) = R2(k)/SR2
  NR3(k) = R3(k)/SR3
end do

! Calculation of the angle Theta.
Dot = Ddot_(3,NR2,1,NR3,1)
Theta = acos(Dot)
CosTheta = cos(Theta)
SinTheta = sin(Theta)

! Calculation of the out of plane angle Phi.
F1 = NR2(2)*NR3(3)-NR2(3)*NR3(2)
F2 = NR2(3)*NR3(1)-NR2(1)*NR3(3)
F3 = NR2(1)*NR3(2)-NR2(2)*NR3(1)
F0(1) = F1/SinTheta
F0(2) = F2/SinTheta
F0(3) = F3/SinTheta
Phi = asin(Ddot_(3,F0,1,NR1,1))
CosPhi = cos(Phi)
TanPhi = tan(Phi)

! Contributions to S.
F4 = One/(SR1*CosPhi*SinTheta)
F5 = TanPhi/SR1
S(1,i1,j) = F1*F4-NR1(1)*F5
S(2,i1,j) = F2*F4-NR1(2)*F5
S(3,i1,j) = F3*F4-NR1(3)*F5

F6 = NR3(2)*NR1(3)-NR3(3)*NR1(2)
F7 = NR3(3)*NR1(1)-NR3(1)*NR1(3)
F8 = NR3(1)*NR1(2)-NR3(2)*NR1(1)
F9 = One/(SR2*CosPhi*SinTheta)
F10 = TanPhi/(SR2*(SinTheta)**2)
S(1,i2,j) = F6*F9-NR2(1)*F10+CosTheta*F10*NR3(1)
S(2,i2,j) = F7*F9-NR2(2)*F10+CosTheta*F10*NR3(2)
S(3,i2,j) = F8*F9-NR2(3)*F10+CosTheta*F10*NR3(3)

F11 = NR1(2)*NR2(3)-NR1(3)*NR2(2)
F12 = NR1(3)*NR2(1)-NR1(1)*NR2(3)
F13 = NR1(1)*NR2(2)-NR1(2)*NR2(1)
F14 = One/(SR3*CosPhi*SinTheta)
F15 = TanPhi/(SR3*(SinTheta)**2)
S(1,i3,j) = F11*F14-NR3(1)*F15+CosTheta*F15*NR2(1)
S(2,i3,j) = F12*F14-NR3(2)*F15+CosTheta*F15*NR2(2)
S(3,i3,j) = F13*F14-NR3(3)*F15+CosTheta*F15*NR2(3)

S(1,i4,j) = -S(1,i1,j)-S(1,i2,j)-S(1,i3,j)
S(2,i4,j) = -S(2,i1,j)-S(2,i2,j)-S(2,i3,j)
S(3,i4,j) = -S(3,i1,j)-S(3,i2,j)-S(3,i3,j)

call NaNChk(S(1,i1,j),1,i1,j)
call NaNChk(S(2,i1,j),2,i1,j)
call NaNChk(S(3,i1,j),3,i1,j)
call NaNChk(S(1,i2,j),1,i2,j)
call NaNChk(S(2,i2,j),2,i2,j)
call NaNChk(S(3,i2,j),3,i2,j)
call NaNChk(S(1,i3,j),1,i3,j)
call NaNChk(S(2,i3,j),2,i3,j)
call NaNChk(S(3,i3,j),3,i3,j)
call NaNChk(S(1,i1,j),1,i4,j)
call NaNChk(S(2,i1,j),2,i4,j)
call NaNChk(S(3,i1,j),3,i4,j)

end subroutine OutOfPl

subroutine CalcS(AtCoord,InterVec,S,NumInt,NumOfAt)
!  Purpose:
!    Calculate the contribution to the S-matrix for each of the internal coordinates.
!
!  Input:
!    AtCoord  : Two dimensional Real array - contains the cartesian coordinates of the atoms.
!    InterVec : Integer array - contains the atoms that are used in the calculations of each internal coordinate.
!    S        : Real array filled with zeros.
!
!  Output:
!    S        : Real array - contains the contributions of each of the internal coordinates.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1994.

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: InterVec(*), NumInt, NumOfAt
real(kind=wp), intent(in) :: AtCoord(3,NumOfAt)
real(kind=wp), intent(inout) :: S(3,NumOfAt,NumInt)
integer(kind=iwp) :: i1, i2, i3, i4, IntType, k, n_Int
real(kind=wp) :: R(3), R1(3), R2(3), R3(3)

! Calculate the contributions to the S-matrix for each internal
! coordinate specified in the vector InterVec.
k = 1
IntType = InterVec(k)
n_Int = 1
do while (n_Int <= NumInt)
  if (IntType == 1) then
    ! Bond Stretching.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    R(:) = AtCoord(:,i2)-AtCoord(:,i1)
    call BondStr(R,i1,i2,n_Int,S,NumOfAt,NumInt)
    k = k+3
  end if
  if (IntType == 2) then
    ! Valence Angle Bending.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i3)-AtCoord(:,i2)
    call AngBend(R1,R2,i1,i2,i3,n_Int,S,NumOfAt,NumInt)
    k = k+4
  end if
  if (IntType == 3) then
    ! Linear Valence Angle.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i3)-AtCoord(:,i2)
    call LinBend(R1,R2,i1,i2,i3,n_Int-1,S,NumOfAt,NumInt)
    k = k+4
  end if
  if (IntType == 4) then
    ! Torsion.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    i4 = InterVec(k+4)
    R1(:) = AtCoord(:,i2)-AtCoord(:,i1)
    R2(:) = AtCoord(:,i3)-AtCoord(:,i2)
    R3(:) = AtCoord(:,i4)-AtCoord(:,i3)
    call Torsion(R1,R2,R3,i1,i2,i3,i4,n_Int,S,NumOfAt,NumInt)
    k = k+5
  end if
  if (IntType == 5) then
    ! Out of Plane Angle Bending.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    i4 = InterVec(k+4)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i4)
    R2(:) = AtCoord(:,i2)-AtCoord(:,i4)
    R3(:) = AtCoord(:,i3)-AtCoord(:,i4)
    call OutOfPl(R1,R2,R3,i1,i2,i3,i4,n_Int,S,NumOfAt,NumInt)
    k = k+5
  end if
  IntType = InterVec(k)
  n_Int = n_Int+1
end do

end subroutine CalcS

subroutine CalcG(G,Mass,S,NumInt,NumOfAt)
!  Purpose:
!    Calculate G-matrix.
!
!  Input:
!    Mass     : Real array - the mass of the atoms.
!    S        : Real three dimensional array - the contributions from all the internal coordinates.
!
!  Output:
!    G        : Real two dimensional array.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1994.

use Constants, only: Zero, One, uToau
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NumInt, NumOfAt
real(kind=wp), intent(out) :: G(NumInt,NumInt)
real(kind=wp), intent(in) :: Mass(NumOfAt), S(3,NumOfAt,NumInt)
integer(kind=iwp) :: i, j, k
real(kind=wp) :: GSum

do i=1,NumInt
  do j=1,NumInt
    GSum = Zero
    do k=1,NumOfAt
      GSum = GSum+(One/(uToau*Mass(k)))*(S(1,k,i)*S(1,k,j)+S(2,k,i)*S(2,k,j)+S(3,k,i)*S(3,k,j))
    end do
    G(i,j) = GSum
  end do
end do

end subroutine CalcG

subroutine Freq_mula(Hess,G,V,Lambda,B,qMat,NumInt,NumOfAt)
!  Purpose:
!    Find eigenvalues and eigenvectors of FG matrix.
!    The eigenvalues are stored in the array Lambda and the eigen-
!    vectors are stored as the columns of the matrix V.
!    The eigenvectors are then used to calculate the cartesian
!    displacements, which are stored in matrix X.
!
!  Input:
!    Hess     : Real two dimensional array -  contains the force constants expressed in internal
!    G        : Real two dimensional array.
!    B        : Real two dimensional array.
!
!  Output:
!    V        : Real two dimensional array - contains the eigenvectors of F*G as columns.
!    Lambda   : Real array - contains the eigenvalues of F*G.
!    qMat     : Real array - contains the cartesian displacements of the atoms.
!
!  Local:
!    U,Tmp    : Real two dimensional arrays.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1994.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NumInt, NumOfAt
real(kind=wp), intent(in) :: Hess(NumInt,NumInt), G(NumInt,NumInt), B(3*NumOfAt,NumInt)
real(kind=wp), intent(out) :: V(NumInt,NumInt), Lambda(NumInt), qMat(3*NumOfAt,NumInt)
real(kind=wp) :: Det
real(kind=wp), allocatable :: Temp(:,:), U(:,:)

! Solve secular equation.
call SolveSecEq(Hess,NumInt,V,G,Lambda)

! get memory space for U.
call mma_allocate(U,NumInt,NumInt,label='U')

! Copy matrix containing eigenvectors to U, because this matrix
! will be destroyed when subroutine Dool_MULA is called.
U(:,:) = V

! Calculate the cartesian diplacements, i.e. solve
!     qMat = B * ( B(T) * B )^(-1) * V.

! get memory for matrix Temp.
call mma_allocate(Temp,NumInt,NumInt,label='Temp')

call DGEMM_('T','N',NumInt,NumInt,3*NumOfAt,One,B,3*NumOfAt,B,3*NumOfAt,Zero,Temp,NumInt)
call Dool_MULA(Temp,NumInt,NumInt,U,NumInt,NumInt,Det)
call DGEMM_('N','N',3*NumOfAt,NumInt,NumInt,One,B,3*NumOfAt,U,NumInt,Zero,qMat,3*NumOfAt)

! free memory space of Temp and U.
call mma_deallocate(U)
call mma_deallocate(Temp)

end subroutine Freq_mula

subroutine CalcGprime(Gprime,Mass,xvec,InterVec,AtCoord,NumOfAt,h,NumInt)
!  Purpose:
!    Calculate first derivatives of G.
!
!  Input:
!    Mass     : Real array - the mass of the atoms.
!    xvec     : Real array - the geometry in internal coordinates.
!    InterVec : Integer array.
!    NumOfAt  : Integer - the number of atoms.
!
!  Output:
!    Gprime   : Real two dimensional array - first derivative of the inverse mass tensor G.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use mula_global, only: ngdim
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: InterVec(*), NumOfAt, NumInt
real(kind=wp), intent(out) :: Gprime(ngdim,ngdim,ngdim)
real(kind=wp), intent(in) :: Mass(NumOfAt), xvec(NumInt), h
real(kind=wp), intent(inout) :: AtCoord(3,NumOfAt)
integer(kind=iwp) :: icoord, ih, iterm
real(kind=wp) :: xtmp(NumInt)
real(kind=wp), allocatable :: Gtemp(:,:,:), Stemp(:,:,:)

! Initialize.
call mma_allocate(Stemp,3,NumOfAt,NumInt,label='Stemp')
call mma_allocate(Gtemp,NumInt,NumInt,4,label='Gtemp')

do icoord=1,NumInt
  xtmp(:) = xvec
  Gtemp(:,:,:) = Zero
  iterm = 1
  do ih=-3,3,2
    xtmp(icoord) = xvec(icoord)+real(ih,kind=wp)*h
    !call Int_To_Cart(InterVec,xtmp,AtCoord,NumOfAt,NumInt,Mass)
    call Int_to_Cart1(InterVec,xtmp,AtCoord,NumOfAt,NumInt)
    Stemp(:,:,:) = Zero

    call CalcS(AtCoord,InterVec,Stemp,NumInt,NumOfAt)
    call CalcG(Gtemp(:,:,iterm),Mass,Stemp,NumInt,NumOfAt)

    iterm = iterm+1
  end do
  Gprime(1:NumInt,1:NumInt,icoord) = (Gtemp(:,:,1)-27.0_wp*Gtemp(:,:,2)+27.0_wp*Gtemp(:,:,3)-Gtemp(:,:,4))/(48.0_wp*h)
end do
!call Int_To_Cart(InterVec,xvec,AtCoord,NumOfAt,NumInt,Mass)
call Int_to_Cart1(InterVec,xtmp,AtCoord,NumOfAt,NumInt)

call mma_deallocate(Stemp)
call mma_deallocate(Gtemp)

end subroutine CalcGprime

subroutine CalcGdbleprime(Gdbleprime,Mass,xvec,InterVec,AtCoord,NumOfAt,h,NumInt)
!  Purpose:
!    Calculate second derivatives of G.
!
!  Input:
!    Mass       : Real array - the mass of the atoms.
!    xvec       : Real array - the geometry in internal coordinates.
!    InterVec   : Integer array.
!    NumOfAt    : Integer - the number of atoms.
!
!  Output:
!    Gdbleprime : Real two dimensional array - second derivative of the inverse mass tensor G.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use mula_global, only: ngdim
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Three
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: InterVec(*), NumOfAt, NumInt
real(kind=wp), intent(out) :: Gdbleprime(ngdim,ngdim,ngdim,ngdim)
real(kind=wp), intent(in) :: Mass(NumOfAt), xvec(NumInt), h
real(kind=wp), intent(inout) :: AtCoord(3,NumOfAt)
integer(kind=iwp) :: icoord, jcoord
real(kind=wp), allocatable :: Gprime1(:,:,:), Gprime2(:,:,:), Gprime3(:,:,:), Gprime4(:,:,:), xtmp(:)

! Initialize.
call mma_allocate(xtmp,NumInt,label='xtmp')
call mma_allocate(Gprime1,NumInt,NumInt,NumInt,label='Gprime1')
call mma_allocate(Gprime2,NumInt,NumInt,NumInt,label='Gprime2')
call mma_allocate(Gprime3,NumInt,NumInt,NumInt,label='Gprime3')
call mma_allocate(Gprime4,NumInt,NumInt,NumInt,label='Gprime4')

do jcoord=1,NumInt
  xtmp(:) = xvec
  xtmp(jcoord) = xvec(jcoord)-Three*h
  call CalcGprime(Gprime1,Mass,xtmp,InterVec,AtCoord,NumOfAt,h,NumInt)
  xtmp(jcoord) = xvec(jcoord)-h
  call CalcGprime(Gprime2,Mass,xtmp,InterVec,AtCoord,NumOfAt,h,NumInt)
  xtmp(jcoord) = xvec(jcoord)+h
  call CalcGprime(Gprime3,Mass,xtmp,InterVec,AtCoord,NumOfAt,h,NumInt)
  xtmp(jcoord) = xvec(jcoord)+Three*h
  call CalcGprime(Gprime4,Mass,xtmp,InterVec,AtCoord,NumOfAt,h,NumInt)
  do icoord=1,NumInt
    Gdbleprime(1:NumInt,1:NumInt,icoord,jcoord) = &
      (Gprime1(:,:,icoord)-27.0_wp*Gprime2(:,:,icoord)+27.0_wp*Gprime3(:,:,icoord)-Gprime4(:,:,icoord))/(48.0_wp*h)
  end do
end do
!call Int_To_Cart(InterVec,xvec,AtCoord,NumOfAt,NumInt,Mass)
call Int_To_Cart1(InterVec,xvec,AtCoord,NumOfAt,NumInt)

call mma_deallocate(xtmp)
call mma_deallocate(Gprime1)
call mma_deallocate(Gprime2)
call mma_deallocate(Gprime3)
call mma_deallocate(Gprime4)

end subroutine CalcGdbleprime

subroutine Anharm(eigenVec,harmfreq,D3,D4,Gprime,Gdbleprime,x,nOsc)
!  Purpose:
!    Calculate the anharmonicity constants.
!    This routine assumes that the curvilinear coordinates are such
!    that they coincide with dimensionless normal coordinates for
!    small displacements.
!
!  Input:
!    eigenVec   : Real two dimensional array - eigenvectors.
!    harmfreq   : Real array - harmonic frequencies.
!    D3         : Real three dimensional array - cubic force constants.
!    D4         : Real four dimensional array - quartic force constants.
!    Gprime     : Real three dimensional array - first derivatives of the inverse mass tensor.
!    Gdbleprime : Real four dimensional array - second derivatives of the inverse mass tensor.
!
!  Output:
!    x          : Real two dimensional array - anharmonicity constants.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use mula_global, only: ngdim
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Four, Five, Six, Eight, Nine, Half, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOsc
real(kind=wp), intent(in) :: eigenVec(nOsc,nOsc), harmfreq(nOsc), D3(ngdim,ngdim,ngdim), D4(ngdim,ngdim,ngdim,ngdim), &
                             Gprime(ngdim,ngdim,ngdim), Gdbleprime(ngdim,ngdim,ngdim,ngdim)
real(kind=wp), intent(out) :: x(nOsc,nOsc)
integer(kind=iwp) :: i, i1, j, j1, k, k1, l, l1, NumInt
real(kind=wp) :: coef, delta, deltaInv, rsum, sum1, sum2, tmp
real(kind=wp), allocatable :: C(:,:), T3(:,:,:), T4(:,:,:,:), Temp(:,:), V3(:,:,:), V4(:,:,:,:)

NumInt = nOsc

call mma_allocate(C,nOsc,nOsc,label='C')
call mma_allocate(Temp,nOsc,nOsc,label='Temp')
call mma_allocate(V3,nOsc,nOsc,nOsc,label='V3')
call mma_allocate(T3,nOsc,nOsc,nOsc,label='T3')
call mma_allocate(V4,nOsc,nOsc,nOsc,nOsc,label='V4')
call mma_allocate(T4,nOsc,nOsc,nOsc,nOsc,label='T4')

! Calculate the eigenvector matrix, C, in dimensionless normal coordinates.
Temp(:,:) = Zero
do i=1,NumInt
  Temp(i,i) = One/sqrt(harmfreq(i))
end do
call DGEMM_('n','n',NumInt,NumInt,NumInt,One,eigenVec,NumInt,Temp,NumInt,Zero,C,NumInt)

call mma_deallocate(Temp)

! Transform cubic force constants to dimensionless normal coordinates
do i=1,NumInt
  do j=1,NumInt
    do k=1,NumInt
      sum1 = Zero
      sum2 = Zero
      do i1=1,NumInt
        do j1=1,NumInt
          do k1=1,NumInt
            coef = C(i1,i)*C(j1,j)*C(k1,k)
            sum1 = sum1+coef*D3(i1,j1,k1)
            sum2 = sum2+coef*Gprime(i1,j1,k1)
          end do
        end do
      end do
      V3(i,j,k) = sum1
      T3(i,j,k) = sum2
    end do
  end do
end do

! Transform quartic force constants to dimensionless normal coordinates
do i=1,NumInt
  do j=1,NumInt
    do k=1,NumInt
      do l=1,NumInt
        sum1 = Zero
        sum2 = Zero
        do i1=1,NumInt
          do j1=1,NumInt
            do k1=1,NumInt
              do l1=1,NumInt
                coef = C(i1,i)*C(j1,j)*C(k1,k)*C(l1,l)
                sum1 = sum1+coef*D4(i1,j1,k1,l1)
                sum2 = sum2+coef*Gdbleprime(i1,j1,k1,l1)
              end do
            end do
          end do
        end do
        V4(i,j,k,l) = sum1
        T4(i,j,k,l) = sum2
      end do
    end do
  end do
end do

call mma_deallocate(C)

! Calculate diagonal anharmonicity constants.
do i=1,NumInt
  x(i,i) = V4(i,i,i,i)/16.0_wp
  tmp = One/(48.0_wp*harmfreq(i))
  x(i,i) = x(i,i)-tmp*(V3(i,i,i)*(Five*V3(i,i,i)+Six*T3(i,i,i))+Nine*T3(i,i,i)**2)
  do j=1,NumInt
    if (j /= i) then
      tmp = -One/(16.0_wp*harmfreq(j)*(Four*harmfreq(i)**2-harmfreq(j)**2))
      x(i,i) = x(i,i)+tmp*(Eight*harmfreq(i)**2-Three*harmfreq(j)**2)*(V3(i,i,j)**2+T3(i,i,j)**2)
      x(i,i) = x(i,i)+tmp*(Eight*harmfreq(i)**2-harmfreq(j)**2)*(Two*V3(i,i,j)*T3(i,i,j))
      x(i,i) = x(i,i)-tmp*Eight*harmfreq(i)*harmfreq(j)*T3(i,j,i)*(V3(i,i,j)-T3(i,i,j))
      x(i,i) = x(i,i)-tmp*Four*harmfreq(j)**2*T3(i,j,i)**2
    end if
  end do
end do

! Calculate off-diagonal anharmonicity constants.
do i=1,NumInt
  do j=1,NumInt
    if (i /= j) then
      x(i,j) = V4(i,i,j,j)*Quart
      x(i,j) = x(i,j)+T4(i,i,j,j)*Half
      x(i,j) = x(i,j)-(V3(i,i,i)+T3(i,i,i))*(V3(i,j,j)+T3(j,j,i))/(Four*harmfreq(i))
      x(i,j) = x(i,j)-(V3(i,i,j)+T3(i,i,j))*(V3(j,j,j)+T3(j,j,j))/(Four*harmfreq(j))
      do k=1,NumInt
        if ((k /= i) .and. (k /= j)) then
          x(i,j) = x(i,j)-(V3(i,i,k)+T3(i,i,k))*(V3(j,j,k)+T3(j,j,k))/(Two*harmfreq(k))
        end if
      end do
      tmp = Half*harmfreq(i)/(Four*harmfreq(i)**2-harmfreq(j)**2)
      x(i,j) = x(i,j)-tmp*((V3(i,i,j)-T3(i,i,j))**2+Two*(V3(j,j,i)-T3(j,j,i))*T3(i,j,j)+Four*T3(i,j,i)**2)
      tmp = Half*harmfreq(j)/(Four*harmfreq(j)**2-harmfreq(i)**2)
      x(i,j) = x(i,j)-tmp*((V3(j,j,i)-T3(j,j,i))**2+Two*(V3(i,i,j)-T3(i,i,j))*T3(i,j,i)+Four*T3(i,j,j)**2)
      do k=1,NumInt
        if ((k /= i) .and. (k /= j)) then
          delta = One
          rsum = harmfreq(i)+harmfreq(j)+harmfreq(k)
          delta = delta*rsum
          rsum = harmfreq(i)-harmfreq(j)-harmfreq(k)
          delta = delta*rsum
          rsum = -harmfreq(i)+harmfreq(j)-harmfreq(k)
          delta = delta*rsum
          rsum = -harmfreq(i)-harmfreq(j)+harmfreq(k)
          delta = delta*rsum
          deltaInv = One/delta
          x(i,j) = x(i,j)+deltaInv*Half*harmfreq(k)*(harmfreq(i)**2+harmfreq(j)**2-harmfreq(k)**2)* &
                   (V3(i,j,k)**2+T3(i,j,k)**2+T3(j,k,i)**2+T3(k,i,j)**2)
          x(i,j) = x(i,j)+deltaInv*Two*(harmfreq(i)*harmfreq(j)*harmfreq(k))*(V3(i,j,k)*T3(i,j,k)-T3(j,k,i)*T3(k,i,j))
          x(i,j) = x(i,j)-deltaInv*harmfreq(i)*(harmfreq(k)**2+harmfreq(j)**2-harmfreq(i)**2)* &
                   (V3(i,j,k)*T3(k,i,j)-T3(i,j,k)*T3(j,k,i))
          x(i,j) = x(i,j)-deltaInv*harmfreq(j)*(harmfreq(k)**2+harmfreq(i)**2-harmfreq(j)**2)* &
                   (V3(i,j,k)*T3(j,k,i)-T3(i,j,k)*T3(k,i,j))
        end if
      end do
    end if
  end do
end do

call mma_deallocate(V3)
call mma_deallocate(T3)
call mma_deallocate(V4)
call mma_deallocate(T4)

end subroutine Anharm

subroutine TransEnergy(G01,x_anharm1,harmfreq1,level1,G02,x_anharm2,harmfreq2,level2,energy,nDim)
!  Purpose:
!    Calculate transition energy between two states.
!
!  Input:
!    G01,G02    : Real - (G02-G01) = energy difference between the two states.
!    x_anharm1  : Real two dimensional array - anharmonicity constants for ground state.
!    x_anharm2  : Real two dimensional array - anharmonicity constants for excited state.
!    harmfreq1  : Real array - harmonic frequencies for ground state.
!    harmfreq2  : Real array - harmonic frequencies for excited state.
!    level1     : Integer array - quanta for ground state.
!    level2     : Integer array - quanta for excited state.
!
!  Output:
!    energy     : Real variable - energy for transition between level1 and level2.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, level1(nDim), level2(nDim)
real(kind=wp), intent(in) :: G01, x_anharm1(nDim,nDim), harmfreq1(nDim), G02, x_anharm2(nDim,nDim), harmfreq2(nDim)
real(kind=wp), intent(out) :: energy
integer(kind=iwp) :: i, j
real(kind=wp) :: G0, G1

! Calculate energy for level 1.
G0 = G01
do i=1,nDim
  G0 = G0+harmfreq1(i)*(level1(i)+Half)
  do j=i,nDim
    G0 = G0+x_anharm1(i,j)*(level1(i)+Half)*(level1(j)+Half)
  end do
end do

! Calculate energy for level 2.
G1 = G02
do i=1,nDim
  G1 = G1+harmfreq2(i)*(level2(i)+Half)
  do j=i,nDim
    G1 = G1+x_anharm2(i,j)*(level2(i)+Half)*(level2(j)+Half)
  end do
end do

! Calculate energy difference.
energy = G1-G0

end subroutine TransEnergy

subroutine AnharmonicFreq(x_anharm,harmfreq,anharmfreq,nOsc)
!  Purpose:
!    Calculate the anharmonic frequencies.
!
!  Input:
!    x_anharm   : Real two dimensional array - anharmonicity constants.
!    harmfreq   : Real array - harmonic frequencies.
!
!  Output:
!    anharmfreq : Real array - anharmonic frequencies.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOsc
real(kind=wp), intent(in) :: x_anharm(nOsc,nOsc), harmfreq(nOsc)
real(kind=wp), intent(out) :: anharmfreq(nOsc)
integer(kind=iwp) :: istate
real(kind=wp) :: G1, G2
integer(kind=iwp), allocatable :: level1(:), level2(:)

call mma_allocate(level1,nOsc,label='level1')
call mma_allocate(level2,nOsc,label='level2')

G1 = Zero
G2 = G1
level1(:) = 0
do istate=1,nOsc
  level2(:) = 0
  level2(istate) = 1
  call TransEnergy(G1,x_anharm,harmfreq,level1,G2,x_anharm,harmfreq,level2,anharmfreq(istate),nOsc)
end do

call mma_deallocate(level1)
call mma_deallocate(level2)

end subroutine AnharmonicFreq

subroutine Cart_to_Int1(InterVec,AtCoord,xvec,BMatrix,NumOfAt,NumInt)
!  Purpose:
!    Calculate internal coordinates, and their gradients.
!
!  Input:
!    InterVec : Integer array - contains the atoms that are used in the calculations of each internal coordinate.
!    AtCoord  : Two dimensional Real array - contains the cartesian coordinates of the atoms.
!
!  Output:
!    xvec     : Real array - internal coordinates.
!    BMatrix  : Real array - Their gradients.
!
!  Written by:
!    Niclas Forsberg, Per Ake Malmqvist,
!    Dept. of Theoretical Chemistry, Lund University, 1997.

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: InterVec(*), NumOfAt, NumInt
real(kind=wp), intent(in) :: AtCoord(3,NumOfAt)
real(kind=wp), intent(inout) :: xvec(NumInt)
real(kind=wp), intent(inout) :: BMatrix(3,NumOfAt,NumInt)
integer(kind=iwp) :: i1, i2, i3, i4, inttype, k, n_Int
real(kind=wp) :: Area, cos123, cos234, cosdv, cosv, cosv0, cot123, cot234, G1(3), G2(3), G3(3), Normal123(3), Normal234(3), &
                 NR1(3), NR2(3), NR3(3), R(3), R1(3), R2(3), R2R3, R3(3), sin123, sin234, sindv, sinv, sinv0, SR, SR1, SR2, SR3

k = 1
IntType = InterVec(k)
n_Int = 1
do while (n_Int <= NumInt)
  if (IntType == 1) then
    ! Bond.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    R(:) = AtCoord(:,i1)-AtCoord(:,i2)
    SR = sqrt(R(1)**2+R(2)**2+R(3)**2)
    xvec(n_Int) = SR
    BMatrix(:,i1,n_Int) = R/SR
    BMatrix(:,i2,n_Int) = -R/SR
    !write(u6,*) ' Bond. i1,i2=',i1,i2
    !write(u6,'(1x,a,3F16.8)') ' R=',R
    !write(u6,'(1x,a,3F16.8)') 'SR=',SR
    !write(u6,'(1x,a,3F16.8)') 'BMatrix(:,i1,n_Int)=',BMatrix(:,i1,n_Int)
    !write(u6,'(1x,a,3F16.8)') 'BMatrix(:,i2,n_Int)=',BMatrix(:,i2,n_Int)
    k = k+3
    n_Int = n_Int+1
  end if
  if (IntType == 2) then
    ! Valence Angle.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i2)-AtCoord(:,i3)
    SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
    SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
    cosv = -(R1(1)*R2(1)+R1(2)*R2(2)+R1(3)*R2(3))/(SR1*SR2)
    if (cosv > One) cosv = One
    if (cosv < -One) cosv = -One
    sinv = sqrt(One-cosv**2)
    xvec(n_Int) = atan2(sinv,cosv)
    BMatrix(:,i1,n_Int) = (SR1*R2+SR2*cosv*R1)/(SR1**2*SR2*sinv)
    BMatrix(:,i3,n_Int) = -(SR2*R1+SR1*cosv*R2)/(SR2**2*SR1*sinv)
    BMatrix(:,i2,n_Int) = -(BMatrix(:,i1,n_Int)+BMatrix(:,i3,n_Int))
    !write(u6,*) ' Angle. i1,i2,i3=',i1,i2,i3
    !write(u6,'(1x,a,3F16.8)') ' R1=',R1
    !write(u6,'(1x,a,3F16.8)') ' R2=',R2
    !write(u6,'(1x,a,3F16.8)') 'BMatrix(:,i1,n_Int)=',BMatrix(:,i1,n_Int)
    !write(u6,'(1x,a,3F16.8)') 'BMatrix(:,i2,n_Int)=',BMatrix(:,i2,n_Int)
    !write(u6,'(1x,a,3F16.8)') 'BMatrix(:,i3,n_Int)=',BMatrix(:,i3,n_Int)
    k = k+4
    n_Int = n_Int+1
  end if
  if (IntType == 3) then
    ! Linear Valence Angle.
    !vv?? stop
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i2)-AtCoord(:,i3)
    SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
    SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
    cosv = -(R1(1)*R2(1)+R1(2)*R2(2)+R1(3)*R2(3))/(SR1*SR2)
    if (cosv > One) cosv = One
    if (cosv < -One) cosv = -One
    sinv = sqrt(One-cosv**2)
    xvec(n_Int) = atan2(sinv,cosv)
    BMatrix(1,i1,n_Int) = One/SR1
    BMatrix(1,i3,n_Int) = One/SR2
    BMatrix(1,i2,n_Int) = -(BMatrix(1,i1,n_Int)+BMatrix(1,i3,n_Int))
    BMatrix(2,i1,n_Int+1) = One/SR1
    BMatrix(2,i3,n_Int+1) = One/SR2
    BMatrix(2,i2,n_Int+1) = -(BMatrix(1,i1,n_Int)+BMatrix(1,i3,n_Int))
    n_Int = n_Int+2
    k = k+4
  end if
  if (IntType == 4) then
    ! Torsion.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    i4 = InterVec(k+4)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i2)-AtCoord(:,i3)
    R3(:) = AtCoord(:,i3)-AtCoord(:,i4)
    SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
    SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
    SR3 = sqrt(R3(1)**2+R3(2)**2+R3(3)**2)
    NR1(:) = R1/SR1
    NR2(:) = R2/SR2
    NR3(:) = R3/SR3
    cos123 = -(NR1(1)*NR2(1)+NR1(2)*NR2(2)+NR1(3)*NR2(3))
    if (cos123 > One) cos123 = One
    if (cos123 < -One) cos123 = -One
    sin123 = sqrt(One-cos123**2)
    cot123 = cos123/sin123
    Normal123(1) = (NR1(2)*NR2(3)-NR1(3)*NR2(2))/sin123
    Normal123(2) = (NR1(3)*NR2(1)-NR1(1)*NR2(3))/sin123
    Normal123(3) = (NR1(1)*NR2(2)-NR1(2)*NR2(1))/sin123
    cos234 = -(NR2(1)*NR3(1)+NR2(2)*NR3(2)+NR2(3)*NR3(3))
    if (cos234 > One) cos234 = One
    if (cos234 < -One) cos234 = -One
    sin234 = sqrt(One-cos234**2)
    cot234 = cos234/sin234
    Normal234(1) = (NR2(2)*NR3(3)-NR2(3)*NR3(2))/sin234
    Normal234(2) = (NR2(3)*NR3(1)-NR2(1)*NR3(3))/sin234
    Normal234(3) = (NR2(1)*NR3(2)-NR2(2)*NR3(1))/sin234
    sinv = NR2(1)*(Normal123(2)*Normal234(3)-Normal123(3)*Normal234(2))+ &
           NR2(2)*(Normal123(3)*Normal234(1)-Normal123(1)*Normal234(3))+ &
           NR2(3)*(Normal123(1)*Normal234(2)-Normal123(2)*Normal234(1))
    if (sinv > One) sinv = One
    if (sinv < -One) sinv = -One
    cosv = Normal123(1)*Normal234(1)+Normal123(2)*Normal234(2)+Normal123(3)*Normal234(3)
    if (cosv > One) cosv = One
    if (cosv < -One) cosv = -One
    cosv0 = cos(xvec(n_Int))
    sinv0 = sin(xvec(n_Int))
    sindv = sinv*cosv0-cosv*sinv0
    cosdv = cosv*cosv0+sinv*sinv0
    xvec(n_Int) = xvec(n_Int)+atan2(sindv,cosdv)
    G1(:) = Normal123/(SR1*sin123)
    G3(:) = Normal234/(SR3*sin234)
    G2(:) = (cot123*Normal123+cot234*Normal234)/SR2
    BMatrix(:,i1,n_Int) = G1
    BMatrix(:,i2,n_Int) = -G1+G2
    BMatrix(:,i3,n_Int) = -G2+G3
    BMatrix(:,i4,n_Int) = -G3
    !write(u6,*) ' Torsion. i1,i2,i3,i4=',i1,i2,i3,i4
    !write(u6,'(1x,a,3F16.8)') ' R1=',R1
    !write(u6,'(1x,a,3F16.8)') ' R2=',R2
    !write(u6,'(1x,a,3F16.8)') ' R3=',R3
    !write(u6,'(1x,a,3F16.8)') 'BMatrix(:,i1,n_Int)=',BMatrix(:,i1,n_Int)
    !write(u6,'(1x,a,3F16.8)') 'BMatrix(:,i2,n_Int)=',BMatrix(:,i2,n_Int)
    !write(u6,'(1x,a,3F16.8)') 'BMatrix(:,i3,n_Int)=',BMatrix(:,i3,n_Int)
    !write(u6,'(1x,a,3F16.8)') 'BMatrix(:,i4,n_Int)=',BMatrix(:,i4,n_Int)
    k = k+5
    n_Int = n_Int+1
  end if
  if (IntType == 5) then
    ! Out of Plane Angle.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    i4 = InterVec(k+4)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i2)-AtCoord(:,i3)
    R3(:) = AtCoord(:,i3)-AtCoord(:,i4)
    SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
    SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
    SR3 = sqrt(R3(1)**2+R3(2)**2+R3(3)**2)
    R2R3 = (R2(1)*R3(1)+R2(2)*R3(2)+R2(3)*R3(3))
    cos234 = -R2R3/(SR2*SR3)
    if (cos234 > One) cos234 = One
    if (cos234 < -One) cos234 = -One
    sin234 = sqrt(One-cos234**2)
    Area = SR2*SR3*sin234
    Normal234(1) = (R2(2)*R3(3)-R2(3)*R3(2))/Area
    Normal234(2) = (R2(3)*R3(1)-R2(1)*R3(3))/Area
    Normal234(3) = (R2(1)*R3(2)-R2(2)*R3(1))/Area
    sinv = (R1(1)*Normal234(1)+R1(2)*Normal234(2)+R1(3)*Normal234(3))/SR1
    if (sinv > One) sinv = One
    if (sinv < -One) sinv = -One
    cosv = sqrt(One-sinv**2)
    xvec(n_Int) = atan2(sinv,cosv)
    G1(1) = (R2(2)*R3(3)-R3(2)*R2(3)-(Area*sinv/SR1)*R1(1))/(SR1*Area*cosv)
    G1(2) = (R2(3)*R3(1)-R3(3)*R2(1)-(Area*sinv/SR1)*R1(2))/(SR1*Area*cosv)
    G1(3) = (R2(1)*R3(2)-R3(1)*R2(2)-(Area*sinv/SR1)*R1(3))/(SR1*Area*cosv)
    G2(1) = (R3(2)*R1(3)-R1(2)*R3(3)-(SR1*sinv/Area)*(SR3*R2(1)-R2R3*R3(1)))/(SR1*Area*cosv)
    G2(2) = (R3(3)*R1(1)-R1(3)*R3(1)-(SR1*sinv/Area)*(SR3*R2(2)-R2R3*R3(2)))/(SR1*Area*cosv)
    G2(3) = (R3(1)*R1(2)-R1(1)*R3(2)-(SR1*sinv/Area)*(SR3*R2(3)-R2R3*R3(3)))/(SR1*Area*cosv)
    G3(1) = (R1(2)*R2(3)-R2(2)*R1(3)-(SR1*sinv/Area)*(SR2*R3(1)-R2R3*R2(1)))/(SR1*Area*cosv)
    G3(2) = (R1(3)*R2(1)-R2(3)*R1(1)-(SR1*sinv/Area)*(SR2*R3(2)-R2R3*R2(2)))/(SR1*Area*cosv)
    G3(3) = (R1(1)*R2(2)-R2(1)*R1(2)-(SR1*sinv/Area)*(SR2*R3(3)-R2R3*R2(3)))/(SR1*Area*cosv)
    BMatrix(:,i1,n_Int) = G1
    BMatrix(:,i2,n_Int) = -G1+G2
    BMatrix(:,i3,n_Int) = -G2+G3
    BMatrix(:,i4,n_Int) = -G3
    k = k+5
    n_Int = n_Int+1
  end if
  IntType = InterVec(k)
end do

end subroutine Cart_to_Int1

subroutine Cart_to_Int0(InterVec,AtCoord,xvec,NumOfAt,NumInt)
!
!  Purpose:
!    Calculate internal coordinates only (not their gradients).
!
!  Input:
!    InterVec : Integer array - contains the atoms that are used in the calculations of each internal coordinate.
!    AtCoord  : Two dimensional Real array - contains the cartesian coordinates of the atoms.
!
!  Output:
!    xvec     : Real array - internal coordinates.
!
!  Written by:
!    Niclas Forsberg, Per Ake Malmqvist,
!    Dept. of Theoretical Chemistry, Lund University, 1997.

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: InterVec(*), NumOfAt, NumInt
real(kind=wp), intent(in) :: AtCoord(3,NumOfAt)
real(kind=wp), intent(inout) :: xvec(NumInt)
integer(kind=iwp) :: i1, i2, i3, i4, inttype, k, n_Int
real(kind=wp) :: cos123, cos234, cosdv, cosv, cosv0, Normal123(3), Normal234(3), NR1(3), NR2(3), NR3(3), R(3), R1(3), R2(3), R2R3, &
                 R3(3), sin123, sin234, sindv, sinv, sinv0, SR, SR1, SR2, SR3

k = 1
IntType = InterVec(k)
n_Int = 1
do while (n_Int <= NumInt)
  if (IntType == 1) then
    ! Bond.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    R(:) = AtCoord(:,i1)-AtCoord(:,i2)
    SR = sqrt(R(1)**2+R(2)**2+R(3)**2)
    xvec(n_Int) = SR
    k = k+3
    n_Int = n_Int+1
  end if
  if (IntType == 2) then
    ! Valence Angle.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i2)-AtCoord(:,i3)
    SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
    SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
    cosv = -(R1(1)*R2(1)+R1(2)*R2(2)+R1(3)*R2(3))/(SR1*SR2)
    if (cosv > One) cosv = One
    if (cosv < -One) cosv = -One
    sinv = sqrt(One-cosv**2)
    xvec(n_Int) = atan2(sinv,cosv)
    k = k+4
    n_Int = n_Int+1
  end if
  if (IntType == 3) then
    ! Linear Valence Angle.
    !vv? stop
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i3)-AtCoord(:,i2)
    SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
    SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
    NR1(:) = R1/SR1
    NR2(:) = R2/SR2
    cosv = NR1(1)*NR2(1)+NR1(2)*NR2(2)+NR1(3)*NR2(3)
    if (cosv > One) cosv = One
    if (cosv < -One) cosv = -One
    xvec(n_Int) = acos(cosv)
    k = k+4
    n_Int = n_Int+2
  end if
  if (IntType == 4) then
    ! Torsion.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    i4 = InterVec(k+4)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i2)-AtCoord(:,i3)
    R3(:) = AtCoord(:,i3)-AtCoord(:,i4)
    SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
    SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
    SR3 = sqrt(R3(1)**2+R3(2)**2+R3(3)**2)
    NR1(:) = R1/SR1
    NR2(:) = R2/SR2
    NR3(:) = R3/SR3
    cos123 = -(NR1(1)*NR2(1)+NR1(2)*NR2(2)+NR1(3)*NR2(3))
    if (cos123 > One) cos123 = One
    if (cos123 < -One) cos123 = -One
    sin123 = sqrt(One-cos123**2)
    Normal123(1) = (NR1(2)*NR2(3)-NR1(3)*NR2(2))/sin123
    Normal123(2) = (NR1(3)*NR2(1)-NR1(1)*NR2(3))/sin123
    Normal123(3) = (NR1(1)*NR2(2)-NR1(2)*NR2(1))/sin123
    cos234 = -(NR2(1)*NR3(1)+NR2(2)*NR3(2)+NR2(3)*NR3(3))
    if (cos234 > One) cos234 = One
    if (cos234 < -One) cos234 = -One
    sin234 = sqrt(One-cos234**2)
    Normal234(1) = (NR2(2)*NR3(3)-NR2(3)*NR3(2))/sin234
    Normal234(2) = (NR2(3)*NR3(1)-NR2(1)*NR3(3))/sin234
    Normal234(3) = (NR2(1)*NR3(2)-NR2(2)*NR3(1))/sin234
    sinv = NR2(1)*(Normal123(2)*Normal234(3)-Normal123(3)*Normal234(2))+ &
           NR2(2)*(Normal123(3)*Normal234(1)-Normal123(1)*Normal234(3))+ &
           NR2(3)*(Normal123(1)*Normal234(2)-Normal123(2)*Normal234(1))
    if (sinv > One) sinv = One
    if (sinv < -One) sinv = -One
    cosv = Normal123(1)*Normal234(1)+Normal123(2)*Normal234(2)+Normal123(3)*Normal234(3)
    if (cosv > One) cosv = One
    if (cosv < -One) cosv = -One
    cosv0 = cos(xvec(n_Int))
    sinv0 = sin(xvec(n_Int))
    sindv = sinv*cosv0-cosv*sinv0
    cosdv = cosv*cosv0+sinv*sinv0
    xvec(n_Int) = xvec(n_Int)+atan2(sindv,cosdv)
    k = k+5
    n_Int = n_Int+1
  end if
  if (IntType == 5) then
    ! Out of Plane Angle.
    i1 = InterVec(k+1)
    i2 = InterVec(k+2)
    i3 = InterVec(k+3)
    i4 = InterVec(k+4)
    R1(:) = AtCoord(:,i1)-AtCoord(:,i2)
    R2(:) = AtCoord(:,i2)-AtCoord(:,i3)
    R3(:) = AtCoord(:,i3)-AtCoord(:,i4)
    SR1 = sqrt(R1(1)**2+R1(2)**2+R1(3)**2)
    SR2 = sqrt(R2(1)**2+R2(2)**2+R2(3)**2)
    SR3 = sqrt(R3(1)**2+R3(2)**2+R3(3)**2)
    R2R3 = (R2(1)*R3(1)+R2(2)*R3(2)+R2(3)*R3(3))
    cos234 = -R2R3/(SR2*SR3)
    if (cos234 > One) cos234 = One
    if (cos234 < -One) cos234 = -One
    sin234 = sqrt(One-cos234**2)
    Normal234(1) = (R2(2)*R3(3)-R2(3)*R3(2))/(SR2*SR3*sin234)
    Normal234(2) = (R2(3)*R3(1)-R2(1)*R3(3))/(SR2*SR3*sin234)
    Normal234(3) = (R2(1)*R3(2)-R2(2)*R3(1))/(SR2*SR3*sin234)
    sinv = (R1(1)*Normal234(1)+R1(2)*Normal234(2)+R1(3)*Normal234(3))/SR1
    if (sinv > One) sinv = One
    if (sinv < -One) sinv = -One
    xvec(n_Int) = asin(sinv)
    k = k+5
    n_Int = n_Int+1
  end if
  IntType = InterVec(k)
end do

end subroutine Cart_to_Int0

subroutine Int_to_Cart1(InterVec,xvec,AtCoord,NumOfAt,NumInt)
!  Purpose:
!    Transform a set of internal coordinates to cartesian coordinates.
!
!  Written by:
!    Per Ake Malmqvist
!    Dept. of Theoretical Chemistry, Lund University, 2000.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: InterVec(*), NumOfAt, NumInt
real(kind=wp), intent(in) :: xvec(NumInt)
real(kind=wp), intent(inout) :: AtCoord(3,NumOfAt)
integer(kind=iwp) :: i1, i2, ii, iter, j, j1, j2, jj, k, ncart
real(kind=wp) :: det, RMSErr, rsum
real(kind=wp), allocatable :: BMatrix(:,:,:), EqMat(:,:), EqRHS(:), xvectmp(:)

! Initialize.

call mma_allocate(BMatrix,3,NumOfAt,NumInt,label='BMatrix')

! Purpose: For a given array InterVec, which describes the set of
! internal coordinates, and a given array xvec with values of these
! internal coordinates, find the structure which has the required
! internal coordinates and which is as close as possible to the
! input structure.
! Method: Newton-Raphson iteration, modified by Gauss' approximation
! in each iteration.
ncart = 3*NumOfAt

BMatrix(:,:,:) = Zero
call mma_allocate(EqMat,ncart,ncart,label='EqMat')
call mma_allocate(EqRHS,ncart,label='EqRHS')
call mma_allocate(xvectmp,NumInt,label='xvectmp')
!write(u6,*) ' Int_to_Cart1 has been called with target internal coordinates:'
!write(u6,'(1x,5F16.8)') xvec
iter = 0
RMSErr = huge(RMSErr)
do while (RMSErr > 1.0e-12_wp)
  iter = iter+1
  if (iter > 50) then
    write(u6,*) ' Int_to_Cart1 fails to converge.'
    call abend()
  end if
  ! Find the current internal coordinates and B matrix:
  !xvectmp = xvec
  xvectmp(:) = xvec
  call Cart_to_Int1(InterVec,AtCoord,xvectmp,BMatrix,NumOfAt,NumInt)

  ! Present error:
  rsum = Zero
  do k=1,NumInt
    rsum = rsum+(xvectmp(k)-xvec(k))**2
  end do
  RMSErr = sqrt(rsum)
  ! The B matrix is the matrix of partial derivatives of xvectmp with
  ! respect to AtCoord.
  ! Form the matrix B(transpose)*B -- This will be the matrix of the
  ! linearized equation system.
  jj = 0
  do j1=1,NumOfAt
    do j2=1,3
      jj = jj+1
      ii = 0
      do i1=1,NumOfAt
        do i2=1,3
          ii = ii+1
          rsum = Zero
          do k=1,NumInt
            rsum = rsum+BMatrix(i2,i1,k)*BMatrix(j2,j1,k)
          end do
          EqMat(ii,jj) = rsum
        end do
      end do
    end do
  end do
  ! The right-hand side of the equation system:
  ii = 0
  do i1=1,NumOfAt
    do i2=1,3
      ii = ii+1
      rsum = Zero
      do k=1,NumInt
        rsum = rsum+BMatrix(i2,i1,k)*(xvec(k)-xvectmp(k))
      end do
      EqRHS(ii) = rsum
    end do
  end do
  !D write(u6,*) ' EqRHS:'
  !D write(u6,'(1x,5f16.8)') EqRHS
  ! Automatic step limitation, and in fact ensuring that we go in the
  ! direction of minimization always, is achieved indirectly:
  do j=1,ncart
    EqMat(j,j) = EqMat(j,j)+1.0e-12_wp
  end do
  ! Solve the linear equation system:
  call Dool_MULA(EqMat,ncart,ncart,EqRHS,ncart,1,det)
  !D write(u6,*) ' Solution vector:'
  !D write(u6,'(1x,5f16.8)') EqRHS
  ! After return from dool, EqMat is destroyed and EqRHS is solution.
  ! Update the cartesian coordinates:
  ii = 0
  do i1=1,NumOfAt
    do i2=1,3
      ii = ii+1
      AtCoord(i2,i1) = AtCoord(i2,i1)+EqRHS(ii)
    end do
  end do
  !write(u6,*) ' Iteration iter=',iter
  !write(u6,*) ' AtCoord array:'
  !do i1=1,NumOfAt
  !  write(u6,'(1x,3f16.8)') (AtCoord(i2,i1),i2=1,3)
  !end do
  !write(u6,*) 'RMSErr:',RMSErr
end do
call mma_deallocate(EqMat)
call mma_deallocate(EqRHS)
call mma_deallocate(xvectmp)
call mma_deallocate(BMatrix)

return

end subroutine Int_to_Cart1

!end module VibMod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Markus P. Fuelscher                              *
!***********************************************************************

subroutine IVcPrt(Title,FmtIn,X,N)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Print a vector of integer numbers                                *
!                                                                      *
!     calling arguments                                                *
!     Title  : character string containing a title                     *
!              If the string is empty now title will be printed        *
!     X      : vector of integers                                      *
!     N      : dimension of vector X                                   *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher                                                  *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: Title, FmtIn
integer(kind=iwp), intent(in) :: N, X(N)
integer(kind=iwp), parameter :: lPaper = 120
integer(kind=iwp) :: i, iPmax, iPmin, lFmt, lItem, lLeft, lNumbr, lTitle, nCols, Xmax, Xmin
real(kind=wp) :: Pmax, Pmin, Temp
character(len=lPaper) :: Line
character(len=20) :: FRMT

!----------------------------------------------------------------------*
! print the title                                                      *
!----------------------------------------------------------------------*
lTitle = len_trim(Title)
if (lTitle > 0) then
  Line = ''
  lLeft = 0
  do i=1,lTitle
    if (Title(i:i) /= ' ') then
      lLeft = i-1
      exit
    end if
  end do
  do i=1,lPaper
    if (i+lLeft <= lTitle) Line(i:i) = Title(i+lLeft:i+lLeft)
  end do
  write(u6,*)
  write(u6,'(2X,A)') Line
  do i=1,len_trim(Line)
    Line(i:i) = '-'
  end do
  write(u6,'(2X,A)') Line
  write(u6,'(2X,A,I6)') 'vec. size = ',N
end if
!----------------------------------------------------------------------*
! determine the printing format                                        *
!----------------------------------------------------------------------*
lFmt = len_trim(FmtIn)
if (lFmt /= 0) then
  FRMT = FmtIn
else
  Xmax = -huge(Xmax)
  Xmin = huge(Xmin)
  do i=1,N
    Xmax = max(Xmax,X(i))
    Xmin = min(Xmin,X(i))
  end do
  Temp = real(Xmax,kind=wp)
  Pmax = Zero
  if (abs(Temp) > 1.0e-72_wp) Pmax = log10(abs(Temp))
  iPmax = int(One+Pmax)
  iPmax = max(1,iPmax)
  if (Xmax < 0) iPmax = iPmax+1
  Temp = real(Xmin,kind=wp)
  Pmin = Zero
  if (abs(Temp) > 1.0e-72_wp) Pmin = log10(abs(Temp))
  iPmin = int(One+Pmin)
  iPmin = max(1,iPmin)
  if (Xmin < 0) iPmin = iPmin+1
  lNumbr = max(iPmax,iPmin)+1
  if (50*lNumbr <= lPaper) then
    nCols = 50
  else if (20*lNumbr <= lPaper) then
    nCols = 20
  else if (10*lNumbr <= lPaper) then
    nCols = 10
  else
    nCols = 5
  end if
  lItem = lPaper/nCols
  write(FRMT,'(A,I2.2,A,I2.2,A)') '(2X,',nCols,'I',lItem,')'
end if
!----------------------------------------------------------------------*
! print the data                                                       *
!----------------------------------------------------------------------*
write(u6,*)
write(u6,FRMT) X(:)

!----------------------------------------------------------------------*
! End procedure                                                        *
!----------------------------------------------------------------------*
return

end subroutine IVcPrt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
*-- In this routine H_0 in RASSI basis is constructed, possibly with
*   external perturbation added on.
*
      Subroutine RasH0(nB)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "qminp.fh"
#include "qm2.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension DiagH0(MxState)

      nBTri=nB*(nB+1)/2
      nTri=nState*(nState+1)/2
      If(.not.AddExt) then
        kaunter=0
        Do 1, i=1,nState
          Do 2, j=1,i
            kaunter=kaunter+1
2         Continue
          DiagH0(i)=HmatState(kaunter)
1       Continue
        Write(6,*)'     -----RASSI H_0 eigenvalues:'
        Write(6,99)(DiagH0(k),k=1,nState)
      Else
*
*---- Collect one-electron perturbations.
*
        Lu_One=49
        Lu_One=IsFreeUnit(Lu_One)
        Call OpnOne(irc,0,'ONEINT',Lu_One)
        Call GetMem('AOExt','Allo','Real',ipAOx,nBTri+4)
        Do 101, iExt=1,nExtAddOns
          irc=-1
          iopt=0
          iSmLbl=0
          Call RdOne(irc,iopt,ExtLabel(iExt),iCompExt(iExt),Work(ipAOx)
     &              ,iSmLbl)
          call dscal_(nBTri,ScalExt(iExt),Work(ipAOx),iONE)
          If(irc.ne.0) then
            Write(6,*)
            Write(6,*)'ERROR when reading ',ExtLabel(iExt),'.'
            Write(6,*)'Have Seward computed this integral?'
            Call Quit(_RC_IO_ERROR_READ_)
          Endif
*
*---- We need to know in which basis the TDM is and then transform
*     the one-electron integrals to RASSI-basis.
*
          If(.not.MoAveRed) then
            Call GetMem('Transition','Allo','Real',ipAOG,nBTri)
            kaunter=0
            Do 102, iS1=1,nState
              Do 103, iS2=1,iS1
                call dcopy_(nBTri,Work(iBigT+nBTri*kaunter),iONE
     &                    ,Work(ipAOG),iONE)
                Element=Ddot_(nBTri,Work(ipAOG),iONE,Work(ipAOx),iONE)
                kaunter=kaunter+1
                HmatState(kaunter)=HmatState(kaunter)+Element
103           Continue
102         Continue
            Call GetMem('Transition','Free','Real',ipAOG,nBTri)
          Else
            nSize=nRedMO*(nRedMO+1)/2
            Call GetMem('Transition','Allo','Real',ipMOG,nSize)
            Call GetMem('AUX','Allo','Real',iAUX,nRedMO*nB)
            Call GetMem('SquareAO','Allo','Real',iSqAO,nB**2)
            Call GetMem('SquareMO','Allo','Real',iSqMO,nRedMO**2)
            Call GetMem('MOExt','Allo','Real',ipMOx,nSize)
            Call Square(Work(ipAOx),Work(iSqAO),iONE,nB,nB)
            Call Dgemm_('T','N',nRedMO,nB,nB,ONE,Work(ipAvRed)
     &                ,nB,Work(iSqAO),nB,ZERO,Work(iAUX),nRedMO)
            Call Dgemm_('N','N',nRedMO,nRedMO,nB,ONE,Work(iAUX)
     &                ,nRedMO,Work(ipAvRed),nB,ZERO,Work(iSqMO),nRedMO)
            Call SqToTri_Q(Work(iSqMO),Work(ipMOx),nRedMO)
            kaunter=0
            Do 104, iS1=1,nState
              Do 105, iS2=1,nState
                call dcopy_(nSize,Work(iBigT+nSize*kaunter),iONE
     &                    ,Work(ipMOG),iONE)
                Element=Ddot_(nSize,Work(ipMOG),iONE,Work(ipMOx),iONE)
                kaunter=kaunter+1
                HmatState(kaunter)=HmatState(kaunter)+Element
105           Continue
104         Continue
            Call GetMem('Transition','Free','Real',ipMOG,nSize)
            Call GetMem('AUX','Free','Real',iAUX,nRedMO*nB)
            Call GetMem('SquareAO','Free','Real',iSqAO,nB**2)
            Call GetMem('SquareMO','Free','Real',iSqMO,nRedMO**2)
            Call GetMem('MOExt','Free','Real',ipMOx,nSize)
          Endif
101     Continue
        Call GetMem('AOExt','Free','Real',ipAOx,nBTri+4)
        Call ClsOne(irc,Lu_One)
*
*-- If sufficient print level, print HmatState with perturbation added.
*
        If(iPrint.ge.5) then
          Write(6,*)
          Call TriPrt('H_0+External perturbation',' ',HmatState,nState)
        Endif
      Endif

99    Format('            ',9(F12.7,'  '))

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Make_Conn(F,Kappa,P,D)
      use Arrays, only: F0SQMO
c
c kappa=\bar{kappa}
c P = \bar{d}
c D = \bar{D}
c
c
      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
      Real*8 P(*),D(*),F(*),Kappa(*)
      Real*8 dum(1)
      Real*8, Allocatable:: T1(:), T2(:), T3(:), T4(:)
*
      Call mma_allocate(T1,n2dens,Label='MO')
      Call mma_allocate(T2,ndens2,Label='F1')
      Call mma_allocate(T3,ndens2,Label='F3')
      Call mma_allocate(T4,ndens2,Label='F2')
c
c OIT of the Fock matrix --> Ftilde the orbital part of the effective Fock
c F = Ftilde, the active part.
c T1 = Dtilde
c
      Call Rint_generic(kappa,T1,dum,T2,T3,T4,F,1,-1.0d0,0)
      Call DSCAL_(ndens2,0.50d0,f,1)
c
c T2 = Fbar The ci part or the active Fock matrix
c
      Call FockGen(0.0d0,D,P,T2,T3,1)
      Fact=1.0d0
      Do iS=1,nsym
          If (nBas(is).ge.1) Then
             Call DGEMM_('N','N',nBas(is),nBas(is),nBas(is),
     &                  Fact,kappa(ipMat(is,is)),nBas(is),
     &                       F0SQMO(ipMat(is,is)),nBas(is),
     &                  1.0D0,F(ipMat(is,is)),nBas(is))
             Call DGEMM_('N','N',nBas(is),nBas(is),nBas(is),
     &                  -Fact,F0SQMO(ipMat(is,is)),nBas(is),
     &                        Kappa(ipmat(is,is)),nBas(is),
     &                  1.0D0,F(ipMat(is,is)),nBas(is))
         End If
      End Do
      Call DaxPy_(ndens2,1.0d0,F,1,T2,1)

      Call TCMO(T2,1,-2 )
      ijB=1
      Do iS=1,nsym
       Do iB=1,nBas(iS)
        iptmp=ipmat(iS,iS)
        iptmp1=iptmp-nbas(iS)+iB-1
        iptmp2=iptmp+nbas(iS)*(iB-1)-1
        Do jB=1,iB-1
         iptmp1=iptmp1+nbas(iS)
         iptmp2=iptmp2+1
         F(ijB)=(T2(iptmp1)+T2(iptmp2))
         ijB=ijB+1
        End Do
        F(ijB)=T2(iptmp2+1)
        ijB=ijB+1
       End Do
      End Do
*
      Call mma_deallocate(T4)
      Call mma_deallocate(T3)
      Call mma_deallocate(T2)
      Call mma_deallocate(T1)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RDMCCI(JOB,IDISP,LABEL,ISYMP,NARRAY,ARRAY)
      IMPLICIT REAL*8 (A-H,O-Z)
C Purpose: Read in the derivatives of CI array derivatives
C from MCKINT file, with respect to some displacement IDISP.
C ISYMP is the symmetry irrep label of the derivatives.
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='RDMCCI')
#include "rasdim.fh"
#include "SysDef.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "rassi.fh"
#include "jobin.fh"
#include "Struct.fh"
#include "symmul.fh"
#include "WrkSpc.fh"
      DIMENSION ARRAY(NARRAY)
      CHARACTER*8 LABEL


      IF(JOB.LT.1 .OR. JOB.GT.NJOB) THEN
        WRITE(6,*)' RDMCI: Invalid JOB parameter.'
        WRITE(6,*)' JOB:',JOB
        CALL ABEND()
      END IF

      IF(IPGLOB.GE.VERBOSE) THEN
        WRITE(6,*)' RDMCCI called for JOB=',JOB
        WRITE(6,*)' perturbed by displacement nr.',IDISP
        WRITE(6,*)' MckInt file name:',MINAME(JOB)
        WRITE(6,*)' Irrep label   ISYMP=',ISYMP
        WRITE(6,*)' Length NARRAY=',NARRAY
      END IF

C Open MCKINT file:
      IRC=-1
      IOPT=0
      CALL OPNMCK(IRC,IOPT,MINAME(JOB),LUMCK)
      IF(IRC.NE.0) THEN
        WRITE(6,*)'RDMCCI: Failed to open '//MINAME(JOB)
        WRITE(6,*)'Unit nr LUMCK=',LUMCK
        WRITE(6,*)'Option code IOPT=',IOPT
        WRITE(6,*)'Return code IRC =',IRC
        CALL ABEND()
      END IF

C Read MCKINT file:
      NTEMP=NCONF1
      IOPT=0
      ISCODE=2**(ISYMP-1)
C Get temporary buffer to read data by RDMCK calls
      CALL GETMEM('RDMCCI','ALLO','REAL',LTEMP,NTEMP)
C Read 1-electron integral derivatives:
      IRC=NTEMP
      CALL dRDMCK(IRC,IOPT,LABEL,IDISP,WORK(LTEMP),ISCODE)
      IF(IRC.NE.0) THEN
        WRITE(6,*)'RDMCCI: RDMCCI failed to read '//MINAME(JOB)
        WRITE(6,*)'  Displacement IDISP=',IDISP
        WRITE(6,*)'    Option code IOPT=',IOPT
        WRITE(6,*)'Symmetry code ISCODE=',ISCODE
        WRITE(6,*)'    Return code IRC =',IRC
        CALL ABEND()
      END IF

      IF(NTEMP.GT.NARRAY) THEN
        WRITE(6,*)'RDMCCI: Output ARRAY has insufficient length.'
        WRITE(6,*)' Input parameter NARRAY=',NARRAY
        WRITE(6,*)' Needed size       NTEMP=',NTEMP
        CALL ABEND()
      END IF
C Move buffer integrals into ARRAY in proper format:
      CALL DCOPY_(NTEMP,WORK(LTEMP),1,ARRAY,1)
C Get rid of temporary buffer
      CALL GETMEM('RDMCCI','FREE','REAL',LTEMP,NTEMP)

C Close MCKINT file:
      IRC=-1
      IOPT=0
      CALL CLSMCK(IRC,IOPT)
      IF(IRC.NE.0) THEN
        WRITE(6,*)'RDMCCI: Failed to close '//MINAME(JOB)
        WRITE(6,*)'Unit nr LUMCK=',LUMCK
        WRITE(6,*)'Option code IOPT=',IOPT
        WRITE(6,*)'Return code IRC =',IRC
        CALL ABEND()
      END IF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1988, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine LULU(A,L,U,NDIM)
! LU DECOMPOSITION OF MATRIX A
!
!     A = L * U
!
! WHERE L IS A LOWER TRIANGULAR MATRIX WITH A
! UNIT DIAGONAL AND U IS AN UPPER DIAGONAL
!
! L AND U ARE STORED AS ONE DIMENSIONAL ARRAYS
!
!   L(I,J) = L(nTri_Elem(I-1) + J) ( I >= J )
!
!   U(I,J) = U(nTri_Elem(J-1) + I) ( J >= I )
!
! THIS ADDRESSING SCHEMES SUPPORTS VECTORIZATION OVER COLUMNS
! FOR L AND  OVER ROWS FOR U .
!
! NO PIVOTING IS DONE HERE, SO THE SCHEME GOES :
!
!     LOOP OVER R=1, NDIM
!       LOOP OVER J = R, NDIM
!         U(R,J) = A(R,J) - SUM(K=1,R-1) L(R,K) * U(K,J)
!       END OF LOOP OVER J
!
!       LOOP OVER I = R+1, NDIM
!         L(I,R) = (A(I,R) - SUM(K=1,R-1)L(I,K) * U(K,R)) /U(R,R)
!       END OF LOOP OVER I
!     END OF LOOP OVER R
!
! JEPPE OLSEN, OCTOBER 1988

use Index_Functions, only: nTri_Elem
use Constants, only: One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NDIM
real(kind=wp), intent(in) :: A(NDIM,NDIM)
real(kind=wp), intent(inout) :: L(nTri_Elem(NDIM)), U(nTri_Elem(NDIM))
integer(kind=iwp) :: I, J, R
real(kind=wp) :: XFACI
real(kind=wp), external :: dDot_

do R=1,NDIM

  do J=R,NDIM
    U(nTri_Elem(J-1)+R) = A(R,J)-dDot_(R-1,L(nTri_Elem(R-1)+1),1,U(nTri_Elem(J-1)+1),1)
  end do

  XFACI = One/U(nTri_Elem(R))
  L(nTri_Elem(R)) = One
  do I=R+1,NDIM
    L(nTri_Elem(I-1)+R) = (A(I,R)-dDot_(R-1,L(nTri_Elem(I-1)+1),1,U(nTri_Elem(R-1)+1),1))*XFACI
  end do

end do

#ifdef _DEBUGPRINT_
write(u6,*) ' L MATRIX'
call PRSYM(L,NDIM)
write(u6,*) ' U MATRIX (TRANSPOSED)'
call PRSYM(U,NDIM)
#endif

end subroutine LULU

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Morgane Vacher                                   *
!***********************************************************************
!
! *********************************************************************
! *                                                                   *
! * Subroutine to keep in only some nuclear coordinates for the       *
! * forces and do dynamics in reduced dimensionality.                 *
! *                                                                   *
! * 27/05/2020                                                        *
! * Morgane Vacher                                                    *
! *                                                                   *
! *********************************************************************

subroutine project_in_for(force,natom)

use Dynamix_Globals, only: PIN
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natom
real(kind=wp), intent(inout) :: force(natom*3)
integer(kind=iwp) :: i, j, p
real(kind=wp) :: pforce
real(kind=wp), allocatable :: Mass(:), pcoo(:,:), pcoo_m(:,:), force_m(:), newforce_m(:)

call mma_allocate(force_m,natom*3)
call mma_allocate(newforce_m,natom*3)
call mma_allocate(pcoo,PIN,natom*3)
call mma_allocate(pcoo_m,PIN,natom*3)
call mma_allocate(Mass,natom)

call Get_dArray('Keep_Coord',pcoo,PIN*natom*3)
call GetMassDx(Mass,natom)

newforce_m(:) = Zero
! Mass-weight the force vector
do i=1,natom
  do j=1,3
    force_m(3*(i-1)+j) = force(3*(i-1)+j)/sqrt(Mass(i))
  end do
end do

do p=1,PIN
  ! Mass-weight the projection vector
  do i=1,natom
    do j=1,3
      pcoo_m(p,3*(i-1)+j) = pcoo(p,3*(i-1)+j)*sqrt(Mass(i))
    end do
  end do
  ! normalise it (needed or not?)
  pcoo_m(p,:) = pcoo_m(p,:)/sqrt(dot_product(pcoo_m(p,:),pcoo_m(p,:)))
  ! Calculate the projection to keep in
  pforce = dot_product(pcoo_m(p,:),force_m)
  newforce_m(:) = newforce_m(:)+pforce*pcoo_m(p,:)
end do

! Un-Mass-weight the force vector
do i=1,natom
  do j=1,3
    force(3*(i-1)+j) = newforce_m(3*(i-1)+j)*sqrt(Mass(i))
  end do
end do

call mma_deallocate(force_m)
call mma_deallocate(newforce_m)
call mma_deallocate(pcoo)
call mma_deallocate(pcoo_m)
call mma_deallocate(Mass)

return

end subroutine project_in_for

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_RemoveLinDep(iAtomPair,Z,ID,M,nZ)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Handle linear dependence: remove linearly dependent rows of Z and
C     update atom pair info.
C
      Implicit None
      Integer iAtomPair
      Integer M, nZ
      Real*8  Z(M,nZ)
      Integer ID(M)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"

      Character*8 Label

      Integer ip_Included, l_Included
      Integer ip, l
      Integer ip0
      Integer iAtom, jAtom
      Integer n1CLinDep, n2CFunctions
      Integer iS, jS, iShell, jShell
      Integer K, ij, ijS, i2CF
      Integer nShell_i

      Integer  LDF_nShell_Atom, LDF_nBasSh_Atom
      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nShell_Atom, LDF_nBasSh_Atom
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom

      Integer i, j
      Integer nBasSh, Included, AP_Atoms, AP_1CLinDep, AP_2CFunctions
      Integer IndxG, IndxG2
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      Included(i)=iWork(ip_Included-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      IndxG(i,j)=iWork(ip_IndxG-1+l_IndxG_1*(j-1)+i)
      IndxG2(i,j)=iWork(ip_IndxG2-1+l_IndxG2_1*(j-1)+i)

      ! Return if nothing to do
      If (nZ.ge.M) Return

      ! Set up Included array
      ! Included(J)=0: aux. function J is not included
      ! Included(J)=1: aux. function J is included
      l_Included=M
      Call GetMem('Incl','Allo','Inte',ip_Included,l_Included)
      Call iZero(iWork(ip_Included),l_Included)
      ip0=ip_Included-1
      Do J=1,nZ
         iWork(ip0+ID(J))=1
      End Do

      ! Remove linearly dependent rows of Z vectors
      ! = the leading nZ x nZ part of Z will contain the
      !   Z vectors corresponding to the linearly independent
      !   auxiliary basis functions
      ! Note that no reordering is done, implying that the Z vectors
      ! reflect the ordering of the G matrix with linearly dependent
      ! columns AND rows removed.
      l=nZ
      Call GetMem('ZTmp','Allo','Real',ip,l)
      Do J=1,nZ
         K=0
         Do I=1,M
            If (Included(I).eq.1) Then
               Work(ip+K)=Z(I,J)
               K=K+1
            End If
         End Do
         Call dCopy_(nZ,Work(ip),1,Z(1,J),1)
      End Do
      Call GetMem('ZTmp','Free','Real',ip,l)

      ! Get atoms of atom pair
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)

      ! Count number of linearly dependent 1-center functions
      n1CLinDep=AP_1CLinDep(1,iAtomPair)
      ip0=LDF_lAuxShell_Atom(iAtom)-1
      Do iS=1,LDF_nAuxShell_Atom(iAtom)
         iShell=iWork(ip0+iS)
         Do i=1,nBasSh(iShell)
            J=IndxG(i,iShell)
            If (J.gt.0) Then
               If (Included(J).eq.0) Then
                  n1CLinDep=n1CLinDep+1
               End If
            End If
         End Do
      End Do
      If (jAtom.ne.iAtom) Then
         ip0=LDF_lAuxShell_Atom(jAtom)-1
         Do jS=1,LDF_nAuxShell_Atom(jAtom)
            jShell=iWork(ip0+jS)
            Do i=1,nBasSh(jShell)
               J=IndxG(i,jShell)
               If (J.gt.0) Then
                  If (Included(J).eq.0) Then
                     n1CLinDep=n1CLinDep+1
                  End If
               End If
            End Do
         End Do
      End If

      ! Reallocate and reset 1C lindep info
      If (n1CLinDep.gt.0) Then
         Write(Label,'(A,I5.5)') '1CL',iAtomPair-1
         l=3*AP_1CLinDep(1,iAtomPair)
         If (l.gt.0) Then
            ip=AP_1CLinDep(2,iAtomPair)
            Call GetMem(Label,'Free','Inte',ip,l)
         End If
         l=3*n1CLinDep
         Call GetMem(Label,'Allo','Inte',ip,l)
         iWork(ip_AP_1CLinDep+2*(iAtompair-1))=n1CLinDep
         iWork(ip_AP_1CLinDep+2*(iAtompair-1)+1)=ip
         ip0=LDF_lAuxShell_Atom(iAtom)-1
         n1CLinDep=0
         Do iS=1,LDF_nAuxShell_Atom(iAtom)
            iShell=iWork(ip0+iS)
            Do i=1,nBasSh(iShell)
               J=IndxG(i,iShell)
               If (J.gt.0) Then
                  If (Included(J).eq.0) Then
                     iWork(ip+3*n1CLinDep)=iAtom
                     iWork(ip+3*n1CLinDep+1)=iS
                     iWork(ip+3*n1CLinDep+2)=i
                     n1CLinDep=n1CLinDep+1
                  End If
               Else
                  iWork(ip+3*n1CLinDep)=iAtom
                  iWork(ip+3*n1CLinDep+1)=iS
                  iWork(ip+3*n1CLinDep+2)=i
                  n1CLinDep=n1CLinDep+1
               End If
            End Do
         End Do
         If (jAtom.ne.iAtom) Then
            ip0=LDF_lAuxShell_Atom(jAtom)-1
            Do jS=1,LDF_nAuxShell_Atom(jAtom)
               jShell=iWork(ip0+jS)
               Do i=1,nBasSh(jShell)
                  J=IndxG(i,jShell)
                  If (J.gt.0) Then
                     If (Included(J).eq.0) Then
                        iWork(ip+3*n1CLinDep)=jAtom
                        iWork(ip+3*n1CLinDep+1)=jS
                        iWork(ip+3*n1CLinDep+2)=i
                        n1CLinDep=n1CLinDep+1
                     End If
                  Else
                     iWork(ip+3*n1CLinDep)=jAtom
                     iWork(ip+3*n1CLinDep+1)=jS
                     iWork(ip+3*n1CLinDep+2)=i
                     n1CLinDep=n1CLinDep+1
                  End If
               End Do
            End Do
         End If
      End If

      ! Remove 2C functions (if any)
      If (AP_2CFunctions(1,iAtomPair).gt.0) Then
         ! Count contributing 2C functions
         n2CFunctions=0
         nShell_i=LDF_nShell_Atom(iAtom)
         ip0=AP_2CFunctions(2,iAtomPair)-1
         Do i2CF=0,AP_2CFunctions(1,iAtomPair)-1
            ip=ip0+4*i2CF
            iS=iWork(ip+1)
            i=iWork(ip+2)
            jS=iWork(ip+3)
            j=iWork(ip+4)
            ijS=nShell_i*(jS-1)+iS
            ij=LDF_nBasSh_Atom(iS,iAtom)*(j-1)+i
            K=IndxG2(ij,ijS)
            If (K.gt.0) Then
               If (Included(K).eq.1) Then
                  n2CFunctions=n2CFunctions+1
               End If
            End If
         End Do
         ! Set data for those contributing
         ! Not needed, of course, if none has been removed by the CD
         If (n2CFunctions.lt.AP_2CFunctions(1,iAtomPair)) Then
            Write(Label,'(A,I5.5)') '2CF',iAtomPair-1
            If (n2CFunctions.eq.0) Then
               k=4*AP_2CFunctions(1,iAtomPair)
               ip0=AP_2CFunctions(2,iAtomPair)
               Call GetMem(Label,'Free','Inte',ip0,k)
               iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=0
               iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=0
            Else
               l=4*n2CFunctions
               Call GetMem(Label,'Allo','Inte',ip,l)
               nShell_i=LDF_nShell_Atom(iAtom)
               ip0=AP_2CFunctions(2,iAtomPair)-1
               n2CFunctions=0
               Do i2CF=0,AP_2CFunctions(1,iAtomPair)-1
                  iS=iWork(ip0+4*i2CF+1)
                  i=iWork(ip0+4*i2CF+2)
                  jS=iWork(ip0+4*i2CF+3)
                  j=iWork(ip0+4*i2CF+4)
                  ijS=nShell_i*(jS-1)+iS
                  ij=LDF_nBasSh_Atom(iS,iAtom)*(j-1)+i
                  K=IndxG2(ij,ijS)
                  If (K.gt.0) Then
                     If (Included(K).eq.1) Then
                        iWork(ip+4*n2CFunctions)=iS
                        iWork(ip+4*n2CFunctions+1)=i
                        iWork(ip+4*n2CFunctions+2)=jS
                        iWork(ip+4*n2CFunctions+3)=j
                        n2CFunctions=n2CFunctions+1
                     End If
                  End If
               End Do
               k=4*AP_2CFunctions(1,iAtomPair)
               ip0=AP_2CFunctions(2,iAtomPair)
               Call GetMem(Label,'Free','Inte',ip0,k)
               iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=n2CFunctions
               iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=ip
            End If
         End If
      End If

      ! Deallocate Included array
      Call GetMem('Incl','Free','Inte',ip_Included,l_Included)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
!***********************************************************************
!  Author : F. Aquilante
!
!  Purpose:
!          For a given set of total symmetric AO-densities
!          (hermitian matrix representation) and MO coefficients
!          this routine
!          computes the Coulomb and Exchange contributions
!          to the Fock matrix from Cholesky vectors in full storage
!
!          The vectors are indeed read in reduced set storage
!          and then reordered.
!
!          Coulomb term (Drs is the lower triangular matrix
!                        of r=s symmetry block. The diagonals
!                        are scaled by a factor 1/2 already in
!                        the packed density DLT, given as input)
!
!    F(pq) = F(pq) + FactC * Sum_J Lpq,J * (Sum_rs Drs*Lrs,J)
!
!
!          Exchange term (Crk is the squared matrix of MO coeff.
!                             of r=s symmetry block)
!
!    F(pq) = F(pq) - FactX * Sum_Jk [(Sum_r Crk * Lpr,J) * (Sum_s Csk * Lqs,J)]
!
!
!    Integral-fashion formula:
!
!    F(pq) =  Sum_rs Drs * [(pq|rs)  - 0.5 (ps|rq)]
!
!----------------------------------------------------------------------
!  DoCoulomb(nDen) :  specifies the densities for which coulomb term
!                     has to be computed
!
!  DoExchange(nDen) : specifies the densities for which exchange term
!                     has to be computed
!
!  FactC(nDen) : factor for the coulomb of the corresponding density
!  FactX(nDen) : factor for the exchange of the corresponding density
!
!  ip{X}LT(nDen) : pointer to the array containing {X} in LT storage
!  ip{X}SQ(nDen) : pointer to the array containing {X} in SQ storage
!    {X=D,F,M --- Density, Fock matrix, MOs coeff.}
!
!  pNocc(nDen) : pointer to the array of the Occupation numbers
!                 for the corresponding density
!
!  MinMem(nSym) : minimum amount of memory required to read
!                 a single Cholesky vector in full storage
!
!***********************************************************************

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Fock_util_global, only: Deco, DensityCheck
use Data_structures, only: Deallocate_DT, DSBA_Type, Integer_Pointer, Map_to_SBA, SBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp), intent(in) :: nDen, lOff1, MinMem(*)
logical(kind=iwp), intent(in) :: DoCoulomb(nDen), DoExchange(nDen)
real(kind=wp), intent(in) :: FactC(nDen), FactX(nDen)
type(DSBA_Type), intent(in) :: DLT(nDen), DSQ(nDen), MSQ(nDen)
type(DSBA_Type), intent(inout) :: FLT(nDen), FSQ(nDen)
type(Integer_Pointer), intent(in) :: pNocc(nDen)
#include "chotime.fh"
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: i, iBatch, iE, irc, IREDC, iS, iSkip(8), iSwap, iSym, ISYMA, ISYMB, ISYMD, ISYMG, iSymp, iSymq, iSymr, &
                     iSymr_Occ, iSyms, iVec, jB, jD, jDen, jjB, jjS, jR, jS, jSR, jSym, JVEC, k, kOcc(8), KSQ1(8), KTOT, l, lChoV, &
                     LKV, lScr, LVK, LWORK, MaxSym, Naa, nBatch, NBL, NK, np, npp, nq, nr, NumV, nVec
real(kind=wp) :: TC1X1, TC1X2, TC2X1, TC2X2, TCC1, TCC2, tcoul(2), TCR1, TCR2, TCREO1, TCREO2, texch(2), TOTCPU, TOTCPU1, TOTCPU2, &
                 TOTWALL, TOTWALL1, TOTWALL2, tread(2), TW1X1, TW1X2, TW2X1, TW2X2, TWC1, TWC2, TWR1, TWR2, TWREO1, TWREO2, xf, &
                 xnormY
logical(kind=iwp) :: DoSomeC, DoSomeX, Square
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: Debug
#endif
character(len=50) :: CFmt
type(SBA_Type), target :: Wab
real(kind=wp), allocatable :: DChk(:)
real(kind=wp), pointer :: LrJs(:,:,:) => null(), Scr(:) => null(), VJ(:) => null(), XgJk(:) => null(), XkJb(:) => null(), &
                          XkJs(:) => null()
real(kind=wp), parameter :: Thr = 1.0e-12_wp
logical(kind=iwp), parameter :: DoRead = .true.
character(len=*), parameter :: SECNAM = 'CHO_FMO_RED'
real(kind=r8), external :: ddot_

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
Debug = .false. ! to avoid double printing in SCF-debug
DensityCheck = .true.
#endif
IREDC = -1 ! unknown reduced set in core

call CWTIME(TOTCPU1,TOTWALL1) ! start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = zero ! time read/reorder vectors
tcoul(:) = zero ! time for computing Coulomb
texch(:) = zero ! time for computing Exchange

if (DensityCheck) then
  Square = .true.
  xf = Two
  if (DECO) xf = One
  do jDen=1,nDen
    do jSym=1,nSym
      if ((nBas(jSym) /= 0) .and. (pNocc(jDen)%I1(jSym) /= 0)) then
        call mma_allocate(Dchk,nBas(jSym)**2,Label='Dchk')
        call Cho_X_Test(DSQ(jDen)%SB(jSym)%A2,nBas(jSym),Square,MSQ(jDen)%SB(jSym)%A2,pNocc(jDen)%I1(jSym),xf,Dchk,nBas(jSym)**2, &
                        Thr,irc)
        if (irc == 0) then
          write(u6,*) '*** DENSITY CHECK : OK! *** SYMM= ',jSym
        else
          write(u6,*) '*** DENSITY CHECK FAILED IN SYMMETRY: ',jSym,'FOR THE DENSITY NR. ',jDen
          xnormY = sqrt(ddot_(nBas(jSym)**2,Dchk,1,Dchk,1))
          write(u6,*) '    Norm of the residual vector = ',xnormY
        end if
        call mma_deallocate(Dchk)
      end if
    end do
  end do
end if

! Tests on the type of calculation
DoSomeC = .false.
DoSomeX = .false.
MaxSym = 0

jD = 0
do while ((jD < nDen) .and. (.not. DoSomeX))
  jD = jD+1
  DoSomeX = DoExchange(jD)
end do
jD = 0
do while ((jD < nDen) .and. (.not. DoSomeC))
  jD = jD+1
  DoSomeC = DoCoulomb(jD)
end do

if (DoSomeX) then
  MaxSym = nSym ! we want to do some exchange
else
  if (DoSomeC) then
    MaxSym = 1 ! we want to do only Coulomb
  else
    return ! we are lazy and won't do anything
  end if
end if

! *************** BIG LOOP OVER VECTORS SYMMETRY *****************
do jSym=1,MaxSym

  if (NumCho(jSym) < 1) cycle

  ! Total length of the vectors
  do i=1,nSym
    kSQ1(i) = -6666
  end do
  ! ------------------------------------------------------

  ! SET UP THE READING
  ! ------------------
  call mma_maxDBLE(LWORK)

  if (MinMem(jSym) > 0) then
    nVec = min(LWORK/MinMem(jSym),NumCho(jSym))
  else
    ! ***QUIT*** bad initialization
    write(u6,*) 'Cho_FMO_red: bad initialization'
    rc = 99
    call Abend()
    nVec = -9999 ! dummy assignment - avoid compiler warnings
  end if

  ! this is ONLY for debug:
  !      nVec = min(nVec,1)

  if (nVec > 0) then
    nBatch = (NumCho(jSym)-1)/nVec+1
  else
    ! ***QUIT*** insufficient memory
    write(u6,*) 'Cho_FMO_red: Insufficient memory for batch'
    write(u6,*) 'LWORK= ',LWORK
    write(u6,*) 'min. mem. need= ',MinMem(jSym)
    write(u6,*) 'NumCho= ',NumCho(jsym)
    write(u6,*) 'jsym= ',jsym
    rc = 33
    call Abend()
    nBatch = -9999 ! dummy assignment
  end if

  ! *************** BATCHING  *****************

  do iBatch=1,nBatch

    if (iBatch == nBatch) then
      NumV = NumCho(jSym)-nVec*(nBatch-1)
    else
      NumV = nVec
    end if

    iVec = nVec*(iBatch-1)+1

    kTOT = MinMem(jSym)*NumV
    call mma_allocate(Wab%A0,kTOT,Label='Wab')
    Wab%iSym = jSym
    Wab%nSym = nSym
    Wab%iCase = 7

    ! setup the skipping flags according to # of Occupied
    do k=1,nSym
      iSkip(k) = 0
      l = Mul(k,jsym) ! L(kl) returned if nOcc(k or l) /= 0
      if (k == l) then
        iSkip(k) = 666 ! always contribute to Coulomb
      else
        do jDen=1,nDen
          iSkip(k) = iSkip(k)+pNocc(jDen)%I1(k)+pNocc(jDen)%I1(l)
        end do
      end if
    end do

    ! Compute the total amount of memory needed to have the
    ! vectors in core (full storage)
    iE = 0
    do iSymq=1,nSym
      iSymp = Mul(jSym,iSymq)
      nq = nBas(iSymq)
      np = nBas(iSymp)

      if (nq*np <= 0) cycle
      iS = iE+1

      if ((iSymp > iSymq) .and. (iSkip(iSymp) /= 0)) then
        iE = iE+np*nq*NumV

        Wab%SB(iSymp)%A2(1:np*nq,1:NumV) => Wab%A0(iS:iE)
      else
        if ((iSymp == iSymq) .and. (iSkip(iSymp) /= 0)) then
          ! Special trick for the vector L11 ; used to store X(a,Jb)
          npp = np*(np+1)/2
          if ((iSymp == 1) .and. (jSym == 1) .and. DoSomeX) then
            iE = iE+lOff1*NumV
          else
            iE = iE+npp*NumV
          end if
          Wab%SB(iSymp)%A2(1:npp,1:NumV) => Wab%A0(iS:)
        end if
      end if
    end do

    call Map_to_SBA(Wab,KSQ1)

    lChoV = iE
    lScr = kTOT-lChoV
    Scr(1:lScr) => Wab%A0(iE+1:iE+lScr)

    ! Reading of the vectors is done in Reduced sets
    iSwap = min(1,(jSym-1)) ! L(ab,J) --> L(a,J,b) iff jSym /= 1

    call CWTIME(TCR1,TWR1)

    call CHO_X_getVfull(irc,Scr,lScr,iVEC,NumV,jSym,iSwap,IREDC,KSQ1,iSkip,DoRead)

    call CWTIME(TCR2,TWR2)
    tread(1) = tread(1)+(TCR2-TCR1)
    tread(2) = tread(2)+(TWR2-TWR1)

    Scr => null()

#   ifdef _DEBUGPRINT_
    write(u6,*) 'Batch ',iBatch,' of   ',nBatch,': NumV = ',NumV
    write(u6,*) 'Total allocated :     ',kTOT
    write(u6,*) 'Memory pointers KSQ1: ',(KSQ1(i),i=1,nSym)
    write(u6,*) 'lScr:                 ',lScr
    write(u6,*) 'lOff1:                ',lOff1
    write(u6,*) 'JSYM:                 ',jSym
#   endif
    if (irc /= 0) then
      rc = irc
      return
    end if

    ! Reading Done!
    ! ********************************************************************

    do jDen=1,nDen

      if ((jSym == 1) .and. DoCoulomb(jDen)) then

        ! *************** BEGIN COULOMB CONTRIBUTION  ****************
        !
        !       Computing the intermediate vector V(J)
        !
        ! Contraction with the density matrix
        ! -----------------------------------
        ! V{#J} <- V{#J} + sum_rr L(rr,{#J})*D(rr)
        !==========================================================

        call CWTIME(TCC1,TWC1)

        VJ(1:NumV) => Wab%A0(iE+1:iE+NumV)
        VJ(:) = Zero

        do iSymr=1,nSym
          if ((nBas(iSymr) /= 0) .and. (pNocc(jDen)%I1(isymr) /= 0)) then

            Naa = nBas(iSymr)*(nBas(iSymr)+1)/2

            call DGEMV_('T',Naa,NumV,ONE,Wab%SB(iSymr)%A2,Naa,DLT(jDen)%SB(ISYMR)%A1,1,ONE,VJ,1)

          end if
        end do

        ! Contraction with the 2nd vector
        ! -----------------------------------
        ! Fss{#J} <- Fss{#J} + FactC * sum_J L(ss,{#J})*V{#J}
        !==========================================================

        do iSyms=1,nSym
          if (nBas(iSyms) /= 0) then

            Naa = nBas(iSyms)*(nBas(iSyms)+1)/2

            call DGEMV_('N',Naa,NumV,FactC(jDen),Wab%SB(iSyms)%A2,Naa,VJ,1,ONE,FLT(jDen)%SB(ISYMS)%A1,1)

          end if
        end do

        call CWTIME(TCC2,TWC2)
        tcoul(1) = tcoul(1)+(TCC2-TCC1)
        tcoul(2) = tcoul(2)+(TWC2-TWC1)

        VJ => null()

      end if ! jSym=1 & DoCoulomb

    end do ! loop over densities for the Coulomb term

    ! *************** END COULOMB CONTRIBUTION  ****************

    ! **********************************************************
    ! WE INCLUDE THE DIAGONAL PART OF THE EXCHANGE HERE!!!!
    !
    ! ********** REORDER and SQUARE ONE VECTOR AT THE TIME *****
    !
    !     CHOVEC(nrs,numv) ---> CHOVEC(nr,numv,ns)

    if ((jSym == 1) .and. DoSomeX) then

      do iSymr=1,nSym

        iSymr_Occ = 0
        do jDen=1,nDen
          iSymr_Occ = iSymr_Occ+pNocc(jDen)%I1(iSymr)
        end do
        if ((nBas(iSymr) /= 0) .and. (iSymr_Occ /= 0)) then

          call CWTIME(TCREO1,TWREO1)

          nr = NBAS(iSymr)
          LrJs(1:nr,1:NUMV,1:nr) => Wab%A0(iE+1:iE+nr*NUMV*nr)

          do JVEC=1,NUMV

            do jR=1,NBAS(iSymr)
              do jS=jR,NBAS(iSymr)

                jSR = iTri(jS,jR)

                LrJs(jR,JVEC,jS) = Wab%SB(iSymr)%A2(jSR,JVEC)

                LrJs(jS,JVEC,jR) = Wab%SB(iSymr)%A2(jSR,JVEC)

              end do
            end do
          end do

          call CWTIME(TCREO2,TWREO2)
          tread(1) = tread(1)+(TCREO2-TCREO1)
          tread(2) = tread(2)+(TWREO2-TWREO1)

          do jDen=1,nDen

            if (DoExchange(jDen)) then

              kOcc(iSymr) = pNocc(jDen)%I1(iSymr)

              if (kOcc(iSymr) /= 0) then

                call CWTIME(TC1X1,TW1X1)

                ! Calculate intermediate:
                ! X(k,Js) = Sum(r) C(r,k) * L(r,Js).
                ! -----------------------------------
                iSyms = iSymr
                NK = kOcc(iSymr)

                XkJs(1:NK*NUMV*NBAS(ISYMR)) => Wab%A0(1:NK*NUMV*NBAS(ISYMR))

                call DGEMM_('T','N',NK,NUMV*NBAS(ISYMR),NBAS(iSYMR),ONE,MSQ(jDen)%SB(ISYMR)%A2,NBAS(ISYMR),LrJs,NBAS(ISYMR),ZERO, &
                            XkJs,NK)

                ! F(s,t) = F(s,t) - Sum(kJ) X(kJ,s)*X(kJ,t).
                !------------------------------------------
                !CALL DGEMM_('T','N',NBAS(ISYMR),NBAS(iSYMR),NK*NUMV,-FactX(jDen),XkJs,NK*NUMV,XkJs,NK*NUMV,One, &
                !            FSQ(jDen)%SB(ISYMR)%A2,NBAS(ISYMR))

                ! *** Compute only the LT part of the exchange matrix ***************

                LKV = NK*NUMV
                do jS=1,NBAS(iSymS)
                  NBL = NBAS(iSymR)-(jS-1)
                  jjS = 1+(jS-1)*LKV

                  call DGEMV_('T',LKV,NBL,-FactX(jDen),XkJs(jjS:),LKV,XkJs(jjS:),1,ONE,FSQ(jDen)%SB(ISYMR)%A2(jS:,jS),1)

                end do

                call CWTIME(TC1X2,TW1X2)
                texch(1) = texch(1)+(TC1X2-TC1X1)
                texch(2) = texch(2)+(TW1X2-TW1X1)

                XkJs => null()

              end if ! if kocc /= 0

            end if ! DoExchange(jDen)

          end do ! end of the loop over densities
          LrJs => null()

        end if ! if nbas /= 0 & iSymr_nOcc /= 0

      end do ! loop over Fock mat symmetries

    end if ! jSym=1 & DoSomeX

    ! ****************** END DIAGONAL EXCHANGE **********************
    !
    ! ************ "OFF-DIAGONAL" EXCHANGE CONTRIBUTION  ************

    if (jSym /= 1) then

      do jDen=1,nDen

        if (DoExchange(jDen)) then
          ! **** Occupation numbers needed for the Exchange term *****
          do iSym=1,nsym
            kOcc(iSym) = pNocc(jDen)%I1(iSym)
          end do
          ! **********************************************************
          ! --- COMPUTE EXCHANGE FOR OFF-DIAGONAL VECTORS

          call CWTIME(TC2X1,TW2X1)

          do ISYMG=1,NSYM

            ISYMB = Mul(ISYMG,JSYM)

            if (nBas(iSymb)*nBas(iSymg) /= 0) then

              ISYMA = ISYMB ! block diagonal Fock Matrix
              ISYMD = ISYMG ! total symmetric densities

              if ((ISYMG > ISYMB) .and. (iSkip(iSymg) /= 0)) then

                ! ---------------------------
                ! F(a,b) = - D(g,d) * (ad|gb)
                ! ---------------------------
                NK = kOcc(iSymG)

                if (NK /= 0) then

                  XkJb(1:NK*NUMV*NBAS(ISYMB)) => Wab%A0(iE+1:iE+NK*NUMV*NBAS(ISYMB))

                  ! Calculate intermediate:
                  ! X(k,Jb) = Sum(g) C(g,k) * L(g,Jb).
                  ! ----------------------------------

                  call DGEMM_('T','N',NK,NUMV*NBAS(ISYMB),NBAS(ISYMG),ONE,MSQ(jDen)%SB(ISYMG)%A2,NBAS(ISYMG),Wab%SB(ISYMG)%A2, &
                              NBAS(ISYMG),ZERO,XkJb,NK)

                  ! F(a,b) = F(a,b) - Sum(kJ) X(kJ,a) * X(kJ,b).
                  ! -------------------------------------------

                  !CALL DGEMM_('T','N',NBAS(ISYMA),NBAS(iSYMB),NK*NUMV,-FactX(jDen),Wab%SB(ISYMG)%A2,NK*NUMV,Wab%SB(ISYMG)%A2, &
                  !            NK*NUMV,One,FSQ(jDen)%SB(ISYMB)%A2,NBAS(ISYMA))

                  ! *** Compute only the LT part of the exchange matrix ***************
                  LKV = NK*NUMV
                  do jB=1,NBAS(iSymB)
                    NBL = NBAS(iSymA)-(jB-1)
                    jjB = 1+(jB-1)*LKV

                    call DGEMV_('T',LKV,NBL,-FactX(jDen),XkJb(jjB:),LKV,XkJb(jjB:),1,ONE,FSQ(JDen)%SB(ISYMB)%A2(jB:,jB),1)

                  end do
                  ! ******************************************************************

                  XkJb => null()

                end if

                ! ---------------------------
                ! F(g,d) = - D(a,b) * (ad|gb)
                ! ---------------------------
                NK = kOcc(iSymB)

                if (NK /= 0) then

                  XgJk(1:NBAS(ISYMG)*NUMV*NK) => Wab%A0(iE+1:iE+NBAS(ISYMG)*NUMV*NK)

                  ! Calculate intermediate:
                  ! X(gJ,k) = Sum(a) L(gJ,a) * C(a,k).
                  ! ----------------------------------

                  call DGEMM_('N','N',NBAS(ISYMG)*NUMV,NK,NBAS(ISYMA),ONE,Wab%SB(ISYMG)%A2,NBAS(ISYMG)*NUMV, &
                              MSQ(jDen)%SB(ISYMB)%A2,NBAS(ISYMA),ZERO,XgJk,NBAS(ISYMG)*NUMV)

                  ! F(g,d) = F(g,d) - Sum(Jk) X(g,Jk) * X(d,Jk).
                  ! -------------------------------------------

                  !CALL DGEMM_('N','T',NBAS(ISYMG),NBAS(ISYMD),NK*NUMV,-FactX(jDen),XgJk,NBAS(ISYMG),XgJk,NBAS(ISYMD),One, &
                  !            FSQ(jDen)%SB(ISYMG)%A2,NBAS(ISYMG))

                  ! *** Compute only the LT part of the exchange matrix ***************
                  LVK = NUMV*NK
                  do jD=1,NBAS(iSymD)
                    NBL = NBAS(iSymG)-(jD-1)

                    call DGEMV_('N',NBL,LVK,-FactX(jDen),XgJk(jD:),NBAS(iSymG),XgJk(jD:),NBAS(iSymD),ONE, &
                                FSQ(jDen)%SB(ISYMG)%A2(jD:,jD),1)

                  end do
                  ! ******************************************************************

                  XgJk => null()

                end if

              end if

            end if
          end do ! loop over orbital symmetries

          call CWTIME(TC2X2,TW2X2)
          texch(1) = texch(1)+(TC2X2-TC2X1)
          texch(2) = texch(2)+(TW2X2-TW2X1)

          ! ************ END "OFF-DIAGONAL" EXCHANGE CONTRIBUTION  ***********

        end if ! DoExchange section

      end do ! end of the loop over densities

    end if ! jSym /= 1

    ! Free the memory
    call Deallocate_DT(Wab)

  end do ! end of the batch procedure

end do ! loop over JSYM

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky SCF timing from '//SECNAM
  write(u6,CFmt) '------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Fock matrix construction        CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ/REORDER VECTORS                      ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COULOMB                                   ',tcoul(1),tcoul(2)
  write(u6,'(2x,A26,2f10.2)') 'EXCHANGE                                  ',texch(1),texch(2)

  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

! Print the Fock-matrix
#ifdef _DEBUGPRINT_
if (Debug) then ! to avoid double printing in SCF-debug

  write(u6,'(6X,A)') 'TEST PRINT FROM '//SECNAM
  write(u6,'(6X,A)') '***** EXCHANGE MATRIX ***** '
  do jDen=1,nDen
    write(u6,'(6X,A,I2)') 'DENSITY TYPE: ',jDen
    write(u6,'(6X,A,I2)') 'DoExchange: ',DoExchange(jDen)
    write(u6,*)
    if (DoExchange(jDen)) then
      do ISYM=1,NSYM
        NB = NBAS(ISYM)
        if (NB > 0) then
          write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
          call cho_output(FSQ(jDen)%SB(ISYM)%A2,1,NB,1,NB,NB,NB,1,u6)
        end if
      end do
    end if
  end do

end if
#endif

rc = 0

return

end subroutine CHO_FMO_red

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OFembed_dmat(Dens,nDens)

use OFembed, only: Do_OFemb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDens
real(kind=wp), intent(inout) :: Dens(nDens)
character(len=16) :: NamRfil
real(kind=wp), allocatable :: D_Var(:)

if (.not. Do_OFemb) return

call Get_NameRun(NamRfil) ! save the old RUNFILE name
call NameRun('AUXRFIL')   ! switch RUNFILE name

call mma_allocate(D_var,nDens,Label='D_var')
call get_dArray('D1aoVar',D_var,nDens)
Dens(:) = Dens-D_var
call mma_deallocate(D_Var)

call NameRun(NamRfil)   ! switch back to old RUNFILE name

return

end subroutine OFembed_dmat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Jeppe Olsen                                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GRAPW(W,Y,MINEL,MAXEL,NORB,NEL)
! A graph of strings has been defined from
!
!  MINEL(I) is the smallest allowed number of electrons in
!  orbitals 1 through I
!
!  MAXEL(I) is the largest allowed number of electrons in
!  orbitals 1 through I
!
! Set up vertex weights W
! Set up arc weights    Y
!
! Reverse lexical ordering is used with
! weights of unoccupied orbitals set to 0
!
! Jeppe Olsen

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NORB, MINEL(NORB), MAXEL(NORB), NEL
integer(kind=iwp), intent(out) :: W(NORB+1,NEL+1), Y(NORB,NEL)
integer(kind=iwp) :: IEL, IORB

W(:,:) = 0
Y(:,:) = 0

!================
!  Vertex weights
!================

! (Weight for vertex(IEL,IORB) is stored in W(IORB+1,IEL+1))
W(1,1) = 1
do IEL=0,NEL
  do IORB=1,NORB
    if ((MINEL(IORB) <= IEL) .and. (IEL <= MAXEL(IORB))) then
      if (IEL > 0) then
        W(IORB+1,IEL+1) = W(IORB,IEL+1)+W(IORB,IEL)
      else
        W(IORB+1,1) = W(IORB,1)
      end if
    end if
  end do
end do

! Weight for arc connecting vertices (IORB-1,IEL-1) and(IORB,IEL)
! is stored in Y(IORB,IEL)
! Y(IORB,IEL) = W(IORB-1,IEL)

do IEL=1,NEL
  do IORB=1,NORB
    if ((MINEL(IORB) <= IEL) .and. (IEL <= MAXEL(IORB))) Y(IORB,IEL) = W(IORB-1+1,IEL+1)
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' vertex weights'
call IWRTMA(W,NORB+1,NEL+1,NORB+1,NEL+1)
write(u6,*) ' arc weights'
call IWRTMA(Y,NORB,NEL,NORB,NEL)
#endif

end subroutine GRAPW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine vRys2Dm(xyz2D,nArg,lRys,nabMax,ncdMax,PAWP,QCWQ,B10,B00,B01,la,lb,lc,ld,IfGrad)
!***********************************************************************
!                                                                      *
!     Object: to compute the 2-dimensional integrals of the Rys        *
!             quadrature. The z components are assumed to be pre-      *
!             conditioned with the weights of the roots of the         *
!             Rys polynomial.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
! Modified loop structure for RISC 1991 R. Lindh Dept. of Theoretical  *
! Chemistry, University of Lund, Sweden.                               *
!***********************************************************************

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nArg, lRys, nabMax, ncdMax, la, lb, lc, ld
real(kind=wp), intent(inout) :: xyz2D(nArg*lRys,3,0:nabMax,0:ncdMax)
real(kind=wp), intent(in) :: PAWP(nArg*lRys,3), QCWQ(nArg*lRys,3), B10(nArg*lRys), B00(nArg*lRys), B01(nArg*lRys)
logical(kind=iwp), intent(in) :: IfGrad(3,4)
integer(kind=iwp) :: iab, iCar, icd, llab, llcd, mabMax, mcdMax
real(kind=wp) :: Fac1, Fac2, Fact
#ifdef _DEBUGPRINT_
character(len=30) :: Label
#endif

#ifdef _DEBUGPRINT_
if (nabMax > 0) call RecPrt('PAWP',' ',PAWP,nArg,lRys*3)
if (ncdMax > 0) call RecPrt('QCWQ',' ',QCWQ,nArg,lRys*3)
call RecPrt(' B10',' ',B10,nArg*lRys,3)
call RecPrt(' B00',' ',B00,nArg*lRys,3)
call RecPrt(' B01',' ',B01,nArg*lRys,3)
#endif

! Compute 2D integrals with index (0,0). Observe that the z
! component already contains the weight factor.

xyz2D(:,1:2,0,0) = One

! Compute 2D integrals with index (i,0)

do iCar=1,3
  llab = 0
  if (IfGrad(iCar,1) .or. IfGrad(iCar,2)) llab = 1
  llcd = 0
  if (IfGrad(iCar,3) .or. IfGrad(iCar,4)) llcd = 1
  mabMax = la+lb+llab
  mcdMax = lc+ld+llcd

  if (mabMax /= 0) then
    xyz2D(:,iCar,1,0) = PAWP(:,iCar)*xyz2D(:,iCar,0,0)
    if (mabMax == 2) then
      xyz2D(:,iCar,2,0) = PAWP(:,iCar)*xyz2D(:,iCar,1,0)+B10(:)*xyz2D(:,iCar,0,0)
    else if (mabMax > 2) then
      Fact = One
      do iab=1,mabMax-1
        xyz2D(:,iCar,iab+1,0) = PAWP(:,iCar)*xyz2D(:,iCar,iab,0)+Fact*B10(:)*xyz2D(:,iCar,iab-1,0)
        Fact = Fact+One
      end do
    end if
  end if

  ! Compute 2D integrals with index (0,i)

  if (mcdMax /= 0) then
    xyz2D(:,iCar,0,1) = QCWQ(:,iCar)*xyz2D(:,iCar,0,0)
    if (mcdMax == 2) then
      xyz2D(:,iCar,0,2) = QCWQ(:,iCar)*xyz2D(:,iCar,0,1)+B01(:)*xyz2D(:,iCar,0,0)
    else if (mcdMax > 2) then
      Fact = One
      do icd=1,mcdMax-1
        xyz2D(:,iCar,0,icd+1) = QCWQ(:,iCar)*xyz2D(:,iCar,0,icd)+Fact*B01(:)*xyz2D(:,iCar,0,icd-1)
        Fact = Fact+One
      end do
    end if
  end if

  ! Compute 2D integrals with index (i,iCar,j)

  if (mcdMax <= mabMax) then
    Fac1 = One
    do icd=1,mcdMax
      xyz2D(:,iCar,1,icd) = PAWP(:,iCar)*xyz2D(:,iCar,0,icd)+Fac1*B00(:)*xyz2D(:,iCar,0,icd-1)
      if (mabMax == 2) then
        xyz2D(:,iCar,2,icd) = PAWP(:,iCar)*xyz2D(:,iCar,1,icd)+B10(:)*xyz2D(:,iCar,0,icd)+Fac1*B00(:)*xyz2D(:,iCar,1,icd-1)
      else if (mabMax > 2) then
        Fac2 = One
        do iab=1,mabMax-1
          xyz2D(:,iCar,iab+1,icd) = PAWP(:,iCar)*xyz2D(:,iCar,iab,icd)+Fac2*B10(:)*xyz2D(:,iCar,iab-1,icd)+ &
                                    Fac1*B00(:)*xyz2D(:,iCar,iab,icd-1)
          Fac2 = Fac2+One
        end do
      end if
      Fac1 = Fac1+One
    end do
  else
    Fac1 = One
    do iab=1,mabMax
      xyz2D(:,iCar,iab,1) = QCWQ(:,iCar)*xyz2D(:,iCar,iab,0)+Fac1*B00(:)*xyz2D(:,iCar,iab-1,0)
      if (mcdMax == 2) then
        xyz2D(:,iCar,iab,2) = QCWQ(:,iCar)*xyz2D(:,iCar,iab,1)+B01(:)*xyz2D(:,iCar,iab,0)+Fac1*B00(:)*xyz2D(:,iCar,iab-1,1)
      else if (mcdMax > 2) then
        Fac2 = One
        do icd=1,mcdMax-1
          xyz2D(:,iCar,iab,icd+1) = QCWQ(:,iCar)*xyz2D(:,iCar,iab,icd)+Fac2*B01(:)*xyz2D(:,iCar,iab,icd-1)+ &
                                    Fac1*B00(:)*xyz2D(:,iCar,iab-1,icd)
          Fac2 = Fac2+One
        end do
      end if
      Fac1 = Fac1+One
    end do
  end if
end do

#ifdef _DEBUGPRINT_
do iab=0,nabMax
  do icd=0,ncdMax
    write(Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(x)'
    call RecPrt(Label,' ',xyz2D(:,1,iab,icd),nArg,lRys)
    write(Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(y)'
    call RecPrt(Label,' ',xyz2D(:,2,iab,icd),nArg,lRys)
    write(Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(z)'
    call RecPrt(Label,' ',xyz2D(:,3,iab,icd),nArg,lRys)
  end do
end do
#endif

return

end subroutine vRys2Dm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ADADST(IOBTP,IOBSM,IOBOFF,NIOB,JOBTP,JOBSM,JOBOFF,NJOB,
     &                  IJORD,ICLS,ISM,IGRP,KMIN,KMAX,I1,XI1S,NK,
     &                  NKDIM,IEND)
*
*
* Obtain mappings
* a+IORB a+ JORB !KSTR> = +/-!ISTR>
* Where IORB belongs to orbitals IOBTP,IOBSM
* and JORB belongs to JOBTP,JOBSM
* In the form
* I1(KSTR) =  ISTR if a+IORB a+ JORB !KSTR> = +/-!ISTR> , ISTR is in
* ICLS,ISM,IGRP.
* (numbering relative to TS start)
*
* Above +/- is stored in XI1S
* Number of K strings checked is returned in NK
* Only Kstrings with relative numbers from KMIN to KMAX are included
*
* If IEND .ne. 0 last string has been checked
*
* Jeppe Olsen , Winter of 1991
*
* ======
*. Input
* ======
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "detdim.fh"
#include "WrkSpc.fh"
#include "orbinp_mclr.fh"
#include "strinp_mclr.fh"
#include "stinf_mclr.fh"
#include "strbas_mclr.fh"
*
* =======
*. Output
* =======
*
      INTEGER I1(NKDIM,*)
      DIMENSION XI1S(NKDIM,*)
*
      JGRP = IGRP + 1
      IF(IUNIQMP(JGRP).NE.JGRP) THEN
         JGRP = -IUNIQMP(JGRP)
C         write(6,*) ' Unique string group for mappings ',JGRP
      END IF
*. Are the creation arrays full or in compact form
*. N-1 => N
      IF(ISTAC(JGRP,1).NE.0.AND.ISTAC(JGRP,2).NE.0) THEN
         I1MPF = 1
         L1MP = NACOB
       ELSE
         I1MPF = 0
         L1MP = 0
       END IF
*
      KGRP = IGRP + 2
      IF(IUNIQMP(KGRP).NE.KGRP) THEN
        KGRP = -IUNIQMP(KGRP)
C        write(6,*) ' Unique string group for mappings ',KGRP
      END IF
*. N-2 => N-1
      IF(ISTAC(KGRP,1).NE.0.AND.ISTAC(KGRP,2).NE.0) THEN
         I2MPF = 1
         L2MP = NACOB
      ELSE
         I2MPF = 0
         L2MP = 0
      END IF
*
      CALL ADADS1(NK,I1,XI1S,IOBSM,IOBTP,IOBOFF,NIOB,
     &           JOBSM,JOBTP,JOBOFF,NJOB,IJORD,NKDIM,
     &           ICLS,ISM,iWORK(KSTSTM(KGRP,1)),
     &           iWORK(KSTSTM(KGRP,2)),I2MPF,L2MP,
     &           iWORK(KSTSTMI(KGRP)), iWORK(KSTSTMN(KGRP)),
     &           iWORK(KSTSTM(JGRP,1)),iWORK(KSTSTM(JGRP,2)),
     &           I1MPF,L1MP,
     &           iWORK(KSTSTMI(JGRP)), iWORK(KSTSTMN(JGRP)),
     &           iWORK(KEL1(IGRP)),
     &           iWORK(KEL3(IGRP)),iWORK(KEL1(IGRP+2)),
     &           iWORK(KEL3(IGRP+2)),iWORK(KISTSO(IGRP)),
     &           iWORK(KNSTSO(IGRP)),iWORK(KISTSO(IGRP+2)),
     &           iWORK(KNSTSO(IGRP+2)),NOCTYP(IGRP),NOCTYP(IGRP+2),
     &           NORB1,NORB2,NORB3,NACOB,KMAX,KMIN,IEND)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine genovlp(Lhigh,coulovlp,eval)
!bs generates overlap of normalized  primitives.

use AMFI_global, only: Lmax, MxprimL, normovlp, nprimit, OVLPinv, rootOVLP, rootOVLPinv
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lhigh
real(kind=wp), intent(in) :: coulovlp(MxprimL,MxprimL,-1:1,-1:1,0:Lmax,0:Lmax)
real(kind=wp), intent(out) :: eval(MxprimL)
integer(kind=iwp) :: ipnt, Irun, Jrun, L, n
real(kind=wp) :: fact
real(kind=wp), allocatable :: evecinv(:,:)
real(kind=wp), allocatable, target :: scratch(:)
real(kind=wp), pointer :: tmp(:,:)

call mma_allocate(evecinv,MxprimL,MxprimL,label='evecinv')
call mma_allocate(scratch,MxprimL**2,label='scratch')
tmp(1:MxprimL,1:MxprimL) => scratch

do L=0,Lhigh
  n = nprimit(L)
  normovlp(1:n,1:n,L) = coulovlp(1:n,1:n,0,0,L,L)
  !bs invert the matrix, not very elegant, but sufficient
  ipnt = 0
  do jrun=1,n
    do irun=1,jrun
      ipnt = ipnt+1
      scratch(ipnt) = normovlp(irun,jrun,L)
    end do
  end do
  evecinv(:,1:n) = Zero
  do Jrun=1,n
    evecinv(jrun,jrun) = One
  end do
  call Jacob(scratch,evecinv,n,MxprimL)
  do irun=1,n
    eval(irun) = sqrt(scratch((irun*(irun+1))/2))
  end do
  !bs ensure normalization of the vectors.
  do IRUN=1,n
    fact = Zero
    do JRUN=1,n
      fact = fact+evecinv(JRUN,IRUN)*evecinv(JRUN,IRUN)
    end do
    fact = One/sqrt(fact)
    evecinv(:,IRUN) = fact*evecinv(:,IRUN)
  end do
  !bs now generate rootOVLP
  do irun=1,n
    tmp(1:n,irun) = eval(irun)*evecinv(1:n,irun)
  end do
  call dgemm_('N','T',n,n,n,One,evecinv,MxprimL,tmp,MxprimL,Zero,rootOVLP(:,:,L),MxprimL)
  !bs now generate rootOVLPinv
  do irun=1,n
    tmp(1:n,irun) = evecinv(1:n,irun)/eval(irun)
  end do
  call dgemm_('N','T',n,n,n,One,evecinv,MxprimL,tmp,MxprimL,Zero,rootOVLPinv(:,:,L),MxprimL)
  !bs now generate OVLPinv
  do irun=1,n
    tmp(1:n,irun) = evecinv(1:n,irun)/eval(irun)**2
  end do
  call dgemm_('N','T',n,n,n,One,evecinv,MxprimL,tmp,MxprimL,Zero,OVLPinv(:,:,L),MxprimL)
end do

nullify(tmp)
call mma_deallocate(evecinv)
call mma_deallocate(scratch)

return

end subroutine genovlp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Markus P. Fuelscher                              *
!***********************************************************************

subroutine UPKVEC(NITEM,ICVEC,CVEC)
!***********************************************************************
!
! PURPOSE:
! DECODE THE CI-VECTOR BY CHANGING THE NUMBER REPRESENTATION FROM
! INTEGER*4 ==> REAL*8
!
!**** M.P. FUELSCHER, UNIVERSITY OF LUND, SWEDEN, NOV. 1990 ************

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NITEM, ICVEC(NITEM)
real(kind=wp), intent(out) :: CVEC(NITEM)
integer(kind=iwp) :: ITEM
real(kind=wp), parameter :: SCL = One/2147483647.0_wp

do ITEM=1,NITEM
  CVEC(ITEM) = SCL*real(ICVEC(ITEM),kind=wp)
end do

return

end subroutine UPKVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_B(BB,dima,dimb,dimbe,dimga,adda,addb,addbe,addga)
! this routine tests L2

use chcc_global, only: Bc
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimbe, dimga, adda, addb, addbe, addga
real(kind=wp), intent(inout) :: BB(dima,dimbe,dimb,dimga)
integer(kind=iwp) :: a, b, bad, be, ga, ntot
real(kind=wp) :: s

bad = 0
ntot = 0

do ga=addga+1,addga+dimga
  do b=addb+1,addb+dimb
    do be=addbe+1,addbe+dimbe
      do a=adda+1,adda+dima

        s = Bc(a,b,be,ga)

        if (abs(BB(a-adda,be-addbe,b-addb,ga-addga)-s) > 1.0e-10_wp) then
          bad = bad+1
          BB(a-adda,be-addbe,b-addb,ga-addga) = s
        end if
        ntot = ntot+1

      end do
    end do
  end do
end do

write(u6,*) ' B test ',bad,ntot

return

end subroutine Chck_B

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine MakeMO(AOInt,Temp,nTemp,n_Int,iCmp,iCmpa,ibasi,jbasj,kbask,lbasl,nGr,Indx,moip,naco,nop,indgrd,ishll, &
                  ishell,rmoin,nmoin,iuvwx,iaost,buffer,ianga)
! this is the driver for the two index transformation
! it is not very efficent, but on the other hand it
! usually to take more than a few percent of the total
! CPU time, if someone notice something else I will
! rewrite it, in the mean time, dont worry.

use Basis_Info, only: Shells
use Symmetry_Info, only: nIrrep
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nTemp, n_Int, icmp(4), iCmpa(4), ibasi, jbasj, kbask, lbasl, nGr, Indx(3,4), moip(0:7), naco, &
                                 nop(4), indgrd(3,4,0:nirrep-1), ishll(4), ishell(4), nmoin, iuvwx(4), iAOST(4), ianga(4)
real(kind=wp), intent(in) :: AOInt(n_Int)
real(kind=wp), intent(out) :: Temp(nTemp)
real(kind=wp), intent(inout) :: rmoin(nmoin), buffer(*)
integer(kind=iwp) :: ibas(4), iCar, iCent, iCnt, iGr, ii, iIrrep, iMax, ip, ip0, ip1, ip2, ip5, ipc, ipck, ipcl, ipFin, mSum, &
                     nabcd, nCk, nCl, nij, nijkl, nkl, nScrtch, ntot
logical(kind=iwp) :: lc, pert(0:7)

iMax = 0
mSum = 0
nabcd = iBasi*jBasj*kBask*lBasl
nijkl = icmp(1)*icmp(2)*icmp(3)*icmp(4)
ntot = nabcd*nijkl
iBas(1) = iBasi
iBas(2) = jBasj
iBas(3) = kBask
iBas(4) = lBasl
do ii=1,4
  imax = max(iBas(ii)*iCmp(ii),imax)
  mSum = mSum+iBas(ii)*iCmp(ii)
end do
imax = max(iMax,nAco)

ip = 1
ip0 = ip
ip = ip+nGr*ntot
ip1 = ip
nScrtch = imax**4
ip = ip+nScrtch
ip2 = ip
ip = ip+nScrtch
ip = ip+nScrtch ! some unused memory here?
ip5 = ip
ip = ip+iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)*iBas(1)*iBas(2)*iBas(3)*iBas(4)
if (ip-1 > nTemp) then
  write(u6,*) 'MakeMO: ip-1 > nTemp'
  write(u6,*) 'ip,nTemp=',ip,nTemp
  call Abend()
end if
!ip = 2
!Temp(ip-1) = Zero
!ip0 = ip
!ip = ip+nGr*ntot+1
!Temp(ip-1) = Zero
!ip1 = ip
!nScrtch = imax**4+1
!ip = ip+nScrtch
!Temp(ip-1) = Zero
!ip2 = ip
!ip = ip+nScrtch
!Temp(ip-1) = Zero
!ip3 = ip
!ip = ip+nScrtch
!Temp(ip-1) = Zero
!ip5 = ip
!ip = ip+iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)*iBas(1)*iBas(2)*iBas(3)*iBas(4)+1
!Temp(ip-1) = Zero

ipc = 1
!ipD = ipc
!nD = nACO**4
!ipC = ipC+nd
!ipci = ipc
!nCi = iBas(1)*iCmp(1)*nACO
!ipcj = ipc
!nCj = iBas(2)*iCmp(2)*nACO
ipck = ipc
nCk = iBas(3)*iCmp(3)*nACO
ipc = ipc+nCk
ipcl = ipc
nCl = iBas(4)*iCmp(4)*nAcO
ipc = ipc+nCl
nij = iCmp(1)*iBas(1)*iBas(2)*iCmp(2)
nkl = iCmp(3)*iBas(3)*iBas(4)*iCmp(4)
if (ipc-1 /= nMoIn) then
  write(u6,*) 'MakeMO: ipc-1 /= nMoIn'
  write(u6,*) 'ipc,nMoIn=',ipc,nMoIn
  call Abend()
end if

call Sort_mck(AOInt,Temp(ip0),iBas(1),iBas(2),iBas(3),iBas(4),iCmp(1),iCmp(2),iCmp(3),iCmp(4),iBas(1),iBas(2),iBas(3),iBas(4), &
              iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4),nGr,nop,ianga,ishll)

do iCent=1,4
  lc = .false.
  do iCar=1,3
    pert(0:nIrrep-1) = .false.
    lC = .false.
    do iIrrep=0,nIrrep-1
      if (IndGrd(iCar,iCent,iIrrep) /= 0) pert(iIrrep) = .true.
      if (IndGrd(iCar,iCent,iIrrep) /= 0) lC = .true.
    end do
    if (lc) then
      if (Indx(iCar,iCent) > 0) then

        iGr = Indx(icar,icent)
        call MOAcc(Temp(ip0+(iGr-1)*ntot),Temp(ip1),Temp(ip2),nScrtch,ishell,rmoin(ipCk),nCk,rmoin(ipCl),nCl,Moip,nACO,pert,nOp, &
                   ibas,icmpa,iCar,icent,indgrd,real(iuvwx(iCent),kind=wp)/real(nIrrep,kind=wp),iaost,buffer,nij,nkl, &
                   Shells(ishll(1))%nBasis,Shells(ishll(2))%nBasis,icmpa(1),icmpa(2))

      else if (Indx(iCar,iCent) < 0) then
        Temp(ip5:ip5+ntot-1) = Zero
        do iCnt=1,4
          iGr = Indx(iCar,iCnt)
          if (iGr > 0) then
            ipFin = (iGr-1)*ntot+ip0
            Temp(ip5:ip5+ntot-1) = Temp(ip5:ip5+ntot-1)-Temp(ipFin:ipFin+ntot-1)
          end if
        end do
        call MOAcc(Temp(ip5),Temp(ip1),Temp(ip2),nScrtch,ishell,rmoin(ipCk),nCk,rmoin(ipCl),nCl,moip,nACO,pert,nOp,ibas,icmpa, &
                   iCar,icent,indgrd,real(iuvwx(iCent),kind=wp)/real(nIrrep,kind=wp),iaost,buffer,nij,nkl,Shells(ishll(1))%nBasis, &
                   Shells(ishll(2))%nBasis,icmpa(1),icmpa(2))

      end if
    end if
  end do
end do

return

end subroutine MakeMO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
      Subroutine XPBE(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                   Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object: To compute the functional called x_pbe in the Density        *
* Functional Repository (http://www.cse.clrc.ac.uk/qcg/dft)            *
* Original reference article: J.P. Perdew, K. Burke, and M. Ernzerhof, *
*  "Generalized gradient approximation made simple,"                   *
*      Phys. Rev. Lett. 77 (1996) 3865-3868.                           *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author:Per Ake Malmqvist, Department of Theoretical Chemistry,  *
*             University of Lund, SWEDEN. June 2006                    *
************************************************************************
      use KSDFT_Info, only: F_xca, F_xcb, tmpB
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
#include "ksdft.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),
     &       F_xc(mGrid)
cGLM     &       F_xca(mGrid),F_xcb(mGrid),tmpB(mGrid)
* Call arguments:
* Weights(mGrid) (input) integration weights.
* Rho(nRho,mGrid) (input) Density and density derivative values,
*   Rho(1,iGrid) is rho_alpha values, Rho(2,iGrid) is rho_beta values
*   Rho(i,iGrid) is grad_rho_alpha (i=3..5 for d/dx, d/dy, d/dz)
*   Rho(i,iGrid) is grad_rho_beta  (i=6..8 for d/dx, d/dy, d/dz)
* dF_dRho (inout) are (I believe) values of derivatives of the
*   DFT functional (*NOT* derivatives of Fock matrix contributions).
* F_xc is values of the DFT energy density functional (surprised?)

* IDORD=Order of derivatives to request from XPBE:
      idord=1


      if (ispin.eq.1) then
* ispin=1 means spin zero.
* T_X: Screening threshold of total density.
        Ta=0.5D0*T_X
        do iGrid=1,mgrid
         rhoa=max(1.0D-24,Rho(ipR,iGrid))
         if(rhoa.lt.Ta) goto 110
         grdrhoa_x=Rho(ipdRx,iGrid)
         grdrhoa_y=Rho(ipdRy,iGrid)
         grdrhoa_z=Rho(ipdRz,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2

         call xpbe_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*(2.0D0*Fa)
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*dFdrhoa
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*dFdgammaaa
* Note: For xpbe, dFdgammaab is zero.
 110     continue
        end do
      else
* ispin .ne. 1, use both alpha and beta components.
        do iGrid=1,mgrid
         rhoa=max(1.0D-24,Rho(ipRa,iGrid))
         rhob=max(1.0D-24,Rho(ipRb,iGrid))
         rho_tot=rhoa+rhob
         if(rho_tot.lt.T_X) goto 210
         grdrhoa_x=Rho(ipdRxa,iGrid)
         grdrhoa_y=Rho(ipdRya,iGrid)
         grdrhoa_z=Rho(ipdRza,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         call xpbe_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)

         grdrhob_x=Rho(ipdRxb,iGrid)
         grdrhob_y=Rho(ipdRyb,iGrid)
         grdrhob_z=Rho(ipdRzb,iGrid)
         sigmabb=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
         call xpbe_(idord,rhob,sigmabb,Fb,dFdrhob,dFdgammabb,
     &          d2Fdrb2,d2Fdrbdgbb,d2Fdgbb2)

         F_xc (iGrid)=F_xc (iGrid)+Coeff*(Fa+Fb)
         F_xca(iGrid)=F_xca(iGrid)+Coeff*(Fa)
         F_xcb(iGrid)=F_xcb(iGrid)+Coeff*(   Fb)
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+Coeff*dFdrhoa
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+Coeff*dFdrhob
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
* Note: For xpbe, dFdgammaab is zero.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*dFdgammaaa
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*dFdgammabb
 210     continue
        end do
        tmpB(:)=F_xc(:)

      end if

      Return
      End

      Subroutine XPBE_(idord,rho_s,sigma_s,
     &                        f,dFdr,dFdg,d2Fdr2,d2Fdrdg,d2Fdg2)
************************************************************************
*                                                                      *
* Object: To compute the functional called x_pbe in the Density        *
* Functional Repository (http://www.cse.clrc.ac.uk/qcg/dft)            *
* Original reference article: J.P. Perdew, K. Burke, and M. Ernzerhof, *
*  "Generalized gradient approximation made simple,"                   *
*      Phys. Rev. Lett. 77 (1996) 3865-3868.                           *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author:Per Ake Malmqvist, Department of Theoretical Chemistry,  *
*             University of Lund, SWEDEN. December 2006                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Data Ckp, Cmu / 0.804D0, 0.2195149727645171D0/
      Data CkF / 3.0936677262801359310D0/
      Data CeX /-0.73855876638202240588D0/

      rho=max(1.0D-24,rho_s)
      sigma=max(1.0D-24,sigma_s)

      rthrd=(2.D0*rho)**(1.0D0/3.0D0)
      XkF=CkF*rthrd

* FX, and its derivatives wrt S:
      s2=sigma/((2.D0*rho)*XkF)**2
      s=sqrt(s2)
      Cmus2=Cmu*s2
      t=1.0D0/(Ckp+Cmus2)
      fx=(Cmus2+Ckp*(1.0D0+Cmus2))*t
      a=2.0D0*Cmu*(Ckp*t)**2
      dfxds=a*s
      d2fxds2=-a*(3.0D0*Cmus2-Ckp)*t

* The derivatives of S wrt rho (r)  and sigma (g)
      a=1.0D0/(3.0D0*rho)
      b=1.0D0/(2.0D0*sigma)
      dsdr=-4.0D0*s*a
      dsdg=s*b
      d2sdr2=-7.0D0*dsdr*a
      d2sdrdg=dsdr*b
      d2sdg2=-dsdg*b

* Thus, derivatives of fx wrt rho and sigma
      dfxdr=dsdr*dfxds
      dfxdg=dsdg*dfxds
      d2fxdr2=d2sdr2*dfxds+dsdr**2*d2fxds2
      d2fxdrdg=d2sdrdg*dfxds+dsdr*dsdg*d2fxds2
      d2fxdg2=d2sdg2*dfxds+dsdg**2*d2fxds2

* rho*XeX, and its derivatives wrt rho
      rX=rho*CeX*rthrd
      drXdr=4.0d0*rX*a
      d2rXdr2=drXdr*a

* Put it together:
      F=rX*fx
      dFdr=drXdr*fx+rX*dfxdr
      dFdg=rX*dfxdg
      d2Fdr2=d2rXdr2*fx+2.0D0*drXdr*dfxdr+rX*d2fxdr2
      d2Fdrdg=drXdr*dfxdg +rX*d2fxdrdg
      d2Fdg2=rX*d2fxdg2

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(idord)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Trnab(Win,Wout,nvec,na,nb)
      Implicit Real*8 (A-H,O-Z)
c#include "print.fh"
      Real*8 Win(na,nb,nVec), Wout(na,nb,nvec)
*
      Do iVec = 1, nVec
        Call DGeTmo(Win(1,1,ivec),na,na,nb,Wout(1,1,ivec),nb)
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Giovanni Ghigo                              *
!***********************************************************************

subroutine ChoMP2_TraA(iSym,jSym,NumV,CMO,NCMO,lUCHFV,iStrtVec_AB,nFVec)
!***********************************************************************
! Author :  Giovanni Ghigo                                             *
!           Lund University, Sweden                                    *
! Written:  October 2004                                               *
! Modified for Cholesky-MP2 May 2005                                   *
!***********************************************************************

use Cho_Tra, only: nBas, nFro, nIsh, nSsh, TCVX, TCVXist
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSym, jSym, NumV, NCMO, lUCHFV, iStrtVec_AB, nFVec
real(kind=wp), intent(in) :: CMO(NCMO)
integer(kind=iwp) :: i, iFBatch, iiVec, iStrt, iStrt0MO, iStrtVec_FAB, iVec, j, jStrt, jStrt0MO, jVec, Len_XAj, Len_XBi, Naj, Nbi, &
                     NFAB, NumFV
logical(kind=iwp) :: TCVC, TCVCt
real(kind=wp), allocatable :: XAj(:), XBi(:), FAB(:,:)

! Memory to allocate & Nr. of Cholesky vectors transformable
! A=Alpha(AO);  B=Beta(AO)
TCVC = .false.
TCVCt = .false.

NFAB = 0
Naj = 0  ! C
Nbi = 0  ! C"
Len_XAj = 0   ! C
Len_XBi = 0   ! C"
NFAB = nBas(iSym)*nBas(jSym)

! Allocate memory for Transformed Cholesky Vectors - TCVx
! TCV-C :
if (TCVXist(3,iSym,jSym)) then
  TCVC = .true.
  Len_XAj = nBas(iSym)*nIsh(jSym)
  Naj = nSsh(iSym)*nIsh(jSym)

  call mma_allocate(TCVX(3,iSym,jSym)%A,Naj,NumV,Label='TCVX')
end if
! TCV-Ct:
if (TCVXist(3,jSym,iSym)) then
  TCVCt = .true.
  Len_XBi = nBas(jSym)*nIsh(iSym)
  Nbi = nSsh(jSym)*nIsh(iSym)

  call mma_allocate(TCVX(3,jSym,iSym)%A,Nbi,NumV,Label='TCVX')
end if

iStrt = 1
do i=1,iSym-1
  iStrt = iStrt+nBas(i)*nBas(i)
end do

jStrt = 1
do j=1,jSym-1
  jStrt = jStrt+nBas(j)*nBas(j)
end do

! START LOOP iiVec
do iiVec=1,NumV,nFVec
  NumFV = max(nFVec,NumV-iiVec+1)
  iFBatch = (iiVec+nFVec-1)/nFVec

  ! Allocate memory & Load Full Cholesky Vectors - CHFV

  iStrtVec_FAB = iStrtVec_AB+nFVec*(iFBatch-1)

  call mma_allocate(FAB,nFAB,NumFV,Label='FAB')
  call RdChoVec(FAB,NFAB,NumFV,iStrtVec_FAB,lUCHFV)

  ! Start Loop jVec
  do jVec=iiVec,iiVec+NumFV-1   ! Loop  jVec
    iVec = jVec-iiVec+1

    ! 1st Half-Transformation  iBeta(AO) -> q(MO) only occupied
    ! From CHFV A(Alpha,Beta) to XAj(Alpha,jMO)
    if (TCVC) then
      jStrt0MO = jStrt+nFro(jSym)*nBas(jSym)
      call mma_allocate(XAj,Len_XAj,Label='XAj')
      call ProdsA_2(FAB(:,iVec),nBas(iSym),nBas(jSym),CMO(jStrt0MO),nIsh(jSym),XAj)
    end if
    ! From CHFV A(Alpha,Beta) to XBi(Beta,iMO)
    if (TCVCt) then
      iStrt0MO = iStrt+nFro(iSym)*nBas(iSym)
      call mma_allocate(XBi,Len_XBi,Label='XBi')
      call ProdsA_2t(FAB(:,iVec),nBas(iSym),nBas(jSym),CMO(iStrt0MO),nIsh(iSym),XBi)
    end if

    ! 2nd Half-Transformation  iAlpha(AO) -> p(MO)
    ! From XAj(Alpha,jMO) to aj(a,j)
    if (TCVC) then
      iStrt0MO = iStrt+(nFro(iSym)+nIsh(iSym))*nBas(iSym)
      call ProdsA_1(XAj,nBas(iSym),nIsh(jSym),CMO(iStrt0MO),nSsh(iSym),TCVX(3,iSym,jSym)%A(:,jVec))
    end if

    ! From XBi(Beta,jMO) to bi(b,i)
    if (TCVCt) then
      jStrt0MO = jStrt+(nFro(jSym)+nIsh(jSym))*nBas(jSym)
      call ProdsA_1(XBi,nBas(jSym),nIsh(iSym),CMO(jStrt0MO),nSsh(jSym),TCVX(3,jSym,iSym)%A(:,jVec))
    end if

    ! End of Transformations

    if (allocated(XAj)) call mma_deallocate(XAj)
    if (allocated(XBi)) call mma_deallocate(XBi)

  end do
  ! End Loop jVec

  call mma_deallocate(FAB)
end do
! END LOOP iiVec

return

end subroutine ChoMP2_TraA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine diisra (wrk,wrksize,
     & diispoint,num,
     & mapd1,mapi1,poss10,mapd2,mapi2,poss20,
     & mapd3,mapi3,poss30,mapd4,mapi4,poss40)
c
c     this routine read num vectors of amplitudes
c     form prepaired diispoint(1) - diispoint(num) files
c
c     diispoint - stack of lun numbers (I)
c     num       - number of vertors to be read (1-4) (I)
c     mapd1     - direct matrix of vector 1 (I)
c     mapi1     - inverse matrix of vector 1 (I)
c     poss10    - initial possition of vector 1 (I)
c     mapd2     - direct matrix of vector 2 (I)
c     mapi2     - inverse matrix of vector 2 (I)
c     poss20    - initial possition of vector 2 (I)
c     mapd3     - direct matrix of vector 3 (I)
c     mapi3     - inverse matrix of vector 3 (I)
c     poss30    - initial possition of vector 3 (I)
c     mapd4     - direct matrix of vector 4 (I)
c     mapi4     - inverse matrix of vector 4 (I)
c     poss40    - initial possition of vector 4 (I)
c     if there is less tahn 4 vecrors required
c     use any map's and poss's
c
#include "wrk.fh"
c
       integer diispoint(1:4)
       integer num
c
       integer mapd1(0:512,1:6)
       integer mapd2(0:512,1:6)
       integer mapd3(0:512,1:6)
       integer mapd4(0:512,1:6)
       integer mapi1(1:8,1:8,1:8)
       integer mapi2(1:8,1:8,1:8)
       integer mapi3(1:8,1:8,1:8)
       integer mapi4(1:8,1:8,1:8)
       integer poss10,poss20,poss30,poss40
c
c     help variables
c
       integer lun,rc
c
c
       if (num.eq.1) then
       lun=diispoint(1)
       call getmediate (wrk,wrksize,
     & lun,poss10,mapd1,mapi1,rc)
       else if (num.eq.2) then
       lun=diispoint(1)
       call getmediate (wrk,wrksize,
     & lun,poss10,mapd1,mapi1,rc)
       lun=diispoint(2)
       call getmediate (wrk,wrksize,
     & lun,poss20,mapd2,mapi2,rc)
       else if (num.eq.3) then
       lun=diispoint(1)
       call getmediate (wrk,wrksize,
     & lun,poss10,mapd1,mapi1,rc)
       lun=diispoint(2)
       call getmediate (wrk,wrksize,
     & lun,poss20,mapd2,mapi2,rc)
       lun=diispoint(3)
       call getmediate (wrk,wrksize,
     & lun,poss30,mapd3,mapi3,rc)
       else if (num.eq.4) then
       lun=diispoint(1)
       call getmediate (wrk,wrksize,
     & lun,poss10,mapd1,mapi1,rc)
       lun=diispoint(2)
       call getmediate (wrk,wrksize,
     & lun,poss20,mapd2,mapi2,rc)
       lun=diispoint(3)
       call getmediate (wrk,wrksize,
     & lun,poss30,mapd3,mapi3,rc)
       lun=diispoint(4)
       call getmediate (wrk,wrksize,
     & lun,poss40,mapd4,mapi4,rc)
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRIPAK(AUTPAK,APAK,IWAY,MATDIM,NDIM)
C
C ( NOT A SIMPLIFIED VERSION OF TETRAPAK )
C
C.. REFORMATING BETWEEN LOWER TRIANGULAR PACKING
C   AND FULL MATRIX FORM FOR A SYMMETRIC MATRIX
C
C   IWAY = 1 : FULL TO PACKED
C   IWAY = 2 : PACKED TO FULL FORM
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AUTPAK(MATDIM,MATDIM),APAK(*)
C
      IF( IWAY .EQ. 1 ) THEN
        IJ = 0
        DO 100 I = 1,NDIM
          DO 50  J = 1, I
           APAK(IJ+J) = AUTPAK(J,I)
   50     CONTINUE
          IJ = IJ + I
  100   CONTINUE
      END IF
C
      IF( IWAY .EQ. 2 ) THEN
        IJ = 0
        DO 200 I = 1,NDIM
          DO 150  J = 1, I
           AUTPAK(I,J) = APAK(IJ+J)
           AUTPAK(J,I) = APAK(IJ+J)
  150     CONTINUE
          IJ = IJ + I
  200   CONTINUE
      END IF
C
      NTEST = 0
      IF( NTEST .NE. 0 ) THEN
        WRITE(6,*) ' AUTPAK AND APAK FROM TRIPAK '
        CALL WRTMAT(AUTPAK,NDIM,MATDIM,NDIM,MATDIM)
        CALL PRSYM(APAK,NDIM)
      END IF
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1994, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine RysEF(xyz2D,nArg,mArg,nRys,neMin,neMax,nfMin,nfMax,EFInt,meMin,meMax,mfMin,mfMax,Scrtch,PreFct,AeqB,CeqD)
!***********************************************************************
!                                                                      *
!     Object: to compute integrals corresponding to the primitive set  *
!             used for the HRR. The primitive integrals are generated  *
!             from the 2D-integrals according to the Rys quadrature.   *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90.                                             *
!                                                                      *
!             Modified for kernel routine RysEF0 August '90.           *
!             Modified for kernel routines RysS1, RysS2, and RysS3     *
!             September '90.                                           *
!             Modified for improved vectorization August '91.          *
!             Modified for decreased memory access January '94.        *
!***********************************************************************

use Index_Functions, only: iTri_Rev
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nArg, mArg, nRys, neMin, neMax, nfMin, nfMax, meMin, meMax, mfMin, mfMax
real(kind=wp), intent(in) :: xyz2D(nRys,mArg,3,0:neMax,0:nfMax), PreFct(mArg)
real(kind=wp), intent(out) :: EFInt(nArg,meMin:meMax,mfMin:mfMax)
real(kind=wp), intent(inout) :: Scrtch(nRys,mArg)
logical(kind=iwp), intent(in) :: AeqB, CeqD
integer(kind=iwp) :: ie, ief, if_, itr(2), ixe, ixf, ixye, ixyf, iye, iyf, ne, nf, nItem, nzeMax, nzeMin, nzfMax, nzfMin
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
character(len=80) :: Label
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
ne = (neMax+1)*(neMax+2)/2
nf = (nfMax+1)*(nfMax+2)/2

do ief=1,ne*nf
  if_ = (ief-1)/ne+1
  ie = ief-(if_-1)*ne

  itr(:) = iTri_Rev(ie)
  ixye = itr(1)-1
  ixe = itr(2)-1
  iye = ixye-ixe

  itr(:) = iTri_Rev(if_)
  ixyf = itr(1)-1
  ixf = itr(2)-1
  iyf = ixyf-ixf
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  nzeMax = max(0,neMax-ixye)
  nzfMax = max(0,nfMax-ixyf)
  nzeMin = max(0,neMin-ixye)
  if (AeqB) nzeMin = nzeMax
  nzfMin = max(0,nfMin-ixyf)
  if (CeqD) nzfMin = nzfMax

  nItem = (nzeMax-nzeMin+1)*(nzfMax-nzfMin+1)
  if (nItem > 1) then

    ! Precompute for all arguments Ix*Iy, avoid multiplying with ones.

    ! Combine with possible Iz

    if (ixye+ixyf == 0) then

      call RysEF1(xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,ixye,ixyf,nzeMin,nzeMax,nzfMin, &
                  nzfMax)

    else if (ixe+ixf == 0) then

      call RysEF0(xyz2D(:,:,2,iye,iyf),xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,ixye,ixyf, &
                  nzeMin,nzeMax,nzfMin,nzfMax)

    else if (iye+iyf == 0) then

      call RysEF0(xyz2D(:,:,1,ixe,ixf),xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,ixye,ixyf, &
                  nzeMin,nzeMax,nzfMin,nzfMax)

    else

      Scrtch(:,:) = xyz2D(:,:,1,ixe,ixf)*xyz2D(:,:,2,iye,iyf)
      call RysEF0(Scrtch,xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,ixye,ixyf,nzeMin,nzeMax, &
                  nzfMin,nzfMax)

    end if

  else

    ! Here if only one triplet of 2D-integrals

    ! Contract over roots

    if (ixye+ixyf == 0) then

      call RysEF2(xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,ixye,ixyf,nzeMax,nzfMax)

    else if (ixe+ixf == 0) then

      call RysEF3(xyz2D(:,:,2,iye,iyf),xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,ixye,ixyf, &
                  nzeMax,nzfMax)

    else if (iye+iyf == 0) then

      call RysEF3(xyz2D(:,:,1,ixe,ixf),xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,ixye,ixyf, &
                  nzeMax,nzfMax)

    else

      call RysEF4(xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,ixye,ixyf,nzeMax,nzfMax)

    end if

  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end do
!                                                                      *
!***********************************************************************
!                                                                      *

#ifdef _DEBUGPRINT_
do iab=meMin,meMax
  do icd=mfMin,mfMax
    write(Label,'(A,I3,A,I3,A)') ' In RysEF: [',iab,',0|',icd,',0]'
    call RecPrt(Label,' ',EFInt(1,iab,icd),1,nArg)
  end do
end do
#endif

return

end subroutine RysEF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TODSC(A,NDIM,MBLOCK,IFIL)
C TRANSFER ARRAY REAL*8  A(LENGTH NDIM) TO DISCFIL IFIL IN
C RECORDS WITH LENGTH NBLOCK.
      IMPLICIT REAL*8 (A-H,O-Z)
#include "io_util.fh"
      DIMENSION A(NDIM)
      INTEGER START,ISTOP
      REAL*8 INPROD
      INTEGER ISCR(2)
*
      IPACK = 1
      IF(IPACK.NE.0) THEN
*. Check norm of A before writing
        XNORM = INPROD(A,A,NDIM)
        IF(XNORM.EQ.0.0D0) THEN
          IMZERO = 1
        ELSE
          IMZERO = 0
        END IF
        MMBLOCK = MBLOCK
        IF(MMBLOCK.GT.2) MMBLOCK = 2
*
        ISCR(1) = IMZERO
*. No packing
        ISCR(2) = 0
        CALL ITODS(ISCR,2,2,IFIL)
        IF(IMZERO.EQ.1) GOTO 1001
      END IF
*
C
      NBLOCK = MBLOCK
      IF ( MBLOCK .LE. 0 ) NBLOCK = NDIM
      ISTOP=0
      NBACK=NDIM
C LOOP OVER RECORDS
  100 CONTINUE
       IF(NBACK.LE.NBLOCK) THEN
         NTRANS=NBACK
         NLABEL=-NTRANS
       ELSE
         NTRANS=NBLOCK
         NLABEL=NTRANS
       END IF
       START=ISTOP+1
       ISTOP=START+NBLOCK-1
       NBACK=NBACK-NTRANS
       CALL DDAFILE(IFIL,1,A(START),ISTOP-START+1,IDISK(IFIL))
       CALL IDAFILE(IFIL,1,[NLABEL],1,IDISK(IFIL))
      IF(NBACK.NE.0) GOTO 100
*
 1001 CONTINUE
C
C?    write(6,*) ' leaving TODSC '
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SPIN_PHASE(MM,d,Zinp,Zout)
! The RASSI program gives a random phase to the spin-orbit functions.
!
! This routine performs a simple check with the obtained spin functions,
! in order to determine the phase of the spin functions.
! If the phase is not the same, Then the spin functions will be multiplied
! with the correspondind coefficient that sets the same phase to all spin
! eigenfunctions

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, cZero, cOne
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: d
complex(kind=wp), intent(in) :: mm(3,d,d), Zinp(d,d)
complex(kind=wp), intent(out) :: Zout(d,d)
integer(kind=iwp) :: i, i1, i2, j
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: l
#endif
real(kind=wp), allocatable :: rxi(:), rxr(:)
complex(kind=wp), allocatable :: mm_tmp(:,:), phs(:,:,:), r(:), tmp(:,:)

call mma_allocate(rxr,d,'rxr')
call mma_allocate(rxi,d,'rxi')
call mma_allocate(r,d,'r')
call mma_allocate(mm_tmp,d,d,'mm_tmp')
call mma_allocate(phs,d,d,3,'phs')
call mma_allocate(tmp,d,d,'tmp')
!-----------------------------------------------------------------------
phs(:,:,:) = cZero
r(:) = czero
rxr(:) = Zero
rxi(:) = Zero
rxi(1) = Zero
r(1) = cOne

do i=1,d-1
  j = i+1
  Zout(:,1) = Zinp(:,1)

  do i1=1,d
    do i2=1,d
      phs(i,j,1) = phs(i,j,1)+MM(1,i1,i2)*conjg(Zout(i1,i))*Zinp(i2,j)
    end do
  end do

  if (abs(phs(i,j,1)) > 1.0e-14_wp) then
    rxr(j) = real(phs(i,j,1))/abs(phs(i,j,1))
    rxi(j) = aimag(phs(i,j,1))/abs(phs(i,j,1))
  else
    rxr(j) = One
    rxi(j) = Zero
  end if

  r(j) = cmplx(rxr(j),rxi(j),kind=wp)

  Zout(:,j) = conjg(r(j))*Zinp(:,j)

# ifdef _DEBUGPRINT_
  write(u6,'(A,i2,A,2ES24.14)') 'SPIN-PHASE: R(',j,') = ',conjg(r(j))
# endif
end do ! i

mm_tmp(:,:) = mm(1,:,:)
call zgemm_('C','N',d,d,d,cOne,Zout,d,mm_tmp,d,cZero,TMP,d)
call zgemm_('N','N',d,d,d,cOne,TMP,d,Zout,d,cZero,phs(:,:,1),d)
! convention:
!    mX(i,i+1) => Real, negative
!    mY(i,i+1) => imag, positive
!    mZ(i,i)   => diagonal
do i=1,d-1,2
  j = i+1
  if (real(phs(i,j,1)) > Zero) Zout(:,j) = -Zout(:,j)
end do

#ifdef _DEBUGPRINT_
do l=1,3
  mm_tmp(:,:) = mm(l,:,:)
  call zgemm_('C','N',d,d,d,cOne,Zout,d,mm_tmp,d,cZero,TMP,d)
  call zgemm_('N','N',d,d,d,cOne,TMP,d,Zout,d,cZero,phs(:,:,l),d)
end do

do i=1,d
  do j=1,d
    write(u6,'(a,i2,a,i2,a,2ES24.14)') 'SPIN-PHASE:  Zout(',i,',',j,') = ',Zout(i,j)
  end do
end do

write(u6,'(//)')
do i=1,d
  do j=1,d
    if ((j == i-1) .or. (j == i+1)) &
      write(u6,'(A,i2,A,i2,A, 3(2ES24.14,3x))') 'SPIN-PHASE: PHS(',i,',',j,') = (x,y,z) =',(phs(i,j,l),l=1,3)
  end do
end do
#endif

!-----------------------------------------------------------------------
call mma_deallocate(rxr)
call mma_deallocate(rxi)
call mma_deallocate(r)
call mma_deallocate(mm_tmp)
call mma_deallocate(phs)
call mma_deallocate(tmp)

return

end subroutine SPIN_PHASE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine RHS_SCATTER(LDW,lg_W,Buff,idxW,nBuff)
!SVC: this routine scatters + adds values of a buffer array into the RHS
!     array at positions given by the buffer index array.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
#endif
use fake_GA, only: GA_Arrays
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LDW, lg_W, nBuff, idxW(nBuff)
real(kind=wp), intent(in) :: Buff(nBuff)
integer(kind=iwp) :: I
#ifdef _MOLCAS_MPP_
integer(kind=iwp), allocatable :: TMPW1(:), TMPW2(:)
#else
#include "macros.fh"
unused_var(LDW)
#endif

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  !SVC: global array RHS matrix expects 2 index buffers
  call mma_allocate(TMPW1,nBuff,Label='TMPW1')
  call mma_allocate(TMPW2,nBuff,Label='TMPW2')
  do I=1,nBuff
    TMPW2(I) = (idxW(I)-1)/LDW+1
    TMPW1(I) = idxW(I)-LDW*(TMPW2(I)-1)
  end do
  call GA_Scatter_Acc(lg_W,Buff,TMPW1,TMPW2,nBuff,One)
  call mma_deallocate(TMPW1)
  call mma_deallocate(TMPW2)
else
#endif
  do I=1,nBuff
    GA_Arrays(lg_W)%A(idxW(I)) = GA_Arrays(lg_W)%A(idxW(I))+BUFF(I)
  end do
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine RHS_SCATTER

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  PMLoc
*
*> @brief
*>   Pipek--Mezey localization of occupied orbitals
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Performs iterative (Jacobi sweeps) Pipek--Mezey localization of
*> molecular orbitals. CMO is assumed to be the full set of
*> orbitals, but only the first \p nOcc will be localized. On exit,
*> the localized MOs are returned in CMO.
*> Note that symmetry is not allowed.
*>
*> If successful, \p irc = ``0`` is returned. If \p irc = ``-1``
*> is returned, an error was found in the input and nothing has
*> been done. If \p irc = ``1`` is returned, the iterative procedure did
*> not converge to within the threshold (\p Thr, \p ThrGrad) in the
*> requested max. number of iterations (\p MxIter). If the user
*> specifies negative thresholds, \p Thr = ``1.0d-6`` and \p ThrGrad = ``1.0d-3``
*> will be used.
*> If the user specifies a negative screening threshold,
*> \p ThrRot = ``1.0d-10`` is used.
*>
*> @param[out]    irc     Return code
*> @param[in,out] CMO     Molecular orbital coefficients
*> @param[in]     Thr     Threshold for functional
*> @param[in]     ThrGrad Threshold for gradient
*> @param[in]     ThrRot  Screening threshold
*> @param[in]     MxIter  Max. number of iterations
*> @param[in]     nBas    Number of basis functions per irrep
*> @param[in]     nOcc    Number of occupied orbitals to localize
*> @param[in]     nFro    Number of frozen occupied orbitals
*> @param[in]     nSym    Number of irreps
*> @param[in]     Silent  Flag to avoid printing
************************************************************************
      SubRoutine PMLoc(irc,CMO,Thr,ThrGrad,ThrRot,MxIter,nBas,nOcc,nFro,
     &                 nSym,Silent)
      Implicit Real*8 (a-h,o-z)
      Real*8  CMO(*)
      Integer nBas(nSym), nOcc(nSym), nFro(nSym)
      Logical Silent
#include "Molcas.fh"

      Character*5 SecNam
      Parameter (SecNam = 'PMLoc')

      Character*(LENIN8)  myName(MxAtom)
      Character*80 Txt
      Logical Maximization, Converged, Debug

C     Initialization.
C     ---------------

      irc = 0
      If (MxIter .lt. 1) Return

      nBasT = nBas(1)
      Do iSym = 2,nSym
         nBasT = nBasT + nBas(iSym)
      End Do
      If (nBasT .lt. 1) Return

      nOccT = nOcc(1)
      Do iSym = 2,nSym
         nOccT = nOccT + nOcc(iSym)
      End Do
      If (nOccT .lt. 1) Return

C     Pipek-Mezey does not work with symmetry.
C     TODO/FIXME: we might consider de-symmetrization.
C     ------------------------------------------------

      If (nSym .ne. 1) Then
         irc = -1
         Return
      End If

C     Read number of atoms, atomic labels, and basis functions labels
C     from runfile.
C     ---------------------------------------------------------------

      Call Get_nAtoms_All(nAtoms)
      If (nAtoms.lt.1 .or. nAtoms.gt.MxAtom) Then
         Write(Txt,'(A,I9)') 'nAtoms =',nAtoms
         Call SysAbendMsg(SecNam,'Atom limit exceeded!',Txt)
      End If
      Call Get_cArray('Unique Basis Names',myName,LENIN8*nBasT)

C     Localize.
C     ---------

      Functional = -9.9d9
      If (Thr .le. 0.0d0) Then
         ThrLoc = 1.0d-6
      Else
         ThrLoc = Thr
      End If
      If (ThrGrad .le. 0.0d0) Then
         ThrGLoc = 1.0d-3
      Else
         ThrGLoc = ThrGrad
      End If
      If (ThrRot .lt. 0.0d0) Then
         ThrRotLoc = 1.0d-10
      Else
         ThrRotLoc = ThrRot
      End If
      Maximization = .True.
      Converged = .False.
      Debug = .False.
      Call PipekMezey(Functional,CMO,ThrLoc,ThrRotLoc,ThrGLoc,myName,
     &                nBas,nOcc,nFro,nSym,nAtoms,MxIter,
     &                Maximization,Converged,Debug,Silent)

C     Check convergence.
C     ------------------

      If (.not. Converged) irc = 1

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000-2016, Valera Veryazov                             *
************************************************************************
******************************************************************************
*                                                                            *
* Author:   Valera Veryazov 2000-2016                                        *
*           Theoretical Chemistry                                            *
*           Lund University                                                  *
*           Sweden                                                           *
*                                                                            *
******************************************************************************
       Subroutine StdIn_Name(Name)
       Character*(*) Name
       Character*132 Line
*
       nName=LEN(Name)
       If (nName.ne.16) Then
          Write (6,*) 'StdIn_Name: Wrong length of character Name'
          Call Abend()
       End If
C      Write (*,*) 'nName=',nName
*
       Name='Stdin.  '
       Call GetEnvf('EMIL_RC2',Line)
       Read (Line,'(I132.132)') Iter
c      Write (*,*) 'Line=',Line
c      Write (*,*) 'Iter=',Iter
       Iter = Iter+1
       If (Line(1:1).eq.' ') Then
          Name(7:7)='2'
       Else If (Iter.le.9) Then
          Write (Name(7:7),'(I1)') Iter
       Else If (Iter.le.99) Then
          Write (Name(7:8),'(I2)') Iter
       Else
          Write (6,*) 'StdIn_Name: Error in Line!'
          Call Abend()
       End If
       Line=' '
       Call GetEnvf('EMIL_InLoop',Line)
       ib=-1
       ie=-1
       i=1
10     continue
        if(Line(i:i).ne.' '.and. ib.eq.-1) then
           ib=i
           goto 20
        endif
        if(Line(i:i).eq.' '.and.ib.gt.0) then
           ie=i
           goto 30
        endif
20      i=i+1
        goto 10
30      Name(index(Name,' '):)='.'//Line(ib:ie)
c        write(*,*) '>',Line,'<', ib, ie
c       Write (6,*) 'StdIn=',Name
*
       Return
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine unpackab2 (wrk,wrksize,
     & mapdn,mapin,mapdr1,mapir1,mapdr2,mapir2,
     &                       mapdr3,mapir3,
     & mapdr4,mapir4,mapdr5,mapir5,mapdr6,mapir6,ssn,key,aeqb)
c
c     mapdn - direct map matrix corresponding to N (Input)
c     mapin - direct map matrix corresponding to N (Input)
c     mapdr1- inverse map matrix corresponding to R1 (Input)
c     mapir1- inverse map matrix corresponding to R1 (Input)
c     mapdr2- inverse map matrix corresponding to R2 (Input)
c     mapir2- inverse map matrix corresponding to R2 (Input)
c     mapdr3- inverse map matrix corresponding to R3 (Input)
c     mapir3- inverse map matrix corresponding to R3 (Input)
c     mapdr4- inverse map matrix corresponding to R4 (Input)
c     mapir4- inverse map matrix corresponding to R4 (Input)
c     mapdr5- inverse map matrix corresponding to R4 (Input)
c     mapir5- inverse map matrix corresponding to R4 (Input)
c     mapdr6- inverse map matrix corresponding to R4 (Input)
c     mapir6- inverse map matrix corresponding to R4 (Input)
c     ssn   - overall symmtry state of N (Input)
c     key   - define state of _a,_b  key   a, b (Input)
c     1    S  S
c     2    V  S
c     3    S  V
c     4    V  V
c     aqeb  - aqeb=0 if a.ne.b; =1 if a=b (Input)
c
c     this routine unpack: N _a_b (p,q) = <ab|pq>              key   aeqb
c     N _a_b (p,q) a>=b-aa  -> R1 _a,_b(j,e)aaaa = <ab||je>     4     0
c     -> R2 _a,_b(j,e)bbbb = <ab||je>    1-4    0
c     -> R3 _a,_b(j,e)abab = <ab||je>    3,4   0,1
c     -> R4 _b,_a(j,e)abab = <ba||je>    2,4   0,1
c     -> R5 _a,_b(j,e)abba = <ab||je>    3,4   0,1
c     -> R6 _b,_a(j,e)abba = <ba||je>    2,4   0,1
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer mapdn(0:512,1:6)
       integer mapdr1(0:512,1:6)
       integer mapdr2(0:512,1:6)
       integer mapdr3(0:512,1:6)
       integer mapdr4(0:512,1:6)
       integer mapdr5(0:512,1:6)
       integer mapdr6(0:512,1:6)
c
       integer mapin(1:8,1:8,1:8)
       integer mapir1(1:8,1:8,1:8)
       integer mapir2(1:8,1:8,1:8)
       integer mapir3(1:8,1:8,1:8)
       integer mapir4(1:8,1:8,1:8)
       integer mapir5(1:8,1:8,1:8)
       integer mapir6(1:8,1:8,1:8)
c
       integer ssn,key,aeqb
c
c     help variables
c
       integer symp,symq,dimp,dimq,dime,dimj
       integer in,inm,inp,ir1,ir2,ir3,ir4,ir5,ir6
       integer possn,possnp,possnm,possr1,possr2,possr3,possr4,possr5,
     & possr6
       integer lengthn
c
       do 1000 symp=1,nsym
       symq=mmul(ssn,symp)
c
       in=mapin(symp,1,1)
       lengthn=mapdn(in,2)
c
       if (lengthn.eq.0) goto 1000
c
       if (symp.eq.symq) then
c     symp=symq
c
       possn=mapdn(in,1)
       dimp=dimm(5,symp)
c
cI.1  def R1 - _a_b(j,e)aaaa
c
       if ((key.eq.4).and.(aeqb.eq.0)) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dimj=noa(symp)
       dime=nva(symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp5 (wrk(possn),wrk(possr1),dimp,dimj,dime,
     & 0,noa(symp),noa(symp),nva(symp))
       end if
       end if
c
cI.2  def R2 - _a_b(j,e)bbbb
c
       if (aeqb.eq.0) then
       ir2=mapir2(symp,1,1)
       possr2=mapdr2(ir2,1)
       dimj=nob(symp)
       dime=nvb(symq)
       if (mapdr2(ir2,2).gt.0) then
       call unpckhelp5 (wrk(possn),wrk(possr2),dimp,dimj,dime,
     & 0,nob(symp),nob(symp),nvb(symp))
       end if
       end if
c
cI.3  def R3 - _a_b(j,e)abba
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir3=mapir3(symp,1,1)
       possr3=mapdr3(ir3,1)
       dimj=nob(symp)
       dime=nva(symq)
       if (mapdr3(ir3,2).gt.0) then
       call unpckhelp7 (wrk(possn),wrk(possr3),dimp,dimp,dimj,
     & dime,0,nob(symp),noa(symq),nva(symq))
       end if
       end if
c
cI.4  def R4 - _b_a(j,e)abba
c
       if (((key.eq.3).or.(key.eq.4)).and.(aeqb.eq.0)) then
       ir4=mapir4(symp,1,1)
       possr4=mapdr4(ir4,1)
       dimj=nob(symp)
       dime=nva(symq)
       if (mapdr4(ir4,2).gt.0) then
       call unpckhelp6 (wrk(possn),wrk(possr4),dimp,dimp,dimj,
     & dime,0,nob(symp),noa(symq),nva(symq))
       end if
       end if
c
cI.5  def R5 - _a_b (j,e)abab
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir5=mapir5(symp,1,1)
       possr5=mapdr5(ir5,1)
       dimj=noa(symp)
       dime=nvb(symq)
       if (mapdr5(ir5,2).gt.0) then
       call unpckhelp3 (wrk(possn),wrk(possr5),dimp,dimp,dimj,
     & dime,0,noa(symp),nob(symq),nvb(symq))
       end if
       end if
c
cI.6  def R6 - _b_a(j,e)abab
c
       if (((key.eq.3).or.(key.eq.4)).and.(aeqb.eq.0)) then
       ir6=mapir6(symp,1,1)
       possr6=mapdr6(ir6,1)
       dimj=noa(symp)
       dime=nvb(symq)
       if (mapdr6(ir6,2).gt.0) then
       call unpckhelp4 (wrk(possn),wrk(possr6),dimp,dimp,dimj,
     & dime,0,noa(symp),nob(symq),nvb(symq))
       end if
       end if
c
       else
c     symp.ne.symq
c
       inp=mapin(symp,1,1)
       inm=mapin(symq,1,1)
       possnp=mapdn(inp,1)
       possnm=mapdn(inm,1)
       dimp=dimm(5,symp)
       dimq=dimm(5,symq)
c
cII.1 def R1 - _a_b(j,e)aaaa
c
       if (key.eq.4) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dimj=noa(symp)
       dime=nva(symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp2 (wrk(possnp),wrk(possnm),wrk(possr1),dimp,dimq,
     &                  dimj,dime,
     & 0,noa(symp),noa(symq),nva(symq))
       end if
       end if
c
cII.2 def R2 - _a_b(j,e)bbbb
c
       ir2=mapir2(symp,1,1)
       possr2=mapdr2(ir2,1)
       dimj=nob(symp)
       dime=nvb(symq)
       if (mapdr2(ir2,2).gt.0) then
       call unpckhelp2 (wrk(possnp),wrk(possnm),wrk(possr2),dimp,dimq,
     &                  dimj,dime,
     & 0,nob(symp),nob(symq),nvb(symq))
       end if
c
cII.3 def R3 - _a_b(j,e)abba
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir3=mapir3(symq,1,1)
       possr3=mapdr3(ir3,1)
       dimj=nob(symq)
       dime=nva(symp)
       if (mapdr3(ir3,2).gt.0) then
       call unpckhelp7 (wrk(possnp),wrk(possr3),dimp,dimq,dimj,dime,
     & 0,nob(symq),noa(symp),nva(symp))
       end if
       end if
c
cII.4 def R4 - _b_a(j,e)abba
c
       if ((key.eq.3).or.(key.eq.4)) then
       ir4=mapir4(symp,1,1)
       possr4=mapdr4(ir4,1)
       dimj=nob(symp)
       dime=nva(symq)
       if (mapdr4(ir4,2).gt.0) then
       call unpckhelp6 (wrk(possnp),wrk(possr4),dimp,dimq,dimj,dime,
     & 0,nob(symp),noa(symq),nva(symq))
       end if
       end if
c
cII.5 def R5 - _a_b(j,e)abab
c
       if ((key.eq.2).or.(key.eq.4)) then
       ir5=mapir5(symp,1,1)
       possr5=mapdr5(ir5,1)
       dimj=noa(symp)
       dime=nvb(symq)
       if (mapdr5(ir5,2).gt.0) then
       call unpckhelp3 (wrk(possnp),wrk(possr5),dimp,dimq,dimj,dime,
     & 0,noa(symp),nob(symq),nvb(symq))
       end if
       end if
c
cII.6 def R6 - _b_a(j,e)abab
c
       if ((key.eq.3).or.(key.eq.4)) then
       ir6=mapir6(symq,1,1)
       possr6=mapdr6(ir6,1)
       dimj=noa(symq)
       dime=nvb(symp)
       if (mapdr6(ir6,2).gt.0) then
       call unpckhelp4 (wrk(possnp),wrk(possr6),dimp,dimq,dimj,dime,
     & 0,noa(symq),nob(symp),nvb(symp))
       end if
       end if
c
       end if
c
 1000   continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NewCar(Iter,nAtom,Coor,mTtAtm,Error)
      use Slapaf_Info, only: Cx, qInt, RefGeo, BMx, Shift, Degen,
     &                       AtomLbl, Lbl
      use Symmetry_Info, only: VarR, VarT
      use Slapaf_Parameters, only: Curvilinear, User_Def, BSet, HSet,
     &                             lOld, WeightedConstraints
      Implicit Real*8 (a-h,o-z)
************************************************************************
*                                                                      *
*     Object: To compute the new symm. distinct Cartesian coordinates  *
*             from the suggested shift of the internal coordinates.    *
*                                                                      *
************************************************************************
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "Molcas.fh"
#include "warnings.h"
      Parameter(NRHS=1)
      Integer, Intent(In):: Iter, nAtom
      Real*8,  Intent(InOut):: Coor(3,nAtom)
      Integer, Intent(In):: mTtAtm
      Logical, Intent(InOut):: Error
*
      Logical:: BSet_Save, HSet_Save, lOld_Save
      Real*8, Allocatable:: DFC(:), dss(:), rInt(:)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Call RecPrt('NewCar: q',' ',qInt,nQQ,iter+1)
      Call RecPrt('NewCar: Shift',' ',Shift,nQQ,iter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      nQQ = SIZE(qInt,1)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(DFC,3*nAtom,Label='DFC')
      Call mma_allocate(dss,nQQ,Label='dss')
      Call mma_allocate(rInt,nQQ,Label='rInt')
*                                                                      *
************************************************************************
*                                                                      *
      rInt(:) = qInt(:,iter)
      dss(:) = Shift(:,iter)
      rInt(:) = rInt(:) + dss(:)
*                                                                      *
************************************************************************
*                                                                      *
      Lu=6
      iRout = 33
      iPrint=nPrint(iRout)
      If (iPrint.ge.11) Then
         Write (Lu,*)
         Write (Lu,*) ' *** Transforming internal coordinates'
     &             //' to Cartesian ***'
         Write (Lu,*)
         Write (Lu,*) ' Iter  Internal  Error'
      End If
*
      If (iPrint.ge.99) Then
         Write (Lu,*)
         Write (Lu,*) ' In NewCar: Shifts'
         Write (Lu,*)
         Write (Lu,'(1X,A,2X,F10.4)') (Lbl(iInter),dss(iInter),
     &          iInter=1,nQQ)
         Call RecPrt(' In NewCar: qInt',' ',qInt,nQQ,
     &               Iter+1)
      End If
*
*     Compute the final internal coordinates, plus sign due to the use
*     of forces and not gradients.
*
      rMax = Zero
      iMax = 0
      jter = 0
      Do i = 1, nQQ
         If (Abs(dss(i)) .gt. Abs(rMax)) Then
            rMax = dss(i)
            iMax = i
         End If
      End Do
      If (iPrint.ge.11) Then
         If (iMax.ne.0) Then
            Write (Lu,300) jter,Lbl(iMax),rMax
         Else
            Write (Lu,300) jter,'N/A     ',rMax
         End If
      End If
 300  Format (1X,'Iter:',I5,2X,A,1X,E11.4)
*
      If (iPrint.ge.19) Then
         Write (Lu,*)
         Write (Lu,*)' Internal coordinates of the next macro iteration'
         Write (Lu,*)
         Write (Lu,'(1X,A,2X,F10.4)') (Lbl(iInter),rInt(iInter),
     &          iInter=1,nQQ)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the new Cartesian coordinates.
*
      iterMx = 50
*
      Do jter = 1, iterMx
*
*--------Compute the Cartesian shift, solve dq = B^T dx!
*
         M = 3*nAtom
         N = nQQ
         Call Eq_Solver('T',M,N,NRHS,BMx,Curvilinear,Degen,dSS,
     &                  DFC)
         Call mma_deallocate(BMx)
*
         If (iPrint.ge.99)
     &     Call PrList('Symmetry Distinct Nuclear Displacements',
     &                 AtomLbl,nAtom,DFC,3,nAtom)
*
*        Compute the RMS in Cartesian Coordinates.
*
         dx2=Zero
         denom=Zero
         ix = 0
         Do iAtom = 1, nAtom
            Do i = 1, 3
              ix = ix + 1
              dx2 = dx2 + Degen(i,iAtom)*DFC(ix)**2
              denom=denom+Degen(i,iAtom)
            End Do
         End Do
         dx_RMS = Sqrt(dx2/denom)
*
*--------Update the symmetry distinct Cartesian coordinates.
*
         Call DaXpY_(3*nAtom,One,DFC,1,Coor,1)
*
*        Dirty fix of zeros
*
         Do iAtom = 1, nAtom
            If (Cx(1,iAtom,Iter).eq.Zero .and.
     &          Abs(Coor(1,iAtom)).lt.1.0D-13) Coor(1,iAtom)=Zero
            If (Cx(2,iAtom,Iter).eq.Zero .and.
     &          Abs(Coor(2,iAtom)).lt.1.0D-13) Coor(2,iAtom)=Zero
            If (Cx(3,iAtom,Iter).eq.Zero .and.
     &          Abs(Coor(3,iAtom)).lt.1.0D-13) Coor(3,iAtom)=Zero
         End Do
*
         Call dcopy_(3*nAtom,Coor,1,Cx(:,:,Iter+1),1)
         If (iPrint.ge.99)
     &      Call PrList('Symmetry Distinct Nuclear Coordinates / Bohr',
     &                   AtomLbl,nAtom,Coor,3,nAtom)
*
*--------Compute new values q and the Wilson B-matrix for the new
*        geometry with the current new set of Cartesian coordinates.
*
         nWndw=1
         BSet_Save=BSet
         HSet_Save=HSet
         lOld_Save=lOld
         BSet=.False.
         HSet=.False.
         lOld=.False.
         Call BMtrx(nAtom,Coor,iter+1,mTtAtm,nWndw)
         BSet=BSet_Save
         HSet=HSet_Save
         lOld=lOld_Save
*
*--------Check if the final structure is reached and get the
*        difference between the present structure and the final.
*
         iMax = 1
         rMax = Zero
         Do i = 1, nQQ
            dSS(i) = rInt(i)-qInt(i,Iter+1)
            If (Abs(dSS(i)) .gt. Abs(rMax)) Then
               rMax = dSS(i)
               iMax = i
            End If
         End Do
*
*        Convergence based on the RMS of the Cartesian displacements.
*
         If (dx_RMS.lt.1.0D-6) Go To 998
*
         If (iPrint.ge.99) Then
            Write (Lu,*)
            Write (Lu,*) ' Displacement of internal coordinates'
            Write (Lu,*)
            Write (Lu,'(1X,A,2X,F10.4)') (Lbl(iInter),dss(iInter),
     &             iInter=1,nQQ)
         End If
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     On input, Error specifies whether an error should be signalled
*     (.True.) or the calculation aborted (.False.)
*     In the former case, the output value indicates if an error has
*     occurred
*
      If (.NOT.Error) Then
         Call WarningMessage(2,'Error in NewCar')
         Write (Lu,*)
         Write (Lu,*) '***********************************************'
         Write (Lu,*) ' ERROR: No convergence in NewCar !             '
         Write (Lu,*) ' Strong linear dependency among Coordinates.   '
         Write (Lu,*) ' Hint: Try to change the Internal Coordinates. '
         Write (Lu,*) '***********************************************'
         If (.NOT.User_Def) Call RecPrt('NewCar: rInt  ','(10F15.10)',
     &                                  rInt,nQQ,1)
         If (.NOT.User_Def) Call RecPrt('NewCar: qInt','(10F15.10)',
     &                                  qInt(:,Iter+1),nQQ,1)
         Write (Lu,*)
         Call Quit(_RC_NOT_CONVERGED_)
      End If
*                                                                      *
************************************************************************
*                                                                      *
 998  Continue
*
      If (iPrint.ge.6) Then
         Write (Lu,*)
         Write (Lu,'(A,i2,A)')
     &         ' New Cartesian coordinates were found in',
     &         jter,' Newton-Raphson iterations.'
         Write (Lu,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Finally, just to be safe align the new Cartesian structure with
*     the reference structure (see init2.f)
*
      If (WeightedConstraints.and.(.not.(VarR.or.VarT)))
     &   Call Align(Cx(:,:,iter+1),RefGeo,nAtom)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(rInt)
      Call mma_deallocate(dss)
      Call mma_deallocate(DFC)
*                                                                      *
************************************************************************
*                                                                      *
      Error=.False.
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ZJAC(NDIMEN,ARRRE,ARRIM,LDV,VECRE,VECIM)
      IMPLICIT NONE
      INTEGER NDIMEN,LDV
      REAL*8 ARRRE(NDIMEN,NDIMEN),ARRIM(NDIMEN,NDIMEN)
      REAL*8 VECRE(LDV,*),VECIM(LDV,*)
      REAL*8 EPS
      PARAMETER (EPS=1.0D-12)
      REAL*8 SBDMAX,ARII,ARJJ,ARIJ,AIIJ,AAIJ,ERE,EIM
      REAL*8 DIFF,SGN,DUM,CS,SN,TN
      REAL*8 VRKJ,VIKJ,VRKI,VIKI,ARKJ,AIKJ,ARKI,AIKI
      REAL*8 ARJK,AIJK,ARIK,AIIK
      REAL*8 VNSUM,VNOLD
      INTEGER I,J,K
      INTEGER NR,NROT,NSWEEP,IFTEST,IFERR
      REAL*8 ERRRE,ERRIM

      IFTEST=0

C von Neumanns sum should be ever decreasing. Check this:
      VNSUM=1.0D99
C Max sub-diagonal element:
      NROT=0
      NSWEEP=0
  10  CONTINUE
      NSWEEP=NSWEEP+1
      NR=0
      SBDMAX=EPS
      VNOLD=VNSUM
      VNSUM=0.0D0
      DO I=2,NDIMEN
       DO J=1,I-1
        ARII=ARRRE(I,I)
        ARJJ=ARRRE(J,J)
        ARIJ=ARRRE(I,J)
        AIIJ=ARRIM(I,J)
        AAIJ=SQRT(ARIJ**2+AIIJ**2)
        VNSUM=VNSUM+AAIJ**2
        SBDMAX=MAX(SBDMAX,AAIJ)
        IF(2.0D0*AAIJ.LT.SBDMAX) GOTO 100
        NR=NR+1
        ERE=ARIJ/AAIJ
        EIM=AIIJ/AAIJ
        DIFF=ARII-ARJJ
        SGN=1.0D0
        IF(DIFF.LT.0.0D0) THEN
           DIFF=-DIFF
           SGN=-SGN
        END IF
        DUM=DIFF+SQRT(DIFF**2+4.0D0*AAIJ**2)
        TN=2.0D0*SGN*AAIJ/DUM
        CS=1.0D0/SQRT(1.0D0+TN**2)
        SN=CS*TN
C TN,CS,SN=TAN,COS AND SIN OF ROTATION ANGLE.
C Rotate vectors:
        DO K=1,LDV
         VRKJ=CS*VECRE(K,J)-SN*( ERE*VECRE(K,I)-EIM*VECIM(K,I))
         VIKJ=CS*VECIM(K,J)-SN*( EIM*VECRE(K,I)+ERE*VECIM(K,I))
         VRKI=SN*VECRE(K,J)+CS*( ERE*VECRE(K,I)-EIM*VECIM(K,I))
         VIKI=SN*VECIM(K,J)+CS*( EIM*VECRE(K,I)+ERE*VECIM(K,I))
         VECRE(K,J)=VRKJ
         VECIM(K,J)=VIKJ
         VECRE(K,I)=VRKI
         VECIM(K,I)=VIKI
        END DO
C Rotate matrix columns:
        DO K=1,NDIMEN
         ARKJ=CS*ARRRE(K,J)-SN*( ERE*ARRRE(K,I)-EIM*ARRIM(K,I))
         AIKJ=CS*ARRIM(K,J)-SN*( EIM*ARRRE(K,I)+ERE*ARRIM(K,I))
         ARKI=SN*ARRRE(K,J)+CS*( ERE*ARRRE(K,I)-EIM*ARRIM(K,I))
         AIKI=SN*ARRIM(K,J)+CS*( EIM*ARRRE(K,I)+ERE*ARRIM(K,I))
         ARRRE(K,J)=ARKJ
         ARRIM(K,J)=AIKJ
         ARRRE(K,I)=ARKI
         ARRIM(K,I)=AIKI
        END DO
C Rotate matrix rows:
        DO K=1,NDIMEN
         ARJK=CS*ARRRE(J,K)-SN*( ERE*ARRRE(I,K)+EIM*ARRIM(I,K))
         AIJK=CS*ARRIM(J,K)-SN*(-EIM*ARRRE(I,K)+ERE*ARRIM(I,K))
         ARIK=SN*ARRRE(J,K)+CS*( ERE*ARRRE(I,K)+EIM*ARRIM(I,K))
         AIIK=SN*ARRIM(J,K)+CS*(-EIM*ARRRE(I,K)+ERE*ARRIM(I,K))
         ARRRE(J,K)=ARJK
         ARRIM(J,K)=AIJK
         ARRRE(I,K)=ARIK
         ARRIM(I,K)=AIIK
        END DO
 100    CONTINUE
       END DO
      END DO
      NROT=NROT+NR

      IF(IFTEST.GT.0) THEN
C --- CHECK IF DIVERGING (This should never happen):
       IF(VNSUM.GE.VNOLD) THEN
        Call WarningMessage(2,'ZJAC got increasing von-Neumann-sum.')
        WRITE(6,*)' Panic exit from Jacobi iteration loop.'
        GOTO 999
       END IF
C --- CHECK IF IDLE LOOPS (This should never happen):
       IF(NR.EQ.0 .AND. SBDMAX.GT.EPS) THEN
        Call WarningMessage(2,'ZJAC detected infinite idle loops.')
        WRITE(6,*)' Panic exit from Jacobi iteration loop.'
        GOTO 999
       END IF
      END IF

* PAM 2008 If unchecked, then idle loop just generates warning and return:
      IFERR=0
      IF(IFTEST.EQ.0) THEN
       IF(VNSUM.GE.VNOLD) THEN
        Call WarningMessage(1,'ZJAC got increasing von-Neumann-sum.')
        IFERR=1
       END IF
       IF(NR.EQ.0 .AND. SBDMAX.GT.EPS) THEN
        Call WarningMessage(1,'ZJAC detected infinite idle loops.')
        IFERR=1
       END IF
       IF(IFERR.NE.0) THEN
        WRITE(6,*)' Probably, the convergence criteria of the ZJAC'
        WRITE(6,*)' code are too strict. You may report this as a bug'
        WRITE(6,*)' but since you probably simply hit the limits to'
        WRITE(6,*)' accuracy caused by round-off, the program will'
        WRITE(6,*)' continue.'
        WRITE(6,*)' At this point, the largest subdiagonal element'
        WRITE(6,*)' is SBDMAX=',SBDMAX
       END IF
      END IF

C --- CHECK IF CONVERGED:
      IF(IFERR.EQ.0 .AND. SBDMAX.GT.EPS) GOTO 10

      !> order the eigenvalues in increasing sequence
      call zorder(ndimen,ldv,vecre,vecim,arrre,1)

      RETURN
 999  CONTINUE
C Jump here on error.
      Call WarningMessage(2,'ZJAC abend diagnostics:')
      WRITE(6,*)' Nr of sweeps      NSWEEP=',NSWEEP
      WRITE(6,*)' Nr of 2-rotations   NROT=',NROT
      WRITE(6,*)' Rotations this sweep  NR=',NR
      WRITE(6,*)' von Neumann sum    VNSUM=',VNSUM
      WRITE(6,*)' Previous value     VNOLD=',VNOLD
      WRITE(6,*)' Largest subdiag   SBDMAX=',SBDMAX
      CALL HRMCHK(NDIMEN,ARRRE,ARRIM,ERRRE,ERRIM)
      WRITE(6,*)' Antisymm. part of ARRRE:',ERRRE
      WRITE(6,*)' Symmetric part of ARRIM:',ERRIM
      CALL ABEND()
      END
      SUBROUTINE HRMCHK(NDIMEN,ARRRE,ARRIM,ERRRE,ERRIM)
      IMPLICIT NONE
      INTEGER NDIMEN,I,J
      REAL*8 ARRRE(NDIMEN,NDIMEN),ARRIM(NDIMEN,NDIMEN)
      REAL*8 ERRRE,ERRIM
      ERRRE=0.0D0
      ERRIM=0.0D0
      DO I=1,NDIMEN
       DO J=1,I
        ERRRE=MAX(ERRRE,ABS(ARRRE(I,J)-ARRRE(J,I)))
        ERRIM=MAX(ERRIM,ABS(ARRIM(I,J)+ARRIM(J,I)))
       END DO
      END DO
      RETURN
      END

      subroutine zorder(ndimen,ldv,vecre,vecim,arrre,switch)

C Order the eigenvalues in increasing sequence:
C
C Note that special care is taken to define some order in case
C of degeneracy.
C

C switch controls whether we assume an array or vector
C of eigenvalues

      IMPLICIT NONE
      INTEGER NDIMEN,LDV, switch
      REAL*8 ARRRE(NDIMEN,*)
      REAL*8 VECRE(LDV,*),VECIM(LDV,*)
      REAL*8 O_i, O_j, Thr_EDiff, EDIFF, ESEL, EVAL
      REAL*8 VRKJ,VIKJ,VRKI,VIKI
      INTEGER I,J,K,ISEL

      Thr_EDiff=1.0D-10
      DO I=1,NDIMEN-1
         ESEL=ARRRE(I,I**(switch))
         ISEL=I
*
         O_i=0.0D0
         Do K=1,LDV
            O_i = O_i + DBLE(K) * (VECRE(K,I)**2+VECIM(K,I)**2)
         End Do
*
*        Check against other eigenvalues
*
         DO J=I+1,NDIMEN
            EVAL=ARRRE(J,J**switch)
*
            EDIFF=ABS(EVAL-ESEL)
            IF (EVAL.LT.ESEL.and.EDIFF.gt.Thr_EDiff) THEN
               ISEL=J
               ESEL=EVAL
            Else If (EDIFF.lt.Thr_EDiff) THEN
               O_j=0.0D0
               Do K=1,LDV
                  O_j = O_j + DBLE(K) * (VECRE(K,J)**2+VECIM(K,J)**2)
               End Do
               If (O_j.gt.O_i) Then
                  ISEL=J
                  ESEL=EVAL
               End If
            END IF
         END DO
*
*        Swap here!
*
         IF (ISEL.NE.I) THEN
            DO K=1,LDV
               VRKI=VECRE(K,I)
               VRKJ=VECRE(K,ISEL)
               VIKI=VECIM(K,I)
               VIKJ=VECIM(K,ISEL)
               VECRE(K,I)=VRKJ
               VECRE(K,ISEL)=VRKI
               VECIM(K,I)=VIKJ
               VECIM(K,ISEL)=VIKI
            END DO
            ARRRE(ISEL,ISEL**switch)=ARRRE(I,I**switch)
            ARRRE(I,I**switch)=ESEL
         END IF
      END DO
      end subroutine zorder

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Ignacio Fdez. Galvan                             *
!***********************************************************************

module RunFile_data

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

! lw       : Label width
! DS_cache : In-memory cache of real scalar values
! IS_cache : In-memory cache of integer scalar values

integer(kind=iwp), parameter :: IDRun = 34676777, lw = 16, nHdrSz = 128, nToc = 1024, nTocCA = 32, nTocDA = 256, nTocDS = 64, &
                                nTocIA = 128, nTocIS = 128, NulPtr = -1, VNRun = 4096
integer(kind=iwp), parameter :: icWr = 1, icRd = 2, &
                                rcOK = 0, rcNotFound = 1, rcWrongType = 2, &
                                sNotUsed = 0, sRegularField = 1, sSpecialField = 2, &
                                TypUnk = 0, TypInt = 1, TypDbl = 2, TypStr = 3, TypLgl = 4

type DS_cache_item
  real(kind=wp) :: val = Zero
  character(len=lw) :: lab = ''
end type DS_cache_item

type IS_cache_item
  integer(kind=iwp) :: val = 0
  character(len=lw) :: lab = ''
end type IS_cache_item

type RunHdr_type
  integer(kind=iwp) :: ID, Ver, Next, Items, DaLab, DaPtr, DaLen, DaMaxLen, DaTyp, nProcs
end type RunHdr_type

type Toc_item
  character(len=lw) :: Lab = 'Empty'
  integer(kind=iwp) :: Ptr = NulPtr, Len = 0, MaxLen = 0, Typ = TypUnk
end type Toc_item

integer(kind=iwp) :: i_run_CA_used(nTocCA), i_run_DA_used(nTocDA), i_run_DS_used(nTocDS), i_run_IA_used(nTocIA), &
                     i_run_IS_used(nTocIS), num_DS_init, num_IS_init
character(len=8) :: RunName, RnNmStk(4)
type(DS_cache_item) :: DS_cache(nTocDS)
type(IS_cache_item) :: IS_cache(nTocIS)
type(RunHdr_type) :: RunHdr
type(Toc_item) :: Toc(nToc)

!***********************************************************************
!                            RUNFILE LABELS                            *
!***********************************************************************

!> List of known character array labels:
!>
!> - '``DFT functional``'     Name of the functional used for the KS-DFT calculation.
!> - '``Irreps``'             Names of the irreducible representations.
!> - '``Relax Method``'       Name of the method used for geometry optimizations.
!> - '``Seward Title``'       The title of the calculation as specified in module SEWARD.
!> - '``Slapaf Info 3``'      Misc. information for module SLAPAF.
!> - '``Unique Atom Names``'  List of the names of the symmetry unique atoms.
!> - '``Unique Basis Names``' List of the basis function names.
!> - '``MkNemo.lMole``'       The labels of molecules as specified in mknemo module.
!> - '``MkNemo.lCluster``'    The labels of clusters as specified in mknemo module.
!> - '``MkNemo.lEnergy``'     The labels of energies as specified in mknemo module.
!> - '``Frag_Type``'          EFP fragment labels
!> - '``ABC``'                EFP atom labels

character(len=lw), parameter :: LabelsCA(nTocCA) = [ &
                                'DFT functional  ','Irreps          ','Relax Method    ','Seward Title    ', & !  1- 4
                                'Slapaf Info 3   ','Unique Atom Name','Unique Basis Nam','LP_L            ', & !  5- 8
                                'MkNemo.lMole    ','MkNemo.lCluster ','MkNemo.lEnergy  ','Symbol ZMAT     ', & !  9-12
                                'Tinker Name     ','ESPF Filename   ','ChDisp          ','cmass           ', & ! 13-16
                                'BirthCertificate','LastEnergyMethod','MMO Labels      ','MCLR Root       ', & ! 17-20
                                'Frag_Type       ','ABC             ','Un_cen Names    ','cDmp            ', & ! 21-24
                                'dc: cDmp        ','SymmetryCInfo   ','SewardXTitle    ','Align_Weights   ', & ! 25-28
                                'Quad_c          ','RFcInfo         ','                ','                ']   ! 29-32

!> List of known real array labels:
!>
!> - '``Analytic Hessian``'         Analytic Hessian.
!> - '``Center of Charge``'         Nuclear center of charge.
!> - '``Center of Mass``'           Nuclear center of mass.
!> - '``CMO_ab``'
!> - '``D1ao``'                     One particle density matrix, AO basis.
!> - '``D1ao_ab``'
!> - '``D1aoVar``'                  Generalized one particle density matrix, AO basis.
!> - '``D1av``'                     Average one particle density matrix, AO basis.
!> - '``D1mo``'                     One particle density matrix, MO basis.
!> - '``D1sao``'                    One particle spin density matrix, AO basis.
!> - '``D2av``'                     Average two particle density matrix for the active space, AO basis.
!> - '``dExcdRa``'                  The potential of the exchange-correlation functional.
!> - '``DLAO``'
!> - '``DLMO``'
!> - '``Effective nuclear charge``' Effective nuclear charge for each unique atom.
!> - '``FockO_ab``'
!> - '``FockOcc``'                  Generalized Fock matrix, AO basis.
!> - '``GeoNew``'                   Next guess for Cartesian coordinates for the unique atoms.
!> - '``GeoNewPC``'                 Next guess for Cartesian coordinates for the unique point charges.
!> - '``GRAD``'                     Gradient with respect to nuclear displacements, for all unique atoms.
!> - '``Hess``'
!> - '``HF-forces``'                Hellmann--Feynman forces.
!> - '``Last orbitals``'            Last set of orbital computed.
!> - '``LCMO``'
!> - '``MEP-Coor``'                 List of nuclear coordinates along a minimum energy path, for unique atoms.
!> - '``MEP-Energies``'             List of energies along a minimum energy path.
!> - '``MEP-Grad``'                 List of nuclear gradients along a minimum energy path.
!> - '``MP2 restart``'              Information for restarting direct MP2 calculations.
!> - '``Mulliken Charge``'          Mulliken population charges for each unique atom.
!> - '``NEMO TPC``'
!> - '``Nuclear charge``'           Actual nuclear charge for each unique atom.
!> - '``OrbE``'                     SCF orbital energies.
!> - '``OrbE_ab``'
!> - '``P2MO``'
!> - '``PCM Charges``'              Charges for each tessera in the PCM model.
!> - '``PCM Info``'                 Misc. information needed for the PCM model.
!> - '``PLMO``'
!> - '``RASSCF orbitals``'          Last orbitals generated by the RASSCF module.
!> - '``Reaction field``'           Misc. information needed for the Kirkwood model.
!> - '``SCFInfoR``'                 Misc. information needed by the SCF module.
!> - '``SCF orbitals``'             Last orbitals generated by the SCF module.
!> - '``Slapaf Info 2``'            Misc. information needed by the SLAPAF module.
!> - '``Unique Coordinates``'       Cartesian coordinates for the symmetry unique atoms.
!> - '``Last energies``'            Energies for all roots in the last calculation.
!> - '``Dipole moment``'            The last computed dipole moment.
!> - '``MkNemo.vDisp``'             The displacements matrix as specified in the mknemo module.
!> - '``MkNemo.tqCluster``'         The transformation matrix for clusters as specified in the mknemo module.
!> - '``MkNemo.Energies``'          The energies of super-system and clusters as specified in the mknemo module.
!> - '``RASSCF OrbE``'              RASSCF orbital energies.
!> - '``GRD1``'                     MR-CISD gradient state1.
!> - '``GRD2``'                     MR-CISD gradient state2.
!> - '``NADC``'                     MR-CISD NADC vector state1/state2.
!> - '``MR-CISD energy``'           MR-CISD energies state1,state2.
!> - '``NOSEHOOVER``'               Extra-degrees of fredom needed to generated canonical ensemble.
!> - '``T-Matrix``'                 T-Matrix associated with PCO.
!> - '``rInt0``'                    Stored constrained values.
!> - '``Weights``'                  Weights used for alignment and hypersphere constraint.
!> - '``MEP-Lengths``'              Lengths of the MEP steps.
!> - '``MEP-Curvatures``'           Curvatures of the MEP steps.
!> - '``D1ao-``'                    Antisymmetric transition density matrix, in AO.
!> - '``P2MOT``'                    "Fake" two-body density needed for MC-PDFT gradient calculations.
!> - '``Guessorb energies``'
!> - '``Pseudo Coordinates``'
!> - '``Initial Coordinates``'
!> - '``Isotopes``'                 Atom masses in a.u.
!> - '``EPF_Coors``'                EFP fragment coordinates.
!> - '``Last Dipole Moments``'
!> - '``Un_cen Effective Charge``'
!> - '``Un_cen Coordinates``'
!> - '``D1ao_PCM``'                 One particle density matrix in AO that polarizes ASCs during RASSCF
!> - '``SolventWeight``'            Weight of the density matrix used for generating reaction-field

character(len=lw), parameter :: LabelsDA(nTocDA) = [ &
                                'Analytic Hessian','Center of Charge','Center of Mass  ','CMO_ab          ', & !   1-  4
                                'D1ao            ','D1ao_ab         ','D1aoVar         ','D1av            ', & !   5-  8
                                'D1mo            ','D1sao           ','D2av            ','dExcdRa         ', & !   9- 12
                                'DLAO            ','DLMO            ','Effective nuclea','FockO_ab        ', & !  13- 16
                                'FockOcc         ','GeoNew          ','GeoNewPC        ','GRAD            ', & !  17- 20
                                'Hess            ','HF-forces       ','Last orbitals   ','LCMO            ', & !  21- 24
                                'MEP-Coor        ','MEP-Energies    ','MEP-Grad        ','MP2 restart     ', & !  25- 28
                                'Mulliken Charge ','NEMO TPC        ','Nuclear charge  ','OrbE            ', & !  29- 32
                                'OrbE_ab         ','P2MO            ','PCM Charges     ','PCM Info        ', & !  33- 36
                                'PLMO            ','RASSCF orbitals ','Reaction field  ','SCFInfoR        ', & !  37- 40
                                'SCF orbitals    ','Slapaf Info 2   ','Unique Coordinat','Vxc_ref         ', & !  41- 44
                                'PotNuc00        ','h1_raw          ','h1    XX        ','HEFF            ', & !  45- 48
                                'PotNucXX        ','Quad_r          ','RCTFLD          ','RFrInfo         ', & !  49- 52
                                'DKH_Info        ','Real_Info       ','Last orbitals_ab','SCFInfoI_ab     ', & !  53- 56
                                'SCFInfoR_ab     ','Transverse      ','SM              ','LP_Coor         ', & !  57- 60
                                'LP_Q            ','DFT_TwoEl       ','Unit Cell Vector','SCF orbitals_ab ', & !  61- 64
                                'Guessorb        ','Guessorb energie','Last energies   ','LoProp Dens 0   ', & !  65- 68
                                'LoProp Dens 1   ','LoProp Dens 2   ','LoProp Dens 3   ','LoProp Dens 4   ', & !  69- 72
                                'LoProp Dens 5   ','LoProp Dens 6   ','LoProp Integrals','MpProp Orb Ener ', & !  73- 76
                                'LoProp H0       ','Dipole moment   ','RICD_Info       ','BMtrx           ', & !  77- 80
                                'CList           ','DList           ','MkNemo.vDisp    ','MkNemo.tqCluster', & !  81- 84
                                'MkNemo.Energies ','MMHessian       ','Bfn Coordinates ','Pseudo Coordinat', & !  85- 88
                                'Pseudo Charge   ','RASSCF OrbE     ','Ref_Geom        ','LoProp Charge   ', & !  89- 92
                                'Initial Coordina','Grad State1     ','Grad State2     ','NADC            ', & !  93- 96
                                'MR-CISD energy  ','Saddle          ','Reaction Vector ','IRC-Coor        ', & !  97-100
                                'IRC-Energies    ','IRC-Grad        ','MM Grad         ','Velocities      ', & ! 101-104
                                'FC-Matrix       ','umass           ','ESO_SINGLE      ','UMATR_SINGLE    ', & ! 105-108
                                'UMATI_SINGLE    ','ANGM_SINGLE     ','TanVec          ','Nuc Potential   ', & ! 109-112
                                'RF CASSCF Vector','Cholesky BkmThr ','NOSEHOOVER      ','T-Matrix        ', & ! 113-116
                                'rInt0           ','Weights         ','MEP-Lengths     ','MEP-Curvatures  ', & ! 117-120
                                'Hss_X           ','Hss_Q           ','KtB             ','BMxOld          ', & ! 121-124
                                'TROld           ','qInt            ','dqInt           ','Fragment_Fock   ', & ! 125-128
                                'RAmatrixV       ','IAmatrixV       ','AllCIP          ','AllCIPP         ', & ! 129-132
                                'VenergyP        ','K               ','MMO Coords      ','MMO Grad        ', & ! 133-136
                                'Hss_upd         ','TR              ','D1ao-           ','ESFS_SINGLE     ', & ! 117-140
                                'LA Fact         ','primitives      ','Isotopes        ','P2AO            ', & ! 141-144
                                'State Overlaps  ','EFP_Coors       ','DIP1_SINGLE     ','P2MOT           ', & ! 145-148
                                'ONTOPO          ','ONTOPT          ','OE_OT           ','TEG_OT          ', & ! 149-152
                                'FI_V            ','FA_V            ','FOCK_PDFT       ','AMFI_SINGLE     ', & ! 153-156
                                'HAMSOR_SINGLE   ','HAMSOI_SINGLE   ','Last Dipole Mome','Un_cen Effective', & ! 157-160
                                'Un_cen Coordinat','Proj_Coord      ','                ','Keep_Coord      ', & ! 161-164
                                'PCMSph          ','PCMTess         ','Vert            ','Centr           ', & ! 165-168
                                'SSph            ','PCMDM           ','EF_Centers      ','OAM_Center      ', & ! 169-172
                                'OMQ_Center      ','DMS_Centers     ','Wel_Info        ','AMP_Center      ', & ! 173-176
                                'RP_Centers      ','XF              ','rDmp            ','rDmp:A          ', & ! 177-180
                                'rDmp:S          ','D1saoVar        ','ESFS_SINGLEAU   ','ESO_LOW         ', & ! 181-184
                                'SFS_HAM         ','SFS_OVLP        ','FocMS           ','MSPDFTD5        ', & ! 185-188
                                'MSPDFTD6        ','TwoEIntegral    ','D1MOt           ','D1INTER         ', & ! 189-192
                                'P2INTER         ','D1AO_MS         ','D1SAO_MS        ','MS_FINAL_ROT    ', & ! 193-196
                                'F1_PDFT         ','F2_PDFT         ','FxyMS           ','SH_Ovlp_Save    ', & ! 297-200
                                'Old_Phase       ','<rhoB|VnucA>    ','D1ao_PCM        ','SolventWeight   ', & ! 201-204
                                '                ','                ','                ','                ', & ! 205-208
                                '                ','                ','                ','                ', & ! 209-212
                                '                ','                ','                ','                ', & ! 213-216
                                '                ','                ','                ','                ', & ! 217-220
                                '                ','                ','                ','                ', & ! 221-224
                                '                ','                ','                ','                ', & ! 225-228
                                '                ','                ','                ','                ', & ! 229-232
                                '                ','                ','                ','                ', & ! 233-236
                                '                ','                ','                ','                ', & ! 237-240
                                '                ','                ','                ','                ', & ! 241-244
                                '                ','                ','                ','                ', & ! 245-248
                                '                ','                ','                ','                ', & ! 249-252
                                '                ','                ','                ','                ']   ! 253-256

!> List of known real scalar labels:
!>
!> - '``CASDFT energy``'             Energy for the last CASDFT calculation.
!> - '``CASPT2 energy``'             Energy for the last CASPT2 calculation.
!> - '``CASSCF energy``'             Energy for the last CASSCF calculation.
!> - '``Ener_ab``'
!> - '``KSDFT energy``'              Energy for the last KS-DFT calculation.
!> - '``Last energy``'               Last energy computed.
!> - '``PC Self Energy``'            Self energy for point charges.
!> - '``PotNuc``'                    Nuclear repusion energy.
!> - '``RF Self Energy``'            Self energy in the Kirkwood model.
!> - '``SCF energy``'                Energy for the last SCF calculation.
!> - '``EThr``'                      Energy convergence threshold.
!> - '``Thrs``'
!> - '``UHF energy``'
!> - '``DFT exch coeff``'            Scaling factor for exchange terms of a density functional.
!> - '``DFT corr coeff``'            Scaling factor for correlation terms of a density functional.
!> - '``Cholesky Threshold``'
!> - '``Total Nuclear Charge``'
!> - '``Numerical Gradient rDelta``'
!> - '``Total Charge``'              total number of electrons.

character(len=lw), parameter :: LabelsDS(nTocDS) = [ &
                                'CASDFT energy   ','CASPT2 energy   ','CASSCF energy   ','Ener_ab         ', & !  1- 4
                                'KSDFT energy    ','Last energy     ','PC Self Energy  ','PotNuc          ', & !  5- 8
                                'RF Self Energy  ','SCF energy      ','Thrs            ','UHF energy      ', & !  9-12
                                'E_0_NN          ','W_or_el         ','W_or_Inf        ','EThr            ', & ! 11-16
                                'Cholesky Thresho','Total Nuclear Ch','Numerical Gradie','MpProp Energy   ', & ! 17-20
                                'UHFSPIN         ','S delete thr    ','T delete thr    ','MD_Etot0        ', & ! 21-24
                                'MD_Time         ','NAD dft energy  ','GradLim         ','Average energy  ', & ! 25-28
                                'Timestep        ','MD_Etot         ','Max error       ','Total Charge    ', & ! 29-32
                                'DFT exch coeff  ','DFT corr coeff  ','Value_l         ','R_WF_HMC        ', & ! 33-36
                                '                ','                ','                ','                ', & ! 37-40
                                '                ','                ','                ','                ', & ! 41-44
                                '                ','                ','                ','                ', & ! 45-48
                                '                ','                ','                ','                ', & ! 49-52
                                '                ','                ','                ','                ', & ! 53-56
                                '                ','                ','                ','                ', & ! 57-60
                                '                ','                ','                ','                ']   ! 61-64

!> List of known integer array labels:
!>
!> - '``Center Index``'
!> - '``Ctr Index Prim``'       Idem with primitive basis set.
!> - '``nAsh``'                 The number of active orbitals per irreducible representation.
!> - '``nBas``'                 The number of basis functions per irreducible representation.
!> - '``nDel``'                 The number of deleted orbitals per irreducible representation.
!> - '``nFro``'                 The number of frozen orbitals per irreducible representation, i.e. orbitals that are not optimized.
!> - '``nIsh``'                 The number of inactive orbitals per irreducible representation.
!> - '``nIsh beta``'
!> - '``nOrb``'                 The total number of orbitals per irreducible representation.
!> - '``Orbital Type``'
!> - '``Slapaf Info 1``'        Misc. information for module SLAPAF.
!> - '``Symmetry operations``'  The symmetry operations of the point group.
!> - '``Non valence orbitals``' The total number of non valence orbitals per irreducible representation.
!> - '``MkNemo.hDisp``'         The hash matrix for displacements as specified in the mknemo module.
!> - '``NumCho``'               Number of Cholesky vectors.
!> - '``nFroPT``'               Number of Frozen for PT.
!> - '``nDelPT``'               Number of Deleted for PT.

character(len=lw), parameter :: LabelsIA(nTocIA) = [ &
                                'Center Index    ','nAsh            ','nBas            ','nDel            ', & !   1-  4
                                'nFro            ','nIsh            ','nIsh beta       ','nOrb            ', & !   5-  8
                                'Orbital Type    ','Slapaf Info 1   ','Symmetry operati','nIsh_ab         ', & !   9- 12
                                'nStab           ','Quad_i          ','                ','RFiInfo         ', & !  13- 16
                                'RFlInfo         ','SCFInfoI        ','Misc            ','SewIInfo        ', & !  17- 20
                                'SCFInfoI_ab     ','icDmp           ','Symmetry Info   ','Sizes           ', & !  21- 24
                                'IndS            ','LP_A            ','NumCho          ','nFroPT          ', & !  25- 28
                                'nDelPT          ','BasType         ','Spread of Coord.','Unit Cell Atoms ', & !  29- 32
                                'iSOShl          ','Non valence orbi','LoProp nInts    ','LoProp iSyLbl   ', & !  33- 36
                                'nDel_go         ','nBas_Prim       ','IsMM            ','Atom -> Basis   ', & !  37- 40
                                'Logical_Info    ','SCF nOcc        ','SCF nOcc_ab     ','iAOtSO          ', & !  41- 44
                                'iSOInf          ','AuxShell        ','nVec_RI         ','MkNemo.hDisp    ', & !  45- 48
                                'Index ZMAT      ','NAT ZMAT        ','nDisp           ','DegDisp         ', & !  49- 52
                                'LBList          ','Ctr Index Prim  ','MLTP_SINGLE     ','JBNUM_SINGLE    ', & !  53- 56
                                'LROOT_SINGLE    ','GeoInfo         ','Cholesky BkmDim ','Cholesky BkmVec ', & !  57- 60
                                'Atom Types      ','LA Def          ','Basis IDs       ','Desym Basis IDs ', & !  61- 64
                                'primitive ids   ','Root Mapping    ','Fermion IDs     ','IsMM Atoms      ', & !  65- 68
                                'Un_cen Charge   ','PCM_N           ','PCMiSph         ','NVert           ', & !  69- 72
                                'IntSph          ','NewSph          ','XMolnr          ','XEle            ', & !  73- 76
                                'iDmp            ','iDmp:S          ','NSTAT_SINGLE    ','cmsNACstates    ', & !  77- 80
                                'NACstatesOpt    ','                ','                ','                ', & !  81- 84
                                '                ','                ','                ','                ', & !  85- 88
                                '                ','                ','                ','                ', & !  89- 92
                                '                ','                ','                ','                ', & !  93- 96
                                '                ','                ','                ','                ', & !  97-100
                                '                ','                ','                ','                ', & ! 101-104
                                '                ','                ','                ','                ', & ! 105-108
                                '                ','                ','                ','                ', & ! 109-112
                                '                ','                ','                ','                ', & ! 113-116
                                '                ','                ','                ','                ', & ! 117-120
                                '                ','                ','                ','                ', & ! 121-124
                                '                ','                ','                ','                ']   ! 125-128

!> List of known integer scalar labels:
!>
!> - '``Multiplicity``'               The spin multiplicity of the last SCF or RASSCF calculation.
!> - '``nMEP``'                       Number of points on the minimum energy path.
!> - '``No of Internal coordinates``' The number of internal coordinates for the molecule that is allowed within the given point
!>                                    group.
!> - '``nSym``'                       The number of irreducible representations of the molecule.
!> - '``PCM info length``'            Length of the block containing misc. info for the PCM model.
!> - '``Relax CASSCF root``'          Signals which root to perform geometry optimization for in a state average CASSCF geometry
!>                                    optimization.
!> - '``SA ready``'                   Signals that SA wavefunction is ready for gradient calculations.
!> - '``System BitSwitch``'           A bit switch controlling various functions. Will be replaced!
!> - '``Unique atoms``'
!> - '``nActel``'                     The number of active electrons in CASSCF calculation.
!> - '``MkNemo.nMole``'               The number of molecules as specified in the mknemo module.
!> - '``nLambda``'                    The number of constraints in the PCO.
!> - '``DNG``'                        Force numerical gradients.
!> - '``HessIter``'                   Last iteration where the analytical Hessian was computed.
!> - '``TS Search``'                  Flag to mark if a TS search has been activated.
!> - '``CHCCLarge``'                  Segmentation of VOs in CHCC.
!> - '``Seed``'                       The seed number for random number generator used in surface hoping.
!> - '``Rotational Symmetry Number``'
!> - '``mp2prpt``'                    True(=1) if mbpt2 was run with prpt
!> - '``DF Mode``'                    Local (1) or non-local (0) DF
!> - '``OptimType``'                  Optimization type in hyper
!> - '``STSYM``'                      symmetry of the CAS root(s)
!> - '``nCoordFiles``'                number of xyz-files in gateway
!> - '``CHCCLarge``'                  Segmentation of VOs in CHCC
!> - '``Invert constraints``'
!> - '``Keep old gradient``'
!> - '``embpot``'                     Flag whether an embedding potential is present
!> - '``EFP``'                        Flag Effective fragment potentials
!> - '``Coor_Type``'                  EFP fragment coordinate format
!> - '``nEFP_Coor``'                  Associated number of coordinates per fragment
!> - '``Relax Original root``'
!> - '``NCONF``'                      For MS-PDFT gradient

character(len=lw), parameter :: LabelsIS(nTocIS) = [ &
                                'Multiplicity    ','nMEP            ','No of Internal c','nSym            ', & !   1-  4
                                'PCM info length ','Relax CASSCF roo','System BitSwitch','Unique atoms    ', & !   5-  8
                                'LP_nCenter      ','ChoIni          ','Unit Cell NAtoms','Cholesky Reorder', & !   9- 12
                                'ChoVec Address  ','SA ready        ','NumGradRoot     ','Number of roots ', & !  13- 16
                                'LoProp Restart  ','MpProp nOcOb    ','Highest Mltpl   ','nActel          ', & !  17- 20
                                'Run_Mode        ','Grad ready      ','ISPIN           ','SCF mode        ', & !  21- 24
                                'MkNemo.nMole    ','N ZMAT          ','Bfn Atoms       ','FMM             ', & !  25- 28
                                'Pseudo atoms    ','nChDisp         ','iOff_Iter       ','Columbus        ', & !  29- 32
                                'ColGradMode     ','IRC             ','MaxHops         ','nRasHole        ', & !  33- 36
                                'nRasElec        ','Rotational Symme','Saddle Iter     ','iMass           ', & !  37- 40
                                'mp2prpt         ','NJOB_SINGLE     ','MXJOB_SINGLE    ','NSS_SINGLE      ', & !  41- 44
                                'NSTATE_SINGLE   ','DF Mode         ','OptimType       ','STSYM           ', & !  45- 48
                                'RF CASSCF root  ','RF0CASSCF root  ','nCoordFiles     ','nLambda         ', & !  49- 52
                                'DNG             ','HessIter        ','CHCCLarge       ','TS Search       ', & !  53- 56
                                'Number of Hops  ','hopped          ','Invert constrain','Keep old gradien', & !  57- 60
                                'embpot          ','nPrim           ','Seed            ','Track Done      ', & !  61- 64
                                'MaxHopsTully    ','EFP             ','nEFP_fragments  ','Coor_Type       ', & !  65- 68
                                'nEFP_Coor       ','Relax Original r','Unique centers  ','nXF             ', & !  69- 72
                                'CSPF            ','NCONF           ','SH RASSI run    ','isCMSNAC        ', & !  73- 76
                                'isMECIMSPD      ','CalcNAC_Opt     ','MECI_via_SLAPAF ','                ', & !  77- 80
                                '                ','                ','                ','                ', & !  81- 84
                                '                ','                ','                ','                ', & !  85- 88
                                '                ','                ','                ','                ', & !  89- 92
                                '                ','                ','                ','                ', & !  93- 96
                                '                ','                ','                ','                ', & !  97-100
                                '                ','                ','                ','                ', & ! 101-104
                                '                ','                ','                ','                ', & ! 105-108
                                '                ','                ','                ','                ', & ! 109-112
                                '                ','                ','                ','                ', & ! 113-116
                                '                ','                ','                ','                ', & ! 117-120
                                '                ','                ','                ','                ', & ! 121-124
                                '                ','                ','                ','                ']   ! 125-128

public :: Arr2RunHdr, DS_cache, i_run_CA_used, i_run_DA_used, i_run_DS_used, i_run_IA_used, i_run_IS_used, icRd, icWr, IDRun, &
          IS_cache, LabelsCA, LabelsDA, LabelsDS, LabelsIA, LabelsIS, lw, nHdrSz, nToc, nTocCA, nTocDA, nTocDS, nTocIA, nTocIS, &
          NulPtr, num_DS_init, num_IS_init, rcNotFound, rcOK, rcWrongType, RnNmStk, RunHdr, RunHdr2Arr, RunName, sNotUsed, &
          sRegularField, sSpecialField, Toc, TypDbl, TypInt, TypLgl, TypStr, TypUnk, VNRun

contains

subroutine RunHdr2Arr(Arr)

  integer(kind=iwp), intent(out) :: Arr(nHdrSz)

  Arr(1) = RunHdr%ID
  Arr(2) = RunHdr%Ver
  Arr(3) = RunHdr%Next
  Arr(4) = RunHdr%Items
  Arr(5) = RunHdr%DaLab
  Arr(6) = RunHdr%DaPtr
  Arr(7) = RunHdr%DaLen
  Arr(8) = RunHdr%DaMaxLen
  Arr(9) = RunHdr%DaTyp
  Arr(10) = RunHdr%nProcs
  Arr(11:) = 0

end subroutine RunHdr2Arr

subroutine Arr2RunHdr(Arr)

  integer(kind=iwp), intent(in) :: Arr(nHdrSz)

  RunHdr%ID = Arr(1)
  RunHdr%Ver = Arr(2)
  RunHdr%Next = Arr(3)
  RunHdr%Items = Arr(4)
  RunHdr%DaLab = Arr(5)
  RunHdr%DaPtr = Arr(6)
  RunHdr%DaLen = Arr(7)
  RunHdr%DaMaxLen = Arr(8)
  RunHdr%DaTyp = Arr(9)
  RunHdr%nProcs = Arr(10)

end subroutine Arr2RunHdr

end module RunFile_data

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2006  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE DENS1_RPT2 (CI,SGM1,G1)
      IMPLICIT NONE

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "pt2_guga.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

#include "para_info.fh"
      LOGICAL RSV_TSK

      REAL*8 CI(MXCI),SGM1(MXCI)
      REAL*8 G1(NLEV,NLEV)
#ifdef _ENABLE_CHEMPS2_DMRG_
      REAL*8 G2(NLEV,NLEV,NLEV,NLEV)
#endif

      REAL*8 GTU

      INTEGER ID
      INTEGER IST,ISU,ISTU
      INTEGER IT,IU,LT,LU,LTU

      INTEGER ITASK,LTASK,LTASK2T,LTASK2U,NTASKS

      INTEGER ISSG,NSGM

      REAL*8, EXTERNAL :: DDOT_,DNRM2_

* Purpose: Compute the 1-electron density matrix array G1.


      CALL DCOPY_(NG1,[0.0D0],0,G1,1)

* For the special cases, there is no actual CI-routines involved:
* Special code for hi-spin case:
      IF(ISCF.EQ.2) THEN
        DO IT=1,NASHT
          G1(IT,IT)=1.0D00
        END DO
        GOTO 99
      END IF
* Special code for closed-shell:
      IF(ISCF.EQ.1 .AND. NACTEL.GT.0) THEN
        DO IT=1,NASHT
          G1(IT,IT)=2.0D00
        END DO
        GOTO 99
      END IF

* For the general cases, we use actual CI routine calls, and
* have to take account of orbital order.
* We will use level inices LT,LU... in these calls, but produce
* the density matrices with usual active orbital indices.
* Translation tables L2ACT and LEVEL, in pt2_guga.fh

* SVC20100311: set up a task table with LT,LU
* SB20190319: maybe it doesn't even make sense to parallelize the 1-RDM
      nTasks=(nLev**2+nLev)/2

      CALL GETMEM ('Tasks','ALLO','INTE',lTask,2*nTasks)
      lTask2T=lTask
      lTask2U=lTask+nTasks

      iTask=0
      DO LT=1,nLev
        DO LU=1,LT
          iTask=iTask+1
          iWork(lTask2T+iTask-1)=LT
          iWork(lTask2U+iTask-1)=LU
        ENDDO
      ENDDO
      IF (iTask.NE.nTasks) WRITE(6,*) "ERROR nTasks"

      Call Init_Tsk(ID, nTasks)

* SVC20100311: BEGIN SEPARATE TASK EXECUTION
 500  If (.NOT.Rsv_Tsk (ID,iTask)) GOTO 501

* Compute SGM1 = E_UT acting on CI, with T.ge.U,
* i.e., lowering operations. These are allowed in RAS.
      LT=iWork(lTask2T+iTask-1)
        IST=ISM(LT)
        IT=L2ACT(LT)
        LU=iWork(lTask2U+iTask-1)
          LTU=iTask
          ISU=ISM(LU)
          IU=L2ACT(LU)
          ISTU=MUL(IST,ISU)
          ISSG=MUL(ISTU,LSYM)
          NSGM=NCSF(ISSG)
          IF(NSGM.EQ.0) GOTO 500
* GETSGM2 computes E_UT acting on CI and saves it on SGM1
          CALL GETSGM2(LU,LT,LSYM,CI,SGM1)
          IF(ISTU.EQ.1) THEN
            GTU=DDOT_(NSGM,CI,1,SGM1,1)
            G1(IT,IU)=GTU
            G1(IU,IT)=GTU
          END IF

* SVC: The master node now continues to only handle task scheduling,
*      needed to achieve better load balancing. So it exits from the task
*      list. It has to do it here since each process gets at least one
*      task.
#if defined (_MOLCAS_MPP_) && !defined (_GA_)
      IF (IS_REAL_PAR().AND.KING().AND.(NPROCS.GT.1)) GOTO 501
#endif

      GOTO 500
 501  CONTINUE
      CALL Free_Tsk(ID)

      CALL GETMEM ('Tasks','FREE','INTE',lTask,2*nTasks)

      CALL GAdSUM (G1,NG1)

  99  CONTINUE

#ifdef _ENABLE_CHEMPS2_DMRG_
      If (DoCumulant) THEN
      If(NACTEL.GT.1) Then
*QP: At this point, only load 2RDM of one state, JSTATE=1
        Call chemps2_load2pdm( nlev, G2, MSTATE(1) )
        Call two2onerdm_bis( nlev, NACTEL, G2, G1 )
      Else
        write(6,*) "FATAL ERROR: DMRG-CASPT2 with
     & CHEMPS2 does not work with NACTEL=1"
      End If
      End If
#endif

      IF(iPrGlb.GE.DEBUG) THEN
        WRITE(6,'("DEBUG> ",A)')
     &   "DENS1_RPT2: norms of the 1-el density matrix:"
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G1:", DNRM2_(NG1,G1,1)
      ENDIF


      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PrintQ(rK,qLbl,nq,nQQ,LuIC,rMult)
      Implicit Real*8 (a-h,o-z)
#include "print.fh"
      Real*8 rK(nq,nQQ), rMult(nq)
      Character*14  qLbl(nq), Line*80, filnam*16
      Logical Start
*                                                                      *
************************************************************************
*                                                                      *
!#define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      iPrint=99
#else
      iRout=122
      iPrint=nPrint(iRout)
#endif
*
      Lu=6
      Thr=0.001D+00 ! Threshold for printout.
*
      If (iPrint.le.5) Go To 99
      Write (Lu,*)
      Call CollapseOutput(1,'Internal coordinate section')
*
      If (iPrint.ge.6) Then
         Write (Lu,*)
         Write (Lu,'(80A)') ('*',i=1,80)
         Write (Lu,*) ' Auto-Defined Internal coordinates'
         Write (Lu,'(80A)') ('-',i=1,80)
         Write (Lu,'(A)') '  Primitive Internal Coordinates:'
      Else
         Write (Lu,*)
         Write (Lu,'(A)') '  Redundant Internal Coordinates:'
         Write (Lu,*)
      End If
*
      Rewind(LuIC)
 999  Continue
         Read (LuIC,'(A)',END=998) Line
         Write (Lu,'(A)') Line
         Go To 999
 998  Continue
      Rewind(LuIC)
      If (iPrint.lt.6) Go To 99
*
      Write (Lu,'(A)') '  Internal Coordinates:'
      Do iQQ = 1, nQQ
         Write(Line,'(A,I3.3,A)') 'q',iQQ,' ='
         iF=7
         jq=0
         Start=.True.
         Do iq = 1, nq
            temp=Abs(rK(iq,iQQ))
            If (temp.gt.Thr) Then
               jq = jq + 1
               If (jq.gt.4) Then
                  Line(80:80)='&'
                  Write (Lu,'(A)') Line
                  Line=' '
                  iF=6
                  jq = 1
                  Start=.False.
               End If
               If (jq.eq.1.and.Start) Then
                  iE=iF+16
                  Write(Line(iF:iE),'(A,F10.8,4A)') ' ',rK(iq,iQQ),
     &                                            ' ',qLbl(iq)(1:4),' '
               Else
                  iE=iF+17
                  Write(Line(iF:iE),'(A,F10.8,4A)') '+ ',rK(iq,iQQ),
     &                                            ' ',qLbl(iq)(1:4),' '
               End If
               iF=iE+1
            End If
         End Do
         Write (Lu,'(A)') Line
      End Do
      Write (Lu,'(80A)') ('*',i=1,80)
      Call CollapseOutput(0,'Internal coordinate section')
 99   Continue
*
*     Write linear combinations to disc
*
      LuTmp=11
      filnam='SPCINX'
      call molcas_binaryopen_vanilla(luTmp,filnam)
c     Open(luTmp,File=filnam,Form='unformatted',Status='unknown')
      ReWind (LuTmp)
*
*---- put in degeneracy factor so that ddot will work.
*
      Write (LuTmp) nq,nQQ
      Do iq = 1, nq
         Write (LuTmp) qLbl(iq),(rMult(iq)*rK(iq,iQQ),iQQ=1,nQQ)
      End Do
*
      Close  (LuTmp)
*
      If (iPrint.ge.10.and.nQQ.le.12) Then
         Write (Lu,*)
         Write (Lu,*) ' Nonredundant internal coordinates'
      End If
      If (iPrint.ge.6.and.nQQ.le.12) Then
         Write (Lu,*)
         Write (Lu,*) ' Number of redundant coordinates:',nq
         Write (Lu,*)
      End If
      If (iPrint.ge.10.and.nQQ.le.12) Then
         Write (Lu,'(A,E10.3)') ' Threshold for printout:',Thr
         IncQQ = 8
         Do iiQQ = 1, nQQ, IncQQ
            mQQ=Min(nQQ,iiQQ+IncQQ-1)
            Write (Lu,*)
            Write (Lu,'(14X,8I10)') (iQQ,iQQ=iiQQ,mQQ)
            Do iq = 1, nq
               temp=Sqrt(DDot_(nQQ,rK(iq,1),nq,rK(iq,1),nq))
               If (temp.gt.Thr)
     &            Write (Lu,'(A,8F10.6)')
     &                  qLbl(iq),(rK(iq,iQQ),iQQ=iiQQ,mQQ)
            End Do
            Write (Lu,*)
         End Do
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefParReord_t3(NaGrpR,maxdim)
! This routine does:
! define parameters in cht3_global using NaGrpR,maxdim
!
! I/O parameter description:
! NxGrpR   - # of groups in a (=b) set (I)
! maxdim   - # maximal dimension of a (=b) Groups(O)

use ChT3_global, only: DimGrpaR, L1Name, L2Name, nv, T2Name
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NaGrpR
integer(kind=iwp), intent(out) :: maxdim
integer(kind=iwp) :: i, j, Low, Up_prev, Up
real(kind=wp) :: rdim

call mma_allocate(DimGrpaR,NaGrpR,label='DimGrpaR')
call mma_allocate(L1Name,NaGrpR,label='L1Name')
call mma_allocate(L2Name,NaGrpR,NaGrpR,label='L2Name')
call mma_allocate(T2Name,NaGrpR,NaGrpR,label='T2Name')

!1 define parameters of Groups of a set

rdim = real(nv,kind=wp)/real(NaGrpR,kind=wp)

Up_prev = 0
do i=1,NaGrpR

  Low = Up_prev+1
  if (i == NaGrpR) then
    Up = nv
  else
    Up = int(rdim*i)
  end if
  Up_prev = Up

  DimGrpaR(i) = Up-Low+1

end do

!2 find maximal dimensions of a'

maxdim = DimGrpaR(1)
do i=1,NaGrpR
  if (DimGrpaR(i) > maxdim) maxdim = DimGrpaR(i)
end do

!3 def L1Name, L2Name, T2Name

do i=1,NaGrpR
  write(L1Name(i),'(A4,I0.2)') 'L1vc',i
  do j=1,NaGrpR
    write(L2Name(i,j),'(A2,I0.2,I0.2)') 'L2',i,j
    write(T2Name(i,j),'(A2,I0.2,I0.2)') 'T2',i,j
  end do
end do

return

end subroutine DefParReord_t3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!               2012,2014, Victor P. Vysotskiy                         *
!***********************************************************************

subroutine Cho_XCV_DistributeVectors(irc,SP_BatchDim,nSP_Batch,idSP,n_idSP,NVT,l_NVT)
!
! Thomas Bondo Pedersen, April 2010.
!
! Parallel execution: distribute vectors across nodes.
! Serial execution: reorder vectors on tmp files and write them to
! permanent vector files.
!
! Victor P. Vysotskiy, 2012:
! Number of 'ga_put' has been remarkably reduced.
! Victor P. Vysotskiy, 2014:
! Number of 'ga_get' has been remarkably reduced by using the stripped mode

use Cholesky, only: Cho_Real_Par, INF_PASS, IPRINT, LuPri
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nSP_Batch, SP_BatchDim(nSP_Batch), n_idSP, idSP(n_idSP), l_NVT, NVT(l_NVT)
real(kind=wp) :: C0, C1, W0, W1

irc = 0
if (Cho_Real_Par) then
  if (iPrint >= Inf_Pass) call CWTime(C0,W0)
  call Cho_XCV_DV_P(irc,SP_BatchDim,nSP_Batch,idSP,n_idSP,NVT,l_NVT)
  if (iPrint >= Inf_Pass) then
    call CWTime(C1,W1)
    write(LuPri,'(/,1X,A)') 'Timing of vector distribution:'
    call Cho_PrtTim(' ',C1,C0,W1,W0,-1)
  end if
else
  if (iPrint >= Inf_Pass) call CWTime(C0,W0)
  call Cho_XCV_DV_S(irc,SP_BatchDim,nSP_Batch,idSP,n_idSP)
  if (iPrint >= Inf_Pass) then
    call CWTime(C1,W1)
    write(LuPri,'(/,1X,A)') 'Timing of vector write:'
    call Cho_PrtTim(' ',C1,C0,W1,W0,-1)
  end if
end if

end subroutine Cho_XCV_DistributeVectors

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Phi_point(iPhi,nPhi,Cos_Phi,Sin_Phi,w_Phi)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
*
      q = Pi*(Two*DBLE(iPhi)-1.0d0)/DBLE(nPhi)
      If (Abs(Cos(q)).gt.1.0D-14) Then
         Cos_Phi=Cos(q)
      Else
         Cos_Phi=Zero
      End If
      If (Abs(Sin(q)).gt.1.0D-14) Then
         Sin_Phi=Sin(q)
      Else
         Sin_Phi=Zero
      End If
      w_Phi=Two*Pi/DBLE(nPhi)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine make_close_rvb_m
      implicit real*8(a-h,o-z)
#include "fio.fh"
      character*8 vec(11)
      vec(1)='TMP01'
      vec(2)='TMP02'
      vec(3)='TMP03'
      vec(4)='TMP04'
      vec(5)='TMP05'
      vec(6)='TMP06'
      vec(7)='TMP07'
      vec(8)='TMP08'
      vec(9)='TMP09'
      vec(10)='VBWFN'
      il=10
c  Preassign some file names to identifiers :
      do n=1,MxFile
         do i=1,il
             if(isOpen(n).eq.1) then
              if (LuName(n).eq.vec(i)) then
c         print *,'closing ',LuName(n)
                call daclos(n)
              endif
              endif
      enddo
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AdT_T17(T1,Q,dimat,dimaq,no,adda,f)
! this routine does:
! T1(a,i) <<- f . Q(a',i)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimat, dimaq, no, adda
real(kind=wp), intent(inout) :: T1(dimat,no)
real(kind=wp), intent(in) :: Q(dimaq,no), f

T1(adda+1:adda+dimaq,:) = T1(adda+1:adda+dimaq,:)+f*Q(:,:)

return

end subroutine AdT_T17

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine ddrestart_cvb(c,axc,vec,
     >  hp,solp,
     >  maxdav,n,
     >  nvguess1,nvrestart1)
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
      dimension c(n,maxdav),axc(n,maxdav),vec(n)
      dimension hp(maxdav,maxdav)
      dimension solp(maxdav)

      i1 = mstackr_cvb(maxdav)
      i2 = mstackr_cvb(maxdav*maxdav)

      call ddrestart2_cvb(c,axc,vec,
     >  hp,solp,
     >  maxdav,n,
     >  nvguess1,nvrestart1,
     >  work(i1),work(i2))

      call mfreer_cvb(i1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE OCCLS(    IWAY,  NOCCLS,  IOCCLS,     NEL,    NGAS,
     &                   IGSMIN,  IGSMAX,I_DO_BASSPC,IBASSPC, NOBPT)
*
* IWAY = 1 :
* obtain NOCCLS =
* Number of allowed ways of distributing the orbitals in the
* active spaces
*
* IWAY = 2 :
* OBTAIN NOCCLS and
* IOCCLS = allowed distributions of electrons
*
* Added Oct 98 : IBASSPC
* The basespace of
* a given class is the first space where this class occurs
*
*
*
* Jeppe Olsen, August 1995
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
*. Input
      DIMENSION IGSMIN(NGAS),IGSMAX(NGAS),NOBPT(NGAS)
*. Output
      DIMENSION IOCCLS(NGAS,*)
      DIMENSION IBASSPC(*)
*. Local scratch
      DIMENSION IOCA(MXPNGAS),IOC(MXPNGAS)
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
         WRITE(6,*)  ' OCCLS in action '
         WRITE(6,*) ' =================='
         WRITE(6,*) ' NGAS NEL ', NGAS,NEL
      END IF
*
      ISKIP = 1
      NOCCLS = 0
*. start with smallest allowed number
      DO IGAS = 1, NGAS
        IOCA(IGAS) = IGSMIN(IGAS)
      END DO
      NONEW = 0
      IFIRST = 1
*. Loop over possible occupations
 1000 CONTINUE
        IF(IFIRST.EQ.0) THEN
*. Next accumulated occupation
          CALL NXTNUM3(IOCA,NGAS,IGSMIN,IGSMAX,NONEW)
        END IF
        IF(NONEW.EQ.0) THEN
*. ensure that IOCA corresponds to an accumulating occupation,
*. i.e. a non-decreasing sequence
        IF(ISKIP.EQ.1) THEN
          KGAS = 0
          DO IGAS = 2, NGAS
            IF(IOCA(IGAS-1).GT.IOCA(IGAS)) KGAS = IGAS
          END DO
          IF(KGAS .NE. 0 ) THEN
            DO IGAS = 1, KGAS-1
              IOCA(IGAS) = IGSMIN(IGAS)
            END DO
            IOCA(KGAS) = IOCA(KGAS)+1
          END IF
        END IF
C?      WRITE(6,*) ' Another accumulated occupation: '
C?      CALL IWRTMA(IOCA,1,NGAS,1,NGAS)
*. corresponding occupation of each active space
        NEGA=0
        IM_TO_STUFFED = 0
        DO IGAS = 1, NGAS
          IF(IGAS.EQ.1) THEN
            IOC(IGAS) = IOCA(IGAS)
          ELSE
            IOC(IGAS) = IOCA(IGAS)-IOCA(IGAS-1)
            IF(IOC(IGAS).LT.0) NEGA = 1
            IF(IOC(IGAS).GT.2*NOBPT(IGAS)) IM_TO_STUFFED = 1
          END IF
        END DO
C?      WRITE(6,*) ' Another occupation: '
C?      CALL IWRTMA(IOC,1,NGAS,1,NGAS)
        IFIRST = 0
*. Correct number of electrons
        IEL = IELSUM(IOC,NGAS)
        IF(IEL.EQ.NEL.AND.NEGA.EQ.0.AND.IM_TO_STUFFED.EQ.0) THEN
          NOCCLS = NOCCLS + 1
          IF(IWAY.EQ.2) THEN
            IF(NTEST.GE.100) THEN
              WRITE(6,*) ' Another allowed class : '
              CALL IWRTMA(IOC,1,NGAS,1,NGAS)
            END IF
            CALL ICOPVE(IOC,IOCCLS(1,NOCCLS),NGAS)
*
            IF(I_DO_BASSPC.EQ.1) THEN
              IBASSPC(NOCCLS) = IBASSPC_FOR_CLS(IOC)
            END IF
*
          END IF
        END IF
      END IF
      IF(NONEW.EQ.0) GOTO 1000
*
      IF(NTEST.GE.10) THEN
         WRITE(6,*) ' Number of Allowed occupation classes ', NOCCLS
         IF(IWAY.EQ.2.AND.NTEST.GE.20) THEN
           WRITE(6,*) ' Occupation classes : '
           WRITE(6,*) ' ===================='
           WRITE(6,*)
           WRITE(6,*) ' Class    Occupation in GASpaces '
           WRITE(6,*) ' ================================'
           DO I = 1, NOCCLS
             WRITE(6,'(1H ,I5,3X,16I3)')
     &       I, (IOCCLS(IGAS,I),IGAS=1, NGAS)
           END DO
C          CALL IWRTMA(IOCCLS,NGAS,NOCCLS,NGAS,NOCCLS)
         END IF
      END IF
*
      IF(I_DO_BASSPC.EQ.1) THEN
C       WRITE(6,*) ' Base CI spaces for the classes '
C       CALL IWRTMA(IBASSPC,1,NOCCLS,1,NOCCLS)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Yoshio Nishimoto                                 *
************************************************************************
!     based on rhsall2.f
!
!     In principle, For E = T_{ij}^{ab}*(ia|jb).
!     With p and q for general orbitals,
!     L_{pq} = (pa|jb)*T_{qj}^{ab} + (ip|jb)*T_{ij}^{qb}
!            + (ia|pb)*T_{iq}^{ab} + (ia|jp)*T_{ij}^{aq}
!     For the first term, with P and Q for auxiliary orbitals
!     L_{pq}(1) = (pa|jb)*T_{qj}^{ab}
!               = (pa|P)*(P|jb) * T_{qj}^{ab} (2c-2e is omitted?)
!               = (pa|P) * tilde{T}_{qa}^P
!               = C_{mu p}*C_{nu a}*(mu nu|P) * tilde{T}_{qa}^P
!               = C_{mu p} * (mu nu|P) * V_{nu q}^P
!     where
!     tilde{T}_{ia}^P = T_{ij}^{ab} * (P|jb)
!     V_{mu p}^P      = tilde{T}_{pa}^P * C_{mu a}
!
!     Dimension of tilde{T} will be the same as that of (ia|P) in MO,
!     where (i,a) = (inact,active), (inact,virtual), (active,virtual)
!
!     tilde{T} is constructed in this file.
!     tilde{T} -> V_{mu p}^P transformations, contraction with 3c-2e,
!     and construction of the orbital Lagrangian (L_{pq}) is elsewhere
!     ... maybe in OLagVVVO
!
!-----------------------------------------------------------------------
!
!     For the ERI derivative calculation,
!     d(mu nu|rho sigma)/da
!     = d/da (mu nu|P) (P|Q)^-1 (Q|rho sigma)
!     = d(mu nu|P)/da (P|Q)^-1 (Q|rho sigma)
!       + (mu nu|P) d(P|Q)^-1/da (Q|rho sigma)
!       + (mu nu|P) (P|Q)^-1 d(Q|rho sigma)/da
!     = d(mu nu|P)/da (P|Q)^-1 (Q|rho sigma)
!       - (mu nu|P) (P|R)^-1 d(R|S)/da (S|Q)^-1 (Q|rho sigma)
!       + (mu nu|P) (P|Q)^-1 d(Q|rho sigma)/da
!     = d(mu nu|P)/da (tP|rho sigma)
!       - (mu nu|tP) d(P|Q)/da (tQ|rho sigma)
!       + (mu nu|tP) d(P|rho sigma)/da
!     where (mu nu|tP) = (mu nu|Q)*(Q|P)^-1
!
!     D_{mu nu rho sigma}*d(mu nu|rho sigma)/da
!     = d(mu nu|P)/da (tP|rho sigma) * D_{mu nu rho sigma}
!       - (mu nu|tP) d(P|Q)/da (tQ|rho sigma) * D_{mu nu rho sigma}
!       + (mu nu|tP) d(P|rho sigma)/da * D_{mu nu rho sigma}
!     = d(mu nu|P)/da tD_{mu nu}^tP
!       - (mu nu|tP) d(P|Q)/da tD_{mu nu}^tQ
!       + tD_{rho sigma}^tP d(P|rho sigma)/da
!     where tD_{mu nu}^tP = D_{mu nu rho sigma} * (rho sigma|tP)
!     In practice, tD_{pq}^tP is constructed and saved in disk.
!     This will be read when 3c-2e ERI derivatives are concerned,
!     and MO->AO transformations will be done on-the-fly.
!     Note that MO coefficients of CASPT2 have to be used.
!
!     For 2c-2e ERI derivatives,
!     D(tP,tQ) = tD_{pq} * C_{mu p} C_{nu q} * (mu nu|tP)
!     then saved.
!
      Subroutine OLagNS_RI(iSym0,DPT2C,DPT2Canti,A_PT2)

      use Symmetry_Info, only: Mul
      Use CHOVEC_IO, only: NVLOC_CHOBATCH
      use caspt2_global, only: iPrGlb
      use caspt2_global, only: do_csf, iStpGrd
      use PrintLevel, only: VERBOSE
      use EQSOLV, only: IVECC2
      use ChoCASPT2, only: MaxVec_PT2
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: iwp,wp,u6
      use fake_GA, only: GA_Arrays
#ifdef _MOLCAS_MPP_
      use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array
      USE Para_Info, ONLY: Is_Real_Par, King
#endif
      use caspt2_module, only: NACTEL, NSYM, NFRO, NISH, NIES, NASH,
     &                         NAES, NSSH, NSES, NORBT, NINABX,
     &                         NSECBX, NBSQT
      use caspt2_module, only: NTUV, NTU, NTGEU, NTGTU, NIGEJ, NIGTJ,
     &                         NAGEB, NAGTB, NTUVES, NTUES, NTGEUES,
     &                         NTGTUES, NIGEJES, NIGTJES, NAGEBES,
     &                         NAGTBES, NASUP, NISUP, NINDEP, NBTCH,
     &                         NBTCHES
      use Constants, only: Zero, One, Quart, Half, Two, Three, OneHalf

      implicit none

#include "warnings.h"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      integer(kind=iwp), intent(in) :: iSym0
      real(kind=wp), intent(inout) :: DPT2C(*), DPT2Canti(*),
     &  A_PT2(MaxVec_PT2,MaxVec_PT2)

      integer(kind=iwp), parameter :: Inactive=1, Active=2, Virtual=3

      integer(kind=iwp),allocatable :: BGRP(:,:)
      real(kind=wp),allocatable :: BRA(:),KET(:),BRAD(:),KETD(:),
     &                             PIQK(:)
#ifdef _MOLCAS_MPP_
      integer(kind=iwp), allocatable :: map2(:)
      integer(kind=iwp) :: myRank, NPROCS, i, lg_V, lg_V1, ndim2
#endif

      integer(kind=iwp) :: nSh(8,3), iSym, JSYM, IB1, IB2, MXBGRP,
     &  IBGRP, IB, NBGRP, iStpGrd_sav, NCHOBUF, MXPIQK, NADDBUF, IOFFCV,
     &  IBSTA, IBEND, NV, nBra, nKet, NVI, JOFFCV, JBGRP, JBSTA, JBEND,
     &  NVJ, JB
      real(kind=wp) :: SCLNEL

      integer(kind=iwp) :: ICASE, ISYT, ISYU, ISYV, ISYX, ISYJ,
     &  ISYL, ISYA, ISYC, ISYJL, ISYAC, ISYII, ISIJ, ISAB, ISI,
     &  NAS, NIS, NIN, NAS1, NASP, NISP, NINP, NASM, NISM, NINM, NWA,
     &  NWBP, NWBM, NWC, NWD,
     &  NWEP, NWEM, NWFP, NWFM, NWGP, NWGM, NWHP, NWHM, NW, NVEC,
     &  ipT, ipTP, ipTM, ipTanti,
     &  ITABS, iTtot, IUABS, iUtot, IVABS, iVtot, IVMAX,
     &  IXABS, iXtot, IXMAX, IJABS, iJtot, ILABS,
     &  IAABS, iAtot, ICABS,
     &  IW1, IW2, IW, nOrbA, IO, IO1, IO2,
     &  NBXSZA, NBXSZC, NBXSZJ, NBXSZL,
     &  IAEND, NASZ, ICEND, NCSZ, IJEND, NJSZ,
     &  ILEND, ILMAX, IAJSTA, IAJ, KAJ, ICLSTA, ICL, KCL,
     &  IAGEC, IAGTC, IJGEL, IJGTL, JGEL, JGTL
      real(kind=wp) :: SCL, SCL1
      real(kind=wp), parameter :: SQ2 = SQRT(Two), SQ3 = SQRT(Three),
     &  SQ05 = SQRT(Half), SQ32 = SQRT(OneHalf)

      nSh(1:nSym,Inactive) = NISH(1:nSym)
      nSh(1:nSym,Active  ) = NASH(1:nSym)
      nSh(1:nSym,Virtual ) = NSSH(1:nSym)

      IF (IPRGLB >= VERBOSE) THEN
        WRITE(u6,'(1X,A)') ' Using RHSALL2+ADDRHS algorithm'
      END IF

      ! iVec = iVecX
      iSym = iSym0
      SCLNEL = One/real(MAX(1,NACTEL),kind=wp)
*                                                                      *
************************************************************************
*                                                                      *
      DO JSYM=1,NSYM
*
      IB1=NBTCHES(JSYM)+1
      IB2=NBTCHES(JSYM)+NBTCH(JSYM)
*
      MXBGRP=IB2-IB1+1
      IF (MXBGRP <= 0) CYCLE
      call mma_allocate(BGRP,2,MXBGRP,Label='BGRP')
      IBGRP=1
      DO IB=IB1,IB2
       BGRP(1,IBGRP) = IB
       BGRP(2,IBGRP) = IB
       IBGRP=IBGRP+1
      END DO
      NBGRP=MXBGRP

      !! With iStpGrd = -1, we try to allocate 4 large arrays
      iStpGrd_sav = iStpGrd
      iStpGrd = -1
      CALL MEMORY_ESTIMATE(JSYM,BGRP,NBGRP,
     &                     NCHOBUF,MXPIQK,NADDBUF)
      iStpGrd = iStpGrd_sav
      IF (IPRGLB > VERBOSE) THEN
        WRITE(u6,*)
        WRITE(u6,'(A,I12)') '  Number of Cholesky batches: ',IB2-IB1+1
        WRITE(u6,'(A,I12)') '  Number of batch groups:     ',NBGRP
        WRITE(u6,*)
      END IF
* buffers are kept allocated until the end of JSYM loop.
      call mma_allocate(PIQK,MXPIQK,Label='PIQK')
      call mma_allocate(BRA,NCHOBUF,Label='BRABUF')
      call mma_allocate(KET,NCHOBUF,Label='KETBUF')
      call mma_allocate(BRAD,NCHOBUF,Label='BRAD')
      call mma_allocate(KETD,NCHOBUF,Label='KETD')
!
!     Loop over groups of batches of Cholesky vectors
!
      IOFFCV = 1
      DO IBGRP=1,NBGRP

      IBSTA=BGRP(1,IBGRP)
      IBEND=BGRP(2,IBGRP)

      NV=0
      DO IB=IBSTA,IBEND
        NV=NV+NVLOC_CHOBATCH(IB)
      END DO

      IF (IPRGLB > VERBOSE) THEN
        WRITE(u6,'(A,I12)') '  Cholesky vectors in this group = ', NV
        WRITE(u6,*)
      END IF

#ifdef _MOLCAS_MPP_
      If (Is_Real_Par()) Then
        myRank = GA_NodeID()
        NPROCS = GA_nNodes()

        call mma_allocate(MAP2,NPROCS,Label='MAP2')
        MAP2(:) = 0
        MAP2(myRank+1) = NV
        call GAIGOP(MAP2,NPROCS,'+')
        ndim2 = sum(map2)

        do i = nprocs, 2, -1
          map2(i) = sum(map2(1:i-1))+1
        end do
        map2(1) = 1
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Read kets (Cholesky vectors) in the form L(VX), all symmetries:
*
      Call Get_Cholesky_Vectors(Active,Active,JSYM,KET,nKet,
     &                          IBSTA,IBEND)
      KETD(1:nKet) = Zero
*                                                                      *
************************************************************************
*                                                                      *
*       Read bra (Cholesky vectors) in the form L(TJ): All symmetries
*
      Call Get_Cholesky_Vectors(Inactive,Active,JSYM,BRA,nBra,
     &                          IBSTA,IBEND)
      BRAD(1:nBra) = Zero
*                                                                      *
************************************************************************
*                                                                      *
*      Assemble contributions to TJVX
*      Loop over the bras and kets, form <A|0>
*
      Call OLagNS_RI2(Inactive,Active,Active,Active,
     &                'A ',BRA,KET,BRAD,KETD)
*                                                                      *
************************************************************************
*                                                                      *
*      TJVL RHSB
*      TJVL: Use TJ buffer as if it was VL, form <B|0>
*
      nKet = nBra
      Call OLagNS_RI2(Inactive,Active,Inactive,Active,
     &                'B ',BRA,BRA,BRAD,BRAD)
*                                                                      *
************************************************************************
*                                                                      *
* Read bra (Cholesky vectors) in the form L(AJ), form <D1|0>
* We still have L(VX) vectors in core, at KETS.
*
      Call Cholesky_Vectors(1,Inactive,Active,JSYM,BRAD,nBra,
     &                      IBSTA,IBEND)
      Call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,BRA,nBra,
     &                          IBSTA,IBEND)
      BRAD(1:nBra) = Zero
*                                                                      *
************************************************************************
*                                                                      *
* AJVX RHSD1
* Loop over the bra and ket vectors.
*
      Call OLagNS_RI2(Inactive,Virtual,Active,Active,
     &                'D1',BRA,KET,BRAD,KETD)
*                                                                      *
************************************************************************
*                                                                      *
* AJCL RHSH
* AJCL: Use AJ buffer still in core as if it was CL, form <H|0>
*
      nKet = nBra
      Call OLagNS_RI2(Inactive,Virtual,Inactive,Virtual,
     &                'H ',BRA,BRA,BRAD,BRAD)
*                                                                      *
************************************************************************
*                                                                      *
* Read Bra (Cholesky vectors)= L(AU)
*
      Call Cholesky_Vectors(1,Inactive,Virtual,JSYM,BRAD,nBra,
     &                      IBSTA,IBEND)
      Call Get_Cholesky_Vectors(Active,Virtual,JSYM,BRA,nBra,
     &                          IBSTA,IBEND)
      BRAD(1:nBra) = Zero
!                                                                      *
************************************************************************
*                                                                      *
* AUVX RHSC
* AUVX: Loop over the bras and kets
*
      Call OLagNS_RI2(Active,Virtual,Active,Active,
     &                'C ',BRA,KET,BRAD,KETD)
*                                                                      *
************************************************************************
*                                                                      *
* AUCX RHSF
* AUCX: Use AU buffer still in core as if it was CX, form <F|0>
*
      nKet = nBra
      Call OLagNS_RI2(Active,Virtual,Active,Virtual,
     &                'F ',BRA,BRA,BRAD,BRAD)
*                                                                      *
************************************************************************
*                                                                      *
* Read kets (Cholesky vectors) in the form L(VL), all symmetries:
*
      Call Cholesky_Vectors(1,Active,Active,JSYM,KETD,nKet,
     &                      IBSTA,IBEND)
      Call Get_Cholesky_Vectors(Inactive,Active,JSYM,KET,nKet,
     &                          IBSTA,IBEND)
      Call Cholesky_Vectors(2,Inactive,Active,JSYM,KETD,nKet,
     &                      IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
* AUVL RHSD2
* Loop over bras and kets, form <D2|0>.
*
      Call OLagNS_RI2(Active,Virtual,Inactive,Active,
     &                'D2',BRA,KET,BRAD,KETD)
*                                                                      *
************************************************************************
*                                                                      *
* Read kets (Cholesky vectors) in the form L(CL), all symmetries:
*
      Call Cholesky_Vectors(1,Inactive,Active,JSYM,KETD,nKet,
     &                      IBSTA,IBEND)
      Call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,KET,nKet,
     &                          IBSTA,IBEND)
      Call Cholesky_Vectors(2,Inactive,Virtual,JSYM,KETD,nKet,
     &                      IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
* AUCL RHSG
* Loop over bras and kets, form  <G|0>
*
      Call OLagNS_RI2(Active,Virtual,Inactive,Virtual,
     &                'G ',BRA,KET,BRAD,KETD)
*                                                                      *
************************************************************************
*                                                                      *
* Read bra vectors AJ
*
      Call Cholesky_Vectors(1,Active,Virtual,JSYM,BRAD,nBra,
     &                      IBSTA,IBEND)
      Call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,BRA,nBra,
     &                          IBSTA,IBEND)
      BRAD(1:nBra) = KETD(1:nBra)
*                                                                      *
************************************************************************
*                                                                      *
* Read kets in the form L(VL)
*
      Call Get_Cholesky_Vectors(Inactive,Active,JSYM,
     &                          KET,nKet,
     &                          IBSTA,IBEND)
      Call Cholesky_Vectors(2,Inactive,Active,JSYM,KETD,nKet,
     &                      IBSTA,IBEND)
*                                                                      *
************************************************************************
*                                                                      *
* AJVL RHSE
* AJVL: Loop over bras and kets. Form <E|0>
*
      Call OLagNS_RI2(Inactive,Virtual,Inactive,Active,
     &                'E ',BRA,KET,BRAD,KETD)
*                                                                      *
************************************************************************
*                                                                      *
* End of loop over batches, IB
      Call Cholesky_Vectors(1,Inactive,Virtual,JSYM,BRAD,nBra,
     &                      IBSTA,IBEND)
      Call Cholesky_Vectors(1,Inactive,Active,JSYM,KETD,nKet,
     &                      IBSTA,IBEND)
      !! Construct A_PT2
      NVI = NV
      JOFFCV = 1
      DO JBGRP=1,NBGRP

        JBSTA=BGRP(1,JBGRP)
        JBEND=BGRP(2,JBGRP)

        NVJ=0
        DO JB=JBSTA,JBEND
          NVJ=NVJ+NVLOC_CHOBATCH(JB)
        END DO

        !! BraAI
        Call Cnst_A_PT2(Inactive,Active)

        !! BraSI
        Call Cnst_A_PT2(Inactive,Virtual)

        !! BraSA
        Call Cnst_A_PT2(Active,Virtual)

        !! BraAA
        Call Cnst_A_PT2(Active,Active)
        JOFFCV = JOFFCV + NVJ
      END DO !! end of JBGRP loop
      IOFFCV = IOFFCV + NVI
      END DO !! end of IBGRP loop
*                                                                      *
************************************************************************
*                                                                      *
      call mma_deallocate(BRA)
      call mma_deallocate(KET)
      call mma_deallocate(BRAD)
      call mma_deallocate(KETD)
      call mma_deallocate(PIQK)
      call mma_deallocate(BGRP)
*                                                                      *
************************************************************************
*                                                                      *
* End of loop over JSYM
      END DO
#ifdef _MOLCAS_MPP_
      If (Is_Real_Par()) call mma_deallocate(map2)
#endif
*                                                                      *
************************************************************************
*                                                                      *
* Synchronized add RHS partial arrays from all nodes into each node.

!-SVC: read the DRA's from disk and copy them all to LUSOLV to continue
!      in serial mode.  FIXME: this call has to be removed when we reach
!      full parallel capabilities
*     CALL SYNRHS(IVEC)
!-SVC: at this point, the RHS elements are on disk, both in LUSOLV and
!      as DRAs with the name RHS_XX_XX_XX with XX a number representing
!      the case, symmetry, and rhs vector respectively.
!

      A_PT2(:,:) = Two*A_PT2(:,:)

      If (NBGRP /= 0) SCLNEL = SCLNEL/real(NBGRP,kind=wp)
      DPT2C(1:NBSQT) = DPT2C(1:NBSQT)*SCLNEL
      If (do_csf) DPT2Canti(1:NBSQT) = DPT2Canti(1:NBSQT)*SCLNEL

#ifdef _MOLCAS_MPP_
      If (is_real_par()) then
        CALL GADSUM (A_PT2,MaxVec_PT2**2)
      end if
#endif

      Return

      Contains
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_RI2(ITI,ITP,ITK,ITQ,Case,Cho_Bra,Cho_Ket,
     &                      Cho_BraD,Cho_KetD)

      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG

      implicit none

      integer(kind=iwp), intent(in) :: ITI, ITP, ITK, ITQ
      character(len=2), intent(in) :: Case
      real(kind=wp), intent(in) :: Cho_Bra(*), Cho_Ket(*)
      real(kind=wp), intent(inout) :: Cho_BraD(*), Cho_KetD(*)

      integer(kind=iwp) :: LBRASM, ISYI, NI, ISYP, NP, NPI, NBRASM,
     &  LKETSM, ISYK, NK, ISYQ, NQ, NQK, NKETSM, NPIQK, KPI, KQK

      real(kind=wp) :: TotCPU0, TotWall0, TotCPU1, TotWall1

      IF (iPrGlb >= DEBUG) THEN
        WRITE(u6,*) 'Processing RHS block '//Case
      END IF

      LBRASM=1
      CALL CWTime(TotCPU0,TotWall0)
      DO ISYI=1,NSYM
        NI=NSH(ISYI,ITI)
        IF(NI == 0) CYCLE
        ISYP=Mul(ISYI,JSYM)
        NP=NSH(ISYP,ITP)
        IF(NP == 0) CYCLE
        NPI=NP*NI
        NBRASM=NPI*NV

        LKETSM=1
        DO ISYK=1,NSYM
          NK=NSH(ISYK,ITK)
          IF(NK == 0) CYCLE
          ISYQ=Mul(ISYK,JSYM)
          NQ=NSH(ISYQ,ITQ)
          IF(NQ == 0) CYCLE
          NQK=NQ*NK
          NKETSM=NQK*NV
*
! SVC: we need an NPI*NQK to store the 2-electron integrals, and 2
! buffers (values+indices) for sorting them.  Later, we can try to get
! rid of the buffer that stores the values and only use an index buffer
! and the two-electron integrals for the scatter operation.  For the
! buffer, any size can be taken, but assuming there is enough memory
! available, it's set to the size of the two-electron integrals unless
! larger than some predefined maximum buffer size.
          NPIQK=NPI*NQK
          IF (NPIQK > MXPIQK) THEN
            IF (Case == 'H') THEN
              KPI=MXPIQK/NQK
              NPIQK=KPI*NQK
            ELSE IF (Case == 'G') THEN
              KQK=MXPIQK/NPI
              NPIQK=NPI*KQK
            ELSE
              WRITE(u6,*) ' NPIQK > MXPIQK and case != G or H'
              WRITE(u6,'(A,A2)')  ' CASE =   ', Case
              WRITE(u6,'(A,I12)') ' NPIQK =  ', NPIQK
              WRITE(u6,'(A,I12)') ' MXPIQK = ', MXPIQK
              WRITE(u6,*) ' This should not happen, please report.'
              CALL AbEnd()
            END IF
          END IF

          IF (NPIQK <= 0) THEN
            WRITE(u6,'(1X,A)') ' ADDRHS: zero-sized NPIQK'
            CALL AbEnd()
          END IF
*
          !! NBUFF(=nAddBuf) is removed
          If (Case == 'A ') Then
             CALL OLagNS_RI_A(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,
     &                        Cho_Bra(LBRASM),Cho_Ket(LKETSM),
     &                        Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
          Else If (Case == 'B ') Then
             CALL OLagNS_RI_B(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,
     &                        Cho_Bra(LBRASM),Cho_Ket(LKETSM),
     &                        Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
          Else If (Case == 'D1') Then
             CALL OLagNS_RI_D1(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,
     &                        Cho_Bra(LBRASM),Cho_Ket(LKETSM),
     &                        Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
          Else If (Case == 'H ') Then
             CALL OLagNS_RI_H(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,
     &                        Cho_Bra(LBRASM),Cho_Ket(LKETSM),
     &                        Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
          Else If (Case == 'C ') Then
             CALL OLagNS_RI_C(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,
     &                        Cho_Bra(LBRASM),Cho_Ket(LKETSM),
     &                        Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
          Else If (Case == 'F ') Then
             CALL OLagNS_RI_F(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,
     &                        Cho_Bra(LBRASM),Cho_Ket(LKETSM),
     &                        Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
          Else If (Case == 'D2') Then
             CALL OLagNS_RI_D2(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,
     &                        Cho_Bra(LBRASM),Cho_Ket(LKETSM),
     &                        Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
          Else If (Case == 'G ') Then
             CALL OLagNS_RI_G(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,
     &                        Cho_Bra(LBRASM),Cho_Ket(LKETSM),
     &                        Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
          Else If (Case == 'E ') Then
             CALL OLagNS_RI_E(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,
     &                        Cho_Bra(LBRASM),Cho_Ket(LKETSM),
     &                        Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
          Else
             Call Abend()
          End If

          LKETSM=LKETSM+NKETSM
        END DO
        LBRASM=LBRASM+NBRASM
      END DO
      CALL CWTime(TotCPU1,TotWall1)
      IF (IPRGLB >= VERBOSE) THEN
        write(u6,'(" CPU/Wall Time (Case ",A2,"):",2f10.2)')
     &    Case,totcpu1-totcpu0,totwall1-totwall0
      END IF

      Return

      End Subroutine OLagNS_RI2
!
!-----------------------------------------------------------------------
!
      SUBROUTINE OLagNS_RI_A(ISYI,ISYK,NT,NJ,NV,NX,TJVX,NTJVX,
     &                       Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

      USE SUPERINDEX, only: KTUV
      use caspt2_global, only: do_csf

      implicit none

      integer(kind=iwp), intent(in) :: ISYI, ISYK, NT, NJ, NV, NX,
     &  NTJVX, NCHO
      real(kind=wp), intent(out) :: TJVX(NT,NJ,NV,NX)
      real(kind=wp), intent(in) :: Cho_Bra(NT,NJ,NCHO),
     &  Cho_Ket(NV,NX,NCHO)
      real(kind=wp), intent(inout) :: Cho_BraD(NT,NJ,NCHO),
     &  Cho_KetD(NV,NX,NCHO)

      integer(kind=iwp) :: IT, IJ, IV, IX

      ISYJ = ISYI
      ISYX = ISYK

      ISYT=Mul(JSYM,ISYJ)
      ISYV=Mul(JSYM,ISYX)
      ISYM=ISYJ
      IF(NINDEP(ISYM,1) == 0) RETURN
      NAS=NTUV(ISYM)
      NIS=NISH(ISYM)
      NWA=NAS*NIS
      IF(NWA == 0) RETURN
!
!     ---- A
!
      !! Read the T-amplitude
      ICASE=1
      nIN = nINDEP(iSym,iCase)
      nAS = nASup(iSym,iCase)
      If (nIN /= 0) Then
        nIS = nISup(iSym,iCase)
        nVec = nAS*nIS
        If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            ! copy global array to local buffer
            Call RHS_ALLO(nAS,nIS,lg_V)
            CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
            ipT = Allocate_GA_Array(nAS*nIS,'ipT')
            CALL GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipT)%A(1),nAS)
            If (do_csf) Then
              CALL RHS_READ_C(lg_V,iCase,iSym,7)
              ipTanti = Allocate_GA_Array(nAS*nIS,'ipTanti')
              CALL GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipTanti)%A(1),nAS)
            End If
            CALL RHS_FREE(lg_V)
            CALL GASYNC()
          ELSE
#endif
            Call RHS_ALLO(nAS,nIS,ipT)
            CALL RHS_READ_C(ipT,iCase,iSym,iVecC2)
            If (do_csf) Then
              Call RHS_ALLO(nAS,nIS,ipTanti)
              CALL RHS_READ_C(ipTanti,iCase,iSym,7)
            End If
#ifdef _MOLCAS_MPP_
          END IF
#endif
        End If
      End If

      Call DCopy_(NTJVX,[Zero],0,TJVX,1)

      nOrbT = nFro(iSyT)+nIsh(iSyT)+nAsh(iSyT)+nSsh(iSyT)
      DO IT=1,NT
        ITABS=IT+NAES(ISYT)
        iTtot = iT + nFro(iSyT) + nIsh(iSyT)
        DO IJ=1,NJ
          ! IJABS=IJ+NIES(ISYJ)
          iJtot = iJ + nFro(iSyJ)

          DO IV=1,NV
            IVABS=IV+NAES(ISYV)
            IF (ISYV == ISYX) THEN !! not sure
              !! ONEADD contributions
              IW1=KTUV(ITABS,IVABS,IVABS)-NTUVES(ISYM)
              IW2=IJ
              IW=IW1+NAS*(IW2-1)

              DPT2C(iTtot+nOrbT*(iJtot-1))
     &          = DPT2C(iTtot+nOrbT*(iJtot-1))
     &          + Two*GA_Arrays(ipT)%A(IW)
              If (do_csf) Then
                DPT2Canti(iTtot+nOrbT*(iJtot-1))
     &            = DPT2Canti(iTtot+nOrbT*(iJtot-1))
     &            + Two*GA_Arrays(ipTanti)%A(IW)
              End If
            END IF
            DO IX=1,NX
              IXABS=IX+NAES(ISYX)
              IW1=KTUV(ITABS,IVABS,IXABS)-NTUVES(ISYM)
              IW2=IJ
              IW=IW1+NAS*(IW2-1)
              TJVX(IT,IJ,IV,IX) = GA_Arrays(ipT)%A(IW)
            END DO
          END DO
        END DO
      END DO

      Call DGEMM_('T','N',NV*NX,NCHO,NT*NJ,
     &            One,TJVX(1,1,1,1),NT*NJ,Cho_Bra(1,1,1),NT*NJ,
     &            One,Cho_KetD(1,1,1),NV*NX)
      Call DGEMM_('N','N',NT*NJ,NCHO,NV*NX,
     &            One,TJVX(1,1,1,1),NT*NJ,Cho_Ket(1,1,1),NV*NX,
     &            One,Cho_BraD(1,1,1),NT*NJ)

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipT)
          if (do_CSF) call deallocate_GA_array(ipTanti)
        ELSE
#endif
          CALL RHS_FREE(ipT)
          If (do_csf) CALL RHS_FREE(ipTanti)

#ifdef _MOLCAS_MPP_
        END IF
#endif

      RETURN

      End Subroutine OLagNS_RI_A
!
!-----------------------------------------------------------------------
!
      SUBROUTINE OLagNS_RI_B(ISYI,ISYK,NT,NJ,NV,NL,TJVL,NTJVL,
     &                       Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

      USE SUPERINDEX, only: KIGTJ, KIGEJ, KTGTU, KTGEU

      implicit none

      integer(kind=iwp), intent(in) :: ISYI, ISYK, NT, NJ, NV, NL,
     &  NTJVL, NCHO
      real(kind=wp), intent(out) :: TJVL(NT,NJ,NV,NL)
      real(kind=wp), intent(in) :: Cho_Bra(NT,NJ,NCHO),
     &  Cho_Ket(NV,NL,NCHO)
      real(kind=wp), intent(inout) :: Cho_BraD(NT,NJ,NCHO),
     &  Cho_KetD(NV,NL,NCHO)

      integer(kind=iwp) :: IT, IV, IJ, IL

      ISYJ = ISYI
      ISYL = ISYK

      ISYT=Mul(JSYM,ISYJ)
      ISYV=Mul(JSYM,ISYL)
      IF(ISYT < ISYV) RETURN
      ISYM=Mul(ISYJ,ISYL) !!

      IF(NINDEP(ISYM,2) > 0) THEN
* The plus combination:
       ICASE=2
       NASP=NTGEU(ISYM)
       NISP=NIGEJ(ISYM)
       NWBP=NASP*NISP
      ELSE
       NWBP=0
      ENDIF
      IF(NINDEP(ISYM,3) > 0) THEN
* The minus combination:
       ICASE=3
       NASM=NTGTU(ISYM)
       NISM=NIGTJ(ISYM)
       NWBM=NASM*NISM
      ELSE
       NWBM=0
      ENDIF
      If (Max(NWBP,NWBM) <= 0) RETURN

      Call DCopy_(NTJVL,[Zero],0,TJVL,1)

      IF(NWBP > 0.AND.NINDEP(ISYM,2) > 0) THEN
        !! Read the T-amplitude
        ICASE=2
        nINP = nINDEP(iSym,iCase)
        nASP = nASup(iSym,iCase)
        If (nINP /= 0) Then
          nISP = nISup(iSym,iCase)
          nVec = nASP*nISP
          If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              ! copy global array to local buffer
              Call RHS_ALLO(nASP,nISP,lg_V)
              CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
              ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
              CALL GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A(1),nASP)
              CALL RHS_FREE(lg_V)
              CALL GASYNC()
            ELSE
#endif
              Call RHS_ALLO(nASP,nISP,ipTP)
              CALL RHS_READ_C(ipTP,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
            END IF
#endif
          End If
        End If

        DO IT=1,NT
          ITABS=IT+NAES(ISYT)
          IVMAX=NV
          IF(ISYV == ISYT) IVMAX=IT
          DO IV=1,IVMAX
            IVABS=IV+NAES(ISYV)
            SCL1=Half
            IW1=KTGEU(ITABS,IVABS)-NTGEUES(ISYM)
            IF(ITABS == IVABS) SCL1=Quart
            DO IJ=1,NJ
              IJABS=IJ+NIES(ISYJ)
              DO IL=1,NL
                ILABS=IL+NIES(ISYL)
                SCL=SCL1
                IF(IJABS >= ILABS) THEN
                 IW2=KIGEJ(IJABS,ILABS)-NIGEJES(ISYM)
                 IF(IJABS == ILABS) SCL=SQ2*SCL1
                ELSE
                 IW2=KIGEJ(ILABS,IJABS)-NIGEJES(ISYM)
                END IF
                IW=IW1+NASP*(IW2-1)
                TJVL(IT,IJ,IV,IL) = SCL*GA_Arrays(ipTP)%A(IW)
              END DO
            END DO
          END DO
        END DO

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTP)
        else
#endif
          CALL RHS_FREE(ipTP)
#ifdef _MOLCAS_MPP_
        end if
#endif
      END IF

      IF(NINDEP(ISYM,3) > 0) THEN
        !! Read the T-amplitude
        ICASE=3
        nINM = nINDEP(iSym,iCase)
        nASM = nASup(iSym,iCase)
        If (nINM /= 0) Then
          nISM = nISup(iSym,iCase)
          nVec = nASM*nISM
          If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              ! copy global array to local buffer
              Call RHS_ALLO(nASM,nISM,lg_V)
              CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
              ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
              CALL GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A(1),nASM)
              CALL RHS_FREE(lg_V)
              CALL GASYNC()
            ELSE
#endif
              Call RHS_ALLO(nASM,nISM,ipTM)
              CALL RHS_READ_C(ipTM,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
            End If
#endif
          End If
        End If

        DO IT=1,NT
          ITABS=IT+NAES(ISYT)
          IVMAX=NV
          IF(ISYV == ISYT) IVMAX=IT-1
          DO IV=1,IVMAX
            IVABS=IV+NAES(ISYV)
            IW1=KTGTU(ITABS,IVABS)-NTGTUES(ISYM)
            DO IJ=1,NJ
              IJABS=IJ+NIES(ISYJ)
              DO IL=1,NL
                ILABS=IL+NIES(ISYL)
                IF(IJABS > ILABS) THEN
                  IW2=KIGTJ(IJABS,ILABS)-NIGTJES(ISYM)
                  SCL =  Half
                ELSE IF (IJABS < ILABS) THEN
                  IW2=KIGTJ(ILABS,IJABS)-NIGTJES(ISYM)
                  SCL = -Half
                ELSE
                  CYCLE
                END IF
                IW=IW1+NASM*(IW2-1)
                TJVL(IT,IJ,IV,IL) = TJVL(IT,IJ,IV,IL)
     &            + SCL*GA_Arrays(ipTM)%A(IW)
              END DO
            END DO
          END DO
        END DO

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTM)
        else
#endif
          CALL RHS_FREE(ipTM)
#ifdef _MOLCAS_MPP_
        end if
#endif
      END IF

      Call DGEMM_('T','N',NV*NL,NCHO,NT*NJ,
     &            One,TJVL(1,1,1,1),NT*NJ,Cho_Bra(1,1,1),NT*NJ,
     &            One,Cho_KetD(1,1,1),NV*NL)
      Call DGEMM_('N','N',NT*NJ,NCHO,NV*NL,
     &            One,TJVL(1,1,1,1),NT*NJ,Cho_Ket(1,1,1),NV*NL,
     &            One,Cho_BraD(1,1,1),NT*NJ)

      RETURN

      End Subroutine OLagNS_RI_B
!
!-----------------------------------------------------------------------
!
      SUBROUTINE OLagNS_RI_C(ISYI,ISYK,NA,NU,NV,NX,AUVX,NAUVX,
     &                       Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

      USE SUPERINDEX
      use caspt2_global, only: do_csf

      implicit none

      integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NU, NV, NX,
     &  NAUVX, NCHO
      real(kind=wp), intent(out) :: AUVX(NA,NU,NV,NX)
      real(kind=wp), intent(in) :: Cho_Bra(NA,NU,NCHO),
     &  Cho_Ket(NV,NX,NCHO)
      real(kind=wp), intent(inout) :: Cho_BraD(NA,NU,NCHO),
     &  Cho_KetD(NV,NX,NCHO)

      real(kind=wp) :: ValCF
      integer(kind=iwp) :: IA, IU, IV, IX

      ISYU = ISYI
      ISYX = ISYK

      ISYA=Mul(JSYM,ISYU)
      ISYV=Mul(JSYM,ISYX)
      ISYM=ISYA !!
      IF(NINDEP(ISYM,4) == 0) RETURN
      NAS=NTUV(ISYM)
      NIS=NSSH(ISYM)
      NWC=NAS*NIS
      IF(NWC == 0) RETURN
!
!     ---- C
!
      !! Read the T-amplitude
      ICASE=4
      nIN = nINDEP(iSym,iCase)
      nAS = nASup(iSym,iCase)
      If (nIN /= 0) Then
        nIS = nISup(iSym,iCase)
        nVec = nIN*nIS
        If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            Call RHS_ALLO(nAS,nIS,lg_V)
            CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
            ipT = Allocate_GA_Array(nAS*nIS,'ipT')
            CALL GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipT)%A(1),nAS)
            If (do_csf) Then
              CALL RHS_READ_C(lg_V,iCase,iSym,7)
              ipTanti = Allocate_GA_Array(nAS*nIS,'ipTanti')
              CALL GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipTanti)%A(1),nAS)
            End If
            Call RHS_FREE(lg_V)
            CALL GASYNC()
          ELSE
#endif
            Call RHS_ALLO(nAS,nIS,ipT)
            CALL RHS_READ_C(ipT,iCase,iSym,iVecC2)
            If (do_csf) Then
              Call RHS_ALLO(nAS,nIS,ipTanti)
              CALL RHS_READ_C(ipTanti,iCase,iSym,7)
            End If
#ifdef _MOLCAS_MPP_
          END IF
#endif
        End If
      End If

      Call DCopy_(NAUVX,[Zero],0,AUVX,1)

      nOrbA = nFro(iSyA)+nIsh(iSyA)+nAsh(iSyA)+nSsh(iSyA)
      DO IA=1,NA
        iAtot = iA + nFro(iSyA) + nIsh(iSyA) + nAsh(iSyA)
        DO IU=1,NU
          IUABS=IU+NAES(ISYU)
          iUtot = iU + nFro(iSyU) + nIsh(iSyU)
          DO IV=1,NV
            IVABS=IV+NAES(ISYV)
            ValCF = Zero
            IF (ISYV == ISYX) THEN !! not sure
              !! ONEADD contributions
              IW1=KTUV(IUABS,IVABS,IVABS)-NTUVES(ISYM)
              IW2=IA
              IW=IW1+NAS*(IW2-1)

              ValCF = GA_Arrays(ipT)%A(IW)*Two
              DPT2C(iAtot+nOrbA*(iUtot-1))
     &          = DPT2C(iAtot+nOrbA*(iUtot-1)) + ValCF
              If (do_csf) Then
                DPT2Canti(iAtot+nOrbA*(iUtot-1))
     &            = DPT2Canti(iAtot+nOrbA*(iUtot-1))
     &            + Two*GA_Arrays(ipTanti)%A(IW)
              End If
              ValCF = ValCF*SCLNEL
            END IF
            DO IX=1,NX
              IXABS=IX+NAES(ISYX)
              IW1=KTUV(IUABS,IVABS,IXABS)-NTUVES(ISYM)
              IW2=IA
              IW=IW1+NAS*(IW2-1)

              AUVX(IA,IU,IV,IX) = AUVX(IA,IU,IV,IX)
     &          + GA_Arrays(ipT)%A(IW)
              AUVX(IA,IX,IU,IX) = AUVX(IA,IX,IU,IX) - ValCF*Half
            END DO
          END DO
        END DO
      END DO

      Call DGEMM_('T','N',NV*NX,NCHO,NA*NU,
     &            One,AUVX(1,1,1,1),NA*NU,Cho_Bra(1,1,1),NA*NU,
     &            One,Cho_KetD(1,1,1),NV*NX)
      Call DGEMM_('N','N',NA*NU,NCHO,NV*NX,
     &            One,AUVX(1,1,1,1),NA*NU,Cho_Ket(1,1,1),NV*NX,
     &            One,Cho_BraD(1,1,1),NA*NU)

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipT)
          if (do_CSF) call deallocate_GA_array(ipTanti)
        ELSE
#endif
          CALL RHS_FREE(ipT)
          If (do_csf) CALL RHS_FREE(ipTanti)
#ifdef _MOLCAS_MPP_
        END IF
#endif

      RETURN

      End Subroutine OLagNS_RI_C
!
!-----------------------------------------------------------------------
!
      SUBROUTINE OLagNS_RI_D1(ISYI,ISYK,NA,NJ,NV,NX,AJVX,NAJVX,
     &                        Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

      USE SUPERINDEX, only: KTU
      use caspt2_global, only: do_csf

      implicit none

#include "intent.fh"

      integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NJ, NV, NX,
     &  NAJVX, NCHO
      real(kind=wp), intent(_OUT_) :: AJVX(NV,NX,*)
      real(kind=wp), intent(in) :: Cho_Bra(NA,NJ,NCHO),
     &  Cho_Ket(NV,NX,NCHO)
      real(kind=wp), intent(inout) :: Cho_BraD(NA,NJ,NCHO),
     &  Cho_KetD(NV,NX,NCHO)
*      Logical Incore
      integer(kind=iwp) :: IOFFD(8,8)
      integer(kind=iwp) :: ISW, ISA, IASTA, IJSTA, IJ, IA, IX, IV

      ISYJ = ISYI
      ISYX = ISYK

      DO ISW=1,NSYM
       IO=0
       DO ISA=1,NSYM
        IOFFD(ISA,ISW)=IO
        ISI=Mul(ISA,ISW)
        IO=IO+NSSH(ISA)*NISH(ISI)
       END DO
      END DO

      ISYA=Mul(JSYM,ISYJ)
      ISYV=Mul(JSYM,ISYX)
      ISYM=JSYM !!!
      IF(NINDEP(ISYM,5) == 0) RETURN
      NAS1=NTU(ISYM)
      NAS=2*NAS1
      NIS=NISUP(ISYM,5)
      NWD=NAS*NIS
      IF(NWD == 0) RETURN
!
!     ---- D1
!
      !! Read the T-amplitude
      ICASE=5
      nIN = nINDEP(iSym,iCase)
      nAS = nASup(iSym,iCase)
      If (nIN /= 0) Then
        nIS = nISup(iSym,iCase)
        nVec = nAS*nIS
        If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            Call RHS_ALLO(nAS,nIS,lg_V)
            CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
            ipT = Allocate_GA_Array(nAS*nIS,'ipT')
            CALL GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipT)%A(1),nAS)
            If (do_csf) Then
              CALL RHS_READ_C(lg_V,iCase,iSym,7)
              ipTanti = Allocate_GA_Array(nAS*nIS,'ipTanti')
              CALL GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipTanti)%A(1),nAS)
            End If
            Call RHS_FREE(lg_V)
            CALL GASYNC()
          ELSE
#endif
            Call RHS_ALLO(nAS,nIS,ipT)
            CALL RHS_READ_C(ipT,iCase,iSym,iVecC2)
            If (do_csf) Then
              Call RHS_ALLO(nAS,nIS,ipTanti)
              CALL RHS_READ_C(ipTanti,iCase,iSym,7)
            End If
#ifdef _MOLCAS_MPP_
          END IF
#endif
        End If
      End If

      NBXSZA=NSECBX
      NBXSZJ=NINABX

      DO IASTA=1,NA,NBXSZA
        IAEND=MIN(IASTA-1+NBXSZA,NA)
        NASZ=IAEND-IASTA+1
        DO IJSTA=1,NJ,NBXSZJ
          IJEND=MIN(IJSTA-1+NBXSZJ,NJ)
          NJSZ=IJEND-IJSTA+1

      IAJSTA=1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
      Call DCopy_(NAJVX,[Zero],0,AJVX,1)

      nOrbA = nFro(iSyA)+nIsh(iSyA)+nAsh(iSyA)+nSsh(iSyA)
      IAJ=0
      DO IJ=IJSTA,IJEND
        iJtot = iJ + nFro(iSyJ)
        DO IA=IASTA,IAEND
          iAtot = iA + nFro(iSyA) + nIsh(iSyA) + nAsh(iSyA)
          IAJ = IAJ + 1
          DO IX=1,NX
            IXABS=IX+NAES(ISYX)
            iXtot = iX + nFro(iSyX) + nIsh(iSyX)
            DO IV=1,NV
              IVABS=IV+NAES(ISYV)
              iVtot = iV + nFro(iSyV) + nIsh(iSyV)
              IW1=KTU(IVABS,IXABS)-NTUES(ISYM)
              IW2=IOFFD(ISYA,ISYM)+IJ+NJ*(IA-1)
              IW=IW1+NAS*(IW2-1)

              If (iVtot == iXtot) Then
                DPT2C(iAtot+nOrbA*(iJtot-1))
     &            = DPT2C(iAtot+nOrbA*(iJtot-1))
     &            + Two*GA_Arrays(ipT)%A(IW)
                If (do_csf) Then
                  DPT2Canti(iAtot+nOrbA*(iJtot-1))
     &              = DPT2Canti(iAtot+nOrbA*(iJtot-1))
     &              + Two*GA_Arrays(ipTanti)%A(IW)
                End If
              End If
              AJVX(IV,IX,IAJ) = GA_Arrays(ipT)%A(IW)
            END DO
          END DO
        END DO
      END DO

      Call DGEMM_('T','N',NASZ*NJSZ,NCHO,NV*NX,
     &            One,AJVX(1,1,1),NV*NX,Cho_Ket(1,1,1),NV*NX,
     &            One,Cho_BraD(IAJSTA,1,1),NA*NJ)
      Call DGEMM_('N','N',NV*NX,NCHO,NASZ*NJSZ,
     &            One,AJVX(1,1,1),NV*NX,Cho_Bra(IAJSTA,1,1),NA*NJ,
     &            One,Cho_KetD(1,1,1),NV*NX)

        ENDDO
      ENDDO

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipT)
          if (do_CSF) call deallocate_GA_array(ipTanti)
        ELSE
#endif
          CALL RHS_FREE(ipT)
          If (do_csf) CALL RHS_FREE(ipTanti)
#ifdef _MOLCAS_MPP_
        END IF
#endif

      RETURN

      End Subroutine OLagNS_RI_D1
!
!-----------------------------------------------------------------------
!
      SUBROUTINE OLagNS_RI_D2(ISYI,ISYK,NA,NU,NV,NL,AUVL,NAUVL,
     &                        Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

      USE SUPERINDEX, only: KTU

      implicit none

      integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NU, NV, NL,
     &  NAUVL, NCHO
      real(kind=wp), intent(out) :: AUVL(NA,NU,NV,NL)
      real(kind=wp), intent(in) :: Cho_Bra(NA,NU,NCHO),
     &  Cho_Ket(NV,NL,NCHO)
      real(kind=wp), intent(inout) :: Cho_BraD(NA,NU,NCHO),
     &  Cho_KetD(NV,NL,NCHO)
*      Logical Incore
      integer(kind=iwp) :: IOFFD(8,8)
      integer(kind=iwp) :: ISYW, ISYA, IA, IU, IV, IL

      ISYU = ISYI
      ISYL = ISYK

      DO ISYW=1,NSYM
       IO=0
       DO ISYA=1,NSYM
        IOFFD(ISYA,ISYW)=IO
        ISYII=Mul(ISYA,ISYW)
        IO=IO+NSSH(ISYA)*NISH(ISYII)
       END DO
      END DO

      ISYA=Mul(JSYM,ISYU)
      ISYV=Mul(JSYM,ISYL)
      ISYM=Mul(ISYU,ISYV)
      IF(NINDEP(ISYM,5) == 0) RETURN
      NAS1=NTU(ISYM)
      NAS=2*NAS1
      NIS=NISUP(ISYM,5)
      NWD=NAS*NIS
      IF(NWD == 0) RETURN
!
!     ---- D2
!
      !! Read the T-amplitude
      ICASE=5
      nIN = nINDEP(iSym,iCase)
      nAS = nASup(iSym,iCase)
      If (nIN /= 0) Then
        nIS = nISup(iSym,iCase)
        nVec = nAS*nIS
        If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            Call RHS_ALLO(nAS,nIS,lg_V)
            CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
            ipT = Allocate_GA_Array(nAS*nIS,'ipT')
            CALL GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipT)%A(1),nAS)
            If (do_csf) Then
              CALL RHS_READ_C(lg_V,iCase,iSym,7)
              ipTanti = Allocate_GA_Array(nAS*nIS,'ipTanti')
              CALL GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipTanti)%A(1),nAS)
            End If
            Call RHS_FREE(lg_V)
            CALL GASYNC()
          ELSE
#endif
            Call RHS_ALLO(nAS,nIS,ipT)
            CALL RHS_READ_C(ipT,iCase,iSym,iVecC2)
            If (do_csf) Then
              Call RHS_ALLO(nAS,nIS,ipTanti)
              CALL RHS_READ_C(ipTanti,iCase,iSym,7)
            End If
#ifdef _MOLCAS_MPP_
          END IF
#endif
        End If
      End If

      Call DCopy_(NAUVL,[Zero],0,AUVL,1)

      DO IA=1,NA
        DO IU=1,NU
          IUABS=IU+NAES(ISYU)
          DO IV=1,NV
            IVABS=IV+NAES(ISYV)
            DO IL=1,NL
              IW1=NAS1+KTU(IVABS,IUABS)-NTUES(ISYM)
              IW2=IOFFD(ISYA,ISYM)+IL+NL*(IA-1)
              IW=IW1+NAS*(IW2-1)
              AUVL(IA,IU,IV,IL) = GA_Arrays(ipT)%A(IW)
            END DO
          END DO
        END DO
      END DO

      Call DGEMM_('T','N',NV*NL,NCHO,NA*NU,
     &            One,AUVL,NA*NU,Cho_Bra,NA*NU,
     &            One,Cho_KetD,NV*NL)
      Call DGEMM_('N','N',NA*NU,NCHO,NV*NL,
     &            One,AUVL,NA*NU,Cho_Ket,NV*NL,
     &            One,Cho_BraD,NA*NU)

      if (nIN /= 0 .and. nVec /= 0) then
#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipT)
          if (do_CSF) call deallocate_GA_array(ipTanti)
        else
#endif
          CALL RHS_FREE(ipT)
          If (do_csf) CALL RHS_FREE(ipTanti)
#ifdef _MOLCAS_MPP_
        end if
#endif
      END IF

      RETURN

      End Subroutine OLagNS_RI_D2
!
!-----------------------------------------------------------------------
!
      SUBROUTINE OLagNS_RI_E(ISYI,ISYK,NA,NJ,NV,NL,AJVL,NAJVL,
     &                       Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

      USE SUPERINDEX, only: KIGTJ, KIGEJ

      implicit none

#include "intent.fh"

      integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NJ, NV, NL,
     &  NAJVL, NCHO
      real(kind=wp), intent(_OUT_) :: AJVL(NV,NL,*)
      real(kind=wp), intent(in) :: Cho_Bra(NA,NJ,NCHO),
     &  Cho_Ket(NV,NL,NCHO)
      real(kind=wp), intent(inout) :: Cho_BraD(NA,NJ,NCHO),
     &  Cho_KetD(NV,NL,NCHO)
*      Logical Incore
      integer(kind=iwp) :: IOFF1(8), IOFF2(8)
      integer(kind=iwp) :: ISA, IASTA, IJSTA, IJ, IA, IV, IL

      ISYJ = ISYI
      ISYL = ISYK

      ISYA=Mul(JSYM,ISYJ)
      ISYV=Mul(JSYM,ISYL)
      ISYM=ISYV
      ISYJL=Mul(ISYJ,ISYL)

! Set up offset table:
      IO1=0
      IO2=0
      DO ISA=1,NSYM
        IOFF1(ISA)=IO1
        IOFF2(ISA)=IO2
        ISIJ=Mul(ISA,ISYM)
        IO1=IO1+NSSH(ISA)*NIGEJ(ISIJ)
        IO2=IO2+NSSH(ISA)*NIGTJ(ISIJ)
      END DO

      NAS=NASH(ISYM)
      NISP=NISUP(ISYM,6)
      NISM=NISUP(ISYM,7)
      ! NIS=NISP+NISM
      NWEP=NAS*NISP
      NWEM=NAS*NISM
      NW=NWEP+NWEM
      If (NW == 0) RETURN
!
!     ---- EP
!
      IF (NWEP > 0) THEN
        !! Read the T-amplitude
        ICASE=6
        nINP = nINDEP(iSym,iCase)
        nASP = nASup(iSym,iCase)
        If (nINP /= 0) Then
          nISP = nISup(iSym,iCase)
          nVec = nINP*nISP
          If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              ! copy global array to local buffer
              Call RHS_ALLO(nASP,nISP,lg_V)
              CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
              ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
              CALL GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A(1),nASP)
              CALL RHS_FREE(lg_V)
              CALL GASYNC()
            ELSE
#endif
              Call RHS_ALLO(nASP,nISP,ipTP)
              CALL RHS_READ_C(ipTP,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
            END IF
#endif
          End If
        End If

        NBXSZA=NSECBX
        NBXSZJ=NINABX

        DO IASTA=1,NA,NBXSZA
          IAEND=MIN(IASTA-1+NBXSZA,NA)
          NASZ=IAEND-IASTA+1
          DO IJSTA=1,NJ,NBXSZJ
            IJEND=MIN(IJSTA-1+NBXSZJ,NJ)
            NJSZ=IJEND-IJSTA+1

        IAJSTA=1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
        Call DCopy_(NAJVL,[Zero],0,AJVL,1)

        IAJ=0
        DO IJ=IJSTA,IJEND
          IJABS=IJ+NIES(ISYJ)
          DO IA=IASTA,IAEND
            ! IAABS=IA+NSES(ISYA)
            IAJ=IAJ+1

            DO IV=1,NV
              ! IVABS=IV+NAES(ISYV)
              DO IL=1,NL
                ILABS=IL+NIES(ISYL)
                SCL=SQ05
                IF(IJABS >= ILABS) THEN
                  JGEL=KIGEJ(IJABS,ILABS)-NIGEJES(ISYJL)
                  IF(IJABS == ILABS) SCL=One
                ELSE
                  JGEL=KIGEJ(ILABS,IJABS)-NIGEJES(ISYJL)
                END IF
                IW1=IV
                IW2=IA+NA*(JGEL-1)+IOFF1(ISYA)
                IW=IW1+NAS*(IW2-1)

                AJVL(IV,IL,IAJ) = SCL*GA_Arrays(ipTP)%A(IW)
              END DO
            END DO
          END DO
        END DO

        Call DGEMM_('T','N',NASZ*NJSZ,NCHO,NV*NL,
     &              One,AJVL(1,1,1),NV*NL,Cho_Ket(1,1,1),NV*NL,
     &              One,Cho_BraD(IAJSTA,1,1),NA*NJ)
        Call DGEMM_('N','N',NV*NL,NCHO,NASZ*NJSZ,
     &              One,AJVL(1,1,1),NV*NL,Cho_Bra(IAJSTA,1,1),NA*NJ,
     &              One,Cho_KetD(1,1,1),NV*NL)

          ENDDO
        ENDDO

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTP)
        else
#endif
          CALL RHS_FREE(ipTP)
#ifdef _MOLCAS_MPP_
        end if
#endif
      END IF
!
!     ---- EM
!
      IF (NWEM > 0) THEN
        !! Read the T-amplitude
        ICASE=7
        nINM = nINDEP(iSym,iCase)
        nASM = nASup(iSym,iCase)
        If (nINM /= 0) Then
          nISM = nISup(iSym,iCase)
          nVec = nINM*nISM
          If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              ! copy global array to local buffer
              Call RHS_ALLO(nASM,nISM,lg_V)
              CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
              ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
              CALL GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A(1),nASM)
              CALL RHS_FREE(lg_V)
              CALL GASYNC()
            ELSE
#endif
              Call RHS_ALLO(nASM,nISM,ipTM)
              CALL RHS_READ_C(ipTM,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
            End If
#endif
          End If
        End If

        NBXSZA=NSECBX
        NBXSZJ=NINABX

        DO IASTA=1,NA,NBXSZA
          IAEND=MIN(IASTA-1+NBXSZA,NA)
          NASZ=IAEND-IASTA+1
          DO IJSTA=1,NJ,NBXSZJ
            IJEND=MIN(IJSTA-1+NBXSZJ,NJ)
            NJSZ=IJEND-IJSTA+1

        IAJSTA=1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
        Call DCopy_(NAJVL,[Zero],0,AJVL,1)

        IAJ=0
        DO IJ=IJSTA,IJEND
          IJABS=IJ+NIES(ISYJ)
          DO IA=IASTA,IAEND
            ! IAABS=IA+NSES(ISYA)
            IAJ=IAJ+1

            DO IV=1,NV
              ! IVABS=IV+NAES(ISYV)
              DO IL=1,NL
                ILABS=IL+NIES(ISYL)
                IF(IJABS /= ILABS) THEN
                  IF(IJABS > ILABS) THEN
                    SCL=SQ32
                    JGTL=KIGTJ(IJABS,ILABS)-NIGTJES(ISYJL)
                  ELSE
                    SCL=-SQ32
                    JGTL=KIGTJ(ILABS,IJABS)-NIGTJES(ISYJL)
                  END IF
                  IW1=IV
                  IW2=IA+NA*(JGTL-1)+IOFF2(ISYA)
                  IW=IW1+NAS*(IW2-1)

                  AJVL(IV,IL,IAJ) = SCL*GA_Arrays(ipTM)%A(IW)
                END IF
              END DO
            END DO
          END DO
        END DO

        Call DGEMM_('T','N',NASZ*NJSZ,NCHO,NV*NL,
     &              One,AJVL(1,1,1),NV*NL,Cho_Ket(1,1,1),NV*NL,
     &              One,Cho_BraD(IAJSTA,1,1),NA*NJ)
        Call DGEMM_('N','N',NV*NL,NCHO,NASZ*NJSZ,
     &              One,AJVL(1,1,1),NV*NL,Cho_Bra(IAJSTA,1,1),NA*NJ,
     &              One,Cho_KetD(1,1,1),NV*NL)

          ENDDO
        ENDDO

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTM)
        else
#endif
          CALL RHS_FREE(ipTM)
#ifdef _MOLCAS_MPP_
        end if
#endif
      END IF

      RETURN

      End Subroutine OLagNS_RI_E
!
!-----------------------------------------------------------------------
!
      SUBROUTINE OLagNS_RI_F(ISYI,ISYK,NA,NU,NC,NX,AUCX,NAUCX,
     &                       Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

      USE SUPERINDEX, only: KTGTU, KTGEU, KAGTB, KAGEB

      implicit none

      integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NU, NC, NX,
     &  NAUCX, NCHO
      real(kind=wp), intent(out) :: AUCX(NA,NU,NC,NX)
      real(kind=wp), intent(in) :: Cho_Bra(NA,NU,NCHO),
     &  Cho_Ket(NC,NX,NCHO)
      real(kind=wp), intent(inout) :: Cho_BraD(NA,NU,NCHO),
     &  Cho_KetD(NC,NX,NCHO)

      integer(kind=iwp) :: IU, IX, IA, IC

      ISYU = ISYI
      ISYX = ISYK

      IF(ISYU < ISYX) RETURN

      ISYA=Mul(JSYM,ISYU)
      ISYC=Mul(JSYM,ISYX)
      ISYM=Mul(ISYU,ISYX) !!

      IF(NINDEP(ISYM,8) > 0) THEN
* The plus combination:
       NASP=NTGEU(ISYM)
       NISP=NAGEB(ISYM)
       NWFP=NASP*NISP
      ELSE
       NWFP=0
      ENDIF
      IF(NINDEP(ISYM,9) > 0) THEN
       ICASE=9
* The minus combination:
       NASM=NTGTU(ISYM)
       NISM=NAGTB(ISYM)
       NWFM=NASM*NISM
      ELSE
       NWFM=0
      ENDIF
      If (NWFP+NWFM <= 0) RETURN

      Call DCopy_(NAUCX,[Zero],0,AUCX,1)
!
!     ---- FP
!
      IF (NWFP > 0.AND.NINDEP(ISYM,8) > 0) THEN
        !! Read the T-amplitude
        ICASE=8
        nINP = nINDEP(iSym,iCase)
        nASP = nASup(iSym,iCase)
        If (nINP /= 0) Then
          nISP = nISup(iSym,iCase)
          nVec = nINP*nISP
          If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              ! copy global array to local buffer
              Call RHS_ALLO(nASP,nISP,lg_V)
              CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
              ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
              CALL GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A(1),nASP)
              CALL RHS_FREE(lg_V)
              CALL GASYNC()
            ELSE
#endif
              Call RHS_ALLO(nASP,nISP,ipTP)
              CALL RHS_READ_C(ipTP,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
            END IF
#endif
          End If
        End If

        DO IU=1,NU
          IUABS=IU+NAES(ISYU)
          IXMAX=NX
          IF(ISYU == ISYX) IXMAX=IU
          DO IX=1,IXMAX
            IXABS=IX+NAES(ISYX)
            SCL1=Half
            IF(IUABS == IXABS) SCL1=Quart
            IW1=KTGEU(IUABS,IXABS)-NTGEUES(ISYM)
            DO IA=1,NA
              IAABS=IA+NSES(ISYA)
              DO IC=1,NC
                ICABS=IC+NSES(ISYC)
                SCL=SCL1
                IF(IAABS >= ICABS) THEN
                  IW2=KAGEB(IAABS,ICABS)-NAGEBES(ISYM)
                  IF(IAABS == ICABS) SCL=SQ2*SCL1
                ELSE
                  IW2=KAGEB(ICABS,IAABS)-NAGEBES(ISYM)
                END IF
                IW=IW1+NASP*(IW2-1)
                AUCX(IA,IU,IC,IX) = SCL*GA_Arrays(ipTP)%A(IW)
              END DO
            END DO
          END DO
        END DO

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTP)
        else
#endif
          CALL RHS_FREE(ipTP)
#ifdef _MOLCAS_MPP_
        end if
#endif
      END IF
!
!     ---- FM
!
      IF (NWFM > 0.AND.NINDEP(ISYM,9) > 0) THEN
        !! Read the T-amplitude
        ICASE=9
        nINM = nINDEP(iSym,iCase)
        nASM = nASup(iSym,iCase)
        If (nINM /= 0) Then
          nISM = nISup(iSym,iCase)
          nVec = nINM*nISM
          If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              ! copy global array to local buffer
              Call RHS_ALLO(nASM,nISM,lg_V)
              CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
              ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
              CALL GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A(1),nASM)
              CALL RHS_FREE(lg_V)
              CALL GASYNC()
            ELSE
#endif
              Call RHS_ALLO(nASM,nISM,ipTM)
              CALL RHS_READ_C(ipTM,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
            End If
#endif
          End If
        End If

        DO IU=1,NU
          IUABS=IU+NAES(ISYU)
          IXMAX=NX
          IF(ISYU == ISYX) IXMAX=IU-1
          DO IX=1,IXMAX
            IXABS=IX+NAES(ISYX)
            IW1=KTGTU(IUABS,IXABS)-NTGTUES(ISYM)
            DO IA=1,NA
              IAABS=IA+NSES(ISYA)
              DO IC=1,NC
                ICABS=IC+NSES(ISYC)
                IF(IAABS > ICABS) THEN
                  IW2=KAGTB(IAABS,ICABS)-NAGTBES(ISYM)
                  SCL = -Half
                ELSE IF(IAABS < ICABS) THEN
                  IW2=KAGTB(ICABS,IAABS)-NAGTBES(ISYM)
                  SCL =  Half
                ELSE
                  CYCLE
                END IF
                IW=IW1+NASM*(IW2-1)
                AUCX(IA,IU,IC,IX) = AUCX(IA,IU,IC,IX)
     &            + SCL*GA_Arrays(ipTM)%A(IW)
              END DO
            END DO
          END DO
        END DO

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTM)
        else
#endif
        CALL RHS_FREE(ipTM)
#ifdef _MOLCAS_MPP_
        end if
#endif
      END IF

      Call DGEMM_('T','N',NC*NX,NCHO,NA*NU,
     &            One,AUCX,NA*NU,Cho_Bra,NA*NU,
     &            One,Cho_KetD,NC*NX)
      Call DGEMM_('N','N',NA*NU,NCHO,NC*NX,
     &            One,AUCX,NA*NU,Cho_Ket,NC*NX,
     &            One,Cho_BraD,NA*NU)

      RETURN

      End Subroutine OLagNS_RI_F
!
!-----------------------------------------------------------------------
!
      SUBROUTINE OLagNS_RI_G(ISYI,ISYK,NA,NU,NC,NL,AUCL,NAUCL,
     &                       Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

      USE SUPERINDEX, only: KAGEB, KAGTB

      implicit none

#include "intent.fh"

      integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NU, NC, NL,
     &  NAUCL, NCHO
      real(kind=wp), intent(_OUT_) :: AUCL(NA,NU,*)
      real(kind=wp), intent(in) :: Cho_Bra(NA,NU,NCHO),
     &  Cho_Ket(NC,NL,NCHO)
      real(kind=wp), intent(inout) :: Cho_BraD(NA,NU,NCHO),
     &  Cho_KetD(NC,NL,NCHO)
*      Logical Incore
      integer(kind=iwp) :: IOFF1(8), IOFF2(8)
      integer(kind=iwp) :: ISI, ICSTA, ILSTA, IL, IC, IA, IU

      ISYU = ISYI
      ISYL = ISYK

      ISYA=Mul(JSYM,ISYU)
      ISYC=Mul(JSYM,ISYL)
      ISYM=ISYU
      ISYAC=Mul(ISYA,ISYC)
! Set up offset table:
      IO1=0
      IO2=0
      DO ISI=1,NSYM
        IOFF1(ISI)=IO1
        IOFF2(ISI)=IO2
        ISAB=Mul(ISI,ISYM)
        IO1=IO1+NISH(ISI)*NAGEB(ISAB)
        IO2=IO2+NISH(ISI)*NAGTB(ISAB)
      END DO

!   Allocate W with parts WP,WM
      NAS=NASH(ISYM)
      NISP=NISUP(ISYM,10)
      NISM=NISUP(ISYM,11)
      ! NIS=NISP+NISM
      NWGP=NAS*NISP
      NWGM=NAS*NISM
      ! NWG=NWGP+NWGM
!
!     LDGP=NAS
!     LDGM=NAS
!
!     ---- GP
!
      IF (NWGP > 0) THEN
        !! Read the T-amplitude
        ICASE=10
        nINP = nINDEP(iSym,iCase)
        nASP = nASup(iSym,iCase)
        If (nINP /= 0) Then
          nISP = nISup(iSym,iCase)
          nVec = nINP*nISP
          If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              ! copy global array to local buffer
              Call RHS_ALLO(nASP,nISP,lg_V)
              CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
              ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
              CALL GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A(1),nASP)
              CALL RHS_FREE(lg_V)
              CALL GASYNC()
            ELSE
#endif
              Call RHS_ALLO(nASP,nISP,ipTP)
              CALL RHS_READ_C(ipTP,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
            END IF
#endif
          End If
        End If

        NBXSZC=NSECBX
        KCL=NAUCL/(NA*NU)
        NBXSZL=KCL/NC
        IF (NBXSZL <= 0) THEN
          Write (u6,*) 'Not enough memory in ADDRHSG, I give up'
          CALL Abend()
        ENDIF

        DO ICSTA=1,NC,NBXSZC
          ICEND=MIN(ICSTA-1+NBXSZC,NC)
          NCSZ=ICEND-ICSTA+1
          DO ILSTA=1,NL,NBXSZL
            ILEND=MIN(ILSTA-1+NBXSZL,NL)
            ! NLSZ=ILEND-ILSTA+1

            ICLSTA=1+NL*(ICSTA-1)+NCSZ*(ILSTA-1)
            Call DCopy_(NAUCL,[Zero],0,AUCL,1)

        ICL=0
        ! IBUF=0
        DO IL=ILSTA,ILEND
          ! ILABS=IL+NIES(ISYL)
          DO IC=ICSTA,ICEND
            ICABS=IC+NSES(ISYC)
            ICL=ICL+1

            DO IA=1,NA
              IAABS=IA+NSES(ISYA)
              SCL=SQ05
              IF(IAABS >= ICABS) THEN
               IAGEC=KAGEB(IAABS,ICABS)-NAGEBES(ISYAC)
               IF(IAABS == ICABS) SCL=One
              ELSE
               IAGEC=KAGEB(ICABS,IAABS)-NAGEBES(ISYAC)
              END IF
              DO IU=1,NU
                ! IUABS=IU+NAES(ISYU)
                IW1=IU
                IW2=IL+NL*(IAGEC-1)+IOFF1(ISYL)
                IW=IW1+NAS*(IW2-1)

                AUCL(IA,IU,ICL) = SCL*GA_Arrays(ipTP)%A(IW)
              END DO
            END DO
          END DO
        END DO

        Call DGEMM_('N','N',NA*NU,NCHO,ICL,
     &              One,AUCL,NA*NU,Cho_Ket(ICLSTA,1,1),NC*NL,
     &              One,Cho_BraD(1,1,1),NA*NU)
        Call DGEMM_('T','N',ICL,NCHO,NA*NU,
     &              One,AUCL,NA*NU,Cho_Bra(1,1,1),NA*NU,
     &              One,Cho_KetD(ICLSTA,1,1),NC*NL)

          ENDDO
        ENDDO

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTP)
        else
#endif
          CALL RHS_FREE(ipTP)
#ifdef _MOLCAS_MPP_
        end if
#endif
      END IF
!
!     ---- GM
!
      IF (NWGM > 0) THEN
        !! Read the T-amplitude
        ICASE=11
        nINM = nINDEP(iSym,iCase)
        nASM = nASup(iSym,iCase)
        If (nINM /= 0) Then
          nISM = nISup(iSym,iCase)
          nVec = nINM*nISM
          If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              ! copy global array to local buffer
              Call RHS_ALLO(nASM,nISM,lg_V)
              CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
              ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
              CALL GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A(1),nASM)
              CALL RHS_FREE(lg_V)
              CALL GASYNC()
            ELSE
#endif
              Call RHS_ALLO(nASM,nISM,ipTM)
              CALL RHS_READ_C(ipTM,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
            End If
#endif
          End If
        End If

        NBXSZC=NSECBX
        KCL=NAUCL/(NA*NU)
        NBXSZL=KCL/NC
        IF (NBXSZL <= 0) THEN
          Write (u6,*) 'Not enough memory in ADDRHSG, I give up'
          CALL Abend()
        ENDIF


        DO ICSTA=1,NC,NBXSZC
          ICEND=MIN(ICSTA-1+NBXSZC,NC)
          NCSZ=ICEND-ICSTA+1
          DO ILSTA=1,NL,NBXSZL
            ILEND=MIN(ILSTA-1+NBXSZL,NL)
            ! NLSZ=ILEND-ILSTA+1

            ICLSTA=1+NL*(ICSTA-1)+NCSZ*(ILSTA-1)
            Call DCopy_(NAUCL,[Zero],0,AUCL,1)

        ICL=0
        ! IBUF=0
        DO IL=ILSTA,ILEND
          ! ILABS=IL+NIES(ISYL)
          DO IC=ICSTA,ICEND
            ICABS=IC+NSES(ISYC)
            ICL=ICL+1

            DO IA=1,NA
              IAABS=IA+NSES(ISYA)
              IF(IAABS > ICABS) THEN
                IAGTC=KAGTB(IAABS,ICABS)-NAGTBES(ISYAC)
                SCL=SQ32
              ELSE IF (IAABS < ICABS) Then
                IAGTC=KAGTB(ICABS,IAABS)-NAGTBES(ISYAC)
                SCL=-SQ32
              ELSE
                CYCLE
              End If
              DO IU=1,NU
                ! IUABS=IU+NAES(ISYU)
                IW1=IU
                IW2=IL+NL*(IAGTC-1)+IOFF2(ISYL)
                IW=IW1+NAS*(IW2-1)

                AUCL(IA,IU,ICL) = SCL*GA_Arrays(ipTM)%A(IW)
              END DO
            END DO
          END DO
        END DO

        Call DGEMM_('N','N',NA*NU,NCHO,ICL,
     &              One,AUCL,NA*NU,Cho_Ket(ICLSTA,1,1),NC*NL,
     &              One,Cho_BraD(1,1,1),NA*NU)
        Call DGEMM_('T','N',ICL,NCHO,NA*NU,
     &              One,AUCL,NA*NU,Cho_Bra(1,1,1),NA*NU,
     &              One,Cho_KetD(ICLSTA,1,1),NC*NL)

          ENDDO
        ENDDO

#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTM)
        else
#endif
          CALL RHS_FREE(ipTM)
#ifdef _MOLCAS_MPP_
        end if
#endif
      END IF

      RETURN

      End Subroutine OLagNS_RI_G
!
!-----------------------------------------------------------------------
!
      !! ADDRHSH
      Subroutine OLagNS_RI_H(ISYI,ISYK,NA,NJ,NC,NL,AJCL,NAJCL,
     &                       Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

      USE SUPERINDEX, only: KAGEB, KAGTB, KIGEJ, KIGTJ

      implicit none

#include "intent.fh"
#include "macros.fh"

      integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NJ, NC, NL,
     &  NAJCL, NCHO
      real(kind=wp), intent(_OUT_) :: AJCL(NC*NL,*)
      real(kind=wp), intent(in) :: Cho_Bra(NA,NJ,NCHO),
     &  Cho_Ket(NC,NL,NCHO)
      real(kind=wp), intent(inout) :: Cho_BraD(NA,NJ,NCHO),
     &  Cho_KetD(NC,NL,NCHO)

      integer(kind=iwp) :: IASTA, IJSTA, ICSTA, ILSTA, IJ, IA, IL, IC

      ISYJ = ISYI
      ISYL = ISYK

      IF(ISYJ < ISYL) Return
      ISYA=Mul(JSYM,ISYJ)
      ISYC=Mul(JSYM,ISYL)
      ISYM=Mul(ISYA,ISYC)
      ISYAC=ISYM
      ISYJL=ISYM

      NASP=NAGEB(ISYM)
      NISP=NIGEJ(ISYM)
      NWHP=NASP*NISP
      IF(NWHP == 0) Return
!     if (nwhp == 0) write (u6,*) cho_bra(1,1,1) !! avoid unused tenta
!     if (nwhp == 0) write (u6,*) cho_ketd(1,1,1) !! avoid unused tenta
      NASM=NAGTB(ISYM)
      NISM=NIGTJ(ISYM)
      NWHM=NASM*NISM
!
!     LDHP=NASP
!     LDHM=NASM
!
!     ---- HP
!
      !! Read the T-amplitude
      ICASE=12
      nINP = nINDEP(iSym,iCase)
      nASP = nASup(iSym,iCase)
      nVec = 0
      If (nINP /= 0) Then
        nISP = nISup(iSym,iCase)
        nVec = nINP*nISP
        If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            ! copy global array to local buffer
            Call RHS_ALLO(nASP,nISP,lg_V)
            CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
            ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
            CALL GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A(1),nASP)
            CALL RHS_FREE(lg_V)
            CALL GASYNC()
          ELSE
#endif
            Call RHS_ALLO(nASP,nISP,ipTP)
            CALL RHS_READ_C(ipTP,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
          END IF
#endif
        End If
      End If

      NBXSZA=NSECBX
      KAJ=NAJCL/(NC*NL)
      NBXSZJ=KAJ/NA
      IF (NBXSZJ <= 0) THEN
        Write (u6,*) 'Not enough memory in ADDRHSH, I give up'
        CALL Abend()
      ENDIF

      NBXSZC=NSECBX
      NBXSZL=NINABX

      DO IASTA=1,NA,NBXSZA
        IAEND=MIN(IASTA-1+NBXSZA,NA)
        NASZ=IAEND-IASTA+1
        DO IJSTA=1,NJ,NBXSZJ
          IJEND=MIN(IJSTA-1+NBXSZJ,NJ)
          NJSZ=IJEND-IJSTA+1

           IAJSTA=1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
           Call DCopy_(NAJCL,[Zero],0,AJCL,1)

          DO ICSTA=1,NC,NBXSZC
            ICEND=MIN(ICSTA-1+NBXSZC,NC)
            NCSZ=ICEND-ICSTA+1
            DO ILSTA=1,NL,NBXSZL
              ILEND=MIN(ILSTA-1+NBXSZL,NL)
              ! NLSZ=ILEND-ILSTA+1

              ICLSTA=1+NL*(ICSTA-1)+NCSZ*(ILSTA-1)

      IAJ=0
      ! IBUF=0
      DO IJ=IJSTA,IJEND
        IJABS=IJ+NIES(ISYJ)
        ILMAX=NL
        IF(ISYJ == ISYL) ILMAX=IJ
        DO IA=IASTA,IAEND
          IAABS=IA+NSES(ISYA)
          IAJ=IAJ+1

          ICL=0
          DO IL=ILSTA,MIN(ILEND,ILMAX)
            ILABS=IL+NIES(ISYL)
            SCL1=One
            IJGEL=KIGEJ(IJABS,ILABS)-NIGEJES(ISYJL)
            IF(IJABS == ILABS) SCL1=SQ05
            DO IC=ICSTA,ICEND
              ICABS=IC+NSES(ISYC)
              ICL=ICL+1

              SCL=SCL1
              IF(IAABS >= ICABS) THEN
                IAGEC=KAGEB(IAABS,ICABS)-NAGEBES(ISYAC)
                IF(IAABS == ICABS) SCL=SQ2*SCL1
              ELSE
                IAGEC=KAGEB(ICABS,IAABS)-NAGEBES(ISYAC)
              END IF
              IW=IAGEC+NAGEB(ISYM)*(IJGEL-1)

              AJCL(ICLSTA+ICL-1,IAJ) = SCL*GA_Arrays(ipTP)%A(IW)
            END DO
          END DO
        END DO
      END DO

            ENDDO
          ENDDO
          Call DGEMM_('T','N',NASZ*NJSZ,NCHO,NC*NL,
     &                One,AJCL(1,1),NC*NL,Cho_Ket(1,1,1),NC*NL,
     &                One,Cho_BraD(IAJSTA,1,1),NA*NJ)
          Call DGEMM_('N','N',NC*NL,NCHO,NASZ*NJSZ,
     &                One,AJCL(1,1),NC*NL,Cho_Ket(IAJSTA,1,1),NC*NL,
     &                One,Cho_BraD(1,1,1),NA*NJ)

        ENDDO
      ENDDO

      if (nVec /= 0) then
#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTP)
        else
#endif
          CALL RHS_FREE(ipTP)
#ifdef _MOLCAS_MPP_
        end if
#endif
      end if
!
!     ---- HM
!
      !! Read the T-amplitude
      ICASE=13
      nINM = nINDEP(iSym,iCase)
      nASM = nASup(iSym,iCase)
      nVec = 0
      If (nINM /= 0) Then
        nISM = nISup(iSym,iCase)
        nVec = nASM*nISM
        If (nVec /= 0) Then
#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            ! copy global array to local buffer
            Call RHS_ALLO(nASM,nISM,lg_V)
            CALL RHS_READ_C(lg_V,iCase,iSym,iVecC2)
            ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
            CALL GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A(1),nASM)
            CALL RHS_FREE(lg_V)
            CALL GASYNC()
          ELSE
#endif
            Call RHS_ALLO(nASM,nISM,ipTM)
            CALL RHS_READ_C(ipTM,iCase,iSym,iVecC2)
#ifdef _MOLCAS_MPP_
          End If
#endif
        End If
      End If

      NBXSZA=NSECBX
      KAJ=NAJCL/(NC*NL)
      NBXSZJ=KAJ/NA
      IF (NBXSZJ <= 0) THEN
        Write (u6,*) 'Not enough memory in ADDRHSH, I give up'
        CALL Abend()
      ENDIF
      NBXSZC=NSECBX
      NBXSZL=NINABX

      DO IASTA=1,NA,NBXSZA
        IAEND=MIN(IASTA-1+NBXSZA,NA)
        NASZ=IAEND-IASTA+1
        DO IJSTA=1,NJ,NBXSZJ
          IJEND=MIN(IJSTA-1+NBXSZJ,NJ)
          NJSZ=IJEND-IJSTA+1

          IAJSTA=1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
          Call DCopy_(NAJCL,[Zero],0,AJCL,1)

          DO ICSTA=1,NC,NBXSZC
            ICEND=MIN(ICSTA-1+NBXSZC,NC)
            NCSZ=ICEND-ICSTA+1
            DO ILSTA=1,NL,NBXSZL
              ILEND=MIN(ILSTA-1+NBXSZL,NL)
              ! NLSZ=ILEND-ILSTA+1

              ICLSTA=1+NL*(ICSTA-1)+NCSZ*(ILSTA-1)

      IAJ=0
      ! IBUF=0
      DO IJ=IJSTA,IJEND
        IJABS=IJ+NIES(ISYJ)
        ILMAX=NL
        IF(ISYJ == ISYL) ILMAX=IJ-1
        DO IA=IASTA,IAEND
          IAABS=IA+NSES(ISYA)
          IAJ=IAJ+1

          ICL=0
          DO IL=ILSTA,MIN(ILMAX,ILEND)
            ILABS=IL+NIES(ISYL)
            IJGTL=KIGTJ(IJABS,ILABS)-NIGTJES(ISYJL)
            DO IC=ICSTA,ICEND
              ICABS=IC+NSES(ISYC)
              ICL=ICL+1

              IF (IAABS > ICABS) THEN
                IAGTC=KAGTB(IAABS,ICABS)-NAGTBES(ISYAC)
                SCL= SQ3
              ELSE IF(IAABS < ICABS) THEN
                IAGTC=KAGTB(ICABS,IAABS)-NAGTBES(ISYAC)
                SCL=-SQ3
              ELSE
                Cycle
              ENDIF
              IW=IAGTC+NAGTB(ISYM)*(IJGTL-1)

              AJCL(ICLSTA+ICL-1,IAJ) = SCL*GA_Arrays(ipTM)%A(IW)
            END DO
          END DO
        END DO
      END DO

            ENDDO
          ENDDO
          Call DGEMM_('T','N',NASZ*NJSZ,NCHO,NC*NL,
     &                One,AJCL(1,1),NC*NL,Cho_Ket(1,1,1),NC*NL,
     &                One,Cho_BraD(IAJSTA,1,1),NA*NJ)
          Call DGEMM_('N','N',NC*NL,NCHO,NASZ*NJSZ,
     &                One,AJCL(1,1),NC*NL,Cho_Ket(IAJSTA,1,1),NC*NL,
     &                One,Cho_BraD(1,1,1),NA*NJ)
        ENDDO
      ENDDO

      if (nVec /= 0) then
#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          call deallocate_GA_array(ipTM)
        else
#endif
        CALL RHS_FREE(ipTM)
#ifdef _MOLCAS_MPP_
        end if
#endif
      end if

      unused_var(cho_bra)
      unused_var(cho_ketd)

      Return

      End Subroutine OLagNS_RI_H
!
!-----------------------------------------------------------------------
!
      Subroutine Cnst_A_PT2(block1,block2)

      implicit none

      integer(kind=iwp), intent(in) :: block1, block2

      integer(kind=iwp) :: ndim1
#ifdef _MOLCAS_MPP_
      logical(kind=iwp) :: bstat
      integer(kind=iwp) :: ILOV1, IHIV1, JLOV1, JHIV1, MV1, iRank
#endif

      ndim1 = nSh(iSym0,block1)*nSh(iSym0,block2)
      if (ndim1 == 0) return

#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
        !! The BRAD vector is first put from local BRA(:) to the
        !! global LG_V1 array. The data is shared among all processes.
        !! The bare Cholesky vector (KET(:)) is local.

        !! NV(I): Number of local Cholesky vectors for BRA(:)
        !! NDIM2: number of total Cholesky vectors for this batch
        !!        (usually NV*NPROCS)
        !! NVJ: number of local Cholesky vectors for KET(:)
        bStat = GA_CREATE_IRREG(MT_DBL,NDIM1,NDIM2,'BRAD',
     &                          1,1,MAP2,NPROCS,LG_V1)
        Call Cholesky_Vectors(2,block1,block2,JSYM,BRA,
     &                        nBra,IBSTA,IBEND)
        !! finds out the range of the global array g_a that process
        !! iproc owns.
        CALL GA_DISTRIBUTION(LG_V1,MYRANK,ILOV1,IHIV1,JLOV1,JHIV1)
        !! provides access to local data in the specified patch of
        !! the array owned by the calling process
        CALL GA_ACCESS(LG_V1,ILOV1,IHIV1,JLOV1,JHIV1,MV1,NDIM1)
        CALL DCOPY_(NDIM1*(JHIV1-JLOV1+1),BRA,1,DBL_MB(MV1),1)
        !! releases access to a global array, when the data was
        !! accessed for writing
        CALL GA_RELEASE_UPDATE(LG_V1,ILOV1,IHIV1,JLOV1,JHIV1)
        CALL GA_SYNC()

        !! ket is ndim1*NVJ dimension
        Call Get_Cholesky_Vectors(block1,block2,JSYM,KET,nKet,
     &                            JBSTA,JBEND)

        do iRank = 0, NPROCS-1
          CALL GA_DISTRIBUTION(LG_V1,iRank,ILOV1,IHIV1,JLOV1,JHIV1)
          CALL GA_GET(LG_V1,ILOV1,IHIV1,JLOV1,JHIV1,BRA,NDIM1)
          Call DGEMM_('T','N',JHIV1-JLOV1+1,NVJ,ndim1,
     &                One,BRA,ndim1,KET,ndim1,
     &    One,A_PT2(IOFFCV+JLOV1-1,JOFFCV+MAP2(myRank+1)-1),MaxVec_PT2)
        end do
        bStat =  GA_DESTROY(LG_V1)
      else
#endif
        Call Cholesky_Vectors(2,block1,block2,JSYM,BRA,nBra,
     &                        IBSTA,IBEND)
        Call Get_Cholesky_Vectors(block1,block2,JSYM,KET,nKet,
     &                            JBSTA,JBEND)
        Call DGEMM_('T','N',NVI,NVJ,ndim1,
     &              One,BRA,ndim1,KET,ndim1,
     &              One,A_PT2(IOFFCV,JOFFCV),MaxVec_PT2)
#ifdef _MOLCAS_MPP_
      end if
#endif

      End Subroutine Cnst_A_PT2

      End Subroutine OLagNS_RI
!
!-----------------------------------------------------------------------
!
      Subroutine Cholesky_Vectors(MODE,ITK,ITQ,JSYM,Array,nArray,
     &                            IBSTA,IBEND)

      USE CHOVEC_IO, only: NVLOC_CHOBATCH, IDLOC_CHOGROUP, NPQ_CHOTYPE
      use caspt2_module, only: NSYM
      use definitions, only: wp, iwp

      implicit none

#include "intent.fh"

      integer(kind=iwp), intent(in) :: MODE, ITK, ITQ, JSYM, IBSTA,
     &  IBEND
      integer(kind=iwp), intent(out) :: nArray
      real(kind=wp), intent(_OUT_) :: Array(*)

      integer(kind=iwp) :: ICASE, LKETSM, LUCDER, ISYK, NQK, IB, NV,
     &  NKETSM, IDISK

      ! ugly hack to convert separate k/q orbital types into a specific
      ! case
      ICASE=ITK*ITQ
      IF (ICASE == 3) THEN
        ICASE=4
      ELSE
        ICASE=ICASE/2
      END IF

      LKETSM=1
      LUCDER = 63 ! tentative
      DO ISYK=1,NSYM
        NQK=NPQ_CHOTYPE(ICASE,ISYK,JSYM)
        IF(NQK == 0) CYCLE
        DO IB=IBSTA,IBEND
          NV=NVLOC_CHOBATCH(IB)
          NKETSM=NQK*NV
          IDISK=IDLOC_CHOGROUP(ICASE,ISYK,JSYM,IB)
          !! MODE = 1: write
          !! MODE = 2: read
          CALL DDAFILE(LUCDER,MODE,Array(LKETSM),NKETSM,IDISK)
          LKETSM=LKETSM+NKETSM
        END DO
      END DO
      nArray=LKETSM-1
*
      End Subroutine Cholesky_Vectors

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine WrDisk(rIn,nrIn,jDisp,iIrrep)
*
*      Sorry about this litle subroutine
*      The reason is just that right now I want to use AO for SCF
*      and MO for RASSCF, this will hopefully be changed, but if you
*      see this mess before that I apologize
*
      use Basis_Info, only: nBas
      use pso_stuff
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "buffer.fh"
#include "etwas.fh"
#include "WrkSpc.fh"
#include "disp.fh"
#include "disp2.fh"
#include "print.fh"
      Real*8 rIn(nrIn)
      Character*8 Label
      Integer ip(0:7),ip2(0:7),nA(0:7),ipCM(0:7)
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      If (Show) Then
         Write (6,*)
         Write (6,*) '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
         Write (6,*)
         Write (6,*) 'jDisp=',jDisp
      End If
      nin=0
      nIn2=0
      nna=0
      ipCC=1
      Do jIrrep=0,nIrrep-1
         kIrrep=NrOpr(iEOr(iOper(jIrrep),iOper(iIrrep)))
         If (kIrrep.lt.jIrrep) Then
            ip(jIrrep)=nIn
            nIn=nIN+nBas(kIrrep)*nBas(jIrrep)
          Else If (kIrrep.eq.jIrrep) Then
            ip(jIrrep)=nIn
            nIn=nIN+nBas(kIrrep)*(1+nBas(jIrrep))/2
          End If
          ip2(kIrrep)=nIn2
          nIn2=nIn2+nBas(kIrrep)*nBas(jIrrep)
          nA(jIrrep)=nnA
          nnA=nnA+nAsh(jIrrep)
          ipCM(jIrrep)=ipCC
          ipCC=ipCC+nBas(jIrrep)**2
#ifdef __INTEL_COMPILER
*
*       To avoid error in intel optimization -O3
*
          If (.False.) Write (6,*) ip(jIrrep)
#endif
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('ACTIVE','ALLO','REAL',ipAct,nIn2)
      Call GetMem('INACTIVE','ALLO','REAL',ipIN,nIn2)
      Call GetMem('OUT','ALLO','REAL',ipOUT1,nIn2)
      Call GetMem('TEMP1','ALLO','REAL',ipY,nIn2)
      Call GetMem('TEMP2','ALLO','REAL',ipX,nIn2)
*
      call dcopy_(nIn2,[0.0d0],0,Work(ipAct),1)
      call dcopy_(nIn2,[0.0d0],0,Work(ipIN),1)
      call dcopy_(nIn2,[0.0d0],0,Work(ipOut1),1)
*                                                                      *
************************************************************************
*                                                                      *
*     Fock1
*
      If (Show) Then
         Write (6,*)
         Write (6,*) 'Fock1'
         Write (6,*)
      End If
      Do jIrrep=0,nIrrep-1
         kIrrep=NrOpr(iEOr(iOper(jIrrep),iOper(iIrrep)))
         If (nBAs(jIrrep).gt.0.and.nbas(kIrrep).gt.0) Then
            If (kIrrep.lt.jIrrep) Then
               Call DGEMM_('N','N',
     &                     nBas(jIrrep),nBas(kIrrep),nBas(kIrrep),
     &                1.0d0,rIn(ipDisp(jDisp)+ip(jIrrep)),nBas(jIrrep),
     &                     CMO(ipCM(kIrrep),1),nBas(kIrrep),
     &                     0.0d0,Work(ipY),nBas(jIrrep))
               Call DGEMM_('T','N',
     &                     nBas(jIrrep),nBas(kirrep),nBas(jIrrep),
     &                     1.0d0,CMO(ipCM(jIrrep),1),nBas(jIrrep),
     &                     Work(ipY),nBas(jIrrep),
     &                     0.0d0,Work(ipAct+ip2(kIrrep)),nBas(jIrrep))
            If (Show) Then
               Write (6,*)
               Write (6,*) 'ipDisp(jDisp),ip(jIrrep)=',
     &                      ipDisp(jDisp),ip(jIrrep)
               Call RecPrt('ipDisp',' ',
     &             rIn(ipDisp(jDisp)+ip(jIrrep)),
     &             nBas(jIrrep),nBas(kIrrep))
               Write (6,'(A,G20.10)') 'ipDisp:',
     &               DDot_(nBas(jIrrep)*nBas(kIrrep),
     &                    rIn(ipDisp(jDisp)+ip(jIrrep)),1,
     &                    rIn(ipDisp(jDisp)+ip(jIrrep)),1)
               Write (6,'(A,G20.10)') 'ipCM(kIrrep):',
     &               DDot_(nBas(kIrrep)*nBas(kIrrep),
     &                    CMO(ipCM(kIrrep),1),1,
     &                    CMO(ipCM(kIrrep),1),1)
               Write (6,'(A,G20.10)') 'ipCM(jIrrep):',
     &               DDot_(nBas(jIrrep)*nBas(jIrrep),
     &                    CMO(ipCM(jIrrep),1),1,
     &                    CMO(ipCM(jIrrep),1),1)
            End If
               Call DGetMO(Work(ipAct+ip2(kIrrep)),Nbas(jIrrep),
     &                  nbas(jIrrep),nBas(kIrrep),
     &                  Work(ipAct+ip2(jIrrep)),nBas(kIrrep))
            Else If (kIrrep.eq.jIrrep) Then
               Call Square(rIn(ipDisp(jDisp)+ip(jIrrep)),Work(ipX),
     &                  1,nBas(kirrep),nBas(kirrep))
               Call DGEMM_('N','N',
     &                     nBas(jIrrep),nBas(kIrrep),nBas(kIrrep),
     &                     1.0d0,work(ipX),nBas(jIrrep),
     &                     CMO(ipCM(kIrrep),1),nBas(kIrrep),
     &                     0.0d0,Work(ipY),nBas(jIrrep))
               Call DGEMM_('T','N',
     &                     nBas(jIrrep),nBas(kirrep),nBas(jIrrep),
     &                     1.0d0,CMO(ipCM(jIrrep),1),nBas(jIrrep),
     &                     Work(ipY),nBas(jIrrep),
     &                     0.0d0,Work(ipAct+ip2(jIrrep)),nBas(jIrrep))
            End If
            If (Show) Then
               Write (6,*) 'jIrrep,kIrrep=',jIrrep,kIrrep
               Write (6,'(A,G20.10)') 'ipAct:',
     &               DDot_(nIn2,Work(ipAct),1,Work(ipAct),1)
            End If
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*
      If (nMethod.eq.RASSCF) Then
*
*        Fock2
*
         If (Show) Then
            Write (6,*)
            Write (6,*) 'Fock2'
            Write (6,*)
         End If
         Do jIrrep=0,nIrrep-1
            kIrrep=NrOpr(iEOr(iOper(jIrrep),iOper(iIrrep)))
            If (nBas(jIrrep).gt.0.and.nBas(kIrrep).gt.0) Then
               If (kIrrep.eq.jIrrep) Then
                  Call Square(rIn(ipDisp2(jDisp)+ip(jIrrep)),Work(ipX),
     &                        1,nBas(kirrep),nBas(kirrep))
                  Call DGEMM_('N','N',
     &                        nBas(jIrrep),nBas(kIrrep),nBas(kIrrep),
     &                        1.0d0,Work(ipX),nBas(jIrrep),
     &                        CMO(ipCM(kIrrep),1),nBas(kIrrep),
     &                        0.0d0,Work(ipY),nBas(jIrrep))
                  Call DGEMM_('T','N',
     &                     nBas(jIrrep),nBas(kirrep),nBas(jIrrep),
     &                     1.0d0,CMO(ipCM(jIrrep),1),nBas(jIrrep),
     &                     Work(ipY),nBas(jIrrep),
     &                     0.0d0,Work(ipIn+ip2(jIrrep)),nBas(jIrrep))
                Else If (kirrep.lt.jirrep) Then
                   Call DGEMM_('N','N',
     &                nBas(jIrrep),nBas(kIrrep),nBas(kIrrep),
     &                1.0d0,rin(ipDisp2(jDisp)+ip(jIrrep)),nBas(jIrrep),
     &                CMO(ipCM(kIrrep),1),nBas(kIrrep),
     &                0.0d0,Work(ipY),nBas(jIrrep))
                   Call DGEMM_('T','N',
     &                    nBas(jIrrep),nBas(kirrep),nBas(jIrrep),
     &                    1.0d0,CMO(ipCM(jIrrep),1),nBas(jIrrep),
     &                    Work(ipY),nBas(jIrrep),
     &                    0.0d0,Work(ipIn+ip2(kIrrep)),nBas(jIrrep))
                   Call DGetMO(Work(ipIn+ip2(kIrrep)),Nbas(jIrrep),
     &                         nBas(jIrrep),nBas(kIrrep),
     &                         Work(ipIn+ip2(jIrrep)),nBas(kIrrep))
                End If
                If (Show) Then
                   Write (6,*) 'jIrrep,kIrrep=',jIrrep,kIrrep
                   Write (6,'(A,G20.10)') 'ipIn:',
     &                   DDot_(nIn2,Work(ipIn),1,Work(ipIn),1)
                End If
             End If
          End Do
*                                                                      *
************************************************************************
*                                                                      *
*        Fock Tot
*
         If (Show) Then
            Write (6,*)
            Write (6,*) 'Fock Tot'
            Write (6,*)
         End If
         iii=0
         Do jIrrep=0,nIrrep-1
            kIrrep=NrOpr(iEOr(iOper(jIrrep),iOper(iIrrep)))
*
            If (nBas(jIrrep)*nIsh(kIrrep).gt.0) Then
               Call DaXpY_(nIsh(kIrrep)*nBas(jIrrep),2.0d0,
     &                    Work(ipAct+ip2(kIrrep)),1,
     &                    Work(ipOut1+ip2(kIrrep)),1)
               Call DaXpY_(nIsh(kIrrep)*nBas(jIrrep),2.0d0,
     &                    Work(ipIn+ip2(kIrrep)),1,
     &                    Work(ipOut1+ip2(kIrrep)),1)
            End If
*
            If (nBas(jIrrep).gt.0) Then
               Do jAsh=1,nAsh(kIrrep)
                  Do kAsh=1,nAsh(kIrrep)
                     rDe=  G1(iTri(nA(kIrrep)+jAsh,nA(kIrrep)+kAsh),1)
                     ipOut=ipOut1+ip2(kIrrep)+nIsh(kIrrep)*nBas(jIrrep)+
     &                     nBas(jIrrep)*(kAsh-1)
                     ipIn1=ipIn+ip2(kIrrep)
     &                    +nBas(jIrrep)*(jAsh-1+nIsh(kIrrep))
                     Call DaXpY_(nBas(jIrrep),rde,Work(ipIn1),1,
     &                                           Work(ipOut),1)
                  End Do
               End Do
            End If
*
            If (nBas(jIrrep)*nAsh(kIrrep).gt.0) Then
               ipOut=ipOut1+ip2(kIrrep)+nIsh(kIrrep)*nBas(jIrrep)
               If (Show) Then
                  Write (6,*) 'jIrrep,kIrrep=',jIrrep,kIrrep
                  Write (6,'(A,G20.10)') 'ipDisp3:',
     &                  DDot_(nBas(jIrrep)*nAsh(kIrrep),
     &                            rin(ipDisp3(jDisp)+iii),1,
     &                            rin(ipDisp3(jDisp)+iii),1)
               End If
               Call DGEMM_('T','N',
     &                     nBas(jIrrep),nAsh(kIrrep),nBas(jIrrep),
     &                     1.0d0,CMO(ipCM(jIrrep),1),nBas(jIrrep),
     &                     rin(ipDisp3(jDisp)+iii),nBas(jIrrep),
     &                     0.0d0,Work(ipY),nBas(jIrrep))
               Call DaXpY_(nAsh(kIrrep)*nBas(jIrrep),1.0d0,
     &                    Work(ipY),1,
     &                    Work(ipOut),1)
               iii=iii+nBas(jIrrep)*nAsh(kIrrep)
            End If
#ifdef __INTEL_COMPILER
            If (.False.) Write (6,*) kIrrep, iii
#endif
            If (Show) Then
               Write (6,*) 'jIrrep,kIrrep=',jIrrep,kIrrep
               Write (6,'(A,G20.10)') 'ipOut1:',
     &               DDot_(nIn2,Work(ipOut1),1,Work(ipOut1),1)
            End If
         End Do
         If (Show) Write (6,*)
*                                                                      *
************************************************************************
*                                                                      *
         irc=-1
         iopt=0
         Label='TOTAL'
         Call dWrMck(irc,iopt,Label,jdisp,Work(ipOut1),2**iIrrep)
         If (iRc.ne.0) Then
            Write (6,*) 'WrDisk: Error writing to MCKINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend()
         End If
         If (Show) Then
            Write (6,'(A,G20.10)') 'TOTAL:',
     &            DDot_(nIn2,Work(ipOut1),1,Work(ipOut1),1)
         End If
*
         irc=-1
         iopt=0
         Label='INACTIVE'
         Call dWrMck(irc,iopt,Label,jdisp,work(ipIn),2**iIrrep)
         If (iRc.ne.0) Then
            Write (6,*) 'WrDisk: Error writing to MCKINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend()
         End If
         If (Show) Then
            Write (6,'(A,G20.10)') 'INACTIVE:',
     &            DDot_(nIn2,Work(ipIn),1,Work(ipIn),1)
            Write (6,*)
         End If
*
         irc=-1
         iopt=0
         Label='MOPERT'
         nt=nna*(nna+1)/2
         nt=nt*(nt+1)/2
         Call dWrMck(irc,iopt,Label,jdisp,rIn(ipMO(jdisp,1)),2**iIrrep)
         If (iRc.ne.0) Then
            Write (6,*) 'WrDisk: Error writing to MCKINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend()
         End If
*                                                                      *
************************************************************************
*                                                                      *
*         SCF case
*
      Else
*                                                                      *
************************************************************************
*                                                                      *
         irc=-1
         iopt=0
         Label='TOTAL'
         Call dWrMck(irc,iopt,Label,jdisp,Work(ipAct),2**iIrrep)
         If (iRc.ne.0) Then
            Write (6,*) 'WrDisk: Error writing to MCKINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend()
         End If
         If (Show) Then
            Write (6,'(A,G20.10)') 'TOTAL:',
     &            DDot_(nIn2,Work(ipAct),1,Work(ipAct),1)
         End If
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('TEMP2','FREE','REAL',ipX,nIn2)
      Call GetMem('TEMP1','FREE','REAL',ipY,nIn2)
      Call GetMem('OUT','FREE','REAL',ipOUT1,nIn2)
      Call GetMem('INACTIVE','FREE','REAL',ipIN,nIn2)
      Call GetMem('ACTIVE','FREE','REAL',ipAct,nIn2)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine rotmom(MOM,N,R,MOMR)
! inverse rotation

use Constants, only: cZero, cOne
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
complex(kind=wp), intent(in) :: MOM(3,N,N) ! initial momentum matrix
real(kind=wp), intent(in) :: R(3,3) ! rotation matrix
complex(kind=wp), intent(out) :: MOMR(3,N,N) ! rotated momentum matrix
integer(kind=iwp) :: i, j, k
complex(kind=wp) :: RC(3,3)

! rotate the matrix

MOMR(:,:,:) = cZero

RC(:,:) = R(:,:)*cOne

do i=1,N
  do j=1,N
    do k=1,3
      MOMR(:,i,j) = MOMR(:,i,j)+RC(:,k)*MOM(k,i,j)
    end do
  end do
end do

return

end subroutine rotmom

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine GetDens_Localisation(Dens,CMO,nBas,nOcc)
C
C     Author: T.B. Pedersen
C
C     Purpose: compute density from CMOs as Dens = CMO * (CMO)^T
C
      Implicit None
      Real*8  Dens(*), CMO(*)
      Integer nBas, nOcc

      Integer nTBs

      nTBs = max(nBas,1)
      Call DGEMM_('N','T',nBas,nBas,nOcc,1.0d0,CMO,nTBs,CMO,nTBs,
     &           0.0d0,Dens,nTBs)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TODSCN(VEC,NREC,LREC,LBLK,LU)
*
* Write VEC as multiple record file accordin to NREC and LREC
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION VEC(*)
      INTEGER LREC(NREC)
*
      IOFF = 1
      DO IREC = 1, NREC
C?      WRITE(6,*) ' TODSCN: IREC, LREC ',IREC,LREC(IREC)
C?      WRITE(6,*) ' Input record '
C?      CALL WRTMAT(VEC(IOFF),1,LREC(IREC),1,LREC(IREC))
        IF(LREC(IREC).GE.0) THEN
          CALL ITODS(LREC(IREC),1,LBLK,LU)
          CALL TODSC(VEC(IOFF),LREC(IREC),LBLK,LU)
          IOFF = IOFF + LREC(IREC)
        ELSE
          CALL ITODS(-LREC(IREC),1,LBLK,LU)
          CALL ZERORC(IDUMMY,LU,0)
        END IF
      END DO
*
      RETURN
      END

*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine TMOMInt(wavevector,iOpt)
************************************************************************
*                                                                      *
* Object: driver for computation of TMOM integrals                     *
*                                                                      *
************************************************************************
      Use MpmC
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      use Sizes_of_Seward, only: S
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
#endif
      Implicit Real*8 (A-H,O-Z)
      External EMFInt, EMFMem
*     ipList: list of pointers to the integrals of each component
*             of the operator
*     OperI: list which irreps a particular component of the operator
*            belongs to
*     OperC: list the character of each component of the operator
*     CoorO: list of origins of the operator, one for each component
      Integer, Dimension(:), Allocatable :: ipList, OperI, OperC
      Real*8, Dimension(:), Allocatable :: CoorO, Nuc
      Real*8 wavevector(3)
#ifdef _DEBUGPRINT_
#include "stdalloc.fh"
      Real*8, Allocatable :: Int_R(:), Int_I(:), Temp_Int(:)
      Real*8, Allocatable :: Int_R_O(:), Int_I_O(:)
      Integer IOFF(8,8)
#endif
#include "print.fh"
#include "nq_info.fh"
#include "real.fh"
#include "wldata.fh"
#include "property_label.fh"
#include "oneswi.fh"
#include "warnings.fh"
      Character*8 Label
      Dimension dum(1),idum(1)
*
      MulTab(i,j)=iEor(i-1,j-1)+1
*
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
*
************************************************************************
************************************************************************
*                                                                      *
*     Electromagnetic field radiation integrals.                       *
*                                                                      *
*     Note that the integral is neither symmetric nor antisymmetric!   *
*                                                                      *
************************************************************************
************************************************************************
      rHrmt=-One ! Not used
*
*     B*s Magnetic * Spin: not that this boils down to just integrals
*     over A.
*
      If (iOpt.eq.2) Then
         rHrmt=One
         nOrdOp = 0
         Label='TMOM0'
         nComp = 2
         Call Allocate_Aux()
*        Here we put in the k-vector
         Call FZero(CoorO,3*nComp)
         Call dcopy_(3,wavevector,1,CoorO,1)
*
*        The electromagnetic field operator contributes to all
*        irreducible irreps, hence OperI=255. Since the operator
*        itself is not symmetry-adapted OperC is set to a dummy value.
*
         OperI(:) = 255
         OperC(:) = 0 ! Dummy
*
         Call dcopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(EMFInt,EMFMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Aux()
#ifdef _DEBUGPRINT_
*
      Call mma_allocate(CoorO,6,Label='CoorO')
      CoorO(:)=0.0D0
      CoorO(1:3)=wavevector
      Write (6,*) 'Wavevector=',Wavevector
*
*     This section of the code is for pure debugging and will replace
*     exact operator with truncated expansions of the operator in
*     terms of multipole integrals
*
      iOpt0=0 ! Write
      iOpt1=1 ! Read just data size and symmetry
      iOpt2=2 ! Read
      iRc=-1
      Label='TMOM0  R'
      iComp=1
*     Pick up the size and the symmetry label.
      Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl_TMOM)
      nInts_TMOM=idum(1)
!     Write (*,*) 'nInts_TMOM=',nInts_TMOM
      Call mma_allocate(Int_R,nInts_TMOM+4,Label='Int_R')
      Call mma_allocate(Int_I,nInts_TMOM+4,Label='Int_I')
      Call mma_allocate(Int_R_O,nInts_TMOM+4,Label='Int_R_O')
      Call mma_allocate(Int_I_O,nInts_TMOM+4,Label='Int_I_O')
*
      Call RdOne(iRc,iOpt0,Label,iComp,Int_R_O,iSyLbl_TMOM)
      Label='TMOM0  I'
      iComp=1
      Call RdOne(iRc,iOpt0,Label,iComp,Int_I_O,iSyLbl_TMOM)
      Len=0
      IOFF(:,:)=-1
      Do i=1,nIrrep
         Do j=1,i
            ij=MulTab(i,j)-1
            If(iAnd(2**ij,iSyLbl_TMOM).ne.0) Then
               IOFF(i,j)=Len+1
               If(i.eq.j) Then
                  Len_=nBas(i-1)*(nBas(i-1)+1)/2
               Else
                  Len_=nBas(i-1)*nBas(j-1)
               End If
               Len = Len + Len_
            End If
         End Do
      End Do
!     Write (*,*) 'Len=',Len
!     Do I = 1, 8
!        Write (6,*) (IOFF(I,J),J=1,8)
!     End Do
*
      Int_R(:)=0.0D0
      Int_R(nInts_TMOM+1:nInts_TMOM+3)=CoorO
      Int_I(:)=0.0D0
      Int_I(nInts_TMOM+1:nInts_TMOM+3)=CoorO
*
      S%nMltpl=9
      iCase=1
      Phase=1.0D0
      Do iMltpl= 0, S%nMltpl
         Write (Label,'(A,I2)') 'Mltpl ',iMltpl
         nComp=(iMltpl+1)*(iMltpl+2)/2
         iComp=0
         Do ix = iMltpl, 0, -1
            x=CoorO(1)**ix
            Do iy = iMltpl-ix, 0, -1
               xy=x*CoorO(2)**iy
               iz = iMltpl-ix-iy
               xyz=xy*CoorO(3)**iz
*
               Fact=Phase*xyz/(Gamma(Dble(ix)+1.0D0)
     &                        *Gamma(Dble(iy)+1.0D0)
     &                        *Gamma(Dble(iz)+1.0D0))
*
*              Write (*,*) 'Fact=',Fact
*              Write (6,*) CoorO(1)**ix, ix
*              Write (6,*) CoorO(2)**iy, iy
*              Write (6,*) CoorO(3)**iz, iz
*
               iComp=iComp+1
               If (Fact.eq.0.0D0) cycle
               Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
!              Write (*,*) 'iRC=',iRC
               If (iRC.ne.0) Then
                  Write (6,*) 'TMOMINT: Error reading ',Label
                  Call Abend()
               End If
               nInts=idum(1)
!              Write (6,*) 'nInts=',nInts
               Call mma_allocate(Temp_Int,nInts+4,Label='Temp_Int')
               Call RdOne(iRc,iOpt0,Label,iComp,Temp_Int,iSyLbl)
!              Write (*,*) 'Temp_Int(1)',Temp_Int(1)
*
               Len=0
               Do i=1,nIrrep
                  Do j=1,i
                     ij=MulTab(i,j)-1
                     If(iAnd(2**ij,iSyLbl).ne.0) Then
                        jOff=Len+1
                        If(i.eq.j) Then
                           Len_=nBas(i-1)*(nBas(i-1)+1)/2
                        Else
                           Len_=nBas(i-1)*nBas(j-1)
                        End If
!                       Write (*,*) 'jOff,IOFF(i,j),Len_=',
!    &                               jOff,IOFF(i,j),Len_
                        If (iCase.eq.1) Then
*                          Contribution to the real part
                           Call DaXpY_(Len_,Fact,Temp_Int(jOff),1,
     &                                 Int_R(IOFF(i,j)),1)
                        Else
*                          Contribution to the imaginary part
                           Call DaXpY_(Len_,Fact,Temp_Int(jOff),1,
     &                                 Int_I(IOFF(i,j)),1)
*                          If (i.eq.1.and.j.eq.1.and.nIrrep.eq.1) Then
*                             Write (6,*) nBas(i-1),nBas(j-1)
*                             Write (*,*) 'Fact=',Fact
*                             Write (6,*) CoorO(1)**ix, ix
*                             Write (6,*) CoorO(2)**iy, iy
*                             Write (6,*) CoorO(3)**iz, iz
*                             Write (6,*) 'Temp_Int(385)=',
*    &                                     Temp_Int(jOff+384)
*                             Write (6,*) 'Int_I(385)=',
*    &                                     Int_I(IOFF(i,j)+384)
*                             Write (6,*) 'Int_I_O(385)=',
*    &                                     Int_I_O(IOFF(i,j)+384)
*                          End If
*                          If (i.eq.2.and.j.eq.1.and.nIrrep.eq.8) Then
*                             Write (6,*) nBas(i-1),nBas(j-1)
*                             Write (*,*) 'Fact=',Fact
*                             Write (6,*) CoorO(1)**ix, ix
*                             Write (6,*) CoorO(2)**iy, iy
*                             Write (6,*) CoorO(3)**iz, iz
*                             Write (6,*) 'Temp_Int(55)=',
*    &                                     Temp_Int(jOff+54)
*                             Write (6,*) 'Int_I(55)=',
*    &                                     Int_I(IOFF(i,j)+54)
*                             Write (6,*) 'Int_I_O(55)=',
*    &                                     Int_I_O(IOFF(i,j)+54)
*                          End If
                        End If
                        Len = Len + Len_
                     End If
                  End Do
               End Do
               Call mma_deallocate(Temp_Int)
            End Do
         End Do
*
         If (iCase.eq.1) Then
            iCase=2
         Else
            iCase=1
            Phase=-Phase
         End If
      End Do
*
*     Compare exact integrals with approximated.
*
#define _COMPARE_
#ifdef _COMPARE_
      Len=0
      Do i=1,nIrrep
         Do j=1,i
            ij=MulTab(i,j)-1
            If(iAnd(2**ij,iSyLbl_TMOM).ne.0) Then
               If(i.eq.j) Then
                  Len_=nBas(i-1)*(nBas(i-1)+1)/2
               Else
                  Len_=nBas(i-1)*nBas(j-1)
               End If
               Do iLen = 1, Len_
*                    Write (6,*) 'isym,jsym,iLen=',i,j,iLen
*                    Write (*,*) 'Int_R,Int_Q=',Int_R_O(Len+iLen),
*    &                                          Int_R(Len+iLen)
*                    Write (*,*) 'Int_I,Int_J=',Int_I_O(Len+iLen),
*    &                                          Int_I(Len+iLen)
                  temp= Abs(Int_R_O(Len+iLen)-Int_R(Len+iLen))/
     &                  Max(Abs(Int_R_O(Len+iLen)),
     &                      Abs(Int_R(Len+iLen)),1.0D-8)
                  If (temp.gt.1.0D-2) Then
                     Write (6,*) 'isym,jsym,iLen=',i,j,iLen
                     Write (6,*) 'Int_R,Int_Q=',Int_R_O(Len+iLen),
     &                                          Int_R(Len+iLen)
                  End If
                  temp= Abs(Int_I_O(Len+iLen)-Int_I(Len+iLen))/
     &                  Max(Abs(Int_I_O(Len+iLen)),
     &                      Abs(Int_I(Len+iLen)),1.0D-8)
                  If (temp.gt.1.0D-2) Then
                     Write (6,*) 'isym,jsym,iLen=',i,j,iLen
                     Write (6,*) 'Int_I,Int_J=',Int_I_O(Len+iLen),
     &                                          Int_I(Len+iLen)
                  End If
               End Do
!     Write (*,*) 'i,j=',i,j
!     Write (*,*) 'Int_R,Int_Q=',Int_R_O(Len+1),Int_R(Len+1)
!     Write (*,*) 'Int_I,Int_J=',Int_I_O(Len+1),Int_I(Len+1)
!     Write (*,*) 'Int_R,Int_Q=',
!    &                     DDOT_(Len_,1.0D0,0,Int_R_O(Len+1),1),
!    &                     DDOT_(Len_,1.0D0,0,Int_R(Len+1),1)
!     Write (*,*) 'Int_I,Int_J=',
!    &                     DDOT_(Len_,1.0D0,0,Int_I_O(Len+1),1),
!    &                     DDOT_(Len_,1.0D0,0,Int_I(Len+1),1)
               Len = Len + Len_
            End If
         End Do
      End Do
#endif
*
*     Overwrite the integrals with a truncated expansion.
*
      Label='TMOM0  R'
      iComp=1
      Call WrOne(iRc,iOpt0,Label,iComp,Int_R,iSyLbl_TMOM)
      Label='TMOM0  I'
      iComp=1
      Call WrOne(iRc,iOpt0,Label,iComp,Int_I,iSyLbl_TMOM)
*
      Call mma_deallocate(Int_R_O)
      Call mma_deallocate(Int_I_O)
      Call mma_deallocate(Int_R)
      Call mma_deallocate(Int_I)
      Call mma_deallocate(CoorO)
*
#endif
      End If
*
*     A*nabla. Note that when used the numbers are multiplied with -i to
*     generate A*p.
*
      If (iOpt.le.2) Then
      nOrdOp = 1
      Label='TMOM'
      nComp = 12
      Call Allocate_Aux()
*     Here we put in the k-vector
      Call FZero(CoorO,3*nComp)
      Call dcopy_(3,wavevector,1,CoorO,1)
*
*     The electromagnetic field operator contributes to all
*     irreducible irreps, hence OperI=255. Since the operator
*     itself is not symmetry-adapted OperC is set to a dummy value.
*
      OperI(:) = 255
      OperC(:) = 0 ! Dummy
*
      Call dcopy_(nComp,[Zero],0,Nuc,1)
      Call OneEl(EMFInt,EMFMem,Label,ipList,OperI,nComp,
     &           CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &           dum,1,dum,idum,0,0,
     &           dum,1,0)
*
      Call Deallocate_Aux()
      End If
*
*     The A^2 term
*
      If (iOpt.gt.2) Then
      nOrdOp = 0
      Label='TMOM2'
      nComp = 2
      Call Allocate_Aux()
*     Here we put in the k-vector
      Call FZero(CoorO,3*nComp)
      Call dcopy_(3,wavevector,1,CoorO,1)
*     Change the argument to 2xA
      Call dscal_(3,2.0D0,CoorO,1)
*
*     The electromagnetic field operator contributes to all
*     irreducible irreps, hence OperI=255. Since the operator
*     itself is not symmetry-adapted OperC is set to a dummy value.
*
      OperI(:) = 255
      OperC(:) = 0 ! Dummy
*
      Call dcopy_(nComp,[Zero],0,Nuc,1)
      Call OneEl(EMFInt,EMFMem,Label,ipList,OperI,nComp,
     &           CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &           dum,1,dum,idum,0,0,
     &           dum,1,0)
*
      Call Deallocate_Aux()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_iSD()
*                                                                      *
************************************************************************
*                                                                      *
      Return
*
      Contains
      Subroutine Allocate_Aux()
      Implicit None
#include "stdalloc.fh"
*
      Call mma_Allocate(ipList,nComp,Label='ipList')
      Call mma_Allocate(OperI,nComp,Label='OperI')
      Call mma_Allocate(OperC,nComp,Label='OperC')
      Call mma_Allocate(CoorO,3*nComp,Label='CoorO')
      Call mma_Allocate(Nuc,nComp,Label='Nuc')
*
      Return
      End Subroutine Allocate_Aux
      Subroutine Deallocate_Aux()
      Implicit None
#include "stdalloc.fh"
*
      Call mma_Deallocate(OperC)
      Call mma_Deallocate(OperI)
      Call mma_Deallocate(ipList)
      Call mma_Deallocate(CoorO)
      Call mma_Deallocate(Nuc)
*
      Return
      End Subroutine Deallocate_Aux
*
      End Subroutine TMOMInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine inittemp(num)
! this routine initializes status matrix
! num - number of files to be used (I)

use ccsort_global, only: lrectemp, nrectemp, stattemp
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: num

stattemp(1:num) = 0
nrectemp(1:num) = 0
lrectemp(1:num) = 0

return

end subroutine inittemp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_CASPT2_OpenF(iOpt,iTyp,iSym,nBatch)
C
C
C     Purpose: open (iOpt=1), close and keep (iOpt=2), or close and
C              delete (iOpt=3) Cholesky vector files for CASPT2 program
C              (full vectors).
C              For iOpt=0, the units are initialized (to -1).
C              iTyp=1: transformed Cholesky vectors (Inactive).
C              iTyp=2: transformed Cholesky vectors (Active).
C              iTyp=3: vectors from (pi|qj) decomposition (Not
C                      implemented yet!)
C
#include "implicit.fh"
#include "WrkSpc.fh"
      Character*16 SecNam
      Parameter (SecNam = 'Cho_CASPT2_OpenF')
      Character*3 BaseNm
      Character*7 FullNm
#include "chocaspt2.fh"
      DIMENSION NUMCHO(8)

      Save NCALLS
      Integer NCALLS
      Data NCALLS /0/

*******************************************************************
      lUnit_F(j,k,l) = iWork(ipUnit_F(j)+(l-1)*nIsplit(j)+k-1)
*******************************************************************

      If (nBatch .gt. 999) Then
         Call Cho_x_Quit(SecNam,' nBatch limited to 999 !!!',' ')
      End If
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('NumCho',NumCho,nSym)

      If (NCALLS.EQ.0) THEN
        Do iB=1,nBatch
          iWork(ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1) = -1
        End Do
      End If

C     Initialize units and return for iOpt=0.
C     ---------------------------------------

      If (iOpt .eq. 0) Then
         Do iB=1,nBatch
            iWork(ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1) = -1
         End Do
         Return
      End If

C     Open or close files.
C     --------------------
      If (iTyp.lt.1 .or. iTyp.gt.2) Then
         Call Cho_x_Quit(SecNam,'iTyp error',' ')
      End If

      If (iOpt .eq. 1) Then
         If (NumCho(iSym).gt.0) Then
            Do iB=1,nBatch
               If(lUnit_F(iSym,iB,iTyp) .lt. 1) Then
                 Call Cho_caspt2_GetBaseNm(BaseNm,iTyp)
                 Write(FullNm,'(A3,I1,I3)') BaseNm,iSym,iB
                 LuV=7 ! initial guess
                 Call daName_MF_WA(LuV,FullNm)!handle inquire/free unit
                 iWork(ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1) = LuV
      write(6,*)' Opened file ''',FullNm,''' as unit nr LuV=',LuV
      iaddr=ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1
      write(6,*)' Unit number LuV is stored at address ',iaddr
               End If
            End Do
         Else
            Do iB=1,nBatch
               iWork(ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1) = -1
            End Do
         End If
      Else If (iOpt .eq. 2) Then
         Do iB=1,nBatch
            If (lUnit_F(iSym,iB,iTyp) .gt. 0) Then
      write(6,*)' Closing lUnit_F(iSym,iB,iTyp)=',lUnit_F(iSym,iB,iTyp)
               Call daClos(lUnit_F(iSym,iB,iTyp))
               iWork(ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1) = -1
            End If
         End Do
      Else If (iOpt .eq. 3) Then
         Do iB=1,nBatch
            If (lUnit_F(iSym,iB,iTyp) .gt. 0) Then
      write(6,*)' Erasing lUnit_F(iSym,iB,iTyp)=',lUnit_F(iSym,iB,iTyp)
               Call daEras(lUnit_F(iSym,iB,iTyp))
               iWork(ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1) = -1
            End If
         End Do
      Else
         Call Cho_x_Quit(SecNam,'iOpt out of bounds',' ')
      End If

      End


      SubRoutine Cho_caspt2_GetBaseNm(BaseNm,iTyp)
      Implicit None
      Character*3 BaseNm
      Integer     iTyp

      If (iTyp .eq. 1) Then
         BaseNm = '_PI'
      Else If (iTyp .eq. 2) Then
         BaseNm = '_PW'
      Else If (iTyp .eq. 3) Then
         BaseNm = '_CD'
      Else
         BaseNm = '_un'
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
*               2012, Thomas Bondo Pedersen                            *
************************************************************************
      SUBROUTINE TRNSPS(N,M,A,B)
      IMPLICIT REAL*8 (A-H,O-Z)
C Return B = Transpose of A.
      DIMENSION A(N,M),B(M,N)
      DO 10 I=1,N
        DO 11 J=1,M
          B(J,I)=A(I,J)
  11    CONTINUE
  10  CONTINUE
      RETURN
      END
      Subroutine iTrnsps(n,m,a,b)
C Thomas Bondo Pedersen, August 2012: integer version of trnsps
      Implicit None
      Integer n
      Integer m
      Integer a(n,m)
      Integer b(m,n)
      Integer i, j
      Do i=1,n
         Do j=1,m
            b(j,i)=a(i,j)
         End Do
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine vb2mol_cvb(vecvb,vecmol,isyml)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension vecvb(ndet),vecmol(*)

      iwr=0
      call icomb_cvb(norb,nalf,nsa)
      call icomb_cvb(norb,nbet,nsb)
      i1 = mstacki_cvb(nsa)
      i2 = mstacki_cvb(nsb)
      i3 = mstacki_cvb(mxirrep)
      i4 = mstacki_cvb(mxirrep)
      call mol2vb2_cvb(vecvb,vecmol,isyml,0d0,iwr,
     >  iwork(i1),iwork(i2),iwork(i3),iwork(i4),nsa,nsb)
      ibasemx=max(ibasemx,mstackr_cvb(0))
      call mfreei_cvb(i1)
      return
      end
      subroutine mol2vb_cvb(vecvb,vecmol,isyml)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension vecvb(ndet),vecmol(*)

      iwr=1
      call icomb_cvb(norb,nalf,nsa)
      call icomb_cvb(norb,nbet,nsb)
      i1 = mstacki_cvb(nsa)
      i2 = mstacki_cvb(nsb)
      i3 = mstacki_cvb(mxirrep)
      i4 = mstacki_cvb(mxirrep)
      call mol2vb2_cvb(vecvb,vecmol,isyml,0d0,iwr,
     >  iwork(i1),iwork(i2),iwork(i3),iwork(i4),nsa,nsb)
      ibasemx=max(ibasemx,mstackr_cvb(0))
      call mfreei_cvb(i1)
      return
      end

      subroutine mol2vbma_cvb(vecvb,vecmol,isyml,fac)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension vecvb(ndet),vecmol(*)
      iwr=2
      call icomb_cvb(norb,nalf,nsa)
      call icomb_cvb(norb,nbet,nsb)
      i1 = mstacki_cvb(nsa)
      i2 = mstacki_cvb(nsb)
      i3 = mstacki_cvb(mxirrep)
      i4 = mstacki_cvb(mxirrep)
      call mol2vb2_cvb(vecvb,vecmol,isyml,fac,iwr,
     >  iwork(i1),iwork(i2),iwork(i3),iwork(i4),nsa,nsb)
      ibasemx=max(ibasemx,mstackr_cvb(0))
      call mfreei_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_qlm_builder

use fmm_global_paras, only: INTK, REALK, LUPRI, LUINTM, fmm_counters, scheme_paras, raw_mm_data, id_node, raw_mm_paras, &
                            ELECTRONIC_ONLY, NUCLEAR_ONLY, Zero, One
use fmm_stats, only: stat_n_basis, stat_raw_moms_LHS, stat_raw_moms_RHS
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_get_raw_qlm, &
          fmm_deallocate_qlm

! Public variables
public :: fmm_system_size, fmm_coord_shift

! Coordinate translation required to ensure all primitive (x,y,z) positive
real(REALK), save :: fmm_coord_shift(3)

! Number of multipole moments written to interface file
type(fmm_counters), save :: n_mms
! Number of AO (contracted) basis functions
integer(INTK), save :: nbas
! (minimum) dimension of a cube which encloses all moments
real(REALK), save :: fmm_system_size

contains

!-------------------------------------------------------------------------------

subroutine fmm_get_raw_qlm(scheme,dens,LHS,RHS)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  real(REALK), intent(in)        :: dens(:,:)
  type(raw_mm_data), intent(out) :: LHS, RHS
  type(raw_mm_data) :: mm_data
  integer(INTK) :: LMAX

  LMAX = scheme%raw_LMAX

  ! Get all multipole data from program interface
  call fmm_get_n_mms_from_file(LMAX)
  call fmm_allocate_mms_arrays(LMAX,n_mms%tot,mm_data)
  call fmm_read_in_raw_data(dens,mm_data)
  call fmm_get_system_size_and_shift(mm_data%paras)
  if (scheme%branch_free) call fmm_make_branch_free_extents(scheme,mm_data)

  ! Assign LHS range multipole data
  call fmm_distribute_LHS_RHS_data(LMAX,scheme%LHS_mm_range,mm_data,LHS)
  stat_raw_moms_LHS = size(LHS%paras)
  ! Assign RHS range multipole data
  call fmm_distribute_LHS_RHS_data(LMAX,scheme%RHS_mm_range,mm_data,RHS)
  stat_raw_moms_RHS = size(RHS%paras)

  call fmm_deallocate_mms_arrays(mm_data)

end subroutine fmm_get_raw_qlm

!-------------------------------------------------------------------------------
! Branch-free scheme basically uses CFMM code but we simplify all the
! extents such that they are all the same and only _very_ close interactions
! are avoided (for numerical stability)

subroutine fmm_make_branch_free_extents(scheme,mm_data)

  implicit none
  type(scheme_paras), intent(in)   :: scheme
  type(raw_mm_data), intent(inout) :: mm_data

  integer(INTK) :: i

  do i=1,n_mms%elec
    mm_data%paras(i)%ext = scheme%extent_min
  end do

end subroutine fmm_make_branch_free_extents

!-------------------------------------------------------------------------------

subroutine fmm_distribute_LHS_RHS_data(LMAX,mm_range,all_data,sub_data)

  implicit none
  integer(INTK), intent(in)      :: LMAX, mm_range
  type(raw_mm_data), intent(in)  :: all_data
  type(raw_mm_data), intent(out) :: sub_data
  integer(INTK) :: foo, i, hi, lo

  lo = 1
  hi = n_mms%tot
  if (mm_range == NUCLEAR_ONLY) lo = 1+n_mms%elec
  if (mm_range == ELECTRONIC_ONLY) hi = n_mms%elec
  foo = hi-lo+1

  call fmm_allocate_mms_arrays(LMAX,foo,sub_data)

  sub_data%qlm(:,:) = all_data%qlm(:,lo:hi)
  sub_data%dens(:) = all_data%dens(lo:hi)
  sub_data%paras(:) = all_data%paras(lo:hi)
  sub_data%J_indices(:) = all_data%J_indices(lo:hi)
  nullify(sub_data%qlm_T)
  nullify(sub_data%qlm_W)

  ! Initialise parameter:moments mapping,
  ! and batch numbers for unique centres
  do i=1,foo
    sub_data%paras(i)%id = i
    sub_data%paras(i)%batch = i
  end do

end subroutine fmm_distribute_LHS_RHS_data

!-------------------------------------------------------------------------------

subroutine fmm_deallocate_qlm(LHS,RHS)

  implicit none
  type(raw_mm_data), intent(out) :: LHS, RHS

  call fmm_deallocate_mms_arrays(LHS)
  call fmm_deallocate_mms_arrays(RHS)

end subroutine fmm_deallocate_qlm

!-------------------------------------------------------------------------------

subroutine fmm_get_n_mms_from_file(LMAX_in)

  implicit none
  integer(INTK), intent(in) :: LMAX_in
  integer(INTK) :: LMAX !, ndim
  integer(INTK), external :: IsFreeUnit

  ! Read number of electronic moments
  LUINTM = IsFreeUnit(LUINTM)
  open(unit=LUINTM,file='multipoles.fmm1header',status='OLD',action='READ',form='UNFORMATTED')
  rewind(LUINTM)
  read(LUINTM) LMAX,nbas,n_mms%elec
  close(unit=LUINTM,status='KEEP')

  if (LMAX /= LMAX_in) then
    write(LUPRI,*) LMAX,LMAX_in
    call fmm_quit('LMAX inconsistency in MM interface!')
  end if
  if (n_mms%elec < 1) call fmm_quit('No moments generated!')
  ! This test only works for moments build over contracted AO pairs
  !ndim = nbas*(nbas+1)/2
  !if (n_mms%elec > ndim) then
  !  write(LUPRI,*) LMAX,nbas,ndim,n_mms%elec
  !  call fmm_quit('Too many moments generated, based on AO number!')
  !end if

  ! Read number of nuclear moments or potential grid points
  LUINTM = IsFreeUnit(LUINTM)
  open(unit=LUINTM,file='multipoles.fmm2header',status='OLD',action='READ',form='UNFORMATTED')
  rewind(LUINTM)
  read(LUINTM) n_mms%nuc
  close(unit=LUINTM,status='KEEP')

  n_mms%tot = n_mms%elec+n_mms%nuc
  stat_n_basis = nbas

end subroutine fmm_get_n_mms_from_file

!-------------------------------------------------------------------------------

subroutine fmm_allocate_mms_arrays(LMAX,ndim,mm_data)

  implicit none
  integer(INTK), intent(in)      :: LMAX, ndim
  type(raw_mm_data), intent(out) :: mm_data
  integer(INTK) :: i, foo, alloc_error

  nullify(mm_data%paras,mm_data%dens,mm_data%batch_map)
  nullify(mm_data%qlm,mm_data%qlm_W,mm_data%qlm_T)

  allocate(mm_data%paras(ndim))
  allocate(mm_data%J_indices(ndim))

  ! Initialise parameters
  do i=1,ndim
    mm_data%paras(i)%cntr = zero
    mm_data%paras(i)%ext = zero
    mm_data%paras(i)%id = 0
    mm_data%paras(i)%batch = 0
    mm_data%paras(i)%map_up = 0
    mm_data%paras(i)%box = 0
    mm_data%paras(i)%bra = 0
    mm_data%paras(i)%box_cntr = zero
    mm_data%J_indices(i)%i_indx = 0
    mm_data%J_indices(i)%j_indx = 0
  end do

  allocate(mm_data%dens(ndim))
  foo = (LMAX+1)**2
  write(LUPRI,*) 'mms_arrays: Attempting to allocate',max(1,foo*ndim*8/1000000),'MB of memory...'
  allocate(mm_data%qlm(foo,ndim),stat=alloc_error)
  if (alloc_error /= 0) write(LUPRI,*) '... Failed!'

  mm_data%qlm(:,:) = zero  ! only non-zero written explicitly

end subroutine fmm_allocate_mms_arrays

!------------------------------------------------------------------------------

subroutine fmm_deallocate_mms_arrays(mm_data)

  implicit none
  type(raw_mm_data), intent(out) :: mm_data
  integer(INTK) :: i

  if (associated(mm_data%paras)) deallocate(mm_data%paras)
  if (associated(mm_data%J_indices)) deallocate(mm_data%J_indices)
  if (associated(mm_data%dens)) deallocate(mm_data%dens)
  if (associated(mm_data%qlm)) deallocate(mm_data%qlm)
  if (associated(mm_data%qlm_T)) deallocate(mm_data%qlm_T)
  if (associated(mm_data%qlm_W)) deallocate(mm_data%qlm_W)

  if (associated(mm_data%batch_map)) then
    do i=1,size(mm_data%batch_map)
      call free_batch_map(mm_data%batch_map(i)%head)
    end do
  end if
  if (associated(mm_data%batch_map)) deallocate(mm_data%batch_map)

  nullify(mm_data%paras,mm_data%dens,mm_data%batch_map)
  nullify(mm_data%qlm,mm_data%qlm_W,mm_data%qlm_T)
  nullify(mm_data%J_indices)

contains

recursive subroutine free_batch_map(node)

  implicit none
  type(id_node), pointer :: node
  if (associated(node%next)) then
    call free_batch_map(node%next)
  end if
  deallocate(node)
  nullify(node)

end subroutine free_batch_map

end subroutine fmm_deallocate_mms_arrays

!-------------------------------------------------------------------------------
! Read in multipole moment data from interface file.
! In all this MM code we assume the order of moments is:
!   (0),(-1,0,1),(-2,-1,0,1,2)... wrt (L,M)

subroutine fmm_read_in_raw_data(dens,mm_data)

# include "macros.fh"

  implicit none
  real(REALK), intent(in)        :: dens(:,:)
  type(raw_mm_data), intent(out) :: mm_data
  real(REALK) :: PX, PY, PZ, SPH
  integer(INTK) :: I, J, L, M, A, B, LM, X
  integer(INTK), external :: IsFreeUnit

  ! Read electronic multipole moments into core
  LUINTM = IsFreeUnit(LUINTM)
  open(unit=LUINTM,file='multipoles.fmm1',status='OLD',action='READ',form='UNFORMATTED')
  rewind(LUINTM)

  readloop: do

    read(LUINTM) I,L,M,A,B,PX,PY,PZ,SPH
    ! EOF marked by record with negative angular momentum
    if (L < 0) exit readloop

    !if ((L == 0) .and. (ABS(SPH) > 1.0e-12_REALK)) write(LUPRI,'(5I4,1X,3F8.4,2E13.4)') I,L,M,A,B,PX,PY,PZ,SPH,dens(A,B)

    if (A > nbas) call fmm_quit('interface file error 0')
    if (B > nbas) call fmm_quit('interface file error 00')
    if (I < 1) call fmm_quit('interface file error 1')
    if (I > size(mm_data%qlm,2)) call fmm_quit('interface error 11')
    if (((L+1)**2) > size(mm_data%qlm,1)) call fmm_quit('interface 156')

    ! Indices to map moments to orbitals in J-matrix
    mm_data%J_indices(I)%i_indx = A
    mm_data%J_indices(I)%j_indx = B
    ! Multipole expansion centre
    mm_data%paras(I)%cntr = [PX,PY,PZ]
    ! See defn of 'extent' in p.424 MEST Helgaker et al
    mm_data%paras(I)%ext = 0
    LM = L*(L+1)+M+1
    mm_data%dens(I) = dens(A,B)
    ! Components (l,m) of MM without density factorised in
    mm_data%qlm(LM,I) = SPH

  end do readloop

  close(unit=LUINTM,status='KEEP')

  ! Next read nuclei data: charge and location
  ! This is also used for passing the grid points when
  ! computing an arbitrary potential
  if (n_mms%nuc == 0) return
  LUINTM = IsFreeUnit(LUINTM)
  open(unit=LUINTM,file='multipoles.fmm2',status='OLD',action='READ',form='UNFORMATTED')
  rewind(LUINTM)

  do J=1,n_mms%nuc
    I = n_mms%elec+J
    read(LUINTM) X,L,M,A,B,PX,PY,PZ,SPH
    !write(LUPRI,'(I4,1X,3F8.4,2E13.4)') I,PX,PY,PZ,SPH
    mm_data%qlm(1,I) = SPH
    mm_data%paras(I)%cntr = [PX,PY,PZ]
  end do

  unused_var(X)

  mm_data%dens((n_mms%elec+1):) = one
  mm_data%paras((n_mms%elec+1):)%ext = zero         ! point charges
  mm_data%J_indices((n_mms%elec+1):)%i_indx = 0     ! not relevant
  mm_data%J_indices((n_mms%elec+1):)%j_indx = 0     ! not relevant

  close(unit=LUINTM,status='KEEP')

end subroutine fmm_read_in_raw_data

!-------------------------------------------------------------------------------

subroutine fmm_get_system_size_and_shift(paras)

  implicit none
  type(raw_mm_paras), intent(inout) :: paras(:)
  real(REALK) :: sys_min(3), sys_max(3)
  integer(INTK) :: i

  sys_min = paras(1)%cntr
  sys_max = paras(1)%cntr
  do i=1,size(paras)
    sys_min(:) = min(sys_min(:),paras(i)%cntr(:))
    sys_max(:) = max(sys_max(:),paras(i)%cntr(:))
  end do
  fmm_system_size = maxval(sys_max-sys_min)
  if (fmm_system_size == zero) call fmm_quit('zero system size!')

  fmm_coord_shift = sys_min
  !do i=1,size(paras)
  !  paras(i)%cntr(:) = paras(i)%cntr(:)-sys_min(:)
  !end do

end subroutine fmm_get_system_size_and_shift

!-------------------------------------------------------------------------------

end module fmm_qlm_builder

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine nize_cvb(c,nnrm,s,n,metr,ierr)
! Normalizes NNRM vectors in C.

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nnrm, n, metr
real(kind=wp), intent(inout) :: c(n,nnrm)
real(kind=wp), intent(in) :: s(*)
integer(kind=iwp), intent(inout) :: ierr
integer(kind=iwp) :: i
real(kind=wp) :: cnrm
logical(kind=iwp) :: safe
real(kind=wp), allocatable :: c2(:)
real(kind=wp), parameter :: thresh = 1.0e-8_wp
real(kind=wp), external :: ddot_, dnrm2_

if (metr /= 0) call mma_allocate(c2,n,label='c2')
safe = ierr /= 0
do i=1,nnrm
  if (metr == 0) then
    cnrm = dnrm2_(n,c(:,i),1)
  else
    call saoon_cvb(c(:,i),c2,1,s,n,metr)
    cnrm = sqrt(ddot_(n,c(:,i),1,c2,1))
  end if
  if (safe .and. (cnrm < thresh)) then
    ierr = ierr+1
  else
    c(:,i) = c(:,i)/cnrm
  end if
end do
if (metr /= 0) call mma_deallocate(c2)

return

end subroutine nize_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine v_size_t3(vblock,nprocs,krem,printkey)
      implicit none
      integer krem,N
      integer t3_size_a,t3_size
      integer isp,vblock,maxnu
      integer nuga,nugc,vblock_isp(2),nprocs,rest
      CHARACTER ich*1
cmp
        integer printkey, tmp
cmp
      INTEGER IOPT,NOAB,NNOAB,NUAB,NNUAB
      COMMON/UHF/NOAB(2),NNOAB(3),NUAB(2),NNUAB(3),ICH(3)
      COMMON/IOIND/IOPT(96)
C number of elementary subprocesses: nugc*nuga*(nuga+1)/2
C                                   + nuga*nugc*(nugc+1)/2
C                                   + nugc**3/6
C                                   + nuga**3/6
C  check this:
      maxnu=max(nuab(1),nuab(2))
      vblock_isp(1)=maxnu/nprocs

cmp
      tmp = 1
      if(maxnu.ge.100)tmp = int((2*nprocs)**(1.0d0/3.0d0))

      do while ((tmp*(tmp*(tmp+1))/2).lt.nprocs)
         tmp = tmp + 1
      enddo
      vblock_isp(1) = maxnu/tmp
cmp

cmp      if(vblock_isp(1).lt.40)then
cmp         if(maxnu.ge.160)vblock_isp(1)=40
cmp      endif

C adjusting to reasonably full last block
      vblock_isp(2)=vblock_isp(1)
      t3_size=krem+1
C
C brute force
C
      t3_size_a=0
      do isp=1,2
         vblock=vblock_isp(isp)+1
         N=noab(isp)+nuab(isp)
C this is a first entry - initialization (makes no harm if reapeated)
         do while (krem.lt.t3_size)
            vblock=vblock-1
!!      write(6,*)'whiblock',vblock,krem,t3_size
            t3_size=0
            nuga=nuab(isp)/vblock
            if((nuga*vblock).lt.nuab(isp))nuga=nuga+1
            nugc=nuab(3-isp)/vblock
            if((nugc*vblock).lt.nuab(3-isp))nugc=nugc+1
c  dummy allocations
            if(nuga.ne.1)then
C             call w_alloc(kab, noab(isp)*vblock*vblock*n ,'kaT3loopb')
               t3_size=t3_size+ noab(isp)*vblock*vblock*n +1
C             call w_alloc(kcb, noab(isp)*vblock*vblock*n ,'kbT3loopb')
               t3_size=t3_size+ noab(isp)*vblock*vblock*n +1

C             call w_alloc(kbc, vblock*vblock*n ,'kcT3loopb')
               t3_size=t3_size+ vblock*vblock*n +1
C             call w_alloc(kbc, vblock*vblock*n ,'kcT3loopb')
               t3_size=t3_size+ vblock*vblock*n +1

            else
C             call w_alloc(kab, noab(isp)*N*nnuab(isp) ,'kaT3loopb')
               t3_size=t3_size+ noab(isp)*N*nnuab(isp) +1

            endif
C          call w_alloc(kac, vblock*vblock*n ,'kcT3loopb')
            t3_size=t3_size+ vblock*vblock*n +1

C          call w_alloc(kca, noab(isp)*vblock*vblock*n ,'kbT3loopb')
            t3_size=t3_size+ noab(isp)*vblock*vblock*n +1

C           call w_alloc(kc,v block*vblock*n ,'kcT3loopb')
            t3_size=t3_size+v block*vblock*n +1

C           call w_alloc(la,n noab(isp)*vblock*n ,'laT3loopb')
            t3_size=t3_size+n noab(isp)*vblock*n +1

C          call w_alloc(lxa, nnoab(3)*vblock*n ,'lbaT3loopb')
            t3_size=t3_size+ nnoab(3)*vblock*n +1

            if(nuga.ne.1)then
C              call w_alloc(lb,n noab(isp)*vblock*n ,'lbT3loopb')
               t3_size=t3_size+n noab(isp)*vblock*n +1

C             call w_alloc(lxb, nnoab(3)*vblock*n ,'labT3loopb')
               t3_size=t3_size+ nnoab(3)*vblock*n +1
            endif
C          call w_alloc(lxc, nnoab(3)*vblock*n ,'lacT3loopb')
            t3_size=t3_size+ nnoab(3)*vblock*n +1

C          call w_alloc(t3a, vblock*vblock*vblock ,'t3aT3loopb')
            t3_size=t3_size+ vblock*vblock*vblock +1
C          call w_alloc(t3b, vblock*vblock*vblock ,'t3bT3loopb')
            t3_size=t3_size+ vblock*vblock*vblock +1

C          call w_alloc(vac, vblock*vblock*nnoab(3) ,'vbcT3loopb')
            t3_size=t3_size+ vblock*vblock*nnoab(3) +1
            if(nuga.ne.1) then
C             call w_alloc(vab, vblock*vblock*nnoab(isp) ,'vabT3loopb')
               t3_size=t3_size+ vblock*vblock*nnoab(isp) +1

C             call w_alloc(vbc, vblock*vblock*nnoab(3) ,'vacT3loopb')
               t3_size=t3_size+ vblock*vblock*nnoab(3) +1
            else
C             call w_alloc(vab, nnoab(isp)*nnuab(isp) ,'vabT3loopb')
               t3_size=t3_size+ nnoab(isp)*nnuab(isp) +1
            endif
C           call w_alloc(mi, noab(isp)*(vblock**3) ,'miT3loopb')
            t3_size=t3_size+ noab(isp)*(vblock**3) +1
C          call w_alloc(mij, N*vblock ,'mijT3loopb')
            t3_size=t3_size+ N*vblock +1
C
         enddo                  ! while
         vblock_isp(isp)=vblock
         if(isp.eq.1)t3_size_a=t3_size
      enddo
      vblock=min0(vblock_isp(1),vblock_isp(2))
      nuga=maxnu/vblock
      if(nuga*vblock.lt.maxnu)nuga=nuga+1
      if(mod(maxnu,vblock).ne.0)
     $     vblock=min0(vblock,maxnu/nuga+mod(maxnu,nuga))
C adjusting to reasonably full last block
      rest=mod(maxnu,vblock)
      do while (.not.((rest.eq.0).or.(rest.gt.(vblock-nuga))))
         vblock=vblock-1
         rest=mod(maxnu,vblock)
      enddo
      do isp=1,2
         t3_size=0
         nuga=nuab(isp)/vblock
         if((nuga*vblock).lt.nuab(isp))nuga=nuga+1
         nugc=nuab(3-isp)/vblock
         if((nugc*vblock).lt.nuab(3-isp))nugc=nugc+1
c  dummy allocations
         if(nuga.ne.1)then
C          call w_alloc(kab, noab(isp)*vblock*vblock*n ,'kaT3loopb')
            t3_size=t3_size+ noab(isp)*vblock*vblock*n +1
C          call w_alloc(kcb, noab(isp)*vblock*vblock*n ,'kbT3loopb')
            t3_size=t3_size+ noab(isp)*vblock*vblock*n +1

C          call w_alloc(kbc, vblock*vblock*n ,'kcT3loopb')
            t3_size=t3_size+ vblock*vblock*n +1
C          call w_alloc(kbc, vblock*vblock*n ,'kcT3loopb')
            t3_size=t3_size+ vblock*vblock*n +1

         else
C          call w_alloc(kab, noab(isp)*N*nnuab(isp) ,'kaT3loopb')
            t3_size=t3_size+ noab(isp)*N*nnuab(isp) +1

         endif
C       call w_alloc(kac, vblock*vblock*n ,'kcT3loopb')
         t3_size=t3_size+ vblock*vblock*n +1

C       call w_alloc(kca, noab(isp)*vblock*vblock*n ,'kbT3loopb')
         t3_size=t3_size+ noab(isp)*vblock*vblock*n +1

C        call w_alloc(kc,v block*vblock*n ,'kcT3loopb')
         t3_size=t3_size+v block*vblock*n +1

C        call w_alloc(la,n noab(isp)*vblock*n ,'laT3loopb')
         t3_size=t3_size+n noab(isp)*vblock*n +1

C       call w_alloc(lxa, nnoab(3)*vblock*n ,'lbaT3loopb')
         t3_size=t3_size+ nnoab(3)*vblock*n +1

         if(nuga.ne.1)then
C           call w_alloc(lb,n noab(isp)*vblock*n ,'lbT3loopb')
            t3_size=t3_size+n noab(isp)*vblock*n +1

C          call w_alloc(lxb, nnoab(3)*vblock*n ,'labT3loopb')
            t3_size=t3_size+ nnoab(3)*vblock*n +1
         endif
C       call w_alloc(lxc, nnoab(3)*vblock*n ,'lacT3loopb')
         t3_size=t3_size+ nnoab(3)*vblock*n +1

C      call w_alloc(t3a, vblock*vblock*vblock ,'t3aT3loopb')
        t3_size=t3_size+ vblock*vblock*vblock +1
C      call w_alloc(t3b, vblock*vblock*vblock ,'t3bT3loopb')
        t3_size=t3_size+ vblock*vblock*vblock +1

C      call w_alloc(vac, vblock*vblock*nnoab(3) ,'vbcT3loopb')
        t3_size=t3_size+ vblock*vblock*nnoab(3) +1
        if(nuga.ne.1) then
C         call w_alloc(vab, vblock*vblock*nnoab(isp) ,'vabT3loopb')
           t3_size=t3_size+ vblock*vblock*nnoab(isp) +1

C         call w_alloc(vbc, vblock*vblock*nnoab(3) ,'vacT3loopb')
           t3_size=t3_size+ vblock*vblock*nnoab(3) +1
        else
C         call w_alloc(vab, nnoab(isp)*nnuab(isp) ,'vabT3loopb')
           t3_size=t3_size+ nnoab(isp)*nnuab(isp) +1
        endif
C       call w_alloc(mi, noab(isp)*(vblock**3) ,'miT3loopb')
        t3_size=t3_size+ noab(isp)*(vblock**3) +1
C      call w_alloc(mij, N*vblock ,'mijT3loopb')
        t3_size=t3_size+ N*vblock +1
        if(isp.eq.1)t3_size_a=t3_size
      enddo
      write(6,*)
      write(6,'(2x,A,I5)')
     $     'Virtual orbitals will be treated in blocks of:',vblock
        if (printkey.ge.10) then
           write(6,'(2x,A,I11,A,I11,A)')'Memory requirement:',
     $           max(t3_size,t3_size_a),' Words;    remaining:',krem-
     $           max(t3_size,t3_size_a),' Words'
        end if
      call xflush(6)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine WfCtl_td(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,iRHSDisp,iRHSCIDISP,converged)
!***********************************************************************
!                                                                      *
!     called from: MCLR                                                *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: Mul
use ipPage, only: ipclose, ipget, ipin, ipin1, ipnout, ipout, opout, W
use MCLR_Data, only: CMO, FIMO, Int2, ipCI, ipDia, lDisp, LuTemp, n1Dens, n2Dens, nConf1, nDens, nDensC, XISPSM
use MCLR_procedures, only: CISigma_td
use input_mclr, only: Debug, Eps, ERASSCF, Fail, iBreak, iMethod, kPrint, lCalc, lSave, nCSF, nDisp, nIter, nSym, nTPert, Omega, &
                      PotNuc, PT2, rIn_Ene, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iKapDisp(nDisp), isigDisp(nDisp), iCIDisp(nDisp), iCIsigDisp(nDisp), iRHSDisp(nDisp), &
                                  iRHSCIDisp(nDisp)
logical(kind=iwp), intent(out) :: converged(8)
integer(kind=iwp) :: iDEnd, iDis, iDisp, iLen, ipCID, ipCIT, ipPre2, ipS1, ipS2, ipST, iSym, Iter, jDisp, jSpin, kkkSym, kkSym, &
                     Left, lLine, lPaper, Lu_50, nConf3, niPre2, nPre2, pstate_sym
real(kind=wp) :: Clock(4), D_0, D_1, D_2, Delta, Delta0, DeltaC, DeltaK, EC, R1, R2, rAlpha, rAlphaC, rAlphaK, rBeta, rDum(1), &
                 ReCo, Res, rEsci, rEsk, rGrad, Tim2, Tim3, Tim4
logical(kind=iwp) :: CI, cnvrgd, lPrint, Orb
character(len=8) :: Fmt2
integer(kind=iwp), allocatable :: iPre(:)
real(kind=wp), allocatable :: Dens(:), DigPrec(:), dKappa(:), Kappa(:), Pens(:), rmoaa(:), Sc1(:), Sc2(:), Sc3(:), Sc4(:), &
                              Sigma(:), Temp1(:), Temp2(:), Temp3(:), Temp4(:), TempTD(:)
integer(kind=iwp), parameter :: iTimeCC = 1, iTimeKK = 2, iTimeKC = 3, iTimeCK = 4
integer(kind=iwp), external :: niPre, nPre
real(kind=wp), external :: DDot_

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
!     Initialize blank and header lines                                *
!----------------------------------------------------------------------*
TIM2 = Zero
TIM3 = Zero
TIM4 = Zero

CLOCK(:) = Zero
lPaper = 132
lLine = 120
left = (lPaper-lLine)/2
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
!----------------------------------------------------------------------*
iDis = 0

fail = .false.
Converged(:) = .true.
lprint = .false.
LU_50 = 50
if (lSAVE) call DANAME(LU_50,'RESIDUALS')
if (btest(kprint,1)) lprint = .true.
iDisp = 0
kksym = 1
kkksym = nsym
if (PT2) kkkSym = 1

! Starting loop over all symmetries/PT

do iSym=kksym,kkksym
  PState_SYM = Mul(State_Sym,iSym)
  nconf1 = ncsf(PState_Sym)
  CI = .false.
  if ((iMethod == 2) .and. (nconf1 > 0)) CI = .true.

  if (CI .and. (nconf1 == 1) .and. (isym == 1)) CI = .false.
  ! Initiate CSF <-> SD
  if (CI) call InCSFSD(Mul(iSym,State_Sym),State_sym)

  ! Calculate length of the density, Fock and Kappa matrix etc
  ! notice that this matrixes not necessary are symmetric.
  ! Store pointers.
  !
  ! Input:
  !        iSym : Symmetry of perturbation
  !
  ! Output: Commonblocks (Pointers.fh)

  PState_SYM = Mul(State_Sym,iSym)
  !nConf2 = nint(xispsm(PState_SYM,1))
  !nConf2 = ndtasm(PState_SYM)
  nconf3 = nint(max(xispsm(PState_SYM,1),xispsm(State_SYM,1)))
  !nconf3 = max(ndtasm(PState_SYM),ndtasm(State_SYM))

  ! Setup is realted to symmetry treatment

  call Setup_MCLR(iSym)

  ! Determine if we should page CI vectors

  !                            [2]
  ! Calculate the diagonal of E    and store in core/disc

  if (CI) then

    ! CIDia_td calculates the <i|H|i> elements (diagonal)? From the CI-CI part of E?

    call CIDia_td(PState_Sym)
    call ipout(ipdia)

    ! Allocate disk/memory space

    ! This areas should be addressed through ipin
    ! ipout will page them out to disk and free the memory area
    ! if page mode is used

    ! opout will release the memory area without update the disk

    ! ipget is like getmem but handles weather the vector is on disk or not.

    ips1 = ipget(2*nconf3)
    ips2 = ipget(2*nconf3)
    ipst = ipget(2*nconf3)
    ipcit = ipget(2*nconf1)
    ipcid = ipget(2*nconf1)

  end if

  npre2 = npre(isym)
  nipre2 = nipre(isym)
  call mma_allocate(iPre,nipre2,Label='iPre')

  !OBS npre2 not def

  ipPre2 = ipget(npre2)

  call ipin(ipPre2)
  call Prec_dig(W(ipPre2)%A,iPre,isym)

  call mma_allocate(DigPrec,nDensC,Label='DigPrec')
  DigPrec(:) = Zero
  call Prec_td(W(ipPre2)%A,DigPrec,isym)

  call ipout(ippre2)

  ! OK START WORKING

  iDEND = lDisp(iSym)
  !if ((SewLab == 'NONE') .and. (.not. mckinley)) iDEND = 1

  ! Loop over all PT of sym isym

  do jDisp=1,iDEnd
    iDisp = iDisp+1
    jspin = 0
    if (btest(nTPert(idisp),0)) jSpin = 1
    if (jspin == 0) then
      nconf1 = ncsf(PState_Sym)
    else
      nConf1 = nint(xispsm(Pstate_Sym,1))
    end if
    if (.not. lCalc(iDisp)) then
      converged(isym) = .false.
      cycle
    end if

    ! Allocate areas for scratch and state variables

    call mma_allocate(Kappa,nDensC,Label='Kappa')
    call mma_allocate(dKappa,nDens,Label='dKappa')
    call mma_allocate(Sigma,nDensC,Label='Sigma')
    call mma_allocate(Temp1,nDens,Label='Temp1')
    call mma_allocate(Temp2,nDensC,Label='Temp2')
    call mma_allocate(Temp3,nDens,Label='Temp3')
    call mma_allocate(Temp4,nDens,Label='Temp4')
    call mma_allocate(Sc1,nDens,Label='Sc1')
    call mma_allocate(Sc2,nDens,Label='Sc2')
    call mma_allocate(Sc3,nDens,Label='Sc3')
    call mma_allocate(Sc4,nDensC,Label='Sc4')
    Temp1(:) = Zero
    Kappa(:) = Zero
    dKappa(:) = Zero
    Sc1(:) = Zero
    if (CI) then
      call mma_allocate(Dens,n1Dens,Label='Dens')
      call mma_allocate(Pens,n2Dens,Label='Pens')
      call mma_allocate(rmoaa,n2Dens,Label='Pens')
      Dens(:) = Zero
      Pens(:) = Zero
      rmoaa(:) = Zero
    end if

    !-------------------------------------------------------------------
    !
    ! Calculate RHS for the perturbation. The b^x vector!
    ! sigma is the orbital part and Temp4 is the cipart
    !
    !-------------------------------------------------------------------

    ! (T1,T2,T3,T4,T5,T6,T7,Kappa1,CI1)

    call RHS_td(Sc1,Temp1,Temp3,Sc2,dKappa,Sc3,Temp4,ipST,iDisp,iSym-1,CMO,jdisp,CI)

    Temp4(:) = -Temp4(:)

    ! Make RHS twice as long and change sign on second part!

    if (CI) then
      call ipin(ipST)
      W(ipST)%A(nConf1+1:2*nConf1) = -W(ipST)%A(1:nConf1)
    end if

    call opout(ipci)

    if (lprint) write(u6,*) '       Iteration         Delta     Res(kappa) Res(CI)'
    iLen = nDensC
    iRHSDisp(iDisp) = iDis
    call Compress(Temp4,Sigma,iSym)
    r1 = Half*ddot_(nDensC,Sigma,1,Sigma,1)

    call UnCompress(Sigma,Temp4,iSym)
    call dDaFile(LuTemp,1,Sigma,iLen,iDis)
    if (CI) then
      call ipin(ipCIT)
      W(ipCIT)%A(1:2*nConf1) = Zero
    end if
    call ipout(ipcit)
    if (CI) then
      ilen = 2*nconf1
      iRHSCIDisp(iDisp) = iDis
      call ipin(ipST)
      call dDaFile(LuTemp,1,W(ipST)%A,iLen,iDis)
      W(ipST)%A(1:2*nConf1) = -W(ipST)%A(1:2*nConf1)
    end if

    call DMInvKap_td(DigPrec,Sigma,Kappa)

    call opout(ippre2)
    ! kap:kap
    r2 = Half*ddot_(nDensC,Kappa,1,Kappa,1)
    if (r2 > r1) write(u6,*) 'Warning perturbation number ',idisp,' might diverge'

    call mma_deallocate(Temp1)
    call mma_allocate(Temp1,nDensC,Label='Temp1')

    ! dkap=Kap in matrix form
    call UnCompress(Kappa,dKappa,iSym)

    ! DMinvCI_td is related to cidia_td and inverts the precond CI-CI
    ! part of E
    ! Has to be modified: <i|H|i> --> <i|H|i>+w

    if (CI) then
      call ipin(ipST)
      call ipin(ipCid)
      call DMinvCI_td(W(ipST)%A,W(ipCid)%A,-omega,isym)
      call DMinvCI_td(W(ipST)%A(1+nConf1),W(ipCId)%A(1+nconf1),omega,isym)

      deltaC = Half*ddot_(2*nConf1,W(ipST)%A,1,W(ipCId)%A,1)
      call ipout(ipcid)
    else
      deltac = Zero
    end if
    deltaK = Half*ddot_(nDensC,Kappa,1,Sigma,1)
    Kappa(:) = Zero
    delta = deltac+deltaK

    delta0 = delta
    Orb = .true.
    ReCo = -One
    iter = 1
    !-------------------------------------------------------------------

    !**********************************************************
    !          I   T   E   R   A   T   I   O   N   S          *
    !**********************************************************

    cnvrgd = .true.
    do
      if (delta == Zero) exit

      !*****************************************************************
      !
      !       O R B I T A L    P A R T of the trial vector
      !
      !*****************************************************************

      if (orb) then

        !---------------------------------------------------------------
        !
        !           ~    ~
        ! Construct F,(ij|kl)
        !
        !---------------------------------------------------------------
        !
        ! j2 specifies which part of E I want to look at
        ! j2=0 --> K-K, j2=-1 --> CI-CI, These are antisym within themself
        ! j2>0 --> CI-K and K-CI, These parts are antisym between eachother

        call ipnout(-1)
        call RInt_ns(dKappa,rmoaa,Sc2,Temp4,isym,reco,jspin)

        call RInt_td(Sc2,dKappa,isym)

        Clock(iTimeKK) = Clock(iTimeKK)+Tim2

        !---------------------------------------------------------------
        !
        ! kappa->CI
        !
        ! H(kappa)|0>
        !
        !     [2]
        ! S1=E   k (kappa TO CI) <i|H|0>-<i|0>*Energy
        !
        !---------------------------------------------------------------

        ! This cisigma_td call gives <j|H(k)|0> and <j|H(k)t|0>

        if (CI) then
          ! Adjusted to timedep
          call CISigma_td(jspin,State_Sym,pstate_sym,Temp4,nDens,rmoaa,size(rmoaa),rdum,1,ipCI,ipS1,'T',.true.)
          Clock(iTimeKC) = Clock(iTimeKC)+Tim3

          ! This will give us a better
          ! convergence in the PCG. Notice that
          !
          ! ~Inactive     ~
          ! E        + <0|H|0> = 0
          !
          ! when the wavefunction is converged.

          ! These terms are to be able to handle less converged CASSCF wave func

          call ipin(ipS1)
          if (isym == 1) then
            call ipin(ipCI)
            rGrad = ddot_(nconf1,W(ipCI)%A,1,W(ipS1)%A,1)
            W(ipS1)%A(1:nConf1) = W(ipS1)%A(1:nConf1)-rGrad*W(ipCI)%A(1:nConf1)
            rGrad = ddot_(nconf1,W(ipCI)%A,1,W(ipS1)%A(1+nconf1),1)
            W(ipS1)%A(nConf1+1:2*nConf1) = W(ipS1)%A(nConf1+1:2*nConf1)-rGrad*W(ipCI)%A(1:nConf1)
          end if
          W(ipS1)%A(1:nConf1) = -Two*W(ipS1)%A(1:nConf1)
          W(ipS1)%A(nConf1+1:2*nConf1) = Two*W(ipS1)%A(nConf1+1:2*nConf1)

          call opout(ipCI)
          !*************************************************************

        end if  ! If ci

      end if
      !
      !*****************************************************************
      !
      !    C I    P A R T of the trial vector
      !
      !*****************************************************************
      !
      if (CI) then

        !***************************************************************
        !
        !       [2]
        ! S2 = E   CID  (CI TO CI) = <i|H|d> -E<i|d>
        !
        !***************************************************************

        call ipnout(-1)
        if (CI) call CISigma_td(0,PState_Sym,Pstate_sym,FIMO,size(FIMO),Int2,size(Int2),rdum,1,ipCId,ipS2,'S',.true.)

        ! I want the RASSCF energy of the ACTIVE electrons !!!!
        ! EC=-E[act]           E[RASSCF]=E[inact]+E[act]+E[nuc]

        EC = rin_ene+potnuc-ERASSCF(1)

        call ipin(ipCId)
        call ipin(ipS2)
        W(ipS2)%A(1:2*nConf1) = Two*(W(ipS2)%A(1:2*nConf1)+EC*W(ipCId)%A(1:2*nConf1))

        ! Add the wS contribution
        ! The (-) sign in both daxpys assumes that the two parts of ipcid are def with diff sign.
        ! This is not true for the debug option!! ipcid = 1 regardless of part which part
        ! The S-contribution will make E-wS loose its symmetry because E is sym and S
        ! is antisym.

        W(ipS2)%A(1:nConf1) = W(ipS2)%A(1:nConf1)-Two*omega*W(ipCId)%A(1:nConf1)
        W(ipS2)%A(nConf1+1:2*nConf1) = W(ipS2)%A(nConf1+1:2*nConf1)+Two*omega*W(ipCId)%A(nConf1+1:2*nConf1)
        Clock(iTimeCC) = Clock(iTimeCC)+Tim4

        call ipout(ips2)
        call opout(ipcid)
        call opout(ipci)

        !---------------------------------------------------------------
        !
        ! CI -> Kappa
        !
        !      [2]
        ! SC3=E   CID   (SC3=F(<d|E|0>+<0|E|d>)
        !
        !---------------------------------------------------------------

        call ipnout(-1)

        call CIDens_TD(ipCid,PState_Sym,Pens,Dens)     ! Jeppe's

        ! density for inactive= 2(<d|0>+<0|d>)

        d_0 = Zero

        ! This is just for debugging purpose.
        ! When we use it for actual calculations d_0 == 0

        ! This if statement is just for better convergence! Grad term
        ! Leave this for later!

        if (isym == 1) then
          call ipin(ipCid)
          call ipin(ipci)
          d_1 = ddot_(nconf1,W(ipCid)%A,1,W(ipci)%A,1)
          d_2 = ddot_(nconf1,W(ipCid)%A(1+nConf1),1,W(ipci)%A,1)
          d_0 = d_1+d_2
        end if

        ! Fockgen gives the Fock matrix, MO integrals and one index transformed
        ! MO integrals

        call Fockgen_td(d_0,Dens,Pens,Sc3,isym)

        !---------------------------------------------------------------

      end if

      !*****************************************************************
      !
      ! Sc1  kappa-> kappa
      ! Sc3  CI -> kappa
      ! S1   kappa -> CI
      ! S2   CI -> CI
      ! dKap present step
      ! Kap  kappaX
      ! CIT  CIX
      ! CId  present step
      !*****************************************************************
      !
      ! Add together
      !
      !*****************************************************************

      call ipnout(-1)
      if (CI) then   ! if (.false.) then
        Sc1(:) = Sc2(:)+Sc3(:)
      else
        Sc1(:) = Sc2(:)
      end if
      call Compress(Sc1,Temp1,isym)   ! ds
      call Compress(dKappa,Temp2,isym) ! DX

      ! S1 + S2 --> S1

      if (CI) then  !If (.false.) then
        call ipin1(ipS1,2*nconf1)
        call ipin1(ipS2,2*nconf1)
        W(ipS1)%A(1:2*nConf1) = W(ipS1)%A(1:2*nConf1)+W(ipS2)%A(1:2*nConf1)
        call opout(ips2)
      end if

      !-----------------------------------------------------------------
      !
      !            ######   #####   #####
      !            #     # #     # #     #
      !            #     # #       #
      !            ######  #       #  ####
      !            #       #       #     #
      !            #       #     # #     #
      !            #        #####   #####
      !
      !-----------------------------------------------------------------
      !*****************************************************************
      !
      !            delta
      ! rAlpha=------------
      !        dKappa:dSigma
      !
      !-----------------------------------------------------------------
      rAlphaC = Zero
      rAlphaK = Zero
      if (orb) rAlphaK = Half*ddot_(nDensC,Temp1,1,Temp2,1)
      if (CI) then
        call ipin(ipS1)
        call ipin(ipCId)
        rAlphaC = Half*ddot_(2*nConf1,W(ipS1)%A,1,W(ipCId)%A,1)
      end if
      rAlpha = delta/(rAlphaK+ralphaC)

      !----------------------------------------------------------------*

      ! Kappa=Kappa+rAlpha*dKappa
      ! Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa

      if (orb) then
        Kappa(:) = Kappa(:)+ralpha*Temp2(:)
        Sigma(:) = Sigma(:)-ralpha*Temp1(:)
        resk = sqrt(Half*ddot_(nDensC,Sigma,1,Sigma,1))
      end if
      resci = Zero

      if (CI) then
        call ipin(ipCId)
        call ipin(ipCIT)
        W(ipCIT)%A(1:2*nConf1) = W(ipCIT)%A(1:2*nConf1)+ralpha*W(ipCId)%A(1:2*nConf1)
        call ipout(ipcit)
        call ipin1(ipST,2*nconf1)
        call ipin(ipS1)
        W(ipST)%A(1:2*nConf1) = W(ipST)%A(1:2*nConf1)-ralpha*W(ipS1)%A(1:2*nConf1)
        call opout(ipS1)
        resci = sqrt(Half*ddot_(2*nconf1,W(ipST)%A,1,W(ipST)%A,1))
      end if

      !----------------------------------------------------------------*
      ! Precondition......
      !    -1
      ! S=M  Sigma

      call opout(ipcid)
      if (CI) then
        call ipin(ipST)
        call ipin(ipS2)
        call DMinvCI_td(W(ipST)%A,W(ipS2)%A,-omega,isym)
        call DMinvCI_td(W(ipST)%A(1+nConf1),W(ipS2)%A(1+nconf1),omega,isym)

      end if
      call opout(ipci)
      call opout(ipdia)

      call DMInvKap_td(DigPrec,Sigma,Sc4)

      call opout(ippre2)

      !----------------------------------------------------------------*
      !      s:Sigma
      ! Beta=-------
      !       delta
      !
      ! delta=s:sigma
      !
      ! dKappa=s+Beta*dKappa

      if (CI) then
        call ipin(ipST)
        call ipin(ipS2)
        deltaC = Half*ddot_(2*nConf1,W(ipST)%A,1,W(ipS2)%A,1)
        call ipout(ipST)
      else
        deltaC = Zero
      end if

      deltaK = Half*ddot_(nDensC,Sigma,1,Sc4,1)
      if (.not. CI) then
        rBeta = deltaK/delta
        delta = deltaK
        Temp2(:) = rBeta*Temp2(:)+Sc4(:)
      else
        rbeta = (deltac+deltaK)/delta
        delta = deltac+deltaK
        call ipin(ipCID)
        call ipin(ipS2)
        W(ipCID)%A(1:2*nConf1) = rBeta*W(ipCID)%A(1:2*nConf1)+W(ipS2)%A(1:2*nConf1)
        Temp2(:) = rBeta*Temp2(:)+Sc4(:)
        call opout(ipS2)
        call ipout(ipCID)
      end if

      !    ######  #    #  #####        #####    ####    ####
      !    #       ##   #  #    #       #    #  #    #  #    #
      !    #####   # #  #  #    #       #    #  #       #
      !    #       #  # #  #    #       #####   #       #  ###
      !    #       #   ##  #    #       #       #    #  #    #
      !    ######  #    #  #####        #        ####    ####
      !
      !----------------------------------------------------------------*

      call UnCompress(Temp2,dKappa,isym)

      ! iBreak is defined via include!

      res = Zero ! dummy initialize
      if (iBreak == 1) then
        ! This is the actual breaking!
        if (abs(delta) < abs(Eps**2*delta0)) exit
      else if (ibreak == 2) then
        res = sqrt(resk**2+resci**2)
        if (res < abs(Eps)) exit
      else
        if ((abs(delta) < abs(Eps**2*delta0)) .and. (res < abs(Eps))) exit
      end if

      ! This breaks the PCG iterations

      if (iter >= niter) then
        cnvrgd = .false.
        exit
      end if
      if (lprint) &
        write(u6,Fmt2//'A,i2,A,F12.7,F12.7,F12.7,F12.7,F12.7)') '     ',iter,'       ',delta/delta0,resk,resci,deltac,deltak

      iter = iter+1

    end do

    !*******************************************************************

    if (.not. cnvrgd) then
      write(u6,Fmt2//'A,I4,A)') 'No convergence for perturbation no: ',idisp,'. Increase Iter.'
      converged(isym) = .false.
      fail = .true.
    else
      write(u6,Fmt2//'A,I4,A,I4,A)') 'Perturbation no: ',idisp,' converged in ',iter-1,' steps.'
      call ipnout(-1)
      !stop 10
    end if
    call mma_allocate(TempTD,nDens,Label='TempTD')
    call Uncompress(Kappa,TempTD,isym)
    call mma_deallocate(TempTD)

    write(u6,*)
    iLen = nDensC
    iKapDisp(iDisp) = iDis
    call dDaFile(LuTemp,1,Kappa,iLen,iDis)
    iSigDisp(iDisp) = iDis
    call dDaFile(LuTemp,1,Sigma,iLen,iDis)
    if (CI) then
      ilen = 2*nconf1
      iCIDisp(iDisp) = iDis
      call ipin(ipCIT)
      call dDaFile(LuTemp,1,W(ipCIT)%A,iLen,iDis)
      iCISigDisp(iDisp) = iDis
      call ipin(ipST)
      call dDaFile(LuTemp,1,W(ipST)%A,iLen,iDis)
    end if

    call mma_deallocate(Temp4)
    call mma_deallocate(Temp3)
    call mma_deallocate(Temp2)
    call mma_deallocate(Temp1)
    call mma_deallocate(Sigma)
    call mma_deallocate(dKappa)
    call mma_deallocate(Kappa)
    call mma_deallocate(Sc4)
    call mma_deallocate(Sc3)
    call mma_deallocate(Sc2)
    call mma_deallocate(Sc1)
    if (CI) then
      call mma_deallocate(rmoaa)
      call mma_deallocate(Pens)
      call mma_deallocate(Dens)
    end if
  end do

  ! Free all memory and remove from disk all data
  ! related to this symmetry

  call mma_deallocate(iPre)

  if (CI) then
    call ipclose(ipdia)
  else
    call ipclose(ipPre2)
  end if

  call mma_deallocate(DigPrec)
  call Exp_Close()

end do
if (debug) then
  write(u6,*) '********************************************************************************'
  write(u6,*)
end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine WfCtl_td

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine EPEInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of nuclear attraction     *
*         integrals.                                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, February '91                            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      External TNAI, Fake, Cff2D, XRys2D
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables
      Real*8 TC(3), Coori(3,4), Coora(3,4), CoorAC(3,2)
      Integer iAnga(4), iDCRT(0:7), iStabO(0:7)
      Logical EQ, NoSpecial
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      iRout = 201
      iPrint = nPrint(iRout)
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = 0
      iAnga(4) = 0
      call dcopy_(3,A,1,Coora(1,1),1)
      call dcopy_(3,RB,1,Coora(1,2),1)
      call dcopy_(2*3,Coora(1,1),1,Coori(1,1),1)
      mabMin = nabSz(Max(la,lb)-1)+1
      mabMax = nabSz(la+lb)
      If (EQ(A,RB)) mabMin = nabSz(la+lb-1)+1
*
*     Compute FLOP's and size of the work array which Hrr will use.
*
      Call mHrr(la,lb,nFLOP,nMem)
*
*-----Find center to accumulate angular momentum on.
*
      If (la.ge.lb) Then
         call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
         call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
      llOper = lOper(1)
      Do 90 iComp = 2, nComp
         llOper = iOr(llOper,lOper(iComp))
 90   Continue
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
      Do 100 lDCRT = 0, nDCRT-1
         Call OA(iDCRT(lDCRT),CCoor,TC)
         call dcopy_(3,TC,1,CoorAC(1,2),1)
         call dcopy_(3,TC,1,Coori(1,3),1)
         call dcopy_(3,TC,1,Coori(1,4),1)
         call dcopy_(3,TC,1,Coora(1,3),1)
         call dcopy_(3,TC,1,Coora(1,4),1)
*
*--------Compute primitive integrals before the application of HRR.
*
         nT = nZeta
         NoSpecial=.True.
         Call Rys(iAnga,nt,Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,
     &            TC,1,rKappa,[One],Coori,Coora,CoorAC,
     &            mabmin,mabmax,0,0,Array,nArr*nZeta,
     &            TNAI,Fake,Cff2D,xRys2D,NoSpecial)
*
*--------Use the HRR to compute the required primitive integrals.
*
         Call HRR(la,lb,A,RB,Array,nZeta,nMem,ipIn)
*
*--------Accumulate contributions to the symmetry adaped operator
*
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array(ipIn),nZeta,la,lb,nComp,Final,nIC,
     &               nOp         ,lOper,iChO,One)
*
 100  Continue
*
*     Call GetMem(' Exit EPEInt','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_integer(nHer)
         Call Unused_integer(nOrdOp)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine DrvRF(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq,iCharge)
      use External_Centers, only: iXPolType
      Implicit Real*8 (A-H,O-Z)
      Real*8 h1(nh1), TwoHam(nh1), D(nh1)
#include "SysDef.fh"
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
#include "stdalloc.fh"
      Logical First, Dff, NonEq
      Character*8 Label
      Real*8 RepNuc_Temp
      Save RepNuc_Temp
      Dimension RepNucXX(1)
      Real*8, Allocatable:: RFld(:,:), h1_RF(:), h1_XX(:)
*                                                                      *
************************************************************************
*                                                                      *
      If (.Not.lRF) Return

*
*
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
*
      Call Init_RctFld(NonEq,iCharge)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(RFld,nh1,2,Label='RFld')
      RFld(:,2)=Zero
      If (First) RepNuc_Temp=RepNuc
*                                                                      *
************************************************************************
*                                                                      *
      If (lLangevin.or.iXPolType.gt.0) Then

*
*------- Reaction field a la polarizabilities and Langevin dipole
*        moments on a grid in a cavity in a dielectric medium.
*
         Call Langevin(h1,RFld(1,2),D,RepNuc,nh1,First,Dff)

      Else If (PCM) Then
*
*------- Reaction field a la PCM
*
*
         Call DrvPCM(h1,RFld(1,2),D,RepNuc,nh1,First,Dff,NonEq)

      Else If (lRFCav) Then
*
*------- Reaction field a la cavity in dielectric medium.
*
         Call RctFld(h1,RFld(1,2),D,RepNuc,nh1,First,Dff,NonEq)
*
*
      Else
         Call WarningMessage(2,
     &              'I do not know what reaction field type to use.')
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Get the original one-electron hamiltonian and add the reaction
*     field contribution to it.
*
      Label='h1    XX'
      Call Get_Temp(Label,RFld(1,1),nh1)
      Call DaXpY_(nh1,-One,h1,1,RFld(1,1),1)
      Call DScal_(nh1,-One,RFld(1,1),1)
*     Add contribution to the TwoHam array
      Call DaXpY_(nh1,One,RFld(1,2),1,TwoHam,1)
*
*-----Store away information for perturbative calculations
*
      Call DaXpY_(nh1,One,RFld(1,2),1,RFld(1,1),1)
*
      ERFSelf=RepNuc-RepNuc_Temp
      EEE=DDot_(nh1,RFld(1,2),1,D,1)
      ERFSelf=ERFSelf-Half*EEE

*
      Call Put_dScalar('RF Self Energy',ERFSelf)
      Call Put_dArray('Reaction field',RFld(1,1),nh1)
*
      Call mma_deallocate(RFld)
*                                                                      *
************************************************************************
*                                                                      *
*---- Write out the matrix elements of the reaction field potential
*     to be exploited in subsequent codes like, CC, MP2, and CASPT2.
*
      Label='PotNucXX'
      Call Get_Temp(Label,RepNucXX,1)
      RepNuc_RF=RepNuc-RepNucXX(1)
*
      Call mma_allocate(h1_RF,nh1+4,Label='h1_RF')
      Call mma_allocate(h1_XX,nh1  ,Label='h1_XX')
*
      Label='h1    XX'
      Call Get_Temp(Label,h1_XX,nh1)
      call dcopy_(nh1,h1,1,h1_RF,1)
      Call DaXpY_(nh1,-One,h1_XX,1,h1_RF,1)
      Call mma_deallocate(h1_XX)
*
      h1_RF(nh1+3)=RepNuc_RF
*
      iSyLbl=1
      iRc=-1
      iOpt=0
      iComp=1
      Label='OneHamRF'
      Call WrOne(iRc,iOpt,Label,iComp,h1_RF,iSyLbl)
*
      Call mma_deallocate(h1_RF)
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_iSD()
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PlaceIt(Coord,iQ_Atoms,iCNum)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"

      Dimension Coord(MxAt*3)
      Dimension AvstPart(MxPut),IndexSet(MxPut)
      Dimension CordstTemp(MxPut*MxCen,3)
      Character Head*200
      Logical Changed


      Do 11, i=1,nPart !For each solvent particle, compute the
        Sbig=1D+20   !smallest distance to any QM-atom from the
        Do 12, j=1,iQ_Atoms  !oxygen on water.
          S=0
          Do 13, k=1,3
            S=S+(Coord((j-1)*3+k)-Cordst(nCent*(i-1)+1,k))**2
13        Continue
          If(S.le.Sbig) then
            Sbig=S
            AvstPart(i)=S
          Endif
12      Continue
11    Continue

      Do 21, i=1,MxPut
        IndexSet(i)=i
21    Continue

31    Continue  !Order the indeces suchwise that smallest distance
        Changed=.false.  !goes first. The sorting routine is blunt
        Do 32, i=1,nPart-1 !but at this stage of the execution time
          If(AvstPart(i+1).lt.AvstPart(i)) then !is not a problem.
            Atemp=AvstPart(i)
            AvstPart(i)=AvstPart(i+1)
            AvstPart(i+1)=Atemp
            iTemp=IndexSet(i)
            IndexSet(i)=IndexSet(i+1)
            IndexSet(i+1)=iTemp
            Changed=.true.
          Endif
32      Continue
      If(Changed) GoTo 31

      Do 41, i=1,nPart  !Put coordinates of solvent suchwise that
        Do 42, j=1,nCent !smallest distances goes first.
          CordstTemp((i-1)*nCent+j,1)=Cordst((i-1)*nCent+j,1)
          CordstTemp((i-1)*nCent+j,2)=Cordst((i-1)*nCent+j,2)
          CordstTemp((i-1)*nCent+j,3)=Cordst((i-1)*nCent+j,3)
42      Continue
41    Continue
      Do 43, i=1,nPart
        ind=IndexSet(i)
        Do 44, j=1,nCent
          Cordst((i-1)*nCent+j,1)=CordstTemp((ind-1)*nCent+j,1)
          Cordst((i-1)*nCent+j,2)=CordstTemp((ind-1)*nCent+j,2)
          Cordst((i-1)*nCent+j,3)=CordstTemp((ind-1)*nCent+j,3)
44      Continue
43    Continue

      Do 51,iz=1,iQ_Atoms  !Substitute the first coordinate slots with
        Cordst(iz,1)=Coord((iz-1)*3+1) !QM-molecule, or since we have
        Cordst(iz,2)=Coord((iz-1)*3+2) !ordered above, this is
        Cordst(iz,3)=Coord((iz-1)*3+3) !equivalent with removing closest
51    Continue                         !solvents and there put QM-mol.
      Do 52, iextr=iQ_Atoms+1,iCnum*nCent  !Just dummy-coordinates
        Cordst(iextr,1)=Coord(1)        !added to empty slots.
        Cordst(iextr,2)=Coord(2)
        Cordst(iextr,3)=Coord(3)
52    Continue

      If(iPrint.ge.10) then  !Optional printing.
        Write(Head,*)'Coordinates of the system after substitution and'
     &//' reordening of solvent molecules.'
        Call Cooout(Head,Cordst,nPart,nCent)
      Endif

      Return
      End

*----------------------------------------------------------------------*
* With this function we wish to place the QM-molecule properly when we *
* run with solvetn configurations from the sampfile. This we do by     *
* making the center-of-masses to coincide.                             *
*----------------------------------------------------------------------*
      Subroutine PlaceIt9(Coord,Cordst,info_atom,iQ_Atoms)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"

      Dimension Coord(MxAt*3),Cordst(MxCen*MxPut,3)
      Dimension info_atom(MxAt)

      CMSewx=0
      CMSewy=0
      CMSewz=0
      CMSamx=0
      CMSamy=0
      CMSamz=0
      Wtot=0
      Do 1, i=1,iQ_Atoms
        CMSewx=CMSewx+Coord((i-1)*3+1)*info_atom(i)
        CMSewy=CMSewy+Coord((i-1)*3+2)*info_atom(i)
        CMSewz=CMSewz+Coord((i-1)*3+3)*info_atom(i)
        CMSamx=CMSamx+Cordst(i,1)*info_atom(i)
        CMSamy=CMSamy+Cordst(i,2)*info_atom(i)
        CMSamz=CMSamz+Cordst(i,3)*info_atom(i)
        Wtot=Wtot+dble(info_atom(i))
1     Continue
      CMSewx=CMSewx/Wtot
      CMSewy=CMSewy/Wtot
      CMSewz=CMSewz/Wtot
      CMSamx=CMSamx/Wtot
      CMSamy=CMSamy/Wtot
      CMSamz=CMSamz/Wtot
      Tx=CMSewx-CMSamx
      Ty=CMSewy-CMSamy
      Tz=CMSewz-CMSamz
      Do 2, i=1,iQ_Atoms
        Cordst(i,1)=Coord((i-1)*3+1)-Tx
        Cordst(i,2)=Coord((i-1)*3+2)-Ty
        Cordst(i,3)=Coord((i-1)*3+3)-Tz
2     Continue

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ptrans(npam,ipam,nxpam,PSOPam,nPSOPam,Cred,nC,Scr1,nS1,Scr2,nS2)
! -------------------------------------------------------------------
! The following subroutine calculates a batch of 2-electron
! density matrix elements in SO basis.
! Need to know:
!   nish(),nash(),nbas()
!   npam(indpos,isym)= Nr of SO indices at index position 1..4,
!       with symmetry label isym=0..7.
!   ipam()= A consecutive list of SO indices.
! Also:
!   mxpam=Similar, ipam array
!   mxSO=Largest batch of SO indices in one single symmetry
! Returns:
!   PSOPam()=a four-index array containing the selected matrix
!         elements.
! -------------------------------------------------------------------

use Index_Functions, only: iTri, nTri_Elem
use etwas, only: CoulFac, mBas, mIrrep, nAsh, nIsh, npSOp
use pso_stuff, only: CMO, D0, G1, G2
use Constants, only: Zero, One, Two, Quart
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: npam(4,0:*), nxpam, nPSOPam, nC, nS1, nS2
real(kind=wp), intent(in) :: ipam(nxpam)
real(kind=wp), intent(out) :: PSOPam(nPSOPam), Cred(nC), Scr1(nS1), Scr2(nS2)
integer(kind=iwp) :: i, iEnd, ijSym, Ind, iOCMOI, iOCMOJ, iOCMOK, iOCMOL, iOCMOT, iOCMOU, iOCMOV, iOCMOX, ioDQ, ioDR, iods, iOff1, &
                     iOff2, ioPam1, ioPam2, ioPam3, ioPam4, ip, ipq, ipr, ips, ipSO, iq, ir, irq, irs, is, iScr, isq, iSta, iSym, &
                     it, itEnd, itSta, itu, ituvx, itv, itx, iu, iuEnd, iuSta, iv, iVEnd, ivSta, ivu, ivx, ix, ixEnd, ixSta, ixu, &
                     j, jEnd, jklOf1, jklOff, jSta, jSym, k, kEnd, klOf1, klOff, klSym, kSta, kSym, l, lEnd, lOf1, lOff, lSta, &
                     lSym, nbi, nbj, nbk, nbl, nCopy, ni, nijkl, nj, njkl, nk, nkl, nKLT, nl, nLTU, nnPam1, nnPam2, nnPam3, &
                     nnPam4, nSkip1, nSkip2, nt, nTUV, nu, nv, nx, nxv, nxvu, nxvut
real(kind=wp) :: Fact, t14

#ifdef _DEBUGPRINT_
write(u6,*) ' iPam',iPam
write(u6,*) ' nPam',(nPam(1,i),i=0,mIrrep-1)
write(u6,*) ' nPam',(nPam(2,i),i=0,mIrrep-1)
write(u6,*) ' nPam',(nPam(3,i),i=0,mIrrep-1)
write(u6,*) ' nPam',(nPam(4,i),i=0,mIrrep-1)
#endif
t14 = Quart
! Offsets into the ipam array:
nnpam1 = sum(npam(1,0:mirrep-1))
nnpam2 = sum(npam(2,0:mirrep-1))
nnpam3 = sum(npam(3,0:mirrep-1))
nnpam4 = sum(npam(4,0:mirrep-1))
nPSOP = nnpam1*nnpam2*nnpam3*nnpam4
PSOPam(1:nPSOP) = Zero
iopam1 = 0
iopam2 = nnpam1
iopam3 = iopam2+nnpam2
iopam4 = iopam3+nnpam3
! Loop over all possible symmetry combinations.
lend = 0
ixend = 0
iocmol = 0
ioDs = 0
do lsym=0,mirrep-1
  nl = npam(4,lsym)
  lsta = lend+1
  lend = lend+nl
  nx = nash(lsym)
  ixsta = ixend+1
  ixend = ixend+nx
  iocmox = iocmol+nish(lsym)*mbas(lsym)
  kend = 0
  ivend = 0
  iocmok = 0
  ioDr = 0
  do ksym=0,mirrep-1
    klsym = ieor(ksym,lsym)
    nk = npam(3,ksym)
    ksta = kend+1
    kend = kend+nk
    nkl = nk*nl
    nv = nash(ksym)
    ivsta = ivend+1
    ivend = ivend+nv
    nxv = nx*nv
    iocmov = iocmok+nish(ksym)*mbas(ksym)
    jend = 0
    iuend = 0
    iocmoj = 0
    ioDq = 0
    do jsym=0,mirrep-1
      nj = npam(2,jsym)
      jsta = jend+1
      jend = jend+nj
      njkl = nj*nkl
      nu = nash(jsym)
      iusta = iuend+1
      iuend = iuend+nu
      nxvu = nxv*nu
      iocmou = iocmoj+nish(jsym)*mbas(jsym)
      iend = 0
      itend = 0
      iocmoi = 0
      do isym=0,mirrep-1
        ni = npam(1,isym)
        ista = iend+1
        iend = iend+ni
        nijkl = ni*njkl
        nt = nash(isym)
        itsta = itend+1
        itend = itend+nt
        nxvut = nxvu*nt
        iocmot = iocmoi+nish(isym)*mbas(isym)
        ! Break loop if not acceptable symmetry combination.
        ! Break loop if no such symmetry block:
        ijsym = ieor(isym,jsym)
        if ((klsym == ijsym) .and. (nijkl /= 0)) then
#         ifdef _DEBUGPRINT_
          write(u6,*) ' i,j,k,lsym=',iSym,jSym,kSym,lSym
#         endif
          ! Bypass transformation if no active orbitals:
          if (nxvut /= 0) then
            ! Pick up matrix elements and put in a full symmetry block:
            ind = 0
            do ix=ixsta,ixend
              do iv=ivsta,ivend
                ivx = iTri(iv,ix)
                do iu=iusta,iuend
                  do it=itsta,itend
                    itu = iTri(it,iu)
                    ituvx = iTri(itu,ivx)
                    ind = ind+1
                    scr1(ind) = G2(ituvx,1)
                    if (isym == jsym) then
                      fact = One
                      if ((itu >= ivx) .and. (iv == ix)) fact = Two
                      if ((itu < ivx) .and. (it == iu)) fact = Two
                      scr1(ind) = fact*scr1(ind)
                      !hjw multiplying the G1 product with coulfac gives wrong result
                      scr1(ind) = scr1(ind)-G1(itu,1)*G1(ivx,1)
                    end if
                    if (isym == lsym) then
                      itx = iTri(it,ix)
                      ivu = iTri(iv,iu)
                      !hjw t14 includes exfac, why not coulfac above? What are these terms?
                      scr1(ind) = scr1(ind)+t14*G1(itx,1)*G1(ivu,1)
                    end if
                    if (isym == ksym) then
                      itv = iTri(it,iv)
                      ixu = iTri(ix,iu)
                      scr1(ind) = scr1(ind)+t14*G1(itv,1)*G1(ixu,1)
                    end if
                  end do
                end do
              end do
            end do
#           ifdef _DEBUGPRINT_
            call RecPrt('G2-G1G1(MO)',' ',Scr1,nash(iSym)*nash(jSym),nash(kSym)*nash(lsym))
#           endif

            ! Transform:
            !  scr2(l,tuv)= sum cmo(sl,x)*scr1(tuv,x)
            ncopy = nash(lsym)
            nskip1 = mbas(lsym)
            ioff2 = 0
            nskip2 = npam(4,lsym)
            ntuv = nash(isym)*nash(jsym)*nash(ksym)
            do l=lsta,lend
              ioff1 = iocmox+int(ipam(iopam4+l))
              ioff2 = ioff2+1
              call dcopy_(ncopy,CMO(ioff1,1),nskip1,Cred(ioff2),nskip2)
            end do
            call DGEMM_('N','T',nskip2,ntuv,ncopy,One,Cred,nskip2,Scr1,ntuv,Zero,Scr2,nskip2)
            ! Transform:
            !  scr3(k,ltu)= sum cmo(rk,v)*scr2(ltu,v)
            ncopy = nash(ksym)
            nskip1 = mbas(ksym)
            ioff2 = 0
            nskip2 = npam(3,ksym)
            nltu = nash(isym)*nash(jsym)*npam(4,lsym)
            do k=ksta,kend
              ioff1 = iocmov+int(ipam(iopam3+k))
              ioff2 = ioff2+1
              call dcopy_(ncopy,CMO(ioff1,1),nskip1,Cred(ioff2),nskip2)
            end do
            call DGEMM_('N','T',nskip2,nltu,ncopy,One,Cred,nskip2,Scr2,nltu,Zero,Scr1,nskip2)
            ! Transform:
            !  scr4(j,klt)= sum cmo(qj,u)*scr3(klt,u)
            ncopy = nash(jsym)
            nskip1 = mbas(jsym)
            ioff2 = 0
            nskip2 = npam(2,jsym)
            nklt = nash(isym)*npam(3,ksym)*npam(4,lsym)
            do j=jsta,jend
              ioff1 = iocmou+int(ipam(iopam2+j))
              ioff2 = ioff2+1
              call dcopy_(ncopy,CMO(ioff1,1),nskip1,Cred(ioff2),nskip2)
            end do
            call DGEMM_('N','T',nskip2,nklt,ncopy,One,Cred,nskip2,Scr1,nklt,Zero,Scr2,nskip2)
            ! Transform:
            !  scr5(i,jkl)= sum cmo(pi,t)*scr4(jkl,t)
            ncopy = nash(isym)
            nskip1 = mbas(isym)
            ioff2 = 0
            nskip2 = npam(1,isym)
            njkl = npam(2,jsym)*npam(3,ksym)*npam(4,lsym)
            do i=ista,iend
              ioff1 = iocmot+int(ipam(iopam1+i))
              ioff2 = ioff2+1
              call dcopy_(ncopy,CMO(ioff1,1),nskip1,Cred(ioff2),nskip2)
            end do
            call DGEMM_('N','T',nskip2,njkl,ncopy,One,Cred,nskip2,Scr2,njkl,Zero,Scr1,nskip2)
#           ifdef _DEBUGPRINT_
            call RecPrt('G2-G1G1(SO)',' ',Scr1,nPam(1,iSym)*nPam(2,jSym),nPam(3,kSym)*nPam(4,lSym))
#           endif

            ! Put results into correct positions in PSOPam:
            do l=lsta,lend
              loff = nnpam3*(l-1)
              lof1 = nPam(3,ksym)*(l-lsta)
              do k=ksta,kend
                kloff = nnpam2*(k-1+loff)
                klof1 = nPam(2,jsym)*(k-ksta+lof1)
                do j=jsta,jend
                  jkloff = nnpam1*(j-1+kloff)
                  jklof1 = nPam(1,isym)*(j-jsta+klof1)
                  do i=ista,iend
                    ipso = i+jkloff
                    iscr = 1+i-ista+jklof1
                    PSOPam(ipso) = Scr1(iscr)
                  end do
                end do
              end do
            end do
          end if
          ! Add contributions from 1-el density matrix:
          do l=lsta,lend
            is = int(ipam(iopam4+l))
            loff = nnpam3*(l-1)
            do k=ksta,kend
              ir = int(ipam(iopam3+k))
              irs = iTri(ir,is)
              kloff = nnpam2*(k-1+loff)
              do j=jsta,jend
                iq = int(ipam(iopam2+j))
                jkloff = nnpam1*(j-1+kloff)
                do i=ista,iend
                  ip = int(ipam(iopam1+i))
                  ipq = iTri(ip,iq)
                  ipso = i+jkloff
                  if (isym == lsym) then
                    ips = iTri(ip,is)
                    irq = iTri(ir,iq)
                    PSOPam(ipso) = PSOPam(ipso)-t14*D0(ioDs+ips,1)*D0(ioDr+irq,1)
                  end if
                  if (isym == ksym) then
                    ipr = iTri(ip,ir)
                    isq = iTri(is,iq)
                    PSOPam(ipso) = PSOPam(ipso)-t14*D0(ioDr+ipr,1)*D0(ioDs+isq,1)
                  end if
                  if (isym == jsym) then
                    PSOPam(ipso) = PSOPam(ipso)+D0(ioDq+ipq,1)*D0(ioDs+irs,1)*coulfac
                  end if
                end do
              end do
            end do
          end do
        end if
        ! End of loop over symmetry labels.
        nbi = mbas(isym)
        iocmoi = iocmoi+nbi**2
      end do
      nbj = mbas(jsym)
      iocmoj = iocmoj+nbj**2
      ioDq = ioDq+nTri_Elem(nbj)
    end do
    nbk = mbas(ksym)
    iocmok = iocmok+nbk**2
    ioDr = ioDr+nTri_Elem(nbk)
  end do
  nbl = mbas(lsym)
  iocmol = iocmol+nbl**2
  ioDs = ioDs+nTri_Elem(nbl)
end do
#ifdef _DEBUGPRINT_
call RecPrt('PSOPam',' ',PSOPam,nnPam1*nnPam2,nnPam3*nnPam4)
#endif

return

end subroutine ptrans

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Qmstat(ireturn)

use qmstat_global, only: Anal, AvRed, BasOri, BigT, CasOri, ChaNuc, Cordst, DipIm, EdSt, info_atom, iQang, iQn, iWoGehenC, &
                         iWoGehenQ, lExtr, MoAveRed, mPrimus, MxPut, nBA_C, nBA_Q, nBonA_C, nBonA_Q, nCBoA_C, nCBoA_Q, nCent, &
                         nCnC_C, nPart, nPol, nPrimus, OldGeo, PertNElcInt, QIm, QImp, Qmeq, QmProd, Qmstat_end, QmType, SavOri, &
                         SingPoint, Sqrs, SupM, Trans, Udisp, V1
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: iCi, iQ_Atoms, nAtomsCC, nBas(1), nBas_C(1), nCalls, NCountField, nntyp
character(len=4) :: Labjhr
integer(kind=iwp), allocatable :: natyp(:), nOcc(:)
real(kind=wp), allocatable :: Coord(:,:), Eint(:,:), PertElcInt(:), Poli(:,:), StoreCoo(:,:,:), SumElcPot(:,:)
#include "warnings.h"
!******JoseMEP New variables to perform the MEP calculation
!Eint, Poli, SumElcPot, PertElcInt, nOcc, natyp, Labjhr

! The journey begins. Set non-zero return code.

ireturn = 99

! If parallel compilation, terminate, but gracefully.

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  write(u6,*)
  write(u6,*) ' QMStat does not run in parallel!'
  write(u6,*)
  call Quit(_RC_NOT_AVAILABLE_)
end if
#endif

! Set defaults, zeros and initial values.

call Qmstat_init()

! Make discrete banner.

! Read ('process') input. To do that we need the number of atoms in
! the QM-region, therefore that initial call to the RUNFILE.

call Get_iScalar('Unique atoms',iQ_Atoms)
call mma_allocate(info_atom,iQ_Atoms,label='info_atom')
call mma_allocate(ChaNuc,iQ_Atoms,label='ChaNuc')
call mma_allocate(Udisp,2,iQ_Atoms,label='Udisp')
uDisp(:,:) = Zero
call Get_Qmstat_Input(iQ_Atoms)

! If only the startfile is to be edited or the sampfile analyzed, go here, then terminate.

if (EdSt) then

  call EditStart()

else if (Anal) then

  call Analyze_Q(iQ_Atoms)

else

  ! Read in orbitals, basis functions, integrals and bla bla bla. This
  ! is the centre for communicating with the rest of Molcas.

  call mma_allocate(Coord,3,iQ_Atoms,label='Coord')
  call mma_allocate(nOcc,iQ_Atoms,label='nOcc')
  call mma_allocate(natyp,iQ_Atoms,label='natyp')

  !******JoseMEP*** Qfread is called with more variables to the MEP calculation
  call Qfread(iQ_Atoms,nAtomsCC,Coord,nBas,nBas_C,nOcc,natyp,nntyp)
  !*******

  call mma_allocate(PertElcInt,nTri_Elem(nBas(1)),label='PertElcInt')
  call mma_allocate(Eint,nTri_Elem(iQ_Atoms),10,label='Eint')
  call mma_allocate(Poli,nTri_Elem(iQ_Atoms),10,label='Poli')
  call mma_allocate(SumElcPot,nTri_Elem(iQ_Atoms),10,label='SumElcPot')
  call mma_allocate(OldGeo,3,size(Cordst,2),label='OldGeo')
  call mma_allocate(DipIm,3,MxPut*max(nCent,nPol),label='DipIm')
  call mma_allocate(QIm,MxPut*nCent,label='QIm')
  call mma_allocate(QImp,MxPut*max(nCent,nPol),label='QImp')
  call mma_allocate(Sqrs,MxPut*nCent,label='Sqrs')
  call mma_allocate(PertNElcInt,nTri_Elem(nBas(1)),label='PertNElcInt')
  call mma_allocate(CasOri,3,size(SavOri,2),label='CasOri')

  ! The turning point for the single-point calculation.

  nCalls = 0
  do

    ! If user request a set of single point calculations, then go in to
    ! a separate routine and do a 'reintrepretation' of the input.

    if (SingPoint) then
      if (nCalls == 0) call mma_allocate(StoreCoo,3,nCent,nPart,label='Store')
      call SingP(nCalls,iQ_Atoms,StoreCoo)
    end if

    ! Decide which type of calculation we are to run. At this stage only
    ! QM equilibration and QM production is available.
    ! Also, ordinary sampfile analysis is performed separately.

    if (Qmeq .or. Qmprod) then  !Qmeq=.true. is default option.
      if (QmType(1:3) == 'SCF') then
        call EqScf(iQ_Atoms,nAtomsCC,Coord,nBas,nBas_C)
      else if (QmType(1:4) == 'RASS') then
        call EqRas(iQ_Atoms,nAtomsCC,Coord,nBas,nBas_C)
      end if
    end if

    !********JoseMEP
    ! If MEP option true. Calculate the Interaction energy coming from the
    ! Interaction with Mean Elec. Potential, Field and Field-Gradient
    ! E=q*Pot-dipol*field+quad*field-grad
    ! Also is included the non_Electr perturbation
    ! For a quantum AO i nonE=d*Sum_k <Xi|Chi_k>*Sum_k <Xi|Chi_k>*E_k
    ! These Energies are added to the SEWARD One-electron file
    ! as a perturbation to the One-e Hamiltoniam

    if (lExtr(8)) then
      Labjhr = 'Pert'
      call AverMEP(Labjhr,Eint,Poli,iCi,SumElcPot,NCountField,PertElcInt,iQ_Atoms,nBas(1),nOcc,natyp,nntyp)
    end if
    !********

    ! If we are doing single point calculations, then jump back up.

    if (.not. SingPoint) exit
    if (nCalls < size(StoreCoo,3)) then
      write(u6,*)
      write(u6,*)
      write(u6,*)
      write(u6,*) '     *********** << NEW CALCULATION >> ***********'
      write(u6,'(A,I3,A)') 'Single point-calculation nr.',nCalls+1,' follows below.'
      write(u6,*)
      write(u6,*)
    else
      call mma_deallocate(StoreCoo)
      write(u6,*)
      write(u6,*)
      write(u6,*) ' Single-point calculation ended.'
      write(u6,*)
      exit
    end if
  end do

  call mma_deallocate(Coord)
  call mma_deallocate(nOcc)
  call mma_deallocate(natyp)
  call mma_deallocate(Eint)
  call mma_deallocate(Poli)
  call mma_deallocate(SumElcPot)
  call mma_deallocate(PertElcInt)
  call mma_deallocate(OldGeo)
  call mma_deallocate(DipIm)
  call mma_deallocate(QIm)
  call mma_deallocate(QImp)
  call mma_deallocate(Sqrs)
  call mma_deallocate(PertNElcInt)
  call mma_deallocate(CasOri)
  call mma_deallocate(nBA_C)
  call mma_deallocate(nBA_Q)
  call mma_deallocate(nBonA_C)
  call mma_deallocate(nBonA_Q)
  call mma_deallocate(nCBoA_C)
  call mma_deallocate(nCBoA_Q)
  call mma_deallocate(nCnC_C)
  call mma_deallocate(iWoGehenC)
  call mma_deallocate(iWoGehenQ)
  call mma_deallocate(iQn)
  call mma_deallocate(iQang)
  call mma_deallocate(BasOri)
  call mma_deallocate(SavOri)
  call mma_deallocate(mPrimus)
  call mma_deallocate(nPrimus)
  call mma_deallocate(Trans)

  ! Deallocations of stuff from qfread to simulations. These are unique for the QM-method.

  if (QmType(1:4) == 'RASS') then
    call mma_deallocate(BigT)
    if (MoAveRed) call mma_deallocate(AvRed)
  else if (QmType(1:3) == 'SCF') then
    call mma_deallocate(SupM)
    call mma_deallocate(V1)
  end if

end if

call mma_deallocate(info_atom)
call mma_deallocate(ChaNuc)
call mma_deallocate(Udisp)

! Exit

call Qmstat_end()

ireturn = 0

return

end subroutine Qmstat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine CStart_CI_Util(C,h0,TUVX,iSel,ExplE,ExplV,
     &                          nMaxSel,iFinal)
************************************************************************
*                                                                      *
*     Find initial CI-vectors                                          *
*                                                                      *
*     calling arguments:                                               *
*     C       : array of real*8                                        *
*               CI vector                                              *
*     h0      : array of real*8                                        *
*               one-electron integrals                                 *
*     TUVX    : array of real*8                                        *
*               two-electron integrals                                 *
*     iSel    : array of integer                                       *
*               list of configuration included in the explicit Hamilt. *
*     ExplE   : array of real*8                                        *
*               eigenvalues of the explicit Hamiltonian                *
*     ExplV   : array of real*8                                        *
*               eigenvectors of the explicit Hamiltonian               *
*     iFinal  : integer                                                *
*               status of optimization process                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension C(*) , h0(*) , TUVX(*), iSel(*), ExplE(*), ExplV(*)

#include "rasdim.fh"
#include "general.fh"
#include "rasscf.fh"
#include "csfbas.fh"
#include "WrkSpc.fh"
#include "output_ras.fh"
      PARAMETER (ROUTINE='CSTART  ')
#include "SysDef.fh"
#ifdef _HDF5_
#  include "mh5.fh"
#endif

c      Dimension iToc(15)
      Character*80 String
      Logical Exist

      IPRLEV=IPRLOC(3)

* special case: nConf=1

      If ( nConf.eq.1 .and. nAc.eq.0 ) then
        iDisk = IADR15(4)
C$$$        ExplE(1) = C(1)  ! Commented out by Jesper
C$$$        ExplV(1) = 1.0d0 ! Commented out by Jesper
        C(1) = 1.0d0
        Call Save_tmp_CI_vec(1,nConf,C,LuDavid)
        Return
      End If

* compute the explicit Hamiltonian
* (needs to be out here as we want to redetermine
*  dynamically the selection vector)

      Call ExplH2(C,h0,TUVX,iSel,ExplE,ExplV)

* special case: nSel=nConf

      If ( nSel.eq.nMaxSel ) then
        If ( IPRLEV.ge. DEBUG ) Write (6,*)
     &                  ' Initial CI-vectors are obtained by',
     &                  ' diagonalizing the explicit Hamiltonian'
        iDisk = IADR15(4)
        Do i = 1,lRoots
          Call dCopy_(nConf,[0.0D0],0,C,1)
          Do j = 1,nSel
            k = iSel(j)
            C(k) = ExplV(j+(i-1)*nSel)
          End Do
          Call Save_tmp_CI_vec(i,nConf,C,LuDavid)
          If ( IPRLEV.ge. INSANE ) then
            Write (String,'(A,I2)') 'CI vector of root',i
            Write (String,'(A,I4,A)') '(max. ',nSel,' elements)'
            l = Min(nSel,nConf)
            Call dVcPrt(String,' ',ExplV(1+(i-1)*nSel),l)
          End If
        End Do
        Return
      End If

      If (Start_Vectors) then
        Start_Vectors=.False.
        If ( ICIRST.ne.0 ) then
#ifdef _HDF5_
          Call f_Inquire(StartOrbFile,Exist)
          if (Exist) then
            if (mh5_is_hdf5(StartOrbFile)) then
              If (IPRLEV.ge.TERSE) Then
                write (6,'(1x,a)')
     $                  'reading initial CI vectors from '//StartOrbFile
              End If
              mh5id = mh5_open_file_r(StartOrbFile)

              Call GetMem('Scr1','Allo','Real',iTmp1,nConf)
              call GetMem('kcnf','allo','inte',ivkcnf,nactel)
              Do i = 1,lRoots
                call mh5_fetch_dset_array_real(mh5id,'CI_VECTORS',
     $                  Work(iTmp1),[nconf,1],[0,i-1])
                Call Reord2(NAC,NACTEL,LSYM,1,
     &                  iWork(KICONF(1)),iWork(KCFTP),
     &                  Work(iTmp1),C,iwork(ivkcnf))
                Call Save_CI_vec(i,nConf,C,LuDavid)
              End Do
              call GetMem('kcnf','free','inte',ivkcnf,nactel)
              Call GetMem('Scr1','Free','Real',iTmp1,nConf)

              call mh5_close_file(mh5id)
            else
              Exist = .false.
            end if
          end if
          If (.not.Exist) Then
#endif
* get start vectors by reading JOBOLD
          iJOB=0
          Call f_Inquire('JOBOLD',Exist)
          If (Exist) iJOB=1
          If (iJOB.eq.1) Then
            If (IPRLEV.ge.TERSE) Then
              write (6,'(1x,a)')
     $                'reading initial CI vectors from JOBOLD'
            End If
            If (JOBOLD.le.0) Then
              JOBOLD=20
              Call DaName(JOBOLD,'JOBOLD')
            End If
          Else
            If (IPRLEV.ge.TERSE) Then
              write (6,'(1x,a)')
     $                'reading initial CI vectors from JOBIPH'
            End If
            JOBOLD=JOBIPH
          End If

          iDisk = 0
          Call IDafile(JOBOLD,2,iToc,15,iDisk)
          iDisk = iToc(4)
          Call GetMem('Scr1','Allo','Real',iTmp1,nConf)
          Do i = 1,lRoots
            Call DDafile(JOBOLD,2,Work(iTmp1),nConf,iDisk)
            call GetMem('kcnf','allo','inte',ivkcnf,nactel)
            Call Reord2(NAC,NACTEL,LSYM,1,
     &              iWork(KICONF(1)),iWork(KCFTP),
     &              Work(iTmp1),C,iwork(ivkcnf))
            call GetMem('kcnf','free','inte',ivkcnf,nactel)
            Call Save_CI_vec(i,nConf,C,LuDavid)
            If ( IPRLEV.ge. INSANE ) then
              Write (String,'(A,I2)') 'Start vector of root',i
              Write (String,'(A,I4,A)') '(max. ',nSel,' elements)'
              l = Min(nSel,nConf)
              Call dVcPrt(String,' ',C,l)
            End If
          End Do
          Call GetMem('Scr1','Free','Real',iTmp1,nConf)
          If (iJOB.eq.1) Then
            If(JOBOLD.gt.0.and.JOBOLD.NE.JOBIPH) Then
              Call DaClos(JOBOLD)
              JOBOLD=-1
            Else If(JOBOLD.gt.0) Then
              JOBOLD=-1
            End If
          End If
#ifdef _HDF5_
          End If
#endif

        Else
* no CI restart, get start vectors by diagonalizing the explicit Hamiltonian
          If ( IPRLEV.ge. DEBUG ) Write (6,*)
     &            ' Initial CI-vectors are obtained by',
     &            ' diagonalizing the explicit Hamiltonian'
          Do i = 1,lRoots
            Call dCopy_(nConf,[0.0d0],0,C,1)
            Do j = 1,nSel
              k = iSel(j)
              C(k) = ExplV(j+(i-1)*nSel)
            End Do
            Call Save_CI_vec(i,nConf,C,LuDavid)
            If ( IPRLEV.ge. INSANE ) then
              Write (String,'(A,I2)') 'Start vector of root',i
              Write (String,'(A,I4,A)') '(max. ',nSel,' elements)'
              l = Min(nSel,nConf)
              Call dVcPrt(String,' ',C,l)
            End If
          End Do

        End If

      Else
* no external start vector needed, get start vectors by reading JOBIPH
        If ( iFinal.eq.2 ) then
          If ( IPRLEV.ge. DEBUG ) Write (6,*)
     &            ' Initial CI-vectors are identical to the',
     &            ' transformed CI-vectors of the previous ',
     &            ' RASSCF iteration'
        Else
          If ( IPRLEV.ge.DEBUG ) Write (6,*)
     &            ' Initial CI-vectors are identical to the',
     &            ' CI-vectors of the previous RASSCF iteration'
        End If
        iDisk = IADR15(4)
        Do i = 1,lRoots-hRoots
          Call DDafile(JOBIPH,2,C,nConf,iDisk)
          Call Save_CI_vec(i,nConf,C,LuDavid)
          If ( IPRLEV.gt.10 ) then
            Write (String,'(A,I2)') 'Start vector of root',i
            Write (String,'(A,I4,A)') '(max. ',nSel,' elements)'
            l = Min(nSel,nConf)
            Call dVcPrt(String,' ',C,l)
          End If
        End Do
*MGD simple guess for missing ones : explV
*dangerous if linear dependence with converged states
        Do i= lRoots-hRoots+1,lRoots
           Call dCopy_(nConf,[0.0d0],0,C,1)
           Do j = 1,nSel
             k = iSel(j)
             C(k) = ExplV(j+(i-1)*nSel)
           End Do
          Call Save_CI_vec(i,nConf,C,LuDavid)
        End Do

      End If


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Jesper Norell                                    *
!***********************************************************************

subroutine MKDYSORB(IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,PSI1,PSI2,IF10,IF01,DYSAMP,DYSCOF)

use rassi_global_arrays, only: FSBANN1, FSBANN2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IORBTAB(*), ISSTAB(*), IFSBTAB1(*), IFSBTAB2(*)
real(kind=wp), intent(in) :: PSI1(*), PSI2(*)
logical(kind=iwp), intent(in) :: IF10, IF01
real(kind=wp), intent(out) :: DYSAMP
real(kind=wp), intent(_OUT_) :: DYSCOF(*)
integer(kind=iwp) :: IMODE, ISORB, JSORB, NASORB, NDETS1, NDETS2
real(kind=wp) :: COEFF, OVLP
real(kind=wp), allocatable :: ANN1(:), ANN2(:)
real(kind=wp), external :: OVERLAP_RASSI

! +++ J. Norell 12/7 - 2018
! Calculates the Dyson orbital between two states with
! N and N-1 electrons, defined as:
! D = < N-1 | anni_right | N >, or
! D = < N | anni_left | N-1 >

! Nr of active spin-orbitals
NASORB = IORBTAB(4)
DYSAMP = Zero
DYSCOF(1:NASORB) = Zero

if (IF10) then
  ! IF10 = Eliminate to the left (state 1)

  ! Loop over all spin orbitals ISORB:
  do ISORB=1,NASORB
    OVLP = Zero

    ! Annihilate a single orbital:
    COEFF = One
    IMODE = -1
    call FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB1,1)
    NDETS1 = FSBANN1(5)
    call mma_allocate(ANN1,NDETS1,Label='ANN1')
    ANN1(:) = Zero
    call PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,FSBANN1,IFSBTAB1,COEFF,ANN1,PSI1)

    ! Compute the coefficient as the overlap between the N-1 electron w.f.s
    OVLP = OVERLAP_RASSI(FSBANN1,IFSBTAB2,ANN1,PSI2)
    call mma_deallocate(ANN1)
    call mma_deallocate(FSBANN1)
    DYSCOF(ISORB) = OVLP

    ! Collect the squared norm of the Dyson orbital
    DYSAMP = DYSAMP+OVLP*OVLP

  end do ! ISORB LOOP

else if (IF01) then
  ! IF01 = Eliminate to the right (state 2)

  ! Loop over all spin orbitals JSORB:
  do JSORB=1,NASORB
    OVLP = Zero

    ! Annihilate a single orbital:
    COEFF = One
    IMODE = -1
    call FSBOP(IMODE,JSORB,IORBTAB,ISSTAB,IFSBTAB2,2)
    NDETS2 = FSBANN2(5)
    ! BRN
    call mma_allocate(ANN2,NDETS2,Label='ANN2')
    ANN2(:) = Zero
    call PRIMSGM(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN2,IFSBTAB2,COEFF,ANN2,PSI2)

    ! Compute the coefficient as the overlap between the N-1 electron w.f.s
    OVLP = OVERLAP_RASSI(IFSBTAB1,FSBANN2,PSI1,ANN2)
    call mma_deallocate(ANN2)
    call mma_deallocate(FSBANN2)
    DYSCOF(JSORB) = OVLP

    ! Collect the squared norm of the Dyson orbital
    DYSAMP = DYSAMP+OVLP*OVLP

  end do ! JSORB LOOP

else
  write(u6,*) 'Invalid state combination in MKDYSORB'
  write(u6,*) '(No such Dyson orbital can exist!)'

end if ! IF10 or IF01

! The eventual PES amplitude is given by the squared norm,
! but for transformation of the D_ij elements we need to remove the
! square for now
DYSAMP = sqrt(DYSAMP)

end subroutine MKDYSORB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Do_Index(Index,NrBas,NrBas_Eff,iCmp)
      Implicit Real*8 (a-h,o-z)
      Integer Index(NrBas_Eff*iCmp)
*
      iAdd=NrBas-NrBas_Eff
      Do iB_Eff = 1, NrBas_Eff
         iB = iB_Eff + iAdd
         Do iC = 1, iCmp
            iCB = (iC-1)*NrBas + iB
            iCB_Eff = (iC-1)*NrBas_Eff + iB_Eff
            Index(iCB_Eff)=iCB
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1992, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DesymP(iAng,iCmp,jCmp,kCmp,lCmp,Shijij,iShll,iShell,iAO,kOp,ijkl,Aux,nAux,PAO,PSO,nPSO)
!***********************************************************************
!                                                                      *
!  Object: to transform the integrals in AO basis to symmetry adapted  *
!          orbitals , SO. This is done by accumulating the AO inte-    *
!          grals onto the SO integrals.                                *
!          Observe that one of the operator is the Unit operation      *
!          performed on center A. However, since we scramble the order *
!          we do not really know which center is which. However, the   *
!          Unit operator will always give a factor of one. Hence, this *
!          is a convenient way to do the symmetry transformation with- *
!          out having to know the order.                               *
!                                                                      *
!          The indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified to desymmetrization of the second order density *
!             matrix, January '92.                                     *
!***********************************************************************

use Index_Functions, only: nTri3_Elem
use Basis_Info, only: Shells
use Symmetry_Info, only: iChBas, iChTbl, iOper, nIrrep, Prmt
use SOAO_Info, only: iAOtSO
use Real_Spherical, only: iSphCr
use Constants, only: Zero, Eight, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iAng(4), iCmp, jCmp, kCmp, lCmp, iShll(4), iShell(4), iAO(4), kOp(4), ijkl, nAux, nPSO
logical(kind=iwp), intent(in) :: Shijij
real(kind=wp), intent(out) :: Aux(nAux), PAO(ijkl,iCmp,jCmp,kCmp,lCmp)
real(kind=wp), intent(in) :: PSO(ijkl,nPSO)
integer(kind=iwp) :: i1, i2, i3, i4, iAux, iChBs, ii, is, iSym(0:7), j, j1, j12, j123, j2, j3, j4, jChBs, jj, js, jSym(0:7), &
                     kChBs, kk, ks, kSym(0:7), lChBs, ll, ls, lSym(0:7), MemSO2, niSym, njSym, nkSym, nlSym
real(kind=wp) :: Fact, FactNs, pa, pb, pc, Xa, Xb, Xg
logical(kind=iwp) :: Shij, Shkl
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
real(kind=wp), external :: DDot_
#endif

Shij = (iShell(1) == iShell(2))
Shkl = (iShell(3) == iShell(4))
MemSO2 = 1

#ifdef _DEBUGPRINT_
call RecPrt(' In DesymP: PSO ',' ',PSO,ijkl,nPSO)
call WrCheck(' In DesymP: PSO ',PSO,ijkl*nPSO)
write(u6,*) 'iCmp,jCmp,kCmp,lCmp,nPSO=',iCmp,jCmp,kCmp,lCmp,nPSO
write(u6,*) Shij,Shkl,Shijij
write(u6,*) 'kOp=',kOp
#endif
Fact = Eight
if (Shij) Fact = Fact*Half
if (Shkl) Fact = Fact*Half
if (Shijij) Fact = Fact*Half

! Initialize second order density matrix in AO basis

PAO(:,:,:,:,:) = Zero

! Quadruple loop over elements of the basis functions angular
! description. Loops are reduced to just produce unique SO integrals
! Observe that we will walk through the memory in PAO in a
! sequential way.

ii = nTri3_Elem(iAng(1))
jj = nTri3_Elem(iAng(2))
kk = nTri3_Elem(iAng(3))
ll = nTri3_Elem(iAng(4))
do i1=1,iCmp
  iChBs = iChBas(ii+i1)
  if (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+i1))
  pa = Prmt(iOper(kOp(1)),iChBs)
  niSym = 0
  do j=0,nIrrep-1
    if (iAOtSO(iAO(1)+i1,j) > 0) then
      iSym(niSym) = j
      niSym = niSym+1
    end if
  end do
  do i2=1,jCmp
    jChBs = iChBas(jj+i2)
    if (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+i2))
    pb = Prmt(iOper(kOp(2)),jChBs)
    njSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) then
        jSym(njSym) = j
        njSym = njSym+1
      end if
    end do
    do i3=1,kCmp
      kChBs = iChBas(kk+i3)
      if (Shells(iShll(3))%Transf) kChBs = iChBas(iSphCr(kk+i3))
      pc = Prmt(iOper(kOp(3)),kChBs)
      nkSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(3)+i3,j) > 0) then
          kSym(nkSym) = j
          nkSym = nkSym+1
        end if
      end do
      do i4=1,lCmp
        lChBs = iChBas(ll+i4)
        if (Shells(iShll(4))%Transf) lChBs = iChBas(iSphCr(ll+i4))
        ! Parity factor due to symmetry operations applied to the
        ! angular part of the basis functions.
        FactNs = pa*pb*pc*Prmt(iOper(kOp(4)),lChBs)
        nlSym = 0
        do j=0,nIrrep-1
          if (iAOtSO(iAO(4)+i4,j) > 0) then
            lSym(nlSym) = j
            nlSym = nlSym+1
          end if
        end do

        ! Loop over irreps which are spanned by the basis functions.
        ! Again, the loop structure is restricted to ensure unique
        ! integrals.

        if (nIrrep == 1) then
          !FactNs = 1
          PAO(:,i1,i2,i3,i4) = PAO(:,i1,i2,i3,i4)+Fact*PSO(:,MemSO2)
          MemSO2 = MemSO2+1
          cycle
        end if

        iAux = 0
        do is=0,niSym-1
          j1 = iSym(is)
          Xa = real(iChTbl(j1,kOp(1)),kind=wp)*FactNs
          do js=0,njSym-1
            j2 = jSym(js)
            Xb = real(iChTbl(j2,kOp(2)),kind=wp)*Xa
            j12 = ieor(j1,j2)
            do ks=0,nkSym-1
              j3 = kSym(ks)
              Xg = real(iChTbl(j3,kOp(3)),kind=wp)*Xb
              j123 = ieor(j12,j3)
              do ls=0,nlSym-1
                j4 = lSym(ls)
                if (j123 == j4) then
                  iAux = iAux+1
                  Aux(iAux) = real(iChTbl(j4,kOp(4)),kind=wp)*Xg*Fact
                  exit
                end if
              end do
            end do
          end do
        end do

        if (iAux /= 0) then
#         ifdef _DEBUGPRINT_
          call RecPrt(' Aux',' ',Aux,iAux,1)
#         endif
          if (iAux /= 1) then
            call DNaXpY(iAux,ijkl,Aux,1,PSO(1,MemSO2),1,ijkl,PAO(1,i1,i2,i3,i4),1,0)
          else
            PAO(:,i1,i2,i3,i4) = PAO(:,i1,i2,i3,i4)+Aux(1)*PSO(:,MemSO2)
          end if
          MemSO2 = MemSO2+iAux
        end if

      end do
    end do
  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt(' On exit from DesymP: PAO ',' ',PAO,ijkl,iCmp*jCmp*kCmp*lCmp)
do i=1,ijkl
  write(u6,*) DDot_(iCmp*jCmp*kCmp*lCmp,PAO(i,1,1,1,1),ijkl,PAO(i,1,1,1,1),ijkl)
end do
call WrCheck('DesymP: PAO ',PAO,ijkl*iCmp*jCmp*kCmp*lCmp)
#endif

end subroutine DesymP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SKPRCD2(NDIM,MBLOCK,IFILE)
C
C     Skip record in file IFILE
C
*. Version allowing zero and packed blocks
*
* Dos not work with FASTIO - I expect
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "io_util.fh"
*
      DIMENSION ISCR(2), IDUMMY(1), DUMMY(1)
c      PARAMETER(LPBLK=50000)

C
      IPACK = 1
      IF(IPACK.NE.0) THEN
*. Read if ARRAY is zero
        CALL IFRMDS(ISCR,2,2,IFILE)
        IMZERO=ISCR(1)
        I_AM_PACKED=ISCR(2)
        IF(IMZERO.EQ.1) THEN
          GOTO 1001
        END IF
      END IF
*
      IF(I_AM_PACKED.EQ.1) THEN
*. Loop over packed records of dimension LPBLK
*. The next LPBLK elements
  999   CONTINUE
*. Read next batch
          CALL IDAFILE(IFILE,2,ISCR,1,IDISK(IFILE))
          LBATCH=ISCR(1)
          IF(LBATCH.GT.0) THEN
            IDUMMY(1)=0
            CALL IDAFILE(IFILE,0,IDUMMY,LBATCH,IDISK(IFILE))
            DUMMY(1)=0.0d0
            CALL DDAFILE(IFILE,0,DUMMY,LBATCH,IDISK(IFILE))
          END IF
          CALL IDAFILE(IFILE,2,ISCR,1,IDISK(IFILE))
          ISTOP=ISCR(1)
        IF(ISTOP.EQ.0) GOTO 999
      ELSE IF ( I_AM_PACKED.EQ.0) THEN
cvv        IF(.true.) THEN
          NBLOCK = MBLOCK
          IF ( MBLOCK .LE. 0 ) NBLOCK = NDIM
          IREST=NDIM
          IBASE=0
  100     CONTINUE
          IF(IREST.GT.NBLOCK) THEN
           CALL DDAFILE(IFILE,0,DUMMY,NBLOCK,IDISK(IFILE))
           IBASE=IBASE+NBLOCK
           IREST=IREST-NBLOCK
          ELSE
           CALL DDAFILE(IFILE,0,DUMMY,IREST,IDISK(IFILE))
           IREST=0
          END IF
          CALL IDAFILE(IFILE,0,IDUMMY,1,IDISK(IFILE))
        IF( IREST .GT. 0 ) GOTO 100
cvv        END IF
C
      END IF
*
 1001 CONTINUE
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine GetDDgMat(DDg,GDMat,Gtuvx)

use Index_Functions, only: iTri, nTri_Elem
use rasscf_global, only: lRoots, NAC
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: DDG(lRoots,lRoots,lRoots,lRoots)
real(kind=wp), intent(in) :: GDMat(nTri_Elem(lRoots),NAC,NAC), Gtuvx(NAC,NAC,NAC,NAC)
integer(kind=iwp) :: iI, iIJ, iJ, iK, iKL, iL, iv, ix

DDG(:,:,:,:) = Zero
do iL=1,lRoots
  do iK=1,lRoots
    iKL = iTri(iL,iK)
    do iJ=1,lRoots
      do iI=1,lRoots
        iIJ = iTri(iI,iJ)
        do ix=1,NAC
          do iv=1,NAC
            DDG(iI,iJ,iK,iL) = DDG(iI,iJ,iK,iL)+sum(GDMat(iKL,iv,ix)*GDMat(iIJ,:,:)*Gtuvx(:,:,iv,ix))
          end do
        end do
      end do
    end do
  end do
end do

return

end subroutine GetDDgMat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ALLOC_MRCI
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "warnings.fh"
#include "mrci.fh"
*------
* POW: This array is not used!
*     DIMENSION IPOF(9)
*------
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      NVSQ=0
      NVMAX=0
      DO 10 I=1,NSYM
        NVMAX=MAX(NVMAX,NVIR(I))
        NVSQ=NVSQ+NVIR(I)**2
10    CONTINUE
      NVT=(NVIRT*(NVIRT+1))/2
      if (NVIRT.eq.0) then
        Call SysAbendMsg('alloc_mrci.f:',
     &   'no virtual orbitals in the basis',' ')
      endif
*PAM04 MOVE ALLOCATION OF FOCK MATRIX TO SDCI.
*C FOCK MATRIX IN SORT,IIJJ,IJIJ,FIJ,AI.
*      LFOCK=LPERMA
*      LPERMX=LFOCK+NBTRI
*-----------------------------------------------
*PAM04 Change systematically:
*PAM04  (1) LPERMA, LPERMB, LPERMX set to 1
*PAM04  (2) MAXMEM changed to MEMWRK
      LPERMA=1
      LPERMB=1
      LPERMX=1
*-----------------------------------------------
CPAM97 C BUFFER FOR MOTRA INTEGRALS, TIBUF,  IN SORT, SORTA, SORTB.
CPAM97       LTIBUF=LPERMX
CPAM97       LPERMX=LTIBUF+NTIBUF
*PAM04      MEMX=MAXMEM-LPERMX+1
*PAM04      MEMX=MAXMEM
* PAM06: Evidently some miscounting margin needed:
      MEMX=INT(0.90D0*DBLE(MEMWRK))
C ALLOCATION FOR SORTA.
      NCHN1=LN*NVIRT+1
      IF(IFIRST.NE.0)NCHN1=1
      NBSIZ1=MEMX/NCHN1 - 1
      NBUFBI=KBUFF1
      NBSIZ1=MIN(NBSIZ1,MEMX-2*ISMAX-NBUFBI-1)
      NBSIZ1=MAX(NBSIZ1,256)
CPAM96 NBSIZ1=Size counted in real*8 words.
CPAM96 Must contain NBITM1 real*8 + NBITM1 integ + 2 integ:
CPAM96      NBITM1=2*((NBSIZ1-1)/3)
      NBITM1=(RTOI*NBSIZ1-2)/(RTOI+1)
      NBITM1=MIN(NBITM1,NVSQ)
      NBITM1=((NBITM1+2)/RTOI)*RTOI-2
CPAM96      NBSIZ1=(3*NBITM1+2)/2
      NBSIZ1=((RTOI+1)*NBITM1+2+(RTOI-1))/RTOI
C SORTING AREA, BUFOUT AND INDOUT
*PAM04      LBIN1=LPERMX
*PAM04      NBIN1=NBSIZ1*NCHN1
C BIAC
C NOTE: ONE SINGLE BIN IS IN USE TOGETHER WITH BIAC,BICA,BUFBI.
*PAM04      LBIAC1=LBIN1+NBSIZ1
*PAM04      LBIAC1=LPERMX
*PAM04C BICA
*PAM04      LBICA1=LBIAC1+ISMAX
*PAM04C BUFBI
*PAM04      LBUFBI=LBICA1+ISMAX
*PAM04*PAM04      LTOP1=MAX(LBUFBI+NBUFBI,LBIN1+NBIN1)-1
*PAM04      LTOP1=LBUFBI+NBUFBI-1
*PAM04      LTOP=LTOP1
      LTOP=LPERMX
C DYNAMIC ALLOCATION FOR SORTING ABCD
      NBITM2=1
      NOVT=0
      LTOP2=0
      IF(IFIRST.EQ.0) THEN
        IPASS=0
110       IPASS=IPASS+1
          NCHN2=(NVT-1)/IPASS+1
          NBSIZ2=(MEMX-2*ISMAX-KBUFF1)/NCHN2
CPAM96          IF(2*NBSIZ2.GT.(3*NVSQ+2)) GOTO 120
          IF(RTOI*NBSIZ2.GT.((RTOI+1)*NVSQ+2)) GOTO 120
          IF(IPASS.EQ.5) GOTO 120
          IF(NBSIZ2.LT.1024) GOTO 110
120     CONTINUE
CPAM96        NBITM2=2*((NBSIZ2-1)/3)
        NBITM2=(RTOI*NBSIZ2-2)/(RTOI+1)
        NBITM2=MIN(NBITM2,NVSQ)
        NBITM2=((NBITM2+2)/RTOI)*RTOI-2
CPAM96        NBSIZ2=(3*NBITM2+2)/2
        NBSIZ2=((RTOI+1)*NBITM2+2+(RTOI-1))/RTOI
C SORTING BINS, BUFOUT AND INDOUT
*PAM04        LBIN2=LPERMX
*PAM04        NBIN2=NBSIZ2*NCHN2
C BFACBD, ACBDS, AND ACBDT:
*PAM04        LBACBD=LBIN2+NBIN2
*PAM04        LACBDS=LBACBD+KBUFF1
*PAM04        LACBDT=LACBDS+ISMAX
*PAM04        LTOP2=LACBDT+ISMAX-1
*PAM04        LTOP=MAX(LTOP,LTOP2)
      END IF
C DYNAMIC ALLOCATION FOR SORTING AIBJ, AND CREATING HDIAG:
      NOT2=IROW(LN+1)
      NCHN3=3*NOT2
*PAM04      LHDIAG=LPERMX
*PAM04      NHDIAG=MAX(NVT,IRC(1))
*PAM04      LIIJJ=LHDIAG+NHDIAG
*PAM04      LIJIJ=LIIJJ+NBTRI
*PAM04      NBSIZ3=(MAXMEM-LPERMX)/NCHN3
      NBSIZ3=(MEMWRK-LPERMX)/NCHN3
      NBSIZ3=MAX(NBSIZ3,256)
CPAM96      NBITM3=2*((NBSIZ3-1)/3)
      NBITM3=(RTOI*NBSIZ3-2)/(RTOI+1)
      NBITM3=MIN(NBITM3,NVSQ)
      NBITM3=((NBITM3+2)/RTOI)*RTOI-2
CPAM96      NBSIZ3=(3*NBITM3+2)/2
      NBSIZ3=((RTOI+1)*NBITM3+2+(RTOI-1))/RTOI
*PAM04      NBIN3=NBSIZ3*NCHN3
*PAM04      LTOP3=LBIN3+NBIN3
*PAM04      LTOP=MAX(LTOP,LTOP3)
C VECTORS PERMANENTLY IN CORE DURING CI ITERATIONS.
C LFOCK ALREADY ALLOCATED AT LPERMA. ALSO ALLOCATE DMO AND TDMO
C THERE, OVERLAYED, FOR FUTURE USE.
*PAM04 ALLOCATING DMO AND TDMO HAS BEEN MOVED TO SDCI.
*      LDMO=LPERMA
*      LTDMO=LPERMA
C AREF, EREF: EIGENVECTORS AND ENERGIES OF REFERENCE CI.
*PAM04 NOW AREF CAN START DIRECTLY AT LPERMA
*      LAREF=LPERMA+NBTRI
*      IF(ITRANS.EQ.1) LAREF=LPERMA+NBAST**2
*PAM04      LAREF=LPERMA
*PAM04      LEREF=LAREF+NREF**2
*PAM04      LPERMB=LEREF+NREF
C CALCULATE HOW MUCH SCRATCH WILL BE NEEDED FOR PERS PART:
C FIRST, SET ASIDE WHATS NEEDED FOR SIGMA GENERATION:
      NIJ=(LN*(LN+1))/2
      NIJKL=NIJ*(NIJ+1)/2
      NBMN=IAD10(1)
      IF(IFIRST.NE.0)NBMN=0
      NPER=5*NVSQ+NBSIZ3+2*NVMAX**2
CPAM97      NPER=MAX(NPER,NIJKL+1+KBUFF1/2)
      NPER=MAX(NPER,NIJKL)
      NPER=MAX(NPER,2*NBMN+2*ISMAX+KBUFF1)
      NPER=MAX(NPER,NBSIZ3+2*NVMAX**2+2*NVSQ)
C OVERLAY CI,((HREF,PLEN) & (SGM,PERS PART))
      NHREF=(NREF*(NREF+1))/2
      NPLEN=NREF
      NOVLY1=JSC(ILIM)+MAX(JSC(ILIM)+NPER,NHREF+NPLEN)
C THIS IS TO BE OVERLAYED WITH (CBUF,...,LSCR) IN MQCT. TWO ALT:
      NARR=11*NRROOT**2
*PAM04      MEMB=MAXMEM-LPERMB+1
      MEMB=MEMWRK-LPERMB+1
      MBUF1=MEMB-NOVLY1-NARR
      MBUF2=(MEMB-NARR-(3*NRROOT+2*MXVEC)*NSECT)/(3*MXVEC+2)
      MBUF=MIN(MBUF1,MBUF2,20249)
      MBUF=MAX(MBUF,1259)
C ICI, ONE BUFFER OF PACKED CI COEFFICIENTS:
*PAM04      LICI=LPERMB
C CI ARRAY:
*PAM04      LCI=LICI+MBUF
C SGM ARRAY:
*PAM04      LSGM=LCI+JSC(ILIM)
*PAM04      LPER=LSGM+JSC(ILIM)
      LPER=LPERMB+JSC(ILIM)
*PAM04      LARR=LPER+NPER
C OVERLAY:
*PAM04      LHREF=LSGM
*PAM04      LPLEN=LHREF+NHREF
*PAM04      LARR=MAX(LARR,LPLEN+NPLEN)
C OVERLAY:
*PAM04      LMQ=LCI
*PAM04      LMQ=LPERMB
*PAM04      NMQ=(3*NRROOT+2*MXVEC)*NSECT+(3*MXVEC+1)*MBUF
*PAM04      LARR=MAX(LARR,LMQ+NMQ)
*PAM04      ltop4=larr+narr-1
*PAM04      ltop=max(ltop,ltop4)
C MORE DETAILED, PERS PART, FROM HERE -------------------------------
C DYNAMIC ALLOCATION FOR FAIBJ:
C MATRIX ABIJ
*PAM04      LABIJ=LPER
C MATRIX AIBJ
*PAM04      LAIBJ=LABIJ+NVSQ
C MATRIX AJBI
*PAM04      LAJBI=LAIBJ+NVSQ
C BUFIN, IBUFIN
*PAM04      LBFIN1=LAJBI+NVSQ
C A, SCRATCH AREA
*PAM04      LASCR1=LBFIN1+NBSIZ3
C B, SCRATCH AREA
*PAM04      LBSCR1=LASCR1+NVMAX**2
C F, SCRATCH AREA
*PAM04      LFSCR1=LBSCR1+NVMAX**2
C FSEC, SCRATCH AREA
*PAM04      LFSEC=LFSCR1+NVSQ
*PAM04      LTOP5=LFSEC+NVSQ-1
*PAM04      LTOP=MAX(LTOP,LTOP5)
C DYNAMIC ALLOCATION FOR IJKL
C FIJKL
CPAM04      LFIJKL=LPER
CPAM97C BUFIN, IBUFIN
CPAM97      LBFIN2=LFIJKL+NIJKL
CPAM97      NBFIN2=1+KBUFF1/2
CPAM97      LTOP6=LBFIN2+NBFIN2-1
CPAM97      LTOP=MAX(LTOP,LTOP6)
C DYNAMIC ALLOCATION FOR ABCI
C BMN
*PAM04      LBMN=LPER
C IBMN
*PAM04      LIBMN=LBMN+NBMN
C BIAC
*PAM04      LBIAC2=LIBMN+NBMN
C BICA
*PAM04      LBICA2=LBIAC2+ISMAX
C BUFIN
*PAM04      LBFIN3=LBICA2+ISMAX
*PAM04      NBFIN3=KBUFF1
*PAM04      LTOP7=LBFIN3+NBFIN3-1
*PAM04      LTOP=MAX(LTOP,LTOP7)
C DYNAMIC ALLOCATION FOR ABCD
C ACBDS
*PAM04      LAC1=LPER
C ACBDT
*PAM04      LAC2=LAC1+ISMAX
C BUFIN
*PAM04      LBFIN4=LAC2+ISMAX
*PAM04      NBFIN4=KBUFF1
*PAM04      LTOP8=LBFIN4+NBFIN4-1
*PAM04      LTOP=MAX(LTOP,LTOP8)
C DYNAMIC ALLOCATION FOR FIJ, AI AND AB
C BUFIN, IBUFIN
*PAM04      LBFIN5=LPER
C A, SCRATCH AREA
*PAM04      LASCR2=LBFIN5+NBSIZ3
C B, SCRATCH AREA
*PAM04      LBSCR2=LASCR2+NVMAX**2
C FK IN AI AND AB
*PAM04      LFSCR2=LBSCR2+NVMAX**2
C DBK
*PAM04      LDBK=LFSCR2+NVSQ
*PAM04      LTOP9=LDBK+NVSQ-1
*PAM04      LTOP=MAX(LTOP,LTOP9)
C ALLOCATION OF PERS PART ENDS HERE ------------------------------
C DYNAMIC ALLOCATION FOR NATURAL ORBITALS ETC.
*PAM04      NPRP=2*NCMO+NBAST+NBAST**2+3*NBTRI+MAX(NBTRI,NBMAX**2)
*PAM04      LPRP=LPERMB
*PAM04      LTOP10=LPRP+NPRP-1
*PAM04      LTOP=MAX(LTOP,LTOP10)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'      REQUIRED WORKSPACE SIZE:',LTOP
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'                    AVAILABLE:',MAXMEM
*PAM04      CALL XFLUSH(6)
*PAM04      IF((LTOP.LE.MAXMEM).AND.(IPRINT.LT.5)) RETURN
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)' DYNAMIC ALLOCATION INFORMATION:'
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  CSPCK:',LCSPCK
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' INTSYM:',LINTSY
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  INDX:',LINDX
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   ISAB:',LISAB
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  JREFX:',LJREFX
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  CISEL:',LCISEL
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
CPAM97      WRITE(6,'(A,I9)')'  TIBUF:',LTIBUF
CPAM97      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   FOCK:',LFOCK
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   BIN1:',LBIN1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' NBSIZ1:',NBSIZ1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  NCHN1:',NCHN1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  BIAC1:',LBIAC1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  BICA1:',LBICA1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  BUFBI:',LBUFBI
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  LTOP1:',LTOP1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   BIN2:',LBIN2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' NBSIZ2:',NBSIZ2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  NCHN2:',NCHN2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' BFACBD:',LBACBD
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  ACBDS:',LACBDS
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  ACBDT:',LACBDT
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  LTOP2:',LTOP2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  HDIAG:',LHDIAG
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  FIIJJ:',LIIJJ
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  FIJIJ:',LIJIJ
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   BIN3:',LBIN3
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' NBSIZ3:',NBSIZ3
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  NCHN3:',NCHN3
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  LTOP3:',LTOP3
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   AREF:',LAREF
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   EREF:',LEREF
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   HREF:',LHREF
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   PLEN:',LPLEN
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'    ICI:',LICI
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'     CI:',LCI
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'    SGM:',LSGM
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'    LMQ:',LMQ
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'    ARR:',LARR
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  LTOP4:',LTOP4
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   ABIJ:',LABIJ
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   AIBJ:',LAIBJ
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   AJBI:',LAJBI
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' BUFIN1:',LBFIN1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  ASCR1:',LASCR1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  BSCR1:',LBSCR1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  FSCR1:',LFSCR1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   FSEC:',LFSEC
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  LTOP5:',LTOP5
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
CPAM04      WRITE(6,'(A,I9)')'  FIJKL:',LFIJKL
CPAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'    BMN:',LBMN
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   IBMN:',LIBMN
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  BIAC2:',LBIAC2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  BICA2:',LBICA2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' BUFIN3:',LBFIN3
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  LTOP7:',LTOP7
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' ACBDS2:',LAC1
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' ACBDT2:',LAC2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' BUFIN4:',LBFIN4
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  LTOP8:',LTOP8
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' BUFIN5:',LBFIN5
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  ASCR2:',LASCR2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  BSCR2:',LBSCR2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  FSCR2:',LFSCR2
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'    DBK:',LDBK
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'  LTOP9:',LTOP9
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'    DMO:',LDMO
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'   TDMO:',LTDMO
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'    PRP:',LPRP
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')' ltop10:',LTOP10
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,'(A,I9)')'    LTOP',LTOP
*PAM04      CALL XFLUSH(6)
*PAM04      WRITE(6,*)
*PAM04      CALL XFLUSH(6)
*PAM04      IF(LTOP.LE.MAXMEM) RETURN
      IF(LTOP.LE.MEMWRK) RETURN
      WRITE(6,*)'ALLOC Error: Too much workspace is needed.'
      WRITE(6,'(1X,A,2I10)')'      Needed LTOP=',LTOP
      WRITE(6,'(1X,A,2I10)')' Available MEMWRK=',MEMWRK
      CALL QUIT(_RC_GENERAL_ERROR_)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine buildcoul(l1,l2,l3,l4,incl1,incl3,Lrun,prmints,nprim1,nprim2,nprim3,nprim4,expo1,expo2,expo3,expo4,power13,power24, &
                     quotpow1,quotpow2,coulovlp)
!bs ##################################################################
!bs  purpose: builds up the coulomb integrals
!bs  inbetween primitives and multiplies
!bs  with extra factors to correct the
!bs  normalization
!bs ##################################################################
! l1,l2,l3,l4                 : angular momenta of primitives
! incl1,incl3                 : shifts for different radial integrals
! Lrun                        : L-value for coulomb integrals
! prmints                     ! scratch for prim integral
! nprim1,nprim2,nprim3,nprim4 : number of primitives
! expo1,expo2,expo3,expo4     : arrays with the exponents

use AMFI_global, only: dffrac, MxprimL, Lmax
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Two, Eight, Half, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: l1, l2, l3, l4, incl1, incl3, Lrun, nprim1, nprim2, nprim3, nprim4
real(kind=wp), intent(inout) :: prmints(nprim1,nprim2,nprim3,nprim4)
real(kind=wp), intent(in) :: expo1(nprim1), expo2(nprim2), expo3(nprim3), expo4(nprim4), power13(MxprimL,MxprimL), &
                             power24(MxprimL,MxprimL), quotpow1(nprim1,nprim2,nprim3,nprim4), &
                             quotpow2(nprim1,nprim2,nprim3,nprim4), coulovlp(MxprimL,MxprimL,-1:1,-1:1,0:Lmax,0:Lmax)
integer(kind=iwp) :: index1, index2, index3, index4, irun1, irun2, irun3, irun4, k, krun, limit1, limit2, n1, n13, n2, n24, n3, n4
real(kind=wp) :: a1324, a2413, alpha13, alpha24, alpha24inv, doff1, doff2, fact1, factor, fraclist1(0:Lmax+3), &
                 fraclist2(0:Lmax+3), pow24, pow24inv
real(kind=wp), allocatable :: cfunctx(:), fact(:), frac(:)
real(kind=wp), parameter :: root8ovpi = sqrt(Eight/Pi)

call mma_allocate(cfunctx,MxprimL,label='cfunctx')
call mma_allocate(fact,MxprimL,label='fact')
call mma_allocate(frac,MxprimL,label='frac')

!bs ##################################################################
!bs   prepare indices for coulint
!bs ##################################################################
n1 = l1+incl1+1
n2 = l2+1
n3 = l3+incl3+1
n4 = l4+1
n13 = n1+n3
n24 = n2+n4
index1 = N13-Lrun-1
index2 = n24+Lrun
index3 = N24-Lrun-1
index4 = n13+Lrun
do krun=0,(index1-1)/2
  fraclist1(krun) = dffrac(krun+krun+index2-1,krun+krun)*dffrac(1,index2-1)
end do
do krun=0,(index3-1)/2
  fraclist2(krun) = dffrac(krun+krun+index4-1,krun+krun)*dffrac(1,index4-1)
end do
!bs ##################################################################
!bs   common factors including double factorials
!bs ##################################################################
doff1 = dffrac(index1-1,n13-1)*dffrac(n24+Lrun-1,n24-1)
doff2 = dffrac(index3-1,n24-1)*dffrac(n13+Lrun-1,n13-1)
if (index1 == 1) then
  do irun4=1,nprim4
    do irun3=1,nprim3
      if (l2 == l4) then
        limit2 = irun4
      else
        limit2 = nprim2
      end if
      do irun2=1,limit2
        pow24inv = doff1/power24(irun4,irun2)
        if (l1 == l3) then
          limit1 = irun3
        else
          limit1 = nprim1
        end if
        do irun1=1,limit1
          prmints(irun1,irun2,irun3,irun4) = quotpow1(irun1,irun2,irun3,irun4)*sqrt(Half*(expo1(irun1)+expo3(irun3)))* &
                                             power13(irun3,irun1)*pow24inv
        end do
      end do
    end do
  end do
else
  do irun4=1,nprim4
    do irun3=1,nprim3
      if (l2 == l4) then
        limit2 = irun4
      else
        limit2 = nprim2
      end if
      do irun2=1,limit2
        alpha24inv = One/(expo2(irun2)+expo4(irun4))
        pow24inv = doff1/power24(irun4,irun2)
        if (l1 == l3) then
          limit1 = irun3
        else
          limit1 = nprim1
        end if
        do irun1=1,limit1
          a1324 = alpha24inv*(expo1(irun1)+expo3(irun3))
          Cfunctx(irun1) = fraclist1(0)
          frac(irun1) = a1324/(One+a1324)
          fact(irun1) = frac(irun1)
        end do
        !vocl loop,repeat(Lmax+3)
        do k=1,(index1-1)/2
          do irun1=1,limit1
            Cfunctx(irun1) = Cfunctx(irun1)+fraclist1(k)*fact(irun1)
          end do
          do irun1=1,limit1
            fact(irun1) = fact(irun1)*frac(irun1)
          end do
        end do
        do irun1=1,limit1
          alpha13 = Half*(expo1(irun1)+expo3(irun3))
          prmints(irun1,irun2,irun3,irun4) = quotpow1(irun1,irun2,irun3,irun4)*sqrt(alpha13)*power13(irun3,irun1)*pow24inv* &
                                             Cfunctx(irun1)
        end do
      end do
    end do
  end do
end if
if (index3 == 1) then
  do irun4=1,nprim4
    do irun3=1,nprim3
      if (l2 == l4) then
        limit2 = irun4
      else
        limit2 = nprim2
      end if
      do irun2=1,limit2
        pow24 = doff2*power24(irun4,irun2)*sqrt(Half*(expo2(irun2)+expo4(irun4)))
        if (l1 == l3) then
          limit1 = irun3
        else
          limit1 = nprim1
        end if
        prmints(1:limit1,irun2,irun3,irun4) = prmints(1:limit1,irun2,irun3,irun4)+pow24*quotpow2(1:limit1,irun2,irun3,irun4)/ &
                                              power13(irun3,1:limit1)
      end do
    end do
  end do
else
  do irun4=1,nprim4
    do irun3=1,nprim3
      if (l2 == l4) then
        limit2 = irun4
      else
        limit2 = nprim2
      end if
      do irun2=1,limit2
        alpha24 = expo2(irun2)+expo4(irun4)
        pow24 = doff2*power24(irun4,irun2)*sqrt(Half*alpha24)
        if (l1 == l3) then
          limit1 = irun3
        else
          limit1 = nprim1
        end if
        Cfunctx(1:limit1) = fraclist2(0)
        do irun1=1,limit1
          a2413 = alpha24/(expo1(irun1)+expo3(irun3))
          frac(irun1) = a2413/(One+a2413)
          fact(irun1) = frac(irun1)
        end do
        !vocl loop,repeat(Lmax+3)
        do k=1,(index3-1)/2
          Cfunctx(1:limit1) = Cfunctx(1:limit1)+fraclist2(k)*fact(1:limit1)
          fact(1:limit1) = fact(1:limit1)*frac(1:limit1)
        end do
        prmints(1:limit1,irun2,irun3,irun4) = prmints(1:limit1,irun2,irun3,irun4)+ &
                                              quotpow2(1:limit1,irun2,irun3,irun4)*Cfunctx(1:limit1)*pow24/power13(irun3,1:limit1)
      end do
    end do
  end do
end if
call mma_deallocate(cfunctx)
call mma_deallocate(fact)
call mma_deallocate(frac)
!bs make some mirroring for identical l-values
!bs for the case that l1=l3
if (l1 == l3) then
  do irun4=1,nprim4
    do irun3=1,nprim3
      do irun2=1,nprim2
        prmints(irun3+1:,irun2,irun3,irun4) = prmints(irun3,irun2,irun3+1:,irun4)
      end do
    end do
  end do
end if
!bs for the case that l2=l4
if (l2 == l4) then
  do irun4=1,nprim4
    do irun3=1,nprim3
      do irun2=irun4+1,nprim2
        prmints(1:nprim1,irun2,irun3,irun4) = prmints(1:nprim1,irun4,irun3,irun2)
      end do
    end do
  end do
end if
!bs some factors which are the same for all cases
do irun4=1,nprim4
  do irun3=1,nprim3
    do irun2=1,nprim2
      prmints(:,irun2,irun3,irun4) = prmints(:,irun2,irun3,irun4)*coulovlp(irun4,irun2,0,0,l4,l2)* &
                                     coulovlp(irun3,1:nprim1,incl3,incl1,l3,l1)*root8ovpi
    end do
  end do
end do

!bs look for additional factors, as the
!bs coulomb integrals are calculated
!bs for normalized functions with that
!bs specific l

!bs if l was increased by one, the factor is
!bs 0.5*sqrt((2l+3)/(exponent))
!bs if l was decreased by one, the factor is
!bs 2*sqrt(exponent/(2l+1))

!bs  check for first function

if (incl1 == 1) then
  fact1 = Half*sqrt(real(l1+l1+3,kind=wp))
  do irun4=1,nprim4
    do irun3=1,nprim3
      do irun2=1,nprim2
        prmints(1:nprim1,irun2,irun3,irun4) = prmints(1:nprim1,irun2,irun3,irun4)*fact1/sqrt(expo1(1:nprim1))
      end do
    end do
  end do
else if (incl1 == -1) then
  fact1 = Two/sqrt(real(l1+l1+1,kind=wp))
  do irun4=1,nprim4
    do irun3=1,nprim3
      do irun2=1,nprim2
        prmints(1:nprim1,irun2,irun3,irun4) = prmints(1:nprim1,irun2,irun3,irun4)*fact1*sqrt(expo1(1:nprim1))
      end do
    end do
  end do
end if

!bs check for third function

if (incl3 == 1) then
  fact1 = Half*sqrt(real(l3+l3+3,kind=wp))
  do irun4=1,nprim4
    do irun3=1,nprim3
      factor = fact1/sqrt(expo3(irun3))
      do irun2=1,nprim2
        prmints(1:nprim1,irun2,irun3,irun4) = prmints(1:nprim1,irun2,irun3,irun4)*factor
      end do
    end do
  end do
else if (incl3 == -1) then
  fact1 = Two/sqrt(real(l3+l3+1,kind=wp))
  do irun4=1,nprim4
    do irun3=1,nprim3
      factor = fact1*sqrt(expo3(irun3))
      do irun2=1,nprim2
        prmints(1:nprim1,irun2,irun3,irun4) = prmints(1:nprim1,irun2,irun3,irun4)*factor
      end do
    end do
  end do
end if

return

end subroutine buildcoul

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine bss_ts1e(n,s,t,v,w,ul,us,clight)
C
C Evaluate the BSS Hamiltonian matrix and store the transform matrices
C
      implicit none
#include "WrkSpc.fh"
C Input
C w   aka pVp
      integer n
      Real*8 s(n,n),t(n,n),v(n,n),w(n,n),clight
C Output
      Real*8 ul(n,n),us(n,n)
C Temp
      integer m,i,j,k,nn,lwork,iW,info
      integer iTr,iBk,iEL,iES,iOL,iOS,iEp,iE0,iKC,itF,itmp
      integer iA,iB,iX,iM
C
C Transform to the free-particle Foldy-Wothuysen picture
C
      nn=n*n+4
      call getmem('Tr  ','ALLOC','REAL',iTr ,nn)
      call getmem('Back','ALLOC','REAL',iBk ,nn)
      call getmem('mEL ','ALLOC','REAL',iEL ,nn)
      call getmem('mES ','ALLOC','REAL',iES ,nn)
      call getmem('mOL ','ALLOC','REAL',iOL ,nn)
      call getmem('mOS ','ALLOC','REAL',iOS ,nn)
      call getmem('Ep  ','ALLOC','REAL',iEp ,n+4)
      call getmem('E0  ','ALLOC','REAL',iE0 ,n+4)
      call getmem('KC  ','ALLOC','REAL',iKC ,n*3+4)
      call XDR_fpFW(n,s,t,v,w,Work(iTr),Work(iBk),Work(iEL),Work(iES),
     &              Work(iOL),Work(iOS),Work(iEp),work(iE0),Work(iKC),
     &              Work(iKC+n),Work(iKC+2*n),clight)
C
C Diagonalize to get the X matrix
C
      do i=1,n
C       ! add (diagonal) kinetic matrix in fpFW picture
        Work(iEL+(i-1)*(n+1)) = Work(iEL+(i-1)*(n+1)) + Work(iE0+i-1)
        Work(iES+(i-1)*(n+1)) = Work(iES+(i-1)*(n+1)) - Work(iEp+i-1)
     &                          - clight*clight
      end do
      m = n+n
      lwork = 8*m
      call getmem('Fock ','ALLOC','REAL',itF ,m*m+4)
      call getmem('Eig  ','ALLOC','REAL',iW  ,m+4  )
      call getmem('Tmp  ','ALLOC','REAL',itmp,lwork  )
      k = 0
      do i=1,n
        do j=1,n
          Work(itF+(j-1)  +(i-1)*m  ) = Work(iEL+k)
          Work(itF+(j-1)  +(i+n-1)*m) = Work(iOL+k)
          Work(itF+(j-1+n)+(i-1)*m  ) = Work(iOS+k)
          Work(itF+(j-1+n)+(i+n-1)*m) = Work(iES+k)
          k = k + 1
        end do
      end do
      call dsyev_('V','L',m,Work(itF),m,Work(iW),Work(itmp),lwork,info)
      call getmem('tmpA','ALLOC','REAL',iA ,nn)
      call getmem('tmpB','ALLOC','REAL',iB ,nn)
      call getmem('matX','ALLOC','REAL',iX ,nn)
      k = 0
      do i=1,n
        do j=1,n
          Work(iA+k) = Work(itF+j-1+(i+n-1)*m)
          Work(iB+k) = Work(itF+j+n-1+(i+n-1)*m)
          k = k + 1
        end do
      end do
      call XDR_dmatinv(Work(iA),n)
      call dmxma(n,'N','N',Work(iB),Work(iA),Work(iX),1.d0)
C
C Apply decoupling transformation to the Fock matrix
C
      call dmxma(n,'C','N',Work(iX) ,Work(iOS),Work(iA) ,1.d0)
      call dmxma(n,'C','N',Work(iX) ,Work(iES),Work(iB) ,1.d0)
      call dmxma(n,'N','N',Work(iB) ,Work(iX) ,Work(iES),1.d0)
      call dmxma(n,'N','N',Work(iOL),Work(iX) ,Work(iB) ,1.d0)
      do i=0,n*n-1
C       ! X-projected Fock matrix
        Work(iEL+i)=Work(iEL+i)+Work(iA+i)+Work(iB+i)+Work(iES+i)
      end do
      call dmxma(n,'C','N',Work(iX),Work(iX),Work(iA),1.d0)
      do i=1,n
        Work(iA+(i-1)*(n+1)) = Work(iA+(i-1)*(n+1)) + 1.d0
      end do
C     ! renormalization matrix
      call XDR_dmatsqrt(Work(iA),n)
C     ! decoupled electron Fock matrix in moment space (eigenfunction of T matrix)
      call dmxma(n,'C','N',Work(iA),Work(iEL),Work(iB),1.d0)
      call dmxma(n,'N','N',Work(iB),Work(iA),v,1.d0)
C
C Back transform to non-orthogonal basis picture
C
      call dmxma(n,'C','N',Work(iBk),v,Work(iB),1.d0)
      call dmxma(n,'N','N',Work(iB),Work(iBk),v,1.d0)
C
C Calculate transform matrices in non-orthogonal basis space
C
      call dmxma(n,'N','N',Work(iX),Work(iA),Work(iB),1.d0)
C     ! iA/iB is the upper/lower part of transformation matrix in fpFW picture
      call getmem('TmpM','ALLOC','REAL',iM,nn*4+4)
      call XDR_mkutls(n,Work(iA),Work(iB),Work(iTr),Work(iBk),
     &     Work(iKC),Work(iKC+n),Work(iKC+2*n),ul,us,Work(iM),
     &     Work(iM+nn),Work(iM+nn*2),Work(iM+nn*3) )
      call getmem('TmpM','FREE','REAL',iM,nn*4+4)
C
C Free temp memories
C
      call getmem('Tr  ','FREE','REAL',iTr ,nn)
      call getmem('Back','FREE','REAL',iBk ,nn)
      call getmem('mEL ','FREE','REAL',iEL ,nn)
      call getmem('mES ','FREE','REAL',iES ,nn)
      call getmem('mOL ','FREE','REAL',iOL ,nn)
      call getmem('mOS ','FREE','REAL',iOS ,nn)
      call getmem('Ep  ','FREE','REAL',iEP ,n+4)
      call getmem('E0  ','FREE','REAL',iE0 ,n+4)
      call getmem('KC  ','FREE','REAL',iKC ,n*3+4)
      call getmem('Fock ','FREE','REAL',itF ,m*m+4)
      call getmem('Eig  ','FREE','REAL',iW  ,m+4  )
      call getmem('Tmp  ','FREE','REAL',itmp,lwork  )
      call getmem('tmpA','FREE','REAL',iA ,nn)
      call getmem('tmpB','FREE','REAL',iB ,nn)
      call getmem('matX','FREE','REAL',iX ,nn)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!               2004, Takashi Tsuchiya                                 *
!***********************************************************************

subroutine dFdxyz(mterm,mform,N,jp,ip,ixyz,ipf,jdrv)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: mTerm, mForm, jp, ip, ixyz, ipf, jdrv
integer(kind=iwp), intent(inout) :: N(mterm,5,mform)
integer(kind=iwp) :: i, iTerm, jTerm, nTerm

! ipf: Phase factor in integer

nterm = 2**jdrv
iterm = 0

do jterm=1,nterm

  ! downward operation
  ! (derivation of angular part)

  iterm = iterm+1
  do i=1,5
    if (i == ixyz) then
      N(iterm,ixyz,ip) = N(jterm,ixyz,jp)-1
    else
      N(iterm,i,ip) = N(jterm,i,jp)
    end if
  end do
  N(iterm,5,ip) = N(iterm,5,ip)*N(jterm,ixyz,jp)
  N(iterm,5,ip) = N(iterm,5,ip)*ipf

  ! upward operation
  ! (derivation of radial  part)

  iterm = iterm+1
  do i=1,5
    if (i == ixyz) then
      N(iterm,ixyz,ip) = N(jterm,ixyz,jp)+1
    else
      N(iterm,i,ip) = N(jterm,i,jp)
    end if
  end do
  N(iterm,4,ip) = N(iterm,4,ip)+1
  N(iterm,5,ip) = N(iterm,5,ip)*ipf
end do

end subroutine dFdxyz

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RMVERT(NLEV,NVERT,IDRT,IDOWN,NLIM,NWVERT)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='RMVERT')
#include "WrkSpc.fh"
      DIMENSION IDRT(NVERT,5),IDOWN(NVERT,0:3)
      DIMENSION NWVERT(NVERT)
      PARAMETER (LTAB=1,NTAB=2)
      DIMENSION NLIM(NLEV)
C Purpose: Remove vertices from a DRT table.

      Logical Test


      CALL GETMEM('Conn','Allo','Inte',LCONN,NVERT)
C KILL VERTICES THAT DO NOT OBEY RESTRICTIONS.
      DO IV=1,NVERT-1
        NWVERT(IV)=1
        L=IDRT(IV,LTAB)
        N=IDRT(IV,NTAB)
        IF(N.LT.NLIM(L)) NWVERT(IV)=0
      END DO
      NWVERT(NVERT)=1

C     OPEN(UNIT=10,STATUS='NEW',FILE='SGraph.ps')
C     call DRAWSG(10,NLEV,NVERT,IDRT,IDOWN,NWVERT)

  10  CONTINUE
C REMOVE ARCS HAVING A DEAD UPPER OR LOWER VERTEX.
C COUNT THE NUMBER OF ARCS REMOVED OR VERTICES KILLED.
      NCHANGES=0
      DO IV=1,NVERT-1
        IF(NWVERT(IV).EQ.0) THEN
          DO IC=0,3
            ID=IDOWN(IV,IC)
            IF(ID.GT.0) THEN
              IDOWN(IV,IC)=0
              NCHANGES=NCHANGES+1
            END IF
          END DO
        ELSE
          NLD=0
          DO IC=0,3
            ID=IDOWN(IV,IC)
            IF(ID.GT.0) THEN
              IF(NWVERT(ID).EQ.0) THEN
                IDOWN(IV,IC)=0
                NCHANGES=NCHANGES+1
              ELSE
                NLD=NLD+1
              END IF
            END IF
          END DO
          IF(NLD.EQ.0) THEN
            NWVERT(IV)=0
            NCHANGES=NCHANGES+1
          END IF
        END IF
      END DO
C ALSO CHECK ON CONNECTIONS FROM ABOVE:
      IWORK(LCONN)=NWVERT(1)
      DO IV=2,NVERT
        IWORK(LCONN-1+IV)=0
      END DO
      DO IV=1,NVERT-1
        IF(NWVERT(IV).EQ.1) THEN
          DO IC=0,3
            ID=IDOWN(IV,IC)
            Test = ID.GT.0
            If (Test) Then
               Test = NWVERT(ID).EQ.1
            End If
            IF(Test) THEN
                IWORK(LCONN-1+ID)=1
            END IF
          END DO
        END IF
      END DO
      DO IV=1,NVERT
        IF(NWVERT(IV).EQ.1 .AND. IWORK(LCONN-1+IV).EQ.0) THEN
          NWVERT(IV)=0
          NCHANGES=NCHANGES+1
        END IF
      END DO
C     call DRAWSG(10,NLEV,NVERT,IDRT,IDOWN,NWVERT)
C ANY CHANGES? RERUN.
      IF(NCHANGES.GT.0) GOTO 10
      CALL GETMEM('Conn','Free','Inte',LCONN,NVERT)
C     Close(10)

C IF NO CHANGES, THE REMAINING GRAPH IS VALID.
C EVERY VERTEX OBEYS THE RESTRICTIONS. EVERY VERTEX IS
C CONNECTED ABOVE AND BELOW (EXCEPTING THE TOP AND BOTTOM)
C TO OTHER CONFORMING VERTICES.
C THE PROCEDURE IS GUARANTEED TO FIND A STABLE SOLUTIONS,
C SINCE EACH ITERATION REMOVES ARCS AND/OR VERTICES FROM THE
C FINITE NUMBER WE STARTED WITH.
      IF(NWVERT(1).EQ.0) THEN
        WRITE(6,*)'RASSI/RMVERT: Too severe restrictions.'
        WRITE(6,*)'Not one single configuration is left.'
        CALL ABEND()
      END IF

      NV=0
      DO IV=1,NVERT
        IF(NWVERT(IV).EQ.1) THEN
          NV=NV+1
          NWVERT(IV)=NV
        END IF
      END DO
      NVERT=NV


      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1992, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine TwoEl_g(Coor,nRys,Grad,nGrad,IfGrad,IndGrd,PSO,nijkl,nPSO,Wrk2,nWrk2,iSD4)
!***********************************************************************
!                                                                      *
! Object: to generate the SO integrals for four fixed centers and      *
!         fixed basis set types.                                       *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!          Roland Lindh, Dept. of Theoretical Chemistry, University of *
!          Lund, SWEDEN. Modified to gradients, January '92.           *
!***********************************************************************

use setup, only: nAux
use Real_Spherical, only: ipSph, RSph
use Basis_Info, only: Shells
use Phase_Info, only: iPhase
use Gateway_Info, only: ChiI2
use iSD_data, only: nSD
use Gateway_global, only: IsChi
use Index_Functions, only: iTri, nTri_Elem1
use k2_structure, only: Indk2, k2_type, k2Data
use k2_arrays, only: Aux, BraKet
use Disp, only: CutGrd, l2DI
use Rys_interfaces, only: cff2d_kernel, modu2_kernel, tval1_kernel
#ifdef _DEBUGPRINT_
use Symmetry_Info, only: ChOper
#endif
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nRys, nGrad, IndGrd(3,4), nijkl, nPSO, nWrk2, iSD4(0:nSD,4)
real(kind=wp), intent(in) :: Coor(3,4), PSO(nijkl,nPSO)
real(kind=wp), intent(inout) :: Grad(nGrad)
logical(kind=iwp), intent(in) :: IfGrad(3,4)
real(kind=wp), intent(out) :: Wrk2(nWrk2)
integer(kind=iwp) :: iAnga(4), iAO(4), iAOst(4), iBasi, iC, iCar, iCent, iCmp(4), iCmpa, iDCRR(0:7), iDCRS(0:7), iDCRT(0:7), &
                     iDCRTS, iEta, iiCent, ijklab, ijMax, ijMin, ijS, ik2, ikl, IncEta, IncZet, iS, iShell(4), iShll(4), iShlla, &
                     iuvwx(4), iW2, iW3, iW4, ix1, ix2, ixSh, iy1, iy2, iz1, iz2, iZeta, jBasj, jCent, jCmpb, jjCent, jk2, &
                     JndGrd(3,4), jPrInc, jS, jShllb, kBask, kCent, kCmpc, klMax, klMin, klS, kOp(4), kS, kShllc, la, lb, lBasl, &
                     lc, lCent, lCmpd, ld, lDCR1, lDCR2, lDCRR, lDCRS, lDCRT, lEta, lPrInc, lS, lShlld, lZeta, mab, mcd, mCent, &
                     mEta, mGrad, MxDCRS, mZeta, nAlpha, nBeta, nDCR1, nDCR2, nDCRR, nDCRS, nDCRT, nDelta, nEta, nEta_Tot, nGamma, &
                     nIdent, nOp(4), nW2, nW4, nWrk3, nZeta, nZeta_Tot
real(kind=wp) :: Aha, CoorAC(3,2), CoorM(3,4), Fact
logical(kind=iwp) :: ABeqCD, AeqB, AeqC, CeqD, JfGrad(3,4), PreScr, Shijij
procedure(cff2d_kernel) :: vCff2D
procedure(modu2_kernel) :: ModU2
procedure(tval1_kernel) :: TERI1
real(kind=wp), pointer :: Coeff1(:,:), Coeff2(:,:), Coeff3(:,:), Coeff4(:,:)
type(k2_type), pointer :: k2data1(:), k2data2(:)
integer(kind=iwp), external :: NrOpr
real(kind=wp), external :: DDot_
logical(kind=iwp), external :: EQ

!                                                                      *
!***********************************************************************
!                                                                      *

jPrInc = iSD4(6,2)
lPrInc = iSD4(6,4)

iAnga(:) = iSD4(1,:)
iCmp(:) = iSD4(2,:)
iShll(:) = iSD4(0,:)
iShell(:) = iSD4(11,:)
iAO(:) = iSD4(7,:)
iAOst(:) = iSD4(8,:)

Shijij = (iSD4(11,1) == iSD4(11,3)) .and. (iSD4(11,2) == iSD4(11,4))

nAlpha = iSD4(5,1)
nBeta = iSD4(5,2)
nGamma = iSD4(5,3)
nDelta = iSD4(5,4)

iBasi = iSD4(19,1)
jBasj = iSD4(19,2)
kBask = iSD4(19,3)
lBasl = iSD4(19,4)

nZeta = nAlpha*nBeta
nEta = nGamma*nDelta
la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)
iCmpa = iCmp(1)
jCmpb = iCmp(2)
kCmpc = iCmp(3)
lCmpd = iCmp(4)
iShlla = iShll(1)
jShllb = iShll(2)
kShllc = iShll(3)
lShlld = iShll(4)
IncZet = nAlpha*jPrInc
IncEta = nGamma*lPrInc

mab = nTri_Elem1(la)*nTri_Elem1(lb)
mcd = nTri_Elem1(lc)*nTri_Elem1(ld)
iW4 = 1
if ((jPrInc /= nBeta) .or. (lPrInc /= nDelta)) then
  iW2 = 1+mab*mcd*nijkl
else
  iW2 = 1
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Pick up pointers to k2 entities.

iS = iShell(1)
jS = iShell(2)
kS = iShell(3)
lS = iShell(4)
ijS = iTri(iS,jS)
klS = iTri(kS,lS)
nDCR1 = IndK2(2,ijS)
ik2 = IndK2(3,ijS)
nDCR2 = IndK2(2,klS)
jk2 = IndK2(3,klS)
k2data1(1:nDCR1) => k2Data(1:nDCR1,ik2)
k2data2(1:nDCR2) => k2Data(1:nDCR2,jk2)

Coeff1(1:nAlpha,1:iBasi) => Shells(iShll(1))%pCff(:,iAOst(1)+1:)
Coeff2(1:nBeta,1:jBasj) => Shells(iShll(2))%pCff(:,iAOst(2)+1:)
Coeff3(1:nGamma,1:kBask) => Shells(iShll(3))%pCff(:,iAOst(3)+1:)
Coeff4(1:nDelta,1:lBasl) => Shells(iShll(4))%pCff(:,iAOst(4)+1:)

call mk_DCRs_and_Stabilizers(Fact,iuvwx,nDCRR,nDCRS,nDCRT,iDCRR,iDCRS,iDCRT,nSD,iSD4)
!                                                                      *
!***********************************************************************
!                                                                      *
nOp(1) = NrOpr(0)
CoorM(:,1) = Coor(:,1)
do lDCRR=0,nDCRR-1
  nOp(2) = NrOpr(iDCRR(lDCRR))
  call OA(iDCRR(lDCRR),Coor(:,2),CoorM(:,2))
  AeqB = EQ(CoorM(:,1),CoorM(:,2))

  MxDCRS = nDCRS-1
  do lDCRS=0,MxDCRS
    CoorM(:,3) = Coor(:,3)
    call OA(iDCRS(lDCRS),Coor(1:3,4),CoorM(1:3,4))
    CeqD = EQ(Coor(:,3),CoorM(:,4))

    do lDCRT=nDCRT-1,0,-1
#     ifdef _DEBUGPRINT_
      write(u6,'(6A)') ' R=',ChOper(iDCRR(lDCRR)),', S=',ChOper(iDCRS(lDCRS)),', T=',ChOper(iDCRT(lDCRT))
#     endif

      nOp(3) = NrOpr(iDCRT(lDCRT))
      iDCRTS = ieor(iDCRT(lDCRT),iDCRS(lDCRS))
      nOp(4) = NrOpr(iDCRTS)

      call OA(iDCRTS,Coor(:,4),CoorM(:,4))
      call OA(iDCRT(lDCRT),Coor(:,3),CoorM(:,3))

#     ifdef _DEBUGPRINT_
      call RecPrt(' CoorM in TwoEl',' ',CoorM,3,4)
#     endif
      AeqC = EQ(CoorM(:,1),CoorM(:,3))
      ABeqCD = AeqB .and. CeqD .and. AeqC
      ! No contribution to gradient from one-center integrals
      if (ABeqCD) cycle

      ! Modify which center we will differetiate with
      ! respect to using the translational invariance.

      mGrad = 0
      do iCar=1,3
        ! Copy to temporary arrays
        JfGrad(iCar,:) = IfGrad(iCar,:)
        JndGrd(iCar,:) = IndGrd(iCar,:)
        ! In case of four differentiations use
        ! the translational invariance to remove
        ! one or several of them.
        if (IfGrad(iCar,1) .and. IfGrad(iCar,2) .and. IfGrad(iCar,3) .and. IfGrad(iCar,4)) then

          nIdent = 0
          kCent = 0
          lCent = 0
          do iCent=1,3
            do jCent=iCent+1,4
              if (EQ(CoorM(1,iCent),CoorM(1,jCent))) then
                nIdent = nIdent+1
                kCent = iCent
                lCent = jCent
              end if
            end do
          end do

          ! Remove a center which is unique and if possible
          ! if it occurs several times.

          if (nIdent == 0) then
            ! Four center case, remove a center
            jCent = 1
            do iCent=1,4
              if (iAnga(iCent) /= 0) jCent = iCent
            end do
            JndGrd(iCar,jCent) = -JndGrd(iCar,jCent)
            JfGrad(iCar,jCent) = .false.
          else if (nIdent == 1) then
            ! Three center case
            iiCent = kCent
            jjCent = lCent
            JndGrd(iCar,iiCent) = 0
            JfGrad(iCar,iiCent) = .false.
            JndGrd(iCar,jjCent) = -JndGrd(iCar,jjCent)
            JfGrad(iCar,jjCent) = .false.
          else if (nIdent == 2) then
            ! Two center case
            iiCent = kCent
            jjCent = lCent
            ikl = ibset(0,kCent-1)
            ikl = ibset(ikl,lCent-1)
            do iC=4,1,-1
              if (.not. btest(ikl,iC-1)) then
                iCent = iC
                exit
              end if
            end do
            ikl = ibset(ikl,iCent-1)
            do iC=4,1,-1
              if (.not. btest(ikl,iC-1)) then
                jCent = iC
                exit
              end if
            end do
            ijMax = max(iAnga(iCent),iAnga(jCent))
            ijMin = min(iAnga(iCent),iAnga(jCent))
            klMax = max(iAnga(kCent),iAnga(lCent))
            klMin = min(iAnga(kCent),iAnga(lCent))
            if (klMin > 0) then
              iiCent = kCent
              jjCent = lCent
            else if (ijMin > 0) then
              iiCent = iCent
              jjCent = jCent
            else if (klMax > 0) then
              iiCent = kCent
              jjCent = lCent
            else if (ijMax > 0) then
              iiCent = iCent
              jjCent = jCent
            end if
            JndGrd(iCar,iiCent) = 0
            JfGrad(iCar,iiCent) = .false.
            JndGrd(iCar,jjCent) = -JndGrd(iCar,jjCent)
            JfGrad(iCar,jjCent) = .false.
          else if (nIdent == 3) then
            ! Two center case
            if (lCent /= 4) then
              mCent = 1
            else if (kCent /= 3) then
              mCent = 1
            else if (EQ(CoorM(1,1),CoorM(1,4))) then
              mCent = 1
            else
              mCent = 2
            end if
            JndGrd(iCar,mCent) = 0
            JfGrad(iCar,mCent) = .false.
            JndGrd(iCar,kCent) = 0
            JfGrad(iCar,kCent) = .false.
            JndGrd(iCar,lCent) = -JndGrd(iCar,lCent)
            JfGrad(iCar,lCent) = .false.
          else
            call WarningMessage(2,'Error in Twoel_g')
            write(u6,*) ' Twoel: nIdent too large!'
            call Abend()
          end if
        end if
        do ixSh=1,4
          if (JfGrad(iCar,ixSh)) mGrad = mGrad+1
        end do
      end do
      if (mGrad == 0) cycle

      ! Find the proper centers to start of with the angular
      ! momentum on. If la == lb there will exist an
      ! ambiguity to which center that angular momentum should
      ! be accumulated on. In that case we will use A and C of
      ! the order as defined by the basis functions types.

      if (iAnga(1) >= iAnga(2)) then
        CoorAC(:,1) = CoorM(:,1)
      else
        CoorAC(:,1) = CoorM(:,2)
      end if
      if (iAnga(3) >= iAnga(4)) then
        CoorAC(:,2) = CoorM(:,3)
      else
        CoorAC(:,2) = CoorM(:,4)
      end if
      kOp(:) = nOp(:)

      ! Desymmetrize the second order density matrix

      ! (faA fbR(B) | fcT(C) fdTS(D))ijkl

      call DesymP(iAnga,iCmp(1),iCmp(2),iCmp(3),iCmp(4),Shijij,iShll,iShell,iAO,kOp,nijkl,Aux,nAux,Wrk2(iW2),PSO,nPSO)

      if (Fact /= One) call DScal_(nijkl*iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4),Fact,Wrk2(iW2),1)

      ! Backtransform 2nd order density matrix from spherical
      ! harmonic gaussians to cartesian gaussians.

      ijklab = nijkl*iCmp(1)*iCmp(2)
      nW2 = ijklab*max(kCmpc*lCmpd,mcd)
      iW3 = iW2+nW2
      nWrk3 = nWrk2-((iW2-iW4)+nW2)
      call SphCr1(Wrk2(iW2),ijklab,Wrk2(iW3),nWrk3,RSph(ipSph(lc)),nTri_Elem1(lc),kCmpc,Shells(kShllc)%Transf, &
                  Shells(kShllc)%Prjct,RSph(ipSph(ld)),nTri_Elem1(ld),lCmpd,Shells(lShlld)%Transf,Shells(lShlld)%Prjct, &
                  Wrk2(iW2),mcd)
      if (iW2 == iW4) then
        nW2 = nijkl*mcd*max(iCmpa*jCmpb,mab)
        nW4 = 0
      else
        nW2 = nijkl*mcd*iCmpa*jCmpb
        nW4 = nijkl*mcd*mab
      end if
      iW3 = iW2+nW2
      nWrk3 = nWrk2-(nW2+nW4)
      call SphCr2(Wrk2(iW2),nijkl,mcd,Wrk2(iW3),nWrk3,RSph(ipSph(la)),nTri_Elem1(la),iCmpa,Shells(iShlla)%Transf, &
                  Shells(iShlla)%Prjct,RSph(ipSph(lb)),nTri_Elem1(lb),jCmpb,Shells(jShllb)%Transf,Shells(jShllb)%Prjct, &
                  Wrk2(iW4),mab)

      ! Transpose the 2nd order density matrix

      if (mab*mcd /= 1) then
        iW3 = iW4+nijkl*mab*mcd
        call DGetMO(Wrk2(iW4),nijkl,nijkl,mab*mcd,Wrk2(iW3),mab*mcd)
        call dcopy_(mab*mcd*nijkl,Wrk2(iW3),1,Wrk2(iW4),1)
      end if

      lDCR1 = NrOpr(iDCRR(lDCRR))+1
      lDCR2 = NrOpr(iDCRS(lDCRS))+1
      ix1 = 1
      iy1 = 1
      iz1 = 1
      ix2 = iPhase(1,iDCRT(lDCRT))
      iy2 = iPhase(2,iDCRT(lDCRT))
      iz2 = iPhase(3,iDCRT(lDCRT))

      nZeta_Tot = k2Data1(lDCR1)%IndZ(nZeta+1)
      nEta_Tot = k2Data2(lDCR2)%IndZ(nEta+1)

      ! Loops to partition the primitives

      do iZeta=1,nZeta_Tot,IncZet
        mZeta = min(IncZet,nZeta_Tot-iZeta+1)
        if (all(Coeff2(:,:) == Zero)) cycle

        do iEta=1,nEta_Tot,IncEta
          mEta = min(IncEta,nEta_Tot-iEta+1)
          if (all(Coeff4(:,:) == Zero)) cycle

          ! Preprescreen

          call PrePre_g(mZeta,mEta,lZeta,lEta,PreScr,CutGrd,iZeta-1,iEta-1,k2Data1(lDCR1),k2Data2(lDCR2))
          if (lZeta*lEta == 0) cycle

          ! Decontract the 2nd order density matrix

          if (iW4 == iW2) then
            nW4 = 0
            nW2 = max(nijkl,mZeta*mEta)*mab*mcd
          else
            nW4 = nijkl*mab*mcd
            nW2 = mZeta*mEta*mab*mcd
          end if
          iW3 = iW2+nW2
          nWrk3 = nWrk2-(nW4+nW2)
          call Tcrtnc(Coeff1,nAlpha,iBasi,Coeff2,nBeta,jBasj,Coeff3,nGamma,kBask,Coeff4,nDelta,lBasl, &
                      Wrk2(iW4),mab*mcd,Wrk2(iW3),nWrk3,Wrk2(iW2), &
                      k2Data1(lDCR1)%IndZ(iZeta:iZeta+mZeta-1),mZeta, &
                      k2Data2(lDCR2)%IndZ(iEta:iEta+mEta-1),mEta)

          ! Transfer k2 data and prescreen

          iW3 = iW2+mZeta*mEta*mab*mcd
          nWrk3 = nWrk2-mZeta*mEta*mab*mcd
          call Screen_g(iZeta-1,iEta-1,Wrk2(iW2),Wrk2(iW3),mab*mcd,nZeta,nEta,mZeta,mEta,lZeta,lEta, &
                        k2Data1(lDCR1),k2Data2(lDCR2), &
                        Braket%Zeta,Braket%ZInv,Braket%P,Braket%xA,Braket%xB, &
                        Braket%Eta,Braket%EInv,Braket%Q,Braket%xG,Braket%xD, &
                        ix1,iy1,iz1,ix2,iy2,iz2,CutGrd,l2DI, &
                        PreScr,nWrk3,IsChi,ChiI2)
          if (lZeta*lEta == 0) cycle

          ! Compute integral derivative and accumulate
          ! contribution to the molecular gradient. Note that
          ! the PSO matrix now is stored in Wrk2(iW2).

          iW3 = iW2+lZeta*lEta*mab*mcd
          call Rysg1(iAnga,nRys,lZeta*lEta,BraKet%xA,BraKet%xB,BraKet%xG,BraKet%xD, &
                     BraKet%Zeta,BraKet%ZInv,lZeta,BraKet%Eta,BraKet%EInv,lEta, &
                     BraKet%P,nZeta,BraKet%Q,nEta,CoorM,CoorM,CoorAC, &
                     Wrk2(iW3),nWrk3,TERI1,ModU2,vCff2D,Wrk2(iW2),mab*mcd,Grad,nGrad,JfGrad,JndGrd,kOp,iuvwx)
          Aha = sqrt(DDot_(nGrad,Grad,1,Grad,1))
          if (Aha > 1.0e5_wp) then
            write(u6,*) 'Norm of gradient contribution is huge!'
            write(u6,*) 'Probably due to wrong coordinates.'
          end if

        end do
      end do

#     ifdef _DEBUGPRINT_
      call PrGrad(' In TwoEl',Grad,nGrad)
#     endif

    end do
  end do
end do

end subroutine TwoEl_g

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Per-Olof Widmark                                 *
!               2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

function iMostAbundantIsotope(Z)
!***********************************************************************
!                                                                      *
! Routine: iMostAbundantIsotope                                        *
! Purpose: The mass number for the most abundant isotope of the atom   *
!          with charge Z is returned. For radioactive atoms, the       *
!          most stable isotope is returned.                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University, Sweden.                                    *
! Written: March 2000                                                  *
! History: March 2017, use isotopes module, Ignacio Fdez. Galvan       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Algorithm: The nuclear mass number is tabulated for most charges.    *
!            For Z=0, A=1 is returned, corresponding to a neutron.     *
!            For untabulated Z, A=176+Z.                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Arguments:                                                           *
! Z   - The nuclear charge for which the nuclear mass number is        *
!       returned.                                                      *
!                                                                      *
!***********************************************************************

use isotopes, only: Initialize_Isotopes, ElementList, MaxAtomNum
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iMostAbundantIsotope
integer(kind=iwp), intent(in) :: Z
integer(kind=iwp) :: A

!----------------------------------------------------------------------*
! Compute A.                                                           *
!----------------------------------------------------------------------*
call Initialize_Isotopes()
if (Z < 0) then
  write(u6,'(a)') '***'
  write(u6,'(a)') '*** iMostAbundantIsotope: error'
  write(u6,'(a)') '***    Charge less than zero!'
  write(u6,'(a)') '***'
  A = 1
else if (Z == 0) then
  A = 1
else if (Z > MaxAtomNum) then
  A = 176+Z
else
  A = ElementList(Z)%Isotopes(1)%A
end if
!----------------------------------------------------------------------*
! Done.                                                                *
!----------------------------------------------------------------------*
iMostAbundantIsotope = A

return

end function iMostAbundantIsotope

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DNDOT(N,M,S,INCS,ISW,X,INCXI,INCXO,Y,INCYI,INCYO)
C
C     COMPUTE DOT PRODUCT N TIMES
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 S(1+(N-1)*INCS),
     1       X((1+(M-1)*INCXI)*(1+(N-1)*INCXO)),
     2       Y((1+(M-1)*INCYI)*(1+(N-1)*INCYO))
      IF (ISW.EQ.1) THEN
         DO 10 I = 1, N
            S(1+(I-1)*INCS) = DDOT_(M,X(1+(I-1)*INCXO),INCXI,
     1                               Y(1+(I-1)*INCYO),INCYI)
   10    CONTINUE
      ELSE IF (ISW.EQ.2) THEN
         DO 20 I = 1, N
            S(1+(I-1)*INCS) =-DDOT_(M,X(1+(I-1)*INCXO),INCXI,
     1                               Y(1+(I-1)*INCYO),INCYI)
   20    CONTINUE
      ELSE IF (ISW.EQ.3) THEN
         DO 30 I = 1, N
            S(1+(I-1)*INCS) = S(1+(I-1)*INCS) +
     1                        DDOT_(M,X(1+(I-1)*INCXO),INCXI,
     2                               Y(1+(I-1)*INCYO),INCYI)
   30    CONTINUE
      ELSE IF (ISW.EQ.4) THEN
         DO 40 I = 1, N
            S(1+(I-1)*INCS) = S(1+(I-1)*INCS) -
     1                        DDOT_(M,X(1+(I-1)*INCXO),INCXI,
     2                               Y(1+(I-1)*INCYO),INCYI)
   40    CONTINUE
      ELSE
         Call SysAbendMsg('dndot','ISW IS OUT OF RANGE IN DNDOT',' ')
      END IF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE INT7(I,K,L,IDIAG,BUFOUT,INDOUT,ICAD,IBUFL,
     *KBUF,NTPB)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
      DIMENSION BUFOUT(*),INDOUT(*),ICAD(*),IBUFL(*)
C     I.LT.L  I.EQ.K  J.EQ.L
#include "real_guga.fh"
#include "integ.fh"
#include "files_guga.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
      COMMON/D/JNDX(500 000)
*
      IJJ=0 ! dummy initialize
      KBUF0=RTOI*KBUF
      KBUF1=KBUF0+KBUF+1
      KBUF2=KBUF1+1
      IDIV=RTOI
      ITYP=0
      IF(IDIAG.EQ.1)IJJ=L*(L-1)/2+K
      LJS=IJ(L+1)+1
      LJM=IJ(L)
      DO 100 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      DO 10 LJ=LJS,LJM
      ITURN=0
      IF(IDIAG.EQ.1)ITURN=1
33    IWAY(L)=1
32    KM=L
      J2(KM+1)=LJ
      J1(KM+1)=LJ
      JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      IF(ITURN.EQ.0)CALL LOOP7(KM,ISTOP,IT1,IT2)
      IF(ITURN.EQ.1)CALL LOOP8(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 54
      IF(IDIAG.EQ.1.AND.J1(KM).NE.J2(KM))GO TO 32
      GO TO 53
54    IF(ITURN.EQ.1)GO TO 10
      ITURN=1
      GO TO 33
53    KM=KM-1
      IWAY(KM)=1
      IF(KM.EQ.I)GO TO 71
62    JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      IF(ITURN.EQ.0)CALL LOOP17(KM,ISTOP,IT1,IT2)
      IF(ITURN.EQ.1)CALL LOOP21(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 55
      IF(IDIAG.EQ.1.AND.J1(KM).NE.J2(KM))GO TO 62
      GO TO 53
55    KM=KM+1
      IF(KM.EQ.L)GO TO 32
      GO TO 62
71    KM=I
      IF(ITURN.EQ.0)CALL LOOP14(KM,ISTOP,IT1,IT2)
      IF(ITURN.EQ.1)CALL LOOP18(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 73
      IF(ABS(COUP(I)).LT.1.D-06)GO TO 71
      IF(IDIAG.EQ.0)GO TO 105
      IF(ICOUP1(I).NE.ICOUP(I))GO TO 71
      GO TO 106
105   IF(ITURN.EQ.0.OR.IWAY(L).EQ.5)GO TO 106
      IF(ICOUP1(I).LT.ICOUP(I))GO TO 71
      IF(ICOUP1(I).EQ.ICOUP(I))GO TO 71
106   IF(ITURN.EQ.0)COUP(I)=COUP(I)/D2
      IF(IDIAG.EQ.1)GO TO 25
      CALL COMP(I,LJ,ITYP,I,IT1,IT2)
      GO TO 71
25    KM=KM-1
      IF(KM.EQ.0)GO TO 26
      IWAY(KM)=1
27    CALL PATH(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 25
      KM=KM+1
      IF(KM.EQ.I)GO TO 71
      GO TO 27
26    IVL=J2(1)
      ITAIL=IX(IT1+LJ)
      ISUM=IV0-IVL
      ISU=0
      IF(ISUM.NE.0)ISU=IRC(ISUM)
      DO 104 IN=1,ITAIL
        JND1=JNDX(ISU+ICOUP(1)+IN)
        IF(JND1.EQ.0)GO TO 104
        IPOS=(JND1-1)*LNP+IJJ
        NBN=(IPOS-1)/NTPB+1
        IBUFL(NBN)=IBUFL(NBN)+1
        ICQ=ICAD(NBN)
        ICP=ICQ/IDIV+IBUFL(NBN)
        BUFOUT(ICP)=COUP(I)
        ICPP=ICQ+KBUF0+IBUFL(NBN)
        INDOUT(ICPP)=IPOS
        IF(IBUFL(NBN).LT.KBUF)GO TO 104
        INDOUT(ICQ+KBUF1)=KBUF
        IAD110=IADD11
        CALL iDAFILE(Lu_11,1,INDOUT(ICQ+1),KBUF2,IADD11)
        INDOUT(ICQ+KBUF2)=IAD110
        IBUFL(NBN)=0
104   CONTINUE
      IF(I.EQ.1)GO TO 71
      KM=1
      GO TO 27
73    KM=KM+1
      IF(KM.EQ.L)GO TO 32
      GO TO 62
10    CONTINUE
100   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine VVVOX(NSYM,NBAS,NFRO,KEEP,iSymI,iSymJ,iSymK,iSymL,NBMX,T2AO,vLag,CMO,nOcc,nBasT,LBUF,X1,X2,WRK,DPT2AO,DPT2CAO,FPT2AO, &
                 FPT2CAO,DIA,DI,FIFA,FIMO)

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSYM, NBAS(8), NFRO(8), KEEP(8), iSymI, iSymJ, iSymK, iSymL, NBMX, nOcc, nBasT, LBUF
real(kind=wp), intent(in) :: T2AO(nOcc,nBasT,nOcc,nBasT), CMO(nBasT,nBasT), DPT2AO(nBasT**2), DPT2CAO(nBasT**2), DIA(nBasT**2), &
                             DI(nBasT**2)
real(kind=wp), intent(inout) :: vLag(nBasT,nBasT), X1(LBUF), X2(NBMX*NBMX), WRK(nBasT**2), FPT2AO(nBasT**2), FPT2CAO(nBasT**2), &
                                FIFA(nBasT**2), FIMO(nBasT**2)
integer(kind=iwp) :: IOPT, IP, IPQ, IRC, iSMax, ISTLT(8), ISTSQ(8), ISX, iSym, iSymIJ, iSymL_, JQ, KEEPI, KEEPJ, KEEPK, KEEPL, &
                     LPQ, nB, nB2, nB3, nBasI, nBasIJ, nBasJ, nBasK, nBasKL, nBasL, nFroT, NPQ

ISTSQ(1) = 0
ISTLT(1) = 0
do iSym=2,nSym
  nB = nBas(iSym-1)
  nB2 = nB**2
  nB3 = nTri_Elem(nB)
  ISTSQ(iSym) = ISTSQ(iSym-1)+nB2
  ISTLT(iSym) = ISTLT(iSym-1)+nB3
end do
nFroT = sum(nFro(1:nSym))

nBasI = nBas(iSymI)
KEEPI = KEEP(iSymI)
!nAuxI = nAux(iSymI)
nBasJ = nBas(iSymJ)
KEEPJ = KEEP(iSymJ)
!nAuxJ = nAux(iSymJ)
iSymIJ = Mul(iSymI,iSymJ)
nBasIJ = nBasI*nBasJ
if (iSymI == iSymJ) nBasIJ = nTri_Elem(nBasI)
if (nBasIJ == 0) return

nBasK = nBas(iSymK)
KEEPK = KEEP(iSymK)
!nAuxK = nAux(iSymK)
iSMax = iSymK
if (iSymK == iSymI) iSMax = iSymJ
iSymL_ = Mul(iSymIJ,iSymK)
if (iSymL_ > iSMax) return !! should not
nBasL = nBas(iSymL_)
KEEPL = KEEP(iSymL_)
!nAuxL = nAux(iSymL_)
nBasKL = nBasK*nBasL
if (iSymK == iSymL_) nBasKL = nTri_Elem(nBasK)
if (nBasKL == 0) return

! INTEGRAL BLOCK EXCLUDED BY SETTING KEEP PARAMETERS?
if (KEEPI+KEEPJ+KEEPK+KEEPL /= 0) return
!! This will not work when the number of the inactive orbital is 0
!if (nAuxI+nAuxJ+nAuxK+nAuxL == 0) return ! frozen orbitals

!! (ij|kl)
if ((iSymI == iSymJ) .and. (iSymI == iSymK)) then
  IOPT = 1
  LPQ = 0
  IPQ = 0
  NPQ = 0
  do IP=1,nBasI
    do JQ=1,IP
      IPQ = IPQ+1
      LPQ = LPQ+1
      if (IPQ > NPQ) then
        call RDORD(IRC,IOPT,iSymI,iSymJ,iSymK,iSymL,X1,LBUF,NPQ)
        if (IRC > 1) then
          write(u6,*) ' Error return code IRC=',IRC
          write(u6,*) ' from RDORD call, in FTWOI.'
          call Abend()
        end if
        IOPT = 2
        IPQ = 1
      end if
      ISX = (IPQ-1)*nBasKL+1
      !ISF = ISTLT(iSymI)+LPQ
      !ISD = ISTLT(iSymI)+1
      !! coulomb
      !TEMP = DDOT_(KLB,X1(ISX),1,DLT(ISD),1)
      !FLT(ISF) = FLT(ISF)+TEMP
      !! exchange
      !! f_{ik} = (ij|kl)*D_{jl}
      !! read (ij|kl) for given ij as (kl)
      !! first  dgemv: (kl)*D_{l,i} -> f_{ki}
      !! second dgemv: (kl)*D_{l,i} -> f_{ki}

      !! For (mu nu), read (mu nu|rho sigma) as I(rho sigma)
      !! (mu j|rho sigma) = sum_{nu} C_{nu j} (mu nu|rho sigma)

      !! L_{mu i} = T_{ij}^{mu nu} * (mu rho | j sigma)
      !!          = T_{ij}^{rho sigma} * C_{nu j}
      !!                 * (mu rho | nu sigma)

      !! IP = mu, JQ = rho
      !! X2 = (nu sigma) --> X2' = C_{nu j}*(nu sigma) = (j sigma)
      !! T_{ij}^{rho sigma} * (j sigma)
      !!   -> U_{i rho} for (mu, rho) pairs

      call SQUARE(X1(ISX),X2(1),1,nBasK,nBasL)
      !if (DoCholesky) then
      !else
      !! (mu(ip) rho(jq) | nu sigma) -> (mu(ip) rho(jq) | j sigma)
      call dgemm_('T','N',nOcc,nBasT,nBasT,One,CMO,nBasT,X2,nBasT,Zero,WRK,nOcc)
      !! wrk(j,sigma) for the given mu(ip), mu(jq)
      !! T2AO(j,sigma,i,rho) = T_{ij}^{rho sigma}
      !! rather than L_{mu i}, L_{i mu} is computed
      !! L_{i mu} = wrk(j,sigma)*(T2AO(j,sigma,i,rho)
      call dgemv_('t',nOcc*nBasT,nOcc,One,t2ao(1,1,1,jq),nOcc*nBasT,wrk,1,One,vlag(1,ip),1)
      if (ip /= jq) then
        call dgemv_('t',nOcc*nBasT,nOcc,One,t2ao(1,1,1,ip),nOcc*nBasT,wrk,1,One,vlag(1,jq),1)
        !call dgemm_('T','T',nOcc,nBasT,nBasT,One,CMO,nBasT,X2,nBasT,One,WRK,nOcc)
        !call dgemv_('n',nOcc*nBasT,nOcc,One,t2ao(1,ip,1,1),nOcc*nBasT,wrk,1,One,vlag(1,jq),1)
      end if
      !end if

      !! DPT2AO -> FPT2AO transformation
      !! FPT2 = G(DPT2)
      call FDGTRF(DPT2AO,FPT2AO)
      call FDGTRF(DPT2CAO,FPT2CAO)
      if (nFroT /= 0) then
        call FDGTRF(DIA,FIFA)
        call FDGTRF(DI,FIMO)
      end if
      !! Coulomb
      !Val = DDot_(nBasK*nBasL,X2,1,DPT2AO(ISTSQ(iSymI)+1),1)
      !iSF = ISTSQ(iSYmI)+iP+nBasI*(jQ-1)
      !FPT2AO(iSF) = FPT2AO(iSF)+Val
      !!! Exchange
      !iSF = ISTSQ(iSymI)+(jQ-1)*nBasJ+1
      !iSD = ISTSQ(iSymI)+(iP-1)*nBasI+1
      !call DGEMV_('N',nBasK,nBasL,-Half,X2,nBasK,DPT2AO(iSD),1,One,FPT2AO(iSF),1)
      !if (iP /= jQ) then
      !  iSF = ISTSQ(iSymI)+jQ+nBasJ*(iP-1)
      !  FPT2AO(iSF) = FPT2AO(iSF)+Val
      !  iSF = ISTSQ(iSymI)+(iP-1)*nBasI+1
      !  iSD = ISTSQ(iSymI)+(jQ-1)*nBasJ+1
      !  call DGEMV_('N',nBasK,nBasL,-Half,X2,nBasK,DPT2AO(iSD),1,One,FPT2AO(iSF),1)
      !end if

      !!! DPT2CAO -> FPT2CAO transformation
      !!! Coulomb
      !Val = DDot_(nBasK*nBasL,X2,1,DPT2CAO(ISTSQ(iSymI)+1),1)
      !iSF = ISTSQ(iSYmI)+iP+nBasI*(jQ-1)
      !FPT2CAO(iSF) = FPT2CAO(iSF)+Val
      !!! Exchange
      !iSF = ISTSQ(iSymI)+(jQ-1)*nBasJ+1
      !iSD = ISTSQ(iSymI)+(iP-1)*nBasI+1
      !call DGEMV_('N',nBasK,nBasL,-Half,X2,nBasK,DPT2CAO(iSD),1,One,FPT2CAO(iSF),1)
      !if (iP /= jQ) then
      !  iSF = ISTSQ(iSymI)+jQ+nBasJ*(iP-1)
      !  FPT2CAO(iSF) = FPT2CAO(iSF)+Val
      !  iSF = ISTSQ(iSymI)+(iP-1)*nBasI+1
      !  iSD = ISTSQ(iSymI)+(jQ-1)*nBasJ+1
      !  call DGEMV_('N',nBasK,nBasL,-Half,X2,nBasK,DPT2CAO(iSD),1,One,FPT2CAO(iSF),1)
      !end if
    end do
  end do
end if

!else if ((IS == JS) .and. (IS /= KS)) then
!  ! CASE 2: Integrals are of symmetry type (II/JJ)
!  ! Coulomb terms need to be accumulated only
!else if ((IS == KS) .and. (JS == LS)) then
!  ! CASE 3: Integrals are of symmetry type (IJ/IJ)
!  ! Exchange terms need to be accumulated only
!  IOPT = 1
!  LPQ = 0
!  IPQ = 0
!  NPQ = 0
!  do IP=1,IB
!    do JQ=1,JB
!      IPQ = IPQ+1
!      LPQ = LPQ+1
!      if (IPQ > NPQ) then
!        call RDORD(IRC,IOPT,IS,JS,KS,LS,X1,LBUF,NPQ)
!        if (IRC > 1) then
!          write(u6,*) ' Error return code IRC=',IRC
!          write(u6,*) ' from RDORD call, in FTWOI.'
!          call Abend()
!        end if
!        IOPT = 2
!        IPQ = 1
!      end if
!      ISX = (IPQ-1)*KLB+1
!      if (NFI /= 0) then
!        ISD = ISTSQ(IS)+(IP-1)*IB+1
!        ISF = ISTSQ(JS)+(JQ-1)*JB+1
!        call DGEMV_('N',LB,KB,(-Half*ExFac),X1(ISX),LB,DSQ(ISD),1,One,FSQ(ISF),1)
!      end if
!      if (NFJ /= 0) then
!        ISD = ISTSQ(JS)+(JQ-1)*JB+1
!        ISF = ISTSQ(IS)+(IP-1)*IB+1
!        call DGEMV_('T',LB,KB,(-Half*ExFac),X1(ISX),LB,DSQ(ISD),1,One,FSQ(ISF),1)
!      end if
!    end do
!  end do
!end if

return

contains

subroutine FDGTRF(DD,FF)

  real(kind=wp), intent(in) :: DD(nBasT**2)
  real(kind=wp), intent(inout) :: FF(nBasT**2)
  integer(kind=iwp) :: iSD, iSF
  real(kind=wp) :: Val
  real(kind=wp), external :: ddot_

  !! Coulomb
  Val = DDot_(nBasK*nBasL,X2,1,DD(ISTSQ(iSymI)+1),1)
  iSF = ISTSQ(iSYmI)+iP+nBasI*(jQ-1)
  FF(iSF) = FF(iSF)+Val

  !! Exchange
  iSF = ISTSQ(iSymI)+(jQ-1)*nBasJ+1
  iSD = ISTSQ(iSymI)+(iP-1)*nBasI+1
  call DGEMV_('N',nBasK,nBasL,-Half,X2,nBasK,DD(iSD),1,One,FF(iSF),1)
  if (iP /= jQ) then
    iSF = ISTSQ(iSymI)+jQ+nBasJ*(iP-1)
    FF(iSF) = FF(iSF)+Val
    iSF = ISTSQ(iSymI)+(iP-1)*nBasI+1
    iSD = ISTSQ(iSymI)+(jQ-1)*nBasJ+1
    call DGEMV_('N',nBasK,nBasL,-Half,X2,nBasK,DD(iSD),1,One,FF(iSF),1)
  end if

end subroutine FDGTRF

end subroutine VVVOX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MMSort(A,B,ldisp1)

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: lDisp
use input_mclr, only: nSym, nTPert
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: A(*)
real(kind=wp), intent(_OUT_) :: B(*)
integer(kind=iwp), intent(out) :: ldisp1(nsym)
integer(kind=iwp) :: iDisp, iG, iii, ijD, ijD1, ijG, ijG1, iSym, jDisp, jG
logical(kind=iwp) :: geomi, geomj

ijG = 0
ijD = 0
iii = 0
ldisp1(:) = 0
do iSym=1,nsym
  iG = 0
  do idisp=1,ldisp(isym)
    geomi = btest(ntpert(iii+idisp),4)
    if (geomi) then
      ldisp1(isym) = ldisp1(isym)+1
      iG = iG+1
      jG = 0
      do jdisp=1,idisp
        geomj = btest(ntpert(jdisp+iii),4)
        if (geomj) then
          jG = jG+1
          ijg1 = ijG+iTri(ig,jg)
          ijd1 = ijD+iTri(idisp,jdisp)
          B(ijG1) = A(ijD1)
        end if
      end do
    end if
  end do
  ijG = ijG+nTri_Elem(iG)
  ijD = ijD+nTri_Elem(ldisp(isym))
  iii = iii+ldisp(isym)
end do

end subroutine MMSort

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NEMO_Opt1()

use Basis_Info, only: dbsc, nBas, nCnttp, Shells
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, OneHalf
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
#include "warnings.h"
#include "rinfo.fh"
#include "print.fh"
integer(kind=iwp) :: nBas_Prim(0:7), nBas_cont(0:7), lOper(3), ip(3), iSml(3), Length(1), n_int(1), i, iAngr, iBas, icnt, iCnttp, &
                     iComp, idbg, iExp, iip, iMltPl, iOpt, iPrint, iRC, iRout, iSmLbl, jExp, kAng, kC, kCof, kCofi, kCofj, kExp, &
                     kExpi, kExpj, kSh, kShEnd, kShStr, L, lSh, Lu_One, nComp, nInt_Tot, nip, nLength_Tot, nSym
real(kind=wp) :: rCofi, rCofj, rExpi, rExpj, rI, rNorm, rSum
character(len=8) Label
integer(kind=iwp), allocatable :: ipMP(:), iSm(:)
real(kind=wp), allocatable :: P_Matrix(:), MP_Matrix(:)
integer(kind=iwp), parameter :: MxMltPl = 10

iRout = 77
iPrint = nPrint(iRout)
!                                                                      *
!***********************************************************************
!                                                                      *
! Save basis set info from contracted run

if (iprint >= 10) write(u6,*) ' In NEMO_Opt1',ncnttp
kCof = 0
kAng = 0
kExp = 0
kC = 0

call mma_allocate(ipMP,(MxMltPl+1)*(MxMltPl+2)*(MxMltPl+3)/6,label='ipMP')
call mma_allocate(iSm,(MxMltPl+1)*(MxMltPl+2)*(MxMltPl+3)/6,label='iSm')

! Normalize coefficients

do iCnttp=1,nCnttp

  !-- Make a check that no cartesian d or higher have been used.
  !   The reason for this restriction is found in tr_prm_cnt.
  !   If that routine is generalized, then remove this check.

  lSh = 0
  kShStr = dbsc(iCnttp)%iVal
  kShEnd = dbsc(iCnttp)%iVal+dbsc(iCnttp)%nVal-1
  do kSh=kShStr,kShEnd
    if ((.not. Shells(kSh)%Transf) .and. (lSh >= 2)) then
      call WarningMessage(2,'   NEMO Error')
      write(u6,*)
      write(u6,*)
      write(u6,*) 'Error! The NEMO keyword does not work with cartesian d-functions or higher.'
      write(u6,*) 'Request spherical functions to proceed.'
      write(u6,*)
      write(u6,*)
      call Quit(_RC_INPUT_ERROR_)
    end if
    lSh = lSh+1
  end do

  !-- End check.

  do icnt=1,dbsc(iCnttp)%nCntr
    kC = kC+1
    !do iAngr=0,nAngr(icnt)
    do iAngr=0,nAngr(kC)
      !rI = iAngr+One+Half
      rI = real(iAngr,kind=wp)+OneHalf
      kAng = kAng+1
      do iBas=1,nBasisr(kAng)
        rSum = Zero
        kExpi = kExp
        kCofi = kCof
        do iExp=1,nPrimr(kAng)
          kExpi = kExpi+1
          kCofi = kCofi+1
          rExpi = rExp(kExpi)
          !write(u6,'(a11,f20.8)') ' Exponents',rExpi
          rCofi = rCof(kCofi)
          kExpj = kExp
          kCofj = kCof
          do jExp=1,nPrimr(kAng)
            kExpj = kExpj+1
            kCofj = kCofj+1
            rExpj = rExp(kExpj)
            rCofj = rCof(kCofj)
            rSum = rSum+rCofi*rCofj*(Two*sqrt(rExpi*rExpj)/(rExpi+rExpj))**rI
          end do
        end do
        rNorm = One/sqrt(rSum)
        if (iprint >= 10) write(u6,*) ' rNorm',kAng,rNorm
        do iExp=1,nPrimr(kAng)
          rCof(kCof+iExp) = rCof(kCof+iExp)*rNorm
          if (iprint >= 10) then
            write(u6,'(a24,f20.6)') ' normalized coefficients',rCof(kCof+iExp)
          end if
        end do
        kCof = kCof+nPrimr(kAng)
      end do
      kExp = kExp+nPrimr(kAng)
    end do
  end do
end do

if (iPrint >= 10) then
  i = 0
  do L=1,nrSym
    write(u6,*) ' Irreducible representation',L
    do ibas=1,nrBas(L)
      i = i+1
      write(u6,'(20i4)') i,icent(i),lnang(i),lmag(i)
    end do
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Close ONEINT and re-open ONEREL

nBas_Cont(:) = nBas

nSym = nIrrep
iOpt = 0
call ClsOne(iRC,iOpt)
iOpt = 0
iRC = -1
Lu_One = 2
call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
if (iRC /= 0) call error()

call OneBas('PRIM')
call Get_iArray('nBas_Prim',nBas_Prim,nIrrep)

if (iPrint >= 10) then
  write(u6,'(a,8i5)') ' Symmetries          ',nSym
  write(u6,'(a,8i5)') ' Primitive basis fcns',(nBas_Prim(i),i=0,nSym-1)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Read P_Matrix from ONEREL

nComp = 3
nLength_Tot = 0
do iComp=1,nComp
  iOpt = 1
  iRC = -1
  call iRdOne(iRC,iOpt,'P_matrix',iComp,Length,iSmLbl)
  if (iRC /= 0) then
    call WarningMessage(2,'Error reading length of P-Matrix')
    write(u6,*) 'iComp=',iComp
    call Abend()
  end if
  iSml(iComp) = iSmLbl
  lOper(iComp) = 1
  ip(iComp) = 1+nLength_Tot
  nLength_Tot = nLength_Tot+Length(1)+4
end do

call mma_allocate(P_Matrix,nLength_Tot,label='P_Matrix')
call FZero(P_Matrix,nLength_Tot)

do iComp=1,nComp
  iOpt = 0
  iRC = -1
  iSmLbl = iSml(iComp)
  ip(iComp) = ip(iComp)
  call RdOne(iRC,iOpt,'P_matrix',iComp,P_Matrix(ip(iComp)),iSmLbl)
  if (iRC /= 0) then
    call WarningMessage(2,'Error reading P-Matrix')
    write(u6,*) 'iComp=',iComp
    call Abend()
  end if
end do
if (iPrint >= 10) call PrMtrx('P_matrix',lOper,nComp,ip,P_Matrix)
!                                                                      *
!***********************************************************************
!                                                                      *
! Read multipole integrals from ONEREL

nip = 0
nInt_Tot = 0
outer1: do iMltPl=0,MxMltPl
  write(Label,'(a,i2)') 'MLTPL ',iMltPl
  nComp = (iMltPl+1)*(iMltPl+2)/2
  do iComp=1,nComp
    iRC = -1
    iOpt = 1
    n_Int = 0
    call iRdOne(iRC,iOpt,Label,iComp,n_Int,iSmLbl)
    if (iRC /= 0) then
      if (iComp /= 1) then
        call WarningMessage(2,' Error reading length!')
        write(u6,*) ' Label=',Label,' Comp=',iComp
        call Abend()
      end if
      exit outer1
    end if
    nip = nip+1
    iSm(nip) = iSmLbl
    ipMP(nip) = 1+nInt_Tot
    nInt_Tot = nInt_Tot+n_int(1)+4
  end do
end do outer1

call mma_allocate(MP_Matrix,nInt_Tot,label='MP_Matrix')

iip = 0
outer2: do iMltPl=0,MxMltPl
  write(Label,'(a,i2)') 'MLTPL ',iMltPl
  nComp = (iMltPl+1)*(iMltPl+2)/2
  do iComp=1,nComp
    iip = iip+1
    if (iip > nip) exit outer2
    iRC = -1
    iOpt = 0
    ipMP(iip) = ipMP(iip)
    iSmLbl = iSm(iip)
    call RdOne(iRC,iOpt,Label,iComp,MP_Matrix(ipMP(iip)),iSmLbl)
    if (iRC /= 0) then
      call WarningMessage(2,' Error reading integrals!')
      write(u6,*) ' Label=',Label,' Comp=',iComp
      call Abend()
    end if
  end do
end do outer2
!                                                                      *
!***********************************************************************
!                                                                      *
! Close ONEREL and re-open ONEINT

iOpt = 0
iRC = -1
call ClsOne(iRC,iOpt)
if (iRC /= 0) call error()
iOpt = 0
iRC = -1
Lu_One = 2
call OpnOne(iRC,iOpt,'ONEINT',Lu_One)
if (iRC /= 0) call error()

call OneBas('PRIM')
!                                                                      *
!***********************************************************************
!                                                                      *
! Put the transformation matrix on RUNFILE

idbg = 0
call tr_prm_cnt(idbg,nBas_Cont,nBas_Prim)
!                                                                      *
!***********************************************************************
!                                                                      *
! Process the P-matrix

nComp = 3
iOpt = 0
do iComp=1,nComp
  iRC = -1
  call WrOne(iRC,iOpt,'P_matrix',iComp,P_Matrix(ip(iComp)),iSml(iComp))
  if (iRC /= 0) then
    call WarningMessage(2,'Error reading P-Matrix')
    write(u6,*) 'iComp=',iComp
    call Abend()
  end if
end do
call mma_deallocate(P_Matrix)
!                                                                      *
!***********************************************************************
!                                                                      *
! Process multipole integrals

iip = 0
outer3: do iMltPl=0,MxMltPl
  write(Label,'(a,i2)') 'PLTPL ',iMltpl
  nComp = (iMltpl+1)*(iMltpl+2)/2
  do iComp=1,nComp
    iip = iip+1
    if (iip > nip) exit outer3
    iRC = -1
    iOpt = 0
    call WrOne(iRC,iOpt,Label,iComp,MP_Matrix(ipMP(iip)),iSm(iip))
    if (iRC /= 0) then
      call WarningMessage(2,' Error writing integrals!')
      write(u6,*) ' Label=',Label,' Comp=',iComp
      call Abend()
    end if
  end do
end do outer3
call mma_deallocate(MP_Matrix)
call mma_deallocate(ipMP)
call mma_deallocate(iSm)
!                                                                      *
!***********************************************************************
!                                                                      *
! And now change it back!

call OneBas('CONT')
!                                                                      *
!***********************************************************************
!                                                                      *
return

contains

subroutine error()
  call WarningMessage(2,' *** Error in subroutine NEMO_Opt1 ***;     Abend in subroutine OpnOne or ClsOne')
  call Abend()
end subroutine

end subroutine NEMO_Opt1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine restart_sa( input_to_read, input_file_name,
     &                        nss, nstate )

       Implicit None
       Integer        :: nss, nstate, input_to_read, iDisk
       Integer        :: luaniso
       Character(Len=180) :: input_file_name
       Integer        :: IsFreeUnit
       External       :: IsFreeUnit
       Logical        :: dbg
       dbg=.false.


       If ( input_to_read .eq. 1 ) Then
          ! read the binary file "$Project.aniso":
          luaniso=8
          Call daname(luaniso,'POLYFILE')
          iDisk=0
          Call idafile(luaniso,2,nstate,1,iDisk)
          Call idafile(luaniso,2,nss,1,iDisk)
          Call daclos(luaniso)
          ! put them on RunFile:
          Call Put_iScalar('NSTATE_SINGLE   ',nstate)
          Call Put_iScalar('NSS_SINGLE      ',nss)
          Call Put_iScalar('MXJOB_SINGLE    ',1)
          Call Put_iScalar('NJOB_SINGLE     ',1)



       Else If ( (input_to_read .eq. 2) .OR.
     &           (input_to_read .eq. 4) ) Then
          ! read the ascii formatted "aniso.input" file:
          luaniso = IsFreeUnit(18)
          Call molcas_open(luaniso,input_file_name)
          READ(luaniso,*) nstate, nss
          Close(luaniso)
          ! put them on RunFile:
          Call Put_iScalar('NSTATE_SINGLE   ',nstate)
          Call Put_iScalar('NSS_SINGLE      ',nss)
          Call Put_iScalar('MXJOB_SINGLE    ',1)
          Call Put_iScalar('NJOB_SINGLE     ',1)




       Else If ( input_to_read .eq. 3 ) Then
          If(dbg) Write(6,*) 'restart_sa: file h5=',
     &                        trim(input_file_name)
#ifdef _HDF5_
          ! NSS and NSTATE are also placed on RunFile
          Call read_hdf5_init(input_file_name,nstate,nss)
          If(dbg) Write(6,*) 'restart_sa:    nss=',nss
          If(dbg) Write(6,*) 'restart_sa: nstate=',nstate
          Call Put_iScalar('NSTATE_SINGLE   ',nstate)
          Call Put_iScalar('NSS_SINGLE      ',nss)
          Call Put_iScalar('MXJOB_SINGLE    ',1)
          Call Put_iScalar('NJOB_SINGLE     ',1)
#else
          Write(6,'(A)') 'Warning:: restart option was set to 3:'//
     &                   'i.e. from an HDF5 file'
          Write(6,'(A,A)') 'file id =',trim(input_file_name)
          Call WarningMessage(2,'MOLCAS was compiled without '//
     &                          '_HDF5_ option.')
          Call Quit_OnUserError()
#endif


       Else
          Call WarningMessage(2,'SINGLE_ANISO:: RESTART  '//
     &                          'option is not known.')
          Write(6,'(A,I6)') 'restart_option =',input_to_read
          Write(6,'(A,I6)') 'restart_option can only take integer '//
     &                      'values:'
          Write(6,'(A,I6)') '1 - from binary $Project.aniso'
          Write(6,'(A,I6)') '2 - from formatted file "aniso.input" '//
     &                      '(filename can be given in the input)'
          Write(6,'(A,I6)') '3 - from an HDF5 type file generated '//
     &                      'by RASSI code (filename can be given '//
     &                      'in the input)'
          Write(6,'(A,I6)') '4 - from formatted file "aniso.input" '//
     &                      '(filename can be given in the input) '//
     &                      'in molcas-8.0 format'
          Call Quit_OnUserError()

       End If

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MMSort2(A,B,P,iel)

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: DspVec, lDisp
use input_mclr, only: nSym, nTPert
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: A(*)
real(kind=wp), intent(_OUT_) :: B(*), P(*)
integer(kind=iwp), intent(out) :: iel(3)
integer(kind=iwp) :: iDisp, iG, iii, ijD, ijD1, ijG, ijP, iSym, jDisp
logical(kind=iwp) :: geomi, geomj

ijD = 0
iG = 0
ijG = 0
ijP = 0
iii = 0
iel(:) = 0
do iSym=1,nsym
  do idisp=1,ldisp(isym)
    geomi = btest(ntpert(idisp+iii),4)
    if (.not. geomi) then
      iG = iG+1
      iel(ig) = isym
      do jdisp=1,ldisp(isym)
        geomj = btest(ntpert(jdisp+iii),4)
        if (geomj) then
          ijg = ijg+1
          ijd1 = ijD+iTri(idisp,jdisp)
          B(ijG) = A(ijD1)
        else if (idisp <= jdisp) then
          ijP = iTri(dspvec(jdisp+iii),dspvec(idisp+iii))
          P(ijP) = A(ijD+iTri(idisp,jdisp))
        end if
      end do
    end if
  end do
  ijD = ijD+nTri_Elem(ldisp(isym))
  iii = iii+ldisp(isym)
end do

end subroutine MMSort2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Read_h0(nSize,nBas,ip_h0,Restart)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Character*8 Label
      Logical Restart
      Dimension nInts(1)
*                                                                      *
************************************************************************
*                                                                      *
      iOpt0=0
      iOpt1=1
*
      Call Allocate_Work(ip_h0,nsize)
*
      iComp=1
      iSyLbl=1
      Label='OneHam  '
      iRc=-1
      If (Restart) Then
         Call Get_dArray('LoProp H0',Work(ip_h0),nSize)
      Else
         Call iRdOne(iRc,iOpt1,Label,iComp,nInts,iSyLbl)
         If ( iRc.ne.0 ) Then
            Write (6,*) 'Read_h0: Error reading ONEINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend()
         End If
         If (nInts(1)+4.ne.nSize) Then
            Write (6,*) 'Local_Polar: nInts+4.ne.nSize',nInts(1)+4,nSize
            Call Abend()
         End If
         iRc=-1
         Call RdOne(iRc,iOpt0,Label,iComp,Work(ip_h0),iSyLbl)
         Call Put_dArray('LoProp H0',Work(ip_h0),nSize)
      End If
C     Call TriPrt('H0 ',' ',Work(ip_h0),nBas)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nBas)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
c  **************************************
c  ** Low-level input parsing routines **
c  **************************************
      subroutine popfield_cvb(ifc)
c  IFC is field control :
c  IFC=1 --> read to end of line only, no new line -- DISABLED in MOLCAS
c  IFC=2 --> begin read from next line
      implicit real*8 (a-h,o-z)
c      character*8 string
#include "pop_cvb.fh"
      save initpop
      data initpop/0/
      if(initpop.eq.0) then
      ifield=0
      nfield=0
      nfold=0
      endif
      initpop=1

      if((ifield.eq.nfield).or.ifc.eq.2)then
        nfold=nfield
        call rdline_cvb(nfield)
        ifield=1
      else
c  IFIELD > NFIELD will signify no read
        ifield=min(ifield+1,nfield+1)
      endif
      return
      end

      subroutine pushfield_cvb()
      implicit real*8 (a-h,o-z)
c      character*8 string
#include "pop_cvb.fh"
      if(ifield.eq.1.or.nfield.eq.-1)then
        call pushline_cvb()
        ifield=nfold
        nfield=nfold
      else
        ifield=ifield-1
      endif
      return
      end
      subroutine rdstring_cvb(string,ierr)
c  Check if field is applicable:
      implicit real*8 (a-h,o-z)
      character*8 string
#include "pop_cvb.fh"
      ierr=0
      if(nfield.eq.-1)ierr=1
      if(ifield.gt.nfield)ierr=2
      if(ierr.ne.0)then
        string='        '
        return
      endif
c      call gtstring_cvb(string,ifield)
      call gtany_cvb(string,idi,rdr,1,ifield,ierr)
      return
      end
      subroutine rdint_cvb(intval,ierr)
c  Check if field is applicable:
      implicit real*8 (a-h,o-z)
      character*8 string
#include "pop_cvb.fh"
      ierr=0
      if(nfield.eq.-1)ierr=1
      if(ifield.gt.nfield)ierr=2
      if(ierr.ne.0)return
c      call gtint_cvb(intval,ifield,jerr)
      call gtany_cvb(string,intval,rdr,2,ifield,jerr)
      if(jerr.eq.1)then
        if(ifield.eq.1)ierr=3
        if(ifield.ne.1)ierr=4
      endif
      return
      end
      subroutine rdreal_cvb(realval,ierr)
c  Check if field is applicable:
      implicit real*8 (a-h,o-z)
      character*8 string
#include "pop_cvb.fh"
      ierr=0
      if(nfield.eq.-1)ierr=1
      if(ifield.gt.nfield)ierr=2
      if(ierr.ne.0)return
c      call gtreal_cvb(realval,ifield,jerr)
      call gtany_cvb(string,idi,realval,3,ifield,jerr)
      if(jerr.eq.1)then
        if(ifield.eq.1)ierr=3
        if(ifield.ne.1)ierr=4
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Ext_W4hlp3 (V2,M1,
     c                     nc,dima,dimb,dimapp,dimbpp,addapp,addbpp)
c
c        this routine do:
c        Extract M1(m,a",b") <- V2(m,a',b')
c
        implicit none
        integer nc,dima,dimb,dimapp,dimbpp,addapp,addbpp
        real*8 V2(1:nc,1:dima,1:dimb)
        real*8 M1(1:nc,1:dimapp,1:dimbpp)
c
c        help variables
c
        integer a,b,app,bpp,m
c
        do app=1,dimapp
        a=addapp+app
        do bpp=1,dimbpp
        b=addbpp+bpp
c
          do m=1,nc
          M1(m,app,bpp)=V2(m,a,b)
          end do
c
        end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module gugadrt_global

use Definitions, only: wp, iwp

implicit none
private

#ifndef _I8_
integer(kind=iwp), parameter :: max_ref = 64, iintbit = 32, n32int = 4, n16int = 2
#else
integer(kind=iwp), parameter :: max_ref = 128, iintbit = 64, n32int = 2, n16int = 1
#endif

integer(kind=iwp), parameter :: max_node = 36000, max_orb = 260, max_innorb = 60

real(kind=wp) :: spin
integer(kind=iwp) :: iseg_downwei(25), iseg_sta(26), ja_sys, jb_sys, jc_sys, jpad_upwei(41), jroute_sys, lsm_inn(max_innorb), &
                     mxnode, n_electron, n_ref, nci_dim, ng_sm, nlsm_all(8), nlsm_bas(8), nlsm_ext(8), nlsmddel(8), nlsmedel(8), &
                     norb_act, norb_all, norb_dbl, norb_dz, norb_ext, norb_frz, norb_inn, ns_sm, nstart_act, nu_ad(41), nu_ae(25)
logical(kind=iwp) :: logic_mr, logic_mrelcas
integer(kind=iwp) :: iref_occ(max_innorb,max_ref)
integer(kind=iwp) :: jd(8), js(8), jt(8), jv, no(0:max_innorb)
integer(kind=iwp), allocatable :: ja(:), jb(:), jj(:,:), jm(:), kk(:)
integer(kind=iwp) :: iprint, ludrt

public :: max_ref, iintbit, n32int, n16int
public :: max_innorb, max_node, max_orb
public :: iseg_downwei, iseg_sta, ja_sys, jb_sys, jc_sys, jpad_upwei, jroute_sys, logic_mr, logic_mrelcas, lsm_inn, mxnode, &
          n_electron, n_ref, nci_dim, ng_sm, nlsm_all, nlsm_bas, nlsm_ext, nlsmddel, nlsmedel, norb_act, norb_all, norb_dbl, &
          norb_dz, norb_ext, norb_frz, norb_inn, ns_sm, nstart_act, nu_ad, nu_ae, spin
public :: iref_occ
public :: ja, jb, jd, jj, jm, jv, js, jt, kk, no
public :: iprint, ludrt

end module gugadrt_global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKHREF(HREF,FC,FIJKL,JREFX)

use mrci_global, only: IAD25S, INDSRT, IRC, IROW, IVVER, LASTAD, LN, Lu_25, Lu_70, LUSYMB, NBTRI, NCVAL, NREF, NSRTMX, POTNUC, &
                       VALSRT
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: HREF(*), FC(*), FIJKL(*)
integer(kind=iwp), intent(in) :: JREFX(NCVAL)
integer(kind=iwp) :: i, IADD10, IADD25, IADR, IBUF, IC1, IC2, ICHK, IIN, IIR, IK, ILEN, IND, INDI, IP, IR, IVEC, IVL, JP, KP, &
                     LENGTH, LP, NA, NAT, NB, NHREF, NI, NIJ, NIJKL, NK, NKL
real(kind=wp) :: FINI

NHREF = (NREF*(NREF+1))/2
HREF(1:NHREF) = Zero
ICHK = 0
IK = 0
FINI = Zero
IADD25 = 0
call dDAFILE(Lu_25,2,FC,NBTRI,IADD25)
IADD10 = IAD10(8)
do
  call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
  call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
  ILEN = ICOP1(nCOP+1)
  if (ILEN < 0) exit
  do IIN=1,ILEN
    IND = ICOP1(IIN)
    if (ICHK /= 0) then
      ICHK = 0
      INDI = IND
      NI = ibits(INDI,0,10)
      NK = ibits(INDI,10,10)
      IK = IROW(NK)+NI
      FINI = FC(IK)
    else if (IND == 0) then
      ICHK = 1
    else
      IVL = ibits(IND,0,6)
      if (IVL /= IVVER) cycle
      IC2 = ibits(IND,6,13)
      NA = JREFX(IC2)
      if (NA == 0) cycle
      IC1 = ibits(IND,19,13)
      NB = JREFX(IC1)
      if (NB == 0) cycle
      if (NA < NB) then
        NAT = NA
        NA = NB
        NB = NAT
      end if
      IVEC = (NA*(NA-1))/2+NB
      HREF(IVEC) = HREF(IVEC)+COP(IIN)*FINI
    end if
  end do
end do
ICHK = 0
NIJ = IROW(LN+1)
NIJKL = NIJ*(NIJ+1)/2
FIJKL(1:NIJKL) = Zero
FINI = Zero
IADR = LASTAD(1)
do
  call dDAFILE(Lu_70,2,VALSRT,NSRTMX,IADR)
  call iDAFILE(Lu_70,2,INDSRT,NSRTMX+2,IADR)
  LENGTH = INDSRT(NSRTMX+1)
  IADR = INDSRT(NSRTMX+2)
  do i=1,length
    FIJKL(INDSRT(i)) = VALSRT(i)
  end do
  if (IADR == -1) exit
end do
IADD10 = IAD10(5)
do
  call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
  call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
  ILEN = ICOP1(nCOP+1)
  if (ILEN < 0) exit
  do IIN=1,ILEN
    IND = ICOP1(IIN)
    if (ICHK /= 0) then
      ICHK = 0
      INDI = IND
      IP = ibits(INDI,0,8)
      JP = ibits(INDI,8,8)
      KP = ibits(INDI,16,8)
      LP = ibits(INDI,24,8)
      NIJ = IROW(IP)+JP
      NKL = IROW(KP)+LP
      IND = NIJ*(NIJ-1)/2+NKL
      FINI = FIJKL(IND)
    else if (IND == 0) then
      ICHK = 1
    else
      IVL = ibits(IND,0,6)
      if (IVL /= 0) cycle
      IC2 = ibits(IND,6,13)
      NA = JREFX(IC2)
      if (NA == 0) cycle
      IC1 = ibits(IND,19,13)
      NB = JREFX(IC1)
      if (NB == 0) cycle
      if (NA < NB) then
        NAT = NA
        NA = NB
        NB = NAT
      end if
      IVEC = (NA*(NA-1))/2+NB
      HREF(IVEC) = HREF(IVEC)+COP(IIN)*FINI
    end if
  end do
end do
IADD25 = IAD25S
IBUF = nCOP
do I=1,IRC(1)
  IBUF = IBUF+1
  if (IBUF > nCOP) then
    call dDAFILE(Lu_25,2,COP,nCOP,IADD25)
    IBUF = 1
  end if
  IR = JREFX(I)
  if (IR > 0) then
    IIR = (IR*(IR+1))/2
    HREF(IIR) = HREF(IIR)+COP(IBUF)+POTNUC
  end if
end do

return

end subroutine MKHREF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,2020, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine CrtCmp(Zeta,P,nZeta,A,Axyz,na,HerR,nHer,ABeq)
************************************************************************
*                                                                      *
* Object: to compile the value of the angular part of a basis function *
*         evaluated at a root of the quadrature.                       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      Implicit None
#include "real.fh"
      Integer, Intent(In):: nZeta, nHer, na
      Integer iHer, iCar, ia
      Real*8, Intent(In)::  Zeta(nZeta), P(nZeta,3), A(3), HerR(nHer)
      Real*8, Intent(Out):: Axyz(nZeta,3,nHer,0:na)
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Character*80 Label
#endif
      Logical ABeq(3)
*
*
      If (na.lt.0) Then
         Call WarningMessage(2,'CrtCmp: na.lt.0')
         Call Abend()
      End If
#ifdef _DEBUGPRINT_
      Write (Label,'(A)') ' In CrtCmp: Axyz(in)'
      Call RecPrt(Label,' ',Axyz,nZeta*3,nHer*(na+1))
      Call RecPrt(' In CrtCmp: HerR',' ',HerR,1,nHer)
      Call RecPrt(' In CrtCmp: Zeta',' ',Zeta,nZeta,1)
      Call RecPrt(' In CrtCmp: A   ',' ',A   ,1    ,3)
      Call RecPrt(' In CrtCmp: P   ',' ',P   ,nZeta,3)
#endif
      Axyz(:,:,:,0)=One
      If (na.ne.0) then
*
         Do iHer = 1, nHer
            Do iCar = 1, 3
*
               If (ABeq(iCar)) Then
                  Axyz(:,iCar,iHer,1) =
     &                   HerR(iHer)*1/Sqrt(Zeta(:))
               Else
                  Axyz(:,iCar,iHer,1) =
     &                      HerR(iHer)*1/Sqrt(Zeta(:)) +
     &                      P(:,iCar) - A(iCar)
               End If
*
               Do ia = 2, na
                  Axyz(:,iCar,iHer,ia) = Axyz(:,iCar,iHer,1) *
     &                                      Axyz(:,iCar,iHer,ia-1)
               End Do
*
            End Do
         End Do
*
      End If
*
#ifdef _DEBUGPRINT_
      Write (Label,'(A)') ' In CrtCmp: Axyz(out) '
      Call RecPrt(Label,' ',Axyz,nZeta*3,nHer*(na+1))
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine esb_ic_2(symp,symq,Vic,dimp,dimq,pqind)
! this routine realizes expansion of symmetry block
! symp,symq,symr,syms <p,q|r,s>  <-> (IJ|KL),
! (for case symp=symr,symq=syms)
! provided such integrals exist
! It finds corresponding (IJ|KL) and expands it to
! matrix vic (pr,qs)

use ccsort_global, only: idis, LUINTM, mbas, NORB, np, nq, nr, ns, typ
use TraToc, only: NTRABUF
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: symp, symq, dimp, dimq
real(kind=wp), intent(_OUT_) :: Vic(dimp*(dimp+1)/2,dimq*(dimq+1)/2)
integer(kind=iwp), intent(out) :: pqind(mbas,mbas)
integer(kind=iwp) :: i, i1, idis13, ilow, ind(4), indtemp, iold, iup, j, j1, jlow, jold, jup, k1, kold, kup, l1, lold, lup, maxx, &
                     ni, nj, nk, nl, nsi, nsj, nsk, nsl, typp, yes234, yes5, yes678
real(kind=wp) :: val1
real(kind=wp), allocatable :: TWO(:)

!I calc pqind

if (dimp >= dimq) then
  maxx = dimp
else
  maxx = dimq
end if

do i=1,maxx
  do j=1,maxx
    if (i >= j) then
      pqind(i,j) = i*(i-1)/2+j
    else
      pqind(i,j) = j*(j-1)/2+i
    end if
  end do
end do

!II get address
idis13 = idis(symp,symq,symp)

!III.1 define order of indices

ni = np(symp,symq,symp)
nj = nq(symp,symq,symp)
nk = nr(symp,symq,symp)
nl = ns(symp,symq,symp)

!III.2 def yes1-8

typp = typ(symp,symq,symp)

!:1 combination (ij|kl) -> (ij|kl)
!   used in types: 1,2,3,4,5,6,7,8 (all)
!yes1 = 1

!:2 combination (ij|kl) -> (ji|kl)
!:3 combination (ij|kl) -> (ij|lk)
!:4 combination (ij|kl) -> (ji|lk)
!   used in types: 1,5 since 2,3,6,7 never appear
if ((typp == 1) .or. (typp == 5)) then
  yes234 = 1
else
  yes234 = 0
end if

!:5 combination (ij|kl) -> (kl|ij)
!   used in types: 1,2,3,4
if ((typp >= 1) .and. (typp <= 4)) then
  yes5 = 1
else
  yes5 = 0
end if

!:6 combination (ij|kl) -> (lk|ij)
!:7 combination (ij|kl) -> (kl|ji)
!:8 combination (ij|kl) -> (lk|ji)
!   used in types: 1 (since 2,3 never appeard)
if (typp == 1) then
  yes678 = 1
else
  yes678 = 0
end if

! define NSI,NSJ,NSK,NSL
ind(ni) = symp
ind(nj) = symq
ind(nk) = symp
ind(nl) = symq
NSI = ind(1)
NSJ = ind(2)
NSK = ind(3)
NSL = ind(4)

call mma_allocate(TWO,nTraBuf,label='TWO')

indtemp = nTraBuf+1
KUP = NORB(NSK)
do KOLD=1,KUP

  LUP = NORB(NSL)
  if (NSK == NSL) LUP = KOLD
  do LOLD=1,LUP

    ILOW = 1
    if (NSI == NSK) ILOW = KOLD
    IUP = NORB(NSI)
    do IOLD=ILOW,IUP

      JLOW = 1
      if ((NSI == NSK) .and. (IOLD == KOLD)) JLOW = LOLD
      JUP = NORB(NSJ)
      if (NSI == NSJ) JUP = IOLD
      do JOLD=JLOW,JUP

        ! read block of integrals if necessary

        if (indtemp == (nTraBuf+1)) then
          indtemp = 1
          ! read block
          call dDAFILE(LUINTM,2,TWO,nTraBuf,IDIS13)
        end if

        ! write integrals to appropriate positions

        val1 = TWO(indtemp)

        !:1 combination (ij|kl) -> (ij|kl)
        !   since yes1 is always 1, if structure is skipped
        ind(1) = iold
        ind(2) = jold
        ind(3) = kold
        ind(4) = lold
        j1 = ind(nj)
        l1 = ind(nl)
        i1 = ind(ni)
        k1 = ind(nk)

        if ((i1 <= dimp) .and. (j1 <= dimq) .and. (k1 <= dimp) .and. (l1 <= dimq)) Vic(pqind(i1,k1),pqind(j1,l1)) = val1

        if (yes234 == 1) then

          !:2 combination (ij|kl) -> (ji|kl)
          ind(1) = jold
          ind(2) = iold
          ind(3) = kold
          ind(4) = lold
          j1 = ind(nj)
          l1 = ind(nl)
          i1 = ind(ni)
          k1 = ind(nk)

          if ((i1 <= dimp) .and. (j1 <= dimq) .and. (k1 <= dimp) .and. (l1 <= dimq)) Vic(pqind(i1,k1),pqind(j1,l1)) = val1

          !:3 combination (ij|kl) -> (ij|lk)
          ind(1) = iold
          ind(2) = jold
          ind(3) = lold
          ind(4) = kold
          j1 = ind(nj)
          l1 = ind(nl)
          i1 = ind(ni)
          k1 = ind(nk)

          if ((i1 <= dimp) .and. (j1 <= dimq) .and. (k1 <= dimp) .and. (l1 <= dimq)) Vic(pqind(i1,k1),pqind(j1,l1)) = val1

          !:4 combination (ij|kl) -> (ji|lk)
          ind(1) = jold
          ind(2) = iold
          ind(3) = lold
          ind(4) = kold
          j1 = ind(nj)
          l1 = ind(nl)
          i1 = ind(ni)
          k1 = ind(nk)

          if ((i1 <= dimp) .and. (j1 <= dimq) .and. (k1 <= dimp) .and. (l1 <= dimq)) Vic(pqind(i1,k1),pqind(j1,l1)) = val1

        end if

        !:5 combination (ij|kl) -> (kl|ij)
        if (yes5 == 1) then
          ind(1) = kold
          ind(2) = lold
          ind(3) = iold
          ind(4) = jold
          j1 = ind(nj)
          l1 = ind(nl)
          i1 = ind(ni)
          k1 = ind(nk)

          if ((i1 <= dimp) .and. (j1 <= dimq) .and. (k1 <= dimp) .and. (l1 <= dimq)) Vic(pqind(i1,k1),pqind(j1,l1)) = val1

        end if

        if (yes678 == 1) then

          !:6 combination (ij|kl) -> (lk|ij)
          ind(1) = lold
          ind(2) = kold
          ind(3) = iold
          ind(4) = jold
          j1 = ind(nj)
          l1 = ind(nl)
          i1 = ind(ni)
          k1 = ind(nk)

          if ((i1 <= dimp) .and. (j1 <= dimq) .and. (k1 <= dimp) .and. (l1 <= dimq)) Vic(pqind(i1,k1),pqind(j1,l1)) = val1

          !:7 combination (ij|kl) -> (kl|ji)
          ind(1) = kold
          ind(2) = lold
          ind(3) = jold
          ind(4) = iold
          j1 = ind(nj)
          l1 = ind(nl)
          i1 = ind(ni)
          k1 = ind(nk)

          if ((i1 <= dimp) .and. (j1 <= dimq) .and. (k1 <= dimp) .and. (l1 <= dimq)) Vic(pqind(i1,k1),pqind(j1,l1)) = val1

          !:8 combination (ij|kl) -> (lk|ji)
          ind(1) = lold
          ind(2) = kold
          ind(3) = jold
          ind(4) = iold
          j1 = ind(nj)
          l1 = ind(nl)
          i1 = ind(ni)
          k1 = ind(nk)

          if ((i1 <= dimp) .and. (j1 <= dimq) .and. (k1 <= dimp) .and. (l1 <= dimq)) Vic(pqind(i1,k1),pqind(j1,l1)) = val1

        end if

        indtemp = indtemp+1

      end do
    end do
  end do
end do

call mma_deallocate(TWO)

return

end subroutine esb_ic_2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETRED(IPASS,ILOC,LRSH)
!
! Purpose: read index arrays for current reduced set (reduced set IPASS).

use Cholesky, only: IndRed, IndRSh, InfRed, iSP2F, LuRed, LuPri, nnBstRSh, nnShl, nSym
#ifdef _DEBUGPRINT_
use Cholesky, only: nnBstRT
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IPASS, ILOC
logical(kind=iwp), intent(in) :: LRSH
integer(kind=iwp) :: IADR, IADR1, IOPT, LSAV, LTOT
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_GETRED'

#ifdef _DEBUGPRINT_
! Test dimensions.
! ----------------

if (size(nnBstRSh,1) /= NSYM) call CHO_QUIT('NSYM error in '//SECNAM,104)

if (size(nnBstRSh,2) /= NNSHL) call CHO_QUIT('NNSHL error in '//SECNAM,104)

if (size(IndRed,1) /= NNBSTRT(1)) call CHO_QUIT('NNBSTRT(1) error in '//SECNAM,104)

if ((IPASS < 1) .or. (IPASS > size(InfRed))) call CHO_QUIT('IPASS error in '//SECNAM,104)
#endif

! Get first address.
! ------------------

IADR1 = INFRED(IPASS)
#ifdef _DEBUGPRINT_
if (IADR1 < 0) then
  write(LUPRI,*) SECNAM,': negative address for reduced set ',IPASS,': ',IADR1
  call CHO_QUIT('Error in '//SECNAM,104)
end if
#endif

if (LOCDBG) write(LUPRI,*) SECNAM,': getting reduced set ',IPASS,' at addr: ',IADR1

! Read index arrays.
! ------------------

IOPT = 2
IADR = IADR1
LTOT = NSYM*NNSHL
call IDAFILE(LURED,IOPT,NNBSTRSH(:,:,ILOC),LTOT,IADR)
IOPT = 2
IADR = IADR1+NSYM*NNSHL
LSAV = sum(NNBSTRSH(:,:,ILOC))
LTOT = LSAV
call IDAFILE(LURED,IOPT,INDRED(:,ILOC),LTOT,IADR)
if (LRSH .and. (IPASS == 1)) then
  IOPT = 2
  IADR = IADR1+NSYM*NNSHL+LSAV
  LTOT = LSAV
  call IDAFILE(LURED,IOPT,INDRSH,LTOT,IADR)
  IOPT = 2
  IADR = IADR1+NSYM*NNSHL+2*LSAV
  LTOT = NNSHL
  call IDAFILE(LURED,IOPT,ISP2F,LTOT,IADR)
end if

end subroutine CHO_GETRED

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_INIT(SKIP_PRESCREEN)
!
! Purpose: initialization of Cholesky decomposition in MOLCAS.

use Index_Functions, only: nTri_Elem
use iSD_data, only: iSO2Sh
use Cholesky, only: iBas, iBasSh, IFCSew, iShlSO, iShP2Q, iShP2RS, iSOShl, iSP2F, LuPri, Mx2Sh, MxOrSh, nBas, nBasSh, nBasT, &
                    nBstSh, nnShl, nnShl_Tot, nShell, nSym
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: SKIP_PRESCREEN
integer(kind=iwp) :: I, IA, IJ, IJSHL, ISHL, ISYM, J, NUMIJ
character(len=*), parameter :: SECNAM = 'CHO_MCA_INIT'

! Check that the number of shells is within limits.
! -------------------------------------------------

if (NSHELL < 1) then
  write(LUPRI,*) 'NSHELL out of bounds: ',NSHELL
  call CHO_QUIT('NSHELL out of bounds in '//SECNAM,102)
end if

! Compute total #shell pair.
! --------------------------

NNSHL_TOT = nTri_Elem(NSHELL)
if (NNSHL_TOT < 1) then
  write(LUPRI,*) 'NNSHL_TOT=nTri_Elem(NSHELL) is non-positive: ',NNSHL_TOT
  write(LUPRI,*) 'Integer overflow ?'
  call CHO_QUIT('NNSHL_TOT out of bounds in '//SECNAM,102)
end if

! Compute contributing #shell pair by prescreening (if requested).
! iSP2F(k): returns global shell pair of contributing shell pair k.
!           (Allocated and defined in CHO_DIAPS.)
! -----------------------------------------------------------------

if (SKIP_PRESCREEN) then
  if ((NNSHL < 1) .or. (NNSHL > NNSHL_TOT)) then
    write(LUPRI,*) SECNAM,': flag SKIP_PRESCREEN is ',SKIP_PRESCREEN
    write(LUPRI,*) 'NNSHL is out-of-bounds: ',NNSHL
    write(LUPRI,*) 'Condition: 0 < NNSHL < ',NNSHL_TOT
    call CHO_QUIT('Initialization error in '//SECNAM,102)
  end if
  if (size(iSP2F) /= NNSHL) then
    write(LUPRI,*) SECNAM,': flag SKIP_PRESCREEN is ',SKIP_PRESCREEN
    write(LUPRI,*) 'NNSHL is: ',NNSHL
    write(LUPRI,*) 'SIZE(iSP2F) must be equal to NNSHL, SIZE(iSP2F)= ',size(iSP2F)
    call CHO_QUIT('Initialization error in '//SECNAM,102)
  end if
else
  call CHO_DIASP()
end if

! Get the number of symmetries.
! -----------------------------

call GET_ISCALAR('nSym',NSYM)  ! Get # irreps.
if ((NSYM < 1) .or. (NSYM > 8)) then
  write(LUPRI,*) 'NSYM out of bounds: ',NSYM
  call CHO_QUIT('NSYM out of bounds in '//SECNAM,102)
end if

! NBAS(ISYM): # basis functions (SOs) in symmetry ISYM
! IBAS(ISYM): offset to basis functions in symmetry ISYM
! NBAST     : total number of basis functions
! ------------------------------------------------------

call GET_IARRAY('nBas',NBAS,NSYM)
IBAS(1) = 0
NBAST = NBAS(1)
do ISYM=2,NSYM
  IBAS(ISYM) = NBAST
  NBAST = NBAST+NBAS(ISYM)
end do
if (NBAST < 1) then
  write(LUPRI,*) 'NBAST out of bounds: ',NBAST
  call CHO_QUIT('NBAST out of bounds in '//SECNAM,102)
end if

! Allocate shell based index arrays.
! ----------------------------------

call mma_allocate(iBasSh,nSym,nShell,Label='iBasSh')
call mma_allocate(nBasSh,nSym,nShell,Label='nBasSh')
call mma_allocate(nBstSh,nShell,Label='nBstSh')

! ISOSHL(I): shell to which SO I belongs
! --------------------------------------

call mma_allocate(iSOShl,NBAST,Label='iSOShl')
do ISYM=1,NSYM
  do IA=1,NBAS(ISYM)
    I = IBAS(ISYM)+IA
    iSOShl(I) = ISO2SH(I)
  end do
end do

! NBASSH(ISYM,ISHL): total dimension of shell ISHL, sym. ISYM
! NBSTSH(ISHL): total dimension of shell ISHL
! MXORSH      : max. shell dimension
! -----------------------------------------------------------

call CHO_SETSH(IBASSH,NBASSH,NBSTSH,IBAS,NBAS,ISOSHL,NSYM,NSHELL,NBAST)

MXORSH = NBSTSH(1)
do ISHL=2,NSHELL
  MXORSH = max(MXORSH,NBSTSH(ISHL))
end do

! MX2SH: max. dimension of contributing shell pair.
! -------------------------------------------------

MX2SH = -1
do IJSHL=1,NNSHL
  IJ = iSP2F(IJSHL)
  call CHO_INVPCK(IJ,I,J,.true.)
  if (I == J) then
    NUMIJ = nTri_Elem(NBSTSH(I))
  else
    NUMIJ = NBSTSH(I)*NBSTSH(J)
  end if
  MX2SH = max(MX2SH,NUMIJ)
end do
if (MX2SH < 1) then
  write(LUPRI,*) 'Max. shell pair dimension non-positive: ',MX2SH
  call CHO_QUIT('Initialization problem in '//SECNAM,102)
end if

! If needed, allocate memory for extracting qualified columns
! directly in reduced set from Seward.
! -----------------------------------------------------------

if (IFCSEW == 2) then
  call mma_allocate(iShP2RS,2,Mx2Sh,Label='iShP2RS')
  call mma_allocate(iShP2Q,2,Mx2Sh,Label='iShP2Q ')
end if

! ISHLSO(I): index of SO I within its shell
! -----------------------------------------

call mma_allocate(iShlSO,nBasT,Label='iShlSO')
call CHO_SETSH2(iShlSO,iSOShl,NBSTSH,NBAST,NSHELL)

end subroutine CHO_MCA_INIT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine BasisConsistency(LuWr,iErr)

use ZMatConv_Mod, only: BasAva, BasReq
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LuWr
integer(kind=iwp), intent(out) :: iErr
integer(kind=iwp) :: i

iErr = 0
do i=1,size(BasReq)
  if (BasReq(i) .and. (.not. BasAva(i))) then
    iErr = 1
    write(LuWr,*) ' [BasisConsistency]: Atom NA=',i,' requires BS'
    exit
  end if
end do

return

end subroutine BasisConsistency

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Update_H(nWndw,H,nInter,nIter,iOptC,dq,g,iOptH,jPrint,GNrm,nsAtom,Store,AllowFindTS)

use Slapaf_Info, only: IRC, MF, Mode
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nWndw, nInter, nIter, iOptH, jPrint, nsAtom
real(kind=wp), intent(inout) :: H(nInter,nInter)
integer(kind=iwp), intent(inout) :: iOptC
real(kind=wp), intent(in) :: dq(nInter,nIter), g(nInter,nIter), GNrm
logical(kind=iwp), intent(in) :: Store, AllowFindTS
integer(kind=iwp) :: ierr, IterHess
logical(kind=iwp) :: Old_MF
real(kind=wp), allocatable :: Tmp(:,:)
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
! Update the Hessian. The procedure here loops over gradients
! of the nWndw last iteration. The reason for this is that the
! initial Hessian is reset to new values at each iteration.
! The anharmonic constants used here is the most recently
! updated version.

call DrvUpH(nWndw,nIter,H,nInter,dq,g,iOptH,IterHess)

call Chk4NAN(nInter*nInter,H,ierr)

if (ierr /= 0) call SysAbendMsg('Update_H','NaNs in Hessian','')
if (Store) call Put_dArray('Hss_upd',H,nInter**2)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Check if we have an old reaction mode

Old_MF = DDot_(3*nsAtom,MF,1,MF,1) /= Zero
Old_MF = Old_MF .and. (Mode /= 0) .and. (IRC == 0)
call mma_allocate(Tmp,3,nsAtom,Label='Tmp')
if (Old_MF) then
  if (jPrint >= 6) write(u6,*) ' Reading old reaction mode from disk'
  Tmp(:,:) = MF(:,:)
  Mode = 1  ! any number between 1 and nInter
  iOptC = ibset(iOptC,13)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Massage the new Hessian

call FixHess(H,nInter,iOptC,Tmp,GNrm,nsAtom,(IterHess == nIter),AllowFindTS)
!                                                                      *
!***********************************************************************
!                                                                      *
! Store the new reaction mode if any!

if ((Mode > 0) .and. (Mode <= nInter)) then
  if (jPrint >= 6) write(u6,*) ' Storing new reaction mode on disk'
  MF(:,:) = Tmp(:,:)
end if
call mma_deallocate(Tmp)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (jPrint >= 99) call RecPrt('Update_H: Updated Hessian',' ',H,nInter,nInter)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Update_H

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_ComputeCoulombIntermediates0(nD,ip_DBlocks,ip_VBlocks)
! Thomas Bondo Pedersen, September 2010.
!
! Purpose: Compute Coulomb intermediates
!
!      V(J) = sum_uv C(uv,J)*D(uv)
!
!      using LDF fitting coefficients.
!
! BLOCKED VERSION

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nD, ip_DBlocks(nD), ip_VBlocks(nD)
integer(kind=iwp) :: TaskListID, iAtomPair, iAtom, jAtom, l_C, iD, ipV, ipD, nuv, M
real(kind=wp), allocatable :: LDFCBlk(:)
integer(kind=iwp), external :: LDF_nBas_Atom, LDF_nBasAux_Pair
logical(kind=iwp), external :: Rsv_Tsk
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

#ifdef _MOLCAS_MPP_
! Initialize V arrays
do iD=1,nD
  call LDF_ZeroBlockVector(ip_VBlocks(iD))
end do
#endif

! Allocate array for storing coefficients
l_C = 0
do iAtomPair=1,NumberOfAtomPairs
  iAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+1)
  jAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+2)
  nuv = LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
  M = LDF_nBasAux_Pair(iAtomPair)
  l_C = max(l_C,nuv*M)
end do
call mma_allocate(LDFCBlk,l_C,label='LDFCBlk')

! Compute atom pair blocks of V
call Init_Tsk(TaskListID,NumberOfAtomPairs)
do while (Rsv_Tsk(TaskListID,iAtomPair))
  ! Get dimensions
  iAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+1)
  jAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+2)
  nuv = LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
  M = LDF_nBasAux_Pair(iAtomPair)
  ! Read coefficients for this atom pair
  call LDF_CIO_ReadC(iAtomPair,LDFCBlk,l_C)
  ! Compute V for this atom pair and for each density
  do iD=1,nD
    ipD = iWork(ip_DBlocks(iD)-1+iAtomPair)
    ipV = iWork(ip_VBlocks(iD)-1+iAtomPair)
    call dGeMV_('T',nuv,M,One,LDFCBlk,nuv,Work(ipD),1,Zero,Work(ipV),1)
  end do
end do
call Free_Tsk(TaskListID)

! Deallocation
call mma_deallocate(LDFCBlk)

#ifdef _MOLCAS_MPP_
! Get complete V on all nodes
do iD=1,nD
  call LDF_P_AddBlockVector(ip_VBlocks(iD))
end do
#endif

end subroutine LDF_ComputeCoulombIntermediates0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine CSF2SD(CSF,SD,is)
! Transforms a CSF vector to slater determinants

use Symmetry_Info, only: Mul
use Str_Info, only: CNSM, DTOC
use MCLR_Data, only: NDTASM
use input_mclr, only: nConf, nCSF, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: is
real(kind=wp), intent(in) :: CSF(nCSF(is))
real(kind=wp), intent(_OUT_) :: SD(*)
integer(kind=iwp) :: i, iiCOPY, iSym
real(kind=wp), allocatable :: CTM(:)

iiCOPY = 0
nConf = max(ncsf(is),ndtasm(iS))
isym = Mul(is,State_Sym)
i = 2
if (isym == 1) i = 1

call mma_allocate(CTM,nConf,Label='CTM')
CTM(1:ncsf(is)) = CSF(1:ncsf(is))
CTM(ncsf(is)+1:) = Zero

call CSDTVC_MCLR_1(CTM,SD,DTOC,CNSM(i)%ICTS,IS,iiCOPY)

call mma_deallocate(CTM)

end subroutine CSF2SD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine write_stderr (msg)
      implicit none
      character(len=*) :: msg
#include "para_info.fh"
      write(0,'(a,i6,a,1x,a)')
     &  '[ process ', myrank, ']:',
     &  trim(msg)
      call xflush(0)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine expec_cvb(dxp,gradp,heigval,nnegeig,npr,expc,exp1,exp2)

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nnegeig, npr
real(kind=wp), intent(in) :: dxp(npr), gradp(npr), heigval(npr)
real(kind=wp), intent(out) :: expc, exp1, exp2
integer(kind=iwp) :: i
real(kind=wp) :: exp1l, exp2l

exp1l = Zero
do i=1,nnegeig
  exp1l = exp1l+dxp(i)*(gradp(i)+Half*dxp(i)*heigval(i))
end do
exp2l = Zero
do i=nnegeig+1,npr
  exp2l = exp2l+dxp(i)*(gradp(i)+Half*dxp(i)*heigval(i))
end do
expc = exp1l+exp2l
exp1 = exp1l
exp2 = exp2l

return

end subroutine expec_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine sminus_cvb(bikfrom,bikto,nel,nalffrom,nalfto,nvec)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: bikfrom(*)
real(kind=wp), intent(_OUT_) :: bikto(*)
integer(kind=iwp), intent(in) :: nel, nalffrom, nalfto, nvec
integer(kind=iwp) :: ialffrom, ialfto, ivec, ndetfrom, ndetto
real(kind=wp) :: cnrmfrom, cnrmto
real(kind=wp), allocatable :: b4(:,:), b5(:,:)
real(kind=wp), external :: dnrm2_

call asc2ab_cvb(bikfrom,nvec,nel,nalffrom)

do ialfto=nalffrom-1,nalfto,-1
  ialffrom = ialfto+1
  call icomb_cvb(nel,ialffrom,ndetfrom)
  call icomb_cvb(nel,ialfto,ndetto)
  if (nalffrom == nalfto+1) then
    call sminus2_cvb(bikfrom,bikto,nel,ialffrom,ndetfrom,ialfto,ndetto,nvec)
  else if (ialfto == nalffrom-1) then
    call mma_allocate(b4,ndetto,nvec,label='b4')
    call sminus2_cvb(bikfrom,b4,nel,ialffrom,ndetfrom,ialfto,ndetto,nvec)
  else if (ialfto == nalfto) then
    call sminus2_cvb(b4,bikto,nel,ialffrom,ndetfrom,ialfto,ndetto,nvec)
    call mma_deallocate(b4)
  else
    call mma_allocate(b5,ndetto,nvec,label='b5')
    call sminus2_cvb(b4,b5,nel,ialffrom,ndetfrom,ialfto,ndetto,nvec)
    call mma_deallocate(b4)
    call move_alloc(b5,b4)
  end if
end do

call asc2ab_cvb(bikto,nvec,nel,nalfto)
! Now try to retain normalization ...
call icomb_cvb(nel,nalffrom,ndetfrom)
call icomb_cvb(nel,nalfto,ndetto)
do ivec=1,nvec
  cnrmfrom = dnrm2_(ndetfrom,bikfrom((ivec-1)*ndetfrom+1:ivec*ndetfrom),1)
  cnrmto = dnrm2_(ndetto,bikto((ivec-1)*ndetto+1:ivec*ndetto),1)
  if (cnrmto > 1.0e-10_wp) bikto((ivec-1)*ndetto+1:ivec*ndetto) = cnrmfrom/cnrmto*bikto((ivec-1)*ndetto+1:ivec*ndetto)
end do

return

end subroutine sminus_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

! *********************************************************************
      subroutine read_dmrg_parameter_for_mclr()

#include "Input.fh"
#include "dmrginfo_mclr.fh"

        integer ierr,i
        open(unit=100,file="dmrg_for_mclr.parameters",
     &       status='OLD',action='READ',iostat=ierr)
          if(ierr.ne.0)then
            doDMRG=.false.
            doMCLR=.false.
          else
            read(100,"(11X,L1,4X)")  doDMRG
            read(100,"(4X,I8,4X)")nele_RGLR
            read(100,"(4X,I8,4X)") ms2_RGLR
!>          write(6,*)doDMRG,dmrg_state%nactel,dmrg_state%ms2
            do i=1,8
              read(100,"(4X,I3)",advance='no')RGras2(i)
            end do
            read(100,*)
            do i=1,8
              read(100,"(4X,I3)",advance='no')LRras2(i)
            end do
!>          write(6,*)RGras2
!>          write(6,*)LRras2
            read(100,*)
            read(100,"(4X,I8,4X)")nstates_RGLR
!            allocate(checkpoint(nstates_RGLR))
!            checkpoint=""
            do i=1,nstates_RGLR
              read(100,*)
              read(100,'(G20.12)')ERASSCF(i)
              write(6,*)"RASSCF energy", ERASSCF(i)
            end do
!> It is redundant
            doMCLR=.true.
          end if
        close(100)

        write(6,*)"doDMRG, nele_dmrg, ms2_dmrg"
        write(6,*) doDMRG, nele_rglr, ms2_rglr
        call xflush(6)

      end subroutine read_dmrg_parameter_for_mclr

! *********************************************************************
      Subroutine dmrg_spc_change_mclr(orbspc,lrspc)

       integer::orbspc(8)
       integer::lrspc(8)

       lrspc=0

       lrspc=orbspc

      End Subroutine dmrg_spc_change_mclr

! *********************************************************************

      Subroutine dmrg_dim_change_mclr(orbspc,ndim,iflag)

        integer::orbspc(8)
        integer::iflag
        integer::ndim
        integer i,n1,n2

!        write(6,*)"==================================================="
!        write(6,*)" Currently, only valid for no symmetry calculation"
!        write(6,*)"==================================================="

!        I remember it was already valid for all symmetry.
!                         -- yma, need check it again 2015.5.14

!        write(6,*)"orbspc",orbspc(1:8)
        ndim=0

        n1 = 0

        if(iflag.eq.0)then
          do i=1,8
            ndim=ndim+orbspc(i)
          end do
        else if(iflag.eq.1)then
          do i=1,1
            n1=n1+orbspc(i)
            ndim=n1*n1
          end do
        else if(iflag.eq.2)then
          do i=1,1
            n1=n1+orbspc(i)
            ndim=n1**4
          end do
        else if(iflag.eq.3)then
          do i=1,1
            n1=n1+orbspc(i)
            ndim=(n1+1)*n1/2
          end do
        else if(iflag.eq.4)then
          do i=1,1
            n1=n1+orbspc(i)
            n2=n1*n1
            ndim=(n2+1)*n2/2
          end do
        else
          write(6,*)"unknow iflag"
          call Quit_OnUserError()
        end if

      End Subroutine dmrg_dim_change_mclr
! *********************************************************************

      Subroutine ci_reconstruct(istate,nSDET,vector,indexSD)

#include "dmrginfo_mclr.fh"
        character*100,allocatable :: checkpoint(:)  ! for many states

        integer :: istate,nsdet

        integer i,j,idet,idx_det
        integer norb,norbLR

        integer neletol
        integer nele_mod
        integer nele_alpha,nele_beta

        integer irrep_pre,iorbLR0,iorbLR
        integer irrep_diff(8)

! need to be rewrittren using the Molcas getmem,
!                                    or mma_allocate and mma_deallocate
! soon ..
        integer,allocatable::ele_orb_alpha(:)
        integer,allocatable::ele_orb_beta(:)

        integer,allocatable::pre_ele(:)

        integer ndets_mclr

        character*200 tmp_run

        real*8 dtmp

        logical IFFILE
        integer rc

        integer :: indexSD(nsdet)            ! index
        real*8  :: vector(nsdet)             ! determinants

        type Slater_determinant
          integer :: itype                  = 1 ! excitation type
          integer :: inum                   = 1 ! determinant number
          integer :: isign                  = 1 ! determinant phase
          integer,allocatable :: electron(:)    ! determinant
          integer,allocatable :: ele_conf(:)    ! electron configuration
          real*8 ,allocatable :: dV(:)          ! for many states
        end type Slater_determinant

        type (Slater_determinant), allocatable::SD_DMRG(:)

          !> The total electrons
          neletol=0
          neletol= nele_RGLR

          !> Check if there is single electron
          nele_mod=mod(neletol,2)

          !> electrons in alpha or beta orbitals
          if(nele_mod.eq.0)then
            !> If no single electron
            nele_alpha= neletol/2 + ms2_RGLR/2
            nele_beta = neletol/2 - ms2_RGLR/2
          else
            nele_alpha= neletol/2 + ms2_RGLR/2+1
            nele_beta = neletol/2 - ms2_RGLR/2
          end if

! Read in all the name of checkpoint file
          lcheckpoint=20
          lcheckpoint=isFreeUnit(lcheckpoint)
          Call Molcas_Open(lcheckpoint,'dmrg_for_mclr.parameters')
          allocate(checkpoint(nstates_RGLR))
          checkpoint=""
          do i=1,6
            read(lcheckpoint,*)
          end do
          do i=1,nstates_RGLR
            read(lcheckpoint,*)checkpoint(i)
            read(lcheckpoint,*)
          end do
          close(lcheckpoint)

          ! reconstructing dets for current state
          do i=istate,istate
            write(6,*)trim(checkpoint(i))
          end do

          ! preparing for point group symmetry
          norb=0
          norbLR=0
          irrep_diff=0
          do j=1,8
             norb          =  norb      +   RGras2(j)
             norbLR        =  norbLR    +   LRras2(j)
             irrep_diff(j) =  RGras2(j) -   LRras2(j)
          end do

          allocate(pre_ele(norbLR)); pre_ele=0
          iorbLR0=1
          iorbLR =0
          irrep_pre=0
          do i=1,8
            iorbLR=iorbLR+LRras2(i)
            if(i.eq.1)then
            else
              irrep_pre=irrep_pre+irrep_diff(i-1)
            end if
            do j=iorbLR0,iorbLR,1
              pre_ele(j)=irrep_pre
              write(6,*)"j,pre_ele(j)",j,pre_ele(j)
            end do
            iorbLR0=iorbLR+1 ! At least work for C1
          end do

          write(6,*)"pre_ele, ndets_RGLR", pre_ele, ndets_RGLR
          write(6,*)"nalpha,  nbeta     ", nele_alpha, nele_beta

          !> DETs read from mclr_dets.initial
          open(UNIT=117,file="mclr_dets.initial",status="OLD")
          allocate(SD_DMRG(ndets_RGLR))
          do idet=1,ndets_RGLR
            allocate(SD_DMRG(idet)%electron(neletol))
            allocate(SD_DMRG(idet)%ele_conf(norb))
            allocate(SD_DMRG(idet)%dv(nstates_RGLR))
            SD_DMRG(idet)%electron=0
            SD_DMRG(idet)%ele_conf=0
            SD_DMRG(idet)%dv=0.0d0
            read(117,"(1X,I8,6X)",advance='no')SD_DMRG(idet)%ITYPE
            do i=1,neletol
              read(117,"(1X,I5)",advance='no')SD_DMRG(idet)%electron(i)
            end do
            read(117,"(5X,I3)",advance='no')SD_DMRG(idet)%isign
            read(117,"(11X,I20)")SD_DMRG(idet)%inum
          end do
          close(117)

          write(6,*)"before get the executable file"

          !> get the executable file
         call systemf("cp /home/eth/yma/Maquis_MPSLR/build/applications/
     &srcas/srcas $PWD",rc)

          write(6,*)"before get the executable file"

          allocate(ele_orb_alpha(norb))
          allocate(ele_orb_beta(norb))
          !> All of the DETs into Maquis format
          open(unit=118,file="dets.mclr")
          do idet=1,ndets_RGLR
!            write(6,*)"idet",idet
            ele_orb_alpha=0
            ele_orb_beta=0
            do i=1,neletol
              if(SD_DMRG(idet)%electron(i)>0)then ! With preconditioner
                j=abs(SD_DMRG(idet)%electron(i))
                ele_orb_alpha(j+pre_ele(j))=1
              else
                j=abs(SD_DMRG(idet)%electron(i))
                ele_orb_beta(j+pre_ele(j))=1
              end if
            end do
            !> The same style also used in Maquis input
            do i=1,norb
              if(ele_orb_alpha(i).eq.1.and.ele_orb_beta(i).eq.1)
     &           SD_DMRG(idet)%ele_conf(i)=4
              if(ele_orb_alpha(i).eq.1.and.ele_orb_beta(i).eq.0)
     &           SD_DMRG(idet)%ele_conf(i)=3
              if(ele_orb_alpha(i).eq.0.and.ele_orb_beta(i).eq.1)
     &           SD_DMRG(idet)%ele_conf(i)=2
              if(ele_orb_alpha(i).eq.0.and.ele_orb_beta(i).eq.0)
     &           SD_DMRG(idet)%ele_conf(i)=1
!             write(6,*)"SD_DMRG(idet)%ele_conf(i)",SD_DMRG(idet)%ele_conf(i)
            end do
            do i=1,norb
              write(118,"(I1)",advance='no')SD_DMRG(idet)%ele_conf(i)
!              write(6,*)"SD_DMRG(idet)%ele_conf(",i,")",
!     &                   SD_DMRG(idet)%ele_conf(i)
            end do
            write(118,*)
          end do
          close(118)

          write(6,*)"After write dets.mclr file"

          !> Test for part of DETS
          !> The way of "open file" need to be written
          !                                   Yingjin 2015.8.13
          call systemf("wc -l dets.mclr > dets.mclr.info",rc)
          open(unit=118,file="dets.mclr.info")
            read(118,*)ndets_total
          close(118)
!         > If too many determinants,
!         > try to use the single, double, triple gradually untill 9999 (as the maximum)
          if(ndets_total.gt.9999)then
            call systemf("head -9999 dets.mclr > ELE_CISR_FOR_MCLR",rc)
          end if

          !> Recover the determinants, off-diagional multiply 2
          !> ========= should be improved by Hash etc. ==========
          do i=istate,istate
             !write(6,*)"SD_DMRG(idet)%dv(i)",i
            open(unit=118,file="GET_COEFF_IN_LIST")
              call f_inquire('ELE_CISR_FOR_MCLR', IFFILE)
              if(IFFILE)then
                tmp_run="./srcas "//trim(checkpoint(i))//
     &       " dets.mclr 1.0 1.0 0 ELE_CISR_FOR_MCLR > "//"CIRE.scratch"
              else
                tmp_run="./srcas "//trim(checkpoint(i))//
     &               " dets.mclr 1.0 1.0 0 dets.mclr > "//"CIRE.scratch"
              end if
              write(118,*)trim(tmp_run)
            close(118)
            call systemf("chmod +x GET_COEFF_IN_LIST",rc)
            call systemf("./GET_COEFF_IN_LIST",rc)
            !> read in the dets-coefficients
            open(unit=118,file="det_coeff.tmp")
            read(118,*)ndets_mclr
            do idet=1,ndets_mclr
              read(118,*)idx_det,SD_DMRG(idx_det)%dv(i)
!              write(6,*)idx_det,SD_DMRG(idx_det)%dv(i)
            end do
            close(118)
            !>  off-diagional multiply 2
            do idet=1,ndets_RGLR
              if(SD_DMRG(idet)%ITYPE.eq.1)then
                SD_DMRG(idet)%dv(i)=-1.0d0*SD_DMRG(idet)%dv(i)
              else
                dtmp=sqrt((SD_DMRG(idet)%dv(i)**2)*2.0d0)
                SD_DMRG(idet)%dv(i)=
     &         -1.0d0*dsign(dtmp,SD_DMRG(idet)%dv(i))
              end if
!              write(6,*)"i,idet,dv",i,idet,SD_DMRG(idet)%dv(i)
            end do
          end do

          dtmp=0.0d0
          indexSD=0
          vector=0.0d0
          do i=1,ndets_RGLR
            indexSD(i)=i !SD_DMRG(i)%inum*SD_DMRG(i)%isign
            vector(i)=SD_DMRG(i)%dv(istate)
            dtmp=dtmp+vector(i)**2
          end do

          write(6,*)"nele_alpha","nele_beta",nele_alpha,nele_beta
          write(6,*)"Total CI weight is ", dtmp
          write(6,*)" ================================================ "
          write(6,*)"  IF for frequency, the CI weight must be  "
          write(6,*)"      very close to 1 (i.e. 0.9999)"
          write(6,*)" ------------------------------------------------ "
          write(6,*)"  IF gradients in state-averaged case,  "
          write(6,*)"      even very few is stil OK (e.g. 0.1)"
          write(6,*)"      however, better around 0.9 "
          write(6,*)" ================================================ "
          call xflush(6)

!          stop

          deallocate(pre_ele)
          deallocate(SD_DMRG)

      end Subroutine ci_reconstruct

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _HDF5_

subroutine one2h5_crtmom(fileid,nSym,nBas)
! SVC: read cartesian moments from the 1-electron integral file
! and write it to the HDF5 file specified with fileid.
! This routine does nothing if HDF5 is not supported.
! FP: also include the origins used for the operators
!
! Datasets:
!   MLTPL_X, MLTPL_Y, MLTPL_Z
!   MLTPL_XX, MLTPL_YY, MLTPL_ZZ, MLTPL_XY, MLTPL_YZ, MLTPL_XZ
!   MLTPL_ORIG

use Symmetry_Info, only: Mul
use mh5, only: mh5_close_dset, mh5_create_dset_real, mh5_init_attr, mh5_put_dset
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: fileid, nSym, nBas(nSym)
integer(kind=iwp) :: dsetid, i, iBas, iComp, iOff, iOpt, iRc, iScrOff, iSym, iSyMsk, j, jBas, jOff, jsym, msym, nB1, nB2, nbast
real(kind=wp) :: mp_orig(3,3)
character(len=8) :: Label
real(kind=wp), allocatable :: MLTPL(:,:), Scratch(:)
character(len=*), parameter :: mltpl1_comp(3) = ['X','Y','Z'], mltpl2_comp(6) = ['XX','XY','XZ','YY','YZ','ZZ']

nbast = 0
do iSym=1,nSym
  nbast = nbast+nBas(iSym)
end do

mp_orig(:,:) = 0.

call mma_allocate(MLTPL,NBAST,NBAST)
call mma_allocate(Scratch,NBAST**2+3)

do icomp=1,3
  MLTPL = Zero
  iRc = -1
  iOpt = 4
  iSyMsk = 0
  Label = 'Mltpl  1'
  call RdOne(iRc,iOpt,Label,iComp,Scratch,iSyMsk)
  ! iSyMsk tells us which symmetry combination is valid
  iScrOff = 0
  iOff = 0
  do iSym=1,nSym
    jOff = 0
    nB1 = nBas(iSym)
    do jSym=1,iSym
      mSym = Mul(iSym,jSym)
      nB2 = nBas(jSym)
      if (btest(iSyMsk,mSym-1)) then
        if (iSym == jSym) then
          do j=1,nB2
            jBas = jOff+j
            do i=1,j
              iBas = iOff+i
              MLTPL(iBas,jBas) = Scratch(1+iScrOff)
              iScrOff = iScrOff+1
            end do
          end do
        else
          do j=1,nB2
            jBas = jOff+j
            do i=1,nB1
              iBas = iOff+i
              MLTPL(jBas,iBas) = Scratch(1+iScrOff)
              iScrOff = iScrOff+1
            end do
          end do
        end if
      end if
      jOff = jOff+nB2
    end do
    iOff = iOff+nB1
  end do
  do j=1,nBasT
    do i=1,j-1
      MLTPL(j,i) = MLTPL(i,j)
    end do
  end do
  dsetid = mh5_create_dset_real(fileid,'AO_MLTPL_'//mltpl1_comp(icomp),2,[NBAST,NBAST])
  call mh5_init_attr(dsetid,'DESCRIPTION', &
                     '1st-order multipole matrix of the atomic orbitals, arranged as matrix of size [NBAST,NBAST]')
  call mh5_put_dset(dsetid,MLTPL)
  call mh5_close_dset(dsetid)
end do

mp_orig(1:3,2) = Scratch(iScrOff+1:iScrOff+3)

do icomp=1,6
  MLTPL = Zero
  iRc = -1
  iOpt = 4
  iSyMsk = 0
  Label = 'Mltpl  2'
  call RdOne(iRc,iOpt,Label,iComp,Scratch,iSyMsk)
  ! iSyMsk tells us which symmetry combination is valid
  iScrOff = 0
  iOff = 0
  do iSym=1,nSym
    jOff = 0
    nB1 = nBas(iSym)
    do jSym=1,iSym
      mSym = Mul(iSym,jSym)
      nB2 = nBas(jSym)
      if (btest(iSyMsk,mSym-1)) then
        if (iSym == jSym) then
          do j=1,nB2
            jBas = jOff+j
            do i=1,j
              iBas = iOff+i
              MLTPL(iBas,jBas) = Scratch(1+iScrOff)
              iScrOff = iScrOff+1
            end do
          end do
        else
          do j=1,nB2
            jBas = jOff+j
            do i=1,nB1
              iBas = iOff+i
              MLTPL(jBas,iBas) = Scratch(1+iScrOff)
              iScrOff = iScrOff+1
            end do
          end do
        end if
      end if
      jOff = jOff+nB2
    end do
    iOff = iOff+nB1
  end do
  do j=1,nBasT
    do i=1,j-1
      MLTPL(j,i) = MLTPL(i,j)
    end do
  end do
  dsetid = mh5_create_dset_real(fileid,'AO_MLTPL_'//mltpl2_comp(icomp),2,[NBAST,NBAST])
  call mh5_init_attr(dsetid,'DESCRIPTION', &
                     '2nd-order multipole matrix of the atomic orbitals, arranged as matrix of size [NBAST,NBAST]')
  call mh5_put_dset(dsetid,MLTPL)
  call mh5_close_dset(dsetid)
end do

mp_orig(1:3,3) = Scratch(iScrOff+1:iScrOff+3)

call mma_deallocate(MLTPL)
call mma_deallocate(Scratch)

dsetid = mh5_create_dset_real(fileid,'MLTPL_ORIG',2,[3,3])
call mh5_init_attr(dsetid,'DESCRIPTION','Origin used for the multipole moment operators: arranged as overlap, dipole, quadrupole')
call mh5_put_dset(dsetid,mp_orig,[3,3],[0,0])
call mh5_close_dset(dsetid)

end subroutine one2h5_crtmom

#elif !defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(one2h5_crtmom)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RSTD_GETIND2()
!
! Purpose: read mapping arrays for diagonal restart.

use Cholesky, only: IndRed, IndRSh, LuRed, nnBstRT, nnShl, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IADR, IOPT, LEN0, LEN1, LEN2

LEN0 = NSYM*NNSHL
LEN1 = NNBSTRT(1)
LEN2 = LEN1
IOPT = 2
IADR = LEN0
call IDAFILE(LURED,IOPT,INDRED,LEN1,IADR)
IOPT = 2
IADR = LEN0+LEN1
call IDAFILE(LURED,IOPT,INDRSH,LEN2,IADR)

end subroutine CHO_RSTD_GETIND2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine applyh_cvb(civec)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
#include "casvb.fh"
#include "rasscf_lucia.fh"
      dimension civec(*)
      save thr2
      data thr2/1.d-20/

      kH0_Pointer = lw1_cvb
      icivec=nint(civec(1))
      c_daxpy=zero

      n_applyh=n_applyh+1
      call setcnt2_cvb(icivec,0)
      if(iform_ci(icivec).ne.0)then
        write(6,*)' Unsupported format in APPLYH :',iform_ci(icivec)
        call abend_cvb()
      endif

c  (NIRREP may be altered in loop)
      isymmx=nirrep
      do 1000 isyml=1,isymmx
      nci=ncivb(isyml)
      lcim=mstackrz_cvb(nci)
      ibasemx=max(ibasemx,mstackr_cvb(0))
      call vb2mol_cvb(work(iaddr_ci(icivec)),work(lcim),isyml)

c  If only one irrep present keep down memory requirements:
      if(isymmx.gt.1.and.nci.ne.ndet)then
        lcim2=mstackrz_cvb(nci)
        ibasemx=max(ibasemx,mstackr_cvb(0))
        cnrm=ddot_(nci,work(lcim),1,work(lcim),1)
c  If anything there, apply Hamiltonian to vector of this symmetry :
        if(cnrm.gt.thr2)then
          call sigmadet_cvb(work(lcim),work(lcim2),isyml,nci)
          if(c_daxpy.ne.zero)
     >      call daxpy_(nci,c_daxpy,work(lcim),1,work(lcim2),1)
        else
          if(c_daxpy.ne.zero)
     >      call daxpy_(nci,c_daxpy,work(lcim),1,work(lcim2),1)
        endif
        call mol2vb_cvb(work(iaddr_ci(icivec)),work(lcim2),isyml)
        call mfreer_cvb(lcim2)
      else
        call fzero(work(iaddr_ci(icivec)),nci)
        cnrm=ddot_(nci,work(lcim),1,work(lcim),1)
c  If anything there, apply Hamiltonian to vector of this symmetry :
        if(cnrm.gt.thr2)then
          call fzero(work(iaddr_ci(icivec)),nci)
          call sigmadet_cvb(work(lcim),work(iaddr_ci(icivec)),isyml,nci)
          if(c_daxpy.ne.zero)
     >      call daxpy_(nci,c_daxpy,work(lcim),1,work(iaddr_ci(icivec)),
     >                  1)
          call fmove_cvb(work(iaddr_ci(icivec)),work(lcim),nci)
        else
          if(c_daxpy.ne.zero)
     >      call daxpy_(nci,c_daxpy,work(lcim),1,work(iaddr_ci(icivec)),
     >                  1)
          call fmove_cvb(work(iaddr_ci(icivec)),work(lcim),nci)
        endif
        call mol2vb_cvb(work(iaddr_ci(icivec)),work(lcim),isyml)
      endif
      call mfreer_cvb(lcim)
1000  continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
      SUBROUTINE Restart_SurfaceHop
      use Tully_variables
      IMPLICIT NONE
#ifdef _HDF5_
#include "surfacehop.fh"
#include "stdalloc.fh"
      INTEGER             ::    i,nstates,nconfs,restart_fileid
      Character           ::    tmp*256,sFile*128
      LOGICAL             ::    Exist
      real*8              ::    dt
      real*8, allocatable ::    ener(:),ciarray(:),real_amatrix(:),
     &                          imag_amatrix(:)
      complex*16, allocatable :: amatrix(:)

      write(6,'(A)') 'Restarting surfacehop from h5 file', file_h5res

C Check the file exists
      call f_inquire(sFile,Exist)
      if(.not.Exist) then
        call getenvf('MOLCAS_SUBMIT_DIR',tmp)
        if(tmp.ne.' ') then
          i=index(tmp,' ')
          if(i.gt.0) then
            sFile=tmp(1:i-1)//'/'//file_h5res
            call f_inquire(sFile,Exist)
          endif
        endif
        if(.not.Exist) then
          Call WarningMessage(2,'File '//
     &                        sFile//' is not found')
          call Quit_OnUserError()
        endif
      endif

C Save on the RUNFILE information for DYNAMIX
      call restart_dynamix(file_h5res)

      call Get_dScalar('Timestep',DT)
      NSUBSTEPS=Int(200*DT/41.3)
      restart_fileid = mh5_open_file_r(sFile)
      call mh5_fetch_attr(restart_fileid,'NSTATES',nstates)
      call mh5_fetch_attr(restart_fileid,'NCONFS',nconfs)

C Save on the RUNFILE information for SURFACEHOP now

C read seed number and save in RunFile
      call mh5_fetch_dset_scalar_int(restart_fileid,'SEED',i)
      CALL Put_iScalar('Seed',i)

C read number of hops and save in RunFile
      if (mh5_exists_attr(restart_fileid,'NO. OF HOPS')) then
        call mh5_fetch_dset_scalar_int(restart_fileid,'NO. OF HOPS',i)
        CALL Put_iScalar('Number of Hops',i)
      endif

C read max hop for Tully and save in RunFile
      if (mh5_exists_dset(restart_fileid,'MAX_HOP_TULLY')) then
        call mh5_fetch_dset_scalar_int(restart_fileid,'MAX_HOP_TULLY',i)
        CALL Put_iScalar('MaxHopsTully',i)
      endif

C read relax root number and save in RunFile
      call mh5_fetch_dset_scalar_int(restart_fileid,'Relax CAS root',i)
      CALL Put_iScalar('Relax CASSCF root',i)

C read the energies of the previous step and save in RunFile
      CALL mma_allocate(ener,nstates)
      call mh5_fetch_dset_array_real(restart_fileid,'Energ Prev',ener)
      CALL Put_darray('VenergyP',ener,nstates)
      CALL mma_deallocate(ener)

C read the CI arrays of the previous step and save in RunFile
      CALL mma_allocate(ciarray,nstates*nconfs)
      call mh5_fetch_dset_array_real(restart_fileid,'CI Prev',ciarray)
      CALL Put_darray('AllCIP',ciarray,nstates*nconfs)
      CALL mma_deallocate(ciarray)

C read the CI arrays of the step before the previous step and save in RunFile
      CALL mma_allocate(ciarray,nstates*nconfs)
      call mh5_fetch_dset_array_real(restart_fileid,'CI PPrev',ciarray)
      CALL Put_darray('AllCIPP',ciarray,nstates*nconfs)
      CALL mma_deallocate(ciarray)

C read the AmatrixV and save in RunFile
      CALL mma_allocate(real_amatrix,nstates*nstates)
      CALL mma_allocate(imag_amatrix,nstates*nstates)
      CALL mma_allocate(amatrix,nstates*nstates)
      call mh5_fetch_dset_array_real(restart_fileid,'AmatrixV-R'
     &          ,real_amatrix)
      call mh5_fetch_dset_array_real(restart_fileid,'AmatrixV-I'
     &          ,imag_amatrix)
      amatrix(:) = DCMPLX(real_amatrix,imag_amatrix)
      CALL Put_zarray('AmatrixV',amatrix,nstates*nstates)
      CALL mma_deallocate(amatrix)
      CALL mma_deallocate(real_amatrix)
      CALL mma_deallocate(imag_amatrix)

      call mh5_close_file(restart_fileid)

#endif
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Markus P. Fuelscher                              *
!***********************************************************************

subroutine PKVEC(NITEM,CVEC,ICVEC)
!***********************************************************************
!
! PURPOSE:
! ENCODE THE CI-VECTOR BY CHANGING THE NUMBER REPRESENTATION FROM
! REAL*8 ==> INTEGER*4
!
! NOTE:
! THE INCOMING DATA CVEC SHOULD NOT BE GREATER THAN 1.0.
! THE ACCURACY OF THE UNPACKED VALUES IS APPROX. 1.0e-9.
!
!**** M.P. FUELSCHER, UNIVERSITY OF LUND, SWEDEN, NOV. 1990 ************

use Definitions, only: wp, iwp
#ifdef _CYGWIN_
use Definitions, only: r4
#endif

implicit none
integer(kind=iwp), intent(in) :: NITEM
real(kind=wp), intent(in) :: CVEC(NITEM)
integer(kind=iwp), intent(out) :: ICVEC(NITEM)
integer(kind=iwp) :: ITEM
real(kind=wp), parameter :: SCL = 2147483647.0_wp
#ifdef _CYGWIN_
! NOTE VERY CAREFULLY!! NINT() (and maybe similar) intrinsics
! are BROKEN in CYGWIN GFORTAN!!
! So the intermediate variable tmp is necessary for it to work!
real(kind=r4) :: tmp
#endif

do ITEM=1,NITEM
# ifdef _CYGWIN_
  tmp = SCL*CVEC(ITEM)
  ICVEC(ITEM) = nint(tmp)
# else
  ICVEC(ITEM) = nint(SCL*CVEC(ITEM))
# endif
end do

return

end subroutine PKVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Ignacio Fdez. Galvan                             *
!***********************************************************************

module Functionals

use libxc_parameters, only: nFuncs_max
use nq_Info, only: Functional_Type, GGA_Type, LDA_Type, meta_GGA_Type1, meta_GGA_Type2, Other_Type
use Constants, only: Zero
use Definitions, only: wp, iwp, LibxcInt

implicit none
private

! Def_* variables are a cache of last read values, so the database file
! does not need to be re-read over and over

integer(kind=iwp) :: Def_Functional_Type = Other_Type, Def_nFuncs = 0
integer(kind=LibxcInt) :: Def_func_id(nFuncs_max) = -1_LibxcInt
real(kind=wp) :: Def_Coeffs(nFuncs_max) = Zero, Def_ExFac = Zero
character(len=80) :: Def_Label = ''
character(len=*), parameter :: Custom_File = 'CUSTFUNC', Custom_Func = '-999_CUSTOM_FUNCTIONAL'

public :: Custom_File, Custom_Func, Get_Func_ExFac, Get_Funcs, Init_Funcs, Print_Info

contains

subroutine Init_Funcs(Label)

  use fortran_strings, only: to_upper

  character(len=*), intent(in) :: Label
  character(len=len(Label)) :: UpLabel

  UpLabel = to_upper(Label)
  if (UpLabel /= Def_Label) call Find_Functional(UpLabel)

end subroutine Init_Funcs

function Get_Func_ExFac(Label)

  real(kind=wp) :: Get_Func_Exfac
  character(len=*), intent(in) :: Label

  call Init_Funcs(Label)
  Get_Func_ExFac = Def_ExFac

end function Get_Func_ExFac

subroutine Get_Funcs(Label)

  use libxc_parameters, only: Coeffs, func_id, nFuncs

  character(len=*), intent(in) :: Label

  call Init_Funcs(Label)
  nFuncs = Def_nFuncs
  Coeffs(1:Def_nFuncs) = Def_Coeffs(1:Def_nFuncs)
  func_id(1:Def_nFuncs) = Def_func_id(1:Def_nFuncs)
  Functional_Type = Def_Functional_Type

end subroutine Get_Funcs

subroutine Print_Info()

  use xc_f03_lib_m, only: xc_f03_func_end, xc_f03_func_get_info, xc_f03_func_info_get_name, xc_f03_func_info_get_references, &
                          xc_f03_func_info_t, xc_f03_func_init, xc_f03_func_reference_get_doi, xc_f03_func_reference_get_ref, &
                          xc_f03_func_reference_t, xc_f03_func_t, XC_UNPOLARIZED
  use Definitions, only: u6

  integer(kind=iwp) :: i, old_j
  integer(kind=LibxcInt) :: j
  type(xc_f03_func_t) :: func
  type(xc_f03_func_info_t) :: info
  type(xc_f03_func_reference_t) :: ref

  if (Def_nFuncs < 1) return

  write(u6,*)
  do i=1,Def_nFuncs
    call xc_f03_func_init(func,Def_func_id(i),xc_unpolarized)
    info = xc_f03_func_get_info(func)
    write(u6,100) trim(xc_f03_func_info_get_name(info))
    ! old_j is a workaround for a bug in Libxc 5.2.0
    old_j = -1
    j = 0
    do while ((j >= 0) .and. (j /= old_j))
      old_j = j
      ref = xc_f03_func_info_get_references(info,j)
      write(u6,101) trim(xc_f03_func_reference_get_ref(ref)),trim(xc_f03_func_reference_get_doi(ref))
    end do
    call xc_f03_func_end(func)
  end do

100 format(6x,'* ',a)
101 format(8x,'- ',a,' doi:',a)

end subroutine Print_Info

! Read functional database file and assign DFT parameters according to the chosen functional
subroutine Find_Functional(Label)

  use xc_f03_lib_m, only: xc_f03_func_end, xc_f03_func_get_info, xc_f03_func_info_get_family, xc_f03_func_info_get_flags, &
                          xc_f03_func_info_t, xc_f03_func_init, xc_f03_func_t, xc_f03_hyb_exx_coef, XC_FAMILY_GGA, &
                          XC_FAMILY_HYB_GGA, XC_FAMILY_HYB_LDA, XC_FAMILY_HYB_MGGA, XC_FAMILY_LDA, XC_FAMILY_MGGA, &
                          XC_FLAGS_NEEDS_LAPLACIAN, XC_UNPOLARIZED
  use fortran_strings, only: to_upper
  use Constants, only: One
  use Definitions, only: u6

  character(len=*), intent(in) :: Label
  integer(kind=iwp) :: i, istatus, Lu, nComp
  integer(kind=LibxcInt) :: flags(nFuncs_max)
  real(kind=wp) :: Coeff
  character(len=256) :: Line
  character(len=80) :: Labels(nFuncs_max), Word1, Word2
  integer(kind=iwp), external :: IsFreeUnit
  type(xc_f03_func_t) :: func(nFuncs_max)
  type(xc_f03_func_info_t) :: info(nFuncs_max)

  Def_ExFac = Zero
  Def_nFuncs = 0

  ! First test if this is already a Libxc functional
  Def_func_id(1) = get_func(Label,test=.true.)
  if (Def_func_id(1) >= 0) then

    Def_nFuncs = 1
    Def_Coeffs(1) = One
    Labels(1) = Label

  else

    ! If not, we have to read the database file, or the custom functional file
    Lu = IsFreeUnit(11)
    if (Label == Custom_Func) then
      call molcas_open(Lu,Custom_File)
    else
      call molcas_open(Lu,'FUNCDATA')
    end if

    ! Find the line that starts with the keyword name
    do
      read(Lu,'(A)',iostat=istatus) Line
      if (istatus /= 0) then
        call WarningMessage(2,' Find_Functional: Undefined functional type!')
        write(u6,*) '         Functional=',trim(Label)
        call Quit_OnUserError()
      end if
      Line = adjustl(Line)
      if ((Line == '') .or. (Line(1:1) == '#')) cycle
      read(Line,*) Word1,Word2
      if (to_upper(Word1) == Label) exit
    end do

    ! Once found, read the second word
    read(Word2,*,iostat=istatus) nComp
    if (istatus == 0) then
      ! If it's a number, read the component functionals and factors
      if (Def_nFuncs > nFuncs_max) then
        call WarningMessage(2,' Find_Functional: Too many components!')
        write(u6,*) '         nFuncs=',Def_nFuncs
        call Quit_OnUserError()
      end if
      i = 0
      do while (i < nComp)
        read(Lu,'(A)',iostat=istatus) Line
        if (istatus /= 0) then
          call WarningMessage(2,' Find_Functional: Error in functional definition!')
          write(u6,*) '         Functional=',trim(Label)
          call Quit_OnUserError()
        end if
        Line = adjustl(Line)
        if ((Line == '') .or. (Line(1:1) == '#')) cycle
        i = i+1
        read(Line,*,iostat=istatus) Coeff,Word2
        if (istatus /= 0) then
          call WarningMessage(2,' Find_Functional: Error in functional definition!')
          write(u6,*) '         Functional=',trim(Label)
          call Quit_OnUserError()
        end if
        ! HF_X means exact exchange
        if (to_upper(Word2) == 'HF_X') then
          Def_ExFac = Def_ExFac+Coeff
        else
          Def_nFuncs = Def_nFuncs+1
          Def_Coeffs(Def_nFuncs) = Coeff
          Def_func_id(Def_nFuncs) = get_func(Word2)
          Labels(Def_nFuncs) = Word2
        end if
      end do
    else
      ! Otherwise, this is just an alias for a Libxc functional
      Def_nFuncs = 1
      Def_Coeffs(1) = One
      Def_func_id(1) = get_func(Word2)
      Labels(1) = Word2
    end if

    close(Lu)

  end if

  ! Now process the functional(s)

  do i=1,Def_nFuncs
    call xc_f03_func_init(func(i),Def_func_id(i),XC_UNPOLARIZED)
    info(i) = xc_f03_func_get_info(func(i))
    flags(i) = xc_f03_func_info_get_flags(info(i))
  end do

  Def_Functional_Type = Other_Type
  do i=1,Def_nFuncs
    ! Check whether the functional uses some unsupported feature
    call check_supported(Labels(i),flags(i))
    ! Add exact exchange from components
    Def_ExFac = Def_ExFac+Def_Coeffs(i)*xc_f03_hyb_exx_coef(func(i))
    ! Assign functional type ("maximum" of its components)
    select case (xc_f03_func_info_get_family(info(i)))
      case (XC_FAMILY_LDA,XC_FAMILY_HYB_LDA)
        Def_Functional_type = max(Def_Functional_type,LDA_type)
      case (XC_FAMILY_GGA,XC_FAMILY_HYB_GGA)
        Def_Functional_type = max(Def_Functional_type,GGA_type)
      case (XC_FAMILY_MGGA,XC_FAMILY_HYB_MGGA)
        if (iand(flags(i),XC_FLAGS_NEEDS_LAPLACIAN) > 0) then
          Def_Functional_type = max(Def_Functional_type,meta_GGA_type2)
        else
          Def_Functional_type = max(Def_Functional_type,meta_GGA_type1)
        end if
    end select
  end do

  do i=1,Def_nFuncs
    call xc_f03_func_end(func(i))
  end do

  Def_Label = Label

end subroutine Find_Functional

function get_func(xcLabel,test)

  use xc_f03_lib_m, only: xc_f03_functional_get_number
  use Definitions, only: u6

  integer(kind=LibxcInt) :: get_func
  character(len=*), intent(in) :: xcLabel
  logical(kind=iwp), intent(in), optional :: test
  logical(kind=iwp) :: do_test

  if (present(test)) then
    do_test = test
  else
    do_test = .false.
  end if

  get_func = xc_f03_functional_get_number(xcLabel)
  if ((get_func < 0) .and. (.not. do_test)) then
    call WarningMessage(2,' Find_Functional: Undefined functional in Libxc!')
    write(u6,*) '         Functional=',trim(xcLabel)
    call Quit_OnUserError()
  end if

end function get_func

subroutine check_supported(Label,flags)

  use xc_f03_lib_m, only: XC_FLAGS_HYB_CAM, XC_FLAGS_HYB_CAMY, XC_FLAGS_HYB_LC, XC_FLAGS_HYB_LCY, XC_FLAGS_VV10
  use Definitions, only: u6

  character(len=*), intent(in) :: Label
  integer(kind=LibxcInt), intent(in) :: flags
  integer(kind=iwp) :: lev, lt, maxlev

  maxlev = 0
  lt = len_trim(Label)

  if ((iand(flags,XC_FLAGS_HYB_CAM) > 0) .or. (iand(flags,XC_FLAGS_HYB_CAMY) > 0) .or. (iand(flags,XC_FLAGS_HYB_LC) > 0) .or. &
      (iand(flags,XC_FLAGS_HYB_LCY) > 0)) then
    lev = 2
    maxlev = max(lev,maxlev)
    call WarningMessage(lev,' Find_Functional: Range separation is not supported!')
  end if
  if ((iand(flags,XC_FLAGS_VV10) > 0)) then
    lev = 2
    maxlev = max(lev,maxlev)
    call WarningMessage(lev,' Find_Functional: Non-local correlation is not supported!')
  end if
  if ((Label(lt-1:lt) == '_D') .or. (Label(lt-2:lt) == '_D3')) then
    lev = 1 ! make it just a warning for now
    maxlev = max(lev,maxlev)
    call WarningMessage(lev,' Find_Functional: Dispersion corrections are not implemented!')
  end if
  if (maxlev > 0) write(u6,*) '         Functional=',trim(Label)
  if (maxlev > 1) call Quit_OnUserError()

end subroutine check_supported

end module Functionals

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakeWwHlp2(Ww,W1,dima,dimb,dimab,dimbe,dimga,key)
! this routine does:
! Make Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
! for the case a"=b" , be"/=ga"
! N.B. algoritmus nieje prilis vymakany
!
! parameter description
! Ww   - array for Ww+(-) (O)
! W1   - array for W1(a",be",b",ga") (I)
! dimx - dimension of a",b",ab",be",ga" (I)
! key  - 1 - calc Ww+, 2 - calc Ww- (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimab, dimbe, dimga, key
real(kind=wp), intent(out) :: Ww(dimab,dimbe,dimga)
real(kind=wp), intent(in) :: W1(dima,dimbe,dimb,dimga)
integer(kind=iwp) :: a, ab, be

if (key == 1) then
  do be=1,dimbe
    ab = 0
    do a=2,dima
      Ww(ab+1:ab+a-1,be,:) = W1(a,be,1:a-1,:)+W1(1:a-1,be,a,:)
      ab = ab+a-1
    end do
  end do
else
  do be=1,dimbe
    ab = 0
    do a=2,dima
      Ww(ab+1:ab+a-1,be,:) = W1(a,be,1:a-1,:)-W1(1:a-1,be,a,:)
      ab = ab+a-1
    end do
  end do
end if

! Cely clen ma Faktor 2, tu teda nevydelim 2
!Ww(:,:,:) = Half*Ww(:,:,:)

return

end subroutine MakeWwHlp2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************

subroutine CMSOpt(TUVX)
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 07, 2022, created this file.               *
! ****************************************************************

use CMS, only: CMSNotConverged, RGD
use rasscf_global, only: CMSStartMat, lRoots, NAC, NACPR2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: TUVX(NACPR2)
integer(kind=iwp) :: lRoots2, NAC2, nGD, nTUVX
real(kind=wp), allocatable :: Dgorbit(:), Dgstate(:), GDorbit(:), GDstate(:), Gtuvx(:), RotMat(:,:)
#include "warnings.h"

!*****************************************************************
!     some notes on the arrays:                                  *
!     Gtuvx : two-electron integral, g_tuvx                      *
!     GD    : "generalized 1-e density matrix"                   *
!              GD^KL: transition density matrix from L to K      *
!              GD^KK: density matrix for state K                 *
!     Dg    :  sum_{vx}{GD^KL_vx * g_tuvx}                       *
!     In GDorbit and Dgorbit, the leading index is orbital index;*
!     In GDstate and Dgstate, the leading index is state index.  *
!                                                                *
!     DDg   :  sum_{tuvx}{GD^KL_tu * GD^MN_vx * g_tuvx}          *
!      namely, sum_{tu}{GD^KL_tu * Dg^MN_tu}                     *
!*****************************************************************

NAC2 = NAC**2
nTUVX = NAC2**2
lRoots2 = lRoots**2
nGD = lRoots2*NAC2

CMSNotConverged = .true.

! Memory Allocation
call mma_allocate(GDstate,nGD)
call mma_allocate(Dgstate,nGD)
call mma_allocate(GDorbit,nGD)
call mma_allocate(Dgorbit,nGD)
call mma_allocate(Gtuvx,nTUVX)
call mma_allocate(RGD,lRoots2)
call mma_allocate(RotMat,lRoots,lRoots)

! Calculate generalized density mtrix
call LoadGtuvx(TUVX,Gtuvx)

!write(u6,*) 'Gtuvx matrix'
!call RecPrt(' ',' ',Gtuvx,NAC2,NAC2)

call CalcGD(GDorbit,nGD)
!write(u6,*) 'GD matrix orbital-leading'
!call RecPrt(' ',' ',GDorbit,NAC2,lRoots2)
call DGEMM_('T','N',NAC**2,lRoots**2,NAC**2,One,Gtuvx,NAC**2,GDorbit,NAC**2,Zero,Dgorbit,NAC**2)
!write(u6,*) 'Dg matrix orbital-leading'
!call RecPrt(' ',' ',Dgorbit,NAC2,lRoots2)

call mma_deallocate(Gtuvx)

call Trnsps(NAC2,lRoots2,Dgorbit,Dgstate)
call Trnsps(NAC2,lRoots2,GDorbit,GDstate)

! Load initial rotation matrix
call InitRotMat(RotMat,lRoots,trim(CMSStartMat),len_trim(CMSStartMat))

! Print header of CMS iterations
call CMSHeader(trim(CMSStartMat))

! Start CMS Optimization
CMSNotConverged = .true.
call CMSNewton(RotMat,GDorbit,GDstate,Dgorbit,Dgstate,nGD)

! Print end of CMS intermediate-state optimization
call CMSTail()

! Save rotation matrix
call PrintMat('ROT_VEC','CMS-PDFT',RotMat,lroots,lroots,7,8,'T')

! releasing memory
call mma_deallocate(GDstate)
call mma_deallocate(Dgstate)
call mma_deallocate(GDorbit)
call mma_deallocate(Dgorbit)
call mma_deallocate(RGD)
call mma_deallocate(RotMat)

! check convergence
if (CMSNotConverged) then
  call WarningMessage(2,'CMS Intermediate States Not Converged')
  call Quit(_RC_NOT_CONVERGED_)
end if

end subroutine CMSOpt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Chad E. Hoyer                                          *
************************************************************************
*  DQVDiabat
*
*> @brief
*>   Compute diabats with DQV
*> @author C. E. Hoyer
*>
*> @details
*> This subroutine takes in properties that have been
*> computed by RASSI and uses them to compute diabatic
*> states and thus diabatic energies and couplings.
*> Currently, the user must compute x, y, z, xx,
*> yy, zz, and 1/r, and they must be computed in that
*> order.
*>
*> @param[in] PROP Properties computed in RASSI
************************************************************************
      SUBROUTINE DQVDiabat(PROP,HAM)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='DQVDiabat')
#include "rasdef.fh"
#include "symmul.fh"
#include "rassi.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "Files.fh"
#include "Struct.fh"
#include "tshcntrl.fh"
#include "constants2.fh"
      REAL*8 PROP(NSTATE,NSTATE,NPROP)
      REAL*8 TROT(NSTATE,NSTATE)
      REAL*8 TRQ(NSTATE,NSTATE)
      REAL*8 TROTT(NSTATE,NSTATE)
      REAL*8 HDIA(NSTATE,NSTATE)
      REAL*8 HDIAI(NSTATE,NSTATE)
      REAL*8 HAMT(NSTATE,NSTATE)
      REAL*8 HAM(NSTATE,NSTATE)

*  These are the blocks of parameters
      INTEGER, PARAMETER :: MAX=50
      REAL*8, PARAMETER :: MTE=1.0D-8, MTF=1.0D-14
      REAL*8, PARAMETER :: THRS=1.0D-8
      INTEGER :: PNUM(7)

*



*
* Printing some stuff
*
      WRITE(6,*)
      WRITE(6,*)
      WRITE(6,'(6X,100A1)') ('*',i=1,100)
      WRITE(6,'(6X,A,98X,A)') '*','*'
      WRITE(6,'(6X,A,33X,A,34X,A)')
     &     '*',' The DQV Diabatization Section ','*'
      WRITE(6,'(6X,A,98X,A)') '*','*'
      WRITE(6,'(6X,100A1)') ('*',i=1,100)
      WRITE(6,*)
      WRITE(6,*)

      Call CollapseOutput(1,'DQV Diabatization section')
      WRITE(6,'(3X,A)')     '-------------------------'

* Find the properties we need
      DO IPROP=1,7
        PNUM(IPROP)=0
      END DO
      DO IPROP=1,NPROP
        IF (PNAME(IPROP).EQ.'MLTPL  1') THEN
          IF (ICOMP(IPROP).EQ.1) PNUM(1)=IPROP
          IF (ICOMP(IPROP).EQ.2) PNUM(2)=IPROP
          IF (ICOMP(IPROP).EQ.3) PNUM(3)=IPROP
        END IF
        IF (PNAME(IPROP).EQ.'MLTPL  2') THEN
          IF (ICOMP(IPROP).EQ.1) PNUM(4)=IPROP
          IF (ICOMP(IPROP).EQ.4) PNUM(5)=IPROP
          IF (ICOMP(IPROP).EQ.6) PNUM(6)=IPROP
        END IF
        IF (PNAME(IPROP).EQ.'EF0    1') THEN
          IF (ICOMP(IPROP).EQ.1) PNUM(7)=IPROP
        END IF
      END DO
      DO IPROP=1,7
        IF (PNUM(IPROP).EQ.0) THEN
          WRITE(6,*) 'DQVDiabat: '//
     &               'Some required properties are not available'
          CALL Abend()
        END IF
      END DO

* CEH Now we maximize f_DQV through a Jacobi sweep algorithm


* Initialize rotation matrix to unit matrix (theta=0)
        DO ISTA=1, NSTATE
         DO JSTA=1, NSTATE
          TROT(ISTA,JSTA) = 0.0D0
          IF (ISTA .eq. JSTA) THEN
           TROT(ISTA,JSTA) = 1.0D0
          END IF
         END DO
       END DO

*Now, we have to form the trace of the quadrupole
*The user has to specify dipole then quadrupole
       DO ISTA=1, NSTATE
        DO JSTA=1, NSTATE
         TRQ(ISTA,JSTA) = PROP(ISTA,JSTA,PNUM(4)) +
     &                    PROP(ISTA,JSTA,PNUM(5)) +
     &                    PROP(ISTA,JSTA,PNUM(6))
        END DO
       END DO

       Call RecPrt('The TRQ matrix in DQVDiabat','',TRQ,NSTATE,NSTATE)
       WRITE(6,*) ''

       DO i=1, MAX
        THRSCH = 0.0D0

        DO ISTA=1, NSTATE
         DO JSTA=ISTA+1, NSTATE

* Equations 9 and 10 of Kleir et al. with \mu written
* as a vector in addition to the quadrupole trace

          ATERM = PROP(ISTA,JSTA,PNUM(1))**2
     &           +PROP(ISTA,JSTA,PNUM(2))**2
     &           +PROP(ISTA,JSTA,PNUM(3))**2
     &           +ALPHZ*TRQ(ISTA,JSTA)**2
     &           +BETAE*PROP(ISTA,JSTA,PNUM(7))**2
     &           -0.25D0*(PROP(ISTA,ISTA,PNUM(1))**2
     &           +PROP(ISTA,ISTA,PNUM(2))**2
     &           +PROP(ISTA,ISTA,PNUM(3))**2
     &           +ALPHZ*TRQ(ISTA,ISTA)**2
     &           +BETAE*PROP(ISTA,ISTA,PNUM(7))**2)
     &           -0.25D0*(PROP(JSTA,JSTA,PNUM(1))**2
     &           +PROP(JSTA,JSTA,PNUM(2))**2
     &           +PROP(JSTA,JSTA,PNUM(3))**2
     &           +ALPHZ*TRQ(JSTA,JSTA)**2
     &           +BETAE*PROP(JSTA,JSTA,PNUM(7))**2)
     &           +0.5D0*
     &           (PROP(ISTA,ISTA,PNUM(1))*PROP(JSTA,JSTA,PNUM(1))
     &           +PROP(ISTA,ISTA,PNUM(2))*PROP(JSTA,JSTA,PNUM(2))
     &           +PROP(ISTA,ISTA,PNUM(3))*PROP(JSTA,JSTA,PNUM(3))
     &           +ALPHZ*TRQ(ISTA,ISTA)*TRQ(JSTA,JSTA)
     &           +BETAE*PROP(ISTA,ISTA,PNUM(7))*PROP(JSTA,JSTA,PNUM(7)))


          BTERM = PROP(ISTA,JSTA,PNUM(1))*(PROP(ISTA,ISTA,PNUM(1))-
     &            PROP(JSTA,JSTA,PNUM(1))) +
     &            PROP(ISTA,JSTA,PNUM(2))*(PROP(ISTA,ISTA,PNUM(2))-
     &            PROP(JSTA,JSTA,PNUM(2))) +
     &            PROP(ISTA,JSTA,PNUM(3))*(PROP(ISTA,ISTA,PNUM(3))-
     &            PROP(JSTA,JSTA,PNUM(3))) +
     &            ALPHZ*TRQ(ISTA,JSTA)*(TRQ(ISTA,ISTA)-TRQ(JSTA,JSTA))
     &            +BETAE*
     &            PROP(ISTA,JSTA,PNUM(7))*(PROP(ISTA,ISTA,PNUM(7))-
     &            PROP(JSTA,JSTA,PNUM(7)))

          IF (ABS(BTERM) .gt. MTF) THEN
           IF((ATERM .gt. MTE) .or. (ATERM .lt. -1.0D0*MTE)) THEN
* This part of the code computes the rotation angle.
            CTERM=-1.0D0*BTERM/ATERM
            ROTANGF = Atan(CTERM)

            IF((ROTANGF .lt. 0.0D0) .and. (BTERM .gt. 0.0D0)) THEN
             ROTANGF = ROTANGF + RPI
            END IF

            IF((ROTANGF .gt. 0.0D0) .and. (BTERM .lt. 0.0D0)) THEN
             ROTANGF = ROTANGF - RPI
            END IF

            ROTANGO = ROTANGF/4.0D0

            IF((ROTANGO .gt. RPI/4.0D0) .or.
     &       (ROTANGO .lt. -RPI/4.0D0)) THEN
             WRITE(6,*) 'Quadrants 2 and 3'
            END IF

            COSO = cos(ROTANGO)
            SINO = sin(ROTANGO)

            ELSE

            WRITE(6,*) 'A is pretty close to zero.  Something is fishy.'
             COSO=0.0D0
             SINO=0.0D0

            END IF

*Equation 13 of Kleir et al.
            CHNG = ATERM + SQRT(ATERM**2+BTERM**2)

            IF(CHNG .gt. THRSCH) THEN
             THRSCH = CHNG
            END IF

            IF(CHNG .gt. MTE) THEN


*Update T rotation matrix
            DO k=1, NSTATE
             T1 = TROT(k,ISTA)
             T2 = TROT(k,JSTA)
             TROT(k,ISTA) = COSO*T1 + SINO*T2
             TROT(k,JSTA) = -1.0D0*SINO*T1 + COSO*T2
            END DO

*Rotates transition dipole matrices
*These equations can be found in a book on Jacobi sweeps

            TII = PROP(ISTA,ISTA,PNUM(1))
            TJJ = PROP(JSTA,JSTA,PNUM(1))
            TIJ = PROP(ISTA,JSTA,PNUM(1))
            DO k=1, NSTATE
             T1 = PROP(ISTA,k,PNUM(1))
             T2 = PROP(JSTA,k,PNUM(1))
             PROP(ISTA,k,PNUM(1)) = COSO*T1 + SINO*T2
             PROP(k,ISTA,PNUM(1)) = PROP(ISTA,k,PNUM(1))
             PROP(JSTA,k,PNUM(1)) = COSO*T2 - SINO*T1
             PROP(k,JSTA,PNUM(1)) = PROP(JSTA,k,PNUM(1))
            END DO
            PROP(ISTA,JSTA,PNUM(1)) = (COSO**2-SINO**2)*TIJ +
     &          COSO*SINO*(TJJ-TII)
            PROP(JSTA,ISTA,PNUM(1)) = PROP(ISTA,JSTA,PNUM(1))
            PROP(ISTA,ISTA,PNUM(1)) = COSO**2*TII + SINO**2*TJJ +
     &          2*COSO*SINO*TIJ
            PROP(JSTA,JSTA,PNUM(1)) = SINO**2*TII + COSO**2*TJJ -
     &          2*COSO*SINO*TIJ


            TII = PROP(ISTA,ISTA,PNUM(2))
            TJJ = PROP(JSTA,JSTA,PNUM(2))
            TIJ = PROP(ISTA,JSTA,PNUM(2))
            DO k=1, NSTATE
             T1 = PROP(ISTA,k,PNUM(2))
             T2 = PROP(JSTA,k,PNUM(2))
             PROP(ISTA,k,PNUM(2)) = COSO*T1 + SINO*T2
             PROP(k,ISTA,PNUM(2)) = PROP(ISTA,k,PNUM(2))
             PROP(JSTA,k,PNUM(2)) = COSO*T2 - SINO*T1
             PROP(k,JSTA,PNUM(2)) = PROP(JSTA,k,PNUM(2))
            END DO
            PROP(ISTA,JSTA,PNUM(2)) = (COSO**2-SINO**2)*TIJ +
     &          COSO*SINO*(TJJ-TII)
            PROP(JSTA,ISTA,PNUM(2)) = PROP(ISTA,JSTA,PNUM(2))
            PROP(ISTA,ISTA,PNUM(2)) = COSO**2*TII + SINO**2*TJJ +
     &          2*COSO*SINO*TIJ
            PROP(JSTA,JSTA,PNUM(2)) = SINO**2*TII + COSO**2*TJJ -
     &          2*COSO*SINO*TIJ


            TII = PROP(ISTA,ISTA,PNUM(3))
            TJJ = PROP(JSTA,JSTA,PNUM(3))
            TIJ = PROP(ISTA,JSTA,PNUM(3))
            DO k=1, NSTATE
             T1 = PROP(ISTA,k,PNUM(3))
             T2 = PROP(JSTA,k,PNUM(3))
             PROP(ISTA,k,PNUM(3)) = COSO*T1 + SINO*T2
             PROP(k,ISTA,PNUM(3)) = PROP(ISTA,k,PNUM(3))
             PROP(JSTA,k,PNUM(3)) = COSO*T2 - SINO*T1
             PROP(k,JSTA,PNUM(3)) = PROP(JSTA,k,PNUM(3))
            END DO
            PROP(ISTA,JSTA,PNUM(3)) = (COSO**2-SINO**2)*TIJ +
     &          COSO*SINO*(TJJ-TII)
            PROP(JSTA,ISTA,PNUM(3)) = PROP(ISTA,JSTA,PNUM(3))
            PROP(ISTA,ISTA,PNUM(3)) = COSO**2*TII + SINO**2*TJJ +
     &          2*COSO*SINO*TIJ
            PROP(JSTA,JSTA,PNUM(3)) = SINO**2*TII + COSO**2*TJJ -
     &          2*COSO*SINO*TIJ

*Rotates trace of quadrupole matrix

            TII = TRQ(ISTA,ISTA)
            TJJ = TRQ(JSTA,JSTA)
            TIJ = TRQ(ISTA,JSTA)
            DO k=1, NSTATE
             T1 = TRQ(ISTA,k)
             T2 = TRQ(JSTA,k)
             TRQ(ISTA,k) = COSO*T1 + SINO*T2
             TRQ(k,ISTA) = TRQ(ISTA,k)
             TRQ(JSTA,k) = COSO*T2 - SINO*T1
             TRQ(k,JSTA) = TRQ(JSTA,k)
            END DO
            TRQ(ISTA,JSTA) = (COSO**2-SINO**2)*TIJ + COSO*SINO*(TJJ-TII)
            TRQ(JSTA,ISTA) = TRQ(ISTA,JSTA)
            TRQ(ISTA,ISTA) = COSO**2*TII + SINO**2*TJJ + 2*COSO*SINO*TIJ
            TRQ(JSTA,JSTA) = SINO**2*TII + COSO**2*TJJ - 2*COSO*SINO*TIJ


*Rotates electric potential
            TII = PROP(ISTA,ISTA,PNUM(7))
            TJJ = PROP(JSTA,JSTA,PNUM(7))
            TIJ = PROP(ISTA,JSTA,PNUM(7))
            DO k=1, NSTATE
             T1 = PROP(ISTA,k,PNUM(7))
             T2 = PROP(JSTA,k,PNUM(7))
             PROP(ISTA,k,PNUM(7)) = COSO*T1 + SINO*T2
             PROP(k,ISTA,PNUM(7)) = PROP(ISTA,k,PNUM(7))
             PROP(JSTA,k,PNUM(7)) = COSO*T2 - SINO*T1
             PROP(k,JSTA,PNUM(7)) = PROP(JSTA,k,PNUM(7))
            END DO
            PROP(ISTA,JSTA,PNUM(7)) = (COSO**2-SINO**2)*TIJ +
     &          COSO*SINO*(TJJ-TII)
            PROP(JSTA,ISTA,PNUM(7)) = PROP(ISTA,JSTA,PNUM(7))
            PROP(ISTA,ISTA,PNUM(7)) = COSO**2*TII + SINO**2*TJJ +
     &          2*COSO*SINO*TIJ
            PROP(JSTA,JSTA,PNUM(7)) = SINO**2*TII + COSO**2*TJJ -
     &          2*COSO*SINO*TIJ

            END IF
           END IF
          END DO
         END DO

         IF(THRSCH .lt. THRS) THEN
          WRITE(6,*) 'Converged in this many iterations:'
          WRITE(6,*) i
          WRITE(6,*) ''
          EXIT
         END IF

         IF(i .eq. MAX) THEN
          write(6,*) 'Max iterations'
         END IF
        END DO

        CALL RecPrt('Diabatic Coefficients','',TROT,NSTATE,NSTATE)

        DO ISTA = 1, NSTATE
         DO JSTA = 1, NSTATE
          TROTT(JSTA,ISTA)=TROT(JSTA,ISTA)**2
         END DO
        END DO
        CALL RecPrt('Weights of adiabatic states','',
     &              TROTT,NSTATE,NSTATE)

        DO ISTA = 1, NSTATE
         DO JSTA = 1, NSTATE
          HAMT(ISTA,JSTA)=HAM(ISTA,JSTA)
         END DO
        END DO

        TROTT = TROT


        CALL DGEMM_('T','N',NSTATE,NSTATE,NSTATE,1.0D0,
     &              TROTT, NSTATE, HAMT, NSTATE, 0.0D0,HDIAI,NSTATE)

        CALL DGEMM_('N','N',NSTATE,NSTATE,NSTATE,1.0D0,
     &              HDIAI, NSTATE, TROTT, NSTATE, 0.0D0,HDIA,NSTATE)

        WRITE(6,*) ''
        WRITE(6,*) 'The eigenvectors may no longer be in'
        WRITE(6,*) 'energetic order'
        WRITE(6,*) ''
        CALL RecPrt('Diabatic Hamiltonian','',HDIA,NSTATE,NSTATE)

        Call CollapseOutput(0,'DQV Diabatization section')
        WRITE(6,*) ''

*Molcas verify calls
       CALL Add_Info('Adiabat1',HAM(1,1),1,4)
       CALL Add_Info('Adiabat2',HAM(2,2),1,4)
       CALL Add_Info('Adiabat3',HAM(3,3),1,4)
       CALL Add_Info('DQVHam11',HDIA(1,1),1,4)
       CALL Add_Info('DQVHam12',HDIA(1,2),1,4)
       CALL Add_Info('DQVHam13',HDIA(1,3),1,4)
       CALL Add_Info('DQVHam22',HDIA(2,2),1,4)
       CALL Add_Info('DQVHam23',HDIA(2,3),1,4)
       CALL Add_Info('DQVHam33',HDIA(3,3),1,4)
*End Molcas verify calls

       RETURN
       END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine symelminp_cvb(ip_symelm,nsyme,tags,izeta,
     >  mxirrep,mxorb,mxsyme,ityp)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "malloc_cvb.fh"
      parameter (nsymelm=5,nsign=2,ncmp=4)
      character*8 symelm(nsymelm),sign(nsign)
      character*3 tags(mxsyme)
      dimension izeta(*)
      dimension ityp(mxorb)
      dimension iaux(1),daux(1)
      save symelm,sign
      data symelm/'IRREPS  ','COEFFS  ','TRANS   ','END     ',
     >            'ENDSYMEL'/
      data sign/'+       ','-       '/
      save zero,one
      data zero/0d0/,one/1d0/

      nsyme=nsyme+1
      if(nsyme.gt.mxsyme)then
        write(6,*)' Too many symmetry elements found :',nsyme,mxsyme
        call abend_cvb()
      endif
      tags(nsyme)=' '
      call string_cvb(tags(nsyme),1,nread,1)
      call fstring_cvb(sign,nsign,isign,ncmp,1)
      if(isign.eq.1)then
        izeta(nsyme)=1
      elseif(isign.eq.2)then
        izeta(nsyme)=-1
      else
        izeta(nsyme)=0
      endif
      call mreallocr_cvb(ip_symelm,mxorb*mxorb*nsyme)
      ishft=mxorb*mxorb*(nsyme-1)
      call mxunit_cvb(w(ishft+ip_symelm),mxorb)

1000  call fstring_cvb(symelm,nsymelm,istr2,ncmp,2)
      if(istr2.eq.1)then
c    'IRREPS'
        do 1100 i=1,mxirrep
        iaux=0
        call int_cvb(iaux,1,nread,0)
        irrep=iaux(1)
        if(irrep.ne.0)then
          do 1200 iorb=1,mxorb
          if(irrep.eq.ityp(iorb))
     >      w(iorb+(iorb-1)*mxorb+ishft+ip_symelm-1)=-one
1200      continue
        endif
1100    continue
      elseif(istr2.eq.2)then
c    'COEFFS'
        do 1300 i=1,mxorb
        iaux=0
        call int_cvb(iaux,1,nread,0)
        iorb=iaux(1)
        if(iorb.ne.0)then
          w(iorb+(iorb-1)*mxorb+ishft+ip_symelm-1)=-one
        else
          goto 1301
        endif
1300    continue
1301    continue
      elseif(istr2.eq.3)then
c    'TRANS'
        iaux=0
        call int_cvb(iaux,1,nread,0)
        idim=iaux(1)
        if(idim.lt.1.or.idim.gt.mxorb)then
          write(6,*)' Illegal dimension in TRANS:',idim,mxorb
          call abend_cvb()
        endif
        itmp = mstacki_cvb(idim)
        do 1400 i=1,idim
        call int_cvb(iaux,1,nread,0)
        iorb=iaux(1)
        if(iorb.lt.1.or.iorb.gt.mxorb)then
          write(6,*)' Illegal orbital number in TRANS:',iorb
          call abend_cvb()
        endif
        iw(i+itmp-1)=iorb
1400    continue
        do 1500 ior=1,idim
        iorb=iw(ior+itmp-1)
        do 1501 jor=1,idim
        jorb=iw(jor+itmp-1)
        daux=zero
        call real_cvb(daux(1),1,nread,0)
        w(iorb+(jorb-1)*mxorb+ishft+ip_symelm-1)=daux(1)
1501    continue
1500    continue
        call mfreei_cvb(itmp)
      endif
c    'END' , 'ENDSYMEL' or unrecognized keyword -- end SYMELM input :
      if(.not.(istr2.eq.4.or.istr2.eq.5.or.istr2.eq.0))goto 1000
      if(.not.mxorth_cvb(w(ishft+ip_symelm),mxorb))then
        write(6,*)' Symmetry element ',tags(nsyme),' not orthogonal!'
        write(6,*)' Check usage of TRANS keyword.'
        call abend_cvb()
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Set2CL(iAtomPair,n2CF_Added)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: Set list of two-center functions for atom pair iAtomPair
C     based on diagonal integrals. On exit, n2CF_Added is the number of
C     two-center funtions added (not the total number; some might be
C     present already).
C
      Implicit None
      Integer iAtomPair
      Integer n2CF_Added
#include "WrkSpc.fh"
#include "localdf.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom

      Character*8 Label

      Integer iAtom, jAtom
      Integer ip_D, l_D
      Integer nBas_iAtom, nBas_jAtom
      Integer uv, nuv
      Integer n2CF_Old
      Integer ip_OldList, l_OldList
      Integer ip_NewList, l_NewList
      Integer ipi, ipj
      Integer iS, jS
      Integer iShell, jShell
      Integer u, v
      Integer i2CFun

      Real*8  Thr

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_2CFunctions
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Init counter
      n2CF_Added=0

      ! Get requested accuracy
      Thr=Thr_Accuracy

      ! Get atoms of atom pair
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)

      ! Get dimensions
      nBas_iAtom=LDF_nBas_Atom(iAtom)
      nBas_jAtom=LDF_nBas_Atom(jAtom)

      ! Get pointer to diagonals
      If (iAtom.eq.jAtom) Then
         l_D=nBas_iAtom*(nBas_iAtom+1)/2
         Call GetMem('DiaLT','Allo','Real',ip_D,l_D)
         Call LDF_Q2LT(iAtom,Work(iWork(ip_AP_Diag-1+iAtomPair)),
     &                       Work(ip_D))
      Else
         l_D=0
         ip_D=iWork(ip_AP_Diag-1+iAtomPair)
      End If
      ip_D=ip_D-1

      ! Count diagonals greater than threshold
      If (iAtom.eq.jAtom) Then
         nuv=nBas_iAtom*(nBas_iAtom+1)/2
      Else If (iAtom.gt.jAtom) Then
         nuv=nBas_iAtom*nBas_jAtom
      Else
         Call WarningMessage(2,'LDF_Set2CL: iAtom<jAtom')
         Call LDF_Quit(1)
         nuv=0
      End If
      Do uv=1,nuv
         If (abs(Work(ip_D+uv)).gt.Thr) Then
            n2CF_Added=n2CF_Added+1
         End If
      End Do

      ! Set new list
      If (n2CF_Added.gt.0) Then
         ! If two-center functions are already present, get pointer to
         ! old list
         n2CF_Old=AP_2CFunctions(1,iAtomPair)
         If (n2CF_Old.gt.0) Then
            ip_OldList=AP_2CFunctions(2,iAtomPair)
            l_OldList=4*n2CF_Old
         Else
            ip_OldList=0
            l_OldList=0
         End If
         ! Store total number of two-center functions
         iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=n2CF_Old+n2CF_Added
         ! Allocate new list
         l_NewList=4*AP_2CFunctions(1,iAtomPair)
         Write(Label,'(A,I5.5)') '2CF',iAtomPair-1
         Call GetMem(Label,'Allo','Inte',ip_NewList,l_NewList)
         ! Store pointer to new list
         iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=ip_NewList
         ! Copy contents of old list to new list
         ! Deallocate old list
         If (n2CF_Old.gt.0) Then
            Call iCopy(l_OldList,iWork(ip_OldList),1,
     &                           iWork(ip_NewList),1)
            Call GetMem(Label,'Free','Inte',ip_OldList,l_OldList)
         End If
         ! Store data for newly added two-center functions
         If (iAtom.eq.jAtom) Then
            ipi=LDF_lShell_Atom(iAtom)-1
            uv=ip_D
            i2CFun=n2CF_Old
            Do iS=1,LDF_nShell_Atom(iAtom)
               iShell=iWork(ipi+iS)
               Do jS=1,iS-1
                  jShell=iWork(ipi+jS)
                  Do v=1,nBasSh(jShell)
                     Do u=1,nBasSh(iShell)
                        uv=uv+1
                        If (abs(Work(uv)).gt.Thr) Then
                           iWork(ip_NewList+4*i2CFun)=iS
                           iWork(ip_NewList+4*i2CFun+1)=u
                           iWork(ip_NewList+4*i2CFun+2)=jS
                           iWork(ip_NewList+4*i2CFun+3)=v
                           i2CFun=i2CFun+1
                        End If
                     End Do
                  End Do
               End Do
               Do v=1,nBasSh(iShell)
                  Do u=1,v
                     uv=uv+1
                     If (abs(Work(uv)).gt.Thr) Then
                        iWork(ip_NewList+4*i2CFun)=iS
                        iWork(ip_NewList+4*i2CFun+1)=u
                        iWork(ip_NewList+4*i2CFun+2)=iS
                        iWork(ip_NewList+4*i2CFun+3)=v
                        i2CFun=i2CFun+1
                     End If
                  End Do
               End Do
            End Do
         Else
            ipi=LDF_lShell_Atom(iAtom)-1
            ipj=LDF_lShell_Atom(jAtom)-1
            uv=ip_D
            i2CFun=n2CF_Old
            Do jS=1,LDF_nShell_Atom(jAtom)
               jShell=iWork(ipj+jS)
               Do iS=1,LDF_nShell_Atom(iAtom)
                  iShell=iWork(ipi+iS)
                  Do v=1,nBasSh(jShell)
                     Do u=1,nBasSh(iShell)
                        uv=uv+1
                        If (abs(Work(uv)).gt.Thr) Then
                           iWork(ip_NewList+4*i2CFun)=iS
                           iWork(ip_NewList+4*i2CFun+1)=u
                           iWork(ip_NewList+4*i2CFun+2)=jS
                           iWork(ip_NewList+4*i2CFun+3)=v
                           i2CFun=i2CFun+1
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End If
#if defined (_DEBUGPRINT_)
         If (i2CFun.ne.AP_2CFunctions(1,iAtomPair)) Then
            Call WarningMessage(2,'LDF_Set2CL: count error!')
            Write(6,'(A,3I10)') 'iAtomPair,iAtom,jAtom:',iAtomPair,
     &                          iAtom,jAtom
            Write(6,'(A,2I10)') 'i2CFun,AP_2CFunctions:',i2CFun,
     &                          AP_2CFunctions(1,iAtomPair)
            Write(6,'(A,2I10)') 'n2CF_Old,n2CF_Added:',n2CF_Old,
     &                          n2CF_Added
            Call LDF_Quit(1)
         End If
#endif
      End If

      If (l_D.gt.0) Then
         ip_D=ip_D+1
         Call GetMem('DiaLT','Free','Real',ip_D,l_D)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1997, Jeppe Olsen                                 *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RSBB1E(ISCSM,ISCTP,ICCSM,ICCTP,IGRP,NROW,NGAS,ISEL,ICEL,SB,CB,NOBPTS,MAXI,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,H,NSMOB,MOC, &
                  SCLFAC,IPHGAS)
! SUBROUTINE RSBB1E --> 33
!
! One electron excitations on column strings
! If IH2TRM /= 0 then the diagonal and one-electron
! excitations arising from the two body operator is also included
!
! =====
! Input
! =====
!
! ISCSM,ISCTP : Symmetry and type of sigma columns
! ISBCTP : Base for sigma column types
! ICCSM,ICCTP : Symmetry and type of C     columns
! ICBCTP : Base for C     column types
! IGRP : String group of columns
! NROW : Number of rows in S and C block
! NGAS : Number of active sets
! ISEL : Occupation in each active set for sigma block
! ICEL : Occupation in each active set for C     block
! CB   : Input C block
! NTSOB  : Number of orbitals per type and symmetry
! IBTSOB : base for orbitals of given type and symmetry
! IBORB  : Orbitals of given type and symmetry
! NSMOB  : Number of symmetries of orbitals
! MAXI   : Largest Number of "spectator strings" treated simultaneously
! MAXK   : Largest number of inner resolution strings treated at simult.
!
! MOC  : Use MOC method (instead of N-1 resolution method)
!
! ======
! Output
! ======
! SB : updated sigma block
!
! =======
! Scratch
! =======
!
! SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
!              largest number of orbital pairs of given symmetries and
!              types.
! I1, XI1S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! H : Space for one electron integrals
!
! Jeppe Olsen, Winter of 1991
!              IUSE_PH added winter of 97

use Symmetry_Info, only: Mul
use Para_Info, only: MyRank, nProcs
use lucia_data, only: MXPNGAS, MXPTSOB
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ISCSM, ISCTP, ICCSM, ICCTP, IGRP, NROW, NGAS, ISEL(NGAS), ICEL(NGAS), NOBPTS(MXPNGAS,*), MAXI, &
                                 MAXK, NSMOB, MOC, IPHGAS(NGAS)
real(kind=wp), intent(_OUT_) :: SB(*), SSCR(*), CSCR(*), H(*)
real(kind=wp), intent(in) :: CB(*), SCLFAC
integer(kind=iwp), intent(inout) :: I1(*), I2(*)
real(kind=wp), intent(inout) :: XI1S(*), XI2S(*)
integer(kind=iwp) :: IBOT, ICGOFF, ICGRP(16), IDOCOMP, IIORB, IIPART, IJ_AC(2), IJ_DIM(2), IJ_REO(2), IJ_SM(2), IJ_TP(2), IJSM, &
                     IJTP, ISBOFF, ISGRP(16), ISM, ITOP, ITP(16), ITYP, IXXX, JJORB, JSM, JTP(16), JTYP, KACT, KBOT, KEND, KTOP, &
                     LKABTC, NIBTC, NIK, NIORB, NIPART, NIPARTSZ, NJORB, NKAEFF, NKASTR, NSXTP
real(kind=wp) :: FACTORAB, FACTORC, HSCR(MXPTSOB*MXPTSOB), SCLFACS, SIGNIJ

!MOC = 1
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ======================='
write(u6,*) ' Information from RSBB1E'
write(u6,*) ' ======================='
write(u6,*)
write(u6,*) ' RSBB1E : MOC ',MOC
write(u6,*) ' ISEL :'
call IWRTMA(ISEL,1,NGAS,1,NGAS)
write(u6,*) ' ICEL :'
call IWRTMA(ICEL,1,NGAS,1,NGAS)
#endif

! Number of partitionings over column strings
!SVC: determine optimum number of partitions as the lowest multiple of
!     NPROCS that satisfies a block size smaller than MAXI:
NIPART = 0
do
  NIPART = NIPART+NPROCS
  NIPARTSZ = max(NROW-1,0)/NIPART+1
  if (NIPARTSZ <= MAXI) exit
end do

! Obtain groups
!    GET_SPGP_INF(ISPGP,ITP,IGRP)
call GET_SPGP_INF(ICCTP,IGRP,ICGRP)
call GET_SPGP_INF(ISCTP,IGRP,ISGRP)

! Types of single excitations that connect ISEL and ICEL
call SXTYP2_GAS(NSXTP,ITP,JTP,NGAS,ISEL,ICEL,IPHGAS)
! Symmetry of single excitation that connects IBSM and JBSM
IJSM = Mul(ISCSM,ICCSM)
if (IJSM /= 0) then
  do IJTP=1,NSXTP
    ITYP = ITP(IJTP)
    JTYP = JTP(IJTP)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' ITYP JTYP ',ITYP,JTYP
#   endif
    ! Is this combination of types allowed
    !IJ_ACT = 1
    !if (IJ_ACT == 0) cycle
    ! Hvilken vej skal vi valge,
    !NOP = 2
    IJ_AC(1) = 2
    IJ_AC(2) = 1
    IJ_TP(1) = ITYP
    IJ_TP(2) = JTYP
    !if (IUSE_PH == 1) then
    !  call ALG_ROUTERX(IAOC,JAOC,NOP,IJ_TP,IJ_AC,IJ_REO,SIGNIJ)
    !else
    IJ_REO(1) = 1
    IJ_REO(2) = 2
    SIGNIJ = One
    !end if

    if (IJ_REO(1) == 1) then

      IJ_TP(1) = ITYP
      IJ_TP(2) = JTYP
    else
      IXXX = IJ_AC(1)
      IJ_AC(1) = IJ_AC(2)
      IJ_AC(2) = IXXX

      !ISCR(1) = ITYP
      !ISCR(2) = JTYP
      IJ_TP(1) = JTYP
      IJ_TP(2) = ITYP
    end if

    !ISCR(1) = IJ_AC(1)
    !ISCR(2) = IJ_AC(2)
    !IJ_AC(1) = ISCR(IJ_REO(1))
    !IJ_AC(2) = ISCR(IJ_REO(2))

    ! nasty code to avoid optimization
    !if (iscr(1) == -1000) write(u6,*) IJ_TP,IJ_REO
    !
    !ISCR(1) = ITYP
    !ISCR(2) = JTYP
    !IJ_TP(1) = ISCR(IJ_REO(1))
    !IJ_TP(2) = ISCR(IJ_REO(2))

    do ISM=1,NSMOB
      JSM = Mul(ISM,IJSM)
      ! New intermediate strings will be accessed so
      if (JSM == 0) cycle
#     ifdef _DEBUGPRINT_
      write(u6,*) ' ISM JSM ',ISM,JSM
#     endif
      NIORB = NOBPTS(ITYP,ISM)
      NJORB = NOBPTS(JTYP,JSM)
      ! Reorder

      !ISCR(1) = ISM
      !ISCR(2) = JSM
      !IJ_SM(1) = ISCR(IJ_REO(1))
      !IJ_SM(2) = ISCR(IJ_REO(2))

      !ISCR(1) = NIORB
      !ISCR(2) = NJORB
      !IJ_DIM(1) = ISCR(IJ_REO(1))
      !IJ_DIM(2) = ISCR(IJ_REO(2))

      if (IJ_REO(1) == 1) then
        IJ_SM(1) = ISM
        IJ_SM(2) = JSM
        IJ_DIM(1) = NIORB
        IJ_DIM(2) = NJORB
      else
        IJ_SM(1) = JSM
        IJ_SM(2) = ISM
        IJ_DIM(1) = NJORB
        IJ_DIM(2) = NIORB
      end if

      if ((NIORB == 0) .or. (NJORB == 0)) cycle
      ! Fetch integrals : For CI-transformations using RSBB1E
      ! most of the blocks vanishes
      ! Obtain one electron integrals (ISM,ITP,JSM,JTP) transposed
      if (IJ_REO(1) == 1) then
        ! obtain integrals h(j,i)
        call GETH1(HSCR,IJ_SM(1),IJ_TP(1),IJ_SM(2),IJ_TP(2))
        call TRNSPS(IJ_DIM(1),IJ_DIM(2),HSCR,H)
      else
        ! Obtain integrals h(i,j)
        call GETH1(H,IJ_SM(2),IJ_TP(2),IJ_SM(1),IJ_TP(1))
      end if
      !OLD XNORM = dDot_(IJ_DIM(1)*IJ_DIM(2),H,1,H,1)
      !OLD if (XNORM == 0) cycle
      if (MOC == 0) then

        ! ==============================================================
        !                    Use N-1 resolution method
        ! ==============================================================

        ! Obtain annihilation/creation maps for all K strings

        ! For operator connecting to |Ka> and |Ja> i.e. operator 2
        SCLFACS = SIGNIJ*SCLFAC
#       ifdef _DEBUGPRINT_
        write(u6,*) ' IJ_SM,IJ_TP,IJ_AC',IJ_SM(2),IJ_TP(2),IJ_AC(2)
#       endif
        call ADAST_GAS(IJ_SM(2),IJ_TP(2),NGAS,ICGRP,ICCSM,I1,XI1S,NKASTR,KACT,SCLFACS,IJ_AC(1))
        ! For operator connecting |Ka> and |Ia>, i.e. operator 1
        call ADAST_GAS(IJ_SM(1),IJ_TP(1),NGAS,ISGRP,ISCSM,I2,XI2S,NKASTR,KACT,One,IJ_AC(1))
        ! Compress list to common nonvanishing elements
        IDOCOMP = 1
        if (IDOCOMP == 1) then
          call COMPRS2LST(I1,XI1S,IJ_DIM(2),I2,XI2S,IJ_DIM(1),NKASTR,NKAEFF)
        else
          NKAEFF = NKASTR
        end if
        ! Loop over partitionings of the row strings
        ! Loop over partitionings of N-1 strings
        KBOT = 1-MAXK
        KTOP = 0
        do
          KBOT = KBOT+MAXK
          KTOP = min(KTOP+MAXK,NKAEFF)
          if (KTOP == NKAEFF) then
            KEND = 1
          else
            KEND = 0
          end if
          LKABTC = KTOP-KBOT+1
          ! This is the place to start over partitioning of I strings
          do IIPART=1+MYRANK,NIPART,NPROCS
            IBOT = (IIPART-1)*MAXI+1
            ITOP = min(IBOT+MAXI-1,NROW)
            NIBTC = ITOP-IBOT+1
            if (NIBTC <= 0) exit
            ! Obtain CSCR(I,K,JORB) = SUM(J)<K!A JORB!J>C(I,J)
            do JJORB=1,IJ_DIM(2)
              ICGOFF = 1+(JJORB-1)*LKABTC*NIBTC
              call MATCG(CB,CSCR(ICGOFF),NROW,NIBTC,IBOT,LKABTC,I1(KBOT+(JJORB-1)*NKASTR),XI1S(KBOT+(JJORB-1)*NKASTR))
            end do
            ! Obtain one electron integrals (ISM,ITP,JSM,JTP) transposed
            !call GETH1(HSCR,IJ_SM(1),IJ_TP(1),IJ_SM(2),IJ_TP(2))
            !call TRNSPS(IJ_DIM(1),IJ_DIM(2),HSCR,H)
            ! Problems when HOLE switches blocks around ?
            !call GETH1(H,IJ_SM(2),IJ_TP(2),IJ_SM(1),IJ_TP(1))
#           ifdef _DEBUGPRINT_
            write(u6,*) ' RSBB1E H BLOCK'
            call WRTMAT(H,IJ_DIM(2),IJ_DIM(1),IJ_DIM(2),IJ_DIM(1))
#           endif
            ! Sscr(I,K,i) = CSCR(I,K,j)*h(j,i)
            NIK = NIBTC*LKABTC
            FACTORC = Zero
            FACTORAB = One
#           ifdef _DEBUGPRINT_
            write(u6,*) ' CSCR array,NIK X NJORB array'
            call WRTMAT(CSCR,NIK,IJ_DIM(2),NIK,IJ_DIM(2))
#           endif
            call MATML7(SSCR,CSCR,H,NIK,IJ_DIM(1),NIK,IJ_DIM(2),IJ_DIM(2),IJ_DIM(1),FACTORC,FACTORAB,0)
#           ifdef _DEBUGPRINT_
            write(u6,*) ' SSCR array,NIK X NIORB array'
            call WRTMAT(SSCR,NIK,IJ_DIM(1),NIK,IJ_DIM(1))
#           endif
            ! S(I,a+ K) =  S(I, a+ K) + sgn*Sscr(I,K,i)
            do IIORB=1,IJ_DIM(1)
              ISBOFF = 1+(IIORB-1)*LKABTC*NIBTC
              call MATCAS(SSCR(ISBOFF),SB,NIBTC,NROW,IBOT,LKABTC,I2(KBOT+(IIORB-1)*NKASTR),XI2S(KBOT+(IIORB-1)*NKASTR))
            end do

          end do
          ! end of this K partitioning
          if (KEND /= 0) exit
        end do
        ! End of loop over I partitioninigs
      end if
      ! (End of algorithm switch)
    end do
    ! (end of loop over symmetries)
  end do
end if

end subroutine RSBB1E

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Expectus(QMMethod,HmatOld,Vmat,VpolMat,Smat,VEC,nDim,lEig,iEig,ExpVal)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
character(len=5), intent(in) :: QMMethod
integer(kind=iwp), intent(in) :: nDIM, iEig
real(kind=wp), intent(in) :: HmatOld(nTri_Elem(nDim)), Vmat(nTri_Elem(nDim)), VpolMat(nTri_Elem(nDim)), Smat(nTri_Elem(nDim)), &
                             VEC(nDim,nDim)
logical(kind=iwp), intent(in) :: lEig
real(kind=wp), intent(_OUT_) :: ExpVal(4,*)
integer(kind=iwp) :: iRoot, nDTri, nRoots
real(kind=wp), allocatable :: DTmp(:)
real(kind=r8), external :: Ddot_
#include "warnings.h"

! Take different path for different QM-method.

if (QMMethod(1:5) == 'RASSI') then

  ! For how many roots are the eigenvalues to be computed.

  if (lEig) then
    nRoots = iEig
  else
    nRoots = nDim
  end if

  ! Loop over roots and compute expectation values according to
  ! well-known formulas.

  nDTri = nTri_Elem(nDim)
  call mma_allocate(DTmp,nDTri,label='DenTemp')
  do iRoot=1,nRoots

    ! Generate density matrix for relevant root.

    call DensiSt(DTmp,VEC,iRoot,nDim,nDim)

    ! Expectation values.

    ExpVal(1,iRoot) = Ddot_(nDTri,DTmp,1,HmatOld,1)
    ExpVal(2,iRoot) = Ddot_(nDTri,DTmp,1,Vmat,1)
    ExpVal(3,iRoot) = Ddot_(nDTri,DTmp,1,Vpolmat,1)
    ExpVal(4,iRoot) = Ddot_(nDTri,DTmp,1,Smat,1)
  end do
  call mma_deallocate(DTmp)

else if (QMMethod(1:5) == 'SCF  ') then
  ! If it's SCF we are running.

  nDTri = nTri_Elem(nDim)
  call mma_allocate(DTmp,nDTri,label='DenTemp')
  call Densi_MO(DTmp,VEC,1,iEig,nDim,nDim)

  ! Expectation values.

  ExpVal(1,1) = Ddot_(nDTri,DTmp,1,HmatOld,1)
  ExpVal(2,1) = Ddot_(nDTri,DTmp,1,Vmat,1)
  ExpVal(3,1) = Ddot_(nDTri,DTmp,1,Vpolmat,1)
  ExpVal(4,1) = Ddot_(nDTri,DTmp,1,Smat,1)
  call mma_deallocate(DTmp)

else
  ! Shit happens.

  write(u6,*)
  write(u6,*) ' Now how did this happen, says Expectus!'
  call Quit(_RC_INTERNAL_ERROR_)
end if

! What's you major malfunction, numb nuts!

return

end subroutine Expectus

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine rdlow_cvb(vec,n,fileid,ioffset)
      implicit real*8(a-h,o-z)
#include "io_cvb.fh"
#include "idbl_cvb.fh"
      !integer vec
      dimension vec(n)
      logical newfile,debug
      data debug/.false./

      if(debug)write(6,*)' rdlow :',n,fileid,ioffset
      call mkfn_cvb(fileid,ibf)
      call ibf2unit_cvb(ibf,lu,newfile)

      if(newfile)call ioopn_cvb(filename(ibf),lu)

      ioffs=ioffset
      call dDaFile(lu,2,vec,n,ioffs)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_CAS_DRV(rc,W_CMO,DI,FI,DA1,FA,W_PWXY,TraOnly)

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use Fock_util_global, only: ALGO, Deco, dmpk, DoActive, DoLocK, Nscreen
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: rc
real(kind=wp), intent(in) :: W_CMO(*), DI(*), DA1(*)
real(kind=wp), intent(inout) :: FI(*), FA(*)
real(kind=wp), intent(_OUT_) :: W_PWXY(*)
logical(kind=iwp), intent(in) :: TraOnly
#include "rasdim.fh"
#include "wadr.fh"
#include "general.fh"
#include "rasscf.fh"
integer(kind=iwp) :: i, iBas, iFro, ikk, incs, iOrb, iSym, ja, jkk, nAorb(8), nChI(8), nChM(8), nForb(8), nIorb(8), NumV
real(kind=wp) :: dmpk_old, FactXI, Ymax
type(DSBA_Type) :: ChoIn, CMO, CVa(2), Ddec, DLT(2), FLT(2), FLT_MO(2), MSQ, POrb(3)
real(kind=wp), allocatable :: Tmp1(:), Tmp2(:)
real(kind=wp), parameter :: Thr = 1.0e-12_wp
character(len=*), parameter :: SECNAM = 'CHO_CAS_DRV'

!                                                                      *
!***********************************************************************
!                                                                      *
rc = 0

call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI',Ref=FI)
call Allocate_DT(FLT(2),nBas,nBas,nSym,aCase='TRI',Ref=FA)
call Allocate_DT(CMO,nBas,nBas,nSym,Ref=W_CMO)

!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (TraOnly) then
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Let us construct a second pointer structure based on nOrb

  call Allocate_DT(FLT_MO(1),nOrb,nOrb,nSym,aCase='TRI',Ref=FI)
  call Allocate_DT(FLT_MO(2),nOrb,nOrb,nSym,aCase='TRI',Ref=FA)
  !
  ! It only performs the MO transformation of FI and FA
  ! ---------------------------------------------------
  !
  ! transform FI/FA from AO to MO basis  (LT-storage)
  do i=1,2
    do iSym=1,nSym
      iBas = nBas(iSym)
      iOrb = nOrb(iSym)
      iFro = nFro(iSym)
      call mma_allocate(Tmp1,iBas*iBas,Label='Tmp1')
      call mma_allocate(Tmp2,iOrb*iBas,Label='Tmp1')
      call Square(FLT(i)%SB(iSym)%A1,Tmp1,1,iBas,iBas)
      call DGEMM_('N','N',iBas,iOrb,iBas,One,Tmp1,iBas,CMO%SB(iSym)%A1(1+iFro*iBas:),iBas,Zero,Tmp2,iBas)
      call DGEMM_Tri('T','N',iOrb,iOrb,iBas,One,Tmp2,iBas,CMO%SB(iSym)%A1(1+iFro*iBas:),iBas,Zero,FLT_MO(i)%SB(iSym)%A1,iOrb)
      call mma_deallocate(Tmp2)
      call mma_deallocate(Tmp1)
    end do
  end do

  call Deallocate_DT(FLT_MO(1))
  call Deallocate_DT(FLT_MO(2))
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! It only computes FI and FA  in AO-basis and returns
  ! the active integrals (tw|xy)
  ! If specified in input, the routine also computes
  ! the auxiliary Q-matrix stored as Q(av), where a is an AO index
  ! and v refers to the active orbitals only

  nForb(:) = nFro(:)
  nIorb(:) = nIsh(:)
  nAorb(:) = nAsh(:)

  ! Build the packed densities from the Squared ones
  call Allocate_DT(DLT(1),nBas,nBas,nSym,aCase='TRI')
  call Allocate_DT(DLT(2),nBas,nBas,nSym,aCase='TRI')

  call Fold(nSym,nBas,DI,DLT(1)%A0)
  call Fold(nSym,nBas,DA1,DLT(2)%A0)

  FactXI = -One

  !AMS - should this be set differently for ExFac /= 1?
  !      FactXI = 0-ExFac

  if (Deco) then

    FactXI = -Half

    !AMS - should this be set differently for ExFac /= 1?
    !      FactXI = 0-(ExFac*Half)

    ! --- decompose the Inactive density on request
    call Allocate_DT(ChoIn,nBas,nBas,nSym)
    call Allocate_DT(DDec,nBas,nBas,nSym)
    DDec%A0(1:NTot2) = DI(1:NTot2)

    call Allocate_DT(MSQ,nBas,nBas,nSym,Ref=ChoIn%A0)

    incs = 0
    do i=1,nSym
      if ((nForb(i)+nIorb(i)) > 0) then
        call CD_InCore(DDec%SB(i)%A2,nBas(i),ChoIn%SB(i)%A2,nBas(i),NumV,Thr,rc)
        if (rc /= 0) then
          write(u6,*) SECNAM//': ill-defined dens decomp for Inact'
          write(u6,*) 'rc value produced = ',rc
          call abend()
        end if
        nChI(i) = NumV
        if (NumV /= nIsh(i)+nForb(i)) then
          write(u6,*) 'Warning! The number of occupied from the decomposition of the Inactive density matrix is ',numV, &
                      ' in symm. ',i
          write(u6,*) 'Expected value = ',nIsh(i)+nForb(i)
          incs = incs+1
          Ymax = Zero
          do ja=1,nBas(i)
            Ymax = max(Ymax,DDec%SB(i)%A2(ja,ja))
          end do
          write(u6,*) 'Max diagonal of the density in symm. ',i,' is equal to ',Ymax
        end if
      else
        nChI(i) = 0
      end if
    end do

    if ((incs > 0) .and. DoLocK) then
      dmpk_old = dmpk
      dmpk = 1.0e-2_wp*dmpk
      write(u6,*) 'LK-damping decreased from ',dmpk_old,' to ',dmpk
    end if

    call Deallocate_DT(DDEc)

    ! --- to get the right input arguments for CHO_FCAS_AO and CHO_FMCSCF
    if (.not. DoLocK) then
      nForb(:) = 0
      nIorb(:) = nChI(:)
    end if

  else

    call Allocate_DT(MSQ,nBas,nBas,nSym,Ref=W_CMO)

    nChI(:) = nForb(:)+nIorb(:)

  end if

  ! Reordering of the MOs coefficients to fit cholesky needs

  if (.not. DoLocK) then

    call Allocate_DT(POrb(1),nChI,nBas,nSym)
    call Allocate_DT(POrb(3),nAOrb,nBas,nSym)

    do iSym=1,nSym

      do ikk=1,nChI(iSym)
        POrb(1)%SB(iSym)%A2(ikk,:) = MSQ%SB(iSym)%A2(:,ikk)
      end do

      do ikk=1,nAorb(iSym)
        jkk = nForb(iSym)+nIorb(iSym)+ikk
        POrb(3)%SB(iSym)%A2(ikk,:) = CMO%SB(iSym)%A2(:,jkk)
      end do

    end do

  else

    ! *** Only the active orbitals MO coeff need reordering
    call Allocate_DT(CVa(1),nAorb,nBas,nSym)

    do iSym=1,nSym
      do ikk=1,nAorb(iSym)
        jkk = nForb(iSym)+nIorb(iSym)+ikk
        CVa(1)%SB(iSym)%A2(ikk,:) = CMO%SB(iSym)%A2(:,jkk)
      end do
    end do

  end if

  if (DoActive) then
    ! Decompose the active density  -----------------------------

#   ifdef _DEBUGPRINT_
    do i=1,nSym
      call CD_TESTER(rc,DLT(2)%SB(i)%A1,nBas(i),.true.)
      write(u6,*) 'DALT for sym=',i
      call TRIPRT('DALT',' ',DLT(2)%SB(i)%A1,nBas(i))
    end do
#   endif

    call Allocate_DT(CVa(2),nBas,nBas,nSym)
    call Allocate_DT(DDec,nBas,nBas,nSym)
    DDec%A0(1:NTot2) = DA1(1:NTot2)

    do i=1,nSym
      if (nAorb(i) > 0) then
        ! NOTE(Giovanni): CD will proceed with approx. decompos for QMC
        !                 This will avoid warnings for negative-definite
        call CD_InCore(DDec%SB(i)%A2,nBas(i),CVa(2)%SB(i)%A2,nBas(i),NumV,Thr,rc)
        if (rc /= 0) then
          write(u6,*) SECNAM//': ill-defined dens decomp for active'
          write(u6,*) 'rc value produced = ',rc
          call abend()
        end if
        nChM(i) = NumV
      else
        nChM(i) = 0
      end if
    end do

    call Deallocate_DT(DDec)

  else

    ! Dummy allocation
    call Allocate_DT(CVa(2),[1],[1],1)
    nChM(:) = 0

  end if

  if ((.not. DoLocK) .and. DoActive) then

    ! reorder "Cholesky MOs" to Cva storage

    call Allocate_DT(POrb(2),nChM,nBas,nSym)
    do iSym=1,nSym
      if (nBas(iSym)*nChM(iSym) /= 0) then
        do ikk=1,nChM(iSym)
          POrb(2)%SB(iSym)%A2(ikk,:) = CVa(2)%SB(iSym)%A2(:,ikk)
        end do
      end if
    end do

  else

    call Allocate_DT(POrb(2),[1],[1],1)

  end if
  ! --------------------------------------------------------------------
  FLT(1)%A0(:) = Zero
  FLT(2)%A0(:) = Zero

  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

  if ((ALGO == 1) .and. (.not. DoLocK)) then

    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

    call CHO_FMCSCF(rc,FLT,nForb,nIorb,nAorb,FactXI,DLT,DoActive,POrb,nChM,W_PWXY,CMO,ExFac)

    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

  else if ((ALGO == 1) .and. DoLocK) then

    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

    call CHO_LK_CASSCF(DLT,FLT,MSQ,W_PWXY,FactXI,nChI,nAorb,nChM,CVa,DoActive,nScreen,dmpK,abs(CBLBM),CMO,ExFac)

    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

  else

    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

    write(u6,*) SECNAM//': wrong input parameter. ALGO= ',ALGO
    rc = 55
    return

    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

  end if

  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

  call Deallocate_DT(POrb(3))
  call Deallocate_DT(POrb(2))
  call Deallocate_DT(POrb(1))
  call Deallocate_DT(CVa(1))
  call Deallocate_DT(CVa(2))

  if (Deco) call Deallocate_DT(ChoIn)

  call Deallocate_DT(DLT(2))
  call Deallocate_DT(DLT(1))

  call Deallocate_DT(MSQ)
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
call Deallocate_DT(CMO)
call Deallocate_DT(FLT(2))
call Deallocate_DT(FLT(1))

return

end subroutine CHO_CAS_DRV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************

subroutine NEWDIA()
! Post-diagonalization modification of diagonal energy
! denominator terms for active and for non-active superindex.

use EQSOLV, only: IDBMAT
use caspt2_global, only: LUSBT
use caspt2_module, only: nASup, nInDep, nISup, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ICASE, ISYM, JD, NAS, NIN, NIS
real(kind=wp), allocatable :: BD(:), C1(:), C2(:), ID(:)

do ICASE=1,13
  do ISYM=1,NSYM
    NIN = NINDEP(ISYM,ICASE)
    if (NIN == 0) cycle
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (NIS == 0) cycle
    ! Remember: NIN values in BDIAG, but must read NAS for correct
    ! positioning.
    call mma_allocate(BD,NAS,LABEL='BD')
    call mma_allocate(ID,NIS,LABEL='ID')
    call mma_allocate(C1,NAS,LABEL='C1')
    call mma_allocate(C2,NIS,LABEL='C2')
    JD = IDBMAT(ISYM,ICASE)
    ! Active, and non-active, energy denominators:
    call DDAFILE(LUSBT,2,BD,NAS,JD)
    call DDAFILE(LUSBT,2,ID,NIS,JD)
    ! Active, and non-active, corrections:
    ! (Replace this strange example with something sensible)
    C1(:) = Zero
    C2(:) = Zero
    ! Modifications are added to the usual diagonal energies:
    BD(:) = BD(:)+C1(:)
    ID(:) = ID(:)+C2(:)
    JD = IDBMAT(ISYM,ICASE)
    call DDAFILE(LUSBT,1,BD,NAS,JD)
    call DDAFILE(LUSBT,1,ID,NIS,JD)
    ! Added modifications are saved on LUSBT.
    call DDAFILE(LUSBT,1,C1,NAS,JD)
    call DDAFILE(LUSBT,1,C2,NIS,JD)

    call mma_deallocate(BD)
    call mma_deallocate(ID)
    call mma_deallocate(C1)
    call mma_deallocate(C2)
    JD = IDBMAT(ISYM,ICASE)
  end do
end do

end subroutine NEWDIA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TODSCN(VEC,NREC,LREC,LBLK,LU)
! Write VEC as multiple record file accordin to NREC and LREC

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_IN_) :: VEC(*)
integer(kind=iwp), intent(in) :: NREC, LBLK, LU
integer(kind=iwp), intent(_IN_) :: LREC(NREC)
integer(kind=iwp) :: DUM(1), IOFF, IREC

IOFF = 1
do IREC=1,NREC
  !write(u6,*) ' TODSCN: IREC, LREC ',IREC,LREC(IREC)
  !write(u6,*) ' Input record'
  !call WRTMAT(VEC(IOFF),1,LREC(IREC),1,LREC(IREC))
  if (LREC(IREC) >= 0) then
    call ITODS(LREC(IREC),1,LBLK,LU)
    call TODSC(VEC(IOFF),LREC(IREC),LBLK,LU)
    IOFF = IOFF+LREC(IREC)
  else
    DUM(1) = -LREC(IREC)
    call ITODS(DUM,1,LBLK,LU)
    call ZERORC(LU,0)
  end if
end do

end subroutine TODSCN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Add2(rMat,fact)
*
*     Purpose:
*             Adds the contribution from the gradient to
*              [2]
*             E   Kappa. This is done to insure us about
*             a beautifull convergence of the PCG,
*             which is just the case if E is symmetric.
*
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"
#include "spin.fh"

#include "Input.fh"
#include "WrkSpc.fh"
      Real*8 rMat(*)
      Do iS=1,nSym
        If (nOrb(is)*nOrb(is).gt.0) Then
        Call Getmem('OJTEMP','ALLO','REAL',ipTemp,nBas(is)**2)
*
*    T=Brillouin matrix
*

        Call DGeSub(Work(ipFS+ipCM(is)-1),nOrb(is),'N',
     &              Work(ipFS+ipCM(is)-1),nOrb(is),'T',
     &              Work(ipTemp),nOrb(is),
     &              nOrb(is),nOrb(is))
*
*               t           t
*   +1/2 { Kappa T - T kappa  }
*
*
        Call DaXpY_(nOrb(is)**2,-4.0d0*Fact,Work(ipTemp),1,
     &              rMat(ipMat(is,is)),1)
        Call Getmem('OJTEMP','FREE','REAL',ipTemp,nBas(is)**2)
      End If
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module MBPT2_Global

use Data_Structures, only: DSBA_Type
use Definitions, only: wp, iwp

implicit none
private

#include "LenIn.fh"

integer(kind=iwp) :: iPL, iPoVec(9), mAdDel(8), mAdFro(8), mAdOcc(8), mAdVir(8), nBas(8), nDel1(8), nDel2(8), nDsto(8), nFro1(8), &
                     nFro2(8), nnB, nTit
real(kind=wp) :: EMP2, Thr_ghs, VECL2
logical(kind=iwp) :: DelGhost, DoCholesky, DoDF, DoLDF
character(len=80) :: Title(10)
type(DSBA_Type) :: Density, DiaA, Mp2Lagr, WDensity
integer(kind=iwp), allocatable :: iDel(:,:), iFro(:,:)
real(kind=wp), allocatable :: CMO(:), EOcc(:), EOrb(:), EVir(:)
character(len=LenIn), allocatable :: NamAct(:)
! Unit Numbers & File Names
integer(kind=iwp) :: LuHLF1 = 40, LuHLF2 = 41, LuHLF3 = 42, LuIntA = 43, LuIntM = 44
character(len=8) :: FnHLF1 = 'LUHLF1', FnHLF2 = 'LUHLF2', FnHLF3 = 'LUHLF3', FnIntA = 'ORDINT', FnIntM = 'MOLINT'

public :: CMO, DelGhost, Density, DiaA, DoCholesky, DoDF, DoLDF, EMP2, EOcc, EOrb, EVir, FnHLF1, FnHLF2, FnHLF3, FnIntA, FnIntM, &
          iDel, iFro, iPL, iPoVec, LuHLF1, LuHLF2, LuHLF3, LuIntA, LuIntM, mAdDel, mAdFro, mAdOcc, mAdVir, MBPT2_Clean, MP2Lagr, &
          NamAct, nBas, nDel1, nDel2, nDsto, nFro1, nFro2, nnB, nTit, Title, Thr_ghs, VECL2, WDensity

contains

subroutine MBPT2_Clean()
  use stdalloc, only: mma_deallocate
  if (allocated(CMO)) call mma_deallocate(CMO)
  if (allocated(EOcc)) call mma_deallocate(EOcc)
  if (allocated(EOrb)) call mma_deallocate(EOrb)
  if (allocated(EVir)) call mma_deallocate(EVir)
  if (allocated(iDel)) call mma_deallocate(iDel)
  if (allocated(iFro)) call mma_deallocate(iFro)
  if (allocated(NamAct)) call mma_deallocate(NamAct)
end subroutine MBPT2_Clean

end module MBPT2_Global

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines:
c     map
c     cct3_noperm
c     map41
c     map42
c     map31
c     map32
c     map21
c     map22
c     map11
c
c     -----------------------------------------------------------
c
       subroutine cct3_map (wrk,wrksize,
     & nind,p,q,r,s,
     & mapda,mapia,ssa,mapdb,mapib,possb0,posst,rc)
c
c     this routine realize mappings
c
c     B(indb) <-- A(inda)
c     where inda are order of indexes in mtx A and indb = Perm(inda)
c
c     nind   - number of indexes in matrix A (and B)  (Input)
c     p      - possition of 1-st index od mtx A in mtx B  (Input)
c     q      - possition of 2-nd index od mtx A in mtx B  (Input)
c     r      - possition of 3-rd index od mtx A in mtx B  (Input)
c     s      - possition of 4-th index od mtx A in mtx B  (Input)
c     mapda  - direct map matrix corresponding to A  (Input)
c     mapia  - inverse map matrix corresponding to A  (Input)
c     ssa    - overall symetry state  of matrix A  (Input)
c     mapdb  - direct map matrix corresponding to B  (Output)
c     mapib  - inverse map matrix corresponding to B  (Output)
c     possb0 - initial possition of matrix B in WRK  (Input)
c     posst  - final possition of matrix B in WRK (Output, not used yet)
c     rc     - return (error) code  (Output)
c
c
c     The table of implemented permutations
c
c     ninda  typA   p  q  r  s            Operation                 Implemented
c
c     4     0     all 24 comb.    A(1,2,3,4) -> B(p,q,r,s)             Yes
c
c     4     1     1  2  3  4      A(12,3,4)  -> B(12,3,4)              Yes
c     4     1     1  2  4  3      A(12,3,4)  -> B(12,4,3)              Yes
c     4     1     2  3  1  4      A(12,3,4)  -> B(3,12,4)              Yes
c     4     1           4  1      A(12,3,4)  -> B(4,12,3)              Yes
c     4     1     3  4  1  2      A(12,3,4)  -> B(3,4,12)              Yes
c     4     1           2  1      A(12,3,4)  -> B(4,3,12)              Yes
c     4     1     other comb.                                          No
c
c     4     2     1  2  3  4      A(1,23,4)  -> B(1,23,4)              Yes
c     4     2     4  2  3  1      A(1,23,4)  -> B(4,23,1)              Yes
c     4     2     3  1  2  4      A(1,23,4)  -> B(23,1,4)              Yes
c     4     2     4        3      A(1,23,4)  -> B(23,4,1)              Yes
c     4     2     1  3  4  2      A(1,23,4)  -> B(1,4,23)              Yes
c     4     2     2        1      A(1,23,4)  -> B(4,1,23)              Yes
c     4     2     other comb.                                          No
c
c     4     3     1  2  3  4      A(1,2,34)  -> B(1,2,34)              Yes
c     4     3     2  1  3  4      A(1,2,34)  -> B(2,1,34)              Yes
c     4     3     3  4  1  2      A(1,2,34)  -> B(34,1,2)              Yes
c     4     3     4  4            A(1,2,34)  -> B(34,2,1)              Yes
c     4     3     1  4  2  3      A(1,2,34)  -> B(1,34,2)              Yes
c     4     3     4  1            A(1,2,34)  -> B(2,34,1)              Yes
c     4     3     other comb.                                          No
c
c     4     4     1  2  3  4      A(12,34)   -> B(12,34)               Yes
c     4     4     3  4  1  2      A(12,34)   -> B(32,12)               Yes
c     4     4     other comb.                                          No
c
c     3     0     all 6 comb.     A(1,2,3)   -> B(p,q,r)               Yes
c
c     3     1     1  2  3  -      A(12,3)    -> B(12,3)                Yes
c     3     1     2  3  1  -      A(12,3)    -> B(3,12)                Yes
c     3     1     other comb.                                          No
c
c     3     2     1  2  3         A(1,23)    -> B(1,23)                Yes
c     3     2     3  1  2         A(1,23)    -> B(23,1)                Yes
c     3     2     other comb.                                          No
c
c     2     0     all 2 comb.     A(1,2)     -> B(p,q)                 Yes
c
c     2     1     1  2  -  -      A(12)      -> B(12)                  Yes
c     2     1     other comb.                                          No
c
c
#include "t31.fh"
#include "wrk.fh"

c
       integer nind,p,q,r,s,ssa,possb0,posst,rc
       integer mapda(0:512,1:6),mapdb(0:512,1:6)
       integer mapia(1:8,1:8,1:8),mapib(1:8,1:8,1:8)
c
       integer type(1:4),dl(1:4),sa(1:4)
       integer nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7
       integer ia,ib,typ,newtyp
c
       rc=0
c
c     some test of correctness
c
       nhelp1=p+q+r+s
       if ((nind.eq.1).and.(nhelp1.eq.1)) then
       else if ((nind.eq.2).and.(nhelp1.eq.3)) then
       else if ((nind.eq.3).and.(nhelp1.eq.6)) then
       else if ((nind.eq.4).and.(nhelp1.eq.10)) then
       else
c     RC=1 - uncorrect indexes
       rc=1
       return
       end if
c
c     ******** No permutation *******
c
       if (nind.eq.1) then
       call cct3_noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,possb0,posst)
       return
       end if
c
       if ((nind.eq.2).and.(p.eq.1).and.(q.eq.2)) then
       call cct3_noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,possb0,posst)
       return
       end if
c
       if ((nind.eq.3).and.(p.eq.1).and.(q.eq.2).and.(r.eq.3)) then
       call cct3_noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,possb0,posst)
       return
       end if
c
       if ((nind.eq.4).and.(p.eq.1).and.(q.eq.2).and.(r.eq.3)
     &     .and.(s.eq.4)) then
       call cct3_noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,possb0,posst)
       return
       end if
c
       if (nind.eq.2) then
c
c     *********** 2 index ***********
c
       typ=mapda(0,6)
c
       if (typ.eq.0) then
c
c2.1  map A(p,q) -> B(q,p)
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       call cct3_grc0 (nind,0,type(1),type(2),0,0,ssa,
     & possb0,posst,mapdb,mapib)
c
       do 210 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 210
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       ib=mapib(sa(1),1,1)
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       call cct3_map21 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,p,q,1)
c
 210    continue
c
       else
c     RC=2 - bad typ for: nind=2
       rc=2
       end if
c
       else if (nind.eq.3) then
c
c     *********** 3 index ***********
c
       typ=mapda(0,6)
c
       if (typ.eq.0) then
c
c3.1  map A(p,q,r) -> B(p1,q1,r1)
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       call cct3_grc0 (nind,0,type(1),type(2),type(3),0,ssa,
     & possb0,posst,mapdb,mapib)
c
       do 310 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 310
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       ib=mapib(sa(1),sa(2),1)
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,r
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,
     &  nhelp5,p,q,r,1)
c
 310    continue
c
       else if (typ.eq.1) then
c
c3.2  map A(pq,r)
c     => only sophystical order of p,q,r is 2,3,1 i.e. B(r,pq)
c     => newtyp=2
c
       if ((p.eq.2).and.(q.eq.3).and.(r.eq.1)) then
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       call cct3_grc0 (nind,2,type(1),type(2),type(3),0,ssa,
     & possb0,posst,mapdb,mapib)
c
       do 320 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 320
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       ib=mapib(sa(1),sa(2),1)
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
c
c     dimpq
       if (sa(2).eq.sa(3)) then
       nhelp7=nhelp3*(nhelp3-1)/2
       else
       nhelp7=nhelp3*nhelp4
       end if
       call cct3_map21 (wrk(nhelp1),wrk(nhelp2),nhelp7,nhelp5,2,1,1)
c
 320    continue
c
       else
c     RC=3 - bad order of p,q,r for: nind=3,typ=1
       rc=3
       end if
c
       else if (typ.eq.2) then
c
c3.3  map A(p,qr)
c     => only sophystical order of p,q,r is 3,1,2 i.e. B(qr,p)
c     => typb=1
c
       if ((p.eq.3).and.(q.eq.1).and.(r.eq.2)) then
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       call cct3_grc0 (nind,1,type(1),type(2),type(3),0,ssa,
     & possb0,posst,mapdb,mapib)
c
       do 330 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 330
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       ib=mapib(sa(1),sa(2),1)
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
c
c     dimpq
       if (sa(1).eq.sa(2)) then
       nhelp7=nhelp4*(nhelp4-1)/2
       else
       nhelp7=nhelp4*nhelp5
       end if
       call cct3_map21 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp7,2,1,1)
c
 330    continue
c
       else
c     RC=4 - bad order of p,q,r for: nind=3,typ=2
       rc=4
       end if
c
       else
c     RC=5 - bad type for: nind=3
       rc=5
       end if
c
       else if (nind.eq.4) then
c
c     *********** 4 index ***********
c
       typ=mapda(0,6)
c
       if (typ.eq.0) then
c
c4.1  map A(p,q,r,s)
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       type(s)=mapda(0,4)
       call cct3_grc0 (nind,0,type(1),type(2),type(3),type(4),ssa,
     & possb0,posst,mapdb,mapib)
c
       do 410 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 410
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       sa(s)=mapda(ia,6)
       ib=mapib(sa(1),sa(2),sa(3))
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
       nhelp6=dimm(mapda(0,4),sa(s))
       call cct3_map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,
     & nhelp5,nhelp6,p,q,r,s,1)
c
 410    continue
c
       else if ((typ.gt.0).and.(typ.lt.4)) then
c
c4.2  map A(p,q,r,s) with one limitation
c
c     def newtype and do corresponding tests
c
       if (typ.eq.1) then
       if ((p.gt.3).or.((q-p).ne.1)) then
c     RC=6 bad order of p,q,r,s, for: nind=4,typ=1
       rc=6
       return
       else
       nhelp1=p
       end if
       else if (typ.eq.2) then
       if ((q.gt.3).or.((r-q).ne.1)) then
c     RC=7 bad order of p,q,r,s, for: nind=4,typ=2
       rc=7
       return
       else
       nhelp1=q
       end if
       else if (typ.eq.3) then
       if ((r.gt.3).or.((s-r).ne.1)) then
c     RC=8 bad order of p,q,r,s, for: nind=4,typ=3
       rc=8
       return
       else
       nhelp1=r
       end if
       end if
       newtyp=nhelp1
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       type(s)=mapda(0,4)
       call cct3_grc0 (nind,newtyp,type(1),type(2),type(3),type(4),ssa,
     & possb0,posst,mapdb,mapib)

       do 420 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 420
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       sa(s)=mapda(ia,6)
       ib=mapib(sa(1),sa(2),sa(3))
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr,dims
       dl(p)=dimm(mapda(0,1),sa(p))
       dl(q)=dimm(mapda(0,2),sa(q))
       dl(r)=dimm(mapda(0,3),sa(r))
       dl(s)=dimm(mapda(0,4),sa(s))
c
       if ((newtyp.eq.1).and.(sa(1).eq.sa(2))) then
c     B(p1q1,r1,s1) case => oldtyp can be 2,3
       nhelp7=dl(1)*(dl(1)-1)/2
c
       if (typ.eq.1) then
c     A(pq,r,s) case
c     A(pq,r,s) -> A(pq,s,r)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),
     &  dl(s),1,3,2,1)
       else if (typ.eq.2) then
c     A(p,qr,s) case
       if (p.eq.3) then
c     A (p,qr,s) -> B(qr,p,s)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),
     &  2,1,3,1)
       else
c     A (p,qr,s) -> B(qr,s,p)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),
     &  3,1,2,1)
       end if
       else
c     A(p,q,rs) case
       if (p.eq.3) then
c     A (p,q,rs) -> B(rs,p,q)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),
     &  nhelp7,2,3,1,1)
       else
c     A (p,q,rs) -> B(rs,q,p)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),
     &  nhelp7,3,2,1,1)
       end if
       end if
c
       else if ((newtyp.eq.2).and.(sa(2).eq.sa(3))) then
c     B(p1,q1r1,s1) case => oldtyp can be 1,3
       nhelp7=dl(2)*(dl(2)-1)/2
       if (typ.eq.1) then
c     A(pq,r,s) case
       if (r.eq.1) then
c     A (pq,r,s) -> B(r,pq,s)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),
     &  2,1,3,1)
       else
c     A (pq,r,s) -> B(s,pq,p)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),
     &  2,3,1,1)
       end if
       else if (typ.eq.2) then
c     A(p,qr,s) case
c     A(p,qr,s) -> B(s,qr,p)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),
     & 3,2,1,1)
       else
c     A(p,q,rs) case
       if (p.eq.1) then
c     A (p,q,rs) -> B(p,rs,q)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,
     & 1,3,2,1)
       else
c     A (p,q,rs) -> B(q,rs,p)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,
     & 3,1,2,1)
       end if
       end if
c
       else if ((newtyp.eq.3).and.(sa(3).eq.sa(4))) then
c     B(p1,q1,r1s1) case => oldtyp can be 1,2
       nhelp7=dl(3)*(dl(3)-1)/2
       if (typ.eq.1) then
c     A(pq,r,s) case
       if (r.eq.2) then
c     A (pq,r,s) -> B(r,s,pq)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),
     & 3,1,2,1)
       else
c     A (pq,r,s) -> B(s,r,pq)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),
     & 3,2,1,1)
       end if
       else if (typ.eq.2) then
c     A(p,qr,s) case
       if (p.eq.1) then
c     A (p,qr,s) -> B(p,s,qr)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),
     & 1,3,2,1)
       else
c     A (p,qr,s) -> B(s,p,qr)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),
     & 2,3,1,1)
       end if
       else
c     A(p,q,rs) case
c     A(p,q,rs) -> A(q,p,rs)
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,
     &  2,1,3,1)
       end if
c
       else
c     B(p1,q1,r1,s1) case
       call cct3_map41 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),dl(r),
     & dl(s),p,q,r,s,1)
       end if
c
 420    continue
c
c
       else if (typ.eq.4) then
c
c4.2  map A(pq,rs) -> B(rs,pq)
c
c     tests
c
       if ((p.ne.3).and.(q.ne.4).and.(r.ne.1).and.(s.ne.2)) then
c     RC=9 : nind=4, typA=4 (bad order of p,q,r,s, Stup)
       rc=9
       return
       end if
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       type(s)=mapda(0,4)
       call cct3_grc0 (nind,4,type(1),type(2),type(3),type(4),ssa,
     & possb0,posst,mapdb,mapib)
c
       do 430 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 430
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       sa(s)=mapda(ia,6)
       ib=mapib(sa(1),sa(2),sa(3))
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
       nhelp6=dimm(mapda(0,4),sa(s))
c
       if ((sa(p).eq.sa(q)).and.(sa(r).eq.sa(s))) then
c     A(pq,rs) -> B(rs,pq)
       nhelp3=nhelp3*(nhelp3-1)/2
       nhelp5=nhelp5*(nhelp5-1)/2
       call cct3_map21 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5,2,1,1)
c
       else if (sa(p).eq.sa(q)) then
c     A(pq,r,s) -> B(r,s,pq)
       nhelp3=nhelp3*(nhelp3-1)/2
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5,nhelp6,
     & 3,1,2,1)
c
       else if (sa(r).eq.sa(s)) then
c     A(p,q,rs) -> B(rs,p,q)
       nhelp5=nhelp5*(nhelp5-1)/2
       call cct3_map31 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,
     & 2,3,1,1)
c
       else
c     A(p,q,r,s) -> B(r,s,p,q)
       call cct3_map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,
     & nhelp6,3,4,1,2,1)
       end if
c
 430    continue
c
       else
c     RC=10 bad type for: nind=4
       rc=10
       end if
c
       else
c
c     *********  more than 4 indexes
c
c     RC=11 bad number of indexes
       rc=11
       end if
c
c
       return
       end
c
c     -----------
c
       subroutine cct3_noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,poss0,posst)
c
c     realize mapping without permutation
c     define mapd,mapi
c
#include "t31.fh"
#include "wrk.fh"
c
       integer poss0,posst
       integer mapda(0:512,1:6),mapdb(0:512,1:6)
       integer mapia(1:8,1:8,1:8),mapib(1:8,1:8,1:8)
c
c     help variables
c
       integer ib,nhelp,i,j,k
c
c     def mapib
c
       do 10 k=1,nsym
       do 11 j=1,nsym
       do 12 i=1,nsym
       mapib(i,j,k)=mapia(i,j,k)
 12     continue
 11     continue
 10     continue
c
c     def initial values
c
       do nhelp=1,6
       mapdb(0,nhelp)=mapda(0,nhelp)
       end do
c
       posst=poss0
       do 100 ib=1,mapda(0,5)
       do nhelp=2,6
       mapdb(ib,nhelp)=mapda(ib,nhelp)
       end do
       mapdb(ib,1)=posst
       posst=posst+mapdb(ib,2)
c
       call cct3_map11 (wrk(mapda(ib,1)),wrk(mapdb(ib,1)),mapda(ib,2),1)
c
 100    continue
c
       return
       end
c
c     --------------------------
c
       subroutine cct3_map41 (a,b,dimp,dimq,dimr,dims,p,q,r,s,nfact)
c
c     maping A(p1,q1,r1,s1) -> nfact* B(p2,q2,r2,s2)
c
       real*8 a(*)
       real*8 b(*)
       integer dim(4)
       integer dimp,dimq,dimr,dims,p,q,r,s,nfact
       dim(p)=dimp
       dim(q)=dimq
       dim(r)=dimr
       dim(s)=dims
       call cct3_map42 (a,b,dimp,dimq,dimr,dims,dim(1),dim(2),dim(3),
     & dim(4),p,q,r,s,nfact)
       return
       end
c
       subroutine cct3_map42 (a,b,dimp,dimq,dimr,dims,dim1,dim2,
     & dim3,dim4,p,q,r,s,nfact)
c
       integer dimp,dimq,dimr,dims,dim1,dim2,dim3,dim4,p,q,r,s,nfact
       real*8 a(1:dimp,1:dimq,1:dimr,1:dims)
       real*8 b(1:dim1,1:dim2,1:dim3,1:dim4)
c     integer index(1:4)
c
       integer pp,qq,rr,ss
c
       if (nfact.eq.1) then
c
c     factor + 1
c
c     do 100 ss=1,dims
c     index(s)=ss
c     do 100 rr=1,dimr
c     index(r)=rr
c     do 100 qq=1,dimq
c     index(q)=qq
c     do 100 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2),index(3),index(4))=a(pp,qq,rr,ss)
c100  continue
c
       if (p.eq.1) then
c     1***
       if (q.eq.2) then
c     12**
       if (r.eq.3) then
c     123* (4)
       do 111 ss=1,dims
       do 1110 rr=1,dimr
       do 1111 qq=1,dimq
       do 1112 pp=1,dimp
       b(pp,qq,rr,ss)=a(pp,qq,rr,ss)
 1112   continue
 1111   continue
 1110   continue
 111    continue
       else
c     124* (3)
       do 112 ss=1,dims
       do 1120 rr=1,dimr
       do 1121 qq=1,dimq
       do 1122 pp=1,dimp
       b(pp,qq,ss,rr)=a(pp,qq,rr,ss)
 1122   continue
 1121   continue
 1120   continue
 112    continue
       end if
       else if (q.eq.3) then
c     13**
       if (r.eq.2) then
c     132* (4)
       do 113 ss=1,dims
       do 1130 rr=1,dimr
       do 1131 qq=1,dimq
       do 1132 pp=1,dimp
       b(pp,rr,qq,ss)=a(pp,qq,rr,ss)
 1132   continue
 1131   continue
 1130   continue
 113    continue
       else
c     134* (2)
       do 114 ss=1,dims
       do 1140 rr=1,dimr
       do 1141 qq=1,dimq
       do 1142 pp=1,dimp
       b(pp,ss,qq,rr)=a(pp,qq,rr,ss)
 1142   continue
 1141   continue
 1140   continue
 114    continue
       end if
       else if (q.eq.4) then
c     14**
       if (r.eq.2) then
c     142* (3)
       do 115 ss=1,dims
       do 1150 rr=1,dimr
       do 1151 qq=1,dimq
       do 1152 pp=1,dimp
       b(pp,rr,ss,qq)=a(pp,qq,rr,ss)
 1152   continue
 1151   continue
 1150   continue
 115    continue
       else
c     143* (2)
       do 116 ss=1,dims
       do 1160 rr=1,dimr
       do 1161 qq=1,dimq
       do 1162 pp=1,dimp
       b(pp,ss,rr,qq)=a(pp,qq,rr,ss)
 1162   continue
 1161   continue
 1160   continue
 116    continue
       end if
       end if
c
       else if (p.eq.2) then
c     2***
       if (q.eq.1) then
c     21**
       if (r.eq.3) then
c     213* (4)
       do 121 ss=1,dims
       do 1210 rr=1,dimr
       do 1211 qq=1,dimq
       do 1212 pp=1,dimp
       b(qq,pp,rr,ss)=a(pp,qq,rr,ss)
 1212   continue
 1211   continue
 1210   continue
 121    continue
       else
c     214* (3)
       do 122 ss=1,dims
       do 1220 rr=1,dimr
       do 1221 qq=1,dimq
       do 1222 pp=1,dimp
       b(qq,pp,ss,rr)=a(pp,qq,rr,ss)
 1222   continue
 1221   continue
 1220   continue
 122    continue
       end if
       else if (q.eq.3) then
c     23**
       if (r.eq.1) then
c     231* (4)
       do 123 ss=1,dims
       do 1230 rr=1,dimr
       do 1231 qq=1,dimq
       do 1232 pp=1,dimp
       b(rr,pp,qq,ss)=a(pp,qq,rr,ss)
 1232   continue
 1231   continue
 1230   continue
 123    continue
       else
c     234* (1)
       do 124 ss=1,dims
       do 1240 rr=1,dimr
       do 1241 qq=1,dimq
       do 1242 pp=1,dimp
       b(ss,pp,qq,rr)=a(pp,qq,rr,ss)
 1242   continue
 1241   continue
 1240   continue
 124    continue
       end if
       else if (q.eq.4) then
c     24**
       if (r.eq.3) then
c     243* (1)
       do 125 ss=1,dims
       do 1250 rr=1,dimr
       do 1251 qq=1,dimq
       do 1252 pp=1,dimp
       b(ss,pp,rr,qq)=a(pp,qq,rr,ss)
 1252   continue
 1251   continue
 1250   continue
 125    continue
       else
c     241* (3)
       do 126 ss=1,dims
       do 1260 rr=1,dimr
       do 1261 qq=1,dimq
       do 1262 pp=1,dimp
       b(rr,pp,ss,qq)=a(pp,qq,rr,ss)
 1262   continue
 1261   continue
 1260   continue
 126    continue
       end if
       end if
c
       else if (p.eq.3) then
c     3***
       if (q.eq.1) then
c     31**
       if (r.eq.2) then
c     312* (4)
       do 131 ss=1,dims
       do 1310 rr=1,dimr
       do 1311 qq=1,dimq
       do 1312 pp=1,dimp
       b(qq,rr,pp,ss)=a(pp,qq,rr,ss)
 1312   continue
 1311   continue
 1310   continue
 131    continue
       else
c     314* (2)
       do 132 ss=1,dims
       do 1320 rr=1,dimr
       do 1321 qq=1,dimq
       do 1322 pp=1,dimp
       b(qq,ss,pp,rr)=a(pp,qq,rr,ss)
 1322   continue
 1321   continue
 1320   continue
 132    continue
       end if
       else if (q.eq.2) then
c     32**
       if (r.eq.1) then
c     321* (4)
       do 133 ss=1,dims
       do 1330 rr=1,dimr
       do 1331 qq=1,dimq
       do 1332 pp=1,dimp
       b(rr,qq,pp,ss)=a(pp,qq,rr,ss)
 1332   continue
 1331   continue
 1330   continue
 133    continue
       else
c     324* (1)
       do 134 ss=1,dims
       do 1340 rr=1,dimr
       do 1341 qq=1,dimq
       do 1342 pp=1,dimp
       b(ss,qq,pp,rr)=a(pp,qq,rr,ss)
 1342   continue
 1341   continue
 1340   continue
 134    continue
       end if
       else if (q.eq.4) then
c     34**
       if (r.eq.1) then
c     341* (2)
       do 135 ss=1,dims
       do 1350 rr=1,dimr
       do 1351 qq=1,dimq
       do 1352 pp=1,dimp
       b(rr,ss,pp,qq)=a(pp,qq,rr,ss)
 1352   continue
 1351   continue
 1350   continue
 135    continue
       else
c     342* (1)
       do 136 ss=1,dims
       do 1360 rr=1,dimr
       do 1361 qq=1,dimq
       do 1362 pp=1,dimp
       b(ss,rr,pp,qq)=a(pp,qq,rr,ss)
 1362   continue
 1361   continue
 1360   continue
 136    continue
       end if
       end if
c
       else if (p.eq.4) then
c     4***
       if (q.eq.1) then
c     41**
       if (r.eq.3) then
c     413* (2)
       do 141 ss=1,dims
       do 1410 rr=1,dimr
       do 1411 qq=1,dimq
       do 1412 pp=1,dimp
       b(qq,ss,rr,pp)=a(pp,qq,rr,ss)
 1412   continue
 1411   continue
 1410   continue
 141    continue
       else
c     412* (3)
       do 142 ss=1,dims
       do 1420 rr=1,dimr
       do 1421 qq=1,dimq
       do 1422 pp=1,dimp
       b(qq,rr,ss,pp)=a(pp,qq,rr,ss)
 1422   continue
 1421   continue
 1420   continue
 142    continue
       end if
       else if (q.eq.2) then
c     42**
       if (r.eq.1) then
c     421* (3)
       do 143 ss=1,dims
       do 1430 rr=1,dimr
       do 1431 qq=1,dimq
       do 1432 pp=1,dimp
       b(rr,qq,ss,pp)=a(pp,qq,rr,ss)
 1432   continue
 1431   continue
 1430   continue
 143    continue
       else
c     423* (1)
       do 144 ss=1,dims
       do 1440 rr=1,dimr
       do 1441 qq=1,dimq
       do 1442 pp=1,dimp
       b(ss,qq,rr,pp)=a(pp,qq,rr,ss)
 1442   continue
 1441   continue
 1440   continue
 144    continue
       end if
       else if (q.eq.3) then
c     43**
       if (r.eq.1) then
c     431* (2)
       do 145 ss=1,dims
       do 1450 rr=1,dimr
       do 1451 qq=1,dimq
       do 1452 pp=1,dimp
       b(rr,ss,qq,pp)=a(pp,qq,rr,ss)
 1452   continue
 1451   continue
 1450   continue
 145    continue
       else
c     432* (1)
       do 146 ss=1,dims
       do 1460 rr=1,dimr
       do 1461 qq=1,dimq
       do 1462 pp=1,dimp
       b(ss,rr,qq,pp)=a(pp,qq,rr,ss)
 1462   continue
 1461   continue
 1460   continue
 146    continue
       end if
       end if
c
       end if
c
       else
c
c     factor = -1
c
c     do 200 ss=1,dims
c     index(s)=ss
c     do 200 rr=1,dimr
c     index(r)=rr
c     do 200 qq=1,dimq
c     index(q)=qq
c     do 200 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2),index(3),index(4))=-a(pp,qq,rr,ss)
c200  continue
c
       if (p.eq.1) then
c     1***
       if (q.eq.2) then
c     12**
       if (r.eq.3) then
c     123* (4)
       do 211 ss=1,dims
       do 2110 rr=1,dimr
       do 2111 qq=1,dimq
       do 2112 pp=1,dimp
       b(pp,qq,rr,ss)=-a(pp,qq,rr,ss)
 2112   continue
 2111   continue
 2110   continue
 211    continue
       else
c     124* (3)
       do 212 ss=1,dims
       do 2120 rr=1,dimr
       do 2121 qq=1,dimq
       do 2122 pp=1,dimp
       b(pp,qq,ss,rr)=-a(pp,qq,rr,ss)
 2122   continue
 2121   continue
 2120   continue
 212    continue
       end if
       else if (q.eq.3) then
c     13**
       if (r.eq.2) then
c     132* (4)
       do 213 ss=1,dims
       do 2130 rr=1,dimr
       do 2131 qq=1,dimq
       do 2132 pp=1,dimp
       b(pp,rr,qq,ss)=-a(pp,qq,rr,ss)
 2132   continue
 2131   continue
 2130   continue
 213    continue
       else
c     134* (2)
       do 214 ss=1,dims
       do 2140 rr=1,dimr
       do 2141 qq=1,dimq
       do 2142 pp=1,dimp
       b(pp,ss,qq,rr)=-a(pp,qq,rr,ss)
 2142   continue
 2141   continue
 2140   continue
 214    continue
       end if
       else if (q.eq.4) then
c     14**
       if (r.eq.2) then
c     142* (3)
       do 215 ss=1,dims
       do 2150 rr=1,dimr
       do 2151 qq=1,dimq
       do 2152 pp=1,dimp
       b(pp,rr,ss,qq)=-a(pp,qq,rr,ss)
 2152   continue
 2151   continue
 2150   continue
 215    continue
       else
c     143* (2)
       do 216 ss=1,dims
       do 2160 rr=1,dimr
       do 2161 qq=1,dimq
       do 2162 pp=1,dimp
       b(pp,ss,rr,qq)=-a(pp,qq,rr,ss)
 2162   continue
 2161   continue
 2160   continue
 216    continue
       end if
       end if
c
       else if (p.eq.2) then
c     2***
       if (q.eq.1) then
c     21**
       if (r.eq.3) then
c     213* (4)
       do 221 ss=1,dims
       do 2210 rr=1,dimr
       do 2211 qq=1,dimq
       do 2212 pp=1,dimp
       b(qq,pp,rr,ss)=-a(pp,qq,rr,ss)
 2212   continue
 2211   continue
 2210   continue
 221    continue
       else
c     214* (3)
       do 222 ss=1,dims
       do 2220 rr=1,dimr
       do 2221 qq=1,dimq
       do 2222 pp=1,dimp
       b(qq,pp,ss,rr)=-a(pp,qq,rr,ss)
 2222   continue
 2221   continue
 2220   continue
 222    continue
       end if
       else if (q.eq.3) then
c     23**
       if (r.eq.1) then
c     231* (4)
       do 223 ss=1,dims
       do 2230 rr=1,dimr
       do 2231 qq=1,dimq
       do 2232 pp=1,dimp
       b(rr,pp,qq,ss)=-a(pp,qq,rr,ss)
 2232   continue
 2231   continue
 2230   continue
 223    continue
       else
c     234* (1)
       do 224 ss=1,dims
       do 2240 rr=1,dimr
       do 2241 qq=1,dimq
       do 2242 pp=1,dimp
       b(ss,pp,qq,rr)=-a(pp,qq,rr,ss)
 2242   continue
 2241   continue
 2240   continue
 224    continue
       end if
       else if (q.eq.4) then
c     24**
       if (r.eq.3) then
c     243* (1)
       do 225 ss=1,dims
       do 2250 rr=1,dimr
       do 2251 qq=1,dimq
       do 2252 pp=1,dimp
       b(ss,pp,rr,qq)=-a(pp,qq,rr,ss)
 2252   continue
 2251   continue
 2250   continue
 225    continue
       else
c     241* (3)
       do 226 ss=1,dims
       do 2260 rr=1,dimr
       do 2261 qq=1,dimq
       do 2262 pp=1,dimp
       b(rr,pp,ss,qq)=-a(pp,qq,rr,ss)
 2262   continue
 2261   continue
 2260   continue
 226    continue
       end if
       end if
c
       else if (p.eq.3) then
c     3***
       if (q.eq.1) then
c     31**
       if (r.eq.2) then
c     312* (4)
       do 231 ss=1,dims
       do 2310 rr=1,dimr
       do 2311 qq=1,dimq
       do 2312 pp=1,dimp
       b(qq,rr,pp,ss)=-a(pp,qq,rr,ss)
 2312   continue
 2311   continue
 2310   continue
 231    continue
       else
c     314* (2)
       do 232 ss=1,dims
       do 2320 rr=1,dimr
       do 2321 qq=1,dimq
       do 2322 pp=1,dimp
       b(qq,ss,pp,rr)=-a(pp,qq,rr,ss)
 2322   continue
 2321   continue
 2320   continue
 232    continue
       end if
       else if (q.eq.2) then
c     32**
       if (r.eq.1) then
c     321* (4)
       do 233 ss=1,dims
       do 2330 rr=1,dimr
       do 2331 qq=1,dimq
       do 2332 pp=1,dimp
       b(rr,qq,pp,ss)=-a(pp,qq,rr,ss)
 2332   continue
 2331   continue
 2330   continue
 233    continue
       else
c     324* (1)
       do 234 ss=1,dims
       do 2340 rr=1,dimr
       do 2341 qq=1,dimq
       do 2342 pp=1,dimp
       b(ss,qq,pp,rr)=-a(pp,qq,rr,ss)
 2342   continue
 2341   continue
 2340   continue
 234    continue
       end if
       else if (q.eq.4) then
c     34**
       if (r.eq.1) then
c     341* (2)
       do 235 ss=1,dims
       do 2350 rr=1,dimr
       do 2351 qq=1,dimq
       do 2352 pp=1,dimp
       b(rr,ss,pp,qq)=-a(pp,qq,rr,ss)
 2352   continue
 2351   continue
 2350   continue
 235    continue
       else
c     342* (1)
       do 236 ss=1,dims
       do 2360 rr=1,dimr
       do 2361 qq=1,dimq
       do 2362 pp=1,dimp
       b(ss,rr,pp,qq)=-a(pp,qq,rr,ss)
 2362   continue
 2361   continue
 2360   continue
 236    continue
       end if
       end if
c
       else if (p.eq.4) then
c     4***
       if (q.eq.1) then
c     41**
       if (r.eq.3) then
c     413* (2)
       do 241 ss=1,dims
       do 2410 rr=1,dimr
       do 2411 qq=1,dimq
       do 2412 pp=1,dimp
       b(qq,ss,rr,pp)=-a(pp,qq,rr,ss)
 2412   continue
 2411   continue
 2410   continue
 241    continue
       else
c     412* (3)
       do 242 ss=1,dims
       do 2420 rr=1,dimr
       do 2421 qq=1,dimq
       do 2422 pp=1,dimp
       b(qq,rr,ss,pp)=-a(pp,qq,rr,ss)
 2422   continue
 2421   continue
 2420   continue
 242    continue
       end if
       else if (q.eq.2) then
c     42**
       if (r.eq.1) then
c     421* (3)
       do 243 ss=1,dims
       do 2430 rr=1,dimr
       do 2431 qq=1,dimq
       do 2432 pp=1,dimp
       b(rr,qq,ss,pp)=-a(pp,qq,rr,ss)
 2432   continue
 2431   continue
 2430   continue
 243    continue
       else
c     423* (1)
       do 244 ss=1,dims
       do 2440 rr=1,dimr
       do 2441 qq=1,dimq
       do 2442 pp=1,dimp
       b(ss,qq,rr,pp)=-a(pp,qq,rr,ss)
 2442   continue
 2441   continue
 2440   continue
 244    continue
       end if
       else if (q.eq.3) then
c     43**
       if (r.eq.1) then
c     431* (2)
       do 245 ss=1,dims
       do 2450 rr=1,dimr
       do 2451 qq=1,dimq
       do 2452 pp=1,dimp
       b(rr,ss,qq,pp)=-a(pp,qq,rr,ss)
 2452   continue
 2451   continue
 2450   continue
 245    continue
       else
c     432* (1)
       do 246 ss=1,dims
       do 2460 rr=1,dimr
       do 2461 qq=1,dimq
       do 2462 pp=1,dimp
       b(ss,rr,qq,pp)=-a(pp,qq,rr,ss)
 2462   continue
 2461   continue
 2460   continue
 246    continue
       end if
       end if
c
       end if
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(s)
       end
c
c     --------------------------
c
       subroutine cct3_map31 (a,b,dimp,dimq,dimr,p,q,r,nfact)
c
c     maping A(p1,q1,r1) -> nfact*B(p2,q2,r2)
c
       real*8 a(*)
       real*8 b(*)
       integer dim(3)
       integer dimp,dimq,dimr,p,q,r,nfact
       dim(p)=dimp
       dim(q)=dimq
       dim(r)=dimr
       call cct3_map32 (a,b,dimp,dimq,dimr,dim(1),dim(2),dim(3),
     & p,q,r,nfact)
       return
       end
c
       subroutine cct3_map32 (a,b,dimp,dimq,dimr,dim1,dim2,dim3,
     & p,q,r,nfact)
c
       integer dimp,dimq,dimr,dim1,dim2,dim3,p,q,r,nfact
       real*8 a(1:dimp,1:dimq,1:dimr)
       real*8 b(1:dim1,1:dim2,1:dim3)
c     integer index(1:3)
c
       integer pp,qq,rr
c
       if (nfact.eq.1) then
c
c     fact = + 1
c
c     do 100 rr=1,dimr
c     index(r)=rr
c     do 100 qq=1,dimq
c     index(q)=qq
c     do 100 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2),index(3))=a(pp,qq,rr)
c100  continue
c
       if (p.eq.1) then
c     1**
       if (q.eq.2) then
c     12* (3)
       do 110 rr=1,dimr
       do 111 qq=1,dimq
       do 112 pp=1,dimp
       b(pp,qq,rr)=a(pp,qq,rr)
 112    continue
 111    continue
 110    continue
       else
c     13* (2)
       do 120 rr=1,dimr
       do 121 qq=1,dimq
       do 122 pp=1,dimp
       b(pp,rr,qq)=a(pp,qq,rr)
 122    continue
 121    continue
 120    continue
       end if
       else if (p.eq.2) then
c     2**
       if (q.eq.1) then
c     21* (3)
       do 130 rr=1,dimr
       do 131 qq=1,dimq
       do 132 pp=1,dimp
       b(qq,pp,rr)=a(pp,qq,rr)
 132    continue
 131    continue
 130    continue
       else
c     23* (1)
       do 140 rr=1,dimr
       do 141 qq=1,dimq
       do 142 pp=1,dimp
       b(rr,pp,qq)=a(pp,qq,rr)
 142    continue
 141    continue
 140    continue
       end if
       else if (p.eq.3) then
c     3**
       if (q.eq.1) then
c     31* (2)
       do 150 rr=1,dimr
       do 151 qq=1,dimq
       do 152 pp=1,dimp
       b(qq,rr,pp)=a(pp,qq,rr)
 152    continue
 151    continue
 150    continue
       else
c     32* (1)
       do 160 rr=1,dimr
       do 161 qq=1,dimq
       do 162 pp=1,dimp
       b(rr,qq,pp)=a(pp,qq,rr)
 162    continue
 161    continue
 160    continue
       end if
       end if
c
c
       else
c
c     factor = -1
c
c     do 200 rr=1,dimr
c     index(r)=rr
c     do 200 qq=1,dimq
c     index(q)=qq
c     do 200 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2),index(3))=-a(pp,qq,rr)
c     200        continue
c
       if (p.eq.1) then
c     1**
       if (q.eq.2) then
c     12* (3)
       do 210 rr=1,dimr
       do 211 qq=1,dimq
       do 212 pp=1,dimp
       b(pp,qq,rr)=-a(pp,qq,rr)
 212    continue
 211    continue
 210    continue
       else
c     13* (2)
       do 220 rr=1,dimr
       do 221 qq=1,dimq
       do 222 pp=1,dimp
       b(pp,rr,qq)=-a(pp,qq,rr)
 222    continue
 221    continue
 220    continue
       end if
       else if (p.eq.2) then
c     2**
       if (q.eq.1) then
c     21* (3)
       do 230 rr=1,dimr
       do 231 qq=1,dimq
       do 232 pp=1,dimp
       b(qq,pp,rr)=-a(pp,qq,rr)
 232    continue
 231    continue
 230    continue
       else
c     23* (1)
       do 240 rr=1,dimr
       do 241 qq=1,dimq
       do 242 pp=1,dimp
       b(rr,pp,qq)=-a(pp,qq,rr)
 242    continue
 241    continue
 240    continue
       end if
       else if (p.eq.3) then
c     3**
       if (q.eq.1) then
c     31* (2)
       do 250 rr=1,dimr
       do 251 qq=1,dimq
       do 252 pp=1,dimp
       b(qq,rr,pp)=-a(pp,qq,rr)
 252    continue
 251    continue
 250    continue
       else
c     32* (1)
       do 260 rr=1,dimr
       do 261 qq=1,dimq
       do 262 pp=1,dimp
       b(rr,qq,pp)=-a(pp,qq,rr)
 262    continue
 261    continue
 260    continue
       end if
       end if
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(r)
       end
c
c     --------------------------
c
       subroutine cct3_map21 (a,b,dimp,dimq,p,q,nfact)
c
c     maping A(p1,q1) -> nfact*B(p2,q2)
c
       real*8 a(*)
       real*8 b(*)
       integer dim(2)
       integer dimp,dimq,p,q,nfact
       dim(p)=dimp
       dim(q)=dimq
       call cct3_map22 (a,b,dimp,dimq,dim(1),dim(2),p,q,nfact)
       return
       end
c
       subroutine cct3_map22 (a,b,dimp,dimq,dim1,dim2,p,q,nfact)
c
       integer dimp,dimq,dim1,dim2,p,q,nfact
       real*8 a(1:dimp,1:dimq)
       real*8 b(1:dim1,1:dim2)
c       integer index(1:2)
c
       integer pp,qq
c
       if (nfact.eq.1) then
c
c     nfact = + 1
c
c     do 100 qq=1,dimq
c     index(q)=qq
c     do 100 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2))=a(pp,qq)
c100  continue
c
       if (p.eq.1) then
c     1* (2)
       do 110 qq=1,dimq
       do 111 pp=1,dimp
       b(pp,qq)=a(pp,qq)
 111    continue
 110    continue
       else
c     2* (1)
       do 120 qq=1,dimq
       do 121 pp=1,dimp
       b(qq,pp)=a(pp,qq)
 121    continue
 120    continue
       end if
c
c
       else
c
c     nfact = -1
c
c     do 200 qq=1,dimq
c     index(q)=qq
c     do 200 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2))=-a(pp,qq)
c200  continue
c
       if (p.eq.1) then
c     1* (2)
       do 210 qq=1,dimq
       do 211 pp=1,dimp
       b(pp,qq)=-a(pp,qq)
 211    continue
 210    continue
       else
c     2* (1)
       do 220 qq=1,dimq
       do 221 pp=1,dimp
       b(qq,pp)=-a(pp,qq)
 221    continue
 220    continue
       end if
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(q)
       end
c
c     --------------------------
c
       subroutine cct3_map11 (a,b,dimp,nfact)
c
c     maping A(p) -> nfact*B(p)
c
       integer dimp,nfact
       real*8 a(1:dimp)
       real*8 b(1:dimp)
c
       integer pp
c
       if (nfact.eq.1) then
c
       do 100 pp=1,dimp
       b(pp)=a(pp)
 100    continue
c
       else
c
       do 200 pp=1,dimp
       b(pp)=-a(pp)
 200    continue
c
       end if
c
       return
       end
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Find_Bonds(Coor,nAtoms,iTab,nMax,nx,ny,nz,iBox,iANr,iTabBonds,nBonds,nBondMax,iTabAtoms,ThrB)

use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Slapaf_Info, only: BondType
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nMax, nx, ny, nz, iTab(0:nMax,nx,ny,nz), iBox(3,nAtoms), iANr(nAtoms), nBondMax
real(kind=wp), intent(in) :: Coor(3,nAtoms), ThrB
integer(kind=iwp), intent(out) :: iTabBonds(3,nBondMax), nBonds, iTabAtoms(2,0:nMax,nAtoms)
integer(kind=iwp) :: iAtom, iRow, ix, iy, iz, jx, jy, jz
real(kind=wp) :: ThrB_vdW
integer(kind=iwp), external :: iTabRow
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, iBond, nn
integer(kind=iwp), external :: nCoBond
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
! Initiate

#ifdef _DEBUGPRINT_
call RecPrt('Coor',' ',Coor,3,nAtoms)
write(u6,*) 'Find_Bonds: ThrB=',ThrB
write(u6,*) 'Initialize iTabAtoms'
#endif

iTabBonds(:,:) = 0
iTabAtoms(:,:,:) = 0
nBonds = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Find all covalent bonds (type 0).

do iAtom=1,nAtoms

  iRow = iTabRow(iANr(iAtom))
  if (iRow == 0) cycle

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'iAtom, iAnr=',iAtom,iANr(iAtom)
  write(u6,*)
# endif
  ix = iBox(1,iAtom)
  iy = iBox(2,iAtom)
  iz = iBox(3,iAtom)

  ! Loop over all adjacent boxes.

  do jx=ix-1,ix+1
    do jy=iy-1,iy+1
      do jz=iz-1,iz+1
        call Bond_Tester(Coor,nAtoms,iTab,nx,ny,nz,jx,jy,jz,iAtom,iRow,iANr,iTabBonds,nBonds,nBondMax,iTabAtoms,nMax,ThrB,1.0e99_wp)

      end do
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'After Covalent Bonds'
write(u6,*)
write(u6,*) 'iTabAtoms:'
do iAtom=1,nAtoms
  write(u6,*)
  write(u6,*) 'iAtom=',iAtom
  write(u6,*)
  write(u6,*) 'nNeighbor=',iTabAtoms(1,0,iAtom)
  nn = iTabAtoms(1,0,iAtom)
  write(u6,*) ' Neigbors:',(iTabAtoms(1,i,iAtom),i=1,nn)
  write(u6,*) ' Bond    :',(iTabAtoms(2,i,iAtom),i=1,nn)
  write(u6,*) ' Bondtype:',(iTabBonds(3,iTabAtoms(2,i,iAtom)),i=1,nn)
  write(u6,*) ' nCoBond :',nCoBond(iAtom,nAtoms,nMax,iTabBonds,nBondMax,iTabAtoms)

end do
write(u6,*)
write(u6,*)
write(u6,*) 'Bonds:'
do iBond=1,nBonds
  write(u6,*)
  write(u6,*) 'iBond=',iBond
  write(u6,*)
  write(u6,*) 'Atoms=',iTabBonds(1,iBond),iTabBonds(2,iBond)
  write(u6,*) 'Bondtype:',BondType(min(3,iTabBonds(3,iBond)))
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Find all vdW bonds (type 1).

! Loop over all adjacent boxes. Do vdW bonds.

ThrB_vdW = 1.0e-4_wp*ThrB
do iAtom=1,nAtoms

  iRow = iTabRow(iANr(iAtom))
  if (iRow == 0) cycle

  ix = iBox(1,iAtom)
  iy = iBox(2,iAtom)
  iz = iBox(3,iAtom)

  ! Loop over all adjacent boxes.

  do jx=ix-1,ix+1
    do jy=iy-1,iy+1
      do jz=iz-1,iz+1
        call Bond_Tester(Coor,nAtoms,iTab,nx,ny,nz,jx,jy,jz,iAtom,iRow,iANr,iTabBonds,nBonds,nBondMax,iTabAtoms,nMax,ThrB,ThrB_vdW)

      end do
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'After vdW Bonds'
write(u6,*)
write(u6,*) 'iTabAtoms:'
do iAtom=1,nAtoms
  write(u6,*)
  write(u6,*) 'iAtom=',iAtom
  write(u6,*)
  write(u6,*) 'nNeighbor=',iTabAtoms(1,0,iAtom)
  nn = iTabAtoms(1,0,iAtom)
  write(u6,*) ' Neigbors:',(iTabAtoms(1,i,iAtom),i=1,nn)
  write(u6,*) ' Bond    :',(iTabAtoms(2,i,iAtom),i=1,nn)
  write(u6,*) ' Bondtype:',(iTabBonds(3,iTabAtoms(2,i,iAtom)),i=1,nn)
end do
write(u6,*)
write(u6,*)
write(u6,*)
write(u6,*) 'Bonds:'
do iBond=1,nBonds
  write(u6,*)
  write(u6,*) 'iBond=',iBond
  write(u6,*)
  write(u6,*) 'Atoms=',iTabBonds(1,iBond),iTabBonds(2,iBond)
  write(u6,*) 'Bondtype:',BondType(min(3,iTabBonds(3,iBond)))
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Test connectivity in case of fragmentation of the system.

! These bonds are of type 2.

call Connect_Fragments(nAtoms,iTabBonds,nBondMax,nBonds,Coor,iTabAtoms,nMax,iANr)
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'After Connecting Fragments'
write(u6,*)
write(u6,*) 'iTabAtoms:'
do iAtom=1,nAtoms
  write(u6,*)
  write(u6,*) 'iAtom=',iAtom
  write(u6,*)
  write(u6,*) 'nNeighbor=',iTabAtoms(1,0,iAtom)
  nn = iTabAtoms(1,0,iAtom)
  write(u6,*) ' Neigbors:',(iTabAtoms(1,i,iAtom),i=1,nn)
  write(u6,*) ' Bond    :',(iTabAtoms(2,i,iAtom),i=1,nn)
  write(u6,*) ' Bondtype:',(iTabBonds(3,iTabAtoms(2,i,iAtom)),i=1,nn)
end do
write(u6,*)
write(u6,*)
write(u6,*) 'Bonds:'
do iBond=1,nBonds
  write(u6,*)
  write(u6,*) 'iBond=',iBond
  write(u6,*)
  write(u6,*) 'Atoms=',iTabBonds(1,iBond),iTabBonds(2,iBond)
  write(u6,*) 'Bondtype:',BondType(min(3,iTabBonds(3,iBond)))
end do
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
! Finally, for partially linear system we need "extra long bond",
! this to make sure that we include torsions over linear subsystems.
! This "magic bonds" are only included when forming torsions.

call Magic_Bonds(Coor,nAtoms,iTabBonds,nBondMax,nBonds,iTabAtoms,nMax)

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'After Magic Bonds'
write(u6,*)
write(u6,*) 'iTabAtoms:'
do iAtom=1,nAtoms
  write(u6,*)
  write(u6,*) 'iAtom=',iAtom
  write(u6,*)
  write(u6,*) 'nNeighbor=',iTabAtoms(1,0,iAtom)
  nn = iTabAtoms(1,0,iAtom)
  write(u6,*) ' Neigbors:',(iTabAtoms(1,i,iAtom),i=1,nn)
  write(u6,*) ' Bond    :',(iTabAtoms(2,i,iAtom),i=1,nn)
  write(u6,*) ' Bondtype:',(iTabBonds(3,iTabAtoms(2,i,iAtom)),i=1,nn)
end do
write(u6,*)
write(u6,*)
write(u6,*) 'Bonds:'
do iBond=1,nBonds
  write(u6,*)
  write(u6,*) 'iBond=',iBond
  write(u6,*)
  write(u6,*) 'Atoms=',iTabBonds(1,iBond),iTabBonds(2,iBond)
  write(u6,*) 'Bondtype:',BondType(min(3,iTabBonds(3,iBond)))
end do
#endif

return

end subroutine Find_Bonds

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      integer function symmetry(isym,jsym)
CSVC: returns the product of two irreps (1-based indexing of irreps!)
      implicit none
      integer isym, jsym
      symmetry = IEOR(isym-1,jsym-1)+1
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1999, Roland Lindh                                *
************************************************************************
      Subroutine TnsCtl(Wrk,nWrk,Coora,
     &                  mabcd,nijkl,mabMax,mabMin,mcdMax,mcdMin,
     &                  HMtrxAB,HMtrxCD,la,lb,lc,ld,
     &                  iCmpa,jCmpb,kCmpc,lCmpd,
     &                  iShlla,jShllb,kShllc,lShlld,i_out)
************************************************************************
*                                                                      *
* Object: to transform the intermediate integral set directly to       *
*         the final integral set.                                      *
*         Note that the position in memory of the final set is not     *
*         fixed.                                                       *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             Modified by R.L Februrary, 1999.                         *
************************************************************************
      use Real_Spherical
      use Basis_Info
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "print.fh"
#include "real.fh"
      Parameter(lab=iTabMx*2+1,npMax=lab*(lab+1)*(lab+2)/6)
      Real*8 HMtrxAB(*),HMtrxCD(*)
      Real*8, Intent(inout) :: Wrk(nWrk)
      Real*8 Coora(3,4)
      Integer, Intent(out) :: i_out
      ![all others are intent(in)]
*
*---- Integral are stored as e,f,IJKL in Wrk
*
*---- Observe that Transf is false for s and p functions.
*
*---- If (ss|ss) integral exit.
*
      If (la+lb+lc+ld.eq.0) Then
         i_out=1
         Return
      End If
*
      ne=(mabMax-mabMin+1)
      nf=(mcdMax-mcdMin+1)
      nab=iCmpa*jCmpb
      ncd=kCmpc*lCmpd
*
      iW2=1
      iW3=1+nijkl*Max(ne*nf,nab*nf,nab*ncd)
*
*---- Transpose if no transformation is needed.
*
      If ((la*lb.eq.0).and.(lc*ld.eq.0).and.
     &    .Not.Shells(iShlla)%Transf .and.
     &    .Not.Shells(jShllb)%Transf .and.
     &    .Not.Shells(kShllc)%Transf .and.
     &    .Not.Shells(lShlld)%Transf ) Then
         Call DGeTMO(Wrk(iW2),ne*nf,ne*nf,nijkl,Wrk(iW3),nijkl)
         i_out=iW3
         Return
      End If
*
*---- Form matrix corresponding to the transfer equation, le,la,lb.
*     The matrix transforms directly from e0 cartesians to real
*     spherical harmonics.
*
      If (la+lb.eq.0) Then
         i_in=iW2
         i_out=iW3
      Else If ((la*lb.eq.0).and.
     &    .Not.Shells(iShlla)%Transf .and.
     &    .Not.Shells(jShllb)%Transf) Then
         Call DGeTMO(Wrk(iW2),ne,ne,nf*nijkl,Wrk(iW3),nf*nijkl)
         i_in=iW3
         i_out=iW2
      Else
*
*------- Now transform directly (e,[f,IJKL]) to ([f,IJKL],AB)
*        Int(lf*IJKL,lA*lB)=Int(le,lf*IJKL)*HMtrx(le,lA*lB)
*
         nfijkl = nf*nijkl
         Call Sp_Mlt(Wrk(iW2),ne,Wrk(iW3),nfijkl,HMtrxAB,
     &               iCmpa*jCmpb)
         i_in=iW3
         i_out=iW2
      End If
*
*
*---- Form matrix corresponding to the transfer equation, lf,lC,lD
*
      If (lc+ld.eq.0) Then
         i_out=i_in
      Else If ((lc*ld.eq.0).and.
     &    .Not.Shells(kShllc)%Transf .and.
     &    .Not.Shells(lShlld)%Transf) Then
         Call DGeTMO(Wrk(i_in),nf,nf,nijkl*iCmpa*jCmpb,Wrk(i_out),
     &               nijkl*iCmpa*jCmpb)
      Else
*
*------- Now transform directly (f,[IJKL,AB]) to ([IJKL,AB],CD)
*        Int(IJKL*lA*lB,lC*lD)=Int(lf,IJKL*lA*lB)*HMtrx(lf,lC*lD)
*
         nijklAB = nijkl*iCmpa*jCmpb
         Call Sp_Mlt(Wrk(i_in),nf,Wrk(i_out),nijklAB,HMtrxCD,
     &               kCmpc*lCmpd)
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Coora)
         Call Unused_integer(mabcd)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

module InputData
!SVC: this module contains a data structure to keep all input variables.

use Data_Structures, only: Alloc1DiArray_Type
use fciqmc_interface, only: DoFCIQMC, NonDiagonal, TransformToNormalOrder
use fortran_strings, only: str
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
private

type InputTable
  ! TITL  one line with a descriptive name
  character(len=128) :: Title = ' '
  ! FILE  file to read CAS/RAS reference from
  character(len=128) :: File = 'JOBIPH'
  ! MULT  the number of states, followed by the ID of each state
  logical(kind=iwp) :: MULT = .false.
  integer(kind=iwp) :: nMultState = 0
  type(Alloc1DiArray_Type) :: MultGroup
  logical(kind=iwp) :: AllMult = .false.
  ! XMUL  extended multi-state caspt2
  logical(kind=iwp) :: XMUL = .false.
  integer(kind=iwp) :: nXMulState = 0
  type(Alloc1DiArray_Type) :: XMulGroup
  logical(kind=iwp) :: AllXMult = .false.
  ! RMUL  rotated multi-state caspt2
  logical(kind=iwp) :: RMUL = .false.
  integer(kind=iwp) :: nRMulState = 0
  type(Alloc1DiArray_Type) :: RMulGroup
  logical(kind=iwp) :: AllRMult = .false.
  ! DWMS  use dynamical weighting to construct Fock
  logical(kind=iwp) :: DWMS = .false.
  integer(kind=iwp) :: DWType = -1
  real(kind=wp) :: ZETA = One
  ! LROO  compute only a single root, mutually exclusive with both MULT or XMUL
  logical(kind=iwp) :: LROO = .false.
  integer(kind=iwp) :: SingleRoot = 0
  ! RLXR  root for which the gradient is computed
  integer(kind=iwp) :: RlxRoot = -1

  ! IPEA  the IPEA shift
  logical(kind=iwp) :: IPEA = .false.
  real(kind=wp) :: ipea_shift = Zero
  ! IMAG  the imaginary level shift
  real(kind=wp) :: imag_shift = Zero
  ! SHIF  the real level shift
  real(kind=wp) :: real_shift = Zero
  ! SIG1  sigma-1 regularization
  real(kind=wp) :: sigma_1_epsilon = Zero
  ! SIG2  sigma-2 regularization
  real(kind=wp) :: sigma_2_epsilon = Zero

  ! several freeze-delete schemes, each of these should active
  ! the general flag below, to indicate additional conversion is
  ! needed on the input orbitals
  logical(kind=iwp) :: modify_correlating_MOs = .false.
  ! AFRE  freeze orbitals that do not have sufficient density on specified 'active' atoms
  logical(kind=iwp) :: aFreeze = .false.
  integer(kind=iwp) :: lnFro = 0
  real(kind=wp) :: ThrFr = Zero, ThrDe = Zero
  character(len=4), allocatable :: NamFro(:)
  ! LOVC  freeze orbitals that are not localized no the active site
  logical(kind=iwp) :: LovCASPT2 = .false.
  real(kind=wp) :: Thr_Atm = Zero
  ! FNOC  delete a fraction of virtual orbitals
  logical(kind=iwp) :: FnoCASPT2 = .false.
  real(kind=wp) :: VFrac = Zero
  ! RegFNO  FNO regularization parameter
  real(kind=wp) :: RegFNO = Zero
  ! DOMP
  logical(kind=iwp) :: doMP2 = .false.
  ! DOEN
  logical(kind=iwp) :: doEnv = .false.
  ! VIRA
  logical(kind=iwp) :: VIRA = .false.
  ! GHOS  excludes ghost orbitals from the PT2 treatment
  logical(kind=iwp) :: GhostDelete = .false.
  real(kind=wp) :: ThrGD = Zero

  ! FROZ  number of frozen orbitals in each irrep
  logical(kind=iwp) :: FROZ = .false.
  integer(kind=iwp), allocatable :: nFro(:)
  ! DELE  number of deleted orbitals in each irrep
  logical(kind=iwp) :: DELE = .false.
  integer(kind=iwp), allocatable :: nDel(:)
  ! DENS  computes full density matrix from the 1st-order wavefunction
  logical(kind=iwp) :: DENS = .false.
  ! RFPE  make a perturbative reaction field calculation
  logical(kind=iwp) :: RFPert = .false.
  ! THRE  thresholds for removal of:
  !   ThrsHN  zero-norm components in the first-order perturbed
  !           wave function
  !   ThrsHS  linear dependencies between components of the first-
  !           order perturbed wave function
  logical(kind=iwp) :: THRE = .false.
  real(kind=wp) :: ThrsHN = 1.0e-10_wp, ThrsHS = 1.0e-8_wp
  ! MAXI  maximum number of iterations for solving a system of
  !       linear equations, default 20. A 0 indicates: use of
  !       the diagonal zeroth order hamiltonian
  integer(kind=iwp) :: maxIter = 20
  ! Conv  convergence criteria for solving a system of linear equations
  real(kind=wp) :: ThrConv = 1.0e-6_wp
  ! NOMI  do not create an PM-CAS wavefunction file (JobMix)
  logical(kind=iwp) :: NoMix = .false.
  ! NOMU  do not perform a multistate interaction
  logical(kind=iwp) :: noMult = .false.
  ! ONLY  in a MS calculation, compute a single root with couplings to the other roots
  integer(kind=iwp) :: OnlyRoot = 0
  ! EFFE  read Heff coupling terms from the input and perform only the multistate part
  logical(kind=iwp) :: JMS = .false.
  real(kind=wp), allocatable :: Heff(:,:)
  ! NOOR  do not print orbitals
  logical(kind=iwp) :: PrOrb = .true.
  ! PROP  compute properties
  ! NOPR  do not compute properties
  logical(kind=iwp) :: Properties = .false.
  ! transformation of reference (input) orbitals
  ! NOTR  do not transform to quasi-canonical orbitals,
  !       regardless of the state of the reference orbitals
  ! TRAN  transform to quasi-canonical orbitals, regardless
  !       of the state of the reference orbitals
  ! the default is to use transformation, unless the PT2 keyword
  ! was used in the rasscf program and the fock matrix is standard
  character(len=8) :: OrbIn = 'TRANSFOR'
  ! OFEM  add orbital-free embedding potential to hamiltonian
  logical(kind=iwp) :: OFEmbedding = .false.
  ! OUTP  control extent of orbital printing
  character(len=8) :: OutFormat = 'DEFAULT '
  ! PRWF  print the CI coefficients above this threshold
  real(kind=wp) :: PrWF = 0.05_wp
  ! PRSD  print the determinant expansion of CSFs
  logical(kind=iwp) :: PrSD = .false.
  ! PRHS  Parallel strategy for RHS construction
  !       '0' = 'DEFAULT', '1' = 'OLD', '2' = 'NEW', '3' = 'DIRECT'
  character(len=7) :: PRHS = 'DEFAULT'

  ! DMRG-related keywords
  ! CUMU
  logical(kind=iwp) :: doCumulant = .false.
  ! DMRG  DMRG-CASPT2 using QCMaquis
  logical(kind=iwp) :: DMRG = .false.

  ! Gradient-related keywords
  ! SADREF  use state-averaged density even for SS-CASPT2 with
  !         SA-CASSCF reference and MS-CASPT2 (not XMS)
  logical(kind=iwp) :: SADREF = .false.
  ! DORT  use the conventional (canonical) orthonormalization for generating
  !       internally contracted basis, rather than scaled (?)
  !       procedure by the diagonal element. This option is
  !       'sometimes' needed for analytic gradient.
  logical(kind=iwp) :: DORTHO = .false.
  ! GRDT  used for single-point gradient calculation
  logical(kind=iwp) :: GRDT = .false.
  ! NAC  compute NAC or interstate coupling vectors
  logical(kind=iwp) :: NAC = .false.
  integer(kind=iwp) :: iNACRoot1 = 0, iNACRoot2 = 0

  ! UNDOCUMENTED KEYWORDS
  ! CHOL
  logical(kind=iwp) :: Chol = .false.
  ! CHOI
  logical(kind=iwp) :: Choi = .false.
  ! WTHR  thresholds for writing large components in the
  !       first-order perturbed wave function, 3 values that
  !       are for denominator, coefficient, and energy
  real(kind=wp) :: DnmThr = 0.3_wp, CmpThr = 0.025_wp, CntThr = 0.005_wp
  ! FOCK  string representing the type of Fock matrix
  character(len=8) :: FockType = 'STANDARD'
  ! HZER  string representing the type of 0-order hamiltonian
  character(len=8) :: Hzero = 'STANDARD'
  ! G1SE  include secondary/inactive elements of the exchange
  !       matrix in the g1 modification to the fock matrix
  logical(kind=iwp) :: G1SecIn = .false.
  ! RHSD  use the RHS-ondemand algorithm for the calculation of the right-hand side
  logical(kind=iwp) :: RHSD = .false.
  ! CompressMPS  for (t)3-RDM computation to bond dimension given by CompressMPD
  integer(kind=iwp) :: CompressMPS = 0
  ! INVAR  specify the CASPT2 energy is invariant wrt active
  !        orbital rotations. This is automatically set for
  !        the case with IPEA shift. Otherwise, just for debug
  !        purpose
  logical(kind=iwp) :: INVAR = .true.
  ! CVIN  Convergence threshold for non-invariant CASPT2 equation
  real(kind=wp) :: ThrConvInvar = 1.0e-7_wp
  ! CSF  compute CSF contributions in derivative coupling
  logical(kind=iwp) :: CSF = .true.
  ! IAINVAR  specify the CASPT2 energy is invariant wrt inactive
  !          and secondary orbital rotations. Development purpose
  logical(kind=iwp) :: IAINVAR = .true.
  ! SCNEVPT2  Do property at SC-NEVPT2
  logical(kind=iwp) :: SCPROP = .false.
  ! DOPC      Do PC-NEVPT2 energy
  logical(kind=iwp) :: DOPC = .true.
  ! DOSC      Do SC-NEVPT2 energy
  logical(kind=iwp) :: DOSC = .true.
  ! SC_thres  Threshold for avoiding vanishing denominators
  real(kind=wp) :: SC_thres = 1.0e-9_wp

end type ! end of type InputTable

! Define the Input as an InputTable structure
type(InputTable), allocatable :: Input

public :: CleanUp_Input, Input, readin_CASPT2

contains

subroutine readin_CASPT2(LuIn,nSym)
  !SVC read and store the input as independent as possible. Any sanity
  ! checks not required for reading in the input should be postponed till
  ! the proc_inp call (processing of input). The only variable needed here
  ! is nSym, as some input lines assume knowledge of the number of irreps.

  use text_file, only: extend_line, next_non_comment

  integer(kind=iwp), intent(in) :: LuIn, nSym
  integer(kind=iwp) :: i, iError, iSplit, iSym, j, nStates
# ifdef _ENABLE_CHEMPS2_DMRG_
  logical(kind=iwp) :: dochemps2 = .false.
# endif
  character(len=4) :: Command, Word
  character(len=:), allocatable :: dLine, Line

  nStates = 0
  ! even if SCF was performed with FCIQMC, stochastic CASPT2 requires manual invocation.
  DoFCIQMC = .false.
  ! User needs to specify that they do not want to sample in pseudo-canonical orbitals.
  NonDiagonal = .false.
  ! for now, non-histogramming remains the default, hopefully that will change soon.
  TransformToNormalOrder = .false.

  rewind(LuIn)
  call RdNLst(LuIn,'CASPT2')

  ! beginning of reading loop
  do

    if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
    Command = Line(1:min(4,len(Line)))
    call Upcase(Command)

    ! Note that when multiple values are required, extend_line may
    ! be called (0 or more times) until the READ statement gives no error.
    ! This allows the input to be split in lines more or less arbitrarily,
    ! as if the values were read directly from the file.
    select case (Command)

      case ('TITL')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,'(A128)') Input%Title

      case ('FILE')
        ! File with the reference CAS/RAS wavefunction
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        ! Not using list-directed input (*), because then the slash means end of input
        read(Line,'(A)',iostat=iError) Input%file
        if (iError /= 0) call IOError(Line)

      ! root selection

      case ('MULT')
        Input%MULT = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*) Word
        call Upcase(Word)
        if (Word == 'ALL') then
          nStates = 0
          Input%AllMult = .true.
        else
          read(Line,*,iostat=iError) nStates
          if (iError /= 0) call IOError(Line)
          if (nStates <= 0) call MultError(Line)
        end if
        call mma_allocate(Input%MultGroup%A,nStates,label='MultGroup')
        Input%nMultState = nStates
        iSplit = scan(Line,' ')
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line(iSplit:)
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) (Input%MultGroup%A(i),i=1,nStates)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)

      case ('XMUL')
        Input%XMUL = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*) Word
        call Upcase(Word)
        if (Word == 'ALL') then
          nStates = 0
          Input%AllXMult = .true.
        else
          read(Line,*,iostat=iError) nStates
          if (iError /= 0) call IOError(Line)
          if (nStates <= 1) call StatesError(Line)
        end if
        call mma_allocate(Input%XMulGroup%A,nStates,label='XMulGroup')
        Input%nXMulState = nStates
        iSplit = scan(Line,' ')
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line(iSplit:)
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) (Input%XMulGroup%A(i),i=1,nStates)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)

      case ('RMUL')
        Input%RMUL = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*) Word
        call Upcase(Word)
        if (Word == 'ALL') then
          nStates = 0
          Input%AllRMult = .true.
        else
          read(Line,*,iostat=iError) nStates
          if (iError /= 0) call IOError(Line)
          if (nStates <= 1) call StatesError(Line)
        end if
        call mma_allocate(Input%RMulGroup%A,nStates,label='RMulGroup')
        Input%nRMulState = nStates
        iSplit = scan(Line,' ')
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line(iSplit:)
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) (Input%RMulGroup%A(i),i=1,nStates)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)

      case ('DWMS')
        Input%DWMS = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%ZETA
        if (iError /= 0) call IOError(Line)

      case ('DWTY')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%DWType
        if (iError /= 0) call IOError(Line)

      case ('LROO')
        Input%LROO = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%SingleRoot
        if (iError /= 0) call IOError(Line)

      case ('RLXR')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%RlxRoot
        if (iError /= 0) call IOError(Line)

      ! freeze-deleted control

      case ('FROZ')
        Input%FROZ = .true.
        call mma_allocate(Input%nFro,nSYM,label='nFro')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) (Input%nFro(iSym),iSym=1,nSym)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)

      case ('DELE')
        Input%DELE = .true.
        call mma_allocate(Input%nDel,nSYM,label='nDel')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) (Input%nDel(iSym),iSym=1,nSym)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)

      ! equation solver control

      case ('MAXI')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%maxIter
        if (iError /= 0) call IOError(Line)

      case ('CONV')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%ThrConv
        if (iError /= 0) call IOError(Line)

      case ('THRE')
        Input%THRE = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) Input%ThrsHN,Input%ThrsHS
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)

      case ('SHIF')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%real_shift
        if (iError /= 0) call IOError(Line)

      case ('IMAG')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%imag_shift
        if (iError /= 0) call IOError(Line)

      case ('SIG1')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%sigma_1_epsilon
        if (iError /= 0) call IOError(Line)

      case ('SIG2')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%sigma_2_epsilon
        if (iError /= 0) call IOError(Line)

      ! environment

      case ('RFPE')
        Input%RFpert = .true.

      case ('OFEM')
        Input%OFEmbedding = .true.

      ! print controls

      case ('PRWF')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%PrWF
        if (iError /= 0) call IOError(Line)

      case ('OUTP')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call StdFmt(Line,Input%OutFormat)

      case ('NOOR')
        Input%PrOrb = .false.

      case ('PRSD')
        Input%PRSD = .true.

      case ('WTHR')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) Input%DNMTHR,Input%CMPTHR,Input%CNTTHR
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)

      ! properties

      case ('DENS')
        Input%DENS = .true.

      case ('PROP')
        Input%Properties = .true.

      case ('NOPR')
        Input%Properties = .false.

      ! fock matrix, 0-order hamiltonian

      case ('TRAN')
        Input%ORBIN = 'TRANSFOR'

      case ('FOCK')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call StdFmt(Line,Input%FockType)

      case ('HZER')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call StdFmt(Line,Input%HZero)

      case ('G1SE')
        Input%G1SECIN = .true.

      case ('IPEA')
        Input%ipea = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%ipea_shift
        if (iError /= 0) call IOError(Line)

      ! cholesky

      case ('CHOL')
        Input%Chol = .true.
        call Cho_caspt2_rdInp(.true.,LuIn)

      case ('CHOI')
        Input%ChoI = .true.
        call Cho_caspt2_rdInp(.false.,LuIn)

      ! freeze-delete approximation schemes

      case ('AFRE')
        Input%aFreeze = .true.
        Input%modify_correlating_MOs = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) Input%lnFro,Input%ThrFr,Input%ThrDe
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)
        call mma_allocate(Input%NamFro,Input%lnFro,label='NamFro')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call Upcase(Line)
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) (Input%NamFro(i),i=1,Input%lnFro)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call Upcase(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)

      case ('LOVC')
        Input%LovCASPT2 = .true.
        Input%modify_correlating_MOs = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%thr_atm
        if (iError /= 0) call IOError(Line)

      case ('FNOC')
        Input%FnoCASPT2 = .true.
        Input%modify_correlating_MOs = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%vFrac
        if (iError /= 0) call IOError(Line)

      case ('REGF')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%RegFNO
        if (iError /= 0) call IOError(Line)

      case ('DOMP')
        Input%doMP2 = .true.

      case ('DOEN')
        Input%doEnv = .true.

      case ('VIRA')
        Input%VIRA = .true.

      case ('GHOS')
        Input%GhostDelete = .true.
        Input%modify_correlating_MOs = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%ThrGD
        if (iError /= 0) call IOError(Line)

      case ('NOMU')
        Input%NoMult = .true.

      case ('ONLY')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%OnlyRoot
        if (iError /= 0) call IOError(Line)

      case ('NOMI')
        Input%NoMix = .true.

      case ('RHSD')
        Input%RHSD = .true.

#     ifdef _ENABLE_BLOCK_DMRG_
      case ('CUMU')
        Input%doCumulant = .true.

#     elif _ENABLE_CHEMPS2_DMRG_
      case ('CHEM')
        !Quan: Using the same variable doCumulant in Block
        Input%doCumulant = .true.
        dochemps2 = .true.

#     elif _DMRG_
      case ('DMRG')
        Input%DMRG = .true.

      case ('CMPS')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%CompressMPS
        if (iError /= 0) call IOError(Line)
#     endif

      case ('FCIQ')
        DoFciQMC = .true.

      case ('NDIA')
        NonDiagonal = .true.

      case ('NORD')
        TransformToNormalOrder = .true.

      case ('EFFE')
        Input%JMS = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) nStates
        if (iError /= 0) call IOError(Line)
        call mma_allocate(Input%Heff,nStates,nStates,label='Heff')
        Input%Heff = Zero
        do i=1,nStates
          if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
          call mma_allocate(dLine,len(Line),label='dLine')
          dLine(:) = Line
          iError = -1
          do while (iError < 0)
            read(dLine,*,iostat=iError) (Input%Heff(i,j),j=1,nStates)
            if (iError > 0) call IOError(Line)
            if (iError < 0) then
              if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
              call extend_line(dLine,Line)
            end if
          end do
          call mma_deallocate(dLine)
        end do

      case ('SADR')
        Input%SADREF = .true.

      case ('DORT')
        Input%DORTHO = .true.

      case ('CORT') !! it is actually the canonical orthonormalization
        Input%DORTHO = .true.

      case ('INVA')
        Input%INVAR = .false.

      case ('CVIN')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%ThrConvInvar
        if (iError /= 0) call IOError(Line)

      case ('GRDT')
        Input%GRDT = .true.

      case ('NAC ')
        Input%NAC = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate(dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read(dLine,*,iostat=iError) Input%iNACRoot1,Input%iNACRoot2
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate(dLine)

      case ('NOCS')
        Input%CSF = .false.

      case ('IAIN')
        Input%IAINVAR = .false.

      case ('PRHS')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call StdFmt(Line,Input%PRHS)

      ! NEVPT2-related keywords

      case ('NEV ','NEVP','PCNE','PC-N','PC  ')
        Input%Hzero = 'DYALL'

      case ('SC  ','SCNE','SC-N')
        Input%Hzero = 'DYALL'
        Input%SCPROP = .true.

      case ('NOPC')
        Input%DOPC = .false.

      case ('NOSC')
        Input%DOSC = .false.

      case ('SCTH')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read(Line,*,iostat=iError) Input%SC_thres
        if (iError /= 0) call IOError(Line)

      ! OBSOLETE KEYWORDS

      case ('GRAD')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError()

      case ('NOTR')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError()

      case ('JACO')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError()

      case ('EXTR')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError()

      case ('QLQR')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError()

      case ('NATU')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError()

      case ('MOLO')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError()

      ! DONE WITH READING INPUT

      case ('END ')
        exit

      ! NO MATCH FOUND, UNKOWN KEYWORD

      case default
        call WarningMessage(2,'Unrecognized keyword: '//Command)
        call Quit_OnUserError()

    end select

  end do ! end of reading loop

# ifdef _ENABLE_CHEMPS2_DMRG_
  ! Check if nState>1
  if (dochemps2 .and. (nStates > 1)) then
    write(u6,*) 'CHEMPS2> Only State Specific calculation supported'
    call Quit_OnUserError()
  end if
# endif

  if (DoFCIQMC .and. (nStates > 1)) then
    write(u6,*) 'FCIQMC supports only state-specific CASPT2.'
    write(u6,*) 'You requested '//str(nStates)//' states.'
    write(u6,*) 'Consult the manual for the keyword "Multistate".'
    call Quit_OnUserError()
  end if

  call mma_deallocate(Line)

  ! Normal exit
  return

end subroutine readin_CASPT2

subroutine CleanUp_Input()

  if (allocated(Input)) then
    call mma_deallocate(Input%MultGroup%A,safe='*')
    call mma_deallocate(Input%XMulGroup%A,safe='*')
    call mma_deallocate(Input%RMulGroup%A,safe='*')
    call mma_deallocate(Input%NamFro,safe='*')
    call mma_deallocate(Input%nFro,safe='*')
    call mma_deallocate(Input%nDel,safe='*')
    call mma_deallocate(Input%Heff,safe='*')
    ! The input structure itself is a scalar, allocated outside mma
    deallocate(Input)
  end if

end subroutine CleanUp_Input

subroutine IOError(line)

  character(len=*), intent(in) :: line

  call WarningMessage(2,'I/O error when reading line.')
  write(u6,*) 'Last line read from input: ',line
  call Quit_OnUserError()

end subroutine IOError

subroutine EOFError(line)

  character(len=*), intent(in) :: line

  call WarningMessage(2,'Premature end of input file.')
  write(u6,*) 'Last line read from input: ',line
  call Quit_OnUserError()

end subroutine EOFError

subroutine StatesError(line)

  character(len=*), intent(in) :: line

  call WarningMessage(2,'Number of XMULT or RMULT states must be > 1.')
  write(u6,*) 'Last line read from input: ',line
  call Quit_OnUserError()

end subroutine StatesError

subroutine MultError(line)

  character(len=*), intent(in) :: line

  call WarningMessage(2,'Number of MULT states must be > 0.')
  write(u6,*) 'Last line read from input: ',line
  call Quit_OnUserError()

end subroutine MultError

end module InputData

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine readin_single(iprint,nmult,ndim,ldim,ndimcf,ldimcf,
     & nlanth,axisoption,poly_file,Ifrestart,input_to_read, nk, mg,
     & zmagn,Do_structure_abc,cryst,coord,encut_definition,
     & compute_g_tensors,compute_CF,nDirTot,nss,nstate,
     & compute_magnetization,compute_torque,smagn,tinput,hinput,
     & compute_Mdir_vector, zeeman_energy, LUZee, doplot,
     & encut_rate,ncut,nTempMagn,TempMagn,m_paranoid,
     & compute_barrier,nBlock,AngPoints,input_file_name,
     & nT,nH,texp,chit_exp,zJ,hexp,magn_exp,hmin,hmax,
     & nDir,nDirZee,dirX,dirY,dirZ,dir_weight,xfield,tmin,tmax,
     & thrs,H_torq,T_torq)
C
C  THIS ROUTINE READS THE FILE "SINGLE_ANISO.INPUT".
C
C
      Implicit None
      Integer, parameter         :: wp=SELECTED_REAL_KIND(p=15,r=307)
#include "warnings.fh"
#include "mgrid.fh"

c----------------------------------------------------------------
c   magnetization vectors:
      Integer            :: nDir,nDirZee
      Real(kind=8)      :: dirX(nDir), dirY(nDir), dirZ(nDir)
      Real(kind=8)      :: dir_weight(nDirZee,3)
      Logical            :: compute_Mdir_vector, zeeman_energy
c      common/MVL/ compute_Mdir_vector
c      common/MZEL/ zeeman_energy
c----------------------------------------------------------------
      Integer :: nss, nstate
      Integer :: iprint,nt,nh,nk,mg,igsm,l,jEnd
      Integer :: nlanth,ndimcf,ldimcf,axisoption, i_OxStat
      Integer :: input_to_read,encut_definition,ncut,ntempmagn
      Integer :: ndirtot
      Integer :: nBlock
      Integer :: nmult,ndim(nMult), ldim
      Integer :: AngPoints
      Integer :: LUZee(nDirZee)

      Real(kind=8) :: tmin,tmax,hmin,hmax,t1,t2,zj,
     &                 tempmagn(nTempMagn), encut_rate
      Real(kind=8) :: texp(nT),chit_exp(nT)
      Real(kind=8) :: hexp(nH),magn_exp(nH,ntempmagn)
      Real(kind=8) :: zmagn(3,3),sum,tmp
      Real(kind=8) :: cryst(6),coord(3)
      Real(kind=8) :: column_check(3,3), row_check(3,3)
      Real(kind=8) :: check_dir_weight(nDirZee)
      Real(kind=8) :: zr(3,3),det_zmagn
      Real(kind=8) :: FindDetR
      Real(kind=8) :: Xfield
      Real(kind=8), intent(out) :: thrs
      Real(kind=8), intent(out) :: H_torq, T_torq

      Logical :: hcheck,tcheck,poly_file
      Logical :: Ifrestart,Do_structure_abc
      Logical :: compute_magnetization,encut_check,compute_cf
      Logical :: compute_g_tensors
      Logical :: checktmag
      Logical :: compute_barrier
      Logical :: compute_torque
      Logical :: smagn
      Logical :: tinput,hinput
      Logical, intent(out) :: m_paranoid
      Logical              :: doplot

      Character(Len=2)  :: cME,clanth(37)
      Character(Len=21) :: namefile_energy
      Character(Len=180):: input_file_name,tmpline,err_msg

      External      :: FindDetR

      Integer  :: IsFreeUnit
      External :: IsFreeUnit
c=======================================================================
c      COMMON/CHISUBR/ TMIN,TMAX,T1,T2
c      COMMON/CHISUBL/ TINPUT
c      COMMON/MAGNSUBI/ NK,MG
c      COMMON/MAGNSUBR/ HMIN,HMAX
c      COMMON/MAGNSUBL/ HINPUT

      Integer        :: I,LINENR,j
      Character(Len=280) :: LINE


      Logical :: DBG

      DBG=.false.
C============ Some default settings=====================================
c  variables in "mgrid.fh"
      Do i=1,32
         Do j=1,3
           get_nP(j,i)=0
         End Do
      End Do
      nsymm  =1
      ngrid  =15
      get_nP(1, 1)=   5
      get_nP(1, 2)=   9
      get_nP(1, 3)=  17
      get_nP(1, 4)=  25
      get_nP(1, 5)=  29
      get_nP(1, 6)=  45
      get_nP(1, 7)=  49
      get_nP(1, 8)=  61
      get_nP(1, 9)=  77
      get_nP(1,10)=  93
      get_nP(1,11)= 105
      get_nP(1,12)= 125
      get_nP(1,13)= 141
      get_nP(1,14)= 161
      get_nP(1,15)= 185
      get_nP(1,16)= 229
      get_nP(1,17)= 309
      get_nP(1,18)= 401
      get_nP(1,19)= 505
      get_nP(1,20)= 621
      get_nP(1,21)= 749
      get_nP(1,22)= 889
      get_nP(1,23)=1041
      get_nP(1,24)=1205
      get_nP(1,25)=1381
      get_nP(1,26)=1569
      get_nP(1,27)=1769
      get_nP(1,28)=1981
      get_nP(1,29)=2205
      get_nP(1,30)=2441
      get_nP(1,31)=2689
      get_nP(1,32)=2949
      get_nP(2, 1)=   4
      get_nP(2, 2)=   6
      get_nP(2, 3)=  11
      get_nP(2, 4)=  16
      get_nP(2, 5)=  17
      get_nP(2, 6)=  27
      get_nP(2, 7)=  28
      get_nP(2, 8)=  34
      get_nP(2, 9)=  41
      get_nP(2,10)=  51
      get_nP(2,11)=  57
      get_nP(2,12)=  68
      get_nP(2,13)=  75
      get_nP(2,14)=  86
      get_nP(2,15)=  98
      get_nP(2,16)= 121
      get_nP(2,17)= 162
      get_nP(2,18)= 209
      get_nP(2,19)= 262
      get_nP(2,20)= 321
      get_nP(2,21)= 386
      get_nP(2,22)= 457
      get_nP(2,23)= 534
      get_nP(2,24)= 617
      get_nP(2,25)= 706
      get_nP(2,26)= 801
      get_nP(2,27)= 902
      get_nP(2,28)=1009
      get_nP(2,29)=1122
      get_nP(2,30)=1241
      get_nP(2,31)=1366
      get_nP(2,32)=1497
      get_nP(3, 1)=  3
      get_nP(3, 2)=  4
      get_nP(3, 3)=  7
      get_nP(3, 4)= 10
      get_nP(3, 5)= 10
      get_nP(3, 6)= 16
      get_nP(3, 7)= 16
      get_nP(3, 8)= 19
      get_nP(3, 9)= 22
      get_nP(3,10)= 28
      get_nP(3,11)= 31
      get_nP(3,12)= 37
      get_nP(3,13)= 40
      get_nP(3,14)= 46
      get_nP(3,15)= 52
      get_nP(3,16)= 64
      get_nP(3,17)= 85
      get_nP(3,18)=109
      get_nP(3,19)=136
      get_nP(3,20)=166
      get_nP(3,21)=199
      get_nP(3,22)=235
      get_nP(3,23)=274
      get_nP(3,24)=316
      get_nP(3,25)=361
      get_nP(3,26)=409
      get_nP(3,27)=460
      get_nP(3,28)=514
      get_nP(3,29)=571
      get_nP(3,30)=631
      get_nP(3,31)=694
      get_nP(3,32)=760
c variables in "mvect.fh"
      compute_Mdir_vector=.false.
      zeeman_energy=.false.
      Do i=1,nDir
        DirX(i)=0.0_wp
        DirY(i)=0.0_wp
        DirZ(i)=0.0_wp
      End Do
      Do i=1,nDirZee
        dir_weight(i,1)=0.0_wp
        dir_weight(i,2)=0.0_wp
        dir_weight(i,3)=0.0_wp
      End Do
C========== Initializations of arrays ==================================
      Do I=1,nTempMagn
        TempMagn(i)=0.0_wp
      End Do
C============ Initializations of constants =============================

      thrs                  = 1.0D-10
      ldim                  = 1
      ncut                  = 1
      TMIN                  = 0.0_wp
      TMAX                  = 300.0_wp
      XFIELD                = 0.0_wp
c      NT                    = 301
      HMIN                  =  0.0_wp
      HMAX                  = 10.0_wp
c      NH                    =  21
      NK                    = 200
      MG                    = 200
c      NDIR                  = 0
c      nDirZee               = 0
c      nTempMagn             = 1
      If(nTempMagn>0) TempMagn(1) = 2.0_wp
      T1                    = 5.0_wp
      T2                    = 6.0_wp
      ZJ                    = 0.0_wp
      IGSM                  = 1
      m_paranoid            =  .true.
      checkTMAG             =  .FALSE.
      compute_g_tensors     =  .FALSE.
      compute_magnetization =  .FALSE.
      compute_Mdir_vector   =  .FALSE.
      compute_CF            =  .FALSE.
      compute_barrier       =  .FALSE.
      compute_torque        =  .FALSE.
      smagn                 =  .FALSE.
      TINPUT                =  .FALSE.
      HINPUT                =  .FALSE.
      TCHECK                =  .FALSE.
      HCHECK                =  .FALSE.
      POLY_FILE             =  .FALSE.
      Do_structure_abc      =  .FALSE.
      zeeman_energy         =  .false.
      ENCUT_check           =  .false.
      doplot                =  .false.
      nlanth                =  0
      nDIMcf                =  0
      cME                   =  '  '
c -- lanthanides
      clanth( 1)            =  'CE'
      clanth( 2)            =  'PR'
      clanth( 3)            =  'ND'
      clanth( 4)            =  'PM'
      clanth( 5)            =  'SM'
      clanth( 6)            =  'EU'
      clanth( 7)            =  'GD'
      clanth( 8)            =  'TB'
      clanth( 9)            =  'DY'
      clanth(10)            =  'HO'
      clanth(11)            =  'ER'
      clanth(12)            =  'TM'
      clanth(13)            =  'YB'
      clanth(14)            =  'LU'
c -- actinides
      clanth(15)            =  'TH'
      clanth(16)            =  'PA'
      clanth(17)            =  'U'
      clanth(18)            =  'NP'
      clanth(19)            =  'PU'
      clanth(20)            =  'AM'
      clanth(21)            =  'CM'
      clanth(22)            =  'BK'
      clanth(23)            =  'CF'
      clanth(24)            =  'ES'
      clanth(25)            =  'FM'
      clanth(26)            =  'MD'
      clanth(27)            =  'NO'
      clanth(28)            =  'LR'
c -- transition metals
      clanth(29)            =  'SC'
      clanth(30)            =  'TI'
      clanth(31)            =  'V'
      clanth(32)            =  'CR'
      clanth(33)            =  'MN'
      clanth(34)            =  'FE'
      clanth(35)            =  'CO'
      clanth(36)            =  'NI'
      clanth(37)            =  'CU'

      Do i=1,6
      cryst(i)=0.0_wp
      End Do
      Do i=1,3
      coord(i)=0.0_wp
      End Do
      axisoption       =  1
      input_to_read    =  0
      encut_definition =  2
      encut_rate       =  1
      Do i=1,3
      coord(i)=0.0_wp
       Do j=1,3
       zmagn(i,j)=0.0_wp
       End Do
      End Do
      AngPoints = 46

C=========== End of default settings====================================
      REWIND (5)
50    READ(5,'(A280)',End=998) LINE
      IF(DBG) Write(6,'(A)') TRIM(LINE)
      Call NORMAL(LINE)
      If(LINE(1:7).ne.'&SINGLE') Go To 50
      LINENR=0
100   READ(5,'(A280)',End=998) LINE
      IF(DBG) Write(6,'(A)') TRIM(LINE)
      LINENR=LINENR+1
      Call NORMAL(LINE)
      If(LINE(1:1).eq.'*') Go To 100
      If(LINE.eq.' ') Go To 100
      If ((LINE(1:4).eq.'End ').OR.(LINE(1:4).eq.'    '))  Go To 200

C ------------------------------------------
c      If (LINE(1:4).eq.'TYPE') Then
c        READ(5,*,ERR=997) ICALC
c         If     (icalc.eq.1) Then
c           compute_g_tensors     =  .true.
c         Else If (icalc.eq.2) Then
c           compute_chiT          =  .true.
c         Else If (icalc.eq.3) Then
c           compute_magnetization =  .true.
c         Else If (icalc.eq.4) Then
c           compute_g_tensors     =  .true.
c           compute_chiT          =  .true.
c         Else If (icalc.eq.5) Then
c           compute_g_tensors     =  .true.
c           compute_magnetization =  .true.
c         Else If (icalc.eq.6) Then
c           compute_chiT          =  .true.
c           compute_magnetization =  .true.
c         Else If (icalc.eq.7) Then
c           compute_g_tensors     =  .true.
c           compute_chiT          =  .true.
c           compute_magnetization =  .true.
c         Else
c         Write(6,'(A)') 'ICALC: the maximum value is 7. However, '//
c     &    'the calculation will continue by computing the magnetism.'
c           compute_g_tensors     =  .true.
c           compute_chiT          =  .true.
c           compute_magnetization =  .true.
c         End If
c        LINENR=LINENR+1
c        Go To 100
c      End If
C ------------------------------------------
      If (LINE(1:4).eq.'MLTP') Then
        READ(5,*,ERR=997) NMULT
        IF(DBG) Write(6,*) 'MLTP:  NMULT=',NMULT
        compute_g_tensors     =  .true.
        READ(5,*,Err=997) (NDIM(i),i=1,NMULT)
        IF(DBG) Write(6,*) 'MLTP: NDIM()=',(NDIM(i),i=1,NMULT)
        IGSM=NDIM(1)
        LINENR=LINENR+2
        Go To 100
      End If
C ------------------------------------------
      If (LINE(1:4).eq.'REST') Then
        Ifrestart=.true.
        READ(5,*,ERR=997) input_to_read
        IF(DBG) Write(6,*) 'REST: input_to_read=',input_to_read
        If ( (input_to_read==2) .OR. (input_to_read==3) .OR.
     &       (input_to_read==4)  ) Then
          BACKSPACE(5)
          READ(5,*) input_to_read, tmpline
          input_file_name=trim(tmpline)
        End If
        If (input_to_read == 1) Then
          Write(6,*)'RESTART: -- The SINGLE_ANISO will take all '//
     &              'ab initio information from the binary '//
     &              '$Project.aniso" file.'
        Else If (input_to_read == 2) Then
          Write(6,*)'RESTART: -- The SINGLE_ANISO will take all '//
     &              'ab initio information from the ASCII '//
     &              trim(input_file_name)//' file.'
        Else If ( input_to_read .eq. 3 ) Then
          Write(6,*)'RESTART: -- The SINGLE_ANISO will take all '//
     &              'ab initio information from the RASSI-HDF5 '//
     &              'binary file.'
        Else If (input_to_read == 4) Then
          Write(6,*)'RESTART: -- The SINGLE_ANISO will take all '//
     &              'ab initio information from the ASCII '//
     &              trim(input_file_name)//' file -- molcas-8.0 format.'
        Else
          Call WarningMessage(2,'SINGLE_ANISO:: RESTART  '//
     &                          'option is not known.')
          Call Quit_OnUserError()
        End If
       Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'TINT') Then
        If(TINPUT.EQV..FALSE.) Then
          TCHECK=.TRUE.

            t1=0.0_wp
            t2=0.0_wp

            READ(5,*,ERR=997) t1, t2, nT

            If( (t1<0).OR.(t2<0)) Then
               Call WarningMessage(2,
     &                  'TINT: negative temperature requested! ')
               Call Quit_OnUserError()
            End If
            If( (t1-t2)>0.0_wp) Then
               Tmin=t2
               Tmax=t1
            Else If ( (t1-t2)<0.0_wp ) Then
               Tmin=t1
               Tmax=t2
            Else ! t1==t2
               Call WarningMessage(2,
     &                  'TINT: temperature interval == 0! ' )
               Call Quit_OnUserError()
            End If

          IF(DBG) Write(6,*) 'TINT: Tmin, Tmax, nT=',Tmin, Tmax, nT
        Else
          goto 590
        End If
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'XFIE') Then
        READ(5,*,ERR=997) Xfield
        IF(DBG) Write(6,*) 'XFIE: Xfield=',Xfield
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'HINT') Then
        If(HINPUT.EQV..FALSE.) Then
           HCHECK=.TRUE.
           compute_magnetization=.true.

            t1=0.0_wp
            t2=0.0_wp

            READ(5,*,ERR=997) t1, t2, nH

            If ( (t1<0).OR.(t2<0) ) Then
               Call WarningMessage(2,
     &                  'HINT: negative field requested! ')
               Call Quit_OnUserError()
            End If

            If ( (t1-t2)>0.0_wp ) Then
               Hmin=t2
               Hmax=t1
            Else If ( (t1-t2)<0.0_wp ) Then
               Hmin=t1
               Hmax=t2
            Else ! t1==t2
               Call WarningMessage(2,
     &                  'HINT: temperature interval == 0! ')
               Call Quit_OnUserError()
            End If

           IF(DBG) Write(6,*) 'HINT: Hmin, Hmax, nH=',Hmin, Hmax, nH
        Else
           Go To 591
        End If
         LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'NCUT') Then
        If(ENCUT_check) Then
           Go To 595
        Else
           ENCUT_check=.true.
           compute_magnetization=.true. !request for computation of M(H)
           encut_definition=1

           READ(5,*,ERR=997) NCUT  !E_cut=ESO(Ncut)

            If ( NCUT<0 ) Then
               Call WarningMessage(2,
     &                  'NCUT: negative NCUT requested! ')
               Call Quit_OnUserError()
            Else If ( NCUT==0 ) Then
               Call WarningMessage(2,
     &                  'NCUT: zero NCUT requested! ')
               Call Quit_OnUserError()
            End If

           IF(DBG) Write(6,*) 'NCUT: NCUT=',NCUT
           LINENR=LINENR+1
           Go To 100
        End If
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'ENCU') Then
        If(ENCUT_check) Then
           Go To 595
        Else
          ENCUT_check=.true.
          compute_magnetization=.true.
          encut_definition=2

          READ(5,*,ERR=997) NK, MG

          If ( (NK<=0).OR.(MG<=0) ) Then
             Call WarningMessage(2,
     &                'ENCU: zero or negative NK,MG requested! ')
             Call Quit_OnUserError()
          End If

          IF(DBG) Write(6,*) 'ENCU: NK, MG=',NK, MG
          LINENR=LINENR+1
          Go To 100
        End If
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'ERAT') Then
        If(ENCUT_check) Then
           Go To 595
        Else
          ENCUT_check=.true.
          compute_magnetization=.true.
          encut_definition=3  !Ncut = INT(nss*encut_rate); E_cut=E(Ncut)

          READ(5,*,ERR=997) encut_rate

          If ( encut_rate<=0.0_wp ) Then
             Call WarningMessage(2,
     &                'ERAT: zero or negative encut rate requested! ')
             Call Quit_OnUserError()
          End If

          IF(DBG) Write(6,*) 'ERAT: encut_rate=',encut_rate
          LINENR=LINENR+1
          Go To 100
        End If
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'MVEC') Then
        compute_magnetization=.true.   ! request for computation of M(H)
        compute_Mdir_vector=.true.
        READ(5,*,ERR=997) nDir
        IF(DBG) Write(6,*) 'MVEC: nDir=',nDir
        Do i=1,nDir
          READ(5,*,ERR=997) DirX(i), DirY(i), DirZ(i)
        IF(DBG) Write(6,*) 'MVEC: DirX,DirY,DirZ=',
     &                            DirX(i),DirY(i),DirZ(i)
        End Do
c  some processing:
        Do i=1,nDir
          sum=0.0_wp
          sum=DirX(i)*DirX(i)+DirY(i)*DirY(i)+DirZ(i)*DirZ(i)
          If ( sum .eq. 0.0_wp ) Then
             Write(err_msg,'(a,i3,a)') 'error: MVEC  vector ',i,
     &                          'has the modulus = 0.0_wp.'
             Call WarningMessage(2,err_msg)
             Call Quit_OnUserError()
          End If
          If ( sum .ne. 1.0_wp) Then
            Write(6,'(a,i3,a)') 'the vector',i,'was re-normalized.'
            tmp=dirX(i)/sqrt(sum)
            dirX(i)=tmp
            tmp=dirY(i)/sqrt(sum)
            dirY(i)=tmp
            tmp=dirZ(i)/sqrt(sum)
            dirZ(i)=tmp
          End If
        End Do
c
        LINENR=LINENR+NDIR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'MAVE') Then
        compute_magnetization=.true.

        READ(5,*,ERR=997) nsymm, ngrid

        IF(DBG) Write(6,*) 'MAVE: nsymm, ngrid=',nsymm, ngrid
        If((nsymm.lt.1).OR.(nsymm.gt.3)) Then
        Write(6,'(A)') '"nsymm" must take Integer values 1, 2 or 3.'
        Write(6,'(A,i5)') '"nsymm" = ',nsymm
        Call Quit_OnUserError()
        End If
        If((ngrid.lt.1).OR.(ngrid.gt.32)) Then
        Write(6,'(A)') '"ngrid" must take Integer values 1, 2, ... 32.'
        Write(6,'(A,i5)') '"ngrid" = ',ngrid
        Call Quit_OnUserError()
        End If
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
c      If (LINE(1:4).eq.'TLIN') Then
c        READ(5,*,ERR=997) T1, T2
c        LINENR=LINENR+1
c        Go To 100
c      End If
C-------------------------------------------
      If (LINE(1:4).eq.'SMAG') Then
        smagn=.true.
        IF(DBG) Write(6,*) 'SMAG: =',smagn
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'PLOT') Then
        doplot=.true.
        IF(DBG) Write(6,*) 'PLOT: =',doplot
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'TEXP') Then
        If(TCHECK.EQV..FALSE.) Then
          TINPUT=.TRUE.
          READ(5,*,ERR=997) NT
          IF(DBG) Write(6,*) 'TEXP: nT=',nT
          Do i=1,NT
            texp(i)=0.0_wp
            chit_exp(i)=0.0_wp
            READ(5,*,ERR=997) texp(i), chit_exp(i)
            IF(DBG) Write(6,*) 'TEXP: texp(i), chit_exp(i)=',
     &                                texp(i), chit_exp(i)
            ! check and clean negative values:
            if(    texp(i)<0.0_wp)     texp(i)=abs(    texp(i))
            if(chit_exp(i)<0.0_wp) chit_exp(i)=abs(chit_exp(i))
          End Do
          tmin=texp(1)
          tmax=texp(nT)
        Else
          Go To 590
        End If
        LINENR=LINENR+NT+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'HEXP') Then
        compute_magnetization=.true.
        If(checkTMAG) Then
          Write(6,'(A)') 'The data provided in TMAG will be ignored.'
        End If
        If(HCHECK.EQV..FALSE.) Then
          HINPUT=.TRUE.
          READ(5,*) nTempMagn, (TempMagn(i),i=1,nTempMagn)
          IF(DBG) Write(6,*) 'HEXP: nTempMagn =',nTempMagn
          IF(DBG) Write(6,*) 'HEXP: TempMagn()=',
     &                             (TempMagn(i),i=1,nTempMagn)
          READ(5,*) nH
          IF(DBG) Write(6,*) 'HEXP: nH =',nH
          if(nH<0) nH=abs(nH)
          if(nH==0) Call Quit_OnUserError()
          Do i=1,nH
            hexp(i)=0.0_wp
            Do j=1,nTempMagn
              magn_exp(i,j)=0.0_wp
            End Do
          End Do
          Do i=1,nH
            READ(5,*,ERR=997) Hexp(i), (magn_exp(i,j),j=1,nTempMagn)
            IF(DBG) Write(6,*) 'HEXP: Hexp(i),  magn_exp(i,j)=',
     &                           Hexp(i), (magn_exp(i,j),j=1,nTempMagn)
            ! check and clean negative values:
            If(hexp(i)<0.0_wp) hexp(i)=abs(hexp(i))
            Do j=1,nTempMagn
              If(magn_exp(i,j)<0.0_wp) magn_exp(i,j)=abs(magn_exp(i,j))
            End Do
          End Do
          hmin=hexp(1)
          hmax=hexp(nH)
        Else
          Go To 591
        End If
        LINENR=LINENR+NH+2
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'ZJPR') Then
        READ(5,*,ERR=997) ZJ
        IF(DBG) Write(6,*) 'ZJPR: zJ =',zJ
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'TORQ') Then
        compute_torque=.true.
        READ(5,*,ERR=997) AngPoints, H_torq, T_torq
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'TMAG') Then
         If(HINPUT.EQV..FALSE.) Then
            compute_magnetization=.true.
            checkTMAG=.true.

            READ(5,*,ERR=997) nTempMagn, (TempMagn(i),i=1,nTempMagn)

            Do i=1,nTempMagn
               If ( TempMagn(i)<=0.0_wp ) Then
                  Call WarningMessage(2,
     &                'TMAG: zero or negative temperature requested! ')
                  If(TempMagn(i) <0.0_wp) TempMagn(i)=abs(TempMagn(i))
                  If(TempMagn(i)==0.0_wp) TempMagn(i)=0.0001_wp
               End If
            End Do

            IF(DBG) Write(6,*) 'TMAG: nTempMagn =',nTempMagn
            IF(DBG) Write(6,*) 'TMAG: TempMagn()=',
     &                             (TempMagn(i),i=1,nTempMagn)
          ! check and clean negative values:
         Else
            Write(6,'(A)') 'TMAG data is taken from HEXP.'
         End If
         LINENR=LINENR+1
         Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'PRLV') Then
        READ(5,*,ERR=997) IPRINT
        IF(DBG) Write(6,*) 'PRLV: IPRINT =',iPrint
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'POLY') Then
        IF(DBG) Write(6,*) 'POLY:'
        POLY_FILE = .TRUE.
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'CRYS') Then
        compute_CF = .TRUE.
        Read(5,*,ERR=997) cME
        IF(DBG) Write(6,*) 'CRYS: cME =',cME

      If( (cME.eq.'ce') .OR. (cME.eq.'Ce') .OR.
     &    (cME.eq.'cE') .OR. (cME.eq.'CE') ) Then
      nlanth=1
      nDIMcf=6  ! f1; multiplet J=L-S=3-1/2=5/2  =>  J = 2F_5/2
      lDIMCF=7 ! (L=3)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'pr') .OR. (cME.eq.'Pr') .OR.
     &         (cME.eq.'pR') .OR. (cME.eq.'PR') ) Then
      nlanth=2
      nDIMcf=9  ! f2; multiplet J=L-S=5-1=4  => J = 3H_4
      lDIMCF=11 ! (L=5)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'nd') .OR. (cME.eq.'Nd') .OR.
     &         (cME.eq.'nD') .OR. (cME.eq.'ND') ) Then
      nlanth=3
      nDIMcf=10  ! f3; multiplet J=L-S=6-3/2=9/2  => J = 4I_9/2
      lDIMCF=13 ! (L=6)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'pm') .OR. (cME.eq.'Pm') .OR.
     &         (cME.eq.'pM') .OR. (cME.eq.'PM') ) Then
      nlanth=4
      nDIMcf=9  ! f4; multiplet J=L-S=6-2=4  => J = 5I_4
      lDIMCF=13 ! (L=6)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'sm') .OR. (cME.eq.'Sm') .OR.
     &         (cME.eq.'sM') .OR. (cME.eq.'SM') ) Then
      nlanth=5
      nDIMcf=6  ! f5; multiplet J=L-S=5-5/2=5/2  => J = 6H_5/2
      lDIMCF=11 ! (L=5)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'eu') .OR. (cME.eq.'Eu') .OR.
     &         (cME.eq.'eU') .OR. (cME.eq.'EU') ) Then
      nlanth=6
      nDIMcf=1  ! f6; multiplet J=L-S=3-3=0  => J = 3F_0
      lDIMCF=7 ! (L=3)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'gd') .OR. (cME.eq.'Gd') .OR.
     &         (cME.eq.'gD') .OR. (cME.eq.'GD') ) Then
      nlanth=7
      nDIMcf=8  ! f7; multiplet J=L+S=0+7/2=0  => J = 8S_7/2
      lDIMCF=1 ! (L=0)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'tb') .OR. (cME.eq.'Tb') .OR.
     &         (cME.eq.'tB') .OR. (cME.eq.'TB') ) Then
      nlanth=8
      nDIMcf=13  ! f8; multiplet J=L+S=3+3=0  => J = 7F_6
      lDIMCF=7 ! (L=3)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'dy') .OR. (cME.eq.'Dy') .OR.
     &         (cME.eq.'dY') .OR. (cME.eq.'DY') ) Then
      nlanth=9
      nDIMcf=16  ! f9; multiplet J=L+S=5+5/2=15/2  => J = 6H_15/2
      lDIMCF=11 ! (L=5)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'ho') .OR. (cME.eq.'Ho') .OR.
     &         (cME.eq.'hO') .OR. (cME.eq.'HO') ) Then
      nlanth=10
      nDIMcf=17  ! f10; multiplet J=L+S=6+2=8  => J = 5I_8
      lDIMCF=13 ! (L=6)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'er') .OR. (cME.eq.'Er') .OR.
     &         (cME.eq.'eR') .OR. (cME.eq.'ER') ) Then
      nlanth=11
      nDIMcf=16  ! f11; multiplet J=L+S=6+3/2=15/2  => J = 4I_15/2
      lDIMCF=13 ! (L=6)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'tm') .OR. (cME.eq.'Tm') .OR.
     &         (cME.eq.'tM') .OR. (cME.eq.'TM') ) Then
      nlanth=12
      nDIMcf=13  ! f12; multiplet J=L+S=5+1=6  => J = 3H_6
      lDIMCF=11 ! (L=5)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'yb') .OR. (cME.eq.'Yb') .OR.
     &         (cME.eq.'yB') .OR. (cME.eq.'YB') ) Then
      nlanth=13
      nDIMcf=8  ! f13; multiplet J=L+S=3+1/2=7/2  => J = 2F_7/2
      lDIMCF=7 ! (L=3)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'lu') .OR. (cME.eq.'Lu') .OR.
     &         (cME.eq.'lU') .OR. (cME.eq.'LU') ) Then
      nlanth=14
      nDIMcf=1  ! f14; multiplet J=L+S=0+0=0  => J = 1S_0
      lDIMCF=1 ! (L=0)


      !- - - - - - - - - - - - - - - - - - - -
      ! ACTINIDES
      Else If( (cME.eq.'th') .OR. (cME.eq.'Th') .OR.
     &         (cME.eq.'tH') .OR. (cME.eq.'TH') ) Then
      nlanth=15
      nDIMcf=6  ! f1; multiplet J=L-S=3-1/2=5/2  =>  J = 2F_5/2
      lDIMCF=7 ! (L=3)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'pa') .OR. (cME.eq.'Pa') .OR.
     &         (cME.eq.'pA') .OR. (cME.eq.'PA') ) Then
      nlanth=16
      nDIMcf=9  ! f2; multiplet J=L-S=5-1=4  => J = 3H_4
      lDIMCF=11 ! (L=5)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'U' ) .OR. (cME.eq.'u' ) .OR.
     &         (cME.eq.'u ') .OR. (cME.eq.'U ') ) Then
      nlanth=17
      nDIMcf=10  ! f3; multiplet J=L-S=6-3/2=9/2  => J = 4I_9/2
      lDIMCF=13 ! (L=6)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'np') .OR. (cME.eq.'Np') .OR.
     &         (cME.eq.'nP') .OR. (cME.eq.'NP') ) Then
      nlanth=18
      nDIMcf=9  ! f4; multiplet J=L-S=6-2=4  => J = 5I_4
      lDIMCF=13 ! (L=6)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'pu') .OR. (cME.eq.'Pu') .OR.
     &         (cME.eq.'pU') .OR. (cME.eq.'PU') ) Then
      nlanth=19
      nDIMcf=6  ! f5; multiplet J=L-S=5-5/2=5/2  => J = 6H_5/2
      lDIMCF=11 ! (L=5)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'am') .OR. (cME.eq.'Am') .OR.
     &         (cME.eq.'aM') .OR. (cME.eq.'AM') ) Then
      nlanth=20
      nDIMcf=1  ! f6; multiplet J=L-S=3-3=0  => J = 3F_0
      lDIMCF=7 ! (L=3)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'cm') .OR. (cME.eq.'Cm') .OR.
     &         (cME.eq.'cM') .OR. (cME.eq.'CM') ) Then
      nlanth=21
      nDIMcf=8  ! f7; multiplet J=L+S=0+7/2=0  => J = 8S_7/2
      lDIMCF=1 ! (L=0)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'bk') .OR. (cME.eq.'Bk') .OR.
     &         (cME.eq.'bK') .OR. (cME.eq.'BK') ) Then
      nlanth=22
      nDIMcf=13  ! f8; multiplet J=L+S=3+3=0  => J = 7F_6
      lDIMCF=7 ! (L=3)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'cf') .OR. (cME.eq.'Cf') .OR.
     &         (cME.eq.'cF') .OR. (cME.eq.'CF') ) Then
      nlanth=23
      nDIMcf=16  ! f9; multiplet J=L+S=5+5/2=15/2  => J = 6H_15/2
      lDIMCF=11 ! (L=5)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'es') .OR. (cME.eq.'Es') .OR.
     &         (cME.eq.'eS') .OR. (cME.eq.'ES') ) Then
      nlanth=24
      nDIMcf=17  ! f10; multiplet J=L+S=6+2=8  => J = 5I_8
      lDIMCF=13 ! (L=6)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'fm') .OR. (cME.eq.'Fm') .OR.
     &         (cME.eq.'fM') .OR. (cME.eq.'FM') ) Then
      nlanth=25
      nDIMcf=16  ! f11; multiplet J=L+S=6+3/2=15/2  => J = 4I_15/2
      lDIMCF=13 ! (L=6)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'md') .OR. (cME.eq.'Md') .OR.
     &         (cME.eq.'mD') .OR. (cME.eq.'MD') ) Then
      nlanth=26
      nDIMcf=13  ! f12; multiplet J=L+S=5+1=6  => J = 3H_6
      lDIMCF=11 ! (L=5)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'no') .OR. (cME.eq.'No') .OR.
     &         (cME.eq.'nO') .OR. (cME.eq.'NO') ) Then
      nlanth=27
      nDIMcf=8  ! f13; multiplet J=L+S=3+1/2=7/2  => J = 2F_7/2
      lDIMCF=7 ! (L=3)
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'lr') .OR. (cME.eq.'Lr') .OR.
     &         (cME.eq.'lR') .OR. (cME.eq.'LR') ) Then
      nlanth=28
      nDIMcf=1  ! f14; multiplet J=L+S=0+0=0  => J = 1S_0
      lDIMCF=1 ! (L=0)





!------------------------ transition metals --------------------------!

      Else If( (cME.eq.'Sc') .OR. (cME.eq.'Sc') .OR.
     &         (cME.eq.'sC') .OR. (cME.eq.'SC') ) Then

         nlanth=29
         ! Sc2+ -- d^1
         READ(5,*,ERR=997) i_OxStat
         IF(DBG) Write(6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth

           If(i_OxStat<0) Then
             Write(6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',
     &                           i_OxStat
             Write(6,'(A)')  'It was re-set to positive.'
             i_OxStat=abs(i_OxStat)
           End If
           If (i_OxStat<2) Then
             lDIMCF=1 ! (L=0)
             Write(6,'(A)') 'Oxidation state of ', cME,' is:', i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           Else If (i_OxStat == 2) Then
             lDIMCF=5 ! (L=2) d^1
           Else
             lDIMCF=1 ! (L=0)
             Write(6,'(A)') 'Oxidation state of ', cME,' is:', i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           End If

      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'Ti') .OR. (cME.eq.'Ti') .OR.
     &         (cME.eq.'tI') .OR. (cME.eq.'TI') ) Then

         nlanth=30
         ! Ti2+ -- d^2
         ! Ti3+ -- d^1
         ! Ti4+ -- d^0
         READ(5,*,ERR=997) i_OxStat
         IF(DBG) Write(6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth

           If(i_OxStat<0) then
             Write(6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',
     &                           i_OxStat
             Write(6,'(A)')  'It was re-set to positive.'
             i_OxStat=abs(i_OxStat)
           End If
           If (i_OxStat<2) then
             lDIMCF=1 ! (L=0)
             Write(6,'(3A,i5)') 'Oxidation state of ', cME,' is:',
     &                           i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           Else If (i_OxStat == 2) Then
             lDIMCF=7 ! (L=3) d^2  3F
           Else If (i_OxStat == 3) Then
             lDIMCF=5 ! (L=2) d^1  2D
           Else
             lDIMCF=1 ! (L=0) d^4
             Write(6,'(A)') 'Oxidation state of ', cME,' is:', i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           End If


      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'v' ) .OR. (cME.eq.'V' ) .OR.
     &         (cME.eq.'V ') .OR. (cME.eq.'v ') ) Then

         nlanth=31
         ! V2+ -- d^3
         ! V3+ -- d^2
         ! V4+ -- d^1
         READ(5,*,ERR=997) i_OxStat
         IF(DBG) Write(6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth

           If(i_OxStat<0) then
             Write(6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',
     &                           i_OxStat
             Write(6,'(A)')  'It was re-set to positive.'
             i_OxStat=abs(i_OxStat)
           End If
           If (i_OxStat<2) then
             lDIMCF=1 ! (L=0)
             Write(6,'(3A,i5)') 'Oxidation state of ', cME,' is:',
     &                           i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           Else If (i_OxStat == 2) Then
             lDIMCF=7 ! (L=3) d^3
           Else If (i_OxStat == 3) Then
             lDIMCF=7 ! (L=3) d^2
           Else If (i_OxStat == 4) Then
             lDIMCF=5 ! (L=2) d^1
           Else
             lDIMCF=1 ! (L=0) d^4
             Write(6,'(A)') 'Oxidation state of ', cME,' is:', i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           End If


      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'cr') .OR. (cME.eq.'cR') .OR.
     &         (cME.eq.'Cr') .OR. (cME.eq.'CR') ) Then

         nlanth=32
         Write(6,'(A)') 'Crystal field will not be computed'
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'mn') .OR. (cME.eq.'mN') .OR.
     &         (cME.eq.'Mn') .OR. (cME.eq.'MN') ) Then

         nlanth=33
         ! Mn3+ -- d^4
         READ(5,*,ERR=997) i_OxStat
         IF(DBG) Write(6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth

           If(i_OxStat<0) then
             Write(6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',
     &                           i_OxStat
             Write(6,'(A)')  'It was re-set to positive.'
             i_OxStat=abs(i_OxStat)
           End If
           If (i_OxStat<3) then
             lDIMCF=1 ! (L=0)
             Write(6,'(3A,i5)') 'Oxidation state of ', cME,' is:',
     &                           i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           Else If (i_OxStat == 3) Then
             lDIMCF=5 ! (L=2) d^4
           Else
             lDIMCF=1 ! (L=0)
             Write(6,'(A)') 'Oxidation state of ', cME,' is:', i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           End If
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'fe') .OR. (cME.eq.'fE') .OR.
     &         (cME.eq.'Fe') .OR. (cME.eq.'FE') ) Then

         nlanth=34
         ! Co2+ -- d^6 or d^4
         READ(5,*,ERR=997) i_OxStat
         IF(DBG) Write(6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth

           If(i_OxStat<0) then
             Write(6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',
     &                           i_OxStat
             Write(6,'(A)')  'It was re-set to positive.'
             i_OxStat=abs(i_OxStat)
           End If
           If (i_OxStat<2) then
             lDIMCF=1 ! (L=0)
             Write(6,'(3A,i5)') 'Oxidation state of ', cME,' is:',
     &                           i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           Else If (i_OxStat == 2) Then
             lDIMCF=5 ! (L=2)  d^6  or  d^4
           Else
             lDIMCF=1 ! (L=0)
             Write(6,'(A)') 'Oxidation state of ', cME,' is:', i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           End If
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'co') .OR. (cME.eq.'cO') .OR.
     &         (cME.eq.'Co') .OR. (cME.eq.'CO') ) Then

         nlanth=35
         ! Co2+ -- d^7
         READ(5,*,ERR=997) i_OxStat
         IF(DBG) Write(6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth

           If(i_OxStat<0) then
             Write(6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',
     &                           i_OxStat
             Write(6,'(A)')  'It was re-set to positive.'
             i_OxStat=abs(i_OxStat)
           End If
           If (i_OxStat<2) then
             lDIMCF=1 ! (L=0)
             Write(6,'(3A,i5)') 'Oxidation state of ', cME,' is:',
     &                           i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           Else If (i_OxStat == 2) Then
             lDIMCF=7 ! (L=3) d^7
           Else
             lDIMCF=1 ! (L=0)
             Write(6,'(A)') 'Oxidation state of ', cME,' is:', i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           End If
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'ni') .OR. (cME.eq.'nI') .OR.
     &         (cME.eq.'Ni') .OR. (cME.eq.'NI') ) Then

         nlanth=36
         ! Ni2+ -- d^8
         READ(5,*,ERR=997) i_OxStat
         IF(DBG) Write(6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth

           If(i_OxStat<0) then
             Write(6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',
     &                           i_OxStat
             Write(6,'(A)')  'It was re-set to positive.'
             i_OxStat=abs(i_OxStat)
           End If
           If (i_OxStat<2) then
             lDIMCF=1 ! (L=0)
             Write(6,'(3A,i5)') 'Oxidation state of ', cME,' is:',
     &                           i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           Else If (i_OxStat == 2) Then
             lDIMCF=7 ! (L=2) d^8
           Else
             lDIMCF=1 ! (L=0)
             Write(6,'(A)') 'Oxidation state of ', cME,' is:', i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           End If
      !- - - - - - - - - - - - - - - - - - - -
      Else If( (cME.eq.'cu') .OR. (cME.eq.'cU') .OR.
     &         (cME.eq.'Cu') .OR. (cME.eq.'CU') ) Then

         nlanth=37
         ! Cu2+ -- d^9
         READ(5,*,ERR=997) i_OxStat
         IF(DBG) Write(6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth

           If(i_OxStat<0) then
             Write(6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',
     &                           i_OxStat
             Write(6,'(A)')  'It was re-set to positive.'
             i_OxStat=abs(i_OxStat)
           End If
           If (i_OxStat<2) then
             lDIMCF=1 ! (L=0)
             Write(6,'(3A,i5)') 'Oxidation state of ', cME,' is:',
     &                           i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           Else If (i_OxStat == 2) Then
             lDIMCF=5 ! (L=2) d^9
           Else
             lDIMCF=1 ! (L=0) d^4
             Write(6,'(A)') 'Oxidation state of ', cME,' is:', i_OxStat
             Write(6,'(A)') 'Crystal field will not be computed'
           End If
      !- - - - - - - - - - - - - - - - - - - -
      Else
         Write(6,'(A)') 'Label of the metal is not understood.'
         Write(6,'(A)') 'Crystal field will not be computed'
      End If



      If (IPRINT > 2) Then
      Write(6,'(5x,3A)') 'SINGLE_ANISO will calculate the parameters'//
     & ' of the crystal field for Ln = ',clanth(nlanth),','
      Write(6,'(5x,A,I2,a)') 'for the ground multiplet J.'//
     & ' Multiplicity of J = ', nDIMcf, ' and'
      Write(6,'(5x,A,I2)') 'for the ground LS term.'//
     & ' Multiplicity of L = ', lDIMcf
      End If
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'QUAX') Then
c        If ( check_CRYS ) Then
        READ(5,*,ERR=997) axisoption
        IF(DBG) Write(6,*) 'QUAX: axisoption =',axisoption
        LINENR=LINENR+1

        If( (axisoption.lt.1) .OR. (axisoption.gt.3) ) Then
           Call WarningMessage(2,'QUAX: axisoption out of range!'//
     &          ' Calculation will continue by employing the default'//
     &          ' option.')
        End If
        If( axisoption == 3 ) Then
          Do j=1,3
            READ(5,*,ERR=997) (zmagn(i,j),i=1,3)
            IF(DBG) Write(6,*) 'QUAX: zmagn(i,j) =',(zmagn(i,j),i=1,3)
          End Do
          LINENR=LINENR+3
        End If
c        Else
c        Write(6,'(A)') 'The CRYS keyword must be declared '//
c     &                 'above QUAX in the input!'
c        End If
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'PREX') Then
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'UBAR') Then
        compute_barrier=.TRUE.
        IF(DBG) Write(6,*) 'UBAR:'
        LINENR=LINENR+1
        Go To 100
      End If
C-------------------------------------------
      If (LINE(1:4).eq.'ABCC') Then
      Do_structure_abc = .TRUE.
      Read(5,*,ERR=997) (cryst(i),i=1,6)

      Do i=1,6
         If ( cryst(i)<=0 ) Then
            Call WarningMessage(2,
     &               'ABCC: zero or negative crystallographic '//
     &               'parameters requested! ')
            Call Quit_OnUserError()
         End If
      End Do

      IF(DBG) Write(6,*) 'ABCC: (cryst(i),i=1,6)=',(cryst(i),i=1,6)
      Read(5,*,ERR=997) (coord(i),i=1,3)
      IF(DBG) Write(6,*) 'ABCC: (coord(i),i=1,3)=',(coord(i),i=1,3)
        LINENR=LINENR+2
        Go To 100
      End If
c array "cryst" collects the crystallographic data:
c  cryst(1)= a
c  cryst(2)= b
c  cryst(3)= c
c  cryst(4)= alpha
c  cryst(5)= beta
c  cryst(6)= gamma
c  coord(i) =the coordinates of the magnetic center in "abc" axes
c  logical variable 'Do_structure_abc' will make the program compute
c  the magnetic and anisotropy axes in the "abc" coordinate system
C-------------------------------------------
      If (LINE(1:4).eq.'ZEEM') Then
        zeeman_energy=.true.
        compute_magnetization=.true.

        READ(5,*,ERR=997) nDirZee
        IF(DBG) Write(6,*) 'ZEEM: nDirZee=',nDirZee

        Do i=1,nDirZee
!         open the zeeman_energy_xxx.txt file where Zeeman eigenstates will
!         be further written in mangetization() subroutine
          Write(namefile_energy,'(5A)') 'zeeman_energy_',
     &                     CHAR(48+mod( int((i)/100),10)),
     &                     CHAR(48+mod( int((i)/10 ),10)),
     &                     CHAR(48+mod( int( i     ),10)),'.txt'
          !print *, 'namefile_energy: ', namefile_energy
          LUZee(i)=IsFreeUnit(30+i)
          Call molcas_open(LUZee(i),namefile_energy)
c          OPEN(30+i, FILE=namefile_energy)

          READ(5,*,ERR=997) (dir_weight(i,l),l=1,3)
          IF(DBG) Write(6,*) 'ZEEM: (dir_weight(i,l),l=1,3)=',
     &                              (dir_weight(i,l),l=1,3)

          check_dir_weight(i)=0.0_wp
          check_dir_weight(i)=sqrt( dir_weight(i,1)**2 +
     &                              dir_weight(i,2)**2 +
     &                              dir_weight(i,3)**2 )

          If( (check_dir_weight(i).lt.0.995_wp).OR.
     &        (check_dir_weight(i).gt.1.005_wp) ) Then
            Write(6,'(A)') 'The directions for the magnetic field '//
     &                     'for the computation of the Zeeman '//
     &                     'splitting are wrong.'
            Write(6,'(A)') '( px^2 + py^2 + pz^2 ) must give 1.!'
            Write(6,'(A,I3,2x,A,F9.5)') 'In the present case for '//
     &                                  'direction Nr.', i,
     &                                  ' the dir_weight = px^2 + '//
     &                                  'py^2 + pz^2 = ',
     &                                   check_dir_weight(i)**2
            LINENR=LINENR+2+i
            Go To 997
          End If

        End Do
        LINENR=LINENR+nDirZee+1
        Go To 100
      End If
C-------------------------------------------

200   continue
      If(IPRINT.gt.2) Then
      Write(6,'(5X,A)') 'NO ERROR WAS LOCATED WHILE READING INPUT'
      End If



      If(compute_CF) Then
        If(axisoption.eq.3) Then
c check the determinant of the ZMAGN
        Det_zmagn=0.0_wp
        Do I=1,3
          Do J=1,3
          ZR(I,J)=0.0_wp
          ZR(I,J)=zmagn(I,J)
          End Do
        End Do
        Det_zmagn = FindDetR(ZR,3)
          If( Det_zmagn .lt. 0.0_wp ) Then
        Write(6,'(A)') 'QUAX: The determinant of the rotation matrix '//
     &                 'provided in the input is NEGATIVE.'
        Write(6,'(A,F22.14)') 'Determinant = ', Det_zmagn
        Write(6,'(A)') 'This means that the matrix you have provided '//
     &                 'can be decomposed in a product of two '
        Write(6,'(A)') 'matrices: Rotation*Inversion'
        Write(6,'(A)') 'The determinant of the Rotation matrix must '//
     &                 'be POSITIVE.'
        Write(6,'(A)') 'The program will stop.'
        Return
          End If

c check the orthogonality of the ZMAGN:
       Do i=1,3
         Do j=1,3
        column_check(i,j)=0.0_wp
        row_check(i,j)   =0.0_wp
           Do L=1,3
        column_check(i,j) = column_check(i,j) + zmagn(i,L) * zmagn(j,L)
           row_check(i,j) =    row_check(i,j) + zmagn(L,i) * zmagn(L,j)
           End Do
         End Do
       End Do

       Do i=1,3
         Do j=i+1,3
         If (i.eq.j) Go To 112
           If ( (ABS(column_check(1,2)).gt.0.0001_wp).OR.
     &          (ABS(column_check(1,3)).gt.0.0001_wp).OR.
     &          (ABS(column_check(2,3)).gt.0.0001_wp).OR.
     &          (ABS(   row_check(1,2)).gt.0.0001_wp).OR.
     &          (ABS(   row_check(1,3)).gt.0.0001_wp).OR.
     &          (ABS(   row_check(2,3)).gt.0.0001_wp) ) Then
          Write(6,'(A)') 'QUAX: The rotation matrix is not UNITARY.'
          Write(6,'(A,F19.14)') 'column_check(1,2) = ',column_check(1,2)
          Write(6,'(A,F19.14)') 'column_check(1,3) = ',column_check(1,3)
          Write(6,'(A,F19.14)') 'column_check(2,3) = ',column_check(2,3)
          Write(6,'(A,F19.14)') '   row_check(1,2) = ',   row_check(1,2)
          Write(6,'(A,F19.14)') '   row_check(1,3) = ',   row_check(1,3)
          Write(6,'(A,F19.14)') '   row_check(2,3) = ',   row_check(2,3)
          Write(6,'(A)') 'All above values must be exact 0.0.'
          Write(6,'(A)') 'Or at least less than than 0.0001.'
          Write(6,'(A)') 'Did you employ enough digits for '//
     &                   'the rotation matrix?'
          Write(6,'(A)') 'The program will stop.'
          Return
           End If
 112     continue
         End Do
       End Do
        End If ! axisoption
      End If ! compute_CF

c  preparing the info for computation of molar magnetization
      If(compute_magnetization) Then
c calculate the total number of directions for the average procedure
        nDirTot=0
        If(zeeman_energy) Then
        nDirTot=nDirZee
        End If
        If(compute_Mdir_vector) Then
        nDirTot=nDirTot+nDir
        End If
        nDirTot=nDirTot+get_nP(nsymm,ngrid)
      End If

C------ CHECK the data from INPUT ------------------------------
c      If(iprint.gt.10) Then

       If(dbg) Write(6,'(A,  F9.5)') 'ZJPR :         = ', zJ
       If(dbg) Write(6,'(A,  I3  )') 'PRLV :         = ',iprint

c      If (.not. compute_g_tensors) then
c         !generate an array of 10 low-lying groups of states
c         !
c         ndim(:)=0
c         nmult_try=10
c         j=0
c         ndim(i)=1
c         Do i=1, nss
c           etmp=eso(i)
c           do k=i+1,nss
c             if (abs(eso(k)-etmp) < 0.01_wp) ndim(i)=ndim(i)+1
c           enddo
c         End Do
c      End If

      If(compute_g_tensors) Then
        If(NMULT.gt.0) Then
        Write(6,'(A,I3)')   'MLTP :         = ', NMULT
           If(NMULT.le.20) Then
             Write(6,'(A,20I3)') '               = ',(NDIM(i),i=1,NMULT)
           Else
             Write(6,'(A,20I3)') '               = ',(NDIM(i),i=1,20)
             Do j=21,NMULT,20
             jEnd=MIN(NMULT,J+19)
             Write(6,'(A,20I3)') '                 ',(NDIM(i),i=j,jEnd)
             End Do
           End If
        Else
        Write(6,'(A)') 'MLTP :         =  No pseudospin Hamiltonians'//
     &     ' will be computed. Is MLTP defined?'
        End If
      End If



      If((compute_CF).AND.(nDIMcf<=nss).AND.(lDIMcf<=nstate)) Then
        If (nlanth<15) Then
           Write(6,'(3A)') 'The Crystal-Field acting on the '//
     &                     'ground atomic multiplet of Ln = ',
     &                      clanth(nlanth),' is computed.'
        Else If (nlanth>=15 .and. nlanth<29) Then
           Write(6,'(3A)') 'The Crystal-Field acting on the '//
     &                     'ground atomic multiplet of Ac = ',
     &                      clanth(nlanth) ,' is computed.'
        Else If (nlanth>=29) Then
           Write(6,'(3A)') 'The Crystal-Field acting on the '//
     &                     'ground atomic |L,ML> multiplet of TM = ',
     &                      clanth(nlanth) ,' is computed.'
      End If


      Write(6,'(A,A )') 'CHIT :         = ',' molar magnetic '//
     & 'susceptibility is computed'
      If(TINPUT) Write(6,'(A)') 'TEXP :         = the experimental'//
     & ' temperature interval is read from the file "chitexp.input"'
      Write(6,'(A, I3)')  'TINT :      nT = ', nT
      Write(6,'(A,F7.3)') '          Tmin = ', Tmin
      Write(6,'(A,F7.3)') '          Tmax = ', Tmax


      End If
!--------------------------------------------------------------------
      If(compute_magnetization) Then

        Write(6,'(A,A )') 'MAGN :         = ',' molar magnetization'//
     &                    ' is computed'
        Write(6,'(A, I3)') 'NDIRTOT        = ', nDirTot
        Write(6,'(A, I3)') 'TMAG :         = ',nTempMagn
        Write(6,'(6x,A,20F7.3)') 'TempMagn = ',
     &                                 (TempMagn(i),i=1,nTempMagn)
        Write(6,'(A, I3)')  'HINT :      nH = ', nH
        Write(6,'(A,F7.3)') '          Hmin = ', Hmin
        Write(6,'(A,F7.3)') '          Hmax = ', Hmax
        Write(6,'(A, I3)') 'MAVE :   nDir = ', get_nP(nsymm,ngrid)

        If(HINPUT) Write(6,'(A)') 'HEXP :         = the experimental '//
     &                            'field interval is read from the '//
     &                            'file "mexp.input"'
        If(encut_definition.eq.1) Then
          Write(6,'(A, I3)')  'NCUT :         = ', ncut
        Else If(encut_definition.eq.2) Then
          Write(6,'(A,I4,a,i4)')  'ECUT :         = ', nk,', ',mg
        Else If(encut_definition.eq.3) Then
          Write(6,'(A,F7.3)') 'ERAT :         = ', encut_rate
        End If


        If(compute_Mdir_vector) Then
          Write(6,'(A,20I3)') 'MVEC :         = ', nDir
          If(nDir.gt.0) Then
            Do i=1,nDir
              Write(6,'(A,I2,A,3F11.6)') '   Dir :',i,' : ',
     &          dirX(i), dirY(i), dirZ(i)
            End Do
          End If
        End If
        If(zeeman_energy) Then
          If (nDirZee == 1) Then
             Write(6,'(2A,I2,1x,A)')
     &            'ZEEM :         = ',' Zeeman splitting '//
     &            'for the following direction of the '
             Write(6,'(18x,A)')
     &            'applied magnetic field is given in the'//
     &            ' "zeeman_energy_xxx.txt" file in $WorkDir/'
          Else If (nDirZee > 1) Then
             Write(6,'(2A,I2,1x,A)')
     &            'ZEEM :         = ',' Zeeman splitting '//
     &            'for the following',nDirZee,' directions of the '
             Write(6,'(18x,A)')
     &            'applied magnetic field are given in the'//
     &            ' "zeeman_energy_xxx.txt" files in $WorkDir/.'
          Else
             Write(6,'(A)') 'Error in input processing. nDirZee<0!'
             Call Quit_OnUserError()
          End If
          Do i=1, nDirZee
            Write(6,'(17x,3F11.6)')  (dir_weight(i,l),l=1,3)
          End Do
        End If
      End If !magnetization
!--------------------------------------------------------------------

      If(compute_torque) Then
        Write(6,'(A,A )') 'TORQ :         = ',' torque magnetization '//
     &                    'is computed'
      End If !torque

      If(doplot) Then
        Write(6,'(A,A )') 'PLOT :         = ',' GNUPLOT scripts and '//
     &                    'corresponding XT, M and UBAR plots will'//
     &                    'be generated'
      End If !




      If(Do_structure_abc) Then
        Write(6,'(2A)') 'ABCC :         = ','the main magnetic axes '//
     &                  'for the computed pseudospins are written '//
     &                  'also in the '
        Write(6,'( A)') 'crystallographic "abc" axes'
        Write(6,'(10x,A,F9.4)') 'a       = ', cryst(1)
        Write(6,'(10x,A,F9.4)') 'b       = ', cryst(2)
        Write(6,'(10x,A,F9.4)') 'c       = ', cryst(3)
        Write(6,'(10x,A,F9.4)') 'alpha   = ', cryst(4)
        Write(6,'(10x,A,F9.4)') 'beta    = ', cryst(5)
        Write(6,'(10x,A,F9.4)') 'gamma   = ', cryst(6)
        Write(6,'(10x,a,3F9.4)') 'coords: = ',(coord(i),i=1,3)
      End If

      If(compute_g_tensors) Then
        If(compute_barrier) Then
          Nblock=0
          Do i=1,nmult
            Nblock=Nblock+ndim(i)
          End Do
          Write(6,'(A,i4)') 'nBlock = ', nBlock
        End If
      End If




      Go To 190
C------ errors ------------------------------
      Write(6,*)' The following input line was not understood:'
      Write(6,'(A)') LINE
      Go To 999

997   continue
      Write(6,*)' READIN: Error reading standard input.'
      Write(6,*)' SINGLE_ANISO input near line nr.',LINENR+1
      Go To 999

998   continue
      Write(6,*)' READIN: Unexpected End of input file.'

999   continue
      Call XFLUSH(6)
      Call ABEnd()

590   continue
      Write(6,*) 'READIN: the TINT command is incompatible with TEXP'
      Call ABEnd()

591   continue
      Write(6,*) 'READIN: the HINT command is incompatible with HEXP'
      Call ABEnd()

595   continue
      Write(6,*) 'READIN: NCUT, ERAT and ENCU are mutually exclusive.'
      Call ABEnd()


 190  continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!***********************************************************************

subroutine ContEI(I,mDeg,ESIT,ix,iy,iz,temp)

use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mDeg, I(0:mDeg,0:mDeg,0:mDeg,0:mDeg,0:mDeg,0:mDeg), ix, iy, iz
real(kind=wp), intent(inout) :: ESIT(nTri_Elem1(mDeg))
real(kind=wp), intent(in) :: Temp
integer(kind=iwp) :: a, b, c, ip, n

! Purpose: Express the interaction tensor, defined by the
! quantities T(a,b,c) as functions of the vector R=(x,y,z),
! where a,b, and c are nonnegative integers and
! T(a,b,c)=((d/dx)**a)((d/dy)**b)((d/dz)**c) 1/R, in terms
! of a polynomial:
! T(a,b,c)=
!  (sum over p,q,r of I(a,b,c,p,q,r) x**p y**q z**r)/(R**(2*n+1)),
! where n=a+b+c.
! The polynomial coefficients are integers, and are 0 unless
! p+q+r=n.

! write out only elements with a>=b>=c. The others are obtained
! by index permutation.
! This restriction has been removed! (Roland Lindh)
!n = mDeg
!do a=n,0,-1
!  do b=n-a,0,-1
!    c = n-a-b
!    write(6,'(5x,''T('',i1,'','',i1,'','',i1,'')='',i5)')a,b,c,Ind(n,a,c)
!    do p=n,0,-1
!      do q=n-p,0,-1
!        r = n-p-q
!        coef = I(a,b,c,p,q,r)
!        if (coef /= 0) write(6,'(10x,i8,''*x**'',i1,'' *y**'',i1,'' *z**'',i1,i5)') coef,p,q,r,Ind(n,p,r)
!      end do
!    end do
!  end do
!end do

!write(u6,*) ' Temp,ix,iy,iz=',temp,ix,iy,iz
n = mDeg
ip = 0
do a=n,0,-1
  do b=n-a,0,-1
    c = n-a-b
    ip = ip+1
    !write(u6,*) ip, I(a,b,c,ix,iy,iz)
    if (I(a,b,c,ix,iy,iz) /= 0) ESIT(ip) = ESIT(ip)+real(I(a,b,c,ix,iy,iz),kind=wp)*temp
  end do
end do

return

end subroutine ContEI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine add44 (a,b,r,dimp,dimqr,dimq,fact)

c     this routine do:
c     B(p,qr) <-- fact * A(p,q) for given r
c
#include "ccsd1.fh"
       integer dimp,dimqr,dimq,r
       real*8 fact
       real*8 b(1:dimp,1:dimqr)
       real*8 a(1:dimp,1:dimq)
c
c     help variable
c
       integer p,qr,rq,q
c
       if (r.eq.1) goto 101
c
       rq=nshf(r)
       do 100 q=1,r-1
       rq=rq+1
c
       do 50 p=1,dimp
       b(p,rq)=b(p,rq)-fact*a(p,q)
 50     continue
c
 100    continue
c
 101    if (r.eq.dimq) then
       return
       end if
c
c
       do 200 q=r+1,dimq
       qr=nshf(q)+r
       do 150 p=1,dimp
       b(p,qr)=b(p,qr)+fact*a(p,q)
 150    continue
c
 200    continue
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!*********************************************************************
!*                                                                   *
!*  PROJ      := Project CASSCF vector onto irrep(s).                *
!*                                                                   *
!*********************************************************************
subroutine proj_cvb(civec)

use casvb_global, only: mxirrep, ndet, projsym
use Definitions, only: wp

implicit none
real(kind=wp), intent(inout) :: civec(0:ndet)
real(kind=wp) :: dum(mxirrep)

if (projsym) call psym1_cvb(civec(1:),civec(1:),dum,1)

return

end subroutine proj_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Put_nadc(colgradmode,Grad,nGrad)
      Implicit Real*8 (a-h,o-z)
#include "SysDef.fh"

      Real*8       Grad(nGrad)
      Integer colgradmode
      Character*24 Label
      if (colgradmode.eq.0) then
      Label='GRAD'
      elseif (colgradmode.eq.1) then
      Label='Grad State1'
      elseif (colgradmode.eq.2) then
      Label='Grad State2'
      elseif (colgradmode.eq.3) then
      Label='NADC'
      else
        Write(6,*) 'put_nadc: invalid colgradmode',colgradmode
        call Abend()
      endif
      Call Put_dArray(Label,Grad,nGrad)
*
      Call Get_iScalar('Grad ready',iGO)
      iGO = iOr(iGO,2**0)
      Call Put_iScalar('Grad ready',iGO)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1999, Roland Lindh                      *
*               1990, IBM                                              *
************************************************************************
      SubRoutine k2Loop(Coor,
     &                  iAnga,iCmpa,iShll,
     &                  iDCRR,nDCRR,Data,
     &                  Alpha,nAlpha,Beta, nBeta,
     &                  Alpha_,Beta_,
     &                  Coeff1,iBasn,Coeff2,jBasn,
     &                  Zeta,ZInv,Kappab,P,IndP,nZeta,IncZZ,Con,
     &                  Wrk,nWork2,
     &                  Cmpct,nScree,mScree,iStb,jStb,
     &                  Dij,nDij,nDCR,nHm,ijCmp,DoFock,
     &                  Scr,nScr,
     &                  Knew,Lnew,Pnew,Qnew,nNew,DoGrad,HMtrx,nHrrMtrx)
************************************************************************
*                                                                      *
* Object: to compute zeta, kappa, P, and the integrals [nm|nm] for     *
*         prescreening. This is done for all unique pairs of centers   *
*         generated from the symmetry unique centers A and B.          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN.                              *
*             June '91, modified to compute zeta, P, kappa and inte-   *
*             grals for Schwartz inequality in a k2 loop.              *
*             Modified for direct SCF, January '93                     *
************************************************************************
      use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
      use Real_Spherical
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iOper
      use Gateway_Info, only: CutInt, RadMax, cdMax, EtMax
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
      External TERIS, ModU2, Cmpct, Cff2DS, Rys2D
#include "real.fh"
#include "Molcas.fh"
#include "disp.fh"
#include "print.fh"
      Real*8 Coor(3,4), CoorM(3,4), Coori(3,4), Coora(3,4), CoorAC(3,2),
     &       Alpha(nAlpha), Beta(nBeta), Dij(nDij,nDCR),
     &       Data((nZeta*(nDArray+2*ijCmp)+nDScalar+nHm),nDCRR),
     &       Zeta(nZeta), ZInv(nZeta), Kappab(nZeta), P(nZeta,3),
     &       Wrk(nWork2), Q(3), TA(3), TB(3), Scr(nScr,3),
     &       Con(nZeta), Coeff1(nAlpha,iBasn), Coeff2(nBeta,jBasn),
     &       Alpha_(nZeta),Beta_(nZeta), HMtrx(nHrrMtrx,2)
      Real*8  Knew(nNew), Lnew(nNew), Pnew(nNew*3), Qnew(nNew*3)
      Integer   iDCRR(0:7), iAnga(4), iCmpa(4), mStb(2),
     &          iShll(2), IndP(nZeta)
      Integer isave(1024)
      Logical AeqB, EQ, NoSpecial,
     &        DoFock, DoGrad
      External EQ
      Dimension Dummy(1)
*                                                                      *
************************************************************************
*                                                                      *
      Call k2loop_internal(Data)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine k2loop_internal(Data)
      Real*8, Target :: Data((nZeta*(nDArray+2*ijCmp)+nDScalar+nHm),
     &                       nDCRR)
      Integer, Pointer :: iData(:)
      Logical, External :: TF
#ifdef _WARNING_WORKAROUND_
      Interface
        SubRoutine Rys(iAnga,nT,Zeta,ZInv,nZeta,Eta,EInv,nEta,P,lP,Q,lQ,
     &                 rKapab,rKapcd,Coori,Coora,CoorAC,mabMin,mabMax,
     &                 mcdMin,mcdMax,Array,nArray,Tvalue,ModU2,Cff2D,
     &                 Rys2D,NoSpecial)
        use Definitions, only: wp, iwp
        integer(kind=iwp), intent(in) :: iAnga(4), nT, nZeta, nEta, lP,
     &                                   lQ, mabMin, mabMax, mcdMin,
     &                                   mcdMax, nArray
        real(kind=wp), intent(in) :: Zeta(nZeta), ZInv(nZeta),
     &                               Eta(nEta), EInv(nEta), P(lP,3),
     &                               Q(lQ,3), rKapab(nZeta),
     &                               rKapcd(nEta), Coori(3,4),
     &                               Coora(3,4), CoorAC(3,2)
        real(kind=wp), intent(inout) :: Array(nArray)
        external :: Tvalue, ModU2, Cff2D, Rys2D
        logical(kind=iwp), intent(in) :: NoSpecial
         End Subroutine Rys
      End Interface
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function to compute canonical index
*
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 241
      iPrint = nPrint(iRout)
*     iPrint = 99
      call dcopy_(3,[One],0,Q,1)
      nData=nZeta*(nDArray+2*ijCmp)+nDScalar+nHm
      call dcopy_(nData*nDCRR,[Zero],0,Data,1)
      mStb(1) = iStb
      mStb(2) = jStb
      la = iAnga(1)
      lb = iAnga(2)
      iSmAng=la+lb+la+lb
      iCmpa_= iCmpa(1)
      jCmpb_= iCmpa(2)
      iShlla = iShll(1)
      jShllb = iShll(2)
*                                                                      *
************************************************************************
*                                                                      *
      call dcopy_(3,Coor(1,1),1,CoorM(1,1),1)
*                                                                      *
************************************************************************
*                                                                      *
      Do 100 lDCRR = 0, nDCRR-1
*
         Call ICopy(1024,nPrint,1,iSave,1)
         Call ICopy(1024,[5],0,nPrint,1)
*
         Call OA(iDCRR(lDCRR),Coor(1:3,2),CoorM(1:3,2))
         AeqB = EQ(CoorM(1,1),CoorM(1,2))
*        Branch out if integrals are zero by symmetry.
         If (AeqB .and. Mod(iSmAng,2).eq.1) Go To 100
         call dcopy_(6,CoorM(1,1),1,CoorM(1,3),1)
         If (iPrint.ge.99) Call RecPrt(' Actual centers',
     &                                  ' ',CoorM,3,4)
*                                                                      *
************************************************************************
*                                                                      *
*        Compute zeta, P and kappa.
*
*        No triangulatization applied at this level
         Call DoZeta(Alpha,nAlpha,Beta,nBeta,
     &               CoorM(1,1),CoorM(1,2),
     &               P,
     &               Zeta,
     &               Kappab,
     &               ZInv,
     &               Alpha_,
     &               Beta_,
     &               IndP)
*                                                                      *
************************************************************************
*                                                                      *
*        Generate transformation matrix from intermediate integrals
*        to final angular composition.
*
         mabMin=nabSz(Max(la,lb)-1)+1
         If (EQ(CoorM(1,1),CoorM(1,2))) mabMin = nabSz(la+lb-1)+1
         mabMax=nabSz(la+lb)
         ne=(mabMax-mabMin+1)
         Do iIrrep = 0, nIrrep-1
            i13_=ip_HrrMtrx(nZeta)+(iIrrep*nHm)/nIrrep
            Call OA(iOper(iIrrep),CoorM(1:3,1),TA)
            Call OA(iOper(iIrrep),CoorM(1:3,2),TB)
            Call HrrMtrx(Data(i13_,lDCRR+1),
     &                   ne,la,lb,TA,TB,
     &                   Shells(iShlla)%Transf,RSph(ipSph(la)),iCmpa_,
     &                   Shells(jShllb)%Transf,RSph(ipSph(lb)),jCmpb_)
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*        Compute primitive integrals to be used in the prescreening
*        by the Schwartz inequality.
*
         call dcopy_(12,CoorM(1,1),1,Coora(1,1),1)
         call dcopy_(12,CoorM(1,1),1,Coori(1,1),1)
*
*        Compute actual size of [a0|c0] block
*
         mcdMin=mabMin
         mcdMax=mabMax
         mabcd=(mabMax-mabMin+1)*(mcdMax-mcdMin+1)
*
*        Find the proper centers to start of with the angular
*        momentum on. If la.eq.lb there will exist an
*        ambiguity to which center that angular momentum should
*        be accumulated on. In that case we will use A and C of
*        the order as defined by the basis functions types.
*
         If (iAnga(1).ge.iAnga(2)) Then
            call dcopy_(3,Coora(1,1),1,CoorAC(1,1),1)
         Else
            call dcopy_(3,Coora(1,2),1,CoorAC(1,1),1)
         End If
         call dcopy_(3,CoorAC(1,1),1,CoorAC(1,2),1)
*
*        Compute [a0|c0], ijkl,a,c
*
         Jnd = 0
         nScree = nScree + nZeta
         Do iZeta = 1, nZeta, IncZZ
            mZeta = Min(nZeta-iZeta+1,IncZZ)
*
            nT = mZeta*1
            NoSpecial=.True.
            Call Rys(iAnga,nT,
     &               Zeta(iZeta),ZInv(iZeta),mZeta,[One],[One],1,
     &               P(iZeta,1),nZeta,Q,1,Kappab(iZeta),[One],
     &               Coori,Coora,CoorAC,
     &               mabMin,mabMax,mcdMin,mcdMax,
     &               Wrk,nWork2,TERIS,ModU2,Cff2DS,
     &               Rys2D,NoSpecial)
            If (iPrint.ge.59)
     &         Call RecPrt(' In k2Loop: ijkl,[a0|c0]',' ',Wrk,
     &                               mZeta,mabcd)
*
*---------- Apply a transpose prior to Tnsctl to fake the action
*           of Cntrct.
*
            iW3=1+mZeta*mabcd
            Call DGeTMO(Wrk,mZeta,mZeta,mabcd,Wrk(iW3),mabcd)
            call dcopy_(mabcd*mZeta,Wrk(iW3),1,Wrk,1)
            Call TnsCtl(Wrk,nWork2,Coora,
     &                  mabcd,mZeta,mabMax,mabMin,mabMax,mabMin,
     &                  Data(ip_HrrMtrx(nZeta),lDCRR+1),
     &                  Data(ip_HrrMtrx(nZeta),lDCRR+1),
     &                  la,lb,la,lb,
     &                  iCmpa_,jCmpb_,iCmpa_,jCmpb_,
     &                  iShlla,jShllb,iShlla,jShllb,i_Int)
            If (i_Int.eq.1) Then
               iW2=1
               iW3=1+mZeta*(iCmpa_*jCmpb_)**2
            Else
               iW2=i_Int
               iW3=1
            End If
*                                                                      *
************************************************************************
*                                                                      *
         Call C_F_Pointer(C_Loc(Data(ip_IndZ(1,nZeta),lDCRR+1)),iData,
     &                    [nAlpha*nBeta+1])
*                                                                      *
************************************************************************
*                                                                      *
*-----------Store data in core
*
            Call Cmpct(Wrk(iW2),iCmpa_,jCmpb_,nZeta,mZeta,
     &                 Zeta(iZeta),Kappab(iZeta),
     &                 P(iZeta,1),IndP(iZeta),Con,
     &                 Data(ip_Z    (1,nZeta),lDCRR+1),
     &                 Data(ip_Kappa(1,nZeta),lDCRR+1),
     &                 Data(ip_Pcoor(1,nZeta),lDCRR+1),
     &                 iData,iZeta-1,Jnd,
     &                 Data(ip_ZInv (1,nZeta),lDCRR+1),CutInt,RadMax,
     &                 cdMax,EtMax,AeqB,
     &                 Data(ip_ab   (1,nZeta),lDCRR+1),
     &                 Data(ip_abCon(1,nZeta),lDCRR+1),
     &                 Alpha_(iZeta),
     &                 Data(ip_Alpha(1,nZeta,1),lDCRR+1),
     &                 Beta_(iZeta),
     &                 Data(ip_Beta (1,nZeta,2),lDCRR+1))
*
         End Do ! iZeta
         mScree = mScree + Jnd
*                                                                      *
************************************************************************
*                                                                      *
*        Estimate the largest contracted integral.
*
         Data(ip_EstI(nZeta),lDCRR+1) =
     &                      EstI(Data(ip_Z(1,nZeta),lDCRR+1),
     &                           Data(ip_Kappa(1,nZeta),lDCRR+1),
     &                           nAlpha,nBeta,
     &                           Coeff1,iBasn,Coeff2,jBasn,
     &                           Data(ip_ab   (1,nZeta),lDCRR+1),
     &                           iCmpa_*jCmpb_,
     &                           Wrk,nWork2,
     &                           iData)
         Nullify(iData)
*                                                                      *
************************************************************************
*                                                                      *
*------- Find the largest integral estimate (AO Basis).
*
         Tst  = -One
         Do  iZeta = 0, nZeta-1
             Tst=Max(Data(ip_Z(iZeta+1,nZeta),lDCRR+1),Tst)
         End Do
         Data(ip_ZetaM(nZeta),lDCRR+1) = tst
*
         iOffZ = nDij-nZeta-1
         ZtMax=One
         abMax=Zero
         ZtMaxD=One
         abMaxD=Zero
         Do iZeta = 0, Jnd-1
            tmp = Data(ip_abCon(iZeta+1,nZeta),lDCRR+1)
            If (abMax.lt.tmp) Then
               abMax = tmp
               ZtMax = Data(ip_Z    (iZeta+1,nZeta),lDCRR+1)
            End If
            If (DoFock) Then
               tmp = Data(ip_ab(iZeta+1,nZeta),lDCRR+1)
     &             * Dij(iOffZ+iZeta,lDCRR+1)
               If (abMaxD.lt.tmp) Then
                 abMaxD = tmp
                 ZtMaxD = Data(ip_Z(iZeta+1,nZeta),lDCRR+1)
               End If
            Else
                 ZtMaxD=-One
                 abMaxD=Zero
            End If
         End Do
         Data(ip_ZtMax(nZeta),lDCRR+1) = ZtMax
         Data(ip_abMax (nZeta),lDCRR+1) = abMax
         Data(ip_ZtMaxD(nZeta),lDCRR+1) = ZtMaxD
         Data(ip_abMaxD(nZeta),lDCRR+1) = abMaxD
         Call ICopy(1024,iSave,1,nPrint,1)
*                                                                      *
************************************************************************
*                                                                      *
*------- Compute data for gradient evaluation
*
         mZeta=Jnd
         If (DoGrad.and.mZeta.gt.0) Then
*
*---------- Compute primitive integrals to be used in the prescreening
*           by the Cauchy-Schwarz inequality.
*
            Do iZeta = 1, mZeta, IncZZ
               lZeta = Min(mZeta-iZeta+1,IncZZ)
               Call SchInt(CoorM,iAnga,iCmpa,lZeta,
     &                     Data(ip_Z    (iZeta,nZeta),lDCRR+1),
     &                     Data(ip_ZInv (iZeta,nZeta),lDCRR+1),
     &                     Data(ip_Kappa(iZeta,nZeta),lDCRR+1),
     &                     Data(ip_PCoor(iZeta,nZeta),lDCRR+1),
     &                     Data(ip_Kappa(iZeta,nZeta),lDCRR+1),
     &                     Data(ip_PCoor(iZeta,nZeta),lDCRR+1),
     &                     nZeta,Wrk,nWork2,HMtrx,
     &                     nHrrMtrx,iShlla,jShllb,i_Int)
               Call PckInt(Wrk(i_Int),lZeta,ijCmp,
     &                     Data(ip_abG(nZeta,nHm)+iZeta-1,lDCRR+1),
     &                     Data(ip_Kappa(iZeta,nZeta),lDCRR+1),.True.,
     &                     Data(ip_Z   (iZeta,nZeta),lDCRR+1),nZeta,
     &                     Dummy)
            End Do
*
*---------- Second order numerical differentiation. The gradients are
*           restricted to only those with respect to symmetrical
*           displacements. The symmetric three point formula is used in
*           the numerical procedure.
*
            iIrrep=0
            Delta = 1.0D-03
            iOff_g=ip_abG(nZeta,nHm)+ijCmp*nZeta
            Call FZero(Data(iOff_g,lDCRR+1),nZeta*ijCmp)
            Scr(1:nZeta*ijCmp,:)=Zero
*
*---------- Loop over center A and B.
*
            Do iCnt = 1, 2
*
               nDisp=IndDsp(mStb(iCnt),iIrrep)
               Do iComp = 1, 3
                  iCmp=2**(iComp-1)
                  If (TF(mStb(iCnt),iIrrep,iCmp) .and.
     &                Direct(nDisp+1)) Then
                     nDisp = nDisp + 1
                     temp = CoorM(iComp,iCnt)
*
                     CoorM(iComp,iCnt  ) = temp + Delta
                     CoorM(iComp,iCnt+2) = temp + Delta
                     Call NewPK(CoorM(1,1),CoorM(1,2),
     &                          Pnew,mZeta,nZeta,
     &                          Knew,
     &                          Data(ip_Alpha(1,nZeta,1),lDCRR+1),
     &                          Data(ip_Beta (1,nZeta,2),lDCRR+1))
                     Do iZeta = 1, mZeta, IncZZ
                        lZeta = Min(mZeta-iZeta+1,IncZZ)
                        Call SchInt(CoorM,
     &                              iAnga,iCmpa,lZeta,
     &                              Data(ip_Z   (iZeta,nZeta),lDCRR+1),
     &                              Data(ip_ZInv(iZeta,nZeta),lDCRR+1),
     &                              Knew(iZeta),
     &                              Pnew(iZeta),
     &                              Knew(iZeta),
     &                              Pnew(iZeta),
     &                              nZeta,Wrk,nWork2,
     &                              HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
                        Call PckInt(Wrk(i_Int),lZeta,ijCmp,
     &                              Scr(iZeta,1),
     &                              Knew(iZeta),
     &                              .False.,
     &                              Data(ip_Z    (iZeta,nZeta),lDCRR+1),
     &                              nZeta,
     &                              Knew(iZeta))
                     End Do
*
                     CoorM(iComp,iCnt  ) = temp - Delta
                     CoorM(iComp,iCnt+2) = temp - Delta
                     Call NewPK(CoorM(1,1),CoorM(1,2),
     &                          Qnew,mZeta,nZeta,
     &                          Lnew,
     &                          Data(ip_Alpha(1,nZeta,1),lDCRR+1),
     &                          Data(ip_Beta (1,nZeta,2),lDCRR+1))
                     Do iZeta = 1, mZeta, IncZZ
                        lZeta = Min(mZeta-iZeta+1,IncZZ)
                        Call SchInt(CoorM,
     &                              iAnga,iCmpa,lZeta,
     &                              Data(ip_Z   (iZeta,nZeta),lDCRR+1),
     &                              Data(ip_ZInv(iZeta,nZeta),lDCRR+1),
     &                              Lnew(iZeta),
     &                              Qnew(iZeta),
     &                              Lnew(iZeta),
     &                              Qnew(iZeta),
     &                              nZeta,Wrk,nWork2,
     &                              HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
                        Call PckInt(Wrk(i_Int),lZeta,ijCmp,
     &                              Scr(iZeta,2),
     &                              Lnew(iZeta),
     &                              .False.,
     &                              Data(ip_Z   (iZeta,nZeta),lDCRR+1),
     &                              nZeta,
     &                              Lnew(iZeta))
                     End Do
*
                     Call DaXpY_(nZeta*ijCmp, One,Scr(1,2),1,
     &                                           Scr(1,1),1)
*
                     CoorM(iComp,iCnt  ) = temp + Delta
                     CoorM(iComp,iCnt+2) = temp - Delta
                     Do iZeta = 1, mZeta, IncZZ
                        lZeta = Min(mZeta-iZeta+1,IncZZ)
                        Call SchInt(CoorM,
     &                              iAnga,iCmpa,lZeta,
     &                              Data(ip_Z   (iZeta,nZeta),lDCRR+1),
     &                              Data(ip_ZInv(iZeta,nZeta),lDCRR+1),
     &                              Knew(iZeta),
     &                              Pnew(iZeta),
     &                              Lnew(iZeta),
     &                              Qnew(iZeta),
     &                              nZeta,Wrk,nWork2,
     &                              HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
                        Call PckInt(Wrk(i_Int),lZeta,ijCmp,
     &                              Scr(iZeta,3),
     &                              Knew(iZeta),
     &                              .False.,
     &                              Data(ip_Z    (iZeta,nZeta),lDCRR+1),
     &                              nZeta,
     &                              Lnew(iZeta))
                     End Do
*
                     Call DaXpY_(nZeta*ijCmp,-One,Scr(1,3),1,
     &                                           Scr(1,1),1)
*
                     CoorM(iComp,iCnt  ) = temp - Delta
                     CoorM(iComp,iCnt+2) = temp + Delta
                     Do iZeta = 1, mZeta, IncZZ
                        lZeta = Min(mZeta-iZeta+1,IncZZ)
                        Call SchInt(CoorM,
     &                              iAnga,iCmpa,lZeta,
     &                              Data(ip_Z   (iZeta,nZeta),lDCRR+1),
     &                              Data(ip_ZInv(iZeta,nZeta),lDCRR+1),
     &                              Lnew(iZeta),
     &                              Qnew(iZeta),
     &                              Knew(iZeta),
     &                              Pnew(iZeta),
     &                              nZeta,Wrk,nWork2,
     &                              HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
                        Call PckInt(Wrk(i_Int),lZeta,ijCmp,
     &                              Scr(iZeta,3),
     &                              Lnew(iZeta),
     &                              .False.,
     &                              Data(ip_Z    (iZeta,nZeta),lDCRR+1),
     &                              nZeta,
     &                              Knew(iZeta))
                     End Do
*
                     Call DaXpY_(nZeta*ijCmp,-One,Scr(1,3),1,
     &                                           Scr(1,1),1)
*
                     Call DScal_(nZeta*ijCmp,One/(Four*Delta**2),
     &                                           Scr(1,1),1)
                     Call AbsAdd(nZeta*ijCmp,    Scr(1,1),1,
     &                                   Data(iOff_g,lDCRR+1),1)
*
                     CoorM(iComp,iCnt  ) = temp
                     CoorM(iComp,iCnt+2) = temp
                  End If
               End Do
*
            End Do
         End If       ! DoGrad
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*) 'lDCRR=',lDCRR
         Call WrCheck('Zeta ',Data(ip_Z    (1,nZeta),  lDCRR+1),nZeta)
         Call WrCheck('Kappa',Data(ip_Kappa(1,nZeta),  lDCRR+1),nZeta)
         Call WrCheck('P    ',Data(ip_PCoor(1,nZeta),  lDCRR+1),nZeta*3)
         Call WrCheck('xA   ',Data(ip_Alpha(1,nZeta,1),lDCRR+1),nZeta)
         Call WrCheck('xB   ',Data(ip_Beta (1,nZeta,2),lDCRR+1),nZeta)
         Call WrCheck('ZInv ',Data(ip_ZInv (1,nZeta),  lDCRR+1),nZeta)
         If (DoGrad) Then
            Call WrCheck('ab   ',
     &         Data(ip_abG  (nZeta,nHm),  lDCRR+1),nZeta*ijCmp)
            iOff_g=ip_abG(nZeta,nHm)+ijCmp*nZeta
            Call WrCheck('abG  ',
     &         Data(iOff_g,               lDCRR+1),nZeta*ijCmp)
         End If
         Write (6,*)
         Write (6,*) ' ERI(Max)=',Data(  ip_EstI(nZeta),lDCRR+1)
         Write (6,*) ' ZtMax   =',Data( ip_ZtMax(nZeta),lDCRR+1)
         Write (6,*) ' abMax   =',Data(ip_abMax (nZeta),lDCRR+1)
         Write (6,*) ' ZtMaxD  =',Data(ip_ZtMaxD(nZeta),lDCRR+1)
         Write (6,*) ' abMaxD  =',Data(ip_abMaxD(nZeta),lDCRR+1)
         Call WrCheck(' HrrMtrx',
     &        Data(ip_HrrMtrx(nZeta),lDCRR+1),
     &        ne*iCmpa_*jCmpb_)
#endif
 100  Continue ! lDCRR
*
      Return
      End Subroutine k2loop_internal
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cre_dyn
*     MV: Create a dynamix file. If another .dyn.h5 file already
*     exists, it will be overwritten.
      implicit none
#ifdef _HDF5_
#  include "Molcas.fh"
#  include "dyn.fh"
#  include "stdalloc.fh"
      integer :: natoms,nh,nsym,nstates,nconfs,
     $           dyn_dsetid,surf_dsetid,wfn_fileid,ii
      real*8, allocatable :: coord(:,:), ener(:), ciarray(:)
      character(len=LENIN), allocatable :: atomlbl(:)
      logical :: found
      complex*16, allocatable :: amatrix(:)

*     Create a new dynamix file!
      dyn_fileid = mh5_create_file('DYN')

*     Set module type
      call mh5_init_attr (dyn_fileid,'MOLCAS_MODULE', 'DYNAMIX')

*     Copy basic molecular information to the HDF5 file
*     Morgane Vacher: Need to be able to modify the geom
*     but could not make it work with run2h5
*      call run2h5_molinfo(dyn_fileid)
*     Symmetry
      call mh5_init_attr (dyn_fileid,'NSYM', 1)
      call get_iScalar('nSym',nsym)
      if (nsym .gt. 1) then
        Call get_iScalar('LP_nCenter',natoms)
      else
        Call Get_iScalar('Unique atoms',natoms)
      endif
*     Number of atoms
      call mh5_init_attr (dyn_fileid,'NATOMS_UNIQUE', natoms)
*     Nuclear geometry
      dyn_geom = mh5_create_dset_real(dyn_fileid,
     $          'CENTER_COORDINATES', 1, [3*natoms])
      call mh5_init_attr(dyn_geom, 'description',
     $          'Geometry in cartesians coordinates '//
     $          'at the current time step')
      call mma_allocate(coord,3,natoms)
      if (nsym .gt. 1) then
        call get_dArray('LP_Coor',coord,3*natoms)
      else
        Call Get_dArray('Unique Coordinates',coord,3*natoms)
      endif
      call mh5_put_dset_array_real(dyn_geom,coord)
      call mma_deallocate(coord)
*     Atom labels
      dyn_dsetid = mh5_create_dset_str(dyn_fileid,
     $          'CENTER_LABELS', 1, [natoms], LENIN)
      call mh5_init_attr(dyn_dsetid, 'description',
     $          'Center labels '//
     $          'arranged as a [NATOMS] block')
      call mma_allocate(atomlbl,natoms)
      if (nsym .gt. 1) then
        call get_cArray('LP_L',atomlbl,LENIN4*natoms)
      else
        Call Get_cArray('Unique Atom Names',atomlbl,LENIN*natoms)
      endif
      call mh5_put_dset(dyn_dsetid,atomlbl)
      call mma_deallocate(atomlbl)
      call mh5_close_dset(dyn_dsetid)

*     Current time
      dyn_time = mh5_create_dset_real (dyn_fileid,'TIME')
      call mh5_init_attr(dyn_time, 'description',
     $        'Current time of the Molecular Dynamics')
*     Time step
      dyn_dt = mh5_create_dset_real (dyn_fileid,'TIME_STEP')
      call mh5_init_attr(dyn_dt, 'description',
     $        'Time step of the Molecular Dynamics')

*     Total energy at t=0
      dyn_etot0 = mh5_create_dset_real (dyn_fileid,'ETOT_0')
      call mh5_init_attr(dyn_etot0, 'description',
     $        'Total energy at t=0')
*     Total energy at current time
      dyn_etot = mh5_create_dset_real (dyn_fileid,'ETOT')
      call mh5_init_attr(dyn_etot, 'description',
     $        'Total energy at current time')

*     Velocities
      dyn_vel = mh5_create_dset_real(dyn_fileid,
     $          'VELOCITIES', 1, [3*natoms])
      call mh5_init_attr(dyn_vel, 'description',
     $          'Velocities in cartesians coordinates '//
     $          'at the current time step')

*     NoseHoover
      nh=6
      dyn_nh = mh5_create_dset_real(dyn_fileid,
     $          'NOSEHOOVER', 1, [nh])
      call mh5_init_attr(dyn_nh, 'description',
     $          'NoseHoover degrees of freedom')

*     MaxHop
*     Morgane Vacher: Dataset only created if needed since its existence serves as a flag.
      call qpg_iScalar('MaxHops',Found)
      if (Found) then
         call get_iScalar('MaxHops',ii)
         call mh5_init_dset(dyn_fileid,'MAX_HOP',ii)
      end if

*     Isotopes
      dyn_mass = mh5_create_dset_real(dyn_fileid,
     $          'MASSES', 1, [natoms])
      call mh5_init_attr(dyn_mass, 'description',
     $          'Atomic masses, in a.u.')

*     The following variables are relevant to the SURFACEHOP module.
*     They are not modified by the DYNAMIX module but saved here on the H5 file.
*     This way, the informations saved are consistent, ie belong to the same step.

*     Seed number
      call qpg_iscalar('Seed',Found)
      if (Found) then
        surf_dsetid = mh5_create_dset_int (dyn_fileid,'SEED')
        call mh5_init_attr(surf_dsetid, 'description',
     $        'Seed number')
        call get_iscalar('Seed',ii)
        call mh5_put_dset(surf_dsetid,ii)
        call mh5_close_dset(surf_dsetid)
      endif

*     Number of hops
      call qpg_iscalar('Number of Hops',Found)
      if (Found) then
        surf_dsetid = mh5_create_dset_int (dyn_fileid,'NO. OF HOPS')
        call mh5_init_attr(surf_dsetid, 'description',
     $        'Number of hops')
        call get_iscalar('Number of Hops',ii)
        call mh5_put_dset(surf_dsetid,ii)
        call mh5_close_dset(surf_dsetid)
      endif

*     Maximum number of hops in Tully
      call qpg_iscalar('MaxHopsTully',Found)
      if (Found) then
        surf_dsetid = mh5_create_dset_int (dyn_fileid,'MAX_HOP_TULLY')
        call mh5_init_attr(surf_dsetid, 'description',
     $        'Maximum number of hops in Tully algorithm')
        call get_iscalar('MaxHopsTully',ii)
        call mh5_put_dset(surf_dsetid,ii)
        call mh5_close_dset(surf_dsetid)
      endif

*     Relax CASSCF root
      call qpg_iscalar('Relax CASSCF root',Found)
      if (Found) then
        surf_dsetid = mh5_create_dset_int (dyn_fileid,'Relax CAS root')
        call mh5_init_attr(surf_dsetid, 'description',
     $        'Relax CASSCF root')
        call get_iscalar('Relax CASSCF root',ii)
        call mh5_put_dset(surf_dsetid,ii)
        call mh5_close_dset(surf_dsetid)
      endif

*     Read number of states and configurations from rasscf.h5 file
      wfn_fileid = mh5_open_file_r('RASWFN')
      if (mh5_exists_attr(wfn_fileid,'NSTATES')
     $  .and. mh5_exists_attr(wfn_fileid,'NCONF')) then
        call mh5_fetch_attr(wfn_fileid,'NSTATES',nstates)
        call mh5_fetch_attr(wfn_fileid,'NCONF',nconfs)
        call mh5_init_attr(dyn_fileid,'NSTATES',nstates)
        call mh5_init_attr(dyn_fileid,'NCONFS',nconfs)

*     Energies at the previous step
        call qpg_darray('VenergyP',Found,nstates)
        if (Found) then
          surf_dsetid = mh5_create_dset_real (dyn_fileid,'Energ Prev',
     $            1, [nstates])
          call mh5_init_attr(surf_dsetid, 'description',
     $        'Potential energies at the previous time step')
          call mma_allocate(ener,nstates)
          call get_darray('VenergyP',ener,nstates)
          call mh5_put_dset(surf_dsetid,ener)
          call mma_deallocate(ener)
          call mh5_close_dset(surf_dsetid)
        endif

*     CI coeffs at the previous step
        call qpg_darray('AllCIP',Found,nstates*nconfs)
        if (Found) then
          surf_dsetid = mh5_create_dset_real (dyn_fileid,'CI Prev',
     $            1, [nstates*nconfs])
          call mh5_init_attr(surf_dsetid, 'description',
     $        'CI coeffs at the previous time step')
          call mma_allocate(ciarray,nstates*nconfs)
          call get_darray('AllCIP',ciarray,nstates*nconfs)
          call mh5_put_dset(surf_dsetid,ciarray)
          call mma_deallocate(ciarray)
          call mh5_close_dset(surf_dsetid)
        endif

*     CI coeffs at the step before the previous step
        call qpg_darray('AllCIPP',Found,nstates*nconfs)
        if (Found) then
          surf_dsetid = mh5_create_dset_real (dyn_fileid,'CI PPrev',
     $            1, [nstates*nconfs])
          call mh5_init_attr(surf_dsetid, 'description',
     $        'CI coeffs at the step before the previous time step')
          call mma_allocate(ciarray,nstates*nconfs)
          call get_darray('AllCIPP',ciarray,nstates*nconfs)
          call mh5_put_dset(surf_dsetid,ciarray)
          call mma_deallocate(ciarray)
          call mh5_close_dset(surf_dsetid)
        endif

*     A matrix V
        call Qpg_zArray('AmatrixV', Found, nstates*nstates)
        if (Found) then
          call mma_allocate(Amatrix,nstates*nstates)
          call get_zarray('AmatrixV',Amatrix,NSTATES*NSTATES)
*     HDF5 format does not deal with complex numbers so split manually into
*     real and imaginary parts and save 2 datasets
*         Real part
          surf_dsetid = mh5_create_dset_real (dyn_fileid,'AmatrixV-R',
     $            1, [nstates*nstates])
          call mh5_init_attr(surf_dsetid, 'description',
     $        'real part of AmatrixV')
          call mh5_put_dset(surf_dsetid,REAL(Amatrix))
          call mh5_close_dset(surf_dsetid)
*         Imaginary part
          surf_dsetid = mh5_create_dset_real (dyn_fileid,'AmatrixV-I',
     $            1, [nstates*nstates])
          call mh5_init_attr(surf_dsetid, 'description',
     $        'imaginary part of AmatrixV')
          call mh5_put_dset(surf_dsetid,AIMAG(Amatrix))
          call mh5_close_dset(surf_dsetid)
          call mma_deallocate(Amatrix)
        endif


      endif
      call mh5_close_file(wfn_fileid)

#endif
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine OneOverR(iFil,Ax,Ay,Az,BoMaH,BoMaO,EEDisp,iCNum,Eint
     &                   ,iQ_Atoms,outxyz)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "WrkSpc.fh"

      Dimension iFil(MxQCen,10)
      Dimension Eint(MxQCen,10),BoMaH(MxAt),BoMaO(MxAt),outxyz(MxQCen,3)

      EEdisp=0.0d0
*----------------------------------------------------------------------*
* Compute some distances and inverted distances etc. The potential,    *
* the field and etc. and when we already have the numbers, we also do  *
* the dispersion interaction.                                          *
*----------------------------------------------------------------------*
      iCi=(iQ_Atoms*(iQ_Atoms+1))/2
      Do 601, k=1,iCi
        Gx=outxyz(k,1)+Ax
        Gy=outxyz(k,2)+Ay
        Gz=outxyz(k,3)+Az
        Do 602, j=iCnum+1,nPart
          i=1+(j-1)*nCent
          ip=1+(j-1)*nPol
          Rabx1=Cordst(i,1)-Gx  !Below follows a lot of
          Raby1=Cordst(i,2)-Gy  !distances to and fro.
          Rabz1=Cordst(i,3)-Gz
          Rabx2=Cordst(i+1,1)-Gx
          Raby2=Cordst(i+1,2)-Gy
          Rabz2=Cordst(i+1,3)-Gz
          Rabx3=Cordst(i+2,1)-Gx
          Raby3=Cordst(i+2,2)-Gy
          Rabz3=Cordst(i+2,3)-Gz
          Rabx4=Cordst(i+3,1)-Gx
          Raby4=Cordst(i+3,2)-Gy
          Rabz4=Cordst(i+3,3)-Gz
          Rabx5=Cordst(i+4,1)-Gx
          Raby5=Cordst(i+4,2)-Gy
          Rabz5=Cordst(i+4,3)-Gz
          R21=Rabx1**2+Raby1**2+Rabz1**2
          R22=Rabx2**2+Raby2**2+Rabz2**2
          R23=Rabx3**2+Raby3**2+Rabz3**2
          R24=Rabx4**2+Raby4**2+Rabz4**2
          R25=Rabx5**2+Raby5**2+Rabz5**2
          Rg1=Sqrt(r21)
          Rg2=Sqrt(r22)
          Rg3=Sqrt(r23)
          Rg4=Sqrt(r24)
          Rg5=Sqrt(r25)
          S1i=1/Rg1
          S2i=1/Rg2
          S3i=1/Rg3
          S4i=1/Rg4
          S5i=1/Rg5
          S1e=S1i
          S2e=S2i
          S3e=S3i
          S4e=S4i
          S5e=S5i
          Eint(k,1)=-Qsta(1)*S2e-Qsta(2)*S3e-Qsta(3)*S4e !This term
     &             -Qsta(4)*S5e+Eint(k,1)  !will below turn into
          Rab13i=S1e/R21          !the interaction between charges
          Rab23i=S2e/R22         !on water and the MME-charges on
          Rab33i=S3e/R23         !the QM-molecule.
          Rab43i=S4e/R24
          Rab53i=S5e/R25
*----------------------------------------------------------------------*
* The dispersion interaction between QM-atoms and solvent is computed, *
* with or without damping. The initial if-clause sees to that only     *
* atom-centers are included, while bonds and virtual centers are       *
* ignored.                                                             *
*----------------------------------------------------------------------*
          If(k.le.iQ_atoms) then
            Call DispEnergy(EEDisp,BoMah,BoMaO,rg1,rg2,rg3
     &                     ,Rab13i,Rab23i,Rab33i,k)
          Endif
*----------------------------------------------------------------------*
* Now we wrap up the electrostatics.                                   *
*----------------------------------------------------------------------*
          Ux1=RabX1*s1i
          Uy1=RabY1*s1i
          Uz1=RabZ1*s1i
          Ux2=RabX2*s2i
          Uy2=RabY2*s2i
          Uz2=RabZ2*s2i
          Ux3=RabX3*s3i
          Uy3=RabY3*s3i
          Uz3=RabZ3*s3i
          Ux4=RabX4*s4i
          Uy4=RabY4*s4i
          Uz4=RabZ4*s4i
          Ux5=RabX5*s5i
          Uy5=RabY5*s5i
          Uz5=RabZ5*s5i
         !These three terms will below turn into the interaction
         !between water charges and the MME-dipoles on the QM-mol.
         !Change sign of charge, change sign of vector and then we
         !should also change sign since when a dipole interacts with
         !a field we have a minus sign, but this minus sign we have
         !omitted in hel; therefore this calculation gives the right
         !number eventually.
          Eint(k,2)=-Qsta(1)*RabX2*Rab23i-Qsta(2)*RabX3*Rab33i
     &-Qsta(3)*RabX4*Rab43i-Qsta(4)*RabX5*Rab53i+Eint(k,2)
          Eint(k,3)=-Qsta(1)*RabY2*Rab23i-Qsta(2)*RabY3*Rab33i
     &-Qsta(3)*RabY4*Rab43i-Qsta(4)*RabY5*Rab53i+Eint(k,3)
          Eint(k,4)=-Qsta(1)*RabZ2*Rab23i-Qsta(2)*RabZ3*Rab33i
     &-Qsta(3)*RabZ4*Rab43i-Qsta(4)*RabZ5*Rab53i+Eint(k,4)
          !And here it is the MME-quadrupoles that are prepared.
          !Change sign of charges, change sign two times of the
          !vector (in effect, zero times then) and then in the
          !energy expression for the interaction between the field
          !vector from a charge and a quarupole there is a plus
          !sign, so a minus is the right sign below.
          Eint(k,5)=Eint(k,5)-Qsta(1)*Ux2**2*Rab23i-Qsta(2)*Ux3**2
     &*Rab33i-Qsta(3)*Ux4**2*Rab43i-Qsta(4)*Ux5**2*Rab53i
          Eint(k,7)=Eint(k,7)-Qsta(1)*Uy2**2*Rab23i-Qsta(2)*Uy3**2
     &*Rab33i-Qsta(3)*Uy4**2*Rab43i-Qsta(4)*Uy5**2*Rab53i
          Eint(k,10)=Eint(k,10)-Qsta(1)*Uz2**2*Rab23i-Qsta(2)*Uz3**2
     &*Rab33i-Qsta(3)*Uz4**2*Rab43i-Qsta(4)*Uz5**2*Rab53i
          Eint(k,6)=Eint(k,6)-Qsta(1)*Ux2*Uy2*Rab23i-Qsta(2)*Ux3
     &*Uy3*Rab33i-Qsta(3)*Ux4*Rab43i*Uy4-Qsta(4)*Ux5*Rab53i*Uy5
          Eint(k,8)=Eint(k,8)-Qsta(1)*Ux2*Uz2*Rab23i-Qsta(2)*Ux3
     &*Uz3*Rab33i-Qsta(3)*Ux4*Rab43i*Uz4-Qsta(4)*Ux5*Rab53i*Uz5
          Eint(k,9)=Eint(k,9)-Qsta(1)*Uz2*Uy2*Rab23i-Qsta(2)*Uz3
     &*Uy3*Rab33i-Qsta(3)*Uz4*Rab43i*Uy4-Qsta(4)*Uz5*Rab53i*Uy5

*----------------------------------------------------------------------*
* And now a whole lot of grad(1/r) and higher...                       *
*----------------------------------------------------------------------*
      !Unipoles.
          Work(iFil(k,1)-1+ip)=Rabx1*Rab13i
          Work(iFil(k,1)-1+ip+1)=Rabx2*Rab23i
          Work(iFil(k,1)-1+ip+2)=Rabx3*Rab33i
          Work(iFil(k,1)-1+nPart*nPol+ip)=Raby1*Rab13i
          Work(iFil(k,1)-1+nPart*nPol+ip+1)=Raby2*Rab23i
          Work(iFil(k,1)-1+nPart*nPol+ip+2)=Raby3*Rab33i
          Work(iFil(k,1)-1+2*nPart*nPol+ip)=Rabz1*Rab13i
          Work(iFil(k,1)-1+2*nPart*nPol+ip+1)=Rabz2*Rab23i
          Work(iFil(k,1)-1+2*nPart*nPol+ip+2)=Rabz3*Rab33i
      !Dipole -- x-component.
          Work(iFil(k,2)-1+ip)=-(1-3*Ux1**2)*Rab13i
          Work(iFil(k,2)-1+ip+1)=-(1-3*Ux2**2)*Rab23i
          Work(iFil(k,2)-1+ip+2)=-(1-3*Ux3**2)*Rab33i
          Work(iFil(k,2)-1+nPart*nPol+ip)=Uy1*Ux1*Rab13i*3
          Work(iFil(k,2)-1+nPart*nPol+ip+1)=Uy2*Ux2*Rab23i*3
          Work(iFil(k,2)-1+nPart*nPol+ip+2)=Uy3*Ux3*Rab33i*3
          Work(iFil(k,2)-1+2*nPart*nPol+ip)=Uz1*Ux1*Rab13i*3
          Work(iFil(k,2)-1+2*nPart*nPol+ip+1)=Uz2*Ux2*Rab23i*3
          Work(iFil(k,2)-1+2*nPart*nPol+ip+2)=Uz3*Ux3*Rab33i*3
      !Dipole -- y-component.
          Work(iFil(k,3)-1+ip)=Uy1*Ux1*Rab13i*3
          Work(iFil(k,3)-1+ip+1)=Uy2*Ux2*Rab23i*3
          Work(iFil(k,3)-1+ip+2)=Uy3*Ux3*Rab33i*3
          Work(iFil(k,3)-1+nPart*nPol+ip)=-(1-3*Uy1**2)*Rab13i
          Work(iFil(k,3)-1+nPart*nPol+ip+1)=-(1-3*Uy2**2)*Rab23i
          Work(iFil(k,3)-1+nPart*nPol+ip+2)=-(1-3*Uy3**2)*Rab33i
          Work(iFil(k,3)-1+2*nPart*nPol+ip)=Uz1*Uy1*Rab13i*3
          Work(iFil(k,3)-1+2*nPart*nPol+ip+1)=Uz2*Uy2*Rab23i*3
          Work(iFil(k,3)-1+2*nPart*nPol+ip+2)=Uz3*Uy3*Rab33i*3
      !Dipole -- z-component.
          Work(iFil(k,4)-1+ip)=Uz1*Ux1*Rab13i*3
          Work(iFil(k,4)-1+ip+1)=Uz2*Ux2*Rab23i*3
          Work(iFil(k,4)-1+ip+2)=Uz3*Ux3*Rab33i*3
          Work(iFil(k,4)-1+nPart*nPol+ip)=Uz1*Uy1*Rab13i*3
          Work(iFil(k,4)-1+nPart*nPol+ip+1)=Uz2*Uy2*Rab23i*3
          Work(iFil(k,4)-1+nPart*nPol+ip+2)=Uz3*Uy3*Rab33i*3
          Work(iFil(k,4)-1+2*nPart*nPol+ip)=-(1-3*Uz1**2)*Rab13i
          Work(iFil(k,4)-1+2*nPart*nPol+ip+1)=-(1-3*Uz2**2)*Rab23i
          Work(iFil(k,4)-1+2*nPart*nPol+ip+2)=-(1-3*Uz3**2)*Rab33i
      !Quadrupole -- xx-component.
          Work(iFil(k,5)-1+ip)=(5*Ux1*(Ux1*Ux1-.4))*Rab13i*S1e
          Work(iFil(k,5)-1+ip+1)=(5*Ux2*(Ux2*Ux2-.4))*Rab23i*S2e
          Work(iFil(k,5)-1+ip+2)=(5*Ux3*(Ux3*Ux3-.4))*Rab33i*S3e
          Work(iFil(k,5)-1+nPart*nPol+ip)=5*Uy1*Ux1*Ux1*Rab13i*S1e
          Work(iFil(k,5)-1+nPart*nPol+ip+1)=5*Uy2*Ux2*Ux2*Rab23i*S2e
          Work(iFil(k,5)-1+nPart*nPol+ip+2)=5*Uy3*Ux3*Ux3*Rab33i*S3e
          Work(iFil(k,5)-1+2*nPart*nPol+ip)=5*Uz1*Ux1*Ux1*Rab13i*S1e
          Work(iFil(k,5)-1+2*nPart*nPol+ip+1)=5*Uz2*Ux2*Ux2*Rab23i*S2e
          Work(iFil(k,5)-1+2*nPart*nPol+ip+2)=5*Uz3*Ux3*Ux3*Rab33i*S3e
      !Quadrupole -- yy-component.
          Work(iFil(k,7)-1+ip)=5*Uy1*Uy1*Ux1*Rab13i*S1e
          Work(iFil(k,7)-1+ip+1)=5*Uy2*Uy2*Ux2*Rab23i*S2e
          Work(iFil(k,7)-1+ip+2)=5*Uy3*Uy3*Ux3*Rab33i*S3e
          Work(iFil(k,7)-1+nPart*nPol+ip)=(5*Uy1*(Uy1*Uy1-.4))
     &                                   *Rab13i*S1e
          Work(iFil(k,7)-1+nPart*nPol+ip+1)=(5*Uy2*(Uy2*Uy2-.4))
     &                                   *Rab23i*S2e
          Work(iFil(k,7)-1+nPart*nPol+ip+2)=(5*Uy3*(Uy3*Uy3-.4))
     &                                   *Rab33i*S3e
          Work(iFil(k,7)-1+2*nPart*nPol+ip)=5*Uz1*Uy1*Uy1*Rab13i*S1e
          Work(iFil(k,7)-1+2*nPart*nPol+ip+1)=5*Uz2*Uy2*Uy2*Rab23i*S2e
          Work(iFil(k,7)-1+2*nPart*nPol+ip+2)=5*Uz3*Uy3*Uy3*Rab33i*S3e
      !Quadrupole -- zz-component.
          Work(iFil(k,10)-1+ip)=5*Uz1*Uz1*Ux1*Rab13i*S1e
          Work(iFil(k,10)-1+ip+1)=5*Uz2*Uz2*Ux2*Rab23i*S2e
          Work(iFil(k,10)-1+ip+2)=5*Uz3*Uz3*Ux3*Rab33i*S3e
          Work(iFil(k,10)-1+nPart*nPol+ip)=5*Uz1*Uz1*Uy1*Rab13i*S1e
          Work(iFil(k,10)-1+nPart*nPol+ip+1)=5*Uz2*Uz2*Uy2*Rab23i*S2e
          Work(iFil(k,10)-1+nPart*nPol+ip+2)=5*Uz3*Uz3*Uy3*Rab33i*S3e
          Work(iFil(k,10)-1+2*nPart*nPol+ip)=(5*Uz1*(Uz1*Uz1-.4))
     &                                      *Rab13i*S1e
          Work(iFil(k,10)-1+2*nPart*nPol+ip+1)=(5*Uz2*(Uz2*Uz2-.4))
     &                                      *Rab23i*S2e
          Work(iFil(k,10)-1+2*nPart*nPol+ip+2)=(5*Uz3*(Uz3*Uz3-.4))
     &                                      *Rab33i*S3e
      !Quadrupole -- xy-component.
          Work(iFil(k,6)-1+ip)=(5*Uy1*(Ux1*Ux1-.2))*Rab13i*S1e
          Work(iFil(k,6)-1+ip+1)=(5*Uy2*(Ux2*Ux2-.2))*Rab23i*S2e
          Work(iFil(k,6)-1+ip+2)=(5*Uy3*(Ux3*Ux3-.2))*Rab33i*S3e
          Work(iFil(k,6)-1+nPart*nPol+ip)=(5*Ux1*(Uy1*Uy1-.2))
     &                                   *Rab13i*S1e
          Work(iFil(k,6)-1+nPart*nPol+ip+1)=(5*Ux2*(Uy2*Uy2-.2))
     &                                   *Rab23i*S2e
          Work(iFil(k,6)-1+nPart*nPol+ip+2)=(5*Ux3*(Uy3*Uy3-.2))
     &                                   *Rab33i*S3e
          Work(iFil(k,6)-1+2*nPart*nPol+ip)=5*Uz1*Uy1*Ux1*Rab13i*S1e
          Work(iFil(k,6)-1+2*nPart*nPol+ip+1)=5*Uz2*Uy2*Ux2*Rab23i*S2e
          Work(iFil(k,6)-1+2*nPart*nPol+ip+2)=5*Uz3*Uy3*Ux3*Rab33i*S3e
      !Quadrupole -- xz-component.
          Work(iFil(k,8)-1+ip)=(5*Uz1*(Ux1*Ux1-.2))*Rab13i*S1e
          Work(iFil(k,8)-1+ip+1)=(5*Uz2*(Ux2*Ux2-.2))*Rab23i*S2e
          Work(iFil(k,8)-1+ip+2)=(5*Uz3*(Ux3*Ux3-.2))*Rab33i*S3e
          Work(iFil(k,8)-1+nPart*nPol+ip)=5*Uz1*Uy1*Ux1*Rab13i*S1e
          Work(iFil(k,8)-1+nPart*nPol+ip+1)=5*Uz2*Uy2*Ux2*Rab23i*S2e
          Work(iFil(k,8)-1+nPart*nPol+ip+2)=5*Uz3*Uy3*Ux3*Rab33i*S3e
          Work(iFil(k,8)-1+2*nPart*nPol+ip)=(5*Ux1*(Uz1*Uz1-.2))
     &                                     *Rab13i*S1e
          Work(iFil(k,8)-1+2*nPart*nPol+ip+1)=(5*Ux2*(Uz2*Uz2-.2))
     &                                     *Rab23i*S2e
          Work(iFil(k,8)-1+2*nPart*nPol+ip+2)=(5*Ux3*(Uz3*Uz3-.2))
     &                                     *Rab33i*S3e
      !Quadrupole -- yz-component.
          Work(iFil(k,9)-1+ip)=5*Uz1*Uy1*Ux1*Rab13i*S1e
          Work(iFil(k,9)-1+ip+1)=5*Uz2*Uy2*Ux2*Rab23i*S2e
          Work(iFil(k,9)-1+ip+2)=5*Uz3*Uy3*Ux3*Rab33i*S3e
          Work(iFil(k,9)-1+nPart*nPol+ip)=(5*Uz1*(Uy1*Uy1-.2))
     &                                   *Rab13i*S1e
          Work(iFil(k,9)-1+nPart*nPol+ip+1)=(5*Uz2*(Uy2*Uy2-.2))
     &                                   *Rab23i*S2e
          Work(iFil(k,9)-1+nPart*nPol+ip+2)=(5*Uz3*(Uy3*Uy3-.2))
     &                                   *Rab33i*S3e
          Work(iFil(k,9)-1+2*nPart*nPol+ip)=(5*Uy1*(Uz1*Uz1-.2))
     &                                   *Rab13i*S1e
          Work(iFil(k,9)-1+2*nPart*nPol+ip+1)=(5*Uy2*(Uz2*Uz2-.2))
     &                                   *Rab23i*S2e
          Work(iFil(k,9)-1+2*nPart*nPol+ip+2)=(5*Uy3*(Uz3*Uz3-.2))
     &                                   *Rab33i*S3e
*----------------------------------------------------------------------*
* If damping of the field is requested, then do it.                    *
*----------------------------------------------------------------------*
          If(FieldDamp) then
            Do 620, ijhr=1,10
              Do 621, jjhr=0,2
                Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip)=
     &          Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip)
     &          *(1-exp(CAFieldG*rg1))**CFexp
                Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip+1)=
     &          Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip+1)
     &          *(1-exp(CBFieldG*rg2))**CFexp
                Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip+2)=
     &          Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip+2)
     &          *(1-exp(CBFieldG*rg3))**CFexp
621           Continue
620         Continue
          Endif
602     Continue
601   Continue

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine INFO_CONF_LIST(NCONF_PER_OPEN,MAXOP,NEL,LENGTH_LIST,NCONF_TOT,IB_REO,IB_OCC)
! Info on configuration list form NCONF_PER_OPEN
!
! IB_REO : Offset for configuration  with given number of
!          open orbitals in of configuration reordering
! IB_OCC : Offset for configuration  with given number of
!          open orbitals in list of configuration occupations
!
! Jeppe Olsen, November 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: MAXOP, NCONF_PER_OPEN(MAXOP+1), NEL
integer(kind=iwp), intent(out) :: LENGTH_LIST, NCONF_TOT, IB_REO(MAXOP+1), IB_OCC(MAXOP+1)
integer(kind=iwp) :: JB_OCC, JB_REO, NOCOB, NOPEN

JB_REO = 1
JB_OCC = 1
!write(u6,*) ' MAXOP, NEL = ',MAXOP,NEL
do NOPEN=0,MAXOP
  IB_REO(NOPEN+1) = JB_REO
  IB_OCC(NOPEN+1) = JB_OCC
  if (mod(NEL-NOPEN,2) == 0) then
    NOCOB = NOPEN+(NEL-NOPEN)/2
    JB_OCC = JB_OCC+NOCOB*NCONF_PER_OPEN(NOPEN+1)
    JB_REO = JB_REO+NCONF_PER_OPEN(NOPEN+1)
  end if
end do

LENGTH_LIST = JB_OCC-1
NCONF_TOT = JB_REO-1

#ifdef _DEBUGPRINT_
write(u6,*) ' NCONF_PER_OPEN list'
call IWRTMA(NCONF_PER_OPEN,1,MAXOP+1,1,MAXOP+1)
write(u6,*) ' Length of configuration list :',LENGTH_LIST
write(u6,*) ' Total number of configurations : ',NCONF_TOT
#endif

end subroutine INFO_CONF_LIST

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine ciscale2_cvb(cvec,scale,iscf,cscf)
      implicit real*8(a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension cvec(*)

      ivec=nint(cvec(1))
      iscf=0
      cscf=zero
      iformat=iform_ci(ivec)
      if(iformat.eq.0)then
        do 100 idet=1,ndet
        work(idet+iaddr_ci(ivec)-1)=scale*work(idet+iaddr_ci(ivec)-1)
        if(abs(work(idet+iaddr_ci(ivec)-1)).gt.p8)then
          iscf=idet
          cscf=work(idet+iaddr_ci(ivec)-1)
        endif
100     continue
      else
        write(6,*)' Unsupported format in CISCALE2 :',iformat
        call abend_cvb()
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Hess_Vec(nAtoms,Hess,EVec,nDim)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nDim
real(kind=wp), intent(inout) :: Hess(nTri_Elem(3*nAtoms))
real(kind=wp), intent(out) :: EVec(nDim,nDim)
integer(kind=iwp) :: iElem, iQ, nQ
real(kind=wp) :: rZ
real(kind=wp), parameter :: ThrD = 1.0e-10_wp

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the eigenvalues and the eigenvectors of the Hessian

!#define _DEBUGPRINT_

! Set up a unit matrix

nQ = nDim
call unitmat(EVec,nQ)

! Compute eigenvalues and eigenvectors

call NIDiag_new(Hess,EVec,nQ,nQ)
call JacOrd(Hess,EVec,nQ,nQ)

do iQ=1,nQ
  ! Fix standard direction.
  rZ = Zero
  do iElem=1,nQ
    if (abs(EVec(iElem,iQ)) > abs(rZ)+ThrD) rZ = EVec(iElem,iQ)
  end do
  if (rZ < Zero) EVec(:,iQ) = -EVec(:,iQ)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt(' Eigenvectors','(12f6.2)',EVec,nDim,nDim)
call TriPrt(' Eigenvalues','(12ES9.2)',Hess,nDim)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Hess_Vec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Freqanal(nDeg,nrvec,H,converged,ELEC,iel,elout,ldisp,Lu_10)

use Index_Functions, only: nTri_Elem
use input_mclr, only: ChIrr, nDisp, nSRot, nSym, nUserPT, UserP, UserT
use temperatures, only: DefTemp
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Five
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nDeg(*), nrvec(*), iel(3), ldisp(nsym), Lu_10
real(kind=wp), intent(in) :: H(*), elec(*)
logical(kind=iwp), intent(in) :: converged(8)
real(kind=wp), intent(_OUT_) :: elout(*)
integer(kind=iwp) :: i, i1, i3, iCtl, ii, iNeg, ipNx, iSym, iT, ix, j, jpNx, jx, k, kk, ll, lModes, lnm_molpac, nEig, nModes, nx
real(kind=wp) :: Fact, rNorm, Tmp
logical(kind=iwp) :: Do_Molden
real(kind=wp), allocatable :: EVal(:), EVal2(:), EVec(:), EVec2(:,:), Intens(:), NMod(:), RedMas(:), Temp(:), Tmp3(:)
integer(kind=iwp), external :: IsFreeUnit

call mma_allocate(NMod,nDisp**2,Label='NMod')
call mma_allocate(EVec,nDisp**2,Label='EVec')
call mma_allocate(EVec2,2,nDisp**2,Label='EVec2')
call mma_allocate(EVal,nDisp,Label='EVal')
call mma_allocate(Intens,nDisp*2,Label='Intens')
call mma_allocate(RedMas,nDisp,Label='RedMas')
ipNx = 1
nModes = 0
lModes = 0

write(u6,*)
write(u6,*) '     ************************************'
write(u6,*) '     *                                  *'
write(u6,*) '     * Harmonic frequencies in cm-1     *'
write(u6,*) '     * Intensities in km/mole           *'
write(u6,*) '     *                                  *'
write(u6,*) '     * No correction due to curvilinear *'
write(u6,*) '     * representations has been done    *'
write(u6,*) '     *                                  *'
write(u6,*) '     ************************************'
write(u6,*)
i1 = 1
i3 = 1
j = 0
ii = 1
write(Lu_10,'(A)') '*PERTURBATIONS'
write(Lu_10,*) ldisp
write(Lu_10,'(A)') '*BEGIN NORMAL MODES'
write(Lu_10,'(A)') '*NOTICE THAT THEY ARE SYMMETRY ADAPTED'
write(Lu_10,'(A)') '*USING ORTHOGONAL TRANSFORMATIONS'
write(Lu_10,'(A)') '*AND NOT ALASKA TYPE'

! open normal mode file for "normal mode molpac" ! yma
lnm_molpac = 60
lnm_molpac = isFreeUnit(lnm_molpac)
call Molcas_Open(lnm_molpac,'normal_modes_molpac')

Do_Molden = .true.
do iSym=1,nSym
  nX = ldisp(isym)
  if (nX /= 0) then
    write(u6,*)
    write(u6,*) '   Symmetry ',chirr(isym)
    write(u6,*) '  =============='
    write(u6,*)

    if (converged(isym)) then
      call mma_allocate(EVal2,2*nX,Label='EVal2')
      call mma_allocate(Tmp3,nX**2,Label='Tmp3')
      call FREQ(nX,H(i3),nDeg(i1),nrvec(i1),Tmp3,EVec2,EVal2,RedMas,iNeg)
      EVec(:) = EVec2(1,:)
      EVal(i1:i1+nX-1) = EVal2(1:nX)
      call mma_deallocate(EVal2)
      call mma_deallocate(Tmp3)

      iCtl = 0
      ll = 0
      kk = j+1
      do i=1,3
        if (iel(i) == isym) then
          iCtl = 1
          ll = ll+1
          do k=1,nx
            j = j+1
            tmp = Zero
            do it=0,nx-1
              Fact = sqrt(real(nDeg(i1+it),kind=wp))
              tmp = tmp+EVec(1+(k-1)*nx+it)*elec(ii+it)*Fact
            end do
            elout(j) = tmp
          end do
          ii = ii+nx
        end if
      end do
      write(Lu_10,'(A,I1)') '*NORMAL MODES SYMMETRY: ',isym

      ! Save normal modes for later generation of Molden input.

      NMod(ipNx:ipNx+nX**2-1) = EVec(1:nX**2)
      jpNx = ipNx

      do iX=1,nX

        ! Transform from mass-weighted cartesian to cartesian for Molden.

        rNorm = Zero
        do jX=0,nX-1
          Fact = sqrt(real(nDeg(jX+1),kind=wp))
          NMod(ipNx+jX) = NMod(ipNx+jX)/Fact
          rNorm = rNorm+real(nDeg(jX+1),kind=wp)*NMod(ipNx+jX)**2
        end do
        NMod(ipNx:ipNx+nX-1) = NMod(ipNx:ipNx+nX-1)/sqrt(rNorm)

        ipNx = ipNx+nX
        lModes = lModes+nX
      end do
      nModes = nModes+nX
      EVec(1:nX**2) = NMod(jpNx:jpNx+nX**2-1)
      call GF_Print(EVal(i1),EVec,elout(kk),ll,nX,nX,iCtl,Intens(i1),RedMas,Lu_10,i1-1)
    else
      write(u6,*)
      write(u6,*) '     NOT CONVERGED'
      write(u6,*)
      do i=1,3
        if (iel(i) == isym) then
          j = j+1
          ii = ii+nx
          elout(j) = -99999999.0_wp
        end if
      end do
      Do_Molden = .false.
    end if
  end if
  i3 = i3+nTri_Elem(nx)
  i1 = i1+nx
end do
nEig = i1-1

! close the normal mode file
close(lnm_molpac) ! This is for normal_modes_molpac -- yma
!call NM_MOPAC_SNF(nsym,ldisp,natoms) ! f90 not support ....

if (nsym == 1) call Print_Mode_Components(NMod,EVal,nModes,lModes,lDisp)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(Temp,nEig,Label='Temp')
Temp(:) = Eval(1:nEig)

! For verification purpose we skip frequencies close to zero.

do i=1,nEig
  if (abs(Temp(i)) < Five) Temp(i) = Zero
end do
call Add_Info('Harm_Freq',Temp,nEig,1)
call mma_deallocate(Temp)

do i=1,nEig
  if (abs(Intens(i)) < One) Intens(i) = Zero
end do
call Add_Info('IR_Intensities',Intens,nEig,1)
!                                                                      *
!***********************************************************************
!                                                                      *
write(Lu_10,'(A)') '*END NORMAL MODES'

! Calculate thermodynamic properties----------

if ((nUserPT == 0) .and. (nsRot == 0)) then
  UserP = One
  nUserPT = size(DefTemp)
  UserT(1:nUserPT) = DefTemp(1:nUserPT)
  !call ThermoData(EVal,nEig)
end if
call Thermo_Driver(UserT,UserP,nUserPT,nsRot,EVal,nEig,.false.)

! Write stuff on Molden input file

if (Do_Molden) call Freq_Molden(EVal,nModes,NMod,lModes,nSym,Intens,lDisp,RedMas)

call mma_deallocate(NMod)
call mma_deallocate(evec)
call mma_deallocate(evec2)
call mma_deallocate(eval)
call mma_deallocate(intens)
call mma_deallocate(redmas)

end subroutine Freqanal

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine torque(Nss,NM,AngPoints,EM,eso,dipm,sm,zJ,thrs,mem,
     &                  m_paranoid,smagn,H_torq,T_torq,ma,dbg)
      Implicit None
      Integer, Parameter            :: wp=kind(0.d0)
#include "cntrl_sa.fh"
#include "mgrid.fh"
#include "stdalloc.fh"
      Integer, intent(in)          :: nss, nm
      Integer, intent(in)          :: AngPoints
      Integer, intent(in)          :: mem
      Logical, intent(in)          :: smagn
      Logical, intent(in)          :: m_paranoid
c ab initio data:
!     exchange energies printed out in the previous part
      Real(kind=8), intent(in)    :: ESO(nss)
      Real(kind=8), intent(in)    :: EM, zJ, thrs
      Real(kind=8), intent(in)    :: H_torq, T_torq
      Real(kind=8), intent(in)    :: ma(3,3) ! main magnetic axes
      Complex(kind=8), intent(in) :: DIPM(3,nss,nss)
      Complex(kind=8), intent(in) ::   SM(3,nss,nss)

! local data:
c magnetic field strength and orientation data:
      Integer       :: nPlanes
      Parameter (nPlanes=1)
!      Real(kind=8) :: dlth
      Real(kind=8), allocatable :: W(:)
!                                   W(NM) ! Zeeman exchange energies
      Real(kind=8)              :: ZT(1)!
!                                   ZT ! total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ST(:)
!                                   ST(3) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT(:) ! MT(3) ! total magnetisation
      Real(kind=8), allocatable :: dX(:) ! dX(AngPoints)
      Real(kind=8), allocatable :: dY(:) ! dY(AngPoints)
      Real(kind=8), allocatable :: dZ(:) ! dZ(AngPoints)
      Real(kind=8), allocatable :: Ang(:)  ! Ang(AngPoints)
      Complex(kind=8), allocatable :: M(:,:,:)
      Complex(kind=8), allocatable :: S(:,:,:)
c magnetic torque
!     Real(kind=8), allocatable :: tx(:,:) ! tx(nPlanes,AngPoints,nH,nTempMagn) ! magnetization torque
      Real(kind=8), allocatable :: ty(:)
!                                   ty(nPlanes,AngPoints,nH,nTempMagn) ! magnetization torque
!     Real(kind=8), allocatable :: tz(:,:) ! tz(nPlanes,AngPoints,nH,nTempMagn) ! magnetization torque
c magnetic and spin moments (i.e. the BIG matrices):
      Character(len=99):: STLNE1, STLNE2
      Real(kind=8)    :: g(3),mg(3,3)!,ma_inv(3,3)!,det
      Real(kind=8)    :: AngStep,AngRad,pi
      Logical          :: DBG
      Integer          :: IM,I,J,mem_local,RtoB,CtoB,nT_torq

c      Boltz_k=0.6950356000_wp   !   in cm^-1*K-1
c      mu_Bohr=0.4668643740_wp   !   in cm-1*T-1
c      cm3tomB=0.5584938904_wp   !   in cm3 * mol-1 * T
      pi=3.1415926535897932384626433832795028841971_wp

      Write(6,*)
      Write(6,'(100A)') (('%'),J=1,96)
      Write(6,'(20X,A)')
     & 'ANGULAR DEPENDENCE OF THE MAGNETIZATION TORQUE'
      Write(6,'(100A)') (('%'),J=1,96)
      Write(6,*)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c      Write(6,'(2X,A,i3,A)') 'Magnetization torque is '//
c     & 'calculated for the ',NH,' field points, in the field domain:'
c      Write(6,'(2X,F4.1,1x,a,1X,F4.1,a,10(F6.3,a))') HMIN,'--',HMAX,
c     & ' T., at the following temperatures:',
c     & (TempMagn(l),' K.;',l=1,nTempMagn)
c      Do i=11,nTempMagn,10
c        j=MIN(nTempMagn,i+9)
c        Write(6,'(17x,10(F9.3,A))') (TempMagn(k),' K.;',k=i,j)
c      End Do
      Write(6,'(2X,A,F10.5,A,F10.5)') 'Magnetization torque is '//
     & 'calculated for one field point,',H_torq,
     & ' T., at the following temperature:', T_torq

      Write(6,'(2x,A,i3,A)')
     & 'Angular dependence of the magnetization torque '//
     & 'is computed for ',AngPoints,' angular points distributed'
      Write(6,'(2x,A)') 'in the domain 0-180 deg.'
      Write(6,'(2X,A)') 'The cut-off energy for the '//
     & 'exact diagonalization of the Zeeman Hamiltonian is:'
      Write(6,'(2x,a,F15.9,A)') 'E = ',EM ,' cm(-1).'
      If(NM.lt.10) Then
        Write(6,'(2X,A,i2,a)') 'The exact diagonalization of the '//
     &       'Zeeman Hamiltonian included ',NM,' exchange states.'
      Else If( (NM.ge.10) .AND. (NM.lt.100) ) Then
        Write(6,'(2X,A,i3,a)') 'The exact diagonalization of the '//
     &       'Zeeman Hamiltonian included ',NM,' exchange states.'
      Else If( (NM.ge.100) .AND. (NM.lt.1000) ) Then
        Write(6,'(2X,A,i4,a)') 'The exact diagonalization of the '//
     &       'Zeeman Hamiltonian included ',NM,' exchange states.'
      Else If( (NM.ge.1000) .AND. (NM.lt.10000) ) Then
        Write(6,'(2X,A,i5,a)') 'The exact diagonalization of the '//
     &       'Zeeman Hamiltonian included ',NM,' exchange states.'
      End If
      nT_torq=1

c      If (dbg) Then
        Do i=1,3
           Write(6,*) (ma(j,i),j=1,3)
        End Do
c      End If
!-----------------------------------------------------------------------
! Allocate memory for this computation:
      mem_local=0
      RtoB=8
      CtoB=16
      ! Zeeman exchange energy spectrum
      Call mma_allocate(W,nM,'W')
      Call dcopy_(nM,[0.0_wp],0,W,1)
      mem_local=mem_local+nM*RtoB

      Call mma_allocate(ST,3,'ST')
      Call dcopy_(3,[0.0_wp],0,ST,1)
      mem_local=mem_local+3*RtoB

      Call mma_allocate(MT,3,'MT')
      Call dcopy_(3,[0.0_wp],0,MT,1)
      mem_local=mem_local+3*RtoB

      Call mma_allocate(dX,AngPoints,'dX')
      Call mma_allocate(dY,AngPoints,'dY')
      Call mma_allocate(dZ,AngPoints,'dZ')
      Call dcopy_(AngPoints,[0.0_wp],0,dX,1)
      Call dcopy_(AngPoints,[0.0_wp],0,dY,1)
      Call dcopy_(AngPoints,[0.0_wp],0,dZ,1)
      mem_local=mem_local+3*AngPoints*RtoB

      Call mma_allocate(Ang,AngPoints,'Ang')
      Call dcopy_(AngPoints,[0.0_wp],0,Ang,1)
      mem_local=mem_local+AngPoints*RtoB

      Call mma_allocate(ty,AngPoints,'ty')
      Call dcopy_(AngPoints,[0.0_wp],0,ty,1)
      mem_local=mem_local+AngPoints*RtoB

      Call mma_allocate(M,3,nss,nss,'Mrot')
      Call mma_allocate(S,3,nss,nss,'Srot')
      Call zcopy_(3*nss*nss,[(0.0_wp,0.0_wp)],0,M,1)
      Call zcopy_(3*nss*nss,[(0.0_wp,0.0_wp)],0,S,1)
      mem_local=mem_local+2*3*nss*nss*CtoB


      If(dbg) Write(6,*) 'TORQ:  memory allocated (local):'
      If(dbg) Write(6,*) 'mem_local=', mem_local
      If(dbg) Write(6,*) 'TORQ:  memory allocated (total):'
      If(dbg) Write(6,*) 'mem_total=', mem+mem_local
!-----------------------------------------------------------------------
      ! rotate the moments to the coordiante system of
      ! the ground state
      ! ma_inv=0.0_wp
      ! Call REVERSE(ma,ma_inv,DET)
      Call rotmom2( DIPM, nss, ma, M )
      Call rotmom2(   SM, nss, ma, S )

      g=0.0_wp
      mg=0.0_wp
      Call atens( M(1:3,1:2,1:2), 2, g, mg, 2)
!-----------------------------------------------------------------------
      Call dcopy_(AngPoints,[0.0_wp],0,dX,1)
      Call dcopy_(AngPoints,[0.0_wp],0,dY,1)
      Call dcopy_(AngPoints,[0.0_wp],0,dZ,1)
      Call dcopy_(AngPoints,[0.0_wp],0,Ang,1)
      !Call hdir2(AngPoints,2,dX(:),dY(:),dZ(:),Ang,2)
      AngStep=0.0_wp
      AngRad =0.0_wp
      AngStep=360.0_wp/dble(AngPoints-1)
      dX(1)=1.0_wp
      dZ(1)=0.0_wp
      Do i=1,AngPoints
        AngRad=dble(i-1)*AngStep*Pi/180.0_wp!+122.625_wp*Pi/180.0_wp
        Ang(i)=dble(i-1)*AngStep
         dX(i)=cos(AngRad)
         dZ(i)=sin(AngRad)
      End Do
      If(dbg) Then
!       Write(6,'(A,I5)') 'Angular grid for Magnetization Torque, '//
!    &                    'Cartesian Component =',L
        Write(6,'(2x,A,4x,A,5x,3(10X,A,10x))') 'Nr.','Angle','X','Y','Z'
        Do i=1,AngPoints
          Write(6,'(I4,F10.3,3x,3F21.14)') i,Ang(i),dX(i),dY(i),dZ(i)
        End Do
      End If
!-----------------------------------------------------------------------


      Do IM=1,AngPoints
         WRITE(STLNE1,'(A   )') 'SINGLE_ANISO:  torque:'
         WRITE(STLNE2,'(A,I3)') ' Magnetization at point ',IM
         Call StatusLine( trim(STLNE1), trim(STLNE2) )
         ZT=0.0_wp
         Call dcopy_(nM,[0.0_wp],0,W,1)
         Call dcopy_(3,[0.0_wp],0,MT,1)
         Call dcopy_(3,[0.0_wp],0,ST,1)
c exchange magnetization:
         Call MAGN( nss, NM, dX(iM), dY(iM), dZ(iM),
     &              H_torq,
     &              eso, zJ, THRS,
     &              M, !DIPM,
     &              S, !  SM,
     &              nT_torq, [T_torq], smagn,
     &              W,
     &              ZT,
     &              ST,
     &              MT, m_paranoid , DBG )
        If(dbg) Write(6,'(A,3F18.10)') 'TORQ: MT=',MT(1),MT(2),MT(3)

       !  tx(iPl,iM) = ( MT(2)*dZ(iM) - MT(3)*dY(iM) ) *H_torq
         ty(iM) = ( MT(3)*dX(iM) - MT(1)*dZ(iM) ) * H_torq
       !  tz(iPl,iM) = ( MT(1)*dY(iM) - MT(2)*dX(iM) ) *H_torq
      End Do ! iM
c -------------------------------------------------------------------
C   WRITING SOME OF THE OUTPUT....
C -------------------------------------------------------------------
      Write(6,*)
      Write(6,'(25X,A)') 'ANGULAR DEPENDENCE OF THE MAGNETIZATION '//
     &                   'TORQUE'
      Write(6,'(30X,A)') '(Units of torque: [energy, cm-1])'
      Write(6,*)

        Write(6,'(5x,A)') 'Orientation of the applied magnetic'//
     & ' field employed:'
        Write(6,'(10A)') '--------|','---------------------------|'

        Write(6,'(2x,A,10x,A)') 'Angle |',
     &                             'rotation in the XZ plane          |'
        Write(6,'(10A)') '--------|',
     &             '--- proj X ---|','--- proj Y ---|','--- proj Z ---|'
         Do iM=1,AngPoints
           Write(6,'(F7.3,1x,A,F13.10,1x,A,F13.10,1x,A,F13.10,1x,'//
     &               'A,F20.14,1x,A)')
     &        Ang(iM),'|',dX(iM),' ',dY(iM),' ',dZ(iM),'|',ty(iM),'|'
           End Do
        Write(6,'(10A)') '--------|','---------------------------|'

        Write(6,*)
        Write(6,'(10A)') '--------|','---------------------------|'
        Write(6,'(A,F9.4,A)') 'Magnetic field strength = ',H_torq,
     &                        ' Tesla'
        Write(6,'(12x,A,F9.4,A)') 'Temperature = ',T_torq,' Kelvin'
        Write(6,'(10A)') '--------|','---------------------------|'

        Write(6,'(2x,A,3(10x,A))') 'Angle |',
     &                             'rotation in the XZ plane          |'
        Write(6,'(10A)') '--------|', '-- torque along Y --|'
         Do iM=1,AngPoints
            Write(6,'(F7.3,1x,A,E18.10)') Ang(iM),'|',ty(iM)
         End Do
        Write(6,'(10A)') '--------|','---------------------------|'

!-----------------------------------------------------------------------
! deallocate memory for this computation:
      Call mma_deallocate(W)
      Call mma_deallocate(ST)
      Call mma_deallocate(MT)
      Call mma_deallocate(dX)
      Call mma_deallocate(dY)
      Call mma_deallocate(dZ)
      Call mma_deallocate(Ang)
      Call mma_deallocate(ty)
      Call mma_deallocate(m)
      Call mma_deallocate(s)

      If(dbg) Write(6,*) 'TORQ: allocated memory was sucessfully '//
     &                   'deallocated'

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Rys33(Arg,nArg,Root,Weight,iPntr,nPntr,
     &                 x0,nMax,R6,R5,R4,R3,R2,R1,R0,
     &                         W6,W5,W4,W3,W2,W1,W0,ddx,
     &                 HerW,HerR2,TMax)
************************************************************************
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             September '90                                            *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Arg(nArg), Root(3,nArg), Weight(3,nArg), x0(nMax),
     &       R6(nMax,3), R5(nMax,3),
     &       R4(nMax,3), R3(nMax,3), R2(nMax,3), R1(nMax,3), R0(nMax,3),
     &       W6(nMax,3), W5(nMax,3),
     &       W4(nMax,3), W3(nMax,3), W2(nMax,3), W1(nMax,3), W0(nMax,3),
     &       HerW(3), HerR2(3)
      Integer iPntr(nPntr)
*
      xdInv=One/ddx
      dddx=ddx/10d0 + ddx
      Do iArg = 1, nArg
         If (Arg(iArg).lt.TMax) Then
            n = iPntr(Int((Arg(iArg)+dddx)*xdInv))
            z = Arg(iArg) - x0(n)
            r = (((((R6(n,1)*z+R5(n,1))*z+R4(n,1))*z+R3(n,1))*z+R2(n,1))
     &          *z+R1(n,1))*z+R0(n,1)
            Root(1,iArg)= r
            r = (((((R6(n,2)*z+R5(n,2))*z+R4(n,2))*z+R3(n,2))*z+R2(n,2))
     &          *z+R1(n,2))*z+R0(n,2)
            Root(2,iArg)= r
            r = (((((R6(n,3)*z+R5(n,3))*z+R4(n,3))*z+R3(n,3))*z+R2(n,3))
     &          *z+R1(n,3))*z+R0(n,3)
            Root(3,iArg)= r
            r = (((((W6(n,1)*z+W5(n,1))*z+W4(n,1))*z+W3(n,1))*z+W2(n,1))
     &          *z+W1(n,1))*z+W0(n,1)
            Weight(1,iArg) = r
            r = (((((W6(n,2)*z+W5(n,2))*z+W4(n,2))*z+W3(n,2))*z+W2(n,2))
     &          *z+W1(n,2))*z+W0(n,2)
            Weight(2,iArg) = r
            r = (((((W6(n,3)*z+W5(n,3))*z+W4(n,3))*z+W3(n,3))*z+W2(n,3))
     &          *z+W1(n,3))*z+W0(n,3)
            Weight(3,iArg) = r
         Else
            ai = 1.0D0/Arg(iArg)
            si = Sqrt(ai)
            Root(1,iArg) = HerR2(1)*ai
            Root(2,iArg) = HerR2(2)*ai
            Root(3,iArg) = HerR2(3)*ai
            Weight(1,iArg) = HerW(1)*si
            Weight(2,iArg) = HerW(2)*si
            Weight(3,iArg) = HerW(3)*si
         End If
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADVICE_SIGMA(IAOCC,IBOCC,JAOCC,JBOCC,LADVICE)
! Advice Sigma routine about best route to take
!
! LADVICE : ADVICE given (short, an integer !!)
!
! For ITERM = 1 :
!   LADVICE = 1 : Business as usual, no transpose of matrix
!                 (resolution on alpha strings, direct exc on beta)
!   LADVICE = 2 = Transpose matrices
!                 (resolution on beta strings, direct exc on alpha)
! (SVC: one call to this routine and ITERM is one, so I removed that
! argument and skipped the checking. Also, the arguments are all scalar,
! so that has been hard-coded now too)
!
! Jeppe Olsen, Tirstrup Airport, Jan 12, 98

use lucia_data, only: IADVICE, IPHGAS, MNHL, NGAS, NOBPT
use Constants, only: One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: IAOCC(*), IBOCC(*), JAOCC(*), JBOCC(*)
integer(kind=iwp), intent(out) :: LADVICE
integer(kind=iwp) :: IGAS, IPHMODI, ITP(16), JTP(16), KHOLEA, KHOLEB, KTP(16), LHOLEA, LHOLEB, LLADVICE, LTP(16), NIJTYP, NKLTYP
real(kind=wp) :: XCJKAJB, XCLJAKB, XFLOPA, XFLOPB, XNIJSX, XNIOB, XNJEL, XNJOB, XNKLSX, XNKOB, XNLEL, XNLOB

! sigma(i,Ka,Ib) = sum(i,kl)<Ib!Eb_kl!Jb>(ij!kl)C(j,Ka,Jb)
!
! Number of ops : Number of sx(kl) N_i*N_j_dimension of C(j,Ka,Jb)
! No absolute calc of flops is made, only a relative measure
!
! Single excitations connecting the two types

!    SXTYP2_GAS(NSXTYP,ITP,JTP,NGAS,ILTP,IRTP,IPHGAS)
call SXTYP2_GAS(NIJTYP,ITP,JTP,NGAS,IAOCC,JAOCC,IPHGAS)
call SXTYP2_GAS(NKLTYP,KTP,LTP,NGAS,IBOCC,JBOCC,IPHGAS)
!write(u6,*) 'NIJTYP, NKLTYP',NIJTYP,NKLTYP
! P-h modifications (I cannot predict these at the moment
if ((NIJTYP >= 1) .and. (NKLTYP >= 1)) then

  if (((IPHGAS(ITP(1)) == 2) .and. (IPHGAS(JTP(1)) == 2)) .or. ((IPHGAS(KTP(1)) == 2) .and. (IPHGAS(LTP(1)) == 2))) then
    IPHMODI = 1
  else
    IPHMODI = 0
  end if
else
  IPHMODI = 0
end if

if ((IPHMODI == 1) .or. (NIJTYP /= 1) .or. (NKLTYP /= 1) .or. (IADVICE == 0)) then
  ! Several connections, i.e. the alpha or the beta blocks are identical,
  ! or ph modifications
  ! just continue
  LADVICE = 1
else
  ! ======================================
  ! Index for flops along C(j,Ka,Jb) route
  ! ======================================
  ! Dim of C(j,Ka,Jb) relative to C(Ja,Jb)
  ! going from Ja to  Ka reduces occ by one elec, changes dim by n/(N-n+1)
  XNJOB = real(NOBPT(JTP(1)),kind=wp)
  XNJEL = real(JAOCC(JTP(1)),kind=wp)
  XCJKAJB = XNJOB*XNJEL/(XNJOB-XNJEL+One)
  ! Number of kl excitations per beta string :
  XNKLSX = real((NOBPT(KTP(1))-JBOCC(KTP(1)))*JBOCC(LTP(1)),kind=wp)
  ! Number of ops (relative to dim of C)
  XNIOB = real(NOBPT(ITP(1)),kind=wp)
  XFLOPA = XCJKAJB*XNKLSX*XNIOB
  ! ======================================
  ! Index for flops along C(l,Ja,Kb) route
  ! ======================================
  ! Dim of C(l,Ja,Kb) relative to C(Ja,Jb)
  XNLOB = real(NOBPT(LTP(1)),kind=wp)
  XNLEL = real(JBOCC(LTP(1)),kind=wp)
  XCLJAKB = XNLOB*XNLEL/(XNLOB-XNLEL+One)
  ! Number of ij excitations per alpha string :
  XNIJSX = real((NOBPT(ITP(1))-JAOCC(ITP(1)))*JAOCC(JTP(1)),kind=wp)
  ! Number of ops (relative to dim of C)
  XNKOB = real(NOBPT(KTP(1)),kind=wp)
  XFLOPB = XCLJAKB*XNIJSX*XNKOB
  ! Switch to second route if atleast 20 percent less work
  if (XFLOPB <= 0.8_wp*XFLOPA) then
    LADVICE = 2
  else
    LADVICE = 1
  end if
  ! Well, an additional consideration :
  ! If the C block involes the smallest allowed number of elecs in hole space,
  ! and the annihilation is in hole space
  ! then we do the annihilation in the space with the smallest number of
  ! hole electrons.
  LHOLEA = 0
  LHOLEB = 0
  do IGAS=1,NGAS
    if (IPHGAS(IGAS) == 2) then
      LHOLEA = LHOLEA+JAOCC(IGAS)
      LHOLEB = LHOLEB+JBOCC(IGAS)
    end if
  end do

  if ((LHOLEA+LHOLEB == MNHL) .and. ((IPHGAS(JTP(1)) == 2) .or. (IPHGAS(LTP(1)) == 2))) then

    if (IPHGAS(JTP(1)) == 2) then
      KHOLEA = LHOLEA-1
      KHOLEB = LHOLEB
    else
      KHOLEA = LHOLEA
      KHOLEB = LHOLEB-1
    end if

    if (KHOLEA == KHOLEB) then
      LLADVICE = LADVICE
    else if (KHOLEA < KHOLEB) then
      LLADVICE = 1
    else
      LLADVICE = 2
    end if
#   ifdef _DEBUGPRINT_
    if (LADVICE /= LLADVICE) then
      write(u6,*) ' Advice changed by hole considetions'
      write(u6,*) ' LADVICE, LLADVICE',LADVICE,LLADVICE
    end if
#   endif
    LADVICE = LLADVICE
  end if

# ifdef _DEBUGPRINT_
  write(u6,*) ' ADVICE active'
  write(u6,*) ' IAOCC JAOCC IBOCC JBOCC'
  call IWRTMA(IAOCC,1,NGAS,1,NGAS)
  call IWRTMA(JAOCC,1,NGAS,1,NGAS)
  call IWRTMA(IBOCC,1,NGAS,1,NGAS)
  call IWRTMA(JBOCC,1,NGAS,1,NGAS)
  write(u6,*) ' ITP JTP KTP LTP ',ITP(1),JTP(1),KTP(1),LTP(1)
  write(u6,*) ' XFLOPA,XFLOPB',XFLOPA,XFLOPB
  write(u6,*) ' ADVICE given : ',LADVICE
# endif
end if
! End if several types/ph modi

end subroutine ADVICE_SIGMA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ADDTUVX(NP,NI,NQ,NK,NASHT,iOffP,iOffI,iOffQ,iOffK,TUVX,nTUVX,PIQK,nPIQK,NUMERR)

use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NP, NI, NQ, NK, NASHT, iOffP, iOffI, iOffQ, iOffK, nTUVX, nPIQK
real(kind=wp), intent(inout) :: TUVX(nTUVX)
real(kind=wp), intent(in) :: PIQK(nPIQK)
integer(kind=iwp), intent(inout) :: NUMERR
integer(kind=iwp) :: iU, iUVX1, iUVX2, iV, iVX1, iVX2, iX, iX1, iX2
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iPIQK, iT, iTUVX
#include "warnings.h"
#else
#include "macros.fh"
unused_var(NUMERR)
#endif

! Add into correct positions in TUVX:

do iX=0,NK-1
  iX1 = NASHT*(iX+iOffK)
  iX2 = NQ*iX
  do iV=0,NQ-1
    iVX1 = NASHT*(iV+iOffQ+iX1)
    iVX2 = NI*(iV+iX2)
    do iU=0,NI-1
      iUVX1 = NASHT*(iU+iOffI+iVX1)
      iUVX2 = NP*(iU+iVX2)
#     ifdef _DEBUGPRINT_
      do iT=1,NP
        iTUVX = iT+iOffP+iUVX1
        iPIQK = iT+iUVX2
        ! Temporary test statements -- remove after debug!
        if ((ITUVX < 1) .or. (ITUVX > NTUVX+1)) then
          ITUVX = NTUVX+1
          NUMERR = NUMERR+1
          if (NUMERR > 100) then
            write(u6,*) ' THIS IS TOO MUCH -- STOP.'
            call QUIT(_RC_INTERNAL_ERROR_)
          end if
        end if
        ! End of temporary test statements
        TUVX(iTUVX) = TUVX(iTUVX)+PIQK(iPIQK)
      end do
#     else
      TUVX(1+iOffP+iUVX1:nP+iOffP+iUVX1) = TUVX(1+iOffP+iUVX1:nP+iOffP+iUVX1)+PIQK(1+iUVX2:nP+iUVX2)
#     endif
    end do
  end do
end do

end subroutine ADDTUVX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine CCmbnVe(Rnxyz,nZeta,la,lb,Zeta,rKappa,rFinal,nComp,Vxyz,KVector,P)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January  91                                              *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Half, Quart, OneHalf, Onei
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nComp
complex(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la+1,0:lb+1), Vxyz(nZeta,3,0:la,0:lb,2)
real(kind=wp), intent(in) :: Zeta(nZeta), rKappa(nZeta), kVector(3), P(nZeta,3)
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nComp)
#include "print.fh"
integer(kind=iwp) :: ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyaMax, iyb, iybMax, iza, izb, iZeta
real(kind=wp) :: Fact, k_dot_P, kModQ, rTemp
complex(kind=wp) :: Temp1, Temp2, Tempm, Tempp

iRout = 161
iPrint = nPrint(iRout)

kModQ = Quart*(kVector(1)**2+kVector(2)**2+kVector(3)**2)

do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        ! Combine integrals

        do iZeta=1,nZeta

          ! Put in the correct prefactors

          rTemp = kModQ/Zeta(iZeta)
          Fact = rKappa(iZeta)*Zeta(iZeta)**(-OneHalf)*exp(-rTemp)
          k_dot_P = kVector(1)*P(iZeta,1)+kVector(2)*P(iZeta,2)+kVector(3)*P(iZeta,3)
          Temp1 = Vxyz(iZeta,1,ixa,ixb,1)*Rnxyz(iZeta,2,iya,iyb)*Rnxyz(iZeta,3,iza,izb)
          Temp2 = Vxyz(iZeta,1,ixa,ixb,2)*Rnxyz(iZeta,2,iya,iyb)*Rnxyz(iZeta,3,iza,izb)
          Tempp = exp(Onei*k_dot_P)*Fact*(Temp1+Temp2)*Half
          Tempm = exp(Onei*k_dot_P)*Fact*(Temp1-Temp2)*Half
          rFinal(iZeta,ipa,ipb,1) = real(Tempp)
          rFinal(iZeta,ipa,ipb,4) = real(Tempm)
          rFinal(iZeta,ipa,ipb,7) = aimag(Tempp)
          rFinal(iZeta,ipa,ipb,10) = aimag(Tempm)
          Temp1 = Rnxyz(iZeta,1,ixa,ixb)*Vxyz(iZeta,2,iya,iyb,1)*Rnxyz(iZeta,3,iza,izb)
          Temp2 = Rnxyz(iZeta,1,ixa,ixb)*Vxyz(iZeta,2,iya,iyb,2)*Rnxyz(iZeta,3,iza,izb)
          Tempp = exp(Onei*k_dot_P)*Fact*(Temp1+Temp2)*Half
          Tempm = exp(Onei*k_dot_P)*Fact*(Temp1-Temp2)*Half
          rFinal(iZeta,ipa,ipb,2) = real(Tempp)
          rFinal(iZeta,ipa,ipb,5) = real(Tempm)
          rFinal(iZeta,ipa,ipb,8) = aimag(Tempp)
          rFinal(iZeta,ipa,ipb,11) = aimag(Tempm)
          Temp1 = Rnxyz(iZeta,1,ixa,ixb)*Rnxyz(iZeta,2,iya,iyb)*Vxyz(iZeta,3,iza,izb,1)
          Temp2 = Rnxyz(iZeta,1,ixa,ixb)*Rnxyz(iZeta,2,iya,iyb)*Vxyz(iZeta,3,iza,izb,2)
          Tempp = exp(Onei*k_dot_P)*Fact*(Temp1+Temp2)*Half
          Tempm = exp(Onei*k_dot_P)*Fact*(Temp1-Temp2)*Half
          rFinal(iZeta,ipa,ipb,3) = real(Tempp)
          rFinal(iZeta,ipa,ipb,6) = real(Tempm)
          rFinal(iZeta,ipa,ipb,9) = aimag(Tempp)
          rFinal(iZeta,ipa,ipb,12) = aimag(Tempm)
        end do
        if (iPrint >= 99) then
          write(u6,*) '(',ixa,iya,iza,ixb,iyb,izb,')'
          write(u6,*) 'x-component'
          write(u6,*) rFinal(1,ipa,ipb,1)
          write(u6,*) rFinal(1,ipa,ipb,4)
          write(u6,*) rFinal(1,ipa,ipb,7)
          write(u6,*) rFinal(1,ipa,ipb,10)
          write(u6,*) 'y-component'
          write(u6,*) rFinal(1,ipa,ipb,2)
          write(u6,*) rFinal(1,ipa,ipb,5)
          write(u6,*) rFinal(1,ipa,ipb,8)
          write(u6,*) rFinal(1,ipa,ipb,11)
          write(u6,*) 'z-component'
          write(u6,*) rFinal(1,ipa,ipb,3)
          write(u6,*) rFinal(1,ipa,ipb,6)
          write(u6,*) rFinal(1,ipa,ipb,9)
          write(u6,*) rFinal(1,ipa,ipb,12)
        end if

      end do
    end do
  end do
end do

return

end subroutine CCmbnVe

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function IPBO(IA,JA,RIJ,BondOr)
! Return the order of the bond between atoms of atomic numbers IA
! and JA, separated by RIJ, or 0 if there is no bond.

use Solvent_Data, only: RCov97
use Constants, only: Half, Angstrom
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: IPBO
real(kind=wp), intent(in) :: RIJ
integer(kind=iwp), intent(in) :: IA, JA
real(kind=wp), intent(out) :: BondOr
integer(kind=iwp) :: IBondO
real(kind=wp) :: R0IJ, R1IJ

! Generate connectivity based on bond distances alone.  The criteria
! is whether the distances is no more than 30% longer than the sum of
! covalent radii of involved atoms. For the moment all bond types are
! determined using Pauling bond orders.
! Note that RIJ is multiplied by Angstrom

IPBO = 0
R1IJ = RIJ*Angstrom
R0IJ = RCov97(IA,JA)
!if (R1IJ > R0IJ*1.3_wp) return
BondOr = exp((R0IJ-R1IJ)/0.3_wp)
if (BondOr < 0.2_wp) return
IBondO = int(BondOr+Half)
IBondO = max(IBondO,1)
IBondO = min(IBondO,3)
IPBO = IBondO

end function IPBO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CSFCOUNT(CIS,NSYM,NUW)

use Symmetry_Info, only: Mul
use gugx, only: CIStruct
use Definitions, only: iwp

implicit none
type(CIStruct), intent(inout) :: CIS
integer(kind=iwp), intent(in) :: NSYM
integer(kind=iwp), intent(out) :: NUW
integer(kind=iwp) :: ISYDWN, ISYM, ISYTOT, ISYUP, MV, N

! CONSTRUCT OFFSET TABLES FOR UPPER AND LOWER WALKS
! SEPARATED FOR EACH MIDVERTEX AND SYMMETRY

NUW = 0
do MV=1,CIS%nMidV
  do ISYM=1,NSYM
    CIS%IOW(1,ISYM,MV) = NUW*CIS%nIpWlk
    NUW = NUW+CIS%NOW(1,ISYM,MV)
  end do
end do
CIS%nWalk = NUW
do MV=1,CIS%nMidV
  do ISYM=1,NSYM
    CIS%IOW(2,ISYM,MV) = CIS%nWalk*CIS%nIpWlk
    CIS%nWalk = CIS%nWalk+CIS%NOW(2,ISYM,MV)
  end do
end do

! CONSTRUCT COUNTER AND OFFSET TABLES FOR THE CSFS
! SEPARATED BY MIDVERTICES AND SYMMETRY.
! FORM ALSO CONTRACTED SUMS OVER MIDVERTICES.

CIS%NCSF(:) = 0
do ISYTOT=1,NSYM
  do MV=1,CIS%nMidV
    do ISYUP=1,NSYM
      ISYDWN = Mul(ISYTOT,ISYUP)
      N = CIS%NOW(1,ISYUP,MV)*CIS%NOW(2,ISYDWN,MV)
      CIS%NOCSF(ISYUP,MV,ISYTOT) = N
      CIS%IOCSF(ISYUP,MV,ISYTOT) = CIS%NCSF(ISYTOT)
      CIS%NCSF(ISYTOT) = CIS%NCSF(ISYTOT)+N
#     include "compiler_features.h"
#     ifdef _BUGGY_INTEL_LLVM_
      ! dummy statement to work around compiler bug, will never be executed
      if (ISYUP > 99) CIS%NCSF(ISYTOT) = -1
#     endif
    end do
  end do
end do

end subroutine CSFCOUNT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
function EstI(nAlpha,nBeta,Coeff1,niBas,Coeff2,njBas,xab,Scrt,nScrt,IndZ)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp) :: EstI
integer(kind=iwp), intent(in) :: nAlpha, nBeta, niBas, njBas, nScrt, IndZ(nAlpha*nBeta+1)
real(kind=wp), intent(in) :: Coeff1(nAlpha,niBas), Coeff2(nBeta,njBas), xab(nAlpha*nBeta)
real(kind=wp), intent(out) :: Scrt(nScrt)
integer(kind=iwp) :: iAlpha, iBas, iBeta, iDelta, iEta, iGamma, iHigh, ijBas, iZeta, jBas, mZeta
real(kind=wp) :: A_Int, rab, rcd
integer(kind=iwp), external :: iDAMax_

#ifdef _DEBUGPRINT_
write(u6,*) 'Esti:mZeta=',IndZ(nAlpha*nBeta)
call RecPrt('Esti:xab',' ',xab,1,nAlpha*nBeta)
call RecPrt('Esti:Coeff1',' ',Coeff1,nAlpha,niBas)
call RecPrt('Esti:Coeff2',' ',Coeff2,nBeta,njBas)
#endif

mZeta = IndZ(nAlpha*nBeta+1)
Scrt(1:niBas*njBas) = Zero
do iZeta=1,mZeta
  iBeta = (IndZ(iZeta)-1)/nAlpha+1
  iAlpha = IndZ(iZeta)-(iBeta-1)*nAlpha
  rab = xab(iZeta)
  do iEta=1,mZeta
    iDelta = (IndZ(iEta)-1)/nAlpha+1
    iGamma = IndZ(iEta)-(iDelta-1)*nAlpha
    rcd = xab(iEta)
    A_Int = rab*rcd
    do iBas=1,niBas
      do jBas=1,njBas
        ijBas = (jBas-1)*niBas+iBas
        Scrt(ijBas) = Scrt(ijBas)+abs(Coeff1(iAlpha,iBas)*Coeff2(iBeta,jBas))*abs(Coeff1(iGamma,iBas)*Coeff2(iDelta,jBas))*A_Int
      end do
    end do
  end do
end do
iHigh = iDAMax_(niBas*njBas,Scrt,1)
EstI = sqrt(Scrt(iHigh))

return

end function EstI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! Module containing routines to generate contributions to a
! multipole potential on the fly.
! Note that another module allows contraction of T-pairs.


!FIXME:  ************************************************************
!FIXME:  *                                                          *
!FIXME:  *  Array bounds when W-vector is ZERO !!!!!!!!!!           *
!FIXME:  *                                                          *
!FIXME:  ************************************************************


MODULE fmm_W_contractors

   USE fmm_global_paras
   USE fmm_stats
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_init_W_contractors,           &
             fmm_free_W_contractors,           &
             fmm_select_W_con,                 &
             fmm_set_W_con_ptrs

   ! Public variable to stop the resetting of W_con pointers with open T-buffer
   PUBLIC :: fmm_lock_W_con

   REAL(REALK), ALLOCATABLE, SAVE :: W_matrix(:,:)
   INTEGER(INTK),            SAVE :: WLDA
   ! Pointers to actual moments and potentials described elsewhere
   REAL(REALK), POINTER, SAVE :: old_ptr(:,:)
   REAL(REALK), POINTER, SAVE :: new_ptr(:,:)
   ! Diagnostic variables
   CHARACTER(LEN=11), SAVE :: W_con_stat
   LOGICAL,       SAVE :: fmm_lock_W_con

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_W_contractors(LMAX)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: LMAX

      IF (ALLOCATED(W_matrix)) CALL fmm_quit('W_matrix not deallocated!')
      ALLOCATE(W_matrix((1+LMAX)**2,(1+LMAX)**2))
      WLDA = (1+LMAX)**2
      W_matrix = zero

   END SUBROUTINE fmm_init_W_contractors

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_free_W_contractors

      IMPLICIT NONE
      DEALLOCATE(W_matrix)

   END SUBROUTINE fmm_free_W_contractors

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_set_W_con_ptrs(old,new)

      IMPLICIT NONE
      REAL(REALK), TARGET, INTENT(IN) :: old(:,:), new(:,:)

      IF (W_con_stat /= 'initialised') STOP 'no W_contractor preselected!'
      IF (fmm_lock_W_con) STOP 'W_buffer not empty! Cannot reset W_con!'
      NULLIFY (old_ptr, new_ptr)
      old_ptr => old(:,:)
      new_ptr => new(:,:)

   END SUBROUTINE fmm_set_W_con_ptrs

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_check_W_status

      IMPLICIT NONE
      IF ((.NOT.ASSOCIATED(old_ptr)) .OR. (.NOT.ASSOCIATED(new_ptr))) THEN
         CALL fmm_quit('W_contractor pointers not associated as reqd.')
      END IF

   END SUBROUTINE fmm_check_W_status

!-------------------------------------------------------------------------------
! Built for DIRECT scheme.  Can only take one W_pair at a time.

   SUBROUTINE fmm_W_con_direct(W_pair)

      USE fmm_W_worker, ONLY: fmm_get_ltsqr_W_matrix,       &
                             fmm_contract_Wq

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: W_pair

      REAL(REALK)   :: arr_tmp(W_pair%lm_max)
      REAL(REALK)   :: r_mod2
      INTEGER(INTK) :: n,m,w, lm_dim, hi, p,q, LMAX,JMAX
      CHARACTER(LEN=1)  :: NT

      CALL fmm_check_W_status

      NT = W_pair%N_or_T
      p = W_pair%paras%LHS_id
      q = W_pair%paras%RHS_id
      lm_dim = W_pair%lm_max

      r_mod2 = DOT_PRODUCT(W_pair%r_ab,W_pair%r_ab)
      IF (r_mod2 > ZERO_VECT_TOL*ZERO_VECT_TOL) THEN
         LMAX = W_pair%paras%LHS_LMAX
         JMAX = W_pair%paras%RHS_LMAX
         stat_W_mat_builds = stat_W_mat_builds + one
         CALL fmm_get_ltsqr_W_matrix(LMAX,JMAX,W_pair%r_ab,W_matrix)
         IF (LMAX /= JMAX) THEN
            n = (1+JMAX)**2
            m = (1+LMAX)**2
            w = W_pair%lm_max
            CALL fmm_contract_Wq(NT,W_matrix,WLDA,old_ptr(:,q),n,new_ptr(:,p),m)
         ELSE
            arr_tmp(:lm_dim) = old_ptr(:lm_dim,q)
            CALL DTRMV('L',NT,'U',lm_dim,W_matrix,WLDA,arr_tmp,1)
            new_ptr(:lm_dim,p) = new_ptr(:lm_dim,p) + arr_tmp(:lm_dim)
         END IF
      ELSE
         hi = (1+W_pair%paras%LHS_LMAX)**2
         new_ptr(:hi,p) = new_ptr(:hi,p) + old_ptr(:hi,q)
      END IF

   END SUBROUTINE fmm_W_con_direct

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_W_con_X(W_pairs)

      USE fmm_W_worker, ONLY: fmm_get_ltsqr_W_matrix

      IMPLICIT NONE
      TYPE(T_pair_list), INTENT(IN) :: W_pairs

      REAL(REALK)   :: arr_tmp(W_pairs%lm_max)
      REAL(REALK)   :: lastlen, r_pq(3), r_pq_mod(3)
      INTEGER(INTK) :: LMAX, i, p,q, lm_dim, hi
      CHARACTER(LEN=1)  :: NT

      CALL fmm_check_W_status

      LMAX = W_pairs%LMAX
      NT = W_pairs%N_or_T
      r_pq_mod(:) = W_pairs%r_ab(:)
      lm_dim = W_pairs%lm_max
      lastlen = zero

      DO i = 1, SIZE(W_pairs%paras)

         p  = W_pairs%paras(i)%LHS_id
         q  = W_pairs%paras(i)%RHS_id

         hi = (1+W_pairs%paras(i)%RHS_LMAX)**2
         IF (hi < SIZE(arr_tmp)) arr_tmp = zero
         arr_tmp(:hi) = old_ptr(:hi,q)

         IF(ABS(W_pairs%paras(i)%ratio) < ZERO_VECT_TOL) THEN
            ! zero translation, so just copy over old to new
            hi = (1+W_pairs%paras(i)%LHS_LMAX)**2
            new_ptr(:hi,p) = new_ptr(:hi,p) + arr_tmp(:hi)
            lastlen = W_pairs%paras(i)%ratio
            CYCLE
         END IF
         ! get matrix if different
         IF(ABS(W_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) THEN
            r_pq = r_pq_mod * W_pairs%paras(i)%ratio
            lastlen = W_pairs%paras(i)%ratio
            stat_W_mat_builds = stat_W_mat_builds + one
            CALL fmm_get_ltsqr_W_matrix(LMAX,LMAX,r_pq,W_matrix)
         END IF
         ! now translate
         hi = (1+W_pairs%paras(i)%RHS_LMAX)**2
         IF (hi < lm_dim) arr_tmp = zero
         arr_tmp(:hi) = old_ptr(:hi,q)
         CALL DTRMV('L',NT,'U',lm_dim,W_matrix,WLDA,arr_tmp,1)
         hi = (1+W_pairs%paras(i)%LHS_LMAX)**2
         new_ptr(:hi,p) = new_ptr(:hi,p) + arr_tmp(:hi)

      END DO

   END SUBROUTINE fmm_W_con_X

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_W_con_FAST(W_pairs)

      USE fmm_W_worker, ONLY: fmm_get_ltsqr_W_matrix, fmm_contract_Wq

      IMPLICIT NONE
      TYPE(T_pair_list), INTENT(IN) :: W_pairs

      REAL(REALK)   :: arr_tmp(W_pairs%lm_max)
      REAL(REALK)   :: lastlen, r_pq(3), r_pq_mod(3)
      INTEGER(INTK) :: LMAX,JMAX, n,m,lm_dim, i, p,q, hi
      CHARACTER(LEN=1)  :: NT

      CALL fmm_check_W_status

      NT = W_pairs%N_or_T
      r_pq_mod(:) = W_pairs%r_ab(:)
      lastlen = zero
      LMAX = W_pairs%LHS_LMAX
      JMAX = W_pairs%RHS_LMAX
      n = (1+JMAX)**2
      m = (1+LMAX)**2
      lm_dim = W_pairs%lm_max

      DO i = 1, SIZE(W_pairs%paras)

         p  = W_pairs%paras(i)%LHS_id
         q  = W_pairs%paras(i)%RHS_id
         IF(ABS(W_pairs%paras(i)%ratio) < ZERO_VECT_TOL) THEN
            ! zero translation, so just copy over old to new
            hi = (1+W_pairs%paras(i)%LHS_LMAX)**2
            new_ptr(:hi,p) = new_ptr(:hi,p) + old_ptr(:hi,q)
            lastlen = W_pairs%paras(i)%ratio
            CYCLE
         END IF
         IF(ABS(W_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) THEN
            r_pq = r_pq_mod * W_pairs%paras(i)%ratio
            lastlen = W_pairs%paras(i)%ratio
            stat_W_mat_builds = stat_W_mat_builds + one
            CALL fmm_get_ltsqr_W_matrix(LMAX,JMAX,r_pq,W_matrix)
         END IF
         IF (LMAX /= JMAX) THEN
            CALL fmm_contract_Wq(NT,W_matrix,WLDA,old_ptr(:,q),n,new_ptr(:,p),m)
         ELSE
            hi = (1+W_pairs%paras(i)%RHS_LMAX)**2
            IF (hi < lm_dim) arr_tmp = zero
            arr_tmp(:hi) = old_ptr(:hi,q)
            CALL DTRMV('L',NT,'U',lm_dim,W_matrix,WLDA,arr_tmp,1)
            hi = (1+W_pairs%paras(i)%LHS_LMAX)**2
            new_ptr(:hi,p) = new_ptr(:hi,p) + arr_tmp(:hi)
         END IF

      END DO

   END SUBROUTINE fmm_W_con_FAST

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_W_con_BOUNDARY(W_pairs)

      USE fmm_W_worker, ONLY: fmm_get_boundary_W_matrix

      IMPLICIT NONE
      TYPE(T_pair_list), INTENT(IN) :: W_pairs

      REAL(REALK)   :: lastlen, r_pq(3), r_pq_mod(3)
      INTEGER(INTK) :: LMAX, n,lm_dim, i, p,q
      CHARACTER(LEN=1)  :: NT

      CALL fmm_check_W_status

      NT = W_pairs%N_or_T
      r_pq_mod(:) = W_pairs%r_ab(:)
      lastlen = zero
      LMAX = W_pairs%RHS_LMAX
      n = (1+LMAX)**2
      lm_dim = W_pairs%lm_max

      DO i = 1, SIZE(W_pairs%paras)

         p  = W_pairs%paras(i)%LHS_id
         q  = W_pairs%paras(i)%RHS_id
         IF(ABS(W_pairs%paras(i)%ratio) < ZERO_VECT_TOL) THEN
            ! zero translation, so just copy over old to new
            new_ptr(1,p) = new_ptr(1,p) + old_ptr(1,q)
            lastlen = W_pairs%paras(i)%ratio
            CYCLE
         END IF
         IF(ABS(W_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) THEN
            r_pq = r_pq_mod * W_pairs%paras(i)%ratio
            lastlen = W_pairs%paras(i)%ratio
            stat_W_mat_builds = stat_W_mat_builds + one
            CALL fmm_get_boundary_W_matrix(LMAX,r_pq,W_matrix)
         END IF

         ! Always perform transpose contraction to get boundary potential
         new_ptr(1,p) = new_ptr(1,p)+DOT_PRODUCT(W_matrix(1:n,1),old_ptr(:,q))

      END DO

   END SUBROUTINE fmm_W_con_BOUNDARY

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_select_W_con(W_con_ID)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: W_con_ID
      EXTERNAL fmm_store_w_contractor

      IF (.NOT.ALLOCATED(W_matrix)) CALL fmm_quit('W_matrix not allocated!')

      SELECT CASE (W_con_ID)
      CASE (W_CONTRACTOR_DIRECT)
         CALL fmm_store_w_contractor(fmm_W_con_DIRECT)
      CASE (W_CONTRACTOR_X)
         CALL fmm_store_w_contractor(fmm_W_con_X)
      CASE (W_CONTRACTOR_FAST)
         CALL fmm_store_w_contractor(fmm_W_con_FAST)
      CASE (W_CONTRACTOR_BOUNDARY)
         CALL fmm_store_w_contractor(fmm_W_con_BOUNDARY)
      CASE DEFAULT
         CALL fmm_quit ('invalid W_contractor requested!')
      END SELECT
      ! initialise diagnostics
      W_con_stat = 'initialised'
      W_con_stat = 'initialised'
      fmm_lock_W_con = .FALSE.

   END SUBROUTINE fmm_select_W_con

!-------------------------------------------------------------------------------

END MODULE fmm_W_contractors

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,1994, Per Ake Malmqvist                           *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE POLY1(CI,NCI)
      use gugx, only: SGS
      use stdalloc, only: mma_allocate, mma_deallocate
      use pt2_guga, only: MxCI, nG1, iAdr10, cLab10
      IMPLICIT NONE
* PER-AAKE MALMQUIST, 92-12-07
* THIS PROGRAM CALCULATES THE 1-EL DENSITY
* MATRIX FOR A CASSCF WAVE FUNCTION.

      INTEGER, INTENT(IN) :: NCI
      REAL*8, INTENT(IN) :: CI(NCI)

      INTEGER I
      Integer :: nLev
      Real*8, Allocatable:: SGM1(:), G1TMP(:)

      nLev = SGS%nLev

      IF(NLEV.GT.0) THEN
        CALL mma_allocate(SGM1 ,MXCI,LABEL='SGM1')
        CALL mma_allocate(G1TMP,NG1,LABEL='G1TMP')
        CALL DENS1_RPT2(CI,SGM1,G1TMP,nLev)
      END IF

* REINITIALIZE USE OF DMAT.
* The fields IADR10 and CLAB10 are kept in pt2_guga.F90
* CLAB10 replaces older field called LABEL.
      DO I=1,64
        IADR10(I,1)=-1
        IADR10(I,2)=0
        CLAB10(I)='   EMPTY'
      END DO
      IADR10(1,1)=0
* HENCEFORTH, THE CALL PUT(NSIZE,LABEL,ARRAY) WILL ENTER AN
* ARRAY ON LUDMAT AND UPDATE THE TOC.
      IF(NLEV.GT.0) THEN
        CALL PT2_PUT(NG1,' GAMMA1',G1TMP)

        CALL mma_deallocate(SGM1)
        CALL mma_deallocate(G1TMP)
      END IF

      END SUBROUTINE POLY1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PMATEL(ISTATE,JSTATE,PROP,PINT,SMAT,CNO,OCC,
     *                  SFOLD,AFOLD,TDAO)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PINT(NBTRI),SFOLD(NBTRI),AFOLD(NBTRI),CNO(NCMO)
      DIMENSION TDAO(NBAST,NBAST),SMAT(*),OCC(NBAST)
      DIMENSION IDUM(1)
      INTEGER   ISYMLB
      REAL*8    PROP(NRROOT,NRROOT,NPROP)

#include "SysDef.fh"
#include "mrci.fh"
      SAVE ICALL
      DATA ICALL /0/
      IF(ISTATE.EQ.JSTATE) THEN
C READ OVERLAP INTEGRALS FROM TRAONE.
        CALL RDONE(IRTC,6,'MLTPL  0',1,SMAT,IDUMMY)
C CALCULATE AND WRITE MULLIKEN CHARGES.
        WRITE(6,*)
      CALL XFLUSH(6)
        WRITE(6,'(A,I2)')' MULLIKEN CHARGES FOR STATE NR ',ISTATE
      CALL XFLUSH(6)
        CALL CHARGE(NSYM,NBAS,NAME,CNO,OCC,SMAT,2,.True.,.True.)
        WRITE(6,*)' ',('*',I=1,70)
      CALL XFLUSH(6)
      END IF
C FOLD TDAO SYMMETRICALLY (ANTI-SYMM) INTO SFOLD (AFOLD):
C MOLCAS2 UPDATE: SYMMETRY-BLOCKED STORAGE.
      CALL DCOPY_(NBTRI,[0.0D00],0,SFOLD,1)
      CALL DCOPY_(NBTRI,[0.0D00],0,AFOLD,1)
      IJ=0
      IEND=0
      DO ISY=1,NSYM
        ISTA=IEND+1
        IEND=IEND+NBAS(ISY)
        DO I=ISTA,IEND
          DO J=ISTA,I-1
            IJ=IJ+1
            SFOLD(IJ)=TDAO(I,J)+TDAO(J,I)
            AFOLD(IJ)=TDAO(I,J)-TDAO(J,I)
          END DO
          IJ=IJ+1
          SFOLD(IJ)=TDAO(I,I)
          AFOLD(IJ)=0.0D00
        END DO
      END DO
      NSIZ=0
      DO 100 IPROP=1,NPROP
C PICK UP MATRIX ELEMENTS FROM ONE-ELECTRON FILE:
        CALL iRDONE(IRTC,1,PNAME(IPROP),IPCOMP(IPROP),IDUM,ISYMLB)
        IF(IRTC.EQ.0) NSIZ=IDUM(1)
        CALL RDONE(IRTC,0,PNAME(IPROP),IPCOMP(IPROP),PINT,ISYMLB)
C SEPARATE OUT THE OPERATOR GAUGE ORIGIN, AND NUCLEAR CONTRIBUTION:
        IF(ICALL.EQ.0) THEN
          PORIG(1,IPROP)=PINT(NSIZ+1)
          PORIG(2,IPROP)=PINT(NSIZ+2)
          PORIG(3,IPROP)=PINT(NSIZ+3)
          PNUC(IPROP)=PINT(NSIZ+4)
        END IF
        IF(ISYMLB.NE.1) THEN
C NON-DIAGONAL SYMMETRY BLOCKS MUST BE COMPRESSED AWAY:
          IFROM=1
          ITO=1
          DO 40 ISY1=1,NSYM
            NB1=NBAS(ISY1)
            IF(NB1.EQ.0) GOTO 40
            DO 30 ISY2=1,ISY1
              NB2=NBAS(ISY2)
              IF(NB2.EQ.0) GOTO 30
              ISY12=MUL(ISY1,ISY2)
CPAM96              MASK=2**(ISY12-1)
CPAM96              IF(IAND(ISYMLB,MASK).EQ.0) GOTO 30
              IF(MOD(ISYMLB,2**(ISY12)).EQ.0) GOTO 30
              NB12=NB1*NB2
              IF(ISY12.EQ.1) THEN
                NB12=(NB12+NB1)/2
                IF(IFROM.GT.ITO)
     *            CALL DCOPY_(NB12,PINT(IFROM),1,PINT(ITO),1)
                ITO=ITO+NB12
              END IF
              IFROM=IFROM+NB12
30          CONTINUE
40        CONTINUE
          NSIZ=ITO
        END IF
C PUT DDOT OF TR DENS MATRIX AND INTEGRALS INTO PROPER MATRIX ELEMENT
C FOR MULTIPOLES, USE NEGATIVE SIGN OF ELECTRONIC PART.
        SGN=1.0D00
        IF(PNAME(IPROP)(1:5).EQ.'MLTPL') SGN=-SGN
        IF(PTYPE(IPROP).EQ.'HERM') THEN
          X=SGN*DDOT_(NBTRI,SFOLD,1,PINT,1)
          PROP(ISTATE,JSTATE,IPROP)=X
          PROP(JSTATE,ISTATE,IPROP)=X
        ELSE
          X=SGN*DDOT_(NBTRI,AFOLD,1,PINT,1)
          PROP(ISTATE,JSTATE,IPROP)=X
          PROP(JSTATE,ISTATE,IPROP)=-X
        END IF
100   CONTINUE
      ICALL=1
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per Ake Malmqvist                                      *
!               Markus P. Fuelscher                                    *
!***********************************************************************

subroutine GUGACTL(nSym,iSpin,nActEl,nHole1,nElec3,nRs1,nRs2,nRs3,SGS,CIS,EXS,STSYM,DoblockDMRG)
! PURPOSE: CONTROL ROUTINE TO SET UP GUGA TABLES
! AUTHOR:  P.-AA. MALMQVIST
!
! MODIFIED TO FIT THE DETRAS PROGRAM BY M.P. FUELSCHER

use gugx, only: CIStruct, EXStruct, SGStruct
use MkGUGA_mod, only: MKGUGA
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nSym, iSpin, nActEl, nHole1, nElec3, nRs1(nSym), nRs2(nSym), nRs3(nSym), STSYM
type(SGStruct), intent(out) :: SGS
type(CIStruct), intent(out) :: CIS
type(EXStruct), intent(out) :: EXS
logical(kind=iwp), intent(in) :: DoBlockDMRG
integer(kind=iwp) :: IS, nRas1T, nRas2T, nRas3T

nRas1T = sum(nRs1(1:nSym))
nRas2T = sum(nRs2(1:nSym))
nRas3T = sum(nRs3(1:nSym))

#ifdef _DEBUGPRINT_
write(u6,*) 'nSym,iSpin,nActEl,nHole1,nElec3,nRas1T,nRas2T,nRas3T,STSYM=',nSym,iSpin,nActEl,nHole1,nElec3,nRas1T,nRas2T,nRas3T,STSYM
#endif

SGS%nSym = nSym
SGS%iSpin = iSpin
SGS%nActEl = nActEl

! COMPUTE RAS RESTRICTIONS ON VERTICES:

SGS%LV1RAS = NRAS1T
SGS%LV3RAS = nRas1T+NRAS2T
SGS%LM1RAS = 2*nRas1T-NHOLE1
SGS%LM3RAS = NACTEL-nElec3

! SET IFRAS FLAG
! IFRAS = 0 : THIS IS A CAS CALCULATION
! IFRAS = 1 : THIS IS A RAS CALCULATION

if (NRAS1T+NRAS3T /= 0) then
  SGS%IFRAS = 1
  do IS=1,NSYM
    if (nRs1(IS)+nRs2(IS)+nRs3(IS) /= 0) SGS%IFRAS = SGS%IFRAS+1
  end do
else
  SGS%IFRAS = 0
end if

! INITIALIZE GUGA TABLES:

call MKGUGA(SGS,CIS)

if (SGS%NVERT0 == 0) then
  CIS%NCSF(STSYM) = 0
  return
end if
if (doBlockDMRG) then
  CIS%NCSF(STSYM) = 1
  return
end if

! PURPOSE: FREE THE GUGA TABLES
! FORM VARIOUS OFFSET TABLES:
! NOTE: NIPWLK AND DOWNWLK ARE THE NUMER OF INTEGER WORDS USED
!       TO STORE THE UPPER AND LOWER WALKS IN PACKED FORM.

call MKCOT(SGS,CIS)

! CONSTRUCT THE CASE LIST

call MKCLIST(SGS,CIS)

! SET UP ENUMERATION TABLES

call MKSGNUM(STSYM,SGS,CIS,EXS)

if (NActEl == 0) CIS%NCSF(STSYM) = 1

! (IFRAS-1) IS THE NUMBER OF SYMMETRIES CONTAINING ACTIVE ORBITALS
! IF THIS IS GREATER THAN 1 ORBITAL REORDERING INTEGRALS IS REQUIRED
! SET UP THE REINDEXING TABLE

call SETSXCI()

end subroutine GUGACTL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Funi_Print()

use nq_Grid, only: nGridMax
use nq_Info, only: Angular_Pruning, Crowding, Fade, iOpt_Angular, L_Quad, NQ_Direct, nR, On, Quadrature, T_Y, Threshold
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: iOpt, iPrint
real(kind=wp) :: EThr
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: Reduce_Prt

!                                                                      *
!***********************************************************************
!                                                                      *
iPrint = iPrintLevel(-1)
!                                                                      *
!***********************************************************************
!                                                                      *
call Get_dScalar('EThr',EThr)
T_Y = min(T_Y,EThr*0.1_wp)
Threshold = min(Threshold,EThr*1.0e-4_wp)
!                                                                      *
!***********************************************************************
!                                                                      *
if ((.not. Reduce_Prt()) .and. (iPrint >= 2)) then
  write(u6,*)
  write(u6,'(6X,A)') 'Numerical integration parameters'
  write(u6,'(6X,A)') '--------------------------------'
  write(u6,'(6X,A,21X,A)') 'Radial quadrature type:    ',Quadrature

  if (Quadrature(1:3) == 'LMG') then
    write(u6,'(6X,A,E11.4)') 'Radial quadrature accuracy:',Threshold
  else
    write(u6,'(6X,A,18X,I5)') 'Size of radial grid:       ',nR
  end if

  if (btest(iOpt_Angular,2)) then
    write(u6,'(6X,A,25X,I4)') 'Lebedev angular grid:',L_Quad
  else if (btest(iOpt_Angular,0)) then
    write(u6,'(6X,A,I4)') 'Lobatto angular grid, l_max:',L_Quad
  else
    write(u6,'(6X,A,I4)') 'Gauss and Gauss-Legendre angular grid, l_max:',L_Quad
  end if

  if (Angular_Pruning == On) then
    write(u6,'(6X,A,1X,ES9.2)') 'Angular grid prunned with the crowding factor:',Crowding
    write(u6,'(6X,A,1X,ES9.2)') '                            and fading factor:',Fade
  end if
  if (btest(iOpt_Angular,1)) then
    write(u6,'(6X,A)') 'The whole atomic grid is scanned for each sub block.'
  end if

  write(u6,'(6X,A,2X,ES9.2)') 'Screening threshold for integral computation:',T_Y
  if (Quadrature(1:3) /= 'LMG') then
    write(u6,'(6X,A,20X,ES9.2)') 'Radial quadrature accuracy:',Threshold
  end if

  write(u6,'(6X,A,17X,I7)') 'Maximum batch size:        ',nGridMax
  if (NQ_Direct == On) then
    write(u6,'(6X,A)') 'AO values are recomputed each iteration'
  else
    write(u6,'(6X,A)') 'AO values are stored on disk'
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Put flag on RUNFILE to indicate that we are doing DFT.

!call Get_iOption(iOpt)
call Get_iScalar('System BitSwitch',iOpt)
iOpt = ibset(iOpt,6)
!call Put_iOption(iOpt)
call Put_iScalar('System BitSwitch',iOpt)
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Funi_Print

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994-1996, Jeppe Olsen                                 *
!***********************************************************************

subroutine DENSI2_MCLR(I12,RHO1,RHO2,L,R,LUL,LUR,ieaw,n1,n2)
! Density matrices between L and R
!
! I12 = 1 => only one-body density
! I12 = 2 => one- and two-body density matrices
!
! Jeppe Olsen,      Oct 1994
! GAS modifications Aug 1995
! Two body density added, 1996
!
! Two-body density is stored as rho2(ijkl)=<l!e(ij)e(kl)-delta(jk)e(il)!r>
! ijkl = ij*(ij-1)/2+kl, ij >= kl
!
! =====
! Input
! =====
! Definition of L and R is picked up from CANDS
! with L being S and  R being C

use Index_Functions, only: nTri_Elem
use Str_Info, only: IATPM1, IATPM2, IBTPM1, IBTPM2, ITYP_DUMMY, NELEC, NOCTYP, STR
use MCLR_Data, only: IASTFI, IBSTFI, IBTSOB, ICISTR, IDC, MAXI, MAXK, MNR1IC, MXINKA, MXPNGAS, MXR3IC, MXSB, MXSOOB, NACOB, &
                     NOBPTS, NTSOB, PSSIGN
use CandS, only: ICSM, ICSPC, ISSM, ISSPC
use input_mclr, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: I12, LUL, LUR, ieaw, n1, n2
real(kind=wp), intent(out) :: RHO1(NACOB,NACOB), RHO2(nTri_Elem(NACOB**2))
real(kind=wp), intent(inout) :: L(*), R(*)
integer(kind=iwp) :: IATP, IATP2, IBTP, IBTP2, idum(1), IDUMMY(1), IMNMX, INTSCR, IOCTPA, IOCTPB, JATP, JBTP, LSCR1, LSCR12, &
                     LSCR2, LSCR3, MAXA, MAXA1, MAXB, MAXB1, MAXIK, MXCIJA, MXCIJAB, MXCIJB, MXCJ, MXIJST, MXIJSTF, MXSTBL, &
                     MXSXBL, MXTSOB, NAEL, NBEL, NGAS, NOCTPA, NOCTPB, NOOS
integer(kind=iwp), allocatable :: CBLTP(:), CIOIO(:), IX(:,:), OOS(:,:), SBLTP(:), SIOIO(:)
real(kind=wp), allocatable :: C2(:), CB(:), INSCR(:), RHO1P(:), RHO1S(:), SB(:), XIXS(:,:), XNATO(:)

IDUM = 0
NGAS = 3

RHO1(:,:) = Zero
RHO2(:) = Zero

! Info for this internal space

IATP = IASTFI(ISSPC)
IBTP = IBSTFI(ISSPC)
JATP = IASTFI(ICSPC)
JBTP = IBSTFI(ICSPC)
if ((IATP /= JATP) .or. (IBTP /= JBTP)) then
  write(u6,*) ' My world is falling apart'
  write(u6,*) ' C and sigma belongs to different types of strings'
  write(u6,*) ' IATP IBTP JATP JBTP ',IATP,IBTP,JATP,JBTP
  call Abend()
end if
NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)
NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)
! Offsets for supergroups
IOCTPA = 1
IOCTPB = 1

NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)

! Largest number of strings of given symmetry and type
MAXA = 0
if (NAEL >= 1) then
  MAXA1 = IMNMX(Str(IATPM1)%NSTSO,nIrrep*NOCTYP(IATPM1),2)
  MAXA = max(MAXA,MAXA1)
end if
if (NAEL >= 2) then
  MAXA1 = IMNMX(Str(IATPM2)%NSTSO,nIrrep*NOCTYP(IATPM2),2)
  MAXA = max(MAXA,MAXA1)
end if
MAXB = 0
if (NBEL >= 1) then
  MAXB1 = IMNMX(Str(IBTPM1)%NSTSO,nIrrep*NOCTYP(IBTPM1),2)
  MAXB = max(MAXB,MAXB1)
end if
if (NBEL >= 2) then
  MAXB1 = IMNMX(Str(IBTPM2)%NSTSO,nIrrep*NOCTYP(IBTPM2),2)
  MAXB = max(MAXB,MAXB1)
end if
MXSTBL = max(MAXA,MAXB)
! Largest number of resolution strings and spectator strings
! that can be treated simultaneously
! replace with MXINKA !!!
MAXI = min(MXINKA,MXSTBL)
MAXK = min(MXINKA,MXSTBL)
! Largest active orbital block belonging to given type and symmetry
MXTSOB = max(0,maxval(NOBPTS(1:NGAS,1:nIrrep)))
! Local scratch arrays for blocks of C and sigma
LSCR1 = 0
if (ICISTR <= 2) then
  LSCR1 = MXSB
else if (ICISTR == 3) then
  LSCR1 = MXSOOB
end if
if (ICISTR == 1) then
  call mma_allocate(CB,LSCR1,Label='CB')
  call mma_allocate(SB,LSCR1,Label='SB')
end if

! SCRATCH space for block of two-electron density matrix
! A 4 index block with four indices belonging OS class

INTSCR = MXTSOB**4

call mma_allocate(INSCR,INTSCR,Label='INSCR')

! Arrays giving allowed type combinations
call mma_allocate(SIOIO,NOCTPA*NOCTPB,Label='SIOIO')
call mma_allocate(CIOIO,NOCTPA*NOCTPB,Label='CIOIO')

call IAIBCM_MCLR(MNR1IC(ISSPC),MXR3IC(ISSPC),NOCTPA,NOCTPB,Str(IATP)%EL1,Str(IATP)%EL3,Str(IBTP)%EL1,Str(IBTP)%EL3,SIOIO)

call IAIBCM_MCLR(MNR1IC(ICSPC),MXR3IC(ICSPC),NOCTPA,NOCTPB,Str(IATP)%EL1,Str(IATP)%EL3,Str(IBTP)%EL1,Str(IBTP)%EL3,CIOIO)

! Get memory requirements

IATP2 = min(IATP+2,ITYP_Dummy)
IBTP2 = min(IBTP+2,ITYP_Dummy)
call MXRESC(CIOIO,IATP,IBTP,NOCTPA,NOCTPB,nIrrep,Str(IATP)%NSTSO,Str(IBTP)%NSTSO,Str(IATP+1)%NSTSO,NOCTYP(IATP+1), &
            Str(IBTP+1)%NSTSO,NOCTYP(IBTP+1),NTSOB,MAXK,Str(IATP2)%NSTSO,NOCTYP(IATP2),Str(IBTP2)%NSTSO,NOCTYP(IBTP2), &
            Str(IATP)%EL123,Str(IBTP)%EL123,MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL,MXIJST,MXIJSTF)

LSCR2 = max(MXCJ,MXCIJA,MXCIJB,MXCIJAB)
LSCR12 = max(LSCR1,2*LSCR2)
call mma_allocate(C2,LSCR12,Label='C2')

! Space for annihilation/creation mappings
MAXIK = max(MAXI,MAXK)
LSCR3 = max(MXSTBL*MXTSOB,MXIJST,MAXIK*MXTSOB*MXTSOB)
call mma_allocate(IX,LSCR3,4,Label='IX')
call mma_allocate(XIXS,LSCR3,4,Label='XIXS')
! Arrays giving block type
call mma_allocate(SBLTP,nIrrep,Label='SBLTP')
call mma_allocate(CBLTP,nIrrep,Label='CBLTP')
! Arrays for additional symmetry operation
call ZBLTP(ISSM,nIrrep,IDC,SBLTP,idum)
call ZBLTP(ICSM,nIrrep,IDC,CBLTP,idum)
!10 OOS array
NOOS = NOCTPA*NOCTPB*nIrrep
call mma_allocate(OOS,NOOS,10,Label='OSS')
! scratch space containing active one body
call mma_allocate(RHO1S,NACOB**2,Label='RHO1S')
! For natural orbitals
call mma_allocate(RHO1P,nTri_Elem(NACOB),Label='RHO1P')
call mma_allocate(XNATO,NACOB**2,Label='XNATO')
! Natural orbitals in symmetry blocks
!call mma_allocate(RHO1SM,NACOB ** 2,Label='RHO1SM')
!call mma_allocate(XNATSM,NACOB ** 2,Label='XNATSM')
!call mma_allocate(OCCSM,NACOB,Label='OCCSM')

! Transform from combination scaling to determinant scaling

if ((IDC /= 1) .and. (ICISTR == 1)) then
  ! Left CI vector
  call SCDTC2_MCLR(L,ISSM,SBLTP,nIrrep,NOCTPA,NOCTPB,Str(IATP)%NSTSO,Str(IBTP)%NSTSO,SIOIO,IDC,2,IDUMMY)
  ! Right CI vector
  call SCDTC2_MCLR(R,ICSM,CBLTP,nIrrep,NOCTPA,NOCTPB,Str(IATP)%NSTSO,Str(IBTP)%NSTSO,CIOIO,IDC,2,IDUMMY)
end if

if (ICISTR == 1) then
  call GASDN2_MCLR(I12,RHO1,RHO2,R,L,CB,SB,C2,CIOIO,SIOIO,ICSM,ISSM,CBLTP,SBLTP,NACOB,Str(IATP)%NSTSO,Str(IBTP)%NSTSO,NAEL,IATP, &
                   NBEL,IBTP,IOCTPA,IOCTPB,NOCTPA,NOCTPB,nIrrep,MXPNGAS,NTSOB,IBTSOB,MAXK,MAXI,LSCR1,LSCR1,C2(LSCR2+1:LSCR12), &
                   C2(1:LSCR2),NGAS,Str(IATP)%EL123,Str(IBTP)%EL123,IDC,OOS(:,1),OOS(:,2),OOS(:,3),OOS(:,4),OOS(:,5),OOS(:,6), &
                   OOS(:,7),OOS(:,8),OOS(:,9),OOS(:,10),IX(:,1),XIXS(:,1),IX(:,2),XIXS(:,2),IX(:,3),XIXS(:,3),IX(:,4),XIXS(:,4), &
                   INSCR,RHO1S,LUL,LUR,PSSIGN,PSSIGN,ieaw,n1,n2)
else if (ICISTR >= 2) then
  call GASDN2_MCLR(I12,RHO1,RHO2,R,L,R,L,C2,CIOIO,SIOIO,ICSM,ISSM,CBLTP,SBLTP,NACOB,Str(IATP)%NSTSO,Str(IBTP)%NSTSO,NAEL,IATP, &
                   NBEL,IBTP,IOCTPA,IOCTPB,NOCTPA,NOCTPB,nIrrep,MXPNGAS,NTSOB,IBTSOB,MAXK,MAXI,LSCR1,LSCR1,C2(LSCR2+1:LSCR12), &
                   C2(1:LSCR2),NGAS,Str(IATP)%EL123,Str(IBTP)%EL123,IDC,OOS(:,1),OOS(:,2),OOS(:,3),OOS(:,4),OOS(:,5),OOS(:,6), &
                   OOS(:,7),OOS(:,8),OOS(:,9),OOS(:,10),IX(:,1),XIXS(:,1),IX(:,2),XIXS(:,2),IX(:,3),XIXS(:,3),IX(:,4),XIXS(:,4), &
                   INSCR,RHO1S,LUL,LUR,PSSIGN,PSSIGN,ieaw,n1,n2)
end if

if ((IDC /= 1) .and. (ICISTR == 1)) then
  ! Transform from combination scaling to determinant scaling

  call SCDTC2_MCLR(L,ISSM,SBLTP,nIrrep,NOCTPA,NOCTPB,Str(IATP)%NSTSO,Str(IBTP)%NSTSO,SIOIO,IDC,1,IDUMMY)
  call SCDTC2_MCLR(R,ICSM,CBLTP,nIrrep,NOCTPA,NOCTPB,Str(IATP)%NSTSO,Str(IBTP)%NSTSO,CIOIO,IDC,1,IDUMMY)
end if

! Free memory

if (ICISTR == 1) then
  call mma_deallocate(CB)
  call mma_deallocate(SB)
end if
call mma_deallocate(INSCR)
call mma_deallocate(SIOIO)
call mma_deallocate(CIOIO)
call mma_deallocate(C2)
call mma_deallocate(IX)
call mma_deallocate(XIXS)
call mma_deallocate(SBLTP)
call mma_deallocate(CBLTP)
call mma_deallocate(OOS)
call mma_deallocate(RHO1S)
call mma_deallocate(RHO1P)
call mma_deallocate(XNATO)

end subroutine DENSI2_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine dkh_woplft(n,ifodd,nw,np,wr,rw,p1,p2,q1,q2,t1,t2)
C
C Product of W(nw)P(np)=Q(np+nw)
C
      implicit none
      integer n,nw,np,i,j
      logical ifodd
      Real*8 wr(n,n),rw(n,n),p1(n,n),p2(n,n),q1(n,n),q2(n,n)
      Real*8 t1(n,n),t2(n,n)
      call dmxma(n,'N','N',wr,p2,t1,1.d0)
      call dmxma(n,'N','N',rw,p1,t2,1.d0)
      do i=1,n
        do j=1,n
          q1(j,i) = t1(j,i)
          q2(j,i) = t2(j,i)
        end do
      end do
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_logical(ifodd)
        call Unused_integer(nw)
        call Unused_integer(np)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Name_All(LblCnt)

use Symmetry_Info, only: iOper, nIrrep, Symmetry_Info_Get
use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
character(len=*), intent(_OUT_) :: LblCnt(*)
integer(kind=iwp) :: Active = 0, i, iAll_Atom, iChAtom, iCoSet(0:7), iGen(3), iUnique_Atom, nAtoms, nCoSet, nGen
character(len=len(LblCnt)), allocatable :: LblCnt_Unique(:)
real(kind=wp), allocatable :: Coord(:,:)
integer(kind=iwp), external :: iChxyz

call Get_iScalar('Unique atoms',nAtoms)
call mma_allocate(Coord,3,nAtoms,label='Coord')
call mma_allocate(LblCnt_Unique,nAtoms,label='LblCnt_Unique')
call Get_dArray('Unique Coordinates',Coord,3*nAtoms)
select case (len(LblCnt))
  case (2)
    call Get_Name(LblCnt_Unique)
  case (LenIn)
    call Get_cArray('Unique Atom Names',LblCnt_Unique,LenIn*nAtoms)
  case default
    call SysAbendMsg('Get_Name_All','Wrong character length','Aborting')
end select
!                                                                      *
!***********************************************************************
!                                                                      *
if (Active == 0) then
  call Symmetry_Info_Get()
  Active = 1
end if
!                                                                      *
!***********************************************************************
!                                                                      *
nGen = 0
if (nIrrep == 2) nGen = 1
if (nIrrep == 4) nGen = 2
if (nIrrep == 8) nGen = 3
if (nGen >= 1) iGen(1) = iOper(1)
if (nGen >= 2) iGen(2) = iOper(2)
if (nGen == 3) iGen(3) = iOper(4)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute total number of centers.

iAll_Atom = 0
do iUnique_Atom=1,nAtoms

  iChAtom = iChxyz(Coord(:,iUnique_Atom),iGen,nGen)
  call CoSet(iCoSet,nCoSet,iChAtom)

  do i=1,nCoSet
    iAll_Atom = iAll_Atom+1
    LblCnt(iAll_Atom) = LblCnt_Unique(iUnique_Atom)
  end do

end do

!***********************************************************************
!                                                                      *
!write(u6,*) 'Exit Get_Name_All'

call mma_deallocate(Coord)
call mma_deallocate(LblCnt_Unique)

return

end subroutine Get_Name_All

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FockGen(d_0,rDens1,rdens2,Fock,FockOut,idSym)
!***********************************************************************
!                                                                      *
!   Constructs active Fock matrix and Q matrix                         *
!                                                                      *
!   Input: rkappa: Rotation matrix                                     *
!          idsym : symmetry of perturbation                            *
!                                                                      *
!                                                                      *
!   Output:MO     : MO integrals                                       *
!          Fock   : Fock matrix (one index transformed integrals)      *
!          MOtilde: MO (one index transformed integrals)               *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use Data_structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use MCLR_Data, only: CMO, FIMO, ipCM, ipMat, isNAC, nA, nDens, nNA
use input_mclr, only: LuAChoVec, nAsh, nBas, NewCho, nIsh, nOrb, nSym
use PCM_grad, only: do_RF, DSCFMO, iStpPCM, PCMPT2MO, PCMSCFMO, PCMSSMO, PT2_solv
use dmrginfo, only: DoDMRG, LRRAS2, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: d_0, rDens1(nna,nna), rDens2(*)
real(kind=wp), intent(out) :: Fock(nDens), FockOut(nDens)
integer(kind=iwp), intent(in) :: idSym
integer(kind=iwp) :: iA, iAA, iAsh, iB, iij, ijS, ikl, iOff, iOff2, iOff3, ip1, ip2, ipF, ipGx, ipM, ipS, iS, iSym, jA, jAA, jAsh, &
                     jS, jSym, kA, kAsh, kS, lAsh, lS, n1, n2, nAG2, nG2
real(kind=wp) :: rd
type(DSBA_type) :: CVa
real(kind=wp), allocatable :: G2x(:), MO(:), Scr(:), Scr1(:,:)

!                                                                      *
!***********************************************************************
!                                                                      *
Fock(:) = Zero

n1 = max(0,maxval(nBas(1:nSym)))
n2 = n1**2

if (doDMRG) nash(:) = RGras2(:)  ! yma

!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. NewCho) then  ! Cho-MO

  call mma_allocate(MO,n2,Label='MO')
  call mma_allocate(Scr,n2,Label='Scr')

  do ipS=1,nSym
    do kS=1,nSym
      do iS=1,nSym
        jS = Mul(Mul(ipS,kS),iS)
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Coulomb term: F  = 2(pk|ji)d
        !                kp           ij
        !                                                              *
        !***************************************************************
        !                                                              *
        if ((Mul(ipS,kS) == idSym) .and. (nBas(ipS)*nIsh(kS) > 0)) then
          do iA=1,nAsh(iS)
            iAA = iA+nIsh(iS)
            do jA=1,nAsh(jS)
              jAA = jA+nIsh(jS)

              call Coul(ipS,kS,iS,jS,iAA,jAA,MO,Scr)

              rD = rDens1(iA+nA(iS),jA+nA(jS))*Two
              Fock(ipMat(ipS,Ks):ipMat(ipS,Ks)+nBas(ipS)*nIsh(kS)-1) = Fock(ipMat(ipS,Ks):ipMat(ipS,Ks)+nBas(ipS)*nIsh(kS)-1)+ &
                                                                       rd*MO(1:nBas(ipS)*nIsh(kS))

            end do
          end do
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Exchange term: F = -(pk|ji)d
        !                 pl          kj
        !                                                              *
        !***************************************************************
        !                                                              *
        if ((Mul(ipS,iS) == idSym) .and. (nBas(ipS) > 0)) then
          do iA=1,nIsh(iS)
            ipF = ipMat(ipS,iS)+nBas(ipS)*(iA-1)
            do jA=1,nAsh(jS)
              jAA = jA+nIsh(jS)

              call Coul(ipS,kS,iS,jS,iA,jAA,MO,Scr)

              ipM = 1+nIsh(kS)*nBas(ipS)
              do kA=1,nAsh(kS)

                rd = rDens1(kA+nA(kS),jA+nA(jS))
                Fock(ipF:ipF+nBas(ipS)-1) = Fock(ipF:ipF+nBas(ipS)-1)-rd*MO(ipM:ipM+nBas(ipS)-1)
                ipM = ipM+nBas(ipS)
              end do

            end do
          end do
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
      end do
    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call CreQADD(Fock,rdens2,idSym,MO,Scr,n2)
  call mma_deallocate(Scr)
  call mma_deallocate(MO)

else  ! Cho-Fock

  !*********************************************************************
  !   new Cholesky code                                                *
  !*********************************************************************
  nG2 = 0
  do iSym=1,nSym
    nAG2 = 0
    do jSym=1,nSym
      nAG2 = nAg2+nAsh(jSym)*nAsh(Mul(jSym,iSym))
    end do
    nG2 = nG2+nAG2**2
  end do

  ! Unfold 2-DM

  call mma_allocate(G2x,nG2,Label='G2x')
  ipGx = 0
  do ijS=1,nSym
    do iS=1,nSym
      jS = Mul(is,ijS)
      do kS=1,nSym
        lS = Mul(kS,ijS)
        do kAsh=1,nAsh(ks)
          do lAsh=1,nAsh(ls)
            !ikl = iTri(lAsh+nA(lS),kAsh+nA(kS))
            ikl = nna*(lAsh+nA(lS)-1)+kAsh+nA(kS)
            do iAsh=1,nAsh(is)
              do jAsh=1,nAsh(js)
                !iij = iTri(iAsh+nA(is),jAsh+nA(jS))
                iij = nna*(jAsh+nA(jS)-1)+iAsh+nA(iS)
                ipGx = ipGx+1
                G2x(ipGx) = rdens2(iTri(iij,ikl))
              end do
            end do
          end do
        end do
      end do
    end do
  end do

  ! Get active CMO

  call Allocate_DT(CVa,nAsh,nBas,nSym)
  CVa%A0(:) = Zero

  ioff = 0
  do iS=1,nSym
    ioff2 = ioff+nOrb(iS)*nIsh(iS)
    do iB=1,nAsh(iS)
      ioff3 = ioff2+nOrb(iS)*(iB-1)
      CVa%SB(iS)%A1(iB:iB+nOrb(iS)*nAsh(iS)-1:nAsh(iS)) = CMO(ioff3+1:ioff3+nOrb(iS))
    end do
    ioff = ioff+(nIsh(iS)+nAsh(iS))*nOrb(iS)
  end do

  call mma_allocate(Scr1,n2,2,Label='Scr1')
  Scr1(:,:) = Zero

  call cho_fock_mclr(rdens1,G2x,Scr1(:,1),Scr1(:,2),Fock,CVa,CMO,nIsh,nAsh,LuAChoVec)

  call mma_deallocate(Scr1)
  call Deallocate_DT(CVa)
  call mma_deallocate(G2x)

  call GADSum(Fock,nDens)

end if

!***********************************************************************
!       Common part                                                    *
!***********************************************************************

do iS=1,nSym
  if (nBas(iS) > 0) then
    jS = Mul(is,idSym)
    do iA=1,nAsh(is)
      do jA=1,nAsh(js)
        rd = rDens1(iA+nA(iS),jA+nA(js))
        ip1 = nBas(iS)*(nIsh(is)+iA-1)+ipCM(is)
        ip2 = nBas(iS)*(nIsh(js)+jA-1)+ipmat(is,js)
        Fock(ip2:ip2+nBas(iS)-1) = Fock(ip2:ip2+nBas(iS)-1)+Rd*FIMO(ip1:ip1+nBas(iS)-1)
      end do
    end do
  end if
end do

if (idSym == 1) then
  do iS=1,nSym
    Fock(ipMat(is,is):ipMat(is,is)+nBas(iS)*nIsh(is)-1) = Fock(ipMat(is,is):ipMat(is,is)+nBas(iS)*nIsh(is)-1)+ &
                                                          Two*d_0*FIMO(ipMat(is,is):ipMat(is,is)+nBas(iS)*nIsh(is)-1)
  end do
end if

! PCM contributions
! The contribution to the free energy is kind of D1*K*D2/2
! (usually D1 \neq D2), so each contribution is separately
! evaluated and halved.

! No additional contributions during and after Z-vector here
! the implicit contributions are added in PCM_grad_TimesE2
! iStpPCM = 1   : derivative of the energy
! iStpPCM = 2,3 : derivative of the eigenstate (eigenenergy)
if (do_RF .and. (iStpPCM == 1)) then
  if (PT2_solv) PCMSSMO(:,3) = PCMSSMO(:,3)+PCMPT2MO(:,3)

  ! Compute V(rDens1) -> PCMRESMO
  ! rDens1 (MO) -> rDens1 (AO)
  do iS=1,nSym
    if (nBas(iS) > 0) then
      jS = Mul(iS,idSym)
      do iA=1,nAsh(is)
        do jA=1,nAsh(js)
          ip1 = nBas(iS)*(nIsh(is)+iA-1)+ipCM(is)
          ip2 = nBas(iS)*(nIsh(js)+jA-1)+ipmat(is,js)
          !! implicit D^SS*V(e,SCF)
          rd = DSCFMO(iA+nA(iS),jA+nA(js))
          Fock(ip2:ip2+nBas(iS)-1) = Fock(ip2:ip2+nBas(iS)-1)+Rd*PCMSSMO(ip1:ip1+nBas(iS)-1,3)
          !! explicit and implicit D^SA*V(e,SA)/2
          if (.not. isNAC) Fock(ip2:ip2+nBas(iS)-1) = Fock(ip2:ip2+nBas(iS)-1)-Rd*PCMSCFMO(ip1:ip1+nBas(iS)-1,3)
        end do
      end do
    end if
  end do

  ! inactive
  ! explicit derivative for NAC should be with d_0,
  ! but implicit contributions should not be scaled
  if (idSym == 1) then
    do iS=1,nSym
      if (nBas(iS)*nIsh(iS) > 0) then
        !! implicit D^SS*V(e,SCF)
        Fock(ipMat(is,is):ipMat(is,is)+nBas(iS)*nIsh(is)-1) = Fock(ipMat(is,is):ipMat(is,is)+nBas(iS)*nIsh(is)-1)+ &
                                                              Two*PCMSSMO(ipMat(is,is):ipMat(is,is)+nBas(iS)*nIsh(is)-1,3)
        !! explicit + implicit erfx
        Fock(ipMat(is,is):ipMat(is,is)+nBas(iS)*nIsh(is)-1) = Fock(ipMat(is,is):ipMat(is,is)+nBas(iS)*nIsh(is)-1)- &
                                                              Two*d_0*PCMSCFMO(ipMat(is,is):ipMat(is,is)+nBas(iS)*nIsh(is)-1,3)
      end if
    end do
  end if
  if (PT2_solv) PCMSSMO(:,3) = PCMSSMO(:,3)-PCMPT2MO(:,3)
end if

do iS=1,nSym
  jS = Mul(iS,idSym)
  if (nBas(is)*nBas(jS) /= 0) &
    call DGeSub(Fock(ipMat(iS,jS)),nBas(iS),'N',Fock(ipMat(jS,iS)),nBas(jS),'T',FockOut(ipMat(iS,jS)),nBas(iS),nBas(iS),nBas(jS))
end do

FockOut(:) = Two*FockOut(:)
if (idSym == 1) call AddGrad2(FockOut,d_0)

if (doDMRG) nash(:) = LRras2(:)  ! yma
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine FockGen

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
!      SUBROUTINE lp10_arbrbr_ext_calcuvalue(intentry,isma,nlp_value)
!      SUBROUTINE lp11_arblbr_ext_calcuvalue(intentry,isma,nlp_value)
!      SUBROUTINE lp12_arblbl_ext_calcuvalue(intentry,isma,nlp_value)
!      SUBROUTINE lp9_drlbl_ext_calcuvalue(lri,lrk,isma)
!      SUBROUTINE lp8_drlbr_sum_calcuvalue(lri,lrp,lrq,isma,nv)
!      SUBROUTINE lp9_drlbl_sum_calcuvalue(lri,lrp,lrq,isma,nv)
!      SUBROUTINE lp_arbl_ext_dd_calcuvalue(lri,lrj,iml,imr,nlp_value)
!      SUBROUTINE lp_ar_coe_calcuvalue(idtu,isma,lri,lrj,nlp_value,lpcoe
!      SUBROUTINE lp_drl_ext_SS_calcuvalue(lri,nlp_value)
!      SUBROUTINE lp_drl_sum_SS_calcuvalue(lri,lrj,nlp_value)
!      SUBROUTINE lp_drl_ext_ST_calcuvalue(lri,nlp_value)
!      SUBROUTINE lp_drl_ext_TT_calcuvalue(lri,n1415_value,nlp_value)
!      SUBROUTINE lp_drl_sum_TT_calcuvalue(lri,lrj,n1415,nlp_value)
!      SUBROUTINE lp_arbr_ext_svtv_calcuvalue(LRI,LRJ,nlp_value)
!      SUBROUTINE lp_drr_ext_svtv_calcuvalue(lri,nlp_value)
!      SUBROUTINE lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
!      SUBROUTINE lp678_ext_calcuvalue(lri,lrk,isma,nlp_value)
      subroutine lp_drl_ext_TS_calcuvalue(lri,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      intpos=intind_abkk(lri)
      intspace=intspace_abkk(lri)
      ivalue=0
!G1415
      if ( logic_g1415 ) then

      w1lp=w1_plp*w1g14a

      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
            do ia=iasta,min(iaend,ib-1)
              lra=norb_number(ia)
            ivalue=ivalue+1
C           value_lpext(ivalue)=vint_ci(intposia)*ww0lp
C    *         +vint_ci(intposia+1)*ww1lp+valuelpib
!  OK,only for Spin=0
         value_lpext(ivalue)=(voint(lra,lri)-voint(lrb,lri))*w1lp
            enddo
         enddo
      enddo
      endif

!G2G4b
      if ( logic_g2g4a ) then
        w0lp=w0_plp*w0g2a
        w1lp=w1_plp*w1g2a

C       valuelptmp1=w0lp
C       w0lp=w0lp-w1lp
C       w1lp=-valuelptmp1*2.d0
C       valuelptmp1=ww0lp
C       ww0lp=ww0lp-ww1lp
C       ww1lp=-valuelptmp1*2.d0

        do i=1,intspace
         ivalue=ivalue+2
!        Drl -- B^rA^l =4_2
      value_lpext(ivalue)=w1lp*vint_ci(intpos)
!        Drl -- B^lA^r =4_3
      value_lpext(ivalue-1)=-value_lpext(ivalue)
          intpos=intpos+2
        enddo
      endif

      intpos=intind_abkk(lri)
      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a

      do I=1,intspace
        ivalue=ivalue+1
        value_lpext(ivalue)=vint_ci(intpos+1)*w0lp-vint_ci(intpos)*w1lp
        intpos=intpos+2
      enddo
      nlp_value=ivalue
      end

      subroutine lp9_drlbl_ext_sd_calcuvalue(intentry,isma)   !,
!    *                                    nlp_value)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      w0_sdplp25=(w0_sdplp-w1_sdplp)*w0g25
      w1_sdplp25=-2.d0*w0_sdplp*w0g25
      intpos=intentry
      iaddpos=norb_act*2            !severe_new_error_1020
      ilpvalue=0
      do m_ia=1,nlsm_ext(isma)
         ilpvalue=ilpvalue+1
         value_lpext(ilpvalue)=w0_sdplp25*vint_ci(intpos)+
     *                  w1_sdplp25*vint_ci(intpos+1)
         intpos=intpos+iaddpos      !ip3ad_intspace   !severe_new_error_
      enddo
      end

      subroutine lp10_arbrbr_ext_calcuvalue(intentry,isma,nlp_value)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      w0_sdplp25=(w0_sdplp-w1_sdplp)*w0g25
      w1_sdplp25=(w0_sdplp+w1_sdplp)*w0g25
      intpos=intentry
      ilpvalue=0
      do m_ia=1,nlsm_ext(isma)
         ilpvalue=ilpvalue+1
         value_lpext(ilpvalue)=w0_sdplp25*vint_ci(intpos+2)+
     *                  w1_sdplp25*vint_ci(intpos+1)
         intpos=intpos+3
      enddo
      nlp_value=ilpvalue
      end

      subroutine lp11_arblbr_ext_calcuvalue(intentry,isma,nlp_value)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      w0_sdplp25=(w0_sdplp-w1_sdplp)*w0g25
      w1_sdplp25=-2.d0*w0_sdplp*w0g25
      intpos=intentry
      ilpvalue=0
      do m_ia=1,nlsm_ext(isma)
         ilpvalue=ilpvalue+1
         value_lpext(ilpvalue)=w0_sdplp25*vint_ci(intpos+1)+
     *                  w1_sdplp25*vint_ci(intpos)
         intpos=intpos+3
      enddo
      nlp_value=ilpvalue
      end

      subroutine lp12_arblbl_ext_calcuvalue(intentry,isma,nlp_value)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      w0_sdplp25=(w0_sdplp-w1_sdplp)*w0g25
      w1_sdplp25=-2.d0*w0_sdplp*w0g25
      intpos=intentry
      ilpvalue=0
      do m_ia=1,nlsm_ext(isma)
         ilpvalue=ilpvalue+1
         value_lpext(ilpvalue)=w0_sdplp25*vint_ci(intpos+2)+
     *                  w1_sdplp25*vint_ci(intpos)
         intpos=intpos+3

      enddo
      nlp_value=ilpvalue
      end

      subroutine lp_arbr_ext_svtv_calcuvalue(intentry,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"
      ivalue=0
!G36a
      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a
      valuelptmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=valuelptmp1+w1lp
      do intpos=intentry,intentry+ip2_intsymspace-3,3
!        intpos=intentry+lpext_int_index(ii)*3-3
         ivalue=ivalue+1
!        ArBr -- B^rA^r =10
         value_lpext(ivalue)=vint_ci(intpos+2)*w0lp
     *                  +vint_ci(intpos+1)*w1lp
      enddo
!G36b
!G1415
      if ( logic_g13 ) then
         w0lp=w0g13a*(w0_plp+w1_plp)
         intpos=intentry+ip2_intsymspace
         do ia=1,norb_ext
            ivalue=ivalue+1
            value_lpext(ivalue)=w0lp*vint_ci(intpos)
!    *                  -vint_ci(intpos+1)*2.d0)
            intpos=intpos+2
         enddo
      endif
      nlp_value=ivalue
      end
      subroutine lp_drr_ext_svtv_calcuvalue(intentry,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ivalue=0
!G36a
      w0lp=(w0_plp+w1_plp)*w0g36a
      do intpos=intentry,intentry+ip2_drl_drl_intspace-2,2         !seve
!        intpos=intentry+lpext_int_index(ii)*3-3
         ivalue=ivalue+1
         value_lpext(ivalue)=vint_ci(intpos)*w0lp
!    *                  -vint_ci(intpos)*w1lp      !severe_error_1111
      enddo

      if ( logic_g13 ) then
!        intpos=intentry+ip2_drl_drlintstart
         w0lp=0.5d0*w0_plp*w0g13a
!        isma=ism_g1415
!        na_tmp=nlsm_ext(isma)
         do intpos=intentry+ip2_drl_drl_intspace,
     *               intentry+ip2_drl_intspace-2,2         !severe_new_e
!        do ia=1,na_tmp
            ivalue=ivalue+1
            value_lpext(ivalue)=vint_ci(intpos+1)*w0lp
!    *            +vint_ci(intpos+1)*w1lp
!           intpos=intpos+2
         enddo
      endif
      nlp_value=ivalue
      end

      subroutine lp9_drlbl_ext_calcuvalue_wyb(lri,lrk,isma)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      next_sta=ibsm_ext(isma)-1
      w0_sdplp25=(w0_sdplp-w1_sdplp)*w0g25
      w1_sdplp25=-2.d0*w0_sdplp*w0g25
      ia0=(lri-1)*norb_ext
      idorbint=lrk*2-2
      ilpvalue =0
      do m_ia=1,nlsm_ext(isma)
          ilpvalue=ilpvalue+1
          ira=m_ia+next_sta
          ia=ia0+ira
          intposbase=intind_iaqq(ia)
          intpos=intposbase+idorbint
          value_lpext(ilpvalue)=w0_sdplp25*vint_ci(intpos)+
     *                          w1_sdplp25*vint_ci(intpos+1)
      enddo
      end

      subroutine lp8_drlbr_sum_calcuvalue_wyb(lri,lrp,lrq,isma,nv)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      dimension vint_0(MAX_INNORB,MAX_EXTORB),
     :          vint_1(MAX_INNORB,MAX_EXTORB)

      vint_0(1:norb_inn,1:norb_ext)=viasum_0(1:norb_inn,1:norb_ext)
      vint_1(1:norb_inn,1:norb_ext)=viasum_1(1:norb_inn,1:norb_ext)

      next_sta=ibsm_ext(isma)-1
      ia0=(lri-1)*norb_ext
      idorbint_q=lrq*2-2
      do m_ia=1,nlsm_ext(isma)
        ira=m_ia+next_sta
        ia=ia0+ira
        intposbase=intind_iaqq(ia)
        if(lrp.ne.0) then
          idorbint_p=lrp*2-2
          intpos=intposbase+idorbint_p
          vint_0(lri,ira)=vint_0(lri,ira)-vint_ci(intpos)
          vint_1(lri,ira)=vint_1(lri,ira)-vint_ci(intpos+1)
        endif
        if(lrq.ne.0) then
          idorbint_q=lrq*2-2
          intpos=intposbase+idorbint_q
          vint_0(lri,ira)=vint_0(lri,ira)-vint_ci(intpos)
          vint_1(lri,ira)=vint_1(lri,ira)-vint_ci(intpos+1)
        endif
      enddo

      w0_sdplp25=w0_sdplp*w0g25
      w1_sdplp25=2*w0_sdplp*w0g25

      ilpvalue =0
      do m_ia=1,nlsm_ext(isma)
          ilpvalue=ilpvalue+1
          ira=m_ia+next_sta
          value_lpext(ilpvalue)=w0_sdplp25*vint_0(lri,ira)   !value_lptm
     :                       -w1_sdplp25*vint_1(lri,ira)
      enddo
      nv=   ilpvalue
      end

      subroutine lp9_drlbl_sum_calcuvalue_wyb(lri,lrp,lrq,isma,nv)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      dimension vint_0(MAX_INNORB,MAX_EXTORB),
     :          vint_1(MAX_INNORB,MAX_EXTORB)

      vint_0(1:norb_INN,1:norb_ext)=viasum_0(1:norb_INN,1:norb_ext)
      vint_1(1:norb_INN,1:norb_ext)=viasum_1(1:norb_INN,1:norb_ext)

      next_sta=ibsm_ext(isma)-1
      ia0=(lri-1)*norb_ext
      idorbint_q=lrq*2-2
      do m_ia=1,nlsm_ext(isma)
        ira=m_ia+next_sta
        ia=ia0+ira
        intposbase=intind_iaqq(ia)
        if(lrp.ne.0) then
          idorbint_p=lrp*2-2
          intpos=intposbase+idorbint_p
          vint_0(lri,ira)=vint_0(lri,ira)-vint_ci(intpos)
          vint_1(lri,ira)=vint_1(lri,ira)-vint_ci(intpos+1)
        endif
        if(lrq.ne.0) then
          idorbint_q=lrq*2-2
          intpos=intposbase+idorbint_q
          vint_0(lri,ira)=vint_0(lri,ira)-vint_ci(intpos)
          vint_1(lri,ira)=vint_1(lri,ira)-vint_ci(intpos+1)
        endif
      enddo

      next_sta=ibsm_ext(isma)-1
      w0_sdplp25=w0_sdplp*w0g25
      w1_sdplp25=-2.d0*w0_sdplp*w0g25

      ilpvalue =0
      do m_ia=1,nlsm_ext(isma)
          ilpvalue=ilpvalue+1
          ira=m_ia+next_sta
          value_lpext(ilpvalue)=w0_sdplp25*vint_0(lri,ira)+
     *                        w1_sdplp25*vint_1(lri,ira)
      enddo
      nv=   ilpvalue
      end

      subroutine lp_drl_ext_dd_calcuvalue_wyb(lri,iml,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"
      w0lp=w0_plp*w0gdd
      w1lp=w1_plp*w1gdd
      nliml=nlsm_ext(iml)
      iasta=ibsm_ext(iml)
      iaend=iesm_ext(iml)
      intpos0=intind_abkk(lri)
      intspace=intspace_abkk(lri)
      ivalue=0
      jvalue=0
      if(.not.logic_g49b) goto 100
      DO ira=iasta,iaend
        ivalue=ivalue+1
        lra=norb_number(ira)
        value_lpext(ivalue)=-w1lp*voint(lra,lri)
      ENDDO
100   mloop=nliml*(nliml-1)/2
      intpos=intpos0+int_dd_drl*2
      ivalue=ivalue+int_dd_drl
      do I=1,mloop
        ivalue=ivalue+1
        jvalue=ivalue+mloop
        value_lpext(ivalue)=w0lp*vint_ci(intpos+1)-w1lp*vint_ci(intpos)
        value_lpext(jvalue)=value_lpext(ivalue)
        intpos=intpos+2
      enddo
      nlp_value=jvalue
      end

      subroutine lp_arbl_ext_dd_calcuvalue(lri,lrj,iml,imr,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ij=LRI-norb_frz+NGW2(LRJ-norb_frz)
      nliml=nlsm_ext(iml)
      nlbf=ibsm_ext(iml)-1
      intoffset=2*nlbf
      nlimr=nlsm_ext(imr)
      w0lp=w0_plp*w0gdd
      w1lp=w1_plp*w1gdd
      valuetmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=-valuetmp1*2.d0
      ivalue=0
!G50
      if ( logic_g50 ) then
        intentry=intind_ijcc(ij)

        mcloop=nliml
        intpos=intentry+intoffset
        do I=1,mcloop
          ivalue=ivalue+1
          value_lpext(ivalue)=vint_ci(intpos)*w0lp
     *            +vint_ci(intpos+1)*w1lp
          intpos=intpos+2
        enddo
      endif

      intentry=intind_ijab(ij)
      mcloop=nliml*nlimr
      if(iml.eq.imr)  mcloop=nliml*(nliml-1)/2
      INTPOS=INTENTRY
      ivalue =ivalue
      intoffset=int_dd_drl*3
      INTPOS=INTENTRY+intoffset
      ivalue=ivalue+int_dd_drl
      if (logic_g49a ) then
!G49a:Bl_Ar  line=12
        do I=1,MCLOOP
          ivalue=ivalue+1
          value_lpext(ivalue)=vint_ci(intpos+2)*w0lp
     *                  +vint_ci(intpos)*w1lp
          INTPOS=INTPOS+3
        enddo
      ENDIF
!G49b:Br_Al  line=11
      INTPOS=INTENTRY+intoffset
      if (logic_g49b) then
        do I=1,MCLOOP
          ivalue=ivalue+1
          value_lpext(ivalue)=vint_ci(intpos+1)*w0lp
     *                  +vint_ci(intpos)*w1lp
          INTPOS=INTPOS+3
        enddo
      endif
      nlp_value=ivalue
      end

      subroutine lp_ar_coe_calcuvalue_wyb
     *          (idtu,isma,lri,lrj,nlp_value,lpcoe)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      REAL*8 valuetmp
      dimension lpcoe(norb_dz+1:norb_inn)
C      idtu=25,26,28,25(43),46,51,100(in act_space)

      next_sta=ibsm_ext(isma)-1
      w0_sdplp25=w0_sdplp*w0g25
      ia0=(lri-1)*norb_ext
C      idorbint=lri*2-2
C      intpos=intposbase+idorbint
      ilpvalue=0
C      intposbase=intentry

      if(idtu.eq.100) then
        lsta=lri
        lend=norb_inn
        do m_ia=1,nlsm_ext(isma)
          ira=m_ia+next_sta
          lra=norb_number(ira)
          valuetmp=voint(lri,lra)
C          valuetmp=0.D0
          ia=ia0+ira
          intposbase=intind_iaqq(ia)
          do iorb=lsta,lend
            KCOE=lpcoe(iorb)
            CALL NEOC(KCOE,NOCC,TCOE)
            idorbint=(iorb-1)*2
            intpos=intposbase+idorbint
        valuetmp=valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
C            WL=WL+NEOC(K)*VLOP0*(VINT(LIST+2)+COE(K)*VINT(LIST+1))
          enddo
          ilpvalue=ilpvalue+1
          value_lpext(ilpvalue)=w0_sdplp25*valuetmp
        enddo
        nlp_value=nlsm_ext(isma)
        return
      endif

      if(idtu.eq.51) then
      ndorb=norb_DZ-lri
      do m_ia=1,nlsm_ext(isma)
          ira=m_ia+next_sta
            lra=norb_number(ira)
            valuetmp=voint(lri,lra)
C            valuetmp=0.d0
            ia=ia0+ira
            intposbase=intind_iaqq(ia)
            idorbint=-2
            if(LOGIC_DH) then
              idorbint=lri*2-2
              intpos=intposbase+idorbint
              valuetmp=valuetmp+vint_ci(intpos)
              do idorb=1,ndorb
                idorbint=idorbint+2
                intpos=intposbase+idorbint
                valuetmp=valuetmp+2.d0*vint_ci(intpos+1)-vint_ci(intpos)
              enddo
            endif
            iorbs=max(norb_dz+1,lri)
            do iorb=iorbs,norb_inn
              Kcoe=lpcoe(iorb)
              CALL NEOC(KCOE,NOCC,TCOE)
              idorbint=iorb*2-2
              intpos=intposbase+idorbint
        valuetmp=valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
C            WL=WL+NEOC(K)*VLOP0*(VINT(LIST+2)+COE(K)*VINT(LIST+1))
            enddo
            ilpvalue=ilpvalue+1
            value_lpext(ilpvalue)=w0_sdplp25*valuetmp
        enddo
        nlp_value=nlsm_ext(isma)
        return
      endif

      if(idtu.eq.25.or.idtu.eq.43) then
      do m_ia=1,nlsm_ext(isma)
        ira=m_ia+next_sta
        lra=norb_number(ira)
        valuetmp=voint(lri,lra)
C        valuetmp=0.d0
        ia=ia0+ira
        intposbase=intind_iaqq(ia)
        idorbint=lri*2-2
        intpos=intposbase+idorbint
        valuetmp=valuetmp+vint_ci(intpos)
        do idorb=lri+1,norb_dz
          idorbint=idorbint+2
          intpos=intposbase+idorbint
          valuetmp=valuetmp+2.d0*vint_ci(intpos+1)-vint_ci(intpos)
        enddo
        iorbs=max(norb_dz+1,lri)
        do iorb=iorbs,norb_inn
          Kcoe=lpcoe(iorb)
          CALL NEOC(KCOE,NOCC,TCOE)
          idorbint=iorb*2-2
          intpos=intposbase+idorbint
        valuetmp=valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
C            WL=WL+NEOC(K)*VLOP0*(VINT(LIST+2)+COE(K)*VINT(LIST+1))
        enddo
        ilpvalue=ilpvalue+1
        value_lpext(ilpvalue)=w0_sdplp25*valuetmp
      enddo
      nlp_value=nlsm_ext(isma)
      return
      endif

      if(idtu.eq.26) then
          ndorb=norb_DZ-lri
        do m_ia=1,nlsm_ext(isma)
          ira=m_ia+next_sta
          lra=norb_number(ira)
          valuetmp=voint(lri,lra)              !310
          ia=ia0+ira
          intposbase=intind_iaqq(ia)
          idorbint=lri*2-2
        if(LOGIC_DH) then
            do idorb=1,ndorb
              idorbint=idorbint+2
              intpos=intposbase+idorbint
              valuetmp=valuetmp+2.d0*vint_ci(intpos+1)-vint_ci(intpos)
            enddo
        endif
            do iorb=norb_dz+1,norb_inn
              Kcoe=lpcoe(iorb)
              CALL NEOC(KCOE,NOCC,TCOE)
              idorbint=idorbint+2
              intpos=intposbase+idorbint
        valuetmp=valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
C            WL=WL+NEOC(K)*VLOP0*(VINT(LIST+2)+COE(K)*VINT(LIST+1))
            enddo

            ilpvalue=ilpvalue+1
            value_lpext(ilpvalue)=w0_sdplp25*valuetmp
        enddo
      nlp_value=nlsm_ext(isma)
      return
      endif
      if(idtu.eq.28.OR.idtu.eq.46) then
      nsorb=1
      ndorb=norb_DZ-lri-1
        if(ndorb.gt.0) nsorb=1
        if(idtu.eq.28) then
          icoe=-(JB_SYS+2)
        else !if(idtu.eq.46)
          icoe=0
        endif
        do m_ia=1,nlsm_ext(isma)
            ira=m_ia+next_sta
            lra=norb_number(ira)
            ia=ia0+ira
            intposbase=intind_iaqq(ia)
            idorbint=lri*2-2
            intpos=intposbase+idorbint
            valuetmp=voint(lri,lra)+vint_ci(intpos)        ! 310+710
            if(nsorb.gt.0) then
              do iorb=lri+1,norb_dz
               idorbint=idorbint+2
                intpos=intposbase+idorbint
                if(iorb.eq.lrj) valuetmp=valuetmp+
     *                  vint_ci(intpos+1)+icoe*vint_ci(intpos)
                if(iorb.ne.lrj) valuetmp=valuetmp+
     *                    2.d0*vint_ci(intpos+1)-vint_ci(intpos)
              enddo
            endif
            do iorb=norb_dz+1,norb_inn
              Kcoe=lpcoe(iorb)
              CALL NEOC(KCOE,NOCC,TCOE)
              idorbint=idorbint+2
              intpos=intposbase+idorbint
        valuetmp=valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
C            WL=WL+NEOC(K)*VLOP0*(VINT(LIST+2)+COE(K)*VINT(LIST+1))
            enddo

            ilpvalue=ilpvalue+1
            value_lpext(ilpvalue)=w0_sdplp25*valuetmp
            intposbase=intposbase+norb_inn*2
        enddo
        nlp_value=nlsm_ext(isma)
      return
      endif
      if(idtu.eq.57.or.idtu.eq.29) then
      nsorb=1
      ndorb=norb_DZ-lri-1
        if(ndorb.gt.0) nsorb=1
        if(idtu.eq.29) then
            icoe=JB_SYS
        else !if(idtu.eq.57)
            icoe=-1
        endif
        do m_ia=1,nlsm_ext(isma)
            ira=m_ia+next_sta
            lra=norb_number(ira)
            ia=ia0+ira
            intposbase=intind_iaqq(ia)
            idorbint=lri*2-2
            intpos=intposbase+idorbint
            valuetmp=voint(lri,lra)+vint_ci(intpos)        ! 310+710
            if(nsorb.gt.0) then
              do iorb=lri+1,norb_dz
               idorbint=idorbint+2
                intpos=intposbase+idorbint
                if(iorb.eq.lrj) valuetmp=valuetmp+
     *                  vint_ci(intpos+1)+icoe*vint_ci(intpos)
                if(iorb.ne.lrj) valuetmp=valuetmp+
     *                    2.d0*vint_ci(intpos+1)-vint_ci(intpos)
              enddo
            endif
            do iorb=norb_dz+1,norb_inn
              Kcoe=lpcoe(iorb)
              CALL NEOC(KCOE,NOCC,TCOE)
              idorbint=idorbint+2
              intpos=intposbase+idorbint
        valuetmp=valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
C            WL=WL+NEOC(K)*VLOP0*(VINT(LIST+2)+COE(K)*VINT(LIST+1))
            enddo

            ilpvalue=ilpvalue+1
            value_lpext(ilpvalue)=w0_sdplp25*valuetmp
            intposbase=intposbase+norb_inn*2
        enddo
        nlp_value=nlsm_ext(isma)
      return
      endif
!=====================
      if(idtu.eq.55.or.idtu.eq.73) then    !(11)(23)=55 (11)(13)=75
      do m_ia=1,nlsm_ext(isma)
        ira=m_ia+next_sta
        lra=norb_number(ira)
        valuetmp=voint(lri,lra)
C        valuetmp=0.d0
        ia=ia0+ira
        intposbase=intind_iaqq(ia)
        idorbint=lri*2-2
        intpos=intposbase+idorbint
        valuetmp=valuetmp+vint_ci(intpos)
        do idorb=lri+1,norb_dz
          idorbint=idorbint+2
          intpos=intposbase+idorbint
          valuetmp=valuetmp+2.d0*vint_ci(intpos+1)-vint_ci(intpos)
        enddo
        iorbs=max(norb_dz+1,lri)
        do iorb=iorbs,norb_inn
          Kcoe=lpcoe(iorb)
          CALL NEOC(KCOE,NOCC,TCOE)
          idorbint=iorb*2-2
          intpos=intposbase+idorbint
        valuetmp=valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
C            WL=WL+NEOC(K)*VLOP0*(VINT(LIST+2)+COE(K)*VINT(LIST+1))
        enddo
        ilpvalue=ilpvalue+1
        value_lpext(ilpvalue)=w0_sdplp25*valuetmp
      enddo
      nlp_value=nlsm_ext(isma)
      return
      endif

      end

      subroutine lp_drl_ext_SS_calcuvalue(lri,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      intpos=intind_abkk(lri)
      intspace=intspace_abkk(lri)
      ivalue=0

!G2G4b
      if ( logic_g2g4a ) then
        w0lp=w0_plp*w0g2a
        w1lp=w1_plp*w1g2a
        ww0lp=w0_plp*w0g4a
        ww1lp=w1_plp*w1g4a

C       valuelptmp1=w0lp
C       w0lp=w0lp-w1lp
C       w1lp=-valuelptmp1*2.d0
C       valuelptmp1=ww0lp
C       ww0lp=ww0lp-ww1lp
C       ww1lp=-valuelptmp1*2.d0

        do i=1,intspace
         ivalue=ivalue+2
!        Drl -- B^lA^r =4_3
      value_lpext(ivalue)=vint_ci(intpos+1)*w0lp-vint_ci(intpos)*w1lp
!        Drl -- B^rA^l =4_2
      value_lpext(ivalue-1)=(w0lp-w1lp)*vint_ci(intpos)
          intpos=intpos+2
        enddo
      endif

      intpos=intind_abkk(lri)
      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a

      do I=1,intspace
        ivalue=ivalue+1
        value_lpext(ivalue)=vint_ci(intpos+1)*w0lp-vint_ci(intpos)*w1lp
        intpos=intpos+2
      enddo
      nlp_value=ivalue
      end

      subroutine lp_drl_sum_SS_calcuvalue(lri,lrj,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension vint_0(norb_ext*norb_ext),vint_1(norb_ext*norb_ext)

      intspace=intspace_abkk(1)
      vint_0(1:intspace)=vijkk_0sum(1:intspace)
      vint_1(1:intspace)=vijkk_1sum(1:intspace)

      if(lri.ne.0) then
        intpos=intind_abkk(lri)
        do I=1,intspace
          vint_0(I)=vint_0(I)-vint_ci(intpos)
          vint_1(I)=vint_1(I)-vint_ci(intpos+1)
          intpos=intpos+2
        enddo
      endif
      if(lrj.ne.0) then
        intpos=intind_abkk(lrj)
        do I=1,intspace
          vint_0(I)=vint_0(I)-vint_ci(intpos)
          vint_1(I)=vint_1(I)-vint_ci(intpos+1)
          intpos=intpos+2
        enddo
      endif

       ivalue=0
!G2G4b
        if ( logic_g2g4a ) then
          w0lp=w0_plp*w0g2a
          w1lp=w1_plp*w1g2a
          ww0lp=w0_plp*w0g4a
          ww1lp=w1_plp*w1g4a
          do i=1,intspace
           ivalue=ivalue+2
!        Drl -- B^lA^r =4_3
      value_lpext(ivalue)=vint_1(i)*w0lp-vint_0(i)*w1lp
!        Drl -- B^rA^l =4_2
      value_lpext(ivalue-1)=(w0lp-w1lp)*vint_0(i)
          enddo
        endif

        w0lp=w0_plp*w0g36a
        w1lp=w1_plp*w1g36a

        do I=1,intspace
          ivalue=ivalue+1
          value_lpext(ivalue)=vint_1(i)*w0lp-vint_0(i)*w1lp
        enddo

        w0lp=w0_plp*w0g36a
        w1lp=w1_plp*w1g36a

        do I=1,intspace
          ivalue=ivalue+1
          value_lpext(ivalue)=
     :          vint_1(i)*w0lp-vint_0(i)*w1lp
        enddo
      nlp_value=ivalue
      end

      subroutine lp_drl_ext_ST_calcuvalue(lri,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ivalue=0
!G1415
      if ( logic_g1415 ) then

      w1lp=w1_plp*w1g14a

      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
            do ia=iasta,min(iaend,ib-1)
              lra=norb_number(ia)
            ivalue=ivalue+1
C           value_lpext(ivalue)=vint_ci(intposia)*ww0lp
C    *         +vint_ci(intposia+1)*ww1lp+valuelpib
!  OK,only for Spin=0
         value_lpext(ivalue)=(voint(lra,lri)-voint(lrb,lri))*w1lp
            enddo
         enddo
      enddo
      endif

      intpos=intind_abkk(lri)
      intspace=intspace_abkk(lri)
!G2G4b
      if ( logic_g2g4b ) then
        w1lp=w1_plp*w1g4b

        do i=1,intspace
         ivalue=ivalue+2
!        Drl -- B^lA^r =4_3
      value_lpext(ivalue)  =w1lp*vint_ci(intpos)
!        Drl -- B^rA^l =4_2
      value_lpext(ivalue-1)=-value_lpext(ivalue)
          intpos=intpos+2
        enddo
      endif

      intpos=intind_abkk(lri)
      w1lp=w1_plp*w1g36a

      do I=1,intspace
        ivalue=ivalue+1
        value_lpext(ivalue)=-vint_ci(intpos)*w1lp
        intpos=intpos+2
      enddo
      nlp_value=ivalue
      end

      subroutine lp_drl_ext_TT_calcuvalue(lri,n1415_value,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ivalue=0
!G1415
      if ( logic_g1415 ) then

      w014=w0_plp*w0g14a
      w114=w1_plp*w1g14a
      w015=w0_plp*w0g15a
      w115=w1_plp*w1g15a

      w14lp=w014-w114
      w15lp=w015-w115

      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
            do ia=iasta,min(iaend,ib-1)
              lra=norb_number(ia)
            ivalue=ivalue+1
          value_lpext(ivalue)=w15lp*voint(lra,lri)+w14lp*voint(lrb,lri)
         enddo
         enddo
      enddo
      endif

      n1415_value=ivalue
      intpos=intind_abkk(lri)
      intspace=intspace_abkk(lri)

      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a

      do I=1,intspace
        ivalue=ivalue+1
        value_lpext(ivalue)=vint_ci(intpos+1)*w0lp-vint_ci(intpos)*w1lp
        intpos=intpos+2
      enddo
      nlp_value=ivalue
      end

      subroutine lp_drl_sum_TT_calcuvalue(lri,lrj,n1415,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension vint_0(norb_ext*norb_ext),vint_1(norb_ext*norb_ext)
      intspace=intspace_abkk(1)
      vint_0(1:intspace)=vijkk_0sum(1:intspace)
      vint_1(1:intspace)=vijkk_1sum(1:intspace)

      if(lri.ne.0) then
        intpos=intind_abkk(lri)
        do I=1,intspace
          vint_0(I)=vint_0(I)-vint_ci(intpos)
          vint_1(I)=vint_1(I)-vint_ci(intpos+1)
          intpos=intpos+2
        enddo
      endif
      if(lrj.ne.0) then
        intpos=intind_abkk(lrj)
        do I=1,intspace
          vint_0(I)=vint_0(I)-vint_ci(intpos)
          vint_1(I)=vint_1(I)-vint_ci(intpos+1)
          intpos=intpos+2
        enddo
      endif

      lrk0=1
      if(lri.eq.1) lrk0=2
      if(lrj.eq.2) lrk0=3
      ivalue=0
!G1415
      if ( logic_g1415 ) then

      w014=w0_plp*w0g14a
      w015=w0_plp*w0g15a

      w14lp=w014
      w15lp=w015

      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
            do ia=iasta,min(iaend,ib-1)
              lra=norb_number(ia)
            ivalue=ivalue+1
        value_lpext(ivalue)=w15lp*voint(lra,lrk0)+w14lp*voint(lrb,lrk0)
              do lrk=lrk0+1,norb_dz
                if(lrk.eq.lri) cycle
                if(lrk.eq.lrj) cycle
        value_lpext(ivalue)=value_lpext(ivalue)+
     :         w15lp*voint(lra,lrk)+w14lp*voint(lrb,lrk)
              enddo
          enddo
         enddo
      enddo
      endif

      n1415=ivalue
      w0lp=w0_plp*w0g36a

      do I=1,intspace
        ivalue=ivalue+1
        value_lpext(ivalue)=vint_1(I)*w0lp
      enddo
      nlp_value=ivalue
      end

      subroutine lp_arbr_ext_svtv_calcuvalue_wyb(LRI,LRJ,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"
      IJ=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)
      intentry=intind_ijab(ij)
      intspace=intspace_ijab(ij)
      ivalue=0
      intpos=intentry
!G36a
      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a
      valuelptmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=valuelptmp1+w1lp
!        ArBr -- B^rA^r =10
      do i=1,intspace
        ivalue=ivalue+1
        value_lpext(ivalue)=vint_ci(intpos+2)*w0lp
     *                  +vint_ci(intpos+1)*w1lp
        intpos=intpos+3
      enddo
!G36b
!G1415
      if ( logic_g13 ) then
      intentry=intind_ijcc(IJ)
      intpos=intentry
      intspace=intspace_ijcc(ij)
      w0lp=w0g13a*(w0_plp+w1_plp)
      do i=1,intspace
          ivalue=ivalue+1
!        ArBr -- D^r^r
         value_lpext(ivalue)=w0lp*vint_ci(intpos)
         intpos=intpos+2
      enddo
      endif
      nlp_value=ivalue
      end

      subroutine lp_drr_ext_svtv_calcuvalue_wyb(lri,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      intpos=intind_abkk(lri)
      intspace=intspace_abkk(lri)
      ivalue=0
!G36a
      w0lp=(w0_plp+w1_plp)*w0g36a
      DO I=1,intspace
        ivalue=ivalue+1
        value_lpext(ivalue)=vint_ci(intpos)*w0lp
        intpos=intpos+2
      enddo

      if ( logic_g13 ) then
        w0lp=0.5d0*w0_plp*w0g13a
        do LRA=NORB_ALL,NORB_INN+1,-1
          ivalue=ivalue+1
          value_lpext(ivalue)=voint(LRA,LRI)*w0lp
        enddo
      endif
      nlp_value=ivalue
      end

      subroutine lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"
      ivalue=0
      ij=LRI-norb_frz+NGW2(LRJ-norb_frz)
      intpos=intind_ijcc(IJ)
      INTSPACE=intspace_ijcc(IJ)
!      lmij=mul_tab(lsm_inn(lri),lsm_inn(lrj))
!G1415
      if ( logic_g1415 ) then

      w0lp=w0_plp*w0g14a
      w1lp=w1_plp*w1g14a
      ww0lp=w0_plp*w0g15a
      ww1lp=w1_plp*w1g15a

      valuelptmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=-valuelptmp1*2.d0
      valuelptmp1=ww0lp
      ww0lp=ww0lp-ww1lp
      ww1lp=-valuelptmp1*2.d0

      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
!         lmab=mul_tab(isma,ismb)
!         if(lmab.ne.lmij) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
           intposib=intpos+ib*2-2
           valuelpib=vint_ci(intposib)*w0lp+vint_ci(intposib+1)*w1lp
           do ia=iasta,min(iaend,ib-1)
             intposia=intpos+ia*2-2
             ivalue=ivalue+1
             valp=vint_ci(intposia)*ww0lp+vint_ci(intposia+1)*ww1lp
             value_lpext(ivalue)=valp+valuelpib
           enddo
         enddo
      enddo
      endif
!G13
      if ( logic_g13 ) then
         w0lp=w0g13a*w0_plp
         do ia=1,norb_ext
             intpos13=intpos+ia*2-2
            ivalue=ivalue+1
            value_lpext(ivalue)=w0lp*(vint_ci(intpos13)
     :                         -vint_ci(intpos13+1)*2.d0)
            intpos13=intpos13+2
         enddo
      endif

      INTSPACE=intspace_ijab(IJ)
!G2G4a
      if ( logic_g2g4a ) then
        intpos=intind_ijab(IJ)

        w0lp=w0_plp*w0g2a
        w1lp=w1_plp*w1g2a
        ww0lp=w0_plp*w0g4a
        ww1lp=w1_plp*w1g4a

        valuelptmp1=w0lp
        w0lp=w0lp-w1lp
        w1lp=-valuelptmp1*2.d0
        valuelptmp1=ww0lp
        ww0lp=ww0lp-ww1lp
        ww1lp=-valuelptmp1*2.d0

        do i=1,intspace
         ivalue=ivalue+2
!        ArBl -- B^lA^r =12
         value_lpext(ivalue-1)=vint_ci(intpos+2)*w0lp
     *               +vint_ci(intpos)*w1lp
!        ArBl -- B^rA^l =11
         value_lpext(ivalue)=vint_ci(intpos+1)*ww0lp
     *               +vint_ci(intpos)*ww1lp
          intpos=intpos+3
        enddo
      else
!G2G4b
      if ( logic_g2g4b ) then
        intpos=intind_ijab(IJ)
        w0lp=w0_plp*w0g2b
        w1lp=w1_plp*w1g2b
        ww0lp=w0_plp*w0g4b
        ww1lp=w1_plp*w1g4b

        valuelptmp1=w0lp
        w0lp=w0lp-w1lp
        w1lp=-valuelptmp1*2.d0
        valuelptmp1=ww0lp
        ww0lp=ww0lp-ww1lp
        ww1lp=-valuelptmp1*2.d0

        do i=1,intspace
         ivalue=ivalue+2
!        ArBl -- B^lA^r =12
         value_lpext(ivalue-1)=vint_ci(intpos+2)*ww0lp
     *               +vint_ci(intpos)*ww1lp
!        ArBl -- B^rA^l =11
         value_lpext(ivalue)=vint_ci(intpos+1)*w0lp
     *               +vint_ci(intpos)*w1lp
          intpos=intpos+3
        enddo
      endif

      endif
!G36a
      intpos=intind_ijab(IJ)
      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a
      valuelptmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=-valuelptmp1*2.d0
      do i=1,intspace
        ivalue=ivalue+1
!       ArBl -- B^lA^r =12
        value_lpext(ivalue)=vint_ci(intpos+2)*w0lp
     *                     +vint_ci(intpos)*w1lp
        intpos=intpos+3
      enddo
!G36b
      intpos=intind_ijab(IJ)
      w0lp=w0_plp*w0g36b
      w1lp=w1_plp*w1g36b
      valuelptmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=-valuelptmp1*2.d0
      do i=1,intspace
         ivalue=ivalue+1
!        ArBl -- B^rA^l =11
        value_lpext(ivalue)=vint_ci(intpos+1)*w0lp+vint_ci(intpos)*w1lp
          intpos=intpos+3
      enddo
      nlp_value=ivalue
      end

!   lp7_ar_drl,lp7_drr_br,lp8_drl_br
      subroutine lp678_ext_wyb_calcuvalue(lri,lrk,isma,nlp_value)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      w0_sdplp25=w0_sdplp*w0g25
      ia0=(lri-1)*norb_ext
      intoffset=(lrk-1)*2
      ilpvalue=0
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      do ia=iasta,iaend
         iaqq=ia0+ia
         intpos=intind_iaqq(iaqq)
         iposint=intpos+intoffset
         ilpvalue=ilpvalue+1
         value_lpext(ilpvalue)=w0_sdplp25*vint_ci(iposint)
      enddo
      nlp_value=nlsm_ext(isma)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Store_Not_Grad
!
!> @brief Mark a vector as non-computable in the gradients file
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Marks a gradient or coupling vector in the gradients file (GRADS)
!> as non-computable. This is useful, for example, to allow SLAPAF
!> to proceed with an approximate coupling vector if it cannot be
!> computed with the current method.
!> For a gradient use \p iNAC, \p jNAC = 0. For a coupling vector use
!> \p iRoot = 0.
!>
!> @param[in] iRoot Root number to which the gradient belongs
!> @param[in] iNAC  First root of a coupling vector
!> @param[in] jNAC  Second root of a coupling vector
!***********************************************************************

subroutine Store_Not_Grad(iRoot,iNAC,jNAC)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iRoot, iNAC, jNAC
integer(kind=iwp) :: iAd, idx, iSt, jSt, Length(1), LuGrad, nCoup, nGrad, nRoots, TOC(5)
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: i_grad(:), i_nac(:)
character(len=5), parameter :: Filename = 'GRADS'

! Create GRADS file if it does not exist

call Get_iScalar('Number of roots',nRoots)
call Get_iScalar('Unique atoms',nGrad)
nGrad = 3*nGrad
LuGrad = 20
call f_Inquire(Filename,Found)
if (.not. Found) call Create_Grads(Filename,nRoots,nGrad)

! Read the header

call DaName(LuGrad,Filename)
iAd = 0
call iDaFile(LuGrad,2,TOC,size(TOC),iAd)
call iDaFile(LuGrad,2,Length,1,iAd)
if (Length(1) /= nRoots) then
  call WarningMessage(2,'Bad number of roots in GRADS file')
  call Abend()
end if
call iDaFile(LuGrad,2,Length,1,iAd)
if (Length(1) /= nGrad) then
  call WarningMessage(2,'Bad length in GRADS file')
  call Abend()
end if
nCoup = max(1,nRoots*(nRoots-1)/2)
call mma_Allocate(i_grad,nRoots)
call mma_Allocate(i_nac,nCoup)
call iDaFile(LuGrad,2,i_grad,nRoots,iAd)
call iDaFile(LuGrad,2,i_nac,nCoup,iAd)

! Write the negative index that marks it as non-computable

if (iRoot == 0) then
  if ((iNAC /= 0) .and. (jNAC /= 0)) then
    iSt = max(iNAC,jNAC)-1
    jSt = min(iNAC,jNAC)
    idx = iSt*(iSt-1)/2+jSt
    i_nac(idx) = -1
    iAd = TOC(4)
    call iDaFile(LuGrad,1,i_nac,nCoup,iAd)
  end if
else
  idx = iRoot
  i_grad(idx) = -1
  iAd = TOC(3)
  call iDaFile(LuGrad,1,i_grad,nRoots,iAd)
end if

call DaClos(LuGrad)
call mma_Deallocate(i_grad)
call mma_Deallocate(i_nac)

end subroutine Store_Not_Grad

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_DIAGINT(ISHLA,ISHLB,SCR,LSCR)
C
C     Purpose: call Seward to calculate diagonal shell (AB|AB).
C
      IMPLICIT REAL*8 (A-H,O-Z)
      EXTERNAL  Integral_WrOut_Cho_diag
      DIMENSION SCR(LSCR)
#include "itmax.fh"
#include "cholesky.fh"
#if defined (_DEBUGPRINT_)
      CHARACTER*15 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_DIAGINT')
#endif

      NAB = MAX(ISHLA,ISHLB)*(MAX(ISHLA,ISHLB)+1)/2+MIN(ISHLA,ISHLB)
      XAB = DBLE(NAB)

      CALL CHO_DZERO(SCR,LSCR)

#if defined (_DEBUGPRINT_)
      CALL CHO_PRESCR(CUTINT1,THRINT1)
#endif

      CALL EVAL_IJKL(ISHLA,ISHLB,ISHLA,ISHLB,SCR,LSCR,
     &               Integral_WrOut_Cho_diag)

#if defined (_DEBUGPRINT_)
      CALL CHO_PRESCR(CUTINT2,THRINT2)
      IF (CUTINT2.NE.CUTINT1 .OR. THRINT2.NE.THRINT1) THEN
         WRITE(LUPRI,*) SECNAM,': CutInt before Eval_Ints_: ',CUTINT1
         WRITE(LUPRI,*) SECNAM,': CutInt after  Eval_Ints_: ',CUTINT2
         WRITE(LUPRI,*) SECNAM,': ThrInt before Eval_Ints_: ',THRINT1
         WRITE(LUPRI,*) SECNAM,': ThrInt after  Eval_Ints_: ',THRINT2
         CALL CHO_QUIT('Integral prescreening error detected in '
     &                 //SECNAM,102)
      END IF
#endif

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  QuaterSetup
!
!> @brief
!>   Transforms \p V2 such that \f$ U_1 \cdot V_1 = U_2 \cdot V_2 \f$
!> @author Y. Carissan
!>
!> @details
!> Transforms \p V2 such that \f$ U_1 \cdot V_1 = U_2 \cdot V_2 \f$.
!>
!> @param[in,out] U1 Input Vector
!> @param[in,out] V1 Input Vector
!> @param[in,out] U2 Input Vector
!> @param[in,out] V2 Input and output Vector
!***********************************************************************

subroutine QuaterSetup(U1,U2,V1,V2)

use Quater_globals, only: debug
use Constants, only: One
use Definitions, only: wp, r8

implicit none
real(kind=wp), intent(inout) :: U1(3), V1(3), U2(3), V2(3)
real(kind=wp) :: coeff, U1dU2, V1dV2
real(kind=r8), external :: ddot_

call normalizeVec(U1)
call normalizeVec(V1)
call normalizeVec(U2)
call normalizeVec(V2)

if (debug) then
  call RecPrt('IN QUATERSETUP normalized U1','',U1,3,1)
  call RecPrt('IN QUATERSETUP normalized V1','',V1,3,1)
  call RecPrt('IN QUATERSETUP normalized U2','',U2,3,1)
  call RecPrt('IN QUATERSETUP normalized V2','',V2,3,1)
end if

U1dU2 = ddot_(3,U1,1,U2,1)
V1dV2 = ddot_(3,V1,1,V2,1)
coeff = (One-U1dU2**2)/(One-V1dV2**2)
coeff = sqrt(coeff)
V2(:) = (U1dU2-V1dV2*coeff)*V1(:)+coeff*V2(:)
if (debug) call RecPrt('IN QUATERSETUP modified V2','',V2,3,1)

return

end subroutine QuaterSetup

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1996, Markus P. Fuelscher                         *
!***********************************************************************

subroutine EXPLH2(DIAG,ONEINT,TUVX,ISEL,EXPLE,EXPLV)
!***********************************************************************
!                                                                      *
!     Compute and diagonalize the explicit Hamiltonian in a            *
!     subspace smaller or identical to nSel. nSel may be chosen        *
!     somewhat smaller in order to avoid selecting only one of         *
!     several degenerate diagonal matrix elements.                     *
!                                                                      *
!     calling arguments:                                               *
!     DIAG    : array of Real*8                                        *
!               diagonal Hamiltonian                                   *
!     ONEINT  : array of Real*8                                        *
!               one-electron integrals                                 *
!     TUVX    : array of Real*8                                        *
!               two-electron integrals                                 *
!     ISEL    : array of integer                                       *
!               index array                                            *
!     EXPLE   : array of Real*8                                        *
!               eigenvalues of the explicit Hamiltonian                *
!     EXPLV   : array of Real*8                                        *
!               eigenvectors of the explicit Hamiltonian               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher and J. Olsen                                      *
!     University of Lund, Sweden, 1990                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!     - updated for integral direct and reaction field calculations    *
!       M.P. Fuelscher, University of Lund, Sweden, 1996               *
!                                                                      *
!***********************************************************************

use csfbas, only: CONF, KDFTP, KDTOC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: DIAG(*), EXPLE(*), EXPLV(*)
real(kind=wp), intent(in) :: ONEINT(*), TUVX(*)
integer(kind=iwp), intent(_OUT_) :: ISEL(*)
integer(kind=iwp) :: I, II, IPRLEV, MXXSEL, MXXWS, NHEX, NPCNF
real(kind=wp) :: ECORE
integer(kind=iwp), allocatable :: CNF(:), IREOTS(:)
real(kind=wp), allocatable :: EXHAM(:), HONE(:,:), Scr(:)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "ciinfo.fh"
#include "strnum.fh"
#include "WrkSpc.fh"
#include "timers.fh"
#include "output_ras.fh"

call Timing(Omega_1,Swatch,Swatch,Swatch)
IPRLEV = IPRLOC(3)

ECORE = Zero
MXXSEL = NSEL
NHEX = NSEL*(NSEL+1)/2

! ALLOCATE LOCAL MEMORY

call mma_allocate(CNF,NCNASM(STSYM),label='IPCNF')
call mma_allocate(HONE,NAC,NAC,label='HONE')
call mma_allocate(EXHAM,NHEX,label='EXHAM')

! EXPAND ONE-INTS FROM TRIANGULAR PACKING TO FULL STORAGE MODE

call TRIEXP(ONEINT,HONE,NAC)

! Load the diagonal approximation of the CI Hamiltonian

call Load_H_diag(nConf,DIAG,LuDavid)

! CONSTRUCT THE EXPLICIT HAMILTONIAN

IPRINT = 0
if (IPRLEV == INSANE) IPRINT = 40
call mma_allocate(IREOTS,NAC,label='IREOTS')
call mma_maxDBLE(MXXWS)
call mma_allocate(Scr,MXXWS,label='EXHSCR')
call GET_IREOTS(IREOTS,NAC)
call PHPCSF(EXHAM,ISEL,CNF,MXXSEL,Work(KDTOC),iWork(KDFTP),CONF,STSYM,HONE,ECORE,NAC,Scr,NCNASM(STSYM),NAEL+NBEL,NAEL,NBEL,NSEL, &
            NPCNF,DIAG,TUVX,IPRINT,ExFac,IREOTS)
if (IPRLEV == INSANE) then
  call Square(EXHAM,EXPLV,1,NSEL,NSEL)
  call RECPRT('Square Explicit Hamiltonian',' ',EXPLV,NSEL,NSEL)
end if
call mma_deallocate(IREOTS)
call mma_deallocate(Scr)
call mma_deallocate(CNF)
call mma_deallocate(HONE)

! DIAGONALIZE THE EXPLICIT HAMILTONIAN.

!if (nSel == nConf) then
if (.true.) then
  EXPLV(1:NSEL*NSEL) = Zero
  do I=1,NSEL
    II = I+NSEL*(I-1)
    EXPLV(II) = One
  end do
  !call Jacob(EXHAM,EXPLV,NSEL,NSEL)
  !# ifdef _DEBUGPRINT_
  !call NIdiag(EXHAM,EXPLV,NSEL,NSEL)
  !# else
  call NIdiag_new(EXHAM,EXPLV,NSEL,NSEL)
  !# endif
  call JACORD(EXHAM,EXPLV,NSEL,NSEL)
  do I=1,NSEL
    EXPLE(I) = EXHAM(I*(I+1)/2)
  end do
else
  call mma_allocate(Scr,nSel,label='ExHscr')
  call Square(EXHAM,EXPLV,1,NSEL,NSEL)
  call Eigen_Molcas(NSEL,EXPLV,EXPLE,Scr)
  call mma_deallocate(Scr)
end if
call mma_deallocate(EXHAM)
if (IPRLEV >= INSANE) call IVCPRT('Configurations included in the explicit Hamiltonian',' ',ISEL,NSEL)
if (IPRLEV >= INSANE) call DVCPRT('Eigenvalues of the explicit Hamiltonian',' ',EXPLE,NSEL)
if (IPRLEV >= INSANE) call RECPRT('Eigenvectors of the explicit Hamiltonian',' ',EXPLV,NSEL,NSEL)

call Timing(Omega_2,Swatch,Swatch,Swatch)
Omega_2 = Omega_2-Omega_1
Omega_3 = Omega_3+Omega_2

return

end subroutine EXPLH2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine dampF(r,RHOAB,NCMM,MMLR,IVSR,IDSTT,DM)

use LEVEL_COMMON, only: bDS, cDS
use Constants, only: One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: r, RHOAB
integer(kind=iwp), intent(in) :: NCMM, MMLR(NCMM), IVSR, IDSTT
real(kind=wp), intent(out) :: DM(NCMM)
integer(kind=iwp) :: FIRST = 1, m, MM
real(kind=wp) :: br, XP, YP, ZK
real(kind=wp), save :: bpm(20,-2:0), cpm(20,-2:0)

!write(u6,*) 'Made it inside of dampF! IVSR=',IVSR
if (NCMM > 4) write(u6,*) 'IDSTT=',IDSTT
if (FIRST == 1) then
  do m=1,20
    bpm(m,:) = bDS(-2:0)/real(m,kind=wp)
    cpm(m,:) = cDS(-2:0)/sqrt(real(m,kind=wp))
  end do
  FIRST = 0
end if
br = RHOAB*r
!write(u6,*) 'NCMM=',NCMM
do m=1,NCMM
  MM = MMLR(m)
  XP = exp(-(bpm(MM,IVSR)+cpm(MM,IVSR)*br)*br)
  YP = One-XP
  ZK = MM-One
  DM(m) = YP**(MM-1)
  !... Actually ...  DM(m)= YP**(MM + IVSR/2)  :  set it up this way to
  !   avoid taking exponential of a logarithm for fractional powers (slow)
  select case (IVSR)
    case (-4)
      ZK = ZK-One
      DM(m) = DM(m)/YP
    case (-3)
      ZK = ZK-Half
      DM(m) = DM(m)/sqrt(YP)
    case (-1)
      ZK = ZK+Half
      DM(m) = DM(m)*sqrt(YP)
    case (0)
      ZK = MM
      DM(m) = DM(m)*YP
    case (-9)
  end select
end do

return

!600 format(/,' *** ERROR ***  For  IDSTT=',i3,'   IVSR=',i3,' no damping function is defined')
!602 format( /,' ***ERROR ***  RHOAB=', F7.4,'  yields an invalid Damping Function definition')

end subroutine dampF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine utmul(EXCH,N,Z,ML)
! the same as UTMU, except being that the input M is
! being transformed and only one projection is done at a time.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: EXCH, N
complex(kind=wp), intent(in) :: Z(N,N)
complex(kind=wp), intent(inout) :: ML(EXCH,EXCH)
integer(kind=iwp) :: I, i1, J, j1
real(kind=wp) :: R1, R2
complex(kind=wp), allocatable :: MTMP(:,:), TMP(:,:), TMP2(:,:)
real(kind=wp), external :: dznrm2_

if ((N <= 0) .or. (EXCH <= 0)) then
  write(u6,'(A)') 'in UTMU2:   EXCH or N<=0 !!!'
  write(u6,*) 'EXCH=',EXCH
  write(u6,*) 'N   =',N
  call xquit(128)
end if

if (N > EXCH) then
  write(u6,'(A)') 'in UTMU2:   EXCH < N !!!'
  write(u6,*) 'EXCH=',EXCH
  write(u6,*) 'N   =',N
  write(u6,'(A)') 'Nothing is to be done >> Return'
  call xquit(128)
end if

R1 = dznrm2_(EXCH*EXCH,ML,1)
R2 = dznrm2_(N*N,Z,1)
if ((R1 < 1.0e-25_wp) .or. (R2 < 1.0e-25_wp)) then
  write(u6,'(A)') 'in UTMU2:   M or Z are empty!!!'
  write(u6,*) 'norm(M)=',R1
  write(u6,*) 'norm(Z)=',R2
  call xquit(128)
end if

#ifdef _DEBUGPRINT_
write(u6,'(A)') 'UTMU :: input moment'
do i=1,EXCH
  do j=1,EXCH
    write(u6,'(A,i3,A,i3,A,3(2ES16.8,2x))') '<',i,'|ML|',j,'>',ML(i,j)
  end do
end do
#endif

call mma_allocate(TMP,N,EXCH,'TMP')
if (N /= EXCH) then
  call mma_allocate(MTMP,(EXCH-N),(EXCH-N),'MTMP')
  ! save the part which is not altered
  do i=N+1,EXCH
    do j=N+1,EXCH
      i1 = i-N
      j1 = j-N
      MTMP(i1,j1) = ML(i,j)
    end do
  end do
end if

if (N == EXCH) then
  call zgemm_('C','N',EXCH,EXCH,EXCH,cOne,Z,EXCH,ML,EXCH,cZero,TMP,EXCH)
  call zgemm_('N','N',EXCH,EXCH,EXCH,cOne,TMP,EXCH,Z,EXCH,cZero,ML,EXCH)

else

  call mma_allocate(TMP2,N,EXCH,'TMP2')
  TMP2(:,:) = ML(1:N,:)
  call ZGEMM_('C','N',N,N,N,cOne,Z,N,TMP2(:,1:N),EXCH,cZero,TMP(:,1:N),N)
  call ZGEMM_('N','N',N,N,N,cOne,TMP(:,1:N),N,Z,N,cZero,TMP2(:,1:N),EXCH)
  ML(1:N,1:N) = TMP2(:,1:N)
  call ZGEMM_('C','N',N,EXCH,N,cOne,Z,N,TMP2,EXCH,cZero,TMP,N)
  call mma_deallocate(TMP2)

  do I=1,N
    ML(I,N+1:) = TMP(I,N+1:)
    ML(N+1:,I) = conjg(TMP(I,N+1:))
  end do
  ML(N+1:,N+1:) = MTMP(1:EXCH-N,1:EXCH-N)

end if !N == exch

#ifdef _DEBUGPRINT_
write(u6,'(A)') 'UTMU :: unitary transformtion matrix'
do i=1,N
  do j=1,N
    write(u6,'(A,i3,A,i3,A,3(2ES16.8,2x))') '<',i,'| U |',j,'>',Z(i,j)
  end do
end do
write(u6,'(A)') 'UTMU :: output moment'
do i=1,EXCH
  do j=1,EXCH
    write(u6,'(A,i3,A,i3,A,3(2ES16.8,2x))') '<',i,'|ML|',j,'>',ML(i,j)
  end do
end do
#endif

if (N < EXCH) call mma_deallocate(MTMP)
call mma_deallocate(TMP)

return

end subroutine utmul

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHO_LK_RASSI(ipDLT,ipMSQ1,ipMSQ2,ipFLT,ipK,ipInt,
     &                              ipAsh,nScreen,dmpk)

**********************************************************************
*  Author : F. Aquilante
*
*  Note: this routine should be used only to compute the FI matrix
*        for cases in which the 2 sets of MOs are identical and
*        therefore FI is symmetric and stored as LT matrix.
*        For historical reasons, the routine is written as if it
*        could handle the more general case of different MOs.
*
*        Please, for that purpose, use CHO_LK_RASSI_X instead!
*
C *************** INACTIVE AO-BASIS FOCK MATRIX **********************
C
C   FI(ab) = 2 * sum_J  Lab,J * U(J)  -  sum_Jk  Xka,J * Ykb,J
C
C      U(J) = sum_gd  Lgd,J * DI(gd)
C
C      a,b,g,d:  AO-index
C      k:        MO-index   belonging to (Inactive)
C      v,w,x,y:  MO-indeces belonging to (Active)
C
**********************************************************************

      Implicit Real*8 (a-h,o-z)
#include "warnings.fh"
      Integer   rc,ipLxy(8),ipScr(8,8)
      Integer   ipLpq(8,2)
      Integer   iSkip(8),kOff(8)
      Integer   ISTLT(8),ISTK(8),ISSQ(8,8)
      Real*8    tread(2),tcoul(2),texch(2),tintg(2)
      Real*8    tmotr(2),tscrn(2)
      Integer   ipAsh(2),ipAorb(8,2)
      Integer   ipMO(2),ipYk(2),ipMLk(2),ipIndsh(2),ipSk(2)
      Integer   ipMSQ(2),ipCM(2),ipY(2),ipML(2),ipIndx(2),ipSksh(2)
      Logical   Debug,timings,DoRead,DoReord,DoScreen
      Logical   Estimate,Update,Deco,PseudoChoMOs
      Real*8    FactCI,FactXI,dmpk
      Character*50 CFmt
      Character*12 SECNAM
      Parameter (SECNAM = 'CHO_LK_RASSI')
      COMMON    /CHOTIME /timings
      COMMON /LKSCREEN / Estimate, Update, Deco, PseudoChoMOs
      Logical Fake_CMO2
      COMMON / CHO_JOBS / Fake_CMO2

      parameter (DoRead = .false. )
      parameter (FactCI = 1.0D0, FactXI = -1.0D0)
      parameter (zero = 0.0D0, one = 1.0D0, xone=-1.0D0)

#include "rassi.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
#include "para_info.fh"

      parameter ( N2 = InfVec_N2 )
      Character*6 mode
      Real*8   LKThr
      Integer  Cho_F2SP
      External Cho_F2SP
      Integer  Cho_LK_MaxVecPerBatch
      External Cho_LK_MaxVecPerBatch
      Real*8   Cho_LK_ScreeningThreshold
      External Cho_LK_ScreeningThreshold

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
******
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
******
      NBASSH(I,J)=IWORK(ip_NBASSH-1+NSYM*(J-1)+I)
******
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
******
      nnBfShp(j,i) = iWork(ip_nnBfShp-1+nnShl_tot*(i-1)+j)
******
      ipLab(i,j) = iWork(ip_Lab+nShell*(j-1)+i-1)
******
      kOffSh(i,j) = iWork(ip_kOffSh+nShell*(j-1)+i-1)
******
      iShp_rs(i) = iWork(ip_iShp_rs+i-1)
******
      SvShp(i) = Work(ip_SvShp+i-1)
****** next is a trick to save memory. Memory in "location 2" is used
******      to store this offset array defined later on
      iOffShp(i,j) = iWork(ip_iiBstRSh+nSym*nnShl-1+nSym*(j-1)+i)
************************************************************************


#ifdef _DEBUGPRINT_
c      Debug=.true.
      Debug=.false.! to avoid double printing in CASSCF-debug
#else
      Debug=.false.
#endif


      DoReord = .false.
      IREDC = -1  ! unknown reduced set in core
      ipMSQ(1)=ipMSQ1
      ipMSQ(2)=ipMSQ2

      nDen = 2  ! the two bi-orthonormal sets of orbitals
      If (Fake_CMO2) nDen = 1  ! MO1 = MO2
      kDen=nDen

      CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

      do i=1,2            ! 1 --> CPU   2 --> Wall
         tread(i) = zero  !time read/transform vectors
         tcoul(i) = zero  !time for computing Coulomb
         texch(i) = zero  !time for computing Exchange
         tintg(i) = zero  !time for computing (tw|xy) integrals
         tmotr(i) = zero  !time for the half-transf of vectors
         tscrn(i) = zero  !time for screening overhead
      end do

C ==================================================================

c --- Various offsets
c --------------------
      nnO=0
      kOff(1)=0
      MaxB=nBas(1)
      nsBB=nBas(1)**2
      ISTLT(1)=0
      ISTK(1)=0
      DO ISYM=2,NSYM
        MaxB=Max(MaxB,nBas(iSym))
        nsBB = nsBB + nBas(iSym)**2
        NBB=NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NBB ! Inactive D and F matrices
        nK = nIsh(iSym-1) + nAsh(iSym-1)
        ISTK(ISYM)=ISTK(ISYM-1)+nBas(iSym-1)*nK ! Inact. MO coeff.
        nnO = nnO + nIsh(iSym-1)
        kOff(iSym)=nnO
      END DO
      nnO = nnO + nIsh(nSym)

      nnBSQ=0
      DO LSYM=1,NSYM
         DO KSYM=LSYM,NSYM
            ISSQ(KSYM,LSYM) = nnBSQ
            ISSQ(LSYM,KSYM) = nnBSQ ! symmetrization
            nnBSQ = nnBSQ + nBas(kSym)*nBas(lSym)
         END DO
      END DO

**************************************************
      If (Deco) Then

         Call GetMem('ChoMOs','Allo','Real',ipCM(1),nsBB*nDen)
         ipCM(2)=ipCM(1)+(nDen-1)*nsBB

         If (PseudoChoMOs) Then
            Call cho_get_MO(iOK,nDen,nSym,nBas,nIsh,ipMSQ,
     &                          ISTLT,ISTK,ipCM)
         Else
            Call cho_lr_MOs(iOK,nDen,nSym,nBas,nIsh,ipMSQ,
     &                          ISTLT,ISTK,ipCM)
         EndIf

         If (iOK.eq.0) Then ! point to the "generalized" Cholesky MOs
           do jden=1,nDen
              ipMSQ(jden)=ipCM(jden)
           end do
c           write(6,*)'Cholesky MOs used for state A'
c           If(nDen.eq.2)write(6,*)'Pseudo Cholesky MOs used for state B'
         Else
           write(6,*)'*******************************'
           write(6,*)'*** Resort to Canonical MOs ***'
           write(6,*)'*******************************'
         EndIf

      EndIf
**************************************************

      DO jDen=1,nDen

         ipAorb(1,jDen)= ipAsh(jDen)

         DO ISYM=2,NSYM

            ipAorb(iSym,jDen) = ipAorb(iSym-1,jDen)
     &                        + nAsh(iSym-1)*nBas(iSym-1)

         END DO

      END DO

C --- Define the max number of vectors to be treated in core at once

      MaxVecPerBatch=Cho_LK_MaxVecPerBatch()

C --- Define the screening threshold

C threshold for max BLB matrix element
C Note: must be consistent with threshold in subroutine rasscf/rasscf_init.f
      THRSX=1.D-04
      LKThr=Cho_LK_ScreeningThreshold(THRSX)
      tau = (LKThr/Max(1,nnO))*dmpk

      MaxRedT=MaxRed
      Call GAIGOP_SCAL(MaxRedT,'+')

      If (Estimate) tau=tau/MaxRedT

      xtau = sqrt(tau)

C --- Vector MO transformation screening thresholds
      NumVT=NumChT
      Call GAIGOP_SCAL(NumVT,'+')
      thrv = (sqrt(LKThr/(Max(1,nnO)*NumVT)))*dmpk

      CALL GETMEM('diagI','Allo','Real',ipDIAG,NNBSTRT(1))

#if defined (_MOLCAS_MPP_)
      If (nProcs.gt.1 .and. Update .and. Is_Real_Par()) Then
         NNBSTMX=0
         Do i=1,nSym
            NNBSTMX = Max(NNBSTMX,NNBSTR(i,1))
         End Do
         CALL GETMEM('diagJ','Allo','Real',ipjDIAG,NNBSTMX)
         Call FZero(Work(ipjDIAG),NNBSTMX)
      EndIf
#endif
C *************** Read the diagonal integrals (stored as 1st red set)
      If (Update) CALL CHO_IODIAG(Work(ipDIAG),2) ! 2 means "read"

c --- allocate memory for sqrt(D(a,b)) stored in full (squared) dim
      CALL GETMEM('diahI','Allo','Real',ipDIAH,NNBSQ)
      CALL FZERO(Work(ipDIAH),NNBSQ)

c --- allocate memory for the abs(C(l)[k])
      Call GetMem('absc','Allo','Real',ipAbs,MaxB)

      Do jDen=1,nDen
c --- allocate memory for the Y(l)[k] vectors
         Call GetMem('yc','Allo','Real',ipY(jDen),MaxB*nnO)
c --- allocate memory for the ML[k] lists of largest elements
c --- in significant shells
         Call GetMem('MLk','Allo','Real',ipML(jDen),nShell*nnO)
c --- allocate memory for the lists of  S:= sum_l abs(C(l)[k])
c --- for each shell
         Call GetMem('SKsh','Allo','Real',ipSKsh(jDen),nShell*nnO)
c --- allocate memory for the Index arrays
         Call GetMem('Indx','Allo','Inte',ipIndx(jDen),(nShell+1)*nnO)
      End Do

c --- allocate memory for ipLab
      Call GetMem('ip_Lab','Allo','Inte',ip_Lab,nDen*nShell)

c --- allocate memory for kOffSh
      Call GetMem('ip_kOffSh','Allo','Inte',ip_kOffSh,nShell*nSym)

c --- allocate memory for nnBfShp
      Call GetMem('ip_nnBfShp','Allo','Inte',ip_nnBfShp,nnShl_tot*nSym)

c --- allocate memory for iShp_rs
      Call GetMem('ip_iShp_rs','Allo','Inte',ip_iShp_rs,nnShl_tot)

c --- allocate memory for the shell-pair Frobenius norm of the vectors
      Call GetMem('ip_SvShp','Allo','Real',ip_SvShp,2*nnShl)


C *** Compute Shell Offsets ( MOs and transformed vectors)

      MxBasSh = 0

      Do iSyma=1,nSym

         LKsh=0

         Do iaSh=1,nShell    ! kOffSh(iSh,iSym)

            iWork(ip_kOffSh+nShell*(iSyma-1)+iaSh-1) = LKsh

            LKsh = LKsh + nBasSh(iSyma,iaSh)

            MxBasSh = Max(MxBasSh,nBasSh(iSyma,iaSh))

         End Do

      End Do


C --- allocate memory for the diagonal elements of the Fock matrix
      Call GetMem('F(k)ss','Allo','Real',ipFk,MxBasSh+nShell)
      Call FZero(Work(ipFk),MxBasSh+nShell)

C *** Determine S:= sum_l C(l)[k]^2  in each shell of C(a,k)
      Do jDen=1,nDen
         Do kSym=1,nSym

            Do jK=1,nIsh(kSym)

               ipMO(jDen) = ipMSQ(jDen) + ISTK(kSym) + nBas(kSym)*(jK-1)

               ipSk(jDen) = ipSKsh(jDen) + nShell*(kOff(kSym) + jK - 1)

               Do iaSh=1,nShell

                  ipMsh = ipMO(jDen) + kOffSh(iaSh,kSym)

                  SKsh=zero
                  Do ik=0,nBasSh(kSym,iaSh)-1
                     SKsh = SKsh + Work(ipMsh+ik)**2
                  End Do

                  Work(ipSk(jDen)+iaSh-1) = SKsh

               End Do

            End Do
         End Do
      End Do

C *** Compute Shell-pair Offsets in the K-matrix

         Do iSyma=1,nSym

            LKshp=0

            Do iaSh=1,nShell

             Do ibSh=1,iaSh

               iShp = iaSh*(iaSh-1)/2 + ibSh

               iWork(ip_nnBfShp - 1 + nnShl_tot*(iSyma-1)
     &        + iShp) = LKShp   ! nnBfShp(iShp,iSyma)

               LKShp = LKShp + nBasSh(iSyma,iaSh)*nBasSh(iSyma,ibSh)
     &                       - (1-Min((iaSh-ibSh),1))*nBasSh(iSyma,iaSh)
     &                       * (nBasSh(iSyma,iaSh) - 1)/2

             End Do

            End Do

         End Do

C *** Mapping shell pairs from the full to the reduced set

      Do iaSh=1,nShell
         Do ibSh=1,iaSh
            iShp = iaSh*(iaSh-1)/2 + ibSh
            iWork(ip_iShp_rs+iShp-1) = Cho_F2SP(iShp)
         End Do
      End Do



C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
      DO jSym=1,nSym


         NumCV=NumCho(jSym)
         Call GAIGOP_SCAL(NumCV,'max')
         If (NumCV .lt. 1) GOTO 1000

C *** Compute Shell pair Offsets   iOffShp(iSyma,iShp)

         LFULL=0

         Do iaSh=1,nShell

          Do ibSh=1,iaSh

           iShp = iaSh*(iaSh-1)/2 + ibSh

           If (iShp_rs(iShp).gt.0) Then

            If (nnBstRSh(Jsym,iShp_rs(iShp),1).gt.0) Then

             Do iSymb=1,nSym

              iSyma=MulD2h(iSymb,Jsym)

              If (iSyma.ge.iSymb) Then

               iWork(ip_iiBstRSh + nSym*nnShl - 1
     &         + nSym*(iShp_rs(iShp)-1) + iSyma) = LFULL

                 LFULL = LFULL + nBasSh(iSyma,iaSh)*nBasSh(iSymb,ibSh)
     &        + Min(1,(iaSh-ibSh))*nBasSh(iSyma,ibSh)*nBasSh(iSymb,iaSh)

              EndIf

             End Do

            EndIf

           EndIf

          End Do

         End Do


C *** memory for the (tw|xy) integrals --- temporary array
      Mtwxy = 0
      Do iSymy=1,nSym
         iSymx=MulD2h(iSymy,JSYM)
         Do iSymw=iSymy,nSym    ! iSymw.ge.iSymy (particle symmetry)
            iSymt=MulD2h(isymw,JSYM)
            Mtwxy=Mtwxy+nAsh(iSymt)*nAsh(iSymw)*nAsh(iSymx)*nAsh(iSymy)
         End Do
      End Do

      Call GetMem('Mtmp','ALLO','REAL',ipItmp,Mtwxy)
      Call Fzero(Work(ipItmp),Mtwxy)

C *** setup pointers to the symmetry blocks of (tw|xy)
      Do i=1,nSym
         Do j=1,nSym
            ipScr(j,i) = ipItmp
         End Do
      End Do

      kScr=ipItmp
      Do iSymy=1,nSym
         iSymx=MulD2h(iSymy,JSYM)
         Do iSymw=iSymy,nSym   ! iSymw.ge.iSymy (particle symmetry)
            iSymt=MulD2h(isymw,JSYM)
            ipScr(iSymw,iSymy) = kScr
            kScr=kScr+nAsh(iSymt)*nAsh(iSymw)*nAsh(iSymx)*nAsh(iSymy)
         End Do
      End Do


      iLoc = 3 ! use scratch location in reduced index arrays

C ****************     MEMORY MANAGEMENT SECTION    *****************
C ------------------------------------------------------------------
C --- compute memory needed to store at least 1 vector of JSYM
C --- and do all the subsequent calculations
C ------------------------------------------------------------------
         mTvec = 0
         MxB=0
         do l=1,nSym
            k=Muld2h(l,JSYM)
            Mmax = Max(0,nIsh(k))
            If (Mmax.gt.0) MxB = Max(MxB,nBas(l))
            mTvec = mTvec + nAsh(k)*(nBas(l)+nAsh(l))
         end do

         LFMAX = Max(mTvec,LFULL) ! re-use memory for the active vec
         mTvec = nDen*Max(MxB,1) ! mem for storing half-transformed vec

C ------------------------------------------------------------------
C ------------------------------------------------------------------

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec
         myJRED1=JRED1 ! first red set present on this node
         myJRED2=JRED2 ! last  red set present on this node

c --- entire red sets range for parallel run
         Call GAIGOP_SCAL(JRED1,'min')
         Call GAIGOP_SCAL(JRED2,'max')

         ntv0=0
         kscreen=1
         DoScreen=.true.

         Do JRED=JRED1,JRED2

            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               call Abend
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED)
c           !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.'//
     &                          ' rc= ',irc
              call Abend
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            If(JSYM.eq.1)Then

               Call GetMem('rsDtot','Allo','Real',ipDab,nRS)
               Call GetMem('rsFC','Allo','Real',ipFab,nRS)
               Call Fzero(Work(ipDab),nRS)
               Call Fzero(Work(ipFab),nRS)

            EndIf

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec = min(LWORK/(nRS+mTvec+LFMAX),min(nVrs,MaxVecPerBatch))

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) 'LWORK= ',LWORK
               WRITE(6,*) 'min. mem. need= ',nRS+mTvec+LFMAX
               WRITE(6,*) 'nRS= ',nRS
               WRITE(6,*) 'mTvec= ',mTvec
               WRITE(6,*) 'LFMAX= ',LFMAX
               WRITE(6,*) 'jsym= ',jsym
               CALL Quit(_RC_MEMORY_ERROR_)
               nBatch = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
            Call GetMem('ChoT','Allo','Real',ipChoT,mTvec*nVec)
            CALL GETMEM('FullV','Allo','Real',ipLF,LFMAX*nVec)

            If(JSYM.eq.1)Then
C --- Transform the density to reduced storage
               mode = 'toreds'
               Call play_rassi_sto(irc,iLoc,JSYM,ISTLT,ISSQ,
     &                                 ipDLT,ipDab,mode)
            EndIf

C --- BATCH over the vectors ----------------------------

            nBatch = (nVrs-1)/nVec + 1

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM ) then
                  rc=77
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

               If(JSYM.eq.1)Then
C ************ (alpha+beta) COULOMB CONTRIBUTION  ****************
C
C --- Contraction with the density matrix
C ---------------------------------------
C --- V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * DI(rs)
C==========================================================
C
                  CALL CWTIME(TCC1,TWC1)

                  ipVJ = ipChoT

                  CALL DGEMV_('T',nRS,JNUM,
     &                 ONE,Work(ipLrs),nRS,
     &                 Work(ipDab),1,ZERO,Work(ipVJ),1)

C --- FI(rs){#J} <- FI(rs){#J} + FactCI * sum_J L(rs,{#J})*V{#J}
C===============================================================

                  Fact = dble(min(jVec-iVrs,1))

                  CALL DGEMV_('N',nRS,JNUM,
     &                 FactCI,Work(ipLrs),nRS,
     &                 Work(ipVJ),1,Fact,Work(ipFab),1)


                  CALL CWTIME(TCC2,TWC2)
                  tcoul(1) = tcoul(1) + (TCC2 - TCC1)
                  tcoul(2) = tcoul(2) + (TWC2 - TWC1)

               EndIf  ! Coulomb contribution


C *************** EXCHANGE CONTRIBUTIONS  ***********************

               CALL CWTIME(TCS1,TWS1)
C ---------------------------------------------------------------------
C --- Estimate the diagonals :   D(a,b) = sum_J (Lab,J)^2
C
               If (Estimate) Then

                  Call Fzero(Work(ipDiag+iiBstR(jSym,1)),NNBSTR(jSym,1))

                  Do krs=1,nRS

                     mrs = iiBstR(JSYM,iLoc) + krs
                     jrs = IndRed(mrs,iLoc) ! address in 1st red set

                     Do jvc=1,JNUM

                        ipL = ipLrs + nRS*(jvc-1)

                        Work(ipDiag+jrs-1) = Work(ipDiag+jrs-1)
     &                                  + Work(ipL+krs-1)**2

                     End Do

                  End Do

               EndIf

               CALL CWTIME(TCS2,TWS2)
               tscrn(1) = tscrn(1) + (TCS2 - TCS1)
               tscrn(2) = tscrn(2) + (TWS2 - TWS1)

               CALL CWTIME(TCX1,TWX1)

C *** Reorder vectors to Full-dimensions
C ***
C *** Vectors are returned in the storage LaJ,b with the restriction:
C ***
C ***    Sym(a).ge.Sym(b)
C ***
C *** and blocked in shell pairs

               CALL FZero(Work(ipLF),LFULL*JNUM)
               CALL FZero(Work(ip_SvShp),2*nnShl)

               CALL CHO_getShFull(Work(ipLrs),lread,JNUM,JSYM,
     &                            IREDC,ipLF,Work(ip_SvShp),
     &                            iWork(ip_iShp_rs))


               CALL CWTIME(TCX2,TWX2)
               texch(1) = texch(1) + (TCX2 - TCX1)
               texch(2) = texch(2) + (TWX2 - TWX1)


               IF (DoScreen) THEN

                   CALL CWTIME(TCS1,TWS1)

c --- Compute DH(a,b)=sqrt(D(a,b)) from the updated diagonals.
c ---                              Only the symmetry blocks with
c ---                              compound symmetry JSYM are computed
c --------------------------------------------------------------------
                   mode = 'tosqrt'
                   ired1 = 1 ! location of the 1st red set
                   Call play_rassi_sto(irc,ired1,JSYM,ISTLT,ISSQ,
     &                                     ipDIAH,ipDIAG,mode)

                   CALL CWTIME(TCS2,TWS2)
                   tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                   tscrn(2) = tscrn(2) + (TWS2 - TWS1)

               ENDIF


               Do kSym=1,nSym

                  lSym=MulD2h(JSYM,kSym)

                  Do jK=1,nIsh(kSym)

                   CALL FZero(Work(ipChoT),nDen*nBas(lSym)*JNUM)

                   Do jDen=1,nDen

                    ipMO(jDen) = ipMSQ(jDen) + ISTK(kSym)
     &                         + nBas(kSym)*(jK-1)

                    ipYk(jDen) = ipY(jDen) + MaxB*(kOff(kSym)+jK-1)

                    ipMLk(jDen) = ipML(jDen) + nShell*(kOff(kSym)+jK-1)
                    ipIndSh(jDen) = ipIndx(jDen)
     &                            + (nShell+1)*(kOff(kSym) + jK - 1)
                    ipSk(jDen) = ipSKsh(jDen) + nShell*(kOff(kSym)+jK-1)

                   End Do

                   IF (DoScreen) THEN

                     CALL CWTIME(TCS1,TWS1)
C------------------------------------------------------------------
C --- Setup the screening
C------------------------------------------------------------------
                     ipDIH = ipDIAH + ISSQ(lSym,kSym)

                     Do jDen=1,nDen

                        Do ik=0,nBas(kSym)-1
                           Work(ipAbs+ik) = abs(Work(ipMO(jDen)+ik))
                        End Do

                        If (lSym.ge.kSym) Then
c --------------------------------------------------------------
C --- Y(l)[k] = sum_n  DH(l,n) * |C(n)[k]|
C===============================================================
                           nBs = Max(1,nBas(lSym))

                           CALL DGEMV_('N',nBas(lSym),nBas(kSym),
     &                                ONE,Work(ipDIH),nBs,
     &                                    Work(ipAbs),1,
     &                               ZERO,Work(ipYk(jDen)),1)

                        Else
c --------------------------------------------------------------
C --- Y(l)[k] = sum_n  DH(n,l) * |C(n)[k]|
C===============================================================
                           nBs = Max(1,nBas(kSym))

                           CALL DGEMV_('T',nBas(kSym),nBas(lSym),
     &                                ONE,Work(ipDIH),nBs,
     &                                    Work(ipAbs),1,
     &                               ZERO,Work(ipYk(jDen)),1)

                        EndIf

c            write(6,*)'Y(k)= ',(Work(ipYk(jDen)+i-1),i=1,nBas(lSym))
c            write(6,*)'|C(k)|= ',(Work(ipAbs+i-1),i=1,nBas(kSym))

                     End Do

c            Call recprt('DH','',Work(ipDIH),nBas(lSym),nBas(kSym))

C --- List the shells present in Y(l)[k] by the largest element
                     Do jDen=1,nDen
                        Do ish=1,nShell
                           YshMax=zero
                           Do ibs=1,nBasSh(lSym,ish)
                              YshMax = Max(YshMax,
     &                          Work(ipYk(jDen)+koffSh(ish,lSym)+ibs-1))
                           End Do
                           Work(ipMLk(jDen)+ish-1) = YshMax
                        End Do
                     End Do


C --- Sort the lists ML[k]
                     Do jDen=1,nDen
                        Do ish=1,nShell
                           iWork(ipIndSh(jDen)+ish) = ish
                        End Do
                     End Do

C ****  The Max in the MO set 1 is used as reference
                     numSh1=0  ! # of significant shells in MO set 1
                     YMax=Work(ipMLk(1))
                     jmlmax=1
                     Do iml=2,nShell  ! get the max in the MO set 1
                        If (Work(ipMLk(1)+iml-1).gt.YMax) then
                           YMax = Work(ipMLk(1)+iml-1)
                           jmlmax = iml
                        Endif
                     End Do
                     If (jmlmax.ne.1) then  ! swap positions
                        xTmp = Work(ipMLk(1))
                        iTmp = iWork(ipIndSh(1)+1)
                        Work(ipMLk(1)) = YMax
                        iWork(ipIndSh(1)+1) = iWork(ipIndSh(1)+jmlmax)
                        Work(ipMLk(1)+jmlmax-1) = xTmp
                        iWork(ipIndSh(1)+jmlmax) = iTmp
                     Endif

C **** Sort the list for the MO set 2   iff  MOs1.ne.MOs2
                     If (.not.Fake_CMO2) Then
                       numSh2=0  ! # of significant shells in MO set 2
                       jml=1
                       Do while (jml.le.nShell)

                         YMax=Work(ipMLk(2)+jml-1)
                         jmlmax=jml

                         Do iml=jml+1,nShell  ! get the max
                           If (Work(ipMLk(2)+iml-1).gt.YMax) then
                              YMax = Work(ipMLk(2)+iml-1)
                              jmlmax = iml
                           Endif
                         End Do

                         If(jmlmax.ne.jml) then  ! swap positions
                          xTmp = Work(ipMLk(2)+jml-1)
                          iTmp = iWork(ipIndSh(2)+jml)
                          Work(ipMLk(2)+jml-1) = YMax
                          iWork(ipIndSh(2)+jml)=iWork(ipIndSh(2)+jmlmax)
                          Work(ipMLk(2)+jmlmax-1) = xTmp
                          iWork(ipIndSh(2)+jmlmax) = iTmp
                         Endif

c --- Exact bounds (quadratic scaling of the MO transformation)
c --- Note that in true RASSI the exchange matrix is not
c --- positive definite.
c
                         If(Work(ipMLk(2)+jml-1)*Work(ipMLk(1))
     &                                         .ge.tau)then
                           numSh2 = numSh2 + 1
                         else
                           jml=nShell  ! exit the loop
                         endif

                         jml=jml+1

                       End Do

                       iWork(ipIndSh(2)) = numSh2
                       numSh1 = 1

                     Else ! fake biorthonormal basis

                       numSh2 = 6669666 ! dummy assignement

                       If (Work(ipMLk(1)) .ge. xtau)  numSh1 = 1

                     EndIf

C **** Sort the list for the MO set 1 only if needed
                     If(numSh2.gt.0) then
                       jml=2 ! the 1st element has already been treated
                       Do while (jml.le.nShell)

                          YMax=Work(ipMLk(1)+jml-1)
                          jmlmax=jml
                          Do iml=jml+1,nShell  ! get the max
                             If (Work(ipMLk(1)+iml-1).gt.YMax) then
                                YMax = Work(ipMLk(1)+iml-1)
                                jmlmax = iml
                             Endif
                          End Do

                          If(jmlmax.ne.jml) then  ! swap positions
                            xTmp = Work(ipMLk(1)+jml-1)
                            iTmp = iWork(ipIndSh(1)+jml)
                            Work(ipMLk(1)+jml-1) = YMax
                            iWork(ipIndSh(1)+jml) =
     &                                      iWork(ipIndSh(1)+jmlmax)
                            Work(ipMLk(1)+jmlmax-1) = xTmp
                            iWork(ipIndSh(1)+jmlmax) = iTmp
                          Endif

                          If( .not.Fake_CMO2  .and.
     &                       Work(ipMLk(1)+jml-1)*Work(ipMLk(kDen))
     &                                             .ge.tau)then
                             numSh1 = numSh1 + 1

c --- Here we use a non-exact bound for the exchange matrix because a
c     fake rassi (MOs1=MOs2) has a positive definite exchange
                          ElseIf ( Fake_CMO2  .and.
     &                             Work(ipMLk(1)+jml-1) .ge. xtau ) then
                             numSh1 = numSh1 + 1
                          Else
                             jml=nShell  ! exit the loop
                          Endif

                          jml=jml+1

                       End Do
                     Else
                       numSh1 = 0
                     EndIf

                     iWork(ipIndSh(1)) = numSh1

c      Do jDen=1,nDen
c         write(6,*)'ord-ML(k)= ',(Work(ipMLk(jDen)+i-1),i=1,nShell)
c         write(6,*)'Ind-ML(k)= ',(iWork(ipIndSh(jDen)+i-1),i=1,nShell+1)
c      End Do
c         write(6,*)'lSym,kSym,jSym,jk,nShell,numSh1,numSh2= ',lSym,
c     &              kSym,jSym,jk,nShell,numSh1,numSh2

                     CALL CWTIME(TCS2,TWS2)
                     tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                     tscrn(2) = tscrn(2) + (TWS2 - TWS1)
C------------------------------------------------------------------
                   ENDIF    ! Screening setup

C --- Transform vectors for shells in the lists ML[k]
C
C --- Screening based on the Frobenius norm: sqrt(sum_ij A(i,j)^2)
C
C ---  || La,J[k] ||  .le.  || Lab,J || * || Cb[k] ||

                      CALL CWTIME(TCT1,TWT1)

                      Do jDen=1,nDen

                         IF (lSym.ge.kSym) Then


                            Do iSh=1,iWork(ipIndSh(jDen))

                               iaSh = iWork(ipIndSh(jDen)+iSh)

                               iOffSha = kOffSh(iaSh,lSym)

                               iWork(ip_Lab+nShell*(jDen-1)+iaSh-1) =
     &                                 ipChoT + iOffSha*JNUM
     &                                        + (jDen-1)*nBas(lSym)*JNUM

                               ibcount=0

                               Do ibSh=1,nShell

                                  iOffShb = kOffSh(ibSh,kSym)

                                  iShp = iTri(iaSh,ibSh)

                                  If (iShp_rs(iShp) .gt. 0) Then

                                   If(nnBstRSh(JSym,iShp_rs(iShp),iLoc)*
     &                                nBasSh(lSym,iaSh)*
     &                                nBasSh(kSym,ibSh) .gt. 0
     &                           .and. sqrt(abs(Work(ipSk(jDen)+ibSh-1)*
     &                           SvShp(iShp_rs(iShp)) )) .ge. thrv )Then

                                    ibcount = ibcount + 1

c                                   jOff = iOffShp(lSym,iShp)

c                                   if (iaSh.lt.ibSh) jOff = jOff +
c     &                               nBasSh(lSym,ibSh)*nBasSh(kSym,iaSh)

                                    jOff = iOffShp(lSym,iShp_rs(iShp)) -
     &                                             nBasSh(lSym,ibSh)*
     &                                             nBasSh(kSym,iaSh)*
     &                             Min(0,(iaSh-ibSh))/Max(1,(ibSh-iaSh))


C ---  LaJ,[k] = sum_b  L(aJ,b) * C(b)[k]
C ---------------------------------------

                                 CALL DGEMV_('N',nBasSh(lSym,iaSh)*JNUM,
     &                                        nBasSh(kSym,ibSh),
     &                                    ONE,Work(ipLF+jOff*JNUM),
     &                                        nBasSh(lSym,iaSh)*JNUM,
     &                                     Work(ipMO(jDen)+ioffShb),1,
     &                                    ONE,Work(ipLab(iaSh,jDen)),1)


                                   EndIf

                                  EndIf

                               End Do

c --- The following re-assignement is used later on to check if the
c --- iaSh vector LaJ[k] can be neglected because identically zero

                               iWork(ip_Lab+nShell*(jDen-1)+iaSh-1) =
     &                               ipLab(iaSh,jDen)*Min(1,ibcount)
     &                             + ipAbs*(1-Min(1,ibcount))


                            End Do


                         Else   ! lSym < kSym


                            Do iSh=1,iWork(ipIndSh(jDen))

                               iaSh = iWork(ipIndSh(jDen)+iSh)

                               iOffSha = kOffSh(iaSh,lSym)

                               iWork(ip_Lab+nShell*(jDen-1)+iaSh-1) =
     &                              ipChoT + iOffSha*JNUM
     &                                     + (jDen-1)*nBas(lSym)*JNUM

                               ibcount=0

                               Do ibSh=1,nShell

                                  iOffShb = kOffSh(ibSh,kSym)

                                  iShp = iTri(iaSh,ibSh)

                                  If (iShp_rs(iShp) .gt. 0) Then

                                   If(nnBstRSh(JSym,iShp_rs(iShp),iLoc)*
     &                                nBasSh(lSym,iaSh)*
     &                                nBasSh(kSym,ibSh) .gt. 0
     &                           .and. sqrt(abs(Work(ipSk(jDen)+ibSh-1)*
     &                           SvShp(iShp_rs(iShp)) )) .ge. thrv )Then

                                   ibcount = ibcount + 1

                                   jOff = iOffShp(kSym,iShp_rs(iShp)) -
     &                                      nBasSh(kSym,iaSh)*
     &                                      nBasSh(lSym,ibSh)*
     &                             Min(0,(ibSh-iaSh))/Max(1,(iaSh-ibSh))


C ---  LJa,[k] = sum_b  L(b,Ja) * C(b)[k]
C ---------------------------------------

                                    CALL DGEMV_('T',nBasSh(kSym,ibSh),
     &                                       JNUM*nBasSh(lSym,iaSh),
     &                                    ONE,Work(ipLF+jOff*JNUM),
     &                                        nBasSh(kSym,ibSh),
     &                                     Work(ipMO(jDen)+ioffShb),1,
     &                                    ONE,Work(ipLab(iaSh,jDen)),1)


                                    EndIf

                                  Endif

                               End Do

c --- The following re-assignement is used later on to check if the
c --- iaSh vector LaJ[k] can be neglected because identically zero

                               iWork(ip_Lab+nShell*(jDen-1)+iaSh-1) =
     &                               ipLab(iaSh,jDen)*Min(1,ibcount)
     &                             + ipAbs*(1-Min(1,ibcount))


                            End Do

                         EndIf


                      End Do

                      CALL CWTIME(TCT2,TWT2)
                      tmotr(1) = tmotr(1) + (TCT2 - TCT1)
                      tmotr(2) = tmotr(2) + (TWT2 - TWT1)

C --- Prepare the J-screening

                      CALL CWTIME(TCS1,TWS1)

                      IF (lSym.ge.kSym) Then


                         Do iSh=1,iWork(ipIndSh(1))

                            iaSh = iWork(ipIndSh(1)+iSh)

                            ipFaa = ipFk + MxBasSh + iaSh - 1

                            iaSkip=Min(1,Max(0,
     &                             abs(ipLab(iaSh,1)-ipAbs))) ! = 1 or 0

                            jaSkip=Min(1,Max(0,
     &                             abs(ipLab(iaSh,kDen)-ipAbs)))

                            Do i=1,iaSkip*jaSkip  ! 0 or 1

C ---  Faa,[k] = sum_J  LaJ[k1]*LaJ[k2]
C -------------------------------------
                               Do jv=1,JNUM

                                  xfjv = dble(min(1,jv-1))

                                  Do ia=1,nBasSh(lSym,iaSh)

                                     ipFia = ipFk + ia - 1

                                     ipLai = ipLab(iaSh,1)
     &                                     + nBasSh(lSym,iaSh)*(jv-1)
     &                                     + ia - 1

                                     ipLaj = ipLab(iaSh,kDen)
     &                                     + nBasSh(lSym,iaSh)*(jv-1)
     &                                     + ia - 1

                                     Work(ipFia) = xfjv*Work(ipFia)
     &                                        + Work(ipLai)*Work(ipLaj)
                                  End Do
                               End Do

                               CALL FindMax(ipFk,'N',
     &                                      nBasSh(lSym,iaSh),
     &                                      1,ipFaa)

                            End Do

                         End Do

                      Else   ! lSym < kSym


                         Do iSh=1,iWork(ipIndSh(1))

                            iaSh = iWork(ipIndSh(1)+iSh)

                            ipFaa = ipFk + MxBasSh + iaSh - 1

                            iaSkip=Min(1,Max(0,
     &                             abs(ipLab(iaSh,1)-ipAbs))) ! = 1 or 0

                            jaSkip=Min(1,Max(0,
     &                             abs(ipLab(iaSh,kDen)-ipAbs)))

                            Do i=1,iaSkip*jaSkip

C ---  Faa,[k] = sum_J  LJa[k1]*LJa[k2]
C -------------------------------------
                               Do ia=1,nBasSh(lSym,iaSh)

                                  ipFia = ipFk + ia - 1

                                  Do jv=1,JNUM

                                     xfjv = dble(min(1,jv-1))

                                     ipLai = ipLab(iaSh,1)
     &                                     + JNUM*(ia-1)
     &                                     + jv - 1

                                     ipLaj = ipLab(iaSh,kDen)
     &                                     + JNUM*(ia-1)
     &                                     + jv - 1

                                     Work(ipFia) = xfjv*Work(ipFia)
     &                                        + Work(ipLai)*Work(ipLaj)
                                  End Do
                               End Do

                               CALL FindMax(ipFk,'N',
     &                                      nBasSh(lSym,iaSh),
     &                                      1,ipFaa)

                            End Do

                         End Do


                      EndIf

                      CALL CWTIME(TCS2,TWS2)
                      tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                      tscrn(2) = tscrn(2) + (TWS2 - TWS1)


C------------------------------------------------------------
C --- Compute exchange matrix for the interacting shell pairs
C------------------------------------------------------------

                      CALL CWTIME(TCX1,TWX1)

                      IF (lSym.ge.kSym) Then

                         Do lSh=1,iWork(ipIndSh(1))

                            iaSh = iWork(ipIndSh(1)+lSh)

                            ipFaa = ipFk + MxBasSh + iaSh - 1

                            iaSkip=Min(1,Max(0,
     &                            abs(ipLab(iaSh,1)-ipAbs))) ! = 1 or 0

                            iOffSha = kOffSh(iaSh,lSym)

                            mSh = 1

                            Do while (mSh.le.iWork(ipIndSh(kDen)))

                               ibSh = iWork(ipIndSh(kDen)+mSh)

                               ipFbb = ipFk + MxBasSh + ibSh - 1

                               ibSkip = Min(1,Max(0,
     &                                  abs(ipLab(ibSh,kDen)-ipAbs)))

                               iShp = iTri(iaSh,ibSh)

                               iOffShb = kOffSh(ibSh,lSym)

                               iOffAB = nnBfShp(iShp,lSym)

                               ipKI = ipK + ISTLT(lSym) + iOffAB

                               xFab = sqrt(abs(Work(ipFaa)*Work(ipFbb)))

                               If (Work(ipMLk(1)+lSh-1)*
     &                             Work(ipMLk(kDen)+mSh-1).lt.tau) Then


                                   mSh = iWork(ipIndSh(kDen)) !skip rest


                               ElseIf (iaSh.eq.ibSh
     &                                 .and. xFab.ge.tau/MaxRedT
     &                                 .and. iaSkip*ibSkip.eq.1) Then

C ---  F(a,b)[k] = F(a,b)[k] + FactXI * sum_J  X1(a,J)[k] * X2(b,J)[k]
C --------------------------------------------------------------------
                               nBs = Max(1,nBasSh(lSym,iaSh))

                               CALL DGEMM_Tri('N','T',nBasSh(lSym,iaSh),
     &                                           nBasSh(lSym,ibSh),JNUM,
     &                                      FActXI,Work(ipLab(iaSh,1)),
     &                                           nBs,
     &                                           Work(ipLab(ibsh,kDen)),
     &                                           nBs,
     &                                       ONE,Work(ipKI),
     &                                               nBs)

                               ElseIf (iaSh.gt.ibSh
     &                                 .and. xFab.ge.tau/MaxRedT
     &                                 .and. iaSkip*ibSkip.eq.1) Then

C ---  F(a,b)[k] = F(a,b)[k] + FactXI * sum_J  X1(a,J)[k] * X2(b,J)[k]
C --------------------------------------------------------------------
                                  nBsa = Max(1,nBasSh(lSym,iaSh))
                                  nBsb = Max(1,nBasSh(lSym,ibSh))

                                  CALL DGEMM_('N','T',nBasSh(lSym,iaSh),
     &                                           nBasSh(lSym,ibSh),JNUM,
     &                                      FactXI,Work(ipLab(iaSh,1)),
     &                                           nBsa,
     &                                           Work(ipLab(ibsh,kDen)),
     &                                           nBsb,
     &                                       ONE,Work(ipKI),
     &                                               nBsa)

                               EndIf


                               mSh = mSh + 1  ! update shell counter


                            End Do

                         End Do


                      ELSE   ! lSym < kSym


                         Do lSh=1,iWork(ipIndSh(1))

                            iaSh = iWork(ipIndSh(1)+lSh)

                            ipFaa = ipFk + MxBasSh + iaSh - 1

                            iaSkip=Min(1,Max(0,
     &                            abs(ipLab(iaSh,1)-ipAbs))) ! = 1 or 0

                            iOffSha = kOffSh(iaSh,lSym)

                            mSh = 1

                            Do while (mSh.le.iWork(ipIndSh(kDen)))

                               ibSh = iWork(ipIndSh(kDen)+mSh)

                               ipFbb = ipFk + MxBasSh + ibSh - 1

                               ibSkip = Min(1,Max(0,
     &                                  abs(ipLab(ibSh,kDen)-ipAbs)))

                               iShp = iTri(iaSh,ibSh)

                               iOffShb = kOffSh(ibSh,lSym)

                               iOffAB = nnBfShp(iShp,lSym)

                               ipKI = ipK + ISTLT(lSym) + iOffAB

                               xFab = sqrt(abs(Work(ipFaa)*Work(ipFbb)))

                               If (Work(ipMLk(1)+lSh-1)*
     &                             Work(ipMLk(kDen)+mSh-1).lt.tau) Then


                                   mSh = iWork(ipIndSh(kDen))
c                                  ! skip rest


                               ElseIf (iaSh.eq.ibSh
     &                                 .and. xFab.ge.tau/MaxRedT
     &                                 .and. iaSkip*ibSkip.eq.1) Then

C ---  F(a,b)[k] = F(a,b)[k] + FactXI * sum_J  X1(J,a)[k] * X2(J,b)[k]
C --------------------------------------------------------------------

                               nBs = Max(1,nBasSh(lSym,iaSh))

                               CALL DGEMM_Tri('T','N',nBasSh(lSym,iaSh),
     &                                           nBasSh(lSym,ibSh),JNUM,
     &                                      FActXI,Work(ipLab(iaSh,1)),
     &                                             JNUM,
     &                                           Work(ipLab(ibsh,kDen)),
     &                                           JNUM,
     &                                           ONE,Work(ipKI),
     &                                                nBs)


                               ElseIf (iaSh.gt.ibSh
     &                                 .and. xFab.ge.tau/MaxRedT
     &                                 .and. iaSkip*ibSkip.eq.1) Then

C ---  F(a,b)[k] = F(a,b)[k] + FactXI * sum_J  X1(J,a)[k] * X2(J,b)[k]
C --------------------------------------------------------------------

                                  nBs = Max(1,nBasSh(lSym,iaSh))

                                  CALL DGEMM_('T','N',nBasSh(lSym,iaSh),
     &                                           nBasSh(lSym,ibSh),JNUM,
     &                                     FactXI,Work(ipLab(iaSh,1)),
     &                                           JNUM,
     &                                           Work(ipLab(ibsh,kDen)),
     &                                           JNUM,
     &                                       ONE,Work(ipKI),
     &                                               nBs)

                               EndIf


                               mSh = mSh + 1  ! update shell counter


                            End Do

                         End Do


                      ENDIF

                      CALL CWTIME(TCX2,TWX2)
                      texch(1) = texch(1) + (TCX2 - TCX1)
                      texch(2) = texch(2) + (TWX2 - TWX1)


                  End Do  ! loop over k MOs


               End Do   ! loop over MOs symmetry


               DoScreen=.false. ! avoid redo screening inside batch loop

C --- Diagonals updating. It only makes sense if Nscreen > 0

               If (Update .and. Nscreen .gt. 0) Then

                  CALL CWTIME(TCS1,TWS1)
C ---------------------------------------------------------------------
C --- update the diagonals :   D(a,b) = D(a,b) - sum_J (Lab,J)^2
C
C --- subtraction is done in the 1st reduced set
#if defined (_MOLCAS_MPP_)
                  If (nProcs .gt. 1 .and. Is_Real_Par()) then

                   Do krs=1,nRS

                     mrs = iiBstR(JSYM,iLoc) + krs
                     jrs = IndRed(mrs,iLoc) - iiBstR(JSYM,1)

                     Do jvc=1,JNUM

                        ipL = ipLrs + nRS*(jvc-1)
                        Work(ipjDiag+jrs-1) = Work(ipjDiag+jrs-1)
     &                                      + Work(ipL+krs-1)**2
                     End Do

                   End Do

                  Else

                   Do krs=1,nRS

                     mrs = iiBstR(JSYM,iLoc) + krs
                     jrs = IndRed(mrs,iLoc) ! address in 1st red set

                     Do jvc=1,JNUM

                        ipL = ipLrs + nRS*(jvc-1)
                        Work(ipDiag+jrs-1) = Work(ipDiag+jrs-1)
     &                                     - Work(ipL+krs-1)**2
                     End Do

                   End Do

                  EndIf

#else
                  Do krs=1,nRS

                     mrs = iiBstR(JSYM,iLoc) + krs
                     jrs = IndRed(mrs,iLoc) ! address in 1st red set

                     Do jvc=1,JNUM

                        ipL = ipLrs + nRS*(jvc-1)
                        Work(ipDiag+jrs-1) = Work(ipDiag+jrs-1)
     &                                     - Work(ipL+krs-1)**2
                     End Do

                  End Do
#endif

                  CALL CWTIME(TCS2,TWS2)
                  tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                  tscrn(2) = tscrn(2) + (TWS2 - TWS1)

               EndIf

C ************  END EXCHANGE CONTRIBUTION  ****************


C --------------------------------------------------------------------
C --- First half Active transformation  Lvb,J = sum_a  C1(v,a) * Lab,J
C --------------------------------------------------------------------

               CALL CWTIME(TCINT1,TWINT1)

C --- Set up the skipping flags and the pointers ipLpq
C --- The memory used before for the full-dimension AO-vectors
C ---     is now re-used to store half and full transformed
C ---     vectors in the active space
C -------------------------------------------------------------
               lChoa=0
               Do i=1,nSym

                  k = Muld2h(i,JSYM)
                  iSkip(k) = Min(1,
     &                 nBas(i)*nAsh(k))

                  ipLpq(k,1) = ipLF + lChoa       ! Lvb,J
                  ipLpq(k,2) = ipLpq(k,1)         ! Lvw,J
     &                       + nAsh(k)*nBas(i)*JNUM

                  lChoa= lChoa + nAsh(k)*(nAsh(i)+nBas(i))*JNUM

               End Do

               iSwap = 0  ! Lvb,J are returned
               kMOs = 1  !
               nMOs = 1  ! Active MOs (1st set)

               CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                           JSYM,iSwap,IREDC,nMOs,kMOs,ipAorb,nAsh,
     &                           ipLpq,iSkip,DoRead)


               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif

C --------------------------------------------------------------------
C --- Active-Active transformation  Lvw,J = sum_b  Lvb,J * C2(w,b)
C --------------------------------------------------------------------
                  Do iSymb=1,nSym

                     iSymv = MulD2h(JSYM,iSymb)
                     NAv = nAsh(iSymv)
                     NAw = nAsh(iSymb) ! iSymb=iSymw

                     If(NAv*NAw.ne.0)Then

                      Do JVC=1,JNUM

                       ipLvb = ipLpq(iSymv,1) + NAv*NBAS(iSymb)*(JVC-1)
                       ipLvw = ipLpq(iSymv,2)
     &                       + nAsh(iSymv)*nAsh(iSymb)*(JVC-1)

                       CALL DGEMM_('N','T',NAv,NAw,NBAS(iSymb),
     &                            One,Work(ipLvb),NAv,
     &                                Work(ipAorb(iSymb,kDen)),NAw,
     &                           Zero,Work(ipLvw),NAv)

                      End Do

                     EndIf

                  End Do

C
C
C *************** EVALUATION OF THE (TW|XY) INTEGRALS ***********

               DoReord = JRED.eq.myJRED2.and.iBatch.eq.nBatch

               Do iSym=1,nSym
                  ksym = mulD2h(iSym,JSYM)
                  ipLxy(kSym) = ipLpq(iSym,2)
c                 ! switch to column-wise storage
               End Do

               CALL CHO_rassi_twxy(irc,ipScr,ipLxy,ipInt,nAsh,
     &                                 JSYM,JNUM,DoReord)

               CALL CWTIME(TCINT2,TWINT2)
               tintg(1) = tintg(1) + (TCINT2 - TCINT1)
               tintg(2) = tintg(2) + (TWINT2 - TWINT1)

               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif

C ---------------- END (TW|XY) EVALUATION -----------------------


            END DO  ! end batch loop


            If(JSYM.eq.1)Then
c --- backtransform fock matrix to full storage
               mode = 'tofull'
               Call play_rassi_sto(irc,iLoc,JSYM,ISTLT,ISSQ,
     &                                 ipFLT,ipFab,mode)
            EndIf

C --- free memory
            CALL GETMEM('FullV','Free','Real',ipLF,LFMAX*nVec)
            Call GetMem('ChoT','Free','Real',ipChoT,mTvec*nVec)
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

            If(JSYM.eq.1)Then
              Call GetMem('rsFC','Free','Real',ipFab,nRS)
              Call GetMem('rsDtot','Free','Real',ipDab,nRS)
            EndIf


999         Continue

C --- Screening control section
            DoScreen = kscreen.eq.Nscreen

            if (.not.DoScreen) then
                kscreen = kscreen + 1
            else
                kscreen = 1
            endif

#if defined (_MOLCAS_MPP_)
            If (nProcs.gt.1 .and. Update .and. DoScreen
     &          .and. Is_Real_Par()) Then
               Call GaDsum(Work(ipjDiag),nnBSTR(JSYM,1))
               Call Daxpy_(nnBSTR(JSYM,1),xone,Work(ipjDiag),1,
     &                    Work(ipDiag+iiBstR(JSYM,1)),1)
               Call Fzero(Work(ipjDiag),nnBSTR(JSYM,1))
            EndIf
C--- Need to activate the screening to setup the contributing shell
C--- indeces the first time the loop is entered .OR. whenever other nodes
C--- have performed screening in the meanwhile
            If (nProcs.gt.1 .and. .not.DoScreen .and. nVrs.eq.0
     &          .and. Is_Real_Par()) Then
               ntv0=ntv0+1
               DoScreen = (JRED.lt.myJRED1 .or. ntv0.ge.Nscreen)
               if (DoScreen) ntv0=0
            EndIf
#endif

         END DO   ! loop over red sets


         Call GetMem('Mtmp','Free','REAL',ipItmp,Mtwxy)

1000  CONTINUE


      END DO  ! loop over JSYM

* --- Accumulate Coulomb and Exchange contributions
      Do iSym=1,nSym

         ipFI = ipFLT + ISTLT(iSym)
         ipKI = ipK   + ISTLT(iSym)

         Do iaSh=1,nShell

            ioffa = kOffSh(iaSh,iSym)

c --- ibSh < iaSh
c ---------------
            Do ibSh=1,iaSh-1

               iShp = iaSh*(iaSh-1)/2 + ibSh

               iOffAB = nnBfShp(iShp,iSym)

               ioffb = kOffSh(ibSh,iSym)

               Do ib=1,nBasSh(iSym,ibSh)

                Do ia=1,nBasSh(iSym,iaSh)

                  iab = nBasSh(iSym,iaSh)*(ib-1) + ia

                  jK = ipKI - 1 + iOffAB + iab

                  iag = ioffa + ia
                  ibg = ioffb + ib

                  jF = ipFI - 1 + iTri(iag,ibg)

                  Work(jF) = Work(jF) + Work(jK)

                End Do

               End Do

            End Do

c --- ibSh = iaSh
c ---------------
            iShp = iaSh*(iaSh+1)/2

            iOffAB = nnBfShp(iShp,iSym)

            Do ib=1,nBasSh(iSym,iaSh)

              Do ia=ib,nBasSh(iSym,iaSh)

                 iab = ia*(ia-1)/2 + ib

                 jK = ipKI - 1 + iOffAB + iab

                 iag = ioffa + ia
                 ibg = ioffa + ib

                 jF = ipFI - 1 + iag*(iag-1)/2 + ibg

                 Work(jF) = Work(jF) + Work(jK)

              End Do

            End Do

         End Do

      End Do


      Call GetMem('F(k)ss','Free','Real',ipFk,MxBasSh+nShell)
      Call GetMem('ip_SvShp','Free','Real',ip_SvShp,2*nnShl)
      Call GetMem('ip_iShp_rs','Free','Inte',ip_iShp_rs,nnShl_tot)
      Call GetMem('ip_nnBfShp','Free','Inte',ip_nnBfShp,nnShl_tot*nSym)
      Call GetMem('ip_kOffSh','Free','Inte',ip_kOffSh,nShell*nSym)
      Call GetMem('ip_Lab','Free','Inte',ip_Lab,nDen*nShell)
      Do jDen=nDen,1,-1
         Call GetMem('Indx','Free','Inte',ipIndx(jDen),(nShell+1)*nnO)
         Call GetMem('SKsh','Free','Real',ipSKsh(jDen),nShell*nnO)
         Call GetMem('MLk','Free','Real',ipML(jDen),nShell*nnO)
         Call GetMem('yc','Free','Real',ipY(jDen),MaxB*nnO)
      End Do
      Call GetMem('absc','Free','Real',ipAbs,MaxB)
      CALL GETMEM('diahI','Free','Real',ipDIAH,NNBSQ)
#if defined (_MOLCAS_MPP_)
      If (nProcs.gt.1 .and. Update .and. Is_Real_Par())
     &    CALL GETMEM('diagJ','Free','Real',ipjDIAG,NNBSTMX)
#endif
      CALL GETMEM('diagI','Free','Real',ipDIAG,NNBSTRT(1))

      If (Deco) Call GetMem('ChoMOs','Free','Real',ipCM(1),nsBB*nDen)

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1


*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky RASSI timing from '//SECNAM
      Write(6,CFmt)'----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ VECTORS                     '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB                          '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'EXCHANGE                         '
     &                           //'         ',texch(1),texch(2)
         Write(6,'(2x,A26,2f10.2)')'(TW|XY) INTEGRALS                '
     &                           //'         ',tintg(1),tintg(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


c Print the Fock-matrix
#ifdef _DEBUGPRINT_

      if(Debug) then !to avoid double printing in RASSI-debug

      WRITE(6,'(6X,A)')'TEST PRINT FROM '//SECNAM
      WRITE(6,'(6X,A)')
      WRITE(6,'(6X,A)')'***** INACTIVE FOCK MATRIX ***** '
      DO ISYM=1,NSYM
        ISFI=ipFLT+ISTLT(ISYM)
        IF( NBAS(ISYM).GT.0 ) THEN
          WRITE(6,'(6X,A)')
          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
          call TRIPRT('','',Work(ISFI),NBAS(ISYM))
        ENDIF
      END DO

      endif

#endif

      rc  = 0


      Return
      END

**************************************************************

      SUBROUTINE play_rassi_sto(irc,iLoc,JSYM,ISLT,ISSQ,
     &                        ipXLT,ipXab,mode)

      Implicit Real*8 (a-h,o-z)
      Integer ISLT(8),ISSQ(8,8),cho_isao
      External cho_isao
      Integer ipXLT,ipXab
      Character*6 mode

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      iRS2F(i,j)  = iWork(ip_iRS2F-1+2*(j-1)+i)
************************************************************************



      If (mode.eq.'toreds'.and.JSYM.eq.1) then ! TOTAL SYMMETRIC

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            kfrom = ipXLT + isLT(iSyma) + iab - 1

            Work(ipXab+jRab-1) = Work(kfrom)

         End Do  ! jRab loop


      ElseIf (mode.eq.'tofull'.and.JSYM.eq.1) then  ! TOTAL SYMMETRIC

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            kto = ipXLT + isLT(iSyma) + iab - 1

            Work(kto) = Work(kto)
     &                + Work(ipXab+jRab-1)

         End Do  ! jRab loop


      ElseIf (mode.eq.'tosqrt'.and.JSYM.ne.1) then
c      ! NON TOTAL-SYMMETRIC

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab ! already in 1st red set

            iag   = iRS2F(1,kRab)  !global address
            ibg   = iRS2F(2,kRab)

            iSyma = cho_isao(iag)  !symmetry block
            iSymb = MulD2h(jSym,iSyma) ! sym(a) .gt. sym(b)

            ias   = iag - ibas(iSyma)
            ibs   = ibg - ibas(iSymb)

            iab   = nBas(iSyma)*(ibs-1) + ias

            kto = ipXLT - 1 + isSQ(iSyma,iSymb) + iab

            Work(kto) = sqrt(abs(Work(ipXab+kRab-1)))

         End Do  ! jRab loop


      ElseIf (mode.eq.'tosqrt'.and.JSYM.eq.1) then

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab ! already in 1st red set

            iag   = iRS2F(1,kRab)  !global address
            ibg   = iRS2F(2,kRab)

            iSyma = cho_isao(iag)  ! sym(a)=sym(b)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)

            iab   = nBas(iSyma)*(ibs-1) + ias
            iba   = nBas(iSyma)*(ias-1) + ibs

            kto = ipXLT - 1 + isSQ(iSyma,iSyma)

            Work(kto+iab) = sqrt(abs(Work(ipXab+kRab-1)))

            Work(kto+iba) = sqrt(abs(Work(ipXab+kRab-1)))

         End Do  ! jRab loop


      Else

         write(6,*)'Wrong input parameters. JSYM,mode = ',JSYM,mode
         irc = 66
         Call abend()

      EndIf

      irc = 0

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine RHS_SGMDIA(NIN,NIS,lg_W,DIN,DIS)
! Apply the resolvent of the diagonal part of H0 to an RHS array

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
#endif
use fake_GA, only: GA_Arrays
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NIN, NIS, lg_W
real(kind=wp), intent(in) :: DIN(NIN), DIS(NIS)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iHi, iLo, jHi, jLo, LDW, mW, myRank, NCOL, NROW

if (Is_Real_Par()) then
  call GA_Sync()
  myRank = GA_NodeID()
  !-SVC: get the local vertical stripes of the lg_W vector
  call GA_Distribution(lg_W,myRank,iLo,iHi,jLo,jHi)
  if ((iLo /= 0) .and. (jLo /= 0)) then
    NROW = iHi-iLo+1
    NCOL = jHi-jLo+1
    call GA_Access(lg_W,iLo,iHi,jLo,jHi,mW,LDW)
    call SGMDIA(NROW,NCOL,DBL_MB(mW),LDW,DIN(iLo),DIS(jLo))
    call GA_Release_Update(lg_W,iLo,iHi,jLo,jHi)
  end if
  call GA_Sync()
else
#endif
  call SGMDIA(NIN,NIS,GA_Arrays(lg_W)%A,NIN,DIN,DIS)
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine RHS_SGMDIA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine oit_sp(rkappa,sigma,i1,r3,p11,r4,p12,D,FA,rm1,rm2,focki)
!                          ~
! Constructs  F  = <0|[Q  ,H]|0>
!              pq       pq

use MCLR_Data, only: ipMat, nA, nDens, nDensC, nMBA, nNA
use input_mclr, only: nAsh, nBas, nIsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: rkappa(nDensC), R3, p11(*), R4, p12(*), D(*), FA(nDens)
real(kind=wp), intent(out) :: sigma(nDensC)
integer(kind=iwp), intent(in) :: i1
real(kind=wp), intent(_OUT_) :: rm1(*), rm2(*), Focki(*)
integer(kind=iwp) :: IA, iAsh, ipF1, ipF2, ipFI1, iS, iSym, jAsh, jSpin
real(kind=wp) :: Dij, Fact, R1, Reco
real(kind=wp), allocatable :: FAtemp(:), Fock(:), K(:), Q(:), Q1(:)

isym = 1
! sign1  Kappa**t=Sign1*Kappa
! sign2  <0|[Qip,H]|0>=Aip+sign2*Api
r1 = real(i1,kind=wp)
Fact = -One ! bullshit
reco = -One !(k*a+reco*a*k)
jspin = 1 ! triplet
call mma_allocate(K,nDens,Label='K')
call mma_allocate(FAtemp,nDens,Label='FAtemp')
call mma_allocate(Fock,nDens,Label='Fock')
call mma_allocate(Q,nDens,Label='Q')
call mma_allocate(Q1,nDens,Label='Q1')
rm1(1:nmba) = Zero
rm2(1:nmba) = Zero
Focki(1:nDens) = Zero
Q(:) = Zero
Q1(:) = Zero
call Unc(rkappa,K,isym,r1)

call R2ElInt_SP(K,rm1,rm2,FockI,FAtemp,iSym,ReCo,Fact,jspin,D,FA)

Fock(:) = Zero

! Q  = sum(jkl)=(pj|kl)d(ijkl)
!  pi

! <o|E(S)  E- E(S) |o>(pb|cd)
!        ab cd    ad
call CreQ_sp(Q,rm1,P11,isym)
Q(:) = r3*Q(:)

! <o|E(S)  E- E(S) |o>(pb|cd)
!        ab cd   ad
call CreQ_sp(Q1,rm2,p12,isym)
Q(:) = Q(:)+r4*Q1(:)

do iS=1,nSym

  !        A
  ! F  =2 F
  !  pi    pi

  Fock(ipMat(is,is):ipMat(is,is)+nIsh(is)*nBas(is)-1) = Fock(ipMat(is,is):ipMat(is,is)+nIsh(is)*nBas(is)-1)- &
                                                        r1*Two*FAtemp(ipMat(is,is):ipMat(is,is)+nIsh(is)*nBas(is)-1)

  do iAsh=1,nAsh(iS)
    do jAsh=1,nAsh(is)
      Dij = D(iash+nA(is)+(jAsh+nA(is)-1)*nNA)
      ipF1 = ipMat(is,is)+(Nish(is)+iAsh-1)*nBas(is)
      ipF2 = ipMat(is,is)+Nish(is)+iAsh-1
      ipFI1 = ipMat(is,is)+(Nish(is)+jAsh-1)*nBas(is)

      !         I
      ! F  = F + F  D
      !  pa   pa  pb ab

      Fock(ipF1:ipF1+nBas(is)-1) = Fock(ipF1:ipF1+nBas(is)-1)-r1*Dij*FockI(ipFI1:ipFI1+nBas(is)-1)
      Fock(ipF2:ipF2+nIsh(is)*nBas(is)-1:nBas(is)) = Fock(ipF2:ipF2+nIsh(is)*nBas(is)-1:nBas(is))-Dij*FockI(ipFI1:ipFI1+nIsh(is)-1)
    end do
  end do

  ! F  = F  + Q
  !  pa   pa   pa

  ipF1 = ipMat(is,is)+nBas(is)*nIsh(is)
  ipF2 = ipMat(is,is)+nBas(is)*(nIsh(is)+nAsh(is))-1
  Fock(ipF1:ipF2) = Fock(ipF1:ipF2)-r1*Q(ipF1:ipF2)
  do iA=nIsh(is),nIsh(is)+nAsh(is)-1
    Fock(ipMat(is,is)+iA:ipMat(is,is)+iA+nBas(is)**2-1:nBas(is)) = &
      Fock(ipMat(is,is)+iA:ipMat(is,is)+iA+nBas(is)**2-1:nBas(is))-Q(ipMat(is,is)+nBas(is)*iA:ipMat(is,is)+nBas(is)*(iA-1)-1)
  end do
end do

call Compress(Fock,Sigma,isym)

call mma_deallocate(Q1)
call mma_deallocate(Q)
call mma_deallocate(K)
call mma_deallocate(FAtemp)
call mma_deallocate(FOck)

end subroutine oit_sp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************

      SubRoutine ChoMP2g_MOReOrd(CMO,COrb1,COrb2,iMoType1,iMOType2)
C
C     Jonas Bostrom, Jan. 2010. (modified from ChoMP2_MOReOrd)
C
C     Purpose: Make CMO:s of appropriate length, transpose COrb2,
C
C              CMO(alpha,p) -> COrb1(p,alpha)
C              CMO(alpha,q) -> COrb2(alpha,q)
C
#include "implicit.fh"
      Real*8 COrb1(*), COrb2(*), CMO(*)
      Integer nOrb1(8), nOrb2(8)
      Integer nOffOrb1(8), nOffOrb2(8)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2g.fh"
#include "choorb.fh"

      Do iSym = 1, nSym
         nOffOrb1(iSym) = 0
         nOffOrb2(iSym) = 0
         Do i = 1, iMOType1-1
            nOffOrb1(iSym) = nOffOrb1(iSym) + nMo(iSym,i)
         End Do
         Do i = 1, iMOType2-1
            nOffOrb2(iSym) = nOffOrb2(iSym) + nMo(iSym,i)
         End Do
         nOrb1(iSym) = nMo(iSym,iMOType1)
         nOrb2(iSym) = nMo(iSym,iMOType2)
      End Do
*
      iCount = 0
      Do iSym = 1,nSym
*
         jCount = iCount + nOffOrb1(iSym)*nBas(iSym)
*
         Do i = 1,nOrb1(iSym)
            kOff1 = jCount + nBas(iSym)*(i-1) + 1
            kOff2 = iMoAo(iSym,iSym,iMoType1) + i
           Call dCopy_(nBas(iSym),CMO(kOff1),1,COrb1(kOff2),nOrb1(iSym))
         End Do

         kOff1 = iCount + nOffOrb2(iSym)*nBas(iSym) + 1
         kOff2 = iAoMo(iSym,iSym,iMoType2) + 1
         Call dCopy_(nBas(isym)*nOrb2(iSym),CMO(kOff1),1,COrb2(kOff2),1)

         iCount = iCount + nBas(iSym)*nBas(iSym)

      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine defs_cvb()
      implicit real*8 (a-h,o-z)
      parameter (iunset=-1357924680,unset=-1357924680d0)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
      logical ifploc
      common /ifploc_complc/ifploc
      dimension ifxorb(mxorb)

c  Default settings :
      strtvb=zero
      savvb=zero
      savvbci=zero
      kbasis=1
      mxiter=iunset
      icrit=iunset
      imethod=iunset
      isaddle=iunset
      initial=-1
      opposite=.false.
      projcas=.false.
      projsym=.false.
      npcf=iunset
      ishstruc=iunset
c  +1=CHIRGWIN +2=LOWDIN +4=INVERSE
      ivbweights=iunset
      iciweights=iunset
      opposite=.false.
      projcas=.false.
      projsym=.false.
      sij=.false.
      anyslater=.false.
      service=.false.
      do 50 i=1,10
      ip(i)=1
50    continue

      call tunedefs_cvb()
      if(variat)then
        ploc=ifploc
      else
        ploc=.false.
      endif

c  Counters
      norbrel=0
      ndimrel=0
      nfxorb=0
      nfxvb=0
      nzrvb=0
      nort=0
      lfxvb=0
      lzrvb=0
      return

      entry defs2_cvb(ifxorb)
      if(icrit.eq.iunset)then
        if((.not.variat).and.imethod.ne.6)then
          icrit=1
        else
          icrit=2
        endif
      endif
c Set ifxorb
      nfxorb=0
      do i=1,norb
      if(ifxorb(i).eq.1)nfxorb=nfxorb+1
      enddo
      call izero(ifxorb(norb+1),mxorb-norb)

c Set STRUCOPT :
      if(projcas)then
        strucopt=.false.
      elseif(imethod.eq.11)then
        strucopt=.false.
      elseif(nvb.eq.1)then
        strucopt=.false.
      else
        nfxvbr=nfxvb
        if(lfxvb.eq.1)nfxvbr=nvb-nfxvb
        nzrvbr=nzrvb
        if(lzrvb.eq.1)nzrvbr=nvb-nzrvb
        if(nfxvbr.ge.nvb)then
          strucopt=.false.
        elseif(nfxvbr+nzrvbr.ge.nvb)then
          write(6,*)' Should check!'
          call abend_cvb()
        else
          strucopt=.true.
        endif
      endif
      if(isaddle.eq.iunset)isaddle=0
c  If unset, set default for IMETHOD :
      if(imethod.eq.iunset)then
        if(isaddle.eq.0)then
          imethod=10
        else
          imethod=7
        endif
        if(nfxorb.eq.norb.and.strucopt.and.nfrag.le.1)imethod=4
      elseif(isaddle.ne.0.and.imethod.eq.1)then
        call abend_cvb()
      endif
c  If unset, set default for MXITER :
      if(mxiter.eq.iunset)then
        if(imethod.ne.4)then
          mxiter=50
        else
          mxiter=200
        endif
      endif
      if(ishstruc.eq.iunset)ishstruc=0
      if(npcf.eq.iunset)npcf=-2
      if(ivbweights.eq.iunset)ivbweights=-1
      if(iciweights.eq.iunset)iciweights=0
      call tunedefs2_cvb(imethod,.false.)

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Proc_InpX(DSCF,iRc)

! module dependencies
      use csfbas, only: CONF, KCFTP
#ifdef module_DMRG
!     use molcas_dmrg_interface !stknecht: Maquis-DMRG program
#endif
      use Fock_util_global, only: DoCholesky
#ifdef _HDF5_
      Use mh5, Only: mh5_is_hdf5, mh5_open_file_r, mh5_exists_attr,
     &               mh5_exists_dset, mh5_fetch_attr, mh5_fetch_dset,
     &               mh5_close_file
#endif
      use KSDFT_Info, only: CoefR, CoefX
      use OFembed, only: Do_OFemb
      use hybridpdft, only: Ratio_WF, Do_Hybrid
      Implicit Real*8 (A-H,O-Z)
#include "SysDef.fh"
#include "rasdim.fh"
#include "warnings.h"
#include "WrkSpc.fh"
#include "gas.fh"
#include "rasscf.fh"
#include "input_ras_mcpdft.fh"
#include "splitcas.fh"
#include "bk_approx.fh"
#include "general.fh"
#include "output_ras.fh"
#include "orthonormalize_mcpdft.fh"
#include "mspdft.fh"
#include "casvb.fh"
#include "pamint.fh"
*Chen write JOBIPH/HDF5
#include "wjob.fh"
* Lucia-stuff:
#include "ciinfo.fh"
#include "spinfo.fh"
#include "lucia_ini.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
      character(len=32) :: prgm
#endif
*
      Character*180  Line
!      Character*8 NewJobIphName
      logical lExists, RunFile_Exists
* Some strange extra logical variables...
      logical DSCF
      logical RF_On
      logical Langevin_On
      logical PCM_On

      Logical DBG

#include "chotime.fh"
#include "chopar.fh"

* Local NBAS_L, NORB_L .. avoid collision with items in common.
      DIMENSION NFRO_L(8),NISH_L(8),NRS1_L(8),NRS2_L(8)
      DIMENSION NRS3_L(8),NSSH_L(8),NDEL_L(8)
#ifdef _HDF5_
      character(len=1), allocatable :: typestring(:)
      DIMENSION NBAS_L(8)
#endif
* TOC on JOBOLD (or JOBIPH)
      DIMENSION IADR19(15)

      Character*180 Get_LN
      External Get_LN
      Real*8   Get_ExFac
      External Get_ExFac
      Character*100 ProgName, Get_SuperName
      External Get_SuperName
      Character*72 ReadStatus
      Character*72 JobTit(mxTit)
      Character*256 RealName
      Logical, External :: Is_First_Iter
      Dimension Dummy(1)
      Character*(LENIN8*mxOrb) lJobH1
      Character*(2*72) lJobH2

      INTEGER :: iDNG,IPRLEV
      Logical :: DNG
      Character*8 emiloop
      Character*8 inGeo

      Intrinsic DBLE
C...Dongxia note for GAS:
C   No changing about read in orbital information from INPORB yet.

      Call StatusLine('MCPDFT:','Processing Input')

!      DBG = .TRUE.
      DBG = .FALSE.
      IPRLEV = TERSE

      doGradPDFT = .false.
      doGradMSPD = .false.
      doNOGRad = .false.
      DoGSOR=.false.

*    SplitCAS related variables declaration  (GLMJ)
      DoSplitCAS= .false.
      NumSplit = .false.
      EnerSplit = .false.
      PerSplit = .false.
      FOrdSplit  = .false.
*    BK type of approximation (GLMJ)
      DoBKAP = .false.

*    GAS flag, means the INPUT was GAS
      iDoGas = .false.

      !> read from / write to HDF5 file
      hasHDF5ref = .false.
!> reference wave function is of MPS type (aka "DMRG wave function")
      hasMPSref  = .false.

!> default for MC-PDFT: read/write from/to JOBIPH-type files
      keyJOBI = .true.

      NAlter=0
      iRc=_RC_ALL_IS_WELL_

      KeyCIRE=.TRUE.

      ProgName=Get_SuperName()
      IfVB=0
      If (ProgName(1:6).eq.'mcpdft') Then
* For geometry optimizations use the old CI coefficients.
        If (.Not.Is_First_Iter()) Then
          KeyCIRE=.true.
          KeyFILE=.false.
        End If
      Else If (ProgName(1:18).eq.'numerical_gradient') Then
        KeyCIRE=.true.
        KeyFILE=.false.
      End If

      !> Local print level in this routine:
      IPRLEV=IPRLOC(1)
!     IPRLEV=INSANE

      DBG=DBG .or. (IPRLEV.GE.DEBUG)

* ==== Check if there is any runfile ====
      Call F_Inquire('RUNFILE',RunFile_Exists)
      If (DBG) Write(6,*)' Inquire about RUNFILE.'
      IF (RunFile_Exists) Then
       If (DBG) Write(6,*)' Yes, there is one.'
       NSYM=0
       Call qpg_iScalar('nSym',lExists)
       IF (lExists) Then
        Call Get_iScalar('nSym',nSym)
        Call Get_iArray('nBas',nBas,nSym)
        If (DBG) Then
          Write(6,*)' The following information exists on runfile:'
          Write(6,*)' Nr of symmetries, NSYM:',NSYM
          Write(6,*)' Nr of basis functions/symmetry:'
          Write(6,'(1x,8I5)')(NBAS(I),I=1,NSYM)
          Call XFlush(6)
        End If
       ELSE
        Call WarningMessage(2,'No symmetry info on runfile.')
        Write(6,*)' There seems to be no information about symmetry'
        Write(6,*)' on the runfile! This is an unexpected error.'
        Call Quit(_RC_IO_ERROR_READ_)
       END IF
      ELSE
       Call WarningMessage(2,'Cannot find runfile.')
       Write(6,*)' PROC_INP: Cannot find RUNFILE. This is an'//
     &           ' unexpected error.'
        Call Quit(_RC_IO_ERROR_READ_)
      END IF
* ==== End check if there is any runfile ====

      iOrbData=0
* iOrbData=0: no orbital space data is specified
*         >0: specifications from some orbital file (JOBOLD, JOBIPH, HDF5)
      INVEC=0
* INVEC=0, no source for orbitals (yet)
*       3, take from JOBOLD, or JOBIPH file
*       4, take from an HDF5 file

*---  ==== FILE(ORB) keyword =====
      If (DBG) Write(6,*)' Where to read MOs/CI vectors? '
      StartOrbFile=''

      If (KeyFILE) Then
       If (DBG) Then
         Write(6,*)' Reading file name for start orbitals.'
       End If
       Call SetPos_m(LUInput,'FILE',Line,iRc)
       Line=Get_Ln(LUInput)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       Call ChkIfKey_m()
       If (DBG) Then
         Write(6,*) ' Calling fileorb with filename='
         Write(6,*) Line
       End If
       call fileorb(Line,StartOrbFile)
#ifdef _HDF5_
       if (mh5_is_hdf5(StartOrbFile)) then
         KeyCIRE=.true.
         hasHDF5ref = .true.
       end if
#endif
!> we do not need a JOBIPH file if we have HDF5 - override the default!
       if(hasHDF5ref) keyJOBI = .false.

      End If
*---  ==== FILE(ORB) keyword =====

*---  ==== JOBI(PH) keyword =====

* The JOBIPH file, following decisions from the Torre Normanna labour camp:
* Default, the file name is 'JOBIPH'.
* However, if keyword IPHNAME was used, then the name was given in input.
* Also, if instead the keyword NEWIPH was given, then a new name will be
* chosen as the first not-already-used name in the sequence
* 'JOBIPH', 'JOBIPH01', 'JOBIPH02', etc.

      if(keyJOBI)then
        IPHNAME='ToBeFoun'
        If (KeyIPHN) Then
          If (DBG) Then
            Write(6,*)' Reading file name for JOBIPH file.'
          End If
          Call SetPos_m(LUInput,'IPHN',Line,iRc)
          If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
          ReadStatus=' Failure reading IPHNAME string.'
          Read(LUInput,*,End=9910,Err=9920) IPHNAME
          ReadStatus=' O.K. after reading IPHNAME string.'
          Call UpCase(IPHNAME)
        End If

        IF(IPHNAME.EQ.'ToBeFoun') IPHNAME='JOBIPH'

        !> check first for JOBOLD
        Call f_Inquire('JOBOLD',lExists)
        If (lExists) Then
          INVEC=3
        else !> check next for JOBIPH
          Call F_Inquire(trim(IPHNAME),lExists)
          If(lExists) Then
            Call PrgmTranslate(IPHNAME,RealName,not_sure)
            If (DBG) Then
                Write(6,*)' A JOBIPH file has been found:'
                write(6,*) RealName
            End If
            INVEC=3
          Else
            Write(LF,*)
            Write(LF,*)'******************************************'
            Write(LF,*)' JOBIPH does not seem to exist,           '
            Write(LF,*)' so the calculation cannot continue.      '
            Write(LF,*)'******************************************'
            Call Abend()
          End If
        end if !> check for JOBOLD

        if(JOBIPH.gt.0) Then
          Call DaClos(JOBIPH)
          JOBIPH=-1
        end if
        JOBIPH=IsFreeUnit(15)
        CALL DANAME(JOBIPH,IPHNAME)
        INVEC=3
      end if !> JOBI(PH) keyword

*---  ==== JOBI(PH) keyword =====

*---  process KSDF command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if KSDFT was requested.'
      If (KeyKSDF) Then
       If (DBG) Write(6,*) ' KSDFT command was given.'
       PamGen=.False.
       PamGen1=.False.
!AMS       DFTFOCK='CAS '
       DFTFOCK='ROKS'
       Call SetPos_m(LUInput,'KSDF',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
!       Read(LUInput,*,End=9910,Err=9920) Line
!       Call UpCase(Line)
!       If (Line(1:4).eq.'ROKS') DFTFOCK='ROKS'
!       If (Line(1:6).eq.'CASDFT') DFTFOCK='DIFF'
       Read(LUInput,*,End=9910,Err=9920) Line
       KSDFT=Line(1:80)
       Call UpCase(KSDFT)
      ExFac=Get_ExFac(KSDFT)
*******
*
* Read numbers, and coefficients for rasscf potential calculations:
* nPAM  - number of potentials
* ipPAM - list of potentials
* CPAM  - coeffcients of potentials
* PamGen - switch to generate grid of Rho, grad ....., ......
*
*******
       If ( KSDFT(1:3).eq.'PAM') Then
        If ( KSDFT(4:4).eq.'G') PamGen =.True.
        If ( KSDFT(4:4).eq.'G') PamGen1=.False.
        call dcopy_(nPAMintg,[0.0d0],0,CPAM,1)
        ReadStatus=' Failure reading data following KSDF=PAM.'
        Read(LUInput,*,End=9910,Err=9920) nPAM
        ReadStatus=' O.K. after reading data following KSDF=PAM.'
*        Write(LF,*) ' Number included exponent in PAM=',nPAM
        Do iPAM=1,nPAM
          ReadStatus=' Failure reading data following KSDF=PAM.'
          Read(LUInput,*,End=9910,Err=9920) Line
          ReadStatus=' O.K.after reading data following KSDF=PAM.'
          Call RdPAM_m(Line,ipPAM(iPAM),CPAM(iPAM))
        End Do
       End If
       Call ChkIfKey_m()
       Else
        Call WarningMessage(2,'No KSDFT functional specified')
        Write(LF,*) ' ************* ERROR **************'
        Write(LF,*) ' KSDFT functional type must be     '
        Write(LF,*) ' specified for MCPDFT calculations '
        Write(LF,*) ' **********************************'
        Call Abend()
      End If
*---  Process DFCF command (S Dong, 2018)--------------------------*
      If (DBG) Write(6,*) ' Check if DFCF was provided.'
      If (KeyDFCF) Then
       If (DBG) Write(6,*) ' DFCF command has been used.'
       Call SetPos_m(LUInput,'DFCF',Line,iRc)
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       ReadStatus=' Failure after reading DFCF keyword.'
       Read(LUInput,*,End=9910,Err=9920) CoefX,CoefR
       ReadStatus=' O.K. after reading DFCF keyword.'
!       Write(6,*) ' Exchange energy scaling factor is ',CoefX
!       Write(6,*) ' Correlation energy scaling factor is ',CoefR
      End If
*---  Process MSPD command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if Multi-state MC-PDFT case.'
      If (KeyMSPD) Then
       If (DBG) Write(6,*) ' MSPD keyword was used.'
       iMSPDFT=1
       Call SetPos_m(LUInput,'MSPD',Line,iRc)
       Call ChkIfKey_m()
       if(dogradpdft) then
        dogradmspd=.true.
        dogradpdft=.false.
       end if
      End If
*---  Process WJOB command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if write JOBIPH case.'
      If (KeyWJOB) Then
       If (DBG) Write(6,*) ' WJOB keyword was used.'
       iWJOB=1
       Call SetPos_m(LUInput,'WJOB',Line,iRc)
       Call ChkIfKey_m()
      End If
*---  Process LAMB command --------------------------------------------*
      If (KeyLAMB) Then
       If (DBG) Write(6,*) 'Check if hybrid PDFT case'
       Call SetPos_m(LUInput,'LAMB',Line,iRc)
       ReadStatus=' Failure reading data following HPDF keyword.'
       Read(LUInput,*,End=9910,Err=9920) Ratio_WF
       ReadStatus=' O.K. reading data following HPDF keyword.'
       If(iRc.ne._RC_ALL_IS_WELL_) GoTo 9810
       If(Ratio_WF.gt.0.0d0) Then
        Do_Hybrid=.true.
        CALL Put_DScalar('R_WF_HMC',Ratio_WF)
       End If
       If (DBG) Write(6,*) 'Wave Funtion Ratio in hybrid PDFT',Ratio_WF
       If (dogradmspd.or.dogradpdft) Then
        Call WarningMessage(2,'GRAD currently not compatible with HPDF')
        GoTo 9810
       End If
       Call ChkIfKey_m()
      End If

*---  Process HDF5 file --------------------------------------------*
      If (hasHDF5ref) Then
#ifdef _HDF5_
        mh5id = mh5_open_file_r(StartOrbFile)
*     read basic attributes
        call mh5_fetch_attr(mh5id, 'MOLCAS_MODULE', prgm)
        call mh5_fetch_attr(mh5id, 'NSYM', NSYM_L)
        if (nsym.ne.nsym_l) then
          write (LF,*) 'Number of symmetries on HDF5 file does not'
          write (LF,*) 'match the number of symmetries on the'
          write (LF,*) 'RunFile, calculation will stop now.'
          call Quit(_RC_INPUT_ERROR_)
        end if
        call mh5_fetch_attr(mh5id, 'NBAS', NBAS_L)
        ierr=0
        do isym=1,nsym
          if (nbas(isym).ne.nbas_l(isym)) ierr=1
        end do
        if (ierr.eq.1) then
          write (LF,*) 'Number of basis functions on HDF5 file does not'
          write (LF,*) 'match the number of basis functions on the'
          write (LF,*) 'RunFile, calculation will stop now.'
          call Quit(_RC_INPUT_ERROR_)
        end if
*     orbitals available?
        if (mh5_exists_dset(mh5id, 'MO_VECTORS')) then
          inVec=4
        else
          write (LF,*)'The HDF5 ref file does not contain MO vectors.'
          write (LF,*)'Fatal error, the calculation will stop now.'
          call Quit(_RC_INPUT_ERROR_)
        end if
*     typeindex data available?
        if (mh5_exists_dset(mh5id, 'MO_TYPEINDICES')) then
          iOrbData=3
          call mma_allocate(typestring, sum(nbas(1:nsym)))
          call mh5_fetch_dset(mh5id, 'MO_TYPEINDICES', typestring)
          call tpstr2orb(nSym,nbas_l,
     $            typestring,
     $            nFro_L,nISh_L,
     $            NRS1_L,NRS2_L,NRS3_L,
     $            nSSh_L,nDel_L)
          call mma_deallocate(typestring)
        else
          write (LF,*)'The HDF5 ref file does not contain TYPEindices.'
          write (LF,*)'Fatal error, the calculation will stop now.'
          call Quit(_RC_INPUT_ERROR_)
        end if

#ifdef _DMRG_
        !> QCMaquis MPS reference wave function
        if (mh5_exists_dset(mh5id, 'QCMAQUIS_CHECKPOINT')) then
           hasMPSref  = .true.
        end if
#endif
        if(.not.hasMPSref.and.keyCIRE)then
          if (mh5_exists_dset(mh5id, 'CI_VECTORS'))then
            write (LF,*)' CI vectors will be read from HDF5 ref file.'
          else
            write (LF,*)'The HDF5 ref file does not contain CI vectors.'
            write (LF,*)'Fatal error, the calculation will stop now.'
            call Quit(_RC_INPUT_ERROR_)
          end if
          iCIRST=1
        end if
        call mh5_close_file(mh5id)
#else
        write (6,*) 'The format of the start orbital file was'
        write (6,*) 'specified by the user as HDF5, but this'
        write (6,*) 'is not implemented in this installation.'
        call Quit(_RC_INPUT_ERROR_)
#endif
      End If

* =======================================================================
      !> transfer orbital space data read from HDF5 file
      IF(IORBDATA.eq.3) THEN
        DO ISYM=1,NSYM
          NFRO(ISYM)=NFRO_L(ISYM)
          NISH(ISYM)=NISH_L(ISYM)
          NRS1(ISYM)=NRS1_L(ISYM)
          NRS2(ISYM)=NRS2_L(ISYM)
          NRS3(ISYM)=NRS3_L(ISYM)
          NSSH(ISYM)=NSSH_L(ISYM)
          NDEL(ISYM)=NDEL_L(ISYM)
        END DO
      END IF
* =======================================================================
      iprlev=insane

!> read orbital space data AND CI optimiation parameters from JOBIPH
      IF (IORBDATA.EQ.0) THEN
        IAD19=0
        Call IDaFile(JOBIPH,2,IADR19,10,IAD19)
        iAd19=iAdr19(1)
        CALL WR_RASSCF_Info(JobIPH,2,iAd19,NACTEL,ISPIN,NSYM,STSYM,
     &                      NFRO,NISH,NASH,NDEL,NBAS,
     &                      mxSym,lJobH1,LENIN8*mxOrb,NCONF,
     &                      lJobH2,2*72,JobTit,4*18*mxTit,
     &                      POTNUCDUMMY,LROOTS,NROOTS,IROOT,mxRoot,
     &                      NRS1,NRS2,NRS3,NHOLE1,NELEC3,IPT2,WEIGHT)
      End If  !> IORBDATA

!> read CI optimiation parameters from HDF5 file
      if(hasHDF5ref)then
#ifdef _HDF5_
        mh5id = mh5_open_file_r(StartOrbFile)
        call mh5_fetch_attr (mh5id,'SPINMULT', iSpin)
        call mh5_fetch_attr (mh5id,'NSYM', nSym)
        call mh5_fetch_attr (mh5id,'LSYM', stSym)
        call mh5_fetch_attr (mh5id,'NBAS', nBas)

        call mh5_fetch_attr (mh5id,'NACTEL', nactel)
        call mh5_fetch_attr (mh5id,'NHOLE1', nhole1)
        call mh5_fetch_attr (mh5id,'NELEC3', nelec3)
        call mh5_fetch_attr (mh5id,'NCONF',  nconf)
        call mh5_fetch_attr (mh5id,'NSTATES', lroots)
        If (mh5_exists_attr(mh5id, 'NROOTS')) Then
          call mh5_fetch_attr (mh5id,'NROOTS', nroots)
        Else
          nroots = lroots
        End If
        call mh5_fetch_attr (mh5id,'STATE_WEIGHT', weight)

        call mh5_close_file(mh5id)
#endif
      end if

!AMS - this may be closing either JOBOLD or JOBIPH. Close only JOBOLD.
      IF(JOBOLD>0) then
        IF(JOBOLD.ne.JOBIPH) THEN
            Call DaClos(JOBOLD)
        END IF
      end if


!AMS - make sure we change to a different JOBIPH file - we don't want to
!overwrite any existing JOBIPH file.
!
!Close the old JOBIPH file
      if(JOBIPH.gt.0) Then
        Call DaClos(JOBIPH)
        JOBIPH=-1
      end if
!Rename JOBIPH file, and open it.
      JOBIPH=IsFreeUnit(15)
      CALL DANAME(JOBIPH,IPHNAME)

*---  complete orbital specifications ---------------------------------*
      Do iSym=1,nSym
        if(.not.iDoGas)then
          nash(isym)=nrs1(isym)+nrs2(isym)+nrs3(isym)
        else
          NASH(ISYM)=SUM(NGSSH(1:NGAS,ISYM))
        end if
        NORB(ISYM)=NBAS(ISYM)-NFRO(ISYM)-NDEL(ISYM)
        NSSH(ISYM)=NORB(ISYM)-NISH(ISYM)-NASH(ISYM)
      End Do
*---  Related data for sizes, etc.
      NTOT=0
      NTOT1=0
      NTOT2=0
      NO2M=0
      NISHT=0
      NASHT=0
      NDELT=0
      NFROT=0
      NSEC=0
      NORBT=0
      NTOT3=0
      NTOTSP=0
      NTOT4=0
      NRS1T=0 ! for RASSCF
      NRS2T=0
      NRS3T=0
c      Call FZero(NGSSH_tot,ngas)
c      do igas=1,ngas
c        NGSSH_tot(igas) = SUM(NGSSH(IGAS,1:NSYM))
c      end do
c      if(dbg) then
c        write(6,*) 'NGSSH_tot(igas):'
c        write(6,*) (NGSSH_tot(igas),igas=1,ngas)
c      end if
      DO ISYM=1,NSYM
         NTOT=NTOT+NBAS(ISYM)
         NTOT1=NTOT1+NBAS(ISYM)*(NBAS(ISYM)+1)/2
         NTOT2=NTOT2+NBAS(ISYM)**2
         NO2M=MAX(NO2M,NBAS(ISYM)**2)
         NRS1T=NRS1T+NRS1(ISYM)  ! for RAS
         NRS2T=NRS2T+NRS2(ISYM)
         NRS3T=NRS3T+NRS3(ISYM)
         NFROT=NFROT+NFRO(ISYM)
         NISHT=NISHT+NISH(ISYM)
         NASHT=NASHT+NASH(ISYM)
         NDELT=NDELT+NDEL(ISYM)
         NSEC=NSEC+NSSH(ISYM)
         NORBT=NORBT+NORB(ISYM)
         NTOT3=NTOT3+(NORB(ISYM)+NORB(ISYM)**2)/2
         NTOTSP=NTOTSP+(NASH(ISYM)*(NASH(ISYM)+1)/2)
         NTOT4=NTOT4+NORB(ISYM)**2
      END DO
      NACPAR=(NASHT+NASHT**2)/2
      NACPR2=(NACPAR+NACPAR**2)/2
* NASHT is called NAC in some places:
      NAC=NASHT
* Same, NISHT, NIN:
      NIN=NISHT
      NFR=NFROT
      If (DBG) Write(6,*)' The iOrbData code is now',iOrbData
* =======================================================================
* Compute effective nuclear charge.
* Identical to nr of protons for conventional basis sets only, not ECP.
      Call Get_iScalar('Unique atoms',nNuc)
      Call GetMem('EffNChrg','Allo','Real',ipENC,nNuc)
      Call Get_dArray('Effective nuclear Charge',Work(ipENC),nNuc)
      TEffNChrg=0.0D0
      Call GetMem('nStab','Allo','Inte',ipStab,nNuc)
      Call Get_iArray('nStab',iWork(ipStab),nNuc)
      do i=1,nNuc
       TEffNChrg=TEffNChrg+Work(ipENC-1+i)*DBLE(nSym/iWork(ipStab-1+i))
      end do
      Call GetMem('nStab','Free','Inte',ipStab,nNuc)
      Call GetMem('EffNChrg','Free','Real',ipENC,nNuc)
      If (DBG) Write(6,*)
     &             ' Effective nuclear charge is TEffNChrg=',TEffNChrg
      TotChrg=0.0D0
      If (DBG) Write(6,*)' Set TotChrg=',TotChrg
*---  Process GRAD command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if GRADient case.'
      If (KeyGRAD) Then
       If (DBG) Write(6,*) ' GRADient keyword was used.'
       DoGradPDFT=.true.
*TRS
       call Put_iScalar('agrad',1)
*TRS
       if(iMSPDFT==1) then
        dogradmspd=.true.
        dogradpdft=.false.
       end if
       Call SetPos_m(LUInput,'GRAD',Line,iRc)
       Call ChkIfKey_m()
*TRS - Adding else statement to make nograd the default if the grad
*keyword isn't used
       Else
       DoNoGrad=.true.
*TRS
      End If
*
*---  Process GSOR command --------------------------------------------*
      If (DBG) Write(6,*) ' Check if Gram-Schmidt case.'
      If (KeyGSOR) Then
       If (DBG) Write(6,*) ' GSOR keyword was used.'
       DoGSOR=.true.
       Call SetPos_m(LUInput,'GSOR',Line,iRc)
       Call ChkIfKey_m()
      End If
*
*---  All keywords have been processed ------------------------------*

************************************************************************
* Generate artificial splitting or RAS into GAS for parallel blocking  *
************************************************************************
      IF (.NOT.IDOGAS) THEN
* SVC: convert CAS/RAS to general GAS description here, then we only
* need to copy it for lucia later, which always uses GAS description.
        NGSSH(1,1:NSYM)=NRS1(1:NSYM)
        NGSSH(2,1:NSYM)=NRS2(1:NSYM)
        NGSSH(3,1:NSYM)=NRS3(1:NSYM)
        IGSOCCX(1,1) = MAX(2*SUM(NRS1(1:NSYM))-NHOLE1,0)
        IGSOCCX(1,2) = 2*SUM(NRS1(1:NSYM))
        IGSOCCX(2,1) = NACTEL - NELEC3
        IGSOCCX(2,2) = NACTEL
        IGSOCCX(3,1) = NACTEL
        IGSOCCX(3,2) = NACTEL
      END IF
*
!Considerations for gradients/geometry optimizations

*     Numerical gradients requested in GATEWAY
      Call Qpg_iScalar('DNG',DNG)
      If (DNG) Then
         Call Get_iScalar('DNG',iDNG)
         DNG = iDNG.eq.1
      End If
      DNG=DoNoGrad.or.DNG
*
*     Inside LAST_ENERGY we do not need analytical gradients
      ProgName=Get_SuperName()
      If (ProgName(1:11).eq.'last_energy') DNG=.true.
*
*     Inside NUMERICAL_GRADIENT override input!
      If (ProgName(1:18).eq.'numerical_gradient') DNG=.true.
*
*
      If (DNG) Then
         DoGradPDFT=.false.
         if(iMSPDFT==1) then
          dogradmspd=.false.
         end if
      End If
*
*     Check to see if we are in a Do While loop
      Call GetEnvF('EMIL_InLoop',emiloop)
      If (emiloop.eq.' ') emiloop='0'
      Call GetEnvF('MOLCAS_IN_GEO',inGeo)
      If ((emiloop(1:1).ne.'0') .and. inGeo(1:1) .ne. 'Y'
     &    .and. .not.DNG) Then
         DoGradPDFT=.true.
         if(iMSPDFT==1) then
          dogradmspd=.true.
          dogradpdft=.false.
         end if
      End If
*                                                                      *
*---  Compute IZROT. IZROT is a matrix (lower triangular over the -----*
*     active space), which specifies which t,u rotations should be
*     avoided, since the orbitals belong to the same RAS space.
*     This is the only way the RAS concept is explicitly used in the
*     SX section of the program.
      ITU=0
      DO ISYM=1,NSYM
        NAO=NASH(ISYM)
*
        IF(DOBKAP)THEN
*.Giovanni... BK stuff SplitCAS related. We want to treat RAS CI space as CAS.
          DO NT=2,NAO
            DO NU=1,NT-1
              ITU=ITU+1
              IZROT(ITU)=1
            END DO
          END DO
        ELSE
*
*
*
          DO NT=2,NAO
            DO NU=1,NT-1
              ITU=ITU+1
              IZROT(ITU)=0
CSVC: check if NU<NT are included in the same gas space
              NGSSH_LO=0
              DO IGAS=1,NGAS
                NGSSH_HI=NGSSH_LO+NGSSH(IGAS,ISYM)
                IF (NU.GT.NGSSH_LO.AND.NT.LE.NGSSH_HI) THEN
                  IZROT(ITU)=1
                END IF
                NGSSH_LO=NGSSH_HI
              END DO
            END DO
          END DO
        END IF
      END DO
*
      Call Put_iArray('nIsh',nIsh,nSym)
      Call Put_iArray('nAsh',nAsh,nSym)
      Call Put_iScalar('Multiplicity',ISPIN)
*
*---  Initialize Cholesky information if requested
      if (DoCholesky)then
         Call Cho_X_init(irc,ChFracMem)
         if (irc.ne.0) Go To 9930
      endif

* ===============================================================

*
*     Initialize seward
*
      If (DBG) Write(6,*)' Initialize seward.'
      nDiff = 0
      If (DSCF           .or.
     &    RF_On()        .or.
     &    Langevin_On()  .or.
     &    PCM_On()       .or.
     &    Do_OFEmb       .or.
     &    KSDFT.ne.'SCF'     )
     &    Call IniSew(DSCF.or.Langevin_On().or.PCM_On(),nDiff)
* ===============================================================
*
*     Check the input data
*
      If (DBG) Then
        Write(6,*)' Call ChkInp.'
        Call XFlush(6)
      End If
      Call ChkInp_m()
* ===============================================================

      if(.not.DoGSOR) then
        NCONF=1
        GoTo 9000
      end if

      If(hasMPSref) GoTo 9000
* ===============================================================
*
*     Construct the Guga tables
*
      if(.not.iDoGas) then
        call gugactl_m
      else
        call mknsm_m
      end if
* ===============================================================
*
*     Construct the determinant tables
*

      If (DBG) Write(6,*)' Construct the determinant tables.'
      MS2 = iSpin - 1
*
* Set variables needed in Lucia_Ini
*
      Call iCopy(mxGAS*mxSym,ngssh,1,ngssh_Molcas,1)
      Call iCopy(mxGAS*2,igsoccx,1,igsoccx_Molcas,1)
      Call iCopy(nSym,norb,1,norb_Molcas,1)
      Call iCopy(nSym,nbas,1,nbas_Molcas,1)
      Call iCopy(nSym,nish,1,nish_Molcas,1)
      potnuc_Molcas    = potnuc
      thre_Molcas      = thre
      nsym_Molcas      = nsym
      nactel_Molcas    = nactel
      ms2_Molcas       = ms2
      ispin_Molcas     = ispin
      lsym_Molcas      = stsym
      NHOLE1_Molcas    = NHOLE1
      NELEC3_Molcas    = NELEC3
      itmax_Molcas     = itmax
      rtoi_Molcas      = rtoi
      nroots_Molcas    = Max(nroots,lRoots)
      ipt2_Molcas      = ipt2
      iprci_molcas     = iprloc(3)
      ngas_molcas      = ngas
      INOCALC_MOLCAS   = INOCALC
      ISAVE_EXP_MOLCAS = ISAVE_EXP
      IEXPAND_MOLCAS   = IEXPAND

*
* And call Lucia_Ini to initialize LUCIA
*
* Combinations don't work for CASVB (at least yet)!
      If (ifvb .ne. 0) iSpeed(1) = 0
*
      CALL Lucia_Util('Ini',iDummy,iDummy,Dummy)
* to get number of CSFs for GAS
      nconf=0
      do i=1,mxsym
        nconf=nconf+ncsasm(i)
      end do
*
      ISCF=0
      IF (ISPIN.EQ.NAC+1.AND.NACTEL.EQ.NAC) ISCF=1
      IF (ISPIN.EQ.1.AND.NACTEL.EQ.2*NAC)   ISCF=1
      IF (ISCF.EQ.1) THEN
         NCONF=1
         MAXJT=1
      END IF
*
*     If the CI-root selectioning option has been specified translate
*     the reference configuration numbers from the split graph GUGA
*     to the symmetric group numbering
*
* ===============================================================
      IF (ICICH.EQ.1) THEN
        CALL GETMEM('UG2SG','ALLO','INTE',LUG2SG,NCONF)
        CALL UG2SG_m(NROOTS,NCONF,NAC,NACTEL,STSYM,IPR,
     *             CONF,IWORK(KCFTP),IWORK(LUG2SG),
     *             ICI,JCJ,CCI,MXROOT)
        CALL GETMEM('UG2SG','FREE','INTE',LUG2SG,NCONF)
      END IF
* ===============================================================

      Go to 9000
*
*---  Error exits -----------------------------------------------------*
9810  CONTINUE
      If (IPRLEV.ge.TERSE) Then
       Call WarningMessage(2,'Error in input preprocessing.')
       Write(6,*)' PROC_INP: A keyword was found during prescanning'
       Write(6,*)' the input file, but when later trying to locate'
       Write(6,*)' this input, it could not be found. Something has'
       Write(6,*)' happened to the input file, or else there is some'
       Write(6,*)' strange program error.'
       iRc=_RC_INPUT_ERROR_
      End If
      Go to 9900

9910  CONTINUE
      Call WarningMessage(2,'End of input file during preprocessing.')
      Call WarningMessage(2,ReadStatus)
      If (IPRLEV.ge.TERSE) Write(6,*)' Error exit 9910 from PROC_INP.'
      iRc=_RC_INPUT_ERROR_
      Go to 9900
*
9920  CONTINUE
      Call WarningMessage(2,'Read error during input preprocessing.')
      Call WarningMessage(2,ReadStatus)
      If (IPRLEV.ge.TERSE) Write(6,*)' Error exit 9920 from PROC_INP.'
      iRc=_RC_INPUT_ERROR_
      Go to 9900
*
9930  CONTINUE
      Call WarningMessage(2,'Error during input preprocessing.')
      Call WarningMessage(2,ReadStatus)
      If (IPRLEV.ge.TERSE) Write(6,*)' Error exit 9930 from PROC_INP.'
      iRc=_RC_INPUT_ERROR_
      Go to 9900

*---  Normal exit -----------------------------------------------------*
9000  CONTINUE
      close(989)
      If (DBG) Write(6,*)' Normal exit from PROC_INP.'
      Return
*---  Abnormal exit -----------------------------------------------------*
9900  CONTINUE
      If (DBG) Write(6,*)' Abnormal exit from PROC_INP.'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function arSin(Arg)

use Constants, only: One
use Definitions, only: wp

implicit none
real(kind=wp) :: arSin
real(kind=wp), intent(in) :: Arg
real(kind=wp) :: A
character(len=72) :: Warning
real(kind=wp), parameter :: Delta = 1.0e-12_wp

A = Arg
if (abs(A) > One) then
  write(Warning,3) A
  if (abs(A) >= One+Delta) then
    call WarningMessage(2,Warning)
    call Abend()
  end if
  !call WarningMessage(1,Warning)
  A = sign(One,A)
end if

ArSin = asin(A)

return

3 format(1X,'Warning argument of aSin= ',1F21.18)

end function arSin

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dRdR(NSI,NESFJ,DR,RSolv,Sphere,NewSph)

use Constants, only: Two, Three, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NSI, NESFJ, NewSph(2)
real(kind=wp), intent(out) :: DR
real(kind=wp), intent(in) :: RSolv, Sphere(4,*)
integer(kind=iwp) :: NSK
real(kind=wp) :: D, D2, RI, RJ, RK, RS

! Trova la derivata del raggio della sfera NSI rispetto al raggio
! della sfera NSJ.
!
! La sfera NSI (che appartiene alle sfere "aggiunte" da PEDRA)
! dipende dalle due sfere "precedenti" NESFJ e NSK
! Se NESFJ o NSK sono negativi, la sfera aggiunta e' di tipo C
! e la generatrice "principale" corrisponde al label negativo
! (cfr. JCC 11, 1047 (1990))

if ((NEWSPH(1) < 0) .or. (NEWSPH(2) < 0)) then
  NSK = NEWSPH(1)
  if (abs(NSK) == NESFJ) NSK = NEWSPH(2)
  if (NSK > 0) then
    RS = RSOLV
    RJ = Sphere(4,NESFJ)+RS
    RK = Sphere(4,NSK)+RS
    RI = Sphere(4,NSI)+RS
    D2 = (Sphere(1,NESFJ)-Sphere(1,NSK))**2+(Sphere(2,NESFJ)-Sphere(2,NSK))**2+(Sphere(3,NESFJ)-Sphere(3,NSK))**2
    D = sqrt(D2)
    DR = (Two*D*RJ+Two*D*Sphere(4,NESFJ)-Two*RJ*Sphere(4,NESFJ)+D*D-RJ*RJ-RK*RK)/(Two*D*RI)
  else
    RS = RSOLV
    RJ = Sphere(4,NESFJ)+RS
    RI = Sphere(4,NSI)+RS
    D2 = (Sphere(1,NESFJ)-Sphere(1,abs(NSK)))**2+(Sphere(2,NESFJ)-Sphere(2,abs(NSK)))**2+(Sphere(3,NESFJ)-Sphere(3,abs(NSK)))**2
    D = sqrt(D2)
    DR = (Sphere(4,abs(NSK))*RJ)/(D*RI)
  end if
else
  NSK = NEWSPH(1)
  if (NSK == NESFJ) NSK = NEWSPH(2)
  RS = RSOLV
  RJ = Sphere(4,NESFJ)+RS
  RK = Sphere(4,NSK)+RS
  RI = Sphere(4,NSI)+RS
  D2 = (Sphere(1,NESFJ)-Sphere(1,NSK))**2+(Sphere(2,NESFJ)-Sphere(2,NSK))**2+(Sphere(3,NESFJ)-Sphere(3,NSK))**2
  D = sqrt(D2)
  DR = (-Three*RJ*RJ+RK*RK+Two*RJ*RK+Three*D*RJ-D*RK)/(Four*D*RI)
end if

return

end subroutine dRdR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************

function threej(XJ1,XJ2,XJ3,XM1,XM2,XM3)
!  ThreeJ: real Wigner 3-j coefficients. From a modification
!          of Racah's formula for Clebsch-Gordan coeffs.

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: threej
real(kind=wp), intent(in) :: XJ1,XJ2,XJ3,XM1,XM2,XM3
real(kind=wp), external :: DCLEBS
integer(kind=iwp) :: i

threej = DCLEBS(XJ1,XJ2,XJ3,XM1,XM2,-XM3)
if (threej == Zero) return
i = nint(XJ1-XJ2-XM3)
if (i /= (i/2)*2) threej = -threej
threej = threej/sqrt(Two*XJ3+One)

end function threej

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Cooout(Head,Cordst,nPart,nCent)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"

      Dimension Cordst(MxCen*MxPut,3)
      Character Head*200

      Write(6,*)
      Write(6,*)
      Write(6,'(A)')Head
      kaunter=0
      Do 1, i=1,nPart
        Write(6,*)'Molecule ',i
        Do 2, j=1,nCent
          kaunter=kaunter+1
          Write(6,*)(Cordst(kaunter,ii),ii=1,3)
2       Continue
1     Continue

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine CloseP
************************************************************************
*                                                                      *
* Object: to close the handling of the 2nd order density matrix.       *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
************************************************************************
      use aces_stuff
      use pso_stuff
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "stdalloc.fh"
#include "real.fh"
#include "setup.fh"
#include "mp2alaska.fh"
      Logical DoCholesky
*
      iRout = 249
      iPrint = nPrint(iRout)
*
      If(case_mp2) then
         Call DecideOnCholesky(DoCholesky)
         If(.not. DoCholesky) Then
            Call DaClos(LuGam)
         End If
      End If
      If (Gamma_On) Then
************ columbus interface ****************************************
         Call DaClos(LuGamma)
         Call mma_deallocate(Bin)
         Call mma_deallocate(G_Toc)
         Call mma_deallocate(SO2cI)
      End If
*
      If (lPSO) Then
         Call mma_deallocate(G2)
         Call mma_deallocate(G1)
      End If
      call mma_deallocate(CMO)
      call mma_deallocate(DSVar)
      call mma_deallocate(DS)
      call mma_deallocate(DVar)
      call mma_deallocate(D0)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine HRR1(ab1,nab1,a1b,na1b,cffAB,ab,nab,
     &           na,nb,na1,nb1,nPrim,la,lb)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             June '91                                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
*     Character*72 Label
      Real*8 ab1(nPrim,nab1), a1b(nPrim,na1b), cffAB(3),
     &       ab(nPrim,nab)
*
      Ind(iy,iz) = (iy+iz)*(iy+iz+1)/2 + iz + 1
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
*     iRout = 99
*     iPrint = nPrint(iRout)
*     If (iPrint.ge.99) Then
*        Write(Label,'(A,i1,A,i1,A)') ' Source: (',na1,',',nb,'|'
*        Call RecPrt(Label,' ',a1b,nPrim,na1b)
*        Call RecPrt(' Coordinates (A-B)',' ',cffAB,1,3)
*        Write(Label,'(A,i1,A,i1,A)') ' Source: (',na,',',nb,'|'
*        Call RecPrt(Label,' ',ab,nPrim,nab)
*     End If
*
*     Loop over indices of the target batch
*
      Do 20 ixb = nb1, 0, -1
         Do 25 iyb = nb1-ixb, 0, -1
            izb = nb1-ixb-iyb
            ixyzb1=Ind(iyb,izb)
*
            Do 30 ixa = na, 0, -1
               Do 35 iya = na-ixa, 0, -1
                  iza = na-ixa-iya
*
                  ixyza =Ind(iya,iza)
*
*                 Find a angular index which can be decremented
*
                  If (ixb.ne.0) Then
                     ipxyz = 1
                     ixyza1=Ind(iya,iza)
                     ixyzb =Ind(iyb,izb)
                  Else If (iyb.ne.0) Then
                     ipxyz = 2
                     ixyza1=Ind(iya+1,iza)
                     ixyzb =Ind(iyb-1,izb)
                  Else
                     ipxyz = 3
                     ixyza1=Ind(iya,iza+1)
                     ixyzb =Ind(iyb,izb-1)
                  End If
                  If (la.ge.lb) Then
                     ipab1 = ixyza  + nElem(na )*(ixyzb1-1)
                     ipa1b = ixyza1 + nElem(na1)*(ixyzb -1)
                     ipab  = ixyza  + nElem(na )*(ixyzb -1)
                  Else
                     ipab1 = ixyzb1 + nElem(nb1)*(ixyza -1)
                     ipa1b = ixyzb  + nElem(nb )*(ixyza1-1)
                     ipab  = ixyzb  + nElem(nb )*(ixyza -1)
                  End If
                  If (cffAB(ipxyz).ne.Zero) Then
                     Call DZaXpY(nPrim,cffAB(ipxyz),ab(1,ipab),1,
     &                                             a1b(1,ipa1b),1,
     &                                             ab1(1,ipab1),1)
                  Else
*                    call dcopy_(nPrim,a1b(1,ipa1b),1,ab1(1,ipab1),1)
                     Do 40 i = 1, nPrim
                        ab1(i,ipab1) = a1b(i,ipa1b)
 40                  Continue
                  End If
 35            Continue
 30         Continue
 25      Continue
 20   Continue
*
*     If (iPrint.ge.99) Then
*        Write(Label,'(A,i1,A,i1,A)') ' Target: (',na,',',nb1,'|'
*        Call RecPrt(Label,' ',ab1,nPrim,nab1)
*     End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_TestBookmark_1CInit(AllocatedHere)

use Cholesky, only: iAtomShl, nShell
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp), intent(out) :: AllocatedHere
integer(kind=iwp) :: irc

if (.not. allocated(iAtomShl)) then
  call mma_allocate(iAtomShl,nShell,Label='iAtomShl')
  irc = -1
  call Cho_SetAtomShl(irc,iAtomShl,size(iAtomShl))
  if (irc /= 0) then
    write(u6,'(A,I4)') 'Cho_TestBookmark_1Cinit: Cho_SetAtomShl returned',irc
    call Cho_Quit('shell-to-atom init failed!',104)
  end if
  AllocatedHere = .true.
else
  AllocatedHere = .false.
end if

end subroutine Cho_TestBookmark_1CInit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RdCtl_Seward(LuRd,lOPTO,Do_OneEl)
      use SW_File
      use AMFI_Info
      use Basis_Info
      use Center_Info
      use Her_RW
      use Period
      use MpmC
      use EFP_Module
      use Real_Spherical, only: Sphere
      use fortran_strings, only : str
      use External_Centers
      use Symmetry_Info, only: Symmetry_Info_Back, Symmetry_Info_Setup,
     &                         iSkip, nIrrep
      use Temporary_Parameters
      use Integral_Parameters
      use Sizes_of_Seward, Only: S
      use Real_Info, only: ThrInt, Rtrnc, CutInt, PkAcc, Thrs, E1, E2,
     &                     RPQMin, SadStep, Shake, kVector, CoM
      use DKH_Info
      use RICD_Info, only: iRI_Type, LDF, Do_RI, Cholesky,
     &                     Do_acCD_Basis, Skip_High_AC, DiagCheck,
     &                     LocalDF, Do_nacCD_Basis, Thrshld_CD
      use Logical_Info
#ifndef _HAVE_EXTRA_
      use XYZ
#endif
      Implicit Real*8 (a-h,o-z)
      External NucExp
#include "Molcas.fh"
#include "para_info.fh"
*
#include "angtp.fh"
#include "constants.fh"
#include "constants2.fh"
#include "SysDef.fh"
#include "notab.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "rctfld.fh"
#include "rmat.fh"
#include "real.fh"
#include "print.fh"
#include "RelLight.fh"
#include "gateway.fh"
#include "hyper.fh"
#ifdef _FDE_
      ! Thomas Dresselhaus
#include "embpotdata.fh"
#endif
#include "relae.fh"
#include "periodic_table.fh"
      Common /AMFn/ iAMFn
*
      Real*8 Lambda
      Character Key*180, KWord*180, Oper(3)*3, BSLbl*80, Fname*256,
     &          DefNm*13, Ref(2)*80, ChSkip*80, AngTyp(0:iTabMx)*1,
     &          dbas*(LENIN),filename*180, KeepBasis*256, KeepGroup*180,
     &          Previous_Command*12, BSLbl_Dummy*80, CtrLDK(10)*(LENIN),
     &          Directory*256, BasLib*256,ExtBasDir*256
      Character(LEN=72):: Header(2)=['','']
      Character(LEN=80):: Title(10)=['','','','','','','','','','']
      Character(LEN=14):: Vrsn='Gateway/Seward'
      Character(LEN=512):: Align_Weights='MASS'
      Character*180 Line
      common/cgetlc/ Line
      Character*180 Get_Ln
      External Get_Ln
      Logical lTtl, lSkip, lMltpl, DoRys, RF_read, Convert, IfTest,
     &        Exist,CutInt_UsrDef, ThrInt_UsrDef, MolWgh_UsrDef,
     &        CholeskyWasSet, GWInput, NoAMFI, lOPTO, Do_OneEl
      Logical do1CCD
      Logical:: CSPF=.False.
      Logical APThr_UsrDef, Write_BasLib
      Integer Cho_MolWgh, StayAlone, BasisTypes(4), BasisTypes_Save(4),
     &        iGeoInfo(2), iOpt_XYZ, RC
      Parameter (Cho_CutInt = 1.0D-40, Cho_ThrInt = 1.0D-40,
     &           Cho_MolWgh = 2)
*
      Real*8 NucExp, WellCff(3), WellExp(3), WellRad(3),
     &       OAMt(3), OMQt(3)
      Real*8, Allocatable :: RTmp(:,:), EFt(:,:),
     &                       DMSt(:,:), OrigTrans(:,:), OrigRot(:,:,:),
     &                       mIsot(:)
      Integer, Allocatable :: ITmp(:), nIsot(:,:), iScratch(:)
!     Temporary buffer
      Integer, Parameter:: nBuff=10000
      Real*8, Allocatable:: Buffer(:), Isotopes(:)
!
      Character*180, Allocatable :: STDINP(:)
      Character Basis_lib*256, CHAR4*4
      Character*256 Project, GeoDir, temp1, temp2
*
      Integer StrnLn
      External StrnLn

      Logical SymmSet
      Logical CoordSet,RPSet
      Logical BasisSet
      Logical GroupSet
      Logical DoneCoord
      Logical NoZMAT
      Logical ForceZMAT
      Logical XYZdirect
      Logical NoDKroll
      Logical DoTinker
      Logical DoGromacs
      Logical OriginSet
      Logical FragSet
      Logical HyperParSet
      Logical WriteZMat, geoInput, oldZmat,zConstraints
      Logical EFgiven
      Logical Invert
      Real*8 HypParam(3), RandVect(3)
      Logical Vlct_, nmwarn, FOUND
*
      Logical DoEMPC, Basis_test, lECP, lPP
      Logical :: lDMS=.FALSE., lOAM=.FALSE., lOMQ=.False.,
     &           lAMP=.False., lXF=.False., lFAIEMP=.False.
      Common /EmbPCharg/ DoEMPC
*
#ifdef _GROMACS_
      Integer, Dimension(:), Allocatable :: CastMM
      Integer, Dimension(:,:), Allocatable :: DefLA
      Real*8, Dimension(:), Allocatable :: FactLA
#endif
      Character*256 Message
      parameter (MAX_XBAS=20)
      Character*12 xb_label(MAX_XBAS)
      Character*128 xb_bas(MAX_XBAS)
*
      Data WellCff/.35D0,0.25D0,5.2D0/
      Data WellExp/4.0D0,3.0D0,2.0D0/
      Data WellRad/-1.22D0,-3.20D0,-6.20D0/
      Data StayAlone/0/
*
#include "angstr.fh"
      Data DefNm/'basis_library'/
      Data IfTest/.False./
*                                                                      *
************************************************************************
*                                                                      *
      Interface
#include "getbs_interface.fh"
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      iRout=3
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(Buffer,nBuff,Label='Buffer')
*                                                                      *
************************************************************************
*                                                                      *
      Do i=0,iTabMx
         AngTyp(i)=Angtp(i)
         Call UpCase(AngTyp(i))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call WhichMolcas(Basis_lib)
      If (Basis_lib(1:1).ne.' ') Then
         StayAlone=1
         ib=index(Basis_lib,' ')-1
         if(ib.lt.1)
     &   Call SysAbendMsg('rdCtl','Too long PATH to MOLCAS',' ')
         BasLib=Basis_lib(1:ib)//'/basis_library'
      Else
         BasLib=DefNm
      End If
      Write_BasLib=.False.
*                                                                      *
************************************************************************
*                                                                      *
      Call Qpg_cArray('Align_Weights',Found,lAW)
      If (Found) Call Get_cArray('Align_Weights',Align_Weights,512)
*                                                                      *
************************************************************************
*                                                                      *
      CutInt_UsrDef=.False.
      ThrInt_UsrDef=.False.
      MolWgh_UsrDef=.False.
      APThr_UsrDef=.False.
      NoAMFI=.False.
*
      iChk_RI=0
      iChk_CH=0
      iChk_DC=0
      iOpt_XYZ=-1
*
      isXfield=0
      CholeskyThr=-9.99d9
*
      Basis_Test=.False.
*                                                                      *
************************************************************************
*                                                                      *
      LuWr=6
      LuFS=-1
      LuRdSave=-1
*
      nTemp=0
      ipRTmp=ip_Dummy
      ipITmp=ip_iDummy
      lMltpl=.False.
*
      CholeskyWasSet=.False.
      do1CCD=.false.
      spanCD=-9.9d9
      lTtl = .False.
      RF_read=.False.
      lSkip=.False.
      NoDKroll=.false.
      SymmSet=.false.
      BasisSet=.false.
      GroupSet=.false.
      RPSet=.false.
      CoordSet=.false.
      DoneCoord=.false.
      KeepGroup='FULL'
      NoZMAT=.false.
      ForceZMAT=.false.
      XYZDirect=.false.
      DoTinker = .False.
      DoGromacs = .False.
      origin_input = .False.
      geoInput = .False.
      ZConstraints = .False.
      OldZmat = .False.
      WriteZMat = .False.
      nFragment = 0
      iFrag = 0
      FragSet = .False.
      OriginSet = .False.
      HyperParSet = .False.
      stepFac1 = 60.0d0
      iOptimType = 1
      gradLim = 0.0d0
      Do_OneEl=.True.
      Vlct_=.False.
#ifdef _FDE_
      ! Embedding
      embPot=.false.
      embPotInBasis=.false.
      embPotPath='EMBPOT'
      outGridPathGiven=.false.
      embWriteDens=.false.
      embWriteEsp=.false.
      embWriteGrad=.false.
      embWriteHess=.false.
      Call Put_iScalar('embpot',0)
#endif
      DoEmPC=.False.
      EFgiven=.False.
      Invert=.False.
      Call Put_iScalar('agrad',0)
*
      ScaleFactor=1.0d0
      lSTDINP=0
      iCoord=0
      nCoord=0
      iBSSE=-1
      SymThr=0.01D0
      isHold=-1
      nTtl=0
*
      imix=0
      ifnr=-1
      ign=0
      itype=0
      ExtBasDir=' '
      isxbas=0
      nmwarn=.True.
*
*     Selective initialization
*
      If (Run_Mode.eq.S_Mode) Then
         iShll = S%Mx_Shll
         mdc = S%Mx_mdc
      Else
         iShll = 0
         mdc = 0
*
         ChSkip=' '
         Do i = 1,3
            Oper(i)=' '
         End Do
         nOper=0
         CLightAU = CONST_C_IN_AU_
      End If
*
      iDNG=0
      nDKfull = 0
      iAMFn = 0   ! usual AMFI
      BasisTypes(:)=0
      KeepBasis=' '
cperiod
      lthCell = 0
      Cell_l = .FALSE.
      Call izero(ispread,3)
      Call fzero(VCell,9)
*     Set local DF variables (dummy)
      Call LDF_SetInc()
      Rewind(LuRd)
*     Count the number of calls to coord to set the number of fragments
*     for a geo/hyper-calculation
 400  Key= Get_Ln(LuRd)
      KWord = Key
      Call UpCase(KWord)
      If(KWord(1:4) .eq. 'COOR') nFragment=nFragment+1
      If((KWord(1:4) .eq. 'HYPE') .or.
     &   (KWord(1:4) .eq. 'GEO ')) Then
         call getenvf("Project",Project)
         call getenvf("GeoDir",GeoDir)
         temp1 = Project(1:index(Project,' ')-1)//
     &           '.Gateway.Input'
         temp2 = GeoDir(1:index(GeoDir,' ')-1)//'/'//
     &           Project(1:index(Project,' ')-1)//'.gwcopy.input'
         Call fCopy(temp1,temp2,ierr)
         if(ierr.ne.0) then
           write(6,*) '*** Detect Hyper input, but no GEO loop'
           call Quit_OnUserError()
         EndIf
      End If
      If (KWord(1:4).eq.'END ') Go To 401
      GoTo 400
 401  Call Put_iScalar('nCoordFiles',nFragment)
      Rewind(LuRd)
*                                                                      *
************************************************************************
*                                                                      *
      If (Run_Mode.eq.G_Mode) Then
         Call RdNLst(LuRd,'GATEWAY')
         Previous_Command='&Gateway'
      Else
         Call RdNLst(LuRd,'SEWARD')
         Previous_Command='&Seward'
      End If
*
*     Default setting of GWInput
*
      GWInput=Run_Mode.eq.G_Mode
*
*     GWInput is a logical flag which tells if a keyword is Gateway or
*     Seward specific. This is done down below for each keyword in the
*     case that the keyword is not Seward or Gateway specific enter the
*     line,
*
*     GWInput = Run_Mode.eq.G_Mode
*
*     in the section of the particular keyword
*                                                                      *
************************************************************************
*                                                                      *
*
*     KeyWord directed input
*
      Call mma_allocate(STDINP,MxAtom*2,label='STDINP')
*
      nDone=0
 998  lTtl = .False.
      If (Basis_Test.and.nDone.eq.1) Then
         nDone=0
         Basis_Test=.False.
      End If
 9988 Continue
      Key = Get_Ln(LuRd)
*
 9989 If (Run_Mode.eq.G_Mode.and..Not.GWInput) Then
         Call WarningMessage(2,'Gateway input error!')
         Write (LuWr,*) 'The keyword : "',Previous_Command,
     &                  '" is not allowed in the Gateway input!'
         Write (LuWr,*) 'This keyword most likely belongs in the '
     &                //'Seward input section!.'
         Write (LuWr,*)
         Call Quit_OnUserError()
      Else If (Run_Mode.eq.S_Mode.and.GWInput) Then
         Call WarningMessage(2,'Seward input error!')
         Write (LuWr,*) 'The keyword : "',Previous_Command,
     &                  '" is not allowed'
     &               //' in the Seward input when the Gateway is used!'
         Write (LuWr,*) ' Try putting the keyword in the Gateway '
     &                //'input section!'
         Write (LuWr,*)
         Call Quit_OnUserError()
      End If
      GWInput=.False.
*
      If (IfTest) Write (LuWr,*) ' RdCtl: Processing:',Key
      KWord = Key
      Call UpCase(KWord)
      Previous_Command=KWord(1:4)
      If (KWord(1:1).eq.'*') Go To 998
      If (KWord.eq.'')    Go To 998
      If (Basis_Test) nDone=1
*
*     KEYWORDs in ALPHABETIC ORDER!
*
      If (KWord(1:4).eq.'1C-C') Go To 9022
      If (KWord(1:4).eq.'1CCD') Go To 9022
      If (KWord(1:4).eq.'ACCD') Go To 8005
      If (KWord(1:4).eq.'ACD ') Go To 8004
      If (KWord(1:4).eq.'ALIG') Go To 8013
      If (KWord(1:4).eq.'AMFI') Go To 9761
      If (KWord(1:4).eq.'AMF1') Go To 8761
      If (KWord(1:4).eq.'AMF2') Go To 8762
      If (KWord(1:4).eq.'AMF3') Go To 8763
      If (KWord(1:4).eq.'AMPR') Go To 9951
      If (KWord(1:4).eq.'ANGM') Go To 995
      If (KWord(1:4).eq.'APTH') Go To 38
      If (KWord(1:4).eq.'AUXS') Go To 912
      If (KWord(1:4).eq.'BASD') Go To 7700
      If (KWord(1:4).eq.'BASI') Go To 920
      If (KWord(1:4).eq.'BASL') Go To 8029
      If (KWord(1:4).eq.'BSSE') Go To 6020
      If (KWord(1:4).eq.'BSSH') Go To 9121
      If (KWord(1:4).eq.'BSSM') Go To 9760
      If (KWord(1:4).eq.'CDTH') Go To 8001
      If (KWord(1:4).eq.'CELL') Go To 887
      If (KWord(1:4).eq.'CENT') Go To 973
      If (KWord(1:4).eq.'CHEC') Go To 39
      If (KWord(1:4).eq.'CLDF') Go To 42
      If (KWord(1:4).eq.'CHOL') Go To 9091
      If (KWord(1:4).eq.'CHOI') Go To 9092
      If (KWord(1:4).eq.'CLIG') Go To 9000
      If (KWord(1:4).eq.'CONS') Go To 8010
      If (KWord(1:4).eq.'COOR') Go To 6000
      If (KWord(1:4).eq.'CSPF') Go To 9110
      If (KWord(1:4).eq.'CUTO') Go To 942
      If (KWord(1:4).eq.'DCRN') Go To 958
      If (KWord(1:4).eq.'DIAG') Go To 9087
      If (KWord(1:4).eq.'DIRE') Go To 9770
      If (KWord(1:4).eq.'DK1H') Go To 9001
      If (KWord(1:4).eq.'DK2H') Go To 9002
      If (KWord(1:4).eq.'DK3F') Go To 9004
      If (KWord(1:4).eq.'DK3H') Go To 9003
      If (KWord(1:4).eq.'DOAN') Go To 8019
      If (KWord(1:4).eq.'DOFM') Go To 8006
      If (KWord(1:4).eq.'DOUG') Go To 976
      If (KWord(1:4).eq.'DOWN') Go To 1002
      If (KWord(1:4).eq.'DSHD') Go To 996
      If (KWord(1:4).eq.'ECPS') Go To 912
      If (KWord(1:4).eq.'EFLD') Go To 993
      If (KWord(1:4).eq.'EFP ') Go To 9088
#ifdef _FDE_
      If (KWord(1:4).eq.'EMBE') Go To 666
#endif
      If (KWord(1:4).eq.'EMFR') Go To 8035
      If (KWord(1:4).eq.'EMPC') Go To 974
      If (KWord(1:4).eq.'EPOT') Go To 9932
      If (KWord(1:4).eq.'EXPE') Go To 9771
      If (KWord(1:4).eq.'EXTR') Go To 9960
      If (KWord(1:4).eq.'FAKE') Go To 9759
      If (KWord(1:4).eq.'FAT-') Go To 8004
      If (KWord(1:4).eq.'FCD ') Go To 9091
      If (KWord(1:4).eq.'FILE') Go To 904
      If (KWord(1:4).eq.'FINI') Go To 9762
      If (KWord(1:4).eq.'FLDG') Go To 994
      If (KWord(1:4).eq.'FNMC') Go To 9086
      If (KWord(1:4).eq.'FOOC') Go To 8000
      If (KWord(1:4).eq.'FPCO') Go To 9764
      If (KWord(1:4).eq.'FPPR') Go To 9765
      If (KWord(1:4).eq.'FRGM') Go To 8025
      If (KWord(1:4).eq.'GEO ') Go To 8024
      If (KWord(1:4).eq.'GEOE') Go To 8020
      If (KWord(1:4).eq.'GIAO') Go To 9020
      If (KWord(1:4).eq.'GRID') Go To 9773
      If (KWord(1:4).eq.'GROM') Go To 8034
      If (KWord(1:4).eq.'GROU') Go To 6010
      If (KWord(1:4).eq.'HIGH') Go To 9096
      If (KWord(1:4).eq.'HYPE') Go To 8016
      If (KWord(1:4).eq.'ISOT') Go To 7654
      If (KWord(1:4).eq.'JMAX') Go To 971
      If (KWord(1:4).eq.'KHAC') Go To 8003
      If (KWord(1:4).eq.'LDF ') Go To 35
      If (KWord(1:4).eq.'LDF1') Go To 35
      If (KWord(1:4).eq.'LDF2') Go To 36
      If (KWord(1:4).eq.'RLOC') Go To 658
      If (KWord(1:4).eq.'LINK') Go To 8036
      If (KWord(1:4).eq.'LOCA') Go To 35
      If (KWord(1:4).eq.'LOW ') Go To 9094
      If (KWord(1:4).eq.'MEDI') Go To 9095
      If (KWord(1:4).eq.'MGAU') Go To 8009
      If (KWord(1:4).eq.'MOLC') Go To 957
      If (KWord(1:4).eq.'MOLE') Go To 960
      If (KWord(1:4).eq.'MOLP') Go To 959
      If (KWord(1:4).eq.'MOVE') Go To 6040
      If (KWord(1:4).eq.'MULT') Go To 972
      If (KWord(1:4).eq.'NACC') Go To 8030
      If (KWord(1:4).eq.'NEMO') Go To 800
      If (KWord(1:4).eq.'NGEX') Go To 501
      If (KWord(1:4).eq.'NOAL') Go To 7013
      If (KWord(1:4).eq.'NOAM') Go To 8007
      If (KWord(1:4).eq.'NOCD') Go To 9084
      If (KWord(1:4).eq.'NOCH') Go To 9089
      If (KWord(1:4).eq.'NODE') Go To 7070
      If (KWord(1:4).eq.'NODK') Go To 989
      If (KWord(1:4).eq.'NOGU') Go To 9100
      If (KWord(1:4).eq.'NOMO') Go To 6050
      If (KWord(1:4).eq.'NOON') Go To 8023
      If (KWord(1:4).eq.'NOPA') Go To 9910
      If (KWord(1:4).eq.'NOTA') Go To 980
      If (KWord(1:4).eq.'NOUN') Go To 46
      If (KWord(1:4).eq.'NUME') Go To 8031
      If (KWord(1:4).eq.'OLDD') Go To 8121
      If (KWord(1:4).eq.'OLDZ') Go To 8021
      If (KWord(1:4).eq.'OMQI') Go To 999
      If (KWord(1:4).eq.'ONEO') Go To 990
      If (KWord(1:4).eq.'OPTH') Go To 8022
      If (KWord(1:4).eq.'OPTO') Go To 940
      If (KWord(1:4).eq.'ORBA') Go To 913
      If (KWord(1:4).eq.'ORBC') Go To 906
      If (KWord(1:4).eq.'ORIG') Go To 8015
      If (KWord(1:4).eq.'OVER') Go To 41
      If (KWord(1:4).eq.'PAMF') Go To 8060
      If (KWord(1:4).eq.'PART') Go To 9763
      If (KWord(1:4).eq.'PKTH') Go To 9940
      If (KWord(1:4).eq.'PSOI') Go To 9023
      If (KWord(1:4).eq.'PRIN') Go To 930
c     If (KWord(1:1).eq.'R' .and.
c    &    (KWord(2:2).ge.'0' .and.
c    &     KWord(2:2).le.'9') .and.
c    &     (KWord(3:3).ge.'0' .and.
c    &      KWord(3:3).le.'9') .and.
c    &      (KWord(4:4).eq.'O' .or.
c    &       KWord(4:4).eq.'E' .or.
c    &       KWord(4:4).eq.'S' .or.
c    &       KWord(4:4).eq.'M' .or.
c    &       KWord(4:4).eq.'C') ) Go To 657
      If (KWord(1:4).eq.'RA0F') Go To 9012
      If (KWord(1:4).eq.'RA0H') Go To 9011
      If (KWord(1:4).eq.'RADI') Go To 909
      If (KWord(1:4).eq.'RAIH') Go To 9013
      If (KWord(1:4).eq.'RBSS') Go To 9015
      If (KWord(1:4).eq.'RELA') Go To 657
      If (KWord(1:4).eq.'RELI') Go To 962
      If (KWord(1:4).eq.'RESC') Go To 978
      If (KWord(1:4).eq.'RF-I') Go To 9970
      If (KWord(1:4).eq.'RLDF') Go To 8012
      If (KWord(1:4).eq.'RIC ') Go To 9097
      If (KWord(1:4).eq.'RICD') Go To 9080
      If (KWord(1:4).eq.'RIJ ') Go To 9098
      If (KWord(1:4).eq.'RIJK') Go To 9099
      If (KWord(1:4).eq.'RMAT') Go To 880
      If (KWord(1:4).eq.'RMBP') Go To 886
      If (KWord(1:4).eq.'RMDI') Go To 884
      If (KWord(1:4).eq.'RMEA') Go To 881
      If (KWord(1:4).eq.'RMER') Go To 882
      If (KWord(1:4).eq.'RMEQ') Go To 885
      If (KWord(1:4).eq.'RMQC') Go To 883
      If (KWord(1:4).eq.'ROT ') Go To 8027
      If (KWord(1:4).eq.'RP-C') Go To 9093
      If (KWord(1:4).eq.'RPQM') Go To 8008
      If (KWord(1:4).eq.'RTRN') Go To 950
      If (KWord(1:4).eq.'RX2C') Go To 9014
      If (KWord(1:4).eq.'SADD') Go To 9081
      If (KWord(1:4).eq.'SCAL') Go To 8018
      If (KWord(1:4).eq.'SHAK') Go To 8050
      If (KWord(1:4).eq.'SDEL') Go To 7071
      If (KWord(1:4).eq.'SDIP') Go To 992
      If (KWord(1:4).eq.'SHAC') Go To 8002
      If (KWord(1:4).eq.'SKIP') Go To 9950
      If (KWord(1:4).eq.'SLIM') Go To 8005
      If (KWord(1:4).eq.'SPAN') Go To 890
      If (KWord(1:4).eq.'SPRE') Go To 889
      If (KWord(1:4).eq.'STDO') Go To 9930
      If (KWord(1:4).eq.'SYMM') Go To 900
      If (KWord(1:4).eq.'SYMT') Go To 6060
      If (KWord(1:4).eq.'TARG') Go To 37
      If (KWord(1:4).eq.'TDEL') Go To 7072
      If (KWord(1:4).eq.'TEST') Go To 991
      If (KWord(1:4).eq.'THRC') Go To 9021
      If (KWord(1:4).eq.'THRE') Go To 941
      If (KWord(1:4).eq.'THRL') Go To 37
      If (KWord(1:4).eq.'THRS') Go To 907
      If (KWord(1:4).eq.'TINK') Go To 8014
      If (KWord(1:4).eq.'TITL') Go To 910
      If (KWord(1:4).eq.'TRAN') Go To 8026
      If (KWord(1:4).eq.'UNCO') Go To 43
      If (KWord(1:4).eq.'UNIQ') Go To 45
      If (KWord(1:4).eq.'UNNO') Go To 908
      If (KWord(1:4).eq.'UPON') Go To 1001
      If (KWord(1:4).eq.'VECT') Go To 905
      If (KWord(1:4).eq.'VART') Go To 8032
      If (KWord(1:4).eq.'VARR') Go To 8033
      If (KWord(1:4).eq.'VERB') Go To 9122
      If (KWord(1:4).eq.'VERI') Go To 40
      If (KWord(1:4).eq.'WEIG') Go To 7014
      If (KWord(1:4).eq.'WELL') Go To 986
      If (KWord(1:4).eq.'WRUC') Go To 44
      If (KWord(1:4).eq.'XBAS') Go To 1924
      If (KWord(1:4).eq.'XFIE') Go To 975
      If (KWord(1:4).eq.'XRIC') Go To 9085
      If (KWord(1:4).eq.'XYZ ') Go To 1917
      If (KWord(1:4).eq.'ZCON') Go To 8017
      If (KWord(1:4).eq.'ZMAT') Go To 1920
      If (KWord(1:4).eq.'ZONL') Go To 8028
*
      If (KWord(1:4).eq.'END ') Go To 997
      If (lTtl) Go To 911
*
      If (Basis_test) Then
*
*        So the Basis keyword was in the native format.
*        We have to back step until we find the command line!
*
         Backspace(LuRd)
         Backspace(LuRd)
         Read(LuRd,'(A)') Key
         Call UpCase(Key)
         Do While(Index(Key(1:4),'BASI').eq.0)
              Backspace(LuRd)
              Backspace(LuRd)
              Read(LuRd,'(A)') Key
              Call UpCase(Key)
         End Do
         Basis_test=.False.
         nDone=0
         Go To 9201
      End If
      iChrct=Len(KWord)
      Last=iCLast(KWord,iChrct)
      Write (LuWr,*)
      Call WarningMessage(2,KWord(1:Last)//' is not a keyword!,'//
     &               ' Error in keyword.')
      Call Quit_OnUserError()
*
c977  Call WarningMessage(2,' Premature end of input file.')
c     Call Quit_OnUserError()
*
#ifdef _FDE_
*                                                                      *
****** EMBE ************************************************************
*                                                                      *
*     Read in the name of a file for an embedding potential on a grid
*
 666  embPot=.true.
      Call Put_iScalar('embpot',1)
 667  KWord = Get_Ln(LuRd)
      if(KWord(1:4).eq."ENDE") then
       ! Sanity check
       if (embPotInBasis.and.(.not.outGridPathGiven).and.(embWriteDens
     &      .or.embWriteESP.or.embWriteGrad.or.embWriteHess)) then
        Call WarningMessage(2,' No grid to write output in embedding.')
        Call Quit_OnUserError()
       end if
       ! Write the embpot runfile
       Call EmbPotWrRun
       Go To 998
      end if
      ! Switch whether the potential is given in basis set
      ! representation instead of grid representation
      if (KWord(1:4).eq."BASI") then
       embPotInBasis = .true.
       write(LuWr,*) "Set embPotInBasis to ", embPotInBasis
       Go To 667
      end if
      ! Get the EMBInfile path containing an embedding pot. on a grid
      if(KWord(1:4).eq."EMBI") then
       KWord = Get_Ln(LuRd)
       Call Get_S(1,embPotPath,1)
       Go To 667
      end if
      ! If the output grid is different from the input grid a path to
      ! a grid file is specified here
      if(KWord(1:4).eq."OUTG") then
       KWord = Get_Ln(LuRd)
       Call Get_S(1,outGridPath,1)
       outGridPathGiven=.true.
       Go To 667
      end if
      ! If given, the final density is written out on a grid, the path
      ! to the file where to write it to must be given as well.
      if(KWord(1:4).eq."WRDE") then
       embWriteDens=.true.
       KWord = Get_Ln(LuRd)
       Call Get_S(1,embOutDensPath,1)
       Go To 667
      end if
      ! If given, the final electrostatic potential is written out on
      ! a grid, the path to the file where to write it to must be given
      ! as well.
      if(KWord(1:4).eq."WREP") then
       KWord = Get_Ln(LuRd)
       Call Get_S(1,embOutEspPath,1)
       embWriteESP=.true.
       Go To 667
      end if
      ! If given, the density gradient is written out on a grid, the
      ! path to the file where to write it to must be given as well.
      if(KWord(1:4).eq."WRGR") then
       KWord = Get_Ln(LuRd)
       Call Get_S(1,embOutGradPath,1)
       embWriteGrad=.true.
       Go To 667
      end if
      ! If given, the Hessian of the density is written out on a grid,
      ! the path to the file where to write it to must be given as
      ! well.
      if(KWord(1:4).eq."WRHE") then
       embWriteHess=.true.
       KWord = Get_Ln(LuRd)
       Call Get_S(1,embOutHessPath,1)
       Go To 667
      end if
      ! Should not be reached.
       Call WarningMessage(2,
     &             'Error in input of EMBEdding block!')
       Call Quit_OnUserError()
#endif
*                                                                      *
****** SYMM ************************************************************
*                                                                      *
*     Read distinct symmetry operators apart for the unity operator
*
 900  SymmSet=.true.
      KWord = Get_Ln(LuRd)
      GWInput=.True.
      If (.not.DoneCoord.and.iCoord.ne.0) Then
       Call WarningMessage(2,
     &             'SYMMETRY keyword is not compatible with COORD')
       Call Quit_OnUserError()
      End If
      If (Run_Mode.eq.S_Mode) Then
         Call WarningMessage(2,'Seward input error!')
         Write (LuWr,'(A,A,A)') 'The command : "',Previous_Command,
     &                          '" is not allowed'
     &                        //' in Seward input when Gateway is used!'
         Write (LuWr,*)
         Call Quit_OnUserError()
      End If
      Call UpCase(KWord)
      iChrct=Len(KWord)
 901  Last=iCLast(KWord,iChrct)
      iFrst=iCFrst(KWord,iChrct)
      If (iFrst.le.Last) Then
         nOper = nOper + 1
         Oper(nOper)(1:1) = KWord(iFrst:iFrst)
         KWord(iFrst:iFrst) = ' '
         iFrst = iFrst + 1
         If (KWord(iFrst:iFrst).eq.' ') Go To 901
         Oper(nOper)(2:2) = KWord(iFrst:iFrst)
         KWord(iFrst:iFrst) = ' '
         iFrst = iFrst + 1
         If (KWord(iFrst:iFrst).eq.' ') Go To 901
         Oper(nOper)(3:3) = KWord(iFrst:iFrst)
         KWord(iFrst:iFrst) = ' '
         Go to 901
      Else
         Go To 998
      End If
*                                                                      *
****** FILE ************************************************************
*                                                                      *
*     Specify filename for input orbitals
*
 904  Line = Get_Ln(LuRd)
      Call FileOrb(Line,SW_FileOrb)
      Go To 998
*                                                                      *
****** VECT ************************************************************
*                                                                      *
*     Change mode of Seward to property calculations.
*
 905  Prprt = .True.
      Go To 998
*                                                                      *
****** ORBC ************************************************************
*                                                                      *
*     Request property output with explicit listing of orbital
*     contributions.
*
 906  Short = .False.
      Go To 998
*                                                                      *
****** THRS ************************************************************
*                                                                      *
*     Change default for non-zero occupation numbers
*
 907  KWord = Get_Ln(LuRd)
      Call Get_F1(1,Thrs)
      Thrs = Abs(Thrs)
      Go To 998
*                                                                      *
****** UNNO ************************************************************
*                                                                      *
*     Change default to unnormalized integrals
*
 908  UnNorm = .True.
      Go To 998
*                                                                      *
****** RADI ************************************************************
*                                                                      *
*     Integral cutoff to be based on radial overlap integrals
*
 909  lSchw = .False.
      Go To 998
*                                                                      *
****** TITL ************************************************************
*                                                                      *
*     Read the Title card
*
 910  Key = Get_Ln(LuRd)
 911  Continue
      GWInput = Run_Mode.eq.G_Mode
      lTtl = .True.
      nTtl = nTtl + 1
      If (nTtl.gt.10) Then
         Call WarningMessage(2,' Too many title cards')
         Call Quit_OnUserError()
      End If
      i1=iCFrst(Key,80)
      i2=iCLast(Key,80)
      nc = 80-(i2-i1+1)
      nc2=nc/2
      nc3=(nc+1)/2
      Title(nTtl)=''
      Title(nTtl)(nc2+1:nc2+i2-i1+1)=Key(i1:i2)
      Go To 9988
*                                                                      *
****** ECPS **** or ****** AUXS ****************************************
*                                                                      *
*     Allow printing of ECP data
*
 912  nPrint(2)=Max(10,nPrint(2))
      GWInput=.True.
      Go To 998
*                                                                      *
****** BSSH ************************************************************
*                                                                      *
*     Allow printing of basis set data
*
 9121 nPrint(2)=Max(6,nPrint(2))
      GWInput=.True.
      Go To 998
*                                                                      *
****** VERB ************************************************************
*                                                                      *
*     Verbose printing
*
 9122 nPrint(2)=Max(10,nPrint(2))
      nPrint(117)=6
      nPrint(80)=6
      nPrint( 1)=6
      GWInput = Run_Mode.eq.G_Mode
      Go To 998
*                                                                      *
****** ORBA ************************************************************
*                                                                      *
*     Request property output with explicit listing of properties of
*     all orbitals, including all unoccupied (ignoring THRS), and not
*     weighted by occupation numbers. (S.S.Dong, 2018)
*
 913  ifallorb = .True.
      Go To 998
*                                                                      *
****** ZMAT ************************************************************
*                                                                      *
*     Read Basis Sets & Coordinates in Z-Matrix format
*
1920  Continue
      if(isxbas.eq.0) Call Quit_OnUserError()
      Call ZMatrixConverter(LuRd,LuWr,mxAtom,STDINP,lSTDINP,
     &   iglobal,nxbas,xb_label,xb_bas,iErr)
      If (iErr.ne.0) Call Quit_OnUserError()
      GWInput=.True.
      Call StdSewInput(LuRd,ifnr,mdc,iShll,BasisTypes,
     &                 STDINP,lSTDINP,iErr)
      If (iErr.ne.0) Call Quit_OnUserError()
      Go To 998
*                                                                      *
****** XBAS ************************************************************
*                                                                      *
1924  Continue
      call read_xbas(LuRd,iglobal,nxbas,xb_label,xb_bas,ierr)
      GWInput=.True.
      isxbas=1
      if(ierr.eq.1) Call Quit_OnUserError()
      goto 998
*                                                                      *
****** XYZ  ************************************************************
*                                                                      *
1917  Continue
      if(isxbas.eq.0) Call Quit_OnUserError()
      Call XMatrixConverter(LuRd,LuWr,mxAtom,STDINP,lSTDINP,
     &   iglobal,nxbas,xb_label,xb_bas,iErr)
      If (iErr.ne.0) Call Quit_OnUserError()
      GWInput=.True.
      Call StdSewInput(LuRd,ifnr,mdc,iShll,BasisTypes,
     &                 STDINP,lSTDINP,iErr)
      If (iErr.ne.0) Call Quit_OnUserError()
      XYZdirect=.true.
*      If (SymmSet) Then
*         Call WarningMessage(2,
*     &                 'SYMMETRY keyword is not compatible with XYZ')
*         Call Quit_OnUserError()
*      End If
      If (GroupSet) Then
         Call WarningMessage(2,
     &                 'GROUP keyword is not compatible with XYZ')
         Call Quit_OnUserError()
      End If
      Go To 998

*                                                                      *
****** COOR ************************************************************
*                                                                      *
*     Read Basis Sets & Coordinates in xyz format
*
6000  Continue
      If (SymmSet) Then
         Call WarningMessage(2,
     &                 'SYMMETRY keyword is not compatible with COORD')
         Call Quit_OnUserError()
      End If
      If (iOpt_XYZ.eq.0) Then
         Call WarningMessage(2,
     &            'COORD keyword is not compatible with non-XYZ format')
         Call Quit_OnUserError()
      End If
c      If (CoordSet) Then
c         Call WarningMessage(2,'There is more than one COORD keyword!')
c*        Should this be an error and stop? Only if no HYPER or GEO?
c      End If
      if(isxbas.eq.1) Call Quit_OnUserError()
      iCoord=iCoord+1

      CoordSet=.true.
      GWInput=.True.
#ifdef _HAVE_EXTRA_
      Call XYZread(LuRd,ForceZMAT,nCoord, iErr)
      If (iErr.ne.0) Call Quit_OnUserError()
      Call XYZcollect(iCoord,nCoord,OrigTrans,OrigRot,nFragment)
#else
      Call Read_XYZ(LuRd,OrigRot,OrigTrans)
#endif
      Go To 998
*                                                                      *
****** GROUP ***********************************************************
*                                                                      *
*     Read information for a group
*
6010  Continue
      If (SymmSet) Then
         Call WarningMessage(2,
     &                 'SYMMETRY keyword is not compatible with GROUP')
         Call Quit_OnUserError()
      End If
      If (.not.CoordSet) Then
         Call WarningMessage(2,'COORD keyword is not found')
         Call Quit_OnUserError()
      End If
      KeepGroup=Get_Ln(LuRd)
c Simplistic validity check for value
      temp1=KeepGroup
      Call UpCase(temp1)
      If (temp1(1:4).eq.'FULL') Goto 6015
      If (temp1(1:1).eq.'E') Goto 6015
      If (temp1(1:2).eq.'C1') Goto 6015
      If (temp1(1:5).eq.'NOSYM') Goto 6015
      Do i=1,StrnLn(temp1)
        If (temp1(i:i).ne.'X'.and.
     &      temp1(i:i).ne.'Y'.and.
     &      temp1(i:i).ne.'Z'.and.
     &      temp1(i:i).ne.' ') Then
          Call WarningMessage(2,
     &    'Illegal symmetry group or operator: '//temp1(:StrnLn(temp1)))
          Call Quit_OnUserError()
        End If
      End Do
6015  Continue
      GroupSet=.true.
      GWInput=.True.
      DoneCoord=.True.
      goto 998
*                                                                      *
****** BSSE ************************************************************
*                                                                      *
*     Read information for BSSE
*
6020  Continue
      if(.not.CoordSet) Then
         Call WarningMessage(2,'COORD keyword is not found')
         Call Quit_OnUserError()
      End If
      KWord=Get_Ln(LuRd)
      read(Kword,*,end=6666,err=6666) iBSSE
      GWInput=.True.
      goto 998
*                                                                      *
****** MOVE ************************************************************
*                                                                      *
*     allow to MOVE coordinates
*
6040  Continue
      if(.not.CoordSet) Then
         Call WarningMessage(2,'COORD keyword is not found')
         Call Quit_OnUserError()
      End If
      isHold=0
      GWInput=.True.
      goto 998
*                                                                      *
****** NOMOVE **********************************************************
*                                                                      *
*     Do NOT allow to MOVE coordinates
*
6050  Continue
      if(.not.CoordSet) Then
         Call WarningMessage(2,'COORD keyword is not found')
         Call Quit_OnUserError()
      End If
      isHold=1
      GWInput=.True.
      goto 998
*                                                                      *
****** SYMT ************************************************************
*                                                                      *
*     Threshold for findsym
*
6060  Continue
      if(.not.CoordSet) Then
         Call WarningMessage(2,'COORD keyword is not found')
         Call Quit_OnUserError()
      End If
      KWord=Get_Ln(LuRd)
      read(Kword,*,end=6666, err=6666) SymThr
      GWInput=.True.
      goto 998
*                                                                      *
****** NODE ************************************************************
*                                                                      *
*     Set global delete parameters to disable orbital deleting
*     Keywords: NODElete at 7070
*               SDELete  at 7071
*               TDELete  at 7072
*
7070  continue
      Call Put_dScalar('S delete thr',0.0d0)
      Call Put_dScalar('T delete thr',1.0d15)
      goto 998
7071  continue
      KWord = Get_Ln(LuRd)
      Call Get_F1(1,sDel)
      Call Put_dScalar('S delete thr',sDel)
      goto 998
7072  continue
      KWord = Get_Ln(LuRd)
      Call Get_F1(1,tDel)
      Call Put_dScalar('T delete thr',tDel)
      goto 998
7700  continue
      KWord = Get_Ln(LuRd)
      ExtBasDir=KWord
      GWInput=.True.
      goto 998
*                                                                      *
****** BASI ************************************************************
*                                                                      *
*     Read information for a basis set
*
 920  continue
*
*     Check if the format is old or new style. Damn the person who used
*     the same keword for two different styles of input and making the
*     input require a specific order of the keyword. Comrade 55?
*
      Basis_Test=.True.
*
      GWInput=.True.
      Key = Get_Ln(LuRd)
      BSLbl = Key(1:80)
      If (BasisSet) Then
         KeepBasis=KeepBasis(1:index(KeepBasis,' '))//','//BSLbl
      Else
         KeepBasis=BSLbl
         BasisSet=.True.
      Endif
      temp1=KeepBasis
      Call UpCase(temp1)
*     If (INDEX(temp1,'INLINE').ne.0) then
*        Write(LuWr,*)
*    &        'XYZ input and Inline basis set are not compatible'
*        Write(LuWr,*)
*    &        'Consult the manual how to change inline basis set'
*        Write(LuWr,*) ' into basis set library'
*        Call Quit_OnUserError()
*     End If
      iOpt_XYZ=1
      Goto 998
*
 9201 Continue
      iOpt_XYZ=0
      GWInput=.True.
      nCnttp = nCnttp + 1
      If (Run_Mode.eq.S_Mode) Then
         Call WarningMessage(2,'Seward input error!')
         Write (LuWr,*) 'The command : "',Previous_Command,
     &               '" is not allowed'
     &              //' in the Seward input when the Gateway is used!'
         Write (LuWr,*)
         Call Quit_OnUserError()
      End If
      If (nCnttp.gt.Mxdbsc) Then
         Call WarningMessage(2,' Increase Mxdbsc')
         Call Quit_OnUserError()
      End If
      NoZMAT=.True.
*
*     Read the basis set label
*
      Key = Get_Ln(LuRd)
      BSLbl = Key(1:80)
*
*     If dummy atom point at the ANO-RCC set where the specification is.
*
      Call UpCase(BSLbl)
      iDummy_basis=0
      Call ICopy(4,BasisTypes,1,BasisTypes_save,1)
      If (BSLbl(1:2).eq.'X.'.and.Index(BSLbl,'INLINE').eq.0.and.
     &    Index(BSLbl,'RYDBERG').eq.0) Then
         BSLbl_Dummy=BSLbl
         BSLbl='X.ANO-RCC.'
         Do i=11,80
           BSLbl(i:i)='.'
         End do
         iDummy_basis=1
      End If
*     Call UpCase(BSLbl)
      LenBSL=Len(BSLbl)
      Last=iCLast(BSLbl,LenBSL)
      GWInput=.True.
      Indx=Index(BSLbl,'/')
      If (Indx.eq.0) Then
         Fname=BasLib
         Indx = Last+1
         dbsc(nCnttp)%Bsl=BSLbl
      Else
         Fname= BSLbl(Indx+2:Last)
         If (Fname.eq.' ') Then
            Call WarningMessage(2,
     &                     ' No basis set library specified for'
     &                   //'BSLbl='//BSLbl(1:Indx-1)//' Fname='//Fname)
            Call Quit_OnUserError()
         End If
 1919    If (Fname(1:1).eq.' ') Then
            Fname(1:79)=Fname(2:80)
            Fname(80:80) = ' '
            Go To 1919
         End If
         dbsc(nCnttp)%Bsl=BSLbl(1:Indx-1)
      End If
*
      n=INDEX(dbsc(nCnttp)%Bsl,' ')
      If (n.eq.0) n=81
      Do i=n,80
        dbsc(nCnttp)%Bsl(i:i)='.'
      End Do
*
      If ((Show.and.nPrint(2).ge.6) .or.
     &    Write_BasLib) Then
         Write (LuWr,*)
         Write (LuWr,*)
         Write(LuWr,'(1X,A,I5,A,A)')
     &           'Basis Set ',nCnttp,' Label: ', BSLbl(1:Indx-1)
         Write(LuWr,'(1X,A,A)') 'Basis set is read from library:',
     *         Fname(1:index(Fname,' '))
      End if
*
      jShll = iShll
      dbsc(nCnttp)%Bsl_old=dbsc(nCnttp)%Bsl
      dbsc(nCnttp)%mdci=mdc
      Call GetBS(Fname,dbsc(nCnttp)%Bsl,iShll,Ref,UnNorm,LuRd,
     &           BasisTypes,STDINP,lSTDINP,.False.,Expert,ExtBasDir)
*
      Do_FckInt = Do_FckInt .and. dbsc(nCnttp)%FOp .and.
     &            dbsc(nCnttp)%AtmNr.le.96
#ifdef _DEMO_
      Do_GuessOrb = .False.
#else
      Do_GuessOrb = Do_GuessOrb .and. dbsc(nCnttp)%AtmNr.le.96
#endif
*
      If (iDummy_Basis.eq.1) Call ICopy(4,BasisTypes_Save,1,
     &                                    BasisTypes,1)
      If (itype.eq.0) Then
         If (BasisTypes(3).eq.1 .or. BasisTypes(3).eq.2 .or.
     &       BasisTypes(3).eq.14)
     &       iType=BasisTypes(3)
      Else
         If (BasisTypes(3).eq.1 .or. BasisTypes(3).eq.2 .or.
     &       BasisTypes(3).eq.14) Then
            If (BasisTypes(3).ne.iType) Then
               imix=1
               BasisTypes(3)=-1
            End If
            iType=BasisTypes(3)
         End If
      End If
      If (itype.eq.1) ifnr=1
      If (itype.eq.2 .or. itype.eq.14) ifnr=0
*
      If (ign.eq.0) Then
         ign=BasisTypes(4)
      Else If (Abs(BasisTypes(4)).ne.Abs(ign)) Then
         If (nmwarn) Then
            Call WarningMessage(1,
     &        'SEWARD found basis sets of mixed nuclear charge model. '
     &      //'The most advanced one will be used.')
         End If
         nmwarn=.False.
         ign=Max(ign,BasisTypes(4))
         BasisTypes(4)=ign
      End If
*
      If (Show.and.nPrint(2).ge.6 .and.
     &   Ref(1).ne.'' .and. Ref(2).ne.'') Then
         Write (LuWr,'(1x,a)')  'Basis Set Reference(s):'
         If (Ref(1).ne.'') Write (LuWr,'(5x,a)') Ref(1)
         If (Ref(2).ne.'') Write (LuWr,'(5x,a)') Ref(2)
         Write (LuWr,*)
         Write (LuWr,*)
      End If
      dbsc(nCnttp)%ECP=(dbsc(nCnttp)%nPP
     &                 +dbsc(nCnttp)%nPrj
     &                 +dbsc(nCnttp)%nSRO
     &                 +dbsc(nCnttp)%nSOC
     &                 +dbsc(nCnttp)%nM1
     &                 +dbsc(nCnttp)%nM2) .NE. 0
*
      lAng=Max(dbsc(nCnttp)%nVal,
     &         dbsc(nCnttp)%nSRO,
     &         dbsc(nCnttp)%nPrj)-1
      S%iAngMx=Max(S%iAngMx,lAng)
*     No transformation needed for s and p shells
      Shells(jShll+1)%Transf=.False.
      Shells(jShll+1)%Prjct =.False.
      Shells(jShll+2)%Transf=.False.
      Shells(jShll+2)%Prjct =.False.
      dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal
     &                     + dbsc(nCnttp)%nPrj
     &                     + dbsc(nCnttp)%nSRO
     &                     + dbsc(nCnttp)%nSOC
     &                     + dbsc(nCnttp)%nPP
      nCnt = 0
      If (dbsc(nCnttp)%Aux) Then
         Do iSh = jShll+1, iShll
            Shells(iSh)%Aux=.True.
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Set Cartesian functions if specified by the basis type
*     (6-31G family).
*
      If (BasisTypes(1).eq.9) Then
         Do iSh = jShll+3, iShll
            Shells(iSh)%Transf=.False.
            Shells(iSh)%Prjct =.False.
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Automatic onset of muonic charge if the basis type is muonic.
*     This will also automatically activate finite nuclear mass
*     correction.
*
      KWord=BSLbl(1:Indx-1)
      Call UpCase(KWord)
      If (INDEX(KWord,'MUONIC').ne.0) Then
         dbsc(nCnttp)%fMass=
     &    CONST_MUON_MASS_IN_SI_ / CONST_ELECTRON_MASS_IN_SI_
         FNMC=.True.
         tDel=1.0D50
         Call Put_dScalar('T delete thr',tDel)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Update BasisTypes
*
      Do i=1,4
         If (BasisTypes_save(i).eq.0) Cycle
         If (BasisTypes(i).ne.BasisTypes_save(i)) BasisTypes(i)=-1
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*
 777  KWord = Get_Ln(LuRd)
      Call UpCase(KWord)
      Call LeftAd(KWord)
      If (KWord(1:4).eq.'PSEU') Then
         dbsc(nCnttp)%pChrg=.True.
         dbsc(nCnttp)%Fixed=.True.
         Go To 777
      End If
      If (KWord(1:4).eq.'ACDT') Then
         KWord = Get_Ln(LuRd)
         Call Get_F1(1,dbsc(nCnttp)%aCD_Thr)
         Go To 777
      End If
      If (KWord(1:4).eq.'MUON') Then
         dbsc(nCnttp)%fMass=
     &    CONST_MUON_MASS_IN_SI_ / CONST_ELECTRON_MASS_IN_SI_
         Go To 777
      End If
      If (KWord(1:4).eq.'NUCL') Then
         KWord = Get_Ln(LuRd)
         Call Get_F1(1,dbsc(nCnttp)%ExpNuc)
         Go To 777
      End If
      If (KWord(1:4).eq.'FIXE') Then
         dbsc(nCnttp)%Fixed=.True.
         Go To 777
      End If
      If (KWord(1:4).eq.'SPHE') Then
         If (Index(KWord,'ALL').ne.0) Then
            Do iSh = jShll+3, iShll
               Shells(iSh)%Transf=.True.
               Shells(iSh)%Prjct =.True.
            End Do
            Go To 777
         End If
         ist = index(KWord,' ')
         iAng = 2
         Do iSh = jShll+3, iShll
            If (Index(KWord(ist:80),AngTyp(iAng)).ne.0) Then
               Shells(iSh)%Transf = .True.
               Shells(iSh)%Prjct  = .True.
            End If
            iAng = iAng + 1
         End Do
         Go To 777
      End If
      If (KWord(1:4).eq.'CART') Then
         If (Index(KWord,'ALL').ne.0) Then
            Do iSh = jShll+1, iShll
               Shells(iSh)%Transf=.False.
               Shells(iSh)%Prjct =.False.
            End Do
            Go To 777
         End If
         ist = index(KWord,' ')
         iAng = 0
         Do iSh = jShll+1, iShll
            If (Index(KWord(ist:80),AngTyp(iAng)).ne.0) Then
               Shells(iSh)%Transf = .False.
               Shells(iSh)%Prjct  = .False.
            End If
            iAng = iAng + 1
         End Do
         Go To 777
      End If
      If (KWord(1:4).eq.'CONT') Then
         If (Index(KWord,'ALL').ne.0) Then
            Do iSh = jShll+1, iShll
               Shells(iSh)%Prjct  = .False.
            End Do
            Go To 777
         End If
         ist = index(KWord,' ')
         iAng = 0
         Do iSh = jShll+1, iShll
            If (Index(KWord(ist:80),AngTyp(iAng)).ne.0)
     &          Shells(iSh)%Prjct  = .False.
            iAng = iAng + 1
         End Do
         Go To 777
      End If
      If (KWord(1:4).eq.'CHAR') Then
         KWord = Get_Ln(LuRd)
         Call UpCase(KWord)
         Call Get_F1(1,dbsc(nCnttp)%Charge)
         ist = index(KWord,' ')
         If (dbsc(nCnttp)%IsMM.ne.0) Then
            Call WarningMessage(1,
     &         ' Found a charge associated with a MM atom. Ignore it')
            dbsc(nCnttp)%Charge = Zero
         End If
         Go To 777
      End If
      If (KWord(1:4).eq.'FRAG') Then
         dbsc(nCnttp)%pChrg=.True.
         dbsc(nCnttp)%Fixed=.True.
         lFAIEMP=.True.
         Go To 777
      End If
      If (KWord(1:4).eq.'END ') Then
         If (nCnt.eq.0) Then
            Call WarningMessage(2,' Input error, no center specified!')
            Call Quit_OnUserError()
         End If
         dbsc(nCnttp)%nCntr = nCnt
         mdc = mdc + nCnt
!        Now allocate the array for the coordinates and copy them over.
!        Call Allocate(dbsc(nCnttp)%Coor(1:3,1:nCnt)
         Call mma_Allocate(dbsc(nCnttp)%Coor_Hidden,3,nCnt,
     &                     Label='dbsc:C')
         dbsc(nCnttp)%Coor => dbsc(nCnttp)%Coor_Hidden(:,:)
         Call DCopy_(3*nCnt,Buffer,1,dbsc(nCnttp)%Coor,1)
!
         Go To 998
      End If
*
*     Read Coordinates
*
      nCnt = nCnt + 1
      n_dc=max(mdc+nCnt,n_dc)
      If (mdc+nCnt.gt.MxAtom) Then
         Call WarningMessage(2,' RdCtl: Increase MxAtom')
         Write (LuWr,*) '        MxAtom=',MxAtom
         Call Quit_OnUserError()
      End If
      iend=Index(KWord,' ')
      If (iEnd.gt.LENIN+1) Then
         Write (6,*) 'Warning: the label ', KWord(1:iEnd),
     &               ' will be truncated to ',LENIN,' characters!'
      End If
      dc(mdc+nCnt)%LblCnt = KWord(1:Min(LENIN,iend-1))
      dbas=dc(mdc+nCnt)%LblCnt(1:LENIN)
      Call Upcase(dbas)
      If (dbas.eq.'DBAS') Then
         RMat_On=.True.
      End If
      If (mdc+nCnt.gt.1) then
        Call Chk_LblCnt(dc(mdc+nCnt)%LblCnt,mdc+nCnt-1)
      endif
      iOff=1+(nCnt-1)*3
      Call Get_F(2,Buffer(iOff),3)
      If (Index(KWord,'ANGSTROM').ne.0) Then
         Do i = 0, 2
            Buffer(iOff+i) = Buffer(iOff+i)/angstr
         End Do
      End If
*
      If(Cell_l) Then
      nCnt0 = nCnt
      iOff0=iOff
      lthCell = lthCell + 1
      AdCell(lthCell) = mdc+nCnt0  ! the sequence atom No
      ii = 0
      Do n1=-ispread(1),ispread(1)
         Do n2=-ispread(2),ispread(2)
            Do n3=-ispread(3),ispread(3)
               If((n1.Eq.0).And.(n2.Eq.0).And.(n3.Eq.0)) GoTo 110

                  ii = ii + 1

                  If(ii.GE.10000) Then
                     Call WarningMessage(2,' Too many atoms in Seward')
                     Call Quit_OnUserError()
                  Else
                     If(ii.LT.1000) Then
                        CHAR4 = '_'//str(ii)
                     Else
                        CHAR4 = str(ii)
                     End If
                  End If

                  nCnt = nCnt + 1

                  n_dc=max(mdc+nCnt,n_dc)
                  If (mdc+nCnt.gt.MxAtom) Then
                     Call WarningMessage(2,' RdCtl: Increase MxAtom')
                     Write (LuWr,*) '        MxAtom=',MxAtom
                     Call Quit_OnUserError()
                  End If

                  iend=Index(KWord,' ')
                  If (iEnd.gt.5) Then
                     Write (6,*) 'Warning: the label ', KWord(1:iEnd),
     &               ' will be truncated to ',LENIN,' characters!'
                  End If
                  dc(mdc+nCnt)%LblCnt = KWord(1:Min(LENIN,iend-1))//
     &              CHAR4

                  Call Chk_LblCnt(dc(mdc+nCnt)%LblCnt,mdc+nCnt-1)

                  iOff=1+(nCnt-1)*3

*                 Copy old coordinate  first
                  CALL DCOPY_(3,Buffer(iOff0),1,Buffer(iOff),1)
                  CALL DAXPY_(3,DBLE(n1),VCell(1,1),1,Buffer(iOff),1)
                  CALL DAXPY_(3,DBLE(n2),VCell(1,2),1,Buffer(iOff),1)
                  CALL DAXPY_(3,DBLE(n3),VCell(1,3),1,Buffer(iOff),1)
*
  110          Continue
*
            End Do
         End Do
      End Do
      End If
      Go To 777
*                                                                      *
****** PRIN ************************************************************
*                                                                      *
*     Print level
*
 930  KWord = Get_Ln(LuRd)
      GWInput = Run_Mode.eq.G_Mode
      Call Get_I1(1,n)
      Do i = 1, n
         KWord = Get_Ln(LuRd)
         Call Get_I1(1,jRout)
         Call Get_I1(2,iPrint)
         nPrint(jRout)=iPrint
      End Do
      Go To 998
*                                                                      *
****** OPTO ************************************************************
*                                                                      *
*     Reduce the output for optimizations
*
 940  lOPTO = .True.
      Go To 998
*                                                                      *
****** THRE ************************************************************
*                                                                      *
*     Threshold for writing integrals to disk
*
 941  KWord = Get_Ln(LuRd)
      Call Get_F1(1,ThrInt)
      ThrInt = Abs(ThrInt)
      ThrInt_UsrDef = .True.
      Go To 998
*                                                                      *
****** CUTO ************************************************************
*                                                                      *
*     Cutoff for computing primitive integrals [a0|c0]
*
 942  KWord = Get_Ln(LuRd)
      Call Get_F1(1,CutInt)
      CutInt = Abs(CutInt)
      CutInt_UsrDef = .True.
      Go To 998
*                                                                      *
****** RTRN ************************************************************
*                                                                      *
*     Defining max bond distance for bonds, angles and dihedrals
*     Define max number of atoms to list for
*
 950  KWord = Get_Ln(LuRd)
      Call Upcase(KWord)
      Call Get_I1(1,S%Max_Center)
      Call Get_F1(2,rtrnc)
      If (Index(KWord,'ANGSTROM').ne.0)
     &    Rtrnc = Rtrnc/angstr
      GWInput=.True.
      Go To 998
*                                                                      *
****** DIRE ************************************************************
*                                                                      *
*     Force direct calculations & disable two-electron integrals
*
 9770 DirInt = .True.
      Onenly = .True.
      iChk_DC=1
      If ( (iChk_RI+iChk_CH) .gt. 0) Then
         Call WarningMessage(2,
     &           'Direct is incompatible with RI and Cholesky keywords')
         Call Quit_OnUserError()
      End If
      Do_RI=.False.
      Go To 998
*                                                                      *
****** CSPF ************************************************************
*                                                                      *
*     Turn on the use of Condon-Shortley phase factors
*
 9110 CSPF=.True.
      GWInput = Run_Mode.eq.G_Mode
      Go To 998
*                                                                      *
****** EXPE ************************************************************
*                                                                      *
*     Expert mode
*
 9771 Expert = .True.
      GWInput = Run_Mode.eq.G_Mode
      Call WarningMessage(1,
     &   ' EXPERT option is ON!')
      Go To 998
*                                                                      *
****** MOLC or DCRN ****************************************************
*                                                                      *
*     Weight for DCR summation (this is the default for conventional
*     calculations)
*
 957  Continue
 958  MolWgh=0
      MolWgh_UsrDef=.true.
      Go To 998
*                                                                      *
****** MOLP ************************************************************
*                                                                      *
*     Weight for DCR summation modified to MOLPRO format
*
 959  MolWgh=2
      MolWgh_UsrDef=.true.
      Go To 998
*                                                                      *
****** MOLE ************************************************************
*                                                                      *
*     Weight for DCR summation modified to MOLECULE format
*
 960  MolWgh=1
      MolWgh_UsrDef=.true.
      Go To 998
*                                                                      *
****** RELI ************************************************************
*                                                                      *
*     Compute integrals for first order relativistic corrections
*     of the energy, i.e. the mass-velocity integrals and the
*     one-electron Darwin contract term integrals.
*
 962  lRel=.True.
      Go To 998
*                                                                      *
****** JMAX ************************************************************
*                                                                      *
*     Change max j quantum number for the rigid rotor analysis
*
 971  KWord = Get_Ln(LuRd)
      Call Get_I1(1,S%jMax)
      Go To 998
*                                                                      *
****** MULT ************************************************************
*                                                                      *
*     Read order of highest multipole to be computed
*
 972  KWord = Get_Ln(LuRd)
      Call Get_I1(1,S%nMltpl)
      Go To 998
*                                                                      *
****** CENT ************************************************************
*                                                                      *
*     User specified centers of multipole moment operators.
*
 973  KWord = Get_Ln(LuRd)
      Call Get_I1(1,nTemp)
      If (lMltpl) Then
         Call WarningMessage(2,
     &               ' Abend: User specified centers already defined;'
     &             //' Abend: Correct input error!')
         Call Quit_OnUserError()
      Else
         lMltpl = .TRUE.
      End If
*     Allocate temporary memory for user defined centers
      Call mma_allocate(RTmp,3,nTemp,label='RTmp')
      Call mma_allocate(ITmp,nTemp,label='ITmp')
      Do 1502 i = 1, nTemp
         KWord = Get_Ln(LuRd)
         Call Upcase(KWord)
         Call Get_I1(1,iMltpl)
         Call Get_F(2,RTmp(1,i),3)
         If (Index(KWord,'ANGSTROM').ne.0)
     &       Call DScal_(3,One/angstr,RTmp(1,i),1)
         ITmp(i) = iMltpl
 1502 Continue
      Go To 998
*                                                                      *
****** EMPC ************************************************************
*                                                                      *
*     Compute Orbital-Free Embedding integrals from Point Charges
*             specified in XFIEld
*
 974  DoEmPC=.True.
      isHold=1 ! avoid coordinate moving
      GWInput=.True.
      Go To 998
*                                                                      *
****** XFIE ************************************************************
*                                                                      *
*     User specified external field
*
 975  lXF=.True.
      GWInput=.True.
      KWord = Get_Ln(LuRd)
*     Open external file if the line does not start with an integer
*     Note that the "Err" signal cannot be completely trusted, since
*     a slash (i.e., an absolute path) marks end of input and gives
*     no error
      LuRd_saved=LuRd
      ibla = -1
      Read(KWord,*,Err=9751) ibla
      If (ibla.lt.0) Goto 9751
      Goto 9752
9751  LuRd=1
      Call Get_S(1,filename,1)
9753  Call OpnFl(filename(1:(Index(filename,' ')-1)),LuRd,Exist)
      If (.not.Exist) Then
         Call WarningMessage(2,
     &                'Error! File not found: '//
     &        filename(1:(Index(filename,' ')-1)))
         Call Quit_OnUserError()
      End If
      write(LuWr,*)'Reading external field from file: ',
     &        filename(1:(Index(filename,' ')-1))
      KWord = Get_Ln(LuRd)
9752  Call Get_I1(1,nXF)
      Convert=.False.
      Call Upcase(KWord)
      If (Index(KWord,'ANGSTROM').ne.0) Then
          Convert=.True.
          ix=Index(KWord,'ANGSTROM')
          KWord(ix:ix+7)='        '
      End If
*
      KWord(170:180)='-2 -2 -2 -2'
      Call Put_Ln(KWord)
      Call Get_I1(2,nOrd_XF)
      Call Get_I1(3,iXPolType)
      Call Get_I1(4,nXMolnr)
      Call Get_I1(5,nReadEle)
*
*     Set defaults: ch+dip, no polarisabilities,
*                   exclude only its own multipole,
*                   no element read
*
      if (nOrd_XF  .eq.-2) nOrd_XF  =1
      if (iXPolType.eq.-2) iXPolType=0
      if (nXMolnr  .eq.-2) nXMolnr  =0
      if (nReadEle .eq.-2) nReadEle =0

      If ((nOrd_XF.gt.2).or.(nOrd_XF.lt.-1)) Then
         Call WarningMessage(2,'Error! Illegal value of nOrd_XF')
         Write(LuWr,*)'nOrd_XF= ', nOrd_XF
         Call Quit_OnUserError()
      EndIf
      If ((iXPolType.gt.2).or.(iXPolType.lt.0)) Then
         Call WarningMessage(2,'Error! Illegal value of iXPolType')
         Write(LuWr,*)'iXPolType= ', iXPolType
         Call Quit_OnUserError()
      EndIf
      If ((nXMolnr.gt.100).or.(nXMolnr.lt.0)) Then
         Call WarningMessage(2,'Error! Illegal value of nXMolnr')
         Write(LuWr,*)'nXMolnr= ', nXMolnr
         Call Quit_OnUserError()
      EndIf
      If ((nReadEle.gt.1).or.(nReadEle.lt.0)) Then
         Call WarningMessage(2,'Error! Illegal value of nReadEle')
         Write(LuWr,*)'nReadEle= ', nReadEle
         Call Quit_OnUserError()
      EndIf
*
      nData_XF=3
      Do iOrd_XF = 0, nOrd_XF
         nData_XF = nData_XF +  (iOrd_XF+1)*(iOrd_XF+2)/2
      End Do

      if(iXPolType.gt.0) then
         nData_XF=nData_XF+6
         lRF=.true.  ! Polarisabilities treated as Langevin
      endif
*
      If(iXPolType.eq.1) Then
         nDataRead=nData_XF-5   !Read only one pol value
      Else
         nDataRead=nData_XF
      Endif
*
      Call mma_allocate(XF,nData_XF,nXF,Label='XF')
      Call mma_allocate(XMolnr,nXMolnr,nXF,Label='XMolnr')
      Call mma_allocate(XEle,nXF,Label='XEle')
*
      Call Upcase(KWord)
*
      Do iXF = 1, nXF
         XEle(iXF)=0   ! default: no element spec.
*
*        If reading from external file, use free format to allow
*        long lines of input. On the other hand, comments are
*        not allowed in external files.
*
         If (LuRd.ne.LuRd_saved) then
            Call mma_Allocate(iScratch,nXMolnr+nReadEle,
     &                        Label='iScratch')
            Read(LuRd,*)(iScratch(k),k=1,nXMolnr),
     &                  (iScratch(nXMolnr+k),k=1,nReadEle),
     &           (XF(k,iXF),k=1,nDataRead)
            Do i = 1, nXMolnr
               XMolnr(i,iXF)=iScratch(i)
            End Do
            Do i = 1, nReadEle
               XEle(iXF+(i-1))=iScratch(nXMolnr+i)
            End Do
            Call mma_deallocate(iScratch)
         Else
            KWord = Get_Ln(LuRd)
            KWord(170:180)=' 0.0 0.0 0.0'
            Call Put_Ln(KWord)

            Do i = 1, nXMolnr
               Call Get_I1(i,iTemp)
               XMolnr(i,iXF)=iTemp
            End Do
            Do i = 1, nReadEle
               Call Get_I1(nXMolnr+i,iTemp)
               XEle(iXF+(i-1))=iTemp
            End Do
            Call Get_F(nXMolnr+nReadEle+1,XF(1,iXF),nDataRead)
         EndIf
*
         XF(1:3,iXF) = XF(1:3,iXF) * ScaleFactor
         If (Convert) XF(1:3,iXF) = XF(1:3,iXF) / angstr
*
      End Do
*
*---- Close file and reset LuRd if external file was used
      If(LuRd.ne.LuRd_saved) then
         Close(LuRd)
         LuRd = LuRd_saved
      EndIf
      If (isXfield.eq.1) Then
         goto 9755
      End If
      Go To 998
*                                                                      *
****** DOUG ************************************************************
*                                                                      *
*     Full Douglas-Kroll operator
*
 976  continue
      IRELAE=0
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Full Douglas-Kroll (DK1) operator
*
 9001 continue
      IRELAE=1
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Full Douglas-Kroll (DK2) operator
*
 9002 continue
      IRELAE=2
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Douglas-Kroll (DK3) operator
*
 9003 continue
      IRELAE=3
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Full Douglas-Kroll (DK3) operator
*
 9004 continue
      IRELAE=4
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Full RESC operator
*
 978  continue
      IRELAE=11
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Full ZORA
*
 9011 continue
      IRELAE=21
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Full ZORA-FP
*
 9012 continue
      IRELAE=22
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Full IORA
*
 9013 continue
      IRELAE=23
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Exact decoupling X2C method
*
 9014 continue
      IRELAE=101
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Exact decoupling BSS method
*
 9015 continue
      IRELAE=102
      DKroll=.True.
      GWInput=.True.
      go to 998
*
*     Switch on the old DKH routine
*
 8121 continue
      IRFLAG1=1
      GWInput=.True.
      goto 998
*                                                                      *
****** BSSM ************************************************************
*                                                                      *
*     BSS method
 9760 continue
      BSS=.True.
      GWInput=.True.
      go to 976
*                                                                      *
****** AMFI ************************************************************
*                                                                      *
*     AMFI integrals
*
 9761 Continue
      lAMFI=.True.
      GWInput=.True.
      Go To 998
*                                                                      *
****** AMF1 ************************************************************
*                                                                      *
*     AMFI integrals
*
 8761 Continue
      lAMFI=.True.
      iAMFn = 1
      GWInput=.True.
      Go To 998
*                                                                      *
****** AMF2 ************************************************************
*                                                                      *
*     AMFI integrals (including 2nd-order)
*
 8762 Continue
      lAMFI=.True.
      iAMFn = 2
      GWInput=.True.
      Go To 998
*                                                                      *
****** AMF3 ************************************************************
*                                                                      *
*     AMFI integrals (including 3rd-order)
*
 8763 Continue
      lAMFI=.True.
      iAMFn = 3
      GWInput=.True.
      Go To 998
*                                                                      *
****** FAKE ************************************************************
*                                                                      *
*     Fake run : conventional, RI or CD ERIs not computed
*                but some info is set to runfile (e.g. CD thrs)
*                Not the same as ONEOnly !!
*
 9759 Continue
      Fake_ERIs = .true.
      Go To 998
*                                                                      *
****** FINI ************************************************************
*                                                                      *
*     Finite nuclei - Gaussian type
*
 9762 Continue
      Nuclear_Model=Gaussian_Type
      GWInput=.True.
      Go To 998
*                                                                      *
****** MGAU ************************************************************
*                                                                      *
*     Finite nuclei - modified Gaussian type
*
 8009 Continue
      Nuclear_Model=mGaussian_Type
      GWInput=.True.
      Go To 998
*                                                                      *
****** PART ************************************************************
*                                                                      *
*     Show partitioning statistics
*
 9763 Continue
      nPrint(10)=6
      Go To 998
*                                                                      *
****** FPCO ************************************************************
*                                                                      *
*     Force partitioning for contracted functions
*
 9764 Continue
      force_part_c=.True.
      Go To 998
*                                                                      *
****** FPPR ************************************************************
*                                                                      *
*     Force partitioning for primitive functions
*
 9765 Continue
      force_part_p=.True.
      Go To 998
*                                                                      *
****** NOTA ************************************************************
*                                                                      *
*     Do not use tables for the roots and weights of the
*     Rys polynomials.
*
 980  NoTab = .TRUE.
      Go To 998
*                                                                      *
****** WELL ************************************************************
*                                                                      *
*-----Read radius and exponents for spherical well integrals
*     and coefficient
*
 986  KWord = Get_Ln(LuRd)
      GWInput=.True.
      Call Get_I1(1,nWel)
      If (nWel.le.0) Then
*--------Use automatic set up for well integrals
         nWel=3
         Call mma_allocate(Wel_Info,3,nWel,Label='Wel_Info')
         Do iWel = 1, nWel
            Wel_Info(3,iWel)=WellCff(iWel)
            Wel_Info(2,iWel)=WellExp(iWel)
            Wel_Info(1,iWel)=WellRad(iWel)
         End Do
      Else
         Call mma_allocate(Wel_Info,3,nWel,Label='Wel_Info')
         Do iWel = 1, nWel
*---------- Read the Coefficient, Exponent, and Radius
            KWord = Get_Ln(LuRd)
            call Get_F1(1,Wel_Info(3,iWel))
            call Get_F1(2,Wel_Info(2,iWel))
            call Get_F1(3,Wel_Info(1,iWel))
            Call Upcase(KWord)
            If (Index(KWord,'ANGSTROM').ne.0) Then
               Wel_Info(1,iWel)=Wel_Info(1,iWel)/angstr
               Wel_Info(2,iWel)=Wel_Info(2,iWel)*angstr
            End If
         End Do
      End If
      Go To 998
*                                                                      *
****** NODK ************************************************************
*                                                                      *
*     Do not compute Douglas-Kroll integrals.
*
 989  NoDKroll = .TRUE.
      Go To 998
*                                                                      *
****** ONEO ************************************************************
*                                                                      *
*     Do not compute two electron integrals.
*
 990  Onenly = .TRUE.
      Go To 998
*                                                                      *
****** TEST ************************************************************
*                                                                      *
*     Process only the input.
*
 991  Test = .TRUE.
      GWInput=Run_Mode.eq.G_Mode
      Go To 998
*                                                                      *
****** SDIP ************************************************************
*                                                                      *
*     Compute integrals for transition dipole moment
*
 992  Vlct_ = .TRUE.
      GWInput=.True.
      Go To 998
*                                                                      *
****** EPOT ************************************************************
*                                                                      *
*     Compute the electric potential for a number of points.  If nEF is
*     set to 0 this will cause the points to coincide with the unique
*     centers.
*
 9932 nOrdEF=Max(nOrdEF,0)
      GWInput=.True.
      IF (EFgiven) Then
        Call WarningMessage(2,'Only one of EPOT,EFLD,FLDG may be given')
        Call Quit_OnUserError()
      End If
      EFgiven=.True.
      Go To 9931
*                                                                      *
****** EFLD ************************************************************
*                                                                      *
*     Compute the electric potential and electric field for a number of
*     points. If nEF is set to 0 this will cause the points to coincide
*     with the unique centers.
*
 993  nOrdEF=Max(nOrdEF,1)
      GWInput=.True.
      IF (EFgiven) Then
        Call WarningMessage(2,'Only one of EPOT,EFLD,FLDG may be given')
        Call Quit_OnUserError()
      End If
      EFgiven=.True.
      Go To 9931
*                                                                      *
****** FLDG ************************************************************
*                                                                      *
*     Compute the electric potential, electric field, and electric field
*     gradient for a number of points. If nEF is set to 0 this will
*     cause the points to coincide with the Unique centers.
*
 994  nOrdEF=Max(nOrdEF,2)
      GWInput=.True.
      IF (EFgiven) Then
        Call WarningMessage(2,'Only one of EPOT,EFLD,FLDG may be given')
        Call Quit_OnUserError()
      End If
      EFgiven=.True.
      Go To 9931
*
 9931 KWord = Get_Ln(LuRd)
      Call Get_I1(1,nEF)
      If (nEF.lt.0) nEF = 0
      If (nEF.eq.0) Go To 998
      Call mma_allocate(EFt,3,nEF,label='nEF')
      Do iEF = 1, nEF
         KWord = Get_Ln(LuRd)
* Check whether a label is specified instead of a coordinate
         Call Get_S(1,Key,1)
         Call LeftAd(Key)
         Call Upcase(Key)
         jTmp = iChar(Key(1:1))
         If (jTmp .ge. 65 .AND. jTmp .le. 90) Then
            iEnd=Index(Key,' ')-1
            iOff = 0
            iFound_Label = 0
            Do iCnttp = 1, nCnttp
               Do iCnt = iOff+1, iOff+dbsc(iCnttp)%nCntr
                  If (Key(1:iEnd) .Eq. dc(iCnt)%LblCnt(1:iEnd)) Then
                     iFound_Label = 1
                     EFt(1:3,iEF)=dbsc(iCnttp)%Coor(1:3,iCnt-iOff)
                  End If
               End Do
               iOff = iOff + dbsc(iCnttp)%nCntr
            End Do
            If (iFound_Label .Eq. 0) Then
               Call WarningMessage(2,';'
     &                     //' Error in processing the keyword FLDG.;'
     &                     //' The label '''//Key(1:iEnd)
     &                  //''' could not be found among the centers.;'
     &                     //' Remember to specify the atom center'
     &                     //' before specifying the FLDG keyword.')
               Call Quit_OnUserError()
            End If
         Else
            Call Get_F(1,EFt(1,iEF),3)
            Call Upcase(KWord)
            If (Index(KWord,'ANGSTROM').ne.0)
     &         Call DScal_(3,One/angstr,EFt(1,iEF),1)
         End If
      End Do
      Go To 998
*                                                                      *
****** ANGM ************************************************************
*                                                                      *
*     Orbital angular momentum
*
 995  lOAM = .True.
      GWInput=.True.
      KWord = Get_Ln(LuRd)
      Call Upcase(KWord)
      Call Get_F(1,OAMt,3)
      If (Index(KWord,'ANGSTROM').ne.0)
     &    Call DScal_(3,One/angstr,OAMt,1)
      Go To 998
*                                                                      *
****** ANGM derivative restriction *************************************
*                                                                      *
*     Orbital angular momentum restriction
*
 1001 lUPONLY = .True.
      Go To 998
*
 1002 lDOWNONLY = .True.
      Go To 998
*                                                                      *
****** OMQI ************************************************************
*                                                                      *
*     Orbital magnetic quadrupole
*
 999  lOMQ = .True.
      GWInput=.True.
      KWord = Get_Ln(LuRd)
      Call Upcase(KWord)
      Call Get_F(1,OMQt,3)
      If (Index(KWord,'ANGSTROM').ne.0)
     &    Call DScal_(3,One/angstr,OMQt,1)
      Go To 998
*                                                                      *
****** AMPR ************************************************************
*                                                                      *
*     Angular momentum products
*
 9951 lAMP = .True.
      GWInput=.True.
      If (Run_Mode.eq.S_Mode.and.GWInput) Go To 9989
      Call mma_allocate(AMP_Center,3,Label='AMP_Center')
      KWord = Get_Ln(LuRd)
      Call Upcase(KWord)
      Call Get_F(1,AMP_Center,3)
      If (Index(KWord,'ANGSTROM').ne.0)
     &   AMP_Center(:)=(One/angstr)*AMP_Center(:)
      Go To 998
*                                                                      *
****** DSHD ************************************************************
*                                                                      *
*     Compute the diamagnetic shielding for a number of points. If nDMS
*     is set to 0 this will cause the points to coincide with the
*     unique centers.
*
 996  lDMS = .True.
      GWInput=.True.
      KWord = Get_Ln(LuRd)
      Call Get_F(1,Dxyz,3)
      KWord = Get_Ln(LuRd)
      Call Get_I1(1,nDMS)
      If (nDMS.lt.0) nDMS = 0
      If (nDMS.eq.0) Go To 998
      Call mma_allocate(DMSt,3,nDMS,label='DMSt')
      Do iDMS = 1, nDMS
         KWord = Get_Ln(LuRd)
         Call Upcase(KWord)
         Call Get_F(1,DMSt(1,iDMS),3)
         If (Index(KWord,'ANGSTROM').ne.0)
     &        Call DScal_(3,One/angstr,DMSt(1,iDMS),1)
      End Do
      Go To 998
*                                                                      *
****** NOPA ************************************************************
*                                                                      *
*     Set integral packing flag
*     Note      : this flag is only active if iWRopt=0
*     iPack=0   : pack 2el integrals (= Default)
*     iPack=1   : do not pack 2el integrals
*
 9910 iPack=1
      Go To 998
*                                                                      *
****** STDO ************************************************************
*                                                                      *
*     Set integral write option for 2 el integrals
*     iWRopt=0  : 2 el integrals are written in the MOLCAS2 format,
*                 i.e., in canonical order, no labels and packed format
*                 (= Default)
*     iWRopt=1  : 2 el integrals are written in a format identical
*                 to MOLECULE, i.e., values and labels
*
 9930 iWRopt=1
      Go To 998
*                                                                      *
****** PKTH ************************************************************
*                                                                      *
*     Read desired packing accuracy ( Default = 1.0D-14 )
*     Note      : this flag is only active if iWRopt=0
*
 9940 KWord = Get_Ln(LuRd)
      Call Get_F1(1,PkAcc)
      PkAcc = Abs(PkAcc)
      Go To 998
*                                                                      *
****** SKIP ************************************************************
*                                                                      *
*     Read skip parameters,i.e.,
*     if 2el integral symmetry blocks containing a given symmetry
*     will not be needed in subsequent calculations their computation
*     ans storage can be omitted.
*     ( Default = 0,0,0,0,0,0,0,0 )
*     Note      : this flag is only activ if iWRopt=0
*
 9950 KWord = Get_Ln(LuRd)
      lSkip = .True.
      ChSkip = KWord(1:80)
      Go To 998
*                                                                      *
****** EXTR ************************************************************
*                                                                      *
*     Put the program name and the time stamp onto the extract file
*
c23456789012345678901234567890123456789012345678901234567890123456789012
 9960 Write (LuWr,*)'RdCtl: keyword EXTRACT is obsolete and is ignored!'
      Go To 998
*                                                                      *
****** REAC ************************************************************
*                                                                      *
*     Read reaction field input.
*
 9970 Continue
      GWInput=.True.
      If (.Not.RF_read) Then
         Call InpRct(LuRd)
         If (lLangevin.or.PCM) Go To 9971
*
*------- Add a center corresponding to the center of the RF cavity.
*
         RF_read=.True.
 9971    Continue
*
      Else
         Call WarningMessage(2,
     &                  'RdCtl: A second RF-input block discovered!')
         Call Quit_OnUserError()
      End If
      Go To 998
*                                                                      *
***** GRID *************************************************************
*                                                                      *
 9773 Continue
      Call Funi_input(LuRd)
      Go To 998
*                                                                      *
****** CLIG ************************************************************
*                                                                      *
*     Speed of light (in au)
*
 9000 KWord = Get_Ln(LuRd)
      Call Get_F1(1,CLightAU)
      CLightAU = Abs(CLightAU)
      write(LuWr,*)'The speed of light in this calculation =', CLightAU
      Go To 998
*                                                                      *
***** NEMO *************************************************************
*                                                                      *
 800  Continue
      NEMO=.True.
      Go To 998
*                                                                      *
***** RMAT *************************************************************
*                                                                      *
*     RmatR    : radius of the R-matrix sphere (bohr)
*
 880  KWord = Get_Ln(LuRd)
      Call Get_F1(1,RMatR)
      Go To 998
*                                                                      *
***** RMEA *************************************************************
*                                                                      *
*     Epsabs   : absolute precision of numerical radial integration
*
 881  KWord = Get_Ln(LuRd)
      Call Get_F1(1,Epsabs)
      Go To 998
*                                                                      *
***** RMER *************************************************************
*                                                                      *
*     Epsrel   : relative precision of numerical radial integration
*
 882  KWord = Get_Ln(LuRd)
      Call Get_F1(1,Epsrel)
      Go To 998
*                                                                      *
***** RMQC *************************************************************
*                                                                      *
*     qCoul    : effective charge of the target molecule
*
 883  KWord = Get_Ln(LuRd)
      Call Get_F1(1,qCoul)
      Go To 998
*                                                                      *
***** RMDI *************************************************************
*                                                                      *
*     dipol(3) : effective dipole moment of the target molecule
*
 884  KWord = Get_Ln(LuRd)
      Call Get_F(1,dipol,3)
      dipol1=Abs(dipol(1))+Abs(dipol(2))+Abs(dipol(3))
      Go To 998
*                                                                      *
***** RMEQ *************************************************************
*                                                                      *
*     epsq     : minimal value of qCoul and/or dipol1 to be considered
*
 885  KWord = Get_Ln(LuRd)
      Call Get_F1(1,epsq)
      Go To 998
*                                                                      *
***** RMBP *************************************************************
*                                                                      *
*     bParm    : Bloch term parameter
*
 886  KWord = Get_Ln(LuRd)
      Call Get_F1(1,bParm)
      Go To 998
*                                                                      *
***** GIAO *************************************************************
*                                                                      *
*     Enable GIAO integrals.
*
 9020 GIAO=.True.
      Go To 998
*                                                                      *
***** NOCH *************************************************************
*                                                                      *
*     Deactivate Cholesky decomposition.
*
 9089 Continue
      Cholesky=.False.
      CholeskyWasSet=.True.
      Do_RI=.False.
      Go To 998
*                                                                      *
***** CHOL *************************************************************
*                                                                      *
*     Activate Cholesky decomposition with default settings.
*     This section can only be executed once.
*
 9091 Continue
      Do_RI=.False.
      If (.not. CholeskyWasSet) Then
         CholeskyWasSet=.True.
         Cholesky=.True.
         Do_RI=.False.
         DirInt = .True.
         Call Cho_Inp(.True.,-1,6)
         iChk_CH=1
      End If
      If ( (iChk_RI+iChk_DC) .gt. 0) Then
         Call WarningMessage(2,
     &           'Cholesky is incompatible with RI and Direct keywords')
         Call Quit_OnUserError()
      EndIf
      GWInput = .False.
      Go To 998
*                                                                      *
***** THRC *************************************************************
*                                                                      *
*     Set Cholesky decomposition threshold to specified value.
*
 9021 Continue
      KWord=Get_Ln(LuRd)
      Call Get_F1(1,CholeskyThr)
      Go To 998
*                                                                      *
***** 1CCD *************************************************************
*                                                                      *
*     Use one-center Cholesky.
*
 9022 Continue
      do1CCD=.true.
      Do_RI=.False.
      iChk_Ch=1
      If ( (iChk_RI+iChk_DC) .gt. 0) Then
         Call WarningMessage(2,
     &           'Cholesky is incompatible with RI and Direct keywords')
         Call Quit_OnUserError()
      EndIf
      Go To 998
*                                                                      *
***** CHOI *************************************************************
*                                                                      *
*     Activate Cholesky decomposition with user-defined settings.
*     This section can be executed any number of times.
*     User-defined settings will be preferred to defaults also if the
*     keywords appear in "wrong" order,
*
*     ChoInput
*     ...
*     End ChoInput
*     Cholesky
*
 9092 Continue
      Do_RI=.False.
      CholeskyWasSet=.True.
      Cholesky=.True.
      DirInt = .True.
      Call Cho_Inp(.False.,LuRd,6)
      iChk_CH=1
      If ( (iChk_RI+iChk_DC) .gt. 0) Then
         Call WarningMessage(2,
     &           'Cholesky is incompatible with RI and Direct keywords')
         Call Quit_OnUserError()
      EndIf
      Go To 998
*                                                                      *
***** RP-C *************************************************************
*                                                                      *
 9093 lRP=.True.
      KWord = Get_Ln(LuRd)
      jTmp=0
      nRP_prev=-1
      Read(KWord,*,err=9082) nRP
      isnumber=1
      ifile=index(KWord,' ')
      do i=1,ifile
        ii=index(' 0123456789',KWord(i:i))
        if(ii.eq.0) then
           isnumber=0
        endif
      enddo
*
      if(isnumber.eq.0) goto 9082
      nRP=3*nRP
      Call mma_allocate(RP_Centers,3,nRP/3,2,Label='RP_Centers')
*
**    Inline input
*
      Call UpCase(KWord)
      If (Index(KWord,'ANGSTROM').ne.0) Then
         Fact=One/Angstr
      Else
         Fact=One
      End If
*
*
      KWord = Get_Ln(LuRd)
      Call Get_F1(1,E1)
      Call Read_v(LuRd,RP_Centers(1,1,1),1,nRP,1,iErr)
      KWord = Get_Ln(LuRd)
      Call Get_F1(1,E2)
      Call Read_v(LuRd,RP_Centers(1,1,2),1,nRP,1,iErr)
      RP_Centers(:,:,:)=Fact*RP_Centers(:,:,:)
      GWInput = .True.
      Go To 998
*
**    Files
*
 9082 Continue
      RPSet=.true.
      jTmp=jTmp+1
      ifile=index(KWord,' ')
      If(KWord(1:1).eq.'/') then
        call f_inquire(KWord(1:ifile-1),Exist)
        Key=KWord
      Else
        call getenvf('MOLCAS_SUBMIT_DIR',Directory)
        if(Directory(1:1).ne.' ') then
          i=index(Directory,' ')
          Key=Directory(1:i-1)//'/'//KWord(1:ifile-1)
          ifile=i+ifile
          call f_inquire(Key(1:iFile-1),Exist)
        Else
          Exist=.false.
        End If
        If (.not.Exist) Then
          Key=Key(i+1:iFile-1)
          ifile=ifile-i
          call f_inquire(Key(1:iFile-1),Exist)
        End If
      End If
      If (.not.Exist) Then
        Call WarningMessage(2,'File '//
     &                            Key(1:ifile)//' is not found')
        Call Quit_OnUserError()
      End If
      LuIn=8
      LuIn=isFreeUnit(LuIn)
      call molcas_open(LuIn,Key(1:iFile-1))
*
      KWord = Get_Ln(LuIn)
      Read(KWord,*,err=9083) nRP
      If (nRP_prev.ge.0 .and. nRP.ne.nRP_prev) Then
        Call WarningMessage(2,'The numbers of atoms in the two RP'//
     &                        ' structures do not match.')
        Call Quit_OnUserError()
      End IF
      nRP_prev=nRP
      nRP=3*nRP
      If (.NOT.Allocated(RP_Centers))
     &   Call mma_allocate(RP_Centers,3,nRP/3,2,Label='RP_Centers')
      KWord = Get_Ln(LuIn)
      Call UpCase(KWord)
      If (Index(KWord,'BOHR').ne.0) Then
         Fact=One
      Else
         Fact=One/Angstr
      End If
      If (jTmp.eq.1) Then
         LuRP=10
         LuRP=isFreeUnit(LuRP)
         call molcas_open(LuRP,'findsym.RP1')
         Read(KWord,*,err=9083) E1
*
**  write a separate file for findsym
*
         Write(LuRP,*) nRP/3
#ifdef _HAVE_EXTRA_
         Write(LuRP,'(a)')
#else
         Write(LuRP,'(a)') 'bohr'
#endif
         Do i=1,nRP/3
            KWord = Get_Ln(LuIn)
            Read(KWord,*,err=9083) Key,(RP_Centers(j,i,1),j=1,3)
            Write(LuRP,'(A,3F20.12)') Key(1:LENIN),
     &                   (RP_Centers(j,i,1)*Fact,j=1,3)
         End Do
         KWord = Get_Ln(LuRd)
         close(LuIn)
         close(LuRP)
         Go To 9082
      Else
         LuRP=10
         LuRP=isFreeUnit(LuRP)
         call molcas_open(LuRP,'findsym.RP2')
         Write(LuRP,*) nRP/3
#ifdef _HAVE_EXTRA_
         Write(LuRP,'(a)')
#else
         Write(LuRP,'(a)') 'bohr'
#endif
         Read(KWord,*,err=9083) E2
         Do i=1,nRP/3
            KWord = Get_Ln(LuIn)
            Read(KWord,*,err=9083) Key,(RP_Centers(j,i,2),j=1,3)
            Write(LuRP,'(A,3F20.12)') Key(1:LENIN),
     &            (RP_Centers(j,i,2)*Fact,j=1,3)
         End Do
         close(LuRP)
      End If
      RP_Centers(:,:,:)= Fact* RP_Centers(:,:,:)
*
      close(LuIn)
      GWInput = Run_Mode.eq.G_Mode
      Go To 998
*
**    Error
*
 9083 Continue
      Write(6,'(a,a)') 'Error reading from file ',Key(1:iFile-1)
      Write(6,'(a,a)') 'unable to process line: ',KWord
      Call Quit_OnUserError()
*                                                                      *
***** SADD *************************************************************
*                                                                      *
*     Saddle options
 9081 Key = Get_Ln(LuRd)
      Call Get_F1(1,SadStep)
      GWInput = .True.
      Go To 998
*                                                                      *
***** CELL *************************************************************
*                                                                      *
*     VCell(3,3)    : the vectors of the cell
*
 887  Key = Get_Ln(LuRd)
      Call Upcase(Key)
      If (Index(Key,'ANGSTROM').ne.0) KWord = Get_Ln(LuRd)
      Call Get_F(1,VCell(1,1),3)
      KWord = Get_Ln(LuRd)
      Call Get_F(1,VCell(1,2),3)
      KWord = Get_Ln(LuRd)
      Call Get_F(1,VCell(1,3),3)
      If (Index(Key,'ANGSTROM').ne.0) Call DScal_(9,One/angstr,VCell,1)
      Cell_l = .TRUE.
      Call mma_allocate(AdCell,MxAtom)
      Go To 998
*                                                                      *
***** SPAN *************************************************************
*                                                                      *
*     Set span factor in Cholesky decomposition (0 < span < 1).
*     The span decides the smallest diagonal element that can be
*     treated as span*max(Diag). Span=1 thus implies full pivoting.
*
 890  Continue
      KWord = Get_Ln(LuRd)
      Call Get_F1(1,spanCD)
      spanCD=abs(spanCD)
      Go To 998
*                                                                      *
***** SPREAD ***********************************************************
*                                                                      *
*     ispread(3)    : the number of cells to spread in different directions
*
 889  KWord = Get_Ln(LuRd)
      Call Get_I(1,ispread,3)
      Go To 998
*                                                                      *
***** LOW  *************************************************************
*                                                                      *
*     Activate low-accuracy Cholesky decomposition.
*
 9094 Continue
      Do_RI=.False.
      If (.not. CholeskyWasSet) Then
         CholeskyWasSet=.True.
         Cholesky=.True.
         DirInt = .True.
         Call Cho_Inp(.True.,-1,6)
         Call Cho_InpMod('LOW ')
         Thrshld_CD=1.0D-4
      End If
      Go To 998
*                                                                      *
***** MEDI *************************************************************
*                                                                      *
*     Activate medium-accuracy Cholesky decomposition.
*
 9095 Continue
      Do_RI=.False.
      If (.not. CholeskyWasSet) Then
         CholeskyWasSet=.True.
         Cholesky=.True.
         DirInt = .True.
         Call Cho_Inp(.True.,-1,6)
         Call Cho_InpMod('MEDI')
         Thrshld_CD=1.0D-6
      End If
      Go To 998
*                                                                      *
***** HIGH *************************************************************
*                                                                      *
*     Activate high-accuracy Cholesky decomposition.
*
 9096 Continue
      Do_RI=.False.
      If (.not. CholeskyWasSet) Then
         CholeskyWasSet=.True.
         Cholesky=.True.
         DirInt = .True.
         Call Cho_Inp(.True.,-1,6)
         Call Cho_InpMod('HIGH')
         Thrshld_CD=1.0D-8
      End If
      Go To 998
*                                                                      *
***** DIAG *************************************************************
*                                                                      *
 9087 Continue
      DiagCheck=.true.
      Go To 998
*                                                                      *
***** RI   *************************************************************
*                                                                      *
*     Activate RI approach
*
 9097 Continue
      Do_RI=.True.
      GWInput=.True.
      iRI_Type=3
      iChk_RI=1
      If ( (iChk_DC+iChk_CH) .gt. 0) Then
         Call WarningMessage(2,
     &          'RI is incompatible with Direct and Cholesky keywords')
         Call Quit_OnUserError()
      End If
      Go To 998
 9098 Continue
      Do_RI=.True.
      GWInput=.True.
      iRI_Type=1
      iChk_RI=1
      If ( (iChk_DC+iChk_CH) .gt. 0) Then
         Call WarningMessage(2,
     &          'RI is incompatible with Direct and Cholesky keywords')
         Call Quit_OnUserError()
      End If
      Go To 998
 9099 Continue
      Do_RI=.True.
      GWInput=.True.
      iRI_Type=2
      iChk_RI=1
      If ( (iChk_DC+iChk_CH) .gt. 0) Then
         Call WarningMessage(2,
     &          'RI is incompatible with Direct and Cholesky keywords')
         Call Quit_OnUserError()
      End If
      Go To 998
 9080 Continue
      Do_RI=.True.
      GWInput=.True.
      iRI_Type=4
      iChk_RI=1
      If ( (iChk_DC+iChk_CH) .gt. 0) Then
         Call WarningMessage(2,
     &          'RI is incompatible with Direct and Cholesky keywords')
         Call Quit_OnUserError()
      End If
      Go To 998
 9085 Continue
      Do_RI=.True.
      GWInput=.True.
      iRI_Type=5
      iChk_RI=1
      If ( (iChk_DC+iChk_CH) .gt. 0) Then
         Call WarningMessage(2,
     &          'RI is incompatible with Direct and Cholesky keywords')
         Call Quit_OnUserError()
      End If
      Go To 998
*                                                                      *
***** NOGU *************************************************************
*                                                                      *
*     Disable atomatic execution of GuessOrb
*
 9100 Do_GuessOrb=.FALSE.
      Go To 998
*                                                                      *
***** RELA *************************************************************
*                                                                      *
*     DKH option: order and parameterization.
*     xx: order of Hamiltonian
*      y: parameterization
*     zz: order of properties
*
 657  Continue
      kWord = Get_Ln(LuRd)
      If (KWord(1:1).eq.'R' .and.
     &    (KWord(2:2).ge.'0' .and.
     &     KWord(2:2).le.'9') .and.
     &     (KWord(3:3).ge.'0' .and.
     &      KWord(3:3).le.'9') .and.
     &      (KWord(4:4).eq.'O' .or.
     &       KWord(4:4).eq.'E' .or.
     &       KWord(4:4).eq.'S' .or.
     &       KWord(4:4).eq.'M' .or.
     &       KWord(4:4).eq.'C') ) Then
      Else
         Call WarningMessage(2,'Error in RELA keyword')
         Call Quit_OnUserError()
      End If
      DKroll=.True.
*
*     DKH order in the Hamiltonian
*
      read( KWord(2:3), * ) idk_ord
      IRELAE = 1000 + idk_ord * 10
*
*     Method of parametrization
*
      If (kWord(4:4).eq.'O') IRELAE=IRELAE+1
      If (kWord(4:4).eq.'E') IRELAE=IRELAE+2
      If (kWord(4:4).eq.'S') IRELAE=IRELAE+3
      If (kWord(4:4).eq.'M') IRELAE=IRELAE+4
      If (kWord(4:4).eq.'C') IRELAE=IRELAE+5
*
*     DKH order in the property integrals
*
      If ( KWord(5:5).ge.'0' .and.
     &     KWord(5:5).le.'9' .and.
     &     KWord(6:6).ge.'0' .and.
     &     KWord(6:6).le.'9' ) then
        read( KWord(5:6), * ) iprop_ord
          IRELAE = IRELAE + iprop_ord * 10000
      Else
          IRELAE = IRELAE + idk_ord * 10000
      End If
*
      Go To 998
*                                                                      *
***** LDKH *************************************************************
*                                                                      *
*     Local Douglas-Kroll-Hess/X2C/BSS
*
 658  LDKroll=.True.
*     GWInput=.True.
      nCtrLD=0
      radiLD=5.5d0
*
      KWord = Get_Ln(LuRd)
      Call Upcase(KWord)
      If (KWord(1:3).eq.'DLU') Go To 998
      If (KWord(1:3).eq.'DLH') Then
        radiLD=0.0d0
        Go To 998
      End If
      read(KWord,*,end=6582, err=6582) nCtrLD, radiLD
      If (nCtrLD.gt.10) Then
         Call WarningMessage(2,
     &           'The number of centers for LDKH is limited to 10')
         call Quit_OnUserError()
      End If
      If (Index(KWord,'ANGSTROM').ne.0) Then
          radiLD = radiLD/angstr
      End If
*
      KWord = Get_Ln(LuRd)
      Call Upcase(KWord)
      read(KWord,*,end=6666, err=6581) (iCtrLD(i),i=1,nCtrLD)
      Go To 998
 6581 read(Kword,*,end=6666, err=6666) (CtrLDK(i),i=1,nCtrLD)
      Call Get_nAtoms_all(nAtom)
      k=0
      Do i=1,nAtom
        Do j=1,nCtrLD
          if (CtrLDK(j).eq.dc(i)%LblCnt(1:LENIN)) Then
             iCtrLD(j)=i
             k=k+1
          End If
        End Do
      End Do
      If (k.ne.nCtrLD) Then
         Call WarningMessage(2,'Error in LDKH Centers definitions')
         Call Quit_OnUserError()
      End If
      Go To 998
*
**    Automatic choice: all heavy elements (from K 19)
*
 6582 Continue
CDP      If (nCtrLD.eq.0) radiLD=0.0d0
      Key=KWord
      Go To 9989
*                                                                      *
***** FOOC *************************************************************
*                                                                      *
*     Force the use of the out-of-core RI algorithm.
*
 8000 Force_Out_of_Core=.True.
      Go To 998
*                                                                      *
***** CDTH *************************************************************
*                                                                      *
*     Threshold for CD to generate RICD auxiliary basis sets
*
 8001 Key = Get_Ln(LuRd)
      Call Get_F1(1,Thrshld_CD)
      GWInput=.True.
      Go To 998
*                                                                      *
***** SHAC *************************************************************
*                                                                      *
*     Skip high angular combinations when constructing RICD aux basis.
*
 8002 Skip_High_AC=.True.
      GWInput=.True.
      Go To 998
*                                                                      *
***** KHAC *************************************************************
*                                                                      *
*     Keep high angular combinations when constructing RICD aux basis.
*
 8003 Skip_High_AC=.False.
      GWInput=.True.
      Go To 998
*                                                                      *
***** ACD  *************************************************************
*                                                                      *
*     Generate a aCD basis.
*
 8004 Do_acCD_Basis=.False.
      GWInput=.True.
      Go To 998
*                                                                      *
***** ACCD *************************************************************
*                                                                      *
*     Generate a acCD basis.
*
 8005 Do_acCD_Basis=.True.
      GWInput=.True.
      Go To 998
*                                                                      *
***** NACC *************************************************************
*                                                                      *
*     Generate a nacCD basis.
*
 8030 Do_acCD_Basis=.False.
      Do_nacCD_Basis=.True.
      GWInput=.True.
      Go To 998
*                                                                      *
***** DOFM *************************************************************
*                                                                      *
*     DoFMM: activate FMM option
*
 8006 DoFMM = .True.
      Go To 998
*                                                                      *
***** NOAM *************************************************************
*                                                                      *
*     No computation of AMFI integrals
*
 8007 NoAMFI=.True.
      GWInput=.True.
      Go To 998
*                                                                      *
***** RPQM *************************************************************
*                                                                      *
*     Set RPQMin for FMM option
*
 8008 Key = Get_Ln(LuRd)
      Call Get_F1(1,RPQMin)
      Go To 998
*                                                                      *
***** CONS *************************************************************
*                                                                      *
*     Have the Gateway read the constraints for Slapaf
*
 8010 Continue
      GWInput=.True.
      Lu_UDC=97
      Lu_UDC = IsFreeUnit(Lu_UDC)
      Call Molcas_Open(Lu_UDC,'UDC.Gateway')
 8011 Continue
         Key=Get_Ln(LuRd)
         Call UpCase(Key)
         Write (Lu_UDC,'(A)') Trim(Key)
         If (Key(1:4).ne.'END ') Go To 8011
*     This rather obscure feature seems to be needed to to make Intel
*     compilers behave like the others when detecting EOF
      End File(Lu_UDC)
      Close(Lu_UDC)
      Go To 998
*                                                                      *
***** NGEX *************************************************************
*                                                                      *
*     Have the Gateway read the constraints for Numerical_gradient
*
  501 Continue
      GWInput=.True.
      Lu_UDC=97
      Lu_UDC = IsFreeUnit(Lu_UDC)
      Call Molcas_Open(Lu_UDC,'UDC.NG')
  502 Continue
         Key=Get_Ln(LuRd)
         Call UpCase(Key)
         If (AdjustL(Key).eq.'INVERT') Then
            Invert=.True.
            Go To 502
         End If
         Write (Lu_UDC,'(A)') Trim(Key)
         If (Key(1:4).ne.'END ') Go To 502
*     This rather obscure feature seems to be needed to to make Intel
*     compilers behave like the others when detecting EOF
      End File(Lu_UDC)
      Close(Lu_UDC)
      Go To 998
*                                                                      *
***** LOCA or LDF1 or LDF **********************************************
*                                                                      *
*     Activate Local Density Fitting.
*
   35 Continue
         LocalDF=.True.
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** LDF2 *************************************************************
*                                                                      *
*     Activate Local Density Fitting with 2-center functions included
*     when needed to achieve target accuracy.
*
   36 Continue
         LocalDF=.True.
         Call LDF_SetLDF2(.True.)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** TARG or THRL *****************************************************
*                                                                      *
*     Set target accuracy for Local Density Fitting.
*     This implies inclusion of 2-center functions (the only way we can
*     affect accuracy).
*
   37 Continue
         Key=Get_Ln(LuRd)
         Call Get_F1(1,Target_Accuracy)
         Call LDF_SetThrs(Target_Accuracy)
         LocalDF=.True.
         Call LDF_SetLDF2(.True.)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** APTH *************************************************************
*                                                                      *
*     Set screening threshold for LDF - i.e. threshold for defining
*     significant atom pairs.
*
   38 Continue
         Key=Get_Ln(LuRd)
         Call Get_F1(1,APThr)
         Call LDF_SetPrescreen(APThr)
         LocalDF=.True.
         APThr_UsrDef=.True.
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** CHEC *************************************************************
*                                                                      *
*     LDF debug option: check pair integrals.
*
   39 Continue
         Call LDF_SetOptionFlag('CHEC',.True.)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** VERI *************************************************************
*                                                                      *
*     LDF debug option: verify fit for each atom pair.
*
   40 Continue
         Call LDF_SetOptionFlag('VERI',.True.)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** OVER *************************************************************
*                                                                      *
*     LDF debug option: check overlap integrals (i.e. charge)
*
   41 Continue
         Call LDF_SetOptionFlag('OVER',.True.)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** CLDF *************************************************************
*                                                                      *
*     Constrained LDF - read constraint order
*     order=-1 --- unconstrained
*     order=0  --- charge (i.e. overlap)
*
   42 Continue
         Key=Get_Ln(LuRd)
         Call Get_I1(1,iCLDF)
         Call LDF_AddConstraint(iCLDF)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** UNCO *************************************************************
*                                                                      *
*     Unconstrained LDF (same as CLDF=-1)
*
   43 Continue
         Call LDF_AddConstraint(-1)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** WRUC *************************************************************
*                                                                      *
*     Write unconstrained coefficients to disk.
*     Only meaningful along with constrained fitting.
*     For debugging purposes: enables constrained fit verification in
*     modules other than Seward.
*
   44 Continue
         Call LDF_SetOptionFlag('WRUC',.True.)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** UNIQ *************************************************************
*                                                                      *
*     LDF: use unique atom pairs.
*
   45 Continue
         Call LDF_SetOptionFlag('UNIQ',.True.)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** NOUN *************************************************************
*                                                                      *
*     LDF: do not use unique atom pairs.
*
   46 Continue
         Call LDF_SetOptionFlag('UNIQ',.False.)
         GWInput=.False. ! Only in Seward
      Go To 998
*                                                                      *
***** RLDF *************************************************************
*                                                                      *
*     Activate local DF/RI, Roland's original LDF test implementation
*
 8012 LDF=.True.
      GWInput=.True.
      Go To 998
*                                                                      *
***** NOAL *************************************************************
*                                                                      *
*     Do not align reactants and products
*
 7013 Do_Align=.False.
      If (Align_Only) Then
         Call WarningMessage(2,
     &       'Keywords ALIG and NOAL are not compatible')
         Call Quit_OnUserError()
      End If
      GWInput=.True.
      Go To 998
*                                                                      *
***** WEIG *************************************************************
*                                                                      *
*     Weights for alignment of reactants and products
*
 7014 Align_Weights=Get_Ln(LuRd)
      Call UpCase(Align_Weights)
      GWInput=.True.
      Go To 998
*                                                                      *
***** ALIG *************************************************************
*                                                                      *
*     Align reactants and products
*
 8013 Align_Only=.True.
      If (.not.Do_Align) Then
         Call WarningMessage(2,
     &       'Keywords ALIG and NOAL are not compatible')
         Call Quit_OnUserError()
      End If
      GWInput=.True.
      Go To 998
*                                                                      *
****** TINK ************************************************************
*                                                                      *
*     Read Coordinates in Tinker's xyz format
*
8014  If (SymmSet) Then
         Call WarningMessage(2,
     &                 'SYMMETRY keyword is not compatible with TINKER')
         Call Quit_OnUserError()
      End If
      DoTinker = .True.
      ITkQMMM = 1
      If (MyRank.eq.0) Then
        ITkQMMM = IsFreeUnit(ITkQMMM)
        Call Molcas_Open (ITkQMMM,'QMMM')
        Write(ITkQMMM,'(A)') 'Molcas -1 0'
        Close (ITkQMMM)
c
        Call Getenvf('TINKER ',Key)
        mLine = Len(Key)
        iLast = iCLast(Key,mLine)
        if (iLast.eq.0) Then
          Call Getenvf('MOLCAS',Key)
          mLine = Len(Key)
          iLast = iCLast(Key,mLine)
          Key = Key(1:iLast)//'/tinker/bin'
        End If
        iLast = iCLast(Key,mLine)
        Call Getenvf('Project',Project)
        mLine = Len(Project)
        jLast = iCLast(Project,mLine)
        Key = Key(1:iLast)//'/tkr2qm_s '//Project(1:jLast)//'.xyz'//
     &                 '>'//Project(1:jLast)//'.Tinker.log'
        mLine = Len(Key)
        iLast = iCLast(Key,mLine)
        Write(6,*) 'TINKER keyword found, run ',Key(1:iLast)
        Call StatusLine(' Gateway:',' Read input from Tinker')
        RC=0
        Call Systemf(Key(1:iLast),RC)
        If (RC.ne.0) Then
          Key='RdCtl_Seward: Tinker call terminated abnormally'
          Call WarningMessage(2,Key)
          Call Abend()
        End If
      End If
#ifdef _MOLCAS_MPP_
      If (Is_Real_Par()) Then
         Call GA_Sync()
         Call PFGet_ASCII('QMMM')
         Call GA_Sync()
      End If
#endif
      iCoord=iCoord+1
      CoordSet=.True.
      ITkQMMM = IsFreeUnit(ITkQMMM)
      Call Molcas_Open (ITkQMMM,'QMMM')
#ifdef _HAVE_EXTRA_
      If (Expert) Then
         If (iCoord.gt.1) Then
            Call WarningMessage(1,
     &         'TINKER and COORD keywords cannot be combined '//
     &         'with molcas_extra')
         End If
      End If
      Call XYZread(ITkQMMM,ForceZMAT,nCoord,iErr)
      If (iErr.ne.0) Then
        Key='RdCtl_Seward: Tinker+XYZread failed:'//
     &          ' check Tinker input files'
        Call WarningMessage(2,Key)
        Call Abend()
      End If
      Call XYZcollect(iCoord,nCoord,OrigTrans,OrigRot,nFragment)
#else
      If (Expert) Then
         If (iCoord.gt.1) Then
            Call WarningMessage(1,
     &          'TINKER coordinates replacing COORD')
         End If
         Call Read_XYZ(ITkQMMM,OrigRot,OrigTrans,Replace=(iCoord.gt.1))
      Else
         Call Read_XYZ(ITkQMMM,OrigRot,OrigTrans)
      End If
#endif
      Close(ITkQMMM)
      GWInput = .True.
      Go To 998
*                                                                      *
***** ORIG *************************************************************
*                                                                      *
*     Defines translation and rotation for each xyz-file
*
 8015 Origin_input = .True.
      If(FragSet) Then
         Write(6,*) 'Keywords FRGM and ORIG are mutually exclusive!'
         Call Quit_OnUserError()
      End If
      If(.not. OriginSet) Then
         Call mma_allocate(OrigTrans,3,nFragment,label='OrigTrans')
         Call mma_allocate(OrigRot,3,3,nFragment,label='OrigRot')
         OriginSet = .True.
      End If
      Do iFrag = 1, nFragment
         KWord = Get_Ln(LuRd)
         Call Get_F(1,OrigTrans(1,iFrag),3)
         KWord = Get_Ln(LuRd)
         Call Get_F(1,OrigRot(1,1,iFrag),9)
      End Do
      GWinput = .True.
      Go To 998
*                                                                      *
***** HYPE *************************************************************
*                                                                      *
 8016 KWord = Get_Ln(LuRd)
      geoInput = .true.
      writeZmat = .true.
      Call Get_F(1,HypParam,3)
      GWinput = .True.
      HyperParSet = .True.
      Go To 998
*                                                                      *
***** ZCON *************************************************************
*                                                                      *
 8017 ZConstraints = .true.
      writeZMat = .true.
      GWinput = .True.
      Go To 998
*                                                                      *
***** SCAL *************************************************************
*                                                                      *
 8018 KWord = Get_Ln(LuRd)
      Call Get_F1(1,ScaleFactor)
      GWinput = .True.
      if(.not.CoordSet) then
         Call WarningMessage(2,'Scale can be used only with xyz input')
         Call Quit_OnUserError()
      endif
      Go To 998
*                                                                      *
***** DOAN *************************************************************
*                                                                      *
 8019 Call Put_iScalar('agrad',1)
      Go To 998
*                                                                      *
***** GEOE *************************************************************
*                                                                      *
 8020 Kword = Get_Ln(LuRd)
      Call Get_I1(1,iGeoInfo(2))
      GWinput = .True.
      iGeoInfo(1) = 1
      Call Put_iArray('GeoInfo',iGeoInfo,2)
      Go To 998
*                                                                      *
***** OLDZ *************************************************************
*                                                                      *
 8021 GWinput = .True.
      oldZmat = .True.
      Go To 998
*                                                                      *
***** OPTH *************************************************************
*                                                                      *
 8022 GWinput = .True.
      Kword = Get_Ln(LuRd)
      Call Get_I1(1,iOptimType)
      Kword = Get_Ln(LuRd)
      Call Get_F1(1,StepFac1)
      if(iOptimType .eq. 2) Then
         KWord = Get_Ln(LuRd)
         Call Get_F1(1,gradLim)
      end if
      Go To 998
*                                                                      *
***** NOON *************************************************************
*                                                                      *
 8023 Do_OneEl = .False.
      Go To 998
*                                                                      *
***** GEO  *************************************************************
*                                                                      *
 8024 geoInput = .true.
      writeZMat = .true.
*     Parameters for the gridsize is set to default-values if geo is
*     used instead of hyper
      If(.not. HyperParSet) Then
            HypParam(1) = 0.15d0
            HypParam(2) = 2.5d0
            HypParam(3) = 2.5d0
      End If
      GWinput = .True.
      Go To 998
*                                                                      *
***** GEN1INT **********************************************************
*                                                                      *
*        GEN1INT integrals
 9023 lPSOI=.true.
      !Write(6,*) 'lPSOI',lPSOI,nAtoms
      Go To 998
*                                                                      *
***** FRGM *************************************************************
*                                                                      *
 8025 Origin_input= .True.
      GWinput = .True.
      If(OriginSet) Then
         Write(6,*) 'Keywords FRGM and ORIG are mutually exclusive!'
         Call Quit_OnUserError()
      End If
      If(.not.FragSet) then
         Call mma_allocate(OrigTrans,3,nFragment,label='OrigTrans')
         Call mma_allocate(OrigRot,3,3,nFragment,label='OrogRot')
*     Set up no translation and no rotation as default
         Call FZero(OrigTrans,3*nFragment)
         Call FZero(OrigRot,9*nFragment)
         Do i = 1, nFragment
            OrigRot(1,1,i)   = 1.0d0
            OrigRot(2,2,i)   = 1.0d0
            OrigRot(3,3,i)   = 1.0d0
         End Do
         FragSet = .True.
      End If
      Kword = Get_Ln(LuRd)
      Call Get_I1(1,iFrag)
      Go To 998
*                                                                      *
***** TRAN *************************************************************
*                                                                      *
 8026 If(.not. FragSet) Then
         Write(6,*) 'Keyword TRANS must be preceded by keyword FRAG!'
         Call Quit_OnUserError()
      End If
      GWinput = .True.
      Kword = Get_Ln(LuRd)
      Call Get_F(1,OrigTrans(1,iFrag),3)
      Go To 998
*                                                                      *
****** ROT  ************************************************************
*                                                                      *
 8027 If(.not. FragSet) Then
         Write(6,*) 'Keyword ROT must be preceded by keyword FRAG!'

      End If
      GWinput = .True.
      Kword = Get_Ln(LuRd)
      Call Get_F(1,OrigRot(1,1,iFrag),9)
      Go To 998
*                                                                      *
******* ZONL ***********************************************************
*                                                                      *
 8028 GWinput = .True.
      WriteZMat = .True.
      Go To 998
*                                                                      *
******* BASL ***********************************************************
*                                                                      *
 8029 GWinput = .True.
      BasLib=Get_Ln(LuRd)
      Write_BasLib=.True.
      Go To 998
*                                                                      *
******* NUME ***********************************************************
*                                                                      *
 8031 GWinput = .True.
      iDNG=1
      Go To 998
*                                                                      *
******* VART ***********************************************************
*                                                                      *
 8032 GWinput = .True.
      VarT=.True.
      Go To 998
*                                                                      *
******* VARR ***********************************************************
*                                                                      *
 8033 GWinput = .True.
      VarR=.True.
      Go To 998
*                                                                      *
******* SHAK ***********************************************************
*                                                                      *
 8050 Continue
      GWinput = .True.
      KWord = Get_Ln(LuRd)
      Call Upcase(KWord)
      Call Get_F1(1,Shake)
      If (Index(KWord,'ANGSTROM').ne.0) Shake = Shake/angstr
      Go To 998
*                                                                      *
****** PAMF ************************************************************
*                                                                      *
*     Disable AMFI for an atom type
*
 8060 KWord = Get_Ln(LuRd)
      Call Get_I1(1,iAtom_Number)
      No_AMFI(iAtom_Number)=.True.
      Go To 998
*                                                                      *
******* GROM ***********************************************************
*                                                                      *
*     Import definition of QMMM system from Gromacs
*
 8034 Continue
#ifdef _GROMACS_
      If (SymmSet) Then
         Message = 'SYMMETRY keyword is not compatible with GROMACS'
         Call WarningMessage(2,Message)
         Call Quit_OnUserError()
      End If
      DoGromacs = .True.
      GWInput = .True.
      VarT = .True.
      VarR = .True.
*
* Check for options
      KWord = Get_Ln(LuRd)
      Call UpCase(KWord)
      If (KWord(1:4).Eq.'SIMP') Then
         nCastMM = 0
         Call mma_allocate(CastMM,nCastMM)
      Else If (KWord(1:4).Eq.'CAST') Then
         KWord = Get_Ln(LuRd)
         Call Get_I(1,nCastMM,1)
         If (nCastMM.LE.0) Then
            Message = 'nCastMM is zero or negative'
            Call WarningMessage(2,Message)
            Call Quit_OnUserError()
         End If
         Call mma_allocate(CastMM,nCastMM)
         KWord = Get_Ln(LuRd)
         Call Get_I(1,CastMM,nCastMM)
         Do iCastMM = 1,nCastMM
            If (CastMM(iCastMM).LE.0) Then
               Message = 'Impossible, MM index < 1'
               Call WarningMessage(2,Message)
               Call Quit_OnUserError()
            End If
         End Do
      Else
         Message='GROMACS keyword found, but no valid option'
         Call WarningMessage(2,Message)
         Call Quit_OnUserError()
      End If
*
* After the call to Fetch_QMMM, the inner subsystem is in a temporary
* xyz file and the outer subsystem is on the runfile
      Call Fetch_QMMM(CastMM,nCastMM)
*
      Call mma_deallocate(CastMM)
*
* Let Molcas read the xyz file
      iCoord = iCoord+1
      CoordSet = .True.
      LuXYZ = 1
      LuXYZ = isFreeUnit(LuXYZ)
      Call molcas_open(LuXYZ,'GMX.XYZ')
#ifdef _HAVE_EXTRA_
      If (Expert) Then
         If (iCoord.gt.1) Then
            Call WarningMessage(1,
     &         'GROMACS and COORD keywords cannot be combined '//
     &         'with molcas_extra')
         End If
      End If
      Call XYZread(LuXYZ,ForceZMAT,nCoord,iErr)
      If (iErr.NE.0) Then
         Message='RdCtl_Seward: XYZread returned non-zero error code'
         Call WarningMessage(2,Message)
         Call Abend()
      End If
      Call XYZcollect(iCoord,nCoord,OrigTrans,OrigRot,nFragment)
#else
      If (Expert) Then
         If (iCoord.gt.1) Then
            Call WarningMessage(1,
     &          'TINKER coordinates replacing COORD')
         End If
         Call Read_XYZ(LuXYZ,OrigRot,OrigTrans,Replace=(iCoord.gt.1))
      Else
         Call Read_XYZ(LuXYZ,OrigRot,OrigTrans)
      End If
#endif
      Close(LuXYZ)
#else
      Message = 'Interface to Gromacs not installed'
      Call WarningMessage(2,Message)
      Call Quit_OnUserError()
#endif
      Go To 998
*                                                                      *
******* LINK ***********************************************************
*                                                                      *
*     Define link atoms for a Molcas/Gromacs run
*
 8036 Continue
#ifdef _GROMACS_
      GWInput = .True.
      KWord = Get_Ln(LuRd)
      Call Get_I(1,nLA,1)
      If (nLA.LE.0) Then
         Message = 'LA definition: nLA is zero or negative'
         Call WarningMessage(2,Message)
         Call Quit_OnUserError()
      End If
#ifdef _DEBUGPRINT_
      Write(LuWr,'(/,a)') ' Link atoms (Gromacs numbering):'
      Write(LuWr,'(/,a)') '      LA     QM     MM     Scaling factor'
#endif
      Call mma_allocate(DefLA,3,nLA)
      Call mma_allocate(FactLA,nLA)
      Do iLA = 1,nLA
         KWord = Get_Ln(LuRd)
         Call Get_I(1,DefLA(1,iLA),3)
         Call Get_F(4,FactLA(iLA),1)
#ifdef _DEBUGPRINT_
         Write(LuWr,'(i8,2i7,F19.8)') (DefLA(i,iLA),i=1,3),FactLA(iLA)
#endif
         If (DefLA(1,iLA).LE.0) Then
            Call WarningMessage(2,'LA definition: index of LA atom < 1')
            Call Quit_OnUserError()
         Else If (DefLA(2,iLA).LE.0) Then
            Call WarningMessage(2,'LA definition: index of QM atom < 1')
            Call Quit_OnUserError()
         Else If (DefLA(3,iLA).LE.0) Then
            Call WarningMessage(2,'LA definition: index of MM atom < 1')
            Call Quit_OnUserError()
         Else If (FactLA(iLA).LE.Zero.Or.FactLA(iLA).GE.One) Then
            Call WarningMessage(2,'LA definition: bad scaling factor')
            Call Quit_OnUserError()
         End If
      End Do
      Call Put_iArray('LA Def',DefLA,3*nLA)
      Call Put_dArray('LA Fact',FactLA,nLA)
      Call mma_deallocate(DefLA)
      Call mma_deallocate(FactLA)
#else
      Message = 'Interface to Gromacs not installed'
      Call WarningMessage(2,Message)
      Call Quit_OnUserError()
#endif
      Go To 998
*                                                                      *
****** EMFR ************************************************************
*                                                                      *
 8035 GWinput = .True.
      Kword = Get_Ln(LuRd)
      Call Upcase(KWord)
      EMFR=.True.
      Call Get_F(1,KVector,3)
      Temp=Sqrt(KVector(1)**2+KVector(2)**2+KVector(3)**2)
      KVector(1)=KVector(1)/Temp
      KVector(2)=KVector(2)/Temp
      KVector(3)=KVector(3)/Temp
*     Get the wavelength in atomic units.
      Call Get_F1(4,Lambda)
      If (Index(KWord,'ANGSTROM').ne.0) Lambda  = Lambda/angstr
      If (Index(KWord,'NANOMETER').ne.0) Then
         Lambda  = Ten*Lambda/angstr
      ENd If
      KVector(1)=((Two*Pi)/Lambda)*KVector(1)
      KVector(2)=((Two*Pi)/Lambda)*KVector(2)
      KVector(3)=((Two*Pi)/Lambda)*KVector(3)
      Go To 998
*                                                                      *
****** NOCD ************************************************************
*                                                                      *
 9084 GWinput = .True.
      If (.NOT.CholeskyWasSet) Then
         Do_RI=.False.
         iRI_Type=0
         Cholesky=.False.
         CholeskyWasSet=.True.
      End If
      Go To 998
*                                                                      *
****** FNMC ************************************************************
*                                                                      *
 9086 GWinput = .True.
      FNMC=.True.
      Go To 998
*                                                                      *
****** ISOT ************************************************************
*                                                                      *
 7654 GWinput = .True.
      KWord = Get_Ln(LuRd)
      Call Upcase(KWord)
      Call Get_I1(1,nIsotopes)
      Call mma_allocate(nIsot,nIsotopes,2)
      Call mma_allocate(mIsot,nIsotopes)
      Do i=1,nIsotopes
         KWord = Get_Ln(LuRd)
         Call Upcase(KWord)
         Call Get_I1(1,iAt)
         nIsot(i,1)=iAt
         If (Index(KWord,'DALTON').ne.0) Then
            Call Get_F1(2,dMass)
            nIsot(i,2) = -1
            mIsot(i) = dMass*UToAU
         Else
            Call Get_I1(2,iIso)
            nIsot(i,2) = iIso
            mIsot(i) = -One
         End If
      End Do
      Go To 998
*                                                                      *
****** EFP  ************************************************************
*                                                                      *
 9088 GWinput = .True.
      Kword = Get_Ln(LuRd)
      Call Get_I1(1,nEFP_fragments)
      Allocate(FRAG_TYPE(nEFP_fragments))
      Allocate(ABC(3,nEFP_fragments))
      Kword = Get_Ln(LuRd)
      Call Upcase(kWord)
      If (KWord.eq.'XYZABC') Then
         Coor_Type=XYZABC_type
         nEFP_Coor=6
         Allocate(EFP_COORS(nEFP_Coor,nEFP_fragments))
         Write (LuWr,*) 'XYZABC option to be implemented'
         Call Abend()
      Else If (KWord.eq.'POINTS') Then
         Coor_Type=POINTS_type
         nEFP_Coor=9
         Allocate(EFP_COORS(nEFP_Coor,nEFP_fragments))
         Do iFrag = 1, nEFP_fragments
            KWord = Get_Ln(LuRd)
            FRAG_Type(iFrag)=KWord
            Do i = 1, 3
               KWord = Get_Ln(LuRd)
               iend=Index(KWord,' ')
               If (iEnd.gt.LENIN+1) Then
                  Write (LuWr,*) 'Warning: the label ', KWord(1:iEnd),
     &                        ' will be truncated to ',LENIN,
     &                        ' characters!'
               End If
               ABC(i,iFrag) = KWord(1:Min(LENIN,iend-1))
               Call Get_F(2,EFP_COORS((i-1)*3+1,iFrag),3)
            End Do
         End Do
      Else If (KWord.eq.'ROTMAT') Then
         Coor_Type=ROTMAT_type
         nEFP_Coor=12
         Allocate(EFP_COORS(nEFP_Coor,nEFP_fragments))
         Write (LuWr,*) 'ROTMAT option to be implemented'
         Call Abend()
      Else
         Write (LuWr,*) 'Illegal EFP format :',KWord
         Write (LuWr,*)
         Write (LuWr,*) 'Allowed format: XYZABC,'
         Write (LuWr,*) '                POINTS, and'
         Write (LuWr,*) '                ROTMAT'
      End If
      lEFP=.True.
      Go To 998
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     P O S T   P R O C E S S I N G                                    *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*
 997  Continue
c     Postprocessing for COORD
c      ik=index(KeepBasis,'....')
c      if(ik.ne.0) then
c        KeepBasis=KeepBasis(1:ik-1)
c      endif
      If (CoordSet) Then
         Do ik=len(KeepBasis),1,-1
            If (KeepBasis(ik:ik).ne.' '.and.KeepBasis(ik:ik).ne.'.')
     &         Go To 1997
         End Do
1997     Continue
         KeepBasis=KeepBasis(1:ik)
#ifdef _HAVE_EXTRA_
         Call ProcessXYZ(BasisSet, KeepBasis, KeepGroup,iBSSE,
     &                   SymThr,isHold,ScaleFactor,HyperParSet,
     &                   isXfield)
#else
         Call Parse_Basis(KeepBasis)
         Call Parse_Group(KeepGroup, SymThr)
         Call Write_SewInp('COORD',[iBSSE])
#endif
         if(writeZmat) then
#ifdef _HAVE_EXTRA_
            stepFactor = stepFac1/(hypParam(1)*hypParam(1))
            Call Geo_Setup_Drv(ishold,oldZMat,zConstraints,
     &                         geoInput,hypParam,nFragment,iOptimType,
     &                         stepFactor,gradLim)
#else
            Call WarningMessage(2,'molcas-extra not installed')
            Call Quit_OnUserError()
#endif
         end if
         DoneCoord=.true.
         if(isXfield.eq.1) then
            LuRd_saved=LuRd
            filename='findsym.xfield'
            lXF=.True.
            goto 9753
         endif
      endif
*
9755  continue
      If (CoordSet) Then
         CoordSet=.false.
         LuRdSave=LuRd
         LuFS=IsFreeUnit(1)
#ifdef _HAVE_EXTRA_
         Call Molcas_Open(LuFS,'FS.std')
#else
         Call Molcas_Open(LuFS,'COORD')
#endif
         LuRd=LuFS
         GWInput=.True.
         Go To 998
      Else
         If (DoneCoord) Then
           Close(LuFS)
           LuRd=LuRdSave
#ifndef _HAVE_EXTRA_
           Call Clear_XYZ()
#endif
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Put_lScalar('CSPF',CSPF)
      Call Put_cArray('Align_Weights',Align_Weights,512)
*                                                                      *
************************************************************************
*                                                                      *
*     Isotopic specifications
*
      If (.not.Allocated(nIsot)) Call mma_allocate(nIsot,0,2)

      If (Run_Mode.ne.S_Mode) Then
*        Loop over unique centers
         iUnique = 0
         Call mma_allocate(Isotopes,nCnttp,Label='Isotopes')
         Do iCnttp = 1, nCnttp
            nCnt = dbsc(iCnttp)%nCntr
            Do iCnt = 1, nCnt
               iUnique = iUnique+1
*              Get the mass for this center
               dm = rMass(dbsc(iCnttp)%AtmNr)
               Do j = 1, Size(nIsot, 1)
                  If (nIsot(j,1).eq.iUnique) Then
                     If (nIsot(j,2).ge.0) Then
                        dm = rMassx(dbsc(iCnttp)%AtmNr,nIsot(j,2))
                     Else
                        dm = mIsot(j)
                     End If
                     Exit
                  End If
               End Do
               If (iCnt.eq.1) Then
                  dbsc(iCnttp)%CntMass = dm
               Else
                  If (dm.ne.dbsc(iCnttp)%CntMass) Then
                     Call WarningMessage(2,
     &                 'Error: All centers of the same type must '//
     &                 'have the same mass')
                     Call Quit_OnUserError()
                  End If
               End If
            End Do
            Isotopes(iCnttp)=dbsc(iCnttp)%CntMass
         End Do ! iCnttp
         Call Put_dArray('Isotopes',Isotopes,nCnttp)
         Call mma_deallocate(Isotopes)

*        Find errors
         Do j = 1, Size(nIsot, 1)
            If (nIsot(j,1).gt.iUnique) Then
               Call WarningMessage(2,
     &           'Error: Isotope specification index larger than the '//
     &           'number of unique centers')
               Call Quit_OnUserError()
            End If
         End Do
      End If

*     Deallocate
      If (Allocated(nIsot)) Call mma_deallocate(nIsot)
      If (Allocated(mIsot)) Call mma_deallocate(mIsot)
*                                                                      *
************************************************************************
*                                                                      *
**    post-processing for RP-Coord
*
      If (lRP.and.RPset) Call processRP(KeepGroup,SymThr)
*
**
*
      lAMFI=lAMFI .and. .Not. NoAMFI
*
*     Disable the RI flag if only one-electron integrals are
*     requested
*
      Do_RI = .Not.Onenly .and. Do_RI
      If (Do_RI) Then
         If (LDF .and. LocalDF) Then
            Call WarningMessage(2,'LDF and LocalDF are incompatible')
            Call Quit_OnUserError()
         End If
      End If
*
      iPrint = nPrint(iRout)
*
      S%Mx_Shll = iShll + 1
      Max_Shells=S%Mx_Shll
*
      If (nCnttp.eq.0) then
         Call WarningMessage(2,'Input does not contain any basis sets')
         Call Quit_OnUserError()
      End If
      If (mdc.eq.0) Then
         Call WarningMessage(2,'Input does not contain coordinates')
         Call Quit_OnUserError()
      End If
      If (S%iAngMx.lt.0) Then
         Call WarningMessage(2,
     &     ' There is an error somewhere in the input!;S%iAngMx.lt.0')
         Call Quit_OnUserError()
      End If
      If (S%iAngMx.gt.iTabMx) Then
         Call WarningMessage(2,' Too High angular momentum !!!')
         Call Quit_OnUserError()
      End If
      If (DoTinker.and.DoGromacs) Then
         Call WarningMessage(2,
     &      'TINKER and GROMACS keywords cannot be used together')
         Call Quit_OnUserError()
      End If
      If (DoTinker.and.iCoord.gt.1) Then
         If (.Not.Expert) Then
            Call WarningMessage(2,
     &         'TINKER and COORD keywords cannot be used together')
            Call Quit_OnUserError()
         End If
      End If
      If (DoGromacs.and.iCoord.gt.1) Then
         If (.Not.Expert) Then
            Call WarningMessage(2,
     &         'GROMACS and COORD keywords cannot be used together')
            Call Quit_OnUserError()
         End If
      End If
*
      If (Test) Then
         Do_GuessOrb=.False.
         Do_FckInt=.False.
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Automatic DK and AMFI option for relativistic basis sets
*                                                                      *
************************************************************************
*                                                                      *
      IF (BSS.AND..Not.DKroll) Then
         Call WarningMessage(2,
     &           ';BSSM GOES ALWAYS WITH DOUGLAS.'//
     &           'THE OPPOSITE IS NOT TRUE')
         Call Abend()
      End If
*
      lECP = .False.
      lPP  = .False.
      Do i = 1, nCnttp
         lECP = lECP .or. dbsc(i)%ECP
         lPP  = lPP  .or. dbsc(i)%nPP.ne.0
      End Do
      If ((lECP.or.lPP).and.DKroll.and..Not.Expert) Then
         Call WarningMessage(2,
     &               ' ECP option not compatible with Douglas-Kroll!')
         Call Quit_OnUserError()
      End If
*
      If (imix.eq.1) Then
         if (Expert) then
           Call WarningMessage(1,
     &        ' input is inconsistent!;'
     &      //'SEWARD found basis sets of mixed relativistic'
     &      //' (or non-relativistic) types!;'
     &      //'No relativistic option will be automatically enabled')
         else
           Call WarningMessage(2,
     &        ' input is inconsistent!;'
     &      //'SEWARD found basis sets of mixed relativistic'
     &      //' (or non-relativistic) types!')
           Call Quit_OnUserError()
         endif
      End If
      If (ifnr.eq.1.and..not.Expert) Then
         If (DKroll) Then
         Call WarningMessage(1,
     *    ';you requested the DK-option for;'
     *   //'a non-relativistic basis.;'
     *   //'This request will be ignored')
         End If
         DKroll=.False.
      Else If (ifnr.eq.0) Then
         lAMFI=.True. .and. .NOT. NoAMFI
         If (.Not.DKroll) Then
            DKroll=.True.
C           If (iRELAE.eq.-1) IRELAE=201022
            If (iRELAE.eq.-1) Then
               If (itype.eq.2) Then
                  IRELAE=  1022
               Else If (itype.eq.14) Then
                  IRELAE=   101
               End If
            End If
         End If
         If (MolWgh.ne.0 .and. MolWgh.ne.2) MolWgh=2
      End If
*
      If (NoDKroll) DKroll=.false.
      If (DoEMPC) isHold=1
*
      If ((lECP.or.lPP).and.lAMFI.and..Not.Expert) Then
         Call WarningMessage(2,
     &               ' ECP option not compatible with AMFI!')
         Call Quit_OnUserError()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Activate Finite Nucleus parameters
*
      If (Nuclear_Model.eq.Point_Charge) Then
         If (ign.eq.2) Nuclear_Model=Gaussian_Type
         If (ign.eq.3) Nuclear_Model=mGaussian_Type
      End If
*
      Do iCnttp = 1, nCnttp
         If (Nuclear_Model.eq.Gaussian_Type) Then
*
*           If ExpNuc not explicitly defined use default value.
*
            nMass = nInt(dbsc(iCnttp)%CntMass/UToAU)
            If (dbsc(iCnttp)%ExpNuc.lt.Zero)
     &          dbsc(iCnttp)%ExpNuc=NucExp(nMass)
         Else If (Nuclear_Model.eq.mGaussian_Type) Then
*
*           Get parameters for the Modified Gaussian Nuclear
*           charge distribution.
*
            jAtmNr=dbsc(iCnttp)%AtmNr
            nMass = nInt(dbsc(iCnttp)%CntMass/UToAU)
            Call ModGauss(DBLE(jAtmNr),nMass,dbsc(iCnttp)%ExpNuc,
     &                    dbsc(iCnttp)%w_mGauss)
*
         Else
*
*           Nothing to do for point charges!
*
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Cholesky-specific postprocessing:
*     0) if 1C-CD is requested, do it.
*     1) reset integral prescreening thresholds (if not user-defined).
*     2) use default Cholesky normalization (if not user-defined);
*        for AMFI or Douglas-Kroll, use Molcas normalization (again,
*        if not user-defined).
*     3) Turn off Onenly flag, which might be set through the Direct
*        keyword. Thus, specifying Cholesky will force 2-el. int.
*        processing even with Direct specifed as well!
*     4) Turn off Dist flag (makes no sense with Cholesky).
*     5) Integral format on disk is irrelevant, except that Aces II is
*        not allowed. So, reset iWrOpt or quit (for Aces II).
*     6) if Cholesky threshold is specified, use it.
*     7) if span factor is specified, use it.
*
      If (do1CCD) Then
         If (.not.Cholesky) Then
            DirInt = .True.
            Call Cho_Inp(.True.,-1,6)
         End If
         Cholesky=.True.
         Call Cho_InpMod('1CCD')
      End If
      If (Cholesky) Then
         If (Onenly) Then
            Cholesky=.false. ! we gotta be lazy in such cases
         Else
            If (.not. CutInt_UsrDef) CutInt = Cho_CutInt
            If (.not. ThrInt_UsrDef) ThrInt = Cho_ThrInt
            If (.not. MolWgh_UsrDef) Then
               If (lAMFI .or. DKroll) Then
                  MolWgh = 2
               Else
                  MolWgh = Cho_MolWgh
               End If
            End If
            If (iWrOpt .eq. 2) Then
               Write(LuWr,*)
     &         'Acess II format not allowed with Cholesky!!'
               Call Quit_OnUserError()
            Else If (iWrOpt.ne.0 .and. iWrOpt.ne.3) Then
               iWrOpt = 0
            End If
            If (CholeskyThr.ge.0.0d0) Then
               Thrshld_CD=CholeskyThr
               Call Cho_SetDecompositionThreshold(Thrshld_CD)
               Call Put_Thr_Cho(Thrshld_CD)
            End If
            If (spanCD.ge.0.0d0) Then
               v=min(spanCD,1.0d0)
               Call Cho_SetSpan(v)
            End If
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (Prprt) Then
         Onenly = .True.
         Vlct   = .False.
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Post processing for FAIEMP fragment data
*
      If (lFAIEMP.and.Run_Mode.ne.S_Mode) Call FragExpand(LuRd)
*                                                                      *
************************************************************************
*                                                                      *
*     Post processing for RI and RI/CD option
*
      If ( Do_RI .and. Run_Mode.ne.S_Mode ) Then
         If (iRI_Type.eq.4) Then
*
*           Generate on-the-fly aCD or aTrue.cCD auxiliary basis sets.
*
            Call Mk_RICD_Shells()
*
         Else
*
*           Pick up an externally defined auxiliary basis set.
*
            Call Mk_RI_Shells(LuRd)
*
         End If
      End If
      If (Do_RI .and. LocalDF .and. Run_Mode.eq.S_Mode) Then
         Call SetTargetAccuracy_LDF()
         If (CutInt_UsrDef .and. .not.APThr_UsrDef) Then
            Call LDF_SetPrescreen(CutInt)
            Call LDF_CheckThrs()
         End If
         Call LDF_CheckConfig()
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Post processing for Well integrals
*
      Do iWel = 1, nWel
         If (Wel_Info(1,iWel).lt.Zero) Then
            If (.Not.lRF) Then
               Call WarningMessage(2,
     &                        '; Input inconsistency!; ;'
     &                      //'Relative positions of well integrals'
     &                      //' can only be used if the cavity radius'
     &                      //' has been specified!')
               Call Quit_OnUserError()
            End If
            Wel_Info(1,iWel)=rds+Abs(Wel_Info(1,iWel))
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Put up list for point at which the electric field will be
*     evaluated. If nEF=0 the default points will be the unique
*     centers.
*
      If (nOrdEF.ge.0.and. .NOT.(Run_Mode.eq.S_Mode)) Then
         If (nEF.ne.0) Then
            Call mma_allocate(EF_Centers,3,nEF,Label='EF_Centers')
            EF_Centers(:,:) = EFt(:,:)
            Call mma_deallocate(EFt)
         Else
            nEF = 0
            Do iCnttp = 1, nCnttp
               If (.NOT.dbsc(iCnttp)%Aux .and. .NOT.dbsc(iCnttp)%Frag)
     &         nEF = nEF + dbsc(iCnttp)%nCntr
            End Do
            Call mma_allocate(EF_Centers,3,nEF,Label='EF_Centers')
*
            iEF = 1
            Do iCnttp = 1, nCnttp
               If (.NOT.dbsc(iCnttp)%Aux .and.
     &             .NOT.dbsc(iCnttp)%Frag) Then
                  call dcopy_(3*dbsc(iCnttp)%nCntr,
     &                                        dbsc(iCnttp)%Coor,1,
     &                                        EF_Centers(1,iEF),1)
                  iEF = iEF + dbsc(iCnttp)%nCntr
               End If
            End Do
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Put up list for point at which the diamagnetic shielding will
*     be evaluated. If nDMS=0 the default points will be the unique
*     centers.
*
      If (lDMS.and. .NOT.(Run_Mode.eq.S_Mode)) Then
         If (nDMS.ne.0) Then
            Call mma_allocate(DMS_Centers,3,nDMS,Label='DMS_Centers')
            DMS_Centers(:,:)=DMSt(:,:)
            call mma_deallocate(DMSt)
         Else
            nDMS = 0
            Do iCnttp = 1, nCnttp
               nDMS = nDMS + dbsc(iCnttp)%nCntr
            End Do
            Call mma_allocate(DMS_Centers,3,nDMS,Label='DMS_Centers')
            iDMS = 1
            Do iCnttp = 1, nCnttp
               call dcopy_(3*dbsc(iCnttp)%nCntr,
     &                                     dbsc(iCnttp)%Coor,1,
     &                                     DMS_Centers(1,iDMS),1)
               iDMS = iDMS + dbsc(iCnttp)%nCntr
            End Do
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*     If no multipole moment integrals are requested turn also of the
*     computation of the velocity integrals.
*
      If (S%nMltpl.eq.0) Vlct=.False.
*
*     But turn it on again if explicitly requested
*
      If (Vlct_) Vlct=.True.
*
*     This is the highest order of any property operator.
*     The default value of 4 is due to the mass-velocity operator
*     which is computed by default.
*
      nPrp = Max(4,S%nMltpl)
*
*     Setup of tables for coefficients of the Rys roots and weights.
*
      nDiff=0
      If (S%iAngMx.eq.0) nDiff=2
      DoRys=.True.
      If (DKroll.and.nOrdEF.gt.0) nDiff=nDiff+nOrdEF
      If (.Not.Test.and.Run_Mode.ne.S_Mode) Call SetUp_RW(DoRys,nDiff)
*                                                                      *
************************************************************************
*                                                                      *
*     Store information for the Douglas-Kroll code.
*
      If (DKroll.or.NEMO) Call Fill_rInfo1()
*                                                                      *
************************************************************************
*                                                                      *
*     Compute kOffAO and lOffAO
*
      Call Setup_OffAO()
*                                                                      *
************************************************************************
*                                                                      *
*---- Generate labels for Cartesian and spherical basis sets.
*     Generate the transformation matrix for cartesian to sphericals
*     and contaminants. This has to be done after adding auxiliary or
*     fragment basis sets.
*
      Call Sphere(S%iAngMx)
*                                                                      *
************************************************************************
************************************************************************
************************************************************************
*                                                                      *
*     Set up Symmetry_Info
*
      Call Symmetry_Info_Setup(nOper,Oper,Max(S%iAngMx,3))

      If (lSkip) then
         Call Put_Ln(ChSkip)
         Call Get_I(1,iSkip,nIrrep)
         Do_GuessOrb=.FALSE.
      End If
*                                                                      *
************************************************************************
************************************************************************
************************************************************************
*                                                                      *
*     Generate list of Stabilizers , Stabilizer Index
*     and distinct cosets
*
      S%mCentr=0
      S%mCentr_Aux=0
      S%mCentr_Frag=0
      Do iCnttp = 1, nCnttp
         nCnt = dbsc(iCnttp)%nCntr
         Do iCnt = 1, nCnt
            mdc = iCnt + dbsc(iCnttp)%mdci
            S%Mx_mdc = Max(S%Mx_mdc,mdc)
            n_dc=max(mdc,n_dc)
            If (mdc.gt.MxAtom) Then
               Call WarningMessage(2,' mdc.gt.MxAtom!;'
     &                      //' Increase MxAtom in info.fh.')
               Write (LuWr,*) ' MxAtom=',MxAtom
               Call Abend()
            End If
*
*           The symmetry operators of the fragment's atoms should
*           always be identical to that of the fragment's
*           pseudocenter/placeholder
*
            If (dbsc(iCnttp)%Frag) Then
*              Check the FragExpand routine!
               If (Abs(dbsc(iCnttp)%nFragCoor)>mdc) Then
                  Write (6,*) 'rdctl_seward: incorrect mdc index'
                  Call Abend()
               End If
               iChxyz = dc(Abs(dbsc(iCnttp)%nFragCoor))%iChCnt
            Else
*
*------------- To assign the character of a center we need to find
*              the cartesian components that are permutable. We
*              will only need to loop over the generators of the
*              group. We will use the three first bits to indicate if
*              the cartesian component is affected by any symmetry
*              operation.
*
               iChxyz=iChAtm(dbsc(iCnttp)%Coor(:,iCnt))
            End If
            dc(mdc)%iChCnt = iChxyz
            Call Stblz(iChxyz,dc(mdc)%nStab,dc(mdc)%iStab,
     &                 nIrrep,dc(mdc)%iCoSet)
*
*           Perturb the initial geometry if the SHAKE keyword was given,
*           but maintain the symmetry
*
            If ((Shake.gt.Zero).And.
     &          .Not.(dbsc(iCnttp)%pChrg.Or.
     &                dbsc(iCnttp)%Frag.Or.
     &                dbsc(iCnttp)%Aux)) Then
               jTmp=0
               Do j=1,dc(mdc)%nStab-1
                  jTmp=iOr(jTmp,dc(mdc)%iStab(j))
               End Do
               S%nDim=0
               Do j=0,2
                  If (iAnd(jTmp,2**j).eq.0) S%nDim=S%nDim+1
               End Do
               If (S%nDim.gt.0) Then
                  Call Random_Vector(S%nDim,RandVect(1:S%nDim),.False.)
                  jDim=0
                  Do j=0,2
                     If (iAnd(jTmp,2**j).eq.0) Then
                        jDim=jDim+1
                        dbsc(iCnttp)%Coor(j+1,iCnt)=
     &                      dbsc(iCnttp)%Coor(j+1,iCnt)
     &                     +Shake*RandVect(jDim)
                  End If
                  End Do
               End If
            End If
            If (dbsc(iCnttp)%Frag) Then
               S%mCentr_Frag = S%mCentr_Frag + nIrrep/dc(mdc)%nStab
            Else If (dbsc(iCnttp)%Aux) Then
               S%mCentr_Aux = S%mCentr_Aux + nIrrep/dc(mdc)%nStab
            Else
               S%mCentr = S%mCentr + nIrrep/dc(mdc)%nStab
            End If
         End Do
      End Do
      If (S%mCentr.gt.MxAtom) Then
         Call WarningMessage(2,'RdCtl: S%mCentr.gt.MxAtom')
         Write (6,*) 'S%mCentr=',S%mCentr
         Write (6,*) 'Edit src/Include/Molcas.fh'
         Write (6,*) 'Set MxAtom to the value of S%mCentr.'
         Write (6,*) 'Recompile MOLCAS and try again!'
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If ((SymmSet.or.nIrrep.gt.1).and.LDKroll) Then
         Call WarningMessage(2,
     &      'Local DKH approach is not yet implemented with SYMMETRY')
         Call Quit_OnUserError()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (Do_GuessOrb.and.Run_Mode.ne.S_Mode) Call Fix_FockOp(LuRd)
*                                                                      *
************************************************************************
*                                                                      *
      If ((iXPolType.ne.0).and.(nIrrep.ne.1)) Then
         Call WarningMessage(2,
     &                'Polarizabilities are not compatible'
     &              //' with symmetry.')
         Call Quit_OnUserError()
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
      If (nTtl.ne.0.and.Run_Mode.eq.G_Mode) Then
         If (iPrint.ge.6) Then
            Write (LuWr,*)
            Write (LuWr,'(15X,88A)') ('*',i=1,88)
            Write (LuWr,'(15X,88A)') '*', (' ',i=1,86), '*'
            Do iTtl = 1, nTtl
               Write (LuWr,'(15X,A,A,A)') '*   ',Title(iTtl),'   *'
            End Do
            Write (LuWr,'(15X,88A)') '*', (' ',i=1,86), '*'
            Write (LuWr,'(15X,88A)') ('*',i=1,88)
         Else
            Write (LuWr,*)
            Write (LuWr,'(A)') ' Title:'
            Do iTtl = 1, nTtl
               Write (LuWr,'(8X,A)') Title(iTtl)
            End Do
            Write (LuWr,*)
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Process the weights used for alignment and distance measurement
*
      Call Process_Weights(iPrint)
*
************************************************************************
*                                                                      *
*     Set structures for TS optimization according to the Saddle
*     method.
*
      If (Run_Mode.ne.G_Mode) Then
         Call Saddle()
*                                                                      *
************************************************************************
*                                                                      *
*---- Read coordinates from run file (if any), ditto for external
*     field. Do not do this in the Gateway!
*
         Call GeoNew(Show)
         If (lXF) Call GeoNew_PC()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Gen_GeoList()
*                                                                      *
************************************************************************
*                                                                      *
*     Generate list of centers for multipole operators
*
      Call SetMltplCenters()
*
*     Put in user specified centers if any
*
      If (lMltpl) Then
         Do i = 1, nTemp
            iMltpl = ITmp(i)
            If (iMltpl.le.S%nMltpl) call dcopy_(3,RTmp(1,i),1,
     &                                         Coor_MPM(1,iMltpl+1),1)
         End Do
         Call mma_deallocate(RTmp)
         Call mma_deallocate(ITmp)
      End If
#ifdef _DEBUGPRINT_
       Call RecPrt(' Multipole centers',' ',Coor_MPM,3,S%nMltpl+1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Put up list for point at which the orbital angular momentum
*     will be computed.
*
      If (lOAM .and. .NOT.(Run_Mode.eq.S_Mode)) Then
         Call mma_allocate(OAM_Center,3,Label='OAM_Center')
         call dcopy_(3,OAMt,1,OAM_Center,1)
      Else If (.NOT.allocated(OAM_Center)) Then
         Call mma_allocate(OAM_Center,3,Label='OAM_Center')
         call dcopy_(3,CoM,1,OAM_Center,1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Put up list for point at which the orbital magnetic quadrupole
*     will be computed.
*
      If (lOMQ .and. .NOT.(Run_Mode.eq.S_Mode)) Then
         Call mma_allocate(OMQ_Center,3,Label='OMQ_Center')
         Call DCopy_(3,OMQt,1,OMQ_Center,1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Deallocate fields from keyword ORIGIN
*
      If(Origin_input) Then
         Call mma_deallocate(OrigRot)
         Call mma_deallocate(OrigTrans)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (NoZMAT .and. .NOT.ForceZMAT) Call Put_iScalar('N ZMAT',0)
      If (Run_Mode.ne.S_Mode) Call Put_iArray('BasType',BasisTypes,4)
*                                                                      *
************************************************************************
*                                                                      *
      If (Run_Mode.eq.G_Mode)
     &   Call Put_lScalar('Invert constraints',Invert)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Buffer)
*                                                                      *
************************************************************************
*                                                                      *
      Call Datimx(KWord)
      Header(1)=Title(1)(5:76)
      Write (Header(2),'(4A)')
     &          ' Integrals generated by ',
     &            Vrsn,', ',KWord(1:24)
      Call Put_cArray('Seward Title',Header(1),144)
      If (nTtl>0) Call Put_cArray('SewardXTitle',Title(1),nTtl*80)
*                                                                      *
************************************************************************
*                                                                      *
      If (Run_Mode.eq.G_Mode) Call Put_iScalar('DNG',iDNG)
*                                                                      *
************************************************************************
*                                                                      *
*
      Call mma_deallocate(STDINP)
      Return
6666  Call WarningMessage(2,'Unable to read data from '//KWord)
      call Quit_OnUserError()
      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine SetTargetAccuracy_LDF()
      Implicit None
#include "localdf.fh"
      If (Thr_Accuracy.lt.0.0d0) Call LDF_SetDefaultThrs()
      Return
      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CheckThrs()
      Implicit None
#include "localdf.fh"
      If (Thr_Accuracy.lt.0.0d0) Then
         Call WarningMessage(2,'LDF: Thr_Accuracy<0')
         Call Quit_OnUserError()
      End If
      If (Thr_Prescreen.lt.0.0d0) Then
         Call WarningMessage(2,'LDF: Thr_Prescreen<0')
         Call Quit_OnUserError()
      End If
      Thr_Prescreen=min(Thr_Prescreen,Thr_Accuracy)
      Return
      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_SetOptionFlag(Option,Value)
      Implicit None
      Character*4 Option
      Logical Value
#include "localdf.fh"
      If (Option.eq.'LDF2') Then
         LDF2=Value
      Else If (Option.eq.'CHEC') Then
         CheckPairIntegrals=Value
      Else If (Option.eq.'VERI') Then
         VerifyFit=Value
      Else If (Option.eq.'OVER') Then
         CheckOverlapIntegrals=Value
      Else If (Option.eq.'WRUC') Then
         WriteUnconstrainedC=Value
      Else If (Option.eq.'UNIQ') Then
         UseUniqueAtomPairs=Value
      Else
         Call WarningMessage(2,'LDF_SetOptionFlag: unknown Option')
         Write(6,'(A,A)') 'Option=',Option
         Write(6,'(A,L1)') 'Value=',Value
         Call LDF_Quit(1)
      End If
      Return
      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CheckConfig()
      Implicit None
#include "localdf.fh"
#include "para_info.fh"
      ! Debug write of unconstrained coefficients:
      ! 1) makes no sense for unconstrained LDF => reset
      ! 2) not implemented in parallel => error
      WriteUnconstrainedC=WriteUnconstrainedC .and. LDF_Constraint.ne.-1
#ifdef _MOLCAS_MPP_
      If (WriteUnconstrainedC) Then
         If (nProcs.gt.1 .and. Is_Real_Par()) Then
            Call WarningMessage(2,
     &   'Write unconstrained coefficients not implemented in parallel')
            Call Quit_OnUserError()
         End If
      End If
#endif
      ! Using unique atom pairs is buggy, warn!
      If (UseUniqueAtomPairs) Then
         Call WarningMessage(1,
     &   'WARNING: using unique atom pairs may cause erroneous results')
         Call xFlush(6)
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CLagDXA_DP(iSym,nAS,nAshT,BDER,SDER,DG1,DG2,DF1,DF2,DEPSA,DEASUM,iLo,iHi,jLo,jHi,LDA,G1,G2,SA,SA2,lg_S)

use Index_Functions, only: iTri, nTri_Elem
use SUPERINDEX, only: MTUV
use caspt2_global, only: ipea_shift
use caspt2_module, only: EASUM, EPSA, NTUVES
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
#endif
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSym, nAS, nAshT, iLo, iHi, jLo, jHi, LDA, lg_S
real(kind=wp), intent(in) :: BDER((iHi-iLo+1)*(jHi-jLo+1)), SA((iHi-iLo+1)*(jHi-jLo+1)), SA2((iHi-iLo+1)*(jHi-jLo+1))
real(kind=wp), intent(inout) :: SDER((iHi-iLo+1)*(jHi-jLo+1)), DG1(nAshT,nAshT), DG2(nAshT,nAshT,nAshT,nAshT), DF1(nAshT,nAshT), &
                                DF2(nAshT,nAshT,nAshT,nAshT), DEPSA(nAshT,nAshT), DEASUM, G1(nAshT,nAshT), &
                                G2(nAshT,nAshT,nAshT,nAshT)
integer(kind=iwp) :: iLoS, ISADR, ISADR2, ITABS, ITUV, ITUVABS, iTWV, IUABS, IVABS, iWabs, iWUV, iWYZ, IXABS, iXWZ, IXYZ, IXYZABS, &
                     IYABS, IZABS, jLoS, NROW
real(kind=wp) :: bsBDER, ET, ETU, EU, EX, EY, FACT, ValB, ValS
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iHiS, irank, jHiS
#else
#include "macros.fh"
unused_var(lg_S)
#endif

! LDA == 0, if not parallel; SA is triangular
! LDA /= 0, if parallel    ; SA is square
! In both cases, BDER and SDER are square

ISADR = 0
NROW = 0
iLoS = 0
jLoS = 0
#ifdef _MOLCAS_MPP_
if (is_real_par()) then
  irank = 0
  call GA_Distribution(lg_S,iRank,iLoS,iHiS,jLoS,jHiS)
  NROW = jHiS-jLoS+1 !! = NAS
  call GA_GET(lg_S,jLoS,jHiS,iLoS,iHiS,SA2,NROW)
end if
#endif
do IXYZ=jLo,jHi
  IXYZABS = IXYZ+NTUVES(ISYM)
  IXABS = MTUV(1,IXYZABS)
  IYABS = MTUV(2,IXYZABS)
  IZABS = MTUV(3,IXYZABS)
  EX = EPSA(IXABS)
  EY = EPSA(IYABS)
  do ITUV=iLo,iHi
    ITUVABS = ITUV+NTUVES(ISYM)
    ITABS = MTUV(1,ITUVABS)
    IUABS = MTUV(2,ITUVABS)
    IVABS = MTUV(3,ITUVABS)
    ET = EPSA(ITABS)
    EU = EPSA(IUABS)
    ETU = ET+EU
    FACT = EY+EU+EX+ET-EASUM
    if (LDA == 0) then
      ISADR = 1+iTUV-iLo+NAS*(iXYZ-jLo)
    else
      ISADR = 1+iTUV-iLo+LDA*(iXYZ-jLo)
    end if
    ValB = BDER(ISADR)

    if ((iTUV == iXYZ) .and. (ipea_shift /= Zero)) then
      !! BA in the next equation refers to the active overlap
      ! ipea_shift*Half*BA(ISADR)*(Two-DREF(IDV)+DREF(IDT)+DREF(IDU))
      bsBDER = ipea_shift*Half*ValB
      SDER(iSAdr) = SDER(iSAdr)+bsBDER*(Two+G1(iTabs,iTabs)+G1(iUabs,iUabs)-G1(iVabs,iVabs))
      if (LDA == 0) then
        iSAdr2 = nTri_Elem(iTUV)
      else
        ISADR2 = 1+iTUV-iLo+LDA*(iTUV-jLo)
      end if
      DG1(iTabs,iTabs) = DG1(iTabs,iTabs)+bsBDER*SA(iSAdr2)
      DG1(iUabs,iUabs) = DG1(iUabs,iUabs)+bsBDER*SA(iSAdr2)
      DG1(iVabs,iVabs) = DG1(iVabs,iVabs)-bsBDER*SA(iSAdr2)
    end if

    !! First VALUE contribution in MKBC_DP (FACT)
    SDER(ISADR) = SDER(ISADR)+FACT*ValB
    ValS = SDER(ISADR)

    if (lda == 0) then
      do iWabs=1,nAshT
        !! EU derivative
        iTWV = iTabs+nAshT*(iWabs-1)+nAshT**2*(iVabs-1)
        iSAdr2 = iTri(iTWV,iXYZ)
        DEPSA(iWabs,iUabs) = DEPSA(iWabs,iUabs)+ValB*SA(iSAdr2)

        !! EY derivative
        iXWZ = iXabs+nAshT*(iWabs-1)+nAshT**2*(iZabs-1)
        iSAdr2 = iTri(iTUV,iXWZ)
        DEPSA(iWabs,iYabs) = DEPSA(iWabs,iYabs)+ValB*SA(iSAdr2)

        !! EX derivative
        iWYZ = iWabs+nAshT*(iYabs-1)+nAshT**2*(iZabs-1)
        iSAdr2 = iTri(iTUV,iWYZ)
        DEPSA(iWabs,iXabs) = DEPSA(iWabs,iXabs)+ValB*SA(iSAdr2)

        !! ET derivative
        iWUV = iWabs+nAshT*(iUabs-1)+nAshT**2*(iVabs-1)
        iSAdr2 = iTri(iWUV,iXYZ)
        DEPSA(iWabs,iTabs) = DEPSA(iWabs,iTabs)+ValB*SA(iSAdr2)
      end do
    else
      do iWabs=1,nAshT
        !! EU derivative
        iTWV = iTabs+nAshT*(iWabs-1)+nAshT**2*(iVabs-1)
        ISADR2 = 1+iTWV-jLoS+NROW*(iXYZ-iLoS)
        DEPSA(iWabs,iUabs) = DEPSA(iWabs,iUabs)+ValB*SA2(iSAdr2)

        !! EY derivative
        iXWZ = iXabs+nAshT*(iWabs-1)+nAshT**2*(iZabs-1)
        ISADR2 = 1+iTUV-iLo+LDA*(iXWZ-jLo)
        DEPSA(iWabs,iYabs) = DEPSA(iWabs,iYabs)+ValB*SA(iSAdr2)

        !! EX derivative
        iWYZ = iWabs+nAshT*(iYabs-1)+nAshT**2*(iZabs-1)
        ISADR2 = 1+iTUV-iLo+LDA*(iWYZ-jLo)
        DEPSA(iWabs,iXabs) = DEPSA(iWabs,iXabs)+ValB*SA(iSAdr2)

        !! ET derivative
        iWUV = iWabs+nAshT*(iUabs-1)+nAshT**2*(iVabs-1)
        ISADR2 = 1+iWUV-jLoS+NROW*(iXYZ-iLoS)
        DEPSA(iWabs,iTabs) = DEPSA(iWabs,iTabs)+ValB*SA2(iSAdr2)
      end do
    end if

    if (LDA == 0) iSAdr = iTri(iTUV,iXYZ)
    DEASUM = DEASUM-ValB*SA(iSAdr)

    ! 2dtx ( Fvuyz-Et*Gvuyz )
    ! 2 dtx Gvuyz + 2 dtx dyu Gvz
    if (iTabs == iXabs) then
      !VALUE = VALUE+Four*(FP(IP)-ET*PREF(IP))
      DF2(iVabs,iUabs,iYabs,iZabs) = DF2(iVabs,iUabs,iYabs,iZabs)+Two*ValB
      DG2(iVabs,iUabs,iYabs,iZabs) = DG2(iVabs,iUabs,iYabs,iZabs)-Two*ET*ValB

      !VALUE = VALUE+Four*PREF(IP)
      DG2(iVabs,iUabs,iYabs,iZabs) = DG2(iVabs,iUabs,iYabs,iZabs)+Two*ValS
      !VALUE = VALUE+Two*DREF(ID)
      if (iYabs == iUabs) DG1(iVabs,iZabs) = DG1(iVabs,iZabs)+Two*ValS
    end if
    DEPSA(iTabs,iXabs) = DEPSA(iTabs,iXabs)-Two*ValB*G2(iVabs,iUabs,iYabs,iZabs)

    ! dxu ( -Fvtyz + Eu*Gvtyz )
    ! -dxu Gvtyz -dxu dyt Gvz
    if (iXabs == iUabs) then
      !VALUE = VALUE-Two*(FP(IP)-EU*PREF(IP))
      DF2(iVabs,iTabs,iYabs,iZabs) = DF2(iVabs,iTabs,iYabs,iZabs)-ValB
      DG2(iVabs,iTabs,iYabs,iZabs) = DG2(iVabs,iTabs,iYabs,iZabs)+EU*ValB
      !VALUE = VALUE-Two*PREF(IP)
      DG2(iVabs,iTabs,iYabs,iZabs) = DG2(iVabs,iTabs,iYabs,iZabs)-ValS
      !VALUE = VALUE-DREF(ID)
      if (iYabs == iTabs) DG1(iVabs,iZabs) = DG1(iVabs,iZabs)-ValS
    end if
    DEPSA(iXabs,iUabs) = DEPSA(iXabs,iUabs)+ValB*G2(iVabs,iTabs,iYabs,iZabs)

    ! dyt ( -Fvuxz + Et*Gvuxz +dxu (-Fvz+(Et+Eu)*Gvz))
    ! -dyt Gvuxz
    if (iYabs == iTabs) then
      !VALUE = VALUE-Two*(FP(IP)-ET*PREF(IP))
      DF2(iVabs,iUabs,iXabs,iZabs) = DF2(iVabs,iUabs,iXabs,iZabs)-ValB
      DG2(iVabs,iUabs,iXabs,iZabs) = DG2(iVabs,iUabs,iXabs,iZabs)+ET*ValB
      if (iXabs == iUabs) then
        !VALUE = VALUE-(FD(ID)-ETU*DREF(ID))
        DF1(iVabs,iZabs) = DF1(iVabs,iZabs)-ValB
        DG1(iVabs,iZabs) = DG1(iVabs,iZabs)+ETU*ValB
      end if

      !VALUE = VALUE-Two*PREF(IP)
      DG2(iVabs,iUabs,iXabs,iZabs) = DG2(iVabs,iUabs,iXabs,iZabs)-ValS
    end if
    DEPSA(iYabs,iTabs) = DEPSA(iYabs,iTabs)+ValB*G2(iVabs,iUabs,iXabs,iZabs)
    if (iYabs == iTabs) DEPSA(iXabs,iUabs) = DEPSA(iXabs,iUabs)+ValB*G1(iVabs,iZabs)
    if (iXabs == iUabs) DEPSA(iYabs,iTabs) = DEPSA(iYabs,iTabs)+ValB*G1(iVabs,iZabs)

    ! -dyu Gvzxt
    if (iYabs == iUabs) then
      !VALUE = VALUE-Two*(FP(IP)-EU*PREF(IP))
      DF2(iVabs,iZabs,iXabs,iTabs) = DF2(iVabs,iZabs,iXabs,iTabs)-ValB
      DG2(iVabs,iZabs,iXabs,iTabs) = DG2(iVabs,iZabs,iXabs,iTabs)+EU*ValB
      if (iXabs == iTabs) then
        !VALUE = VALUE+Two*(FD(ID)-ETU*DREF(ID))
        DF1(iVabs,iZabs) = DF1(iVabs,iZabs)+Two*ValB
        DG1(iVabs,iZabs) = DG1(iVabs,iZabs)-Two*ETU*ValB
      end if

      !VALUE = VALUE-Two*PREF(IP)
      DG2(iVabs,iZabs,iXabs,iTabs) = DG2(iVabs,iZabs,iXabs,iTabs)-ValS
    end if
    DEPSA(iYabs,iUabs) = DEPSA(iYabs,iUabs)+ValB*G2(iVabs,iZabs,iXabs,iTabs)
    if (iYabs == iUabs) DEPSA(iXabs,iTabs) = DEPSA(iXabs,iTabs)-Two*ValB*G1(iVabs,iZabs)
    if (iXabs == iTabs) DEPSA(iYabs,iUabs) = DEPSA(iYabs,iUabs)-Two*ValB*G1(iVabs,iZabs)
  end do
# ifdef _MOLCAS_MPP_
  if (is_real_par() .and. (IXYZ == iHiS) .and. (iRank /= NPROCS-1)) then
    irank = irank+1
    call GA_Distribution(lg_S,iRank,iLoS,iHiS,jLoS,jHiS)
    call GA_GET(lg_S,jLoS,jHiS,iLoS,iHiS,SA2,NROW)
  end if
# endif
end do

return

end subroutine CLagDXA_DP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_PFake_VDist()
C
C     Author: Thomas Bondo Pedersen, April 2007.
C     Purpose: fake parallel distribution of vectors.
C
      Implicit None
#include "cholesky.fh"
#include "choptr.fh"
#include "choglob.fh"
#include "WrkSpc.fh"
#include "cho_para_info.fh"

      Character*15 SecNam
      Parameter (SecNam = 'Cho_PFake_VDist')

      Integer iSym
      Integer ip_IDV, l_IDV
      Integer ip_Wrk, l_Wrk
      Integer ip_InfV, l_InfV
      Integer iRedC, iV, nV
      Integer kOff, nRead

      Integer i, j
      Integer InfV
      InfV(i,j)=iWork(ip_InfV-1+2*(j-1)+i)

C     Return if nothing to do.
C     ------------------------

      If (nProcs.eq.1 .or. .not.Is_Real_Par()) Return ! serial run
      If (.not.CHO_FAKE_PAR) Return ! true parallel run

C     Memory allocation.
C     ------------------

      l_InfV = 2*(MaxVec+1)
      l_IDV = MaxVec
      Call GetMem('InfV_','Allo','Inte',ip_InfV,l_InfV)
      Call GetMem('IDV_','Allo','Inte',ip_IDV,l_IDV)
      Call GetMem('MAX_','Max ','Real',ip_Wrk,l_Wrk)
      Call GetMem('Wrk_','Allo','Real',ip_Wrk,l_Wrk)

C     Distribute vectors in each symmetry:
C     read from LuCho files; put into LuCho_G files.
C     ----------------------------------------------

      iRedC = -1
      Do iSym = 1,nSym
         Call iZero(iWork(ip_InfV),l_InfV)
         nV = 0
         Call Cho_Distrib_Vec(1,NumCho(iSym),iWork(ip_IDV),nV)
         iV = 0
         Do While (iV .lt. nV)
            nRead = 0
            Call Cho_PFake_GetVec(Work(ip_Wrk),l_Wrk,
     &                            iWork(ip_IDV+iV),nV-iV,
     &                            iWork(ip_InfV+2*iV),
     &                            iSym,nRead,iRedC)
            If (nRead .lt. 1) Then
               Call Cho_Quit('Insufficient memory in '//SecNam,101)
            End If
            Call Cho_PFake_PutVec(Work(ip_Wrk),iWork(ip_InfV),nRead,
     &                            iSym,iV+1)
            iV = iV + nRead
         End Do
#if defined (_DEBUGPRINT_)
         If (iV .ne. nV) Then
            Call Cho_Quit('Logical error in '//SecNam,103)
         End If
#endif
         kOff = ip_InfVec - 1 + MaxVec*InfVec_N2*(iSym-1) + MaxVec*2
         Do iV = 1,nV
            iWork(kOff+iV) = InfV(2,iV)
         End Do
      End Do

C     Deallocation.
C     -------------

      Call GetMem('Wrk_','Free','Real',ip_Wrk,l_Wrk)
      Call GetMem('IDV_','Free','Inte',ip_IDV,l_IDV)
      Call GetMem('InfV_','Free','Inte',ip_InfV,l_InfV)

      End
      SubRoutine Cho_PFake_GetVec(Vec,lVec,IDV,lIDV,InfV,iSym,nRead,
     &                            iRedC)
      Implicit None
      Integer lVec, lIDV
      Real*8  Vec(lVec)
      Integer IDV(lIDV)
      Integer InfV(2,*)
      Integer iSym, nRead, iRedC

      Character*16 SecNam
      Parameter (SecNam = 'Cho_PFake_GetVec')

      Integer ipV, Mem, iVec, n, m

      nRead = 0
      ipV = 1
      Mem = lVec
      Do iVec = 1,lIDV
         n = 0
         m = 0
         Call Cho_VecRd(Vec(ipV),Mem,IDV(iVec),IDV(iVec),iSym,
     &                  n,iRedC,m)
         If (n .eq. 1) Then
            nRead = nRead + 1
            ipV = ipV + m
            Mem = Mem - m
            InfV(1,iVec) = m
         Else If (n .eq. 0) Then
            Return
         Else
            Call Cho_Quit('Logical error in '//SecNam,103)
         End If
      End Do

      End
      SubRoutine Cho_PFake_PutVec(Vec,InfV,nVec,iSym,iV1)
      Implicit None
      Real*8 Vec(*)
      Integer InfV(2,*)
      Integer nVec, iSym, iV1
#include "cholesky.fh"
#include "choglob.fh"

      Character*16 SecNam
      Parameter (SecNam = 'Cho_PFake_PutVec')

      Integer iOpt, lTot, iAdr
      Integer iVec, iPos

      If (nVec .lt. 1) Return

      If (CHO_ADRVEC .eq. 1) Then
         iOpt = 1
         lTot = InfV(1,iV1)
         Do iVec = iV1+1,iV1+nVec-1
            lTot = lTot + InfV(1,iVec)
         End Do
         iAdr = InfV(2,iV1)
         Call dDAFile(LuCho_G(iSym),iOpt,Vec,lTot,iAdr)
         Do iVec = iV1+1,iV1+nVec
            InfV(2,iVec) = InfV(2,iVec-1) + InfV(1,iVec-1)
         End Do
      Else If (CHO_ADRVEC .eq. 2) Then
         iPos = 1
         Do iVec = iV1,iV1+nVec-1
            iOpt = 1
            lTot = InfV(1,iVec)
            iAdr = InfV(2,iVec)
            Call dDAFile(LuCho_G(iSym),iOpt,Vec(iPos),lTot,iAdr)
            iPos = iPos + InfV(1,iVec)
            InfV(2,iVec+1) = iAdr
         End Do
      Else
         Call Cho_Quit('Illegal CHO_ADRVEC in '//SecNam,102)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine REFORM_CONF_OCC(IOCC_EXP,IOCC_PCK,NEL,NOCOB)
! Reform between two ways of writing occupations
!
! IOCC_EXP : Occupation in expanded form, i.e. the orbital for each
!            electron is given
!
! IOCC_PCK  : Occupation is given in packed form, i.e. each occupied
!             orbitals is given once, and a negative index indicates
!             a double occupation
!
! Expanded to Packed form
!
! Jeppe Olsen, Nov. 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NEL, IOCC_EXP(NEL), NOCOB
integer(kind=iwp), intent(out) :: IOCC_PCK(NOCOB)
integer(kind=iwp) :: IEL, IOCC

! Expanded => Packed form

! Loop over electrons
IEL = 1
IOCC = 0
do
  !IEL = IEL+1
  if (IEL < NEL) then
    if (IOCC_EXP(IEL) == IOCC_EXP(IEL+1)) then
      IOCC = IOCC+1
      IOCC_PCK(IOCC) = -IOCC_EXP(IEL)
      IEL = IEL+2
    else
      IOCC = IOCC+1
      IOCC_PCK(IOCC) = IOCC_EXP(IEL)
      IEL = IEL+1
    end if
  else
    ! Last occupation was not identical to previous, so single occupied
    IOCC = IOCC+1
    IOCC_PCK(IOCC) = IOCC_EXP(IEL)
    IEL = IEL+1
  end if
  if (IEL > NEL) exit
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Reforming form of configuration'
write(u6,*) ' Expanded to packed form'
write(u6,*) ' IOCC_EXP :'
call IWRTMA(IOCC_EXP,1,NEL,1,NEL)
write(u6,*) ' IOCC_PCK :'
call IWRTMA(IOCC_PCK,1,NOCOB,1,NOCOB)
#endif

end subroutine REFORM_CONF_OCC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Giovanni Li Manni                                *
!***********************************************************************

subroutine DecoMat(MAT,dimens,eigenvec,NumV,rc)
!************ by G. Li Manni Stuttgart March 2016 *************
!
! MAT:      copy of the D1A matrix (1RDM) in AO basis.
!           It will be destroyed in eigen_molcas
!
! DIMENS:   dimension of the square MAT = nbas(isym)
!
! EIGENVEC: First it is used as scratch inside eigen_molcas. Next it will contains eigenvectors
!           of the eigen-decomposed matrix in Cholesky form. Instead of eigenvectors X such that MAT = XDX^t,
!           eigenvectors are presented as Y = X(D**0.5) such that MAT = YY^t.
!           Negative eigenvalues are set to zero and eigenvalue larger than 2.0 set to 2.0
!
! NUMV    : Number of non negative eigenvalues

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dimens
real(kind=wp), intent(inout) :: MAT(dimens,dimens), eigenvec(dimens,dimens)
integer(kind=iwp), intent(out) :: NumV, rc
integer(kind=iwp) :: j
real(kind=wp), allocatable :: eigenval(:)

rc = 0
NumV = 0

if (dimens < 1) then
  rc = -1
  write(u6,*) 'matrix size < 1'
else

  ! Step 1: diagonalize MAT. MAT is destroyed and replaced by the eigenvectors values.
  ! IMPORTANT: At this stage eigenvec is used as scratch.
  call mma_allocate(eigenval,dimens,Label='eigenval')
  call eigen_molcas(dimens,MAT,eigenval,eigenvec)
  ! Move MAT to eigenvec. where it belongs. I could not wait!
  eigenvec(:,:) = MAT(:,:)
  ! Set to zero negative eigenvalue and to TWO values larger than 2.0.
  ! Count only the positive ones (counter NumV)
  do j=1,dimens
    if (eigenval(j) > 1.0e-12_wp) then
      NumV = NumV+1
      if (eigenval(j) > Two) eigenval(j) = Two
    else
      eigenval(j) = Zero
    end if
  end do
  ! Sort eigenvalues in decreasing order of occupation number
  call IncrSort(eigenval,eigenvec,dimens)
  ! Compute sqrt(eigenvalues)
  eigenval(:) = sqrt(eigenval(:))
  ! Generate Y = X(D**0.5)
  do j=1,dimens
    eigenvec(:,j) = eigenvec(:,j)*eigenval(j)
  end do
  call mma_deallocate(eigenval)

end if

return

end subroutine DecoMat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Giovanni Ghigo                                   *
************************************************************************
      Subroutine MkExSB33(iAddSB,LenSB,
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden & Torino University, Italy         *
*           Jannuary February 2005                                     *
*----------------------------------------------------------------------*
* Purpuse:  Generation of the SubBlock(3,3) (p,q secondary) of the     *
*           two-electron integral matrix for each i,j occupied couple. *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Logical SameLx

*   - SubBlock 3 3
      LenSB = nSsh(iSymA) * nSsh(iSymB)
      Call GetMem('SB','Allo','Real',iAddSB,LenSB)

*     Build Lx
      Call GetMem('Lx','Allo','Real',iAddLx0,nSsh(iSymA)*numV)
      LxType=0
      iIx=0
      SameLx=.False.
      Call MkL3(iSymA,iSymI,iI,numV, LxType,iIx, iAddLx0,SameLx)

*     Build Ly
      Call GetMem('Ly','Allo','Real',iAddLy0,nSsh(iSymB)*numV)
      If(iSymA.EQ.iSymB) SameLx=.True.
      Call MkL3(iSymB,iSymJ,iJ,numV, LxType,iIx, iAddLy0,SameLx)

*     Generate the SubBlock
      If (.NOT.SameLx) then
        Call DGEMM_('N','T',nSsh(iSymB),nSsh(iSymA),numV,1.0d0,
     &    Work(iAddLy0),nSsh(iSymB), Work(iAddLx0),nSsh(iSymA),
     &                     0.0d0,Work(iAddSB),nSsh(iSymB) )
      else
        Call DGEMM_('N','T',nSsh(iSymA),nSsh(iSymA),numV,1.0d0,
     &    Work(iAddLx0),nSsh(iSymA), Work(iAddLx0),nSsh(iSymA),
     &                     0.0d0,Work(iAddSB),nSsh(iSymA) )
      EndIf

      Call GetMem('Ly','Free','Real',iAddLy0,nSsh(iSymB)*numV)
      Call GetMem('Lx','Free','Real',iAddLx0,nSsh(iSymA)*numV)

      Return
      End

      Subroutine MkCouSB33(iAddSB,LenSB,
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden & Torino University, Italy         *
*           July 2005                                                  *
*----------------------------------------------------------------------*
* Purpuse:  Generation of the SubBlock(3,3) (p,q secondary) of the     *
*           two-electron integral matrix for each i,j occupied couple. *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"

*   - SubBlock 3 3
      LenSB = nSsh(iSymA) * nSsh(iSymB)
      Call GetMem('SB','Allo','Real',iAddSB,LenSB)

*     Define Lab
      iAddAB = iMemTCVX(6,iSymA,iSymB,1)
      LenAB  = LenSB
CGG   ------------------------------------------------------------------
c      If(IfTest) then
c      Write(6,*)'     MkCouSB33: TCVF(',iSymA,',',iSymB,')'
c      Write(6,'(8F10.6)')(Work(iAddAB+k),k=0,LenAB*numV-1)
c      Call XFlush(6)
c      EndIf
CGG   ------------------------------------------------------------------

*     Build Lij
      LenLij = numV
      Call GetMem('Lij','Allo','Real',iAddLij,LenLij)
      Call MkLij(iSymI,iSymJ,iI,iJ,numV, iAddLij)

*     Generate the SubBlock
      Call DGEMM_('N','N',LenAB,1,numV,1.0d0,
     &    Work(iAddAB),LenAB, Work(iAddLij),LenLij,
     &                0.0d0,Work(iAddSB),LenSB )

      Call GetMem('Lij','Free','Real',iAddLij,LenLij)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!               Markus P. Fuelscher                                    *
!***********************************************************************

subroutine DmpInf()
!***********************************************************************
!                                                                      *
! Object: to dump all input information on the file INFO.              *
!                                                                      *
! Called from: Seward                                                  *
!                                                                      *
! Calling    :                                                         *
!              Put_dArray                                              *
!              Get_dArray                                              *
!              Put_iArray                                              *
!              Get_iArray                                              *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January 1992                                             *
!                                                                      *
! modified by M.P. Fuelscher                                           *
! - changed to used communication file                                 *
!***********************************************************************

use External_Centers, only: External_Centers_Dmp
use Basis_Info, only: Basis_Info_Dmp
use Center_Info, only: Center_Info_Dmp
use Symmetry_Info, only: Symmetry_Info_Dmp
use SOAO_Info, only: SOAO_Info_Dmp
use Sizes_of_Seward, only: Size_Dmp
use DKH_Info, only: DKH_Info_Dmp
use Gateway_Info, only: Gateway_Info_Dmp
use RICD_Info, only: RICD_Info_Dmp
use nq_Info, only: NQ_Info_Dmp
use rctfld_module, only: PCM_Info_Dmp
use Gateway_Info, only: Gateway_Info_Dmp

implicit none

!                                                                      *
!***********************************************************************
!                                                                      *
call SOAO_Info_Dmp()
call Basis_Info_Dmp()
call Center_Info_Dmp()
call Symmetry_Info_Dmp()
call Size_Dmp()
call DKH_Info_Dmp()
call Gateway_Info_Dmp()
call RICD_Info_Dmp()
!                                                                      *
!***********************************************************************
!                                                                      *
! Reaction field parameters

call PCM_Info_Dmp()
!                                                                      *
!***********************************************************************
!                                                                      *
call NQ_Info_Dmp()
!                                                                      *
!***********************************************************************
!                                                                      *
call External_Centers_Dmp()
!                                                                      *
!***********************************************************************
!                                                                      *
call DMP_EFP()
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine DmpInf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! s-s interaction, with too small exponent difference.
function CoulT0_1(Rho,dSepInv,Expo)

use Constants, only: One, Three, Four, Six, Eight, Eleven
use Definitions, only: wp

implicit none
real(kind=wp) :: CoulT0_1
real(kind=wp), intent(in) :: Rho, dSepInv, Expo
real(kind=wp) :: T1, T2, T3, T4

T1 = One
T2 = (Eleven/Eight)*Rho
T3 = (Three/Four)*Rho**2
T4 = (One/Six)*Rho**3
CoulT0_1 = dSepInv*(One-(T1+T2+T3+T4)*Expo)

return

end function CoulT0_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine defvhlp52 (r1,r2,v,dimr1a,dimr1b,dimr1c,
     & dimva,dimvb,dimvc,adda,addb,addc)
c
c     this routine do
c     V(a,b,c)xxx = R1(a,b,c)-R2(b,a,c) x=a,b
c     for syma>symc, symb<symc, (syma>symb)
c
c     r1        - r1 matrix (I)
c     r2        - r2 matrix (I)
c     v        - v matrix (O)
c     dimr1a         - dimension of a in R (I)
c     dimr1b         - dimension of b in R (I)
c     dimr1c         - dimension of c in R (I)
c     dimva        - dimension of a in V (I)
c     dimvb        - dimension of b in V (I)
c     dimvc        - dimension of c in V (I)
c     adda    - additional constat to a (I)
c     addb    - additional constat to b (I)
c     addc    - additional constat to c (I)
c
#include "t31.fh"
       integer dimr1a,dimr1b,dimr1c
       integer dimva,dimvb,dimvc,adda,addb,addc
       real*8 r1(1:dimr1a,1:dimr1c,1:dimr1b)
       real*8 r2(1:dimr1b,1:dimr1a,1:dimr1c)
       real*8 v(1:dimva,1:dimvb,1:dimvc)
c
c     help variables
c
       integer a,b,c,br1,cr1,br2,cr2
c
c
       do 100 b=1,dimvb
       br1=b+addb
       do 101 c=1,dimvc
       cr1=c+addc
       do 102 a=1,dimva
       v(a,b,c)=r1(a+adda,cr1,br1)
 102    continue
 101    continue
 100    continue
c
       do 200 c=1,dimvc
       cr2=c+addc
       do 201 b=1,dimvb
       br2=b+addb
       do 202 a=1,dimva
       v(a,b,c)=v(a,b,c)-r2(br2,a+adda,cr2)
 202    continue
 201    continue
 200    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine Assg1_mck(g1,nT,nRys,la,lb,lc,ld,xyz2D0,xyz2D1,
     &                 IfGrad,Index,mVec,Index2)
************************************************************************
*                                                                      *
* Object: to assemble the gradients of the ERI's.                      *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
c#include "print.fh"
#include "real.fh"
#include "itmax.fh"
#include "iavec.fh"
      Real*8 g1(nT,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,
     &             (lc+1)*(lc+2)/2,(ld+1)*(ld+2)/2,9),
     &       xyz2D0(nRys,nT,0:la+2,0:lb+2,0:lc+2,0:ld+2,3),
     &       xyz2D1(nRys,nT,0:la  ,0:lb  ,0:lc  ,0:ld  ,9)
      Logical IfGrad(3,4)
      Integer Ind1(3), Ind2(3), Index(3,4),Index2(3,4)
*
*     Statement functions
*
      nElem(i) = (i+1)*(i+2)/2
*
      ka=(la+1)*(la+2)/2
      kb=(lb+1)*(lb+2)/2
      kc=(lc+1)*(lc+2)/2
      kd=(ld+1)*(ld+2)/2
      nG1=nT*9*ka*kb*kc*kd
      call dcopy_(nG1,[Zero],0,G1,1)
      Call ICOPY(12,[0],0,Index2,1)
*
      ii = la*(la+1)*(la+2)/6
      jj = lb*(lb+1)*(lb+2)/6
      kk = lc*(lc+1)*(lc+2)/6
      ll = ld*(ld+1)*(ld+2)/6
*
      Do 100 ipa = 1, nElem(la)
         ipaii=ipa+ii
         ixa = ixyz(1,ipaii)
         iya = ixyz(2,ipaii)
         iza = ixyz(3,ipaii)
*
      Do 200 ipb = 1, nElem(lb)
         ipbjj=ipb+jj
         ixb = ixyz(1,ipbjj)
         iyb = ixyz(2,ipbjj)
         izb = ixyz(3,ipbjj)
*
         ixab = ixa + ixb
         iyab = iya + iyb
         izab = iza + izb
*
      Do 300 ipc = 1, nElem(lc)
         ipckk=ipc+kk
         ixc = ixyz(1,ipckk)
         iyc = ixyz(2,ipckk)
         izc = ixyz(3,ipckk)
*
         ixabc = ixab + ixc
         iyabc = iyab + iyc
         izabc = izab + izc
*
      Do 400 ipd = 1, nElem(ld)
         ipdll=ipd+ll
         ixd = ixyz(1,ipdll)
         iyd = ixyz(2,ipdll)
         izd = ixyz(3,ipdll)
*
         ixabcd = ixabc + ixd
         iyabcd = iyabc + iyd
         izabcd = izabc + izd
*
*        Compute all desired gradients with respect to an x-component.
*
         mVec = 0
         nVec = 0
         Do 1000 iCent = 1, 4
            If (IfGrad(1,iCent)) Then
               mVec = mVec + 1
               nVec = nVec + 1
               Ind1(nVec) = 3*(Index(1,iCent)-1) + 1
               Ind2(nVec) = mVec
               Index2(1,iCent)=mVec
            End If
 1000    Continue
*
         If (iyabcd.ne.0) Then
*
         If (nVec.eq.3) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               tmp3=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2) *
     &                  xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(2))
                  tmp3 = tmp3 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(3))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
               g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) + tmp3
            End Do
         Else If (nVec.eq.2) Then
            Do iT = 1, nT
               tmp1 = 0.0D0
               tmp2 = 0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2) *
     &                  xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(2))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
            End Do
         Else If (nVec.eq.1) Then
            Do iT = 1, nT
               tmp1 = 0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2) *
     &                  xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
            End Do
         End If
*
         Else
*
         If (nVec.eq.3) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               tmp3=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(2))
                  tmp3 = tmp3 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(3))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
               g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) + tmp3
            End Do
         Else If (nVec.eq.2) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(2))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
            End Do
         Else If (nVec.eq.1) Then
            Do iT = 1, nT
               tmp1=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
            End Do
         End If
*
         End If
*
*        Compute all desired gradients with respect to an y-component.
*
         nVec = 0
         Do 2000 iCent = 1, 4
            If (IfGrad(2,iCent)) Then
               mVec = mVec + 1
               nVec = nVec + 1
               Ind1(nVec) = 3*(Index(2,iCent)-1) + 2
               Ind2(nVec) = mVec
               Index2(2,iCent)=mVec
            End If
 2000    Continue
*
         If (ixabcd.ne.0) Then
*
         If (nVec.eq.3) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               tmp3=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1) *
     &                  xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(2))
                  tmp3 = tmp3 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(3))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
               g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) + tmp3
            End Do
         Else If (nVec.eq.2) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1) *
     &                  xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(2))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
            End Do
         Else If (nVec.eq.1) Then
            Do iT = 1, nT
               tmp1 = 0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1) *
     &                  xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
            End Do
         End If
*
         Else
*
         If (nVec.eq.3) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               tmp3=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(2))
                  tmp3 = tmp3 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(3))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
               g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) + tmp3
            End Do
         Else If (nVec.eq.2) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(2))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
            End Do
         Else If (nVec.eq.1) Then
            Do iT = 1, nT
               tmp1 = 0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
            End Do
         End If
*
         End If
*
*        Compute all desired gradients with respect to an z-component.
*
         nVec = 0
         Do 3000 iCent = 1, 4
            If (IfGrad(3,iCent)) Then
               mVec = mVec + 1
               nVec = nVec + 1
               Ind1(nVec) = 3*(Index(3,iCent)-1) + 3
               Ind2(nVec) =  mVec
               Index2(3,iCent)=mVec
            End If
 3000    Continue
*
         If (ixabcd*iyabcd.ne.0) Then
*
         If (nVec.eq.3) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               tmp3=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1) *
     &                  xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                  tmp3 = tmp3 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(3))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
               g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) + tmp3
            End Do
         Else If (nVec.eq.2) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1) *
     &                  xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
            End Do
         Else If (nVec.eq.1) Then
            Do iT = 1, nT
               tmp1=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1) *
     &                  xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
            End Do
         End If
*
         Else If (ixabcd.eq.0.and.iyabcd.ne.0) Then
*
         If (nVec.eq.3) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               tmp3=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                  tmp3 = tmp3 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(3))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
               g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) + tmp3
            End Do
         Else If (nVec.eq.2) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
            End Do
         Else If (nVec.eq.1) Then
            Do iT = 1, nT
               tmp1=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
            End Do
         End If
*
         Else If (iyabcd.eq.0.and.ixabcd.ne.0) Then
*
         If (nVec.eq.3) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               tmp3=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                  tmp3 = tmp3 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(3))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
               g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) + tmp3
            End Do
         Else If (nVec.eq.2) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
            End Do
         Else If (nVec.eq.1) Then
            Do iT = 1, nT
               tmp1=0.0D0
               Do iRys = 1, nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)
                  tmp1 = tmp1 + tmp *
     &                  xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
            End Do
         End If
*
         Else
*
         If (nVec.eq.3) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               tmp3=0.0D0
               Do iRys = 1, nRys
                  tmp1 = tmp1 + xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2 + xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                  tmp3 = tmp3 + xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(3))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
               g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) + tmp3
            End Do
         Else If (nVec.eq.2) Then
            Do iT = 1, nT
               tmp1=0.0D0
               tmp2=0.0D0
               Do iRys = 1, nRys
                  tmp1 = tmp1 + xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2 + xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
               g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) + tmp2
            End Do
         Else If (nVec.eq.1) Then
            Do iT = 1, nT
               tmp1=0.0D0
               Do iRys = 1, nRys
                  tmp1 = tmp1 + xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
               End Do
               g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) =
     &                    g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) + tmp1
            End Do
         End If
*
         End If
*
 400  Continue
*
 300  Continue
*
 200  Continue
*
 100  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombOnly0_(Mode,nD,FactC,ip_DBlocks,ip_VBlocks,ip_FBlocks)
! Thomas Bondo Pedersen, September 2010.
!
!          OLD CODE
!
! Purpose: Compute Coulomb contributions to the Fock matrix using
!          Coulomb intermediates V.
!
! See LDF_Fock_CoulombOnly for an outline of the algorithm.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Mode, nD, ip_DBlocks(nD), ip_VBlocks(nD), ip_FBlocks(nD)
real(kind=wp), intent(in) :: FactC(nD)
integer(kind=iwp) :: l_WBlkP, iD, TaskListID, AB, CD, l, A, B, nuv, M, ipW, ipF
integer(kind=iwp), allocatable :: WBlkP(:)
real(kind=wp), allocatable :: C_AB(:)
character(len=*), parameter :: SecNam = 'LDF_Fock_CoulombOnly0_'
logical(kind=iwp), external :: Rsv_Tsk
integer(kind=iwp), external :: LDF_nBas_Atom, LDF_nBasAux_Pair
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

! Allocate and initialize W intermediates
l_WBlkP = nD
call mma_allocate(WBlkP,l_WBlkP,label='WBlk_P')
do iD=1,nD
  call LDF_AllocateBlockVector('Win',WBlkP(iD))
  call LDF_ZeroBlockVector(WBlkP(iD))
end do

if ((Mode == 1) .or. (Mode == 3)) then
  ! Parallel loop over atom pairs AB (A>=B)
  call Init_Tsk(TaskListID,NumberOfAtomPairs)
  do while (Rsv_Tsk(TaskListID,AB))
    ! Serial loop over atom pairs CD (C>=D)
    do CD=1,NumberOfAtomPairs
      ! F(u_A v_B) = F(u_A v_B) + sum_[K_CD] (u_A v_B | K_CD)*V(K_CD)
      call LDF_Fock_CoulombOnly0_1(nD,FactC,ip_VBlocks,ip_FBlocks,AB,CD)
      ! W(J_AB) = W(J_AB) + sum_[k_C l_D] (J_AB | k_C l_D)*D(k_C l_D)
      call LDF_Fock_CoulombOnly0_2(nD,ip_DBlocks,WBlkP,AB,CD)
      if (Mode == 1) then
        ! W(J_AB) = W(J_AB) - sum_[K_CD] (J_AB | K_CD)*V(K_CD)
        call LDF_Fock_CoulombOnly0_3(-One,nD,ip_VBlocks,WBlkP,AB,CD)
      end if
    end do ! end serial loop over atom pairs CD
    ! F(u_A v_B) = F(u_A v_B) + sum_[J_AB] C(u_A v_B,J_AB)*W(J_AB)
    A = iWork(ip_AP_Atoms-1+2*(AB-1)+1)
    B = iWork(ip_AP_Atoms-1+2*(AB-1)+2)
    nuv = LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
    M = LDF_nBasAux_Pair(AB)
    l = nuv*M
    call mma_allocate(C_AB,l,label='C_AB')
    call LDF_CIO_ReadC(AB,C_AB,l)
    do iD=1,nD
      ipF = iWork(ip_FBlocks(iD)-1+AB)
      ipW = iWork(WBlkP(iD)-1+AB)
      call dGeMV_('N',nuv,M,FactC(iD),C_AB,nuv,Work(ipW),1,One,Work(ipF),1)
    end do
    call mma_deallocate(C_AB)
  end do ! end parallel loop over atom pairs AB
  call Free_Tsk(TaskListID)
else if (Mode == 2) then ! non-robust fitting
  ! Parallel loop over atom pairs AB (A>=B)
  call Init_Tsk(TaskListID,NumberOfAtomPairs)
  do while (Rsv_Tsk(TaskListID,AB))
    ! Serial loop over atom pairs CD (C>=D)
    do CD=1,NumberOfAtomPairs
      ! W(J_AB) = W(J_AB) + sum_[K_CD] (J_AB | K_CD)*V(K_CD)
      call LDF_Fock_CoulombOnly0_3(One,nD,ip_VBlocks,WBlkP,AB,CD)
    end do ! end serial loop over atom pairs CD
    ! F(u_A v_B) = F(u_A v_B) + sum_[J_AB] C(u_A v_B,J_AB)*W(J_AB)
    A = iWork(ip_AP_Atoms-1+2*(AB-1)+1)
    B = iWork(ip_AP_Atoms-1+2*(AB-1)+2)
    nuv = LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
    M = LDF_nBasAux_Pair(AB)
    l = nuv*M
    call mma_allocate(C_AB,l,label='C_AB')
    call LDF_CIO_ReadC(AB,C_AB,l)
    do iD=1,nD
      ipF = iWork(ip_FBlocks(iD)-1+AB)
      ipW = iWork(WBlkP(iD)-1+AB)
      call dGeMV_('N',nuv,M,FactC(iD),C_AB,nuv,Work(ipW),1,One,Work(ipF),1)
    end do
    call mma_deallocate(C_AB)
  end do ! end parallel loop over atom pairs AB
  call Free_Tsk(TaskListID)
else
  write(u6,'(A,A,I6)') SecNam,': unknown Mode:',Mode
  call LDF_NotImplemented()
end if

#ifdef _MOLCAS_MPP_
! Add F over nodes
do iD=1,nD
  call LDF_P_AddBlockMatrix(ip_FBlocks(iD))
end do
#endif

! Deallocate W intermediates
do iD=1,nD
  call LDF_DeallocateBlockVector('Win',WBlkP(iD))
end do
call mma_deallocate(WBlkP)

end subroutine LDF_Fock_CoulombOnly0_

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2000, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Init_PCM(NonEq,iCharg)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!                                                                      *
!             Modified for Langevin polarizabilities, March 2000 (RL)  *
!***********************************************************************

use PCM_arrays, only: Centr, DCntr, dPnt, dRad, dTes, IntSph, MxVert, NewSph, nVert, PCM_n, PCM_SQ, PCMDm, PCMiSph, PCMSph, &
                      PCMTess, SSPh, Vert
use Isotopes, only: MaxAtomNum, PTab
use UnixInfo, only: ProgName
use rctfld_module, only: DoDeriv, iCharge_Ref, iSlPar, NoNEQ_Ref, nPCM_Info, nS, nTs, PCM, PCM_Info_Dmp
use Molcas, only: MxAtom
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
logical(kind=iwp), intent(in) :: NonEq
integer(kind=iwp), intent(inout) :: iCharg
character(len=2) ::Elements(MxAtom*8)
integer(kind=iwp) :: i, iPrint, j, lCnAtm, nAtoms
real(kind=wp), allocatable :: Coor(:,:), LcCoor(:,:)
integer(kind=iwp), allocatable :: ANr(:), LcANr(:)

if (.not. PCM) return
!                                                                      *
!***********************************************************************
!                                                                      *
! Reinitialize always for gradient calculations

DoDeriv = .false.
!pcm_solvent
! added mckinley for pcm in second derivatives
if ((ProgName == 'alaska') .or. (ProgName == 'mckinley') .or. (ProgName == 'mclr')) DoDeriv = .true.
!pcm_solvent end
if (DoDeriv) then
  LcNAtm = ISlPar(42)
  call mma_allocate(dTes,nTs,lcNAtm,3,Label='dTes')
  call mma_allocate(dPnt,nTs,lcNAtm,3,3,Label='dPnt')
  call mma_allocate(dRad,nS,lcNAtm,3,Label='dRad')
  call mma_allocate(dCntr,nS,lcNAtm,3,3,Label='dCntr')
  call mma_allocate(PCM_SQ,2,nTs,Label='PCM_SQ')
  call Get_dArray('PCM Charges',PCM_SQ,2*nTs)
else
  !                                                                      *
  !***********************************************************************
  !                                                                      *
  ! Check if we have retrievable PCM data

  call Get_iScalar('PCM info length',nPCM_info)
  if (nPCM_info /= 0) then

    ! nonequilibrium model for the case of ionization:
    ! redo PCM initiation but with the fake charge corresponding to
    ! the one of the ground (reference) state
    if ((iCharge_ref < iCharg) .and. NonEq) then
      iCharg = iCharge_ref
    else if ((iCharge_ref == iCharg) .and. (NonEq_ref .eqv. NonEq)) then
      ! If charge or NonEq/Eq status in retrieved data not the same as
      ! for request redo the PCM initiation.

      ! Evolving the new code

      call mma_allocate(PCMSph,4,NS,Label='PCMSph')
      call mma_allocate(PCMTess,4,nTs,Label='PCMTess')
      call mma_allocate(Vert,3,MxVert,nTs,Label='Vert')
      call mma_allocate(Centr,3,MxVert,nTs,Label='Centr')
      call mma_allocate(SSph,NS,Label='SSph')
      call mma_allocate(PCMDM,nTs,nTs,Label='PCMDM')
      call mma_allocate(PCM_N,NS,Label='PCM_N')
      call mma_allocate(PCMiSph,nTs,Label='PCMiSph')
      call mma_allocate(NVert,nTs,Label='NVert')
      call mma_allocate(IntSph,MxVert,nTs,Label='IntSph')
      call mma_allocate(NewSph,2,NS,Label='NewSph')

      call Get_dArray('PCMSph',PCMSph,4*NS)
      call Get_dArray('PCMTess',PCMTess,4*nTs)
      call Get_dArray('Vert',Vert,3*MxVert*nTs)
      call Get_dArray('Centr',Centr,3*MxVert*nTs)
      call Get_dArray('SSph',SSph,NS)
      call Get_dArray('PCMDM',PCMDM,nTs**2)
      call Get_iArray('PCM_N',PCM_N,NS)
      call Get_iArray('PCMiSph',PCMiSph,nTs)
      call Get_iArray('NVert',NVert,nTs)
      call Get_iArray('IntSph',IntSph,MxVert*nTs)
      call Get_iArray('NewSph',NewSph,2*NS)

      return
    end if
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Initial processing for PCM

call Get_nAtoms_All(nAtoms)
call mma_allocate(Coor,3,nAtoms,Label='Coor')
call Get_Coord_All(Coor,nAtoms)
call Get_Name_All(Elements)
call mma_Allocate(ANr,nAtoms,Label='ANr')
do i=1,nAtoms
  do j=0,MaxAtomNum
    if (PTab(j) == Elements(i)) then
      ANr(i) = j
      exit
    end if
  end do
end do
call mma_allocate(LcCoor,3,nAtoms,Label='LcCoor')
call mma_allocate(LcANr,nAtoms,Label='LcANr')

! Initialize PCM model

! iPrint: Print level
! ICharg: Molecular charge
! nAtoms: total number of atoms
! Coor: Coordinates of atoms
! MxVert*nTs ANr: atomic numbers
! LcCoor: local array for atomic coordinates
! LcANr: local array for atomic numbers
! Solvent: string with explicit solvent name
! Conductor: logical flag to activate conductor approximation
! aArea: average area of a tessera
! r_min_sphere: minimum radius of smoothing sphere
! ip_Ts: pointer to tesserae
! nTs  : number of tesserae

#ifdef _DEBUGPRINT_
iPrint = 99
#else
iPrint = 5
#endif
call PCM_Init(iPrint,ICharg,nAtoms,Coor,ANr,LcCoor,LcANr,NonEq)
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*)
#endif

call mma_deallocate(LcANr)
call mma_deallocate(LcCoor)
call mma_deallocate(ANr)
call mma_deallocate(Coor)
!                                                                      *
!***********************************************************************
!                                                                      *
! Put the dynamic arrays on COMFILE

call Put_iScalar('PCM info length',nPCM_info)

call Put_dArray('PCMSph',PCMSph,4*NS)
call Put_dArray('PCMTess',PCMTess,4*nTs)
call Put_dArray('Vert',Vert,3*MxVert*nTs)
call Put_dArray('Centr',Centr,3*MxVert*nTs)
call Put_dArray('SSph',SSph,NS)
call Put_dArray('PCMDM',PCMDM,nTs**2)
call Put_iArray('PCM_N',PCM_N,NS)
call Put_iArray('PCMiSph',PCMiSph,nTs)
call Put_iArray('NVert',NVert,nTs)
call Put_iArray('IntSph',IntSph,MxVert*nTs)
call Put_iArray('NewSph',NewSph,2*NS)

iCharge_ref = iCharg
NonEq_ref = NonEq

! Put the reaction field common blocks on disk again!

call PCM_Info_Dmp()

end subroutine Init_PCM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine symtrizorbs2_cvb(orbs,
     >  north,corth,irels,relorb,ifxorb,iorts,
     >  ihlp,ihlp2,ihlp3,iprev,jprev,updi,updj)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "formats_cvb.fh"
      dimension orbs(norb,norb)
      dimension north(norb),corth(norb,niorth)
      dimension irels(2,nijrel),relorb(norb,norb,nijrel)
      dimension ifxorb(norb),iorts(2,nort)
      dimension ihlp(norb),ihlp2(norb),ihlp3(norb)
      dimension iprev(norb),jprev(norb)
      dimension updi(norb),updj(norb)
      dimension dum(1)
      save four,hund,thresh
      data four/4d0/,hund/100d0/,thresh/1d-10/

      ioffs=1
      do 100 iorb=1,norb
      if(north(iorb).ne.0) call schmidtd_cvb(corth(1,ioffs),
     >  north(iorb),orbs(1,iorb),1,dum,norb,0)
      ioffs=ioffs+north(iorb)
100   continue

c  Now enforce orthogonality between specified orbitals:
c  -----------------------------------------------------
      do 290 i=1,norb
      ihlp(i)=-1
290   continue
      do 300 iort=1,nort
      do 301 j=1,2
      iorb=iorts(j,iort)
      ihlp(iorb)=min(north(iorb),norb)
301   continue
300   continue
c  Check feasibility
      do 350 irel=1,nijrel
      if(ihlp(irels(1,irel)).ne.-1)then
        write(6,'(2a,i3)')' WARNING - cannot perform orthogonalizations'
     >    ,' involving orbital ',irels(1,irel)
        write(6,'(2a,i3)')' because this orbital is generated by',
     >    ' symmetry operations from orbital ',irels(2,irel)
        write(6,'(a)')' Please simplify orthogonality constraints.'
        call abend_cvb()
      endif
350   continue
c  Set up order of orthogonalization - first help arrays :
      call izero(ihlp2,norb)
      call izero(ihlp3,norb)
      nortorb=0
      do 400 icon=norb,0,-1
      do 401 iorb=1,norb
      if(ihlp(iorb).eq.icon)then
        nortorb=nortorb+1
        ihlp2(nortorb)=iorb
        ihlp3(iorb)=nortorb
      endif
401   continue
400   continue

c  Loop all pairs that may be orthogonalized
      do 450 iortorb=1,nortorb
      iorb=ihlp2(iortorb)
c  Create list of previous orthonormalisations involving IORB
      niprev=0
      do 465 iort=1,nort
      if(iorts(1,iort).eq.iorb)then
        if(ihlp3(iorts(2,iort)).lt.iortorb)then
          niprev=niprev+1
          iprev(niprev)=iorts(2,iort)
        endif
      elseif(iorts(2,iort).eq.iorb)then
        if(ihlp3(iorts(1,iort)).lt.iortorb)then
          niprev=niprev+1
          iprev(niprev)=iorts(1,iort)
        endif
      endif
465   continue
      do 451 jortorb=iortorb+1,nortorb
      jorb=ihlp2(jortorb)
c  Create list of previous orthonormalisations involving JORB
      iok=0
      njprev=0
      do 475 iort=1,nort
      if(iorts(1,iort).eq.jorb)then
        if(ihlp3(iorts(2,iort)).lt.iortorb)then
          njprev=njprev+1
          jprev(njprev)=iorts(2,iort)
        elseif(ihlp3(iorts(2,iort)).eq.iortorb)then
          iok=1
        endif
      elseif(iorts(2,iort).eq.jorb)then
        if(ihlp3(iorts(1,iort)).lt.iortorb)then
          njprev=njprev+1
          jprev(njprev)=iorts(1,iort)
        elseif(ihlp3(iorts(1,iort)).eq.iortorb)then
          iok=1
        endif
      endif
475   continue
      if(iok.eq.0)goto 451
      sovr=ddot_(norb,orbs(1,iorb),1,orbs(1,jorb),1)
      if(abs(sovr).lt.thresh)goto 490
c  Now ready to orthogonalise
c  Update vectors
      call updvec_cvb(updi,iorb,jorb,niprev,iprev,
     >  orbs,north,corth)
      cnrmi=ddot_(norb,updi,1,updi,1)
      if(ifxorb(iorb).eq.1)cnrmi=zero
      call updvec_cvb(updj,jorb,iorb,njprev,jprev,
     >  orbs,north,corth)
      cnrmj=ddot_(norb,updj,1,updj,1)
      if(ifxorb(jorb).eq.1)cnrmj=zero

      if(cnrmi.gt.thresh.and.cnrmj.gt.thresh)then
        faci=one/sqrt(cnrmi)
        call dscal_(norb,faci,updi,1)
        facj=one/sqrt(cnrmj)
        call dscal_(norb,facj,updj,1)
        s1=ddot_(norb,updi,1,orbs(1,jorb),1)
        s2=ddot_(norb,updj,1,orbs(1,iorb),1)
        s3=ddot_(norb,updi,1,updj,1)
c  Initialize cpp & cpm to suppress compiler warning ...
        cpp=0d0
        cpm=0d0
c  Same magnitudes of updates, either ++ or +- :
        if(abs(s3).gt.thresh)then
          a=s3
          b=s1+s2
          c=sovr
          discrpp=b*b-four*a*c
          if(discrpp.ge.zero)then
            c1=(-b+sqrt(discrpp))/(two*a)
            c2=(-b-sqrt(discrpp))/(two*a)
            if(abs(c1).lt.abs(c2))cpp=c1
            if(abs(c2).le.abs(c1))cpp=c2
          else
            cpp=hund
          endif
          a=-s3
          b=s1-s2
          discrpm=b*b-four*a*c
          if(discrpm.ge.zero)then
            c1=(-b+sqrt(discrpm))/(two*a)
            c2=(-b-sqrt(discrpm))/(two*a)
            if(abs(c1).lt.abs(c2))cpm=c1
            if(abs(c2).le.abs(c1))cpm=c2
          else
            cpm=hund
          endif
        else
          if(abs(s1+s2).gt.thresh)then
            cpp=sovr/(s1+s2)
          else
            cpp=hund
          endif
          if(abs(s1-s2).gt.thresh)then
            cpm=sovr/(s1+s2)
          else
            cpm=hund
          endif
        endif
        if(abs(cpp).lt.abs(cpm))c=cpp
        if(abs(cpm).le.abs(cpp))c=cpm
        if(c.eq.hund.or.abs(s2+c*s3).lt.thresh)then
          write(6,'(a,2i3)')' Could not orthogonalize orbitals',
     >      iorb,jorb
          write(6,'(a)')' Please simplify orthogonality constraints.'
          call abend_cvb()
        endif
        d=-(sovr+c*s1)/(s2+c*s3)
        call dscal_(norb,c,updi,1)
        call addvec(orbs(1,iorb),orbs(1,iorb),updi,norb)
        call dscal_(norb,d,updj,1)
        call addvec(orbs(1,jorb),orbs(1,jorb),updj,norb)
      elseif(cnrmi.gt.thresh)then
        faci=one/sqrt(cnrmi)
        call dscal_(norb,faci,updi,1)
        s1=ddot_(norb,updi,1,orbs(1,jorb),1)
        c=-sovr/s1
        call dscal_(norb,c,updi,1)
        call addvec(orbs(1,iorb),orbs(1,iorb),updi,norb)
      elseif(cnrmj.gt.thresh)then
        facj=one/sqrt(cnrmj)
        call dscal_(norb,facj,updj,1)
        s2=ddot_(norb,updj,1,orbs(1,iorb),1)
        d=-sovr/s2
        call dscal_(norb,d,updj,1)
        call addvec(orbs(1,jorb),orbs(1,jorb),updj,norb)
      else
        write(6,'(a,2i3)')' Could not orthogonalize orbitals',iorb,jorb
        write(6,'(a)')' Please simplify orthogonality constraints.'
        call abend_cvb()
      endif
490   niprev=niprev+1
      iprev(niprev)=jorb
451   continue
450   continue

      call nize_cvb(orbs,norb,dum,norb,0,0)
      smax=-one
      do 497 iort=1,nort
      iorb=iorts(1,iort)
      jorb=iorts(2,iort)
      s=abs(ddot_(norb,orbs(1,iorb),1,orbs(1,jorb),1))
      if(s.gt.smax)then
        smax=s
        iorbmax=iorb
        jorbmax=jorb
      endif
497   continue
      if(ip(3).ge.2.and.smax.gt.1d-10)then
        write(6,'(a,2i3)')
     >    ' Maximum overlap for orthogonalized orbitals :',
     >    iorbmax,jorbmax
        write(6,formAD)
     >    ' Value : ',ddot_(norb,orbs(1,iorbmax),1,orbs(1,jorbmax),1)
      endif

      do 500 irel=1,nijrel
      iorb=irels(1,irel)
      jorb=irels(2,irel)
      call mxatb_cvb(relorb(1,1,irel),orbs(1,jorb),
     >  norb,norb,1,orbs(1,iorb))
500   continue

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NucAtt_EMB(mGrid,Rho,nRho,P2_ontop,
     &                      nP2_ontop,iSpin,F_xc,dF_dRho,
     &                      ndF_dRho,dF_dP2ontop,ndF_dP2ontop)
      use nq_Grid, only: Grid
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "debug.fh"
#include "nsd.fh"
#include "setup.fh"
#include "nq_info.fh"
      Real*8  Rho(nRho,mGrid), dF_dRho(ndF_dRho,mGrid),
     &        dF_dP2ontop(ndF_dP2ontop,mGrid),
     &        P2_ontop(nP2_ontop,mGrid), F_xc(mGrid)
      Real*8, Allocatable:: RA(:,:), ZA(:), Eff(:)
      Integer, Allocatable:: nStab(:)
*
*
      Call Get_nAtoms_All(mCenter)
      Call mma_Allocate(RA,3,mCenter,Label='RA')
      Call Get_Coord_All(RA,mCenter)
*
      Call Allocate_Work(ip_ZA,mCenter)
      Call mma_allocate(ZA,mCenter,Label='ZA')
*
      Call mma_Allocate(nStab,nCenter,Label='nStab')
      Call Get_iArray('nStab',nStab,nCenter)
      Call mma_allocate(Eff,nCenter,Label='Eff')
      Call Get_dArray('Effective Nuclear Charge',Eff,nCenter)
      Call Get_iScalar('nSym',nSym)
*
      iOff = 1
      Do i = 1, nCenter
         n=nSym/nStab(i)
         call dcopy_(n,Eff(i),0,ZA(iOff),1)
         iOff = iOff + n
      End Do
*
      Call mma_deallocate(Eff)
      Call mma_deallocate(nStab)
*
      Call Do_NucAtt_EMB(mGrid,Rho,nRho,P2_ontop,nP2_ontop,
     &                   iSpin,F_xc,dF_dRho,ndF_dRho,
     &                   dF_dP2ontop,ndF_dP2ontop,Grid,
     &                   RA,ZA,mCenter,T_X)
*
      Call mma_deallocate(ZA)
      Call mma_deallocate(RA)
*
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine Do_NucAtt_EMB(mGrid,Rho,nRho,P2_ontop,nP2_ontop,
     &                         iSpin,F_xc,dF_dRho,ndF_dRho,
     &                         dF_dP2ontop,ndF_dP2ontop,Grid,RA,ZA,
     &                         mCenter,T_X)

      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid), dF_dRho(ndF_dRho,mGrid),
     &        dF_dP2ontop(ndF_dP2ontop,mGrid),
     &        P2_ontop(nP2_ontop,mGrid), F_xc(mGrid)
      Real*8 Grid(3,mGrid),RA(3,mCenter),ZA(mCenter)
*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=1
*
      If (iSpin.eq.1) Then
*                                                                      *
************************************************************************
*                                                                      *
        Do iGrid = 1, mGrid
*
         d_alpha=Rho(1,iGrid)
         DTot=Two*d_alpha
         If (DTot.lt.T_X) Go To 100
*
*------- Accumulate contributions to the nuclear attraction potential
*
         Attr=Zero
         Do i = 1, mCenter
            x=Grid(1,iGrid)-RA(1,i)
            y=Grid(2,iGrid)-RA(2,i)
            z=Grid(3,iGrid)-RA(3,i)
            Fact=ZA(i)/Sqrt(x**2+y**2+z**2)
            Attr=Attr+Fact
         End Do
         F_xc(iGrid)=F_xc(iGrid)-Attr*DTot
*
         dF_dRho(ipR,iGrid)=-Attr
*
100      Continue
*
        End Do
*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=/=1
*
      Else
*                                                                      *
************************************************************************
*                                                                      *
        Do iGrid = 1, mGrid
*
         d_alpha=Rho(1,iGrid)
         d_beta =Rho(2,iGrid)
         DTot=d_alpha+d_beta
         If (DTot.lt.T_X) Go To 200
*
*------- Accumulate contributions to the nuclear attraction potential
*
         Attr=Zero
         Do i = 1, mCenter
            x=Grid(1,iGrid)-RA(1,i)
            y=Grid(2,iGrid)-RA(2,i)
            z=Grid(3,iGrid)-RA(3,i)
            Fact=ZA(i)/Sqrt(x**2+y**2+z**2)
            Attr=Attr+Fact
         End Do
         F_xc(iGrid)=F_xc(iGrid)-Attr*DTot
*
         dF_dRho(ipRa,iGrid)=-Attr
         dF_dRho(ipRb,iGrid)=-Attr
*
200      Continue
*
        End Do
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(P2_ontop)
         Call Unused_real_array(dF_dP2ontop)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DelGHOST_MBPT(ipCMO,ipCMO_t,lthCMO,
     &                         ipEOrb,ipEOrb_t,lthEOr)
************************************************************************
************************************************************************
      Implicit Real*8 (A-H,O-Z)

*     declaration of calling arguments
      Integer ipCMO,ipCMO_t,ipEOrb,ipEOrb_t,lthCMO,lthEOr

#include "real.fh"
#include "Molcas.fh"
#include "mxdim.fh"
#include "namact.fh"
#include "corbinf.fh"
#include "orbinf2.fh"
#include "mbpt2aux.fh"
#include "WrkSpc.fh"
#include "files_mbpt2.fh"
#include "print_mbpt2.fh"

*     declaration of local variables...
      Integer nZero(8)
      Character*(LENIN8) Name(mxBas)
      Logical Debug
      Data Debug/.False./


#include "SysDef.fh"

      If (.not.DelGHOST) Return

      If (Debug) Then
         Write (6,'(A,8I5)') 'nSym:',nSym
         Write (6,'(A,8I5)') 'nBas:',(nBas(i),i=1,nSym)
         Write (6,'(A,8I5)') 'nOrb:',(nOrb(i),i=1,nSym)
         Write (6,'(A,8I5)') 'nOcc:',(nOcc(i),i=1,nSym)
         Write (6,'(A,8I5)') 'nFro:',(nFro(i),i=1,nSym)
      End If
      Do iSym=1,nSym
         nDel(iSym)=nBas(iSym)-nOrb(iSym)
         nExt(iSym)=nOrb(iSym)-nOcc(iSym)-nFro(iSym)
         nDsto(iSym)=nDel(iSym)
         nZero(iSym)=0
      End Do
*
      Call GetMem('CMO   ','Allo','Real',ipCMO,lthCMO)
*
      Call GetMem('EOrb  ','Allo','Real',ipEOrb,lthEOr)
*
      Write(6,'(A)')
     &    '-------------------------------------------------------'
      Write(6,'(A)') ' GHOST virtual space removal'
      Write(6,'(A)')
     &    '-------------------------------------------------------'
      Write(6,'(A,8I4)')
      Write(6,'(A,8I4)')
     &  ' Secondary orbitals before selection:',(nExt(i),i=1,nSym)
      Write(6,'(A,8I4)')
     &  ' Deleted orbitals before selection:  ',(nDel(i),i=1,nSym)

      Call Get_iScalar('Unique atoms',nUniqAt)
      Call Get_cArray('Unique Basis Names',Name,(LENIN8)*nnB)
      Call Delete_GHOSTS(irc,nSym,nBas,nFro,nOcc,nZero,nExt,nDel,
     &       NAME,nUniqAt,thr_ghs,.False.,Work(ipCMO_t),Work(ipEOrb_t))

      If (irc.ne.0) Then
         write(6,*) 'Delete_GHOSTS returned rc= ',irc
         Call abend()
      EndIf
      Write(6,'(A,8I4)')
      Write(6,'(A)')
     &    '-------------------------------------------------------'
      Write(6,'(A,8I4)')
      Write(6,'(A,8I4)')
*
*...  set MO coefficients of the deleted orbitals to zero
*     Observe that these are not included at all in the basis
      iStart   = ipCMO
      iStart_t = ipCMO_t
      Do iSym=1,nSym
         call dcopy_(nOrb(iSym)*nBas(iSym),Work(iStart_t),1,
     &                                    Work(iStart),1)
         iStart   = iStart   + nOrb(iSym)*nBas(iSym)
         iStart_t = iStart_t + nOrb(iSym)*nBas(iSym)
         call dcopy_((nBas(iSym)-nOrb(iSym))*nBas(iSym),
     &               [Zero],0,Work(iStart),1)
         iStart   = iStart   +
     &              (nBas(iSym)-nOrb(iSym))*nBas(iSym)
      End Do
      Call GetMem('CMO_t ','Free','Real',ipCMO_t,lthCMO)
*
*...  set energies of the deleted orbitals to zero
*
      iStart   = ipEOrb
      iStart_t = ipEOrb_t
      Do iSym=1,nSym
         call dcopy_(nOrb(iSym),Work(iStart_t),1,Work(iStart),1)
         iStart  = iStart   + nOrb(iSym)
         iStart_t= iStart_t + nOrb(iSym)
*
         call dcopy_(nBas(iSym)-nOrb(iSym),[Zero],0,Work(iStart),1)
         iStart  = iStart   + nBas(iSym)-nOrb(iSym)
      End Do
      Call GetMem('EOrb_t','Free','Real',ipEOrb_t,lthEOr)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Energy_E2d (V,Tau,e,eos,dima,no)
c
c        this routine calc:
c        E2 = sum(a,b,i,j) (2V(ai|bj)-V(aj|bi)) . Tau(a,b,i,j
c        E2os=sum(a,b,i,j) (  (ai|bj)         ) . Tau(a,b,i,j
c        where
c           E2    - complete E2 component of energy
c           E2os  - other spin E2 component of energy
c        for aGrp=bGrp (Tau array is full, but only a>=b values are completed)
c
        implicit none
        integer dima,no
        real*8 V(1:dima,1:no,1:dima,1:no)
        real*8 Tau(1:dima,1:dima,1:no,1:no)
        real*8 e,eos
c
c        help variables
        integer a,b,i,j
        real*8 ehlp
c
        e=0.0d0
        eos=0.0d0
        ehlp=0.0d0
c
c        off diagonal
c
        do j=1,no
        do i=1,no
        do b=1,dima-1
           ehlp=ehlp+V(b,i,b,j)*Tau(b,b,i,j)
        do a=b+1,dima
           e=e+(2.0d0*V(a,i,b,j)-V(a,j,b,i))*Tau(a,b,i,j)
           eos=eos+V(a,i,b,j)*Tau(a,b,i,j)
        end do
        end do
           ehlp=ehlp+V(dima,i,dima,j)*Tau(dima,dima,i,j)
        end do
        end do
c
        e=2.0d0*e
        eos=2.0d0*eos
c
        e=e+ehlp
        eos=eos+ehlp
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine genprexyz14(icheckz,interxyz)
      implicit real*8(a-h,o-z)
#include "para.fh"
#include "Molcas.fh"
      integer mcheckz
      dimension icheckz(0:Lmax,0:Lmax,0:Lmax,0:Lmax),
     *interxyz(16,0:Lmax,0:Lmax,0:Lmax,0:Lmax)
cbs #####################################################################
cbs   some quick decision for interaction
cbs #####################################################################
      do M4=0,Lmax
      do M3=0,Lmax
      do M2=0,Lmax
      do M1=0,Lmax
              icheckz(m1,m2,m3,m4)=mcheckz(m1,m2,m3,m4)
      enddo
      enddo
      enddo
      enddo
cbs #####################################################################
cbs   there are at most 16 possible combinations of signs ( 2**4)
cbs #####################################################################
      do M4=0,Lmax
      do M3=0,Lmax
      do M2=0,Lmax
      do M1=0,Lmax
      do irun=1,16
      interxyz(irun,m1,m2,m3,m4)=0
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function IRowAt(NumAt)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IRowAt
integer(kind=iwp), intent(in) :: NumAt
integer(kind=iwp), parameter :: IRow(0:108) = [ &
  0, &
  1,1, &
  2,2,2,2,2,2,2,2, &
  3,3,3,3,3,3,3,3, &
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4, &
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5, &
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6, &
  7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7 &
]

IRowAt = IRow(NumAt)

return

end function IRowAt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! MxSph: maximum number of spheres allowed                             *
! MxTs: maximum number of tesserae allowed                             *
! MxVert: maximum number of vertices per tessera                       *
! PCMSph: coordinates and radii of spheres                             *
! PCMTess: coordinates and area of tesserae                            *
! Vert: coordinates of tesserae vertices (3,:)                         *
! Centr: coordinates of tesserae centers (3,:)                         *
! SSph: exposed surface of each sphere                                 *
! PCMDM: PCM matrix                                                    *
! PCM_N: atoms where the spheres are centered                          *
! PCMiSph: sphere to which each tessera belongs                        *
! NVert: number of vertices of each tessera                            *
! IntSph: sphere intersected by each tessera edge (MxVert,:)           *
! NewSph: parent spheres for each added sphere (2,:)                   *
! PCM_SQ: PCM solvation charges                                        *
!***********************************************************************

module PCM_arrays

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: MxSph = 1000, MxTs = 6000, MxVert = 20
integer(kind=iwp) :: nTiles
real(kind=wp), parameter :: DiagScale = 1.0694_wp
integer(kind=iwp), allocatable :: IntSph(:,:), NewSph(:,:), nVert(:), PCM_N(:), PCMiSph(:)
real(kind=wp), allocatable :: C_Tessera(:,:), Centr(:,:,:), dCntr(:,:,:,:), dPnt(:,:,:,:), dRad(:,:,:), dTes(:,:,:), MM(:,:), &
                              PCM_SQ(:,:), PCMDM(:,:), PCMSph(:,:), PCMTess(:,:), Q_Tessera(:), SSph(:), Vert(:,:,:)

public :: C_Tessera, Centr, dCntr, DiagScale, dPnt, dRad, dTes, IntSph, MM, MxSph, MxTs, MxVert, NewSph, nTiles, NVert, PCM_N, &
          PCM_SQ, PCMDM, PCMiSph, PCMSph, PCMTess, Q_Tessera, SSph, Vert

end module PCM_arrays

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Valera Veryazov                                  *
************************************************************************
      Subroutine SysExpand(strin, strout, iRet)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     general purpose routine for expanding frequently used messages   *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     V.Veryazov University of Lund, 2001                              *
*                                                                      *
************************************************************************
*       character s*256
*       call sysexpand('MSG: open ',s,i)  - correct call
*       call sysexpand('MSG: opens ',s,i) - uncorrect, but could be fixed
*       call sysexpand('MSG: uNit ',s,i)  - mixed case
*       call sysexpand('MSG: blah ',s,i)  - will print BLAH
*             i=real len of s
*       call sysexpand('blah-blah ',s,i)  - will print string as is
*            and return i=0
************************************************************************
      parameter (MAXlabel=8)
      Character*(*) strin, strout
      Character*16 MSGlabel(MAXlabel)
      Character*128 MSGtext(MAXlabel)
      Character*512 sstrin
      Dimension MSGlen(MAXlabel)
      character*27 up,lw
      character*36  printable
      character c
      dimension itab(0:255)
      save up,lw,ifset,itab
      save MSGlabel, MSGtext, MSGlen
      data up /'ABCDEFGHIJKLMNOPQRSTUVWXYZ ' /
      data lw /'abcdefghijklmnopqrstuvwxyz ' /
      data printable /'1234567890-=~!@#$%^&*()_+<>,.?/[]":;'/
      data ifset / 0 /
c FORTRAN hash :-)
      data MSGlabel/'OPEN',
     *  'CLOSE',
     *  'UNIT',
     *  'DELETE',
     *  'SEEK',
     *  'INVALIDOPTION',
     *  'USED',
     *  'NOTOPENED'/
      data MSGtext/'Premature abort while opening file',   !OPEN
     *  'Premature abort while closing the file',          !CLOSE
     *  'Invalid unit number (Lu<=0 or Lu>99)',            !UNIT
     *  'Premature abort while removing the file',         !DELETE
     *  'Premature abort while seeking the file',          !SEEK
     * 'An invalid option or combination of options has been supplied',
     *  'Invalid unit number. The file is already opened', !USED
     *  'File is not Opened'/ !NOT OPENED

c preset of saved data
c this code uses a part of upcase routine
      if (ifset.eq.0) then
        ifset=1
        do i=0,255
          itab(i)=-1
        end do
        do ii=1,26
          i=ichar(up(ii:ii))
          j=ichar(lw(ii:ii))
          itab(j)=i
          itab(i)=i
        end do
        do i=1,MAXlabel
         do j=128,1,-1
         if(MSGtext(i)(j:j).ne.' ') goto 1
         enddo
1        MSGlen(i)=j
        enddo
      end if
c fixation of bug in G77
      sstrin=strin
c no action if it's an ordinary message
      if(sstrin(1:4).ne.'MSG:') then
      do ii=1, len(sstrin)
      c=sstrin(ii:ii)
#ifdef NAGFOR
      if(c.ne.'\') then
#endif
       ip=index(up,c)+index(lw,c)+index(printable,c)
c        print *,'ii',ii
       if(ip.eq.0) sstrin(ii:ii)=' '
#ifdef NAGFOR
       endif
#endif
      enddo
      iRet=0
      return
      endif
c uppercase with removing noncharacters.
      ik=0
      do ii=5,len(sstrin)
        i=ichar(sstrin(ii:ii))
        j=itab(i)
        if(j.ge.0) then
        ik=ik+1
        sstrin(ik:ik)=char(j)
        endif
      end do
      do ii=1,MAXlabel
      if(sstrin(1:ik).eq.MSGlabel(ii)) goto 10
      enddo
c  try again...
      do ii=1,MAXlabel
      if(sstrin(1:4).eq.MSGlabel(ii)(1:4)) goto 10
      enddo
      strout=sstrin(1:ik)
      iRet=ik
      return
10     continue
        strout=MSGtext(ii)(1:MSGlen(ii))
        iRet=MSGlen(ii)
        return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Per Ake Malmqvist                                *
!               1996, Roland Lindh                                     *
!***********************************************************************

subroutine AMPInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for computing matrix elements of the          *
!         six hermitized products of two angular momentum ops          *
!                                                                      *
!     Author: Per-AAke Malmqvist, Dept. of Theoretical Chemistry,      *
!             University of Lund, SWEDEN                               *
!             November '96                                             *
!     After pattern of other SEWARD soubroutines by R. Lindh.          *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: iBeta, iComp, iDCRT(0:7), iDum, iOrdOp, ipArr, ipB, ipOff, ipRes, iPrint, ipT, ipTm, ipTmm, ipTp, ipTpp, &
                     iRout, iStabO(0:7), lDCRT, llOper, LmbdT, mArr, nDCRT, nip, nOp, nStabO
real(kind=wp) :: TC(3)
integer(kind=iwp), external :: NrOpr

#include "macros.fh"
unused_var(nOrdOp)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 220
iPrint = nPrint(iRout)

nip = 1
ipB = nip
nip = nip+nZeta
ipTpp = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb+2)*6
ipTp = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb+1)*3
ipT = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*6
ipTm = 1
ipTmm = 1
if (lb > 0) then
  ipTm = nip
  nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb-1)*3
  if (lb > 1) then
    ipTmm = nip
    nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb-2)*6
  end if
end if
ipRes = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp
if (nip-1 > nZeta*nArr) then
  call WarningMessage(2,' AMPInt: nip-1 > nZeta*nArr')
  call Abend()
end if
ipArr = nip
mArr = (nArr*nZeta-(nip-1))/nZeta

rFinal(:,:,:,:) = Zero

ipOff = ipB-1
do iBeta=1,nBeta
  Array(ipOff+1:ipOff+nAlpha) = Beta(iBeta)
  ipOff = ipOff+nAlpha
end do

llOper = lOper(1)
do iComp=2,nComp
  iDum = lOper(iComp)
  llOper = ior(llOper,iDum)
end do

! Compute stabilizer, and then the double coset representation:
call SOS(iStabO,nStabO,llOper)
call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

! Loop over the cosets of the stabilizer group:
do lDCRT=0,nDCRT-1
  call OA(iDCRT(lDCRT),Ccoor,TC)

  ! Generate the quadrupole integral tables:
  iComp = 6
  iOrdOp = 2
  nHer = (la+(lb+2)+2+2)/2
  call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipTpp),nZeta,iComp,la,lb+2,A,RB,nHer,Array(ipArr),mArr,TC,iOrdOp)
  nHer = (la+lb+2+2)/2
  call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipT),nZeta,iComp,la,lb,A,RB,nHer,Array(ipArr),mArr,TC,iOrdOp)
  if (lb >= 2) then
    nHer = (la+(lb-2)+2+2)/2
    call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipTmm),nZeta,iComp,la,lb-2,A,RB,nHer,Array(ipArr),mArr,TC,iOrdOp)
  end if
  ! Generate the dipole integral tables:
  iComp = 3
  iOrdOp = 1
  nHer = (la+(lb+1)+1+2)/2
  call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipTp),nZeta,iComp,la,lb+1,A,RB,nHer,Array(ipArr),mArr,TC,iOrdOp)
  if (lb >= 1) then
    nHer = (la+(lb-1)+1+2)/2
    call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipTm),nZeta,iComp,la,lb-1,A,RB,nHer,Array(ipArr),mArr,TC,iOrdOp)
  end if

  if (iprint > 49) write(u6,*) ' AMPInt calling AMPr.'
  call AMPr(Array(ipB),nZeta,Array(ipRes),la,lb,Array(ipTpp),Array(ipTp),Array(ipT),Array(ipTm),Array(ipTmm))

  ! Symmetry adaption:
  if (iprint > 49) write(u6,*) ' AMPInt calling SymAdO'
  nOp = NrOpr(iDCRT(lDCRT))
  call SymAdO(Array(ipRes),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,One)
  if (iprint > 49) write(u6,*) ' Back to AMPInt.'
end do

if (iprint > 49) write(u6,*) ' Leaving AMPInt.'

return

end subroutine AMPInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine CD_Tester_Final(irc,NumCho,n,Thr,Err,Verbose)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: NumCho, n
real(kind=wp), intent(in) :: Thr, Err(6)
logical(kind=iwp), intent(in) :: Verbose
character(len=*), parameter :: SecNam = 'CD_Tester_Final'

irc = 0

if (Verbose) then
  write(u6,*)
  write(u6,*) 'Final results from ',SecNam,':'
  write(u6,*) 'Matrix dimension: ',n
  write(u6,*) 'Number of vecs. : ',NumCho
  write(u6,*) 'Threshold       : ',Thr
  write(u6,*) 'Min. Diag. err. : ',Err(1)
  write(u6,*) 'Max. Diag. err. : ',Err(2)
  write(u6,*) 'RMS  Diag. err. : ',Err(3)
  write(u6,*) 'Min. Matr. err. : ',Err(4)
  write(u6,*) 'Max. Matr. err. : ',Err(5)
  write(u6,*) 'RMS  Matr. err. : ',Err(6)
end if

if ((NumCho < 0) .or. (NumCho > n)) then
  irc = -1
  if (Verbose) write(u6,*) '>>> NumCho out of bounds!'
  return
end if

if (abs(Err(1)) > Thr) then
  irc = irc+1
  if (Verbose) write(u6,*) '>>> LARGE MINIMUM DIAGONAL ERROR: ',Err(1)
end if
if (abs(Err(2)) > Thr) then
  irc = irc+1
  if (Verbose) write(u6,*) '>>> LARGE MAXIMUM DIAGONAL ERROR: ',Err(2)
end if
if (abs(Err(3)) > Thr) then
  irc = irc+1
  if (Verbose) write(u6,*) '>>> LARGE RMS     DIAGONAL ERROR: ',Err(3)
end if
if (abs(Err(4)) > Thr) then
  irc = irc+1
  if (Verbose) write(u6,*) '>>> LARGE MINIMUM MATRIX   ERROR: ',Err(4)
end if
if (abs(Err(5)) > Thr) then
  irc = irc+1
  if (Verbose) write(u6,*) '>>> LARGE MAXIMUM MATRIX   ERROR: ',Err(5)
end if
if (abs(Err(6)) > Thr) then
  irc = irc+1
  if (Verbose) write(u6,*) '>>> LARGE RMS     MATRIX   ERROR: ',Err(6)
end if

if (Verbose) call xFlush(u6)

end subroutine CD_Tester_Final

!********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 18, 2021, created this file.               *
! ****************************************************************
subroutine TranslateDens(Pi,dRho_dr,dPi,l_tanhr,mGrid,nPi,ndRho_dr,nEGrad,DoGrad)

use nq_Grid, only: GradRho, Rho
use nq_pdft, only: dZdR, fta, ftb, ftc, lft, lGGA, OneMZ, OnePZ, Pass1, Pass2, Pass3, RatioA, RhoAB, ThrsFT, ThrsNT, ThrsOMR, &
                   ThrsRho, ZetaA
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Four, Five, Six, Eight, Twelve, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mGrid, nPi, ndRho_dr, nEGrad
real(kind=wp), intent(in) :: Pi(nPi,mGrid), dPi(nPi,nEGrad,mGrid)
real(kind=wp), intent(inout) :: dRho_dr(ndRho_dr,mGrid,nEGrad)
logical(kind=iwp), intent(in) :: l_tanhr, DoGrad
integer(kind=iwp) :: iEGrad, iGrid
real(kind=wp) :: Diff1, GraddZdR, GradRatio, GradRatioX, GradRatioY, GradRatioZ, GradZetaX, GradZetaY, GradZetaZ, Rd2RdRho2, &
                 Rd2RdRhodPi, Rd2ZdR2, Rd2ZdRdZ, RdRdPi, RdRdRho, RRatio, TempR, XAdd, YAdd, ZAdd, ZetaX, ZetaY, ZetaZ
real(kind=wp), allocatable :: dRatio(:,:), dRhodx(:), dRhody(:), dRhodz(:), dZeta(:,:), ftx23(:), fty23(:), ftz23(:), &
                              GradRhoAB(:,:), GradRhoX(:,:), GradRhoY(:,:), GradRhoZ(:,:), RatioX(:), RatioY(:), RatioZ(:), &
                              tanhrx(:), tanhry(:), tanhrz(:)
! PassX
! Pass1. Total density is greater than thresRho
! Pass2. Do translation
! Pass3. Do full translation
! if Pass1 is false, Pass2, 3, are both false.
! if Pass1 is true, Pass2 and 3 cannot both be true (can both be
! false).
!***********************************************************************

!***********************************************************************
! calculating total density at each grid
!***********************************************************************
RhoAB(:) = Rho(1,1:mGrid)+Rho(2,1:mGrid)

!***********************************************************************
! calculating x, y, z components of density gradient
!***********************************************************************
if (lGGA) then
  call mma_allocate(dRhodx,mGrid,label='dRhodx')
  call mma_allocate(dRhody,mGrid,label='dRhody')
  call mma_allocate(dRhodz,mGrid,label='dRhodz')
  dRhodx(:) = GradRho(1,1:mGrid)+GradRho(4,1:mGrid)
  dRhody(:) = GradRho(2,1:mGrid)+GradRho(5,1:mGrid)
  dRhodz(:) = GradRho(3,1:mGrid)+GradRho(6,1:mGrid)
end if

!***********************************************************************
! Ratio and Zeta at each grid point
!***********************************************************************
ZetaA(:) = Zero
RatioA(:) = Zero
dZdR(:) = Zero
do iGrid=1,mGrid
  Pass1(iGrid) = .false.
  Pass2(iGrid) = .false.
  Pass3(iGrid) = .false.
end do

if (.not. lft) then
  do iGrid=1,mGrid
    if (RhoAB(iGrid) >= ThrsRho) then
      Pass1(iGrid) = .true.
      RRatio = Four*Pi(1,iGrid)/(RhoAB(iGrid)**2)
      RatioA(iGrid) = Rratio
      if (l_tanhr) RRatio = tanh(RRatio)
      if ((One-Rratio) > ThrsOMR) then
        ZetaA(iGrid) = sqrt(One-Rratio)
        Pass2(iGrid) = .true.
        dZdR(iGrid) = -Half/ZetaA(iGrid)
      end if
    end if
  end do
else
  do iGrid=1,mGrid
    if (RhoAB(iGrid) >= ThrsRho) then
      Pass1(iGrid) = .true.
      RRatio = Four*Pi(1,iGrid)/(RhoAB(iGrid)**2)
      RatioA(iGrid) = Rratio
      if (RRatio < ThrsFT) then ! do t-translation
        ZetaA(iGrid) = sqrt(One-Rratio)
        Pass2(iGrid) = .true.
        dZdR(iGrid) = -Half/ZetaA(iGrid)
      else if (RRatio <= ThrsNT) then ! do ft-translation
        Diff1 = RRatio-ThrsNT
        ZetaA(iGrid) = (fta*Diff1**2+ftb*Diff1+ftc)*Diff1**3
        Pass3(iGrid) = .true.
        dZdR(iGrid) = (Five*fta*Diff1**2+Four*ftb*Diff1+Three*ftc)*Diff1**2
      end if
    end if
  end do
end if

!***********************************************************************
! (1 + zeta)/2 and (1 - zeta)/2
!***********************************************************************
OnePZ(:) = Half*(One+ZetaA)
OneMZ(:) = Half*(One-ZetaA)

!***********************************************************************
! translating rho_a and rho_b
!***********************************************************************
do iGrid=1,mGrid
  if (Pass1(iGrid)) then
    Rho(1,iGrid) = OnePZ(iGrid)*RhoAB(iGrid)
    Rho(2,iGrid) = OneMZ(iGrid)*RhoAB(iGrid)
  end if
end do

!***********************************************************************
! translating gradient component of rho_a and rho_b
!***********************************************************************
if (lGGA) then
  do iGrid=1,mGrid
    if (Pass1(iGrid)) then
      GradRho(1,iGrid) = OnePZ(iGrid)*dRhodX(iGrid)
      GradRho(2,iGrid) = OnePZ(iGrid)*dRhodY(iGrid)
      GradRho(3,iGrid) = OnePZ(iGrid)*dRhodZ(iGrid)
      GradRho(4,iGrid) = OneMZ(iGrid)*dRhodX(iGrid)
      GradRho(5,iGrid) = OneMZ(iGrid)*dRhodY(iGrid)
      GradRho(6,iGrid) = OneMZ(iGrid)*dRhodZ(iGrid)
    end if
  end do

  if (lft) then
    call mma_allocate(RatioX,mGrid,label='RatioX')
    call mma_allocate(RatioY,mGrid,label='RatioY')
    call mma_allocate(RatioZ,mGrid,label='RatioZ')
    call mma_allocate(ftx23,mGrid,label='ftx23')
    call mma_allocate(fty23,mGrid,label='fty23')
    call mma_allocate(ftz23,mGrid,label='ftz23')
    do iGrid=1,mGrid
      if (Pass1(iGrid)) then
        RatioX(iGrid) = (Four*Pi(2,iGrid)/RhoAB(iGrid)-Two*RatioA(iGrid)*dRhodX(iGrid))/RhoAB(iGrid)
        RatioY(iGrid) = (Four*Pi(3,iGrid)/RhoAB(iGrid)-Two*RatioA(iGrid)*dRhodY(iGrid))/RhoAB(iGrid)
        RatioZ(iGrid) = (Four*Pi(4,iGrid)/RhoAB(iGrid)-Two*RatioA(iGrid)*dRhodZ(iGrid))/RhoAB(iGrid)
      else
        RatioX(iGrid) = Zero
        RatioY(iGrid) = Zero
        RatioZ(iGrid) = Zero
      end if
      ftx23(iGrid) = Half*RhoAB(iGrid)*dZdR(iGrid)*RatioX(iGrid)
      fty23(iGrid) = Half*RhoAB(iGrid)*dZdR(iGrid)*RatioY(iGrid)
      ftz23(iGrid) = Half*RhoAB(iGrid)*dZdR(iGrid)*RatioZ(iGrid)
    end do
    GradRho(1,:) = GradRho(1,:)+ftx23
    GradRho(2,:) = GradRho(2,:)+fty23
    GradRho(3,:) = GradRho(3,:)+ftz23
    GradRho(4,:) = GradRho(4,:)-ftx23
    GradRho(5,:) = GradRho(5,:)-fty23
    GradRho(6,:) = GradRho(6,:)-ftz23
    call mma_deallocate(ftx23)
    call mma_deallocate(fty23)
    call mma_deallocate(ftz23)
  end if
end if

!********************************************************************
! Additional terms in the tanh translation
!********************************************************************
if (l_tanhr) then
  call mma_allocate(tanhrx,mGrid,label='tanhrx')
  call mma_allocate(tanhry,mGrid,label='tanhry')
  call mma_allocate(tanhrz,mGrid,label='tanhrz')
  tanhrx(:) = Zero
  tanhry(:) = Zero
  tanhrz(:) = Zero
  do iGrid=1,mGrid
    if (Pass1(iGrid)) then
      RRatio = RatioA(iGrid)
      TempR = Four*Pi(1,iGrid)/RhoAB(iGrid)
      TanhrX(iGrid) = (RRatio**2-One)*(Pi(2,iGrid)-(dRhodX(iGrid)*TempR))/(RhoAB(iGrid)*ZetaA(iGrid))
      TanhrY(iGrid) = (RRatio**2-One)*(Pi(3,iGrid)-(dRhodY(iGrid)*TempR))/(RhoAB(iGrid)*ZetaA(iGrid))
      TanhrZ(iGrid) = (RRatio**2-One)*(Pi(4,iGrid)-(dRhodZ(iGrid)*TempR))/(RhoAB(iGrid)*ZetaA(iGrid))
    end if
  end do
  GradRho(1,:) = GradRho(1,:)+TanhrX
  GradRho(2,:) = GradRho(2,:)+TanhrY
  GradRho(3,:) = GradRho(3,:)+TanhrZ
  GradRho(4,:) = GradRho(4,:)-TanhrX
  GradRho(5,:) = GradRho(5,:)-TanhrY
  GradRho(6,:) = GradRho(6,:)-TanhrZ
  call mma_deallocate(tanhrx)
  call mma_deallocate(tanhry)
  call mma_deallocate(tanhrz)
end if

!***********************************************************************
! calculating terms needed in gradient calculation
!***********************************************************************
! if not doing gradient, code ends here

if (DoGrad) then
  !*********************************************************************
  ! calculating density gradient wrt geometrical changes
  !*********************************************************************
  call mma_allocate(GradRhoAB,mGrid,nEGrad,label='GradRhoAB')
  GradRhoAB(:,:) = dRho_dr(1,:,:)+dRho_dr(2,:,:)

  if (lGGA) then
    call mma_allocate(GradRhoX,mGrid,nEGrad,label='GradRhoX')
    call mma_allocate(GradRhoY,mGrid,nEGrad,label='GradRhoY')
    call mma_allocate(GradRhoZ,mGrid,nEGrad,label='GradRhoZ')
    GradRhoX(:,:) = dRho_dr(3,:,:)+dRho_dr(6,:,:)
    GradRhoY(:,:) = dRho_dr(4,:,:)+dRho_dr(7,:,:)
    GradRhoZ(:,:) = dRho_dr(5,:,:)+dRho_dr(8,:,:)
  end if

  !***********************************************************************
  ! dRatio and dZeta at each grid point
  !***********************************************************************
  call mma_allocate(dRatio,mGrid,nEGrad,label='dRatio')
  call mma_allocate(dZeta,mGrid,nEGrad,label='dZeta')
  ! Calculate dRatio
  dRatio(:,:) = Zero
  do iGrid=1,mGrid
    if (Pass1(iGrid)) then
      do iEGrad=1,nEGrad
        dRatio(iGrid,iEGrad) = Four*dPi(1,iEGrad,iGrid)/(RhoAB(iGrid)**2)- &
                               Eight*Pi(1,iGrid)*GradRhoAB(iGrid,iEGrad)/(RhoAB(iGrid)**3)
      end do
    end if
  end do
  ! Calculate dZeta
  do iGrid=1,mGrid
    dZeta(iGrid,:) = dZdR(iGrid)*dRatio(iGrid,:)
  end do

  do iEGrad=1,nEGrad
    do iGrid=1,mGrid
      if (Pass1(iGrid)) then
        dRho_dr(1,iGrid,iEGrad) = OnePZ(iGrid)*GradRhoAB(iGrid,iEGrad)+Half*dZeta(iGrid,iEGrad)*RhoAB(iGrid)
        dRho_dr(2,iGrid,iEGrad) = OneMZ(iGrid)*GradRhoAB(iGrid,iEGrad)-Half*dZeta(iGrid,iEGrad)*RhoAB(iGrid)
      end if
    end do
  end do

  if (lGGA) then
    do iEGrad=1,nEGrad
      do iGrid=1,mGrid
        if (Pass1(iGrid)) then
          dRho_dr(3,iGrid,iEGrad) = OnePZ(iGrid)*GradRhoX(iGrid,iEGrad)+Half*dZeta(iGrid,iEGrad)*dRhodx(iGrid)
          dRho_dr(6,iGrid,iEGrad) = OneMZ(iGrid)*GradRhoX(iGrid,iEGrad)-Half*dZeta(iGrid,iEGrad)*dRhodx(iGrid)
          dRho_dr(4,iGrid,iEGrad) = OnePZ(iGrid)*GradRhoY(iGrid,iEGrad)+Half*dZeta(iGrid,iEGrad)*dRhody(iGrid)
          dRho_dr(7,iGrid,iEGrad) = OneMZ(iGrid)*GradRhoY(iGrid,iEGrad)-Half*dZeta(iGrid,iEGrad)*dRhody(iGrid)
          dRho_dr(5,iGrid,iEGrad) = OnePZ(iGrid)*GradRhoZ(iGrid,iEGrad)+Half*dZeta(iGrid,iEGrad)*dRhodz(iGrid)
          dRho_dr(8,iGrid,iEGrad) = OneMZ(iGrid)*GradRhoZ(iGrid,iEGrad)-Half*dZeta(iGrid,iEGrad)*dRhodz(iGrid)
        end if
      end do
    end do
    if (lft) then
      do iGrid=1,mGrid
        if (.not. Pass1(iGrid)) cycle
        if (.not. (Pass2(iGrid) .or. Pass3(iGrid))) cycle
        ZetaX = dZdR(iGrid)*RatioX(iGrid)
        ZetaY = dZdR(iGrid)*RatioY(iGrid)
        ZetaZ = dZdR(iGrid)*RatioZ(iGrid)
        RdRdRho = -Two*RatioA(iGrid)/RhoAB(iGrid)
        RdRdPi = Four/RhoAB(iGrid)**2
        Rd2RdRho2 = -Three*RdRdRho/RhoAB(iGrid)
        Rd2RdRhodPi = -Two*RdRdPi/RhoAB(iGrid)
        Rd2ZdRdZ = Zero
        Rd2ZdR2 = Zero
        if (Pass2(iGrid)) Rd2ZdRdZ = Half/ZetaA(iGrid)**2
        if (Pass3(iGrid)) then
          Diff1 = RatioA(iGrid)-ThrsNT
          Rd2ZdR2 = (20.0_wp*fta*Diff1**2+Twelve*ftb*Diff1+Six*ftc)*Diff1
        end if
        do iEGrad=1,nEGrad
          GradRatio = dRatio(iGrid,iEGrad)
          GradRatioX = (Rd2RdRho2*dRhodX(iGrid)+Rd2RdRhodPi*Pi(2,iGrid))*GradRhoAB(iGrid,iEGrad)+ &
                       Rd2RdRhodPi*dRhodX(iGrid)*dPi(1,iEGrad,iGrid)+RdRdRho*GradRhoX(iGrid,iEGrad)+RdRdPi*dPi(2,iEGrad,iGrid)

          GradRatioY = (Rd2RdRho2*dRhodY(iGrid)+Rd2RdRhodPi*Pi(3,iGrid))*GradRhoAB(iGrid,iEGrad)+ &
                       Rd2RdRhodPi*dRhodY(iGrid)*dPi(1,iEGrad,iGrid)+RdRdRho*GradRhoY(iGrid,iEGrad)+RdRdPi*dPi(3,iEGrad,iGrid)

          GradRatioZ = (Rd2RdRho2*dRhodZ(iGrid)+Rd2RdRhodPi*Pi(4,iGrid))*GradRhoAB(iGrid,iEGrad)+ &
                       Rd2RdRhodPi*dRhodZ(iGrid)*dPi(1,iEGrad,iGrid)+RdRdRho*GradRhoZ(iGrid,iEGrad)+RdRdPi*dPi(4,iEGrad,iGrid)
          GraddZdR = Zero
          if (Pass2(iGrid)) then
            GraddZdR = Rd2ZdRdZ*dZeta(iGrid,iEGrad)
          else if (Pass3(iGrid)) then
            GraddZdR = Rd2ZdR2*GradRatio
          end if

          GradZetax = GraddZdR*RatioX(iGrid)+dZdR(iGrid)*GradRatioX
          GradZetaY = GraddZdR*RatioY(iGrid)+dZdR(iGrid)*GradRatioY
          GradZetaZ = GraddZdR*RatioZ(iGrid)+dZdR(iGrid)*GradRatioZ

          XAdd = Half*(RhoAB(iGrid)*GradZetaX+ZetaX*GradRhoAB(iGrid,iEGrad))
          YAdd = Half*(RhoAB(iGrid)*GradZetaY+ZetaY*GradRhoAB(iGrid,iEGrad))
          ZAdd = Half*(RhoAB(iGrid)*GradZetaZ+ZetaZ*GradRhoAB(iGrid,iEGrad))

          dRho_dr(3,iGrid,iEGrad) = dRho_dr(3,iGrid,iEGrad)+XAdd
          dRho_dr(6,iGrid,iEGrad) = dRho_dr(6,iGrid,iEGrad)-XAdd
          dRho_dr(4,iGrid,iEGrad) = dRho_dr(4,iGrid,iEGrad)+YAdd
          dRho_dr(7,iGrid,iEGrad) = dRho_dr(7,iGrid,iEGrad)-YAdd
          dRho_dr(5,iGrid,iEGrad) = dRho_dr(5,iGrid,iEGrad)+ZAdd
          dRho_dr(8,iGrid,iEGrad) = dRho_dr(8,iGrid,iEGrad)-ZAdd
        end do
      end do
    end if
    call mma_deallocate(GradRhoX)
    call mma_deallocate(GradRhoY)
    call mma_deallocate(GradRhoZ)
  end if
  call mma_deallocate(GradRhoAB)
  call mma_deallocate(dRatio)
  call mma_deallocate(dZeta)
end if

if (lGGA) then
  call mma_deallocate(dRhodx)
  call mma_deallocate(dRhody)
  call mma_deallocate(dRhodz)
  if (lft) then
    call mma_deallocate(RatioX)
    call mma_deallocate(RatioY)
    call mma_deallocate(RatioZ)
  end if
end if

return

end subroutine TranslateDens

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993,1998, Roland Lindh                                *
!***********************************************************************

subroutine FckAcc_Mck(iAng,iCmp,jCmp,kCmp,lCmp,Shijij,iShll,iShell,kOp,nijkl,AOInt,TwoHam,nDens,Scrt,nScrt,iAO,iAOst,iBas,jBas, &
                      kBas,lBas,Dij,ij1,ij2,ij3,ij4,Dkl,kl1,kl2,kl3,kl4,Dik,ik1,ik2,ik3,ik4,Dil,il1,il2,il3,il4,Djk,jk1,jk2,jk3, &
                      jk4,Djl,jl1,jl2,jl3,jl4,FT,nFT,tfact,iCar,iCent,pert,indgrd,ipdisp)

#define _USE_OLD_CODE_
#ifdef _USE_OLD_CODE_

!***********************************************************************
!                                                                      *
!  Object: to accumulate contributions from the AO integrals directly  *
!          to the symmatry adapted Fock matrix.                        *
!                                                                      *
!          The indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!          In addition to this complication we have that the order of  *
!          indicies in the integrals are not ordered canonically but   *
!          rather in an order such that the contraction step will be   *
!          optimal. Hence, special care has to be taken when tracing   *
!          the density with the integrals so that both entities have   *
!          the same order.                                             *
!                                                                      *
!          The Fock matrix is computed in lower triangular form.       *
!                                                                      *
!          The density matrix is not folded if the shell indices and   *
!          the angular indices are identical.                          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden. February '93                            *
!***********************************************************************

use McKinley_global, only: sIrrep
use Index_Functions, only: nTri3_Elem
use Basis_Info, only: Shells
use Symmetry_Info, only: iChBas, iChTbl, iOper, nIrrep, Prmt
use SOAO_Info, only: iAOtSO
use Real_Spherical, only: iSphCr
use Gateway_Info, only: CutInt
use Constants, only: Zero, One, Two, Four, Half, Quart
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: iAng(4), iCmp, jCmp, kCmp, lCmp, iShll(4), iShell(4), kOp(4), nijkl, nDens, nScrt, iAO(4), &
                                 iAOst(4), iBas, jBas, kBas, lBas, ij1, ij2, ij3, ij4, kl1, kl2, kl3, kl4, ik1, ik2, ik3, ik4, &
                                 il1, il2, il3, il4, jk1, jk2, jk3, jk4, jl1, jl2, jl3, jl4, nFT, iCar, iCent, &
                                 indgrd(3,4,0:nirrep-1), ipdisp(*)
logical(kind=iwp), intent(in) :: Shijij, Pert(0:nIrrep-1)
real(kind=wp), intent(in) :: AOInt(nijkl,iCmp,jCmp,kCmp,lCmp), Dij(ij1*ij2+1,ij3,ij4), Dkl(kl1*kl2+1,kl3,kl4), &
                             Dik(ik1*ik2+1,ik3,ik4), Dil(il1*il2+1,il3,il4), Djk(jk1*jk2+1,jk3,jk4), Djl(jl1*jl2+1,jl3,jl4), tfact
real(kind=wp), intent(inout) :: TwoHam(nDens)
real(kind=wp), intent(out) :: Scrt(nScrt), FT(nFT)
integer(kind=iwp) :: i, i1, i12, i2, i3, i34, i4, iChBs, iCmpa(4), ii, iIn, iIrrep, ijkl, iljk, iOut, ip, ipD, ipFij, ipFij1, &
                     ipFik, ipFik1, ipFil, ipFil1, ipFjk, ipFjk1, ipFjl, ipFjl1, ipFkl, ipFkl1, iSym(4,0:7), j, jChBs, jCmpMx, jj, &
                     k, kChBs, kk, kOp2(4), l, lChBs, lCmpMx, ll, mFij, mFik, mFil, mFjk, mFjl, mFkl, nFij, nFik, nFil, nFjk, &
                     nFjl, nFkl, nij, nik, nil, njk, njl, nkl, nnIrrep, np
real(kind=wp) :: D_ij, D_ik, D_il, D_jk, D_jl, D_kl, Fac, Fact, pEa, pFctr, pRb, pTc, pTSd, qFctr, rCh, vij, vijkl, vik, vil, vjk, &
                 vjl, vkl
logical(kind=iwp) :: iQij, iQik, iQil, iQjk, iQjl, iQkl, iShij, iShik, iShil, iShjk, iShjl, iShkl, lFij, lFik, lFil, lFjk, lFjl, &
                     lFkl, Qijij, Shij, Shkl
real(kind=r8), external :: DNrm2_

!iprint = 0

!write(u6,*) DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1),DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One,0)
!if (iPrint >= 49) then
!  if ((DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1) > Zero) .or. (DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One,0) > Zero)) then
!    call RecPrt('Dik','(5G20.10)',Dik,ik1*ik2+1,ik3*ik4)
!    write(u6,'(A,2G20.10)') &
!      ' FckAcc:AOIn',DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1), DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One,0)
!  end if
!end if
!if (iPrint >= 99) then
!  call RecPrt('FckAcc:AOInt','(5G20.10)',AOInt,nijkl,iCmp*jCmp*kCmp*lCmp)
!  write(u6,'(A,G20.10)') 'Dij=',XDot(Dij,ij1,ij2,ij3,ij4)
!  write(u6,'(A,G20.10)') 'Dkl=',XDot(Dkl,kl1,kl2,kl3,kl4)
!  write(u6,'(A,G20.10)') 'Dik=',XDot(Dik,ik1,ik2,ik3,ik4)
!  write(u6,'(A,G20.10)') 'Dil=',XDot(Dil,il1,il2,il3,il4)
!  write(u6,'(A,G20.10)') 'Djk=',XDot(Djk,jk1,jk2,jk3,jk4)
!  write(u6,'(A,G20.10)') 'Djl=',XDot(Djl,jl1,jl2,jl3,jl4)
!end if

!write(u6,'(A,8L1)') 'Pert=',Pert
if (iBas*jBas*kBas*lBas > nScrt) then
  write(u6,*) 'FckAcc_McK: iBas*jBas*kBas*lBas > nScrt'
  write(u6,*) 'iBas,jBas,kBas,lBas,nScrt=',iBas,jBas,kBas,lBas,nScrt
  call Abend()
end if
ii = nTri3_Elem(iAng(1))
jj = nTri3_Elem(iAng(2))
kk = nTri3_Elem(iAng(3))
ll = nTri3_Elem(iAng(4))
kOp2(1) = iOper(kOp(1))
kOp2(2) = iOper(kOp(2))
kOp2(3) = iOper(kOp(3))
kOp2(4) = iOper(kOp(4))
iCmpa(1) = iCmp
iCmpa(2) = jCmp
iCmpa(3) = kCmp
iCmpa(4) = lCmp
lFij = .false.
lFkl = .false.
lFik = .false.
lFjl = .false.
lFil = .false.
lFjk = .false.

ipFij = 1
nFij = iBas*jBas*iCmpa(1)*iCmpa(2)

ipFkl = ipFij+nFij
nFkl = kBas*lBas*iCmpa(3)*iCmpa(4)

ipFik = ipFkl+nFkl
nFik = iBas*kBas*iCmpa(1)*iCmpa(3)

ipFjl = ipFik+nFik
nFjl = jBas*lBas*iCmpa(2)*iCmpa(4)

ipFil = ipFjl+nFjl
nFil = iBas*lBas*iCmpa(1)*iCmpa(4)

ipFjk = ipFil+nFil
nFjk = jBas*kBas*iCmpa(2)*iCmpa(3)

FT(ipFij:ipFjk+nFjk-1) = Zero

! Quadruple loop over elements of the basis functions angular
! description. Loops are reduced to just produce unique SO integrals
! Observe that we will walk through the memory in AOInt in a
! sequential way.

Shij = iShell(1) == iShell(2)
Shkl = iShell(3) == iShell(4)
iShij = iShell(1) == iShell(2)
iShkl = iShell(3) == iShell(4)
iShik = iShell(1) == iShell(3)
iShil = iShell(1) == iShell(4)
iShjk = iShell(2) == iShell(3)
iShjl = iShell(2) == iShell(4)
do i1=1,iCmp
  do j=0,nIrrep-1
    iSym(1,j) = 0
    if (iAOtSO(iAO(1)+i1,j) > 0) iSym(1,j) = 2**j
  end do
  jCmpMx = jCmp
  if (Shij) jCmpMx = i1
  iChBs = iChBas(ii+i1)
  if (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+i1))
  pEa = Prmt(iOper(kOp(1)),iChBs)
  do i2=1,jCmpMx
    do j=0,nIrrep-1
      iSym(2,j) = 0
      if (iAOtSO(iAO(2)+i2,j) > 0) iSym(2,j) = 2**j
    end do
    jChBs = iChBas(jj+i2)
    if (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+i2))
    pRb = Prmt(iOper(kOp(2)),jChBs)
    !Qij = i1 == i2
    if (iShell(2) > iShell(1)) then
      i12 = jCmp*(i1-1)+i2
    else
      i12 = iCmp*(i2-1)+i1
    end if
    do i3=1,kCmp
      do j=0,nIrrep-1
        iSym(3,j) = 0
        if (iAOtSO(iAO(3)+i3,j) > 0) iSym(3,j) = 2**j
      end do
      lCmpMx = lCmp
      if (Shkl) lCmpMx = i3
      kChBs = iChBas(kk+i3)
      if (Shells(iShll(3))%Transf) kChBs = iChBas(iSphCr(kk+i3))
      pTc = Prmt(iOper(kOp(3)),kChBs)
      do i4=1,lCmpMx
        do j=0,nIrrep-1
          iSym(4,j) = 0
          if (iAOtSO(iAO(4)+i4,j) > 0) iSym(4,j) = 2**j
        end do
        !Qkl = i3 == i4
        lChBs = iChBas(ll+i4)
        if (Shells(iShll(4))%Transf) lChBs = iChBas(iSphCr(ll+i4))
        pTSd = Prmt(iOper(kOp(4)),lChBs)
        if (iShell(4) > iShell(3)) then
          i34 = lCmp*(i3-1)+i4
        else
          i34 = kCmp*(i4-1)+i3
        end if
        if (Shijij .and. (i34 > i12)) cycle
        Qijij = Shijij .and. (i12 == i34)
        iQij = iShij .and. (i1 == i2)
        iQkl = iShkl .and. (i3 == i4)
        iQik = iShik .and. (i1 == i3)
        iQil = iShil .and. (i1 == i4)
        iQjk = iShjk .and. (i2 == i3)
        iQjl = iShjl .and. (i2 == i4)
        pFctr = pEa*pRb*pTc*pTSd

        mFij = 0
        mFkl = 0
        mFik = 0
        mFjl = 0
        mFil = 0
        mFjk = 0
        do iIrrep=0,nIrrep-1
          if ((iSym(1,iIrrep) /= 0) .and. (iSym(2,iIrrep) /= 0)) mFkl = mFkl+1
          if ((iSym(3,iIrrep) /= 0) .and. (iSym(4,iIrrep) /= 0)) mFij = mFij+1
          if ((iSym(1,iIrrep) /= 0) .and. (iSym(3,iIrrep) /= 0)) mFjl = mFjl+1
          if ((iSym(2,iIrrep) /= 0) .and. (iSym(4,iIrrep) /= 0)) mFik = mFik+1
          if ((iSym(1,iIrrep) /= 0) .and. (iSym(4,iIrrep) /= 0)) mFjk = mFjk+1
          if ((iSym(2,iIrrep) /= 0) .and. (iSym(3,iIrrep) /= 0)) mFil = mFil+1
        end do
        if (mFij+mFkl+mFik+mFjl+mFil+mFjk == 0) cycle

        vijkl = DNrm2_(iBas*jBas*kBas*lBas,AOInt(:,i1,i2,i3,i4),1)
        if (vijkl < CutInt) cycle
        !***************************************************************
        !                                                              *
        ! Fij = hij + Sum(kl) Dkl {(ij|kl)-1/2(ik|jl)}                 *
        !                                                              *
        ! or                                                           *
        !                                                              *
        ! Fij = hij + Sum(k=>l) Dkl {(2-d(kl)} P(ij|kl)                *
        !                                                              *
        ! where P(ij|kl)=(ij|kl)-1/4(ik|jl)-1/4(il|jk)                 *
        !                                                              *
        ! or in the case of no sum restriction                         *
        !                                                              *
        ! P(ij|kl) = (ij|kl) - 1/2(ik|jl)                              *
        !                                                              *
        ! Coloumb Contributions                                        *
        !                                                              *
        ! Fij = Dkl * (ij|kl)                                          *
        !                                                              *
        ! Order density matrix in accordance with the integrals        *
        !                                                              *
        !***************************************************************
        if (mFij /= 0) then
          if (iShell(3) < iShell(4)) then
            vkl = Dkl(kBas*lBas+1,i4,i3)
          else
            vkl = Dkl(kBas*lBas+1,i3,i4)
          end if

          ! Pickup the right column of the density matrix and
          ! change order if not canonical.

          qFctr = One
          ipFij1 = ((i2-1)*iCmpa(1)+i1-1)*iBas*jBas+ipFij
          Fac = One
          if (iQij) Fac = Half
          D_kl = Two
          if (iQkl) D_kl = One
          Fac = Fac*D_kl
          if (vkl*vijkl*abs(Fac*qFctr*pFctr) >= CutInt) then
            if (iShell(3) < iShell(4)) then
              call DGetMO(Dkl(:,i4,i3),kl1,kl1,kl2,Scrt,kl2)
              call dGeMV_('N',iBas*jBas,kBas*lBas,Fac*qFctr*pFctr,AOInt(:,i1,i2,i3,i4),iBas*jBas,Scrt,1,One,FT(ipFij1),1)
            else
              call dGeMV_('N',iBas*jBas,kBas*lBas,Fac*qFctr*pFctr,AOInt(:,i1,i2,i3,i4),iBas*jBas,Dkl(:,i3,i4),1,One,FT(ipFij1),1)
            end if
            !call RecPrt('Fij',' ',FT(ipFij1),iBas,jBas)
            lFij = .true.
          end if
        end if
        ! Fkl = Dij * (ij|kl)
        if ((.not. Qijij) .and. (mFkl /= 0)) then
          if (iShell(1) < iShell(2)) then
            vij = Dij(iBas*jBas+1,i2,i1)
          else
            vij = Dij(iBas*jBas+1,i1,i2)
          end if
          qFctr = One
          ipFkl1 = ((i4-1)*iCmpa(3)+i3-1)*kBas*lBas+ipFkl
          Fac = One
          if (iQkl) Fac = Half
          D_ij = Two
          if (iQij) D_ij = One
          Fac = Fac*D_ij
          if (vij*vijkl*abs(Fac*qFctr*pFctr) >= CutInt) then
            if (iShell(1) < iShell(2)) then
              call DGeTMO(Dij(:,i2,i1),ij1,ij1,ij2,Scrt,ij2)
              call dGeMV_('T',iBas*jBas,kBas*lBas,Fac*qFctr*pFctr,AOInt(:,i1,i2,i3,i4),iBas*jBas,Scrt,1,One,FT(ipFkl1),1)
            else
              call dGeMV_('T',iBas*jBas,kBas*lBas,Fac*qFctr*pFctr,AOInt(:,i1,i2,i3,i4),iBas*jBas,Dij(:,i1,i2),1,One,FT(ipFkl1),1)
            end if
            !call RecPrt('Fkl',' ',FT(ipFkl1),kBas,lBas)
            lFkl = .true.
          end if
        end if

        ! Exchange contributions

        ! Change the order ijkl to ikjl. Make sure also that
        ! the index pairs are canonical.

        ipD = 1+iBas*jBas*kBas*lBas
        np = ipD-1+max(iBas*lBas,jBas*lBas,iBas*kBas,jBas*kBas)
        if (np > nScrt) then
          write(u6,*) 'FckAcc_McK: np > nScrt'
          write(u6,*) 'np,nScrt=',np,nScrt
          call Abend()
        end if
        if (mFik+mFjl /= 0) then
          if ((mFik /= 0) .and. (iShell(2) < iShell(4))) then
            vjl = Djl(jBas*lBas+1,i4,i2)
          else if (mFik /= 0) then
            vjl = Djl(jBas*lBas+1,i2,i4)
          else
            vjl = Zero
          end if
          if ((mFjl /= 0) .and. (iShell(1) < iShell(3))) then
            vik = Dik(iBas*kBas+1,i3,i1)
          else if (mFjl /= 0) then
            vik = Dik(iBas*kBas+1,i1,i3)
          else
            vik = Zero
          end if
          if ((vik*vijkl/Four >= CutInt) .or. (vjl*vijkl/Four >= CutInt)) then
            do j=1,jBas
              nij = (j-1)*iBas+1
              do k=1,kBas
                nik = (k-1)*iBas+1
                do l=1,lBas
                  nkl = (l-1)*kBas+k
                  njl = (l-1)*jBas+j
                  iOut = (nkl-1)*iBas*jBas+nij
                  iIn = (njl-1)*iBas*kBas+nik
                  Scrt(iIn:iIn+iBas-1) = AOInt(iOut:iOut+iBas-1,i1,i2,i3,i4)
                end do
              end do
            end do
            !***********************************************************
            !                                                          *
            ! Fik = - 1/4 * Djl * P(jl|ik)                             *
            !                                                          *
            ! P(jl|ik) = (jl|ik) - 1/4(ji|lk) - 1/4(jk|il)             *
            !                                                          *
            ! P(jl|ik) = (jl|ik) - 1/2(ji|lk)                          *
            !                                                          *
            ! Change factor if                                         *
            ! a) asymmetrical P matrix is implied                      *
            ! b) if the two exchange integrals in the symmetrical      *
            !    P matrix are identical.                               *
            !                                                          *
            !***********************************************************
            if (mFik /= 0) then
              qFctr = One
              ipFik1 = ((i3-1)*iCmpa(1)+i1-1)*iBas*kBas+ipFik
              Fac = -Quart
              if (iQjl .and. (.not. iQik)) Fac = -Half
              D_jl = Two
              if (iQjl) D_jl = One
              Fac = Fac*D_jl
              if (vjl*vijkl*abs(Fac*qFctr*pFctr) >= CutInt) then
                if (iShell(2) < iShell(4)) then
                  call DGeTMO(Djl(:,i4,i2),jl1,jl1,jl2,Scrt(ipD),jl2)
                  call dGeMV_('N',iBas*kBas,jBas*lBas,Fac*qFctr*pFctr,Scrt,iBas*kBas,Scrt(ipD),1,One,FT(ipFik1),1)
                else
                  call dGeMV_('N',iBas*kBas,jBas*lBas,Fac*qFctr*pFctr,Scrt,iBas*kBas,Djl(:,i2,i4),1,One,FT(ipFik1),1)
                end if
                !call RecPrt('Fik',' ',FT(ipFik1),iBas,kBas)
                lFik = .true.
              end if
            end if
            if ((.not. iQij) .or. (.not. iQkl)) then
              !*********************************************************
              !                                                        *
              ! Fjl = - 1/4 * Dik * P(jl|ik)                           *
              !                                                        *
              ! P(jl|ik) = (jl|ik) - 1/4(ji|lk) - 1/4(jk|il)           *
              !                                                        *
              ! P(jl|ik) = (jl|ik) - 1/2(ji|lk)                        *
              !                                                        *
              !*********************************************************
              if (mFjl /= 0) then
                qFctr = One
                ipFjl1 = ((i4-1)*iCmpa(2)+i2-1)*jBas*lBas+ipFjl
                Fac = -Quart
                if (iQik .and. (.not. iQjl)) Fac = -Half
                D_ik = Two
                if (iQik) D_ik = One
                Fac = Fac*D_ik
                if (vik*vijkl*abs(Fac*qFctr*pFctr) >= CutInt) then
                  if (iShell(1) < iShell(3)) then
                    call DGeTMO(Dik(:,i3,i1),ik1,ik1,ik2,Scrt(ipD),ik2)
                    call dGeMV_('T',iBas*kBas,jBas*lBas,Fac*qFctr*pFctr,Scrt,iBas*kBas,Scrt(ipD),1,One,FT(ipFjl1),1)
                  else
                    call dGeMV_('T',iBas*kBas,jBas*lBas,Fac*qFctr*pFctr,Scrt,iBas*kBas,Dik(:,i1,i3),1,One,FT(ipFjl1),1)
                  end if
                  !call RecPrt('Fjl',' ',FT(ipFjl1),jBas,lBas)
                  lFjl = .true.
                end if
              end if
            end if
          end if
        end if

        ! Change order ijkl to iljk

        if ((.not. iQij) .and. (.not. iQkl) .and. (mFil+mFjk /= 0)) then
          if ((mFil /= 0) .and. (iShell(2) < iShell(3))) then
            vjk = Djk(jBas*kBas+1,i3,i2)
          else if (mFil /= 0) then
            vjk = Djk(jBas*kBas+1,i2,i3)
          else
            vjk = Zero
          end if
          if ((mFjk /= 0) .and. (iShell(1) < iShell(4))) then
            vil = Dil(iBas*lBas+1,i4,i1)
          else if (mFjk /= 0) then
            vil = Dil(iBas*lBas+1,i1,i4)
          else
            vil = Zero
          end if
          if ((vil*vijkl/Four >= CutInt) .or. (vjk*vijkl/Four >= CutInt)) then
            i = 1
            do j=1,jBas
              nij = (j-1)*iBas+i
              do k=1,kBas
                njk = (k-1)*jBas+j
                do l=1,lBas
                  nkl = (l-1)*kBas+k
                  nil = (l-1)*iBas+i
                  ijkl = (nkl-1)*iBas*jBas+nij
                  iljk = (njk-1)*iBas*lBas+nil
                  Scrt(iljk:iljk+iBas-1) = AOInt(ijkl:ijkl+iBas-1,i1,i2,i3,i4)
                end do
              end do
            end do
            ! Fil = - 1/4 * Djk * (ij|kl)
            if (mFil /= 0) then
              qFctr = One
              ipFil1 = ((i4-1)*iCmpa(1)+i1-1)*iBas*lBas+ipFil
              Fac = -Quart
              if (iQjk .and. (.not. iQil)) Fac = -Half
              D_jk = Two
              if (iQjk) D_jk = One
              Fac = Fac*D_jk
              if (vjk*vijkl*abs(Fac*qFctr*pFctr) >= CutInt) then
                if (iShell(2) < iShell(3)) then
                  call DGeTMO(Djk(:,i3,i2),jk1,jk1,jk2,Scrt(ipD),jk2)
                  call dGeMV_('N',iBas*lBas,jBas*kBas,Fac*qFctr*pFctr,Scrt,iBas*lBas,Scrt(ipD),1,One,FT(ipFil1),1)
                else
                  call dGeMV_('N',iBas*lBas,jBas*kBas,Fac*qFctr*pFctr,Scrt,iBas*lBas,Djk(:,i2,i3),1,One,FT(ipFil1),1)
                end if
                !call RecPrt('Fil',' ',FT(ipFil1),iBas,lBas)
                lFil = .true.
              end if
            end if
            ! Fjk = - 1/4 * Dil * (ij|kl)
            if ((.not. Qijij) .and. (mFjk /= 0)) then
              qFctr = One
              ipFjk1 = ((i3-1)*iCmpa(2)+i2-1)*jBas*kBas+ipFjk
              Fac = -Quart
              if (iQil .and. (.not. iQjk)) Fac = -Half
              D_il = Two
              if (iQil) D_il = One
              Fac = Fac*D_il
              if (vil*vijkl*abs(Fac*qFctr*pFctr) >= CutInt) then
                if (iShell(1) < iShell(4)) then
                  call DGeTMO(Dil(:,i4,i1),il1,il1,il2,Scrt(ipD),il2)
                  call dGeMV_('T',iBas*lBas,jBas*kBas,Fac*qFctr*pFctr,Scrt,iBas*lBas,Scrt(ipD),1,One,FT(ipFjk1),1)
                else
                  call dGeMV_('T',iBas*lBas,jBas*kBas,Fac*qFctr*pFctr,Scrt,iBas*lBas,Dil(:,i1,i4),1,One,FT(ipFjk1),1)
                end if
                !call RecPrt('Fjk',' ',FT(ipFjk1),jBas,kBas)
                lFjk = .true.
              end if
            end if
          end if
        end if

      end do
    end do
  end do
end do

!write(u6,*) ' Fij'
nnIrrep = nIrrep
if (sIrrep) nnIrrep = 1
do iIrrep=0,nnIrrep-1
  !write(u6,'(I2,L1)') iIrrep,pert(iIrrep)
  if (pert(iIrrep)) then
    ip = ipDisp(abs(indgrd(iCar,iCent,iIrrep)))
    rCh = Prmt(iOper(kOp(iCent)),iChBas(1+iCar))*real(iChTbl(iIrrep,kOp(iCent)),kind=wp)
    Fact = tfact*rCh
    !write(u6,*) 'Level ij'
    if (lFij) call FckDst(TwoHam(ip),ndens,FT(ipFij),iBas,jBas,iCmpa(1),iCmpa(2),kOp2(1),kOp2(2),iIrrep,iShij,iAO(1),iAO(2), &
                          iAOst(1),iAOst(2),fact)
    !write(u6,*) 'Level kl'
    if (lFkl) call FckDst(TwoHam(ip),ndens,FT(ipFkl),kBas,lBas,iCmpa(3),iCmpa(4),kOp2(3),kOp2(4),iIrrep,iShkl,iAO(3),iAO(4), &
                          iAOst(3),iAOst(4),fact)
    !write(u6,*) 'Level ik'
    if (lFik) call FckDst(TwoHam(ip),ndens,FT(ipFik),iBas,kBas,iCmpa(1),iCmpa(3),kOp2(1),kOp2(3),iIrrep,iShik,iAO(1),iAO(3), &
                          iAOst(1),iAOst(3),fact)
    !write(u6,*) 'Level jl'
    if (lFjl) call FckDst(TwoHam(ip),ndens,FT(ipFjl),jBas,lBas,iCmpa(2),iCmpa(4),kOp2(2),kOp2(4),iIrrep,iShjl,iAO(2),iAO(4), &
                          iAOst(2),iAOst(4),fact)
    !write(u6,*) 'Level il'
    if (lFil) call FckDst(TwoHam(ip),ndens,FT(ipFil),iBas,lBas,iCmpa(1),iCmpa(4),kOp2(1),kOp2(4),iIrrep,iShil,iAO(1),iAO(4), &
                          iAOst(1),iAOst(4),fact)
    !write(u6,*) 'Level jk'
    if (lFjk) call FckDst(TwoHam(ip),ndens,FT(ipFjk),jBas,kBas,iCmpa(2),iCmpa(3),kOp2(2),kOp2(3),iIrrep,iShjk,iAO(2),iAO(3), &
                          iAOst(2),iAOst(3),fact)
    !if (DDot_(3468,TwoHam,1,TwoHam,1) > Zero) then
    !  if (Abs(DDot_(3468,TwoHam,1,One,0)) > 1.0e-16_wp) then
    !    write(u6,'(A,G20.6,G20.7)') 'TwoHam=',DDot_(3468,TwoHam,1,TwoHam,1),DDot_(3468,TwoHam,1,One,0)
    !  else
    !    write(u6,'(A,G20.6)') 'TwoHam=',DDot_(3468,TwoHam,1,TwoHam,1)
    !  end if
    !  TwoHam(1:3468) = Zero
    !end if
  end if
end do

return

#else

!***********************************************************************
!                                                                      *
!  Object: to accumulate contributions from the AO integrals directly  *
!          to the symmatry adapted Fock matrix.                        *
!                                                                      *
!          The indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!          In addition to this complication we have that the order of  *
!          indicies in the integrals are not ordered canonically but   *
!          rather in an order such that the contraction step will be   *
!          optimal. Hence, special care has to be taken when tracing   *
!          the density with the integrals so that both entities have   *
!          the same order.                                             *
!                                                                      *
!          The Fock matrix is computed in lower triangular form.       *
!                                                                      *
!          The density matrix is not folded if the shell indices and   *
!          the angular indices are identical.                          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden. February '93                            *
!                                                                      *
!     Modified July '98 in Tokyo by R. Lindh                           *
!***********************************************************************

use McKinley_global, only: sIrrep
use Index_Functions, only: nTri3_Elem
use Basis_Info, only: Shells
use Symmetry_Info, only: iChBas, iChTbl, iOper, nIrrep, Prmt
use SOAO_Info, only: iAOtSO
use Real_Spherical, only: iSphCr
use Gateway_Info, only: ThrInt !, CutInt
use Constants, only: Zero, One, Two, Half, Quart
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iAng(4), iCmp, jCmp, kCmp, lCmp, iShll(4), iShell(4), kOp(4), nijkl, nDens, nScrt, iAO(4), &
                                 iAOst(4), iBas, jBas, kBas, lBas, ij1, ij2, ij3, ij4, kl1, kl2, kl3, kl4, ik1, ik2, ik3, ik4, &
                                 il1, il2, il3, il4, jk1, jk2, jk3, jk4, jl1, jl2, jl3, jl4, nFT, iCar, iCent, &
                                 indgrd(3,4,0:nirrep-1), ipdisp(*)
logical(kind=iwp), intent(in) :: Shijij, Pert(0:nIrrep-1)
real(kind=wp), intent(in) :: AOInt(nijkl,iCmp,jCmp,kCmp,lCmp), Dij(ij1*ij2+1,ij3,ij4), Dkl(kl1*kl2+1,kl3,kl4), &
                             Dik(ik1*ik2+1,ik3,ik4), Dil(il1*il2+1,il3,il4), Djk(jk1*jk2+1,jk3,jk4), Djl(jl1*jl2+1,jl3,jl4), tfact
real(kind=wp), intent(inout) :: TwoHam(nDens)
real(kind=wp), intent(out) :: Scrt(nScrt), FT(nFT)
integer(kind=iwp) :: i1, i12, i2, i3, i34, i4, iChBs, iCmpa(4), ii, iIrrep, ijkl, iOpt, ip, ipDij, ipDik, ipDil, ipDjk, ipDjl, &
                     ipDkl, ipFij, ipFij1, ipFik, ipFik1, ipFil, ipFil1, ipFjk, ipFjk1, ipFjl, ipFjl1, ipFkl, ipFkl1, iSym(4), ix, &
                     j, jChBs, jCmpMx, jj, kChBs, kk, kOp2(4), lChBs, lCmpMx, ll, loc1, loc2, mijkl, nFij, nFik, nFil, nFjk, nFjl, &
                     nFkl, nnIrrep
real(kind=wp) :: D_ij, D_ik, D_il, D_jk, D_jl, D_kl, ExFac, Fac_ij, Fac_ik, Fac_il, Fac_jk, Fac_jl, Fac_kl, Fact, pEa, pFctr, pRb, &
                 pTc, pTSd, rCh, vij, vijkl, vik, vil, vjk, vjl, vkl
logical(kind=iwp) :: iQij, iQik, iQil, iQjk, iQjl, iQkl, iShij, iShik, iShil, iShjk, iShjl, iShkl, lFij, lFik, lFil, lFjk, lFjl, &
                     lFkl, Qijij

!iRout = 38
!iPrint = nPrint(iRout)
!
!if (iPrint >= 49) then
!   write(u6,*) ' FckAcc:AOIn',DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1), DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One,0)
!end if
!if (iPrint >= 99) then
!   call RecPrt('FckAcc:AOInt',' ',AOInt,nijkl,iCmp*jCmp*kCmp*lCmp)
!   write(u6,*) 'Dij=',XDot(Dij,ij1,ij2,ij3,ij4)
!   write(u6,*) 'Dkl=',XDot(Dkl,kl1,kl2,kl3,kl4)
!   write(u6,*) 'Dik=',XDot(Dik,ik1,ik2,ik3,ik4)
!   write(u6,*) 'Dil=',XDot(Dil,il1,il2,il3,il4)
!   write(u6,*) 'Djk=',XDot(Djk,jk1,jk2,jk3,jk4)
!   write(u6,*) 'Djl=',XDot(Djl,jl1,jl2,jl3,jl4)
!end if

ExFac = One
ThrInt = Zero
if (iBas*jBas*kBas*lBas > nScrt) then
  write(u6,*) 'FckAcc: nScrt too small!'
  call Abend()
end if
ii = nTri3_Elem(iAng(1))
jj = nTri3_Elem(iAng(2))
kk = nTri3_Elem(iAng(3))
ll = nTri3_Elem(iAng(4))

kOp2(1) = iOper(kOp(1))
kOp2(2) = iOper(kOp(2))
kOp2(3) = iOper(kOp(3))
kOp2(4) = iOper(kOp(4))
iCmpa(1) = iCmp
iCmpa(2) = jCmp
iCmpa(3) = kCmp
iCmpa(4) = lCmp
lFij = .false.
lFkl = .false.
lFik = .false.
lFjl = .false.
lFil = .false.
lFjk = .false.

ipFij = 1
nFij = iBas*jBas*iCmpa(1)*iCmpa(2)

ipFkl = ipFij+nFij
nFkl = kBas*lBas*iCmpa(3)*iCmpa(4)

ipFik = ipFkl+nFkl
nFik = iBas*kBas*iCmpa(1)*iCmpa(3)

ipFjl = ipFik+nFik
nFjl = jBas*lBas*iCmpa(2)*iCmpa(4)

ipFil = ipFjl+nFjl
nFil = iBas*lBas*iCmpa(1)*iCmpa(4)

ipFjk = ipFil+nFil
nFjk = jBas*kBas*iCmpa(2)*iCmpa(3)

FT(ipFij:ipFjk+nFjk-1) = Zero

ipDij = 1
ipDkl = 1
ipDik = 1
ipDil = 1
ipDjk = 1
ipDjl = 1
ipFij1 = 1
ipFkl1 = 1
ipFik1 = 1
ipFil1 = 1
ipFjk1 = 1
ipFjl1 = 1

! Quadruple loop over elements of the basis functions angular
! description. Loops are reduced to just produce unique SO integrals
! Observe that we will walk through the memory in AOInt in a
! sequential way.

iShij = iShell(1) == iShell(2)
iShkl = iShell(3) == iShell(4)
iShik = iShell(1) == iShell(3)
iShil = iShell(1) == iShell(4)
iShjk = iShell(2) == iShell(3)
iShjl = iShell(2) == iShell(4)
mijkl = iBas*jBas*kBas*lBas
do i1=1,iCmp
  ix = 0
  do j=0,nIrrep-1
    if (iAOtSO(iAO(1)+i1,j) > 0) ix = ibset(ix,j)
  end do
  iSym(1) = ix
  jCmpMx = jCmp
  if (iShij) jCmpMx = i1
  iChBs = iChBas(ii+i1)
  if (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+i1))
  pEa = Prmt(iOper(kOp(1)),iChBs)
  do i2=1,jCmpMx
    ix = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) ix = ibset(ix,j)
    end do
    iSym(2) = ix
    jChBs = iChBas(jj+i2)
    if (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+i2))
    pRb = Prmt(iOper(kOp(2)),jChBs)
    if (iShell(2) > iShell(1)) then
      i12 = jCmp*(i1-1)+i2
    else
      i12 = iCmp*(i2-1)+i1
    end if
    do i3=1,kCmp
      ix = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(3)+i3,j) > 0) ix = ibset(ix,j)
      end do
      iSym(3) = ix
      lCmpMx = lCmp
      if (iShkl) lCmpMx = i3
      kChBs = iChBas(kk+i3)
      if (Shells(iShll(3))%Transf) kChBs = iChBas(iSphCr(kk+i3))
      pTc = Prmt(iOper(kOp(3)),kChBs)
      do i4=1,lCmpMx
        ix = 0
        do j=0,nIrrep-1
          if (iAOtSO(iAO(4)+i4,j) > 0) ix = ibset(ix,j)
        end do
        iSym(4) = ix
        lChBs = iChBas(ll+i4)
        if (Shells(iShll(4))%Transf) lChBs = iChBas(iSphCr(ll+i4))
        pTSd = Prmt(iOper(kOp(4)),lChBs)
        if (iShell(4) > iShell(3)) then
          i34 = lCmp*(i3-1)+i4
        else
          i34 = kCmp*(i4-1)+i3
        end if
        if (Shijij .and. (i34 > i12)) cycle
        vijkl = 0
        do ijkl=1,mijkl
          vijkl = max(vijkl,abs(AOInt(ijkl,i1,i2,i3,i4)))
        end do
        !vijkl = DNrm2_(iBas*jBas*kBas*lBas,AOInt(1,i1,i2,i3,i4),1)
        !if (vijkl < CutInt) cycle

        Qijij = Shijij .and. (i12 == i34)
        iQij = iShij .and. (i1 == i2)
        iQkl = iShkl .and. (i3 == i4)
        iQik = iShik .and. (i1 == i3)
        iQil = iShil .and. (i1 == i4)
        iQjk = iShjk .and. (i2 == i3)
        iQjl = iShjl .and. (i2 == i4)
        pFctr = pEa*pRb*pTc*pTSd
        !***************************************************************

        Fac_ij = pFctr
        Fac_kl = pFctr
        Fac_ik = -Quart*pFctr
        Fac_jl = -Quart*pFctr
        Fac_il = -Quart*pFctr
        Fac_jk = -Quart*pFctr
        if (iQij) Fac_ij = Fac_ij*Half
        if (iQkl) Fac_kl = Fac_kl*Half
        if (iQjl .and. (.not. iQik)) Fac_ik = Fac_ik*Two
        if (iQik .and. (.not. iQjl)) Fac_jl = Fac_jl*Two
        if (iQjk .and. (.not. iQil)) Fac_il = Fac_il*Two
        if (iQil .and. (.not. iQjk)) Fac_jk = Fac_jk*Two

        D_ij = Two
        if (iQij) D_ij = One
        D_kl = Two
        if (iQkl) D_kl = One
        D_ik = Two
        if (iQik) D_ik = One
        D_jl = Two
        if (iQjl) D_jl = One
        D_il = Two
        if (iQil) D_il = One
        D_jk = Two
        if (iQjk) D_jk = One

        Fac_ij = Fac_ij*D_kl
        Fac_kl = Fac_kl*D_ij
        Fac_jl = Fac_jl*D_ik
        Fac_ik = Fac_ik*D_jl
        Fac_jk = Fac_jk*D_il
        Fac_il = Fac_il*D_jk

        !write(u6,*)
        !write(u6,*) 'iShell(1),iShell(2),i1,i2=',iShell(1),iShell(2),i1,i2
        !write(u6,*) 'Dij=',Dij(1,i1,i2)
        !write(u6,*) 'Fac_ij,iQij=',Fac_ij,iQij
        !write(u6,*)
        !write(u6,*) 'iShell(3),iShell(4),i3,i4=',iShell(3),iShell(4),i3,i4
        !write(u6,*) 'Dkl=',Dkl(1,i3,i4)
        !write(u6,*) 'Fac_kl,iQkl=',Fac_kl,iQkl
        !write(u6,*)
        if (Qijij) then
          Fac_kl = Zero
          Fac_jk = Zero
        end if
        if (iQij .and. iQkl) then
          Fac_jl = Zero
          Fac_il = Zero
          Fac_jk = Zero
        end if
        if (iQij .or. iQkl) then
          Fac_il = Zero
          Fac_jk = Zero
        end if
        !***************************************************************

        iOpt = 0
        ip = 1
        if ((iand(iSym(1),iSym(2)) /= 0) .or. (iand(iSym(3),iSym(4)) /= 0)) then
          iOpt = iOpt+1

          if (iShell(3) < iShell(4)) then
            vkl = Dkl(kBas*lBas+1,i4,i3)
            ipDkl = ip
            ip = ip+kBas*lBas
            call DGetMO(Dkl(1,i4,i3),kl1,kl1,kl2,Scrt(ipDkl),kl2)
          else
            vkl = Dkl(kBas*lBas+1,i3,i4)
            loc1 = (ixLoc(Dkl(1,i3,i4))-ixLoc(Scrt(1)))
            loc2 = (ixLoc(Scrt(2))-ixLoc(Scrt(1)))
            ipDkl = 1+loc1/loc2
          end if
          ipFij1 = ((i2-1)*iCmpa(1)+i1-1)*iBas*jBas+ipFij
          if (iShell(1) < iShell(2)) then
            vij = Dij(iBas*jBas+1,i2,i1)
            ipDij = ip
            ip = ip+iBas*jBas
            call DGeTMO(Dij(1,i2,i1),ij1,ij1,ij2,Scrt(ipDij),ij2)
          else
            vij = Dij(iBas*jBas+1,i1,i2)
            loc1 = (ixLoc(Dij(1,i1,i2))-ixLoc(Scrt(1)))
            loc2 = (ixLoc(Scrt(2))-ixLoc(Scrt(1)))
            ipDij = 1+loc1/loc2
          end if
          ipFkl1 = ((i4-1)*iCmpa(3)+i3-1)*kBas*lBas+ipFkl
          if ((vkl*vijkl*abs(Fac_ij) < ThrInt) .and. (vij*vijkl*abs(Fac_kl) < ThrInt)) then
            iOpt = iOpt-1
          else
            lFij = .true.
            lFkl = .true.
          end if
        end if

        if ((iand(iSym(1),iSym(3)) /= 0) .or. (iand(iSym(2),iSym(4)) /= 0)) then
          iOpt = iOpt+2

          if (iShell(2) < iShell(4)) then
            vjl = Djl(jBas*lBas+1,i4,i2)
            ipDjl = ip
            ip = ip+jBas*lBas
            call DGeTMO(Djl(1,i4,i2),jl1,jl1,jl2,Scrt(ipDjl),jl2)
          else
            vjl = Djl(jBas*lBas+1,i2,i4)
            loc1 = (ixLoc(Djl(1,i2,i4))-ixLoc(Scrt(1)))
            loc2 = (ixLoc(Scrt(2))-ixLoc(Scrt(1)))
            ipDjl = 1+loc1/loc2
          end if
          ipFik1 = ((i3-1)*iCmpa(1)+i1-1)*iBas*kBas+ipFik
          if (iShell(1) < iShell(3)) then
            vik = Dik(iBas*kBas+1,i3,i1)
            ipDik = ip
            ip = ip+iBas*kBas
            call DGeTMO(Dik(1,i3,i1),ik1,ik1,ik2,Scrt(ipDik),ik2)
          else
            vik = Dik(iBas*kBas+1,i1,i3)
            loc1 = (ixLoc(Dik(1,i1,i3))-ixLoc(Scrt(1)))
            loc2 = (ixLoc(Scrt(2))-ixLoc(Scrt(1)))
            ipDik = 1+loc1/loc2
          end if
          ipFjl1 = ((i4-1)*iCmpa(2)+i2-1)*jBas*lBas+ipFjl
          if ((vik*vijkl*abs(Fac_jl) < ThrInt) .and. (vjl*vijkl*abs(Fac_ik) < ThrInt)) then
            iOpt = iOpt-2
          else
            lFik = .true.
            lFjl = .true.
          end if
        end if

        if ((iand(iSym(1),iSym(4)) /= 0) .or. (iand(iSym(2),iSym(3)) /= 0)) then
          iOpt = iOpt+4

          if (iShell(2) < iShell(3)) then
            vjk = Djk(jBas*kBas+1,i3,i2)
            ipDjk = ip
            ip = ip+jBas*kBas
            call DGeTMO(Djk(1,i3,i2),jk1,jk1,jk2,Scrt(ipDjk),jk2)
          else
            vjk = Djk(jBas*kBas+1,i2,i3)
            loc1 = (ixLoc(Djk(1,i2,i3))-ixLoc(Scrt(1)))
            loc2 = (ixLoc(Scrt(2))-ixLoc(Scrt(1)))
            ipDjk = 1+loc1/loc2
          end if
          ipFil1 = ((i4-1)*iCmpa(1)+i1-1)*iBas*lBas+ipFil
          if (iShell(1) < iShell(4)) then
            vil = Dil(iBas*lBas+1,i4,i1)
            ipDil = ip
            ip = ip+iBas*lBas
            call DGeTMO(Dil(1,i4,i1),il1,il1,il2,Scrt(ipDil),il2)
          else
            vil = Dil(iBas*lBas+1,i1,i4)
            loc1 = (ixLoc(Dil(1,i1,i4))-ixLoc(Scrt(1)))
            loc2 = (ixLoc(Scrt(2))-ixLoc(Scrt(1)))
            ipDil = 1+loc1/loc2
          end if
          ipFjk1 = ((i3-1)*iCmpa(2)+i2-1)*jBas*kBas+ipFjk
          if ((vil*vijkl*abs(Fac_jk) < ThrInt) .and. (vjk*vijkl*abs(Fac_il) < ThrInt)) then
            iOpt = iOpt-4
          else
            lFil = .true.
            lFjk = .true.
          end if
        end if
        if (ip-1 > nScrt) then
          write(u6,*) 'FckAcc: nScrt too small!'
          call Abend()
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        select case (iOpt)
          case (1)
            call Fck1(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,Scrt(ipDij),FT(ipFij1),Fac_ij,Scrt(ipDkl),FT(ipFkl1),Fac_kl,ExFac)
          case (2)
            call Fck2(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,Scrt(ipDik),FT(ipFik1),Fac_ik,Scrt(ipDjl),FT(ipFjl1),Fac_jl,ExFac)
          case (3)
            call Fck3(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,Scrt(ipDij),FT(ipFij1),Fac_ij,Scrt(ipDkl),FT(ipFkl1),Fac_kl, &
                      Scrt(ipDik),FT(ipFik1),Fac_ik,Scrt(ipDjl),FT(ipFjl1),Fac_jl,ExFac)
          case (4)
            call Fck4(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,Scrt(ipDil),FT(ipFil1),Fac_il,Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
          case (5)
            call Fck5(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,Scrt(ipDij),FT(ipFij1),Fac_ij,Scrt(ipDkl),FT(ipFkl1),Fac_kl, &
                      Scrt(ipDil),FT(ipFil1),Fac_il,Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
          case (6)
            call Fck6(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,Scrt(ipDik),FT(ipFik1),Fac_ik,Scrt(ipDjl),FT(ipFjl1),Fac_jl, &
                      Scrt(ipDil),FT(ipFil1),Fac_il,Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
          case (7)
            call Fck7(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,Scrt(ipDij),FT(ipFij1),Fac_ij,Scrt(ipDkl),FT(ipFkl1),Fac_kl, &
                      Scrt(ipDik),FT(ipFik1),Fac_ik,Scrt(ipDjl),FT(ipFjl1),Fac_jl,Scrt(ipDil),FT(ipFil1),Fac_il,Scrt(ipDjk), &
                      FT(ipFjk1),Fac_jk,ExFac)
          case default
            ! nothing
        end select
        !***************************************************************

      end do
    end do
  end do
end do

nnIrrep = nIrrep
if (sIrrep) nnIrrep = 1
do iIrrep=0,nnIrrep-1

  if (pert(iIrrep)) then
    ip = ipDisp(abs(indgrd(iCar,iCent,iIrrep)))
    rCh = Prmt(iOper(kOp(iCent)),iChBas(1+iCar))*real(iChTbl(iIrrep,kOp(iCent)),kind=wp)
    Fact = tfact*rCh
    !write(u6,*) 'Level ij'
    if (lFij) call FckDst(TwoHam(ip),ndens,FT(ipFij),iBas,jBas,iCmpa(1),iCmpa(2),kOp2(1),kOp2(2),iIrrep,iShij,iAO(1),iAO(2), &
                          iAOst(1),iAOst(2),fact)
    !write(u6,*) 'Level kl'
    if (lFkl) call FckDst(TwoHam(ip),ndens,FT(ipFkl),kBas,lBas,iCmpa(3),iCmpa(4),kOp2(3),kOp2(4),iIrrep,iShkl,iAO(3),iAO(4), &
                          iAOst(3),iAOst(4),fact)
    !write(u6,*) 'Level ik'
    if (lFik) call FckDst(TwoHam(ip),ndens,FT(ipFik),iBas,kBas,iCmpa(1),iCmpa(3),kOp2(1),kOp2(3),iIrrep,iShik,iAO(1),iAO(3), &
                          iAOst(1),iAOst(3),fact)
    !write(u6,*) 'Level jl'
    if (lFjl) call FckDst(TwoHam(ip),ndens,FT(ipFjl),jBas,lBas,iCmpa(2),iCmpa(4),kOp2(2),kOp2(4),iIrrep,iShjl,iAO(2),iAO(4), &
                          iAOst(2),iAOst(4),fact)
    !write(u6,*) 'Level il'
    if (lFil) call FckDst(TwoHam(ip),ndens,FT(ipFil),iBas,lBas,iCmpa(1),iCmpa(4),kOp2(1),kOp2(4),iIrrep,iShil,iAO(1),iAO(4), &
                          iAOst(1),iAOst(4),fact)
    !write(u6,*) 'Level jk'
    if (lFjk) call FckDst(TwoHam(ip),ndens,FT(ipFjk),jBas,kBas,iCmpa(2),iCmpa(3),kOp2(2),kOp2(3),iIrrep,iShjk,iAO(2),iAO(3), &
                          iAOst(2),iAOst(3),fact)
  end if
end do

return

#endif

end subroutine FckAcc_Mck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function FindDetR(matrix,n)
! Function to find the determinant of a square matrix
!
! Description: The Subroutine is based on two key points:
!
! 1]  A determinant is unaltered when row operations are performed:
!     Hence, using this principle, row operations (column operations
!     would work as well) are used to convert the matrix the matrix
!     into upper triangular form
! 2]  The determinant of a triangular matrix is obtained by finding
!     the product of the diagonal elements

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: FindDetR
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(inout) :: matrix(N,N)
integer(kind=iwp) :: i, j, k
real(kind=wp) :: m, temp
logical(kind=iwp) :: DetExists
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)

DetExists = .true.
temp = 0
! Convert to upper triangular form
do k=1,N-1
  if (abs(matrix(k,k)) < MINIMAL_REAL) then
    DetExists = .false.
    do i=k+1,N
      if (abs(matrix(i,k)) > MINIMAL_REAL) then
        do j=1,N
          temp = matrix(i,j)
          matrix(i,j) = matrix(k,j)
          matrix(k,j) = temp
        end do
        DetExists = .true.
      end if
    end do
    if (.not. DetExists) then
      FindDetR = 0
      return
    end if
  end if
  do j=k+1,N
    m = matrix(j,k)/matrix(k,k)
    matrix(j,k+1:N) = matrix(j,k+1:N)-m*matrix(k,k+1:N)
  end do
end do ! k
! Evaluate determinant by finding product of diagonal elements
FindDetR = One
do i=1,N
  FindDetR = FindDetR*matrix(i,i)
end do

return

end function FindDetR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Niclas Forsberg                                  *
!***********************************************************************

subroutine SolveSort(A,C,S,D,W1,W2,W0,C1,C2,C0,r01,r02,r00,icre,iann,nMat,nd1,nd2,OccNumMat,nOsc,nDimTot)
!  Purpose:
!    Solve the secular equation AC = SCD.
!
!  Input:
!    A         : Real two dimensional array
!    S         : Real two dimensional array
!    W0,W1,W2  : Real two dimensional arrays - eigenvectors scaled by square root of harmonic frequencies.
!    C0,C1,C2  : Real two dimensional arrays - inverses of W0,W1 and W2.
!    r00,
!    r01,
!    r02       : Real arrays - geometry in internal coordinates.
!    nMat      : Two dimensional integer array
!
!  Output:
!    C         : Real two dimensional array
!    D         : Real array
!    OccNumMat : Real two dimensional array - occupation numbers for the different modes.
!
!  Calls:
!    Jacob
!    Jacord
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Eight, Half, auTocm
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nd1, nd2, icre(0:nd1,nd2), iann(0:nd1,nd2), nMat(0:nd1,nd2), nOsc, nDimTot
real(kind=wp), intent(in) :: A(nDimTot,nDimTot), W1(nOsc,nOsc), W2(nOsc,nOsc), W0(nOsc,nOsc), C1(nOsc,nOsc), C2(nOsc,nOsc), &
                             C0(nOsc,nOsc), r01(nOsc), r02(nOsc), r00(nOsc)
real(kind=wp), intent(out) :: C(nDimTot,nDimTot), D(nDimTot), OccNumMat(0:nDimTot-1,nOsc)
real(kind=wp), intent(inout) :: S(nDimTot,nDimTot)
integer(kind=iwp) :: i, ii, iOsc, j, jOsc, k, l, la, lc, m, n
real(kind=wp) :: det
real(kind=wp), allocatable :: A1(:,:), A2(:,:), alpha(:,:), alpha1(:,:), alpha2(:,:), Asymm(:,:), B1(:,:), B2(:,:), beta(:,:), &
                              C_col(:), d1(:), d2(:), r_temp1(:), r_temp2(:), SC_col(:), Scr(:), T(:,:), temp1(:,:), temp2(:,:), &
                              Tmp1(:,:)
real(kind=wp), external :: Ddot_

! Initialize.
n = nDimTot
call mma_allocate(Scr,n*(n+1)/2,label='Scr')
call mma_allocate(T,n,n,label='T')
call mma_allocate(Tmp1,n,n,label='T')
call mma_allocate(Asymm,n,n,label='Asymm')

! Cholesky decomposition of S.
do i=1,n
  S(i,i) = S(i,i)+1.0e-6_wp
end do
call Cholesky(S,Tmp1,n)
T(:,:) = Zero
do i=1,n
  T(i,i) = One
end do
call Dool_MULA(Tmp1,n,n,T,n,n,det)

! Make A symmetric and transform it to lower packed storage in Scratch.
call DGEMM_('N','N',n,n,n,One,A,n,T,n,Zero,Tmp1,n)
call DGEMM_('T','N',n,n,n,One,T,n,Tmp1,n,Zero,Asymm,n)
k = 1
do i=1,n
  do j=1,i
    Scr(k) = Asymm(i,j)
    k = k+1
  end do
end do

! Diagonalize Scratch.
Tmp1(:,:) = Zero
do i=1,n
  Tmp1(i,i) = One
end do
call Jacob(Scr,Tmp1,n,n)
call Jacord(Scr,Tmp1,n,n)

! Store the eigenvalues in array D and calculate C.
do i=1,n
  ii = i*(i+1)/2
  D(i) = Scr(ii)
end do

call DGEMM_('N','N',n,n,n,One,T,n,Tmp1,n,Zero,C,n)
call mma_deallocate(Scr)
call mma_deallocate(T)
call mma_deallocate(Tmp1)
call mma_deallocate(Asymm)

! Calculate alpha1, alpha2 and alpha.
call mma_allocate(temp1,nOsc,nOsc,label='temp1')
call mma_allocate(temp2,nOsc,nOsc,label='temp2')

call mma_allocate(alpha,nOsc,nOsc,label='alpha')
call mma_allocate(alpha1,nOsc,nOsc,label='alpha1')
call mma_allocate(alpha2,nOsc,nOsc,label='alpha2')

call DGEMM_('T','N',nOsc,nOsc,nOsc,Half,C1,nOsc,C1,nOsc,Zero,alpha1,nOsc)
call DGEMM_('T','N',nOsc,nOsc,nOsc,Half,C2,nOsc,C2,nOsc,Zero,alpha2,nOsc)
call DGEMM_('T','N',nOsc,nOsc,nOsc,Half,C0,nOsc,C0,nOsc,Zero,alpha,nOsc)

! Calculate beta.
call mma_allocate(beta,nOsc,nOsc,label='beta')
call mma_allocate(r_temp1,nOsc,label='r_temp1')
call mma_allocate(r_temp2,nOsc,label='r_temp2')

temp1(:,:) = alpha1
temp2(:,:) = Two*alpha

call Dool_MULA(temp2,nOsc,nOsc,temp1,nOsc,nOsc,det)
call DGEMM_('N','N',nOsc,nOsc,nOsc,One,alpha2,nOsc,temp1,nOsc,Zero,beta,nOsc)

! Calculate A, B and d matrices.
call mma_allocate(A1,nOsc,nOsc,label='A1')
call mma_allocate(B1,nOsc,nOsc,label='B1')
call mma_allocate(A2,nOsc,nOsc,label='A2')
call mma_allocate(B2,nOsc,nOsc,label='B2')
call mma_allocate(d1,nOsc,label='d1')
call mma_allocate(d2,nOsc,label='d2')
call DGEMM_('N','N',nOsc,nOsc,nOsc,One,C1,nOsc,W0,nOsc,Zero,A1,nOsc)
call DGEMM_('T','T',nOsc,nOsc,nOsc,One,W1,nOsc,C0,nOsc,Zero,temp1,nOsc)
B1(:,:) = A1-temp1
r_temp1(:) = r01-r00
call DGEMM_('N','N',nOsc,1,nOsc,One,beta,nOsc,r_temp1,nOsc,Zero,r_temp2,nOsc)
call DGEMM_('T','N',nOsc,1,nOsc,sqrt(Eight),W1,nOsc,r_temp2,nOsc,Zero,d1,nOsc)
call DGEMM_('N','N',nOsc,nOsc,nOsc,One,C2,nOsc,W0,nOsc,Zero,A2,nOsc)
call DGEMM_('T','T',nOsc,nOsc,nOsc,One,W2,nOsc,C0,nOsc,Zero,temp2,nOsc)
B2(:,:) = A2-temp2
r_temp1(:) = r02-r00
call DGEMM_('N','N',nOsc,1,nOsc,One,beta,nOsc,r_temp1,nOsc,Zero,r_temp2,nOsc)
call DGEMM_('T','N',nOsc,1,nOsc,sqrt(Eight),W2,nOsc,r_temp2,nOsc,Zero,d2,nOsc)

call mma_deallocate(temp1)
call mma_deallocate(temp2)

call mma_deallocate(alpha)
call mma_deallocate(alpha1)
call mma_deallocate(alpha2)

call mma_deallocate(beta)
call mma_deallocate(r_temp1)
call mma_deallocate(r_temp2)

m = (n/2)-1

call mma_allocate(C_col,[0,n-1],label='C_col')
call mma_allocate(SC_col,[0,n-1],label='SC_col')
OccNumMat(:,:) = Zero
do k=1,n
  do jOsc=1,nOsc
    C_col(:) = Zero
    do l=0,m
      do iOsc=1,nOsc
        lc = iCre(l,iosc)
        la = iAnn(l,iosc)
        if (lc >= 0) C_col(lc) = C_col(lc)+sqrt(real(nmat(lc,iosc),kind=wp))*c(l+1,k)*B1(iosc,josc)
        if (la >= 0) C_col(la) = C_col(la)+sqrt(real(nmat(l,iosc),kind=wp))*c(l+1,k)*A1(iosc,josc)
      end do
      C_col(l) = C_col(l)-c(l+1,k)*d1(josc)
    end do
    do l=0,m
      do iOsc=1,nOsc
        lc = icre(l,iosc)
        la = iann(l,iosc)
        if (lc >= 0) C_col(m+lc+1) = C_col(m+lc+1)+sqrt(real(nmat(lc,iosc),kind=wp))*c(m+l+2,k)*B2(iosc,josc)
        if (la >= 0) C_col(m+la+1) = C_col(m+la+1)+sqrt(real(nmat(l,iosc),kind=wp))*c(m+l+2,k)*A2(iosc,josc)
      end do
      C_col(m+l+1) = C_col(m+l+1)-c(m+l+2,k)*d2(josc)
    end do
    call DGEMM_('N','N',n,1,n,One,S,n,C_col,n,Zero,SC_col,n)
    OccNumMat(k-1,jOsc) = Ddot_(n,C_col,1,SC_col,1)
  end do
end do
write(u6,*)
write(u6,*) 'Frequencies'
write(u6,'(20i6)') (int((D(i+1)-D(1))*auTocm),i=1,m)
write(u6,*)

call mma_deallocate(A1)
call mma_deallocate(B1)
call mma_deallocate(A2)
call mma_deallocate(B2)
call mma_deallocate(d1)
call mma_deallocate(d2)
call mma_deallocate(C_col)
call mma_deallocate(SC_col)

end subroutine SolveSort

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine CarSph(Win,nab,nijx,Scrt,nScrt,Coeff1,n1,Tr1,Pr1,
     &                  Coeff2,n2,Tr2,Pr2,Wout,mab)
************************************************************************
*                                                                      *
*  Object: to transform the one electron integrals from cartesian      *
*          basis to spherical basis.                                   *
*                                                                      *
* Called from: OneEl                                                   *
*                                                                      *
* Calling    : RecPrt                                                  *
*              DGEMM_   (ESSL)                                         *
*              DGeTMO   (ESSL)                                         *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             February '90                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
      Real*8 Win(nab*nijx), Scrt(nScrt),
     &       Coeff1((n1+1)*(n1+2)/2,(n1+1)*(n1+2)/2),
     &       Coeff2((n2+1)*(n2+2)/2,(n2+1)*(n2+2)/2),
     &       Wout(mab*nijx)
      Logical Tr1, Pr1, Tr2, Pr2
*
      iRout = 26
      iPrint = nPrint(iRout)
      l1=(n1+1)*(n1+2)/2
      k1=l1
      If (Pr1) k1 = 2*n1 + 1
      l2=(n2+1)*(n2+2)/2
      k2 = l2
      If (Pr2) k2 = 2*n2 + 1
*
      If (Tr1.and.Tr2) Then
*
*        Starting with a,bIJx transforming to bIJx,A
*
         Call DGEMM_('T','N',
     &               l2*nijx,k1,l1,
     &               1.0d0,Win,l1,
     &               Coeff1,l1,
     &               0.0d0,Scrt,l2*nijx)
*
*        Transform b,IJxA to IJxAB
*
         Call DGEMM_('T','N',
     &               nijx*k1,k2,l2,
     &               1.0d0,Scrt,l2,
     &               Coeff2,l2,
     &               0.0d0,Wout,nijx*k1)
*
      Else If(Tr2) Then
*
*        Transpose from ab,IJ,x to b,IJ,x,a
*
         Call DGeTmO(Win,l1,l1,l2*nijx,Scrt,l2*nijx)
*
*        Start transforming b,IJ,x,a to IJ,x,aB
*
         Call DGEMM_('T','N',
     &               nijx*l1,k2,l2,
     &               1.0d0,Scrt,l2,
     &               Coeff2,l2,
     &               0.0d0,Wout,nijx*l1)
      Else
*
*        Starting with a,bIJx transforming to AbIJx
*
         Call DGEMM_('T','N',
     &               k1,l2*nijx,l1,
     &               1.0d0,Coeff1,l1,
     &               Win,l1,
     &               0.0d0,Scrt,k1)
*
*        Transpose to IJxAb
*
         Call DGeTmO(Scrt,k1*l2,k1*l2,nijx,Wout,nijx)
      End If
*
*     Call GetMem('CarSph','CHEC','REAL',iDum,iDum)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine makecivbhs_cvb(civbh,civbs,orbs,gjorb,gjorb2,gjorb3)
c  Construct CIVBS ( = T(s) * CIVB ) & CIVBH ( = T(O)*H*T(O) * CIVB ):
      implicit real*8 (a-h,o-z)
c ... Content of CI vectors ...
      logical, external :: tstcnt_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension orbs(norb,norb)
      dimension civbh(ndet),civbs(ndet)
      dimension gjorb(*),gjorb2(*),gjorb3(*)

      if(tstcnt_cvb(civbs,4).and.tstcnt_cvb(civbh,5))then
        return
      elseif(tstcnt_cvb(civbs,4))then
        call applyth_cvb(civbh,orbs,gjorb,gjorb2,gjorb3)
      elseif(tstcnt_cvb(civbs,5))then
        call applyts_cvb(civbs,orbs,gjorb,gjorb2,gjorb3)
      else
        call applyths_cvb(civbh,civbs,orbs,gjorb,gjorb2,gjorb3)
      endif
      call setcnt_cvb(civbs,4)
      call setcnt_cvb(civbh,5)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine schmidt2_cvb(c,sxc,cnrm,nvec,sao,n,metr)
      implicit real*8 (a-h,o-z)
      dimension c(n,nvec),sxc(n,nvec),cnrm(nvec),sao(*)
      save thresh
      data thresh/1d-20/

      do 100 i=1,nvec
      do 200 j=1,i-1
      if(cnrm(j).gt.thresh)
     >  call daxpy_(n,-ddot_(n,c(1,i),1,sxc(1,j),1)/cnrm(j),
     >  c(1,j),1,c(1,i),1)
200   continue
      if(metr.ne.0)call saoon_cvb(c(1,i),sxc(1,i),1,sao,n,metr)
      cnrm(i)=ddot_(n,c(1,i),1,sxc(1,i),1)
100   continue
      return
      end

************************************************************************
************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,1997, Roland Lindh                                *
*               2014, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine RS_P_RFO(H,g,nInter,dq,UpMeth,dqHdq,StepMax,
     &                    Step_Trunc)
************************************************************************
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             December '94                                             *
*                                                                      *
*                                                                      *
*             Solve      | H    g | | d |     | 1 0 | | d |            *
*                        |  T     | |   | = e |     | |   |            *
*                        | g    0 | | 1 |     | 0 1 | | 1 |            *
*                                                                      *
*             this corresponds to                                      *
*                                                                      *
*             H d + g = e d                                            *
*                                                                      *
*             and                                                      *
*                                                                      *
*               T                                                      *
*             g  d = e                                                 *
*                                                                      *
*             Modified from single negative eigenvalue to an arbitrary *
*             number, June '97, R. Lindh                               *
*                                                                      *
*             Removed full diagonalizations, April '14, I. Fdez. Galvan*
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
      Real*8 H(nInter,nInter), g(nInter), dq(nInter), Lambda
      Real*8, Allocatable:: Mat(:), Val(:), Vec(:,:), Tmp(:,:)
      Real*8, Allocatable:: MatN(:), ValN(:), VecN(:), TmpN(:),
     &        StepN(:), GradN(:)
      Real*8, Allocatable:: MatP(:), ValP(:), VecP(:), TmpP(:),
     &        StepP(:), GradP(:)
*
      Character*6 UpMeth
      Character*1 Step_Trunc
      Logical Found,Iterate
*
      iRout = 215
      Lu =6
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In RS_P_RFO: H','(10f10.6)',H,nInter,nInter)
         Call RecPrt(' In RS_P_RFO: g','(10f10.6)', g,nInter,1)
         Call RecPrt(' In RS_P_RFO:dq','(10f10.6)',dq,nInter,1)
      End If
*
      UpMeth='RSPRFO'
*
      NumVal=Min(2,nInter)
      nVStep=2
      Found=.False.
      Thr=1.0D-6
      Call mma_allocate(Vec,nInter,NumVal,Label='Vec')
      Call mma_allocate(Val,NumVal,Label='Val')
      Call mma_allocate(Mat,nInter*(nInter+1)/2,Label='Mat')
      Vec(:,:)=Zero
      Do i = 1, nInter
         Do j = 1, i
            ij = i*(i-1)/2+j
            Mat(ij)=H(i,j)
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Find the negative eigenvalue(s)
*     Stop when the highest eigenvalue found is larger than Thr
      Do While (.Not.Found)
        Call Davidson(Mat,nInter,NumVal,Val,Vec,iStatus)
        If (iStatus.gt.0) Then
          Call SysWarnMsg('RS_P_RFO',
     &      'Davidson procedure did not converge','')
        End If
        If ((Val(NumVal).gt.Thr).or.(NumVal.ge.nInter)) Then
          Found=.True.
        Else
*----     Increase the number of eigenpairs to compute
          Call mma_allocate(Tmp,nInter,NumVal,Label='Tmp')
          Tmp(:,:) = Vec(:,:)
          Call mma_deallocate(Vec)
          Call mma_deallocate(Val)

          NumVal=Min(NumVal+nVStep,nInter)

          Call mma_allocate(Vec,nInter,NumVal,Label='Vec')
          Vec(:,:)=Zero
          Call mma_allocate(Val,NumVal,Label='Val')
          Val(:)=Zero

          Vec(:,1:NumVal-nVStep) = Tmp(:,:)

          Call mma_deallocate(Tmp)
        End If
      End Do
      Call mma_deallocate(Mat)
*
      nNeg=0
      i=NumVal
      Do While ((i.ge.0).and.(nNeg.eq.0))
         If (Val(i).lt.Zero) nNeg=i
         i=i-1
      End Do
      If (iPrint.ge.99) Then
         Call RecPrt(' In RS_P_RFO: Eigenvalues',' ',Val,1,NumVal)
         Call RecPrt(' In RS_P_RFO: Eigenvectors',' ',Vec,nInter,NumVal)
         Write (Lu,*) ' nNeg=',nNeg
      End If
*
      If (iPrint.ge.6) Then
         Write (Lu,*)
         Write (Lu,*) 'RS-P-RF Optimization'
         Write (Lu,*) ' Iter   alpha        dqdq  StepMax'//
     &                '   EigVal_r  EigVal_t'
      End If
*
*     Write (Lu,*) 'Trust radius=',StepMax
      A_RFO=One   ! Initial seed of alpha
      IterMx=25
      Iter=0
      Iterate=.False.
      Thr=1.0D-7
      If (nNeg.gt.0) Then
         mInter=nNeg+1
         Call mma_allocate(StepN,nInter,Label='StepN')
         Call mma_allocate(GradN,nInter,Label='GradN')
         Call mma_allocate(VecN,mInter,Label='VecN')
         Call mma_allocate(ValN,1,Label='ValN')
         Call mma_allocate(MatN,mInter*(mInter+1)/2,Label='MatN')
         Call mma_allocate(TmpN,mInter,Label='TmpN')
         TmpN(:)=Zero
      End If
      mInter=nInter+1
      Call mma_allocate(StepP,nInter,Label='StepP')
      Call mma_allocate(GradP,nInter,Label='GradP')
      Call mma_allocate(VecP,mInter,Label='VecP')
      Call mma_allocate(ValP,1,Label='ValP')
      Call mma_allocate(MatP,mInter*(mInter+1)/2,Label='MatP')
      Call mma_allocate(TmpP,mInter,Label='TmpP')
      TmpP(:) = Zero
 998  Continue
         Iter=Iter+1
*        Write (Lu,*) 'Iter=',Iter
*        Write (Lu,*) 'A_RFO=',A_RFO
         Call DZero(dq,nInter)
         If (nNeg.gt.0) Then
*           write(Lu,*)
*           write(Lu,*) 'Process negative eigenvalues.'
*           write(Lu,*)
            mInter=nNeg+1
*                                                                      *
************************************************************************
*                                                                      *
*--------   Build the augmented matrix of the "negative" subspace
*            diagonal: negative eigenvalues (divided by alpha)
*            last row/column: components of the gradient along the
*                     negative eigenvectors (divided by sqrt(alpha))
*           Project the gradient in the negative subspace (but expressed
*           in the full space)
*           (Note that, since we are interested in the largest eigenvalue,
*            the whole matrix is multiplied by -1, so we actually find the
*            smallest eigenvalue and change its sign)
            GradN(:)=Zero
            MatN(:) =Zero
            j=mInter*(mInter-1)/2
            Do i=1,nNeg
               MatN(i*(i+1)/2)=-Val(i)/A_RFO
               gv=DDot_(nInter,g,1,Vec(:,i),1)
               MatN(j+i)=gv/Sqrt(A_RFO)
               Call DaXpY_(nInter,gv,Vec(:,i),1,GradN,1)
            End Do
*
*--------   Solve the partial RFO system for the negative subspace
            VecN(:) = TmpN(:)
            Call Davidson(MatN,mInter,1,ValN,VecN,iStatus)
            TmpN(:) = VecN(:)
            If (iStatus.gt.0) Then
               Call SysWarnMsg('RS_P_RFO',
     &              'Davidson procedure did not converge','')
            End If
            ValN(1) = - ValN(1)
*
*--------   Scale the eigenvector (combines eqs. (5) and (23))
*           Convert to full space and add to complete step
            Call DScal_(nNeg,One/(Sqrt(A_RFO)*VecN(1+nNeg)),VecN,1)
            Call dGeMV_('N',nInter,nNeg,One,Vec,nInter,
     &                                  VecN,1,Zero,StepN,1)
            Call DaXpY_(nInter,One,StepN,1,dq,1)
*           dqdq_max=Sqrt(DDot_(nInter,StepN,1,StepN,1))
*           write (Lu,*) 'dqdq_max=',dqdq_max
!           Sign
            EigVal_r=-DDot_(nInter,StepN,1,GradN,1)
            If (iPrint.ge.99) Then
               Call RecPrt('dq_r',' ',StepN,1,nInter)
               Call RecPrt(' g_r',' ',GradN,1,nInter)
               Write (Lu,*) 'Lambda=',EigVal_r
            End If
            If (EigVal_r.lt.-Thr) Then
               Write (Lu,*)
               Write (Lu,*) 'W A R N I N G !'
               Write (Lu,*) 'EigVal_r.lt.Zero',EigVal_r
               Write (Lu,*)
            End If
         Else
            EigVal_r=Zero
*           dqdq_max=Zero
         End If
*
*        write(Lu,*)
*        write(Lu,*) 'Process positive eigenvalues.'
*        write(Lu,*)
         mInter=nInter+1
*                                                                      *
************************************************************************
*                                                                      *
*----    Build the augmented matrix of the "positive" subspace
*        Instead of reducing the dimensions, the negative eigenvectors
*        are simply projected out from the gradient and the eigenvalues
*        are shifted to a large positive arbitrary value (10), to avoid
*        interferences
         GradP(:) = g(:)
         Do i=1,nNeg
           gv=DDot_(nInter,GradP(:),1,Vec(:,i),1)
           Call DaXpY_(nInter,-gv,Vec(:,i),1,GradP(:),1)
         End Do
         Do j=1,nInter
           call dcopy_(j,H(1,j),1,MatP(1+j*(j-1)/2),1)
           Do i=1,nNeg
             Do k=1,j
               jk=j*(j-1)/2+k
               MatP(jk)=MatP(jk)-(Val(i)-Ten)*Vec(j,i)*Vec(k,i)
             End Do
           End Do
           Call DScal_(j,One/A_RFO,MatP(1+j*(j-1)/2),1)
         End Do
         Call DZero(MatP(1+mInter*(mInter-1)/2),mInter)
         Call DaXpY_(nInter,-One/Sqrt(A_RFO),GradP(:),1,
     &                     MatP(1+mInter*(mInter-1)/2),1)
*
*----    Solve the partial RFO system for the positive subspace
         call dcopy_(mInter,TmpP(:),1,VecP(:),1)
         Call Davidson(MatP,mInter,1,ValP,VecP,iStatus)
         If (iStatus.gt.0) Then
           Call SysWarnMsg('RS_P_RFO',
     &          'Davidson procedure did not converge','')
         End If
         TmpP(1:mInter) = VecP(1:mInter)
         StepP(1:nInter) = VecP(1:nInter)
*
*----    Scale the eigenvector (combines eqs. (5) and (23))
*        Add to complete step
         Call DScal_(nInter,One/(Sqrt(A_RFO)*VecP(1+nInter)),StepP,1)
         Call DaXpY_(nInter,One,StepP,1,dq,1)
*        dqdq_min=Sqrt(DDot_(nInter,StepP,1,StepP,1))
*        write (Lu,*) 'dqdq_min=',dqdq_min
         EigVal_t=-DDot_(nInter,StepP,1,GradP,1) ! Sign
         If (iPrint.ge.99) Then
           Call RecPrt('dq_t',' ',StepP,1,nInter)
           Call RecPrt(' g_t',' ',GradP,1,nInter)
           Write (Lu,*) 'Lambda=',EigVal_t
         End If
         If (EigVal_t.gt.Thr) Then
           Write (Lu,*)
           Write (Lu,*) 'W A R N I N G !'
           Write (Lu,*) 'EigVal_t.gt.Zero',EigVal_t
           Write (Lu,*)
         End If
*
      Lambda = EigVal_t + EigVal_r
      dqdq=Sqrt(DDot_(nInter,dq,1,dq,1))
*
      If (iPrint.ge.6)
     &  Write (Lu,'(I5,5F10.5)') Iter,A_RFO,dqdq,StepMax,
     &                           EigVal_r,EigVal_t
*                                                                      *
************************************************************************
*                                                                      *
*------- Initialize data for iterative scheme (only at first iteration)
*
         If (.Not.Iterate) Then
            A_RFO_long=A_RFO
            dqdq_long=dqdq
            A_RFO_short=Zero
            dqdq_short=dqdq_long+One
         End If
*                                                                      *
************************************************************************
*                                                                      *
*------- RF with constraints. Start iteration scheme if computed step
*        is too long.
*
         If (Iter.eq.1.and.dqdq.gt.StepMax) Iterate=.True.
*                                                                      *
************************************************************************
*                                                                      *
*        Procedure if the step length is not equal to the trust radius
*
         If (Iterate.and.Abs(StepMax-dqdq).gt.Thr) Then
            Step_Trunc='*'
*           Write (Lu,*) 'StepMax-dqdq=',StepMax-dqdq
            Call Find_RFO_Root(A_RFO_long,dqdq_long,
     &                         A_RFO_short,dqdq_short,
     &                         A_RFO,dqdq,StepMax)
            If (Iter.gt.IterMx) Then
               Write (Lu,*) ' Too many iterations in RF'
               Go To 997
            End If
            Go To 998
         End If
*
 997  Continue

      Call mma_deallocate(Vec)
      Call mma_deallocate(Val)

      If (nNeg.gt.0) Then
         mInter=nNeg+1
         Call mma_deallocate(StepN)
         Call mma_deallocate(GradN)
         Call mma_deallocate(VecN)
         Call mma_deallocate(ValN)
         Call mma_deallocate(MatN)
         Call mma_deallocate(TmpN)
      End If
      mInter=nInter+1
      Call mma_deallocate(StepP)
      Call mma_deallocate(GradP)
      Call mma_deallocate(VecP)
      Call mma_deallocate(ValP)
      Call mma_deallocate(MatP)
      Call mma_deallocate(TmpP)
*
      If (iPrint.ge.6) Then
         Write (Lu,*)
         Write (Lu,*)
         Write (Lu,*) 'Rational Function Optimization: Lambda=',Lambda
         Write (Lu,*)
      End If
      dqHdq=dqHdq+Lambda*Half
*
      If (iPrint.ge.99) Then
         Write (Lu,*) 'EigVal,dqHdq=',Lambda,dqHdq
         Call RecPrt(' In RS_P_RFO: g','(10f10.6)', g,nInter,1)
         Call RecPrt(' In RS_P_RFO:dq','(10f10.6)',dq,nInter,1)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SYG2SGU(IMODE,SGS,CIS,LSYM,ICNFTAB,ISPNTAB,CIOLD,CINEW)
! SGS       : Data that define a Split Graph
! qCIS : Data that define a CI array structure
! IMODE=0 transforms a Symmetric Group CI array to SGUGA
! IMODE=1 transforms a Split GUGA CI array to Symm Group
! ...Configuration and Spin Coupling tables, fill this in later.
! CIOLD and CINEW are obvious.

use rassi_aux, only: ipglob
use sguga, only: CIStruct, SGStruct
use Molcas, only: MxLev
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IMODE, LSYM, ICNFTAB(*), ISPNTAB(*)
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(in) :: CIS
real(kind=wp), intent(in) :: CIOLD(*)
real(kind=wp), intent(_OUT_) :: CINEW(*)
integer(kind=iwp), parameter :: IFUP2CS(0:1) = [2,1], MXCPI = 15, NBUFFER = 600
integer(kind=iwp) :: I, ICASE(400), ICNF, ICNUM(NBUFFER), ICPL, ICSPLT, ICSYMG, IEL, IEL1, IEL2, IFORM, IFUP, IOCC, IORB, IREST, &
                     IWLKPOS, IWORD, IWRD, KCNF, KCNFINF, KCPL, KGSLIM, KGSORB, KSPNINF, KWALK(NBUFFER), LEV, MAXOP, MINOP, &
                     MIPWLK, MXWLK, NACTEL, NAPART, NCLSD, NCNF, NCONF, NCPL, NCSYMG, NHEAD, NLEV, NOCC, NODD, NOPEN, NSYM, NWALK, &
                     NWLKLST, NWRD
real(kind=wp) :: PHASE(NBUFFER), PHS
integer(kind=iwp), allocatable :: MWS2W(:), OrbArr(:)

! Dereference CIS and SGS       for some data:
NCONF = CIS%NCSF(LSYM)
NWALK = CIS%nWalk
call mma_allocate(MWS2W,NWALK,Label='MWS2W')
NSYM = ICNFTAB(7)
call MSTOW(SGS,CIS,MWS2W,NSYM)
! MWS2W is a table which gives the upper or lower walk
! index as function of the MAW sum.

! Inspect the top row of the DRT to find NACTEL and spin:
NLEV = SGS%DRT(1,1)
if (NLEV > MXLEV) then
  write(u6,*) ' SYG2SGU: error: number of levels exceeds MXLEV'
  write(u6,'(1X,2(A,I4))') ' NLEV = ',NLEV,' MXLEV = ',MXLEV
  call AbEnd()
end if
NACTEL = SGS%DRT(1,2)

! Now a good bound on MINOP, the minimum number of open
! shells, would be MLTPLC-1. This is the best bound, and it
! does not depend on any assumed Ms.

! A buffer of packed walks is used:
NWLKLST = 0
IWLKPOS = 1
! Nr of integers used to store each total walk:
MIPWLK = 1+(NLEV-1)/MXCPI
! Max nr of Split-Graph CSF's, stored as walks in the
! buffer KWALK
MXWLK = NBUFFER/MIPWLK
! Pick up various data from conf and spin tables
! Unbutton Configuration table:

MINOP = ICNFTAB(5)
MAXOP = ICNFTAB(6)
NSYM = ICNFTAB(7)
if (LSYM /= ICNFTAB(8)) call abend()
NAPART = ICNFTAB(9)
IFORM = ICNFTAB(10)
!PAM07 Statement to fool intel 10.1 compiler do do the right thing:
if (MINOP > MAXOP) write(u6,*) MINOP,MAXOP

NHEAD = 10
KGSORB = NHEAD+1
KGSLIM = KGSORB+(NSYM+1)*(NAPART+1)
KCNFINF = KGSLIM+2*NAPART
! Unbutton Spin table:
KSPNINF = 9
call mma_allocate(ORBARR,NACTEL,Label='OrbArr')

! Loop over nr of open shells
! NCSYMG=Nr of Symmetric-Group CSF's treated so far.
NCSYMG = 0
do NOPEN=MINOP,MAXOP
  NCLSD = (NACTEL-NOPEN)/2
  if (NCLSD < 0) cycle
  if (2*NCLSD+NOPEN /= NACTEL) cycle
  NOCC = NCLSD+NOPEN
  if (NOCC > NLEV) cycle
  NCNF = ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP)))
  KCNF = ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP))+1)
  NWRD = ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP))+2)
  NCPL = ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+1)
  KCPL = ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+3)

  ! Here follows four if-clauses on the cases of IFORM=1..4.
  ! The contents in all four cases is almost the same, but it is
  ! *DELIBERATE* that it has not been rewritten as one single piece of code
  ! with a few IF statement inside. It seems that some compilers do not
  ! optimize the code correctly then.
  ! Also, a number of IF-clauses have been replaced by arithmetic computation
  ! for the same reason. Pardon the clumsy result...
  IWORD = 0 ! dummy initialize
  if (IFORM == 1) then
    !*******************************************************************
    ! The IFORM=1 case:
    ! Long loop over configurations
    do ICNF=1,NCNF
      ORBARR(1:NOCC) = ICNFTAB(KCNF+NWRD*(ICNF-1):KCNF+NWRD*(ICNF-1)+NOCC-1)
      ! Loop over spin couplings
      do ICPL=1,NCPL
        ICASE(1:NLEV) = 0
        do I=1,NCLSD
          ICASE(ORBARR(I)) = 3
        end do
        do I=1,NOPEN
          IORB = ORBARR(NCLSD+I)
          IFUP = ISPNTAB(KCPL-1+I+NOPEN*(ICPL-1))
          !ICASE(IORB) = 1
          !if (IFUP /= 1) ICASE(IORB) = 2
          ICASE(IORB) = IFUP2CS(IFUP)

        end do
        ! A phase factor will be induced by the reordering.
        PHS = One
        NODD = 0
        do LEV=1,NLEV
          I = ICASE(LEV)
          !if (I == 1) NODD = 1-NODD
          !if (I == 2) NODD = 1-NODD
          NODD = (2*NODD-1)*I*(I-3)/2+NODD
          !if (NODD == 1) then
          !  IF(I == 2) PHS = -PHS
          !  IF(I == 3) PHS = -PHS
          !end if
          PHS = real((3+NODD*I*(I-1)*(2*I-7))/3,kind=wp)*PHS
        end do
        ! Pack the walk and add it to the list.
        call PKWLK(NLEV,MIPWLK,1,KWALK(IWLKPOS),ICASE)
        IWLKPOS = IWLKPOS+MIPWLK
        NWLKLST = NWLKLST+1
        PHASE(NWLKLST) = PHS
        if (NWLKLST == MXWLK) then
          ! Translate the packed walks to a list of CSF ID-numbers
          call W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
          IWLKPOS = 1
          ! Loop over this list.
          ICSYMG = NCSYMG
          if (IMODE == 0) then
            do I=1,NWLKLST
              ICSPLT = ICNUM(I)
              ICSYMG = NCSYMG+I
              CINEW(ICSPLT) = CIOLD(ICSYMG)*PHASE(I)
            end do
          else
            do I=1,NWLKLST
              ICSPLT = ICNUM(I)
              ICSYMG = NCSYMG+I
              CINEW(ICSYMG) = CIOLD(ICSPLT)*PHASE(I)
            end do
          end if
          NCSYMG = ICSYMG
          NWLKLST = 0
        end if

        ! End of loop over spin couplings
      end do
      ! End of loop over configurations
    end do
  else if (IFORM == 2) then
    !*******************************************************************
    ! The IFORM=2 case:
    ! Long loop over configurations
    do ICNF=1,NCNF
      IEL2 = 0
      IEL1 = NCLSD
      do IORB=1,NLEV
        IOCC = ICNFTAB(KCNF-1+IORB+NWRD*(ICNF-1))
        if (IOCC == 1) then
          IEL1 = IEL1+1
          ORBARR(IEL1) = IORB
        else
          IEL2 = IEL2+1
          ORBARR(IEL2) = IORB
        end if
      end do
      ! Loop over spin couplings
      do ICPL=1,NCPL
        ICASE(1:NLEV) = 0
        do I=1,NCLSD
          ICASE(ORBARR(I)) = 3
        end do
        do I=1,NOPEN
          IORB = ORBARR(NCLSD+I)
          IFUP = ISPNTAB(KCPL-1+I+NOPEN*(ICPL-1))
          !ICASE(IORB) = 1
          !if (IFUP /= 1) ICASE(IORB) = 2
          ICASE(IORB) = IFUP2CS(IFUP)
        end do
        ! A phase factor will be induced by the reordering.
        PHS = One
        NODD = 0
        do LEV=1,NLEV
          I = ICASE(LEV)
          !if (I == 1) NODD = 1-NODD
          !if (I == 2) NODD = 1-NODD
          NODD = (2*NODD-1)*I*(I-3)/2+NODD
          !if (NODD == 1) then
          !  if (I == 2) PHS = -PHS
          !  if (I == 3) PHS = -PHS
          !end if
          PHS = real((3+NODD*I*(I-1)*(2*I-7))/3,kind=wp)*PHS
        end do
        ! Pack the walk and add it to the list.
        call PKWLK(NLEV,MIPWLK,1,KWALK(IWLKPOS),ICASE)
        IWLKPOS = IWLKPOS+MIPWLK
        NWLKLST = NWLKLST+1
        PHASE(NWLKLST) = PHS
        if (NWLKLST == MXWLK) then
          ! Translate the packed walks to a list of CSF ID-numbers
          call W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
          IWLKPOS = 1
          ! Loop over this list.
          ICSYMG = NCSYMG
          if (IMODE == 0) then
            do I=1,NWLKLST
              ICSPLT = ICNUM(I)
              ICSYMG = NCSYMG+I
              CINEW(ICSPLT) = CIOLD(ICSYMG)*PHASE(I)
            end do
          else
            do I=1,NWLKLST
              ICSPLT = ICNUM(I)
              ICSYMG = NCSYMG+I
              CINEW(ICSYMG) = CIOLD(ICSPLT)*PHASE(I)
            end do
          end if
          NCSYMG = ICSYMG
          NWLKLST = 0
        end if

        ! End of loop over spin couplings
      end do
      ! End of loop over configurations
    end do
  else if (IFORM == 3) then
    !*******************************************************************
    ! The IFORM=3 case:
    ! Long loop over configurations
    do ICNF=1,NCNF
      do IEL=1,NOCC
        IWRD = (3+IEL)/4
        IREST = (3+IEL)-4*IWRD
        if (IREST == 0) IWORD = ICNFTAB(KCNF-1+IWRD+NWRD*(ICNF-1))
        IORB = mod(IWORD,256)
        IWORD = IWORD/256
        ORBARR(IEL) = IORB
      end do
      ! Loop over spin couplings
      do ICPL=1,NCPL
        ICASE(1:NLEV) = 0
        do I=1,NCLSD
          ICASE(ORBARR(I)) = 3
        end do
        do I=1,NOPEN
          IORB = ORBARR(NCLSD+I)
          IFUP = ISPNTAB(KCPL-1+I+NOPEN*(ICPL-1))
          !ICASE(IORB) = 1
          !if (IFUP /= 1) ICASE(IORB) = 2
          ICASE(IORB) = IFUP2CS(IFUP)
        end do
        ! A phase factor will be induced by the reordering.
        PHS = One
        NODD = 0
        do LEV=1,NLEV
          I = ICASE(LEV)
          !if (I == 1) NODD = 1-NODD
          !if (I == 2) NODD = 1-NODD
          NODD = (2*NODD-1)*I*(I-3)/2+NODD
          !if (NODD == 1) then
          !  if (I == 2) PHS = -PHS
          !  if (I == 3) PHS = -PHS
          !end if
          PHS = real((3+NODD*I*(I-1)*(2*I-7))/3,kind=wp)*PHS
        end do
        ! Pack the walk and add it to the list.
        call PKWLK(NLEV,MIPWLK,1,KWALK(IWLKPOS),ICASE)
        IWLKPOS = IWLKPOS+MIPWLK
        NWLKLST = NWLKLST+1
        PHASE(NWLKLST) = PHS
        if (NWLKLST == MXWLK) then
          ! Translate the packed walks to a list of CSF ID-numbers
          call W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
          IWLKPOS = 1
          ! Loop over this list.
          ICSYMG = NCSYMG
          if (IMODE == 0) then
            do I=1,NWLKLST
              ICSPLT = ICNUM(I)
              ICSYMG = NCSYMG+I
              CINEW(ICSPLT) = CIOLD(ICSYMG)*PHASE(I)
            end do
          else
            do I=1,NWLKLST
              ICSPLT = ICNUM(I)
              ICSYMG = NCSYMG+I
              CINEW(ICSYMG) = CIOLD(ICSPLT)*PHASE(I)
            end do
          end if
          NCSYMG = ICSYMG
          NWLKLST = 0
        end if

        ! End of loop over spin couplings
      end do
      ! End of loop over configurations
    end do
  else if (IFORM == 4) then
    !*******************************************************************
    ! The IFORM=4 case:
    ! Long loop over configurations
    do ICNF=1,NCNF
      IEL2 = 0
      IEL1 = NCLSD
      do IORB=1,NLEV
        IWRD = (IORB+14)/15
        IREST = IORB+14-15*IWRD
        if (IREST == 0) IWORD = ICNFTAB(KCNF-1+IWRD+NWRD*(ICNF-1))
        IOCC = mod(IWORD,4)
        IWORD = IWORD/4
        if (IOCC == 1) then
          IEL1 = IEL1+1
          ORBARR(IEL1) = IORB
        else
          IEL2 = IEL2+1
          ORBARR(IEL2) = IORB
        end if
      end do
      ! Loop over spin couplings
      do ICPL=1,NCPL
        ICASE(1:NLEV) = 0
        do I=1,NCLSD
          ICASE(ORBARR(I)) = 3
        end do
        do I=1,NOPEN
          IORB = ORBARR(NCLSD+I)
          IFUP = ISPNTAB(KCPL-1+I+NOPEN*(ICPL-1))
          !ICASE(IORB) = 1
          !if (IFUP /= 1) ICASE(IORB) = 2
          ICASE(IORB) = IFUP2CS(IFUP)
        end do
        ! A phase factor will be induced by the reordering.
        PHS = One
        NODD = 0
        do LEV=1,NLEV
          I = ICASE(LEV)
          !if (I == 1) NODD = 1-NODD
          !if (I == 2) NODD = 1-NODD
          NODD = (2*NODD-1)*I*(I-3)/2+NODD
          !if (NODD == 1) then
          !  if (I == 2) PHS = -PHS
          !  if (I == 3) PHS = -PHS
          !end if
          PHS = real((3+NODD*I*(I-1)*(2*I-7))/3,kind=wp)*PHS
        end do
        ! Pack the walk and add it to the list.
        call PKWLK(NLEV,MIPWLK,1,KWALK(IWLKPOS),ICASE)
        IWLKPOS = IWLKPOS+MIPWLK
        NWLKLST = NWLKLST+1
        PHASE(NWLKLST) = PHS
        if (NWLKLST == MXWLK) then
          ! Translate the packed walks to a list of CSF ID-numbers
          call W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
          IWLKPOS = 1
          ! Loop over this list.
          ICSYMG = NCSYMG
          if (IMODE == 0) then
            do I=1,NWLKLST
              ICSPLT = ICNUM(I)
              ICSYMG = NCSYMG+I
              CINEW(ICSPLT) = CIOLD(ICSYMG)*PHASE(I)
            end do
          else
            do I=1,NWLKLST
              ICSPLT = ICNUM(I)
              ICSYMG = NCSYMG+I
              CINEW(ICSYMG) = CIOLD(ICSPLT)*PHASE(I)
            end do
          end if
          NCSYMG = ICSYMG
          NWLKLST = 0
        end if

        ! End of loop over spin couplings
      end do
      ! End of loop over configurations
    end do
  end if
  !*********************************************************************

  ! End of loop over NOPEN
end do

! As above, processing what remains in the KWALK buffer.
call W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
IWLKPOS = 1
if (IMODE == 0) then
  do I=1,NWLKLST
    ICSPLT = ICNUM(I)
    ICSYMG = NCSYMG+I
    CINEW(ICSPLT) = CIOLD(ICSYMG)*PHASE(I)
  end do
else
  do I=1,NWLKLST
    ICSPLT = ICNUM(I)
    ICSYMG = NCSYMG+I
    CINEW(ICSYMG) = CIOLD(ICSPLT)*PHASE(I)
  end do
end if
NCSYMG = NCSYMG+NWLKLST
NWLKLST = 0

if (IPGLOB >= 5) then
  write(u6,*)
  write(u6,*) ' CI vector reordered in SYG2SGU'
  if (IMODE == 0) then
    write(u6,*) ' OLD CI vector in SYMMETRIC GROUP order'
    write(u6,'(10F12.8)') (CIOLD(I),I=1,NCONF)
    write(u6,*) ' NEW CI vector in SPLIT GRAPH UGA order'
    write(u6,'(10F12.8)') (CINEW(I),I=1,NCONF)
  else
    write(u6,*) ' OLD CI vector in SPLIT GRAPH UGA order'
    write(u6,'(10F12.8)') (CIOLD(I),I=1,NCONF)
    write(u6,*) ' NEW CI vector in SYMMETRIC GROUP order'
    write(u6,'(10F12.8)') (CINEW(I),I=1,NCONF)
  end if
end if

call mma_deallocate(OrbArr)
call mma_deallocate(MWS2W)

end subroutine SYG2SGU

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRTSTR(ISTR,NEL,NSTR)
! Print NSTR strings each containing NEL electrons

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NEL, NSTR, ISTR(NEL,NSTR)
integer(kind=iwp) :: IEL, JSTR

do JSTR=1,NSTR
  write(u6,100) ' String ',JSTR,' : ',(ISTR(IEL,JSTR),IEL=1,NEL)
end do

return
100 format('0',A,I6,A,4X,10(2X,I4),/,(1X,19X,10(2X,I4)))

end subroutine PRTSTR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010,2012,2017, Francesco Aquilante                    *
!               2015,2017, Alexander Zech                              *
!***********************************************************************

function Xlambda(omega,sigma)

use Constants, only: One
use Definitions, only: wp

implicit none
real(kind=wp) :: Xlambda
real(kind=wp), intent(in) :: omega, sigma

if (sigma*omega > 42.0_wp) then
  Xlambda = One
else
  Xlambda = One-exp(-sigma*omega)
end if

end function Xlambda

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine casinfoinp_cvb()

use casvb_global, only: iorclos_d, iorcore_d, iorocc_d, istms2_d, istnel_d, istsy_d, mxirrep_ci, nstats_d, nstsym_d, weight_d
use Constants, only: Zero, One
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), parameter :: ncmp = 4, nstrin = 6
integer(kind=iwp) :: istr, nactel(3), nread
character(len=*), parameter :: string(nstrin) = ['RAS2    ','INACTIVE','FROZEN  ','NACTEL  ','SPIN    ','SYMMETRY']

do
  call fstring_cvb(string,nstrin,istr,ncmp,2)

  if (istr == 1) then
    ! 'RAS2'
    iorocc_d(:) = 0
    call int_cvb(iorocc_d,mxirrep_ci,nread,1)
  else if (istr == 2) then
    ! 'INACTIVE'
    iorclos_d(:) = 0
    call int_cvb(iorclos_d,mxirrep_ci,nread,1)
  else if (istr == 3) then
    ! 'FROZEN'
    iorcore_d(:) = 0
    call int_cvb(iorcore_d,mxirrep_ci,nread,1)
  end if
  if ((istr == 4) .or. (istr == 5) .or. (istr == 6)) then
    ! 'NACTEL' or 'SPIN' or 'SYMMETRY'
    if (nstsym_d == 0) then
      istnel_d(:) = 0
      istsy_d(:) = 0
      istms2_d(:) = 0
      nstats_d(:) = 0
      weight_d(:,:) = Zero
      nstsym_d = 1
      istsy_d(nstsym_d) = 1
      nstats_d(nstsym_d) = 1
      weight_d(1,nstsym_d) = One
    end if
  end if
  if (istr == 4) then
    ! 'NACTEL'
    nactel(:) = 0
    call int_cvb(nactel,3,nread,1)
    if ((nactel(2) /= 0) .or. (nactel(3) /= 0)) then
      write(u6,*) ' Illegal NACTEL read :',nactel
      write(u6,*) ' Use CASVB only with CASSCF wavefunctions!'
      call abend_cvb()
    end if
    istnel_d(nstsym_d) = nactel(1)
  else if (istr == 5) then
    ! 'SPIN'
    call int_cvb(istms2_d(nstsym_d),1,nread,1)
    istms2_d(nstsym_d) = istms2_d(nstsym_d)-1
  else if (istr == 6) then
    ! 'SYMMETRY'
    call int_cvb(istsy_d(nstsym_d),1,nread,1)
  end if
  ! Unrecognized keyword -- end of input:
  if (istr == 0) exit
end do

return

end subroutine casinfoinp_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine evaluate_Uxxx (dkhorder,xorder,paramtype,dkhscfflg,
     *                    uused,unumber,utimes,uorder,umult,u,uscrchar,
     *                    uscrleng,utimestot,umulttot,totmult)
c
c*************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 14.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,xorder
      character*(3) paramtype
      logical dkhscfflg
c
      integer uused,unumber,utimes(maxunumber),uorder(maxunumber,3),
     *        umult(maxunumber),uscrleng(maxunumber),utimestot,umulttot,
     *        totmult
      character*(4) u(maxunumber)
      character*(3) uscrchar(maxunumber)
c
      integer i
#ifdef _MOLCAS_
      Integer IsFreeUnit
#endif
c
c-------------------------------------------------------------------------
c
CMR      write (stdout,1007)
CMR1007  format (//5X,'|',70('-'),'|',/5X,'|',6X,'STEP 6: Determine ',
CMR     *        'auxiliary matrices Uxxx ',22X,'|',/5X,'|',
CMR     *        70('-'),'|')
c
      if (dbgflg.ge.1) then
        write (dbgunit,1009)
1009    format (/2X,'Step 6: Enter subroutine "evaluate_Uxxx" ',//2X,
     *          'Determine number of matrix multiplications necessary',
     *          ' for the evaluation of all Uxxx matrices,',/4X,
     *          ' which have been used so far.')
      endif
#ifndef MOLPRO
#ifdef _MOLCAS_
      DKHUnit5=5
      DKHUnit5=IsFreeUnit(DKHUnit5)
      Call Molcas_Open(DKHUnit5,'dkhops.15')
#else
      open (dkhunit5, file='dkhops.15', status='UNKNOWN',
     *        form='FORMATTED')
#endif
#endif
      rewind(dkhunit5)
      write (dkhunit5,1021) dkhorder,paramtype,xorder,dkhscfflg
1021  format (50('-'),/2X,'dkhorder = ',I2,10X,A3,/2X,'xorder   = ',I2,
     *        /2X,'dkhscfflg = ',L1,/'+++',47('-'))
      write (dkhunit5,1042) unumber
1042  format (I3,17X,'order(V)  order(X)  order(tot)')
      do 20 i=1,uused
        if (utimes(i).ge.1) then
          write (dkhunit5,1043) uscrleng(i),u(i),uscrchar(i),
     *                          uorder(i,1),uorder(i,2),uorder(i,3)
1043      format (I1,3X,A4,3X,A3,8X,I2,8X,I2,9X,I2)
        endif
  20  continue
c
#ifdef _MOLCAS_
      close (dkhunit5)
#endif
c
      totmult=totmult+umulttot
      if (dbgflg.ge.1) then
        write (dbgunit,2766) unumber,unumber,umulttot,dkhorder,xorder,
     *                       totmult
2766    format (/2X,'All ',I3,' Uxxx matrices have been written to the',
     *          ' file "dkhops.15".',//2X,'Number of matrix ',
     *          'multiplications necessary to evaluate all ',I3,' Uxxx',
     *          ' expressions:',2X,I5,//2X,'Total number of matrix',
     *          ' multiplications needed for evaluation of all DKH(',
     *          I2,',',I2,')-corrections:',3X,I8)
        write (dbgunit,2769)
2769    format (/2X,'Subroutine evaluate_Uxxx (step6) has now been ',
     *          'completed.',//2X,145('*'))
      endif
CMR      write (stdout,1034) unumber,unumber,umulttot,dkhorder,xorder,
CMR     *                    totmult
CMR1034  format (/2X,'All ',I3,' required Uxxx matrices have been ',
CMR     *        'written to the file "dkhops.15".',
CMR     *        //2X,'Total number of low-level matrix multiplications',
CMR     *        /4X,'necessary for the evaluation of all ',I3,' Uxxx:',
CMR     *        11X,I10,//2X,'Total number of matrix multiplications',
CMR     *        ' for the',/4X,'evaluation of all terms contributing',
CMR     *        ' to DKH(',I2,',',I2,'):',4X,I11,/2X)
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer_array(umult)
        call Unused_integer(utimestot)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1998,2005, Roland Lindh                 *
!               1990, IBM                                              *
!***********************************************************************

subroutine Post_2Center_RI(A_Diag)
!***********************************************************************
!                                                                      *
!  Object: driver for two-electron integrals.                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for k2 loop. August '91                         *
!             Modified to minimize overhead for calculations with      *
!             small basis sets and large molecules. Sept. '93          *
!             Modified driver. Jan. '98                                *
!             Modified to 2-center ERIs for RI June '05                *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Basis_Info, only: nBas_Aux
use RI_glob, only: Lu_A, Lu_Q, nChV
use Gateway_global, only: force_out_of_core
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: A_Diag(*)
integer(kind=iwp) :: i, iAddr, iAddr_, ichk, iIrrep, iOff, irc, iSeed, kCol, kQm, lAm, LinDep, lJ, lQm, lScr, MaxMem, MaxMem2, mB, &
                     mQm, nA_Diag, nAm, nB, nBfn2, nBfnTot, nDmA(0:7), nDmB(0:7), nMem, nQm, nQm_full, nScr, nXZ
real(kind=wp) :: a, b, dum(1), ThrQ
logical(kind=iwp) :: Out_of_Core
character(len=6) :: Name_Q
integer(kind=iwp), allocatable :: iDiag(:)
real(kind=wp), allocatable :: Scr(:), X(:), Z(:)
real(kind=wp), allocatable, target :: A_k(:), Am(:), Q_k(:), Qm(:)
real(kind=wp), pointer :: A_l(:), Q_l(:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
!define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *

nScr = 0
nBfn2 = 0
nBfnTot = 0
do iIrrep=0,nIrrep-1
  lJ = nBas_Aux(iIrrep)
  if (iIrrep == 0) lJ = lJ-1
  nDmA(iIrrep) = lJ
  nDmB(iIrrep) = 0
  nScr = max(nScr,3*lJ)
  nBfn2 = nBfn2+lJ**2
  nBfnTot = nBfnTot+lJ
end do
nA_Diag = nBfnTot

call mma_maxDBLE(MaxMem)
!                                                                      *
!***********************************************************************
!                                                                      *
! Fill in the lower part of the A matrix as it is stored on disk.

do iIrrep=0,nIrrep-1
  nB = nBas_Aux(iIrrep)
  if (iIrrep == 0) nB = nB-1 ! subtract dummy af
  call Square_A(Lu_A(iIrrep),nB,MaxMem,Force_Out_of_Core)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Pivoting of the A matrix

call mma_allocate(iDiag,nA_Diag,Label='iDiag')
call mma_maxDBLE(MaxMem2)

if (Force_Out_of_Core) MaxMem2 = 3*nBfnTot
!lScr = Min(MaxMem2,nScr)
lScr = max(MaxMem2-(nScr/3),nScr)
call mma_allocate(Scr,lScr,Label='Scr')

call SORT_mat(irc,nDmA,nDmB,iDiag,nIrrep,Lu_A,'GePivot',lScr,Scr,A_Diag)
ichk = 0
do iIrrep=0,nIrrep-1
  nChV(iIrrep) = nDmB(iIrrep)
  ichk = ichk+min(1,nDmA(iIrrep)-nDmB(iIrrep))
end do
if (ichk /= 0) then
  write(u6,*)
  write(u6,*) 'Post_2Center_RI'
  write(u6,*) 'Detected lin. dependences in the auxiliary basis.'
  write(u6,'(A,8I6)') ' # of AuxBas before l. d. removal: ',(nDmA(i),i=0,nIrrep-1)
  write(u6,'(A,8I6)') ' # of AuxBas after  l. d. removal: ',(nDmB(i),i=0,nIrrep-1)
  write(u6,*)
end if

call SORT_mat(irc,nDmA,nDmB,iDiag,nIrrep,Lu_A,'DoPivot',lScr,Scr,dum)

! Note: after the 'DoPivot' call to Sort_mat, the A-matrix is
!       no longer stored as squared but as upper-triangular

call mma_deallocate(Scr)

!***********************************************************************
!     A-vectors are now on disk. Go ahead and compute the Q-vectors!
!***********************************************************************

ThrQ = 1.0e-14_wp ! Threshold for Inv_Cho_Factor

do iIrrep=0,nIrrep-1
  !nB = nBas_Aux(iIrrep)
  !if (iIrrep == 0) nB = nB-1
  nB = nDmB(iIrrep)
  if (nB == 0) cycle
  nQm = nTri_Elem(nB)

  nXZ = nB
  nQm_full = nTri_Elem(nB)

  if (Force_Out_of_Core) MaxMem = (8*(2*nQm_full+5*nXZ))/10
  Out_of_Core = 2*nQm_full+5*nXZ > MaxMem

  if (Out_Of_Core) then
    mQm = (nQm*MaxMem-5*nXZ)/(2*nQm_full)
    a = One
    b = -Two*real(mQm,kind=wp)
    mB = int(-a*Half+sqrt((a*Half)**2-b))
    kQm = nTri_Elem(mB)
    if (kQm > mQm) then
      call WarningMessage(2,'Error in Post_2Center_RI')
      write(u6,*) 'kQm > mQm!'
      write(u6,*) 'MaxMem=',MaxMem
      write(u6,*) 'nQm,mQm,kQm=',nQm,mQm,kQm
      write(u6,*) 'nB,mB=',nB,mB
      call Abend()
    end if
  else
    mB = nB
    kQm = nQm
  end if

  lQm = kQm
  lAm = lQm

  if (lQm < 1) then
    call WarningMessage(2,'Error in Post_2Center_RI')
    write(u6,*) 'lQm < 1'
    call Abend()
  end if

  ! Some of memory for scratch arrays for Inv_Cho_Factor
  ! Allocate memory for the A- and Q-vectors and initialize.

  lScr = nXZ
  call mma_allocate(Scr,lScr,Label='Scr')
  call mma_allocate(Z,nXZ,Label='Z')
  call mma_allocate(X,nXZ,Label='X')
  call mma_allocate(Am,lAm,Label='Am')
  call mma_allocate(Qm,lQm,Label='Qm')
  call mma_allocate(A_k,nXZ,Label='A_k')
  call mma_allocate(Q_k,nXZ,Label='Q_k')

  Am(:) = Zero
  Qm(:) = Zero
  !                                                                    *
  !--------------------------------------------------------------------*
  !                                                                    *
  ! Process the A_ks to generate Q_ks.

  iSeed = 55+iIrrep
  Lu_Q(iIrrep) = IsFreeUnit(iSeed)
  write(Name_Q,'(A4,I2.2)') 'QMAT',iIrrep
  call DaName_MF_WA(Lu_Q(iIrrep),Name_Q)

  iAddr = 0
  nMem = mB
  do kCol=1,nB

    iAddr_ = iAddr
    if (kCol <= nMem) then
      ! Point to A_k in Am
      iOff = nTri_Elem(kCol-1)
      A_l(1:kCol) => Am(iOff+1:iOff+kCol)
      if (kCol == 1) then
        nAm = nTri_Elem(nMem)
        call dDaFile(Lu_A(iIrrep),2,Am,nAm,iAddr_)
      end if
      ! Point to Q_k in Qm
      Q_l(1:kCol) => Qm(iOff+1:iOff+kCol)
    else if (kCol > nMem) then
      ! Use special scratch for A_k
      A_l(1:kCol) => A_k(1:kCol)
      call dDaFile(Lu_A(iIrrep),2,A_l,kCol,iAddr_)
      ! Use special scratch for Q_k
      Q_l(1:kCol) => Q_k(1:kCol)
    end if

    LinDep = 2
    call Inv_Cho_Factor(A_l,kCol,Am,Qm,nMem,Lu_A(iIrrep),Lu_Q(iIrrep),Scr,lScr,Z,X,ThrQ,Q_l,LinDep)

    if (LinDep /= 0) then
      call WarningMessage(2,'Error in Post_2Center_RI')
      write(u6,*) 'Inv_Cho_Factor found linear dependence!'
      call Abend()
    end if

    ! Write the new A/Q-vector to file

    iAddr_ = iAddr
    if (kCol == nMem) then
      nQm = nTri_Elem(kCol)
      call dDaFile(Lu_Q(iIrrep),1,Qm,nQm,iAddr)
      call dDaFile(Lu_A(iIrrep),1,Am,nQm,iAddr_)
    else if (kCol > nMem) then
      call dDaFile(Lu_Q(iIrrep),1,Q_l,kCol,iAddr)
      call dDaFile(Lu_A(iIrrep),1,A_l,kCol,iAddr_)
    end if

  end do

  nullify(Q_l,A_l)
  call mma_deallocate(Q_k)
  call mma_deallocate(A_k)
  call mma_deallocate(Qm)
  call mma_deallocate(Am)
  call mma_deallocate(X)
  call mma_deallocate(Z)
  call mma_deallocate(Scr)
  call DaClos(Lu_A(iIrrep))
end do ! iIrrep
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Sort the Q-matrix back to the original order.

call mma_maxDBLE(MaxMem2)

if (Force_Out_of_Core) MaxMem2 = 2*nBfnTot
lScr = min(MaxMem2,max(nBfn2,2*nBfnTot))
call mma_allocate(Scr,lScr,Label='Scr')

call SORT_mat(irc,nDmA,nDmB,iDiag,nIrrep,Lu_Q,'Restore',lScr,Scr,dum)

! Note: after the 'Restore' call to Sort_mat, the Q-matrix is
!       no longer stored as upper-triangular but as RECTANGULAR
!       (nDmA,nDmB). The column index is still pivoted.

call mma_deallocate(Scr)
call mma_deallocate(iDiag)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
return

end subroutine Post_2Center_RI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetChV(wrk,wrksize,aGrp,bGrp,beGrp,gaGrp,NL2,L2Status,pL21,pL22,pL23,pL24,pL2W,PosL11,PosL12,LunAux)
! this routine does:
! read L2 files from disc file
! L21 (m,a',be')
! L22 (m,a',ga')
! L23 (m,b',be')
! L24 (m,b',ga')
! and completed it by the term
! L2x (m,c',de') <<- L2(m,c',i) . T1(T)(de',i)
!
! Routine define pL2x, which are values, which show, which index
! i (correspondig to L2Status(i,1-3) correspond to ginev L2x.
! Array L2Status (neaningful only for i=1,NL2) stores informations
! about really loaded L2's in memory. If some of the blocks were
! already defined in previous spep(s), they are not read repeatedly.
!
! N.B.1 Rutina sa da spravit aj trivialne, ze sa pokazde vsetky
! L21-4 nacitaju, toto riesenie je menej prehladne, ale setri IO
! N.B.2 Efektivitu ovplyvnuje hlavne, ako vybera rutine getChVHlp2
! kam sa ma nove L2 nacitat, najma ak ma vybrat, ktory s
! existujucich rekordov premaze
!
! I/O parameter description:
! aGrp, bGrp   - groups of a,b (I)
! beGrp, GaGrp - groups of be,ga (I)
! NL2          - real number of L2 declared in memory(1,2or4) (I)
! L2Status     - L2 status matrix (I/O)
!                L2Status(i,1) - cGrp
!                L2Status(i,2) - deGrp
!                L2Status(i,3) - Pos
! pL2x         - position of L2x in L2Status (i.e. index i
!                in L2Status(i,1-3) for given L2x (O)
! PosL11       - Position of L1(m,a',i) (I)
! PosL12       - Position of L1(m,b',i) (I)
! LunAux       - lun for auxiliary reading (I)

use chcc_global, only: DimGrpa, DimGrpbe, nc, no, PosT1o
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, aGrp, bGrp, beGrp, gaGrp, NL2, pL2W, PosL11, PosL12, LunAux
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp), intent(inout) :: L2Status(4,3)
integer(kind=iwp), intent(out) :: pL21, pL22, pL23, pL24
integer(kind=iwp) :: addde, cGrp, deGrp, dimc, dimde, HowMany, i, kam, Kde(4), kery, ToDo, Used(4), WhatNeedToRead(4,2), Which(4), &
                     yes

kam = -1 ! dummy initialize

!1 Define
!  a) what need to be read (WhatNeedToRead)
!  b) How many different L2 need to be defined (HowMany)
!  c) How L21-4 is mapped to the unique ones, that need to be read (Which)

if (aGrp == bGrp) then
  if (beGrp == gaGrp) then
    ! case L21=L22=L23=L24
    HowMany = 1
    WhatNeedToRead(1,1) = aGrp
    WhatNeedToRead(1,2) = beGrp
    Which(1) = 1
    Which(2) = 1
    Which(3) = 1
    Which(4) = 1
  else
    ! case L21=L23, L22=L24
    HowMany = 2
    WhatNeedToRead(1,1) = aGrp
    WhatNeedToRead(1,2) = beGrp
    WhatNeedToRead(2,1) = aGrp
    WhatNeedToRead(2,2) = gaGrp
    Which(1) = 1
    Which(2) = 2
    Which(3) = 1
    Which(4) = 2
  end if
else
  if (beGrp == gaGrp) then
    ! case L21=L22,L23=L24
    HowMany = 2
    WhatNeedToRead(1,1) = aGrp
    WhatNeedToRead(1,2) = beGrp
    WhatNeedToRead(2,1) = bGrp
    WhatNeedToRead(2,2) = beGrp
    Which(1) = 1
    Which(2) = 1
    Which(3) = 2
    Which(4) = 2
  else
    ! all L2s are different
    HowMany = 4
    WhatNeedToRead(1,1) = aGrp
    WhatNeedToRead(1,2) = beGrp
    WhatNeedToRead(2,1) = aGrp
    WhatNeedToRead(2,2) = gaGrp
    WhatNeedToRead(3,1) = bGrp
    WhatNeedToRead(3,2) = beGrp
    WhatNeedToRead(4,1) = bGrp
    WhatNeedToRead(4,2) = gaGrp
    Which(1) = 1
    Which(2) = 2
    Which(3) = 3
    Which(4) = 4
  end if
end if

!2 Load neccesarry L2 from disk

!2.1 SetUp
Kde(1:NL2) = 0
Used(1:NL2) = 0

do
  ToDo = HowMany

  !2.2 Test, which ones of those, that need to be read are
  !    already loaded and where (Kde) and find, how many of
  !    L2 need to be readed really (ToDo)
  do i=1,HowMany
    call getChVHlp1(WhatNeedToRead(i,1),WhatNeedToRead(i,2),yes,NL2,L2Status)
    Kde(i) = yes
    if (yes /= 0) then
      used(yes) = 1
      ToDo = ToDo-1
    end if
  end do

  if (ToDo <= 0) exit
  !2.3 if there is at least one L2 to read, read only one
  !    and run 2.2 section again

  ! zistit kere L2 treba nacitat (kery)
  kery = 0
  do i=1,HowMany
    if (Kde(i) == 0) kery = i
  end do

  ! found, where to read it (kam)
  call getChVHlp2(L2Status,NL2,used,kam)

  ! read L2 (kery) into (kam) (+ expand, f needed)
  L2Status(kam,1) = WhatNeedToRead(kery,1)
  L2Status(kam,2) = WhatNeedToRead(kery,2)
  cGrp = L2Status(kam,1)
  deGrp = L2Status(kam,2)
  call getChVHlp3(wrk(L2Status(kam,3)),wrk(pL2W),L2Status(kam,1),L2Status(kam,2),LunAux)

  ! Create L2W(i,de') <- T1(de,i)
  dimde = DimGrpbe(deGrp)
  addde = sum(DimGrpbe(1:deGrp-1))
  call getChVHlp4(wrk(pL2W),wrk(PosT1o),dimde,addde)

  ! upgrade L2(m,c',de') <<- - L1(m,c',i). L2W(i,de')
  dimc = DimGrpa(cGrp)
  if (cGrp == aGrp) then
    call mc0c2a3b(nc*dimc,no,no,dimde,nc*dimc,dimde,nc*dimc,no,dimde,wrk(PosL11),wrk(pL2W),wrk(L2Status(kam,3)))
  else if (cGrp == bGrp) then
    call mc0c2a3b(nc*dimc,no,no,dimde,nc*dimc,dimde,nc*dimc,no,dimde,wrk(PosL12),wrk(pL2W),wrk(L2Status(kam,3)))
  else
    write(u6,*) ' Nieje dobre, c nieje ani a ani b :-( Ch. K.'
    call Abend()
  end if

  used(kam) = 1

end do

!3 At this point all neccesarry L2 are read - def pL2x

i = Which(1)
pL21 = Kde(i)
i = Which(2)
pL22 = Kde(i)
i = Which(3)
pL23 = Kde(i)
i = Which(4)
pL24 = Kde(i)

return

end subroutine GetChV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_CALCINT_2(ISHLAB)
!
! Purpose: calculate qualified integral columns from
!          shell pair distribution (**|ISHLA ISHLB).
!
! Version 2: avoid storage of full shell quadruple in interface to
!            seward; get qualified directly!

use Cholesky, only: INF_IN2, INF_INT, iOff_col, iOffq, IPRINT, iSP2F, LuPri, LuSel, MySP, nnBstR, nnBstRSh, nnShl, nQual, nSym, &
                    TINTEG
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ISHLAB
integer(kind=iwp) :: IADR, ILOC, IOPT, IRC, ISCD, ISHLA, ISHLB, ISHLC, ISHLCD, ISHLD, ISYM, KOFF, LCOL, LINT, LTOT, NAB(8)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: MEM_END, MEM_START, LEAK
#endif
real(kind=wp) :: C1, C2, PCT, W1, W2, XSKIP, XXSHL
logical(kind=iwp) :: DOINTS
real(kind=wp), allocatable :: IntCol(:), Temp(:)
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_MCA_CALCINT_2'

#ifdef _DEBUGPRINT_
call mma_maxDBLE(MEM_START)
#endif

! Initializations.
! ----------------

call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)

NAB(1) = 0 ! dummy initialization
NAB(1:NSYM) = NQUAL(1:NSYM)-IOFFQ(1:NSYM)

IOFF_COL(1) = 0
LCOL = NNBSTR(1,2)*NAB(1)
do ISYM=2,NSYM
  IOFF_COL(ISYM) = LCOL
  LCOL = LCOL+NNBSTR(ISYM,2)*NAB(ISYM)
end do

XXSHL = real(NNSHL,kind=wp)
XSKIP = Zero

if (IPRINT >= INF_INT) write(LUPRI,*)

! Allocate memory and initialize:
! qualified columns in reduced set,
! max. shell quadruple.
! ---------------------------------

call mma_allocate(IntCol,LCOL,Label='IntCol')
call mma_allocate(Temp,LCOL,Label='Temp')
IntCol(:) = Zero
Temp(:) = Zero

! Set mapping from shell pair AB to qualified columns.
! ----------------------------------------------------

IRC = 0
ILOC = 2
call CHO_P_SETSHP2Q(IRC,ILOC,ISHLAB,NAB)
if (IRC /= 0) then
  write(LUPRI,*) SECNAM,': CHO_SETSHP2Q returned ',IRC
  call CHO_QUIT('Error termination in '//SECNAM,IRC)
end if

! Set memory used by seward.
! --------------------------

call mma_maxDBLE(LINT)
call XSETMEM_INTS(LINT)

! Loop over shell quadruples.
! ---------------------------

do ISHLCD=1,NNSHL

  ! Set left shell pair index.
  ! --------------------------

  ISCD = MYSP(ISHLCD)
  call CHO_INVPCK(ISP2F(ISCD),ISHLC,ISHLD,.true.)

  ! Find out if this shell pair (CD) contributes to
  ! current reduced set.
  ! -----------------------------------------------

  ISYM = 1
  DOINTS = (NAB(ISYM) > 0) .and. (NNBSTRSH(ISYM,ISHLCD,2) > 0)
  do while ((ISYM < NSYM) .and. (.not. DOINTS))
    ISYM = ISYM+1
    DOINTS = (NAB(ISYM) > 0) .and. (NNBSTRSH(ISYM,ISHLCD,2) > 0)
  end do

  if (DOINTS) then

    ! Print message.
    ! --------------

    if (IPRINT >= INF_INT) write(LUPRI,'(A,I5,1X,I5,A,I5,1X,I5,A)') 'Invoking Seward for shell quadruple (',ISHLC,ISHLD,'|',ISHLA, &
                                                                    ISHLB,')'

    ! Set mapping from shell pair CD to reduced set.
    ! ----------------------------------------------

    IRC = 0
    ILOC = 2
    call CHO_SETSHP2RS(IRC,ILOC,ISHLCD,NAB)
    if (IRC /= 0) then
      write(LUPRI,*) SECNAM,': CHO_SETSHP2RS returned ',IRC
      call CHO_QUIT('Error termination in '//SECNAM,IRC)
    end if

    ! Calculate integrals.
    ! --------------------

    call CWTIME(C1,W1)
    Temp(:) = Zero
    call CHO_MCA_INT_1(ISCD,ISHLAB,Temp,LCOL,LOCDBG .or. (IPRINT >= 100))
    IntCol(:) = IntCol(:)+Temp(:)
    call CWTIME(C2,W2)
    TINTEG(1,1) = TINTEG(1,1)+C2-C1
    TINTEG(2,1) = TINTEG(2,1)+W2-W1

  else

    ! Update skip counter.
    ! --------------------

    XSKIP = XSKIP+One

    ! Print message.
    ! --------------

    if (IPRINT >= INF_INT) write(LUPRI,'(A,I5,1X,I5,A,I5,1X,I5,A)') 'NOTICE: skipping shell quadruple    (',ISHLC,ISHLD,'|',ISHLA, &
                                                                    ISHLB,')'

  end if

end do

! Write the columns to disk.
! --------------------------

call CWTIME(C1,W1)
do ISYM=1,NSYM
  LTOT = NNBSTR(ISYM,2)*NAB(ISYM)
  if (LTOT > 0) then
    IOPT = 1
    KOFF = 1+IOFF_COL(ISYM)
    IADR = NNBSTR(ISYM,2)*IOFFQ(ISYM)
    call DDAFILE(LUSEL(ISYM),IOPT,IntCol(KOFF),LTOT,IADR)
  end if
end do
call CWTIME(C2,W2)
TINTEG(1,2) = TINTEG(1,2)+C2-C1
TINTEG(2,2) = TINTEG(2,2)+W2-W1

! Free memory: both memory used by seward and used here.
! ------------------------------------------------------

call XRLSMEM_INTS()
call mma_deallocate(Temp)
call mma_deallocate(IntCol)

! Print skip statistics.
! ----------------------

if (IPRINT >= INF_IN2) then
  PCT = 1.0e2_wp*XSKIP/XXSHL
  write(LUPRI,'(A,F7.2,A)') 'Skipped',PCT,'% of rows (shell pairs) in this distribution'
end if

#ifdef _DEBUGPRINT_
call mma_maxDBLE(MEM_END)
LEAK = MEM_END-MEM_START
if (LEAK /= 0) then
  write(LUPRI,'(//,A,A,I9)') SECNAM,': Memory leak:',LEAK
  call CHO_QUIT('Memory leak detected in '//SECNAM,104)
end if
#endif

end subroutine CHO_MCA_CALCINT_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_CHKINT(XINT,DIAG,ISYM,NERR,TOL,REPORT)
C
C     Purpose: check diagonals in qualified integral columns.
C
      use ChoSwp, only: iQuAB, IndRed
#include "implicit.fh"
      DIMENSION XINT(*), DIAG(*)
      LOGICAL   REPORT
#include "cholesky.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_CHKINT')

      NERR = 0
      DO I = 1,NQUAL(ISYM)
         II = IQUAB(I,ISYM)
         JJ = INDRED(II,2)
         IK = II - IIBSTR(ISYM,2)
         KK = NNBSTR(ISYM,2)*(I - 1) + IK
         DF = DIAG(JJ) - XINT(KK)
         IF (ABS(DF) .GT. TOL) THEN
            NERR = NERR + 1
            IF (REPORT) THEN
               WRITE(LUPRI,*) SECNAM,': diag error: ',DIAG(JJ),XINT(KK)
               WRITE(LUPRI,*) '            diagonal elm    : ',JJ,
     &                        ' (rs1) ',II,' (rs2)'
               WRITE(LUPRI,*) '            integral row,col: ',IK,I
            END IF
         END IF
      END DO

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine ClsFls_CASPT2()
!***********************************************************************
!     Close files.                                                     *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!***********************************************************************

use PrintLevel, only: SILENT
use caspt2_global, only: iPrGlb, LUCIEX, LUDMAT, LUDRA, LUDRATOT, LUH0T, LUHLF1, LUHLF2, LUHLF3, LUINTM, LUONEM, LURHS, LUSBT, &
                         LUSOLV
use caspt2_module, only: IfChol
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IMAT, iRc, IVEC

!----------------------------------------------------------------------*
!     Start                                                            *
!-------------------------------------- -------------------------------*

call DaClos(LUCIEX)
call DaClos(LUONEM)
call DaClos(LUINTM)
call DaClos(LUDRA)
call DaClos(LUDRATOT)
call DaClos(LUHLF1)
call DaClos(LUHLF2)
call DaClos(LUHLF3)
call DaClos(LUDMAT)
call DaClos(LUSOLV)
call DaClos(LUSBT)
do IVEC=1,8
  call DaClos(LURHS(IVEC))
end do
do IMAT=1,4
  call DaClos(LUH0T(IMAT))
end do
!---  close the ORDINT file -------------------------------------------*
if (.not. IfChol) then
  iRc = -1
  call ClsOrd(iRc)
  if ((IRC /= 0) .and. (IPRGLB > SILENT)) call WarningMessage(1,'Failed to close ORDINT file.')
end if
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine ClsFls_CASPT2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine BdVGrd( &
#                 define _CALLING_
#                 include "grd_interface.fh"
                 )

use Index_Functions, only: nTri_Elem1
use Symmetry_Info, only: ChOper
use Center_Info, only: dc
use Rys_interfaces, only: cff2d_kernel, modu2_kernel, tval1_kernel
use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: i, iAlpha, iAnga(4), iBeta, iCar, iChxyz, iDAO, iDCRT(0:7), iDum, ii, iStb(0:7), iOrdOp, ipA, ipAOff, ipB, &
                     ipBOff, ipDAO, iPnt, IPotFl, iPrint, iuvwx(4), iZeta, jCoSet(8,8), JndGrd(3,4), jpDAO, lDCRT, LmbdT, lOp(4), &
                     mGrad, mRys, nArray, nDAO, nDCRT, nDiff, nGrdPt, nip, nStb, nT
real(kind=wp) :: C(3), CoorAC(3,2), Coori(3,4), Fact, TC(3), TZFd(3), ZFd(3), ZFdx, ZFdy, ZFdz
logical(kind=iwp) :: ESPFexist, JfGrad(3,4), NoLoop
character(len=180) :: Key
procedure(cff2d_kernel) :: XCff2D
procedure(modu2_kernel) :: Fake
procedure(tval1_kernel) :: TNAI1
integer(kind=iwp), external :: iChAtm, IsFreeUnit, NrOpr
character(len=180), external :: Get_Ln
#include "macros.fh"
unused_var(rFinal(1,1,1,1,1))
unused_var(nHer)
unused_var(nOrdOp)
unused_var(nComp)

iPrint = 5

! Modify the density matrix with the prefactor

nDAO = nTri_Elem1(la)*nTri_Elem1(lb)
do iDAO=1,nDAO
  do iZeta=1,nZeta
    Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
    DAO(iZeta,iDAO) = Fact*DAO(iZeta,iDAO)
  end do
end do
if (iPrint >= 99) then
  call RecPrt('DAO',' ',DAO,nZeta,nDAO)
  call RecPrt('Alpha',' ',Alpha,1,nAlpha)
  call RecPrt('Beta ',' ',Beta,1,nBeta)
  call RecPrt('Zeta ',' ',Zeta,1,nZeta)
end if

! Loop over charges and dipole moments in the external field

iOrdOp = 0

nip = 1
ipA = nip
nip = nip+nAlpha*nBeta
ipB = nip
nip = nip+nAlpha*nBeta
ipDAO = nip
nip = nip+nAlpha*nBeta*nTri_Elem1(la)*nTri_Elem1(lb)*nTri_Elem1(iOrdOp)
if (nip-1 > nZeta*nArr) then
  write(u6,*) 'nip-1 > nZeta*nArr'
  call Abend()
end if
nArray = nZeta*nArr-nip+1

iAnga(1) = la
iAnga(2) = lb
iAnga(3) = iOrdOp
iAnga(4) = 0
Coori(:,1) = A
Coori(:,2) = RB

! Find center to accumulate angular momentum on. (HRR)

if (la >= lb) then
  CoorAC(:,1) = A
else
  CoorAC(:,1) = RB
end if
iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
lOp(1) = kOp(1)
lOp(2) = kOp(2)

ipAOff = ipA
do iBeta=1,nBeta
  call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB
do iAlpha=1,nAlpha
  call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
  ipBOff = ipBOff+1
end do

! Loop over centers of the grid
! But how to retrieve the grid ???
! I just read it in the ESPF file !
call F_Inquire('ESPF.DATA',ESPFExist)
if (.not. ESPFExist) then
  write(u6,*) ' Error ! No ESPF.DATA file found'
  call Quit_OnUserError()
end if
IPotFl = IsFreeUnit(1)
call Molcas_Open(IPotFl,'ESPF.DATA')
do
  Key = Get_Ln(IPotFl)
  if (Key(1:10) == 'GRID      ') then
    call Get_I1(2,nGrdPt)
    exit
  end if
end do
close(IPotFl)

iDum = 0
do iPnt=1,nGrdPt
  ZFd(1) = CCoor((iPnt-1)*4+4)
  NoLoop = ZFd(1) == Zero
  if (NoLoop) cycle
  ! Pick up the center coordinates
  C(1) = CCoor((iPnt-1)*4+1)
  C(2) = CCoor((iPnt-1)*4+2)
  C(3) = CCoor((iPnt-1)*4+3)

  if (iPrint >= 99) call RecPrt('C',' ',C,1,3)

  ! Generate stabilizer of C

  iChxyz = iChAtm(C)
  call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)

  ! Find the DCR for M and S

  call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
  Fact = -real(nStabM,kind=wp)/real(LmbdT,kind=wp)

  if (iPrint >= 99) then
    write(u6,*) ' ZFd=',(ZFd(i),i=1,nTri_Elem1(iOrdOp))
    write(u6,*) ' Fact=',Fact
    call RecPrt('DAO*Fact*ZFd()',' ',Array(ipDAO),nZeta*nDAO,nTri_Elem1(iOrdOp))
    write(u6,*) ' m      =',nStabM
    write(u6,'(9A)') '(M)=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
    write(u6,*) ' s      =',nStb
    write(u6,'(9A)') '(S)=',(ChOper(iStb(ii)),ii=0,nStb-1)
    write(u6,*) ' LambdaT=',LmbdT
    write(u6,*) ' t      =',nDCRT
    write(u6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),ii=0,nDCRT-1)
  end if
  iuvwx(3) = nStb
  iuvwx(4) = nStb
  JndGrd(:,1:2) = IndGrd
  JfGrad(:,1:2) = IfGrad

  ! No derivatives with respect to the third or fourth center.
  ! The positions of the points in the external field are frozen.

  JndGrd(:,3:4) = 0
  JfGrad(:,3:4) = .false.
  mGrad = 0
  do iCar=1,3
    do i=1,2
      if (JfGrad(iCar,i)) mGrad = mGrad+1
    end do
  end do
  if (iPrint >= 99) write(u6,*) ' mGrad=',mGrad
  if (mGrad == 0) cycle

  do lDCRT=0,nDCRT-1
    lOp(3) = NrOpr(iDCRT(lDCRT))
    lOp(4) = lOp(3)
    call OA(iDCRT(lDCRT),C,TC)
    CoorAC(:,2) = TC
    Coori(:,3) = TC
    Coori(:,4) = TC

    if (iOrdOp == 0) then
      call DYaX(nZeta*nDAO,Fact*ZFd(1),DAO,1,Array(ipDAO),1)
    else
      call OA(iDCRT(lDCRT),ZFd,TZFd)
      jpDAO = ipDAO
      ZFdx = TZFd(1)
      call DYaX(nZeta*nDAO,Fact*ZFdx,DAO,1,Array(jpDAO),1)
      jpDAO = jpDAO+nZeta*nDAO
      ZFdy = TZFd(2)
      call DYaX(nZeta*nDAO,Fact*ZFdy,DAO,1,Array(jpDAO),1)
      jpDAO = jpDAO+nZeta*nDAO
      ZFdz = TZFd(3)
      call DYaX(nZeta*nDAO,Fact*ZFdz,DAO,1,Array(jpDAO),1)
    end if

    ! Compute integrals with the Rys quadrature.

    nT = nZeta
    nDiff = 1
    mRys = (la+lb+2+nDiff+iOrdOp)/2
    call Rysg1(iAnga,mRys,nT,Array(ipA),Array(ipB),[One],[One], &
               Zeta,ZInv,nZeta,[One],[One],1, &
               P,nZeta,TC,1,Coori,Coori,CoorAC, &
               Array(nip),nArray,TNAI1,Fake,XCff2D,Array(ipDAO),nDAO*nTri_Elem1(iOrdOp),Grad,nGrad,JfGrad,JndGrd,lOp,iuvwx)

    !call RecPrt(' In BdVGrd:Grad',' ',Grad,nGrad,1)
  end do  ! End loop over DCRs

end do  ! End loop over centers in the grid

return

end subroutine BdVGrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Effective_CD_Pairs(ip_ij2,nij_Eff)
      use Basis_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the max number of auxiliary shells in case of CD. Hence
*     we do not have any explicit auxiliary basis set!
*
      nSkal_Valence=0
      Do iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%Aux) Then
            Do iAng = 0, dbsc(iCnttp)%nVal-1
               iShll = dbsc(iCnttp)%iVal + iAng
               If (.Not.Shells(iShll)%Aux) Then
                  nSkal_Valence = nSkal_Valence + dbsc(iCnttp)%nCntr
               End If
            End Do
         End If
      End Do
*
*     Max number of pairs
*
      nij=nSkal_Valence*(nSkal_Valence+1)/2
      Call GetMem('ip_ij3','Allo','Inte',ip_ij3,nij)
      Call IZero(iWork(ip_ij3),nij)
C     Write (*,*) 'nij3=',nij
*                                                                      *
************************************************************************
*                                                                      *
      nAux_Tot=0
      nVal_Tot=0
      Do iIrrep = 0, nIrrep-1
         nAux_Tot=nAux_Tot+nBas_Aux(iIrrep)
         nVal_Tot=nVal_Tot+nBas(iIrrep)
      End Do
      Call GetMem('SO_ab','Allo','INTE',ipSO_ab,2*nAux_Tot)
      Call iZero(iWork(ipSO_ab),2*nAux_Tot)
*
      iOff = 0
      jOff = 0
      nSym=nIrrep
      Do iSym = 1, nSym
         iIrrep=iSym-1
         ip_List_rs=ip_InfVec+MaxVec*InfVec_N2*(iSym-1)
         Call CHO_X_GET_PARDIAG(iSym,ip_List_rs,iWork(ipSO_ab+iOff))
*
         Call Get_Auxiliary_Shells(iWork(ipSO_ab+iOff),nBas_Aux(iIrrep),
     &                             jOff,iWork(ip_iSOShl),nVal_Tot,
     &                             iWork(ip_ij3),nij)
*
         jOff = jOff + nBas_Aux(iIrrep)
         iOff = iOff + 2*nBas_Aux(iIrrep)
      End Do
      Call Free_iWork(ipSO_ab)
*                                                                      *
************************************************************************
*                                                                      *
      nij_Eff=0
      Do i = 1, nij
         nij_Eff = nij_Eff + iWork(ip_ij3-1+i)
      End Do
C     Write (6,*) 'nij_Eff=',nij_Eff
      If (nij_Eff.gt.nij) Then
         Call WarningMessage(2,
     &               'Effective_CD_Pairs: nij_Eff.gt.nij')
         Call Abend()
      End If
*
      Call GetMem('ip_ij2','Allo','Inte',ip_ij2,nij_Eff*2)
      ij = 0
      ij_Eff = 0
      Do i = 1, nSkal_Valence
         Do j = 1, i
            ij = ij + 1
C           Write (6,*) 'i,j,ij=',i,j,ij
            If (iWork(ip_ij3-1+ij).eq.1) Then
               ij_Eff = ij_Eff + 1
C              Write (*,*) 'ij_Eff=',ij_Eff
               iWork(ip_ij2-1 + (ij_Eff-1)*2 + 1) = i
               iWork(ip_ij2-1 + (ij_Eff-1)*2 + 2) = j
            End If
         End Do
      End Do
      If (ij_Eff.ne.nij_Eff) Then
         Call WarningMessage(2,
     &               'Effective_CD_Pairs: ij_Eff.ne.nij_Eff')
         Call Abend()
      End If
      Call Free_Work(ip_ij3)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      Subroutine Get_Auxiliary_Shells(iSO,nSO,jOff,iSO2Shl,nSO2Shl,
     &                                iPair,nPair)
      Integer iSO(2,nSO), iSO2Shl(nSO2Shl), iPair(nPair)
*
C      Write (6,*) 'iSO'
C      Write (6,*) '==='
C      Do i = 1, nSO
C         Write (6,*) iSO(1,i), iSO(2,i)
C      End Do
*
C      Write (6,*) 'iSO2Shl'
C      Write (6,*) '======='
C      Do i = 1, nSO2Shl
C         Write (6,*) i, iSO2Shl(i)
C      End Do
       Do i = 1, nSO
          k=iSO(1,i) + jOff
          l=iSO(2,i) + jOff
          kSh=iSO2Shl(k)
          lSh=iSO2Shl(l)
C         Write (6,*) 'k,kSh=',k,kSh
C         Write (6,*) 'l,lSh=',k,lSh
          kl = Max(kSh,lSh)*(Max(kSh,lSh)-1)/2 + Min(kSh,lSh)
          iPair(kl)=1
      End Do
C     Write (6,*) 'iPairs'
C     Write (6,*) '======'
C     Do i = 1, nPair
C        Write (6,*) iPair(i)
C     End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine put array integer data to the runfile.                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: August 2003                                                 *
*                                                                      *
************************************************************************
*  Put_iArray
*
*> @brief
*>   Add/update array data in runfile
*> @author Per-Olof Widmark
*>
*> @details
*> This routine is used to put array data of type
*> ``Integer`` into the runfile. The data items are
*> identified by the label. Below is a list of the
*> data items that are recognized. The labels are
*> case insensitive and significant to 16 characters.
*>
*> For development purposes you can use an unsupported
*> label. Whenever such a field is accessed a warning
*> message is printed in the output, to remind the
*> developer to update this routine.
*>
*> List of known labels:
*>
*> - '``Center Index``'
*> - '``Ctr Index Prim``'       Idem with primitive basis set.
*> - '``nAsh``'                 The number of active orbitals per irreducible representation.
*> - '``nBas``'                 The number of basis functions per irreducible representation.
*> - '``nDel``'                 The number of deleted orbitals per irreducible representation.
*> - '``nFro``'                 The number of frozen orbitals per irreducible representation, i.e. orbitals that are not optimized.
*> - '``nIsh``'                 The number of inactive orbitals per irreducible representation.
*> - '``nIsh beta``'
*> - '``nOrb``'                 The total number of orbitals per irreducible representation.
*> - '``Orbital Type``'
*> - '``Slapaf Info 1``'        Misc. information for module SLAPAF.
*> - '``Symmetry operations``'  The symmetry operations of the point group.
*> - '``Non valence orbitals``' The total number of non valence orbitals per irreducible representation.
*> - '``MkNemo.hDisp``'         The hash matrix for displacements as specified in the mknemo module.
*>
*> @param[in] Label Name of field
*> @param[in] Data  Data to put on runfile
*> @param[in] nData Length of array
************************************************************************
      Subroutine Put_iArray(Label,Data,nData)
      Implicit None
#include "pg_ia_info.fh"
*----------------------------------------------------------------------*
* Arguments                                                            *
*----------------------------------------------------------------------*
      Character*(*) Label
      Integer       nData
      Integer       Data(nData)
*----------------------------------------------------------------------*
* Define local variables                                               *
*----------------------------------------------------------------------*
      Character*16 RecLab(nTocIA)
      Integer      RecIdx(nTocIA)
      Integer      RecLen(nTocIA)
      Save         RecLab
      Save         RecIdx
      Save         RecLen
*
      Character*16 CmpLab1
      Character*16 CmpLab2
      Integer      nTmp
      Integer      item
      Integer      iTmp
      Integer      i
*----------------------------------------------------------------------*
* Initialize local variables                                           *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
* Do setup if this is the first call.                                  *
*----------------------------------------------------------------------*
      Call ffRun('iArray labels',nTmp,iTmp)
      If(nTmp.eq.0) Then
         Do i=1,nTocIA
            RecLab(i)=' '
            RecIdx(i)=sNotUsed
            RecLen(i)=0
         End Do
*
*        Observe that label is at most 16 characters!
*
*                     1234567890123456
         RecLab(  1)='Center Index    '
         RecLab(  2)='nAsh            '
         RecLab(  3)='nBas            '
         RecLab(  4)='nDel            '
         RecLab(  5)='nFro            '
         RecLab(  6)='nIsh            '
         RecLab(  7)='nIsh beta       '
         RecLab(  8)='nOrb            '
         RecLab(  9)='Orbital Type    '
         RecLab( 10)='Slapaf Info 1   '
         RecLab( 11)='Symmetry operati' !ons
         RecLab( 12)='nIsh_ab         '
         RecLab( 13)='nStab           '
         RecLab( 14)='                ' !Free slot
         RecLab( 15)='Quad_i          '
         RecLab( 16)='RFcInfo         '
         RecLab( 17)='RFiInfo         '
         RecLab( 18)='RFlInfo         '
         RecLab( 19)='SCFInfoI        '
         RecLab( 20)='Misc            '
         RecLab( 21)='SewIInfo        '
         RecLab( 22)='                ' !Free slot
         RecLab( 23)='SCFInfoI_ab     '
         RecLab( 24)='icDmp           '
         RecLab( 25)='Symmetry Info   '
         RecLab( 26)='Sizes           '
         RecLab( 27)='                ' !Free slot
         RecLab( 28)='IndS            '
         RecLab( 29)='                ' !Free slot
         RecLab( 30)='                ' !Free slot
         RecLab( 31)='                ' !Free slot
         RecLab( 32)='                ' !Free Slot
         RecLab( 33)='                ' !Free slot
         RecLab( 34)='                ' !Free slot
         RecLab( 35)='                ' !Free slot
         RecLab( 36)='LP_A            '
         RecLab( 37)='NumCho          ' ! Number of Cholesky vectors.
         RecLab( 38)='nFroPT          ' ! Number of Frozen for PT
         RecLab( 39)='nDelPT          ' ! Number of Deleted for PT
         RecLab( 40)='BasType         '
         RecLab( 41)='Spread of Coord.'
         RecLab( 42)='Unit Cell Atoms '
         RecLab( 43)='iSOShl          '
         RecLab( 44)='Non valence orbi' !tals
         RecLab( 45)='LoProp nInts    '
         RecLab( 46)='LoProp iSyLbl   '
         RecLab( 47)='nDel_go         '
         RecLab( 48)='nBas_Prim       '
         RecLab( 49)='IsMM            '
         RecLab( 50)='Atom -> Basis   '
         RecLab( 51)='Logical_Info    '
         RecLab( 52)='                ' !Free slot
         RecLab( 53)='                ' !Free slot
         RecLab( 54)='SCF nOcc        '
         RecLab( 55)='SCF nOcc_ab     '
         RecLab( 56)='                ' !Free slot
         RecLab( 57)='                ' !Free slot
         RecLab( 58)='iAOtSO          '
         RecLab( 59)='iSOInf          '
         RecLab( 60)='                ' !Free Slot
         RecLab( 61)='AuxShell        '
         RecLab( 62)='nVec_RI         '
         RecLab( 63)='MkNemo.hDisp    '
         RecLab( 64)='Index ZMAT      '
         RecLab( 65)='NAT ZMAT        '
         RecLab( 66)='                ' ! Free slot
         RecLab( 67)='nDisp           '
         RecLab( 68)='DegDisp         '
         RecLab( 69)='LBList          '
         RecLab( 71)='Ctr Index Prim  '
         RecLab( 72)='MLTP_SINGLE     '
         RecLab( 73)='JBNUM_SINGLE    '
         RecLab( 74)='LROOT_SINGLE    '
         RecLab( 75)='GeoInfo         '
         RecLab( 76)='Cholesky BkmDim '
         RecLab( 77)='Cholesky BkmVec '
         RecLab( 78)='Atom Types      '
         RecLab( 79)='LA Def          '
         RecLab( 80)='Basis IDs       '
         RecLab( 81)='Desym Basis IDs '
         RecLab( 82)='primitive ids   '
         RecLab( 83)='Root Mapping    '
         RecLab( 84)='Fermion IDs     '
         RecLab( 85)='IsMM Atoms      '
         RecLab( 86)='Un_cen Charge   '
         RecLab( 87)='PCM_N           '
         RecLab( 88)='PCMiSph         '
         RecLab( 89)='NVert           '
         RecLab( 90)='IntSph          '
         RecLab( 91)='NewSph          '
         RecLab( 92)='XMolnr          '
         RecLab( 93)='XEle            '
         RecLab( 94)='iDmp            '
         RecLab( 95)='iDmp:S          '
         Reclab( 96)='NSTAT_SINGLE    '
*                     1234567890123456

* Do not go beyond 128 without changing the length of RecLab in include
* file too!
         Call cWrRun('iArray labels',RecLab,16*nTocIA)
         Call iWrRun('iArray indices',RecIdx,nTocIA)
         Call iWrRun('iArray lengths',RecLen,nTocIA)
      Else
         Call cRdRun('iArray labels',RecLab,16*nTocIA)
         Call iRdRun('iArray indices',RecIdx,nTocIA)
         Call iRdRun('iArray lengths',RecLen,nTocIA)
      End If
*----------------------------------------------------------------------*
* Locate item                                                          *
*----------------------------------------------------------------------*
      item=-1
      CmpLab1=Label
      Call UpCase(CmpLab1)
      Do i=1,nTocIA
         CmpLab2=RecLab(i)
         Call UpCase(CmpLab2)
         If(CmpLab1.eq.CmpLab2) item=i
      End Do
*
* Do we create a new temporary field?
*
      If(item.eq.-1) Then
         Do i=1,nTocIA
            If(RecLab(i).eq.' ') item=i
         End Do
         If(item.ne.-1) Then
            RecLab(item)=Label
            RecIdx(item)=sSpecialField
            Call cWrRun('iArray labels',RecLab,16*nTocIA)
            Call iWrRun('iArray indices',RecIdx,nTocIA)
         End If
      End If
*
* Is this a temporary field?
*
      If(item.ne.-1) Then
         If(Recidx(item).eq.sSpecialField) Then
            Write(6,*) '***'
            Write(6,*) '*** Warning, writing temporary iArray field'
            Write(6,*) '***   Field: ',Label
            Write(6,*) '***'
#ifndef _DEVEL_
            Call AbEnd()
#endif
         End If
      End If
*----------------------------------------------------------------------*
* Write data to disk.                                                  *
*----------------------------------------------------------------------*
      If(item.eq.-1) Then
         Call SysAbendMsg('put_iArray','Could not locate',Label)
      End If
      Call iWrRun(RecLab(item),Data,nData)
      If(RecIdx(item).eq.0) Then
         RecIdx(item)=sRegularField
         Call iWrRun('iArray indices',RecIdx,nTocIA)
      End If
      If(RecLen(item).ne.nData) Then
         RecLen(item)=nData
         Call iWrRun('iArray lengths',RecLen,nTocIA)
      End If
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!---------------------------------------------------------------------*
!                                                                     *
!     lDaRec       : minimal record (in 4Byte words) transfered by    *
!                    DAFILE                                           *
!     nSect        : integer multiple of lDaRec which constitutes the *
!                    standard record length                           *
!     lStRec       : standard record length in units of integers      *
!     DiskMx_Byte  : Max disk space -1 in units of Byte               *
!                                                                     *
!---------------------------------------------------------------------*

module IOBUF

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: lDaRec = 2**10, Mode_None = 111111111, Mode_Read = 987654321, Mode_Write = 198765432, &
                                nSect = 2**5, lStRec = nSect*lDaRec
integer(kind=iwp) :: iBuf, id, iPos, iStatIO, lBuf, LuTmp, nBuf
real(kind=wp) :: Disk, Disk_1, Disk_2, DiskMx_Byte
logical(kind=iwp) :: InCore, IODone, OnDisk
real(kind=wp), allocatable :: Buffer(:,:)

public :: Buffer, Disk, Disk_1, Disk_2, DiskMX_Byte, iBuf, ID, InCore, IODone, ipos, iStatIO, lBuf, lDaRec, lStRec, LuTmp, &
          Mode_None, Mode_Read, Mode_Write, nSect, nBuf, OnDisk

end module IOBUF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE INFO_CONF_LIST(NCONF_PER_OPEN,
     &                           MAXOP,NEL,LENGTH_LIST,NCONF_TOT,IB_REO,
     &                           IB_OCC)
*
* Info on  configuration list form NCONF_PER_OPEN
*
* Jeppe Olsen, November 2001
*
#include "implicit.fh"
*. Input
      INTEGER NCONF_PER_OPEN(MAXOP+1)
*. Output :
*    Offset for configuration  with given number of
*    open orbitals in of configuration reordering
      INTEGER IB_REO(MAXOP+1)
*    Offset for configuration  with given number of
*    open orbitals in list of configuration occupations
      INTEGER IB_OCC(MAXOP+1)
*
      LENGTH = 0
      JB_REO = 1
      JB_OCC = 1
C?    WRITE(6,*) ' MAXOP, NEL = ', MAXOP, NEL
      DO NOPEN = 0, MAXOP
        IB_REO(NOPEN+1) =  JB_REO
        IB_OCC(NOPEN+1) =  JB_OCC
        IF(MOD(NEL-NOPEN,2).EQ.0) THEN
          NOCOB = NOPEN + (NEL - NOPEN)/2
          JB_OCC = JB_OCC + NOCOB*NCONF_PER_OPEN(NOPEN+1)
          JB_REO = JB_REO + NCONF_PER_OPEN(NOPEN+1)
        END IF
      END DO
*
      LENGTH_LIST = JB_OCC-1
      NCONF_TOT = JB_REO - 1
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' NCONF_PER_OPEN list '
        CALL IWRTMA(NCONF_PER_OPEN,1,MAXOP+1,1,MAXOP+1)
        WRITE(6,*) ' Length of configuration list :', LENGTH_LIST
        WRITE(6,*) ' Total number of configurations : ', NCONF_TOT
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine calc_MP2(w,e,no,nv)
! this is primitive checking routine to calculate 2nd order energy

use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: no, nv
real(kind=wp), intent(in) :: w(nv,no,nv,no), e(no+nv)
integer(kind=iwp) :: a, b, i, j
real(kind=wp) :: denom, e2, integral

e2 = Zero

do j=1,no
  do i=1,no
    do b=1,nv
      do a=1,nv

        denom = e(no+a)+e(no+b)-e(i)-e(j)
        !mp write(u6,'(4(i3,2x),A,3(f17.10,2x))') a,i,b,j,'w1, w2, denom ',w(a,i,b,j),w(a,j,b,i),denom

        integral = -Two*w(a,i,b,j)**2-w(a,j,b,i)

        !write(u6,*) integral

        e2 = e2+integral/denom

      end do
    end do
  end do
end do

write(u6,*) 'Druhy rad je asi = ',e2

return

end subroutine calc_MP2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine OneEl_g(Kernel,KrnlMm,Grad,nGrad,DiffOp,CCoor,FD,
     &                        nFD,lOper,nComp,nOrdOp,Label)
************************************************************************
*                                                                      *
* Object: to compute gradients of the one electron integrals.          *
*         The memory at this point is assumed to be large enough to do *
*         the computation in core.                                     *
*         The data is structured with respect to four indices, two (my *
*         ny or i j) refer to primitives or basis functions and two (a *
*         b) refer to the components of the cartesian or spherical     *
*         harmonic gaussians.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*             Modified for Hermite-Gauss quadrature November '90       *
*             Modified for Rys quadrature November '90                 *
*             Modified for multipole moments November '90              *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for general kernel routines January '91         *
*             Modified for nonsymmetrical operators February '91       *
*             Modified for gradients October '91                       *
************************************************************************
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
*     External Kernel, KrnlMm
      External KrnlMm
#include "Molcas.fh"
#include "angtp.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "disp.fh"
#include "nsd.fh"
#include "nac.fh"
#include "setup.fh"
CNIKO      Real*8 A(3), B(3), Ccoor(3,nComp), FD(nFD),
      Real*8 A(3), B(3), Ccoor(*), FD(nFD),
     &       RB(3), Grad(nGrad)
      Character ChOper(0:7)*3, Label*80
      Integer iDCRR(0:7), iDCRT(0:7), iStabM(0:7),
     &          IndGrd(3,2), nOp(2), iStabO(0:7), lOper(nComp)
      Logical AeqB, EQ, DiffOp, IfGrad(3,3)
      Logical FreeiSD
      Real*8, Allocatable:: Zeta(:), ZI(:), Kappa(:), PCoor(:,:)
      Real*8, Allocatable:: Krnl(:), Final(:), Scr1(:), Scr2(:)
      Real*8, Allocatable:: DAO(:), DSOpr(:), DSO(:)
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      Subroutine Kernel(
#define _CALLING_
#include "grd_interface.fh"
     &                 )
#include "grd_interface.fh"
      End Subroutine Kernel
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
*
*     Statement functions
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 112
      iPrint = nPrint(iRout)
      call dcopy_(nGrad,[Zero],0,Grad,1)
*
      iIrrep = 0
*
*     Auxiliary memory allocation.
*
      Call mma_allocate(Zeta,S%m2Max,Label='Zeta')
      Call mma_allocate(ZI,S%m2Max,Label='ZI')
      Call mma_allocate(Kappa,S%m2Max,Label='Kappa')
      Call mma_allocate(PCoor,S%m2Max,3,Label='PCoor')
*                                                                      *
************************************************************************
*                                                                      *
      If (.Not.Allocated(iSD)) Then
         Call Set_Basis_Mode('Valence')
         Call Setup_iSD()
         FreeiSD=.True.
      Else
         FreeiSD=.False.
      End If
      Call Nr_Shells(nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
*-----Double loop over shells. These loops decide the integral type
*
      nTasks = nSkal*(nSkal+1)/2
      iS = 0
      jS = 0
      Do ijS = 1, nTasks
         jS = jS + 1
         If (jS.gt.iS) Then
            iS = jS
            jS = 1
         End If
*
C     Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

C        Do jS = 1, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
            B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
*
            iSmLbl = 1
            nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            If (nSO.eq.0) Go To 131
*
*           Find the DCR for A and B
*
            Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &                                  dc(mdcj)%iStab,dc(mdcj)%nStab,
     &                                                iDCRR,nDCRR)
*
*           For the CSF contribution we cannot skip the A,A case
*
            If (.Not.isCSF) Then
               If (.Not.DiffOp .and. nDCRR.eq.1 .and. EQ(A,B)) Go To 131
            End If
            If (iPrint.ge.49) Write (6,'(10A)')
     &         ' {R}=(',(ChOper(iDCRR(i)),i=0,nDCRR-1),')'
*
            If (iPrint.ge.19) Write (6,'(A,A,A,A,A)')
     &         ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
*
*           Call kernel routine to get memory requirement.
*
            Call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)
            MemKrn=MemKer*S%m2Max
            Call mma_allocate(Krnl,MemKrn,Label='Krnl')
*
*           Allocate memory for the final integrals, all in the
*           primitive basis.
*
            lFinal = 6 * S%MaxPrm(iAng) * S%MaxPrm(jAng) *
     &               nElem(iAng)*nElem(jAng) * nComp
            Call mma_allocate(Final,lFinal,Label='Final')
*
*           Scratch area for contraction step
*
            nScr1 =S%MaxPrm(iAng)*S%MaxPrm(jAng)*nElem(iAng)*nElem(jAng)
            Call mma_allocate(Scr1,nScr1,Label='Scr1')
*
*           Scratch area for the transformation to spherical gaussians
*
            nScr2=S%MaxPrm(iAng)*S%MaxPrm(jAng)*nElem(iAng)*nElem(jAng)
            Call mma_allocate(Scr2,nScr2,Label='Scr2')
*
            Call mma_allocate(DAO,iPrim*jPrim*nElem(iAng)*nElem(jAng),
     &                        Label='DAO')
*
*           At this point we can compute Zeta.
*
            Call ZXia(Zeta,ZI,iPrim,jPrim,Shells(iShll)%Exp,
     &                                    Shells(jShll)%Exp)
*
            Do iCar = 0, 2
               IndGrd(iCar+1,1) = iSD(iCar+16,iS)
               IfGrad(iCar+1,1) = iSD(iCar+16,iS).ne.0
            End Do
*
            AeqB = iS.eq.jS
*
            Do iCar = 0, 2
               IndGrd(iCar+1,2) = iSD(iCar+16,jS)
               IfGrad(iCar+1,2) = iSD(iCar+16,jS).ne.0
            End Do
*
*-----------Find the stabilizer for A and B
*
            Call Inter(dc(mdci)%iStab,dc(mdci)%nStab,
     &                 dc(mdcj)%iStab,dc(mdcj)%nStab,
     &                             iStabM,nStabM)
*
*           Allocate memory for the elements of the Fock or 1st order
*           density matrix which are associated with the current shell
*           pair.
*
            Call mma_allocate(DSOpr,nSO*iPrim*jPrim,Label='DSOpr')
            Call mma_allocate(DSO,nSO*iPrim*jPrim,Label='DSO')
*
*           Gather the elements from 1st order density / Fock matrix.
*
            Call SOGthr(DSO,iBas,jBas,nSO,FD,n2Tri(iSmLbl),iSmLbl,
     &                  iCmp,jCmp,iShell,jShell,AeqB,iAO,jAO)
*
*           Project the Fock/1st order density matrix in AO
*           basis on to the primitive basis.
*
            If (iPrint.ge.99) Then
               Call RecPrt(' Left side contraction',' ',
     &                     Shells(iShll)%pCff,iPrim,iBas)
               Call RecPrt(' Right side contraction',' ',
     &                     Shells(jShll)%pCff,jPrim,jBas)
            End If
*
*           Transform IJ,AB to J,ABi
            Call DGEMM_('T','T',
     &                  jBas*nSO,iPrim,iBas,
     &                  1.0d0,DSO,iBas,
     &                  Shells(iShll)%pCff,iPrim,
     &                  0.0d0,DSOpr,jBas*nSO)
*           Transform J,ABi to AB,ij
            Call DGEMM_('T','T',
     &                  nSO*iPrim,jPrim,jBas,
     &                  1.0d0,DSOpr,jBas,
     &                  Shells(jShll)%pCff,jPrim,
     &                  0.0d0,DSO,nSO*iPrim)
*           Transpose to ij,AB
            Call DGeTmO(DSO,nSO,nSO,iPrim*jPrim,DSOpr,
     &                  iPrim*jPrim)
            Call mma_deallocate(DSO)
*
            If (iPrint.ge.99) Call
     &         RecPrt(' Decontracted 1st order density/Fock matrix',
     &                ' ',DSOpr,iPrim*jPrim,nSO)
*
*           Loops over symmetry operations.
*
            nOp(1) = NrOpr(0)
c VV: gcc bug: one has to use this if!
          if(nDCRR.ge.1) then
            Do 140 lDCRR = 0, nDCRR-1
               Call OA(iDCRR(lDCRR),B,RB)
               nOp(2) = NrOpr(iDCRR(lDCRR))
*
*              For the CSF contribution we cannot skip the A,A case
*              (lack of translational invariance is taken care of by CmbnS1)
*
               If (.Not.isCSF) Then
                  If (EQ(A,RB).and. .Not.DiffOp) Go To 140
               End If
               If (.Not.DiffOp) Then
*--------------Use the translational invariance to reduce the set of
*              gradients to compute
                  Do iCar = 1, 3
                     If (IfGrad(iCar,1).and.IfGrad(iCar,2))  Then
                        IfGrad(iCar,2) = .False.
                        IndGrd(iCar,2) = -IndGrd(iCar,2)
                     End If
                  End Do
               End If
*
               If (iPrint.ge.49) Then
                  Write (6,'(10A)') ' {M}=(',(ChOper(iStabM(i)),
     &                  i=0,nStabM-1),')'
               End If
*
               llOper = lOper(1)
               Do iComp = 2, nComp
                  llOper = iOr(llOper,lOper(iComp))
               End Do
               Call SOS(iStabO,nStabO,llOper)
               Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
*--------------Compute normalization factor due the DCR symmetrization
*              of the two basis functions and the operator.
*
               iuv = dc(mdci)%nStab*dc(mdcj)%nStab
               FactNd = DBLE(iuv*nStabO) / DBLE(nIrrep**2 * LmbdT)
               If (MolWgh.eq.1) Then
                FactNd = FactNd * DBLE(nIrrep)**2 / DBLE(iuv)
               Else If (MolWgh.eq.2) Then
                FactNd = sqrt(DBLE(iuv))*DBLE(nStabO)/DBLE(nIrrep*LmbdT)
               End If
*
               If (iPrint.ge.49) Then
                  Write (6,'(A,/,2(3F6.2,2X))')
     &                  ' *** Centers A, RB ***',
     &                  ( A(i),i=1,3), (RB(i),i=1,3)
               End If
*
*--------------Desymmetrize the matrix with which we will
*              contracte the trace.
*
               Call DesymD(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                     iShell,jShell,iShll,jShll,
     &                     iAO,jAO,DAO,iPrim,jPrim,
     &                     DSOpr,nSO,nOp,FactNd)
*
*--------------Project the spherical harmonic space onto the
*              cartesian space.
*
               kk = nElem(iAng)*nElem(jAng)
               If (Shells(iShll)%Transf.or.Shells(jShll)%Transf) Then
*
*-----------------ij,AB --> AB,ij
                  Call DGeTmO(DAO,iPrim*jPrim,iPrim*jPrim,
     &                        iCmp*jCmp,Scr1,iCmp*jCmp)
*-----------------AB,ij --> ij,ab
                  Call SphCar(Scr1,iCmp*jCmp,iPrim*jPrim,
     &                        Scr2,nScr2,
     &                        RSph(ipSph(iAng)),
     &                        iAng,Shells(iShll)%Transf,
     &                             Shells(iShll)%Prjct,
     &                        RSph(ipSph(jAng)),
     &                        jAng,Shells(jShll)%Transf,
     &                             Shells(jShll)%Prjct,
     &                        DAO,kk)
               End If
               If (iPrint.ge.99) Call RecPrt(
     &                  ' Decontracted FD in the cartesian space',
     &                  ' ',DAO,iPrim*jPrim,kk)
*
*--------------Compute kappa and P.
*
               Call Setup1(Shells(iShll)%Exp,iPrim,
     &                     Shells(jShll)%Exp,jPrim,
     &                     A,RB,Kappa,PCoor,ZI)
*
*--------------Compute gradients of the primitive integrals and
*              trace the result.
*
               Call Kernel(Shells(iShll)%Exp,iPrim,
     &                     Shells(jShll)%Exp,jPrim,
     &                     Zeta,ZI,Kappa,Pcoor,
     &                     Final,iPrim*jPrim,
     &                     iAng,jAng,A,RB,nOrder,Krnl,
     &                     MemKer,Ccoor,nOrdOp,Grad,nGrad,
     &                     IfGrad,IndGrd,DAO,
     &                     mdci,mdcj,nOp,lOper,nComp,
     &                     iStabM,nStabM)
               If (iPrint.ge.49) Call PrGrad(' In Oneel',
     &             Grad,nGrad,ChDisp,5)
*
 140        Continue
          endif
            Call mma_deallocate(DSOpr)
            Call mma_deallocate(DAO)
            Call mma_deallocate(Scr2)
            Call mma_deallocate(Scr1)
            Call mma_deallocate(Final)
            Call mma_deallocate(Krnl)
 131        Continue
C        End Do
C     End Do
      End Do
*
      If (FreeiSD) Call Free_iSD()
      Call mma_deallocate(PCoor)
      Call mma_deallocate(Kappa)
      Call mma_deallocate(ZI)
      Call mma_deallocate(Zeta)
*
      If (iPrint.ge.15) Call PrGrad(Label,Grad,nGrad,ChDisp,5)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function LDF_OpenC()
      Implicit None
      Integer LuC
#if defined (_MOLCAS_MPP_)
#include "para_info.fh"
      LuC=7
      If (nProcs.gt.1 .and. Is_Real_Par()) Then
         Call DAName_MF_WA(LuC,'MyLC')
      Else
         Call DAName_MF_WA(LuC,'LDFC')
      End If
#else
      LuC=7
      Call DAName_MF_WA(LuC,'LDFC')
#endif
      LDF_OpenC=LuC
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_Energy_Prt(Caller,Job,iBatch)
C
C     Thomas Bondo Pedersen, March 2005.
C
C     Purpose: print progress reports for the MP2 energy evaluation.
C
      Implicit None
      Character*17 Caller
      Integer      Job, iBatch
#include "chomp2.fh"

      Real*8 CME_Time(2,2)
      Save CME_Time

      Character*17 SecNam
      Parameter (SecNam = 'ChoMP2_Energy_Prt')

      Character*10 ThisNam
      Parameter (ThisNam = 'Energy_Prt')

      Real*8 CPU, Wall, Ratio

      If (Job .eq. 0) Then

         Call FZero(CME_Time,2*2)

         Write(6,'(/,4X,A,/,4X,A)')
     &   'Evaluation of MP2 energy correction',
     &   '==================================='
         Write(6,'(4X,A,A)')
     &   'Evaluator: ',Caller

         Write(6,'(/,4X,A,/,4X,A,/,4X,A)')
     &   'Batch      CPU       Wall    Ratio',
     &   ' No.     seconds    seconds',
     &   '----------------------------------'

         Call xFlush(6)

      Else If (Job .eq. 1) Then

         Call CWTime(CME_Time(1,1),CME_Time(2,1))

         Call xFlush(6)

      Else If (Job .eq. 2) Then

         Call CWTime(CME_Time(1,2),CME_Time(2,2))
         CPU   = CME_Time(1,2) - CME_Time(1,1)
         Wall  = CME_Time(2,2) - CME_Time(2,1)
         If (Abs(Wall) .lt. 1.0D-8) Then
            If (Abs(CPU) .lt. 1.0D-8) Then
               Ratio = 1.0D0
            Else
               Ratio = 1.0D15
            End If
         Else
            Ratio = CPU/Wall
         End If
         Write(6,'(I9,2(1X,F10.2),1X,F6.3)') iBatch,CPU,Wall,Ratio

         Call xFlush(6)

      Else If (Job .eq. 3) Then

         Write(6,'(4X,A)')
     &   '----------------------------------'

         Call xFlush(6)

      Else

         Call ChoMP2_Quit(SecNam,
     &                    'Input parameter "Job" is out of range',' ')

      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
* This routine prints the prologue part to the postscript figure of    *
* occupation numbers.                                                  *
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine FigOpn(lu)
      Write(lu,'(a)') '%!PS'
      Write(lu,'(a)') '%%BoundingBox: 70 95 550 735'
      Write(lu,'(a)') '/TF /Helvetica findfont 18 scalefont def'
      Write(lu,'(a)') '/SF /Symbol findfont 18 scalefont def'
      Write(lu,'(a)') '/HF /Helvetica findfont 24 scalefont def'
      Write(lu,'(a)') '/Y {0.5 sub neg 75 mul} def'
      Write(lu,'(a)') '/X {75 mul} def'
      Write(lu,'(a)') '/Draw {'
      Write(lu,'(a)') '  newpath'
      Write(lu,'(a)') '  2.0 setlinewidth'
      Write(lu,'(a)') '  moveto'
      Write(lu,'(a)') '  0.5 X 0 rlineto'
      Write(lu,'(a)') '  currentpoint /y exch def /x exch def'
      Write(lu,'(a)') '  stroke'
      Write(lu,'(a)') '  x y moveto'
      Write(lu,'(a)') '} def'
      Write(lu,'(a)') '/Label {'
      Write(lu,'(a)') '  TF setfont'
      Write(lu,'(a)') '  6 -6 rmoveto show'
      Write(lu,'(a)') '} def'
      Write(lu,'(a)') '/Connect {'
      Write(lu,'(a)') '  [5 5] 0 setdash'
      Write(lu,'(a)') '  newpath'
      Write(lu,'(a)') '  0.5 setlinewidth'
      Write(lu,'(a)') '  moveto'
      Write(lu,'(a)') '  exch 0.5 X add exch'
      Write(lu,'(a)') '  lineto'
      Write(lu,'(a)') '  stroke'
      Write(lu,'(a)') '  [] 0 setdash'
      Write(lu,'(a)') '} def'
      Write(lu,'(a)') '/CenterLine {'
************************************************************************
      Write(lu,'(a)') '  dup stringwidth pop 0.5 mul neg 0 rmoveto show'
      Write(lu,'(a)') '} def'
      Write(lu,'(a)') '/RightLine {'
      Write(lu,'(a)') '  dup stringwidth pop neg 0 rmoveto show'
      Write(lu,'(a)') '} def'
      Write(lu,'(a)') '%.ManualFeed'
      Write(lu,'(a)') 'gsave'
      Write(lu,'(a)') '144 144 translate'
      Write(lu,'(a)') '-0.30 X -6.6 Y moveto'
      Write(lu,'(a)') 'TF setfont (lg\050) CenterLine'
      Write(lu,'(a)') 'SF setfont (h) show'
      Write(lu,'(a)') 'TF setfont (\051) show'
      Write(lu,'(a)') '%---'
      Write(lu,'(a)') 'TF setfont'
      Write(lu,'(a)') '0.25 X 1.0 Y moveto (s) CenterLine'
      Write(lu,'(a)') '1.25 X 1.0 Y moveto (p) CenterLine'
      Write(lu,'(a)') '2.25 X 1.0 Y moveto (d) CenterLine'
      Write(lu,'(a)') '3.25 X 1.0 Y moveto (f) CenterLine'
      Write(lu,'(a)') '4.25 X 1.0 Y moveto (g) CenterLine'
      Write(lu,'(a)') '%---'
      Write(lu,'(a)') '3.0 setlinewidth'
      Write(lu,'(a)') 'newpath'
************************************************************************
      Write(lu,'(a)') '-0.25 X  0.5 Y moveto -0.25 X -6.5 Y lineto'
      Write(lu,'(a)') '-0.40 X  0.0 Y moveto -0.25 X  0.0 Y lineto'
      Write(lu,'(a)') '-0.40 X -1.0 Y moveto -0.25 X -1.0 Y lineto'
      Write(lu,'(a)') '-0.40 X -2.0 Y moveto -0.25 X -2.0 Y lineto'
      Write(lu,'(a)') '-0.40 X -3.0 Y moveto -0.25 X -3.0 Y lineto'
      Write(lu,'(a)') '-0.40 X -4.0 Y moveto -0.25 X -4.0 Y lineto'
      Write(lu,'(a)') '-0.40 X -5.0 Y moveto -0.25 X -5.0 Y lineto'
      Write(lu,'(a)') '-0.40 X -6.0 Y moveto -0.25 X -6.0 Y lineto'
      Write(lu,'(a)') 'TF setfont'
      Write(lu,'(a)') '-0.45 X  0.0 Y 6 sub moveto (0.0) RightLine'
      Write(lu,'(a)') '-0.45 X -1.0 Y 6 sub moveto (\261 1.0) RightLine'
      Write(lu,'(a)') '-0.45 X -2.0 Y 6 sub moveto (\261 2.0) RightLine'
      Write(lu,'(a)') '-0.45 X -3.0 Y 6 sub moveto (\261 3.0) RightLine'
      Write(lu,'(a)') '-0.45 X -4.0 Y 6 sub moveto (\261 4.0) RightLine'
      Write(lu,'(a)') '-0.45 X -5.0 Y 6 sub moveto (\261 5.0) RightLine'
      Write(lu,'(a)') '-0.45 X -6.0 Y 6 sub moveto (\261 6.0) RightLine'
      Write(lu,'(a)') 'stroke'
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine JKQPar_Naoya(N1,N2,HEXCH,Jpar)
      Implicit None
      Integer, parameter            :: wp=SELECTED_REAL_KIND(p=15,r=307)

      Integer, intent(in)           :: N1, N2
      Complex(kind=8), intent(in)  :: HEXCH(N1,N1,N2,N2)
      Complex(kind=8), intent(out) :: Jpar( (N1-1), (-N1+1):(N1-1),
     &                                       (N2-1), (-N2+1):(N2-1) )
      ! local variables
      Integer          :: is1,is2,js1,js2,ms1,ms2,ns1,ns2,
     &                    k1,k2,q1,q2,j1,j2
      Complex(kind=8) :: QMAT(N1,N1,N2,N2), trace
      Real(kind=8)    :: WCG, OPER, FACT
      External         :: WCG
      Logical DBG
      DBG=.false.

c we need to project now the HEXCH: in products of ITOs
c  HEXCH = SUM(rank1,proj1,rank2,proj2)=
c         { B(rank1,proj1,rank2,proj2)* O1(rank1,proj1) * O2(rank2,proj2) }
c Naoya definition
c eq.40 in DoI:10.1103/PhysRevB.91.174438
      Jpar=(0.0_wp,0.0_wp)
      J1=N1-1 ! i.e. Double of the dimension of the spin on site 1
      J2=N2-1 ! i.e. Double of the dimension of the spin on site 2
      Do k1=0,J1
        Do q1=-k1,k1
          Do k2=0,J2
            Do q2=-k2,k2
!             the rank of individual spins must be even
              If( mod(k1,2).ne.1) Go To 104
!             the rank of individual spins must be even
              If( mod(k2,2).ne.1) Go To 104
!             If the total rank is odd, Then it is a local ZFS contribution; ==> to be Done later
              QMAT=0.0_wp
              ! compute the qmat:
              ! projections q and q' are with opposite sign:
              !  -is1 and  -is2
              Do is1=1,N1
                ms1=2*is1-N1-1 ! spin projection on site 1
                Do js1=1,N1
                  ns1=2*js1-N1-1 ! spin projection on site 1
                  Do is2=1,N2
                    ms2=2*is2-N2-1 ! spin projection on site 2
                    Do js2=1,N2
                      ns2=2*js2-N2-1 ! spin projection on site 2
                      If ( WCG(J1,J1,2*k1,0,J1,J1)==0) Go To 103
                      If ( WCG(J2,J2,2*k2,0,J2,J2)==0) Go To 103

                      QMAT(is1,js1,is2,js2)=
     &                               WCG( J1, ns1, 2*k1,-2*q1, J1, ms1 )
     &                             * WCG( J2, ns2, 2*k2,-2*q2, J2, ms2 )
     &                             / WCG( J1,  J1, 2*k1,    0, J1,  J1 )
     &                             / WCG( J2,  J2, 2*k2,    0, J2,  J2 )

       If ( DBG .and. (ABS(QMAT(is1,js1,is2,js2)).gt.1.d-12) ) Then
          Write(6,'(8(A,i3),A,2F20.14)')
     &                       ' QMAT(',k1,',', q1,',', k2,',', q2,'|||',
     &                               is1,',',js1,',',is2,',',js2,') = ',
     &                         QMAT(is1,js1,is2,js2)
       End If

 103                Continue
                    End Do
                  End Do
                End Do
              End Do
              ! compute the trace Tr[QMAT * HEXCH]
              trace=(0.0_wp,0.0_wp)
              Do is1=1,N1
                Do js1=1,N1
                  Do is2=1,N2
                    Do js2=1,N2
                      trace = trace +  QMAT(is1,js1,is2,js2)
     &                              * HEXCH(js1,is1,js2,is2)
                    End Do
                  End Do
                End Do
              End Do

              If ( DBG .AND. (ABS(trace).gt.1.d-12) ) Then
                  Write(6,'(4(A,i3),A,2F20.14)')
     &                    'trace(',k1,',',q1,',',k2,',',q2,') = ',trace
              End If

              OPER=0.0_wp
              FACT=0.0_wp
              OPER= WCG(J1,J1,2*k1,0,J1,J1)*WCG(J1,J1,2*k1,0,J1,J1)
     &             *WCG(J2,J2,2*k2,0,J2,J2)*WCG(J2,J2,2*k2,0,J2,J2)
              FACT=dble(((-1)**(q1+q2))*((2*k1+1)*(2*k2+1)))/dble(N1*N2)

              Jpar(k1,q1,k2,q2)=cmplx(FACT*OPER,0.0_wp,wp)*trace

              If( DBG.and. (ABS(Jpar(k1,q1,k2,q2)).gt.0.5d-13) ) Then
                  Write(6,'(4(A,i3),A,2F20.14)')
     &                    '    J(',k1,',',q1,',',k2,',',q2,') = ',
     &                         Jpar(k1,q1,k2,q2)
       End If

 104        Continue
            End Do
          End Do
        End Do
      End Do

      Return
      End Subroutine JKQPar_Naoya

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Per-Olof Widmark                                 *
!***********************************************************************

subroutine Scram(CMO,nSym,nBas,nOrb,ScrFac)
!***********************************************************************
!                                                                      *
! This routine scrambles start orbitals in order to introduce symmetry *
! breaking where it is desirable.                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University, Sweden                                     *
! Written: September 2006                                              *
!                                                                      *
!***********************************************************************

use Constants, only: One, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: CMO(*)
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym)
real(kind=wp), intent(in) :: ScrFac
integer(kind=iwp) :: iBas, indx, iOff, iOrb, iSeed = 13, iSym, jndx, jOrb
real(kind=wp) :: p, q, u, v
real(kind=wp), external :: Random_Molcas

!----------------------------------------------------------------------*
! Do small rotations                                                   *
!----------------------------------------------------------------------*
iOff = 0
do iSym=1,nSym
  !write(u6,*) 'Scrambling irrep',iSym
  do iOrb=1,nOrb(iSym)-1
    jOrb = iOrb+1
    q = ScrFac*(Two*Random_Molcas(iSeed)-One)
    p = sqrt(One-q*q)
    !write(u6,*) 'q=',q
    do iBas=1,nBas(iSym)
      indx = iOff+(iOrb-1)*nBas(iSym)+iBas
      jndx = iOff+(jOrb-1)*nBas(iSym)+iBas
      u = p*CMO(indx)-q*CMO(jndx)
      v = q*CMO(indx)+p*CMO(jndx)
      CMO(indx) = u
      CMO(jndx) = v
    end do
  end do
  iOff = iOff+nBas(iSym)*nOrb(iSym)
end do
!----------------------------------------------------------------------*
! Done                                                                 *
!----------------------------------------------------------------------*
return

end subroutine Scram

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine gen1overR3(Lhigh,oneoverR3)
      implicit real*8 (a-h,o-z)
cbs   generates the radial integrals  for the one electron spin orbit integrals
cbs   taken the 1/r**3 formula from the documentation and included additional
cbs   factors for normalization
#include "para.fh"
#include "param.fh"
#include "dofuc.fh"
#include "real.fh"
      dimension oneoverR3((MxprimL*MxprimL+MxprimL)/2,Lmax)
      do L=1,Lhigh
      icount=0
      do iprim2=1,nprimit(L)
      alpha2=exponents(iprim2,L)
      do iprim1=1,iprim2
      alpha1=exponents(iprim1,L)
      icount=icount+1
      oneoverR3(icount,L)=sqrt(2d0/pi)*
     *(df(L+L-2)*DBLE(2**(L+3))*
     *(alpha1*alpha2)**(0.25d0*
     *DBLE(L+L+3)))/((alpha1+alpha2)**L*df(L+L+1))
      enddo
      enddo
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine Cnt1El2(Kernel,KrnlMm,Label,iDCnt,iDCar,loper,rHrmt,DiffOp,Lab_Dsk,iadd,isym,kcar,nordop)
!***********************************************************************
!                                                                      *
! Object: to compute the one-electron integrals. The method employed at*
!         this point is not necessarily the fastest. However, the total*
!         time for the computation of integrals will depend on the time*
!         spent in computing the two-electron integrals.               *
!         The memory at this point is assumed to be large enough to do *
!         the computation in core.                                     *
!         The data is structured with respect to four indices, two (my *
!         ny or i j) refer to primitives or basis functions and two (a *
!         b) refer to the components of the cartesian or spherical     *
!         harmonic gaussians.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!             Rewritten for gradients needed in hessian calculations   *
!             and general operator treatment                           *
!             May '95 By:                                              *
!             Anders Bernhardsson , Dept. of Theoretical Chemistry,    *
!             University  of Lund, SWEDEN.                             *
!***********************************************************************

use McKinley_global, only: nFck, sIrrep
use mck_interface, only: mck_mem, oneel_mck_kernel
use Index_Functions, only: nTri_Elem, nTri_Elem1
use Real_Spherical, only: ipSph, RSph
use iSD_data, only: iSD
use Basis_Info, only: dbsc, MolWgh, nBas, Shells
use Center_Info, only: dc
use Symmetry_Info, only: iOper, nIrrep
use Sizes_of_Seward, only: S
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
procedure(oneel_mck_kernel) :: Kernel
procedure(mck_mem) :: KrnlMm
character(len=8), intent(in) :: Label, Lab_Dsk
integer(kind=iwp), intent(in) :: iDCnt, iDCar, iadd, isym, kcar, nordop
integer(kind=iwp), intent(out) :: loper
real(kind=wp), intent(in) :: rHrmt
logical(kind=iwp), intent(in) :: DiffOp
#include "Molcas.fh"
#include "disp.fh"
integer(kind=iwp) :: iAng, iAO, iBas, iCar, iCmp, iCnt, iCnttp, iComp, iDCRR(0:7), iDCRT(0:7), iI, iIC, iIrrep, IndGrd(0:7), iopt, &
                     ip(8), iPrim, irc, iS, iShell, iShll, iSmLbl, iSOBlk, iStabM(0:7), iStabO(0:7), iStart, iuv, jAng, jAO, jBas, &
                     jCmp, jCnt, jCnttp, jdisp, jIrrep, jPrim, jS, jShell, jShll, kk, kOper, lDCRR, LenInt, LenInt_Tot, lFinal, &
                     LmbdR, LmbdT, maxi, mdci, mdcj, MemKer, MemKrn, mSO, nDCRR, NDCRT, nDens, ndenssq, nDisp, nIC, nnIrrep, &
                     nOp(2), nOrder, nrOp, nScr1, nSkal, nSO, nStabM, nStabO
real(kind=wp) :: A(3), B(3), CCoor(3), Fact, RB(3)
logical(kind=iwp) :: DiffCnt, IfGrd(3,2), Trans(2)
character(len=8) :: LabDsk
real(kind=wp), allocatable :: Fnl(:), Integrals(:), Kappa(:), Kern(:), PCoor(:,:), Scr(:), ScrSph(:), SO(:), Zeta(:), ZI(:)
integer(kind=iwp), external :: MemSO1, NrOpr
logical(kind=iwp), external :: EQ, TF

! Compute the number of blocks from each component of the operator
! and the irreps it will span.

LabDsk = Lab_Dsk
CCoor(:) = Zero
IndGrd(0:nIrrep-1) = 0
loper = 0
nnIrrep = nIrrep
if (sIrrep) nnIrrep = 1
do iIrrep=0,nnIrrep-1
  jIrrep = nropr(ieor(ioper(iIrrep),ioper(isym)))
  nDisp = IndDsp(iDcnt,iIrrep)
  do iCar=1,3
    iComp = 2**(iCar-1)
    if (TF(iDCnt,iIrrep,iComp)) then
      ndisp = ndisp+1
      if (iDCar == icar) then
        loper = loper+2**jIrrep
        IndGrd(jIrrep) = nDisp
      end if
    end if
  end do
end do
nIC = 0
if (loper == 0) return

ip(1:nIrrep) = 0

iStart = 1
do iIrrep=0,nIrrep-1
  if (btest(loper,iIrrep)) then
    LenInt = nFck(iIrrep)
    nIc = nIC+1
    ip(NIC) = iStart
    iStart = iStart+LenInt
  end if
end do
LenInt_Tot = iStart-1
call mma_allocate(Integrals,LenInt_Tot,Label='Integrals')
Integrals(:) = Zero

call SOS(iStabO,nStabO,1)

! Auxiliary memory allocation.

!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Basis_Mode('Valence')
call Nr_Shells(nSkal)
call Setup_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *

! Double loop over shells.

do iS=1,nSkal
  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  mdci = iSD(10,iS)
  iShell = iSD(11,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

  do jS=1,iS
    jShll = iSD(0,jS)
    jAng = iSD(1,jS)
    jCmp = iSD(2,jS)
    jBas = iSD(3,jS)
    jPrim = iSD(5,jS)
    jAO = iSD(7,jS)
    mdcj = iSD(10,jS)
    jShell = iSD(11,jS)
    jCnttp = iSD(13,jS)
    jCnt = iSD(14,jS)
    B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

    ! Call kernel routine to get memory requirement. Observe, however
    ! that kernels which will use the HRR will allocate that
    ! memory internally.

    maxi = S%maxPrm(iAng)*S%maxprm(jang)
    call mma_allocate(Zeta,maxi,Label='Zeta')
    call mma_allocate(ZI,maxi,Label='ZI')
    call mma_allocate(Kappa,maxi,Label='Kappa')
    call mma_allocate(PCoor,maxi,3,Label='PCoor')
    call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)

    ! Memory requirements for contraction and Symmetry
    ! adaption of derivatives.

    lFinal = S%MaxPrm(iAng)*S%MaxPrm(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)*nIrrep

    MemKrn = max(MemKer*Maxi,lFinal)
    call mma_allocate(Kern,MemKrn,Label='Kern')

    ! Save some memory and use Scrt area for transformation

    ! Allocate memory for the final integrals all in the primitive basis.

    call mma_allocate(Fnl,lFinal,Label='Fnl')

    ! Scratch area for the transformation to spherical gaussians

    nScr1 = S%MaxBas(iAng)*S%MaxBas(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)*nIC
    call mma_allocate(ScrSph,nScr1,Label='ScfSph')

    ! At this point we can compute Zeta.
    ! This is now computed in the ij or ji order.

    call ZXia(Zeta,ZI,iPrim,jPrim,Shells(iShll)%Exp,Shells(jShll)%Exp)

    DiffCnt = (mdci == iDCnt) .or. (mdcj == iDCnt)
    if (DiffCnt .or. DiffOp) then
      IfGrd(:,:) = .false.
      trans(:) = .false.
      if (mdci == iDCnt) then
        IfGrd(idCar,1) = .true.
      end if
      if (mdcj == iDCnt) then
        IfGrd(idCar,2) = .true.
      end if

      if (IfGrd(iDCar,1) .and. IfGrd(iDCar,2) .and. (.not. DiffOp)) then
        IfGrd(iDCar,2) = .false.
        Trans(2) = .true.
      end if
      if (Label == 'CONNECTI') Trans(2) = .false.

      ! Allocate memory for SO integrals that will be generated by
      ! this batch of AO integrals.

      nSO = 0
      do iIrrep=0,nIrrep-1
        if (btest(loper,iIrrep)) then
          iSmLbl = 2**iIrrep
          nSO = nSO+MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
        end if
      end do
      !if (iPrint >= 29) write(u6,*) ' nSO=',nSO
      if (nSO /= 0) then
        call mma_allocate(SO,iBas*jBas*nSO,Label='SO')
        SO(:) = Zero

        ! Find the DCR for A and B

        call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)

        ! Find the stabilizer for A and B

        call Inter(dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iStabM,nStabM)

        call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

        ! Compute normalization factor

        iuv = dc(mdci)%nStab*dc(mdcj)%nStab
        Fact = real(iuv*nStabO,kind=wp)/real(nIrrep**2*LmbdT,kind=wp)
        if (MolWgh == 1) then
          Fact = Fact*real(nIrrep,kind=wp)**2/real(iuv,kind=wp)
        else if (MolWgh == 2) then
          Fact = sqrt(real(iuv,kind=wp))*real(nStabO,kind=wp)/real(nIrrep*LmbdT,kind=wp)
        end if

        ! Loops over symmetry operations acting on the basis.

        nOp(1) = NrOpr(0)
        if (jBas < -999999) write(u6,*) 'gcc overoptimization',nDCRR
        do lDCRR=0,nDCRR-1
          call OA(iDCRR(lDCRR),B,RB)
          nOp(2) = NrOpr(iDCRR(lDCRR))
          if ((Label /= 'CONNECTI') .and. EQ(A,RB) .and. (.not. DiffOp)) cycle

          ! Compute kappa and P.

          call Setup1(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,A,RB,Kappa,PCoor,ZI)

          ! Compute AO integrals.
          ! for easy implementation of NA integrals.

          call Kernel(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,Zeta,Kappa,PCoor,Fnl,iPrim*jPrim,iAng,jAng,A,RB,nOrder,Kern, &
                      MemKrn,Ccoor,nOrdOp,IfGrd,IndGrd,nop,dc(mdci)%nStab,dc(mdcj)%nStab,nic,idcar,trans,kcar,isym)

          ! Transform from primitive to contracted basis functions.
          ! Order of transformation is fixed. It has been shown through
          ! testing that the index order ij,ab will give a performance
          ! that is up to 20% faster than the ab,ij index order.

          ! Transform i,jabx to jabx,I

          kk = nTri_Elem1(iAng)*nTri_Elem1(jAng)*nIC
          call DGEMM_('T','N',jPrim*kk,iBas,iPrim,One,Fnl,iPrim,Shells(iShll)%pCff,iPrim,Zero,Kern,jPrim*kk)

          ! Transform j,abxI to abxI,J

          call DGEMM_('T','N',kk*iBas,jBas,jPrim,One,Kern,jPrim,Shells(jShll)%pCff,jPrim,Zero,Fnl,kk*iBas)

          ! Transform to spherical gaussians if needed.

          kk = nTri_Elem1(iAng)*nTri_Elem1(jAng)

          if (Shells(iShll)%Transf .or. Shells(jShll)%Transf) then

            ! Result comes back as IJAB or IJAb

            call CarSph(Fnl,kk,iBas*jBas*nIC,Kern,nScr1,RSph(ipSph(iAng)),iAng,Shells(iShll)%Transf, &
                        Shells(iShll)%Prjct,RSph(ipSph(jAng)),jAng,Shells(jShll)%Transf,Shells(jShll)%Prjct,ScrSph,iCmp*jCmp)

            call DGeTmO(ScrSph,nIC,nIC,iBas*jBas*iCmp*jCmp,Kern,iBas*jBas*iCmp*jCmp)

          else

            ! Transpose abx,IJ back to IJ,abx

            call DGeTmO(Fnl,kk*nIC,kk*nIC,iBas*jBas,Kern,iBas*jBas)
          end if

          ! At this point accumulate the batch of integrals onto the
          ! final symmetry adapted integrals.

          !if (iPrint >= 99) then
          !  call RecPrt (' Accumulated SO integrals, so far...',' ',SO,iBas*jBas,nSO)
          !end if

          ! Symmetry adapt component by component

          iSOBlk = 1
          iIC = 1
          do iIrrep=0,nIrrep-1
            iSmLbl = iand(lOper,2**iIrrep)
            mSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            if (mSO == 0) then
              do jIrrep=0,nIrrep-1
                if (btest(iSmLbl,jIrrep)) iIC = iIC+1
              end do
            else
              call SymAd1(iSmLbl,iAng,jAng,iCmp,jCmp,iShell,jShell,iShll,jShll,iAO,jAO,Kern,iBas,jBas,nIC,iIC,SO(iSOBlk),mSO,nOp)
              iSOBlk = iSOBlk+mSO*iBas*jBas
            end if
          end do

        end do

        ! Multiply with factors due to projection operators

        if (Fact /= One) SO(:) = Fact*SO

        ! Scatter the SO's on to the non-zero blocks of the lower triangle.

        iSOBlk = 1
        iIC = 0
        do iIrrep=0,nIrrep-1
          if (btest(lOper,iIrrep)) then
            iSmlbl = 2**iIrrep
            iiC = iiC+1
            mSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            if ((nfck(iirrep) /= 0) .and. (mSO /= 0)) call SOSctt(SO(iSOBlk),iBas,jBas,mSO,Integrals(ip(iIC)),nFck(iIrrep),iSmLbl, &
                                                                  iCmp,jCmp,iShell,jShell,iAO,jAO,nIC,Label,2**iIrrep,rHrmt)
            iSOBlk = iSOBlk+mSO*iBas*jBas
          end if
        end do

        call mma_deallocate(SO)
      end if
    end if
    call mma_deallocate(pCoor)
    call mma_deallocate(Kappa)
    call mma_deallocate(ZI)
    call mma_deallocate(Zeta)
    call mma_deallocate(ScrSph)
    call mma_deallocate(Fnl)
    call mma_deallocate(Kern)

  end do
end do

call Free_iSD()

! Compute properties or write integrals to disc and deallocate core.

nDens = 0
ndenssq = 0
do iI=0,nIrrep-1
  ndenssq = ndenssq+nbas(ii)**2
  nDens = nDens+nTri_Elem(nBas(iI))
end do
nrOp = 0

call mma_allocate(Scr,ndenssq,Label='Scr')
do iIrrep=0,nIrrep-1
  if (btest(loper,iIrrep)) then
    nrOp = nrOp+1
    jdisp = indgrd(iirrep)
    kOper = 2**iIrrep
    !write(u6,*) koper,isym,jdisp,iirrep
    if (iadd /= 0) then
      irc = -1
      iopt = 0
      call drdmck(irc,iOpt,LabDsk,jdisp,Scr,koper)
      if (irc /= 0) call SysAbendMsg('cnt1el2','error during read in rdmck',' ')
      Integrals(ip(nrop):ip(nrop)+nfck(iIrrep)-1) = Integrals(ip(nrop):ip(nrop)+nfck(iIrrep)-1)+Scr(1:nfck(iIrrep))
    end if
    irc = -1
    iopt = 0
    !write(u6,*) LabDsk,jdisp,koper
    call dwrmck(irc,iOpt,LabDsk,jdisp,Integrals(ip(nrop)),koper)
    if (irc /= 0) call SysAbendMsg('cnt1el2','error during write in dwrmck',' ')
  end if
end do

call mma_deallocate(Scr)
call mma_deallocate(Integrals)

return

end subroutine Cnt1El2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_RstD_GetInd3(iSP2F,l_iSP2F)

use Cholesky, only: LuRed, nnBstRT, nnShl, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: l_iSP2F
integer(kind=iwp), intent(out) :: iSP2F(l_iSP2F)
integer(kind=iwp) :: iAdr, iOpt

iOpt = 2
iAdr = nSym*nnShl+2*nnBstRT(1)
call iDAFile(LuRed,iOpt,iSP2F,l_iSP2F,iAdr)

end subroutine Cho_RstD_GetInd3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1998, Roland Lindh                      *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drv2El_Atomic_NoSym(Integral_WrOut,ThrAO,iCnttp,jCnttp,
     &                               TInt,nTInt,
     &                               In_Core,ADiag,LuA,ijS_req,
     &                               Keep_Shell)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals.                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August '91                         *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. '93          *
*             Modified driver. Jan. '98                                *
************************************************************************
      use Basis_Info, only: nBas
      use iSD_data
      use Wrj12
      use k2_arrays, only: Sew_Scr
      use Basis_Info, only: dbsc
      use Temporary_Parameters, only: force_out_of_core
      use Integral_Parameters, only: iWROpt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Integral_WrOut
#include "nsd.fh"
#include "setup.fh"
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "WrkSpc.fh"
#define _no_nShs_
#include "iTOffs.fh"
      Real*8, Allocatable :: TInt(:), ADiag(:)
      Integer, Allocatable :: IJInd(:,:)
      Logical Verbose, Indexation, FreeK2, DoGrad, DoFock,
     &        In_Core, Out_of_Core, Only_DB, Do_RI_Basis, Do_ERIs
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 9
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*     Temporary modifications to facilitate atomic calculations
*
      nIrrep_Save=nIrrep
      nIrrep=1
      iWROpt_Save=iWROpt
      iWROpt=1
*
      Do_RI_Basis = dbsc(iCnttp)%Aux
*
      Call Set_Basis_Mode_Atomic(iCnttp,jCnttp)
      Call Setup_iSD()
*
      If (Do_RI_Basis .and. ijS_req.eq.0) Then
         Call WarningMessage(2,
     &               'Do_RI_Basis .and. ijS_req.eq.0')
         Call Abend()
      End If
C     Write (6,*) 'Do_RI_Basis=',Do_RI_Basis
*                                                                      *
************************************************************************
*                                                                      *
*     Initialize for 2-electron integral evaluation. Do not generate
*     tables for indexation.
*
      DoGrad=.False.
      DoFock=.False.
      Indexation = .False.
      Call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
*                                                                      *
************************************************************************
*                                                                      *
*     Create list of pairs
*
      Call mma_allocate(IJInd,2,nSkal*(nSkal+1)/2,Label='IJInd')
      nij=0
      nBfn=0
      If (Do_RI_Basis) Then
         iS=nSkal   ! Dummy shell
         Do jS = 1, nSkal-1
            nij = nij +1
            IJInd(1,nij)=iS
            IJInd(2,nij)=jS
            nBfn=nBfn+iSD(2,jS)*iSD(3,jS)
         End Do
      Else
         Do iS = 1, nSkal
            Do jS = 1, iS
               nij = nij +1
               IJInd(1,nij)=iS
               IJInd(2,nij)=jS
            End Do
         End Do
      End If
C     Write (6,*) 'nij=',nij
*                                                                      *
************************************************************************
*                                                                      *
*     Preallocate some core for Seward!
*
      Call mma_MaxDBLE(MemSew)
      MemLow=Min(MemSew/2,1024*128)
      MemSew=Max(MemSew/10,MemLow)
      Call mma_allocate(Sew_Scr,MemSew,Label='Sew_Scr')
*                                                                      *
************************************************************************
*                                                                      *
*     Determine if only diagonal block should be computed.
*     This option is forced when the auxiliary basis set is transformed
*     to the Cholesky basis!
*
      Only_DB=ijS_req.ne.0 .or. Do_RI_Basis
*                                                                      *
************************************************************************
*                                                                      *
*     Choose between in-core and out-of-core options
*
      Call mma_MaxDBLE(MemT)
      MemT=MemT/2
*
      If (Only_DB) Then
*
*        Only diagonal block
*
         nTInt=0
         If (Do_RI_Basis) Then
            Do iS = 1, nSkal-1 ! Skip the dummy shell
               nBfn_i=iSD(2,iS)*iSD(3,iS)
               If (iS.eq.ijS_req) nTInt=nBfn_i
            End Do
            If (nTInt.eq.0) Then
               Call WarningMessage(2,
     &                     'Drv2el_atomic_nosym: nTInt.eq.0')
               Call Abend()
            End If
*
            Call mma_Allocate(SO2Ind,nBfn,Label='SO2Ind')
            Do iBfn = 1, nBfn
               SO2Ind(iBfn)=iBfn
            End Do
            nSOs=nBfn
         Else
            Do iS = 1, nSkal
               nBfn_i=iSD(2,iS)*iSD(3,iS)
               Do jS = 1, iS-1
                  ijS = iS*(iS-1)/2 + jS
                  nBfn_j=iSD(2,jS)*iSD(3,jS)
                  If (ijS.eq.ijS_req) nTInt=nBfn_i*nBfn_j
               End Do
               ijS = iS*(iS+1)/2
               If (ijS.eq.ijS_req) nTInt=nBfn_i*(nBfn_i+1)/2
            End Do
         End If
         mTInt=nTInt
         nTInt2=mTInt*nTInt
         If (nTInt2.gt.MemT) Then
            Call WarningMessage(2,'Not enough memory!')
            Call Abend()
         End If
*
         iTOffs(1)=0
*
         In_Core=.True.       ! no out-of-core option needed.
         Out_of_core=.False.
         mTInt2=nTInt2
*
      Else
*
*        All blocks
*
         nTInt=nBas(0)*(nBas(0)+1)/2
         mTInt=nTInt
         nTInt2=nTInt**2
         In_Core=nTInt2.le.MemT
         If (Force_out_of_Core) In_Core=.False.
         Out_of_Core=.NOT.In_Core
*
*        Compute the size of the array, TInt, to write the integrals to.
*
         If (Out_of_Core) Then
*
*           Find the larges block for a fixed shell pair.
*
            mTInt=0
            Do iS = 1, nSkal
               nBfn_i=iSD(2,iS)*iSD(3,iS)
               Do jS = 1, iS-1
                  nBfn_j=iSD(2,jS)*iSD(3,jS)
                  mTInt=Max(mTInt,nBfn_i*nBfn_j)
               End Do
               mTInt=Max(mTInt,nBfn_i*(nBfn_i+1)/2)
            End Do
            nTInt2=mTInt*nTInt
*
*           Open file for the A-vectors
*
            iAddr=0
            iSeed=63
            LuA=IsFreeUnit(iSeed)
            Call DaName_MF_WA(LuA,'AVEC0')
*
            Call mma_allocate(ADiag,nTInt,label='ADiag')
            Call FZero(ADiag,nTInt)
*
         Else
*
*           In-core option
*
            mTInt2=nTInt2
            iTOffs(1)=0  ! Offset permanently set to zero!
*
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
      iTOffs(2)=nTInt  ! # of rows in TInt
      iTOffs(3)=mTInt  ! # of colums in TInt
      Call mma_allocate(TInt,nTInt2,label='TInt')
      If (In_Core) Call FZero(TInt,nTInt2)
*                                                                      *
************************************************************************
*                                                                      *
*     Now do a quadruple loop over shells
*
      iTOff=0
      iTOffs(4)=0    ! Offset to the ij set
      Do ijS = 1, nij
         iS = IJInd(1,ijS)
         jS = IJInd(2,ijS)
*
         nBfn_i=iSD(2,iS)*iSD(3,iS)
         nBfn_j=iSD(2,jS)*iSD(3,jS)
         ijAng =iSD(1,iS)+iSD(1,jS)
*
         If (Out_of_Core) Then
            If (iS.eq.jS) Then
               mTInt=nBfn_i*(nBfn_i+1)/2
            Else
               mTInt=nBfn_i*nBfn_j
            End If
            mTInt2=mTInt*nTInt
            Call FZero(TInt,mTInt2)
            iTOffs(1)=iTOff
            iTOffs(3)=mTInt
         End If
*
         iTOffs(5)=0    ! Offset to the kl set
         Do klS = 1, ijS
            kS = IJInd(1,klS)
            lS = IJInd(2,klS)
*
            nBfn_k=iSD(2,kS)*iSD(3,kS)
            nBfn_l=iSD(2,lS)*iSD(3,lS)
            klAng =iSD(1,kS)+iSD(1,lS)
*
*           For Only_DB compute the shell quadruplet (ijS_req|ijS_req)
*
            Do_ERIs = .NOT.Only_DB .or.
     &                (ijS.eq.ijS_req.and.klS.eq.ijS_req)
*
*           If high angular combination of the product basis is skipped
*           do not compute the contributions.
*
            Do_ERIs = Do_ERIs .and. ijAng.le.Keep_Shell .and.
     &                              klAng.le.Keep_Shell
*
            If (Do_ERIs) Then
               Call Eval_IJKL(iS,jS,kS,lS,TInt,mTInt2,
     &                       Integral_WrOut)
            End If
*
            If (.NOT.Only_DB) Then
               If (kS.eq.lS) Then
                  iTOffs(5)=iTOffs(5)+nBfn_k*(nBfn_k+1)/2
               Else
                  iTOffs(5)=iTOffs(5)+nBfn_k*nBfn_l
               End If
            End If
*
         End Do
*
*        For out-of-core version write the integrals to disk!
*        Pick up the diagonal elements.
*
         If (Out_of_Core) Then
            Call dDaFile(LuA,1,TInt,mTInt2,iAddr)
            call dcopy_(mTInt,TInt(1+iTOff),nTInt+1,
     &                  ADiag(1+iTOff),1)
            iTOff=iTOff+mTInt
         End If
*
         If (.NOT.Only_DB) Then
            If (iS.eq.jS) Then
               iTOffs(4)=iTOffs(4)+nBfn_i*(nBfn_i+1)/2
            Else
               iTOffs(4)=iTOffs(4)+nBfn_i*nBfn_j
            End If
         End If
*
      End Do      !    ijS
*
      If (Do_RI_Basis) Call mma_deallocate(SO2Ind)
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*
      If (Out_of_Core) Call mma_deallocate(TInt)
      Call mma_deallocate(IJInd)
*                                                                      *
************************************************************************
*                                                                      *
*     Terminate integral environment.
*
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*                                                                      *
************************************************************************
*                                                                      *
*     Square TInt from upper triangular to full.
*
      If (In_Core.and..Not.Do_RI_Basis) Then
*
         Do iTInt = 1, nTInt
            Do jTInt = 1, iTInt-1
               ij = (jTInt-1)*nTInt + iTInt
               ji = (iTInt-1)*nTInt + jTInt
               TInt(ij)=TInt(ji)
            End Do
         End Do
C        Call RecPrt('Drv2El_atomic: TInt',' ',
C    &               TInt,nTInt,nTInt)
*
      Else If (.Not.Do_RI_Basis) Then
*
         nij=nBas(0)*(nBas(0)+1)/2
         Call mma_MaxDBLE(MaxMem)
         Call Square_A(LuA,nij,MaxMem,Force_Out_of_Core)
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_iSD()
      nIrrep=nIrrep_Save
      iWROpt=iWROpt_Save
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine store_reschar (termleng,term,hit,scrleng,
     *                          reslengl,reslengr,rescharl,rescharr)
c
c***************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 12.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer termleng,hit,scrleng,reslengl,reslengr
      character*(maxlength) term,rescharl,rescharr
      integer k
      do 10 k=1,maxlength
        rescharl(k:k)=' '
        rescharr(k:k)=' '
  10  continue
      reslengl=hit-1
      reslengr=termleng-(reslengl+scrleng)
      if (reslengl.ne.0) rescharl(1:reslengl)=term(1:reslengl)
      if (reslengr.ne.0) rescharr(1:reslengr)=term(hit+scrleng:termleng)
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c
       subroutine sumovera (wrk,wrksize,
     & lunt2o1,lunt2o2,lunt2o3,
     & lunw3aaaa,lunw3baab,lunw3bbaa,lunw3bbbb,lunw3abba,lunw3aabb)
c
c     This routine do:
c     I) Prepair phase:
c
c     II) sum over A - alfa
c     FI3, WIII1, WIII2, T15, T16, T27, T2Ex
c
c     FI3
cF13.1FI(a,e)aa <- -sum(m,f-aa) [ <ma||ef>aaaa . T1o(f,m)aa ] *
cF13.2FI(a,e)aa <- -sum(m,f-bb) [ <ma||ef>baab . T1o(f,m)bb ] *
cF13.3FI(a,e)bb <-  sum(m,f-bb) [ <ma||fe>bbbb . T1o(f,m)bb ] +
cf13.4FI(a,e)bb <-  sum(m,f-aa) [ <ma||fe>abab . T1o(f,m)aa ] +
c
c     WIII1
cW31.1WIII(m,e,b,j)aaaa <= <mb||ej>aaaa *
cW31.2WIII(m,e,b,j)bbbb <= <mb||ej>bbbb +
cW31.3WIII(m,e,b,j)aabb <= <mb||ej>abab +
cW31.4WIII(m,e,b,j)abba <= <mb||ej>abba +
cW31.5WIII(m,e,b,j)baab <= <mb||ej>baab *
cW31.6WIII(m,e,b,j)bbaa <= <mb||ej>baba *
c
c     WIII2
cW32.1WIII(m,e,b,j)aaaa <- + sum(f-a) [  <mb||ef>aaaa . T1o(f,j)aa ] *
cW32.2WIII(m,e,b,j)bbbb <- _ sum(f-b) [  <mb||ef>bbbb . T1o(f,j)bb ] +
cW32.3WIII(m,e,b,j)aabb <- + sum(f-b) [  <mb||ef>abab . T1o(f,j)bb ] +
cW32.4WIII(m,e,b,j)abba <- - sum(f-a) [  <mb||fe>abab . T1o(f,j)aa ] +
cW32.5WIII(m,e,b,j)baab <-  sum(f-b) [  <mb||ef>baab . T1o(f,j)bb ] *
cW32.6WIII(m,e,b,j)bbaa <- - sum(f-a) [  <mb||fe>baab . T1o(f,j)aa ] *
c
c     T15
cT15.1T1n(a,i)aa <- sum(n,f-aa) [ <na||fi>aaaa . T1o(f,n)aa ] *
cT15.2T1n(a,i)aa <- sum(n,f-bb) [ <na||fi>baba . T1o(f,n)bb ] *
cT15.3T1n(a,i)bb <- sum(n,f-bb) [ <na||fi>bbbb . T1o(f,n)bb ] +
cT15.4T1n(a,i)bb <- sum(n,f-aa) [ <na||fi>abab . T1o(f,n)aa ] +
c
c     T16
cT16.1T1n(a,i)aa <- - sum(m,e>f-aaa) [ T2o(ef,i,m)aaaa  . <ma||ef>aaaa ] *
cT16.2T1n(a,i)aa <- - sum(m,e,f-bab) [ T2o(e,f,i,m)abab . <ma||ef>baab ] *
cT16.3T1n(a,i)bb <- - sum(m,e>f-bbb) [ T2o(ef,i,m)bbbb  . <ma||ef>bbbb ] +
cT16.4T1n(a,i)bb <- + sum(m,e,f-aab) [ T2o(e,f,m,i)abab . <ma||ef>abab ] +
c
c     T2Ex
cT2E.12  R(a,m,ij)aaaa   <= - sum(e>f-aa) [ <ma||ef>aaaa . Tau(ef,ij)aaaa ] *
cT2E.1T2n(ab,ij)aaaa   <- - sum(m-a)    [ T1o(b,m)aa   .  R(a,m,ij)aaaa ] *
cT2E.2T2n(ab,ij)aaaa         <-   sum(m-a)    [ T1o(a,m)aa   .  R(b,m,ij)aaaa ] *
cT2E.34         R(a,m,ij)bbbb   <= - sum(e>f-bb) [ <ma||ef>bbbb . Tau(ef,ij)bbbb ] +
cT2E.3T2n(ab,ij)bbbb   <- - sum(m-b)    [ T1o(b,m)bb   .  R(a,m,ij)bbbb ] +
cT2E.4T2n(ab,ij)bbbb         <-   sum(m-b)    [ T1o(a,m)bb   .  R(b,m,ij)bbbb ] +
cT2E.5R1(a,m,i,j)abab <= - sum(e,f-ab) [ <ma||ef>baab . Tau(e,f,i,j)abab ] *
cT2E.5T2n(a,b,i,j)abab <- - sum(m-b)    [ T1o(m,b)bb . R1(a,m,i,j)baab ] *
cT2E.6R2(a,m,i,j)baab <= - sum(e,f-ab) [ <ma||ef>abab . Tau(e,f,i,j)abab ] +
cT2E.6T2n(a,b,i,j)abab <-   sum(m-a)    [ T1o(m,a)aa . R2(a,m,i,j)abab ] +
c
c     T27
cT27.1G(b,m,i,j)aaaa  <= - sum(e-a)  [ <mb||ej>aaaa . T1o(e,i)aa ]  *
cT27.1Q(b,m,ij)aaaa   <= G(b,m,i,j)aaaa - G(b,m,j,i)aaaa            *
cT27.1R(c,d,ij)aaaa   <= sum(m-a)    [ T1o(c,m)aa   . Q(d,m,ij)aa ] *
cT27.1T2n(ab,ij)aaaa   <- R(a,b,ij)aaaa - R(b,a,ij)aaaa              *
cT27.2G(b,m,i,j)bbbb  <= - sum(e-b)  [ <mb||ej>bbbb . T1o(e,i)bb ]  +
cT27.2Q(b,m,ij)bbbb   <= G(b,m,i,j)bbbb - G(b,m,j,i)bbbb            +
cT27.2R(c,d,ij)bbbb   <= sum(m-b)    [ T1o(c,m)bb   . Q(d,m,ij)bb ] +
cT27.2T2n(ab,ij)bbbb   <- R(a,b,ij)bbbb - R(b,a,ij)bbbb              +
cT27.3G1(b,m,i,j)abab <= + sum(e-a)  [ <mb||ej>baab . T1o(e,i)aa ]  *
cT27.3<- - sum(e-b)  [ <mb||ei>baba . T1o(e,j)bb ]  *
cT27.3T2n(a,b,i,j)abab <- sum(m-b)    [ T1o(b,m)bb   . G1(a,m,i,j)abab ] *
cT27.4G2(b,m,i,j)baab <= - sum(e-a)  [ <mb||ej>abab . T1o(e,i)aa ] +
cT27.4<- + sum(e-b)  [ <mb||ei>abba . T1o(e,j)bb ] +
cT27.4T2n(a,b,i,j)abab <- sum(m-a)    [ T1o(a,m)aa   . G2(b,m,i,j)baab ] +
c
c
c     General status
c
c     Temporary files lunt2o1,lunt2o2,lunt2o3
c     with T2o4, T2o4b and T2o2b must be opened
c
c     Integrals are strored as follows:
c
c     1) <ma||ef> for a - alfa
c     lun = n1aalfa
c     integrals : <ma||ef>aaaa, <ma||ef>baab
c
c     do syma=1,nsym
c     ! one record with mapd,mapi of <ma||ef>aaaa - always
c     ! one record with mapd,mapi of <ma||ef>baab - always
c     do a=1,nva(syma)
c     ! one record with <ma||ef>aaaa if any
c     ! one record with <ma||ef>baab if any
c     end do
c     end do
c
c
c     2) <ma||ef> for a - beta
c     lun = n1abeta
c     integrals : <ma||ef>bbbb, <ma||ef>abab
c
c     do syma=1,nsym
c     ! one record with mapd,mapi of <ma||ef>bbbb - always
c     ! one record with mapd,mapi of <ma||ef>abab - always
c     do a=1,nvb(syma)
c     ! one record with <ma||ef>bbbb if any
c     ! one record with <ma||ef>abab if any
c     end do
c     end do
c
c
c     3) <ma||ej> for a - alfa
c     lun = n2aalfa
c     integrals : <ma||ej>aaaa, <ma||ej>baab, <ma||ej>baba
c
c     do syma=1,nsym
c     ! one record with mapd,mapi of <ma||ej>aaaa - always
c     ! one record with mapd,mapi of <ma||ej>baab - always
c     ! one record with mapd,mapi of <ma||ej>baba - always
c     do a=1,nva(syma)
c     ! one record with <ma||ej>aaaa if any
c     ! one record with <ma||ej>baab if any
c     ! one record with <ma||ej>baba if any
c     end do
c     end do
c
c
c     4) <ma||ej> for a - beta
c     lun = n2abeta
c     integrals : <ma||ej>bbbb, <ma||ej>abab, <ma||ej>abba
c
c     do syma=1,nsym
c     ! one record with mapd,mapi of <ma||ej>bbbb - always
c     ! one record with mapd,mapi of <ma||ej>abba - always
c     ! one record with mapd,mapi of <ma||ej>abab - always
c     do a=1,nva(syma)
c     ! one record with <ma||ej>bbbb if any
c     ! one record with <ma||ej>abba if any
c     ! one record with <ma||ej>abab if any
c     end do
c     end do
c
c     N.B. use and destroy : all
c     N.B. # of reads      : 4
c
c
c        Paralell status
c
c        Alternatives:
c
c        A) 1 proc - idaaaa,idbbbb,idaabb,idabba,idbaab,idbbaa = 1
c
c        B) 2 proc - idaaaa,idbaab,idbbaa = 1
c                   idbbbb,idaabb,idabba = 2
c
c        C) 4 proc - idaaaa        = 1
c                   idbbaa,idbaab = 2
c                   idbbbb        = 3
c                   idabba,idaabb = 4
c
c        D) 6 proc - idaaaa = 1
c                   idbaab = 2
c                   idbbaa = 3
c                   idbbbb = 4
c                   idaabb = 5
c                   idabba = 6
c
c        Pilot nodes (in the case of multiplicity contribution to Tn
c       is evaluated only on pivot node)
c                      : idbaab for alpha, idaabb for beta
c                 i.e. : A-1; B-1,2; C-2,4; D-2,5
c
c        In case D) contributions F13 are calculated separately. In such
c        a case on idaaaa, and idbbbb nodes contr. F13.1 and F13.3 resp.
c        are set (nod add) directly to corresp. F1. On pilot nodes,
c       cont. F13.2 and F13.4 are standardly added to F1's
c
        implicit none
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "paralell.fh"
#include "wrk.fh"
c
       integer lunt2o1,lunt2o2,lunt2o3
       integer lunw3aaaa,lunw3baab,lunw3bbaa,lunw3bbbb,lunw3abba,
     & lunw3aabb
c
c     help variables
c
       integer n1aalfa,n1abeta,n2aalfa,n2abeta
       integer m1lenght,m2lenght,h1lenght,h2lenght,h3lenght
       integer syma,a
       integer rc,posst
       integer ssm3,ssm4,ssh4
c
c     paralell parameters
       integer yesa,yesb
c
c
cA0   paralell
c
c     I.par.1  - escape, if this node is not reserved for sumoverb_a
c
      if ((myRank.eq.idaaaa).or.
     & (myRank.eq.idbaab).or.(myRank.eq.idbbaa)) then
        yesa=1
      else
        yesa=0
      end if
c
      if ((myRank.eq.idbbbb).or.
     & (myRank.eq.idaabb).or.(myRank.eq.idabba)) then
        yesb=1
      else
        yesb=0
      end if
c
        if ((yesa.eq.0).and.(yesb.eq.0)) then
        return
        end if
c
c     ****************   A - prepair phase part 1 -------------------
c
cpar
      if (yesa.eq.1) then
c
cA.1  read T2o4a from opened lunt2o1 file
c     V1(ef,ij)    <- T2o(ef,ij)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv10,mapdv1,mapiv1,rc)
c
cA.2  V2(ij,ef) <- V1(ef,ij)
       call map (wrk,wrksize,
     & 4,3,4,1,2,
     & mapdv1,mapiv1,1,mapdv2,mapiv2,possv20,posst,rc)
c
cA.3  mktau V1(ef,ij) <- V1(ef,ij)
       call mktau (wrk,wrksize,
     & mapdv1,mapiv1,mapdt11,mapit11,mapdt12,mapit12,1.0d0,
     &             rc)
c
cA.4  expand V3(i,j,ef) <- V2(ij,ef)
       call expand (wrk,wrksize,
     & 4,5,mapdv2,mapiv2,1,possv30,mapdv3,mapiv3,rc)
c
cA.5
        if ((idaaaa.ne.idbaab).and.(myRank.eq.idaaaa)) then
        call set0 (wrk,wrksize,
     &             mapdf11,mapif11)
        end if
cparend
      end if
c
cpar
      if ((yesa.eq.1).or.(yesb.eq.1)) then
c
cA.6  read T2o2b from opened lunt2o3 file
c     V2(e,f,i,j)  <- T2o(e,f,i,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
c
cA.6  V4(i,j,e,f) <- V2(e,f,i,j)
       call map (wrk,wrksize,
     & 4,3,4,1,2,
     & mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,rc)
c
cA.7  mktau V2(e,f,i,j) <- V2(e,f,i,j)
       call mktau (wrk,wrksize,
     & mapdv2,mapiv2,mapdt11,mapit11,mapdt12,mapit12,1.0d0,
     &             rc)
cparend
      end if
c
c
c     now there is:
c     V1(ef,ij)   = Tau(ef,ij)aaaa
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(i,j,ef)  = T2o(ef,ij)aaaa
c     V4(i,j,e,f) = T2o(e,f,i,j)abab
c     free: M1-M4, H1-H4
c
c
c
c     ****************   B - sum over a alpha ---------------------
c
cpar
       if (yesa.eq.1) then
c
cB.1  open n1aalfa,n2aalfa
       n1aalfa=11
       n2aalfa=13
       call filemanager (4,n1aalfa,rc)
       call filemanager (4,n2aalfa,rc)
c
cB.2  open temp files lunw3aaaa, lunw3baab, lunw3bbaa
cpar
       if (myRank.eq.idaaaa) then
       call filemanager (1,lunw3aaaa,rc)
       end if
c
       if (myRank.eq.idbaab) then
       call filemanager (1,lunw3baab,rc)
       end if
c
       if (myRank.eq.idbbaa) then
       call filemanager (1,lunw3bbaa,rc)
       end if
c
c
       do 3000 syma=1,nsym
c
        if (fullprint.ge.3) then
        write (6,*) ' SymA alfa ',syma
        end if
c
c     storing of mediates:
c
c     V1(ef,ij)   = Tau(ef,ij)aaaa
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(i,j,ef)  = T2o(ef,ij)aaaa
c     V4(i,j,e,f) = T2o(e,f,i,j)abab
c     M1(m,ef)  - <ma||ef>aaaa
c     M2(m,e,f) - <ma||ef>baab
c     H1(m,e,j) - <ma||ej>aaaa = W3(m,e,a,j)aaaa
c     H2(m,e,j) - <ma||ej>baab = W3(m,e,a,j)baab
c     H3(m,e,j) - <ma||ej>baba = W3(m,e,a,j)bbaa
c     free: M3,M4,H4
c
cB.3  get mapd and mapi for M1,M2
       call getmap (n1aalfa,possm10,m1lenght,mapdm1,mapim1,rc)
       call getmap (n1aalfa,possm20,m2lenght,mapdm2,mapim2,rc)
c
cB.4  get mapd and mapi for H1 - H3
       call getmap (n2aalfa,possh10,h1lenght,mapdh1,mapih1,rc)
       call getmap (n2aalfa,possh20,h2lenght,mapdh2,mapih2,rc)
       call getmap (n2aalfa,possh30,h3lenght,mapdh3,mapih3,rc)
c
cB.5  write mapd and mapi of W3aaaa(H1), W3baab(H2) and W3bbaa(H3)
cpar
       if (myRank.eq.idaaaa) then
       call wrtmap (lunw3aaaa,mapdh1,mapih1,rc)
       end if
c
       if (myRank.eq.idbaab) then
       call wrtmap (lunw3baab,mapdh2,mapih2,rc)
       end if
c
       if (myRank.eq.idbbaa) then
       call wrtmap (lunw3bbaa,mapdh3,mapih3,rc)
       end if
c
c
cB.6  skip cycle over a if lenght of all files is zero
       if ((m1lenght+m2lenght+h1lenght+h2lenght+h3lenght).eq.0) goto
     & 3000
c
       do 2500 a=1,nva(syma)
        if (fullprint.ge.3) then
        write (6,*) ' A alfa ',a
        end if
c
c
       if (h1lenght.gt.0) then
cW31.1.1    read H1(m,e,j) = <ma||ej>aaaa
cpar
       if (myRank.eq.idaaaa) then
       call rea (n2aalfa,h1lenght,wrk(possh10))
       else
       call reajalovy (n2aalfa,h1lenght,wrk(possh10))
       end if
c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)aaaa
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(i,j,ef)  = T2o(ef,ij)aaaa
c     V4(i,j,e,f) = T2o(e,f,i,j)abab
c     M1(m,ef)  - <ma||ef>aaaa (free, but reserved map's)
c     M2(m,e,f) - <ma||ef>baab (free, but reserved map's)
c     H1(m,e,j) - <ma||ej>aaaa = W3(m,e,a,j)aaaa
c     H2(m,e,j) - <ma||ej>baab = W3(m,e,a,j)baab (free, but reserved map's)
c     H3(m,e,j) - <ma||ej>baba = W3(m,e,a,j)bbaa (free, but reserved map's)
c     free: M3,M4,H4
c
cpar
        if (myRank.eq.idaaaa) then
c
c     ------- cont to T15
cT15.1T1n(a,i)aa <- sum(n,f-aa) [ <na||fi>aaaa . T1o(f,n)aa ]
c
cT15.1.1    H4(i,f,n) <- H1(n,f,i)
       call map (wrk,wrksize,
     & 3,3,2,1,0,
     & mapdh1,mapih1,syma,mapdh4,mapih4,possh40,posst,rc)
c
cT15.1.2    M3(i) <- H4(i,f,n) . T1o(f,n)aa
       call mult (wrk,wrksize,
     & 3,2,1,2,
     & mapdh4,mapih4,syma,mapdt11,mapit11,1,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT15.1.3    T1n(a,i)aa <- 1.0d0 . M3(i)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,1.0d0,
     & mapdm3,syma,mapdt13,mapit13,1,rc)
c
c     ------- cont to T27
cT27.1G(b,m,i,j)aaaa  <= - sum(e-a)  [ <mb||ej>aaaa . T1o(e,i)aa ]
cT27.1Q(b,m,ij)aaaa   <= G(b,m,i,j)aaaa - G(b,m,j,i)aaaa
cT27.1R(c,d,ij)aaaa   <= sum(m-a)    [ T1o(c,m)aa   . Q(d,m,ij)aa ]
cT27.1T2n(ab,ij)aaaa   <- R(a,b,ij)aaaa - R(b,a,ij)aaaa
c
cT27.1.1    M3(m,j,e) <- H1(m,e,j)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdh1,mapih1,syma,mapdm3,mapim3,possm30,posst,rc)
c
cT27.1.2    H4(m,j,i) <- M3(m,j,e) . T1o(e,i)aa
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm3,mapim3,syma,mapdt11,mapit11,1,mapdh4,mapih4,ssh4,
     & possh40,rc)
c
cT27.1.3    M3(m,ji) <- H4(m,j,i) - H4(m,i,j)
       call fack (wrk,wrksize,
     & 3,2,mapdh4,syma,mapih4,mapdm3,mapim3,possm30,rc)
c
cT27.1.4    M4(c,ji) <- T1o(c,m)aa . M3(m,ji)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt11,mapit11,1,mapdm3,mapim3,syma,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cT27.1.5    T2n(ab,ij) <- - (M4(a,ji)-M4(b,ji) = M4(b,ij)-M4(a,ij)
c     since -1 was skipped in first step (T27.1)
       call add (wrk,wrksize,
     & 3,4,1,2,a,0,syma,1,1.0d0,
     & mapdm4,syma,mapdt21,mapit21,1,rc)
c
cparend
       end if
c
       end if
c
c
c
c
       if (h2lenght.gt.0) then
cW31.5read H2(m,e,j) = <ma||ej>baab
cpar
        if (myRank.eq.idbaab) then
       call rea (n2aalfa,h2lenght,wrk(possh20))
        else
       call reajalovy (n2aalfa,h2lenght,wrk(possh20))
        end if

c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)aaaa
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(i,j,ef)  = T2o(ef,ij)aaaa
c     V4(i,j,e,f) = T2o(e,f,i,j)abab
c     M1(m,ef)  - <ma||ef>aaaa (free, but reserved map's)
c     M2(m,e,f) - <ma||ef>baab (free, but reserved map's)
c     H1(m,e,j) - <ma||ej>aaaa = W3(m,e,a,j)aaaa
c     H2(m,e,j) - <ma||ej>baab = W3(m,e,a,j)baab
c     H3(m,e,j) - <ma||ej>baba = W3(m,e,a,j)bbaa (free, but reserved map's)
c     free: M3,M4,H4
c
cpar
        if (myRank.eq.idbaab) then
c
c     ------- cont to T27 (part)
cT27.3p            G1(b,m,i,j)abab <= + sum(e-a)  [ <mb||ej>baab . T1o(e,i)aa ]
c
cT27.3.1    M4(m,j,e) <- H2(m,e,j)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdh2,mapih2,syma,mapdm4,mapim4,possm40,posst,rc)
c
cT27.3.2    M3(m,j,i) <- M4(m,j,e) . T1o(e,i)
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm4,mapim4,syma,mapdt11,mapit11,1,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT27.3.3    M4(m,i,j) <- M3(m,j,i)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdm3,mapim3,syma,mapdm4,mapim4,possm40,posst,rc)
c
cpar
        if (idbaab.ne.idbbaa) then
c        if idbaab and idbbaa are different, we need to add contribution
c       from this part of G1 to T2n, since they will be not present on
c       idbbaa
c
cT27.3  T2n(a,b,i,j)abab <- sum(m-b)    [ T1o(b,m)bb   . G1(a,m,i,j)abab ]
c
cT27.3.7    M3(b,i,j) <- T1o(b,m)bb . M4(m,i,j)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt12,mapit12,1,mapdm4,mapim4,syma,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT27.3.8    T2n(a,b,i,j) <- 1.0d0 . M3(b,i,j)
       call add (wrk,wrksize,
     & 3,4,1,1,a,0,syma,1,1.0d0,
     & mapdm3,syma,mapdt23,mapit23,1,rc)
cparend
        end if
c
cparend
       end if
c
       end if
c
c
c
c
       if (h3lenght.gt.0) then
cW31.6read H3(m,e,j) = <ma||ej>baba
cpar
         if (myRank.eq.idbbaa) then
       call rea (n2aalfa,h3lenght,wrk(possh30))
        else
       call reajalovy (n2aalfa,h3lenght,wrk(possh30))
        end if
c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)aaaa
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(i,j,ef)  = T2o(ef,ij)aaaa
c     V4(i,j,e,f) = T2o(e,f,i,j)abab
c     M1(m,ef)  - <ma||ef>aaaa (free, but reserved map's)
c     M2(m,e,f) - <ma||ef>baab (free, but reserved map's)
c     M4(m,j,i) - part of G1 intermediat from previos step (only if idbaab=idbbaa)
c     H1(m,e,j) - <ma||ej>aaaa = W3(m,e,a,j)aaaa
c     H2(m,e,j) - <ma||ej>baab = W3(m,e,a,j)baab
c     H3(m,e,j) - <ma||ej>baba = W3(m,e,a,j)bbaa
c     free: M3,H4
c
cpar
        if (myRank.eq.idbbaa) then
c
c     ------- cont to T27 (continue)
cT27.3G1(b,m,i,j)abab <- - sum(e-b)  [ <mb||ei>baba . T1o(e,j)bb ]
cT27.3T2n(a,b,i,j)abab <- sum(m-b)    [ T1o(b,m)bb   . G1(a,m,i,j)abab ]
c     part of G1 is in M4(m,i,j) from part T27.3.3
c
cT27.3.4    M3(m,i,e) <- H3(m,e,i)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdh3,mapih3,syma,mapdm3,mapim3,possm30,posst,rc)
c
cT27.3.5    H4(m,i,j) <- M3(m,i,e) . T1o(e,j)bb
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm3,mapim3,syma,mapdt12,mapit12,1,mapdh4,mapih4,ssh4,
     & possh40,rc)
c
cpar
        if (idbaab.eq.idbbaa) then
c        if idbaab=idbbaa add H4 to M4 from prev step and realize
c        contribution from both parts of G1 in one step
c
cT27.3.6    (G1) M4(m,i,j) <- -H4(m,i,j)
       call add (wrk,wrksize,
     & 3,3,0,0,0,0,1,1,-1.0d0,
     & mapdh4,syma,mapdm4,mapim4,syma,rc)
c
cT27.3.7    M3(b,i,j) <- T1o(b,m)bb . M4(m,i,j)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt12,mapit12,1,mapdm4,mapim4,syma,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT27.3.8    T2n(a,b,i,j) <- 1.0d0 . M3(b,i,j)
       call add (wrk,wrksize,
     & 3,4,1,1,a,0,syma,1,1.0d0,
     & mapdm3,syma,mapdt23,mapit23,1,rc)
c
        else
c        if idbaab.ne.idbbaa we need to calc only contribution from
c        2.nd part of G1
c
cT27.3.7    M3(b,i,j) <- T1o(b,m)bb . H4(m,i,j)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt12,mapit12,1,mapdh4,mapih4,syma,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT27.3.8    T2n(a,b,i,j) <- -1.0d0 . M3(b,i,j)
c           (minus sign, since we skip sign in previous step)
       call add (wrk,wrksize,
     & 3,4,1,1,a,0,syma,1,-1.0d0,
     & mapdm3,syma,mapdt23,mapit23,1,rc)
cparend
        end if
c
c     ------- cont to T15
cT15.2T1n(a,i)aa <- sum(n,f-bb) [ <na||fi>baba . T1o(f,n)bb ]
c
cT15.2.1    H4(i,f,n) <- H3(n,f,i)
       call map (wrk,wrksize,
     & 3,3,2,1,0,
     & mapdh3,mapih3,syma,mapdh4,mapih4,possh40,posst,rc)
c
cT15.2.2    M3(i) <- H4(i,f,n) . T1o(f,n)bb
       call mult (wrk,wrksize,
     & 3,2,1,2,
     & mapdh4,mapih4,syma,mapdt12,mapit12,1,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT15.2.3    T1n(a,i)aa <- 1.0d0 . M3(i)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,1.0d0,
     & mapdm3,syma,mapdt13,mapit13,1,rc)
c
cparend
       end if
c
       end if
c
c
c
c
       if (m1lenght.gt.0) then
c
cB.7  read M1(m,ef) = <ma||ef>aaaa
cpar
        if (myRank.eq.idaaaa) then
       call rea (n1aalfa,m1lenght,wrk(possm10))
        else
       call reajalovy (n1aalfa,m1lenght,wrk(possm10))
        end if
c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)aaaa
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(i,j,ef)  = T2o(ef,ij)aaaa
c     V4(i,j,e,f) = T2o(e,f,i,j)abab
c     M1(m,ef)  - <ma||ef>aaaa
c     M2(m,e,f) - <ma||ef>baab (free, but reserved map's)
c     H1(m,e,j) - <ma||ej>aaaa = W3(m,e,a,j)aaaa
c     H2(m,e,j) - <ma||ej>baab = W3(m,e,a,j)baab
c     H3(m,e,j) - <ma||ej>baba = W3(m,e,a,j)bbaa
c     free: M3,M4,H4
c
cpar
        if (myRank.eq.idaaaa) then
c
c     ------- cont to T16
cT16.1T1n(a,i)aa <- - sum(m,e>f-aaa) [ T2o(ef,i,m)aaaa  . <ma||ef>aaaa ]
c
cT16.1.1    M3(i) = V3(i,m,ef). M1(m,ef)
       call mult (wrk,wrksize,
     & 4,3,1,3,
     & mapdv3,mapiv3,1,mapdm1,mapim1,syma,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT16.1.2    t1n(a,i)aa <- -1.0d0 . M3(i)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,-1.0d0,
     & mapdm3,syma,mapdt13,mapit13,1,rc)
c
c     ------- cont to T2Ex
cT2E.12             R(a,m,ij)aaaa   <= - sum(e>f-aa) [ <ma||ef>aaaa . Tau(ef,ij)aaaa ]
cT2E.1T2n(ab,ij)aaaa   <- - sum(m-a)    [ T1o(b,m)aa   .  R(a,m,ij)aaaa ]
cT2E.2T2n(ab,ij)aaaa   <-   sum(m-a)    [ T1o(a,m)aa   .  R(b,m,ij)aaaa ]
c
cT2E.12.1   M3(m,ij) = M1(m,ef) . V1(ef,ij)
       call mult (wrk,wrksize,
     & 3,4,3,2,
     & mapdm1,mapim1,syma,mapdv1,mapiv1,1,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT2E.1,2.1  M4(b,ij) = T1o(b,m)aa . M3(m,ij)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt11,mapit11,1,mapdm3,mapim3,ssm3,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cT2E.1,2.2    T2n(ab,ij)aaaa <- 1.0d0 . M4(b,ij) (@@ pozor na factor @@)
       call add (wrk,wrksize,
     & 3,4,1,1,a,0,syma,1,1.0d0,
     & mapdm4,syma,mapdt21,mapit21,1,rc)
c
c     ------- cont to W32
cW32.1WIII(m,e,b,j)aaaa <- + sum(f-a) [  <mb||ef>aaaa . T1o(f,j)aa ]
c
cW32.1.1    M3(m,e,f) <- M1(m,ef)
       call expand (wrk,wrksize,
     & 3,2,mapdm1,mapim1,syma,possm30,mapdm3,mapim3,rc)
c
cW32.1.2    M4(m,e,j) <- M3(m,e,f) . T1o(f,j)aa
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm3,mapim3,syma,mapdt11,mapit11,1,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cW32.1.3    H1(W3aaaa)(m,e,j) <- +1.0d0 . M4(m,e,j)
       call add (wrk,wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0,
     & mapdm4,syma,mapdh1,mapih1,syma,rc)
c
cW3.1 write W3aaaa(m,e,j) to  lunw3aaaa file if size is not zero
       if (h1lenght.gt.0) then
       call wri (lunw3aaaa,h1lenght,wrk(possh10))
       end if
c
c     ------- cont to FI3
cF13.1FI(a,e)aa <- -sum(m,f-aa) [ <ma||ef>aaaa . T1o(f,m)aa ]
c
cF13.1.1    M4(e,f,m) <- M3(m,e,f)  (M3 from previous part is not destroyed)
       call map (wrk,wrksize,
     & 3,3,1,2,0,
     & mapdm3,mapim3,syma,mapdm4,mapim4,possm40,posst,rc)
c
cF13.1.2    H4(e) <- M4(e,f,m) . T1o(f,m)aa
       call mult (wrk,wrksize,
     & 3,2,1,2,
     & mapdm4,mapim4,syma,mapdt11,mapit11,1,mapdh4,mapih4,ssh4,
     & possh40,rc)
c
cF13.1.3    F1(a,e)aa <- -1.0d0 . H4(e)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,-1.0d0,
     & mapdh4,syma,mapdf11,mapif11,1,rc)
c
cparend
       end if
c
       end if
c
c
c
c
       if (m2lenght.gt.0) then
cB.8  read M2(m,e,f) = <ma||e,f>baab
cpar
        if ((myRank.eq.idbaab).or.(myRank.eq.idbbaa)) then
       call rea (n1aalfa,m2lenght,wrk(possm20))
        else
       call reajalovy (n1aalfa,m2lenght,wrk(possm20))
        end if
c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)aaaa
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(i,j,ef)  = T2o(ef,ij)aaaa
c     V4(i,j,e,f) = T2o(e,f,i,j)abab
c     M1(m,ef)  - <ma||ef>aaaa (free, but reserved map's)
c     M2(m,e,f) - <ma||ef>baab
c     H1(m,e,j) - <ma||ej>aaaa  (free, but reserved map's)
c     H2(m,e,j) - <ma||ej>baab = W3(m,e,a,j)baab
c     H3(m,e,j) - <ma||ej>baba = W3(m,e,a,j)bbaa
c     free: M3,M4,H4
c
c
cpar
        if (myRank.eq.idbaab) then
c
c     ------- cont to T16
cT16.2T1n(a,i)aa <- - sum(m,e,f-bab) [ T2o(e,f,i,m)abab . <ma||ef>baab ]
c
cT16.2.1    M3(i) = V4(i,m,e,f) . M2(m,e,f)
       call mult (wrk,wrksize,
     & 4,3,1,3,
     & mapdv4,mapiv4,1,mapdm2,mapim2,syma,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT16.2.2    t1n(a,i)aa <- -1.0d0 . M3(i)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,-1.0d0,
     & mapdm3,syma,mapdt13,mapit13,1,rc)
c
c     ------- cont to T2Ex
cT2E.5R1(a,m,i,j)abab <= - sum(e,f-ab) [ <ma||ef>baab . Tau(e,f,i,j)abab ]
cT2E.5T2n(a,b,i,j)abab <- - sum(m-b)    [ T1o(m,b)bb . R1(a,m,i,j)baab ]
c
cT2E.5.1    M4(m,i,j) <- M2(m,e,f) . V2(e,f,i,j)
       call mult (wrk,wrksize,
     & 3,4,3,2,
     & mapdm2,mapim2,syma,mapdv2,mapiv2,1,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cT2E.5.2    M3(b,i,j) <- T1o(b,m)bb . M4(m,i,j)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt12,mapit12,1,mapdm4,mapim4,syma,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT2E.5.3    T2n(a,b,i,j)abab <- 1.0d0 M3(b,i,j)
       call add (wrk,wrksize,
     & 3,4,1,1,a,0,syma,1,1.0d0,
     & mapdm3,ssm3,mapdt23,mapit23,1,rc)
cparend
        end if
c
c
c     ------- cont to W32
cW32.5WIII(m,e,b,j)baab <-  sum(f-b) [  <mb||ef>baab . T1o(f,j)bb ]
cW32.6WIII(m,e,b,j)bbaa <- - sum(f-a) [  <mb||fe>baab . T1o(f,j)aa ]
c
cpar
        if (myRank.eq.idbaab) then
cW32.5.1    M4(m,e,j) = M2(m,e,f) . T1o(f,j)bb
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm2,mapim2,syma,mapdt12,mapit12,1,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cW32.5.2    H2(W3baab)(m,e,j) <- 1.0d0 M4(m,e,j)
       call add (wrk,wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0,
     & mapdm4,syma,mapdh2,mapih2,syma,rc)
c
cW3.5 write W3baab(m,e,j) to  lunw3baab file if size is not zero
       if (h2lenght.gt.0) then
       call wri (lunw3baab,h2lenght,wrk(possh20))
       end if
cendpar
        end if
c
c
cpar
        if (myRank.eq.idbbaa) then
cW32.6.1    M4(m,e,f) <- M2(m,f,e)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdm2,mapim2,syma,mapdm4,mapim4,possm40,posst,rc)
c
cW32.6.2    M3(m,e,j) <- M4(m,e,f) . T1o(f,j)aa
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm4,mapim4,syma,mapdt11,mapit11,1,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cW32.6.3    H3(W3bbaa)(m,e,j) <- -1.0d0 M3(m,e,j)
       call add (wrk,wrksize,
     & 3,3,0,0,0,0,1,1,-1.0d0,
     & mapdm3,syma,mapdh3,mapih3,syma,rc)
c
cW3.6 write W3bbaa(m,e,j) to  lunw3bbaa file if size is not zero
       if (h3lenght.gt.0) then
       call wri (lunw3bbaa,h3lenght,wrk(possh30))
       end if
cparend
        end if
c
c     ------- cont to FI3
cpar
        if (myRank.eq.idbaab) then
cF13.2FI(a,e)aa <- -sum(m,f-bb) [ <ma||ef>baab . T1o(f,m)bb ]
c
cF13.2.1    M3(e,f,m) <- M2(m,e,f)
       call map (wrk,wrksize,
     & 3,3,1,2,0,
     & mapdm2,mapim2,syma,mapdm3,mapim3,possm30,posst,rc)
c
cF13.2.2    M4(e)     <- M3(e,f,m) . T1o(f,m)bb
       call mult (wrk,wrksize,
     & 3,2,1,2,
     & mapdm3,mapim3,syma,mapdt12,mapit12,1,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cF13.2.3    F1(a,e)aa <- -1.0d0 M4(e)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,-1.0d0,
     & mapdm4,syma,mapdf11,mapif11,1,rc)
       end if
cparend
        end if
c
 2500   continue
c
 3000   continue
c
cB.9  close n1aalfa,n2aalfa
       call filemanager (3,n1aalfa,rc)
       call filemanager (3,n2aalfa,rc)
cparend
       end if
c
c
c     ****************   A - prepair phase part 2 -------------------
c
c
cpar
       if (yesb.eq.1) then
cA.10 V3(j,i,e,f) <- V4(i,j,e,f)
       call map (wrk,wrksize,
     & 4,2,1,3,4,
     & mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,rc)
c
cA.11 read T2o4b from opened lunt2o1 file
c     V4(ef,ij)    <- T2o(ef,ij)aaaa
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv40,mapdv4,mapiv4,rc)
c
cA.12 V1(ij,ef) <- V4(ef,ij)
       call map (wrk,wrksize,
     & 4,3,4,1,2,
     & mapdv4,mapiv4,1,mapdv1,mapiv1,possv10,posst,rc)
c
cA.13 expand V4(i,j,ef) <- V1(ij,ef)
       call expand (wrk,wrksize,
     & 4,5,mapdv1,mapiv1,1,possv40,mapdv4,mapiv4,rc)
c
cA.14 read T2o4b from opened lunt2o1 file
c     V1(ef,ij)    <- T2o(ef,ij)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv10,mapdv1,mapiv1,rc)
c
cA.15 mktau V1(ef,ij) <- V1(ef,ij)
       call mktau (wrk,wrksize,
     & mapdv1,mapiv1,mapdt11,mapit11,mapdt12,mapit12,1.0d0,
     &             rc)
cA.16
        if ((idbbbb.ne.idaabb).and.(myRank.eq.idbbbb)) then
       call set0 (wrk,wrksize,
     &             mapdf12,mapif12)
        end if
c
c
c     now there is:
c     V1(ef,ij)   = Tau(ef,ij)bbbb
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(j,i,e,f) = T2o(e,f,i,j)abab
c     V4(i,j,ef)  = T2o(ef,ij)bbbb
c     free: M1-M4, H1-H4
c
c
c     ****************   C - sum over a beta ---------------------
c
cC.1  open n1abeta,n2abeta
       n1abeta=12
       n2abeta=14
       call filemanager (4,n1abeta,rc)
       call filemanager (4,n2abeta,rc)
c
cC.2  open temp files lunw3bbbb, lunw3abba, lunw3aabb
cpar
       if (myRank.eq.idbbbb) then
       call filemanager (1,lunw3bbbb,rc)
       end if
c
       if (myRank.eq.idabba) then
       call filemanager (1,lunw3abba,rc)
       end if
c
       if (myRank.eq.idaabb) then
       call filemanager (1,lunw3aabb,rc)
       end if
c
c
       do 6000 syma=1,nsym
c
        if (fullprint.ge.3) then
        write (6,*) ' SymA beta ',syma
        end if
c
c     storing of mediates:
c
c     V1(ef,ij)   = Tau(ef,ij)bbbb
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(j,i,e,f) = T2o(e,f,i,j)abab
c     V4(i,j,ef)  = T2o(ef,ij)bbbb
c     M1(m,ef)  - <ma||ef>bbbb
c     M2(m,e,f) - <ma||ef>abab
c     H1(m,e,j) - <ma||ej>bbbb = W3(m,e,a,j)bbbb
c     H2(m,e,j) - <ma||ej>abba = W3(m,e,a,j)abba
c     H3(m,e,j) - <ma||ej>abab = W3(m,e,a,j)aabb
c     free: M3,M4,H4
c
cC.3  get mapd and mapi for M1,M2
       call getmap (n1abeta,possm10,m1lenght,mapdm1,mapim1,rc)
       call getmap (n1abeta,possm20,m2lenght,mapdm2,mapim2,rc)
c
cC.4  get mapd and mapi for H1 - H3
       call getmap (n2abeta,possh10,h1lenght,mapdh1,mapih1,rc)
       call getmap (n2abeta,possh20,h2lenght,mapdh2,mapih2,rc)
       call getmap (n2abeta,possh30,h3lenght,mapdh3,mapih3,rc)
c
cC.5  write mapd and mapi of W3bbbb(H1), W3abba(H2) and W3aabb(H3)
cpar
        if (myRank.eq.idbbbb) then
       call wrtmap (lunw3bbbb,mapdh1,mapih1,rc)
        end if
c
        if (myRank.eq.idabba) then
       call wrtmap (lunw3abba,mapdh2,mapih2,rc)
        end if
c
        if (myRank.eq.idaabb) then
       call wrtmap (lunw3aabb,mapdh3,mapih3,rc)
        end if
cparend
c
c
cC.6  skip cycle over a if lenght of all files is zero
       if ((m1lenght+m2lenght+h1lenght+h2lenght+h3lenght).eq.0) goto
     & 6000
c
       do 5500 a=1,nvb(syma)
        if (fullprint.ge.3) then
        write (6,*) ' A beta ',a
        end if
c
c
       if (h1lenght.gt.0) then
cW31.2.1    read H1(m,e,j) = <ma||ej>bbbb
cpar
        if (myRank.eq.idbbbb) then
       call rea (n2abeta,h1lenght,wrk(possh10))
        else
       call reajalovy (n2abeta,h1lenght,wrk(possh10))
        end if
c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)bbbb
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(j,i,e,f) = T2o(e,f,i,j)abab
c     V4(i,j,ef)  = T2o(ef,ij)bbbb
c     M1(m,ef)  - <ma||ef>bbbb (free, but reserved map's)
c     M2(m,e,f) - <ma||ef>abab (free, but reserved map's)
c     H1(m,e,j) - <ma||ej>bbbb = W3(m,e,a,j)bbbb
c     H2(m,e,j) - <ma||ej>abba = W3(m,e,a,j)abba (free, but reserved map's)
c     H3(m,e,j) - <ma||ej>abab = W3(m,e,a,j)aabb (free, but reserved map's)
c     free: M3,M4,H4
c
cpar
        if (myRank.eq.idbbbb) then
c
c     ------- cont to T15
cT15.3T1n(a,i)bb <- sum(n,f-bb) [ <na||fi>bbbb . T1o(f,n)bb ]
c
cT15.3.1    H4(i,f,n) <- H1(n,f,i)
       call map (wrk,wrksize,
     & 3,3,2,1,0,
     & mapdh1,mapih1,syma,mapdh4,mapih4,possh40,posst,rc)
c
cT15.3.2    M3(i) <- H4(i,f,n) . T1o(f,n)bb
       call mult (wrk,wrksize,
     & 3,2,1,2,
     & mapdh4,mapih4,syma,mapdt12,mapit12,1,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT15.3.3    T1n(a,i)aa <- 1.0d0 . M3(i)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,1.0d0,
     & mapdm3,syma,mapdt14,mapit14,1,rc)
c
c     ------- cont to T27
cT27.2G(b,m,i,j)bbbb  <= - sum(e-b)  [ <mb||ej>bbbb . T1o(e,i)bb ]
cT27.2Q(b,m,ij)bbbb   <= G(b,m,i,j)bbbb - G(b,m,j,i)bbbb
cT27.2R(c,d,ij)bbbb   <= sum(m-b)    [ T1o(c,m)bb   . Q(d,m,ij)bb ]
cT27.2T2n(ab,ij)bbbb   <- R(a,b,ij)bbbb - R(b,a,ij)bbbb
c
cT27.2.1    M3(m,j,e) <- H1(m,e,j)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdh1,mapih1,syma,mapdm3,mapim3,possm30,posst,rc)
c
cT27.2.2    H4(m,j,i) <- M3(m,j,e) . T1o(e,i)bb
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm3,mapim3,syma,mapdt12,mapit12,1,mapdh4,mapih4,ssh4,
     & possh40,rc)
c
cT27.2.3    M3(m,ji) <- H4(m,j,i) - H4(m,i,j)
       call fack (wrk,wrksize,
     & 3,2,mapdh4,syma,mapih4,mapdm3,mapim3,possm30,rc)
c
cT27.2.4    M4(c,ji) <- T1o(c,m)bb . M3(m,ji)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt12,mapit12,1,mapdm3,mapim3,syma,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cT27.2.5    T2n(ab,ij) <- - (M4(a,ji)-M4(b,ji) = M4(b,ij)-M4(a,ij)
c     since -1 was skipped in first step (T27.1)
       call add (wrk,wrksize,
     & 3,4,1,2,a,0,syma,1,1.0d0,
     & mapdm4,syma,mapdt22,mapit22,1,rc)
cparend
       end if
c
       end if
c
c
c
c
       if (h2lenght.gt.0) then
cW31.4read H2(m,e,j) = <ma||ej>abba
cpar
        if (myRank.eq.idabba) then
       call rea (n2abeta,h2lenght,wrk(possh20))
        else
       call reajalovy (n2abeta,h2lenght,wrk(possh20))
        end if
c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)bbbb
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(j,i,e,f) = T2o(e,f,i,j)abab
c     V4(i,j,ef)  = T2o(ef,ij)bbbb
c     M1(m,ef)  - <ma||ef>bbbb (free, but reserved map's)
c     M2(m,e,f) - <ma||ef>abab (free, but reserved map's)
c     H1(m,e,j) - <ma||ej>bbbb = W3(m,e,a,j)bbbb
c     H2(m,e,j) - <ma||ej>abba = W3(m,e,a,j)abba
c     H3(m,e,j) - <ma||ej>abab = W3(m,e,a,j)aabb (free, but reserved map's)
c     free: M3,M4,H4
c
cpar
        if (myRank.eq.idabba) then
c
c     ------- cont to T27 (part)
cT27.4p      G2(b,m,i,j)baab <- + sum(e-b)  [ <mb||ei>abba . T1o(e,j)bb ] +
c
cT27.4.1    M3(m,i,e) <- H2(m,e,i)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdh2,mapih2,syma,mapdm3,mapim3,possm30,posst,rc)
c
cT27.4.2    M4(m,i,j) <- M3(m,i,e) . T1o(e,j)bb
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm3,mapim3,syma,mapdt12,mapit12,1,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cpar
        if (idaabb.ne.idabba) then
c        if idaabb and idabba are different, we need to add contribution
c       from this part of G2 to T2n, since they will be not present on
c       idaabb
c
cT27.4        T2n(a,b,i,j)abab <- sum(m-a)    [ T1o(a,m)aa   . G2(b,m,i,j)baab ] +
c
cT27.4.7    H4(a,i,j) <- T1o(a,m)aa . M4(m,i,j)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt11,mapit11,1,mapdm4,mapim4,syma,mapdh4,mapih4,ssh4,
     & possh40,rc)
c
cT27.4.8    T2n(c,a,i,j) <- 1.0d0 . H4(c,i,j)
       call add (wrk,wrksize,
     & 3,4,1,2,a,0,syma,1,1.0d0,
     & mapdh4,syma,mapdt23,mapit23,1,rc)
cparend
        end if
c
cparend
       end if
c
       end if
c
c
c
c
       if (h3lenght.gt.0) then
cW31.3read H3(m,e,j) = <ma||ej>abab
cpar
        if (myRank.eq.idaabb) then
       call rea (n2abeta,h3lenght,wrk(possh30))
        else
       call reajalovy (n2abeta,h3lenght,wrk(possh30))
        end if
c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)bbbb
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(j,i,e,f) = T2o(e,f,i,j)abab
c     V4(i,j,ef)  = T2o(ef,ij)bbbb
c     M1(m,ef)  - <ma||ef>bbbb (free, but reserved map's)
c     M2(m,e,f) - <ma||ef>abab (free, but reserved map's)
c     M4(m,j,i) - part of G2 intermediat from previos step
c     H1(m,e,j) - <ma||ej>bbbb = W3(m,e,a,j)bbbb
c     H2(m,e,j) - <ma||ej>abba = W3(m,e,a,j)abba
c     H3(m,e,j) - <ma||ej>abab = W3(m,e,a,j)aabb
c     free: M3,H4
c
cpar
        if (myRank.eq.idaabb) then
c
c     ------- cont to T27 (continue)
cT27.4G2(b,m,i,j)baab <= - sum(e-a)  [ <mb||ej>abab . T1o(e,i)aa ] +
cT27.4T2n(a,b,i,j)abab <- sum(m-a)    [ T1o(a,m)aa   . G2(b,m,i,j)baab ] +
c     N.B. part of G2(m,i,j) is in M4 from part T27.4.2
c
cT27.4.3    M3(m,j,e) <- H3(m,e,j)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdh3,mapih3,syma,mapdm3,mapim3,possm30,posst,rc)
c
cT27.4.4    H4(m,j,i) <- M3(m,j,e) . T1o(e,i)aa
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm3,mapim3,syma,mapdt11,mapit11,1,mapdh4,mapih4,ssh4,
     & possh40,rc)
c
cT27.4.5    M3(m,i,j) <- H4(m,j,i)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdh4,mapih4,syma,mapdm3,mapim3,possm30,posst,rc)
c
cpar
        if (idaabb.eq.idabba) then
c        if idaabb=idabba add H4 to M4 from prev step and realize
c        contribution from both parts of G2 in one step

cT27.4.6    (G2) M4(m,i,j) <- - M3(m,i,j)
       call add (wrk,wrksize,
     & 3,3,0,0,0,0,1,1,-1.0d0,
     & mapdm3,syma,mapdm4,mapim4,syma,rc)
c
cT27.4.7    H4(a,i,j) <- T1o(a,m)aa . M4(m,i,j)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt11,mapit11,1,mapdm4,mapim4,syma,mapdh4,mapih4,ssh4,
     & possh40,rc)
c
cT27.4.8    T2n(c,a,i,j) <- 1.0d0 . H4(c,i,j)
       call add (wrk,wrksize,
     & 3,4,1,2,a,0,syma,1,1.0d0,
     & mapdh4,syma,mapdt23,mapit23,1,rc)
c
        else
c        if idabba.ne.idaabb we need to calc only contribution from
c        2.nd part of G2
c
cT27.4.7    H4(a,i,j) <- T1o(a,m)aa . M3(m,i,j)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt11,mapit11,1,mapdm3,mapim3,syma,mapdh4,mapih4,ssh4,
     & possh40,rc)
c
cT27.4.8    T2n(c,a,i,j) <- 1.0d0 . -H4(c,i,j)
c           (minus sign, since we skip sign in previous step)
       call add (wrk,wrksize,
     & 3,4,1,2,a,0,syma,1,-1.0d0,
     & mapdh4,syma,mapdt23,mapit23,1,rc)
cparend
        end if
c
c
c     ------- cont to T15
cT15.4T1n(a,i)bb <- sum(n,f-aa) [ <na||fi>abab . T1o(f,n)aa ]
c
cT15.4.1    H4(i,f,n) <- H3(n,f,i)
       call map (wrk,wrksize,
     & 3,3,2,1,0,
     & mapdh3,mapih3,syma,mapdh4,mapih4,possh40,posst,rc)
c
cT15.4.2    M3(i) <- H4(i,f,n) . T1o(f,n)aa
       call mult (wrk,wrksize,
     & 3,2,1,2,
     & mapdh4,mapih4,syma,mapdt11,mapit11,1,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT15.4.3    T1n(a,i)bb <- 1.0d0 . M3(i)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,1.0d0,
     & mapdm3,syma,mapdt14,mapit14,1,rc)
cparend
       end if
c
       end if
c
c
c
c
       if (m1lenght.gt.0) then
c
cC.7  read M1(m,ef) = <ma||ef>bbbb
cpar
        if (myRank.eq.idbbbb) then
       call rea (n1abeta,m1lenght,wrk(possm10))
        else
       call reajalovy (n1abeta,m1lenght,wrk(possm10))
        end if
c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)bbbb
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(j,i,e,f) = T2o(e,f,i,j)abab
c     V4(i,j,ef)  = T2o(ef,ij)bbbb
c     M1(m,ef)  - <ma||ef>bbbb
c     M2(m,e,f) - <ma||ef>abab (free, but reserved map's)
c     H1(m,e,j) - <ma||ej>bbbb = W3(m,e,a,j)bbbb
c     H2(m,e,j) - <ma||ej>abba = W3(m,e,a,j)abba
c     H3(m,e,j) - <ma||ej>abab = W3(m,e,a,j)aabb
c     free: M3,M4,H4
c
cpar
        if (myRank.eq.idbbbb) then
c
c     ------- cont to T16
cT16.3T1n(a,i)bb <- - sum(m,e>f-bbb) [ T2o(ef,i,m)bbbb  . <ma||ef>bbbb ]
c
cT16.3.1*   M3(i) = V4(i,m,ef). M1(m,ef)
       call mult (wrk,wrksize,
     & 4,3,1,3,
     & mapdv4,mapiv4,1,mapdm1,mapim1,syma,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT16.3.2    t1n(a,i)bb <- -1.0d0 . M3(i)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,-1.0d0,
     & mapdm3,syma,mapdt14,mapit14,1,rc)
c
c     ------- cont to T2Ex
cT2E.34             R(a,m,ij)bbbb   <= - sum(e>f-bb) [ <ma||ef>bbbb . Tau(ef,ij)bbbb ] +
cT2E.3T2n(ab,ij)bbbb   <- - sum(m-b)    [ T1o(b,m)bb   .  R(a,m,ij)bbbb ] +
cT2E.4T2n(ab,ij)bbbb   <-   sum(m-b)    [ T1o(a,m)bb   .  R(b,m,ij)bbbb ] +
c
cT2E.34.1   M3(m,ij) = M1(m,ef) . V1(ef,ij)
       call mult (wrk,wrksize,
     & 3,4,3,2,
     & mapdm1,mapim1,syma,mapdv1,mapiv1,1,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT2E.3,4.1  M4(b,ij) = T1o(b,m)bb . M3(m,ij)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt12,mapit12,1,mapdm3,mapim3,ssm3,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cT2E.3,4.2    T2n(ab,ij)bbbb <- 1.0d0 . M4(b,ij) (@@ pozor na factor @@)
       call add (wrk,wrksize,
     & 3,4,1,1,a,0,syma,1,1.0d0,
     & mapdm4,ssm4,mapdt22,mapit22,1,rc)
c
c     ------- cont to W32
cW32.2WIII(m,e,b,j)bbbb <- + sum(f-b) [  <mb||ef>bbbb . T1o(f,j)bb ]
c
cW32.2.1    M3(m,e,f) <- M1(m,ef)
       call expand (wrk,wrksize,
     & 3,2,mapdm1,mapim1,syma,possm30,mapdm3,mapim3,rc)
c
cW32.2.2    M4(m,e,j) <- M3(m,e,f) . T1o(f,j)bb
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm3,mapim3,syma,mapdt12,mapit12,1,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cW32.2.3    H1(W3bbbb)(m,e,j) <- +1.0d0 . M4(m,e,j)
       call add (wrk,wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0,
     & mapdm4,syma,mapdh1,mapih1,syma,rc)
c
cW3.2 write W3bbbb(m,e,j) to  lunw3bbbb file if size is not zero
       if (h1lenght.gt.0) then
       call wri (lunw3bbbb,h1lenght,wrk(possh10))
       end if
c
c     ------- cont to FI3
cF13.3FI(a,e)bb <-  sum(m,f-bb) [ <ma||fe>bbbb . T1o(f,m)bb ]
c
cF13.3.1    M4(e,f,m) <- M3(m,f,e)  (M3 from previous part is not destroyed)
       call map (wrk,wrksize,
     & 3,3,2,1,0,
     & mapdm3,mapim3,syma,mapdm4,mapim4,possm40,posst,rc)
c
cF13.3.2    H4(e) <- M4(e,f,m) . T1o(f,m)bb
       call mult (wrk,wrksize,
     & 3,2,1,2,
     & mapdm4,mapim4,syma,mapdt12,mapit12,1,mapdh4,mapih4,ssh4,
     & possh40,rc)
c
cF13.3.3    F1(a,e)bb <- 1.0d0 . H4(e)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,1.0d0,
     & mapdh4,syma,mapdf12,mapif12,1,rc)
cparend
       end if
c
       end if
c
c
c
c
       if (m2lenght.gt.0) then
cB.8  read M2(m,e,f) = <ma||e,f>abab
        if ((myRank.eq.idaabb).or.(myRank.eq.idabba)) then
       call rea (n1abeta,m2lenght,wrk(possm20))
        else
       call reajalovy (n1abeta,m2lenght,wrk(possm20))
        end if
c
c     Status:
c     V1(ef,ij)   = Tau(ef,ij)bbbb
c     V2(e,f,i,j) = Tau(e,f,i,j)abab
c     V3(j,i,e,f) = T2o(e,f,i,j)abab
c     V4(i,j,ef)  = T2o(ef,ij)bbbb
c     M1(m,ef)  - <ma||ef>bbbb (free, but reserved map's)
c     M2(m,e,f) - <ma||ef>abab
c     H1(m,e,j) - <ma||ej>bbbb  (free, but reserved map's)
c     H2(m,e,j) - <ma||ej>abba = W3(m,e,a,j)abba
c     H3(m,e,j) - <ma||ej>abab = W3(m,e,a,j)aabb
c     free: M3,M4,H4
c
cpar
        if (myRank.eq.idaabb) then
c
c     ------- cont to T16
cT16.4T1n(a,i)bb <- + sum(m,e,f-aab) [ T2o(e,f,m,i)abab . <ma||ef>abab ]
c
cT16.4.1    M3(i) = V3(i,m,e,f) . M2(m,e,f)
       call mult (wrk,wrksize,
     & 4,3,1,3,
     & mapdv3,mapiv3,1,mapdm2,mapim2,syma,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT16.4.2    t1n(a,i)bb <- +1.0d0 . M3(i)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,1.0d0,
     & mapdm3,syma,mapdt14,mapit14,1,rc)
c
c     ------- cont to T2Ex
cT2E.6R2(a,m,i,j)baab <= - sum(e,f-ab) [ <ma||ef>abab . Tau(e,f,i,j)abab ]
cT2E.6T2n(a,b,i,j)abab <-   sum(m-a)    [ T1o(m,a)aa . R2(b,m,i,j)abab ]
c
cT2E.6.1    M4(m,i,j) <- M2(m,e,f) . V2(e,f,i,j)
       call mult (wrk,wrksize,
     & 3,4,3,2,
     & mapdm2,mapim2,syma,mapdv2,mapiv2,1,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cT2E.6.2    M3(a,i,j) <- T1o(a,m)aa . M4(m,i,j)
       call mult (wrk,wrksize,
     & 2,3,3,1,
     & mapdt11,mapit11,1,mapdm4,mapim4,syma,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cT2E.6.3    T2n(a,b,i,j)abab <- -1.0d0 M3(a,i,j)
       call add (wrk,wrksize,
     & 3,4,1,2,a,0,syma,1,-1.0d0,
     & mapdm3,ssm3,mapdt23,mapit23,1,rc)
cparend
       end if
c
c     ------- cont to W32
cW32.3WIII(m,e,b,j)aabb <- + sum(f-b) [  <mb||ef>abab . T1o(f,j)bb ]
cW32.4WIII(m,e,b,j)abba <- - sum(f-a) [  <mb||fe>abab . T1o(f,j)aa ]
c
cpar
        if (myRank.eq.idaabb) then
cW32.3.1    M4(m,e,j) = M2(m,e,f) . T1o(f,j)bb
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm2,mapim2,syma,mapdt12,mapit12,1,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cW32.3.2    H3(W3aabb)(m,e,j) <- 1.0d0 M4(m,e,j)
       call add (wrk,wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0,
     & mapdm4,syma,mapdh3,mapih3,syma,rc)
c
cW3.3 write W3aabb(m,e,j) to  lunw3baab file if size is not zero
       if (h3lenght.gt.0) then
       call wri (lunw3aabb,h3lenght,wrk(possh30))
       end if
cparend
        end if
c
c
cpar
        if (myRank.eq.idabba) then
cW32.4.1    M4(m,e,f) <- M2(m,f,e)
       call map (wrk,wrksize,
     & 3,1,3,2,0,
     & mapdm2,mapim2,syma,mapdm4,mapim4,possm40,posst,rc)
c
cW32.4.2    M3(m,e,j) <- M4(m,e,f) . T1o(f,j)aa
       call mult (wrk,wrksize,
     & 3,2,3,1,
     & mapdm4,mapim4,syma,mapdt11,mapit11,1,mapdm3,mapim3,ssm3,
     & possm30,rc)
c
cW32.4.3    H2(W3abba)(m,e,j) <- -1.0d0 M3(m,e,j)
       call add (wrk,wrksize,
     & 3,3,0,0,0,0,1,1,-1.0d0,
     & mapdm3,syma,mapdh2,mapih2,syma,rc)
c
cW3.4 write W3abba(m,e,j) to  lunw3baba file if size is not zero
       if (h2lenght.gt.0) then
       call wri (lunw3abba,h2lenght,wrk(possh20))
       end if
cparend
        end if
c
c     ------- cont to FI3
cpar
        if (myRank.eq.idaabb) then
cF13.4FI(a,e)bb <-  sum(m,f-aa) [ <ma||fe>abab . T1o(f,m)aa ]
c
cF13.4.1    M3(e,f,m) <- M2(m,f,e)
       call map (wrk,wrksize,
     & 3,3,2,1,0,
     & mapdm2,mapim2,syma,mapdm3,mapim3,possm30,posst,rc)
c
cF13.4.2    M4(e)     <- M1(e,f,m) . T1o(f,m)aa
       call mult (wrk,wrksize,
     & 3,2,1,2,
     & mapdm3,mapim3,syma,mapdt11,mapit11,1,mapdm4,mapim4,ssm4,
     & possm40,rc)
c
cF13.4.3    F1(a,e)bb <- -1.0d0 M4(e)
       call add (wrk,wrksize,
     & 1,2,1,1,a,0,syma,1,1.0d0,
     & mapdm4,syma,mapdf12,mapif12,1,rc)
       end if
cparend
        end if
c
 5500   continue
c
 6000   continue
c
cC.9  close n1abeta,n2abeta
       call filemanager (3,n1abeta,rc)
       call filemanager (3,n2abeta,rc)
cparend
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine loopstr0_cvb(iocc,indx,nel,norb)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nel, norb
integer(kind=iwp), intent(out) :: iocc(nel), indx
integer(kind=iwp) :: iel

if (nel > norb) then
  write(u6,*) ' Error in loopstr0, nel > norb :',nel,norb
  call abend_cvb()
end if
indx = 1
do iel=1,nel
  iocc(iel) = iel
end do

return

end subroutine loopstr0_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine GetDens_Localisation(Dens,CMO,nBas,nOcc)
! Author: T.B. Pedersen
!
! Purpose: compute density from CMOs as Dens = CMO * (CMO)^T

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBas, nOcc
real(kind=wp), intent(out) :: Dens(nBas,nBas)
real(kind=wp), intent(in) :: CMO(nBas,nOcc)
integer(kind=iwp) :: nTBs

nTBs = max(nBas,1)
call DGEMM_('N','T',nBas,nBas,nOcc,One,CMO,nTBs,CMO,nTBs,Zero,Dens,nTBs)

end subroutine GetDens_Localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LToSph(F,nalpha,ishll,la,iAng,nvecac)
*******************************************************************************
*
*   Transform <A|core> from Cartesian components to Sperical harmonics
*
*              Observe that as opposed to the projection operator that this
*              contraction is done in the primitive basis.
*
*******************************************************************************
*    @parameter F  The cartesian components of <A|core>(in)
*                  The spherical components of <A|core>(out)

*    @parameter nAlpha Number of exponents
*    @parameter ishll Shell number for ECP
*    @parameter la angular momenta LS
*    @parameter iAng angular momenta core
*    @parameter Number of derivatives
*******************************************************************************
*
      use Basis_Info
      use Real_Spherical
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"
      Dimension F(*)

      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*******************************************************************************
*
      nExpi=Shells(iShll)%nExp
      nac=nelem(la)*nelem(iang)
      Call Getmem('TMP1','ALLO','REAL',iptmp,
     &             nExpi*nac*nVecAC*nalpha)
      Call Getmem('TMP2','ALLO','REAL',ipF,
     &             nExpi*nac*nVecAC*nalpha)


      Call DgeTMo(F,nAlpha*nExpi*nElem(la),
     &            nAlpha*nExpi*nElem(la),
     &            nElem(iAng)*nVecAC,Work(ipTmp),
     &            nElem(iAng)*nVecAC)
*
*--------------2) xika,C = c,xika * c,C
*
      Call DGEMM_('T','N',
     &            nVecAC*nAlpha*nExpi*nElem(la),
     &            (2*iAng+1),nElem(iAng),
     &            1.0d0,Work(ipTmp),nElem(iAng),
     &            RSph(ipSph(iAng)),nElem(iAng),
     &            0.0d0,Work(ipF),
     &            nVecAC*nAlpha*nExpi*nElem(la))
*
*--------------3) x,ikaC -> ikaC,x
*
      Call DGetMo(Work(ipF),nVecAC,nVecAC,
     &            nAlpha*nExpi*nElem(la)*(2*iAng+1),
     &            Work(ipTmp),
     &            nAlpha*nExpi*nElem(la)*(2*iAng+1))
      call dcopy_(nVecAC*
     &           nAlpha*nExpi*nElem(la)*(2*iAng+1),
     &           Work(ipTmp),1,F,1)
*
      Call Getmem('TMP1','FREE','REAL',iptmp,
     &             nExpi*nac*nVecAC*nalpha)
      Call Getmem('TMP2','FREE','REAL',ipF,
     &             nExpi*nac*nVecAC*nalpha)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_t2sym()
! chek T2c symmetry abij = baji

use chcc_global, only: no, nv, T2c
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: a, b, bad, i, j

bad = 0
do j=1,no
  do i=1,no
    do b=1,nv
      do a=1,nv
        if (abs(T2c(a,b,i,j)-T2c(b,a,j,i)) > 1.0e-10_wp) bad = bad+1
      end do
    end do
  end do
end do

write(u6,*) ' T2 Symm Check: ',bad

return

end subroutine Chck_t2sym

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! Module for second order update info
!
!     iterso   - second order iteration number
!              - comes into play
!     MemRsv   - memory kept unallocated in LList management
!     QNRTh    - threshold for QNR/C2Diis startup
!     DltNTh   - convergence threshold for Norm of delta
!     DltNrm   - actual Norm of delta after QNR/C2Diis extrapolation

Module InfSO

Integer :: iterso=0
Integer :: MemRsv=0
Real*8  :: QNRTh = 0.075d+00
Real*8  :: DltNTh= 0.2d-4
Real*8  :: DltNrm= 0.0D0

End Module InfSO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PCM_Init(iPrint,ICharg,NAtm,ToAng,
     &                    AtmC,IAtm,LcAtmC,LcIAtm,nIrrep,NonEq)
      use PCM_arrays
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "rctfld.fh"
#include "status.fh"
      Real*8 AtmC(3,NAtm),LcAtmC(3,NAtm)
      Integer IAtm(NAtm),LcIAtm(NAtm)
      Logical NonEq
      Dimension RJunk(1)
      Real*8, Allocatable:: Xs(:), Ys(:), Zs(:), Rs(:)
      Integer, Allocatable:: pNs(:), VTS(:)
*
*     Build the cavity.
*     Write the input file for GeomView.
*     Form the PCM matrix.
*
*     Possibly print parameter values
      If(iPrint.ge.99) Then
        write(6,'(''PCM parameters'')')
        Do 10 I = 1, 100
          write(6,'(''ISlpar('',i3,'') ='',i6)')I, ISlPar(I)
   10   Continue
        Do 20 I = 1, 100
          write(6,'(''RSlpar('',i3,'') ='',F8.3)')I, RSlPar(I)
   20   Continue
      EndIf
*
*---- Recover solvent data
*
      Call DataSol(ISlPar(15))
*
*     It is necessary to avoid spurious "atoms" which can cause errors
*     in UATM: then let's copy only the real atoms on local arrays
*     of coordinates and atomic numbers.
*
      LcI = 0
      Do 30 I = 1, NAtm
        If(IAtm(I).gt.0) then
          LcI = LcI + 1
          LcAtmC(1,LcI) = AtmC(1,I)
          LcAtmC(2,LcI) = AtmC(2,I)
          LcAtmC(3,LcI) = AtmC(3,I)
          LcIAtm(LcI)   = IAtm(I)
        EndIf
   30 Continue
      LcNAtm = LcI
      ISlPar(42) = LcNAtm
*
*---- Define atomic/group spheres
*     Allocate space for X, Y, Z, Radius and NOrd for MxSph spheres
*
      Call mma_allocate(Xs,MxSph,Label='Xs')
      Call mma_allocate(Ys,MxSph,Label='Ys')
      Call mma_allocate(Zs,MxSph,Label='Zs')
      Call mma_allocate(Rs,MxSph,Label='Rs')
      Call mma_allocate(pNs,MxSph,Label='pNs')
      pNs(:)=0
*
      NSinit = 0
      Call FndSph(LcNAtm,ICharg,ToAng,LcAtmC,LcIAtm,ISlPar(9),
     &            ISlPar(14),RSlPar(9),Xs,Ys,Zs,Rs,pNs,iPrint)
*
*---- Define surface tesserae
*
      Call FndTess(iPrint,ToAng,LcNAtm,Xs,Ys,Zs,Rs,pNs,MxSph)
*
      Call mma_deallocate(pNs)
      Call mma_deallocate(Rs)
      Call mma_deallocate(Zs)
      Call mma_deallocate(Ys)
      Call mma_deallocate(Xs)
*
*---- Prepare an input file for GeomView visualization tool
*
      Call mma_allocate(VTS,MxVert*nTs,Label='VTS')
      Call GVWrite(1,nTs,NSinit,LcNAtm,LcAtmC,LcIAtm,PCMSph,
     &             PCMTess,NVert,Vert,PCMiSph,RJunk,VTS,MxVert)
      Call mma_deallocate(VTS)

*
*---- If needed compute the geometrical derivatives
*
      If(DoDeriv) then
        RSolv = RSlPar(19)
        Call Deriva(0,ToAng,LcNAtm,nTs,nS,nSInit,RSolv,PCMTess,Vert,
     &              Centr,PCMSph,PCMiSph,IntSph,PCM_N,NVert,
     &              NewSph,DTes,dPnt,dRad,dCntr)
      EndIf
*
*---- Compute cavitation energy
*
      TAbs = RSlPar(16)
      Call Cavitation(DoDeriv,ToAng,LcNAtm,NS,nTs,RSlPar(46),VMol,TAbs,
     &                TCE,RSolv,PCMSph,PCMTess,PCMiSph)
*
*---- Define PCM matrix: the inverse is stored in PCMDM
*
      nTs2 = nTs * nTs
c     LenScr = 2 * nTs
      Call GetMem('SMat','Allo','Real',ip_SM,nTs2)
      Call GetMem('SDMat','Allo','Real',ip_SDM,nTs2)
      Call GetMem('TMat','Allo','Real',ip_TM,nTs2)
      Call GetMem('RMat','Allo','Real',ip_RM,nTs2)
      If (NonEq) Then
         Eps_=EpsInf
      Else
         Eps_=Eps
      End If
      Call MatPCM(nTs,Eps_,Conductor,PCMiSph,PCMSph, PCMTess,PCMDM,
     &            Work(ip_SM),Work(ip_SDM),Work(ip_TM),Work(ip_RM))
      Call GetMem('RMat','Free','Real',ip_RM,nTs2)
      Call GetMem('TMat','Free','Real',ip_TM,nTs2)
      Call GetMem('SDMat','Free','Real',ip_SDM,nTs2)
      Call GetMem('SMat','Free','Real',ip_SM,nTs2)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nIrrep)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_map41 (a,b,dimp,dimq,dimr,dims,p,q,r,s,nfact)
c
c     maping A(p1,q1,r1,s1) -> nfact* B(p2,q2,r2,s2)
c
       real*8 a(*)
       real*8 b(*)
       integer dim(4)
       integer dimp,dimq,dimr,dims,p,q,r,s,nfact
       dim(p)=dimp
       dim(q)=dimq
       dim(r)=dimr
       dim(s)=dims
       call cct3_map42 (a,b,dimp,dimq,dimr,dims,dim(1),dim(2),dim(3),
     & dim(4),p,q,r,s,nfact)
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Bjorn O. Roos                                    *
!               2008, Valera Veryazov                                  *
!***********************************************************************

subroutine expbas(ireturn)
!***********************************************************************
!                                                                      *
!     Objective: Expand MOs to larger basis set                        *
!                                                                      *
!     B. O. Roos, University of Lund, April 2008.                      *
!                                                                      *
!***********************************************************************

use info_expbas_mod, only: EB_FileOrb, LenIn, mxsym, n_orb_kinds
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: i, ib1, ib2, iErr, iLen, ind, ishift, ist1, ist2, iSym, Lu_, LuInpOrb, nb1, nb2, nDim1, nDim2, nSym1, nSym2, &
                     nTot1, nTot2, nBas1(mxsym), nBas2(mxsym)
character(len=80) :: VecTit
character(len=512) :: FName
logical(kind=iwp) :: Exist_1, Exist_2, okay
integer(kind=iwp), allocatable :: indt1(:), indt2(:), IndType(:)
real(kind=wp), allocatable :: CMO1(:), CMO2(:), Eorb1(:), Eorb2(:), Occ1(:), Occ2(:)
character(len=LenIn+8), allocatable :: Bas1(:), Bas2(:)

!----------------------------------------------------------------------*
!     Read information from Runfile 1                                  *
!----------------------------------------------------------------------*
FName = 'RUNFIL1'
iLen = len_trim(FName)
call f_Inquire(FName(:iLen),Exist_1)
if (.not. Exist_1) then
  write(u6,*) 'Error finding file '//FName(:iLen)
  call Abend()
end if
call namerun(FName(:iLen))
call get_iScalar('nSym',nSym1)
call Get_iArray('nBas',nBas1,nSym1)
nDim1 = 0
nTot1 = 0
do iSym=1,nSym1
  nDim1 = nDim1+nBas1(iSym)
  nTot1 = nTot1+nBas1(iSym)**2
end do
call mma_allocate(Bas1,nDim1,label='Bas1')
call Get_cArray('Unique Basis Names',Bas1,(Lenin+8)*nDim1)
!----------------------------------------------------------------------*
!     Read information from Runfile 2                                  *
!----------------------------------------------------------------------*
FName = 'RUNFIL2'
iLen = len_trim(FName)
call f_Inquire(FName(:iLen),Exist_2)
if (.not. Exist_2) then
  write(u6,*) 'Error finding file '//FName(:iLen)
  call Abend()
end if
call namerun(FName(:iLen))
call get_iScalar('nSym',nSym2)
call Get_iArray('nBas',nBas2,nSym2)
nDim2 = 0
nTot2 = 0
do iSym=1,nSym2
  nDim2 = nDim2+nBas2(iSym)
  nTot2 = nTot2+nBas2(iSym)**2
end do
call mma_allocate(Bas2,nDim2,label='Bas2')
call Get_cArray('Unique Basis Names',Bas2,(LenIn+8)*nDim2)
!----------------------------------------------------------------------*
!     Read MO coefficients from a formatted vector file                *
!----------------------------------------------------------------------*
call mma_allocate(CMO1,nTot1,label='CMO1')
call mma_allocate(Eorb1,nDim1,label='Eorb1')
call mma_allocate(Occ1,nDim1,label='Occ1')
call mma_allocate(indt1,nDim1,label='indt1')
call mma_allocate(CMO2,nTot2,label='CMO2')
call mma_allocate(Eorb2,nDim2,label='Eorb2')
call mma_allocate(Occ2,nDim2,label='Occ2')
call mma_allocate(indt2,nDim2,label='indt2')
FName = EB_FileOrb
if (len_trim(FName) == 0) FName = 'INPORB'
iLen = len_trim(FName)
call f_Inquire(FName(:iLen),okay)
if (okay) then
  LuInpOrb = 50
  call RdVec(FName(:iLen),LuInpOrb,'COEI',nSym1,nBas1,nBas1,CMO1,Occ1,Eorb1,indt1,VecTit,1,iErr)
else
  write(u6,*) 'RdCMO: Error finding MO file'
  call Abend()
end if

!----------------------------------------------------------------------*
!     Print and check input information                                *
!----------------------------------------------------------------------*
!write(u6,910) 'Start of option expand.'
write(u6,930) trim(Vectit)
write(u6,910) 'Information from input runfile'
write(u6,920) 'Number of symmetries',nSym1
write(u6,920) 'Number of basis functions',(nBas1(i),i=1,nSym1)
write(u6,910) 'Information from expanded basis set runfile'
write(u6,920) 'Number of symmetries',nSym2
write(u6,920) 'Number of basis functions',(nBas2(i),i=1,nSym2)
! Check for inconsistensies:
if (nSym1 /= nSym2) then
  write(u6,*) 'Symmetries are not equal. Stop here',nSym1,nSym2
  call Abend()
end if
do isym=1,nSym1
  if (nBas1(isym) > nBas2(isym)) then
    write(u6,*) 'Second basis set must be larger than first'
    write(u6,*) 'not fulfilled in sym',isym,'basis functions are',nBas1(isym),nBas2(isym)
    call Abend()
  end if
end do
!----------------------------------------------------------------------*
!     Build the new orbitals                                           *
!----------------------------------------------------------------------*
ist1 = 1
ist2 = 1
ib1 = 1
ib2 = 1
do isym=1,nsym1
  nb1 = nBas1(isym)
  nb2 = nBas2(isym)
  if (nb2 > 0) then
    call expandbas(Bas1(ib1),nb1,Bas2(ib2),nb2,CMO1(ist1),CMO2(ist2),Occ1(ib1),Eorb1(ib1),indt1(ib1), &
                                                                     Occ2(ib2),Eorb2(ib2),indt2(ib2))
    ist1 = ist1+nb1**2
    ist2 = ist2+nb2**2
    ib1 = ib1+nb1
    ib2 = ib2+nb2
  end if
end do
call mma_deallocate(Bas1)
call mma_deallocate(Bas2)
!----------------------------------------------------------------------*
!     Write the new orbitals in to the file EXPORB                     *
!----------------------------------------------------------------------*
! First resort indt to standard
call mma_allocate(IndType,nSym2*n_orb_kinds,label='IndType')
IndType(:) = 0
ind = 0
ishift = 0
do isym=1,nSym2
  nb2 = nBas2(isym)
  if (nb2 /= 0) then
    do ib2=1,nb2
      ind = ind+1
      IndType(ishift+indt2(ind)) = IndType(ishift+indt2(ind))+1
    end do
  end if
  ishift = ishift+n_orb_kinds
end do

VecTit = 'Basis set expanded orbital file EXPORB'
Lu_ = 60
call WRVEC('EXPORB',LU_,'COEI',nSym2,nBas2,nBas2,CMO2,Occ2,Eorb2,IndType,VecTit)
write(u6,*) 'New orbitals have been built in file EXPORB'
!----------------------------------------------------------------------*
!     Normal termination                                               *
!----------------------------------------------------------------------*
call mma_deallocate(CMO1)
call mma_deallocate(Eorb1)
call mma_deallocate(Occ1)
call mma_deallocate(indt1)
call mma_deallocate(CMO2)
call mma_deallocate(Eorb2)
call mma_deallocate(Occ2)
call mma_deallocate(indt2)
call mma_deallocate(IndType)

ireturn = 0

return

910 format(/1x,a)
920 format(1x,a30,8i5)
930 format(/1x,'Header on input orbitals file:'/a)

end subroutine expbas

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_INTCHK_REG(LABEL,ISHLCD,ISHLAB)
!
! Purpose: register a shell quadruple (CD|AB) for minimal integral
!          check using LABEL to keep track of its origin.

use Cholesky, only: iChkq, iSP2F, nChkq, nnShl
use Definitions, only: iwp

implicit none
character(len=8), intent(in) :: LABEL
integer(kind=iwp), intent(in) :: ISHLCD, ISHLAB
integer(kind=iwp) :: ID, ISHLA, ISHLB, ISHLC, ISHLD
character(len=8) :: LAB
character(len=*), parameter :: SECNAM = 'CHO_INTCHK_REG'

! Check shell pair index.
! -----------------------

if ((ISHLCD < 1) .or. (ISHLCD > NNSHL)) call CHO_QUIT('Shell index error 1 in '//SECNAM,103)
if ((ISHLAB < 1) .or. (ISHLAB > NNSHL)) call CHO_QUIT('Shell index error 2 in '//SECNAM,103)

! Registration.
! -------------

call CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.true.)
call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)
LAB = LABEL
call CHO_INTCHK_ID_OF(LAB,ID,1)
if ((ID < 1) .or. (ID > NCHKQ)) ID = NCHKQ+1 ! junk yard
ICHKQ(1,ID) = ISHLC
ICHKQ(2,ID) = ISHLD
ICHKQ(3,ID) = ISHLA
ICHKQ(4,ID) = ISHLB

end subroutine CHO_INTCHK_REG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Per-Olof Widmark                                 *
*               1993,1996,1997, Markus P. Fuelscher                    *
*               1996, Luis Serrano-Andres                              *
*               2001, Roland Lindh                                     *
*               2016, Steven Vancoillie                                *
************************************************************************
      Subroutine bDaFile(Lu,iOpt,Buf,lBuf,iDisk)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Control direct access I/O operations                             *
*                                                                      *
*     calling arguments:                                               *
*     Lu      : integer, input                                         *
*               logical unit number (Lu={1,2,...40,50,60,70,80,90}     *
*               If Lu={40,50,60,70,80,90} we are possibly concerned    *
*               with a multi file unit (c.f. allocdisk)                *
*     iOpt    : integer, input                                         *
*               option code                                            *
*               iOpt= 0 dummy write                                    *
*               iOpt= 99 dummy read (return buf(1)=1 in success        *
*               iOpt= 1 synchronous write                              *
*               iOpt= 2 synchronous read                               *
*               iOpt= 5 synchronous rewind                             *
*               iOpt= 6 asynchronous write                             *
*               iOpt= 7 asynchronous read                              *
*               iOpt=10 asynchronous rewind                            *
*               Note: At present the asynchronous modes are not        *
*                     supported and work identically the synchronous   *
*                     modes                                            *
*     Buf     : array of characters, input/output                      *
*               Buffer carrying/receiving the data to write/read       *
*     lBuf    : integer, input                                         *
*               length of the buffer Buf in bytes!!!                   *
*     iDisk   : integer, input/output                                  *
*               disk address as byte offset!!!                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, IBM Sweden, 1991                                   *
*     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
*     L. Serrano-Andres, University of Lund, Sweden, 1996              *
*     R. Lindh, University of Lund, Sweden, 2001                       *
*     Steven Vancoillie: use of byte lengths/offests (2016)            *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

#include "SysDef.fh"
#include "blksize.fh"
#include "fio.fh"

      Character Buf(*)


      If ( Trace ) then
        Write (6,*) ' >>> Enter bDaFile <<<'
        Write (6,*) ' unit      :',Lu
        Write (6,*) ' name      :',LuName(Lu)
        Write (6,*) ' option    :',iOpt
        Write (6,*) ' length    :',lBuf
        Write (6,*) ' disk adr. :',iDisk
      End If

      If((iOpt.eq.5).or.(iOpt.eq.10)) then
        Addr(Lu)   = 0
        iDisk      = 0
        goto 1100
C*     Get filesize in 8-byte units
      Else If (iOpt.eq.0) Then
C*     Dummy write. No I/O is made. Disk address is updated.
        Addr(Lu)   = iDisk+lBuf
        iDisk      = Addr(Lu)
        goto 1100
      Else If ( iOpt.eq.8 ) then
        iRc=AixFsz(FSCB(Lu))
        iDisk=iRc
        goto 1100
      End If

      If ( Multi_File(Lu) .and. MaxFileSize.ne.0 ) then
         jDisk       = iDisk
         kDisk       = iDisk
         Call MpDaFile(Lu,MaxFileSize,iOpt,Buf,lBuf,kDisk)
         Addr(Lu)    = jDisk+lBuf
         iDisk       = Addr(Lu)
      Else
         Call ChDaFile(Lu,iOpt,Buf,lBuf,iDisk)
      End If

1100  Continue
      If ( Trace ) Write (6,*) ' >>> Exit bDaFile <<<'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gugadrt_active_drt()

use gugadrt_global, only: iseg_sta, iseg_downwei, jpad_upwei, jd, jj, js, jt, jv, logic_mr, logic_mrelcas, max_node, mxnode, &
                          nci_dim, ng_sm, no, norb_act, norb_inn, nu_ad, nu_ae
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i, im, indd, iseg_dim(25), jde, jdim, jdn, jds, jji, jp, jpe, jpn, jsim, jtim, ndd, ndi, ndim
integer(kind=iwp), allocatable :: iin(:)

iseg_dim = 0
nci_dim = 0
if (norb_act == 0) then
  !====================  norb_act=0 ========================
  iseg_sta(1) = 0
  iseg_dim(1) = 1
  do im=1,ng_sm
    jdim = nu_ae(1+im)
    jtim = nu_ae(9+im)
    jsim = nu_ae(17+im)
    jd(im) = jdim
    jt(im) = jtim
    js(im) = jsim
    iseg_dim(jdim) = iseg_downwei(jdim)*jpad_upwei(jdim)
    iseg_dim(jtim) = iseg_downwei(jtim)*jpad_upwei(jtim)
    iseg_dim(jsim) = iseg_downwei(jsim)*jpad_upwei(jsim)
    if (iseg_dim(jdim) == 0) then
      jd(im) = 0
      nu_ad(jdim) = 0
      nu_ae(jdim) = 0
    end if
    if (iseg_dim(jtim) == 0) then
      jt(im) = 0
      nu_ad(jtim) = 0
      nu_ae(jtim) = 0
    end if
    if (iseg_dim(jsim) == 0) then
      js(im) = 0
      nu_ad(jsim) = 0
      nu_ae(jsim) = 0
    end if
  end do
  do jp=2,25
    iseg_sta(jp) = iseg_sta(jp-1)+iseg_dim(jp-1)
  end do
  nci_dim = iseg_sta(25)+iseg_dim(25)
  iseg_sta(26) = nci_dim
else
  !====================  norb_act<>0 ========================
  if (logic_mr) call gugadrt_rst(ndd,indd)
  if (logic_mrelcas) call gugadrt_rcas(ndd,indd) !npp=3

  nu_ae(1) = jv
  do im=1,ng_sm
    nu_ae(1+im) = jd(im)
    nu_ae(9+im) = jt(im)
    nu_ae(17+im) = js(im)
  end do
  jds = 1
  jde = mxnode
  jpe = no(norb_inn+1)

  call mma_allocate(iin,[0,max_node],label='iin')
  iin(1:max_node) = 0
  jp = jv
  iin(1:jpe) = 0
  iin(0) = 0
  iin(jp) = 1
  iseg_sta(1) = 0 ! for node_ext
  do jpn=jpe,1,-1
    do i=1,4
      jji = jj(i,jpn)
      if (iin(jji) == 0) cycle
      iin(jpn) = iin(jpn)+iin(jji)
    end do
  end do

  do jdn=jds,jde
    if (nu_ad(jdn) == 0) cycle
    ndi = iin(jdn)*iseg_downwei(1)*jpad_upwei(jdn)
    iseg_dim(1) = iseg_dim(1)+ndi
  end do

  do im=1,ng_sm
    jp = jd(im)
    iseg_sta(1+im) = nci_dim ! for node_d_ext
    if (jp == 0) cycle
    iin(1:jpe) = 0
    iin(0) = 0
    iin(jp) = 1
    do jpn=jpe,1,-1
      do i=1,4
        jji = jj(i,jpn)
        if (iin(jji) == 0) cycle
        iin(jpn) = iin(jpn)+iin(jji)
      end do
    end do
    do jdn=jds,jde
      if (nu_ad(jdn) == 0) cycle
      ndi = iin(jdn)*iseg_downwei(1+im)*jpad_upwei(jdn)
      iseg_dim(1+im) = iseg_dim(1+im)+ndi
    end do
  end do

  do im=1,ng_sm
    jp = jt(im)
    iseg_sta(9+im) = nci_dim ! for node_t_ext
    if (jp == 0) cycle
    iin(1:jpe) = 0
    iin(0) = 0
    iin(jp) = 1
    do jpn=jpe,1,-1
      do i=1,4
        jji = jj(i,jpn)
        if (iin(jji) == 0) cycle
        iin(jpn) = iin(jpn)+iin(jji)
      end do
    end do
    do jdn=jds,jde
      if (nu_ad(jdn) == 0) cycle
      ndi = iin(jdn)*iseg_downwei(9+im)*jpad_upwei(jdn)
      iseg_dim(9+im) = iseg_dim(9+im)+ndi
    end do
  end do
  do im=1,ng_sm
    jp = js(im)
    iseg_sta(17+im) = nci_dim ! for node_s_ext
    if (jp == 0) cycle
    iin(1:jpe) = 0
    iin(0) = 0
    iin(jp) = 1
    do jpn=jpe,1,-1
      do i=1,4
        jji = jj(i,jpn)
        if (iin(jji) == 0) cycle
        iin(jpn) = iin(jpn)+iin(jji)
      end do
    end do
    do jdn=jds,jde
      if (nu_ad(jdn) == 0) cycle
      ndi = iin(jdn)*iseg_downwei(17+im)*jpad_upwei(jdn)
      iseg_dim(17+im) = iseg_dim(17+im)+ndi
    end do
  end do
  do jp=2,25
    iseg_sta(jp) = iseg_sta(jp-1)+iseg_dim(jp-1)
  end do
  nci_dim = iseg_sta(25)+iseg_dim(25)
  iseg_sta(26) = nci_dim
  call mma_deallocate(iin)
end if
! to the end of dbl,act,ext parts
call gugadrt_dbl_downwalk()
!write(u6,*) '  end of drt,nci_dim= ',nci_dim
!write(u6,*) 'number of cfss: ',nci_dim
write(u6,*)
write(u6,*) '-----------------------------------------------'
write(u6,*) '    csf information'
write(u6,*) '    num. of configurations:        ',nci_dim
ndim = iseg_dim(1)
write(u6,*) '    num. of valence states:        ',ndim
ndim = 0
do i=2,9
  ndim = ndim+iseg_dim(i)
end do
write(u6,'(5x,a32,1x,i12)') 'num. of doublet couple singles: ',ndim
ndim = 0
do i=10,17
  ndim = ndim+iseg_dim(i)
end do
write(u6,'(5x,a32,1x,i12)') 'num. of triplet couple doubles: ',ndim
ndim = 0
do i=18,25
  ndim = ndim+iseg_dim(i)
end do
write(u6,'(5x,a32,1x,i12)') 'num. of singlet couple doubles: ',ndim
write(u6,*) '-----------------------------------------------'

return

end subroutine gugadrt_active_drt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE ONEEL_GUGA()
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "real_guga.fh"
#include "integ.fh"
#include "files_guga.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
*
      IOUT=0
      NMAT=0
      ITYP=0
      DO 10 NK=1,LN
      DO 20 NI=1,NK
      K=ICH(NK)
      I=ICH(NI)
      IF(K.GT.I)GO TO 19
      K=ICH(NI)
      I=ICH(NK)
19    NSK=NSM(K)
      KJS=IJ(K+1)+1
      KJL=IJ(K)
      NSI=NSM(I)
      IF(NSI.NE.NSK)GO TO 20
      IOUT=IOUT+1
      ICOP1(IOUT)=0
      IF(IOUT.LT.NBUF)GO TO 460
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
460   IOUT=IOUT+1
*      ICOP1(IOUT)=I+2**10*K
      ICOP1(IOUT)=IOR(I,ISHFT(K,10))
      IF(IOUT.LT.NBUF)GO TO 21
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
21    IF(I.EQ.K)GO TO 20
      DO 101 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      DO 30 J=KJS,KJL
      IWAY(K)=1
32    KM=K
      J2(KM+1)=J
      J1(KM+1)=J
      CALL LOOP1(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 30
41    KM=KM-1
      IWAY(KM)=1
      IF(KM.EQ.I)GO TO 51
42    CALL LOOP5(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 41
      KM=KM+1
      IF(KM.EQ.K)GO TO 32
      GO TO 42
51    IWAY(I)=1
52    KM=I
      CALL LOOP3(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 53
      CALL COMP(I,J,ITYP,I,IT1,IT2)
      GO TO 52
53    KM=KM+1
      IF(KM.EQ.K)GO TO 32
      GO TO 42
30    CONTINUE
101   CONTINUE
20    CONTINUE
10    CONTINUE
      ICOP1(nCOP+1)=IOUT
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+IOUT
      ICOP1(nCOP+1)=-1
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      WRITE(IW,100)NMAT
100   FORMAT(/6X,'COEFFICIENTS FOR IJ',I11)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine cnfprint_cvb()

use casvb_global, only: ipr, nconf, nconf_fr, ndetvb_fr, nel, nel_fr, nfrag, noe, norb, nvbr_fr, recinp
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: idum(1), ifrag, ioffs, nconf_off
integer(kind=iwp), allocatable :: scr(:)
logical(kind=iwp), external :: recinpcmp_cvb, up2date_cvb ! ... Make: up to date? ...

if (recinpcmp_cvb(4)) call touch_cvb('CNFPRINT')

if ((ipr(1) >= 0) .and. (.not. up2date_cvb('CNFPRINT'))) then
  call mma_allocate(scr,max(noe,noe*nconf),label='scr')
  call rdioff_cvb(1,recinp,ioffs)
  call rdis_cvb(idum,1,recinp,ioffs)
  !noe1 = idum(1)
  call rdis_cvb(idum,1,recinp,ioffs)
  !nconf1 = idum(1)
  call rdis_cvb(idum,1,recinp,ioffs)
  !kbasiscvb1 = idum(1)
  call rdis_cvb(scr,noe*nconf,recinp,ioffs)
  if (nconf == 0) then
    scr(1:min(nel,norb)) = 1
    scr(1:nel-norb) = 2
  end if
  nconf_off = 0
  do ifrag=1,nfrag
    if (nfrag > 1) write(u6,'(/,a,i3)') ' Configuration list for wavefunction fragment',ifrag
    write(u6,'(/,a)') ' Spatial VB configurations'
    write(u6,'(a)') ' -------------------------'
    write(u6,'(a)') '     Conf. =>   Orbitals'
    call cnfprt_cvb(scr(noe*nconf_off+1),nconf_fr(ifrag),nel_fr(ifrag))
    write(u6,'(/,a,i6)') ' Number of VB configurations :',nconf_fr(ifrag)
    write(u6,'(a,i6)') '           VB structures     :',nvbr_fr(ifrag)
    write(u6,'(a,i6)') '           VB determinants   :',ndetvb_fr(ifrag)
    nconf_off = nconf_off+nconf_fr(ifrag)
  end do
  call mma_deallocate(scr)
  call make_cvb('CNFPRINT')
end if

return

end subroutine cnfprint_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Logical Function LDF_CheckIntegrals_JK_2P(Tol,Silent)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: check symmetry of integrals (J_AB | K_CD).
C              Returns .True. if symmetric (debug code).
C
      Implicit None
      Real*8  Tol
      Logical Silent
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBasAux_Pair
      External LDF_nBasAux_Pair

      Logical S
      Logical LDF_CheckIntegrals_JK_2P_

      Integer AB, CD
      Integer MAB, MCD
      Integer ip_ABCD, l_ABCD
      Integer ip_CDAB, l_CDAB
      Integer iCount

      iCount=0
      Do CD=1,NumberOfAtomPairs
         Do AB=CD,NumberOfAtomPairs
            ! Get auxiliary basis dimensions
            MAB=LDF_nBasAux_Pair(AB)
            MCD=LDF_nBasAux_Pair(CD)
            ! Allocate integral arrays
            l_ABCD=MAB*MCD
            l_CDAB=l_ABCD
            Call GetMem('CIJKABCD','Allo','Real',ip_ABCD,l_ABCD)
            Call GetMem('CIJKCDAB','Allo','Real',ip_CDAB,l_CDAB)
            ! Compute integrals
            Call LDF_ComputeIntegrals_JK_2P(AB,CD,l_ABCD,Work(ip_ABCD))
            Call LDF_ComputeIntegrals_JK_2P(CD,AB,l_CDAB,Work(ip_CDAB))
            ! Check symmetry
            S=LDF_CheckIntegrals_JK_2P_(MAB,MCD,
     &                                  Work(ip_ABCD),Work(ip_CDAB),
     &                                  Tol)
            If (.not.S) iCount=iCount+1
            If (.not.Silent) Then
               If (S) Then
                  Write(6,'(A,I9,1X,I9)')
     &            '(J|K) = (K|J) for atom pairs',AB,CD
               Else
                  Write(6,'(A,I9,1X,I9,A,I9,A)')
     &            '(J|K) != (K|J) for atom pairs',AB,CD,
     &            '(Error',iCount,')'
               End If
            End If
            ! Deallocate
            Call GetMem('CIJKCDAB','Free','Real',ip_CDAB,l_CDAB)
            Call GetMem('CIJKABCD','Free','Real',ip_ABCD,l_ABCD)
         End Do
      End Do

      ! Set return value
      LDF_CheckIntegrals_JK_2P=iCount.eq.0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Logical Function LDF_CheckIntegrals_JK_2P_(N,M,X,Y,Tol)
      Implicit None
      Integer N
      Integer M
      Real*8  X(N,M)
      Real*8  Y(M,N)
      Real*8  Tol

      Integer I, J

      LDF_CheckIntegrals_JK_2P_=.True.
      Do J=1,M
         Do I=1,N
            If (abs(X(I,J)-Y(J,I)).gt.Tol) Then
               LDF_CheckIntegrals_JK_2P_=.False.
               Return
            End If
         End Do
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Scan_Inp_m(iRc)
      Implicit Real*8 (A-H,O-Z)
* ------------------------------------------------------------
* Scan input lines after the '&MCPDFT' marker and until
* finding keyword 'END ' or the end of file.
* Keywords are identified according to file 'input_ras.fh'
* Logical flags in 'input_ras.fh' are set according to input.
* Return codes are _RC_ALL_IS_WELL_ or _RC_INPUT_ERROR_
* ------------------------------------------------------------
#include "rasdim.fh"
#include "warnings.fh"
#include "WrkSpc.fh"
#include "input_ras.fh"
#include "output_ras.fh"
      Parameter(ROUTINE='Scan_Inp')
*
      Character*4 Command
      Character*180  Line
      Character*180 Get_LN
      External Get_LN
*

* If the return code is already set to indicate an error, there will
* be an error trace written out.
* Also at very high print level, there will be an error trace.
!        goto 200
      if(IPRLOC(1).ge.DEBUG  .or. iRc.ne._RC_ALL_IS_WELL_) goto 200

*--Find keywords in input and set keyword flags
      Do I=0,NKeys
       KeyFlags(I)=.False.
      End Do
      Rewind(LuInput)
  10  Continue
      Read(LuInput,'(A)',End=9910,Err=9920) Line
      Command=Line(1:4)
      Call UpCase(Command)
      Do iCmd=1,NKeys
        If ( Command.eq.Cmd(iCmd) ) Then
         KeyFlags(iCmd)=.TRUE.
* Special case: Skip title line.
         If ( Command.eq.'TITL') Then
          Read(LuInput,'(A)',End=9910,Err=9920) Line
         End If
* SVC (ugly hack) Special case: Skip fileorb line. FIXME: we need a more
* robust input scanning method so that these things are not necessary
         If ( Command.eq.'FILE') Then
          Read(LuInput,'(A)',End=9910,Err=9920) Line
         End If
         GoTo 20
        End If
      End Do
  20  Continue
      If ( .not.KeyEND ) GoTo 10
      Go To 9990

 200  continue
* Similar functionality, but with written trace:
      Do I=0,NKeys
       KeyFlags(I)=.False.
      End Do
      write(6,*)' Scanning the input for keywords:'
      write(6,*)' Rewinding LUInput=',LUInput
      Rewind(LuInput)
      write(6,*)' OK after rewind.'
 210  Continue
      write(6,*)' Reading a line...'
      Read(LuInput,'(A)',End=9910,Err=9920) Line
      write(6,*)' '''//line(1:64)//' ...'''
      Command=Line(1:4)
      Call UpCase(Command)
      Do iCmd=1,NKeys
        If ( Command.eq.Cmd(iCmd) ) Then
          write(6,*)' Understood keyword '''//Cmd(iCmd)//''''
          KeyFlags(iCmd)=.TRUE.
* Special case: Skip title line.
          If ( Command.eq.'TITL') Then
           write(6,*)' Dummy read title line.'
           Read(LuInput,'(A)',End=9910,Err=9920) Line
          End If
          GoTo 220
        End If
      End Do
 220  Continue
      If ( .not.KeyEND ) GoTo 210
      Go To 9990

* Error exits ---------------------------------------
9910  CONTINUE
      write(6,*)' Tried to read a new line. Hit End of record.'
      write(6,*)' Last word was ',Command
      irc=_RC_INPUT_ERROR_
      GOTO 9990
*----------------------------------------------------
9920  CONTINUE
      write(6,*)' Tried, and failed, to read a new line.'
      write(6,*)' Last word was ',Command
      irc=_RC_INPUT_ERROR_
      GOTO 9990
*----------------------------------------------------
9990  CONTINUE
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
*                                                                      *
************************************************************************
      Subroutine SCF_Init()
************************************************************************
*                                                                      *
*     purpose: set up parameters that has to be predefined in SCF      *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
*
#include "mxdm.fh"
#include "file.fh"
#include "infscf.fh"
#include "infso.fh"
#include "llists.fh"
#include "twoswi.fh"
*
      Logical  Found, Reduce_Prt
      External Reduce_Prt
*
*----------------------------------------------------------------------*
*     Define files ( file names and unit numbers )                     *
*----------------------------------------------------------------------*
      LuOne = 10
      FnOne = 'ONEINT '
      LuOrd = 40
      FnOrd = 'ORDINT '
      LuOut = 20
      FnOut = 'SCFORB  '
      LuInp = 25
      LuDSt = 34
      FnDSt = 'DNSMAT  '
      LuOSt = 40
      FnOSt = 'DVXCDR  '
      LuTSt = 35
      FnTSt = 'TWOHAM  '
      LuGrd = 36
      FnGrd = 'GRADIENT'
      LuDGd = 37
      FnDGd = 'SODGRAD '
      Lux   = 38
      Fnx   = 'SOXVEC  '
      LuDel = 39
      FnDel = 'SODELTA '
      Luy   = 29
      Fny   = 'SOYVEC  '
*----------------------------------------------------------------------*
*     Initialize global variables                                      *
*----------------------------------------------------------------------*
      Call Peek_iScalar('nSym',nSym)
      nAtoms = 0
      Call ICopy(MxSym,[0],0,nBas,1)
      Call ICopy(MxSym,[0],0,nOrb,1)
      Call ICopy(MxSym*2,[0],0,nOcc,1)
      If(iUHF.eq.0) Then
         Call Put_iArray('nIsh',nOcc(1,1),nSym)
      Else
         Call Put_iArray('nIsh',nOcc(1,1),nSym)
         Call Put_iArray('nIsh beta',nOcc(1,2),nSym)
      Endif
      Call ICopy(MxSym,[0],0,nFro,1)
      Call Put_iArray('nFro',nFro,nSym)
      Call ICopy(MxSym,[0],0,nFrz,1)
      Call ICopy(MxSym,[0],0,nDel,1)
      Call qpg_iarray('nDel',Found,ndata)
      If (.not.Found) Then
         Call Put_iArray('nDel',nDel,nSym)
      End If
      Thize = 1.0d-6
      EThr  = 1.0d-9
C     DThr  = 1.0d-5
      DThr  = 1.0d-4
      Call Qpg_dScalar('S delete thr',Found)
      If(Found) Then
         Call Get_dScalar('S delete thr',DelThr)
      Else
         DelThr= 1.0d-5
         Call Put_dScalar('S delete thr',DelThr)
      End If
      DiisTh= 0.15d+00
      QNRTh = 0.075d+00
      DltNTh= 0.2d-4
C     FThr   =  0.5d-6
      FThr   =  1.5d-4
      QudThr = 1.0d-5
      Energy = 0.0D0
      E1     = 0.0D0
      E2     = 0.0D0
      EKin   = 0.0D0
      PotNuc = 0.0D0
      EneV = 0.0d0
      E1V  = 0.0d0
      E2V  = 0.0d0
      EKinV= 0.0d0
      OnlyProp=.false.
      NoProp=.false.
      FckAuf=.True.
*
* Order: SCF(0), Guessorb(1), Lumorb(2), Core(4)
* New order: SCF(0), Lumorb(2), Guessorb(1), Core(4)
*
      InVec   = 1
      Do i=1,nStOpt
         LstVec(i)=-1
      End Do
      LstVec(1)=0
      LstVec(2)=2
      LstVec(3)=1
      LstVec(4)=4
      nIter(0)= MxIter
      nIter(1)= MxIter
      nIterP  = 1
      iter    = 1
      iter0   = 0
      iterso  = 0
*
      iPrint=iPrintLevel(-1)
      jPrint=iPrint
      If (Reduce_Prt().and.iPrint.lt.3) jPrint=0
*
      iPrOrb = 1
      kIvo   = 0
      iUHF   = 0
      iROHF  = 0
      iCoCo = 0
      jVOut = 2
      Diis = .True.
      Damping = .True.
      One_Grid=.False.
      Two_Thresholds=.True.
      iDKeep = 4
      lPaper = 132
      nDens = 0
      kOptim = 1
      AccCon = '         '
      nDisc  =  2000
      nCore = 512
      Call ICopy(MxOptm,[-1],0,kDisk,1)
      Call ICopy(MxDDsk,[-1],0,iDisk,1)
      Call ICopy(MxKeep,[0],0,MapDns,1)
      FrstDs = .True.
      FrstDa = .True.
      PreSch = .False.
      MiniDn = .True.
      WrOutD = .False.
      c1Diis = .False.
      RSRFO  = .False.
      Scrmbl = .False.
      RFpert = .False.
      PmTime = .False.
      EmConv = .False.
      AddFragments = .False.
      call dcopy_(nFld,[0.0d0],0,TimFld,1)
      NamFld( 1)='1) Input processing                         :'
      NamFld( 2)='2) Wave function optimization               :'
      NamFld( 3)='     Line Search Iterations    (QNR steps)  :'
      NamFld( 4)='  a ) calculation of the density            :'
      NamFld( 5)='  b ) contraction with integrals            :'
      NamFld( 6)='  c ) acceleration of convergence           :'
      NamFld( 7)='        recursive BFGS         (QNR steps)  :'
      NamFld( 8)='  d ) solution to Roothaan-Hall equations   :'
      NamFld( 9)='  d'') rotate MOs C with U      (QNR steps)  :'
      NamFld(10)='        U=exp(kap)                          :'
      NamFld(11)='          via Taylor expansion (sin/cos)    :'
      NamFld(12)='          via transformation to Schur basis :'
      NamFld(13)='  e'') transf. Fck Mat. with C  (QNR steps)  :'
      NamFld(14)='  f ) other calculations                    :'
      NamFld(15)='3) Final processing (generation of outputs) :'
      NamFld(16)='   T O T A L                                :'
      NDDO = .False.
      RTemp = 0.04D0
      TemFac= 0.02D0
      TStop = 0.00D0
      KSDFT='SCF '
      ExFac=1.0D0
      WarnCfg=.False.
      WarnPocc=.False.
      WarnSlow=.False.
*
      Call Get_iScalar('FMM',iFMM)
      DoFMM=iFMM.eq.1
*
*     Initialize energy due to external potential on the run file. This
*     to make sure that it can be read unconditionally and is zero if
*     not redefined by DrvXV
      Call Poke_dScalar('KSDFT energy',0.0D0)
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function fradf(x)
!***********************************************************************
!                                                                      *
! Object: to compute the angular contribution to the multipole integral*
!         between continuum basis functions within an R-matrix sphere  *
!         (theta integration)                                          *
!                                                                      *
!***********************************************************************

use rmat, only: expsum, l
use Definitions, only: wp

implicit none
real(kind=wp) :: fradf
real(kind=wp), intent(in) :: x

fradf = x**(l+2)*exp(-expsum*x*x)

end function fradf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Giovanni Ghigo                              *
************************************************************************
*  Cho_TraA
*
*> @brief
*>   Routine for the transformation of the Cholesky vectors in MO-based TCVx for case \c Sym(i) &ne; \c Sym(j)
*> @author Giovanni Ghigo
*>
*> @details
*> In the inner batch the Cholesky Full Vectors are transformed and
*> stored in memory. Adresses (``1``) and length (``2``) are stored in the
*> integer matrix <tt>iMemTCVX(iType, Sym(i), Sym(j), 1/2)</tt>.
*>
*> - \c iType = ``1``: TCVA
*> - \c iType = ``2``: TCVB
*> - \c iType = ``3``: TCVC
*> - \c iType = ``4``: TCVD
*> - \c iType = ``5``: TCVE
*> - \c iType = ``6``: TCVF
*> - \c iType = ``7``: TCVG
*>
*> Types ``1``, ``2`` and ``4``--``7`` are generated only if \c DoTCVA = ``.True.``
*> TCVC is always generated.
*>
*> In the first half-transformation the vectors are contracted
*> only with the occupied (inactive and active) MO coefficients
*> for \c Sym(j). In the second half-transformation the vectors are
*> contracted with all MO coefficients.
*>
*> @note
*> The logical matrix \c TCVXist must be defined.
*>
*> @param[in]     iSymL       Symmetry of the Cholesky vector
*> @param[in]     iSym        Symmetry(``i``) of the Cholesky Full Vector
*> @param[in]     jSym        Symmetry(``j``) of the Cholesky Full Vector
*> @param[in]     NumV        Number of Cholesky vectors to transform in the current batch
*> @param[in]     CMO         MO coefficients
*> @param[in]     NCMO        Total number of MO coefficients
*> @param[in]     lUCHFV      Unit number of the Cholesky Full Vector to transform (``CHFV``)
*> @param[in,out] iStrtVec_AB Current initial disk pointer of the Cholesky Full Vector to transform (``CHFV``)
*> @param[in]     nFVec       Number of Cholesky vectors to transform in the inner batch procedure (\p nFBatch)
*> @param[in]     nFBatch     Number of cycles in the inner batch procedure
************************************************************************
      Subroutine Cho_TraA(iSymL, iSym,jSym, NumV, CMO,NCMO,
     &                               lUCHFV, iStrtVec_AB, nFVec,nFBatch)
************************************************************************
*  This is the routine for the transformation from AO basis to MO      *
*  basis of the Cholesky Full Vectors when  iSym.NE.jSym.              *
*  The new Transformed Cholesky Full Vectors L are :                   *
*                                                                      *
*  IF DoFull.EQ.False. (CASPT2, MCLR,MBPT2)                            *
*   TCVA : L_ij, L_ji=T(L_ij) if DoTCVA=.True.                         *
*   TCVB : L_tj, L_ui         if DoTCVA=.True.                         *
*   TCVC : L_aj, L_bi                                                  *
*   TCVD : L_tu, L_ut=T(L_tu) if DoTCVA=.True.                         *
*   TCVE : L_au, L_bt         if DoTCVA=.True.                         *
*   TCVF : L_ab               if DoTCVA=.True.                         *
*   TCVG : L_jt, L_iu         if DoTCVA=.True.                         *
*  For generation of <pk|ql>  p,q: All MO, k,l: Occupied (i & t)       *
*  MO Indices  i,j: Inactive;   t,u: Active;   a,b: Secondary          *
*                                                                      *
*----------------------------------------------------------------------*
*  Author  :  Giovanni Ghigo                                           *
*             Lund University, Sweden & University di Torino, Italia   *
*  Written :  October 2004                                             *
*  Modified:  July 2005                                                *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)

#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Dimension CMO(NCMO)
      Logical TCVA,TCVB,TCVBt,TCVC,TCVCt,TCVD,TCVE,TCVEt,TCVF

* --- Memory to allocate & Nr. of Cholesky vectors transformable
*     A=Alpha(AO);  B=Beta(AO)
      TCVA = .False.
      TCVB = .False.
      TCVBt= .False.
      TCVC = .False.
      TCVCt= .False.
      TCVD = .False.
      TCVE = .False.
      TCVEt= .False.
      TCVF = .False.

      NFAB = 0
      Nij = 0  ! A
      Nji = 0  ! A"
      Ntj = 0  ! B
      Njt = 0  ! G
      Nui = 0  ! B"
      Niu = 0  ! G"
      Naj = 0  ! C
      Nbi = 0  ! C"
      Ntu = 0  ! D
      Nut = 0  ! D"
      Nau = 0  ! E
      Nbt = 0  ! E"
      Nab = 0  ! F

      Len_FAB = 0
      Len_ij = 0  ! A
      Len_ji = 0  ! A"
      Len_tj = 0  ! B
      Len_jt = 0  ! G
      Len_ui = 0  ! B"
      Len_iu = 0  ! G"
      Len_aj = 0  ! C
      Len_bi = 0  ! C"
      Len_tu = 0  ! D
      Len_ut = 0  ! D"
      Len_au = 0  ! E
      Len_bt = 0  ! E"
      Len_ab = 0  ! F

      Len_XAj = 0   ! A/A", B, C
      Len_XAu = 0   ! D/D", E
      Len_XAb = 0   ! F
      Len_XBi = 0   ! B",C"
      Len_XBt = 0   ! E"

      NFAB = nBas(iSym) * nBas(jSym)

* TCV-A :
      If (TCVXist(1,iSym,jSym)) Then
        TCVA = .True.
        Len_XAj = nBas(iSym) * nIsh(jSym)
        Nij = nIsh(iSym) * nIsh(jSym)
        Nji = nIsh(jSym) * nIsh(iSym)
      EndIf

* TCV-B :
      If (TCVXist(2,iSym,jSym)) Then
        TCVB = .True.
        Len_XAj = nBas(iSym) * nIsh(jSym)
        Ntj = nAsh(iSym) * nIsh(jSym)
        Njt = nIsh(jSym) * nAsh(iSym)
      EndIf
      If (TCVXist(2,jSym,iSym)) Then
        TCVBt= .True.
        Len_XBi = nBas(jSym) * nIsh(iSym)
        Nui = nAsh(jSym) * nIsh(iSym)
        Niu = nIsh(iSym) * nAsh(jSym)
      EndIf

* TCV-C :
      If (TCVXist(3,iSym,jSym)) Then
        TCVC = .True.
        Len_XAj = nBas(iSym) * nIsh(jSym)
        Naj = nSsh(iSym) * nIsh(jSym)
      EndIf
      If (TCVXist(3,jSym,iSym)) Then
        TCVCt= .True.
        Len_XBi = nBas(jSym) * nIsh(iSym)
        Nbi = nSsh(jSym) * nIsh(iSym)
      EndIf

* TCV-D :
      If (TCVXist(4,iSym,jSym)) Then
        TCVD = .True.
        Len_XAu = nBas(iSym) * nAsh(jSym)
        Ntu = nAsh(iSym) * nAsh(jSym)
        Nut = nAsh(jSym) * nAsh(iSym)
      EndIf

* TCV-E :
      If (TCVXist(5,iSym,jSym)) Then
        TCVE = .True.
        Len_XAu = nBas(iSym) * nAsh(jSym)
        Nau = nSsh(iSym) * nAsh(jSym)
      EndIf
      If (TCVXist(5,jSym,iSym)) Then
        TCVEt= .True.
        Len_XBt = nBas(jSym) * nAsh(iSym)
        Nbt = nSsh(jSym) * nAsh(iSym)
      EndIf

* TCV-F :
      If (TCVXist(6,iSym,jSym)) Then
        TCVF = .True.
        Len_XAb = nBas(iSym) * nSsh(jSym)
        Nab = nSsh(iSym) * nSsh(jSym)
      EndIf

*     Allocate memory for Transformed Cholesky Vectors - TCVx
      Len_ij = Nij * NumV
      Len_ji = Nji * NumV
      Len_tj = Ntj * NumV
      Len_jt = Njt * NumV
      Len_ui = Nui * NumV
      Len_iu = Niu * NumV
      Len_aj = Naj * NumV
      Len_bi = Nbi * NumV
      Len_tu = Ntu * NumV
      Len_ut = Nut * NumV
      Len_au = Nau * NumV
      Len_bt = Nbt * NumV
      Len_ab = Nab * NumV
      iStrt_ij = 0  ! A
      iStrt_ji = 0  ! A"
      iStrt_tj = 0  ! B
      iStrt_jt = 0  ! G
      iStrt_ui = 0  ! B"
      iStrt_iu = 0  ! G"
      iStrt_aj = 0  ! C
      iStrt_bi = 0  ! C"
      iStrt_tu = 0  ! D
      iStrt_ut = 0  ! D"
      iStrt_au = 0  ! E
      iStrt_bt = 0  ! E"
      iStrt_ab = 0  ! F
      iStrt0_ij = 0  ! A
      iStrt0_ji = 0  ! A"
      iStrt0_tj = 0  ! B
      iStrt0_jt = 0  ! G
      iStrt0_ui = 0  ! B"
      iStrt0_iu = 0  ! G"
      iStrt0_aj = 0  ! C
      iStrt0_bi = 0  ! C"
      iStrt0_tu = 0  ! D
      iStrt0_ut = 0  ! D"
      iStrt0_au = 0  ! E
      iStrt0_bt = 0  ! E"
      iStrt0_ab = 0  ! F
      If ( TCVA  ) then
        Call GetMem('ij','ALLO','REAL',iStrt00_ij,Len_ij)
        iMemTCVX(1,iSym,jSym,1)=iStrt00_ij
        iMemTCVX(1,iSym,jSym,2)=Len_ij
        Call GetMem('ji','ALLO','REAL',iStrt00_ji,Len_ji)
        iMemTCVX(1,jSym,iSym,1)=iStrt00_ji
        iMemTCVX(1,jSym,iSym,2)=Len_ji
      EndIf
      If ( TCVB  ) then
        Call GetMem('tj','ALLO','REAL',iStrt00_tj,Len_tj)
        iMemTCVX(2,iSym,jSym,1)=iStrt00_tj
        iMemTCVX(2,iSym,jSym,2)=Len_tj
        Call GetMem('jt','ALLO','REAL',iStrt00_jt,Len_jt)
        iMemTCVX(7,jSym,iSym,1)=iStrt00_jt
        iMemTCVX(7,jSym,iSym,2)=Len_jt
      EndIf
      If ( TCVBt ) then
        Call GetMem('ui','ALLO','REAL',iStrt00_ui,Len_ui)
        iMemTCVX(2,jSym,iSym,1)=iStrt00_ui
        iMemTCVX(2,jSym,iSym,2)=Len_ui
        Call GetMem('iu','ALLO','REAL',iStrt00_iu,Len_iu)
        iMemTCVX(7,iSym,jSym,1)=iStrt00_iu
        iMemTCVX(7,iSym,jSym,2)=Len_iu
      EndIf
      If ( TCVC  ) then
        Call GetMem('aj','ALLO','REAL',iStrt00_aj,Len_aj)
        iMemTCVX(3,iSym,jSym,1)=iStrt00_aj
        iMemTCVX(3,iSym,jSym,2)=Len_aj
      EndIf
      If ( TCVCt ) then
        Call GetMem('bi','ALLO','REAL',iStrt00_bi,Len_bi)
        iMemTCVX(3,jSym,iSym,1)=iStrt00_bi
        iMemTCVX(3,jSym,iSym,2)=Len_bi
      EndIf
      If ( TCVD  ) then
        Call GetMem('tu','ALLO','REAL',iStrt00_tu,Len_tu)
        iMemTCVX(4,iSym,jSym,1)=iStrt00_tu
        iMemTCVX(4,iSym,jSym,2)=Len_tu
        Call GetMem('ut','ALLO','REAL',iStrt00_ut,Len_ut)
        iMemTCVX(4,jSym,iSym,1)=iStrt00_ut
        iMemTCVX(4,jSym,iSym,2)=Len_ut
      EndIf
      If ( TCVE  ) then
        Call GetMem('au','ALLO','REAL',iStrt00_au,Len_au)
        iMemTCVX(5,iSym,jSym,1)=iStrt00_au
        iMemTCVX(5,iSym,jSym,2)=Len_au
      EndIf
      If ( TCVEt ) then
        Call GetMem('bt','ALLO','REAL',iStrt00_bt,Len_bt)
        iMemTCVX(5,jSym,iSym,1)=iStrt00_bt
        iMemTCVX(5,jSym,iSym,2)=Len_bt
      EndIf
      If ( TCVF  ) then
        Call GetMem('ab','ALLO','REAL',iStrt00_ab,Len_ab)
        iMemTCVX(6,iSym,jSym,1)=iStrt00_ab
        iMemTCVX(6,iSym,jSym,2)=Len_ab
      EndIf

* --- START LOOP iFBatch -----------------------------------------------
      DO iFBatch=1,nFBatch
        If (iFBatch.EQ.nFBatch) then
         NumFV = NumV - nFVec * (nFBatch-1)
        Else
         NumFV = nFVec
        EndIf
        If ( TCVA  ) iStrt0_ij = iStrt00_ij + (iFBatch-1) * nFVec * Nij
        If ( TCVA  ) iStrt0_ji = iStrt00_ji + (iFBatch-1) * nFVec * Nji
        If ( TCVB  ) iStrt0_tj = iStrt00_tj + (iFBatch-1) * nFVec * Ntj
        If ( TCVB  ) iStrt0_jt = iStrt00_jt + (iFBatch-1) * nFVec * Njt
        If ( TCVBt ) iStrt0_ui = iStrt00_ui + (iFBatch-1) * nFVec * Nui
        If ( TCVBt ) iStrt0_iu = iStrt00_iu + (iFBatch-1) * nFVec * Niu
        If ( TCVC  ) iStrt0_aj = iStrt00_aj + (iFBatch-1) * nFVec * Naj
        If ( TCVCt ) iStrt0_bi = iStrt00_bi + (iFBatch-1) * nFVec * Nbi
        If ( TCVD  ) iStrt0_tu = iStrt00_tu + (iFBatch-1) * nFVec * Ntu
        If ( TCVD  ) iStrt0_ut = iStrt00_ut + (iFBatch-1) * nFVec * Nut
        If ( TCVE  ) iStrt0_au = iStrt00_au + (iFBatch-1) * nFVec * Nau
        If ( TCVEt ) iStrt0_bt = iStrt00_bt + (iFBatch-1) * nFVec * Nbt
        If ( TCVF  ) iStrt0_ab = iStrt00_ab + (iFBatch-1) * nFVec * Nab

*       Allocate memory & Load Full Cholesky Vectors - CHFV
        Len_FAB = NFAB * NumFV
        iStrtVec_FAB = iStrtVec_AB + nFVec * (iFBatch-1)
        Call GetMem('FAB','Allo','Real',iStrt0_FAB,Len_FAB)
        Call RdChoVec(Work(iStrt0_FAB),NFAB,NumFV,iStrtVec_FAB,lUCHFV)

*  ---  Start Loop  iVec  ---
        Do iVec=1,NumFV   ! Loop  iVec
          iStrt_FAB = iStrt0_FAB + (iVec-1) * NFAB
          If ( TCVA  ) iStrt_ij = iStrt0_ij + (iVec-1) * Nij
          If ( TCVA  ) iStrt_ji = iStrt0_ji + (iVec-1) * Nji
          If ( TCVB  ) iStrt_tj = iStrt0_tj + (iVec-1) * Ntj
          If ( TCVB  ) iStrt_jt = iStrt0_jt + (iVec-1) * Njt
          If ( TCVBt ) iStrt_ui = iStrt0_ui + (iVec-1) * Nui
          If ( TCVBt ) iStrt_iu = iStrt0_iu + (iVec-1) * Niu
          If ( TCVC  ) iStrt_aj = iStrt0_aj + (iVec-1) * Naj
          If ( TCVCt ) iStrt_bi = iStrt0_bi + (iVec-1) * Nbi
          If ( TCVD  ) iStrt_tu = iStrt0_tu + (iVec-1) * Ntu
          If ( TCVD  ) iStrt_ut = iStrt0_ut + (iVec-1) * Nut
          If ( TCVE  ) iStrt_au = iStrt0_au + (iVec-1) * Nau
          If ( TCVEt ) iStrt_bt = iStrt0_bt + (iVec-1) * Nbt
          If ( TCVF  ) iStrt_ab = iStrt0_ab + (iVec-1) * Nab

*     --- 1st Half-Transformation  iBeta(AO) -> q(MO) only occupied
          jStrt0MO = 1
          Do j=1,jSym-1
            jStrt0MO = jStrt0MO + nBas(j) * nBas(j)
          EndDo
          jStrt0MO = jStrt0MO + nFro(jSym) * nBas(jSym)

C         From CHFV A(Alpha,Beta) to XAj(Alpha,jMO)
          If ( TCVA .or. TCVB .or. TCVC ) then
            Call GetMem('XAj','ALLO','REAL',iStrt0_XAj,Len_XAj)
            Call ProdsA_2(Work(iStrt_FAB), nBas(iSym),nBas(jSym),
     &                  CMO(jStrt0MO),nIsh(jSym), Work(iStrt0_XAj))
          EndIf
          jStrt0MO = jStrt0MO + nIsh(jSym) * nBas(jSym)

C         From CHFV A(Alpha,Beta) to XAu(Alpha,uMO)
          If ( TCVD .or. TCVE ) then
            Call GetMem('XAu','ALLO','REAL',iStrt0_XAu,Len_XAu)
            Call ProdsA_2(Work(iStrt_FAB), nBas(iSym),nBas(jSym),
     &                  CMO(jStrt0MO),nAsh(jSym), Work(iStrt0_XAu))
          EndIf
          jStrt0MO = jStrt0MO + nAsh(jSym) * nBas(jSym)

C         From CHFV A(Alpha,Beta) to XAb(Alpha,bMO)
          If ( TCVF ) then
            Call GetMem('XAb','ALLO','REAL',iStrt0_XAb,Len_XAb)
            Call ProdsA_2(Work(iStrt_FAB), nBas(iSym),nBas(jSym),
     &                  CMO(jStrt0MO),nSsh(jSym), Work(iStrt0_XAb))
          EndIf

          iStrt0MO = 1
          Do i=1,iSym-1
            iStrt0MO = iStrt0MO + nBas(i) * nBas(i)
          EndDo
          iStrt0MO = iStrt0MO + nFro(iSym) * nBas(iSym)

C         From CHFV A(Alpha,Beta) to XBi(Beta,iMO)
          If ( TCVBt .or. TCVCt ) then
            Call GetMem('XBi','ALLO','REAL',iStrt0_XBi,Len_XBi)
            Call ProdsA_2t(Work(iStrt_FAB), nBas(iSym),nBas(jSym),
     &                  CMO(iStrt0MO),nIsh(iSym), Work(iStrt0_XBi))
          EndIf
          iStrt0MO = iStrt0MO + nIsh(iSym) * nBas(iSym)

C         From CHFV A(Alpha,Beta) to XBt(Beta,tMO)
          If ( TCVEt ) then
            Call GetMem('XBt','ALLO','REAL',iStrt0_XBt,Len_XBt)
            Call ProdsA_2t(Work(iStrt_FAB), nBas(iSym),nBas(jSym),
     &                  CMO(iStrt0MO),nAsh(iSym), Work(iStrt0_XBt))
          EndIf

*     --- 2nd Half-Transformation  iAlpha(AO) -> p(MO)
          iStrt0MO = 1
          Do i=1,iSym-1
            iStrt0MO = iStrt0MO + nBas(i) * nBas(i)
          EndDo
          iStrt0MO = iStrt0MO + nFro(iSym) * nBas(iSym)

C         From XAj(Alpha,jMO) to ij(i,j)
          If ( TCVA ) then
            Call ProdsA_1(Work(iStrt0_XAj), nBas(iSym),nIsh(jSym),
     &                  CMO(iStrt0MO),nIsh(iSym), Work(iStrt_ij))
            Call Trnsps(nIsh(iSym),nIsh(jSym),
     &                                    Work(iStrt_ij),Work(iStrt_ji))
          EndIf
          iStrt0MO = iStrt0MO + nIsh(iSym) * nBas(iSym)

C         From XAj(Alpha,jMO) to tj(t,j)
          If ( TCVB ) then
            Call ProdsA_1(Work(iStrt0_XAj), nBas(iSym),nIsh(jSym),
     &                  CMO(iStrt0MO),nAsh(iSym), Work(iStrt_tj))
            Call Trnsps(nAsh(iSym),nIsh(jSym),
     &                                    Work(iStrt_tj),Work(iStrt_jt))
          EndIf

C         From XAu(Alpha,jMO) to tu(t,u)
          If ( TCVD ) then
            Call ProdsA_1(Work(iStrt0_XAu), nBas(iSym),nAsh(jSym),
     &                  CMO(iStrt0MO),nAsh(iSym), Work(iStrt_tu))
            Call Trnsps(nAsh(iSym),nAsh(jSym),
     &                                    Work(iStrt_tu),Work(iStrt_ut))
          EndIf
          iStrt0MO = iStrt0MO + nAsh(iSym) * nBas(iSym)

C         From XAj(Alpha,jMO) to aj(a,j)
          If ( TCVC ) then
            Call ProdsA_1(Work(iStrt0_XAj), nBas(iSym),nIsh(jSym),
     &                  CMO(iStrt0MO),nSsh(iSym), Work(iStrt_aj))
          EndIf

C         From XAu(Alpha,jMO) to au(a,u)
          If ( TCVE ) then
            Call ProdsA_1(Work(iStrt0_XAu), nBas(iSym),nAsh(jSym),
     &                  CMO(iStrt0MO),nSsh(iSym), Work(iStrt_au))
          EndIf

C         From XAb(Alpha,jMO) to ab(a,b)
          If ( TCVF ) then
            Call ProdsA_1(Work(iStrt0_XAb), nBas(iSym),nSsh(jSym),
     &                  CMO(iStrt0MO),nSsh(iSym), Work(iStrt_ab))
          EndIf

          jStrt0MO = 1
          Do j=1,jSym-1
            jStrt0MO = jStrt0MO + nBas(j) * nBas(j)
          EndDo
          jStrt0MO = jStrt0MO + ( nFro(jSym) + nIsh(jSym) ) * nBas(jSym)

C         From XBi(Beta,jMO) to ui(u,i)
          If ( TCVBt ) then
            Call ProdsA_1(Work(iStrt0_XBi), nBas(jSym),nIsh(iSym),
     &                  CMO(jStrt0MO),nAsh(jSym), Work(iStrt_ui))
            Call Trnsps(nAsh(jSym),nIsh(iSym),
     &                                    Work(iStrt_ui),Work(iStrt_iu))
          EndIf
          jStrt0MO = jStrt0MO + nAsh(jSym) * nBas(jSym)

C         From XBi(Beta,jMO) to bi(b,i)
          If ( TCVCt ) then
            Call ProdsA_1(Work(iStrt0_XBi), nBas(jSym),nIsh(iSym),
     &                  CMO(jStrt0MO),nSsh(jSym), Work(iStrt_bi))
          EndIf

C         From XBt(Beta,jMO) to bt(b,t)
          If ( TCVEt ) then
            Call ProdsA_1(Work(iStrt0_XBt), nBas(jSym),nAsh(iSym),
     &                  CMO(jStrt0MO),nSsh(jSym), Work(iStrt_bt))
          EndIf

*     --- End of Transformations

          If ( TCVA .or. TCVB .or. TCVC ) then
            Call GetMem('XAj','FREE','REAL',iStrt0_XAj,Len_XAj)
          EndIf
          If ( TCVD .or. TCVE ) then
            Call GetMem('XAu','FREE','REAL',iStrt0_XAu,Len_XAu)
          EndIf
          If ( TCVF ) then
            Call GetMem('XAb','FREE','REAL',iStrt0_XAb,Len_XAb)
          EndIf
          If ( TCVBt .or. TCVCt ) then
            Call GetMem('XBi','FREE','REAL',iStrt0_XBi,Len_XBi)
          EndIf
          If ( TCVEt ) then
            Call GetMem('XBt','FREE','REAL',iStrt0_XBt,Len_XBt)
          EndIf

        EndDo
*  ---  End Loop  iVec  ---

        Call GetMem('FAB','Free','Real',iStrt0_FAB,Len_FAB)
      ENDDO
* --- END LOOP iFBatch -------------------------------------------------

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iSymL)
      End

      Subroutine ProdsA_1(AB,iA,iB, CMO,nMO, Y)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension AB(iA,iB), CMO(iA,nMO), Y(nMO,iB)
      Call DGEMM_('T','N',nMO,iB,iA,1.0d0,CMO,iA,AB,iA,0.0d0,Y,nMO)
      Return
      End

      Subroutine ProdsA_2(AB,iA,iB, CMO,nMO, Y)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension AB(iA,iB), CMO(iB,nMO), Y(iA,nMO)
      Call DGEMM_('N','N',iA,nMO,iB,1.0d0,AB,iA,CMO,iB,0.0d0,Y,iA)
      Return
      End

      Subroutine ProdsA_2t(AB,iA,iB, CMO,nMO, Y)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension AB(iA,iB), CMO(iA,nMO), Y(iB,nMO)
      Call DGEMM_('T','N',iB,nMO,iA,1.0d0,AB,iA,CMO,iA,0.0d0,Y,iB)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,2002, Roland Lindh                                *
!***********************************************************************

subroutine CmbnKE_GIAO(Rxyz,nZeta,la,lb,lr,Zeta,rKappa,rFinal,nComp,nB,Txyz,Wxyz,A,RB,C)
!***********************************************************************
!                                                                      *
! Object: to compute the first derivative of the kinetic energy        *
!         integrals with respect to the magnetic field.                *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!                                                                      *
!     Modified for GIAO's by RL June 2002, Tokyo, Japan.               *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Half, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, lr, nComp, nB
real(kind=wp), intent(in) :: Rxyz(nZeta,3,0:la+1,0:lb+1,0:lr+1), Zeta(nZeta), rKappa(nZeta), Txyz(nZeta,3,0:la,0:lb,0:lr+1), &
                             Wxyz(nZeta,3,0:la,0:lb,2), A(3), RB(3), C(3)
real(kind=wp), intent(out) :: rFinal(nZeta,nComp,nTri_Elem1(la),nTri_Elem1(lb),nB)
integer(kind=iwp) :: iBx, iBy, iBz, iComp, indx(3,2), ipa, ipb, ixa, ixb, iya, iyaMax, iyb, iybMax, iza, izb, iZeta, jxa, jxb, &
                     jya, jyb, jza, jzb
real(kind=wp) :: Fact, RAB(3), temp1, temp2a, temp2b, temp2c

!iRout = 134
!iPrint = nPrint(iRout)

RAB(:) = A-RB

iComp = 1
do ixa=0,la
  iyaMax = la-ixa
  indx(1,1) = ixa
  do ixb=0,lb
    iybMax = lb-ixb
    indx(1,2) = ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      indx(2,1) = iya
      indx(3,1) = iza
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        indx(2,2) = iyb
        indx(3,2) = izb
        ipb = C_Ind(lb,ixb,izb)

        !if (iPrint >= 99) then
        !  write(u6,*)
        !  write(u6,*) ixa,iya,iza
        !  write(u6,*) ixb,iyb,izb
        !  write(u6,*) ipa,ipb
        !end if
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Loop over components of B

        do iBx=1,3
          iBy = iBx+1-((iBx+1)/4)*3
          iBz = iBy+1-((iBy+1)/4)*3
          jxa = indx(iBx,1)
          jxb = indx(iBx,2)
          jya = indx(iBy,1)
          jyb = indx(iBy,2)
          jza = indx(iBz,1)
          jzb = indx(iBz,2)
          !write(u6,*) 'iBx,iBy,iBz=',iBx,iBy,iBz
          !write(u6,*) 'nZeta=',nZeta
          !write(u6,*) jxa,jya,jza
          !write(u6,*) jxb,jyb,jzb
          !                                                            *
          !*************************************************************
          !                                                            *
          ! Combine integrals

          do iZeta=1,nZeta

            Fact = rKappa(iZeta)*Zeta(iZeta)**(-OneHalf)

            temp1 = Rxyz(iZeta,iBx,jxa,jxb,0)*(Wxyz(iZeta,iBy,jya,jyb,2)*Rxyz(iZeta,iBz,jza+1,jzb,0)- &
                                               Rxyz(iZeta,iBy,jya+1,jyb,0)*Wxyz(iZeta,iBz,jza,jzb,2)- &
                                               Wxyz(iZeta,iBy,jya,jyb,1)*Rxyz(iZeta,iBz,jza,jzb+1,0)+ &
                                               Rxyz(iZeta,iBy,jya,jyb+1,0)*Wxyz(iZeta,iBz,jza,jzb,1))

            temp2a = Txyz(iZeta,iBx,jxa,jxb,0)*(RAB(iBy)*Rxyz(iZeta,iBy,jya,jyb,0)* &
                                                (Rxyz(iZeta,iBz,jza,jzb,1)+Rxyz(iZeta,iBz,jza,jzb,0)*C(iBz))- &
                                                (Rxyz(iZeta,iBy,jya,jyb,1)+Rxyz(iZeta,iBy,jya,jyb,0)*C(iBy))* &
                                                RAB(iBz)*Rxyz(iZeta,iBz,jza,jzb,0))

            temp2b = Rxyz(iZeta,iBx,jxa,jxb,0)*(RAB(iBy)*Txyz(iZeta,iBy,jya,jyb,0)* &
                                                (Rxyz(iZeta,iBz,jza,jzb,1)+Rxyz(iZeta,iBz,jza,jzb,0)*C(iBz))- &
                                                (Txyz(iZeta,iBy,jya,jyb,1)+Txyz(iZeta,iBy,jya,jyb,0)*C(iBy))* &
                                                RAB(iBz)*Rxyz(iZeta,iBz,jza,jzb,0))

            temp2c = Rxyz(iZeta,iBx,jxa,jxb,0)*(RAB(iBy)*Rxyz(iZeta,iBy,jya,jyb,0)* &
                                                (Txyz(iZeta,iBz,jza,jzb,1)+Txyz(iZeta,iBz,jza,jzb,0)*C(iBz))- &
                                                (Rxyz(iZeta,iBy,jya,jyb,1)+Rxyz(iZeta,iBy,jya,jyb,0)*C(iBy))* &
                                                RAB(iBz)*Txyz(iZeta,iBz,jza,jzb,0))

            rFinal(iZeta,iComp,ipa,ipb,iBx) = Half*Fact*(temp1+Half*(temp2a+temp2b+temp2c))
          end do
          !write(u6,*)
          !                                                            *
          !*************************************************************
          !                                                            *
        end do ! iBx
        !                                                              *
        !***************************************************************
        !                                                              *
      end do
    end do
  end do
end do

return

end subroutine CmbnKE_GIAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SPNCOM_LUCIA(  NOPEN,    MS2,   NDET, IABDET, IABUPP,
     &                          IFLAG, PSSIGN, IPRCSF)
*
* Combinations of nopen unpaired electrons.Required
* spin projection MS2/2.
*
#include "implicit.fh"
*. MXPDIM is included to have access to MXPORB
#include "mxpdim.fh"
      INTEGER ADD
      DIMENSION IABDET(NOPEN,*),IABUPP(NOPEN,*)
*. Should have length of max number of open orbitals
      DIMENSION IWORK(MXPORB)
*
* LENGTH OF IWORK MUST BE AT LEAST NOPEN
*
      NTEST = 0
      NTEST = MAX(NTEST,IPRCSF)
      NDET=0
      NUPPER = 0
*
* Determinants are considered as binary numbers,1=alpha,0=beta
*
      MX=2 ** NOPEN
      CALL ISETVC(IWORK,0,NOPEN)
      IFIRST = 1
* Loop over all possible binary numbers
      DO 200 I=1, MX
        IF(IFIRST.EQ.1) THEN
*. Initial number
          IZERO = 0
          CALL ISETVC(IWORK,IZERO,NOPEN)
          IFIRST = 0
        ELSE
*. Next number
          ADD=1
          J=0
  190     CONTINUE
          J=J+1
          IF(IWORK(J).EQ.1) THEN
            IWORK(J)=0
          ELSE
            IWORK(J)=1
            ADD=0
          END IF
          IF( ADD .EQ. 1 ) GOTO 190
        END IF
C
C.. 2 :  CORRECT SPIN PROJECTION ?
        NALPHA=0
        DO J=1,NOPEN
          NALPHA=NALPHA+IWORK(J)
        END DO
C
        IF(2*NALPHA-NOPEN.EQ.MS2.AND.
     &    .NOT.(PSSIGN.NE.0.0D0 .AND. IWORK(1).EQ.0)) THEN
          IF (IFLAG .LT. 3 ) THEN
            NDET=NDET+1
            CALL ICOPVE(IWORK,IABDET(1,NDET),NOPEN)
          END IF
*
          IF (IFLAG .GT. 1 ) THEN
C UPPER DET ?
            MS2L = 0
            LUPPER = 1
C
            DO IEL = 1,NOPEN
              IF (IWORK(IEL).EQ.1) THEN
                 MS2L = MS2L + 1
              ELSE
                 MS2L = MS2L - 1
              END IF
              IF( MS2L .LT. 0 ) LUPPER = 0
            END DO
*
            IF( LUPPER .EQ. 1 ) THEN
              NUPPER = NUPPER + 1
              CALL ICOPVE(IWORK,IABUPP(1,NUPPER),NOPEN)
            END IF
          END IF
        END  IF
C
  200 CONTINUE
C
      XMSD2=0.5D0*DBLE(MS2)
C
      IF(NTEST.GE.5.AND.IFLAG .NE.3) THEN
         WRITE(6,1010) NOPEN,NDET,XMSD2
 1010    FORMAT(1H0,2X,I3,' Unpaired electrons give ',I5,/,
     +'           combinations with spin projection ',F12.7)
         WRITE(6,*)
         WRITE(6,'(A)') '  Combinations : '
         WRITE(6,'(A)') '  ============== '
         WRITE(6,*)
         DO 20 J=1,NDET
           WRITE(6,1020) J,(IABDET(K,J),K=1,NOPEN)
  20     CONTINUE
 1020    FORMAT(1H0,I5,2X,30I2,/,(1H ,7X,30I2))
      END IF
C
      IF( IFLAG.GT.1.AND.NTEST.GE.5) THEN
         WRITE(6,*)
         WRITE(6,'(A)') ' Upper determinants '
         WRITE(6,'(A)') ' ================== '
         WRITE(6,*)
         DO 22 J=1,NUPPER
           WRITE(6,1020) J,(IABUPP(K,J),K=1,NOPEN)
  22     CONTINUE
      END IF
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This program converts a runfile into an ascii file.                  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
! Written: July 2003                                                   *
!          Lund University, Sweden                                     *
!                                                                      *
!***********************************************************************

program RF2Asc

use RunFile_data, only: lw, nToc, NulPtr, RunHdr, Toc, TypDbl, TypInt, TypLgl, TypStr
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, iDisk, iOpt, iRc, Lu, RUNASCII
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: iBuf(:)
real(kind=wp), allocatable :: dBuf(:)
character, allocatable :: cBuf(:)
integer(kind=iwp), external :: isFreeUnit

call IniMem()
call Init_LinAlg()
call PrgmInit('RF2Asc')
!----------------------------------------------------------------------*
! Open runfile and check that file is ok.                              *
!----------------------------------------------------------------------*
call f_inquire('RUNFILE',Found)
if (.not. Found) then
  call WarningMessage(2,'RUNFILE not found')
  stop
end if
call NameRun('RUNFILE')
iOpt = 0
iRc = 0
call OpnRun(iRc,Lu,iOpt)
!----------------------------------------------------------------------*
! Read the ToC                                                         *
!----------------------------------------------------------------------*
iDisk = RunHdr%DaLab
call cDaFile(Lu,2,Toc(:)%Lab,lw*nToc,iDisk)
iDisk = RunHdr%DaPtr
call iDaFile(Lu,2,Toc(:)%Ptr,nToc,iDisk)
iDisk = RunHdr%DaLen
call iDaFile(Lu,2,Toc(:)%Len,nToc,iDisk)
iDisk = RunHdr%DaTyp
call iDaFile(Lu,2,Toc(:)%Typ,nToc,iDisk)
!----------------------------------------------------------------------*
! Open output file.                                                    *
!----------------------------------------------------------------------*
RUNASCII = isFreeUnit(15)
call MOLCAS_OPEN(RUNASCII,'RUNASCII')
!----------------------------------------------------------------------*
! Print header information.                                            *
!----------------------------------------------------------------------*
write(RUNASCII,'(a)') '# Header information'
write(RUNASCII,'(a,i15)') '# ID                      ',RunHdr%ID
write(RUNASCII,'(a,i15)') '# Version                 ',RunHdr%Ver
write(RUNASCII,'(a,i15)') '# Next free address       ',RunHdr%Next
write(RUNASCII,'(a,i15)') '# Number of items         ',RunHdr%Items
write(RUNASCII,'(a,i15)') '# Address to ToC labels   ',RunHdr%DaLab
write(RUNASCII,'(a,i15)') '# Address to ToC pointers ',RunHdr%DaPtr
write(RUNASCII,'(a,i15)') '# Address to ToC lengths  ',RunHdr%DaLen
write(RUNASCII,'(a,i15)') '# Address to ToC types    ',RunHdr%DaTyp
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
do i=1,nToc
  if (Toc(i)%Ptr == NulPtr) cycle
  write(RUNASCII,'(3a)') '<',Toc(i)%Lab,'>'
  write(RUNASCII,*) Toc(i)%Len,Toc(i)%Typ
  select case (Toc(i)%Typ)
    case (TypDbl)
      iDisk = Toc(i)%Ptr
      call mma_allocate(dBuf,Toc(i)%Len,Label='dBuf')
      call dDaFile(Lu,2,dBuf,Toc(i)%Len,iDisk)
      write(RUNASCII,'(4d26.18)') dBuf(1:Toc(i)%Len)
      call mma_deallocate(dBuf)
    case (TypInt)
      iDisk = Toc(i)%Ptr
      call mma_allocate(iBuf,Toc(i)%Len,Label='iBuf')
      call iDaFile(Lu,2,iBuf,Toc(i)%Len,iDisk)
      write(RUNASCII,*) iBuf(1:Toc(i)%Len)
      call mma_deallocate(iBuf)
    case (TypStr)
      iDisk = Toc(i)%Ptr
      call mma_allocate(cBuf,Toc(i)%Len,Label='cBuf')
      call cDaFile(Lu,2,cBuf,Toc(i)%Len,iDisk)
      write(RUNASCII,'(64a1)') cBuf(1:Toc(i)%Len)
      call mma_deallocate(cBuf)
    case (TypLgl)
      write(u6,*) 'Cannot handle type logical'
      exit
  end select
end do
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
close(RUNASCII)

call GetMem('Finish','LIST','REAL',I,0)
call GetMem('Finish','TERM','REAL',I,0)

end program RF2Asc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Compute the dx parameters value

subroutine dX()

use LnkLst, only: GetNod, iVPtr, LLDelt, LLx, LstPtr, PutVec, SCF_V
use InfSCF, only: Iter, Iter_Start, mOV
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, inode, jpgrd
real(kind=wp), allocatable :: Scr(:)

call mma_allocate(Scr,mOV,Label='Scr')

! Loop over all iterations starting at Iter_Start

do i=Iter_Start,Iter-1

  !dX(i) = X(i+1)-X(i)

  jpgrd = LstPtr(i+1,LLx)   ! Pointer to X(i+1)

  call GetNod(i,LLx,inode) ! X(i)
  if (inode == 0) then
    write(u6,*) 'inode == 0'
    call Abend()
  end if
  call iVPtr(Scr,mOV,inode)

  Scr(:) = SCF_V(jpgrd)%A(:)-Scr(:)

  call PutVec(Scr,mOV,i,'OVWR',LLDelt)
end do

call mma_deallocate(Scr)

return

end subroutine dX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine EdmistonRuedenberg_Iter(Functional,CMO,Thrs,ThrRot,ThrGrad,nBasis,nOrb2Loc,nMxIter,Maximisation,Converged,Debug,Silent)
! Thomas Bondo Pedersen, November 2005.
!
! Purpose: ER localisation of orbitals.
!
! The optimization algorithm is the "generalized eta step" of
! Subotnik, Shao, Liang, and Head-Gordon, JCP 121, 9220 (2004).
!
! Redundant arguments that might be used at a later stage:
!   ThrRot [might be used for DIIS]
!   Maximisation [might be used for Jacobi sweeps]
!
! Note that two-electron integrals (Cholesky decomposed) must be
! available and appropriately set up when calling this routine.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: Functional
integer(kind=iwp), intent(in) :: nBasis, nOrb2Loc, nMxIter
real(kind=wp), intent(inout) :: CMO(nBasis,nOrb2Loc)
real(kind=wp), intent(in) :: Thrs, ThrRot, ThrGrad
logical(kind=iwp), intent(in) :: Maximisation, Debug, Silent
logical(kind=iwp), intent(out) :: Converged
integer(kind=iwp) :: nIter
real(kind=wp) :: C1, C2, Delta, FirstFunctional, GradNorm, OldFunctional, TimC, TimW, W1, W2
logical(kind=iwp) :: Timing
real(kind=wp), allocatable :: Rmat(:,:)
character(len=*), parameter :: SecNam = 'EdmistonRuedenberg_Iter'

if (Debug) then
  write(u6,*) SecNam,'[debug]: Maximisation: ',Maximisation
  write(u6,*) SecNam,'[debug]: ThrRot      : ',ThrRot
end if

! Print iteration table header.
! -----------------------------

if (.not. Silent) then
  write(u6,'(//,1X,A,/,1X,A)') '                                                        CPU       Wall', &
                               'nIter      Functional ER        Delta     Gradient     (sec)     (sec)'
end if

! Initialization.
! ---------------

Converged = .false.
Timing = Debug

call mma_allocate(Rmat,nOrb2Loc,nOrb2Loc,label='Rmat')

! Iteration 0.
! ------------

if (.not. Silent) call CWTime(C1,W1)
nIter = 0
Functional = Zero
call GetGrad_ER(Functional,GradNorm,Rmat,CMO,nBasis,nOrb2Loc,Timing)
OldFunctional = Functional
FirstFunctional = Functional
Delta = Functional
if (.not. Silent) then
  call CWTime(C2,W2)
  TimC = C2-C1
  TimW = W2-W1
  write(u6,'(1X,I5,1X,F18.8,2(1X,D12.4),2(1X,F9.1))') nIter,Functional,Delta,GradNorm,TimC,TimW
end if

! Iterations.
! -----------

do while ((nIter < nMxIter) .and. (.not. Converged))
  if (.not. Silent) call CWTime(C1,W1)
  call RotateOrb_ER(Rmat,CMO,nBasis,nOrb2Loc,Debug)
  call GetGrad_ER(Functional,GradNorm,Rmat,CMO,nBasis,nOrb2Loc,Timing)
  nIter = nIter+1
  Delta = Functional-OldFunctional
  OldFunctional = Functional
  if (.not. Silent) then
    call CWTime(C2,W2)
    TimC = C2-C1
    TimW = W2-W1
    write(u6,'(1X,I5,1X,F18.8,2(1X,D12.4),2(1X,F9.1))') nIter,Functional,Delta,GradNorm,TimC,TimW
  end if
  Converged = (GradNorm <= ThrGrad) .and. (abs(Delta) <= Thrs)
end do

! Print convergence message.
! --------------------------

if (.not. Silent) then
  if (.not. Converged) then
    write(u6,'(/,A,I4,A)') 'No convergence after',nIter,' iterations.'
  else
    write(u6,'(/,A,I4,A)') 'Convergence after',nIter,' iterations.'
    write(u6,*)
    write(u6,'(A,I8)') 'Number of localised orbitals  : ',nOrb2loc
    write(u6,'(A,F12.8)') 'Value of P before localisation: ',FirstFunctional
    write(u6,'(A,F12.8)') 'Value of P after localisation : ',Functional
  end if
end if

! Finalization.
! -------------

call mma_deallocate(Rmat)

end subroutine EdmistonRuedenberg_Iter

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module LUCIA_INTERFACE

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
private

public :: Lucia_Util

contains

!***********************************************************************
!  Lucia_Util
!
!> @brief
!>   Wrapper for using LUCIA utils in MOLCAS.
!> @author Jesper Wisborg Krogh
!>
!> @details
!> By using the LUCIA utils through this wrapper it is guaranteed
!> that all common blocks used have a common parent routine.
!>
!> @param[in] Module Identifier
!***********************************************************************
subroutine Lucia_Util(ModLab,iSym,iDisk,LU,Array,RVec,CI_VECTOR,SIGMA_VECTOR)

  use lucia_data, only: IREFSM, MXNTTS

  implicit none
  character(len=*), intent(in) :: ModLab
  integer(kind=iwp), intent(in), optional :: iSym, LU
  integer(kind=iwp), intent(inout), optional :: iDisk
  real(kind=wp), intent(in), optional :: Array(:), RVEC(:)
  real(kind=wp), intent(_IN_), optional :: CI_Vector(:)
  real(kind=wp), intent(out), optional :: SIGMA_Vector(:)
  character(len=72) :: Module_
  integer(kind=iwp), allocatable :: lVec(:)
# ifdef _DEBUGPRINT_
  integer(kind=iwp) :: COUNTER = 0

  COUNTER = COUNTER+1
  write(u6,'(1X,A1,I6,A1,1X,A,1X,A1,A,A1)') '[',COUNTER,']','ENTRY LUCIA_UTIL','(',ModLab,')'
# endif

  ! Make sure the ModLab variable is in upper case.

  Module_ = ModLab
  call UpCase(Module_)

  ! Call the appropriate routines according to ModLab

  if (Module_(1:4) == 'DIAG') then
    call Diag_Master()
  else if (Module_(1:9) == 'SIGMA_CVB') then
    ! iSym_LI is the symmetry to be used.
    call Sigma_Master_CVB(CI_VECTOR,SIGMA_VECTOR,iSym)
  else if (Module_(1:5) == 'SIGMA') then
    !write(u6,*) 'blubbbbbbhc'
    call Sigma_Master(CI_VECTOR,SIGMA_VECTOR)
  else if (Module_(1:5) == 'TRACI') then
    !write(u6,*) 'blubbbbbbtraci'
    ! iDisk is the initial disk address (for read/write of JOBIPH)
    ! Lu is the file unit for JOBIPH
    ! Array is the transformation matrix (not sorted as LUCIA needs it).
    call mma_allocate(lVec,MXNTTS,Label='lVec')
    call Traci_Master(iDisk,LU,Array,lVec)
    call mma_deallocate(lVec)
  else if (Module_(1:5) == 'DENSI') then
    if (present(RVEC)) then
      call Densi_Master(CI_VECTOR,RVEC=RVEC(:))
    else
      call Densi_Master(CI_VECTOR)
    end if
  else if (Module_(1:3) == 'INI') then
    call Lucia_Ini()
    call DetCtl_Gas()
  else if (Module_(1:5) == 'CLOSE') then
    call CSFDIM_FREE(IREFSM)
    call LUCIA2MOLCAS_FREE()
    call Lucia_Close()
  else
    write(u6,*) 'Unknown module requested in Lucia_Util.'
    write(u6,*) 'Module = ',ModLab
    write(u6,*) 'Known modules are:'
    write(u6,*) 'Diag, Sigma, Sigma_CVB, Densi, DetCtl, Ini'
    call Abend()
  end if

# ifdef _DEBUGPRINT_
  write(u6,'(1X,A1,I6,A1,1X,A,1X,A1,A,A1)') '[',COUNTER,']','EXIT LUCIA_UTIL','(',ModLab,')'
# endif

end subroutine Lucia_Util

subroutine densi_master(CIVec,RVec)
  ! Controls the calculation of the densities, when Lucia is called
  ! from Molcas Rasscf.

  use lucia_data, only: DSTmp, Dtmp, DTOC, IDISK, IREFSM, LCSBLK, kvec3_length, LUC, LUHC, LUSC1, LUSC34, MXNTTS, MXSOOB, &
                        NCSF_PER_SYM, NSD_PER_SYM, NTOOB, PAtmp, PSSIGN, Ptmp, RHO1, SDREO, Sigma_on_Disk, SRHO1, VEC3, XISPSM
  use Constants, only: Zero

  implicit none
  real(kind=wp), intent(in) :: CIVec(:)
  real(kind=wp), intent(in), optional :: RVec(:)
  integer(kind=iwp) :: LBLK, LBLOCK, NCSF, NSD
  real(kind=wp) :: dummy(1), EXPS2
  logical(kind=iwp) :: iPack, tdm
  integer(kind=iwp), allocatable :: lVec(:)
  real(kind=wp), allocatable :: SCR2(:), SCR4(:), VEC1(:), VEC2(:)
  real(kind=wp), allocatable, target :: SCR1(:), SCR3(:)

  ! Put CI-vector from RASSCF on luc

  ! if rvec is associated, it should be a pointer to a second CI vector
  ! and a one-particle transition density matrix will be computed
  tdm = present(rVec)

  NSD = NSD_PER_SYM(IREFSM)
  NCSF = NCSF_PER_SYM(IREFSM)
  call mma_allocate(SCR1,NSD,Label='SCR1')
  call mma_allocate(SCR2,NSD,Label='SCR2')

  SCR1(1:NCSF) = CIVEC(1:NCSF)

  call mma_allocate(lVec,MXNTTS,Label='lVec')
  if (tdm) then
    call mma_allocate(SCR3,NSD,Label='SCR3')
    call mma_allocate(SCR4,NSD,Label='SCR4')

    SCR3(1:NCSF) = rvec(1:NCSF)
    call CSDTVC(SCR3,SCR4,1,DTOC,SDREO,IREFSM,1)
    call CPCIVC1(SCR3,NSD,LUHC,MXNTTS,IREFSM,lVec)
    call mma_deallocate(SCR3)
    call mma_deallocate(SCR4)
  end if
  call CSDTVC(SCR1,SCR2,1,DTOC,SDREO,IREFSM,1)
  call CPCIVC1(SCR1,NSD,LUC,MXNTTS,IREFSM,lVec)
  call mma_deallocate(lVec)

  ! Determine length of arrays VEC1 and VEC2

  !if (ISIMSYM == 0) then
  LBLOCK = MXSOOB
  !else
  !  LBLOCK = MXSOOB_AS
  !end if
  LBLOCK = max(LBLOCK,LCSBLK)
  ! JESPER : Should reduce I/O
  !PAM06 LBLOCK = max(XISPSM(IREFSM,1),real(MXSOOB,kind=wp))
  LBLOCK = max(int(XISPSM(IREFSM,1)),MXSOOB)
  if (PSSIGN /= Zero) LBLOCK = 2*int(XISPSM(IREFSM,1))

  ! Allocate arrays

  call mma_allocate(VEC1,LBLOCK,Label='VEC1')
  call mma_allocate(VEC3,kvec3_length,Label='VEC3')

  ! Copy Sigma-vector from disc to core

  call mma_allocate(VEC2,LBLOCK,Label='VEC2')
  if (Sigma_on_disk) then
    call mma_allocate(lVec,MXNTTS,Label='lVec')
    call cpsivc(lusc34,mxntts,vec2,lVec)
    call mma_deallocate(lVec)
  else
    vec2(:) = Zero
  end if

  ! Information needed on file handling

  LBLK = -1

  ! Copy vector on file LUC to LUSC1 and LUHC

  IDISK(LUC) = 0
  IDISK(LUSC1) = 0
  call COPVCD(LUC,LUSC1,VEC1,0,LBLK)
  if (.not. tdm) call COPVCD(LUSC1,LUHC,VEC1,1,LBLK)

  ! Calculate one- and two-body densities

  IPACK = .true.
  DUMMY = Zero
  if (tdm) then
    call densi2(1,Dtmp,dummy,dummy,dummy,vec1,vec2,lusc1,luhc,exps2,1,DStmp,IPACK)
  else
    call densi2(2,rho1,dummy,Ptmp,PAtmp,vec1,vec2,lusc1,luhc,exps2,1,srho1,IPACK)
  end if

  ! Explanation of calling parameters
  !
  ! 2     : DONE!!! - Calculate both one and two body densities.
  ! rho1  : DONE!!! - Output - include in module lucia_data
  ! rho2  : DONE!!! - Output - include in module lucia_data
  ! vec1  : DONE!!! - CI-vector
  ! vec2  : DONE!!! - Sigma-vector
  ! lusc1 : DONE!!! - file pointer
  ! luhc  : DONE!!! - file pointer
  ! exps2 : DONE!!! - Output - expectation value of S**2.
  ! 1     : DONE!!! - Calculate spin density
  ! srho1 : DONE!!! - Comming with module lucia_data

  if (.not. tdm) then
    ! Save densities in trigonal format for use in Molcas

    call TriPak(rho1,Dtmp,ntoob,ntoob)
    call TriPak(srho1,DStmp,ntoob,ntoob)
  end if

  call CSDTVC(scr1,scr2,2,dtoc,SDREO,iRefSm,1)

  call mma_deallocate(SCR1)
  call mma_deallocate(SCR2)
  call mma_deallocate(VEC1)
  call mma_deallocate(VEC2)
  call mma_deallocate(VEC3)

end subroutine densi_master

subroutine sigma_master(CIVEC,SIGMAVEC)
  ! Controls the calculation of the sigma vector, when Lucia is called
  ! from Molcas Rasscf.

  use lucia_data, only: CI_VEC, ECORE, ECORE_ORIG, INI_H0, INT1, INT1O, IREFSM, KVEC3_LENGTH, LUC, LUSC34, MXNTTS, NSD_PER_SYM, &
                        SIGMA_VEC, VEC3

  implicit none
  real(kind=wp), intent(_IN_) :: CIVEC(:)
  real(kind=wp), intent(out) :: SIGMAVEC(:)
  integer(kind=iwp) :: nSD
  integer(kind=iwp), allocatable :: lVec(:)

  nSD = NSD_PER_SYM(IREFSM)

  ! Put CI-vector from RASSCF on luc and get h0 from Molcas enviroment.

  if (INI_H0 == 0) ECORE = ECORE_ORIG
  INI_H0 = 0
  INT1(:) = INT1O(:)
  ECORE_ORIG = ECORE
  !if (IUSE_PH == 1) then
  !  call FI(INT1,ECORE_HEX,1)
  !  ECORE = ECORE+ECORE_HEX
  !end if
  call mma_allocate(lVec,MXNTTS,Label='lVec')
  call CPCIVC1(CIVEC,nSD,LUC,MXNTTS,IREFSM,lVec)
  call mma_deallocate(lVec)

  ! Calculate the sigma vector:
  ! LUC       : unit from which the CI vector is picked
  ! LUSC34    : unit to which the sigma vector is put
  ! CI_VEC    : scratch area to store the CI vector temporarily
  ! SIGMA_VEC : the computed sigmavector in core.

  call mma_allocate(VEC3,KVEC3_LENGTH,Label='VEC3')
  ! Note that CI_VEC is used as a scratch array!
  call MV7(CI_VEC,SIGMA_VEC,LUC,LUSC34)
  call mma_deallocate(VEC3)

  ! Export lusc34 to RASSCF

  call mma_allocate(lVec,MXNTTS,Label='lVec')
  call CPCIVC2(SIGMAVEC,nSD,LUSC34,MXNTTS,IREFSM,lVec)
  call mma_deallocate(lVec)

end subroutine SIGMA_MASTER

subroutine SIGMA_MASTER_CVB(CIVEC,SIGMAVEC,IREFSM_CASVB)

  use CandS, only: ICSM, ISSM
  use lucia_data, only: CI_VEC, ECORE, ECORE_ORIG, INI_H0, INT1, INT1O, IREFSM, KVEC3_LENGTH, LUC, LUSC34, MXNTTS, NSD_PER_SYM, &
                        SIGMA_ON_DISK, VEC3

  implicit none
  integer(kind=iwp), intent(in) :: IREFSM_CASVB
  real(kind=wp), intent(_IN_) :: CIVEC(:)
  real(kind=wp), intent(out) :: SIGMAVEC(:)
  integer(kind=iwp) :: nSD
  integer(kind=iwp), allocatable :: lVec(:)

  ! Set ICSM and ISSM (from module CandS to the correct symmetry for this call

  ICSM = IREFSM_CASVB
  ISSM = IREFSM_CASVB

  !nSD = NSD_PER_SYM(IREFSM)
  nSD = NSD_PER_SYM(IREFSM_CASVB)

  ! Get h0 from Molcas enviroment.

  if (INI_H0 == 0) ECORE = ECORE_ORIG
  INI_H0 = 0
  INT1(:) = INT1O(:)
  ECORE_ORIG = ECORE
  !if (IUSE_PH == 1) then
  !  call FI(INT1,ECORE_HEX,1)
  !  ECORE = ECORE+ECORE_HEX
  !end if

  ! Write CI-vector to disc

  call mma_allocate(lVec,MXNTTS,Label='lVec')
  call CPCIVC1(CIVEC,nSD,LUC,MXNTTS,ISSM,lVec)
  call mma_deallocate(lVec)

  ! Calculate the sigma vector:

  call DIAG_MASTER()
  call mma_allocate(VEC3,KVEC3_LENGTH,Label='VEC3')
  ! Note that CI_VEC is used as a scratch array!
  call MV7(CI_VEC,SIGMAVec,LUC,LUSC34)
  call mma_deallocate(VEC3)

  ! Export lusc34 to RASSCF

  SIGMA_ON_DISK = .true.

  ! Set ICSM and ISSM (from CandS) back to IREFSM

  ICSM = IREFSM
  ISSM = IREFSM

end subroutine SIGMA_MASTER_CVB

subroutine cpcivc1(CIVec,nCIVEC,ifile,mxrec,isym,lrec)
  ! Copies the CI-vector from Molcas to Lucia (from core to disk unit ifile).

  use lucia_data, only: IDISK

  implicit none
  integer(kind=iwp), intent(in) :: nCIVEC, ifile, mxrec, isym
  real(kind=wp), intent(_IN_) :: CIVec(nCIVec)
  integer(kind=iwp), intent(out) :: lrec(mxrec)
  integer(kind=iwp) :: dum(1), nRec
# ifdef _DEBUGPRINT_
  integer(kind=iwp) :: iOff, iRec
# endif

  ! ==================
  ! Find nrec and lrec
  ! ==================

  call blkfo_min(isym,nrec,lrec)
  IDISK(IFILE) = 0

  ! =======================
  ! Write CI-vector to disc
  ! =======================

# ifdef _DEBUGPRINT_
  ioff = 1
  write(u6,*) 'CI-vector put to disk:'
  do IREC=1,NREC
    if (LREC(IREC) >= 0) then
      call wrtmat(CIVec(ioff),1,lrec(irec),1,lrec(irec))
      ioff = ioff+lrec(irec)
    end if
  end do
# endif
  call todscn(CIVec,nrec,lrec,-1,ifile)
  dum(1) = -1
  call itods(dum,1,-1,ifile)

end subroutine cpcivc1

subroutine cpcivc2(CIVec,nCIVEC,ifile,mxrec,isym,lrec)
  ! Copies the CI-vector from Lucia to Molcas (from disk unit ifile to core).

  use lucia_data, only: IDISK

  implicit none
  integer(kind=iwp), intent(in) :: nCIVEC, ifile, mxrec, isym
  real(kind=wp), intent(out) :: CIVec(nCIVec)
  integer(kind=iwp), intent(out) :: lrec(mxrec)
  integer(kind=iwp) :: nRec

  ! ==================
  ! Find nrec and lrec
  ! ==================

  call blkfo_min(isym,nrec,lrec)
  IDISK(IFILE) = 0

  ! ========================
  ! Read CI-vector from disc
  ! ========================
  call frmdscn(CIVec,nrec,-1,ifile)

end subroutine cpcivc2

subroutine cpsivc(ifile,mxrec,vec,lrec)
  ! Copies the Sigma-vector between Molcas Rasscf and Lucia enviroment

  use lucia_data, only: IDISK
  use general_data, only: STSYM

  implicit none
  integer(kind=iwp), intent(in) :: ifile, mxrec
  real(kind=wp), intent(inout) :: vec(mxrec)
  integer(kind=iwp), intent(out) :: lrec(mxrec)
  integer(kind=iwp) :: nrec

  ! ==================
  ! Find nrec and lrec
  ! ==================

  call blkfo_min(stsym,nrec,lrec)
  IDISK(IFILE) = 0

  ! ===========================
  ! Read Sigma-vector from disc
  ! ===========================

  call frmdscn(vec,nrec,-1,ifile)

end subroutine cpsivc

end module LUCIA_INTERFACE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine SymAdO(ArrIn,nZeta,la,lb,nComp,ArrOut,nIC,iDCRT,
     &                  lOper,iChO,Factor)
      use Symmetry_Info, only: nIrrep, iChTbl, iOper
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 ArrIn (nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp),
     &       ArrOut(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nIC),
     &       Prmt(0:7)
      Integer iDCRT ,iTwoj(0:7), lOper(nComp), iChO(nComp)
      Data iTwoj/1,2,4,8,16,32,64,128/
      Data Prmt/1.d0,-1.d0,-1.d0,1.d0,-1.d0,1.d0,1.d0,-1.d0/
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      xPrmt(i,j) = Prmt(iAnd(i,j))
*
C     nA = (la+1)*(la+2)/2
C     nB = (lb+1)*(lb+2)/2
C     Call RecPrt('SymAdO: ArrIn',' ',ArrIn,nZeta*nA*nB, nComp)
*
*--------Accumulate contributions
*
      iIC = 0
      Do 103 iComp = 1, nComp
         pO = xPrmt(iOper(iDCRT),iChO(iComp))
         Do 104 iIrrep = 0, nIrrep-1
            If (iAnd(lOper(iComp),iTwoj(iIrrep)).eq.0) Go To 104
            iIC = iIC + 1
            Xg = DBLE(iChTbl(iIrrep,iDCRT))
            Call DaXpY_(nZeta*nElem(la)*nElem(lb),Xg*pO*Factor,
     &                 ArrIn(1,1,1,iComp),1,ArrOut(1,1,1,iIC),1)
 104     Continue
 103  Continue
      If (iIC.ne.nIC) Then
         Call WarningMessage(2,' Abend in SymAdO: iIC.ne.nIC')
         Write (6,*) 'iIC,nIC=',iIC,nIC
         Call Abend()
      End If
C     Call RecPrt('SymAdO: ArrOut',' ',ArrOut,nZeta*nA*nB, nIC)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dawri(lun,length,vector)
! this routine writes length-R8 numbers to open unformatted file
! with number lun at the given position as one record
!
! lun    - Logical unit number of file, where mediate will be stored (Input)
! length - # of R8 numbers to be written (Input)
! vector - space, where numbers are stored (Input)

use ccsort_global, only: daddr, iokey
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: lun, length
real(kind=wp), intent(_IN_) :: vector(length)

if (iokey == 1) then
  ! Fortran IO
  write(lun) vector

else
  ! MOLCAS IO
  call ddafile(lun,1,vector,length,daddr(lun))
end if

return

end subroutine dawri

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine FnoMP2_putInf(mSym,lnOrb,lnOcc,lnFro,lnDel,lnVir)
! Purpose: put info in MP2 common blocks.

use ChoMP2, only: DoFNO, l_Dii
use cOrbInf, only: nDel, nExt, nFro, nOcc, nOrb, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: mSym, lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
integer(kind=iwp) :: iSym

nSym = mSym

do iSym=1,nSym
  nOrb(iSym) = lnOrb(iSym)
  nOcc(iSym) = lnOcc(iSym)
  nFro(iSym) = lnFro(iSym)
  nDel(iSym) = lnDel(iSym)
  nExt(iSym) = lnVir(iSym)
end do

DoFNO = .true.
l_Dii = nOcc(1)
do iSym=2,nSym
  l_Dii = l_Dii+nOcc(iSym)
end do

return

end subroutine FnoMP2_putInf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Bernd Artur Hess                                 *
!***********************************************************************

subroutine Util8(Beta,nZeta,rFinal,la,lb,Slalbp,Slalbm)
!***********************************************************************
!                                                                      *
! Object: to assemble the Vp integrals from                            *
!         derivative integrals of the electric potential.              *
!                                                                      *
!     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
!             Chemie, University of Bonn, Germany, August 1994         *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb
real(kind=wp), intent(in) :: Beta(nZeta), Slalbp(nZeta,nTri_Elem1(la),nTri_Elem1(lb+1)), &
                             Slalbm(nZeta,nTri_Elem1(la),nTri_Elem1(lb-1))
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),3)
#include "print.fh"
integer(kind=iwp) :: ia, ib, iElem, iiComp, iiZeta, ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyb, iza, izb, jElem
character(len=80) :: Label

iRout = 203
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  write(u6,*) ' In util8 la,lb=',la,lb
  call RecPrt('Beta','(5f15.8)',Beta,nZeta,1)
  do ib=1,nTri_Elem1(lb)
    write(Label,'(A,I2,A)') ' Slalbp(',la,ib,')'
    call RecPrt(Label,'(5f15.8)',Slalbp(:,:,ib),nZeta,nTri_Elem1(la+1))
  end do
  if (lb > 0) then
    do ia=1,nTri_Elem1(la)
      write(Label,'(A,I2,A)') ' Slalbm(',la,ib,')'
      call RecPrt(Label,'(5f15.8)',Slalbm(:,:,ib),nZeta,nTri_Elem1(lb-1))
    end do
  end if
end if

do ixa=la,0,-1
  do iya=la-ixa,0,-1
    iza = la-ixa-iya
    ipa = C_Ind(la,ixa,iza)

    do ixb=lb,0,-1
      do iyb=lb-ixb,0,-1
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        if (ixb == 0) then
          rFinal(:,ipa,ipb,1) = Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb))
        else
          rFinal(:,ipa,ipb,1) = Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb))-real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb))
        end if

        if (iyb == 0) then
          rFinal(:,ipa,ipb,2) = Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb))
        else
          rFinal(:,ipa,ipb,2) = Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb))-real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb))
        end if

        if (izb == 0) then
          rFinal(:,ipa,ipb,3) = Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1))
        else
          rFinal(:,ipa,ipb,3) = Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1))-real(iza,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1))
        end if

      end do
    end do

  end do
end do

if (iPrint >= 49) then
  write(u6,*) ' In UTIL8 la,lb=',la,lb
  do iiComp=1,3
    do jElem=1,nTri_Elem1(lb)
      do iElem=1,nTri_Elem1(la)
        do iiZeta=1,nZeta
          write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,') '
          !call RecPrt(Label,'(5f15.8)',
          write(u6,*) iiZeta,iElem,jElem,iiComp,rFinal(iiZeta,iElem,jElem,iiComp)
        end do
      end do
    end do
  end do
end if

return

end subroutine Util8

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine O2N(AA,AB,BB,Temp,nA,nB,Error)
      Implicit Real*8 (a-h,o-z)
      Real*8 AA(nA,nA), AB(nA,nB), BB(nB,nB), Temp(nA,nB)
*                                                                      *
************************************************************************
*                                                                      *
*     (1) Project the new basis on to the old space and compute the
*         matrix elements.
*
      Call DGEMM_('N','N',
     &             nA,nB,nA,
     &             1.0D0,AA,nA,
     &                   AB,nA,
     &             0.0D0,Temp,nA)
      Call DGEMM_('T','N',
     &            nB,nB,nA,
     &            1.0D0,AB,nA,
     &                  Temp,nA,
     &            0.0D0,BB,nB)
*                                                                      *
************************************************************************
*                                                                      *
*     (2) Do diagnostics on how poorly or good the
*         new basis spans the old space
*
      Error = DDot_(nA,AA,nA+1,AA,nA+1)
     &      - DDot_(nB,BB,nB+1,BB,nB+1)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine MltPrm(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &                  Final,nZeta,nComp,la,lb,A,RB,nHer,
     &                  Array,nArr,Ccoor,nOrdOp)
************************************************************************
*                                                                      *
* Object: to compute the multipole moments integrals with the          *
*         Gauss-Hermite quadrature.                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Modified to multipole moments November '90               *
************************************************************************
      use Her_RW, only: HerR, HerW, iHerR, iHerw
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp),
     &       Zeta(nZeta), ZInv(nZeta), Alpha(nAlpha), Beta(nBeta),
     &       rKappa(nZeta), P(nZeta,3), A(3), RB(3),
     &       Array(nZeta*nArr), Ccoor(3)
      Logical ABeq(3)
*
*     Statement function for Cartesian index
*
*     nElem(i) = (i+1)*(i+2)/2
*     Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*     iOff(ixyz) = ixyz*(ixyz+1)*(ixyz+2)/6
*     Index(ixyz,ix,iz) = Ind(ixyz,ix,iz) + iOff(ixyz)
*
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+1)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+1)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp+1)
      ipQxyz = nip
      nip = nip + nZeta*3*(la+1)*(lb+1)*(nOrdOp+1)
      If (nip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'MltPrm: nip-1.gt.nArr*nZeta')
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Write (6,*) ' Abend in MltPrm'
         Call Abend()
      End If
*
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt(' In MltPrm: A',' ',A,1,3)
      Call RecPrt(' In MltPrm: RB',' ',RB,1,3)
      Call RecPrt(' In MltPrm: Ccoor',' ',Ccoor,1,3)
      Call RecPrt(' In MltPrm: Kappa',' ',rKappa,nAlpha,nBeta)
      Call RecPrt(' In MltPrm: Zeta',' ',Zeta,nAlpha,nBeta)
      Call RecPrt(' In MltPrm: P',' ',P,nZeta,3)
      Write (6,*) ' In MltPrm: la,lb=',la,lb
#endif
*
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the contribution from the multipole moment operator
*
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),
     &            nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the cartesian components for the multipole moment
*     integrals. The integrals are factorized into components.
*
       Call Assmbl(Array(ipQxyz),
     &             Array(ipAxyz),la,
     &             Array(ipRxyz),nOrdOp,
     &             Array(ipBxyz),lb,
     &             nZeta,HerW(iHerW(nHer)),nHer)
*
*     Combine the cartesian components to the full one electron
*     integral.
*
      Call CmbnMP(Array(ipQxyz),nZeta,la,lb,nOrdOp,Zeta,rKappa,
     &            Final,nComp)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_real_array(ZInv)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Bingbing Suo                                     *
!***********************************************************************

! 28 dec 2007 -bsuo- the initial vectors for davidson diagonalization are
!                    the vectors obtained by diagnal h0 space will be us
!                    initial vector for mrci calculation.
! 18 jul 2007 -bsuo- multi-root calculation is revised to perform calcul
!                    nci_dim*mroot>max_civector, the roots are calculated
!                    by one, old subroutine for davidson diagonalization
!                    deleted. the subroutines to init the initial vector
!                    revised.
! 15 mar 2007 -bsuo- new method for multi-root calculation finished
! 23 feb 2007 -bsuo- revised by suo bing for multi-root calculation

! this module contains some routines to calculate the segmentation
! value of the partial loops, information of the molecular orbital
! and the davidson diagonalization calculation

subroutine mole_inf()

use gugaci_global, only: cm_cri, logic_calpro, logic_inivec_read, maxciiter, mroot, pror, vthrealp, vthreen, vthreresid
                         !, logic_tdav
use Definitions, only: wp, iwp, u5, u6

implicit none
integer(kind=iwp), parameter :: ncmd = 9
integer(kind=iwp) :: icmd, istatus, jcmd, ntit
character(len=4) :: command
character(len=72) :: line
#ifndef MOLPRO
#define _END_ 'END '
#endif
#ifdef _XIANEST_
#define _END_ '$END'
#endif
logical(kind=iwp) :: skip
character(len=4), parameter :: cmd(ncmd) = ['TITL','NRRO','MAXI','CPRO','PTHR','CONV','PROR','REST',_END_]

#ifndef MOLPRO
call rdnlst(u5,'GUGACI')
#endif

! init some program control logic variables
! traditional davidson diagonalization method is used
!logic_tdav = .true.
logic_inivec_read = .false.
logic_calpro = .false.
cm_cri = 0.05_wp
pror = 1.0e-4_wp
! set the default convergence threshold
vthreen = 1.0e-8_wp
vthrealp = 1.0e-6_wp
vthreresid = 1.0e-8_wp
mroot = 1
maxciiter = 30
ntit = 0
skip = .false.
jcmd = 0
do
  if (.not. skip) then
    read(u5,'(a)',iostat=istatus) line
    if (istatus < 0) call error(istatus)
    command = line(1:8)
    call upcase(command)
    if (command(1:1) == '*') cycle
#   ifdef _XIANEST_
    if (command(1:4) == '$MRC') cycle
#   endif
    if (command == ' ') cycle
    jcmd = 0
    do icmd=1,ncmd
      if (command == cmd(icmd)) jcmd = icmd
    end do
  end if
  skip = .false.
  select case (jcmd)
    case (1)
      !---  process title    command -----------------------------------
      do
        read(u5,'(a)',iostat=istatus) line
        if (istatus < 0) call error(istatus)
        command = line(1:8)
        call upcase(command)
        if (command(1:1) == '*') cycle
        jcmd = 0
        do icmd=1,ncmd
          if (command == cmd(icmd)) jcmd = icmd
        end do
        if (jcmd /= 0) then
          skip = .true.
          exit
        end if
        ntit = ntit+1
      end do

    case (2)
      !---  process nrroot command -------------------------------------
      do
        read(u5,'(a)',iostat=istatus) line
        if (istatus < 0) call error(istatus)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=istatus) mroot
      if (istatus > 0) call error(istatus)

    case (3)
      !---  process Maxiterations command ------------------------------
      do
        read(u5,'(a)',iostat=istatus) line
        if (istatus < 0) call error(istatus)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=istatus) maxciiter
      if (istatus > 0) call error(istatus)

    case (4)
      !---  process Calculate property command -------------------------
      logic_calpro = .true.

    case (5)
      !---  process Thresh print command -------------------------------
      do
        read(u5,'(a)',iostat=istatus) line
        if (istatus < 0) call error(istatus)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=istatus) cm_cri
      if (istatus > 0) call error(istatus)

    case (6)
      !---  process Convergence threshold command ----------------------
      do
        read(u5,'(a)',iostat=istatus) line
        if (istatus < 0) call error(istatus)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=istatus) vthreen,vthrealp,vthreresid
      if (istatus > 0) call error(istatus)

    case (7)
      !---  process print orbital command ------------------------------
      do
        read(u5,'(a)',iostat=istatus) line
        if (istatus < 0) call error(istatus)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=istatus) pror
      if (istatus > 0) call error(istatus)

    case (8)
      !---  process restart command ------------------------------------

    case (9)
      !--- End of GUGACI input -----------------------------------------
      exit

    case default
      write(u6,*) 'input: illegal keyword'
      write(u6,'(a,a)') 'command=',command
#     ifndef MOLPRO
      call abend()
#     endif
  end select

end do

call mole_inf_molcas()

return

contains

subroutine error(code)

  integer(kind=iwp), intent(in) :: code

  if (code < 0) then
    write(u6,*) 'input: end of input file encountered'
  else
    write(u6,*) 'input: error while reading input!'
  end if
  write(u6,'(a,a)') 'last command: ',command
# ifndef MOLPRO
  call abend()
# endif

end subroutine error

end subroutine mole_inf

subroutine mole_inf_molcas()

use gugaci_global, only: ibsm_ext, iesm_ext, int_dd_offset, iref_occ, logic_assign_actorb, logic_mr, lsm, lsm_inn, lsmorb, LuDrt, &
                         n_ref, nabc, ng_sm, ngw2, ngw3, ngw4, nlsm_all, nlsm_bas, nlsm_dbl, nlsm_ext, nlsm_frz, noidx, norb_act, &
                         norb_all, norb_dbl, norb_dz, norb_ext, norb_frz, norb_inn, ns_sm, nstart_act, spin !, logic_mrelcas
use Symmetry_Info, only: Mul
use Constants, only: Half
use Definitions, only: iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp) :: i, idisk, idum(1), idx, im, im_lr_sta, iml, imr, imrcas_case, iorb, ispin, itmp, j, l, lr, nact_sm, &
                     nlsm_act(mxSym), nlsm_inn(mxSym), lsmtmp(mxSym), ngsm, ni, norb_all_tmp

!open(nf1,file='drt.inp')
!read(nf1,*)
!read(nf1,*) mroot,mth_eigen,kin
!read(nf1,*) n_electron,spin,ng_sm,ns_sm,cm_cri
!read(nf1,*) nlsm_all(1:ng_sm)
!read(nf1,*) nlsm_frz(1:ng_sm)
!read(nf1,*) nlsm_dbl(1:ng_sm)
!read(nf1,*) nlsm_act(1:ng_sm)
!read(nf1,*) log_thre
! merge into molcas
! write date into cidrt for ci calculation
noidx = 0
idisk = 0
call idafile(ludrt,2,noidx,2,idisk)
! group symmetry
call idafile(ludrt,2,idum,1,idisk)
ng_sm = idum(1)
! state symmetry
call idafile(ludrt,2,idum,1,idisk)
ns_sm = idum(1)
! number of roots to be cal
call idafile(ludrt,2,idum,1,idisk)
! number of corelation electrons
call idafile(ludrt,2,idum,1,idisk)
!n_electron = idum(1)
! number of active electrons
call idafile(ludrt,2,idum,1,idisk)
!nactel = idum(1)
! spin symmetry of the state, 2s+1
call idafile(ludrt,2,idum,1,idisk)
ispin = idum(1)
! dbl orb
call idafile(ludrt,2,nlsm_dbl,8,idisk)
! act orb
call idafile(ludrt,2,nlsm_act,8,idisk)
! all correlated orb
call idafile(ludrt,2,nlsm_all,8,idisk)
! num. basis
call idafile(ludrt,2,nlsm_bas,8,idisk)
spin = (ispin-1)*Half
nlsm_frz(:) = 0

norb_frz = 0
norb_dbl = 0
norb_act = 0
norb_dz = 0
norb_all = 0
noidx = 0
idx = 0
ni = 0
do i=1,ng_sm
  norb_frz = norb_frz+nlsm_frz(i)
  norb_dbl = norb_dbl+nlsm_dbl(i)
  norb_act = norb_act+nlsm_act(i)
  nlsm_inn(i) = nlsm_frz(i)+nlsm_dbl(i)+nlsm_act(i)
  nlsm_ext(i) = nlsm_all(i)-nlsm_inn(i)
  norb_all = norb_all+nlsm_all(i)
  noidx(i) = idx
  idx = idx+nlsm_all(i)
  lsmorb(ni+1:idx) = i
  ni = idx
end do
norb_inn = norb_frz+norb_dbl+norb_act
norb_ext = norb_all-norb_inn
norb_dz = norb_dbl+norb_frz

nstart_act = norb_dz+1
ngw2(:) = 0
ngw3(:) = 0
ngw4(:) = 0
ngw2(1) = 0
ngw2(2) = 0
ngw3(1) = 0
ngw3(2) = 0
ngw3(3) = 0
do i=1,norb_all
  ngw2(i+2) = ngw2(i+1)+i
  ngw3(i+3) = ngw3(i+2)+ngw2(i+2)
  ngw4(i+4) = ngw4(i+3)+ngw3(i+3)
end do
nabc = norb_ext-2+ngw2(norb_ext-1)+ngw3(norb_ext)

iorb = 0
do i=1,ng_sm
  do j=1,nlsm_frz(i)
    iorb = iorb+1
    lsm_inn(iorb) = i
  end do
end do
do i=1,ng_sm
  do j=1,nlsm_dbl(i)
    iorb = iorb+1
    lsm_inn(iorb) = i
  end do
end do
do i=1,ng_sm
  do j=1,nlsm_act(i)
    iorb = iorb+1
    lsm_inn(iorb) = i
  end do
end do

nact_sm = 1
do im=1,norb_inn
  if (lsm_inn(im) > nact_sm) nact_sm = lsm_inn(im)
end do

norb_all_tmp = 0
do ngsm=1,ng_sm
  norb_all_tmp = norb_all_tmp+nlsm_all(ngsm)
end do
if (norb_all_tmp /= norb_all) then
  write(u6,*) '  input num.of orbital err! check again!'
# ifndef MOLPRO
  call abend()
# endif
end if

do l=1,norb_inn
  lr = norb_all-l+1
  lsm(lr) = lsm_inn(l)
end do

lr = 0
int_dd_offset(1:8,1:8) = 0
do im=1,ng_sm
  im_lr_sta = 0
  do iml=1,ng_sm
    imr = Mul(im,iml)
    if (imr > iml) cycle
    int_dd_offset(iml,imr) = im_lr_sta
    int_dd_offset(imr,iml) = im_lr_sta
    if (iml == imr) im_lr_sta = im_lr_sta+nlsm_ext(iml)*(nlsm_ext(iml)-1)/2
    if (iml /= imr) im_lr_sta = im_lr_sta+nlsm_ext(iml)*nlsm_ext(imr)
  end do
  do l=1,nlsm_ext(im)
    lr = lr+1
    lsm(lr) = im
  end do
end do
lsm_inn(norb_inn+1) = lsm(norb_ext)

logic_mr = .false.
!logic_mrelcas = .false.
logic_assign_actorb = .false.

call idafile(ludrt,2,idum,1,idisk)
imrcas_case = idum(1)
if (imrcas_case == 2) then
  logic_mr = .true.
  call idafile(ludrt,2,idum,1,idisk)
  n_ref = idum(1)
  do i=1,n_ref
    call idafile(ludrt,2,iref_occ(1,i),norb_inn,idisk)
  end do
end if
!if (imrcas_case == 4) then
!  logic_mrelcas = .true.
!end if

do i=1,ng_sm   !norb_inn
  lsmtmp(i) = 0
end do
do i=1,norb_inn
  lsmtmp(lsm_inn(i)) = lsmtmp(lsm_inn(i))+1
end do

itmp = 0
ibsm_ext(:) = 0
iesm_ext(:) = 0
do i=1,ng_sm
  ibsm_ext(i) = itmp+1
  itmp = itmp+nlsm_ext(i)
  iesm_ext(i) = itmp
end do

!***********************************************************************
#ifdef _DEBUG
idebug = 1
if (idebug == 1) then
  write(u6,1001)
  write(u6,1002) norb_all,norb_frz,norb_dz,norb_inn,norb_ext
  write(u6,1002) nlsm_all(1:ng_sm)
  write(u6,1002) nlsm_frz(1:ng_sm)
  write(u6,1002) nlsm_dbl(1:ng_sm)
  write(u6,1002) nlsm_inn(1:ng_sm)
  write(u6,1002) nlsm_ext(1:ng_sm)
  write(u6,*) 'lsm inn, imrcas_case',imrcas_case
  write(u6,1002) lsm_inn(1:norb_inn)
  write(u6,*) 'lsm all',norb_all
  write(u6,1002) (lsm(i),i=norb_all,1,-1)
end if
1001 format(1x,'all frz dz inn ext')
1002 format(8(1x,i3))
#endif
!***********************************************************************

return

end subroutine mole_inf_molcas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ICISPC(MNRS10,MXRS30,IPRNT)
*
* Obtain internal CI spaces relevant for MRSDCI
*       /STRINP/+/LUCINP/ = > /CICISP/
* Jeppe Olsen , Dec 1990
*
* Input
* =====
* Information in STRINP
*
* Output
* ======
* Common block CICISP
*
* Internal CI spaces
********************************************************************
*   *  Basic space  * Allowed internal excit * Delta NA * Delta Nb *
********************************************************************
* 1 *  Zero order   *           0            *    0     *    0     *
********************************************************************
* ====================
*. Input common blocks
* ====================
*./LUCINP : EXTSPC is used
#include "detdim.fh"
*./STRINP/
#include "strinp_mclr.fh"
*/ORBINP/
#include "orbinp_mclr.fh"
* ====================
*. Output common block
* ====================
#include "cicisp_mclr.fh"
* NICISP : Number of internal CI spaces constructed
* IASTFI : Alpha string type for internal CI space
* IBSTFI : Beta string type for internal CI space
* IACTI  : Given internal space is active
* MXR3IC : Max number of elecs in RAS 3 space for internal CI space
* MNR1IC : Min number of elecs in RAS 1 space for internal CI space
* IZCI   : Internal zero order space
* IRCI(IEX,DELTAA+5,DELTAB+5) : Number of zero order space
* NELCI : Number of electrons per CI space
* obtained by (IEX-1) fold internal excitation , with a NAEL + DELTAA
* alpha electrons and  NBEL + DELTAB beta electrons
*
*
      NTEST = 00000
      NTEST = MAX(NTEST,IPRNT)
*
      ICI = 1
      MNR1IC(ICI) = MNRS10
      MXR3IC(ICI) = MXRS30
      IASTFI(ICI) = IAZTP
      IBSTFI(ICI) = IBZTP
      NAELCI(ICI) = NELEC(IAZTP)
      NBELCI(ICI) = NELEC(IBZTP)
      NELCI(ICI)  = NAELCI(ICI)+NBELCI(ICI)
      IACTI(1) = 1
      NICISP = ICI
* EAW Just zero order
      Call iCopy(3*49,[0],0,irci,1)
* EAW
*. Number and distribution of electrons in each space
      DO 100 IEX = 1, 3
      DO 101 IDA = -4,2
      DO 102 IDB = -4,2
        IF(IRCI(IEX,IDA+5,IDB+5).NE.0) THEN
           ICI = IRCI(IEX,IDA+5,IDB+5)
           NAELCI(ICI) = NELEC(IASTFI(ICI))
           NBELCI(ICI) = NELEC(IBSTFI(ICI))
           NELCI(ICI) = NAELCI(ICI)+NBELCI(ICI)
        END IF
102   CONTINUE
101   CONTINUE
100   CONTINUE
*
*. Default max in RAS1 and min in RAS3
      DO 150 ICI = 1, NICISP
        MXR1IC(ICI) = MIN(2*NORB1,NELCI(ICI))
        MNR3IC(ICI) = MAX(0,NELCI(ICI)-2*(NORB1+NORB2))
150   CONTINUE
*
      IF(NTEST .GE. 1 ) THEN
        WRITE(6,*) ' Number of internal CI spaces ', NICISP
        WRITE(6,*)
     &  ' Space a-type b-type nael nbel mnrs1 mxrs1 mnrs3 mxrs3 '
        WRITE(6,*)
     &  ' ===================================================== '
         DO 1020 ICI = 1, NICISP
          IF(IACTI(ICI).EQ.1)
     &    WRITE(6,'(I5,2I7,2I5,4I6)')
     &    ICI,IASTFI(ICI),IBSTFI(ICI),NAELCI(ICI),NBELCI(ICI),
     &    MNR1IC(ICI),MXR1IC(ICI),MNR3IC(ICI),MXR3IC(ICI)
1020    CONTINUE
      END IF
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombOnly0(IntegralOption,tau,Mode,Add,PackedD,PackedF,nD,FactC,ip_D,F)
! Thomas Bondo Pedersen, September 2010.
!
!          OLD CODE
!
! Purpose: Compute Coulomb contribution to Fock matrix using local
!          Density Fitting coefficients. Use only for debugging!
!          Poor performance!
!
! Args:    - IntegralOption (integer)
!              111  => use two-electron integrals computed from
!                      LDF coefficients (for debugging)
!              222  => use conventional two-electron integrals
!                      (for debugging)
!              333  => use conventional or LDF two-electron
!                      integrals depending on positivity of the
!                      latter (for debugging)
!              all other values => use production-level LDF code
!              (INPUT)
!          - tau (real*8) integral prescreening threshold (INPUT).
!            Only used with IntegralOption=111.
!          - Mode (integer) 1:robust,2:nonrobust,3:half-and-half
!          - Add (boolean): .True. if Coulomb contribution should be
!            added to the Fock matrix (INPUT). Not available in
!            parallel execution!!
!          - PackedD (boolean): .True. if density matrices
!            are stored in lower triangular format; else quadratic
!            storage (INPUT)
!          - PackedF (boolean): .True. if Fock matrices
!            are stored in lower triangular format; else quadratic
!            storage (INPUT)
!          - nD: Number of densities/Fock matrices (INPUT)
!          - FactC(nD): scaling factor for each density (INPUT)
!          - ip_D(nD): pointers to nD density matrices (if PackedD:
!            lower triangular storage) (INPUT)
!          - F(*,nD): nD Fock matrices (if PackedF:
!            lower triangular storage) (INPUT/OUTPUT)
!
!          If (Add):  [NOT IMPLEMENTED IN PARALLEL]
!   (1)       F(uv) = F(uv) + FactC * sum_kl (uv|kl)*D(kl)
!          Else:
!   (2)       F(uv) = FactC * sum_kl (uv|kl)*D(kl)
!
!          where the integrals are given by the robust LDF
!          representation
!
!          (uv|kl) = ([uv]|kl) + (uv|[kl]) - ([uv]|[kl])
!
!          or the non-robust representation
!
!          (uv|kl) = ([uv]|[kl])
!
!          or the half-and-half representation
!
!          (uv|kl) = 0.5*([uv]|kl) + 0.5*(uv|[kl])
!
!          and the fitted products are given by
!
!          |[uv]) = sum_J C(uv,J) |J)
!
!          where the fitting functions |J) are centered on the atom
!          pair to which the product |uv) belongs.
!
!          In more detail (assuming robust fitting representation):
!
!          F(uv) = FactC * {sum_J C(uv,J)*W(J) + sum_K (uv|K)*V(K)}
!
!          W(J) = sum_kl (J|kl)*D(kl) - sum_K (J|K)*V(K)
!
!          V(K) = sum_kl C(kl,K)*D(kl)
!
! NOTES:
!   - The density matrices are assumed to be symmetric.
!   - It is the complete sum over kl in Eqs(1,2)! This means that
!     the input density matrices should NOT be scaled by 2 on the
!     off-diagonal (scaling factors are handled internally).
!   - LDF information must be properly set up before calling this
!     routine (use subroutine LDF_X_Init).
!   - Two-center functions may or mat not be included in the fitting
!     basis for a given atom pair.
!   - The algorithm is NOT integral driven. This means that 3-center
!     integrals (4-center integrals if 2-center fitting functions
!     are included) are computed several times, causing quite poor
!     performance.
!   - The max number of processes for which the algorithm can
!     possibly scale well equals the number of LDF atom pairs.
!   - No screening has been implemented.
!   - Add is not implemented in parallel !!!
!
! Outline of the algorithm (robust representation):
! =================================================
!
! *If (Mode=3): FactC := 0.5*FactC
!
! *Scale off-diagonal density blocks:
!  D[u_A v_B] <-- 2*D[u_A v_B] iff A != B
!
! *Parallel loop over atom pairs AB (A>=B):
!    - V(J_AB) = sum_[u_A v_B] C(u_A v_B,J_AB)*D(u_A v_B)
! *End loop AB
! Add V over nodes.
!
! *Parallel loop over atom pairs AB (A>=B):
!    *Loop over atom pairs CD (C>=D):
!       - F(u_A v_B) = F(u_A v_B)
!                    + sum_[K_CD] (u_A v_B | K_CD)*V(K_CD)
!       - W(J_AB) = W(J_AB)
!                 + sum_[k_C l_D] (J_AB | k_C l_D)*D(k_C l_D)
!       - W(J_AB) = W(J_AB)
!                 - sum_[K_CD] (J_AB | K_CD)*V(K_CD)
!    *End loop CD
!    - F(u_A v_B) = F(u_A v_B)
!                 + sum_[J_AB] C(u_A v_B,J_AB)*W(J_AB)
! *End loope AB
! Add F over nodes
!
! Note that both arrays V and F are stored locally as O(N) arrays,
! which should keep the communication bottleneck at a minimum as the
! system size grows.

#ifdef _MOLCAS_MPP_
use Para_Info, only: nProcs, Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
#ifdef _DEBUGPRINT_
use Constants, only: One
#endif
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IntegralOption, Mode, nD, ip_D(nD)
real(kind=wp), intent(in) :: tau
logical(kind=iwp), intent(in) :: Add, PackedD, PackedF
real(kind=wp), intent(inout) :: FactC(nD), F(*)
logical(kind=iwp) :: UsePartPermSym
integer(kind=iwp) :: nBas, iD, l, l_DBlocks, l_FBlocks, l_VBlocks, l_FactC
integer(kind=iwp), allocatable :: DBlocks(:), FBlocks(:), VBlocks(:)
real(kind=wp), allocatable :: FactCBak(:)
character(len=*), parameter :: SecNam = 'LDF_Fock_CoulombOnly0'
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: DoTest
real(kind=wp) :: x, y
logical(kind=iwp), external :: LDF_X_IsSet, LDF_TestBlockMatrix
integer(kind=iwp), external :: LDF_nAtom
#endif
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

! Return if nothing to do
if (nD < 1) return

! Get number of basis functions (from localdf_bas.fh)
nBas = nBas_Valence
if (nBas < 1) then
  call WarningMessage(1,SecNam//': nBas<1 -- Fock matrix NOT computed!')
  write(u6,'(A,I9)') 'nBas=',nBas
  call xFlush(u6)
  return
end if

#ifdef _DEBUGPRINT_
if (.not. LDF_X_IsSet()) then
  call WarningMessage(2,SecNam//': LDF data not initialized!')
  call LDF_Quit(1)
end if
#endif

#ifdef _MOLCAS_MPP_
if (Add) then
  if ((nProcs > 1) .and. Is_Real_Par()) then
    write(u6,'(A,A)') SecNam,': >>Add<< feature not implemented in parallel execution!'
    call LDF_NotImplemented()
  end if
end if
#endif

! For half-and-half integral representation, scale FactC by 1/2.
! Save a copy of FactC (restored at the end)
if (Mode == 3) then
  l_FactC = nD
  call mma_allocate(FactCBak,l_FactC,label='FactCBak')
  call dCopy_(nD,FactC,1,FactCBak,1)
  call dScal_(nD,Half,FactC,1)
else
  l_FactC = 0
end if

! Initialize Fock matrices (if not Add)
if (PackedF) then
  l = nBas*(nBas+1)/2
else
  l = nBas**2
end if
if (.not. Add) then
  F(1:nD*l) = Zero
end if

! Allocate and set blocked density matrices (atom pair blocks)
l_DBlocks = nD
call mma_allocate(DBlocks,l_DBlocks,label='DBlk_P')
#ifdef _DEBUGPRINT_
x = real(NumberOfAtomPairs,kind=wp)
y = real(LDF_nAtom(),kind=wp)*(real(LDF_nAtom(),kind=wp)+One)*Half
DoTest = int(x-y) == 0
#endif
do iD=1,nD
  call LDF_AllocateBlockMatrix('Den',DBlocks(iD))
  call LDF_Full2Blocked(Work(ip_D(iD)),PackedD,DBlocks(iD))
# ifdef _DEBUGPRINT_
  if (DoTest) then
    if (.not. LDF_TestBlockMatrix(DBlocks(iD),PackedD,Work(ip_D(iD)))) then
      call WarningMessage(2,SecNam//': block matrix test failure')
      write(u6,'(A,I4,A,I9,3X,A,L1)') 'Density matrix',iD,' at location',ip_D(iD),'Packed: ',PackedD
      call LDF_Quit(1)
    end if
  end if
# endif
  call LDF_ScaleOffdiagonalMatrixBlocks(DBlocks(iD),Two)
end do

! Allocate and set blocked Fock matrices (atom pair blocks)
l_FBlocks = nD
call mma_allocate(FBlocks,l_FBlocks,label='FBlk_P')
do iD=1,nD
  call LDF_AllocateBlockMatrix('Fck',FBlocks(iD))
  call LDF_Full2Blocked(F((iD-1)*l+1),PackedF,FBlocks(iD))
end do

if (IntegralOption == 111) then
  ! Compute Fock matrix using LDF integrals (debug)
  call WarningMessage(0,SecNam//': Using integrals from LDF coefficients!')
  call xFlush(u6)
  UsePartPermSym = .true.
  if (Mode == 3) then
    call LDF_FVIFC(UsePartPermSym,Mode,max(tau,Zero),nD,FactCBak,DBlocks,FBlocks)
  else
    call LDF_FVIFC(UsePartPermSym,Mode,max(tau,Zero),nD,FactC,DBlocks,FBlocks)
  end if
else if (IntegralOption == 222) then
  ! Compute Fock matrix using conventional integrals (debug)
  call WarningMessage(0,SecNam//': Using conventional integrals!')
  call xFlush(u6)
  UsePartPermSym = .true.
  call LDF_FCI(UsePartPermSym,nD,FactC,DBlocks,FBlocks)
else if (IntegralOption == 333) then
  ! Compute Fock matrix using conventional or LDF integrals
  ! depending on positivity of the latter (debug)
  call WarningMessage(0,SecNam//': Using PSD (LDF or conv.) integrals!')
  call xFlush(u6)
  UsePartPermSym = .true.
  if (Mode == 3) then
    call LDF_FTst(UsePartPermSym,Mode,max(tau,Zero),nD,FactCBak,DBlocks,FBlocks)
  else
    call LDF_FTst(UsePartPermSym,Mode,max(tau,Zero),nD,FactC,DBlocks,FBlocks)
  end if
else
  ! Allocate Coulomb intermediates
  l_VBlocks = nD
  call mma_allocate(VBlocks,l_VBlocks,label='VBlk_P')
  do iD=1,nD
    call LDF_AllocateBlockVector('CIn',VBlocks(iD))
  end do
  ! Compute Coulomb intermediates,
  ! V(J) = sum_uv C(uv,J)*D(uv)
  ! for each density matrix
  call LDF_ComputeCoulombIntermediates0(nD,DBlocks,VBlocks)
  ! Compute Coulomb contributions
  call LDF_Fock_CoulombOnly0_(Mode,nD,FactC,DBlocks,VBlocks,FBlocks)
  ! Deallocate Coulomb intermediates
  do iD=1,nD
    call LDF_DeallocateBlockVector('CIn',VBlocks(iD))
  end do
  call mma_deallocate(VBlocks)
end if

! Get full storage (triangular or quadratic) Fock matrices from
! blocked ones.
do iD=1,nD
  call LDF_Blocked2Full(FBlocks(iD),PackedF,F((iD-1)*l+1))
end do

! Restore FactC
if (l_FactC > 0) then
  call dCopy_(nD,FactCBak,1,FactC,1)
  call mma_deallocate(FactCBak)
end if

! Deallocation
do iD=1,nD
  call LDF_DeallocateBlockMatrix('Fck',FBlocks(iD))
end do
call mma_deallocate(FBlocks)
do iD=1,nD
  call LDF_DeallocateBlockMatrix('Den',DBlocks(iD))
end do
call mma_deallocate(DBlocks)

end subroutine LDF_Fock_Coulombonly0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
      SUBROUTINE DRT_m(IDRT0,IDOWN0,IVER,IDRT,IDOWN)
C
C     PURPOSE: USING THE UNRESTRICTED DRT TABLE GENERATED BY DRT0 AND
C              THE MASKING ARRAY PRODUCED BY RESTR COPY ALL VALID
C              VERTICES FROM THE OLD TO THE NEW DRT TABLE
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "gugx.fh"
#include "rasdim.fh"
#include "general.fh"
C
      DIMENSION IDRT0(NVERT0,5),IDOWN0(NVERT0,0:3)
      DIMENSION IVER(NVERT0)
      DIMENSION IDRT(NVERT,5),IDOWN(NVERT,0:3)
C
      DO IV=1,NVERT0
        IVNEW=IVER(IV)
        IF(IVNEW.EQ.0) GOTO 30
        DO ITAB=1,5
          IDRT(IVNEW,ITAB)=IDRT0(IV,ITAB)
        END DO
        DO IC=0,3
          ID=IDOWN0(IV,IC)
          IDNEW=0
          IF(ID.NE.0) IDNEW=IVER(ID)
          IDOWN(IVNEW,IC)=IDNEW
        END DO
  30    CONTINUE
      END DO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine writedrt(id)

use gugadrt_global, only: ja, jb, jd, jj, jm, js, jt, jv, kk, ludrt, no, norb_inn
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: id
integer(kind=iwp) :: i, idisk, idum(1), idx(2), jbuf(4*(id+1)), nc

nc = 1
do i=0,id
  jbuf(nc:nc+3) = jj(1:4,i)
  nc = nc+4
end do
idisk = 0
! number of nodes
call idafile(ludrt,2,idx,2,idisk)
idisk = idx(2)
idum(1) = id
call idafile(ludrt,1,idum,1,idisk)
call idafile(ludrt,1,ja,id,idisk)
call idafile(ludrt,1,jb,id,idisk)
call idafile(ludrt,1,jm,id,idisk)
call idafile(ludrt,1,jbuf,4*(id+1),idisk)
call idafile(ludrt,1,kk(0),1+id,idisk)
call idafile(ludrt,1,no(0),norb_inn+2,idisk)
idum(1) = jv
call idafile(ludrt,1,idum,1,idisk)
call idafile(ludrt,1,jd,8,idisk)
call idafile(ludrt,1,jt,8,idisk)
call idafile(ludrt,1,js,8,idisk)

return

end subroutine writedrt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
!               2010, Jonas Bostrom                                    *
!               2021, Roland Lindh                                     *
!***********************************************************************

subroutine ChoMP2_deallocate(irc)
!
! Purpose: to deallocate memory of the  Cholesky MP2 program.

use ChoMP2, only: ChoMP2_allocated, iFirst, iFirstS, LiMatij, LiPQprod, LiT1am, LnBatOrb, LnMatij, LnOcc, LnPQprod, LnT1am, lUnit, &
                  NumBatOrb, NumOcc
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc

irc = 0

call ChoMP2g_deallocate(irc)

if (ChoMP2_allocated) then

  call mma_deallocate(LiPQprod)
  call mma_deallocate(LnPQprod)
  call mma_deallocate(LnBatOrb)
  call mma_deallocate(NumBatOrb)
  call mma_deallocate(lUnit)
  call mma_deallocate(LiMatij)
  call mma_deallocate(LnMatij)
  call mma_deallocate(LiT1am)
  call mma_deallocate(LnT1am)
  call mma_deallocate(LnOcc)
  call mma_deallocate(NumOcc)
  call mma_deallocate(iFirstS)
  call mma_deallocate(iFirst)

  ChoMP2_allocated = .false.

end if

end subroutine ChoMP2_deallocate

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine DrvN1_mck(Grad,nGrad)
!***********************************************************************
!                                                                      *
! Object: to compute the molecular gradient contribution due to the    *
!         nuclear repulsion energy.                                    *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October 1991                                             *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep, iChBas
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
#include "Molcas.fh"
#include "disp.fh"
integer(kind=iwp) :: iCar, iCnt, iCnttp, iComp, iDCRR(0:7), igu, igv, iIrrep, iR, jCnt, jCntMx, jCnttp, LmbdR, mdc, ndc, nDCRR, &
                     nDisp, nOp
real(kind=wp) :: A(3), B(3), Fact, PreFct, ps, r12, RB(3), ZA, ZAZB
integer(kind=iwp), external :: iPrmt, NrOpr
logical(kind=iwp), external :: EQ, TstFnc

iIrrep = 0
mdc = 0
! Loop over centers with the same change
do iCnttp=1,nCnttp
  if (iCnttp > 1) mdc = mdc+dbsc(iCnttp-1)%nCntr
  ZA = dbsc(iCnttp)%Charge
  if (ZA == Zero) cycle
  ! Loop over all unique centers of this group
  do iCnt=1,dbsc(iCnttp)%nCntr
    A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

    ndc = 0
    do jCnttp=1,iCnttp
      if (jCnttp > 1) ndc = ndc+dbsc(jCnttp-1)%nCntr
      ZAZB = ZA*dbsc(jCnttp)%Charge
      if (ZAZB == Zero) cycle
      jCntMx = dbsc(jCnttp)%nCntr
      if (iCnttp == jCnttp) jCntMx = iCnt
      do jCnt=1,jCntMx
        B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

        Fact = One
        ! Factor due to resticted summation
        if (EQ(A,B)) Fact = Half

        ! Find the DCR for the two centers

        call DCR(LmbdR,dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,iDCRR,nDCRR)

        PreFct = Fact*ZAZB*real(nIrrep,kind=wp)/real(LmbdR,kind=wp)
        do iR=0,nDCRR-1
          call OA(iDCRR(iR),B,RB)
          nOp = NrOpr(iDCRR(iR))
          if (EQ(A,RB)) cycle
          r12 = sqrt((A(1)-RB(1))**2+(A(2)-RB(2))**2+(A(3)-RB(3))**2)

          ! The factor u/g will ensure that the value of the
          ! gradient in symmetry adapted and no symmetry basis
          ! will have the same value.

          nDisp = IndDsp(mdc+iCnt,iIrrep)
          igu = nIrrep/dc(mdc+iCnt)%nStab
          do iCar=0,2
            iComp = 2**iCar
            if (TstFnc(dc(mdc+iCnt)%iCoSet,iIrrep,iComp,dc(mdc+iCnt)%nStab)) then
              nDisp = nDisp+1
              Grad(nDisp) = Grad(nDisp)-One/real(igu,kind=wp)*PreFct*(A(iCar+1)-RB(iCar+1))/(r12**3)
            end if
          end do

          nDisp = IndDsp(ndc+jCnt,iIrrep)
          igv = nIrrep/dc(ndc+jCnt)%nStab
          do iCar=0,2
            iComp = 2**iCar
            if (TstFnc(dc(ndc+jCnt)%iCoSet,iIrrep,iComp,dc(ndc+jCnt)%nStab)) then
              nDisp = nDisp+1
              ps = real(iPrmt(nOp,iChBas(2+iCar)),kind=wp)
              Grad(nDisp) = Grad(nDisp)+ps*One/real(igv,kind=wp)*PreFct*(A(iCar+1)-RB(iCar+1))/(r12**3)
            end if
          end do
        end do

      end do
    end do
  end do
end do

return

end subroutine DrvN1_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
*     LHR function: convert full Hessian indices in lower triangular index
*
      Integer Function LHR(i,iAtom,j,jAtom)
      ivv1 = (iAtom-1)*3 + i
      ivv2 = (jAtom-1)*3 + j
      ivv  = Max(ivv1,ivv2)
      LHR  = ivv*(ivv-3)/2 + ivv1 + ivv2
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Off_Diagonal(B1,nB,iB1s,iB1e,B2,iB2s,iB2e)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nB, iB1s, iB1e, iB2s, iB2e
real(kind=wp), intent(_OUT_) :: B1(nB,iB1s:iB1e)
real(kind=wp), intent(in) :: B2(nB,iB2s:iB2e)
integer(kind=iwp) :: i, j

do j=iB2s,iB2e
  do i=iB1s,iB1e
    B1(j,i) = B2(i,j)
  end do
end do

return

end subroutine Off_Diagonal

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRDRT_MCLR(NVERT,DRT,DOWN)
      IMPLICIT INTEGER (A-Z)
      DIMENSION DRT(NVERT,5),DOWN(NVERT,0:3)
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,*)' VERT      L  N    A  B  C      CHAINING INDICES.'
      CALL XFLUSH(6)
      DO 10 V=1,NVERT
        WRITE(6,1000) V,(DRT(V,I),I=1,5),(DOWN(V,S),S=0,3)
      CALL XFLUSH(6)
10    CONTINUE
      WRITE(6,*)
      CALL XFLUSH(6)
      RETURN
1000  FORMAT(1X,I4,5X,2I3,2X,3I3,5X,4I4)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Fix_UDC(iRow_c,nLambda,AtomLbl,nsAtom,nStab,Remove)
      Implicit Real*8 (A-H,O-Z)
************************************************************************
*                                                                      *
*     Object: Replace the fragment specifications with actual          *
*             constraint specifications.                               *
*             Remove constraints to be ignored.                        *
*                                                                      *
************************************************************************
#include "Molcas.fh"
      External Get_Ln
      Character*180 Get_Ln, Line, Line2, Lines(iRow_c)
      Character*16 FilNam
      Character*180 Label1, Label2, Label3, Label4, FragLabels(iRow_c),
     &              SoftLabels(iRow_c)
      Character AtomLbl(nsAtom)*(LENIN)
      Integer nStab(nsAtom), FragZMat(iRow_c,2),ZMatOffset
      Logical Ignore, Values, Remove
      External Get_SuperName
      Character*100 Get_SuperName
      Character*100 SuperName
*                                                                      *
************************************************************************
*                                                                      *
      If (iRow_c.le.1) Return
      iRow_c_Save=iRow_c
      nLambda_save=nLambda
      SuperName=Get_SuperName()
*                                                                      *
************************************************************************
*                                                                      *
*     Open files for user defined internal constraints.
*
      Lu_UDC=91
      FilNam='UDC'
      Lu_UDC=IsFreeUnit(Lu_UDC)
      Call Molcas_Open(Lu_UDC,FilNam)
      ReWind(Lu_UDC)
*
      Lu_TMP=Lu_UDC+1
      FilNam='UDCTMP'
      Lu_TMP=IsFreeUnit(Lu_TMP)
      Call Molcas_Open(Lu_TMP,FilNam)
      ReWind(Lu_TMP)
*                                                                      *
************************************************************************
*                                                                      *
*     Process the content of LU_UDC and put it onto LU_TMP
*
      iRow_c=0 ! Number of lines in the section
      nZMat=0  ! Number of additional lines with constraints
      nFrag=0  ! Number of fragment constraints
      nSoft=0  ! Number of default soft constraints
      Values=.False.
*
      iZMat=0
      ZMatOffset=0
 100  Continue
         Line=Get_Ln(LU_UDC)   ! Read the line
         Call UpCase(Line)
*
         If (Line(1:4).eq.'VALU') Values=.True.
         If (Line(1:4).ne.'END') Then
*
*           Read all possible continuation lines
*
            nLines=1
            Lines(nLines)=Line
            Do While (Index(Lines(nLines),'&').gt.0)
               nLines=nLines+1
               Lines(nLines)=Get_Ln(LU_UDC)
               Call UpCase(Lines(nLines))
            End Do
            iLine=1
            Line=Lines(iLine)
            iEq=Index(Line,'=')
*
*           If there are already some ZMAT constraints in the file,
*           start numbering from the next one
*
            If (Line(1:4) .eq. 'ZMAT') Then
               Read(Line(5:7),*) Num
               ZMatOffset=Max(ZMatOffset,Num)
            End If
*
            If (.Not.Values) Then
*
*           Find out if the primitive defaults to soft
*
            iFrst=iEq+1
            Call NxtWrd(Line,iFrst,iEnd)
            If ((Line(iFrst:iFrst+3).eq.'SPHE') .or.
     &          (Line(iFrst:iFrst+3).eq.'TRAN') .or.
     &          (Line(iFrst:iFrst+3).eq.'EDIF') .or.
     &          (Line(iFrst:iFrst+3).eq.'NAC ')) Then
               nSoft=nSoft+1
               iFrst=1
               Call NxtWrd(Line,iFrst,iEnd)
               SoftLabels(nSoft)=Line(iFrst:iEnd)
            End If
*
*           Modify the lines with Fragments to Z-matrix format
*
            iFrst=iEq+1
            Call NxtWrd(Line,iFrst,iEnd)
            If (Line(iFrst:iFrst+7).eq.'FRAGMENT') Then
*
*              Here we do the expansion
*
               nFrag=nFrag+1
               FragZMat(nFrag,1)=0
               FragZMat(nFrag,2)=0
               iFrst=1
               Call NxtWrd(Line,iFrst,iEnd)
               FragLabels(nFrag)=Line(iFrst:iEnd)
               iFrst=Index(Line,'FRAGMENT')
               Call NxtWrd(Line,iFrst,iEnd)
*
*              Pick up the first atom label
*
               iFrst=iEnd+1
               Call NxtWrd(Line,iFrst,iEnd)
               If (Line(iFrst:iEnd).eq.'&') Then
                  iLine=iLine+1
                  Line=Lines(iLine)     ! Read the continuation line
                  iFrst=1
                  Call NxtWrd(Line,iFrst,iEnd)
               End If
               Label1=Line(iFrst:iEnd)
               nLabel1=iEnd-iFrst+1
*
*              Pick up the second atom label
*
               iFrst=iEnd+1
               Call NxtWrd(Line,iFrst,iEnd)
               If (Line(iFrst:iEnd).eq.'&') Then
                  iLine=iLine+1
                  Line=Lines(iLine)     ! Read the continuation line
                  iFrst=1
                  Call NxtWrd(Line,iFrst,iEnd)
               End If
               Label2=Line(iFrst:iEnd)
               nLabel2=iEnd-iFrst+1
*
*              Case: Bond
*
               nZMat=nZMat+1
               Write (Line2,'(A,I3.3,A,2(1X,A))')
     &         'ZMAT',nZMat+ZMatOffset,' = Bond',Label2(1:nLabel2),
     &                                           Label1(1:nLabel1)

               Write(Lu_TMP,'(A)') Line2
               iRow_c=iRow_c+1
               iZMat=iZMat+1
               FragZMat(nFrag,1)=iZMat
               FragZMat(nFrag,2)=iZMat
*
*              Pick up the third atom label
*
               iFrst=iEnd+1
               Call NxtWrd(Line,iFrst,iEnd)
               If (iEnd.eq.-1) Go To 300
               If (Line(iFrst:iEnd).eq.'&') Then
                  iLine=iLine+1
                  Line=Lines(iLine)     ! Read the continuation line
                  iFrst=1
                  Call NxtWrd(Line,iFrst,iEnd)
               End If
               Label3=Line(iFrst:iEnd)
               nLabel3=iEnd-iFrst+1
               jAtom=0
               Do iAtom = 1, nsAtom
                  If (Label3.eq.AtomLbl(iAtom)) jAtom=iAtom
               End Do
               If (nStab(jAtom).eq.1) Then
                  nDeg=3
               Else If (nStab(jAtom).eq.2) Then
                  nDeg=2
               Else If (nStab(jAtom).eq.1) Then
                  nDeg=1
               Else
                  nDeg=0
               End If
*
*              Case: Bond-Angle
               If (nDeg.le.1) Go To 200
               nZMat=nZMat+1
               Write (Line2,'(A,I3.3,A,2(1X,A))')
     &         'ZMAT',nZMat+ZMatOffset,' = Bond',Label3(1:nLabel3),
     &                                           Label2(1:nLabel2)
               Write(Lu_TMP,'(A)') Line2
               iRow_c=iRow_c+1
*
               If (nDeg.le.2) Go To 200
               nZMat=nZMat+1
               Write (Line2,'(A,I3.3,A,3(1X,A))')
     &         'ZMAT',nZMat+ZMatOffset,' = Angle',Label3(1:nLabel3),
     &                                            Label2(1:nLabel2),
     &                                            Label1(1:nLabel1)
               Write(Lu_TMP,'(A)') Line2
               iRow_c=iRow_c+1
               iZMat=iZMat+2
               FragZMat(nFrag,2)=iZMat
 200           Continue
*
 400           Continue
*
*              Pick up next atom (fourth)
*
               iFrst=iEnd+1
               Call NxtWrd(Line,iFrst,iEnd)
*
*              Branch out if no more labels. Look out for line
*              continuations
*
               If (iEnd.eq.-1) Go To 300
               If (Line(iFrst:iEnd).eq.'&') Then
                  iLine=iLine+1
                  Line=Lines(iLine)     ! Read the continuation line
                  iFrst=1
                  Call NxtWrd(Line,iFrst,iEnd)
               End If
*
               Label4=Line(iFrst:iEnd)
               nLabel4=iEnd-iFrst+1
               jAtom=0
               Do iAtom = 1, nsAtom
                  If (Label4.eq.AtomLbl(iAtom)) jAtom=iAtom
               End Do
               If (nStab(jAtom).eq.1) Then
                  nDeg=3
               Else If (nStab(jAtom).eq.2) Then
                  nDeg=2
               Else If (nStab(jAtom).eq.1) Then
                  nDeg=1
               Else
                  nDeg=0
               End If
*
*              Case: Bond-Angle-Dihedral
               If (nDeg.eq.0) Go To 500
               nZMat=nZMat+1
               Write (Line2,'(A,I3.3,A,2(1X,A))')
     &         'ZMAT',nZMat+ZMatOffset,' = Bond',Label4(1:nLabel4),
     &                                           Label3(1:nLabel3)
               Write(Lu_TMP,'(A)') Line2
               iRow_c=iRow_c+1
*
               If (nDeg.eq.1) Go To 500
               nZMat=nZMat+1
               Write (Line2,'(A,I3.3,A,3(1X,A))')
     &         'ZMAT',nZMat+ZMatOffset,' = Angle',Label4(1:nLabel4),
     &                                            Label3(1:nLabel3),
     &                                            Label2(1:nLabel2)
               Write(Lu_TMP,'(A)') Line2
               iRow_c=iRow_c+1
*
               If (nDeg.eq.2) Go To 500
               nZMat=nZMat+1
               Write (Line2,'(A,I3.3,A,4(1X,A))')
     &         'ZMAT',nZMat+ZMatOffset,' = Dihedral',Label4(1:nLabel4),
     &                                               Label3(1:nLabel3),
     &                                               Label2(1:nLabel2),
     &                                               Label1(1:nLabel1)
               Write(Lu_TMP,'(A)') Line2
               iRow_c=iRow_c+1
               iZMat=iZMat+3
               FragZMat(nFrag,2)=iZMat
 500           Continue
*
*              Push the labels
*
               Label1=Label2
               nLabel1=nLabel2
               Label2=Label3
               nLabel2=nLabel3
               Label3=Label4
               nLabel3=nLabel4
*
*              Get the next label
*
               Go To 400
*
 300           Continue
*
            Else
*
*              No processing just write to the file.
*
               Write(Lu_TMP,'(A)') Line
               iRow_c=iRow_c+1
            End If
*
            Else ! Values
*
*              Remove constraints to be ignored
*
               Ignore=.False.
               iFrst=1
               Call NxtWrd(Lines(1),iFrst,iEnd)
               iFrag=0
               Do i=1,nFrag
                  If (Line(iFrst:iEnd).eq.Trim(FragLabels(i))) Then
                     iFrag=i
                  End If
               End Do
*              Some constraints default to soft unless marked as hard
               iSoft=0
               If (Index(Lines(nLines),'HARD').le.iEq) Then
                  Do i=1,nSoft
                     If (Line(iFrst:iEnd).eq.Trim(SoftLabels(i))) Then
                        iSoft=i
                     End If
                  End Do
               End If
               iEq=Index(Lines(nLines),'=')
*              Ignore soft in num. grad., phantom in slapaf
               If ((SuperName.eq.'numerical_gradient') .and.
     &             ((Index(Lines(nLines),'SOFT').gt.iEq) .or.
     &              (iSoft.gt.0))) Ignore=.True..And.Remove
               If ((SuperName.eq.'slapaf') .and.
     &             (Index(Lines(nLines),'PHANTOM').gt.iEq))
     &               Ignore=.True..And.Remove
*              Ignore if this is a fragment constraint
               If (iFrag.gt.0) Then
*                 if it is already ignored, ignore all replacement constraints
                  If (Ignore) FragZMat(iFrag,2)=0
                  Ignore=.True.
               End If
               If (.Not.Ignore) Then
                  Do i=1,nLines
                     Write(Lu_TMP,'(A)') Lines(i)
                  End Do
                  iRow_c=iRow_c+nLines
               Else
                  nLambda=nLambda-1
               End If
*
            End If ! Values
*
            Go To 100 ! Get the next line
*
         End If
*
*     Put in the additional constraints here.
*
      Do iFrag=1,nFrag
*        Note that FragZMat(iFrag,2)=0 if the fragment is ignored
         Do iZMat=FragZMat(iFrag,1),FragZMat(iFrag,2)
            Write (Lu_TMP,'(A,I3.3,A)') 'ZMAT',iZMat+ZMatOffset,' = FIX'
            iRow_c=iRow_c+1
            nLambda=nLambda+1
         End Do
      End Do
*
*                                                                      *
************************************************************************
*                                                                      *
*     Write out the last line again
*
      Line='END OF CONSTRAINTS'
      Write(Lu_TMP,'(A)') Line
*                                                                      *
************************************************************************
*                                                                      *
*     Copy the stuff from LU_TMP back to LU_UDC
*
      REWIND(Lu_UDC)
      REWIND(Lu_TMP)
 600  Continue
      Line=Get_Ln(Lu_TMP)
*     Write (*,*) Line
*
      Write (Lu_UDC,'(A)') Trim(Line)
      If (Line(1:4).ne.'END ') Go To 600
*     Write (*,*) 'iRow_C,nLambda=',iRow_C,nLambda
*
*                                                                      *
************************************************************************
*                                                                      *
*     Close the files.
*
      Close(Lu_TMP)
      Close(Lu_UDC)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine propagate()

use rhodyn_data, only: ak1, ak2, ak3, ak4, ak5, ak6, d, decay, density0, densityt, dgl, DM_basis, dt, emiss, errorthreshold, &
                       finaltime, flag_decay, flag_dipole, flag_emiss, flag_fdm, flag_pulse, hamiltonian, hamiltoniant, &
                       initialtime, ipglob, lu_csf, lu_dip, lu_pls, lu_sf, lu_so, method, nconftot, Npop, Nstep, Ntime_tmp_dm, &
                       out2_fmt, out3_fmt, out_decay_i, out_decay_r, out_fdm, out_freq, out_ham_i, out_ham_r, out_tfdm, &
                       pulse_func, safety, time_fdm, timestep, tout
use rhodyn_utils, only: dashes
use integrators, only: classic_rk4, rk4, rk5, rk45, rkck
use mh5, only: mh5_put_dset
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Five, Ten, Quart, auToFs
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: ihh, ii, imm, iss, jj, kk, Ntime, Noutstep
real(kind=wp) :: dum(3), error_rk, oldstep, t_temp, time, timer(3)
real(kind=wp), allocatable :: dgl_csf(:)
complex(kind=wp), allocatable :: density_csf(:,:)
procedure(pulse_func) :: pulse

call dashes()
write(u6,*) 'Propagation starts'
write(u6,*) 'Dimension: ',d
call dashes()

! initialize parameters for solution of Liouville equation
ii = 1 ! counts output of populations
Ntime = 1 !counts steps
Nstep = int((finaltime-initialtime)/timestep)+1
Npop = int((finaltime-initialtime)/tout)+1
Noutstep = int(tout/timestep)
Ntime_tmp_dm = int(finaltime/time_fdm)+1 !fdm
time = initialtime
oldstep = timestep
densityt(:,:) = density0
! create and initialize h5 output file
call cre_out()
call mh5_put_dset(out_ham_r,real(hamiltonian))
call mh5_put_dset(out_ham_i,aimag(hamiltonian))
if (flag_decay) then
  call mh5_put_dset(out_decay_r,real(decay))
  call mh5_put_dset(out_decay_i,aimag(decay))
end if
if (flag_emiss) then
  call mh5_put_dset(out_freq,emiss)
  !write(u6,*) 'frequencies have been written to hdf5 file'
  emiss = Zero
end if
if (flag_fdm) then
  jj = 1 ! counts output of full density matrix

  ! store full density matrix
  call mh5_put_dset(out_tfdm,[time*auToFs],[1],[0])
  call mh5_put_dset(out_fdm,abs(density0),[1,d,d],[0,0,0])
end if

call mma_allocate(dgl,d)
call mma_allocate(ak1,d,d)
call mma_allocate(ak2,d,d)
call mma_allocate(ak3,d,d)
call mma_allocate(ak4,d,d)
call mma_allocate(ak5,d,d)
call mma_allocate(ak6,d,d)

call mma_allocate(dgl_csf,nconftot,label='dgl_csf')
call mma_allocate(density_csf,nconftot,nconftot,label='density_csf')
call pop(time,ii,dgl_csf,density_csf) ! write 0th iteration (initial values)

if ((method == 'RKCK') .or. (method == 'RK45')) then
  !*********************************************************************
  ! methods with adaptive step size
  !*********************************************************************
  kk = 1 ! counts initial steps by timestep
  ! initialize time step as 1/10 of interval:
  dt = (finaltime-initialtime)/Ten
  if (ipglob > 2) then
    call dashes()
    write(u6,*) 'Propagation with ',trim(method),' method'
    write(u6,*) 'Integration values at each step:'
    write(u6,out2_fmt) 'Time','Error','Timestep'
  end if
  ! main loop loopprop:
  loopprop: do while (time <= finaltime)
    call Timing(dum(1),dum(2),timer(1),dum(3))
    ! calculate hamiltonian with pulse at the current time:
    if (flag_pulse) then
      if (time >= (initialtime+timestep*(kk-1))) then
        call pulse(hamiltonian,hamiltoniant,time,kk)
        kk = kk+1
      else
        call pulse(hamiltonian,hamiltoniant,time,-1)
      end if
    else
      hamiltoniant(:,:) = hamiltonian
    end if
    ! run loop to find the step with acceptable accuracy
    ! use density0 as storage for initial value
    loopstep: do
      density0(:,:) = densityt
      if (method == 'RKCK') then
        call rkck(time,densityt,error_rk)
      else if (method == 'RK45') then
        call rk45(time,densityt,error_rk)
      end if
      if (error_rk <= errorthreshold) exit loopstep
      ! then step rejected, try new smaller step
      densityt(:,:) = density0
      t_temp = safety*dt*(errorthreshold/error_rk)**Quart
      dt = max(t_temp,0.2_wp*dt)
      if (ipglob > 2) write(u6,*) ' ------',error_rk,dt*auToFs
    end do loopstep
    ! step succeeded
    time = time+dt
    oldstep = dt
    if (time >= finaltime) exit loopprop
    ! write info and elapsed time
    if (time >= (initialtime+tout*ii)) then
      ii = ii+1
      call pop(time,ii,dgl_csf,density_csf)
    end if
    if (flag_fdm .and. (time >= time_fdm*jj)) then
      ! should be moved to procedure pop
      call mh5_put_dset(out_tfdm,[time*auToFs],[1],[jj])
      ! density0 is stored as temporary storage for dm in required basis in pop
      call mh5_put_dset(out_fdm,abs(density0),[1,d,d],[jj,0,0])
      jj = jj+1
    end if
    call Timing(dum(1),dum(2),timer(2),dum(3))
    timer(3) = timer(2)-timer(1)
    ihh = int(timer(3)/3600.0_wp)
    imm = int((timer(3)-ihh*3600.0_wp)/60.0_wp)
    iss = int(timer(3)-ihh*3600.0_wp-imm*60.0_wp)
    if (ipglob > 2) write(u6,out3_fmt) time*auToFs,error_rk,dt*auToFs,ihh,':',imm,':',iss
    ! next step size
    if (method == 'RKCK') then
      dt = safety*dt*(errorthreshold/error_rk)**0.2_wp
    else if (method == 'RK45') then
      dt = safety*dt*(errorthreshold/error_rk)**Quart
    end if
    ! stepsize cannot decrease faster than by 5x
    dt = min(dt,Five*oldstep)
    Ntime = Ntime+1
    if (dt < 1.0e-8_wp) then
      write(u6,*) 'The step of integration got too small, try fixed-step methods and/or check the hamiltonian'
      call abend()
    end if
  end do loopprop
else
  !*********************************************************************
  ! methods with fixed step
  !*********************************************************************
  do Ntime=1,(Nstep-1)
    if (flag_pulse) then
      ! update hamiltonian with dipole term
      call pulse(hamiltonian,hamiltoniant,time,Ntime)
    else
      hamiltoniant(:,:) = hamiltonian
    end if
    select case (method)
      case ('CLASSIC_RK4')
        call classic_rk4(time,densityt)
      case ('RK4')
        call rk4(time,densityt)
      case ('RK5')
        call rk5(time,densityt)
      case default
        ! check has already been done in read_input
        write(u6,*) 'Integration method ',method,' is not known'
        call abend()
    end select
    !!vk!! call test_rho(densityt,time)
    time = initialtime+timestep*Ntime
    if (mod(Ntime,Noutstep) == 0) then
      ii = ii+1
      call pop(time,ii,dgl_csf,density_csf)
    end if
  end do
end if
call mma_deallocate(dgl_csf)
call mma_deallocate(density_csf)

! deallocation of matrices needed for propagation
call mma_deallocate(ak1)
call mma_deallocate(ak2)
call mma_deallocate(ak3)
call mma_deallocate(ak4)
call mma_deallocate(ak5)
call mma_deallocate(ak6)
call mma_deallocate(dgl)

if ((DM_basis == 'SO') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) close(lu_so)
if ((DM_basis == 'SF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) close(lu_sf)
if ((DM_basis == 'CSF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'ALL')) close(lu_csf)
if (flag_pulse) close(lu_pls)
if (flag_dipole) close(lu_dip)

call dashes()
write(u6,*) 'Propagation finished after ',Ntime,' steps'
call dashes()

end subroutine propagate

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************

      SubRoutine ChoMP2g_density2(irc,EOcc,EVir,EFro,Wrk,lWrk)
*
*     Jonas Bostrom, Mars 2010
*
*     Purpose: Solve the CPHF-equations to obtain occ-vir
*              contributions to the 1-pdm.

#include "implicit.fh"
#include "chomp2g.fh"
#include "chomp2.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
*
      Character Fname*5
      Real*8 Wrk(lWrk),EOcc(*), EVir(*), EFro(*)
      Integer kCGVec(9), kEndCGVec(9), kDiag(2), nOccAll(8)
      Logical Done

      Character*8  ThisNm
      Character*16 SecNam
      Parameter (SecNam = 'ChoMP2g_Density2', ThisNm = 'Density2')

*     Do not delete vectors after use.
*     ------------------------------------------------------
      iClos = 2
      iTypL = 1
      iVecFF = 1
      iVecOV = 6
      iVecVV = 9
      iVecOO = 5
      iVecFV = 3
      iVecFO = 2
      iVecOF = 4

*
*     Setup the conjugate gradient procedure
*     --------------------------------------
      Eps = 1D-8
      Done=.false.
      nIter = 100

*     Allocate memory for Frozen Diagonal of A
*     ---------------------------------
      lFDiag = nMoMo(1,iVecFV)
      kDiag(1) = kFLagr(1) + lFLagr
      kEndFDiag = kDiag(1) + lFDiag
      Call FZero(Wrk(kDiag(1)),lFDiag)

*     Allocate memory for Occupied Diagonal of A
*     ---------------------------------
      lDiag = nMoMo(1,iVecOV)
      kDiag(2) = kEndFDiag
      kEndDiag = kDiag(2) + lDiag
      Call FZero(Wrk(kDiag(2)),lDiag)
*
      iSym = 1
      nOccAll(iSym) = nFro(iSym)+nOcc(iSym)

*     Open Cholesky vector files.
*     ---------------------------
      Call ChoMP2_OpenF(1,1,iSym)

      maxvalue = 200
      nVec = min(NumCho(iSym),maxvalue)
      nBatL = (NumCho(iSym)-1)/nVec + 1
      If(nVec .lt. 1) Then
         Call ChoMP2_Quit(SecNam,'Insufficient memory','[1]')
      End If

*     Allocate memory for Lia-vector and LIa-vector
*     ---------------------------------------------

      lLfa = nMoMo(iSym,iVecFV)*nVec
      kLfa = kEndDiag
      kEndLfa = kLfa + lLfa

      lLia = nMoMo(iSym,iVecOV)*nVec
      kLia = kEndLfa
      kEndLia = kLia + lLia

      Do iBat = 1, nBatL
         If (iBat .eq. nBatL) Then
            NumVec = NumCho(iSym) - nVec*(nBatL-1)
         Else
            NumVec = nVec
         End If
         iVec = nVec*(iBat-1) + 1

*        Read Lfa-vectors
*        ----------------
         iOpt = 2
         lTot = nMoMo(iSym,iVecFV)*NumVec
         iAdr = nMoMo(iSym,iVecFV)*(iVec-1) + 1 +
     &        iAdrOff(iSym,iVecFV)
         Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLfa),
     &                lTot,iAdr)

*        Read Lia-vectors
*        ----------------
         iOpt = 2
         lTot = nMoMo(iSym,iVecOV)*NumVec
         iAdr = nMoMo(iSym,iVecOV)*(iVec-1) + 1 +
     &        iAdrOff(iSym,iVecOV)
         Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLia),
     &                lTot,iAdr)

*        Construct Diagonal of A
*        -----------------------
         Do iVec1 = 1, NumVec
            Do i = 1, nMoMo(iSym,iVecFV)
               iOffL = (iVec1-1)*nMoMo(iSym,iVecFV)
               Wrk(kDiag(1)+i-1) =  Wrk(kDiag(1)+i-1) +
     &                           3.0d0*Wrk(kLfa+i-1+iOffL)**2
            End Do
         End Do
         Do iVec1 = 1, NumVec
            Do i = 1, nMoMo(iSym,iVecOV)
               iOffL = (iVec1-1)*nMoMo(iSym,iVecOV)
               Wrk(kDiag(2)+i-1) = Wrk(kDiag(2)+i-1) +
     &                             3.0d0*Wrk(kLia+i-1+iOffL)**2
            End Do
         End Do
*
         index1 = 0
         Do iSym1 = 1, nSym
            nA = nVir(iSym1)
            nI = nFro(iSym1)
            Do iI = 1, nI
               Ei = EFro(iFro(iSym1) + iI)
               Do iA = 1,nA
                  index = iA-1 + (iI-1)*nA + index1
                  Ea = EVir(iVir(iSym1) + iA)
                  Wrk(kDiag(1)+index) = Wrk(kDiag(1)+index) + Ea - Ei
               End Do
            End Do
            nI = nOcc(iSym1)
            Do iI = 1, nI
               Ei = EOcc(iOcc(iSym1) + iI)
               Do iA = 1,nA
                  index = iA-1 + (iI-1)*nA + index1
                  Ea = EVir(iVir(iSym1) + iA)
                  Wrk(kDiag(2)+index) = Wrk(kDiag(2)+index) + Ea - Ei
               End Do
            End Do
            index1 = index1 + nOcc(iSym1)*nVir(iSym1)
         End Do
         Do i = 1, lFDiag
            Wrk(kDiag(1)+i-1) = 1/Wrk(kDiag(1)+i-1)
         End Do
         Do i = 1, lDiag
            Wrk(kDiag(2)+i-1) = 1/Wrk(kDiag(2)+i-1)
         End Do
      End Do

      Call ChoMP2_OpenF(iClos,1,iSym)


*     Allocate vectors needed for the PCG
*     -----------------------------------
      lCGFVec = 0
      Do iSym = 1, nSym
         lCGFVec = lCGFVec + (nFro(iSym))*nVir(iSym)
      End Do
      lCGOVec = 0
      Do iSym = 1, nSym
         lCGOVec = lCGOVec + (nOcc(iSym))*nVir(iSym)
      End Do
      lCGVec = lCGOVec + lCGFVec
*     Vector Legend (as they are named in Conj_Grad):
*                    Z = 1, Ztemp = 2
*                    R = 3, Rtemp = 4
*                    P = 5, Ptemp = 6
*                    X = 7, Xtemp = 8
*                    AP = 9

      kCGVec(1) = kEndDiag
      kEndCGVec(1) = kCGVec(1) + lCGVec
      Call FZero(Wrk(kCGVec(1)),lCGVec)
      nCGvec = 9

      Do i = 2, nCGVec
         kCGVec(i) = kEndCGVec(i-1)
         kEndCGVec(i) = kCGVec(i) + lCGVec
         Call FZero(Wrk(kCGVec(i)),lCGVec)
      End Do

*     Calculate inital values for the CG-vectors needing that
*     -------------------------------------------------------

      Do i=1, lCGFVec
         Wrk(kCGVec(1)+i-1) = Wrk(kFLagr(1)+i-1)*Wrk(kDiag(1)+i-1)
         Wrk(kCGVec(3)+i-1) = Wrk(kFLagr(1)+i-1)
         Wrk(kCGVec(5)+i-1) = Wrk(kCGVec(1)+i-1)
      End Do
      iOff = lCGFVec
      Do i = 1, lCGOVec
         Wrk(kCGVec(1)+i-1+iOff) = Wrk(kLagr(1)+i-1)*Wrk(kDiag(2)+i-1)
         Wrk(kCGVec(3)+i-1+iOff) = Wrk(kLagr(1)+i-1)
         Wrk(kCGVec(5)+i-1+iOff) = Wrk(kCGVec(1)+i-1+iOff)
      End Do

      Do iIter = 1, nIter
         Call FZero(Wrk(kCGVec(9)),lCGVec)

*     Calculate A*p
*     -------------
         Do iSym = 1, nSym

*           Open Cholesky vector files.
*           ---------------------------
            Call ChoMP2_OpenF(1,1,iSym)

            iSeed = 7
            LuVVec = IsFreeUnit(iSeed)
            Write(Fname,'(A4,I1)') 'TMPV',2
            Call DaName_MF_WA(LuVVec,Fname)
*
            iSeed = 7
            LuWVec = IsFreeUnit(iSeed)
            Write(Fname,'(A4,I1)') 'TMPV',3
            Call DaName_MF_WA(LuWVec,Fname)

            nVec = min(NumCho(iSym),maxvalue)
            If(nVec .lt. 1) Then
               Call ChoMP2_Quit(SecNam,'Insufficient memory','[1]')
            End If

            lScr = lWrk - kEndCGVec(9)
            iOff = lCGFVec
*
*           Construct The Frozen part of A*P
*           --------------------------------
            Call ChoMP2g_Constrap(irc,Wrk(kEndCGVec(9)),lScr,
     &                            'fvvf',iSym,nVec,Wrk(kCGVec(9)),
     &                            lCGFVec,Wrk(kCGVec(5)),lCGFVec,
     &                            1.0d0)
            Call ChoMP2g_Constrap(irc,Wrk(kEndCGVec(9)),lScr,
     &                            'ovvf',iSym,nVec,Wrk(kCGVec(9)),
     &                            lCGFVec,Wrk(kCGVec(5)+iOff),lCGOVec,
     &                            1.0d0)
*           Construct The Occupied part of A*P
*           ----------------------------------
            Call ChoMP2g_Constrap(irc,Wrk(kEndCGVec(9)),lScr,
     &                            'fvvo',iSym,nVec,Wrk(kCGVec(9)+iOff),
     &                            lCGOVec,Wrk(kCGVec(5)),lCGFVec,
     &                            1.0d0)
            Call ChoMP2g_Constrap(irc,Wrk(kEndCGVec(9)),lScr,
     &                            'ovvo',iSym,nVec,Wrk(kCGVec(9)+iOff),
     &                            lCGOVec,Wrk(kCGVec(5)+iOff),lCGOVec,
     &                            1.0d0)

            Call ChoMP2_OpenF(iClos,1,iSym)
            Call DaClos(LuVVec)
            Call DaClos(LuWVec)

         End Do
*
         index1 = 0
         Do iSym1 = 1, nSym
            nA = nVir(iSym1)
            nI = nFro(iSym1)
            Do iI = 1, nI
               Ei = EFro(iFro(iSym1) + iI)
               Do iA = 1,nA
                  index = iA-1 + (iI-1)*nA + index1
                  Ea = EVir(iVir(iSym1) + iA)
                  Wrk(kCGVec(9)+ index) =Wrk(kCGVec(9)+index)+
     &                                   (Ea - Ei)*Wrk(kCGVec(5)+index)
               End Do
            End Do
            nI = nOcc(iSym1)
            Do iI = 1, nI
               Ei = EOcc(iOcc(iSym1) + iI)
               Do iA = 1,nA
                  index = iA-1 + (iI-1)*nA +index1
                  Ea = EVir(iVir(iSym1) + iA)
                  Wrk(kCGVec(9)+ index+iOff) =Wrk(kCGVec(9)+index+iOff)+
     &                              (Ea - Ei)*Wrk(kCGVec(5)+index+iOff)
               End Do
            End Do
            index1 = index1 + (nFro(iSym1)+nOcc(iSym1))*nVir(iSym1)
         End Do
*
         Call Conj_Grad(Done,lCGVec,Wrk(kDiag(1)),Wrk(kCGVec(7)),
     &                  Wrk(kCGVec(8)),Wrk(kCGVec(3)),Wrk(kCGVec(4)),
     &                  Wrk(kCGVec(5)),Wrk(kCGVec(6)),Wrk(kCGVec(1)),
     &                  Wrk(kCGVec(2)),Wrk(kCGVec(9)),Eps,Res)
         If(Done) Go To 100
      End Do
      Write(6,*) '***************WARNING************************'
      Write(6,*) ''
      write(6,*) 'Too many iterations, this is what you get after:'
      Write(6,*)  nIter, ' Iterations'
      write(6,*) 'The residual is', res, 'and not', Eps
      Write(6,*) '**********************************************'

 100  Continue

*     Construct MP2 Density contribution from parts of the matrix
*     -----------------------------------------------------------
      iSymOffOV = 0
      Do iSym = 1, nSym
         Do i = 1, nOcc(iSym)
            iOrb = nFro(iSym) + i
            Do j = 1, nFro(iSym)
               jOrb = j
               Work(ipDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &             Wrk(kPiK(iSym) + i-1 + nOcc(iSym)*(j-1))
               Work(ipDensity(iSym) + iOrb-1 + (jOrb-1)*nOrb(iSym)) =
     &             Wrk(kPiK(iSym) + i-1 + nOcc(iSym)*(j-1))
            End Do
         End Do

         Do i = 1, nOcc(iSym)
            iOrb = nFro(iSym) + i
            Do j =  1, nOcc(iSym)
               jOrb = nFro(iSym) + j
               Work(ipDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &               Wrk(kPij(iSym) + j-1 + nOcc(iSym)*(i-1))
            End Do
         End  Do

         Do iI = 1, nFro(iSym)
            Do iA = 1, nVir(iSym)
               Wrk(kPaK(iSym)+ iA-1 + nVir(iSym)*(iI-1)) =
     &           Wrk(kCGVec(7) + iA-1 + nVir(iSym)*(iI-1) + iSymOffOV)
            End Do
         End Do
         Do iI = 1, nOcc(iSym)
            iOrbI = nFro(iSym) + iI
            Do iA = 1, nVir(iSym)
               Wrk(kPai(iSym)+ iA-1 + nVir(iSym)*(iI-1)) =
     &          Wrk(kCGVec(7) + iA-1 + nVir(iSym)*(iOrbI-1) + iSymOffOV)
            End Do
         End Do

         Do i = 1, nFro(iSym) + nOcc(iSym)
            iOrb = i
            Do j = 1, nVir(iSym)
               jOrb = nFro(iSym) + nOcc(iSym) +  j
               Work(ipDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &               Wrk(kCGVec(7) + j-1 +
     &               (nVir(iSym))*(i-1) + iSymOffOV)
               Work(ipDensity(iSym) + iOrb-1 + (jOrb-1)*nOrb(iSym)) =
     &             Work(ipDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym))

            End Do
         End Do

         Do i = 1, nVir(iSym)
            iOrb = nFro(iSym) + nOcc(iSym) + i
            Do j =  1, nVir(iSym)
               jOrb = nFro(iSym) + nOcc(iSym) + j
               Work(ipDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &               Wrk(kPab(iSym) + j-1 + nVir(iSym)*(i-1))
            End Do
         End  Do
         iSymOffOV = iSymOffOV + (nOcc(iSym)+nFro(iSym))*nVir(iSym)
      End Do

*     Add type (II) terms to W-matrix
*     -------------------------------

      Do iSym = 1, nsym
         Do iI = 1, nOcc(iSym)
            Ei = EOcc(iOcc(iSym)+iI)
            Do iJ = 1, nFro(iSym)
               Ej = EFro(iFro(iSym)+iJ)
               Wrk(kWiK(iSym) + iI-1 + nOcc(iSym)*(iJ-1)) =
     &             Wrk(kWiK(iSym) + iI-1 + nOcc(iSym)*(iJ-1)) -1.0*
     &             Wrk(kPiK(iSym) + iI-1 + nOcc(iSym)*(iJ-1))*(Ei+Ej)
            End Do
         End Do
         Do iI = 1, nOcc(iSym)
            Ei = EOcc(iOcc(iSym)+iI)
            Do iJ = 1, nOcc(iSym)
               Ej = EOcc(iOcc(iSym)+iJ)
               Wrk(kWij(iSym) + iJ-1 + nOcc(iSym)*(iI-1)) =
     &             Wrk(kWij(iSym) + iJ-1 + nOcc(iSym)*(iI-1)) - 0.5d0*
     &             Wrk(kPij(iSym) + iJ-1 + nOcc(iSym)*(iI-1))*(Ei+Ej)
            End Do
         End Do
         Do iA = 1, nVir(iSym)
            Ea = EVir(iVir(iSym)+iA)
            Do iB = 1, nVir(iSym)
               Eb = EVir(iVir(iSym)+iB)
               Wrk(kWab(iSym) + iB-1 + nVir(iSym)*(iA-1)) =
     &              Wrk(kWab(iSym) + iB-1 + nVir(iSym)*(iA-1)) - 0.5d0*
     &              Wrk(kPab(iSym) + iB-1 + nVir(iSym)*(iA-1))*(Ea+Eb)
            End Do
         End Do
         Do iI = 1, nFro(iSym)
            Ei = Efro(iFro(iSym)+iI)
            iOrbI = iI
            Do iA = 1, nVir(iSym)
               iOrbA = nFro(iSym) + nOcc(iSym) + iA
               Wrk(kWak(iSym) + iA-1 + nVir(iSym)*(iI-1)) =
     &           Wrk(kWak(iSym) + iA-1 + nVir(iSym)*(iI-1)) - 2.0d0*
     &           Wrk(kPaK(iSym) + iA-1 + nVir(iSym)*(iI-1))*Ei
            End Do
         End Do
         Do iI = 1, nOcc(iSym)
            Ei = EOcc(iOcc(iSym)+iI)
            iOrbI = nFro(iSYm) + iI
            Do iA = 1, nVir(iSym)
               iOrbA = nFro(iSym) + nOcc(iSym) + iA
               Wrk(kWai(iSym) + iA-1 + nVir(iSym)*(iI-1)) =
     &           Wrk(kWai(iSym) + iA-1 + nVir(iSym)*(iI-1)) - 2.0d0*
     &           Wrk(kPai(iSym) + iA-1 + nVir(iSym)*(iI-1))*Ei
            End Do
         End Do

      End Do

      iSym = 1

*     Add type (III) terms to W-matrix
*     -------------------------------

*     Open Cholesky vector files.
*     ---------------------------
      Call ChoMP2_OpenF(1,1,iSym)


      nVec = min(NumCho(iSym),maxvalue)
      If(nVec .lt. 1) Then
         Call ChoMP2_Quit(SecNam,'Insufficient memory','[1]')
      End If
      nBatL = (NumCho(iSym)-1)/nVec + 1

*     Allocate memory for U-vector
*     ----------------------------

      lU = nVec
      kU = kEndDiag
      kEndU = kU + lU


*     Allocate memory for Lia-vector and LIa-vector
*     ---------------------------------------------

      lLfa = nMoMo(iSym,iVecFV)*nVec
      kLfa = kEndU
      kEndLfa = kLfa + lLfa

      lLia = nMoMo(iSym,iVecOV)*nVec
      kLia = kEndLfa
      kEndLia = kLia + lLia

      lLij = nMoMo(iSym,iVecOO)*nVec
      kLij = kEndLia
      kEndLij = kLij + lLij

      lLiK = nMoMo(iSym,iVecOF)*nVec
      kLiK = kEndLij
      kEndLiK = kLiK + lLiK

      lLKi = nMoMo(iSym,iVecFO)*nVec
      kLKi = kEndLiK
      kEndLKi = kLKi + lLKi

      lLab = nMoMo(iSym,iVecVV)*nVec
      kLab = kEndLKi
      kEndLab = kLab + lLab

      lLJK = nMoMo(iSym,iVecFF)*nVec
      kLJK = kEndLab
      kEndLJK = kLJK + lLJK

      Do iBat = 1, nBatL
         If (iBat .eq. nBatL) Then
            NumVec = NumCho(iSym) - nVec*(nBatL-1)
         Else
            NumVec = nVec
         End If
         iVec = nVec*(iBat-1) + 1
         Call FZero(Wrk(kU),lU)

*     Read Lij^J-vectors from disk
*     ----------------------------

         If(NumVec .gt. 0) Then
            iOpt = 2
            lTot = nMoMo(iSym,iVecOO)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecOO)*(iVec-1) +
     &           iAdrOff(iSym,iVecOO)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLij),lTot,
     &           iAdr)
         End If

*     Read LiK^J-vectors from disk
*     ----------------------------

         If(NumVec .gt. 0) Then
            iOpt = 2
            lTot = nMoMo(iSym,iVecOF)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecOF)*(iVec-1) +
     &           iAdrOff(iSym,iVecOF)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLiK),lTot,
     &           iAdr)
         End If

*     Read LKi^J-vectors from disk
*     ----------------------------

         If(NumVec .gt. 0) Then
            iOpt = 2
            lTot = nMoMo(iSym,iVecFO)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecFO)*(iVec-1) +
     &           iAdrOff(iSym,iVecFO)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLKi),lTot,
     &           iAdr)
         End If

*     Read LIK^J-vectors from disk
*     ----------------------------

         If(NumVec .gt. 0) Then
            iOpt = 2
            lTot = nMoMo(iSym,iVecFF)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecFF)*(iVec-1) +
     &           iAdrOff(iSym,iVecFF)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLJK),lTot,
     &           iAdr)
         End If

*     Read Lia^J-vectors from disk
*     ----------------------------

         If(NumVec .gt. 0) Then
            iOpt = 2
            lTot = nMoMo(iSym,iVecOV)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecOV)*(iVec-1) +
     &           iAdrOff(iSym,iVecOV)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLia),lTot,
     &           iAdr)
         End If

*     Read Lfa^J-vectors from disk
*     ----------------------------

         If(NumVec .gt. 0) Then
            iOpt = 2
            lTot = nMoMo(iSym,iVecFV)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecFV)*(iVec-1) +
     &           iAdrOff(iSym,iVecFV)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLfa),lTot,
     &           iAdr)
         End If

*     Read Lab^J-vectors from disk
*     ----------------------------

         If(NumVec .gt. 0) Then
            iOpt = 2
            lTot = nMoMo(iSym,iVecVV)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecVV)*(iVec-1) +
     &           iAdrOff(iSym,iVecVV)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLab),lTot,
     &           iAdr)
         End If

*     Construct U^J intermediate vectors
*     ----------------------------------
         If(NumVec*nMoMo(iSym,iVecOO).eq.0) Go To 101
         Call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecOO),
     &              1.0d0,Wrk(kPij(iSym)), 1,
     &              Wrk(kLij),nMoMo(iSym,iVecOO),1.0d0,
     &              Wrk(kU),1)
 101     Continue

         If(NumVec*nMoMo(iSym,iVecFO).eq.0) Go To 102
         Call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecFO),
     &              2.0d0,Wrk(kPiK(iSym)), 1,
     &              Wrk(kLKi),nMoMo(iSym,iVecFO),1.0d0,
     &              Wrk(kU),1)
 102     Continue

         If(NumVec*nMoMo(iSym,iVecOV).eq.0) Go To 103
         Call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecOV),
     &              2.0d0,Wrk(kPai(iSym)), 1,
     &              Wrk(kLia),nMoMo(iSym,iVecOV),1.0d0,
     &              Wrk(kU),1)
 103     Continue

         If(NumVec*nMoMo(iSym,iVecFV).eq.0) Go To 104
         Call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecFV),
     &              2.0d0,Wrk(kPaK(iSym)), 1,
     &              Wrk(kLfa),nMoMo(iSym,iVecFV),1.0d0,
     &              Wrk(kU),1)
 104     Continue

         If(NumVec*nMoMo(iSym,iVecVV).eq.0) Go To 105
         Call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecVV),
     &              1.0d0,Wrk(kPab(iSym)), 1,
     &              Wrk(kLab),nMoMo(iSym,iVecVV),1.0d0,
     &              Wrk(kU),1)
 105     Continue

*     Construct contribution to Wij
*     -----------------------------

         If(nMoMo(iSym,iVecOO).eq.0) Go To 111
         Call dGemm_('N','N',nMoMo(iSym,iVecOO),1,NumVec,
     &             -2.0d0,Wrk(kLij),nMoMo(iSym,iVecOO),
     &             Wrk(kU),NumVec,1.0d0,
     &             Wrk(kWij(iSym)),nMoMo(iSym,iVecOO))
 111     Continue

*     Construct Contribution to WiK
*     -----------------------------

         If(nMoMo(iSym,iVecOF).eq.0) Go To 112
         Call dGemm_('N','N',nMoMo(iSym,iVecOF),1,NumVec,
     &             -4.0d0,Wrk(kLKi),nMoMo(iSym,iVecOF),
     &             Wrk(kU),NumVec,1.0d0,
     &             Wrk(kWiK(iSym)),nMoMo(iSym,iVecOF))
 112     Continue

*     Construct Contribution to WJK
*     -----------------------------

         If(nMoMo(iSym,iVecFF).eq.0) Go To 113
         Call dGemm_('N','N',nMoMo(iSym,iVecFF),1,NumVec,
     &             -2.0d0,Wrk(kLJK),nMoMo(iSym,iVecFF),
     &             Wrk(kU),NumVec,1.0d0,
     &             Wrk(kWJK(iSym)),nMoMo(iSym,iVecFF))
 113     Continue

      End Do


      iVecFF = 1
      iVecOF = 2
      iVecVF = 3
      iVecFO = 4
      iVecOO = 5
      iVecVO = 6
      iVecFV = 7
      iVecOV = 8
      iVecVV = 9

*     Allocate memory for Lia-vector and LIa-vector
*     ---------------------------------------------

      lLJK = nMoMo(iSym,iVecFF)*nVec
      kLJK = kEndDiag
      kEndLJK = kLJK + lLJK

      lLKi = nMoMo(iSym,iVecOF)*nVec
      kLKi = kEndLJK
      kEndLKi = kLKi + lLKi

      lLKa = nMoMo(iSym,iVecVF)*nVec
      kLKa = kEndLKi
      kEndLKa = kLKa + lLKa

      lLiK = nMoMo(iSym,iVecFO)*nVec
      kLiK = kEndLKa
      kEndLiK = kLiK + lLiK

      lLij = nMoMo(iSym,iVecOO)*nVec
      kLij = kEndLiK
      kEndLij = kLij + lLij

      lLia = nMoMo(iSym,iVecVO)*nVec
      kLia = kEndLij
      kEndLia = kLia + lLia

      lLip = nOccAll(iSym)*nOrb(iSym)*nVec
      kLip = kEndLia
      kEndLip = kLip + lLip

      lVip = nOccAll(iSym)*nOrb(iSym)*nVec
      kVip = kEndLip
      kEndVip = kVip + lVip

      lWij2 = nOccAll(iSym)*nOccAll(iSym)
      kWij2 = kEndVip
      kEndWij2 = kWij2 + lWij2
      Do i = 1, lWij2
         Wrk(kWij2+i-1) = 0.0d0
      End Do

      Do iBat = 1, nBatL
         If (iBat .eq. nBatL) Then
            NumVec = NumCho(iSym) - nVec*(nBatL-1)
         Else
            NumVec = nVec
         End If
         iVec = nVec*(iBat-1) + 1

*     Read Lpq^J-vectors from disk
*     ----------------------------

         If(NumVec .gt. 0) Then
            iOpt = 2
            lTot = nMoMo(iSym,iVecFF)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecFF)*(iVec-1) +
     &           iAdrOff(iSym,iVecFF)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLJK),lTot,
     &           iAdr)

            lTot = nMoMo(iSym,iVecOF)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecOF)*(iVec-1) +
     &           iAdrOff(iSym,iVecOF)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLKi),lTot,
     &           iAdr)

            lTot = nMoMo(iSym,iVecVF)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecVF)*(iVec-1) +
     &           iAdrOff(iSym,iVecVF)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLKa),lTot,
     &           iAdr)

            lTot = nMoMo(iSym,iVecFO)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecFO)*(iVec-1) +
     &           iAdrOff(iSym,iVecFO)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLiK),lTot,
     &           iAdr)

            lTot = nMoMo(iSym,iVecOO)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecOO)*(iVec-1) +
     &           iAdrOff(iSym,iVecOO)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLij),lTot,
     &           iAdr)

            lTot = nMoMo(iSym,iVecVO)*NumVec
            iAdr = 1 + nMoMo(iSym,iVecVO)*(iVec-1) +
     &           iAdrOff(iSym,iVecVO)
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLia),lTot,
     &           iAdr)
         End If

*     Put the Lpq-vectors together to one large vector
*     ------------------------------------------------

         iOff2 = 0
         Do iVec1 = 1, NumVec
            Do i = 1, nFro(iSym)
               iOff1 = nMoMo(iSym,iVecFF)*(iVec1-1) + (i-1)*nFro(iSym)
               Call dCopy_(nFro(iSym),Wrk(kLJK+iOff1),1,
     &                               Wrk(kLip+iOff2),1)
               iOff2 = iOff2+nFro(iSym)
               iOff1 = nMoMo(iSym,iVecOF)*(iVec1-1) + (i-1)*nOcc(iSym)
               Call dCopy_(nOcc(iSym),Wrk(kLKi+iOff1),1,
     &                               Wrk(kLip+iOff2),1)
               iOff2 = iOff2+nOcc(iSym)
               iOff1 = nMoMo(iSym,iVecVF)*(iVec1-1) + (i-1)*nVir(iSym)
               Call dCopy_(nVir(iSym),Wrk(kLKa+iOff1),1,
     &                               Wrk(kLip+iOff2),1)
               iOff2 = iOff2+nVir(iSym)
            End Do
            Do i = 1, nOcc(iSym)
               iOff1 = nMoMo(iSym,iVecFO)*(iVec1-1) + (i-1)*nFro(iSym)
               Call dCopy_(nFro(iSym),Wrk(kLiK+iOff1),1,
     &                               Wrk(kLip+iOff2),1)
               iOff2 = iOff2 + nFro(iSym)
               iOff1 = nMoMo(iSym,iVecOO)*(iVec1-1) + (i-1)*nOcc(iSym)
               Call dCopy_(nOcc(iSym),Wrk(kLij+iOff1),1,
     &                               Wrk(kLip+iOff2),1)
               iOff2 = iOff2 + nOcc(iSym)
               iOff1 = nMoMo(iSym,iVecVO)*(iVec1-1) + (i-1)*nVir(iSym)
               Call dCopy_(nVir(iSym),Wrk(kLia+iOff1),1,
     &                               Wrk(kLip+iOff2),1)
               iOff2 = iOff2 + nVir(iSym)
            End Do
         End Do

         Do iVec1 = 1, NumVec
            iOff = nOrb(iSym)*nOccAll(iSym)*(iVec1-1)
            Call dGemm_('N','N',nOrb(iSym),nOccAll(iSym),nOrb(iSym),
     &                  1.0d0,Work(ipDensity(iSym)),nOrb(iSym),
     &                  Wrk(kLip+iOff),nOrb(iSym),0.0d0,
     &                  Wrk(kVip+iOff),nOrb(iSym))
         End Do

*     Construct exchange contribution to Wij
*     --------------------------------------

         Do iVec1 = 1, NumVec
            iOff = nOrb(iSym)*nOccAll(iSym)*(iVec1-1)
            Call dGemm_('T','N',nOccAll(iSym),nOccAll(iSym),nOrb(iSym),
     &                 1.0d0,Wrk(kLip+iOff),nOrb(iSym),
     &                 Wrk(kVip+iOff),nOrb(iSym),1.0d0,
     &                 Wrk(kWij2),nOccAll(iSym))
         End Do
      End Do

      Call ChoMP2_OpenF(iClos,1,iSym)

*     Add SCF-density to MP2-density contribution
*     -------------------------------------------
      Do iSym1 = 1, nSym
         Do i = 1, nOcc(iSym1) + nFro(iSym1)
            Work(ipDensity(iSym1)+(i-1)*nOrb(iSym1)+(i-1)) =
     &        Work(ipDensity(iSym1)+(i-1)*nOrb(iSym1)+(i-1)) + 2.0d0
         End Do
      End Do

*     Construct Mp2 + SCF W-density
*     -----------------------------

      Do i = 1, nFro(iSym)
         iOrb = i
         Do j = 1, nFro(iSym)
            jOrb = j
            term = 0.0d0
            If(i .eq. j) term = Efro(iFro(iSym)+i)
            Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &          - Wrk(kWJK(iSym) + j-1 + nFro(iSym)*(i-1)) + 2.0d0*term
            Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &           Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) -
     &           Wrk(kWij2 + j-1 + nOccAll(iSym)*(i-1))
         End Do
      End Do
      Do i = 1, nOcc(iSym)
            iOrb = nFro(iSym) + i
            Do j = 1, nFro(iSym)
               jOrb = j
               Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &           - 0.5d0* Wrk(kWiK(iSym) + i-1 + nOcc(iSym)*(j-1))
               Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &           Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym))
     &         - Wrk(kWij2 + jOrb-1 + nOccAll(iSym)*(iOrb-1))
               Work(ipWDensity(iSym) + iOrb-1 + (jOrb-1)*nOrb(iSym)) =
     &           - 0.5d0* Wrk(kWiK(iSym) + i-1 + nOcc(iSym)*(j-1))
               Work(ipWDensity(iSym) + iOrb-1 + (jOrb-1)*nOrb(iSym)) =
     &           Work(ipWDensity(iSym) + iOrb-1 + (jOrb-1)*nOrb(iSym))
     &         - Wrk(kWij2 + jOrb-1 + nOccAll(iSym)*(iOrb-1))
            End Do
         End Do
      Do i = 1, nOcc(iSym)
         iOrb = nFro(iSym) + i
         Do j = 1, nOcc(iSym)
            jOrb = nFro(iSym) + j
            term = 0.0d0
            If(i .eq. j) term = EOcc(iOcc(iSym)+i)
            Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &         - Wrk(kWij(iSym) + j-1 + nOcc(iSym)*(i-1)) + 2.0d0*term
            Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &           Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym))
     &         - Wrk(kWij2 + jOrb-1 + nOccAll(iSym)*(iOrb-1))
         End Do
      End Do

      Do i = 1, nFro(iSym)
         iOrb = i
         Do j = 1, nVir(iSym)
            jOrb = nFro(iSym) + nOcc(iSym) + j
            Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &           -0.5d0*Wrk(kWaK(iSym) + j-1 + nVir(iSym)*(i-1))
            Work(ipWDensity(iSym) + iOrb-1 + (jOrb-1)*nOrb(iSym)) =
     &           -0.5d0*Wrk(kWaK(iSym) + j-1 + nVir(iSym)*(i-1))
         End Do
      End Do

      Do i = 1, nOcc(iSym)
         iOrb = nFro(iSym) + i
         Do j = 1, nVir(iSym)
            jOrb = nFro(iSym) + nOcc(iSym) + j
            Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &           -0.5d0*Wrk(kWai(iSym) + j-1 + nVir(iSym)*(i-1))
            Work(ipWDensity(iSym) + iOrb-1 + (jOrb-1)*nOrb(iSym)) =
     &           -0.5d0*Wrk(kWai(iSym) + j-1 + nVir(iSym)*(i-1))
         End Do
      End Do


      Do i = 1, nVir(iSym)
         iOrb = nFro(iSym) + nOcc(iSym) +i
         Do j = 1, nVir(iSym)
            jOrb = nFro(iSym) + nOcc(iSym) + j
            Work(ipWDensity(iSym) + jOrb-1 + (iOrb-1)*nOrb(iSym)) =
     &         - Wrk(kWab(iSym) + j-1 + nVir(iSym)*(i-1))
         End Do
      End Do

#ifdef _DEBUGPRINT_
      Write(6,*) 'Full One-electron Density Matrix'
      iOff = 0
      Do iSym = 1, nSym
         Do i = 1, nOrb(iSym)*nOrb(iSym)
            Write(6,*) Work(ipMP2D + i-1+iOff)
         End Do
         iOff = iOff + nOrb(iSym)*nOrb(iSym)
      End Do
      Write(6,*) 'Full One-electron energy weighted D Matrix'
      iOff = 0
      Do iSym = 1, nSym
         Do i = 1, nOrb(iSym)*nOrb(iSym)
            Write(6,*) Work(ipMP2W + i-1+iOff)
         End Do
         iOff = iOff + nOrb(iSym)*nOrb(iSym)
      End Do
#endif


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function SIMPLM(NMP,F,X)
! Calculates  Intg/xmin,xmax/(F(x) dx)
! if the F function has been evaluated in a logarithmic mesh.
!
! Note that the integral equals Ingt/xmin,xmax/(F.x d(ln x)),
! which is what is actually calculated.
!
! NMP:    number of mesh points
! F:      array with the function values
! X:      array with the variable values of the log. mesh

use Constants, only: Zero, Three, Four, Six, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: SIMPLM
integer(kind=iwp), intent(in) :: NMP
real(kind=wp), intent(in) :: F(NMP), X(NMP)
integer(kind=iwp) :: I, IP1, IP2, J, N, NM2
real(kind=wp) :: DELTA, DLM, SUM_

! checks the precision of the incr. of the log.mesh
DLM = log(X(2))-log(X(1))
do J=2,5
  DELTA = log(X(J+1))-log(X(J))
  if (abs(DELTA-DLM) >= 1.0e-8_wp) then
    write(u6,602)
    call Abend()
  end if
end do

if (mod(NMP,2) /= 0) then
  N = NMP
else
  N = NMP-1
end if
! Odd number of points
SUM_ = Zero
NM2 = N-2
do I=1,NM2,2
  IP1 = I+1
  IP2 = I+2
  SUM_ = SUM_+F(I)*X(I)+Four*F(IP1)*X(IP1)+F(IP2)*X(IP2)
end do
SIMPLM = SUM_*DLM/Three
if (N == NMP) return

! even number of points: add up the remaining
SUM_ = 2.5_wp*F(NMP)*X(NMP)+Four*F(N)*X(N)-Half*F(N-1)*X(N-2)
SIMPLM = SIMPLM+SUM_*DLM/Six

return

602 format(' SIMPLM: Increment of the log mesh not constant')

end function SIMPLM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992,2000, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine Drvg1(Grad,Temp,nGrad)
!***********************************************************************
!                                                                      *
!  Object: driver for two-electron integrals. The four outermost loops *
!          will control the type of the two-electron integral, eg.     *
!          (ss|ss), (sd|pp), etc. The next four loops will generate    *
!          list of symmetry distinct centers that do have basis        *
!          functions of the requested type.                            *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for k2 loop. August '91                         *
!             Modified for gradient calculation. January '92           *
!             Modified for SetUp_Ints. January '00                     *
!***********************************************************************

use setup, only: mSkal, MxPrm
use k2_arrays, only: Sew_Scr
use Sizes_of_Seward, only: S
use Gateway_Info, only: CutInt
use Para_Info, only: nProcs, King
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Eight
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Temp(nGrad)
integer(kind=iwp) :: i, iAng, ijMax, ijS, iOpt, iS, j, jAng, jS, kls, kS, lS, nHrrab, nij, nSkal
real(kind=wp) :: A_int, Cnt, P_Eff, ThrAO, TMax_all, TskHi, TskLw
logical(kind=iwp) :: DoFock, DoGrad, Indexation, lDummy, Triangular
character(len=8) :: Method_chk
integer(kind=iwp), allocatable :: Pair_Index(:,:)
real(kind=wp), allocatable :: TMax(:,:)
logical(kind=iwp), external :: Rsv_GTList
!*********** columbus interface ****************************************
integer(kind=iwp) :: Columbus
!                                                                      *
!***********************************************************************
!                                                                      *

Temp(:) = Zero

call StatusLine('Alaska: ','Computing 2-electron gradients')
!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Basis_Mode('Valence')
call Setup_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
!-- Precompute k2 entities.

call Get_iScalar('Columbus',Columbus)
Indexation = .false.
call Get_cArray('Relax Method',Method_chk,8)
! MP2 gradients:
if (Method_chk == 'MBPT2   ') Indexation = .true.
!*********** columbus interface ****************************************
! in order to access the half-sorted density matrix file
! some index arrays must be generated
if (Columbus == 1) Indexation = .true.
DoFock = .false.
DoGrad = .true.
ThrAO = Zero
call SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
mSkal = nSkal
!                                                                      *
!***********************************************************************
!                                                                      *
!-- Prepare handling of two-particle density.

call PrepP()

!                                                                      *
!***********************************************************************
!                                                                      *
MxPrm = 0
do iAng=0,S%iAngMx
  MxPrm = max(MxPrm,S%MaxPrm(iAng))
end do
!
!***********************************************************************
!                                                                      *
!-- Compute entities for prescreening at shell level

call mma_allocate(TMax,nSkal,nSkal,Label='TMax')
call Shell_MxSchwz(nSkal,TMax)
TMax_all = Zero
do iS=1,nSkal
  do jS=1,iS
    TMax_all = max(TMax_all,TMax(iS,jS))
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Create list of non-vanishing pairs

call mma_allocate(Pair_Index,2,nskal*(nSkal+1)/2,Label='Ind_ij')
nij = 0
do iS=1,nSkal
  do jS=1,iS
    if (TMax_All*TMax(iS,jS) >= CutInt) then
      nij = nij+1
      Pair_Index(1,nij) = iS
      Pair_Index(2,nij) = jS
    end if
  end do
end do
P_Eff = real(nij,kind=wp)
!                                                                      *
!***********************************************************************
!                                                                      *
!-- Compute FLOPs for the transfer equation.

do iAng=0,S%iAngMx
  do jAng=0,iAng
    nHrrab = 0
    do i=0,iAng+1
      do j=0,jAng+1
        if (i+j <= iAng+jAng+1) then
          ijMax = min(iAng,jAng)+1
          nHrrab = nHrrab+ijMax*2+1
        end if
      end do
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
Triangular = .true.
call Init_TList(Triangular,P_Eff)
call Init_PPList()
call Init_GTList()
iOpt = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! In MPP case dispatch one processor to do 1-el gradients first

if ((nProcs > 1) .and. King()) then
  call Drvh1(Grad,Temp,nGrad)
  !if (nPrint(1) >= 15) call PrGrad(' Gradient excluding two-electron contribution',Grad,lDisp(0))
  Temp(:) = Zero
end if
!                                                                      *
!***********************************************************************
!                                                                      *
ijS = 0
klS = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! big loop over individual tasks, distributed over individual nodes
do
  ! make reservation of a task on global task list and get task range
  ! in return. Function will be false if no more tasks to execute.
  if (.not. Rsv_GTList(TskLw,TskHi,iOpt,lDummy)) exit

  ! Now do a quadruple loop over shells

  ijS = int((One+sqrt(Eight*TskLw-Three))/Two)
  klS = int(TskLw-real(ijS,kind=wp)*(real(ijS,kind=wp)-One)/Two)
  Cnt = TskLw

  Cnt = Cnt-One
  klS = kls-1
  do
    Cnt = Cnt+One
    if (Cnt-TskHi > 1.0e-10_wp) exit
    klS = klS+1
    if (klS > ijS) then
      ijS = ijS+1
      klS = 1
    end if
    iS = Pair_Index(1,ijS)
    jS = Pair_Index(2,ijS)
    kS = Pair_Index(1,klS)
    lS = Pair_Index(2,klS)

    A_int = TMax(iS,jS)*TMax(kS,lS)
    if (A_Int < CutInt) cycle

    call Eval_g1_ijkl(iS,jS,kS,lS,Temp,nGrad,A_Int)

  end do

  ! Task endpoint
end do
! End of big task loop
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _MOLCAS_MPP_
call GADGOP(Temp,nGrad,'+')
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
!                         E P I L O G U E                              *
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Sew_Scr,safe='*')
call Free_GTList()
call Free_PPList()
call Free_TList()
call mma_deallocate(Pair_Index)
call mma_deallocate(TMax)
!                                                                      *
!***********************************************************************
!                                                                      *
call CloseP()
call Term_Ints()
!                                                                      *
!***********************************************************************
!                                                                      *
call Free_iSD()

!write(6,*) 'Exit Drvg1'

end subroutine Drvg1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine FnoCASPT2_putInf(mSym,lnOrb,lnOcc,lnFro,lnDel,lnVir)
! Purpose: put info in MP2 common blocks.

use ChoMP2, only: C_os, ChkDecoMP2, ChoAlg, Decom_Def, DecoMP2, DoFNO, EOSMP2, ForceBatch, l_Dii, MxQual_Def, MxQualMP2, OED_Thr, &
                  set_cd_thr, SOS_mp2, Span_Def, SpanMP2, ThrMP2, Verbose
use cOrbInf, only: nSym, nOrb, nOcc, nFro, nDel, nExt
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mSym, lnOrb(mSym), lnOcc(mSym), lnFro(mSym), lnDel(mSym), lnVir(mSym)

nSym = mSym
nOrb(1:nSym) = lnOrb(:)
nOcc(1:nSym) = lnOcc(:)
nFro(1:nSym) = lnFro(:)
nDel(1:nSym) = lnDel(:)
nExt(1:nSym) = lnVir(:)

ChoAlg = 2
DecoMP2 = Decom_Def
ThrMP2 = -9.9e9_wp
SpanMP2 = Span_Def
MxQualMP2 = MxQual_Def
ChkDecoMP2 = .false.
ForceBatch = .false.
Verbose = .false.
SOS_mp2 = .false.
set_cd_thr = .true.
OED_Thr = 1.0e-8_wp
C_os = 1.3_wp
EOSMP2 = Zero

DoFNO = .true.
l_Dii = sum(nOcc(1:nSym))

end subroutine FnoCASPT2_putInf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine getpow(max,quot,quotpow,
     *nprim1,nprim2,nprim3,nprim4)
cbs   generates some powers of for the prefactors of cfunct(X)
cbs   look out for details there and in initfrac
      implicit real*8 (a-h,o-z)
#include "para.fh"
      dimension quotpow(nprim1,nprim2,
     *nprim3,nprim4),
     *quot(nprim1,nprim2,nprim3,nprim4)
      do irun4=1,nprim4
      do irun3=1,nprim3
      do irun2=1,nprim2
      do irun1=1,nprim1
      quotpow(irun1,irun2,irun3,irun4)=
     *sqrt(quot(irun1,irun2,irun3,irun4))
      enddo
      enddo
      enddo
      enddo
      if (max.eq.1) return
cbs
      do irun=2,max
      do irun4=1,nprim4
      do irun3=1,nprim3
      do irun2=1,nprim2
      do irun1=1,nprim1
      quotpow(irun1,irun2,irun3,irun4)=
     *quotpow(irun1,irun2,irun3,irun4)*
     *quot(irun1,irun2,irun3,irun4)
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine WRH(LU,NSYM,NBAS,NORB,CMO,OCC,LOCC,TITLE)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LU, NSYM, NBAS(NSYM), NORB(NSYM), LOCC
real(kind=wp), intent(in) :: CMO(*), OCC(*)
character(len=*), intent(inout) :: TITLE
integer(kind=iwp) :: I, IBAS, IORB, ISYM, KCMO, KOCC, NDIV
character(len=40) :: FRMT

FRMT = '(4ES20.12)'
!REWIND(LU)
KCMO = 0
NDIV = 4
if (TITLE(1:1) /= '*') TITLE = '*'//TITLE(:len(TITLE)-1)
if (locc /= 2) then
  do ISYM=1,NSYM
    do IORB=1,NORB(ISYM)
      write(LU,'(A,I5)') '* Column    ',IORB
      do IBAS=1,NBAS(ISYM),NDIV
        write(LU,FRMT) (CMO(I+KCMO),I=IBAS,min(IBAS+3,NBAS(ISYM)))
      end do
      KCMO = KCMO+NBAS(ISYM)
    end do
  end do
end if
if (LOCC == 0) return
write(LU,'(A)') Title
KOCC = 0
do ISYM=1,NSYM
  do IORB=1,NORB(ISYM),NDIV
    write(LU,FRMT) (OCC(I+KOCC),I=IORB,min(IORB+3,NORB(ISYM)))
  end do
  KOCC = KOCC+NORB(ISYM)
end do

return

end subroutine WRH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETDAMP()
C
C     Purpose: set screening damping, unless user-defined.
C
      IMPLICIT NONE
#include "cholesky.fh"
      INTEGER I

      DO I = 1,2
         IF (DAMP(I) .LT. 0.0D0) THEN
            IF (THRCOM .GT. 9.99D-3) THEN ! >= 1.0D-2
               DAMP(I) = 1.0D7
            ELSE IF (THRCOM .GT. 9.99D-4) THEN ! >= 1.0D-3
               DAMP(I) = 1.0D6
            ELSE IF (THRCOM .GT. 9.99D-5) THEN ! >= 1.0D-4
               DAMP(I) = 1.0D5
            ELSE IF (THRCOM .GT. 9.99D-6) THEN ! >= 1.0D-5
               DAMP(I) = 1.0D4
            ELSE IF (THRCOM .GT. 9.99D-7) THEN ! >= 1.0D-6
               DAMP(I) = 1.0D3
            ELSE IF (THRCOM .GT. 9.99D-8) THEN ! >= 1.0D-7
               DAMP(I) = 1.0D2
            ELSE IF (THRCOM .GT. 9.99D-9) THEN ! >= 1.0D-8
               DAMP(I) = 1.0D1
            ELSE
               DAMP(I) = 1.0D0
            END IF
         END IF
      END DO

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Anders Bernhardsson                              *
************************************************************************
      Subroutine CmbnACB1(FA1,FB1,Final,Fact,nAlpha,nBeta,C,nC,
     &                    la,lb,iang,ifgrad,tmp,lsro,
     &                    index,mvec,idcar)
*******************************************************************************
*
*     Merges the first derivatives of ECP projection/SRO  integrals
*     for derivatives of components
*
*******************************************************************************
*
*     @parameter FA1   The first derivative of Left side , Includes no deriavtive (input)
*     @parameter FB1   The first derivative of Right side . Includes no derivative (input)
*     @parameter Final Result added up to (out)
*     @parameter Fact  Factor the reult is multiplied with bef. added up (input)
*     @parameter C     Coefficients for SRO (input)
*     @parameter nAlpha Number of exponents LS (input)
*     @parameter nBeta  Number of exponents RS (input)
*     @parameter nC     Number of exponents in SRO (input)
*     @parameter la     Angular monenta LS (input)
*     @parameter lb     Angular monenta RS (input)
*     @parameter iAng   Angular monenta SRO (input)
*     @parameter Tmp    Working Area nAlpha*nC (SRO case) (scratch)
*     @parameter lSRO   true for SRO false projection operator (input)
*     @paramaeter index array storing index for derivatives in final (out)
*     @parameter  mvec  Number of derivatives calculated (out)
*     @parameter  idcar cartesiam index for current derivative (input)
*
*******************************************************************************
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "disp.fh"

      Logical ifgrad(3,4),lsro
      Real*8 FA1(nAlpha,nC,(la+1)*(la+2)/2,(2*iang+1),*),
     &       FB1(nC,nBeta,(2*iang+1),(lb+1)*(lb+2)/2,*),
     &     Final(nAlpha*nbeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,21)

      Real*8  C(*),Tmp(*)
      Integer Index(3,4)

      nelem(ixyz) = (ixyz+1)*(ixyz+2)/2
      iprint =0


      nZeta = nAlpha*nBeta
      call dcopy_(nZeta*nElem(la)*nElem(lb)*6,
     &                    [Zero],0,Final,1)
      Call iCopy(12,[0],0,Index,1)

      mVec = 0
      Do iCent = 1, 2
         If (ifGrad(iDCar,iCent)) Then
            mVec = mVec + 1
            Index(iDcar,icent)=mvec
*
            If (iCent.eq.1) Then
               iFa = 2
               iFb = 1
            Else
               iFa = 1
               iFb = 2
            End If
*
            Do  ib = 1, nElem(lb)
               Do  ia = 1, nElem(la)

                  Do iC = 1, (2*iAng+1)
                     if (lsro) Then
                       Call DGEMM_('N','N',
     &                      nAlpha,nC,nC,
     &                      One,FA1(1,1,ia,ic,iFa),nAlpha,
     &                      C,nC,
     &                      Zero,Tmp,nAlpha)
                       Call DGEMM_('N','N',
     &                      nAlpha,nBeta,nC,
     &                      Fact,Tmp,nAlpha,
     &                      FB1(1,1,ic,ib,iFb),nC,
     &                      One,Final(1,ia,ib,mvec),nAlpha)
                     else
                       Call DGEMM_('N','N',
     &                           nAlpha,nBeta,nC,
     &                           Fact,Fa1(1,1,ia,ic,iFa),nAlpha,
     &                           Fb1(1,1,ic,ib,iFb),nC,
     &                           One,Final(1,ia,ib,mvec),
     &                           nAlpha)
                     Endif



                  End DO        ! iC
               End DO           ! iA
            End DO              ! ib

         End If
      End Do ! icent

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Francesco Aquilante                              *
!***********************************************************************

subroutine Charge_GRID_IT(nSym,nBas,CMO,nCMO,OCCN,iDoIt,long_prt)

!***********************************************************************
!
!  Author : F. Aquilante
!
!
!   Purpose: Compute Mulliken charges for each MO separately.
!            The analysis is performed ONLY for the occupied MOs
!            specified in GRID_IT input (this info is stored in iDoIt)
!
!   Note:  this functionality was requested by some Turbomole users
!          recently converted to MolCas. Its scientific value is not
!          too high in my opinion, therefore this subroutine is simply
!          a hack of the existing CHARGE_ and thus infinitely far from
!          efficient coding.
!
!                                            Toulouse, 28 Nov 2011
!
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nCMO, iDoIt(*)
real(kind=wp), intent(in) :: CMO(nCMO), OCCN(*)
logical(kind=iwp), intent(in) :: long_prt
#include "Molcas.fh"
integer(kind=iwp) :: iCase, iComp, iOpt, iOrb, iRc, iSyLbl, iSym, jOcc, MxTyp, nNUC, nTot1
real(kind=wp), allocatable :: QQ(:), S(:), Xocc(:)
character(len=LenIn8), allocatable :: UBName(:)

MxTyp = 0
nTot1 = 0
do iSym=1,nSym
  MxTyp = MxTyp+nBas(iSym)
  nTot1 = nTot1+nBas(iSym)*(nBas(iSym)+1)/2
end do
call mma_allocate(UBName,MxTyp,label='UBName')
call Get_cArray('Unique Basis Names',UBName,LenIn8*MxTyp)
call mma_allocate(Xocc,MxTyp,label='XOCC')
call Get_iScalar('Unique atoms',nNUC)
call mma_allocate(QQ,MxTyp*nNuc,label='QQ')
call mma_allocate(S,nTot1,label='Ovrlp')
iRc = -1
iOpt = 2
iComp = 1
iSyLbl = 1
call RdOne(iRc,iOpt,'Mltpl  0',iComp,S,iSyLbl)
if (iRc /= 0) then
  write(u6,*) 'charge_grid_it: iRc from Call RdOne not 0'
  !write(u6,*) 'Label = ',Label
  write(u6,*) 'iRc = ',iRc
  call Abend()
end if
write(u6,*)
write(u6,*)
write(u6,*)
write(u6,'(A)') '         **************************'
call CollapseOutput(1,'       Charges per occupied MO ')
write(u6,'(A)') '         **************************'
write(u6,*)
write(u6,*)
write(u6,*)

Xocc(:) = Zero

iCase = 2
jOcc = 1
do iSym=1,nSym
  do iOrb=1,nBas(iSym)

    if ((IdoIt(jOcc) == 1) .and. (OCCN(jOcc) > Zero)) then

      write(u6,'(A,I4,A,I1,A,F6.4)') '          MO:',iOrb,'      Symm.: ',iSym,'      Occ. No.: ',OCCN(jOcc)

      Xocc(jOcc) = OCCN(jOcc)

      QQ(:) = Zero
      call One_CHARGE(NSYM,NBAS,UBName,CMO,Xocc,S,iCase,long_prt,MxTyp,QQ,nNuc)
      Xocc(jOcc) = Zero
    end if

    jOcc = jOcc+1
  end do
end do

call mma_deallocate(Xocc)
call mma_deallocate(QQ)
call mma_deallocate(S)
call mma_deallocate(UBName)

return

end subroutine Charge_GRID_IT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Giovanni Ghigo                                   *
************************************************************************
*  ZMatrixConverter
*
*> @brief
*>   Routine for reading seward input in Z-Matrix format
*> @author Giovanni Ghigo
*>
*> @details
*> The input for seward is read and a string vector is generate (\p STDINP).
*> This vector contains a standard seward input and it will be read later as usual
*> by a modified copy of the section ``BASI`` code already present in ::RdCtl_Seward.
*> This new code is in the ::StdSewInput routine.
*> Only the standard basis present in the ``$MOLCAS/basis_library`` are allowed.
*>
*> @param[in]    LuRd    Input file unit number
*> @param[in]    LuWr    Output file unit number
*> @param[in]    mxAtom  Parameter
*> @param[out]   STDINP  String vector of seward standard input
*> @param[out]   lSTDINP Length of String vector \p STDINP
*> @param[out]   iErr    Error flag
************************************************************************
       Subroutine ZMatrixConverter(LuRd,LuWr,mxAtom,STDINP,lSTDINP,
     & iglobal,nxbas,xb_label,xb_bas,iErr)
************************************************************************
* Author: Giovanni Ghigo                                               *
*         Torino (Italy)  October-November 2006                        *
*                                                                      *
* This is an adaptation of Program ZMatrixConverter                    *
* A converter of Z-Matrix in cartesian coordinates in MolCAS format.   *
* Version 1.0                                                          *
* The input for seward is read and a string vector is generate. This   *
* vector is a standard seward input and it will be read later as usual *
* by a copy on the code already present in RdCtl_Seward.               *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Character*180 STDINP(mxAtom*2)
      Character*80 Blank
      Character*180 aDebug
      Character*12 Angstring
#include "constants.fh"
#include "g_zmatconv.fh"
      Logical IfTest
        character *(*) xb_label(*)
        character *(*) xb_bas(*)

#ifdef _DEBUGPRINT_
      IfTest=.True.
#else
      IfTest=.False.
#endif

C  ***  H-Fm (Atomic numbers 1-100)
C  ***  X dummy atoms (NA = 0 )
C  ***  Z ghost atoms (NA =-1 )
C  ***  nAskAtoms.EQ.-1  =>  Seward ZMAT input
C  ***  nAskAtoms.NE.-1  =>  GateWay ZMAT input

C nAtoms : nr. of atoms passed to SEWARD (includes X dummy atoms).
C nXAtoms: nr. of ghost Z atoms (not passed to SEWARD but resumed
C          by OutZMat in SLAPAF).
C nBase  : number of BasisSets found in input.
C Base(i): BasisSet for atom with Atomic Number -i-.
C BasAva(i) & BasReq(i): Logical to check BasisSet-consistency.
C Coords(_,i): X, Y, Z, coordinates (in Angstrom) for atom -i-.


      nAtoms  = 0
      nXAtoms = 0
      nBase  = 0
      lSTDINP = 0
      Do i = 1, Num_Elem
        Base(i)   = ' '
        BasAva(i) = .False.
        BasReq(i) = .False.
      EndDo
      Do i = 1, MaxAtoms
        Coords(i,1) = 0.0d0
        Coords(i,2) = 0.0d0
        Coords(i,3) = 0.0d0
      EndDo
      nBasis = 0
      iErr   = 0
      Blank = ' '
      Angstring = '  / Angstrom'

* Reading input
      iErr = 0
      Call BasisReader(LuWr,nBase,iglobal,
     &      nxbas,xb_label,xb_bas,iErr)
      If (IfTest) then
        Write(LuWr,*)
        Write(LuWr,*) '------------------------------------------------'
        Write(LuWr,*) 'ZMatrixConverter - From BasisReader :'
        Write(LuWr,*) '                   nBase=',nBase
        Do i = 1, Num_Elem
          If (BasAva(i)) Write(LuWr,'(I23,3X,A)') i, Base(i)
        EndDo
        Write(LuWr,*)
      EndIf
      If (iErr.NE.0) GoTo 9905
      iErr = 0
      Call ZMatReader(LuRd,LuWr,nAtoms,nXAtoms,nBasis,-1,iErr)
      If (IfTest) then
        Write(LuWr,*)
        Write(LuWr,*) '------------------------------------------------'
        Write(LuWr,*) 'ZMatrixConverter - From ZMatReader :'
        Write(LuWr,*) '                   nAtoms=',nAtoms,
     &     ', nXAtoms=',nXAtoms,', Tot=',nAtoms+nXAtoms
        Write(LuWr,*)
     &' Label NA    i   bond        j   angle       k   dihedral'
        Do i = 1, nAtoms+nXAtoms
          Write(LuWr,'(1X,A,I3,3(1X,I4,1X,F10.6))')
     &    Symbols(i),NAT(i),(iZmat(i,j),Zmat(i,j),j=1,3)
        EndDo
        Write(LuWr,*)
      EndIf
      If (iErr.NE.0) GoTo 9906

* Some checks
      If (nBase.EQ.0) then
        Write(LuWr,*) 'ERROR: No basis set specified !'
        GoTo 9999
      EndIf
      If (nAtoms.EQ.0) then
        Write(LuWr,*) 'ERROR: No atom coordinates specified !'
        GoTo 9999
      EndIf
      If (nBase.lt.nBasis) then
        Write(LuWr,*) 'ERROR: Wrong number of basis sets !'
        Write(LuWr,*) '       Available=',nBase,'  Required=',nBasis
        GoTo 9999
      EndIf
      Call BasisConsistency(LuWr,iErr)
      If (iErr.NE.0) then
        Write(LuWr,*) 'ERROR: Basis set inconsistency !'
        GoTo 9999
      EndIf

      Call Put_iScalar('N ZMAT',nAtoms+nXAtoms)
      Call Put_cArray('Symbol ZMAT',Symbols(1),(nAtoms+nXAtoms)*5)
      Call Put_iArray('Index ZMAT',iZmat,MaxAtoms*3)
      Call Put_iArray('NAT ZMAT',NAT,nAtoms+nXAtoms)

* Calculate coordinates
      torad = CONST_PI_ / 180.0d0
*     Atom #1
      If (nAtoms+nXAtoms.EQ.1) GoTo 2000
*     Atom #2
      Coords(2,3)=Zmat(2,1)  ! Z(2)=R
      If (nAtoms+nXAtoms.EQ.2) GoTo 2000
*     Atom #3
      If (iZmat(3,1).EQ.1) then
        Coords(3,1)=Zmat(3,1)*SIN(Zmat(3,2)*torad) ! X(2)=R sin(A)
        Coords(3,3)=Zmat(3,1)*COS(Zmat(3,2)*torad) ! Z(3)=R cos(A)
      else
        Coords(3,1)=Zmat(3,1)*SIN(Zmat(3,2)*torad)
        Coords(3,3)=Coords(2,3)-Zmat(3,1)*COS(Zmat(3,2)*torad)
      EndIf
      If (nAtoms+nXAtoms.EQ.3) GoTo 2000
*     Atom #4 ->
      Do iAtom = 4, nAtoms+nXAtoms
        Call ZMatConv(LuWr,iAtom,iErr)
      EndDo
      If (iErr.NE.0) GoTo 9999

      If (IfTest) then
        Write(LuWr,*)
        Write(LuWr,*) '------------------------------------------------'
        Write(LuWr,*) 'ZMatrixConverter - XYZCoords (Angstroms) :'
        Do i = 1, nAtoms+nXAtoms
          Write(LuWr,99) i,NAT(i),(Coords(i,j),j=1,3)
        EndDo
        Write(LuWr,*)
      EndIf

*     Check for superposed atoms
      Do i = 1, nAtoms+nXAtoms
        If (NAT(i).GT.0) then
          Do j = i+1, nAtoms+nXAtoms
            If (NAT(j).GT.0) then
              r = 0.0d0
              Do k =1, 3
                r = r + (Coords(i,k)-Coords(j,k))**2
              EndDo
              If (r.LT.0.0001d0) GoTo 9907
            EndIf
          EndDo
        EndIf
      EndDo

* Writing
2000  Continue
      If (NAT(1).EQ.-1) then
        NATprev = -1
      else
        NATprev = -9999
      EndIf
      iSTDINP = 1
      Do i = 1, nAtoms+nXAtoms
        If (NAT(i).EQ.-1) GoTo 2100
        If (NAT(i).NE.NATprev) then
          If (i.NE.1 .and. NATprev.NE.-1) then
             Write(STDINP(iSTDINP),'(A)') 'End of basis'
             iSTDINP = iSTDINP + 1
          EndIf
          Write(STDINP(iSTDINP),'(A)') 'Basis set'
          iSTDINP = iSTDINP + 1
          If (NAT(i).GT.0) then
            Write(STDINP(iSTDINP),'(A)') Base(NAT(i))
          else
            Write(STDINP(iSTDINP),'(A)') 'X..... / InLine '
            iSTDINP = iSTDINP + 1
            Write(STDINP(iSTDINP),'(A)') '0.   0'
            iSTDINP = iSTDINP + 1
            Write(STDINP(iSTDINP),'(A)') '0    0'
          EndIf
          iSTDINP = iSTDINP + 1
          NATprev = NAT(i)
        EndIf
        Write(STDINP(iSTDINP),'(A5,3F16.10,A)')
     &          Symbols(i),(Coords(i,j),j=1,3),Angstring
        iSTDINP = iSTDINP + 1
2100    Continue
      EndDo
      Write(STDINP(iSTDINP),'(A)') 'End of basis'
      lSTDINP = iSTDINP
      If (IfTest) then
        Write(LuWr,*)
        Write(LuWr,*) '------------------------------------------------'
        Write(LuWr,*) 'ZMatrixConverter - The input passed to SEWARD : '
        Do i = 1, iSTDINP
          aDebug = STDINP(i)
          Write(LuWr,*) aDebug
        EndDo
        Write(LuWr,*)
      EndIf
      GoTo 9999

99    Format(I3,1X,I3,1X,3(F12.6))

9905  Write(LuWr,*) ' ERROR: Wrong input in Bases Set definition !'
      GoTo 9999
9906  Write(LuWr,*) ' ERROR: Wrong input in Z-Matrix definition !'
      GoTo 9999
9907  Write(LuWr,*) ' ERROR: Superimposed atoms: ',i,j,'  r=',sqrt(r)
      GoTo 9999

9999  Continue

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
*               2003, Jesper Wisborg Krogh                             *
************************************************************************
      SUBROUTINE ADTOR2(    RHO2,   RHO2S,   RHO2A,   RHO2T,   ITYPE,
     &                        NI,    IOFF,      NJ,    JOFF,      NK,
     &                      KOFF,      NL,    LOFF,    NORB,   IPACK)
*
* Add contributions to two electron density matrix RHO2
* output density matrix is in the form Rho2(ij,kl),(ij).ge.(kl)
*
*
* Jeppe Olsen, Fall of 96
* Jesper Wisborg Krogh, September 03: Can now symmetry pack on the fly
*
*
* Itype = 1 => alpha-alpha or beta-beta loop
*              input is in form Rho2t(ik,jl)
* Itype = 2 => alpha-beta loop
*              input is in form Rho2t(ij,kl)
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "crun.fh"
#include "orbinp.fh"
*.Input
      DIMENSION RHO2T(*)
      LOGICAL   IPACK
*. Input and output
      DIMENSION RHO2(*),RHO2S(*),RHO2A(*)
* Program flow flags
      LOGICAL   IPROCEED,DO_IJKL,DO_IJKL_PACK,DO_JIKL_PACK
*
* Some dummy initializations
      NII = 0 ! jwk-cleanup
      NJJ = 0 ! jwk-cleanup
      NKK = 0 ! jwk-cleanup
      NLL = 0 ! jwk-cleanup
      KKOFF = 0 ! jwk-cleanup
      LLOFF = 0 ! jwk-cleanup
      SIGN = 1.0D0 ! jwk-cleanup
      IACTIVE = 1 ! jwk-cleanup
      I = 0 ! jwk-cleanup
      K = 0 ! jwk-cleanup
      J = 0 ! jwk-cleanup
      L = 0 ! jwk-cleanup
      I_PACK    = 0
      J_PACK    = 0
      K_PACK    = 0
      L_PACK    = 0
      IJ_PACK   = 0
      JI_PACK   = 0
      KL_PACK   = 0
      FACTOR    = 0.0d0
*
      NTEST = 000
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Welcome to ADTOR2 '
        WRITE(6,*) ' ================='
        WRITE(6,*) ' NI NJ NK NL = ', NI,NJ,NK,NL
        WRITE(6,*) ' IOFF JOFF KOFF LOFF =',IOFF,JOFF,KOFF,LOFF
        WRITE(6,*) ' ITYPE = ',ITYPE
        WRITE(6,*) ' NORB ', NORB
        IF(NTEST.GE.2000 .AND. .NOT. IPACK) THEN
          WRITE(6,*) ' Initial two body density matrix '
          CALL PRSYM(RHO2,NORB**2)
        END IF
*
        WRITE(6,*) ' RHO2T : '
        IF(ITYPE.EQ.1) THEN
          IF(IOFF.EQ.KOFF) THEN
            NROW = NI*(NI+1)/2
          ELSE
            NROW = NI*NK
          END IF
          IF(JOFF.EQ.LOFF) THEN
            NCOL = NJ*(NJ+1)/2
          ELSE
            NCOL = NJ*NL
          END IF
        ELSE IF (ITYPE.EQ.2) THEN
          NROW = NI*NJ
          NCOL = NK*NL
        END IF
        CALL WRTMAT(RHO2T,NROW,NCOL,NROW,NCOL)
      END IF

C?    RETURN
*
      NELMNT = NORB**2*(NORB**2+1)/2
*
      IF(ITYPE.EQ.1) THEN
*
* =======================================
*     Alpha-alpha or beta-beta term
* =======================================
*
*. Four permutations
      DO IPERM = 1, 4
        IF(IPERM.EQ.1) THEN
          NII = NI
          IIOFF = IOFF
          NJJ = NJ
          JJOFF = JOFF
          NKK = NK
          KKOFF = KOFF
          NLL = NL
          LLOFF = LOFF
          SIGN = 1.0D0
          IACTIVE = 1
        ELSE IF(IPERM.EQ.2) THEN
          IF(IOFF.NE.KOFF) THEN
            NII = NK
            IIOFF = KOFF
            NKK = NI
            KKOFF = IOFF
            NJJ = NJ
            JJOFF = JOFF
            NLL = NL
            LLOFF = LOFF
            IACTIVE = 1
          ELSE
            IACTIVE = 0
          END IF
          SIGN = -1.0D0
        ELSE IF(IPERM.EQ.3) THEN
          IF(JOFF.NE.LOFF) THEN
            NII = NI
            IIOFF = IOFF
            NKK = NK
            KKOFF = KOFF
            NJJ = NL
            JJOFF = LOFF
            NLL = NJ
            LLOFF = JOFF
            SIGN = -1.0D0
            IACTIVE = 1
          ELSE
            IACTIVE = 0
          END IF
        ELSE IF(IPERM.EQ.4) THEN
          IF(IOFF.NE.KOFF.AND.JOFF.NE.LOFF) THEN
            NKK = NI
            KKOFF = IOFF
            NII = NK
            IIOFF = KOFF
            NJJ = NL
            JJOFF = LOFF
            NLL = NJ
            LLOFF = JOFF
            SIGN = 1.0D0
            IACTIVE = 1
          ELSE
            IACTIVE = 0
          END IF
        END IF
*
        IJOFF = (JJOFF-1)*NORB+IIOFF
        KLOFF = (LLOFF-1)*NORB+KKOFF
C       IF(IACTIVE.EQ.1.AND.IJOFF.GE.KLOFF) THEN
        IF(IACTIVE.EQ.1) THEN
          IJOFF = (JJOFF-1)*NORB+IIOFF
          KLOFF = (LLOFF-1)*NORB+LLOFF
            DO II = 1, NII
              DO JJ = 1, NJJ
                DO KK = 1, NKK
                  DO LL = 1, NLL
                    IJ = (JJ+JJOFF-2)*NORB + II+IIOFF - 1
                    KL = (LL+LLOFF-2)*NORB + KK+KKOFF - 1

                    IPROCEED     = .FALSE.
                    DO_IJKL      = .FALSE.
                    DO_IJKL_PACK = .FALSE.
                    DO_JIKL_PACK = .FALSE.
                    IF (IPACK) THEN
                       I_PACK    = II + IIOFF - 1
                       J_PACK    = JJ + JJOFF - 1
                       K_PACK    = KK + KKOFF - 1
                       L_PACK    = LL + LLOFF - 1

                       IJ_PACK   = I_PACK*(I_PACK-1)/2 + J_PACK
                       JI_PACK   = J_PACK*(J_PACK-1)/2 + I_PACK
                       KL_PACK   = K_PACK*(K_PACK-1)/2 + L_PACK

                       IF (K_PACK .EQ. L_PACK) THEN
                          FACTOR = 0.25d0
                       ELSE
                          FACTOR = 0.5d0
                       END IF

                       IF (K_PACK .GE. L_PACK) THEN
                          IF (I_PACK .GE. J_PACK .AND.
     &                          IJ_PACK .GE. KL_PACK) THEN
                             DO_IJKL_PACK = .TRUE.
                             IPROCEED     = .TRUE.
                          END IF
                          IF (J_PACK .GE. I_PACK .AND.
     &                          JI_PACK .GE. KL_PACK) THEN
                             DO_JIKL_PACK = .TRUE.
                             IPROCEED     = .TRUE.
                          END IF
                       END IF
                    ELSE IF (IJ .GE. KL) THEN
                       DO_IJKL  = .TRUE.
                       IPROCEED = .TRUE.
                       FACTOR   = 1.0D0
                    END IF

                    IF (IPROCEED) THEN
                      IF(IPERM.EQ.1) THEN
                        I = II
                        K = KK
                        J = JJ
                        L = LL
                      ELSE IF(IPERM.EQ.2) THEN
                        I = KK
                        K = II
                        J = JJ
                        L = LL
                      ELSE IF(IPERM.EQ.3) THEN
                        I = II
                        K = KK
                        J = LL
                        L = JJ
                      ELSE IF(IPERM.EQ.4) THEN
                        I = KK
                        K = II
                        J = LL
                        L = JJ
                      END IF
                      IF(IOFF.NE.KOFF) THEN
                        IKIND = (K-1)*NI+I
                        NIK = NI*NK
                        SIGNIK = 1.0D0
                      ELSE
                        IKIND = MAX(I,K)*(MAX(I,K)-1)/2+MIN(I,K)
                        NIK = NI*(NI+1)/2
                        IF(I.EQ.MAX(I,K)) THEN
                          SIGNIK = 1.0D0
                        ELSE
                          SIGNIK = -1.0D0
                        END IF
                      END IF
                      IF(JOFF.NE.LOFF) THEN
                        JLIND = (L-1)*NJ+J
                        SIGNJL = 1.0D0
                      ELSE
                        JLIND = MAX(J,L)*(MAX(J,L)-1)/2+MIN(J,L)
                        IF(J.EQ.MAX(J,L)) THEN
                          SIGNJL = 1.0D0
                        ELSE
                          SIGNJL = -1.0D0
                        END IF
                      END IF
                      IKJLT = (JLIND-1)*NIK+IKIND
                      TERM = FACTOR*SIGN*SIGNJL*SIGNIK*RHO2T(IKJLT)

                      IF (DO_IJKL_PACK) THEN
                         IJKL_PACK = IJ_PACK*(IJ_PACK-1)/2 + KL_PACK
                         RHO2S(IJKL_PACK) = RHO2S(IJKL_PACK) - TERM
                         RHO2A(IJKL_PACK) = RHO2A(IJKL_PACK) - TERM
                      END IF
                      IF (DO_JIKL_PACK) THEN
                         JIKL_PACK = JI_PACK*(JI_PACK-1)/2 + KL_PACK
                         RHO2S(JIKL_PACK) = RHO2S(JIKL_PACK) - TERM
                         RHO2A(JIKL_PACK) = RHO2A(JIKL_PACK) + TERM
                      END IF
                      IF (DO_IJKL) THEN
                         IJKL = IJ*(IJ-1)/2+KL
                         IF(IJKL.GT.NELMNT) THEN
                            WRITE(6,*) ' Problemo 1 : IJKL .gt. NELMNT'
                            WRITE(6,*) ' IJKL, NELMNT',IJKL,NELMNT
                            WRITE(6,*) ' IJ, KL', IJ,KL
                            WRITE(6,*) ' JJ JJOFF ', JJ,JJOFF
                            WRITE(6,*) ' II IIOFF ', II,IIOFF
                            WRITE(6,*) ' IPERM = ', IPERM
                         END IF
                         RHO2(IJKL) = RHO2(IJKL) - TERM
                      END IF
*. The minus : Rho2t comes as <a+i a+k aj al>, but we want
* <a+ia+k al aj>
                    END IF
                  END DO
                END DO
              END DO
            END DO
*. End of active/inactive if
        END IF
*. End of loop over permutations
      END DO
      ELSE IF(ITYPE.EQ.2) THEN
*
* =======================================
*     Alpha-alpha or beta-beta term
* =======================================
*
      DO I = 1, NI
       DO J = 1, NJ
         DO K = 1, NK
           DO L = 1, NL
             IJ = (J+JOFF-2)*NORB + I+IOFF - 1
             KL = (L+LOFF-2)*NORB + K+KOFF - 1
             IF(IJ.EQ.KL) THEN
               FACTOR = 2.0D0
             ELSE
               FACTOR = 1.0D0
             END IF
             IJKL = MAX(IJ,KL)*(MAX(IJ,KL)-1)/2+MIN(IJ,KL)
             IJKLT = (L-1)*NJ*NK*NI+(K-1)*NJ*NI
     &             + (J-1)*NI + I
                      IF(IJKL.GT.NELMNT) THEN
                         WRITE(6,*) ' Problemo 2 : IJKL .gt. NELMNT'
                         WRITE(6,*) ' IJKL, NELMNT',IJKL,NELMNT
                      END IF
             TERM = FACTOR*RHO2T(IJKLT)
             IF (IPACK) THEN
                DO IPERM = 1,2
                   IF (IPERM .EQ. 1) THEN
                      I_PACK    = I + IOFF - 1
                      J_PACK    = J + JOFF - 1
                      K_PACK    = K + KOFF - 1
                      L_PACK    = L + LOFF - 1
                      JI = (I+IOFF-2)*NORB + J+JOFF - 1
                      IJ_PACK   = I_PACK*(I_PACK-1)/2 + J_PACK
                      JI_PACK   = J_PACK*(J_PACK-1)/2 + I_PACK
                      KL_PACK   = K_PACK*(K_PACK-1)/2 + L_PACK
                   ELSE
                      I_PACK    = K + KOFF - 1
                      J_PACK    = L + LOFF - 1
                      K_PACK    = I + IOFF - 1
                      L_PACK    = J + JOFF - 1
                      IJ_PACK   = I_PACK*(I_PACK-1)/2 + J_PACK
                      JI_PACK   = J_PACK*(J_PACK-1)/2 + I_PACK
                      KL_PACK   = K_PACK*(K_PACK-1)/2 + L_PACK
                   END IF


                IF (K_PACK .EQ. L_PACK) THEN
                   FACTOR_PACK = .25d0
                ELSE
                   FACTOR_PACK = .5d0
                END IF
                IF (I_PACK .EQ. K_PACK .AND. J_PACK .EQ. L_PACK) THEN
                   FACTOR_PACK = FACTOR_PACK * .5D0
                END IF

                IF (I_PACK .GE. J_PACK .AND. K_PACK .GE. L_PACK
     &                        .AND. IJ_PACK .GE. KL_PACK) THEN
                   IJKL_PACK = IJ_PACK*(IJ_PACK-1)/2 + KL_PACK
                   RHO2S(IJKL_PACK) = RHO2S(IJKL_PACK)
     &                              + FACTOR_PACK*TERM
                   RHO2A(IJKL_PACK) = RHO2A(IJKL_PACK)
     &                              + FACTOR_PACK*TERM
                END IF
                IF (J_PACK .GE. I_PACK .AND. K_PACK .GE. L_PACK
     &                       .AND. JI_PACK .GE. KL_PACK) THEN
                   JIKL_PACK = JI_PACK*(JI_PACK-1)/2 + KL_PACK
                   IJKL_PACK = IJ_PACK*(IJ_PACK-1)/2 + KL_PACK
                   RHO2S(JIKL_PACK) = RHO2S(JIKL_PACK)
     &                              + FACTOR_PACK*TERM
                   RHO2A(JIKL_PACK) = RHO2A(JIKL_PACK)
     &                              - FACTOR_PACK*TERM
                END IF
                END DO
             ELSE
                RHO2(IJKL) = RHO2(IJKL) + TERM
             END IF
            END DO
          END DO
        END DO
      END DO
*
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! Module containing routines to generate contributions to a
! multipole potential on the fly.
! Note that another module allows contraction of T-pairs.

!FIXME:  ************************************************************
!FIXME:  *                                                          *
!FIXME:  *  Array bounds when W-vector is ZERO !!!!!!!!!!           *
!FIXME:  *                                                          *
!FIXME:  ************************************************************

module fmm_W_contractors

use fmm_global_paras, only: INTK, REALK, T_pair_single, T_pair_list, W_CONTRACTOR_DIRECT, W_CONTRACTOR_X, W_CONTRACTOR_FAST, &
                            W_CONTRACTOR_BOUNDARY, ZERO_VECT_TOL, DISTINCT_T_TOL, Zero, One
use fmm_stats, only: stat_W_mat_builds
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_init_W_contractors, &
          fmm_free_W_contractors, &
          fmm_select_W_con, &
          fmm_set_W_con_ptrs

! Public variable to stop the resetting of W_con pointers with open T-buffer
public :: fmm_lock_W_con

real(REALK), allocatable, save :: W_matrix(:,:)
integer(INTK), save :: WLDA
! Pointers to actual moments and potentials described elsewhere
real(REALK), pointer, save :: old_ptr(:,:)
real(REALK), pointer, save :: new_ptr(:,:)
! Diagnostic variables
character(len=11), save :: W_con_stat
logical, save :: fmm_lock_W_con

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_W_contractors(LMAX)

  implicit none
  integer(INTK), intent(in) :: LMAX

  if (allocated(W_matrix)) call fmm_quit('W_matrix not deallocated!')
  allocate(W_matrix((1+LMAX)**2,(1+LMAX)**2))
  WLDA = (1+LMAX)**2
  W_matrix = zero

end subroutine fmm_init_W_contractors

!-------------------------------------------------------------------------------

subroutine fmm_free_W_contractors()

  implicit none
  deallocate(W_matrix)

end subroutine fmm_free_W_contractors

!-------------------------------------------------------------------------------

subroutine fmm_set_W_con_ptrs(old,new)

  implicit none
  real(REALK), target, intent(in) :: old(:,:), new(:,:)

  if (W_con_stat /= 'initialised') call fmm_quit('no W_contractor preselected!')
  if (fmm_lock_W_con) call fmm_quit('W_buffer not empty! Cannot reset W_con!')
  nullify(old_ptr,new_ptr)
  old_ptr => old(:,:)
  new_ptr => new(:,:)

end subroutine fmm_set_W_con_ptrs

!-------------------------------------------------------------------------------

subroutine fmm_check_W_status()

  implicit none
  if ((.not. associated(old_ptr)) .or. (.not. associated(new_ptr))) then
    call fmm_quit('W_contractor pointers not associated as reqd.')
  end if

end subroutine fmm_check_W_status

!-------------------------------------------------------------------------------
! Built for DIRECT scheme.  Can only take one W_pair at a time.

subroutine fmm_W_con_direct(W_pair)

  use fmm_W_worker, only: fmm_get_ltsqr_W_matrix, &
                          fmm_contract_Wq

  implicit none
  type(T_pair_single), intent(in) :: W_pair

  real(REALK) :: arr_tmp(W_pair%lm_max)
  real(REALK) :: r_mod2
  integer(INTK) :: n, m, lm_dim, hi, p, q, LMAX, JMAX
  character :: NT

  call fmm_check_W_status()

  NT = W_pair%N_or_T
  p = W_pair%paras%LHS_id
  q = W_pair%paras%RHS_id
  lm_dim = W_pair%lm_max

  r_mod2 = dot_product(W_pair%r_ab,W_pair%r_ab)
  if (r_mod2 > ZERO_VECT_TOL*ZERO_VECT_TOL) then
    LMAX = W_pair%paras%LHS_LMAX
    JMAX = W_pair%paras%RHS_LMAX
    stat_W_mat_builds = stat_W_mat_builds+one
    call fmm_get_ltsqr_W_matrix(LMAX,JMAX,W_pair%r_ab,W_matrix)
    if (LMAX /= JMAX) then
      n = (1+JMAX)**2
      m = (1+LMAX)**2
      call fmm_contract_Wq(NT,W_matrix,WLDA,old_ptr(:,q),n,new_ptr(:,p),m)
    else
      arr_tmp(:lm_dim) = old_ptr(:lm_dim,q)
      call DTRMV('L',NT,'U',lm_dim,W_matrix,WLDA,arr_tmp,1)
      new_ptr(:lm_dim,p) = new_ptr(:lm_dim,p)+arr_tmp(:lm_dim)
    end if
  else
    hi = (1+W_pair%paras%LHS_LMAX)**2
    new_ptr(:hi,p) = new_ptr(:hi,p)+old_ptr(:hi,q)
  end if

end subroutine fmm_W_con_direct

!-------------------------------------------------------------------------------

subroutine fmm_W_con_X(W_pairs)

  use fmm_W_worker, only: fmm_get_ltsqr_W_matrix

  implicit none
  type(T_pair_list), intent(in) :: W_pairs

  real(REALK) :: arr_tmp(W_pairs%lm_max)
  real(REALK) :: lastlen, r_pq(3), r_pq_mod(3)
  integer(INTK) :: LMAX, i, p, q, lm_dim, hi
  character :: NT

  call fmm_check_W_status()

  LMAX = W_pairs%LMAX
  NT = W_pairs%N_or_T
  r_pq_mod(:) = W_pairs%r_ab(:)
  lm_dim = W_pairs%lm_max
  lastlen = zero

  do i=1,size(W_pairs%paras)

    p = W_pairs%paras(i)%LHS_id
    q = W_pairs%paras(i)%RHS_id

    hi = (1+W_pairs%paras(i)%RHS_LMAX)**2
    if (hi < size(arr_tmp)) arr_tmp = zero
    arr_tmp(:hi) = old_ptr(:hi,q)

    if (abs(W_pairs%paras(i)%ratio) < ZERO_VECT_TOL) then
      ! zero translation, so just copy over old to new
      hi = (1+W_pairs%paras(i)%LHS_LMAX)**2
      new_ptr(:hi,p) = new_ptr(:hi,p)+arr_tmp(:hi)
      lastlen = W_pairs%paras(i)%ratio
      cycle
    end if
    ! get matrix if different
    if (abs(W_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) then
      r_pq = r_pq_mod*W_pairs%paras(i)%ratio
      lastlen = W_pairs%paras(i)%ratio
      stat_W_mat_builds = stat_W_mat_builds+one
      call fmm_get_ltsqr_W_matrix(LMAX,LMAX,r_pq,W_matrix)
    end if
    ! now translate
    hi = (1+W_pairs%paras(i)%RHS_LMAX)**2
    if (hi < lm_dim) arr_tmp = zero
    arr_tmp(:hi) = old_ptr(:hi,q)
    call DTRMV('L',NT,'U',lm_dim,W_matrix,WLDA,arr_tmp,1)
    hi = (1+W_pairs%paras(i)%LHS_LMAX)**2
    new_ptr(:hi,p) = new_ptr(:hi,p)+arr_tmp(:hi)

  end do

end subroutine fmm_W_con_X

!-------------------------------------------------------------------------------

subroutine fmm_W_con_FAST(W_pairs)

  use fmm_W_worker, only: fmm_get_ltsqr_W_matrix, fmm_contract_Wq

  implicit none
  type(T_pair_list), intent(in) :: W_pairs

  real(REALK) :: arr_tmp(W_pairs%lm_max)
  real(REALK) :: lastlen, r_pq(3), r_pq_mod(3)
  integer(INTK) :: LMAX, JMAX, n, m, lm_dim, i, p, q, hi
  character :: NT

  call fmm_check_W_status()

  NT = W_pairs%N_or_T
  r_pq_mod(:) = W_pairs%r_ab(:)
  lastlen = zero
  LMAX = W_pairs%LHS_LMAX
  JMAX = W_pairs%RHS_LMAX
  n = (1+JMAX)**2
  m = (1+LMAX)**2
  lm_dim = W_pairs%lm_max

  do i=1,size(W_pairs%paras)

    p = W_pairs%paras(i)%LHS_id
    q = W_pairs%paras(i)%RHS_id
    if (abs(W_pairs%paras(i)%ratio) < ZERO_VECT_TOL) then
      ! zero translation, so just copy over old to new
      hi = (1+W_pairs%paras(i)%LHS_LMAX)**2
      new_ptr(:hi,p) = new_ptr(:hi,p)+old_ptr(:hi,q)
      lastlen = W_pairs%paras(i)%ratio
      cycle
    end if
    if (abs(W_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) then
      r_pq = r_pq_mod*W_pairs%paras(i)%ratio
      lastlen = W_pairs%paras(i)%ratio
      stat_W_mat_builds = stat_W_mat_builds+one
      call fmm_get_ltsqr_W_matrix(LMAX,JMAX,r_pq,W_matrix)
    end if
    if (LMAX /= JMAX) then
      call fmm_contract_Wq(NT,W_matrix,WLDA,old_ptr(:,q),n,new_ptr(:,p),m)
    else
      hi = (1+W_pairs%paras(i)%RHS_LMAX)**2
      if (hi < lm_dim) arr_tmp = zero
      arr_tmp(:hi) = old_ptr(:hi,q)
      call DTRMV('L',NT,'U',lm_dim,W_matrix,WLDA,arr_tmp,1)
      hi = (1+W_pairs%paras(i)%LHS_LMAX)**2
      new_ptr(:hi,p) = new_ptr(:hi,p)+arr_tmp(:hi)
    end if

  end do

end subroutine fmm_W_con_FAST

!-------------------------------------------------------------------------------

subroutine fmm_W_con_BOUNDARY(W_pairs)

  use fmm_W_worker, only: fmm_get_boundary_W_matrix

  implicit none
  type(T_pair_list), intent(in) :: W_pairs

  real(REALK) :: lastlen, r_pq(3), r_pq_mod(3)
  integer(INTK) :: LMAX, n, i, p, q

  call fmm_check_W_status()

  r_pq_mod(:) = W_pairs%r_ab(:)
  lastlen = zero
  LMAX = W_pairs%RHS_LMAX
  n = (1+LMAX)**2

  do i=1,size(W_pairs%paras)

    p = W_pairs%paras(i)%LHS_id
    q = W_pairs%paras(i)%RHS_id
    if (abs(W_pairs%paras(i)%ratio) < ZERO_VECT_TOL) then
      ! zero translation, so just copy over old to new
      new_ptr(1,p) = new_ptr(1,p)+old_ptr(1,q)
      lastlen = W_pairs%paras(i)%ratio
      cycle
    end if
    if (abs(W_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) then
      r_pq = r_pq_mod*W_pairs%paras(i)%ratio
      lastlen = W_pairs%paras(i)%ratio
      stat_W_mat_builds = stat_W_mat_builds+one
      call fmm_get_boundary_W_matrix(LMAX,r_pq,W_matrix)
    end if

    ! Always perform transpose contraction to get boundary potential
    new_ptr(1,p) = new_ptr(1,p)+dot_product(W_matrix(1:n,1),old_ptr(:,q))

  end do

end subroutine fmm_W_con_BOUNDARY

!-------------------------------------------------------------------------------

subroutine fmm_select_W_con(W_con_ID)

  implicit none
  integer(INTK), intent(in) :: W_con_ID
  external :: fmm_store_w_contractor

  if (.not. allocated(W_matrix)) call fmm_quit('W_matrix not allocated!')

  select case (W_con_ID)
    case (W_CONTRACTOR_DIRECT)
      call fmm_store_w_contractor(fmm_W_con_DIRECT)
    case (W_CONTRACTOR_X)
      call fmm_store_w_contractor(fmm_W_con_X)
    case (W_CONTRACTOR_FAST)
      call fmm_store_w_contractor(fmm_W_con_FAST)
    case (W_CONTRACTOR_BOUNDARY)
      call fmm_store_w_contractor(fmm_W_con_BOUNDARY)
    case default
      call fmm_quit('invalid W_contractor requested!')
  end select
  ! initialise diagnostics
  W_con_stat = 'initialised'
  W_con_stat = 'initialised'
  fmm_lock_W_con = .false.

end subroutine fmm_select_W_con

!-------------------------------------------------------------------------------

end module fmm_W_contractors

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine defvhlp1(r1,v,dimr1a,dimr1bc,dimvab,dimvc,add)
! this routine does
! V(ab,c)xxx = R1(a,bc)-R1(b,ac) x=a,b
! for syma=symb=symc
!
! r1      - r1 matrix (I)
! v       - v matrix (O)
! dimr1a  - dimension of a (b,c) in R1 (I)
! dimr1bc - dimension of bc (ac) in R1 (I)
! dimvab  - dimension of ab in V (I)
! dimvc   - dimension of c (a,b) in V (I)
! add     - additional constant (I)
!           (# of singly occ in syma for alpha, 0 for beta)

use CCT3_global, only: nshf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimr1a, dimr1bc, dimvab, dimvc, add
real(kind=wp), intent(in) :: r1(dimr1a,dimr1bc)
real(kind=wp), intent(out) :: v(dimvab,dimvc)
integer(kind=iwp) :: a, ab, ab0, acr1, ar1, b, bk, c, cr1 !, bcr1

!do c=1,dimvc
!  cr1 = c+add
!  do a=2,dimvc
!    ar1 = a+add
!    ab0 = nshf(a)
!    do b=1,a-1
!      bcr1 = indab(b+add,cr1)
!      v(ab0+b,c) = r1(ar1,bcr1)
!    end do
!  end do
!end do

do c=1,dimvc
  cr1 = c+add
  do a=2,dimvc
    ar1 = a+add
    ab0 = nshf(a)
    if (c <= (a-2)) then
      ! b1 <= c1
      bk = cr1*(cr1-1)/2+add
      ! bcr1=cr1*(cr1-1)/2+add+b
      v(ab0+1:ab0+c,c) = r1(ar1,bk+1:bk+c)
      ! b1 > c1
      bk = (add+c+1)*(add+c)/2+cr1
      do b=c+1,a-1
        ! bcr1=(add+b)*(add+b-1)/2+cr1
        v(ab0+b,c) = r1(ar1,bk)
        bk = bk+add+b
      end do
    else
      bk = cr1*(cr1-1)/2+add
      ! b1 <= c1
      ! bcr1=cr1*(cr1-1)/2+add+b
      v(ab0+1:ab0+a-1,c) = r1(ar1,bk+1:bk+a-1)
    end if
  end do
end do

do c=1,dimvc
  cr1 = c+add
  do a=2,dimvc
    ab0 = nshf(a)
    ! acr1=indab(a+add,cr1)
    if ((a+add) > cr1) then
      acr1 = (a+add)*(a+add-1)/2+cr1
    else
      acr1 = cr1*(cr1-1)/2+a+add
    end if
    do b=1,a-1
      ab = ab0+b
      v(ab,c) = v(ab,c)-r1(b+add,acr1)
    end do
  end do
end do

return

end subroutine defvhlp1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Ignacio Fdez. Galvan                             *
!               2016, Roland Lindh                                     *
!***********************************************************************
!  Process_Weights
!
!> @brief
!>   Process and store the weights used for alignment
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Process the weights according to the `WEIG` option in `GATEWAY`.
!> These weights are used in alignment and in the "sphere" constraint.
!> The list of weights is stored in the runfile, first the symmetry-unique
!> atoms and then the symmetric images, in the manner of ::Expand_Coor.
!>
!> @param[in] iPrint Print level
!***********************************************************************

subroutine Process_Weights(iPrint)

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, UtoAU
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint
integer(kind=iwp) :: i, iAt, iCnt, iErr, iSymAt, j, k, nAt, ndc, nSymAt
real(kind=wp) :: wTot
logical(kind=iwp) :: Small
character(len=512) :: Align_Weights
real(kind=wp), allocatable :: W(:)
real(kind=wp), parameter :: thr = 1.0e-6_wp

call Get_cArray('Align_Weights',Align_Weights,512)

! Count the total and symmetry-unique number of atoms
nAt = 0
nSymAt = 0
ndc = 0
do i=1,nCnttp
  do j=1,dbsc(i)%nCntr
    ndc = ndc+1
    if (.not. (dbsc(i)%pChrg .or. dbsc(i)%Frag .or. dbsc(i)%Aux)) then
      nAt = nAt+nIrrep/dc(ndc)%nStab
      nSymAt = nSymAt+1
    end if
  end do
end do
call mma_allocate(W,nAt,label='W')

! By default, all weights are 1
W(:) = One

if (Align_Weights(1:4) == 'MASS') then
  ! Set the weights to the mass of each atom
  j = 1
  do i=1,nCnttp
    if (.not. (dbsc(i)%pChrg .or. dbsc(i)%Frag .or. dbsc(i)%Aux)) then
      do iCnt=1,dbsc(i)%nCntr
        W(j) = dbsc(i)%CntMass/UtoAU
        j = j+1
      end do
    end if
  end do
else if (Align_Weights(1:5) == 'HEAVY') then
  ! Set the the weight to 1 for heavy atoms, 0 for hydrogens
  j = 1
  do i=1,nCnttp
    if (.not. (dbsc(i)%pChrg .or. dbsc(i)%Frag .or. dbsc(i)%Aux)) then
      do iCnt=1,dbsc(i)%nCntr
        if (dbsc(i)%AtmNr <= 1) W(j) = Zero
        j = j+1
      end do
    end if
  end do
else if (Align_Weights(1:5) == 'EQUAL') then
  ! EQUAL is already the default: 1 for all
  !continue
else
  ! Read the weights from the input line
  read(Align_Weights,*,iostat=iErr) (W(i),i=1,nAt)
  if (iErr > 0) then
    call WarningMessage(2,'Unable to read data from WEIG')
    call Quit_OnUserError()
  end if
end if

! Unfold the symmetry
iSymAt = 1
iAt = 1+nSymAt
ndc = 0
do i=1,nCnttp
  do j=1,dbsc(i)%ncntr
    ndc = ndc+1
    if (.not. (dbsc(i)%pChrg .or. dbsc(i)%Frag .or. dbsc(i)%Aux)) then
      do k=1,nIrrep/dc(ndc)%nStab-1
        W(iAt) = W(iSymAt)
        iAt = iAt+1
      end do
      iSymAt = iSymAt+1
    end if
  end do
end do

! Check for zero total weight
wTot = Zero
do i=1,nAt
  wTot = wTot+W(i)
end do
if (wTot < thr) then
  call WarningMessage(1,'Total weight too small. Setting equal weights.')
  do i=1,nAt
    W(i) = One
  end do
end if
! Prevent zero weights, it could break the "sphere" constraint
! (a value between 1e-6 and 1e-1 can still be used)
Small = .false.
do i=1,nAt
  if (W(i) < thr) then
    W(i) = 1.0e-1_wp
    Small = .true.
  end if
end do
if (iPrint >= 6) then
  if (Small) then
    call WarningMessage(1,'Small weights were increased to avoid problems with constraints.')
  end if
  call RecPrt('Weights used for alignment and distance',' ',W,nAt,1)
  write(u6,*)
end if

! Store weights in the runfile too
call Put_dArray('Weights',W,nAt)
call mma_deallocate(W)

end subroutine Process_Weights

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  setvect
*
*> @brief
*>   Computes the vectors \f$ V_1 = \mathit{XYZ}(2)-\mathit{XYZ}(1) \f$ and
*>   \f$ V_2 = \mathit{XYZ}(3)-\mathit{XYZ}(1) \f$ using the geometry \p geom
*> @author Y. Carissan
*>
*> @details
*> Computes the vectors \f$ V_1 = \mathit{XYZ}(2)-\mathit{XYZ}(1) \f$ and
*> \f$ V_2 = \mathit{XYZ}(3)-\mathit{XYZ}(1) \f$ using the geometry \p geom.
*>
*> @param[in]  natoms Number of atoms
*> @param[in]  Geom   Geometry to be considered, xyz coordinates
*> @param[in]  XYZ    atom index array
*> @param[out] V1     output vector
*> @param[out] V2     output vector
************************************************************************
      subroutine setvect(natoms,Geom,XYZ,V1,V2)
      implicit none
#include "real.fh"
      Real*8 V1(3),V2(3)
      Real*8 O(3),A(3),B(3)
      Integer natoms
      Real*8 Geom(3,natoms)
      Integer XYZ(3)
c
      call dcopy_(3,Geom(1,XYZ(1)),1,O,1)
      call dcopy_(3,Geom(1,XYZ(2)),1,A,1)
      call dcopy_(3,Geom(1,XYZ(3)),1,B,1)
c
c daxpy(n,da,dx,incx,dy,incy)
      call dcopy_(3,A,1,V1,1)
      call daxpy_(3,-One,O,1,V1,1) ! V1=OA
      call dcopy_(3,B,1,V2,1)
      call daxpy_(3,-One,O,1,V2,1) ! V2=OB
c
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKSBMAT()
! Set up S and B matrices for cases 1..13.

use caspt2_global, only: iPrGlb
use PrintLevel, only: DEBUG, VERBOSE
use caspt2_global, only: DREF, LUSOLV, PREF
use caspt2_module, only: NASHT, NG1, NG2, NG3
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6, byte

implicit none
integer(kind=iwp) :: iLUID
logical(kind=iwp) :: Single_set_of_PCO
integer(kind=byte), allocatable :: idxG3(:,:)
real(kind=wp), allocatable :: F1(:), F2(:), F3(:), FD(:), FP(:), G3(:)

if (IPRGLB >= VERBOSE) then
  write(u6,*)
  write(u6,*) ' Construct S and B matrices'
end if

! Single_set_of_PCO=.TRUE.
Single_set_of_PCO = .false.
if (Single_set_of_PCO) then
  call MKSMAT()
  call MKBMAT()
  return
end if

if (NASHT /= 0) then
  !SVC: print header for debug info
  if (IPRGLB >= DEBUG) then
    write(u6,'("DEBUG> ",A)') 'CASE SYM S/B-MATRIX NORM'
    write(u6,'("DEBUG> ",A)') '==== === ==============='
  end if
  ! For the cases A and C, begin by reading in the local storage
  !  part of the three-electron density matrix G3:

  !-SVC20100902: For the remaining cases that do not need G3, use replicate arrays

  call mma_allocate(F1,NG1,Label='F1')
  call PT2_GET(NG1,'DELTA1',F1)

  call mma_allocate(FD,size(DREF),Label='FD')
  call MKDREF_RPT2(NASHT,F1,FD,size(DREF))

  call mma_deallocate(F1)

  call mma_allocate(F2,NG2,Label='F2')
  call PT2_GET(NG2,'DELTA2',F2)

  call mma_allocate(FP,size(PREF),Label='FP')
  call MKPREF_RPT2(NASHT,F2,FP,size(PREF))

  call mma_deallocate(F2)

  call mma_allocate(G3,NG3,Label='G3')
  call PT2_GET(NG3,'GAMMA3',G3)

  call mma_allocate(F3,NG3,Label='F3')
  call PT2_GET(NG3,'DELTA3',F3)

  call mma_allocate(idxG3,6,NG3,label='idxG3')
  iLUID = 0
  call I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)

  call MKSA(DREF,size(DREF),PREF,size(PREF),NG3,G3,idxG3)
  call MKBA(DREF,size(DREF),PREF,size(PREF),FD,FP,NG3,F3,idxG3)

  call MKSC(DREF,size(DREF),PREF,size(PREF),NG3,G3,idxG3)
  call MKBC(DREF,size(DREF),PREF,size(PREF),FD,FP,NG3,F3,idxG3)

  call mma_deallocate(F3)
  call mma_deallocate(G3)
  call mma_deallocate(idxG3)

  call MKSB(DREF,size(DREF),PREF,size(PREF))
  call MKBB(DREF,size(DREF),PREF,size(PREF),FD,FP)

  call MKSD(DREF,size(DREF),PREF,size(PREF))
  call MKBD(DREF,size(DREF),PREF,size(PREF),FD,FP)

  call MKSE(DREF,size(DREF))
  call MKBE(DREF,size(DREF),FD)

  call MKSF(PREF,size(PREF))
  call MKBF(DREF,size(DREF),PREF,size(PREF),FP)

  call MKSG(DREF,size(DREF))
  call MKBG(DREF,size(DREF),FD)

  call mma_deallocate(FP)
  call mma_deallocate(FD)

end if

call MKSH()
call MKBH()

end subroutine MKSBMAT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        SUBROUTINE BNDINV(       A,      EL,       N,  DETERM,   EPSIL,
     &                       ITEST,   NSIZE)
C
C       REAL*8 MATRIX INVERSION SUBROUTINE
C       FROM "DLYTAP".
C
C*      REAL*8 E,F
C*      REAL*8 A,EL,D,SQRT,C,S,DETERP
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION A(NSIZE,*),EL(NSIZE,*)
        INDSNL=0
        IF(N.LT.2)GO TO 140
        ISL2=0
C       K000FX=2
        IF(ISL2.EQ.0)INDSNL=2
        IF(ISL2.EQ.1)INDSNL=1
C       CALL SLITET(2,INDSNL)
C       CALL OVERFL(K000FX)
C       CALL DVCHK(K000FX)
C
C       SET EL = IDENTITY MATRIX
        DO I=1,N
         DO J=1,N
          EL(I,J)=0.0D0
         END DO
         EL(I,I)=1.0D0
        END DO
C
C       TRIANGULARIZE A, FORM EL
C
        N1=N-1
        M=2
        DO J=1,N1
         DO I=M,N
          IF(A(I,J).EQ.0.0D0)GO TO 45
          D=sqrt(A(J,J)*A(J,J)+A(I,J)*A(I,J))
          C=A(J,J)/D
          S=A(I,J)/D
          DO K=J,N
           D=C*A(J,K)+S*A(I,K)
           A(I,K)=C*A(I,K)-S*A(J,K)
           A(J,K)=D
          END DO
          DO K=1,N
           D=C*EL(J,K)+S*EL(I,K)
           EL(I,K)=C*EL(I,K)-S*EL(J,K)
           EL(J,K)=D
          END DO
 45       CONTINUE
         END DO
         M=M+1
        END DO
C       CALL OVERFL(K000FX)
C       GO TO (140,51),K000FX
C
C       CALCULATE THE DETERMINANT
        DETERP=A(1,1)
        DO I=2,N
         DETERP=DETERP*A(I,I)
        END DO
        DETERM=DETERP
C       CALL OVERFL(K000FX)
C       GO TO (140,520,520),K000FX
C
C       IS MATRIX SINGULAR
c 520    CONTINUE
        F=A(1,1)
        E=A(1,1)
        DO I=2,N
         IF(abs(F).LT.abs(A(I,I)))F=A(I,I)
         IF(abs(E).GT.abs(A(I,I)))E=A(I,I)
        END DO
        EPSILP=EPSIL
        IF(EPSILP.LE.0.0D0)EPSILP=1.0D-8
        RAT=E/F
        IF(ABS(RAT).LT.EPSILP)GO TO 130
C
C       INVERT TRIANGULAR MATRIX
        J=N
        DO J1=1,N
         A(J,J)=1.0D0/A(J,J)
         I=J-1
         DO I1=2,J
          D=0.0D0
          DO K=I+1,J
            D=D+A(I,K)*A(K,J)
          END DO
          A(I,J)=-D/A(I,I)
          I=I-1
         END DO
         J=J-1
        END DO
C       CALL OVERFL(K000FX)
C       GO TO (140,103,103),K000FX

C103    CALL DVCHK(K000FX)
C       GO TO (140,105),K000FX
C
C       PREMULTIPLY EL BY INVERTED TRIANGULAR MATRIX
        M=1
        DO 120 I=1,N
        DO 118 J=1,N
        D=0.0D0
        DO 107 K=M,N
        D=D+A(I,K)*EL(K,J)
 107    CONTINUE
        EL(I,J)=D
 118    CONTINUE
        M=M+1
 120    CONTINUE
C       CALL OVERFL(K000FX)
C       GO TO (140,123,123),K000FX
C
C       RECOPY EL TO A
        DO 124 I=1,N
        DO 125 J=1,N
        A(I,J)=EL(I,J)
 125    CONTINUE
 124    CONTINUE
        ITEST=0
C126    IF(INDSNL.EQ.1)CALL SLITE(2)
 126    IF(INDSNL.EQ.1)ISL2=1
        RETURN
C
 130    ITEST=1
        GO TO 126
 140    ITEST=-1
        GO TO 126
        END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_CHKINT(XINT,DIAG,ISYM,NERR,TOL,REPORT)
!
! Purpose: check diagonals in qualified integral columns.

use Cholesky, only: iiBstR, IndRed, iQuAB, LuPri, nnBstR, nQual
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: XINT(*), DIAG(*), TOL
integer(kind=iwp), intent(in) :: ISYM
integer(kind=iwp), intent(out) :: NERR
logical(kind=iwp), intent(in) :: REPORT
integer(kind=iwp) :: I, II, IK, JJ, KK
real(kind=wp) :: DF
character(len=*), parameter :: SECNAM = 'CHO_CHKINT'

NERR = 0
do I=1,NQUAL(ISYM)
  II = IQUAB(I,ISYM)
  JJ = INDRED(II,2)
  IK = II-IIBSTR(ISYM,2)
  KK = NNBSTR(ISYM,2)*(I-1)+IK
  DF = DIAG(JJ)-XINT(KK)
  if (abs(DF) > TOL) then
    NERR = NERR+1
    if (REPORT) then
      write(LUPRI,*) SECNAM,': diag error: ',DIAG(JJ),XINT(KK)
      write(LUPRI,*) '            diagonal elm    : ',JJ,' (rs1) ',II,' (rs2)'
      write(LUPRI,*) '            integral row,col: ',IK,I
    end if
  end if
end do

end subroutine CHO_CHKINT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MAGN_ZJ_PAR( EXCH,N,X,Y,Z,H,W,zJ, dM,sM,nT,T,sopt,
     &                        WZ, ZB, S, M, thrs, m_paranoid, dbg )
c this Subroutine computes the magnetisation for zJ .ne. 0.0, paranoid accuracy
c
c definition of the variables:
c   EXCH -- total number of exchange states, Integer, input
c      N -- size of the Zeeman matrix, Integer, input, NM .LE. EXCH !
c  X,Y,Z -- projections of the magnetic field, specIfying the orientation of the applied
c           magnetic field, Real(kind=8) ::, input;  rule: ( X**2 + Y**2 + Z**2 = 1);
c      H -- strength of the magnetic field in Tesla, Real(kind=8) ::, input;
c      W -- energies of the exchange states; Real(kind=8) :: array (EXCH);
c     zJ -- parameter of intermolecular interaction, Real(kind=8) ::, input;
c   THRS -- threshold for convergence of the spin magnetisation. Real(kind=8) ::, input;
c           Of any importance only when (zJ.ne.0.0_wp), otherwise unused. Default value 1.D-8.
c     dM -- matrix of the magnetic moment, Complex(kind=8) :: (3,EXCH,EXCH) array, input;
c     sM -- matrix of the     spin moment, Complex(kind=8) :: (3,EXCH,EXCH) array, input;
c     nT -- number of temperature points for which magnetisation is computed, input;
c      T -- temperature values(in Kelvin) for which magnetisation is computed, input;
c   sopt -- logical parameter. If sopt=.true. Then spin magnetisation is computed.
c                              If sopt=.false. Then spin part is skipped.
c
c     WZ -- Zeeman energies, true values (not shifted to 0), in cm-1, Real(kind=8) :: (N) array, output;
c     ZB -- statistical Boltzmann distribution, for each temperature, Real(kind=8) :: (nT) array, output;
c      S -- spin magnetisation, Real(kind=8) :: (3,nT) array, output;
c      M -- magnetisation, Real(kind=8) :: (3,nT) array, output;
c m_paranoid --  logical parameter.
c            If m_paranoid = .true.  Then the average spin is computed for each temperature point exactly
c            If m_paranoid = .false. Then  the average spin is computed only for the lowest temperature point
c---------
c  temporary (local) variables:
c    MZ -- matrix of the magnetic moment, Complex(kind=8) :: (3,EXCH,EXCH) array
c    SZ -- matrix of the     spin moment, Complex(kind=8) :: (3,EXCH,EXCH) array
c    WM -- array containing the Zeeman eigenstates and, If N<EXCH the exchange eigenstates
c          for the states higher in energy than N, Real(kind=8) ::, (EXCH) array;
c    ZM -- Zeeman eigenvectors, (N,N) Complex(kind=8) :: array,
c  SCHK -- variable used for checking the convergence; SCHK = ABS(Sx) + ABS(Sy) + ABS(Sz), Real(kind=8) ::
c   i,j -- labers of the states;
c     l -- labels the cartesian component of the momentum (convention: x=1, y=2, z=3)
c    iT -- labes the temperature points;
c mxIter--defines the maximal number of iterations for determination of the average spin
c    ST -- value of the average spin of neighboring sites, Real(kind=8) :: (3) array;
      Implicit None
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)          :: EXCH, N, nT
      Real(kind=8), intent(in)    :: X, Y, Z, H, zJ
      Real(kind=8), intent(in)    :: W(EXCH), T(nT)
      Real(kind=8), intent(in)    :: thrs
      Complex(kind=8), intent(in) :: dM(3,EXCH,EXCH)
      Complex(kind=8), intent(in) :: sM(3,EXCH,EXCH)
      Logical, intent(in)          :: sopt
      Logical, intent(in)          :: m_paranoid
      Logical, intent(in)          :: dbg

      Real(kind=8), intent(out)   :: ZB(nT)
      Real(kind=8), intent(out)   :: WZ(N)
      Real(kind=8), intent(out)   :: S(3,nT)
      Real(kind=8), intent(out)   :: M(3,nT)

c local variables:
#include "stdalloc.fh"
      Integer, parameter :: mxIter=100
! defines the maximal number of iterations for determination of the average spin
!      parameter (mxIter=100) ! it is of any importance only If ( zJ.ne.0 )
      Integer          :: i, l, iT
      Real(kind=8)    :: kB, mB, ST(3), STsave(3)
      Real(kind=8), allocatable :: WM(:)
      Real(kind=8), allocatable :: RWORK(:)
      Complex(kind=8), allocatable :: HZEE(:), WORK(:), W_c(:)
      Complex(kind=8), allocatable :: ZM(:,:)
      Complex(kind=8), allocatable :: SZ(:,:,:)
      Complex(kind=8), allocatable :: MZ(:,:,:)
!                                      SZ(3,EXCH,EXCH), MZ(3,EXCH,EXCH)

      kB=0.6950356000_wp   ! Boltzmann constant,  in cm^-1*K-1
      mB=0.4668643740_wp   ! Bohr magneton,       in cm-1*T-1


c a few checks, before proceeding:
      Do iT=1,nT
        If (T(iT)==0.0_wp) Return
      End Do
      If(H==0.0_wp) Return
      If(N > EXCH) Return


! allocate memory:
      Call mma_allocate(WM,exch,'WM')
      Call dcopy_(exch,[0.0_wp],0,WM,1)

      Call mma_allocate(ZM,exch,exch,'ZM')
      Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,ZM,1)

      Call mma_allocate(SZ,3,exch,exch,'SZ')
      Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,SZ,1)

      Call mma_allocate(MZ,3,exch,exch,'MZ')
      Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,MZ,1)

      ! temporary arrays used in ZEEM_SA:
      Call mma_allocate(RWORK,(3*N-2),'ZEEM_RWORK')
      Call mma_allocate(HZEE,(N*(N+1)/2),'ZEEM_HZEE')
      Call mma_allocate(WORK,(2*N-1),'ZEEM_WORK')
      Call mma_allocate(W_c,N,'ZEEM_W_c')

      ! zero everything:
      Call dcopy_(3*N-2,[0.0_wp],0,RWORK,1)
      Call zcopy_(N*(N+1)/2,[(0.0_wp,0.0_wp)],0,HZEE,1)
      Call zcopy_(2*N-1,[(0.0_wp,0.0_wp)],0,WORK,1)
      Call zcopy_(N,[(0.0_wp,0.0_wp)],0,W_c,1)

c start calculations:
      ! code for the case (zJ .ne. 0 ):
      Call dcopy_(  nT,[0.0_wp],0,ZB,1)
      Call dcopy_(3*nT,[0.0_wp],0,M,1)
      Call dcopy_(3*nT,[0.0_wp],0,S,1)


      Do iT=1,nT
         ! determine first the average spin of neighboring
         ! molecules for each temperature point ST(1:3)
         If(m_paranoid) Then
            Call dcopy_(3,[0.0_wp],0,ST,1)
            Call dcopy_(3,[0.0_wp],0,STsave,1)
            Call mean_field( EXCH, N, H, X,Y,Z, zJ, T(iT), W, thrs,
     &                       DM, SM, ST, dbg )
            Call dcopy_(3,ST,1,STsave,1)
         Else
            ! i.e. when m_paranoid=.false.
            If (iT == 1) Then
               Call dcopy_(3,[0.0_wp],0,ST,1)
               Call dcopy_(3,[0.0_wp],0,STsave,1)
               Call mean_field( EXCH, N, H, X,Y,Z, zJ, T(iT), W, thrs,
     &                          DM, SM, ST, dbg )
               Call dcopy_(3,ST,1,STsave,1)
            Else
               ! use the last saved value of the ST:
               Call dcopy_(3,STsave,1,ST,1)
            End If
         End If
!        --------------------------------------------------------------
!        here  we have the value of the averaged spin for this temperature
!        proceed with the computation of magnetism for this temperature
         If(DBG) Write(6,'(A,3E13.5)')
     &                 'Average spin finished. ST on entrance to '//
     &                 'last ZEEM:',(ST(i),i=1,3)
         Call dcopy_(exch,[0.0_wp],0,WM,1)
         Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,ZM,1)


         Call ZEEM_SA( N, H, X,Y,Z, W(1:N),
     &              dM(1:3,1:N,1:N), sM(1:3,1:N,1:N),
     &              ST, zJ, WM(1:N), ZM(1:N,1:N),
     &              DBG, RWORK, HZEE, WORK, W_c )


         ! move WM energies to WZ:
         Call dcopy_(N, [0.0_wp], 0, WZ, 1)
         Call dcopy_(N,       WM, 1, WZ, 1)
c /// calculation of matrix elements of spin momentum in the basis of Zeeman states
        If(N<EXCH) Then
           Do i=N+1,EXCH
              WM(i)=W(i)
           End Do
        End If


        ! transform the momenta
        Call zcopy_(3*exch*exch, [(0.0_wp,0.0_wp)], 0, SZ, 1)
        Call zcopy_(3*exch*exch, [(0.0_wp,0.0_wp)], 0, MZ, 1)
        Call UTMU( EXCH, N, ZM(1:N,1:N), SM, SZ )
        Call UTMU( EXCH, N, ZM(1:N,1:N), DM, MZ )



        ! calculation of magnetizations at different temperatures:
         If (N==EXCH) Then
            Do l=1,3
               If (sopt) Then
                  Call calcmagn1( EXCH, WM, SZ(l,1:EXCH,1:EXCH),
     &                            T(iT), S(l,iT), ZB(iT) )
               End If
                 Call calcmagn1( EXCH, WM, MZ(l,1:EXCH,1:EXCH),
     &                           T(iT), M(l,iT), ZB(iT))
            End Do
         Else
            Do l=1,3
               If(sopt) Then
                  Call calcmagn2( EXCH, N, WM, T(iT), H,
     &                            SZ, X, Y, Z, l,
     &                            S(l,iT), ZB(iT) )
               End If
                  Call calcmagn2( EXCH, N, WM, T(iT), H,
     &                            MZ, X,Y,Z, L,
     &                            M(l,iT), ZB(iT) )
            End Do
         End If

      End Do ! iT

      ! deallocate temporary arrays:
      Call mma_deallocate(RWORK)
      Call mma_deallocate(HZEE)
      Call mma_deallocate(WORK)
      Call mma_deallocate(W_c)

      Call mma_deallocate(WM)
      Call mma_deallocate(ZM)
      Call mma_deallocate(SZ)
      Call mma_deallocate(MZ)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine CHO_CASPT2_RDINP(DFonly,LuSpool)
************************************************************************
*
*  Purpose:   If DFonly, use defaults only.
*             Else, read and process input for Cholesky section
*             in CASPt2
*
************************************************************************
      Use Fock_util_global, only: ALGO, Deco, DensityCheck, REORD
      use definitions, only: iwp, u6
      Use Cholesky, only: timings
      use ChoCASPT2, only: iAlGO
      Implicit None
      Logical(kind=iwp), intent(in)::  DFonly
      integer(kind=iwp), intent(in):: LuSpool

      Character(Len=180) KWord, Key
      Character(Len=180), External:: Get_Ln
      character(len=16), parameter:: SECNAM = 'CHO_CASPT2_RDINP'
      integer(kind=iwp) iChrct, Last
      integer(kind=iwp), External:: iCLast
*                                                                      *
************************************************************************
*                                                                      *
*     Algorithms for generating MO integrals in CASPT2
*
*        iALGO :
*               0  --> MOLINT file is generated from the
*                      transformed Cholesky vectors. Both "Coulomb" and
*                      "Exchange(1,2)" integrals are computed and stored
*                      on disk
         !! Is iALGO = 0 really working?
*
*               1  --> Only the "Exchange" integrals are computed and
*                      combined directly in order to compute the RHS
*                      of the caspt2 equations. The latter is then
*                      stored on disk. The AO Fock matrix is
*                      computed during the MO transformation of the
*                      vectors and it is stored on disk
*
************************************************************************
*
***** Algorithms for using Cholesky vectors in Fock matrix generation **
*
*   ALGO:
*          0  --->  Integrals are regenerated on the fly
*                   from a set of Cholesky vectors resorted on disk
*
*          1  --->  The resorted Cholesky vectors are used directly
*                   by the Fock matrix builder routines and contracted
*                   with the proper density matrices. Uses
*                   vectors resorted either on disk or on the fly
*
*          2  --->  As in option 1 but using the MO-basis transformed
*                   vectors for computing the exchange term
*
*                                                                      *
************************************************************************
*                                                                      *
*     Default  parameters

      IF (DFonly) THEN
         iAlGO = 1
         ALGO  = 2
         REORD =.false.
         DECO  =.true.
         DensityCheck=.false.
         timings=.false.
         RETURN
      ENDIF
*
*    set some parameters if not specified in ChoInput section
         iAlGO = 1
         ALGO  = 2
         REORD =.false.
         DECO  =.true.
         DensityCheck=.false.
         timings=.false.
*                                                                      *
************************************************************************
*                                                                      *
*-----Process the input
*
*-------------------------------------------------------------------*
* The big turning point.                                            *
*-------------------------------------------------------------------*
      DO
*-------------------------------------------------------------------*
* Use Get_Ln to read the lines.                                     *
*-------------------------------------------------------------------*
      Key=Get_Ln(LuSpool)
      Kword=Key
      Call UpCase(Kword)
*-------------------------------------------------------------------*
* The keywords and their labels.                                    *
*-------------------------------------------------------------------*

      If (KWord(1:1).eq.'*')    Cycle
      If (KWord.eq.'')          Cycle

      Select case (KWord(1:4))
*                                                                      *
****** ALGO ************************************************************
*                                                                      *
*-----Read Cholesky algorithm parameters
*
      Case ('ALGO')
*
       READ(LuSpool,*) ALGO
*                                                                      *
****** IALG ************************************************************
*                                                                      *
      Case ('IALG')
       READ(LuSpool,*) iALGO
*                                                                      *
****** REOR ************************************************************
*                                                                      *
      Case ('REOR')
       REORD=.true.
      WRITE(u6,*) 'Vectors reordered on FILE'
      WRITE(u6,*)
*                                                                      *
****** DECO ************************************************************
*                                                                      *
      Case ('DECO')
       DECO=.true.
      WRITE(u6,*) 'Decomposed densty matrix'
      WRITE(u6,*)
*                                                                      *
****** TIME ************************************************************
*                                                                      *
      Case ('TIME')
       timings=.true.
*                                                                      *
****** DCHK ************************************************************
*                                                                      *
      Case ('DCHK')
       DensityCheck=.true.
*
*                                                                      *
****** END  ************************************************************
*                                                                      *
*-----End of input
*
      Case ('END ','ENDO')
      RETURN
*-------------------------------------------------------------------*
* Control section                                                   *
*-------------------------------------------------------------------*
      Case Default
         iChrct=Len(KWord)
         Last=iCLast(KWord,iChrct)
         WRITE(u6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
         WRITE(u6,*) SECNAM, ' Error in keyword.'
         CALL ABEND()
      END SELECT
      END DO
*                                                                      *
************************************************************************
*                                                                      *
      End SubRoutine CHO_CASPT2_RDINP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine mult_sro(A,nA,C,nC,B,nB,Fact,Res,Tmp)
      Implicit Real*8(a-h,o-z)
      Real*8 A(*),B(*),C(*),Res(*),Tmp(*)

      Call DGEMM_('N','N', nA,nC,nC,
     &           1.0d0,A,nA, C,nC,
     &           0.0d0,Tmp,nA)
      Call DGEMM_('N','N', nA,nB,nC,
     &           Fact,Tmp,nA, B,nC,
     &           1.0d0,Res,nA)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Jeppe Olsen                                      *
!               2011, Giovanni Li Manni                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CHECK_BLOCKS_FOR_BK_APPROX(IATP,IBTP,JATP,JBTP,IASM,IBSM,JASM,JBSM,IOCTPA,IOCTPB,I_DO_EXACT_BLOCK)
! Check whether block <IATP, IBTP! H! JATP, JBTP> should
! be calculated exactly or by BK approx
! Input
! ======
! IATP IBTP JATP JBTP : Supergroups (relative numbers)
! IOCTPA, IOBTPB : Offset for type
! Output
! ======
! I_DO_EXACT_BLOCK = 1 => Do exact block
!                  = 0 => Set block to zero
!                  =-1 => Use diagonal aproximation
! Giovanni +Jeppe Olsen, Sept 2011, on a bench at Torre Normanna, Sicily

use lucia_data, only: IBSPGPFTP, MXPNGAS, NELFSPGP, NGAS
use spinfo, only: IOCCPSPC, NGASBK
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: IATP, IBTP, JATP, JBTP, IASM, IBSM, JASM, JBSM
integer(kind=iwp), intent(out) :: IOCTPA, IOCTPB, I_DO_EXACT_BLOCK
integer(kind=iwp) :: ICHECK_OCC_IN_ACCSPC, IOCC(MXPNGAS), IOCC_IN, JOCC(MXPNGAS), JOCC_IN
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IGAS
#endif

IOCTPA = IBSPGPFTP(1)
IOCTPB = IBSPGPFTP(2)
#ifdef _DEBUGPRINT_
write(u6,*) 'IOCTPA, IOCTPB',IOCTPA,IOCTPB
write(u6,*) 'IATP,IBTP,JATP,JBTP'
write(u6,'(5x,I4,5x,I4,5x,I4,5X,I4)') IATP,IBTP,JATP,JBTP
write(u6,*) 'NELFSPGP (IA), (IB), (JA), (JB)'
write(u6,*) (NELFSPGP(igas,IOCTPA-1+IATP),igas=1,NGAS)
write(u6,*) (NELFSPGP(igas,IOCTPB-1+IBTP),igas=1,NGAS)
write(u6,*) (NELFSPGP(igas,IOCTPA-1+JATP),igas=1,NGAS)
write(u6,*) (NELFSPGP(igas,IOCTPB-1+JBTP),igas=1,NGAS)
#endif
IOCC(1:NGAS) = NELFSPGP(1:NGAS,IOCTPA-1+IATP)+NELFSPGP(1:NGAS,IOCTPB-1+IBTP)
JOCC(1:NGAS) = NELFSPGP(1:NGAS,IOCTPA-1+JATP)+NELFSPGP(1:NGAS,IOCTPB-1+JBTP)
#ifdef _DEBUGPRINT_
write(u6,*) ' Routine CHECK_BLOCKS_FOR_BK_APPROX is speaking!'
write(u6,*) ' I am doing BK-type of approximation'
write(u6,*) ' Min and Max for subspace with exact Hamiltonian'
write(u6,*) ' ==============================================='
write(u6,*) 'NGASBK : ',NGASBK
write(u6,*) '              Min. Occ.      Max. Occ.'
do IGAS=1,NGASBK
  write(u6,'(A,I2,10X,I3,9X,I3)') '   GAS',IGAS,IOCCPSPC(IGAS,1),IOCCPSPC(IGAS,2)
end do
#endif

IOCC_IN = ICHECK_OCC_IN_ACCSPC(IOCC,IOCCPSPC,NGASBK,20)
JOCC_IN = ICHECK_OCC_IN_ACCSPC(JOCC,IOCCPSPC,NGASBK,20)
! = 1 if the Occupation is IN
! = 0 of the Occupation is OUT
! If both occupation are outside of IOCCPSPC, we make approximations
if ((IOCC_IN == 0) .and. (JOCC_IN == 0)) then
  ! If the blocks are identical use diagonal approximation
  if ((IATP == JATP) .and. (IASM == JASM) .and. (IBTP == JBTP) .and. (IBSM == JBSM)) then
    ! Compute as diagonal
    I_DO_EXACT_BLOCK = -1
  else
    ! Neglect
    I_DO_EXACT_BLOCK = 0
  end if
else
  ! At least one block is in PSPC, so calculate exactly
  I_DO_EXACT_BLOCK = 1
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' CHECK_BLOCKS_FOR_BK_APPROX is speaking'
write(u6,'(A, 4I4)') ' Input blocks IA, IB, JA, JB = ',IATP,IBTP,JATP,JBTP
write(u6,'(A, 4I4)') ' Input blocks IASM, IBSM, JASM, JBSM = ',IASM,IBSM,JASM,JBSM
write(u6,'(A,I4)') ' I_DO_EXACT_BLOCK = ',I_DO_EXACT_BLOCK
#endif

end subroutine CHECK_BLOCKS_FOR_BK_APPROX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine update2_cvb(orbs,cvb,orbsp,cvbp,
     >  sorbs,dxorg,
     >  ic,
     >  norb,nvb,nprorb,npr,orbopt,strucopt,sym,
     >  dx,iorts,nort,sorbsinv)
      implicit real*8 (a-h,o-z)
      logical orbopt,strucopt,sym
#include "print_cvb.fh"
      dimension orbs(norb,norb),cvb(nvb)
      dimension orbsp(norb,norb),cvbp(nvb)
      dimension sorbs(norb,norb)
      dimension dxorg(npr),dx(npr)
      dimension iorts(2,nort)
      dimension sorbsinv(norb,norb)
      dimension dum(1)
      save zero
      data zero/0d0/

      call free2all_cvb(dxorg,dx,1)
      if(ip(3).ge.3.and.ic.eq.1)then
        write(6,'(/,a)')' Update vector :'
        call vecprint_cvb(dx,npr)
      endif

      call fmove_cvb(orbsp,orbs,norb*norb)
      call fmove_cvb(cvbp,cvb,nvb)

      if(orbopt)then
        call mxattb_cvb(orbsp,orbsp,norb,norb,norb,sorbs)

        ij=0
        do 200 iorb=1,norb
        do 201 jorb=1,norb
        if(jorb.ne.iorb)then
          ij=ij+1
          do 400 i=1,norb
          orbs(i,iorb)=orbs(i,iorb)+dx(ij)*orbsp(i,jorb)
400       continue
        endif
201     continue
200     continue

c  2nd-order correction for orthogonality constraints:
        call fmove_cvb(sorbs,sorbsinv,norb*norb)
        call mxinv_cvb(sorbsinv,norb)
        do 500 iort=1,nort
        iorb=iorts(1,iort)
        jorb=iorts(2,iort)
        sdidj=zero
        do 600 k=1,norb-1
        korb=k
        if(korb.ge.iorb)korb=korb+1
        do 601 l=1,norb-1
        lorb=l
        if(lorb.ge.jorb)lorb=lorb+1
        sdidj=sdidj+sorbs(korb,lorb)*dx(k+(iorb-1)*(norb-1))
     >    *dx(l+(jorb-1)*(norb-1))
601     continue
600     continue
        fac=-.5d0*sdidj
        do 700 i=1,norb
        do 701 j=1,norb
        orbs(i,iorb)=orbs(i,iorb)+fac*orbsp(i,j)*sorbsinv(j,jorb)
        orbs(i,jorb)=orbs(i,jorb)+fac*orbsp(i,j)*sorbsinv(j,iorb)
701     continue
700     continue
500     continue
      endif

      if(strucopt)then
        call addvec(cvb,cvb,dx(nprorb+1),nvb)
        call scalstruc_cvb(orbs,cvb)
        call cvbnrm_cvb(cvb)
      endif

      call nize_cvb(orbs,norb,dum,norb,0,0)
      if(sym)call symtriz_cvb(orbs,cvb)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine CD_DiaMax(Diag,nDim,iPivot,iQual,nQual,DiaMin)
!
! Thomas Bondo Pedersen, October 2004.
!
! Purpose: find nQual largest elements in Diag and leave pointers to
!          them in iQual. Only elements larger than DiaMin are
!          returned (thus, nQual may be reduced here).

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(in) :: Diag(nDim), DiaMin
integer(kind=iwp), intent(inout) :: nQual
integer(kind=iwp), intent(out) :: iPivot(nDim), iQual(nQual)
integer(kind=iwp) :: i, iMax, iTmp, j

do i=1,nDim
  iPivot(i) = i
end do

do j=1,nQual
  do i=nDim,j+1,-1
    if (Diag(iPivot(i)) > Diag(iPivot(i-1))) then
      iTmp = iPivot(i-1)
      iPivot(i-1) = iPivot(i)
      iPivot(i) = iTmp
    end if
  end do
end do

iQual(:) = 0
iMax = nQual
i = 0
nQual = 0
do while (i < iMax)
  i = i+1
  if (Diag(iPivot(i)) >= DiaMin) then
    nQual = nQual+1
    iQual(nQual) = iPivot(i)
  else
    i = iMax+1
  end if
end do

end subroutine CD_DiaMax

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c****************************************************
      subroutine arrange_orbital()
c****************************************************
c  arrange orbital for ci calculation, in meld and
c  molcas program, the orbital are arranged as the symmetry
c  block. we transfer them to ci order
c -----
c map_order_orbital    ab ---> ci
c
#include "drt_h.fh"
#include "intsort_h.fh"
      common /mcorb/ lsmorb(max_orb),noidx(8)
      dimension lsmorbcount(ng_sm),map_tmp(max_orb)
      logical logi_norb_inn(norb_all)

      logi_norb_inn(1:norb_all)=.false.
      iorb=norb_all
      do la=1,norb_all
         norb_number(la)=iorb
         iorb=iorb-1
      enddo

      nim=0
      lsmorbcount(1)=nim
      do im=2,ng_sm
        nim=nim+nlsm_all(im-1)
        lsmorbcount(im)=nim
      enddo

      if ( logic_assign_actorb ) then
        do lr=1,norb_inn
          lr_scf=map_orb_order(lr)
          logi_norb_inn(lr_scf)=.true.
        enddo
        goto 200
      else
        do lr=1,norb_inn
          lsmr=lsm_inn(lr)
          lsmorbcount(lsmr)=lsmorbcount(lsmr)+1
          lr_scf=lsmorbcount(lsmr)
          map_orb_order(lr)=lr_scf
          logi_norb_inn(lr_scf)=.true.
        enddo
      endif
200   lr_scf0=norb_all
      la=norb_inn+1
      do ms=ng_sm,1,-1
        lr_scf0=lr_scf0-nlsm_all(ms)
        lr_scf=lr_scf0
        do lra=1,nlsm_all(ms)
          lr_scf=lr_scf+1
          if(logi_norb_inn(lr_scf)) cycle
          map_orb_order(la)=lr_scf
          la=la+1
        enddo
      enddo

      isum2=0
      isum3=0
      do i=1,ng_sm
        jp2(i)=isum2
        isum2=isum2+i
        jp3(i)=isum3
        isum3=isum3+isum2
      enddo

      iccount=1
      do lrd = 1,norb_inn
        ipwt(lrd) = iccount
        iccount   = iccount+2
      enddo
      lsmorbcount =0
      do lrd=norb_dz,1,-1
        lsmid=lsm_inn(lrd)
        lsmorbcount(lsmid)=lsmorbcount(lsmid)+1
        ipws(lrd)=(lsmorbcount(lsmid)-1)*3+1
      enddo


      map_tmp(1:norb_all)=map_orb_order(1:norb_all)
      do 40 i=1,norb_all
        do j=1,norb_all
          if(map_tmp(j).eq.i) then
            map_orb_order(i)=j
            goto 40
          endif
        enddo
40    continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GenRadQuad_TA(R,nR,nR_Eff,Alpha)

use Constants, only: One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nR
real(kind=wp), intent(out) :: R(2,nR-1)
integer(kind=iwp), intent(out) :: nR_Eff
real(kind=wp), intent(in) :: Alpha
integer(kind=iwp) :: iR
real(kind=wp) :: F1, F2, F6, Fact, x

! Last point at infinity is eliminated

#ifdef _DEBUGPRINT_
write(u6,*) 'Treutler-Ahlrichs Algorithm'
write(u6,*) 'Alpha=',Alpha
write(u6,*) 'nR=',nR
#endif
Fact = Alpha/log(Two)
F6 = 0.6_wp
do iR=1,nR-1
  x = Two*real(iR,kind=wp)/real(nR,kind=wp)-One
  F1 = (One+x)
  F2 = log(Two/(One-x))
  R(1,iR) = Fact*F1**F6*F2
  R(2,iR) = R(1,iR)**2*Fact*(F6*F1**(F6-One)*F2+F1**F6*One/(One-x))*Two/real(nR,kind=wp)
end do
nR_Eff = nR-1

return

end subroutine GenRadQuad_TA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Bruno Tenorio                                    *
!***********************************************************************

subroutine SRTDM2(IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,PSI1,PSI2,IF21,IF12,SRT2M)
! Calculates the 2-electron Dyson matrix between two states with
! N and N-1 electrons, defined as:
! IF12 D = < N-1 | anni_left anni_right anni_right | N >, or
! IF21 D = < N | anni_left anni_left anni_right | N-1 >
! reduced 2-electron tdm in the space of active spin-orbitals

use rassi_global_arrays, only: FSBANN1, FSBANN2, FSBANN3
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IORBTAB(*), ISSTAB(*), IFSBTAB1(*), IFSBTAB2(*)
real(kind=wp), intent(in) :: PSI1(*), PSI2(*)
logical(kind=iwp), intent(in) :: IF21, IF12
real(kind=wp), intent(_OUT_) :: SRT2M(*)
integer(kind=iwp) :: IJL, IMODE, ISORB, JLSORB, JSORB, LSORB, NASORB, ND1, ND2, ND3
real(kind=wp) :: COEFF, OVLP
real(kind=wp), allocatable :: ANN1(:), ANN2(:), ANN3(:)
real(kind=wp), external :: OVERLAP_RASSI

NASORB = IORBTAB(4)

! IF12 = eliminte one electron to the left: < N-1 | anni_left (PSI1)
! and then eliminate two to the left (PSI2) anni_right anni_right | N >
if (IF12) then
  do ISORB=1,NASORB
    ! Annihilate a single spin orbital from PSI1 (N-1), ISORB:
    IMODE = -1
    call FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB1,1)
    ND1 = FSBANN1(5)
    COEFF = One
    call mma_allocate(ANN1,ND1,Label='ANN1')
    ANN1(:) = Zero
    call PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,FSBANN1,IFSBTAB1,COEFF,ANN1,PSI1)
    !TEST write(u6,*) ' The ANN1 wave function, with ISORB=',ISORB
    !TEST PRTHR = 0.01_wp
    !TEST call PRWVF(IORBTAB,ISSTAB,FSBANN1,PRTHR,ANN1)
    do JSORB=1,NASORB
      ! Annihilate a single spin orbital from PSI2, the spin orbital JSORB:
      IMODE = -1
      call FSBOP(IMODE,JSORB,IORBTAB,ISSTAB,IFSBTAB2,2)
      ND2 = FSBANN2(5)
      COEFF = One
      call mma_allocate(ANN2,ND2,Label='ANN2')
      ANN2(:) = Zero
      call PRIMSGM(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN2,IFSBTAB2,COEFF,ANN2,PSI2)
      !TEST write(u6,*) ' The ANN2 wave function, with JSORB=',JSORB
      !TEST PRTHR = 0.01_wp
      !TEST call PRWVF(IORBTAB,ISSTAB,FSBANN2,PRTHR,ANN2)
      do LSORB=1,NASORB
        ! Pair index J,L:
        JLSORB = (NASORB*(JSORB-1))+LSORB-1
        OVLP = Zero
        ! Annihilate another spin orbital from PSI2, LSORB:
        IMODE = -1
        call FSBOP(IMODE,LSORB,IORBTAB,ISSTAB,FSBANN2,3)
        ND3 = FSBANN3(5)
        COEFF = One
        call mma_allocate(ANN3,ND3,Label='ANN3')
        ANN3(:) = Zero
        if (JSORB /= LSORB) then
          call PRIMSGM(IMODE,LSORB,IORBTAB,ISSTAB,FSBANN3,FSBANN2,COEFF,ANN3,ANN2)
          ! Compute the spin transition density matrix element:
          OVLP = OVERLAP_RASSI(FSBANN1,FSBANN3,ANN1,ANN3)
        else
          OVLP = Zero
        end if
        IJL = ISORB+(NASORB*JLSORB)
        SRT2M(IJL) = OVLP
        call mma_deallocate(ANN3)
        call mma_deallocate(FSBANN3)
      end do
      call mma_deallocate(ANN2)
      call mma_deallocate(FSBANN2)
    end do
    call mma_deallocate(ANN1)
    call mma_deallocate(FSBANN1)
  end do
else if (IF21) then
  ! ################################################################################
  ! IF12 = Eliminate to the right (state 2)
  write(u6,*) 'Invalid state combination. Please, give PSI1=(N-1) and PSI2=(N)'
else
  write(u6,*) 'Invalid state combination in 2particle DYSON'
end if ! IF10 or IF01
! ################################################################################
end subroutine SRTDM2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Rulin Feng                                       *
************************************************************************
*       ****************************************************
*                  Do SVD for SO-TDM in AO basis
*       ****************************************************
*        This routine is made to do single value decompositon
*        to spin-orbit coupled transition density matrices in AO
*        basis.
*        Input: TDMZZ, transition densitry matrix
*               TSDMZZ,transition spin density matrix(x,y,z)
*        Remember that TDMZZ and TSDMZZ contain six TDM's each
*        See sonatorbm_full.f
*        TDMZZ(3,:) and TSDMZZ(1-3,:), for the real part of TDM
*        The transition density matrix TDMZZ does not depend on
*        spin matrices, thus TDMZZ(1-3,:) are the same, so are the
*        imaginary part TDMZZ(4-6,:).
*        TDMZZ(6,:) and TSDMZZ(4-6,:), for the imaginary part of TDM
*
*                                                       -RF 8/18,2021

      SUBROUTINE DO_AOTDMNTO(TDMZZ,TSDMZZ,ANTSIN,ISTATE,JSTATE,nb,nb2)
      use OneDat, only: sNoNuc, sNoOri, sOpSiz
      use stdalloc, only: mma_allocate, mma_deallocate
      use Cntrl, only: IfArgu
      use rassi_data, only: NBTRI

      IMPLICIT None
      Integer ISTATE,JSTATE,nb,nb2
      REAL*8 TDMZZ(6,nb2)
      REAL*8 TSDMZZ(6,nb2)
      REAL*8 ANTSIN(6,nb2)
      REAL*8, ALLOCATABLE:: TDMZZL(:,:), TSDMZZL(:,:)
      COMPLEX*16, ALLOCATABLE:: YMAT(:,:)
      COMPLEX*16, ALLOCATABLE:: TDMZZLC(:),TDMZZC(:),BUFF(:),DIPsC(:)
      COMPLEX*16, ALLOCATABLE:: SVDU(:),SVDVH(:),RESI(:)
      REAL*8, ALLOCATABLE:: SVDS(:)
      COMPLEX*16, ALLOCATABLE:: BUFF1(:),BUFF2(:),SumofYdiag(:)
      COMPLEX*16  Transition_Dipole
      Integer i,j,info,lwork,di,icmp,iopt,irc,isylab
      REAL*8 NumofEc, Sumofeigen, eigen_print_limit,Zero,Two,pi
      REAL*8 SumofTDMZZLC
      REAL*8 Dummy(1)
      Integer, DIMENSION(1)::SIZ
      COMPLEX*16, ALLOCATABLE:: SIZC(:)
      Integer LU, isfreeunit, iDummy(7,8)
c start Phase factor stuff
c trace of transition dipole real and imaginary (x,y,and z)
      REAL*8 ttdr(3),ttdi(3)
      REAL*8 phi,sd
c end
      CHARACTER(LEN=8) LABEL
      CHARACTER(LEN=7) STATENAME,STATENAMETMP
      CHARACTER(LEN=128) FNAME
      CHARACTER(LEN=72) NOTE
      Real*8, Allocatable:: Dips(:), Dip(:)
      Real*8, Allocatable:: TMPR(:), TMPI(:)
      Real*8, Allocatable:: SZZs(:), SZZ(:)
      Real*8, Allocatable:: EIG(:), EIGM(:)
      Real*8, Allocatable:: TMP(:)
      Real*8, Allocatable:: BFF(:)
      Real*8, Allocatable:: RESIX(:), RESIR(:)
      Real*8, Allocatable:: SM(:), SMI(:)
      Real*8, Allocatable:: SVDUR(:), SVDUI(:)
      Integer, Allocatable:: PIV(:)
      Real*8, Allocatable:: SVDVHR(:), SVDVHI(:)
      Real*8, Allocatable:: SVDVR(:), SVDVI(:)

      Zero=0.0D0
      Two=2.0D0
      pi=ACOS(-1.0D0)

c ANTISYMMETRIC matrix needs a little fixing
      do i=0, nb-1
        do j=1, nb
          if(i.LT.j-1) then
            ANTSIN(3,i*nb+j)=-ANTSIN(3,i*nb+j)
          else if(i.EQ.j-1) then
            ANTSIN(3,i*nb+j)=zero
          endif
        enddo
      enddo
c The imaginary part may need a negative sign
      TDMZZ(4,:) = -TDMZZ(4,:)
      TDMZZ(5,:) = -TDMZZ(5,:)
      TDMZZ(6,:) = -TDMZZ(6,:)
c     'HERMSING' ITYPE=1
c     'ANTISING' ITYPE=2
c     'HERMTRIP' ITYPE=3
c     'ANTITRIP' ITYPE=4

C Thus we obtained the AO based transition density matrix TDMZZ
c and the transition spin density matrix TSDMZZ
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C we can do testing here we calculate the oscillator strength
c by dot with dipole moment AO matrix and trace
c do the test before the Lowdin orthogonalization
c      If (TestPrint) then
      Call MMA_ALLOCATE(BUFF,nb2,LABEL="LBUFF")
      Call MMA_ALLOCATE(TDMZZC,nb2,LABEL="TDMZZC")
      do di=1, 3
        Call mma_allocate(DIPs,nb2,Label='Dips')
        LABEL(1:8)='MLTPL  1'
        IRC = -1
        ICMP = di
        ISYLAB = 1
        IOPT = ibset(0,sOpSiz) ! Only read the size of the array
        CALL IRDONE(IRC,IOPT,LABEL,ICMP,SIZ,ISYLAB)
        !no nuclear contrib, no origin of operator
        IOPT = ibset(ibset(0,sNoOri),sNoNuc)
        Call mma_allocate(DIP,SIZ(1),Label='DIP')
        CALL RDONE(IRC,IOPT,LABEL,ICMP,DIP,ISYLAB)
        Call DESYM_SONTO(DIP,SIZ(1),DIPs,ISYLAB)
        Call mma_deallocate(DIP)
        write(6,*) '  For istate ', ISTATE, ' jstate ',JSTATE
        write(6,*) '  Component ',ICMP
c Get complex matrices
        Call MMA_ALLOCATE(DIPsC,nb2,LABEL="DIPsC")
        do i=1,nb2
          TDMZZC(i)=cmplx(TDMZZ(di,i),TDMZZ(di+3,i),8)
          DIPsC(i)=cmplx(DIPs(i),zero,8)
        enddo
c TDM
        Call ZGEMM_('N','N',nb,nb,nb,(1.0D0,0.0D0),DIPsC,nb,
     &              TDMZZC,nb,(0.0D0,0.0D0),BUFF,nb)
C Trace the resulting matrix
        Transition_Dipole = cmplx(zero,zero,8)
        do i=1, nb
          Transition_Dipole = Transition_Dipole +
     &    BUFF((i-1)*nb+i)
        enddo
        ttdr(di)=real(Transition_Dipole)
        ttdi(di)=aimag(Transition_Dipole)
        write(6,*) '  Transition_Dipole :',Transition_Dipole
        write(6,*)
        Call MMA_DEALLOCATE(DIPs)
        Call MMA_DEALLOCATE(DIPsC)
      enddo
      Call MMA_DEALLOCATE(BUFF)
      Call MMA_DEALLOCATE(TDMZZC)
c      Endif
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c phase factor = cos phi + i * sin phi
c phi = 1/2 * arc tan (2*(x_r*x_i + y_r*y_i + z_r*z_i)/
c                        (x_i**2 + y_i**2 + z_i**2 -
c                         x_r**2 - y_r**2 - z_r**2))
c to minimize the imaginary part of total transition dipole
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      If(IFARGU) then
c check if minimum of maximum
        If((ttdi(1)**2+ttdi(2)**2+ttdi(3)**2
     &     -ttdr(1)**2-ttdr(2)**2-ttdr(3)**2).EQ.0.0D0) Then
          phi = 0.0D0
        Else
          phi = 0.5D0*atan(2*(ttdr(1)*ttdi(1)
     &                   +ttdr(2)*ttdi(2)
     &                   +ttdr(3)*ttdi(3))/
     &                   (ttdi(1)**2+ttdi(2)**2+ttdi(3)**2
     &                   -ttdr(1)**2-ttdr(2)**2-ttdr(3)**2))
        Endif
        sd = 2*cos(2*phi)*(ttdr(1)**2+ttdr(2)**2+ttdr(3)**2
     &                    -ttdi(1)**2-ttdi(2)**2-ttdi(3)**2)
     &      -4*sin(2*phi)*(ttdr(1)*ttdi(1)+ttdr(2)*ttdi(2)
     &                    +ttdr(3)*ttdi(3))
c make sure it's minimum
        If (sd.LT.Zero) phi=phi+pi/Two
c multipole phase factor with tdm as a whole
        write(6,*) 'Phase factor turned on with calculated'
        write(6,'(2X,A,F6.2)') "argument Phi: ", phi
        call mma_allocate(TMPR,nb2,Label='TMPR')
        call mma_allocate(TMPI,nb2,Label='TMPI')
        do i=1,nb2
          TMPR(i)=TDMZZ(3,i)*cos(phi)-TDMZZ(6,i)*sin(phi)
          TMPI(i)=TDMZZ(6,i)*cos(phi)+TDMZZ(3,i)*sin(phi)
        enddo
        TDMZZ(1,:) = TMPR(1:nb2)
        TDMZZ(2,:) = TMPR(1:nb2)
        TDMZZ(3,:) = TMPR(1:nb2)
        TDMZZ(4,:) = TMPI(1:nb2)
        TDMZZ(5,:) = TMPI(1:nb2)
        TDMZZ(6,:) = TMPI(1:nb2)
        call mma_deallocate(TMPI)
        call mma_deallocate(TMPR)
      EndIf
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

C Make NTO output file names without spin
      write(STATENAME,'(I3)') ISTATE
      write(STATENAMETMP,'(I3,a1,a)')
     &      JSTATE,'_',trim(adjustl(STATENAME))
      write(STATENAME,'(a)') trim(adjustl(STATENAMETMP))
Cc Everything is in C1 symmetry for now
C Do the Lowdin Orthogonalization assuming C1 symmetry
c SZZ  - AO Overlap integral
c SZZs - AO Overlap integral in square
c EIG  - AO Overlap eigenvalues
      call mma_allocate(SZZ,NBTRI,Label='SZZ')
      call mma_allocate(SZZs,nb2,Label='SZZs')
      call mma_allocate(EIG,nb,Label='EIG')
      SZZ(:)=0.0D0
      SZZs(:)=0.0D0
      EIG(:)=0.0D0
C AO OVERLAP MATRIX
      IRC=-1
c IOPT=6, origin and nuclear contrib not read
      IOPT=ibset(ibset(0,sNoOri),sNoNuc)
      ICMP=1
      ISYLAB=1
      LABEL='MLTPL  0'
      call RDONE(IRC,IOPT,LABEL,ICMP,SZZ,ISYLAB)
      IF (IRC.NE.0) THEN
        WRITE(6,*)
        WRITE(6,*)'      *** ERROR IN SUBROUTINE  SONATORB ***'
        WRITE(6,*)'      OVERLAP INTEGRALS ARE NOT AVAILABLE'
        WRITE(6,*)
        CALL ABEND()
      ENDIF
      Call DESYM_SONTO(SZZ,NBTRI,SZZs,ISYLAB)
      call mma_deallocate(SZZ)
**************
* For tests
**************
      call mma_allocate(TMP,nb2,Label='TMP')
      TMP(1:nb2) = TDMZZ(3,:)
      Call mma_allocate(BFF,nb2,Label='BFF')
      call DGEMM_('N','N',nb,nb,nb,1.0D0,SZZs,nb,
     &             TMP,nb,0.0D0,BFF,nb)
C Trace the resulting matrix
      NumOfEc = Zero
      do i=0, nb-1
        do j=0, nb-1
          if(i.eq.j) then
            NumOfEc = NumOfEc + BFF(1+i*nb+j)
          endif
        enddo
      enddo
c      write(6,*) 'NumOfEc ',NumOfEc
      Call mma_deallocate(BFF)
**************

c DIAGONALIZE AO OVERLAP MATRIX
c Set LWORK=-1 to get the optimal scratch space RESI
c then let LWORK equal to length of scratch space
c free and reallocate memory for RESI using that length
      call mma_allocate(RESIX,1,Label='RESIX')
      LWORK=-1
      call DSYEV_('V','U',nb,SZZs,nb,EIG,
     &            RESIX,LWORK,INFO)
      LWORK=INT(RESIX(1))
      call mma_deallocate(RESIX)
      call mma_allocate(RESIX,LWORK,Label='RESIX')
c SZZs in as the AO overlap sqaure matrix
c out as the eigenvector matrix of SZZs
c with eigenvalues in EIG
      call DSYEV_('V','U',nb,SZZs,nb,EIG,
     &            RESIX,LWORK,INFO)
c Put EIG in sqrt and in diagonal in EIGM
      call mma_allocate(EIGM,nb2,Label='EIGM')
      do i=0,nb-1
        do j=0,nb-1
          If (i.eq.j) then
            EIGM(1+i*nb+j)=sqrt(EIG(1+i))
          Else
            EIGM(1+i*nb+j)=zero
          Endif
        enddo
      enddo
      call mma_deallocate(EIG)
      call mma_deallocate(RESIX)
c Get S^1/2 from S^1/2 = U S_diag^1/2 U^T
      call mma_allocate(SM,nb2,Label='SM')
      call DGEMM_('N','T',nb,nb,nb,1.0D0,EIGM,nb,
     &             SZZs,nb,0.0D0,TMP,nb)
      call DGEMM_('N','N',nb,nb,nb,1.0D0,SZZs,nb,
     &             TMP,nb,0.0D0,SM,nb)
      call mma_deallocate(SZZs)
      call mma_deallocate(EIGM)
c Get inverse of S^1/2 -> S^-1/2
c Before calling DGETRI, call DGETRF to factorize SM
c Set LWORK=-1 to get the optimal scratch space RESI
c then let LWORK equal to length of scratch space
c free and reallocate memory for RESI using that length
      call mma_allocate(SMI,nb2,Label='SMI')
      SMI(:)=SM(:)
      call mma_allocate(PIV,nb,Label='PIV')
      call DGETRF_(nb,nb,SMI,nb,PIV,INFO)
      call mma_allocate(RESIX,1,Label='RESIX')
      LWORK=-1
      call DGETRI_(nb,SMI,nb,PIV,RESIX,LWORK,INFO)
      LWORK=INT(RESIX(1))
      call mma_deallocate(RESIX)
      call mma_allocate(RESIX,LWORK,Label='RESIX')
      call DGETRI_(nb,SMI,nb,PIV,RESIX,LWORK,INFO)
      call mma_deallocate(PIV)
      call mma_deallocate(RESIX)

c Note: The density matrix should transform as S^1/2 D S^1/2
c Transform TDMZZ and TSDMZZ as S^1/2 T S^1/2
      Call MMA_ALLOCATE(TDMZZL,6,nb2,LABEL='LTDMZZL')
      Call MMA_ALLOCATE(TSDMZZL,6,nb2,LABEL='LTSDMZZL')
      call mma_allocate(TMPR,nb2,Label='TMPR')
c Real part of TDMZZ
      TMPR(1:nb2) = TDMZZ(3,:)
      call DGEMM_('N','N',nb,nb,nb,1.0D0,TMPR,nb,
     &               SM,nb,0.0D0,TMP,nb)
      call DGEMM_('N','N',nb,nb,nb,1.0D0,SM,nb,
     &               TMP,nb,0.0D0,TMPR,nb)
      TDMZZL(3,:) = TMPR(1:nb2)
c Imaginary part of TDMZZ
      TMPR(1:nb2) = TDMZZ(6,:)
      call DGEMM_('N','N',nb,nb,nb,1.0D0,TMPR,nb,
     &               SM,nb,0.0D0,TMP,nb)
      call DGEMM_('N','N',nb,nb,nb,1.0D0,SM,nb,
     &               TMP,nb,0.0D0,TMPR,nb)
      TDMZZL(6,:) = TMPR(1:nb2)
c Do for all components of TSDMZZ
      do i=1, 6
        TMPR(1:nb2) = TSDMZZ(i,:)
        call DGEMM_('N','N',nb,nb,nb,1.0D0,TMPR,nb,
     &               SM,nb,0.0D0,TMP,nb)
        call DGEMM_('N','N',nb,nb,nb,1.0D0,SM,nb,
     &               TMP,nb,0.0D0,TMPR,nb)
        TSDMZZL(i,:) = TMPR(1:nb2)
      enddo
      call mma_deallocate(TMPR)
C End of the Lowdin Orthogonalization

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Do SVD for transition density matrix as a whole
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c In order to use zgesvd first we combine TDMZZL(3,:)
c and TDMZZL(6,:) as a complex matrix
      Call MMA_ALLOCATE(TDMZZLC,nb2,LABEL='LTDMZZLC')
      SumofTDMZZLC = 0.0D0
      do i=1, nb2
        TDMZZLC(i) = cmplx(TDMZZL(3,i),TDMZZL(6,i),8)
        SumofTDMZZLC = SumofTDMZZLC+abs(TDMZZLC(i))
      enddo
C Do SVD by using ZGESVD, see lapack for documentation
c A = U * SIGMA * V^dagger
C Get work space for U, SIGMA, and V^dagger, VH
      Call MMA_ALLOCATE(SVDU,nb2,LABEL='SVDU')
      Call MMA_ALLOCATE(SVDS,nb,LABEL='SVDS')
      Call MMA_ALLOCATE(SVDVH,nb2,LABEL='SVDVH')
      Call MMA_ALLOCATE(SIZC,1,LABEL='RESI')
      call mma_allocate(RESIR,5*nb,Label='RESIR')
c Set LWORK=-1 to get the optimal scratch space in SIZC
c then let LWORK equal to length of scratch space
c free and reallocate memory for SIZC using that length
      LWORK=-1
      Call ZGESVD_('A','A',NB,NB,TDMZZLC,NB,SVDS,
     &            SVDU,NB,SVDVH,NB,SIZC,
     &            LWORK,RESIR,INFO)
      LWORK=max(1,int(SIZC(1)))
      Call MMA_DEALLOCATE(SIZC)
      Call MMA_ALLOCATE(RESI,LWORK,LABEL='RESI')
c Do SVD for TDMZZLC
      call ZCOPY_(nb2,[(0.0d0,0.0d0)],0,SVDU,1)
      call DCOPY_(nb,[0.0d0],0,SVDS,1)
      call ZCOPY_(nb2,[(0.0d0,0.0d0)],0,SVDVH,1)
      call ZCOPY_(LWORK,[(0.0d0,0.0d0)],0,RESI,1)
      If(SumofTDMZZLC.GE.1.0D-20) Then
        Call ZGESVD_('A','A',nb,nb,TDMZZLC,nb,SVDS,
     &            SVDU,nb,SVDVH,nb,RESI,
     &            LWORK,RESIR,INFO)
      EndIf
      If(INFO.ne.zero) write(6,*) "SVD convergence issue"
c End testing SVD
c For partitioning properties in the NTO basis
c Partition of the MLTPL 1, dipole moment intergals
      Call mma_allocate(DIPs,nb2,Label='DIPs')
      Call MMA_ALLOCATE(DIPsC,nb2,LABEL="LDIPsC")
      Call MMA_ALLOCATE(BUFF1,nb2,LABEL='BUFF1')
      Call MMA_ALLOCATE(BUFF2,nb2,LABEL='BUFF2')
      Call MMA_ALLOCATE(YMAT,3,nb2,LABEL='YMAT')
      Call MMA_ALLOCATE(SumofYdiag,3,LABEL='SumofYdiag')
c The three components of dipole
      do di=1, 3
        LABEL='MLTPL  1'
        IRC = -1
        ICMP = di
        ISYLAB = 1
        IOPT = ibset(0,sOpSiz)
        CALL IRDONE(IRC,IOPT,LABEL,ICMP,SIZ,ISYLAB)
        IOPT = 6
        Call mma_allocate(DIP,SIZ(1),Label='DIP')
        CALL RDONE(IRC,IOPT,LABEL,ICMP,DIP,ISYLAB)
        Call DESYM_SONTO(DIP,SIZ(1),DIPs,ISYLAB)
        Call mma_deallocate(DIP)
c Perform Lowdin orthogonalization on operator matrix
c They transform as S^-1/2 P S^-1/2
        Call DGEMM_('N','N',nb,nb,nb,1.0D0,DIPs,nb,
     &              SMI,nb,0.0D0,TMP,nb)
        Call DGEMM_('N','N',nb,nb,nb,1.0D0,SMI,nb,
     &              TMP,nb,0.0D0,DIPs,nb)
c ZGESVD destroys TDMZZLC after it finishes
c reconstruct TDMZZLC and DIPsC
        do i=1, nb2
          TDMZZLC(i) = cmplx(TDMZZL(3,i),TDMZZL(6,i),8)
          DIPsC(i)=cmplx(DIPs(i),zero,8)
        enddo
c Do U^H TDMZZLC DIP U = Y, Diagonal of Y contains the partition
        Call ZGEMM_('N','N',nb,nb,nb,(1.0D0,0.0D0),TDMZZLC(:),nb,
     &              DIPsC,nb,(0.0D0,0.0D0),BUFF1(:),nb)
        Call ZGEMM_('N','N',nb,nb,nb,(1.0D0,0.0D0),BUFF1(:),nb,
     &              SVDU(:),nb,(0.0D0,0.0D0),BUFF2(:),nb)
        Call ZGEMM_('C','N',nb,nb,nb,(1.0D0,0.0D0),SVDU(:),nb,
     &              BUFF2(:),nb,(0.0D0,0.0D0),BUFF1(:),nb)
        YMAT(di,:) = BUFF1(:)
        SumofYdiag(di) = cmplx(zero,zero,8)
        do i=1, nb
          SumofYdiag(di)=SumofYdiag(di) + YMAT(di,(i-1)*nb+i)
        enddo
      enddo
      Call mma_deallocate(DIPs)
      Call MMA_DEALLOCATE(BUFF1)
      Call MMA_DEALLOCATE(BUFF2)
      Call MMA_DEALLOCATE(DIPsC)
      Call MMA_DEALLOCATE(RESI)
      Call MMA_DEALLOCATE(RESIR)

c      Call MMA_DEALLOCATE(YMAT)

c      write(6,'(F11.5,SP,F8.5,"i")') SumofYdiag(1)
c      write(6,'(F11.5,SP,F8.5,"i")') SumofYdiag(2)
c      write(6,'(F11.5,SP,F8.5,"i")') SumofYdiag(3)
c End of partitioning properties

c But we still need to transform U and V back to original AO
c basis using U=S^{-1/2) U' and V=S^{-1/2} V'
c for V^t it is V'^t S^{-1/2} = V^t
      call mma_allocate(SVDUR,nb2,Label='SVDUR')
      call mma_allocate(SVDUI,nb2,Label='SVDUI')
      SVDUR(:)=0.0D0
      SVDUI(:)=0.0D0
      call mma_allocate(SVDVHR,nb2,Label='SVDVHR')
      call mma_allocate(SVDVHI,nb2,Label='SVDVHR')
      SVDVHR(:)=0.0D0
      SVDVHI(:)=0.0D0

      TMP(:)=0.0D0

      SVDUR(:)= real(SVDU(:))
      SVDUI(:)=aimag(SVDU(:))
      SVDVHR(:)= real(SVDVH(:))
      SVDVHI(:)=aimag(SVDVH(:))
c U
      call DGEMM_('N','N',nb,nb,nb,1.0D0,SMI,nb,
     &             SVDUR,nb,0.0D0,TMP,nb)
      SVDUR(:)=TMP(:)
      call DGEMM_('N','N',nb,nb,nb,1.0D0,SMI,nb,
     &             SVDUI,nb,0.0D0,TMP,nb)
      SVDUI(:)=TMP(:)
c V^H
      call DGEMM_('N','N',nb,nb,nb,1.0D0,SVDVHR,nb,
     &             SMI,nb,0.0D0,TMP,nb)
      SVDVHR(:)=TMP(:)
      call DGEMM_('N','N',nb,nb,nb,1.0D0,SVDVHI,nb,
     &             SMI,nb,0.0D0,TMP,nb)
      SVDVHI(:)=TMP(:)
c V
      call mma_allocate(SVDVR,nb2,Label='SVDVR')
      call mma_allocate(SVDVI,nb2,Label='SVDVI')
      SVDVR(:)=0.0D0
      SVDVI(:)=0.0D0
      do i=0, nb-1
        do j=0, nb-1
          SVDVR(1+i*nb+j)=SVDVHR(1+j*nb+i)
c imaginary part takes a negative sign
          SVDVI(1+i*nb+j)=-1.D0*SVDVHI(1+j*nb+i)
        enddo
      enddo
      call mma_deallocate(SVDVHR)
      call mma_deallocate(SVDVHI)
c tests
      CALL ADD_INFO("LAMBDA",SVDS,5,4)

c singular values
      Sumofeigen=zero
      do i=0, nb-1
        Sumofeigen=Sumofeigen+SVDS(i+1)**2
      enddo

c Head of the output
      write(6,*)
      write(6,'(6X,A)') repeat('*',90)
      write(6,'(6X,A,88X,A)') '*','*'
      write(6,'(6X,A,29X,A31,28X,A)')
     & '*','Natural transition orbitals','*'
      write(6,'(6X,A,88X,A)') '*','*'
      write(6,'(6X,A,27X,A25,I2,A12,I2,20X,A)')
     &'*','Between spin-orbit state ',ISTATE,' and state ',JSTATE,'*'
      write(6,'(6X,A,88X,A)') '*','*'
      write(6,'(6X,A)') repeat('*',90)
      write(6,*)
c Start output singular value information for positive spin values
      write(6,'(6X,A)') repeat('=',90)
      eigen_print_limit=1.0D-8
      write(6,'(5X,A12,A12,A16,A51)')'EXCITATION','EIGENVALUE',
     &'EXCITATION',
     &'TRANSITION DIPOLE MOMENT'
      write(6,'(5X,A12,12X,A16,3A17)')'AMPLITUDE',
     &'CONTRIBUTION(%)',
     &'(1)','(2)','(3)'
      write(6,'(6X,A)') repeat('-',90)
      do i=0,nb-1
        IF(SVDS(i+1)**2.lt.eigen_print_limit)  EXIT
        write(6,'(4X,3X,F8.5,4X,F8.5,8X,F8.2,2X,
     &           3(F9.4,SP,F7.4,"i",SS))')
     &  SVDS(i+1),SVDS(i+1)**2,
     &  SVDS(i+1)**2/Sumofeigen*1.0D2,
     &  YMAT(1,i*nb+i+1),
     &  YMAT(2,i*nb+i+1),
     &  YMAT(3,i*nb+i+1)
      enddo
      write(6,'(6X,A,F8.5)')'SUM OF EIGENVALUES ',Sumofeigen
      write(6,'(6X,A24,15X,3(F9.4,SP,F7.4,"i",SS))')
     &                       'SUM OF TRANSITION DIPOLE',
     &                       SumofYdiag(1),
     &                       SumofYdiag(2),
     &                       SumofYdiag(3)
      write(6,'(6X,A)') repeat('=',90)
      write(6,*)
      write(6,*)
c Write NTOs to file in C1 symmetry
      Do i=1, nb
        SVDS(i)=SVDS(i)**2/Sumofeigen
      EndDo
      LU=50
      LU=ISFREEUNIT(LU)
      Note='*  Spin-orbit Natural Transition Orbitals'
c U real
      write(FNAME,'(6(a))')
     &      'NTORB.SO.',trim(adjustl(STATENAME)),'.','PART','.','Re'
      write(6,'(4(a))')
     & '      NATURAL TRANSITION ORBITALS FOR SPIN-ORBIT STATE ',
     & trim(STATENAME),
     & ' ARE WRITTEN ONTO FILE ',
     & FNAME
      call WRVEC(FNAME,LU,'CO',1,[NB],[NB],SVDUR,
     &           SVDS ,Dummy,iDummy,Note)
c U imaginary
      write(FNAME,'(6(a))')
     &      'NTORB.SO.',trim(adjustl(STATENAME)),'.','PART','.','Im'
      write(6,'(4(a))')
     & '      NATURAL TRANSITION ORBITALS FOR SPIN-ORBIT STATE ',
     & trim(STATENAME),
     & ' ARE WRITTEN ONTO FILE ',
     & FNAME
      call WRVEC(FNAME,LU,'CO',1,[NB],[NB],SVDUI,
     &           SVDS ,Dummy,iDummy,Note)
c V real
      write(FNAME,'(6(a))')
     &      'NTORB.SO.',trim(adjustl(STATENAME)),'.','HOLE','.','Re'
      write(6,'(4(a))')
     & '      NATURAL TRANSITION ORBITALS FOR SPIN-ORBIT STATE ',
     & trim(STATENAME),
     & ' ARE WRITTEN ONTO FILE ',
     & FNAME
      call WRVEC(FNAME,LU,'CO',1,[NB],[NB],SVDVR,
     &           SVDS ,Dummy,iDummy,Note)
c V imaginary
      write(FNAME,'(6(a))')
     &      'NTORB.SO.',trim(adjustl(STATENAME)),'.','HOLE','.','Im'
      write(6,'(4(a))')
     & '      NATURAL TRANSITION ORBITALS FOR SPIN-ORBIT STATE ',
     & trim(STATENAME),
     & ' ARE WRITTEN ONTO FILE ',
     & FNAME
      call WRVEC(FNAME,LU,'CO',1,[NB],[NB],SVDVI,
     &           SVDS ,Dummy,iDummy,Note)
c End of output
      write(6,*)
      write(6,'(6X,A)') repeat('*',90)
      write(6,'(6X,A,88X,A)') '*','*'
      write(6,'(6X,A,28X,A34,25X,A)')
     & '*','End of natural transition orbitals','*'
      write(6,'(6X,A,88X,A)') '*','*'
      write(6,'(6X,A,27X,A25,I2,A12,I2,20X,A)')
     &'*','Between spin-orbit state ',ISTATE,' and state ',JSTATE,'*'
      write(6,'(6X,A,88X,A)') '*','*'
      write(6,'(6X,A)') repeat('*',90)
      write(6,*)

c Free up workspace
      Call MMA_DEALLOCATE(SVDU)
      Call MMA_DEALLOCATE(SVDS)
      Call MMA_DEALLOCATE(SVDVH)
      Call MMA_DEALLOCATE(TDMZZL)
      Call MMA_DEALLOCATE(TSDMZZL)
      Call MMA_DEALLOCATE(TDMZZLC)
      Call MMA_DEALLOCATE(YMAT)
      Call MMA_DEALLOCATE(SumofYdiag)
      Call MMA_DEALLOCATE(SM)
      Call MMA_DEALLOCATE(SMI)
      Call MMA_DEALLOCATE(TMP)
      Call MMA_DEALLOCATE(SVDUR)
      Call MMA_DEALLOCATE(SVDUI)
      Call MMA_DEALLOCATE(SVDVR)
      Call MMA_DEALLOCATE(SVDVI)

      END SUBROUTINE DO_AOTDMNTO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996,1999, Per Ake Malmqvist                           *
************************************************************************
*--------------------------------------------*
* 1996  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
* 1999: GEMINAL-R12 ENABLED                  *
*--------------------------------------------*
      SUBROUTINE PCG(ICONV)
      USE INPUTDATA
      IMPLICIT NONE

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

      INTEGER ICONV

      INTEGER I,IC,IS,ITER
      INTEGER IVECP,IVECT,IVECU
      INTEGER LAXITY
      INTEGER Cho_X_GetTol
      EXTERNAL Cho_X_GetTol
      REAL*8 ALPHA,BETA,PR,PT,UR
      REAL*8 ECORR(0:8,0:MXCASE)
      REAL*8 EAIVX,EATVX,EBJAI,EBJAT,EBVAT,EVJAI,EVJTI,EVJTU
      REAL*8 E2NONV,ESHIFT
      REAL*8 OVLAPS(0:8,0:MXCASE)
      REAL*8 SAV,SAVI,DSCALE

C Flag to tell wether convergence was obtained
      ICONV = 0

C Lists of coupling coefficients, used for sigma vector
C generation from non-diagonal blocks of H0.
      CALL GETMEM('LISTS','ALLO','INTE',LLISTS,NLSTOT)
      CALL MKLIST(iWORK(LLISTS))


C Mnemonic names for vectors stored on LUSOLV, see EQCTL.
C Here, we use the local names IVECP, IVECT, IVECU which are thus
C to be seen as overlayed areas. The true vectors IVECC and IVECC2
C are computed on return from this routine, so for a while we use them
C for temporaries.
      IVECP=IVECC
      IVECT=IVECC2
      IVECU=IVECC2


      ITER=0
      RNORM=0.0d0

C Solve equations for the diagonal case, in eigenbasis:
C Current solution vector X, Current residual vector R
      CALL PSCAVEC(-1.0D00,IRHS,IVECR)
      CALL PRESDIA(IVECR,IVECX,OVLAPS)
      IF(MAXIT.EQ.0) THEN
       IF(IPRGLB.GE.TERSE) THEN
        WRITE(6,*)
        WRITE(6,'(23A5)')('-----',i=1,23)
        WRITE(6,*)' DIAGONAL CASPT2 APPROXIMATION:'
        GOTO 900
       END IF
      END IF

C Pre-conditioned conjugate gradient:
C R <- R - (H0-E0)*X
      CALL SIGMA_CASPT2(-1.0D00,1.0D00,IVECX,IVECR)
      CALL POVLVEC(IVECR,IVECR,OVLAPS)
      RNORM=SQRT(OVLAPS(0,0))
      IF(RNORM.LT.THRCONV) GOTO 900
      IF(IPRGLB.GE.USUAL) THEN
       WRITE(6,*)
       WRITE(6,*)'The contributions to the second order'//
     &     ' correlation energy in atomic units.'
       WRITE(6,'(25A5)')('-----',I=1,25)
       WRITE(6,'(2X,A,A)')
     & 'IT.      VJTU        VJTI        ATVX        AIVX        VJAI ',
     & '       BVAT        BJAT        BJAI        TOTAL       RNORM  '
       WRITE(6,'(25A5)')('-----',I=1,25)
      END IF
      CALL PRESDIA(IVECR,IVECP,OVLAPS)
C PCG iteration loops:
C---------------------
 100  CONTINUE
      CALL POVLVEC(IVECP,IVECP,OVLAPS)
      DSCALE=1.0D00/SQRT(OVLAPS(0,0))
      CALL PSCAVEC(DSCALE,IVECP,IVECP)
      CALL POVLVEC(IVECP,IVECR,OVLAPS)
      PR=OVLAPS(0,0)
      CALL SIGMA_CASPT2(1.0D00,0.0D0,IVECP,IVECT)
      CALL POVLVEC(IVECP,IVECT,OVLAPS)
      PT=OVLAPS(0,0)
      ALPHA=PR/PT
      CALL PLCVEC(ALPHA,1.0D00,IVECP,IVECX)
      CALL PLCVEC(-ALPHA,1.0D00,IVECT,IVECR)
      CALL POVLVEC(IVECR,IVECR,OVLAPS)
      RNORM=SQRT(OVLAPS(0,0))
      IF(RNORM.LT.THRCONV) GOTO 900
      ITER=ITER+1
      CALL POVLVEC(IRHS,IVECX,ECORR)
      EVJTU=ECORR(0,1)
      EVJTI=ECORR(0,2)+ECORR(0,3)
      EATVX=ECORR(0,4)
      EAIVX=ECORR(0,5)
      EVJAI=ECORR(0,6)+ECORR(0,7)
      EBVAT=ECORR(0,8)+ECORR(0,9)
      EBJAT=ECORR(0,10)+ECORR(0,11)
      EBJAI=ECORR(0,12)+ECORR(0,13)
      E2NONV=ECORR(0,0)
      IF(IPRGLB.GE.USUAL) THEN
       WRITE(6,'(1X,I3,1X,10F12.6)') ITER,EVJTU,EVJTI,EATVX,EAIVX,
     &                     EVJAI,EBVAT,EBJAT,EBJAI,E2NONV,RNORM
       CALL XFLUSH(6)
      END IF
      IF(ITER.GE.MAXIT) GOTO 800
      CALL PRESDIA(IVECR,IVECU,OVLAPS)
      UR=OVLAPS(0,0)
      BETA=PR/UR
      CALL PLCVEC(BETA,1.0D00,IVECU,IVECP)
      GOTO 100
C---------------------

 800  CONTINUE
      IF(IPRGLB.GE.TERSE) THEN
       WRITE(6,*)
       WRITE(6,*)' NOT CONVERGED AFTER MAX ITERATIONS.'
      END IF
      ICONV = 16
 900  CONTINUE
      IF(IPRGLB.GE.TERSE) THEN
       WRITE(6,'(25A5)')('-----',I=1,25)
       WRITE(6,*)
       WRITE(6,*)' FINAL CASPT2 RESULT:'
      END IF
      CALL POVLVEC(IRHS,IVECX,ECORR)
      EVJTU=ECORR(0,1)
      EVJTI=ECORR(0,2)+ECORR(0,3)
      EATVX=ECORR(0,4)
      EAIVX=ECORR(0,5)
      EVJAI=ECORR(0,6)+ECORR(0,7)
      EBVAT=ECORR(0,8)+ECORR(0,9)
      EBJAT=ECORR(0,10)+ECORR(0,11)
      EBJAI=ECORR(0,12)+ECORR(0,13)
      E2NONV=ECORR(0,0)
      CALL POVLVEC(IVECX,IVECX,OVLAPS)
      DENORM=1.0D0+OVLAPS(0,0)
      REFWGT=1.0D00/DENORM
CPAM Insert: Compute the variational second-order energy.
CPAM Use unshifted H0. Save any shifts, then restore them.
      SAV=SHIFT
      SAVI=SHIFTI
      SHIFT=0.0d0
      SHIFTI=0.0d0
      CALL SIGMA_CASPT2(1.0d0,0.0d0,IVECX,IVECT)
      SHIFT=SAV
      SHIFTI=SAVI
      CALL POVLVEC(IVECX,IVECT,OVLAPS)
      E2CORR=2.0D0*E2NONV+OVLAPS(0,0)
CPAM End of insert.
      ESHIFT=E2CORR-E2NONV
      E2TOT=EREF+E2CORR

      IF(IPRGLB.GT.USUAL) THEN
        WRITE(6,*)
        WRITE(6,*)' Correlation energy /Case, /Symm, and sums:'
        DO IC=1,13
         WRITE(6,'(1X,A8,9F12.8)')
     &      CASES(IC),(ECORR(IS,IC),IS=1,NSYM),ECORR(0,IC)
        END DO
        WRITE(6,'(1X,A8,9F12.8)')
     &    'Summed: ', (ECORR(IS,0),IS=1,NSYM),ECORR(0,0)
      ENDIF

      IF (IPRGLB.GE.TERSE) THEN
         WRITE(6,*)

         If (.not.Input % LovCASPT2) Then
            WRITE(6,'(6x,a,f18.10)')'Reference energy:     ',EREF
            WRITE(6,'(6x,a,f18.10)')'E2 (Non-variational): ',E2NONV
            IF(SHIFT.NE.0.0d0.or.SHIFTI.ne.0.0d0) THEN
              WRITE(6,'(6x,a,f18.10)')'Shift correction:     ',ESHIFT
            END IF
            WRITE(6,'(6x,a,f18.10)')'E2 (Variational):     ',E2CORR
            If (.not.Input % FnoCASPT2) Then
               WRITE(6,'(6x,a,f18.10)')'Total energy:         ',E2TOT
            Else
               WRITE(6,'(6x,a,f18.10,a)')'FNO correction:       ',EMP2,
     &              '   (estimate)   '
               WRITE(6,'(6x,a,f13.5)')
               E2TOT=E2TOT+EMP2
               WRITE(6,'(6x,a,f18.10,a)')'Total energy:         ',E2TOT,
     &              '   (FNO-CASPT2) '
            EndIf
            WRITE(6,'(6x,a,f18.10)')'Residual norm:        ',RNORM
            WRITE(6,'(6x,a,f13.5)') 'Reference weight:     ',REFWGT
         Else
            WRITE(6,'(6x,a,f18.10)')
     &              'Reference energy:                 ',EREF
            WRITE(6,'(6x,a,f18.10)')
     &              'Active-Site E2 (Non-variational): ',E2NONV
            IF(SHIFT.NE.0.0d0.or.SHIFTI.ne.0.0d0) THEN
              WRITE(6,'(6x,a,f18.10)')
     &              'Shift correction:                 ',ESHIFT
            END IF
            WRITE(6,'(6x,a,f18.10)')
     &              'Active-Site E2 (Variational):     ',E2CORR
            WRITE(6,'(6x,a,f18.10)')
     &              'Frozen region E2 :                ',EMP2
            WRITE(6,'(6x,a,f18.10)')
     &              'Residual norm:                    ',RNORM
            WRITE(6,'(6x,a,f13.5)')
     &              'Reference weight:                 ',REFWGT
            WRITE(6,'(6x,a,f13.5)')
            E2TOT=E2TOT+EMP2
            WRITE(6,'(6x,a,f18.10)')
     &              'Total energy (LovCASPT2):         ',E2TOT
         EndIf
      END IF

* In automatic verification calculations, the precision is lower
* in case of Cholesky calculation.
      LAXITY=8
      IF(IfChol) LAXITY=Cho_X_GetTol(LAXITY)
      Call Add_Info('E_CASPT2',[E2TOT],1,LAXITY)

      IF(IPRGLB.GE.USUAL) THEN
       WRITE(6,*)
       WRITE(6,'(6x,a)')
     &  'Contributions to the CASPT2 correlation energy'
       WRITE(6,'(6x,a,F18.10)')
     &  'Active & Virtual Only:    ',EATVX+EBVAT
       WRITE(6,'(6x,a,F18.10)')
     &  'One Inactive Excited:     ',EVJTU+EAIVX+EBJAT
       WRITE(6,'(6x,a,F18.10)')
     &  'Two Inactive Excited:     ',EVJTI+EVJAI+EBJAI
       WRITE(6,*)
      END IF
      CALL GETMEM('LISTS','FREE','INTE',LLISTS,NLSTOT)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine exth5 (a,b,dimp,dimq,dimqr,q)
c
c     this routine extract A(p,qr) -> B_q(p,r)
c
c     a     - matrxi a (Input)
c     b     - matrix b (Output)
c     dimp  - dimension of p (Input)
c     dimq  - dimension of q (and also r) (Input)
c     dimqr - dimension of qr (Input)
c     q     - value of index q (Input)
c
#include "t31.fh"
       integer dimp,dimq,dimqr,q
       real*8 a(1:dimp,1:dimqr)
       real*8 b(1:dimp,dimq)
c
c     help variables
c
       integer r,p,rq,qr0,qr
c
       if (q.eq.0) then
       return
       end if
c
c     r>q part
       if (q.gt.1) then
       qr0=nshf(q)
       do 20 r=1,q-1
       qr=qr0+r
       do 21 p=1,dimp
       b(p,r)=a(p,qr)
 21     continue
 20     continue
       end if
c
c     r=q part
       do 40 p=1,dimp
       b(p,q)=0.0d0
 40     continue
c
c     r<p part
       if (q.lt.dimq) then
       do 60 r=q+1,dimq
       rq=nshf(r)+q
       do 61 p=1,dimp
       b(p,r)=-a(p,rq)
 61     continue
 60     continue
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE get_Umn(PHP,EnIn,DHAM,
     &                   IPCSF,IPCNF,MXPDIM,
     &                   DTOC,IPRODT,ICONF,
     &                   IREFSM,ONEBOD,ECORE,NACTOB,
     &                   NCONF,NEL,NAEL,NBEL,
     &                   NPCSF,NPCNF,DIAG,TUVX,
     &                   iterSplit,ITER,
     &                   NTEST,ExFac,IREOTS)
C
C     ARGUMENTS :
C     ===========
C     PHP    : AA Block Hamiltonian un-dressed                  (Output)
C     EnIn   : energy value of the root selected                (Input)
C     DHAM   : Dressed AA block Hamiltonian                     (Output)
C     IPCSF  : CSF's order - Index Array -                      (Input)
C     IPCNF  : CNF's order - Index Array -                      (Input)
C     MXPDIM : Total number of CSFs                             (Input)
C     DTOC   : Transformation matrix between CSF's and DET's    (input)
C     IPRODT : Prototype determinants                           (input)
C     ICONF  : List of configurations                           (input)
C     IREFSM : symmetry of considered CI space                  (input)
C     Onebod : one body hamilton matrix in rectangular form     (input)
C     ECORE  : Core energy                                      (input)
C     NACTOB : Number of active orbitals                        (input)
C     NCONF  : Number of CNFs of symmetry IREFSM                (Input)
C     NEL    : total number of active electrons                 (input)
C     NAEL   : number of alpha active electron                  (input)
C     NBEL   : number of beta active electron                   (input)
C     NPCSF  : Number of CSFs in AA block                       (Input)
C     NPCNF  : Number of CNFs in AA block                       (Input)
C     DIAG   : Hamilton diagonal over CSF's                     (Input)
C     TUVX   : Two-electron integrals (MO space)                (Input)
C     NTEST  :
C     ExFac  :
C     IREOTS : Type => symmetry reordering array
C
      IMPLICIT REAL*8 (A-H,O-Z)

#include "spinfo.fh"
#include "WrkSpc.fh"

      DIMENSION PHP(NPCSF*(NPCSF+1)/2),DHAM(NPCSF*(NPCSF+1)/2)
      DIMENSION IPCSF(*),IPCNF(*),DIAG(*)
      DIMENSION DTOC(*),IPRODT(*),ICONF(*)
      DIMENSION ONEBOD(*)
      DIMENSION TUVX(*), IREOTS(*)

      IF( NTEST.GE.30 ) THEN
        WRITE(6,*) ' Input in get_Umn '
        WRITE(6,*) ' ================== '
        WRITE(6,*)
     &  ' Number of CNFs ',NCONF
        WRITE(6,*)
     &  ' Number of CSFs ',MXPDIM
        WRITE(6,*) ' Configurations included : '
        CALL IWRTMA(IPCNF,1,NCONF,1,NCONF)
        WRITE(6,*) ' CSFs included : '
        CALL IWRTMA(IPCSF,1,MXPDIM,1,MXPDIM)
        write(6,*) ' Number of CNFs in AA block:',NPCNF
        write(6,*) ' Number of CSFs in AA block:',NPCSF
      END IF

      Call FZero(DHAM,NPCSF*(NPCSF+1)/2)
* construct the Dressed Hamiltonian matrix
      MXCSFC = 0
      DO ITYP = 1, NTYP
        MXCSFC = MAX(MXCSFC,NCSFTP(ITYP))
      END DO
*      write(6,*) 'MXCSFC = ', MXCSFC
      IBblockV = MXPDIM-NPCSF
      call getmem('AuxDia','ALLO','REAL',ipAuxD,MXCSFC)
      call getmem('AuxVer', 'ALLO','REAL',ipAuxV, MXCSFC*NPCSF)
      call getmem('AuxCopy','ALLO','REAL',ipAuxC, MXCSFC*NPCSF)
      CALL GETMEM('EXHSCR','MAX','REAL',LW2,MXXWS)
      MXXWS = MXXWS/2
      CALL GETMEM('EXHSCR','ALLO','REAL',LW2,MXXWS)

      KACONF = LW2
      KLCONF = KACONF+NEL
      KRCONF = KLCONF+NEL
      KLAUXD = KRCONF+NEL
      KLPHPS = KLAUXD+MXCSFC*MXCSFC
      KLFREE = KLPHPS+MXCSFC*MXCSFC

C Shape of PHP matrix:
C
C           CNFL (n)
C
C      1  2  4  7 11 16 22 ...
C  C   -  3  5  8 12 17 23 ...
C  N   -  -  6  9 13 18 24 ...
C  F   -  -  - 10 14 19 25 ...
C  R   -  -  -  - 15 20 26 ...
C (m)  -  -  -  -  - 21 27 ...
C      -  -  -  -  -  - 28 ...
C      -  -  -  -  -  -  - ...

************************************************************************
* Now a loop over alpha will start to calculate:                       *
*   1) BB-Block DIAGONAL element 1/(En-H(alpha,alpha))                 *
*   2) AB-Block array H(m,alpha)
************************************************************************
      if (ITER.eq.1.and.iterSplit.eq.1) goto 29555
      IIAB = 1
      Do iAlpha = NPCNF+1,NCONF
*     ^ Loop over alpha
        Call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
*        write(6,*)'iAlpha = ', iAlpha
        iKACONF=ip_of_iWork_d(Work(KACONF))
        CALL GETCNF_LUCIA(iWork(iKACONF),IATYP,IPCNF(iAlpha),
     &                    ICONF,IREFSM,NEL)
        NCSFA = NCSFTP(IATYP)
*        write(6,*)'NCSFA = ', NCSFA
        iKACONF=ip_of_iWork_d(Work(KACONF))
        CALL CNHCN(iWork(iKACONF),IATYP,iWork(iKACONF),
     &             IATYP,Work(KLAUXD),Work(KLFREE),
     &             NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,
     &             NTEST,ExFac,IREOTS)
        DO IIA = 1, NCSFA
          ILAI = IIA*IIA
          IF( NTEST.GE.30 ) write(6,*)'ILAI =', ILAI
*          Work(ipAuxD+IIA-1) = Work(KLAUXD+ILAI-1)
*          write(6,*) 'Work(ipAuxD+IIA-1)',Work(ipAuxD+IIA-1)
          Work(ipAuxD+IIA-1) = 1.0d0/
     &                           (EnIn-Work(KLAUXD+ILAI-1))
          IF( NTEST.GE.30 )
     &         write(6,*) 'Work(ipAuxD+IIA-1)',Work(ipAuxD+IIA-1)
        END DO
****************** 2) AB-Block Array (alpha Column) ********************
        IILB = 1
        do Mindex = 1, NPCNF
*       ^ Loop over AB-Block
          Call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
*          write(6,*)'Mindex',Mindex
          iKLCONF=ip_of_iWork_d(Work(KLCONF))
          CALL GETCNF_LUCIA(iWork(iKLCONF),ILTYP,IPCNF(Mindex),
     &                      ICONF,IREFSM,NEL)
          NCSFL = NCSFTP(ILTYP)
*          write(6,*)'NCSFL = ', NCSFL
          iKACONF=ip_of_iWork_d(Work(KACONF))
          iKLCONF=ip_of_iWork_d(Work(KLCONF))
          CALL CNHCN(iWork(iKACONF),IATYP,iWork(iKLCONF),
     &               ILTYP,Work(KLAUXD),Work(KLFREE),
     &               NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,
     &               NTEST,ExFac,IREOTS)
          IF( NTEST.GE.30 ) then
            write(6,*)'M_Alpha elements'
            call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
          end if
          DO IIL = 1, NCSFL
            DO IIA = 1, NCSFA
              IILACT = IILB-1+IIL
              IIAACT = NPCSF*(IIA-1)
              ILAI = (IIL-1)*NCSFA+IIA
*             ILAI = (IIA-1)*MXCSFC+IIL
*             ILAI = (IIL-1)*MXCSFC+IIA
              ILAOV = IILACT+IIAACT
              Work(ipAuxV+ILAOV-1) = Work(KLAUXD+ILAI-1)
*              write(6,*)'ILAI, ILAOV =', ILAI,ILAOV
              IF( NTEST.GE.30 )
     &         write(6,*) 'Work(ipAuxV+ILAOV-1)',Work(ipAuxV+ILAOV-1)
              Work(ipAuxC+ILAOV-1) = Work(ipAuxV+ILAOV-1)*
     &                               Work(ipAuxD+IIA-1)
              IF( NTEST.GE.30 )
     &            write(6,*) 'Work(ipAuxC+ILAOV-1)',Work(ipAuxC+ILAOV-1)
            END DO
          END DO
          IILB = IILB + NCSFL
        end do
*       ^ End loop over AB-Block
        IF( NTEST.GE.30 ) then
          write(6,*)'AB-Block Vertical Vector'
          call wrtmat(Work(ipAuxV),NPCSF,NCSFA,NPCSF,NCSFA)
          write(6,*)'AB-Block Vertical Vector times Daa'
          call wrtmat(Work(ipAuxC),NPCSF,NCSFA,NPCSF,NCSFA)
        end if
************************************************************************
        call dGeMM_Tri('N','T',NPCSF,NPCSF,NCSFA,
     &                   1.0d0,Work(ipAuxC),NPCSF,
     &                         Work(ipAuxV),NPCSF,
     &                   1.0d0,DHAM,NPCSF)
        IF( NTEST.GE.30 )
     &        call TRIPRT('correction to the AA block',' ',DHAM,NPCSF)
        IIAB = IIAB + NCSFA
      End Do
*     ^ End of the loop over iAlpha
************************************************************************
*    1. A-Block matrix element                                         *
************************************************************************
29555 continue
      IILB = 1
      do Nindex = 1, NPCNF
*     ^ Loop over the AA-block (vertical index)
        IF( NTEST.GE.30 ) write(6,*)'Nindex',Nindex
*       write(6,*)'IILB',IILB
        iKLCONF=ip_of_iWork_d(Work(KLCONF))
        CALL GETCNF_LUCIA(iWork(iKLCONF),ILTYP,IPCNF(Nindex),ICONF,
     &                    IREFSM,NEL)
        NCSFL = NCSFTP(ILTYP)
*        write(6,*)'NCSFL = ', NCSFL

        IIRB = 1
        do Mindex = 1, Nindex
*       ^ Loop over the AA-block (horizontal index)
          Call FZero(Work(KLPHPS),MXCSFC*MXCSFC)
*          write(6,*)'Nindex,Mindex', Nindex,Mindex
          iKRCONF=ip_of_iWork_d(Work(KRCONF))
          CALL GETCNF_LUCIA(iWork(iKRCONF),IRTYP,IPCNF(Mindex),
     &                      ICONF,IREFSM,NEL)
          NCSFR = NCSFTP(IRTYP)
*          write(6,*)'NCSFR = ', NCSFR
          iKLCONF=ip_of_iWork_d(Work(KLCONF))
          iKRCONF=ip_of_iWork_d(Work(KRCONF))
          CALL CNHCN(iWork(iKLCONF),ILTYP,iWork(iKRCONF),IRTYP,
     &               Work(KLPHPS),Work(KLFREE),NAEL,NBEL,
     &               ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,NTEST,
     &               ExFac,IREOTS)
          IF( NTEST.GE.30 ) then
            write(6,*)'AA block elements'
            call wrtmat(Work(KLPHPS),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
          End if
          DO IIL = 1, NCSFL
            IF(IILB.EQ.IIRB) THEN
              IIRMAX = IIL
            ELSE
              IIRMAX = NCSFR
            END IF
            DO IIR = 1, IIRMAX
              IIRACT = IIRB-1+IIR
              IILACT = IILB-1+IIL
*             ILRI = (IIR-1)*MXCSFC+IIL
              ILRI = (IIR-1)*NCSFL+IIL
*             ^ Forse questo e' quello giusto; la precedente formula
*               potrebbe essere fonte di BUGS! Vedremo!
              ILRO = ((IILACT*IILACT-IILACT)/2)+IIRACT
              PHP(ILRO) = Work(KLPHPS+ILRI-1)
*              write(6,*)'ILRI, ILRO =', ILRI,ILRO
*              write(6,*) 'PHP(ILRO)',PHP(ILRO)
            END DO
          END DO
          IIRB = IIRB + NCSFR
        end do
*       ^End loop over the AA-block (horizontal index)
        IILB = IILB + NCSFL
      end do
*     ^End loop over the AA-block (vertical index)

************************************************************************
* Let's add Hmn (PHP) to the correction (DHAM)
          call daxpy_(NPCSF*(NPCSF+1)/2,1.0d0,PHP,1,DHAM,1)
************************************************************************
      IF( NTEST.GE.30 ) then
        write(6,*)'AA-Block matrix un-dressed'
        call wrtmat(PHP,NPCSF*(NPCSF+1)/2,1,NPCSF*(NPCSF+1)/2,1)
        write(6,*)'AA-Block matrix dressed'
        call wrtmat(DHAM,NPCSF*(NPCSF+1)/2,1,NPCSF*(NPCSF+1)/2,1)
      end if

      IF( NTEST.GE.30 ) then
        call TRIPRT('AA block Hamiltonian Matrix un-dressed',' ',
     &              PHP,NPCSF)
        call TRIPRT('Dressed AA block Hamiltonian Matrix',' ',
     &              DHAM,NPCSF)
      END IF
      CALL GETMEM('EXHSCR','FREE','REAL',LW2,MXXWS)
      call getmem('AuxCopy','FREE','REAL',ipAuxC,MXCSFC*NPCSF)
      call getmem('AuxVer', 'FREE','REAL',ipAuxV, MXCSFC*NPCSF)
      call getmem('AuxDia', 'FREE','REAL',ipAuxD,MXCSFC)

      RETURN
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(DIAG)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

subroutine WRTTTS(BLOCKS,IBLOCK,NBLOCK,NSMST,NSASO,NSBSO,ISC)
! Print a batch of TTS blocks as given by IBLOCK
!
! ISC = 1 : In slater determinant form
! ISC = 2 : In Combination        form
!
! Jeppe Olsen, August 1995

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: BLOCKS(*)
integer(kind=iwp), intent(in) :: NBLOCK, IBLOCK(8,NBLOCK), NSMST, NSASO(NSMST,*), NSBSO(NSMST,*), ISC
integer(kind=iwp) :: IASM, IATP, IBSM, IBTP, IOFF, IPACK, JBLOCK, NELMNT, NIA, NIB

write(u6,*) ' Batch of blocks'
write(u6,*) ' ==============='
write(u6,*)
write(u6,'(A,I4)') ' Number of blocks in batch ',NBLOCK

do JBLOCK=1,NBLOCK

  IATP = IBLOCK(1,JBLOCK)
  IBTP = IBLOCK(2,JBLOCK)
  IASM = IBLOCK(3,JBLOCK)
  IBSM = IBLOCK(4,JBLOCK)
  if (IBLOCK(1,JBLOCK) > 0) then

    if (ISC == 1) then
      IOFF = IBLOCK(5,JBLOCK)
    else
      IOFF = IBLOCK(6,JBLOCK)
    end if

    ! Is this block diagonal
    if ((ISC == 2) .and. (IASM == IBSM) .and. (IATP == IBTP)) then
      IPACK = 1
    else
      IPACK = 0
    end if
    NIA = NSASO(IASM,IATP)
    NIB = NSBSO(IBSM,IBTP)
    !write(u6,*) ' iatp ibtp iasm ibsm nia nib ',iatp,ibtp,iasm,ibsm,nia,nib

    if (IPACK == 1) then
      NELMNT = nTri_Elem(NIA)
      if (NELMNT /= 0) then
        write(u6,'(A,3I3)') '  Iasm iatp ibtp : ',IASM,IATP,IBTP
        write(u6,'(A)') '  ============================'
        call PRSM2(BLOCKS(IOFF),NIA)
      end if
    else
      NELMNT = NIA*NIB
      if (NELMNT /= 0) then
        write(u6,'(A,3I3)') '  Iasm iatp ibtp : ',IASM,IATP,IBTP
        write(u6,'(A)') '  ============================'
        call WRTMAT(BLOCKS(IOFF),NIA,NIB,NIA,NIB)
      end if
    end if

  end if
end do

end subroutine WRTTTS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Roland Lindh                                     *
*               2009, Grigory A. Shamov                                *
************************************************************************
      Subroutine B2PLYP(mGrid,Rho,nRho,P2_ontop,
     &                  nP2_ontop,iSpin,F_xc,
     &                  dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
************************************************************************
*                                                                      *
* Object:   DFT part for the Grimme's double hybrud functional.        *
*         requires (manual?) scaling of the &mbpt2 correlation energy! *
*         Grimme S., J. Chem.Phys 124(2006) 034108                     *
*                                                                      *
*      Author: Template by Roland Lindh, Department of Chemical Physi  *
*             of Lund, SWEDEN. March 2001                              *
*              Grigory A Shamov, University of Manitoba, 2009          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "ksdft.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),
     &       P2_ontop(nP2_ontop,mGrid), F_xc(mGrid),
     &       dF_dP2ontop(ndF_dP2ontop,mGrid)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
      Coeff_A=0.470D0*CoefX
      Coeff_B=0.0000*CoefX
      Coeff_C=0.73D0*CoefR
C    requires 0.27 times MP2 correlation energy from MBPT2
*                                                                      *
*---- Dirac Exchange Functional                                        *
*                                                                      *
      Call Diracx(mGrid,Rho,nRho,
     &            iSpin,F_xc,dF_dRho,
     &            ndF_dRho,Coeff_A,T_X)
*                                                                      *
*---- Becke 88 Exchange Functional                                     *
*                                                                      *
      Call xB88(Rho,nRho,mGrid,
     &          dF_dRho,ndF_dRho,
     &          Coeff_A,iSpin,F_xc,T_X)
*                                                                      *
*---- Vosko-Wilk-Nusair Correlation Functional V                       *
*                                                                      *
C--      Call VWN_V(mGrid,Rho,nRho,
C--     &           iSpin,F_xc,dF_dRho,
C--     &           ndF_dRho,CoefR-Coeff_C,T_X)
*                                                                      *
*---- Lee-Yang-Parr Correlation Functional                             *
*                                                                      *
      Call LYP(Rho,nRho,mGrid,
     &         dF_dRho,ndF_dRho,
     &         Coeff_C,iSpin,F_xc,T_X)
*                                                                      *
************************************************************************
*                                                                      *
C
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(P2_ontop)
         Call Unused_real_array(dF_dP2ontop)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine NewCar_Kriging(kIter,SaveBMx,Error)
      use Slapaf_Info, only: Cx, BMx
      use Slapaf_Parameters, only: PrQ, Numerical, mTtAtm, Force_dB
      Implicit None
#include "stdalloc.fh"
      Integer :: kIter
      Logical :: SaveBMx, Error

      Real*8, Allocatable :: Coor(:,:), BMx_Tmp(:,:)
      Logical :: Numerical_Save,PrQ_Save
*
      Call mma_allocate(Coor,3,SIZE(Cx,2),Label='Coor')
      Coor(:,:) = Cx(:,:,kIter)

      Call mma_allocate(BMx_tmp,SIZE(BMx,1),SIZE(BMx,2),Label='BMx_tmp')
      BMx_tmp(:,:) = BMx(:,:)
*
      Numerical_Save=Numerical
      PrQ_Save=PrQ
      Numerical=.False.
      PrQ_Save=PrQ
      PrQ=.False.
*
      Force_dB=SaveBMx
*
      Call NewCar(kIter,SIZE(Coor,2),Coor,mTtAtm,Error)
*
      Numerical=Numerical_Save
      PrQ=PrQ_Save
      Force_dB=.False.
      Call mma_deallocate(Coor)

      If (.NOT.SaveBMx) Then
         Call mma_deallocate(BMx)
         Call mma_allocate(BMx,SIZE(BMx_tmp,1),SIZE(BMx_Tmp,2),
     &                     Label='BMx')
         BMx(:,:) = BMx_tmp(:,:)
      End If

      Call mma_deallocate(BMx_tmp)
*
      End Subroutine NewCar_Kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_1VecRd_SP(Vec,lVec,jVec,iSym,LstSP,nSP,iRedC,
     &                         iLoc)
C
C     Purpose: read vector jVec, sym. iSym, from disk. Read only
C              components from shell pairs in list LstSP. Use scratch
C              location iLoc to set index arrays. On input, iRedC
C              specifies the reduced set available at location iLoc:
C              specify -1 if not set (or unknown). On exit, iRedC
C              identifies the reduced set for which indices are
C              available at location iLoc. NOTE: only WA files!!
C
      Implicit Real*8 (a-h,o-z)
      Real*8  Vec(lVec)
      Integer LstSP(nSP)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Character*13 SecNam
      Parameter (SecNam = 'Cho_1VecRd_SP')

      Parameter (N2 = InfVec_N2)

      Integer  Cho_P_LocalSP
      External Cho_P_LocalSP

      InfVec(i,j,k)=iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
      iiBstRSh(i,j,k)=iWork(ip_iiBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      nnBstRSh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)

C     Return if no vectors are available on disk.
C     -------------------------------------------

      If (NumCho(iSym) .lt. 1) Return

C     Check that vector storage mode is word-addressable (WA).
C     --------------------------------------------------------

      If (Cho_AdrVec .ne. 1) Then
         Write(Lupri,*) SecNam,': WA address mode is required!'
         Write(Lupri,*) 'Cho_AdrVec is: ',Cho_AdrVec,
     &                  ' (should be 1)'
         Call Cho_Quit('WA address mode is required in '//SecNam,104)
      End If

C     Get reduced set of this vector.
C     -------------------------------

      If (jVec.gt.0 .and. jVec.le.NumCho(iSym)) Then
         iRed = InfVec(jVec,2,iSym)
      Else
         Call Cho_Quit('Red. set error in '//SecNam,104)
         iRed = -999999
      End If

C     Set reduced set (if needed).
C     ----------------------------

      If (iRedC .ne. iRed) Then
         Call Cho_X_SetRed(irc,iLoc,iRed)
         If (irc .ne. 0) Then
            Write(Lupri,*) SecNam,': Cho_X_SetRed returned ',irc
            Call Cho_Quit('Error in '//SecNam,104)
         End If
         iRedC = iRed
      End If

C     Read vector elements.
C     ---------------------

      iAdr0 = InfVec(jVec,3,iSym)
      kV = 1
      Do iSP = 1,nSP
         iShlAB = Cho_P_LocalSP(LstSP(iSP))
         iOpt = 2
         lTot = nnBstRSh(iSym,iShlAB,iLoc)
         iAdr = iAdr0 + iiBstRSh(iSym,iShlAB,iLoc)
         Call dDAFile(LuCho(iSym),iOpt,Vec(kV),lTot,iAdr)
         kV = kV + lTot
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cortab(binom,dfac,eps,lmf,lml,lmx,lmy,lmz,lmax,lmn1u,ndfac,zlm)
! Tables for core potential and spin-orbit integrals.

use ppint_arrays, only: hpt, hwt
use stdalloc, only: mma_allocate
use Constants, only: Zero, One, Three
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lmax, lmn1u, ndfac
#define _LSIZE_ ((lmax*(lmax+2)*(lmax+4)/3)*(lmax+3)+(lmax+2)**2*(lmax+4))/16
real(kind=wp), intent(out) :: binom(lmn1u*(lmn1u+1)/2), dfac(ndfac), &
                              zlm(_LSIZE_)
real(kind=wp), intent(in) :: eps
integer(kind=iwp), intent(out) :: lmf((lmax+1)**2), lml((lmax+1)**2), &
                                  lmx(_LSIZE_), &
                                  lmy(_LSIZE_), &
                                  lmz(_LSIZE_)
integer(kind=iwp) :: i, igh, il, indexh, inew, ione, isig, isigm, isigma, itwo, iu, j, k, lang, lone, ltwo, mang, nn, nsigma, &
                     nterm, nxy
real(kind=wp) :: aden, anum, coef, coef1, coef2, fi

! Compute Gauss-Hermite points and weights for c, z integrals.
igh = 1
nn = 5
call mma_allocate(hpt,nn*(2**3-1),label='hpt')
call mma_allocate(hwt,nn*(2**3-1),label='hwt')
do i=1,3
  call hermit(nn,hpt(igh),hwt(igh),eps)
  igh = igh+nn
  nn = 2*nn
end do
! Compute double factorials.
dfac(1) = One
dfac(2) = One
fi = Zero
do i=1,ndfac-2
  fi = fi+One
  dfac(i+2) = fi*dfac(i)
end do
! Compute binomial coefficients.
inew = 1
binom(1) = One
do j=1,lmn1u-1
  inew = inew+1
  binom(inew) = One
  do i=1,j-1
    inew = inew+1
    binom(inew) = real(j-i+1,kind=wp)*binom(inew-1)/real(i,kind=wp)
  end do
  inew = inew+1
  binom(inew) = One
end do
! Compute tables by recursion for real spherical harmonics. They
! are indexed by l, m and sigma. The sequence number of the
! harmonic with quantum numbers l, m and sigma is given by
!     l**2+2*m+1-sigma
! lmf(index) and lml(index) hold the positions of the first and
! last terms of the harmonic in the lmx, lmy, lmz, and zlm arrays.
! The harmonics with angular momentum l are generated from those
! with angular momenta l-1 and l-2.
! For m = 0,1,2,...,l-1, the recursion relation
!     z*Z(l-1,m,s) = sqrt(((l-m)*(l+m))/((2*l-1)*(2*l+1)))*Z(l,m,s)+
!                    sqrt(((l+m-1)*(l-m-1))/((2*l-3)*(2*l-1)))*Z(l-2,m,s)
! is used.
! For m = l, the recursion relation
!     x*Z(l-1,l-1,s)+(-1)**(1-s)*y*Z(l-1,l-1,1-s) = sqrt((2*l))/((2*l+1)))*Z(l,l,s)
! is used.

! l=0
lmf(1) = 1
lml(1) = 1
lmx(1) = 0
lmy(1) = 0
lmz(1) = 0
zlm(1) = One
! l=1
lmf(2) = 2
lml(2) = 2
lmx(2) = 0
lmy(2) = 0
lmz(2) = 1
zlm(2) = sqrt(Three)
lmf(3) = 3
lml(3) = 3
lmx(3) = 0
lmy(3) = 1
lmz(3) = 0
zlm(3) = zlm(2)
lmf(4) = 4
lml(4) = 4
lmx(4) = 1
lmy(4) = 0
lmz(4) = 0
zlm(4) = zlm(2)
nterm = 4
do lang=2,lmax
  do mang=0,lang-1
    anum = real((2*lang-1)*(2*lang+1),kind=wp)
    aden = real((lang-mang)*(lang+mang),kind=wp)
    coef1 = sqrt(anum/aden)
    anum = real((lang+mang-1)*(lang-mang-1)*(2*lang+1),kind=wp)
    aden = real(2*lang-3,kind=wp)*aden
    coef2 = sqrt(anum/aden)
    nsigma = min(1,mang)
    do isigma=nsigma,0,-1
      indexh = lang**2+2*mang+1-isigma
      lone = lang-1
      ltwo = lang-2
      ione = lone**2+2*mang+1-isigma
      itwo = ltwo**2+2*mang+1-isigma
      lmf(indexh) = lml(indexh-1)+1
      lml(indexh) = lml(indexh-1)
      nxy = (mang-isigma+2)/2
      iu = lmf(ione)+nxy-1
      do i=lmf(ione),iu
        lml(indexh) = lml(indexh)+1
        j = lml(indexh)
        lmx(j) = lmx(i)
        lmy(j) = lmy(i)
        lmz(j) = lmz(i)+1
        zlm(j) = zlm(i)*coef1
        nterm = nterm+1
      end do
      if (ltwo >= mang) then
        il = iu+1
        do i=il,lml(ione)
          lml(indexh) = lml(indexh)+1
          j = lml(indexh)
          k = lmf(itwo)+i-il
          lmx(j) = lmx(k)
          lmy(j) = lmy(k)
          lmz(j) = lmz(k)
          zlm(j) = zlm(i)*coef1-zlm(k)*coef2
          nterm = nterm+1
        end do
        il = lml(itwo)-nxy+1
        if (mod(lang-mang,2) == 0) then
          do i=il,lml(itwo)
            lml(indexh) = lml(indexh)+1
            j = lml(indexh)
            lmx(j) = lmx(i)
            lmy(j) = lmy(i)
            lmz(j) = lmz(i)
            zlm(j) = -zlm(i)*coef2
            nterm = nterm+1
          end do
        end if
      end if
    end do
  end do
  anum = real(2*lang+1,kind=wp)
  aden = real(2*lang,kind=wp)
  coef = sqrt(anum/aden)
  mang = lang
  isigma = 1
  indexh = lang**2+2*mang+1-isigma
  lmf(indexh) = lml(indexh-1)+1
  lml(indexh) = lml(indexh-1)
  ! isig:  index of the harmonic (l-1),(m-1),sigma
  ! isigm: index of the harmonic (l-1),(m-1),(1-sigma)
  isig = (lang-1)**2+2*(mang-1)+1-isigma
  isigm = (lang-1)**2+2*(mang-1)+isigma
  k = lmf(isigm)
  do i=lmf(isig),lml(isig)
    lml(indexh) = lml(indexh)+1
    j = lml(indexh)
    lmx(j) = lmx(i)+1
    lmy(j) = lmy(i)
    lmz(j) = lmz(i)
    zlm(j) = (zlm(i)+zlm(k))*coef
    k = k+1
    nterm = nterm+1
  end do
  if (mod(mang,2) == 1) then
    lml(indexh) = lml(indexh)+1
    j = lml(indexh)
    lmx(j) = lmx(k)
    lmy(j) = lmy(k)+1
    lmz(j) = lmz(k)
    zlm(j) = zlm(k)*coef
    nterm = nterm+1
  end if
  isigma = 0
  indexh = lang**2+2*mang+1-isigma
  ! isig:  index of the harmonic (l-1),(m-1),sigma
  ! isigm: index of the harmonic (l-1),(m-1),(1-sigma)
  isig = (lang-1)**2+2*(mang-1)+1-isigma
  isigm = (lang-1)**2+2*(mang-1)+isigma
  lmf(indexh) = lml(indexh-1)+1
  lml(indexh) = lmf(indexh)
  j = lml(indexh)
  i = lmf(isig)
  lmx(j) = lmx(i)+1
  lmy(j) = lmy(i)
  lmz(j) = lmz(i)
  zlm(j) = zlm(i)*coef
  nterm = nterm+1
  k = lmf(isigm)
  do i=lmf(isig)+1,lml(isig)
    lml(indexh) = lml(indexh)+1
    j = lml(indexh)
    lmx(j) = lmx(i)+1
    lmy(j) = lmy(i)
    lmz(j) = lmz(i)
    zlm(j) = (zlm(i)-zlm(k))*coef
    k = k+1
    nterm = nterm+1
  end do
  if (mod(mang,2) == 0) then
    lml(indexh) = lml(indexh)+1
    j = lml(indexh)
    k = lml(isigm)
    lmx(j) = lmx(k)
    lmy(j) = lmy(k)+1
    lmz(j) = lmz(k)
    zlm(j) = -zlm(k)*coef
    nterm = nterm+1
  end if
end do
!ixy = 0
!iz = 0
!do lang=1,lproju
!  do mang=0,lang-1
!    nsigma = min(1,mang)
!    ndelta = max(0,1-mang)
!    anum = real((lang-mang)*(lang+mang+1),kind=wp)
!    aden = real(2*(2-ndelta),kind=wp)
!    coef = sqrt(anum/aden)
!    do isigma=nsigma,0,-1
!      i_sign = 2*isigma-1
!      ixy = ixy+1
!      flmtx(1,ixy) = real(i_sign,kind=wp)*coef
!      flmtx(2,ixy) = coef
!      if (mang /= 0) then
!        iz = iz+1
!        flmtx(3,iz) = -real(mang*isigma,kind=wp)
!      end if
!    end do
!  end do
!  iz = iz+1
!  flmtx(3,iz) = -real(lang,kind=wp)
!end do
! Column and row indices for angular momentum matrix elements.
!iadd = 1
!do i=1,2*lproju-1
!  mc(1,i) = i
!  mc(2,i) = i
!  mc(3,i) = i+1
!  mr(1,i) = i+iadd
!  mr(2,i) = i+2
!  mr(3,i) = i+2
!  iadd = 4-iadd
!end do

return

end subroutine cortab

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine fx_cvb(fx,fast)
! FAST=.TRUE. :     Quick evaluation of f(x) --
!                   no reusable quantities
! FAST=.FALSE.:     Slower evaluation of f(x) --
!                   but with reusable quantities
!                   (CIVECP/CIVBH & CIVBS)

use casvb_global, only: civb1, civb2, civb3, civb4, civb6, civb7, civb8, cvb, cvbdet, dxmove, icnt_ci, icrit, memplenty, orbs
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: fx
logical(kind=iwp), intent(in) :: fast

dxmove = .true.
if (.not. memplenty) then
  call ciwr_cvb(civb2,61002.2_wp)
  call ciwr_cvb(civb3,61003.2_wp)
  call ciwr_cvb(civb4,61004.2_wp)
  icnt_ci(2:4) = 0
end if
icnt_ci(6:8) = 0
if (icrit == 1) then
  call fx_svb1_cvb(fx,fast,orbs,cvb,civb1,civb6,civb7,civb8,cvbdet)
else if (icrit == 2) then
  call fx_evb1_cvb(fx,fast,orbs,cvb,civb1,civb6,civb7,civb8,cvbdet)
end if
if (.not. memplenty) then
  call ciwr_cvb(civb6,61006.2_wp)
  call ciwr_cvb(civb7,61007.2_wp)
  call ciwr_cvb(civb8,61008.2_wp)
  call cird_cvb(civb2,61002.2_wp)
  call cird_cvb(civb3,61003.2_wp)
  call cird_cvb(civb4,61004.2_wp)
end if
! Figure out what we just calculated, and make it up2date:
if (dxmove) then
  if (icrit == 1) then
    call make_cvb('SVB')
  else if (icrit == 2) then
    call make_cvb('EVB')
  end if
else
  if (icrit == 1) then
    call make_cvb('SVBTRY')
  else if (icrit == 2) then
    call make_cvb('EVBTRY')
  end if
end if

return

end subroutine fx_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function D1Mach(I)
! DOUBLE-PRECISION MACHINE CONSTANTS
!
! D1MACH(1) = B**(EMIN-1), THE SMALLEST POSITIVE MAGNITUDE.
!
! D1MACH(4) = B**(1-T), THE LARGEST RELATIVE SPACING.

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: D1Mach
integer(kind=iwp), intent(in) :: I
real(kind=wp) :: eps, xmin, xmax
! PAM 2008 These declarations should be used with machar
!real(kind=wp) :: epsneg
!integer(kind=iwp) :: ibeta, it, irnd, ngrd, machep, negep, iexp, minexp, maxexp

! PAM 2008 Do not use machar any more. Try hardcoded values:
!call machar(ibeta,it,irnd,ngrd,machep,negep,iexp,minexp,maxexp,eps,epsneg,xmin,xmax)
eps = 1.0e-15_wp
xmin = 1.0e-300_wp
xmax = 1.0e+300_wp

if (I == 1) then
  D1Mach = xmin
else if (I == 2) then
  D1Mach = xmax
else if (I == 4) then
  D1Mach = eps
else
  D1Mach = -One
end if

return

end function D1Mach

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Bend(xyz,nCent,Fir,Bf,lWrite,lWarn,Label,dBf,ldB)
      Implicit Real*8  (a-h,o-z)
#include "real.fh"
      Real*8   Bf(3,nCent), xyz(3,nCent), dBf(3,nCent,3,nCent),
     &        BRij(3,2), dBRij(3,2,3,2),
     &        BRjk(3,2), dBRjk(3,2,3,2)
      Logical lWrite, ldB, lWarn
      Character*8 Label
*                                                                      *
************************************************************************
*                                                                      *
*define _TIME_
*                                                                      *
************************************************************************
*                                                                      *
*
#ifdef _TIME_
#endif
*
      mCent=2
      Call Strtch(xyz(1,1),mCent,Rij1,BRij,.False.,Label,dBRij,ldB)
      Call Strtch(xyz(1,2),mCent,Rjk1,BRjk,.False.,Label,dBRjk,ldB)
      Co=Zero
      Crap=Zero
*     BRij and BRjk should be normalized
      Do i = 1, 3
         Co=Co+BRij(i,1)*BRjk(i,2)
      End Do
      Do i = 1, 3
         Crap=Crap+(BRjk(i,2)-Sign(One,Co)*BRij(i,1))**2
      End Do
      Crap = Sqrt(Crap)
*
*.... Special care for cases close to linearity
*
      If (Crap.lt.1.0D-4) Then
         Si=Crap
         If (Co.lt.Zero) Then
            Fir=Pi-ArSin(Si)
         Else
            Fir=ArSin(Si)
         End If
      Else
         If (Abs(Co).gt.One) Co=Sign(One,Co)
         Fir=ArCos(Co)
         Si=Sqrt(One-Co**2)
      End If
*
      If (Fir.lt.1.0d-13) Then
         Fir=Zero
#ifdef _TIME_
#endif
         Return
      Else If (Abs(Fir-Pi).lt.1.0d-13) Then
         Fir=Pi
#ifdef _TIME_
#endif
         Return
      End If
      dFir=180.0D0*Fir/Pi
      If ((Abs(dFir).gt.177.5 .or. Abs(dFir).lt.2.5).and.lWarn)
     &   Write (6,*) ' Valence angle close to end in '//
     &               'range of definition'
      If (lWrite) Write (6,'(1X,A,A,F10.4,A,F10.6,A)') Label,
     &            ' : Angle=    ', dFir,'   / Degree  ',Fir,' / rad'
*
*---- Compute the WDC B-matrix
*
      If (Si.eq.Zero) Then
*------- Dummy assignment for a linear system!
         call dcopy_(3*nCent,[0.0D0],0,Bf,1)
      Else
         Do i = 1, 3
            Bf(i,1)= (Co*BRij(i,1)-BRjk(i,2))/(Si*Rij1)
            Bf(i,3)= (Co*BRjk(i,2)-BRij(i,1))/(Si*Rjk1)
*.......    Utilize translational invariance.
            Bf(i,2)=-(Bf(i,1)+Bf(i,3))
         End Do
      End If
*     Call RecPrt('Bf',' ',Bf,9,1)
*
*---- Compute the cartesian derivative of the B-Matrix.
*
      If (ldB) Then
*
*        dBf=-11.11111
         If (Si.eq.Zero) Then
            Call WarningMessage(2,'Bend: Si.eq.0.0D')
            Call Abend()
         End If
         Do i = 1, 3
            Do j = 1, i
               dBf(i,1,j,1)=( -Si*Bf(i,1)*BRij(j,1)
     &                        +Co*dBRij(i,1,j,1)
     &                        -Bf(j,1)*(Co*Bf(i,1)*Rij1
     &                        +Si*BRij(i,1)) ) / (Si*Rij1)
               dBf(i,1,j,3)=(-Si*Bf(i,1)*BRjk(j,2)
     &                       +dBRij(i,1,j,2)
     &                       -Bf(j,3)*Co*Bf(i,1)*Rjk1)
     &                       / (Si*Rjk1)
*              Write (*,*) '13',dBf(i,1,j,3), i, j
               dBf(i,3,j,1)=(-Si*Bf(i,3)*BRij(j,1)
     &                       +dBRjk(i,2,j,1)
     &                       -Bf(j,1)*Co*Bf(i,3)*Rij1)
     &                       / (Si*Rij1)
               dBf(i,3,j,3)=( -Si*Bf(i,3)*BRjk(j,2)
     &                        +Co*dBRjk(i,2,j,2)
     &                        -Bf(j,3)*(Co*Bf(i,3)*Rjk1
     &                        +Si*BRjk(i,2)) ) / (Si*Rjk1)
*
               dBf(j,1,i,1)=dBf(i,1,j,1)
               dBf(j,3,i,1)=dBf(i,1,j,3)
               dBf(j,1,i,3)=dBf(i,3,j,1)
               dBf(j,3,i,3)=dBf(i,3,j,3)
*
               dBf(i,1,j,2)=-(dBf(i,1,j,1)+dBf(i,1,j,3))
               dBf(j,2,i,1)=dBf(i,1,j,2)
               dBf(j,1,i,2)=-(dBf(j,1,i,1)+dBf(j,1,i,3))
               dBf(i,2,j,1)=dBf(j,1,i,2)
               dBf(i,3,j,2)=-(dBf(i,3,j,1)+dBf(i,3,j,3))
               dBf(j,2,i,3)=dBf(i,3,j,2)
               dBf(j,3,i,2)=-(dBf(j,3,i,1)+dBf(j,3,i,3))
               dBf(i,2,j,3)=dBf(j,3,i,2)
*
               dBf(i,2,j,2)=-(dBf(i,2,j,1)+dBf(i,2,j,3))
               dBf(j,2,i,2)=dBf(i,2,j,2)
*
            End Do
         End Do
*        Call RecPrt('dBf','(9F9.1)',dBf,9,9)
*
      End If
*
#ifdef _TIME_
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Markus P. Fuelscher                              *
*               1991, Per Ake Malmqvist                                *
************************************************************************
      Subroutine SORT2A(iBin,lSrtA,SrtArr,IOStk,lStk,nStk)
************************************************************************
*                                                                      *
*     Purpose: Reload all integral belonging to a given slice          *
*              and sort them.                                          *
*                                                                      *
*     Called from: Sort2                                               *
*                                                                      *
*     Calls to : UPkI4,UPkR8,DaFile                                    *
*                                                                      *
*     Calling parameters:                                              *
*     iBin   : Slice number                                            *
*     SrtArr : Work space to keep the 2el integrals                    *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDef  : definitions of the record structure                    *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*     Srt1    : common block containing information the number of      *
*               bins and partitioning of symmetry blocks               *
*     Srt2    : common block containing information pertinent to       *
*               the bin sorting algorithm                              *
*     Srt3    : dynamic stack to control inout and output of           *
*               integral buffers                                       *
*                                                                      *
*     local data declarations:                                         *
*     PkVBin : I/O buffer contains packed integral values              *
*     PkIBin : I/O buffer contains packed ordering numbers             *
*     ValBin : contains unpacked integral values                       *
*     IndBin : contains unpacked ordering numbers                      *
*                                                                      *
**** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****
*
      use srt2
      Implicit Real*8 (A-H,O-Z)
*
#include "TwoDat.fh"
#include "srt0.fh"
#include "srt1.fh"
#include "SysDef.fh"
#include "print.fh"
#include "PkCtl.fh"
#include "warnings.fh"
*
      Dimension SrtArr(lSrtA)
      Dimension PkVBin(lStRec)
      Integer   PkIBin(lStRec)
      Integer IOStk(lStk)
*
*----------------------------------------------------------------------*
*     as the packed integral labels add an extra 1-2 Byte              *
*     disk space per integral we have to adjust the record             *
*     length of LuTmp to the different machines.                       *
*----------------------------------------------------------------------*
*
      idiv = ItoB/2
      If ( Pack ) idiv = idiv/2
      mStRec=(lStRec/idiv)
      mDaRec=(lDaRec/idiv)
*
*----------------------------------------------------------------------*
*     pick up the print level                                          *
*----------------------------------------------------------------------*
*
      iRout = 85
      iPrint = nPrint(iRout)
      If ( iPrint.ge.10) then
        Write (6,*) ' >>> Enter SORT2A <<<'
        Write (6,*) ' iBin  ',iBin
        Write (6,*) ' lSrtA ',lSrtA
      End If
*
      iZero=lSrtA-mInt(1,iBin)
      iInt=mInt(2,iBin)*RtoB
      iInd=mInt(3,iBin)
      iP_Storage=(iZero+iInt+RtoB)/RtoB
      iI_Storage=( iInd+iInt+RtoB)/RtoB
      If (iP_Storage .le. iI_Storage) Then
         iDVBin(4,iBin) = 0  ! Dense mode.
C        Write (*,*) 'Mode: Dense'
      Else
         iDVBin(4,iBin) = 1  ! Sparse mode.
C        Write (*,*) 'Mode: Sparse'
      End If
*
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'Processing slice                   :',iBin
      Write (6,*) 'Actual number of non-zero integrals:', mInt(1,iBin)
      Write (6,*) 'Effective number of integrals      :', mInt(2,iBin)
      Write (6,*) 'Effective number of indicies       :', mInt(3,iBin)
      Write (6,*) 'Total number of integrals          :',lSrtA
      Write (6,*) 'Packed storage                     :',iP_Storage
      Write (6,*) 'Indexed storage                    :',iI_Storage
#endif
*
*----------------------------------------------------------------------*
*     Start reading packed buffers                                     *
*----------------------------------------------------------------------*
*
      iDaTmp=iDIBin(2,iBin)
      iDaTwo=iDVBin(2,iBin)
      Do while ( iDaTmp.ge.0 )
        nStk=nStk+1
        If ( nStk.gt.lStk ) then
          iRC=001
          Write(6,*)
          Write(6,'(2X,A,I3.3,A)')
     &    '*** Error in SORT2A ***'
          Write(6,'(2X,A)') 'nStk exceeds limits (nStk>lStk)'
          Write(6,'(2X,A,I8)') 'nStk =',nStk
          Write(6,'(2X,A,I8)') 'lStk =',lStk
          Write(6,'(2X,A,I8)') 'iBin =',iBin
          Write(6,*)
          Write(6,*) 'Action: rerun with a larger MOLCAS_MEM'
          Call Quit(_RC_MEMORY_ERROR_)
        End If
        IOStk(nStk)=iDaTwo
        iOpt=2
        If ( iPrint.ge.10 ) then
          Write (6,*) ' read records: iDaTmp,iDaTwo ',iDaTmp,iDaTwo
        End If
        Call iDAFILE(LuTmp,iOpt,PkIBin,mStRec,iDaTmp)
        Call dDAFILE(LuTwo,iOpt,PkVBin,lStRec,iDaTwo)
        ist1=lTop
        ist2=lTop
        Do iSec=1,nSect
          nInts1=PkIBin(ist1-1)
          nInts2=Int(PkVBin(ist2-1))
          If ( nInts1.ne.nInts2 ) then
            iRC=002
            Write(6,*)
            Write(6,'(2X,A,I3.3,A)')
     &      '*** Error in SORT2A ***'
            Write(6,'(2X,A)') 'An inconsistency has been deteced'
            Write(6,'(2X,A)') 'nInts1#nInts2'
            Write(6,*)
            Call xFlush(6)
            Call Abend
          End If
          nInts=nInts1
          If ( nInts.gt.lBin ) then
            iRC=003
            Write(6,*)
            Write(6,'(2X,A,I3.3,A)')
     &      '*** Error in SORT2A ***'
            Write(6,'(2X,A)') 'An inconsistency has been deteced'
            Write(6,'(2X,A)') 'nInts>lBin'
            Write(6,*)
            Call xFlush(6)
            Call Abend
          End If
          If ( nInts.gt.0 ) then
*
*----------------------------------------------------------------------*
*     Unpack buffers                                                   *
*----------------------------------------------------------------------*
*
            Call UPKI4(nInts,lIBin,PkIBin(ist1+1),IndBin)
            iOpt=0 ! Always tight mode
            Call UPKR8(iOpt,nInts,lVBin,PkVBin(ist2+1),ValBin)
*
*----------------------------------------------------------------------*
*     Sort 2el integrals                                               *
*----------------------------------------------------------------------*
*
            Do indx=1,nInts
              SrtArr(IndBin(indx))=ValBin(indx)
            End Do
            ist1=ist1+mDaRec
            ist2=ist2+lDaRec
          End If
        End Do
*
*----------------------------------------------------------------------*
*     Get the disk adress of the next record                           *
*----------------------------------------------------------------------*
*
        iDaTmp=PkIBin(1)
        iDaTwo=Int(PkVBin(1))
      End Do
      If ( iPrint.ge.99 ) Call dVcPrt('sorted ERIs',' ',SrtArr,lSrtA)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_CHKDIA(DIAG,ISYM,XM,YM,ZM,NNEGT,NNEG,NCONV)
!
! Purpose: 1) find min. in updated diagonal, XM (sym. ISYM only)
!          2) find max. in updated diagonal, YM (sym. ISYM only)
!          3) find abs. max. in updated diagonal, ZM (sym. ISYM only)
!          4) count #diagonals < 0.0, NNEGT
!          5) count #diagonals < THRNEG, NNEGT
!          6) count #screenable diagonals, NCONV
!
! -- also: a) zero negative diagonals < THRNEG
!          b) screen diagonal if requested (flag SCDIAG)
!          c) Keep track of most negative zeroed diagonal.

use Cholesky, only: Damp, DIAMNZ, IABMNZ, iiBstR, IndRed, LuPri, nnBstR, ScDiag, ThrCom, ThrNeg, TooNeg, WarNeg
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Diag(*)
integer(kind=iwp), intent(in) :: ISYM
real(kind=wp), intent(out) :: XM, YM, ZM
integer(kind=iwp), intent(out) :: NNEGT, NNEG, NCONV
integer(kind=iwp) :: IAB, JAB, JAB1, JAB2
real(kind=wp) :: TST
character(len=*), parameter :: SECNAM = 'CHO_CHKDIA'

! Initialization.
! ---------------

NNEGT = 0
NNEG = 0
NCONV = 0

if (NNBSTR(ISYM,2) > 0) then
  JAB1 = IIBSTR(ISYM,2)+1
  JAB2 = JAB1+NNBSTR(ISYM,2)-1
  XM = DIAG(INDRED(JAB1,2))
  YM = DIAG(INDRED(JAB1,2))
  ZM = abs(YM)
else
  XM = Zero
  YM = Zero
  ZM = Zero
  return
end if

! Find min. and max. diagonal and zero too negative diagonals.
! ------------------------------------------------------------

do JAB=JAB1,JAB2
  IAB = INDRED(JAB,2)  ! get address in first red. set
  XM = min(XM,DIAG(IAB))
  YM = max(YM,DIAG(IAB))
  if (DIAG(IAB) < Zero) then
    NNEGT = NNEGT+1
    if (DIAG(IAB) < THRNEG) then
      NNEG = NNEG+1
      if (DIAG(IAB) < TOONEG) then
        write(LUPRI,'(A,A,I12,1X,ES16.8)') SECNAM,': diagonal too negative: ',IAB,DIAG(IAB)
        write(LUPRI,'(A,A)') SECNAM,': shutting down Cholesky decomposition!'
        call CHO_QUIT('Diagonal too negative in '//SECNAM,104)
      end if
      if (DIAG(IAB) < WARNEG) write(LUPRI,'(A,A,I12,1X,ES16.8,A)') SECNAM,': Negative diagonal: ',IAB,DIAG(IAB),' (zeroed)'
      if (DIAG(IAB) < DIAMNZ) then
        DIAMNZ = DIAG(IAB)
        IABMNZ = IAB
      end if
      DIAG(IAB) = Zero
    end if
  end if
end do
ZM = max(abs(XM),abs(YM))

! Screen diagonal (if requested) and count the screenables as converged.
! NOTE: the screening is actually identical to setting up
!       reduced sets. However, doing the screening here will
!       force entries in later vectors of this integral pass
!       to have zero entries at screened diagonals.
! -----------------------------------------------------------

if (SCDIAG) then
  do JAB=JAB1,JAB2
    IAB = INDRED(JAB,2)  ! get address in first red. set
    TST = sqrt(abs(DIAG(IAB))*ZM)*DAMP(2)
    if (TST <= THRCOM) then
      NCONV = NCONV+1
      DIAG(IAB) = Zero
    end if
  end do
else
  do JAB=JAB1,JAB2
    IAB = INDRED(JAB,2)  ! get address in first red. set
    TST = sqrt(abs(DIAG(IAB))*ZM)*DAMP(2)
    if (TST <= THRCOM) NCONV = NCONV+1
  end do
end if

end subroutine CHO_CHKDIA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,2015, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine CCrtCmp(Zeta,P,nZeta,A,Axyz,na,HerR,nHer,kVector)
!***********************************************************************
!                                                                      *
! Object: to compile the value of the angular part of a basis function *
!         evaluated at a root of the quadrature.                       *
!                                                                      *
! Called from: PrpInt                                                  *
!                                                                      *
! Calling    :                                                         *
!              RecPrt                                                  *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!                                                                      *
!             Roland Lindh, Uppsala Universitet, Uppsala Sweden        *
!             December 2015.                                           *
!             Modification to wave vectors and complex representation. *
!***********************************************************************

use Constants, only: Two, cOne
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, na, nHer
real(kind=wp), intent(in) :: Zeta(nZeta), P(nZeta,3), A(3), HerR(nHer), kVector(3)
complex(kind=wp), intent(out) :: Axyz(nZeta,3,nHer,0:na)
#include "print.fh"
integer(kind=iwp) :: ia, iCar, iHer, iPrint, iRout
character(len=80) :: Label

iRout = 116
iPrint = nPrint(iRout)

if (na < 0) then
  call WarningMessage(2,'CCrtCmp: na < 0')
  call Abend()
end if
if (iPrint >= 99) then
  call RecPrt(' In CCrtCmp: HerR',' ',HerR,1,nHer)
  call RecPrt(' In CCrtCmp: Zeta',' ',Zeta,nZeta,1)
  call RecPrt(' In CCrtCmp: A   ',' ',A,1,3)
  call RecPrt(' In CCrtCmp: P   ',' ',P,nZeta,3)
  call RecPrt(' In CCrtCmp: KVec',' ',kVector,1,3)
end if
Axyz(:,:,:,0) = cOne

if (na /= 0) then
  do iHer=1,nHer
    do iCar=1,3

      Axyz(:,iCar,iHer,1) = cmplx(HerR(iHer)/sqrt(Zeta)+P(:,iCar)-A(iCar),kVector(iCar)/(Two*Zeta),kind=wp)

      do ia=2,na
        Axyz(:,iCar,iHer,ia) = Axyz(:,iCar,iHer,1)*Axyz(:,iCar,iHer,ia-1)
      end do

    end do
  end do
end if

if (iPrint >= 99) then
  write(Label,'(A)') ' In CCrtCmp: Axyz '
  call CRecPrt(Label,' ',Axyz,nZeta*3,nHer*(na+1),'R')
  call CRecPrt(Label,' ',Axyz,nZeta*3,nHer*(na+1),'I')
end if

return

end subroutine CCrtCmp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
***************************************************************
*
* Author :   F. Aquilante
*
*  Get_Int :  driver for the integral generator from Cholesky
*             vectors
***************************************************************
      SUBROUTINE Get_Int(rc,iOpt,iSymp,iSymq,iSymr,iSyms,Xint,lBuf,nMat)

      Implicit Real*8 (a-h,o-z)
      Integer  rc,iOpt
      Integer  iSymp,iSymq,iSymr,iSyms,Npq,Nrs
      Real*8   Xint(*)
      Integer  lBuf,nMat

#include "RdOrd.fh"
#include "TwoRc.fh"

      Character*4 BaseNm
      Character*6 Fname
      Parameter (BaseNm = 'CHFV')

      MulD2h(i,j) = iEor(i-1,j-1)+1

C Check input parameters

      rc = 0
      If (iOpt.ne.1 .and. iOpt.ne.2) Then
         rc = rcRD06
         Write(6,*) 'Get_Int: Invalid option'
         Write(6,*) 'iOpt= ',iOpt
         Call Abend()
      End If
      If (iSymp.lt.iSymq .or. iSymr.lt.iSyms) Then
         rc = rcRD02
         Write(6,*) 'Get_Int: invalid order of symmetry labels'
         Call Abend()
      End If
      If (MulD2h(iSymp,iSymq) .ne. MulD2h(iSymr,iSyms)) Then
         rc = rcRD01
         Write(6,*) 'Get_Int: wrong symmetry labels, direct product',
     &              ' is not total symmetric'
         Call Abend()
      End If
      If (lBuf.lt.1) Then
         rc = rcRD04
         Write(6,*) 'Get_Int: invalid buffer size'
         Write(6,*) 'lBuf=',lBuf
         Call Abend()
      End If

C Open files.
      LuCVec(1) = 7
      Write(Fname,'(A4,I1,I1)') BaseNm,iSymp,iSymq
      Call DANAME_MF_WA (LuCVec(1),Fname)
      if (iSymp.ne.iSymr) then
          LuCVec(2) = 7
          Write(Fname,'(A4,I1,I1)') BaseNm,iSymr,iSyms
          Call DANAME_MF_WA (LuCVec(2),Fname)
      Else
          LuCVec(2) = -1
      end if


         If (iSymp .eq. iSymq) Then
             Npq = nBas(iSymp)*(nBas(iSymp) + 1)/2
         Else
             Npq = nBas(iSymp)*nBas(iSymq)
         End If
         If (iSymr .eq. iSyms) Then
             Nrs = nBas(iSymr)*(nBas(iSyms) + 1)/2
         Else
             Nrs = nBas(iSymr)*nBas(iSyms)
         End If

C --- For debug
C      lBufs=lBuf
C      lBuf=  min(Nrs*min(Npq,2)+1,lBufs)

      If (iOpt.eq.1) then
       pq1  = 1
       nMat = min(Npq,(lBuf - 1)/Nrs)
      else
       If (pq1.lt.1 .or. pq1.gt.Npq) Then
          rc = 999999
          Write(6,*) 'pq1 out of bounds: ',pq1
          Call Abend()
          nMat = 99999999
       Else
          nMat = min((Npq-pq1+1),(lBuf - 1)/Nrs)
       End If
      end if

       If (nMat.lt.1) Then
          return !no more integrals to compute
       Else
          CALL GEN_INT(rc,iSymp,iSymq,iSymr,iSyms,pq1,nMat,Xint)
       End If
       pq1 = pq1 + nMat

C Close files.
      Do i=1,2
       if (LuCVec(i).ne.-1) then
          Call DACLOS(LuCVec(i))
          LuCVec(i) = -1
       end if
      End do

C      LBuf = lBufs

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Destroy_Chunk()

use RI_glob, only: Chunk
#ifdef _MOLCAS_MPP_
use RI_glob, only: iMap, ip_Chunk
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_deallocate

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  call GA_Destroy(ip_Chunk)
  call mma_deallocate(iMap)
else
  call mma_deallocate(Chunk)
end if
#else
call mma_deallocate(Chunk)
#endif

return

end subroutine Destroy_Chunk

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ISWAP(N,X,incX,Y,incY)
************************************************************************
*                                                                      *
*     Interchange vectors X and Y                                      *
*                                                                      *
*     calling arguments:                                               *
*     N       : Integer, input.                                        *
*               Number of input elements.                              *
*     X       : Array of Integer                                       *
*               Vector X                                               *
*     incX    : Integer, input.                                        *
*               Stride of vector X.                                    *
*     Y       : Array of Integer                                       *
*               Vector Y                                               *
*     incY    : Integer, input.                                        *
*               Stride of vector Y.                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Dimension X(*),Y(*)

      If ( N.lt.0 ) then
         Write (6,*)
         Write (6,*) '  *** Error in subroutine ISWAP ***'
         Write (6,*) '  Invalid number of elements in vectors X and Y :'
         Write (6,*) '  N must be larger than zero'
         Write (6,*)
         Call Abend
      End If

      iX=1
      If ( incX.lt.0 ) iX=1+(1-N)*incX
      iY=1
      If ( incY.lt.0 ) iY=1+(1-N)*incY

      Do i=0,N-1
         Temp=Y(iY+i*incY)
         Y(iY+i*incY)=X(iX+i*incX)
         X(iX+i*incX)=Temp
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine SCHRQas(KV,JROT,EO,GAMA,VMAX,VLIM,V,WF,BFCT,EEPS,YMIN,YH,NPP,NBEG,NEND,INNODE,INNER,IWR,LPRWF)
!*****  subroutine SCHRQ, last updated  21 August 2007 *****
!   !!!!   Form modified for handling Stolyarov radial variable  !!!!!
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!** SCHRQ solves radial Schrodinger equation in dimensionless form
!  d^2WF/dy^2 = - [(E-V(R))*BFCT*(r')^2 - F(y)]*WF(R) ,  where WF(I) is
!  the wave function and  y  the reduced radial vble.  y_p(r).
!** Integrate by Numerov method over NPP mesh points with increment
!  H=YH across range beginning at YMIN .
!** Input trial energy EO, eigenvalue convergence criterion EEPS
!  potential asymptote VLIM, and all returned energies (EO, GAMA & VMAX)
!  have units (cm-1).
!** On entry, the input potential V(I) must include the centrifugal
!  term, the factor:  'BFCT'=2*mu*(YH/hbar)**2 (1/cm-1) as well as the
!  Stolyarov conversion factors (r')^2 and F(y).
!  BFCT is also internally incorporated into EO, VLIM & EEPS.
!* Note that these reduced quantities (& the internal eigenvalue E)
!  contain a factor of the squared integration increment  YH**2 .
!  This saves arithmetic work in the innermost loop of the algorithm.
!** For energy in (cm-1), BFCT=ZMU(u)*H(Angst)**2/16.85762920 (1/cm-1)
!** INNODE > 0  specifies that wavefx. initiates at YMIN with a node
!     (normal default case);  INNODE <= 0  specifies  zero slope  at
!     YMIN (for finding symmetric eigenfunctions of symmetric potential
!     with potential mid-point @ YMIN).
!** INNER specifies wave function matching condition: INNER = 0  makes
!     matching of inward & outward solutions occur at outermost turning
!     point;  INNER > 0 makes matching occur at innermost turning point.
! * Normally use  INNER=0 ,  but to find inner-well levels of double
!     minimum potential, set  INNER > 0 .
!-----------------------------------------------------------------------
!** Output vibrational quantum number KV, eigenvalue EO, normalized
!  wave function WF(I), and range, NBEG <= I <= NEND  over
!  which WF(I) is defined. *** Have set  WF(I)=0  outside this range.
!* (NBEG,NEND), defined by requiring  abs(WF(I)) < RATST=1.0e-9  outside.
!** If(LPRWF /= 0) write every LPRWF-th value of wavefunction WF(I) to
!   a file on channel-10 (i.e., WRITE(10,XXX)), starting at YVB(NBEG)
!   with step size  |LPRWF|*YH.
!** For energies above the potential asymptote VLIM, locate quasibound
!  levels using Airy function boundary condition and return the level
!  width GAMA and barrier height VMAX, as well as EO.
!** ERROR condition on return is  KV < 0 ; usually KV=-1, but return
!  KV=-2 if error appears to arise from too low trial energy.
!** If(IWR /= 0) print error & warning descriptions
!  If (IWR > 0) also print final eigenvalues & node count.
!  If (IWR >= 2) also show end-of-range wave function amplitudes
!  If (IWR >= 3) print also intermediate trial eigenvalues, etc.
!** If input KV >= 998 , tries to find highest bound level, and
!  trial energy should be only slightly less than VLIM.
!-----------------------------------------------------------------------
!++ "SCHRQ" calls subroutines "QBOUND" and "WIDTH", and the latter
!++ calls "LEVQAD" .
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

use LEVEL_COMMON, only: ARV, DRDY2, PRV, RVB, SDRDY, VBZ, YVB
use Constants, only: Zero, One, Two, Ten, Twelve, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: KV
integer(kind=iwp), intent(in) :: JROT, NPP, INNODE, INNER, IWR, LPRWF
real(kind=wp), intent(inout) :: EO
real(kind=wp), intent(out) :: GAMA, VMAX, WF(NPP)
real(kind=wp), intent(in) :: VLIM, V(NPP), BFCT, EEPS, YMIN, YH
integer(kind=iwp), intent(out) :: NBEG, NEND
integer(kind=iwp) :: I, IBEGIN, ICOR, IT, ITER, ITP1, ITP1P, ITP2, ITP3, J, J1, J2, JPSIQ, KKV, KVIN, M, MS, MSAVE, NPR
real(kind=wp) :: DE, DEP, DEPRN, DF, DOLD, DSOC, DXPW, E, EPS, F, GB, GI, H, HT, PPROD, PROD, RATIN, RATOUT, REND, RR, SB, SI, SM, &
                 SN, SRTGB, SRTGI, VMX, VPR, WKBTST, XPR, Y1, Y2, Y3, YIN, YM, YMINN, YOUT
logical(kind=iwp) :: Conv, Found, Skip
integer(kind=iwp), parameter :: NDN = 10
real(kind=wp), parameter :: RATST = 1.0e-9_wp, XPW = log(1.0e10_wp)

!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! OPTIONALLY PRINT THESE VARIABLES WHEN DEBUGGING
!write(u6,*) 'After entering schrqas we have:'
!write(u6,*) 'KV=',KV
!write(u6,*) 'JROT=',JROT
!write(u6,*) 'EO=',EO
!write(u6,*) 'GAMA=',GAMA
!write(u6,*) 'VMAX=',VMAX
!write(u6,*) 'VLIM=',VLIM
!do I=1,3
!  write(u6,*) 'V=',V(I)
!  write(u6,*) 'WF=',WF(I)
!end do
!write(u6,*) 'BFCT=',BFCT
!write(u6,*) 'EEPS=',EEPS
!write(u6,*) 'YMIN=',YMIN
!write(u6,*) 'YH=',YH
!write(u6,*) 'NPP=',NPP
!write(u6,*) 'NBEG=',NBEG
!write(u6,*) 'NEND=',NEND
!write(u6,*) 'INNODE=',INNODE
!write(u6,*) 'INNER=',INNER
!write(u6,*) 'IWR=',IWR
!write(u6,*) 'LPRWF=',LPRWF
YOUT = 0
YM = 0
YIN = 0
ITP1P = 0
DXPW = XPW/real(NDN,kind=wp)
ICOR = 0
KVIN = KV
KV = -1
YMINN = YMIN-YH
GAMA = Zero
VMAX = VLIM
VMX = VMAX*BFCT
H = YH
HT = One/Twelve
E = EO*BFCT
EPS = EEPS*BFCT
DSOC = VLIM*BFCT
DE = Zero
RATIN = Zero
RATOUT = Zero
if (IWR > 2) then
  if (KVIN >= 998) then
    write(u6,610) EO
  else
    write(u6,601) KVIN,JROT,EO,INNER
  end if
  write(u6,602)
end if
NEND = NPP
GI = Zero
GB = Zero
! OPTIONALLY WRITE THESE VARIABLES WHEN DEBUGGING:
!write(u6,*) 'NEND=',NEND
!write(u6,*) 'V(1)=',V(1)
!write(u6,*) 'V(NEND)=',V(NEND)
!write(u6,*) 'E=',E
!write(u6,*) 'DSOC=',DSOC
! Start iterative loop; try to converge for up to 15 iterations.
! Actually allow only 10 because garble "finds" v=10 with 12 iterations.
Conv = .false.
do IT=1,10
  ITER = IT
  do
    ! OPTIONALLY write when debugging:
    !write(u6,*) 'INNER=',INNER,'If >0, SKIP'
    if (INNER <= 0) then
      !if (E > DSOC) then
      ! For quasibound levels, initialize wave function in "QBOUND"
      !end if
      if (ITER <= 2) then
        ! For  E < DSOC  begin inward integration by using JWKB to estimate
        ! optimum (minimum) inward starting point which will still give
        ! RATOUT < RATST = exp(-XPW) (ca. 1.0e-10) [not needed after 1st 2 ITER]
        NEND = NPP-1
        GB = VBZ(NEND)-E
        ! OPTIONALLY WRITE THESE VARIABLES WHEN DEBUGGING:
        !write(u6,*) 'VBZ(NEND)=',VBZ(NEND)
        !write(u6,*) 'GB=',GB
        ! ... first do rough inward search for outermost turning point
        Found = .False.
        do M=NEND-NDN,1,-NDN
          ITP2 = M
          GI = VBZ(M)-E
          !write(u6,*) 'VBZ(M)=',VBZ(M)
          !write(u6,*) 'E=',E
          !write(u6,*) 'GI=',GI,'If <= 0, EXIT'
          if ((GI <= Zero) .and. (E <= Zero)) then
            Found = .true.
            exit
          end if
          !if (GI <= Zero) then
          !  Found = .true.
          !  exit
          !end if
          GB = GI
        end do
        if (.not. Found) then
          if (IWR /= 0) write(u6,611) JROT,EO
          KV = -1
          return
        end if
        SM = GB/(GI-GB)
        SM = Half*(One+SM)*sqrt(GB)
        ITP2 = ITP2+2*NDN
        ! OPTIONALLY write when debugging:
        !write(u6,*) 'ITP2=',ITP2,'If < NEND, EXIT'
        if (ITP2 < NEND) then
          ! ... now integrate exponent till JWKB wave fx. would be negligible
          do M=ITP2,NPP-1,NDN
            NEND = M
            SM = SM+sqrt(VBZ(M)-E)*SDRDY(M)**2
            ! OPTIONALLY write when debugging:
            !write(u6,*) 'SM=',SM,'If SM > DXPW, EXIT'
            if (SM > DXPW) exit
          end do
        end if
      end if
      ! Now, checking that {[V-E](r')**2 + FAS} small enuf that Numerov,
      ! stable, and if necessary, step inward till  {[V-E](r')**2 - F} < 10
      do
        GB = V(NEND)-E*DRDY2(NEND)
        ! OPTIONALLY PRINT THESE VARIABLES WHEN DEBUGGING:
        !write(u6,*) 'NEND=',NEND
        !write(u6,*) 'V(NEND)=',V(NEND)
        !write(u6,*) 'DRDY2(NEND)=',DRDY2(NEND)
        !write(u6,*) 'GB=',GB
        if (GB <= Ten) exit
        ! If potential has [V-E] so high that H is (locally) much too large,
        ! then shift outer starting point inward & use WKB starting condition.
        ! [extremely unlikely condition w. WKB initialization]
        NEND = NEND-1
        ! OPTIONALLY write when debugging:
        !write(u6,*) 'NEND=',NEND,'If <=1, EXIT'
        if (NEND <= 1) then
          if (IWR /= 0) write(u6,613)
          KV = -1
          return
        end if
      end do
      if ((ITER <= 1) .and. (IWR >= 2) .and. (NEND < NPP-1)) write(u6,6609) JROT,EO,NEND,YVB(NEND)
      if (NEND == NPP-1) then
        !!! Initialize with node if at end of range  (YMAX= 1)
        NEND = NPP
        SB = Zero
        Y1 = Zero
        SI = One
        GI = GB
      else
        ! For truly bound state initialize wave function as 1-st order WKB
        ! solution increasing inward
        GB = V(NEND)-E*DRDY2(NEND)
        GI = V(NEND-1)-E*DRDY2(NEND-1)
        MS = NEND-1
        if (GI < Zero) then
          ! ERROR condition if  E > V(R)  at outer end of integration range.
          XPR = YMINN+MS*H
          VPR = V(MS)/BFCT
          if (IWR /= 0) write(u6,608) EO,MS,VPR,XPR,IT
          return
        end if
        ! Below is an even stronger condition to return. Basically print an error if the level above 0cm=-1
        ! Comment the three lines below (IF statement) if you want to allow levels above dissociation:
        !write(u6,*) 'EO=',EO
        !write(u6,*) 'GI=',GI
        !if (EO > Zero) then
        !  write(u6,*) 'Level is not bound!'
        !  XPR = YMINN+MS*H
        !  VPR = V(MS)/BFCT
        !  if (IWR /= 0) write(u6,608) EO,MS,VPR,XPR,IT
        !  return
        !end if
        SRTGB = sqrt(VBZ(NEND)-E)
        SRTGI = sqrt(VBZ(NEND-1)-E)
        SB = One
        SI = SB*sqrt(SRTGB/SRTGI)*exp((SRTGB+SRTGI)*Half*(RVB(NEND)-RVB(NEND-1))/YH)
        if (SB > SI) then
          ! WOOPS - JWKB gives inward DEcreasing solution, so initialize with node
          if (IWR /= 0) write(u6,618) JROT,EO,SB/SI
          SI = One
          SB = Zero
          GI = V(NEND-1)-E*DRDY2(NEND-1)
        end if
      end if
      M = NEND-1
      Y1 = (One-HT*GB)*SB
      Y2 = (One-HT*GI)*SI
      WF(NEND) = SB
      WF(NEND-1) = SI
      MS = NEND
      IBEGIN = 3
      if (INNER > 0) IBEGIN = ITP1+2
      ! Actual inward integration loop starts here
      Found = .false.
      do I=IBEGIN,NEND
        M = M-1
        Y3 = Y2+Y2-Y1+GI*SI
        GI = V(M)-E*DRDY2(M)
        SB = SI
        SI = Y3/(One-HT*GI)
        WF(M) = SI
        if (abs(SI) >= 1.0e17_wp) then
          ! Renormalize to prevent overflow of  WF(I)  in classically
          !forbidden region where  (V(I) > E)
          SI = One/SI
          WF(M:MS) = WF(M:MS)*SI
          !MS = M
          Y2 = Y2*SI
          Y3 = Y3*SI
          SB = SB*SI
          SI = One
        end if
        Y1 = Y2
        Y2 = Y3
        ! Test for outermost maximum of wave function.
        ! ... old matching condition - turning point works OK & is simpler.
        !if ((INNER == 0) .and. (abs(SI) <= abs(SB))) then
        !  Found = .true.
        !  exit
        !end if
        !** Test for outer well turning point
        !write(u6,*) 'GI=',GI
        if ((INNER == 0) .and. (GI < Zero)) then
          Found = .true.
          exit
        end if
      end do
      if ((.not. Found) .and. (INNER == 0)) then
        ! Error mode ... inward propagation finds no turning point
        KV = -2
        if (IWR /= 0) write(u6,616) KV,JROT,EO
        KV = -1
        return
      end if
      ! Scale outer part of wave function before proceeding
      SI = One/SI
      YIN = Y1*SI
      MSAVE = M
      RR = YMINN+MSAVE*H
      RATOUT = WF(NEND-1)*SI
      WF(MSAVE:NEND) = WF(MSAVE:NEND)*SI
    end if
    !-------------------------------------------------------------------
    !** Set up to prepare for outward integration **********************
    NBEG = 2
    if (INNODE <= 0) then
      ! Option to initialize with zero slope at beginning of the range
      SB = One
      GB = V(1)-E*DRDY2(1)
      Y1 = SB*(One-HT*GB)
      Y2 = Y1+GB*SB*Half
      GI = V(2)-E*DRDY2(2)
      SI = Y2/(One-HT*GI)
    else
      ! Initialize outward integration with a node at beginning of range
      do
        GB = V(NBEG)-E*DRDY2(NBEG)
        if (GB <= Ten) exit
        ! If potential has [V(i)-E] so high that H is (locally) much too
        ! large, then shift inner starting point outward.
        NBEG = NBEG+1
        if (NBEG >= NPP) then
          if (IWR /= 0) write(u6,613)
          KV = -1
          return
        end if
      end do
      if (NBEG == 2) NBEG = 1
      if ((ITER <= 1) .and. (IWR /= 0)) then
        if (NBEG > 1) write(u6,609) JROT,EO,NBEG,YVB(NBEG)
        if (GB <= Zero) write(u6,604) JROT,EO,NBEG,V(NBEG)/BFCT
      end if
      ! Initialize outward wave function with a node:  WF(NBEG) = 0.
      SB = Zero
      SI = One
      GI = V(NBEG+1)-E*DRDY2(NBEG+1)
      Y1 = SB*(One-HT*GB)
      Y2 = SI*(One-HT*GI)
    end if

    WF(NBEG) = SB
    WF(NBEG+1) = SI
    if (INNER > 0) MSAVE = NPP
    ! Actual outward integration loops start here
    Found = .false.
    do I=NBEG+2,MSAVE
      Y3 = Y2+Y2-Y1+GI*SI
      GI = V(I)-E*DRDY2(I)
      SI = Y3/(One-HT*GI)
      WF(I) = SI
      if (abs(SI) >= 1.0e17_wp) then
        ! Renormalize to prevent overflow of  WF(I)  in classically forbidden
        ! region where  V(I) > E
        SI = One/SI
        WF(NBEG:I) = WF(NBEG:I)*SI
        Y2 = Y2*SI
        Y3 = Y3*SI
        SI = One
      end if
      Y1 = Y2
      Y2 = Y3
      ITP1P = I
      ! Exit from this loop at onset of classically allowed region
      if (GI <= Zero) then
        Found = .true.
        exit
      end if
    end do
    Skip = .false.
    if (.not. Found) then
      MS = MSAVE
      if ((INNER == 0) .and. (GB <= Zero)) then
        Skip = .true.
      else
        if (IWR /= 0) write(u6,612) KVIN,JROT,EO,MSAVE
        KV = -1
        return
      end if
    end if
    if (.not. Skip) then
      ! ITP1 is last point of AS-forbidden region & ITP1P 1'st point in allowed
      ITP1 = ITP1P-1
      MS = ITP1
      if (INNER <= 0) then
        do I=ITP1P+1,MSAVE
          Y3 = Y2+Y2-Y1+GI*SI
          GI = V(I)-E*DRDY2(I)
          SI = Y3/(One-HT*GI)
          WF(I) = SI
          if (abs(SI) > 1.0e17_wp) then
            ! Renormalize to prevent overflow of  WF(I) , as needed.
            SI = One/SI
            WF(NBEG:I) = WF(NBEG:I)*SI
            Y2 = Y2*SI
            Y3 = Y3*SI
            SI = One
          end if
          Y1 = Y2
          Y2 = Y3
        end do
        MS = MSAVE
      end if
    end if
    ! Finished outward integration.  Normalize w.r.t. WF(MSAVE)
    SI = One/SI
    YOUT = Y1*SI
    YM = Y2*SI
    RATIN = WF(NBEG+1)*SI
    WF(NBEG:MS) = WF(NBEG:MS)*SI
    if (INNER <= 0) exit
  end do
  !----- Finished numerical integration ... now correct trial energy
  ! DF*H  is the integral of  (WF(I))**2 dR
  DF = sum(DRDY2(NBEG:NEND)*WF(NBEG:NEND)**2)
  !** Add edge correction to DF assuming wave function dies off as simple
  !  exponential past R(NEND);  matters only if WF(NEND) unusually large.
  !if ((E <= DSOC) .and. (WF(NEND) /= 0)) then
  !
  !!! huh ... how do I fix this for AS ??? - or is it no longer necessary ??
  !
  !if  ((KVIN >= -10) .and. (WF(NEND-1)/WF(NEND) > ONe)) DF = DF+WF(NEND)**2/(Two*log(WF(NEND-1)/WF(NEND)))
  !
  !. note that by construction, at this point  WF(MSAVE)= 1.0
  F = -YOUT-YIN+Two*YM+GI
  DOLD = DE
  if (abs(F) <= 1.0e30_wp) then
    DE = F/DF
  else
    F = 9.9e30_wp
    DF = F
    DE = abs(0.01_wp*(DSOC-E))
  end if
  if (IWR > 2) then
    DEPRN = DE/BFCT
    ! RATIN & RATOUT  are wave fx. amplitude at inner/outer ends of range
    ! relative to its value at outermost extremum.
    write(u6,603) IT,EO,F,DF,DEPRN,MSAVE,RR,RATIN,RATOUT,NBEG,ITP1
  end if
  ! Test trial eigenvalue for convergence
  if (abs(DE) <= abs(EPS)) then
    Conv = .true.
    exit
  end if
  E = E+DE
  ! KV >= 998  Option ... Search for highest bound level.  Adjust new
  ! trial energy downward if it would have been above dissociation.
  if ((KVIN >= 998) .and. (E > VMX)) E = VMX-Two*(VMX-E+DE)
  EO = E/BFCT
  if ((IT > 4) .and. (abs(DE) >= abs(DOLD)) .and. (DOLD*DE <= Zero)) then
    ! Adjust energy increment if having convergence difficulties.  Not
    ! usually needed except for some quasibounds extremely near  VMAX .
    ICOR = ICOR+1
    DEP = DE/BFCT
    if (IWR /= 0) write(u6,617) IT,DEP
    DE = Half*DE
    E = E-DE
    EO = E/BFCT
  end if
end do
!** End of iterative loop which searches for eigenvalue ************
!-------------------------------------------------------------------*
if (.not. Conv) then
  ! Convergence fails, so return in error condition
  E = E-DE
  EO = E/BFCT
  DEPRN = DE/BFCT
  if (IWR /= 0) write(u6,620) KVIN,JROT,ITER,DEPRN
  KV = -1
  return
end if
if (IWR /= 0) then
  if (IWR >= 3) write(u6,619)
  if ((abs(RATIN) > RATST) .and. (INNODE > 0) .and. (YMIN > Zero)) write(u6,614) JROT,EO,RATIN
  if ((E < DSOC) .and. (abs(RATOUT) > RATST)) then
    WKBTST = Half*abs(V(NEND)-V(NEND-1))/sqrt((V(NEND)-E)**3)
    if (WKBTST > 1.0e-3_wp) write(u6,615) JROT,EO,RATOUT,RATST,WKBTST
  end if
end if
KKV = 0
! Perform node count on converged solution
PROD = WF(ITP1)*WF(ITP1-1)
J1 = ITP1+1
J2 = NEND-1
do J=J1,J2
  PPROD = PROD
  PROD = WF(J)*WF(J-1)
  if ((PPROD <= Zero) .and. (PROD > Zero)) KKV = KKV+1
end do
KV = KKV

!write(12,699) kv,jrot,EO,nend
!699 format('   v=',i3,'    J='i3,'   E=',f10.3,'   NEND=',i6)

! Normalize & find interval (NBEG,NEND) where WF(I) is non-negligible
SN = One/sqrt(H*DF)
WF(NBEG:NEND) = WF(NBEG:NEND)*SN
if (ITP1 > 1) then
  J = ITP1P
  do I=1,ITP1
    J = J-1
    if (abs(WF(J)) < RATST) exit
  end do
  NBEG = J
  if (NBEG > 1) then
    J = J-1
    WF(1:J) = Zero
  end if
end if
! Move NEND inward to where wavefunction "non-negligible"
J = NEND-1
do I=NBEG,NEND
  if (abs(WF(J)) > RATST) exit
  J = J-1
end do
NEND = J+1
if (NEND < NPP) then
  ! Zero out wavefunction array at distances past NEND
  WF(NEND+1:NPP) = Zero
end if
if (LPRWF < 0) then
  ! If desired, write every |LPRWF|-th point of wave function to a file
  ! on channel-10, starting at mesh point # NBEG for radial distance
  ! YVB(NBEG), with the NPR values separated by mesh step  JPSIQ*YH
  JPSIQ = -LPRWF
  NPR = 1+(NEND-NBEG)/JPSIQ
  ! Write every JPSIQ-th point of the wave function for level  v=KV
  ! J=JROT , beginning at mesh point NBEG & distance RSTT where
  write(10,701) KV,JROT,EO,NPR,YVB(NBEG),YH*JPSIQ,NBEG,JPSIQ
  write(10,702) (YVB(I),WF(I),I=NBEG,NEND,JPSIQ)
end if
if (IWR == 1) write(u6,607) KV,JROT,EO
if (IWR >= 2) then
  REND = ARV*((One+YVB(NEND-1))/(One-YVB(NEND-1)))**(One/PRV)
  RATIN = RATIN*SDRDY(NBEG+1)/SDRDY(MSAVE)
  RATOUT = RATOUT*SDRDY(NEND-1)/SDRDY(MSAVE)
  write(u6,607) KV,JROT,EO,ITER,RR,RATIN,NBEG,REND,RATOUT,NEND-1
end if
! For quasibound levels, calculate width in subroutine "WIDTH"
if ((E > DSOC) .and. (KVIN > -10)) call WIDTHas(KV,JROT,E,EO,DSOC,VBZ,WF,SDRDY,VMX,YMIN,H,BFCT,IWR,ITP1,ITP2,ITP3,INNER,NPP,GAMA)

return

601 format(/' Solve for  v=',I3,'   J=',I3,'   ETRIAL=',ES15.7,'  INNER=',i2,'   WF(1st)  WF(NEND)')
602 format('ITER    ETRIAL',8X,'F(E)      DF(E)     D(E)',5X,'M    yp(M)   /WF(M)    /WF(M)  NBEG  ITP1'/1X,96('-'))
603 format(I3,ES15.7,3es10.2,I6,F7.3,2ES9.1,I5,I6)
604 format('   NOTE:  for  J=',I3,'   EO=',F12.4,' >= V(',i3,')=',F12.4)
607 format('E(v=',I3,',J=',I3,')=',F15.8,I3,' iterations  yp(M)=',F6.3,'  WF(NBEG)/WF(M)=',ES8.1,'   NBEG=',i5/40x,'R(NEND)=', &
           f9.2,'   WF(NEND)/WF(M)=',ES8.1,'   NEND=',i5)
608 format(' *** SCHRQ Error:  E=',F9.2,' > V(',I5,')=',F9.2,'  at  Rmax=',F6.2,'  for  IT=',I2)
6609 format(' *** For  J=',I3,'   E=',ES15.7,"  integration can't start till inside"/21x,'mesh point',I6,' (yp=',f8.4, &
            '),  so YMAX larger than needed')
609 format(' *** For  J=',I3,'   E=',ES15.7,"  integration can't start till past"/23x,'mesh point',I5,' (yp=',f6.2, &
           '),  so YMIN smaller than needed')
610 format(/' Seek highest bound level:   ETRIAL =',ES9.2,17x,'WF(1st)  WF(NEND)')
611 format(' *** SCHRQ inward search at   J=',i3,'   E=',f11.2,' finds no classical region')
612 format(/' *** ERROR *** for   v =',I3,'   J =',I3,'   E =',F12.4,'  Innermost turning point not found by   M = MSAVE =',I5)
613 format(/' *** ERROR in potential array ... V(I) everywhere too big to integrate with given  increment')
614 format(' *** CAUTION *** For  J=',I3,'  E=',G15.8/16x,'WF(first)/WF(Max)=',ES9.2,'  suggests  YMIN  may be too large')
615 format(' ** CAUTION ** For  J=',I3,'  E=',ES13.6,'  WF(NEND)/WF(Max)=',ES8.1,' >',ES8.1/4X,' initialization quality test ', &
           ES8.1,' > 1.D-3   so RMAX may be too small')
616 format(' ** WARNING *** For  v=',I2,', J=',I3,' at  E=',G14.7, &
           ':  inward propagation finds no turning point ... v=-2 means: Trial energy is too low (!), or potential is too weak')
617 format(' *** SCHRQ has a convergence problem, so for  IT=',I2,'  cut  DE=',ES10.2,'  in HALF')
618 format(' *** For  J=',I3,'  E=',F9.2,'  JWKB start gives  SB/SI=',ES10.3,'  so use a node.')
619 format(1X,96('-'))
620 format(' *** CAUTION for  v=',I3,'  J=',I3,"  SCHRQ doesn't converge by  ITER=",I2,'  DE=',ES9.2)
701 format(/2x,'Level  v=',I3,'   J=',I3,'   E=',F12.4,' ,  wave function at',I6,' points.'/7x,'R(1-st)=',F12.8,'   mesh=',F12.8, &
           '   NBEG=',I4,'   |LPRWF|=',I3)
702 format((4(f10.6,f11.7)))

end subroutine SCHRQas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine BestMatch(nConstr,nOrb,Occ,Match,ldim)

      Implicit Real*8 (a-h,o-z)
      Integer nConstr, nOrb, ldim, Match(2,ldim)
      Real*8  Occ(nOrb)
*
      jConstr=1

10    Continue

      delta0=2.0d0
      Do i=1,nOrb
         Do j=1,i-1
            xOcc=Occ(i)+Occ(j)
            delta=abs(2.0d0-xOcc)
            If (delta.lt.delta0) Then
               delta0=delta
               If (Occ(i).gt.Occ(j)) Then
                  Match(1,jConstr)=i
                  Match(2,jConstr)=j
               Else
                  Match(1,jConstr)=j
                  Match(2,jConstr)=i
               EndIf
            EndIf
         End Do
      End Do
*
      If (jConstr.lt.nConstr) Then ! note: Occ array destroyed here
         k=Match(1,jConstr)
         Occ(k)=-42.0d0
         l=Match(2,jConstr)
         Occ(l)=-42.0d0
         jConstr=jConstr+1
         Go To 10
      EndIf
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************

subroutine ProtoSD(NPELA,NPELB,NPSDSZ,IPSDMS)
! Given NPELA and NPELB, returns a table of all possible
! Slater determinants with NPELA alpha electrons and NPELB
! beta electrons in NPELA+NPELB orbitals.
! The ordering of the resulting SD is consistent with the
! index function   Index=1+Sum(j) noverm(k-1,j), where the sum
! is over only the alpha spins, enumerated j=1..NPELA,
! while k is the orbital with the j-th alpha electron.

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NPELA, NPELB, NPSDSZ
integer(kind=iwp), intent(out) :: IPSDMS(NPELA+NPELB,NPSDSZ)
integer(kind=iwp) :: ITMP(50), K, L, NDET, NPORB
integer(kind=iwp), parameter :: ASPIN = 1, BSPIN = 0
integer(kind=iwp), external :: NOVERM

if ((NPELA < 0) .or. (NPELB < 0)) then
  write(u6,*) ' Invalid input to ProtoSD.'
  write(u6,*) '  NPELA,NPELB:',NPELA,NPELB
  call ABEND()
end if
NPORB = NPELA+NPELB
if (NPORB == 0) return
ITMP(1:NPELA) = [(K,K=1,NPELA)]
IPSDMS(1:NPELA,1) = ASPIN
if (NPELA == NPORB) return
IPSDMS(NPELA+1:NPORB,1) = BSPIN
if (NPELA == 0) return

NDET = NOVERM(NPORB,NPELA)
if (NDET > NPSDSZ) then
  write(u6,*) ' Too small space allocated in PROTOSD. Input:'
  write(u6,'(1x,a,3i6)') ' NPELA,NPELB,NPSDSZ:',NPELA,NPELB,NPSDSZ
  write(u6,'(1x,a,i12)') ' Required NPSDSZ is',NDET
  call ABEND()
end if
!PAM write(u6,*) 'PROTOSD. Nr of orbitals:',NPORB
!PAM write(u6,*) '         Nr of determin:',NDET
!PAM write(u6,*) '         Need array siz:',NPORB*NDET

ITMP(NPELA+1) = NPORB+1
NDET = 1

outer: do
  K = 0
  do
    K = K+1
    if (K > NPELA) exit outer
    if (ITMP(K+1) /= 1+ITMP(K)) exit
  end do
  ITMP(K) = ITMP(K)+1
  ITMP(1:K-1) = [(L,L=1,K-1)]
  NDET = NDET+1
  if (NDET > NPSDSZ) then
    write(u6,*) " Serious error in PROTOSD. Too many SD's are produced."
    call ABEND()
  end if
  IPSDMS(1:NPORB,NDET) = BSPIN
  do L=1,NPELA
    IPSDMS(ITMP(L),NDET) = ASPIN
  end do
end do outer

end subroutine ProtoSD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Real*8 FUNCTION DNORM2(N,X,INCX)
C
C     EUCLIDEAN NORM OF A VECTOR
C
      INTEGER    N, INCX
      REAL*8     X(*), DNRM2_
      External DNrm2_

      DNORM2 = DNRM2_(N,X,INCX)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               1995, Martin Schuetz                                   *
!***********************************************************************

subroutine ReadIn_SCF(SIntTh)
!***********************************************************************
!                                                                      *
!     purpose: Read input to SCF: one-electron integrals, informations *
!              about basis set and molecule and options to SCF.        *
!                                                                      *
!***********************************************************************

use Gateway_Info, only: PkAcc
use InfSCF, only: DSCF, EThr, KSDFT, nCore, nDisc, TimFld
use Definitions, only: wp

implicit none
real(kind=wp), intent(inout) :: SIntTh
real(kind=wp) :: CPU1, CPU2, Tim1, Tim2, Tim3

call Timing(Cpu1,Tim1,Tim2,Tim3)
!                                                                      *
!***********************************************************************
!                                                                      *
! read one electron integral file header

call R1IBas()
!                                                                      *
!***********************************************************************
!                                                                      *
! read input

call RdInp_SCF()
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate memory for SCF procedure

call MemAlo()
!                                                                      *
!***********************************************************************
!                                                                      *
! read one-electron integrals

call R1IntA()
!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize seward

call IniSew_scf(DSCF,EThr,SIntTh,KSDFT)
!                                                                      *
!***********************************************************************
!                                                                      *
! setup for direct or conventional integral calculations

if (DSCF) then
  call Set_Basis_Mode('Valence')
  call Setup_iSD()
  call AlloK2()
  call Free_iSD()

  ! Initiate integral packing for semi-direct implementation

  if (nDisc /= 0) call inipkr8(PkAcc,.true.)

  ! Allocate buffers for semi-direct SCF

  call IniBuf(nDisc,nCore)

else

  ! Read the header of the two-electron integral file

  call Rd2Int_SCF()

end if
!                                                                      *
!***********************************************************************
!                                                                      *
call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(1) = TimFld(1)+(Cpu2-Cpu1)

end subroutine ReadIn_SCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine termCF(ANGMOM,AMFI,ESFS,ldimcf,d,maxes2,iopt,nlanth,iprint)
! this Subroutine calculates the parameters of term-specific crystal field
! for lanthanides:
!
!  nstate                      -- total number of spin free states
!                                 mixed in RASSI
!  lDIMcf                      -- number of orbital states in the
!                                 considered term (LS term)
!  ANGMOM ( 3, nstate, nstate) -- a real array holding the matrix
!                                 elements of L in this basis
!                                 (read from RASSI):
!  ESFS (nstate)               -- energy of the orbital states form the LS term
!  maxes2(3,3)                 -- rotation matrix needed to choose the
!                                 main quantization axis
!                                 ( determinant(maxes)=1.0, orthogonal vectors )
!  iopt                        -- option for choosing the main quanization axis
!                   iopt = 1   -- axis of the ground orbital multiplet,
!                                 d specifies the size of pseudo L
!                   iopt = 2   -- axis of the entire L manifold
!                   iopt = 3   -- maxes is defined by the user
!                                 ( maxes2 is given as input )
!                   iopt = 4   -- maxes is the unity matrix ( original Z
!                                 is the quantization axis )

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero, cOne, Onei, auTocm
#ifdef _DISABLED_
use Constants, only: One, Two, Half
#endif
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ldimcf, d, iopt, nlanth, iprint
real(kind=wp), intent(in) :: angmom(3,ldimcf,ldimcf), amfi(3,ldimcf,ldimcf), esfs(ldimcf), maxes2(3,3)
integer(kind=iwp) :: i, i2, info, j, l
real(kind=wp) :: det, gtens(3), maxes(3,3)
real(kind=wp), allocatable :: BNC(:,:), BNS(:,:), Bstev(:,:), eloc(:), Winit(:)
complex(kind=wp), allocatable :: Akq(:,:), amfi2(:,:,:), amfi_c(:,:,:), amfi_l(:,:,:), amfi_tmp(:,:), Angm(:,:,:), dipso(:,:,:), &
                                 dipso_tmp(:,:,:), HCF(:,:), tmp(:,:), Z(:,:), Zinit(:,:)
logical(kind=iwp), parameter :: debug = .false.
real(kind=wp), external :: finddetr
#ifdef _DISABLED_
integer(kind=iwp) :: ibasJ(100), ibasL(100), ibasS(100), icas, ij, iLS, ir, irootL(100), k, MJ, ML, MS, nLS
real(kind=wp) :: CF(100,100), coeffCG, orbM, spinM, tJ, tJM, tL, tS
complex(kind=wp) :: CFC(100,100)
#else
#include "macros.fh"
unused_var(nlanth)
#endif

call mma_allocate(eloc,lDIMcf,label='eloc')
call mma_allocate(Winit,lDIMcf,label='Winit')

call mma_allocate(Angm,3,ldimcf,ldimcf,label='angm')
call mma_allocate(dipso,3,ldimcf,ldimcf,label='dipso')
call mma_allocate(amfi_c,3,ldimcf,ldimcf,label='amfi_c')
call mma_allocate(amfi2,3,ldimcf,ldimcf,label='amfi2')
call mma_allocate(amfi_l,3,ldimcf,ldimcf,label='amfi_l')
call mma_allocate(Z,ldimcf,ldimcf,label='Z')
call mma_allocate(Zinit,ldimcf,ldimcf,label='Zinit')
call mma_allocate(tmp,ldimcf,ldimcf,label='tmp')
call mma_allocate(HCF,ldimcf,ldimcf,label='HCF')
call mma_allocate(BNC,[1,lDIMcf],[0,lDIMcf],label='BNC')
call mma_allocate(BNS,[1,lDIMcf],[0,lDIMcf],label='BNS')
call mma_allocate(Bstev,[1,lDIMcf],[-lDIMcf,lDIMcf],label='Bstev')
call mma_allocate(Akq,[1,lDIMcf-1],[-(lDIMcf-1),lDIMcf-1],label='Akq')
!-----------------------------------------------------------------------
write(u6,'(/)')
write(u6,'(A)') repeat('%',95)
if (mod(lDIMcf,2) == 1) then
  write(u6,'(5x,A,I2,A)') 'CALCULATION OF CRYSTAL-FIELD PARAMETERS OF THE GROUND ATOMIC TERM, L = ',(lDIMcf-1)/2,'.'
else
  write(u6,'(5x,A,I2,A)') 'CALCULATION OF CRYSTAL-FIELD PARAMETERS OF THE GROUND ATOMIC TERM, L = ',lDIMcf-1,'/2.'
end if
write(u6,'(A)') repeat('%',95)
write(u6,*)

dipso(:,:,:) = -angmom(:,:,:)*Onei
amfi_c(:,:,:) = amfi(:,:,:)*cOne
! find the main anisotropy direction of the
! diagonalize the angmom
if (iopt == 1) then
  ! iopt = 1   -- axis of the ground orbital doublet
  call mma_allocate(dipso_tmp,3,d,d,label='dipso_tmp')
  dipso_tmp(:,:,:) = dipso(:,1:d,1:d)
  call atens(dipso_tmp,d,gtens,maxes,iprint)
  call mma_deallocate(dipso_tmp)
  write(u6,'(a)') 'The parameters of the Crystal Field matrix are written in the coordinate system:'
  if (mod(d,2) == 0) then
    write(u6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic axes of the ground pseudo-L = |',d-1,'/2> orbital multiplet.'
  else
    write(u6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic axes of the ground pseudo-L = |',(d-1)/2,'> orbital multiplet.'
  end if

else if (iopt == 2) then
  ! iopt = 2   -- axis of the entire L manifold
  call atens(dipso,lDIMcf,gtens,maxes,iprint)
  if (mod(lDIMCF,2) == 0) then
    write(u6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic axes of the ground atomic L = |',lDIMCF-1,'/2> multiplet'
  else
    write(u6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic axes of the ground atomic L = |',(lDIMCF-1)/2,'> multiplet'
  end if

else if (iopt == 3) then
  ! iopt = 3   -- maxes is defined by the user ( maxes is given as input )
  write(u6,'(a)') 'The parameters of the Crystal Field matrix are written in the coordinate system:'
  write(u6,'(a)') '(Xm, Ym, Zm) -- defined in the input file.'
  ! copy the maxes2 to maxes
  maxes(:,:) = maxes2(:,:)
  det = finddetr(maxes,3)
  if (det == Zero) then
    write(u6,'(A)') 'TermCF:   iopt=3, while  DET(maxes)= 0.0'
    call AbEnd()
  end if
  ! FIXME: note finddetr modifies the matrix!
  if (det < Zero) then
    maxes(:,1) = -maxes2(:,1)
    if (iprint > 2) write(u6,'(a)') 'The original coordinate system was LEFT-handed. It has been changed to the RIGHT-handed'
  end if

else if (iopt == 4) then
  ! iopt = 4   -- maxes is the unity matrix ( original Z is the quantization axis )
  call unitmat(maxes,3)
else
  call AbEnd()
end if

! print out the rotation matrix:
write(u6,'(a)') 'Rotation matrix from the initial coordinate system to the employed coordinate system is:'

if ((iopt == 1) .or. (iopt == 2)) then
  write(u6,'(2a)') repeat('-',67),'|'
  write(u6,'(A,31x,A)') 'x , y , z  -- initial Cartesian axes','|'
  write(u6,'(A,35x,A)') 'Xm, Ym, Zm -- main magnetic axes','|'
  write(u6,'(4x,3(17x,a),9x,a)') 'x','y','z','|'
  write(u6,'(6x,A,3F18.14,1x,A)') '| Xm |',(maxes(j,1),j=1,3),'|'
  write(u6,'( A,A,3F18.14,1x,A)') ' R =  ','| Ym |',(maxes(j,2),j=1,3),'|'
  write(u6,'(6x,A,3F18.14,1x,A)') '| Zm |',(maxes(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',67),'|'
  write(u6,'(A,I3)') 'Quantization axis is Zm.'

else if (iopt == 3) then

  write(u6,'(2a)') repeat('-',67),'|'
  write(u6,'(A,31x,A)') 'x , y , z  -- initial Cartesian axes','|'
  write(u6,'(A,11x,A)') 'Xm, Ym, Zm -- the coordinate system defined in the input','|'
  write(u6,'(4x,3(17x,a),9x,a)') 'x','y','z','|'
  write(u6,'(6x,A,3F18.14,1x,A)') '| Xm |',(maxes(j,1),j=1,3),'|'
  write(u6,'( A,A,3F18.14,1x,A)') ' R =  ','| Ym |',(maxes(j,2),j=1,3),'|'
  write(u6,'(6x,A,3F18.14,1x,A)') '| Zm |',(maxes(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',67),'|'
  write(u6,'(A,I3)') 'Quantization axis is Zm.'

else

  write(u6,'(A)') 'IDENTITY matrix.'
  write(u6,'(A,I3)') 'Quantization axis is the initial z axis.'
end if

! rotate the angular momentum to the new axes, using "maxes"
call rotmom2(dipso,ldimcf,maxes,angm)
call rotmom2(amfi_c,ldimcf,maxes,amfi2)
if (debug) call prmom('TERMCF:: ANGM',angm,ldimcf)
if (debug) call prmom('TERMCF:: AMFI2',amfi2,ldimcf)

!-----------------------------------------------------------------------
! Find the pseudo-L basis of the LS manifold
call pseudospin(angm,ldimcf,Z,3,1,iprint)

if ((iprint >= 4) .or. debug) then
  write(u6,*)
  write(u6,'(5X,A)') 'PSEUDO-L EIGENFUNCTIONS:'
  write(u6,*)
  if (mod(lDIMcf,2) == 1) then
    do I=1,lDIMcf
      write(u6,'(A,I3,A,3X,20(2F9.6,1X))') '|',(lDIMcf-1)/2+(1-I),' > :',(Z(j,I),j=1,lDIMcf)
    end do
  else
    do I=1,lDIMcf
      write(u6,'(A,I3,A,3X,20(2F9.6,1X))') '|',(lDIMcf-1)-2*(I-1),'/2 > :',(Z(j,I),j=1,lDIMcf)
    end do
  end if
end if
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!  decompose the orbital moment AMSL in ITOs
!  transform AMFI integrals to pseudo-L basis:
! calculate the matrix elements of the spin and magnetic moment
! in the spin-orbit basis:
call mma_allocate(amfi_tmp,ldimcf,ldimcf,label='amfi_tmp')
do L=1,3
  ! amfi:
  amfi_tmp(:,:) = AMFI2(L,:,:)
  call ZGEMM_('C','N',lDIMcf,lDIMcf,lDIMcf,cOne,Z,lDIMcf,amfi_tmp,lDIMcf,cZero,TMP,lDIMcf)
  call ZGEMM_('N','N',lDIMcf,lDIMcf,lDIMcf,cOne,TMP,lDIMcf,Z,lDIMcf,cZero,amfi_tmp,lDIMcf)
  AMFI_L(L,:,:) = amfi_tmp(:,:)
end do !L
call mma_deallocate(amfi_tmp)

if (debug) call prMom_herm('TERMCF:: AMFI_L',amfi_l*auTocm,ldimcf)

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! calculate the RASSI Crystal Field matrix
call rtrace(lDIMcf,ESFS,ELOC)
HCF(:,:) = cZero
do i=1,lDIMcf
  do I2=1,lDIMcf
    HCF(:,I2) = HCF(:,I2)+ELOC(i)*conjg(Z(i,:))*Z(i,I2)
  end do
end do

info = 0
call DIAG_C2(HCF,lDIMcf,info,Winit,Zinit)
call print_ZFS('Ab Initio Calculated Crystal-Field Splitting Matrix written in the basis of Pseudo-L Eigenfunctions',HCF,lDIMCF)

call NEWCF(HCF,lDIMcf,Akq,BNC,BNS,BStev)
!ccccccccccccc print CF parameter ccccccccccccccccccccccccccccccc
if ((iprint >= 4) .or. debug) then
  call print_CFP_LCLU(lDIMCF,BNC,BNS,.true.)
  call print_CFP_stev(lDIMCF,Bstev,.true.)
  call print_CFP_naoya(lDIMcf,Akq,.true.)
else
  call print_CFP_LCLU(lDIMCF,BNC,BNS,.false.)
  call print_CFP_stev(lDIMCF,Bstev,.false.)
  call print_CFP_naoya(lDIMcf,Akq,.false.)
end if

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
write(u6,'(/)')
if (mod(lDIMCF,2) == 1) then
  write(u6,'(A,I0)') 'DECOMPOSITION OF THE RASSCF WAVE FUNCTIONS CORRESPONDING TO THE LOWEST ATOMIC MULTIPLET L =',(lDIMCF-1)/2
else
  write(u6,'(A,I0,A)') 'DECOMPOSITION OF THE RASSCF WAVE FUNCTIONS CORRESPONDING TO THE LOWEST ATOMIC MULTIPLET L = ',lDIMCF-1,'/2'
end if
write(u6,'(A,I0)') 'IN WAVE FUNCTIONS WITH DEFINITE PROJECTION OF THE TOTAL MOMENT ON THE QUANTIZATION AXIS'
call print_ZFS_naoya('L',Zinit,lDIMcf)
call individual_ranks(lDIMCF,BNC,BNS,HCF,'L',iprint)

! saving some information for tests:
call Add_Info('CRYS_TERM_BNMC_20',BNC(2,0),1,4)
call Add_Info('CRYS_TERM_BNMC_40',BNC(4,0),1,4)
call Add_Info('CRYS_TERM_BNMC_60',BNC(6,0),1,4)
#ifdef _DISABLED_
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! generate |J,MJ> states using the spin |S,MS> and |L,ML> states

select case (nlanth)
  case (1)  ! Ce  J=5/2
    tS = 0.5_wp
    tJ = 2.5_wp
  case (2)  ! Pr  J=4
    tS = 1.0_wp
    tJ = 4.0_wp
  case (3)  ! Nd  J=9/2
    tS = 1.5_wp
    tJ = 4.5_wp
  case (4)  ! Pm  J=4
    tS = 2.0_wp
    tJ = 4.0_wp
  case (5)  ! Sm  J=5/2
    tS = 2.5_wp
    tJ = 2.5_wp
  case (6)  ! Eu  J=0
    tS = 3.0_wp
    tJ = 0.0_wp
  case (7)  ! Gd  J=7/2; S=7/2
    tS = 3.5_wp
    tJ = 3.5_wp
  case (8)  ! Tb  J=6
    tS = 3.0_wp
    tJ = 6.0_wp
  case (9)  ! Dy  J=15/2
    tS = 2.5_wp
    tJ = 7.5_wp
  case (10) ! Ho  J=8
    tS = 2.0_wp
    tJ = 8.0_wp
  case (11) ! Er  J=15/2
    tS = 1.5_wp
    tJ = 7.5_wp
  case (12) ! Tm  J=6
    tS = 1.0_wp
    tJ = 6.0_wp
  case (13) ! Yb  J=7/2
    tS = 0.5_wp
    tJ = 3.5_wp
  case default
    tS = Zero
    tJ = Zero
    write(u6,'(A)') 'not implemented yet'
end select
tL = real(lDIMcf-1,kind=wp)*Half
ML = lDIMcf
MS = nint(Two*tS+One)
MJ = nint(Two*tJ+One)

!write(u6,*) 'nlanth=',nlanth,'  S,  L,  J =',tS,tL,tJ,' MS, ML, MJ =',MS,ML,MJ

!write(u6,*) 'build coupled basis |L,ML>|S,MS>'
nLS = ML*MS
ij = 0
ir = 0
do i=-ML+1,ML-1,2
  ir = ir+1
  do j=-MS+1,MS-1,2
    ij = ij+1
    ibasL(ij) = i
    ibasS(ij) = j
    irootL(ij) = ir
  end do
end do
do iLS=1,nLS
  write(u6,'(A,3I4,2x,A,2F6.1)') 'nLS,  ML,  MS =',iLS,ibasL(iLS),ibasS(iLS),'ML, MS =',real(ibasL(iLS),kind=wp)*Half, &
                                 real(ibasS(iLS),kind=wp)*Half
end do

write(u6,*) 'proceed to build |J,MJ> states'
ij = 0
do i=-MJ+1,MJ-1,2
  ij = ij+1
  ibasJ(ij) = i
end do

do i=1,MJ
  write(u6,'(i3,i6,F6.1)') i,ibasJ(i),real(ibasJ(i),kind=wp)*Half
end do

Cf(:,:) = Zero
CfC(:,:) = cZero

do ij=1,MJ
  tJM = real(ibasJ(ij),kind=wp)*Half
  do iLS=1,nLS
    ! set projections
    spinM = real(ibasS(iLS),kind=wp)*Half
    orbM = real(ibasL(iLS),kind=wp)*Half

    call Clebsch_Gordan(tL,orbM,tS,spinM,tJ,tJM,coeffCG)
    Cf(iJ,iLS) = coeffCG

    if (abs(coeffCG) > 1.0e-20_wp) write(u6,*) 'ij,iLS,coeffCG',ij,iLS,coeffCG
  end do
end do

write(u6,*) 'MJ ->  (1,16), (2,15), (3,14), (4,13), (5,12), (6,11), (7,10), (8,9)'
do iLS=1,nLS
  write(u6,'(A,2F6.1,16F11.8)') 'ML,MS: ',real(ibasL(iLS),kind=wp)*Half,real(ibasS(iLS),kind=wp)*Half,Cf(1,iLS),Cf(MJ,iLS), &
                                Cf(2,iLS),Cf(MJ-1,iLS),Cf(3,iLS),Cf(MJ-2,iLS),Cf(4,iLS),Cf(MJ-3,iLS),Cf(5,iLS),Cf(MJ-4,iLS), &
                                Cf(6,iLS),Cf(MJ-5,iLS),Cf(7,iLS),Cf(MJ-6,iLS),Cf(8,iLS),Cf(MJ-7,iLS)
end do

write(u6,*) 're-write initial CASSCF states into |J,MJ>, using ( Z(j,I),j=1,lDIMcf)  coefficients'

do ij=1,MJ
  do iLS=1,nLS

    k = ibasL(iLS)/2

    do iCAS=1,ML
      CFC(iJ,iLS) = CFC(iJ,iLS)+Z(k,iCAS)*Cf(iJ,iLS)
    end do

  end do
end do

write(u6,*) 'MJ ->  (1,16), (2,15), (3,14), (4,13), (5,12), (6,11), (7,10), (8,9)'
do iLS=1,nLS
  write(u6,'(A,i2,F6.1,16(2F8.4,2x))') 'iCAS,MS: ',irootL(iLS),real(ibasS(iLS),kind=wp)*Half,CfC(1,iLS),CfC(MJ,iLS),CfC(2,iLS), &
                                       CfC(MJ-1,iLS),CfC(3,iLS),CfC(MJ-2,iLS),CfC(4,iLS),CfC(MJ-3,iLS) !,CfC(5,iLS),CfC(MJ-4,iLS), &
                                       !CfC(6,iLS),CfC(MJ-5,iLS),CfC(7,iLS),CfC(MJ-6,iLS),CfC(8,iLS),CfC(MJ-7,iLS)
end do
#endif

!-----------------------------------------------------------------------
call mma_deallocate(eloc)
call mma_deallocate(Winit)

call mma_deallocate(Angm)
call mma_deallocate(dipso)
call mma_deallocate(amfi_c)
call mma_deallocate(amfi2)
call mma_deallocate(amfi_l)
call mma_deallocate(Z)
call mma_deallocate(Zinit)
call mma_deallocate(tmp)
call mma_deallocate(HCF)
call mma_deallocate(BNC)
call mma_deallocate(BNS)
call mma_deallocate(Bstev)
call mma_deallocate(Akq)

return

end subroutine termCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine creates start orbitals from model fock matrix elements  *
! generated by SEWARD.                                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: Oct 2004                                                    *
!                                                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine FckByInt(iReturncode,StandAlone)

use Index_Functions, only: nTri_Elem
use GuessOrb_Global, only: GapThr, iPrFmt, Label, nBas, nDel, nSym, PrintEor, PrintMOs, PrintPop, PrThr, SThr, TThr
#ifdef _HDF5_
use GuessOrb_Global, only: wfn_energy, wfn_mocoef, wfn_occnum, wfn_orbene, wfn_tpidx
use mh5, only: mh5_put_dset
#endif
use OneDat, only: sNoNuc, sNoOri
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iReturncode
logical(kind=iwp), intent(in) :: StandAlone
integer(kind=iwp) :: i, i1, iBas, iComp, ijL, ijS, ijT, ik, inCMO, IndType(7,8), inEps, inFck, inOvl, iOff, iOpt, ipCOk, ipEE, &
                     ipEE0, ipOk, ipOk0, ipOkk, irc, iSym, iSymlb, j1, jBas, jk, jOff, k, kBas, kOff, kSpin, Lu, nActEl, nAsh(8), &
                     nB, nBasMax, nBasTot, nC, nD, nIsh(8), nOkk, nOrb(8), nS, nSqrTot, nTriTot
real(kind=wp) :: dActEl, ei, ej, Enr_go, tmp, tmp1, tmp2, xocc
character(len=180) :: Line
character(len=80) :: Title
character(len=8) :: Lbl
real(kind=wp), allocatable :: CMO(:), Eps(:), Fck(:), Ovl(:), T1(:), T2(:), T3(:)
#ifdef _HDF5_
integer(kind=iwp) :: IndTypeT(8,7)
character, allocatable :: typestring(:)
#endif

!----------------------------------------------------------------------*
! Some setup                                                           *
!----------------------------------------------------------------------*
iReturncode = 0
call getenvf('MOLCAS_TEST',Line)
!----------------------------------------------------------------------*
! Do some counting                                                     *
!----------------------------------------------------------------------*
nBasTot = 0
nBasMax = 0
nTriTot = 0
nSqrTot = 0
do iSym=1,nSym
  nBasTot = nBasTot+nbas(iSym)
  nBasMax = max(nbasmax,nBas(iSym))
  nTriTot = nTriTot+nTri_Elem(nBas(iSym))
  nSqrTot = nSqrTot+nBas(iSym)*nBas(iSym)
end do
!----------------------------------------------------------------------*
! Get model Fock matrix.                                               *
!----------------------------------------------------------------------*
inFck = nTriTot+6
call mma_allocate(Fck,inFck)
iRc = -1
iSymlb = 1
iOpt = ibset(ibset(0,sNoOri),sNoNuc)
Lbl = 'FckInt'
iComp = 1
call RdOne(irc,iOpt,Lbl,iComp,Fck,iSymlb)
if (iRc /= 0) then
  iReturncode = 1
  call mma_deallocate(Fck)
  write(u6,*) '***'
  write(u6,*) '*** WARNING:'
  write(u6,*) '*** Guessorb did not produce start orbitals!!!'
  write(u6,*) '***'
  return
end if
#ifdef _DEBUGPRINT_
i = 1
do iSym=1,nSym
  call TriPrt('FckInt','(12f12.6)',Fck(i),nBas(iSym))
  !call NrmClc(Fck(i),nTri_Elem(nBas(iSym)),'FckbyInt','Fck(i)')
  i = i+nTri_Elem(nBas(iSym))
end do
#endif
!----------------------------------------------------------------------*
! Make symmetric orthonormal orbital basis.                            *
!----------------------------------------------------------------------*
inCMO = nSqrTot
call mma_allocate(CMO,inCMO)
call goLowdin(CMO)
#ifdef _DEBUGPRINT_
i = 1
do iSym=1,nSym
  nB = nBas(iSym)
  call RecPrt('CMO','(12f12.6)',CMO(i),nB,nB)
  !call NrmClC(CMO(i),nB**2,'FckbyInt','CMO(i)')
  i = i+nB*nB
end do
#endif
!----------------------------------------------------------------------*
! Get overlap matrix                                                   *
!----------------------------------------------------------------------*
inOvl = nTriTot+6
call mma_allocate(Ovl,inOvl)
iSymlb = 1
Lbl = 'Mltpl  0'
call RdOne(irc,iOpt,Lbl,iComp,Ovl,iSymlb)
#ifdef _DEBUGPRINT_
i = 1
do iSym=1,nSym
  call TriPrt('Ovlp','(12f12.6)',Ovl(i),nBas(iSym))
  !call NrmClc(Ovl(i),nTri_Elem(nBas(iSym)),'FckbyInt','Ovl(i)')
  i = i+nTri_Elem(nBas(iSym))
end do
#endif
!----------------------------------------------------------------------*
! Transform: F = S eps S                                               *
!----------------------------------------------------------------------*
call mma_allocate(T1,nBasMax**2)
call mma_allocate(T2,nBasMax**2)
call mma_allocate(T3,nBasMax**2)
ijT = 1
ijS = 1
ijL = 1
do iSym=1,nSym
  nB = nBas(iSym)
  if (nB > 0) then
    call Square(Fck(ijT),T1,1,nB,nB)
    call Square(Ovl(ijT),T2,1,nB,nB)
    call DGEMM_('N','N',nB,nB,nB,One,T1,nB,T2,nB,Zero,T3,nB)
    call DGEMM_Tri('T','N',nB,nB,nB,One,T2,nB,T3,nB,Zero,Fck(ijT),nB)
#   ifdef _DEBUGPRINT_
    call TriPrt('Fock matrix with metric','(12f12.6)',Fck(ijT),nB)
    !call NrmClc(Fck(ijT),nTri_Elem(nB),'FckbyInt','Fck(ijT)')
#   endif
  end if
  ijT = ijT+nTri_Elem(nB)
  ijS = ijS+nB*nB
  ijL = ijL+nB
end do
call mma_deallocate(T3)
call mma_deallocate(T2)
call mma_deallocate(T1)
!----------------------------------------------------------------------*
! Diagonalize the model Fock matrix                                    *
!----------------------------------------------------------------------*
inEps = nBasTot
call mma_allocate(Eps,inEps)
call mma_allocate(T1,nBasMax**2)
call mma_allocate(T2,nBasMax**2)
call mma_allocate(T3,nBasMax**2)
ijT = 1
ijS = 1
ijL = 1
do iSym=1,nSym
  nB = nBas(iSym)
  nS = nBas(iSym)-nDel(iSym)
  if (nB > 0) then
    call Square(Fck(ijT),T1,1,nB,nB)
    call DGEMM_('N','N',nB,nS,nB,One,T1,nB,CMO(ijS),nB,Zero,T2,nB)
    call DGEMM_Tri('T','N',nS,nS,nB,One,CMO(ijS),nB,T2,nB,Zero,T3,nS)
#   ifdef _DEBUGPRINT_
    call TriPrt('Transformed Fock matrix','(12f12.6)',T3,nB)
    !call NrmClc(T3,nTri_Elem(nB),'FckbyInt','Transformed Fck')
#   endif
    call NIdiag(T3,CMO(ijS),nS,nB)
    call goPickup(T3,Eps(ijL),nS)
    call goSort(Eps(ijL),CMO(ijS),nS,nB)

    do i=1,nS
      call VecPhase(CMO(ijS+(i-1)*nB),nB)
    end do
  end if
  ijT = ijT+nTri_Elem(nB)
  ijS = ijS+nB*nB
  ijL = ijL+nB
end do
#ifdef _DEBUGPRINT_
i = 1
do iSym=1,nSym
  nB = nBas(iSym)
  call RecPrt('CMO','(12f12.6)',CMO(i),nB,nB)
  !call NrmClC(CMO(i),nB**2,'FckbyInt','CMO(i)')
  i = i+nB*nB
end do
#endif
call mma_deallocate(T3)
call mma_deallocate(T2)
call mma_deallocate(T1)
!----------------------------------------------------------------------*
! Diagonalize T in virtual space.                                      *
!----------------------------------------------------------------------*
iRc = -1
iSymlb = 1
Lbl = 'Kinetic'
call RdOne(irc,iOpt,Lbl,iComp,Fck,iSymlb)
if (iRc == 0) then
  call mma_allocate(T1,nBasMax**2)
  call mma_allocate(T2,nBasMax**2)
  call mma_allocate(T3,nBasMax**2)
  ijT = 1
  ijS = 1
  ijL = 1
  do iSym=1,nSym
    nB = nBas(iSym)
    nD = nDel(iSym)
    nC = 0
    do iBas=1,nB-nD
      if (Eps(ijL+iBas-1) < -1.0e-3_wp) nC = nC+1
    end do
    nS = nB-nC-nD
    if (nS > 0) then

      ! Generate standardized virtual orbitals before we proceed.
      ! The virtual orbitals generated previously are not well
      ! defined and might differ substantially with different
      ! hardware/software and compiler options. To be able to
      ! compare we will need these standardized virtual orbitals.
      ! In real production calculations this step could for all
      ! practical purposes be skipped.

      call Virt_Space(CMO(ijS),CMO(ijS+nB*nC),Ovl(ijT),nB,nC,nS)

      call Square(Fck(ijT),T1,1,nB,nB)
      call DGEMM_('N','N',nB,nS,nB,One,T1,nB,CMO(ijS+nB*nC),nB,Zero,T2,nB)

      call DGEMM_Tri('T','N',nS,nS,nB,One,CMO(ijS+nB*nC),nB,T2,nB,Zero,T3,nS)
#     ifdef _DEBUGPRINT_
      call TriPrt('Virtual space','(12f12.6)',T3,nS)
#     endif
      call NIdiag(T3,CMO(ijS+nB*nC),nS,nB)
      call goPickup(T3,Eps(ijL+nC),nS)
      call goSort(Eps(ijL+nC),CMO(ijS+nB*nC),nS,nB)
#     ifdef _DEBUGPRINT_
      call RecPrt('Eps',' ',Eps(ijL+nC),nS,1)
      call RecPrt('Virtual Orbitals',' ',CMO(ijS+nB*nC),nB,nS)
#     endif

      ! Now order degenerate orbitals. This is only important for
      ! verification runs.

      do iBas=nC+1,nB-nD-1
        ei = Eps(ijL+iBas-1)
        tmp1 = Zero
        do kBas=1,nB
          ik = ijS+(iBas-1)*nB+kBas-1
          tmp1 = tmp1+abs(CMO(ik)*real(kBas,kind=wp))
        end do
        do jBas=iBas+1,nB-nD
          ej = Eps(ijL+jBas-1)
          if (abs(ei-ej) < 1.0e-12_wp) then
            tmp2 = Zero
            do kBas=1,nB
              jk = ijS+(jBas-1)*nB+kBas-1
              tmp2 = tmp2+abs(CMO(jk)*real(kBas,kind=wp))
            end do
            if (tmp2 > tmp1) then
              tmp = tmp2
              tmp2 = tmp1
              tmp1 = tmp
              Eps(ijL+iBas-1) = ej
              Eps(ijL+jBas-1) = ei
              ei = ej
              i1 = ijS+(iBas-1)*nB
              j1 = ijS+(jBas-1)*nB
              call DSwap_(nB,CMO(i1),1,CMO(j1),1)
            end if
          end if

        end do
      end do

      ! Introduce "standard" phase.

      do iBas=1,nB
        call VecPhase(CMO(ijS+(iBas-1)*nB),nB)
      end do

#     ifdef _DEBUGPRINT_
      call RecPrt('Eps',' ',Eps(ijL+nC),nS,1)
      call RecPrt('Virtual Orbitals',' ',CMO(ijS+nB*nC),nB,nS)
#     endif
      Eps(ijL+nC:ijL+nB-nD-1) = Eps(ijL+nC:ijL+nB-nD-1)+Three
      Eps(ijL+nB-nD:ijL+nB-1) = 999.0_wp
      do iBas=1,nB-nD
        if (Eps(ijL+iBas-1) > TThr) nDel(iSym) = nDel(iSym)+1
      end do
    end if
    ijT = ijT+nTri_Elem(nB)
    ijS = ijS+nB*nB
    ijL = ijL+nB
  end do
  call mma_deallocate(T3)
  call mma_deallocate(T2)
  call mma_deallocate(T1)
  !--------------------------------------------------------------------*
  ! Print orbital space data.                                          *
  !--------------------------------------------------------------------*
  if (StandAlone) then
    write(u6,'(a,es10.3)') 'Threshold for linear dependence due to S:',SThr
    write(u6,'(a,es10.3)') 'Threshold for linear dependence due to T:',TThr
    write(u6,*)
    write(u6,'(a,8i5)') 'Total number of basis functions',(nBas(iSym),iSym=1,nSym)
    write(u6,'(a,8i5)') 'Deleted orbitals               ',(nDel(iSym),iSym=1,nSym)
    write(u6,*)
  end if
end if
!----------------------------------------------------------------------*
! Present data.                                                        *
!----------------------------------------------------------------------*
call mma_allocate(T1,nBasTot)
call mma_allocate(T2,nBasTot)
T1(:) = Zero
call GoPop(Eps,T1,T2,nBasTot,PrintEor,PrThr,GapThr)
iBas = 0
dActEl = Zero
IndType(1:5,1:nSym) = 0
do iSym=1,nSym
  IndType(6,iSym) = nBas(iSym)-nDel(iSym)
  IndType(7,iSym) = nDel(iSym)
  do kBas=1,nBas(iSym)-nDel(iSym)
    iBas = iBas+1
    if (T1(iBas) > 1.99_wp) then
      IndType(2,iSym) = IndType(2,iSym)+1
      IndType(6,iSym) = IndType(6,iSym)-1
    else if (T1(iBas) > 0.01_wp) then
      IndType(4,iSym) = IndType(4,iSym)+1
      IndType(6,iSym) = IndType(6,iSym)-1
      dActEl = dActEl+T1(iBas)
    end if
  end do
end do
nActEl = int(dActEl+Half)
if (PrintMOs) then
  call PriMO('Start orbitals (virtuals shifted)',.true.,.true.,Zero,PrThr,nSym,nBas,nBas,Label,Eps,T1,CMO,iPrFmt)
  call xflush(u6)
end if
if (PrintPop) call Charge(nSym,nBas,Label,CMO,T1,Ovl,2,.true.,.true.)
call put_darray('Guessorb',CMO,nSqrTot)
call put_darray('Guessorb energies',Eps,nBasTot)
nOrb(1:nSym) = nBas(1:nSym)-nDel(1:nSym)
call Put_iArray('nOrb',nOrb,nSym)
call Put_iArray('nDel_go',nDel,nSym)
call Put_iArray('nDel',nDel,nSym)
nIsh(1:nSym) = IndType(2,1:nSym)
call Put_iArray('nIsh',nIsh,nSym)
nAsh(1:nSym) = IndType(4,1:nSym)
call Put_iArray('nAsh',nAsh,nSym)
call Put_iScalar('nActel',nActEl)
kSpin = 1 ! always same alpha and beta orbs
call Put_iScalar('Multiplicity',kSpin)
Enr_go = Zero
ipEE0 = 1
ipOk0 = 1
do iSym=1,nSym
  do i=0,nIsh(iSym)+nAsh(iSym)-1
    ipEE = ipEE0+i
    ipOk = ipOk0+i
    Enr_go = Enr_go+T1(ipOk)*Eps(ipEE)
  end do
  ipEE0 = ipEE0+nBas(iSym)
  ipOk0 = ipOk0+nBas(iSym)
end do
call Put_dScalar('Last energy',Enr_go)
#ifdef _HDF5_
call mh5_put_dset(wfn_energy,Enr_go)
#endif
Lu = 20
Title = 'Guess orbitals'
call WrVec('GSSORB',Lu,'COEI',nSym,nBas,nBas,CMO,T1,Eps,IndType,Title)
#ifdef _HDF5_
IndTypeT(:,:) = transpose(IndType(:,:))
call mma_allocate(typestring,nBasTot)
call orb2tpstr(nSym,nBas,IndTypeT(:,1),IndTypeT(:,2),IndTypeT(:,3),IndTypeT(:,4),IndTypeT(:,5),IndTypeT(:,6),IndTypeT(:,7), &
               typestring)
call mh5_put_dset(wfn_tpidx,typestring)
call mma_deallocate(typestring)
call mh5_put_dset(wfn_mocoef,CMO)
call mh5_put_dset(wfn_occnum,T1)
call mh5_put_dset(wfn_orbene,Eps)
#endif

! Compute density matrix (re-use memory allocated in Ovl)
iOff = 1
jOff = 1
kOff = 1
do iSym=1,nSym
  ipOkk = iOff
  nOkk = nIsh(iSym)+nAsh(iSym)
  ipCOk = jOff
  if (nBas(iSym) > 0) then
    do k=0,nOkk-1
      xocc = sqrt(T1(k+ipOkk))
      CMO(ipCOk:ipCOk+nBas(iSym)-1) = xocc*CMO(ipCOk:ipCOk+nBas(iSym)-1)
      ipCOk = ipCOk+nBas(iSym)
    end do
    call DGEMM_Tri('N','T',nBas(iSym),nBas(iSym),nOkk,One,CMO(jOff),nBas(iSym),CMO(jOff),nBas(iSym),Zero,Ovl(kOff),nBas(iSym))
    iOff = iOff+nBas(iSym)
    jOff = jOff+nBas(iSym)**2
    kOff = kOff+nTri_Elem(nBas(iSym))
  end if
end do
call Fold_tMat(nSym,nBas,Ovl,Ovl)
call Put_dArray('D1ao',Ovl,nTriTot)

call mma_deallocate(T2)
call mma_deallocate(T1)
!----------------------------------------------------------------------*
! Done, deallocate the rest.                                           *
!----------------------------------------------------------------------*
call mma_deallocate(Eps)
call mma_deallocate(Ovl)
call mma_deallocate(CMO)
call mma_deallocate(Fck)

end subroutine FckByInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Giovanni Li Manni                                *
*               2019, Oskar Weser                                      *
*               2021, Werner Dobrautz                                  *
************************************************************************

      module fciqmc_make_inp
        use linalg_mod, only: verify_
        implicit none
        private
        public :: make_inp, cleanup
        integer, public ::
! No default value on purpose
     &    totalwalkers,
! &    calcrdmonfly(2),
! &    rdmsamplingiters,
! Default value for time per NECI run
     &    Time = 200,
! Practically this means no trial_wavefunction by default
     &    trial_wavefunction = 1000000000,
     &    nmcyc = 50000,
     &    pops_trial = 1000,
     &    stepsshift = 10,
     &    addtoinitiator = 3,
     &    maxwalkerbloom = 1,
     &    semi_stochastic = 1000,
     &    highlypopwrite = 50,
     &    startsinglepart = 10,
     &    pops_core =  10000
        character(len=:), allocatable, public ::
     &    definedet
        real*8, public ::
     &    proje_changeref = 1.2d0,
     &    max_tau = 0.02d0,
     &    memoryfacpart = 5.0d0,
     &    memoryfacspawn = 10.0d0,
! Default value for NECI RealSpawnCutOff
     &    realspawncutoff = 0.3d0,
! Default value for NECI diagonal shift value
     &    diagshift = 0.00d0,
     &    shiftdamp = 0.02d0

        type, public :: t_RDMsampling
          sequence
          integer :: start, n_samples, step
        end type t_RDMsampling

        type(t_RDMsampling), public :: RDMsampling
        save
      contains

!>  @brief
!>    Generate an Input for NECI
!>
!>  @author
!>    G. Li Manni, Oskar Weser
!>
!>  @param[in] path
!>  @param[in] readpops If true the readpops option for NECI is set.
!>  @param[in] tGUGA
!>  @param[in] FCIDUMP_name
!>  @param[in] GAS_spaces
!>  @param[in] GAS_particles
      subroutine make_inp(path, readpops, tGUGA, FCIDUMP_name,
     &      GAS_spaces, GAS_particles)
      use general_data, only : nActEl, iSpin
      use fortran_strings, only : str
      character(len=*), intent(in) :: path
      logical, intent(in) :: readpops, tGUGA
      character(len=*), intent(in), optional :: FCIDUMP_name
      integer, intent(in), optional ::
     &      GAS_spaces(:, :), GAS_particles(:, :)

      integer :: i, isFreeUnit, file_id, indentlevel, iGAS, iSym
      integer :: nGAS, nSym
      integer, parameter :: indentstep = 4

      call verify_(present(GAS_spaces) .eqv. present(GAS_particles),
     &             'present(GAS_spaces) .eqv. present(GAS_particles)')

      call add_info('Default number of total walkers',
     &  [dble(totalwalkers)], 1, 6)
      call add_info('Default number of cycles ',[dble(nmcyc)],1,6)
      call add_info('Default value for Time  ',[dble(Time)],1,6)


      file_id = isFreeUnit(39)
      call Molcas_Open(file_id, path)

      indentlevel = 0
      write(file_id, A_fmt()) 'Title'
      write(file_id, *)
      write(file_id, A_fmt()) 'System read'
      call indent()
        write(file_id, I_fmt()) 'electrons ', nActEl
        if (tGUGA) then
            write(file_id,A_fmt())
     &          'nonuniformrandexcits mol_guga_weighted'
        else
            write(file_id,A_fmt())
     &          'nonuniformrandexcits 4ind-weighted-2'
        end if
        write(file_id,A_fmt()) 'nobrillouintheorem'
        if (tGUGA) then
          write(file_id, I_fmt()) 'guga', iSpin - 1
        else if(iSpin /= 1) then
          write(file_id, I_fmt()) 'spin-restrict', iSpin - 1
        end if
        if (present(FCIDUMP_name)) then
          write(file_id,A_fmt()) 'FCIDUMP-name', FCIDUMP_name
        end if

        write(file_id, A_fmt()) 'freeformat'
        if (present(GAS_spaces) .and. present(GAS_particles)) then
          nGAS = size(GAS_spaces, 1)
          nSym = size(GAS_spaces, 2)
          write(file_id, A_fmt())
     &      'GAS-SPEC '//str(nGAS)//' +++'
          call indent()
          do iGAS = 1, nGAS
        write(file_id, '('//indent_fmt()//'I0, 1x, I0, 1x, I0, 1x, A)')
     &        sum([(GAS_spaces(iGAS, iSym), iSym = 1, nSym)]),
     &        GAS_particles(iGAS, 1), GAS_particles(iGAS, 2), '+++'
          end do
          write(file_id, '('//indent_fmt()//')', advance='no')
          do iSym = 1, nSym
            do iGAS = 1, nGAS
              do i = 1, GAS_spaces(iGAS, iSym)
                write(file_id, '(I0, 1x)', advance='no') iGAS
              end do
            end do
          end do
          write(file_id, *)
          call dedent()
        end if
      call dedent()
      write(file_id, A_fmt()) 'endsys'
      write(file_id, *)
      write(file_id, A_fmt()) 'calc'
      call indent()
        if (allocated(DefineDet)) then
          write(file_id, A_fmt()) 'definedet '//trim(definedet)
        end if
        write(file_id, *)
        write(file_id, I_fmt()) 'totalwalkers', totalwalkers
        write(file_id, A_fmt()) merge(' ', '(', readpops)//'readpops'
        write(file_id, A_fmt())merge(' ', '(',readpops)//'walkcontgrow'
        write(file_id, I_fmt()) 'semi-stochastic', semi_stochastic
        write(file_id, *)
        write(file_id, A_fmt()) 'methods'
        call indent()
          write(file_id, A_fmt()) 'method vertex fcimc'
        call dedent()
        write(file_id, A_fmt()) 'endmethods'
        write(file_id, *)
        write(file_id, R_fmt()) 'diagshift', diagshift
        write(file_id, R_fmt()) 'shiftdamp', shiftdamp
        write(file_id, I_fmt()) 'nmcyc', nmcyc
        write(file_id, I_fmt()) 'stepsshift', stepsshift
        write(file_id, R_fmt()) 'proje-changeref', proje_changeref
        write(file_id, A_fmt()) 'truncinitiator'
        write(file_id, I_fmt()) 'addtoinitiator ', addtoinitiator
        write(file_id, A_fmt()) 'allrealcoeff'
        write(file_id, R_fmt()) 'realspawncutoff', realspawncutoff
        write(file_id, A_fmt()) 'jump-shift'
        if (tGUGA) then
            write(file_id, A_fmt()) 'hist-tau-search 0.9999'
        else
            write(file_id, A_fmt()) 'tau 0.01 search'
        end if
        write(file_id, R_fmt()) 'max-tau', max_tau
        write(file_id, I_fmt()) 'maxwalkerbloom', maxwalkerbloom
        write(file_id, R_fmt()) 'memoryfacspawn', memoryfacspawn
        write(file_id, R_fmt()) 'memoryfacpart', memoryfacpart
        write(file_id, I_fmt()) 'time', time
        write(file_id, I_fmt()) 'startsinglepart', startsinglepart
        write(file_id, I_fmt()) 'pops-core', pops_core
        write(file_id, I_fmt())
      call dedent()
      write(file_id, A_fmt()) 'endcalc'
      write(file_id, *)
      write(file_id, A_fmt()) 'logging'
      call indent()
        write(file_id, I_fmt()) 'highlypopwrite', Highlypopwrite
        write(file_id, A_fmt()) 'hdf5-pops'
        if (tGUGA) then
            write(file_id, A_fmt()) 'print-molcas-rdms'
        else
            write(file_id, A_fmt()) 'print-spin-resolved-RDMs'
        end if
        write(file_id, A_fmt()) 'printonerdm'
       write(file_id,'('//str(indentlevel)//'x, A,1x,I0,1x,I0,1x,I0)')
     &     'RDMlinspace',
     &      RDMsampling%start, RDMsampling%n_samples, RDMsampling%step
      call dedent()
      write(file_id, A_fmt()) 'endlog'
      write(file_id, A_fmt()) 'end'


      close(file_id)

      contains

        function indent_fmt() result(res)
          character(len=:), allocatable :: res
          if (indentlevel /= 0) then
            res = str(indentlevel)//'x, '
          else
            res = ''
          end if
        end function

        function kw_fmt(value_fmt) result(res)
          character(len=*), intent(in) :: value_fmt
          character(len=:), allocatable :: res
          res = '('//indent_fmt()//'A, 1x, '//value_fmt//')'
        end function

        function I_fmt() result(res)
          character(len=:), allocatable :: res
          res = kw_fmt('I0')
        end function

        function R_fmt() result(res)
          character(len=:), allocatable :: res
          res = kw_fmt('F0.2')
        end function

        function A_fmt() result(res)
          character(len=:), allocatable :: res
          res = kw_fmt('A')
        end function

        subroutine indent()
          indentlevel = indentlevel + indentstep
        end subroutine

        subroutine dedent()
          indentlevel = indentlevel - indentstep
        end subroutine
      end subroutine make_inp

      subroutine cleanup()
        use stdalloc, only: mma_deallocate
        if (allocated(definedet)) call mma_deallocate(definedet)
      end subroutine cleanup

      end module fciqmc_make_inp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine KE_Covalent(N,lant,t,u,OPT,HCOV)
! this function computes the covalent CF Hamiltonian ofr a given Lanthanide

use jcoeff, only: dE, init_Jx, Jx
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cOne
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, lant, OPT
real(kind=wp), intent(in) :: t, u
complex(kind=wp), intent(out) :: HCOV(N,N)
integer(kind=iwp) :: i, iJ, iK, ika, iLS, j, JLn, ms1, ns1
real(kind=wp), allocatable :: HCOV1(:,:)
real(kind=wp), external :: WCG ! Clebsch-Gordan Coefficients

call init_Jx()
call mma_allocate(HCOV1,N,N,label='HCOV1')
HCOV1(:,:) = Zero
JLn = N-1

do i=1,N
  ms1 = -(N-1)+2*(i-1)
  do j=1,N
    ns1 = -(N-1)+2*(j-1)

    if (OPT == 1) then !FULL calculation

      do iLS=1,4
        do iJ=1,17
          do iK=0,6,2
            do ika=-4,4,4
              if (WCG(JLn,JLn,2*iK,0,JLn,JLn) == Zero) cycle
              HCOV1(i,j) = HCOV1(i,j)+t*t/(u+dE(lant,iLS,iJ))*Jx(lant,iLS,iJ,iK,ika,0,0)*WCG(JLn,ns1,2*iK,2*ika,JLn,ms1)/ &
                           WCG(JLn,JLn,2*iK,0,JLn,JLn)
            end do
          end do
        end do
      end do

    else if (OPT == 2) then ! 1/U approximation

      do iLS=1,4
        do iJ=1,17
          do iK=0,6,2
            do ika=-4,4,4
              if (WCG(JLn,JLn,2*iK,0,JLn,JLn) == Zero) cycle
              HCOV1(i,j) = HCOV1(i,j)+t*t/u*Jx(lant,iLS,iJ,iK,ika,0,0)*WCG(JLn,ns1,2*iK,2*ika,JLn,ms1)/WCG(JLn,JLn,2*iK,0,JLn,JLn)
            end do
          end do
        end do
      end do
    end if
    HCOV(i,j) = HCOV1(i,j)*cOne
  end do !j
end do !i

call mma_deallocate(HCOV1)

return

end subroutine KE_Covalent

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKTDM2(LSYM1,MPLET1,MSPROJ1,IFSBTAB1,
     &                  LSYM2,MPLET2,MSPROJ2,IFSBTAB2,ISSTAB,
     &                  MAPORB,DET1,DET2,NTDM2,TDM2,
     &                  ISTATE,JSTATE,job1,job2,ist,jst)

      !> module dependencies
#ifdef _DMRG_
      use rassi_global_arrays, only: LROOT
      use qcmaquis_interface_cfg
      use qcmaquis_interface_wrapper
      use qcmaquis_interface_utility_routines, only:
     &    pretty_print_util
      use qcmaquis_info
#endif
      IMPLICIT NONE
      INTEGER IFSBTAB1(*),IFSBTAB2(*),ISSTAB(*),MAPORB(*),NTDM2
      REAL*8 DET1(*),DET2(*)
      REAL*8 TDM2(NTDM2)
      INTEGER IORB,ITABS,IUABS,JORB,LORBTB
      INTEGER NASHT,NASORB
      REAL*8 SGNJL,SGNIK
      REAL*8 GVAL,GAAAA,GABBA,GBAAB,GBBBB,GABAB,GBABA
      INTEGER LSYM1,MSPROJ1,LSYM2,MSPROJ2,ISYOP,MS2OP
      INTEGER MPLET1,MPLET2, MPLETD
      INTEGER IAAAA,IABAB,IABBA,IAKA,IAKB,IBAAB,IBABA,IBBBB,IBIA
      INTEGER IBKA,IBKB,IJ,IJIJ,IORBA,IORBB,ITU,ITUVX
      INTEGER IVABS,IVX,IXABS,JALA,JALB,JBJA,JBLA,JBLB
      INTEGER JORBA,JORBB,KORB,KORBA,KORBB,LORB,LORBA,LORBB
      INTEGER NASGEM,NSPD2,ISTATE,JSTATE
      INTEGER job1,job2,ist,jst
#ifdef _DMRG_
      LOGICAL :: debug_dmrg_rassi_code = .false.
#endif
#include "symmul.fh"
#include "stdalloc.fh"
#include "WrkSpc.fh"
      Real*8, Allocatable:: SPD2(:)

C Given two CI expansions, using a biorthonormal set of SD''s,
C calculate the spin-summed 2-particle transition density matrix
C in the biorthonormal active orbital basis.

      LORBTB=ISSTAB(3)
C Pick out nr of active orbitals from orbital table:
      NASORB=IWORK(LORBTB+3)
      NASHT=NASORB/2
      NASGEM=(NASORB*(NASORB-1))/2
      NSPD2=NASGEM**2
      Call mma_allocate(SPD2,nSPD2,Label='SPD2')
      SPD2(:)=0.0D0
      ISYOP   = MUL(LSYM1,LSYM2)
      MS2OP   = MSPROJ1-MSPROJ2
      MPLETD =  MPLET1 - MPLET2
#ifdef _DMRG_
      if(.not.doDMRG)then
#endif
        CALL SPIND2(ISYOP,MS2OP,IWORK(LORBTB),ISSTAB,
     &              IFSBTAB1,IFSBTAB2,DET1,DET2,SPD2)
#ifdef _DMRG_
      else

!#define BLUBB
        if (doMPSSICheckpoints) then
          call dmrg_interface_ctl(
     &                          task       = 'imp rdmY',
#ifndef BLUBB
     &                          x2         = spd2,
     &                          mdim       = nasgem,
#else
     &                          x2         = tdm2,
     &                          mdim       = ntdm2,
#endif
     &                          checkpoint1=
     &                          qcm_group_names(job1)%states(ist),
     &                          checkpoint2=
     &                          qcm_group_names(job2)%states(jst),
     &                          msproj     = msproj1,
     &                          msprojL    = msproj2,
     &                          multiplet  = MPLET1-1, ! (we need 2*S)
     &                          multipletL = MPLET2-1, ! (we need 2*S)
     &                          rdm1       = .false.,
     &                          rdm2       = .true.
     &                          )
        else
          call dmrg_interface_ctl(
     &                          task       = 'imp rdmY',
#ifndef BLUBB
     &                          x2         = spd2,
     &                          mdim       = nasgem,
#else
     &                          x2         = tdm2,
     &                          mdim       = ntdm2,
#endif
     &                          state      = LROOT(ISTATE),
     &                          stateL     = LROOT(JSTATE),
     &                          msproj     = msproj1,
     &                          msprojL    = msproj2,
     &                          multiplet  = MPLET1-1, ! (we need 2*S)
     &                          multipletL = MPLET2-1, ! (we need 2*S)
     &                          rdm1       = .false.,
     &                          rdm2       = .true.
     &                          )
        end if
#ifdef BLUBB
        goto 124
#endif
      end if
#endif

#ifdef _DMRG_
      if(debug_dmrg_rassi_code)then
        write(6,*)'density for i, j',istate,jstate
        write(6,*)'dimension: ',nasgem**2, '--> #nact', nasorb
        call pretty_print_util(SPD2,1,nasgem,1,nasgem,
     &                         nasgem,nasgem,1,6)
      end if
#endif

      SGNJL=1.0D0 ! dummy initialize
      SGNIK=1.0D0 ! dummy initialize
      IAKA=0      ! dummy initialize
      IAKB=0      ! dummy initialize
      IBIA=0      ! dummy initialize
      IBKA=0      ! dummy initialize
      IBKB=0      ! dummy initialize
      JALA=0      ! dummy initialize
      JALB=0      ! dummy initialize
      JBLA=0      ! dummy initialize
      JBLB=0      ! dummy initialize
      JBJA=0      ! dummy initialize
      DO JORB=1,NASHT
       JORBA=2*JORB-1
       JORBB=2*JORB
       IUABS=MAPORB(JORBA)
       DO IORB=1,NASHT
        IORBA=2*IORB-1
        IORBB=2*IORB
        ITABS=MAPORB(IORBA)
        ITU=ITABS+NASHT*(IUABS-1)
        DO LORB=1,NASHT
         LORBA=2*LORB-1
         LORBB=2*LORB
         IXABS=MAPORB(LORBA)
      IF(JORB.GT.LORB) THEN
        SGNJL=1.0D0
        JALA=((JORBA-1)*(JORBA-2))/2+LORBA
        JALB=((JORBA-1)*(JORBA-2))/2+LORBB
        JBLA=((JORBB-1)*(JORBB-2))/2+LORBA
        JBLB=((JORBB-1)*(JORBB-2))/2+LORBB
      ELSE IF(JORB.EQ.LORB) THEN
        JBJA=((JORBB-1)*(JORBB-2))/2+JORBA
      ELSE
        SGNJL=-1.0D0
        JALA=((LORBA-1)*(LORBA-2))/2+JORBA
        JALB=((LORBB-1)*(LORBB-2))/2+JORBA
        JBLA=((LORBA-1)*(LORBA-2))/2+JORBB
        JBLB=((LORBB-1)*(LORBB-2))/2+JORBB
      END IF
         DO KORB=1,NASHT
          KORBA=2*KORB-1
          KORBB=2*KORB
          IVABS=MAPORB(KORBA)
          IVX=IVABS+NASHT*(IXABS-1)
          IF(ITU.LT.IVX) GOTO 123
      IF(IORB.GT.KORB) THEN
        SGNIK=1.0D0
        IAKA=((IORBA-1)*(IORBA-2))/2+KORBA
        IAKB=((IORBA-1)*(IORBA-2))/2+KORBB
        IBKA=((IORBB-1)*(IORBB-2))/2+KORBA
        IBKB=((IORBB-1)*(IORBB-2))/2+KORBB
      ELSE IF(IORB.EQ.KORB) THEN
        IBIA=((IORBB-1)*(IORBB-2))/2+IORBA
      ELSE
        SGNIK=-1.0D0
        IAKA=((KORBA-1)*(KORBA-2))/2+IORBA
        IAKB=((KORBB-1)*(KORBB-2))/2+IORBA
        IBKA=((KORBA-1)*(KORBA-2))/2+IORBB
        IBKB=((KORBB-1)*(KORBB-2))/2+IORBB
      END IF
      IF(IORB.NE.KORB) THEN
       IF(JORB.NE.LORB) THEN
        IAAAA=IAKA+NASGEM*(JALA-1)
        IABBA=IAKB+NASGEM*(JALB-1)
        IBAAB=IBKA+NASGEM*(JBLA-1)
        IBBBB=IBKB+NASGEM*(JBLB-1)
        GAAAA=SPD2(IAAAA)
        GABBA=SPD2(IABBA)
        GBAAB=SPD2(IBAAB)
        GBBBB=SPD2(IBBBB)
        GVAL=SGNIK*SGNJL*(GAAAA+GABBA+GBAAB+GBBBB)
       ELSE
        IABAB=IAKB+NASGEM*(JBJA-1)
        IBAAB=IBKA+NASGEM*(JBJA-1)
        GABAB=SPD2(IABAB)
        GBAAB=SPD2(IBAAB)
        GVAL=SGNIK*(-GABAB+GBAAB)
       END IF
      ELSE
       IF(JORB.NE.LORB) THEN
        IBABA=IBIA+NASGEM*(JALB-1)
        IBAAB=IBIA+NASGEM*(JBLA-1)
        GBABA=SPD2(IBABA)
        GBAAB=SPD2(IBAAB)
        GVAL=SGNJL*(-GBABA+GBAAB)
       ELSE
        IBAAB=IBIA+NASGEM*(JBJA-1)
        GBAAB=SPD2(IBAAB)
        GVAL=2.0D0*GBAAB
       END IF
      END IF
C Position determined by active orbital index in external order:
          ITUVX=(ITU*(ITU-1))/2+IVX
          TDM2(ITUVX)=GVAL
 123      CONTINUE
         END DO
        END DO
       END DO
      END DO

#ifdef BLUBB
 124  CONTINUE
#endif

#ifdef _DMRG_DEBUGPRINT_
      write(6,*)' final 2-TDM'
      DO IJ=1,ntdm2
        write(6,*)' IJ, value = ',IJ,TDM2(IJ)
      end do
#endif

      CALL mma_deallocate(SPD2)
C DIAGONAL ELEMENTS HALF-SIZED (This is for proper contraction with TUVX):
      IJIJ=0
      DO IJ=1,NASHT**2
        IJIJ=IJIJ+IJ
        TDM2(IJIJ)=0.5D0*TDM2(IJIJ)
      END DO
      RETURN
#ifndef _DMRG_
! Leon: Avoid warnings for unused variables if DMRG support is disabled
      if (.false.) then
        call Unused_integer(ISTATE)
        call Unused_integer(JSTATE)
        call Unused_integer(job1)
        call Unused_integer(job2)
        call Unused_integer(ist)
        call Unused_integer(jst)
      endif
#endif
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine torque_pa( nneq, nCenter, neq, neqv, nLoc, exch,
     &                   nTempMagn, nH, nM, AngPoints, nexch,
     &                   iopt, nss, mem,
     &                   smagn, m_paranoid, m_accurate,
     &                   TempMagn, w, hmin, hmax, dltH0, EM, zJ, THRS,
     &                   hexp,
     &                   dipexch, s_exch, dipso, s_so, eso,
     &                   hinput, r_rot, XLM, ZLM, XRM, ZRM )

      Implicit None
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
#include "mgrid.fh"
#include "stdalloc.fh"
c------------------------------------------------------------
c         INPUT VARIABLES:
c------------------------------------------------------------
      Integer, intent (in)         :: nneq, neq(nneq), neqv, nLoc,
     &                                nexch(nneq), nH, nTempMagn, nM,
     &                                exch, nCenter, AngPoints,
     &                                nss(nneq), iopt, mem
      Real(kind=8), intent(in)    :: TempMagn(nTempMagn), hmin, hmax,
     &                                dltH0, EM, zJ, THRS, Hexp(nH)
      Logical, intent(in)          :: m_paranoid, m_accurate, smagn,
     &                                hinput
c correction to M from the local excited states:
      Real(kind=8), intent(in)    :: XLM( nCenter,nTempMagn,3,3)
      Real(kind=8), intent(in)    :: ZLM( nCenter,nTempMagn)
      Real(kind=8), intent(in)    :: XRM( nCenter,nTempMagn,3,3)
      Real(kind=8), intent(in)    :: ZRM( nCenter,nTempMagn)
c rotation matrices for equivalent sites:
      Real(kind=8), intent(in)    :: R_ROT(nneq,neqv,3,3)
c exchange spectum:
!     exchange energies printed out in the previous part
      Real(kind=8), intent(in)    :: W(exch)
c local spin-orbit spectum:
!     spin-orbit energies from ANISO files
      Real(kind=8), intent(in)    :: ESO(nneq,nLoc)
c magnetic and spin moments (i.e. the BIG matrices):
      Complex(kind=8), intent(in) :: DIPEXCH(3,EXCH,EXCH)
      Complex(kind=8), intent(in) ::  S_EXCH(3,EXCH,EXCH)
      Complex(kind=8), intent(in) :: dipso(nneq,3,nLoc,nLoc)
      Complex(kind=8), intent(in) ::  s_so(nneq,3,nLoc,nLoc)

c------------------------------------------------------------
c         LOCAL VARIABLES:
c------------------------------------------------------------
c exchange data:
      Real(kind=8), allocatable :: WEX(:)
!                                   WEX(NM)                ! Zeeman exchange energies
      Real(kind=8), allocatable :: ZEX(:)
!                                   ZEX(nTempMagn)         ! exchange statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: SEX(:,:)
!                                   SEX(3,nTempMagn)       ! spin magnetisation, from the exchange block;
      Real(kind=8), allocatable :: MEX(:,:)
!                                   MEX(3,nTempMagn)       ! magnetisation, form the exchange block
c data for individual sites (all states):
      Real(kind=8), allocatable :: ZL(:,:)
!                                   ZL(nneq,nTempMagn)     ! local statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: WL(:,:)
!                                   WL(nneq,nLoc)          ! Zeeman local energies
      Real(kind=8), allocatable :: SL(:,:,:)
!                                   SL(nneq,3,nTempMagn)   ! spin magnetisation, from the local sites, using ALL states ;
      Real(kind=8), allocatable :: ML(:,:,:)
!                                   ML(nneq,3,nTempMagn)   ! magnetisation, from local sites, using ALL states;
c data for individual sites (only states that enter exchange):
      Real(kind=8), allocatable :: ZR(:,:)
!                                   ZR(nneq,nTempMagn)     ! local statistical sum, Boltzmann distribution, using only NEXCH states
      Real(kind=8), allocatable :: WR(:,:)
!                                   WR(nneq,nLoc)          ! Zeeman local reduced energies, using only NEXCH states;
      Real(kind=8), allocatable :: SR(:,:,:)
!                                   SR(nneq,3,nTempMagn)   ! spin magnetisation, from the local sites, using only NEXCH states ;
      Real(kind=8), allocatable :: MR(:,:,:)
!                                   MR(nneq,3,nTempMagn)   ! magnetisation, from local sites, using only NEXCH states;
c total vectors in general coordinate system:
      Real(kind=8), allocatable :: ZRT(:,:)   ! ZRT(nCenter,nTempMagn)
      Real(kind=8), allocatable :: ZLT(:,:)   ! ZLT(nCenter,nTempMagn)
      Real(kind=8), allocatable :: MRT(:,:,:)
!                                   MRT(nCenter,3,nTempMagn)
      Real(kind=8), allocatable :: MLT(:,:,:)
!                                   MLT(nCenter,3,nTempMagn)
      Real(kind=8), allocatable :: SRT(:,:,:)
!                                   SRT(nCenter,3,nTempMagn)
      Real(kind=8), allocatable :: SLT(:,:,:)
!                                   SLT(nCenter,3,nTempMagn)
c data for total system:
      Real(kind=8), allocatable :: ZT(:)
!                                   ZT(nTempMagn)        ! total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ST(:,:)
!                                   ST(3,nTempMagn)      ! total spin magnetisation,
      Real(kind=8), allocatable :: MT(:,:)
!                                   MT(3,nTempMagn)      ! total magnetisation
c magnetic field strength and orientation data:
      Integer       :: nPlanes
      Real(kind=8) :: dlth
      parameter (nPlanes=3)
      Real(kind=8), allocatable :: H(:)    ! H(nH)
      Real(kind=8), allocatable :: dX(:,:) ! dX(nPlanes,AngPoints)
      Real(kind=8), allocatable :: dY(:,:) ! dY(nPlanes,AngPoints)
      Real(kind=8), allocatable :: dZ(:,:) ! dZ(nPlanes,AngPoints)
      Real(kind=8), allocatable :: Ang(:)  ! Ang(AngPoints)
c magnetic torque
      Real(kind=8), allocatable :: tx(:,:,:,:)
!                                   tx(nPlanes,AngPoints,nH,nTempMagn) ! magnetization torque, X
      Real(kind=8), allocatable :: ty(:,:,:,:)
!                                   ty(nPlanes,AngPoints,nH,nTempMagn) ! magnetization torque, Y
      Real(kind=8), allocatable :: tz(:,:,:,:)
!                                   tz(nPlanes,AngPoints,nH,nTempMagn) ! magnetization torque, Z
      Real(kind=8), allocatable :: sx(:,:,:,:)
!                                   sx(nPlanes,AngPoints,nH,nTempMagn) ! spin magnetization torque, X
      Real(kind=8), allocatable :: sy(:,:,:,:)
!                                   sy(nPlanes,AngPoints,nH,nTempMagn) ! spin magnetization torque, Y
      Real(kind=8), allocatable :: sz(:,:,:,:)
!                                   sz(nPlanes,AngPoints,nH,nTempMagn) ! spin magnetization torque, Z
      Real(kind=8) :: cm3tomB
      Integer :: mem_local, RtoB
c local data:
      Integer :: IM,I,it
      Integer :: J,IH,k,isite,l,n,iPl
      Logical :: DBG



c      Boltz_k=0.6950356000_wp   !   in cm^-1*K-1
c      mu_Bohr=0.4668643740_wp   !   in cm-1*T-1
      cm3tomB=0.5584938904_wp   !   in cm3 * mol-1 * T
      DBG=.false.

      Write(6,*)
      Write(6,'(100A)') (('%'),J=1,96)
      Write(6,'(20X,A)')
     & 'ANGULAR DEPENDENCE OF THE MAGNETIZATION TORQUE'
      Write(6,'(100A)') (('%'),J=1,96)
      Write(6,*)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Write(6,'(2X,A,i3,A)') 'Magnetization torque is '//
     & 'calculated for the ',NH,' field points, in the field Domain:'
      Write(6,'(2X,F4.1,1x,a,1X,F4.1,a,30(F6.3,a))') HMIN,'--',HMAX,
     & ' T., at the following temperatures:'
      Do i=11,nTempMagn,10
        j=MIN(nTempMagn,i+9)
        Write(6,'(17x,10(F9.3,A))') (TempMagn(k),' K.;',k=i,j)
      End Do
      Write(6,'(2x,A,i3,A)')
     & 'Angular dependence of the magnetization torque '//
     & 'is computed for ',AngPoints,' angular points distributed'
      Write(6,'(2x,A)') 'in the domain 0-180 deg.'
      Write(6,'(2X,A)') 'The cut-off energy for the '//
     & 'exact diagonalization of the Zeeman Hamiltonian is:'
      Write(6,'(2x,a,F15.9,A)') 'E = ',EM ,' cm(-1).'
      If(NM.lt.10) Then
        Write(6,'(2X,A,i2,a)') 'The exact diagonalization of the '//
     &       'Zeeman Hamiltonian included ',NM,' exchange states.'
      Else If( (NM.ge.10) .AND. (NM.lt.100) ) Then
        Write(6,'(2X,A,i3,a)') 'The exact diagonalization of the '//
     &       'Zeeman Hamiltonian included ',NM,' exchange states.'
      Else If( (NM.ge.100) .AND. (NM.lt.1000) ) Then
        Write(6,'(2X,A,i4,a)') 'The exact diagonalization of the '//
     &       'Zeeman Hamiltonian included ',NM,' exchange states.'
      Else If( (NM.ge.1000) .AND. (NM.lt.10000) ) Then
        Write(6,'(2X,A,i5,a)') 'The exact diagonalization of the '//
     &       'Zeeman Hamiltonian included ',NM,' exchange states.'
      End If
      If(m_accurate) Then
        Write(6,'(2x,A)') 'The contribution of local excited states'//
     &                    ' is computed exactly.'
      Else
        Write(6,'(2x,A)') 'The contribution of local excited states'//
     &                    ' is computed approximately (by using the'//
     &                    ' susceptibility data). '
      End If
!-----------------------------------------------------------------------
      If(dbg) Write(6,*) 'nM       = ', nM
      If(dbg) Write(6,*) 'nTempMagn= ', nTempMagn
      If(dbg) Write(6,*) 'nneq     = ', nneq
      If(dbg) Write(6,*) 'nCenter  = ', nCenter
      If(dbg) Write(6,*) 'AngPoints= ', AngPoints
      If(dbg) Write(6,*) 'nPlanes  = ', nPlanes
      If(dbg) Write(6,*) 'nH       = ', nH
      If(dbg) Write(6,*) 'nLoc     = ', nLoc
      If(dbg) Write(6,*) 'nexch()  = ', (nexch(i),i=1,nneq)
      If(dbg) Write(6,*) 'neq()    = ', (neq(i),i=1,nneq)
      If(dbg) Write(6,*) 'exch     = ', exch
      If(dbg) Write(6,*) 'iopt     = ', iopt
      If(dbg) Write(6,*) 'neqv     = ', neqv
      If(dbg) Write(6,*) 'nss()    = ', (nss(i),i=1,nneq)
      If(dbg) Write(6,*) 'W()      = ', (W(i),i=1,exch)
      If(dbg) Write(6,*) 'zJ       = ', zJ
      If(dbg) Write(6,*) 'EM       = ', EM
      If(dbg) Write(6,*) 'm_paranoi= ', m_paranoid
      If(dbg) Write(6,*) 'm_accurat= ', m_accurate
      If(dbg) Write(6,*) 'smagn    = ', smagn
      If(dbg) Write(6,*) 'hinput   = ', hinput


! Allocate memory for this calculation:
      mem_local=0
      RtoB=8
      If(nM>=0) Then
         ! Zeeman exchange energy spectrum
         Call mma_allocate(Wex,nM,'Wex')
         Call dcopy_(nM,[0.0_wp],0,Wex,1)
         mem_local=mem_local+nM*RtoB
      End If

      If(dbg) Write(6,*) 'mem_local 1 = ', mem_local

      If(nTempMagn>=0) Then
         ! exchange statistical sum, Boltzmann distribution
         Call mma_allocate(Zex,nTempMagn,'Zex')
         Call dcopy_(nTempMagn,[0.0_wp],0,Zex,1)
         mem_local=mem_local+nTempMagn*RtoB
         ! spin magnetisation, from the exchange block
         Call mma_allocate(SEX,3,nTempMagn,'SEX')
         Call dcopy_(3*nTempMagn,[0.0_wp],0,SEX,1)
         mem_local=mem_local+3*nTempMagn*RtoB
         ! magnetisation, from the exchange block
         Call mma_allocate(MEX,3,nTempMagn,'MEX')
         Call dcopy_(3*nTempMagn,[0.0_wp],0,MEX,1)
         mem_local=mem_local+3*nTempMagn*RtoB

         ! total statistical sum, Boltzmann distribution
         Call mma_allocate(ZT,nTempMagn,'ZT')
         Call dcopy_(nTempMagn,[0.0_wp],0,ZT,1)
         mem_local=mem_local+nTempMagn*RtoB
         ! total spin magnetisation
         Call mma_allocate(ST,3,nTempMagn,'ST')
         Call dcopy_(3*nTempMagn,[0.0_wp],0,ST,1)
         mem_local=mem_local+3*nTempMagn*RtoB
         ! total magnetisation
         Call mma_allocate(MT,3,nTempMagn,'MT')
         Call dcopy_(3*nTempMagn,[0.0_wp],0,MT,1)
         mem_local=mem_local+3*nTempMagn*RtoB

      if(dbg) Write(6,*) 'mem_local 2 = ', mem_local
         If(nneq>=0) Then
            ! local statistical sum, Boltzmann distribution
            Call mma_allocate(ZL,nneq,nTempMagn,'ZL')
            Call dcopy_(nneq*nTempMagn,[0.0_wp],0,ZL,1)
            mem_local=mem_local+nneq*nTempMagn*RtoB
            ! spin magnetisation, from the local sites, using ALL states
            Call mma_allocate(SL,nneq,3,nTempMagn,'SL')
            Call dcopy_(nneq*3*nTempMagn,[0.0_wp],0,SL,1)
            mem_local=mem_local+nneq*3*nTempMagn*RtoB
            ! magnetisation, from local sites, using ALL states
            Call mma_allocate(ML,nneq,3,nTempMagn,'ML')
            Call dcopy_(nneq*3*nTempMagn,[0.0_wp],0,ML,1)
            mem_local=mem_local+nneq*3*nTempMagn*RtoB

            ! local statistical sum, Boltzmann distribution
            Call mma_allocate(ZR,nneq,nTempMagn,'ZR')
            Call dcopy_(nneq*nTempMagn,[0.0_wp],0,ZR,1)
            mem_local=mem_local+nneq*nTempMagn*RtoB
!           spin magnetisation, from the local sites, using only NEXCH states
            Call mma_allocate(SR,nneq,3,nTempMagn,'SR')
            Call dcopy_(nneq*3*nTempMagn,[0.0_wp],0,SR,1)
            mem_local=mem_local+nneq*3*nTempMagn*RtoB
!           magnetisation, from the local sites, using only NEXCH states
            Call mma_allocate(MR,nneq,3,nTempMagn,'MR')
            Call dcopy_(nneq*3*nTempMagn,[0.0_wp],0,MR,1)
            mem_local=mem_local+nneq*3*nTempMagn*RtoB
         End If

      if(dbg) Write(6,*) 'mem_local 3 = ', mem_local
         If(nCenter>=0) Then
            ! ZRT(nCenter,nTempMagn)
            Call mma_allocate(ZRT,nCenter,nTempMagn,'ZRT')
            Call dcopy_(nCenter*nTempMagn,[0.0_wp],0,ZRT,1)
            mem_local=mem_local+nCenter*nTempMagn*RtoB
            ! ZLT(nCenter,nTempMagn)
            Call mma_allocate(ZLT,nCenter,nTempMagn,'ZLT')
            Call dcopy_(nCenter*nTempMagn,[0.0_wp],0,ZLT,1)
            mem_local=mem_local+nCenter*nTempMagn*RtoB
            ! MRT(nCenter,3,nTempMagn)
            Call mma_allocate(MRT,nCenter,3,nTempMagn,'MRT')
            Call dcopy_(nCenter*3*nTempMagn,[0.0_wp],0,MRT,1)
            mem_local=mem_local+nCenter*3*nTempMagn*RtoB
            ! MLT(nCenter,3,nTempMagn)
            Call mma_allocate(MLT,nCenter,3,nTempMagn,'MLT')
            Call dcopy_(nCenter*3*nTempMagn,[0.0_wp],0,MLT,1)
            mem_local=mem_local+nCenter*3*nTempMagn*RtoB
            ! SRT(nCenter,3,nTempMagn)
            Call mma_allocate(SRT,nCenter,3,nTempMagn,'SRT')
            Call dcopy_(nCenter*3*nTempMagn,[0.0_wp],0,SRT,1)
            mem_local=mem_local+nCenter*3*nTempMagn*RtoB
            ! SLT(nCenter,3,nTempMagn)
            Call mma_allocate(SLT,nCenter,3,nTempMagn,'SLT')
            Call dcopy_(nCenter*3*nTempMagn,[0.0_wp],0,SLT,1)
            mem_local=mem_local+nCenter*3*nTempMagn*RtoB
         End If

         If(dbg) Write(6,*) 'mem_local 4 = ', mem_local
c magnetic torque
         If( (nPlanes>=0).and.(AngPoints>=0).and.(nH>=0)
     &                                    .and.(nTempMagn>=0) ) Then
            Call mma_allocate(tx,nPlanes,AngPoints,nH,nTempMagn,'tx')
            Call mma_allocate(ty,nPlanes,AngPoints,nH,nTempMagn,'ty')
            Call mma_allocate(tz,nPlanes,AngPoints,nH,nTempMagn,'tz')
            Call mma_allocate(sx,nPlanes,AngPoints,nH,nTempMagn,'sx')
            Call mma_allocate(sy,nPlanes,AngPoints,nH,nTempMagn,'sy')
            Call mma_allocate(sz,nPlanes,AngPoints,nH,nTempMagn,'sz')
            Call dcopy_(nPlanes*AngPoints*nH*nTempMagn,[0.0_wp],0,tx,1)
            Call dcopy_(nPlanes*AngPoints*nH*nTempMagn,[0.0_wp],0,ty,1)
            Call dcopy_(nPlanes*AngPoints*nH*nTempMagn,[0.0_wp],0,tz,1)
            Call dcopy_(nPlanes*AngPoints*nH*nTempMagn,[0.0_wp],0,sx,1)
            Call dcopy_(nPlanes*AngPoints*nH*nTempMagn,[0.0_wp],0,sy,1)
            Call dcopy_(nPlanes*AngPoints*nH*nTempMagn,[0.0_wp],0,sz,1)
            mem_local=mem_local+6*nPlanes*AngPoints*nH*nTempMagn*RtoB
         End If
      End If
      if(dbg) Write(6,*) 'mem_local 5 = ', mem_local

      If((nLoc>=0).and.(nneq>=0)) Then
         ! Zeeman local energies
         Call mma_allocate(WL,nneq,nLoc,'WL')
         Call dcopy_(nneq*nLoc,[0.0_wp],0,WL,1)
         mem_local=mem_local+nneq*nLoc*RtoB
         ! Zeeman local reduced energies, using only NEXCH states
         Call mma_allocate(WR,nneq,nLoc,'WR')
         Call dcopy_(nneq*nLoc,[0.0_wp],0,WR,1)
         mem_local=mem_local+nneq*nLoc*RtoB
      End If
      if(dbg) Write(6,*) 'mem_local 6 = ', mem_local

      If(AngPoints>=0) Then
         Call mma_allocate(Ang,AngPoints,'Ang')
         Call dcopy_(AngPoints,[0.0_wp],0,Ang,1)
         mem_local=mem_local+AngPoints*RtoB
         If(nPlanes>=0) Then
            Call mma_allocate(dX,nPlanes,AngPoints,'dX')
            Call mma_allocate(dY,nPlanes,AngPoints,'dY')
            Call mma_allocate(dZ,nPlanes,AngPoints,'dZ')
            Call dcopy_(nPlanes*AngPoints,[0.0_wp],0,dX,1)
            Call dcopy_(nPlanes*AngPoints,[0.0_wp],0,dY,1)
            Call dcopy_(nPlanes*AngPoints,[0.0_wp],0,dZ,1)
            mem_local=mem_local+3*nPlanes*AngPoints*RtoB
         End If
      End If
      if(dbg) Write(6,*) 'mem_local 7 = ', mem_local

      If(nH>=0) Then
         Call mma_allocate(H,nH,'H')
         Call dcopy_(nH,[0.0_wp],0,H,1)
         mem_local=mem_local+nH*RtoB
      End If

      If(dbg) Write(6,*) 'TORQ:  memory allocated (local):'
      If(dbg) Write(6,*) 'mem_local=', mem_local
      If(dbg) Write(6,*) 'TORQ:  memory allocated (total):'
      If(dbg) Write(6,*) 'mem_total=', mem+mem_local


!-----------------------------------------------------------------------
! set up the field points:
      If (HINPUT) Then
        Do iH=1,nH
          H(iH)=HEXP(iH)
          If(H(iH).eq.0.0_wp) Then
            H(iH)=0.0001_wp
          End If
        End Do
      Else
        DLTH=(HMAX-HMIN)/DBLE(NH-1)
        Do iH=1,nH
          If (iH.eq.1) Then
            H(IH)=HMIN+dltH0
          Else
            H(IH)=HMIN+DLTH*DBLE(IH-1)
          End If
          If(H(iH).eq.0.0_wp) Then
            H(iH)=0.0001_wp
          End If
        End Do
      End If
c-----------------------------------------

      Do IH=1,NH
c ///  opening the loop over field points:
         Call dcopy_(nPlanes*AngPoints,[0.0_wp],0,dX,1)
         Call dcopy_(nPlanes*AngPoints,[0.0_wp],0,dY,1)
         Call dcopy_(nPlanes*AngPoints,[0.0_wp],0,dZ,1)
         Do iPl=1,nPlanes
c ///  opening the loop over dIfferent planes of rotation of the applied magnetic field:
c  loop over various angular grids  (iPl = 1, 2 or 3)
c  iPl=1 (X) , angular grid in the plane YZ ( half of the plane , 0-180 degrees)
c  iPl=2 (Y) , angular grid in the plane XZ ( half of the plane , 0-180 degrees)
c  iPl=3 (Z) , angular grid in the plane XY ( half of the plane , 0-180 degrees)
            Call dcopy_(AngPoints,[0.0_wp],0,Ang,1)

            Call hdir2( AngPoints, iPl, dX(iPl,:), dY(iPl,:), dZ(iPl,:),
     &                  Ang, 4 )

            If(dbg) Write(6,*) 'iPl, dX, dY, dZ=', iPl, dX(iPl,:),
     &                          dY(iPl,:), dZ(iPl,:),  Ang
            Do IM=1,AngPoints
c ///  opening the loop over dIfferent directions of the magnetic field
               Call dcopy_(nM,              [0.0_wp],0,Wex,1)
               Call dcopy_(nneq*nLoc,       [0.0_wp],0,WL ,1)
               Call dcopy_(nneq*nLoc,       [0.0_wp],0,WR ,1)
               Call dcopy_(       nTempMagn,[0.0_wp],0,Zex,1)
               Call dcopy_(nneq*  nTempMagn,[0.0_wp],0,ZL ,1)
               Call dcopy_(nneq*  nTempMagn,[0.0_wp],0,ZR ,1)
               Call dcopy_(     3*nTempMagn,[0.0_wp],0,SEX,1)
               Call dcopy_(     3*nTempMagn,[0.0_wp],0,MEX,1)
               Call dcopy_(nneq*3*nTempMagn,[0.0_wp],0,SL ,1)
               Call dcopy_(nneq*3*nTempMagn,[0.0_wp],0,ML ,1)
               Call dcopy_(nneq*3*nTempMagn,[0.0_wp],0,SR ,1)
               Call dcopy_(nneq*3*nTempMagn,[0.0_wp],0,MR ,1)
               Call dcopy_(     3*nTempMagn,[0.0_wp],0,MT ,1)
               Call dcopy_(     3*nTempMagn,[0.0_wp],0,ST ,1)
               Call dcopy_(       nTempMagn,[0.0_wp],0,ZT ,1)

c exchange magnetization:
               Call MAGN( EXCH, NM,
     &                    dX(iPl,iM),dY(iPl,iM),dZ(iPl,iM), H(iH),
     &                    W, zJ, THRS,
     &                    DIPEXCH,
     &                     S_EXCH,
     &                    nTempMagn,TempMagn,smagn,
     &                    Wex,
     &                    Zex,
     &                    Sex,
     &                    Mex, m_paranoid , DBG )

          If(iPl==2) Then
          If(DBG) Write(6,'(A,I3,1x,F8.4,2x, 3F19.14,2x,3F19.14)')
     &            'MEX: iM,',iM, H(iH), (Mex(l,1),l=1,3),
     &                   dX(iPl,iM),dY(iPl,iM),dZ(iPl,iM)
          End If
c              iT=1

c              Write(6,'(F10.4,1x,2I3,3F18.14,3x,3F20.14,2x,F20.14)')
c     &           H(iH), iL, iM, dX(iM),dY(iM),dZ(iM),(Mex(j,iT),j=1,3),
c     &           Mex(1,iT)*dX(iM)+Mex(2,iT)*dY(iM)+Mex(3,iT)*dZ(iM)
               ! compute local magnetizations:
               If (m_accurate) Then
                  Do i=1,nneq
                     ! all states:
                     If ( NSS(i) > NEXCH(i) )  Then
                     ! this check is meant to avoid the unnecessary
                     ! computation, in cases when no local excited
                     ! states are present
                       Call MAGN( NSS(i), NEXCH(i),
     &                            dX(iPl,iM),dY(iPl,iM),dZ(iPl,iM),
     &                            H(iH), ESO(i,1:NSS(i)), zJ, THRS,
     &                            DIPSO(i,:,:,:),
     &                             S_SO(i,:,:,:),
     &                            nTempMagn,TempMagn,smagn,
     &                            WL(i,:),
     &                            ZL(i,:),
     &                            SL(i,:,:),
     &                            ML(i,:,:), m_paranoid, DBG )
                     ! only local "exchange states":
                       Call MAGN( NEXCH(i), NEXCH(i),
     &                            dX(iPl,iM),dY(iPl,iM),dZ(iPl,iM),
     &                            H(iH), ESO(i,1:NEXCH(i)), zJ, THRS,
     &                            DIPSO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                             S_SO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                            nTempMagn,TempMagn,smagn,
     &                            WR(i,1:Nexch(i)),
     &                            ZR(i,:),
     &                            SR(i,:,:),
     &                            MR(i,:,:), m_paranoid, DBG )
                     End If
                  End Do
                  ! expand the basis and rotate local vectors to the
                  ! general coordinate system:
                  Call dcopy_(  nCenter*nTempMagn,[0.0_wp],0,ZRT,1)
                  Call dcopy_(  nCenter*nTempMagn,[0.0_wp],0,ZLT,1)
                  Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,MRT,1)
                  Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,MLT,1)
                  Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,SRT,1)
                  Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,SLT,1)

                  isite=0
                  Do i=1,NNEQ
                     Do j=1,NEQ(i)
                        isite=isite+1
                        ! statistical distributions
                        Do iT=1,nTempMagn
                           ZLT(isite,iT)=ZL(i,iT)
                           ZRT(isite,iT)=ZR(i,iT)
                        End Do
!                       magnetizations:
!                       use R_rot matrices, which have determinant +1.
!                        >> note that  R_lg matrices may have arbitrary
!                        >> sign of the determinant.
                        Do iT=1,nTempMagn
                           Do l=1,3
                              Do n=1,3
                                 MLT(isite,l,iT) = MLT(isite,l,iT)
     &                                       + r_rot(i,j,l,n)*ML(i,n,iT)

                                 SLT(isite,l,iT) = SLT(isite,l,iT)
     &                                       + r_rot(i,j,l,n)*SL(i,n,iT)

                                 MRT(isite,l,iT) = MRT(isite,l,iT)
     &                                       + r_rot(i,j,l,n)*MR(i,n,iT)

                                 SRT(isite,l,iT) = SRT(isite,l,iT)
     &                                       + r_rot(i,j,l,n)*SR(i,n,iT)
                              End Do
                           End Do
                        End Do

                     End Do ! j, neq(i)
                  End Do ! i, nneq
               End If ! m_accurate

               ! compute the total magnetizations according
               ! to the derived formulas:
               If (m_accurate) Then
                  Do iT=1,nTempMagn
                    If (smagn) Then
                       Call MSUM ( nCenter, Sex(:,iT), Zex(iT),
     &                             SLT(:, :,iT), ZLT(:,iT),
     &                             SRT(:, :,iT), ZRT(:,iT), iopt,
     &                             ST(:,iT),  ZT(iT)  )
                    End If

                    Call MSUM ( nCenter, Mex(:,iT), Zex(iT),
     &                          MLT(:, :,iT), ZLT(:,iT),
     &                          MRT(:, :,iT), ZRT(:,iT), iopt,
     &                           MT(:,iT),  ZT(iT)  )
                  End Do

               Else ! (m_accurate)

                  ! add the contribution from local excited states
                  ! using the approximate X*H expression:
                  Do iT=1,nTempMagn
                     Do isite=1,nCenter
                        Do l=1,3

                           MRT(isite,l,iT)=(
     &                                XRM(isite,iT,l,1)*H(iH)*dX(iPl,iM)
     &                               +XRM(isite,iT,l,2)*H(iH)*dY(iPl,iM)
     &                               +XRM(isite,iT,l,3)*H(iH)*dZ(iPl,iM)
     &                                ) /cm3tomB

                           MLT(isite,l,iT)=(
     &                                XLM(isite,iT,l,1)*H(iH)*dX(iPl,iM)
     &                               +XLM(isite,iT,l,2)*H(iH)*dY(iPl,iM)
     &                               +XLM(isite,iT,l,3)*H(iH)*dZ(iPl,iM)
     &                                ) /cm3tomB

                        End Do ! l
                     End Do ! isite

                     If (smagn) Then
                        Call MSUM ( nCenter, Sex(:,iT), Zex(iT),
     &                              SLT(:, :,iT), ZLM(:,iT),
     &                              SRT(:, :,iT), ZRM(:,iT), iopt,
     &                              ST(:,iT),  ZT(iT)  )
                     End If
                     Call MSUM ( nCenter, Mex(:,iT), Zex(iT),
     &                           MLT(:, :,iT), ZLM(:,iT),
     &                           MRT(:, :,iT), ZRM(:,iT), iopt,
     &                           MT(:,iT),  ZT(iT)  )
                  End Do ! iT
               End If ! (m_accurate)


               !  at this point we have MT and ST computed
               !  in the direction of applied field
               ! compute the M and S torque
               Do iT=1,nTempMagn
                  tx(iPl,iM,iH,iT) = MT(2,iT)*dZ(iPl,iM)*H(iH)
     &                              -MT(3,iT)*dY(iPl,iM)*H(iH)

                  ty(iPl,iM,iH,iT) = MT(3,iT)*dX(iPl,iM)*H(iH)
     &                              -MT(1,iT)*dZ(iPl,iM)*H(iH)

                  tz(iPl,iM,iH,iT) = MT(1,iT)*dY(iPl,iM)*H(iH)
     &                              -MT(2,iT)*dX(iPl,iM)*H(iH)

                  If (smagn) Then
                     sx(iPl,iM,iH,iT) = ST(2,iT)*dZ(iPl,iM)*H(iH)
     &                                 -ST(3,iT)*dY(iPl,iM)*H(iH)

                     sy(iPl,iM,iH,iT) = ST(3,iT)*dX(iPl,iM)*H(iH)
     &                                 -ST(1,iT)*dZ(iPl,iM)*H(iH)

                     sz(iPl,iM,iH,iT) = ST(1,iT)*dY(iPl,iM)*H(iH)
     &                                 -ST(2,iT)*dX(iPl,iM)*H(iH)
                 End If
               End Do !iT

c ///  closing the loops over field strengths and directions
          End Do ! iL
        End Do ! iM
      End Do ! iH
c -------------------------------------------------------------------
C   WRITING SOME OF THE OUTPUT....
C -------------------------------------------------------------------
      Write(6,*)
      Write(6,'(25X,A)') 'ANGULAR DEPENDENCE OF THE MAGNETIZATION '//
     &                   'TORQUE'
      Write(6,'(30X,A)') '(Units of torque: [energy, cm-1])'
      Write(6,*)

        Write(6,'(5x,A)') 'Orientation of the applied magnetic'//
     & ' field employed:'
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)

        Write(6,'(2x,A,3(10x,A))') 'Angle |',
     & 'rotation in the YZ plane          |',
     & 'rotation in the XZ plane          |',
     & 'rotation in the XY plane          |'
        Write(6,'(10A)') '--------|',
     & ('--- proj X ---|','--- proj Y ---|','--- proj Z ---|',i=1,3)
         Do iM=1,AngPoints
         Write(6,'(F7.3,1x,A,3(F13.10,1x,A,F13.10,1x,A,F13.10,1x,A))')
     &   Ang(iM),'|',
     &   ( dX(iPl,iM),' ',dY(iPl,iM),' ',dZ(iPl,iM),'|', iPl=1,3 )
           End Do
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)

      Do iH=1,nH
        Do iT=1,nTempMagn
        Write(6,*)
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)
        Write(6,'(A,F9.4,A)') 'Magnetic field strength = ',H(iH),
     &                        ' Tesla'
        Write(6,'(12x,A,F9.4,A)') 'Temperature = ',TempMagn(iT),
     &                            ' Kelvin'
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)

        Write(6,'(2x,A,3(10x,A))') 'Angle |',
     & 'rotation in the YZ plane          |',
     & 'rotation in the XZ plane          |',
     & 'rotation in the XY plane          |'
        Write(6,'(10A)') '--------|',
     & ('-- torque X --|','-- torque Y --|','-- torque Z --|',i=1,3)
         Do iM=1,AngPoints
         Write(6,'(F7.3,1x,A,3(E13.6,1x,A,E13.6,1x,A,E13.6,1x,A))')
     &   Ang(iM),'|',
     &   ( tx(iPl,iM,iH,iT),' ',
     &     ty(iPl,iM,iH,iT),' ',
     &     tz(iPl,iM,iH,iT),'|', iPl=1,3 )
           End Do
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)
        End Do !iT
      End Do !iH

C -------------------------------------------------------------------
      If(smagn) Then
      Write(6,*)
      Write(6,'(25X,A)') 'ANGULAR DEPENDENCE OF THE SPIN '//
     &                   'MAGNETIZATION TORQUE'
      Write(6,'(30X,A)') '(Units of torque: [energy, cm-1])'
      Write(6,*)

        Write(6,'(5x,A)') 'Orientation of the applied magnetic'//
     & ' field employed:'
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)

        Write(6,'(2x,A,3(10x,A))') 'Angle |',
     & 'rotation in the YZ plane          |',
     & 'rotation in the XZ plane          |',
     & 'rotation in the XY plane          |'
        Write(6,'(10A)') '--------|',
     & ('--- proj X ---|','--- proj Y ---|','--- proj Z ---|',i=1,3)
         Do iM=1,AngPoints
         Write(6,'(F7.3,1x,A,3(F13.10,1x,A,F13.10,1x,A,F13.10,1x,A))')
     &   Ang(iM),'|',
     &   ( dX(iPl,iM),' ',dY(iPl,iM),' ',dZ(iPl,iM),'|', iPl=1,3 )
           End Do
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)

      Do iH=1,nH
        Do iT=1,nTempMagn
        Write(6,*)
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)
        Write(6,'(A,F9.4,A)') 'Magnetic field strength = ',H(iH),
     &                        ' Tesla'
        Write(6,'(12x,A,F9.4,A)') 'Temperature = ',TempMagn(iT),
     &                            ' Kelvin'
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)

        Write(6,'(2x,A,3(10x,A))') 'Angle |',
     & 'rotation in the YZ plane          |',
     & 'rotation in the XZ plane          |',
     & 'rotation in the XY plane          |'
        Write(6,'(10A)') '--------|',
     & ('Spin torque X |','Spin torque Y |','Spin torque Z |',i=1,3)
         Do iM=1,AngPoints
         Write(6,'(F7.3,1x,A,3(E13.6,1x,A,E13.6,1x,A,E13.6,1x,A))')
     &   Ang(iM),'|',
     &   ( sx(iPl,iM,iH,iT),' ',
     &     sy(iPl,iM,iH,iT),' ',
     &     sz(iPl,iM,iH,iT),'|', iPl=1,3 )
           End Do
        Write(6,'(10A)') '--------|',
     & ('--------------------------------------------|',i=1,3)
        End Do !iT
      End Do !iH

      End If !smagn

! 199  Continue
!-----------------------------------------------------------------------
! Deallocate memory for this calculation:
      If(nM>=0) Then
         Call mma_deallocate(Wex)
      End If

      If(nTempMagn>=0) Then
         Call mma_deallocate(Zex)
         Call mma_deallocate(SEX)
         Call mma_deallocate(MEX)
         Call mma_deallocate(ZT)
         Call mma_deallocate(ST)
         Call mma_deallocate(MT)

         If(nneq>=0) Then
            Call mma_deallocate(ZL)
            Call mma_deallocate(SL)
            Call mma_deallocate(ML)
            Call mma_deallocate(ZR)
            Call mma_deallocate(SR)
            Call mma_deallocate(MR)
         End If

         If(nCenter>=0) Then
            Call mma_deallocate(ZRT)
            Call mma_deallocate(ZLT)
            Call mma_deallocate(MRT)
            Call mma_deallocate(MLT)
            Call mma_deallocate(SRT)
            Call mma_deallocate(SLT)
         End If

         If( (nPlanes>=0).and.(AngPoints>=0).and.(nH>=0) ) Then
            Call mma_deallocate(tx)
            Call mma_deallocate(ty)
            Call mma_deallocate(tz)
            Call mma_deallocate(sx)
            Call mma_deallocate(sy)
            Call mma_deallocate(sz)
         End If
      End If

      If((nLoc>=0).and.(nneq>=0)) Then
         Call mma_deallocate(WL)
         Call mma_deallocate(WR)
      End If

      If(AngPoints>=0) Then
         Call mma_deallocate(Ang)
         If(nPlanes>=0) Then
            Call mma_deallocate(dX)
            Call mma_deallocate(dY)
            Call mma_deallocate(dZ)
         End If
      End If

      If(nH>=0) Then
         Call mma_deallocate(H)
      End If

      If(dbg) Write(6,*) 'TORQ: allocated memory was sucessfully '//
     &                   'deallocated'

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagNS_Hel2(iCase,NBSQT,lT2AO,iSym,iSymA,iSymB,iSymI,iSymJ,nMaxOrb,ERI1,Amp1,Scr,DPT2C,T2AO)
! DMNS_{ijkl}*d(ij|kl)/dx -> (pj|kl)*D_{qjkl} + (ip|kl)*D_{iqkl}
!                          + (ij|pl)*D_{ijql} + (ij|kp)*D_{ijkq}

! Integrals needed:
! (OO|OO), (VO|OO), (VV|OO), (VO|VO), (VV|VO)
! -> <OO|OO>, <VO|OO>, <VO|VO>, <VV|OO>, <VV|VO>
! Here, O is occupied (doubly and partially) orbitals
!       V is not filled (partially and virtual) orbitals

! <**|VV> and <**|OO> are fetched by Exch
! <V*|V*> and <O*|O*> are fetched by Exch

! However, (*O|*O) is split into (*C|*C), (*C|*A), (*A|*A)
!          (V*|V*) is split into (A*|A*), (A*|V*), (V*|V*)
!          (*O|V*) is split into (*A|A*), (*A|V*)

use Symmetry_Info, only: Mul
use SUPERINDEX, only: KAGEB, KAGTB, KIGEJ, KIGTJ, KTGEU, KTGTU, KTU, KTUV
use EQSOLV, only: IVECC2
use fake_GA, only: GA_Arrays
use caspt2_global, only: OLag
use caspt2_module, only: HZERO, NACTEL, NAES, NAGEB, NAGEBES, NAGTB, NAGTBES, NASH, NASUP, NBAS, NBAST, NFRO, NIES, NIGEJES, &
                         NIGTJES, NISH, NISUP, NSES, NSSH, NSYM, NTGEUES, NTGTUES, NTU, NTUES, NTUVES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iCase, NBSQT, lT2AO, iSym, iSymA, iSymB, iSymI, iSymJ, nMaxOrb
real(kind=wp), intent(out) :: ERI1(NBSQT), Amp1(nMaxOrb,nMaxOrb), Scr(nMaxOrb,nMaxOrb)
real(kind=wp), intent(inout) :: DPT2C(NBSQT), T2AO(lT2AO)
integer(kind=iwp) :: iAabs, iAgeB, iAgtB, iAS, iASM, iASP, iAtot, iBabs, iBtot, IgeJ, IgtJ, iIabs, iIS, iISM, iISP, iItot, iJabs, &
                     iJtot, IO1, IO2, IOFF1(8), IOFF2(8), ipTC, ipTCM, ipTCP, iSymAB, iSymK, iTabs, iUabs, iVabs, iVaHM, iVaHP, &
                     iVaM, iVaP, iVHM, iVHP, iViHM, iViHM0, iViHP, iViHP0, iViM, iViP, iVjM, iVjP, IW1, nAS, nAshA, nAshB, nAshI, &
                     nAshJ, nASM, nASP, nBasA, nBasB, nBasI, nBasJ, nCorA, nCorB, nCorI, nCorJ, nFroA, nFroB, nFroI, nFroJ, nIS, &
                     nIshA, nIshB, nIshI, nIshJ, nISM, nISP, nJ, nOccA, nOccA2, nOccB, nOccB2, nOrbA, nSshA, nSshB
real(kind=wp) :: Fac, ONEADD, SQ2, SQ3, SQI2, ValA, ValBM, ValBP, ValC1, ValC2, ValD1, ValD2, ValEM, ValEP, ValFM, ValFP, ValGM, &
                 ValGP, ValHM, ValHP
logical(kind=iwp) :: PM
real(kind=wp), allocatable :: WRK1(:), WRK2(:)

! EXCH(ISYP,ISYI,ISYQ,ISYJ,II,IJ,ERI,SCR)

! rhs_mp2_help1

!! The amplitude is in the IC (internally contracted) basis, so
!! the active orbital index (indices) must be transformed to the
!! (quasi-)canonical MO (or contravatiant) basis.
!! IC = SR (why?), contravariant = C
!write(u6,*) 'icase = ',icase

if ((iCase == 2) .or. (iCase == 6) .or. (iCase == 8) .or. (iCase == 10) .or. (iCase == 12)) then
  PM = .true.
else
  PM = .false.
end if
if ((iCase == 3) .or. (iCase == 7) .or. (iCase == 9) .or. (iCase == 11) .or. (iCase == 13)) return

SQ2 = sqrt(Two)
SQI2 = One/SQ2
SQ3 = sqrt(Three)
!iVec = iVecX
IO1 = 0
IO2 = 0
do iSymK=1,nSym
  IOFF1(iSymK) = IO1
  IOFF2(iSymK) = IO2
  iSymAB = Mul(iSymK,iSym)
  IO1 = IO1+nIsh(iSymK)*nAgeB(iSymAB)
  IO2 = IO2+nIsh(iSymK)*nAgtB(iSymAB)
end do

!! Some setup
!! Read T-amplitude, hopefully in contravariant form
!nINP = 0
!nINM = 0
!nIN = 0
if (PM) then
  !nINP = nINDEP(iSym,iCase)
  nASP = nASup(iSym,iCase)
  nISP = nISup(iSym,iCase)
  !if (nINP /= 0) nVec = nINP*nISP
  !nINM = nINDEP(iSym,iCase+1)
  nASM = nASup(iSym,iCase+1)
  nISM = nISup(iSym,iCase+1)
  !if (nINM /= 0) nVec = nINM*nISM
  if (nASP*nISP /= 0) then
    call RHS_ALLO(nASP,nISP,ipTCP)
    call RHS_READ(nASP,nISP,ipTCP,iCase,iSym,iVecC2)
  end if
  if (nASM*nISM /= 0) then
    call RHS_ALLO(nASM,nISM,ipTCM)
    call RHS_READ(nASM,nISM,ipTCM,iCase+1,iSym,iVecC2)
  end if
else
  !nIN = nINDEP(iSym,iCase)
  nAS = nASup(iSym,iCase)
  nIS = nISup(iSym,iCase)
  !if (nIN /= 0) nVec = nIN*nIS
  if (nAS*nIS /= 0) then
    call RHS_ALLO(nAS,nIS,ipTC)
    call RHS_READ(nAS,nIS,ipTC,iCase,iSym,iVecC2)
  end if
end if

! finish if no contributions
! should we use the number of independent vectors?
if (PM) then
  if ((nASP*nISP == 0) .and. (nASM*nISM == 0)) return
else
  if (nAS*nIS == 0) return
end if

call mma_allocate(WRK1,nBasT*nBasT,Label='WRK1')
call mma_allocate(WRK2,nBasT*nBasT,Label='WRK2')

nFroI = nFro(iSymI)
nFroJ = nFro(iSymJ)
nFroA = nFro(iSymA)
nFroB = nFro(iSymB)
nIshI = nIsh(iSymI)
nIshJ = nIsh(iSymJ)
nIshA = nIsh(iSymA)
nIshB = nIsh(iSymB)
nAshI = nAsh(iSymI)
nAshJ = nAsh(iSymJ)
nAshA = nAsh(iSymA)
nAshB = nAsh(iSymB)
nSshA = nSsh(iSymA)
nSshB = nSsh(iSymB)
nBasI = nBas(iSymI)
nBasJ = nBas(iSymJ)
nBasA = nBas(iSymA)
nBasB = nBas(iSymB)

nCorI = nFroI+nIshI
nCorJ = nFroJ+nIshJ
nCorA = nFroA+nIshA
nCorB = nFroB+nIshB
nOccA = nCorA+nAshA
nOccB = nCorB+nAshB
nOccA2 = nOccA-nFroA
nOccB2 = nOccB-nFroB
nOrbA = nOccA+nSshA

!nOcc = nFro(iSym)+nIsh(iSym)+nAsh(iSym)

!! active+virtual part for the right index
!nJ = nFro(iSymJ)+nIsh(iSymJ)+nAsh(iSymJ)

if (iCase == 1) then
  call OLagNS_A(Amp1)
else if ((iCase == 2) .or. (iCase == 3)) then
  call OLagNS_B(Amp1)
else if (iCase == 4) then
  call OLagNS_C(Amp1)
else if (iCase == 5) then
  call OLagNS_D(Amp1)
else if ((iCase == 6) .or. (iCase == 7)) then
  call OLagNS_E(Amp1)
else if ((iCase == 8) .or. (iCase == 9)) then
  call OLagNS_F(Amp1)
else if ((iCase == 10) .or. (iCase == 11)) then
  call OLagNS_G(Amp1)
else if ((iCase == 12) .or. (iCase == 13)) then
  call OLagNS_H(Amp1)
end if

if ((iCase == 1) .and. (HZERO == 'DYALL')) call OLagNS_AAAA(Amp1)
call mma_deallocate(WRK1)
call mma_deallocate(WRK2)

if (PM) then
  if (nASP*nISP /= 0) call RHS_FREE(ipTCP)
  if (nASM*nISM /= 0) call RHS_FREE(ipTCM)
else
  if (nAS*nIS /= 0) call RHS_FREE(ipTC)
end if

return

contains

subroutine OLagNS_A(AmpL1)

  real(kind=wp), intent(out) :: AmpL1(nAshA,nAshB)
  integer(kind=iwp) :: iA, iB, iI, iJ

  if (nAshI*nIshJ*nAshA*nAshB == 0) return

  !nJ = nIshJ
  do iI=1,nAshI
    iIabs = iI+nIshI+nAes(iSymI)
    !iItot = iI + nCorI
    !if (iSymI == iSymJ) nJ = iI
    do iJ=1,nIshJ
      iJabs = iJ+nIes(iSymJ)
      iJtot = iJ+nFroJ
      !if (iIabs < iJabs) Cycle
      Fac = One
      !if ((iI /= iJ) .and. (iSymI == iSymJ)) Fac = Two
      if (iSymI /= iSymJ) Fac = Two

      call Exch(iSymA,iSymI,iSymB,iSymJ,iI+nCorI,iJ+nFroJ,ERI1,Scr)

      AmpL1(:,:) = Zero

      do iA=1,nAshA
        iAabs = iA+nAes(iSymA)
        !iAtot = iA+nCorA
        do iB=1,nAshB
          iBabs = iB+nAes(iSymB)
          iBtot = iB+nCorB

          iTabs = iBabs
          iUabs = iI+nAes(iSymI)
          iVabs = iAabs
          IW1 = kTUV(iTabs,iUabs,iVabs)-nTUVes(iSym)
          !ValA = Zero
          !do iICB=1,nIN
          !  iVA = iICB+nIN*(iJabs-1)
          !  ValA = ValA+Work(ipT+iVA-1)*Work(LST+IW1-1+nAS*(iICB-1))
          !end do
          !ValA = ValA*Two
          iIS = iJabs
          iAS = IW1
          ValA = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two

          !! For FIMO derivative
          if (iUabs == iVabs) DPT2C(iBtot+nOrbA*(iJtot-1)) = DPT2C(iBtot+nOrbA*(iJtot-1))+ValA

          AmpL1(iA,iB) = AmpL1(iA,iB)+ValA
        end do
      end do

      AmpL1(:,:) = AmpL1(:,:)*Fac

      !! Calculate the actual contributions
      !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
      call OLagNS_post1(1,1,ERI1,AmpL1)

      !! Prepare for implicit (VV|VO) integrals
      !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
      !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
      call OLagNS_post2(nAshA,nAshB,nCorA,nCorB,AmpL1,WRK2)
      !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
      call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
    end do
  end do

end subroutine OLagNS_A

subroutine OLagNS_B(AmpL1)

  real(kind=wp), intent(out) :: AmpL1(nAshA,nAshB)
  integer(kind=iwp) :: iA, iB, iI, iJ

  if (nIshI*nIshJ*nAshA*nAshB == 0) return

  nJ = nIshJ
  do iI=1,nIshI
    iIabs = iI+nIes(iSymI)
    !iItot = iI+nFroI
    if (iSymI == iSymJ) nJ = iI
    do iJ=1,nJ
      iJabs = iJ+nIes(iSymJ)
      !iJtot = iJ+nFroJ
      if (iIabs < iJabs) cycle
      Fac = One
      !if ((iI /= iJ) .and. (iSymI == iSymJ)) Fac = Two
      if (iSymI /= iSymJ) Fac = Two

      call Exch(iSymA,iSymI,iSymB,iSymJ,iI+nFroI,iJ+nFroJ,ERI1,Scr)

      AmpL1(:,:) = Zero

      do iA=1,nAshA
        iAabs = iA+nAes(iSymA)
        !iAtot = iA+nCorA
        do iB=1,nAshB
          iBabs = iB+nAes(iSymB)
          !iBtot = iB+nCorB

          if (iaabs > ibabs) then
            iTabs = iAabs
            iUabs = iBabs
          else
            iTabs = iBabs
            iUabs = iAabs
          end if
          iViP = kIgeJ(iIabs,iJabs)-nIgeJes(iSym) ! inactive
          iVaP = kTgeU(iTabs,iUabs)-nTgeUes(iSym) !   active
          iViM = kIgtJ(iIabs,iJabs)-nIgtJes(iSym)
          iVaM = kTgtU(iTabs,iUabs)-nTgtUes(iSym)
          !! transform internally contracted (SR)
          !!        to contravariant (C)
          ValBP = Zero
          ValBM = Zero
          !do iICB=1,nINP
          !  iVP  = iICB+nINP*(iViP-1)
          !  ValBP = ValBP+Work(ipTP+iVP-1)*Work(LSTP+iVaP-1+nASP*(iICB-1))
          !end do
          iIS = iViP
          iAS = iVaP
          ValBP = GA_Arrays(ipTCP)%A(iAS+nASP*(iIS-1))
          if ((iAabs /= iBabs) .and. (iIabs /= iJabs)) then
            if (iIabs /= iJabs) then
              !do iICB=1,nINM
              !  iVM = iICB+nINM*(iViM-1)
              !  ValBM = ValBM+Work(ipTM+iVM-1)*Work(LSTM+iVaM-1+nASM*(iICB-1))
              !end do
              iIS = iViM
              iAS = iVaM
              ValBM = GA_Arrays(ipTCM)%A(iAS+nASM*(iIS-1))
            end if
            !! permutated
            if (iAabs < iBabs) ValBM = -ValBM
          end if
          if (iIabs == iJabs) ValBP = ValBP*SQI2

          AmpL1(iA,iB) = AmpL1(iA,iB)+ValBP+ValBM
        end do
      end do

      AmpL1(:,:) = AmpL1(:,:)*Fac

      !! Calculate the actual contributions
      !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
      call OLagNS_post1(1,1,ERI1,AmpL1)

      !! Prepare for implicit (VV|VO) integrals
      !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
      !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
      call OLagNS_post2(nAshA,nAshB,nCorA,nCorB,AmpL1,WRK2)
      !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
      call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
    end do
  end do

end subroutine OLagNS_B

subroutine OLagNS_C(AmpL1)

  real(kind=wp), intent(out) :: AmpL1(nAshA+nSshA,nAshB+nSshB)
  integer(kind=iwp) :: iA, iB, iI, iJ, iXabs

  if (nAshI*nAshJ*nSshA*nAshB == 0) return

  !nJ = nIshJ
  do iI=1,nAshI
    iIabs = iI+nIshI+nAes(iSymI)
    !iItot = iI+nCorI
    !if (iSymI == iSymJ) nJ = iI
    do iJ=1,nAshJ
      iJabs = iJ+nIshJ+nAes(iSymJ)
      !iJtot = iJ+nCorJ
      if (iIabs < iJabs) cycle
      Fac = One
      !if ((iI /= iJ) .and. (iSymI == iSymJ)) Fac = Two
      if (iSymI /= iSymJ) Fac = Two

      call Exch(iSymA,iSymI,iSymB,iSymJ,iI+nCorI,iJ+nCorJ,ERI1,Scr)

      AmpL1(:,:) = Zero

      do iA=1,nSshA
        iAabs = iA+nSes(iSymA)
        iAtot = iA+nFroA+nIshA+nAshA
        do iB=1,nAshB
          iBabs = iB+nAes(iSymB)
          iBtot = iB+nCorB

          iTabs = iI+nAes(iSymI)
          iUabs = iBabs
          iVabs = iJ+nAes(iSymJ)
          !write(u6,*) itabs,iuabs,ivabs
          !! (at|uv) -> (ai|bj) -> (at|uv)
          !IW1 = kTUV(iTabs,iUabs,iVabs)-nTUVes(iSym)
          ValC1 = Zero
          ValC2 = Zero
          !do iICB=1,nIN
          !  iV = iICB+nIN*(iAabs-1)
          !  ValC1 = ValC1+Work(ipT+iV-1)*Work(LST+IW1-1+nAS*(iICB-1))
          !end do
          !if (iIabs /= iJabs) then
          !  IW1 = kTUV(iVabs,iUabs,iTabs)-nTUVes(iSym)
          !  do iICB=1,nIN
          !    iV = iICB+nIN*(iAabs-1)
          !    ValC2 = ValC2+Work(ipT+iV-1)*Work(LST+IW1-1+nAS*(iICB-1))
          !  end do
          !end if

          !ValC1 = ValC1*Two
          !ValC2 = ValC2*Two

          iIS = iAabs
          iAS = kTUV(iTabs,iUabs,iVabs)-nTUVes(iSym)
          ValC1 = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two
          if (iIabs /= iJabs) then
            iAS = kTUV(iVabs,iUabs,iTabs)-nTUVes(iSym)
            ValC2 = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two
          end if

          iTabs = iBabs
          iUabs = iI+nAes(iSymI)
          iVabs = iJ+nAes(iSymJ)
          if (iUabs == iVabs) then
            !! For FIMO derivative
            ONEADD = Zero
            !IW1 = kTUV(iTabs,iUabs,iVabs)-nTUVes(iSym)
            !do iICB=1,nIN
            !  iV = iICB+nIN*(iAabs-1)
            !  ONEADD = ONEADD+Work(ipT+iV-1)*Work(LST+IW1-1+nAS*(iICB-1))
            !end do
            !ONEADD = ONEADD*Two
            iAS = kTUV(iTabs,iUabs,iVabs)-nTUVes(iSym)
            ONEADD = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two
            DPT2C(iAtot+nOrbA*(iBtot-1)) = DPT2C(iAtot+nOrbA*(iBtot-1))+ONEADD

            !! For -sum(y)(ay,yt) -> (ay,ty) derivative
            !! It is correct, but should be rewritten
            !ONEADD = Zero
            !do iXabs=1,nAshI !?
            !  IW1 = kTUV(iTabs,iXabs,iXabs)-nTUVes(iSym)
            !  do iICB=1,nIN
            !    iV = iICB+nIN*(iAabs-1)
            !    ONEADD = ONEADD+Work(ipT+iV-1)*Work(LST+IW1-1+nAS*(iICB-1))
            !  end do
            !end do
            !ONEADD = Two*ONEADD/real(MAX(1,NACTEL),kind=wp)
            ONEADD = Zero
            do iXabs=1,nAshI !?
              iAS = kTUV(iTabs,iXabs,iXabs)-nTUVes(iSym)
              ONEADD = ONEADD+GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))
            end do
            ONEADD = Two*ONEADD/real(max(1,NACTEL),kind=wp)
            AmpL1(iAtot-nCorA,iBtot-nCorA) = AmpL1(iAtot-nCorA,iBtot-nCorA)-ONEADD
          end if
          AmpL1(iAtot-nCorA,iBtot-nCorB) = AmpL1(iAtot-nCorA,iBtot-nCorB)+ValC1
          AmpL1(iBtot-nCorB,iAtot-nCorA) = AmpL1(iBtot-nCorB,iAtot-nCorA)+ValC2
        end do
      end do

      AmpL1(:,:) = AmpL1(:,:)*Fac

      !! Calculate the actual contributions
      !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
      call OLagNS_post1(3,3,ERI1,AmpL1)

      !! Prepare for implicit (VV|VO) integrals
      !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
      !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
      call OLagNS_post2(nAshA+nSshA,nAshB+nSshB,nCorA,nCorB,AmpL1,WRK2)
      !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
      call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
    end do
  end do

end subroutine OLagNS_C

subroutine OLagNS_D(AmpL1)

  real(kind=wp), intent(out) :: AmpL1(nAshA+nSshA,nAshB+nSshB)
  integer(kind=iwp) :: iA, iB, iI, iJ

  if (nAshI*nIshJ*nSshA*nAshB == 0) return

  !nJ = nIshJ
  do iI=1,nAshI
    iIabs = iI+nIshI+nAes(iSymI)
    iItot = iI+nCorI
    !if (iSymI == iSymJ) nJ = iI
    do iJ=1,nIshJ
      iJabs = iJ+nIes(iSymJ)
      iJtot = iJ+nFroJ
      !if (iIabs < iJabs) cycle
      Fac = One
      !if ((iI /= iJ) .and. (iSymI == iSymJ)) Fac = Two
      if (iSymI /= iSymJ) Fac = Two

      call Exch(iSymA,iSymI,iSymB,iSymJ,iI+nCorI,iJ+nFroJ,ERI1,Scr)

      AmpL1(:,:) = Zero

      do iA=1,nSshA
        iAabs = iA+nSes(iSymA)
        iAtot = iA+nFroA+nIshA+nAshA
        do iB=1,nAshB
          !iBabs = iB+nAes(iSymB)
          iBtot = iB+nCorB

          !iVi = iJabs+nIshA*(iAabs-1)+IOFF1(iSymA)
          !iVa1 = iB+nAshB*(iI+nAes(iSymI)-1)+IOFF1(iSymB)
          !iVa2 = iB+nAshB*(iI+nAes(iSymI)-1)+IOFF1(iSymB)+nAshT*nAshT
          !! transform internally contracted (SR)
          !!        to contravariant (C)
          !ValD1 = Zero
          !ValD2 = Zero
          !do iICB=1,nIN
          !  iVD = iICB+nIN*(iVi-1)
          !  ValD1 = ValD1+Work(ipT+iVD-1)*Work(LST+iVa1-1+nAS*(iICB-1))
          !  ValD2 = ValD2+Work(ipT+iVD-1)*Work(LST+iVa2-1+nAS*(iICB-1))
          !end do
          !ValD1 = ValD1*Two
          !ValD2 = ValD2*Two
          iIS = iJabs+nIshA*(iAabs-1)+iOFF1(iSymA)
          iAS = kTU(iB,iI)-nTUes(iSymA)
          ValD1 = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two
          iAS = iAS+nTU(iSymA)
          ValD2 = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two

          !! Fock contributions from the inactive density
          if (iItot == iBtot) DPT2C(iAtot+nOrbA*(iJtot-1)) = DPT2C(iAtot+nOrbA*(iJtot-1))+ValD1

          AmpL1(iA+nAshA,iB) = AmpL1(iA+nAshA,iB)+ValD2
          AmpL1(iB,iA+nAshB) = AmpL1(iB,iA+nAshB)+ValD1
        end do
      end do

      AmpL1(:,:) = AmpL1(:,:)*Fac

      !! Calculate the actual contributions
      !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
      call OLagNS_post1(3,3,ERI1,AmpL1)

      !! Prepare for implicit (VV|VO) integrals
      !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
      !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
      call OLagNS_post2(nAshA+nSshA,nAshB+nSshB,nCorA,nCorB,AmpL1,WRK2)
      !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
      call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
    end do
  end do

end subroutine OLagNS_D

subroutine OLagNS_E(AmpL1)

  real(kind=wp), intent(out) :: AmpL1(nAshA+nSshA,nAshB+nSshB)
  integer(kind=iwp) :: iA, iB, iI, iJ

  if (nIshI*nIshJ*nSshA*nAshB == 0) return

  nJ = nIshJ
  do iI=1,nIshI
    iIabs = iI+nIes(iSymI)
    !iItot = iI
    if (iSymI == iSymJ) nJ = iI
    do iJ=1,nJ
      iJabs = iJ+nIes(iSymJ)
      !iJtot = iJ
      if (iIabs < iJabs) cycle
      Fac = One
      !if ((iI /= iJ) .and. (iSymI == iSymJ)) Fac = Two
      if (iSymI /= iSymJ) Fac = Two

      call Exch(iSymA,iSymI,iSymB,iSymJ,iI+nFroI,iJ+nFroJ,ERI1,Scr)

      AmpL1(:,:) = Zero

      IgeJ = kIgeJ(iIabs,iJabs)-nIgeJes(iSym) ! iSymIJ
      IgtJ = kIgtJ(iIabs,iJabs)-nIgtJes(iSym) ! iSymIJ
      do iA=1,nSshA
        iAabs = iA+nSes(iSymA)
        !iAtot = iA+nIshA+nAshA
        do iB=1,nAshB
          iBabs = iB+nAes(iSymB)
          !iBtot = iB+nIshB

          iASP = iBabs
          iISP = iAabs+nSshA*(IgeJ-1)+iOFF1(iSymA)
          ValEP = GA_Arrays(ipTCP)%A(iASP+nASP*(iISP-1))
          ValEM = Zero
          if (iIabs > iJabs) then
            ValEP = ValEP*SQ2
            iASM = iBabs
            iISM = iAabs+nSshA*(IgtJ-1)+iOFF1(iSymA)
            ValEM = GA_Arrays(ipTCM)%A(iASM+nASM*(iISM-1))*SQ2*SQ3
          end if

          AmpL1(iA+nAshA,iB) = AmpL1(iA+nAshA,iB)+ValEP+ValEM
          AmpL1(iB,iA+nAshB) = AmpL1(iB,iA+nAshB)+ValEP-ValEM
        end do
      end do

      AmpL1(:,:) = AmpL1(:,:)*Fac

      !! Calculate the actual contributions
      !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
      call OLagNS_post1(3,3,ERI1,AmpL1)

      !! Prepare for implicit (VV|VO) integrals
      !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
      !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
      call OLagNS_post2(nAshA+nSshA,nAshB+nSshB,nCorA,nCorB,AmpL1,WRK2)
      !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
      call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
    end do
  end do

end subroutine OLagNS_E

subroutine OLagNS_F(AmpL1)

  real(kind=wp), intent(out) :: AmpL1(nSshA,nSshB)
  integer(kind=iwp) :: iA, iB, iI, iJ

  if (nAshI*nAshJ*nSshA*nSshB == 0) return

  !nJ = nIshJ
  do iI=1,nAshI
    iIabs = iI+nIshI+nAes(iSymI)
    !iItot = iI+nCorI
    !if (iSymI == iSymJ) nJ = iI
    do iJ=1,nAshI
      iJabs = iJ+nIshJ+nIes(iSymJ)
      !iJtot = iJ+nCorJ
      if (iIabs < iJabs) cycle
      Fac = One
      !if ((iI /= iJ) .and. (iSymI == iSymJ)) Fac = Two
      if (iSymI /= iSymJ) Fac = Two

      call Exch(iSymA,iSymI,iSymB,iSymJ,iI+nCorI,iJ+nCorJ,ERI1,Scr)

      AmpL1(:,:) = Zero

      iTabs = iI+nAes(iSymI)
      iUabs = iJ+nAes(iSymJ)
      do iA=1,nSshA
        iAabs = iA+nSes(iSymA)
        !iAtot = iA+nIsh(iSymA)+nAsh(iSymA)
        do iB=1,nSshB
          iBabs = iB+nSes(iSymB)
          if (iAabs < iBabs) cycle
          !iBtot = iB+nIsh(iSymB)+nAsh(iSymB)

          iASP = kTgeU(iTabs,iUabs)-nTgeUes(iSym)
          iISP = kAgeB(iAabs,iBabs)-nAgeBes(iSym)
          ValFP = GA_Arrays(ipTCP)%A(iASP+nASP*(iISP-1))
          if (iIabs == iJabs) ValFP = ValFP*Half
          ValFM = Zero
          if (iAabs /= iBabs) then
            if (iTabs /= iUabs) then
              iASM = kTgtU(iTabs,iUabs)-nTgtUes(iSym)
              iISM = kAgtB(iAabs,iBabs)-nAgtBes(iSym)
              ValFM = GA_Arrays(ipTCM)%A(iASM+nASM*(iISM-1))
            end if
          else
            ValFP = ValFP*SQI2
          end if
          VALFM = -VALFM !! why?

          AmpL1(iA,iB) = AmpL1(iA,iB)+ValFP+ValFM
          AmpL1(iB,iA) = AmpL1(iB,iA)+ValFP-ValFM
        end do
      end do

      AmpL1(:,:) = AmpL1(:,:)*Fac

      !! Calculate the actual contributions
      !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
      call OLagNS_post1(2,2,ERI1,AmpL1)

      !! Prepare for implicit (VV|VO) integrals
      !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
      !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
      call OLagNS_post2(nSshA,nSshB,nOccA,nOccB,AmpL1,WRK2)
      !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
      call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
    end do
  end do

end subroutine OLagNS_F

subroutine OLagNS_G(AmpL1)

  real(kind=wp), intent(out) :: AmpL1(nSshA,nSshB)
  integer(kind=iwp) :: iA, iB, iI, iJ

  if (nAshI*nIshJ*nSshA*nSshB == 0) return

  !nJ = nIshJ
  do iI=1,nAshI
    iIabs = iI+nIshI+nAes(iSymI)
    !iItot = iI + nCorI
    !if (iSymI == iSymJ) nJ = iI
    do iJ=1,nIshI
      iJabs = iJ+nIes(iSymJ)
      !iJtot = iJ
      !if (iIabs < iJabs) cycle
      Fac = One
      !if ((iI /= iJ) .and. (iSymI == iSymJ)) Fac = Two
      if (iSymI /= iSymJ) Fac = Two

      call Exch(iSymA,iSymI,iSymB,iSymJ,iI+nCorI,iJ+nFroJ,ERI1,Scr)

      AmpL1(:,:) = Zero

      do iA=1,nSshA
        iAabs = iA+nSes(iSymA)
        !iAtot = iA+nIsh(iSymA)+nAsh(iSymA)
        do iB=1,nSshB
          iBabs = iB+nSes(iSymB)
          if (iAabs < iBabs) cycle
          !iBtot = iB+nIsh(iSymB)+nAsh(iSymB)

          iAgeB = kAgeB(iAabs,iBabs)-nAgeBes(iSym) !! iSymAB
          iVjP = iJ+nIsh(iSymJ)*(iAgeB-1)+IOFF1(iSymJ)
          ValGP = GA_Arrays(ipTCP)%A(iI+nASP*(iVjP-1))
          ValGM = Zero
          if (iAabs /= iBabs) then
            ValGP = ValGP*SQ2
            iAgtB = kAgtB(iAabs,iBabs)-nAgtBes(iSym) !! iSymAB
            iVjM = iJ+nIsh(iSymJ)*(iAgtB-1)+IOFF2(iSymJ)
            ValGM = GA_Arrays(ipTCM)%A(iI+nASM*(iVjM-1))*SQ2*SQ3
          end if

          AmpL1(iA,iB) = AmpL1(iA,iB)+ValGP+ValGM
          AmpL1(iB,iA) = AmpL1(iB,iA)+ValGP-ValGM
        end do
      end do

      AmpL1(:,:) = AmpL1(:,:)*Fac

      !! Calculate the actual contributions
      !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
      call OLagNS_post1(2,2,ERI1,AmpL1)
      !call DGEMM_('N','T',nOrbA,nSshA,nSshB,One,ERI1(1+nOrbA*nOccB),nOrbA,AmpL1,nSshA,One,OLAG(nOrbA*nOccB+1),nOrbA)
      !call DGEMM_('T','N',nOrbA,nSshA,nSshB,One,ERI1(nOccA+1),nOrbA,AmpL1,nSshA,One,OLAG(nOrbA*nOccB+1),nOrbA)

      !! Prepare for implicit (VV|VO) integrals
      !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
      !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu} for all ij
      call OLagNS_post2(nSshA,nSshB,nOccA,nOccB,AmpL1,WRK2)
      !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
      call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
    end do
  end do

end subroutine OLagNS_G

subroutine OLagNS_H(AmpL1)

  real(kind=wp), intent(out) :: AmpL1(nSshA,nSshB)
  integer(kind=iwp) :: iA, iB, iI, iJ

  if (nIshI*nIshJ*nSshA*nSshB == 0) return

  nJ = nIshJ
  do iI=1,nIshI
    iIabs = iI+nIes(iSymI)
    !iItot = iI
    if (iSymI == iSymJ) nJ = iI
    do iJ=1,nJ
      iJabs = iJ+nIes(iSymJ)
      !iJtot = iJ
      if (iIabs < iJabs) cycle
      Fac = One
      !if ((iI /= iJ) .and. (iSymI == iSymJ)) Fac = Two
      if (iSymI /= iSymJ) Fac = Two

      call Exch(iSymA,iSymI,iSymB,iSymJ,iI+nFroI,iJ+nFroJ,ERI1,Scr)

      AmpL1(:,:) = Zero

      iViHP0 = kIgeJ(iIabs,iJabs)-nIgeJes(iSym)
      iViHP = nAgeB(iSym)*(iViHP0-1)
      iViHM0 = kIgtJ(iIabs,iJabs)-nIgtJes(iSym)
      iViHM = nAgtB(iSym)*(iViHM0-1)
      do iA=1,nSshA
        iAabs = iA+nSes(iSymA)
        !iAtot = iA+nIsh(iSymA)+nAsh(iSymA)
        do iB=1,nSshB
          iBabs = iB+nSes(iSymB)
          if (iAabs < iBabs) cycle
          !iBtot = iB+nIsh(iSymB)+nAsh(iSymB)
          iVaHP = kAgeB(iAabs,iBabs)-nAgeBes(iSym)
          iVHP = iVaHP+iViHP !! nAgeB(iSym)*(iViP-1)

          ValHP = GA_Arrays(ipTCP)%A(iVHP)
          ValHM = Zero
          if (iIabs /= iJabs) then
            if (iAabs /= iBabs) then
              ValHP = ValHP*Two
              iVaHM = kAgtB(iAabs,iBabs)-nAgtBes(iSym)
              iVHM = iVaHM+iViHM !! nAgtB(iSym)*(iViM-1)
              ValHM = GA_Arrays(ipTCM)%A(iVHM)*Two*SQ3
            else
              ValHP = ValHP*SQ2
            end if
          else
            if (iAabs /= iBabs) ValHP = ValHP*SQ2
          end if

          !write(u6,'(2i3,2f20.10)') ia,ib,valhp,valhm
          AmpL1(iA,iB) = AmpL1(iA,iB)+ValHP+ValHM
          AmpL1(iB,iA) = AmpL1(iB,iA)+ValHP-ValHM
        end do
      end do

      AmpL1(:,:) = AmpL1(:,:)*Fac

      !! Calculate the actual contributions
      !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
      call OLagNS_post1(2,2,ERI1,AmpL1)
      !call DGEMM_('N','T',nOrbA,nSshA,nSshB,One,ERI1(1+nOrbA*nOccB),nOrbA,AmpL1,nSshA,One,OLAG(nOrbA*nOccB+1),nOrbA)
      !call DGEMM_('T','N',nOrbA,nSshA,nSshB,One,ERI1(nOccA+1),nOrbA,AmpL1,nSshA,One,OLAG(nOrbA*nOccB+1),nOrbA)

      !! Prepare for implicit (VV|VO) integrals
      !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
      !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu} for all ij
      call OLagNS_post2(nSshA,nSshB,nOccA,nOccB,AmpL1,WRK2)
      !call DGEMM_('N','N',nBasT,nSshA,nSshB,One,CMOPT2(1+nBasT*nOccB),nBasT,AmpL1,nSshA,Zero,WRK1,nBasT)
      !call DGEMM_('N','T',nBasT,nBasT,nSshB,One,WRK1,nBasT,CMOPT2(1+nBasT*nOccA),nBasT,Zero,WRK2,nBasT)
      !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
      call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
      !do iBas=1,nBasT
      !  do jBas=1,nBasT
      !    loc1 = iJ-1+(jBas-1)*nOccA2+(iI-1)*nOccA2*nBasT+(iBas-1)*nOccA2*nBasT*nOccA2
      !    loc2 = iI-1+(jBas-1)*nOccA2+(iJ-1)*nOccA2*nBasT+(iBas-1)*nOccA2*nBasT*nOccA2
      !    loc3 = iBas-1+(jBas-1)*nBasT
      !    loc4 = jBas-1+(iBas-1)*nBasT
      !    T2AO(1+loc1) = T2AO(1+loc1)+WRK2(1+loc3)
      !    T2AO(1+loc2) = T2AO(1+loc2)+WRK2(1+loc4)
      !  end do
      !end do
    end do
  end do

end subroutine OLagNS_H

subroutine OLagNS_post1(iLeft,iRight,ERI,AmpMO)

  integer(kind=iwp), intent(in) :: iLeft, iRight
  real(kind=wp), intent(in) :: ERI(NBSQT), AmpMO(NBSQT)
  integer(kind=iwp) :: nDimA, nDimB, nSkpA, nSkpB

  nSkpA = 0
  nSkpB = 0
  nDimA = 0
  nDimB = 0
  if (iLeft == 1) then
    nDimA = nAshA
    nSkpA = nCorA
  else if (iLeft == 2) then
    nDimA = nSshA
    nSkpA = nOccA
  else if (iLeft == 3) then
    nDimA = nAshA+nSshA
    nSkpA = nCorA
  end if
  if (iRight == 1) then
    nDimB = nAshB
    nSkpB = nCorB
  else if (iRight == 2) then
    nDimB = nSshB
    nSkpB = nOccB
  else if (iRight == 3) then
    nDimB = nAshB+nSshB
    nSkpB = nCorB
  end if

  call DGEMM_('N','T',nOrbA,nDimA,nDimB,One,ERI(1+nOrbA*nSkpB),nOrbA,AmpMO,nDimA,One,OLAG(nOrbA*nSkpB+1),nOrbA)
  call DGEMM_('T','N',nOrbA,nDimA,nDimB,One,ERI(nSkpA+1),nOrbA,AmpMO,nDimA,One,OLAG(nOrbA*nSkpB+1),nOrbA)

end subroutine OLagNS_post1

subroutine OLagNS_post2(nDimA,nDimB,nSkpA,nSkpB,AmpMO,AmpAO)

  use caspt2_global, only: CMOPT2

  integer(kind=iwp), intent(in) :: nDimA, nDimB, nSkpA, nSkpB
  real(kind=wp), intent(in) :: AmpMO(nDimA,nDimB)
  real(kind=wp), intent(out) :: AmpAO(nBasA,nBasB)

  call DGEMM_('N','N',nBasA,nDimB,nDimA,One,CMOPT2(1+nBasA*nSkpA),nBasA,AmpMO,nDimA,Zero,WRK1,nBasA)
  call DGEMM_('N','T',nBasA,nBasB,nDimB,One,WRK1,nBasA,CMOPT2(1+nBasB*nSkpB),nBasA,Zero,AmpAO,nBasA)

end subroutine OLagNS_post2

subroutine OLagNS_post3(iIabs,iJabs,TampAO,TampIJ)

  integer(kind=iwp), intent(in) :: iIabs, iJabs
  real(kind=wp), intent(inout) :: TampAO(nOccA2,nBasI,nOccB2,nBasJ)
  real(kind=wp), intent(in) :: TampIJ(nBasI,nBasJ)
  integer(kind=iwp) :: iBas

  do iBas=1,nBasI
    ! FIXME: this can't work if iBas /= jBas
    TampAO(iJabs,:,iIabs,iBas) = TampAO(iJabs,:,iIabs,iBas)+TampIJ(iBas,:)
    TampAO(iIabs,:,iJabs,iBas) = TampAO(iIabs,:,iJabs,iBas)+TampIJ(:,iBas)
  end do

end subroutine OLagNS_post3

subroutine OLagNS_AAAA(AmpL1)

  use BDerNEV, only: Gder

  real(kind=wp), intent(inout) :: AmpL1(nAshA,nAshB)
  integer(kind=iwp) :: iA, iB, iI, iJ

  if (nAshI*nAshJ*nAshA*nAshB == 0) return

  do iI=1,nAshI
    iIabs = iI+nIshI+nAes(iSymI)
    do iJ=1,nAshJ
      iJabs = iJ+nIshJ+nAes(iSymJ)
      !Fac = One

      call Exch(iSymA,iSymI,iSymB,iSymJ,iI+nCorI,iJ+nCorJ,ERI1,Scr)
      AmpL1(:,:) = Zero

      do iA=1,nAshA
        iAabs = iA+nAes(iSymA)
        do iB=1,nAshB
          iBabs = iB+nAes(iSymB)
          ValA = Gder(iAabs,iI,iBabs,iJ)
          AmpL1(iA,iB) = AmpL1(iA,iB)+ValA
        end do
      end do

      !AmpL1(:,:) = Fac*AmpL1(:,:)
      call OLagNS_post1(1,1,ERI1,AmpL1)
      call OLagNS_post2(nAshA,nAshB,nCorA,nCorB,AmpL1,WRK2)
      call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
    end do
  end do

end subroutine OLagNS_AAAA

end subroutine OLagNS_Hel2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function D_Bend(Ind,iOp_,nSym)

use Slapaf_Info, only: jStab, nStab
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: D_Bend
integer(kind=iwp), intent(in) :: Ind(3), iOp_(3), nSym
integer(kind=iwp) :: iAtom, ideg, iOp_E, iOp_ER, iOp_ET, iOp_R, iOp_T, iU_A, iU_AB, iU_ABC, iU_AC, iU_B, iU_C, jAtom, mAtom, nU_A, &
                     nU_ABC, nU_B, nU_C
integer(kind=iwp), external :: iU, iUR, nU

!                                                                      *
!***********************************************************************
!                                                                      *
! B E N D  (iAtom,mAtom,jAtom)

D_Bend = Zero

iAtom = Ind(1)
mAtom = Ind(2)
jAtom = Ind(3)
iOp_E = iOp_(1)
iOp_R = iOp_(2)
iOp_T = iOp_(3)

! Pick up the dimension of the stabilizer and store the operator
! indices in iU_*

nU_A = nStab(iAtom)
iU_A = iU(jStab(0,iAtom),nU_A)

nU_B = nStab(mAtom)
iU_B = iU(jStab(0,mAtom),nU_B)

nU_C = nStab(jAtom)
iU_C = iU(jStab(0,jAtom),nU_C)

!write(u6,*) ' U_A',iU_A,nU_A
!write(u6,*) ' U_B',iU_B,nU_B
!write(u6,*) ' U_C',iU_C,nU_C

! Form the stabilizer for ((iAtom,mAtom),jAtom)

if ((iAtom == mAtom) .and. (iAtom == jAtom)) then

  ! A-R(A)-T(A)

  iOp_ER = ieor(iOp_E,iOp_R)
  iU_AB = ior(iU_A,iUR(iOp_ER,iU_A))
  iOp_ET = ieor(iOp_E,iOp_T)
  iU_ABC = ior(iU_AB,iUR(iOp_ET,iU_C))
else if (iAtom == jAtom) then

  ! A-R(B)-T(A)

  iOp_ET = ieor(iOp_E,iOp_T)
  iU_AC = ior(iU_A,iUR(iOp_ET,iU_C))
  iU_ABC = iand(iU_AC,iU_B)
else if (mAtom == jAtom) then

  ! A-R(B)-T(B)

  iU_ABC = iand(iU_A,iU_C)
else if (iAtom == mAtom) then

  ! A-R(A)-T(C)

  iU_ABC = iand(iU_A,iU_C)
else

  ! A-R(B)-T(C)

  iU_AB = iand(iU_A,iU_B)
  iU_ABC = iand(iU_AB,iU_C)
end if
nU_ABC = nU(iU_ABC)

! Compute the degeneracy of the angle

ideg = nSym/nU_ABC
D_Bend = real(iDeg,kind=wp)

!write(u6,*) ' D_Bend=',D_Bend

return

end function D_Bend

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE IJKL(INTSYM,INDX,C,S,FIJKL)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION INTSYM(*),INDX(*),C(*),S(*),
     *          FIJKL(*)
*
      JSYM(L)=JSUNP(INTSYM,L)
*------
* POW: Unnecessary but warning stopping initialization
      fini=1.0d30
*------
      ICHK=0
      NIJ=IROW(LN+1)
      NIJKL=NIJ*(NIJ+1)/2
      CALL FZERO(FIJKL,NIJKL)
      IADR=LASTAD(1)
201   CALL dDAFILE(Lu_70,2,VALSRT,NSRTMX,IADR)
      CALL iDAFILE(Lu_70,2,INDSRT,NSRTMX+2,IADR)
      LENGTH=INDSRT(NSRTMX+1)
      IADR=INDSRT(NSRTMX+2)
*       IF(LENGTH.GT.0) CALL SCATTER(LENGTH,FIJKL,INDSRT,VALSRT)
      do i=1,length
        FIJKL(INDSRT(i))=VALSRT(i)
      end do
      IF(IADR.NE.-1) GO TO 201
      IADD10=IAD10(5)
100   CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 100
      IF(LEN.LT.0)GO TO 200
      DO 10 IN=1,LEN
      IND=ICOP1(IN)
      IF(ICHK.NE.0) THEN
        ICHK=0
        INDI=IND
*        IP=MOD(INDI,2**8)
*        JP=MOD(INDI/2**8,2**8)
*        KP=MOD(INDI/2**16,2**8)
*        LP=MOD(INDI/2**24,2**8)
      IP=IBITS(INDI, 0,8)
      JP=IBITS(INDI, 8,8)
      KP=IBITS(INDI,16,8)
      LP=IBITS(INDI,24,8)
        NIJ=IROW(IP)+JP
        NKL=IROW(KP)+LP
        IND=NIJ*(NIJ-1)/2+NKL
        FINI=FIJKL(IND)
        GOTO 10
      END IF
      IF(IND.EQ.0) THEN
        ICHK=1
        GOTO 10
      END IF
*      IVL=MOD(IND,2**6)
*      IC2=MOD(IND/2**6,2**13)
*      IC1=MOD(IND/2**19,2**13)
      IVL=IBITS(IND, 0, 6)
      IC2=IBITS(IND, 6,13)
      IC1=IBITS(IND,19,13)
      COPI=COP(IN)*FINI
      IF(IVL.EQ.0) THEN
        S(IC1)=S(IC1)+COPI*C(IC2)
        S(IC2)=S(IC2)+COPI*C(IC1)
        GO TO 10
      END IF
      INDA=IRC(IVL)+IC1
      INDB=IRC(IVL)+IC2
      NA=INDX(INDA)
      NB=INDX(INDB)
      NS1=JSYM(INDA)
      NS1L=MUL(NS1,LSYM)
      INUM=NVIR(NS1L)
      IF(IVL.GE.2)INUM=NVPAIR(NS1L)
      CALL DAXPY_(INUM,COPI,C(NB+1),1,S(NA+1),1)
      CALL DAXPY_(INUM,COPI,C(NA+1),1,S(NB+1),1)
10    CONTINUE
      GO TO 100
200   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine r2elint(rKappa,rMO1,rmo2,FockI,FockA,iDSym,Sgn,Fact,jspin)
!***********************************************************************
!
! Constructs the one index transformed Fock-matrixes
! and (pj|kl).
! rKappa : the transformation matrix
! iDSym  : Symmetry of transformation
! Sgn    : 1:real -1:complex
! jspin  : 0:singlet 1:triplet
!
!***********************************************************************

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use MCLR_Data, only: CMO, FAMO, FIMO, G1t, ipCM, ipMat, nA, nCMO, nDens, nMBA
use input_mclr, only: CasInt, iMethod, nAsh, nBas, nIsh, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: rKappa(nDens), Sgn, Fact
real(kind=wp), intent(inout) :: rMO1(nMba), rmo2(*)
real(kind=wp), intent(out) :: FockI(nDens), FockA(nDens)
integer(kind=iwp), intent(in) :: iDSym, jSpin
integer(kind=iwp) :: i, iA, iB, ip, ip2, iS, jA, jB, jS, nDens22
real(kind=wp) :: FacR
logical(kind=iwp) :: lFA, lFI, lMo
real(kind=wp), allocatable :: DA(:), DI(:), FA(:), FI(:), T1(:), T3(:), T4(:), Tmp2(:)

nDens22 = nDens
do i=1,nSym
  nDens22 = max(nDens22,maxval(nBas(i)*nBas(1:nSym)))
end do

call mma_allocate(T1,nDens22,Label='T1')
call mma_allocate(Tmp2,nDens22,Label='Tmp2')
call mma_allocate(T3,nDens22,Label='T3')
call mma_allocate(T4,nDens22,Label='T4')
call mma_allocate(DI,nCMO,Label='DI')
call mma_allocate(FI,nDens,Label='FI')

FockI(:) = Zero
FockA(:) = Zero
FI(:) = Zero
DI(:) = Zero
lFI = .true.
lFa = .false.
lMo = .false.
if (iMethod == 2) then
  call mma_allocate(DA,nCMO,Label='DA')
  call mma_allocate(FA,nDens,Label='FA')
  lFa = .true.
  lMo = .true.
else
  call mma_allocate(DA,1,Label='DA')
  call mma_allocate(FA,1,Label='FA')
end if
FA(:) = Zero
DA(:) = Zero

do iS=1,nSym
  do iB=1,nIsh(iS)
    ip = ipCM(iS)+(iB-1)*nOrb(iS)+iB-1
    DI(ip) = Two
  end do
end do
if (iMethod == 2) then
  do iS=1,nSym
    do iB=1,nAsh(iS)
      do jB=1,nAsh(iS)
        ip = ipCM(iS)+iB+nIsh(iS)+(jB+nIsh(iS)-1)*nOrb(iS)-1
        iA = nA(iS)+iB
        jA = nA(iS)+jB
        ip2 = iTri(iA,jA)
        DA(ip) = G1t(ip2)
      end do
    end do
  end do
end if

! Construct {kappa,(ij|kl)} and the fock matrix contribution
! from one index tranformation of contracted indexes

FacR = Fact
call Read2_2(rmo1,rmo2,FockI,FockA,T1,Tmp2,T3,T4,nDens22,DI,DA,rkappa,idsym,Sgn,Facr,jSpin,lFA,lfi,lMo)

!call recprt('1 FockI','',FockI,nDens,1)
!call recprt('1 FockA','',FockA,nDens,1)

! Calculate contribution from uncontracted indexes.

do iS=1,nSym
  jS = Mul(iS,iDSym)
  if (nOrb(iS)*nOrb(jS) /= 0) then
    if (.not. CASINT) &
      call DGEMM_('T','N',nOrb(iS),nOrb(jS),nBas(iS),One,CMO(ipCM(iS)),nBas(iS),FI(ipMat(iS,jS)),nBas(iS),Zero, &
                  FockI(ipMat(iS,jS)),nOrb(iS))
    call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(iS),Sgn*Facr,FIMO(ipCM(iS)),nOrb(is),rkappa(ipMat(iS,jS)),nOrb(iS),One, &
                FockI(ipMat(iS,jS)),nOrb(iS))
    call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(jS),Facr,rkappa(ipMat(iS,jS)),nOrb(is),FIMO(ipCM(jS)),nOrb(jS),One, &
                FockI(ipMat(iS,jS)),nOrb(is))
    if (iMethod == 2) then
      if (.not. CASINT) &
        call DGEMM_('T','N',nOrb(iS),nOrb(jS),nBas(iS),One,CMO(ipCM(iS)),nBas(iS),FA(ipMat(iS,jS)),nBas(iS),Zero, &
                    FockA(ipMat(iS,jS)),nOrb(iS))
      call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(iS),Sgn*Facr,FAMO(ipCM(iS)),nOrb(is),rkappa(ipMat(iS,jS)),nOrb(iS),One, &
                  FockA(ipMat(iS,jS)),nOrb(iS))
      call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(jS),Facr,rkappa(ipMat(iS,jS)),nOrb(is),FAMO(ipCM(jS)),nOrb(jS),One, &
                  FockA(ipMat(iS,jS)),nOrb(is))
    end if
  end if
end do

!call recprt('2 FockI',' ',FockI,nDens,1)
!call recprt('2 FockA',' ',FockA,nDens,1)

call mma_deallocate(DA)
call mma_deallocate(FA)
call mma_deallocate(FI)
call mma_deallocate(DI)
call mma_deallocate(T4)
call mma_deallocate(T3)
call mma_deallocate(Tmp2)
call mma_deallocate(T1)

end subroutine r2elint

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine SortEig(EVal,EVec,n,nB)
!***********************************************************************
!                                                                      *
!     purpose: Sort the set of eigenvalues and eigenvectors            *
!                                                                      *
!                                                                      *
!     input:                                                           *
!       EVal    : the set of eigenvalues in random order               *
!       EVec    : the set of eigenvectors in random order              *
!       n,nB    : dimensions                                           *
!                                                                      *
!     output:                                                          *
!       EVal    : sorted set of eigenvalues                            *
!       EVec    : sorted set of eigenvectors                           *
!                                                                      *
!     called from: DCore, NewOrb, IvoGen                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, nB
real(kind=wp), intent(inout) :: EVal(n), EVec(nB,n)
integer(kind=iwp) :: i, j, k, l
real(kind=wp) :: Swap

do i=1,n-1
  k = i
  do j=i+1,n
    if (EVal(j) < EVal(k)) k = j
  end do
  if (k /= i) then
    Swap = EVal(k)
    EVal(k) = EVal(i)
    EVal(i) = Swap
    do l=1,nB
      Swap = EVec(l,k)
      EVec(l,k) = -EVec(l,i)
      EVec(l,i) = Swap
    end do
  end if
end do

end subroutine SortEig

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine x2c_ts1e(n,s,t,v,w,ul,us,clight)
C
C Evaluate the X2C Hamiltonian matrix and store the transform matrices
C
      implicit none
#include "WrkSpc.fh"
C Input
C w   aka pVp
      integer n
      Real*8 s(n,n),t(n,n),v(n,n),w(n,n),clight
C Output
      Real*8 ul(n,n),us(n,n)
C Temp
      integer m,i,j,k
      Real*8 c_2c2,c_4c2,c_2c
      integer itF,itS,itX,itA,itB,itC,itSS
C
C Construct the full dimensional (2*n) Fock matrix and overlap matrix
C
      m = n+n
      c_2c  = clight*2.d0
      c_2c2 = clight*clight*2.d0
      c_4c2 = c_2c2*2.d0
C     ! rescale, in order to make X matrix close to unit matrix
      do i=1,n
        do j=1,n
          w(j,i) = w(j,i)/c_4c2
        end do
      end do
      call getmem('TmpF ','ALLOC','REAL', itF, m*m+4 )
      call getmem('TmpS ','ALLOC','REAL', itS, m*m+4 )
      do k=0,m*m-1
        Work(itS+k) = 0.d0
      end do
      do i=1,n
        do j=1,n
          Work(itS+(j-1)  +(i-1)*m)   = s(j,i)
          Work(itS+(j+n-1)+(i+n-1)*m) = t(j,i)/c_2c2
          Work(itF+(j-1)  +(i-1)*m)   = v(j,i)
          Work(itF+(j-1)  +(i+n-1)*m) = t(j,i)
          Work(itF+(j+n-1)+(i-1)*m)   = t(j,i)
          Work(itF+(j+n-1)+(i+n-1)*m) = w(j,i)-t(j,i)
        end do
      end do
C
C Call diagonalization routine to obtain the X matrix
C
      call getmem('TmpX ','ALLOC','REAL', itX, n*n+4 )
      call x2c_makx(m,n,Work(itF),Work(itS),Work(itX))
C
C Calculate transformed Hamiltonian matrix
C
      call getmem('TmpA ','ALLOC','REAL', itA, n*n+4 )
      call getmem('TmpB ','ALLOC','REAL', itB, n*n+4 )
      call getmem('TmpC ','ALLOC','REAL', itC, n*n+4 )
      call getmem('TmpSS','ALLOC','REAL', itSS, n*n+4 )
      call dmxma(n,'C','N',Work(itX),t,Work(itA),1.d0)
      call dmxma(n,'N','N',t,Work(itX),Work(itB),1.d0)
      call dmxma(n,'N','N',Work(itA),Work(itX),Work(itC),1.d0)
      k = 0
      do i=1,n
        do j=1,n
C          ! X-projected overlap matrix
          Work(itSS+k) = s(j,i) + Work(itC+k)/c_2c2
C          ! X-projected kinetic matrix
          t(j,i) = Work(itA+k) + Work(itB+k) - Work(itC+k)
          k = k + 1
        end do
      end do
      call XDR_dmatsqrt(s,n)
      call dmxma(n,'C','N',s,Work(itSS),Work(itA),1.d0)
      call dmxma(n,'N','N',Work(itA),s,Work(itB),1.d0)
      call XDR_dmatsqrt(Work(itB),n)
      call dmxma(n,'N','N',s,Work(itB),Work(itC),1.d0)
      call XDR_dmatinv(s,n)
C      ! renormalization matrix, also the upper part of transformation matrix
      call dmxma(n,'N','N',Work(itC),s,ul,1.d0)
C      ! lower part of the transformation matrix
      call dmxma(n,'N','N',work(itX),ul,us,1.d0)
C
C Apply transformation to kinetic and potential matrices
C
      call dmxma(n,'C','N',ul,t,work(itA),1.d0)
      call dmxma(n,'N','N',work(itA),ul,t,1.d0)
      call dmxma(n,'C','N',ul,v,work(itA),1.d0)
      call dmxma(n,'N','N',work(itA),ul,v,1.d0)
      call dmxma(n,'C','N',us,w,work(itA),1.d0)
      call dmxma(n,'N','N',work(itA),us,w,1.d0)
      do i=1,n
        do j=1,n
          v(j,i) = t(j,i) + v(j,i) + w(j,i)
C          ! since pVp was rescaled, the lower part of transformation matrix also need to be rescaled
          us(j,i) = us(j,i)/c_2c
        end do
      end do
C
C Free temp memories
C
      call getmem('TmpF ','FREE','REAL', itF, m*m+4 )
      call getmem('TmpS ','FREE','REAL', itS, m*m+4 )
      call getmem('TmpX ','FREE','REAL', itX, n*n+4 )
      call getmem('TmpA ','FREE','REAL', itA, n*n+4 )
      call getmem('TmpB ','FREE','REAL', itB, n*n+4 )
      call getmem('TmpC ','FREE','REAL', itC, n*n+4 )
      call getmem('TmpSS','FREE','REAL', itSS, n*n+4 )
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine change5_cvb()

use casvb_global, only: iconstruc, imethod, lfxvb, lzrvb, ndimrel, ndrot, nfxorb, nfxvb, norbrel, nort, nsyme, nvb, nzeta, nzrvb, &
                        orbfr_is_unit, plc_const, strucopt
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nfxvbr, nzrvbr
logical(kind=iwp) :: changed, construc
logical(kind=iwp), external :: chpcmp_cvb ! ... Change of dimensioning variables ...

! Dimensioning for symmetry handling:
changed = .false.
if (chpcmp_cvb(nsyme)) changed = .true.
if (chpcmp_cvb(ndimrel)) changed = .true.
if (chpcmp_cvb(norbrel)) changed = .true.
if (chpcmp_cvb(nvb)) changed = .true.
if (chpcmp_cvb(nzrvb)) changed = .true.
if (chpcmp_cvb(nort)) changed = .true.
if (chpcmp_cvb(ndrot)) changed = .true.

orbfr_is_unit = ((ndimrel == 0) .and. (nfxorb == 0) .and. (nort == 0) .and. (.not. plc_const))
! Set ORBFR_IS_UNIT if optimization method is 'NONE':
if (imethod == 11) orbfr_is_unit = .true.
if (chpcmp_cvb(merge(1,0,orbfr_is_unit))) changed = .true.
nfxvbr = nfxvb
if (lfxvb == 1) nfxvbr = nvb-nfxvb
nzrvbr = nzrvb
if (lzrvb == 1) nzrvbr = nvb-nzrvb
! NPR arrays -- depend on nature of opt procedure
construc = ((nzrvbr > 0) .or. ((nfxvbr > 0) .and. (nfxvbr < nvb)) .or. (nzeta > 0))
if (construc) then
  if ((nvb > 20) .or. (.not. strucopt)) then
    iconstruc = 1
  else
    iconstruc = 2
  end if
else
  iconstruc = 0
end if
if (chpcmp_cvb(iconstruc)) changed = .true.
if (changed) call touch_cvb('MEM5')

return

end subroutine change5_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function G(Arg)

use Constants, only: One, Half, Quart, Pi
use Definitions, only: wp

implicit none
real(kind=wp) :: G
real(kind=wp), intent(in) :: Arg
real(kind=wp) :: Arg_, rG

g = -1.0e3_wp

Arg_ = real(int(Arg),kind=wp)
if (abs(Arg-Arg_) < Quart) then
  ! Integer argument
  G = One
  rG = One
else
  ! Fractional argument
  G = sqrt(Pi)
  rG = Half
end if

do
  if (abs(rG-Arg) < Quart) exit
  G = rG*G
  rG = rG+One
end do

return

end function G

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine CmbnMV(Rnxyz,nZeta,la,lb,lr,Zeta,rKappa,rFinal,nComp,rV2Int,rV4Int)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN, February '91                 *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: One, Eight, OneHalf, c_in_au
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, lr, nComp
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la+2,0:lb+2,0:lr), Zeta(nZeta), rKappa(nZeta), rV2Int(nZeta,3,0:la,0:lb,2), &
                             rV4Int(nZeta,3,0:la,0:lb)
real(kind=wp), intent(out) :: rFinal(nZeta,nComp,nTri_Elem1(la),nTri_Elem1(lb))
integer(kind=iwp) :: iComp, ipa, ipb, ixa, ixb, iya, iyaMax, iyb, iybMax, iza, izb
real(kind=wp), parameter :: Const = -One/(Eight*c_in_au**2)

!iRout = 191
!iPrint = nPrint(iRout)

iComp = 1
do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)
        !if (iPrint >= 99) then
        !  write(u6,*) ixa,iya,iza,ixb,iyb,izb
        !  write(u6,*) ipa,ipb
        !end if

        ! Combine integrals

        rFinal(:,iComp,ipa,ipb) = rKappa*Zeta**(-OneHalf)*Const*(rV4Int(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb,0)*Rnxyz(:,3,iza,izb,0)+ &
                                                                 rV2Int(:,1,ixa,ixb,1)*rV2Int(:,2,iya,iyb,2)*Rnxyz(:,3,iza,izb,0)+ &
                                                                 rV2Int(:,1,ixa,ixb,1)*Rnxyz(:,2,iya,iyb,0)*rV2Int(:,3,iza,izb,2)+ &
                                                                 rV2Int(:,1,ixa,ixb,2)*rV2Int(:,2,iya,iyb,1)*Rnxyz(:,3,iza,izb,0)+ &
                                                                 Rnxyz(:,1,ixa,ixb,0)*rV4Int(:,2,iya,iyb)*Rnxyz(:,3,iza,izb,0)+ &
                                                                 Rnxyz(:,1,ixa,ixb,0)*rV2Int(:,2,iya,iyb,1)*rV2Int(:,3,iza,izb,2)+ &
                                                                 rV2Int(:,1,ixa,ixb,2)*Rnxyz(:,2,iya,iyb,0)*rV2Int(:,3,iza,izb,1)+ &
                                                                 Rnxyz(:,1,ixa,ixb,0)*rV2Int(:,2,iya,iyb,2)*rV2Int(:,3,iza,izb,1)+ &
                                                                 Rnxyz(:,1,ixa,ixb,0)*Rnxyz(:,2,iya,iyb,0)*rV4Int(:,3,iza,izb))

      end do
    end do
  end do
end do

return

end subroutine CmbnMV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************
!  CHO_get_Rij
!
!> @author F. Aquilante
!>
!> @details
!> Computes the \f$ R \f$ matrix used for the
!> maximization of Edmiston--Ruedenberg functional
!>
!> \f[ \mathit{ER} = \sum_i (ii|ii) = \mathrm{Tr}(R) \f]
!>
!> for a given set of MOs.
!>
!> \f$ R \f$ is defined from the two-electron integrals
!> computed from the MO-transformed Cholesky vectors
!>
!> \f[ R_{ij} = (ij|jj) = \sum_K L_{ij,K} L_{jj,K} \f]
!>
!> and the condition for the maximization of the ER-functional
!> is given by
!>
!> \f[ \mathrm{grad}(\mathit{ER})_{ij} = 4(R_{ij} - R_{ji}) = 0 \quad (\forall i,j) \f]
!>
!> @note
!> Requires initialization of the Cholesky information.
!>
!> @param[out] irc     Return code
!> @param[in]  MO      type DSBA_Type of block of the MO matrix, stored as \p C(k,a)
!> @param[in]  nOcc    Number of orbitals to be localized in each symmetry
!> @param[out] Rij     \p nOcc &times; \p nOcc symmetry blocked matrix \f$  R_{ij} = (ij|jj) \f$
!> @param[in]  timings Switch on/off timings printout
!***********************************************************************

subroutine CHO_get_Rij(irc,MO,nOcc,Rij,timings)

use Cholesky, only: InfVec, nBas, nDimRS, nSym, NumCho
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, SBA_Type
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
type(DSBA_Type), intent(in) :: MO(1)
integer(kind=iwp), intent(in) :: nOcc(*)
real(kind=wp), intent(_OUT_) :: Rij(*)
logical(kind=iwp), intent(in) :: timings
integer(kind=iwp) :: iBatch, iE, iLoc, iOcc(8), iOcs(8), IREDC, iS, iSkip(8), iSwap, IVEC2, iVrs, JNUM, jpR, JRED, JRED_, JRED1, &
                     JRED2, JSYM, jVEC, kMOs, kS, kSym, lj, LREAD, LWORK, Maj, Mneed, Mocc, MUSED, n1, nBatch, nMOs, nOcs, nRS, &
                     NUMV, nVec, nVrs
real(kind=wp) :: TCI1, TCI2, TCR1, TCR2, TCT1, TCT2, tintg(2), tmotr(2), TOTCPU, TOTCPU1, TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, &
                 tread(2), TWI1, TWI2, TWR1, TWR2, TWT1, TWT2
type(SBA_Type) :: Laq(1)
real(kind=wp), allocatable, target :: Lab(:)
real(kind=wp), pointer :: pLab(:,:,:), pLjj(:)
logical(kind=iwp), parameter :: DoRead = .false.
character(len=*), parameter :: SECNAM = 'CHO_get_Rij'

IREDC = -1

JSYM = 1
if (NumCho(JSYM) < 1) then
  write(u6,*) SECNAM//': No total symmetric vectors present'
  irc = 77
  return
end if

do kS=1,nSym
  if ((nOcc(kS) > nBas(kS)) .or. (nOcc(kS) < 0)) then
    write(u6,*) SECNAM//': Wrong nOcc in symmetry ',kS
    write(u6,*) 'nOcc(',kS,')= ',nOcc(kS)
    write(u6,*) 'nBas(',kS,')= ',nBas(kS)
    irc = 79
    return
  end if
end do

call CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = Zero  !time for reading the vectors
tmotr(:) = Zero  !time for MO transformation of the vectors
tintg(:) = Zero  !time for computing the functional

! compute some offsets and other quantities
iOcc(1) = 0
iOcs(1) = 0
Mocc = nOcc(1)
do kSym=2,nSym
  iOcc(kSym) = iOcc(kSym-1)+nOcc(kSym-1)
  iOcs(kSym) = iOcs(kSym-1)+nOcc(kSym-1)**2
  Mocc = max(Mocc,nOcc(kSym))
end do

nOcs = iOcs(nSym)+nOcc(nSym)**2

Rij(1:nOcs) = Zero

do kS=1,nSym
  iSkip(kS) = min(nOcc(kS),1) ! initialize skipping flags
end do

! Memory need for 1 of the half-transformed vectors : L(aj)
Maj = sum(nBas(1:nSym)*nOcc(1:nSym))

iLoc = 3 ! use scratch location in reduced index arrays

JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

do JRED=JRED1,JRED2

  ! Memory management section -----------------------------

  call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

  if (nVrs == 0) cycle

  if (nVrs < 0) then
    write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs < 0. STOP!!'
    call abend()
  end if

  call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
  if (irc /= 0) then
    write(u6,*) SECNAM//': cho_X_setred non-zero return code. rc= ',irc
    call abend()
  end if

  IREDC = JRED

  nRS = nDimRS(JSYM,JRED)

  Mneed = max(nRS,Mocc**2+1) ! mem. for Lab and (Lij + Ljj)

  call mma_maxDBLE(LWORK)

  nVec = min(LWORK/(Maj+Mneed),nVrs)

  if (nVec < 1) then
    write(u6,*) SECNAM//': Insufficient memory for batch'
    write(u6,*) 'LWORK= ',LWORK
    write(u6,*) 'min. mem. need= ',Maj+Mneed
    irc = 33
    call Abend()
    nBatch = -9999  ! dummy assignment
  end if

  LREAD = nRS*nVec

  call mma_allocate(Lab,Mneed*nVec,Label='Lab')

  ! BATCH over the vectors in JSYM=1 ----------------------------

  nBatch = (nVrs-1)/nVec+1

  do iBatch=1,nBatch

    if (iBatch == nBatch) then
      JNUM = nVrs-nVec*(nBatch-1)
    else
      JNUM = nVec
    end if
    iSwap = 2  ! LiK,b are returned
    call Allocate_DT(Laq(1),nOcc,nBas,JNUM,JSYM,nSym,iSwap)

    JVEC = nVec*(iBatch-1)+iVrs
    IVEC2 = JVEC-1+JNUM

    call CWTIME(TCR1,TWR1)

    JRED_ = JRED
    call CHO_VECRD(Lab,LREAD,JVEC,IVEC2,JSYM,NUMV,JRED_,MUSED)

    if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
      irc = 77
      return
    end if

    call CWTIME(TCR2,TWR2)
    tread(1) = tread(1)+(TCR2-TCR1)
    tread(2) = tread(2)+(TWR2-TWR1)

    ! First half-transformation of the vectors : Lab,J --> LiJ,b
    !-----------------------------------------------------------

    kMOs = 1
    nMOs = 1

    call CWTIME(TCT1,TWT1)

    call CHO_X_getVtra(irc,Lab,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,MO(1),Laq(1),DoRead)

    if (irc /= 0) return

    call CWTIME(TCT2,TWT2)
    tmotr(1) = tmotr(1)+(TCT2-TCT1)
    tmotr(2) = tmotr(2)+(TWT2-TWT1)

    do kSym=1,nSym

      n1 = nOcc(kSym)
      iS = 1
      iE = n1*JNUM*n1
      pLab(1:n1,1:JNUM,1:n1) => Lab(iS:iE)
      iS = iE+1
      iE = iE+JNUM
      pLjj(1:JNUM) => Lab(iS:iE)

      if (iSkip(kSym) /= 0) then

        call CWTIME(TCT1,TWT1)
        !---------------------------------------------------------------
        ! Second half-transformation  L(iK,j) = sum_b  L(iK,b) * C(j,b)
        !---------------------------------------------------------------

        call DGEMM_('N','T',nOcc(kSym)*JNUM,nOcc(kSym),nBas(kSym),One,Laq(1)%SB(kSym)%A3,nOcc(kSym)*JNUM,MO(1)%SB(kSym)%A2, &
                    nOcc(kSym),Zero,pLab,nOcc(kSym)*JNUM)

        call CWTIME(TCT2,TWT2)
        tmotr(1) = tmotr(1)+(TCT2-TCT1)
        tmotr(2) = tmotr(2)+(TWT2-TWT1)

        call CWTIME(TCI1,TWI1)

        do lj=1,nOcc(kSym)

          pLjj(1:JNUM) = pLab(lj,1:JNUM,lj)

          !-------------------------------------------------------------
          ! Compute   R(i,j) = sum_K  L(i,K)[j] * L(K)[j]
          !-------------------------------------------------------------

          jpR = iOcs(kSym)+nOcc(kSym)*(lj-1)+1

          call DGEMV_('N',nOcc(kSym),JNUM,One,pLab(:,:,lj),nOcc(kSym),pLjj,1,One,Rij(jpR),1)

        end do

        call CWTIME(TCI2,TWI2)
        tintg(1) = tintg(1)+(TCI2-TCI1)
        tintg(2) = tintg(2)+(TWI2-TWI1)

      end if
      nullify(pLjj,pLab)

    end do

    call Deallocate_DT(Laq(1))
  end do  !end batch loop

  ! free memory
  call mma_deallocate(Lab)

end do   ! loop over red sets

! sync Rij

call GAdGOp(Rij,nOcs,'+')

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  write(u6,*)
  write(u6,*) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*) 'Timing from ',SECNAM,'           CPU      WALL  '
  write(u6,*) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,'(2x,A26,2f10.2)') 'READ VECTORS                              ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'TRANSFORM VECTORS                         ',tmotr(1),tmotr(2)
  write(u6,'(2x,A26,2f10.2)') 'COMPUTE Rij = (ij|jj)                     ',tintg(1),tintg(2)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,*) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

irc = 0

return

end subroutine CHO_get_Rij

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fokunpck5(symp,foka,fokb,dpa,dpb,dimfok,rc)
! this routine produces dpa,dpb from foka,fokb
! for some cases
! shifto,shiftv will be also added
!
! symp   - symmetry of this block
! foka   - Fok aa matrix (I)
! fokb   - Fok bb matrix (I)
! dpa    - Diagonal part alpha vector (O)
! dpb    - Diagonal part beta vector (O)
! dimfok - dimension for Fok matrix - norb (I)
! rc     - return (error) code

use ccsd_global, only: eps, fullprint, keysa, noa, nob, norb, shifto, shiftv, typden
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: symp, dimfok
real(kind=wp), intent(in) :: foka(dimfok,dimfok), fokb(dimfok,dimfok)
real(kind=wp), intent(inout) :: dpa(dimfok), dpb(dimfok)
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: nhelp1, p

rc = 0

if (typden == 0) then
  !1 diagonal elements are required

  do p=1,dimfok
    dpa(p) = foka(p,p)
    dpb(p) = fokb(p,p)
  end do

else if (typden == 1) then
  !2 (faa+fbb)/2 are required

  do p=1,dimfok
    dpa(p) = (foka(p,p)+fokb(p,p))/2
  end do
  dpb(1:dimfok) = dpa(1:dimfok)

else if (typden == 2) then
  !3 orbital energies are required

  !3.1 def shift
  if (symp == 1) then
    nhelp1 = 0
  else
    nhelp1 = sum(norb(1:symp-1))
  end if

  !3.2 map oe to dp
  dpa(1:dimfok) = eps(nhelp1+1:nhelp1+dimfok)
  dpb(1:dimfok) = eps(nhelp1+1:nhelp1+dimfok)

else
  ! RC=1 : invalid key (NCI/Stup)
  rc = 1
end if

if ((keysa == 3) .or. (keysa == 4)) then
  ! for full adaptation scheme only D and V orbitals are shifted

  dpa(1:nob(symp)) = dpa(1:nob(symp))-shifto
  dpb(1:nob(symp)) = dpb(1:nob(symp))-shifto

  dpa(1:noa(symp):norb(symp)) = dpa(1+noa(symp):norb(symp))+shiftv
  dpb(1:noa(symp):norb(symp)) = dpb(1+noa(symp):norb(symp))+shiftv

else
  ! for other schemes all orbitals are shifted

  dpa(1:noa(symp)) = dpa(1:noa(symp))-shifto

  dpb(1:nob(symp)) = dpb(1:nob(symp))-shifto

  dpa(1+noa(symp):norb(symp)) = dpa(1+noa(symp):norb(symp))+shiftv

  dpb(1+nob(symp):norb(symp)) = dpb(1+nob(symp):norb(symp))+shiftv

end if

if (fullprint >= 2) then
  write(u6,*) ' Diagonal part Dp aa, bb for irrep: ',symp
  do p=1,norb(symp)
    write(u6,99) p,dpa(p),dpb(p)
  end do
end if

return

99 format(2x,i4,2(f20.14,2x))

end subroutine fokunpck5

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  RdInput_Quater
!
!> @brief
!>   Reads the input of the quater program
!> @author Y. Carissan
!>
!> @param[out] U1 vector needed for the rotation
!> @param[out] U2 vector needed for the rotation
!> @param[out] V1 vector needed for the rotation
!> @param[out] V2 vector needed for the rotation
!>
!> @details
!> Reads the input of the quater program.
!***********************************************************************

subroutine RdInput_Quater(U1,U2,V1,V2)

use Quater_globals, only: debug, rotate, translate, ngeoms, list, XYZ1, XYZ2
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: U1(3), U2(3), V1(3), V2(3)
integer(kind=iwp) :: iLU, ig
character(len=6) :: cName
character(len=180) :: Line
character(len=20) :: key
logical(kind=iwp) :: AxisSet, NewAxisSet, Geo1Set, Geo2Set, XYZ1Set, XYZ2Set
character(len=180), external :: Get_ln

AxisSet = .false.
NewAxisSet = .false.
Geo1Set = .false.
Geo2Set = .false.
XYZ1Set = .false.
XYZ2Set = .false.
rotate = .true.
translate = .true.
ngeoms = 1
call SpoolInp(iLU)

! skip &quater &end

Line = Get_ln(iLU)
do
  Line = Get_ln(iLU)
  call Put_ln(Line)
  call Get_S(1,key,1)
  if (debug) write(u6,*) 'KEY:',key
  if (key(1:4) == 'AXIS') then
    Line = Get_ln(iLU)
    call Put_ln(Line)
    call Get_F(1,U1,3)
    Line = Get_ln(iLU)
    call Put_ln(Line)
    call Get_F(1,U2,3)
    AxisSet = .true.
  else if (key(1:4) == 'NEWA') then
    Line = Get_ln(iLU)
    call Put_ln(Line)
    call Get_F(1,V1,3)
    Line = Get_ln(iLU)
    call Put_ln(Line)
    call Get_F(1,V2,3)
    NewAxisSet = .true.
  else if (key(1:4) == 'DEBU') then
    debug = .true.
  else if (key(1:4) == 'GEO1') then
    call readgeo(iLU,1)
    Geo1Set = .true.
  else if (key(1:4) == 'GEO2') then
    call readgeo(iLU,2)
    Geo2Set = .true.
  else if (key(1:4) == 'XYZ1') then
    Line = Get_ln(iLU)
    call Put_ln(Line)
    call Get_I(1,XYZ1,3)
    XYZ1Set = .true.
  else if (key(1:4) == 'XYZ2') then
    Line = Get_ln(iLU)
    call Put_ln(Line)
    call Get_I(1,XYZ2,3)
    XYZ2Set = .true.
  !else if (key(1:4) == 'NGEO') then
  !  Line = Get_ln(iLU)
  !  call Put_ln(Line)
  !  call Get_I(1,ngeoms,1)
  else if (key(1:4) == 'NOTR') then
    translate = .false.
  else if (key(1:4) == 'NORO') then
    rotate = .false.
  else if (key(1:4) == 'END ') then
    exit
  else
    call SysAbendMsg('RdInput_Quater','Keyword not relevant : ',key)
  end if
end do

if (.not. AxisSet) then
  if (.not. XYZ1Set) then
    call SysAbendMsg('RdInput_Quater','Reference Axis not set','AXIS or XYZ1 Keyword mandatory')
  end if
else
  if (XYZ1Set) then
    call SysAbendMsg('RdInput_Quater','Reference Axis not set properly','AXIS and XYZ1 Keywords are exclusive')
  end if
end if

if (.not. NewAxisSet) then
  if (.not. XYZ2Set) then
    call SysAbendMsg('RdInput_Quater','New Axis not set :','NEWAXIS or XYZ2 Keyword mandatory')
  end if
else
  if (XYZ2Set) then
    call SysAbendMsg('RdInput_Quater','New Axis not set properly','NEWAXIS and XYZ2 Keywords are exclusive')
  end if
end if

if (XYZ1Set .and. (.not. GEO1Set)) then
  call SysAbendMsg('RdInput_Quater','XYZ1 keyword requires GEO1 definition','')
end if

if (XYZ2Set .and. (.not. GEO2Set)) then
  call SysAbendMsg('RdInput_Quater','XYZ2 keyword requires GEO2 definition','')
end if

if (translate .and. (.not. (XYZ1Set .and. XYZ2Set))) then
  call SysAbendMsg('RdInput_Quater','Translation cannot be done if both','XYZ1 and XYZ2 are not set')
end if

if (XYZ1Set) call SetVect(list(1)%nat,list(1)%geo,XYZ1,V1,V2)
if (XYZ2Set) call SetVect(list(2)%nat,list(2)%geo,XYZ2,U1,U2)

do ig=3,ngeoms+2
  if (ig < 10) then
    write(cName,'(a5,i1)') 'GEOM0',ig
    list(ig)%title = cName
  else if (ig < 100) then
    write(cName,'(a4,i2)') 'GEOM',ig
    list(ig)%title = cName
  end if
  list(ig)%nat = list(2)%nat
  call mma_allocate(list(ig)%geo,3,list(ig)%nat,label=cName)
  call mma_allocate(list(ig)%geolbl,list(ig)%nat,label=cName)
  list(ig)%geolbl(:) = list(2)%geolbl(:)
end do

return

end subroutine RdInput_Quater

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Assg1_mck(g1,nT,nRys,la,lb,lc,ld,xyz2D0,xyz2D1,IfGrad,Indx,mVec,Indx2)
!***********************************************************************
!                                                                      *
! Object: to assemble the gradients of the ERI's.                      *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!***********************************************************************

use Index_Functions, only: C_Ind3_Rev, nTri_Elem1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nT, nRys, la, lb, lc, ld, Indx(3,4)
real(kind=wp), intent(out) :: g1(nT,nTri_Elem1(la),nTri_Elem1(lb),nTri_Elem1(lc),nTri_Elem1(ld),9)
real(kind=wp), intent(in) :: xyz2D0(nRys,nT,0:la+2,0:lb+2,0:lc+2,0:ld+2,3), xyz2D1(nRys,nT,0:la,0:lb,0:lc,0:ld,9)
logical(kind=iwp), intent(in) :: IfGrad(3,4)
integer(kind=iwp), intent(out) :: mVec, Indx2(3,4)
#include "itmax.fh"
integer(kind=iwp) :: iCent, icir(3), Ind1(3), Ind2(3), ipa, ipb, ipc, ipd, iRys, iT, ixa, ixab, ixabc, ixabcd, ixb, ixc, ixd, iya, &
                     iyab, iyabc, iyabcd, iyb, iyc, iyd, iza, izb, izc, izd, nVec
real(kind=wp) :: tmp, tmp1, tmp2, tmp3

g1(:,:,:,:,:,:) = Zero
Indx2(:,:) = 0

do ipa=1,nTri_Elem1(la)
  icir(:) = C_Ind3_Rev(ipa,la)
  ixa = icir(1)
  iya = icir(2)
  iza = icir(3)

  do ipb=1,nTri_Elem1(lb)
    icir(:) = C_Ind3_Rev(ipb,lb)
    ixb = icir(1)
    iyb = icir(2)
    izb = icir(3)

    ixab = ixa+ixb
    iyab = iya+iyb

    do ipc=1,nTri_Elem1(lc)
      icir(:) = C_Ind3_Rev(ipc,lc)
      ixc = icir(1)
      iyc = icir(2)
      izc = icir(3)

      ixabc = ixab+ixc
      iyabc = iyab+iyc

      do ipd=1,nTri_Elem1(ld)
        icir(:) = C_Ind3_Rev(ipd,ld)
        ixd = icir(1)
        iyd = icir(2)
        izd = icir(3)

        ixabcd = ixabc+ixd
        iyabcd = iyabc+iyd

        ! Compute all desired gradients with respect to an x-component.

        mVec = 0
        nVec = 0
        do iCent=1,4
          if (IfGrad(1,iCent)) then
            mVec = mVec+1
            nVec = nVec+1
            Ind1(nVec) = 3*(Indx(1,iCent)-1)+1
            Ind2(nVec) = mVec
            Indx2(1,iCent) = mVec
          end if
        end do

        if (iyabcd /= 0) then

          select case (nVec)
            case (3)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                tmp3 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)*xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(2))
                  tmp3 = tmp3+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(3))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
                g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(3))+tmp3
              end do
            case (2)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)*xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(2))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
              end do
            case (1)
              do iT=1,nT
                tmp1 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)*xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
              end do
          end select

        else

          select case (nVec)
            case (3)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                tmp3 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(2))
                  tmp3 = tmp3+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(3))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
                g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(3))+tmp3
              end do
            case (2)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(2))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
              end do
            case (1)
              do iT=1,nT
                tmp1 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,ixa,ixb,ixc,ixd,Ind1(1))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
              end do
          end select

        end if

        ! Compute all desired gradients with respect to a y-component.

        nVec = 0
        do iCent=1,4
          if (IfGrad(2,iCent)) then
            mVec = mVec+1
            nVec = nVec+1
            Ind1(nVec) = 3*(Indx(2,iCent)-1)+2
            Ind2(nVec) = mVec
            Indx2(2,iCent) = mVec
          end if
        end do

        if (ixabcd /= 0) then

          select case (nVec)
            case (3)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                tmp3 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)*xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(2))
                  tmp3 = tmp3+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(3))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
                g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(3))+tmp3
              end do
            case (2)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)*xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(2))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
              end do
            case (1)
              do iT=1,nT
                tmp1 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)*xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
              end do
          end select

        else

          select case (nVec)
            case (3)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                tmp3 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(2))
                  tmp3 = tmp3+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(3))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
                g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(3))+tmp3
              end do
            case (2)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(2))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
              end do
            case (1)
              do iT=1,nT
                tmp1 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iza,izb,izc,izd,3)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iya,iyb,iyc,iyd,Ind1(1))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
              end do
          end select

        end if

        ! Compute all desired gradients with respect to a z-component.

        nVec = 0
        do iCent=1,4
          if (IfGrad(3,iCent)) then
            mVec = mVec+1
            nVec = nVec+1
            Ind1(nVec) = 3*(Indx(3,iCent)-1)+3
            Ind2(nVec) = mVec
            Indx2(3,iCent) = mVec
          end if
        end do

        if (ixabcd*iyabcd /= 0) then

          select case (nVec)
            case (3)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                tmp3 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)*xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                  tmp3 = tmp3+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(3))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
                g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(3))+tmp3
              end do
            case (2)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)*xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
              end do
            case (1)
              do iT=1,nT
                tmp1 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)*xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
              end do
          end select

        else if ((ixabcd == 0) .and. (iyabcd /= 0)) then

          select case (nVec)
            case (3)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                tmp3 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                  tmp3 = tmp3+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(3))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
                g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(3))+tmp3
              end do
            case (2)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
              end do
            case (1)
              do iT=1,nT
                tmp1 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,iya,iyb,iyc,iyd,2)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
              end do
          end select

        else if ((iyabcd == 0) .and. (ixabcd /= 0)) then

          select case (nVec)
            case (3)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                tmp3 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                  tmp3 = tmp3+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(3))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
                g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(3))+tmp3
              end do
            case (2)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
              end do
            case (1)
              do iT=1,nT
                tmp1 = Zero
                do iRys=1,nRys
                  tmp = xyz2D0(iRys,iT,ixa,ixb,ixc,ixd,1)
                  tmp1 = tmp1+tmp*xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
              end do
          end select

        else

          select case (nVec)
            case (3)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                tmp3 = Zero
                do iRys=1,nRys
                  tmp1 = tmp1+xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2+xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                  tmp3 = tmp3+xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(3))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
                g1(iT,ipa,ipb,ipc,ipd,Ind2(3)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(3))+tmp3
              end do
            case (2)
              do iT=1,nT
                tmp1 = Zero
                tmp2 = Zero
                do iRys=1,nRys
                  tmp1 = tmp1+xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                  tmp2 = tmp2+xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(2))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
                g1(iT,ipa,ipb,ipc,ipd,Ind2(2)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(2))+tmp2
              end do
            case (1)
              do iT=1,nT
                tmp1 = Zero
                do iRys=1,nRys
                  tmp1 = tmp1+xyz2D1(iRys,iT,iza,izb,izc,izd,Ind1(1))
                end do
                g1(iT,ipa,ipb,ipc,ipd,Ind2(1)) = g1(iT,ipa,ipb,ipc,ipd,Ind2(1))+tmp1
              end do
          end select

        end if

      end do

    end do

  end do

end do

return

end subroutine Assg1_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SECULAR(NDIM,N,NRON,HMAT,SMAT,VEC,EVAL,SCR,THR)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTRINSIC SQRT
      DIMENSION HMAT(NDIM,NDIM),SMAT(NDIM,NDIM)
      DIMENSION VEC(NDIM,NDIM),EVAL(NDIM),SCR(*)
      THR2=THR**2
C PUT NORMALIZED VECTORS INTO VEC:
      CALL DCOPY_(N*NDIM,[0.0D00],0,VEC,1)
      DO 5 I=1,N
        VEC(I,I)=1.0D00/SQRT(SMAT(I,I))
5     CONTINUE
C GRAM-SCHMIDT ORTHONORMALIZING PROCEDURE:
      NRON=0
      DO 60 I=1,N
C SMAT*(NORMALIZED VECTOR) INTO SCR:
        CALL DCOPY_(N,SMAT(1,I),1,SCR,1)
        CALL DSCAL_(N,VEC(I,I),SCR,1)
C PROJECT AWAY THE ALREADY ORTHONORMALIZED BASIS SET:
        DO 30 J=1,NRON
          MAXLEN=I-1-NRON+J
          SUM=0.0D00
          DO 10 K=1,MAXLEN
            SUM=SUM+VEC(K,J)*SCR(K)
10        CONTINUE
          DO 20 K=1,MAXLEN
            VEC(K,I)=VEC(K,I)-SUM*VEC(K,J)
20        CONTINUE
30      CONTINUE
C NORMALIZE AND MOVE INTO POSITION:
        SUM=0.0D00
        DO 40 K=1,I
          SUM=SUM+VEC(K,I)*SCR(K)
40      CONTINUE
        IF(SUM.LT.THR2) GOTO 60
        NRON=NRON+1
        SCALE=1.0D00/SQRT(SUM)
        DO 50 K=1,I
          VEC(K,NRON)=SCALE*VEC(K,I)
50      CONTINUE
60    CONTINUE
      DO 70 I=NRON+1,N
        CALL DCOPY_(N,[0.0D00],0,VEC(1,I),1)
70    CONTINUE
C TRANSFORM HAMILTONIAN INTO SCR:
      IOFF1=N*NRON
      CALL DGEMM_('N','N',
     &            N,NRON,N,
     &            1.0d0,HMAT,NDIM,
     &            VEC,NDIM,
     &            0.0d0,SCR,N)
      CALL DGEMM_('T','N',
     &            NRON,NRON,N,
     &            1.0d0,VEC,NDIM,
     &            SCR,N,
     &            0.0d0,SCR(IOFF1+1),NRON)
C COPY TRANSFORMED HMAT INTO TRIANGULAR STORAGE IN SCR:
      IFROM=IOFF1+1
      ITO=1
      DO 110 I=1,NRON
        CALL DCOPY_(I,SCR(IFROM),1,SCR(ITO),1)
        ITO=ITO+I
        IFROM=IFROM+NRON
110   CONTINUE
C DIAGONALIZE:
      CALL Jacob(SCR,VEC,NRON,NDIM)
C COPY EIGENVALUES INTO EVAL:
      II=0
      DO 120 I=1,NRON
        II=II+I
        EVAL(I)=SCR(II)
120   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine ChoMP2_Setup(irc)
!
! Thomas Bondo Pedersen, Oct. 2004 / Feb. 2005.
!
! Purpose: setup of Cholesky MP2 program.

use Symmetry_Info, only: Mul
use Cholesky, only: LuPri, nBas, nSym, NumCho
use ChoMP2, only: ChoAlg, ChoMP2_allocated, DecoMP2, DoDens, ForceBatch, iAOVir, iBatOrb, iDel, iFirst, iFirstS, iFro, iMatab, &
                  iOcc, iT1am, iT1AOT, iVir, Laplace, Laplace_BlockSize, LiMatij, LiPQprod, LiT1am, LnBatOrb, LnMatij, LnOcc, &
                  LnPQprod, LnT1am, lUnit, nAOVir, nBatch, nBatOrbT, nDel, nDelT, nFro, nFroT, nMatab, nOcc, nOccT, nOrb, nT1am, &
                  nT1AOT, nTypF, NumBatOrb, NumOcc, nVir, nVirT, SOS_mp2, ThrMP2
#ifdef _DISABLED_
use ChoMP2, only: iPQ_prod, L_Mp2Lagr, nPQ_prod, nPQ_prodab, nPQ_prodia, nPQ_prodij
#endif
use stdalloc, only: mma_allocate, mma_maxDBLE
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: blast, bsize, iSym, iSyma, iSymAl, iSymb, iSymi, iTyp, l_X, lAvail, lWork, mBatch, nBlock, nFrac(8), nT1amx, &
                     NumVec(8)
real(kind=wp) :: Byte, lX, xb, xbp, xM, xn
logical(kind=iwp) :: Accepted, ChoMP2_Setup_MemChk
character(len=2) :: Unt
character(len=*), parameter :: SecNam = 'ChoMP2_Setup'
#ifdef _DISABLED_
integer(kind=iwp) :: iSymP, iSymQ, nPQprodx
#endif

irc = 0

! Setup index arrays and counters.
! --------------------------------

if ((DecoMP2 .or. DoDens) .and. (ThrMP2 <= Zero)) call Get_dScalar('Cholesky Threshold',ThrMP2)

call ChoMP2_GetInf(nOrb,nOcc,nFro,nDel,nVir)
iOcc(1) = 0
iBatOrb(1) = 0
iVir(1) = 0
iFro(1) = 0
iDel(1) = 0
nOccT = nOcc(1)
nVirT = nVir(1)
nFroT = nFro(1)
nDelT = nDel(1)
#ifdef _DISABLED_
nBatOrbT = nVir(1)+nOcc(1)+nFro(1)+nDel(1)
#else
nBatOrbT = nOcc(1)
#endif
do iSym=2,nSym
  iOcc(iSym) = nOccT
  iVir(iSym) = nVirT
  iFro(iSym) = nFroT
  iDel(iSym) = nDelT
  iBatOrb(iSym) = nBatOrbT
  nOccT = nOccT+nOcc(iSym)
  nVirT = nVirT+nVir(iSym)
  nFroT = nFroT+nFro(iSym)
  nDelT = nDelT+nDel(iSym)
# ifdef _DISABLED_
  nBatOrbT = nBatOrbT+nOcc(iSym)+nVir(iSym)+nFro(iSym)+nDel(iSym)
# else
  nBatOrbT = nBatOrbT+nOcc(iSym)
# endif
end do

do iSym=1,nSym
  nT1am(iSym) = 0
  do iSymi=1,nSym
    iSyma = Mul(iSymi,iSym)
    iT1am(iSyma,iSymi) = nT1am(iSym)
    nT1am(iSym) = nT1am(iSym)+nVir(iSyma)*nOcc(iSymi)
  end do
end do

#ifdef _DISABLED_
do iSym=1,nSym
  nPQ_prod(iSym) = 0
  nPQ_prodij(iSym) = 0
  nPQ_prodia(iSym) = 0
  nPQ_prodab(iSym) = 0
  do iSymQ=1,nSym
    iSymP = Mul(iSymQ,iSym)
    iPQ_prod(iSymP,iSymQ) = nPQ_prod(iSym)

    nPQ_prod(iSym) = nPQ_Prod(iSym)+(nOcc(iSymP)+nVir(iSymP)+nFro(iSymP)+nDel(iSymP))* &
                     (nOcc(iSymQ)+nVir(iSymQ)+nFro(iSymQ)+nDel(iSymQ))
    nPQ_prodij(iSym) = nPQ_Prodij(iSym)+(nFro(iSymP)+nOcc(iSymP))*(nFro(iSymQ)+nOcc(iSymQ))
    nPQ_prodia(iSym) = nPQ_Prodia(iSym)+(nFro(iSymP)+nOcc(iSymP))*(nVir(iSymQ)+nDel(iSymQ))
    nPQ_prodab(iSym) = nPQ_Prodab(iSym)+(nVir(iSymP)+nDel(iSymP))*(nVir(iSymQ)+nDel(iSymQ))
  end do
end do
#endif

do iSym=1,nSym
  nT1AOT(iSym) = 0
  do iSymAl=1,nSym
    iSymi = Mul(iSymAl,iSym)
    iT1AOT(iSymi,iSymAl) = nT1AOT(iSym)
    nT1AOT(iSym) = nT1AOT(iSym)+nOcc(iSymi)*nBas(iSymAl)
  end do
end do

do iSym=1,nSym
  nAOVir(iSym) = 0
  do iSyma=1,nSym
    iSymAl = Mul(iSyma,iSym)
    iAOVir(iSymAl,iSyma) = nAOVir(iSym)
    nAOVir(iSym) = nAOVir(iSym)+nBas(iSymAl)*nVir(iSyma)
  end do
end do

if (ChoAlg == 2) then
  do iSym=1,nSym
    nMatab(iSym) = 0
    do iSymb=1,nSym
      iSyma = Mul(iSymb,iSym)
      iMatab(iSyma,iSymb) = nMatab(iSym)
      nMatab(iSym) = nMatab(iSym)+nVir(iSyma)*nVir(iSymb)
    end do
  end do
else
  nMatab(:) = 0
  iMatab(:,:) = 0
end if

! If batching over occuped orbitals is forced by user, there better
! be orbitals to batch over!
! -----------------------------------------------------------------

if (ForceBatch .and. (nBatOrbT == 1)) ForceBatch = .false.

! Setup batches over occupied orbitals.
! -------------------------------------

! nPQ_prodx will be the largest number of products in one symmetry
#ifdef _DISABLED_
nPQProdx = 0
nPQProdx = nPQ_Prod(1)
do iSym=2,nSym
  nPQProdx = max(nPQProdx,nPQ_Prod(iSym))
end do
#endif

nT1amx = nT1am(1)
do iSym=2,nSym
  nT1amx = max(nT1amx,nT1am(iSym))
end do

if (DecoMP2) then
  do iSym=1,nSym
    NumVec(iSym) = min(NumCho(iSym),nT1am(iSym))
  end do
else
  NumVec(1:nSym) = NumCho(1:nSym)
end if
call Cho_GAiGOp(NumVec,nSym,'max')

! nBatOrbT is the total numbers of orbitals to batch over,
! if densities are not to be computed this is set equal to nOccT

if (nBatOrbT < 6) then
  mBatch = nBatOrbT
else
  mBatch = nBatOrbT/2+1
end if
Accepted = .false.
nBatch = 0
do while ((nBatch < mBatch) .and. (.not. Accepted))

  nBatch = nBatch+1
  if (nBatch == mBatch) then
    nBatch = nBatOrbT
    do iSym=1,nSym
      nFrac(iSym) = max(NumVec(iSym),1)
    end do
  else
    do iSym=1,nSym
      nFrac(iSym) = max(min(NumVec(iSym),20),1)
    end do
  end if

  call ChoMP2_deallocate(irc)
  ChoMP2_allocated = .true.

  call mma_allocate(iFirst,nBatch,Label='iFirst')
  call mma_allocate(iFirstS,nSym,nBatch,Label='iFirstS')
  call mma_allocate(NumOcc,nBatch,Label='NumOcc')
  call mma_allocate(LnOcc,nSym,nBatch,Label='LnOcc')
  call mma_allocate(LnT1am,nSym,nBatch,Label='LnT1am')
  call mma_allocate(LiT1am,nSym,nSym,nBatch,Label='LiT1am')
  call mma_allocate(lUnit,nSym,nBatch,Label='lUnit')

  if (ChoAlg == 2) then
    call mma_allocate(LnMatij,nSym,nBatch,Label='LnMatij')
    call mma_allocate(LiMatij,nSym,nSym,nBatch,Label='LiMatij')
  else
    call mma_allocate(LnMatij,1,1,Label='LnMatij')
    call mma_allocate(LiMatij,1,1,1,Label='LiMatij')
  end if

  ! Generalization of NumOcc for arbitrary quantity to batch over
  ! Would be good to kill NumOcc safely and only use one...
  call mma_allocate(NumBatOrb,nBatch,Label='NumBatOrb')
  ! Generalization of LnOcc for arbitrary quantity to batch over.
  call mma_allocate(LnBatOrb,nSym,nBatch,Label='LnBatOrb')
# ifdef _DISABLED_
  call mma_allocate(LnPQprod,nSym,nBatch,Label='LnPQprod')
  call mma_allocate(LiPQprod,nSym,nSym,nBatch,Label='LiPQprod')
# else
  call mma_allocate(LnPQprod,1,1,Label='LnPQprod')
  call mma_allocate(LiPQprod,1,1,1,Label='LiPQprod')
# endif

  call ChoMP2_Setup_Index(iFirst,iFirstS,NumOcc,LnOcc,NumBatOrb,LnBatOrb,LnT1am,LiT1am,LnPQprod,LiPQprod,LnMatij,LiMatij,nSym, &
                          nBatch)

  call mma_maxDBLE(lWork)
# ifdef _DISABLED_
  ! All Memory available minus one full vector and some small
  ! vectors for the PCG-algorithm.
  lAvail = lWork-nPQprodx-l_Mp2Lagr*9
# else
  if (Laplace .and. SOS_MP2) then
    lX = Zero
    do iSym=1,nSym
      if ((nT1am(iSym) > 0) .and. (NumVec(iSym) > 0)) then
        bsize = min(Laplace_BlockSize,NumVec(iSym))
        nBlock = (NumVec(iSym)-1)/bsize+1
        blast = NumVec(iSym)-bsize*(nBlock-1)
        xM = real(NumVec(iSym),kind=wp)
        xn = real(nBlock,kind=wp)
        xb = real(bsize,kind=wp)
        xbp = real(blast,kind=wp)
        lX = max(lX,Half*(xM*(xM+One)+(xn-One)*xb*(xb-One)+xbp*(xbp-One)))
      end if
    end do
    l_X = int(lX)
    if (l_X < 0) then
      write(Lupri,'(A,A)') SecNam,': dimension of X matrix is negative!'
      write(Lupri,'(A,I15)') 'l_X=',l_X
      if (lX > Zero) then
        write(LuPri,'(A)') 'This seems to be an integer overflow!'
        call Cho_RWord2Byte(lX,Byte,Unt)
        write(LuPri,'(A,ES15.6,A,ES15.6,1X,A,A)') 'In double precision, lX=',lX,' words (',Byte,Unt,')'
      end if
      irc = 1
      lAvail = 0
    else
      lAvail = lWork-l_X
    end if
  else
    lAvail = lWork-nT1amx ! all minus one vector (for reading)
  end if
# endif
  call GAiGOp_Scal(lAvail,'min')
  ! The argument LnPQprod is only used for the case where full
  ! Lpq-vectors are transformed for densities. Will be a dummy arg
  ! for regular MP2.
  Accepted = ChoMP2_Setup_MemChk(LnT1am,LnPQprod,NumVec,nFrac,nSym,nBatch,lAvail)

  if (ForceBatch .and. (nBatch == 1)) Accepted = .false. ! force batching

  if (.not. Accepted) call ChoMP2_deallocate(irc)

  if (irc == 1) then
    Accepted = .false.
    nBatch = mBatch ! break while loop
  end if

end do

if (.not. Accepted) then
  write(u6,*) 'Accepted = false'
  irc = -1
  return
end if

! Initialize file units.
! ----------------------

do iSym=1,nSym
  do iTyp=1,nTypF
    call ChoMP2_OpenF(0,iTyp,iSym)
  end do
end do

end subroutine ChoMP2_Setup

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NRCOUP(ISGSTRUCT,ICISTRUCT,IXSTRUCT,
     &                  NVERT,NMIDV,MXEO,ISM,IDRT,
     &                  ISGMNT,NOW,IOW,NOCP,IOCP,NOCSF,IOCSF,NCSF,
     &                  NRL,MVL,MVR)

      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='NRCOUP')
#include "segtab.fh"
C INPUT PARAMETERS:
CAR   ADD MVR MVL
#include "Struct.fh"
#include "symmul.fh"
      Dimension iSGStruct(nSGSize)
      Dimension iCIStruct(nCISize)
      Dimension iXStruct (nXSize)
      DIMENSION MVL(NMIDV,2),MVR(NMIDV,2)
      DIMENSION IDRT(NVERT,5),ISGMNT(NVERT,26)
      DIMENSION ISM(*)
      PARAMETER (LTAB=1)
C OUTPUT PARAMETERS:
      DIMENSION NOW(2,NSYM,NMIDV),NOCP(MXEO,NSYM,NMIDV)
      DIMENSION IOW(2,NSYM,NMIDV),IOCP(MXEO,NSYM,NMIDV)
      DIMENSION NOCSF(NSYM,NMIDV,NSYM),IOCSF(NSYM,NMIDV,NSYM)
      DIMENSION NCSF(NSYM)
C SCRATCH PARAMETERS:
      DIMENSION NRL(NSYM,NVERT,0:MXEO)




C Dereference ISGSTRUCT, ICISTRUCT for some other data
      NLEV  =ISGSTRUCT(2)
      MVSTA =ISGSTRUCT(9)
      MVEND =ISGSTRUCT(10)
      NIPWLK=ICISTRUCT(2)
      DO 10 INDEO=0,MXEO
        DO 11 IV=1,MVEND
          DO 12 LFTSYM=1,NSYM
            NRL(LFTSYM,IV,INDEO)=0
12        CONTINUE
11      CONTINUE
10    CONTINUE
      NRL(1,1,0)=1
      DO 101 IVLT=1,MVSTA-1
        LEV=IDRT(IVLT,LTAB)
        DO 102 ISGT=1,26
          IVLB=ISGMNT(IVLT,ISGT)
          IF(IVLB.EQ.0) GOTO 102
          ICL=IC1(ISGT)
          ISYM=1
          IF((ICL.EQ.1).OR.(ICL.EQ.2)) ISYM=ISM(LEV)
          DO 100 ITSYM=1,NSYM
            IBSYM=MUL(ITSYM,ISYM)
      IF(ISGT.LE.4) THEN
C THIS IS AN UPPER WALK.
        NRL(IBSYM,IVLB,0)=NRL(IBSYM,IVLB,0)+NRL(ITSYM,IVLT,0)
        GOTO 100
      END IF
      IF(ISGT.LE.8) THEN
C THIS IS AN TOP SEGMENT.
        INDEO=LEV+(IBVPT(ISGT)-1)*NLEV
        NRL(IBSYM,IVLB,INDEO)=NRL(IBSYM,IVLB,INDEO)+NRL(ITSYM,IVLT,0)
        GOTO 100
      END IF
      IF(ISGT.LE.18) THEN
C THIS IS A MID-SEGMENT.
        DO 110 IP=LEV+1,NLEV
          INDEOT=IP+(ITVPT(ISGT)-1)*NLEV
          INDEOB=IP+(IBVPT(ISGT)-1)*NLEV
          NRL(IBSYM,IVLB,INDEOB)=NRL(IBSYM,IVLB,INDEOB)+
     *            NRL(ITSYM,IVLT,INDEOT)
110     CONTINUE
        GOTO 100
      END IF
      IF(ISGT.LE.22) THEN
C THIS IS A BOTTOM SEGMENT.
        DO 120 IP=LEV+1,NLEV
          INDEOT=IP+(ITVPT(ISGT)-1)*NLEV
          IPQ=(IP*(IP-1))/2 + LEV
          INDEOB=IPQ+2*NLEV
          NRL(IBSYM,IVLB,INDEOB)=NRL(IBSYM,IVLB,INDEOB) +
     *          NRL(ITSYM,IVLT,INDEOT)
120     CONTINUE
        GOTO 100
      END IF
C THIS IS A LOWER WALK.
      DO 130 INDEO=2*NLEV+1,MXEO
        NRL(IBSYM,IVLB,INDEO)=NRL(IBSYM,IVLB,INDEO)+
     *         NRL(ITSYM,IVLT,INDEO)
130   CONTINUE
100   CONTINUE
102   CONTINUE
101   CONTINUE
      MXUP=0
      DO 140 MV=1,NMIDV
        IVLT=MV+MVSTA-1
        DO 141 LFTSYM=1,NSYM
          NOW(1,LFTSYM,MV)=NRL(LFTSYM,IVLT,0)
          MXUP=MAX(MXUP,NOW(1,LFTSYM,MV))
          DO 142 INDEO=1,MXEO
            NOCP(INDEO,LFTSYM,MV)=NRL(LFTSYM,IVLT,INDEO)
142       CONTINUE
141     CONTINUE
140   CONTINUE
      DO 150 INDEO=0,MXEO
        DO 151 IV=MVSTA,NVERT
          DO 152 LFTSYM=1,NSYM
            NRL(LFTSYM,IV,INDEO)=0
152       CONTINUE
151     CONTINUE
150   CONTINUE
      NRL(1,NVERT,0)=1
      DO 201 IVLT=NVERT-1,MVSTA,-1
        LEV=IDRT(IVLT,LTAB)
        DO 202 ISGT=1,26
          IVLB=ISGMNT(IVLT,ISGT)
          IF(IVLB.EQ.0) GOTO 202
          ICL=IC1(ISGT)
          ISYM=1
          IF((ICL.EQ.1).OR.(ICL.EQ.2)) ISYM=ISM(LEV)
          DO 200 ITSYM=1,NSYM
            IBSYM=MUL(ITSYM,ISYM)
      IF(ISGT.GE.23) THEN
C THIS IS A LOWER WALK.
        NRL(ITSYM,IVLT,0)=NRL(ITSYM,IVLT,0)+NRL(IBSYM,IVLB,0)
        GOTO 200
      END IF
      IF(ISGT.GE.19) THEN
C THIS IS AN BOTTOM SEGMENT.
        INDEO=LEV+(ITVPT(ISGT)-1)*NLEV
        NRL(ITSYM,IVLT,INDEO)=NRL(ITSYM,IVLT,INDEO)+NRL(IBSYM,IVLB,0)
        GOTO 200
      END IF
      IF(ISGT.GE.9) THEN
C THIS IS A MID-SEGMENT.
        DO 210 IQ=1,LEV-1
          INDEOT=IQ+(ITVPT(ISGT)-1)*NLEV
          INDEOB=IQ+(IBVPT(ISGT)-1)*NLEV
          NRL(ITSYM,IVLT,INDEOT)=NRL(ITSYM,IVLT,INDEOT)+
     *            NRL(IBSYM,IVLB,INDEOB)
210     CONTINUE
        GOTO 200
      END IF
      IF(ISGT.GE.5) THEN
C THIS IS AN TOP SEGMENT.
        DO 220 IQ=1,LEV-1
          INDEOB=IQ+(IBVPT(ISGT)-1)*NLEV
          IPQ=(LEV*(LEV-1))/2+IQ
          INDEOT=IPQ+2*NLEV
          NRL(ITSYM,IVLT,INDEOT)=NRL(ITSYM,IVLT,INDEOT) +
     *          NRL(IBSYM,IVLB,INDEOB)
220     CONTINUE
        GOTO 200
      END IF
C THIS IS AN UPPER WALK.
      DO 230 IPQ=1,(LEV*(LEV-1))/2
        INDEO=2*NLEV+IPQ
        NRL(ITSYM,IVLT,INDEO)=NRL(ITSYM,IVLT,INDEO)+
     *         NRL(IBSYM,IVLB,INDEO)
230   CONTINUE
200   CONTINUE
202   CONTINUE
201   CONTINUE
      MXDWN=0
      DO 240 MV=1,NMIDV
        IVLT=MV+MVSTA-1
        DO 241 LFTSYM=1,NSYM
          NOW(2,LFTSYM,MV)=NRL(LFTSYM,IVLT,0)
          MXDWN=MAX(MXDWN,NOW(2,LFTSYM,MV))
          DO 242 INDEO=1,MXEO
            N=NRL(LFTSYM,IVLT,INDEO)
            IF(N.NE.0) NOCP(INDEO,LFTSYM,MV)=N
242       CONTINUE
241     CONTINUE
240   CONTINUE
      NUW=0
      DO 251 MV=1,NMIDV
        DO 252 ISYM=1,NSYM
          IOW(1,ISYM,MV)=NUW*NIPWLK
          NUW=NUW+NOW(1,ISYM,MV)
252     CONTINUE
251   CONTINUE
      NWALK=NUW
      DO 253 MV=1,NMIDV
        DO 254 ISYM=1,NSYM
          IOW(2,ISYM,MV)=NWALK*NIPWLK
          NWALK=NWALK+NOW(2,ISYM,MV)
254   CONTINUE
253   CONTINUE
      NLW=NWALK-NUW
      NICOUP=0
      DO 260 INDEO=1,MXEO
        DO 261 MV=1,NMIDV
          DO 262 LFTSYM=1,NSYM
            IOCP(INDEO,LFTSYM,MV)=NICOUP
            NICOUP=NICOUP+NOCP(INDEO,LFTSYM,MV)
262       CONTINUE
261     CONTINUE
260   CONTINUE
      DO 270 ISYTOT=1,NSYM
        NCSF(ISYTOT)=0
        DO 271 MV=1,NMIDV
          DO 272 ISYUP=1,NSYM
            ISYDWN=MUL(ISYTOT,ISYUP)
            N=NOW(1,ISYUP,MV)*NOW(2,ISYDWN,MV)
            NOCSF(ISYUP,MV,ISYTOT)=N
            IOCSF(ISYUP,MV,ISYTOT)=NCSF(ISYTOT)
            NCSF(ISYTOT)=NCSF(ISYTOT)+N
272       CONTINUE
271     CONTINUE
270   CONTINUE
CAR   INSERT FOR US IN SIGMA ROUTINE
C
      NSGMX=1
      NT1MX=MAX(MXUP,MXDWN)
      NT2MX=MAX(MXUP,MXDWN)
      NT3MX=MAX(MXUP,MXDWN)
      NT4MX=MAX(MXUP,MXDWN)
      NT5MX=MAX(MXUP,MXDWN)
      DO 550 MV3=1,NMIDV
        MV1=MVL(MV3,2)
        MV2=MVL(MV3,1)
        MV4=MVR(MV3,1)
        MV5=MVR(MV3,2)
      DO 551 ISYUS1=1,NSYM
        NUPS1=NOW(1,ISYUS1,MV3)
      DO 552 ISYDS1=1,NSYM
        NDWNS1=NOW(2,ISYDS1,MV3)
C
        IF (NOCSF(ISYUS1,MV3,ISYDS1).GT.NSGMX)
     *      NSGMX=NOCSF(ISYUS1,MV3,ISYDS1)
C
        IF (MV1.NE.0)THEN
          NT4TMP=NUPS1*NOW(2,ISYDS1,MV1)
          IF (NT4TMP.GT.NT4MX)NT4MX=NT4TMP
          NT5TMP=NDWNS1*NOW(1,ISYUS1,MV1)
          IF (NT5TMP.GT.NT5MX)NT5MX=NT5TMP
        ENDIF
C
        IF (MV2.NE.0)THEN
          NT3TMP=NUPS1*NOW(2,ISYDS1,MV2)
          IF (NT3TMP.GT.NT3MX)NT3MX=NT3TMP
          NT5TMP=NDWNS1*NOW(1,ISYUS1,MV2)
          IF (NT5TMP.GT.NT5MX)NT5MX=NT5TMP
        ENDIF
C
        IF (MV4.NE.0)THEN
          NT1TMP=NUPS1*NOW(2,ISYDS1,MV4)
          IF (NT1TMP.GT.NT1MX)NT1MX=NT1TMP
          NT5TMP=NDWNS1*NOW(1,ISYUS1,MV4)
          IF (NT5TMP.GT.NT5MX)NT5MX=NT5TMP
        ENDIF
C
        IF (MV5.NE.0)THEN
          NT2TMP=NUPS1*NOW(2,ISYDS1,MV5)
          IF (NT2TMP.GT.NT2MX)NT2MX=NT2TMP
          NT5TMP=NDWNS1*NOW(1,ISYUS1,MV5)
          IF (NT5TMP.GT.NT5MX)NT5MX=NT5TMP
        ENDIF
C
552   CONTINUE
551   CONTINUE
550   CONTINUE
      NSUMTOT=2*NSGMX+NT1MX+NT2MX+NT3MX+NT4MX+NT5MX
C
      IF (IPGLOB.GT.INSANE)
     *WRITE(6,555)MXUP,MXDWN,
     *            NSGMX,NSGMX,NT1MX,NT2MX,NT3MX,NT4MX,NT5MX,NSUMTOT
555   FORMAT(/,' MAXIMUM NUMBER OF WALKS',
     *       /,' UPPER ',I6,' LOWER ',I6,
     *       /,' LENGTH OF LARGEST WORK ARRAYS IN SUBROUTINE SIGMA',
     *       /,' TEMPORARY SGM1 ',I7,
     *       /,' TEMPORARY SGM2 ',I7,
     *       /,' NT1MX          ',I7,
     *       /,' NT2MX          ',I7,
     *       /,' NT3MX          ',I7,
     *       /,' NT4MX          ',I7,
     *       /,' NT5MX          ',I7,
     *       /,' TOTAL          ',I7)
C
CAR   END OF INSERT
      IF (IPGLOB.GE.INSANE) THEN
        WRITE(6,*)
        WRITE(6,*)' TOTAL NR OF WALKS: UPPER ',NUW
        WRITE(6,*)'                    LOWER ',NLW
        WRITE(6,*)'                     SUM  ',NWALK
        WRITE(6,*)' TOTAL NR OF COUPL COEFFS ',NICOUP
        INDEO=2*NLEV+1
        WRITE(6,*)'         OF TYPE 1&2 ONLY:',IOCP(INDEO,1,1)
        WRITE(6,*)
        WRITE(6,*)' NR OF CONFIGURATIONS/SYMM:'
        WRITE(6,'(8(1X,I8))')(NCSF(IS),IS=1,NSYM)
        WRITE(6,*)
      END IF
      IF (IPGLOB.GE.INSANE) THEN
        WRITE(6,*)
        WRITE(6,*)' NR OF WALKS AND CONFIGURATIONS IN NRCOUP'
        WRITE(6,*)' BY MIDVERTEX AND SYMMETRY.'
        DO 310 MV=1,NMIDV
          WRITE(6,*)
          WRITE(6,1234) MV,(NOW(1,IS,MV),IS=1,NSYM)
          WRITE(6,1235)    (NOW(2,IS,MV),IS=1,NSYM)
          DO 305 IST=1,NSYM
            WRITE(6,1236)IST,(NOCSF(IS,MV,IST),IS=1,NSYM)
305       CONTINUE
1234  FORMAT('  MV=',I2,'    UPPER WALKS:',8I6)
1235  FORMAT('           LOWER WALKS:',8I6)
1236  FORMAT(' IST=',I2,'  CONFIGURATIONS:',8I6)
310     CONTINUE
        WRITE(6,*)
        WRITE(6,*)' NR OF COUPLING COEFFICIENTS:'
        WRITE(6,*)' 1. OPEN LOOPS TYPE 1:'
        DO 320 IP=1,NLEV
          DO 321 MV=1,NMIDV
            DO 322 IS=1,NSYM
              NCP=NOCP(IP,IS,MV)
              IF(NCP.EQ.0) GOTO 322
              WRITE(6,2345) IP,MV,IS,NCP
2345  FORMAT(' P=',I2,'  MV=',I2,' SYMM ',I1,' NOCP=',I4)
322         CONTINUE
321       CONTINUE
320     CONTINUE
        WRITE(6,*)
        WRITE(6,*)' 2. OPEN LOOPS TYPE 2:'
        DO 330 IP=1,NLEV
          DO 331 MV=1,NMIDV
            DO 332 IS=1,NSYM
              NCP=NOCP(NLEV+IP,IS,MV)
              IF(NCP.EQ.0) GOTO 332
              WRITE(6,2345) IP,MV,IS,NCP
332         CONTINUE
331       CONTINUE
330     CONTINUE
        WRITE(6,*)
        WRITE(6,*)' 3. CLOSED LOOPS:'
        DO 340 IP=2,NLEV
          DO 341 IQ=1,IP-1
            INDEO=2*NLEV+(IP*(IP-1))/2+IQ
            DO 342 MV=1,NMIDV
              DO 343 IS=1,NSYM
                NCP=NOCP(INDEO,IS,MV)
                IF(NCP.EQ.0) GOTO 343
                WRITE(6,2346) IP,IQ,MV,IS,NCP
2346  FORMAT(' P=',I2,'  Q=',I2,'  MV=',I2,' SYMM ',I1,' NOCP=',I4)
343           CONTINUE
342         CONTINUE
341       CONTINUE
340     CONTINUE
      END IF
C Put sizes in structures iCIStruct, iXStruct:
      ICISTRUCT(8)=NWALK
      IXSTRUCT(4 )=NICOUP
      IXSTRUCT(10)=NT1MX
      IXSTRUCT(11)=NT2MX
      IXSTRUCT(12)=NT3MX
      IXSTRUCT(13)=NT4MX
      IXSTRUCT(14)=NT5MX

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Bernd Artur Hess                                 *
************************************************************************
C $Id: vpbmbpv.r,v 1.4 1995/05/08 14:08:53 hess Exp $
C calculate relativistic operators
C   Bernd Artur Hess, hess@uni-bonn.de
C
C
      SUBROUTINE VPBMBPV(idbg,epsilon,EIGA,EIGB,
     *REVTA,SINVA,SINVB,NA,NB,ISIZEA,ISIZEB,VELIT,
     *AAA,AAB,RRA,RRB,PVA,VPA,ISYMA,ISYMB,BU2,G2,
     *AUX2,CMM1,BU4,CMM2,PVAA,VPAA,SCPV,SCVP)
C
      IMPLICIT REAL*8(A-H,O-Z)
#include "real.fh"
C
      DIMENSION PVAA(ISIZEA),VPAA(ISIZEA)
C
      DIMENSION EIGA(NA,NA),EIGB(NB,NB),SINVA(NA,NA),
     *SINVB(NB,NB),REVTA(NA,NA),
     *AAA(NA),RRA(NA),AAB(NB),RRB(NB),
     *PVA(NA,NB),VPA(NA,NB),
     *BU2(NA,NB),G2(NA,NB),
     *CMM1(NA,NB),BU4(NA,NB)
C
      DIMENSION AUX2(NA,NB),CMM2(NA,NB),
     *          SCPV(NB,NA),SCVP(NB,NA)
C
C
C
      IF(iSyma.eq.iSymb) Then
        IJ=0
        DO I=1,NA
        DO J=1,I
        IJ=IJ+1
        PVA(I,J)=PVAA(IJ)
        PVA(J,I)=-VPAA(IJ)
        VPA(I,J)=VPAA(IJ)
        VPA(J,I)=-PVAA(IJ)
        ENDDO
        ENDDO
      ENDIF
C
      IF(iSyma.lt.iSymb) THEN
      DO I=1,NA
      DO J=1,NB
      CMM1(I,J) = SCPV(J,I)
      CMM2(I,J) = SCVP(J,I)
      ENDDO
      ENDDO
      DO I=1,NA
      DO J=1,NB
      PVA(I,J) = CMM1(I,J)
      VPA(I,J) = CMM2(I,J)
      ENDDO
      ENDDO
      CALL DCOPY_(NA*NB,[ZERO],0,CMM1,1)
      CALL DCOPY_(NA*NB,[ZERO],0,CMM2,1)
C
      ENDIF
C
C
C    TRANSFORM pV TO T-BASIS
C
C
      CALL TrSmrN(PVA,SINVA,SINVB,G2,NA,NB,AUX2,CMM1)
      CALL TrSmrN(G2,EIGA,EIGB,BU2,NA,NB,AUX2,CMM1)
*
*
      call dcopy_(na*nb,[Zero],0,G2,1)
      call dcopy_(na*nb,[Zero],0,Aux2,1)
*
C    TRANSFORM Vp TO T-BASIS
*
      CALL TrSmrN(VPA,SINVA,SINVB,G2,NA,NB,AUX2,CMM1)
      CALL TrSmrN(G2,EIGA,EIGB,BU4,NA,NB,AUX2,CMM1)
*
*
C
      call dcopy_(na*nb,[Zero],0,G2,1)
      call dcopy_(na*nb,[Zero],0,Aux2,1)
      call dcopy_(na*nb,[Zero],0,Cmm1,1)
C
C     Multiply
C
C
      DO I=1,NA
      DO J=1,NB
      G2(I,J)=BU4(I,J)*RRB(J)
      CMM1(I,J)=-BU2(I,J)*RRA(I)
      Enddo
      Enddo
C
*
*
*     write(*,*)
*     write(*,*) 'pV part ofcommutator MATRIX'
*     write(*,*)  G2
*     write(*,*)
*
*     write(*,*)
*     write(*,*) '-Vp part commutator MATRIX'
*     write(*,*)  CMM1
*     write(*,*)
*
*
C     Caculate the commutator <iSymA|[V,pb]|iSymB> and put into CMM1
C
      CAll AddMar(NA*NB,G2,CMM1)
C
*
C
C     MultiplY BY A MATRIX
C
      DO I=1,NA
      DO J=1,NB
      CMM1(I,J)=CMM1(I,J)*AAA(I)*AAB(J)
      ENDDO
      ENDDO
C
C
C     MultiplY BY REVTA  MATRIX
C
C
      DO I=1,NA
      DO J=1,NB
      DO K=1,NA
      CMM2(I,J)=CMM2(I,J)+REVTA(I,K)*CMM1(K,J)
      ENDDO
      ENDDO
      ENDDO
C
      call dcopy_(na*nb,[Zero],0,Cmm1,1)
C
*     write(*,*)
*     write(*,*) 'CMM2  MATRX FINAL'
*     write(*,*)  CMM2
*     write(*,*)
C
C
*     write(*,*) 'END OF VPBMBPV !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(idbg)
        CALL Unused_real(epsilon)
        CALL Unused_integer(ISIZEB)
        CALL Unused_real(VELIT)
      END IF
      END
      SUBROUTINE TrSmrN(A,BA,BB,C,NA,NB,H,W)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NA,NB),BA(NA,NA),BB(NB,NB),
     &C(NA,NB),H(NA,NB),W(NA,NB)
C
C     TRANSFORM SYMMETRIC MATRIX A BY UNITARY TRANSFORMATION
C     IN B. RESULT IS IN C
C
C
      CALL DZero(C,NA*NB)
      CALL DZero(H,NA*NB)
      call dcopy_(NA*NB,A,1,W,1)
*
C
      DO 2 I=1,NA
      DO 3 L=1,NB
      DO 4 K=1,NA
      H(I,L)=BA(K,I)*W(K,L)+H(I,L)
4     CONTINUE
3     CONTINUE
2     CONTINUE
*
*
      DO 21 I=1,NA
      DO 22 J=1,NB
      DO 23 L=1,NB
      C(I,J)=H(I,L)*BB(L,J)+C(I,J)
23    CONTINUE
22    CONTINUE
21    CONTINUE
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRAMO(LBUF,OUTBUF,nOUTBUF,X1,nX1,X2,nX2,X3,nX3,VXPQ,nVXPQ,CMO,iDsk,mOVX)
! Purpose: two-electron transformation routine.
!          Transformation is made in core if all half-transformed
!          integrals fit. Otherwise sorted integrals
!          are written onto unit LUHALF.

#ifdef _HDF5_QCM_
use hdf5_utils, only: datadim, datadim_bound, datatag, file_id, hdf5_put_data, tagx
use motra_global, only: ihdf5
use stdalloc, only: mma_allocate, mma_deallocate
#endif
use motra_global, only: FnHalf, IAD13, iPrint, ISP, ISQ, ISR, ISS, LMOP, LMOQ, LMOR, LMOS, LTUVX, LuHalf, LuTwoMO, NBP, NBPQ, NBQ, &
                        NBR, NBRS, NBS, NOP, NOQ, NOR, NOS, NOVX
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: LBUF, nOUTBUF, nX1, nX2, nX3, nVXPQ, mOVX
real(kind=wp), intent(inout) :: OUTBUF(nOUTBUF), X1(nX1), VXPQ(nVXPQ)
real(kind=wp), intent(out) :: X2(nX2), X3(nX3)
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp), intent(out) :: iDsk(3,mOVX)
#include "tratoc.fh"
integer(kind=iwp) :: I, IAD14, IAD14_, inBuf, IOPT, IOUT, IPQ, IPQMAX, IPQST, IPQUT, IPQX, IRC, IRSST, IST, ISTMOT, IVX, IX1, IX2, &
                     KBUF1, LOQ, LPKREC, LPQ, LVXPQ, NBYTES, NP, NPQ, NQ, NQM, NT, NTUVX, NUMAX, NV, NX, NXM
logical(kind=iwp) :: INCORE
#ifdef _HDF5_QCM_
integer(kind=iwp) :: iout_total
integer(kind=iwp), save :: total_number_2ints = 0
real(kind=wp), allocatable :: tmpbuf(:)
#endif

! Set some constants

iDsk(1,:) = -1
iDsk(2,:) = 0
iDsk(3,:) = 1

#ifdef _HDF5_QCM_
if (ihdf5 == 1) then
  !call mma_allocate(tmpbuf,nx1,label='tmpbuf')
  ! Stefan's dirty hack to increase the # of BF working in MOTRA with HDF5
  call mma_allocate(tmpbuf,(nop+1)*(noq+1)*(nor+1)*(nos+1),label='tmpbuf')
  tmpbuf(:) = 0
  write(u6,*) 'size of tmpbuf:',(nop+1)*(noq+1)*(nor+1)*(nos+1)
  iout_total = 0
end if
#endif
KBUF1 = 1
LTUVX = 0
IOUT = 0
IAD14 = 0
IPQUT = 0
IPQMAX = NBPQ
INCORE = .false.
if (NBPQ*NOVX > nVXPQ) then
  INCORE = .true.
  IPQMAX = nVXPQ/NOVX
  IPQMAX = (nVXPQ-IPQMAX)/NOVX
  IPQMAX = (nVXPQ-IPQMAX)/NOVX
  IPQMAX = (nVXPQ-IPQMAX)/NOVX
  write(u6,'(6X,A)') 'OUT OF CORE TRANSFORMATION'
  call DANAME_MF(LUHALF,FNHALF)
end if

! Start loop over sorted AO-integrals: npq pq-pairs in each buffer

if (IPRINT >= 20) write(u6,*) 'TRAMO 001'
IRC = 0
IOPT = 1
IPQ = 0
LPQ = 0
NPQ = 0
IRSST = 1-NBRS
do NP=1,NBP
  NQM = NBQ
  if (ISP == ISQ) NQM = NP
  do NQ=1,NQM
    IPQ = IPQ+1
    IPQUT = IPQUT+1

    ! Read in a block of integrals NPQ pq values

    if (LPQ == NPQ) then
      call RDORD(IRC,IOPT,ISP,ISQ,ISR,ISS,X1,LBUF,NPQ)
      call GADSum(X1,LBUF)
      IOPT = 2
      LPQ = 0
      IRSST = 1-NBRS
    end if
    LPQ = LPQ+1
    IRSST = IRSST+NBRS

    ! Start transformation of this pq pair

    if (ISR == ISS) then
      call SQUARE(X1(IRSST),X2,1,NBS,NBS)
      if (IPRINT >= 30) then
        write(u6,'(6X,A,2I4)') 'AO Integrals for the pair',NP,NQ
        call SQPRT(X2,NBR)
      end if
      if (NBR*NBS*NOS > 0) call DGEMM_('T','N',NBR,NOS,NBS,One,X2,NBS,CMO(LMOS),NBS,Zero,X3,NBR)
      if (NBR*NOR > 0) call DGEMM_Tri('T','N',NOR,NOR,NBR,One,X3,NBR,CMO(LMOR),NBR,ZERO,X2,NOR)
    else
      if (NBR*NBS*NOS > 0) call DGEMM_('T','N',NBR,NOS,NBS,One,X1(IRSST),NBS,CMO(LMOS),NBS,Zero,X3,NBR)
      if (NOS*NBR*NOR > 0) call DGEMM_('T','N',NOS,NOR,NBR,One,X3,NBR,CMO(LMOR),NBR,Zero,X2,NOS)
    end if

    ! Sort the matrix X2 into VXPQ (sort after PQ instead of VX)
    ! if INCORE also write sorted integrals on unit LUHALF.

    if (IPQUT > IPQMAX) then
      IPQUT = 1
      IST = 1
      do I=1,NOVX
        call PKR8(0,IPQMAX,NBYTES,VXPQ(IST),VXPQ(IST))
        LPKREC = (NBYTES+RtoB-1)/RtoB

        IAD14_ = IAD14
        call dDAFILE(LUHALF,1,VXPQ(IST),LPKREC,IAD14)
        call iDAFILE(LUHALF,1,iDsk(1,I),2,IAD14)
        iDsk(1,I) = IAD14_
        iDsk(2,I) = LPKREC
        iDsk(3,I) = iDsk(3,I)+IPQMAX

        IST = IST+IPQMAX
      end do
    end if

    IPQX = IPQUT
    do I=1,NOVX
      VXPQ(IPQX) = X2(I)
      IPQX = IPQX+IPQMAX
    end do
  end do !  NQ
end do   !  NP

LVXPQ = NBPQ*NOVX
if (IPRINT >= 20) write(u6,*) 'TRAMO 002'
if (IPRINT >= 30) then
  write(u6,'(A,I6)') ' HALF TRANSFORMED INTEGRALS:',LVXPQ
  write(u6,'(1X,10F11.6)') VXPQ(1:LVXPQ)
end if

! Empty last buffers

if (INCORE) then
  IST = 1
  do I=1,NOVX
    call PKR8(0,IPQMAX,NBYTES,VXPQ(IST),VXPQ(IST))
    LPKREC = (NBYTES+RtoB-1)/RtoB

    IAD14_ = IAD14
    call dDAFILE(LUHALF,1,VXPQ(IST),LPKREC,IAD14)
    call iDAFILE(LUHALF,1,iDsk(1,I),2,IAD14)
    iDsk(1,I) = IAD14_
    iDsk(2,I) = LPKREC
    iDsk(3,I) = iDsk(3,I)+IPQMAX

    IST = IST+IPQMAX
  end do
  IAD14 = 0
end if

! First half transformation is now done. VXPQ contains half trans-
! formed integrals for this symmetry block, if not INCORE
! otherwise integrals or one VX pair at a time will be read
! from unit LUHALF.

if (IPRINT >= 20) write(u6,*) 'TRAMO 004'
IVX = 0
do NV=1,NOR
  NXM = NV
  if (ISS /= ISR) NXM = NOS
  do NX=1,NXM
    IPQST = 1+NBPQ*IVX
    IVX = IVX+1

    ! Read one buffer of integrals back into core if INCORE

    if (INCORE) then

      ! Back chain buffers

      inBuf = iDsk(3,iVX)
      IPQ = inBuf-IPQMAX
      do
        IAD14 = iDsk(1,iVX)  ! Disk Address of the next buffer
        if (IAD14 < 0) exit
        LPKREC = iDsk(2,iVX)  ! Length of the  buffer
        call dDAFILE(LUHALF,2,VXPQ(inBuf),LPKREC,IAD14)
        call iDAFILE(LUHALF,2,iDsk(1,iVX),2,IAD14)
        call UPKR8(0,IPQMAX,NBYTES,VXPQ(inBuf),VXPQ(IPQ))
        IPQ = IPQ-IPQMAX
      end do

      IPQST = 1
    end if
    if (ISP /= ISR) then
      if (ISP == ISQ) then
        call SQUARE(VXPQ(IPQST),X2,1,NBQ,NBQ)
        if (NBP*NBQ*NOQ > 0) call DGEMM_('T','N',NBP,NOQ,NBQ,One,X2,NBQ,CMO(LMOQ),NBQ,Zero,X1,NBP)
        If (NOP*NBP > 0) call DGEMM_Tri('T','N',NOP,NOP,NBP,One,X1,NBP,CMO(LMOP),NBP,Zero,X2,NOP)
        IX2 = (NOP+NOP**2)/2
      else
        if (NBP*NBQ*NOQ > 0) call DGEMM_('T','N',NBP,NOQ,NBQ,One,VXPQ(IPQST),NBQ,CMO(LMOQ),NBQ,Zero,X1,NBP)
        if (NOQ*NBP*NOP > 0) call DGEMM_('T','N',NOQ,NOP,NBP,One,X1,NBP,CMO(LMOP),NBP,Zero,X2,NOQ)
        IX2 = NOP*NOQ
      end if
    else
      if (ISP == ISQ) then
        call SQUARE(VXPQ(IPQST),X2,1,NBP,NBP)
        if (NBP*NBQ*NOQ > 0) call DGEMM_('T','N',NBP,NOQ,NBQ,One,X2,NBQ,CMO(LMOQ),NBQ,Zero,X1,NBP)
      else
        if (NBP*NBQ*NOQ > 0) call DGEMM_('T','N',NBP,NOQ,NBQ,One,VXPQ(IPQST),NBQ,CMO(LMOQ),NBQ,Zero,X1,NBP)
      end if

      ! X1 now contains the matrix (pu/vx) for all p and all u
      ! for a fixed pair vx.
      ! If the first index t=v then the range of u is x,umax
      ! Otherwise the range is 1,umax. a loop over t is necessary her

      ISTMOT = LMOP+NBP*(NV-1)
      IX2 = 1
      do NT=NV,NOP
        NUMAX = NOQ
        if (ISP == ISQ) NUMAX = NT
        LOQ = NUMAX
        if (NT == NV) LOQ = NUMAX-NX+1
        IX1 = 1
        if (NT == NV) IX1 = 1+NBP*(NX-1)
        if (LOQ > 0) then
          if (NBP == 0) then
            X2(IX2:IX2+LOQ-1) = Zero
          else
            call DGEMM_('T','N',LOQ,1,NBP,One,X1(IX1),NBP,CMO(ISTMOT),NBP,Zero,X2(IX2),LOQ)
          end if
        end if
        IX2 = IX2+LOQ
        ISTMOT = ISTMOT+NBP
      end do
      IX2 = IX2-1
    end if

    ! Move integrals to output buffer and write them on LUTWOMO

    do NTUVX=1,IX2
      if (IOUT == nTraBuf) then
        IOUT = 0
        if (IPRINT >= 5) then
          write(u6,'(A)') 'SAVE TRANSFORMED INTEGRALS:'
          write(u6,'(A,3I8)') 'LU,nTraBuf,IDISK =',LUTWOMO,nTraBuf,IAD13
        end if
        call dDAFILE(LUTWOMO,1,OUTBUF(KBUF1),nTraBuf,IAD13)
#       ifdef _HDF5_QCM_
        !write(u6,*) 'SAVE TRANSFORMED INTEGRALS:',nTraBuf,KBUF1,iout_total,iout_total+nTraBuf
        if (ihdf5 == 1) then
          call dcopy_(nTraBuf,OUTBUF(KBUF1),1,tmpbuf(iout_total+1),1)
          iout_total = iout_total+nTraBuf
        end if
#       endif
        KBUF1 = nTraBuf+2-KBUF1
      end if
      IOUT = IOUT+1
      LTUVX = LTUVX+1
      OUTBUF(IOUT+KBUF1-1) = X2(NTUVX)
    end do
  end do
end do

! Empty last buffer (which is never empty)

if (IPRINT >= 5) then
  write(u6,'(A)') 'SAVE TRANSFORMED INTEGRALS:'
  write(u6,'(A,3I8)') 'LU,nTraBuf,IDISK =',LUTWOMO,nTraBuf,IAD13
end if
call dDAFILE(LUTWOMO,1,OUTBUF(KBUF1),nTraBuf,IAD13)
if (IPRINT >= 10) then
  write(u6,'(1X,A,4I2,A,I4)') 'TRANSFORMED INTEGRALS FOR SYMMETRY BLOCK',ISP,ISQ,ISR,ISS,' IOUT=',IOUT
  write(u6,'(1X,10F12.6)') OUTBUF(KBUF1:KBUF1+IOUT-1)
end if

#ifdef _HDF5_QCM_
if (ihdf5 == 1) then
  !> and the last buffer here as well...
  call dcopy_(iout,OUTBUF(KBUF1),1,tmpbuf(iout_total+1),1)
  iout_total = iout_total+iout
  !> put data to file
  write(datatag,'(a1,i3,a1,i3,a1,i3,a1,i3)') 'p',isp,'q',isq,'r',isr,'s',iss
  tagx = 16
  datadim(1) = 1
  datadim_bound = 1
  call hdf5_put_data(file_id(1),'XXXXXX',datadim,iout_total)
  datadim(1) = iout_total
  datadim_bound = 1
  call hdf5_put_data(file_id(1),'XXXXXX',datadim,tmpbuf)

  if (IPRINT >= 5) then
    total_number_2ints = total_number_2ints+iout_total
    write(u6,'(1X,a,i10)') ' total number of integrals (sym)  ...',iout_total
    write(u6,'(1X,a,i10)') ' total number of integrals so far ...',total_number_2ints
  end if

  call mma_deallocate(tmpbuf)
end if
#endif

if (INCORE) call DACLOS(LUHALF)

return

end subroutine TRAMO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SIADD(A,B,N)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: A(N,N)
real(kind=wp), intent(inout) :: B(*)
integer(kind=iwp) :: I, IIN, J

IIN = 0
do I=1,N
  do J=1,I-1
    IIN = IIN+1
    B(IIN) = B(IIN)+A(I,J)+A(J,I)
  end do
  IIN = IIN+1
  B(IIN) = B(IIN)+A(I,I)
end do

return

end subroutine SIADD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Bernd Artur Hess                                 *
************************************************************************
      SUBROUTINE RELOP
      IMPLICIT REAL*8(A-H,O-Z)
C
C     SUBROUTINE RELOP INITIALIZES THE COMMON BLOCK USED BY
C     THE RELOP PACKAGE
C     V 1.0 - 12.3.86 - BERND HESS
C
#include "RelLight.fh"
      COMMON /CRELOP/ PI,ZWP,SQPI,VELIT,PREA,CSQ,ZWPH32,FAK(26),
     *                ZWPH12,BCO(210),GA(20),IMAX
      SAVE /CRELOP/
c      WRITE (6,100)
c100   FORMAT(/,
c     X' ****** RELATIVISTIC OPERATORS V 1.0 - BERND HESS ******'
c     X//)
      PI=4.D0*ATAN(1.D0)
      ZWP=2.D0*PI
      ZWPH32=ZWP**1.5D0
      ZWPH12=sqrt(ZWP)
      SQPI=sqrt(PI)
      VELIT=CLightAU
      PREA=1.D0/(VELIT*VELIT)
      CSQ=VELIT*VELIT
      FAK(1)=1.D0
C     GHALB(1)=SQPI
      DO 1 I=2,26
C     GHALB(I)=GHALB(I-1)*(DBLE(I)-1.5D0)
      FAK(I)=FAK(I-1)*DBLE(I-1)
1     CONTINUE
C
C     BINOMIALKOEFFIZIENTEN
C
      IMAX=20
      BCO(1)=1.D0
      IBIAS=1
      JBIAS=1
      K=IMAX-1
      DO 53 I=1,K
      ADD=0.D0
      DO 52 J=1,I
      JBIAS=JBIAS+1
      BCO(JBIAS)=ADD+BCO(IBIAS)
      ADD=BCO(IBIAS)
      IBIAS=IBIAS+1
52    CONTINUE
      JBIAS=JBIAS+1
      BCO(JBIAS)=1.D0
53    CONTINUE
C
      DO 10 N=1,20
      GA(N)=GAM(N-1)
10    CONTINUE
      RETURN
      END
      SUBROUTINE ADDMA(N,S,OVE)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION S(N),OVE(N)
      DO 1 I=1,N
      OVE(I)=OVE(I)+S(I)
1     CONTINUE
      RETURN
      END
C     COMPILER (XM=3)
*                                                                      *
************************************************************************
*                                                                      *

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombOnly0_1(nD,FactC,ip_VBlocks,ip_FBlocks,AB,CD)
! Thomas Bondo Pedersen, September 2010.
!
!          OLD CODE
!
! Purpose: Compute
!
!      F(u_A v_B) = F(u_A v_B) + FactC*sum_[K_CD] (u_A v_B | K_CD)*V(K_CD)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nD, ip_VBlocks(nD), ip_FBlocks(nD), AB, CD
real(kind=wp), intent(in) :: FactC(nD)
integer(kind=iwp) :: A, B, nuv, M, l_Int, iD, ipV, ipF
real(kind=wp), allocatable :: FuvJ1(:)
integer(kind=iwp), external :: LDF_nBas_Atom, LDF_nBasAux_Pair
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

! Get row and column dimensions of integrals
A = iWork(ip_AP_Atoms-1+2*(AB-1)+1)
B = iWork(ip_AP_Atoms-1+2*(AB-1)+2)
nuv = LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
M = LDF_nBasAux_Pair(CD)

! Return if nothing to do
if ((nuv < 1) .or. (M < 1)) return

! Allocate integrals (u_A v_B | K_CD)
l_Int = nuv*M
call mma_allocate(FuvJ1,l_Int,label='LDFFuvJ1')

! Compute integrals (u_A v_B | K_CD)
call LDF_ComputeIntegrals_uvJ_2P(AB,CD,l_Int,FuvJ1)

! Compute contributions
do iD=1,nD
  ipV = iWork(ip_VBlocks(iD)-1+CD)
  ipF = iWork(ip_FBlocks(iD)-1+AB)
  call dGeMV_('N',nuv,M,FactC(iD),FuvJ1,nuv,Work(ipV),1,One,Work(ipF),1)
end do

! Deallocate integrals
call mma_deallocate(FuvJ1)

end subroutine LDF_Fock_CoulombOnly0_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
       SubRoutine Read2_2(rMO1,rMO2,FockI,FockA,
     &                    Temp1,nTemp,Temp2,Temp3,Temp4,
     &                    DI13,DI24,DI,
     &                    DA13,DA24,DA,
     &                    rkappa,idsym,
     &                    Signa,Fact,jSpin,lfat,lfit,lMOt,CMO)
********************************************************************
*                                        ~     ~                   *
*   Monster routine for construction of Fock, MO                   *
*                                                                  *
*   Input: rkappa : Rotation matrix                                *
*          idsym  : symmetry of perturbation                       *
*          DIR    : Inactive One electron density                  *
*          DAR    : Inactive One electron density                  *
*                                                                  *
*   Scrtch:Temp1, Temp2,Temp3,Temp4,DR,DL                          *
*                                                                  *
*   Output:                                                        *
*         FockI(A):Fock matrix (one index transformed integrals)   *
*                  ~~                                              *
*         rMO1    (pj|kl)\     Added together this gives oneindex  *
*                     ~~  -->  transformed integrals. They are     *
*         rMO2    (pj|kl)/     separated to make it easy to go     *
*                              to spindependent perturbations      *
*                                                                  *
*   Remember Coulomb type integrals are used to construct          *
*   exchange part Fock matrix and exchange integrals to construct  *
*   Coulomb part.                                                  *
*                                                                  *
*   Sign  =  1                                                     *
*                                                                  *
*   Sign  = -1  {I,K}=KI+signIK                                    *
*                                                                  *
*   jspin =  0  Fock matrixes and MO's needed for singlet          *
*               perturbations                                      *
*                                                                  *
*   jspin =  1  Fock matrixes and MO's needed for triplet          *
*               perturbations                                      *
*                                                                  *
********************************************************************
      Implicit Real*8(a-h,o-z)
#include "Pointers.fh"
#include "Input.fh"
#include "intgrl.fh"
      Real*8 rkappa(nDens2),FockA(nDens2),FockI(nDens2),
     &       Temp1(ntemp),Temp2(nDens2),
     &       temp3(nDens2),Temp4(nDens2),
     &       rmo1(nMba),rmo2(nmba),
     &       CMO(nCMO),DA(nCMO),DI(nCMO),
     &       DA24(nDens2),DI24(nDens2),
     &       DA13(nDens2),DI13(nDens2)
      Parameter ( half  = 0.5d0 )
      Parameter ( One   = 1.0d0 )
      Parameter ( Two   = 2.0d0 )
      Logical lFAt,lFIT,lmot,singlet
*                                                                      *
************************************************************************
*                                                                      *
* (mn|pq)=sum(o) T  (on|pq) + sign*T  (mo|pq)+T (mn|oq) +sign*T  (mn|po)
*                 mo                no         po              qo
*
*
*   DL = sum(po) D  T   C     (13)
*     bj          ij pi  bp
*
*                     *
*   DR  = sum(qo) D  T  C     (24)
*     ib           ij jp bp
*
*
      If (jspin.eq.1) Then
        Singlet=.false.
      Else If (jspin.eq.0) Then
        Singlet=.true.
      Else
        Singlet=.false.
        Write(6,*) 'Error jspin=/=1,0'
        Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*                         t
*     Construct ( C* kappa * D )   &   ( C * kappa ) and store it with
*     the general index as the 1st index and the occupied as the 2nd.
*     The general index is transformed to AO index (contravariant).
*                                                                      *
************************************************************************
*                                                                      *
      Do iS=1,nSym
         If (nOrb(iS).ne.0) Then
            Do jS=1,nSym
               If (iEOr(iS-1,jS-1)+1.eq.idsym.and.nB(jS).ne.0) Then
*
                  Call DGEMM_('N','N',
     &                        nOrb(iS),nB(jS),nOrb(jS),
     &                        1.0d0,rkappa(ipMat(is,js)),nOrb(iS),
     &                        DI(ipCM(js)),nOrb(jS),
     &                        0.0d0,DI24(ipMat(iS,jS)),nOrb(iS))
*
                  Call DGEMM_('T','N',
     &                        nOrb(iS),nB(jS),nOrb(jS),
     &                        1.0d0,rkappa(ipMat(js,is)),nOrb(jS),
     &                        DI(ipCM(js)),nOrb(jS),
     &                        0.0d0,DI13(ipMat(iS,jS)),nOrb(iS))
*
                  If (iMethod.eq.2) Then
*
                     Call DGEMM_('N','N',
     &                           nOrb(iS),nB(jS),nOrb(jS),
     &                           1.0d0,rkappa(ipMat(is,js)),nOrb(iS),
     &                           DA(ipCM(js)),nOrb(jS),
     &                           0.0d0,DA24(ipMat(iS,jS)),nOrb(iS))
*
                     Call DGEMM_('T','N',
     &                           nOrb(iS),nB(jS),nOrb(jS),
     &                           1.0d0,rKappa(ipMat(js,iS)),nOrb(jS),
     &                           DA(ipCM(js)),nOrb(js),
     &                           0.0d0,DA13(ipMat(iS,jS)),nOrb(iS))
*
                  End If
               End If
            End Do
         End If
      End Do
*
      sign=1.0d0
      If (imethod.eq.2) Call DScal_(ndens2,signa,DA24,1)
      Call DScal_(ndens2,signa,Di24,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Read in integrals                                                *
*                                                                      *
************************************************************************
*                                                                      *
      Do iS=1,nSym
       Do jS=1,iS
*
        If (nOrb(iS)*nOrb(jS).ne.0) Then
*
        ijS=iEOr(iS-1,jS-1)+1
        Do kS=1,nSym
         Do lS=1,ks
          If (nOrb(kS)*nOrb(lS).ne.0) Then
*
*
           If (iEOr(kS-1,lS-1).eq.ijS-1) Then
            Do iB=1,nB(iS)
             nnB=nB(jS)
             If (iS.eq.jS) nnB=iB
             Do jB=1,nnB
*
              Call COUL(lS,kS,IS,jS,IB,JB,Temp2,Temp4)

***************************************************************************
*                                                                         *
*       A   C   T   I   V   E      F   O   C   K   M   A   T   R   I   X  *
*                                                                         *
***************************************************************************
*                                       ~
*-----------------Fpj = sum(i,l) Dil (pl|ij) = sum(ilr) Dil Klr (pr|ij) =
*
*                                IJ  I
*                  Fqj=sum(rI)  I  DL
*                                qr  r
*
              If (lFAT) Then
*
                If (iEOr(ls-1,is-1)+1.eq.idsym) Then
                 ipD=ipMat(lS,iS)+nOrb(lS)*(ib-1)
                 ipF=ipMat(kS,jS)+nOrb(kS)*(jB-1)
                 Call dGeMV_('T',nOrb(lS),nOrb(kS),
     &                     -Fact*Sign*half,
     &                     Temp2,nOrb(lS),DA24(ipD),1,
     &                     One,FockA(ipF),1)
                End If
*
*                                IJ  I
*                  FqJ=sum(rI)  I  DL
*                                rq  r
*
                If (kS.ne.ls.and.(iEOr(kS-1,is-1)+1.eq.iDSym)) Then
                 ipD=ipMat(kS,iS)+nOrb(kS)*(ib-1)
                 ipF=ipMat(lS,jS)+nOrb(lS)*(jB-1)
                 Call dGeMV_('N', nOrb(lS),nOrb(kS),-Fact*Sign*half,
     &                     Temp2,nOrb(lS),DA24(ipD),1,
     &                     One,FockA(ipF),1)
                End If
*
*                                JI  J
*                  FqI=sum(rJ)  I  DL
*                                qr  r

                If (iS.ne.jS.or.iB.ne.jb) Then
                 If (iEOr(lS-1,js-1)+1.eq.iDSym) Then
                  ipD=ipMat(lS,jS)+nOrb(lS)*(jb-1)
                  ipF=ipMat(kS,iS)+nOrb(kS)*(iB-1)
                  Call dGeMV_('T',nOrb(lS),nOrb(kS),-Fact*Sign*half,
     &                      Temp2,nOrb(lS),DA24(ipD),1,
     &                      One,FockA(ipF),1)
                 End If
*
*                                 JI  J
*                  Fqr=sum(rJ) = I  DL
*                                 rq  r
*
                 If (kS.ne.ls.and.(iEOr(kS-1,js-1)+1.eq.iDSym)) Then
                  ipD=ipMat(kS,jS)+nOrb(kS)*(jb-1)
                  ipF=ipMat(lS,iS)+nOrb(lS)*(iB-1)
                  Call dGeMV_('N', nOrb(lS),nOrb(kS),-Fact*Sign*half,
     &                     Temp2,nOrb(lS),DA24(ipD),1,
     &                     One,FockA(ipF),1)
                 End If

                End If
              End If
******************************************************************************
*                                                                            *
*  I   N   A   C   T   I   V   E      F   O   C   K   M   A   T   R   I   X  *
*                                                                            *
******************************************************************************
              If (lFIT) Then
*                                IJ  I
*                  Fqj=sum(rI)  I  DL
*                                qr  r
*
                If (iEOr(ls-1,is-1)+1.eq.idsym) Then
                 ipD=ipMat(lS,iS)+nOrb(lS)*(ib-1)
                 ipF=ipMat(kS,jS)+norb(kS)*(jB-1)
                 Call dGeMV_('T',nOrb(lS),nOrb(kS),
     &                     -Fact*Sign*half,
     &                     Temp2,nOrb(lS),DI24(ipD),1,
     &                     One,FockI(ipF),1)
                End If
*
*                                IJ  I
*                  FqJ=sum(rI)  I  DL
*                                rq  r
*
                If (kS.ne.ls.and.(iEOr(kS-1,is-1)+1.eq.iDSym)) Then
                 ipD=ipMat(kS,iS)+nOrb(kS)*(ib-1)
                 ipF=ipMat(lS,jS)+norb(lS)*(jB-1)
                 Call dGeMV_('N', nOrb(lS),nOrb(kS),-Fact*Sign*half,
     &                     Temp2,nOrb(lS),DI24(ipD),1,
     &                     One,FockI(ipF),1)
                End If

*
*                                JI  J
*                  FqI=sum(rJ)  I  DL
*                                qr  r

                If (iS.ne.jS.or.iB.ne.jb) Then
                 If (iEOr(lS-1,js-1)+1.eq.iDSym) Then
                  ipD=ipMat(lS,jS)+nOrb(lS)*(jb-1)
                  ipF=ipMat(kS,iS)+norb(kS)*(iB-1)
                  Call dGeMV_('T',nOrb(lS),nOrb(kS),-Fact*Sign*half,
     &                      Temp2,nOrb(lS),DI24(ipD),1,
     &                      One,FockI(ipF),1)
                 End If
*
*                                 JI  J
*                  Fqr=sum(rJ) = I  DL
*                                 rq  r
*
                 If (kS.ne.ls.and.(iEOr(kS-1,js-1)+1.eq.iDSym)) Then
                  ipD=ipMat(kS,jS)+nOrb(kS)*(jb-1)
                  ipF=ipMat(lS,iS)+norb(lS)*(iB-1)
                  Call dGeMV_('N', nOrb(lS),nOrb(kS),-Fact*Sign*half,
     &                     Temp2,nOrb(lS),DI24(ipD),1,
     &                     One,FockI(ipF),1)
                 End If

                End If
              End If
*
******************************************************************************
*
*             The rest of the Fock matrix is taken from {F,K}
*             and exchange type integrals
*
******************************************************************************
************************************************************************
*
*            M O !!!
*             ~           ~
*            (pj|kl) &  (pj|kl)
*
************************************************************************
*--------NOT DEBUGGED?
*|
*V
              If (LMOT.and.jB.gt.nIsh(js).and.ib.gt.nish(is).and.
     &           nOrb(ls)*nOrb(ks).gt.0) Then
               iib=ib-nIsh(is)
               jjb=jb-nIsh(js)

               Call DGETMO(Temp2,nOrb(ls),nOrb(ls),nOrb(kS),
     &                     Temp4,nOrb(ks))

*
               ipS=iEOr(kS-1,idsym-1)+1
               If (nOrb(ips)*nAsh(lS).gt.0) Then
                ipI=norb(ks)*nIsh(ls)+1
                ip1=ipMO(ls,js,is)+
     &             nOrb(ips)*nAsh(ls)*((iiB-1)*nAsh(jS)+jjb-1)
                ip4=ipMO(ls,is,js)+
     &             nOrb(ips)*nAsh(ls)*((jjB-1)*nAsh(iS)+iib-1)
                Call DGEMM_('N','N',
     &                      nOrb(ips),nAsh(ls),nOrb(ks),
     &                      1.0d0,rKappa(ipMat(ips,ks)),nOrb(ipS),
     &                      Temp4(ipI),nOrb(ks),
     &                      0.0d0,Temp3,nOrb(ips))
*               ~
*              (pl|ij)
*
                call daxpy_(nOrb(ips)*nash(ls),
     &                     Fact,Temp3,1,rmo1(ip1),1)

*               ~
*              (pl|ji)
*
                If (is.ne.js.or.ib.ne.jb)
     &              call daxpy_(nOrb(ips)*nash(ls),
     &                         Fact,temp3,1,rmo1(ip4),1)
               End If ! nOrb(ips)*nAsh(lS)
*
               If (ks.ne.ls) Then
                 ipS=iEOr(lS-1,idsym-1)+1
                 If (nOrb(ips)*nAsh(ks).gt.0) Then
                  ip1=ipMO(ks,js,is)+
     &               nOrb(ips)*nAsh(ks)*((iiB-1)*nAsh(jS)+jjb-1)
                  ip4=ipMO(ks,is,js)+
     &               nOrb(ips)*nAsh(ks)*((jjB-1)*nAsh(iS)+iib-1)
                  Call DGEMM_('N','T',
     &                        nOrb(ips),nAsh(ks),nOrb(ls),
     &                        1.0d0,rKappa(ipmat(ips,ls)),nOrb(ips),
     &                        Temp4(nIsh(ks)+1),nOrb(ks),
     &                        0.0d0,Temp3,nOrb(ips))
*               ~
*              (pk|ij)
*
                  call daxpy_(nOrb(ips)*nash(ks),
     &                 Fact,temp3,1,rmo1(ip1),1)

*               ~
*              (pk|ji)
*
                  If (is.ne.js.or.ib.ne.jb)
     &             call daxpy_(nOrb(ips)*nash(ks),Fact,
     6                       temp3,1,rmo1(ip4),1)
                 End If !(nOrb(ips)
               End If ! kl

               ipS=iEOr(lS-1,idsym-1)+1
               If (nOrb(ks)*nAsh(ips).gt.0) Then
                ip2=ipMO(ips,js,is)+
     &             nOrb(kS)*nAsh(ips)*((iiB-1)*nAsh(jS)+jjb-1)
                ip3=ipMO(ips,is,js)+
     &             nOrb(kS)*nAsh(ips)*((jjB-1)*nAsh(iS)+iib-1)
                Call DGEMM_('N','N',
     &                      nOrb(ks),nAsh(ips),nOrb(ls),
     &                      1.0d0,Temp4,nOrb(kS),
     &                      rkappa(ipMat(ls,ips)+nOrb(ls)*nIsh(ips)),
     &                      nOrb(ls),
     &                      0.0d0,Temp3,nOrb(ks))
*                ~
*              (pl|ji)
*
                call daxpy_(nOrb(ks)*nash(ips),Fact*Signa,
     &                     temp3,1,rmo1(ip2),1)
*                ~
*              (pl|ij)
*
                 If (is.ne.js.or.ib.ne.jb)
     &             call daxpy_(nOrb(ks)*nash(ips),Fact*Signa,
     &                        temp3,1,rmo1(ip3),1)
               End If ! nOrb(ips)

               If (ks.ne.ls) Then
                 ipS=iEOr(kS-1,idsym-1)+1
                 If (nOrb(ls)*nAsh(ips).gt.0) Then
                  ip1=ipMO(ips,js,is)+
     &               nOrb(ls)*nAsh(ips)*((iiB-1)*nAsh(jS)+jjb-1)
                  ip4=ipMO(ips,is,js)+
     &               nOrb(ls)*nAsh(ips)*((jjB-1)*nAsh(iS)+iib-1)
                  Call DGEMM_('T','N',
     &                        nOrb(ls),nAsh(ips),nOrb(ks),
     &                        1.0d0,Temp4,nOrb(ks),
     &                        rKappa(ipMat(ks,ips)+nOrb(ks)*nIsh(ips)),
     &                        nOrb(ks),
     &                        0.0d0,Temp3,nOrb(ls))
*                ~
*              (pk|ij)
*
                  call daxpy_(nOrb(ls)*nash(ips),
     &                      Fact*Signa,temp3,1,rmo1(ip1),1)
*                ~
*              (pk|ji)
*
                  If (is.ne.js.or.ib.ne.jb)
     &             call daxpy_(nOrb(ls)*nash(ips),Fact*Signa,
     &                        temp3,1,rmo1(ip4),1)
                 End If !(nOrb)
               End If ! (kl)
*A
*|
*--------NOT DEBUGGED?
               End If ! lmo
*
             End Do
            End Do
          End If
          End If
         End Do
        End Do
*
        End If
*
       End Do
      End Do
*
********************************************************************
*
      Do iS=1,nSym
       Do jS=1,nSym
*
        If (nOrb(iS)*nOrb(jS).ne.0) Then
*
        ijS=iEOr(iS-1,jS-1)+1
        Do kS=1,nSym
         Do lS=1,nSym
*
          If (iEOr(kS-1,lS-1)+1.eq.ijS) Then
          If (nOrb(kS)*nOrb(lS).ne.0) Then
*
           Do lB=1,nB(lS)
            Do jB=1,nB(jS)
*
            Call EXCH(is,js,ks,ls,jb,lb,Temp1,Temp2)
*
******************************************************************************
*                                                                            *
*  I   N   A   C   T   I   V   E      F   O   C   K   M   A   T   R   I   X  *
*                                                                            *
******************************************************************************
             If (lFIT) Then
*                       ~
*             Fpi=Dkl(pi|kl)=Dkl Kkr (pi|rl)=
*
*                    il   l
*             F =   I   DR
*              pi    pr   r
*
              If (singlet) Then
               If (iEOr(ks-1,ls-1)+1.eq.idsym) Then
                ipD=ipMat(kS,lS)+nOrb(kS)*(lb-1)
                ipF=ipMat(iS,jS)+norb(iS)*(jB-1)
                Call dGeMV_('N', nOrb(iS),nOrb(kS),Fact,
     &                     Temp1,nOrb(iS),DI13(ipD),1,
     &                     One,FockI(ipF),1)
*
*                       ~
*             Fpi=Dkl(pi|kl)=Dkl Klr (pi|lr)=(Dkl Klr (pi|rl)
*
*                    il   l
*             F =   I   DL
*              pi    pr   r
*

                ipD=ipMat(kS,lS)+nOrb(kS)*(lb-1)
                ipF=ipMat(iS,jS)+nOrb(iS)*(jB-1)
                Call dGeMV_('N', nOrb(iS),nOrb(kS),Fact*Sign,
     &                     Temp1,nOrb(iS),DI24(ipD),1,
     &                     One,FockI(ipF),1)
               End If
              End If
*                       ~
*             Fpl=Dkj(pj|kl)=Dkj Kkr (pj|rl)
*
*                         jl   j
*                        I   DR
*                         pr   r
              If (iEOr(ks-1,js-1)+1.eq.idsym) Then
               ipD=ipMat(kS,jS)+nOrb(kS)*(jb-1)
               ipF=ipMat(iS,lS)+nOrb(iS)*(lB-1)
               Call dGeMV_('N', nOrb(iS),nOrb(kS),-Fact*half,
     &                     Temp1,nOrb(iS),DI13(ipD),1,
     &                     One,FockI(ipF),1)


              End If
             End If
******************************************************************************
*                                                                            *
*          A   C   T   I   V   E      F   O   C   K   M   A   T   R   I   X  *
*                                                                            *
******************************************************************************
             If (lFAT) Then
              If (singlet) Then
*                       ~
*             Fpi=Dkl(pi|kl)=Dkl Kkr (pi|rl)=
*
*                    il   l
*             F =   I   DR
*              pi    pr   r
*
               If (iEOr(ks-1,ls-1)+1.eq.idsym) Then
                ipD=ipMat(kS,lS)+nOrb(kS)*(lb-1)
                ipF=ipMat(iS,jS)+nOrb(iS)*(jB-1)
                Call dGeMV_('N', nOrb(iS),nOrb(kS),Fact,
     &                     Temp1,nOrb(iS),DA13(ipD),1,
     &                     One,FockA(ipF),1)
*
*                       ~
*             Fpi=Dkl(pi|kl)=Dkl Krl (pi|rl)=
*
*                    il   l
*             F =   I   DL
*              pi    pr   r
*

                ipD=ipMat(kS,lS)+nOrb(kS)*(lb-1)
                ipF=ipMat(iS,jS)+nOrb(iS)*(jB-1)
                Call dGeMV_('N', nOrb(iS),nOrb(kS),Fact*Sign,
     &                     Temp1,nOrb(iS),DA24(ipD),1,
     &                     One,FockA(ipF),1)
               End If
              End If
*                       ~
*             Fpl=Dkj(pj|kl)=Dkj Kkr (pj|rl)
*
*                         jl   j
*                        I   DR
*                         pr   r
              If (iEOr(kS-1,js-1).eq.idsym-1) Then
                ipD=ipMat(kS,jS)+nOrb(kS)*(jb-1)
                ipF=ipMat(iS,lS)+nOrb(iS)*(lB-1)
                Call dGeMV_('N', nOrb(iS),nOrb(kS),-Fact*half,
     &                     Temp1,nOrb(iS),DA13(ipD),1,
     &                     One,FockA(ipF),1)

              End If
             End If
*
************************************************************************
*
*            M O !!!
*                ~           ~
*            (pj|kl) &  (pj|kl)
*
************************************************************************
*
             If (lmot.and.(nAsh(js)*nAsh(ls).ne.0).and.
     &          ( (jb.gt.nish(js)).and.(lB.gt.nish(ls))) ) Then

              call dcopy_(nOrb(iS)*nOrb(kS),Temp1,1,Temp3,1)

*                 ~            ~
*             (pj|kl) &   (pj|lk)
*
*              JL                      JL
*             I   k    (iJ|kL)      & I   k    (iJLk)
*              ir  kr                  ir  kr
              ips=iEOR(kS-1,iDsym-1)+1
              If (nOrb(iS)*nAsh(ipS).ne.0)
     &         Call DGEMM_('N','T',
     &                     nOrb(iS),nAsh(ipS),nOrb(kS),
     &                     1.0d0,Temp3,nOrb(iS),
     &                     rKappa(ipMat(ips,ks)+nIsh(ips)),nOrb(ips),
     &                     0.0d0,Temp4,nOrb(iS))
              ija=jB-nIsh(jS)
              ila=lB-nIsh(lS)
*                 ~
*             (pj|kl)
*
              ip2=ipMO(js,ips,ls)+nOrb(iS)*(ija-1)+
     &               nOrb(is)*nAsh(js)*nAsh(ips)*(ilA-1)
              ip1=1
              Do ipa=1,nAsh(ips)
               Call DaXpY_(nOrb(iS),Fact,Temp4(ip1),1,rMO2(ip2),1)
               ip2=ip2+nOrb(is)*nAsh(js)
               ip1=ip1+nOrb(is)
                          End Do
*                  ~
*             (pj|lk)
*
              If (nOrb(is)*nAsh(ipS).ne.0)
     &         Call DGEMM_('N','N',
     &                     nOrb(iS),nAsh(ipS),nOrb(kS),
     &                     1.0d0,Temp3,nOrb(iS),
     &                     rKappa(ipMat(ks,ips)+nOrb(ks)*nIsh(ipS)),
     &                     nOrb(ks),
     &                     0.0d0,Temp4,nOrb(iS))
              ip3=ipMO(js,ls,ips)+nOrb(iS)*(ija-1)+
     &               nOrb(is)*nAsh(js)*(ilA-1)
              ip1=1
              Do ipa=1,nAsh(ips)
               Call DaXpY_(nOrb(iS),Fact*signa,
     &                    Temp4(ip1),1,rMO2(ip3),1)
               ip3=ip3+nOrb(is)*nAsh(js)*nAsh(lS)
               ip1=ip1+nOrb(is)
              End Do
             End If
*
            End Do
           End Do
          End If
          End If
         End Do
        End Do
        End If
       End Do
      End Do
*
*

      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(CMO)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function NumSolv(Solvent)
      Implicit Real*8 (a-h,o-z)
      Character*30 Solvent, Solvent_
      IdSolv = 0
      Solvent_=Solvent
      Call Upcase(Solvent_)
      If(Solvent_.eq.'WATER')               IdSolv = 1
      If(Solvent_.eq.'ACETONITRILE')        IdSolv = 2
      If(Solvent_.eq.'METHANOL')            IdSolv = 3
      If(Solvent_.eq.'ETHANOL')             IdSolv = 4
      If(Solvent_.eq.'ISOQUINOLINE')        IdSolv = 5
      If(Solvent_.eq.'QUINOLINE')           IdSolv = 6
      If(Solvent_.eq.'CHLOROFORM')          IdSolv = 7
      If(Solvent_.eq.'ETHYLETHER')          IdSolv = 8
      If(Solvent_.eq.'METHYLENECHLORIDE')   IdSolv = 9
      If(Solvent_.eq.'DICHLOROETHANE')      IdSolv =10
      If(Solvent_.eq.'CARBONTETRACHLORIDE') IdSolv =11
      If(Solvent_.eq.'BENZENE')             IdSolv =12
      If(Solvent_.eq.'TOLUENE')             IdSolv =13
      If(Solvent_.eq.'CHLOROBENZENE')       IdSolv =14
      If(Solvent_.eq.'NITROMETHANE')        IdSolv =15
      If(Solvent_.eq.'HEPTANE')             IdSolv =16
      If(Solvent_.eq.'CYCLOHEXANE')         IdSolv =17
      If(Solvent_.eq.'ANILINE')             IdSolv =18
      If(Solvent_.eq.'ACETONE')             IdSolv =19
      If(Solvent_.eq.'TETRAHYDROFURAN')     IdSolv =20
      If(Solvent_.eq.'DIMETHYLSULFOXIDE')   IdSolv =21
      If(Solvent_.eq.'ARGON')               IdSolv =22
      If(Solvent_.eq.'KRYPTON')             IdSolv =23
      If(Solvent_.eq.'XENON')               IdSolv =24

      If(IdSolv.eq.0) then
*       Call ErrTra
        Write (6,*) ' Unrecognized solvent: ',Solvent
        Write (6,10)'WATER', 'ACETONITRILE', 'METHANOL',
     &  'ETHANOL', 'ISOQUINOLINE', 'QUINOLINE', 'CHLOROFORM',
     &  'ETHYLETHER', 'METHYLENECHLORIDE', 'DICHLOROETHANE',
     &  'CARBONTETRACHLORIDE', 'BENZENE', 'TOLUENE',
     &  'CHLOROBENZENE', 'NITROMETHANE' , 'HEPTANE', 'CYCLOHEXANE',
     &  'ANILINE', 'ACETONE', 'TETRAHYDROFURAN', 'DIMETHYLSULFOXIDE',
     &  'ARGON', 'KRYPTON', 'XENON'
  10    format(' Allowed solvents are:',/,24(A30,/))
        Call Abend()
      EndIf
      NumSolv = IdSolv
      Return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine sroMmH( &
#                 define _CALLING_
#                 include "mem_interface.fh"
                 )
!***********************************************************************
!                                                                      *
!  Object: to compute the number of real*8 the kernel routine will     *
!          need for the computation of a matrix element between two    *
!          cartesian Gaussian functions with the total angular momentum*
!          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
!          lr is the order of the operator (this is only used when the *
!          integrals are computed with the Hermite-Gauss quadrature).  *
!                                                                      *
!  Called from: OneEl                                                  *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc, nCnttp, Shells
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: iacore, iAng, iCnttp, icoreb, icores, ip, iShll, ld, nac, ncb, nExpi, nOrder, nordop

nOrder = 0
nordop = lr
ld = 2
Mem = 0
do iCnttp=1,nCnttp
  if (.not. dbsc(iCnttp)%ECP) cycle
  do iAng=0,dbsc(iCnttp)%nSRO-1
    iShll = dbsc(iCnttp)%iSRO+iAng
    nExpi = Shells(iShll)%nExp
    if (nExpi == 0) cycle

    ip = 0
    nac = nTri_Elem1(la)*nTri_Elem1(iAng)
    ncb = nTri_Elem1(iAng)*nTri_Elem1(lb)
    ip = ip+nTri_Elem1(la)*nTri_Elem1(lb)*21 ! Final

    ip = ip+nExpi*nExpi ! tmp

    ip = ip+10*nac*nExpi ! FA1 & FA2
    ip = ip+10*ncb*nExpi ! FB1 & FB2

    nHer = (la+1+iAng+1+ld)/2
    nOrder = max(nHer,nOrder)
    iacore = 6+3*nHer*(la+1+ld)+3*nHer*(iAng+1)+3*nHer*(nOrdOp+1)+3*(la+1+ld)*(iAng+1)*(nOrdOp+1)+1

    nHer = (lb+1+iAng+1+ld)/2
    nOrder = max(nHer,nOrder)
    icoreb = 6+3*nHer*(lb+1+ld)+3*nHer*(iAng+1)+3*nHer*(nOrdOp+1)+3*(lb+1+ld)*(iAng+1)*(nOrdOp+1)+1

    icores = max(icoreb,iacore)*nExpi
    Mem = max(Mem,ip+icores)

  end do
end do
nHer = nOrder

return

end subroutine sroMmH

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine prtfid_cvb(chr,fileid)

use casvb_global, only: filename
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: chr
real(kind=wp), intent(in) :: fileid
integer(kind=iwp) :: ibf
character(len=200) :: line

line = chr
call mkfn_cvb(fileid,ibf)
call appendchr_cvb(line,' file ',0)
call appendchr_cvb(line,filename(ibf),1)
call appendchr_cvb(line,'.',0)
write(u6,'(a)') trim(line)

return

end subroutine prtfid_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRWVF(IORBTAB,ISSTAB,IFSBTAB,PRTHR,CI)
      IMPLICIT NONE
      REAL*8 CI(*),PRTHR
      INTEGER IORBTAB(*),ISSTAB(*),IFSBTAB(*)
C     INTEGER MORSBITS,IBLKDET,NPRINTED
      INTEGER          IBLKDET,NPRINTED
C     INTEGER NASORB,NASPRT,KSPART,KOINFO,KSSTTB,KSBSMRS
      INTEGER        NASPRT,KSPART,       KSSTTB,KSBSMRS
      INTEGER NFSB,KSTARR,LSBSET,NSSTP,ISUM,ISST,NSBS
      INTEGER IFSB,KPOS,ISPART,NBLKDET
      INTEGER ISSTARR(50),NDIMARR(50)
      INTEGER ICREL,ICI,INDX,ISORB,N,I,ISBS,IMORS
      CHARACTER*80 DETTXT
#include "WrkSpc.fh"

C The orbital table:
      NASPRT= IORBTAB(9)
      KSPART= IORBTAB(10)
C The substring table:
      NSSTP   =ISSTAB(7)
      KSSTTB=15
      KSBSMRS=ISSTAB(11)
C The FS blocks of the SGM wave function:
      NFSB=IFSBTAB(3)
      KSTARR=8
C Make an array with nr of earlier substrings for each
C substring type:
      CALL GETMEM('NSBSET','Allo','Inte',LSBSET,NSSTP)
      ISUM=0
      DO ISST=1,NSSTP
        IWORK(LSBSET-1+ISST)=ISUM
        NSBS=ISSTAB(KSSTTB+5*(ISST-1))
        ISUM=ISUM+NSBS
      END DO
C Loop over FS blocks of the SGM wave function
      NPRINTED=0
      DO IFSB=1,NFSB
        KPOS=KSTARR+(NASPRT+2)*(IFSB-1)
        DO ISPART=1,NASPRT
          ISSTARR(ISPART)=IFSBTAB(KPOS-1+ISPART)
        END DO
        NBLKDET =IFSBTAB(KPOS+NASPRT  )
        IBLKDET =IFSBTAB(KPOS+NASPRT+1)
C Dimension of each substring type:
        DO ISPART=1,NASPRT
          ISST=ISSTARR(ISPART)
          NSBS=ISSTAB(KSSTTB+5*(ISST-1))
          NDIMARR(ISPART)=NSBS
        END DO
        DO ICREL=1,NBLKDET
         ICI=IBLKDET-1+ICREL
         IF(ABS(CI(ICI)).GE.PRTHR) THEN
C Get occupation array in the form of string DETTXT:
           INDX=ICREL-1
           ISORB=0
           DO ISPART=1,NASPRT
            N=NDIMARR(ISPART)
            I=MOD(INDX,N)
            INDX=INDX-N*I
            ISST=ISSTARR(ISPART)
            ISBS=IWORK(LSBSET-1+ISST)+I+1
            IMORS=ISSTAB(KSBSMRS+2*(ISBS-1))
            N=IORBTAB(KSPART-1+ISPART)
            CALL MORSWRITE(IMORS,DETTXT(ISORB+1:ISORB+N))
            ISORB=ISORB+N
           END DO
           WRITE(6,'(1x,a,5x,f16.8)') DETTXT(1:ISORB),CI(ICI)
           NPRINTED=NPRINTED+1
         END IF
        END DO
C End of loop over FS blocks
      END DO
      IF(NPRINTED.EQ.0) WRITE(6,*)' (PRWVF: Nothing worth printing)'
      CALL GETMEM('NSBSET','free','Inte',LSBSET,NSSTP)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine ReaW3 (Ww,Wx,aSGrp,beSGrp,bSGrp,LunAux)
c
c        this routine do:
c        define Ww(a",be",b",i) <- (a",be"|b",i)
c
c        integrals (a",be"|b",i) are stored in files V3xxyyzz for xx>=yy
c
c        Storing of integrals in V3files
c        do i=1,no
c          record of V3(a"be",b",_i): a">=be",b" for given i
c        end do
c
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aSGrp,beSGrp,bSGrp,LunAux
        real*8 Ww(1)
        real*8 Wx(1)
c
c        help variables
c
        integer dima,dimb,dimbe
        character*8 LunName

c0        def dimensions
c
        dima=DimSGrpa(aSGrp)
        dimb=DimSGrpa(bSGrp)
        dimbe=DimSGrpbe(beSGrp)
c
c
        if (aSGrp.gt.beSGrp) then
c1        case aSGrp>beSGrp, integrals (a",be"|b",i) to be read
c1.1          make Name
          call MkNameV3 (aSGrp,beSGrp,bSGrp,'W3',LunName)
c1.2          read (a",be"|b",i) from V3:(a",be"|b",i)
          call ReaW3hlp1 (Ww,Wx,dima,dimbe,dimb,no,LunName,LunAux)
c
        else if (aSGrp.eq.beSGrp) then
c2        case aSGrp=beSGrp, integrals (a">=be"|b",i)to be read and expand
c2.1          make Name
          call MkNameV3 (aSGrp,beSGrp,bSGrp,'W3',LunName)
c2.2          read (a",be"|b",i) from V3:(a">=be"|b",i)
          call ReaW3hlp2 (Ww,Wx,dima,dimb,no,LunName,LunAux)
c
        else
c3        case aSGrp<beSGrp, integrals (be",a"|b",i) to be read and mapped
c3.1          make Name
          call MkNameV3 (beSGrp,aSGrp,bSGrp,'W3',LunName)
c3.2          read (a",be"|b",i) from V3:(be",a"|b",i)
          call ReaW3hlp3 (Ww,Wx,dima,dimbe,dimb,no,LunName,LunAux)

        end if
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_AmpFromInt(Col,nDim,iCol,nCol,EOcc,EVir)
!
! Thomas Bondo Pedersen, Dec. 2007.
!
! Purpose: scale integrals with orbital energies to get
!          (minus) MP2 amplitudes: (ai|bj)/[e(a)-e(i)+e(b)-e(j)].

use Symmetry_Info, only: Mul
use Cholesky, only: nSym
use ChoMP2, only: iOcc, iT1am, iVir, nOcc, NowSym, nVir
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, nCol, iCol(nCol)
real(kind=wp), intent(inout) :: Col(nDim,nCol)
real(kind=wp), intent(in) :: EOcc(*), EVir(*)
integer(kind=iwp) :: a, ai, ai0, b, bj, bj_, i, iSym, iSyma, iSymb, iSymi, iSymj, j
real(kind=wp) :: DE, Ebj

iSym = NowSym
do bj_=1,nCol
  bj = iCol(bj_)
  call ChoMP2_Col_Invai(bj,iSym,b,iSymb,j,iSymj)
  Ebj = EVir(iVir(iSymb)+b)-EOcc(iOcc(iSymj)+j)
  do iSymi=1,nSym
    iSyma = Mul(iSymi,iSym)
    do i=1,nOcc(iSymi)
      ai0 = iT1am(iSyma,iSymi)+nVir(iSyma)*(i-1)
      do a=1,nVir(iSyma)
        ai = ai0+a
        DE = EVir(iVir(iSyma)+a)-EOcc(iOcc(iSymi)+i)+Ebj
        Col(ai,bj_) = Col(ai,bj_)/DE
      end do
    end do
  end do
end do

end subroutine ChoMP2_AmpFromInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRAONE(CMO)
      use output_caspt2, only:iPrGlb,verbose
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "warnings.h"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
      DIMENSION CMO(NCMO)
      DIMENSION nBasXX(8),Keep(8)
      Logical iSquar, Found

c Objective: Transformation of one-electron integrals
c (effective one electron Hamiltonian) for CASPT2.

#ifdef _DEBUGPRINT_
      IFTEST=1
#else
      IFTEST=0
#endif

      Call GetOrd(IRC,iSquar,nSymXX,nBasXX,Keep)
      IF ( IPRGLB.GE.VERBOSE ) THEN
        If(iSquar)      WRITE(6,*) 'TRAONE OrdInt status: squared'
        If(.not.iSquar) WRITE(6,*) 'TRAONE OrdInt status: non-squared'
      ENDIF
      IERR=0
      DO ISYM=1,NSYM
        IF (NBAS(ISYM).NE.NBASXX(ISYM)) IERR=1
      END DO
      IF(IERR.NE.0) THEN
        WRITE(6,*)'     *** ERROR IN SUBROUTINE TRAONE ***'
        WRITE(6,*)'          INCOMPATIBLE BASIS DATA'
        WRITE(6,*)
        WRITE(6,*)' JOBIPH NR OF SYMM:', NSYM
        WRITE(6,*)' JOBIPH NR OF BASIS FUNCTIONS/SYMM:'
        WRITE(6,'(1x,8I5)')(NBAS(I),I=1,NSYM)
        WRITE(6,*)
        WRITE(6,*)' ORDINT NR OF SYMM:', NSYMXX
        WRITE(6,*)' ORDINT NR OF BASIS FUNCTIONS/SYMM:'
        WRITE(6,'(1x,8I5)')(NBASXX(I),I=1,NSYMXX)
        CALL ERRTRA
        CALL ABEND()
      END IF
c Allocate FLT,DLT, and DSQ.
      CALL GETMEM('WFLT','ALLO','REAL',LWFLT,NBTRI)
c Read nuclear repulsion energy:
      IRC=-1
      IOPT=0
      ICOMP=0
      ISYLBL=1
      IF ( IFTEST.NE.0 ) WRITE(6,*)' GET POTNUC FROM RUNFILE'
      Call Get_dScalar('PotNuc',PotNuc)
      IF ( IFTEST.NE.0 ) WRITE(6,*)' POTNUC:',POTNUC
c Read one-electron hamiltonian matrix into FLT.
      IRC=-1
      IOPT=6
      ICOMP=1
      ISYLBL=1
      IF ( IFTEST.NE.0 ) WRITE(6,*)' CALLING RDONE (ONEHAM)'
      CALL RDONE(IRC,IOPT,'OneHam  ',ICOMP,WORK(LWFLT),ISYLBL)
      IF ( IFTEST.NE.0 ) WRITE(6,*)' BACK FROM RDONE'
      IF(IRC.NE.0) THEN
        WRITE(6,*)'TRAONE Error: RDONE failed reading OneHam.'
        Call Quit(_RC_IO_ERROR_READ_)
      END IF

      IF ( IFTEST.NE.0 ) THEN
        WRITE(6,*)'     TEST PRINTS FROM TRAONE.'
        WRITE(6,*)'     NAKED 1-EL HAMILTONIAN IN AO BASIS'
        ISTLT=0
        DO ISYM=1,NSYM
          IF ( NBAS(ISYM).GT.0 ) THEN
            WRITE(6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
            CALL TRIPRT(' ',' ',WORK(LWFLT+ISTLT),NBAS(ISYM))
            ISTLT=ISTLT+NBAS(ISYM)*(NBAS(ISYM)+1)/2
          END IF
        END DO
      END IF

c If this is a perturbative reaction field calculation then
c modifiy the one-electron Hamiltonian by the reaction field and
c the nuclear attraction by the cavity self-energy

      If ( RFpert ) then
         nTemp=0
         Do iSym=1,nSym
            nTemp=nTemp+nBas(iSym)*(nBas(iSym)+1)/2
         End Do
         Call GetMem('RFFLD','Allo','Real',lTemp,nTemp)
*
         Call f_Inquire('RUNOLD',Found)
         If (Found) Call NameRun('RUNOLD')
         Call Get_dScalar('RF Self Energy',ERFSelf)
         Call Get_dArray('Reaction field',Work(lTemp),nTemp)
         If (Found) Call NameRun('RUNFILE')
         PotNuc=PotNuc+ERFself
         Call Daxpy_(nTemp,1.0D0,Work(lTemp),1,WORK(LWFLT),1)
*
         Call GetMem('RFFLD','Free','Real',lTemp,nTemp)
         IF ( IFTEST.NE.0 ) THEN
           WRITE(6,*)' 1-EL HAMILTONIAN INCLUDING REACTION FIELD'
           ISTLT=0
           DO ISYM=1,NSYM
             IF ( NBAS(ISYM).GT.0 ) THEN
               WRITE(6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
               CALL TRIPRT(' ',' ',WORK(LWFLT+ISTLT),NBAS(ISYM))
               ISTLT=ISTLT+NBAS(ISYM)*(NBAS(ISYM)+1)/2
             END IF
           END DO
         END IF
      End If

      EONE=0.0d0
      ETWO=0.0d0
c The following section is needed for frozen orbitals:
      IF(NFROT.EQ.0) GOTO 300
      CALL GETMEM('WDLT','ALLO','REAL',LWDLT,NBTRI)
      CALL GETMEM('WDSQ','ALLO','REAL',LWDSQ,NBSQT)
c Compute the density matrix of the frozen orbitals
c The DLT matrix contains the same data as DSQ, but
c with symmetry blocks in lower triangular format, and
c with non-diagonal elements doubled.
      CALL DCOPY_(NBTRI,[0.0D0],0,WORK(LWDLT),1)
      CALL DCOPY_(NBSQT,[0.0D0],0,WORK(LWDSQ),1)
      ISTMO=1
      ISTSQ=LWDSQ
      ISTLT=LWDLT
      DO 100 ISYM=1,NSYM
        NF=NFRO(ISYM)
        NB=NBAS(ISYM)
        IF(NB.EQ.0) GOTO 100
        IF(NF.EQ.0) GOTO 110
        CALL DGEMM_('N','T',NB,NB,NF,2.0D0,CMO(ISTMO),NB,
     &             CMO(ISTMO),NB,0.0D0,WORK(ISTSQ),NB)
        IJ=ISTLT-1
        DO 130 IB=1,NB
          DO 140 JB=1,IB
            IJ=IJ+1
            WORK(IJ)=2.0D0*WORK(ISTSQ+JB-1+(IB-1)*NB)
140       CONTINUE
          WORK(IJ)=0.5D0*WORK(IJ)
130     CONTINUE
110     CONTINUE
        ISTMO=ISTMO+NB*NB
        ISTSQ=ISTSQ+NB*NB
        ISTLT=ISTLT+NB*(NB+1)/2
100   CONTINUE

c One-electron contribution to the core energy.
c Note that FLT still contains only the naked
c  one-electron hamiltonian.
      EONE=DDOT_(NBTRI,WORK(LWDLT),1,WORK(LWFLT),1)
*                                                                      *
************************************************************************
*                                                                      *
*     Generate Fock-matrix for frozen orbitals
*     and compute the total core energy
*     Look out-- we temporarily allocate all available memory.
*
      ExFac=1.0D0
         Call FTwo_Drv(nSym,nBas,nFro,KEEP,
     &                 WORK(LWDLT),WORK(LWDSQ),WORK(LWFLT),NBTRI,
     &                 ExFac,nBMX,CMO)

*                                                                      *
************************************************************************
*                                                                      *
c Compute the two-electron contribution to the core energy
      ETWO=0.5D0*(DDOT_(NBTRI,WORK(LWDLT),1,WORK(LWFLT),1)-EONE)
      CALL GETMEM('WDSQ','FREE','REAL',LWDSQ,NBSQT)
      CALL GETMEM('WDLT','FREE','REAL',LWDLT,NBTRI)
c Previous section was bypassed if NFROT.EQ.0.
 300  CONTINUE
      ECORE=POTNUC+EONE+ETWO
      IF ( IFTEST.NE.0 ) THEN
         WRITE(6,'(6X,A,E20.10)') 'NUCLEAR REPULSION ENERGY:',POTNUC
         WRITE(6,'(6X,A,E20.10)') 'ONE-ELECTRON CORE ENERGY:',EONE
         WRITE(6,'(6X,A,E20.10)') 'TWO-ELECTRON CORE ENERGY:',ETWO
         WRITE(6,'(6X,A,E20.10)') '       TOTAL CORE ENERGY:',ECORE
      ENDIF

c Allocate FMO, TMP:
      NWTMP=2*NBMX**2
      CALL GETMEM('WFMO','ALLO','REAL',LWFMO,notri)
      CALL GETMEM('WTMP','ALLO','REAL',LWTMP,NWTMP)

c Transform one-electron effective Hamiltonian:
      CALL DCOPY_(notri,[0.0D0],0,WORK(LWFMO),1)
      CALL DCOPY_(NWTMP,[0.0D0],0,WORK(LWTMP),1)
      ICMO=1
      IAO =LWFLT
      IMO =LWFMO
      DO 200 ISYM=1,NSYM
         ICMO=ICMO+NBAS(ISYM)*NFRO(ISYM)
         IOFF=LWTMP+NBAS(ISYM)*NBAS(ISYM)
         IF(NORB(ISYM).GT.0) THEN
           CALL SQUARE(WORK(IAO),WORK(LWTMP),1,NBAS(ISYM),NBAS(ISYM))

           CALL DGEMM_('T','N',NORB(ISYM),NBAS(ISYM),NBAS(ISYM),
     &                  1.0d0,CMO(ICMO),NBAS(ISYM),WORK(LWTMP),
     &                  NBAS(ISYM),0.0d0,WORK(IOFF),NORB(ISYM))

           Call DGEMM_Tri('N','N',NORB(ISYM),NORB(ISYM),NBAS(ISYM),
     &                    1.0D0,WORK(IOFF),NORB(ISYM),
     &                          CMO(ICMO),NBAS(ISYM),
     &                    0.0D0,WORK(IMO),NORB(ISYM))
         END IF
         ICMO=ICMO+NBAS(ISYM)*(NORB(ISYM)+NDEL(ISYM))
         IAO =IAO +NBAS(ISYM)*(NBAS(ISYM)+1)/2
         IMO =IMO +NORB(ISYM)*(NORB(ISYM)+1)/2
200   CONTINUE

      IF ( IFTEST.NE.0 ) THEN
        WRITE(6,*)'      EFFECTIVE 1-EL HAMILTONIAN IN MO BASIS'
        ISTLT=0
        DO ISYM=1,NSYM
          IF ( NORB(ISYM).GT.0 ) THEN
            WRITE(6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
            CALL TRIPRT(' ',' ',WORK(LWFMO+ISTLT),NORB(ISYM))
            ISTLT=ISTLT+NORB(ISYM)*(NORB(ISYM)+1)/2
          END IF
        END DO
      END IF
      IDISK=IEOF1M
      IAD1M(3)=IDISK
      CALL DDAFILE(LUONEM,1,WORK(LWFMO),notri,IDISK)
      IEOF1M=IDISK
      CALL DCOPY_(NOTRI,WORK(LWFMO),1,WORK(LHONE),1)
      CALL GETMEM('WTMP','FREE','REAL',LWTMP,NWTMP)
      CALL GETMEM('WFMO','FREE','REAL',LWFMO,notri)
      CALL GETMEM('WFLT','FREE','REAL',LWFLT,NBTRI)


      RETURN
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Box_On_Sphere(x_Min_,x_Max_, y_Min_,
     &                         y_Max_, z_Min_,z_Max_,
     &                         xMin_, xMax_,  yMin_,
     &                         yMax_,  zMin_ ,zMax_ )
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 xyz(3,2), xyz0(3,2), Roots(3,3)
*
      delta=1.0D-15
*
      xyz(1,1)=x_min_
      xyz(1,2)=x_max_
      xyz(2,1)=y_min_
      xyz(2,2)=y_max_
      xyz(3,1)=z_min_
      xyz(3,2)=z_max_
c     Write (*,*)
c     Write (*,*) 'Box limitations'
c     Write (*,*) 'x:',xyz(1,1), xyz(1,2)
c     Write (*,*) 'y:',xyz(2,1), xyz(2,2)
c     Write (*,*) 'z:',xyz(3,1), xyz(3,2)
*
*     Set extremal values
*
      xyz0(1,1)= One
      xyz0(1,2)=-One
      xyz0(2,1)= One
      xyz0(2,2)=-One
      xyz0(3,1)= One
      xyz0(3,2)=-One
*
      Do ix = 1, 3
         iy=ix+1
         If (iy.gt.3) iy=1
         iz=iy+1
         If (iz.gt.3) iz=1
*
         xMax=xyz(ix,2)
         xMin=xyz(ix,1)
c        Write (*,*)
         Roots(1,iy)=xyz(iy,1)
         Roots(2,iy)=xyz(iy,2)
         If (xyz(iy,1)*xyz(iy,2).lt.Zero) Then
            ny_Roots=3
            Roots(3,iy)=Zero
         Else
            ny_Roots=2
         End If
         Roots(1,iz)=xyz(iz,1)
         Roots(2,iz)=xyz(iz,2)
         If (xyz(iz,1)*xyz(iz,2).lt.Zero) Then
            nz_Roots=3
            Roots(3,iz)=Zero
         Else
            nz_Roots=2
         End If
c        Call RecPrt('Roots','(3G25.12)',Roots,3,3)
*
         Do i = 1, ny_Roots
c           Write (*,*) 'i=',i,ny_Roots
c           Write (*,*)
            y = Roots(i,iy)
            Do j = 1, nz_Roots
c              Write (*,*) 'j=',j,nz_Roots
               z = Roots(j,iz)
*
               x=xMin
               r=sqrt(x**2+y**2+z**2)
c              Write (*,*) x/r
               If (r.eq.Zero) Then
                  x_r=Zero
               Else
                  x_r=x/r
               End If
               xyz0(ix,1)=Min(xyz0(ix,1),x_r)
               xyz0(ix,2)=Max(xyz0(ix,2),x_r)
*
               x=xMax
               r=sqrt(x**2+y**2+z**2)
c              Write (*,*) x/r
               If (r.eq.Zero) Then
                  x_r=Zero
               Else
                  x_r=x/r
               End If
               xyz0(ix,1)=Min(xyz0(ix,1),x_r)
               xyz0(ix,2)=Max(xyz0(ix,2),x_r)
*
            End Do
         End Do
      End Do
*
c     Write (*,*) 'xMin=',xyz0(1,1)
c     Write (*,*) 'xMax=',xyz0(1,2)
c     Write (*,*) 'yMin=',xyz0(2,1)
c     Write (*,*) 'yMax=',xyz0(2,2)
c     Write (*,*) 'zMin=',xyz0(3,1)
c     Write (*,*) 'zMax=',xyz0(3,2)
      xMin_=xyz0(1,1)-Delta
      xMax_=xyz0(1,2)+Delta
      yMin_=xyz0(2,1)-Delta
      yMax_=xyz0(2,2)+Delta
      zMin_=xyz0(3,1)-Delta
      zMax_=xyz0(3,2)+Delta
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!               1994, Markus P. Fuelscher                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RFmltp()
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!                                                                      *
!     modified by M. P. Fuelscher, 94/04/28                            *
!***********************************************************************

use Index_Functions, only: nTri3_Elem1, nTri_Elem1
use rctfld_module, only: Eps, EpsInf, lMax, lRF, lRFCav, MM, NonEq_ref, PCM, rds
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, iElem, iM, iOff, jM, l, nComp, nElem, nM
real(kind=wp) :: dESolv, ESolv
real(kind=wp), allocatable :: QTot(:), VTot(:)
real(kind=wp), external :: DDot_

if (.not. lRF) return
nComp = nTri3_Elem1(lMax)
call mma_allocate(VTot,nComp,Label='VTot')
call mma_allocate(QTot,nComp,Label='QTot')

if (lRF .and. (.not. PCM) .and. lRFCav) then
  QTot(:) = MM(:,1)+MM(:,2)
# ifdef _DEBUGPRINT_
  call RecPrt('Total Multipole Moments',' ',QTot,1,nComp)
# endif
  VTot(:) = QTot(:)
  ! Compute the electric field due to the total charge distribution.
  call AppFld(VTot,rds,Eps,lMax,EpsInf,NonEq_ref)
# ifdef _DEBUGPRINT_
  call RecPrt('Total Electric Field',' ',VTot,1,nComp)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  write(u6,*) '     Multipole analysis of the contributions to the dielectric solvation energy'
  write(u6,*)
  write(u6,*) '     --------------------------------------'
  write(u6,*) '        l             dE '
  write(u6,*) '     --------------------------------------'
  Esolv = Zero
  iOff = 1
  do l=0,lMax
    nElem = nTri_Elem1(l)
    dEsolv = -Half*DDot_(nElem,QTot(iOff),1,VTot(iOff),1)
    write(u6,'(8X,I2,10X,F13.10)') l,dEsolv
    iOff = iOff+nElem
    Esolv = Esolv+dEsolv
  end do
  write(u6,*) '     --------------------------------------'
  write(u6,*)
  write(u6,*)
  write(u6,*) '     Total Multipole Moments (cartesian)'
  write(u6,*) '     -----------------------------------'
  iM = 1
  do l=0,lMax
    nElem = nTri_Elem1(l)
    jM = iM
    do iElem=1,nElem,7
      nM = min(7,nElem-iElem+1)
      write(u6,'(8X,7ES14.5)') (QTot(i),i=jM,jM+nM-1)
      jM = jM+nM
    end do
    iM = iM+nElem
  end do
  write(u6,*) '     -----------------------------------'
  write(u6,*)
  write(u6,*)
  write(u6,*) '     Total Electric Field (cartesian)'
  write(u6,*) '     --------------------------------'
  iM = 1
  do l=0,lMax
    nElem = nTri_Elem1(l)
    jM = iM
    do iElem=1,nElem,7
      nM = min(7,nElem-iElem+1)
      write(u6,'(8X,7ES14.5)') (VTot(i),i=jM,jM+nM-1)
      jM = jM+nM
    end do
    iM = iM+nElem
  end do
  write(u6,*) '     -----------------------------------'
  write(u6,*)
end if

call mma_deallocate(VTot)
call mma_deallocate(QTot)

end subroutine RFmltp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_XCV_GetInt(irc,ListCD,l_ListCD,ListSP,l_ListSP,
     &                          NVT,l_nVT,xInt,l_Int)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: calculate integrals (CD|J) where CD belongs to the shell
C              pairs in ListCD and J runs over all Cholesky vectors.
C
C     NOTE: this will only work if nQual and iQuAB are properly set to
C     correspond to parent diagonals. Also, mySP should be be set to a
C     trivial array [i.e. mySP(i)=i].
C
      use ChoArr, only: nDim_Batch
      Implicit None
      Integer irc
      Integer l_ListCD, l_ListSP, l_NVT, l_Int
      Integer ListCD(l_ListCD)
      Integer ListSP(l_ListSP)
      Integer NVT(l_NVT)
      Real*8  xInt(l_Int)
#include "cholesky.fh"

      Integer iSym, n
      Integer iSP, iCD

      ! Set return code
      irc=0

      ! Offsets to symmetry blocks of the integrals
      n=0
      Do iSym=1,nSym
         iOff_Col(iSym)=n
         n=n+nDim_Batch(iSym)*NVT(iSym)
      End Do

      ! Check allocation of xInt
      If (n .gt. l_Int) Then
         irc=1
         Return
      End If

      ! Calculate integrals
      Call FZero(xInt,n)
      Do iSP=1,l_ListSP
         Do iCD=1,l_ListCD
            Call Cho_MCA_CalcInt_4(xInt,n,ListCD(iCD),ListSP(iSP))
         End Do
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine large_svd(m,n,amat,umat,vmat,svals)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: m, n
real(kind=wp), intent(inout) :: amat(m,*)
real(kind=wp), intent(_OUT_) :: umat(m,*), vmat(n,*), svals(*)
integer(kind=iwp) :: info, lwork, nm
real(kind=wp) :: wrk1_lapack(1)
real(kind=wp), allocatable :: lapckwrk(:)

! Note that dgesvd returns V**T, not V.
nm = min(n,m)
!write(u6,*) ' In large_svd. Calling dgesvd:'
call dgesvd_('S','S',m,n,amat,m,svals,umat,m,vmat,nm,wrk1_lapack,-1,info)
!write(u6,*) ' large_svd back from dgesvd'
lwork = int(wrk1_lapack(1))
!write(u6,*) ' lwork:',lwork
call mma_allocate(lapckwrk,lwork,label='lapckwrk')
!write(u6,*) ' Calling dgesvd again:'
call dgesvd_('S','S',m,n,amat,m,svals,umat,m,vmat,nm,lapckwrk,lwork,info)
!write(u6,*) ' large_svd back from dgesvd'
call mma_deallocate(lapckwrk)

return

end subroutine large_svd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MakeWwHlp4 (Ww,W1,W2,
     c                       dima,dimb,dimbe,dimga,key)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c                                     and W2(b",be",a",ga")
c       for the case a".ne.b" , be".ne.ga"
c       N.B. algoritmus nieje prilis vymakany, prva cast sa da
c            urobit pomodou dcopy
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       W2     - array for W1(b",be",a",ga") (I)
c       dimx   - dimension of a",b",be",ga" (I)
c       key    - 1 - calc Ww+, 2 - calc Ww- (I)
c
        implicit none
        integer dima,dimb,dimbe,dimga,key
        real*8 Ww(1:dima,1:dimb,1:dimbe,1:dimga)
        real*8 W1(1:dima,1:dimbe,1:dimb,1:dimga)
        real*8 W2(1:dimb,1:dimbe,1:dima,1:dimga)
c
c       help variables
        integer a,b,be,ga
c
c
        if (key.eq.1) then
          do ga=1,dimga
          do be=1,dimbe
          do b=1,dimb
          do a=1,dima
            Ww(a,b,be,ga)=W1(a,be,b,ga)+W2(b,be,a,ga)
          end do
          end do
          end do
          end do
        else
          do ga=1,dimga
          do be=1,dimbe
          do b=1,dimb
          do a=1,dima
            Ww(a,b,be,ga)=W1(a,be,b,ga)-W2(b,be,a,ga)
          end do
          end do
          end do
          end do
        end if
c
c        Cely clen ma Faktor 2, tu teda nevydelim 2
c        call mv0sv (dima*dimb*dimbe*dimga,dima*dimb*dimbe*dimga,
c    c              Ww(1,1,1,1),0.5d0)
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fiin(lmax)

use Constants, only: Zero, One, Two, Pi
use welcom, only: binom, fiInt
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lmax
integer(kind=iwp) :: i, iexp, j, k, l
real(kind=wp) :: a, al, tal

fiint(0,0) = Two*Pi
do i=0,lmax
  do j=0,lmax-i
    fiint(i,j) = Zero
    do k=0,j
      a = binom(j,k)
      iexp = i+k
      tal = Two*Pi*a*(-One)**k
      if (iexp /= 0) then
        do l=1,iexp
          al = real(2*l,kind=wp)
          tal = tal*(al-One)/al
        end do
      end if
      fiint(i,j) = fiint(i,j)+tal
    end do
  end do
end do

return

end subroutine fiin

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mk_tVtF(TInt,nTheta_All,tVtF,nTheta,List2,mData,iPrm,nPrm,iAng,jAng,nk,Indkl,nkl,nTheta_Full)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nTheta_All, nTheta, mData, List2(mData,nTheta_All), nPrm, iPrm(nPrm), iAng, jAng, nk, nkl, &
                                 Indkl(nkl), nTheta_Full
real(kind=wp), intent(in) :: TInt(nTheta_All,nTheta_All)
real(kind=wp), intent(out) :: tVtF(nTheta,nTheta_Full)
integer(kind=iwp) :: iA, ik, il, iTheta, iTheta_All, iTheta_Full, jA, jk, jl, jTheta_All, jTheta_Full, kComp, lComp, mComp, nComp

#ifdef _DEBUGPRINT_
call RecPrt('TInt',' ',TInt,nTheta_all,nTheta_all)
call iVcPrt('Indkl',' ',Indkl,nkl)
#endif
tVtF(:,:) = Zero
iA = iAng+1
jA = jAng+1
do iTheta_All=1,nTheta_All
  kComp = List2(3,iTheta_All)
  lComp = List2(4,iTheta_All)
  ik = List2(5,iTheta_All)
  il = List2(6,iTheta_All)
  if (iAng == jAng) then
    iTheta_Full = nTri_Elem(ik-1)+il
  else
    iTheta_Full = (il-1)*nk+ik
  end if
  !if ((iPrm(iTheta_Full) == 1) .and. (iAL(kComp,lComp) == 1) .and. (kComp == iA) .and. (lComp == jA)) then
  if ((iPrm(iTheta_Full) == 1) .and. (kComp == iA) .and. (lComp == jA)) then
    iTheta = Indkl(iTheta_Full)

    do jTheta_All=1,nTheta_All
      mComp = List2(3,jTheta_All)
      nComp = List2(4,jTheta_All)
      !if (iAL(mComp,nComp) == 1) then
      if ((mComp == iA) .and. (nComp == jA)) then
        jk = List2(5,jTheta_All)
        jl = List2(6,jTheta_All)
        if (iAng == jAng) then
          jTheta_Full = nTri_Elem(jk-1)+jl
        else
          jTheta_Full = (jl-1)*nk+jk
        end if

        tVtF(iTheta,jTheta_Full) = tVtF(iTheta,jTheta_Full)+TInt(iTheta_All,jTheta_All)
        !tVtF(iTheta,jTheta_Full) = tVtF(iTheta,jTheta_Full)+abs(TInt(iTheta_All,jTheta_All))

      end if
    end do

  end if
end do
#ifdef _DEBUGPRINT_
call RecPrt('tVtF',' ',tVtF,nTheta,nTheta_Full)
#endif

return

end subroutine Mk_tVtF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Francesco Aquilante                              *
!***********************************************************************

subroutine Cho_SOSmp2_DecChk(irc,iSym,Col,nDim,nCol,Wrk,lWrk,ErrStat)
! Francesco Aquilante, May 2007.
!
! Purpose: check Scaled Opposite-Spin MP2 decomposition of
!          M(ai,bj)=(ai|bj)^2 for sym. block iSym.
!          The columns of the M matrix (actually, the sqrt of
!          their elements) are compared nCol columns at a time
!          with the corresponding integrals obtained from the
!          Cholesky (or RI) vectors.
!          The memory requirement of this routine
!          should be limited to approximately that of the
!          decomposition itself. Note, however, that since all
!          elements are computed, this routine will consume
!          significantly more CPU time.
!          Files are assumed open.
!          On exit,
!          ErrStat(1) = min error
!          ErrStat(2) = max error
!          ErrStat(3) = rms error

use ChoMP2, only: OldVec
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iSym, nDim, nCol, lWrk
real(kind=wp), intent(inout) :: Col(nDim,nCol)
real(kind=wp), intent(out) :: Wrk(lWrk), ErrStat(3)
integer(kind=iwp) :: iBatCol, ibj1, kai, kbj, lU, Nai, nBatCol, Nbj, NumCol, NumVec
real(kind=wp) :: Fac, xdim
character(len=*), parameter :: SecNam = 'Cho_SOSmp2_DecChk'
real(kind=r8), external :: ddot_
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"

irc = 0

! Check dimensions.
! -----------------

if ((nDim < 1) .or. (nCol < 1)) return
if (nDim /= nT1am(iSym)) then
  irc = -1
  return
end if

! Initialize.
! -----------

ErrStat(1) = huge(ErrStat)
ErrStat(2) = -huge(ErrStat)
ErrStat(3) = Zero

! Set up batching over columns of the (ai|bj) matrix.
! ---------------------------------------------------

NumCol = min(nCol,nT1am(iSym))
nBatCol = (nT1am(iSym)-1)/NumCol+1

! Start column batch loop.
! ------------------------

Nai = nDim
do iBatCol=1,nBatCol

  ! Set batch info.
  ! ---------------

  if (iBatCol == nBatCol) then
    Nbj = nT1am(iSym)-NumCol*(nBatCol-1)
  else
    Nbj = NumCol
  end if
  ibj1 = NumCol*(iBatCol-1)+1

  ! Compute  M(ai,bj)=(ai|bj)^2  from "new" vectors.
  ! -----------------------------------------------

  lU = lUnit_F(iSym,2)
  NumVec = nMP2Vec(iSym)
  Fac = Zero
  call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,Wrk,lWrk,Fac)
  if (irc /= 0) then
    write(u6,*) SecNam,': Cho_SOSmp2_DecChk_Int  rc= ',irc,' [1]'
    irc = 1
    return
  end if

  ! Obtain the (ai|bj) integrals from M(ai,bj).
  ! -------------------------------------------

  do kbj=1,Nbj
    do kai=1,Nai
      Col(kai,kbj) = sqrt(Col(kai,kbj))
    end do
  end do

  ! Compute "old" and subtract "new".
  ! ---------------------------------

  if (InCore(iSym)) then
    call DGEMM_('N','T',Nai,Nbj,NumCho(iSym),One,OldVec,Nai,OldVec(ibj1),Nai,-One,Col,Nai)
  else
    lU = lUnit_F(iSym,1)
    NumVec = NumCho(iSym)
    Fac = -One
    call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,Wrk,lWrk,Fac)
    if (irc /= 0) then
      write(u6,*) SecNam,': Cho_SOSmp2_DecChk_Int returned ',irc,' [2]'
      irc = 2
      return
    end if
  end if

  ! Compute error stats.
  ! --------------------

  do kbj=1,Nbj
    do kai=1,Nai
      ErrStat(1) = min(ErrStat(1),Col(kai,kbj))
      ErrStat(2) = max(ErrStat(2),Col(kai,kbj))
    end do
  end do
  ErrStat(3) = ErrStat(3)+dDot_(Nai*Nbj,Col,1,Col,1)

end do

! Compute rms error.
! ------------------

xdim = real(Nai*Nai,kind=wp)
ErrStat(3) = sqrt(ErrStat(3)/xdim)

end subroutine Cho_SOSmp2_DecChk

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  quatersolve
*
*> @brief
*>   Computes the quaternion which corresponds to the best rotation that transforms \p U1 in \p U2 and \p V1 in \p V2
*> @author Y. Carissan
*>
*> @details
*> Input vectors will be normalized and \p V2 changed.
*> Computes the quaternion which corresponds to the
*> rotation that transforms \p U1 in \p U2 and \p V1 in \p V2.
*> If such a rotation does not exists, i.e. if
*> \f[ U_1 \cdot V_1 \ne U_2 \cdot V_2 \f]
*> the quaternion contains the rotation
*> which transforms \p U1 into \p U2 and \p V1 into \p V2' such that
*> \f[ U_1 \cdot V_1 = U_2 \cdot V_2' \f]
*> and
*> \f[ U_1 \times V_1 = b (U_2 \times V_2') \f] with \f$ b \f$ real.
*>
*> @param[in,out] U1 vector \f$ U_1 \f$
*> @param[in,out] U2 vector \f$ U_2 \f$
*> @param[in,out] V1 vector \f$ V_1 \f$
*> @param[in,out] V2 vector \f$ V_2 \f$
*> @param[out]    Q  quaternion \f$ Q \f$
************************************************************************
      subroutine quatersolve(U1,U2,V1,V2,Q)
      Implicit none
#include "WrkSpc.fh"
#include "debug.fh"
#include "real.fh"
      Real*8 U1(3),V1(3),U2(3),V2(3)
      Real*8 Q(0:3)
      Real*8 U3(3),V3(3)
      Real*8 Uref(3),Vref(3),K(3)
      Real*8 Vtmp(3)
      Real*8 c, thrs, ddot_
      external ddot_

      thrs=1d-3

      if (debug) then
        Call RecPrt("IN SOLVE U1",' ',U1,3,1)
        Call RecPrt("IN SOLVE V1",' ',V1,3,1)
        Call RecPrt("IN SOLVE U2",' ',U2,3,1)
        Call RecPrt("IN SOLVE V2",' ',V2,3,1)
      end if
      call quatersetup(U1,U2,V1,V2)
      if (debug) Call RecPrt("new V2",' ',V2,3,1)

      call dcopy_(3,U1,1,Uref,1)
      call dcopy_(3,V1,1,Vref,1)

      call GetKandC(U1,U2,V1,V2,K,C)

      if ( C.lt.thrs ) then
        Call cross(U1,U2,U3)
        Call cross(V1,V2,V3)
        Call getKandC(U1,V1,U3,V3,K,C)
        if ( C.lt.thrs ) then
          Call getKandC(U2,V2,U3,V3,K,C)
          if ( C.lt.thrs ) then
            call dcopy_(4,[Zero],0,Q,1)
            Q(0)=One
            Go To 999
          end if
          call dcopy_(3,U2,1,Uref,1)
          call dcopy_(3,V2,1,Vref,1)
        end if
      end if

      Q(1) = Half * K(1)/sqrt(C)
      Q(2) = Half * K(2)/sqrt(C)
      Q(3) = Half * K(3)/sqrt(C)

      Call Cross(Uref,Q(1),Vtmp) ! Vtmp=Uref x Q

      Q(0) = Half * ddot_(3,Vref,1,Vtmp,1) / ddot_(3,Vtmp,1,Vtmp,1)
c                     ! Q(0)=0.5 * Vref.(UrefxQ)/(UrefxQ)^2

999   continue ! normal endding
      Call CheckQuater(Q)
      Call setMatrix(Q)
      if(debug) Call RecPrt("Quaternion",' ',Q,4,1)

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine get_diag(diag,ndet)
! Copies CI diagonal from Lucia enviroment to RASSCF envirmonet

use lucia_data, only: IDISK, LUDIA
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: diag(*)
integer(kind=iwp), intent(out) :: nDet
integer(kind=iwp) :: I_AM_PACKED, iDet, idummy(1), IMZERO

ndet = 0
IDISK(LUDIA) = 0
do
  call IDAFILE(LUDIA,2,IDUMMY,1,IDISK(LUDIA))
  IDET = IDUMMY(1)
  call IDAFILE(LUDIA,2,IDUMMY,1,IDISK(LUDIA))
  if (idet == -1) exit
  call frmdsc(diag(ndet+1),idet,-1,ludia,imzero,i_am_packed)
  ndet = ndet+idet
end do

end subroutine get_diag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Prop(Short,qplab,cen1,cen2,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,lpole,ifallorb)
!***********************************************************************
!                                                                      *
!     purpose: preprocessing of tables for different tensor            *
!              properties                                              *
!                                                                      *
!     Short           logical option for either Short (Short           *
!                     =.true., the total electronic contribution)      *
!                     long (Short=.false., orbital contributions)      *
!                     output                                           *
!     oplab           operator label as defined in SEWARD              *
!     cen1(1:3)       coordinates of centre no.1 (operator)            *
!     cen2(1:3)       coordinates of centre no.2 (gauge)               *
!     nIrrep          the number of irreducible representations        *
!     nBas            the number of functions in each representa-      *
!     (0:nIrrep-1)    tion                                             *
!     nTot            the total number of elements supplied for        *
!                     each component of the property tensor; equal     *
!                     either to 1 (total electronic and total nuc-     *
!                     lear contributions) or to the dimension of       *
!                     the basis set.                                   *
!     Occ(1:nTot)     occupation numbers for all eigenvectors,         *
!                     a dummy for Short outputs                        *
!     ThrSV           threshold for occupation numbers; If             *
!                     Occ(i).le.ThrSV the contribution will not        *
!                     be printed                                       *
!     PrEl(1:nTot,    matrix elements for all components 1,2,...,      *
!          1:maxlab)  maxlab, nTot entries for each component          *
!                     maxlab=(lpole+1)*(lpole+2)/2                     *
!     PrNu(1:maxlab)  nuclear contributions for each component         *
!     ifallorb        logical option for whether the property of       *
!                     all orbitals are printed (and not weighted by    *
!                     occupation number)in property calculation when   *
!                     short=.false. (S.S.Dong, 2018)                   *
!                                                                      *
!     lpole is the value for l in l-pole moments                       *
!     allocate integer storage area of the size appropriate            *
!     for the actual lpole value: size as below                        *
!                                                                      *
! 2000 Dept. of Chem. Phys., Univ. of Lund, Sweden                     *
! Modified by S.S.Dong, 2018, Univ. of Minnesota                       *
! - Enable properties to be printed for all orbitals                   *
! (including virtuals) and not weighted by occupation numbers          *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Angstrom, Debye
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: Short, ifallorb
character(len=8), intent(in) :: qplab
integer(kind=iwp), intent(in) :: nIrrep, nBas(0:nIrrep-1), nTot, lpole
real(kind=wp), intent(in) :: cen1(3), cen2(3), Occ(nTot), ThrSV, PrEl(nTot,(lpole+1)*(lpole+2)/2), PrNu((lpole+1)*(lpole+2)/2)
integer(kind=iwp) :: i, icen, icen1, ilab, inp, ip_, iPL, iSt, iTol, iTol_E0, iTol_E1, ix, ixx, iy, iyy, iz, izz, j, jMax, maxlab
real(kind=wp) :: Fact, Molecular_Charge = Zero, sig, tmp, X_Coor, Y_Coor, Z_Coor
logical(kind=iwp) :: StoreInfo
integer(kind=iwp), parameter :: lmax = 16
character(len=lmax) :: lab
character(len=80) :: Line
character(len=8) :: oplab
character(len=5) :: lab5
character(len=4) :: lab4
character(len=3) :: lab3
real(kind=wp), allocatable :: PrElAug(:,:), PrNuAug(:), PrTot(:), tmat(:,:), temp(:)
character(len=lmax), allocatable :: labs(:), labsAug(:)
integer(kind=iwp), external :: Cho_X_GetTol, iPrintLevel
logical(kind=iwp), external :: Reduce_Prt
#include "hfc_logical.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Some properties can be calculated at many, many centers,
! and writing all values through Add_Info affects performance,
! those will be deactivated and the summation is printed by the
! calling function.
! This only affects the call to Add_Info, otherwise the properties
! are calculated and printed normally
!
StoreInfo = .true.
!                                                                      *
!***********************************************************************
!                                                                      *

maxlab = (lpole+1)*(lpole+2)/2
call mma_allocate(labs,maxlab,label='labs')
call mma_allocate(tmat,maxlab,maxlab,label='tmat')
call mma_allocate(temp,maxlab,label='temp')
call mma_allocate(PrElAug,nTot,maxlab+1,label='PrElAug')
call mma_allocate(PrNuAug,maxlab+1,label='PrNuAug')
call mma_allocate(labsAug,maxlab+1,label='labsAug')

! decipher the operator label:oplab
oplab = qplab
call UpCase(oplab)
lab4 = oplab(1:4)
if (lab4 == 'MLTP') then
  if (lpole < 0) then
    call End1()
    return
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Multipole moment section ... generate labels for printing

  if (lPole > lMax) then
    write(u6,*) 'Prop: lPole.gt.lMax'
    write(u6,*) 'lPole=',lPole
    write(u6,*) 'Increase lMax and recompile!'
    call Abend()
  end if
  ilab = 0
  do ix=lpole,0,-1
    do iy=lpole-ix,0,-1
      iz = lpole-ix-iy
      ilab = ilab+1
      lab = '                '
      do izz=lmax,lmax-iz+1,-1
        lab(izz:izz) = 'Z'
      end do
      do iyy=lmax-iz,lmax-iz-iy+1,-1
        lab(iyy:iyy) = 'Y'
      end do
      do ixx=lmax-iz-iy,lmax-lpole+1,-1
        lab(ixx:ixx) = 'X'
      end do
      labs(ilab) = lab
    end do
  end do

  maxlab = ilab
  call mma_allocate(PrTot,maxlab,label='PrTot')

  ! Print cartesian moments

  !--------------------------------------------------------------------*
  if ((iPL == 2) .and. Short) then
  !--------------------------------------------------------------------*

    PrTot(:) = PrNu(1:MaxLab)-PrEl(1,1:MaxLab)

    ! New style output

    Line = ' '
    if (lPole == 0) then
      Line = 'Charge (e):'
      Fact = One
    else if (lPole == 1) then
      Line = 'Dipole Moment (Debye):'
      Fact = Debye
    else if (lPole == 2) then
      Line = 'Quadrupole Moment (Debye*Ang):'
      Fact = Debye*Angstrom
    else if (lPole == 3) then
      Line = 'Octupole Moment (Debye*Ang**2):'
      Fact = Debye*Angstrom**2
    else if (lPole == 4) then
      Line = 'Hexadecapole Moment (Debye*Ang**3):'
      Fact = Debye*Angstrom**3
    else
      Line = ''
      if (lpole <= 9) then
        write(Line,'(I1)') lPole
        iSt = 2
      else
        write(Line,'(I2)') lPole
        iSt = 3
      end if
      Line(iSt:iSt+26) = 'th-pole Moment (Debye*Ang**'
      iSt = iSt+27
      if (lpole <= 10) then
        write(Line(iSt:iSt),'(I1)') lpole-1
        iSt = iSt+1
      else
        write(Line(iSt:iSt+1),'(I2)') lpole-1
        iSt = iSt+2
      end if
      Line(iSt:iSt+2) = '):'
      Fact = Debye*Angstrom**(lPole-1)
    end if
    write(u6,'(6X,A)') trim(Line)
    if (lpole > 0) then
      write(u6,'(6X,A,3F10.4)') 'Origin of the operator (Ang)=',(cen1(i)*Angstrom,i=1,3)
    end if
    if (lPole == 0) then
      write(u6,'(6X,A,A,F10.4)') labs(1),'=',PrTot(1)*Fact
      Molecular_Charge = PrTot(1)*Fact
    else if (lPole == 1) then
      tmp = sqrt(PrTot(1)**2+PrTot(2)**2+PrTot(3)**2)
      write(u6,'(4X,4(A,A,ES12.4))') labs(1),'=',PrTot(1)*Fact,labs(2),'=',PrTot(2)*Fact,labs(3),'=',PrTot(3)*Fact, &
                                     '           Total','=',tmp*Fact
      if (abs(Molecular_Charge) > 0.9_wp) then
        write(u6,'(6X,A)') 'Center of Charge (Ang)'
        X_Coor = Angstrom*(PrTot(1)/Molecular_Charge)
        Y_Coor = Angstrom*(PrTot(2)/Molecular_Charge)
        Z_Coor = Angstrom*(PrTot(3)/Molecular_Charge)
        write(u6,'(6X,3(A,A,F14.8))') labs(1),'=',X_Coor,labs(2),'=',Y_Coor,labs(3),'=',Z_Coor
        Molecular_Charge = Zero
      end if
      call Put_DArray('Dipole moment',PrTot,3)
      !call peek_iScalar('xml opened',isopen)
      !if (isopen == 1) then
      call xml_dDump('dipole','Dipole moment','Debye',1,PrTot,3,1)
      !end if
    else if (lPole >= 2) then
      tmp = Zero
      do i=1,Maxlab
        tmp = max(tmp,abs(PrTot(i)))
      end do
      ip_ = 1
      do i=1,maxlab,4
        jMax = min(maxlab-i,3)
        write(u6,'(4X,4(A,A,ES12.4))') (labs(i+j),'=',PrTot(ip_+j)*Fact,j=0,jMax)
        ip_ = ip_+4
      end do
    end if
    if ((lpole >= 2) .and. (lpole <= 4)) then

      ! Transform cartesian moments to multipole moments

      inp = 0
      call Tmltpl(inp,lpole,maxlab,labs,1,PrNu,tmat,temp)
      inp = 1
      call Tmltpl(inp,lpole,maxlab,labs,nTot,PrEl,tmat,temp)
      PrTot(:) = PrNu(1:MaxLab)-PrEl(1,1:MaxLab)

      if (lPole >= 3) then
        write(u6,'(6X,A,I1,A)') 'In traceless form (Debye*Ang**',lPole-1,')'
      else
        write(u6,'(6X,A,I1,A)') 'In traceless form (Debye*Ang)'
      end if
      ip_ = 1
      do i=1,maxlab,4
        jMax = min(maxlab-i,3)
        write(u6,'(4X,4(A,A,ES12.4))') (labs(i+j),'=',PrTot(ip_+j)*Fact,j=0,jMax)
        ip_ = ip_+4
      end do

    end if

  !--------------------------------------------------------------------*
  else if ((iPL >= 3) .or. ((.not. Short) .and. (iPL == 2))) then
  !--------------------------------------------------------------------*

    ! Old style output

    if (lpole == 0) lab5 = ' 0-th'
    if (lpole == 1) lab5 = ' 1-st'
    if (lpole == 2) lab5 = ' 2-nd'
    if (lpole == 3) lab5 = ' 3-rd'
    if (lpole > 3) then
      lab3 = '-th'
      write(lab5,'(i2,a3)') lpole,lab3
    end if
    write(u6,'(//6x,a5,a,3(f12.8,a))') lab5,' cartesian moments: origin at (',cen1(1),',',cen1(2),',',cen1(3),')'
    write(u6,'(6x,76(''-''))')
    sig = -One
    call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,labs,PrTot,iPL,0,ifallorb)
    if (lpole == 1) then
      write(u6,'(6x,76(''-''))')
      write(u6,'(6x,a,3f16.8,3x,a)') 'Total             ',(PrTot(j)*Debye,j=1,3),'Debye'
      call Put_DArray('Dipole moment',PrTot,3)
    end if

    if ((lpole >= 2) .and. (lpole <= 4)) then
      write(u6,'(//6x,a,i2,a,3(f12.8,a))') 'Cartesian ',lpole,'-pole moment: origin at (',cen1(1),',',cen1(2),',',cen1(3),')'
      write(u6,'(6x,76(''-''))')

      ! Transform cartesian moments to multipole moments

      inp = 0
      call Tmltpl(inp,lpole,maxlab,labs,1,PrNu,tmat,temp)
      inp = 1
      call Tmltpl(inp,lpole,maxlab,labs,nTot,PrEl,tmat,temp)

      ! Print l-pole cartesian moments

      sig = -One
      call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,labs,PrTot,iPL,0,ifallorb)
    end if

  !--------------------------------------------------------------------*
  else
  !--------------------------------------------------------------------*
    PrTot(:) = PrNu(1:MaxLab)-PrEl(1,1:MaxLab)
    if (lpole == 1) call Put_DArray('Dipole moment',PrTot,3)
    if ((lpole >= 2) .and. (lpole <= 4)) then

      ! Transform cartesian moments to multipole moments

      inp = 0
      call Tmltpl(inp,lpole,maxlab,labs,1,PrNu,tmat,temp)
      inp = 1
      call Tmltpl(inp,lpole,maxlab,labs,nTot,PrEl,tmat,temp)
      PrTot(:) = PrNu(1:MaxLab)-PrEl(1,1:MaxLab)
    end if
  !--------------------------------------------------------------------*
  end if ! iPL
  !--------------------------------------------------------------------*
  ! Prop is also called in other programs where MAG_X2C could
  ! be uninitialized, if a test is required in such case
  ! please initialize MAG_X2C to false in related programs
  if (MAG_X2C) StoreInfo = .false.
else if (lab4(1:2) == 'EF') then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! electric field section

  read(oplab,'(a3,i5)') lab3,icen

  if (lab3 == 'EF0') then
    MaxLab = 1
    ! set labels
    labs(1) = '                '
    ! Print cartesian components of the electric field gradient
    ! tensor at the given centre

    if ((iPL >= 3) .or. ((.not. Short) .and. (iPL == 2))) then
      write(u6,'(//6x,a,i5,1x,a,3(f12.8,a))') ' Electric potential:  centre no.',icen,'(',cen1(1),',',cen1(2),',',cen1(3),')'
      write(u6,'(6x,72(''-''))')
    else
      if (icen == 1) then
        write(u6,'(//6X,A)') 'Electric potential:'
      end if
    end if
    sig = -One
  end if
  if (lab3 == 'EF1') then
    MaxLab = 3
    ! set labels
    labs(1) = '               X'
    labs(2) = '               Y'
    labs(3) = '               Z'
    ! Print cartesian components of the electric field vector
    ! at the given centre

    if ((iPL >= 3) .or. ((.not. Short) .and. (iPL == 2))) then
      write(u6,'(//6x,a,i5,1x,a,3(f12.8,a))') ' Electric field:  centre no.',icen,'(',cen1(1),',',cen1(2),',',cen1(3),')'
      write(u6,'(6x,72(''-''))')
    else
      if (icen == 1) then
        write(u6,'(//6X,A)') 'Electric field:'
        write(u6,'(5X,6A16)') (labs(i),i=1,MaxLab)
      end if
    end if
    sig = +One
  end if
  if (lab3 == 'EF2') then
    ! Seven components because we add r*r to the "normal" 6
    MaxLab = 7
    ! set labels
    labs(1) = '  (2*XX-YY-ZZ)/2'
    labs(2) = '          1.5*XY'
    labs(3) = '          1.5*XZ'
    labs(4) = '  (2*YY-ZZ-XX)/2'
    labs(5) = '          1.5*YZ'
    labs(6) = '  (2*ZZ-XX-YY)/2'
    ! Actually, r*r is already stored as the 6th component
    ! we now move it to the 7th using the "augmented" arrays
    do j=1,5
      PrElAug(:,j) = PrEl(:,j)
      PrNuAug(j) = PrNu(j)
      labsAug(j) = labs(j)
    end do
    ! Generate the actual value of the 6th component
    PrElAug(:,6) = -PrEl(:,1)-PrEl(:,4)
    PrElAug(:,7) = PrEl(:,6)
    PrNuAug(6) = PrNu(6)
    PrNuAug(7) = Zero
    labsAug(6) = labs(6)
    labsAug(7) = '     RR=XX+YY+ZZ'

    ! Print cartesian components of the electric field gradient
    ! tensor at the given centre

    if ((iPL >= 3) .or. ((.not. Short) .and. (iPL == 2))) then
      write(u6,'(//6x,a,i5,1x,a,3(f12.8,a))') ' Electric field gradient:  centre no.',icen,'(',cen1(1),',',cen1(2),',',cen1(3),')'
      write(u6,'(6x,78(''-''))')
    else
      if (icen == 1) then
        write(u6,'(//6X,A)') 'Electric field gradient:'
        write(u6,'(5X,6A16)') (labsAug(i),i=1,MaxLab)
      end if
    end if
    sig = +One
  end if
  call mma_allocate(PrTot,maxlab,label='PrTot')

  ! Print the values using "augmented" arrays if needed

  if (Maxlab == 7) then
    call Prout(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrElAug,PrNuAug,maxlab,labsAug,PrTot,iPL,icen,ifallorb)
    MaxLab = 6 ! Reset so call to Add_Info is correct!

  else
    call Prout(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,labs,PrTot,iPL,icen,ifallorb)
  end if

  if (lab3 == 'EF2') then
    Tmp = PrTot(3)
    PrTot(3) = PrTot(4)
    PrTot(4) = Tmp
    if ((iPL >= 3) .or. ((.not. Short) .and. (iPL == 2))) call Print_EigenValues(PrTot,3)
    Tmp = PrTot(3)
    PrTot(3) = PrTot(4)
    PrTot(4) = Tmp
  end if

  ! do not write the different electric field components through Add_Info
  StoreInfo = .false.
else if ((lab4 == 'DMS ') .or. (lab4(1:3) == 'PAM') .or. (lab4(1:3) == 'CNT')) then
  if (lab4 == 'DMS ') then
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! diamagnetic shielding section

    read(oplab,'(a4,i2,i2)') lab4,i,icen1

    maxlab = 9
    call mma_allocate(PrTot,maxlab,label='PrTot')

    ! set labels
    labs(1) = '   (YO*YG+ZO*ZG)'
    labs(2) = '         (XO*YG)'
    labs(3) = '         (XO*ZG)'
    labs(4) = '         (YO*XG)'
    labs(5) = '   (XO*XG+ZO*ZG)'
    labs(6) = '         (YO*ZG)'
    labs(7) = '         (ZO*XG)'
    labs(8) = '         (ZO*YG)'
    labs(9) = '   (XO*XG+YO*YG)'

    ! Print cartesian components of the diamagnetic shielding
    ! tensor at the given centre (O=cen1) with the gauge origin
    ! at centre G=cen2

    write(u6,'(//6x,a,i3,1x,a,3(f12.8,a)/1x,a,3(f12.8,a))') ' Diamagnetic shielding:   centre no.',icen1,'(',cen1(1),',',cen1(2), &
                                                            ',',cen1(3),')','                       gauge origin at (',cen2(1), &
                                                            ',',cen2(2),',',cen2(3),')'
    write(u6,'(6x,78(''-''))')
    sig = One
    call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,labs,PrTot,iPL,0,ifallorb)
  end if
  if ((lab4 == 'DMS ') .or. (lab4(1:3) == 'PAM')) then
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! PAM section ... generate labels for printing

    ilab = 0
    do ix=lpole,0,-1
      do iy=lpole-ix,0,-1
        iz = lpole-ix-iy
        ilab = ilab+1
        lab = '                '
        do izz=lmax,lmax-iz+1,-1
          lab(izz:izz) = 'Z'
        end do
        do iyy=lmax-iz,lmax-iz-iy+1,-1
          lab(iyy:iyy) = 'Y'
        end do
        do ixx=lmax-iz-iy,lmax-lpole+1,-1
          lab(ixx:ixx) = 'X'
        end do
        labs(ilab) = lab
      end do
    end do

    maxlab = ilab
    call mma_allocate(PrTot,maxlab,label='PrTot')

    ! Print cartesian moments

    if (lpole == 0) lab5 = ' 0-th'
    if (lpole == 1) lab5 = ' 1-st'
    if (lpole == 2) lab5 = ' 2-nd'
    if (lpole == 3) lab5 = ' 3-rd'
    if (lpole > 3) then
      lab3 = '-th'
      write(lab5,'(i2,a3)') lpole,lab3
    end if
    write(u6,'(//6x,a5,a,3(f12.8,a))') lab5,' cartesian moments: origin at (',cen1(1),',',cen1(2),',',cen1(3),')'
    write(u6,'(6x,76(''-''))')
    sig = One
    call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,labs,PrTot,iPL,0,ifallorb)

    if ((lpole >= 2) .and. (lpole <= 4)) then
      write(u6,'(//6x,a,i2,a,3(f12.8,a))') 'Cartesian ',lpole,'-pole moment: origin at (',cen1(1),',',cen1(2),',',cen1(3),')'
      write(u6,'(6x,76(''-''))')

      inp = 0
      call Tmltpl(inp,lpole,maxlab,labs,1,PrNu,tmat,temp)
      inp = 1
      call Tmltpl(inp,lpole,maxlab,labs,nTot,PrEl,tmat,temp)

      ! Print 0-pole PAM integrals (sig=1 in opposite multipole moments)

      sig = One
      call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,labs,PrTot,iPL,0,ifallorb)
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Contact term section

  read(oplab,'(a3,i5)') lab3,icen

  maxlab = 1
  call mma_allocate(PrTot,maxlab,label='PrTot')

  ! set labels
  labs(1) = '      Delta(R-C)'

  if ((iPL >= 3) .or. ((.not. Short) .and. (iPL == 2))) then
    write(u6,'(//6x,a,i5,1x,a,3(f12.8,a))') ' Contact term:  centre no.',icen,'(',cen1(1),',',cen1(2),',',cen1(3),')'
    write(u6,'(6x,78(''-''))')
  else
    if (icen == 1) then
      write(u6,'(//6X,A)') 'Contact term:'
      write(u6,'(5X,6A16)') (labs(i),i=1,MaxLab)
    end if
  end if
  sig = +One
  call PrOut(Short,sig,nIrrep,nBas,nTot,Occ,ThrSV,PrEl,PrNu,maxlab,labs,PrTot,iPL,icen,ifallorb)

  ! do not write the contact term through Add_Info
  StoreInfo = .false.
else if (lab4 == 'VELO') then
  call End1()
  return
else if (lab4 == 'ANGM') then
  call End1()
  return
else

  ! invalid label supplied

  write(u6,'(//1x,a,a8,a//)') ' The label: *',oplab,'* is not a valid label ... stop'
  call Quit_OnUserError()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (OpLab(1:3) == 'EF2') then
  iTol = 4
else
  iTol = 5
end if
iTol_E0 = 8
iTol_E1 = Cho_X_GetTol(iTol_E0)
iTol = int(real(iTol*iTol_E1,kind=wp)/real(iTol_E0,kind=wp))
if (StoreInfo) call Add_Info(OpLab,PrTot,maxlab,iTol)
call mma_deallocate(PrTot)
call End1()

return

contains

subroutine End1()
  call mma_deallocate(labs)
  call mma_deallocate(tmat)
  call mma_deallocate(temp)
  call mma_deallocate(PrElAug)
  call mma_deallocate(PrNuAug)
  call mma_deallocate(labsAug)
end subroutine End1

end subroutine Prop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine OFE_print(Energy_A)

      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
      Real*8 ReCharge(MxAtom)
      COMMON  / OFembed_R / Rep_EN,Func_AB,Func_A,Func_B,Energy_NAD,
     &                      V_Nuc_AB,V_Nuc_BA,V_emb
      COMMON  / OFembed_R2/ dFMD
      Character*16 NamRfil
      Character*10 Fmt
      Integer  Cho_X_GetTol
      External Cho_X_GetTol
*
      Call Get_iScalar('nSym',nSym)
      Call Get_iScalar('Unique atoms',nAtoms)
      Call Get_dArray('Effective nuclear Charge',ReCharge,nAtoms)
*
      Call Get_NameRun(NamRfil)
      Call NameRun('AUXRFIL')
      Call PotNuc_nad(nSym,nAtoms,ReCharge,ZRE_nad)
*
      Call Get_dEnergy(Energy_B)
      If (dFMD.gt.0.0) Call Get_dScalar('KSDFT energy',Ec_A)
*
      Call NameRun(NamRfil)
*
      iTol = Cho_X_GetTol(8)
      Call Add_Info('V_OFE',[V_emb],1,iTol)
      Call Add_Info('V_NUC',[V_Nuc_AB],1,iTol)
      Call Add_Info('E_NAD',[Energy_NAD],1,iTol)
      Call Add_Info('RP_EN',[Rep_EN],1,iTol)
*
      Fmt='(A,F19.10)'
      write(6,*)
      write(6,*)  '     -----------------------------------------------'
      write(6,*)  '      Orbital-Free Embedding Calculation : Results  '
      write(6,*)  '     -----------------------------------------------'
      write(6,Fmt)'        DFT energy  (A)    : ', Func_A
      write(6,Fmt)'        DFT energy  (B)    : ', Func_B
      write(6,Fmt)'        DFT energy (A+B)   : ', Func_AB
      write(6,*)
      write(6,Fmt)'        Nonelectr. Vemb    : ', V_emb ! for <A|Vq|A>
      write(6,*)
      write(6,Fmt)'        Energy (A)         : ', Energy_A
      write(6,Fmt)'        Energy (B)         : ', Energy_B
      write(6,Fmt)'        DFT energy (NAD)   : ', Energy_NAD
      write(6,Fmt)'        Vnuc(B)*rhoA       : ', V_Nuc_AB
      write(6,Fmt)'        Vnuc(A)*rhoB       : ', V_Nuc_BA
      write(6,Fmt)'        Electr. repulsion  : ', Rep_EN
      write(6,*)  '     -----------------------------------------------'
      write(6,Fmt)'       Nuclear rep. (A--B) : ', ZRE_nad
      write(6,Fmt)'       Energy (A+B)        : ', Energy_B+Energy_A
     &                                                     +Energy_NAD
     &                                                     +V_Nuc_AB
     &                                                     +V_Nuc_BA
     &                                                     +Rep_EN
     &                                                     +ZRE_nad
      If(dFMD.gt.0.0) write(6,Fmt)'       SCF restoring Ec(A) : ', Ec_A
      write(6,*)  '     -----------------------------------------------'
      write(6,*)
      write(6,*)
*
      Call Put_dScalar('NAD dft energy',Energy_NAD)
      Return
      End
************************************************************************
*
************************************************************************
      Subroutine Get_dEnergy(Energy)
      Implicit Real*8 (a-h,o-z)
      Real*8  Energy
      Logical Found_EAV

      Found_EAV=.false.
      Call Qpg_dScalar('Average energy',Found_EAV)

      If (Found_EAV) Then
         Call Get_dScalar('Average energy',Energy)
      Else
         Call Get_dScalar('Last energy',Energy)
      EndIf

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine fetch_init_const( nneq, neqv, nmax, exch, nLoc,
     &                             nCenter, nT, nH, nTempMagn, nDir,
     &                             nDirZee, nMult, nPair, MxRank1,
     &                             MxRank2, iReturn )
c  this routine looks into the file "single_aniso.input" for the "RESTart" keyword
c
      Implicit None
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
#include "warnings.fh"
      Integer, intent(out) :: nneq, neqv, nmax, exch, nLoc,
     &                        nCenter, nT, nH, nTempMagn, nDir,
     &                        nDirZee, nMult, nPair, MxRank1, MxRank2,
     &                        iReturn
c local variables:
      Integer :: NMAXC
      Parameter (NMAXC=99)
      Integer :: i, j, linenr, Input, nTempMagn_HEXP, nTempMagn_TMAG,
     &           nH_HEXP, nH_HINT, nT_TEXP, nT_TINT
      Integer :: neqA(NMAXC), nexchA(NMAXC)
      Integer :: sfs_check(NMAXC)
      Integer :: sos_check(NMAXC)
      Integer :: imaxrank(NMAXC,2)
      Integer :: idummy
      Integer :: irank1, irank2, iline
      Real(kind=8):: rdummy
      Real(kind=8):: TempMagn(NMAXC)
      Logical :: ab_initio_all
      Logical :: KeyCoor, KeyPair, KeyHEXP, KeyTEXP, KeyHINT, KeyTINT,
     &           KeyTMAG, KeyMLTP, KeyMVEC, KeyNNEQ, KeyZEEM, KeyITOJ
      Integer :: LUANISO, Isfreeunit
      Character(Len=1)   :: itype(NMAXC)
      Character(Len=280) :: line
      Character(Len=180)  :: namefile_aniso
      Logical :: ifHDF
      Logical :: DBG
      External Isfreeunit


      iReturn=0
      nH=0
      nT=0
      nTempMagn=1
      nneq=0
      neqv=0
      nmax=0
      exch=0
      nCenter=0
      nDirZee=0
      nDir=0
      nMult=0
      nLoc=0
      nPair=0
      MxRank1=0
      MxRank2=0
      luaniso=0
      rdummy=0.0_wp
      neqA(1:nmaxc)=0
      nexchA(1:nmaxc)=0
      sfs_check(1:nmaxc)=0
      sos_check(1:nmaxc)=0
      ab_initio_all=.false.
      itype(1:nmaxc)=' '
      imaxrank(1:nmaxc,1:2)=0

c      namefile_aniso='              '
      ifHDF=.false.
      Input=5

      DBG=.false.


      KeyNNEQ=.false.
      KeyPair=.false.
      KeyCoor=.false.
      KeyHEXP=.false.
      KeyTEXP=.false.
      KeyTMAG=.false.
      KeyTINT=.false.
      KeyHINT=.false.
      KeyMLTP=.false.
      KeyMVEC=.false.
      KeyZEEM=.false.
      KeyITOJ=.false.
      nH_HEXP=0
      nH_HINT=0
      nT_TEXP=0
      nT_TINT=0
      nTempMagn_HEXP=0
      nTempMagn_TMAG=0
C=========== End of default settings====================================
      REWIND(Input)
50    READ(Input,'(A280)',End=998) LINE
      Call NORMAL(LINE)
      If(LINE(1:11).ne.'&POLY_ANISO') Go To 50
      LINENR=0
100   READ(Input,'(A280)',End=998) line
      LINENR=LINENR+1
      Call NORMAL(LINE)
      If (LINE(1:1).eq.'*') Go To 100
      If (LINE.eq.' ') Go To 100
      If((LINE(1:4).ne.'NNEQ').AND.(LINE(1:4).ne.'TEXP').AND.
     &   (LINE(1:4).ne.'HEXP').AND.(LINE(1:4).ne.'END ').AND.
     &   (LINE(1:4).ne.'    ').AND.(LINE(1:4).ne.'HINT').AND.
     &   (LINE(1:4).ne.'TINT').AND.(LINE(1:4).ne.'TMAG').AND.
     &   (LINE(1:4).ne.'MVEC').AND.(LINE(1:4).ne.'ZEEM').AND.
     &   (LINE(1:4).ne.'MLTP').AND.(LINE(1:4).ne.'LIN1').AND.
     &   (LINE(1:4).ne.'LIN3').AND.(LINE(1:4).ne.'LIN9').AND.
     &   (LINE(1:4).ne.'PAIR').AND.(LINE(1:4).ne.'ALIN').AND.
     &   (LINE(1:4).ne.'COOR').AND.(LINE(1:4).ne.'ITOJ')) Go To 100
      If((LINE(1:4).eq.'END ').OR.(LINE(1:4).eq.'    '))  Go To 200

      If (line(1:4).eq.'NNEQ') Then

         KeyNNEQ=.true.
         READ(Input,*) nneq, ab_initio_all, ifHDF

         If(DBG) WRITE(6,*) nneq, ab_initio_all, ifHDF

         If(nneq<0) Then
            Write(6,'(A)') 'nneq<0! Must be positive!'
            Call Quit_OnUserError()
         Else If (nneq==0) Then
            Write(6,'(A)') 'nneq=0! Must be larger than zero!'
            Call Quit_OnUserError()
         Else If (nneq>NMAXC) Then
            Write(6,'(A)') 'nneq>99! Must be smaller than this!'
            Call Quit_OnUserError()
         End If

         READ(Input,*) (neqA(i),i=1,nneq)
         If(DBG) WRITE(6,*) (neqA(i),i=1,nneq)

         Do i=1, nneq
           If(neqA(i)<0) Then
              Write(6,'(A,i2,A)') 'neq(',i,')<0! Must be positive!'
              Call Quit_OnUserError()
           Else If (neqA(i)==0) Then
              Write(6,'(A,i2,A)') 'neq(',i,')=0! Must be larger '//
     &                            'than zero!'
              Call Quit_OnUserError()
           End If
         End Do

         READ(Input,*) (nexchA(i),i=1,nneq)
         If(DBG) WRITE(6,*) (nexchA(i),i=1,nneq)

         Do i=1, nneq
           If(nexchA(i)<0) Then
              Write(6,'(A,i2,A)') 'nexch(',i,')<0! Must be positive!'
              Call Quit_OnUserError()
           Else If (nexchA(i)==0) Then
              Write(6,'(A,i2,A)') 'nexch(',i,')=0! Must be larger '//
     &                            'than zero!'
              Call Quit_OnUserError()
           End If
         End Do

         neqv=0
         neqv=MAXVAL(neqA(1:nneq))
         If(DBG) Write(6,*) 'neqv = ', neqv
         nmax=0
         nmax=MAXVAL(nexchA(1:nneq))
         If(DBG) Write(6,*) 'nmax = ', nmax

         ! compute "exch"
         exch=1
         Do i=1,nneq
           Do j=1,neqA(i)
             exch=exch*nexchA(i)
           End Do
         End Do
         If(DBG) Write(6,*) 'exch=',exch

         If(ab_initio_all .eqv. .false.) Then
           READ(Input,*,ERR=997) (itype(i),i=1,Nneq)
         Else
           Do i=1,nneq
             itype(i)='A'
           End Do
         End If !ab_initio_all

         ! check the maximal number of local spin-orbit states
         sos_check=0
         sfs_check=0
         nCenter=0
         Do i=1,NNEQ
           nCenter=nCenter+neqA(I)
         End Do


         Do i=1,NNEQ
           If (itype(i) .eq. 'A') Then
             If( ifHDF ) Then
                ! generating the name of the "aniso_input file for
                ! each center. Maxmimum 10 centers. CHAR(48)=0 (zero)
                If(i<10) Then
                   Write(namefile_aniso,'(4A)') 'aniso_hdf_',
     &                       CHAR(48+mod( int( i     ),10)),'.input'
                Else If(i>=10 .and. i<=99) Then
                   Write(namefile_aniso,'(4A)') 'aniso_hdf_',
     &                       CHAR(48+mod( int((i)/10 ),10)),
     &                       CHAR(48+mod( int( i     ),10)),'.input'
                End If

#ifdef _HDF5_
                Call read_hdf5_init( NAMEFILE_ANISO,sfs_check(I),
     &                               sos_check(I))
                If (DBG) Write(6,*) ' sfs(I) ',sfs_check(I),
     &                              ' sos(I) ',sos_check(I)
#else
                Call WarningMessage(2,'File '//trim(NAMEFILE_ANISO)//
     &                               ' cannot be opened. Molcas was'//
     &                               ' compiled without HDF5 option.')
                Call Quit_OnUserError()
#endif
             Else
                ! generating the name of the "aniso_input file for
                ! each center. Maxmimum 10 centers. CHAR(48)=0 (zero)
                If(i<10) Then
                   Write(namefile_aniso,'(4A)') 'aniso_',
     &                       CHAR(48+mod( int( i     ),10)),'.input'
                Else If(i>=10 .and. i<=99) Then
                   Write(namefile_aniso,'(4A)') 'aniso_',
     &                       CHAR(48+mod( int((i)/10 ),10)),
     &                       CHAR(48+mod( int( i     ),10)),'.input'
                End If
                LUANISO = Isfreeunit(20)
                Call molcas_open( LUANISO, NAMEFILE_ANISO)
                READ( LUANISO,*) sfs_check(I), sos_check(I)
                If (DBG) Write(6,*) ' sfs(I) ',sfs_check(I),
     &                              ' sos(I) ',sos_check(I)
                CLOSE(LUANISO)
             End If ! ifHDF
           Else If((itype(i).eq.'B').OR.(itype(i).eq.'C')) Then
             sfs_check(I)=1
             sos_check(I)=NexchA(i)
           End If


         End Do ! NNEQ

         nLoc=MAXVAL(sos_check(1:nneq))

         LINENR=LINENR+3
         Go To 100
      End If



      If (line(1:4).eq.'TEXP') Then

          KeyTexp=.true.
          READ(Input,*) nT_TEXP

          If ( nT_TEXP<=0 ) Then
             Call WarningMessage(2,
     &                 'TEXP: Number of temperature points <= 0! ')
             Call Quit_OnUserError()
          End If

          If(DBG) WRITE(6,*) 'TEXP:: = nT_TEXP', nT_TEXP

          LINENR=LINENR+1
          Go To 100
      End If



      If (line(1:4).eq.'HEXP') Then

          KeyHexp=.true.
          READ(Input,*) nTempMagn_HEXP, (TempMagn(i),i=1,nTempMagn)
          READ(Input,*) nH_HEXP

          If ( nH_HEXP<=0 ) Then
             Call WarningMessage(2,
     &                 'HEXP: Number of field points <= 0! ')
             Call Quit_OnUserError()
          End If

          If ( nTempMagn_HEXP<=0 ) Then
             Call WarningMessage(2,
     &                 'HEXP: Number of temperature points <= 0! ')
             Call Quit_OnUserError()
          End If

          If(DBG) WRITE(6,*) 'HEXP:: = nH_HEXP ', nH_HEXP
          If(DBG) WRITE(6,*) 'HEXP:: = nTempMagn_HEXP ', nTempMagn_HEXP
          LINENR=LINENR+2
          Go To 100
      End If



      If (line(1:4).eq.'HINT') Then

          KeyHINT=.true.
          READ(Input,*) rdummy, rdummy, nH_HINT

          If ( nH_HINT<=0 ) Then
             Call WarningMessage(2,
     &                 'HINT: Number of field points <= 0! ')
             Call Quit_OnUserError()
          End If

          If(DBG) WRITE(6,*) 'HINT:: = nH_HINT ', nH_HINT
          LINENR=LINENR+1
          Go To 100
      End If



      If (line(1:4).eq.'TINT') Then

          KeyTINT=.true.
          READ(Input,*) rdummy, rdummy, nT_TINT

          If ( nT_TINT<=0 ) Then
             Call WarningMessage(2,
     &                 'TINT: Number of temperature points <= 0! ')
             Call Quit_OnUserError()
          End If

          If(DBG) WRITE(6,*) 'TINT:: = nT_TINT ', nT_TINT
          LINENR=LINENR+1
          Go To 100
      End If




      If (line(1:4).eq.'TMAG') Then

          KeyTMAG=.true.
          READ(Input,*) nTempMagn_TMAG

          If ( nTempMagn_TMAG<=0 ) Then
             Call WarningMessage(2,
     &                 'TMAG: Number of temperatureMAGN points <= 0! ')
             Call Quit_OnUserError()
          End If

          If(DBG) WRITE(6,*) 'TMAG:: = nTempMagn_TMAG ',nTempMagn_TMAG
          LINENR=LINENR+1
          Go To 100
      End If



      If (line(1:4).eq.'MVEC') Then

          KeyMVEC=.true.
          READ(Input,*) nDir

          If ( nDir<=0 ) Then
             Call WarningMessage(2,
     &                 'MVEC: Number of nDir points <= 0! ')
             Call Quit_OnUserError()
          End If

          If(DBG) WRITE(6,*) 'MVEC:: = nDir ',nDir
          LINENR=LINENR+1
          Go To 100
      End If



      If (line(1:4).eq.'ZEEM') Then
          KeyZEEM=.false.
          READ(Input,*) nDirZee

          If ( nDirZee<=0 ) Then
             Call WarningMessage(2,
     &                 'ZEEM: Number of nDirZee points <= 0! ')
             Call Quit_OnUserError()
          End If

          If(DBG) WRITE(6,*) 'ZEEM:: = nDirZee ',nDirZee
          LINENR=LINENR+1
          Go To 100
      End If



      If (line(1:4).eq.'MLTP') Then

          KeyMLTP=.true.
          READ(Input,*) nMult

          If ( nMult<=0 ) Then
             Call WarningMessage(2,
     &                 'MLTP: Number of multiplets <= 0! ')
             Call Quit_OnUserError()
          End If

          If(DBG) WRITE(6,*) 'MLTP:: =nMult ',nMult
          LINENR=LINENR+1
          Go To 100
      End If



      If ( (LINE(1:4).eq.'LIN9') .OR. (LINE(1:4).eq.'LIN3') .OR.
     &     (LINE(1:4).eq.'LIN1') .OR. (LINE(1:4).eq.'ALIN') .OR.
     &     (LINE(1:4).eq.'PAIR') .OR. (LINE(1:4).eq.'ITOJ') ) Then

          KeyPair=.true.
          READ(Input,*,ERR=997) nPair

          If ( nPair<=0 ) Then
             Call WarningMessage(2,
     &             'PAIR OR LINx:: Number of interacting pairs <= 0!')
             Call Quit_OnUserError()
          End If

          If(DBG) WRITE(6,*) 'PAIR:: =nPair ',nPair


          If(LINE(1:4).eq.'ITOJ') Then
             iline=0
             Do i=1,npair
                imaxrank(i,1)=0
                imaxrank(i,2)=0

                READ(Input,*,ERR=997) idummy, idummy,
     &                              imaxrank(i,1),imaxrank(i,2)
                Do irank1=1,2*imaxrank(i,1)+1
                  Do irank2=1,2*imaxrank(i,2)+1
                    READ(Input,*,ERR=997) idummy,idummy,idummy,idummy,
     &                                    rdummy,rdummy
                    iline=iline+1
                  End Do
                End Do
             End Do ! i
             MxRank1=MAXVAL(imaxrank(1:npair,1))
             MxRank2=MAXVAL(imaxrank(1:npair,2))
             LINENR=LINENR+iline
          End If
          LINENR=LINENR+1
          Go To 100
      End If

      If (line(1:4).eq.'COOR') Then
          KeyCoor=.true.
          LINENR=LINENR+1
          Go To 100
      End If

200   Continue

      If((.not.KeyPair).AND.(KeyCoor)) nPair=nCenter*(nCenter-1)/2

      If(KeyHexp) Then
         nTempMagn=nTempMagn_HEXP
         nH       =nH_HEXP
      Else
         nTempMagn=nTempMagn_TMAG
         nH       =nH_HINT
      End If

      If(KeyTEXP) Then
         nT       =nT_TEXP
      Else
         nT       =nT_TINT
      End If

      ! in case the user did not set up some of the above keywords
      ! assume the following default ones:
      If (     nMult == 0 ) nMult=1
      If (        nT == 0 ) nT = 31
      If (        nH == 0 ) nH = 11
      If ( nTempMagn == 0 ) nTempMagn = 1

c preliminary check the values:
      If (DBG) then
         Write(6,*) 'nneq     =',nneq
         Write(6,*) 'neqv     =',neqv
         Write(6,*) 'exch     =',exch
         Write(6,*) 'nLoc     =',nLoc
         Write(6,*) 'nmax     =',nmax
         Write(6,*) 'nCenter  =',nCenter
         Write(6,*) 'nT       =',nT
         Write(6,*) 'nH       =',nH
         Write(6,*) 'nTempMagn=',ntempMagn
         Write(6,*) 'nDir     =',nDir
         Write(6,*) 'nDirZee  =',nDirZee
         Write(6,*) 'nMult    =',nMult
         Write(6,*) 'nPair    =',nPair
         Write(6,*) 'MxRank1  =',MxRank1
         Write(6,*) 'MxRank2  =',MxRank2
      End If

      Go To 190
C------ errors ------------------------------
997   continue
      Write(6,*)' READIN: Error reading "poly_aniso.input" '
      Write(6,*)' near line nr.',LINENR+1
      Go To 999
998   continue
      Write(6,*)' READIN: Unexpected End of input file.'
999   continue
      Call quit(_RC_INPUT_ERROR_)


190   Continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine hdir( nDir, nDirZee, dirX, dirY, dirZ, dir_weight,
     &                 nP, nsymm, ngrid, nDirTot, dHX, dHY, dHZ, dHW)
c      this routine generates the directions of the applied magnetic
c      field according to Lebedev-Laikov grids using the the given parameters (nsymm, ngrid)

      Implicit None
      Integer, parameter           :: wp=kind(0.d0)
      Integer                      :: nP,nDirTot,nDir,nDirZee,i,j
      Integer                      :: nsymm,ngrid

      Real(kind=8) :: dirX(nDir), dirY(nDir), dirZ(nDir),
     &                 dir_weight(nDirZee,3)
      Real(kind=8) :: dHX(nDirTot), dHY(nDirTot), dHZ(nDirTot),
     &                 dHW(nDirTot)
      Real(kind=8) :: X(nP), Y(nP), Z(nP), W(nP)


      If ((nDirTot-nDir-nDirZee-nP).ne.0) Then
        Write(6,'(A   )') 'the number of directions of applied '//
     &                    'magnetic field is not consistent:'
        Write(6,'(A,i4)') 'nDir    = ', nDir
        Write(6,'(A,i4)') 'nDirZee = ', nDirZee
        Write(6,'(A,i4)') 'nP      = ', nP
        Write(6,'(A,i4)') 'nDirTot = ', nDirTot
        Write(6,'(A,i4)') 'The rule is :'
        Write(6,'(A   )') 'nDir + nDirZee + nP = nDirTot'
        Call xFlush(6)
        Call abend()
      End If
c intialization
      Call dcopy_(nDirTot, [0.0_wp], 0, dHX(1), 1)
      Call dcopy_(nDirTot, [0.0_wp], 0, dHY(1), 1)
      Call dcopy_(nDirTot, [0.0_wp], 0, dHZ(1), 1)
      Call dcopy_(nDirTot, [0.0_wp], 0, dHW(1), 1)
      Call dcopy_(     nP, [0.0_wp], 0,   X(1), 1)
      Call dcopy_(     nP, [0.0_wp], 0,   Y(1), 1)
      Call dcopy_(     nP, [0.0_wp], 0,   Z(1), 1)
      Call dcopy_(     nP, [0.0_wp], 0,   W(1), 1)

c      If ( nDir.gt.0) then
c        Call DCOPY_(   nDir, dirX, 1, dHX(1), 1)
c        Call DCOPY_(   nDir, dirY, 1, dHY(1), 1)
c        Call DCOPY_(   nDir, dirZ, 1, dHZ(1), 1)
c      End If
c
c      If ( nDirZee.gt.0) then
c        Call DCOPY_(nDirZee, dir_weight(1:3,1), 1, dHX(1+nDir), 1)
c        Call DCOPY_(nDirZee, dir_weight(1:3,2), 1, dHY(1+nDir), 1)
c        Call DCOPY_(nDirZee, dir_weight(1:3,3), 1, dHZ(1+nDir), 1)
c      End If

      Do i=1,nDir
        dHX(i) = dirX(i)
        dHY(i) = dirY(i)
        dHZ(i) = dirZ(i)
      End Do

      Do i=1,nDirZee
        dHX(i+nDir) = dir_weight(i,1)
        dHY(i+nDir) = dir_weight(i,2)
        dHZ(i+nDir) = dir_weight(i,3)
      End Do


      Call Lebedev_Laikov(nSymm,nGrid,nP,X,Y,Z,W)

      Do i=1, nP
              j=i+nDir+nDirZee
        dHX(j) = X(i)
        dHY(j) = Y(i)
        dHZ(j) = Z(i)
        dHW(j) = W(i)
      End Do

c      Call DCOPY_(     nP, X(1), 1, dHX(1+nDir+nDirZee), 1)
c      Call DCOPY_(     nP, Y(1), 1, dHY(1+nDir+nDirZee), 1)
c      Call DCOPY_(     nP, Z(1), 1, dHZ(1+nDir+nDirZee), 1)
c      Call DCOPY_(     nP, W(1), 1, dHW(1+nDir+nDirZee), 1)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function detm_cvb(a,n)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Ten
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: detm_cvb
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: a(n,n)
integer(kind=iwp) :: ierr
real(kind=wp) :: det(2)
integer(kind=iwp), allocatable :: itmp(:)
real(kind=wp), allocatable :: tmp1(:,:), tmp2(:,:)

! start linpack_determinant
if (n == 0) then
  detm_cvb = One
  return
end if
call mma_allocate(tmp1,n,n,label='tmp1')
call mma_allocate(itmp,n,label='itmp')
ierr = 0
tmp1(:,:) = a(:,:)
call dgetrf_(n,n,tmp1,n,itmp,ierr)
! start linpack_determinant
!call dgefa(tmp1,n,n,itmp,ierr)
if (ierr /= 0) then
  detm_cvb = Zero
else
  call mma_allocate(tmp2,n,n,label='tmp2')
  call dgedi(tmp1,n,n,itmp,det,tmp2,10)
  detm_cvb = det(1)*Ten**det(2)
end if

call mma_deallocate(tmp1)
call mma_deallocate(itmp)
call mma_deallocate(tmp2)

return

end function detm_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GETSTRN_GASSM_SPGP(ISMFGS,ITPFGS,ISTROC,  NSTR,   NEL,
     &                              NNSTSGP,IISTSGP)
*
* Obtain all superstrings containing  strings of given sym and type
*
* ( Superstring :contains electrons belonging to all gasspaces
*        string :contains electrons belonging to a given GAS space
* A super string is thus a product of NGAS strings )
*
* Jeppe Olsen, Summer of 95
*              Optimized version, october 1995
*
*. In this subroutine the ordering of strings belonging to a given type
*  is defined !!
* Currently we are using the order
* Loop over GAS 1 strings
*  Loop over GAS 2 strings
*   Loop over GAS 3 strings --
*
*     Loop over gas N strings
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "strbas.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "csm.fh"
*. Specific input
      INTEGER ITPFGS(*), ISMFGS(*)
      INTEGER NNSTSGP(MXPNSMST,*), IISTSGP(MXPNSMST,*)
*. Local scratch
C     INTEGER NSTFGS(MXPNGAS), IBSTFGS(MXPNGAS), ISTRNM(MXPNGAS)
      INTEGER NSTFGS(MXPNGAS), IBSTFGS(MXPNGAS)
*. Output
      INTEGER ISTROC(NEL,*)
*. Number of strings per GAS space
C?    write(6,*) ' entering problem child '
      DO IGAS = 1, NGAS
        NSTFGS(IGAS)  = NNSTSGP(ISMFGS(IGAS),IGAS)
        IBSTFGS(IGAS) = IISTSGP(ISMFGS(IGAS),IGAS)
      END DO
*
      NTEST = 000
      IF(NTEST.GE.100) THEN
        WRITE(6,*) '  GETSTR_GASSM_SPGP speaking '
        WRITE(6,*) '  =========================== '
        WRITE(6,*) ' ISMFGS,ITPFGS (input) '
        CALL IWRTMA(ISMFGS,1,NGAS,1,NGAS)
        CALL IWRTMA(ITPFGS,1,NGAS,1,NGAS)
        WRITE(6,*)
        WRITE(6,*) ' NSTFGS, IBSTFGS ( intermediate results ) '
        CALL IWRTMA(NSTFGS,1,NGAS,1,NGAS)
        CALL IWRTMA(IBSTFGS,1,NGAS,1,NGAS)
      END IF
*. Last gasspace with a nonvanishing number of electrons
      IGASL = 0
      DO IGAS = 1, NGAS
        IF( NELFGP(ITPFGS(IGAS)) .NE. 0 ) IGASL = IGAS
      END DO
C     WRITE(6,*) ' IGASL = ', IGASL
*
      NSTRTOT = 1
      DO IGAS = 1, NGAS
        NSTRTOT = NSTRTOT*NSTFGS(IGAS)
      END DO
C     WRITE(6,*) ' NSTRTOT = ', NSTRTOT
      IF(IGASL.EQ.0) GOTO 2810
*
      IF(NSTRTOT.EQ.0) GOTO 1001
*. Loop over GAS spaces
      NELB = 0
      DO IGAS = 1, IGASL
*. Number of electrons in GAS = 1, IGAS - 1
        IF(IGAS.GT.1) THEN
          NELB = NELB +  NELFGP(ITPFGS(IGAS-1))
        END IF
*. Number of electron in IGAS
        NELI = NELFGP(ITPFGS(IGAS))
C?      WRITE(6,*) ' NELI and NELB ', NELI,NELB
        IF(NELI.GT.0) THEN

*. The order of strings corresponds to a matrix A(I(after),Igas,I(before))
*. where I(after) loops over strings in IGAS+1 - IGASL and
*  I(before) loop over strings in 1 - IGAS -1
          NSTA = 1
          DO JGAS = IGAS+1, IGASL
            NSTA = NSTA * NSTFGS(JGAS)
          END DO
*
          NSTB =  1
          DO JGAS = 1, IGAS-1
            NSTB = NSTB * NSTFGS(JGAS)
          END DO
*
          NSTI = NSTFGS(IGAS)

C?        write(6,*) ' before call to add_str_group '
          IF(NTEST.GE.200) THEN
            WRITE(6,*) ' NSTI,NSTB,NSTA,NELB,NELI,NEL ',
     &                   NSTI,NSTB,NSTA,NELB,NELI,NEL
            WRITE(6,*) ' IBSTFGS(IGAS),KOC()',
     &                   IBSTFGS(IGAS),KOCSTR(ITPFGS(IGAS))
          END IF
*
          CALL ADD_STR_GROUP(   NSTI,
     &                       IBSTFGS(IGAS),
     &                       IWORK(KOCSTR(ITPFGS(IGAS))),
     &                          NSTB,   NSTA, ISTROC, NELB+1,   NELI,
     &                           NEL)
*
*. Loop over strings in IGAS
        END IF
      END DO
 1001 CONTINUE
 2810 CONTINUE
      NSTR = NSTRTOT
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Info from  GETSTR_GASSM_SPGP '
        WRITE(6,*) ' ============================='
        WRITE(6,*)
        WRITE(6,*) ' Symmetry and type strings : '
        WRITE(6,*)
        WRITE(6,*) '   AS    Sym  Type '
        WRITE(6,*) ' =================='
        DO IGAS = 1, NGAS
          WRITE(6,'(3I6)') IGAS,ISMFGS(IGAS),ITPFGS(IGAS)
        END DO
        WRITE(6,*)
        WRITE(6,*) ' Number of strings generated : ', NSTR
        WRITE(6,*) ' Strings generated '
        CALL PRTSTR(ISTROC,NEL,NSTR)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Move_Prop(rMP,EC,lMax,nElem,nAtoms,nPert,
     &                     nij,iANr,Bond_Threshold)
*
* Distributes the contributions from the bonds that doesn't fulfill the requirement
* Bond_Length <= Bond_Threshold*(Bragg_Slater(iAtom)+Bragg_Slater(jAtom) to the
* two atoms involved in the bond.
*
* Polarizabilities are moved in the Move_Polar subroutine!
*
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 rMP(nij,0:nElem-1,0:nPert-1), EC(3,nij)
      Integer iAnr(nAtoms)
      Logical Bond_OK, Check_Bond
*
      Do iAtom = 2,nAtoms
         ii = iAtom*(iAtom+1)/2
         Do jAtom = 1,iAtom-1
            jj = jAtom*(jAtom+1)/2
            Bond_Ok = Check_Bond(EC(1,ii),EC(1,jj),iANr(iAtom),
     &                           iANr(jAtom),Bond_Threshold)
            If (.NOT. Bond_OK) Then
               ij = iAtom*(iAtom-1)/2+jAtom
               Do iPert = 0,nPert-1
*
* First move half of the bond properties to iAtom
*
                  Do iElem = 0,nElem-1
                     rMP(ij,iElem,iPert) = rMP(ij,iElem,iPert) * Half
                  End Do
*
                  Call ReExpand(rMP(1,0,iPert),nij,nElem,EC(1,ij),
     &                          EC(1,ii),ij,lMax)
*
                  Do iElem = 0,nElem-1
                     rMP(ii,iElem,iPert) = rMP(ii,iElem,iPert)
     &                                   + rMP(ij,iElem,iPert)
                  End Do
*
* Then move the other half of the bond properties to jAtom
*
                  Call ReExpand(rMP(1,0,iPert),nij,nElem,EC(1,ii),
     &                          EC(1,jj),ij,lMax)
*
                  Do iElem = 0,nElem-1
                     rMP(jj,iElem,iPert) = rMP(jj,iElem,iPert)
     &                                   + rMP(ij,iElem,iPert)
                  End Do
*
* Set local properties to zero
*
                  Call dCopy_(nElem,[Zero],0,rMP(ij,0,iPert),nij)
               End Do
            End If
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine make_close_rvb()
      use definitions, only: iwp
      implicit None
      integer(kind=iwp), external ::find_lu
      integer(kind=iwp) il,i,n
      character(LEN=8) vec(11)
      vec(1)='TMP01'
      vec(2)='TMP02'
      vec(3)='TMP03'
      vec(4)='TMP04'
      vec(5)='TMP05'
      vec(6)='TMP06'
      vec(7)='TMP07'
      vec(8)='TMP08'
      vec(9)='TMP09'
      vec(10)='VBWFN'
      il=10
c  Preassign some file names to identifiers :
      do i=1,il
        n=find_lu(vec(i))
        if(n.gt.0)call daclos(n)
      enddo
      end subroutine make_close_rvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************
      SubRoutine ChoMP2g_AmpDiag(irc,Diag,EOcc,EVir)
C
C     Jonas Bostrom, Jan. 2010.
C
C     Purpose: Construct diagonal for decomposition of amplitude
C              vectors.
C
#include "implicit.fh"
      Integer irc
      Real*8  Diag(*), EOcc(*), EVir(*)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2g.fh"

      Character(LEN=7), Parameter:: ThisNm = 'AmpDiag'
      Character(LEN=15), Parameter:: SecNam = 'ChoMP2g_AmpDiag'

      MulD2h(k,l)=iEor(k-1,l-1)+1

      irc = 0

C     Initialization.
C     ------------------------

      iVecType = 6
      kD0 = 0

C     Construct Diagonal
C     ------------------------

      Do iSym = 1, nSym
            Do iSymI = 1,nSym
               iSymA = MulD2h(iSymI,iSym)
               kD1 = kD0 + iMoMo(iSymA,iSymI,iVecType)
               Do iI = 1, nOcc(iSymI)
                  kD2 = kD1 + nVir(iSymA)*(iI-1)
                  Ei = EOcc(iOcc(iSymI) +iI)
                  Do iA = 1, nVir(iSymA)
                     iAI = kD2 + iA
                     DE = 2.0d0*(EVir(iVir(iSymA)+iA)-Ei)
                     Diag(iAI) = Diag(iAI)/DE
                  End Do
               End Do
            End Do
            kD0 = kD0 + nMoMo(iSym,iVecType)
         End Do

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
c  ************************************
c  ** Routines involving CI and ORBS **
c  ************************************
c  *********************************************************************
c  *                                                                   *
c  *  APPLYT := transform CI vector IVEC according to orbital          *
c  *         := transformation in IGJORB (from GAUSSJ)                 *
c  *                                                                   *
c  *  :> IVEC:      starting CI vector                                 *
c  *  :> IGJORB:    simple orbital updates                             *
c  *  :> N_APPLYT   stats                                              *
c  *  :> I1ALF:     string handling                                    *
c  *  :> I1BET:           do.                                          *
c  *  :> IATO:            do.                                          *
c  *  :> IBTO:            do.                                          *
c  *  :> PHATO:           do.                                          *
c  *  :> PHBTO:           do.                                          *
c  *                                                                   *
c  *  :< IVEC:      transformed CI vector                              *
c  *  :< N_APPLYT   stats                                              *
c  *                                                                   *
c  *********************************************************************
      subroutine iapplyt_cvb(cvec,igjorb)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension igjorb(*),cvec(*)

      call iapplyt_cvb_internal(igjorb)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine iapplyt_cvb_internal(igjorb)
      use iso_c_binding
      integer, target :: igjorb(*)
      real*8, pointer :: gjorb(:)
      ivec=nint(cvec(1))
      n_applyt=n_applyt+1
      ioff=idbl_cvb(norb*norb)
      if(iform_ci(ivec).eq.0)then
        call permci_cvb(cvec,igjorb(1+ioff))
        call c_f_pointer(c_loc(igjorb(1)),gjorb,[1])
        call applyt2_cvb(work(iaddr_ci(ivec)),
     >    gjorb,igjorb(1+norb+ioff),
     >    iwork(ll(1)),iwork(ll(2)),iwork(ll(5)),iwork(ll(6)),
     >    work(ll(9)),work(ll(10)))
        nullify(gjorb)
      else
        write(6,*)' Unsupported format in APPLYT :',iform_ci(ivec)
        call abend_cvb()
      endif

      call setcnt2_cvb(ivec,0)
      return
      end subroutine iapplyt_cvb_internal
*
      end
*
      subroutine applyt_cvb(cvec,gjorb)
      implicit real*8 (a-h,o-z)
      dimension gjorb(*),cvec(*)
*
      call applyt_cvb_internal(gjorb)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine applyt_cvb_internal(gjorb)
      use iso_c_binding
      real*8, target :: gjorb(*)
      integer, pointer :: igjorb(:)
      call c_f_pointer(c_loc(gjorb(1)),igjorb,[1])
      call iapplyt_cvb(cvec,igjorb)
      nullify(igjorb)
      end subroutine applyt_cvb_internal
*
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RdRfld(ipHOne)
*
      Implicit Real*8 (A-H,O-Z)
#include "files_motra.fh"

#include "motra_global.fh"
#include "trafo_motra.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
      Logical Found
*
*----------------------------------------------------------------------*
*     If this is a perturbative reaction field calculation then        *
*     modifiy the one-electron Hamiltonian by the reaction field and   *
*     the nuclear attraction by the cavity self-energy                 *
*----------------------------------------------------------------------*
      nTemp=0
      Do iSym=1,nSym
         nTemp=nTemp+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
      Call GetMem('RFFLD','Allo','Real',lTemp,nTemp)
      Call f_Inquire('RUNOLD',Found)
      If (Found) Call NameRun('RUNOLD')
      Call get_dscalar('RF Self Energy',ERFself)
      PotNuc=PotNuc+ERFself
      Call get_darray('Reaction field',Work(lTemp),nTemp)
      If (Found) Call NameRun('RUNFILE')
      Call Daxpy_(nTemp,1.0D0,Work(lTemp),1,Work(ipHone),1)
      Call GetMem('RFFLD','Free','Real',lTemp,nTemp)
*----------------------------------------------------------------------*
*     Normal termination                                               *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mc0c1a3b
     & (rowa,cola,rowb,colb,rowc,colc,
     & row,sum,col,a,b,c)
C
C     C = C + A*B
C
#include "ccsd1.fh"
       integer rowa,cola,rowb,colb,rowc,colc
       integer row,sum,col
       real*8  A(1:rowa,1:cola)
       real*8  B(1:rowb,1:colb)
       real*8  C(1:rowc,1:colc)
C
C      help variables
C
       integer i,j,k
c
       if (mhkey.eq.1) then
c      ESSL
       call DGEMM_('N','N',row,col,sum,1.0d0,a,rowa,b,rowb,
     & 1.0d0,c,rowc)
C
       else
c      Fortran matrix handling
C
       do 50 j=1, col
       do 40 k=1, sum
       do 30 i=1, row
       c(i,j) = c(i,j) + a(i,k)*b(k,j)
 30    continue
 40    continue
 50    continue
C
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine PrGrad(Label,Grad,nGrad,Names,iPrint)
************************************************************************
*                                                                      *
* Object: to print set gradient with respect to the symmetrical dis-   *
*         placements.                                                  *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      use Symmetry_Info, only: lIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
      Real*8 Grad(nGrad)
      Real*8 CGrad(3,MxAtom)
      Character CNames(MxAtom)*(LENIN5)
      Character Label*(*), Names(nGrad)*(LENIN6)
      Character Namei*(LENIN5)
*
      Write (6,*)
      Call Banner(Label,1,Len(Label)+30)
      Write (6,*)
*     If (iPrint.EQ.4) then
      If (.True.) then
         Call TrGrd_Alaska_(CGrad,CNames,Grad,nGrad,iCen)
         Write (6,'(1x,A,A)') ' Irreducible representation: ',lIrrep(0)
         Write (6,'(1x,90A     )') ('-',i=1,90)
         Write (6,'(7x,3(23x,A))')  'X','Y','Z'
         Write (6,'(1x,90A     )') ('-',i=1,90)
         Do iGrad = 1, iCen
            TempX = CGrad(1,iGrad)
            TempY = CGrad(2,iGrad)
            TempZ = CGrad(3,iGrad)
            Namei = CNames(iGrad)
            Write (6,'(2X,A,3X,3ES24.14)') Namei, TempX, TempY, TempZ
         End Do
         Write (6,'(1x,90A     )') ('-',i=1,90)
      else
*
*        Modified by Luca De Vico november 2005 Teokem
*        I need to print the full gradient vector
*        to use it for constrained optimizations
*        with TRANSVERSE option in SLAPAF MODULE
*
*         mGrad=Min(21,nGrad)
*
         mGrad=nGrad
         Write (6,'(15x,A,A)') ' Irreducible representation: ',lIrrep(0)
         Write (6,*)
         Do iGrad = 1, mGrad
            Temp = Grad(iGrad)
*           If (Abs(Temp).lt.1.0D-15) Temp = Zero
            Write (6,'(16X,A,15X,ES15.7)') Names(iGrad), Temp
         End Do
*
*         If (nGrad.gt.21) Then
*            Write (6,*)
*            Write (6,*) '   ... list is truncated ... '
*            Write (6,*)
*         End If
*
*        End of modifications
*
      EndIf
      Write (6,*)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iPrint)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SS_DRL_ACT_BL_SGT0(LIN,LRA)
!=======================================================================
! SS(1)    ACT -BL-
! SS(1-20) Drl(33)-C"(11)-C"(22)-
! SS(1-20) (11)Drl(33)-C"(22)-
! SS(1-20) (11)(22)Drl(33)-
!=======================================================================

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    ! SS(1-16) (11)-Drl(22)-
    if ((JML /= Mul(LMI,LMJ)) .or. (JMR /= Mul(LMI,LMJ))) cycle
    IWDL = JUST(LRJ,LRI)
    IWDR = IWDL
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_SS(16)
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_SS(16)
    end do
    call Drl_BL_EXT_AR_NEW(LIN,LRJ,LRA)
    ! SS(1-18) Drl(11)-C"(22)-
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_SS(18)
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_SS(18)
    end do
    call Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
    ! SS(1-20) Drl(33)-C"(11)-C"(22)-
    ! SS(1-20) (11)Drl(33)-C"(22)-
    ! SS(1-20) (11)(22)Drl(33)-
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_SS(20)
      VPLP_W1(MPL) = Zero
    end do
    if (LRA > NORB_DZ) then
      call Drl_BL_SUM_AR_new(LIN,LRI,LRJ,LRA)
    else
      do LRK=1,NORB_DZ
        if (LRK == LRI) cycle
        if (LRK == LRJ) cycle
        call Drl_BL_EXT_AR_NEW(LIN,LRK,LRA)
      end do
    end if
  end do
end do

return

end subroutine SS_DRL_ACT_BL_SGT0

subroutine SS_ARBL_ACT_BL_SGT0(LIN,LRA)
!=======================================================================
! SS(1)    ACT -BL-
! SS(1-1)  Ar(01)-Bl(32)-
! SS(1-3)  Ar(13)-Bl(20)-
! SS(1-6)  (11)-Ar(23)-Bl(32)-
! SS(1-7)  Ar(13)-C'(21)-Bl(32)-
! SS(1-8)  Ar(13)-C'(22)-Bl(31)-
! SS(1-9)  Ar(23)-C'(11)-Bl(32)-
! SS(1-11) Ar(13)-Bl(31)-C"(22)-
! SS(1-12) Ar(13)-Bl(32)-C"(21)-
! SS(1-13) Ar(23)-Bl(31)-C"(12)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0ss1, w0ss11, w0ss12, w0ss13, w0ss3, w0ss6, w0ss7, w0ss8, w0ss9, w1ss1, w1ss11, w1ss12, w1ss13, w1ss3, w1ss6, &
                 w1ss7, w1ss8, w1ss9
integer(kind=iwp), external :: iwalk_ad

JMLR = Mul(JML,JMR)
ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JMLR) cycle
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    intpos = INTIND_IJKA(IJK)
    !-------------------------------------------------------------------
    W0SS1 = W0_SS(1)
    W1SS1 = W1_SS(1)
    W0SS3 = W0_SS(3)
    W1SS3 = W1_SS(3)
    W0SS6 = W0_SS(6)
    W1SS6 = W1_SS(6)
    W0SS7 = W0_SS(7)
    W1SS7 = W1_SS(7)
    W0SS8 = W0_SS(8)
    W1SS8 = W1_SS(8)
    W0SS9 = W0_SS(9)
    W1SS9 = W1_SS(9)
    W0SS11 = W0_SS(11)
    W1SS11 = W1_SS(11)
    W0SS12 = W0_SS(12)
    W1SS12 = W1_SS(12)
    W0SS13 = W0_SS(13)
    W1SS13 = W1_SS(13)
    NI = mod(LRJ-LRI,2)
    if (NI == 0) then
      W0SS1 = -W0SS1
      W1SS1 = -W1SS1
      W0SS3 = -W0SS3
      W1SS3 = -W1SS3
      W0SS6 = -W0SS6
      W1SS6 = -W1SS6
      W0SS7 = -W0SS7
      W1SS7 = -W1SS7
      W0SS8 = -W0SS8
      W1SS8 = -W1SS8
      W0SS9 = -W0SS9
      W1SS9 = -W1SS9
      W0SS11 = -W0SS11
      W1SS11 = -W1SS11
      W0SS12 = -W0SS12
      W1SS12 = -W1SS12
      W0SS13 = -W0SS13
      W1SS13 = -W1SS13
    end if
    ! SS(1-1)  Ar(01)-Bl(32)-
    if (JML == 1) then
      IWDL = JUST(LRI,LRI)
      IWDR = JUST(LRJ,LRI)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS1
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS1
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end if
    ! SS(1-3)  Ar(13)-Bl(20)-
    if (JMR == 1) then
      IWDL = JUST(LRJ,LRI)
      IWDR = JUST(LRJ,LRJ)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS3
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS3
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end if
    !-------------------------------------------------------------------
    ! SS(1-6)  (11)-Ar(23)-Bl(32)-
    do LRK=NORB_FRZ+1,LRI-1
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      IWDL = JUST(LRI,LRK)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS6
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS6
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end do
    !-------------------------------------------------------------------
    ! SS(1-7)  Ar(13)-C'(21)-Bl(32)-
    do LRK=LRI+1,LRJ-1
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SS7
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SS7
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      ! SS(1-8)  Ar(13)-C'(22)-Bl(31)-
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SS8
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SS8
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      ! SS(1-9)  Ar(23)-C'(11)-Bl(32)-
      IWDL = JUST(LRI,LRK)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SS9
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SS9
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end do
    !-------------------------------------------------------------------
    ! SS(1-11) Ar(13)-Bl(31)-C"(22)-
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS11
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS11
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      ! SS(1-12) Ar(13)-Bl(32)-C"(21)-
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS12
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS12
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      ! SS(1-13) Ar(23)-Bl(31)-C"(12)-
      IWDL = JUST(LRI,LRK)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS13
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS13
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end do
    !-------------------------------------------------------------------
  end do
end do

return

end subroutine SS_ARBL_ACT_BL_SGT0

subroutine ST_ARBL_ACT_BL_SGT0(LIN,LRA)
!***********************************************************************
! ST(2-3) Ar(13)-C'(22)-Bl(32)-
! ST(2-3) Ar(13)-Bl(32)-C'(22)-
!***********************************************************************

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1st3
integer(kind=iwp), external :: iwalk_ad

JMLR = Mul(JML,JMR)
ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JMLR) cycle

    W1ST3 = W1_ST(3)
    NI = mod(LRJ-LRI,2)
    if (NI == 0) W1ST3 = -W1ST3

    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    intpos = INTIND_IJKA(IJK)
    !-------------------------------------------------------------------
    ! ST(2-3) Ar(13)-C'(22)-Bl(32)-
    do LRK=LRI+1,LRJ-1
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = Zero
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1ST3
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end do
    ! ST(2-3) Ar(13)-Bl(32)-C'(22)-
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = Zero
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST3
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end do
  end do
end do

return

end subroutine ST_ARBL_ACT_BL_SGT0

subroutine ST_DRL_ACT_BL_SGT0(LIN,LRA)
! ST(2-7) Drl(12)-C"(22)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JML) cycle
    !-------------------------------------------------------------------
    ! ST(2-7) Drl(12)-C"(22)-
    IWDL = JUST(LRJ,LRI)
    IWDR = JUST(LRI,LRJ)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(7)
    end do
    call Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
  end do
end do

return

end subroutine ST_DRL_ACT_BL_SGT0

subroutine TS_ARBL_ACT_BL_SGT0(LIN,LRA)
!=======================================================================
! TS(3) A&R-B^L-  ACT -B&L ............................................
! TS(3-3) Ar(23)-Bl(31)-C"(22)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_ts
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1ts3
integer(kind=iwp), external :: iwalk_ad

JMLR = Mul(JML,JMR)
ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JMLR) cycle
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    intpos = INTIND_IJKA(IJK)
    !-------------------------------------------------------------------
    W1TS3 = W1_TS(3)
    NI = mod(LRJ-LRI,2)
    if (NI == 0) then
      W1TS3 = -W1TS3
    end if
    ! TS(3-3) Ar(23)-Bl(31)-C"(22)-
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TS3
    end do
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      IWDL = JUST(LRI,LRK)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end do
  end do
end do

return

end subroutine TS_ARBL_ACT_BL_SGT0

subroutine STT_ARBL_ACT_BL_SGT1(LIN,LRA)
!=======================================================================
! STT(4) A&R-B^L-  ACT -B&L ............................................
! ST1(4-1) Ar(01)-Bl(31)-
! ST1(4-2) Ar(23)-Bl(31)-
! ST1(4-3) Ar(13)-C'(21)-Bl(31)-
! ST1(4-3) Ar(13)-Bl(31)-C"(21)-
! ST1(4-4) Ar(23)-C'(11)-Bl(31)-
! ST1(4-4) Ar(23)-Bl(31)-C"(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl
real(kind=wp) :: w1st1, w1st2, w1st3, w1st4
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    W1ST1 = W1_ST1(1)
    W1ST2 = W1_ST1(2)
    W1ST3 = W1_ST1(3)
    W1ST4 = W1_ST1(4)
    if (mod(LRJ-LRI,2) == 0) then
      W1ST1 = -W1ST1
      W1ST2 = -W1ST2
      W1ST3 = -W1ST3
      W1ST4 = -W1ST4
    end if
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ) !???
    intpos = INTIND_IJKA(IJK)                         !???
    ! ST1(4-1) Ar(01)-Bl(31)-
    ! ST1(4-2) Ar(23)-Bl(31)-
    if ((JML == 1) .and. (JMR == LMIJ)) then
      IWDL = JUST(LRI,LRI)
      IWDR = JUST(LRI,LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = Zero
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST1
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end if
    ! ST1(4-2) (11)Ar(23)-Bl(31)-
    do LRK=NORB_FRZ+1,LRI-1
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMK,LMI)) .and. (JMR == Mul(LMK,LMJ))) then
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRK,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST2
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
    ! ST1(4-3) Ar(13)-C'(21)-Bl(31)-
    do LRK=LRI+1,LRJ-1
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMI,LMK)) .and. (JMR == Mul(LMK,LMJ))) then
        IWDL = JUST(LRK,LRI)
        IWDR = JUST(LRK,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1ST3
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ! ST1(4-4) Ar(23)-C'(11)-Bl(31)-
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRK,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1ST4
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
    ! ST1(4-3) Ar(13)-Bl(31)-C"(21)-
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMI,LMK)) .and. (JMR == Mul(LMJ,LMK))) then
        IWDL = JUST(LRK,LRI)
        IWDR = JUST(LRJ,LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST3
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ! ST1(4-4) Ar(23)-Bl(31)-C"(11)-
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRJ,LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST4
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
  end do
end do

return

end subroutine STT_ARBL_ACT_BL_SGT1

subroutine TTS_ARBL_ACT_BL_SGT1(LIN,LRA)
!=======================================================================
! TTS(5) A&R-B^L-  ACT -B&L ............................................
! T1S(5-1)   Ar(13)-Bl(10)-
! T1S(5-2)   (11)Ar(13)-Bl(32)-
! T1S(5-2)   Ar(13)-C'(11)-Bl(32)-
! T1S(5-3)   Ar(13)-Bl(31)-C"(12)-
! T1S(5-4)   Ar(13)-Bl(32)-C"(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl
real(kind=wp) :: w1ts1, w1ts2, w1ts3, w1ts4
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    W1TS1 = W1_T1S(1)
    W1TS2 = W1_T1S(2)
    W1TS3 = W1_T1S(3)
    W1TS4 = W1_T1S(4)
    if (mod(LRJ-LRI,2) == 0) then
      W1TS1 = -W1TS1
      W1TS2 = -W1TS2
      W1TS3 = -W1TS3
      W1TS4 = -W1TS4
    end if
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ) !???
    intpos = INTIND_IJKA(IJK)                         !???
    ! T1S(5-1)   Ar(13)-Bl(10)-
    if ((JMR == 1) .and. (JML == LMIJ)) then
      IWDL = JUST(LRI,LRJ)
      IWDR = JUST(LRJ,LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = Zero
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TS1
      end do
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end if
    ! T1S(5-2)   (11)Ar(13)-Bl(32)-
    do LRK=NORB_FRZ+1,LRI-1
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMK,LMI)) .and. (JMR == Mul(LMK,LMJ))) then
        IWDL = JUST(LRK,LRI)
        IWDR = JUST(LRJ,LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TS2
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
    ! T1S(5-2)   Ar(13)-C'(11)-Bl(32)-
    do LRK=LRI+1,LRJ-1
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMI,LMK)) .and. (JMR == Mul(LMK,LMJ))) then
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRJ,LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1TS2
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
    ! T1S(5-3)   Ar(13)-Bl(31)-C"(12)-
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMI,LMK)) .and. (JMR == Mul(LMJ,LMK))) then
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRK,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TS3
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ! T1S(5-4)   Ar(13)-Bl(32)-C"(11)-
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRJ,LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TS4
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
  end do
end do

return

end subroutine TTS_ARBL_ACT_BL_SGT1

subroutine TTS_Drl_ACT_BL_SGT1(LIN,LRA)
! T1S(5-5)   (11)Drl(12)-
! T1S(5-6)   Drl(12)-C"(12)-
! T1S(5-7)   Drl(12)-C"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    if ((JML /= Mul(LMI,LMJ)) .or. (JMR /= Mul(LMI,LMJ))) cycle
    ! T1S(5-5)   (11)Drl(12)-
    IWDL = JUST(LRI,LRJ)
    IWDR = JUST(LRJ,LRI)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_T1S(5)
    end do
    call Drl_BL_EXT_AR_NEW(LIN,LRJ,LRA)
    ! T1S(5-6)   Drl(11)-C"(12)-
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_T1S(6)
    end do
    call Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
    ! T1S(5-7)   Drl(12)-C"(11)-
    IWDL = JUST(LRI,LRJ)
    IWDR = IWDL
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_T1S(7)
    end do
    call Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
  end do
end do

return

end subroutine TTS_Drl_ACT_BL_SGT1

subroutine SDD_ABB_ACT_C_SGT0(LIN)
!SD1(8-5)    Ar(13)-Br(23)-BR(31)-
!SD1(8-6)    Ar(23)-Br(13)-BR(31)-
!SD1(8-7)    Ar(13)-Bl(31)-BL(23)-
!SD1(8-8)    Ar(23)-Bl(31)-BL(13)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_sd1, w1_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0sd5, w0sd6, w0sd7, w0sd8, w1sd5, w1sd6, w1sd7, w1sd8
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      W0SD5 = W0_SD1(5)
      W1SD5 = W1_SD1(5)
      W0SD6 = W0_SD1(6)
      W1SD6 = W1_SD1(6)
      W0SD7 = W0_SD1(7)
      W1SD7 = W1_SD1(7)
      W0SD8 = W0_SD1(8)
      W1SD8 = W1_SD1(8)
      NI = mod(LRJ-LRI+NORB_DZ-LRK,2)
      if (NI == 0) then
        W0SD5 = -W0SD5
        W1SD5 = -W1SD5
        W0SD6 = -W0SD6
        W1SD6 = -W1SD6
        W0SD7 = -W0SD7
        W1SD7 = -W1SD7
        W0SD8 = -W0SD8
        W1SD8 = -W1SD8
      end if
      IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRK-NORB_FRZ)
      INTPOS = INTIND_IJKA(IJK)

      if ((JML == LMIJ) .and. (JMR == LMK)) then
        ! SD1(8-5)    Ar(13)-Br(23)-BR(31)-
        IWDL = JUST(LRJ,LRI)
        IWDR = JUD(LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD5
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD5
        end do
        call Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)
        ! SD1(8-6)    Ar(23)-Br(13)-BR(31)-
        IWDL = JUST(LRI,LRJ)
        IWDR = JUD(LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD6
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD6
        end do
        call Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)
      end if
      ! SD1(8-7)    Ar(13)-Bl(31)-BL(23)-
      if ((JML == Mul(LMI,LMK)) .and. (JMR == LMJ)) then
        IWDL = JUST(LRK,LRI)
        IWDR = JUD(LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD7
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD7
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ! SD1(8-8)    Ar(23)-Bl(31)-BL(13)-
        IWDL = JUST(LRI,LRK)
        IWDR = JUD(LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD8
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD8
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
  end do
end do

return

end subroutine SDD_ABB_ACT_C_SGT0

subroutine SDD_DrlBl_ACT_C_SGT0(LIN)
! SD1(8-9)  Drl(33)-BL(01)-
! SD1(8-10) Drl(11)-BL(23)-
! SD1(8-11) (11)Drl(33)-BL(23)-
! SD1(8-11) Drl(33)-C"(11)-BL(23)-
! SD1(8-12) Drl(33)-BL(13)-C'(21)-
! SD1(8-13) Drl(33)-BL(23)-C'(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd1, w1_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lri, lrj, lrk, mpl
real(kind=wp) :: w0sd10, w0sd11, w0sd12, w0sd13, w0sd9, w1sd10, w1sd11, w1sd12, w1sd13, w1sd9
integer(kind=iwp), external :: iwalk_ad

do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  if ((JML /= 1) .or. (JMR /= LMI)) cycle
  W0SD9 = W0_SD1(9)
  W1SD9 = W1_SD1(9)
  if (mod(NORB_DZ-LRI,2) == 1) then
    W0SD9 = -W0SD9
    W1SD9 = -W1SD9
  end if
  do LRK=1,LRI-1
    ! SD1(8-9)    Drl(33)-BL(01)-
    IWDL = JUST(LRI,LRI)
    IWDR = JUD(LRI)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD9
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD9
    end do
    call Drl_BL_EXT_AR_NEW(LIN,LRK,LRI)
  end do
end do
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    W0SD10 = W0_SD1(10)
    W1SD10 = W1_SD1(10)
    W0SD11 = W0_SD1(11)
    W1SD11 = W1_SD1(11)
    W0SD12 = W0_SD1(12)
    W1SD12 = W1_SD1(12)
    W0SD13 = W0_SD1(13)
    W1SD13 = W1_SD1(13)
    if (mod(NORB_DZ-LRJ,2) == 1) then
      W0SD10 = -W0SD10
      W1SD10 = -W1SD10
      W0SD11 = -W0SD11
      W1SD11 = -W1SD11
    end if
    if (mod(NORB_DZ-LRI,2) == 1) then
      W0SD12 = -W0SD12
      W1SD12 = -W1SD12
      W0SD13 = -W0SD13
      W1SD13 = -W1SD13
    end if
    ! SD1(8-10) Drl(11)-BL(23)-
    if ((JML == Mul(LMI,LMJ)) .and. (JMR == LMI)) then
      IWDL = JUST(LRJ,LRI)
      IWDR = JUD(LRI)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD10
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD10
      end do
      call Drl_BL_EXT_AR_NEW(LIN,LRI,LRJ)
    end if
    do LRK=1,LRI-1
      LMK = LSM_INN(LRK)
      ! SD1(8-12) Drl(33)-BL(13)-C'(21)-
      if ((JML == Mul(LMI,LMJ)) .and. (JMR == LMJ)) then
        IWDL = JUST(LRJ,LRI)
        IWDR = JUD(LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SD12
          VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SD12
        end do
        call Drl_BL_EXT_AR_NEW(LIN,LRK,LRI)
        ! SD1(8-13) Drl(33)-BL(23)-C'(11)-
        IWDL = JUST(LRI,LRJ)
        IWDR = JUD(LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SD13
          VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SD13
        end do
        call Drl_BL_EXT_AR_NEW(LIN,LRK,LRI)
      end if
      if ((JML == Mul(LMI,LMJ)) .and. (JMR == LMI)) then
        ! SD1(8-11) Drl(33)-C"(11)-BL(23)-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD11
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD11   !?????????
        end do
        IWDL = JUST(LRJ,LRI)
        IWDR = JUD(LRI)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        call Drl_BL_EXT_AR_NEW(LIN,LRK,LRJ)
      end if
    end do
    do LRK=NORB_FRZ+1,LRI-1
      LMK = LSM_INN(LRK)
      ! SD1(8-11) (11)Drl(33)-BL(23)-
      if ((JML == Mul(LMK,LMJ)) .and. (JMR == LMK)) then
        IWDL = JUST(LRJ,LRK)
        IWDR = JUD(LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD11
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD11
        end do
        call Drl_BL_EXT_AR_NEW(LIN,LRI,LRJ)
      end if
    end do
  end do
end do

return

end subroutine SDD_DrlBl_ACT_C_SGT0

subroutine SDD_DrrBR_ACT_C_SGT0(LIN)
! SD1(8-9)    Drr(03)-BR(31)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, w0_sd1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmj, lri, lrj, mpl
real(kind=wp) :: w0sd
integer(kind=iwp), external :: iwalk_ad

do LRI=NORB_FRZ+1,NORB_DZ
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    if ((JML /= 1) .or. (JMR /= LMJ)) cycle
    W0SD = W0_SD1(9)
    if (mod(NORB_DZ-LRJ,2) == 1) W0SD = -W0SD
    IWDL = JUST(LRI,LRI)
    IWDR = JUD(LRJ)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD
      VPLP_W1(MPL) = Zero
    end do
    call Drr_BR_EXT_AR(LIN,LRI,LRJ)
  end do
end do

return

end subroutine SDD_DrrBR_ACT_C_SGT0

subroutine SDD_Ar_ACT_BrBR_SGT0(LIN,LRA)
! SD1(8-1)    Ar(01)-
! SD1(8-2)    Ar(23)-
! SD1(8-3)    Ar(13)-C'(21)-
! SD1(8-4)    Ar(23)-C'(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd1, &
                         w1_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd3, w0sd4, w1sd1, w1sd2, w1sd3, w1sd4
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  W0SD1 = W0_SD1(1)
  W1SD1 = W1_SD1(1)
  W0SD2 = W0_SD1(2)
  W1SD2 = W1_SD1(2)
  W0SD3 = W0_SD1(3)
  W1SD3 = W1_SD1(3)
  W0SD4 = W0_SD1(4)
  W1SD4 = W1_SD1(4)
  NI = mod(NORB_DZ-LRI,2)
  if (NI == 1) then
    W0SD1 = -W0SD1
    W1SD1 = -W1SD1
    W0SD2 = -W0SD2
    W1SD2 = -W1SD2
    W0SD3 = -W0SD3
    W1SD3 = -W1SD3
    W0SD4 = -W0SD4
    W1SD4 = -W1SD4
  end if
  ! SD1(8-1)    Ar(01)-
  if ((JML == 1) .and. (JMR == LMI)) then
    IWDL = JUST(LRI,LRI)
    IWDR = JUD(LRI)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD1
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD1
    end do
    IJK = LRI-NORB_FRZ+LRA
    INTPOS = INTIND_IJKA(IJK)
    call Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)
  end if
  do LRJ=NORB_FRZ+1,LRI-1
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (JML /= LMIJ) cycle
    if (JMR == LMJ) then
      ! SD1(8-2)    (11)Ar(23)-
      IWDL = JUST(LRI,LRJ)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD2
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD2
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)
    end if
  end do
  ! SD1(8-3)    Ar(13)-C'(21)-
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (JML /= LMIJ) cycle
    if (JMR == LMJ) then
      IWDL = JUST(LRJ,LRI)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SD3
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SD3
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)
      ! SD1(8-4)    Ar(23)-C'(11)-
      IWDL = JUST(LRI,LRJ)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SD4
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SD4
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)
    end if
  end do
end do

return

end subroutine SDD_Ar_ACT_BrBR_SGT0

subroutine SDD_Ar_ACT_BlBL_SGT0(LIN,LRA)
! SD1(8-1)    Ar(01)-
! SD1(8-2)    Ar(23)-
! SD1(8-3)    Ar(13)-C'(21)-
! SD1(8-4)    Ar(23)-C'(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd1, &
                         w1_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd3, w0sd4, w1sd1, w1sd2, w1sd3, w1sd4
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  W0SD1 = W0_SD1(1)
  W1SD1 = W1_SD1(1)
  W0SD2 = W0_SD1(2)
  W1SD2 = W1_SD1(2)
  W0SD3 = W0_SD1(3)
  W1SD3 = W1_SD1(3)
  W0SD4 = W0_SD1(4)
  W1SD4 = W1_SD1(4)
  NI = mod(NORB_DZ-LRI,2)
  if (NI == 1) then
    W0SD1 = -W0SD1
    W1SD1 = -W1SD1
    W0SD2 = -W0SD2
    W1SD2 = -W1SD2
    W0SD3 = -W0SD3
    W1SD3 = -W1SD3
    W0SD4 = -W0SD4
    W1SD4 = -W1SD4
  end if
  ! SD1(8-1)    Ar(01)-
  if ((JML == 1) .and. (JMR == LMI)) then
    IWDL = JUST(LRI,LRI)
    IWDR = JUD(LRI)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD1
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD1
    end do
    IJK = LRI-NORB_FRZ+LRA
    INTPOS = INTIND_IJKA(IJK)
    call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
  end if
  do LRJ=NORB_FRZ+1,LRI-1
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (JML /= LMIJ) cycle
    if (JMR == LMJ) then
      ! SD1(8-2)    (11)Ar(23)-
      IWDL = JUST(LRI,LRJ)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD2
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SD2
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end if
  end do
  ! SD1(8-3)    Ar(13)-C'(21)-
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (JML /= LMIJ) cycle
    if (JMR == LMJ) then
      IWDL = JUST(LRJ,LRI)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SD3
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SD3
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      ! SD1(8-4)    Ar(23)-C'(11)-
      IWDL = JUST(LRI,LRJ)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SD4
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SD4
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end if
  end do
end do

return

end subroutine SDD_Ar_ACT_BlBL_SGT0

subroutine DDS_ABB_ACT_C_SGT0(LIN)
! D1S(9-2)    Ar(13)-Bl(31)-BR(32)-
! D1S(9-3)    Ar(13)-Bl(32)-BR(31)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_d1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1ds2, w1ds3
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      W1DS2 = W1_D1S(2)
      W1DS3 = W1_D1S(3)
      NI = mod(LRJ-LRI+NORB_DZ-LRK,2)
      if (NI == 1) then
        W1DS2 = -W1DS2
        W1DS3 = -W1DS3
      end if
      IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRK-NORB_FRZ)
      INTPOS = INTIND_IJKA(IJK)
      ! D1S(9-2)    Ar(13)-Bl(31)-BR(32)-
      if ((JML == LMI) .and. (JMR == Mul(LMJ,LMK))) then
        IWDL = JUD(LRI)
        IWDR = JUST(LRK,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DS2
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ! D1S(9-3)    Ar(13)-Bl(32)-BR(31)-
        IWDL = JUD(LRI)
        IWDR = JUST(LRJ,LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DS3
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
  end do
end do

return

end subroutine DDS_ABB_ACT_C_SGT0

subroutine TTTT_Drl_ACT_BL_SGT1(LIN,LRA)
! T1T1(12-2)  (11)Drl(11)-
! T1T1(12-2)  Drl(11)-C"(11)-
! T1T1(12-3)  (11)Drl(33)-
! T1T1(12-3)  (11)Drl(33)-C"(11)-
! T1T1(12-3)  Drl(33)-C"(11)-C"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1t1, w1_t1t1
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

if (JML /= JMR) return
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (JML /= LMIJ) cycle
    ! T1T1(12-2)  (11)Drl(11)-
    ! T1T1(12-2)  Drl(11)-C"(11)-
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_T1T1(2)
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_T1T1(2)
    end do
    IWDL = JUST(LRI,LRJ)
    IWDR = IWDL
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    call Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
    call Drl_BL_EXT_AR_NEW(LIN,LRJ,LRA)
    ! T1T1(12-3)  (11)Drl(33)-
    ! T1T1(12-3)  (11)Drl(33)-C"(11)-
    ! T1T1(12-3)  Drl(33)-C"(11)-C"(11)-
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_T1T1(3)
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_T1T1(3)
    end do
    if (LRA > NORB_DZ) then
      call Drl_BL_SUM_AR_new(LIN,LRI,LRJ,LRA)
    else
      do LRK=1,NORB_DZ
        if (LRK == LRI) cycle
        if (LRK == LRJ) cycle
        call Drl_BL_EXT_AR_NEW(LIN,LRK,LRA)
      end do
    end if
  end do
end do

return

end subroutine TTTT_Drl_ACT_BL_SGT1

subroutine TTTT_ArBl_ACT_BL_SGT1(LIN,LRA)
! T1T1(12-1)  (11)Ar(13)-Bl(31)-
! T1T1(12-1)  Ar(13)-C'(11)-Bl(31)-
! T1T1(12-1)  Ar(13)-Bl(31)-C"(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_t1t1, w1_t1t1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lri, lrj, lrk, mpl
real(kind=wp) :: w0tt1, w1tt1
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    W0TT1 = W0_T1T1(1)
    W1TT1 = W1_T1T1(1)
    if (mod(LRJ-LRI,2) == 0) then
      W0TT1 = -W0TT1
      W1TT1 = -W1TT1
    end if
    do LRK=NORB_FRZ+1,LRI-1
      LMK = LSM_INN(LRK)
      ! T1T1(12-1)  (11)Ar(13)-Bl(31)-
      if ((JML == Mul(LMK,LMI)) .and. (JMR == Mul(LMK,LMJ))) then
        IWDL = JUST(LRK,LRI)
        IWDR = JUST(LRK,LRJ)
        IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
        INTPOS = INTIND_IJKA(IJK)
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT1
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TT1
        end do
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMI,LMk)) .and. (JMR == Mul(LMJ,LMK))) then
        ! T1T1(12-1)  Ar(13)-Bl(31)-C"(11)-
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRJ,LRK)
        IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
        INTPOS = INTIND_IJKA(IJK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT1
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TT1
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
    do LRK=LRI+1,LRJ-1
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMI,LMK)) .and. (JMR == Mul(LMK,LMJ))) then
        ! T1T1(12-1)  Ar(13)-C'(11)-Bl(31)-
        IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
        INTPOS = INTIND_IJKA(IJK)
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRK,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0TT1
          VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1TT1
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
  end do
end do

return

end subroutine TTTT_ArBl_ACT_BL_SGT1

subroutine TTDD_DrlBL_ACT_C_SGT1(LIN)
! T1D1(15-4)  Drl(11)-BL(13)-
! T1D1(15-5)  (11)Drl(33)-BL(13)-
! T1D1(15-5)  Drl(33)-C"(11)-BL(13)-
! T1D1(15-5)  Drl(33)-BL(13)-C'(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1d1, w1_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, lrk, mpl
real(kind=wp) :: w0td4, w0td5, w1td4, w1td5
integer(kind=iwp), external :: iwalk_ad

do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    if ((JML == Mul(LMI,LMJ)) .and. (JMR == LMI)) then
      IWDL = JUST(LRI,LRJ)
      IWDR = JUD(LRI)
      W0TD4 = W0_T1D1(4)
      W1TD4 = W1_T1D1(4)
      W0TD5 = W0_T1D1(5)
      W1TD5 = W1_T1D1(5)
      if (mod(NORB_DZ-LRJ,2) == 1) then
        W0TD4 = -W0TD4
        W1TD4 = -W1TD4
        W0TD5 = -W0TD5
        W1TD5 = -W1TD5
      end if
      ! T1D1(15-4)  Drl(11)-BL(13)-
      ! T1D1(15-5)  (11)Drl(33)-BL(13)-
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TD4
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TD4
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      call Drl_BL_EXT_AR_NEW(LIN,LRI,LRJ)

      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TD5
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TD5
      end do
      do LRK=1,LRI-1
        ! T1D1(15-5)  Drl(33)-C"(11)-BL(13)-
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        call Drl_BL_EXT_AR_NEW(LIN,LRK,LRJ)
      end do
      ! T1D1(15-5)  (11)Drl(33)-BL(13)-
      do LRK=LRI+1,LRJ-1
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        call Drl_BL_EXT_AR_NEW(LIN,LRK,LRJ)
      end do
    end if
    W0TD5 = W0_T1D1(5)
    W1TD5 = W1_T1D1(5)
    if (mod(NORB_DZ-LRI,2) == 0) then
      W0TD5 = -W0TD5
      W1TD5 = -W1TD5
    end if
    if ((JML == Mul(LMI,LMJ)) .and. (JMR == LMJ)) then
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TD5
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TD5
      end do
      ! T1D1(15-5)  Drl(33)-BL(13)-C'(11)-
      do LRK=1,LRI-1
        IWDL = JUST(LRI,LRJ)
        IWDR = JUD(LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        call Drl_BL_EXT_AR_NEW(LIN,LRK,LRI)
      end do
    end if
  end do
end do

return

end subroutine TTDD_DrlBL_ACT_C_SGT1

subroutine TTDD_ABB_ACT_C_SGT1(LIN)
! T1D1(15-2)  Ar(13)-Br(13)-BR(31)-
! T1D1(15-3)  Ar(13)-Bl(31)-Bl(13)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_t1d1, w1_t1d1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0td3, w1td2, w1td3
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      W1TD2 = W1_T1D1(2)
      W0TD3 = W0_T1D1(3)
      W1TD3 = W1_T1D1(3)
      NI = mod(LRJ-LRI+NORB_DZ-LRK,2)
      if (NI == 0) then
        W1TD2 = -W1TD2
        W0TD3 = -W0TD3
        W1TD3 = -W1TD3
      end if
      IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRK-NORB_FRZ)
      INTPOS = INTIND_IJKA(IJK)
      if ((JML == Mul(LMI,LMJ)) .and. (JMR == LMK)) then
        ! T1D1(15-2)  Ar(13)-Br(13)-BR(31)-
        IWDL = JUST(LRI,LRJ)
        IWDR = JUD(LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TD2
        end do
        call Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)
      end if
      if ((JML == Mul(LMI,LMK)) .and. (JMR == LMJ)) then
        ! T1D1(15-3)  Ar(13)-Bl(31)-Bl(13)-
        IWDL = JUST(LRI,LRK)
        IWDR = JUD(LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TD3
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TD3
        end do
        call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
  end do
end do

return

end subroutine TTDD_ABB_ACT_C_SGT1

subroutine TTDD_Ar_ACT_BrBR_SGT0(LIN,LRA)
! T1D1(15-1)  (11)Ar(13)-
! T1D1(15-1)  Ar(13)-C'(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1d1, &
                         w1_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
real(kind=wp) :: w0td1, w1td1
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  W0TD1 = W0_T1D1(1)
  W1TD1 = W1_T1D1(1)
  if (mod(NORB_DZ-LRI,2) == 1) then
    W0TD1 = -W0TD1
    W1TD1 = -W1TD1
  end if
  do LRJ=NORB_FRZ+1,LRI-1
    ! T1D1(15-1)  (11)Ar(13)-
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if ((JML == LMIJ) .and. (JMR == LMJ)) then
      IWDL = JUST(LRJ,LRI)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TD1
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TD1
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)
    end if
  end do
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    ! T1D1(15-1)  Ar(13)-C'(11)-
    if ((JML == LMIJ) .and. (JMR == LMJ)) then
      IWDL = JUST(LRI,LRJ)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0TD1
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1TD1
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)
    end if
  end do
end do

return

end subroutine TTDD_Ar_ACT_BrBR_SGT0

subroutine TTDD_Ar_ACT_BlBL_SGT0(LIN,LRA)
! T1D1(15-1)  (11)Ar(13)-
! T1D1(15-1)  Ar(13)-C'(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1d1, &
                         w1_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
real(kind=wp) :: w0td1, w1td1
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  W0TD1 = W0_T1D1(1)
  W1TD1 = W1_T1D1(1)
  if (mod(NORB_DZ-LRI,2) == 1) then
    W0TD1 = -W0TD1
    W1TD1 = -W1TD1
  end if
  do LRJ=NORB_FRZ+1,LRI-1
    ! T1D1(15-1)  (11)Ar(13)-
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if ((JML == LMIJ) .and. (JMR == LMJ)) then
      IWDL = JUST(LRJ,LRI)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TD1
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TD1
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end if
  end do
  do LRJ=LRI+1,NORB_DZ
    ! T1D1(15-1)  Ar(13)-C'(11)-
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if ((JML == LMIJ) .and. (JMR == LMJ)) then
      IWDL = JUST(LRI,LRJ)
      IWDR = JUD(LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0TD1
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1TD1
      end do
      IJK = LRI-NORB_FRZ+LRA
      INTPOS = INTIND_IJKA(IJK)
      call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
    end if
  end do
end do

return

end subroutine TTDD_Ar_ACT_BlBL_SGT0

subroutine TTV_ArBr_ACT_C_SGT1(LIN,LRA)
! T1V(18) Ar(13)-Br(13)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1v
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
real(kind=wp) :: w1tv1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if ((JML /= LMIJ) .or. (JMR /= 1)) cycle
    W1TV1 = W1_T1V
    if (mod(LRJ-LRI,2) == 0) W1TV1 = -W1TV1
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    INTPOS = INTIND_IJKA(IJK)
    IWDL = JUST(LRI,LRJ)
    IWDR = 0
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TV1
    end do
    call Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)
  end do
end do

return

end subroutine TTV_ArBr_ACT_C_SGT1

subroutine DDDD_ArBl_ACT_BL_SGT0(LIN,LRA)
! D1D1(20-1) Ar(13)-BL(31)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d1, &
                         w1_d1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, mpl
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    if ((JML /= LMI) .or. (JMR /= LMJ)) cycle
    W0DD1 = W0_D1D1(1)
    W1DD1 = W1_D1D1(1)
    if (mod(LRJ-LRI,2) == 0) then
      W0DD1 = -W0DD1
      W1DD1 = -W1DD1
    end if
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    INTPOS = INTIND_IJKA(IJK)
    IWDL = JUD(LRI)
    IWDR = JUD(LRJ)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD1
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD1
    end do
    call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
  end do
end do

return

end subroutine DDDD_ArBl_ACT_BL_SGT0

subroutine DDDD_Drl_ACT_BL_SGT0(LIN,LRA)
! D1D1(20-2) Drl(11)-
! D1D1(20-3) (11)Drl(33)-
! D1D1(20-3) Drl(33)-C"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d1, w1_d1d1
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

if (JML /= JMR) return
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  if (JML /= LMI) cycle
  ! D1D1(20-2) Drl(11)-
  IWDL = JUD(LRI)
  IWDR = IWDL
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
    LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
  end do
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_D1D1(2)
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_D1D1(2)
  end do
  call Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_D1D1(3)
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_D1D1(3)
  end do
  do LRJ=1,NORB_DZ
    if (LRJ == LRI) cycle
    ! D1D1(20-3) Drl(33)-C"(11)-
    ! D1D1(20-3) (11)Drl(33)-
    call Drl_BL_EXT_AR_NEW(LIN,LRJ,LRA)
  end do
end do

return

end subroutine DDDD_Drl_ACT_BL_SGT0

subroutine DD1_ArBl_ACT_BL_SGT0(LIN,LRA)
! DD1(21) Ar(23)-Bl(31)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_dd1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, mpl
real(kind=wp) :: w1dd1
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    if ((JML /= LMI) .or. (JMR /= LMJ)) cycle
    W1DD1 = W1_DD1
    if (mod(LRJ-LRI,2) == 0) then
      W1DD1 = -W1DD1
    end if
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    INTPOS = INTIND_IJKA(IJK)
    IWDL = JUD(LRI)
    IWDR = JUD(LRJ)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD1
    end do
    call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
  end do
end do

return

end subroutine DD1_ArBl_ACT_BL_SGT0

subroutine D1D_ArBl_ACT_BL_SGT0(LIN,LRA)
! DD1(21) Ar(13)-Bl(32)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_d1d
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, mpl
real(kind=wp) :: w1dd1
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    if ((JML /= LMI) .or. (JMR /= LMJ)) cycle
    W1DD1 = W1_D1D(1)
    if (mod(LRJ-LRI,2) == 0) then
      W1DD1 = -W1DD1
    end if
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    INTPOS = INTIND_IJKA(IJK)
    IWDL = JUD(LRI)
    IWDR = JUD(LRJ)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD1
    end do
    call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
  end do
end do

return

end subroutine D1D_ArBl_ACT_BL_SGT0

subroutine D1D_Drl_ACT_BL_SGT0(LIN,LRA)
! D1D(22-2) Drl(12)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_d1d
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lri, mpl
integer(kind=iwp), external :: iwalk_ad

if (JML /= JMR) return
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  if (JML /= LMI) cycle
  ! D1D(22-2) Drl(12)-
  IWDL = JUD(LRI)
  IWDR = IWDL
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
    LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
  end do
  do MPL=1,MTYPE
    VPLP_W0(MPL) = Zero
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_D1D(2)
  end do
  call Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
end do

return

end subroutine D1D_Drl_ACT_BL_SGT0

subroutine D1V_Drl_BL_ACT_C_SGT0(LIN)
! D1V(24-1)  Ar(13)-
! D1V(24-2)  Drl(33)-BL(13)-

use gugaci_global, only: iml, imr, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, &
                         mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1v
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: isma, iwal, iwar, iwdl, iwdr, lmi, lri, lrj, mpl, ni
real(kind=wp) :: w0
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
if (JMR /= 1) return
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  if (JML /= LMI) cycle
  NI = mod(NORB_DZ-LRI,2)
  ! D1V(24-1)  Ar(13)-
  W0 = W0_D1V(1)
  if (NI == 1) W0 = -W0_D1V(1)
  IWDL = JUD(LRI)
  IWDR = 0
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0
  end do
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
    LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
  end do
  call Ar_DV_EXT_AR(51,isma,LRI,0)   !ar_dv
  ! D1V(24-2)  Drl(33)-BL(13)-
  W0 = W0_D1V(2)
  if (NI == 1) W0 = -W0_D1V(2)
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0
    VPLP_W1(MPL) = Zero
  end do
  do LRJ=1,LRI-1
    call Drl_BL_EXT_AR_NEW(LIN,LRJ,LRI)
  end do
end do

return

end subroutine D1V_Drl_BL_ACT_C_SGT0

subroutine D1V_Ar_ACT_BrBR_SGT0(LIN,LRA)
! D1V(24-1)  Ar(13)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1v, w1_d1v
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lri, mpl
real(kind=wp) :: w0dv1, w1dv1
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  if ((JML /= LMI) .or. (JMR /= 1)) cycle
  W0DV1 = W0_D1V(1)
  W1DV1 = W1_D1V(1)
  if (mod(NORB_DZ-LRI,2) == 1) then
    W0DV1 = -W0_D1V(1)
    W1DV1 = -W1_D1V(1)
  end if
  IJK = LRI-NORB_FRZ+LRA
  INTPOS = INTIND_IJKA(IJK)
  IWDL = JUD(LRI)
  IWDR = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
    LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
  end do
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DV1
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DV1
  end do
  call Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)
end do

return

end subroutine D1V_Ar_ACT_BrBR_SGT0

subroutine D1V_Ar_ACT_BlBL_SGT0(LIN,LRA)
! D1V(24-1)  Ar(13)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1v, w1_d1v
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lri, mpl
real(kind=wp) :: w0dv1, w1dv1
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  if ((JML /= LMI) .or. (JMR /= 1)) cycle
  W0DV1 = W0_D1V(1)
  W1DV1 = W1_D1V(1)
  if (mod(NORB_DZ-LRI,2) == 1) then
    W0DV1 = -W0_D1V(1)
    W1DV1 = -W1_D1V(1)
  end if
  IJK = LRI-NORB_FRZ+LRA
  INTPOS = INTIND_IJKA(IJK)
  IWDL = JUD(LRI)
  IWDR = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
    LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
  end do
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DV1
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DV1
  end do
  call Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
end do

return

end subroutine D1V_Ar_ACT_BlBL_SGT0

!=======================================================
! END OF DV, NEXT VD
!=======================================================

subroutine SS_DRL_ACT_BR_SGT0(LIN,LRA)
! SS(1-16) (11)-Drl(22)-
! SS(1-19) Drl(12)-C"(21)-
! SS(1-20) Drl(33)-C"(11)-C"(22)-
! SS(1-20) (11)Drl(33)-C"(22)-
! SS(1-20) (11)(22)Drl(33)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

if (JML /= JMR) return
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JML) cycle
    ! SS(1-16) (11)-Drl(22)-
    IWDL = JUST(LRJ,LRI)
    IWDR = IWDL
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_SS(16)
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_SS(16)
    end do
    call Drl_BR_EXT_AL_NEW(LIN,LRJ,LRA)
    ! SS(1-18) Drl(11)-C"(22)-
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_SS(18)
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_SS(18)
    end do
    call Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
    ! SS(1-20) Drl(33)-C"(11)-C"(22)-
    ! SS(1-20) (11)Drl(33)-C"(22)-
    ! SS(1-20) (11)(22)Drl(33)-
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_SS(20)
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_SS(20)
    end do
    if (LRA > NORB_DZ) then
      call Drl_BR_SUM_AL_new(LIN,LRI,LRJ,LRA)
    else
      do LRK=1,norb_dz
        if (LRK == LRI) cycle
        if (LRK == LRJ) cycle
        call Drl_BR_EXT_AL_NEW(LIN,LRK,LRA)
      end do
    end if
  end do
end do

return

end subroutine SS_DRL_ACT_BR_SGT0

subroutine SS_S_DRL_ACT_BR_SGT0(LIN,LRA)
! SS(1-19) Drl(12)-C"(21)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

if (JML /= JMR) return
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JML) cycle
    ! SS(1-19) Drl(12)-C"(21)-
    IWDL = JUST(LRJ,LRI)
    IWDR = JUST(LRI,LRJ)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_SS(19)
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_SS(19)
    end do
    call Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
  end do
end do

return

end subroutine SS_S_DRL_ACT_BR_SGT0

subroutine SS_S_DRL_ACT_BL_SGT0(LIN,LRA)
! SS(1-19) Drl(12)-C"(21)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

if (JML /= JMR) return
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JML) cycle
    ! SS(1-19) Drl(12)-C"(21)-
    IWDL = JUST(LRJ,LRI)
    IWDR = JUST(LRI,LRJ)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_SS(19)
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_SS(19)
    end do
    call Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
  end do
end do

return

end subroutine SS_S_DRL_ACT_BL_SGT0

subroutine SS_ARBL_ACT_BR_SGT0(LIN,LRA)
!=======================================================================
! SS(1-1)  Ar(01)-Bl(32)-
! SS(1-3)  Ar(13)-Bl(20)-
! SS(1-6)  (11)-Ar(23)-Bl(32)-
! SS(1-7)  Ar(13)-C'(21)-Bl(32)-
! SS(1-8)  Ar(13)-C'(22)-Bl(31)-
! SS(1-9)  Ar(23)-C'(11)-Bl(32)-
! SS(1-11) Ar(13)-Bl(31)-C"(22)-
! SS(1-12) Ar(13)-Bl(32)-C"(21)-
! SS(1-13) Ar(23)-Bl(31)-C"(12)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0ss1, w0ss11, w0ss12, w0ss13, w0ss3, w0ss6, w0ss7, w0ss8, w0ss9, w1ss1, w1ss11, w1ss12, w1ss13, w1ss3, w1ss6, &
                 w1ss7, w1ss8, w1ss9
integer(kind=iwp), external :: iwalk_ad

JMLR = Mul(JML,JMR)
ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JMLR) cycle
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    intpos = INTIND_IJKA(IJK)
    !-------------------------------------------------------------------
    W0SS1 = W0_SS(1)
    W1SS1 = W1_SS(1)
    W0SS3 = W0_SS(3)
    W1SS3 = W1_SS(3)
    W0SS6 = W0_SS(6)
    W1SS6 = W1_SS(6)
    W0SS7 = W0_SS(7)
    W1SS7 = W1_SS(7)
    W0SS8 = W0_SS(8)
    W1SS8 = W1_SS(8)
    W0SS9 = W0_SS(9)
    W1SS9 = W1_SS(9)
    W0SS11 = W0_SS(11)
    W1SS11 = W1_SS(11)
    W0SS12 = W0_SS(12)
    W1SS12 = W1_SS(12)
    W0SS13 = W0_SS(13)
    W1SS13 = W1_SS(13)
    NI = mod(LRJ-LRI,2)
    if (NI == 0) then
      W0SS1 = -W0SS1
      W1SS1 = -W1SS1
      W0SS3 = -W0SS3
      W1SS3 = -W1SS3
      W0SS6 = -W0SS6
      W1SS6 = -W1SS6
      W0SS7 = -W0SS7
      W1SS7 = -W1SS7
      W0SS8 = -W0SS8
      W1SS8 = -W1SS8
      W0SS9 = -W0SS9
      W1SS9 = -W1SS9
      W0SS11 = -W0SS11
      W1SS11 = -W1SS11
      W0SS12 = -W0SS12
      W1SS12 = -W1SS12
      W0SS13 = -W0SS13
      W1SS13 = -W1SS13
    end if
    !-------------------------------------------------------------------
    ! SS(1-1)  Ar(01)-Bl(32)-
    if (JML == 1) then
      IWDL = JUST(LRI,LRI)
      IWDR = JUST(LRJ,LRI)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS1
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS1
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
    end if
    ! SS(1-3)  Ar(13)-Bl(20)-
    if (JMR == 1) then
      IWDL = JUST(LRJ,LRI)
      IWDR = JUST(LRJ,LRJ)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS3
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS3
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
    end if
    !-------------------------------------------------------------------
    ! SS(1-6)  (11)-Ar(23)-Bl(32)-
    do LRK=NORB_FRZ+1,LRI-1
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      IWDL = JUST(LRI,LRK)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS6
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS6
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
    end do
    !-------------------------------------------------------------------
    do LRK=LRI+1,LRJ-1
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      ! SS(1-7)  Ar(13)-C'(21)-Bl(32)-
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SS7
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SS7
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
      ! SS(1-8)  Ar(13)-C'(22)-Bl(31)-
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SS8
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SS8
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
      ! SS(1-9)  Ar(23)-C'(11)-Bl(32)-
      IWDL = JUST(LRI,LRK)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0SS9
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1SS9
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
    end do
    !-------------------------------------------------------------------
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      ! SS(1-11) Ar(13)-Bl(31)-C"(22)-
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS11
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS11
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
      ! SS(1-12) Ar(13)-Bl(32)-C"(21)-
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS12
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS12
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
      ! SS(1-13) Ar(23)-Bl(31)-C"(12)-
      IWDL = JUST(LRI,LRK)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS13
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS13
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
    end do
    !-------------------------------------------------------------------
  end do
end do

return

end subroutine SS_ARBL_ACT_BR_SGT0

subroutine ST_ARBL_ACT_BR_SGT0(LIN,LRA)
! ST(2-3) Ar(13)-C'(22)-Bl(32)-
! ST(2-3) Ar(13)-Bl(32)-C'(22)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1st3
integer(kind=iwp), external :: iwalk_ad

JMLR = Mul(JML,JMR)
ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JMLR) cycle

    W1ST3 = W1_ST(3)
    NI = mod(LRJ-LRI,2)
    if (NI == 0) then
      W1ST3 = -W1ST3
    end if
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    intpos = INTIND_IJKA(IJK)
    !-------------------------------------------------------------------
    ! ST(2-3) Ar(13)-C'(22)-Bl(32)-
    do LRK=LRI+1,LRJ-1
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = Zero
        VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1ST3
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
    end do
    !-------------------------------------------------------------------
    ! ST(2-3) Ar(13)-Bl(32)-C'(22)-
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      if (Mul(LMK,LMI) /= JML) cycle
      IWDL = JUST(LRK,LRI)
      IWDR = JUST(LRJ,LRK)
      do MPL=1,MTYPE
        VPLP_W0(MPL) = Zero
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST3
      end do
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
    end do
  end do
end do

return

end subroutine ST_ARBL_ACT_BR_SGT0

subroutine ST_DRL_ACT_BR_SGT0(LIN,LRA)
! ST(2-7) Drl(12)-C"(22)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    if (LMIJ /= JML) cycle
    !-------------------------------------------------------------------
    ! ST(2-7) Drl(12)-C"(22)-
    IWDL = JUST(LRJ,LRI)
    IWDR = JUST(LRI,LRJ)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(7)
    end do
    call Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
  end do
end do

return

end subroutine ST_DRL_ACT_BR_SGT0

subroutine TS_ARBL_ACT_BR_SGT0(LIN,LRA)
!=======================================================================
! TS(3) A&R-B^L-  ACT -B&R ............................................
! TS(3-3) Ar(23)-Bl(31)-C"(22)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_ts
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmik, lmj, lmjk, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1ts3
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
    intpos = INTIND_IJKA(IJK)
    !-------------------------------------------------------------------
    W1TS3 = W1_TS(3)
    NI = mod(LRJ-LRI,2)
    if (NI == 0) then
      W1TS3 = -W1TS3
    end if
    !-------------------------------------------------------------------
    ! TS(3-3) Ar(23)-Bl(31)-C"(22)-
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TS3
    end do
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      LMIK = Mul(LMI,LMK)
      LMJK = Mul(LMJ,LMK)
      if ((LMIK /= JML) .or. (LMJK /= JMR)) cycle
      IWDL = JUST(LRI,LRK)
      IWDR = JUST(LRK,LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
    end do
    !-------------------------------------------------------------------
  end do
end do

return

end subroutine TS_ARBL_ACT_BR_SGT0

subroutine STT_ARBL_ACT_BR_SGT1(LIN,LRA)
!=======================================================================
! STT(4) A&R-B^L-  ACT -BR ............................................
! ST1(4-1) Ar(01)-Bl(31)-
! ST1(4-2) Ar(23)-Bl(31)-
! ST1(4-3) Ar(13)-C'(21)-Bl(31)-
! ST1(4-3) Ar(13)-Bl(31)-C"(21)-
! ST1(4-4) Ar(23)-C'(11)-Bl(31)-
! ST1(4-4) Ar(23)-Bl(31)-C"(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl
real(kind=wp) :: w1st1, w1st2, w1st3, w1st4
integer(kind=iwp), external :: iwalk_ad

ISMA = Mul(IML,IMR)
do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    LMIJ = Mul(LMI,LMJ)
    W1ST1 = W1_ST1(1)
    W1ST2 = W1_ST1(2)
    W1ST3 = W1_ST1(3)
    W1ST4 = W1_ST1(4)
    if (mod(LRJ-LRI,2) == 0) then
      W1ST1 = -W1ST1
      W1ST2 = -W1ST2
      W1ST3 = -W1ST3
      W1ST4 = -W1ST4
    end if
    IJK = LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ) !???
    intpos = INTIND_IJKA(IJK)                         !???
    ! ST1(4-1) Ar(01)-Bl(31)-
    ! ST1(4-2) Ar(23)-Bl(31)-
    if ((JML == 1) .and. (JMR == LMIJ)) then
      IWDL = JUST(LRI,LRI)
      IWDR = JUST(LRI,LRJ)
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = Zero
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST1
      end do
      call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
    end if
    ! ST1(4-2) (11)Ar(23)-Bl(31)-
    do LRK=NORB_FRZ+1,LRI-1
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMK,LMI)) .and. (JMR == Mul(LMK,LMJ))) then
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRK,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST2
        end do
        call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
    ! ST1(4-3) Ar(13)-C'(21)-Bl(31)-
    do LRK=LRI+1,LRJ-1
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMI,LMK)) .and. (JMR == Mul(LMK,LMJ))) then
        IWDL = JUST(LRK,LRI)
        IWDR = JUST(LRK,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1ST3
        end do
        call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
        ! ST1(4-4) Ar(23)-C'(11)-Bl(31)-
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRK,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W1ST4
        end do
        call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
    ! ST1(4-3) Ar(13)-Bl(31)-C"(21)-
    do LRK=LRJ+1,NORB_DZ
      LMK = LSM_INN(LRK)
      if ((JML == Mul(LMI,LMK)) .and. (JMR == Mul(LMJ,LMK))) then
        IWDL = JUST(LRK,LRI)
        IWDR = JUST(LRJ,LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST3
        end do
        call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
        ! ST1(4-4) Ar(23)-Bl(31)-C"(11)-
        IWDL = JUST(LRI,LRK)
        IWDR = JUST(LRJ,LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST4
        end do
        call Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
      end if
    end do
  end do
end do

return

end subroutine STT_ARBL_ACT_BR_SGT1

subroutine TTS_Drl_ACT_BR_SGT1(LIN,LRA)
! T1S(5-5)   (11)Drl(12)-
! T1S(5-6)   Drl(12)-C"(12)-
! T1S(5-7)   Drl(12)-C"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

do LRI=NORB_FRZ+1,NORB_DZ
  LMI = LSM_INN(LRI)
  do LRJ=LRI+1,NORB_DZ
    LMJ = LSM_INN(LRJ)
    if ((JML /= Mul(LMI,LMJ)) .or. (JMR /= Mul(LMI,LMJ))) cycle
    ! T1S(5-5)   (11)Drl(12)-
    IWDL = JUST(LRI,LRJ)
    IWDR = JUST(LRJ,LRI)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_T1S(5)
    end do
    call Drl_BR_EXT_AL_NEW(LIN,LRJ,LRA)
    ! T1S(5-6)   Drl(11)-C"(12)-
    IWDL = JUST(LRI,LRJ)
    IWDR = JUST(LRJ,LRI)
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_T1S(6)
    end do
    call Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
    ! T1S(5-7)   Drl(12)-C"(11)-
    IWDL = JUST(LRI,LRJ)
    IWDR = IWDL
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,IPAE,IWAR,IWDR)
    end do
    do MPL=1,MTYPE
      VPLP_W0(MPL) = Zero
      VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_T1S(7)
    end do
    call Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
  end do
end do

return

end subroutine TTS_Drl_ACT_BR_SGT1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine PrBeg(Meth)
!***********************************************************************
!                                                                      *
!     purpose: Print the header to iterations                          *
!                                                                      *
!***********************************************************************

use InfSCF, only: iDummy_run, InVec, jPrint, nD, nIter, nIterP, SCF_FileOrb
use Definitions, only: u6

implicit none
character(len=*), intent(in) :: Meth
character(len=10) :: Label
character(len=4) :: cUHF

if (jPrint < 2) return

write(u6,*)
call CollapseOutput(1,'Convergence information')
iDummy_run = 0
cUHF = '    '
if (nD == 2) cUHF = 'UHF '
Label = Meth(1:10)
if (nIter(nIterP) > 0) then
  write(u6,'(31x,A,A,A)') cUHF,Label,' iterations: Energy and convergence statistics'
  write(u6,*)
  write(u6,'(A,A,A)') 'Iter     Tot. ',Label, &
                      ' One-elec.       Two-elec.     Energy      Max Dij or  Max Fij      DNorm      TNorm      AccCon     Time'
  write(u6,'(A)') '         Energy          Energy          Energy        Change      Delta Norm'// &
                  '                                                in Sec.'
else
  iDummy_run = 1
  write(u6,'(45x,A)') 'No optimization is performed'
  if (InVec == 1) then
    write(u6,'(29x,A)') 'Results refer to orbitals obtained from core diagonalization'
  else if (InVec == 2) then
    write(u6,'(34x,A,A)') 'Results refer to input orbitals read from ',trim(SCF_FileOrb)
  else if (InVec == 3) then
    write(u6,'(34x,A)') 'Results refer to density matrix read from COMOLD'
  end if
end if

end subroutine PrBeg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine TdmTrans(nBas)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "files_qmstat.fh"
#include "qminp.fh"
#include "qm2.fh"
#include "numbers.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension nBas(MxSym)

      Character TDMchar*6

      Logical Exist

*
*--- Sag hej till publiken.
*
      Write(6,*)
      Write(6,*)'     Transforming the transition density matrices.'

*
*--- Inquire if the ToFile is in WorkDir.
*
      Call f_Inquire(RassiM,Exist)
      If(.not.Exist) then
        Write(6,*)
        Write(6,*)'No Transition density matrix file found.'
        Write(6,*)'Did you use the TOFIle keyword in RASSI?'
        Call Quit(_RC_IO_ERROR_READ_)
      Endif
      Call f_Inquire(EigV,Exist)
      If(.not.Exist) then
        Write(6,*)
        Write(6,*)'No Rassi eigenvectors found.'
        Write(6,*)'Did you use the TOFIle keyword in RASSI?'
        Call Quit(_RC_IO_ERROR_READ_)
      Endif

*
*--- Compute number of 'primitive' states.
*
      nStatePrim=0
      Do 111, i=1,NrFiles
        nStatePrim=nStatePrim+NrStates(i)
111   Continue

*
*--- Open EigV file and read information.
*
      Lu=92
      Call DaName(Lu,EigV)
      iDisk=0

*
*--- Read RASSCF overlap and H-matrix.
*
      nSize=nStatePrim*(nStatePrim+1)/2
      Call GetMem('NonOrtH','Allo','Real',iNonH,nSize)
      Call GetMem('NonOrtS','Allo','Real',iNonS,nSize)
      kaunt=0
      Do 201, i=1,nStatePrim
        Do 203, j=1,i
          Call dDaFile(Lu,2,Work(iNonH+kaunt),1,iDisk)
          kaunt=kaunt+1
203     Continue
201   Continue
      kaunt=0
      Do 202, i=1,nStatePrim
        Do 204, j=1,i
          Call dDaFile(Lu,2,Work(iNonS+kaunt),1,iDisk)
          kaunt=kaunt+1
204     Continue
202   Continue
      If(iPrint.ge.10) then
        Call TriPrt('RASSCF Hamiltonian',' ',Work(iNonH),nStatePrim)
        Call TriPrt('RASSCF Overlaps',' ',Work(iNonS),nStatePrim)
      Endif
      Call DaClos(Lu)

*
*--- Construct CASSI state basis.
*
      Call ContRASBas(nBas,nStatePrim,iNonH,iNonS,iEig2)
      Call GetMem('NonOrtH','Free','Real',iNonH,nSize)
      Call GetMem('NonOrtS','Free','Real',iNonS,nSize)

*
*--- Now transform from 'primitive' RASSCF to 'contracted' RASSI states.
*
      Call RasRasTrans(nBas(1),nStatePrim,iEig2,iPrint)

*
*--- If requested, obtain reduced MO-basis, otherwise just go as
*    usual.
*
      If(MoAveRed) then
        Call MoReduce(nBas,nRedMO,ipAvRed)
        Write(TDMchar,'(A)')'TDMSCR'
        Call FetchTDM(nRedMO,nState,iBigT,TDMchar)
      Else
        Write(6,*)'     ----- Use AO-representation of the transition'
     &//' density matrix.'
        nRedMO=0 !Only a dummy.
      Endif

*
*--- Finished!
*
      Write(6,*)'     ...Done!'

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Free_DeDe(Dens,TwoHam,nDens)
      use k2_arrays
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "stdalloc.fh"
#include "setup.fh"
*
      Real*8 :: Dens(nDens), TwoHam(nDens)
*
      Nullify(pDq)
      Nullify(pFq)
*
      If (nIrrep.eq.1) Then
* symmetrize fock matrix
*.... Fix the diagonal elements of D and F
         Call DScal_(nDens,Two,Dens,1)
         nc=nbas(0)
         ijq=0
         jiq=1-nc
         ij=0
         do i=1,nc
           do j=1,i
             ij=ij+1
             TwoHam(ij) = Half*(Fq(ijq+j) + Fq(jiq+j*nc))
           end do
           Dens(ij)  =Half*Dens(ij)
           jiq = jiq + 1
           ijq = ijq + nc
         end do
         Call mma_deallocate(Dq)
         Call mma_deallocate(Fq)
      End If
*
      Call mma_deallocate(ipOffD)
      Call mma_deallocate(DeDe)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_WRRSTC(IPASS)
!
! Purpose: write decomposition restart info for integral pass IPASS.
!
! NB!!!  The restart files are assumed open on entry.

use Cholesky, only: CHO_ADRVEC, Damp, InfRed, InfVec, IntMap, LuMap, LuRst, nBas, nnShl, nShell, nSym, NumCho, SCDIAG, Span, &
                    ThrCom, ThrDiag, ThrNeg, TOONEG, WARNEG
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IPASS
integer(kind=iwp), parameter :: LSCR = 10
integer(kind=iwp) :: IADR, IOPT, ISYM, J, JADR, JSCR(LSCR), NDIM, NTOT, NWR
real(kind=wp) :: DSCR(LSCR)

! Start address on file.
! ----------------------

IADR = 0

! Write molecular and configuration info.
! ---------------------------------------

IOPT = 1
NWR = 4
JSCR(1) = NSYM
JSCR(2) = NSHELL
JSCR(3) = NNSHL
JSCR(4) = 0
call IDAFILE(LURST,IOPT,JSCR,NWR,IADR)

IOPT = 1
NWR = NSYM
JSCR(1:NSYM) = NBAS(1:NSYM)
call IDAFILE(LURST,IOPT,JSCR,NWR,IADR)

IOPT = 1
NWR = 2
if (SCDIAG) then
  JSCR(1) = 1
else
  JSCR(1) = 0
end if
JSCR(2) = CHO_ADRVEC
call IDAFILE(LURST,IOPT,JSCR,NWR,IADR)

IOPT = 1
NWR = 8
DSCR(1) = THRCOM
DSCR(2) = THRDIAG
DSCR(3) = DAMP(1)
DSCR(4) = DAMP(2)
DSCR(5) = SPAN
DSCR(6) = THRNEG
DSCR(7) = WARNEG
DSCR(8) = TOONEG
call DDAFILE(LURST,IOPT,DSCR,NWR,IADR)

! Write vector info.
! ------------------

IOPT = 1
NWR = 1
JSCR(1) = IPASS
call IDAFILE(LURST,IOPT,JSCR,NWR,IADR)

IOPT = 1
call IDAFILE(LURST,IOPT,INFRED,IPASS,IADR)

do ISYM=1,NSYM
  IOPT = 1
  NWR = 1
  JSCR(1) = NUMCHO(ISYM)
  call IDAFILE(LURST,IOPT,JSCR,NWR,IADR)
  if (NUMCHO(ISYM) > 0) then
    do J=1,size(INFVEC,2)
      IOPT = 1
      NTOT = NUMCHO(ISYM)
      call IDAFILE(LURST,IOPT,InfVec(:,J,ISYM),NTOT,IADR)
    end do
  end if
end do

! Write integral shell pair map to disk.
! --------------------------------------

IOPT = 1
NDIM = 0
if (allocated(IntMap)) then
  NDIM = size(IntMap)
  JADR = 0
  call IDAFILE(LUMAP,IOPT,INTMAP,NDIM,JADR)
end if

end subroutine CHO_WRRSTC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
*  WRVEC
*
*> @brief
*>   A routine to write MO coefficients, occupation numbers, one-electron energies and type index information to ``INPORB`` file
*> @author V. Veryazov
*>
*> @details
*> New version of ::wrvec routine.
*> ::WRVEC is a wrapper to ::WRVEC_, which writes UHF
*> information to ``INPORB`` file.
*>
*> \p Label defines the type of information to write to ``INPORB`` file.
*> Valid targets are: ``C``---CMO, ``O``---OCC, ``E``---EORB, ``I``---INDT, ``A``---Append Index, ``K``---Coordinates, ``B``---Basis section
*>
*> Example: Write CMO coeff. for RHF:
*>
*> \code
*> Call WrVec('INPORB',Lu,'C',NSYM,NBAS,NBAS,CMO,Dummy,Dummy,iDummy,Title)
*> \endcode
*>
*> @param[in] Name  File name
*> @param[in] LU_   Unit number
*> @param[in] LABEL Task
*> @param[in] NSYM  N symmetries
*> @param[in] NBAS  N basis functions
*> @param[in] NORB  N orbitals
*> @param[in] CMO   MO coefficients
*> @param[in] OCC   Occupations
*> @param[in] EORB  One electron energies
*> @param[in] INDT  Type Index information
*> @param[in] TITLE Title of orbitals
************************************************************************
      SUBROUTINE WRVEC(Name,LU_,LABEL,NSYM,NBAS,NORB,CMO,
     & OCC, EORB, INDT,TITLE)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NBAS(NSYM),NORB(NSYM),CMO(*),OCC(*),EORB(*),INDT(7,8)
      CHARACTER*(*) TITLE, Name,LABEL
      Dimension vDum(2)
      CALL WrVec_(Name,LU_,LABEL,0,NSYM,NBAS,NORB,CMO,
     & vDum, OCC, vDum,
     & EORB,vDum, INDT,TITLE,0)
       RETURN
       END

      SUBROUTINE WRVEC_(Name,LU_,LABEL,IUHF,NSYM,NBAS,NORB,CMO,
     & CMO_ab, OCC, OCC_ab,
     & EORB,EORB_ab, INDT,TITLE,iWFtype)
*
* The routine to dump information to INPORB
*
* --------------------------------------------------------------------------------
* iWFtype =  0  -- Unknown origin of orbitals
*            1  -- Orbitals for Guessorb
*            2  -- Orbitals for closed shell HF
*            3  -- Orbitals for closed shell DFT
*            4  -- Orbitals for unrestricted HF
*            5  -- Orbitals for unrestricted DFT
*            6  -- Natural orbitals for unrestricted HF
*            7  -- Natural orbitals for unrestricted DFT
*            8  --
* --------------------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NBAS(NSYM),NORB(NSYM),CMO(*),OCC(*),EORB(*),INDT(*)
      DIMENSION CMO_ab(*),OCC_ab(*), EORB_ab(*)
      CHARACTER*(*) TITLE, Name,LABEL
      CHARACTER*8 Line
      CHARACTER FMT*40
      Logical Exist
      Character*10 Buff
      Character*12 lBuff
      Dimension iBuff(0:7)
      Character*7 Crypt
C-SVC: variable to hold birth certificate
      Character cDNA*256
      Character*120 inout
      Character*20 InpOrbVer
      Logical IsBorn
      Data Crypt/'fi123sd'/
      Integer, Save :: iVer=0
#include "inporbfmt.fh"
*
*

* Analyze Label
      iCMO=0
      iOCC=0
      iEne=0
      iInd=0
      iTwoE=0
      iAppend=0
      iExtras=0
      iKoor=0
      iBasis=0
      if(index(Label,'C').ne.0) iCMO=1
      if(index(Label,'O').ne.0) iOcc=1
      if(index(Label,'E').ne.0) iEne=1
      if(index(Label,'I').ne.0) iInd=1
      if(index(Label,'T').ne.0) iTwoE=1
      if(index(Label,'A').ne.0) iAppend=1
      if(index(Label,'X').ne.0) iExtras=1
      if(index(Label,'K').ne.0) iKoor=1
      if(index(Label,'B').ne.0) iBasis=1
      isIndex=0
      Lu=Lu_
      Call OpnFl(Name,Lu,Exist)
      Rewind(Lu)
      if(iAppend.eq.1) then
       iInd=1
50     read(Lu,'(A)',end=102,err=102) Line
       if(Line.eq.'#INDEX') then
         isIndex=1
         goto 100
        endif
       goto 50
102    continue
       Call Append_file(LU)
c#ifdef NAGFOR
c        BACKSPACE(LU)
c#endif
       goto 100
      endif

*
*  Get version
*
      iDefault=iVer22
      If (iVer.eq.0) Then
        Call getenvf('MOLCAS_INPORB_VERSION',InpOrbVer)
        If (InpOrbVer.eq.'') Then
          iVer=iDefault
        Else
          InpOrbVer='#INPORB '//Trim(AdjustL(InpOrbVer))
          Do jVer=1,mxVer
            if(Magic(jVer).eq.InpOrbVer) iVer=jVer
          End Do
          If (iVer.eq.0) Then
            Call WarningMessage(0,
     &           'Unknown INPORB version, using the default')
            iVer=iDefault
          End If
        End If
      End If

*
*  Write INFO header
*
      WRITE(LU,'(A)') Magic(iVer)
      Write(Lu,'(A)') '#INFO'

      KCMO  = 0
      IF(TITLE(1:1).NE.'*') TITLE='*'//TITLE(:LEN(TITLE)-1)
      WRITE(LU,'(A)') TITLE(:mylen(TITLE))
      Write(LU,'(3i8)') IUHF, NSYM, iWFtype
      WRITE(LU,'(8i8)') (NBAS(I),I=1,NSYM)
      WRITE(LU,'(8i8)') (NORB(I),I=1,NSYM)
      Call qpg_cArray('BirthCertificate',IsBorn,nDNA)
      IF (.NOT.IsBorn) THEN
        WRITE(6,*) 'RunFile has no Birth Certificate'
      ELSE
        cDNA=' '
        Call Get_cArray('BirthCertificate',cDNA(:nDNA),nDNA)
        WRITE(LU,'(A)') '*BC:'//cDNA(:mylen(cDNA))
      ENDIF

* Extras section
      If (iTwoE.eq.1 ) iExtras=1  ! so far only case

      If(iExtras.eq.1) then
        Write(Lu,'(A)') '#EXTRAS'
        If(iTwoE.eq.1) then
          WRITE(LU,'(A)') '* ACTIVE TWO-EL ENERGY'
          WRITE(LU,'(E19.12)') EORB_ab(1)
        EndIf
      EndIf

* ORB section
      if(iCMO.eq.1) then
      NDIV=nDivOrb(iVer)
      FMT=FmtOrb(iVer)
      Write(Lu,'(A)') '#ORB'
      KCMO  = 0
      DO ISYM=1,NSYM
         DO IORB=1,NORB(ISYM)
           WRITE(LU,'(A,2I5)') '* ORBITAL',ISYM,IORB
            DO IBAS=1,NBAS(ISYM),NDIV
              IBASEND=MIN(IBAS+NDIV-1,NBAS(ISYM))
            WRITE(LU,FMT) (CMO(I+KCMO),I=IBAS,IBASEND)
            EndDo
           KCMO=KCMO+NBAS(ISYM)
         EndDo
      EndDo
      if(iUHF.eq.1) then
      Write(Lu,'(A)') '#UORB'
      KCMO  = 0
      DO ISYM=1,NSYM
         DO IORB=1,NORB(ISYM)
           WRITE(LU,'(A,2I5)') '* ORBITAL',ISYM,IORB
            DO IBAS=1,NBAS(ISYM),NDIV
              IBASEND=MIN(IBAS+NDIV-1,NBAS(ISYM))
          WRITE(LU,FMT) (CMO_ab(I+KCMO),I=IBAS,IBASEND)
            EndDo
           KCMO=KCMO+NBAS(ISYM)
         EndDo
      EndDo
      Endif  ! UHF
      Endif  ! iCMO

* OCC section
      if(iOcc.eq.1) then
      NDIV=nDivOcc(iVer)
      FMT=FmtOcc(iVer)
      Write(Lu,'(A)') '#OCC'
      WRITE(LU,'(A)') '* OCCUPATION NUMBERS'
      KOCC=0
      DO ISYM=1,NSYM
         DO IORB=1,NORB(ISYM),NDIV
           IORBEND=MIN(IORB+NDIV-1,NORB(ISYM))
            WRITE(LU,FMT) (OCC(I+KOCC),I=IORB,IORBEND)
         EndDo
         KOCC=KOCC+NORB(ISYM)
      EndDo

      if(iUHF.eq.1) then
      Write(Lu,'(A)') '#UOCC'
      WRITE(LU,'(A)') '* Beta OCCUPATION NUMBERS'
      KOCC=0
      DO ISYM=1,NSYM
         DO IORB=1,NORB(ISYM),NDIV
           IORBEND=MIN(IORB+NDIV-1,NORB(ISYM))
         WRITE(LU,FMT) (OCC_ab(I+KOCC),I=IORB,IORBEND)
         EndDo
         KOCC=KOCC+NORB(ISYM)
      EndDo
      Endif  ! UHF

      NDIV=nDivOccHR(iVer)
      If (NDIV.gt.0) Then
         FMT=FmtOccHR(iVer)
         Write(Lu,'(A)') '#OCHR'
         WRITE(LU,'(A)') '* OCCUPATION NUMBERS (HUMAN-READABLE)'
         KOCC=0
         DO ISYM=1,NSYM
            DO IORB=1,NORB(ISYM),NDIV
              IORBEND=MIN(IORB+NDIV-1,NORB(ISYM))
               WRITE(LU,FMT) (OCC(I+KOCC),I=IORB,IORBEND)
            EndDo
            KOCC=KOCC+NORB(ISYM)
         EndDo

         if(iUHF.eq.1) then
         Write(Lu,'(A)') '#UOCHR'
         WRITE(LU,'(A)') '* Beta OCCUPATION NUMBERS (HUMAN-READABLE)'
         KOCC=0
         DO ISYM=1,NSYM
            DO IORB=1,NORB(ISYM),NDIV
              IORBEND=MIN(IORB+NDIV-1,NORB(ISYM))
            WRITE(LU,FMT) (OCC_ab(I+KOCC),I=IORB,IORBEND)
            EndDo
            KOCC=KOCC+NORB(ISYM)
         EndDo
         Endif  ! UHF
      End If
      Endif  ! iOcc

* ONE section
      if(iEne.eq.1) then
      NDIV=nDivEne(iVer)
      FMT=FmtEne(iVer)
      Write(Lu,'(A)') '#ONE'
      WRITE(LU,'(A)') '* ONE ELECTRON ENERGIES'
      KOCC=0
      DO ISYM=1,NSYM
         DO IORB=1,NORB(ISYM),NDIV
           IORBEND=MIN(IORB+NDIV-1,NORB(ISYM))
            WRITE(LU,FMT) (EORB(I+KOCC),I=IORB,IORBEND)
         End Do
         KOCC=KOCC+NORB(ISYM)
      End Do

      if(iUHF.eq.1) then
      Write(Lu,'(A)') '#UONE'
      WRITE(LU,'(A)') '* Beta ONE ELECTRON ENERGIES'
      KOCC=0
      DO ISYM=1,NSYM
         DO IORB=1,NORB(ISYM),NDIV
           IORBEND=MIN(IORB+NDIV-1,NORB(ISYM))
         WRITE(LU,FMT) (EORB_ab(I+KOCC),I=IORB,IORBEND)
         End Do
         KOCC=KOCC+NORB(ISYM)
      End Do
      Endif  ! UHF
      Endif  ! iEne
      Call getenvf('MOLCAS_SAGIT',inout)
      If (inout(1:1).eq.'y'.or.inout(1:1).eq.'Y') Then
        iKoor=iCMO
        iBasis=iCMO
      Else
        iKoor=0
        iBasis=0
      End If
      if(iKoor.eq.1.and.iBasis.eq.1) then
        in=16
        in=isfreeunit(in)
        call molcas_open(in,'ORB.std')
765     read(in,'(a)',end=766,err=766) InOut
        write(Lu,'(a)') InOut(1:mylen(InOut))
        goto 765
766     close(in)
      endif
* INDEX section. NOTE THIS SECTION SHOULD ALWAYS BE LAST (Gv constraint)
100   if(iInd.eq.1) then
       if(iAppend.eq.0.or.(iAppend.eq.1.and.isIndex.eq.0)) then
         Write(Lu,'(A)') '#INDEX'
       endif
      iShift=0
      nDiv=nDivInd(iVer)

      iBuff(0)=1
c       do i=1,7
       i=1
601    continue
       iBuff(i)=iBuff(i-1)+IndT(i+iShift)
       i=i+1
       if(i.le.7) goto 601

c       enddo

      DO ISYM=1,NSYM
      If (nSkpInd(iVer).gt.0) write(Lu,'(A)') '* 1234567890'
      iLab=0
      iBuff(0)=1
c       do i=1,7
       i=1
600    continue
       iBuff(i)=iBuff(i-1)+IndT(i+iShift)
       i=i+1
       if(i.le.7) goto 600

c       enddo
       Ip=1
         DO IORB=1,NORB(ISYM),nDiv
         Buff='          '
          do i=1,nDiv
          iBB=1
          do iB=1,7
          if(Ip.ge.iBuff(iB)) iBB=iBB+1
          enddo
          if(iBB.eq.8) then
           Buff(i:i)=' '
          else
           Buff(i:i)=Crypt(iBB:iBB)
          endif
          Ip=Ip+1
          enddo
            WRITE(lBuff,FMTIND(iVer)) Buff
            If (Index(FMTIND(iVer),'X').gt.0)
     &         WRITE(lBuff(1:1),'(i1)') iLab
            WRITE(LU,'(A)') Trim(lBuff)
            iLab=iLab+1
            if(iLab.gt.9) iLab=0
         End Do
       iShift=iShift+7
      End Do

      Endif  ! iInd

      Close(Lu)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  GetKandC
!
!> @brief
!>   Utility routine for quaternion resolution
!> @author Y. Carissan
!>
!> @details
!> Performs the following operation:
!>
!> \f[ K = (V_1-U_1) \times (V_2-U_2) \\
!>     C = K . (U_1 \times U_2) \f]
!>
!> @param[in]  U1 Input vector \f$ U_1 \f$
!> @param[in]  U2 Input vector \f$ U_2 \f$
!> @param[in]  V1 Input vector \f$ V_1 \f$
!> @param[in]  V2 Input vector \f$ V_2 \f$
!> @param[out] K  Output vector \f$ K \f$
!> @param[out] C  Output value \f$ C \f$
!***********************************************************************

subroutine GetKandC(U1,U2,V1,V2,K,C)

use Quater_globals, only: debug
use Definitions, only: wp, r8, u6

implicit none
real(kind=wp), intent(in) :: U1(3), U2(3), V1(3), V2(3)
real(kind=wp), intent(out) :: K(3), C
real(kind=wp) :: T1(3), T2(3)
real(kind=r8), external :: ddot_

T1(:) = V1(:)-U1(:)     ! T1 = V1-U1
T2(:) = V2(:)-U2(:)     ! T2 = V2-U2

call cross(T1,T2,K)     ! K = T1 x T2 = (V1-U1) x (V2-U2)
call cross(U1,U2,T1)    ! T1 = U1 x U2
C = ddot_(3,K,1,T1,1)   ! C = K . (U1 x U2)

if (debug) then
  call RecPrt('K',' ',K,3,1)
  write(u6,*) 'C',C
end if

return ! K and C

end subroutine GetKandC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine xquit(rc)
!SVC: routine that terminates Molcas properly

use warnings, only: rc_msg
#ifdef _MOLCAS_MPP_
use Para_Info, only: King
#endif
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: rc
integer(kind=iwp) :: lb, ub
character(len=128) :: msg
logical(kind=iwp), external :: bomb_on_error
#include "warnings.h"

call xflush(u6)

!SVC: write rc to stderr if not 0 (all is well)
if (rc /= _RC_ALL_IS_WELL_) then
  !IFG: do not write message if rc is "out of bounds"
  !     (this avoids it, e.g., when a slave process quits with -2,
  !     also avoids writing garbage from rc_msg)
  lb = lbound(rc_msg,dim=1)
  ub = ubound(rc_msg,dim=1)
  if ((rc >= lb) .and. (rc <= ub)) then
    write(msg,'(a,i6,2a)') 'xquit (rc = ',rc,'): ',rc_msg(rc)
    call write_stderr(msg)
  end if
end if

!SVC: write return code to file
call write_rc(rc)

!SVC: critical errors result in backtrace + immediate abort, while
!     regular errors only do this if MOLCAS_BOMB has been set too.
if ((rc >= _RC_GROUP_CRITICAL_) .or. &
#   if _MOLCAS_MPP_
!IFG: in a parallel (real or fake) run, we have to be more strict
!     with errors, or a deadlock may occur when some slave process
!     quits (e.g., a glitch or bug causes a missing file). Of course,
!     it could be argued that the error raised for those cases should
!     be critical... but it's often an "INPUT ERROR"
    (rc >= _RC_GROUP_USER_ERROR_ .and. (.not. King())) .or. &
#   endif
    (rc >= _RC_GROUP_ERROR_ .and. bomb_on_error())) then
  call xabort(rc)
end if

!SVC: terminate GA/MPI gracefully
call GATerminate()

!SVC: eventual exit normally. We should not exit with rc here because
!     some MPI implementations (like MPICH) will treat a non-zero return
!     code similar to an abort.
stop

end subroutine xquit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine XMS_Grad(H0,U0,UEFF,OMGDER)

use Index_Functions, only: nTri_Elem, nTri3_Elem
use sguga, only: SGS
use caspt2_global, only: CLag, CLagFull, CMOPT2, do_csf, do_nac, DPT2_tot, FIFA, FIFA_all, FIFASA_all, if_equalW, iRoot1, iRoot2, &
                         NDREF, nOLag, OLag, TORB, weight
use caspt2_module, only: ENERGY, IFDW, IFRMS, IFXMS, MXCI, NASHT, NBAS, NBAST, NBSQT, NCONF, NDEL, NFRO, NISH, NROOTS, NSTATE, &
                         ORBIN, STSYM, ZETA
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half, Quart
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: H0(nState,nState), U0(nState,nState), OMGDER(nState,nState)
real(kind=wp), intent(inout) :: UEFF(nState,nState)
integer(kind=iwp) :: I, iStat, iState, jAsh, jStat, kStat, nBasI, nCor, nLev, nOrbI, NTG1, NTG3
real(kind=wp) :: EDIFF, EEI, EEJ, EINACT, fact, OVL, Scal, TRC, Wgt
real(kind=wp), allocatable :: CI1(:), CI2(:), DG1(:), DG2(:), DG3(:), DPT2(:), DPT2_AO(:), G1(:,:), RDMEIG(:,:), RDMSA(:,:), &
                              SGM1(:), SGM2(:), SLag(:,:), TG1(:,:), TG2(:), Trf(:), WRK1(:), WRK2(:)
real(kind=wp), external :: ddot_

nLev = SGS%nLev

call mma_allocate(SLag,nState,nState,Label='SLag')

! The XMS rotation applies to any variants: XMS-CASPT2, XDW-CASPT2,
! and RMS-CASPT2.

if (IFXMS .or. IFRMS) then
  call mma_allocate(CI1,nConf,Label='CI1')
  call mma_allocate(CI2,nConf,Label='CI2')
  call mma_allocate(SGM1,MXCI,Label='SGM1')
  call mma_allocate(SGM2,MXCI,Label='SGM2')
  call mma_allocate(TG1,nAshT,nAshT,Label='TG1')
  call mma_allocate(TG2,nAshT**4,Label='TG2')

  call mma_allocate(DG1,nAshT**2,Label='DG1')
  call mma_allocate(DG2,nAshT**4,Label='DG2')

  ! ----- Construct pseudo-density matrix -----

  !! First, we need to consider the derivative of the rotation
  !! of the CASSCF energy (Heff[1]).

  !! Forward transformation of UEFF (CASSCF basis to XMS basis)
  !! SLag is used as a working array
  call DGEMM_('T','N',nState,nState,nState,One,U0,nState,UEFF,nState,Zero,SLag,nState)
  UEFF(:,:) = SLag(:,:)

  !! Then actual calculation
  CLag(1:nconf,1:nstate) = Zero
  do iStat=1,nState
    call LoadCI_XMS('C',0,nConf,nState,CI1,iStat,U0)
    do jStat=1,nState
      call LoadCI_XMS('C',0,nConf,nState,CI2,jStat,U0)

      call Dens2T_RPT2(NLEV,NCONF,MXCI,CI1,CI2,SGM1,SGM2,TG1,TG2)
      TG1(:,:) = TG1(:,:)*Half
      TG2(:) = TG2(:)*Half
      DG1(:) = Zero
      DG2(:) = Zero
      call CnstInt(1,DG1,DG2)

      if (do_nac) then
        Scal = (UEFF(iStat,iRoot1)*UEFF(jStat,iRoot2)+UEFF(jStat,iRoot1)*UEFF(iStat,iRoot2))*Half
      else
        Scal = UEFF(iStat,iRoot1)*UEFF(jStat,iRoot2)
      end if
      if (IFDW .and. (zeta >= Zero)) scal = scal+OMGDER(iStat,jStat)
      DG1(:) = DG1(:)*Scal
      DG2(:) = DG2(:)*Scal

      call mma_allocate(DG3,nAshT**6,Label='DG3')
      DG3(:) = Zero

      NTG1 = NASHT**2
      NTG3 = nTri3_Elem(NTG1)
      OVL = Zero
      call DERTG3(.false.,STSYM,STSYM,NCONF,NASHT,CI1,CI2,OVL,DG1,DG2,NTG3,DG3,CLag(1,iStat),CLag(1,jStat))
      call mma_deallocate(DG3)
    end do
  end do
  call mma_deallocate(SGM2)
  call mma_deallocate(TG2)

  !! Back transformation of UEFF (XMS basis to CASSCF basis)
  !! SLag is used as a working array
  call DGEMM_('N','N',nState,nState,nState,One,U0,nState,UEFF,nState,Zero,SLag,nState)
  UEFF(:,:) = SLag(:,:)
  call mma_deallocate(DG1)
  call mma_deallocate(DG2)

  !! Add to the full CI Lagrangian
  !! CLag is in quasi-canonical basis, so transformation
  !! to natural basis is required.
  if (ORBIN == 'TRANSFOR') then
    do iState=1,nState
      call CLagX_TrfCI(nConf,CLag(1,iState))
    end do
  end if
  CLagFull(:,:) = CLagFull(:,:)+CLag(:,:)

  !! Compute the Lagrange multiplier for XMS
  !! The diagonal element is always zero.
  !! The code has an additional scaling with 0.5,
  !! because some contributions are doubled.
  SLag(:,:) = Zero
  do iStat=1,nState
    call LoadCI_XMS('N',0,nConf,nState,CI1,iStat,U0)
    EEI = H0(iStat,iStat)
    do jStat=1,iStat
      if (iStat == jStat) then
        SLag(iStat,jStat) = Zero
      else
        call LoadCI_XMS('N',0,nConf,nState,CI2,jStat,U0)
        EEJ = H0(jStat,jStat)

        Scal = DDOT_(nConf,CI1,1,CLagFull(1,jStat),1)-DDOT_(nConf,CI2,1,CLagFull(1,iStat),1)
        if (do_csf) then
          !! JCTC 2017, 13, 2561: eq.(66)
          !! iStat and jStat: XMS
          !! kStat and lStat: CASSCF
          fact = Zero
          do kStat=1,nState
            fact = fact+sum((UEFF(kStat,iRoot1)*UEFF(:,iRoot2)-UEFF(kStat,iRoot2)*UEFF(:,iRoot1))*Half*U0(kStat,iStat)*U0(:,jStat))
          end do
          Scal = Scal+fact*(ENERGY(iRoot2)-ENERGY(iRoot1))*Two
        end if
        Scal = Quart*Scal/(EEJ-EEI)
        SLag(iStat,jStat) = Scal
        SLag(jStat,iStat) = Scal
      end if
    end do
  end do

  !! Either subtract the CI derivative of Heff(1)
  !! or add off-diagonal couplings in rhs_sa (Z-vector)
  !CLagFull = CLagFull-CLag

  !! Finally, construct the pseudo-density matrix
  !! d = \sum_{ST} w_{ST} * d_{ST}
  call mma_allocate(G1,nAshT,nAshT,Label='G1')
  G1(:,:) = Zero
  do iStat=1,nState
    call LoadCI_XMS('C',0,nConf,nState,CI1,iStat,U0)
    do jStat=1,nState
      if (abs(SLag(iStat,jStat)) <= 1.0e-10_wp) cycle
      call LoadCI_XMS('C',0,nConf,nState,CI2,jStat,U0)

      call Dens1T_RPT2(CI1,CI2,SGM1,TG1,nLev)
      G1(:,:) = G1(:,:)+Two*SLag(iStat,jStat)*TG1(:,:)
    end do
  end do

  call mma_deallocate(CI1)
  call mma_deallocate(CI2)
  call mma_deallocate(SGM1)
  call mma_deallocate(TG1)

  ! ----- Calculate orbital derivatives -----

  call mma_allocate(RDMEIG,nAshT,nAshT,Label='RDMEIG')
  call mma_allocate(DPT2,NBSQT,Label='DPT2')
  DPT2(:) = Zero

  call mma_allocate(Trf,NBSQT,Label='TRFMAT')
  call mma_allocate(RDMSA,nAshT,nAshT,Label='RDMSA')
  call mma_allocate(WRK1,NBSQT,Label='WRK1')
  call mma_allocate(WRK2,NBSQT,Label='WRK2')

  !! Construct always state-averaged density; XMS basis is always
  !! generated with the equally-averaged density.
  WRK1(1:nDRef) = Zero
  call mma_allocate(CI1,nConf,Label='CI1')
  Wgt = One/nState
  do iState=1,nState
    call LoadCI(CI1,iState)
    call POLY1(CI1,nConf)
    call GETDREF(WRK2,nDRef)
    WRK1(1:nDRef) = WRK1(1:nDRef)+Wgt*WRK2(1:nDRef)
  end do
  call mma_deallocate(CI1)
  call SQUARE(WRK1,RDMSA,1,nAshT,nAshT)

  nOrbI = nBas(1)-nDel(1) !! nOrb(1)
  nBasI = nBas(1)
  !call SQUARE(FIFA,FIFA_all,1,nOrbI,nOrbI)
  !! FIFASA_all is in natural orbital basis
  Trf(1:NBSQT) = Zero
  call CnstTrf(NBSQT,TOrb,Trf)

  !! FIFA: natural -> quasi-canonical
  if (IFDW .or. IFRMS) then
    call DGemm_('T','N',nOrbI,nOrbI,nOrbI,One,Trf,nBasI,FIFASA_all,nOrbI,Zero,WRK1,nOrbI)
    call DGemm_('N','N',nOrbI,nOrbI,nOrbI,One,WRK1,nOrbI,Trf,nBasI,Zero,FIFASA_all,nOrbI)
  end if
  FIFA_all(1:NBSQT) = FIFASA_all(1:NBSQT)

  !! Orbital derivatives of FIFA
  !! Both explicit and implicit orbital derivatives are computed
  !! Also, compute G(D) and put the active contribution to RDMEIG
  OLag(:) = Zero
  call EigDer2(NBSQT,nAshT,RDMEIG,Trf,FIFA_all,RDMSA,G1,WRK1,WRK2)

  !! Add to PT2 density
  !! No inactive contributions. Correct as long as CASSCF CI
  !! vector are orthogonal.
  call AddDEPSA(NBSQT,nAshT,DPT2,G1)
  call DPT2_TrfStore(One,NBSQT,DPT2,DPT2_tot,Trf,WRK1)

  !! Finalize OLag (anti-symetrize) and construct WLag
  call OLagFinal(nOLag,NBSQT,OLag,Trf)

  if (.not. if_equalW) then
    call mma_allocate(DPT2_AO,NBSQT,Label='DPT2_AO')

    !! AddDEPSA considers the frozen orbital, whereas DPT2_Trf
    !! does not. In any case, construct DPT2 again.
    DPT2(:) = Zero
    call DPT2_Trf(NBSQT,nAshT,DPT2,DPT2_AO,CMOPT2,G1,WRK1)
    !! Construct the SCF density
    WRK1(1:nDRef) = Zero
    call mma_allocate(CI1,nConf,Label='CI1')
    do iState=1,nState
      call LoadCI_XMS('N',1,nConf,nState,CI1,iState,U0)
      call POLY1(CI1,nConf)
      call GETDREF(WRK2,nDRef)
      WRK1(1:nDRef) = WRK1(1:nDRef)+Weight(iState)*WRK2(1:nDRef)
    end do
    call mma_deallocate(CI1)
    !! WRK2 is the SCF density (for nstate=nroots)
    call SQUARE(WRK1,WRK2,1,nAshT,nAshT)
    RDMSA(:,:) = RDMSA(:,:)-reshape(WRK2(1:nAshT**2),[nAshT,nAshT])
    !! Construct the SS minus SA density matrix in WRK1
    call OLagFroD(NBSQT,nAshT,WRK1,WRK2,RDMSA,Trf)
    !! Subtract the inactive part
    WRK1(1:nBasT**2) = WRK1(1:nBasT**2)-WRK2(1:nBasT**2)
    !! Save
    call CnstAB_SSDM(NBSQT,DPT2_AO,WRK1)
    call mma_deallocate(DPT2_AO)
  end if

  call mma_deallocate(RDMSA)
  call mma_deallocate(WRK1)
  call mma_deallocate(WRK2)

  call mma_deallocate(DPT2)

  ! ----- Calculate CI derivatives -----

  !! use quasi-canonical CSF rather than natural CSF
  CLag(:,:) = Zero

  !! 1) Explicit CI derivative
  !! a: Extract FIFA in the AS for explicit CI derivative
  !!    Note that this FIFA uses state-averaged density matrix
  !call sqprt(fifa_all,nbast)
  do jAsh=1,nAshT
    G1(:,jAsh) = FIFA_all(nFro(1)+nIsh(1)+nBas(1)*(nFro(1)+nIsh(1)+jAsh-1)+1:nFro(1)+nIsh(1)+nBas(1)*(nFro(1)+nIsh(1)+jAsh-1)+nAshT)
  end do
  !call sqprt(g1),nasht)
  !! Transform quasi-canonical to natural
  nCor = nFro(1)+nIsh(1)
  !call sqprt(trf,nbast)
  call DGemm_('N','N',nAshT,nAshT,nAshT,One,Trf(1+nBasT*nCor+nCor),nBasT,G1,nAshT,Zero,FIFA_all,nAshT)
  !call sqprt(FIFA_all,nasht)
  call DGemm_('N','T',nAshT,nAshT,nAshT,One,FIFA_all,nAshT,Trf(1+nBasT*nCor+nCor),nBasT,Zero,G1,nAshT)
  !call sqprt(g1,nasht)
  call DGemm_('N','N',nAshT,nAshT,nAshT,One,Trf(1+nBasT*nCor+nCor),nBasT,RDMEIG,nAshT,Zero,FIFA_all,nAshT)
  call DGemm_('N','T',nAshT,nAshT,nAshT,One,FIFA_all,nAshT,Trf(1+nBasT*nCor+nCor),nBasT,Zero,RDMEIG,nAshT)
  call mma_deallocate(Trf)

  !! b: FIFA in the inactive space
  TRC = Zero
  !do ISYM=1,NSYM
  do I=1,NISH(1) ! ISYM)
    !II = IOFF(ISYM)+nTri_Elem(I)
    TRC = TRC+FIFA(nTri_Elem(I))
  end do
  !end do
  ! Contribution from inactive orbitals:
  EINACT = Two*TRC
  !! This EINACT may be wrong. Perhaps, FIFA has to be
  !! back-transformed to natural orbital basis. However, this does
  !! not contribute to the final gradient as long as all the
  !! (internal) CI vectors are orthogonal.

  !! c: Finally, compute explicit CI derivative
  !! y_{I,T} = w_{ST} <I|f|S>
  !! Here, G1 is FIFA = ftu
  call CLagEigT(CLag,G1,SLag,EINACT)

  !! 2) Implicit CI derivative
  call CLagEig(.false.,.true.,nConf,nRoots,nState,nLev,CLag,RDMEIG)

# ifdef _MOLCAS_MPP_
  if (is_real_par()) call GADGOP(CLag,nConf*nState,'+')
# endif

  call mma_deallocate(RDMEIG)
  call mma_deallocate(G1)

end if

if (do_csf) then
  !! Eq (68)
  !! I think this contributes even in XMS-CASPT2.
  !! However, maybe I implemented other terms in a different way
  !! from BAGEL.
  call mma_allocate(CI1,nConf,Label='CI1')
  !! Do in the natural orbital in the XMS basis
  !! because CLag is like that
  !! CASSCF -> XMS
  call DGEMM_('T','N',nState,nState,nState,One,U0,nState,UEFF,nState,Zero,SLag,nState)
  UEFF(:,:) = SLag(:,:)

  EDIFF = ENERGY(iRoot2)-ENERGY(iRoot1)
  do iStat=1,nState
    call LoadCI_XMS('N',0,nConf,nState,CI1,iStat,U0)
    do jStat=1,nState
      CLag(:,jStat) = CLag(:,jStat)+(UEFF(iStat,iRoot1)*UEFF(jStat,iRoot2)-UEFF(iStat,iRoot2)*UEFF(jStat,iRoot1))*Half*EDIFF*CI1(:)
    end do
  end do

  !! XMS -> CASSCF
  call DGEMM_('N','N',nState,nState,nState,One,U0,nState,UEFF,nState,Zero,SLag,nState)
  UEFF(:,:) = SLag(:,:)

  call mma_deallocate(CI1)
end if

call mma_deallocate(SLag)

!! Finally, add to the total CI derivative array
CLagFull(:,:) = CLagFull(:,:)+CLag(:,:)

end subroutine XMS_Grad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TODSCP(A,NDIM,MBLOCK,IFIL)
! TRANSFER ARRAY REAL*8  A(LENGTH NDIM) TO DISCFIL IFIL IN
! RECORDS WITH LENGTH NBLOCK.
!
! Packed version : Store only nonzero elements
! Small elements should be zeroed outside

use lucia_data, only: IDISK
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDIM, MBLOCK, IFIL
real(kind=wp), intent(in) :: A(NDIM)
integer(kind=iwp), parameter :: LPBLK = 50000
integer(kind=iwp) :: IDUMMY(1), IELMNT, IMZERO, IPACK, IPAK(LPBLK), ISCR(2), LBATCH, MMBLOCK
real(kind=wp) :: XNORM, XPAK(LPBLK)
real(kind=wp), external :: dDot_

!write(u6,*) ' entering TODSCP, file = ',IFIL
!call XFLUSH(u6)
IPACK = 1
if (IPACK /= 0) then
  ! Check norm of A before writing
  XNORM = dDot_(NDIM,A,1,A,1)
  if (XNORM == Zero) then
    IMZERO = 1
  else
    IMZERO = 0
  end if
  MMBLOCK = MBLOCK
  if (MMBLOCK > 2) MMBLOCK = 2

  ISCR(1) = IMZERO
  ! Packing
  ISCR(2) = 1
  !call ITODS(ISCR,2,MMBLOCK,IFIL)
  call ITODS(ISCR,2,2,IFIL)
  if (IMZERO == 1) return
end if

! Loop over packed records of dimension LPBLK
IELMNT = 0
do
  ! The next LPBLK elements
  LBATCH = 0
  ! Obtain next batch of elemnts
  do
    if (NDIM >= 1) then
      IELMNT = IELMNT+1
      if (A(IELMNT) /= Zero) then
        LBATCH = LBATCH+1
        IPAK(LBATCH) = IELMNT
        XPAK(LBATCH) = A(IELMNT)
      end if
    end if
    if ((LBATCH == LPBLK) .or. (IELMNT == NDIM)) exit
  end do
  ! Send to DISC
  IDUMMY(1) = LBATCH
  call IDAFILE(IFIL,1,IDUMMY,1,IDISK(IFIL))
  if (LBATCH > 0) then
    call IDAFILE(IFIL,1,IPAK,LBATCH,IDISK(IFIL))
    call DDAFILE(IFIL,1,XPAK,LBATCH,IDISK(IFIL))
  end if
  if (IELMNT == NDIM) then
    IDUMMY(1) = -1
    call IDAFILE(IFIL,1,IDUMMY,1,IDISK(IFIL))
    exit
  else
    IDUMMY(1) = 0
    call IDAFILE(IFIL,1,IDUMMY,1,IDISK(IFIL))
  end if
end do
! End of loop over records of truncated elements

end subroutine TODSCP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DGMM2_MOLCAS (AOUT,AIN,DIAG,IWAY,NRDIM,NCDIM)
C
C     PRODUCT OF DIAGONAL MATRIX AND MATRIX :
C
C     IWAY = 1 : AOUT(I,J) = DIAG(I)*AIN(I,J)
C     IWAY = 2 : AOUT(I,J) = DIAG(J)*AIN(I,J)
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION AIN(NRDIM,NCDIM),DIAG(*)
      DIMENSION AOUT(NRDIM,NCDIM)
C
      IF ( IWAY .EQ. 1 ) THEN
         DO 100 J = 1, NCDIM
           DO 110 K = 1, NRDIM
             AOUT(K,J) = AIN(K,J)*DIAG(K)
110        CONTINUE
100      CONTINUE
      END IF
C
      IF( IWAY .EQ. 2 ) THEN
        DO 200 J = 1, NCDIM
          FACTOR = DIAG(J)
          CALL DCOPY_(NRDIM,AIN(1,J),1,AOUT(1,J),1)
          CALL DSCAL_(NRDIM,FACTOR,AOUT(1,J),1)
200     CONTINUE
      END IF
C
      NTEST = 0
      IF( NTEST .NE. 0 ) THEN
        WRITE(6,*) ' AIN DIAG AOUT  FROM DGMTMT '
        CALL WRTMAT(AIN ,NRDIM,NCDIM,NRDIM,NCDIM)
        IF(IWAY.EQ.1) THEN
        CALL WRTMAT(DIAG,1   ,NRDIM,1,NRDIM)
        ELSE
        CALL WRTMAT(DIAG,1   ,NCDIM,1,NCDIM)
        END IF
        CALL WRTMAT(AOUT,NRDIM,NCDIM,NRDIM,NCDIM)
      END IF
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKSGNUM_MCLR
     &           (LSYM,NSYM,NLEV,NVERT,MIDLEV,NMIDV,
     &            MXUP,MXDWN,NICASE,NIPWLK,
     &            IDOWN,IUP,IDAW,IRAW,NOW,IOW,
     &            IUSGNUM,ILSGNUM,ICASE,IPRINT)
C
C     PURPOSE: FOR ALL UPPER AND LOWER WALKS
C              COMPUTE THE DIRECT ARC WEIGHT SUM AND THE
C              REVERSE ARC WEIGHT SUM, RESPECTIVELY.
C              STORE THE DATA IN THE TABLES IUSGNUM AND ILSGNUM
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION IDOWN(NVERT,0:3),IUP(NVERT,0:3)
      DIMENSION IDAW(NVERT,0:4),IRAW(NVERT,0:4)
      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)
      DIMENSION IUSGNUM(MXUP,NMIDV),ILSGNUM(MXDWN,NMIDV)
      DIMENSION ICASE(NICASE)
      DIMENSION ISTEPVEC(50)
C
C
C     INITIALIZE NUMBERING TABLES
C
      DO 10 MIDV=1,NMIDV
        DO 20 IUW=1,MXUP
           IUSGNUM(IUW,MIDV)=0
20      CONTINUE
        DO 30 ILW=1,MXDWN
           ILSGNUM(ILW,MIDV)=0
30      CONTINUE
10    CONTINUE
C
C     MAIN LOOP RUNS OVER MIDVERTICES AND SYMMETRIES
C
      ICONF=0
      DO 100 MIDV=1,NMIDV
        DO 110 ISYM=1,NSYM
          IUOFF=1+IOW(1,ISYM,MIDV)
          NUW=NOW(1,ISYM,MIDV)
          JSYM=1+IEOR(ISYM-1,LSYM-1)
          ILOFF=1+IOW(2,JSYM,MIDV)
          NLW=NOW(2,JSYM,MIDV)
          IF( NUW.EQ.0 .OR. NLW.EQ.0 ) GOTO 110
C
C         LOOP OVER ALL UPPER WALKS
C
          DO 200 IUW=1,NUW
            IPOS=IUOFF+NIPWLK*(IUW-1)
C     UNPACK THE UPPER WALK STEP VECTOR
            ICODE=ICASE(IPOS)
            JPOS=0
            DO 210 LEV=(MIDLEV+1),NLEV
              JPOS=JPOS+1
              IF( JPOS.EQ.16 ) THEN
                JPOS=1
                IPOS=IPOS+1
                ICODE=ICASE(IPOS)
              ENDIF
              ISTEP=MOD(ICODE,4)
              ISTEPVEC(LEV)=ISTEP
              ICODE=ICODE/4
210         CONTINUE
C     GET REVERSE ARC WEIGHT FOR UPPER WALK
            IRAWSUM=1
            LV=1
            DO 220 LEV=NLEV,(MIDLEV+1),-1
              IC=ISTEPVEC(LEV)
              LV=IDOWN(LV,IC)
              IRAWSUM=IRAWSUM+IRAW(LV,IC)
220         CONTINUE
            IUSGNUM(IRAWSUM,MIDV)=IUW
200       CONTINUE
C
C         LOOP OVER ALL LOWER WALKS
C
          DO 300 ILW=1,NLW
            IPOS=ILOFF+NIPWLK*(ILW-1)
C     UNPACK WALK STEP VECTOR
            ICODE=ICASE(IPOS)
            JPOS=0
            DO 310 LEV=1,MIDLEV
              JPOS=JPOS+1
              IF( JPOS.EQ.16 ) THEN
                JPOS=1
                IPOS=IPOS+1
                ICODE=ICASE(IPOS)
              ENDIF
              ISTEP=MOD(ICODE,4)
              ISTEPVEC(LEV)=ISTEP
              ICODE=ICODE/4
310         CONTINUE
C     GET DIRECT ARC WEIGHT FOR THE LOWER WALK
            IDAWSUM=1
            LV=NVERT
            DO 320 LEV=1,MIDLEV
              IC=ISTEPVEC(LEV)
              LV=IUP(LV,IC)
              IDAWSUM=IDAWSUM+IDAW(LV,IC)
320         CONTINUE
            ILSGNUM(IDAWSUM,MIDV)=ICONF
            ICONF=ICONF+NUW
300       CONTINUE
C
110     CONTINUE
100   CONTINUE

      IF( IPRINT.GT.5 ) THEN
        WRITE(6,*)
        WRITE(6,*)' ILSGNUM IN SUBROUTINE MKSGNUM_MCLR'
        DO 400 MIDV=1,NMIDV
          WRITE(6,'(1X,''MIDV='',I3,/,(20I6))')MIDV,
     *         (ILSGNUM(J,MIDV),J=1,MXDWN)
400     CONTINUE
        WRITE(6,*)
        WRITE(6,*)' IUSGNUM IN SUBROUTINE MKSGNUM_MCLR'
        DO 410 MIDV=1,NMIDV
          WRITE(6,'(1X,''MIDV='',I3,/,(20I6))')MIDV,
     *          (IUSGNUM(J,MIDV),J=1,MXUP)
410     CONTINUE
        WRITE(6,*)
        WRITE(6,*)
        WRITE(6,*)' NR OF WALKS AND CONFIGURATIONS IN SGNUM'
        WRITE(6,*)' BY MIDVERTEX AND SYMMETRY.'
        DO 810 MV=1,NMIDV
          WRITE(6,*)
          WRITE(6,1234) MV,(NOW(1,IS,MV),IS=1,NSYM)
          WRITE(6,1235)    (NOW(2,IS,MV),IS=1,NSYM)
1234  FORMAT('  MV=',I2,'    UPPER WALKS:',8I6)
1235  FORMAT('           LOWER WALKS:',8I6)
810     CONTINUE
        WRITE(6,*)' OFFSETS IN MKSGNUM_MCLR'
        WRITE(6,*)' BY MIDVERTEX AND SYMMETRY.'
        DO 820 MV=1,NMIDV
          WRITE(6,*)
          WRITE(6,1234) MV,(IOW(1,IS,MV),IS=1,NSYM)
          WRITE(6,1235)    (IOW(2,IS,MV),IS=1,NSYM)
820     CONTINUE
      ENDIF
C
C
C     EXIT
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine optize2_cvb(fx,nparm,ioptc,iter_is_1,opta,optb)

use casvb_global, only: endwhenclose, expct, formAD, formAF, fxbest, hh, ip, maxize, odx, ograd
use casvb_interfaces, only: opta_sub, optb_sub
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: fx
integer(kind=iwp), intent(in) :: nparm
integer(kind=iwp), intent(inout) :: ioptc
logical(kind=iwp), intent(in) :: iter_is_1
procedure(opta_sub) :: opta
procedure(optb_sub) :: optb
integer(kind=iwp) :: iopth
real(kind=wp) :: dxnrm, exp_tc, grdnrm, s11, s12, s22
logical(kind=iwp) :: close2conv = .false., close2conv_begin, converged, first_time, opth, scalesmall1, skipupd, wrongstat
real(kind=wp), external :: ddot_, dnrm2_

converged = .false.
if (iter_is_1) close2conv = .false.

! << Initialization >>
call grad_cvb(ograd)
call ddproj_cvb(ograd,nparm)
grdnrm = dnrm2_(nparm,ograd,1)
call opta(nparm)

if (ip >= 2) write(u6,'(/a)') ' *****   2. order optimizer   *****'

! << Now trust region control >>
exp_tc = expct
first_time = .true.
opth = .false.
iopth = 0
do
  call trust_cvb(iopth,opth,maxize,fx,fxbest,expct,hh,dxnrm,ioptc,scalesmall1,close2conv,converged,skipupd)
  if (ioptc == -2) return

  ! << Make update >>
  if (.not. (skipupd .or. (hh == Zero))) then

    do
      close2conv_begin = close2conv

      call optb(nparm,dxnrm,grdnrm,close2conv)

      if (.not. first_time) exit
      first_time = .false.

      call testconv_cvb(fx,nparm,odx,ograd,exp_tc,close2conv,converged,wrongstat)

      if ((.not. close2conv) .or. close2conv_begin) exit
    end do
    if (((ip == 2) .and. (.not. opth)) .or. (ip >= 3)) then
      s11 = ddot_(nparm,odx,1,odx,1)
      s22 = ddot_(nparm,ograd,1,ograd,1)
      s12 = ddot_(nparm,odx,1,ograd,1)
      write(u6,formAD) ' Overlap between normalized vectors <DX|GRAD> :',s12/sqrt(s11*s22)
    end if
    call fxdx_cvb(fx,.false.,odx)
  end if
  if (.not. opth) exit
end do

if ((ioptc >= -1) .and. (hh /= Zero)) then
  if (ip >= 2) then
    write(u6,'(a)') ' '
    write(u6,formAF) ' HH & norm of update :',hh,dxnrm
  end if
  call update_cvb(odx)
end if
if (converged) then
  ioptc = 0
else if (close2conv .and. endwhenclose) then
  ioptc = -3
else
  ioptc = 1
end if

return

end subroutine optize2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE ALLOC_CPF(ISMAX,LPERMA)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      DIMENSION IPOF(9)
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
CPAM96      WRITE(6,50)
CPAM9650    FORMAT(/,6X,'DYNAMICAL CORE STORAGE INFORMATION',/)
      ISTOP=0
      MAX1=0
      MAX2=0
      NVMAX=0
      DO 10 I=1,NSYM
      CALL IPO_CPF(IPOF,NVIR,MUL,NSYM,I,-1)
      IF(IPOF(NSYM+1).GT.MAX1)MAX1=IPOF(NSYM+1)
      IF(NVIR(I).GT.NVMAX)NVMAX=NVIR(I)
      DO 20 J=1,NSYM
      IPF=IPOF(J+1)-IPOF(J)
      IF(IPF.GT.MAX2)MAX2=IPF
20    CONTINUE
10    CONTINUE
CPAM97      CALL ALSO(LW,IROW,LIC,NORBT,NVIRT,LN,ISTOP,IFIRST,
CPAM97     *MADR,LPERMA,LBUF,KBUF,JBUF,IPASS,IRC(1),ISMAX,KBUFF1)
      CALL ALSO(ISTOP,LPERMA,IRC(1),ISMAX)
C     VECTORS PERMANENTLY IN CORE DURING CI ITERATIONS
C     CI-VECTOR
C     C
      LW(26)=LPERMA
C     S (SIGMA)
      LW(27)=LW(26)+JSC(ILIM)
C     W
      LW(28)=LW(27)+JSC(ILIM)
C     ITHE (TETA)
      LW(29)=LW(28)+JSC(ILIM)
      IF(ICPF.EQ.1.OR.ISDCI.EQ.1.OR.INCPF.EQ.1)LW(29)=LW(28)
C     TPQ (ONE ROW)
      LW(30)=LW(29)+IRC(ILIM)*IRC(ILIM)
      IF(ICPF.EQ.1.OR.ISDCI.EQ.1.OR.INCPF.EQ.1)LW(30)=LW(29)
C     ENP (NP)
      LW(31)=LW(30)+IRC(ILIM)
C     EPP (EPRIME)
      LW(32)=LW(31)+IRC(ILIM)
C     BST (STORED BIJ MATRIX)
      LW(33)=LW(32)+IRC(ILIM)
C     ADDRESSES NOT USED
      LW(34)=LW(33)+(MAXIT+1)**2
      LW(35)=LW(34)
      LPERMB=LW(35)
C     DYNAMICAL ALLOCATION FOR AIBJ
C     MATRIX ABIJ
      LW(36)=LPERMB
C     MATRIX AIBJ
      LW(37)=LW(36)+MAX1
C     MATRIX AJBI
      LW(38)=LW(37)+MAX1
C     BUFIN , IBUFIN
      LW(39)=LW(38)+MAX1
C     A
CRL   LW(40)=LW(39)+2*LBUF+2
CPAM96      LW(40)=LW(39)+LBUF+LBUF/2+2
      LW(40)=LW(39)+((RTOI+1)*LBUF+2+(RTOI-1))/RTOI
C     B
      LW(41)=LW(40)+MAX2
C     F
      LW(42)=LW(41)+MAX2
C     FSEC
      LW(43)=LW(42)+MAX1
C     ADDRESSES NOT USED
      LW(44)=LW(43)+MAX1
      LW(45)=LW(44)
      LIM=LW(45)
      IF(LIM.GT.LIC) THEN
        ISTOP=1
        WRITE(6,*)'ALLOC: Too much storage needed for AIBJ.'
        WRITE(6,'(1X,A,2I10)')'LIM,LIC:',LIM,LIC
      END IF
C     DYNAMICAL ALLOCATION FOR IJKL
C     FIJKL
      LW(46)=LPERMB
      NIJ=IROW(LN+1)
      IJKL=(NIJ*(NIJ+1))/2
C     BUFIN , IBUFIN
      LW(47)=LW(46)+IJKL
C     ADDRESSES NOT USED
      LW(48)=LW(47)+KBUFF1+2
      LW(49)=LW(48)
      LIM=LW(49)
      IF(LIM.GT.LIC) THEN
        ISTOP=1
        WRITE(6,*)'ALLOC: Too much storage needed for IJKL.'
        WRITE(6,'(1X,A,2I10)')'LIM,LIC:',LIM,LIC
      END IF
C     DYNAMICAL ALLOCATION FOR ABCI
C     BMN
      LW(50)=LPERMB
C     IBMN
      JMAX=IAD10(1)
      IF(IFIRST.NE.0)JMAX=0
      LW(51)=LW(50)+JMAX
C     BIAC
      LW(52)=LW(51)+JMAX
C     BICA
      LW(53)=LW(52)+ISMAX
C     BUFIN
      LW(54)=LW(53)+ISMAX
C     ADDRESSES NOT USED
      LW(55)=LW(54)+KBUFF1
      LW(56)=LW(55)
      LIM=LW(56)
      IF(LIM.GT.LIC) THEN
        ISTOP=1
        WRITE(6,*)'ALLOC: Too much storage needed for ABCI.'
        WRITE(6,'(1X,A,2I10)')'LIM,LIC:',LIM,LIC
      END IF
C     DYNAMICAL ALLOCATION FOR ABCD
C     ACBDS
      LW(57)=LPERMB
C     ACBDT
      LW(58)=LW(57)+ISMAX
C     BUFIN
      LW(59)=LW(58)+ISMAX
C     ADDRESSES NOT USED
      LW(60)=LW(59)+KBUFF1
      LW(61)=LW(60)
      LIM=LW(61)
      IF(LIM.GT.LIC) THEN
        ISTOP=1
        WRITE(6,*)'ALLOC: Too much storage needed for ABCD.'
        WRITE(6,'(1X,A,2I10)')'LIM,LIC:',LIM,LIC
      END IF
C     DYNAMICAL ALLOCATION FOR FIJ, AI AND AB
C     FC
      LW(62)=LPERMB
      NOB2=IROW(NORBT+1)
C     BUFIN , IBUFIN
      LW(63)=LW(62)+NOB2
C     A
CRL   LW(64)=LW(63)+2*LBUF+2
CPAM96      LW(64)=LW(63)+LBUF+LBUF/2+2
      LW(64)=LW(63)+((RTOI+1)*LBUF+2+(RTOI-1))/RTOI
C     B
      LW(65)=LW(64)+MAX2
C     FK IN AI AND F IN AB
      LW(66)=LW(65)+MAX2
C     DBK
      LW(67)=LW(66)+NVMAX
      LIM=LW(67)+NVMAX
      LIM1=LW(66)+MAX1
      IF(LIM.LT.LIM1)LIM=LIM1
C     ADDRESSES NOT USED
      LW(68)=LIM
      LW(69)=LW(68)
      LW(70)=LW(69)
      LW(71)=LW(70)
      LIM=LW(71)
      IF(LIM.GT.LIC) THEN
        ISTOP=1
        WRITE(6,*)'ALLOC: Too much storage needed for FIJ,AI,AB'
        WRITE(6,'(1X,A,2I10)')'LIM,LIC:',LIM,LIC
      END IF
C     DYNAMICAL ALLOCATION FOR NPSET
C     TEMP
      LW(72)=LPERMB
C     ADDRESSES NOT USED
      LW(73)=LW(72)+IRC(ILIM)
      LW(74)=LW(73)
      LIM=LW(74)
CPAM96      WRITE(6,358)LIM
CPAM96358   FORMAT(6X,'STORAGE FOR NPSET',I14)
C     DYNAMICAL ALLOCATION FOR CPFCTL
C     EPB (EPBIS)
      LW(75)=LPERMB
C     AP (APPRIME)
      LW(76)=LW(75)+IRC(ILIM)
C     BIJ
      LW(77)=LW(76)+IRC(ILIM)
C     CN
      LW(78)=LW(77)+(MAXIT+1)**2
C     TEMP1
      LW(79)=LW(78)+MAXIT+1
      NTMAX=0
      DO 357 I=1,NSYM
      IF(NVIR(I).GT.NTMAX)NTMAX=NVIR(I)
      IF(NNS(I).GT.NTMAX)NTMAX=NNS(I)
357   CONTINUE
      IF(IRC(ILIM).GT.NTMAX)NTMAX=IRC(ILIM)
C     TEMP2
      LW(80)=LW(79)+NTMAX
      LIM=LW(80)+NTMAX
      IF(LIM.GT.LIC) THEN
        ISTOP=1
        WRITE(6,*)'ALLOC: Too much storage needed for CPFCTL'
        WRITE(6,'(1X,A,2I10)')'LIM,LIC:',LIM,LIC
      END IF
C     NATURAL ORBITALS
C     DENSITY MATRIX AT LPERMB , D
C     MOLECULAR ORBITALS ALL SYMMETRIES , CM
      LW(87)=LPERMB+NOB2
      LCIN=0
      NBMAX=0
      DO 350 I=1,NSYM
         NBMAX = MAX(NBMAX,NBAS(I))
         LCIN=LCIN+NBAS(I)*NBAS(I)
350   CONTINUE
C     NATURAL ORBITALS ONE SYMMETRY , CMO
      LW(88)=LW(87)+LCIN
C     DENSITY MATRIX FOR ONE SYMMETRY , DSYM
C     MOLECULAR ORBITAL IN AO-BASIS for one symmetry, CAO
      LW(89)=LW(88)+NBMAX*NBMAX
C     OCCUPATION NUMBERS FOR ALL POSSIBLE ORBITALS
      NTOT=0
      DO 333 I=1,NSYM
      NTOT=NTOT+NBAS(I)
333   CONTINUE
      LW(90)=LW(89)+NBMAX*NBMAX
C     OVERLAP MATRIX IN CHARGE
      LW(91)=LW(90)+NTOT
*     Scratch for property calculation
      LW(92)=LW(91)+LCIN
C     ADDRESSES NOT USED
      LW(93)=LW(92)
      LIM=LW(93)
CPAM96      WRITE(6,349)LIM
CPAM96349   FORMAT(6X,'STORAGE FOR DENS',I15)
      IF(IPRINT.GE.2) THEN
C LW(94), LW(95) AND LW(96) USED IN SORTING ABCD
        WRITE(6,450)
        WRITE(6,451)(LW(I),I=1,96)
450     FORMAT(//,6X,'DYNAMICAL STORAGE ADDRESSES LW:',/)
451     FORMAT(6X,5I10)
      END IF
      IF(ISTOP.EQ.0)RETURN
      WRITE(6,*)'ALLOC: Too little memory available.'
      WRITE(6,*)'Program stops here.'
      CALL Abend
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETVEC(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,SCR,LSCR)
!
! Purpose: read Cholesky vectors IVEC=IVEC1,....,IVEC1+NUMVEC-1
!          of symmetry ISYM from file. The vectors are returned
!          in the "current" reduced set. The algorithm used for
!          reading is taken from input (via Cholesky module).

use Cholesky, only: CHO_IOVEC, InfVec, iScr, LuCho, LuPri, MaxVec, nnBstR, nSym
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LENVEC, NUMVEC, IVEC1, ISYM, LSCR
real(kind=wp), intent(inout) :: CHOVEC(LENVEC,NUMVEC), SCR(LSCR)
integer(kind=iwp) :: IFAIL, IVEC, IVEC2, JADR, JVEC
real(kind=wp) :: XNRM
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_GETVEC'
real(kind=wp), external :: ddot_

! Return if no vectors requested.
! -------------------------------

if (NUMVEC < 1) then
  if (LOCDBG) then
    write(LUPRI,*) SECNAM,': WARNING: no vectors in this call!'
    write(LUPRI,*) SECNAM,': NUMVEC = ',NUMVEC
  end if
  return
end if

! Check vector dimension: should be identical to current reduced
! set. Check also symmetry and vector index.
! --------------------------------------------------------------

if (LOCDBG) then
  IFAIL = 0
  if ((LENVEC /= NNBSTR(ISYM,2)) .or. (LENVEC < 1)) then
    write(LUPRI,*) SECNAM,': illegal vector dimension:'
    write(LUPRI,*) SECNAM,': LENVEC = ',LENVEC
    IFAIL = IFAIL+1
  end if
  if ((ISYM < 1) .or. (ISYM > NSYM)) then
    write(LUPRI,*) SECNAM,': illegal symmetry input:'
    write(LUPRI,*) SECNAM,': ISYM = ',ISYM
    IFAIL = IFAIL+1
  end if
  IVEC2 = IVEC1+NUMVEC-1
  if ((IVEC1 < 1) .or. (IVEC1 > MAXVEC) .or. (IVEC2 < 1) .or. (IVEC2 > MAXVEC)) then
    write(LUPRI,*) SECNAM,': illegal vector index:'
    write(LUPRI,*) SECNAM,': IVEC1,IVEC2 = ',IVEC1,IVEC2
    IFAIL = IFAIL+1
  else
    if (INFVEC(IVEC1,3,ISYM) < 0) then
      write(LUPRI,*) SECNAM,': illegal first vector address:'
      write(LUPRI,*) SECNAM,': address: ',INFVEC(IVEC1,3,ISYM)
      IFAIL = IFAIL+1
    end if
    if (INFVEC(IVEC2,3,ISYM) < 0) then
      write(LUPRI,*) SECNAM,': illegal last vector address:'
      write(LUPRI,*) SECNAM,': address: ',INFVEC(IVEC2,3,ISYM)
      IFAIL = IFAIL+1
    end if
  end if
  if ((CHO_IOVEC == 1) .or. (CHO_IOVEC == 2) .or. (CHO_IOVEC == 3) .or. (CHO_IOVEC == 4)) then
    if (size(ISCR) < NNBSTR(ISYM,2)) then
      write(LUPRI,*) SECNAM,': insufficient iscratch:'
      write(LUPRI,*) SECNAM,': SIZE(ISCR) = ',size(ISCR)
      IFAIL = IFAIL+1
    end if
  end if
  if (IFAIL /= 0) then
    write(LUPRI,*) SECNAM,': unable to continue!'
    call CHO_QUIT('Error in '//SECNAM,104)
  end if
end if

! Call reading routine.
! ---------------------

if (CHO_IOVEC == 1) then
  call CHO_GETVEC1(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,SCR,LSCR)
else if ((CHO_IOVEC == 2) .or. (CHO_IOVEC == 3) .or. (CHO_IOVEC == 4)) then
  call CHO_GETVEC2(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,SCR,LSCR)
else
  call CHO_GETVEC0(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,SCR,LSCR)
end if

! Debug print.
! ------------

if (LOCDBG) then
  call XFLUSH(LUPRI)
  write(LUPRI,*)
  write(LUPRI,*) SECNAM,':'
  write(LUPRI,*) 'Vectors ',IVEC1,' to ',IVEC1+NUMVEC-1,' of symmetry ',ISYM,' read from unit ',LUCHO(ISYM)
  write(LUPRI,*) 'Vector dimension: ',LENVEC,' (current reduced set)'
  write(LUPRI,*) 'Algorithm: ',CHO_IOVEC
  do IVEC=1,NUMVEC
    JVEC = IVEC1+IVEC-1
    JADR = INFVEC(JVEC,3,ISYM)
    XNRM = sqrt(DDOT_(LENVEC,CHOVEC(:,IVEC),1,CHOVEC(:,IVEC),1))
    write(LUPRI,*) 'Vector:',JVEC,' address: ',JADR,' norm: ',XNRM
  end do
  call XFLUSH(LUPRI)
end if

end subroutine CHO_GETVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_RI_Final(irc,nVec_RI,l_nVec_RI)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: l_nVec_RI, nVec_RI(l_nVec_RI)
#include "cholesky.fh"

if (l_nVec_RI < nSym) then
  irc = 1
else
  irc = 0
  call Put_iArray('nVec_RI',nVec_RI,nSym)
end if

return

end subroutine Cho_RI_Final

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine stringen_cvb(norb,nel,locc,lunocc)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: norb, nel
integer(kind=iwp), intent(inout) :: locc(*), lunocc(*)
integer(kind=iwp) :: i_locc, i_lunocc, indx, iorb, rc
integer(kind=iwp), allocatable :: nk(:), nkmax(:), nkmin(:)

call mma_allocate(nk,[0,norb],label='nk')
call mma_allocate(nkmax,[0,norb],label='nkmax')
call mma_allocate(nkmin,[0,norb],label='nkmin')
! Spin string loop initialization (use xdet as graph storage):
do iorb=0,norb
  nkmin(iorb) = max(iorb-norb+nel,0)
  nkmax(iorb) = min(iorb,nel)
end do
nk(:) = nkmax(:)
! Spin string loop starts here:
indx = 0
do
  indx = indx+1
  i_locc = (indx-1)*nel+1
  i_lunocc = (indx-1)*(norb-nel)+1
  call occupy_cvb(nk,norb,locc(i_locc),lunocc(i_lunocc))
  call loop_cvb(norb,nk,nkmin,nkmax,rc)
  if (rc == 0) exit
end do
call mma_deallocate(nk)
call mma_deallocate(nkmax)
call mma_deallocate(nkmin)

return

end subroutine stringen_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001-2005, Valera Veryazov                             *
*               2020, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine TransTbl(Filename)
c
c  translate basis file names
c
      character *256 Filename, DirName, OrigName, TransName
      character *256 Line
      Integer Strnln,irecl
      External StrnLn
      logical is_error,found
      iunit=20
      iunit=isfreeunit(iunit)
      ileft=0
      i=Strnln(FileName)
      found=.false.
      do while((.not.found).and.(i.gt.1))
        if(FileName(i:i).eq.'/') then
           ileft=i
           found=.true.
        endif
        i=i-1
      enddo
c
      if(.not.found) then
        ileft=0
        i=Strnln(FileName)
        found=.false.
        do while((.not.found).and.(i.gt.1))
          if(FileName(i:i).eq.'_') then
             ileft=i
             found=.true.
          endif
          i=i-1
        enddo
      endif
      DirName=Filename(1:ileft)
      i=index(Filename,' ')
      if(i.le.0) i=len(Filename)+1
      OrigName=Filename(ileft+1:i-1)
      LenOrig=i-ileft
      call molcas_open_ext2(iunit,DirName(1:ileft)//'trans.tbl',
     & 'sequential','formatted',iostat,.false.,irecl,'unknown',
     & is_error)
c      open(iunit,file=DirName(1:ileft)//'trans.tbl',
c     &        Form='FORMATTED',IOSTAT=IOStat)
      If (IOStat.ne.0) Then
         close(iunit)
         call molcas_open_ext2(iunit,'BASLIB_trans.tbl',
     & 'sequential','formatted',iostat,.false.,irecl,
     &  'unknown',is_error)
c         open(iunit,file='BASLIB_trans.tbl',
c     &        Form='FORMATTED',IOSTAT=IOStat)
        If (IOStat.ne.0) Then
          write(6,*) 'trans.tbl is not found'
         close(iunit)
       return
      endif
      endif
20    read(iunit,'(a)',end=30, err=30) Line
      i=index(Line,OrigName(1:LenOrig-1))
      if(i.ne.1.or.Line(LenOrig:LenOrig).ne.' ') goto 20
       i=LenOrig+1
25     if (Line(i:i).eq.' ') then
        i=i+1
        if(i.lt.len(Line))goto 25
       endif
       ib=i
       ia=index(Line(ib:),' ')
       if(ia.eq.0) ia=len(Line)+1
       TransName=Line(ib:ib+ia-1)
       FileName=DirName(1:ileft)//Line(ib:ib+ia-1)
#ifdef _DEBUGPRINT_
       write(6,*) '*** Basis set was redirected to ',FileName
#endif
30     close(iunit)
       return
      end
      Subroutine BasisTbl(Label,BasDir)
c
c  a routine to translate basis set labels
c
      Character*(*) Label
      Character Temp*256, Line*256
      Character *(*) BasDir
      Integer Strnln,irecl
      External StrnLn
      Logical Exist,is_error
C     i=index(Label,'.')
C     if(i.gt.0) then
C     i=index(Label(i+1:),'.')
c return if we have a complete name
C     if(i.ne.0) return
C     endif
      Temp=BasDir//'/basis.tbl'
      Call f_Inquire(Temp,Exist)
      if(.not.Exist) Return
      jUnit=15
      iUnit=isfreeunit(jUnit)
      call molcas_Open_ext2(iunit,temp,'sequential','formatted',
     & iostat,.false.,irecl,'unknown',is_error)
c      open(unit=iUnit,File=Temp,form='FORMATTED',IOSTAT=IOStat)
      if(IOStat.ne.0) return
      iLast=StrnLn(Label)
*
*
*     Strip trailing dots
*
99    If (Label(iLast:iLast).eq.'.') Then
         iLast=iLast-1
         Go To 99
      End If
C     Write (*,*) 'Label(1:iLast)=',Label(1:iLast)
100     read(iUnit,'(a)',end=200,err=200) Line
        if(Line(1:1).eq.'#') goto 100
        if(Line.eq.' ') goto 100
        Call UpCase(Line)
*
*       Identify first non-blank segment in Line
*
        jlast=0
 98     If (Line(jlast+1:jlast+1).ne.' ') Then
           jLast = jLast +1
           Go To 98
        End If
        If (jlast.ne.ilast) Go To 100
c       i=index(Line,Label(1:iLast))
        i=index(Line(1:jlast),Label(1:iLast))
        if(i.ne.1) goto 100
        i=iLast+1
150      if(Line(i:i).eq.' ') then
         i=i+1
         goto 150
         endif
         ib=i
         ia=index(Line(ib:),' ')
         if(ia.eq.0) ia=len(Line)+1
#ifdef _DEBUGPRINT_
         write(6,'(3a)') Label(1:iLast),'translated to ',
     &      Line(ib:ib+ia-1)
#endif
        Label=Line(ib:ib+ia-1)
200     close(iUnit)
        return
        end
      Subroutine BasisType(Filename,inline,BasisTypes)
c
c  translate basis file names
c
      character *(*) Filename
      Logical King
      External King
      Integer StrnLn
      External StrnLn
      character *256 DirName, OrigName
      character *256 Line, LineComp
      Character *4 tmp
      integer BasisTypes(4),irecl
      logical is_error,found
      character*16 CONT, ALLE, RELA, NUCL
      character*3 vCONT, vALLE, vRELA, vNUCL
#include "basistype.fh"
      CONT='#Contraction '
      ALLE='#AllElectron '
      RELA='#Hamiltonian '
      NUCL='#Nucleus '
      vCONT='UNK'
      vALLE='UNK'
      vRELA='UNK'
      vNUCL='UNK'
      isKnown=0
      If (inline.eq.1) Then
         BasisTypes(1)=-1
         BasisTypes(2)=-1
         BasisTypes(3)=-1
         BasisTypes(4)=-1
         call SysWarnMsg('BasisType','inline basis is used',
     * 'assuming all defaults for the basis types')
         Return
      End If
      BasisTypes(3)=0
      iunit=20
      iunit=isfreeunit(iunit)
      ileft=StrnLn(FileName)
      i=StrnLn(FileName)
      found=.false.

      do while((.not.found).and.(i.gt.1))
        if(FileName(i:i).eq.'/') then
           ileft=i
           found=.true.
        endif
        i=i-1
      enddo

      if(.not.found) then
        ileft=StrnLn(FileName)
        i=StrnLn(FileName)
        do while((.not.found).and.(i.gt.1))
           if(FileName(i:i).eq.'_') then
           ileft=i
           found=.true.
           endif
        i=i-1
        enddo
      endif
      DirName=Filename(1:ileft)
      i=index(Filename,' ')
      if(i.eq.0) i=len(Filename)
      OrigName=Filename(ileft+1:i)
      LenOrig=i-ileft
c
c first, check tbl.
      call molcas_open_ext2(iunit,DirName(1:ileft)//'basistype.tbl',
     & 'sequential','formatted',iostat,.false.,irecl,'old',is_error)
c      open(iunit,file=DirName(1:ileft)//'basistype.tbl',
c     &        Form='FORMATTED',IOSTAT=IOStat)
         if(Iostat.ne.0) then
         close(iunit)
          call molcas_open_ext2(iunit,'BASLIB_basistype.tbl',
     & 'sequential','formatted',iostat,.false.,irecl,'old',is_error)
c         open(iunit,file='BASLIB_basistype.tbl',
c     &        Form='FORMATTED',IOSTAT=IOStat)
        endif
        If (IOStat.ne.0) Then
          write(6,*) 'basistype.tbl is not found'
         close(iunit)
       goto 40
      endif
20    read(iunit,'(a)',end=30, err=30) Line
      if(Line(1:1).eq.'#') goto 20
      i=index(Line,OrigName(1:LenOrig-1))
      if(i.ne.1.or.Line(LenOrig:LenOrig).ne.' ') goto 20
       i=LenOrig+1
       iL=1
       iflag=0
       LineComp=' '
       Do jj=i,256
       if(Line(jj:jj).eq.' ') then
         if(iflag.eq.0) then
           iflag=1
           LineComp(iL:iL)=':'
           iL=iL+1
         endif
       else
         iflag=0
         LineComp(iL:iL)=Line(jj:jj)
         iL=iL+1
       endif
       enddo
       isKnown=1
       vCONT=LineComp(2:4)
       vALLE=LineComp(6:8)
       vRELA=LineComp(10:12)
       vNUCL=LineComp(14:16)
       if(vCONT.eq.' ') vCONT='UNK'
       if(vALLE.eq.' ') vALLE='UNK'
       if(vRELA.eq.' ') vRELA='UNK'
       if(vNUCL.eq.' ') vNUCL='UNK'
30     close(iunit)


c now let's check the header of the basis file
c
      if(OrigName(1:LenOrig-1).eq.' ') goto 40
      Call f_Inquire(DirName(1:ileft)//OrigName(1:LenOrig-1),Found)
      if(.not.Found) goto 40
c      print *, 'open >',DirName(1:ileft)//OrigName(1:LenOrig-1),'<'
      call molcas_open(iunit,DirName(1:ileft)//OrigName(1:LenOrig-1))
777   read(iunit,'(a)', end=35, err=35) Line
      if(Line(1:1).eq.'/') then
c  we already reached body of the file.
       LineComp=':'//vCONT//':'//vALLE//':'//vRELA//':'//vNUCL//':'
             isKnown=1
             goto 35
      endif
c     finish reading, let's create the return string

c       print *,'line=',Line
      if(index(Line,CONT(1:index(CONT,' '))).eq.1) then
         i=index(Line,' ')
         do j=i,len(Line)
           if(Line(j:j).ne.' ') goto 701
         enddo
701         vCONT=Line(j:j+3)
      endif
      if(index(Line,ALLE(1:index(ALLE,' '))).eq.1) then
         i=index(Line,' ')
         do j=i,len(Line)
           if(Line(j:j).ne.' ') goto 702
         enddo
702        vALLE=Line(j:j+3)
      endif
      if(index(Line,RELA(1:index(RELA,' '))).eq.1) then
         i=index(Line,' ')
         do j=i,len(Line)
           if(Line(j:j).ne.' ') goto 703
         enddo
703        vRELA=Line(j:j+3)
      endif

      if(index(Line,NUCL(1:index(NUCL,' '))).eq.1) then
         i=index(Line,' ')
         do j=i,len(Line)
           if(Line(j:j).ne.' ') goto 704
         enddo

704       vNUCL=Line(j:j+3)
      endif

      goto 777

c
c well. now use tbl
c
35     close(iunit)
40     if(isKnown.eq.0) LineComp=':UNK:UNK:UNK:UNK:'
c       print *,'DEBUG=',LineComp
          tmp=LineComp(2:5)
          i1=index(BasTypeCon,tmp)
          if(i1.eq.0.or.tmp.eq.'UNK:') Then
             BasisTypes(1)=-1
          Else
             i1=i1/4+1
             BasisTypes(1)=i1
          End If
c
          tmp=LineComp(6:9)
          i1=index(BasTypeAll,tmp)
          if(i1.eq.0.or.tmp.eq.'UNK:') Then
             BasisTypes(2)=-1
          Else
             i1=i1/4+1
             BasisTypes(2)=i1
c hack to map YES to AE_, and NO_ to NAE
             if(BasisTypes(2).eq.3) BasisTypes(2)=1
             if(BasisTypes(2).eq.4) BasisTypes(2)=2
          EndIf
c
          tmp=LineComp(10:13)
          i1=index(BasTypeRel,tmp)
          if(i1.eq.0.or.tmp.eq.'UNK:') Then
             BasisTypes(3)=-1
          Else
             i1=i1/4+1
             BasisTypes(3)=i1
          EndIf
c
          tmp=LineComp(14:17)
          i1=index(BasTypeNuc,tmp)
          if(i1.eq.0.or.tmp.eq.'UNK:') Then
             BasisTypes(4)=-1
          Else
             i1=i1/4+1
             BasisTypes(4)=i1
          EndIf

       return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007,2008, Roland Lindh                                *
!***********************************************************************

subroutine Mk_RICD_Shells()
!***********************************************************************
!                                                                      *
!    Objective: To generate aCD auxiliary basis sets on-the-fly.       *
!                                                                      *
! Called from: RdCtl_Seward                                            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chem. Phys., Lund Univ., Sweden.  *
!                                                                      *
!             Final implementation for aCD and acCD auxiliary          *
!             basis sets developed while visiting N. Ferre' at the     *
!             Univ. of Provance (champus Univ. Paul Cezanne) in        *
!             Marseille, France, 20 March - 19 April.                  *
!                                                                      *
!             Modified to transform the auxiliary basis to a true      *
!             Cholesky basis set while on TACC 2008 conference in      *
!             Songjiang District, Shanghai, China, 23-27 Sept. 2008.   *
!                                                                      *
!***********************************************************************

use Real_Spherical, only: Sphere, Sphere_Free
use Basis_Info, only: dbsc, nCnttp
use Sizes_of_Seward, only: S
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iCnttp, jCnttp, mCnttp, nDiff
logical(kind=iwp) :: DoRys, W2L

!                                                                      *
!***********************************************************************
!                                                                      *
!define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
iPrint = 49
!iPrint = 99
#endif
!                                                                      *
!***********************************************************************
!                                                                      *

call StatusLine('Gateway:',' Generating aCD or acCD auxiliary basis set')
!                                                                      *
!***********************************************************************
!                                                                      *
! Preamble: Compute kOffAO  and lOffAO

call Setup_OffAO()

! Set up transformation matrix from Cartesian to real spherical harmonics.

call Sphere(S%iAngMx)

! Setup of tables for coefficients for the Rys roots and weights.

nDiff = 0
if (S%iAngMx == 0) nDiff = 2
DoRys = .true.
call SetUp_RW(DoRys,nDiff)

mCnttp = nCnttp
!                                                                      *
!***********************************************************************
!                                                                      *
! Add the DUMMY SHELL!

call Mk_Dummy_Shell()
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Loop now over all unique valence basis sets and generate the
! corresponding aCD auxiliary basis sets. Note that there are two
! different types of aCD auxiliary basis sets, aCD and acCD.

do iCnttp=1,mCnttp
  if (dbsc(iCnttp)%Frag .or. (dbsc(iCnttp)%nVal == 0)) cycle
# ifdef _DEBUGPRINT_
  if (iPrint >= 99) write(u6,*) 'Generating auxiliary basis set for valence basis:',iCnttp
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Procrastinate the printing of the RICD basis set to library
  ! until the last unique valence basis set is processed.

  W2L = .true.
  do jCnttp=iCnttp+1,mCnttp
    if (dbsc(iCnttp)%Bsl_old == dbsc(jCnttp)%Bsl_old) then
      W2L = .false.
      exit
    end if
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! aCD and acCD section

  call Mk_aCD_acCD_Shells(iCnttp,W2L)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Basis_Mode('Valence')
!                                                                      *
!***********************************************************************
!                                                                      *
! Cleanup the mess!

call CloseR()
call Sphere_Free()
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Mk_RICD_Shells

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine atens(moment, dim, gtens, maxes, iprint)

      Implicit None
      Integer, parameter         :: wp=SELECTED_REAL_KIND(p=15,r=307)
c Calling variables:
      Integer,          intent(in)  :: dim, iprint
      Complex (kind=8),intent(in)  :: moment(3,dim,dim)
      Real (kind=8),   intent(out) :: gtens(3)
      Real (kind=8),   intent(out) :: maxes(3,3)
c----------------------------------------------
c  dim    -- size of the magnetic moment
c            dim = muliplicity of the pseuDospin ( 2*S+1, where S is the pseuDospin);
c  moment -- matrix of size (3,dim,dim) of the moment (magnetic, spin or angular)
c  gtens  -- array of size (3) keeping the main values of the A tensor ( sqrt(main_values) )
c  maxes  -- array of size (3,3) keeping the main axes of the A tensor Writen in
c            the right coordinate system (Determinant = +1)
c  iprint -- the print level of the Subroutine
c            iprint = 1 => no output
c            iprint = 2 => standard
c            iprint = 3 => print for debug
c----------------------------------------------
c local variables
      Integer           :: ic1, ic2, i, j, info
      Real (kind=8)    :: A_TENS_TERM(3,3), W(3), MAIN(3), Z(3,3),
     &                     factor, Det_gtens, diff12, diff23,
     &                     ZR(3,3), dnorm
      Real (kind=8)    :: dznrm2, FindDetR
      Complex (kind=8) :: AC_TENS(3,3), trace
      External          :: dznrm2, FindDetR, trace


      dnorm=0.0_wp
      dnorm =  dznrm2(3*dim*dim, moment, 1 )

      If ( dnorm.le.tiny(0.0_wp) ) Then
         Write(6,'(A)') 'Norm of the magnetic moment is zero.'
         Write(6,'(A)') 'Returning the default (dummy) values'
         gtens=0.0_wp
         maxes=0.0_wp
         Do i=1,3
            maxes(i,i)=1.0_wp
         End Do
         Return
      End If

c initialization:
      Do I=1,3
         Do J=1,3
            AC_TENS(I,J)=(0.0_wp,0.0_wp)
            A_TENS_TERM(I,J)=0.0_wp
         End Do
      End Do

      Do ic1=1,3
         Do ic2=1,3
            Ac_tens(ic1,ic2)=trace(dim,moment(ic1,1:dim,1:dim),
     &                                 moment(ic2,1:dim,1:dim))
         End Do
      End Do

      Do ic1=1,3
         Do ic2=1,3
            A_TENS_TERM(ic1,ic2)=DBLE( Ac_tens( ic1, ic2 ) +
     &                                 Ac_tens( ic2, ic1 ) ) /2.0_wp
         End Do
      End Do

      factor=0.0_wp
      factor=12.0_wp/dble( dim**3-dim )
      Do ic1=1,3
         Do ic2=1,3
            A_TENS_TERM(ic1,ic2)=factor*A_TENS_TERM(ic1,ic2)
         End Do
      End Do

      If (iprint.gt.2) Then
         Write(6,'(/)')
         Write(6,'(5X,A)') 'A_TENS_TERM(ic1,ic2):'
         Write(6,*)
         Do ic1=1,3
            Write(6,'(5X,3(2F14.7,3x))') (A_TENS_TERM(ic1,ic2),ic2=1,3)
         End Do
      End If
c
C   Diagonalization of A_tens - g tensors
C
      Do I=1,3
      main(I)=0.0_wp
      w(I)=0.0_wp
         Do J=1,3
         z(I,J)=0.0_wp
         End Do
      End Do
      info=0

      Call DIAG_R2(A_TENS_TERM(1:3,1:3), 3, info, W(1:3),  Z(1:3,1:3))

      If (INFO.ne.0) Go To 199
      If ((w(1).lt.0._wp).AND.(w(2).lt.0._wp).AND.(w(3).lt.0._wp)) Then
      Write(6,'(2x,A)') 'ALL EIGENVALUES OF THE A-TENSOR ARE NEGATIVE'
      Write(6,'(2X,A)') 'THIS IS A VERY UNUSUAL SITUATION. PLEASE'//
     & 'CHECK MANUALLY '
      Write(6,'(2x,A)') 'THE FOLLOWING PART OF THE PSEUDoSPIN SECTION'
      Write(6,'(2x,A)') 'MUST BE DISREGARDED. THE RESULTS ARE NOT' //
     & 'TRUSTABLE.'
      Go To 199
      End If
c
      If (iprint.gt.2) Then
      Write(6,*)
      Write(6,'(4x,A)') 'A_TENS_TERM TENSOR:'
      Write(6,'(65a)') ('-',i=1,56),'|'
      Write(6,'(4x,A,4x,A,13x,A,5x,a,3x,a)') 'MAIN VALUES','|',
     & 'MAIN MAGNETIC AXES','|', 'x , y , z  -- initial Cartesian axes'
      Write(6,'(57a,3x,a)') ('-',i=1,19),'|',('-',i=1,36),'|',
     & 'Xm, Ym, Zm -- main magnetic axes'
      Write(6,'(19x,a,4x,a,5x,a,9x,a,9x,a,5x,a)') '|','|','x','y','z',
     & '|'
      Write(6,'(65a)') ('-',i=1,19),'|',('-',i=1,4),'|',('-',i=1,31),
     & '|'
      Write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gX = ',w(1),' | Xm |',
     & (z(j,1),j=1,3),'|'
      Write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gY = ',w(2),' | Ym |',
     & (z(j,2),j=1,3),'|'
      Write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gZ = ',w(3),' | Zm |',
     & (z(j,3),j=1,3),'|'
      Write(6,'(65a)') ('-',i=1,56),'|'
      End If

      Do I=1,3
      If (W(I).lt.0.0_wp) Then
         W(I)= 1.0e-24_wp
      End If
         MAIN(i)=sqrt(W(i))
      End Do

C  Check the sign of the coordinate system. If CS is Left-handed,
C  Then change it to RIGHT-handed
      Det_gtens=0.0_wp
      Do I=1,3
         Do J=1,3
            ZR(I,J)=0.0_wp
            ZR(I,J)=Z(I,J)
         End Do
      End Do

      Det_gtens=FindDetR(ZR,3)

      If (Det_gtens.lt.0.0_wp) Then
         Do i=1,3
            Z(i,1)=-Z(i,1)
         End Do
         If (iprint.gt.2) Then
            Write(6,'(a)') 'The coordinate system is LEFT-handed.'
            Write(6,'(a)') 'It has been changed to RIGHT-handed'
         End If
      End If

      diff12=0.0_wp
      diff23=0.0_wp
      diff12=MAIN(2)-MAIN(1)
      diff23=MAIN(3)-MAIN(2)

      If (iprint.gt.2) Then
         Write(6,'(5x,a,3F19.15)') 'diff12 = ', diff12
         Write(6,'(5x,a,3F19.15)') 'diff23 = ', diff23
      End If

      Do i=1,3
         gtens(i)=0.0_wp
         Do j=1,3
            maxes(i,j)=0.0_wp
         End Do
      End Do
c set the main Z axis:
      If (diff12 > diff23) Then
         gtens(3)=MAIN(1)
         gtens(2)=MAIN(2)
         gtens(1)=MAIN(3)

         If (Z(3,1).ge.0._wp) Then
            Do i=1,3
            maxes(i,3)=Z(i,1)
            maxes(i,1)=Z(i,3)
            End Do
         Else If (Z(3,1).lt.0._wp) Then
            Do i=1,3
            maxes(i,3)=-1._wp*Z(i,1)
            maxes(i,1)=Z(i,3)
            End Do
         End If

          maxes(1,2)=maxes(2,3)*maxes(3,1)-maxes(2,1)*maxes(3,3)
          maxes(2,2)=maxes(1,1)*maxes(3,3)-maxes(1,3)*maxes(3,1)
          maxes(3,2)=maxes(1,3)*maxes(2,1)-maxes(1,1)*maxes(2,3)

      Else If (diff23 > diff12) Then
         gtens(3)=MAIN(3)
         gtens(2)=MAIN(2)
         gtens(1)=MAIN(1)

         If (Z(3,3).ge.0._wp) Then
            Do i=1,3
            maxes(i,3)=Z(i,3)
            maxes(i,1)=Z(i,1)
            End Do
         Else If (Z(3,3).lt.0.0_wp) Then
            Do i=1,3
            maxes(i,3)=-1.0_wp*Z(i,3)
            maxes(i,1)=Z(i,1)
            End Do
         End If

         maxes(1,2)=maxes(2,3)*maxes(3,1)-maxes(2,1)*maxes(3,3)
         maxes(2,2)=maxes(1,1)*maxes(3,3)-maxes(1,3)*maxes(3,1)
         maxes(3,2)=maxes(1,3)*maxes(2,1)-maxes(1,1)*maxes(2,3)
      Else !( diff23==diff12)
!        this special case is isotropic:
!        therefore assign main axes as close as to be to the cartesian xyz
         Do i=1,3
            gtens(i)=MAIN(i)
            maxes(i,i)=1.0_wp
         End Do

      End If
      If (iprint.gt.2) Then
         Write(6,*)
         Write(6,'(20X,A)') 'A-TENSOR:'
         Write(6,*)
         Write(6,'(10X,A,10X,3(F11.5,2X))') '|  xx    xy    xz  |',
     &                                      (A_TENS_TERM(1,i),i=1,3)
         Write(6,'(10X,A,10X,3(F11.5,2X))') '|  yx    yy    yz  |',
     &                                      (A_TENS_TERM(2,i),i=1,3)
         Write(6,'(10X,A,10X,3(F11.5,2X))') '|  zx    zy    zz  |',
     &                                      (A_TENS_TERM(3,i),i=1,3)
      End If

      If (iprint.GE.2) Then
         Write(6,*)
         Write(6,'(4x,A)') 'g TENSOR:'
         Write(6,'(65a)') ('-',i=1,56),'|'
         Write(6,'(4x,A,4x,A,13x,A,5x,a,3x,a)') 'MAIN VALUES','|',
     &                      'MAIN MAGNETIC AXES','|',
     &                      'x , y , z  -- initial Cartesian axes'
         Write(6,'(26a,3x,a)') ('-',i=1,19),'|',('-',i=1,4),'|',
     &                      '----- x ------- y ------- z ---|',
     &                      'Xm, Ym, Zm -- main magnetic axes'
c         Write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gX = ',gtens(1),' | Xm |',
c     &                                      (maxes(j,1),j=1,3),'|'
c         Write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gY = ',gtens(2),' | Ym |',
c     &                                      (maxes(j,2),j=1,3),'|'
c         Write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gZ = ',gtens(3),' | Zm |',
c     &                                      (maxes(j,3),j=1,3),'|'
         Write(6,'(A,F18.14,A,3F18.14,1x,A)')
     &       ' gX = ',gtens(1),' | Xm |',(maxes(j,1),j=1,3),'|'
         Write(6,'(A,F18.14,A,3F18.14,1x,A)')
     &       ' gY = ',gtens(2),' | Ym |',(maxes(j,2),j=1,3),'|'
         Write(6,'(A,F18.14,A,3F18.14,1x,A)')
     &       ' gZ = ',gtens(3),' | Zm |',(maxes(j,3),j=1,3),'|'
         Write(6,'(65a)') ('-',i=1,56),'|'

      End If

 199  Continue

      Return
      End Subroutine atens

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
*  Cho_X_getVfull
*
*> @brief
*>   Reorder Cholesky vectors from reduced to full storage
*> @author F. Aquilante
*>
*> @details
*> This routine reorders Cholesky vectors from reduced to
*> full storage. For \p DoRead = ``.true.`` the vectors are read from
*> disk using array \p RedVec as scratch space, whereas for
*> \p DoRead = ``.false.`` the reduced vectors must be supplied in
*> array \p RedVec.
*>
*> Given a set of pointers (\p ipChoV) to target
*> arrays, the routine reorders \p NUMV Cholesky
*> vectors of compound symmetry \p ISYM starting with
*> vector \p JVEC1 and returns them in the target arrays.
*> Each pointer should thereby point to a
*> location where the corresponding Cholesky
*> vector of a given unique symmetry pair
*> of indices has to be stored.
*>
*> - \p iSwap = ``0``: \f$ L(a,b,J) \f$ is returned (in LT-storage if \f$ \mathrm{sym}(a)=\mathrm{sym}(b) \f$)
*> - \p iSwap = ``1``: \f$ L(a,J,b) \f$ is returned
*> - \p iSwap = ``2``: \f$ L(a,J,b) \f$ is returned (in SQ-storage if \f$ \mathrm{sym}(a)=\mathrm{sym}(b) \f$)
*>
*> - \p iSkip(syma) = ``0``: skip the symmetry block \f$ a \f$. Any vector \f$ L_{ab} \f$ or \f$ L_{ba} \f$
*>                           with \c syma &times; \c symb = \p ISYM won't be returned in the target array
*>
*> - \p IREDC: reduced set in core at the moment of the call to the routine.
*>             Can be set to ``-1`` (= unknown or undefined) by the calling routine.
*>
*> @param[out] irc     return code
*> @param[in]  RedVec  vectors stored in reduced set(s) [\p DoRead option off]
*>                     or scratch space for reading reduced vectors [\p DoRead option on]
*> @param[in]  lRedVec size of the \p RedVec
*> @param[in]  IVEC1   first vector to read
*> @param[in]  NUMV    number of vectors to read starting from \p IVEC1
*> @param[in]  ISYM    compound symmetry of the Cholesky vectors
*> @param[in]  iSwap   type of the full storage for the returned Cholesky vectors
*> @param[in]  IREDC   current reduced set in core (location ``3``)
*> @param[in]  ipChoV  pointers to the target arrays
*> @param[in]  iSkip   skipping parameters for each symmetry block \f$ (ab) \f$ of compound symmetry \p ISYM
*> @param[in]  DoRead  flag for reading reduced vectors from disk
************************************************************************
      Subroutine Cho_X_getVfull(irc,RedVec,lRedVec,IVEC1,NUMV,ISYM,
     &                          iSwap,IREDC,ipChoV,iSkip,DoRead)
      Implicit Real*8 (a-h,o-z)
      Dimension RedVec(lRedVec)
      Integer   ipVec(8),nnBSF(8,8),n2BSF(8,8)
      Integer   ipChoV(*),iSkip(*)
      Logical   DoRead
      Character*14 SECNAM
      Parameter (SECNAM = 'Cho_X_GetVfull')

#include "cholesky.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

**************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      MXUSD = 0
      MUSED = 0

      do i=1,nSym
         ipVec(i) = ipChoV(i)
      end do


      Call set_nnBSF(nSym,Nbas,nnBSF,n2BSF)


      if(iSwap.eq.0)then

       Do iSymq=1,nSym
         iSymp = muld2h(iSym,iSymq)
         if(nnBSF(iSymp,iSymq).gt.0)then
          if (iSymp.ge.iSymq .and. iSkip(iSymp).ne.0 ) then
            Call FZero(Work(ipChoV(iSymp)),nnBSF(iSymp,iSymq)*NUMV)
          endif
         endif
       End Do

      elseif(iSwap.eq.1 .or. iSwap.eq.2)then

       Do iSymq=1,nSym
         iSymp = muld2h(iSym,iSymq)
         if(n2BSF(iSymp,iSymq).gt.0)then
          if (iSymp.ge.iSymq .and. iSkip(iSymp).ne.0 ) then
            Call FZero(Work(ipChoV(iSymp)),n2BSF(iSymp,iSymq)*NUMV)
          endif
         endif
       End Do

      else

         write(6,*)'Wrong parameter! iSwap= ',iSwap
         irc = 66
         Return

      endif


      If (DoRead) Then

       JVEC1 = IVEC1
       IVEC2 = JVEC1 + NUMV - 1

       Do While (jVec1.le.iVec2)
        Call CHO_VECRD(RedVec,lRedVec,JVEC1,IVEC2,ISYM,
     &                   JNUM,IREDC,MUSED)
        MXUSD = MAX(MXUSD,MUSED)

          If (JNUM.le.0 .or. JNUM.gt.(IVEC2-JVEC1+1)) then
             irc=77
             RETURN
          End If

        jVref = JVEC1 - IVEC1 + 1
        Call cho_Reordr(irc,RedVec,lRedVec,jVref,JVEC1,JNUM,NUMV,ISYM,
     &                 IREDC,iSwap,ipVec,iSkip)

        if (irc.ne.0) then
           return
        endif

        jVec1 = jVec1 + JNUM

        do i=1,nSym
           j=mulD2h(i,ISYM)
           IF ( j.ge.i .and. iSkip(j).ne.0 ) THEN
              if(iSwap.eq.0)then
                ipVec(j) = ipVec(j) + nnBSF(j,i)*JNUM
              elseif(iSwap.eq.1)then
                ipVec(j) = ipChoV(j)
              elseif(iSwap.eq.2)then
                ipVec(j) = ipVec(j) + n2BSF(j,i)*JNUM
              endif
           ENDIF
         end do

       End Do  ! end the while loop

      Else ! only reorder

       JNUM=NUMV

       Call cho_Reordr(irc,RedVec,lRedVec,1,IVEC1,JNUM,NUMV,ISYM,IREDC,
     &                iSwap,ipVec,iSkip)

        if (irc.ne.0) then
           return
        endif

      End If

      irc=0

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_FINAL(WriteBookmarks)
!
! Purpose: Cholesky finalizations.

use Cholesky, only: BkmThr, BkmVec, Cho_AdrVec, Cho_Reord, CHOINICHECK, iSOShl, nBasT, nCol_BkmThr, nCol_BkmVec, nRow_BkmThr, &
                    nRow_BkmVec, nSym, ThrCom
#ifdef _DEBUGPRINT_
use Cholesky, only: Cho_1Center
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: WriteBookmarks
integer(kind=iwp) :: CHOISINI, IREO, l, NUMV(8)
integer(kind=iwp), allocatable :: BkmDim(:), iScratch(:)
real(kind=wp), allocatable :: Scratch(:)

! Write NUMCHO array, shell indices, and threshold to runfile.
! ------------------------------------------------------------

call CHO_P_GETGV(NUMV,NSYM)
call PUT_IARRAY('NUMCHO',NUMV,NSYM)
call PUT_IARRAY('iSOShl',ISOSHL,NBAST)
call PUT_DSCALAR('Cholesky Threshold',THRCOM)
#ifdef _DEBUGPRINT_
! This is needed in order for bookmark tests in cho_x_init to work
if (WriteBookmarks) call Put_lScalar('1C-CD',Cho_1Center)
#endif

! Write bookmarks to runfile.
! First, transpose array.
! ---------------------------

if (WriteBookmarks) then
  call mma_allocate(BkmDim,4,Label='BkmDim')
  BkmDim(1) = nCol_BkmVec
  BkmDim(2) = nRow_BkmVec
  BkmDim(3) = nCol_BkmThr
  BkmDim(4) = nRow_BkmThr
  call Put_iArray('Cholesky BkmDim',BkmDim,size(BkmDim))
  call mma_deallocate(BkmDim)
  if ((nRow_BkmVec > 0) .and. (nCol_BkmVec > 0) .and. (nRow_BkmThr > 0) .and. (nCol_BkmThr > 0)) then
    l = nRow_BkmVec*nCol_BkmVec
    call mma_allocate(iScratch,l,Label='iScratch')
    call iTrnsps(nSym,nCol_BkmVec,BkmVec,iScratch)
    call Put_iArray('Cholesky BkmVec',iScratch,l)
    call mma_deallocate(iScratch)
    call mma_deallocate(BkmVec)
    nRow_BkmVec = 0
    nCol_BkmVec = 0
    l = nRow_BkmThr*nCol_BkmThr
    call mma_allocate(Scratch,l,Label='Scratch')
    call Trnsps(nSym,nCol_BkmThr,BkmThr,Scratch)
    call Put_dArray('Cholesky BkmThr',Scratch,l)
    call mma_deallocate(Scratch)
    call mma_deallocate(BkmThr)
    nRow_BkmThr = 0
    nCol_BkmThr = 0
  end if
end if
if (allocated(BkmVec)) then
  call mma_deallocate(BkmVec)
  nRow_BkmVec = 0
  nCol_BkmVec = 0
end if
if (allocated(BkmThr)) then
  call mma_deallocate(BkmThr)
  nRow_BkmThr = 0
  nCol_BkmThr = 0
end if

! Write vector file address mode to runfile.
! ------------------------------------------

call PUT_ISCALAR('ChoVec Address',CHO_ADRVEC)

! Write reorder mark to runfile.
! ------------------------------

if (CHO_REORD) then
  IREO = 1
else
  IREO = 0
end if
call PUT_ISCALAR('Cholesky Reorder',IREO)

! Set initialization integer flag to "not set".
! ---------------------------------------------

CHOISINI = CHOINICHECK+1
call PUT_ISCALAR('ChoIni',CHOISINI)

end subroutine CHO_FINAL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE INTCTL2(IF_TRNSF)
      use caspt2_global, only: iPrGlb
      use caspt2_global, only: do_grad, nStpGrd, FIMO_all, FIFA_all
      use caspt2_global, only: CMO, FIMO, FAMO, HONE, DREF
      use PrintLevel, only: DEBUG
      use Constants, only: Zero, One
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: nBTri
      IMPLICIT None
      LOGICAL IF_TRNSF

      Real*8, Allocatable:: FFAO(:), FIAO(:), FAAO(:)

* Compute using Cholesky vectors.
* Frozen, inactive and active Fock matrix in AO basis:
      Call mma_allocate(FFAO,NBTRI,LABEL='FFAO')
      Call mma_allocate(FIAO,NBTRI,LABEL='FIAO')
      Call mma_allocate(FAAO,NBTRI,LABEL='FAAO')
* tracho2 makes many allocations but should deallocate everything
* before its return.
      IF (IPRGLB.GE.DEBUG) THEN
        WRITE(6,*)' INTCTL2 calling TRACHO2...'
        CALL XFLUSH(6)
      END IF
      Call TraCho2(CMO,SIZE(CMO),DREF,SIZE(DREF),FFAO,FIAO,FAAO,
     &             IF_TRNSF)
      IF (IPRGLB.GE.DEBUG) THEN
        WRITE(6,*)' INTCTL2 back from TRACHO2.'
        CALL XFLUSH(6)
      END IF
* All extra allocations inside tracho2 should now be gone.

* For gradient calculation, it is good to have FIAO and FAAO
      IF (do_grad.or.nStpGrd.eq.2) THEN
        !! FFAO has one-electron Hamiltonian
        CALL DCOPY_(NBTRI,FFAO,1,FIMO_all,1)
        CALL DAXPY_(NBTRI,One,FIAO,1,FIMO_all,1)
        CALL DCOPY_(NBTRI,FIMO_all,1,FIFA_all,1)
        CALL DAXPY_(NBTRI,One,FAAO,1,FIFA_all,1)
      END IF
* Transform them to MO basis:
      HONE(:)=Zero
      FIMO(:)=Zero
      FAMO(:)=Zero
c Compute FIMO, FAMO, ...  to workspace:
      Call FMat_Cho(CMO,SIZE(CMO),FFAO,FIAO,FAAO,
     &              HONE,SIZE(HONE),FIMO,SIZE(FIMO),FAMO,SIZE(FAMO))

      Call mma_deallocate(FFAO)
      Call mma_deallocate(FIAO)
      Call mma_deallocate(FAAO)

      END SUBROUTINE INTCTL2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FAIBJ(INTSYM,INDX,C,S,ABIJ,AIBJ,AJBI,A,B,F,FSEC)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
#include "WrkSpc.fh"
      DIMENSION INTSYM(*),INDX(*),C(*),S(*),
     *          ABIJ(*),AIBJ(*),AJBI(*),
     *          A(*),B(*),F(*),FSEC(*)
      DIMENSION IPOF(9),IPOA(9),IPOB(9)
      External JSUNP
*------
      CALL GETMEM('BUF','ALLO','REAL',LBUF,NBITM3)
      CALL GETMEM('IBUF','ALLO','INTE',LIBUF,NBITM3+2)
c
cvv this code is a real compiler killer!
c
* POW: Unnecessary but warningstopping initializations
      iTyp=-1234567
      iCoup=-1234567
      iCoup1=-1234567
c      call getmem('test','chec','real',ldum,ndum)
*------
      CALL CSCALE(INDX,INTSYM,C,SQ2)
      CALL CSCALE(INDX,INTSYM,S,SQ2INV)
      ICHK=0
      IFAB=0
      NOVST=LN*NVIRT+1+(NVIRT*(NVIRT+1))/2
      NOT2=IROW(LN+1)
*
      IADD10=IAD10(6)

* Long loop, reading buffers until end of buffers is signalled
* by length field holding a negative number.
 300  CONTINUE
      CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LENCOP=ICOP1(nCOP+1)
      IF(LENCOP.EQ.0)GO TO 300
      IF(LENCOP.LT.0)GO TO 350

* Loop over the elements of this buffer
      DO 260 II=1,LENCOP
         INDCOP=ICOP1(II)
         IF(ICHK.NE.0)GO TO 460
         IF(INDCOP.NE.0)GO TO 371
         ICHK=1
         GO TO 260

460      ICHK=0

* Unpack indices NI and NJ from INDCOP
         INDI=INDCOP
*         NI=MOD(INDI,2**10)
*         NJ=MOD(INDI/2**10,2**10)
         NI=IBITS(INDI, 0,10)
         NJ=IBITS(INDI,10,10)

         NSIJ=MUL(NSM(NI),NSM(NJ))
         CALL IPO(IPOF,NVIR,MUL,NSYM,NSIJ,-1)
         IJ1=IROW(NI)+NJ
         ILIM=IPOF(NSYM+1)
* Clear matrices ABIJ, AIBJ, and AJBI.
         CALL FZERO(ABIJ,ILIM)
         CALL FZERO(AIBJ,ILIM)
         CALL FZERO(AJBI,ILIM)
         IF(ITER.EQ.1 .AND. IREST.EQ.0)GO TO 207
*
*     READ (AB/IJ) INTEGRALS
*
         IADR=LASTAD(NOVST+IJ1)
         JTURN=0
 201     CONTINUE

         CALL iDAFILE(Lu_60,2,iWORK(LIBUF),NBITM3+2,IADR)
         CALL dDAFILE(Lu_60,2,WORK(LBUF),NBITM3,IADR)
         LENBUF=iWORK(LIBUF+NBITM3)
         IADR=iWORK(LIBUF+NBITM3+1)
         call faibj5(LENBUF,JTURN,iWORK(LIBUF),WORK(LBUF), AIBJ,ABIJ)

         IF(IADR.NE.-1) GO TO 201
         IF(JTURN.EQ.1)GO TO 360
*
*     READ (AI/BJ) INTEGRALS
*
207      IADR=LASTAD(NOVST+NOT2+IJ1)
         JTURN=1
         GO TO 201
*
*     CONSTRUCT FIRST ORDER MATRICES
*
360      FAC=1.0D00
         IF(NI.EQ.NJ)FAC=0.5D00
         IN=0
c VV: these calls to getmem are needed to cheat some compilers.

        if (FAC.lt.0) call getmem('CHECK','CHEC','real',0,0)

         IFT=0
         call faibj3(NSIJ,IFT,AIBJ,FSEC,FAC,IN,INS,IPOA,IPOF)


      IF(ITER.EQ.1 .AND. IREST.EQ.0)GO TO 260
      DO 370 IASYM=1,NSYM
        NVIRA=NVIR(IASYM)
        IF(NVIRA.EQ.0)GO TO 370
        IBSYM=MUL(NSIJ,IASYM)
        NVIRB=NVIR(IBSYM)
        IF(NVIRB.EQ.0)GO TO 370
        IPF=IPOF(IASYM)+1
        IPF1=IPOF(IBSYM)+1
        IF(IASYM.GT.IBSYM) THEN
          CALL MTRANS(AIBJ(IPF1),1,AJBI(IPF),1,NVIRA,NVIRB)
          GOTO 370
        END IF
        IF(NSIJ.NE.1) THEN
          CALL MTRANS(ABIJ(IPF1),1,ABIJ(IPF),1,NVIRA,NVIRB)
          CALL MTRANS(AIBJ(IPF1),1,AJBI(IPF),1,NVIRA,NVIRB)
        ELSE
          CALL SQUAR2(ABIJ(IPF),NVIRA)
          IF(NI.EQ.NJ) CALL SQUAR2(AIBJ(IPF),NVIRA)
          CALL MTRANS(AIBJ(IPF),1,AJBI(IPF),1,NVIRA,NVIRB)
        END IF
370   CONTINUE
      GO TO 260
371   CONTINUE
      IF(IFAB.EQ.1) THEN
        CPLA=COP(II)
        IFAB=0
        GO TO 100
      END IF
*      IFAB=MOD(INDCOP,2)
*      ITURN=MOD(INDCOP/2,2)
*      ITYP=MOD(INDCOP/2**2,2**3)
*      ICOUP=MOD(INDCOP/2**5,2**13)
*      ICOUP1=MOD(INDCOP/2**18,2**13)
      IFAB=IBITS(INDCOP, 0, 1)
      ITURN=IBITS(INDCOP, 1, 1)
      ITYP=IBITS(INDCOP, 2, 3)
      ICOUP=IBITS(INDCOP, 5,13)
      ICOUP1=IBITS(INDCOP,18,13)
      CPL=COP(II)
      CPLA=0.0D00
      IF(IFAB.NE.0)GO TO 260
      IF(ITURN.NE.0) GOTO 100
C FIRST ORDER INTERACTION
      INDA=ICOUP
      INDB=IRC(ITYP+1)+ICOUP1
      ISTAR=1
      IF(ITYP.EQ.1)ISTAR=INS+1
      IF(INS.NE.0) THEN
        COPI=CPL*C(INDA)
        CALL DAXPY_(INS,COPI,FSEC(ISTAR),1,S(INDX(INDB)+1),1)
        TERM=DDOT_(INS,FSEC(ISTAR),1,C(INDX(INDB)+1),1)
        S(INDA)=S(INDA)+CPL*TERM
      END IF
      GO TO 260

C INTERACTIONS BETWEEN DOUBLES AND
C INTERACTIONS BETWEEN SINGLES
100   IF((ITER.EQ.1).AND.(IREST.EQ.0))GO TO 260

       Call faibj2(IFTA,IFTB,ICOUP1,ICOUP,
     & INDA,INDB,MYSYM,INTSYM,
     & NYSYM,NSIJ,MYL,NYL,FACS,IPOA,IPOB,
     & INMY,INNY,INDX,iTYP)




      IF(ITYP.NE.5)GO TO 71
C DOUBLET-DOUBLET INTERACTIONS
      IN=IPOF(MYL+1)-IPOF(MYL)
      IF(IN.EQ.0)GO TO 260
      IPF=IPOF(MYL)+1
      CALL DYAX(IN,CPL,AIBJ(IPF),1,F,1)
      CALL DAXPY_(IN,CPLA,ABIJ(IPF),1,F,1)
      IF(INDA.EQ.INDB)CALL SETZZ(F,NVIR(MYL))
*      CALL DGEMTX (NVIR(MYL),NVIR(NYL),FACS,F,NVIR(MYL),
*     *             C(INMY),1,S(INNY),1)
      CALL DGEMV_('T',NVIR(MYL),NVIR(NYL),FACS,F,NVIR(MYL),
     *             C(INMY),1,1.0D0,S(INNY),1)
      IF(INDA.NE.INDB) THEN
*        CALL DGEMX (NVIR(MYL),NVIR(NYL),FACS,F,NVIR(MYL),
*     *              C(INNY),1,S(INMY),1)
        CALL DGEMV_('N',NVIR(MYL),NVIR(NYL),FACS,F,NVIR(MYL),
     *              C(INNY),1,1.0D0,S(INMY),1)
      END IF
      GO TO 260
C TRIPLET-SINGLET, SINGLET-TRIPLET,
C TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
71    CONTINUE

      call loop70(INTSYM,INDX,C,S,ABIJ,AIBJ,AJBI,WORK(LBUF),
     *      iWORK(LIBUF),A,B,F,FSEC,IPOF,IPOA,IPOB,
     * MYL,NYL,INDA,INDB,INMY,INNY,IFTB,IFTA,FACS,
     * IAB,CPL,CPLA, NVIRA,NVIRC,NVIRB)


260   CONTINUE
      GO TO 300

350   CONTINUE
      CALL CSCALE(INDX,INTSYM,C,SQ2INV)
      CALL CSCALE(INDX,INTSYM,S,SQ2)
      CALL GETMEM('BUF','FREE','REAL',LBUF,NBITM3)
      CALL GETMEM('IBUF','FREE','INTE',LIBUF,NBITM3+2)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SCLDIA(A,FACTOR,NDIM,IPACK)
! scale diagonal of square matrix A
!
! IPACK = 0 : full matrix
! IPACK /= 0 : Lower triangular packed matrix
!              assumed packed columnwise !!!!

use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: A(*)
real(kind=wp), intent(in) :: FACTOR
integer(kind=iwp), intent(in) :: NDIM, IPACK
integer(kind=iwp) :: I, II

if (IPACK == 0) then
  do I=1,NDIM
    II = (I-1)*NDIM+I
    A(II) = A(II)*FACTOR
  end do
else
  II = 1
  do I=1,NDIM
    A(II) = A(II)*FACTOR
    II = II+NDIM-I+1
  end do
end if

end subroutine SCLDIA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE SKICKJ(SKII,CKJJ,NKA,NIB,NJB,NKB,XIJKL,
     &                  NI,NJ,NK,NL,MAXK,
     &                  KBIB,XKBIB,KBJB,XKBJB,IKORD,
     &                  IXBOFF,JXBOFF,SXCR,IROUTE,NTEST )
*
*
* Calculate S(Ka,Ib,i) = S(Ka,Ib,i)
*          +SUM(j,k,l,Kb) <Ib!a+ kb!Kb><Kb!a lb !Jb>*(ij!kl)*C(Ka,Jb,j)
*
*
*
* Jeppe Olsen, Spring of 94
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "detdim.fh"
#include "stdalloc.fh"
*. Input
      DIMENSION CKJJ(NKA*NJ,*)
*. Note if Iroute = 2 the form is C(j,Ka,Jb)
      DIMENSION XIJKL(*)
      DIMENSION KBIB(MAXK,*),XKBIB(MAXK,*)
      DIMENSION KBJB(MAXK,*),XKBJB(MAXK,*)
*. Input and output
      DIMENSION SKII(NKA*NI,*)
*. Note if Iroute = 2 the form is S(i,Ka,Ib)
*. Scratch
      PARAMETER(MXTSOB=35)
      DIMENSION IBOFF(MXTSOB*MXTSOB),JBOFF(MXTSOB*MXTSOB)
      Real*8, Allocatable:: KSKICK(:)
*
      MAXORB = MAX(NI,NJ,NK,NL)
      LENGTH = MAXORB*MAXORB*MAXORB*MAXORB
      Call mma_allocate(KSKICK,LENGTH,Label='KSKICK')
*
      IF(NI.GT.MXTSOB.OR.NJ.GT.MXTSOB.OR.NK.GT.MXTSOB
     &   .OR.NL.GT.MXTSOB) THEN
         WRITE(6,*) ' SKICKJ : Too many orbs : NI > MXTSOB '
         WRITE(6,*) ' NI, MXTSOB ',MAX(NI,NJ,NK,NL),MXTSOB
         Write (6,*) ' Redim MXTSOB in SKICKJ'
         Call Abend()
      END IF
*
      IF(IROUTE.EQ.3) THEN
* S(Ka,i,Ib) = S(Ka,i,Ib) + sum(j) (ji!kl) C(Ka,j,Jb)
        DO KB = 1, NKB
*. Number of nonvanishing connections from KB
         LL = 0
         KK = 0
         DO L = 1, NL
           IF(KBJB(KB,L).NE.0) LL = LL + 1
         END DO
         DO K = 1, NK
           IF(KBIB(KB,K).NE.0) KK = KK + 1
         END DO
*
         IF(KK.NE.0.AND.LL.NE.0) THEN
           DO K = 1, NK
             IB = KBIB(KB,K)
             IF(IB.NE.0) THEN
               SGNK = XKBIB(KB,K)
               DO L = 1, NL
                 JB = KBJB(KB,L)
                 IF(JB.NE.0) THEN
                   SGNL = XKBJB(KB,L)
                   FACTOR = SGNK*SGNL
*. We have now a IB and Jb string, let's do it
C                  ISOFF = (IB-1)*NI*NKA + 1
C                  ICOFF = (JB-1)*NJ*NKA + 1
                   INTOF = ((L-1)*NK + K - 1 )*NI*NJ + 1
*
                   ONE = 1.0D0

                   CALL  DGEMM_('N','N',NKA,NI,NJ,
     &                         FACTOR ,CKJJ(1,jB),max(1,NKA),
     &                                 XIJKL(INTOF),max(1,NJ),
     &                         ONE,SKII(1,iB),max(1,NKA))
*
                 END IF
               END DO
             END IF
           END DO
         END IF
       END DO
*. (end over loop over Kb strings )
      ELSE IF(IROUTE.EQ.2) THEN
* S(I,Ka,Ib) = S(I,Ka,Ib) + sum(j) (ij!kl) C(j,Ka,Jb)
        DO KB = 1, NKB
*. Number of nonvanishing connections from KB
         LL = 0
         KK = 0
         DO L = 1, NL
           IF(KBJB(KB,L).NE.0) LL = LL + 1
         END DO
         DO K = 1, NK
           IF(KBIB(KB,K).NE.0) KK = KK + 1
         END DO
*
         IF(KK.NE.0.AND.LL.NE.0) THEN
           DO K = 1, NK
             IB = KBIB(KB,K)
             IF(IB.NE.0) THEN
               SGNK = XKBIB(KB,K)
               DO L = 1, NL
                 JB = KBJB(KB,L)
                 IF(JB.NE.0) THEN
                   SGNL = XKBJB(KB,L)
                   FACTOR = SGNK*SGNL
*. We have now a IB and Jb string, let's do it
C                  ISOFF = (IB-1)*NI*NKA + 1
C                  ICOFF = (JB-1)*NJ*NKA + 1
                   INTOF = ((L-1)*NK + K - 1 )*NI*NJ + 1
*
                   ONE = 1.0D0
                   CALL  DGEMM_('N','N',NI,NKA,NJ,FACTOR ,
     &                         XIJKL(INTOF),max(1,NI),
     &                         CKJJ(1,JB),max(1,NJ),
     &                         ONE,SKII(1,IB),max(1,NI))
                 END IF
               END DO
             END IF
           END DO
         END IF
       END DO
*. (end over loop over Kb strings )
*

      ELSE IF (IROUTE.EQ.1) THEN



      DO 1000 KB = 1, NKB
*. Number of nonvanishing a+lb !Kb>
        LL = 0
        DO L = 1, NL
          IF(KBJB(KB,L).NE.0) LL = LL + 1
        END DO
*
        IKEFF = 0
        DO 900 K = 1, NK
          IB = KBIB(KB,K)
          IF(IB.EQ.0) GOTO 900
          SGNK = XKBIB(KB,K)
*
          IF(IKORD.EQ.0) THEN
             IMIN = 1
          ELSE
             IMIN = K
          END IF
*
          DO 700 I = IMIN, NI
            IKEFF = IKEFF + 1
            IOFF = (IKEFF-1)*NJ*LL
*. Offset for S(1,IB,i)
            IBOFF(IKEFF)  = (I-1)*NIB+IB
            LEFF = 0
            DO 800 L = 1, NL
              JB = KBJB(KB,L)
              IF(JB.EQ.0) GOTO 800
              LEFF = LEFF + 1
              SGNL = XKBJB(KB,L)
              IF(IKORD.EQ.1.AND.I.EQ.K)THEN
                 FACTOR = 0.5D0*SGNK*SGNL
              ELSE
                 FACTOR =       SGNK*SGNL
              END IF
              JL0 = (LEFF-1)*NJ
              JLIK0 = (K-1)*NJ*NL*NI
     &              + (I-1)*NJ*NL
     &              + (L-1)*NJ

              DO 600 J = 1, NJ
                JL = JL0 + J
*. Offsets for C(1,JB,j)
                JBOFF(JL) = (J-1)*NJB + JB
*. integral * signs in SCR(jl,ik)
*. Integrals are stored as (j l i k )
                KSKICK(IOFF+JL) = FACTOR*XIJKL(JLIK0+J)
  600         CONTINUE

  800       CONTINUE

  700     CONTINUE

  900   CONTINUE
*
        CALL GSAXPY(SKII,CKJJ,KSKICK,IKEFF,NJ*LL,NKA,IBOFF,JBOFF)

 1000 CONTINUE
      END IF
*. End of IROUTE branching
*
      Call mma_deallocate(KSKICK)
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(IXBOFF)
        CALL Unused_integer(JXBOFF)
        CALL Unused_real(SXCR)
        CALL Unused_integer(NTEST)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine unpckhelp11(a,b,dimp,dimq,dime,dimf,eadd,noe,fadd,nof,
     c                        bb,dimb)
c
c     this routine do:
c     b(e,f,_Bb) =  a(pf,qe)
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof,bb,dimb
       real*8 a(1:dimp,1:dimq)
       real*8 b(1:dime,1:dimf,1:dimb)
c
c     help variables
       integer qe,pf,f
c
       do 100 pf=fadd+1,fadd+nof
       f=pf-fadd
       do 101 qe=eadd+1,eadd+noe
       b(qe-eadd,f,bb)=a(pf,qe)
 101    continue
 100    continue
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine vAssmbl(Rnxyz,Axyz,la,Rxyz,lr,Bxyz,lb,nZeta,HerW,nHer,Temp)
!***********************************************************************
!                                                                      *
! Object: to assemble the cartesian components of the multipole moment *
!         matrix within the framework of the Gauss-Hermite quadrature. *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: la, lr, lb, nZeta, nHer
real(kind=wp), intent(out) :: Rnxyz(nZeta*3,0:la,0:lb,0:lr), Temp(nZeta*3,nHer)
real(kind=wp), intent(in) :: Axyz(nZeta*3,nHer,0:la), Rxyz(nZeta*3,nHer,0:lr), Bxyz(nZeta*3,nHer,0:lb), HerW(nHer)
integer(kind=iwp) :: ia, ib, iHer, ir
#ifdef _DEBUGPRINT_
character(len=80) :: Label
#endif

#ifdef _DEBUGPRINT_
call RecPrt(' In vAssmbl:HerW',' ',HerW,1,nHer)
call RecPrt(' In vAssmbl:Axyz',' ',Axyz,nZeta*3,nHer*(la+1))
call RecPrt(' In vAssmbl:Bxyz',' ',Bxyz,nZeta*3,nHer*(lb+1))
call RecPrt(' In vAssmbl:Rxyz',' ',Rxyz,nZeta*3,nHer*(lr+1))
#endif

Rnxyz(:,:,:,:) = Zero
do ia=0,la
  do ib=0,lb
    do iHer=1,nHer
      Temp(:,iHer) = Axyz(:,iHer,ia)*Bxyz(:,iHer,ib)*HerW(iHer)
    end do
    do ir=0,lr

      ! Generate the cartesian components of the multipole moment
      ! matrix as a sum of the value of the integrand, evaluated
      ! at a root, times a weight.

      do iHer=1,nHer
        Rnxyz(:,ia,ib,ir) = Rnxyz(:,ia,ib,ir)+Temp(:,iHer)*Rxyz(:,iHer,ir)
      end do

#     ifdef _DEBUGPRINT_
      write(Label,'(A,I2,A,I2,A,I2,A)') ' In vAssmbl: Rnxyz(',ia,',',ib,',',ir,')'
      call RecPrt(Label,' ',Rnxyz(1,ia,ib,ir),nZeta,3)
#     endif
    end do
  end do
end do

end subroutine vAssmbl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grc22C(a,b,c,mvec,ssa,ssb,pbar,ix)

use ccsd_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
type(Map_Type), intent(in) :: a, b
type(Map_Type), intent(inout) :: c
integer(kind=iwp), intent(out) :: mvec(4096,7)
integer(kind=iwp), intent(in) :: ssa, ssb, pbar
integer(kind=iwp), intent(inout) :: ix
integer(kind=iwp) :: ia, ib, ic, nhelp1, nhelp2, nhelp3, nhelp4, posct, sa1, sa2, sb1, sb2

!1*

if (pbar == 1) then

  ! structure A(p,q)*B(q,r)=C(p,r)

  !1.0 prepare c%d,c%i

  call grc0(2,0,a%d(0,1),b%d(0,2),0,0,mmul(ssa,ssb),posct,c)

  !1.1 define limitations - no limitations

  !1.2 def symm states and test the limitations

  ix = 1
  do sa1=1,nsym

    sa2 = mmul(ssa,sa1)
    sb1 = sa2

    sb2 = mmul(ssb,sb1)

    !1.3 def mvec,c%d and c%i

    ia = a%i(sa1,1,1)
    ib = b%i(sb1,1,1)
    ic = c%i(sa1,1,1)

    ! yes/no
    if ((a%d(ia,2) <= 0) .or. (b%d(ib,2) <= 0)) cycle
    nhelp1 = 1

    ! rowA
    nhelp2 = dimm(a%d(0,1),sa1)

    ! colB
    nhelp3 = dimm(b%d(0,2),sb2)

    ! sum
    nhelp4 = dimm(a%d(0,2),sa2)

    mvec(ix,1) = nhelp1
    mvec(ix,2) = a%d(ia,1)
    mvec(ix,3) = b%d(ib,1)
    mvec(ix,4) = c%d(ic,1)
    mvec(ix,5) = nhelp2
    mvec(ix,6) = nhelp4
    mvec(ix,7) = nhelp3

    ix = ix+1

  end do

end if
ix = ix-1

return

end subroutine grc22C

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine XT_dMoverdH(exch,nLoc,nCenter,nneq,neqv,neq,nss,nexch,nTempMagn,nT,NM,iopt,mem,Tmin,Tmax,chit_exp,eso,w,T,RROT,zJ, &
                       Xfield,THRS,XT_no_field,dipso,s_so,dipexch,s_exch,tinput,smagn,m_paranoid,m_accurate,doplot)
! this Subroutine computes the XT as M/H as it is observed for most of experiments.
! The M is averaged over the grid for each temperature point.
!       chi*t ----------- the units are cgsemu: [ cm^3*k/mol ]
!
!  WEX0, WEX1 WEX2 : Zeeman exchange energies
!  WL0, WL1, WL2   : Zeeman local energies
! Zeeman local reduced energies, using only NEXCH states;
!  WR0, WR1, WR2
! local statistical sum, Boltzmann distribution
!  ZL0, ZL1, ZL2
! local statistical sum, Boltzmann distribution, using only NEXCH states
!  ZR0, ZR1, ZR2
! spin magnetisation, from the local sites, using ALL states
!  SL0, SL1, SL2
! spin magnetisation, from the local sites, using only NEXCH states
!  SR0, SR1, SR2
! magnetisation, from local sites, using ALL states
!  ML0, ML1, ML2
! magnetisation, from local sites, using only NEXCH states
!  MR0, MR1, MR2
! spin magnetisation, from the exchange block
!  SEX0, SEX1, SEX2
! magnetisation, form the exchange block
!  MEX0, MEX1, MEX2
! exchange statistical sum, Boltzmann distribution
!  ZEX0, ZEX1, ZEX2
! total vectors in general coordinate system:
!  ZRT0, ZLT0, ZRT1, ZLT1, ZRT2, ZLT2, MRT0, MLT0, SRT0, SLT0, MRT1, MLT1, SRT1, SLT1, MRT2, MLT2, SRT2, SLT2
! data for total system:
! total statistical sum, Boltzmann distribution
!  MT0 : total magnetisation
!  MT1 : total magnetisation
!  ST0 : total spin magnetisation,
!  ST1 : total spin magnetisation,
!  ST2 : total spin magnetisation,
!  MT2 : total magnetisation
!  ZT0, ZT1, ZT2
! standard deviation data:
!  dev

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Ten, mBohr, rNAVO
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: exch, nLoc, nCenter, nneq, neqv, neq(nneq), nss(nneq), nexch(nneq), nTempMagn, nT, NM, iopt, mem
real(kind=wp), intent(in) :: Tmin, Tmax, chit_exp(nT), eso(nneq,nLoc), W(exch), T(nT+nTempMagn), RROT(nneq,neqv,3,3), zJ, Xfield, &
                             THRS, XT_no_field(nT+nTempMagn)
complex(kind=wp), intent(in) :: dipso(nneq,3,nLoc,nLoc), s_so(nneq,3,nLoc,nLoc), dipexch(3,exch,exch), s_exch(3,exch,exch)
logical(kind=iwp), intent(in) :: tinput, smagn, m_paranoid, doplot
integer(kind=iwp) :: i, ibuf, ibuf1, ibuf3, iM, info, isite, iT, j, jT, mem_local, n, nDirX, nTempTotal
real(kind=wp) :: dHX(3), dHY(3), dHZ(3), dltXF, F1, F2, wt(3), Xfield_1, Xfield_2, zt(3,3)
logical(kind=iwp) :: m_accurate
character(len=50) :: label
real(kind=wp), allocatable :: ESO_TMP(:), MEX0(:,:), MEX1(:,:), MEX2(:,:), ML0(:,:,:), ML1(:,:,:), ML2(:,:,:), MLT0(:,:,:), &
                              MLT1(:,:,:), MLT2(:,:,:), MR0(:,:,:), MR1(:,:,:), MR2(:,:,:), MRT0(:,:,:), MRT1(:,:,:), MRT2(:,:,:), &
                              MT0(:,:), MT1(:,:), MT2(:,:), SEX0(:,:), SEX1(:,:), SEX2(:,:), SL0(:,:,:), SL1(:,:,:), SL2(:,:,:), &
                              SLT0(:,:,:), SLT1(:,:,:), SLT2(:,:,:), SR0(:,:,:), SR1(:,:,:), SR2(:,:,:), SRT0(:,:,:), SRT1(:,:,:), &
                              SRT2(:,:,:), ST0(:,:), ST1(:,:), ST2(:,:), WEX0(:), WEX1(:), WEX2(:), WL0(:,:), WL1(:,:), WL2(:,:), &
                              WR0(:,:), WR1(:,:), WR2(:,:), XTM_dMdH(:), XTM_MH(:), XTtens_dMdH(:,:,:), XTtens_MH(:,:,:), ZEX0(:), &
                              ZEX1(:), ZEX2(:), ZL0(:,:), ZL1(:,:), ZL2(:,:), ZLT0(:,:), ZLT1(:,:), ZLT2(:,:), ZR0(:,:), ZR1(:,:), &
                              ZR2(:,:), ZRT0(:,:), ZRT1(:,:), ZRT2(:,:), ZT0(:), ZT1(:), ZT2(:)
complex(kind=wp), allocatable :: dipso_tmp(:,:,:), s_so_tmp(:,:,:)
real(kind=wp), parameter :: cm3tomB = rNAVO*mBohr/Ten ! in cm3 * mol-1 * T
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
integer(kind=iwp) :: l
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: DBG = _DBG_
real(kind=wp), external :: dev, dnrm2_

#ifndef _DEBUGPRINT_
#include "macros.fh"
unused_var(mem)
#endif

nTempTotal = nT+nTempMagn

!m_paranoid = .true. ! .false.
!ccc-------------------------------------------------------cccc
#ifdef _DEBUGPRINT_
write(u6,'(A,   I5)') '      exch =',exch
write(u6,'(A,   I5)') '      nLoc =',nLoc
write(u6,'(A,   I5)') '   nCenter =',nCenter
write(u6,'(A,   I5)') '      nneq =',nneq
write(u6,'(A,   I5)') '      neqv =',neqv
write(u6,'(A, 10I5)') '    neq(i) =',(neq(i),i=1,nneq)
write(u6,'(A, 10I5)') '  nexch(i) =',(nexch(i),i=1,nneq)
write(u6,'(A, 10I5)') '    nss(i) =',(nss(i),i=1,nneq)
write(u6,'(A,   I5)') ' nTempMagn =',nTempMagn
write(u6,'(A,   I5)') '        nT =',nT
write(u6,'(A,   I5)') '        nM =',nM
write(u6,'(A,   I5)') '      iopt =',iopt
write(u6,'(A,F12.5)') '      Tmin =',Tmin
write(u6,'(A,F12.5)') '      Tmax =',Tmax
write(u6,'(A,F12.5)') '        zJ =',zJ
write(u6,'(A,F12.5)') '    Xfield =',Xfield
write(u6,'(A,ES12.5)') '      THRS =',THRS
write(u6,*) 'm_accurate =',m_accurate
write(u6,*) '     smagn =',smagn
write(u6,*) 'm_paranoid =',m_paranoid
write(u6,*) '    tinput =',tinput
if (tinput) then
  do iT=1,nTempMagn
    write(u6,'(2(A,i3,A,F12.6,2x))') 'T(',iT,')=',T(iT)
  end do
  do iT=1,nT
    jT = iT+nTempMagn
    write(u6,'(2(A,i3,A,F12.6,2x))') 'T(',jT,')=',T(jT),' chiT_exp(',iT,')=',chit_exp(iT)
  end do

else
  do iT=1,nTempTotal
    write(u6,'(2(A,i3,A,F12.6,2x))') 'T(',iT,')=',T(iT)
  end do
end if
write(u6,'(A)') 'local ESO:'
do i=1,nneq
  write(u6,'(A,i3)') 'site:',i
  write(u6,'(10F12.5)') (eso(i,j),j=1,nss(i))
end do
write(u6,'(A)') 'EXCHANGE ENERGY'
write(u6,'(10F12.5)') (W(i),i=1,exch)
write(u6,'(A)') 'Rotation Matrices:'
do i=1,nneq
  write(u6,'(A,i3)') 'site:',i
  do j=1,neq(i)
    do l=1,3
      write(u6,'(10F12.5)') (RROT(i,j,l,n),n=1,3)
    end do
  end do
end do
call xFlush(u6)
#endif
!ccc-------------------------------------------------------cccc
write(u6,*)
write(u6,'(A)') repeat('%',95)
write(u6,'(16X,A)') 'CALCULATION OF THE FIELD-DEPENDENT MAGNETIC SUSCEPTIBILITY'
write(u6,'(18X,A)') 'within true (dM/dH) and "experimentalists" (M/H) models'
write(u6,'(A)') repeat('%',95)
write(u6,*)
write(u6,'(2x,A,F10.6,A)') 'Magnetic field strength:',Xfield,' tesla.'
if (tinput) then
  write(u6,'(2x,a)') 'Temperature dependence of the magnetic susceptibility and'
  write(u6,'(2x,a)') 'high-field magnetization will be calculated according to '
  write(u6,'(2x,a)') 'experimental values provided by the user in file "chitexp.input".'
else
  write(u6,'(2x,a,i3,a)') 'Temperature dependence of the magnetic susceptibility will be calculated in',nT,' points, '
  write(u6,'(2x,a,f4.1,a,f6.1,a)') 'equally distributed in temperature range ',tmin,' ---',tmax,' K.'
end if

!=======================================================================
mem_local = 0
call mma_allocate(WEX0,nM,'WEX0')
call mma_allocate(WEX1,nM,'WEX1')
call mma_allocate(WEX2,nM,'WEX2')
mem_local = mem_local+size(WEX0)*RtoB
mem_local = mem_local+size(WEX1)*RtoB
mem_local = mem_local+size(WEX2)*RtoB

call mma_allocate(WL0,nLoc,nneq,'WL0')
call mma_allocate(WL1,nLoc,nneq,'WL1')
call mma_allocate(WL2,nLoc,nneq,'WL2')
call mma_allocate(WR0,nLoc,nneq,'WR0')
call mma_allocate(WR1,nLoc,nneq,'WR1')
call mma_allocate(WR2,nLoc,nneq,'WR2')
mem_local = mem_local+size(WL0)*RtoB
mem_local = mem_local+size(WL1)*RtoB
mem_local = mem_local+size(WL2)*RtoB
mem_local = mem_local+size(WR0)*RtoB
mem_local = mem_local+size(WR1)*RtoB
mem_local = mem_local+size(WR2)*RtoB

call mma_allocate(ZL0,nTempTotal,nneq,'ZL0')
call mma_allocate(ZR0,nTempTotal,nneq,'ZR0')
call mma_allocate(ZL1,nTempTotal,nneq,'ZL1')
call mma_allocate(ZR1,nTempTotal,nneq,'ZR1')
call mma_allocate(ZL2,nTempTotal,nneq,'ZL2')
call mma_allocate(ZR2,nTempTotal,nneq,'ZR2')
mem_local = mem_local+size(ZL0)*RtoB
mem_local = mem_local+size(ZR0)*RtoB
mem_local = mem_local+size(ZL1)*RtoB
mem_local = mem_local+size(ZR1)*RtoB
mem_local = mem_local+size(ZL2)*RtoB
mem_local = mem_local+size(ZR2)*RtoB

call mma_allocate(SL0,3,nTempTotal,nneq,'SL0')
call mma_allocate(SR0,3,nTempTotal,nneq,'SR0')
call mma_allocate(SL1,3,nTempTotal,nneq,'SL1')
call mma_allocate(SR1,3,nTempTotal,nneq,'SR1')
call mma_allocate(SL2,3,nTempTotal,nneq,'SL2')
call mma_allocate(SR2,3,nTempTotal,nneq,'SR2')
call mma_allocate(ML0,3,nTempTotal,nneq,'ML0')
call mma_allocate(MR0,3,nTempTotal,nneq,'MR0')
call mma_allocate(ML1,3,nTempTotal,nneq,'ML1')
call mma_allocate(MR1,3,nTempTotal,nneq,'MR1')
call mma_allocate(ML2,3,nTempTotal,nneq,'ML2')
call mma_allocate(MR2,3,nTempTotal,nneq,'MR2')
mem_local = mem_local+size(SL0)*RtoB
mem_local = mem_local+size(SR0)*RtoB
mem_local = mem_local+size(SL1)*RtoB
mem_local = mem_local+size(SR1)*RtoB
mem_local = mem_local+size(SL2)*RtoB
mem_local = mem_local+size(SR2)*RtoB
mem_local = mem_local+size(ML0)*RtoB
mem_local = mem_local+size(MR0)*RtoB
mem_local = mem_local+size(ML1)*RtoB
mem_local = mem_local+size(MR1)*RtoB
mem_local = mem_local+size(ML2)*RtoB
mem_local = mem_local+size(MR2)*RtoB

call mma_allocate(ZEX0,nTempTotal,'ZEX0')
call mma_allocate(ZEX1,nTempTotal,'ZEX1')
call mma_allocate(ZEX2,nTempTotal,'ZEX2')
mem_local = mem_local+size(ZEX0)*RtoB
mem_local = mem_local+size(ZEX1)*RtoB
mem_local = mem_local+size(ZEX2)*RtoB

call mma_allocate(ZT0,nTempTotal,'ZT0')
call mma_allocate(ZT1,nTempTotal,'ZT1')
call mma_allocate(ZT2,nTempTotal,'ZT2')
ZT0(:) = Zero
ZT1(:) = Zero
ZT2(:) = Zero
mem_local = mem_local+size(ZT0)*RtoB
mem_local = mem_local+size(ZT1)*RtoB
mem_local = mem_local+size(ZT2)*RtoB

call mma_allocate(SEX0,3,nTempTotal,'SEX0')
call mma_allocate(SEX1,3,nTempTotal,'SEX1')
call mma_allocate(SEX2,3,nTempTotal,'SEX2')
call mma_allocate(MEX0,3,nTempTotal,'MEX0')
call mma_allocate(MEX1,3,nTempTotal,'MEX1')
call mma_allocate(MEX2,3,nTempTotal,'MEX2')
mem_local = mem_local+size(SEX0)*RtoB
mem_local = mem_local+size(SEX1)*RtoB
mem_local = mem_local+size(SEX2)*RtoB
mem_local = mem_local+size(MEX0)*RtoB
mem_local = mem_local+size(MEX1)*RtoB
mem_local = mem_local+size(MEX2)*RtoB

call mma_allocate(ST0,3,nTempTotal,'ST0')
call mma_allocate(ST1,3,nTempTotal,'ST1')
call mma_allocate(ST2,3,nTempTotal,'ST2')
call mma_allocate(MT0,3,nTempTotal,'MT0')
call mma_allocate(MT1,3,nTempTotal,'MT1')
call mma_allocate(MT2,3,nTempTotal,'MT2')
ST0(:,:) = Zero
ST1(:,:) = Zero
ST2(:,:) = Zero
MT0(:,:) = Zero
MT1(:,:) = Zero
ST2(:,:) = Zero
mem_local = mem_local+size(ST0)*RtoB
mem_local = mem_local+size(ST1)*RtoB
mem_local = mem_local+size(ST2)*RtoB
mem_local = mem_local+size(MT0)*RtoB
mem_local = mem_local+size(MT1)*RtoB
mem_local = mem_local+size(MT2)*RtoB

call mma_allocate(XTM_MH,nTempTotal,'XTM_MH')
call mma_allocate(XTM_dMdH,nTempTotal,'XTM_dMdH')
call mma_allocate(XTtens_MH,3,3,nTempTotal,'XTtens_MH')
call mma_allocate(XTtens_dMdH,3,3,nTempTotal,'XTtens_dMdH')
mem_local = mem_local+size(XTM_MH)*RtoB
mem_local = mem_local+size(XTM_dMdH)*RtoB
mem_local = mem_local+size(XTtens_MH)*RtoB
mem_local = mem_local+size(XTtens_dMdH)*RtoB

call mma_allocate(ZRT0,nCenter,nTempTotal,'ZRT0')
call mma_allocate(ZLT0,nCenter,nTempTotal,'ZLT0')
call mma_allocate(ZRT1,nCenter,nTempTotal,'ZRT1')
call mma_allocate(ZLT1,nCenter,nTempTotal,'ZLT1')
call mma_allocate(ZRT2,nCenter,nTempTotal,'ZRT2')
call mma_allocate(ZLT2,nCenter,nTempTotal,'ZLT2')
mem_local = mem_local+size(ZRT0)*RtoB
mem_local = mem_local+size(ZLT0)*RtoB
mem_local = mem_local+size(ZRT1)*RtoB
mem_local = mem_local+size(ZLT1)*RtoB
mem_local = mem_local+size(ZRT2)*RtoB
mem_local = mem_local+size(ZLT2)*RtoB

call mma_allocate(MRT0,nCenter,3,nTempTotal,'MRT0')
call mma_allocate(MLT0,nCenter,3,nTempTotal,'MLT0')
call mma_allocate(SRT0,nCenter,3,nTempTotal,'SRT0')
call mma_allocate(SLT0,nCenter,3,nTempTotal,'SLT0')
call mma_allocate(MRT1,nCenter,3,nTempTotal,'MRT1')
call mma_allocate(MLT1,nCenter,3,nTempTotal,'MLT1')
call mma_allocate(SRT1,nCenter,3,nTempTotal,'SRT1')
call mma_allocate(SLT1,nCenter,3,nTempTotal,'SLT1')
call mma_allocate(MRT2,nCenter,3,nTempTotal,'MRT2')
call mma_allocate(MLT2,nCenter,3,nTempTotal,'MLT2')
call mma_allocate(SRT2,nCenter,3,nTempTotal,'SRT2')
call mma_allocate(SLT2,nCenter,3,nTempTotal,'SLT2')
mem_local = mem_local+size(MRT0)*RtoB
mem_local = mem_local+size(MLT0)*RtoB
mem_local = mem_local+size(SRT0)*RtoB
mem_local = mem_local+size(SLT0)*RtoB
mem_local = mem_local+size(MRT1)*RtoB
mem_local = mem_local+size(MLT1)*RtoB
mem_local = mem_local+size(SRT1)*RtoB
mem_local = mem_local+size(SLT1)*RtoB
mem_local = mem_local+size(MRT2)*RtoB
mem_local = mem_local+size(MLT2)*RtoB
mem_local = mem_local+size(SRT2)*RtoB
mem_local = mem_local+size(SLT2)*RtoB

#ifdef _DEBUGPRINT_
write(u6,*) 'XT_MH:  memory allocated (local):'
write(u6,*) 'mem_local=',mem_local
write(u6,*) 'XT_MH:  memory allocated (total):'
write(u6,*) 'mem_total=',mem+mem_local
#endif

!=======================================================================
nDirX = 3

dHX(1) = One
dHY(1) = Zero
dHZ(1) = Zero

dHX(2) = Zero
dHY(2) = One
dHZ(2) = Zero

dHX(3) = Zero
dHY(3) = Zero
dHZ(3) = One

Xfield_1 = Xfield*0.99999_wp
Xfield_2 = Xfield*1.00001_wp
dltXF = Xfield_2-Xfield_1

! ///  opening the loop over different directions of the magnetic field
do iM=1,nDirX
  WL0(:,:) = Zero
  WL1(:,:) = Zero
  WL2(:,:) = Zero
  WR0(:,:) = Zero
  WR1(:,:) = Zero
  WR2(:,:) = Zero

  MRT0(:,:,:) = Zero
  MLT0(:,:,:) = Zero
  SRT0(:,:,:) = Zero
  SLT0(:,:,:) = Zero
  MRT1(:,:,:) = Zero
  MLT1(:,:,:) = Zero
  SRT1(:,:,:) = Zero
  SLT1(:,:,:) = Zero
  MRT2(:,:,:) = Zero
  MLT2(:,:,:) = Zero
  SRT2(:,:,:) = Zero
  SLT2(:,:,:) = Zero
  ! exchange magnetization:
  call MAGN(EXCH,NM,dHX(iM),dHY(iM),dHZ(iM),XField,W,zJ,THRS,DIPEXCH,S_EXCH,nTempTotal,T,smagn,Wex0,Zex0,Sex0,Mex0,m_paranoid,DBG)
  call MAGN(EXCH,NM,dHX(iM),dHY(iM),dHZ(iM),XField_1,W,zJ,THRS,DIPEXCH,S_EXCH,nTempTotal,T,smagn,Wex1,Zex1,Sex1,Mex1,m_paranoid,DBG)
  call MAGN(EXCH,NM,dHX(iM),dHY(iM),dHZ(iM),XField_2,W,zJ,THRS,DIPEXCH,S_EXCH,nTempTotal,T,smagn,Wex2,Zex2,Sex2,Mex2,m_paranoid,DBG)
# ifdef _DEBUGPRINT_
  do i=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex0(',i,')=',(Mex0(l,i),l=1,3)
  end do
  do i=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex1(',i,')=',(Mex1(l,i),l=1,3)
  end do
  do i=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex2(',i,')=',(Mex2(l,i),l=1,3)
  end do
  do i=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex 2-1 (',i,')=',(Mex2(l,i)-Mex1(l,i),l=1,3)
  end do
# endif

  call Add_Info('dM/dH   Mex0',[dnrm2_(3*nTempTotal,Mex0,1)],1,8)
  call Add_Info('dM/dH   Sex0',[dnrm2_(3*nTempTotal,Sex0,1)],1,8)
  call Add_Info('dM/dH   Zex0',[dnrm2_(nTempTotal,Zex0,1)],1,8)
  call Add_Info('dM/dH   Wex0',[dnrm2_(nM,Wex0,1)],1,8)

  call Add_Info('dM/dH   Mex1',[dnrm2_(3*nTempTotal,Mex1,1)],1,8)
  call Add_Info('dM/dH   Sex1',[dnrm2_(3*nTempTotal,Sex1,1)],1,8)
  call Add_Info('dM/dH   Zex1',[dnrm2_(nTempTotal,Zex1,1)],1,8)
  call Add_Info('dM/dH   Wex1',[dnrm2_(nM,Wex1,1)],1,8)

  call Add_Info('dM/dH   Mex2',[dnrm2_(3*nTempTotal,Mex2,1)],1,8)
  call Add_Info('dM/dH   Sex2',[dnrm2_(3*nTempTotal,Sex2,1)],1,8)
  call Add_Info('dM/dH   Zex2',[dnrm2_(nTempTotal,Zex2,1)],1,8)
  call Add_Info('dM/dH   Wex2',[dnrm2_(nM,Wex2,1)],1,8)

  ! compute local magnetizations:
  if (m_accurate) then
    do i=1,nneq
      ! all states:
      if (NSS(i) > NEXCH(i)) then
        call mma_allocate(ESO_TMP,nss(i),label='ESO_TMP')
        call mma_allocate(dipso_tmp,3,nss(i),nss(i),label='dipso_tmp')
        call mma_allocate(s_so_tmp,3,nss(i),nss(i),label='s_so_tmp')
        ! this check is to avoid the unnecessary computation, in cases when no local excited states are present
        ESO_TMP(:) = ESO(i,1:NSS(i))
        dipso_tmp(:,:,:) = DIPSO(i,:,1:NSS(i),1:NSS(i))
        s_so_tmp(:,:,:) = S_SO(i,:,1:NSS(i),1:NSS(i))
        call MAGN(NSS(i),NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),XField,ESO_TMP,zJ,THRS,dipso_tmp,s_so_tmp,nTempTotal,T,smagn, &
                  WL0(1:NSS(i),i),ZL0(:,i),SL0(:,:,i),ML0(:,:,i),m_paranoid,DBG)

        call MAGN(NSS(i),NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),XField_1,ESO_TMP,zJ,THRS,dipso_tmp,s_so_tmp,nTempTotal,T,smagn, &
                  WL1(1:NSS(i),i),ZL1(:,i),SL1(:,:,i),ML1(:,:,i),m_paranoid,DBG)

        call MAGN(NSS(i),NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),Xfield_2,ESO_TMP,zJ,THRS,dipso_tmp,s_so_tmp,nTempTotal,T,smagn, &
                  WL2(1:NSS(i),i),ZL2(:,i),SL2(:,:,i),ML2(:,:,i),m_paranoid,DBG)
        call mma_deallocate(ESO_TMP)
        call mma_deallocate(dipso_tmp)
        call mma_deallocate(s_so_tmp)
        call mma_allocate(ESO_TMP,nexch(i),label='ESO_TMP')
        call mma_allocate(dipso_tmp,3,nexch(i),nexch(i),label='dipso_tmp')
        call mma_allocate(s_so_tmp,3,nexch(i),nexch(i),label='s_so_tmp')
        ESO_TMP(:) = ESO(i,1:NEXCH(i))
        dipso_tmp(:,:,:) = DIPSO(i,:,1:NEXCH(i),1:NEXCH(i))
        s_so_tmp(:,:,:) = S_SO(i,:,1:NEXCH(i),1:NEXCH(i))
        ! only local "exchange states":
        call MAGN(NEXCH(i),NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),XField,ESO_TMP,zJ,THRS,dipso_tmp,s_so_tmp,nTempTotal,T,smagn, &
                  WR0(1:NEXCH(i),i),ZR0(:,i),SR0(:,:,i),MR0(:,:,i),m_paranoid,DBG)

        call MAGN(NEXCH(i),NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),XField_1,ESO_TMP,zJ,THRS,dipso_tmp,s_so_tmp,nTempTotal,T,smagn, &
                  WR1(1:NEXCH(i),i),ZR1(:,i),SR1(:,:,i),MR1(:,:,i),m_paranoid,DBG)

        call MAGN(NEXCH(i),NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),XField_2,ESO_TMP,zJ,THRS,dipso_tmp,s_so_tmp,nTempTotal,T,smagn, &
                  WR2(1:NEXCH(i),i),ZR2(:,i),SR2(:,:,i),MR2(:,:,i),m_paranoid,DBG)
        call mma_deallocate(ESO_TMP)
        call mma_deallocate(dipso_tmp)
        call mma_deallocate(s_so_tmp)
#       ifdef _DEBUGPRINT_
        do iT=1,nTempTotal
          write(u6,'(A,i1,A,i3,A,3ES22.14)') 'ML(',i,',L,',iT,')=',(ML2(l,iT,i)-ML1(l,iT,i),l=1,3)
          write(u6,'(A,i1,A,i3,A,3ES22.14)') 'MR(',i,',L,',iT,')=',(MR2(l,iT,i)-MR1(l,iT,i),l=1,3)
        end do
#       endif
      else
        ZL0(:,i) = Zero
        ZR0(:,i) = Zero
        ZL1(:,i) = Zero
        ZR1(:,i) = Zero
        ZL2(:,i) = Zero
        ZR2(:,i) = Zero
        SL0(:,:,i) = Zero
        SR0(:,:,i) = Zero
        SL1(:,:,i) = Zero
        SR1(:,:,i) = Zero
        SL2(:,:,i) = Zero
        SR2(:,:,i) = Zero
        ML0(:,:,i) = Zero
        MR0(:,:,i) = Zero
        ML1(:,:,i) = Zero
        MR1(:,:,i) = Zero
        ML2(:,:,i) = Zero
        MR2(:,:,i) = Zero
      end if ! NSS(i) > NEXCH(i)
    end do ! i=1,nneq

    ibuf1 = nTempTotal*nneq
    ibuf3 = 3*ibuf1
    call Add_Info('dM/dH    ML0',[dnrm2_(ibuf3,ML0,1)],1,8)
    call Add_Info('dM/dH    SL0',[dnrm2_(ibuf3,SL0,1)],1,8)
    call Add_Info('dM/dH    ZL0',[dnrm2_(ibuf1,ZL0,1)],1,8)
    call Add_Info('dM/dH    WL0',[dnrm2_(nLoc*nneq,WL0,1)],1,8)

    call Add_Info('dM/dH    MR0',[dnrm2_(ibuf3,MR0,1)],1,8)
    call Add_Info('dM/dH    SR0',[dnrm2_(ibuf3,SR0,1)],1,8)
    call Add_Info('dM/dH    ZR0',[dnrm2_(ibuf1,ZR0,1)],1,8)
    call Add_Info('dM/dH    WR0',[dnrm2_(nLoc*nneq,WR0,1)],1,8)

    call Add_Info('dM/dH    ML1',[dnrm2_(ibuf3,ML1,1)],1,8)
    call Add_Info('dM/dH    SL1',[dnrm2_(ibuf3,SL1,1)],1,8)
    call Add_Info('dM/dH    ZL1',[dnrm2_(ibuf1,ZL1,1)],1,8)
    call Add_Info('dM/dH    WL1',[dnrm2_(nLoc*nneq,WL1,1)],1,8)

    call Add_Info('dM/dH    MR1',[dnrm2_(ibuf3,MR1,1)],1,8)
    call Add_Info('dM/dH    SR1',[dnrm2_(ibuf3,SR1,1)],1,8)
    call Add_Info('dM/dH    ZR1',[dnrm2_(ibuf1,ZR1,1)],1,8)
    call Add_Info('dM/dH    WR1',[dnrm2_(nLoc*nneq,WR1,1)],1,8)

    call Add_Info('dM/dH    ML2',[dnrm2_(ibuf3,ML2,1)],1,8)
    call Add_Info('dM/dH    SL2',[dnrm2_(ibuf3,SL2,1)],1,8)
    call Add_Info('dM/dH    ZL2',[dnrm2_(ibuf1,ZL2,1)],1,8)
    call Add_Info('dM/dH    WL2',[dnrm2_(nLoc*nneq,WL2,1)],1,8)

    call Add_Info('dM/dH    MR2',[dnrm2_(ibuf3,MR2,1)],1,8)
    call Add_Info('dM/dH    SR2',[dnrm2_(ibuf3,SR2,1)],1,8)
    call Add_Info('dM/dH    ZR2',[dnrm2_(ibuf1,ZR2,1)],1,8)
    call Add_Info('dM/dH    WR2',[dnrm2_(nLoc*nneq,WR2,1)],1,8)

    ! expand the basis and rotate local vectors to the general
    ! coordinate system:

    isite = 0
    do i=1,NNEQ
      do j=1,NEQ(i)
        isite = isite+1
        ! statistical distributions
        ZLT0(isite,:) = ZL0(:,i)
        ZRT0(isite,:) = ZR0(:,i)
        ZLT1(isite,:) = ZL1(:,i)
        ZRT1(isite,:) = ZR1(:,i)
        ZLT2(isite,:) = ZL2(:,i)
        ZRT2(isite,:) = ZR2(:,i)
        ! magnetizations:
        !    use R_rot matrices, which have determinant +1.
        !  note that  R_lg matrices have arbitrary determinant.
        do iT=1,nTempTotal
          do n=1,3
            MLT0(isite,:,iT) = MLT0(isite,:,iT)+rrot(i,j,:,n)*ML0(n,iT,i)
            SLT0(isite,:,iT) = SLT0(isite,:,iT)+rrot(i,j,:,n)*SL0(n,iT,i)
            MRT0(isite,:,iT) = MRT0(isite,:,iT)+rrot(i,j,:,n)*MR0(n,iT,i)
            SRT0(isite,:,iT) = SRT0(isite,:,iT)+rrot(i,j,:,n)*SR0(n,iT,i)

            MLT1(isite,:,iT) = MLT1(isite,:,iT)+rrot(i,j,:,n)*ML1(n,iT,i)
            SLT1(isite,:,iT) = SLT1(isite,:,iT)+rrot(i,j,:,n)*SL1(n,iT,i)
            MRT1(isite,:,iT) = MRT1(isite,:,iT)+rrot(i,j,:,n)*MR1(n,iT,i)
            SRT1(isite,:,iT) = SRT1(isite,:,iT)+rrot(i,j,:,n)*SR1(n,iT,i)

            MLT2(isite,:,iT) = MLT2(isite,:,iT)+rrot(i,j,:,n)*ML2(n,iT,i)
            SLT2(isite,:,iT) = SLT2(isite,:,iT)+rrot(i,j,:,n)*SL2(n,iT,i)
            MRT2(isite,:,iT) = MRT2(isite,:,iT)+rrot(i,j,:,n)*MR2(n,iT,i)
            SRT2(isite,:,iT) = SRT2(isite,:,iT)+rrot(i,j,:,n)*SR2(n,iT,i)
          end do
        end do

      end do ! j, neq(i)
    end do ! i, nneq
    ibuf = 0
    ibuf = 3*nTempTotal*nCenter
    call Add_Info('dM/dH    MLT0',[dnrm2_(ibuf,MLT0,1)],1,8)
    call Add_Info('dM/dH    SLT0',[dnrm2_(ibuf,SLT0,1)],1,8)
    call Add_Info('dM/dH    MRT0',[dnrm2_(ibuf,MRT0,1)],1,8)
    call Add_Info('dM/dH    SRT0',[dnrm2_(ibuf,SRT0,1)],1,8)

    call Add_Info('dM/dH    MLT1',[dnrm2_(ibuf,MLT1,1)],1,8)
    call Add_Info('dM/dH    SLT1',[dnrm2_(ibuf,SLT1,1)],1,8)
    call Add_Info('dM/dH    MRT1',[dnrm2_(ibuf,MRT1,1)],1,8)
    call Add_Info('dM/dH    SRT1',[dnrm2_(ibuf,SRT1,1)],1,8)

    call Add_Info('dM/dH    MLT2',[dnrm2_(ibuf,MLT2,1)],1,8)
    call Add_Info('dM/dH    SLT2',[dnrm2_(ibuf,SLT2,1)],1,8)
    call Add_Info('dM/dH    MRT2',[dnrm2_(ibuf,MRT2,1)],1,8)
    call Add_Info('dM/dH    SRT2',[dnrm2_(ibuf,SRT2,1)],1,8)
    ! compute the total magnetizations according to the derived formulas:
#   ifdef _DEBUGPRINT_
    write(u6,*) 'check point MLT0'
#   endif
    do iT=1,nTempTotal
      if (smagn) then
        call MSUM(nCenter,Sex0(:,iT),Zex0(iT),SLT0(:,:,iT),ZLT0(:,iT),SRT0(:,:,iT),ZRT0(:,iT),iopt,ST0(:,iT),ZT0(iT))
        call MSUM(nCenter,Sex1(:,iT),Zex1(iT),SLT1(:,:,iT),ZLT1(:,iT),SRT1(:,:,iT),ZRT1(:,iT),iopt,ST1(:,iT),ZT1(iT))
        call MSUM(nCenter,Sex2(:,iT),Zex2(iT),SLT2(:,:,iT),ZLT2(:,iT),SRT2(:,:,iT),ZRT2(:,iT),iopt,ST2(:,iT),ZT2(iT))
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'check point MSUM'
#     endif
      call MSUM(nCenter,Mex0(:,iT),Zex0(iT),MLT0(:,:,iT),ZLT0(:,iT),MRT0(:,:,iT),ZRT0(:,iT),iopt,MT0(:,iT),ZT0(iT))
      call MSUM(nCenter,Mex1(:,iT),Zex1(iT),MLT1(:,:,iT),ZLT1(:,iT),MRT1(:,:,iT),ZRT1(:,iT),iopt,MT1(:,iT),ZT1(iT))
      call MSUM(nCenter,Mex2(:,iT),Zex2(iT),MLT2(:,:,iT),ZLT2(:,iT),MRT2(:,:,iT),ZRT2(:,iT),iopt,MT2(:,iT),ZT2(iT))
    end do

  end if ! m_accurate

  ibuf = 3*nTempTotal
  call Add_Info('dM/dH    ST0',[dnrm2_(ibuf,ST0,1)],1,6)
  call Add_Info('dM/dH    ST1',[dnrm2_(ibuf,ST1,1)],1,6)
  call Add_Info('dM/dH    ST2',[dnrm2_(ibuf,ST2,1)],1,6)
  call Add_Info('dM/dH    MT0',[dnrm2_(ibuf,MT0,1)],1,6)
  call Add_Info('dM/dH    MT1',[dnrm2_(ibuf,MT1,1)],1,6)
  call Add_Info('dM/dH    MT2',[dnrm2_(ibuf,MT2,1)],1,6)
  ! computing the AVERAGE MOMENTS calculated at different temperatures (T(i))
  do iT=1,nTempTotal
    F1 = T(iT)*cm3tomB/dltXF
    F2 = T(iT)*cm3tomB/Xfield

    ! dM/dH model
    XTtens_dMdH(iM,:,iT) = (MT2(:,iT)-MT1(:,iT))*F1

    ! M/H model
    XTtens_MH(iM,:,iT) = MT0(:,iT)*F2
  end do
  ! ///  closing the loops over field directions
end do ! iM (nDirX)
! computing the XT as tensor's average:
XTM_dMdH(:) = (XTtens_dMdH(1,1,:)+XTtens_dMdH(2,2,:)+XTtens_dMdH(3,3,:))/Three

XTM_MH(:) = (XTtens_MH(1,1,:)+XTtens_MH(2,2,:)+XTtens_MH(3,3,:))/Three

ibuf = 9*nTempTotal
call Add_Info('dM/dH    XTtens_dMdH',[dnrm2_(ibuf,XTtens_dMdH,1)],1,5)
call Add_Info('dM/dH    XTtens_MH',[dnrm2_(ibuf,XTtens_MH,1)],1,6)
ibuf = nTempTotal
call Add_Info('dM/dH    XTM_dMdH',[dnrm2_(ibuf,XTM_dMdH,1)],1,5)
call Add_Info('dM/dH    XTM_MH',[dnrm2_(ibuf,XTM_MH,1)],1,6)
! ----------------------------------------------------------------------
! WRITING SOME OF THE OUTPUT....
! ----------------------------------------------------------------------
write(u6,*)
write(u6,'(A)') '--------------------------------------------------------------------------|'
write(u6,'(A)') '     |     T      | Statistical |   CHI*T     |   CHI*T     |   CHI*T     |'
write(u6,'(A,F6.3,A,F6.3,A)') '     |            |  Sum (Z)    | H = 0.000 T | H =',Xfield,' T | H =',XField,' T |'
write(u6,'(A)') '     |            |             |             | X = dM/dH   | X = M/H     |'
write(u6,'(A)') '-----|--------------------------------------------------------------------|'
write(u6,'(A)') 'Units|   kelvin   |    ---      |  cm3*K/mol  |  cm3*K/mol  |  cm3*K/mol  |'
write(u6,'(A)') '-----|--------------------------------------------------------------------|'

do iT=1,nT
  jT = iT+nTempMagn
  write(u6,'(A,F11.6,A,ES12.5,A,F12.8,A,F12.8,A,F12.7,A)') '     |',T(jT),' |',ZT0(jT),' |',XT_no_field(jT),' |',XTM_dMdH(jT), &
                                                           ' |',XTM_MH(jT),' |'
end do
write(u6,'(A)') '-----|--------------------------------------------------------------------|'

!  calcualtion of the standard deviation:
if (tinput) then
  write(u6,'(a,5x, f20.14)') 'ST.DEV: X= dM/dH:',dev(nT,XTM_dMdH(1+nTempMagn:),chit_exp(1+nTempMagn:))
  write(u6,'(a,5x, f20.14)') 'ST.DEV: X=  M/H :',dev(nT,XTM_MH(1+nTempMagn:),chit_exp(1+nTempMagn:))
  write(u6,'(A)') '-----|--------------------------------------------------------------------|'
end if !tinput

!-------------------------  PLOTs -------------------------------------!
write(label,'(A)') 'with_field_M_over_H'
call xFlush(u6)
if (DoPlot) then
  if (tinput) then
    call plot_XT_with_Exp(label,nT,T(1+nTempMagn:),XTM_MH(1+nTempMagn:),chit_exp(1+nTempMagn:))
  else
    call plot_XT_no_Exp(label,nT,T(1+nTempMagn:),XTM_MH(1+nTempMagn:))
  end if
end if

write(label,'(A)') 'with_field_dM_over_dH'
call xFlush(u6)
if (DoPlot) then
  if (tinput) then
    call plot_XT_with_Exp(label,nT,T(1+nTempMagn:),XTM_dMdH(1+nTempMagn:),chit_exp(1+nTempMagn:))
  else
    call plot_XT_no_Exp(label,nT,T(1+nTempMagn:),XTM_dMdH(1+nTempMagn:))
  end if
end if
!------------------------- END PLOTs ----------------------------------!

! print out the main VAN VLECK SUSCEPTIBILITY TENSOR, its main values and main axes:
write(u6,'(/)')
write(u6,'(2A)') repeat('-',110),'|'
write(u6,'(25X,A,15x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR FOR the  X=dM/dH  model,  in cm3*K/mol','|'
write(u6,'(2A)') repeat('-',110),'|'
write(u6,'(A)') '     T(K)   |   |          Susceptibility Tensor      |    Main Values  |               Main Axes             |'
do iT=1,nT
  jT = iT+nTempMagn
  call DIAG_R2(XTtens_dMdH(:,:,jT),3,info,wt,zt)
  write(u6,'(A)') '------------|---|------- x --------- y --------- z ---|-----------------|------ x --------- y --------- z ----|'
  write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | x |',(XTtens_dMdH(1,j,jT),j=1,3),' |  X:',wt(1),'|', &
                                                  (zt(j,1),j=1,3),'|'
  write(u6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),'| y |',(XTtens_dMdH(2,j,jT),j=1,3),' |  Y:',wt(2),'|', &
                                                           (zt(j,2),j=1,3),'|'
  write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | z |',(XTtens_dMdH(3,j,jT),j=1,3),' |  Z:',wt(3),'|', &
                                                  (zt(j,3),j=1,3),'|'
end do
write(u6,'(2A)') repeat('-',110),'|'

write(u6,'(/)')
write(u6,'(2A)') repeat('-',110),'|'

write(u6,'(25X,A,15x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR FOR the  X = M/H  model,  in cm3*K/mol','|'
write(u6,'(2A)') repeat('-',110),'|'
write(u6,'(A)') '     T(K)   |   |          Susceptibility Tensor      |    Main Values  |               Main Axes             |'
do iT=1,nT
  jT = iT+nTempMagn
  call DIAG_R2(XTtens_MH(:,:,jT),3,info,wt,zt)
  write(u6,'(A)') '------------|---|------- x --------- y --------- z ---|-----------------|------ x --------- y --------- z ----|'
  write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | x |',(XTtens_MH(1,j,jT),j=1,3),' |  X:',wt(1),'|', &
                                                  (zt(j,1),j=1,3),'|'
  write(u6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),'| y |',(XTtens_MH(2,j,jT),j=1,3),' |  Y:',wt(2),'|', &
                                                           (zt(j,2),j=1,3),'|'
  write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | z |',(XTtens_MH(3,j,jT),j=1,3),' |  Z:',wt(3),'|', &
                                                  (zt(j,3),j=1,3),'|'
end do
write(u6,'(2A)') repeat('-',110),'|'

!=======================================================================
call mma_deallocate(WEX0)
call mma_deallocate(WEX1)
call mma_deallocate(WEX2)
call mma_deallocate(WL0)
call mma_deallocate(WL1)
call mma_deallocate(WL2)
call mma_deallocate(WR0)
call mma_deallocate(WR1)
call mma_deallocate(WR2)

call mma_deallocate(ZL0)
call mma_deallocate(ZR0)
call mma_deallocate(ZL1)
call mma_deallocate(ZR1)
call mma_deallocate(ZL2)
call mma_deallocate(ZR2)
call mma_deallocate(SL0)
call mma_deallocate(SR0)
call mma_deallocate(SL1)
call mma_deallocate(SR1)
call mma_deallocate(SL2)
call mma_deallocate(SR2)
call mma_deallocate(ML0)
call mma_deallocate(MR0)
call mma_deallocate(ML1)
call mma_deallocate(MR1)
call mma_deallocate(ML2)
call mma_deallocate(MR2)

call mma_deallocate(ZEX0)
call mma_deallocate(ZEX1)
call mma_deallocate(ZEX2)
call mma_deallocate(ZT0)
call mma_deallocate(ZT1)
call mma_deallocate(ZT2)
call mma_deallocate(SEX0)
call mma_deallocate(SEX1)
call mma_deallocate(SEX2)
call mma_deallocate(MEX0)
call mma_deallocate(MEX1)
call mma_deallocate(MEX2)
call mma_deallocate(ST0)
call mma_deallocate(ST1)
call mma_deallocate(ST2)
call mma_deallocate(MT0)
call mma_deallocate(MT1)
call mma_deallocate(MT2)
call mma_deallocate(XTM_MH)
call mma_deallocate(XTM_dMdH)
call mma_deallocate(XTtens_MH)
call mma_deallocate(XTtens_dMdH)

call mma_deallocate(ZRT0)
call mma_deallocate(ZLT0)
call mma_deallocate(ZRT1)
call mma_deallocate(ZLT1)
call mma_deallocate(ZRT2)
call mma_deallocate(ZLT2)
call mma_deallocate(MRT0)
call mma_deallocate(MLT0)
call mma_deallocate(SRT0)
call mma_deallocate(SLT0)
call mma_deallocate(MRT1)
call mma_deallocate(MLT1)
call mma_deallocate(SRT1)
call mma_deallocate(SLT1)
call mma_deallocate(MRT2)
call mma_deallocate(MLT2)
call mma_deallocate(SRT2)
call mma_deallocate(SLT2)

return

end subroutine XT_dMoverdH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989,1993, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE DIHDJ2_MCLR(IASTR,IBSTR,NIDET,
     &                 JASTR,JBSTR,NJDET,
     &                 NAEL,NBEL,
     & jWORK,LWORK,NORB,HAMIL,ISYM,NINOB,ECORE,ICOMBI,PSIGN,
     & IASTRM,IBSTRM,JASTRM,JBSTRM,
     & IGENSG,IASGN,IBSGN,JASGN,JBSGN,LIA,LIB,NDIF0,NDIF1,NDIF2,
     & IPRT)
*
* A set of left hand side determinants defined by string numbers
* IASTR and IBSTR and a set of right hand side determinants
* defined by JASTR and JBSTR are given.
*
* Obtain Hamiltonian matrix  < IA IB ! H ! JA JB >
*
* If Icombi .NE. 0 Spin combinations are assumed  for alpha and
* beta strings with different orbital configurations
*   1/SQRT(2) * ( !I1A I2B! + PSIGN * !I2A I1B! )
*
* If ISYM .EQ. 0 FULL Hamiltonian is constructed
* If ISYM .NE. 0 LOWER half of hamiltonian is constructed
*
* JEPPE OLSEN JANUARY 1989
*
*. Modifed to work with string numbers instead of strings
*. March 93
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IASTR(*),IBSTR(*)
      DIMENSION JASTR(*),JBSTR(*)
      DIMENSION IASTRM(NAEL,*),IBSTRM(NBEL,*)
      DIMENSION JASTRM(NAEL,*),JBSTRM(NBEL,*)
      DIMENSION IASGN(*),IBSGN(*),JASGN(*),JBSGN(*)
*
      DIMENSION jWORK(*), HAMIL(*)
      DIMENSION LIA(NAEL),LIB(NBEL)
*
*
*. Scratch space : 4 vectors of length NORB
      KLFREE = 1
      KLIAE  = KLFREE
      KLFREE = KLIAE + NORB
      KLIBE  = KLFREE
      KLFREE = KLIBE + NORB
*
      KLJAE = KLFREE
      KLFREE = KLJAE + NORB
      KLJBE = KLFREE
      KLFREE = KLJBE + NORB
*
      IF( ISYM .EQ. 0 ) THEN
        LHAMIL = NIDET*NJDET
      ELSE
        LHAMIL = NIDET*(NIDET+1) / 2
      END IF
      CALL SETVEC(HAMIL,0.0D0,LHAMIL)
*
      NTERMS= 0
      NDIF0 = 0
      NDIF1 = 0
      NDIF2 = 0
*
*. Loop over J determinants
*
      JAEQJB = -1    ! dummy initialize
      CONST  = 0.0D0 ! dummy initialize
      IEL1   = -1    ! dummy initialize
      JEL1   = -1    ! dummy initialize
      SIGNA  = 0.0D0 ! dummy initialize
      SIGNB  = 0.0D0 ! dummy initialize
      IPERM  = 0     ! dummy initialize
      JPERM  = 0     ! dummy initialize
      SIGN   = 0.0D0 ! dummy initialize
      XVAL   = 0.0D0 ! dummy initialize
      DO 1000 JDET = 1,NJDET
* Expand JDET
        JASTAC =JASTR(JDET)
        JBSTAC =JBSTR(JDET)
*
        IF(IGENSG .GT. 0 ) THEN
         JXSGN = JASGN(JASTAC)*JBSGN(JBSTAC)
        ELSE
         JXSGN = 1
        END IF
*
        CALL ISETVC(jWORK(KLJAE),0,NORB)
        CALL ISETVC(jWORK(KLJBE),0,NORB)
        DO 40 IAEL = 1, NAEL
          jWORK(KLJAE-1+JASTRM(IAEL,JASTAC) ) = 1
   40   CONTINUE
*
        DO 50 IBEL = 1, NBEL
          jWORK(KLJBE-1+JBSTRM(IBEL,JBSTAC) ) = 1
   50   CONTINUE
*
        IF( ICOMBI .NE. 0 ) THEN
          IF(JASTAC .EQ. JBSTAC) THEN
             JAEQJB = 1
          ELSE
             JAEQJB = 0
          END IF
        END IF
*
*
*
        IF( ISYM .EQ. 0 ) THEN
          MINI = 1
        ELSE
          MINI = JDET
        END IF
*
* Loop over I determinants
*
        DO 900 IDET = MINI, NIDET
          IASTAC = IASTR(IDET)
          IBSTAC = IBSTR(IDET)
*
          IF(IGENSG .GT. 0 ) THEN
           IXSGN = IASGN(IASTAC)*IBSGN(IBSTAC)
          ELSE
           IXSGN = 1
          END IF
*
          IF(IASTAC.EQ.IBSTAC) THEN
            IAEQIB = 1
          ELSE
            IAEQIB = 0
          END IF

*
          IF(ICOMBI.EQ.1 .AND. IAEQIB+JAEQJB.EQ.0 ) THEN
              NLOOP = 2
          ELSE
              NLOOP = 1
          END IF
          DO 899 ILOOP = 1, NLOOP
           NTERMS = NTERMS + 1
* For second part of spin combinations strings should be swopped
           IF(ILOOP.EQ.1) THEN
             CALL ICOPVE(IASTRM(1,IASTAC),LIA,NAEL)
             CALL ICOPVE(IBSTRM(1,IBSTAC),LIB,NBEL)
           ELSE IF (ILOOP.EQ.2) THEN
             CALL ICOPVE(IASTRM(1,IASTAC),LIB,NAEL)
             CALL ICOPVE(IBSTRM(1,IBSTAC),LIA,NBEL)
           END IF
*
* ==============================
*. Number of orbital differences
* ==============================
*
           NACM = 0
           DO 61 IAEL = 1, NAEL
             NACM = NACM + jWORK(KLJAE-1+LIA(IAEL))
   61      CONTINUE
           NBCM = 0
           DO 62 IBEL = 1, NBEL
             NBCM = NBCM + jWORK(KLJBE-1+LIB(IBEL))
   62      CONTINUE
           NADIF = NAEL-NACM
           NBDIF = NBEL-NBCM
*
           IF(NADIF+NBDIF .GT. 2 ) GOTO 898
*. Factor for combinations
           IF( ICOMBI .EQ. 0 ) THEN
             CONST = 1.0D0
           ELSE
             IF((JAEQJB +IAEQIB) .EQ.2 ) THEN
               CONST = 1.0D0
             ELSE IF( (JAEQJB+IAEQIB) .EQ. 1 ) THEN
               CONST = 1.0D0/SQRT(2.0D0)*(1.0D0+PSIGN)
              ELSE IF( (JAEQJB+IAEQIB) .EQ. 0 ) THEN
               IF( ILOOP .EQ. 1)  THEN
                 CONST = 1.0D0
               ELSE
                 CONST = PSIGN
               END IF
             END IF
           END IF
*. External sign factor
           IF(IXSGN*JXSGN .EQ. -1 ) CONST = - CONST
*
* ==================================================
*.. Find differing orbitals and sign for permutation
* ==================================================
*
* Expand idet
           CALL ISETVC(jWORK(KLIAE),0,NORB)
           CALL ISETVC(jWORK(KLIBE),0,NORB)
*
           DO 42 IAEL = 1, NAEL
             jWORK(KLIAE-1+LIA(IAEL)) = 1
   42      CONTINUE
*
           DO 52 IBEL = 1, NBEL
             jWORK(KLIBE-1+LIB(IBEL) ) = 1
   52      CONTINUE
*
*. One pair of differing alpha electrons
*
           IF(NADIF .EQ. 1 ) THEN
             DO 120 IAEL = 1,NAEL
               IF(jWORK(KLJAE-1+LIA(IAEL)).EQ.0) THEN
                 IA = LIA(IAEL)
                 IEL1 = IAEL
                 GOTO 121
               END IF
  120        CONTINUE
  121        CONTINUE
*
             DO 130 JAEL = 1,NAEL
               IF(jWORK(KLIAE-1+JASTRM(JAEL,JASTAC)).EQ.0) THEN
                 JA = JASTRM(JAEL,JASTAC)
                 JEL1 = JAEL
                 GOTO 131
                END IF
  130        CONTINUE
  131        CONTINUE
             SIGNA = DBLE((-1)**(JEL1+IEL1))
           END IF
*
*. One pair of differing beta electrons
*
           IF(NBDIF .EQ. 1 ) THEN
             DO 220 IBEL = 1,NBEL
               IF(jWORK(KLJBE-1+LIB(IBEL) ).EQ.0) THEN
                 IB = LIB(IBEL)
                 IEL1 = IBEL
                 GOTO 221
                END IF
  220        CONTINUE
  221        CONTINUE
             DO 230 JBEL = 1,NBEL
               IF(jWORK(KLIBE-1+JBSTRM(JBEL,JBSTAC)).EQ.0) THEN
                 JB = JBSTRM(JBEL,JBSTAC)
                 JEL1 = JBEL
                 GOTO 231
                END IF
  230        CONTINUE
  231        CONTINUE
             SIGNB = DBLE((-1)**(JEL1+IEL1))
           END IF
*
*. Two pairs of differing alpha electrons
*
           IF(NADIF .EQ. 2 ) THEN
             IDIFF = 0
             DO 320 IAEL = 1,NAEL
               IF(jWORK(KLJAE-1+LIA(IAEL)          ).EQ.0) THEN
                 IF( IDIFF .EQ. 0 ) THEN
                   IDIFF = 1
                   I1 = LIA(IAEL)
                   IPERM = IAEL
                 ELSE
                   I2 = LIA(IAEL)
                   IPERM = IAEL + IPERM
                   GOTO 321
                 END IF
               END IF
  320        CONTINUE
  321        CONTINUE
*
             JDIFF = 0
             DO 330 JAEL = 1,NAEL
               IF(jWORK(KLIAE-1+JASTRM(JAEL,JASTAC)).EQ.0) THEN
                 IF( JDIFF .EQ. 0 ) THEN
                   JDIFF = 1
                   J1 = JASTRM(JAEL,JASTAC)
                   JPERM = JAEL
                 ELSE
                   J2 = JASTRM(JAEL,JASTAC)
                   JPERM = JAEL + JPERM
                   GOTO 331
                 END IF
               END IF
  330        CONTINUE
  331        CONTINUE
             SIGN = DBLE((-1)**(IPERM+JPERM))
           END IF
*
*. Two pairs of differing beta electrons
*
           IF(NBDIF .EQ. 2 ) THEN
             IDIFF = 0
             DO 420 IBEL = 1,NBEL
               IF(jWORK(KLJBE-1+LIB(IBEL)          ).EQ.0) THEN
                 IF( IDIFF .EQ. 0 ) THEN
                   IDIFF = 1
                   I1 = LIB(IBEL)
                   IPERM = IBEL
                 ELSE
                   I2 = LIB(IBEL)
                   IPERM = IBEL + IPERM
                   GOTO 421
                  END IF
               END IF
  420        CONTINUE
  421        CONTINUE
*
             JDIFF = 0
             DO 430 JBEL = 1,NBEL
               IF(jWORK(KLIBE-1+JBSTRM(JBEL,JBSTAC)).EQ.0) THEN
                 IF( JDIFF .EQ. 0 ) THEN
                   JDIFF = 1
                   J1 = JBSTRM(JBEL,JBSTAC)
                   JPERM = JBEL
                 ELSE
                   J2 = JBSTRM(JBEL,JBSTAC)
                   JPERM = JBEL + JPERM
                   GOTO 431
                 END IF
               END IF
  430        CONTINUE
  431        CONTINUE
             SIGN = DBLE((-1)**(IPERM+JPERM))
           END IF
*
* =======================
* Value of matrix element
* =======================
*
        IF( NADIF .EQ. 2 .OR. NBDIF .EQ. 2 ) THEN
* 2 differences in alpha or beta strings
          NDIF2 = NDIF2 + 1
* SIGN * (I1 J1 ! I2 J2 ) - ( I1 J2 ! I2 J1 )
          XVAL = SIGN*( GTIJKL_MCLR(I1,J1,I2,J2)-
     &                  GTIJKL_MCLR(I1,J2,I2,J1) )
        ELSE IF( NADIF .EQ. 1 .AND. NBDIF .EQ. 1 ) THEN
*. 1 difference in alpha strings and one difference in beta string
          NDIF2 = NDIF2 + 1
* SIGN * (IA JA ! IB JB )
          XVAL = SIGNA*SIGNB* GTIJKL_MCLR(IA,JA,IB,JB)
* 1 differences in alpha or beta strings
        ELSE IF( NADIF .EQ. 1 .AND. NBDIF .EQ. 0 .OR.
     &           NADIF .EQ. 0 .AND. NBDIF .EQ. 1 )THEN
          NDIF1 = NDIF1 + 1
* SIGN *
*(  H(I1 J1 ) +
*  (SUM OVER ORBITALS OF BOTH      SPIN TYPES  ( I1 J1 ! JORB JORB )
* -(SUM OVER ORBITALS OF DIFFERING SPIN TYPE   ( I1 JORB ! JORB J1 ) )
          IF( NADIF .EQ. 1 ) THEN
            I1 = IA
            J1 = JA
            SIGN = SIGNA
          ELSE
            I1 = IB
            J1 = JB
            SIGN = SIGNB
          END IF
*
          XVAL = GETH1I_MCLR(I1,J1)
          DO 520 JAEL = 1, NAEL
            JORB = JASTRM(JAEL,JASTAC)
            XVAL = XVAL + GTIJKL_MCLR(I1,J1,JORB,JORB)
  520     CONTINUE
          DO 521 JBEL = 1, NBEL
            JORB = JBSTRM(JBEL,JBSTAC)
            XVAL = XVAL + GTIJKL_MCLR(I1,J1,JORB,JORB)
  521     CONTINUE
          IF( NADIF .EQ. 1 ) THEN
            DO 522 JAEL = 1, NAEL
              JORB = JASTRM(JAEL,JASTAC)
              XVAL = XVAL - GTIJKL_MCLR(I1,JORB,JORB,J1)
  522       CONTINUE
          ELSE
            DO 523 JBEL = 1, NBEL
              JORB = JBSTRM(JBEL,JBSTAC)
              XVAL = XVAL - GTIJKL_MCLR(I1,JORB,JORB,J1)
  523       CONTINUE
          END IF
          XVAL = XVAL * SIGN
        ELSE IF( NADIF .EQ. 0 .AND. NBDIF .EQ. 0 ) THEN
*. Diagonal elements
          NDIF0 = NDIF0 + 1
          XVAL = ECORE
          DO 650 IAB = 1, 2
            IF(IAB .EQ. 1 ) THEN
              NIABEL = NAEL
            ELSE
              NIABEL = NBEL
            END IF
            DO 640 JAB = 1, 2
              IF(JAB .EQ. 1 ) THEN
                NJABEL = NAEL
              ELSE
                NJABEL = NBEL
              END IF
              DO 630 IEL = 1, NIABEL
                IF( IAB .EQ. 1 ) THEN
                  IORB = LIA(IEL)
                ELSE
                  IORB = LIB(IEL)
                END IF
                IF(IAB .EQ. JAB ) XVAL = XVAL + GETH1I_MCLR(IORB,IORB)
                DO 620 JEL = 1, NJABEL
                  IF( JAB .EQ. 1 ) THEN
                    JORB = LIA(JEL)
                  ELSE
                    JORB = LIB(JEL)
                  END IF
                  XVAL = XVAL + 0.5D0*GTIJKL_MCLR(IORB,IORB,JORB,JORB)
*. test

                  IF( IAB . EQ. JAB )
     &            XVAL = XVAL - 0.5D0*GTIJKL_MCLR(IORB,JORB,JORB,IORB)
*. test
          FAC = GTIJKL_MCLR(IORB,JORB,JORB,IORB)
  620           CONTINUE
  630         CONTINUE
  640       CONTINUE
  650     CONTINUE
        END IF

        IF( ISYM .EQ. 0 ) THEN
          HAMIL((JDET-1)*NIDET+IDET) =
     &    HAMIL((JDET-1)*NIDET+IDET) + CONST * XVAL
        ELSE
          HAMIL((IDET-1)*IDET/2 + JDET ) =
     &    HAMIL((IDET-1)*IDET/2 + JDET ) + CONST * XVAL
        END IF
  898 CONTINUE
  899 CONTINUE
  900 CONTINUE
 1000 CONTINUE

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(LWORK)
        CALL Unused_integer(NINOB)
        CALL Unused_integer(IPRT)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!               1996, Bjorn O. Roos                                    *
!***********************************************************************

subroutine TRAMO_MCLR(LBUF,X1,n1,X2,n2,X3,n3,X4,n4,Buffer,MEMX,NBP,NBQ,NBR,NBS,iSP,iSQ,iSR,iSS,nAP,nAQ,nAR,nAS,CMP,CMQ,CMR,CMS, &
                      iAD13,iAD14,iAD23,iAD24,iAD34,IDAHLF2,IRLHLF2,IDAHLF3,IRLHLF3,LIOTAB)
!***********************************************************************
!                                                                      *
!     Purpose: two-electron transformation routine.                    *
!              Transformation is made in core if all                   *
!              half-transformed integrals fit.                         *
!              Otherwise sorted integrals are written onto             *
!              unit LUHALF.                                            *
!                                                                      *
!***********************************************************************
!                                                                      *
!  Stolen from MOTRA and destroyed by Anders to make it                *
!  possible to generate all sort of combination of transformed         *
!  and untransformed indexes                                           *
!                                                                      *
!***********************************************************************

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Index_Functions, only: nTri_Elem
use MCLR_Data, only: FnHlf2, FnHlf3, LuHlf2, LuHlf3, LuTri1, LuTri2, LuTri3, LuTri4, LuTri5, NoFile
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, ItoB

implicit none
integer(kind=iwp), intent(in) :: LBUF, n1, n2, n3, n4, MEMX, NBP, NBQ, NBR, NBS, iSP, iSQ, iSR, iSS, nAP, nAQ, nAR, nAS, LIOTAB
real(kind=wp), intent(out) :: X1(n1), X2(n2), X3(n3), X4(n4), Buffer(MemX)
real(kind=wp), intent(in) :: CMP(nBP,nAP), CMQ(nBQ,nAQ), CMR(nBR,nAR), CMS(nBS,nAS)
integer(kind=iwp), intent(inout) :: iAD13, iAD14, iAD23, iAD24, iAD34
integer(kind=iwp), intent(out) :: IDAHLF2(LIOTAB), IRLHLF2(LIOTAB), IDAHLF3(LIOTAB), IRLHLF3(LIOTAB)
integer(kind=iwp) :: I1, I2, IAD2, IAD3, IBUF, IBUF2, IBUF3, IMAX, INCORE, iOne, IOPT, IP2, IP3, IP4, IP5, IPB, IPQ, IPQST, &
                     IPQUT2, IPQUT3, IPQUT4, IPX, IPY, IPZ, IRC, IRSST, IST, IST2, IST3, IVX, LPKREC, LPQ, MemXX, MEMXXX, NARS, &
                     NBPQ, NBRS, NBUF, NBYTES, NOUT, NPQ, NQM, NR2, NR3

call TRAMO_MCLR_INTERNAL(Buffer)

! This is to allow type punning without an explicit interface
contains

subroutine TRAMO_MCLR_INTERNAL(Buffer)

  real(kind=wp), target, intent(out) :: Buffer(MemX)
  integer(kind=iwp), pointer :: iBuffer(:)
  integer(kind=iwp) :: I, NP, NQ, NR, NS

  ione = 1
  if (nofile) ione = 0

  ! Set some constants

  MemXX = MemX-lBuf-1010
  if (ISS == isr) then
    NBPQ = nTri_Elem(NBP)
    NBRS = nTri_Elem(NBR)
    NARS = nTri_Elem(NAR)
  else
    NBPQ = NBP*NBQ
    NBRS = NBR*NBS
    NARS = NAR*NAS
  end if
  iBUF2 = 0
  iBUF3 = 0
  iAD2 = 0      ! Disk address for (kL|ij)
  iAD3 = 0      ! Disk address for (Kl|ij)
  iPQUT2 = 0    ! Index(ij)  in buffer.
  iPQUT3 = 0    ! Just one should be enough but...
  iPQUT4 = 0    ! ...easy is better than intelligent
  if (iSP == iSQ) then
    iMax = nTri_Elem(nBP)
  else
    iMax = nBP*nBQ  ! Size of buffer
  end if
  Incore = 0        ! First we try to  transform in core
  if (iss /= isr) then
    nBuf = nBR*nAS+nAR*nBS
  else
    nbuf = nbr*nas
  end if

  ! Buffer needed in the final step in the calculation of the exchange type
  ! integrals. The factor ten is arbitrary, however a 10 writes to disk per
  ! batch is acceptable before paging out integrals to disk to increase
  ! memory, however we dont want to write in to small batches 512 dWords (4k) is
  ! the lower limit
  !
  ! /*
  !    __________________________________
  !    |          |           |         |
  !    |          |           |         |
  !    ----------------------------------
  !    |          |           |         |
  !    |         -|-----------|---------|
  !    ---------------------------------|\
  !    |        | |           |         | \
  !    | ORDINT | |  (IjkL)   | (Ij|Kl) |  \
  !    |----------|           |         |   \ N
  !    ----------------------------------   /
  !    |          |           |         |  /
  !    | (ij|KL)  |  (iJ|kL)  | (iJ|Kl) | /
  !    |          |           |         |/
  !    ----------------------------------\
  !    |          |           |         | \
  !    | (ij|Kl)  |  (ij|Kl)  | (ij|Kl) |  \
  !    |          |           |         |   \
  !    ----------------------------------    nBuf*iMax
  !    |          |           |         |   /
  !    | (ij|kL)  |  (ij|kL)  | (ij|kL) |  /
  !    |          |           |         | /
  !    ----------------------------------/
  ! */
  i1 = nAS*(nAP*nBQ*nBR+nAQ*nBP*nBR)
  if (ISP == ISQ) i1 = nAS*nAP*nBQ*nBR
  i2 = nAR*(nAP*nBQ*nBS+nAQ*nBP*nBS)
  if (ISP == ISQ) i2 = nAR*nAP*nBQ*nBS
  ! Size of output buffer if all data should fit in memory
  NOUT = max(i1,i2,NARS*nBPQ)
  !NOUT = max(nAS*(nAP*nBQ*nBR+nAQ*nBP*nBR),nAR*(nAP*nBQ*nBS+nAQ*nBP*nBS),NAR*nAS*nBQ*nBP)

  if (nBuf*iMax+NOUT <= MemXX) then
    Incore = 0 ! We can do the calculation totally in core
  else
    ! But we dont have enough memory
    Incore = 1
    MemXXX = MemXX-nOut
    ! So we give each buffer same amount of memory
    iMax = MemXXX/nBuf
    ! But we need space to unpack the integrals
    iMax = (MemXXX-iMax)/nBuf
    iMax = (MemXXX-iMax)/nBuf
    iMax = (MemXXX-iMax)/nBuf
    if (iMax < 1) then
      write(u6,*) 'TraMO_MCLR: iMax < 1'
      write(u6,*) 'iMax=',iMax
      call Abend()
    end if
    call DAName(LUHLF2,FNHLF2)
    call DAName(LUHLF3,FNHLF3)
  end if

  !*********************************************************************
  !
  ! OK to start with with we need buffers but in the final step
  ! the only memory we need is a place to load (pq) integrals plus
  ! unpacking area plus a area of the size n to put the final result
  ! if we do not have enough memory, we will have a very long nose
  !
  !*********************************************************************

  ip2 = 1                   ! (ij|kL)
  ip3 = ip2+iMax*nBR*nAS+1  ! (ij|Kl)
  Buffer(ip3-1) = -99999.0_wp
  if (iss /= isr) then
    ip4 = ip3+iMax*nBS*nAR+1  ! (ij|KL)
  else
    ip4 = ip3+1
  end if
  Buffer(ip4-1) = -99999.0_wp
  ipB = ip4+nBPQ*nARS+1   ! Read from ORDINT
  Buffer(ipB-1) = -99999.0_wp

  !*********************************************************************
  !
  ! Start loop over sorted AO-integrals: npq pq-pairs in each buffer
  !
  !*********************************************************************

  IPQ = 0
  LPQ = 0
  NPQ = 0
  IRSST = 1-NBRS    ! startpoint for present batch of integrals
  iopt = 1

  if (.not. NOFILE) then
    do NP=1,NBP
      NQM = NBQ
      if (ISP == ISQ) NQM = NP
      do NQ=1,NQM
        IPQ = IPQ+1
        IPQUT2 = IPQUT2+1
        IPQUT3 = IPQUT3+1
        IPQUT4 = IPQUT4+1

        !***************************************************************
        !                                                              *
        !         Read in a block of integrals  NPQ pq values          *
        !                                                              *
        !***************************************************************

        if ((LPQ == NPQ) .and. (.not. NOFILE)) then
          call RDORD(IRC,IOPT,ISP,ISQ,ISR,ISS,Buffer(ipB),LBUF,NPQ)
          call GADSum(Buffer(ipB),LBuf)
          if (irc /= 0) then
            write(u6,*) 'TraMO_MCLR: error reading ORDINT!'
            call Abend()
          end if
          IOPT = 2
          LPQ = 0
          IRSST = 1-NBRS
        end if
        LPQ = LPQ+1
        IRSST = IRSST+NBRS

        !***************************************************************
        !                                                              *
        !       Start transformation of this pq pair -> (ij|kL) (ijKl) *
        !                                                              *
        !***************************************************************

        if ((nAS*nAR /= 0) .or. (nAS*(nAP+nAQ) /= 0)) then
          if (iSR == iSS) then
            call SQUARE(Buffer(ipB+IRSST-1),X1,1,NBS,NBS)
            call DGEMM_('T','N',NBR,NAS,NBS,One,X1,NBS,CMS,NBS,Zero,X2,NBR)
          else
            call DGEMM_('T','N',NBR,NAS,NBS,One,Buffer(ipB+IRSST-1),NBS,CMS,NBS,Zero,X2,NBR)
          end if
        end if

        !***************************************************************
        !                                                              *
        !     Sort and save integrals transformed in one index         *
        !     that should be used for exchange type integrals          *
        !                                                              *
        !***************************************************************

        if ((nAP+nAQ)*nAS /= 0) then
          if (IPQUT2 > iMax) then
            iPQUT2 = 1
            iST2 = 1
            do i=1,nAS*nBR
              iBuf2 = iBuf2+1
              if (iBuf2 > LIOTAB) then
                write(u6,*) 'TraMO_MCLR: iBuf2 > LIOTAB'
                write(u6,*) 'iBuf2,LIOTAB=',iBuf2,LIOTAB
                call Abend()
              end if
              call PKR8(0,iMax,NBYTES,Buffer(ip2+ist2-1),Buffer(ip2+ist2-1))
              LPKREC = (NBYTES+ItoB-1)/ItoB
              ! Save the length of this record
              IRLHLF2(iBUF2) = LPKREC
              ! Save the address of this record
              IDAHLF2(iBUF2) = iAD2
              call c_f_pointer(c_loc(Buffer(ip2+IST2-1)),iBuffer,[LPKREC])
              call iDAFILE(LUHLF2,1,iBuffer,LPKREC,IAD2)
              nullify(iBuffer)
              iST2 = iST2+iMax
            end do
          end if

          Buffer(ip2+iPQUT2-1:ip2+iPQUT2-1+nAs*nBR*iMax-1:iMax) = X2(1:nAs*nBR)

        end if
        !***************************************************************

        if (ISR /= ISS) then
          call DGEMM_('N','N',NBS,NAR,NBR,One,Buffer(ipB+IRSST-1),NBS,CMR,NBR,Zero,X3,NBS)

          !*************************************************************
          if ((nAP+nAQ)*nAR /= 0) then
            if (IPQUT3 > iMax) then
              IPQUT3 = 1
              IST3 = 1
              do I=1,nAR*nBS
                IBUF3 = IBUF3+1
                if (IBUF3 > LIOTAB) then
                  write(u6,*) 'TraMO_MCLR: iBuf3 > LIOTAB'
                  write(u6,*) 'iBuf3,LIOTAB=',iBuf3,LIOTAB
                  call Abend()
                end if
                call PKR8(0,IMAX,NBYTES,Buffer(ip3+IST3-1),Buffer(ip3+IST3-1))
                LPKREC = (NBYTES+ItoB-1)/ItoB
                IRLHLF3(IBUF3) = LPKREC
                IDAHLF3(IBUF3) = IAD3
                call c_f_pointer(c_loc(Buffer(ip3+IST3-1)),iBuffer,[LPKREC])
                call iDAFILE(LUHLF3,1,iBuffer,LPKREC,IAD3)
                nullify(iBuffer)
                IST3 = IST3+iMax
              end do
            end if
          end if

          Buffer(ip3+iPQUT3-1:ip3+iPQUT3-1+nAR*nBS*iMax:iMax) = X3(1:nAR*nBS)

        end if

        !***************************************************************
        !
        !  Transform to Coulomb type integrals
        !
        !***************************************************************

        if (NAR*NAS /= 0) then
          if (ISR == ISS) then
            call DGEMM_Tri('T','N',NAR,NAR,NBR,One,X2,NBR,CMR,NBR,Zero,X4,NAR)
          else
            call DGEMM_('T','N',NAS,NAR,NBR,One,X2,NBR,CMR,NBR,Zero,X4,NAS)
          end if
        end if

        !***************************************************************

        Buffer(ip4+iPQUT4-1:ip4+iPQUT4-1+nARS*nBPQ-1:nBPQ) = X4(1:nARS)

        !***************************************************************

      end do
    end do

    !*******************************************************************
    !
    !     Empty last buffers
    !
    !*******************************************************************

    if (INCORE == 1) then
      IST = 1
      do I=1,nBR*nAS
        IBUF2 = IBUF2+1
        if (IBUF2 > LIOTAB) then
          write(u6,*) 'TraMO_MCLR: iBuf2 > LIOTAB'
          write(u6,*) 'iBuf2,LIOTAB=',iBuf2,LIOTAB
          call Abend()
        end if
        call PKR8(0,iMax,NBYTES,Buffer(ip2+IST-1),Buffer(ip2+IST-1))
        LPKREC = (NBYTES+ItoB-1)/ItoB
        IDAHLF2(IBUF2) = IAD2
        IRLHLF2(IBUF2) = LPKREC
        call c_f_pointer(c_loc(Buffer(ip2+IST-1)),iBuffer,[LPKREC])
        call iDAFILE(LUHLF2,1,iBuffer,LPKREC,IAD2)
        nullify(iBuffer)
        IST = IST+IMAX
      end do
      if (iSS /= iSR) then
        IST = 1
        do I=1,nBS*nAR
          IBUF3 = IBUF3+1
          if (IBUF3 > LIOTAB) then
            write(u6,*) 'TraMO_MCLR: iBuf3 > LIOTAB'
            write(u6,*) 'iBuf3,LIOTAB=',iBuf3,LIOTAB
            call Abend()
          end if
          call PKR8(0,iMax,NBYTES,Buffer(ip3+IST-1),Buffer(ip3+IST-1))
          LPKREC = (NBYTES+ItoB-1)/ItoB
          IDAHLF3(IBUF3) = IAD3
          IRLHLF3(IBUF3) = LPKREC
          call c_f_pointer(c_loc(Buffer(ip3+IST-1)),iBuffer,[LPKREC])
          call iDAFILE(LUHLF3,1,iBuffer,LPKREC,IAD3)
          nullify(iBuffer)
          IST = IST+IMAX
        end do
      end if
    end if
  end if ! nofile
  if (NOFILE) ipqut4 = NBPQ
  if (nars /= 0) call dDafile(LUTRI1,iOne,Buffer(ip4),nARS*NBPQ,iAD34)
  if (Buffer(ip3-1) /= -99999.0_wp) then
    write(u6,*) 'TraMO_MCLR: Buffer(ip3-1) /= -99999.0'
    write(u6,*) 'Buffer(ip3-1)=',Buffer(ip3-1)
    call Abend()
  end if
  if (Buffer(ip4-1) /= -99999.0_wp) then
    write(u6,*) 'TraMO_MCLR: Buffer(ip4-1) /= -99999.0'
    write(u6,*) 'Buffer(ip4-1)=',Buffer(ip4-1)
    call Abend()
  end if
  if (Buffer(ipB-1) /= -99999.0_wp) then
    write(u6,*) 'TraMO_MCLR: Buffer(ipB-1) /= -99999.0'
    write(u6,*) 'Buffer(ipB-1)=',Buffer(ipB-1)
    call Abend()
  end if

  if (nAP+nAQ /= 0) then
    !*******************************************************************
    !
    !     second transformation
    !     =====================
    !
    !    The integrals are transformed and written to disk
    !    this is done so that the integrals are written to
    !    disk in batches of nB*nB*nA integrals. This is the
    !    Least number of integrals that have to match in buffer
    !    because we want to write the integrals sorted onto disk
    !
    !*******************************************************************

    ipX = ip4
    ipY = ipX+nBR*NAS*nBP*nAQ+1   ! (Ij|kL)
    ipz = ipy+1
    if (isp /= isq) ipZ = ipY+nBR*NAS*nBQ*nAP+1
    if (ipz > memx) then
      write(u6,*) 'TraMO_MCLR: ipz > memx'
      write(u6,*) 'ipz,memx=',ipz,memx
      call Abend()
    end if
    Buffer(ipX-1) = -99999.0_wp
    Buffer(ipY-1) = -99999.0_wp
    Buffer(ipZ-1) = -99999.0_wp

    IAD2 = 0
    IAD3 = 0
    IVX = 0
    do NS=1,nAS
      nr2 = (NS-1)*NBR*NBP*NAQ
      nr3 = (NS-1)*nBR*NBQ*NAP
      if (.not. NoFile) then
        do NR=1,nBR
          IPQST = 1+NBPQ*IVX
          IVX = IVX+1
          IBUF = IVX

          !*************************************************************
          !
          !    Read one buffer of integrals back into core if INCORE=1
          !
          !*************************************************************

          if (INCORE == 1) then
            ipq = 0
            ip2 = 1
            ip5 = ip2+((nBPQ-1)/iMax+1)*iMax
            ipX = ip5+iMax+1
            ipY = ipX+nBP*nAQ*nBR*NAS+1
            ipZ = ipY+1
            if (isp /= isq) ipZ = ipX+nAQ*NBP*nBR*NAS+1
            Buffer(ipX-1) = -99999.0_wp
            Buffer(ipY-1) = -99999.0_wp
            Buffer(ipZ-1) = -99999.0_wp
            ipq = 1
            do
              IAD2 = IDAHLF2(IBUF)
              LPKREC = IRLHLF2(IBUF)
              call c_f_pointer(c_loc(Buffer(ip5)),iBuffer,[LPKREC])
              call iDAFILE(LUHLF2,2,iBuffer,LPKREC,IAD2)
              nullify(iBuffer)
              call UPKR8(0,iMax,NBYTES,Buffer(ip5),Buffer(ip2+IPQ-1))
              IPQ = IPQ+iMax
              iBuf = iBuf+nAS*nBR
              if (IPQ > NBPQ) exit
            end do
            IPQST = 1
          end if

          !*************************************************************
          !                                                            *
          ! Transform (ij|kL) -> (Ij|kL) & (iJ|kL)                     *
          !                                                            *
          !*************************************************************

          if (ISP == ISQ) then
            if (NAQ /= 0) then
              call SQUARE(Buffer(ip2+IPQST-1),X1,1,NBP,NBQ)
              call DGEMM_('T','N',NBP,NAQ,NBQ,One,X1,NBQ,CMQ,NBQ,Zero,X2,NBP)
            end if
          else
            if (NAQ /= 0) call DGEMM_('T','N',NBP,NAQ,NBQ,One,Buffer(ip2+IPQST-1),NBQ,CMQ,NBQ,Zero,X2,NBP)
            if (NAP /= 0) call DGEMM_('N','N',NBQ,NAP,NBP,One,Buffer(ip2+IPQST-1),NBQ,CMP,NBP,Zero,X3,NBQ)
          end if

          !*************************************************************
          !
          !      Move integrals to output buffer
          !
          !*************************************************************

          do i=0,nAQ-1
            Buffer(ipX+nr2+i*nBR*nBP:ipX+nr2+(i*nBR+1)*nBP-1) = X2(i*nBP+1:(i+1)*nBP)
          end do
          nr2 = nr2+nBP

          if (isp /= isq) then
            do i=0,nAP-1
              Buffer(ipY+nr3+i*nBR*nBQ:ipY+nr3+(i*nBR+1)*nBQ-1) = X3(i*nBQ+1:(i+1)*nBQ)
            end do
            nr3 = nr3+nBQ
          end if

        end do

        !***************************************************************
        !
        !       Empty last buffers
        !
        !***************************************************************

      end if ! nofile
    end do
    if (nAQ /= 0) then
      !call GADSum(Buffer(ipX),nAQ*NAS*NBR*NBP)
      call dDafile(LUTRI2,ione,Buffer(ipX),nAQ*NAS*NBR*NBP,iAD24)
    end if
    if (iSP /= iSQ .and. nAP /= 0) then
      !call GADSum(Buffer(ipY),NAP*NAS*NBR*NBQ)
      call dDafile(LUTRI3,ione,Buffer(ipY),NAP*NAS*NBR*NBQ,iAD14)
    end if

    !*******************************************************************

    if (buffer(ipX-1) /= -99999.0_wp) then
      write(u6,*) 'TraMO_MCLR: buffer(ipX-1) /= -99999.0'
      write(u6,*) 'buffer(ipX-1)=',buffer(ipX-1)
      call Abend()
    end if
    if (buffer(ipY-1) /= -99999.0_wp) then
      write(u6,*) 'TraMO_MCLR: buffer(ipY-1) /= -99999.0'
      write(u6,*) 'buffer(ipY-1)=',buffer(ipY-1)
      call Abend()
    end if
    if (buffer(ipZ-1) /= -99999.0_wp) then
      write(u6,*) 'TraMO_MCLR: buffer(ipZ-1) /= -99999.0'
      write(u6,*) 'buffer(ipZ-1)=',buffer(ipZ-1)
      call Abend()
    end if
    if (iSS /= iSR) then
      ipX = ip4
      Buffer(ipX-1) = -99999.0_wp
      ipY = ipX+nAR*NBS*nBP*nAQ+1   ! (Ij|kL)
      Buffer(ipY-1) = -99999.0_wp
      ipZ = ipy+1
      if (isp /= isq) ipZ = ipY+nAR*NBS*nBQ*nAP+1
      Buffer(ipZ-1) = -99999.0_wp
      IVX = 0
      do NR=1,nAR
        nr2 = NBP*NBS*(nR-1)*NAQ
        nr3 = NBQ*NBS*(nR-1)*NAP
        if (.not. NoFile) then
          do NS=1,nBS
            IPQST = 1+NBPQ*IVX
            IVX = IVX+1
            IBUF = IVX

            !***********************************************************
            !
            !   Read one buffer of integrals back into core if INCORE=1
            !
            !***********************************************************

            if (INCORE == 1) then
              ip2 = 1
              ip3 = ip2
              ip5 = ip3+((nBPQ-1)/iMax+1)*iMax
              ipX = ip5+iMax+1
              ipY = ipX+nBP*nAQ*nAR*NBS+1
              ipZ = ipY+nBQ*nAP*NAR*NBS+1
              Buffer(ipX-1) = -99999.0_wp
              Buffer(ipY-1) = -99999.0_wp
              Buffer(ipZ-1) = -99999.0_wp
              IPQ = 1
              do
                IAD3 = IDAHLF3(IBUF)
                LPKREC = IRLHLF3(IBUF)
                call c_f_pointer(c_loc(Buffer(ip5)),iBuffer,[LPKREC])
                call iDAFILE(LUHLF3,2,iBuffer,LPKREC,IAD3)
                nullify(iBuffer)
                call UPKR8(0,iMax,NBYTES,Buffer(ip5),Buffer(ip3+IPQ-1))
                IPQ = IPQ+iMax
                iBuf = iBuf+nAR*nBS
                if (IPQ > NBPQ) exit
              end do
              IPQST = 1
            end if

            !***********************************************************
            !                                                          *
            ! Transform (ij|kL) -> (Ij|kL) & (iJ|kL)                   *
            !                                                          *
            !***********************************************************

            if (ISP == ISQ) then
              if (nBQ*nAP /= 0) then

                call SQUARE(Buffer(ip3+IPQST-1),X1,1,NBQ,NBQ)
                call DGEMM_('T','N',NBP,NAQ,NBQ,One,X1,NBQ,CMQ,NBQ,Zero,X2,NBP)
                !call xxDGEMUL(X1,NBQ,'N',CMP,NBP,'N',X3,NBQ,NBQ,NBP,NAP)
                !call RecPrt('PqRs',' ',X3,nBQ,nAP)
              end if
            else
              if (nBP*nAQ /= 0) call DGEMM_('T','N',NBP,NAQ,NBQ,One,Buffer(ip3+IPQST-1),NBQ,CMQ,NBQ,Zero,X2,NBP)
              if (nBQ*nAP /= 0) call DGEMM_('N','N',NBQ,NAP,NBP,One,Buffer(ip3+IPQST-1),NBQ,CMP,NBP,Zero,X3,NBQ)
            end if

            !***********************************************************
            !
            !      Move integrals to output buffer
            !
            !***********************************************************

            do i=0,nAQ-1
              Buffer(ipX+nr2+i*nBS*nBP:ipX+nr2+(i*nBS+1)*nBP-1) = X2(i*nBP+1:(i+1)*nBP)
            end do
            nr2 = nr2+nBP
            if (iSP /= iSQ) then
              do i=0,nAP-1
                Buffer(ipY+nr3+i*NBS*nBQ:ipY+nr3+(i*NBS-1)*nBQ-1) = X3(i*nBQ+1:(i+1)*nBQ)
              end do
              nr3 = nr3+nBQ
            end if

          end do
          if (buffer(ipX-1) /= -99999.0_wp) then
            write(u6,*) 'TraMO_MCLR: buffer(ipX-1) /= -99999.0'
            write(u6,*) 'buffer(ipX-1)=',buffer(ipX-1)
            call Abend()
          end if
          if (buffer(ipY-1) /= -99999.0_wp) then
            write(u6,*) 'TraMO_MCLR: buffer(ipY-1) /= -99999.0'
            write(u6,*) 'buffer(ipY-1)=',buffer(ipY-1)
            call Abend()
          end if
          if (buffer(ipZ-1) /= -99999.0_wp) then
            write(u6,*) 'TraMO_MCLR: buffer(ipZ-1) /= -99999.0'
            write(u6,*) 'buffer(ipZ-1)=',buffer(ipZ-1)
            call Abend()
          end if

          !*************************************************************
          !
          !      Write buffer to disk (iJ|Kl) & (Ij|Kl)
          !
          !*************************************************************

        end if ! nofile
      end do
      if (nAQ /= 0) then
        !call GADSum(Buffer(ipX),nAR*nAQ*nBS*nBP)
        call dDaFile(LuTri4,ione,Buffer(ipX),nAR*nAQ*nBS*nBP,iad23)
      end if
      if (iSP /= iSQ .and. nap /= 0) then
        !call GADSum(Buffer(ipY),nAR*nAP*nBS*nBQ)
        call dDaFile(LuTri5,ione,Buffer(ipY),nAR*nAP*nBS*nBQ,iad13)
      end if
    end if
  end if

  if (INCORE == 1) then
    call DACLOS(LUHLF2)
    call DACLOS(LUHLF3)
  end if

  return

end subroutine TRAMO_MCLR_INTERNAL

end subroutine TRAMO_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Jeppe Olsen                                      *
************************************************************************
*
* Testing new routines with active/passive divisions
*                          Jeppe, sept. 20 97
*
* Splitting the strings into active and passive parts allow us to
* write the a b loop  as
*
* Sigma(I_pa_a,I_pa_b,I_ac_a,I_ac_b) =
* sum(ijkl) <I_ac_a!Ea(ij)!J_ac_b><I_ac_b!Eb(kl)!I_ac_b>(ij!kl)
*           C(J_pa_a,J_pa_b,I_ac_a,I_pa_b)
*. One possibility is to use the above directly, and vectorize
*  over the passive strings.
*
* Another possibility is to use N-1 resolution in the alpha space
* as
*   1) Construct C(Ka_a,I_pa_a,I_pa_b,j,J_ac_b)
*   2) Obtain    S(Ka_a,I_pa_a,I_pa_b,I,I_ac_b) =
*      Sum(kl)   <I_ac_b!Eb(kl)!J_ac_b> Sum(ij)(ij!kl)
*      C(Ka_a,I_Pa_a,I_Pa_b,j,J_ac_b)
*
* The latter is the straightforward extension of LUCILLE's normal route.
*
* About reorganization of strings
*
* I will construct an array IREO(IA,IP)=I, that for given active
* and passive parts gives original number.
* Invoking symmetry :
* We are reordering strings of given supergroup and symmetry.
* The readressing goes thus as
* Loop over symmetry of active part => symmetry of passive part
*   Obtain offset for reordered strings
*          Number of active and passive strings of appropriate sym
*          Reorder array.
*
      SUBROUTINE MAT_P_MATT(A,B,NR,NC,COEF)
*
* A(I,J) = A(I,J) + Coef*B(J,I)
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input and output
      DIMENSION A(NR,NC)
*. Input
      DIMENSION B(NC,NR)
*
      DO J = 1, NC
      DO I = 1, NR
        A(I,J) = A(I,J) + COEF*B(J,I)
      END DO
      END DO
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Giovanni Li Manni                                      *
************************************************************************
      SUBROUTINE print_MCPDFT_2(CASDFT_E,E_nuc,E_cor,E_cas,E_ot,
     & jroot,Ref_Ener)
******************************************************************
* Purpose:
* This routine is called from RASSCF when performing MC-PDFT jobs,
* for printing out some densities information and some functionals
* as computed in DRVNQ and children routines.
*
* Author:
* G. Li Manni (GLM)
* S Dong, 2018 (added print outs related to scaling)
******************************************************************
       use KSDFT_Info, only: Funcaa, Funcbb, Funccc
      Implicit Real*8 (A-H,O-Z)
      Real*8 CASDFT_E,E_nuc,E_cor,E_cas,E_ot
      Real*8 CASDFT_E_1,E_ot_1,Funcaa1,Funcbb1,Funccc1
      Dimension Ref_Ener(*)
      integer jroot
#include "WrkSpc.fh"
#include "ksdft.fh"
#include "nq_info.fh"
#include "mspdft.fh"

      write(6,'(6X,80A)')
      write(6,'(6X,80A)') ('*',i=1,80)
      write(6,'(6X,80A)') ('*',i=1,80)
      IF(Do_Rotate) Then
      write(6,'(6X,2A,1X,I2.2,1X,A)')'**                       '//
     &    MSpdftMethod,' INTERMEDIATE STATE', jroot,
     & '                      ** '
      ELSE
      write(6,'(6X,A,1X,I2.2,1X,A)')'**                         '//
     &    ' MC-PDFT RESULTS, STATE', jroot,
     & '                        ** '
      ENDIF
      write(6,'(6X,80A)') ('*',i=1,80)
      write(6,'(6X,A,40X,F18.8)') 'MCSCF reference energy',
     &                           Ref_Ener(jroot)
      write(6,'(6X,80A)')
      write(6,'(6X,A,45X,F10.3)') 'Integrated total density:',Dens_I
      write(6,'(6X,A,12X,F10.3)') 'Integrated alpha density '//
     &           'before functional transformation:', Dens_a1
      write(6,'(6X,A,12X,F10.3)') 'Integrated  beta density '//
     &           'before functional transformation:', Dens_b1
      write(6,'(6X,A,12X,F10.3)') 'Integrated alpha density '//
     &           ' after functional transformation:', Dens_a2
      write(6,'(6X,A,12X,F10.3)') 'Integrated  beta density '//
     &           ' after functional transformation:', Dens_b2
      write(6,'(6X,80A)')
      write(6,'(6X,A,32X,F18.6)') 'Exchange energy scaling factor',
     &          CoefX
      write(6,'(6X,A,29X,F18.6)') 'Correlation energy scaling factor',
     &          CoefR
      write(6,'(6X,80A)')
      write(6,'(6X,A,30X,F18.6)') 'Integrated alpha exchange energy',
     &          Funcaa
      write(6,'(6X,A,30X,F18.6)') 'Integrated beta  exchange energy',
     &          Funcbb
      write(6,'(6X,A,30X,F18.6)') 'Integrated  correlation   energy',
     &          Funccc
      write(6,'(6X,80A)')

      write(6,'(6X,A,38X,F18.8)') 'Nuclear Repulsion energy',E_nuc
      write(6,'(6X,A,51X,F18.8)') 'Core energy',E_cor
      write(6,'(6X,A,36X,F18.8)') 'CASSCF contribution energy',E_cas
      write(6,'(6X,A,49X,F18.8)') 'On-top energy',E_ot

      write(6,'(6X,80A)')

      IF(Do_Rotate) Then
      write(6,'(6X,A,2X,I3,14X,F18.8)')
     &'Total MC-PDFT energy for intermediate state', jroot,CASDFT_E
      ELSE
      write(6,'(6X,A,2X,I3,27X,F18.8)')
     &'Total MC-PDFT energy for state',jroot,CASDFT_E
      END IF
      if ((CoefX*CoefR.ne.0.0).and.(CoefX.ne.1.0.or.CoefR.ne.1.0)) Then
         Funcaa1 = Funcaa/CoefX
         Funcbb1 = Funcbb/CoefX
         Funccc1 = Funccc/CoefR
         E_ot_1 = E_ot-Funcaa-Funcbb-Funccc+Funcaa1+Funcbb1+Funccc1
         CASDFT_E_1 = CASDFT_E-E_ot+E_ot_1
         write(6,'(6X,80A)')
         write(6,'(6X,80A)')
         write(6,'(6X,A,19X,F18.6)') 'Integrated alpha exchange '//
     &          'energy (unscaled)',
     &          Funcaa1
         write(6,'(6X,A,19X,F18.6)') 'Integrated beta  exchange '//
     &          'energy (unscaled)',
     &          Funcbb1
         write(6,'(6X,A,19X,F18.6)') 'Integrated  correlation   '//
     &          'energy (unscaled)',
     &          Funccc1
!         write(6,'(6X,80A)')
         write(6,'(6X,A,38X,F18.8)') 'On-top energy (unscaled)',E_ot_1
!         write(6,'(6X,80A)')
         write(6,'(6X,A,31X,F18.8)') 'Total MC-PDFT energy '//
     &         '(unscaled)',
     &         CASDFT_E_1
      end if

      write(6,'(6X,80A)')
      write(6,'(6X,80A)') ('*',i=1,80)
      write(6,'(6X,80A)')

      Call Add_Info('dens_tt',[Dens_I],1,6)
      Call Add_Info('dens_a1',[Dens_a1],1,6)
      Call Add_Info('dens_b1',[Dens_b1],1,6)
      Call Add_Info('dens_a2',[Dens_a2],1,6)
      Call Add_Info('dens_b2',[Dens_b2],1,6)
      Call Add_Info('exch_f',[CoefX],1,6)
      Call Add_Info('corr_f',[CoefR],1,6)
      Call Add_Info('excha_a',[Funcaa],1,6)
      Call Add_Info('excha_b',[Funcbb],1,6)
      Call Add_Info('corr_e', [Funccc],1,6)
      Call Add_Info('CASDFTE',[CASDFT_E],1,8)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Stblzr(iU,nU,iV,nV,iR,iM,nM)
!***********************************************************************
!                                                                      *
!  Object: to form the proper stabilizer for a pair of entities        *
!          given the respective stabilizers and the operator acting    *
!          on the second entity.                                       *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             June '90                                                 *
!***********************************************************************

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nU, iU(nU), nV, iV(nV), iR
integer(kind=iwp), intent(out) :: iM(8), nM
integer(kind=iwp) :: i, iRU
logical(kind=iwp) :: UeqV
logical(kind=iwp), external :: RinT

! See if U and V are the same

UeqV = .true.
do i=1,nV
  if (.not. RinT(iU,nU,iV(i))) then
    UeqV = .false.
    exit
  end if
end do
if (UeqV) then
  do i=1,nU
    if (.not. RinT(iV,nV,iU(i))) then
      UeqV = .false.
      exit
    end if
  end do
end if

if (UeqV) then

  ! M is formed as U union RU

  iM(1:nU) = iU(:)
  nM = nU
  do i=1,nU
    iRU = ieor(iR,iU(i))
    if (.not. RinT(iM,nM,iRU)) then
      nM = nM+1
      iM(nM) = iRU
    end if
  end do
else

  ! M is formed as U intersection V

  call Inter(iU,nU,iV,nV,iM,nM)
end if

return

end subroutine Stblzr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine RHS_READ(NIN,NIS,lg_W,iCASE,iSYM,iVEC)
!SVC: this routine reads an RHS array in SR format from disk

use fake_GA, only: GA_Arrays
use caspt2_global, only: LURHS
use caspt2_module, only: IOFFRHS
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
use Definitions, only: u6
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NIN, NIS, lg_W, iCASE, iSYM, iVEC
integer(kind=iwp) :: IDISK, NWPROC
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: IEND, ISTA, JEND, JSTA, LDW, mpt_W, myRank

if (Is_Real_Par()) then
  call GA_Sync()
  myRank = GA_NodeID()
  call GA_Distribution(lg_W,myRank,ISTA,IEND,JSTA,JEND)
  if ((IEND-ISTA+1 == NIN) .and. (ISTA > 0)) then
    call GA_Access(lg_W,ISTA,IEND,JSTA,JEND,mpt_W,LDW)
    if (LDW /= NIN) then
      write(u6,*) 'RHS_READ: Assumption NIN==LDW wrong'
      call AbEnd()
    end if
    NWPROC = NIN*(JEND-JSTA+1)
    IDISK = IOFFRHS(ISYM,ICASE)
    call DDAFILE(LURHS(IVEC),2,DBL_MB(mpt_W),NWPROC,IDISK)
    call GA_Release_Update(lg_W,ISTA,IEND,JSTA,JEND)
  end if
  call GA_Sync()
else
#endif
  NWPROC = NIN*NIS
  IDISK = IOFFRHS(ISYM,ICASE)
  call DDAFILE(LURHS(IVEC),2,GA_Arrays(lg_W)%A,NWPROC,IDISK)
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine RHS_READ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Read all MO-transformed integrals and construct zeroth Fock-matrix.
subroutine ScfH0(nBas)

use qmstat_global, only: AddExt, ExtLabel, HHmat, iCompExt, iOrb, iPrint, MxSymQ, nExtAddOns, ScalExt, SupM, V1
use Index_Functions, only: iTri, nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Quart
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBas(MxSymQ)
#include "Molcas.fh"
#include "tratoc.fh"
integer(kind=iwp) :: i, iDisk, iExt, ij, ik, il, iLu1, iLu2, iopt, irc, iSmLbl, iSup, iToc(64), j, jk, jl, k, kaunter, kl, l, &
                     llmax, Lu_One, nBasM(MxSymQ), nBTri, nBuf1, nBuf2, nDelM(MxSymQ), nFroM(MxSymQ), nMAX, nOrbM(MxSymQ), nSize, &
                     nSymM
real(kind=wp) :: Ecor
character(len=LenIn8) :: NameM(maxbfn)
character(len=10) :: firstind
real(kind=wp), allocatable :: AOx(:), Buff(:), Fine(:,:), MOx(:), SqAO(:,:), TEMP(:,:)
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

! Wilkommen.

write(u6,*)
write(u6,*)
write(u6,*) 'Reading MO-transformed integrals. Zeroth hamiltonian constructed.'

! Numbers and files.

nSize = nTri_Elem(iOrb(1))
call mma_allocate(SupM,nSize,nSize,label='SUPER')
iLu1 = 56
iLu2 = 58
call DaName(iLu1,'TRAONE')
call DaName(iLu2,'TRAINT')
iDisk = 0
! This is special utility to read header of TRAONE.
call Wr_Motra_Info(iLu1,2,iDisk,iToc,64,Ecor,nSymM,nBasM,nOrbM,nFroM,nDelM,MxSymQ,NameM,LenIn8*maxbfn)

! One checks.

if (nBasM(1) /= nBas(1)) then
  write(u6,*)
  write(u6,*) '  ERROR! Conflict between one-electron file and MO-transformed one-electron file.'
  write(u6,*) '         nBas=',nBas(1),' MO-nBas=',nBasM(1)
  call Quit(_RC_GENERAL_ERROR_)
end if

! Read one-electron matrix elements.

iDisk = iToc(2)
call mma_allocate(HHmat,nSize,label='HHmat')
call dDaFile(iLu1,2,HHmat,nSize,iDisk)
call DaClos(iLu1)

! Add external perturbation if requested.

if (AddExt) then
  write(u6,*) '    -- Adding external perturbation.'
  nBTri = nTri_Elem(nBas(1))
  Lu_One = IsFreeUnit(49)
  call OpnOne(irc,0,'ONEINT',Lu_One)
  call mma_allocate(AOx,nBTri,label='AOExt')
  call mma_allocate(TEMP,iOrb(1),nBas(1),label='TEMP')
  call mma_allocate(Fine,iOrb(1),iOrb(1),label='Final')
  call mma_allocate(SqAO,nBas(1),nBas(1),label='Squared')
  call mma_allocate(MOx,nSize,label='MOExt')
  do iExt=1,nExtAddOns
    irc = -1
    iopt = 6
    iSmLbl = 0
    call RdOne(irc,iopt,ExtLabel(iExt),iCompExt(iExt),AOx,iSmLbl)
    AOx(:) = AOx*ScalExt(iExt)
    if (irc /= 0) then
      write(u6,*)
      write(u6,*) 'ERROR when reading ',ExtLabel(iExt),'.'
      write(u6,*) 'Have Seward computed this integral?'
      call Quit(_RC_IO_ERROR_READ_)
    end if
    call Square(AOx,SqAO,1,nBas(1),nBas(1))
    call Dgemm_('T','N',iOrb(1),nBas(1),nBas(1),One,V1,nBas(1),SqAO,nBas(1),Zero,TEMP,iOrb(1))
    call Dgemm_('N','N',iOrb(1),iOrb(1),nBas(1),One,TEMP,iOrb(1),V1,nBas(1),Zero,Fine,iOrb(1))
    call SqToTri_Q(Fine,MOx,iOrb(1))
    HHmat(:) = HHmat+MOx
  end do
  call mma_deallocate(AOx)
  call mma_deallocate(TEMP)
  call mma_deallocate(Fine)
  call mma_deallocate(SqAO)
  call mma_deallocate(MOx)
  call ClsOne(irc,Lu_One)
end if

! Now to the two-electron matrix elements.

iDisk = 0
call iDaFile(iLu2,2,iTraToc,nTraToc,iDisk)
iDisk = iTraToc(1)
iSup = 0
! Ooohhhh, lets get crude! Read ALL (yes, you read right) integrals and then order them.
nBuf1 = nTri_Elem(nOrbM(1))
nBuf2 = nTri_Elem(nBuf1)

! Let's check if this construct is possible. If not advise user what to do.

call mma_maxDBLE(nMAX)
if (nMAX < (nBuf2+nBuf1**2)) then
  write(u6,*)
  write(u6,*) '  Too many MO-transformed two-electron integrals from Motra. Do you need all?'
  write(u6,*) '  If not, then use the DELEte keyword in Motra to remove the superfluous ones.'
  call Quit(_RC_GENERAL_ERROR_)
end if

! Proceed!

call mma_allocate(Buff,nBuf2,label='Buffer')
call mma_allocate(TEMP,nBuf1,nBuf1,label='Temporary')
call dDaFile(iLu2,2,Buff,nBuf2,iDisk)
do i=1,nBuf1
  do j=i,nBuf1
    iSup = iSup+1
    if ((i <= nSize) .and. (j <= nSize)) then
      TEMP(j,i) = Buff(iSup)
      TEMP(i,j) = Buff(iSup)
    end if
  end do
end do

! and see to that right numbers get in the right place.

do i=1,iOrb(1)
  do j=1,i
    do k=1,i
      llmax = k
      if (i == k) llmax = j
      do l=1,llmax
        ij = iTri(i,j)
        ik = iTri(i,k)
        il = iTri(i,l)
        jk = iTri(j,k)
        jl = iTri(j,l)
        kl = iTri(k,l)
        SupM(kl,ij) = TEMP(kl,ij)-(TEMP(jl,ik)+TEMP(jk,il))*Quart
        SupM(ij,kl) = SupM(kl,ij)
        SupM(jl,ik) = TEMP(jl,ik)-(TEMP(kl,ij)+TEMP(jk,il))*Quart
        SupM(ik,jl) = SupM(jl,ik)
        SupM(jk,il) = TEMP(jk,il)-(TEMP(jl,ik)+TEMP(kl,ij))*Quart
        SupM(il,jk) = SupM(jk,il)
      end do
    end do
  end do
end do
call mma_deallocate(Buff)
call mma_deallocate(TEMP)
call DaClos(iLu2)

! Serious amount of printing!

if (iPrint >= 35) then
  write(u6,*)
  write(u6,*) 'The Super Matrix in all its divine g(l)ory:'
  kaunter = 0
  do i=1,iOrb(1)
    do j=1,i
      write(firstind,'(I3,A,I3)') i,',',j
      kaunter = kaunter+1
      call TriPrt(firstind,' ',SupM(:,kaunter),iOrb(1))
    end do
  end do
  write(u6,*) 'Super Matrix End.'
end if
write(u6,*) '...Done!'

! The end.

return

end subroutine ScfH0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine gugaci(ireturn)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "files_gugaci.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      data istep_occ/0,1,1,2/
      data mul_tab/1,2,3,4,5,6,7,8,
     *             2,1,4,3,6,5,8,7,
     *             3,4,1,2,7,8,5,6,
     *             4,3,2,1,8,7,6,5,
     *             5,6,7,8,1,2,3,4,
     *             6,5,8,7,2,1,4,3,
     *             7,8,5,6,3,4,1,2,
     *             8,7,6,5,4,3,2,1/
!                           v   d  t  s dd tt
      data map_jplr/       25,23,17,10,24,18, !v
     :                     26,19,13, 6,22, 0, !d
     :                      0,14,11, 2, 0, 0, !t
     :                      0, 7, 3, 1, 9, 5, !s
     :                      0,21, 0, 8,20,15, !dd
     :                      0, 0, 0, 4,16,12/ !tt

      ireturn=100
      call version_info
      ! open scratch files and read from strach file
      call gugaciinit

      ! user input file
      logic_grad=.false.
      call mole_inf()

      call paras_calculate()
      call arrange_orbital()

      call allocate_casrst()
      call dbl_upwalk()         ! add by wyb 01.9.5
      call ext_downwalk()       ! add by wyb 01.9.5
      call active_drt()         ! add by wyb 01.9.5
      call value_of_pl_in_dbl()

      nc0=norb_all*(norb_all+1)/2
      nc1=nc0*(nc0+1)/2
      if(nc1.gt.2*max_vector) then
        write(6,*) "No enough space to store MO integrals! number of ",
     *             " orbital should be less than ",max_orb
#ifdef MOLPRO
#else
        call abend
#endif
#ifdef _XIANEST_
#endif
      endif

      call mem_intinnindex_alloc()
      lenvec=nc1
      allocate(vector1(nc1))
      vector1(1:nc1)=0.d0
      call int_sort()
      deallocate(vector1)

      mxvec=60000000*10
      if(mroot*nci_dim.le.mxvec) then
        nc1=mroot*nci_dim
        allocate(vector1(nc1))
!        allocate(vector2(nc1))
        lenvec=nc1
      else
        nc1=nci_dim
        allocate(vector1(nc1))
!        allocate(vector2(nc1))
        lenvec=nc1
      endif
      vector1(1:nc1)=0.d0

!      write(6,*)   '===================================================

      sc1=c_time()

      call allocate_subdrt(1,1)
      call allocate_subdrtl(1,1)

      call memcidiag_alloc()
      call diagonal_loop_wyb()
      call memcidiag_dealloc()
      sc2=c_time()
      !write(6,*) vector1(585)
      !stop 888

      write(6,*)
      write(6,*)   '==================================================='
      write(6,'(a30,i10,f14.2,a1)')
     :     '   end of h_diagonal, nci_dim=',nci_dim,sc2-sc1,'s'
      write(6,*)   '==================================================='
      write(6,*)


      call write_ml(lucidia,1,vector1,nci_dim,1)
      !do i=1,74902
      !  write(21,"(i8,f18.8)") i,vector1(i)
      !enddo
      !stop 888

      call allocate_vplp_memory()
      call allocate_int_memory()

      nc=nci_h0 !iw_sta(2,1)
      nc1=nc*(nc+1)/2

      allocate(vcm(mroot*nci_h0))
      if(nc1.le.lenvec) then
        allocate(vector2(lenvec))
      else
        deallocate(vector1)
        allocate(vector1(nc*(nc+1)/2))
        allocate(vector2(nc*(nc+1)/2))
        vector1=0.d0
        call read_ml(Lucidia,2,vector1,nci_dim,1)
      endif

      vector2(1:nc1)=0.d0

      call geth0()
      call xflush(6)

      if(nc1.gt.lenvec) then
        deallocate(vector1)
        deallocate(vector2)
        allocate(vector1(lenvec))
        allocate(vector2(lenvec))
      endif

      sc0=c_time()
      call guga_ploop(npl,maxplcon)

      call deallocate_subdrt()
      call deallocate_subdrtl()


      sc1=c_time()
      call xflush(6)

      write(6,'(a25,i10,f14.2,a1)')
     :          '  end of pl_serach, n_pl=',npl,sc1-sc0,'s'
      write(6,*)'=============================================='

      if(maxplcon.lt.max_node) maxplcon=max_node
      call allocate_subdrt(2,maxplcon)
      call allocate_subdrtl(2,maxplcon)

      call cidiagonalize(mxvec)

      sc2=c_time()

      call xflush(6)

      write(6,910)  sc2-sc0
      write(6,*)
      call deallocate_int_memory()
      !deallocate(vcm)
      deallocate(vector1)
      deallocate(vector2)

      if(logic_calpro) then
        logic_grad=.true.
        call memdengrad_alloc()

        nc0=norb_all*(norb_all+1)/2
        nc1=nc0*(nc0+1)/2
        allocate(vector1(nci_dim))
        allocate(vector2(nc1))
        vector1=0.d0
        vector2=0.d0

        call cidenmat()

! calculate properties
#ifdef MOLPRO
#else
        call cipro()
#endif
        deallocate(vector1)
        deallocate(vector2)
        call memdengrad_free()
      endif

      call deallocate_vplp_memory()
      call deallocate_subdrt()
      call deallocate_subdrtl()
      call deallocate_casrst()
      call mem_intinnindex_dealloc()
      call gugafinalize

      ireturn=0
910   format(/,1x,"end of ci energy calculation,
     *       takes ",f10.2,1x,"seconds"/)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Per-Olof Widmark                                 *
!               1993,1996,1997, Markus P. Fuelscher                    *
!               1996, Luis Serrano-Andres                              *
!***********************************************************************

subroutine DaName_MF(Lu,String)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Open unit Lu for direct access I/O and link the data stream to   *
!     the logical file name Name.                                      *
!                                                                      *
!     calling arguments:                                               *
!     Lu      : integer, input                                         *
!               logical unit number                                    *
!     Name    : character string, input                                *
!               logical file name                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, IBM Sweden, 1991                                   *
!     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
!     L. Serrano-Andres, University of Lund, Sweden, 1996              *
!                                                                      *
!***********************************************************************

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: Lu
character(len=*), intent(in) :: String
logical(kind=iwp) :: mf, wa

mf = .true.
wa = .false.
call Daname_Main(Lu,String,mf,wa)

return

end subroutine DaName_MF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,2000, Markus P. Fuelscher                         *
*               1993, Per-Olof Widmark                                 *
************************************************************************
      Subroutine R8PREP(nData,Buf)
************************************************************************
*                                                                      *
*     purpose: prepare the incoming data to be packed, i.e.,           *
*              round and scale the data. The modified data will        *
*              replace the incoming data.                              *
*                                                                      *
*    Calling parameters:                                               *
*    nData : number of data elements                                   *
*    Buf   : buffer containing the data                                *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    PkCtl : Packing table                                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and P. O. Widmark                                 *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     replacement of packing routines                                  *
*     this subroutine is obsolete !                                    *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 2000                                 *
*                                                                      *
************************************************************************
#include "PkCtl.fh"
*
      Real*8 Buf(*)
*
*----------------------------------------------------------------------*
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nData)
         Call Unused_real_array(Buf)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_AnaDia(Diag,Sync,Bin1,Step,NumBin,Full)
C
C     Purpose: analyze global diagonal (histogram). Diag is the local
C              diagonal. If Sync=.True. the global diagonal is
C              synchronized before analysis.
C
      Implicit None
      Real*8  Diag(*)
      Logical Sync
      Real*8  Bin1, Step
      Integer NumBin
      Logical Full
#include "choglob.fh"
#include "cho_para_info.fh"
#include "WrkSpc.fh"

      Integer iLoc

      If (Cho_Real_Par) Then

C        If requested, sync diagonal.
C        ----------------------------

         If (Sync) Then
            iLoc = 2
            Call Cho_P_SyncDiag(Diag,iLoc)
         End If

C        Swap local and global index arrays and use original serial
C        serial to perform analysis of the global diagonal.
C        ----------------------------------------------------------

         Call Cho_P_IndxSwp()
         Call Cho_AnaDia(Work(ip_Diag_G),Bin1,Step,NumBin,Full)
         Call Cho_P_IndxSwp()

      Else

         Call Cho_AnaDia(Diag,Bin1,Step,NumBin,Full)

      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1987, Jeppe Olsen                                      *
!               1989, Markus P. Fuelscher                              *
!***********************************************************************

subroutine DETSTR2(IDET,IASTR,IBSTR,NEL,NAEL,NBEL,ISGN,IWORK,IPRINT)
! AUTHOR:        J. OLSEN, UNIV. OF LUND, SWEDEN, APRIL 1987
! MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
!                M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
!
! PURPOSE:
!
! A DETERMINANT, IDET, IS GIVEN AS A SET OF OCCUPIED SPIN ORBITALS,
! POSITIVE NUMBER INDICATES ALPHA ORBITAL AND NEGATIVE NUMBER
! INDICATES BETA ORBITAL.
! FIND CORRESPONDING ALPHA STRING AND BETA STRING

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NEL, NAEL, NBEL, IDET(NEL), IPRINT
integer(kind=iwp), intent(out) :: IASTR(NAEL), IBSTR(NBEL), ISGN, IWORK(NEL)
integer(kind=iwp) :: IBEL, IEXPO

! FIRST REORDER SPIN ORBITALS IN ASCENDING SEQUENCE
! THIS WILL AUTOMATICALLY SPLIT ALPHA AND BETASTRING

call ORDSTR(IDET,IWORK,NEL,ISGN,IPRINT)

! ALPHA STRING IS LAST NAEL ORBITALS
call ICOPY(NAEL,IWORK(NBEL+1),1,IASTR,1)

! BETA STRING MUST BE COMPLETELY TURNED AROUND
do IBEL=1,NBEL
  IBSTR(IBEL) = -IWORK(NBEL+1-IBEL)
end do
! SIGN CHANGE FOR SWITCH OF BETA ORBITALS
IEXPO = (NBEL*NBEL+NBEL)/2
ISGN = ISGN*(-1)**IEXPO

if (IPRINT > 30) then
  write(u6,*) ' INPUT DETERMINANT'
  call IWRTMA(IDET,1,NEL,1,NEL)
  write(u6,*) ' CORRESPONDING ALPHA STRING'
  call IWRTMA(IASTR,1,NAEL,1,NAEL)
  write(u6,*) ' CORRESPONDING BETA STRING'
  call IWRTMA(IBSTR,1,NBEL,1,NBEL)
  write(u6,*) ' ISGN FOR SWITCH ',ISGN
end if

return

end subroutine DETSTR2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 12, 2022, created this file.               *
! ****************************************************************

subroutine CMSScaleX(X,R,DeltaR,Qnew,Qold,RCopy,GDCopy,DgCopy,GDstate,GDOrbit,Dgstate,DgOrbit,DDg,nSPair,lRoots2,nGD,NAC2,nDDg, &
                     Saved)

use CMS, only: NCMSScale
use rasscf_global, only: CMSThreshold, lRoots
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSPair, lRoots2, nGD, NAC2, nDDg
real(kind=wp), intent(inout) :: X(nSPair), Qnew, GDstate(nGD), Dgstate(nGD)
real(kind=wp), intent(out) :: R(lRoots2), DeltaR(lRoots2), GDOrbit(nGD), DgOrbit(nGD), DDg(nDDg)
real(kind=wp), intent(in) :: QOld, RCopy(lRoots2), GDCopy(nGD), DgCopy(nGD)
logical(kind=iwp), intent(out) :: Saved
integer(kind=iwp) :: nScaleMax

Saved = .true.

NScaleMax = 5
do while ((Qold-Qnew) > CMSThreshold)
  NCMSScale = NCMSScale+1
  if (NCMSScale == nScaleMax) then
    write(u6,'(6X,A)') 'Scaling does not save Qaa from decreasing.'
    write(u6,'(6X,A)') 'Q_a-a decreases for this step.'
    Saved = .false.
    exit
  end if
  R(:) = RCopy(:)
  GDState(:) = GDCopy(:)
  DgState(:) = DgCopy(:)
  X(:) = 0.1_wp*X(:)

  call UpDateRotMat(R,DeltaR,X,lRoots,nSPair)
  call RotGD(GDstate,DeltaR,nGD,lRoots,NAC2)
  call RotGD(Dgstate,DeltaR,nGD,lRoots,NAC2)
  call Trnsps(lRoots2,NAC2,Dgstate,Dgorbit)
  call Trnsps(lRoots2,NAC2,GDstate,GDorbit)
  call DGEMM_('T','N',lRoots2,lRoots2,NAC2,One,Dgorbit,NAC2,GDorbit,NAC2,Zero,DDg,lRoots2)
  call CalcQaa(Qnew,DDg,lRoots,nDDg)

end do

return

end subroutine CMSScaleX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine set_defaults( nneq, nTempMagn, nDir, nDirZee, nMult,
     &                         neq, nexch, nK, mG, ncut, nP,
     &                         AngPoints, nBlock, encut_definition,
     &                         iopt, iPrint,
     &                         dltT0, dltH0, zJ, tmin, tmax, hmin, hmax,
     &                         XField, thrs, TempMagn,
     &                         cryst, coord, encut_rate, gtens_input,
     &                         D_fact, EoverD_fact, riso,
     &                         decompose_exchange,
     &                         AnisoLines1, AnisoLines3, AnisoLines9,
     &                         DM_exchange,
     &                         Dipol, KE, JITO_exchange, fitCHI, fitM,
     &                         Do_structure_abc, doplot,
     &                         compute_g_tensors, tinput,
     &                         compute_susceptibility,
     &                         compute_torque, compute_barrier,
     &                         compute_magnetization, hinput,
     &                         compute_Mdir_vector, zeeman_energy,
     &                         m_paranoid, m_accurate, smagn,
     &                         itype)
c==================================================================
      Implicit None
#include "mgrid.fh"
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
c definintion of the cluster
      Integer, intent(in)  :: nneq
      Integer, intent(out) :: neq(nneq)
      Real(kind=8), intent(out) :: gtens_input(3,nneq)
      Real(kind=8), intent(out) :: D_fact(nneq)
      Real(kind=8), intent(out) :: EoverD_fact(nneq)
      Real(kind=8), intent(out) :: riso(nneq,3,3)
      Character(Len=1), intent(out) :: itype(nneq)
c definintion of exchange interaction
      Integer, intent(out) :: nexch(nneq)
c  definition of g and D tensors
      Integer, intent(in)  :: nMult
c      Integer, intent(out) :: nDim(nMult)
      Logical, intent(out) :: compute_g_tensors
c  Zeeman energy and M vector
      Integer, intent(in) :: nDir, nDirZee
c  definition of the exchange:
      Logical, intent(out) :: AnisoLines1
      Logical, intent(out) :: AnisoLines3
      Logical, intent(out) :: AnisoLines9
c     ! options used in connection with Dipol-Dipol interaction
      Logical, intent(out) :: Dipol
c     ! options used in connection with KE
      Logical, intent(out) :: KE
      ! option for Dzialoshinsky-Morya antisymmetric exchange
      Logical, intent(out) :: DM_exchange
      ! option for ITO exchange
      Logical, intent(out) :: JITO_exchange


cc  options for automatic fitting of parameters:
      Logical, intent(out) :: fitCHI !-- not used so far
      Logical, intent(out) :: fitM !-- not used so far
cc  definition of data for susceptibility
      Logical, intent(out) :: tinput, compute_susceptibility
      Real(kind=8), intent(out) :: tmin, tmax, dltT0
      ! options related to XT_MoverH
      Real(kind=8), intent(out) :: Xfield
cc  definition of data for magnetization:
      Integer, intent(in)        :: nTempMagn
      Real(kind=8),intent(out)  :: TempMagn(nTempMagn)
      Integer, intent(out)       :: iopt
      Real(kind=8), intent(out) :: dltH0, thrs
      Real(kind=8), intent(out) :: hmin, hmax
      Logical, intent(out)       :: hinput
      Logical, intent(out)       :: compute_magnetization
      Logical, intent(out)       :: compute_Mdir_vector
      Logical, intent(out)       :: zeeman_energy
      Logical, intent(out)       :: m_paranoid
      Logical, intent(out)       :: m_accurate
      Logical, intent(out)       :: smagn
c      ! options used to set up nM and EM
      Integer, intent(out)       :: encut_definition
      Integer, intent(out)       :: nK, mG ! encut_definition=1;
      Integer, intent(out)       :: ncut   ! encut_definition=2;
      Real(kind=8), intent(out) :: encut_rate ! encut_definition=3;
cc decompose exchange
      Logical, intent(out)       :: decompose_exchange
c  magnetization torque
      Logical, intent(out)       :: compute_torque
      Integer, intent(out)       :: nP
      Integer, intent(out)       :: AngPoints
c mean field parameter
      Real(kind=8), intent(out) :: zJ
c  definintion of the crystal axes:
      Logical, intent(out)       :: Do_structure_abc
!     a, b, c, alpha, beta, gamma
      Real(kind=8), intent(out) :: cryst(6)
!     Cartesian coordinates of the main metal site, or center
      Real(kind=8), intent(out) :: coord(3)
cc  definitions for blocking barrier
      Integer, intent(out)       :: nBlock
      Logical, intent(out)       :: compute_barrier
c  default print level
      Integer, intent(out)       :: iPrint
      Logical, intent(out)       :: DoPlot
c------------------------------------------------------------------
! Local variables:
      Integer       :: i,j,l

c------------------------------------------------------------------
!  at this point, the follwing variables have been already assigned
!  their values
!      Integer  :: nneq, exch, nLoc, nCenter, nT, nH, nTempMagn, nDir,
!     &            nDirZee, nMult, nPair
!
       !ntotcenter  =1
       !local_states=1
       !nDirZee=0
       !nCenter =1
       !exch   =1
       !nT     =301
! --  in this subroutine we define other default values of other variables
! --  these values will be (partly) overwritten by the subsequent
!     "readin_poly" subroutine
!
c-----------------------------------------------------------------------
      ! variables related to the cluster:
      If (nneq > 0) Then
         Do i=1, nneq
            neq(i)=1
            nexch(i)=1
            itype(i)=' '
            D_fact(i)=0.0_wp
            EoverD_fact(i)=0.0_wp
            Do l=1,3
               gtens_input(l,i)=2.002319304361_wp
               riso(i,l,l)=1.0_wp
            End Do
         End Do
      End If
c-----------------------------------------------------------------------
      ! magnetic exchange
      Dipol              = .false.
      AnisoLines1        = .false.
      AnisoLines3        = .false.
      AnisoLines9        = .false.
      KE                 = .false.
      DM_exchange        = .false.
      decompose_exchange = .false.
      JITO_exchange      = .false.
c-----------------------------------------------------------------------
      ! g and D tensors
      If (nMult > 0) Then
         compute_g_tensors = .true.
      Else
         compute_g_tensors = .false.
      End If
c-----------------------------------------------------------------------
      ! Magnetization vector and Zeeman energy spliting
      If (nDir > 0) Then
         compute_Mdir_vector=.true.
      Else
         compute_Mdir_vector=.false.
      End If
      If (nDirZee > 0) Then
         zeeman_energy=.true.
      Else
         zeeman_energy=.false.
      End If
c-----------------------------------------------------------------------
      ! powder magnetization:
      compute_magnetization = .false.
      m_accurate            = .true.
      m_paranoid            = .true.
      smagn                 = .false.
!     threshold for convergence of average spin when zJ .ne. 0.0
      THRS                  = 1.D-10
      iopt                  = 1
      dltH0                 =  0.001_wp     ! the non-zero field point
      NK                    = 50
      MG                    = 50
      HMIN                  =  0.0_wp
      HMAX                  = 10.0_wp
      encut_definition      = 2
      encut_rate            =  1.0_wp
      If(nTempMagn>0) TempMagn(1) = 2.0_wp
      ncut                  = 0
c-----------------------------------------------------------------------
      ! magnetic susceptibility
      compute_susceptibility= .false.
      TMIN                  =  0.0_wp
      TMAX                  =300.0_wp
      DLTT0                 =    0.001_wp
      Xfield                =    0.0_wp
c-----------------------------------------------------------------------
      ! magnetic torque
      compute_torque   = .false.
      nP = 0
      AngPoints = 0
c-----------------------------------------------------------------------
      ! perform comparison with experiment
      TINPUT = .false.
      HINPUT = .false.
c-----------------------------------------------------------------------
      ! relate to crystallographic axes
      Do_structure_abc = .false.
      Do i=1,6
        Cryst(i)=0.0_wp
      End Do
      Do i=1,3
        coord(i)=0.0_wp
      End Do
c-----------------------------------------------------------------------
      ! mean field paraemeter
      ZJ = 0.0_wp
c-----------------------------------------------------------------------
      ! automatic fitting:
      fitCHI  = .false.
      fitM    = .false.
c-----------------------------------------------------------------------
      ! print level
      iPrint  = 2
c-----------------------------------------------------------------------
      ! blocking barrier
      nBlock = 0
      compute_barrier       = .false.
cccc
      DoPlot = .false.
c------------------------------------------------------------------
c  variables in "mgrid.fh"
      Do i=1,32
         Do j=1,3
            get_nP(j,i)=0
         End Do
      End Do
      nsymm  =1
      ngrid  =15
      get_nP(1, 1)=   5
      get_nP(1, 2)=   9
      get_nP(1, 3)=  17
      get_nP(1, 4)=  25
      get_nP(1, 5)=  29
      get_nP(1, 6)=  45
      get_nP(1, 7)=  49
      get_nP(1, 8)=  61
      get_nP(1, 9)=  77
      get_nP(1,10)=  93
      get_nP(1,11)= 105
      get_nP(1,12)= 125
      get_nP(1,13)= 141
      get_nP(1,14)= 161
      get_nP(1,15)= 185
      get_nP(1,16)= 229
      get_nP(1,17)= 309
      get_nP(1,18)= 401
      get_nP(1,19)= 505
      get_nP(1,20)= 621
      get_nP(1,21)= 749
      get_nP(1,22)= 889
      get_nP(1,23)=1041
      get_nP(1,24)=1205
      get_nP(1,25)=1381
      get_nP(1,26)=1569
      get_nP(1,27)=1769
      get_nP(1,28)=1981
      get_nP(1,29)=2205
      get_nP(1,30)=2441
      get_nP(1,31)=2689
      get_nP(1,32)=2949
      get_nP(2, 1)=   4
      get_nP(2, 2)=   6
      get_nP(2, 3)=  11
      get_nP(2, 4)=  16
      get_nP(2, 5)=  17
      get_nP(2, 6)=  27
      get_nP(2, 7)=  28
      get_nP(2, 8)=  34
      get_nP(2, 9)=  41
      get_nP(2,10)=  51
      get_nP(2,11)=  57
      get_nP(2,12)=  68
      get_nP(2,13)=  75
      get_nP(2,14)=  86
      get_nP(2,15)=  98
      get_nP(2,16)= 121
      get_nP(2,17)= 162
      get_nP(2,18)= 209
      get_nP(2,19)= 262
      get_nP(2,20)= 321
      get_nP(2,21)= 386
      get_nP(2,22)= 457
      get_nP(2,23)= 534
      get_nP(2,24)= 617
      get_nP(2,25)= 706
      get_nP(2,26)= 801
      get_nP(2,27)= 902
      get_nP(2,28)=1009
      get_nP(2,29)=1122
      get_nP(2,30)=1241
      get_nP(2,31)=1366
      get_nP(2,32)=1497
      get_nP(3, 1)=  3
      get_nP(3, 2)=  4
      get_nP(3, 3)=  7
      get_nP(3, 4)= 10
      get_nP(3, 5)= 10
      get_nP(3, 6)= 16
      get_nP(3, 7)= 16
      get_nP(3, 8)= 19
      get_nP(3, 9)= 22
      get_nP(3,10)= 28
      get_nP(3,11)= 31
      get_nP(3,12)= 37
      get_nP(3,13)= 40
      get_nP(3,14)= 46
      get_nP(3,15)= 52
      get_nP(3,16)= 64
      get_nP(3,17)= 85
      get_nP(3,18)=109
      get_nP(3,19)=136
      get_nP(3,20)=166
      get_nP(3,21)=199
      get_nP(3,22)=235
      get_nP(3,23)=274
      get_nP(3,24)=316
      get_nP(3,25)=361
      get_nP(3,26)=409
      get_nP(3,27)=460
      get_nP(3,28)=514
      get_nP(3,29)=571
      get_nP(3,30)=631
      get_nP(3,31)=694
      get_nP(3,32)=760


      Return
      End Subroutine set_defaults

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine computes the expectation value <s^2> for a UHF          *
! wavefunction.                                                        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Parameters:                                                          *
! Ca     -  Alpha orbitals, input.                                     *
! Cb     -  Beta orbitals, input.                                      *
! S      -  Overlap matrix, input.                                     *
! nAlpha -  Number of alpha orbitals occupied per irrep, input.        *
! nBeta  -  Number of beta orbitals occupied per irrep, input.         *
! nBas   -  Number of basis functions per irrep, input.                *
! nOrb   -  Number of orbitals per irrep, input.                       *
! nSym   -  Number of irreps, input.                                   *
! s2     -  <s^2>, output.                                             *
!                                                                      *
!***********************************************************************

subroutine s2calc(Ca,Cb,S,nAlpha,nBeta,nBas,nOrb,nSym,s2)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(in) :: Ca(*), Cb(*), S(*)
integer(kind=iwp), intent(in) :: nAlpha(*), nBeta(*), nBas(*), nOrb(*), nSym
real(kind=wp), intent(out) :: s2
real(kind=wp) :: sb, so, sz
integer(kind=iwp) :: i, idxCMO, idxOvl, iSym, npHalf, npSmat, npTfrm
real(kind=wp), allocatable :: Smat(:), Halft(:), Tfrm(:)

!----------------------------------------------------------------------*
! Debug printing stuff                                                 *
!----------------------------------------------------------------------*
#ifdef _DEBUGPRINT_
write(u6,'(a,8i5)') 'nSym  . . . . . .',nSym
write(u6,'(a,8i5)') 'nBas  . . . . . .',(nBas(iSym),iSym=1,nSym)
write(u6,'(a,8i5)') 'nOrb  . . . . . .',(nOrb(iSym),iSym=1,nSym)
write(u6,'(a,8i5)') 'nAlpha  . . . . .',(nAlpha(iSym),iSym=1,nSym)
write(u6,'(a,8i5)') 'nBeta . . . . . .',(nBeta(iSym),iSym=1,nSym)
i = 1
do iSym=1,nSym
  call RecPrt('Ca',' ',Ca(i),nBas(iSym),nBas(iSym))
  call RecPrt('Cb',' ',Cb(i),nBas(iSym),nBas(iSym))
  call RecPrt('S ',' ',S(i),nBas(iSym),nBas(iSym))
  i = i+nBas(iSym)**2
end do
#endif
!----------------------------------------------------------------------*
! Initialize                                                           *
!----------------------------------------------------------------------*
s2 = Zero
!----------------------------------------------------------------------*
! Compute <sz> and N_beta                                              *
!----------------------------------------------------------------------*
sz = Zero
sb = Zero
do iSym=1,nSym
  sz = sz+Half*(nAlpha(iSym)-nBeta(iSym))
  sb = sb+One*nBeta(iSym)
end do
s2 = s2+sz*(sz+One)+sb
#ifdef _DEBUGPRINT_
write(u6,'(a,f12.6)') 'sz  . . . . . . .',sz
write(u6,'(a,f12.6)') 'sb  . . . . . . .',sb
write(u6,'(a,f12.6)') 's2  . . . . . . .',s2
#endif
!----------------------------------------------------------------------*
! Compute size of scratch matrices, the allocate.                      *
!----------------------------------------------------------------------*
npSmat = 0
npHalf = 0
npTfrm = 0
do iSym=1,nSym
  npSmat = max(npSmat,nBas(iSym)*nBas(iSym))
  npHalf = max(npHalf,nAlpha(iSym)*nBas(iSym))
  npTfrm = max(npTfrm,nAlpha(iSym)*nBeta(iSym))
end do
#ifdef _DEBUGPRINT_
write(u6,'(a,i5)') 'npSmat  . . . . .',npSmat
write(u6,'(a,i5)') 'npHalf  . . . . .',npHalf
write(u6,'(a,i5)') 'npTfrm  . . . . .',npTfrm
#endif
if (npTfrm == 0) return
call mma_allocate(Smat,npSmat)
call mma_allocate(Halft,npHalf)
call mma_allocate(Tfrm,npTfrm)
!----------------------------------------------------------------------*
! Compute sum_a sum_b [ C_alpha* S C_beta ]^2                          *
!----------------------------------------------------------------------*
!call xxdGemul(a,lda,'N/T',b,ldb,'N/T',c,ldc,l,m,n)
! C=A*B, m is contraction index
so = Zero
idxCMO = 1
idxOvl = 1
do iSym=1,nSym
  !write(u6,'(a,i1)') 'Irrep ',iSym
  if (nAlpha(iSym)*nBeta(iSym) > 0) then
    call Square(S(idxOvl),Smat,1,nBas(iSym),nBas(iSym))
    call DGEMM_('T','N',nAlpha(iSym),nBas(iSym),nBas(iSym),One,Ca(idxCMO),nBas(iSym),Smat,nBas(iSym),Zero,Halft,nAlpha(iSYm))
    !call RecPrt('Half transform','(12f12.6)',Halft,nAlpha(iSym),nBas(iSym))
    call DGEMM_('N','N',nAlpha(iSym),nBeta(iSym),nBas(iSym),One,Halft,nAlpha(iSym),Cb(idxCMO),nBas(iSym),Zero,Tfrm,nAlpha(iSym))
    !call RecPrt('Transform','(12f12.6)',Tfrm,nAlpha(iSym),nBeta(iSym))
    do i=1,nAlpha(iSym)*nBeta(iSym)
      so = so+Tfrm(i)*Tfrm(i)
    end do
  end if
  idxCMO = idxCMO+nBas(iSym)*nOrb(iSym)
  idxOvl = idxOvl+nBas(iSym)*(nBas(iSym)+1)/2
end do
s2 = s2-so
!write(u6,'(a,f12.6)') 'so  . . . . . . .',so
!write(u6,'(a,f12.6)') 's2  . . . . . . .',s2
!----------------------------------------------------------------------*
! Deallocate scratch matrix.                                           *
!----------------------------------------------------------------------*
call mma_deallocate(Tfrm)
call mma_deallocate(Halft)
call mma_deallocate(Smat)
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine s2calc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine StPert()
      Use Arrays, only: Hss, FAMO_SpinP, FAMO_SpinM,
     &                  G2mm, G2mp, G2pp, Fp, Fm, G1p, G1m
      use ipPage, only: W
      Implicit Real*8(a-h,o-z)

#include "real.fh"
#include "Input.fh"
#include "Pointers.fh"
#include "disp_mclr.fh"
#include "stdalloc.fh"
#include "spin_mclr.fh"
#include "cstate_mclr.fh"
#include "Files_mclr.fh"
      Character(LEN=16) Label
      Character(LEN=8)  MckLbl
      Character(LEN=288) Header
      Real*8, Allocatable:: Tmp1(:), Tmp2(:)
*
      nHss=0
      Do iS=1,nSym
         nHss=nHss+lDisp(is)*(lDisp(is)+1)/2
      End Do
      Call mma_allocate(Hss,nHss,Label='Hss')
      Hss(:)=Zero
*
      If (.Not.Mckinley) Then
         irc=-1
         iopt=1
         Call OPNMCK(irc,iopt,FNMCK,LUMCK)
         If (irc.ne.0) Then
            Write (6,*) 'StPert: Error opening MCKINT'
            Call Abend()
         End If
         irc=-1
         iopt=0
         LABEL='SEWARD'
         If (PT2) LABEL='PT2LAG'
         MckLbl='PERT    '
         Call cWrMck(iRC,iOpt,MckLbl,1,LABEL,iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
         irc=-1
         iopt=0
         MckLbl='NDISP   '
         Call WrMck(iRC,iOpt,MckLbl,1,[ndisp],iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
         irc=-1
         iopt=0
         MckLbl='TDISP   '
         Call WrMck(iRC,iOpt,MckLbl,1,ntpert,iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
         irc=-1
         iopt=0
         MckLbl='Title'
         Call cWrMck(iRC,iOpt,MckLbl,1,Header,iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
         irc=-1
         iopt=0
         MckLbl='nSym'
         Call WrMck(iRC,iOpt,MckLbl,1,[nSym],iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
         irc=-1
         iopt=0
         MckLbl='nBas'
         Call WrMck(iRC,iOpt,MckLbl,1,nBas,iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
         irc=-1
         iopt=0
         MckLbl='ldisp'
         Call WrMck(iRC,iOpt,MckLbl,1,ldisp,iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
         irc=-1
         iopt=0
         MckLbl='chdisp'
         Call cWrMck(iRC,iOpt,MckLbl,1,swlbl(1),iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
         irc=-1
         iopt=0
         MckLbl='NISH'
         Call WrMck(iRC,iOpt,MckLbl,1,nish,iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
         irc=-1
         iopt=0
         MckLbl='NASH'
         Call WrMck(iRC,iOpt,MckLbl,1,nash,iDummer)
         If (irc.ne.0) Then
             Write (6,*) 'StPert: Error writing to MCKINT'
             Write (6,'(A,A)') 'MckLbl=',MckLbl
            Call Abend()
         End If
      End If
*
      If (SPINPOL) Then
         call coeff(ralphas,rbetaa,rbetas)
         rms=DBLE(ms2)/2.0d0
         nAct  = 0
         Do iSym = 1, nSym
            nAct = nAct + nAsh(iSym)
         End Do
         nG=nAct**2
         nG2=nAct**4
         Call mma_allocate(famo_spinp,ndens2,Label='famo_spinp')
         Call mma_allocate(famo_spinm,ndens2,Label='famo_spinm')
         Call mma_allocate(G2mp,nG2,Label='G2mp')
         Call mma_allocate(G2pp,nG2,Label='G2pp')
         Call mma_allocate(G2mm,nG2,Label='G2mm')
         Call mma_allocate(Fm,nG2,Label='Fm')
         Call mma_allocate(Fp,nG2,Label='Fp')
         Call mma_allocate(G1p,nG,Label='G1p')
         Call mma_allocate(G1m,nG,Label='G1m')
         itype=2
         irc=ipin(ipCI)
         Call SpinDens(W(ipCI)%Vec,W(ipCI)%Vec,
     &                 STATE_SYM,STATE_SYM,G2mm,G2mp,G2pp,
     &                 Fm,Fp,G1m,G1p,iType)

         Call mma_allocate(Tmp2,ndens2,Label='Tmp2')
         Call mma_MaxDBLE(nMax)
         Call mma_allocate(Tmp1,nMax/2,Label='Tmp1')

         Call Ex_spin(G1p,FAMO_Spinp,Tmp1,nMax/2,Tmp2)
         Call Ex_spin(G1m,FAMO_Spinm,Tmp1,nMax/2,Tmp2)

         Call mma_deallocate(Tmp1)
         Call mma_deallocate(Tmp2)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Rotation(TotalM,TRotA,TRotB,TRotC,nsRot,nFAtoms,lSlapaf)

use Index_Functions, only: iTri, nTri_Elem
use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half, Angstrom, auTocm, auTokJ, auToHz, kBoltzmann, uToau
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: TotalM, TRotA, TRotB, TRotC
integer(kind=iwp), intent(inout) :: nsRot
integer(kind=iwp), intent(out) :: nFAtoms
logical(kind=iwp), intent(in) :: lSlapaf
integer(kind=iwp) :: i, iAtom, j, nrot
real(kind=wp) :: CM(3), dEV, dSum, dVec(3), dX, dY, dZ, EVal(nTri_Elem(3)), Inrt(3,3), RotE(3), Vec(3,3)
real(kind=wp), allocatable :: CCoor(:,:), FCoor(:,:), Mass(:), SOCoor(:,:)
character(len=LenIn), allocatable :: FAtLbl(:)
real(kind=wp), parameter :: RT = 1.0e3_wp*Half*auTokJ/kBoltzmann/uToau

!CM              : Center of masses
!FCoor           : Full Coords
!CCoor           : Mass-centered Coords
!SOCoor          : Symmetry-Oriented Coords
!Inrt, RotE, Vec : Inertia components
!Mass            : Masses
!FAtLbl          : Atomic labels

! Get Atomic Full Labels, Coordinates & Mass - FAtLbl, FCoor, Mass

call Get_nAtoms_All(nFAtoms)
call mma_allocate(FCoor,3,nFAtoms,label='FCoor')
call mma_allocate(Mass,nFAtoms,label='Mass')
call mma_allocate(FAtLbl,nFAtoms,label='FAtLbl')
call GetFullCoord(FCoor,Mass,FAtLbl,nFAtoms,lSlapaf)

! Define the Center of Masses - CM()

CM(1) = Zero
CM(2) = Zero
CM(3) = Zero
TotalM = Zero
do i=1,nFAtoms
  TotalM = TotalM+Mass(i)
  CM(:) = CM+Mass(i)*FCoor(:,i)
end do
CM(:) = CM/TotalM

! Shift coordinates in the center of masses - CCoord()

call mma_allocate(CCoor,3,nFAtoms,label='CCoor')
do i=1,nFAtoms
  CCoor(:,i) = FCoor(:,i)-CM
end do
call mma_deallocate(FCoor)

! Compute the Inertia-matrix - Inrt(3,3)

Inrt(:,:) = Zero
do i=1,nFAtoms
  dX = CCoor(1,i)
  dY = CCoor(2,i)
  dZ = CCoor(3,i)
  Inrt(1,1) = Inrt(1,1)+Mass(i)*(dY*dY+dZ*dZ) ! YY ZZ
  Inrt(2,1) = Inrt(2,1)-Mass(i)*dX*dY         ! XY
  Inrt(2,2) = Inrt(2,2)+Mass(i)*(dX*dX+dZ*dZ) ! XX ZZ
  Inrt(3,1) = Inrt(3,1)-Mass(i)*dX*dZ         ! XZ
  Inrt(3,2) = Inrt(3,2)-Mass(i)*dY*dZ         ! YZ
  Inrt(3,3) = Inrt(3,3)+Mass(i)*(dX*dX+dY*dY) ! XX YY
end do
Inrt(1,2) = Inrt(2,1)
Inrt(1,3) = Inrt(3,1)
Inrt(2,3) = Inrt(3,2)

! and diagonalize it - Inrt(3,3)

do i=1,3
  do j=1,i
    EVal(iTri(i,j)) = Inrt(i,j)
  end do
end do
call unitmat(Vec,3)
call Jacob(EVal,Vec,3,3)
call Jacord(EVal,Vec,3,3)
do i=1,3
  RotE(i) = EVal(nTri_Elem(i))
end do

! Sort the principal axis such that z' is the one with the lowest eigenvalue.

do i=1,2
  do j=i+1,3
    if (RotE(i) < RotE(j)) then
      dEV = RotE(i)
      dVec(:) = Vec(:,i)
      RotE(i) = RotE(j)
      Vec(:,i) = Vec(:,j)
      RotE(j) = dEV
      Vec(:,j) = dVec
    end if
  end do
end do

! Rotate coords to Symmetry-Oriented

call mma_allocate(SOCoor,3,nFAtoms,label='SOCoor')
do iAtom=1,nFAtoms
  do i=1,3
    dSum = Zero
    do j=1,3
      dSum = dSum+CCoor(j,iAtom)*Vec(j,i)
    end do
    SOCoor(i,iAtom) = dSum
  end do
end do
call mma_deallocate(CCoor)

! Rotational Symmetry factor - nsRot

if (nsRot == 0) nsRot = 1
if (nFAtoms == 2) then
  if (Mass(1) == Mass(2)) nsRot = 2
end if

TRotA = RT/(RotE(3)+1.0e-99_wp)
TRotB = RT/(RotE(2)+1.0e-99_wp)
TRotC = RT/(RotE(1)+1.0e-99_wp)

! Check if linear molecule

nrot = 3
if (TRotA > 1.0e99_wp) nrot = nrot-1
if (TRotB > 1.0e99_wp) nrot = nrot-1
if (TRotC > 1.0e99_wp) nrot = nrot-1

! Print results

write(u6,'(A)') ' Mass-centered Coordinates (angstrom):'
write(u6,'(1X,A)') '********************************************************'
write(u6,'(1X,A)') 'Label        X           Y           Z          Mass  '
write(u6,'(1X,A)') '--------------------------------------------------------'
do i=1,nFAtoms
  write(u6,'(1X,A,1X,3F12.6,1x,F12.5)') FAtLbl(i),Angstrom*SOCoor(:,i),Mass(i)
end do
write(u6,'(1X,A)') '--------------------------------------------------------'
write(u6,'(A,F12.6)') ' Molecular mass:',TotalM
write(u6,'(A,3F10.4)') ' Rotational Constants (cm-1):',(auTocm*Half/(uToau*RotE(i)),i=1,nrot)
write(u6,'(A,3F10.4)') ' Rotational Constants (GHz) :',(1.0e-9_wp*auToHz*Half/(uToau*RotE(i)),i=1,nrot)
write(u6,'(A,3F10.4)') ' Rotational temperatures (K):',(RT/RotE(i),i=1,nrot)
write(u6,'(A,I2)') ' Rotational Symmetry factor: ',nsRot
call mma_deallocate(Mass)
call mma_deallocate(FAtLbl)
call mma_deallocate(SOCoor)

return

end subroutine Rotation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Enondyn_dft(nh1,Grad,nGrad,DFTFOCK)
      use SCF_Arrays, only: CMO
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "stdalloc.fh"
#include "infscf.fh"
      Real*8  Grad(nGrad)
      Character*4 DFTFOCK
#include "dcscf.fh"
      Real*8, Allocatable :: F_DFT(:,:), D_DS(:,:)
*
      Erest_xc=0.0d0
      Call mma_allocate(D_DS ,nBT,2,Label='D_DS ')
      D_DS(:,:)=Zero
*
      iOff=1
      jOff=1
      Do iSym=1,nSym
         Call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nOcc(iSym,1),
     &                    1.0d0,CMO(iOff,1),nBas(iSym),
     &                          CMO(iOff,1),nBas(iSym),
     &                    0.0d0,D_DS(jOff:,1),nBas(iSym))
         Call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nOcc(iSym,2),
     &                    1.0d0,CMO(iOff,2),nBas(iSym),
     &                          CMO(iOff,2),nBas(iSym),
     &                    0.0d0,D_DS(jOff:,2),nBas(iSym))
         Do j=1,nBas(iSym)
            Do i=1,j-1
               ji=j*(j-1)/2+i
               iDji=iOff-1+ji
               D_DS(iDji,1)=2.0d0*D_DS(iDji,1)
               D_DS(iDji,2)=2.0d0*D_DS(iDji,2)
            End Do
         End Do
         iOff=iOff+nBas(iSym)*nOrb(iSym)
         jOff=jOff+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
*
*----------------------------------------------------------------------*
      Call Get_Fmat_nondyn(D_DS(:,1),D_DS(:,2),nBT,.true.)
*----------------------------------------------------------------------*
*
*----------------------------------------------------------------------*
      Call mma_allocate(F_DFT,nBT,2,Label='F_DFT')
      Call Get_Exc_dft(nh1,Grad,nGrad,DFTFOCK,F_DFT,D_DS,nBT,2,
     &                     KSDFT)
*----------------------------------------------------------------------*
*
      Call mma_deallocate(D_DS)
      Call mma_deallocate(F_DFT)
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine Get_Exc_dft(nh1,Grad,nGrad,DFTFOCK,F_DFT,D_DS,nBT,nD,
     &                       KSDFT)
      use nq_Info, only: Dens_I, Grad_I, Tau_I
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "debug.fh"
      Real*8  Grad(nGrad)
      Logical Do_MO,Do_TwoEl,Do_Grad
      Character*4 DFTFOCK
      Character*80  KSDFT
#include "dcscf.fh"
      Real*8 :: D_DS(nBT,nD), F_DFT(nBT,nD)
*
      Debug=.False.
*                                                                      *
************************************************************************
*                                                                      *
*     DFT functionals, compute integrals over the potential
*
      Func            =Zero
      Dens_I          =Zero
      Grad_I          =Zero
      Tau_I           =Zero
      Do_MO           =.False.
      Do_TwoEl        =.False.
      Do_Grad=.false.
*
      nFckDim=2
*                                                                      *
************************************************************************
*                                                                      *
      Call Driver(KSDFT,Do_Grad,Func,Grad,nGrad,
     &            Do_MO,Do_TwoEl,D_DS,F_DFT,nh1,nFckDim,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
      Erest_xc=Erest_xc-Func
*
#ifdef _DEBUGPRINT_
      write(6,*) ' XC-part of energy-restoring term : ',-Func
      write(6,*)
      write(6,*) ' XC-potentials: (itri,F_alpha,F_beta)'
      write(6,*)
      Do i=1,nh1
        Write(6,'(i4,3f22.16)') i,F_DFT(i,1),F_DFT(i,2)
      End Do
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************

      SUBROUTINE CHO_FSCF(rc,nDen,ipFLT,nForb,nIorb,
     &                       ipPorb,ipDLT,ExFac)

**********************************************************************
*  Author : F. Aquilante
*
C *************** INACTIVE AO-BASIS FOCK MATRIX **********************
C
C   F(ab) = sum_J  Lab,J * V(J)  -  sum_Jk  Lka,J * Lkb,J
C
**********************************************************************
C
C      V(J) = sum_gd  Lgd,J * Dtot(gd)
C
C      a,b,g,d:  AO-index
C      k:        MO-index   belonging to (Frozen+Inactive)
C
**********************************************************************

      Implicit Real*8 (a-h,o-z)

      Integer   rc,nDen,ipLab(8,2)
      Integer   ipOrb(8,2),nOrb(8,2)
      Integer   iSkip(8)
      Integer   ISTLT(8)
      Real*8    tread(2),tcoul(2),texch(2)
      Real*8    FactCI,FactXI,ExFac
      Integer   ipDLT(nDen),ipFLT(nDen)
      Integer   ipPorb(nDen)
      Integer   nForb(8,nDen),nIorb(8,nDen)
      Logical   Debug,timings,DoRead
      Character*50 CFmt
      Character*8 SECNAM
      Parameter (SECNAM = 'CHO_FSCF')
      COMMON    /CHOTIME /timings

      parameter (zero = 0.0D0, one = 1.0D0, xone = -1.0D0)

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )
      Logical add
      Character*6 mode

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
************************************************************************

#ifdef _DEBUGPRINT_
c      Debug=.true.
      Debug=.false.! to avoid double printing in CASSCF-debug
#else
      Debug=.false.
#endif


      FactCI = one
      FactXI = xone*ExFac

      DoRead  = .false.
      IREDC= -1  ! unknwn reduced set

      If (nDen.ne.1 .and. nDen.ne.2) then
         write(6,*)SECNAM//'Invalid parameter nDen= ',nDen
         call abend()
      EndIf


        CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        do i=1,2            ! 1 --> CPU   2 --> Wall
           tread(i) = zero  !time read/transform vectors
           tcoul(i) = zero  !time for computing Coulomb
           texch(i) = zero  !time for computing Exchange
        end do

C ==================================================================

c --- Various offsets
c --------------------
        ISTLT(1)=0
      DO ISYM=2,NSYM
        NBB=NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NBB ! Inactive D and F matrices
      END DO

      DO jDen=1,nDen

         ipOrb(1,jDen) = ipPorb(jDen)
         nOrb(1,jDen)  = nForb(1,jDen)+nIorb(1,jDen)

         DO ISYM=2,NSYM

            ipOrb(iSym,jDen) = ipOrb(iSym-1,jDen)
     &                       + nOrb(iSym-1,jDen)*nBas(iSym-1)
            nOrb(iSym,jDen)  = nForb(iSym,jDen)+nIorb(iSym,jDen)

         END DO

      END DO

      iLoc = 3 ! use scratch location in reduced index arrays

C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
      DO jSym=1,nSym

         If (NumCho(jSym).lt.1) GOTO 1000


C ****************     MEMORY MANAGEMENT SECTION    *****************
C ------------------------------------------------------------------
C --- compute memory needed to store at least 1 vector of JSYM
C --- and do all the subsequent calculations
C ------------------------------------------------------------------
         mTvec = 0  ! mem for storing the half-transformed vec

         do l=1,nSym
            k=Muld2h(l,JSYM)
            Mmax = 0
            do jDen=1,nDen
               Mmax = Max(Mmax,nForb(k,jDen)+nIorb(k,jDen))
            end do
            mTvec = mTvec + nBas(l)*Mmax
         end do

         mTvec=Max(mTvec,1)

C ------------------------------------------------------------------
C ------------------------------------------------------------------

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

         Do JRED=JRED1,JRED2

            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               call abend()
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.',
     &                        '   rc= ',irc
              call abend()
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            If(JSYM.eq.1)Then

               Call GetMem('rsDtot','Allo','Real',ipDab,nRS)
               Call GetMem('rsFC','Allo','Real',ipFab,nRS)
               Call Fzero(Work(ipDab),nRS)
               Call Fzero(Work(ipFab),nRS)

            EndIf

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec  = Min(LWORK/(nRS+mTvec),nVrs)

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) 'LWORK= ',LWORK
               WRITE(6,*) 'min. mem. need= ',nRS+mTvec
               WRITE(6,*) 'jsym= ',jsym
               rc = 33
               CALL Abend()
               nBatch = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
            Call GetMem('ChoT','Allo','Real',ipChoT,mTvec*nVec)

            If(JSYM.eq.1)Then
C --- Transform the density to reduced storage
               mode = 'toreds'
               add  = .false.
               nMat=1
               Call move_sto(irc,iLoc,nMat,ipDLT,ipDab,mode,add)
            EndIf

C --- BATCH over the vectors ----------------------------

            nBatch = (nVrs-1)/nVec + 1

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM ) then
                  rc=77
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

               If(JSYM.eq.1)Then
C ************ (alpha+beta) COULOMB CONTRIBUTION  ****************
C
C --- Contraction with the density matrix
C ---------------------------------------
C --- V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * DI(rs)
C==========================================================
C
                  CALL CWTIME(TCC1,TWC1)

                  ipVJ = ipChoT

                  CALL DGEMV_('T',nRS,JNUM,
     &                 ONE,Work(ipLrs),nRS,
     &                 Work(ipDab),1,ZERO,Work(ipVJ),1)

C --- FI(rs){#J} <- FI(rs){#J} + FactCI * sum_J L(rs,{#J})*V{#J}
C===============================================================

                  Fact = dble(min(jVec-iVrs,1))

                  CALL DGEMV_('N',nRS,JNUM,
     &                 FactCI,Work(ipLrs),nRS,
     &                 Work(ipVJ),1,Fact,Work(ipFab),1)


                  CALL CWTIME(TCC2,TWC2)
                  tcoul(1) = tcoul(1) + (TCC2 - TCC1)
                  tcoul(2) = tcoul(2) + (TWC2 - TWC1)

               EndIf  ! Coulomb contribution


C *************** EXCHANGE CONTRIBUTIONS  ***********************

C --- Set pointers to the half-transformed Cholesky vectors
               Do jDen=1,nDen

                  lChoT=0
                  Do iSymb=1,nSym

                     iSymp = MulD2h(JSYM,iSymb)

                     ipLab(iSymp,jDen) = ipChoT + lChoT  ! LpJ,b

                     lChoT = lChoT + nBas(iSymb)*
     &                      (nForb(iSymp,jDen)+nIorb(iSymp,jDen))*JNUM

                  End Do

               End Do


               iSwap = 2  ! LpJ,b are returned

               Do jDen=1,nDen

                  CALL CWTIME(TCR3,TWR3)

                  kMOs = jDen  ! 1--> alpha  2-->beta MOs
                  nMOs = jDen

C --- Set up the skipping flags
C -------------------------------------------------------------
                  Do i=1,nSym

                     k = Muld2h(i,JSYM)
                     iSkip(k) = Min(1,
     &                    nBas(i)*(nForb(k,jDen)+nIorb(k,jDen)))

                  End Do
C -------------------------------------------------------------


C *********************** HALF-TRANSFORMATION  ****************

                  CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                            JSYM,iSwap,IREDC,nMOs,kMOs,ipOrb,nOrb,
     &                            ipLab,iSkip,DoRead)

                  CALL CWTIME(TCR4,TWR4)
                  tread(1) = tread(1) + (TCR4 - TCR3)
                  tread(2) = tread(2) + (TWR4 - TWR3)

#ifdef _DEBUGPRINT_
      write(6,*) 'Half-transformation in the MO space: ',jDen
      write(6,*) 'Total allocated :     ',mTvec*nVec,' at ',ipChoT
      write(6,*) 'Mem pointers ipLab: ',((ipLab(i,j),i=1,nSym),j=1,jDen)
      write(6,*) 'iSkip :             ',(iSkip(k),k=1,nSym)
      write(6,*) 'LREAD: ',LREAD,' allocated at ',ipLrs
      write(6,*) 'JSYM :                ',JSYM
      write(6,*) 'JRED :                ',JRED
      write(6,*) 'JNUM :                ',JNUM
#endif

                  if (irc.ne.0) then
                     rc = irc
                     RETURN
                  endif


                  CALL CWTIME(TCX1,TWX1)

                  Do iSyma=1,nSym

                     iSymk = MulD2h(JSYM,iSyma)

C ---------------------------------------------------------------------
c *** Compute only the LT part of the InActive exchange matrix ********
C
C     FI(ab) = FI(ab) + FactXI * sum_Jk  LkJ,a * LkJ,b
C ---------------------------------------------------------------------
                     NK = nForb(iSymk,jDen) + nIorb(iSymk,jDen)

                     If (iSkip(iSymk).ne.0) Then

                        ISFI = ipFLT(jDen) + ISTLT(iSyma)

                        CALL DGEMM_TRI('T','N',nBas(iSyma),nBas(iSyma),
     &                         NK*JNUM,FactXI,Work(ipLab(iSymk,jDen)),
     &                         NK*JNUM,Work(ipLab(iSymk,jDen)),NK*JNUM,
     &                         One,Work(ISFI),nBas(iSyma))


c          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYMA
c          CALL TRIPRT('FI: jSym>1',' ',Work(ISFI),nBas(iSyma))

                     EndIf

C --------------------------------------------------------------------
                  End Do  !loop over MOs symmetries

                  CALL CWTIME(TCX2,TWX2)
                  texch(1) = texch(1) + (TCX2 - TCX1)
                  texch(2) = texch(2) + (TWX2 - TWX1)


               End Do   ! loop over densities

C --------------------------------------------------------------------
C --------------------------------------------------------------------

            END DO  ! end batch loop


            If(JSYM.eq.1)Then
c --- backtransform fock matrix to full storage
               mode = 'tofull'
               add  = .true.
               nMat = nDen
               Call move_sto(irc,iLoc,nMat,ipFLT,ipFab,mode,add)
            EndIf

C --- free memory
            Call GetMem('ChoT','Free','Real',ipChoT,mTvec*nVec)
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

            If(JSYM.eq.1)Then
              Call GetMem('rsFC','Free','Real',ipFab,nRS)
              Call GetMem('rsDtot','Free','Real',ipDab,nRS)
            EndIf


999         Continue

         END DO   ! loop over red sets

1000     CONTINUE

      END DO   !loop over JSYM

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1


*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky SCF timing from '//SECNAM
      Write(6,CFmt)'------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ/TRANSFORM VECTORS           '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB                          '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'EXCHANGE                         '
     &                           //'         ',texch(1),texch(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


c Print the Fock-matrix
#ifdef _DEBUGPRINT_

      if(Debug) then !to avoid double printing in SCF-debug

      WRITE(6,'(6X,A)')'TEST PRINT FROM '//SECNAM
      WRITE(6,'(6X,A)')
      WRITE(6,'(6X,A)')'***** FOCK MATRIX AO-BASIS ***** '
      Do jDen=1,nDen
        if(nDen.eq.2) Then
          if(jden.eq.1) WRITE(6,'(6X,A)')'******** ALPHA SPIN ******** '
          if(jden.eq.2) WRITE(6,'(6X,A)')'******** BETA SPIN ********* '
        endif
        DO ISYM=1,NSYM
           ISFI=ipFLT(jDen)+ISTLT(ISYM)
           IF( NBAS(ISYM).GT.0 ) THEN
             WRITE(6,'(6X,A)')
             WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
             call TRIPRT('','',Work(ISFI),NBAS(ISYM))
           ENDIF
        END DO
      END DO

      endif

#endif

      rc  = 0


      Return
      END

**************************************************************
**************************************************************



      SUBROUTINE move_sto(irc,iLoc,nDen,ipXLT,ipXab,mode,add)

      Implicit Real*8 (a-h,o-z)
      Integer  ISLT(8),cho_isao,nDen
      External cho_isao
      Integer ipXLT(nDen),ipXab
      Logical add
      Character*6 mode

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

************************************************************************
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      iRS2F(i,j)  = iWork(ip_iRS2F-1+2*(j-1)+i)
************************************************************************


c Offsets to symmetry block in the LT matrix
      ISLT(1)=0
      DO ISYM=2,NSYM
         ISLT(ISYM) = ISLT(ISYM-1)
     &              + NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
      END DO

**************************************************

      jSym = 1 ! only total symmetric density

      xf=0.0d0
      if (add) xf=1.0d0 !accumulate contributions

      If (mode.eq.'toreds') then

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            Do jDen=1,nDen

               kfrom = ipXLT(jDen) + isLT(iSyma) + iab - 1

               Work(ipXab+jRab-1) = xf*Work(ipXab+jRab-1)
     &                            +    Work(kfrom)

            End Do

         End Do  ! jRab loop

      ElseIf (mode.eq.'tofull') then

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            Do jDen=1,nDen

               kto = ipXLT(jDen) + isLT(iSyma) + iab - 1

               Work(kto) = xf*Work(kto)
     &                   +    Work(ipXab+jRab-1)

            End Do


         End Do  ! jRab loop

      Else

         write(6,*)'Wrong input parameter. mode = ',mode
         irc = 66
         Call abend()

      EndIf

      irc = 0

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CSFGRad(Grad,nGrad)
!***********************************************************************
!                                                                      *
! Object: to compute the CSF component of the non-adiabatic derivative *
!         coupling                                                     *
!                                                                      *
! This routine assumes C1 symmetry and needs the 'D1ao-' matrix stored *
! in the runfile                                                       *
!                                                                      *
!***********************************************************************

!use Basis_Info, only: nBas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(out) :: Grad(nGrad)
integer(kind=iwp) :: nD, lOper(1)
real(kind=wp) CCoor(3)
logical(kind=iwp) :: Found
character(len=80) :: Label
real(kind=wp), allocatable :: aDAO(:)
external :: OvrGrd, OvrMmG
#include "nac.fh"

Grad(:) = Zero

!nB = nBas(0)
call Qpg_dArray('D1ao-',Found,nD)
call mma_allocate(aDAO,nD)
call Get_dArray('D1ao-',aDAO,nD)
!call TriPrt('DAO-','',aDAO,nB)

!IFG Compute the CSF contribution to the coupling vector.
!    Inner product of S[x] and D^A (antisymmetric component of transition density matrix)
!    This is the same as the product of S[x]^A and D
isCSF = .true.
CCoor(:) = Zero
lOper(1) = 1
Label = 'The CSF Contribution'
call OneEl_g(OvrGrd,OvrMmG,Grad,nGrad,.false.,CCoor,aDAO,nD,lOper,1,0,Label)
isCSF = .false.

call mma_deallocate(aDAO)

end subroutine CSFGRad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mk_G(G,GInv,nDimBC)

use Slapaf_Info, only: Curvilinear, Degen, dMass, Smmtrc, User_Def
use Constants, only: Zero, One, uToau
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDimBC
real(kind=wp), intent(out) :: G(nDimBC,nDimBC), GInv(nDimBC,nDimBC)
integer(kind=iwp) :: i, ii, ix, nsAtom
logical(kind=iwp) :: Auto

Auto = .not. User_Def
nsAtom = size(Smmtrc,2)
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate the mass tensor

G(:,:) = Zero
GInv(:,:) = Zero
ii = 0
do i=1,nsAtom
  do ix=1,3
    if (Smmtrc(ix,i)) then
      ii = ii+1
      if (Auto .and. (.not. Curvilinear)) then
        G(ii,ii) = Degen(ix,i)/dMass(i)
      else
        G(ii,ii) = One/(Degen(ix,i)*dMass(i))
      end if
      GInv(ii,ii) = One/(G(ii,ii)*uToau)
    end if
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('G (cartesian)',' ',G,nDimBC,nDimBC)
call RecPrt('G-1 (cartesian)',' ',GInv,nDimBC,nDimBC)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine mk_G

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DNAXPY(N,M,A,INCA,X,INCXI,INCXO,Y,INCYI,INCYO)
! MULTIPLY A VECTOR, X, BY A SCALAR, ADD TO A VECTOR, Y, AND
! STORE THE RESULT IN THE VECTOR Y. REPEAT THIS N TIMES.

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, M, INCA, INCXI, INCXO, INCYI, INCYO
real(kind=wp), intent(in) :: A((N-1)*INCA+1), X(((M-1)*INCXI+1)*((N-1)*INCXO+1))
real(kind=wp), intent(inout) :: Y(((M-1)*INCYI+1)*((N-1)*INCYO+1))
integer(kind=iwp) :: I

do I=1,N
  call DAXPY_(M,A(1+(I-1)*INCA),X(1+(I-1)*INCXO),INCXI,Y(1+(I-1)*INCYO),INCYI)
end do

return

end subroutine DNAXPY

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine Mk_TriInd()
*
#include "TriInd.fh"
*
       ij = 0
       Do k = 0, I_Max-1
          Do i = 0, k
             j = k - i
             ij = ij + 1
             iTriInd(1,ij)=i
             iTriInd(2,ij)=j
          End Do
       End Do
*
       Return
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Giovanni Ghigo                                   *
************************************************************************
      Subroutine MkLij(iSymI,iSymJ,iI,iJ,numV, iAddLij)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Torino University, Italy                                   *
*           July 2005                                                  *
*----------------------------------------------------------------------*
* Purpuse:  Generation of the Cholesky vector for occupied iI(iSymI),  *
*           iJ(iSymJ) for numV vectors.                                *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"

      If (iI.LE.nIsh(iSymI)) then
        iIx = iI
        nIx = nIsh(iSymI)
        If (iJ.LE.nIsh(iSymJ)) then
          LijType = 1
          iJy = iJ
          nJy = nIsh(iSymJ)
        else
          LijType = 7
          iJy = iJ - nIsh(iSymJ)
          nJy = nAsh(iSymJ)
        EndIf
      else
        iIx = iI - nIsh(iSymI)
        nIx = nAsh(iSymI)
        If (iJ.LE.nIsh(iSymJ)) then
          LijType = 2
          iJy = iJ
          nJy = nIsh(iSymJ)
        else
          LijType = 4
          iJy = iJ - nIsh(iSymJ)
          nJy = nAsh(iSymJ)
        EndIf
      EndIf

CGG   ------------------------------------------------------------------
      If(IfTest) then
      Write(6,*)'     Cho_MkLij: TCVx(',LijType,': ',iSymI,',',iSymJ,')'
      Call XFlush(6)
      EndIf
CGG   ------------------------------------------------------------------
      iAddTCVX= iMemTCVX(LijType,iSymI,iSymJ,1) + nIx*(iJy-1) + iIx - 1
      Call dCopy_(numV,Work(iAddTCVX),nIx*nJy,Work(iAddLij),1)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine torque(Nss,NM,AngPoints,EM,eso,dipm,sm,zJ,thrs,mem,m_paranoid,smagn,H_torq,T_torq,ma,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, deg2rad
use Definitions, only: wp, iwp, u6, CtoB, RtoB

implicit none
integer(kind=iwp), intent(in) :: nss, nm, AngPoints, mem
real(kind=wp), intent(in) :: EM, ESO(nss), zJ, thrs, H_torq, T_torq, ma(3,3) ! main magnetic axes
complex(kind=wp), intent(in) :: DIPM(3,nss,nss), SM(3,nss,nss)
logical(kind=iwp), intent(in) :: m_paranoid, smagn, DBG
integer(kind=iwp) :: I, IM, J, mem_local, nT_torq
real(kind=wp) :: AngRad, AngStep, g(3), mg(3,3), MT(3), ST(3), ZT(1) !, det, dlth, ma_inv(3,3)
complex(kind=wp) :: MM(3,2,2)
character(len=99) :: STLNE2
real(kind=wp), allocatable :: Ang(:), dX(:), dY(:), dZ(:), ty(:), W(:) !, tx(:,:), tz(:,:)
complex(kind=wp), allocatable :: M(:,:,:), S(:,:,:)
integer(kind=iwp), parameter :: nPlanes = 1

write(u6,*)
write(u6,'(A)') repeat('%',96)
write(u6,'(20X,A)') 'ANGULAR DEPENDENCE OF THE MAGNETIZATION TORQUE'
write(u6,'(A)') repeat('%',96)
write(u6,*)
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!write(u6,'(2X,A,i3,A)') 'Magnetization torque is calculated for the ',NH,' field points, in the field domain:'
!write(u6,'(2X,F4.1,1x,a,1X,F4.1,a,10(F6.3,a))') HMIN,'--',HMAX,' T., at the following temperatures:', &
!                                                (TempMagn(l),' K.;',l=1,nTempMagn)
!do i=11,nTempMagn,10
!  j = MIN(nTempMagn,i+9)
!  write(u6,'(17x,10(F9.3,A))') (TempMagn(k),' K.;',k=i,j)
!end do
write(u6,'(2X,A,F10.5,A,F10.5)') 'Magnetization torque is calculated for one field point,',H_torq, &
                                 ' T., at the following temperature:',T_torq

write(u6,'(2x,A,i3,A)') 'Angular dependence of the magnetization torque is computed for ',AngPoints,' angular points distributed'
write(u6,'(2x,A)') 'in the domain 0-180 deg.'
write(u6,'(2X,A)') 'The cut-off energy for the exact diagonalization of the Zeeman Hamiltonian is:'
write(u6,'(2x,a,F15.9,A)') 'E = ',EM,' cm(-1).'
if (NM < 10) then
  write(u6,'(2X,A,i2,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 10) .and. (NM < 100)) then
  write(u6,'(2X,A,i3,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 100) .and. (NM < 1000)) then
  write(u6,'(2X,A,i4,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 1000) .and. (NM < 10000)) then
  write(u6,'(2X,A,i5,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
end if
nT_torq = 1

!if (dbg) then
do i=1,3
  write(u6,*) (ma(j,i),j=1,3)
end do
!end if
!-----------------------------------------------------------------------
! Allocate memory for this computation:
mem_local = 0
! Zeeman exchange energy spectrum
call mma_allocate(W,nM,'W')
mem_local = mem_local+size(W)*RtoB

call mma_allocate(dX,AngPoints,'dX')
call mma_allocate(dY,AngPoints,'dY')
call mma_allocate(dZ,AngPoints,'dZ')
mem_local = mem_local+size(dX)*RtoB
mem_local = mem_local+size(dY)*RtoB
mem_local = mem_local+size(dZ)*RtoB

call mma_allocate(Ang,AngPoints,'Ang')
mem_local = mem_local+size(Ang)*RtoB

call mma_allocate(ty,AngPoints,'ty')
mem_local = mem_local+size(ty)*RtoB

call mma_allocate(M,3,nss,nss,'Mrot')
call mma_allocate(S,3,nss,nss,'Srot')
mem_local = mem_local+size(M)*CtoB
mem_local = mem_local+size(S)*CtoB

if (dbg) then
  write(u6,*) 'TORQ:  memory allocated (local):'
  write(u6,*) 'mem_local=',mem_local
  write(u6,*) 'TORQ:  memory allocated (total):'
  write(u6,*) 'mem_total=',mem+mem_local
end if
!-----------------------------------------------------------------------
! rotate the moments to the coordiante system of
! the ground state
!call REVERSE(ma,ma_inv,DET)
call rotmom2(DIPM,nss,ma,M)
call rotmom2(SM,nss,ma,S)

MM(:,:,:) = M(:,1:2,1:2)
call atens(MM,2,g,mg,2)
!-----------------------------------------------------------------------
!call hdir2(AngPoints,2,dX,dY,dZ,Ang,2)
dY(:) = Zero
AngStep = 360.0_wp/real(AngPoints-1,kind=wp)
do i=1,AngPoints
  AngRad = real(i-1,kind=wp)*AngStep*deg2rad !+122.625_wp*deg2rad
  Ang(i) = real(i-1,kind=wp)*AngStep
  dX(i) = cos(AngRad)
  dZ(i) = sin(AngRad)
end do
if (dbg) then
  !write(u6,'(A,I5)') 'Angular grid for Magnetization Torque, Cartesian Component =',L
  write(u6,'(2x,A,4x,A,5x,3(10X,A,10x))') 'Nr.','Angle','X','Y','Z'
  do i=1,AngPoints
    write(u6,'(I4,F10.3,3x,3F21.14)') i,Ang(i),dX(i),dY(i),dZ(i)
  end do
end if
!-----------------------------------------------------------------------

do IM=1,AngPoints
  write(STLNE2,'(A,I3)') 'Magnetization at point ',IM
  call StatusLine('SINGLE_ANISO: torque: ',STLNE2)
  ! exchange magnetization:
  call MAGN(nss,NM,dX(iM),dY(iM),dZ(iM),H_torq,eso,zJ,THRS,M,S,nT_torq,[T_torq],smagn,W,ZT,ST,MT,m_paranoid,DBG)
  if (dbg) write(u6,'(A,3F18.10)') 'TORQ: MT=',MT(1),MT(2),MT(3)

  !tx(iPl,iM) = (MT(2)*dZ(iM)-MT(3)*dY(iM))*H_torq
  ty(iM) = (MT(3)*dX(iM)-MT(1)*dZ(iM))*H_torq
  !tz(iPl,iM) = (MT(1)*dY(iM)-MT(2)*dX(iM))*H_torq
end do ! iM
!-----------------------------------------------------------------------
! WRITING SOME OF THE OUTPUT....
!-----------------------------------------------------------------------
write(u6,*)
write(u6,'(25X,A)') 'ANGULAR DEPENDENCE OF THE MAGNETIZATION TORQUE'
write(u6,'(30X,A)') '(Units of torque: [energy, cm-1])'
write(u6,*)

write(u6,'(5x,A)') 'Orientation of the applied magnetic field employed:'
write(u6,'(10A)') '--------|','---------------------------|'

write(u6,'(2x,A,10x,A)') 'Angle |','rotation in the XZ plane          |'
write(u6,'(10A)') '--------|','--- proj X ---|','--- proj Y ---|','--- proj Z ---|'
do iM=1,AngPoints
  write(u6,'(F7.3,1x,A,F13.10,1x,A,F13.10,1x,A,F13.10,1x,A,F20.14,1x,A)') Ang(iM),'|',dX(iM),' ',dY(iM),' ',dZ(iM),'|',ty(iM),'|'
end do
write(u6,'(10A)') '--------|','---------------------------|'

write(u6,*)
write(u6,'(10A)') '--------|','---------------------------|'
write(u6,'(A,F9.4,A)') 'Magnetic field strength = ',H_torq,' tesla'
write(u6,'(12x,A,F9.4,A)') 'Temperature = ',T_torq,' kelvin'
write(u6,'(10A)') '--------|','---------------------------|'

write(u6,'(2x,A,3(10x,A))') 'Angle |','rotation in the XZ plane          |'
write(u6,'(10A)') '--------|','-- torque along Y --|'
do iM=1,AngPoints
  write(u6,'(F7.3,1x,A,ES18.10)') Ang(iM),'|',ty(iM)
end do
write(u6,'(10A)') '--------|','---------------------------|'

!-----------------------------------------------------------------------
! deallocate memory for this computation:
call mma_deallocate(W)
call mma_deallocate(dX)
call mma_deallocate(dY)
call mma_deallocate(dZ)
call mma_deallocate(Ang)
call mma_deallocate(ty)
call mma_deallocate(m)
call mma_deallocate(s)

if (dbg) write(u6,*) 'TORQ: allocated memory was sucessfully deallocated'

return

end subroutine torque

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

function ChoMP2_Setup_MemChk(LnT1am,LnPQprod,NumVec,nFrac,nSym,nBatch,Mem)
!
! Thomas Bondo Pedersen, Nov. 2004.
!
! Purpose: Check memory availability.

use ChoMP2, only: Laplace, SOS_mp2
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: ChoMP2_Setup_MemChk
integer(kind=iwp), intent(in) :: nSym, nBatch, LnT1am(nSym,nBatch), LnPQprod(nSym,nBatch), NumVec(nSym), nFrac(nSym), Mem
integer(kind=iwp) :: iBatch, iSym, jBatch, LiPQRSprod(8), LiT2am(8), LnPQRSprod, LnT2am, Nai, NumV
real(kind=wp) :: xDiff, xDim, xInt, xLeft, xMem, xNeed

if (Mem < 1) then
  ChoMP2_Setup_MemChk = .false.
  return
else
  ChoMP2_Setup_MemChk = .true.
end if

if (Laplace .and. SOS_MP2) then
  xMem = real(mem,kind=wp)
  xNeed = Zero
  do iBatch=1,nBatch
    do iSym=1,nSym
      Nai = LnT1am(iSym,iBatch)
      if ((Nai > 0) .and. (NumVec(iSym) > 0)) xNeed = max(xNeed,real(Nai,kind=wp)*real(NumVec(iSym),kind=wp))
    end do
  end do
  xLeft = xMem-xNeed
  if (xLeft < Zero) then
    ChoMP2_Setup_MemChk = .false.
    return
  end if
else
  do iSym=1,nSym
    if (nFrac(iSym) < 1) then
      ChoMP2_Setup_MemChk = .false.
      return
    end if
  end do
  xMem = real(mem,kind=wp)
  do jBatch=1,nBatch
    do iBatch=1,jBatch
      call ChoMP2_Energy_GetInd(LnT2am,LiT2am,iBatch,jBatch)
      if (.false.) call ChoMP2_Energy_GetPQInd(LnPQRSprod,LiPQRSprod,iBatch,jBatch)
      if (.false.) then
        xInt = real(LnPQRSprod,kind=wp)
      else
        xInt = real(LnT2am,kind=wp)
      end if
      xLeft = xMem-xInt
      if ((xInt < One) .or. (xLeft < One)) then
        ChoMP2_Setup_MemChk = .false.
        return
      end if
      do iSym=1,nSym
        if (iBatch == jBatch) then
          if (.false.) then
            xDim = real(LnPQprod(iSym,iBatch),kind=wp)
          else
            xDim = real(LnT1am(iSym,iBatch),kind=wp)
          end if
        else
          if (.false.) then
            xDim = real(LnPQprod(iSym,iBatch))+real(LnPQprod(iSym,iBatch),kind=wp)
          else
            xDim = real(LnT1am(iSym,iBatch))+real(LnT1am(iSym,jBatch),kind=wp)
          end if
        end if
        if (nFrac(iSym) > NumVec(iSym)) then
          NumV = min(NumVec(iSym),1)
        else
          NumV = NumVec(iSym)/nFrac(iSym)
        end if
        xNeed = xDim*real(NumV,kind=wp)
        xDiff = xLeft-xNeed
        if (xDiff < One) then
          ChoMP2_Setup_MemChk = .false.
          return
        end if
      end do
    end do
  end do
end if

end function ChoMP2_Setup_MemChk

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE H0INTSPC(  IH0SPC,  NPTSPC,IOCPTSPC,  NOCTPA,  NOCTPB,
     &                        IOCA,    IOCB,    NGAS, MXPNGAS,INTH0SPC,
     &                      NELFTP)
*
* Set up INTH0SPC : Division of CI space, so only determinants
*                   belonging to the same space  have nonvanishing
*                   matrix elements of H0
*
* =====
* Input
* =====
*
* IH0SPC : ne. 0 : Interacting subspaces have been defined
*          .eq.0 : Interacting subspaces not defined, let
*                  evrything interact
* NPTSPC : Number of subspaces defined
* IOCPTSPC : Allowed occumulated occupation of each subspace
* NOCTPA :  Number of alpha occupation types
* NOCTPB : Number of beta occupation types
* IOCA : Occupation  of alpha string
* IOCB : Occupation  of beta string
*
* Jeppe Olsen, January 1996
*
      IMPLICIT REAL*8 (A-H,O-Z)
*. Input
      DIMENSION IOCPTSPC(2,MXPNGAS,*)
      DIMENSION IOCA(MXPNGAS,*),IOCB(MXPNGAS,*)
      DIMENSION NELFTP(*)
*. Output
      DIMENSION INTH0SPC(NOCTPA,NOCTPB)
*
      IF(IH0SPC.EQ.0) THEN
*. All interactions allowed
        IONE = 1
        CALL ISETVC(INTH0SPC,IONE,NOCTPA*NOCTPB)
      ELSE
*. Explicit construction of matrix giving partitionning of
*  subspaces
        IZERO = 0
        CALL ISETVC(INTH0SPC,IZERO,NOCTPA*NOCTPB)
*
        DO ISPC = 1, NPTSPC
          DO IATP = 1, NOCTPA
            DO IBTP = 1, NOCTPB
              IAMOKAY = 1
              IEL = 0
C?            WRITE(6,*) ' ISPC IATP IBTP ', ISPC,IATP,IBTP
              DO IGAS = 1, NGAS
               IEL = IEL
     &             + NELFTP(IOCA(IGAS,IATP))+NELFTP(IOCB(IGAS,IBTP))
C?             WRITE(6,*) ' IGAS IEL ', IGAS,IEL
C?             WRITE(6,*)
C?   &          ' Limits :',IOCPTSPC(1,IGAS,ISPC),IOCPTSPC(2,IGAS,ISPC)
               IF(IEL.LT.IOCPTSPC(1,IGAS,ISPC).OR.
     &            IEL.GT.IOCPTSPC(2,IGAS,ISPC)    ) IAMOKAY = 0
              END DO
C?            WRITE(6,*) ' IAMOKAY = ', IAMOKAY
*. Allowed
              IF(IAMOKAY.EQ.1.AND.INTH0SPC(IATP,IBTP).EQ.0) THEN
                INTH0SPC(IATP,IBTP) = ISPC
              END IF
            END DO
          END DO
        END DO
      END IF
*
      NTEST = 0
      IF(NTEST.GE.10) THEN
        WRITE(6,*)
        WRITE(6,*) ' ======================'
        WRITE(6,*) ' Output from  H0INTSPC '
        WRITE(6,*) ' ======================'
        WRITE(6,*)
        CALL IWRTMA(INTH0SPC,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
*               2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine PLF_LDF_JK_2P_4(TInt,nTInt,Map,
     &                           AOint,ijkl,iCmp,jCmp,kCmp,lCmp,
     &                           iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*          Modified for Local DF, Thomas Bondo Pedersen, September 2010*
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit None
      Integer nTInt
      Real*8  TInt(nTInt)
      Integer Map(4)
      Integer ijkl, iCmp, jCmp, kCmp, lCmp
      Real*8  AOInt(ijkl,iCmp,jCmp,kCmp,lCmp)
      Integer iAO(4), iAOst(4)
      Integer iBas, jBas, kBas, lBas
      Integer kOp(4)
#include "localdf_bas.fh"
#include "localdf_int2.fh"
#include "WrkSpc.fh"

      Character*15 SecNam
      Parameter (SecNam='PLF_LDF_JK_2P_4')

      Integer i1, i2, i3, i4
      Integer iShlI, iShlJ, iShlK, iShlL
      Integer iSO, jSO, kSO, lSO
      Integer iSOi, jSOj, kSOk, lSOl
      Integer ii, jj, kk, ll
      Integer ij0, ij, kl0, kl
      Integer iShlIJ, iShlKL
      Integer nijkl
      Integer ip

      Integer i, j
      Integer iShlSO
      Integer nBasSh
      Integer iRow
      Integer iCol
#if defined (_DEBUGPRINT_)
      Integer iSOShl
      iSOShl(i)=iWork(ip_iSOShl-1+i)
#endif
      iShlSO(i)=iWork(ip_iShlSO-1+i)
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iRow(i,j)=iWork(ip_AB_IndxG2-1+l_AB_IndxG2_1*(j-1)+i)
      iCol(i,j)=iWork(ip_CD_IndxG2-1+l_CD_IndxG2_1*(j-1)+i)

      If (Map(1).eq.1 .and. Map(2).eq.2 .and.
     &    Map(3).eq.3 .and. Map(4).eq.4) Then
#if defined (_DEBUGPRINT_)
         If (iSOShl(iAOtSO(iAO(1)+1,kOp(1))+iAOst(1)).ne.SHA) Then
            Call WarningMessage(2,SecNam//': Shell problem [1.1]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(2)+1,kOp(2))+iAOst(2)).ne.SHB) Then
            Call WarningMessage(2,SecNam//': Shell problem [2.1]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)).ne.SHC) Then
            Call WarningMessage(2,SecNam//': Shell problem [3.1]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)).ne.SHD) Then
            Call WarningMessage(2,SecNam//': Shell problem [4.1]')
            Call LDF_Quit(1)
         End If
#endif
         iShlI=SHA
         iShlJ=SHB
         iShlK=SHC
         iShlL=SHD
         iShlIJ=SPAB
         iShlKL=SPCD
         Do i4=1,lCmp
            lSO=iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
            Do i3=1,kCmp
               kSO=iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i2=1,jCmp
                  jSO=iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
                  Do i1=1,iCmp
                     iSO=iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
                     nijkl=0
                     Do lSOl=lSO,lSO+lBas-1
                        ll=iShlSO(lSOl)
                        kl0=nBasSh(iShlK)*(ll-1)
                        Do kSOk=kSO,kSO+kBas-1
                           kk=iShlSO(kSOk)
                           kl=kl0+kk
                           If (iCol(kl,iShlKL).gt.0) Then
                              Do jSOj=jSO,jSO+jBas-1
                                 jj=iShlSO(jSOj)
                                 ij0=nBasSh(iShlI)*(jj-1)
                                 Do iSOi=iSO,iSO+iBas-1
                                    ii=iShlSO(iSOi)
                                    ij=ij0+ii
                                    nijkl=nijkl+1
                                    If (iRow(ij,iShlIJ).gt.0) Then
                                       ip=nAB*(iCol(kl,iShlKL)-1)
     &                                   +iRow(ij,iShlIJ)
                                       TInt(ip)=AOInt(nijkl,i1,i2,i3,i4)
                                    End If
                                 End Do
                              End Do
                           Else
                              nijkl=nijkl+iBas*jBas
                           End If
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
      Else If (Map(1).eq.3 .and. Map(2).eq.4 .and.
     &         Map(3).eq.1 .and. Map(4).eq.2) Then
#if defined (_DEBUGPRINT_)
         If (iSOShl(iAOtSO(iAO(1)+1,kOp(1))+iAOst(1)).ne.SHC) Then
            Call WarningMessage(2,SecNam//': Shell problem [1.2]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(2)+1,kOp(2))+iAOst(2)).ne.SHD) Then
            Call WarningMessage(2,SecNam//': Shell problem [2.2]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)).ne.SHA) Then
            Call WarningMessage(2,SecNam//': Shell problem [3.2]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)).ne.SHB) Then
            Call WarningMessage(2,SecNam//': Shell problem [4.2]')
            Call LDF_Quit(1)
         End If
#endif
         iShlI=SHC
         iShlJ=SHD
         iShlK=SHA
         iShlL=SHB
         iShlIJ=SPCD
         iShlKL=SPAB
         Do i4=1,lCmp
            lSO=iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
            Do i3=1,kCmp
               kSO=iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i2=1,jCmp
                  jSO=iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
                  Do i1=1,iCmp
                     iSO=iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
                     nijkl=0
                     Do lSOl=lSO,lSO+lBas-1
                        ll=iShlSO(lSOl)
                        kl0=nBasSh(iShlK)*(ll-1)
                        Do kSOk=kSO,kSO+kBas-1
                           kk=iShlSO(kSOk)
                           kl=kl0+kk
                           If (iRow(kl,iShlKL).gt.0) Then
                              Do jSOj=jSO,jSO+jBas-1
                                 jj=iShlSO(jSOj)
                                 ij0=nBasSh(iShlI)*(jj-1)
                                 Do iSOi=iSO,iSO+iBas-1
                                    ii=iShlSO(iSOi)
                                    ij=ij0+ii
                                    nijkl=nijkl+1
                                    If (iCol(ij,iShlIJ).gt.0) Then
                                       ip=nAB*(iCol(ij,iShlIJ)-1)
     &                                   +iRow(kl,iShlKL)
                                       TInt(ip)=AOInt(nijkl,i1,i2,i3,i4)
                                    End If
                                 End Do
                              End Do
                           Else
                              nijkl=nijkl+iBas*jBas
                           End If
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
      Else
         Call WarningMessage(2,
     &                    SecNam//': Shell combination not implemented')
         Call LDF_Quit(1)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
       SubRoutine Read2_ns(rMO1,rMO2,FockI,FockA,
     &                  Temp1,nTemp,Temp2,Temp3,Temp4,
     &                  DI13,DI24,DI,
     &                  DA13,DA24,DA,
     &                  rkappa,idsym,
     &                  Signa,Fact,jSpin,lfat,lfit,lMOt,CMO)
************************************************************************
*                                        ~     ~                       *
*   Monster routine for construction of Fock, MO                       *
*   Handles non (anti) symmetric orbital rotations                     *
*                                                                      *
*   Input: rkappa : Rotation matrix                                    *
*          idsym  : symmetry of perturbation                           *
*          DIR    : Inactive One electron density                      *
*          DAR    : Inactive One electron density                      *
*                                                                      *
*   Scrtch:Temp1, Temp2,Temp3,Temp4,DR,DL                              *
*                                                                      *
*   Output:                                                            *
*         FockI(A):Fock matrix (one index transformed integrals)       *
*                  ~~                                                  *
*         rMO1    (pj|kl)\     Added together this gives oneindex      *
*                     ~~  -->  transformed integrals. They are         *
*         rMO2    (pj|kl)/     separated to make it easy to go         *
*                              to spindependent perturbations          *
*                                                                      *
*   Remember Coulomb type integrals are used to construct              *
*   exchange part Fock matrix and exchange integrals to construct      *
*   Coulomb part.                                                      *
*                                                                      *
*   Sign  =  1                                                         *
*                                                                      *
*   Sign  = -1  {I,K}=KI+signIK                                        *
*                                                                      *
*   jspin =  0  Fock matrixes and MO's needed for singlet              *
*               perturbations                                          *
*                                                                      *
*   jspin =  1  Fock matrixes and MO's needed for triplet              *
*               perturbations                                          *
*                                                                      *
************************************************************************
      Implicit Real*8(a-h,o-z)
#include "Pointers.fh"
#include "Input.fh"
      Real*8 rkappa(*),FockA(*),FockI(*),
     &       Temp1(ntemp),Temp2(*),
     &       temp3(*),Temp4(*),
     &       rmo1(*),rmo2(*),
     &       CMO(*),DA(*),DI(*),
     &       DA24(*),DI24(*),
     &       DA13(*),DI13(*)
      Parameter ( half  = 0.5d0 )
      Parameter ( One   = 1.0d0 )
      Parameter ( Two   = 2.0d0 )
      Logical lFAt,lFIT,lmot,singlet
*                                                                      *
************************************************************************
*                                                                      *
*  (mn|pq)=sum(o) T  (on|pq) + sign*T  (mo|pq)+T (mn|oq) +sign*T  (mn|po)
*                  mo                no         po              qo
*
*
*   DL = sum(po) D  T   C     (13)
*     bj          ij pi  bp
*
*                     *
*   DR  = sum(qo) D  T  C     (24)
*     ib           ij jp bp
*                                                                      *
************************************************************************
*                                                                      *
      If (jspin.eq.1) Then
        Singlet=.false.
      Else If (jspin.eq.0) Then
        Singlet=.true.
      Else
        Singlet=.false.
        Write(6,*) 'Error jspin=/=1,0'
        Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*                         t
*     Construct ( C* kappa * D )   &   ( C * kappa ) and store it with the
*     general index as the first index and the occupied as the second.
*     The general index is transformed to AO index (contravariant).
*
*                                                                      *
************************************************************************
*                                                                      *
      Do iS=1,nSym
         If (nBas(iS).ne.0) Then
            Do jS=1,nSym
               If (iEOr(iS-1,jS-1)+1.eq.idsym.and.nB(jS).ne.0) Then
*
                  Call DGEMM_('N','N',
     &                        nBas(iS),nB(jS),nB(jS),
     &                        1.0d0,rkappa(ipMat(is,js)),nBas(iS),
     &                        DI(ipCM(js)),nBas(jS),
     &                        0.0d0,DI24(ipMat(iS,jS)),nBas(iS))
*
                  Call DGEMM_('T','N',
     &                        nBas(iS),nB(jS),nB(jS),
     &                        1.0d0,rkappa(ipMat(js,is)),nBas(jS),
     &                        DI(ipCM(js)),nBas(jS),
     &                        0.0d0,DI13(ipMat(iS,jS)),nBas(iS))
*
                  If (iMethod.eq.2) Then
*
                     Call DGEMM_('N','N',
     &                           nBas(iS),nBas(jS),nBas(jS),
     &                           1.0d0,rkappa(ipMat(is,js)),nBas(iS),
     &                           DA(ipCM(js)),nBas(jS),
     &                           0.0d0,DA24(ipMat(iS,jS)),nBas(iS))
*
                     Call DGEMM_('T','N',
     &                           nBas(iS),nBas(jS),nB(jS),
     &                           1.0d0,rKappa(ipMat(js,iS)),nBas(jS),
     &                           DA(ipCM(js)),nBas(js),
     &                           0.0d0,DA13(ipMat(iS,jS)),nBas(iS))
*
                  End If
*
               End If
            End Do
         End If
      End Do
*
      sign=1.0d0
      If (iMethod.eq.2) Call DScal_(ndens2,signa,DA24,1)
      Call DScal_(ndens2,signa,Di24,1)
*                                                                      *
************************************************************************
*                                                                      *
*   Read in integrals                                                  *
*                                                                      *
************************************************************************
*                                                                      *
      Do iS=1,nSym
       Do jS=1,iS
        ijS=iEOr(iS-1,jS-1)+1
        Do kS=1,nSym
         Do lS=1,ks
          If (nBas(iS)*nBas(js)*nBas(kS)*nBAs(ls).ne.0) Then
           If (iEOr(kS-1,lS-1).eq.ijS-1) Then
            Do iB=1,nB(iS)
             nnB=nB(jS)
             If (iS.eq.jS) nnB=iB
             Do jB=1,nnB
*
              Call COUL(lS,kS,iS,jS,iB,jB,Temp2,Temp3)
*
***************************************************************************
*                                                                         *
*       A   C   T   I   V   E      F   O   C   K   M   A   T   R   I   X  *
*                                                                         *
***************************************************************************
*                                       ~
*-----------------Fpj = sum(i,l) Dil (pl|ij) = sum(ilr) Dil Klr (pr|ij) =
*
*                                IJ  I
*                  Fqj=sum(rI)  I  DL
*                                qr  r
*
              If (lFAT) Then
*
                If (iEOr(ls-1,is-1)+1.eq.idsym) Then
                 ipD=ipMat(lS,iS)+nBas(lS)*(ib-1)
                 ipF=ipMat(kS,jS)+nBas(kS)*(jB-1)
                 Call dGeMV_('T',nBas(lS),nBas(kS),
     &                     -Fact*Sign*half,
     &                     Temp2,nBas(lS),DA24(ipD),1,
     &                     One,FockA(ipF),1)
                End If
*
*                                IJ  I
*                  FqJ=sum(rI)  I  DL
*                                rq  r
*
                If (kS.ne.ls.and.(iEOr(kS-1,is-1)+1.eq.iDSym)) Then
                 ipD=ipMat(kS,iS)+nBas(kS)*(ib-1)
                 ipF=ipMat(lS,jS)+nBas(lS)*(jB-1)
                 Call dGeMV_('N', nBas(lS),nBas(kS),-Fact*Sign*half,
     &                     Temp2,nBas(lS),DA24(ipD),1,
     &                     One,FockA(ipF),1)
                End If
*
*                                JI  J
*                  FqI=sum(rJ)  I  DL
*                                qr  r

                If (iS.ne.jS.or.iB.ne.jb) Then
                 If (iEOr(lS-1,js-1)+1.eq.iDSym) Then
                  ipD=ipMat(lS,jS)+nBas(lS)*(jb-1)
                  ipF=ipMat(kS,iS)+nBas(kS)*(iB-1)
                  Call dGeMV_('T',nBas(lS),nBas(kS),-Fact*Sign*half,
     &                      Temp2,nBas(lS),DA24(ipD),1,
     &                      One,FockA(ipF),1)
                 End If
*
*                                 JI  J
*                  Fqr=sum(rJ) = I  DL
*                                 rq  r
*
                 If (kS.ne.ls.and.(iEOr(kS-1,js-1)+1.eq.iDSym)) Then
                  ipD=ipMat(kS,jS)+nBas(kS)*(jb-1)
                  ipF=ipMat(lS,iS)+nBas(lS)*(iB-1)
                  Call dGeMV_('N', nBas(lS),nBas(kS),-Fact*Sign*half,
     &                     Temp2,nBas(lS),DA24(ipD),1,
     &                     One,FockA(ipF),1)
                 End If

                End If
              End If
******************************************************************************
*                                                                            *
*  I   N   A   C   T   I   V   E      F   O   C   K   M   A   T   R   I   X  *
*                                                                            *
******************************************************************************
              If (lFIT) Then
*                                IJ  I
*                  Fqj=sum(rI)  I  DL
*                                qr  r
*
                If (iEOr(ls-1,is-1)+1.eq.idsym) Then
                 ipD=ipMat(lS,iS)+nBas(lS)*(ib-1)
                 ipF=ipMat(kS,jS)+nBas(kS)*(jB-1)
                 Call dGeMV_('T',nBas(lS),nBas(kS),
     &                     -Fact*Sign*half,
     &                     Temp2,nBas(lS),DI24(ipD),1,
     &                     One,FockI(ipF),1)
                End If
*
*                                IJ  I
*                  FqJ=sum(rI)  I  DL
*                                rq  r
*
                If (kS.ne.ls.and.(iEOr(kS-1,is-1)+1.eq.iDSym)) Then
                 ipD=ipMat(kS,iS)+nBas(kS)*(ib-1)
                 ipF=ipMat(lS,jS)+nBas(lS)*(jB-1)
                 Call dGeMV_('N', nBas(lS),nBas(kS),-Fact*Sign*half,
     &                     Temp2,nBas(lS),DI24(ipD),1,
     &                     One,FockI(ipF),1)
                End If

*
*                                JI  J
*                  FqI=sum(rJ)  I  DL
*                                qr  r

                If (iS.ne.jS.or.iB.ne.jb) Then
                 If (iEOr(lS-1,js-1)+1.eq.iDSym) Then
                  ipD=ipMat(lS,jS)+nBas(lS)*(jb-1)
                  ipF=ipMat(kS,iS)+nBas(kS)*(iB-1)
                  Call dGeMV_('T',nBas(lS),nBas(kS),-Fact*Sign*half,
     &                      Temp2,nBas(lS),DI24(ipD),1,
     &                      One,FockI(ipF),1)
                 End If
*
*                                 JI  J
*                  Fqr=sum(rJ) = I  DL
*                                 rq  r
*
                 If (kS.ne.ls.and.(iEOr(kS-1,js-1)+1.eq.iDSym)) Then
                  ipD=ipMat(kS,jS)+nBas(kS)*(jb-1)
                  ipF=ipMat(lS,iS)+nBas(lS)*(iB-1)
                  Call dGeMV_('N', nBas(lS),nBas(kS),-Fact*Sign*half,
     &                     Temp2,nBas(lS),DI24(ipD),1,
     &                     One,FockI(ipF),1)
                 End If

                End If
              End If
*                                                                      *
************************************************************************
*                                                                      *
*            M O !!!
*             ~           ~
*            (pj|kl) &  (pj|kl)
*                                                                      *
************************************************************************
*                                                                      *
              If (LMOT.and.jB.gt.nIsh(js).and.ib.gt.nish(is).and.
     &            (nBas(kS)*nBas(lS).ne.0)) Then
               iib=ib-nIsh(is)
               jjb=jb-nIsh(js)
               Call DGETMO(Temp2,nbas(ls),nbas(ls),nBas(kS),
     &                     Temp4,nbas(ks))
*

               ipS=iEOr(kS-1,idsym-1)+1
                ip1=ipMO(ls,js,is)+
     &             nBas(ips)*nAsh(ls)*((iiB-1)*nAsh(jS)+jjb-1)
                ip2=ipMO(ips,js,is)+
     &             nBas(ls)*nAsh(ips)*((iiB-1)*nAsh(jS)+jjb-1)
                ip3=ipMO(ls,is,js)+
     &             nBas(ips)*nAsh(ls)*((jjB-1)*nAsh(iS)+iib-1)
                ip4=ipMO(ips,is,js)+
     &             nBas(ls)*nAsh(ips)*((jjB-1)*nAsh(iS)+iib-1)
                If (nBas(ips)*nBas(lS).gt.0)
     &          Call DGEMM_('N','N',
     &                      nBas(ips),nBas(ls),nBas(ks),
     &                      1.0d0,rKappa(ipMat(ips,ks)),nBas(ipS),
     &                      Temp4,nBas(ks),
     &                      0.0d0,Temp3,nBas(ips))
*               ~
*              (pl|ij)
*
                If (nBas(ipS)*nAsh(ls).gt.0)
     &          Call DGEADD2(Fact,
     &                       Temp3(nbas(ips)*nish(ls)+1),nbas(ips),'N',
     &                       rmo1(ip1),nbas(ips),'N',
     &                       rmo1(ip1),nbas(ips),nbas(ips),nash(ls))
                If (nBas(lS)*nAsh(ipS).gt.0)
     &          Call DGEADD2(Fact,
     &                       Temp3(nish(ips)+1),nbas(ips),'T',
     &                       rmo2(ip2),nbas(ls),'N',
     &                       rmo2(ip2),nbas(ls),nbas(ls),nash(ips))
*               ~
*              (pl|ji)
*
                If (is.ne.js.or.ib.ne.jb) Then
                 If (nBas(ipS)*nAsh(lS).gt.0)
     &           Call Dgeadd2(Fact,
     &                      Temp3(nbas(ips)*nish(ls)+1),nbas(ips),'N',
     &                      rmo1(ip3),nbas(ips),'N',
     &                      rmo1(ip3),nbas(ips),nbas(ips),nash(ls))
                 If (nBas(ls)*nAsh(ipS).gt.0)
     &           Call Dgeadd2(Fact,
     &                      Temp3(nish(ips)+1),nbas(ips),'T',
     &                      rmo2(ip4),nbas(ls),'N',
     &                      rmo2(ip4),nbas(ls),nbas(ls),nash(ips))
               End If
               If (ks.ne.ls) Then
                 ipS=iEOr(lS-1,idsym-1)+1
                  ip1=ipMO(ks,js,is)+
     &               nBas(ips)*nAsh(ks)*((iiB-1)*nAsh(jS)+jjb-1)
                  ip2=ipMO(ips,js,is)+
     &               nBas(ks)*nAsh(ips)*((iiB-1)*nAsh(jS)+jjb-1)
                  ip3=ipMO(ks,is,js)+
     &               nBas(ips)*nAsh(ks)*((jjB-1)*nAsh(iS)+iib-1)
                  ip4=ipMO(ips,is,js)+
     &               nBas(ks)*nAsh(ips)*((jjB-1)*nAsh(iS)+iib-1)
                  If (nBas(ipS)*nBas(kS).gt.0)
     &            Call DGEMM_('N','T',
     &                        nBas(ips),nBas(ks),nBas(ls),
     &                        1.0d0,rKappa(ipmat(ips,ls)),nBas(ips),
     &                        Temp4,nBas(ks),
     &                        0.0d0,Temp3,nBas(ips))
*               ~
*              (pk|ij)
*
                  If (nBas(ipS)*nAsh(ks).gt.0)
     &            Call Dgeadd2(Fact,
     &                        Temp3(nbas(ips)*nish(ks)+1),nbas(ips),'N',
     &                        rmo1(ip1),nbas(ips),'N',
     &                        rmo1(ip1),nbas(ips),nbas(ips),nash(ks))
                  If (nBas(ks)*nAsh(ips).gt.0)
     &            Call Dgeadd2(Fact,
     &                        Temp3(nish(ips)+1),nbas(ips),'T',
     &                        rmo2(ip2),nbas(ks),'N',
     &                        rmo2(ip2),nbas(ks),nbas(ks),nash(ips))

*               ~
*              (pk|ji)
*

                  If (is.ne.js.or.ib.ne.jb) Then
                   If (nBas(ipS)*nAsh(ks).gt.0)
     &             Call DGEADD2(Fact,
     &                        Temp3(nbas(ips)*nish(ks)+1),nbas(ips),'N',
     &                        rmo1(ip3),nbas(ips),'N',
     &                        rmo1(ip3),nbas(ips),nbas(ips),nash(ks))
                   If (nBas(ks)*nAsh(ips).gt.0)
     &             Call DGEADD2(Fact,
     &                        Temp3(nish(ips)+1),nbas(ips),'T',
     &                        rmo2(ip4),nbas(ks),'N',
     &                        rmo2(ip4),nbas(ks),nbas(ks),nash(ips))
                 End If
               End If ! kl

               ipS=iEOr(lS-1,idsym-1)+1
                ip1=ipMO(ips,js,is)+
     &             nBas(kS)*nAsh(ips)*((iiB-1)*nAsh(jS)+jjb-1)
                ip2=ipMO(ks,js,is)+
     &             nBas(ipS)*nAsh(ks)*((iiB-1)*nAsh(jS)+jjb-1)
                ip3=ipMO(ips,is,js)+
     &             nBas(kS)*nAsh(ips)*((jjB-1)*nAsh(iS)+iib-1)
                ip4=ipMO(ks,is,js)+
     &             nBas(ipS)*nAsh(ks)*((jjB-1)*nAsh(iS)+iib-1)
                If (nBas(ks)*nBas(ips).gt.0)
     &          Call DGEMM_('N','N',
     &                      nBas(ks),nbas(ips),nBas(ls),
     &                      1.0d0,Temp4,nBas(kS),
     &                      rkappa(ipMat(ls,ips)),nBas(ls),
     &                      0.0d0,Temp3,nBas(ks))
*                ~
*              (pl|ji)
*
                If (nBas(ks)*nAsh(ipS).gt.0)
     &          Call DGEADD2(Fact*Signa,
     &                     Temp3(1+nbas(ks)*nish(ips)),nbas(ks),'N',
     &                     rmo1(ip1),nbas(ks),'N',
     &                     rmo1(ip1),nbas(ks),nbas(ks),nash(ips))
                If (nBas(ips)*nAsh(ks).gt.0)
     &          Call DGEADD2(Fact*Signa,
     &                     Temp3(nish(ks)+1),nbas(ks),'T',
     &                     rmo2(ip2),nbas(ips),'N',
     &                     rmo2(ip2),nbas(ips),nbas(ips),nash(ks))
*                ~
*              (pl|ij)
*
                 If (is.ne.js.or.ib.ne.jb) Then
                   If (nBas(ks)*nAsh(ips).gt.0)
     &             Call DGEADD2(Fact*Signa,
     &                          Temp3(1+nbas(ks)*nish(ips)),
     &                          nbas(ks),'N',
     &                          rmo1(ip3),nbas(ks),'N',
     &                          rmo1(ip3),nbas(ks),nbas(ks),nash(ips))
                   If (nBas(ips)*nAsh(ks).gt.0)
     &             Call DGEADD2(Fact*Signa,
     &                          Temp3(nish(ks)+1),nbas(ks),'T',
     &                          rmo2(ip4),nbas(ips),'N',
     &                          rmo2(ip4),nbas(ips),nbas(ips),nash(ks))
               End If

               If (ks.ne.ls) Then
                 ipS=iEOr(kS-1,idsym-1)+1
                  ip1=ipMO(ips,js,is)+
     &               nBas(ls)*nAsh(ips)*((iiB-1)*nAsh(jS)+jjb-1)
                  ip2=ipMO(ls,js,is)+
     &               nBas(ips)*nAsh(ls)*((iiB-1)*nAsh(jS)+jjb-1)
                  ip3=ipMO(ips,is,js)+
     &               nBas(ls)*nAsh(ips)*((jjB-1)*nAsh(iS)+iib-1)
                  ip4=ipMO(ls,is,js)+
     &               nBas(ips)*nAsh(ls)*((jjB-1)*nAsh(iS)+iib-1)
                  If (nBas(ls)*nBas(ips).gt.0)
     &            Call DGEMM_('T','N',
     &                        nBas(ls),nBas(ips),nBas(ks),
     &                        1.0d0,Temp4,nBas(ks),
     &                        rKappa(ipMat(ks,ips)),nBas(ks),
     &                        0.0d0,Temp3,nBas(ls))
*                ~
*              (pk|ij)
*
                  If (nBas(ls)*nAsh(ips).gt.0)
     &            Call Dgeadd2(Fact*Signa,
     &                         Temp3(1+nbas(ls)*nish(ips)),nbas(ls),'N',
     &                         rmo1(ip1),nbas(ls),'N',
     &                         rmo1(ip1),nbas(ls),nbas(ls),nash(ips))
                  If (nBas(ips)*nAsh(ls).gt.0)
     &            Call Dgeadd2(Fact*Signa,
     &                         Temp3(1+nish(ls)),nbas(ls),'T',
     &                         rmo2(ip2),nbas(ips),'N',
     &                         rmo2(ip2),nbas(ips),nbas(ips),nash(ls))
*                ~
*              (pk|ji)
*
                  If (is.ne.js.or.ib.ne.jb) Then
                   If (nBas(ls)*nAsh(ips).gt.0)
     &             Call DGeAdd2(Fact*Signa,
     &                         Temp3(1+nbas(ls)*nish(ips)),nbas(ls),'N',
     &                         rmo1(ip3),nbas(ls),'N',
     &                         rmo1(ip3),nbas(ls),nbas(ls),nash(ips))
                   If (nBas(ips)*nAsh(ls).gt.0)
     &             Call DGeAdd2(Fact*Signa,
     &                         Temp3(1+nish(ls)),nbas(ls),'T',
     &                         rmo2(ip4),nbas(ips),'N',
     &                         rmo2(ip4),nbas(ips),nbas(ips),nash(ls))
                 End If
               End If ! (kl)
*A
*|
*--------NOT DEBUGGED?
               End If ! lmo
*
             End Do
            End Do
          End If
          End If
         End Do
        End Do
       End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Do iS=1,nSym
       Do jS=1,nSym
        ijS=iEOr(iS-1,jS-1)+1
        Do kS=1,nSym
         Do lS=1,nSym
          If (nBas(is)*nBAs(js)*nBas(ks)*nBas(ls).ne.0) Then
          If (iEOr(kS-1,lS-1)+1.eq.ijS) Then
           Do lB=1,nB(lS)
            Do jB=1,nB(jS)
            Call EXCH(is,js,ks,ls,jb,lb,Temp1,Temp2)
*
******************************************************************************
*                                                                            *
*  I   N   A   C   T   I   V   E      F   O   C   K   M   A   T   R   I   X  *
*                                                                            *
******************************************************************************
             If (lFIT) Then
*                       ~
*             Fpi=Dkl(pi|kl)=Dkl Kkr (pi|rl)=
*
*                    il   l
*             F =   I   DR
*              pi    pr   r
*
              If (singlet) Then
               If (iEOr(ks-1,ls-1)+1.eq.idsym) Then
                ipD=ipMat(kS,lS)+nBas(kS)*(lb-1)
                ipF=ipMat(iS,jS)+nBas(iS)*(jB-1)
                Call dGeMV_('N', nBas(iS),nBas(kS),Fact,
     &                     Temp1,nBas(iS),DI13(ipD),1,
     &                     One,FockI(ipF),1)
*
*                       ~
*             Fpi=Dkl(pi|kl)=Dkl Klr (pi|lr)=(Dkl Klr (pi|rl)
*
*                    il   l
*             F =   I   DL
*              pi    pr   r
*

                ipD=ipMat(kS,lS)+nBas(kS)*(lb-1)
                ipF=ipMat(iS,jS)+nBas(iS)*(jB-1)
                Call dGeMV_('N', nBas(iS),nBas(kS),Fact*Sign,
     &                     Temp1,nBas(iS),DI24(ipD),1,
     &                     One,FockI(ipF),1)
               End If
              End If
*                       ~
*             Fpl=Dkj(pj|kl)=Dkj Kkr (pj|rl)
*
*                         jl   j
*                        I   DR
*                         pr   r
              If (iEOr(ks-1,js-1)+1.eq.idsym) Then
               ipD=ipMat(kS,jS)+nBas(kS)*(jb-1)
               ipF=ipMat(iS,lS)+nBas(iS)*(lB-1)
               Call dGeMV_('N', nBas(iS),nBas(kS),-Fact*half,
     &                     Temp1,nBas(iS),DI13(ipD),1,
     &                     One,FockI(ipF),1)


              End If
             End If
******************************************************************************
*                                                                            *
*          A   C   T   I   V   E      F   O   C   K   M   A   T   R   I   X  *
*                                                                            *
******************************************************************************
             If (lFAT) Then
              If (singlet) Then
*                       ~
*             Fpi=Dkl(pi|kl)=Dkl Kkr (pi|rl)=
*
*                    il   l
*             F =   I   DR
*              pi    pr   r
*
               If (iEOr(ks-1,ls-1)+1.eq.idsym) Then
                ipD=ipMat(kS,lS)+nBas(kS)*(lb-1)
                ipF=ipMat(iS,jS)+nBas(iS)*(jB-1)
                Call dGeMV_('N', nBas(iS),nBas(kS),Fact,
     &                     Temp1,nBas(iS),DA13(ipD),1,
     &                     One,FockA(ipF),1)
*
*                       ~
*             Fpi=Dkl(pi|kl)=Dkl Krl (pi|rl)=
*
*                    il   l
*             F =   I   DL
*              pi    pr   r
*

                ipD=ipMat(kS,lS)+nBas(kS)*(lb-1)
                ipF=ipMat(iS,jS)+nBas(iS)*(jB-1)
                Call dGeMV_('N', nBas(iS),nBas(kS),Fact*Sign,
     &                     Temp1,nBas(iS),DA24(ipD),1,
     &                     One,FockA(ipF),1)
               End If
              End If
*                       ~
*             Fpl=Dkj(pj|kl)=Dkj Kkr (pj|rl)
*
*                         jl   j
*                        I   DR
*                         pr   r
              If (iEOr(kS-1,js-1).eq.idsym-1) Then
                ipD=ipMat(kS,jS)+nBas(kS)*(jb-1)
                ipF=ipMat(iS,lS)+nBas(iS)*(lB-1)
                Call dGeMV_('N', nBas(iS),nBas(kS),-Fact*half,
     &                     Temp1,nBas(iS),DA13(ipD),1,
     &                     One,FockA(ipF),1)

              End If
             End If
*                                                                      *
************************************************************************
*                                                                      *
*            M O !!!
*                ~           ~
*            (pj|kl) &  (pj|kl)
*                                                                      *
************************************************************************
*                                                                      *
             If (lmot.and.(nAsh(js)*nAsh(ls).ne.0).and.
     &          ( (jb.gt.nish(js)).and.(lB.gt.nish(ls))) ) Then
              call dcopy_(nBas(iS)*nBas(kS),Temp1,1,Temp3,1)
*                 ~            ~
*             (pj|kl) &   (pj|lk)
*
*              JL                      JL
*             I   k    (iJ|kL)      & I   k    (iJLk)
*              ir  kr                  ir  kr
              ips=iEOR(kS-1,iDsym-1)+1
              If (nBas(is)*nAsh(ipS).ne.0)
     &         Call DGEMM_('N','T',
     &                     nBas(iS),nAsh(ipS),nBas(kS),
     &                     1.0d0,Temp3,nBas(iS),
     &                     rKappa(ipMat(ips,ks)+nish(ips)),nBas(ips),
     &                     0.0d0,Temp4,nBas(iS))
              ija=jB-nIsh(jS)
              ila=lB-nIsh(lS)
*                 ~
*             (pj|kl)
*
              ip2=ipMO(js,ips,ls)+nBas(iS)*(ija-1)+
     &               nBas(is)*nAsh(js)*nAsh(ips)*(ilA-1)
              ip3=ipMO(js,ls,ips)+nBas(iS)*(ija-1)+
     &               nBas(is)*nAsh(js)*(ilA-1)

              ip1=1
              Do ipa=1,nAsh(ips)
               Call DaXpY_(nBas(iS),Fact,Temp4(ip1),1,rMO1(ip2),1)
               Call DaXpY_(nBas(iS),Fact,Temp4(ip1),1,rMO2(ip3),1)
               ip2=ip2+nBas(is)*nAsh(js)
               ip3=ip3+nBas(is)*nAsh(js)*nash(ls)
               ip1=ip1+nBas(is)
              End Do
*                  ~
*             (pj|lk)
*
              If (nBas(iS)*nAsh(ipS).ne.0)
     &         Call DGEMM_('N','N',
     &                     nBas(iS),nAsh(ipS),nBas(kS),
     &                     1.0d0,Temp3,nBas(iS),
     &                     rKappa(ipMat(ks,ips)+nbas(ks)*nish(ips)),
     &                     nBas(ks),
     &                     0.0d0,Temp4,nBas(iS))
              ip2=ipMO(js,ls,ips)+nBas(iS)*(ija-1)+
     &               nBas(is)*nAsh(js)*(ilA-1)
              ip3=ipMO(js,ips,ls)+nBas(iS)*(ija-1)+
     &               nBas(is)*nAsh(js)*nash(ips)*(ilA-1)
              ip1=1
              Do ipa=1,nAsh(ips)
               Call DaXpY_(nBas(iS),Fact*signa,
     &                    Temp4(ip1),1,rMO1(ip2),1)
               Call DaXpY_(nBas(iS),Fact*signa,
     &                    Temp4(ip1),1,rMO2(ip3),1)
               ip2=ip2+nBas(is)*nAsh(js)*nAsh(lS)
               ip3=ip3+nBas(is)*nAsh(js)
               ip1=ip1+nBas(is)
              End Do
             End If
*
            End Do
           End Do
          End If
          End If
         End Do
        End Do
       End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(CMO)
      End If
      End
      Subroutine dgeAdd2(r,A,LDA,FORMA,B,LDB,FORMB,C,LDC,M,N)
C
C     MATRIX Addition FOR GENERAL MATRICES
C
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*1 FORMA,FORMB
      REAL*8 A(*), B(*), C(*)

      IF (FORMA.EQ.'N' .AND. FORMB.EQ.'N') THEN
         Do 10 iRow=0,m-1
         Do 11 iCol=0,n-1
            c(iRow+iCol*ldc+1)=r*a(iRow+iCol*lda+1)+b(iRow+iCol*ldb+1)
   11    Continue
   10    Continue
      ELSE IF (FORMA.EQ.'T' .AND. FORMB.EQ.'N') THEN
         Do 20 iRow=0,m-1
         Do 21 iCol=0,n-1
            c(iRow+iCol*ldc+1)=r*a(iCol+iRow*lda+1)+b(iRow+iCol*ldb+1)
   21    Continue
   20    Continue
      ELSE IF (FORMA.EQ.'N' .AND. FORMB.EQ.'T') THEN
         Do 30 iRow=0,m-1
         Do 31 iCol=0,n-1
            c(iRow+iCol*ldc+1)=r*a(iRow+iCol*lda+1)+b(iCol+iRow*ldb+1)
   31    Continue
   30    Continue
      ELSE IF (FORMA.EQ.'T' .AND. FORMB.EQ.'T') THEN
         Do 40 iRow=0,m-1
         Do 41 iCol=0,n-1
            c(iRow+iCol*ldc+1)=r*a(iCol+iRow*lda+1)+b(iCol+iRow*ldb+1)
   41    Continue
   40    Continue
      ELSE
         Write(6,*) FORMA,FORMB
         Call Abend()
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2g_Tra_1(COrb1,COrb2,Diag,DoDiag,Wrk,lWrk,iSym,iMoType1,iMoType2)
!
! Thomas Bondo Pedersen, Dec. 2010.
!
! Purpose: transform Cholesky vectors to (pq) MO basis for symmetry
!          block iSym. Files are assumed open.
!          If requested (DoDiag=.true.), compute (pq|pq) integral
!          diagonal.

use Cholesky, only: InfVec, nnBstR, NumCho
use ChoMP2, only: iAdrOff, lUnit_F, nAdrOff, nMoAo, nMoMo, nMoType
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: COrb1(*), COrb2(*)
integer(kind=iwp), intent(in) :: lWrk, iSym, iMoType1, iMoType2
real(kind=wp), intent(_OUT_) :: Diag(*)
logical(kind=iwp), intent(in) :: DoDiag
real(kind=wp), intent(out) :: Wrk(lWrk)
integer(kind=iwp) :: iAdr, iBat, iLoc, iOpt, irc, iRed, iRedC, iVec, iVec1, iVec2, iVecType, jNum, jVec, jVec1, kChoAO, kChoMO, &
                     kEnd0, kHlfTr, kOff, kOffMO, lChoAO, lChoMO, lHlfTr, lRead, lWrk0, lWrk1, mUsed, nMOVec, NumBat, NumV
character(len=*), parameter :: SecNam = 'ChoMP2_Tra_1'
integer(kind=iwp), external :: Cho_lRead

! Check what type of Cholesky vector to make (fro-occ, occ-occ.....)
iVecType = iMoType2+(iMoType1-1)*nMoType

! Check if anything to do.
! ------------------------

if ((NumCho(iSym) < 1) .or. (nMoMo(iSym,iVecType) < 1)) return

! Initialize Diag (if needed).
! ----------------------------

if (DoDiag) Diag(1:nMoMo(iSym,iVecType)) = Zero

! Allocate memory for half-transformed vector.
! --------------------------------------------

lHlfTr = nMoAo(iSym,iMoType1)

kHlfTr = 1
kEnd0 = kHlfTr+lHlfTr
lWrk0 = lWrk-kEnd0+1
if (lWrk0 < (nMoMo(iSym,iVecType)+nnBstR(iSym,1))) call SysAbendMsg(SecNam,'insufficient memory','[0]')

! Reserve memory for reading AO vectors.
! --------------------------------------

lRead = Cho_lRead(iSym,lWrk0)
if (lRead < 1) then
  write(u6,*) SecNam,': memory error: lRead = ',lRead
  call SysAbendMsg(SecNam,'memory error',' ')
  lWrk1 = 0 ! to avoid compiler warnings...
else
  lWrk1 = lWrk0-lRead
  if (lWrk1 < nMoMo(iSym,iVecType)) then
    lWrk1 = nMoMo(iSym,iVecType)
    lRead = lWrk-nMoMo(iSym,iVecType)
  end if
end if

! Set up batch.
! -------------

nMOVec = min(lWrk1/nMoMo(iSym,iVecType),NumCho(iSym))
if (nMOVec < 1) call SysAbendMsg(SecNam,'insufficient memory','[1]')
NumBat = (NumCho(iSym)-1)/nMOVec+1

! Set reduced set handles.
! ------------------------

iRedC = -1
iLoc = 3

! Transform each batch of vectors and compute diagonal contributions
! (if requested).
! ------------------------------------------------------------------

do iBat=1,NumBat

  if (iBat == NumBat) then
    NumV = NumCho(iSym)-nMOVec*(NumBat-1)
  else
    NumV = nMOVec
  end if
  iVec1 = nMOVec*(iBat-1)+1
  iVec2 = iVec1+NumV-1

  lChoMO = nMoMo(iSym,iVecType)*NumV

  kChoMO = kEnd0
  kChoAO = kChoMO+lChoMO
  lChoAO = lWrk0-kChoAO+1

  kOffMO = kChoMO
  jVec1 = iVec1
  do while (jVec1 <= iVec2)

    jNum = 0
    call Cho_VecRd(Wrk(kChoAO),lChoAO,jVec1,iVec2,iSym,jNum,iRedC,mUsed)
    if (jNum < 1) call SysAbendMsg(SecNam,'insufficient memory','[2]')

    kOff = kChoAO
    do jVec=1,jNum
      iVec = jVec1+jVec-1
      iRed = InfVec(iVec,2,iSym)
      if (iRedC /= iRed) then
        irc = 0
        call Cho_X_SetRed(irc,iLoc,iRed)
        if (irc /= 0) call SysAbendMsg(SecNam,'error in Cho_X_SetRed',' ')
        iRedC = iRed
      end if

      call ChoMP2g_TraVec(Wrk(kOff),Wrk(kOffMO),COrb1,COrb2,Wrk(kHlfTr),lHlfTr,iSym,1,1,iLoc,iMoType1,iMoType2)
      kOff = kOff+nnBstR(iSym,iLoc)
      kOffMO = kOffMO+nMoMo(iSym,iVecType)
    end do

    jVec1 = jVec1+jNum

  end do

  iOpt = 1
  iAdr = nAdrOff(iSym)+nMoMo(iSym,iVecType)*(iVec1-1)+1
  iAdrOff(iSym,iVecType) = nAdrOff(iSym)
  call ddaFile(lUnit_F(iSym,1),iOpt,Wrk(kChoMO),lChoMO,iAdr)

  if (DoDiag) then
    do iVec=1,NumV
      kOff = kChoMO+nMoMo(iSym,iVecType)*(iVec-1)-1
      Diag(1:nMoMo(iSym,iVecType)) = Diag(1:nMoMo(iSym,iVecType))+Wrk(kOff+1:kOff+nMoMo(iSym,iVecType))**2
    end do
  end if

end do
! When we reach this point we have written all vectors of the present
! type for this symmetry and need to remember were we should continue
! to write the next type.
if (iVecType /= 9) nAdrOff(iSym) = iAdr-1

end subroutine ChoMP2g_Tra_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine ChkInp_ccsort
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Check input for consistency                                      *
*                                                                      *
************************************************************************

       Implicit Real*8 (A-H,O-Z)

#include "ccsort.fh"
#include "motra.fh"
*
c
c      Just print warning...
       If ( IPT2.eq.0 ) then
         Write(6,*)
         Write(6,*) '       !!!!!WARNING!!!!!'
         Write(6,*)
         Write(6,*) '      *** input error ***'
         Write(6,*) '  The JOBIPH file does not include '//
     &                 'canonical orbitals'
         Write(6,*)
         Write(6,*) '       !!!!!WARNING!!!!!'
         Write(6,*)
c        Call Quit_OnUserError()
       End If
c
       If ( NCONF.ne.1 ) then
         Write(6,*)
         Write(6,*) '  *** input error ***'
         Write(6,*) '  The JOBIPH file does not include '//
     &                 'a RHF or ROHF wave function'
         Write(6,*)
         Call Quit_OnUserError()
       End If
*
       iErr = 0
       If ( nSym.ne.nSymX ) iErr = 1
       Do iSym = 1,nSym
         If ( nBas(iSym).ne.nBasX(iSym) ) iErr = 1
       End Do
       If ( iErr.ne.0 ) then
         Write(6,*)
         Write(6,*) '  *** input error ***'
         Write(6,*) '  The JOBIPH and the TRAONE files '//
     &                 'are inconsistent'
         Write(6,*)
         Call Quit_OnUserError()
       End If
*
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine tuneinp_cvb()

use casvb_global, only: alftol, cnrmtol, delopth1, delopth2, dfx, dfxmin, dfxtol, dx, eigwrngtol, endwhenclose, exp12tol, follow, &
                        grd, grdwrngtol, hhaccfac, hhrejfac, hhstart, hhtol, mxdav, nopth1, nopth2, nortiter, orththr, resthr, &
                        safety, scalesmall, sgn, signtol, singul, zzacclim, zzmax, zzmin, zzrejmax, zzrejmin

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, iaux(1), istr, istr2, j, nread
real(kind=wp) :: daux(1)
integer(kind=iwp), parameter :: ncmp = 8, nstrin = 37
character(len=*), parameter :: string(nstrin) = ['CNRMTOL ','SAFETY  ','SIGNTOL ','ALFTOL  ','DFXTOL  ','EXP12TOL','GRDWRNGT', &
                                                 'EIGWRNG ','SINGUL  ','DFX     ','SIGN    ','ZZMAX   ','ZZMIN   ','DX      ', &
                                                 'GRD     ','NOPTH1  ','NOPTH2  ','DELOPTH1','DELOPTH2','HHREJFAC','HHACCFAC', &
                                                 'ZZACCLIM','HHTOL   ','DFXMIN  ','ZZREJMIN','ZZREJMAX','SCALESMA','HHSTART ', &
                                                 'RESTHR  ','NORTITER','ORTHTHR ','FOLLOW  ','MXDAV   ','LASTUPD ','ENDIFCLO', &
                                                 'ENDTUNE ','END     '], &
                               true(1) = ['T']

do
  call fstring_cvb(string,nstrin,istr,ncmp,2)
  if ((istr == 36) .or. (istr == 37)) then
    !'ENDTUNE' or 'END'
    istr = 0
  end if
  if (istr == 1) then
    ! 'CNRMTOL'
    call real_cvb(daux,1,nread,1)
    cnrmtol = daux(1)
  else if (istr == 2) then
    ! 'SAFETY'
    call real_cvb(daux,1,nread,1)
    safety = daux(1)
  else if (istr == 3) then
    ! 'SIGNTOL'
    call real_cvb(daux,1,nread,1)
    signtol = daux(1)
  else if (istr == 4) then
    ! 'ALFTOL'
    call real_cvb(daux,1,nread,1)
    alftol = daux(1)
  else if (istr == 5) then
    ! 'DFXTOL'
    call real_cvb(daux,1,nread,1)
    dfxtol = daux(1)
  else if (istr == 6) then
    ! 'EXP12TOL'
    call real_cvb(daux,1,nread,1)
    exp12tol = daux(1)
  else if (istr == 7) then
    ! 'GRDWRNGT'
    call real_cvb(daux,1,nread,1)
    grdwrngtol = daux(1)
  else if (istr == 8) then
    ! 'EIGWRNG '
    call real_cvb(daux,1,nread,1)
    eigwrngtol = daux(1)
  else if (istr == 9) then
    ! 'SINGUL'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 3)) then
      write(u6,*) ' Illegal I index in SINGUL :',i
      call abend_cvb()
    end if
    call real_cvb(singul(i),1,nread,1)
  else if (istr == 10) then
    ! 'DFX'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 6)) then
      write(u6,*) ' Illegal I index in DFX :',i
      call abend_cvb()
    end if
    call real_cvb(dfx(i),1,nread,1)
  else if (istr == 11) then
    ! 'SIGN'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 6)) then
      write(u6,*) ' Illegal I index in SIGN :',i
      call abend_cvb()
    end if
    call real_cvb(sgn(i),1,nread,1)
  else if (istr == 12) then
    ! 'ZZMAX'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 6)) then
      write(u6,*) ' Illegal I index in ZZMAX :',i
      call abend_cvb()
    end if
    call real_cvb(zzmax(i),1,nread,1)
  else if (istr == 13) then
    ! 'ZZMIN'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 6)) then
      write(u6,*) ' Illegal I index in ZZMIN :',i
      call abend_cvb()
    end if
    call real_cvb(zzmin(i),1,nread,1)
  else if (istr == 14) then
    ! 'DX'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 3)) then
      write(u6,*) ' Illegal I index in DX :',i
      call abend_cvb()
    end if
    call int_cvb(iaux,1,nread,1)
    j = iaux(1)
    if ((j < 1) .or. (j > 6)) then
      write(u6,*) ' Illegal J index in DX :',j
      call abend_cvb()
    end if
    call real_cvb(dx(i,j),1,nread,1)
  else if (istr == 15) then
    ! 'GRD'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 3)) then
      write(u6,*) ' Illegal I index in GRD :',i
      call abend_cvb()
    end if
    call int_cvb(iaux,1,nread,1)
    j = iaux(1)
    if ((j < 1) .or. (j > 6)) then
      write(u6,*) ' Illegal J index in GRD :',j
      call abend_cvb()
    end if
    call real_cvb(grd(i,j),1,nread,1)
  else if (istr == 16) then
    ! 'NOPTH1'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in NOPTH1 :',i
      call abend_cvb()
    end if
    call int_cvb(nopth1(i),1,nread,1)
  else if (istr == 17) then
    ! 'NOPTH2'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in NOPTH2 :',i
      call abend_cvb()
    end if
    call int_cvb(nopth2(i),1,nread,1)
  else if (istr == 18) then
    ! 'DELOPTH1'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in DELOPTH1 :',i
      call abend_cvb()
    end if
    call real_cvb(delopth1(i),1,nread,1)
  else if (istr == 19) then
    ! 'DELOPTH2'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in DELOPTH2 :',i
      call abend_cvb()
    end if
    call real_cvb(delopth2(i),1,nread,1)
  else if (istr == 20) then
    ! 'HHREJFAC'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in HHREJFAC :',i
      call abend_cvb()
    end if
    call real_cvb(hhrejfac(i),1,nread,1)
  else if (istr == 21) then
    ! 'HHACCFAC'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 5)) then
      write(u6,*) ' Illegal I index in HHACCFAC :',i
      call abend_cvb()
    end if
    call int_cvb(iaux,1,nread,1)
    j = iaux(1)
    if ((j < 1) .or. (j > 2)) then
      write(u6,*) ' Illegal J index in HHACCFAC :',j
      call abend_cvb()
    end if
    call real_cvb(hhaccfac(i,j),1,nread,1)
  else if (istr == 22) then
    ! 'ZZACCLIM'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 4)) then
      write(u6,*) ' Illegal I index in ZZACCLIM :',i
      call abend_cvb()
    end if
    call int_cvb(iaux,1,nread,1)
    j = iaux(1)
    if ((j < 1) .or. (j > 2)) then
      write(u6,*) ' Illegal J index in ZZACCLIM :',j
      call abend_cvb()
    end if
    call real_cvb(zzacclim(i,j),1,nread,1)
  else if (istr == 23) then
    ! 'HHTOL'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in HHTOL :',i
      call abend_cvb()
    end if
    call real_cvb(hhtol(i),1,nread,1)
  else if (istr == 24) then
    ! 'DFXMIN'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in DFXMIN :',i
      call abend_cvb()
    end if
    call real_cvb(dfxmin(i),1,nread,1)
  else if (istr == 25) then
    ! 'ZZREJMIN'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in ZZREJMIN :',i
      call abend_cvb()
    end if
    call real_cvb(zzrejmin(i),1,nread,1)
  else if (istr == 26) then
    ! 'ZZREJMAX'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in ZZREJMAX :',i
      call abend_cvb()
    end if
    call real_cvb(zzrejmax(i),1,nread,1)
  else if (istr == 27) then
    ! 'SCALESMALL'
    call int_cvb(iaux,1,nread,1)
    i = iaux(1)
    if ((i < 1) .or. (i > 2)) then
      write(u6,*) ' Illegal I index in SCALESMALL :',i
      call abend_cvb()
    end if
    call fstring_cvb(true,1,istr2,1,1)
    scalesmall(i) = (istr2 == 1)
  else if (istr == 28) then
    ! 'HHSTART'
    call real_cvb(daux,1,nread,1)
    hhstart = daux(1)
  else if (istr == 29) then
    ! 'RESTHR'
    call real_cvb(daux,1,nread,1)
    resthr = daux(1)
  else if (istr == 30) then
    ! 'NORTITER'
    call int_cvb(iaux,1,nread,1)
    nortiter = iaux(1)
  else if (istr == 31) then
    ! 'ORTHTHR'
    call real_cvb(daux,1,nread,1)
    orththr = daux(1)
  else if (istr == 32) then
    ! 'FOLLOW'
    call fstring_cvb(true,1,istr2,1,1)
    follow = (istr2 == 1)
  else if (istr == 33) then
    ! 'MXDAV'
    call int_cvb(iaux,1,nread,1)
    mxdav = iaux(1)
  !else if (istr == 34) then
  !  ! 'LASTUPD'
  !  call fstring_cvb(true,1,istr2,1,1)
  !  lastupd = (istr2 == 1)
  else if (istr == 35) then
    ! 'ENDIFCLOSE'
    call fstring_cvb(true,1,istr2,1,1)
    endwhenclose = (istr2 == 1)
  end if
  ! 'END', 'ENDTUNE' or unrecognized keyword -- end of input:
  if (istr == 0) exit
end do

return

end subroutine tuneinp_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ZBASE(NVEC,IVEC,NCLASS)
! Some class division exists with NVEC(ICLASS) members in
! class ICLASS.
!
! Construct array IVEC(ICLASS) giving first element of
! class ICLASS in full addressing

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NCLASS, NVEC(NCLASS)
integer(kind=iwp), intent(out) :: IVEC(NCLASS)
integer(kind=iwp) :: ICLASS

do ICLASS=1,NCLASS
  if (ICLASS == 1) then
    IVEC(1) = 1
  else
    IVEC(ICLASS) = IVEC(ICLASS-1)+NVEC(ICLASS-1)
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,'(A)') '  ZBASE : NVEC and IVEC'
write(u6,'(A)') '  ====================='
call IWRTMA(NVEC,1,NCLASS,1,NCLASS)
call IWRTMA(IVEC,1,NCLASS,1,NCLASS)
#endif

return

end subroutine ZBASE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ZeroBlockMatrix(ip_Blocks)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Zero block matrix.
C
      Implicit None
      Integer ip_Blocks
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Integer iAtomPair
      Integer iAtom, jAtom
      Integer ip, l

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      Do iAtomPair=1,NumberOfAtomPairs
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         l=LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
         ip=iWork(ip_Blocks-1+iAtomPair)
         Call Cho_dZero(Work(ip),l)
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_WrDiag()
!
! Purpose: store global diagonal on disk (Parallel only).
!          NB: on exit, initial global diagonal is stored!

use Cholesky, only: Cho_Real_Par, Diag_G, nnBstRT
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp

implicit none
real(kind=wp), allocatable :: Diag_L(:)

if (Cho_Real_Par) then
  call mma_allocate(Diag_L,nnBstRT(1),Label='Diag_L')
  call Cho_IODiag(Diag_L,2)
  call Cho_P_SyncDiag(Diag_L,1)
  call Cho_P_IndxSwp()
  call Cho_IODiag(Diag_G,1)
  call Cho_P_IndxSwp()
  call mma_deallocate(Diag_L)
end if

end subroutine Cho_P_WrDiag

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine putguess_cvb(orbs,cvb,recn)
      implicit real*8 (a-h,o-z)
      logical use_ao,ifmos_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
#include "mo_cvb.fh"
      dimension orbs(norb,*),cvb(*)

      call wrheader_cvb(recn,norb,nbas_mo,nvb,kbasiscvb,
     >  ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)
      call rdheader_cvb(recn,norb1,nbas_mo1,nvb1,kbasiscvb1,
     >  ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)
      do 100 iorb=1,norb
      call wrgspr_cvb(recn,orbs(1,iorb),iorb,norb,1,ierr)
100   continue
      call wrgspr_cvb(recn,cvb,1,nvb,2,ierr)
      use_ao=(ifmos_cvb().and.((.not.variat).or.(variat.and.
     >  endvar)))
      if(use_ao)then
        iorbsao = mstackr_cvb(nbas_mo*norb)
        call mo2ao_cvb(orbs,work(iorbsao),norb)
        do 200 iorb=1,norb
        call wrgspr_cvb(recn,work((iorb-1)*nbas_mo+iorbsao),
     >    iorb,nbas_mo,3,ierr)
200     continue
        if(ip(5).ge.2)then
          write(6,'(/,a)')' VB orbitals in AO basis :'
          write(6,'(a)')  ' -------------------------'
          call mxprint_cvb(work(iorbsao),nbas_mo,norb,0)
        endif
        if(ploc)then
          i1 = mstackr_cvb(norb*norb)
          i2 = mstackr_cvb(norb*norb)
          i3 = mstackr_cvb(norb)
          !call getr_plc(work(i1))
          call getr_plc()
          call transp_cvb(work(i1),work(i1),norb,norb)
          call mxatb_cvb(work(i1),orbs,norb,norb,norb,work(i2))
          call lmo2ao_cvb(work(i2),work(iorbsao),norb)
          do 300 iorb=1,norb
          call wrgspr_cvb(recn,work((iorb-1)*nbas_mo+iorbsao),
     >      iorb,nbas_mo,4,ierr)
300       continue
          if(ip(5).ge.2)then
            write(6,'(/,a)')
     >        ' Original localized VB orbitals in AO basis :'
            write(6,'(a)')
     >        ' --------------------------------------------'
            call mxprint_cvb(work(iorbsao),nbas_mo,norb,0)
          endif
          do 400 i=1,norb
          work(i+i3-1)=dnrm2_(norb,work((i-1)*norb+i2),1)
          call dscal_(norb,1d0/work(i+i3-1),work((i-1)*norb+i2),1)
400       continue
          if(ip(5).ge.2)then
            write(6,'(/,a)')' Norms of original localized VB orbitals :'
            write(6,'(a)')  ' -----------------------------------------'
            call mxprint_cvb(work(i3),1,norb,0)
          endif
          call mfreer_cvb(i1)
        endif
        call mfreer_cvb(iorbsao)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDFSCF_Drv(iUHF,nSym,nBas,DSQ,DLT,DSQ_ab,DLT_ab,
     &                      FLT,FLT_ab,nFLT,ExFac,LWFSQ,LWFSQ_ab,
     &                      nOcc,nOcc_ab)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: compute two-electron contributions to the SCF Fock matrix
C              using Local Density Fitting (LDF) coefficients.
C
      Implicit None
      Integer iUHF, nSym, nFLT, LWFSQ, LWFSQ_ab
      Integer nBas(nSym), nOcc(nSym), nOcc_ab(nSym)
      Real*8  DSQ(*), DLT(*)
      Real*8  DSQ_ab(*), DLT_ab(*)
      Real*8  FLT(*), FLT_ab(*)
      Real*8  ExFac
#include "WrkSpc.fh"
#include "ldfscf.fh"
#include "localdf.fh"

      Real*8   LDF_Charge, LDF_FittedCharge, dDot_
      External LDF_Charge, LDF_FittedCharge, dDot_

      Integer  ip_of_Work, iPrintLevel
      External ip_of_Work, iPrintLevel
#if defined (_DEBUGPRINT_)
      Logical  LDF_X_IsSet
      External LDF_X_IsSet
#endif

      Character*6  RegNam
      Character*10 SecNam
      Parameter (RegNam='LDFSCF')
      Parameter (SecNam=RegNam//'_Drv')

      Real*8 Tol2C
      Real*8 Tol_ModeCheck
      Parameter (Tol2C=1.0d-14)
      Parameter (Tol_ModeCheck=1.0d-10)

      Logical Timing

      Integer Mode, IntegralOption

      Integer nDen_Max
      Parameter (nDen_Max=3)

      Real*8  ThrPS(2)
      Real*8  FactC(nDen_Max)
      Real*8  FactX(nDen_Max)
      Integer ip_D(nDen_Max)
      Integer ip_F(nDen_Max)

      Integer nDen
      Integer u, v, uv
      Integer iPrint
      Integer irc
      Integer ip_UBFNorm, l_UBFNorm
      Integer ipF, lF, ipF2
      Integer ip_myF, l_myF
      Integer iDen
      Integer AB_MAE, AB_MRNrm
      Integer lMode
      Integer n

      Logical Add
      Logical PackedD
      Logical PackedF
      Logical ComputeF

      Logical QuitOnError
      Logical Silent

      Real*8  MAE, MRNrm, Q, deltaQ
      Real*8  Q_LDF
      Real*8  MaxErr, MaxAbsErr, AverageErr, RMSErr
      Real*8  MaxErr_OffD, MaxAbsErr_OffD
      Real*8  DiffNorm, DiffSum
      Real*8  ConvNorm, LDFNorm
      Real*8  ConvSum, LDFSum
      Real*8  FNorm, factor

      Integer i, j
      Integer iTri
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

#if defined (_DEBUGPRINT_)
      ! Enter
#endif
      Call ThisIsRestrictedCode('Thomas Bondo Pedersen','LDF-SCF',
     &                          .false.)

      ! Get print level
#if defined (_DEBUGPRINT_)
      iPrint=max(iPrintLevel(-1),4)
#else
      iPrint=iPrintLevel(-1)
#endif

      ! Print entry message
      If (iPrint.ge.3) Then
         Call Cho_Head('Enter '//SecNam,'-',80,6)
      End If

      ! Symmetry not implemented for LDF
      If (nSym.ne.1) Then
         Call WarningMessage(2,
     &                     SecNam//': Symmetry not implemented for LDF')
         Call LDF_Quit(1)
      End If
*
      Call Set_Basis_Mode('WithAuxiliaryr')
      Call Setup_iSD()

#if defined (_DEBUGPRINT_)
      If (.not.LDF_X_IsSet()) Then
         Call WarningMessage(2,SecNam//': LDF info not set!')
         Call LDF_Quit(1)
      End If
#endif

      ! Debug option: print charge
      If (LDF_ChargePrint) Then
         PackedD=.False.
         ip_D(1)=ip_of_Work(DSQ(1))
         Q=LDF_Charge(PackedD,ip_D(1))
         Q_LDF=LDF_FittedCharge(PackedD,ip_D(1))
         Write(6,'(/,A,A,1P,D20.10,2(2X,A,D20.10))')
     &   SecNam,': Q=',Q,'Q_LDF=',Q_LDF,'Error=',Q_LDF-Q
         Call xFlush(6)
         If (Q.lt.0.0d0 .or. Q_LDF.lt.0.0d0) Then
            Call WarningMessage(2,SecNam//': this is unphysical!')
            Call LDF_Quit(1)
         End If
      End If

      ! Integral representation?
      Mode=LDF_IntegralMode
      ! Time the Fock build?
      Timing=LDF_Timing .or. iPrint.ge.3
      ! Set integral handling (options)
      If (LDF_UseLDFIntegrals) Then
         IntegralOption=111
      Else If (LDF_UseConventionalIntegrals) Then
         IntegralOption=222
      Else If (LDF_UsePSDIntegrals) Then
         IntegralOption=333
      Else If (LDF_UseExactIntegralDiagonal) Then
         IntegralOption=444
      Else
         IntegralOption=0
      End If
      ! Determine integral and contribution prescreening thresholds
      If (LDF_IntegralPrescreening.lt.0.0d0) Then
         LDF_IntegralPrescreening=min(abs(Thr_Accuracy)*1.0d-2,1.0d-8)
         If (iPrint.ge.4) Then
            Write(6,'(A,1P,D15.6)')
     &      'Setting default Integral Prescreeening threshold:    ',
     &      LDF_IntegralPrescreening
            Call xFlush(6)
         End If
      End If
      If (LDF_ContributionPrescreening.lt.0.0d0) Then
         LDF_ContributionPrescreening=min(abs(Thr_Accuracy)*1.0d-1,
     &                                                           1.0d-6)
         If (iPrint.ge.4) Then
            Write(6,'(A,1P,D15.6)')
     &      'Setting default Contribution Prescreeening threshold:',
     &      LDF_ContributionPrescreening
            Call xFlush(6)
         End If
      End If
      ! Set prescreening thresholds to pass to Fock calculator
      ThrPS(1)=LDF_IntegralPrescreening
      ThrPS(2)=LDF_ContributionPrescreening

      ! Debug: check that full integral matrix is PSD (if requested)
      ! Note: this is only done in first call to this routine
      !       (unless flag is reset outside)
      If (LDF_IntegralPSDCheck.gt.0) Then
         Call WarningMessage(0,
     &                    SecNam//': Checking full integral matrix PSD')
         If (LDF_UseExactIntegrals.eq.1) Then
            Write(6,'(A)')
     &      'Using exact diagonal blocks of the integral matrix'
         Else If (LDF_UseExactIntegrals.eq.2) Then
            Write(6,'(A)')
     &      'Using exact off-diagonal blocks of the integral matrix'
         End If
         Call xFlush(6)
         Call LDF_CheckPSD_Full(LDF_IntegralPSDCheck.eq.1,Mode,
     &                          LDF_UseExactIntegrals,ThrPS(1),irc)
         If (irc.ne.0) Then
            Call WarningMessage(0,
     &                         SecNam//': full integral matrix NOT PSD')
         Else
            Call WarningMessage(0,SecNam//': full integral matrix PSD')
         End If
         Call xFlush(6)
         LDF_IntegralPSDCheck=-1
      End If

      ! Debug: check fitting coefficients (if requested)
      ! Note: this is only done in first call to this routine
      !       (unless flag is reset outside)
      If (LDF_CoefficientCheck) Then
         Call WarningMessage(0,SecNam//': Checking coefficients')
         Call xFlush(6)
         Call LDF_CheckAllC_wLD(iPrint.ge.3)
         Write(6,'(/,A)') 'Coefficient check completed: all OK!'
         Call xFlush(6)
         LDF_CoefficientCheck=.False.
      End If

      ! Debug: check overlap integrals (if requested)
      ! Note: this is only done in first call to this routine
      !       (unless flag is reset outside)
      If (LDF_OverlapCheck) Then
         Call WarningMessage(0,SecNam//': Checking overlap integrals')
         Call LDF_CheckAllOverlapIntegrals(iPrint.ge.3,Tol2C,
     &                                     MAE,AB_MAE,MRNrm,AB_MRNrm)
         If (iPrint.lt.3) Then
            Write(6,'(/,2X,A,1P,D20.10,2X,A)')
     &      'Tolerance for 2C errors..',Tol2C,'(all 2C passed)'
            Write(6,'(2X,A,1P,D20.10,2X,A,I10)')
     &      'Max abs error............',MAE,'@AB=',AB_MAE
            Write(6,'(2X,A,1P,D20.10,2X,A,I10)')
     &      'Max relative norm error..',MRNrm,'@AB=',AB_MRNrm
         End If
         Write(6,'(/,A)') 'Overlap check completed: 2C OK!'
         Call xFlush(6)
         LDF_OverlapCheck=.False.
      End If

      ! Debug: verify fit for each atom pair (if requested)
      ! Note: this is only done in first call to this routine
      !       (unless flag is reset outside)
      If (LDF_FitVerification) Then
         Call WarningMessage(0,SecNam//': Verifying fit')
         Call xFlush(6)
         Call LDF_VerifyFit_Drv(irc)
         If (irc.ne.0) Then
            Call WarningMessage(2,SecNam//': Fit verification failed!')
            Write(6,'(A,I10)')
     &      'LDF_VerifyFit_Drv returned code',irc
            Call LDF_Quit(1)
         Else
            Write(6,'(/,A)') 'Fit verification completed: all OK!'
            Call xFlush(6)
         End If
         LDF_FitVerification=.False.
      End If

      ! Debug: check all integrals (if requested)
      ! Note: this is only done in first call to this routine
      !       (unless flag is reset outside)
      If (LDF_IntegralCheck) Then
         Call WarningMessage(0,
     &      SecNam//': Checking all integrals - this may take a while!')
         Call xFlush(6)
         QuitOnError=.True.
         Silent=iPrint.lt.3
         Call LDF_CheckAllIntegrals(QuitOnError,Silent,Mode,ThrPS(1),
     &                              MaxErr,MaxAbsErr,AverageErr,RMSErr,
     &                              MaxErr_OffD, MaxAbsErr_OffD,
     &                              DiffNorm,DiffSum,ConvNorm,LDFNorm,
     &                              ConvSum,LDFSum)
         If (Silent) Then
            Call Cho_Head('LDF Integral Error Analysis','-',80,6)
            Write(6,'(3X,A,A)')
     &      '(Increase print level to get more details on ',
     &      'individual atom pair blocks)'
            If (Mode.eq.1) Then
               Write(6,'(3X,A)') 'LDF integral representation: ROBUST'
            Else If (Mode.eq.2) Then
               Write(6,'(3X,A)')
     &                        'LDF integral representation: NONROBUST'
            Else If (Mode.eq.3) Then
               Write(6,'(3X,A)')
     &                    'LDF integral representation: HALF-AND-HALF'
            Else
               Write(6,'(3X,A)')
     &                          'LDF integral representation: UNKNOWN'
            End If
            Write(6,'(3X,A,1P,D20.10)')
     &      'LDF integral prescreening threshold:',ThrPS(1)
            Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &      'Conventional norm...',ConvNorm,
     &      'Conventional sum....',ConvSum
            Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &      'LDF norm............',LDFNorm,
     &      'LDF sum.............',LDFSum
            Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &      'Difference norm.....',DiffNorm,
     &      'Difference sum......',DiffSum
            Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &      'Max Error...........',MaxErr,
     &      'Max Abs Error.......',MaxAbsErr
            Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &      'Max OffD Error......',MaxErr_OffD,
     &      'Max Abs OffD Error..',MaxAbsErr_OffD
            Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &      'Average Error.......',AverageErr,
     &      'RMS Error...........',RMSErr
         End If
         If (MaxAbsErr.gt.Thr_Accuracy) Then
            Write(6,'(/,A)') 'Integral check completed:'
            Call WarningMessage(1,'Integral check completed:'//
     &             'Max Abs Error is greater than LDF target accuracy!')
         Else
            Write(6,'(/,A)') 'Integral check completed: all OK!'
            Call xFlush(6)
         End If
         Call xFlush(6)
         LDF_IntegralCheck=.False. ! Done, so do not do it again
      End If

C--------------------------------------------------------------
C     Branch according to Coulomb-and-exchange or Coulomb-only.
C--------------------------------------------------------------

      If (ExFac.ne.0.0d0) Then ! Coulomb-and-exchange
         Write(6,'(//,A,A)') SecNam,': Exchange not implemented yet!'
         Call LDF_NotImplemented()
         FactX(1)=ExFac ! avoid compiler warning
      Else ! Coulomb-only
         ! Set number of density matrices
         nDen=1
         ! Defensive coding: make sure nDen_Max has not changed
         ! below nDen
         If (nDen.gt.nDen_Max) Then
            Call WarningMessage(2,SecNam//': nDen>nDen_Max')
            Call LDF_Quit(1)
         End If
         ! Set scaling factors
         FactC(1)=1.0d0
         If (iUHF.eq.0) Then ! spin-restricted Coulomb-only
            ! Get pointers to D and F
            ! Off-diagonal elements of DLT are scaled by 2 by the SCF
            ! program. This is incompatible with the LDF implementation.
            ! So, use instead the quadratic DSQ.
            ! Use packed F (FLT) for result.
            ip_D(1)=ip_of_Work(DSQ(1))
            ip_F(1)=ip_of_Work(FLT(1))
            ! Set flags for quadratic (SQ) density matrix and packed
            ! Fock matrix
            PackedD=.False.
            PackedF=.True.
            ! Do not add result to F, simply put it there
            Add=.False.
            ! Debug: check charge (if requested)
            If (LDF_ChargeCheck) Then
               Call WarningMessage(0,SecNam//': Checking charge')
               Call xFlush(6)
               Call LDF_CheckCharge(.True.,PackedD,ip_D(1),MAE,AB_MAE,
     &                              Q,deltaQ)
            End If
            ! Debug: compute norm of upper bound Fock matrix error for
            !        the Coulomb contribution (if requested).
            If (LDF_UBCNorm) Then
               Call WarningMessage(0,SecNam//
     &               ': Computing norm of upper bound to Coulomb error')
               Call xFlush(6)
               l_UBFNorm=nDen
               Call GetMem('UBFNorm','Allo','Real',ip_UBFNorm,l_UBFNorm)
               Call LDF_Fock_CoulombUpperBoundNorm_Full(.True.,PackedD,
     &                                                 nDen,FactC,ip_D,
     &                                                 Work(ip_UBFNorm))
               Call GetMem('UBFNorm','Free','Real',ip_UBFNorm,l_UBFNorm)
            End If
            ! Print args
            If (iPrint.ge.3) Then
               Write(6,'(A)')
     &         'Calling RHF Fock matrix calculator with args'
               Write(6,'(2X,A,I15,2X,A,14X,L1,2X,A,I15)')
     &         'IntegralOption...',IntegralOption,
     &         'Timing...........',Timing,
     &         'Mode.............',Mode
               Write(6,'(2X,A,1P,2D15.6)')
     &         'ThrPS............',ThrPS(1),ThrPS(2)
               Write(6,'(2X,A,14X,L1,2X,A,14X,L1,2X,A,14X,L1)')
     &         'Add..............',Add,
     &         'PackedD..........',PackedD,
     &         'PackedF..........',PackedF
               Write(6,'(2X,A,I15)')
     &         'nDen.............',nDen
               Write(6,'(2X,A,1P,3D15.6)')
     &         'FactC............',(FactC(i),i=1,nDen)
               If (iPrint.ge.5) Then
                  Write(6,'(2X,A,3I15)')
     &            'ip_D.............',(ip_D(i),i=1,nDen)
                  Write(6,'(2X,A,3I15)')
     &            'ip_F.............',(ip_F(i),i=1,nDen)
               End If
            End If
            ! Compute two-electron contributions to Fock matrix
            Call LDF_Fock_CoulombOnly(IntegralOption,
     &                                Timing,Mode,ThrPS,
     &                                Add,PackedD,PackedF,
     &                                nDen,FactC,ip_D,ip_F)
            ! Debug: check Coulomb error
            If (LDF_CoulombCheck) Then
               Call WarningMessage(0,
     &                            SecNam//': Analysis of Coulomb error')
               Call xFlush(6)
               l_myF=nDen
               Call GetMem('DrvmyF','Allo','Inte',ip_myF,l_myF)
               If (PackedF) Then
                  lF=nBas(1)*(nBas(1)+1)/2
               Else
                  lF=nBas(1)**2
               End If
               Do iDen=1,nDen
                  Call GetMem('DrvF','Allo','Real',ipF,lF)
                  Call dCopy_(lF,Work(ip_F(iDen)),1,Work(ipF),1)
                  iWork(ip_myF-1+iDen)=ipF
               End Do
               ComputeF=.False.
               Call LDF_Fock_CoulombErrorAnalysis(ComputeF,Mode,
     &                                            PackedD,PackedF,
     &                                            nDen,FactC,ip_D,
     &                                            iWork(ip_myF))
               Do iDen=1,nDen
                  ipF=iWork(ip_myF-1+iDen)
                  Call GetMem('DrvF','Free','Real',ipF,lF)
               End Do
               Call GetMem('DrvmyF','Free','Inte',ip_myF,l_myF)
            End If
            ! Debug: check mode consistency
            If (LDF_ModeCheck) Then
               LDF_ModeCheck=.False. ! check only once
               Call WarningMessage(0,SecNam//': Mode Check')
               Call xFlush(6)
               l_myF=nDen*2
               Call GetMem('DrvmyF','Allo','Inte',ip_myF,l_myF)
               If (PackedF) Then
                  lF=nBas(1)*(nBas(1)+1)/2
               Else
                  lF=nBas(1)**2
               End If
               Do iDen=1,nDen
                  Call GetMem('DrvF','Allo','Real',ipF,lF)
                  iWork(ip_myF-1+iDen)=ipF
               End Do
               Do iDen=1,nDen
                  Call GetMem('DrvF','Allo','Real',ipF,lF)
                  ipF2=ip_F(iDen)
                  Call dCopy_(lF,Work(ipF2),1,Work(ipF),1)
                  iWork(ip_myF-1+nDen+iDen)=ipF
               End Do
               If (Mode.eq.1) Then
                  lMode=3
                  factor=-2.0d0
               Else If (Mode.eq.2) Then
                  lMode=3
                  factor=-2.0d0
               Else If (Mode.eq.3) Then
                  Do iDen=1,nDen
                     ipF=iWork(ip_myF-1+nDen+iDen)
                     Call dScal_(lF,2.0d0,Work(ipF),1)
                  End Do
                  lMode=1
                  factor=-1.0d0
               Else
                  Call WarningMessage(2,SecNam//': unknown Mode')
                  Call LDF_Quit(1)
                  lMode=0
                  factor=0.0d0
               End If
               Call LDF_Fock_CoulombOnly(IntegralOption,
     &                                   Timing,lMode,ThrPS,
     &                                   Add,PackedD,PackedF,
     &                                   nDen,FactC,ip_D,
     &                                   iWork(ip_myF))
               Do iDen=1,nDen
                  ipF=iWork(ip_myF-1+iDen)
                  ipF2=iWork(ip_myF-1+nDen+iDen)
                  Call dAXPY_(lF,factor,Work(ipF),1,
     &                                 Work(ipF2),1)
               End Do
               If (Mode.eq.1) Then
                  lMode=2
                  factor=1.0d0
               Else If (Mode.eq.2) Then
                  lMode=1
                  factor=1.0d0
               Else If (Mode.eq.3) Then
                  lMode=2
                  factor=-1.0d0
               Else
                  Call WarningMessage(2,SecNam//': unknown Mode')
                  Call LDF_Quit(1)
                  lMode=0
                  factor=0.0d0
               End If
               Call LDF_Fock_CoulombOnly(IntegralOption,
     &                                   Timing,lMode,ThrPS,
     &                                   Add,PackedD,PackedF,
     &                                   nDen,FactC,ip_D,
     &                                   iWork(ip_myF))
               Do iDen=1,nDen
                  ipF=iWork(ip_myF-1+iDen)
                  ipF2=iWork(ip_myF-1+nDen+iDen)
                  Call dAXPY_(lF,factor,Work(ipF),1,
     &                                 Work(ipF2),1)
               End Do
               Call Cho_Head(SecNam//': Mode Check','=',80,6)
               n=0
               Do iDen=1,nDen
                  ipF=iWork(ip_myF-1+nDen+iDen)
                  FNorm=sqrt(dDot_(lF,Work(ipF),1,Work(ipF),1))
                  If (FNorm.gt.Tol_ModeCheck) Then
                     Write(6,'(3X,A,I3,A,1P,D20.10,A)')
     &               'Density no.',iDen,' Check norm=',Fnorm,
     &               '  (FAIL)'
                     n=n+1
                  Else
                     Write(6,'(3X,A,I3,A,1P,D20.10,A)')
     &               'Density no.',iDen,' Check norm=',Fnorm,
     &               '  (pass)'
                  End If
               End Do
               If (n.ne.0) Then
                  Call WarningMessage(2,SecNam//': Mode Check: Failed')
                  Call LDF_Quit(1)
               End If
               Call xFlush(6)
               Do iDen=1,nDen*2
                  ipF=iWork(ip_myF-1+iDen)
                  Call GetMem('DrvF','Free','Real',ipF,lF)
               End Do
               Call GetMem('DrvmyF','Free','Inte',ip_myF,l_myF)
            End If
         Else ! spin-unrestricted Coulomb-only
            ! Add alpha and beta parts of density matrix
            Call dAXPY_(nBas(1)**2,1.0d0,DSQ_ab,1,DSQ,1)
            ! Get pointers to D and F
            ! Off-diagonal elements of DLT are scaled by 2 by the SCF
            ! program. This is incompatible with the LDF implementation.
            ! So, use instead the quadratic DSQ.
            ! Use packed F (FLT) for result.
            ip_D(1)=ip_of_Work(DSQ(1))
            ip_F(1)=ip_of_Work(FLT(1))
            ! Set flags for quadratic (SQ) density matrix and packed
            ! Fock matrix
            PackedD=.False.
            PackedF=.True.
            ! Do not add result to F, simply put it there
            Add=.False.
            ! Debug: check charge (if requested)
            If (LDF_ChargeCheck) Then
               Call WarningMessage(0,SecNam//': Checking charge')
               Call xFlush(6)
               Call LDF_CheckCharge(.True.,PackedD,ip_D(1),MAE,AB_MAE,
     &                              Q,deltaQ)
            End If
            ! Debug: compute norm of upper bound Fock matrix error for
            !        the Coulomb contribution (if requested).
            If (LDF_UBCNorm) Then
               Call WarningMessage(0,SecNam//
     &               ': Computing norm of upper bound to Coulomb error')
               Call xFlush(6)
               l_UBFNorm=nDen
               Call GetMem('UBFNorm','Allo','Real',ip_UBFNorm,l_UBFNorm)
               Call LDF_Fock_CoulombUpperBoundNorm_Full(.True.,PackedD,
     &                                                 nDen,FactC,ip_D,
     &                                                 Work(ip_UBFNorm))
               Call GetMem('UBFNorm','Free','Real',ip_UBFNorm,l_UBFNorm)
            End If
            ! Print args
            If (iPrint.ge.3) Then
               Write(6,'(A)')
     &         'Calling UHF Fock matrix calculator with args'
               Write(6,'(2X,A,I15,2X,A,14X,L1,2X,A,I15)')
     &         'IntegralOption...',IntegralOption,
     &         'Timing...........',Timing,
     &         'Mode.............',Mode
               Write(6,'(2X,A,1P,2D15.6)')
     &         'ThrPS............',ThrPS(1),ThrPS(2)
               Write(6,'(2X,A,14X,L1,2X,A,14X,L1,2X,A,14X,L1)')
     &         'Add..............',Add,
     &         'PackedD..........',PackedD,
     &         'PackedF..........',PackedF
               Write(6,'(2X,A,I15)')
     &         'nDen.............',nDen
               Write(6,'(2X,A,1P,3D15.6)')
     &         'FactC............',(FactC(i),i=1,nDen)
               If (iPrint.ge.5) Then
                  Write(6,'(2X,A,3I15)')
     &            'ip_D.............',(ip_D(i),i=1,nDen)
                  Write(6,'(2X,A,3I15)')
     &            'ip_F.............',(ip_F(i),i=1,nDen)
               End If
            End If
            ! Compute two-electron contributions to Fock matrix
            Call LDF_Fock_CoulombOnly(IntegralOption,
     &                                Timing,Mode,ThrPS,
     &                                Add,PackedD,PackedF,
     &                                nDen,FactC,ip_D,ip_F)
            ! Debug: check Coulomb error
            If (LDF_CoulombCheck) Then
               Call WarningMessage(2,
     &                            SecNam//': Analysis of Coulomb error')
               Call xFlush(6)
               l_myF=nDen
               Call GetMem('DrvmyF','Allo','Inte',ip_myF,l_myF)
               If (PackedF) Then
                  lF=nBas(1)*(nBas(1)+1)/2
               Else
                  lF=nBas(1)**2
               End If
               Do iDen=1,nDen
                  Call GetMem('DrvF','Allo','Real',ipF,lF)
                  Call dCopy_(lF,Work(ip_F(iDen)),1,Work(ipF),1)
                  iWork(ip_myF-1+iDen)=ipF
               End Do
               ComputeF=.False.
               Call LDF_Fock_CoulombErrorAnalysis(ComputeF,Mode,
     &                                            PackedD,PackedF,
     &                                            nDen,FactC,ip_D,
     &                                            iWork(ip_myF))
               Do iDen=1,nDen
                  ipF=iWork(ip_myF-1+iDen)
                  Call GetMem('DrvF','Free','Real',ipF,lF)
               End Do
               Call GetMem('DrvmyF','Free','Inte',ip_myF,l_myF)
            End If
            ! Debug: check mode consistency
            If (LDF_ModeCheck) Then
               LDF_ModeCheck=.False. ! check only once
               Call WarningMessage(0,SecNam//': Mode Check')
               Call xFlush(6)
               l_myF=nDen*2
               Call GetMem('DrvmyF','Allo','Inte',ip_myF,l_myF)
               If (PackedF) Then
                  lF=nBas(1)*(nBas(1)+1)/2
               Else
                  lF=nBas(1)**2
               End If
               Do iDen=1,nDen
                  Call GetMem('DrvF','Allo','Real',ipF,lF)
                  iWork(ip_myF-1+iDen)=ipF
               End Do
               Do iDen=1,nDen
                  Call GetMem('DrvF','Allo','Real',ipF,lF)
                  ipF2=ip_F(iDen)
                  Call dCopy_(lF,Work(ipF2),1,Work(ipF),1)
                  iWork(ip_myF-1+nDen+iDen)=ipF
               End Do
               If (Mode.eq.1) Then
                  lMode=3
                  factor=-2.0d0
               Else If (Mode.eq.2) Then
                  lMode=3
                  factor=-2.0d0
               Else If (Mode.eq.3) Then
                  Do iDen=1,nDen
                     ipF=iWork(ip_myF-1+nDen+iDen)
                     Call dScal_(lF,2.0d0,Work(ipF),1)
                  End Do
                  lMode=1
                  factor=-1.0d0
               Else
                  Call WarningMessage(2,SecNam//': unknown Mode')
                  Call LDF_Quit(1)
                  lMode=0
                  factor=0.0d0
               End If
               Call LDF_Fock_CoulombOnly(IntegralOption,
     &                                   Timing,lMode,ThrPS,
     &                                   Add,PackedD,PackedF,
     &                                   nDen,FactC,ip_D,
     &                                   iWork(ip_myF))
               Do iDen=1,nDen
                  ipF=iWork(ip_myF-1+iDen)
                  ipF2=iWork(ip_myF-1+nDen+iDen)
                  Call dAXPY_(lF,factor,Work(ipF),1,
     &                                 Work(ipF2),1)
               End Do
               If (Mode.eq.1) Then
                  lMode=2
                  factor=1.0d0
               Else If (Mode.eq.2) Then
                  lMode=1
                  factor=1.0d0
               Else If (Mode.eq.3) Then
                  lMode=2
                  factor=-1.0d0
               Else
                  Call WarningMessage(2,SecNam//': unknown Mode')
                  Call LDF_Quit(1)
                  lMode=0
                  factor=0.0d0
               End If
               Call LDF_Fock_CoulombOnly(IntegralOption,
     &                                   Timing,lMode,ThrPS,
     &                                   Add,PackedD,PackedF,
     &                                   nDen,FactC,ip_D,
     &                                   iWork(ip_myF))
               Do iDen=1,nDen
                  ipF=iWork(ip_myF-1+iDen)
                  ipF2=iWork(ip_myF-1+nDen+iDen)
                  Call dAXPY_(lF,factor,Work(ipF),1,
     &                                 Work(ipF2),1)
               End Do
               Call Cho_Head(SecNam//': Mode Check','=',80,6)
               n=0
               Do iDen=1,nDen
                  ipF=iWork(ip_myF-1+nDen+iDen)
                  FNorm=sqrt(dDot_(lF,Work(ipF),1,Work(ipF),1))
                  If (FNorm.gt.Tol_ModeCheck) Then
                     Write(6,'(3X,A,I3,A,1P,D20.10,A)')
     &               'Density no.',iDen,' Check norm=',Fnorm,
     &               '  (FAIL)'
                     n=n+1
                  Else
                     Write(6,'(3X,A,I3,A,1P,D20.10,A)')
     &               'Density no.',iDen,' Check norm=',Fnorm,
     &               '  (pass)'
                  End If
               End Do
               If (n.ne.0) Then
                  Call WarningMessage(2,SecNam//': Mode Check: Failed')
                  Call LDF_Quit(1)
               End If
               Call xFlush(6)
               Do iDen=1,nDen*2
                  ipF=iWork(ip_myF-1+iDen)
                  Call GetMem('DrvF','Free','Real',ipF,lF)
               End Do
               Call GetMem('DrvmyF','Free','Inte',ip_myF,l_myF)
            End If
            ! Copy result to FLT_ab
            Call dCopy_(nFLT,FLT,1,FLT_ab,1)
            ! Restore DSQ from DLT (which is scaled by two on the
            ! off-diagonal)
            uv=0
            Do v=1,nBas(1)
               Do u=1,v-1
                  uv=uv+1
                  DSQ(uv)=0.5d0*DLT(iTri(u,v))
               End Do
               uv=uv+1
               DSQ(uv)=DLT(iTri(v,v))
               Do u=v+1,nBas(1)
                  uv=uv+1
                  DSQ(uv)=0.5d0*DLT(iTri(u,v))
               End Do
            End Do
         End If ! spin-restricted or spin-unrestricted
      End If ! Coulomb-and-exchange or Coulomb-only

      ! Print exit message
      If (iPrint.ge.3) Then
         Write(6,'(2X,A,A)') 'Exit ',SecNam
         Call xFlush(6)
      End If
      Call Free_iSD()

#if defined (_DEBUGPRINT_)
      ! Exit
#endif
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(DLT_ab)
         Call Unused_integer(LWFSQ)
         Call Unused_integer(LWFSQ_ab)
         Call Unused_integer_array(nOcc)
         Call Unused_integer_array(nOcc_ab)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! New VECTOR UTILITIES, written by Steven Vancoillie, May 2011
! A set of subroutines that can transform RHS arrays using the parallel
! aware subroutines
!***********************************************************************

subroutine PTRTOC(ITYPE,IVEC,JVEC)
! Transform RHS vectors from SR format to C format.
! ITYPE=0 uses only T matrix, ITYPE=1 uses S*T matrix

use caspt2_module, only: CPUVEC, NASUP, nCases, nInDep, NISUP, nSym, TIOVEC
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iType, iVec, jVec
real(kind=wp) :: CPU, CPU0, CPU1, TIO, TIO0, TIO1
integer(kind=iwp) :: iCase, iSym, lg_v1, lg_v2, NAS, NIN, NIS

call TIMING(CPU0,CPU,TIO0,TIO)

do ICASE=1,NCASES
  if ((IVEC == JVEC) .and. ((ICASE == 12) .or. (ICASE == 13))) cycle
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    if (NAS == 0) cycle
    NIN = NINDEP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (NIS == 0) cycle
    call RHS_ALLO(NAS,NIS,lg_V2)
    if ((ICASE /= 12) .and. (ICASE /= 13)) then
      if (NIN > 0) then
        call RHS_ALLO(NIN,NIS,lg_V1)
        call RHS_READ(NIN,NIS,lg_V1,ICASE,ISYM,IVEC)
        call RHS_SR2C(ITYPE,0,NAS,NIS,NIN,lg_V1,lg_V2,ICASE,ISYM)
        call RHS_FREE(lg_V1)
      else
        call RHS_SCAL(NAS,NIS,lg_V2,Zero)
      end if
    else
      call RHS_READ(NAS,NIS,lg_V2,ICASE,ISYM,IVEC)
    end if

    call RHS_SAVE(NAS,NIS,lg_V2,ICASE,ISYM,JVEC)

    call RHS_FREE(lg_V2)

  end do
end do

call TIMING(CPU1,CPU,TIO1,TIO)
CPUVEC = CPUVEC+(CPU1-CPU0)
TIOVEC = TIOVEC+(TIO1-TIO0)

end subroutine PTRTOC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReaW3(Ww,Wx,aSGrp,beSGrp,bSGrp,LunAux)
! this routine does:
! define Ww(a",be",b",i) <- (a",be"|b",i)
!
! integrals (a",be"|b",i) are stored in files V3xxyyzz for xx>=yy
!
! Storing of integrals in V3files
! do i=1,no
!   record of V3(a"be",b",_i): a">=be",b" for given i
! end do

use chcc_global, only: DimSGrpa, DimSGrpbe, no
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: Ww(*), Wx(*)
integer(kind=iwp), intent(in) :: aSGrp, beSGrp, bSGrp, LunAux
integer(kind=iwp) :: dima, dimb, dimbe
character(len=8) :: LunName

!0 def dimensions

dima = DimSGrpa(aSGrp)
dimb = DimSGrpa(bSGrp)
dimbe = DimSGrpbe(beSGrp)

if (aSGrp > beSGrp) then
  !1 case aSGrp>beSGrp, integrals (a",be"|b",i) to be read
  !1.1 make Name
  call MkNameV3(aSGrp,beSGrp,bSGrp,'W3',LunName)
  !1.2 read (a",be"|b",i) from V3:(a",be"|b",i)
  call ReaW3hlp1(Ww,dima,dimbe,dimb,no,LunName,LunAux)

else if (aSGrp == beSGrp) then
  !2 case aSGrp=beSGrp, integrals (a">=be"|b",i)to be read and expand
  !2.1 make Name
  call MkNameV3(aSGrp,beSGrp,bSGrp,'W3',LunName)
  !2.2 read (a",be"|b",i) from V3:(a">=be"|b",i)
  call ReaW3hlp2(Ww,Wx,dima,dimb,no,LunName,LunAux)

else
  !3 case aSGrp<beSGrp, integrals (be",a"|b",i) to be read and mapped
  !3.1 make Name
  call MkNameV3(beSGrp,aSGrp,bSGrp,'W3',LunName)
  !3.2 read (a",be"|b",i) from V3:(be",a"|b",i)
  call ReaW3hlp3(Ww,Wx,dima,dimbe,dimb,no,LunName,LunAux)

end if

return

end subroutine ReaW3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3reorg(wrk,wrksize,noa,nsym)
! this routine does final reorganization of t3nam file
! and produces final form of this file
! as it will be required in T3 and close t3nam file
!
! noa   - array with occupation numbers
! nsym  - actual number of irreps

use ccsort_global, only: lunt3, mapdri, mapiri, mbas, posri0
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, noa(8), nsym
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
#include "t3int.fh"
integer(kind=iwp) :: i, iaddr, iindex, iPosPack, iri, length, posri, post, symi

! def iPosPack
!   iPosPack - position of (maps+Ri) set in packed
!               (i.e. final) of T3nam file
iPosPack = T3IntPos(1)

iindex = 0
do symi=1,nsym

  !0 get map's of R_i(a,bc)
  call ccsort_t3grc0(3,8,4,4,4,0,symi,posri0,post,mapdri,mapiri)

  do i=1,noa(symi)
    iindex = iindex+1

    !1 reconstruct R_i(a,bc) per blocks as in is
    !  actually written in t3man file
    do iri=1,mapdri(0,5)

      !1.1 iind address of this R_i block in t3nam file
      iaddr = T3IntPos(iindex)+T3Off(iri,symi)

      !1.2 def position of of this block in R1
      posri = mapdri(iri,1)

      !1.3 read integrals into proper position
      length = mapdri(iri,2)
      if (length > 0) call ddafile(lunt3,2,wrk(posri),length,iaddr)

    end do

    !2 write into t3nam file in packed form
    !  1) mapdri, mapiri
    !  2) R_i
    !2.1 def final (packed) address for i-th set (maps+Ri)
    T3intPos(iindex) = iPosPack
    iaddr = T3intPos(iindex)

    !2.2 write maps
    call idafile(lunt3,1,mapdri,3078,iaddr)
    call idafile(lunt3,1,mapiri,512,iaddr)

    !2.3 def actual length of Ri
    length = 0
    do iri=1,mapdri(0,5)
      length = length+mapdri(iri,2)
    end do
    !length = mapdri(iri,1)+mapdri(iri,2)-mapdri(1,1)

    !2.4 write Ri as one block
    call ddafile(lunt3,1,wrk(posri0),length,iaddr)

    !2.5 save updated address as a new packed (final) position for next i
    iPosPack = iaddr

  end do
end do

!3 store new packed (final) addresses T3IntPos in t3nam file
!  (at the beggining)
iaddr = 0
call idafile(lunt3,1,T3IntPos,mbas,iaddr)

!4 close t3nam file
call daclos(lunt3)

return

end subroutine t3reorg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3sglh322 (w,dima,dimb,dimc,s2,d2,ns)
c
c     this routine add following contribution to W
c     for syma;symb>symc
c
c     W(a;b,c) <- - S2 _i(c) . D2 _jk(a,b)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s2     - S2 matrix (I)
c     d2     - D2 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s2(1:dimc)
       real*8 d2(1:dima,1:dimb)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 110 c=1,dimc
       s=s2(c)
       do 111 b=1,dimb
       do 112 a=1,dima
       w(a,b,c)=w(a,b,c)-d2(a,b)*s
 112    continue
 111    continue
 110    continue
c
       else
c     phase -1
c
       do 210 c=1,dimc
       s=s2(c)
       do 211 b=1,dimb
       do 212 a=1,dima
       w(a,b,c)=w(a,b,c)+d2(a,b)*s
 212    continue
 211    continue
 210    continue
c
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GETINT(    XINT,     ITP,     ISM,     JTP,     JSM,
     &                       KTP,     KSM,     LTP,     LSM,  IXCHNG,
     &                      IKSM,    JLSM,   ICOUL)
*
* Outer routine for accessing integral block
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "mxpdim.fh"
#include "lucinp.fh"
#include "orbinp.fh"
#include "csm.fh"

#include "crun.fh"
#include "WrkSpc.fh"
#include "glbbas.fh"
#include "oper.fh"
#include "wadr.fh"
      DIMENSION XINT(*)
*
      NTEST = 00
*
      IF(NTEST.GE.1) THEN
c       WRITE(6,*) ' I_USE_SIMTRH in GETINT =', I_USE_SIMTRH
       WRITE(6,*) ' GETINT : ICOUL = ', ICOUL
       WRITE(6,*)       'ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM : '
       WRITE(6,'(8I4)')  ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM
      END IF
*. Read integrals in in RASSCF format
        CALL GETINCN_RASSCF(   XINT,    ITP,    ISM,    JTP,    JSM,
     &                          KTP,    KSM,    LTP,    LSM, IXCHNG,
     &                       IKSM,JLSM,IWORK(KPINT2),NSMOB,IWORK(KINH1),
     &                        ICOUL)

      IF(NTEST.NE.0) THEN
        IF(ITP.EQ.0) THEN
          NI = NTOOBS(ISM)
        ELSE
          NI = NOBPTS(ITP,ISM)
        END IF
*
        IF(KTP.EQ.0) THEN
          NK = NTOOBS(KSM)
        ELSE
          NK = NOBPTS(KTP,KSM)
        END IF
*
        IF(IKSM.EQ.0) THEN
          NIK = NI * NK
        ELSE
          NIK = NI*(NI+1)/2
        END IF
*
        IF(JTP.EQ.0) THEN
          NJ = NTOOBS(JSM)
        ELSE
          NJ = NOBPTS(JTP,JSM)
        END IF
*
        IF(LTP.EQ.0) THEN
          NL = NTOOBS(LSM)
        ELSE
          NL = NOBPTS(LTP,LSM)
        END IF
*
        IF(JLSM.EQ.0) THEN
          NJL = NJ * NL
        ELSE
          NJL = NJ*(NJ+1)/2
        END IF
        WRITE(6,*) ' 2 electron integral block for TS blocks '
        WRITE(6,*) ' Ixchng :', IXCHNG
        WRITE(6,*) ' After GETINC '
        WRITE(6,'(1H ,4(A,I2,A,I2,A))')
     &  '(',ITP,',',ISM,')','(',JTP,',',JSM,')',
     &  '(',KTP,',',KSM,')','(',LTP,',',LSM,')'
        CALL WRTMAT(XINT,NIK,NJL,NIK,NJL)
      END IF
*
C     STOP ' Jeppe forced me to stop in GETINT '
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1998,2005, Roland Lindh                 *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Post_2Center_RI(ipA_Diag)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals.                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August '91                         *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. '93          *
*             Modified driver. Jan. '98                                *
*             Modified to 2-center ERIs for RI June '05                *
************************************************************************
      use Basis_Info, only: nBas_Aux
      use Wrj12
      use Temporary_Parameters, only: force_out_of_core
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "setup.fh"
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Integer  nDmA(0:7),  nDmB(0:7)
      Logical Out_of_Core
      Character Name_Q*6
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*
      nScr=0
      nBfn2 = 0
      nBfnTot=0
      Do iIrrep = 0, nIrrep-1
         lJ=nBas_Aux(iIrrep)
         If (iIrrep.eq.0) lJ=lJ-1
         nDmA(iIrrep)=lJ
         nDmB(iIrrep)=0
         nScr=Max(nScr,3*lJ)
         nBfn2 = nBfn2 + lJ**2
         nBfnTot=nBfnTot+lJ
      End Do
      nA_Diag=nBfnTot
*
      Call GetMem('MemMax','Max','Real',iDummy,MaxMem)
*                                                                      *
************************************************************************
*                                                                      *
*     Fill in the lower part of the A matrix as it is stored on disk.
*
      Do iIrrep = 0, nIrrep-1
         nB = nBas_Aux(iIrrep)
         If (iIrrep.eq.0) nB = nB - 1 ! subtract dummy af
         Call Square_A(Lu_A(iIrrep),nB,MaxMem,Force_Out_of_Core)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Pivoting of the A matrix
*
      Call GetMem('iD_Diag','Allo','Inte',ip_iDiag,nA_Diag)
      Call GetMem('MemMax','Max','Real',iDummy,MaxMem2)
*
      If (Force_Out_of_Core) MaxMem2=3*nBfnTot
*     lScr=Min(MaxMem2,nScr)
      lScr=Max(MaxMem2,nScr)
      Call GetMem('Scr','Allo','Real',ip_Scr,lScr)
*
      Call SORT_mat(irc,Work(ipA_Diag),nDmA,nDmB,iWork(ip_iDiag),nIrrep,
     &                  LU_A,'GePivot',lScr,Work(ip_Scr))
      ichk=0
      Do iIrrep = 0, nIrrep-1
         nChV(iIrrep)=nDmB(iIrrep)
         ichk=ichk+Min(1,nDmA(iIrrep)-nDmB(iIrrep))
      End Do
      If (ichk.ne.0) Then
         write(6,*)
         write(6,*)'Post_2Center_RI'
         write(6,*)'Detected lin. dependences in the auxiliary basis.'
         Write(6,'(A,8I6)')
     & ' # of AuxBas before l. d. removal: ',(nDmA(i),i=0,nIrrep-1)
         Write(6,'(A,8I6)')
     & ' # of AuxBas after  l. d. removal: ',(nDmB(i),i=0,nIrrep-1)
         write(6,*)
      EndIf
*
      Call SORT_mat(irc,Work(ipA_Diag),nDmA,nDmB,iWork(ip_iDiag),nIrrep,
     &                  LU_A,'DoPivot',lScr,Work(ip_Scr))
*
*     Note: after the 'DoPivot' call to Sort_mat, the A-matrix is
*           no longer stored as squared but as upper-triangular
*
      Call GetMem('Scr','Free','Real',ip_Scr,lScr)
      Call GetMem('A_Diag','Free','Real',ipA_Diag,nA_Diag)
      ipA_Diag=ip_Dummy  ! Dummy memory pointer.
*
************************************************************************
*     A-vectors are now on disk. Go ahead and compute the Q-vectors!
************************************************************************
*
      ThrQ=1.0d-14 ! Threshold for Inv_Cho_Factor
*
      Do iIrrep = 0, nIrrep-1
c         nB=nBas_Aux(iIrrep)
c         If (iIrrep.eq.0) nB = nB - 1
         nB=nDmB(iIrrep)
         If (nB.eq.0) Go To 777
         nQm=nB*(nB+1)/2
*
         nXZ=nB
         nQm_full= nB*(nB+1)/2
*
         If (Force_Out_of_Core) MaxMem=(8*(2*nQm_full+5*nXZ))/10
         Out_of_Core=2*nQm_full+5*nXZ.gt.MaxMem
*
         If (Out_Of_Core) Then
            mQm=(nQm*MaxMem-5*nXZ)/(2*nQm_full)
            a=One
            b=-Two*DBLE(mQm)
            mB=INT(-a/Two + Sqrt( (a/Two)**2 - b ))
            kQm=mB*(mB+1)/2
            If (kQm.gt.mQm) Then
               Call WarningMessage(2,'Error in Post_2Center_RI')
               Write (6,*) 'kQm.gt.mQm!'
               Write (6,*) 'MaxMem=',MaxMem
               Write (6,*) 'nQm,mQm,kQm=',nQm,mQm,kQm
               Write (6,*) 'nB,mB=',nB,mB
               Call Abend()
            End If
         Else
            mB = nB
            kQm = nQm
         End If
*
         lQm=kQm
         lAm=lQm
*
         If (lQm.lt.1) Then
            Call WarningMessage(2,'Error in Post_2Center_RI')
            Write (6,*) 'lQm.lt.1'
            Call Abend()
         End If
*
*        Some of memory for scratch arrays for Inv_Cho_Factor
*        Allocate memory for the A- and Q-vectors and initialize.
*
         Call GetMem('ICF','Allo','Real',ip_ICF,lAm+lQm+5*nXZ)
         ipZ    = ip_ICF
         ipX    = ip_ICF + 1*nXZ
         ip_Q_k = ip_ICF + 2*nXZ
         ip_A_k = ip_ICF + 3*nXZ
         ip_Scr = ip_ICF + 4*nXZ
         lScr=nXZ
         ip_Am  = ip_ICF + 5*nXZ
         ip_Qm  = ip_ICF + 5*nXZ + lAm
*
         Call FZero(Work(ip_Am),lAm)
         Call FZero(Work(ip_Qm),lQm)
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*        Process the A_ks to generate Q_ks.
*
         iSeed=55+iIrrep
         Lu_Q(iIrrep)=IsFreeUnit(iSeed)
         Write(Name_Q,'(A4,I2.2)') 'QMAT',iIrrep
         Call DaName_MF_WA(Lu_Q(iIrrep),Name_Q)
*
         iAddr=0
         nMem=mB
         Do kCol = 1, nB
*
            iAddr_=iAddr
            If (kCol.le.nMem) Then
*              Point to A_k in Am
               iOff = (kCol-1)*kCol/2
               ip_A_l=ip_Am+iOff
               If (kCol.eq.1) Then
                  nAm=nMem*(nMem+1)/2
                  Call dDaFile(Lu_A(iIrrep),2,Work(ip_Am),nAm,iAddr_)
               End If
*              Point to Q_k in Qm
               iOff = (kCol-1)*kCol/2
               ip_Q_l=ip_Qm+iOff
            Else If (kCol.gt.nMem) Then
*              Use special scratch for A_k
               ip_A_l=ip_A_k
               Call dDaFile(Lu_A(iIrrep),2,Work(ip_A_l),kCol,iAddr_)
*              Use special scratch for Q_k
               ip_Q_l=ip_Q_k
            End If
*
            LinDep=2
            Call Inv_Cho_Factor(Work(ip_A_l),kCol,
     &                          Work(ip_Am),Work(ip_Qm),nMem,
     &                          Lu_A(iIrrep),Lu_Q(iIrrep),
     &                          Work(ip_Scr),lScr,
     &                          Work(ipZ),Work(ipX),ThrQ,
     &                          Work(ip_Q_l),LinDep)

            If (LinDep.ne.0) Then
               Call WarningMessage(2,'Error in Post_2Center_RI')
               Write(6,*) 'Inv_Cho_Factor found linear dependence!'
               Call Abend()
            End If
*
*           Write the new A/Q-vector to file
*
            iAddr_=iAddr
            If (kCol.eq.nMem) Then
               nQm=kCol*(kCol+1)/2
               Call dDaFile(Lu_Q(iIrrep),1,Work(ip_Qm),nQm,iAddr )
               Call dDaFile(Lu_A(iIrrep),1,Work(ip_Am),nQm,iAddr_)
            Else If (kCol.gt.nMem) Then
               Call dDaFile(Lu_Q(iIrrep),1,Work(ip_Q_k),kCol,iAddr )
               Call dDaFile(Lu_A(iIrrep),1,Work(ip_A_l),kCol,iAddr_)
            End If
*
         End Do
*
         Call GetMem('ICF','Free','Real',ip_ICF,lAm+lQm+5*nXZ)
         Call DaClos(Lu_A(iIrrep))
 777     Continue
      End Do ! iIrrep
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Sort the Q-matrix back to the original order.
*
      Call GetMem('MemMax','Max','Real',iDummy,MaxMem2)
*
      If (Force_Out_of_Core) MaxMem2=2*nBfnTot
      lScr=Min(MaxMem2,Max(nBfn2,2*nBfnTot))
      Call GetMem('Scr','Allo','Real',ip_Scr,lScr)
*
      Call SORT_mat(irc,Work(ipA_Diag),nDmA,nDmB,iWork(ip_iDiag),nIrrep,
     &                  LU_Q,'Restore',lScr,Work(ip_Scr))
*
*     Note: after the 'Restore' call to Sort_mat, the Q-matrix is
*           no longer stored as upper-triangular but as RECTANGULAR
*           (nDmA,nDmB). The column index is still pivoted.
*
      Call GetMem('Scr','Free','Real',ip_Scr,lScr)
      Call GetMem('iD_Diag','Free','Inte',ip_iDiag,nA_Diag)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine AIAI(BUFOUT,INDOUT,ICAD,IBUFL,KBUF,NTPB,NBINS)

use guga_global, only: COUP, COUP1, IADD11, ICH, ICOUP, IJ, ILIM, IRC, IV0, IVF0, IWAY, IX, J1, J2, JM, JM1, JNDX, LN, LNP, Lu_11, &
                       MXVERT
use Definitions, only: wp, iwp, RtoI

implicit none
real(kind=wp), intent(inout) :: BUFOUT(*)
integer(kind=iwp), intent(inout) :: INDOUT(*), ICAD(*), IBUFL(*)
integer(kind=iwp), intent(in) :: KBUF, NTPB, NBINS
integer(kind=iwp) :: I, IAD110, ICP, ICPP, ICQ, IDIV, IFAI, IIJ, IJJ, IJM, IJS, IN_, IPOS, ISTOP, ISU, ISUM, IT1, IT2, ITAIL, ITT, &
                     IVL, JND1, KBUF0, KBUF1, KBUF2, KM, NBN, NI
real(kind=wp) :: CP
logical(kind=iwp) :: do_loop

KBUF0 = RtoI*KBUF
KBUF1 = KBUF0+KBUF+1
KBUF2 = KBUF1+1
IDIV = RtoI
do NI=1,LN
  I = ICH(NI)
  IIJ = (I*(I+1))/2
  IJS = IJ(I+1)+1
  IJM = IJ(I)
  do ITT=2,ILIM
    IT1 = (ITT-1)*MXVERT
    IT2 = IT1
    do IJJ=IJS,IJM
      ITAIL = IX(IT1+IJJ)
      IWAY(I) = 1
      loop_1: do
        KM = I
        J2(KM+1) = IJJ
        J1(KM+1) = IJJ
        JM(KM) = IVF0+1
        JM1(KM) = IVF0+1
        IFAI = 0
        call LOOP26(KM,ISTOP,IFAI,IT1,IT2)
        if (ISTOP == 1) exit
        if (J1(KM) /= J2(KM)) cycle
        do_loop = .true.
        do while (do_loop)
          KM = KM-1
          if (KM == 0) then
            IVL = J2(1)
            ISUM = IV0-IVL
            ISU = IRC(ISUM)
            if (ISUM == 3) CP = COUP(1)
            if (ISUM /= 3) CP = COUP1(1)
            do IN_=1,ITAIL
              JND1 = JNDX(ISU+ICOUP(1)+IN_)
              if (JND1 == 0) cycle
              IPOS = (JND1-1)*LNP+IIJ
              NBN = (IPOS-1)/NTPB+1
              IBUFL(NBN) = IBUFL(NBN)+1
              ICQ = ICAD(NBN)
              ICP = ICQ/IDIV+IBUFL(NBN)
              BUFOUT(ICP) = CP
              ICPP = ICQ+KBUF0+IBUFL(NBN)
              INDOUT(ICPP) = IPOS
              if (IBUFL(NBN) < KBUF) cycle
              INDOUT(ICQ+KBUF1) = KBUF
              IAD110 = IADD11
              call iDAFILE(Lu_11,1,INDOUT(ICQ+1),KBUF2,IADD11)
              INDOUT(ICQ+KBUF2) = IAD110
              IBUFL(NBN) = 0
            end do
            if (I == 1) cycle loop_1
            KM = 1
          else
            IWAY(KM) = 1
          end if
          do
            JM(KM) = IVF0+1
            JM1(KM) = IVF0+1
            IFAI = 0
            call LOOP23(KM,ISTOP,IFAI,IT1,IT2)
            if (ISTOP == 1) then
              KM = KM+1
              if (KM == I) cycle loop_1
            else if (J1(KM) == J2(KM)) then
              exit
            end if
          end do
        end do
        do_loop = .false.
      end do loop_1
    end do
  end do
end do
! EMPTY LAST BUFFERS
do I=1,NBINS
  ICQ = ICAD(I)
  INDOUT(ICQ+KBUF1) = IBUFL(I)
  IAD110 = IADD11
  call iDAFILE(Lu_11,1,INDOUT(ICQ+1),KBUF2,IADD11)
  ICAD(I) = IAD110
end do

return

end subroutine AIAI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Filler(N,M,A)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension A(N,M)
      k=0
      Do i=1,N
        Do j=1,M
          k=k+1
          A(i,j)=1.000d0*j+0.100d0*i+0.001d0*k
        EndDo
      EndDo
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Valera Veryazov                                  *
!***********************************************************************
!***********************************************************************
!  SysAbendMsg
!
!> @brief
!>   Stop calculation
!> @author V. Veryazov
!>
!> @details
!> Print formatted message and stop the calculation.
!>
!> @param[in] Location routine name
!> @param[in] Text1    message text
!> @param[in] Text2    message text
!***********************************************************************

subroutine SysAbendMsg(Location,Text1,Text2)

implicit none
character(len=*), intent(in) :: Location, Text1, Text2

call SysWarnMsg(Location,Text1,Text2)
call Abend()

return

end subroutine SysAbendMsg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
      SUBROUTINE ReadIn_Dynamix(Task,nTasks,mTasks)
      IMPLICIT REAL*8 (a-h,o-z)
      INTEGER Task(nTasks)
*
C
C     Copy input from standard input to a local scratch file
C
      LuSpool=isfreeunit(21)
      CALL SpoolInp(LuSpool)
C
C     Read input
C
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix calls RdInp_Dynamix.'
#endif
      CALL RdInp_Dynamix(LuSpool,Task,nTasks,mTasks)
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix back from RdInp_Dynamix.'
#endif
C
C     Remove local copy of standard input
C
      CLOSE(LuSpool)
*
      RETURN
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Make_Fluctuating_Charges(nAtoms,iANr,nij,nPert,rMP,nElem,EC,Alpha)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, iANr(nAtoms), nij, nPert, nElem
real(kind=wp), intent(inout) :: rMP(nij,0:nElem-1,0:nPert-1)
real(kind=wp), intent(in) :: EC(3,nij), Alpha
real(kind=wp), allocatable :: A(:,:), AInv(:,:), dQ(:), Lambda(:)

!                                                                      *
!***********************************************************************
!                                                                      *
! For the A-matrix

call mma_allocate(AInv,nAtoms,nAtoms,label='AInv')
call mma_allocate(A,nAtoms,nAtoms,label='A')

call Build_AMatrix(nAtoms,iANr,A,AInv,EC,nij,Alpha)

call mma_deallocate(A)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the fluctuating charges

call mma_allocate(Lambda,nAtoms,label='Lambda')
call mma_allocate(dQ,nAtoms,label='dQ')

call Fluctuating(AInv,nAtoms,Lambda,dQ,nij,nPert,iANr,rMP,nElem,EC,Alpha)

call mma_deallocate(Lambda)
call mma_deallocate(dQ)
call mma_deallocate(AInv)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Make_Fluctuating_Charges

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Rys2Dg(xyz2D0,nT,nRys,la,lb,lc,ld,xyz2D1,IfGrad,IndGrd,Coora,Alpha,Beta,Gmma,Delta,nZeta,nEta,Scrtch,Temp,Indx,ExpX, &
                  ExpY,mZeta,mEta)
!***********************************************************************
!                                                                      *
! Object: to compute the gradients of the 2D-integrals.                *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!***********************************************************************

use Constants, only: One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nT, nRys, la, lb, lc, ld, nZeta, nEta, mZeta, mEta
real(kind=wp), intent(in) :: xyz2D0(nRys*nT,0:la+1,0:lb+1,0:lc+1,0:ld+1,3), Coora(3,4), Alpha(nZeta), Beta(nZeta), Gmma(nEta), &
                             Delta(nEta)
real(kind=wp), intent(out) :: xyz2D1(nRys*nT,0:la,0:lb,0:lc,0:ld,3,3), Scrtch(nRys*nT), Temp(nT)
logical(kind=iwp), intent(inout) :: IfGrad(3,4)
integer(kind=iwp), intent(inout) :: IndGrd(3,4), Indx(3,4)
external :: ExpX, ExpY
integer(kind=iwp) :: i1, i2, ia, ib, ic, iCar, iCent, id, Ind1(3), Ind2(3), jCent, nVec, nx, ny, nz
real(kind=wp) :: Fact
logical(kind=iwp), external :: EQ

#ifdef _DEBUGPRINT_
iRout = 249
iPrint = nPrint(iRout)
if (iPrint >= 99) then
  call RecPrt(' In Rys2Dg: Alpha',' ',Alpha,1,nZeta)
  call RecPrt(' In Rys2Dg: Beta ',' ',Beta,1,nZeta)
  call RecPrt(' In Rys2Dg: Gamma',' ',Gmma,1,nEta)
  call RecPrt(' In Rys2Dg: Delta',' ',Delta,1,nEta)
  write(u6,*) ' IfGrad=',IfGrad
  write(u6,*) ' IndGrd=',IndGrd
end if
#endif
nx = 0
ny = 0
nz = 0
Indx(:,:) = 0

! Differentiate with respect to the first center

if (IfGrad(1,1) .or. IfGrad(2,1) .or. IfGrad(3,1)) then
  call ExpX(Temp,mZeta,mEta,Alpha,One)
  call Exp_2(Scrtch,nRys,nT,Temp,One)
  !if (iPrint >= 99) call RecPrt('Expanded exponents (alpha)',' ',Scrtch,nT,nRys)
end if
nVec = 0
if (IfGrad(1,1)) then
  nx = nx+1
  nVec = nVec+1
  Ind1(nVec) = nx
  Ind2(nVec) = 1
  Indx(1,1) = nx
end if
if (IfGrad(2,1)) then
  ny = ny+1
  nVec = nVec+1
  Ind1(nVec) = ny
  Ind2(nVec) = 2
  Indx(2,1) = ny
end if
if (IfGrad(3,1)) then
  nz = nz+1
  nVec = nVec+1
  Ind1(nVec) = nz
  Ind2(nVec) = 3
  Indx(3,1) = nz
end if

if (nVec /= 0) then

  do id=0,ld
    do ic=0,lc
      do ib=0,lb
        if (nVec == 3) then
          xyz2D1(:,0,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,1,ib,ic,id,Ind2(1))
          xyz2D1(:,0,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,1,ib,ic,id,Ind2(2))
          xyz2D1(:,0,ib,ic,id,Ind2(3),Ind1(3)) = Two*Scrtch(:)*xyz2D0(:,1,ib,ic,id,Ind2(3))
          if (la >= 1) then
            Fact = -One
            do ia=1,la
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia+1,ib,ic,id,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia-1,ib,ic,id,Ind2(1))
              xyz2D1(:,ia,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia+1,ib,ic,id,Ind2(2))+ &
                                                      Fact*xyz2D0(:,ia-1,ib,ic,id,Ind2(2))
              xyz2D1(:,ia,ib,ic,id,Ind2(3),Ind1(3)) = Two*Scrtch(:)*xyz2D0(:,ia+1,ib,ic,id,Ind2(3))+ &
                                                      Fact*xyz2D0(:,ia-1,ib,ic,id,Ind2(3))
              Fact = Fact-One
            end do
          end if
        else if (nVec == 2) then
          xyz2D1(:,0,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,1,ib,ic,id,Ind2(1))
          xyz2D1(:,0,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,1,ib,ic,id,Ind2(2))
          if (la >= 1) then
            Fact = -One
            do ia=1,la
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia+1,ib,ic,id,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia-1,ib,ic,id,Ind2(1))
              xyz2D1(:,ia,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia+1,ib,ic,id,Ind2(2))+ &
                                                      Fact*xyz2D0(:,ia-1,ib,ic,id,Ind2(2))
              Fact = Fact-One
            end do
          end if
        else if (nVec == 1) then
          xyz2D1(:,0,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,1,ib,ic,id,Ind2(1))
          if (la >= 1) then
            Fact = -One
            do ia=1,la
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia+1,ib,ic,id,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia-1,ib,ic,id,Ind2(1))
              Fact = Fact-One
            end do
          end if
        end if
      end do
    end do
  end do

end if

! Differentiate with respect to the second center

if (IfGrad(1,2) .or. IfGrad(2,2) .or. IfGrad(3,2)) then
  call ExpX(Temp,mZeta,mEta,Beta,One)
  call Exp_2(Scrtch,nRys,nT,Temp,One)
  !if (iPrint >= 99) call RecPrt('Expanded exponents (beta) ',' ',Scrtch,nT,nRys)
end if
nVec = 0
if (IfGrad(1,2)) then
  nx = nx+1
  nVec = nVec+1
  Ind1(nVec) = nx
  Ind2(nVec) = 1
  Indx(1,2) = nx
end if
if (IfGrad(2,2)) then
  ny = ny+1
  nVec = nVec+1
  Ind1(nVec) = ny
  Ind2(nVec) = 2
  Indx(2,2) = ny
end if
if (IfGrad(3,2)) then
  nz = nz+1
  nVec = nVec+1
  Ind1(nVec) = nz
  Ind2(nVec) = 3
  Indx(3,2) = nz
end if

if (nVec /= 0) then

  do id=0,ld
    do ic=0,lc
      do ia=0,la
        if (nVec == 3) then
          xyz2D1(:,ia,0,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,1,ic,id,Ind2(1))
          xyz2D1(:,ia,0,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,1,ic,id,Ind2(2))
          xyz2D1(:,ia,0,ic,id,Ind2(3),Ind1(3)) = Two*Scrtch(:)*xyz2D0(:,ia,1,ic,id,Ind2(3))
          if (lb >= 1) then
            Fact = -One
            do ib=1,lb
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib+1,ic,id,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia,ib-1,ic,id,Ind2(1))
              xyz2D1(:,ia,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib+1,ic,id,Ind2(2))+ &
                                                      Fact*xyz2D0(:,ia,ib-1,ic,id,Ind2(2))
              xyz2D1(:,ia,ib,ic,id,Ind2(3),Ind1(3)) = Two*Scrtch(:)*xyz2D0(:,ia,ib+1,ic,id,Ind2(3))+ &
                                                      Fact*xyz2D0(:,ia,ib-1,ic,id,Ind2(3))
              Fact = Fact-One
            end do
          end if
        else if (nVec == 2) then
          xyz2D1(:,ia,0,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,1,ic,id,Ind2(1))
          xyz2D1(:,ia,0,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,1,ic,id,Ind2(2))
          if (lb >= 1) then
            Fact = -One
            do ib=1,lb
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib+1,ic,id,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia,ib-1,ic,id,Ind2(1))
              xyz2D1(:,ia,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib+1,ic,id,Ind2(2))+ &
                                                      Fact*xyz2D0(:,ia,ib-1,ic,id,Ind2(2))
              Fact = Fact-One
            end do
          end if
        else if (nVec == 1) then
          xyz2D1(:,ia,0,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,1,ic,id,Ind2(1))
          if (lb >= 1) then
            Fact = -One
            do ib=1,lb
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib+1,ic,id,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia,ib-1,ic,id,Ind2(1))
              Fact = Fact-One
            end do
          end if
        end if
      end do
    end do
  end do

end if

! Differentiate with respect to the third center

if (IfGrad(1,3) .or. IfGrad(2,3) .or. IfGrad(3,3)) then
  call ExpY(Temp,mZeta,mEta,Gmma,One)
  call Exp_2(Scrtch,nRys,nT,Temp,One)
  !if (iPrint >= 99) Call RecPrt('Expanded exponents (Gamma)',' ',Scrtch,nT,nRys)
end if
nVec = 0
if (IfGrad(1,3)) then
  nx = nx+1
  nVec = nVec+1
  Ind1(nVec) = nx
  Ind2(nVec) = 1
  Indx(1,3) = nx
end if
if (IfGrad(2,3)) then
  ny = ny+1
  nVec = nVec+1
  Ind1(nVec) = ny
  Ind2(nVec) = 2
  Indx(2,3) = ny
end if
if (IfGrad(3,3)) then
  nz = nz+1
  nVec = nVec+1
  Ind1(nVec) = nz
  Ind2(nVec) = 3
  Indx(3,3) = nz
end if

if (nVec /= 0) then

  do id=0,ld
    do ib=0,lb
      do ia=0,la
        if (nVec == 3) then
          xyz2D1(:,ia,ib,0,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,1,id,Ind2(1))
          xyz2D1(:,ia,ib,0,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,1,id,Ind2(2))
          xyz2D1(:,ia,ib,0,id,Ind2(3),Ind1(3)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,1,id,Ind2(3))
          if (lc >= 1) then
            Fact = -One
            do ic=1,lc
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic+1,id,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic-1,id,Ind2(1))
              xyz2D1(:,ia,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic+1,id,Ind2(2))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic-1,id,Ind2(2))
              xyz2D1(:,ia,ib,ic,id,Ind2(3),Ind1(3)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic+1,id,Ind2(3))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic-1,id,Ind2(3))
              Fact = Fact-One
            end do
          end if
        else if (nVec == 2) then
          xyz2D1(:,ia,ib,0,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,1,id,Ind2(1))
          xyz2D1(:,ia,ib,0,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,1,id,Ind2(2))
          if (lc >= 1) then
            Fact = -One
            do ic=1,lc
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic+1,id,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic-1,id,Ind2(1))
              xyz2D1(:,ia,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic+1,id,Ind2(2))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic-1,id,Ind2(2))
              Fact = Fact-One
            end do
          end if
        else if (nVec == 1) then
          xyz2D1(:,ia,ib,0,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,1,id,Ind2(1))
          if (lc >= 1) then
            Fact = -One
            do ic=1,lc
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic+1,id,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic-1,id,Ind2(1))
              Fact = Fact-One
            end do
          end if
        end if
      end do
    end do
  end do

end if

! Differentiate with respect to the fourth center

if (IfGrad(1,4) .or. IfGrad(2,4) .or. IfGrad(3,4)) then
  call ExpY(Temp,mZeta,mEta,Delta,One)
  call Exp_2(Scrtch,nRys,nT,Temp,One)
  !if (iPrint >= 99) call RecPrt('Expanded exponents (delta)',' ',Scrtch,nT,nRys)
end if
nVec = 0
if (IfGrad(1,4)) then
  nx = nx+1
  nVec = nVec+1
  Ind1(nVec) = nx
  Ind2(nVec) = 1
  Indx(1,4) = nx
end if
if (IfGrad(2,4)) then
  ny = ny+1
  nVec = nVec+1
  Ind1(nVec) = ny
  Ind2(nVec) = 2
  Indx(2,4) = ny
end if
if (IfGrad(3,4)) then
  nz = nz+1
  nVec = nVec+1
  Ind1(nVec) = nz
  Ind2(nVec) = 3
  Indx(3,4) = nz
end if

if (nVec /= 0) then

  do ic=0,lc
    do ib=0,lb
      do ia=0,la
        if (nVec == 3) then
          xyz2D1(:,ia,ib,ic,0,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,1,Ind2(1))
          xyz2D1(:,ia,ib,ic,0,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,1,Ind2(2))
          xyz2D1(:,ia,ib,ic,0,Ind2(3),Ind1(3)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,1,Ind2(3))
          if (ld >= 1) then
            Fact = -One
            do id=1,ld
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,id+1,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic,id-1,Ind2(1))
              xyz2D1(:,ia,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,id+1,Ind2(2))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic,id-1,Ind2(2))
              xyz2D1(:,ia,ib,ic,id,Ind2(3),Ind1(3)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,id+1,Ind2(3))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic,id-1,Ind2(3))
              Fact = Fact-One
            end do
          end if
        else if (nVec == 2) then
          xyz2D1(:,ia,ib,ic,0,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,1,Ind2(1))
          xyz2D1(:,ia,ib,ic,0,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,1,Ind2(2))
          if (ld >= 1) then
            Fact = -One
            do id=1,ld
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,id+1,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic,id-1,Ind2(1))
              xyz2D1(:,ia,ib,ic,id,Ind2(2),Ind1(2)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,id+1,Ind2(2))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic,id-1,Ind2(2))
              Fact = Fact-One
            end do
          end if
        else if (nVec == 1) then
          xyz2D1(:,ia,ib,ic,0,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,1,Ind2(1))
          if (ld >= 1) then
            Fact = -One
            do id=1,ld
              xyz2D1(:,ia,ib,ic,id,Ind2(1),Ind1(1)) = Two*Scrtch(:)*xyz2D0(:,ia,ib,ic,id+1,Ind2(1))+ &
                                                      Fact*xyz2D0(:,ia,ib,ic,id-1,Ind2(1))
              Fact = Fact-One
            end do
          end if
        end if
      end do
    end do
  end do

end if

! Sum over common centers

do iCent=1,3
  do jCent=iCent+1,4
    if (EQ(Coora(1,iCent),Coora(1,jCent))) then
      do iCar=1,3

        if (IfGrad(iCar,iCent) .and. IfGrad(iCar,jCent)) then
          ! Change flags so gradient will not be assembled and
          ! that there will be no contribution to the gradient.
          IfGrad(iCar,jCent) = .false.
          IndGrd(iCar,jCent) = 0
          i1 = Indx(iCar,iCent)
          i2 = Indx(iCar,jCent)
          xyz2D1(:,:,:,:,:,iCar,i1) = xyz2D1(:,:,:,:,:,iCar,i1)+xyz2D1(:,:,:,:,:,iCar,i2)
        end if

      end do
    end if
  end do
end do

!if (iPrint >= 49) then
!  do iCn=1,4
!    do iCar=1,3
!      if (IfGrad(iCar,iCn)) then
!        ij = Indx(iCar,iCn)
!        do ia=0,la
!          do ib=0,lb
!            do ic=0,lc
!              do id=0,ld
!                write(Label,'(A,4(I2,'',''),A,'','',I2,A)') ' xyz2D1(',ia,ib,ic,id,ch(iCar),iCn,')'
!                if (iPrint >= 99) then
!                  call RecPrt(Label,' ',xyz2d1(1,ia,ib,ic,id,iCar,ij),nT,nRys)
!                else
!                  write(u6,'(A)') Label
!                  write(u6,*) DDot_(nT*nRys,xyz2d1(1,ia,ib,ic,id,iCar,ij),1,xyz2d1(1,ia,ib,ic,id,iCar,ij),1)
!                end if
!              end do
!            end do
!          end do
!        end do
!      end if
!    end do
!  end do
!end if

return

end subroutine Rys2Dg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Martin Schuetz                                   *
!               2017, Roland Lindh                                     *
!***********************************************************************

subroutine SwiOpt(AllCnt,OneHam,Ovrlp,mBT,CMO,mBB,nD)
!***********************************************************************
!                                                                      *
!     purpose: Switch from HF AO to MO optimization                    *
!                                                                      *
!***********************************************************************

use OneDat, only: sNoNuc, sNoOri
use Gateway_Info, only: ThrInt
use InfSCF, only: DltNth, DThr, EThr, FThr, nBO, nBT, nIterP, PotNuc
use SCFFiles, only: FnDel, FnDGd, FnDSt, FnGrd, FnOSt, FnTSt, Fnx, Fny, LuDel, LuDGd, LuDSt, LuGrd, LuOSt, LuTSt, Lux, Luy
use NDDO, only: twoel_NDDO
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: AllCnt
integer(kind=iwp), intent(in) :: mBT, mBB, nD
real(kind=wp), intent(out) :: OneHam(mBT), Ovrlp(mBT)
real(kind=wp), intent(inout) :: CMO(mBB,nD)
integer(kind=iwp) :: iComp, iD, iOpt, iRC, lOper
real(kind=wp) :: DNTh_o = Zero, DThr_o = Zero, EThr_o = Zero, FThr_o = Zero, ThrInt_o = Zero
character(len=8) :: Label

if (AllCnt .and. twoel_NDDO) then
  nIterP = 1
  ! read full overlap matrix from ONEINT file
  Label = 'Mltpl  0'
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  iRC = -1
  iComp = 1
  call RdOne(iRC,iOpt,Label,iComp,Ovrlp,lOper)
  call Error_check()
  ! read full one-electron Hamiltonian from ONEINT file
  Label = 'OneHam  '
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  iRC = -1
  call RdOne(iRC,iOpt,Label,iComp,OneHam,lOper)
  call Error_check()
  !call Get_PotNuc(PotNuc)
  !call Get_dScalar('PotNuc',PotNuc)
  call Peek_dScalar('PotNuc',PotNuc)
  ! orthonormalize CMO
  do iD=1,nD
    call Ortho(CMO(:,iD),nBO,Ovrlp,nBT)
  end do
  ! restore threshold values in WfCtl
  EThr = EThr_o
  call Put_dScalar('EThr',EThr)
  FThr = FThr_o
  DThr = DThr_o
  DltNTh = DNTh_o
  ThrInt = ThrInt_o
  ! set twoel to AllCnt...
  twoel_NDDO = .false.
  ! close and reopen some DA files...
  call DaClos(LuDSt)
  call DaClos(LuOSt)
  call DaClos(LuTSt)
  call DaClos(LuGrd)
  call DaClos(LuDGd)
  call DaClos(Lux)
  call DaClos(LuDel)
  call DaClos(Luy)
  call DAName(LuDSt,FnDSt)
  call DAName(LuOSt,FnOSt)
  call DAName(LuTSt,FnTSt)
  call DAName(LuGrd,FnGrd)
  call DAName(LuDGd,FnDGd)
  call DAName(Lux,Fnx)
  call DAName(LuDel,FnDel)
  call DAName(Luy,Fny)
else
  nIterP = 0
  ! read kinetic energy matrix, use space for overlap matrix,
  ! since that one is reread afterwards anyway...
  Label = 'Kinetic '
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  iRC = -1
  iComp = 1
  call RdOne(iRC,iOpt,Label,iComp,Ovrlp,lOper)
  call Error_check()
  ! read NDDO NA matrix from ONEINT file...
  Label = 'AttractS'
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  iRC = -1
  call RdOne(iRC,iOpt,Label,iComp,OneHam,lOper)
  call Error_check()
  ! and form NDDO one-electron Hamiltonian...
  OneHam(:) = OneHam(:)+Ovrlp(:)
  ! read NDDO overlap matrix from ONEINT file...
  Label = 'MltplS 0'
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  iRC = -1
  call RdOne(iRC,iOpt,Label,iComp,Ovrlp,lOper)
  call Error_check()
  ! save threshold values in WfCtl
  EThr_o = EThr
  FThr_o = FThr
  DThr_o = DThr
  DNTh_o = DltNTh
  ThrInt_o = ThrInt
  ! and set new thresholds
  !EThr = EThr*1.0e4_wp
  !call Put_dScalar('EThr',EThr)
  !FThr = FThr*1.0e4_wp
  !DThr = DThr*1.0e4_wp
  !DltNTh = DltNTh*1.0e4_wp
  !ThrInt = ThrInt_o*1.0e4_wp
  ! set twoel to OneCnt...
  twoel_NDDO = .true.
end if

return

contains

subroutine Error_check()

  use Definitions, only: u6

  if (iRC /= 0) then
    write(u6,*) 'SwiOpt: Error reading ONEINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if

end subroutine Error_check

end subroutine SwiOpt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Integer Function iNew(iTest,iIrrep)
      use Symmetry_Info
      Integer iTest(8)
      iNew = 0
*-----Test iTest against all rows thus far.
      Do 10 i = 1, iIrrep
*--------Do a intger inner product.
         iGo = 0
         Do 11 j = 1, nIrrep
            iGo = iGo + iTest(j)*iChTbl(i-1,j-1)
 11      Continue
         If (iGo.ne.0) Then
*-----------Here if row already defined.
            iNew = i
            Return
         End If
 10   Continue
      iNew = iIrrep+1
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

subroutine Freek2()
!***********************************************************************
!                                                                      *
!  Object: deallocate memory for pair entities                         *
!                                                                      *
! Called from: ClsSew                                                  *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden. November '92                            *
!***********************************************************************

use k2_structure, only: free_k2data, Indk2, k2_Processed
use stdalloc, only: mma_deallocate

implicit none

if (allocated(Indk2)) then

  ! Deallocate k2 entities

  call Free_k2data()

  call mma_deallocate(Indk2)
  k2_processed = .false.

end if

return

end subroutine Freek2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine mk_DeDe(FD,nFD,mFD,ipOffD,nOffD,ipDeDe,ipD00,MaxDe,
     &                   mDeDe,mIndij,Special_NoSym,DFT_Storage,
     &                   DeDe,nDeDe)
************************************************************************
*                                                                      *
* Object: to decontract, desymmetrize the 1st order density matrix.    *
*         The memory at this point is assumed to be large enough to do *
*         the computation in core.                                     *
*         The data is structured with respect to four indices, two (my *
*         ny or i j) refer to primitives or basis functions and two (a *
*         b) refer to the components of the cartesian or spherical     *
*         harmonic gaussians.                                          *
*                                                                      *
*         The indices are here ordered canonically!!!                  *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*             Modified for Hermite-Gauss quadrature November '90       *
*             Modified for Rys quadrature November '90                 *
*             Modified for multipole moments November '90              *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for general kernel routines January '91         *
*             Modified for nonsymmetrical operators February '91       *
*             Modified for gradients October '91                       *
*             Modified to process 1st order density matrices, Dec. '92 *
************************************************************************
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (A-H,O-Z)
#include "angtp.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "nsd.fh"
#include "setup.fh"
      Real*8 DeDe(nDeDe)
      Real*8, Dimension (:), Allocatable :: Scrt, DAO, DSOp, DSOc, DSO
      Real*8 FD(nFD,mFD)
      Character ChOper(0:7)*3
      Integer    iDCRR(0:7), nOp(2), ipOffD(2+mFD,nOffD)
      Logical AeqB, Special_NoSym, DFT_Storage
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 112
      iPrint = nPrint(iRout)
      Call CWTime(TCpu1,TWall1)
*
      If (iPrint.ge.99) Then
         Write (6,*)
         Write (6,*) ' Differential 1st order density matrix'
         iFD = 1
         Do iIrrep = 0, nIrrep - 1
            Write (6,*)
            Write (6,*) 'iIrrep=',iIrrep
            Do jFD = 1, mFD
               Write (6,*) 'jFD=',jFD
               Write (6,*)
               Call TriPrt(' Diagonal block',' ',
     &                     FD(iFD,jFD),nBas(iIrrep))
            End Do
            iFD = iFD + nBas(iIrrep)*(nBas(iIrrep)+1)/2
         End Do
      End If
*
      mIndij = 0
      iIrrep = 0
      jOffD = 0
      Inc=3
      If (mFD.eq.2) Inc=4
      Call ICopy(nOffD,[ipD00],0,ipOffD(1,1),Inc)
      If (mFD.eq.2) Call ICopy(nOffD,[ipD00],0,ipOffD(4,1),Inc)
      Call ICopy(nOffD,[nIrrep],0,ipOffD(2,1),Inc)
      Call ICopy(nOffD,[MaxDe],0,ipOffD(3,1),Inc)
*                                                                      *
************************************************************************
*                                                                      *
      Call Nr_Shells(nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*-----Double loop over shells. These loops decide the integral type
*     i.e. (dd), (dp), (pp), etc. This is the ab index.
*
      Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
*
         Do jS = 1, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            ijShll = iTri(iShell,jShell)
*
            iSmLbl = 1
            nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            If (nSO.eq.0) Go To 131
*                                                                      *
************************************************************************
*                                                                      *
            If (iPrint.ge.19) Then
               Write (6,*) 'iS,jS=',iS,jS
               Write (6,'(A,A,A,A,A)')
     &            ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
            End If
*
            Call mma_allocate(DAO,Max(iBas*jBas,iPrim*jPrim)*iCmp*jCmp,
     &                        label='DAO')
*
            AeqB = iS .eq. jS
*
*-----------Find the DCR for A and B
*
            iDCRR(0:nIrrep-1)=iOper(0:nIrrep-1)
            nDCRR=nIrrep
            LmbdR=1
            If (iPrint.ge.49) Write (6,'(10A)')
     &         ' {R}=(',(ChOper(iDCRR(i)),i=0,nDCRR-1),')'
*
*-----------Compute normalization factor due the DCR symmetrization
*           of the two basis functions and the operator.
*
            iuv = dc(mdci)%nStab*dc(mdcj)%nStab
            FactNd = DBLE(iuv)/DBLE(nIrrep * LmbdR)
            If (MolWgh.eq.1) Then
               FactNd = FactNd * DBLE(nIrrep)/DBLE(iuv)
            Else If (MolWgh.eq.2) Then
               FactNd = sqrt(DBLE(iuv))*DBLE(nIrrep)/DBLE(LmbdR)
            End If
*
*-----------Allocate memory for the elements of the Fock or 1st order
*           density matrix which are associated with the current shell
*           pair.
*
            Call mma_allocate(DSOp,nSO*iPrim*jPrim,label='DSOp')
            Call mma_allocate(DSOc,nSO*iBas *jBas,label='DSOc')
            Call mma_allocate(DSO,nSO*iPrim*jPrim,label='DSO')
            Call mma_allocate(Scrt,Max(iBas*jBas,iPrim*jPrim),
     &                        label='Scrt')
*
*-----------Introduce canonical order for the contracted basis
*
            If (iShell.ge.jShell) Then
              iSh   = iShell
              jSh   = jShell
              iAOi  = iAO
              jAOj  = jAO
              iBasi = iBas
              jBasj = jBas
              iPrimi= iPrim
              jPrimj= jPrim
              iAngi = iAng
              jAngj = jAng
              iCmpi = iCmp
              jCmpj = jCmp
              iShlli= iShll
              jShllj= jShll
            Else
              iSh   = jShell
              jSh   = iShell
              iAOi  = jAO
              jAOj  = iAO
              iBasi = jBas
              jBasj = iBas
              iPrimi= jPrim
              jPrimj= iPrim
              iAngi = jAng
              jAngj = iAng
              iCmpi = jCmp
              jCmpj = iCmp
              iShlli= jShll
              jShllj= iShll
            End If
*                                                                      *
************************************************************************
*                                                                      *
*           Loop over the density and the spin-density (optional)
*
            Do iFD = 1,  mFD
               If (iPrint.ge.99) Then
                  If (iFD.eq.1) Then
                     Write (6,*) 'Processing the density'
                  Else
                     Write (6,*) 'Processing the spin-density'
                  End If
               End If
*                                                                      *
************************************************************************
*                                                                      *
*-----------Gather the elements from 1st order density / Fock matrix.
*
            Call SOGthr(DSOc,iBasi,jBasj,nSO,FD(1,iFD),
     &                  n2Tri(iSmLbl),iSmLbl,
     &                  iCmpi,jCmpj,iSh,jSh,
     &                  AeqB,iAOi,jAOj)
*                                                                      *
************************************************************************
*                                                                      *
*-----------Project the Fock/1st order density matrix in AO
*           basis on to the primitive basis.
*
            If (iPrint.ge.99) Then
               Call RecPrt(' Left side contraction',' ',
     &                     Shells(iShll)%pCff,iPrimi,iBasi)
               Call RecPrt(' Right side contraction',' ',
     &                     Shells(jShll)%pCff,jPrimj,jBasj)
            End If
*
*-----------Transform IJ,AB to J,ABi
            Call DGEMM_('T','T',
     &                  jBasj*nSO,iPrimi,iBasi,
     &                  1.0d0,DSOc,iBasi,
     &                        Shells(iShll)%pCff,iPrimi,
     &                  0.0d0,DSOp,jBasj*nSO)
*-----------Transform J,ABi to AB,ij
            Call DGEMM_('T','T',
     &                  nSO*iPrimi,jPrimj,jBasj,
     &                  1.0d0,DSOp,jBasj,
     &                        Shells(jShll)%pCff,jPrimj,
     &                  0.0d0,DSO,nSO*iPrimi)
*-----------Transpose to ij,AB
            Call DGeTmO(DSO,nSO,nSO,iPrimi*jPrimj,DSOp,
     &                  iPrimi*jPrimj)
*
            If (iPrint.ge.99) Call
     &         RecPrt(' Decontracted 1st order density/Fock matrix',' ',
     &                        DSOp,iPrimi*jPrimj,nSO)
*                                                                      *
************************************************************************
*                                                                      *
*-----------Loops over symmetry operations.
*
            nOp(1) = NrOpr(0)
            If (iFD.eq.1) Then
*
*------------- Store away pointer to the block of density info
*
               ipOffD(1,ijShll) = jOffD + ipDeDe
               ipOffD(2,ijShll) = nDCRR
               If (nIrrep.eq.1.and.Special_NoSym) Then
                  ipOffD(3,ijShll) = iCmp*jCmp
     &                             + iPrim*jPrim + 1
               Else
                  ipOffD(3,ijShll) = iCmp*jCmp*(iBas*jBas+1)
     &                             + iPrim*jPrim + 1
               End If
            Else
*
*------------- Store away pointer to the block of spin-density info
*
               ipOffD(4,ijShll) = jOffD + ipDeDe
            End If
            mIndij = mIndij + (nIrrep/dc(mdci)%nStab)*
     &                        (nIrrep/dc(mdcj)%nStab)
            If (iPrint.ge.99) Then
               Write (6,*) ' ipDeDe+jOffD,nDCRR,iCmp*jCmp*iBas*jBas=',
     &                       ipDeDe+jOffD,nDCRR,iCmp*jCmp*iBas*jBas
            End If
            Do lDCRR = 0, nDCRR-1
               nOp(2) = NrOpr(iDCRR(lDCRR))
*                                                                      *
************************************************************************
*                                                                      *
*--------------Desymmetrize the 1st order density matrix(contracted).
*
               Call Desym1(iSmLbl,iAngi,jAngj,iCmpi,jCmpj,
     &                     iSh,jSh,iShlli,jShllj,iAOi,jAOj,
     &                     DAO,iBasi,jBasj,
     &                     DSOc,nSO,nOp,FactNd,Scrt)
*
*--------------Store away result
*
               Temp=Zero
               ipStart=ipDeDe+jOffD
               If (DFT_Storage) Then
*
*---------------- Storage format for numerical integration
*
*                 D(iBas*iCmp,jBas*jCmp)
*
                  Call ResortD(DAO,DeDe(ipStart),
     &                         iBas,iCmp,jBas,jCmp)
                  jOffD = jOffD + iBas*iCmp*jBas*jCmp
*
               Else
*
*---------------- Storage format for direct SCF
*
*                 D(iBas*jBas+1,iCmp*jCmp)
*
                  jpDAO = 1
                  Do ijCmp = 1, iCmp*jCmp
                     If (nIrrep.ne.1.or..Not.Special_NoSym) Then
                        call dcopy_(iBas*jBas,DAO(jpDAO),1,
     &                                       DeDe(ipDeDe+jOffD),1)
                        jOffD = jOffD + iBas*jBas
                     End If
*--------------------Find the largest density for this angular
*                    combination
                     iHigh = iDAMax_(iBas*jBas,DAO(jpDAO),1)
                     DeDe(ipDeDe+jOffD) = Abs(DAO(jpDAO+iHigh-1))
                     If (Temp.lt.Abs(DAO(jpDAO+iHigh-1))) Then
                        Temp=Abs(DAO(jpDAO+iHigh-1))
                     End If
                     jOffD = jOffD + 1
                     jpDAO = jpDAO + iBas*jBas
                  End Do
                  If ( (nIrrep.ne.1.or..Not.Special_NoSym) .and.
     &                iPrint.ge.99) Call RecPrt(' DAO(+AMax)',' ',
     &               DeDe(ipStart),iBas*jBas+1,iCmp*jCmp)
               End If
*
               If (DFT_Storage) Go To 99
*                                                                      *
************************************************************************
*                                                                      *
*--------------Desymmetrize the 1st order density matrix(primitive).
*
               Call Desym1(iSmLbl,iAngi,jAngj,iCmpi,jCmpj,
     &                     iSh,jSh,iShlli,jShllj,iAOi,jAOj,
     &                     DAO,iPrimi,jPrimj,
     &                     DSOp,nSO,nOp,FactNd,Scrt)
*
*--------------Change order so it follows what is used in TwoEl
*
               ipStart=ipDeDe+jOffD
               Do j = 1, jPrimj
                  Do i = 1, iPrimi
                     ij = (j-1)*iPrimi + i
                     iHigh = IDAMax_(iCmpi*jCmpj,DAO(ij),
     &                       iPrimi*jPrimj)-1
                     DeDe(ipDeDe+jOffD) =
     &                       Abs(DAO(ij+iHigh*iPrimi*jPrimj))
                     jOffD = jOffD + 1
                  End Do
               End Do
*--------------Find the overall largest density
               DeDe(ipDeDe+jOffD) = Temp
               jOffD = jOffD + 1
               If (iPrint.ge.99) Then
                  Call RecPrt(' D,prim',' ',
     &               DeDe(ipStart),iPrimi,jPrimj)
                  Write (6,*) ' Max(DAO)=',Temp
               End If
*
 99            Continue
*                                                                      *
************************************************************************
*                                                                      *
            End Do  ! lDCRR
*                                                                      *
************************************************************************
*                                                                      *
            End Do  ! iFD
*                                                                      *
************************************************************************
*                                                                      *
            Call mma_deallocate(Scrt)
            Call mma_deallocate(DSO)
            Call mma_deallocate(DSOc)
            Call mma_deallocate(DSOp)
            Call mma_deallocate(DAO)
 131        Continue
         End Do
      End Do
      mDeDe = jOffD
*
      If (mDeDe.ne.nDeDe) Then
         Write (6,*) 'DeDe:  mDeDe =', mDeDe,' nDeDe =', nDeDe
         Call ErrTra
         Call Abend
      End If
*
      Call CWTime(TCpu2,TWall2)
      Call SavTim(2,TCpu2-TCpu1,TWall2-TWall1)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nDInf)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************
!  Qfread
!
!> @brief
!>   Read in all data that comes from external Molcas routines and prepare various quantities, such as MME
!> @author A. Ohrn
!>
!> @details
!> This subroutine handles the interaction with the rest of Molcas.
!> Here orbitals and various matrices are stored and to some extent
!> modified to our purpose. We call on this subroutine even when
!> we are running classical stuff. The reason for this is that we
!> wish to collect some numbers, but really, we could easily have
!> constructed thing differently so that this subroutine only would
!> be called when quantum-classical stuff is running. For RASSI
!> implementation, we also read in and transform the transition density
!> matrix. At the end, we also call the routines that make the
!> multicenter multipole expansion.
!>
!> @note
!> Seward is mandatory for both SCF and RASSI. For SCF also,
!> Motra, Averd; for RASSI also, RASSCF and RASSI.
!>
!> @param[in]  iQ_Atoms
!> @param[out] nAtomsCC Atoms in solvent
!> @param[out] Coord    Unique coordinates of the atoms in the molecule in the QM-region
!> @param[out] nBas     Number of basis functions in QM-region
!> @param[out] nBasCC   Like nBas but for a solvent molecule
!> @param[out] nOcc     The total number of basis functions that belong to a certain basis-function type.
!> @param[out] natyp    Number of atoms of the i:th basis-function type
!> @param[out] nntyp    Number of basis-function types.
!***********************************************************************

!******JoseMEP the last three variables are included to the MEP calculation
subroutine Qfread(iQ_Atoms,nAtomsCC,Coord,nBas,nBasCC,nOcc,natyp,nntyp)

use qmstat_global, only: Alfa, ATitle, BasOri, Beta, c_orbene, ChaNuc, Cont, CT, Dont, info_atom, iOrb, iPrint, iQang, iQn, &
                         iWoGehenC, iWoGehenQ, Joblab, lmax, mPrimus, MxAngqNr, MxSymQ, nBA_C, nBA_Q, nBonA_C, nBonA_Q, nCBoA_C, &
                         nCBoA_Q, nCnC_C, nPrimus, PotNuc, QmType, SavOri, Trans, V1, V3
use qmstat_procedures, only: GiveMeInfo
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms
integer(kind=iwp), intent(out) :: nAtomsCC, nBas(MxSymQ), nBasCC(1), nOcc(iQ_Atoms), natyp(iQ_Atoms), nntyp
real(kind=wp), intent(out) :: Coord(3,iQ_Atoms)
integer(kind=iwp) :: i, iAtom, iBas, icont, iDummy(1), iErr, iLu, ind, indold, iold, iWarn, ix, j, jnd, k, kk, kold, l, lLine, na, &
                     nnaa, nntypC, nSize, nSym, nSymCC, ntBas
real(kind=wp) :: ChgeCC(3), CoordCC(3*3), Dummy(1)
character(len=120) :: Line, StLine
character(len=100) :: OrbName, Title
character(len=10) :: WhatGet
integer(kind=iwp), allocatable :: iC_Icon(:,:), Icon(:,:), natypC(:), nfSh(:,:), nSh(:)
real(kind=wp), allocatable :: C(:,:), Chge(:), Cmo(:,:), Cmo_S(:), E(:,:), Occu(:), Oe(:), Tmp(:,:), TransC(:)
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

!----------------------------------------------------------------------*
! Enter                                                                *
!----------------------------------------------------------------------*

!----------------------------------------------------------------------*
! Print the joblabel. It is obtained in get_input                      *
!----------------------------------------------------------------------*
if (ATitle) then
  lLine = len(Line)
  do i=1,lLine
    StLine(i:i) = '*'
  end do
  write(u6,*)
  do i=1,6
    Line = ''
    if ((i == 1) .or. (i == 6)) Line = StLine
    if (i == 3) Line = 'Project:'
    if (i == 4) write(Line,'(A72)') JobLab
    call Center_Text(Line)
    write(u6,*) '*'//Line//'*'
  end do
  write(u6,*)
end if
write(u6,*) 'Auxiliary data being read and pre-processed.'
!----------------------------------------------------------------------*
! Collect some data from RUNFILE about the QM-region molecule.         *
!----------------------------------------------------------------------*
call Get_iScalar('nSym',nSym)
if (nSym /= 1) then !A minor restriction, no symmetry allowed, i.e. nSym=1.
  write(u6,*)
  write(u6,*) ' QmStat does not run with symmetry!'
  write(u6,*) ' The perturbation from the solvent breaks all symmetry.'
  call Quit(_RC_GENERAL_ERROR_)
end if
call Get_iScalar('Unique atoms',iQ_Atoms)
call mma_allocate(Chge,iQ_Atoms,label='Chge')
call Get_dArray('Nuclear charge',Chge,iQ_Atoms)
call Get_dArray('Unique Coordinates',Coord,3*iQ_Atoms)
call Get_dArray('Center of Mass',CT,3)
call Get_iArray('nBas',nBas,nSym)

!----------------------------------------------------------------------*
! Print elementary information about molecule.                         *
!----------------------------------------------------------------------*
write(u6,*)
write(u6,*) '     ------------------------------'
write(u6,*) '     |       QM-region data       |'
write(u6,*) '     ------------------------------'
write(u6,*)
write(u6,'(A,15X,I5)') '      Number of basis functions:',(nBas(i),i=1,nSym)
write(u6,'(A,3F10.6)') '      Centre of mass =',(CT(kk),kk=1,3)
call PrCoor()

!----------------------------------------------------------------------*
! If the Qmtype is SCF we now want the orbitals. On the other hand if  *
! we are running RASSI, another route must be taken, hence here we     *
! inquire which QM-method is used.                                     *
!----------------------------------------------------------------------*
if (QmType(1:3) == 'SCF') then
  !--------------------------------------------------------------------*
  !    SSS    CCC  FFFFFF                                              *
  !   SS    CC     FF                                                  *
  !    SS  CC      FFFF                                                *
  !     SS  CC     FF                                                  *
  !   SSS    CCC   FF                                                  *
  !--------------------------------------------------------------------*

  !--------------------------------------------------------------------*
  ! Print information about orbitals and store coefficients in new     *
  ! variable.                                                          *
  !--------------------------------------------------------------------*
  iLu = 15
  iLu = IsFreeUnit(iLu)
  write(OrbName,'(A)') 'AVEORB'
  write(WhatGet,'(A)') 'CO'
  iWarn = 1
  call mma_allocate(Cmo,nBas(1),nBas(1),label='Cmo')
  call mma_allocate(Occu,nBas(1),label='Occu')
  call RdVec(OrbName,iLu,WhatGet,nSym,nBas,nBas,Cmo,Occu,Dummy,iDummy,Title,iWarn,iErr)
  if (iErr /= 0) then
    write(u6,*)
    write(u6,*) 'Error when reading AVEORB'
    write(u6,*)
    call Quit(_RC_IO_ERROR_READ_)
  end if
  call mma_allocate(V1,nBas(1),iOrb(1),label='OrbCoeffQ')
  V1(:,:) = Cmo(:,1:iOrb(1))
  !write(u6,'(A,I4)') '      Number of Orbitals:',iOrb(1)
  call Get_dScalar('PotNuc',PotNuc)

else if (QmType(1:4) == 'RASS') then
  !--------------------------------------------------------------------*
  !   RRRR      AA      SSS   SSS   II                                 *
  !   RR  R    A  A    SS    SS     II                                 *
  !   RR R    AAAAAA    SS    SS    II                                 *
  !   RRR     AA  AA     SS    SS   II                                 *
  !   RR R    AA  AA   SSS   SSS    II                                 *
  !--------------------------------------------------------------------*
  call TdmTrans(nBas)
end if
write(u6,*)
write(u6,*)
!----------------------------------------------------------------------*
! Compute various information about system. This we use for computing  *
! integrals later. GiveMeInfo collects stuff from seward, sometime with*
! some recomputations.                                                 *
!----------------------------------------------------------------------*
call mma_allocate(nSh,iQ_Atoms,label='nSh')
call mma_allocate(nfSh,iQ_Atoms,MxAngqNr,label='nfSh')
call mma_allocate(nBA_Q,iQ_Atoms,label='nBA_Q')
call mma_allocate(nBonA_Q,iQ_Atoms,label='nBonA_Q')
call mma_allocate(nCBoA_Q,iQ_Atoms,MxAngqNr,label='nCBoA_Q')
call GiveMeInfo(nntyp,natyp,BasOri,Icon,nPrimus,nBA_Q,nCBoA_Q,nBonA_Q,E,C,nSh,nfSh,nSize,iPrint,iQ_Atoms,MxAngqNr,Trans,ntBas)
iBas = 0
iAtom = 0
kold = 1
iold = 1
indold = 0
nOcc(1:nntyp) = 0
call mma_allocate(alfa,ntBas,0,label='alfa')
call mma_allocate(cont,ntBas,0,label='cont')
call mma_allocate(iWoGehenQ,ntBas,2*MxAngqNr-1,label='iWoGehenQ')
call mma_allocate(iQang,ntBas,label='iQang')
do i=1,nntyp
  na = natyp(i)
  do j=1,na
    ind = 0
    jnd = 0
    iAtom = iAtom+1
    ChaNuc(iAtom) = Chge(iAtom)
    info_atom(iAtom) = int(Chge(iAtom))
    do k=1,nSh(i)
      nnaa = nfSh(i,k)
      do l=1,nnaa
        ibas = ibas+1
        indold = indold+1
        nOcc(i) = nOcc(i)+2*k-1
        ind = ind+1
        iQang(ibas) = k
        icont = Icon(i,ind)
        !iCharOnBasQ(ibas) = int(Chge(iAtom))
        ! Here we construct an array of indices which is used to put right AO-overlap in right matrix pos.
        do ix=1,2*k-1
          if (k /= kold) then
            if (i /= iold) then
              Indold = Indold+nfSh(iold,kold)*(2*kold-2)
              iold = i
            else
              Indold = Indold+nfSh(i,kold)*(2*kold-2)
            end if
            kold = k
          end if
          iWoGehenQ(ibas,ix) = indold+nnaa*(ix-1)
        end do
        if (icont > size(cont,2)) then
          call mma_allocate(Tmp,size(alfa,1),icont,label='Tmp')
          Tmp(:,1:size(alfa,2)) = alfa
          call mma_deallocate(alfa)
          call move_alloc(Tmp,alfa)
          call mma_allocate(Tmp,size(cont,1),icont,label='Tmp')
          Tmp(:,1:size(cont,2)) = cont
          call mma_deallocate(cont)
          call move_alloc(Tmp,cont)
        end if
        alfa(ibas,1:icont) = E(i,jnd+1:jnd+icont)
        cont(ibas,1:icont) = C(i,jnd+1:jnd+icont)
        jnd = jnd+icont
      end do
    end do
  end do
end do
! Now we do not need them, so deallocate
call mma_deallocate(Chge)
call mma_deallocate(Icon)
call mma_deallocate(E)
call mma_deallocate(C)

!----------------------------------------------------------------------*
! Obtain and print information about solvent. This requires a renaming *
! of the runfile.                                                      *
!----------------------------------------------------------------------*
call NameRun('WRUNFIL')
call Get_iScalar('nSym',nSymCC)
if (nSymCC /= 1) then
  write(u6,*)
  write(u6,*) ' QmStat does not run with symmetry!'
  call Quit(_RC_GENERAL_ERROR_)
end if
call Get_iScalar('Unique atoms',nAtomsCC)
if (nAtomsCC /= 3) then
  write(u6,*)
  write(u6,*) 'Now now... what strange solvent molecule do you try to feed QmStat with?'
  call Quit(_RC_GENERAL_ERROR_)
end if
call Get_dArray('Nuclear charge',ChgeCC,nAtomsCC)
call Get_dArray('Unique Coordinates',CoordCC,3*nAtomsCC)
call Get_iArray('nBas',nBasCC,nSymCC)
write(u6,*)
write(u6,*) '     ------------------------------'
write(u6,*) '     |   Solvent molecule data     |'
write(u6,*) '     ------------------------------'
write(u6,*)
write(u6,'(A,15X,I5)') '      Number of basis functions:',(nBasCC(i),i=1,nSymCC)
call PrCoor()

! Collect information about the solvent orbitals.

iLu = IsFreeUnit(16)
write(OrbName,'(A)') 'SOLORB'
write(WhatGet,'(A)') 'CE'
iWarn = 1
call mma_allocate(Oe,sum(nBasCC),label='OrbitalEnergy')
call mma_allocate(Cmo_S,nBasCC(1)**2,label='Cmo_S')
call RdVec(OrbName,iLu,WhatGet,nSymCC,nBasCC,nBasCC,Cmo_S,Dummy,Oe,iDummy,Title,iWarn,iErr)
call mma_allocate(c_orbene,iOrb(2),label='c_orbene')
c_orbene(1:iOrb(2)) = Oe(1:iOrb(2))
call mma_deallocate(Oe)

! We should not need two solvent orbital vectors, so this should
! be removed when the orbital rotation routine is fixed.

call mma_allocate(V3,nBasCC(1),iOrb(2),label='V3')
do j=1,iOrb(2)
  do k=1,nBasCC(1)
    V3(k,j) = Cmo_S(k+(j-1)*nBasCC(1))
  end do
end do
call mma_deallocate(Cmo_S)
!write(u6,'(A,I4)') '      Number of Orbitals:',iOrb(2)
write(u6,*)
write(u6,*)
!----------------------------------------------------------------------*
! And now basis set information.                                       *
!----------------------------------------------------------------------*
if (nAtomsCC /= iQ_Atoms) then
  call mma_deallocate(nSh)
  call mma_deallocate(nfSh)
  call mma_allocate(nSh,nAtomsCC,label='nSh')
  call mma_allocate(nfSh,nAtomsCC,MxAngqNr,label='nfSh')
end if
call mma_allocate(natypC,nAtomsCC,label='natypC')
call mma_allocate(nBA_C,nAtomsCC,label='nBA_C')
call mma_allocate(nBonA_C,nAtomsCC,label='nBonA_C')
call mma_allocate(nCBoA_C,nAtomsCC,MxAngqNr,label='nCBoA_C')
call GiveMeInfo(nntypC,natypC,SavOri,iC_Icon,mPrimus,nBA_C,nCBoA_C,nBonA_C,E,C,nSh,nfSh,nSize,iPrint,nAtomsCC,MxAngqNr,TransC,ntBas)
iBas = 0
iAtom = 0
kold = 1
iold = 1
indold = 0
call mma_allocate(beta,ntBas,0,label='beta')
call mma_allocate(dont,ntBas,0,label='dont')
call mma_allocate(iWoGehenC,ntBas,2*MxAngqNr-1,label='iWoGehenC')
call mma_allocate(iQn,ntBas,label='iQn')
call mma_allocate(nCnC_C,ntBas,label='nCnC_C')
Lmax = ntBas
do i=1,nntypC !Like the corresponding thing above for the QM-region.
  na = natypC(i)
  do j=1,na
    ind = 0
    jnd = 0
    iAtom = iAtom+1
    do k=1,nSh(i)
      nnaa = nfSh(i,k)
      do l=1,nnaa
        ibas = ibas+1
        indold = indold+1
        nCnC_C(ibas) = nnaa
        ind = ind+1
        iQn(ibas) = k
        icont = iC_Icon(i,ind)
        !iCharOnBasC(ibas) = int(ChgeCC(iAtom))
        ! Here we construct an array of indices which is used to put right AO-overlap in right matrix pos.
        do ix=1,2*k-1
          if (k /= kold) then
            if (i /= iold) then
              Indold = Indold+nfSh(iold,kold)*(2*kold-2)
              iold = i
            else
              Indold = Indold+nfSh(i,kold)*(2*kold-2)
            end if
            kold = k
          end if
          iWoGehenC(ibas,ix) = indold+nnaa*(ix-1)
        end do
        if (icont > size(dont,2)) then
          call mma_allocate(Tmp,size(beta,1),icont,label='Tmp')
          Tmp(:,1:size(beta,2)) = beta
          call mma_deallocate(beta)
          call move_alloc(Tmp,beta)
          call mma_allocate(Tmp,size(dont,1),icont,label='Tmp')
          Tmp(:,1:size(dont,2)) = dont
          call mma_deallocate(dont)
          call move_alloc(Tmp,dont)
        end if
        beta(ibas,1:icont) = E(i,jnd+1:jnd+icont)
        dont(ibas,1:icont) = C(i,jnd+1:jnd+icont)
        jnd = jnd+icont
      end do
    end do
  end do
end do
if (size(TransC) > size(Trans)) then
  call mma_deallocate(Trans)
  call move_alloc(TransC,Trans)
else
  call mma_deallocate(TransC)
end if
! Now we do not need them, so deallocate.
call mma_deallocate(natypC)
call mma_deallocate(nSh)
call mma_deallocate(nfSh)
call mma_deallocate(iC_Icon)
call mma_deallocate(E)
call mma_deallocate(C)

!----------------------------------------------------------------------*
! The multipoles and the Hamiltonian matrix are radically different    *
! between the QM-method alternatives, so once more an inquire.         *
!----------------------------------------------------------------------*
call NameRun('RUNFILE')
if (QmType(1:3) == 'SCF') then
  call ScfHandM(Cmo,nBas,iQ_Atoms,nOcc,natyp,nntyp,Occu)
  call mma_deallocate(Cmo)
  call mma_deallocate(Occu)
else if (QmType(1:4) == 'RASS') then
  call RassiHandM(nBas,iQ_Atoms,nOcc,natyp,nntyp)
end if

!----------------------------------------------------------------------*
! Here is the end.                                                     *
!----------------------------------------------------------------------*
return

end subroutine Qfread

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,
     &                       lOff1,FactC,FactX,ipDLT,ipDSQ,ipFLT,ipFSQ,
     &                       MinMem,ipMSQ,ipNocc)

************************************************************************
*  Author : F. Aquilante
*
*  Purpose:
*          For a given set of total symmetric AO-densities
*          (hermitian matrix representation) and MO coefficients
*          this routine
*          computes the Coulomb and Exchange contributions
*          to the Fock matrix from Cholesky vectors in full storage
*
*          Coulomb term (Drs is the lower triangular matrix
*                        of r=s symmetry block. The diagonals
*                        are scaled by a factor 1/2 already in
*                        the packed density DLT, given as input)
*
*    F(pq) = F(pq) + FactC * Sum_J Lpq,J * (Sum_rs Drs*Lrs,J)
*
*
*          Exchange term (Crk is the squared matrix of MO coeff.
*                             of r=s symmetry block)
*
*    F(pq) = F(pq) - FactX * Sum_Jk [(Sum_r Crk * Lpr,J) * (Sum_s Csk * Lqs,J)]
*
*
*    Integral-fashion formula:
*
*    F(pq) =  Sum_rs Drs * [(pq|rs)  - 0.5 (ps|rq)]
*
*----------------------------------------------------------------------
*  DoCoulomb(nDen) :  specifies the densities for which coulomb term
*                     has to be computed
*
*  DoExchange(nDen) : specifies the densities for which exchange term
*                     has to be computed
*
*  FactC(nDen) : factor for the coulomb of the corresponding density
*  FactX(nDen) : factor for the exchange of the corresponding density
*
*  ip{X}LT(nDen) : pointer to the array containing {X} in LT storage
*  ip{X}SQ(nDen) : pointer to the array containing {X} in SQ storage
*    {X=D,F,M --- Density, Fock matrix, MOs coeff.}
*
*  MinMem(nSym) : minimum amount of memory required to read
*                 a single Cholesky vector in full storage
*
************************************************************************

      Implicit Real*8 (a-h,o-z)

      Integer   rc,nDen,nSym,nBas(nSym),NumCho(nSym),kOcc(nSym)
      Real*8    FactC(nDen),FactX(nDen)
      Integer   Lunit,KSQ1(nSym),ISTSQ(nSym),ISTLT(nSym),lOff1
      Integer   ipDLT(nDen),ipDSQ(nDen),ipFLT(nDen),ipFSQ(nDen)
      Integer   ipMSQ(nDen),ipNocc(nDen),MinMem(nSym),iSkip(nSym)
      Real*8    tread(2),tcoul(2),texch(2)
      Common /CHOUNIT / Lunit(8)
      Logical DoExchange(nDen),DoCoulomb(nDen),DoSomeX,DoSomeC
      Logical Debug,DensityCheck,Square,timings
      Logical REORD,DECO,ALGO
      COMMON   /CHOTIME /timings
      COMMON    /CHODENSITY/ DensityCheck
      Common /CHOSCF / REORD,DECO,dmpk,dFKmat,ALGO,NSCREEN
      Character*50 CFmt
      Character*11 SECNAM
      Parameter (SECNAM = 'CHO_FTWO_MO')

      Character*4 BaseNm
      Character*6 Fname
      Parameter (BaseNm = 'CHFV')

      parameter (zero = 0.0D0, one = 1.0D0, xone = -1.0D0)


#include "WrkSpc.fh"

**************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
**************************************************


#ifdef _DEBUGPRINT_
c      Debug=.true.
      Debug=.false.! to avoid double printing in SCF-debug
#else
      Debug=.false.
#endif

        CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        do i=1,2            ! 1 --> CPU   2 --> Wall
           tread(i) = zero  !time read/rreorder vectors
           tcoul(i) = zero  !time for computing Coulomb
           texch(i) = zero  !time for computing Exchange
        end do

c ISTSQ: Offsets to full symmetry block in DSQ,FSQ
c ISTLT: Offsets to packed LT symmetry blocks in DLT,FLT
        ISTSQ(1)=0
        ISTLT(1)=0
      DO ISYM=2,NSYM
        NB=NBAS(ISYM-1)
        NB2=NB*NB
        NB3=(NB2+NB)/2
        ISTSQ(ISYM)=ISTSQ(ISYM-1)+NB2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NB3
      END DO

      if(DensityCheck)then
        Thr=1.0d-12
        Square=.true.
        xf=2.0d0
        if (DECO) xf=1.0d0
        Do jDen=1,nDen
          Do jSym=1,nSym
           if (nBas(jSym).ne.0.and.iWork(ipNocc(jDen)+jSym-1).ne.0) then
             Call Getmem('Dchk','allo','real',ipDchk,nBas(jSym)**2)
             Call Cho_X_Test(Work(ipDSQ(jDen)+ISTSQ(jSym)),nBas(jSym),
     &                       Square,Work(ipMSQ(jDen)+ISTSQ(jSym)),
     &                       iWork(ipNocc(jDen)+jSym-1),xf,Work(ipDchk),
     &                       nBas(jSym)**2,Thr,irc)
             Call Getmem('Dchk','free','real',ipDchk,nBas(jSym)**2)
             if(irc.eq.0)then
                write(6,*)'*** DENSITY CHECK : OK! *** SYMM= ',jSym
             else
                write(6,*)'*** DENSITY CHECK FAILED IN SYMMETRY: ',
     &                    jSym,'FOR THE DENSITY NR. ',jDen
             endif
           endif
          End Do
        End Do
      endif


C --- Tests on the type of calculation
        DoSomeC=.false.
        DoSomeX=.false.
        MaxSym=0
c
        jD=0
        do while (jD.lt.nDen .and. .not.DoSomeX)
         jD=jD+1
         DoSomeX=DoExchange(jD)
        end do
        jD=0
        do while (jD.lt.nDen .and. .not.DoSomeC)
         jD=jD+1
         DoSomeC=DoCoulomb(jD)
        end do

        if (DoSomeX) Then
           MaxSym=nSym !we want to do some exchange
        Else
           If (DoSomeC) Then
                   MaxSym = 1 !we want to do only Coulomb
           Else
                   Return  !we are lazy and won''t do anything
           End If
        End If

C ********* Data from the Runfile
      Call get_iarray('NumCho',NumCho,nSym)

C *************** BIG LOOP OVER VECTORS SYMMETRY *****************
      DO jSym=1,MaxSym

      If (NumCho(jSym).lt.1) GOTO 1000

C --- Reading of the vectors is done in the full dimension
         do i=1,nSym
            KSQ1(i)=-666
         end do

C Open Files
       Do ksym=1,nSym
        if (nBas(ksym).ne.0) then
          iSymp=MulD2h(ksym,jSym)
          If (iSymp.ge.ksym) then
             Lunit(iSymp) = 7
             Write(Fname,'(A4,I1,I1)') BaseNm,iSymp,ksym
             Call DANAME_MF_WA(Lunit(iSymp),Fname)
          End If
        End If
       End Do


C ------------------------------------------------------


C SET UP THE READING
C ------------------
      Call GetMem('Maxavail','MAX ','REAL',KDUM,LWORK)

      If (MinMem(jSym) .gt. 0) Then
         nVec = Min(LWORK/MinMem(jSym),NumCho(jSym))
      Else
C         ***QUIT*** bad initialization
         WRITE(6,*) 'Cho_FTwo_MO: bad initialization'
         rc=99
         CALL Abend()
         nVec = -9999  ! dummy assignment - avoid compiler warnings
      End If

C...this is ONLY for debug:
c      nVec = min(nVec,1)

      If (nVec .gt. 0) Then
         nBatch = (NumCho(jSym) - 1)/nVec + 1
      Else
C         ***QUIT*** insufficient memory
         WRITE(6,*) 'Cho_FTwo_MO: Insufficient memory for batch'
         WRITE(6,*) 'LWORK= ',LWORK
         WRITE(6,*) 'min. mem. need= ',MinMem(jSym)
         WRITE(6,*) 'NumCho= ',NumCho(jsym)
         WRITE(6,*) 'jsym= ',jsym
         rc = 205
         CALL Abend()
         nBatch = -9999  ! dummy assignment
      End If


C *************** BATCHING  *****************

      DO iBatch = 1,nBatch

         If (iBatch .eq. nBatch) Then
            NumV = NumCho(jSym) - nVec*(nBatch - 1)
         Else
            NumV = nVec
         End If

         iVec = nVec*(iBatch - 1) + 1

C --- Allocate memory for reading the vectors
         kRdMem = MinMem(jSym)*NumV
         Call GetMem('MemR','ALLO','REAL',kWab,kRdMem)

c--- setup the skipping flags according to # of Occupied
      do k=1,nSym
         iSkip(k)=0
         l=Muld2h(k,jsym) !L(kl) returned if nOcc(k or l) .ne.0
         if (k.eq.l) then
            iSkip(k) = 666 ! always contribute to Coulomb
         else
          do jDen=1,nDen
               iSkip(k) = iSkip(k) + iWork(ipNocc(jDen)+k-1)
     &                             + iWork(ipNocc(jDen)+l-1)
          end do
         endif
      end do

C Max dimension of a symmetry block
        Nmax=0
        Do iSym=1,nSym
           if(NBAS(iSym).gt.Nmax .and. iSkip(iSym).ne.0)then
           Nmax = NBAS(iSym)
           iSymMax= iSym
           endif
        End Do
        NNmax = Nmax * (Nmax+1)/2

       CALL CWTIME(TCR1,TWR1)

       kcount=0
       Do ksym=1,nSym

         kSab = kWab + kcount

         iSymp=MulD2h(ksym,jSym)

         IF (nBas(kSym)*nBas(iSymp).ne.0) THEN

         If (iSymp.eq.ksym .and. iSkip(iSymp).ne.0) then
           NumB = NBAS(ksym)*(NBAS(ksym)+1)/2
           Call RdChoVec(Work(kSab),NumB,NumV,iVec,Lunit(iSymp))
           KSQ1(iSymp)=kSab
C --- Special trick for the vector L11 ; used to store X(a,Jb)
           if(ksym.eq.1.and.jSym.eq.1.and.DoSomeX)then
              kcount = kcount + lOff1 * NumV
           else
              kcount = kcount + NumB * NumV
           endif
         Else
           If (iSymp.gt.ksym .and. iSkip(iSymp).ne.0) then
           NumB = NBAS(ksym)*NBAS(iSymp)
           Call RdChoVec(Work(kSab),NumB,NumV,iVec,Lunit(iSymp))
           KSQ1(iSymp)=kSab
           kcount = kcount + NumB * NumV
           End If
         End If

         ENDIF

       End Do ! ends the loop over symmetries

       CALL CWTIME(TCR2,TWR2)
       tread(1) = tread(1) + (TCR2 - TCR1)
       tread(2) = tread(2) + (TWR2 - TWR1)


       kLab = kWab + kcount  ! pointer to the scratch space

#ifdef _DEBUGPRINT_
       write(6,*) 'Batch ',iBatch,' of ',nBatch,': NumV = ',NumV
       write(6,*) 'Total allocated:     ',kRdMem,' at ',kWab
       write(6,*) 'Memory pointers KSQ1:',(KSQ1(i),i=1,nSym)
       write(6,*) 'kcount:              ',kcount
       write(6,*) 'kLab:                ',kLab
       write(6,*) 'JSYM:                ',jSym
#endif

C
C --- Reading Done!
C
C ********************************************************************
      DO jDen=1,nDen

       IF (jSym.eq.1.and.DoCoulomb(jDen)) THEN
C
C *************** BEGIN COULOMB CONTRIBUTION  ****************
C
C---- Computing the intermediate vector V(J)
C
C --- Contraction with the density matrix
C ---------------------------------------
C --- V{#J} <- V{#J} + sum_rr L(rr,{#J})*D(rr)
C==========================================================
C
         CALL CWTIME(TCC1,TWC1)

         CALL FZERO(Work(kLab),NumV)
         DO iSymr=1,nSym
         IF(nBas(iSymr).ne.0.and.iWork(ipNocc(jDen)+iSymr-1).ne.0)THEN

         ISDLT = ipDLT(jDen) + ISTLT(ISYMR)
         Naa = nBas(iSymr)*(nBas(iSymr)+1)/2

         CALL DGEMV_('T',Naa,NumV,
     &              ONE,Work(KSQ1(iSymr)),Naa,
     &              Work(ISDLT),1,ONE,Work(kLab),1)

         ENDIF
         End DO

C --- Contraction with the 2nd vector
C ---------------------------------------
C --- Fss{#J} <- Fss{#J} + FactC * sum_J L(ss,{#J})*V{#J}
C==========================================================
C
          DO iSyms=1,nSym
          IF(nBas(iSyms).ne.0)THEN

           ISFLT = ipFLT(jDen) + ISTLT(ISYMS)
           Naa = nBas(iSyms)*(nBas(iSyms)+1)/2

           CALL DGEMV_('N',Naa,NumV,
     &              FactC(jDen),Work(KSQ1(iSyms)),Naa,
     &              Work(kLab),1,ONE,Work(ISFLT),1)

c           WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYMS
c           CALL TRIPRT('Coulomb FLT',' ',Work(ISFLT),nBas(iSyms))
          ENDIF
          End DO

        CALL CWTIME(TCC2,TWC2)
        tcoul(1) = tcoul(1) + (TCC2 - TCC1)
        tcoul(2) = tcoul(2) + (TWC2 - TWC1)

       ENDIF  ! jSym=1 & DoCoulomb

      END DO ! loop over densities for the Coulomb term

C *************** END COULOMB CONTRIBUTION  ****************
C
C WE INCLUDE THE DIAGONAL PART OF THE EXCHANGE HERE!!!!
C
C ********** REORDER and SQUARE ONE VECTOR AT THE TIME *****
C
C     CHOVEC(nrs,numv) ---> CHOVEC(nr,numv,ns)

       IF (jSym.eq.1.and.DoSomeX) THEN
         KQS1=0
         KQS2=0
         ISFSQ=0
         ISMSQ=0
         DO iSymr=1,nSym

          iSymr_Occ=0
          do jDen=1,nDen
             iSymr_Occ = iSymr_Occ + iWork(ipNocc(jDen)+iSymr-1)
          end do
          IF(nBas(iSymr).ne.0.and.iSymr_Occ.gt.0)THEN

             CALL CWTIME(TCREO1,TWREO1)

             KQS1 = KSQ1(ISYMR)
             KQS2 = kLab
             NRS  = NBAS(iSymr)*(NBAS(iSymr)+1)/2

             KOFF1=0
             KOFF2=0
             KOFF3=0

             iSQ = NBAS(iSymr)*NUMV
             Do JVEC=1,NUMV

                iLT = NRS*(JVEC-1)
                iVR = NBAS(iSymr)*(JVEC-1)

                Do jR=1,NBAS(iSymr)
                   Do jS=jR,NBAS(iSymr)

                      jSR = iTri(jS,jR)
                      KOFF1 = (KQS1-1) + iLT + jSR

                      KOFF2 = (KQS2-1) + iSQ*(jS-1) + iVR + jR

                      WORK(KOFF2) = WORK(KOFF1)

                      KOFF3 = (KQS2-1) + iSQ*(jR-1) + iVR + jS

                      WORK(KOFF3) = WORK(KOFF1)

                   End Do
                End Do
             End Do

             CALL CWTIME(TCREO2,TWREO2)
             tread(1) = tread(1) + (TCREO2 - TCREO1)
             tread(2) = tread(2) + (TWREO2 - TWREO1)

        DO jDen=1,nDen

           IF (DoExchange(jDen)) THEN

              kOcc(iSymr) = iWork(ipNocc(jDen)+iSymr-1)

           IF (kOcc(iSymr).ne.0) THEN

               CALL CWTIME(TC1X1,TW1X1)

C              Calculate intermediate:
C              X(k,Js) = Sum(r) C(r,k) * L(r,Js).
C              -----------------------------------
               iSyms=iSymr
               ISFSQ = ISTSQ(ISYMR) + ipFSQ(jDen)
               ISMSQ = ISTSQ(ISYMR) + ipMSQ(jDen)
               NK = kOcc(iSymr)

               CALL DGEMM_('T','N',
     &               NK,NUMV*NBAS(ISYMR),NBAS(iSYMR),
     &               ONE,WORK(ISMSQ),NBAS(ISYMR),
     &                   Work(KQS2), NBAS(ISYMR),
     &               ZERO,WORK(kWab),NK)

C              Calculate exchange contribution:
C              F(r,s) = F(r,s) - FactX * Sum(kJ) X(kJ,r) * X(kJ,s).
C              ----------------------------------------------------
c               CALL DGEMM_('T','N',
c     &                NBAS(ISYMR),NBAS(ISYMS),NK*NUMV,
c     &             -FactX(jDen),WORK(KWab),NK*NUMV,
c     &                          WORK(kWab),NK*NUMV,
c     &                      One,Work(ISFSQ),NBAS(ISYMR))

c *** Compute only the LT part of the exchange matrix ***************
               ipS=0
               ipF=0
               LKV=NK*NUMV
               DO jS=1,NBAS(iSymS)
                     ipS = kWab + LKV*(jS-1)
                     NBL = NBAS(iSymR) - (jS-1)
                     ipF = ISFSQ + NBAS(iSymR)*(jS-1) + (jS-1)

                     CALL DGEMV_('T',LKV,NBL,
     &                    -FactX(jDen),Work(ipS),LKV,
     &                    Work(ipS),1,ONE,Work(ipF),1)

               END DO

             CALL CWTIME(TC1X2,TW1X2)
             texch(1) = texch(1) + (TC1X2 - TC1X1)
             texch(2) = texch(2) + (TW1X2 - TW1X1)

         ENDIF  ! if kocc.ne.0

       ENDIF  ! Do Exchange(jDen)

      END DO  ! loop over the densities

      ENDIF   ! nbas.ne.0

c         write(6,*)'Symmetry block of FSQ= ',isymr
c         call recprt('FSQ','',Work(ISFSQ),NBAS(ISYMR),NBAS(ISYMR))

      END DO  !loop over Fock mat symmetries

      END IF  ! jSym=1 & DoSomeX

C ****************** END DIAGONAL EXCHANGE **********************
C
C ************ "OFF-DIAGONAL" EXCHANGE CONTRIBUTION  ************
C
       IF (jSym.ne.1) THEN

C
C  Reordering of the Cholesky vectors (ALL AT ONCE)
C
C              Reorder: L(qs,J) -> L(qJ,s).
C
C     CHOVEC(nq,ns,numv) ---> CHOVEC(nq,numv,ns)
C     ------------------------------------------
            CALL CWTIME(TCREO3,TWREO3)

            KQS1=0
            KQS2=0
            DO ISYMS = 1,NSYM

                  ISYMQ = MULD2H(ISYMS,JSYM)

            IF(nBas(iSyms)*nBas(iSymq).ne.0)THEN

             IF (ISYMQ.gt.ISYMS .and. iSkip(iSymq).ne.0) THEN

                  KQS1 = KSQ1(ISYMQ)
                  KQS2 = kLab + (KQS1 - kWab)

              KOFF1=0
              KOFF2=0
              DO JVEC = 1,NUMV

                DO jS=1,NBAS(iSyms)

                   KOFF1 = KQS1 + NBAS(iSymq)*NBAS(iSyms)*(JVEC-1)
     &                   + NBAS(iSymq)*(jS-1)

                   KOFF2 = KQS2 + NBAS(iSymq)*NUMV*(jS-1)
     &                   + NBAS(iSymq)*(JVEC-1)

                   CALL DCOPY_(NBAS(iSymq),Work(KOFF1),1,Work(KOFF2),1)

                END DO

              END DO   !loop over the vectors

             END IF  ! sym(Q) > sym(S)

            END IF

            END DO  !loop over symmetry blocks

            CALL CWTIME(TCREO4,TWREO4)
            tread(1) = tread(1) + (TCREO4 - TCREO3)
            tread(2) = tread(2) + (TWREO4 - TWREO3)

C     -------------- REORDERING DONE !! --------

       DO jDen=1,nDen

       IF (DoExchange(jDen)) THEN
C **** Occupation numbers needed for the Exchange term *****
              do iSym=1,nsym
                 kOcc(iSym) = iWork(ipNocc(jDen)+iSym-1)
              end do
C **********************************************************
C --- COMPUTE EXCHANGE FOR OFF-DIAGONAL VECTORS

            CALL CWTIME(TC2X1,TW2X1)

            DO ISYMG = 1,NSYM

               ISYMB = MULD2H(ISYMG,JSYM)

            IF(nBas(iSymb)*nBas(iSymg).ne.0)THEN

               KQS1 = kWab   !mem used to store the intermediate

               ISYMA = ISYMB     !block diagonal Fock Matrix
               ISYMD = ISYMG     !total symmetric densities

             IF (ISYMG.gt.ISYMB .and. iSkip(iSymg).ne.0) THEN

               KQS2 = kLab + (KSQ1(ISYMG) - kWab)

C -------------------------------
C --- F(a,b) = - D(g,d) * (ad|gb)
C -------------------------------
               NK = kOcc(iSymG)

               if(NK.ne.0)then

               ISFSQ = ISTSQ(ISYMB) + ipFSQ(jDen)
               ISMSQ = ISTSQ(ISYMG) + ipMSQ(jDen)


C              Calculate intermediate:
C              X(k,Jb) = Sum(g) C(g,k) * L(g,Jb).
C              ----------------------------------

               CALL DGEMM_('T','N',
     &                    NK,NUMV*NBAS(ISYMB),NBAS(ISYMG),
     &                    ONE,Work(ISMSQ),NBAS(ISYMG),Work(KQS2),
     &                    NBAS(ISYMG),ZERO,WORK(KQS1),NK)


C              F(a,b) = F(a,b) - Sum(kJ) X(kJ,a) * X(kJ,b).
C              -------------------------------------------

c               CALL DGEMM_('T','N',
c     &              NBAS(ISYMA),NBAS(ISYMB),NK*NUMV,
c     &              -FactX(jDen),WORK(KQS1),NK*NUMV,
c     & WORK(KQS1),NK*NUMV,ONE,Work(ISFSQ),NBAS(ISYMA))

c *** Compute only the LT part of the exchange matrix ***************
               ipB=0
               ipF=0
               LKV=NK*NUMV
               DO jB=1,NBAS(iSymB)
                     ipB = kQS1 + LKV*(jB-1)
                     NBL = NBAS(iSymA) - (jB-1)
                     ipF = ISFSQ + NBAS(iSymA)*(jB-1) + (jB-1)

                     CALL DGEMV_('T',LKV,NBL,
     &                    -FactX(jDen),Work(ipB),LKV,
     &                    Work(ipB),1,ONE,Work(ipF),1)

               END DO
c ******************************************************************

c         write(6,*)'Symmetry block of FSQ= ',isyma
c         write(6,*)'Symmetry block of DSQ= ',isymg
c         call recprt('FSQ','',Work(ISFSQ),NBAS(ISYMA),NBAS(ISYMA))
               endif

C -------------------------------
C --- F(g,d) = - D(a,b) * (ad|gb)
C -------------------------------
               NK = kOcc(iSymB)

               if(NK.ne.0)then

               ISFSQ = ISTSQ(ISYMG) + ipFSQ(jDen)
               ISMSQ = ISTSQ(ISYMB) + ipMSQ(jDen)

C              Calculate intermediate:
C              X(gJ,k) = Sum(a) L(gJ,a) * C(a,k).
C              ----------------------------------

               CALL DGEMM_('N','N',
     &                  NBAS(ISYMG)*NUMV,NK,NBAS(ISYMA),
     &                  ONE,Work(KQS2),NBAS(ISYMG)*NUMV,WORK(ISMSQ),
     &                  NBAS(ISYMA),ZERO,WORK(KQS1),NBAS(ISYMG)*NUMV)


C              F(g,d) = F(g,d) - Sum(Jk) X(g,Jk) * X(d,Jk).
C              -------------------------------------------

c               CALL DGEMM_('N','T',
c     &              NBAS(ISYMG),NBAS(ISYMD),NUMV*NK,
c     &              -FactX(jDen),WORK(KQS1),NBAS(ISYMG),
c     & WORK(KQS1),NBAS(ISYMD),ONE,Work(ISFSQ),NBAS(ISYMG))

c *** Compute only the LT part of the exchange matrix ***************
               ipG=0
               ipF=0
               LVK=NUMV*NK
               DO jD=1,NBAS(iSymD)
                     ipD = kQS1 + (jD-1)
                     NBL = NBAS(iSymG) - (jD-1)
                     ipF = ISFSQ + NBAS(iSymG)*(jD-1) + (jD-1)

                     CALL DGEMV_('N',NBL,LVK,
     &                    -FactX(jDen),Work(ipD),NBAS(iSymG),
     &                    Work(ipD),NBAS(iSymD),ONE,Work(ipF),1)
               END DO

c         write(6,*)'Symmetry block of FSQ= ',isymg
c         write(6,*)'Symmetry block of DSQ= ',isyma
c         call recprt('FSQ','',Work(ISFSQ),NBAS(ISYMG),NBAS(ISYMG))
               endif

             ENDIF

            ENDIF
            END DO  ! loop over orbital symmetries

            CALL CWTIME(TC2X2,TW2X2)
            texch(1) = texch(1) + (TC2X2 - TC2X1)
            texch(2) = texch(2) + (TW2X2 - TW2X1)


C ************ END "OFF-DIAGONAL" EXCHANGE CONTRIBUTION  ***********


       END IF  ! DoExchange section

      END DO  ! end of the loop over densities

      ENDIF ! jSym.ne.1


C --- Free the memory
         Call GetMem('MemR','FREE','REAL',kWab,kRdMem)

      END DO  ! end of the batch procedure

1000  CONTINUE

C -- Close Files
      Do ksym=1,nSym
       if (Lunit(ksym).ne.-1) then
         Call DACLOS(Lunit(ksym))
         Lunit(ksym) = -1
       end if
      End do

      END DO  ! loop over JSYM

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1


*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky SCF timing from '//SECNAM
      Write(6,CFmt)'------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ/REORDER VECTORS             '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB                          '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'EXCHANGE                         '
     &                           //'         ',texch(1),texch(2)

         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif

c Print the Fock-matrix
#ifdef _DEBUGPRINT_

      if(Debug) then !to avoid double printing in SCF-debug

      WRITE(6,'(6X,A)')'TEST PRINT FROM CHO_FTWO_MO.'
      WRITE(6,'(6X,A)')'***** EXCHANGE MATRIX ***** '
      Do jDen=1,nDen
          WRITE(6,'(6X,A,I2)')'DENSITY TYPE: ',jDen
          WRITE(6,'(6X,A,I2)')'DoExchange: ',DoExchange(jDen)
          WRITE(6,*)
      if(DoExchange(jDen))then
      icount=0
      DO ISYM=1,NSYM
      ISQ=ipFSQ(jDen)+icount
        NB=NBAS(ISYM)
        IF ( NB.GT.0 ) THEN
          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
          call cho_output(Work(ISQ),1,NB,1,NB,NB,NB,1,6)
          icount=icount+NB**2
        END IF
      END DO
      endif
      End Do

      endif

#endif

      rc  = 0

      Return
      END

**************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine ChkInp()
!***********************************************************************
!                                                                      *
!     Check the input for obvious errors or violation of limits        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use linalg_mod, only: abort_
use gas_data, only: iDoGAS, iGSOCCX, nGAS, nGSSH
use rasscf_global, only: iRoot, ITMAX, lRoots, MAXIT, MAXJT, NAC, NIN, nRoots, OutFmt1, OutFmt2, PreThr, ProThr, ThFact, ThrE, &
                         ThrEn, ThrSX, ThrTE
use general_data, only: INVEC, ISPIN, MALTER, NACTEL, NALTER, NASH, NBAS, NDEL, NELEC3, NFRO, NHOLE1, NISH, NORB, NRS1, NRS1T, &
                        NRS2, NRS2T, NRS3, NRS3T, NSEL, NSSH, NSYM, NTOT, STSYM
use Molcas, only: MxAct, MxBas, MxGAS, MxIna, MxOrb, MxRoot
use RASDim, only: MxCIIt, MxIter, MxSXIt
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: c_orbs_per_GAS(nGAS), iA0, iAlter, iB0, iC0, ierr, ierr1, ierr2, iSym
#include "warnings.h"

!c_orbs_per_GAS: These are the cumulated number of spin orbitals per GAS space.

!----------------------------------------------------------------------*
! Local print level (if any)
IERR = 0
if (NTOT > mxOrb) then
  write(u6,*)
  write(u6,*) '************ ERROR ******************'
  call WarningMessage(2,'Too many orbitals.')
  write(u6,'(1X,A,I8)') 'Too many orbitals NTOT=',NTOT
  write(u6,'(1X,A,I8)') 'Limit is MXORB=',MXORB
  write(u6,*) '*************************************'
  IERR = 1
end if
if (NAC > mxAct) then
  write(u6,*)
  write(u6,*) '*************** ERROR ***************'
  call WarningMessage(2,'Too many active orbitals.')
  write(u6,'(1X,A,I8)') 'Too many active orbitals NAC=',NAC
  write(u6,'(1X,A,I8)') 'Limit is MXACT=',MXACT
  write(u6,*) '*************************************'
  IERR = 1
end if
if (NIN > mxIna) then
  write(u6,*)
  write(u6,*) '*************** ERROR ***************'
  call WarningMessage(2,'Too many inactive orbitals.')
  write(u6,'(1X,A,I8)') 'Too many inactive orbitals NIN=',NIN
  write(u6,'(1X,A,I8)') 'Limit is MXINA=',MXINA
  write(u6,*) '*************************************'
  IERR = 1
end if
if (NACTEL > 2*NAC) then
  write(u6,*)
  write(u6,*) '********************* ERROR **********************'
  call WarningMessage(2,'Too many active electrons.')
  write(u6,'(1X,A,I6)') 'Too many active electrons NACTEL=',NACTEL
  write(u6,'(1X,A,I6)') 'Cannot be more than 2*Nr of active orbitals=',2*NAC
  write(u6,*) '**************************************************'
  IERR = 1
end if
if (NHOLE1 > 2*NRS1T) then
  write(u6,*)
  write(u6,*) '******************** WARNING *********************'
  call WarningMessage(1,'Too many holes in Ras1.')
  write(u6,'(1X,A,I6)') 'You allow too many holes in Ras1 NHOLE1=',NHOLE1
  write(u6,'(1X,A,I6)') 'Cannot be more than 2*Nr of Ras1 orbitals=',2*NRS1T
  NHOLE1 = 2*NRS1T
  write(u6,'(1X,A,I6)') 'NHOLE1 has been reset to ',NHOLE1
  write(u6,*) '**************************************************'
end if
if (NELEC3 > 2*NRS3T) then
  write(u6,*)
  write(u6,*) '******************** WARNING *********************'
  call WarningMessage(1,'Too many electrons in Ras3.')
  write(u6,'(1X,A,I6)') 'You allow too many electrons in Ras3 NELEC3=',NELEC3
  write(u6,'(1X,A,I6)') 'Cannot be more than 2*Nr of Ras3 orbitals=',2*NRS3T
  NELEC3 = 2*NRS3T
  write(u6,'(1X,A,I6)') 'NELEC3 has been reset to ',NELEC3
  write(u6,*) '**************************************************'
end if
if (.not. iDoGas) then !(DM)
  if (NACTEL > 2*(NRS1T+NRS2T)+NELEC3) then
    write(u6,*)
    write(u6,*) '********************* ERROR **********************'
    call WarningMessage(2,'Too many active electrons.')
    write(u6,'(1X,A,I8)') 'Too many active electrons NACTEL=',NACTEL
    write(u6,'(1X,A,I8)') '(Incompatible with RAS restrictions).'
    write(u6,*) '**************************************************'
    IERR = 1
  end if
  if (NACTEL < 2*NRS1T-NHOLE1) then
    write(u6,*)
    write(u6,*) '********************* ERROR **********************'
    call WarningMessage(2,'Too few active electrons.')
    write(u6,'(1X,A,I8)') 'Too few active electrons NACTEL=',NACTEL
    write(u6,'(1X,A,I8)') '(Incompatible with RAS restrictions).'
    write(u6,*) '**************************************************'
    IERR = 1
  end if
  if ((NHOLE1 == 0) .and. (NRS1T > 0)) then
    write(u6,*)
    write(u6,*) '******************* WARNING *******************'
    call WarningMessage(1,'You allow no holes in Ras1')
    write(u6,*) 'You allow no holes in Ras1.                    '
    write(u6,*) 'This may be deliberate, but may give numerical '
    write(u6,*) 'problems in SXCTL section.'
    write(u6,*) '***********************************************'
  end if
  if ((NELEC3 == 0) .and. (NRS3T > 0)) then
    write(u6,*)
    write(u6,*) '******************* WARNING *******************'
    call WarningMessage(1,'You allow no electrons in Ras3')
    write(u6,*) 'You allow no electrons in Ras3.'
    write(u6,*) 'This may be deliberate, but may give numerical '
    write(u6,*) 'problems in SXCTL section.'
    write(u6,*) '***********************************************'
  end if
! for GAS
else
  if (NGAS > mxGAS) then !(SJS)
    write(u6,*)
    call WarningMessage(2,'GASSCF: too many GAS spaces.')
    write(u6,*) ' ************* ERROR **************'
    write(u6,*) ' GASSCF: Too many GAS spaces. '
    write(u6,*) ' Can be increased up to 16 by changing'
    write(u6,*) ' mxGAS in the Molcas module'
    write(u6,*) ' **********************************'
    call Quit(_RC_INPUT_ERROR_)
  end if
  if (nactel /= igsoccx(ngas,2)) then
    write(u6,*)
    write(u6,*) '**************** ERROR *************************'
    write(u6,*) 'nactel not match occupation'
    write(u6,*) 'nactel=',nactel,'igsoccx:',igsoccx(ngas,2)
    write(u6,*) '************************************************'
  end if

  c_orbs_per_GAS = cumsum(sum(ngssh(:nGAS,:nSym),2)*2)
  if (any(c_orbs_per_GAS < igsoccx(:nGAS,1))) then
    write(u6,*)
    write(u6,*) 'In at least one GAS space, the minimum required '
    write(u6,*) 'particle number by GAS constraints '
    write(u6,*) 'is larger than the particle number '
    write(u6,*) 'allowed by the Pauli principle.'
    write(u6,*)
    call abort_('GASSCF: Pauli forbidden.')
  end if
  ! Conceptionally this should not be a problem, but the code
  ! assumes it to be not the case.
  if (any(c_orbs_per_GAS < igsoccx(:nGAS,2))) then
    write(u6,*)
    write(u6,*) 'In at least one GAS space, the maximum allowed '
    write(u6,*) 'particle number by GAS constraints '
    write(u6,*) 'is larger than the particle number '
    write(u6,*) 'allowed by the Pauli principle.'
    write(u6,*)
    call abort_('GASSCF: Pauli forbidden.')
  end if
end if
if ((NSYM /= 1) .and. (NSYM /= 2) .and. (NSYM /= 4) .and. (NSYM /= 8)) then
  write(u6,*)
  call WarningMessage(2,'Wrong nr of symmetries.')
  write(u6,*) '*************** ERROR ***************'
  write(u6,'(1X,A,I8)') 'Nr of symmetries NSYM=',NSYM
  write(u6,*) ' Only possible values are 1,2,4 or 8.'
  write(u6,*) '*************************************'
  IERR = 1
end if
if (IERR == 1) call Quit(_RC_INPUT_ERROR_)

IERR1 = 0
if (any(nBas(1:nSym) < 0)) IERR1 = 1
if (any(nFro(1:nSym) < 0)) IERR1 = 1
if (any(nDel(1:nSym) < 0)) IERR1 = 1
if (any(nOrb(1:nSym) < 0)) IERR1 = 1
if (any(nISh(1:nSym) < 0)) IERR1 = 1
if (any(nASh(1:nSym) < 0)) IERR1 = 1
if (any(nSSh(1:nSym) < 0)) IERR1 = 1
if (any(nRS1(1:nSym) < 0)) IERR1 = 1
if (any(nRS2(1:nSym) < 0)) IERR1 = 1
if (any(nRS3(1:nSym) < 0)) IERR1 = 1
IERR2 = 0
if (any(nBas(1:nSym) > mxBas)) IERR2 = 1
if (any(nFro(1:nSym) > mxBas)) IERR2 = 1
if (any(nDel(1:nSym) > mxBas)) IERR2 = 1
if (any(nOrb(1:nSym) > mxBas)) IERR2 = 1
if (any(nISh(1:nSym) > mxBas)) IERR2 = 1
if (any(nASh(1:nSym) > mxBas)) IERR2 = 1
if (any(nSSh(1:nSym) > mxBas)) IERR2 = 1
if (any(nRS1(1:nSym) > mxBas)) IERR2 = 1
if (any(nRS2(1:nSym) > mxBas)) IERR2 = 1
if (any(nRS3(1:nSym) > mxBas)) IERR2 = 1
if (IERR1+IERR2 > 0) then
  write(u6,*)
  write(u6,*) '****************** ERROR *******************'
  call WarningMessage(2,'Erroneous nr of orbitals.')
  write(u6,*) 'Inappropriate nr of orbitals. One or more of'
  write(u6,*) 'these orbital counts is wrong or too large.'
  if (IERR1 > 0) write(u6,*) ' Negative values.'
  if (IERR2 > 0) write(u6,*) ' Extremely large values.'
  write(u6,'(1X,A,8I4)') '   All orbitals:',(NBAS(ISYM),ISYM=1,NSYM)
  write(u6,'(1X,A,8I4)') '         Frozen:',(NFRO(ISYM),ISYM=1,NSYM)
  write(u6,'(1X,A,8I4)') '       Inactive:',(NISH(ISYM),ISYM=1,NSYM)
  write(u6,'(1X,A,8I4)') '         Active:',(NASH(ISYM),ISYM=1,NSYM)
  write(u6,'(1X,A,8I4)') '          RAS-1:',(NRS1(ISYM),ISYM=1,NSYM)
  write(u6,'(1X,A,8I4)') '          RAS-2:',(NRS2(ISYM),ISYM=1,NSYM)
  write(u6,'(1X,A,8I4)') '          RAS-3:',(NRS3(ISYM),ISYM=1,NSYM)
  write(u6,'(1X,A,8I4)') '      Secondary:',(NSSH(ISYM),ISYM=1,NSYM)
  write(u6,'(1X,A,8I4)') '        Deleted:',(NDEL(ISYM),ISYM=1,NSYM)
  write(u6,'(1X,A,8I4)') 'Basis functions:',(NBAS(ISYM),ISYM=1,NSYM)
  if (IERR1 > 0) write(u6,*) ' Have you used a too small basis set?'
  write(u6,*) '********************************************'
  call Quit(_RC_INPUT_ERROR_)
end if

IERR = 0
IB0 = ISPIN-1
IA0 = (NACTEL-IB0)/2
IC0 = (NAC-IA0-IB0)
if ((2*IA0+IB0) /= NACTEL) IERR = 1
if (IA0 < 0) IERR = 1
if (IB0 < 0) IERR = 1
if (IC0 < 0) IERR = 1
if (IERR == 1) then
  write(u6,*)
  write(u6,*) '******************** ERROR *********************'
  call WarningMessage(2,'No such wave function.')
  write(u6,*) 'The following combined specifications are wrong.'
  write(u6,'(1X,A,8I4)') 'Nr of active electrons NACTEL=',NACTEL
  write(u6,'(1X,A,8I4)') 'Nr of active orbitals     NAC=',NAC
  write(u6,'(1X,A,8I4)') 'Spin degeneracy         ISPIN=',ISPIN
  write(u6,*) 'There can be no such wave function.'
  write(u6,*) '************************************************'
  call Quit(_RC_INPUT_ERROR_)
end if

if (MAXIT > mxIter) then
  write(u6,*)
  write(u6,*) '*************** WARNING ****************'
  call WarningMessage(1,'Too many macro-iterations.')
  write(u6,*) 'Too many macro-iterations requested.'
  MAXIT = MXITER
  write(u6,'(1X,A,I8)') 'Reset to maximum, new MAXIT=',MAXIT
  write(u6,*) '****************************************'
end if
if (MAXJT > (mxCiIt-2)) then
  write(u6,*)
  write(u6,*) '*************** WARNING ****************'
  call WarningMessage(1,'Too many CI-iterations.')
  write(u6,*) 'Too many CI-iterations requested.'
  MAXJT = mxCiIt-2
  write(u6,'(1X,A,I8)') 'Reset to maximum, new MAXJT=',MAXJT
  write(u6,*) '****************************************'
end if
if (ITMAX > MXSXIT) then
  write(u6,*)
  write(u6,*) '*************** WARNING ****************'
  call WarningMessage(1,'Too many SX-iterations.')
  write(u6,*) 'Too many SX-iterations requested.'
  ITMAX = MXSXIT
  write(u6,'(1X,A,I8)') 'Reset to maximum, new ITMAX=',ITMAX
  write(u6,*) '****************************************'
end if

THRE = max(Zero,THRE)
THRTE = max(Zero,THRTE)
THRSX = max(Zero,THRSX)
THREN = max(Zero,THREN)
THFACT = max(Zero,THFACT)

IERR = 0
if (NROOTS > mxRoot) IERR = 1
if (LROOTS > mxRoot) IERR = 1
if (IERR == 1) then
  write(u6,*)
  write(u6,*) '***************** ERROR *****************'
  call WarningMessage(2,'Max roots exceeded.')
  write(u6,'(1X,A,I6)') 'Input Error: Max roots exceeded.',mxRoot
  write(u6,'(1X,A,I4)') 'Nr of CI roots        LROOTS=',LROOTS
  write(u6,'(1X,A,I4)') 'Nr of optimized roots NROOTS=',NROOTS
  write(u6,*) '************************************************'
  call Quit(_RC_INPUT_ERROR_)
end if
if (any(IROOT(1:NROOTS) < 0) .or. any(IROOT(1:NROOTS) > LROOTS)) IERR = 1
if (IERR == 1) then
  write(u6,*)
  write(u6,*) '***************** ERROR *****************'
  call WarningMessage(2,'Root specifications are wrong.')
  write(u6,*) 'CHKINP Error: Root specifications are wrong.'
  write(u6,'(1X,A,I4)') 'Nr of CI roots        LROOTS=',LROOTS
  write(u6,'(1X,A,I4)') 'Nr of optimized roots NROOTS=',NROOTS
  write(u6,*) '************************************************'
  call Quit(_RC_INPUT_ERROR_)
end if

IERR = 0
if ((NSYM /= 1) .and. (NSYM /= 2) .and. (NSYM /= 4) .and. (NSYM /= 8)) IERR = 1
if (STSYM > NSYM) IERR = 1
if (IERR == 1) then
  write(u6,*)
  write(u6,*) '***************** ERROR *****************'
  call WarningMessage(2,'Wrong symmetry.')
  write(u6,'(1X,A,I8)') 'CHKINP Error: Wrong symmetry.'
  write(u6,'(1X,A,I8)') 'State symmetry   STSYM=',STSYM
  write(u6,'(1X,A,I8)') 'Point group order NSYM=',NSYM
  write(u6,*) '************************************************'
  call Quit(_RC_INPUT_ERROR_)
end if

if (NSEL < LROOTS+1) then
  write(u6,*)
  write(u6,*) '***************** WARNING ***************'
  call WarningMessage(1,'Too small explicit Hamiltonian.')
  write(u6,*) 'CHKINP Warning: Too small explicit Hamiltonian.'
  write(u6,'(1X,A,I8)') 'Nr of CI roots LROOTS=',LROOTS
  write(u6,'(1X,A,I8)') 'You requested NSEL=',NSEL
  NSEL = LROOTS+1
  write(u6,'(1X,A,I8)') 'It has been reset to NSEL=',NSEL
  write(u6,*) '************************************************'
end if

IERR = 0
if ((NHOLE1 < 0) .and. (NRS1T /= 0)) IERR = 1
if ((NELEC3 < 0) .and. (NRS3T /= 0)) IERR = 1
if ((NACTEL < 0) .and. (NRS2T /= 0)) IERR = 1
if (IERR == 1) then
  write(u6,*)
  write(u6,*) '***************** ERROR *****************'
  call WarningMessage(2,'Error in RAS specification.')
  write(u6,*) 'Error in RAS specification.'
  write(u6,'(1X,A,I8)') 'Max holes in Ras1,     NHOLE1=',NHOLE1
  write(u6,'(1X,A,I8)') 'Max electrons in Ras3, NELEC3=',NELEC3
  write(u6,'(1X,A,I8)') 'Nr of active electrons NACTEL=',NACTEL
  write(u6,*) '*****************************************'
  call Quit(_RC_INPUT_ERROR_)
end if

!if (IPT2 == 1) then
!  if ((NHOLE1 /= 0) .or. (NELEC3 /= 0)) then
!    write(u6,*)
!    write(u6,*) '******************* WARNING *******************'
!    call WarningMessage(1,'"Quasi-canonical" is ignored.')
!    write(u6,*) 'You requested quasicanonical orbitals, but this'
!    write(u6,*) 'is not possible with a true RASSCF calculation.'
!    write(u6,*) 'Your request will be ignored.'
!    write(u6,*) '***********************************************'
!    IPT2 = 0
!  end if
!end if

!GG Sep 03 Check ALTEr
if (NAlter > 0) then
  do iAlter=1,NAlter
    if ((MAlter(iAlter,1) < 1) .or. (MAlter(iAlter,1) > NSym)) then
      write(u6,*)
      write(u6,*) '***************** ERROR *****************'
      call WarningMessage(1,'MAlter input is wrong.')
      write(u6,*) 'Wrong symmetry specie in pair ',iAlter
      write(u6,*) '*****************************************'
      call Quit(_RC_INPUT_ERROR_)
    end if
    if ((MAlter(iAlter,2) < 1) .or. (MAlter(iAlter,3) < 1)) then
      write(u6,*)
      write(u6,*) '***************** ERROR *****************'
      call WarningMessage(1,'MAlter input is wrong.')
      write(u6,*) 'Wrong orbital to exchange in pair ',iAlter
      write(u6,*) '*****************************************'
      call Quit(_RC_INPUT_ERROR_)
    end if
    if ((MAlter(iAlter,2) > nBas(MAlter(iAlter,1))) .or. (MAlter(iAlter,3) > nBas(MAlter(iAlter,1)))) then
      write(u6,*)
      write(u6,*) '***************** ERROR *****************'
      call WarningMessage(1,'MAlter input is wrong.')
      write(u6,*) 'Wrong orbital to exchange in pair ',iAlter
      write(u6,*) '*****************************************'
      call Quit(_RC_INPUT_ERROR_)
    end if
  end do
end if

!BOR  Check INVEC
if ((INVEC < 0) .or. (INVEC > 6)) then
  write(u6,*)
  write(u6,*) '************* ERROR ***************'
  ! This should be impossible:...
  call WarningMessage(2,'Keyword for start orbitals is missing.')
  write(u6,*) 'Keyword for start orbitals missing.'
  write(u6,*) 'Use either CORE, LUMORB, or JOBIPH.'
  write(u6,*) '***********************************'
  call Quit(_RC_INPUT_ERROR_)
end if

! PAM Krapperup Nov 05: Orbital print format.
! First question: Which orbital spaces are eligible for printing?
! No user selection, so fall back on default choice.
if (OutFmt1 == 'DEFAULT ') OutFmt1 = 'FEW     '
! Second question: How should they be printed?
if (OutFmt2 == 'DEFAULT ') then
! No user selection, so fall back on default choice.
  if (NTOT < 256) then
    OutFmt2 = 'FULL    '
  else
    OutFmt2 = 'COMPACT '
  end if
end if
! Third: has the user provided input for energy/occupation thresholds?
! A negative PROTHR shows no user value was given in input.
if (PROTHR < Zero) then
  if (OutFmt1 == 'ALL     ') then
    PROTHR = Zero
    PRETHR = 1.0e100_wp
  else
! Else, format is FEW or NOCORE (or NOTHING, but then nothing is printed)
    PROTHR = Zero
    PRETHR = 0.15_wp
  end if
end if
!----------------------------------------------------------------------*

contains

pure function cumsum(X) result(res)

  integer, intent(in) :: X(:)
  integer :: res(size(X))
  integer :: i

  if (size(X) > 0) res(1) = X(1)
  do i=2,size(res)
    res(i) = res(i-1)+X(i)
  end do

end function cumsum

end subroutine ChkInp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine PriTim(TimDat,nFld_par,nProcs)
      Implicit Real*8 (a-h,o-z)
*
*     declaration subroutine parameters
      Real*8 TimDat(2*nFld_par,nProcs)
*
      Write (6,'(1X,A)') 'Timing statistics of individual servers:'
      Write (6,'(1X,A5,6X,9A13)') ' node',
     &                           '   wait Dens.',
     &                           '     k2 stuff',
     &                           '     k4 stuff',
     &                           '  reduce Grad',
     &                           '    T O T A L',
     &                           '      # tasks',
     &                           '  # shl quads'
      Do inode = 1, nProcs
        Write (6,'(1X,I5,A6,5F13.2,2F13.0)')
     &           inode,' CPU  ',(TimDat(iFld,inode),iFld=1,nFld_par-1),
     &                           TimDat(nFld_par,inode),
     &                           TimDat(2*nFld_par,inode)
        Write (6,'(1X,5X,A6,9F13.2)')
     &                 ' Wall ',
     &                 (TimDat(nFld_par+iFld,inode),iFld=1,nFld_par-1)
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine BNDINV(A,EL,N,DETERM,EPSIL,ITEST)
! MATRIX INVERSION SUBROUTINE
! FROM "DLYTAP".

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(inout) :: A(N,N)
real(kind=wp), intent(out) :: EL(N,N), DETERM
real(kind=wp), intent(in) :: EPSIL
integer(kind=iwp), intent(out) :: ITEST
integer(kind=iwp) :: I, I1, J, J1, K, M, N1
real(kind=wp) :: C, D, E, EPSILP, F, RAT, S

!INDSNL = 0
if (N < 2) then
  ITEST = -1
  return
end if
!ISL2 = 0
!K000FX = 2
!if (ISL2 == 0) INDSNL = 2
!if (ISL2 == 1) INDSNL = 1
!call SLITET(2,INDSNL)
!call OVERFL(K000FX)
!call DVCHK(K000FX)

! SET EL = IDENTITY MATRIX
call unitmat(EL,N)

! TRIANGULARIZE A, FORM EL

N1 = N-1
M = 2
do J=1,N1
  do I=M,N
    if (A(I,J) == Zero) cycle
    D = sqrt(A(J,J)*A(J,J)+A(I,J)*A(I,J))
    C = A(J,J)/D
    S = A(I,J)/D
    do K=J,N
      D = C*A(J,K)+S*A(I,K)
      A(I,K) = C*A(I,K)-S*A(J,K)
      A(J,K) = D
    end do
    do K=1,N
      D = C*EL(J,K)+S*EL(I,K)
      EL(I,K) = C*EL(I,K)-S*EL(J,K)
      EL(J,K) = D
    end do
  end do
  M = M+1
end do
!call OVERFL(K000FX)
!if (K000FX == 0) then
!  ITEST = -1
!  goto 126
!end if

! CALCULATE THE DETERMINANT
DETERM = A(1,1)
do I=2,N
  DETERM = DETERM*A(I,I)
end do
!call OVERFL(K000FX)
!if (K000FX == 0) then
!  ITEST = -1
!  goto 126
!end if

! IS MATRIX SINGULAR
F = A(1,1)
E = A(1,1)
do I=2,N
  if (abs(F) < abs(A(I,I))) F = A(I,I)
  if (abs(E) > abs(A(I,I))) E = A(I,I)
end do
EPSILP = EPSIL
if (EPSILP <= Zero) EPSILP = 1.0e-8_wp
RAT = E/F
if (abs(RAT) < EPSILP) then
  ITEST = 1
  return
end if

! INVERT TRIANGULAR MATRIX
J = N
do J1=1,N
  A(J,J) = One/A(J,J)
  I = J-1
  do I1=2,J
    D = sum(A(I,I+1:J)*A(I+1:J,J))
    A(I,J) = -D/A(I,I)
    I = I-1
  end do
  J = J-1
end do
!call OVERFL(K000FX)
!if (K000FX == 0) then
!  ITEST = -1
!  goto 126
!end if

!call DVCHK(K000FX)
!if (K000FX == 0) then
!  ITEST = -1
!  goto 126
!end if

! PREMULTIPLY EL BY INVERTED TRIANGULAR MATRIX
M = 1
do I=1,N
  do J=1,N
    D = sum(A(I,M:N)*EL(M:N,J))
    EL(I,J) = D
  end do
  M = M+1
end do
!call OVERFL(K000FX)
!if (K000FX == 0) then
!  ITEST = -1
!  goto 126
!end if

! RECOPY EL TO A
A(:,:) = EL(:,:)
ITEST = 0
!126 if (INDSNL == 1) call SLITE(2)
!126 if (INDSNL == 1) ISL2 = 1

end subroutine BNDINV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine sumabdistt (n,idtot)
c
c        this routine distribute work for n records among
c        nprocab processors with the frequency, corresponding
c        to ideffab values
c
c        n - # of records to be distributed (I)
c        idtot - distribution vector (O)
c               (idtot(i) -  # of records to be realized by i-th node)
c
        implicit none
#include "parallel.fh"
c
        integer n
        integer idtot(1)
c
c        help parameters
c
        integer i,ntot,max,imax
CLD        integer i,j,ntot,max,imax
        real*8 sum
c
c
c1        distribute recordsc according to eff. coeficients
c
        sum=0.0d0
        do i=1,nprocab
        sum=sum+ideffab(i)
        end do
c
        do i=1,nprocab
        idtot(i)=int(((ideffab(i)*n)/sum)+0.5d0)
        end do
c
c2        do corrections, if roundoff errors caused some diferences
c
1        ntot=0
        do i=1,nprocab
        ntot=ntot+idtot(i)
        end do

        if (ntot.gt.n) then
c        ubrat treba (z najvacsieho dielu)
          max=idtot(1)
          imax=1
          do i=1,nprocab
          if (max.lt.idtot(i)) then
          max=idtot(i)
          imax=i
          end if
          end do
          idtot(imax)=idtot(imax)-1
          goto 1
        else if (ntot.lt.n) then
c        pridat treba (k najvacsiemu dielu)
          max=idtot(1)
          imax=1
          do i=1,nprocab
          if (max.lt.idtot(i)) then
          max=idtot(i)
          imax=i
          end if
          end do
          idtot(imax)=idtot(imax)+1
          goto 1
        end if
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Steven Vancoillie                                *
!***********************************************************************
MODULE WAVEFUNCTION
  ! Implements a wavefunction represtented by a structure (derived type)
  ! consisting of determinant coefficients resulting from the direct product of
  ! separate alpha and beta determinant strings.

  ! Steven Vancoillie, November 2013, Lund

  USE ISO_FORTRAN_ENV, ONLY: REAL64
  USE SECOND_QUANTIZATION
  IMPLICIT NONE

  ! determinant derived type
  TYPE DET
    INTEGER :: ALFA, BETA
  END type DET

  ! wavefunction derived type
  TYPE WFN
    INTEGER :: NEL, NORB, MULT
    INTEGER :: NELA, NDETA
    INTEGER :: NELB, NDETB
    INTEGER :: NDET
    REAL(REAL64), ALLOCATABLE :: COEF(:,:)
  END TYPE WFN

CONTAINS

  SUBROUTINE DET_PRINT(D,NORB)
    IMPLICIT NONE
    TYPE(DET), INTENT(IN) :: D
    INTEGER, INTENT(IN) :: NORB
    CHARACTER(LEN=64) FMT
    WRITE(FMT,'("(2(X,B",I0,".",I0"))")') NORB, NORB
    WRITE(*,FMT) D%ALFA, D%BETA
  END SUBROUTINE DET_PRINT

  SUBROUTINE WFN_INIT(PSI,NEL,NORB,MULT)
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NEL, NORB, MULT
    TYPE(WFN) :: PSI
    ! set basic properties
    PSI%NEL = NEL
    PSI%NORB = NORB
    PSI%MULT = MULT
    ! compute alpha/beta subsets
    PSI%NELA = (NEL+(MULT-1))/2
    PSI%NELB = (NEL-(MULT-1))/2
    IF (PSI%NELA+PSI%NELB.NE.NEL) THEN
      STOP 'WFN_INIT: NELA+NELB != NEL'
    END IF
    PSI%NDETA = BINOM_COEF(PSI%NELA,PSI%NORB)
    PSI%NDETB = BINOM_COEF(PSI%NELB,PSI%NORB)
    PSI%NDET=PSI%NDETA*PSI%NDETB
    ALLOCATE(PSI%COEF(PSI%NDETA,PSI%NDETB))
  END SUBROUTINE WFN_INIT

  SUBROUTINE WFN_FREE(PSI)
    IMPLICIT NONE
    TYPE(WFN) :: PSI
    DEALLOCATE(PSI%COEF)
  END SUBROUTINE WFN_FREE

  SUBROUTINE WFN_NORMALIZE(PSI)
    IMPLICIT NONE
    TYPE(WFN), INTENT(INOUT) :: PSI
    INTEGER :: IDETA, IDETB
    REAL(REAL64) :: NF
    ! compute normalization factor
    NF=0.0D0
    DO IDETB=1,PSI%NDETB
      DO IDETA=1,PSI%NDETA
        NF=NF+PSI%COEF(IDETA,IDETB)**2
      END DO
    END DO
    NF=SQRT(NF)
    PSI%COEF(:,:)=PSI%COEF/NF
  END SUBROUTINE WFN_NORMALIZE

  SUBROUTINE WFN_PRINT(PSI,THR)
    IMPLICIT NONE
    CHARACTER(LEN=256) FMT
    TYPE(WFN), INTENT(IN) :: PSI
    INTEGER :: IA, IB
    INTEGER :: DETA, DETB
    REAL(REAL64) :: THR
    INTEGER :: NBITS
    NBITS=MAX(PSI%NORB,5)
    WRITE(*,'(X,A)') 'WAVEFUNCTION SPECS:'
    WRITE(*,'(X,A)') '==================='
    WRITE(*,'(X,A,I12)') '#ELECTRONS    = ', PSI%NEL
    WRITE(*,'(X,A,I12)') '#ORBITALS     = ', PSI%NORB
    WRITE(*,'(X,A,I12)') '#MULTIPLICITY = ', PSI%MULT
    WRITE(*,'(X,A,I12)') '#DET (ALPHA)  = ', PSI%NDETA
    WRITE(*,'(X,A,I12)') '#DET (BETA)   = ', PSI%NDETB
    WRITE(*,'(X,A,I12)') '#DET (TOTAL)  = ', PSI%NDETA*PSI%NDETB
    WRITE(*,*)
    WRITE(FMT,'("(A18,X,2(2X,A",I0,"))")') NBITS
    WRITE(*,FMT) 'COEFFICIENTS','ALPHA','BETA'
    WRITE(FMT,'("(F18.14,X,2(2X,B",I0,".",I0,"))")') NBITS, PSI%NORB
    DETB = LEX_INIT(PSI%NELB,PSI%NORB)
    DO IB = 1, PSI%NDETB
      DETA = LEX_INIT(PSI%NELA,PSI%NORB)
      DO IA = 1, PSI%NDETA
        IF (ABS(PSI%COEF(IA,IB)).GE.THR) WRITE(*,FMT) PSI%COEF(IA,IB), DETA, DETB
        DETA = LEX_NEXT(DETA)
      END DO
      DETB = LEX_NEXT(DETB)
    END DO
    WRITE(*,*)
  END SUBROUTINE WFN_PRINT

  SUBROUTINE DET_EX1(FACT,P,Q,DETA,DETB,TAU)
    ! computes |TAU> = |TAU> + FACT * Ê_pq |DETA,DETB>
    USE SECOND_QUANTIZATION
    IMPLICIT NONE
    
    REAL(REAL64),INTENT(IN) :: FACT
    INTEGER, INTENT(IN) :: P, Q
    INTEGER, INTENT(IN) :: DETA, DETB
    TYPE(WFN), INTENT(INOUT) :: TAU

    INTEGER :: IA, IB
    INTEGER :: TMPA, TMPB
    REAL(REAL64) :: FA, FB
    
    ! compute E_(pa)(qa)
    TMPA=EX1(P,Q,DETA)
    IF (TMPA.NE.-1) THEN
      IA=RANK_(TMPA)
      IB=RANK_(DETB)
      FA=SIGN(1,TMPA)
      TAU%COEF(IA,IB)=TAU%COEF(IA,IB)+FA*FACT
    END IF
    ! compute E_(pb)(qb)
    TMPB=EX1(P,Q,DETB)
    IF (TMPB.NE.-1) THEN
      IA=RANK_(DETA)
      IB=RANK_(TMPB)
      FB=SIGN(1,TMPB)
      TAU%COEF(IA,IB)=TAU%COEF(IA,IB)+FB*FACT
    END IF

  END SUBROUTINE DET_EX1

  SUBROUTINE WFN_EX1(FACT,P,Q,SGM,TAU)
    USE SECOND_QUANTIZATION
    IMPLICIT NONE
    REAL(REAL64),INTENT(IN) :: FACT
    INTEGER, INTENT(IN) :: P, Q
    TYPE(WFN), INTENT(IN) :: SGM
    TYPE(WFN), INTENT(INOUT) :: TAU

    INTEGER :: IA, IB, DETA, DETB
    REAL(REAL64) :: CPQ

    DETB=LEX_INIT(SGM%NELB,SGM%NORB)
    DO IB=1,SGM%NDETB
      DETA=LEX_INIT(SGM%NELA,SGM%NORB)
      DO IA=1,SGM%NDETA

        CPQ=FACT*SGM%COEF(IA,IB)
        CALL DET_EX1(CPQ,P,Q,DETA,DETB,TAU)

        DETA=LEX_NEXT(DETA)
      END DO
      DETB=LEX_NEXT(DETB)
    END DO

  END SUBROUTINE WFN_EX1

  SUBROUTINE DET_EX2(FACT,P,Q,R,S,DETA,DETB,TAU)
    ! computes |TAU> = |TAU> + FACT * Ê_pqrs |DETA,DETB>
    USE SECOND_QUANTIZATION
    IMPLICIT NONE

    REAL(REAL64),INTENT(IN) :: FACT
    INTEGER, INTENT(IN) :: P, Q, R, S
    INTEGER, INTENT(IN) :: DETA, DETB
    TYPE(WFN), INTENT(INOUT) :: TAU

    INTEGER :: IA, IB
    INTEGER :: TMPA, TMPB
    REAL(REAL64) :: FA, FB

    ! compute E_(pa)(qa)(ra)(sa)
    TMPA=ANN2(S,Q,DETA)
    IF (TMPA.NE.-1) THEN
      TMPA=CRE2(P,R,TMPA)
      IF (TMPA.NE.-1) THEN
        IA=RANK_(TMPA)
        IB=RANK_(DETB)
        FA=SIGN(1,TMPA)
        TAU%COEF(IA,IB)=TAU%COEF(IA,IB)+FA*FACT
      END IF
    END IF
    ! compute E_(pb)(qb)(rb)(sb)
    TMPB=ANN2(S,Q,DETB)
    IF (TMPB.NE.-1) THEN
      TMPB=CRE2(P,R,TMPB)
      IF (TMPB.NE.-1) THEN
        IA=RANK_(DETA)
        IB=RANK_(TMPB)
        FB=SIGN(1,TMPB)
        TAU%COEF(IA,IB)=TAU%COEF(IA,IB)+FB*FACT
      END IF
    END IF
    ! compute E_(pa)(qa)(rb)(sb)
    TMPA=ANN(Q,DETA)
    TMPB=ANN(S,DETB)
    IF (TMPA.NE.-1.AND.TMPB.NE.-1) THEN
      TMPA=CRE(P,TMPA)
      TMPB=CRE(R,TMPB)
      IF (TMPA.NE.-1.AND.TMPB.NE.-1) THEN
        IA=RANK_(TMPA)
        IB=RANK_(TMPB)
        FA=SIGN(1,TMPA)
        FB=SIGN(1,TMPB)
        TAU%COEF(IA,IB)=TAU%COEF(IA,IB)+FA*FB*FACT
      END IF
    END IF
    ! compute E_(pb)(qb)(ra)(sa)
    TMPA=ANN(S,DETA)
    TMPB=ANN(Q,DETB)
    IF (TMPA.NE.-1.AND.TMPB.NE.-1) THEN
      TMPA=CRE(R,TMPA)
      TMPB=CRE(P,TMPB)
      IF (TMPA.NE.-1.AND.TMPB.NE.-1) THEN
        IA=RANK_(TMPA)
        IB=RANK_(TMPB)
        FA=SIGN(1,TMPA)
        FB=SIGN(1,TMPB)
        TAU%COEF(IA,IB)=TAU%COEF(IA,IB)+FA*FB*FACT
      END IF
    END IF

  END SUBROUTINE DET_EX2

  SUBROUTINE WFN_COPY0(NI,SGM,TAU)
    ! sets |TAU> = |SGM>, where SGM excludes the inactives
    USE SECOND_QUANTIZATION
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NI
    TYPE(WFN), INTENT(IN) :: SGM
    TYPE(WFN), INTENT(INOUT) :: TAU
    INTEGER :: DETA, DETB, IA, IB
    INTEGER :: TAUA, TAUB
    INTEGER :: INACTIVE

    TAU%COEF=0.0D0

    INACTIVE=2**NI-1
    DETB=LEX_INIT(SGM%NELB,SGM%NORB)
    DO IB=1,SGM%NDETB
      TAUB=ISHFT(DETB,NI)+INACTIVE
      DETA=LEX_INIT(SGM%NELA,SGM%NORB)
      DO IA=1,SGM%NDETA
        TAUA=ISHFT(DETA,NI)+INACTIVE
        TAU%COEF(RANK_(TAUA),RANK_(TAUB))=SGM%COEF(IA,IB)
        DETA=LEX_NEXT(DETA)
      END DO
      DETB=LEX_NEXT(DETB)
    END DO
  END SUBROUTINE WFN_COPY0

  SUBROUTINE WFN_PK(NI,NA,NS,SGM,TAU)
    ! computes |TAU> = |TAU> + P_K |SGM>
    USE SECOND_QUANTIZATION
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NI, NA, NS
    TYPE(WFN), INTENT(IN) :: SGM
    TYPE(WFN), INTENT(INOUT) :: TAU
    INTEGER :: IA, IB, DETA, DETB, MASK

    ! keep only determinants from |SGM> which have all bits set in the lower NI
    ! part and no bits set in the upper NS part.
    MASK=2**NI-1+ISHFT(2**NS-1,NI+NA)
    DETB=LEX_INIT(SGM%NELB,SGM%NORB)
    DO IB=1,SGM%NDETB
      IF (IAND(DETB,MASK).EQ.2**NI-1) THEN
        DETA=LEX_INIT(SGM%NELA,SGM%NORB)
        DO IA=1,SGM%NDETA
          IF (IAND(DETA,MASK).EQ.2**NI-1) THEN
            TAU%COEF(IA,IB)=TAU%COEF(IA,IB)+SGM%COEF(IA,IB)
          END IF
          DETA=LEX_NEXT(DETA)
        END DO
      END IF
      DETB=LEX_NEXT(DETB)
    END DO
  END SUBROUTINE WFN_PK
  
  SUBROUTINE WFN_PSD(NI,NA,NS,SGM,TAU)
    ! computes |TAU> = |TAU> + P_SD |SGM>
    USE SECOND_QUANTIZATION
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NI, NA, NS
    TYPE(WFN), INTENT(IN) :: SGM
    TYPE(WFN), INTENT(INOUT) :: TAU
    INTEGER :: IA, IB, DETA, DETB, IMASK, SMASK
    INTEGER :: NIA, NSA, NIB, NSB
    INTEGER :: ICOUNT

    ! keep only determinants from |SGM> which have at least 2*NI-2 bits set in
    ! the lower NI part and at most two bits set in the upper NS part, and
    ! remove any non-excited determinants.

    ICOUNT=0
    IMASK=2**NI-1
    SMASK=ISHFT(2**NS-1,NI+NA)
    DETB=LEX_INIT(SGM%NELB,SGM%NORB)
    DO IB=1,SGM%NDETB
      NIB=ONEBITS(IAND(DETB,IMASK))
      NSB=ONEBITS(IAND(DETB,SMASK))
      DETA=LEX_INIT(SGM%NELA,SGM%NORB)
      DO IA=1,SGM%NDETA
        NIA=ONEBITS(IAND(DETA,IMASK))
        NSA=ONEBITS(IAND(DETA,SMASK))
        IF (NIB+NIA.GE.2*NI-2.AND.NSB+NSA.LE.2) THEN
          IF(.NOT.(NIB+NIA.EQ.2*NI.AND.NSB+NSA.EQ.0)) THEN
            TAU%COEF(IA,IB)=TAU%COEF(IA,IB)+SGM%COEF(IA,IB)
            ICOUNT=ICOUNT+1
          END IF
        END IF
        DETA=LEX_NEXT(DETA)
      END DO
      DETB=LEX_NEXT(DETB)
    END DO
  END SUBROUTINE WFN_PSD
  
  SUBROUTINE WFN_ORBROT(PSI,OVEC)
    ! Transforms the CI coefficients to match the orbital rotation given by the
    ! transformation matrix U. The dimensions of U should match those of the
    ! number of orbitals in the wavefunction (of course).
    !
    ! This one-orbital-at-a-time algorithm was adopted from the TRACI_RPT2
    ! subroutine in Molcas, and more info can be found in part IV (on page 4505)
    ! of the publication in Phys. Rev. E, vol. 52 (1995), p. 4499-4508.

    IMPLICIT NONE

    TYPE(WFN), INTENT(INOUT) :: PSI
    REAL(REAL64), INTENT(IN) :: OVEC(:,:)

    TYPE(WFN) :: TAU
    REAL(REAL64), ALLOCATABLE :: U(:,:), T(:)

    INTEGER :: NA, I, J, K
    REAL(REAL64) :: FACT

    NA=SIZE(OVEC,1)
    IF (PSI%NORB.NE.NA) STOP 'WFN_ORBROT: NA != PSI%NORB'

    ALLOCATE(U(NA,NA))
    U(:,:) = OVEC

    CALL WFN_INIT(TAU,PSI%NEL,PSI%NORB,PSI%MULT)
    ALLOCATE(T(NA))

    DO J=1,NA
      ! get column vector
      T(:) = U(:,J)
      ! invert T, unitify U(:,J)
      FACT = 1.0D0/T(J)
      DO I=1,NA
        T(I) = -FACT*T(I)
        U(I,J) = 0.0D0
      END DO
      T(J) = FACT
      U(J,J) = 1.0D0
      ! apply T^-1 to U for the next step
      DO K=J+1,NA
        FACT=U(J,K)
        DO I=1,NA
          U(I,K) = U(I,K) + FACT*T(I)
        END DO
        U(J,K) = FACT*T(J)
      END DO
      ! compute |PSI> := (1+E_ij+E_ijmj)|PSI>
      TAU%COEF(:,:)=(1.5D0-0.5D0*T(J))*PSI%COEF
      DO I=1,NA
        FACT=0.5D0*T(I)
        IF (I.EQ.J) FACT=FACT-0.5D0
        CALL WFN_EX1(FACT,I,J,PSI,TAU)
      END DO
      DO I=1,NA
        FACT=T(I)
        IF (I.EQ.J) FACT=FACT-1.0D0
        CALL WFN_EX1(FACT,I,J,TAU,PSI)
      END DO
    END DO

    DEALLOCATE(T)
    DEALLOCATE(U)
    CALL WFN_FREE(TAU)
  END SUBROUTINE WFN_ORBROT

  SUBROUTINE WFN_ENERGY(NI,NA,NS,D1,D2,ONEINT,TWOINT)
    REAL(REAL64) :: D1(:,:), D2(:,:,:,:)
    REAL(REAL64) :: ONEINT(:,:), TWOINT(:,:,:,:)
    INTEGER :: NI, NA, NS
    INTEGER :: T, U, V, X, I, J
    REAL(REAL64) :: E1, E2, ETOT
    WRITE(*,*) 'Total CASSCF energy:'
    ETOT=-16.704241392292605D0
    WRITE(*,*) '1-el contribution'
    ! inactive
    E1=0.0D0
    DO I=1,NI
      E1=E1+ONEINT(I,I)*2.0D0
    END DO
    WRITE(*,'(1X,A10,F21.14)') 'inactive:', E1
    ETOT=ETOT+E1
    ! active
    E1=0.0D0
    DO T=1,NA
      DO U=1,NA
        IF (D1(T,U).NE.0.0D0) THEN
          E1=E1+ONEINT(NI+T,NI+U)*D1(T,U)
        END IF
      END DO
    END DO
    WRITE(*,'(1X,A10,F21.14)') 'active:', E1
    ETOT=ETOT+E1

    WRITE(*,*) '2-el contribution'
    ! inactive
    E2=0.0D0
    DO I=1,NI
      DO J=1,NI
        E2=E2+2.0D0*TWOINT(I,I,J,J)-TWOINT(I,J,J,I)
      END DO
    END DO
    WRITE(*,'(1X,A10,F21.14)') 'inactive:', E2
    ETOT=ETOT+E2
    ! inactive-active
    E2=0.0D0
    DO I=1,NI
      DO T=1,NA
        DO U=1,NA
          IF (D1(T,U).NE.0.0D0) THEN
            IF (ISNAN(TWOINT(I,I,NI+T,NI+U)).OR.ISNAN(TWOINT(I,NI+U,NI+T,I))) THEN
              WRITE(*,*) 'NaN detected on: ', I, I, NI+T, NI+U
            END IF
            E2=E2+(2.0D0*TWOINT(I,I,NI+T,NI+U)-TWOINT(I,NI+U,NI+T,I))*D1(T,U)
          END IF
        END DO
      END DO
    ENDDO
    WRITE(*,'(1X,A10,F21.14)') 'inact-act:', E2
    ETOT=ETOT+E2
    E2=0.0D0
    DO T=1,NA
      DO U=1,NA
        DO V=1,NA
          DO X=1,NA
            IF (D2(V,T,X,U).NE.0.0D0) THEN
              IF (ISNAN(TWOINT(NI+T,NI+U,NI+V,NI+X))) THEN
                WRITE(*,*) 'NaN detected on: ', NI+T, NI+U, NI+V, NI+X
              END IF
              E2=E2+0.5*TWOINT(NI+T,NI+U,NI+V,NI+X)*D2(V,T,X,U)
            END IF
          END DO
        END DO
      END DO
    ENDDO
    WRITE(*,'(1X,A10,F21.14)') 'active:', E2
    ETOT=ETOT+E2
    WRITE(*,*)
    WRITE(*,'(1X,A10,F21.14)') 'total:', ETOT
    WRITE(*,*)
    IF (.FALSE.) NS=NS
  END SUBROUTINE WFN_ENERGY

END MODULE WAVEFUNCTION

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
C
C
      SUBROUTINE DECOMP(NN,A,UL)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NN,NN),UL(NN,NN),SCALES(200)
      COMMON /IPS/IPS(200)
      N=NN
      IDXPIV=0 ! dummy initialize
C**** INITIALIZE IPS, UL AND SCALES
      DO 5 I=1,N
      IPS(I)=I
      ROWNRM=0.0D00
      DO 2 J=1,N
      UL(I,J)=A(I,J)
c      IF (ROWNRM-ABS(UL(I,J))) 1,2,2
      IF (ROWNRM-ABS(UL(I,J)).ge.0) goto 2
c1     CONTINUE
      ROWNRM=abs(UL(I,J))
2     CONTINUE
c      IF (ROWNRM) 3,4,3
      IF (ROWNRM.eq.0) goto 4
c3     CONTINUE
      SCALES(I)=1.0D00/ROWNRM
      GO TO 5
4     CALL SING(1)
      SCALES(I)=0.0D00
5     CONTINUE
C**** GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
      NM1=N-1
      DO 17 K=1,NM1
      BIG=0.0D00
      DO 11 I=K,N
      IP=IPS(I)
      SIZE=ABS(UL(IP,K))*SCALES(IP)
c      IF (SIZE-BIG) 11,11,10
      IF (SIZE-BIG.le.0) goto 11
c10    CONTINUE
      BIG=SIZE
      IDXPIV=I
11    CONTINUE
c      IF (BIG) 13,12,13
      IF (BIG.ne.0) goto 13
c12    CONTINUE
      CALL SING(2)
      GOTO 17
c13    IF (IDXPIV-K) 14,15,14
13    IF (IDXPIV.eq.K) goto 15
c14    CONTINUE
      J=IPS(K)
      IPS(K)=IPS(IDXPIV)
      IPS(IDXPIV)=J
15    KP=IPS(K)
      PIVOT=UL(KP,K)
      KP1=K+1
      DO 16 I=KP1,N
      IP=IPS(I)
      EM=-UL(IP,K)/PIVOT
      UL(IP,K)=-EM
      DO 160 J=KP1,N
      UL(IP,J)=UL(IP,J)+EM*UL(KP,J)
160   CONTINUE
16    CONTINUE
17    CONTINUE
      KP=IPS(N)
c      IF (UL(KP,N)) 19,18,19
      IF (UL(KP,N).ne.0) goto 19
c18    CONTINUE
      CALL SING(2)
19    RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  dGeMM_Tri
*
*> @brief
*>   Compute matrix product, store result in triangular storage format.
*>   May be used exactly as level 3 BLAS library routine ::DGEMM with \p C stored triangularly.
*> @author Thomas Bondo Pedersen
*>
*> @details
*> This subroutine computes the matrix product of matrices \p A and \p B
*> in a manner similar to the level 3 BLAS routine ::DGEMM. Unlike
*> ::DGEMM, however, the result matrix \p C is computed in triangular
*> storage (i.e., only upper triangle [identical to lower triangle
*> if \p C is symmetric] including diagonal elements). The argument
*> list is identical to that of ::DGEMM. Note, however, that \p m must
*> be equal to \p n. Moreover, \p ldC is not used here (it is included
*> only to have the same interface as ::DGEMM), but must be at least
*> ``1``.
*>
*> @param[in]     TransA Transposition of \p A
*> @param[in]     TransB Transposition of \p B
*> @param[in]     m      Row dimension of \p C
*> @param[in]     n      Column dimension of \p C
*> @param[in]     k      Dimension of summation index
*> @param[in]     alpha  Scale factor
*> @param[in]     A      Factor matrix \p A
*> @param[in]     ldA    Leading dimension of \p A
*> @param[in]     B      Factor matrix \p B
*> @param[in]     ldB    Leading dimension of\p  B
*> @param[in]     beta   Scale factor
*> @param[in,out] C      Result matrix
*> @param[in]     ldC    Leading dimension of \p C
************************************************************************
      SubRoutine dGeMM_Tri(TransA,TransB,m,n,k,alpha,A,ldA,B,ldB,
     &                     beta,C,ldC)
      Implicit None
      Character*1 TransA, TransB
      Integer     m, n, k, ldA, ldB, ldC
      Real*8      alpha, beta
      Real*8      A(ldA,*), B(ldB,*), C(*)

      Character*9  SecNam
      Parameter    (SecNam = 'dGeMM_Tri')
      Character*25 ArgErr
      Parameter    (ArgErr = ' Illegal argument number ')

      Real*8    Zero, One
      Parameter (Zero = 0.0d0, One = 1.0d0)

      Character*2 ArgNum
      Logical     NoAB, NoC
      Integer     iArg, j, kOff, ldARef, ldBRef

C     Test input parameters.
C     ----------------------

      If (TransA.eq.'N' .or. TransA.eq.'n') Then
         ldARef = m
      Else If (TransA.eq.'T' .or. TransA.eq.'t') Then
         ldARef = k
      Else
         ArgNum = ' 1'
         Call SysAbendMsg(SecNam,ArgErr,ArgNum)
         ldARef = 1
      End If
      ldARef = max(ldARef,1)

      If (TransB.eq.'N' .or. TransB.eq.'n') Then
         ldBRef = k
      Else If (TransB.eq.'T' .or. TransB.eq.'t') Then
         ldBRef = n
      Else
         ArgNum = ' 2'
         Call SysAbendMsg(SecNam,ArgErr,ArgNum)
         ldBRef = 1
      End If
      ldBRef = max(ldBRef,1)

      iArg = 0
      If (m .lt. 0) Then
         iArg = 3
      Else If (n .ne. m) Then
         iArg = 4
      Else If (k .lt. 0) Then
         iArg = 5
      Else If (ldA .lt. ldARef) Then
         iArg = 8
      Else If (ldB .lt. ldBRef) Then
         iArg = 10
      Else If (ldC .lt. 1) Then
         iArg = 13
      End If
      If (iArg .ne. 0) Then
         Write(ArgNum,'(I2)') iArg
         Call SysAbendMsg(SecNam,ArgErr,ArgNum)
      End If

C     Scale C and return if possible.
C     -------------------------------

      NoC  = n .eq. 0
      NoAB = alpha.eq.Zero .or. k.eq.0
      If (NoC .or. (NoAB .and. beta.eq.one)) Return
      If (beta .eq. Zero) Then
         Do j = 1,n*(n+1)/2
            C(j) = Zero
         End Do
      Else If (beta .ne. One) Then
         Call dScal_(n*(n+1)/2,beta,C,1)
      End If
      If (NoAB) Return

C     Compute using level 2 BLAS library (matrix-vector products).
C     ------------------------------------------------------------

      kOff = 1
      If (TransB.eq.'N' .or. TransB.eq.'n') Then
         If (TransA.eq.'N' .or. TransA.eq.'n') Then
            Do j = 1,n
               Call dGeMV_('N',j,k,alpha,A,ldA,B(1,j),1,One,C(kOff),1)
               kOff = kOff + j
            End Do
         Else
            Do j = 1,n
               Call dGeMV_('T',k,j,alpha,A,ldA,B(1,j),1,One,C(kOff),1)
               kOff = kOff + j
            End Do
         End If
      Else
         If (TransA.eq.'N' .or. TransA.eq.'n') Then
            Do j = 1,n
              Call dGeMV_('N',j,k,alpha,A,ldA,B(j,1),ldB,One,C(kOff),1)
              kOff = kOff + j
            End Do
         Else
            Do j = 1,n
              Call dGeMV_('T',k,j,alpha,A,ldA,B(j,1),ldB,One,C(kOff),1)
               kOff = kOff + j
            End Do
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Roland Lindh                                     *
!***********************************************************************

subroutine Print_Symmetry()
!***********************************************************************
!                                                                      *
!     Object: to write the output of seward                            *
!                                                                      *
!     Author: Roland Lindh, Dept Chem. Phys., Lund University, Sweden  *
!             September '06                                            *
!***********************************************************************

use Symmetry_Info, only: iChTbl, iOper, lBsFnc, lIrrep, nIrrep, SymLab
use Definitions, only: iwp, u6

implicit none
#include "print.fh"
integer(kind=iwp) :: i, iIrrep, iPrint, iRout, j, jIrrep, nOper
character(len=80) :: frmt
character(len=*), parameter :: ChSymO(0:7) = ['  E  ', &
                                              's(yz)', &
                                              's(xz)', &
                                              'C2(z)', &
                                              's(xy)', &
                                              'C2(y)', &
                                              'C2(x)', &
                                              '  i  '], &
                               SymOpr(0:7) = [' Unit operation              ', &
                                              ' Reflection in the yz-plane  ', &
                                              ' Reflection in the xz-plane  ', &
                                              ' Rotation around the z-axis  ', &
                                              ' Reflection in the xy-plane  ', &
                                              ' Rotation around the y-axis  ', &
                                              ' Rotation around the x-axis  ', &
                                              ' Inversion through the origin']

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 2
iPrint = nPrint(iRout)
if (iPrint == 0) return
!                                                                      *
!***********************************************************************
!                                                                      *
write(u6,*)
call CollapseOutput(1,'   Symmetry information:')
write(u6,'(3X,A)') '   ---------------------'
write(u6,*)
!                                                                      *
!***********************************************************************
!                                                                      *
if (nIrrep /= 1) then
  write(u6,'(19X,A)') ' --- Group Generators ---'
  nOper = 0
  if (nIrrep == 8) nOper = 3
  if (nIrrep == 4) nOper = 2
  if (nIrrep == 2) nOper = 1
  do i=1,nOper
    j = i
    if (i == 3) j = 4
    write(u6,'(19X,A)') SymOpr(iOper(j))
  end do
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
write(u6,'(19X,A,A)') ' Character Table for ',SymLab
write(u6,*)
write(frmt,'(A,I1,A)') '(20X,A3,1X,',nIrrep,'(1X,I5),2X,A)'
write(u6,'(27X,8(A5,1X))') (ChSymO(iOper(iIrrep)),iIrrep=0,nIrrep-1)
do iIrrep=0,nIrrep-1
  write(u6,frmt) lIrrep(iIrrep),(iChTbl(iIrrep,jIrrep),jIrrep=0,nIrrep-1),trim(lBsFnc(iIrrep))
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call CollapseOutput(0,'  Symmetry information:')
write(u6,*)

return

end subroutine Print_Symmetry

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine No_ESPF(natom,Forces,DoTinker)
      use Basis_Info
      use Center_Info
      use external_centers
      use Temporary_Parameters, only: Primitive_pass
      use Real_Info, only: PotNuc
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
*
#include "espf.fh"
*
      Real*8 A(3), B(3), RB(3)
      Integer iDCRR(0:7), jCoSet(8,8), iStb(0:7)
      Logical EQ,NoLoop,Forces,DoTinker,DoRys
      Character*180 Line,Get_Ln
      External Get_Ln
*
      iPL = iPL_espf()
      NoLoop = .True.
*
*     Nothing to do in a gradient calc
*
      If (Forces) Return
*
*     Update the nuclear repulsion energy
*
      Call Get_dScalar('PotNuc',RepNuc)
      RepNuc_old = RepNuc
*
*     Read the MM contribution to the total energy and add it
*     to the Nuclear Repulsion term
*
      If (DoTinker) Then
         Tke = Zero
         ITkQMMM = IsFreeUnit(30)
         Call Molcas_Open (ITkQMMM,'QMMM')
         Line = ' '
         Do While (Index(Line,'TheEnd ') .eq. 0)
            Line=Get_Ln(ITkQMMM)
            If (Index(Line,'MMEnergy ').ne.0) Call Get_F1(2,TkE)
         End Do
         Close (ITkQMMM)
         TkE = TkE * ToHartree
         RepNuc = RepNuc + TkE
         If (iPL.ge.3) Write(6,1000) RepNuc_old,TkE,RepNuc
1000     Format(/,' RepNuc + MM = ',F13.8,' + ',F13.8,' = ',F13.8)
      End If
*
      If (Allocated(XF).and.(nOrd_XF.ge.0)) Then
         write(6,*) 'Here we are!!'
*
         DoRys=.True.
         nDiff=0
         Call GetInf(DoRys,nDiff)
         Primitive_Pass=.True.
*
*--------Add contibution for interaction external field and nuclear
*        charges. Here we will have charge-charge, and charge-dipole
*        inteaction.
*
         ZA = Zero
         DAx= Zero
         DAy= Zero
         DAz= Zero
         Qxx= Zero
         Qxy= Zero
         Qxz= Zero
         Qyy= Zero
         Qyz= Zero
         Qzz= Zero
*
         PNX=Zero
         iDum=0
         Do iFd = 1, nXF
            If (nOrd_XF.eq.0) Then
               ZA = XF(4,iFd)
               NoLoop = ZA.eq.Zero
            Else If (nOrd_XF.eq.1) Then
               ZA = XF(4,iFd)
               DAx= XF(5,iFd)
               DAy= XF(6,iFd)
               DAz= XF(7,iFd)
               NoLoop = ZA.eq.Zero  .and.
     &                  DAx.eq.Zero .and.
     &                  DAy.eq.Zero .and.
     &                  DAz.eq.Zero
            Else If (nOrd_XF.eq.2) Then
               ZA = XF(4,iFd)
               DAx= XF(5,iFd)
               DAy= XF(6,iFd)
               DAz= XF(7,iFd)
               Qxx= XF(8,iFd)
               Qxy= XF(9,iFd)
               Qxz= XF(10,iFd)
               Qyy= XF(11,iFd)
               Qyz= XF(12,iFd)
               Qzz= XF(13,iFd)
               NoLoop = ZA.eq.Zero  .and.
     &                  DAx.eq.Zero .and.
     &                  DAy.eq.Zero .and.
     &                  DAz.eq.Zero .and.
     &                  Qxx.eq.Zero .and.
     &                  Qxy.eq.Zero .and.
     &                  Qxz.eq.Zero .and.
     &                  Qyy.eq.Zero .and.
     &                  Qyz.eq.Zero .and.
     &                  Qzz.eq.Zero
            Else
               Call WarningMessage(2,'Option not implemented yet!')
               Call Quit_OnUserError()
            End If
            If (NoLoop) Go To 102
            A(1:3)=XF(1:3,iFd)
            iChxyz=iChAtm(A)
            Call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)
*
            ndc = 0
            Do jCnttp = 1, nCnttp
               ZB = dbsc(jCnttp)%Charge
               If (dbsc(jCnttp)%pChrg) Go To 202
               If (ZB.eq.Zero) Go To 202
               If (dbsc(jCnttp)%Frag) Go To 202
               ZAZB = ZA * ZB
               Do jCnt = 1, dbsc(jCnttp)%nCntr
                  B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
*                 Find the DCR for the two centers
*
                  Call DCR(LmbdR,iStb,nStb,
     &                     dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                     iDCRR,nDCRR)
*
                  temp0= Zero
                  temp1= Zero
                  temp2= Zero
                  Do iR = 0, nDCRR-1
                     Call OA(iDCRR(iR),B,RB)
*                    The index A=RB is illegal.
                     If (.Not.EQ(A,RB)) Then
                        ABx=A(1)-RB(1)
                        ABy=A(2)-RB(2)
                        ABz=A(3)-RB(3)
                        r12 = Sqrt(ABx**2 + ABy**2 + ABz**2)
*
                        fab=One
                        If (dbsc(jCnttp)%ECP) Then
*--------------------------Add contribution from M1 operator
                           Do iM1xp=1, dbsc(jCnttp)%nM1
                             Gamma = dbsc(jCnttp)%M1xp(iM1xp)
                             CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
                             fab = fab + CffM1 * Exp(-Gamma*r12**2)
                           End Do
*--------------------------Add contribution from M2 operator
                           Do iM2xp=1, dbsc(jCnttp)%nM2
                             Gamma = dbsc(jCnttp)%M2xp(iM2xp)
                             CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
                             fab = fab + CffM2*r12*Exp(-Gamma*r12**2)
                           End Do
                        End If
                        temp0=temp0+fab/r12
                        If (nOrd_XF.ge.1)
     &                     temp1=temp1-fab*(DAx*ABx
     &                                     +DAy*ABy
     &                                     +DAz*ABz)/r12**3
                        If (nOrd_XF.ge.2) then

                            temp2=temp2+fab*0.5D0*(3.0D0*(Qxx*ABx**2
     &                                     +2.0D0*Qxy*ABx*ABy
     &                                     +2.0D0*Qxz*ABx*ABz
     &                                     +Qyy*ABy**2
     &                                     +2.0D0*Qyz*ABy*ABz
     &                                     +Qzz*ABz**2 )/r12**5
     &                                   -One/r12**3*(Qxx+Qyy+Qzz))
                        EndIf

                    End If
                  End Do
                  PNX = PNX + ( ( ZAZB*temp0 + ZB*(temp1+temp2))
     &                * DBLE(nIrrep) ) / DBLE(LmbdR)
*
               End Do
 202           Continue
               ndc = ndc + dbsc(jCnttp)%nCntr
            End Do
 102        Continue
         End Do
*
         If (iPL.ge.3) Write(6,1100) RepNuc,PNX,RepNuc+PNX
1100     Format(/,' RepNuc + Point charges = ',F13.8,' + ',F13.8,' = ',
     &          F13.8)
*
         PotNuc=PotNuc+PNX
         Call Put_dScalar('PotNuc',RepNuc)
      End If
*
*     Update the 1-e integrals
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(natom)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Igor Schapiro                                    *
************************************************************************
C
C *********************************************************************
C *                                                                   *
C * Second part of the velocity Verlet algorithm, which calculates    *
C * velocities of the next time step from the velocities from the     *
C * half step and the new forces.                                     *
C *                                                                   *
C * The algorithm is based on the example F4 of molecular dynamics    *
C * bible from Allen and Tildesley.                                   *
C *                                                                   *
C * 15/10/2006                                                        *
C * Igor Schapiro                                                     *
C *                                                                   *
C *********************************************************************

C REFERENCE:
C SWOPE ET AL., J. CHEM. PHYS. 76, 637, 1982.

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8

      SUBROUTINE VelVer_Second(irc)
      IMPLICIT REAL*8 (a-h,o-z)
#include "prgm.fh"
#include "warnings.fh"
#include "Molcas.fh"
      PARAMETER    (ROUTINE='VV_Second')
#include "MD.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "dyn.fh"
#include "constants2.fh"
      EXTERNAL     IsFreeUnit
      INTEGER      i,j,natom,file,IsFreeUnit,nsAtom
      CHARACTER    filname*80,line*80
      REAL*8       conv,tolerance,DT2,time,kb
      REAL*8       Ekin,Epot,Etot,Etot0,Ekin_target
      REAL*8       EtotLastPoint
      LOGICAL      hybrid,found
      CHARACTER  caption*15, lastline*80
      CHARACTER, ALLOCATABLE ::    atom(:)*2
      REAL*8, ALLOCATABLE ::       Mass(:),vel(:),force(:),xyz(:)
C
C     The parameter conv converts the gradients (Hartree/Bohr) to
C     (i)  forces (Hartree/Bohr)    => -1.0d0
C     (ii) forces (kJ/mole/Agstrom) => -4961.475514610d0
C
      PARAMETER   (conv=-1.0d0)
c     PARAMETER   (conv=-CONV_AU_TO_KJ_PER_MOLE_/Angstrom)
      PARAMETER   (kb = CONST_BOLTZMANN_/
     &             (CONV_AU_TO_KJ_*1.0D3))

*
      IF(IPRINT.EQ.INSANE) WRITE(6,*)' Entering ',ROUTINE

      WRITE(6,*)'*** Second step of the Velocity Verlet algorithm ***'

      filname = 'comqum.dat'
      CALL F_INQUIRE(filname,hybrid)

      IF (hybrid) THEN
         WRITE(6,'(/,5X,A)') 'Perform QM/MM Molecular Dynamics'
         CALL DxRdNAtomHbrd(natom)
      ELSE
         CALL DxRdNAtomStnd(natom)
      END IF

      CALL mma_allocate(atom,natom)
      CALL mma_allocate(Mass,natom)
      CALL mma_allocate(vel,natom*3)
      CALL mma_allocate(force,natom*3)
      CALL mma_allocate(xyz,natom*3)

      IF (hybrid) THEN
         CALL DxRdHbrd(natom,atom,xyz,force)
      ELSE
         CALL DxRdStnd(natom,atom,xyz,force)
      END IF

      CALL Get_Velocity(vel,3*natom)
      CALL GetMassDx(Mass,natom)

C Check if reduced dimensionality
      IF (POUT .NE. 0) THEN
        CALL project_out_for(force,natom)
      ELSEIF (PIN .NE. natom*3) THEN
        CALL project_in_for(force,natom)
      ENDIF
C
C     Definition of the time step
C
      DT2 = DT / 2.0d0
      Ekin = 0.0d0

      CALL Get_dScalar('MD_Time',time)

      DO i=1, natom
         DO j=1, 3
            vel(3*(i-1)+j) = vel(3*(i-1)+j) + DT2 * force(3*(i-1)+j) /
     &      Mass(i)
         END DO
      END DO
C  Calling the thermostats for canonical ensemble
      IF (THERMO.eq.2) THEN
         CALL NhcThermo(vel)
      END IF
C
C Check if reduced dimensionality (should not be needed)
      IF (POUT .NE. 0) THEN
        CALL project_out_vel(vel,natom)
      ENDIF

C Final kinetic energy
      DO i=1, natom
         DO j=1, 3
              Ekin = Ekin + 5.0d-01 * Mass(i) * (vel(3*(i-1)+j) ** 2)
         END DO
      END DO

      Call Add_Info('EKin',[EKin],1,6)
C

C
C     Write out the velocities
C
      caption = 'Velocities'
      lastline = ''
      CALL DxPtTableCo(caption,time,natom,atom,vel,lastline,Mass,force)
C
C     Read in the potential energy
C
      IF (hybrid) THEN
          file=IsFreeUnit(81)
          filname = 'fixenergy.out'
          Call Molcas_Open(file,filname)
          READ(file,*)line
             DO WHILE (i.le.80)
                IF (line(i:i).eq.'$') THEN
                   READ(file,'(E20.13)')Epot
                   i=80
                ELSEIF (i.eq.80.and.line(i:i).ne.'$') THEN
                   WRITE(6,*)'No energy found'
                   CALL Abend()
                END IF
                i=i+1
             END DO
          CLOSE(file)
      ELSE
          CALL Get_dScalar('Last Energy',Epot)
      ENDIF

      Etot = Epot + Ekin
C
C     Output
C
      IF (hybrid) THEN
          WRITE(6,'(//,5X,A,F8.1)') 'Final QM/MM Energy at time ',time
      ELSE
          WRITE(6,'(//,5X,A,F8.1)') 'Final Energy at time ',time
      ENDIF
      WRITE(6,'(5X,A,/)') '============================'
      WRITE(6,'(5X,A,6X,D19.12,1X,A)') 'Kinetic energy',Ekin,'a.u.'
      WRITE(6,'(5X,A,4X,D19.12,1X,A)') 'Potential Energy',Epot,'a.u.'
      WRITE(6,'(5X,A,8X,D19.12,1X,A)') 'Total Energy',Etot,'a.u.'

C--------------------------------------------------------------------C
C CANONICAL ENSEMBLE
C--------------------------------------------------------------------C
      tempNow = 2.D0 * Ekin /(3.D0*dble(natom)*kb)
      IF (THERMO.eq.2) THEN
         tempNow = 2.D0 * Ekin /(3.D0*dble(natom)*kb)
         WRITE(6,'(//,5X,A)') 'Canonical Ensemble'
         WRITE(6,'(5X,A)') 'The temperature is control with a '
         WRITE(6,'(5X,A)') 'Nose-Hoover chain of thermostats'
         WRITE(6,'(5X,A,/)') '========================'
         WRITE(6,'(5X,A,5X,E11.4,1X,A,//)') 'instantaneous temperature'
     &                                  ,tempNow,'kelvin'

      ENDIF
C--------------------------------------------------------------------C

C---------------------------------------------------------------------C
C     MICRO-CANONICAL ENSEMBLE
C---------------------------------------------------------------------C
      IF (THERMO.EQ.1) THEN
         CALL Get_dScalar('MD_Etot0',Etot0)
         WRITE(6,'(//,5X,A)') 'Micro-Canonical Ensemble'
         WRITE(6,'(5X,A,/)') '========================'
         WRITE(6,'(5X,A,7X,D11.4,1X,A)') 'Target Total Energy'
     &                                  ,Etot0,'a.u.'
         WRITE(6,'(5X,A,D11.4,1X,A)') 'Deviation from this Energy'
     &                              ,ABS(Etot0-Etot),'a.u.'
C
C     Check if the total energy is conserved and scale the velocities
C     if necessary.
C
C        1.0K * k_B
         tolerance=1.0D0*kb
         tolerance=1.5D0*natom*tolerance
         IF (ABS(Etot0-Etot).gt.tolerance) THEN
            Ekin_target=Etot0-Epot
            scalfac = sqrt(Ekin_target / Ekin)
            DO i=1, natom
               DO j=1,3
                  vel(3*(i-1)+j)=scalfac*vel(3*(i-1)+j)
               END DO
            END DO
            WRITE(6,'(5X,A)') 'is larger then Scaling-Threshold XX.'
            WRITE(6,'(5X,A)') 'Velocity scaling is necessary.'
            WRITE(6,401) 'Velocity scaling factor',scalfac
            Ekin=Ekin_target
         ELSE
            WRITE(6,'(5X,A)') 'is smaller then Scaling-Threshold XX.'
            WRITE(6,'(5X,A)') 'Velocity scaling is not necessary.'
         ENDIF
      ENDIF
C---------------------------------------------------------------------C
      CALL Put_dScalar('MD_Time',time)

      Etot=Epot+Ekin

C------ Tully reascaling velocities in case of HOP ---------------------C
      call qpg_iscalar('hopped',Found)
      if (found) call get_lscalar('hopped',Found)
      if (found) then
         call Get_iScalar('Unique atoms',nsAtom)
         call get_dScalar('MD_Etot',EtotLastPoint)
         Ekin_target=EtotLastPoint-Epot
         if (Ekin_target.lt.0.0) then
            Ekin_target=0.0
            write (6,*) 'warning negative kin energy rescaled to 0.0'
         end if
C         write (6,*) 'DEBUGS'
C         write (6,*) Epot, EtotLastPoint, Etot
C         write (6,*) 'EtotLastPoint'
C         write (6,*) EtotLastPoint
C         write (6,*) 'scalfac'
C         write (6,*) scalfac
C         write (6,*) 'nsAtom'
C         write (6,*) nsAtom
         scalfac = sqrt(Ekin_target / Ekin)
         write(6,*) 'Velocities before Hop:'
         do i=1, nsAtom
           write(6,*) vel(i*3-2), vel(i*3-1), vel(i*3)
         end do
         DO i=1, natom
            DO j=1,3
               vel(3*(i-1)+j)=scalfac*vel(3*(i-1)+j)
            END DO
         END DO

         write(6,*) 'Velocities after Hop:'
         do i=1, nsAtom
           write(6,*) vel(i*3-2), vel(i*3-1), vel(i*3)
         end do
         Etot=Epot+Ekin_target
      end if

      call Put_dScalar('MD_Etot',Etot)
#ifdef _HDF5_
       call mh5_put_dset(dyn_etot,Etot)
#endif
      CALL DxEnergies(time,Epot,Ekin,Etot)

      CALL DxWtVel(vel,3*natom)
      CALL Put_Velocity(vel,3*natom)
#ifdef _HDF5_
      call mh5_put_dset(dyn_vel,vel)
#endif

 401  FORMAT(5X,A,3X,E11.4)

      CALL mma_deallocate(atom)
      CALL mma_deallocate(Mass)
      CALL mma_deallocate(vel)
      CALL mma_deallocate(force)
      CALL mma_deallocate(xyz)

C
C     The return code is set in order to continue the loop
C
      irc=_RC_ALL_IS_WELL_
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001,2020,  Roland Lindh                               *
!               Sergey Gusarov                                         *
!***********************************************************************

subroutine GetPAM(lUnit,iCnttp)
!***********************************************************************
!                                                                      *
!    Objective: To read potential information, for DMFT calculations   *
!               This means that we read (from input stream)            *
!               the potential terms (PAM)                              *
!                                                                      *
! Called from: GetBs                                                   *
!                                                                      *
! Calling    : RecPrt                                                  *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!                                                                      *
!     Modified: Sergey Gusarov SPb State Ubiv, Russia.                 *
!***********************************************************************

use Basis_Info, only: dbsc
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(iwp), intent(in) :: lUnit, iCnttp
integer(kind=iwp) :: iENd, Ierr, iPAM_Ang, iPrim, iStrt, nArray, nPAM2, nPAM2Bas, nPAM2Prim
character(len=180) :: Line
real(kind=wp), allocatable :: Array(:)
#ifdef _DEBUGPRINT_
#define _TEST_ .true.
#else
#define _TEST_ .false.
#endif
logical(kind=iwp), parameter :: test = _TEST_
character(len=180), external :: Get_Ln

if (test) write(u6,*) ' Reading PAM potencials'
nArray = 10000
call mma_Allocate(Array,nArray,Label='Array')

iStrt = 1
Line = Get_Ln(lUnit)
if (index(Line,'PAM') == 0) then
  call WarningMessage(2,'ERROR: Keyword PAM expected, offending line : '//Line)
  call Quit_OnUserError()
end if
Line = Get_Ln(lUnit)
call Get_i1(1,nPAM2)
dbsc(iCnttp)%nPAM2 = nPAM2
do iPAM_Ang=0,nPAM2
  Line = Get_Ln(lUnit)
  call Get_i1(1,nPAM2Prim)
  call Get_i1(2,nPAM2Bas)
  Array(iStrt) = real(nPAM2Prim,kind=wp)
  Array(iStrt+1) = real(nPAM2Bas,kind=wp)
  iStrt = iStrt+2
  iEnd = iStrt+nPAM2Prim-1

  ! Read exponents

  if (nPAM2Prim > 0) then
    call read_v(lUnit,Array,iStrt,iEnd,1,Ierr)
    if (Ierr /= 0) then
      call WarningMessage(2,'GetPAM: Error reading GPA exponents')
      call Abend()
    end if
  end if

  ! Read coefficents

  iStrt = iEnd+1
  iEnd = iStrt+nPAM2Prim*nPAM2Bas-1
  do iPrim=0,nPAM2Prim-1
    call Read_v(lUnit,Array,iStrt+iPrim,iEnd,nPAM2Prim,ierr)
    if (ierr /= 0) then
      call WarningMessage(2,'GetPAM: Error in reading GPA!!!')
      call Abend()
    end if
  end do
  iStrt = iEnd+1
end do

call mma_allocate(dbsc(iCnttp)%PAM2,iEnd,Label='PAM2')
dbsc(iCnttp)%PAM2(:) = Array(:)

call mma_deAllocate(Array)

return

end subroutine GetPAM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2003, Valera Veryazov                                  *
************************************************************************
      SubRoutine DMat(Dens,TwoHam,nDT,NumDT,CMO,nCMO,OccNo,lthO,
     &                nD,Ovrlp,XCf,nXCf,Vxc)
************************************************************************
*                                                                      *
* Purpose: Compute aufbau density matrix                               *
*                                                                      *
* input:                                                               *
*   Dens    : density matrix - vector containing some (NumDT) last     *
*             (optimized) density matrix differences - (nDT,NumDT)     *
*   TwoHam  : two-el. part of the Fock matrix - vector containing      *
*             corresponding 2-el. contributions - (nDT,NumDT)          *
*   Vxc     : Vxc     part of the Fock matrix - vector containing      *
*             corresponding 2-el. contributions - (nDT,NumDT)          *
*   CMO     : molecular orbitals of length nCMO                        *
*   OccNo   : occupation numbers of length lthO                        *
*                                                                      *
* output:                                                              *
*   Dens    : in proper position density difference is created         *
*                                                                      *
* called from: WfCtl, Final                                            *
*                                                                      *
* calls to: RWDTG, DOne                                                *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Written by:                                                          *
* P.O. Widmark, M.P. Fuelscher and P. Borowski                         *
* University of Lund, Sweden, 1992                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* history: UHF- V.Veryazov 2003                                        *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Real*8 Dens(nDT,nD,NumDT),TwoHam(nDT,nD,NumDT), Vxc(nDT,nD,NumDT),
     &       CMO(nCMO,nD),OccNo(lthO,nD), Ovrlp(nDT), XCf(nXCf,nD)
      Logical alpha_density
      Real*8, Dimension(:), Allocatable:: Aux
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
#include "interfaces_scf.fh"
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
* Start                                                                *
*----------------------------------------------------------------------*
*define _DEBUGPRINT_
*     Call Timing(Cpu1,Tim1,Tim2,Tim3)
*
      iter_d=iter-iter0 ! get interation index
*
*     Form proper MapDns vector
*
      If (MapDns(iter_d).eq.0) Then   ! Position not defined
*
*        Update MapDns and eventually write earlier Dens, TwoHam,
*        and Vxc matrices to disk.
*
         nDsk=Max(0,iter_d-nMem) ! is there too many densities?
*
         If (nDsk.eq.0) Then    ! keep the array in memory
*
            MapDns(iter_d)=iter_d
*
         Else
*
            iFrom=MapDns(iter_d-nMem) ! get index of array to dump
*
            MapDns(iter_d)=iFrom      ! assign to new array
*
            If (iter_d-nMem.eq.1) Then
               MapDns(iter_d-nMem)=-1 !  Initiate
            Else
               MapDns(iter_d-nMem)=MapDns(iter_d-nMem-1)-1
            End If
*
*           Dump the vectors
*
            iOnDsk=-MapDns(iter_d-nMem)
            Call RWDTG(iOnDsk,Dens(1,1,iFrom),  nBT*nD,'W',
     &                 'DENS  ',iDisk,MxDDsk)
            Call RWDTG(iOnDsk,TwoHam(1,1,iFrom),nBT*nD,'W',
     &                 'TWOHAM',iDisk,MxDDsk)
            Call RWDTG(iOnDsk,Vxc   (1,1,iFrom),nBT*nD,'W',
     &                 'dVxcdR',iDisk,MxDDsk)
         End If
*
      End If
*
* Check if MapDns is correct
*
      iPsLst=MapDns(iter_d)
      If (iPsLst.le.0) Then
         Write (6,*) 'DMat: iPsLst.le.0'
         Write (6,*) 'iPsLst=',iPsLst
         Call Abend()
      End If
*
*
* Form i-th density matrix in the position iPsLst
*
      If (InVec.eq.3 .and. iter_d.eq.1) Then
*
* First density matrix is actually in the first position
* (read from RUNFILE) on the first iteration.
*
      Else
*
*        Using the CMOs generate the new density in position iPsLst
*
         alpha_density=.True.
         Do iD = 1, nD
            Call DOne_SCF(nSym,nBas,nOrb,nFrz,CMO(1,iD),nCMO,
     &                    OccNo(1,iD),Dens(1,iD,iPsLst),alpha_density)
            alpha_density=.False.
         End Do ! iD
      End If
*
      Do iD = 1, nD
         Call ChkTrD(nSym,nBas,nOrb,OccNo(1,iD),Dens(1,iD,iPsLst),Ovrlp)
      End Do ! iD
*
#ifdef _DEBUGPRINT_
      Call NrmClc(Dens(1,1,iPsLst),nBT*nD,'DMat  ','D Iter    ')
#endif
*
*     Put the actual densities on the run file.
*
*     Note, this is from where the DFT part of the DrvXV code gets the
*     total density when it computes the DFT constributions to the
*     total energy and the Fock matrix.
*
      Call DensAB(nBT,iPsLst,nD,Dens)
*
* Form density difference (normal or minimized). Notice, that
* for minimized differences i-th density is copied to position
* nDens and kept there till the end of iteration.
* For normal differences position nDens is occupied by the density
* of the previous iteration, until
* (i)  OptClc is called (DIIS-only case), or
* (ii) after Diis (QNR case)
* after that, the actual density is stored at that memory location
*
      If(MiniDn.and. Max(0,nIter(nIterP)-1).gt.0) Then
*
*        Minimized density option
*
         Call DCopy_(nBT*nD,Dens(1,1,iPsLst),1,Dens(1,1,nDens),1)
         If (iter_d.gt.1) Call MinDns(Dens,nBT,nDens,XCf,nXCf,nD)
*
      Else If (.not.DDnOFF) Then
*
*        Do the density difference, D(iPsLst)-D(nDens)=D(k+1)-D(k)
*
         Call mma_allocate(Aux,nBT*nD,Label='Aux')
         Call DCopy_(nBT*nD,Dens(1,1,iPsLst),1,Aux,1)
         Call Daxpy_(nBT*nD,-One,Dens(1,1,nDens ),1,Dens(1,1,iPsLst),1)
         Call DCopy_(nBT*nD,Aux,1,Dens(1,1,nDens),1)
         Call mma_deallocate(Aux)
*
      Else
*
         call DCopy_(nBT*nD,Dens(1,1,iPsLst),1,Dens(1,1,nDens ),1)
*
      End If
*
      DNorm=DBLE(nD)
     &     *DDot_(nBT*nD,Dens(1,1,iPsLst),1,Dens(1,1,iPsLst),1)
*
#ifdef _DEBUGPRINT_
      Write (6,*) 'DNorm=',DNorm
      Call NrmClc(Dens(1,1,iPsLst),nBT*nD,'DMat  ','D iPsLst  ')
      Call NrmClc(Dens(1,1,nDens), nBT*nD,'DMat  ','D nDens   ')
#endif
*
*      Call Timing(Cpu2,Tim1,Tim2,Tim3)
*      TimFld( 4) = TimFld( 4) + (Cpu2 - Cpu1)
*----------------------------------------------------------------------*
* Exit                                                                 *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_OrbE(OrbE,nOrbE)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOrbE
real(kind=wp), intent(out) :: OrbE(nOrbE)
integer(kind=iwp) :: nData
character(len=24) :: Label
logical(kind=iwp) :: Found

Label = 'OrbE'
call qpg_dArray(Label,Found,nData)
if ((.not. Found) .or. (nOrbE == 0)) call SysAbendMsg('get_orbe','Did not find:',Label)
if (nOrbE /= nData) call SysAbendMsg('get_orbe','nOrbE /= nData','')
call Get_dArray(Label,OrbE,nOrbE)

return

end subroutine Get_OrbE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2007, Markus Reiher                               *
************************************************************************
      subroutine initialize2 (nbas,isize,vv,nn,dd,yy,ff,gg,xx,ii,
     *                        jj,kk,ll,mm,revt,tran,sinv,aa,rr,tt,pp,e,
     *                        ew,snumber,tnumber,unumber,
     *                        scrno1,scrno2,nbasp,scr1,scr2,scr3,
     *                        scr5,scr8,dkhorder,xorder)
c
c************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 14.01.2007 (M. Reiher, ETH Zurich)
c            * a couple of matrices are no longer set equal to zero
c             as this is not really necessary
c            * in addition, the last dimension of some arrays is now
c             '*' so that the call to this routine remains unchanged
c             if the no_prop option is switched on
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer nbas,isize,snumber,tnumber,unumber,scrno1,nbasp,
     *        scrno2,dkhorder,xorder
      integer i,j,k
c
      REAL*8 vv(nbas,*),nn(nbas,*),dd(nbas,*),
     *                 yy(nbas,*),ff(nbas,*),gg(nbas,*),
     *                 xx(nbasp,*),
     *                 ii(nbasp,*),jj(nbasp,*),kk(nbasp,*),
     *                 ll(nbasp,*),mm(nbasp,*)
c
      REAL*8 revt(nbas,nbas),tran(nbas,nbas),sinv(nbas,nbas),
     *                 aa(nbas),rr(nbas),tt(nbas),pp(nbas),e(nbas),
     *                 ew(nbas)
c
      REAL*8 scr1(nbas,nbas,snumber),scr2(nbas,nbas,tnumber),
     *                 scr3(nbas,nbas,unumber),scr5(nbas,nbas,scrno1),
     *                 scr8(isize,scrno2)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
CMR          vv(i,j)=0.0d0
CMR          nn(i,j)=0.0d0
CMR          dd(i,j)=0.0d0
CMR          yy(i,j)=0.0d0
CMR          ff(i,j)=0.0d0
CMR          gg(i,j)=0.0d0
          revt(i,j)=0.0d0
          tran(i,j)=0.0d0
          sinv(i,j)=0.0d0
CMR The following matrices are of dimension nbasp X nbasp
CMR          xx(i,j)=0.0d0
CMR          ii(i,j)=0.0d0
CMR          jj(i,j)=0.0d0
CMR          kk(i,j)=0.0d0
CMR          ll(i,j)=0.0d0
CMR          mm(i,j)=0.0d0
  20    continue
  10  continue
      do 40 i=1,nbas
        aa(i)=0.0d0
        rr(i)=0.0d0
        tt(i)=0.0d0
        pp(i)=0.0d0
        e(i)=0.0d0
        ew(i)=0.0d0
  40  continue
c
      do 110 k=1,snumber
        do 112 j=1,nbas
          do 114 i=1,nbas
            scr1(i,j,k)=0.0d0
 114      continue
 112    continue
 110  continue
c
      do 120 k=1,tnumber
        do 122 j=1,nbas
          do 124 i=1,nbas
            scr2(i,j,k)=0.0d0
 124      continue
 122    continue
 120  continue
c
      do 130 k=1,unumber
        do 132 j=1,nbas
          do 134 i=1,nbas
            scr3(i,j,k)=0.0d0
 134      continue
 132    continue
 130  continue
c
      do 150 k=1,scrno1
        do 152 j=1,nbas
          do 154 i=1,nbas
            scr5(i,j,k)=0.0d0
 154      continue
 152    continue
 150  continue
c
CMR      do 180 k=1,scrno2
CMR        do 182 j=1,isize
CMR          scr8(j,k)=0.0d0
CMR 182    continue
CMR 180  continue
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real_array(vv)
        call Unused_real_array(nn)
        call Unused_real_array(dd)
        call Unused_real_array(yy)
        call Unused_real_array(ff)
        call Unused_real_array(gg)
        call Unused_real_array(xx)
        call Unused_real_array(ii)
        call Unused_real_array(jj)
        call Unused_real_array(kk)
        call Unused_real_array(ll)
        call Unused_real_array(mm)
        call Unused_real_array(scr8)
        call Unused_integer(dkhorder)
        call Unused_integer(xorder)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mean_field(EXCH,N,H,X,Y,Z,zJ,T,W,thrs,dM,sM,ST,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: EXCH, N
real(kind=wp), intent(in) :: H, X, Y, Z, zJ, T, W(EXCH), thrs
complex(kind=wp), intent(in) :: DM(3,EXCH,EXCH), SM(3,EXCH,EXCH)
real(kind=wp), intent(out) :: ST(3)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: iopt
complex(kind=wp), allocatable :: DM_TMP(:,:,:), SM_TMP(:,:,:)

iopt = 2

if (iopt == 1) then

  if (dbg) write(u6,'(A)') 'mean_field: enter mean_field_exch'
  call mma_allocate(DM_TMP,3,N,N,label='DM_TMP')
  call mma_allocate(SM_TMP,3,N,N,label='SM_TMP')
  DM_TMP(:,:,:) = DM(:,1:N,1:N)
  SM_TMP(:,:,:) = SM(:,1:N,1:N)
  call mean_field_exch(N,H,X,Y,Z,zJ,T,W(1:N),thrs,DM_TMP,SM_TMP,ST)
  call mma_deallocate(DM_TMP)
  call mma_deallocate(SM_TMP)
  if (dbg) write(u6,'(A)') 'mean_field: exit mean_field_exch'

else if (iopt == 2) then

  if (dbg) write(u6,'(A)') 'mean_field: enter mean_field_all'
  call mean_field_all(EXCH,N,H,X,Y,Z,zJ,T,W,thrs,DM,SM,ST)
  if (dbg) write(u6,'(A)') 'mean_field: exit mean_field_all'

else

  write(u6,'(A)') 'MEAN_FIELD:  iopt is not defined:',iopt

end if

return

end subroutine mean_field

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine elmhes(nm,n,low,igh,a,intx)
! this subroutine is a translation of the algol procedure elmhes,
! num. math. 12, 349-368(1968) by martin and wilkinson.
! handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
!
! given a real general matrix, this subroutine
! reduces a submatrix situated in rows and columns
! low through igh to upper hessenberg form by
! stabilized elementary similarity transformations.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.
!
!    n is the order of the matrix.
!
!    low and igh are integers determined by the balancing
!      subroutine  balanc.  if  balanc  has not been used,
!      set low=1, igh=n.
!
!    a contains the input matrix.
!
! on output
!
!    a contains the hessenberg matrix.  the multipliers
!      which were used in the reduction are stored in the
!      remaining triangle under the hessenberg matrix.
!
!    intx contains information on the rows and columns
!      interchanged in the reduction.
!      only elements low through igh are used.
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n, low, igh
real(kind=wp), intent(inout) :: a(nm,n)
integer(kind=iwp), intent(out) :: intx(igh)
integer(kind=iwp) :: i, j, kp1, la, m, mm1, mp1
real(kind=wp) :: x, y

la = igh-1
kp1 = low+1

do m=kp1,la
  mm1 = m-1
  x = Zero
  i = m

  do j=m,igh
    if (abs(a(j,mm1)) <= abs(x)) cycle
    x = a(j,mm1)
    i = j
  end do

  intx(m) = i
  if (i /= m) then
    ! .......... interchange rows and columns of a ..........
    do j=mm1,n
      y = a(i,j)
      a(i,j) = a(m,j)
      a(m,j) = y
    end do

    do j=1,igh
      y = a(j,i)
      a(j,i) = a(j,m)
      a(j,m) = y
    end do
    ! .......... end interchange ..........
  end if
  if (x == Zero) cycle
  mp1 = m+1

  do i=mp1,igh
    y = a(i,mm1)
    if (y == Zero) cycle
    y = y/x
    a(i,mm1) = y

    a(i,m:) = a(i,m:)-y*a(m,m:)

    a(1:igh,m) = a(1:igh,m)+y*a(1:igh,i)

  end do

end do

return

end subroutine elmhes

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine trust_cvb(iopth,opth,maxize,fx,fxbest,exp,
     >  hh,dxnrm,ioptc,scalesmall1,close2conv,converged,skipupd)
      implicit real*8 (a-h,o-z)
#include "formats_cvb.fh"
      logical opth,maxize,scalesmall1,close2conv,converged
      logical skipupd
      logical dfx_ok,zz_ok
#include "trst_cvb.fh"
#include "tune_cvb.fh"
#include "print_cvb.fh"
      save zero,half,one
      data zero/0d0/,half/.5d0/,one/1d0/

      call zz_cvb(dum,zz,fx,fxbest,exp,-1)
      skipupd=.false.
      if(.not.close2conv)then
        ipu=1
      else
        ipu=2
      endif
      nopth=nopth1(ipu)+nopth2(ipu)
      scalesmall1=scalesmall(ipu)

c
c---- Trust region control, based on the quadratic model
c
      iop=mod(iopth,nopth)
      if(iop.eq.0)iop=iop+nopth
      if(iopth.gt.0)cpropt(iop)=fx
c  Set HHOPT to HH actually used (might have been scaled ) :
      if(iopth.gt.0)hhopt(iop)=dxnrm
1     continue
      if(iopth.gt.0.and.mod(iopth,nopth).eq.0.and.opth)then
c  Optimisation of trust region completed
        opth=.false.
        if(maxize)then
          call findmx_cvb(cpropt,nopth,cprbst,icprbst)
        else
          call findmn_cvb(cpropt,nopth,cprbst,icprbst)
        endif
        dfx=cprbst-fxbest
        dfx_ok=((dfx.gt.dfxmin(ipu).and.maxize).or.
     >          (dfx.lt.-dfxmin(ipu).and..not.maxize))
        zz_ok=(zz.gt.zzrejmin(ipu).and.zz.lt.zzrejmax(ipu))
        if(dfx_ok.and.zz_ok)then
c  << Accepting update >>
          iopth=0
c  Restore HH as used before (so repeated update vector will be
c  exactly the same) :
          if(icprbst.le.nopth1(ipu))then
            hh=hhkeep*(one+(DBLE(icprbst)-half*DBLE(nopth1(ipu)+1))
     >        *delopth1(ipu))
          elseif(icprbst.le.nopth)then
            ! IFG: nopth1 was used in these two calls, probably a bug
            if(maxize)then
              call findmx_cvb(cpropt,nopth,cprbst,icprbst2)
            else
              call findmn_cvb(cpropt,nopth,cprbst,icprbst2)
            endif
            hh=hhkeep*(one+(DBLE(icprbst2)-half*DBLE(nopth1(ipu)+1))
     >        *delopth1(ipu))
            gap2=hhkeep*delopth1(ipu)*delopth2(ipu)
            hh=hh+gap2*
     >        (DBLE(icprbst-nopth1(ipu))-half*DBLE(nopth2(ipu)+1))
          endif
          hh=min(hh,hhmax(ipu))
c  Scale trust region size according to ZZ :
          if(zz.lt.zzacclim(1,ipu))then
            scale=hhaccfac(1,ipu)
          elseif(zz.gt.zzacclim(4,ipu))then
            scale=hhaccfac(5,ipu)
          elseif(zz.lt.zzacclim(2,ipu))then
            scale=hhaccfac(2,ipu)
          elseif(zz.gt.zzacclim(3,ipu))then
            scale=hhaccfac(4,ipu)
          else
            scale=hhaccfac(3,ipu)
          endif
          if(nopth.gt.1)then
            if(hhopt(icprbst).gt.1d-8.and.hh/hhopt(icprbst).gt.2d0)then
              hhkeep=hh
            else
c  Scale trust region size according to ZZ :
              hhkeep=hh*scale
            endif
          else
            oldstep=hhopt(icprbst)
c  Scale trust region size according to ZZ :
            if(scale.ge.one)then
              hhkeep=max(hhkeep,oldstep*scale)
            else
              hhkeep=hhkeep*scale
            endif
          endif
          skipupd=(icprbst.eq.nopth)
        else
c  << Rejecting update >>
          if(converged)then
            iopth=0
            hh=zero
            return
          endif
          if(ip(3).ge.1)write(6,'(a)')' Rejecting step.'
          call findmn_cvb(hhopt,nopth,hh_min,idum)
          hhkeep=min(hh_min,hhkeep)*hhrejfac(ipu)
          gap2=hhkeep*delopth1(ipu)*delopth2(ipu)
          if(nopth2(ipu).eq.0)gap2=zero
          hhlargest=hhkeep*(one+(DBLE(nopth1(ipu))
     >      -half*DBLE(nopth1(ipu)+1))*delopth1(ipu))
     >      +gap2*(DBLE(nopth-nopth1(ipu))-half*DBLE(nopth2(ipu)+1))
          if(hhlargest.lt.hhtol(ipu))then
            if(ip(3).ge.0)then
              write(6,formAD)
     >          ' Trust region size smaller than tolerance !',
     >          hhlargest,hhtol(ipu)
              write(6,'(a)')' Calculation NOT converged!'
            endif
            ioptc=-2
            return
          endif
          goto 1
        endif
      else
        if(iopth.eq.0.and.nopth.gt.1.and.(ip(3).ge.2))
     >    write(6,'(/,a)')' Optimising trust region size :'
        opth=.true.
        iopth=iopth+1
        ioptst=mod(iopth,nopth)
        if(ioptst.eq.0)ioptst=ioptst+nopth

        if(ioptst.le.nopth1(ipu))then
          hh=hhkeep*(one+(DBLE(ioptst)-half*DBLE(nopth1(ipu)+1))
     >      *delopth1(ipu))
        elseif(ioptst.le.nopth)then
          ! IFG: nopth1 was used in these two calls, probably a bug
          if(maxize)then
            call findmx_cvb(cpropt,nopth,cprbst,icprbst)
          else
            call findmn_cvb(cpropt,nopth,cprbst,icprbst)
          endif
          hh=hhkeep*(one+(DBLE(icprbst)-half*DBLE(nopth1(ipu)+1))
     >      *delopth1(ipu))
          gap2=hhkeep*delopth1(ipu)*delopth2(ipu)
          hh=hh+gap2*(DBLE(ioptst-nopth1(ipu))
     >         -half*DBLE(nopth2(ipu)+1))
        endif
        hh=min(hh,hhmax(ipu))
        hhopt(ioptst)=hh
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Bjorn O. Roos                                          *
*               1991, Roland Lindh                                     *
************************************************************************
      Subroutine Decode(LBL,string,N,Hit)
************************************************************************
* Object: to find the character string 'string' between                *
*         dots N-1 and N in the label LBL of length lLBL               *
*         blanks in string are removed                                 *
* Called from: Rdbsl                                                   *
* Subroutine calls: none                                               *
*                                                                      *
* Author: Bjoern Roos, University of Lund, Sweden                      *
************************************************************************
      Character*(*) LBL,string
      Character*80 xstring
      Character*1 dot
      Logical Hit
      Data dot/'.'/
*
*     write(6,'(1x,a)') LBL
      i1=1
      idot=0
      lstring=0
      lLBL=LEN(LBL)
      Do 10 i=1,lLBL
       if(LBL(i:i).ne.dot) go to 10
       idot=idot+1
       if(idot.eq.N-1) i1=i+1
       if(idot.eq.N) then
        xstring=' '
*       Write (*,'(1x,A,/,1X,A)') ' xstring=',xstring
        if(i.gt.i1) xstring=LBL(i1:i-1)
*       Write (*,'(1x,A,/,1X,A)') ' xstring=',xstring
        lstring=i-i1
        go to 20
       Endif
   10 Continue
      If (Hit) Then
         Call WarningMessage(2,'Decode: error in basis set label')
         Write (6,'(A,A)')'LBL=',LBL
         Call Abend()
      Else
         Return
      End If
*
*     Pack the string
*
   20 Continue
      Hit=.True.
      i1=0
      string=' '
      Do 30 i=1,lstring
       If(xstring(i:i).eq.' ') go to 30
       i1=i1+1
       string(i1:i1) =xstring(i:i)
   30 continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module OneDat

use Molcas, only: MxAtom, MxBas, MxSym
use Definitions, only: iwp, ItoB

implicit none
private

!----------------------------------------------------------------------*
!                                                                      *
! Return codes:                                                        *
!   %good - No error                                                   *
!   %CL01 - file is not opened                                         *
!   %RD03 - information not available                                  *
!   %WR11 - to many operators                                          *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Switches for one electron integral handlers:                         *
!   sOpSiz - Return only size of array                                 *
!   sNoOri - Do not read origin of operator                            *
!   sNoNuc - Do not read nuclear contribution                          *
!   sRdFst - Read first operator                                       *
!   sRdNxt - Read next operator                                        *
!   sNew   - New file, create.                                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Other definitions                                                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Parameters:                                                          *
!   NaN    - Not a Number = Variable undefined                         *
!   NotNaN - A Number = Variable is defined                            *
!   nAuxDt - extra space for origin and nuclear contribution.          *
!   nTitle - length of title.                                          *
!   MxOp   - Max number of operators                                   *
!   LenOp  - Length of TOC field defining operator                     *
!                                                                      *
! Pointers:                                                            *
!   pFID   - File identifier                                           *
!   pVersN - Version number                                            *
!   pTitle - Titleof the problem                                       *
!   pOp    - Operator list                                             *
!   pSym   - Number of irred. representations                          *
!   pSymOp - generator of irred. representation                        *
!   pBas   - Number of basis functions per irred. representation       *
!   pAtom  - Atoms in system                                           *
!   pCoord - Coordinates of atoms in system                            *
!   pPot   - Nuclear-Nuclear repulsion                                 *
!   pCoM   - Coordinates of center of mass                             *
!   pCoC   - Coordinates of center of charge                           *
!   pALbl  - Atom labels                                               *
!   pType  - Basis function symmetry labels                            *
!   pChrge - Charge of atoms in system                                 *
!   pOption- Various options - direct, expert mode, ...                *
!   pNext  - Next free record                                          *
!                                                                      *
! Offsets:                                                             *
!   oLabel - Label of operator                                         *
!   oComp  - Component number                                          *
!   oSymLb - Symmetry label of operator                                *
!   oAddr  - Disk address                                              *
!                                                                      *
!----------------------------------------------------------------------*

type FInfo_type
  integer(kind=iwp) :: ID = 4101, VN = 1024
end type FInfo_type
type(FInfo_type), parameter :: FInfoOne = FInfo_type()

type rc_type
  integer(kind=iwp) :: good = 0, &
                       CL01 = 1, &
                       RD03 = 2, &
                       WR11 = 3
end type rc_type
type(rc_type), parameter :: rcOne = rc_type()

integer(kind=iwp), parameter :: sOpSiz = 0, &
                                sNoOri = sOpSiz +1, &
                                sNoNuc = sNoOri +1, &
                                sRdFst = sNoNuc +1, &
                                sRdNxt = sRdFst +1, &
                                sRdCur = sRdNxt +1, &
                                sDbg   = sRdCur +1
integer(kind=iwp), parameter :: sNew = 0, &
                                sDmp = sNew +1
integer(kind=iwp), parameter :: NaN = -1, &
                                nAuxDt = 4, nTitle = (72*2)/ItoB, &
                                MxOp = 16384, LenOp = 5
integer(kind=iwp), parameter :: pFID    = 1, &
                                pVersN  = pFID    +1, &
                                pTitle  = pVersN  +1, &
                                pOp     = pTitle  +nTitle+1, &
                                pSym    = pOp     +MxOp*LenOp, &
                                pSymOp  = pSym    +1, &
                                pBas    = pSymOp  +MxSym, &
                                pAtom   = pBas    +MxSym, &
                                pCoord  = pAtom   +1, &
                                pPot    = pCoord  +6*MxAtom+1, &
                                pCoM    = pPot    +2+1, &
                                pCoC    = pCoM    +6+1, &
                                pALbl   = pCoC    +6+1, &
                                pType   = pALbl   +MxAtom+1, &
                                pChrge  = pType   +4*MxBas+1, &
                                pIndex  = pChrge  +2*MxAtom+1, &
                                pNext   = pIndex  +2*MxAtom+1, &
                                pOption = pNext   +1, &
                                pEnd    = pOption +1
integer(kind=iwp), parameter :: oLabel = 0, &
                                oComp  = oLabel +2, &
                                oSymLb = oComp  +1, &
                                oAddr  = oSymLb +1

type AuxOne_type
  integer(kind=iwp) :: Lu = 0
  logical(kind=iwp) :: Opn = .false.
end type AuxOne_type

integer(kind=iwp), parameter :: lTocOne = 1024*int(real(pEnd+1023)/1024.0)
integer(kind=iwp) :: nBas(8), nSym
type(AuxOne_type) :: AuxOne
integer(kind=iwp), allocatable :: TocOne(:)

public :: AuxOne, FInfoOne, LenOp, lTocOne, MxOp, NaN, nAuxDt, nBas, nSym, oAddr, oComp, oLabel, oSymLb, pALbl, pAtom, pBas, &
          pChrge, pCoC, pCoM, pCoord, pEnd, pFID, pIndex, pNext, pOp, pOption, pPot, pSym, pSymOp, pTitle, pType, pVersN, rcOne, &
          sDbg, sDmp, sNew, sNoNuc, sNoOri, sOpSiz, sRdCur, sRdFst, sRdNxt, TocOne

end module OneDat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,1995, Roland Lindh                                *
!***********************************************************************

subroutine WelGrd( &
#                 define _CALLING_
#                 include "grd_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: to compute the Pauli repulsion integrals with the            *
!         Gauss-Hermite quadrature.                                    *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden. October '92.                            *
!                                                                      *
!             Modified to gradients, April '95. R. Lindh               *
!***********************************************************************

use Center_Info, only: dc
use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: i, iAlpha, iBeta, ik, iOff, ip, ip0m, ip0p, ip1, ip2, ip3, ip4, ip5, ipAlph, ipAMx, ipBeta, ipGri, ipGrin, &
                     ipm0, ipp0, iPrint, ipScr, ipTGri, iPxyz, iRout, jp, jsumm, jsump, k, k0
#include "wldata.fh"
#include "print.fh"

#include "macros.fh"
unused_var(ZInv)
unused_var(nHer)
unused_var(Ccoor(1))
unused_var(nOrdOp)
unused_var(iStabM)
unused_var(nStabM)

iRout = 122
iPrint = nPrint(iRout)
!iQ = 1
if (iPrint >= 59) then
  write(u6,*) ' In WelGrd'
  write(u6,*) ' r0, ExpB=',r0,ExpB
  write(u6,*) ' la,lb=',la,lb
  write(u6,*) '  A=',A
  write(u6,*) ' RB=',RB
end if

k = la+lb+1
jsump = 1
do i=1,k
  jsump = jsump+3**i
end do
k0 = max(la+lb-1,0)
jsumm = 1
do i=1,k0
  jsumm = jsumm+3**i
end do

ip = 1
ipGri = ip
ip = ip+nZeta*jsump
ipTGri = ip
ip = ip+nZeta*jsump
ipGrin = ip
ip = ip+nZeta*(k+1)*(k/2+1)*(k/4+1)
iPxyz = ip
ip = ip+nZeta
if (ip-1 > nZeta*nArr) then
  write(u6,*) ' ip-1 > nZeta*nArr(pos.1)'
  write(u6,*) ip-1,'>',nZeta*nArr
  call ErrTra()
  call Abend()
end if

call Rowel(nZeta,r0,expB,k,Zeta,P,Array(iPxyz),Array(ipGri),Array(ipGrin),jsump)
ip = ip-nZeta
ip = ip-nZeta*(k+1)*(k/2+1)*(k/4+1)
if (iPrint >= 99) call RecPrt(' In WelInt: Array(ipGri)l',' ',Array(ipGri),nZeta,jSumP)

ipAMx = ip
ip = ip+nZeta*9
ipScr = ip
ip = ip+nZeta*3**k
if (ip-1 > nZeta*nArr) then
  write(u6,*) ' ip-1 > nZeta*nArr(pos.2)'
  write(u6,*) ip-1,'>',nZeta*nArr
  call ErrTra()
  call Abend()
end if

! Transform each block to the global coordinate system

iOff = ipgri+nZeta
do ik=1,k
  if (ik == 1) call SetUpA(nZeta,Array(ipAMx),P)
  call Traxyz(nZeta,ik,Array(iOff),Array(ipScr),Array(ipAMx))
  iOff = iOff+nZeta*3**ik
end do
if (iPrint >= 99) call RecPrt(' In WelInt: Array(ipGri)g',' ',Array(ipGri),nZeta,jSumP)
call dcopy_(nZeta*jsump,Array(ipGri),1,Array(ipTGri),1)
ip = ip-nZeta*3**k
ip = ip-nZeta*9

ip1 = ip
ip = ip+nZeta
ip2 = ip
ip = ip+nZeta
ip3 = ip
ip = ip+nZeta
ip4 = ip
ip = ip+nZeta
ip5 = ip
ip = ip+nZeta
if (ip-1 > nZeta*nArr) then
  write(u6,*) ' ip-1 > nZeta*nArr(pos.3)'
  write(u6,*) ip-1,'>',nZeta*nArr
  call ErrTra()
  call Abend()
end if

! Compute <a|O|b+1>

ip0p = ip
ip = ip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb+1)
call TraPAB(nZeta,la,lb+1,Array(ip0p),Array(ipgri),jSump,rKappa,Array(ip1),Array(ip2),Array(ip3),Array(ip4),Array(ip5),A,RB,P)

! Compute <a|O|b-1>

if (lb >= 1) then
  ip0m = ip
  ip = ip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb-1)
  call dcopy_(nZeta*jsumm,Array(ipTGri),1,Array(ipGri),1)
  call TraPAB(nZeta,la,lb-1,Array(ip0m),Array(ipgri),jSumm,rKappa,Array(ip1),Array(ip2),Array(ip3),Array(ip4),Array(ip5),A,RB,P)
else
  ip0m = 1
end if

! Compute <a+1|O|b>

ipp0 = ip
ip = ip+nZeta*nTri_Elem1(la+1)*nTri_Elem1(lb)
call dcopy_(nZeta*jsump,Array(ipTGri),1,Array(ipGri),1)
call TraPAB(nZeta,la+1,lb,Array(ipp0),Array(ipgri),jSump,rKappa,Array(ip1),Array(ip2),Array(ip3),Array(ip4),Array(ip5),A,RB,P)

! Compute <a-1|O|b>

if (la >= 1) then
  ipm0 = ip
  ip = ip+nZeta*nTri_Elem1(la-1)*nTri_Elem1(lb)
  call dcopy_(nZeta*jsumm,Array(ipTGri),1,Array(ipGri),1)
  call TraPAB(nZeta,la-1,lb,Array(ipm0),Array(ipgri),jSumm,rKappa,Array(ip1),Array(ip2),Array(ip3),Array(ip4),Array(ip5),A,RB,P)
else
  ipm0 = 1
end if

ipAlph = ip
ip = ip+nZeta
ipBeta = ip
ip = ip+nZeta

jp = ipAlph
do iBeta=1,nBeta
  call dcopy_(nAlpha,Alpha,1,Array(jp),1)
  jp = jp+nAlpha
end do
jp = ipBeta
do iAlpha=1,nAlpha
  call dcopy_(nBeta,Beta,1,Array(jp),nAlpha)
  jp = jp+1
end do

! Assemble the derivative integrals and distribute contributions.

call CmbnW1(Array(ipp0),Array(ipm0),Array(ip0p),Array(ip0m),nZeta,la,lb,Zeta,rKappa,rFinal,Array(ipAlph),Array(ipBeta),Grad,nGrad, &
            DAO,IfGrad,IndGrd,dc(mdc)%nStab,dc(ndc)%nStab,kOp)

ip = ip-5*nZeta
ip = ip-2*nZeta
if (la >= 1) ip = ip-nZeta*nTri_Elem1(la-1)*nTri_Elem1(lb)
ip = ip-nZeta*nTri_Elem1(la)*nTri_Elem1(lb+1)
if (lb >= 1) ip = ip-nZeta*nTri_Elem1(la)*nTri_Elem1(lb-1)
ip = ip-nZeta*nTri_Elem1(la+1)*nTri_Elem1(lb)
ip = ip-2*nZeta*jsump

return

end subroutine WelGrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Kurt Pfingst                                     *
************************************************************************
      SubRoutine Radlc(Zeta,nZeta,lsum,Rnr)
************************************************************************
*                                                                      *
* Object: to compute the radial part of the continuum  multipole       *
*         integrals within an R-matrix run                             *
*                                                                      *
* Called from: Mltint                                                  *
*                                                                      *
* Author: K.Pfingst 21/5/93                                            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "rmat.fh"
#include "real.fh"
#include "nrmf.fh"
      external fradf
      Character*80 Label
      Real*8 Zeta(nZeta), Rnr(nZeta,0:lsum)
      Parameter(limit=200,lenw=4*limit)
      Integer iScrt(limit)
      Real*8 Scrt(lenw)
*
*     Statement function for Cartesian index
*
      iRout = 122
      iPrint = nPrint(iRout)
ccccccccccccccccccccccccccccccccccccccc
c     iPrint = 99
ccccccccccccccccccccccccccccccccccccccc
      Result=Zero
*
************************************************************************
*
*
       Do 150 ir=0,lsum
        Do 250 iZeta=1,nZeta
         expsum=Zeta(iZeta)
         l=ir
*        If (quadpack) then
         If (quadpack.and..not.testint) then
            ier2=-1
            call dqag(fradf,0.0d0,Rmatr,Epsabs,Epsrel,Keyr,result2,
     &                abser,neval,ier2,
     &                limit,lenw,last,iScrt,Scrt)
            if (ier2.ne.0) then
               Call WarningMessage(1,
     &             ' WARNING in Radlc; Consult the output for details!')
               write(6,*)
               write(6,*) ' WARNING in Radlc'
               write(6,*)
               write(6,*)
     &                  ' ier=',ier2,' Error in Dqag called from Radlc.'
               write(6,*) ' result=',result2
               write(6,*) ' abser=',abser
               write(6,*) ' neval=',neval
               write(6,*)
            end if
            result=result2
*        Else If(Nagint) then
         Else If(Nagint.and..not.testint) then
            Call WarningMessage(2,
     &                          'Radlc: Nagint option not implemented!')
            Call Abend()
C           ier1=-1
C           call d01ajf(fradf,0.0d0,Rmatr,Epsabs,Epsrel,result1,abser,
C    *                  wrk1,4*INtparm,iwrk1,INtparm,ier1)
C           if (ier1.ne.0) then
C              write(*,*)
C              write(*,*) ' WARNING in Radlc'
C              write(*,*)
C              write(6,*)
C    &                ' ier=',ier1,' Error in D01ajf called from Radlc.'
C              write(6,*) ' result=',result1
C              write(6,*) ' abser=',abser
C              write(6,*) ' intparm=',intparm
C              write(6,*)
C           end if
C           result=result1
         EndIf
         If (testint) then
            Call WarningMessage(2,
     &                  'Radlc: testint option not implemented!')
            Call Abend()
C           ier2=-1
C           call dqag(fradf,0.0d0,Rmatr,Epsabs,Epsrel,Keyr,result2,
C    &                abser,neval,ier2,
C    &                limit,lenw,last,iScrt,Scrt)
C           if (ier2.ne.0) then
C              write(*,*)
C              write(*,*) ' WARNING in Radlc'
C              write(*,*)
C              write(6,*)
C    &                  ' ier=',ier2,' Error in Dqag called from Radlc.'
C              write(6,*) ' result=',result2
C              write(6,*) ' abser=',abser
C              write(6,*) ' neval=',neval
C              write(6,*)
C           end if
*
C           ier1=-1
C           call d01ajf(fradf,0.0d0,Rmatr,Epsabs,Epsrel,result1,abser,
C    *                  wrk1,4*INtparm,iwrk1,INtparm,ier1)
C           if (ier1.ne.0.or.ier2.ne.0) then
C              write(*,*)
C              write(*,*) ' WARNING in Radlc'
C              write(*,*)
C              write(6,*)
C    &                ' ier=',ier1,' Error in D01ajf called from Radlc.'
C              write(6,*) ' result=',result1
C              write(6,*) ' abser=',abser
C              write(6,*) ' intparm=',intparm
C              write(6,*)
C           end if
C           result=result1
*
C           diff=abs(result2-result1)
C           diff1=abs((result2-result1)/result2)
C           If (diff.gt.epsabs.or.diff1.gt.epsrel) then
C              write(*,*)
C              write(*,*) ' WARNING in Radlc'
C              write(*,*)
C              write(6,*) ' DIFFabs =',diff
C              write(*,*)
C              write(6,*) ' DIFFrel =',diff1
C              write(*,*)
C              write(6,*) ' NAG result=',result1
C              write(*,*)
C              write(6,*) ' NAG error =',ier1
C              write(*,*)
C              write(6,*) ' QUAD result=',result2
C              write(*,*)
C              write(6,*) ' QUAD error =',ier2
C              write(*,*)
C           End If
         End If
         Rnr(iZeta,ir)=result
250     continue
150    continue
*
************************************************************************
*
*
      If (iPrint.ge.99) Then
         Write (6,*) ' Result in Radlc'
         Write (Label,'(A)') ' Rnr'
         Call RecPrt(Label,' ',Rnr(1,0),nZeta,lsum+1)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************

!***********************************************************************
! History:                                                             *
! Jie J. Bao on May 09, 2022, created this file                        *
! Matthew R. Hennefarth Apr 05, 2023, upgraded to module               *
!***********************************************************************

module mspdft_util

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
private

public :: print_effective_ham, print_final_energies, print_mspdft_vectors, replace_diag

contains

! Prints the Final MS-PDFT Energies
!
! Args:
!   e_mspdft: ndarray of len nroots
!     Final MS-PDFT energies
!
!   nroots: integer
!     Number of roots in the calculation
subroutine print_final_energies(e_mspdft,nroots)

  integer(kind=iwp), intent(in) :: nroots
  real(kind=wp), intent(in) :: e_mspdft(nroots)
  integer(kind=iwp) :: state

  do state=1,nroots
    call printresult(u6,'(6X,A,I3,A,F16.8)','MSPDFT root number',state,' Total energy:',e_mspdft(state),1)
  end do
  write(u6,*)

end subroutine print_final_energies

! Prints the final mspdft eigenvectors in the intermediate state
! basis and reference state basis
!
! Args:
!   si_pdft: ndarray of length nroots*nroots
!     Contains the orthonormal eigenvectors in the intermediate
!     state basis.
!
!   nroots: integer
!     number of roots (lroots) or dimension of u and eigenvectors
subroutine print_mspdft_vectors(si_pdft,nroots)

  integer(kind=iwp), intent(in) :: nroots
  real(kind=wp), intent(in) :: si_pdft(nroots,nroots)
  integer(kind=iwp) :: root
  real(kind=wp) :: eig_vecs_in_ref(nroots,nroots), reference_vectors(nroots,nroots)
  logical(kind=iwp) :: refbas
  character(len=30) :: mspdftfmt
  character(Len=18) :: MatInfo
  character(len=9) :: StatVec, VecStat(nroots)

  refbas = .false.

  do root=1,nroots
    write(statvec,'(A5,I4)') 'Root ',root
    vecstat(root) = statvec
  end do

  write(u6,*)

  write(u6,'(6X,A)') 'Intermediate-state Basis'
  write(mspdftfmt,'(A4,I5,A9)') '(6X,',nroots,'(A10,5X))'
  write(u6,mspdftfmt) ((VecStat(root)),root=1,nroots)
  call RecPrt(' ','(7X,10(F9.6,6X))',si_pdft,size(si_pdft,1),size(si_pdft,2))
  write(u6,*)

  call f_inquire('ROT_VEC',refbas)
  if (refbas) then
    ! Generate reference state basis
    eig_vecs_in_ref = Zero
    call readmat2('ROT_VEC',MatInfo,reference_vectors,nroots,nroots,7,18,'T')
    call dgemm_('n','n',nroots,nroots,nroots,One,reference_vectors,nroots,si_pdft,nroots,Zero,eig_vecs_in_ref,nroots)
    write(u6,'(6X,A)') 'Reference-state Basis'
    write(u6,mspdftfmt) ((VecStat(root)),root=1,nroots)
    call RecPrt(' ','(7X,10(F9.6,6X))',eig_vecs_in_ref,nroots,nroots)
    call PrintMat2('FIN_VEC',MatInfo,eig_vecs_in_ref,nroots,nroots,7,18,'T')
  end if

end subroutine print_mspdft_vectors

! Prints the effective Hamiltonian
!
! Args:
!   heff: ndarray of len nroots*nroots
!     Effective MS-PDFT Hamiltonian
!
!   nroots: integer
!     Dimension of heff, or number of roots
!
!   digit: integer
!     Threshold value to shift diagonal elements by when printed
subroutine print_effective_ham(heff,nroots,digit)

  use PrintLevel, only: SILENT
  use mcpdft_output, only: iPrLoc

  integer(kind=iwp), intent(in) :: nroots, digit
  real(kind=wp), intent(in) :: heff(nroots,nroots)
  integer(kind=iwp) :: root
  real(kind=wp) :: shift, shifted_heff(nroots,nroots)

  if (iPrLoc(1) == SILENT) return

  shifted_heff = heff

  call should_shift_diag(heff,nroots,digit,shift)

  if (shift /= Zero) then
    write(u6,'(6X,A,F9.2,A)') '(diagonal values increased by',-shift,' hartree)'
    do root=1,nroots
      shifted_heff(root,root) = shifted_heff(root,root)-shift
    end do
  end if

  call recprt(' ','(7X,10(F9.6,1X))',shifted_heff,nroots,nroots)
  write(u6,*)

end subroutine print_effective_ham

! Determines if diagonal elements should be shifted, and if so the number
! of decimal places to shift.
!
! Args:
!   heff: ndarray of len nroots*nroots
!     Effective MS-PDFT Hamiltonian
!
!   nroots: integer
!     Dimension of heff, or number of roots
!
!   digit: integer
!     Threshold value to shift diagonal elements by when printed
!
! Returns:
!   shift: real
!     Amount to shift diagonal elements by
subroutine should_shift_diag(heff,nroots,digit,shift)

  integer(kind=iwp), intent(in) :: nroots, digit
  real(kind=wp), intent(in) :: heff(nroots,nroots)
  real(kind=wp), intent(out) :: shift
  integer(kind=iwp) :: i, ishift
  real(kind=wp) :: maxelem, rdiag(nroots)

  shift = Zero

  do i=1,nroots
    rdiag(i) = heff(i,i)
  end do

  maxelem = maxval(rdiag)

  if (abs(maxelem) < real(digit,8)) return

  ishift = int(maxelem,8)/digit*digit
  shift = real(ishift,8)

end subroutine should_shift_diag

subroutine replace_diag(mat,diag,ndim)

  integer(kind=iwp), intent(in) :: ndim
  real(kind=wp), intent(inout) :: mat(ndim,ndim)
  real(kind=wp), intent(in) :: diag(ndim)
  integer(kind=iwp) :: i

  do i=1,ndim
    mat(i,i) = diag(i)
  end do

end subroutine replace_diag

end module mspdft_util

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_ReoQual(iQuAB,MxQ,nSym,iQScr,IDK,nK,nQ)
C
C     Purpose: reorder iQuAB array to IDK ordering.
C
      Implicit None
      Integer MxQ, nSym
      Integer iQuAB(MxQ,nSym)
      Integer iQScr(MxQ)
      Integer IDK(*)
      Integer nK(nSym)
      Integer nQ(nSym)

      Integer iSym, kID
      Integer iK, lK

      kID = 0
      Do iSym = 1,nSym
         If (nQ(iSym) .gt. 0) Then
            Call iCopy(nQ(iSym),iQuAB(1,iSym),1,iQScr,1)
            Do iK = 1,nK(iSym)
               lK = IDK(kID+iK)
               iQuAB(iK,iSym) = iQScr(lK)
            End Do
            kID = kID + nQ(iSym)
         Else
            Do iK = 1,nK(iSym)
               iQuAB(iK,iSym) = 0
            End Do
         End If
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_MaxAbsDiag_1C(Diag,iLoc,DGMax)
!
! Specialization for 1-Center approximation: only find max for
! 1-center diagonals.

use Cholesky, only: DiaMax, DiaMaxT, iAtomShl, iiBstR, iiBstRSh, IndRed, iSP2F, LuPri, nnBstRSh, nnShl, nSym
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*)
integer(kind=iwp), intent(in) :: iLoc
real(kind=wp), intent(out) :: DGMax
integer(kind=iwp) :: i, i1, i2, iShlA, iShlAB, iShlB, iSym
character(len=*), parameter :: SecNam = 'Cho_MaxAbsDiag_1C'

if (iLoc == 1) then
  do iSym=1,nSym
    DiaMax(iSym) = Zero
    do iShlAB=1,nnShl
      call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.true.)
      if (iAtomShl(iShlA) == iAtomShl(iShlB)) then
        i1 = iiBstR(iSym,1)+iiBstRSh(iSym,iShlAB,1)+1
        i2 = i1+nnBstRSh(iSym,iShlAB,1)-1
        do i=i1,i2
          DiaMax(iSym) = max(DiaMax(iSym),Diag(i))
        end do
      end if
    end do
    DiaMaxT(iSym) = DiaMax(iSym)
  end do
else if ((iLoc == 2) .or. (iLoc == 3)) then
  do iSym=1,nSym
    DiaMax(iSym) = Zero
    do iShlAB=1,nnShl
      call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.true.)
      if (iAtomShl(iShlA) == iAtomShl(iShlB)) then
        i1 = iiBstR(iSym,iLoc)+iiBstRSh(iSym,iShlAB,iLoc)+1
        i2 = i1+nnBstRSh(iSym,iShlAB,iLoc)-1
        do i=i1,i2
          DiaMax(iSym) = max(DiaMax(iSym),Diag(IndRed(i,iLoc)))
        end do
      end if
    end do
    DiaMaxT(iSym) = Zero
    do iShlAB=1,nnShl
      call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.true.)
      if (iAtomShl(iShlA) == iAtomShl(iShlB)) then
        i1 = iiBstR(iSym,1)+iiBstRSh(iSym,iShlAB,1)+1
        i2 = i1+nnBstRSh(iSym,iShlAB,1)-1
        do i=i1,i2
          DiaMaxT(iSym) = max(DiaMaxT(iSym),Diag(i))
        end do
      end if
    end do
  end do
else
  write(LuPri,*) SecNam,': unknown reduced set, iLoc = ',iLoc
  call Cho_Quit('Unknown reduced set in '//SecNam,104)
end if

DGMax = DiaMax(1)
do iSym=2,nSym
  DGMax = max(DGMax,DiaMax(iSym))
end do

#ifdef _DEBUGPRINT_
write(LuPri,*) SecNam,': in reduced set ',iLoc,':'
write(LuPri,*) 'DiaMax  = ',(DiaMax(iSym),iSym=1,nSym)
write(LuPri,*) 'DiaMaxT = ',(DiaMaxT(iSym),iSym=1,nSym)
write(LuPri,*) 'DGMax   = ',DGMax
#endif

end subroutine Cho_MaxAbsDiag_1C

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Chen Zhou                                        *
************************************************************************
      subroutine writejobms(iadr19,L1,L2)

#ifdef _HDF5_
      use mh5, only: mh5_open_file_rw, mh5_open_dset,
     &               mh5_put_dset, mh5_close_file, mh5_fetch_attr,
     &               mh5_fetch_dset
#endif

      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "wadr.fh"
#include "rasdim.fh"
#include "warnings.h"
#include "rasscf.fh"
#include "rasrc.fh"
#include "general.fh"
#include "wjob.fh"
      real*8 :: U(lroots,lroots)
      real*8, allocatable :: tCI(:)
      integer :: i,j,idisk,LCIRot,LEnergy,L1,L2
      integer :: iadr19(15),dum(1)
#ifdef _HDF5_
      integer :: refwfn_id,wfn_energy,wfn_cicoef
#endif


      !> step 1: save energies
      !> ---------------------

      CALL GETMEM('Energy','ALLO','REAL',LEnergy,mxRoot*mxIter)
      call dcopy_(mxRoot*mxIter,[0.0d0],0,Work(LEnergy),1)
      Do i = 1,mxIter
        Do j = 1,lroots
          work(LEnergy+mxRoot*(i-1)+j-1)=work(L1+j-1)
        End do
      End do

      if(.not.hasHDF5ref)then
        iDisk = IADR19(6)
        Call DDafile(JOBIPH,1,Work(LEnergy),mxRoot*mxIter,iDisk)
#ifdef _HDF5_
      else
        if(hasMPSref)then
            refwfn_id = mh5_open_file_rw(StartOrbFile)
        else
            refwfn_id = mh5_open_file_rw('RASWFN')
        end if
        wfn_energy = mh5_open_dset(refwfn_id,'ROOT_ENERGIES')
        call mh5_put_dset(wfn_energy,work(L1))
#endif
      end if
      CALL GETMEM('Energy','FREE','REAL',LEnergy,mxRoot*mxIter)

      !> step 2: save (rotated) CI vectors
      !> ---------------------------------

      if(.not.hasHDF5ref)then
        idisk = 284
        Call iDafile(JOBIPH,2,dum,1,iDisk)
        ncon=dum(1)
#ifdef _HDF5_
      else
        call mh5_fetch_attr (refwfn_id,'NCONF',  ncon)
#endif
      end if

      Do i = 1,lroots
       Do j = 1,lroots
        U(j,i) = work(L2+(i-1)*lroots+j-1)
       End do
      End do

      CALL GETMEM('CIRot','ALLO','REAL',LCIRot,NCON*LROOTS)
      call dcopy_(NCON*LROOTS,[0.0d0],0,Work(LCIRot),1)

      call mma_allocate(tCI, ncon)

      if(.not.hasHDF5ref) iDisk = IADR19(4)

      DO I=1,LROOTS
        if(.not.hasHDF5ref)then
          Call DDafile(JOBIPH,2,tCI,nCon,iDisk)
#ifdef _HDF5_
        else
          call mh5_fetch_dset(refwfn_id,
     &          'CI_VECTORS',tCI,[NCON,1],[0,i-1])
#endif
        end if

        DO J=1,LROOTS
          DO K=1,NCON
            ITMP=LCIRot+(J-1)*NCON+K-1
            WORK(ITMP)=WORK(ITMP)+tCI(K)*U(I,J)
          END DO ! k loop
        END DO ! j loop

      END DO ! i loop

      if(.not.hasHDF5ref)then
        iDisk = IADR19(4)

        DO I=1,LROOTS
          Call DDafile(JOBIPH,1,Work(LCIRot+(I-1)*NCON),nCon,iDisk)
        END DO
#ifdef _HDF5_
      else
        wfn_cicoef = mh5_open_dset(refwfn_id,'CI_VECTORS')
        Do I = 1,LROOTS
            call mh5_put_dset(wfn_cicoef,
     &      Work(LCIRot+NCON*(I-1):LCIRot+NCON*I-1),[NCON,1],[0,i-1])
        END DO
        call mh5_close_file(refwfn_id)
#endif
      end if

      CALL GETMEM('CIRot','FREE','REAL',LCIRot,NCON*LROOTS)
      call mma_deallocate(tCI)

      End

      subroutine writejob(iadr19)

#ifdef _HDF5_
      use mh5, only: mh5_open_file_rw, mh5_open_dset,
     &               mh5_put_dset, mh5_close_file
#endif

      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "wadr.fh"
#include "rasdim.fh"
#include "warnings.h"
#include "rasscf.fh"
#include "rasrc.fh"
#include "general.fh"
#include "wjob.fh"
      integer :: i,j,idisk,LEnergy
      integer :: iadr19(15)
#ifdef _HDF5_
      integer :: refwfn_id,wfn_energy
#endif

      !> step 1: save energies
      !> ---------------------

      CALL GETMEM('Energy','ALLO','REAL',LEnergy,mxRoot*mxIter)
      call dcopy_(mxRoot*mxIter,[0.0d0],0,Work(LEnergy),1)
      Do i = 1,mxIter
       Do j = 1,lroots
         work(LEnergy+mxRoot*(i-1)+j-1)=ener(j,1)
       End do
      End do

      if(.not.hasHDF5ref)then
        iDisk = IADR19(6)
        Call DDafile(JOBIPH,1,Work(LEnergy),mxRoot*mxIter,iDisk)
#ifdef _HDF5_
      else
        if(hasMPSref)then
            refwfn_id = mh5_open_file_rw(StartOrbFile)
        else
            refwfn_id = mh5_open_file_rw('RASWFN')
        end if
        wfn_energy = mh5_open_dset(refwfn_id,'ROOT_ENERGIES')
        !write(6,*) 'BLA 5 wfn_energy == ',ener(1:lroots,1)
        call mh5_put_dset(wfn_energy,ener(1,1))
        call mh5_close_file(refwfn_id)
#endif
      end if
      CALL GETMEM('Energy','FREE','REAL',LEnergy,mxRoot*mxIter)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007,2008, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine ChoMP2_VectorMO2AO(iTyp,Delete,BaseName_AO,CMO,DoDiag,Diag,lDiag,lU_AO,irc)
!
! Thomas Bondo Pedersen, Dec. 2007 - Jan. 2008.
!
! Purpose: backtransform vectors from MO to AO basis.
!
! Input:
!    iTyp......... specifies type of vectors (iTyp is used to open
!                  MO vector files through ChoMP2_OpenF()).
!    Delete....... Flag specifiyng whether MO vector files are to
!                  be deleted before exiting this routine.
!    BaseName_AO.. Base name (3 characters) for the files containing
!                  AO vectors. Symmetry index will be appended!
!    CMO.......... MO coefficient array
!    DoDiag....... if .True., calculate AO diagonal elements as
!                  D(ab) = sum_J L(J,ab)*L(J,ab)
! Output:
!    Diag......... Contains the diagonal if requested (flag DoDiag).
!    lDiag........ Dimension of Diag
!    lU_AO........ Array containing units of open AO vector files.
!    irc.......... return code.
!                  = 0 if successful, non-zero otherwise
!                  (must be checked by caller).
!
!***********************************************************************
!!!!!!!!!!!!!!!!!!!!!!!!!! IMPORTANT !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!***********************************************************************
!*** CHOLESKY INFORMATION MUST BE INITIALIZED WHEN CALLING THIS ROUTINE.
!    --> I.e. Cho_X_Init() must have been called.
!    --> It is actually sufficient that nBas + nSym in
!        cholesky are available (which they are when Cho_X_Init()
!        has been called).
!*** CHOLESKY MP2 INFORMATION MUST BE INITIALIZED WHEN CALLING THIS
!    ROUTINE.
!    --> I.e. ChoMP2_Setup() must have been called.
!*** AO VECTORS ARE STORED IN LOWER TRIANGULAR [M(I,J), I >= J] FORMAT.
!    --> I.e. vectors are stored as L(J,ab) where a>=b
!*** DIAGONAL IS STORED IN LOWER TRIANGULAR FORMAT.
!    --> I.e. diagonal is stored as D(ab) where a>=b (same as vectors).
!***********************************************************************
!!!!!!!!!!!!!!!!!!!!!!!!!! IMPORTANT !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!***********************************************************************

use Symmetry_Info, only: Mul
use Cholesky, only: nBas, nSym
use ChoMP2, only: nAOVir, nT1AOT
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iTyp, lDiag
logical(kind=iwp), intent(in) :: Delete, DoDiag
character(len=3), intent(in) :: BaseName_AO
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(out) :: Diag(lDiag)
integer(kind=iwp), intent(_OUT_) :: lU_AO(*)
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: iClose, iCount, iOpen, iSym, iSyma, iSymb
character(len=4) :: FullName_AO
real(kind=wp), allocatable :: COcc(:), CVir(:)
character(len=*), parameter :: SecNam = 'ChoMP2_VectorMO2AO'

! Initializations.
! ----------------

irc = 0
lU_AO(1:nSym) = -999999
if (DoDiag) then
  iCount = 0
  do iSym=1,nSym
    do iSymb=1,nSym
      iSyma = Mul(iSymb,iSym)
      iCount = iCount+nBas(iSyma)*nBas(iSymb)
    end do
  end do
  if (iCount /= lDiag) then
    write(u6,*) SecNam,': WARNING: inconsistent diagonal allocation!'
    if (iCount > lDiag) then
      write(u6,*) '   - insufficient memory, will return now...'
      irc = 1
      return
    else
      write(u6,*) '   - sufficient memory, going to continue...'
    end if
  end if
end if

! Reorder CMO. This also removes frozen orbitals.
! -----------------------------------------------

call mma_allocate(COcc,nT1AOT(1),Label='COcc')
call mma_allocate(CVir,nAOVir(1),Label='CVir')
call ChoMP2_MOReOrd(CMO,COcc,CVir)

! Backtransform.
! --------------

call ChoMP2_BackTra(iTyp,COcc,CVir,BaseName_AO,DoDiag,Diag)

! Open AO vector files (i.e. get units to return).
! ------------------------------------------------

do iSym=1,nSym
  write(FullName_AO,'(A3,I1)') BaseName_AO,iSym
  lU_AO(iSym) = 7
  call daName_MF_WA(lU_AO(iSym),FullName_AO)
end do

#ifdef _DEBUGPRINT_
! Debug: check backtransformation.
! --------------------------------

call ChoMP2_CheckBackTra(iTyp,COcc,CVir,lU_AO)
#endif

! Delete MO files if requested.
! -----------------------------

if (Delete) then
  iOpen = 1
  iClose = 3
  do iSym=1,nSym
    call ChoMP2_OpenF(iOpen,iTyp,iSym)
    call ChoMP2_OpenF(iClose,iTyp,iSym)
  end do
end if

! Deallocate and exit.
! --------------------

call mma_deallocate(CVir)
call mma_deallocate(COcc)

end subroutine ChoMP2_VectorMO2AO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
*               2010, Grigory A. Shamov                                *
*               2017, Giovanni Li Manni                                *
*               2017, Aron Cohen                                       *
************************************************************************
      Subroutine xSSBSW(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object:  SSB-sw exchange functional by Swart, Sola and Bickelhaupt   *
*           this is the first one, "switching between OPTX and PBE"    *
*          derived with Maxima                                         *
*                                                                      *
*      Author: G. Li Manni & A. Cohen, Max Planck Institute Stuttgart  *
*              Summer 2017, edited in Cambridge (UK) & Palermo (Sicily)*
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)

* IDORD=Order of derivatives to request from XPBE:
      idord=1
*
      Rho_Min=T_X*1.0D-2
*
      if (ispin.eq.1) then
* ispin=1 means spin zero.

* T_X: Screening threshold of total density.
        Ta=0.5D0*T_X
        do iGrid=1,mgrid
         rhoa=rho(ipR,iGrid)
         if(rhoa.lt.Ta) goto 110
         grdrhoa_x=rho(ipdRx,iGrid)
         grdrhoa_y=rho(ipdRy,iGrid)
         grdrhoa_z=rho(ipdRz,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2

         call xSSBSW_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*(2.0D0*Fa)
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*dFdrhoa
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*dFdgammaaa
* Note: For xpbe, dFdgammaab is zero.
 110     continue
        end do

      else
* ispin .ne. 1, use both alpha and beta components.

        do iGrid=1,mgrid
         rhoa=Max(Rho_Min,rho(ipRa,iGrid))
         rhob=Max(Rho_Min,rho(ipRb,iGrid))
         rho_tot=rhoa+rhob
         if(rho_tot.lt.T_X) goto 210
         grdrhoa_x=rho(ipdRxa,iGrid)
         grdrhoa_y=rho(ipdRya,iGrid)
         grdrhoa_z=rho(ipdRza,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         call xSSBSW_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)

         grdrhob_x=rho(ipdRxb,iGrid)
         grdrhob_y=rho(ipdRyb,iGrid)
         grdrhob_z=rho(ipdRzb,iGrid)
         sigmabb=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
         call xSSBSW_(idord,rhob,sigmabb,Fb,dFdrhob,dFdgammabb,
     &          d2Fdrb2,d2Fdrbdgbb,d2Fdgbb2)

         F_xc(iGrid)=F_xc(iGrid)+Coeff*(Fa+Fb)
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+Coeff*dFdrhoa
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+Coeff*dFdrhob
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
* Note: For xpbe, dFdgammaab is zero.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*dFdgammaaa
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*dFdgammabb
 210     continue
        end do

      end if

      Return
      End

      subroutine XSSBSW_(idord,rho_s,gamma_s,F,dFdr,dFdg,
     & d2Fdr2,  d2Fdrdg, d2Fdg2)
      implicit none

      integer idord
      real*8 rho_s,gamma_s,F,dFdr,dFdg
      real*8  d2Fdr2,  d2Fdrdg, d2Fdg2
      real*8 rho, gamma, pi
      parameter(pi=3.14159265358979d0)

      real*8 T1, T2, T3, T4, T5, T6, T7,  T8,  T9,  T10
      real*8 T11, T12, T13, T14, T15, T16,  T17, T18
      real*8 T19, T20, T21, T22, T23

      rho=rho_s+1.0D-16
      gamma=gamma_s+1.0D-16


      T1=rho**(4.d+0/3.d+0)
      T2=1/rho**(8.d+0/3.d+0)
      T3=4.1867733411865504d-3*T2*gamma+1.d+0
      T4=1/T3
      T5=1/rho**(1.6d+1/3.d+0)
      T6=gamma**2
      T7=1.0930391066596375d-3*T5*T6+1.d+0
      T8=1/T7
      T9=-2.973605770238684d-3*T2*gamma*T8+3.150500329583
     5   405d-3*T2*gamma*T4+1.05151d+0
      T10=1/rho**(1.9d+1/3.d+0)
      T11=1/T3**2
      T12=1/rho**(1.1000000000000001d+1/3.d+0)
      T13=1/rho**9
      T14= gamma**3
      T15=1/T7**2
      T16=7.929615387303156d-3*T12*gamma*T8-1.73
     8   347594381847d-5*T13*T14*T15-8.401334212222413d-3*T12*gamma*T4+3
     9   .5174482110131294d-5*T10*T6*T11
      T17=rho**(1.d+0/3.d+0)
      T18=1/rho**8
      T19=-2.973605770238684d-3*T2*T8+6.500534789319262d-6*T18*T
     ;   6*T15+3.150500329583405d-3*T2*T4-1.3190430791299237d-5*T5*gamma
     <   *T11
      T20=1/rho**10
      T21=1/T3**3
      T22=1/rho**(1.3999999999999999d+ 1/3.d+0)
      T23=1/T7**3

      F = -9.305257363491001d-1*T1*T9

C dont forget to take sqrt of gamma

      if(idord.lt.1) goto 99

      dFdr = -1
     >   .2407009817988002d+0*T17*T9-9.305257363491001d-1*T1*T16

      dFdg =
     ?   -9.305257363491001d-1*T1*T19

      if(idord.lt.2) goto 99

      d2Fdr2 = -4.135669939329333d-1*T9/
     @   rho**(2.d+0/3.d+0)-2.4814019635976003d+0*T17*T16-9.305257363491
     1   001d-1*T1*(-2.907525642011157d-2*T22*gamma*T8+2.022388601121548
     2   3d-4*T20*T14*T15-2.0210741301837976d-7*gamma**5*T23/rho**(4.599
     3   9999999999996d+1/3.d+0)+3.080489211148218d-2*T22*gamma*T4-3.165
     4   7033899118164d-4*T6*T11/rho**(2.2000000000000003d+1/3.d+0)+7.85
     5   4271146066177d-7*T20*T14*T21)

      d2Fdrdg = -1.2407009817988002d+0*
     6   T17*T19-9.305257363491001d-1*T1*(7.929615387303156d-3*T12*T8-6.
     7   93390377527388d-5*T13*T6*T15+7.579027988189241d-8*gamma**4*T23/
     8   rho**(4.3d+1/3.d+0)-8.401334212222413d-3*T12*T4+1.0552344633039
     9   39d-4*T10*gamma*T11-2.9453516797748164d-7*T13*T6*T21)

      d2Fdg2 =
     =   -9.305257363491001d-1*T1*(1.9501604367957787d-5*T18*gamma*T15-2
     ;   .842135495570965d-8*T14*T23/rho**(4.d+1/3.d+0)-2.63808615825984
     <   75d-5*T5*T11+1.1045068799155562d-7*T18*gamma*T21)

 99   continue

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_AllocateAuxBasVector(Label,ip_V)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Allocate an auxiliary basis vector,
C              such as the vector V(J)=sum_uv C(uv,J)*D(uv) used for
C              computing the Coulomb contribution to the Fock matrix).
C              On exit, ip_V points to pointers in iWork such that
C
C              ip=iWork(ip_V-1+iAtom)
C
C              is the pointer (in array Work) to the vector block for
C              atom iAtom. Two-center functions are placed at the end
C              such that
C
C              ip=iWork(ip_V-1+nAtom+iAtomPair)
C
C              is the pointer (in array Work) to the vector block for
C              atom pair iAtomPair.
C
C              Deallocation is done by calling subroutine
C              LDF_DeallocateBlockVector(Label,ip_V).
C
C              Label is used to label the allocation in GetMem.
C              (Any three-character string is accepted.)
C
      Implicit None
      Character*3 Label
      Integer ip_V
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nAtom, LDF_nBasAux_Atom
      External LDF_nAtom, LDF_nBasAux_Atom

      Integer l
      Integer ip0
      Integer iAtom, nAtom
      Integer ip
      Integer iAtomPair

      Character*8 myLabel

      Integer i, j
      Integer AP_2CFunctions
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Get number of atoms
      nAtom=LDF_nAtom()

      ! Allocate pointer array
      Write(myLabel,'(A3,A5)') Label,'Blk_P'
      l=nAtom+NumberOfAtomPairs
      Call GetMem(myLabel,'Allo','Inte',ip_V,l)

      ! Set pointers relative to 0 (i.e. offsets)
      l=0
      ip0=ip_V-1
      Do iAtom=1,nAtom
         iWork(ip0+iAtom)=l
         l=l+LDF_nBasAux_Atom(iAtom)
      End Do
      ip0=ip0+nAtom
      Do iAtomPair=1,NumberOfAtomPairs
         iWork(ip0+iAtomPair)=l
         l=l+AP_2CFunctions(1,iAtomPair)
      End Do

      ! Allocate matrix blocks
      Write(myLabel,'(A3,A5)') Label,'Block'
      Call GetMem(myLabel,'Allo','Real',ip,l)

      ! Shift pointers so that they become relative to allocated memory
      ip0=ip_V-1
      Do i=1,nAtom+NumberOfAtomPairs
         iWork(ip0+i)=iWork(ip0+i)+ip
      End Do

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_DeallocateAuxBasVector(Label,ip_V)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Deallocate aux bas vector (see LDF_AllocateAuxBasVector).
C
      Implicit None
      Character*3 Label
      Integer ip_V
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nAtom, LDF_nBasAux_Atom
      External LDF_nAtom, LDF_nBasAux_Atom

      Integer l
      Integer iAtom, nAtom
      Integer ip
      Integer iAtomPair

      Character*8 myLabel

      Integer i, j
      Integer AP_2CFunctions
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Get number of atoms
      nAtom=LDF_nAtom()

      ! Get total length of block matrix
      l=0
      Do iAtom=1,nAtom
         l=l+LDF_nBasAux_Atom(iAtom)
      End Do
      Do iAtomPair=1,NumberOfAtomPairs
         l=l+AP_2CFunctions(1,iAtomPair)
      End Do

      ! Deallocate matrix blocks
      Write(myLabel,'(A3,A5)') Label,'Block'
      ip=iWork(ip_V)
      Call GetMem(myLabel,'Free','Real',ip,l)

      ! Deallocate pointer array
      Write(myLabel,'(A3,A5)') Label,'Blk_P'
      l=nAtom+NumberOfAtomPairs
      Call GetMem(myLabel,'Free','Inte',ip_V,l)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine Get_Int_Open(iSymp,iSymq,iSymr,iSyms)

use GetInt_mod, only: LuCVec, pq1
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iSymp, iSymq, iSymr, iSyms
character(len=6) :: Fname
character(len=*), parameter :: BaseNm = 'CHFV'

! Open files.
LuCVec(1) = 7
write(Fname,'(A4,I1,I1)') BaseNm,iSymp,iSymq
call DANAME_MF_WA(LuCVec(1),Fname)
if (iSymp /= iSymr) then
  LuCVec(2) = 7
  write(Fname,'(A4,I1,I1)') BaseNm,iSymr,iSyms
  call DANAME_MF_WA(LuCVec(2),Fname)
else
  LuCVec(2) = -1
end if

pq1=1

end subroutine Get_Int_Open

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      SubRoutine Dihedr(Lbls,xyz,mCentr,rtrnc,Max_Center)
************************************************************************
*                                                                      *
* Object: to compute dihedral angles from a list of coordinates.       *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "Molcas.fh"
      Real*8 xyz(3,mCentr), Bt(3,4), Coor(3,4)
      Character*(LENIN) Lbls(mCentr)
      Character*8 Label
      Logical Type
      Dimension Dummy(1)
*
      Lu=6
      iRout = 127
      iPrint = nPrint(iRout)
      Label=' '
      If (mCentr.gt.Max_Center) Go To 99
*
      Thr = 1.0D-12
      Type = .False.
      Do 452 ic = 1, mCentr
         x2 = xyz(1,ic)
         y2 = xyz(2,ic)
         z2 = xyz(3,ic)
         call dcopy_(3,xyz(1,ic),1,Coor(1,2),1)
         Do 453 jc = 1, mCentr
            If (jc.eq.ic) Go To 453
            x3 = xyz(1,jc)
            y3 = xyz(2,jc)
            z3 = xyz(3,jc)
            r2 = Sqrt((x3-x2)**2+(y3-y2)**2+(z3-z2)**2)
            If (r2.gt.rtrnc.or.r2.eq.Zero) Go To 453
*           Write (Lu,*)
            call dcopy_(3,xyz(1,jc),1,Coor(1,3),1)
            Do 454 kc = 1, mCentr
               If (kc.eq.ic) Go To 454
               If (kc.eq.jc) Go To 454
               x1 = xyz(1,kc)
               y1 = xyz(2,kc)
               z1 = xyz(3,kc)
               r1 = Sqrt((x2-x1)**2+(y2-y1)**2+(z2-z1)**2)
               If (r1.gt.rtrnc.or.r1.eq.Zero) Go To 454
               arg=  ((x1-x2)*(x3-x2)+(y1-y2)*(y3-y2)+
     &                   (z1-z2)*(z3-z2))/(r1*r2)
               If (abs(arg).gt.One) arg=sign(One,arg)
               If (One-abs(arg).lt.Thr) Go To 454
               Phi1= 180.D0 * ACos(arg) / Pi
               x12 = (y2-y1)*(z3-z2)-(y3-y2)*(z2-z1)
               y12 = (z2-z1)*(x3-x2)-(z3-z2)*(x2-x1)
               z12 = (x2-x1)*(y3-y2)-(x3-x2)*(y2-y1)
               r12 = Sqrt(x12**2+y12**2+z12**2)
               If (r12.eq.Zero) Go To 454
               call dcopy_(3,xyz(1,kc),1,Coor(1,1),1)
               Do 455 lc = kc+1, mCentr
                  If (lc.eq.ic) Go To 455
                  If (lc.eq.jc) Go To 455
                  If (lc.eq.kc) Go To 455
                  x4 = xyz(1,lc)
                  y4 = xyz(2,lc)
                  z4 = xyz(3,lc)
                  r3 = Sqrt((x4-x3)**2+(y4-y3)**2+(z4-z3)**2)
                  If (r3.gt.rtrnc.or.r3.eq.Zero) Go To 455
                  arg=  ((x2-x3)*(x4-x3)+(y2-y3)*(y4-y3)+
     &                      (z2-z3)*(z4-z3))/(r2*r3)
                  If (abs(arg).gt.One) arg=sign(One,arg)
                  If (One-abs(arg).lt.Thr) Go To 455
                  Phi2= 180.D0 * ACos(arg) / Pi
                  x23 = (y3-y2)*(z4-z3)-(y4-y3)*(z3-z2)
                  y23 = (z3-z2)*(x4-x3)-(z4-z3)*(x3-x2)
                  z23 = (x3-x2)*(y4-y3)-(x4-x3)*(y3-y2)
                  r23 = Sqrt(x23**2+y23**2+z23**2)
                  If (r23.eq.Zero) Go To 455
                  call dcopy_(3,xyz(1,lc),1,Coor(1,4),1)
C                 arg=  (x12*x23+y12*y23+z12*z23)/
C    &                                     (r12*r23)
C                 If (abs(arg).gt.One) arg=sign(One,arg)
C                 Phi12= 180.D0 * ACos(arg) / Pi
                  Call Trsn(Coor,4,Tau,Bt,.False.,.False.,Label,
     &                      Dummy,.False.)
                  Phi12 = 180.0D+00*Tau/Pi
                  If (.Not.Type) Then
                     Type = .True.
                     Write (Lu,*)
                     Write (Lu,'(10X,A)')
     &' ***************************************************************'
                     Write (Lu,'(10X,A)')
     &' *              Valence Dihedral Angles / Degree               *'
                     Write (Lu,'(10X,A)')
     &' ***************************************************************'
                     Write (Lu,'(7X,A,A)')
     &                     '             Atom centers       ',
     &                     '                Phi1     Phi2     Theta '
                  End If
                  Write (Lu,'(10X,4(I2,1X,A,2X),1X,3(F7.2,2X))')
     &                  kc,Lbls(kc),
     &                  ic,Lbls(ic),
     &                  jc,Lbls(jc),
     &                  lc,Lbls(lc),
     &               Phi1, Phi2, Phi12
 455           Continue
 454         Continue
 453      Continue
 452   Continue
*
 99   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine iTrnsps(n,m,a,b)
! Thomas Bondo Pedersen, August 2012: integer version of trnsps

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n, m, a(n,m)
integer(kind=iwp), intent(out) :: b(m,n)
integer(kind=iwp) :: i

do i=1,n
  b(1:m,i) = a(i,1:m)
end do

return

end subroutine iTrnsps

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AixCheck()

use Fast_IO, only: CtlBlk, FCtlBlk, MxFile, pStat
use Definitions, only: iwp, u6, u5

implicit none
integer(kind=iwp) :: n
logical(kind=iwp) :: is_open
character(len=256) :: filename

!----------------------------------------------------------------------*
! Check if slot in table is available, it should NOT!                  *
!----------------------------------------------------------------------*
do n=1,MxFile
  if (CtlBlk(pStat,n) /= 0) then
    call SysWarnMsg('AixCheck','Active unit: '//FCtlBlk(n),', should have been closed!')
#   ifndef _DEVEL_
    call Abend()
#   endif
  end if
  inquire(unit=n,opened=is_open)
  if (is_open) then
    if ((n /= u6) .and. (n /= u5)) then
      inquire(unit=n,name=filename)
      write(u6,*) 'Fortran file:',n,'(',trim(filename),')  is still open!'
#     ifndef _DEVEL_
      call Abend()
#     endif
    end if
  end if
end do

return

end subroutine AixCheck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine gauleg(x1,x2,xw,n)
      Implicit None
#include "real.fh"
      Integer n
      Real*8 x1,x2,xw(2,n)
      Real*8 EPS
      Parameter(EPS=3.d-14)
      Integer i, j, m
      Real*8 p1, p2, p3, pp, xl, xm, z, z1
*
      m=(n+1)/2
      xm=Half*(x2+x1)
      xl=Half*(x2-x1)
c     Write (*,*) 'm=',m
      Do i = 1, m
         z=Cos(Pi*(DBLE(i)-0.25D0)/(DBLE(n)+Half))
 1       Continue
            p1=One
            p2=Zero
            Do j = 1, n
               p3=p2
               p2=p1
               p1=((Two*DBLE(j)-One)*z*p2-(DBLE(j)-One)*p3)/DBLE(j)
            End Do
            pp=DBLE(n)*(z*p1-p2)/(z*z-One)
            z1=z
            z=z1-p1/pp
            If (Abs(z-z1).gt.EPS) Go To 1
         xw(1,i    )=xm-xl*z
         xw(1,n+1-i)=xm+xl*z
         xw(2,i    )=Two*xl/((One-z*z)*pp*pp)
         xw(2,n+1-i)=xw(2,i)
         If (Abs(xw(1,i    )).lt.EPS) xw(1,i    )=Zero
         If (Abs(xw(1,n+1-i)).lt.EPS) xw(1,n+1-i)=Zero
         If (Abs(xw(2,i    )).lt.EPS) xw(1,i    )=Zero
         If (Abs(xw(2,n+1-i)).lt.EPS) xw(1,n+1-i)=Zero
      End Do
*
      Return
      End
      Subroutine gauleg_(x1,x2,xw,n)
      Implicit None
#include "real.fh"
      Integer n
      Real*8 x1,x2,xw(3,n)
      Real*8 EPS
      Parameter(EPS=3.d-14)
      Integer i, j, m
      Real*8 p1, p2, p3, pp, xl, xm, z, z1
*
      m=(n+1)/2
      xm=Half*(x2+x1)
      xl=Half*(x2-x1)
c     Write (*,*) 'm=',m
      Do i = 1, m
         z=Cos(Pi*(DBLE(i)-0.25D0)/(DBLE(n)+Half))
 1       Continue
            p1=One
            p2=Zero
            Do j = 1, n
               p3=p2
               p2=p1
               p1=((Two*DBLE(j)-One)*z*p2-(DBLE(j)-One)*p3)/DBLE(j)
            End Do
            pp=DBLE(n)*(z*p1-p2)/(z*z-One)
            z1=z
            z=z1-p1/pp
            If (Abs(z-z1).gt.EPS) Go To 1
         xw(1,i    )=xm-xl*z
         xw(1,n+1-i)=xm+xl*z
         xw(2,i    )=Two*xl/((One-z*z)*pp*pp)
         xw(2,n+1-i)=xw(2,i)
         If (Abs(xw(1,i    )).lt.EPS) xw(1,i    )=Zero
         If (Abs(xw(1,n+1-i)).lt.EPS) xw(1,n+1-i)=Zero
         If (Abs(xw(2,i    )).lt.EPS) xw(1,i    )=Zero
         If (Abs(xw(2,n+1-i)).lt.EPS) xw(1,n+1-i)=Zero
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SOSctt(SOInt,iBas,jBas,nSOInt,PrpInt,nPrp,lOper,iCmp,jCmp,iShell,jShell,iAO,jAO,rHrmt)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January '91                                              *
!***********************************************************************

use Index_Functions, only: iTri
use SOAO_Info, only: iAOtSO
use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iBas, jBas, nSOInt, nPrp, lOper, iCmp, jCmp, iShell, jShell, iAO, jAO
real(kind=wp) , intent(in):: SOInt(iBas*jBas,nSOInt), rHrmt
real(kind=wp) , intent(inout):: PrpInt(nPrp)
integer(kind=iwp) :: i1, i2, indAO1, indAO2, Indi, Indj, ip, iPnt, iSO1, iSO2, j1, j12, j2, jBsMax, jjMx, lSO, nRow
integer(kind=iwp), external :: iPntSO

#ifdef _DEBUGPRINT_
call RecPrt(' In SOSctt:SOInt',' ',SOInt,iBas*jBas,nSOInt)
call RecPrt(' In SOSctt:PrpInt',' ',PrpInt,1,nPrp)
#endif

lSO = 0
do j1=0,nIrrep-1
  do i1=1,iCmp
    if (iAOtSO(iAO+i1,j1) < 0) cycle

    ! Scatter the SO's onto lower rectangular blocks and triangular
    ! diagonal blocks.

    do j2=0,nIrrep-1
      j12 = ieor(j1,j2)
      if (.not. btest(lOper,j12)) cycle
      jjMx = jCmp
      if ((iShell == jShell) .and. (j1 == j2)) jjMx = i1
      do i2=1,jjMx
        if (iAOtSO(jAO+i2,j2) < 0) cycle
        lSO = lSO+1
        iSO1 = iAOtSO(iAO+i1,j1)
        iSO2 = iAOtSO(jAO+i2,j2)
        !write(u6,*) iSO1,iAO,i1,j1,iSO2,jAO,i2,j2

        iPnt = iPntSO(max(j1,j2),min(j1,j2),lOper,nbas)
        do indAO1=0,iBas-1
          ! Diagonal block. Store only unique elements
          jBsMax = jBas-1
          if ((j1 == j2) .and. (iSO1 == iSO2)) jBsMax = indAO1
          do indAO2=0,jBsMax
            ip = indAO2*iBas+indAO1+1

            ! Move one-electron integral.

            if (j1 == j2) then
              ! Diagonal symmetry block
              Indi = iSO1+indAO1
              Indj = iSO2+indAO2
              PrpInt(iPnt+iTri(Indi,Indj)) = SOInt(ip,lSO)
            else
              ! Off-diagonal symmetry block j1>j2
              if (j1 > j2) then
                Indi = iSO1+indAO1
                Indj = iSO2+indAO2
                nRow = nBas(j1)
                PrpInt(iPnt+nRow*(Indj-1)+Indi) = SOInt(ip,lSO)
              else
                Indj = iSO1+indAO1
                Indi = iSO2+indAO2
                nRow = nBas(j2)
                PrpInt(iPnt+nRow*(Indj-1)+Indi) = rHrmt*SOInt(ip,lSO)
              end if
            end if

          end do
        end do

      end do
    end do

  end do
end do

return

end subroutine SOSctt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _MOLCAS_MPP_

module GA_Wrapper

implicit none
private

! This module offers a wrapper around the GlobalArrays include files.
! Other routines should use this module instead of the include files.

#include "global.fh"
#include "mafdecls.fh"

! External procedures should forgo TKR checks
external :: GA_Brdcst

public :: DBL_MB, MT_BYTE, MT_DBL, MT_INT
public :: GA_Brdcst, GA_Create, GA_Create_Irreg, GA_DDot, GA_Destroy, GA_Duplicate, GA_NNodes, GA_NodeId, GA_Read_Inc

end module GA_Wrapper

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(GA_Wrapper)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Bjorn O. Roos                                    *
!               1989, Per Ake Malmqvist                                *
!               1991, Jeppe Olsen                                      *
!               1991,1996, Markus P. Fuelscher                         *
!               2000, Thorstein Thorsteinsson                          *
!***********************************************************************

subroutine DavCtl(LW1,TUVX,IFINAL)
!***********************************************************************
!                                                                      *
!     CI control section                                               *
!                                                                      *
!     calling arguments:                                               *
!     LW1     : active Fock matrix                                     *
!               array of real*8                                        *
!     TUVX    : array of real*8                                        *
!               two-electron integrals (tu|vx)                         *
!     IFINAL  : integer                                                *
!               termination flag                                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     B.O. Roos and P.Aa. Malmqvist                                    *
!     University of Lund, Sweden, 1989                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     - updated to use determinant based CI-procedures                 *
!       J. Olsen and M.P. Fuelscher, University of Lund, Sweden, 1991  *
!     - updated for MOLCAS version 3                                   *
!       J. Olsen and M.P. Fuelscher, University of Lund, Sweden, 1991  *
!     - updated for integral direct and reaction field calculations    *
!       M.P. Fuelscher, University of Lund, Sweden, 1996               *
!     - various modifications                                          *
!       T. Thorsteinsson, University of Lund, Sweden, 2000             *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Quart
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: LW1(*), TUVX(*)
integer(kind=iwp), intent(in) :: IFINAL
integer(kind=iwp) :: iDisk, ItLimit, jRoot, m_Sel, mSel, nMaxSel
real(kind=wp) :: ESize, Threshold, ThrRule
integer(kind=iwp), allocatable :: iSel(:)
real(kind=wp), allocatable :: CI_conv(:,:,:), CIVEC(:), ExplE(:), ExplV(:,:)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "ciinfo.fh"
#include "lucia_ini.fh"

!-----------------------------------------------------------------------
! INITIALIZE THE DAVIDSON DIAGONALIZATION
!-----------------------------------------------------------------------

lRoots = lRoots+hroots
call Ini_David(lRoots,nConf,nDet,nSel,n_keep,nAc,LuDavid)

!-----------------------------------------------------------------------
! COMPUTE THE DIAGONAL ELEMENTS OF THE HAMILTONIAN
!-------------------------------------------------------------------

! CIVEC: TEMPORARY CI VECTOR IN CSF BASIS

call mma_allocate(CIVEC,NCONF,label='CIVEC')
if (NAC > 0) call CIDIA_CI_UTIL(NCONF,STSYM,CIVEC,LUDAVID)

!-----------------------------------------------------------------------
! OBTAIN STARTING VECTORS
!-----------------------------------------------------------------------

mSel = nSel
m_Sel = mSel
if (NAC == 0) m_Sel = 0
call mma_allocate(iSel,m_Sel,label='iSel')
call mma_allocate(ExplE,m_Sel,label='ExplE')
call mma_allocate(ExplV,m_Sel,mSel,label='ExplV')
nMaxSel = nConf
if (N_ELIMINATED_GAS_MOLCAS > 0) nmaxSel = nCSF_HEXS

call CStart_CI_Util(CIVEC,LW1,TUVX,iSel,ExplE,ExplV,nMaxSel,IFINAL)

!-----------------------------------------------------------------------
! DIAGONALIZATION SECTION
!-----------------------------------------------------------------------

! PAM Jun 2006: Gradual lowering of threshold in first 3 iterations
!if (Iter > 1) Threshold = THFACT*abs(CONV(4,ITER-1))
! Energy threshold for CI convergence criterion:
if (Iter == 1) then
  Threshold = THREN
else if ((ITER > 1) .and. (ITER <= 3)) then
  ThrRule = THFACT*abs(CONV(4,ITER-1))
  Threshold = (real(4-ITER,kind=wp)*THREN+real(ITER,kind=wp)*ThrRule)*Quart
else
  Threshold = THFACT*abs(CONV(4,ITER-1))
end if
! End of new rule, PAM Jun 2006
Threshold = max(Threshold,1.0e-9_wp)
if (NAC == 0) then
  ESize = abs(EMY)
else
  ESize = abs(ExplE(1))
end if
Threshold = max(Threshold,ESize*1.0e-14_wp)

! CI_conv: CONVERGENCE PARAMETERS
call mma_allocate(CI_conv,2,lRoots,MAXJT,label='CI_conv')
ITERCI = 1
if (NAC == 0) then
  ENER(1,ITER) = EMY
else
  if ((nSel == nConf) .or. ((N_ELIMINATED_GAS_MOLCAS > 0) .and. (nSel == nCSF_HEXS))) then
    do jRoot=1,lRoots-hRoots
      ENER(jRoot,ITER) = ExplE(jRoot)
    end do
  else
    ! PAM Jun 2006: Limit the number of CI iterations in the
    ! first few macroiterations:
    if (KTIGHT == 0) ItLimit = min(12*ITER,MAXJT)
    if (KTIGHT == 1) ItLimit = MAXJT
    ! PAM Oct 2006: Full precision if this is final CI.
    if ((ICIONLY == 1) .or. (IFINAL == 2)) then
      Threshold = max(1.0e-9_wp,ESize*1.0e-14_wp)
      ITLIMIT = MAXJT
    end if
    ! PAM Feb 2009: New code in david5.
    !call David5(nAc,stSym,nDet,MAXJT,ITERCI,
    !call David5(nAc,stSym,nDet,ItLimit,ITERCI,CI_conv,Threshold,LW1,TUVX,iSel,ExplE,ExplV)

    call David5(nDet,ItLimit,IterCI,CI_conv,Threshold,iSel,ExplE,ExplV,LW1,TUVX)

    do jRoot=1,lRoots-hRoots
      ENER(jRoot,ITER) = CI_conv(1,jRoot,ITERCI)
    end do
  end if
end if
call mma_deallocate(CI_conv)
call mma_deallocate(iSel)
call mma_deallocate(ExplE)
call mma_deallocate(ExplV)
nSel = mSel
lRoots = lRoots-hroots

!-----------------------------------------------------------------------
! CLEANUP AFTER THE DAVIDSON DIAGONALIZATION
!-----------------------------------------------------------------------

iDisk = IADR15(4)
call Term_David(ICICH,ITERCI,lRoots,nConf,CIVEC,JOBIPH,LuDavid,iDisk)
call mma_deallocate(CIVEC)

return

end subroutine DavCtl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Ex_spin(rD,Fock,Temp1,ntemp,Temp2)

use MCLR_Data, only: ipCM, nDens, nNA
use input_mclr, only: nAsh, nBas, nIsh, nSym
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: rD(*)
real(kind=wp), intent(_OUT_) :: Fock(*)
integer(kind=iwp), intent(in) :: nTemp
real(kind=wp), intent(out) :: Temp1(nTemp), Temp2(nDens)
integer(kind=iwp) :: jB, jjB, jS, kS, lB, llB
real(kind=wp) :: rDens

Temp2(:) = Zero
do jS=1,nSym
  Fock(ipCm(js):ipCm(js)+nbas(js)**2-1) = Zero
  do kS=1,nsym

    ! To be debugged!

    if (nBas(js)*nash(ks) > 0) then

      do llB=1,nAsh(kS)
        lB = nIsh(kS)+llB
        do jjB=1,nAsh(kS)
          jB = nIsh(kS)+jjB

          call Exch(jS,kS,jS,kS,lB,jB,Temp1,Temp2)
          rDens = -Half*rD(nna*(jjB-1)+llB)
          Fock(ipCM(jS):ipCM(jS)+nBas(jS)**2-1) = Fock(ipCM(jS):ipCM(jS)+nBas(jS)**2-1)+rDens*Temp1(1:nBas(jS)**2)

        end do
      end do

    end if
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Ex_spin

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Roland Lindh                                     *
!***********************************************************************
subroutine DrvRys(iZeta,iEta,nZeta,nEta,mZeta,mEta,nZeta_Tot,nEta_Tot,Data1,mData1,Data2,mData2,nAlpha,nBeta,nGamma,nDelta,IndZ, &
                  Zeta,ZInv,P,KappAB,IndZet,IndE,Eta,EInv,Q,KappCD,IndEta,ix1,iy1,iz1,ix2,iy2,iz2,ThrInt,CutInt,vij,vkl,vik,vil, &
                  vjk,vjl,Prescreen_On_Int_Only,NoInts,iAnga,Coor,CoorAC,mabMin,mabMax,mcdMin,mcdMax,nijkl,nabcd,mabcd,Wrk,iW2, &
                  iW4,nWork2,mWork2,HMtrxAB,HMtrxCD,la,lb,lc,ld,iCmp,iShll,NoPInts,Dij,mDij,Dkl,mDkl,Do_TnsCtl,kabcd,Coeff1,iBasi, &
                  Coeff2,jBasj,Coeff3,kBask,Coeff4,lBasl)
!***********************************************************************
! Routine for the computation of primitive integrals and accumulation  *
! to the (ab|cd) or the (e0|f0) set of integrals. If the primitive     *
! set of integrals is smaller than the set of contracted integrals     *
! the code selects to apply the HRR recursion {e0|f0} -> {ab|cd} here  *
! before the contraction generating the (ab|cd) set of integrals, if   *
! not the {e0|f0} set is contracted to the (e0|f0) set directly and    *
! HRR recursion is applied outside this routine.                       *
!                                                                      *
! For the contraction we have that either all primitive integrals      *
! can be computed in a single step, otherwise subsets of primitive     *
! integrals are computed and accumulated to the contracted set.        *
!                                                                      *
! The Wrk array is subdivided into 2 or 3 blocks depending on if the   *
! calling code iterates over subsets of primitive integrals.           *
!                                                                      *
! Memory blocking                                                      *
! ===============                                                      *
! For an iterative use:                                                *
!      iW4 points to the start of Wrk, length nWork2-mWork2            *
!      iW2 points at nWork2-mWork+1, length mWork2                     *
!      iW3 points at nWork2, length nWork3                             *
!                                                                      *
! For single iteration use:                                            *
!      iW4 and iW2 point at the start of Wrk, length nWork2            *
!      iW3 points at nWork2, length nWork3                             *
!                                                                      *
! Usage of memory                                                      *
!      Screen: does not use Wrk                                        *
!      Rys:    use iW2 section                                         *
!      HRR:    use the aggregated iW2 and iW3 section                  *
!      Cntrct: use the iW2, iW3, and iW4 sections separately           *
!                                                                      *
! Author: Roland Lindh                                                 *
!         Dept Chemistry - Angstrom, the Theoretical Chem. Prog.       *
!         Uppsala University, Uppsala, Sweden                          *
!         2015                                                         *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iZeta, iEta, nZeta, nEta, mZeta, mEta, nZeta_Tot, nEta_Tot, mData1, mData2, nAlpha, nBeta, &
                                 nGamma, nDelta, IndZ(nZeta), IndE(nEta), ix1, iy1, iz1, ix2, iy2, iz2, iAnga(4), mabMin, mabMax, &
                                 mcdMin, mcdMax, nijkl, nabcd, mabcd, iW2, iW4, nWork2, mWork2, la, lb, lc, ld, iCmp(4), iShll(4), &
                                 mDij, mDkl, iBasi, jBasj, kBask, lBasl
real(kind=wp), intent(in) :: Data1(mData1), Data2(mData2), ThrInt, CutInt, vij, vkl, vik, vil, vjk, vjl, Coor(3,4), CoorAC(3,2), &
                             HMtrxAB(*), HMtrxCD(*), Dij(mDij), Dkl(mDkl), Coeff1(nAlpha,iBasi), Coeff2(nBeta,jBasj), &
                             Coeff3(nGamma,kBask), Coeff4(nDelta,lBasl)
real(kind=wp), intent(out) :: Zeta(nZeta), ZInv(nZeta), P(nZeta,3), Eta(nEta), EInv(nEta), Q(nEta,3)
real(kind=wp), intent(inout) :: KappAB(nZeta), KappCD(nEta), Wrk(nWork2)
integer(kind=iwp), intent(out) :: IndZet(nZeta), IndEta(nEta), kabcd
logical(kind=iwp), intent(in) :: Prescreen_On_Int_Only
logical(kind=iwp), intent(inout) :: NoInts, NoPInts, Do_TnsCtl
integer(kind=iwp) :: i_Int, iOffE, iOffZ, iW3, lEta, lZeta, n1, n2, n3, n4, nW2, nWork3
logical(kind=iwp) :: Nospecial
external :: TERI, ModU2, vCff2D, vRys2D
integer(kind=iwp), external :: ip_abMax, ip_abMaxD, ip_ZtMax, ip_ZtMaxD

#ifdef _DEBUGPRINT_
write(u6,*) 'Enter DrvRys'
write(u6,*) 'iZeta, nZeta, mZeta, nZeta_Tot=',iZeta,nZeta,mZeta,nZeta_Tot
write(u6,*) 'iEta , nEta , mEta , nEta_Tot=',iEta,nEta,mEta,nEta_Tot
call RecPrt('Coeff1',' ',Coeff1,nAlpha,iBasi)
call RecPrt('Coeff2',' ',Coeff2,nBeta,jBasj)
call RecPrt('Coeff3',' ',Coeff3,nGamma,kBask)
call RecPrt('Coeff4',' ',Coeff4,nDelta,lBasl)
call RecPrt('KappAB',' ',KappAB,1,nZeta)
call RecPrt('KappCD',' ',KappCD,1,nEta)
#endif

NoSpecial = .false. ! Use special code if possible

! Transfer k2 data and prescreen

iOffZ = mDij-nZeta
iOffE = mDkl-nEta
call Screen(nZeta,nEta,mZeta,mEta,lZeta,lEta,Zeta,ZInv,P,KappAB,IndZet,Data1(iZeta),nAlpha,nBeta,IndZ(iZeta), &
            Data1(ip_ZtMax(nZeta)),Data1(ip_abMax(nZeta)),Data1(ip_ZtMaxD(nZeta)),Data1(ip_abMaxD(nZeta)),Eta,EInv,Q,KappCD, &
            IndEta,Data2(iEta),nGamma,nDelta,IndE(iEta),Data2(ip_ZtMax(nEta)),Data2(ip_abMax(nEta)),Data2(ip_ZtMaxD(nEta)), &
            Data2(ip_abMaxD(nEta)),Dij(iOffZ),Dkl(iOffE),ix1,iy1,iz1,ix2,iy2,iz2,ThrInt,CutInt,vij,vkl,vik,vil,vjk,vjl, &
            Prescreen_On_Int_Only)
!write(u6,*) 'lZeta,lEta:',lZeta,lEta
if (lZeta*lEta == 0) then
  Wrk(iW2:iW2+mWork2-1) = Zero
else
  NoInts = .false.

  ! Compute [a0|c0], ijkl,a,c

  call Rys(iAnga,lZeta*lEta,Zeta,ZInv,lZeta,Eta,EInv,lEta,P,nZeta,Q,nEta,KappAB,KappCD,Coor,Coor,CoorAC,mabMin,mabMax,mcdMin, &
           mcdMax,Wrk(iW2),mWork2,TERI,ModU2,vCff2D,vRys2D,NoSpecial)

  ! Select between HRR before contraction or to contract
  ! and perform the HRR later once the complete set of
  ! contracted integrals have been generated.

  if ((lZeta*lEta < nijkl) .and. (mZeta == nZeta_tot) .and. (mEta == nEta_tot)) then

    ! Apply the HRR recursions first. Note that this is only
    ! executed if used in single iteration mode. Hence,
    ! iW2 and iW4 are identical.

    n1 = lZeta*lEta*mabcd
    iW3 = iW2+n1
    call DGeTMO(Wrk(iW2),lZeta*lEta,lZeta*lEta,mabcd,Wrk(iW3),mabcd)
    Wrk(iW2:iW2+n1-1) = Wrk(iW3:iW3+n1-1)
    call TnsCtl(Wrk(iW2),nWork2,Coor,mabcd,lZeta*lEta,mabMax,mabMin,mcdMax,mcdMin,HMtrxAB,HMtrxCD,la,lb,lc,ld,iCmp(1),iCmp(2), &
                iCmp(3),iCmp(4),iShll(1),iShll(2),iShll(3),iShll(4),i_Int)
    n2 = lZeta*lEta*nabcd
    if (i_Int /= iW2) Wrk(iW2:iW2+n2-1) = Wrk(i_Int:i_Int+n2-1)
    Do_TnsCtl = .false.
    n1 = 1
    n2 = iCmp(1)*iCmp(2)
    n3 = 1
    n4 = iCmp(3)*iCmp(4)
    kabcd = nabcd
  else

    ! Postpone application of the HRR recursions until later.

    Do_TnsCtl = .true.
    n1 = mabMin
    n2 = mabMax
    n3 = mcdMin
    n4 = mcdMax
    kabcd = mabcd
  end if

  ! Accumulate to the contracted integrals

  if (iW4 /= iW2) then
    ! Account for size of the integrals in
    nW2 = lZeta*lEta*kabcd
  else ! iW4 == iW2
    ! Account for size of the integrals in and out
    nW2 = max(iBasi*jBasj*kBask*lBasl,lZeta*lEta)*kabcd
  end if
  iW3 = iW2+nW2
  nWork3 = mWork2-nW2
  !write(u6,*) 'iW4,iW2,iW3:',iW4,iW2,iW3
  !write(u6,*) 'nWork3:',nWork3
  call Cntrct(NoPInts,Coeff1,nAlpha,iBasi,Coeff2,nBeta,jBasj,Coeff3,nGamma,kBask,Coeff4,nDelta,lBasl,Wrk(iW2),n1,n2,n3,n4, &
              Wrk(iW3),nWork3,Wrk(iW4),IndZet,lZeta,IndEta,lEta)
end if

#ifdef _DEBUGPRINT_
write(u6,*) 'iW4,iW2,iW3:',iW4,iW2,iW3
call RecPrt('DrvRys:(e0|0f)',' ',Wrk(iW4),kabcd,iBasi*jBasj*kBask*lBasl)
#endif

return

end subroutine DrvRys

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DerHeffX(IVEC,JVEC,NASHT,NTG3,OVL,DTG1,DTG2,DTG3)
! Compute the coupling Hamiltonian element defined as
!     HEL = < ROOT1 | H * OMEGA | ROOT2 >
! assuming that IVEC contains a contravariant representation of
! H|ROOT1>, JVEC contains a contravariant representation of
! OMEGA|ROOT2>, and OVL, TG1, TG2, TG3 contain the overlap (normally
! expected to be 0 or 1) and active transition density matrices of ROOT1
! and ROOT2. See also subroutine TSVEC for explanations.

! SVC (March 2014): modification of original code to handle distributed
! RHS arrays. There is now a main HCOUP subroutine that loops over cases
! and irreps and gets access to the process-specific block of the RHS.
! The coupling for that block is computed by the subroutine HCOUP_BLK.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB
#endif
use fake_GA, only: GA_Arrays
use caspt2_module, only: NASUP, NINDEP, NISUP, NSYM
use SC_NEVPT2, only: SC_prop, SC_NEVPT2_amplitude
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC, NASHT, NTG3
real(kind=wp), intent(out) :: OVL
real(kind=wp), intent(inout) :: DTG1(NASHT,NASHT), DTG2(NASHT,NASHT,NASHT,NASHT), DTG3(NTG3)
integer(kind=iwp) :: ICASE, iHi1, iHi2, iLo1, iLo2, ISYM, jHi1, jHi2, jLo1, jLo2, lg_V1, lg_V2, MV1, MV2, NAS, NIN, NIS, nvlen

! The dimension of TG3 is NTG3=(NASHT**2+2 over 3)

! Sketch of procedure:
!  Loop over every (case/symmetry)-block.
!     If (No such vector block) Skip to end of loop
!     Allocate two places for this block, VEC1 and VEC2
!     Read VEC1 as IVEC component from file.
!     Read VEC2 as JVEC component from file.
!     Loop nest, computing
!        HEL := HEL + VEC1*GOM*VEC2
!     End of loop nest
!     Deallocate VEC1 and VEC2
!  End of loop.

do ICASE=1,13
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIN = NINDEP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)

    if (NAS*NIS == 0) cycle
    if ((NIN == 0) .and. (.not. SC_prop)) cycle

    call RHS_ALLO(NAS,NIS,lg_V1)
    call RHS_ALLO(NAS,NIS,lg_V2)
    call RHS_READ(NAS,NIS,lg_V1,ICASE,ISYM,IVEC)
    if (SC_prop) then
      call RHS_READ(NAS,NIS,lg_V2,ICASE,ISYM,IVEC)
      call SC_NEVPT2_amplitude(NAS,NIS,ICASE,ISYM,lg_V2)
    else
      call RHS_READ(NAS,NIS,lg_V2,ICASE,ISYM,JVEC)
    end if
    call RHS_ACCESS(NAS,NIS,lg_V1,iLo1,iHi1,jLo1,jHi1,MV1)
    call RHS_ACCESS(NAS,NIS,lg_V2,iLo2,iHi2,jLo2,jHi2,MV2)

    if ((iLo1 /= iLo2) .or. (iHi1 /= iHi2) .or. (jLo1 /= jLo2) .or. (jHi1 /= jHi2)) then
      write(u6,'(1X,A)') 'HCOUP: Error: block mismatch, abort...'
      call ABEND()
    end if

    nvlen = (iHi1-jLo1+1)*(jHi1-jLo1+1)

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call DerHEffX_BLK(ICASE,ISYM,NAS,nvlen,NASHT,NTG3,jLo1,jHi1,DBL_MB(MV1),DBL_MB(MV2),OVL,DTG1,DTG2,DTG3)
    else
#   endif
      call DerHEffX_BLK(ICASE,ISYM,NAS,nvlen,NASHT,NTG3,jLo1,jHi1,GA_Arrays(MV1)%A,GA_Arrays(MV2)%A,OVL,DTG1,DTG2,DTG3)
#   ifdef _MOLCAS_MPP_
    end if
#   endif

    call RHS_RELEASE(lg_V1,iLo1,iHi1,jLo1,jHi1)
    call RHS_RELEASE(lg_V2,iLo2,iHi2,jLo2,jHi2)
    call RHS_FREE(lg_V1)
    call RHS_FREE(lg_V2)
  end do
end do

end subroutine DerHeffX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Giovanni Ghigo                                   *
************************************************************************
      Subroutine OutZMAT(nAtoms,XYZCoords,N_ZMAT)
      Implicit Real*8 (a-h,o-z)
      Real*8 XYZCoords(3,nAtoms)
#include "stdalloc.fh"
#include "SysDef.fh"
      Character(LEN=5), Allocatable:: Symbols(:)
      Integer, Allocatable:: NAT(:)
      Real*8, Allocatable:: ZMATCoords(:,:), ZMAT(:,:)
*
      Call mma_allocate(Symbols,N_ZMAT,Label='Symbols')
      Call mma_allocate(NAT,N_ZMAT,Label='NAT')
      Call mma_allocate(ZMATCoords,3,N_ZMAT,Label='ZMATCoords')
      Call mma_allocate(ZMAT,N_ZMAT,3,Label='ZMAT')
*
      Call OutZMAT_Internal(nAtoms,XYZCoords,N_ZMAT,Symbols,NAT,
     &                      ZMATCoords,ZMAT)
*
      Call mma_deallocate(ZMAT)
      Call mma_deallocate(ZMATCoords)
      Call mma_deallocate(NAT)
      Call mma_deallocate(Symbols)
*
      Return
      End
      Subroutine OutZMAT_Internal(nAtoms,XYZCoords,N_ZMAT,Symbols,NAT,
     &                            ZMATCoords,ZMAT)
************************************************************************
* Author: Giovanni Ghigo                                               *
*         Torino (Italy)  February-March 2007                          *
*                                                                      *
* This subroutine generates the nuclear coordinates in Z-matrix        *
* format using the connection indices recovered from RunFile.          *
* Remember:                                                            *
*           X dummy atoms - NAT(i)= 0 - are included in SEWARD         *
*           Z ghost atoms - NAT(i)=-1 - are NOT included in SEWARD     *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "stdalloc.fh"
#include "angstr.fh"
      Character(LEN=5) Symbols(N_ZMAT)
      Integer NAT(N_ZMAT)
      Integer, Allocatable :: iZmat(:,:)
      Real*8 XYZCoords(3,nAtoms), ZMATCoords(3,N_ZMAT), ZMAT(N_ZMAT,3)
      Real*8 CTX(3,4), Bt(3,4), dBt(3,4,3,4)
      Logical IfTest
      Character(LEN=8) Label
      Real*8, Parameter :: ThrsTrasl=1.0d0  ! Threshold for warning
*
#ifdef _DEBUGPRINT_
      IfTest=.True.
#else
      IfTest=.False.
#endif
*
      LuWr = 6
      todeg = 45.0d0 / ATan(1.0d0)
      dMaxTrasl = 0.0d0
      Label =' '
      Call dZero(ZMAT,N_ZMAT*3)
      Call dZero(ZMATCoords,N_ZMAT*3)
      Call Get_cArray('Symbol ZMAT',Symbols,N_ZMAT*5)
      Call mma_allocate(iZmat,3,N_ZMAT,label='iZmat')
      Call Get_iArray('Index ZMAT',iZmat,N_ZMAT*3)
      Call Get_iArray('NAT ZMAT',NAT,N_ZMAT)

      If (IfTest) then
        Write(LuWr,*)
        Write(LuWr,*) '------------------------------------------------'
        Write(LuWr,*) 'OutZMat - Z-Matrix Data :'
        Write(LuWr,*) '          N_ZMAT=',N_ZMAT
        Write(LuWr,*) '   Label  NA      i   j   k'
        Do i=1,N_ZMAT
          Write(LuWr,97) i,Symbols(i),NAT(i),(iZmat(j,i),j=1,3)
        EndDo
        Write(LuWr,*)
        Write(LuWr,*) '------------------------------------------------'
        Write(LuWr,*) 'OutZMat - XYZCoords (Angstrom):'
        Do i=1,nAtoms
          Write(LuWr,98) i,(angstr*XYZCoords(j,i),j=1,3)
        EndDo
        Write(LuWr,*)
      EndIf

      If (N_ZMAT.LT.3) Return
      If (N_ZMAT.GT.(nAtoms+3)) then
        Write(LuWr,'(A)') ' ZMAT cannot be defined :'
        Write(LuWr,'(A)') ' Too many ghost Z atoms. '
        Return
      EndIf

*  Z are ghost atoms
*  A are both dummy (X) and real atoms

*  Z  Z  Z
      If (NAT(1).EQ.-1.and.NAT(2).EQ.-1.and.NAT(3).EQ.-1) then
        iBonded = 0
        Do i = 4, N_ZMAT
          If (iZmat(1,i).EQ.2.and.iBonded.EQ.0) iBonded = i
        EndDo
        If (iBonded.EQ.0) then
          ZMATCoords(3,2) = 1.0d0/angstr
        else
          ZMATCoords(3,2) = XYZCoords(3,iBonded-3)
        EndIf
        iBonded = 0
        Do i = 4, N_ZMAT
          If (iZmat(1,i).EQ.3.and.iBonded.EQ.0) iBonded = i
        EndDo
        If (iBonded.EQ.0) then
          ZMATCoords(1,3) = 1.0d0/angstr
        else
          ZMATCoords(1,3) = XYZCoords(1,iBonded-3)
        EndIf
        If (iZmat(1,3).EQ.2) ZMATCoords(3,3) = ZMATCoords(3,2)
        Do iAtom = 4, N_ZMAT
          ZMATCoords(1,iAtom)=XYZCoords(1,iAtom-3)
          ZMATCoords(2,iAtom)=XYZCoords(2,iAtom-3)
          ZMATCoords(3,iAtom)=XYZCoords(3,iAtom-3)
        EndDo
      EndIf

*  Z  Z  A
      If (NAT(1).EQ.-1.and.NAT(2).EQ.-1.and.NAT(3).GE.0) then
        iBonded = 0
        Do i = 3, N_ZMAT
          If (iZmat(1,i).EQ.2.and.iBonded.EQ.0) iBonded = i
        EndDo
        If (iBonded.EQ.0) then
          ZMATCoords(3,2) = 1.0d0/angstr
        else
          ZMATCoords(3,2) = XYZCoords(3,iBonded-2)
        EndIf
        Do iAtom = 3, N_ZMAT
          ZMATCoords(1,iAtom)=XYZCoords(1,iAtom-2)
          ZMATCoords(2,iAtom)=XYZCoords(2,iAtom-2)
          ZMATCoords(3,iAtom)=XYZCoords(3,iAtom-2)
        EndDo
      EndIf

*  Z  A  Z
      If (NAT(1).EQ.-1.and.NAT(3).EQ.-1.and.NAT(2).GE.0) then
        dMaxTrasl = 0.0d0
        dX = XYZCoords(1,1)
        dY = XYZCoords(2,1)
        Do iAtom = 1, N_ZMAT-2
          XYZCoords(1,iAtom)=XYZCoords(1,iAtom)-dX
          XYZCoords(2,iAtom)=XYZCoords(2,iAtom)-dY
        EndDo
        ZMATCoords(1,2)=XYZCoords(1,1)
        ZMATCoords(2,2)=XYZCoords(2,1)
        ZMATCoords(3,2)=XYZCoords(3,1)
        dMaxTrasl = Max(0.0d0,ABS(dX),ABS(dY))
        If (dMaxTrasl.GE.ThrsTrasl) Write (LuWr,'(A)')
     &  '  Warning: MaxTrasl.GE.ThrsTrasl for atom ',Symbols(2)
        If (iZmat(1,3).EQ.2) ZMATCoords(3,3) = ZMATCoords(3,2)
        iBonded = 0
        Do i = 4, N_ZMAT
          If (iZmat(1,i).EQ.3.and.iBonded.EQ.0) iBonded = i
        EndDo
        If (iBonded.EQ.0) then
          ZMATCoords(1,3) = 1.0d0/angstr
        else
          ZMATCoords(1,3) = XYZCoords(1,iBonded-2)
        EndIf
        Do iAtom = 4, N_ZMAT
          ZMATCoords(1,iAtom)=XYZCoords(1,iAtom-2)
          ZMATCoords(2,iAtom)=XYZCoords(2,iAtom-2)
          ZMATCoords(3,iAtom)=XYZCoords(3,iAtom-2)
        EndDo
      EndIf

*  A  Z  Z
      If (NAT(1).GE.0.and.NAT(2).EQ.-1.and.NAT(3).EQ.-1) then
        dX = XYZCoords(1,1)
        dY = XYZCoords(2,1)
        dZ = XYZCoords(3,1)
        Do iAtom = 1, N_ZMAT-2
          XYZCoords(1,iAtom)=XYZCoords(1,iAtom)-dX
          XYZCoords(2,iAtom)=XYZCoords(2,iAtom)-dY
          XYZCoords(3,iAtom)=XYZCoords(3,iAtom)-dZ
        EndDo
        dMaxTrasl = Max(0.0d0,ABS(dX),ABS(dY),ABS(dZ))
        If (dMaxTrasl.GE.ThrsTrasl) Write (LuWr,'(A)')
     &  '  Warning: MaxTrasl.GE.ThrsTrasl for atom ',Symbols(1)
        iBonded = 0
        Do i = 4, N_ZMAT
          If (iZmat(1,i).EQ.2.and.iBonded.EQ.0) iBonded = i
        EndDo
        If (iBonded.EQ.0) then
          ZMATCoords(3,2) = 1.0d0/angstr
        else
          ZMATCoords(3,2) = XYZCoords(3,iBonded-2)
        EndIf
        iBonded = 0
        Do i = 4, N_ZMAT
          If (iZmat(1,i).EQ.3.and.iBonded.EQ.0) iBonded = i
        EndDo
        If (iBonded.EQ.0) then
          ZMATCoords(1,3) = 1.0d0/angstr
        else
          ZMATCoords(1,3) = XYZCoords(1,iBonded-2)
        EndIf
        Do iAtom = 4, N_ZMAT
          ZMATCoords(1,iAtom)=XYZCoords(1,iAtom-2)
          ZMATCoords(2,iAtom)=XYZCoords(2,iAtom-2)
          ZMATCoords(3,iAtom)=XYZCoords(3,iAtom-2)
        EndDo
      EndIf

*  Z  A  B
      If (NAT(1).EQ.-1.and.NAT(2).GE.0.and.NAT(3).GE.0) then
        dX = XYZCoords(1,1)
        dY = XYZCoords(2,1)
        Do iAtom = 2, N_ZMAT
          ZMATCoords(1,iAtom)=XYZCoords(1,iAtom-1)-dX
          ZMATCoords(2,iAtom)=XYZCoords(2,iAtom-1)-dY
          ZMATCoords(3,iAtom)=XYZCoords(3,iAtom-1)
        EndDo
        dMaxTrasl = Max(0.0d0,ABS(dX),ABS(dY))
        If (dMaxTrasl.GE.ThrsTrasl) Write (LuWr,'(A)')
     &  '  Warning: MaxTrasl.GE.ThrsTrasl for atom ',Symbols(2)
      EndIf

*  A  Z  B
      If (NAT(1).GE.0.and.NAT(2).EQ.-1.and.NAT(3).GE.0) then
        dX = XYZCoords(1,1)
        dY = XYZCoords(2,1)
        dZ = XYZCoords(3,1)
        Do iAtom = 1, N_ZMAT-1
          XYZCoords(1,iAtom)=XYZCoords(1,iAtom)-dX
          XYZCoords(2,iAtom)=XYZCoords(2,iAtom)-dY
          XYZCoords(3,iAtom)=XYZCoords(3,iAtom)-dZ
        EndDo
        dMaxTrasl = Max(0.0d0,ABS(dX),ABS(dY),ABS(dZ))
        If (dMaxTrasl.GE.ThrsTrasl) Write (LuWr,'(A)')
     &  '  Warning: MaxTrasl.GE.ThrsTrasl for atom ',Symbols(1)
        iBonded = 0
        Do i = 3, N_ZMAT
          If (iZmat(1,i).EQ.2.and.iBonded.EQ.0) iBonded = i
        EndDo
        If (iBonded.EQ.0) then
          ZMATCoords(3,2) = 1.0d0/angstr
        else
          ZMATCoords(3,2) = XYZCoords(3,iBonded-1)
        EndIf
        Do iAtom = 3, N_ZMAT
          ZMATCoords(1,iAtom)=XYZCoords(1,iAtom-1)
          ZMATCoords(2,iAtom)=XYZCoords(2,iAtom-1)
          ZMATCoords(3,iAtom)=XYZCoords(3,iAtom-1)
        EndDo
      EndIf

*  A  B  Z
      If (NAT(1).GE.0.and.NAT(2).GE.0.and.NAT(3).EQ.-1) then
        dMaxTrasl = 0.0d0
        dX = XYZCoords(1,1)
        dY = XYZCoords(2,1)
        dZ = XYZCoords(3,1)
        Do iAtom = 1, N_ZMAT-1
          XYZCoords(1,iAtom)=XYZCoords(1,iAtom)-dX
          XYZCoords(2,iAtom)=XYZCoords(2,iAtom)-dY
          XYZCoords(3,iAtom)=XYZCoords(3,iAtom)-dZ
        EndDo
        dMaxTrasl = Max(0.0d0,ABS(dX),ABS(dY),ABS(dZ))
        If (dMaxTrasl.GE.ThrsTrasl) Write (LuWr,'(A)')
     &  '  Warning: MaxTrasl.GE.ThrsTrasl for atom ',Symbols(1)
        ZMATCoords(1,2)=XYZCoords(1,2)
        ZMATCoords(2,2)=XYZCoords(2,2)
        ZMATCoords(3,2)=XYZCoords(3,2)
        If (iZmat(1,3).EQ.1) then
          iBonded = 0
          Do i = 4, N_ZMAT
            If (iZmat(1,i).EQ.3.and.iBonded.EQ.0) iBonded = i
          EndDo
          If (iBonded.EQ.0) then
            ZMATCoords(1,3) = 1.0d0/angstr
          else
            ZMATCoords(1,3) = XYZCoords(1,iBonded-2)
          EndIf
        else
          ZMATCoords(1,3) = XYZCoords(1,2) + 1.0d0/angstr
          ZMATCoords(2,3) = XYZCoords(2,2)
          ZMATCoords(3,3) = XYZCoords(3,2)
        EndIf
        Do iAtom = 4, N_ZMAT
          ZMATCoords(1,iAtom)=XYZCoords(1,iAtom-1)
          ZMATCoords(2,iAtom)=XYZCoords(2,iAtom-1)
          ZMATCoords(3,iAtom)=XYZCoords(3,iAtom-1)
        EndDo
      EndIf

*  A  B  C
      If (NAT(1).GE.0.and.NAT(2).GE.0.and.NAT(3).GE.0) then
        Call dCopy_(N_ZMAT*3,XYZCoords,1,ZMATCoords,1)
      EndIf


      If (IfTest) then
        Write(LuWr,*)
        Write(LuWr,*) '------------------------------------------------'
        Write(LuWr,*) 'OutZMat - ZMATCoords : '
        Do i=1,N_ZMAT
          Write(LuWr,99) i,NAT(i),(angstr*ZMATCoords(j,i),j=1,3)
        EndDo
      EndIf

      iAtom = 2
      iRX = iZMAT(1,iAtom)
      dX = ZMATCoords(1,iAtom) - ZMATCoords(1,iRX)
      dY = ZMATCoords(2,iAtom) - ZMATCoords(2,iRX)
      dZ = ZMATCoords(3,iAtom) - ZMATCoords(3,iRX)
      bond = SQRT( dX*dX + dY*dY + dZ*dZ )
      ZMAT(iAtom,1) = bond*angstr

      If (N_ZMAT.GE.3) then
        iAtom = 3
        iRX = iZMAT(1,iAtom)
        iAX = iZMAT(2,iAtom)
        dX = ZMATCoords(1,iAtom) - ZMATCoords(1,iRX)
        dY = ZMATCoords(2,iAtom) - ZMATCoords(2,iRX)
        dZ = ZMATCoords(3,iAtom) - ZMATCoords(3,iRX)
        dX2 = ZMATCoords(1,iAX) - ZMATCoords(1,iRX)
        dY2 = ZMATCoords(2,iAX) - ZMATCoords(2,iRX)
        dZ2 = ZMATCoords(3,iAX) - ZMATCoords(3,iRX)
        bond = SQRT( dX*dX + dY*dY + dZ*dZ )
        ZMAT(iAtom,1) = bond*angstr
        prod = dX*dX2 + dY*dY2 + dZ*dZ2
        dvec2 = SQRT( dX2*dX2 + dY2*dY2 + dZ2*dZ2 )
        arccos = prod / ( bond * dvec2 )
        If (arccos.GT.1.0d0) arccos = Sign(1.0d0,arccos)
        alpha = ACOS(arccos)
        ZMAT(iAtom,2) = alpha*todeg
      EndIf

      If (N_ZMAT.GE.4) then
        Do iAtom = 4, N_ZMAT
          If (NAT(iAtom).EQ.-1) then
            Write(LuWr,'(A)') ' ZMAT cannot be defined :'
            Write(LuWr,'(A)') ' Found X atom.           '
            Return
          EndIf
          iRX = iZMAT(1,iAtom)
          iAX = iZMAT(2,iAtom)
          iTX = iZMAT(3,iAtom)
          dX = ZMATCoords(1,iAtom) - ZMATCoords(1,iRX)
          dY = ZMATCoords(2,iAtom) - ZMATCoords(2,iRX)
          dZ = ZMATCoords(3,iAtom) - ZMATCoords(3,iRX)
          dX2 = ZMATCoords(1,iAX) - ZMATCoords(1,iRX)
          dY2 = ZMATCoords(2,iAX) - ZMATCoords(2,iRX)
          dZ2 = ZMATCoords(3,iAX) - ZMATCoords(3,iRX)
          bond = SQRT( dX*dX + dY*dY + dZ*dZ )
          ZMAT(iAtom,1) = bond*angstr
          prod = dX*dX2 + dY*dY2 + dZ*dZ2
          dvec2 = SQRT( dX2*dX2 + dY2*dY2 + dZ2*dZ2 )
          arccos = prod / ( bond * dvec2 )
          If (arccos.GT.1.0d0) arccos = Sign(1.0d0,arccos)
          alpha = ACOS(arccos)
          ZMAT(iAtom,2) = alpha*todeg
          Do ii=1,3
            CTX(ii,1) = ZMATCoords(ii,iTX)
            CTX(ii,2) = ZMATCoords(ii,iAX)
            CTX(ii,3) = ZMATCoords(ii,iRX)
            CTX(ii,4) = ZMATCoords(ii,iAtom)
          EndDo
          Call Trsn(CTX,4,theta,Bt,.False.,.False.,Label,dBt,.False.)
          ZMAT(iAtom,3) = -theta*todeg
        EndDo
      EndIf

      Write (LuWr,*)
      Write (LuWr,*) '***********************************************'//
     &               '*****************'
      Write (LuWr,*) '* Nuclear coordinates in Z-Matrix format / Angs'//
     &               'trom and Degree *'
      Write (LuWr,*) '-----------------------------------------------'//
     &               '-----------------'
      Do i=1, N_ZMAT
        If (i.EQ.1)
     &    Write(LuWr,201) Symbols(i)
        If (i.EQ.2)
     &    Write(LuWr,202) Symbols(i),iZmat(1,i),ZMAT(i,1)
        If (i.EQ.3)
     &    Write(LuWr,203) Symbols(i),(iZmat(j,i),ZMAT(i,j),j=1,2)
        If (i.GE.4)
     &    Write(LuWr,204) Symbols(i),(iZmat(j,i),ZMAT(i,j),j=1,3)
      EndDo
      Call mma_deallocate(iZmat)
      Write (LuWr,*)
201   Format (5X,A5)
202   Format (5X,A5,1X,I4,F13.6)
203   Format (5X,A5,1X,2(I4,F13.6))
204   Format (5X,A5,1X,3(I4,F13.6))

97    Format(I3,1X,A,1X,I3,3X,3I4)
98    Format(I3,1X,3(F12.6))
99    Format(I3,1X,I3,1X,3(F12.6))

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Grid_On_Disk

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: Use_Old = 0, Regenerate = 1, &
                                Not_Specified = 0, Final_Grid = 1, Intermediate = 2
integer(kind=iwp) :: G_S(2), Grid_Status, iDisk_Grid, iDisk_Set(2), iGrid_Set, Lu_Grid, LuGridFile, nBatch, nBatch_Max = 128, &
                     Old_Functional_Type
integer(kind=iwp), allocatable :: GridInfo(:,:), iBatchInfo(:,:)

public :: ExpandBatchInfo, Final_Grid, G_S, Grid_Status, GridInfo, iBatchInfo, iDisk_Grid, iDisk_Set, iGrid_Set, Intermediate, &
          Lu_Grid, LuGridFile, nBatch, nBatch_Max, Not_Specified, Old_Functional_Type, Regenerate, Use_Old

contains

subroutine ExpandBatchInfo()

  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp) :: n
  integer(kind=iwp), allocatable :: new_iBatchInfo(:,:)

  n = size(iBatchInfo,2)
  nBatch_Max = 2*n
  call mma_allocate(new_iBatchInfo,size(iBatchInfo,1),nBatch_Max,label='new_iBatchInfo')
  new_iBatchInfo(:,1:n) = iBatchInfo
  new_iBatchInfo(:,n+1:) = 0
  call mma_deallocate(iBatchInfo)
  call move_alloc(new_iBatchInfo,iBatchInfo)

end subroutine ExpandBatchInfo

end module Grid_On_Disk

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine saamp(wrk,wrksize,key)
! this routine rearranges amplitudes to be spin adapted
! key - 0 - no adaptation
!       1 - T2 DDVV adaptation
!       2 - T2 DDVV + T1 DV adaptation
!       3 - full T1 and T2 adaptation (only for doublets)
!       4 - full T2 without SDVS (only for doublets)
!
! amplitudes T1 are in t13 - aa, t14 - bb
! T2 are in t21 - aaaa, t22 - bbbb, t23 - abab

use ccsd_global, only: dimm, mmul, nsym, t13, t14, t21, t22, t23
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, key
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: ii, pos1, pos2, pos3, pos4, pos5, pos6, syma, symb, symi, symij, symj, syms

!0 skip this routine if SA in not turn on
if (key == 0) return

!I T1 adaptation
if ((key == 2) .or. (key == 3)) then

  !I.1 def symmetry, where S orbital is situated (only for doublet states)
  syms = 0
  do symi=1,nsym
    if (dimm(1,symi) /= dimm(2,symi)) syms = symi
  end do
  if ((key == 2) .and. (syms == 0)) syms = 1
  if (syms == 0) then
    write(u6,*) ' Full SA is turn on and there is no S orbitals'
    call Abend()
  end if

  !I.2 loop over symi
  do symi=1,nsym
    syma = symi

    ii = t13%i(syma,1,1)
    pos1 = t13%d(ii,1)
    ii = t14%i(syma,1,1)
    pos2 = t14%d(ii,1)
    ii = t23%i(syma,syms,syms)
    pos3 = t23%d(ii,1)
    call saamphlp3(wrk(pos1),wrk(pos2),wrk(pos3),dimm(1,symi),dimm(2,symi),dimm(3,symi),dimm(4,symi),dimm(1,syms),dimm(4,syms),key)

  end do
end if

!II T2 adaptation

do symi=1,nsym
  do symj=1,symi
    symij = mmul(symi,symj)

    do syma=1,nsym
      symb = mmul(symij,syma)

      ! Meggie out
      if (symb > syma) cycle

      if (symi == symj) then
        ! case si=sj, sa=sb

        ii = t21%i(syma,symb,symi)
        pos1 = t21%d(ii,1)
        ii = t22%i(syma,symb,symi)
        pos2 = t22%d(ii,1)
        ii = t23%i(syma,symb,symi)
        pos3 = t23%d(ii,1)
        call saamphlp1(wrk(pos1),wrk(pos2),wrk(pos3),dimm(1,symi),dimm(2,symi),dimm(3,syma),dimm(4,syma),key)

      else
        ! case si>sj, sa>sb

        ii = t21%i(syma,symb,symi)
        pos1 = t21%d(ii,1)
        ii = t22%i(syma,symb,symi)
        pos2 = t22%d(ii,1)
        ii = t23%i(syma,symb,symi)
        pos3 = t23%d(ii,1)
        ii = t23%i(symb,syma,symj)
        pos4 = t23%d(ii,1)

        ii = t23%i(symb,syma,symi)
        pos5 = t23%d(ii,1)
        ii = t23%i(syma,symb,symj)
        pos6 = t23%d(ii,1)
        call saamphlp2(wrk(pos1),wrk(pos2),wrk(pos3),wrk(pos4),wrk(pos5),wrk(pos6),dimm(1,symi),dimm(1,symj),dimm(2,symi), &
                       dimm(2,symj),dimm(3,syma),dimm(3,symb),dimm(4,syma),dimm(4,symb),key)

      end if

    end do
  end do
end do

return

end subroutine saamp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Per-Olof Widmark                                 *
*               2010, John Burkardt                                    *
*               2017, Morgane Vacher                                   *
************************************************************************
      Function Random_Molcas(iSeed)
************************************************************************
*                                                                      *
*     Generate a random number z, where 0<z<0.5d0**31                  *
*                                                                      *
*     calling arguments:                                               *
*     iSeed  : Type integer, input/output                              *
*              initial value of new chain                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark                                                     *
*     University of Lund, Sweden, 1993                                 *
*     M. Vacher, Uppsala 2017                                          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Parameter (IM1=134456, IA1=8121, IC1=28411)
      Parameter (IM2=243000, IA2=4561, IC2=51349)
      Parameter (IM3=259200, IA3=7141, IC3=54773)
      real*8 , parameter :: a = 1220703125.0D+00
      real*8 , save :: a1, a2
      integer  i
      integer , save :: ks = 0
      real*8 , save :: r23, r46, t23, t46
      real*8  t1, t2, t3, t4, x, x1, x2, z
      integer  iseed
      Real*8 Random_Molcas
      Character*8 rand_info
      Call GetEnvf('MOLCAS_RANDOM',rand_info)
      Call UpCase(rand_info)
      if (rand_info(1:3) .EQ. 'OLD') then
        IX0 = iSeed
        IX1 = MOD(IA1*IX0+IC1,IM1)
        IX2 = MOD(IA2*IX1+IC2,IM2)
        IX3 = MOD(IA3*IX2+IC3,IM3)
        Random_Molcas = (DBLE(IX1)+DBLE(IX2)/DBLE(IM2))/DBLE(IM1)
        iSeed = IX3
      else
************************************************************************
*     The number returned is a uniform pseudorandom value in the range *
*     (0,1). The algorithm uses the linear congruential generator:     *
*     X(K+1) = A * X(K)  mod 2^46                                      *
*     This scheme generates 2^44 numbers before repeating.             *
*----------------------------------------------------------------------*
*     Author: John Burkardt                                            *
*     Modified: 08 March 2010                                          *
*----------------------------------------------------------------------*
*     Reference:                                                       *
*     David Bailey, Eric Barszcz, John Barton, D Browning, Robert      *
*     Carter, Leonardo Dagum, Rod Fatoohi, Samuel Fineberg, Paul       *
*     Frederickson, Thomas Lasinski, Robert Schreiber, Horst Simon, V  *
*     Venkatakrishnan, Sisira Weeratunga, The NAS Parallel Benchmarks, *
*     RNR Technical Report RNR-94-007, March 1994.                     *
*     Donald Knuth, The Art of Computer Programming, Volume 2,         *
*     Seminumerical Algorithms, Third Edition, Addison Wesley, 1997,   *
*     ISBN: 0201896842, LC: QA76.6.K64.                                *
*----------------------------------------------------------------------*
*     Parameters:                                                      *
*     Input/output, real ( kind = 8 ) X, the seed.  X should be an     *
*     odd integer such that 1 <= X <= 2^46.                            *
*     Output, real (kind=8) Random_Molcas, the next pseudorandom value.*
************************************************************************
*  If this is the first call, compute
*    R23 = 2 ^ -23,
*    R46 = 2 ^ -46,
*    T23 = 2 ^ 23,
*    T46 = 2 ^ 46.
*  These are computed in loops, rather than by merely using the power operator,
*  in order to insure that the results are exact on all systems.
      x = real(iseed,kind(x))
      if ( ks == 0 ) then
        r23 = 1.0D+00
        r46 = 1.0D+00
        t23 = 1.0D+00
        t46 = 1.0D+00
        do i = 1, 23
          r23 = 0.5D+00 * r23
          t23 = 2.0D+00 * t23
        end do
        do i = 1, 46
          r46 = 0.50D+00 * r46
          t46 = 2.0D+00 * t46
        end do
*  Break A into two parts such that A = 2^23 * A1 + A2.
        t1 = r23 * a
        a1 = real ( int ( t1 ), kind = 8 )
        a2 = a - t23 * a1
        ks = 1
      end if
*  Deal with a 0 input value of X.
      if ( x == 0.0D+00 ) then
        x = 314159265.0D+00
      end if
*  Deal somewhat arbitrarily with negative input X.
      if ( x < 0.0D+00 ) then
        x = - x
      end if
*  Break X into two parts X1 and X2 such that:
*    X = 2^23 * X1 + X2,
*  then compute
*    Z = A1 * X2 + A2 * X1  (mod 2^23)
*    X = 2^23 * Z + A2 * X2  (mod 2^46).
      t1 = r23 * x
      x1 = real ( int ( t1 ), kind = 8 )
      x2 = x - t23 * x1
      t1 = a1 * x2 + a2 * x1
      t2 = real ( int ( r23 * t1 ), kind = 8 )
      z = t1 - t23 * t2
      t3 = t23 * z + a2 * x2
      t4 = real ( int ( r46 * t3 ), kind = 8 )
      x = t3 - t46 * t4
      Random_Molcas = r46 * x
      iseed = int(x,kind(iseed))
      endif
*----------------------------------------------------------------------*
*     exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
*               2011, Francesco Aquilante                              *
************************************************************************
      Subroutine PriMO_Localisation(Header,PrOcc,PrEne,ThrOcc,ThrEne,
     &                              nSym,nBas,nOrb,Nme,Ene,Occ,CMO,
     &                              iPrForm,IndxT)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Print MOs.
C     This is a work-around to fix bugs when orbitals are deleted.
C
C     F. Aquilante, Nov 2011   (Print only non-deleted orbitals)
C
      Implicit None
#include "Molcas.fh"
      Character*(*) Header
      Character*(LENIN8) Nme(*)
      Logical PrOcc, PrEne
      Real*8  ThrOcc, ThrEne
      Integer nSym
      Integer nBas(nSym), nOrb(nSym)
      Real*8  Ene(*), Occ(*), CMO(*)
      Integer iPrForm
      Integer IndxT(*)
#include "WrkSpc.fh"

      Integer ip_CMO, l_CMO
      Integer ip_Occ, l_OCc
      Integer ip_EOr, l_EOr
      Integer nOrbT, iSym, k1, k2
      Integer k, kk, ik, nOrb_(8)

      Call Icopy(nSym,nOrb,1,nOrb_,1)
      kk=0
      Do iSym=1,nSym
         Do k=1,nBas(iSym)
            ik=kk+k
            If (IndxT(ik).eq.7) nOrb(iSym)=nOrb(iSym)-1
         End Do
         kk=kk+nBas(iSym)
      End Do

      nOrbT=nOrb(1)
      Do iSym=2,nSym
         nOrbT=nOrbT+nOrb(iSym)
      End Do

      l_CMO=nBas(1)*nOrb(1)
      Do iSym=2,nSym
         l_CMO=l_CMO+nBas(iSym)*nOrb(iSym)
      End Do
      l_Occ=nOrbT
      l_EOr=nOrbT

      Call GetMem('CMO_','Allo','Real',ip_CMO,l_CMO)
      Call GetMem('Occ_','Allo','Real',ip_Occ,l_Occ)
      Call GetMem('Eor_','Allo','Real',ip_EOr,l_EOr)

      k1=1
      k2=ip_CMO
      Do iSym=1,nSym
         Call dCopy_(nBas(iSym)*nOrb(iSym),CMO(k1),1,Work(k2),1)
         k1=k1+nBas(iSym)*nBas(iSym)
         k2=k2+nBas(iSym)*nOrb(iSym)
      End Do

      k1=1
      k2=ip_Occ
      Do iSym=1,nSym
         Call dCopy_(nOrb(iSym),Occ(k1),1,Work(k2),1)
         k1=k1+nBas(iSym)
         k2=k2+nOrb(iSym)
      End Do

      k1=1
      k2=ip_EOr
      Do iSym=1,nSym
         Call dCopy_(nOrb(iSym),Ene(k1),1,Work(k2),1)
         k1=k1+nBas(iSym)
         k2=k2+nOrb(iSym)
      End Do

      Call PriMO(Header,PrOcc,PrEne,ThrOcc,ThrEne,nSym,nBas,nOrb,
     &           Nme,Work(ip_EOr),Work(ip_Occ),Work(ip_CMO),iPrForm)

      Call GetMem('Eor_','Free','Real',ip_EOr,l_EOr)
      Call GetMem('Occ_','Free','Real',ip_Occ,l_Occ)
      Call GetMem('CMO_','Free','Real',ip_CMO,l_CMO)

      Call Icopy(nSym,nOrb_,1,nOrb,1)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MakeWwd (Ww,W1,aSGrp,beSGrp,gaSGrp)
c
c       this routine do:
c       Make  Ww(+)((aa)",(bega)") from W1(a",be",a",ga")
c        and   index bega" is be">=ga"
c       for all cases aSGrp >= bSGrp
c       N.B. rutinky MakeWwHlpx niesu prilis vymakane @
c
c       parameter description:
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",a",ga") (I)
c       xSGrp  - SubGroup of a",be",ga" (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 Ww(1)
        real*8 W1(1)
        integer aSGrp,beSGrp,gaSGrp
c
c       help variables
        integer dimbe,dimga,dimbega,dima
c
c
c1      def dimensions
c
        dimbe=DimSGrpbe(beSGrp)
        dimga=DimSGrpbe(gaSGrp)
        dima=DimSGrpa(aSGrp)
c
        if (beSGrp.eq.gaSGrp) then
          dimbega=dimbe*(dimbe+1)/2
        else
          dimbega=dimbe*dimga
        end if
c
c
c2      Make Ww matrix
c
        if (beSGrp.eq.gaSGrp) then
          call MakeWwdHlp1 (Ww(1),W1(1),
     c                   dima,dimbe,dimbega)
        else
          call MakeWwdHlp2 (Ww(1),W1(1),
     c                   dima,dimbe,dimga)
        end if

c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Cho_X_GetIP_InfVec(InfVcT)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: get pointer to InfVec array for all vectors.

use Cholesky, only: InfVec
#ifdef _MOLCAS_MPP_
use Cholesky, only: Cho_Real_Par, InfVec_Bak
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), pointer, intent(out) :: InfVct(:,:,:)

#ifdef _MOLCAS_MPP_
if (Cho_Real_Par) then
  if (allocated(InfVec_Bak)) then
    InfVcT => InfVec_Bak
  else
    call Cho_Quit('Initialization problem in Cho_X_GetIP_InfVec',103)
  end if
else
#endif
  InfVcT => InfVec
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine Cho_X_GetIP_InfVec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Giovanni Ghigo                                   *
!***********************************************************************
!  Cho_GenE
!
!> @brief
!>   Routine for the generation of the ``A,B`` block of exchange integrals (in symmetries \p iSymA, \p iSymB)
!>   for occupied MO \p iI, \p iJ in symmetries \p iSymI, \p iSymJ
!> @author Giovanni Ghigo
!>
!> @details
!> The routine generates the ``A,B`` block of integrals gathering 9
!> sub-blocks. These are combination of inactive, active, and
!> secondary ``A,B`` MO.
!>
!> @param[in] iSymI,iSymJ,iSymA,iSymB Symmetry block of the two-electrons integrals
!> @param[in] iI,iJ
!> @param[in] NumV                    Number of Cholesky vectors to transform in the current batch
!> @param[in,out] AddEx               Array of the ``A,B`` integrals block
!> @param[in] LenEx                   Length of the ``A,B`` integrals block
!***********************************************************************

subroutine Cho_GenE(iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddEx,LenEx)
!***********************************************************************
! Author :  Giovanni Ghigo                                             *
!           Lund University, Sweden & Torino University, Italy         *
!           January-June 2005                                          *
!----------------------------------------------------------------------*
! This is the routine that really generates the A,B block of exchange  *
! integrals (in symmetries iSymA,iSymB) for occupied MO iI,iJ in       *
! symmetries iSymI,iSymJ. The 3 x 3 A,B block is built gathering 9     *
! sub-blocks. These are combination of inactive, active, and secondary *
! A,B MO                                                               *
!***********************************************************************

use Cho_Tra, only: DoTCVA, nAsh, nIsh, nSsh, SubBlocks
use MkSubs, only: MkExSB11, MkExSB12, MkExSB13, MkExSB21, MkExSB22, MkExSB23, MkExSB31, MkExSB32, MkExSB33
use Data_Structures, only: Alloc1DArray_Type
use stdalloc, only: mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSymI, iSymJ, iSymA, iSymB, iI, iJ, numV, LenEx
real(kind=wp), intent(inout) :: AddEx(LenEx)
integer(kind=iwp) :: iA, iAddExSB, iAddSBi, iB, iLenA, iLenAa, iLenB, iLenBb, iSB_A, iSB_B, LenA(3), LenB(3)
type(Alloc1DArray_Type) :: AddSB(3,3)

!                                                                      *
!***********************************************************************
!                                                                      *
! GENERATION of SubBlocks
if (SubBlocks(1,1)) call MkExSB11(AddSB(1,1)%A,iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV)
if (SubBlocks(1,2)) call MkExSB12(AddSB(1,2)%A,iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV)
if (SubBlocks(1,3)) call MkExSB13(AddSB(1,3)%A,iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV)
if (SubBlocks(2,1)) call MkExSB21(AddSB(2,1)%A,iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddSB(1,2)%A)
if (SubBlocks(2,2)) call MkExSB22(AddSB(2,2)%A,iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV)
if (SubBlocks(2,3)) call MkExSB23(AddSB(2,3)%A,iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV)
if (SubBlocks(3,1)) call MkExSB31(AddSB(3,1)%A,iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddSB(1,3)%A)
if (SubBlocks(3,2)) call MkExSB32(AddSB(3,2)%A,iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddSB(2,3)%A)
if (SubBlocks(3,3)) call MkExSB33(AddSB(3,3)%A,iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV)
! END GENERATION of SubBlocks

! GATHERING of SubBlocks
iAddExSB = 1
if (DoTCVA) then

  LenB(1) = nIsh(iSymB)
  LenB(2) = nAsh(iSymB)
  LenB(3) = nSsh(iSymB)
  LenA(1) = nIsh(iSymA)
  LenA(2) = nAsh(iSymA)
  LenA(3) = nSsh(iSymA)
  if (iSymA /= iSymB) then

    do iSB_A=1,3
      do iA=1,LenA(iSB_A)
        do iSB_B=1,3
          if (LenB(iSB_B) == 0) cycle ! SB(1,iSB_A)

          iAddSBi = 1+LenB(iSB_B)*(iA-1)
          call daxpy_(LenB(iSB_B),One,AddSB(iSB_A,iSB_B)%A(iAddSBi),1,AddEx(iAddExSB),1)
          iAddExSB = iAddExSB+LenB(iSB_B)
        end do
      end do  ! iA
    end do ! iSB_A

  else

    do iSB_B=1,3
      do iB=1,LenB(iSB_B)
        do iSB_A=1,3
          if (LenA(iSB_A) == 0) cycle ! SB(1,iSB_B)

          iAddSBi = 1+LenA(iSB_A)*(iB-1)
          call daxpy_(LenA(iSB_A),One,AddSB(iSB_B,iSB_A)%A(iAddSBi),1,AddEx(iAddExSB),1)
          iAddExSB = iAddExSB+LenA(iSB_A)
        end do  ! iSB_A

      end do  ! iB
    end do ! iSB_B

  end if

else

  if (iSymA /= iSymB) then
    iLenBb = nSsh(iSymB)
    if (iLenBb > 0) then ! SB(3,3)
      iLenA = nSsh(iSymA)
      do iA=1,iLenA
        iAddSBi = 1+iLenBb*(iA-1)
        call daxpy_(iLenBb,One,AddSB(3,3)%A(iAddSBi),1,AddEx(iAddExSB),1)
        iAddExSB = iAddExSB+iLenBb
      end do  ! iA
    end if
  else
    iLenAa = nSsh(iSymA)
    if (iLenAa > 0) then ! SB(3,3)
      iLenB = nSsh(iSymB)
      do iB=1,iLenB
        iAddSBi = 1+iLenAa*(iB-1)
        call daxpy_(iLenAa,One,AddSB(3,3)%A(iAddSBi),1,AddEx(iAddExSB),1)
        iAddExSB = iAddExSB+iLenAa
      end do  ! iB
    end if
  end if

end if
! END GATHERING of SubBlocks

do iSB_A=1,3
  do iSB_B=1,3
    if (allocated(AddSB(iSB_A,iSB_B)%A)) call mma_deallocate(AddSB(iSB_A,iSB_B)%A)
  end do
end do

return

end subroutine Cho_GenE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Compute_O(ZA,RA,nAtoms,Z_Tot,T,O,Lambda)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 ZA(nAtoms), RA(3,nAtoms), T(3), O(3,3), Lambda(3)
*     Local arrays
      Real*8 EVal(6), M(3,3)
*                                                                      *
************************************************************************
*                                                                      *
*---- Form the nuclear charge moment tensor
*
      Call Compute_M(ZA,nAtoms,RA,Z_Tot,T,M)
*                                                                      *
************************************************************************
*                                                                      *
*---- Diagonalize the nuclear charge momentum tensor to get
*     the principle axis system.
*
      Call FZero(O,9)
      call dcopy_(3,[One],0,O,4)
      EVal(1)=M(1,1)
      EVal(2)=M(2,1)
      EVal(3)=M(2,2)
      EVal(4)=M(3,1)
      EVal(5)=M(3,2)
      EVal(6)=M(3,3)
      Call Jacob(EVal,O,3,3)
C     Call JacOrd(EVal,O,3,3)
#ifdef _DEBUGPRINT_
      Call TriPrt('RotGrd: EVal',' ',EVal,3)
      Call RecPrt('RotGrd: O',' ',O,3,3)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Lambda(1)=EVal(1)
      Lambda(2)=EVal(3)
      Lambda(3)=EVal(6)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NRASDT(MNRS1,MXRS1,MNRS3,MXRS3,ITOTSM,NSM,NOCTPA,NOCTPB,IEL1A,IEL1B,NSSOA,NSSOB,IEL3A,IEL3B,NCOMB,XNCOMB,MXSB,MXSOOB, &
                  IBLTP)
! Number of combimations with symmetry ITOTSM and
!       MNRS1 - MXRS1 elecs in RAS1
!       MNRS3 - MXRS3 elecs in RAS3
!
! In view of the limited range of I*4, the number of dets
! is returned as integer and real(kind=wp)
!
! MXSB is largest UNPACKED symmetry block
! MXSOOB is largest UNPACKED symmetry-type-type block
!
! Updated with IBLTP, Summer of 93

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Constants, only: Zero, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: MNRS1, MXRS1, MNRS3, MXRS3, ITOTSM, NSM, NOCTPA, NOCTPB, IEL1A(*), IEL1B(*), NSSOA(NOCTPA,*), &
                                 NSSOB(NOCTPB,*), IEL3A(*), IEL3B(*), IBLTP(*)
integer(kind=iwp), intent(out) :: NCOMB, MXSB, MXSOOB
real(kind=wp), intent(out) :: XNCOMB
integer(kind=iwp) :: IASM, IATP, IBSM, IBTP, IEL1, IEL3, ISYM, LSB, LTTSBL, LTTSUP, MXBTP

MXSB = 0
MXSOOB = 0
NCOMB = 0
XNCOMB = Zero
do IASM=1,NSM
  if (IBLTP(IASM) == 0) cycle
  IBSM = Mul(IASM,ITOTSM)
  LSB = 0
  if (IBSM /= 0) then
    if (IBLTP(IASM) == 2) then
      ISYM = 1
    else
      ISYM = 0
    end if
    do IATP=1,NOCTPA
      if (ISYM == 1) then
        MXBTP = IATP
      else
        MXBTP = NOCTPB
      end if
      do IBTP=1,MXBTP
        IEL1 = IEL1A(IATP)+IEL1B(IBTP)
        IEL3 = IEL3A(IATP)+IEL3B(IBTP)
        if ((IEL1 >= MNRS1) .and. (IEL1 <= MXRS1) .and. (IEL3 >= MNRS3) .and. (IEL3 <= MXRS3)) then
          ! Size of unpacked block
          LTTSUP = NSSOA(IATP,IASM)*NSSOB(IBTP,IBSM)
          ! Size of packed block
          if ((ISYM == 0) .or. (IATP /= IBTP)) then
            LTTSBL = NSSOA(IATP,IASM)*NSSOB(IBTP,IBSM)
          else
            LTTSBL = nTri_Elem(NSSOA(IATP,IASM))
          end if
          NCOMB = NCOMB+LTTSBL
          LSB = LSB+LTTSUP
          MXSOOB = max(MXSOOB,LTTSUP)
          if ((ISYM == 0) .or. (IATP /= IBTP)) then
            XNCOMB = XNCOMB+real(NSSOA(IATP,IASM),kind=wp)*real(NSSOB(IBTP,IBSM),kind=wp)
          else
            XNCOMB = XNCOMB+real(NSSOA(IATP,IASM),kind=wp)*real(NSSOB(IBTP,IBSM)+1,kind=wp)*Half
          end if
        end if
      end do
    end do
    MXSB = max(MXSB,LSB)
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' NCOMB and XNCOMB ',NCOMB,XNCOMB
#endif

end subroutine NRASDT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKWWOPE(IVEC,JVEC,OP0,OP1)
! Presently symmetry blocking is disregarded.

! Given the coefficients for two excitation operators, available in
! vectors numbered IVEC and JVEC on file, use the blocks for
! excitation case VJAI, i.e. cases 6 and 7, to express the
! product (Op in IVEC conjugated)(Op in JVEC) as a one-body
! operator on the CASSCF space.
! Formula used:
!  (W1(t,aij) conj)*(W2(x,bkl)) = dik*djl*dab*(2*dtx - Etx)
! the same for both cases 6 and 7.

use EQSOLV, only: MODVEC
use caspt2_module, only: NAES, NASHT, NASUP, NINDEP, NISUP, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC
real(kind=wp), intent(inout) :: OP0, OP1(NASHT,NASHT)
integer(kind=iwp) :: ICASE, IIEND, IISTA, ISCT, ISYM, IT, ITABS, IW1, IW2, IWPROD, IX, IXABS, MDVEC, NAS, NCOL, NIS, NWPROD
real(kind=wp) :: W_PROD
real(kind=wp), allocatable :: W1(:), W2(:), WPROD(:)

! Loop over cases
do ICASE=6,7
  ! Loop over symmetry ISYM
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (NINDEP(ISYM,ICASE) == 0) cycle
    ! Allocate space for one section of excitation amplitudes:
    MDVEC = MODVEC(ISYM,ICASE)
    call mma_allocate(W1,NAS*MDVEC,Label='W1')
    call mma_allocate(W2,NAS*MDVEC,Label='W2')
    NWPROD = NAS**2
    ! Allocate space for the contraction:
    call mma_allocate(WPROD,NWPROD,Label='WPROD')
    WPROD(:) = Zero
    ! Sectioning loop added:
    ISCT = 0
    do IISTA=1,NIS,MDVEC
      ISCT = ISCT+1
      IIEND = min(IISTA-1+MDVEC,NIS)
      NCOL = 1+IIEND-IISTA
      call RDSCTC(ISCT,ISYM,ICASE,IVEC,W1,NAS*MDVEC)
      call RDSCTC(ISCT,ISYM,ICASE,JVEC,W2,NAS*MDVEC)
      ! Multiply WProd = (W1)*(W2 transpose)
      call DGEMM_('N','T',NAS,NAS,NCOL,One,W1,NAS,W2,NAS,One,WPROD,NAS)
    end do
    ! Deallocate space for this block of excitation amplitudes:
    call mma_deallocate(W1)
    call mma_deallocate(W2)

    ! Loop over (T)
    do IT=1,NAS
      IW1 = IT
      ITABS = IT+NAES(ISYM)
      ! Loop over (X)
      do IX=1,NAS
        IW2 = IX
        IXABS = IX+NAES(ISYM)
        IWPROD = IW1+NAS*(IW2-1)
        W_PROD = WPROD(IWPROD)
        OP1(ITABS,IXABS) = OP1(ITABS,IXABS)-W_PROD
        if (ITABS == IXABS) OP0 = OP0+Two*W_PROD
      end do
    end do
    ! Deallocate matrix product
    call mma_deallocate(WPROD)
  end do
  ! End of loop over cases.
end do

end subroutine MKWWOPE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Drvh1_EMB(Grad,Temp,nGrad)

use Basis_Info, only: dbsc, nCnttp, nBas
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Temp(nGrad)
#include "print.fh"
integer(kind=iwp) :: i, ii, iIrrep, iPrint, iRout, nComp, nDens, nOrdOp
real(kind=wp) :: TCpu1, TCpu2, TWall1, TWall2
logical(kind=iwp) :: DiffOp, lECP, lPP, lFAIEMP
character(len=80) :: Label
character(len=16) :: NamRfil
integer(kind=iwp), allocatable :: lOper(:)
real(kind=wp), allocatable :: Coor(:,:), D_Var(:)
external :: FragPGrd, FragPMmG, M1Grd, M1MmG, M2Grd, M2MmG, NAGrd, NAMmG, PPGrd, PPMmG, PrjGrd, PrjMmG, SROGrd, SROMmG

!...  Prologue
iRout = 131
iPrint = nPrint(iRout)
call CWTime(TCpu1,TWall1)
call StatusLine(' Alaska:',' Computing 1-el OFE gradients')

call Set_Basis_Mode('Valence')
call Setup_iSD()

lECP = .false.
lPP = .false.
lFAIEMP = .false.
do i=1,nCnttp
  lECP = lECP .or. dbsc(i)%ECP
  lPP = lPP .or. (dbsc(i)%nPP /= 0)
  lFAIEMP = LFAIEMP .or. dbsc(i)%Frag
end do

! Allocate memory for density matrices

nDens = 0
do iIrrep=0,nIrrep-1
  nDens = nDens+nBas(iIrrep)*(nBas(iIrrep)+1)/2
end do

! Read the variational 1st order density matrix
! density matrix in AO/SO basis

call Get_NameRun(NamRfil) ! save the old RUNFILE name
call NameRun('AUXRFIL')   ! switch RUNFILE name

call mma_allocate(D_Var,nDens,Label='D_Var')
call Get_D1ao_Var(D_var,nDens)
if (iPrint >= 99) then
  write(u6,*) 'variational 1st order density matrix'
  ii = 1
  do iIrrep=0,nIrrep-1
    write(u6,*) 'symmetry block',iIrrep
    call TriPrt(' ',' ',D_Var(ii),nBas(iIrrep))
    ii = ii+nBas(iIrrep)*(nBas(iIrrep)+1)/2
  end do
end if

! Annihilate all the components of rho_B in the bsfs of the A subsystem

!SVC: fixed according to instructions from Francesco,
!      as embedding should not deal with symmetry
call Annihil_rho(D_var,nBas(0))

call NameRun(NamRfil)   ! switch RUNFILE name
!                                                                      *
!***********************************************************************
!                                                                      *
! nOrdOp: order/rank of the operator
! lOper(:): lOper of each component of the operator

nOrdOp = 0
nComp = (nOrdOp+1)*(nOrdOp+2)/2
call mma_allocate(Coor,3,nComp)
call mma_allocate(lOper,nComp,Label='lOper')
Coor(:,:) = Zero
lOper(:) = 1

!***********************************************************************
!3)                                                                    *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the nuclear attraction integrals.                    *
!                                                                      *
!***********************************************************************

DiffOp = .true.
Label = ' The Nuclear Attraction Contribution'
call OneEl_g(NAGrd,NAMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)

call DaXpY_(nGrad,One,Temp,1,Grad,1)

!***********************************************************************
!4)                                                                    *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the ECP integrals.                                   *
!                                                                      *
!***********************************************************************

if (lECP) then
  DiffOp = .true.
  Label = ' The Projection Operator contribution'
  call OneEl_g(PrjGrd,PrjMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
  call DaXpY_(nGrad,One,Temp,1,Grad,1)

  Label = ' The M1 Operator contribution'
  call OneEl_g(M1Grd,M1MmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
  call DaXpY_(nGrad,One,Temp,1,Grad,1)

  Label = ' The M2 Operator contribution'
  call OneEl_g(M2Grd,M2MmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
  call DaXpY_(nGrad,One,Temp,1,Grad,1)

  Label = ' The SR Operator contribution'
  call OneEl_g(SROGrd,SROMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
  call DaXpY_(nGrad,One,Temp,1,Grad,1)
end if
if (lPP) then
  Label = ' The Pseudo Potential contribution'
  call OneEl_g(PPGrd,PPMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
  call DaXpY_(nGrad,One,Temp,1,Grad,1)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (lFAIEMP) then
  DiffOp = .true.
  Label = ' The FAIEMP Projection Operator Contribution'
  call OneEl_g(FragPGrd,FragPMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
  call DaXpY_(nGrad,One,Temp,1,Grad,1)
  call DrvG_FAIEMP(Grad,Temp,nGrad)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(lOper)
call mma_deallocate(Coor)
!                                                                      *
!***********************************************************************
!                                                                      *
! Epilogue, end

call mma_deallocate(D_Var)

call Free_iSD()
call CWTime(TCpu2,TWall2)
call SavTim(3,TCpu2-TCpu1,TWall2-TWall1)

return

end subroutine Drvh1_EMB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
************************************************************************
      Subroutine Update_sl(Step_Trunc,nWndw,kIter)
************************************************************************
*                                                                      *
*     Object: to update coordinates                                    *
*                                                                      *
*    OutPut:                                                           *
*      Step_Trunc     : character label to denote truncation type      *
*                                                                      *
*                                                                      *
*     Author: Roland Lindh                                             *
*             2000                                                     *
************************************************************************
      use Slapaf_Info, only: Shift, qInt
      use Slapaf_Parameters, only: Beta, Beta_disp, NmIter, iter
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
#include "Molcas.fh"
      Character Step_Trunc
      Real*8 Dummy(1)
      Real*8, Allocatable:: t_Shift(:,:), t_qInt(:,:), tmp(:)
*
      Logical Kriging_Hessian
*                                                                      *
************************************************************************
*                                                                      *
      nQQ = SIZE(qInt,1)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('Update_sl: qInt',' ',qInt,nQQ,Iter)
      Call RecPrt('Update_sl: Shift',' ',Shift,nQQ,Iter-1)
#endif
*
      iOpt_RS=0
      qBeta=Beta
      qBeta_Disp=Beta_Disp
*                                                                      *
************************************************************************
*                                                                      *
      Call Mk_Hss_Q()
      Kriging_Hessian =.FALSE.
*                                                                      *
************************************************************************
*                                                                      *
*     Select between numerical evaluation of the Hessian or a molcular
*     geometry optimization.
*
      Step_Trunc=' '
      If (iter.eq.NmIter.and.NmIter.ne.1) Then
*                                                                      *
************************************************************************
*                                                                      *
*------- On the first iteration after a numerical evaluation of the
*        Hessian we like the step to be relative to the initial
*        structure.
*
#ifdef _DEBUGPRINT_
         Write(6,*)'UpDate_SL: first iteration'
#endif
         iter_=1
         Call mma_Allocate(t_Shift,nQQ,SIZE(Shift,2),Label='t_Shift')
         t_Shift(:,:)=Shift(:,:)
         Shift(:,:)=Zero

         Call mma_Allocate(t_qInt,nQQ,SIZE(qInt,2),Label='t_qInt')
         t_qInt(:,:)=qInt(:,:)
         qInt(:,:)=Zero
         qInt(:,1)=t_qInt(:,1)
*
         Call Update_inner(iter_,Beta,Beta_Disp,Step_Trunc,nWndw,
     &                     kIter,Kriging_Hessian,qBeta,
     &                     iOpt_RS,.True.,iter_,qBeta_Disp)
*                                                                      *
************************************************************************
*                                                                      *
*------- Move new coordinates to the correct position and compute the
*        corresponding shift.
*
         Call mma_allocate(Tmp,SIZE(qInt,1),Label='tmp')
         tmp(:)=qInt(:,2)
         qInt(:,:)=t_qInt(:,:)
         qInt(:,iter+1)=tmp(:)
         Shift(:,:)=t_Shift(:,:)
         Shift(:,iter)=tmp(:)-qInt(:,iter)
*
         Call mma_deallocate(tmp)
         Call mma_deallocate(t_qInt)
         Call mma_deallocate(t_Shift)
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
*        Conventional optimization.
*
         Call Update_inner(iter,Beta,Beta_Disp,Step_Trunc,nWndw,kIter,
     &                     Kriging_Hessian,qBeta,
     &                     iOpt_RS,.True.,iter,qBeta_Disp)
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Write out the shift in internal coordinates basis.
*
#ifdef _DEBUGPRINT_
      Call RecPrt('Shifts in internal coordinate basis / au or rad',
     &      ' ',Shift,nQQ,Iter)
      Call RecPrt('qInt in internal coordinate basis / au or rad',
     &      ' ',qInt,nQQ,Iter+1)
#endif

*
*---- Remove unneeded fields from the runfile
      Dummy(1)=-Zero
      Call Put_dArray('BMxOld',Dummy(1),0)
      Call Put_dArray('TROld',Dummy(1),0)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine gsinp_cvb(
     >  orbs,irdorbs,ip_cvb,nvbinp,kbasiscvb_inp,
     >  mxaobf,mxorb,kbasis,strtvb)
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      parameter (ngs=7,ncmp=4)
      character*8 guess
      logical firsttime_cvb
      external firsttime_cvb
      dimension guess(ngs)
      dimension orbs(mxaobf,mxorb),irdorbs(mxorb)
      dimension idum(1)
      save guess
      data guess/ 'ORB     ','STRUC   ','READ    ','AOBASIS ',
     >            'MOBASIS ','END     ','ENDGUESS'/

      if(firsttime_cvb())call touch_cvb('INPGS')
      mouse=1
3000  call fstring_cvb(guess,ngs,istr,ncmp,2)
      if(istr.eq.1)then
c 'ORB'
        call int_cvb(idum,1,nread,0)
        iorb=idum(1)
        if(iorb.le.0.or.iorb.gt.mxorb)then
          write(6,*)' Illegal orbital number read :',iorb
          call abend_cvb()
        endif
        if(nread.eq.0)then
          write(6,*)' Orbital label in ORB keyword not found!'
          call abend_cvb()
        endif
        irdorbs(iorb)=mouse
        call fzero(orbs(1,iorb),mxaobf)
        call real_cvb(orbs(1,iorb),mxaobf,nread,0)
      elseif(istr.eq.2)then
c 'STRUC'
c  If previous orb. permutation disable:
        call mhpfreer_cvb(ip_cvb)
        mxread=mavailr_cvb()/2
        ip_cvb=mheapr_cvb(mxread)
        call realz_cvb(w(ip_cvb),mxread,nvbinp,0)
        call mreallocr_cvb(ip_cvb,nvbinp)
        kbasiscvb_inp=kbasis
      elseif(istr.eq.3)then
cc 'READ'
c        call fstring_cvb(readgs,nrdgs,istr2,ncmp,1)
c        if(istr2.eq.1)then
cc 'ORB'
c          iorb1=0
c          iorb2=0
c          call int_cvb(idum,1,nread,0)
c          iorb1=idum(1)
c          if(nread.eq.0)then
c            write(6,*)' No orbital number in READ,ORB keyword!'
c            call abend_cvb()
c          endif
c          call fstring_cvb('TO      ',1,jstr,ncmp,1)
c          if(jstr.ne.0)then
c            call int_cvb(idum,1,nread,0)
c            iorb2=idum(1)
c            if(nread.eq.0)then
c              write(6,*)' No orbital number after READ,...,TO, !'
c              call abend_cvb()
c            endif
c          else
c            iorb2=iorb1
c          endif
c          jorb1=iorb1
c          jorb2=iorb2
c          call setstrtvb_cvb(strtvb)
c          recordnm=strtvb
c3100      call fstring_cvb(readgs2,nrdgs2,istr3,ncmp,1)
c          if(istr3.eq.1)then
c            call real_cvb(recordnm,1,nread,0)
c            if(nread.eq.0)then
c              write(6,*)' No identifier after READ,...,FROM, !'
c              call abend_cvb()
c            endif
c          elseif(istr3.eq.2)then
c            call int_cvb(idum,1,nread,0)
c            jorb1=idum(1)
c            if(nread.eq.0)then
c              write(6,*)' No orbital number after READ,...,AS, !'
c              call abend_cvb()
c            endif
c            call fstring_cvb('TO      ',1,jstr,ncmp,1)
c            if(jstr.ne.0)then
c              call int_cvb(idum,1,nread,0)
c              jorb2=idum(1)
c              if(nread.eq.0)then
c                write(6,*)' No orbital number after READ,...,TO, !'
c                call abend_cvb()
c              endif
c            else
c              jorb2=jorb1
c            endif
c          endif
c          if(istr3.ne.0)goto 3100
c          call othergs_cvb(orbs,w(ip_cvb),recordnm,1,
c     >      iorb1,iorb2,jorb1,jorb2)
c        elseif(istr2.eq.2)then
cc      'STRUC'
c          istruc1=0
c          istruc2=0
c          call int_cvb(idum,1,nread,0)
c          istruc1=idum(1)
c          if(nread.eq.0)then
c            write(6,*)' No structure number in READ,STRUC keyword!'
c            call abend_cvb()
c          endif
c          call fstring_cvb('TO      ',1,jstr,ncmp,1)
c          if(jstr.ne.0)then
c            call int_cvb(idum,1,nread,0)
c            istruc2=idum(1)
c            if(nread.eq.0)then
c              write(6,*)' No structure number after READ,...,TO, !'
c              call abend_cvb()
c            endif
c          else
c            istruc2=istruc1
c          endif
c          jstruc1=istruc1
c          jstruc2=istruc2
c          call setstrtvb_cvb(strtvb)
c          recordnm=strtvb
c3200      call fstring_cvb(readgs2,nrdgs2,istr3,ncmp,1)
c          if(istr3.eq.1)then
c            call real_cvb(recordnm,1,nread,0)
c            if(nread.eq.0)then
c              write(6,*)' No identifier after READ,...,FROM, !'
c              call abend_cvb()
c            endif
c          elseif(istr3.eq.2)then
c            call int_cvb(idum,1,nread,0)
c            jstruc1=idum(1)
c            if(nread.eq.0)then
c              write(6,*)' No structure number after READ,...,AS, !'
c              call abend_cvb()
c            endif
c            call fstring_cvb('TO      ',1,jstr,ncmp,1)
c            if(jstr.ne.0)then
c              call int_cvb(idum,1,nread,0)
c              jstruc2=idum(1)
c              if(nread.eq.0)then
c                write(6,*)' No structure number after READ,...,TO, !'
c                call abend_cvb()
c              endif
c            else
c              jstruc2=jstruc1
c            endif
c          endif
c          if(istr3.ne.0)goto 3200
c          call othergs_cvb(orbs,w(ip_cvb),recordnm,2,
c     >      istruc1,istruc2,jstruc1,jstruc2)
c        elseif(istr2.eq.3)then
cc 'ALL'
c          call setstrtvb_cvb(strtvb)
c          recordnm=strtvb
c          call fstring_cvb('FROM    ',1,jstr,ncmp,1)
c          if(jstr.ne.0)then
c            call real_cvb(recordnm,1,nread,0)
c            if(nread.eq.0)then
c              write(6,*)' No identifier after READ,...,FROM, !'
c              call abend_cvb()
c            endif
c          endif
c          call getguess_cvb(orbs,w(ip_cvb),recordnm,kbasiscvb_inp)
c        endif
      elseif(istr.eq.4)then
c 'AOBASIS'
        mouse=2
      elseif(istr.eq.5)then
c 'MOBASIS'
        mouse=1
      endif
c 'END' , 'ENDGUESS' or unrecognized keyword -- end GUESS input :
      if(.not.(istr.eq.0.or.istr.eq.6.or.istr.eq.7))goto 3000

      return
c Avoid unused argument warnings
      if (.false.) call Unused_real(strtvb)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine SlapAf(ireturn)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
#include "WrkSpc.fh"
!     Is this usage permitted? - Yingjin
!#include "dmrginfo_mclr.fh"
      Character*8 ELOOP
************ columbus interface ****************************************
      Integer Columbus
#include "info_slapaf.fh"
#include "warnings.fh"
*                                                                      *
************************************************************************
*                                                                      *
      Lu=6
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     Let us go to work !
*
      iStop=-1
      Call RlxCtl(iStop)
      ! in case it is dmrg calculation
*      call read_dmrg_parameter_for_mclr()
*                                                                      *
************************************************************************
*                                                                      *
*
*     Epilogue
*
      If (nPrint(1).ge.6) Then
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Put out the proper return code.

      If (iStop.eq.2) Then
************ columbus interface ****************************************
* prevent slapaf to startup alaska
* The last MRCI or MRAQCC energy is written to the RUNFILE by the
* Columbus modules, so no need to recompute it internally

        Call Get_iScalar('Columbus',Columbus)
        if (Columbus.eq.1) then
           iReturn=_RC_ALL_IS_WELL_
        else
*
*        Compute the last energy (module Last_Energy)
*
         if (CallLast) then
          Call Start_Last_Energy()
*
          iReturn=_RC_INVOKED_OTHER_MODULE_
         else
          iReturn=_RC_ALL_IS_WELL_
         endif
        endif
*

      Else If (iStop.eq.3) Then
*
*        Invoke Alaska
*
         Call Start_Alaska()
*
         iReturn=_RC_INVOKED_OTHER_MODULE_
*
      Else If (iStop.eq.6) Then
*
*        Saddle TS optimization
*
         iReturn=_RC_INVOKED_OTHER_MODULE_
*
      Else If (iStop.eq.8) Then
*
*        Predicted energy change too large
*
         iReturn=_RC_NOT_CONVERGED_
*
      Else If (iStop.eq.16) Then
*
*        Optimization didn't converge!
*
         iReturn=_RC_NOT_CONVERGED_
*
      Else If (iStop.eq.1) Then
*
*        Continue looping!
*
         Call GetEnvF('EMIL_InLoop',ELOOP)
         If (ELOOP.eq.' ') ELOOP='0'
         If (ELOOP(1:1).ne.'0') Then
            iReturn=_RC_CONTINUE_LOOP_
         Else
            iReturn=_RC_ALL_IS_WELL_
         End If
         If (isFalcon) Then
            iReturn=_RC_ALL_IS_WELL_
         End if
*
      Else If (iStop.eq.0) Then
*
*        ???
*
         iReturn=_RC_ALL_IS_WELL_
*
      Else
*
*        Bad bad boy!
*
         iReturn=_RC_INTERNAL_ERROR_
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine unpackk_ic_1(i,vint,ndimv1,ndimv2,ndimv3,Vic,ndimvi)
! this routine vint(j,k,l) = <i,j|k,l>
! for given i from incore (nonreduced) expanded block Vic
!
! i      - value of pivot index (I)
! vint   - array of integrals (O)
! ndimv1 - first dimension of vint (norb(symj)) (I)
! ndimv2 - second dimension of vint (norb(symk)) (I)
! ndimv3 - third dimension of vint (norb(syml)) (I)
! Vic    - incore expanded block of integrals (I)
! ndimvi - first dimension of Vic norb(symi) (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: i, ndimv1, ndimv2, ndimv3, ndimvi
real(kind=wp), intent(out) :: vint(ndimv1,ndimv2,ndimv3)
real(kind=wp), intent(in) :: Vic(ndimvi,ndimv1,ndimv2,ndimv3)

vint(:,:,:) = Vic(i,:,:,:)

return

end subroutine unpackk_ic_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine findmn_cvb(vec,n,vmn,imn)
      implicit real*8 (a-h,o-z)
      dimension vec(n)

      if(n.gt.0)then
        imn=1
        vmn=vec(1)
        do 100 i=2,n
        if(vec(i).lt.vmn)then
          imn=i
          vmn=vec(i)
        endif
100     continue
      else
        imn=0
        vmn=1d20
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DecideOnLocalDF(LocalDF)
      Implicit None
      Logical LocalDF

      Logical DF
      Integer DFMode

      Call DecideOnDF(DF)
      If (DF) Then
         Call Get_iScalar('DF Mode',DFMode)
         LocalDF=DFMode.eq.1
      Else
         LocalDF=.False.
      End IF

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine TrGen(TrMat,nTrMat,Ovlp,OneHam,mBT)
************************************************************************
*                                                                      *
*     purpose: Generate transformation matrix from AO's in which       *
*              integrals are computed to orthogonal, symmetry adapted  *
*              (and spherical, if desired) functions - near linear     *
*              dependencies are also removed.                          *
*                                                                      *
*     input:                                                           *
*       Ovlp    : overlap matrix in AO basis of length nOvlp           *
*                                                                      *
*     output:                                                          *
*       TrMat   : Transformation matrix of length nTrMat               *
*                                                                      *
*     called from: Start1, Start3                                      *
*                                                                      *
*     calls to: Freeze, OvlDel, SetUp, Ortho                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
      Real*8 TrMat(nTrMat),Ovlp(mBT),OneHam(mBT)
*
#include "real.fh"

#include "mxdm.fh"
#include "infscf.fh"
*
      ind=0
      Do iSym = 1, nSym
         Do i = 1, nBas(iSym)
            Do j = 1, nBas(iSym)
               ind = ind + 1
               TrMat(ind) = 0.0d+00
               If (I.eq.J) TrMat(ind) = 1.0d+00
            End Do
         End Do
      End Do
*
*---- Set up certain parameters (nOrb(i) may be changed)
      Call SetUp
*
*---- Move frozen atomic orbitals to the begining
      If (nnFr.gt.0) Then
         Call Freeze(TrMat,nBO,OneHam,mBT)
         Call SetUp
      End If
*
*---- Remove near linear dependencies from basis set
      If (DelThr.ne.0.0d+00) Then
         Call OvlDel(Ovlp,nBT,TrMat,nBO)
         Call SetUp
      End If
*
*---- Orthogonalize final orbitals
      Call Ortho(TrMat,nBO,Ovlp,nBT)
*
      End subroutine TrGen

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ComputeFuncER(ERFun,CMO,nBas,nOcc,nFro,nSym,Timing)
C
C     Thomas Bondo Pedersen, November 2005.
C
C     Purpose: compute Edmiston-Ruedenberg functional.
C
C     =====================================================
C        WORKS *ONLY* WITH CHOLESKY DECOMPOSED INTEGRALS
C     =====================================================
C
      Implicit None
      Real*8  ERFun
      Real*8  CMO(*)
      Integer nSym
      Integer nBas(nSym), nOcc(nSym), nFro(nSym)
      Logical Timing
#include "WrkSpc.fh"

      Character*13 SecNam
      Parameter (SecNam = 'ComputeFuncER')

      Character*80 Txt

      Real*8 FracMem

      Integer irc, ipERFun, lERFun, iSym, i, kOff, nFroT
      Integer nOccT(8)

C     Initializations.
C     ----------------

      irc = 0

      FracMem = 0.0d0 ! no buffer allocated
      Call Cho_X_Init(irc,FracMem)
      If (irc .ne. 0) Then
         Write(Txt,'(A,I4)') 'Cho_X_Init returned',irc
         Call SysAbendMsg(SecNam,'Cholesky initialization failure!',Txt)
      End If

C     Check dimensions.
C     -----------------

      Call ERChk_Localisation(irc,nBas,nOcc,nFro,nSym)
      If (irc .ne. 0) Then
         Write(Txt,'(A,I4)') 'ERChk_Localisation returned',irc
         Call SysAbendMsg(SecNam,'Cholesky initialization mismatch!',
     &                    Txt)
      End If

C     Compute ER functional.
C     ----------------------

      nOccT(1) = nOcc(1) + nFro(1)
      Do iSym = 2,nSym
         nOccT(iSym) = nOcc(iSym) + nFro(iSym)
      End Do

      lERFun = nOccT(1)
      nFroT = nFro(1)
      Do iSym = 2,nSym
         lERFun = lERFun + nOccT(iSym)
         nFroT = nFroT + nFro(iSym)
      End Do

      Call GetMem('ERFun','Allo','Real',ipERFun,lERFun)
      ERFun = 0.0d0
      Call EvalERFun(ERFun,Work(ipERFun),CMO,nOccT,nSym,Timing)
      If (nFroT .gt. 0) Then
         kOff = ipERFun - 1
         Do iSym = 1,nSym
            Do i = 1,nFro(iSym)
               ERFun = ERFun - Work(kOff+i)
            End Do
            kOff = kOff + nOccT(iSym)
         End Do
      End If
      Call GetMem('ERFun','Free','Real',ipERFun,lERFun)

C     Finalizations.
C     --------------

      Call Cho_X_Final(irc)
      If (irc .ne. 0) Then
         Write(Txt,'(A,I4)') 'Cho_X_Final returned',irc
         Call SysAbendMsg(SecNam,'Cholesky finalization failure!',Txt)
      End If

      End
      SubRoutine ERChk_Localisation(irc,lnBas,lnOcc,lnFro,lnSym)
      Implicit None
      Integer irc, lnSym
      Integer lnBas(lnSym), lnOcc(lnSym), lnFro(lnSym)
#include "cholesky.fh"
#include "choorb.fh"

      Integer iSym, nTst

      irc = 0

      If (lnSym.lt.1 .or. lnSym.gt.8) Then
         irc = 1
         Return
      End If

      If (lnSym .ne. nSym) Then
         irc = 2
         Return
      End If

      Do iSym = 1,nSym
         If (lnBas(iSym) .ne. nBas(iSym)) Then
            irc = 3
            Return
         End If
         nTst = lnOcc(iSym)+lnFro(iSym)
         If (nTst .gt. nBas(iSym)) Then
            irc = 4
            Return
         End If
      End Do

      End
      SubRoutine EvalERFun(ERFun,ERFunC,CMO,nOcc,nSym,Timing)
      Implicit None
      Real*8  ERFun
      Real*8  ERFunC(*), CMO(*)
      Integer nSym
      Integer nOcc(nSym)
      Logical Timing

      Character*9 SecNam
      Parameter (SecNam = 'EvalERFun')

      Character*80 Txt
      Integer irc

      irc = 0
      Call Cho_Get_ER(irc,CMO,nOcc,ERFunC,ERFun,Timing)
      If (irc .ne. 0) Then
         Write(Txt,'(A,I4)') 'Cho_Get_ER returned',irc
         Call SysAbendMsg(SecNam,'ER evaluation failed!',
     &                    Txt)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
************************************************************************
      Subroutine C1DIIS(q,nInter,nIter,dq,H,g,error,B,RHS,
     &                  nFix,iP,MinWdw)
************************************************************************
*                                                                      *
*         References:                                                  *
*           C1-DIIS: P. Csaszar and P. Pulay, J. Mol. Struc.           *
*                    114, 31-34 (1984).                                *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             December 1994                                            *
************************************************************************
      use Slapaf_Parameters, only: iOptC
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
      Real*8 q(nInter,nIter+1), dq(nInter,nIter),
     &       H(nInter,nInter), g(nInter,nIter+1),
     &       error(nInter,nIter), B((nIter+1)*(nIter+1)), RHS(nIter+1)
      Integer   iP(nIter), iRc
      Real*8, Allocatable:: A(:)
*
*     Statement function
*
      ij(i,j,lda)= (j-1)*lda + i
*
      iRout = 114
      iPrint = nPrint(iRout)
*
      Call mma_allocate(A,nInter**2,Label='A')
      call dcopy_(nInter**2,H,1,A,1)
      iRc = 0
      call dpotrf_('U',nInter,A,nInter,iRC)
      If (iRC.ne.0) Then
         Write (6,*) 'C1DIIS(DPOTRF): iRC=',iRC
         Call Abend()
      End If
*
*-----Compute the new set of error vectors
*
      call dcopy_(nInter*nIter,g,1,Error,1)
      iRc = 0
      Call DPOTRS('U',nInter,nIter,A,nInter,Error,nInter,iRC)
      If (iRC.ne.0) Then
         Write (6,*) 'C1DIIS(DPOTRS): iRC=',iRC
         Call Abend()
      End If
      If (iPrint.ge.99) Call RecPrt(' Error vectors',' ',
     &    error,nInter,nIter)
*
*-----Set up small system of linear equations
*     If more error vectors than degrees of freedom
*     exclude those with large error.
*
      Do 400 i = 1, nIter
         iP(i) = i
 400  Continue
*
*
*-----Bubble sort index array with respect to the magnitude of the
*     error vector.
*
      Do 405 i = 1, nIter-1
         If (iAnd(iOptC,16).eq.16) Then
            Err1 = DDot_(nInter,Error(1,iP(i)),1,
     &                         Error(1,iP(i)),1)
         Else If (iAnd(iOptC,32).eq.32) Then
            Err1 = DDot_(nInter,Error(1,iP(i)),1,
     &                             g(1,iP(i)),1)
         Else If (iAnd(iOptC,64).eq.64) Then
            Err1 = DDot_(nInter,    g(1,iP(i)),1,
     &                             g(1,iP(i)),1)
         Else
            Err1 = Zero
            Call WarningMessage(2,' Illegal iOptC setting!')
            Call Abend()
         End If
         ii = i
         Do 406 j = i+1, nIter
            If (iAnd(iOptC,16).eq.16) Then
               Err2 = DDot_(nInter,Error(1,iP(j)),1,
     &                            Error(1,iP(j)),1)
            Else If (iAnd(iOptC,32).eq.32) Then
               Err2 = DDot_(nInter,Error(1,iP(j)),1,
     &                                g(1,iP(j)),1)
            Else If (iAnd(iOptC,64).eq.64) Then
               Err2 = DDot_(nInter,    g(1,iP(j)),1,
     &                                g(1,iP(j)),1)
            Else
               Err2=Zero
               Call WarningMessage(2,' Illegal iOptC setting!')
               Call Abend()
            End If
            If (Err2.gt.Err1) Then
               ii = j
               Err1 = Err2
            End If
 406     Continue
         If (ii.ne.i) Then
            iSave = iP(i)
            iP(i) = iP(ii)
            iP(ii) = iSave
         End If
 405  Continue
      If (iPrint.ge.99) Write (6,*) ' iP=',iP
*
      MaxWdw=Max(2,(nInter-nFix)/2)
      mIter=Min(nIter,Min(MinWdw,MaxWdw))
      iOff = Max(0,nIter-mIter)
      B(ij(mIter+1,mIter+1,mIter+1)) = Zero
      RHS(mIter+1)       = -One
      Do 100 i = 1, mIter
         Do 110 j = 1, i-1
            If (iAnd(iOptC,16).eq.16) Then
               B(ij(i,j,mIter+1)) = DDot_(nInter,error(1,iP(i+iOff)),1,
     &                                          error(1,iP(j+iOff)),1)
            Else If (iAnd(iOptC,32).eq.32) Then
               B(ij(i,j,mIter+1)) = DDot_(nInter,error(1,iP(i+iOff)),1,
     &                                              g(1,iP(j+iOff)),1)
            Else If (iAnd(iOptC,64).eq.64) Then
               B(ij(i,j,mIter+1)) = DDot_(nInter,    g(1,iP(i+iOff)),1,
     &                                              g(1,iP(j+iOff)),1)
            Else
               Call WarningMessage(2,' Illegal iOptC setting!')
               Call Abend()
            End If
            B(ij(j,i,mIter+1)) = B(ij(i,j,mIter+1))
 110     Continue
         If (iAnd(iOptC,16).eq.16) Then
            B(ij(i,i,mIter+1)) = DDot_(nInter,error(1,iP(i+iOff)),1,
     &                                       error(1,iP(i+iOff)),1)
         Else If (iAnd(iOptC,32).eq.32) Then
            B(ij(i,i,mIter+1)) = DDot_(nInter,error(1,iP(i+iOff)),1,
     &                                           g(1,iP(i+iOff)),1)
         Else If (iAnd(iOptC,64).eq.64) Then
            B(ij(i,i,mIter+1)) = DDot_(nInter,    g(1,iP(i+iOff)),1,
     &                                           g(1,iP(i+iOff)),1)
         Else
            Call WarningMessage(2,' Illegal iOptC setting!')
            Call Abend()
         End If
         B(ij(i,mIter+1,mIter+1)) = -One
         B(ij(mIter+1,i,mIter+1)) = -One
         RHS(i)       = Zero
 100  Continue
      If (iPrint.ge.99) Then
         Call RecPrt(' The B Matrix',' ',B,mIter+1,mIter+1)
         Call RecPrt(' The RHS',' ',RHS,1,mIter+1)
      End If
*
*-----Solve linear equation system
*
      Call Gauss(mIter+1,mIter+1,B,RHS,RHS)
      If (iPrint.ge.99) Call RecPrt(' The solution vector',
     &   ' ',RHS,1,mIter+1)
*
*-----Compute the interpolated parameter vector and
*     the interpolated gradient vector.
*
      call dcopy_(nInter,[Zero],0,q(1,nIter+1),1)
      call dcopy_(nInter,[Zero],0,g(1,nIter+1),1)
      Do 200 jIter = 1, mIter
         Call DaXpY_(nInter,RHS(jIter),q(1,iP(jIter+iOff)),1,
     &              q(1,nIter+1),1)
         Call DaXpY_(nInter,RHS(jIter),g(1,iP(jIter+iOff)),1,
     &              g(1,nIter+1),1)
 200  Continue
      If (iPrint.ge.99) Then
         Call RecPrt(' The ipv',' ',q(1,nIter+1),1,nInter)
         Call RecPrt(' The igv',' ',g(1,nIter+1),1,nInter)
      End If
*
*-----Compute a new independent geometry by relaxation of
*     the interpolated gradient vector.
*
      call dcopy_(nInter,g(1,nIter+1),1,dq(1,nIter),1)
      Call DPOTRS('U',nInter,1,A,nInter,dq(1,nIter),nInter,iRC)
      If (iRC.ne.0) Then
         Write (6,*) 'C1DIIS(DPOTRS): iRC=',iRC
         Call Abend()
      End If
      If (iPrint.ge.99) Call RecPrt(' dq',' ',dq(1,nIter),1,nInter)
*
*     The shift is relative to the interpolated parameter
*     vector and we have to change it so that it is relative to the
*     actual parameter vector.
*
      Do 600 iInter = 1, nInter
         dq(iInter,nIter) =  dq(iInter,nIter) + q(iInter,nIter+1) -
     &                                          q(iInter,nIter  )
 600  Continue
      If (iPrint.ge.99) Call RecPrt(' dq(corr.)',' ',
     &   dq(1,nIter),1,nInter)
*
      Call mma_deallocate(A)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!***********************************************************************

#include "macros.fh"
#include "compiler_features.h"

module CC_CI_mod

use Index_Functions, only: nTri_Elem_Rev
use Para_Info, only: MyRank
use filesystem, only: get_errno_, getcwd_, real_path, strerror_
use linalg_mod, only: abort_, verify_
use rasscf_global, only: EMY, Ener, iter, KSDFT, lRoots, nAc, nAcPar, nAcPr2, nroots, S
use general_data, only: iSpin, nActEl, nAsh, nConf, nSym, ntot, ntot1, ntot2
use gas_data, only: iDoGas, ngssh
use generic_CI, only: CI_solver_t
use index_symmetry, only: one_el_idx, two_el_idx_flatten
use rctfld_module, only: lRF
use CI_solver_util, only: CleanMat, RDM_to_runfile, wait_and_read, write_RDM
#ifdef _MOLCAS_MPP_
use MPI_Wrapper, only: MPI_Bcast, MPI_COMM_WORLD, MPI_REAL8
use Para_Info, only: Is_Real_Par
use Definitions, only: MPIInt
#endif
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
private

public :: Do_CC_CI, CC_CI_solver_t, write_RDM

logical(kind=iwp) :: Do_CC_CI = .false.

interface
  function isfreeunit(iseed)
    import :: iwp
    integer(kind=iwp) :: isfreeunit
    integer(kind=iwp), intent(in) :: iseed
  end function
end interface

type, extends(CI_solver_t) :: CC_CI_solver_t
contains
  procedure :: run => CC_CI_ctl
  procedure :: cleanup
end type

interface CC_CI_solver_t
  module procedure :: construct_CC_CI_solver_t
end interface

contains

subroutine CC_CI_ctl(this,actual_iter,ifinal,iroot,weight,CMO,DIAF,D1I_AO,D1A_AO,TUVX,F_IN,D1S_MO,DMAT,PSMAT,PAMAT)

  use fcidump_reorder, only: get_P_GAS, get_P_inp, ReOrFlag, ReOrInp
  use fcidump, only: make_fcidumps, transform

  class(CC_CI_solver_t), intent(in) :: this
  integer, intent(in) :: actual_iter, ifinal, iroot(nroots)
  real(kind=wp), intent(in) :: weight(nroots), CMO(nTot2), DIAF(nTot), D1I_AO(nTot2), D1A_AO(nTot2), TUVX(nAcpr2)
  real(kind=wp), intent(inout) :: F_In(nTot1), D1S_MO(nAcPar)
  real(kind=wp), intent(out) :: DMAT(nAcpar), PSMAT(nAcpr2), PAMAT(nAcpr2)
# ifdef _MOLCAS_MPP_
  integer(kind=MPIInt) :: error
# endif
  real(kind=wp) :: energy(nroots), folded_Fock(nAcPar), orbital_E(nTot)
  integer(kind=iwp), allocatable :: permutation(:)
  character(len=*), parameter :: ascii_fcidmp = 'FCIDUMP', h5_fcidmp = 'H5FCIDUMP'

  unused_var(this)
  unused_var(ifinal)
  unused_var(weight)

  if (size(iroot) >= 2) call abort_('SA-CC-CASSCF yet to be implemented.')

  ! SOME DIRTY SETUPS
  S = Half*real(iSpin-1,kind=wp)

  call check_options(lRoots,lRf,KSDFT,iDoGAS)

  ! Produce a working FCIDUMP file
  if (ReOrFlag /= 0) then
    allocate(permutation(sum(nAsh(:nSym))))
    if (ReOrFlag >= 2) permutation(:) = get_P_inp(ReOrInp)
    if (ReOrFlag == -1) permutation(:) = get_P_GAS(nGSSH)
  end if

  ! This call is not side effect free, sets EMY and modifies F_IN
  call transform(actual_iter,CMO,DIAF,D1I_AO,D1A_AO,D1S_MO,F_IN,orbital_E,folded_Fock)

  ! Fortran Standard 2008 12.5.2.12:
  ! Allocatable actual arguments that are passed to
  ! non-allocatable, optional dummy arguments are **not** present.
  call make_fcidumps(ascii_fcidmp,h5_fcidmp,orbital_E,folded_Fock,TUVX,EMY,permutation)

  ! Run CC
# ifdef _MOLCAS_MPP_
  if (is_real_par()) call MPI_Barrier(MPI_COMM_WORLD,error)
# endif

  call run_CC_CI(ascii_fcidmp,h5_fcidmp,fake_run=actual_iter == 1,energy=energy,D1S_MO=D1S_MO,DMAT=DMAT,PSMAT=PSMAT,PAMAT=PAMAT)
  ENER(1:lRoots,ITER) = energy(1:lRoots)

  if (nAsh(1) /= nac) call dblock(dmat)

end subroutine CC_CI_ctl

subroutine run_CC_CI(ascii_fcidmp,h5_fcidmp,fake_run,energy,D1S_MO,DMAT,PSMAT,PAMAT)

  character(len=*), intent(in) :: ascii_fcidmp, h5_fcidmp
  logical(kind=iwp), intent(in) :: fake_run
  real(kind=wp), intent(out) :: energy(nroots), D1S_MO(nAcPar), DMAT(nAcpar), PSMAT(nAcpr2), PAMAT(nAcpr2)
  real(kind=wp) :: previous_energy(nroots)
  character(len=*), parameter :: energy_file = 'NEWCYCLE', input_name = 'CC_CI.inp'

  if (fake_run) then
    energy(:) = previous_energy(:)
  else
    call make_inp(input_name)
    if (myrank == 0) call write_user_message(input_name,ascii_fcidmp,h5_fcidmp)
    call wait_and_read(energy_file,energy)
    previous_energy = energy
  end if
  call read_CC_RDM(DMAT,D1S_MO,PSMAT,PAMAT)
  call RDM_to_runfile(DMAT,D1S_MO,PSMAT,PAMAT)

end subroutine run_CC_CI

subroutine make_inp(input_name)

  character(len=*), intent(in) :: input_name

  write(u6,*) input_name
  call abort_('make_inp has to be implemented.')

end subroutine

subroutine cleanup(this)

  use fcidump, only: fcidump_cleanup => cleanup

  class(CC_CI_solver_t), intent(inout) :: this

  unused_var(this)
  call fcidump_cleanup()

end subroutine cleanup

function construct_CC_CI_solver_t() result(res)

  type(CC_CI_solver_t) :: res

# if defined (_WARNING_WORKAROUND_) && ! defined (EMPTY_TYPE_INIT)
  res = res
# else
  unused_var(res)
# endif
  ! Due to possible size of active space, arrays of nConf size
  ! need to be avoided.  For this reason set nConf to zero.
  write(u6,*) ' DCC-CI activated. List of Confs might get lengthy.'
  write(u6,*) ' Number of Configurations computed by GUGA: ',nConf
  write(u6,*) ' nConf variable is set to zero to avoid JOBIPH i/o'
  nConf = 0

end function

subroutine check_options(lroots,lRf,KSDFT,DoGAS)

  integer(kind=iwp), intent(in) :: lroots
  logical(kind=iwp), intent(in) :: lRf, DoGAS
  character(len=*), intent(in) :: KSDFT
  logical(kind=iwp) :: Do_ESPF

  call verify_(lroots == 1,"CC-CI doesn't support State Average!")

  call DecideOnESPF(Do_ESPF)
  if (lRf .or. (KSDFT /= 'SCF') .or. Do_ESPF) call abort_('CC CI does not support Reaction Field yet!')

  call verify_(.not. DoGAS,'CC CI does not support GASSCF yet!')

end subroutine check_options

subroutine write_user_message(input_name,ascii_fcidmp,h5_fcidmp)

  character(len=*), intent(in) :: input_name, ascii_fcidmp, h5_fcidmp
  integer(kind=iwp) :: err
  character(len=1024) :: WorkDir

  call getcwd_(WorkDir,err)
  if (err /= 0) write(u6,*) strerror_(get_errno_())

  write(u6,'(A)') 'Run coupled cluster CI externally.'
  write(u6,'(A)') 'Get the (example) coupled cluster input:'
  write(u6,'(4x, A, 1x, A, 1x, A)') 'cp',real_path(input_name),'$CC_RUN_DIR'
  write(u6,'(A)') 'Get the ASCII formatted FCIDUMP:'
  write(u6,'(4x, A, 1x, A, 1x, A)') 'cp',real_path(ascii_fcidmp),'$CC_RUN_DIR'
  write(u6,'(A)') 'Or the HDF5 FCIDUMP:'
  write(u6,'(4x, A, 1x, A, 1x, A)') 'cp',real_path(h5_fcidmp),'$CC_RUN_DIR'
  write(u6,*)
  write(u6,'(A)') 'When finished do:'
  ! TODO(Oskar, Thomas): Change accordingly
  write(u6,'(4x, A)') 'cp PSMAT.dat PAMAT.dat '//trim(WorkDir)
  write(u6,'(4x, A)') 'echo $your_RDM_Energy > '//real_path('NEWCYCLE')
  call xflush(u6)

end subroutine write_user_message

!>  @brief
!>    Read DCC RDM files
!>
!>  @author Oskar Weser
!>
!>  @param[out] DMAT Average 1 body density matrix
!>  @param[out] D1S_MO Average spin 1-dens matrix
!>  @param[out] PSMAT Average symm. 2-dens matrix
!>  @param[out] PAMAT Average antisymm. 2-dens matrix
subroutine read_CC_RDM(DMAT,D1S_MO,PSMAT,PAMAT)

  real(kind=wp), intent(out) :: DMAT(nAcpar), D1S_MO(nAcPar), PSMAT(nAcpr2), PAMAT(nAcpr2)
# ifdef _MOLCAS_MPP_
  integer(kind=MPIInt) :: error
# endif

  if (myrank == 0) then
    call read_2RDM('PSMAT.dat',PSMAT)
    call read_2RDM('PAMAT.dat',PAMAT)
    call calc_1RDM(PSMAT,DMAT)
    call cleanMat(DMAT)
  end if
  ! No spin resolved RDMs available at the moment.
  D1S_MO(:) = Zero
  ! Could be changed into non blocking BCast
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    call MPI_Bcast(PSMAT,size(PSMAT,kind=MPIInt),MPI_REAL8,0_MPIInt,MPI_COMM_WORLD,error)
    call MPI_Bcast(PAMAT,size(PAMAT,kind=MPIInt),MPI_REAL8,0_MPIInt,MPI_COMM_WORLD,error)
    call MPI_Bcast(DMAT,size(DMAT,kind=MPIInt),MPI_REAL8,0_MPIInt,MPI_COMM_WORLD,error)
  end if
# endif

end subroutine read_CC_RDM

subroutine calc_1RDM(PSMAT,DMAT)

# ifdef _ADDITIONAL_RUNTIME_CHECK_
  use Index_Functions, only: nTri_Elem
# endif

  real(kind=wp), intent(in) :: PSMAT(:)
  real(kind=wp), intent(out) :: DMAT(:)
  integer(kind=iwp) :: p, pq, q, r
  debug_function_name('calc_1RDM')

  ASSERT(size(PSMAT) == nTri_Elem(size(DMAT)))

  DMAT(:) = Zero
  do pq=1,size(DMAT)
    call one_el_idx(pq,p,q)
    do r=1,nTri_Elem_Rev(size(DMAT))
      DMAT(pq) = DMAT(pq)+PSMAT(two_el_idx_flatten(p,q,r,r))
    end do
  end do
  DMAT(:) = DMAT(:)*Two/real(nActEl-1,kind=wp)

end subroutine calc_1RDM

subroutine read_2RDM(path,RDM_2)

  character(len=*), intent(in) :: path
  real(kind=wp), intent(out) :: RDM_2(:)
  integer(kind=iwp) :: curr_line, file_id, i, io_err, n_lines
  integer(kind=iwp), parameter :: arbitrary_magic_number = 42

  ASSERT(size(RDM_2) == nAcpr2)
  n_lines = nTri_Elem_Rev(nAcpr2)

  file_id = isfreeunit(arbitrary_magic_number)
  i = 1
  call molcas_open(file_id,trim(path))
  do curr_line=1,n_lines
    read(file_id,*,iostat=io_err) RDM_2(i:i+curr_line-1)
    call verify_(io_err == 0,'Error on reading 2-RDMs.')
    i = i+curr_line
  end do
  close(file_id)

end subroutine read_2RDM

end module CC_CI_mod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkQ3(V)
! Q1(a,b,c,l) <- V(ab,cl)

use Index_Functions, only: nTri_Elem
use chcc_global, only: no, nv, Q3
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: V(nTri_Elem(nv),no,nv)
integer(kind=iwp) :: a, ab, l

call mma_allocate(Q3,nv,nv,nv,no,label='Q3')

do l=1,no
  ab = 0
  do a=1,nv
    Q3(a,1:a-1,:,l) = V(ab+1:ab+a-1,l,:)
    Q3(1:a,a,:,l) = V(ab+1:ab+a,l,:)
    ab = ab+a
  end do
end do

return

end subroutine MkQ3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GetMassDx(Mass,natom)
      USE Isotopes
      IMPLICIT NONE
#include "stdalloc.fh"
      REAL*8, INTENT(INOUT) :: Mass(*)
      INTEGER, INTENT(IN) :: natom
      INTEGER :: matom,i,Iso
      CHARACTER, ALLOCATABLE :: atom(:)*2

      CALL mma_allocate(atom,natom)
      CALL Get_Name_Full(atom)
      CALL Get_nAtoms_All(matom)
      CALL Get_Mass_All(Mass,matom)
      DO i=1,natom
        IF (i.GT.matom) THEN
          CALL LeftAd(atom(i))
          Iso=0
          CALL Isotope(Iso,atom(i),Mass(i))
        END IF
      END DO
      CALL mma_deallocate(atom)

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_PRTDIA(DIAG,ISYLST,NSYLST,IRED)
C
C     Purpose: print requested symmetry block(s) of diagonal in
C              first (IRED=1) or current (IRED=2) reduced set.
C
#include "implicit.fh"
      DIMENSION DIAG(*)
      INTEGER   ISYLST(NSYLST)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_PRTDIA')

      IIBSTRSH(I,J,K)=IWORK(ip_IIBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)
      INDRSH(I)=IWORK(ip_INDRSH-1+I)
      ISP2F(I)=IWORK(ip_iSP2F-1+I)

C     Check dimension of symmetry list.
C     ---------------------------------

      IF (NSYLST .LT. 1) THEN
         RETURN
      ELSE IF (NSYLST .GT. NSYM) THEN
         WRITE(LUPRI,'(//,1X,A,A)') SECNAM,': NSYLST <= NSYM required!'
         WRITE(LUPRI,'(1X,A,I10)')    'NSYLST = ',NSYLST
         WRITE(LUPRI,'(1X,A,I10,/)')  'NSYM   = ',NSYM
         CALL CHO_QUIT('[0] Symmetry error in '//SECNAM,102)
      END IF

C     Code for first or current reduced set.
C     --------------------------------------

      IF (IRED .EQ. 1) THEN
         CALL CHO_HEAD(SECNAM//': Diagonal in Original Reduced Set',
     &                 '=',80,LUPRI)
         DO ILST = 1,NSYLST
            ISYM = ISYLST(ILST)
            IF (ISYM.LT.1 .OR. ISYM.GT.NSYM) THEN
               WRITE(LUPRI,*) SECNAM,': element ',ILST,': ',ISYM,
     &                        ' of list ISYLST is out of bounds!'
               CALL CHO_QUIT('ISYLST input error in '//SECNAM,104)
            ELSE
               WRITE(LUPRI,'(/,A,I2)') 'Symmetry block:',ISYM
               WRITE(LUPRI,'(/,A,/,A)')
     &         '  Element Shell-Pair  SP Index         Diagonal',
     &         '-----------------------------------------------'
               DO ISHLAB = 1,NNSHL
                  IAB1 = IIBSTR(ISYM,IRED) + IIBSTRSH(ISYM,ISHLAB,IRED)
     &                 + 1
                  IAB2 = IAB1 + NNBSTRSH(ISYM,ISHLAB,IRED) - 1
                  DO IAB = IAB1,IAB2
                     IF (INDRSH(IAB) .NE. ISP2F(ISHLAB)) THEN
                        WRITE(LUPRI,*)
     &                  'Shell Pair error: INDRSH,ISP2F,ISHLAB',
     &                  INDRSH(IAB),ISP2F(ISHLAB),ISHLAB
                        CALL CHO_QUIT('Shell-Pair error in '//SECNAM,
     &                                104)
                     ELSE
                        JAB = IAB
                        WRITE(LUPRI,'(I9,2X,I9,1X,I9,1X,1P,D16.8)')
     &                  JAB,ISP2F(ISHLAB),INDRED(IAB,IRED),DIAG(JAB)
                     END IF
                  END DO
               END DO
               WRITE(LUPRI,'(A)')
     &         '-----------------------------------------------'
            END IF
         END DO
      ELSE IF (IRED .EQ. 2) THEN
         CALL CHO_HEAD(SECNAM//': Diagonal in Current Reduced Set',
     &                 '=',80,LUPRI)
         DO ILST = 1,NSYLST
            ISYM = ISYLST(ILST)
            IF (ISYM.LT.1 .OR. ISYM.GT.NSYM) THEN
               WRITE(LUPRI,*) SECNAM,': element ',ILST,': ',ISYM,
     &                        ' of list ISYLST is out of bounds!'
               CALL CHO_QUIT('ISYLST input error in '//SECNAM,104)
            ELSE
               WRITE(LUPRI,'(/,A,I2)') 'Symmetry block:',ISYM
               WRITE(LUPRI,'(/,A,A,/,A,A)')
     &         '  Element  RedSet 1 Shell-Pair  SP Index',
     &         '         Diagonal',
     &         '----------------------------------------',
     &         '-----------------'
               DO ISHLAB = 1,NNSHL
                  IAB1 = IIBSTR(ISYM,IRED) + IIBSTRSH(ISYM,ISHLAB,IRED)
     &                 + 1
                  IAB2 = IAB1 + NNBSTRSH(ISYM,ISHLAB,IRED) - 1
                  DO IAB = IAB1,IAB2
                     JAB = INDRED(IAB,IRED)
                     IF (INDRSH(JAB) .NE. ISP2F(ISHLAB)) THEN
                        WRITE(LUPRI,*)
     &                  'Shell Pair error: INDRSH,ISP2F,ISHLAB',
     &                  INDRSH(JAB),ISP2F(ISHLAB),ISHLAB
                        CALL CHO_QUIT('Shell-Pair error in '//SECNAM,
     &                                104)
                     ELSE
                       WRITE(LUPRI,'(I9,1X,I9,2X,I9,1X,I9,1X,1P,D16.8)')
     &                  IAB,JAB,ISP2F(ISHLAB),INDRED(JAB,1),DIAG(JAB)
                     END IF
                  END DO
               END DO
               WRITE(LUPRI,'(A,A)')
     &         '----------------------------------------',
     &         '-----------------'
            END IF
         END DO
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_W3(W3,dima,dimbe,dimb,adda,addbe,addb)
! this routine tests W3 (a,be|b,i)

use chcc_global, only: no, Q3
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dima, dimbe, dimb, adda, addbe, addb
real(kind=wp), intent(in) :: W3(dima,dimbe,dimb,no)
integer(kind=iwp) :: a, b, bad, be, i, ntot
real(kind=wp) :: s

bad = 0
ntot = 0

do i=1,no
  do b=1,dimb
    do be=1,dimbe
      do a=1,dima
        s = Q3(a+adda,be+addbe,b+addb,i)
        if (abs(W3(a,be,b,i)-s) > 1.0e-10_wp) then
          bad = bad+1
          !W3(a,be,b,i) = s
        end if
        ntot = ntot+1
      end do
    end do
  end do
end do

write(u6,*) ' W3 test ',bad,ntot

return

end subroutine Chck_W3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION CHO_ISAOSH(IAO,ISHL)
C
C     Purpose: return symmetry of AO number IAO in shell ISHL.
C
#if defined (_DEBUGPRINT_)
      use ChoArr, only: nBstSh
#endif
      use ChoArr, only: iBasSh
#include "implicit.fh"
#include "cholesky.fh"

      INTEGER  CHO_IRANGE
      EXTERNAL CHO_IRANGE

#if defined (_DEBUGPRINT_)
      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_ISAOSH')

      IF ((ISHL.GT.NSHELL) .OR. (ISHL.LT.1)) THEN
         WRITE(LUPRI,'(//,1X,A,A,I10)')
     &   SECNAM,': shell index out of bounds: ',ISHL
         WRITE(LUPRI,'(A,I10,A,/)')
     &   'Maximum possible: NSHELL = ',NSHELL,'(from common block)'
         IF (NSHELL .LT. 1) THEN
            CALL CHO_QUIT('Initialization error detected in '//SECNAM,
     &                    102)
         ELSE
            CALL CHO_QUIT('Internal error detected in '//SECNAM,
     &                    103)
         END IF
      ELSE IF ((IAO.GT.NBSTSH(ISHL)) .OR. (IAO.LT.1)) THEN
         WRITE(LUPRI,'(//,1X,A,A,I10)')
     &   SECNAM,': AO index out of bounds: ',IAO,' shell: ',ISHL
         WRITE(LUPRI,'(A,I10,A,/)')
     &   'Maximum possible: NBSTSH(ISHL) = ',NBSTSH(ISHL),
     &   '(from common block)'
         IF (NBSTSH(ISHL) .LT. 1) THEN
            CALL CHO_QUIT('Initialization error detected in '//SECNAM,
     &                    102)
         ELSE
            CALL CHO_QUIT('Internal error detected in '//SECNAM,
     &                    103)
         END IF
      END IF
#endif

      CHO_ISAOSH = CHO_IRANGE(IAO,IBASSH(1,ISHL),NSYM,.FALSE.)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SORT_MRCI(BUFS,INDS,FC,FIIJJ,FIJIJ)

use mrci_global, only: IAD25S, ICH, IPRINT, IROW, ITOC17, LASTAD, LN, Lu_25, Lu_60, LUONE, LUTRA, MCHAIN, NBITM3, NBTRI, NCHN3, &
                       NELEC, NORB, NORBT, NSM, NSYM, NTIBUF, NVIR, NVIRP, NVIRT, POTNUC, TIBUF
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(out) :: BUFS(NBITM3,NCHN3), FC(NBTRI)
integer(kind=iwp), intent(out) :: INDS(NBITM3+2,NCHN3)
real(kind=wp), intent(_OUT_) :: FIIJJ(*), FIJIJ(*)
#include "tratoc.fh"
#include "warnings.h"
integer(kind=iwp) :: I, IAD50, IADD17, IADD25, IBUF, IDISK, IEXP, IIJ, IIN, IJ, IJT, IKT, INAV, IND, IORBI, IOUT, IPOF(65), IPOS, &
                     ISYM, IVEC(20), J, JDISK, JK, JORBI, KORBI, M1, M2, M3, M4, N1, N2, N3, N4, NAV, NBV, NI, NJ, NK, NL, NOP, &
                     NOQ, NOR, NORB0(9), NORBP, NORBTT, NOS, NOT2, NOTT, NOVST, NSA, NSB, NSIJT, NSP, NSPQ, NSPQR, NSQ, NSR, NSS, &
                     NSSM, NT, NTM, NTMP, NU, NUMAX, NUMIN, NV, NVT, NX, NXM
real(kind=wp) :: DFINI, EFROZ, FINI, ONEHAM

IAD50 = 0
call iDAFILE(LUTRA,2,iTraToc,nTraToc,IAD50)
NVT = IROW(NVIRT+1)
do I=1,20
  IVEC(I) = 0
end do
IIN = 1
do I=1,NSYM
  call IPO(IPOF(IIN),NVIR,MUL,NSYM,I,-1)
  IIN = IIN+NSYM
end do
! ORDER OF RECORD-CHAINS IS
! 1.  NOT2 CHAINS (AB/IJ)
! 2.  NOT2 CHAINS (AI/BJ)
! 3.  NOT2 CHAINS (AI/JK)
! RECORD STRUCTURE IS
! 1.  NBITM3 INTEGRALS
! 2.  NBITM3 INDICES
! 3.  NUMBER OF INTEGRALS IN THIS RECORD
! 4.  ADDRESS OF LAST RECORD
NOT2 = IROW(LN+1)
NOTT = 2*NOT2
NOVST = LN*NVIRT+1+NVT
IDISK = 0

INDS(NBITM3+1,:) = 0
INDS(NBITM3+2,:) = -1
NORB0(1) = 0
do I=1,NSYM
  NORB0(I+1) = NORB0(I)+NORB(I)
end do
! READ ONE-ELECTRON ORBITALS. USE FIIJJ TEMPORARILY AS READ BUFFER.
NORBTT = 0
do ISYM=1,NSYM
  NORBTT = NORBTT+(NORB(ISYM)*(NORB(ISYM)+1))/2
end do
EFROZ = POTNUC
FC(:) = Zero
IADD17 = ITOC17(2)
call dDAFILE(LUONE,2,FIIJJ,NORBTT,IADD17)
IBUF = 0
KORBI = 0
do ISYM=1,NSYM
  do JORBI=KORBI+1,KORBI+NORB(ISYM)
    do IORBI=KORBI+1,JORBI
      IBUF = IBUF+1
      ONEHAM = FIIJJ(IBUF)
      NI = ICH(IORBI)
      NJ = ICH(JORBI)
      if ((NI == 0) .or. (NJ == 0)) cycle
      if (NI < NJ) then
        NTMP = NI
        NI = NJ
        NJ = NTMP
      end if
      if (NJ > 0) then
        IJT = IROW(NI)+NJ
        FC(IJT) = FC(IJT)+ONEHAM
      else if (NI == NJ) then
        EFROZ = EFROZ+2*ONEHAM
      end if
    end do
  end do
  KORBI = KORBI+NORB(ISYM)
end do
if (IPRINT >= 20) then
  call TRIPRT('FC IN SORT_MRCI BEFORE TWOEL',' ',FC,NORBT)
  write(u6,'(A,F20.8)') ' EFROZ:',EFROZ
end if
FIIJJ(1:NBTRI) = Zero
FIJIJ(1:NBTRI) = Zero
! TWO-ELECTRON INTEGRALS
do NSP=1,NSYM
  NOP = NORB(NSP)
  do NSQ=1,NSP
    NSPQ = MUL(NSP,NSQ)
    NOQ = NORB(NSQ)
    do NSR=1,NSP
      NSPQR = MUL(NSPQ,NSR)
      NOR = NORB(NSR)
      NSSM = NSR
      if (NSR == NSP) NSSM = NSQ
      do NSS=1,NSSM
        if (NSS /= NSPQR) cycle
        NOS = NORB(NSS)
        NORBP = NOP*NOQ*NOR*NOS
        if (NORBP == 0) cycle
        call dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
        IOUT = 0
        do NV=1,NOR
          NXM = NOS
          if (NSR == NSS) NXM = NV
          do NX=1,NXM
            NTM = 1
            if (NSP == NSR) NTM = NV
            do NT=NTM,NOP
              NUMIN = 1
              if ((NSP == NSR) .and. (NT == NV)) NUMIN = NX
              NUMAX = NOQ
              if (NSP == NSQ) NUMAX = NT
              do NU=NUMIN,NUMAX
                IOUT = IOUT+1
                if (IOUT > NTIBUF) then
                  call dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
                  IOUT = 1
                end if
                M1 = ICH(NORB0(NSP)+NT)
                M2 = ICH(NORB0(NSQ)+NU)
                M3 = ICH(NORB0(NSR)+NV)
                M4 = ICH(NORB0(NSS)+NX)
                if ((M1 == 0) .or. (M2 == 0)) cycle
                if ((M3 == 0) .or. (M4 == 0)) cycle
                ! ORDER THESE INDICES CANONICALLY
                N1 = max(M1,M2)
                N2 = min(M1,M2)
                N3 = max(M3,M4)
                N4 = min(M3,M4)
                NI = N1
                NJ = N2
                NK = N3
                NL = N4
                if (NI <= NK) then
                  if (NI /= NK) then
                    NI = N3
                    NJ = N4
                    NK = N1
                    NL = N2
                  else if (NJ <= NL) then
                    NL = N2
                    NJ = N4
                  end if
                end if
                FINI = TIBUF(IOUT)
                if ((NI <= 0) .or. (NJ <= 0) .or. (NK <= 0) .or. (NL <= 0)) then
                  ! CHECK FOR FOCK-MATRIX, AND FROZEN ENERGY, CONTRIBUTIONS
                  if (NI < 0) then
                    if ((NI == NJ) .and. (NK == NL)) EFROZ = EFROZ+4*FINI
                    if ((NI == NK) .and. (NJ == NL)) EFROZ = EFROZ-2*FINI
                  else if (NL < 0) then
                    if ((NK == NL) .and. (NJ > 0)) then
                      IJT = IROW(NI)+NJ
                      FC(IJT) = FC(IJT)+2*FINI
                    else if ((NJ == NL) .and. (NK > 0)) then
                      IKT = IROW(NI)+NK
                      FC(IKT) = FC(IKT)-FINI
                    end if
                  end if
                  cycle
                end if
                DFINI = abs(FINI)+1.0e-20_wp
                IEXP = int(-log10(DFINI))+5
                if (IEXP <= 20) IVEC(IEXP) = IVEC(IEXP)+1
                if ((NI == NJ) .and. (NK == NL)) then
                  IJ = IROW(NI)+NK
                  FIIJJ(IJ) = FINI
                  ! SKIP (AA/II) INTEGRALS
                else
                  if ((NI == NK) .and. (NJ == NL)) then
                    IJ = IROW(NI)+NJ
                    FIJIJ(IJ) = FINI
                  end if
                  if (NI <= LN) then
                  else if (NJ > LN) then
                    if (NK > LN) cycle
                    ! ABIJ
                    IIJ = IROW(NK)+NL
                    IPOS = INDS(NBITM3+1,IIJ)+1
                    INDS(NBITM3+1,IIJ) = IPOS
                    BUFS(IPOS,IIJ) = FINI
                    NSA = NSM(NI)
                    NAV = NI-LN-NVIRP(NSA)
                    NSB = NSM(NJ)
                    NBV = NJ-LN-NVIRP(NSB)
                    NSIJT = (MUL(NSM(NK),NSM(NL))-1)*NSYM
                    INAV = IPOF(NSIJT+NSA)+(NBV-1)*NVIR(NSA)+NAV
                    INDS(IPOS,IIJ) = INAV
                    if (IPOS >= NBITM3) then
                      JDISK = IDISK
                      call iDAFILE(Lu_60,1,INDS(1,IIJ),NBITM3+2,IDISK)
                      call dDAFILE(Lu_60,1,BUFS(1,IIJ),NBITM3,IDISK)
                      INDS(NBITM3+1,IIJ) = 0
                      INDS(NBITM3+2,IIJ) = JDISK
                    end if
                    if (NK /= NL) cycle
                    if (NI == NJ) cycle
                    IJT = IROW(NI)+NJ
                    FC(IJT) = FC(IJT)+2*FINI
                  else if (NK > LN) then
                    if (NL > LN) cycle
                    ! AIBJ
                    IIJ = NOT2+IROW(NJ)+NL
                    if (NL > NJ) IIJ = NOT2+IROW(NL)+NJ
                    IPOS = INDS(NBITM3+1,IIJ)+1
                    INDS(NBITM3+1,IIJ) = IPOS
                    BUFS(IPOS,IIJ) = FINI
                    NSA = NSM(NI)
                    NAV = NI-LN-NVIRP(NSA)
                    NSB = NSM(NK)
                    NBV = NK-LN-NVIRP(NSB)
                    NSIJT = (MUL(NSM(NJ),NSM(NL))-1)*NSYM
                    if (NL <= NJ) then
                      INAV = IPOF(NSIJT+NSA)+(NBV-1)*NVIR(NSA)+NAV
                    else
                      INAV = IPOF(NSIJT+NSB)+(NAV-1)*NVIR(NSB)+NBV
                    end if
                    INDS(IPOS,IIJ) = INAV
                    if (IPOS >= NBITM3) then
                      JDISK = IDISK
                      call iDAFILE(Lu_60,1,INDS(1,IIJ),NBITM3+2,IDISK)
                      call dDAFILE(Lu_60,1,BUFS(1,IIJ),NBITM3,IDISK)
                      INDS(NBITM3+1,IIJ) = 0
                      INDS(NBITM3+2,IIJ) = JDISK
                    end if
                    if (NJ /= NL) cycle
                    if (NI == NK) cycle
                    IKT = IROW(NI)+NK
                    FC(IKT) = FC(IKT)-FINI
                  else
                    ! AIJK
                    JK = NOTT+IROW(NK)+NL
                    IPOS = INDS(NBITM3+1,JK)+1
                    INDS(NBITM3+1,JK) = IPOS
                    BUFS(IPOS,JK) = FINI
                    INDS(IPOS,JK) = IROW(NI)+NJ
                    if (IPOS >= NBITM3) then
                      JDISK = IDISK
                      call iDAFILE(Lu_60,1,INDS(1,JK),NBITM3+2,IDISK)
                      call dDAFILE(Lu_60,1,BUFS(1,JK),NBITM3,IDISK)
                      INDS(NBITM3+1,JK) = 0
                      INDS(NBITM3+2,JK) = JDISK
                    end if
                  end if
                end if
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end do
! EMPTY LAST BUFFERS
if ((NOVST+NCHN3) > MCHAIN) then
  write(u6,*) 'SORT_MRCI Error: NOVST+NCHN3>MCHAIN (See code).'
  call QUIT(_RC_GENERAL_ERROR_)
end if
do I=1,NCHN3
  JDISK = IDISK
  call iDAFILE(Lu_60,1,INDS(1,I),NBITM3+2,IDISK)
  call dDAFILE(Lu_60,1,BUFS(1,I),NBITM3,IDISK)
  LASTAD(NOVST+I) = JDISK
end do
do J=1,NORBT
  IND = IROW(J+1)
  FC(IND) = FC(IND)+EFROZ/NELEC
end do
IADD25 = 0
call dDAFILE(Lu_25,1,FC,NBTRI,IADD25)
IAD25S = IADD25
!if (IPRINT >= 2) then
write(u6,154)
write(u6,155) (IVEC(I),I=1,20)
!end if

return

154 format(//6X,'STATISTICS FOR INTEGRALS, FIRST ENTRY 10**3-10**4',/)
155 format(6X,5I10)

end subroutine SORT_MRCI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine rdlow_cvb(vec,n,fileid,ioffset)

use casvb_global, only: filename
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n, ioffset
real(kind=wp), intent(out) :: vec(n)
real(kind=wp), intent(in) :: fileid
integer(kind=iwp) :: ibf, ioffs, lu
logical(kind=iwp) :: newfile
logical(kind=iwp), parameter :: debug = .false.

if (debug) write(u6,*) ' rdlow :',n,fileid,ioffset
call mkfn_cvb(fileid,ibf)
call ibf2unit_cvb(ibf,lu,newfile)

if (newfile) call ioopn_cvb(filename(ibf),lu)

ioffs = ioffset
call dDaFile(lu,2,vec,n,ioffs)

return

end subroutine rdlow_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_SyncDiag(Diag,iLoc)
C
C     Purpose: synchronize global diagonal. Diag is the local diagonal
C              and iLoc tells which memory location to use for reduced
C              set index arrays.
C
      use ChoSwp, only: IndRed, Diag_G
      use ChoArr, only: iL2G
      Implicit None
      Real*8  Diag(*)
      Integer iLoc
#include "cho_para_info.fh"
#include "cholesky.fh"
#include "choglob.fh"

      Integer i, j
      Real*8  c1, c2, w1, w2

C     Skip if serial run.
C     -------------------

      If (.not.Cho_Real_Par) Return
      Call Cho_Timer(c1,w1)

C     Zero all entries in global diagonal.
C     ------------------------------------

      Call FZero(Diag_G,nnBstRT_G(1))

C     Copy elements from local to global diagonal.
C     --------------------------------------------

      If (iLoc .eq. 1) Then
         Do i = 1,nnBstRT(1)
            Diag_G(iL2G(i)) = Diag(i)
         End Do
      Else
         Do j = 1,nnBstRT(iLoc)
            i = IndRed(j,iLoc)
            Diag_G(iL2G(i)) = Diag(i)
         End Do
      End If

C     Synchronize global diagonal.
C     ----------------------------

      Call Cho_GADGop(Diag_G,nnBstRT_G(1),'+')

      Call Cho_Timer(c2,w2)
      tMisc(1,4)=tMisc(1,4)+c2-c1
      tMisc(2,4)=tMisc(2,4)+w2-w1

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE INDMAT_CPF(JSY,INDEX,ISAB,ISMAX,JREFX)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      DIMENSION INDEX(*),JSY(*),ISAB(*),JREFX(*)
      DIMENSION ICOUS(8)
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CRL   JSYM(L)=IAND(ISHFT(JSY((L+19)/20),-3*((L+19)/20*20-L)),7)+1
CPAM96      JSYM(L)=UNPACK(JSY((L+9)/10),3*MOD(L-1,10)+1,3)+1
      JSYM(L)=JSUNP_CPF(JSY,L)
C
C     DETERMINE REFERENCE STATE
      JCONF=ISC(1)
      DO 31 IR=1,JCONF
      IF(JREFX(IR).EQ.1)IREF0=IR
31    CONTINUE
      IF(IPRINT.GT.5)WRITE(6,999)IREF0,(JREFX(IR),IR=1,JCONF)
999   FORMAT(2X,I3,2X,'JREFX',10I5)
C
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      NSYS(1)=0
      IF(NSYM.EQ.1)GO TO 1
      DO 2 I=2,NSYM
      NSYS(I)=NSYS(I-1)+NVIR(I-1)
2     CONTINUE
1     NSYS(NSYM+1)=NVIRT
      DO 5 I=1,NSYM
      ICOUS(I)=0
      NNS(I)=0
5     CONTINUE
      ISMAX=0
      IN0=-NVIRT
      DO 15 NA=1,NVIRT
      IN0=IN0+NVIRT
      IN=IN0
      IN2=-NVIRT+NA
      DO 25 NB=1,NA
      IN=IN+1
      IN2=IN2+NVIRT
      NSAB=MUL(NSM(LN+NA),NSM(LN+NB))
      ICOUS(NSAB)=ICOUS(NSAB)+1
      ISAB(IN)=ICOUS(NSAB)
      IF(ISMAX.LT.ISAB(IN))ISMAX=ISAB(IN)
      ISAB(IN2)=ISAB(IN)
      IF(ISAB(IN).GT.NNS(NSAB))NNS(NSAB)=ISAB(IN)
25    CONTINUE
      NDIAG(NA)=ISAB(IN)
15    CONTINUE
      IND=0
      IR=IRC(1)
      DO 10 II=1,IR
      IND=IND+1
      INDEX(II)=IND
10    CONTINUE
      JSC(1)=IND
      IR1=IR+1
      IR2=IRC(2)
      DO 20 II=IR1,IR2
      INDEX(II)=IND
      NSS=MUL(JSYM(II),LSYM)
      IND=IND+NVIR(NSS)
20    CONTINUE
      JSC(2)=IND
      IF(IFIRST.NE.0)GO TO 22
      IR1=IR2+1
      IR2=IRC(4)
      JSC(3)=IND
      DO 30 II=IR1,IR2
      INDEX(II)=IND
      NSS=MUL(JSYM(II),LSYM)
      IND=IND+ICOUS(NSS)
      IF(II.EQ.IRC(3))JSC(3)=IND
30    CONTINUE
      JSC(4)=IND
22    IX1=JSC(1)
      IX2=JSC(2)-JSC(1)
      WRITE(6,213)
      CALL XFLUSH(6)
213   FORMAT(//,6X,'FULL-SPACE CONFIGURATIONS (REAL)')
      IF(IFIRST.NE.0)GO TO 212
      JJM=(JJS(LSYM+1)-JJS(LSYM))*NVIRT
      IX3=JSC(3)-JSC(2)-JJM
      IX4=JSC(4)-JSC(3)
      WRITE(6,215)IX1,IX2,IX3,IX4
      CALL XFLUSH(6)
215   FORMAT(/,6X,'NUMBER OF VALENCE STATES',I16,
     */,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7,
     */,6X,'NUMBER OF TRIPLET COUPLED DOUBLES',I7,
     */,6X,'NUMBER OF SINGLET COUPLED DOUBLES',I7)
      GO TO 211
212   WRITE(6,216)IX1,IX2
      CALL XFLUSH(6)
216   FORMAT(/,6X,'NUMBER OF VALENCE STATES',I14,
     */,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7)
      JJM=0
211   JSCI=JSC(ILIM)-JJM
      WRITE(6,50)ISC(ILIM),JSCI
      CALL XFLUSH(6)
50    FORMAT(//6X,'FORMAL NUMBER OF CONFIGURATIONS',I8,
     */8X,'REAL NUMBER OF CONFIGURATIONS',I8)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE A_3C_Qv_s(A_3C,Qv,Rv,nMuNu,nI,nK,QMode)
************************************************************************
*
*     Author:  F. Aquilante
*
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Real*8 A_3C(nMuNu,*), Qv(nI,nK), Rv(nMuNu,*)
      Character*1 QMode
*
      If (QMode.eq.'N') Then

        Call DGEMM_('N','N',nMuNu,nK,nI,
     &               1.0d0,A_3C,nMuNu,
     &                     Qv,nI,
     &               0.0d0,Rv,nMuNu)

      ElseIf (QMode.eq.'T') Then

        Call DGEMM_('N','T',nMuNu,nI,nK,
     &               1.0d0,A_3C,nMuNu,
     &                     Qv,nI,
     &               1.0d0,Rv,nMuNu)  ! note that Rv is accumulated

      Else

         Call WarningMessage(2,'A_3C_Qv_s: illegal QMode!')
         Call Abend()
      EndIf
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Markus P. Fuelscher                              *
!               1991, Per Ake Malmqvist                                *
!***********************************************************************

subroutine SORT2A(iBin,lSrtA,SrtArr,IOStk,lStk,nStk)
!***********************************************************************
!                                                                      *
!     Purpose: Reload all integrals belonging to a given slice         *
!              and sort them.                                          *
!                                                                      *
!     Called from: Sort2                                               *
!                                                                      *
!     Calls to : UPkI4,UPkR8,DaFile                                    *
!                                                                      *
!     Calling parameters:                                              *
!     iBin   : Slice number                                            *
!     SrtArr : Work space to keep the 2el integrals                    *
!                                                                      *
!     Global data declarations (Include files) :                       *
!     PkCtl  : packing table                                           *
!                                                                      *
!     local data declarations:                                         *
!     PkVBin : I/O buffer contains packed integral values              *
!     PkIBin : I/O buffer contains packed ordering numbers             *
!                                                                      *
!*** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****

use sort_data, only: iDaTmp, iDaTwo, iDIBin, iDVBin, IndBin, lBin, lDaRec, lStRec, lTop, LuTmp, LuTwo, mInt, nSect, ValBin
use Definitions, only: wp, iwp, u6, ItoB, RtoB

implicit none
integer(kind=iwp), intent(in) :: iBin, lSrtA, lStk
real(kind=wp), intent(inout) :: SrtArr(lSrtA)
integer(kind=iwp), intent(out) :: IOStk(lStk)
integer(kind=iwp), intent(inout) :: nStk
#include "print.fh"
#include "PkCtl.fh"
#include "warnings.h"
integer(kind=iwp) :: idiv, iI_Storage, iInd, iInt, indx, Init_do_setup_d, Init_do_setup_e, Init_do_setup_l, iOpt, iP_Storage, &
                     iPrint, iRout, iSec, ist1, ist2, iZero, lIBin, lVBin, mDaRec, mStRec, nInts, nInts1, nInts2, PkIBin(lStRec)
real(kind=wp) :: PkVBin(lStRec)

!----------------------------------------------------------------------*
!     as the packed integral labels add an extra 1-2 Byte              *
!     disk space per integral we have to adjust the record             *
!     length of LuTmp to the different machines.                       *
!----------------------------------------------------------------------*

idiv = ItoB/2
if (Pack) idiv = idiv/2
mStRec = (lStRec/idiv)
mDaRec = (lDaRec/idiv)

!----------------------------------------------------------------------*
!     pick up the print level                                          *
!----------------------------------------------------------------------*

iRout = 85
iPrint = nPrint(iRout)
if (iPrint >= 10) then
  write(u6,*) ' >>> Enter SORT2A <<<'
  write(u6,*) ' iBin  ',iBin
  write(u6,*) ' lSrtA ',lSrtA
end if

iZero = lSrtA-mInt(1,iBin)
iInt = mInt(2,iBin)*RtoB
iInd = mInt(3,iBin)
iP_Storage = (iZero+iInt+RtoB)/RtoB
iI_Storage = (iInd+iInt+RtoB)/RtoB
if (iP_Storage <= iI_Storage) then
  iDVBin(4,iBin) = 0  ! Dense mode.
  !write(u6,*) 'Mode: Dense'
else
  iDVBin(4,iBin) = 1  ! Sparse mode.
  !write(u6,*) 'Mode: Sparse'
end if

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'Processing slice                   :',iBin
write(u6,*) 'Actual number of non-zero integrals:',mInt(1,iBin)
write(u6,*) 'Effective number of integrals      :',mInt(2,iBin)
write(u6,*) 'Effective number of indicies       :',mInt(3,iBin)
write(u6,*) 'Total number of integrals          :',lSrtA
write(u6,*) 'Packed storage                     :',iP_Storage
write(u6,*) 'Indexed storage                    :',iI_Storage
#endif

!----------------------------------------------------------------------*
!     Start reading packed buffers                                     *
!----------------------------------------------------------------------*

iDaTmp = iDIBin(2,iBin)
iDaTwo = iDVBin(2,iBin)
do while (iDaTmp >= 0)
  nStk = nStk+1
  if (nStk > lStk) then
    write(u6,*)
    write(u6,'(2X,A,I3.3,A)') '*** Error in SORT2A ***'
    write(u6,'(2X,A)') 'nStk exceeds limits (nStk>lStk)'
    write(u6,'(2X,A,I8)') 'nStk =',nStk
    write(u6,'(2X,A,I8)') 'lStk =',lStk
    write(u6,'(2X,A,I8)') 'iBin =',iBin
    write(u6,*)
    write(u6,*) 'Action: rerun with a larger MOLCAS_MEM'
    call Quit(_RC_MEMORY_ERROR_)
  end if
  IOStk(nStk) = iDaTwo
  iOpt = 2
  if (iPrint >= 10) then
    write(u6,*) ' read records: iDaTmp,iDaTwo ',iDaTmp,iDaTwo
  end if
  call iDAFILE(LuTmp,iOpt,PkIBin,mStRec,iDaTmp)
  call dDAFILE(LuTwo,iOpt,PkVBin,lStRec,iDaTwo)
  ist1 = lTop
  ist2 = lTop
  do iSec=1,nSect
    nInts1 = PkIBin(ist1-1)
    nInts2 = int(PkVBin(ist2-1),kind=iwp)
    if (nInts1 /= nInts2) then
      write(u6,*)
      write(u6,'(2X,A,I3.3,A)') '*** Error in SORT2A ***'
      write(u6,'(2X,A)') 'An inconsistency has been deteced'
      write(u6,'(2X,A)') 'nInts1#nInts2'
      write(u6,*)
      call xFlush(u6)
      call Abend()
    end if
    nInts = nInts1
    if (nInts > lBin) then
      write(u6,*)
      write(u6,'(2X,A,I3.3,A)') '*** Error in SORT2A ***'
      write(u6,'(2X,A)') 'An inconsistency has been deteced'
      write(u6,'(2X,A)') 'nInts>lBin'
      write(u6,*)
      call xFlush(u6)
      call Abend()
    end if
    if (nInts > 0) then

      !----------------------------------------------------------------*
      ! Unpack buffers                                                 *
      !----------------------------------------------------------------*

      call UPKI4(nInts,lIBin,PkIBin(ist1+1),IndBin)
      iOpt = 0 ! Always tight mode
      call UPKR8(iOpt,nInts,lVBin,PkVBin(ist2+1),ValBin)

      !----------------------------------------------------------------*
      ! Sort 2el integrals                                             *
      !----------------------------------------------------------------*

      do indx=1,nInts
        SrtArr(IndBin(indx)) = ValBin(indx)
      end do
      ist1 = ist1+mDaRec
      ist2 = ist2+lDaRec
    end if
  end do

  !--------------------------------------------------------------------*
  !   Get the disk adress of the next record                           *
  !--------------------------------------------------------------------*

  iDaTmp = PkIBin(1)
  iDaTwo = int(PkVBin(1),kind=iwp)
end do
if (iPrint >= 99) call dVcPrt('sorted ERIs',' ',SrtArr,lSrtA)

return

end subroutine SORT2A

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NAPrm( &
#                define _CALLING_
#                include "prm_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of nuclear attraction     *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, January 1991                            *
!***********************************************************************

use Index_Functions, only: nTri_Elem1, nTri3_Elem1
use Basis_Info, only: DBSC, Gaussian_Type, mGaussian_Type, Nuclear_Model, Point_Charge
use Rys_interfaces, only: cff2d_kernel, modu2_kernel, rys2d_kernel, tval_kernel
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, OneHalf, Pi, TwoP54
use Definitions, only: wp, iwp

implicit none
#include "prm_interface.fh"
integer(kind=iwp) :: iAnga(4), ipIn, ipOff, lc, ld, lta, ltb, mabMax, mabMin, mArr, mcdMax, mcdMin, nFlop, nMem, nT
real(kind=wp) :: C(3), Coora(3,4), CoorAC(3,2), Coori(3,4), EInv, Eta, Q_Nuc, rKappCD
logical(kind=iwp) :: NoSpecial
real(kind=wp), allocatable :: rKappa_mod(:)
! Used for normal nuclear attraction integrals: TNAI, Fake, XCff2D, XRys2D
! Used for finite nuclei: TERI, ModU2, vCff2D, vRys2D
procedure(cff2d_kernel) :: vCff2D, XCff2D
procedure(modu2_kernel) :: Fake, ModU2
procedure(rys2d_kernel) :: vRys2D, XRys2D
procedure(tval_kernel) :: TERI, TNAI
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(nHer)
unused_var(nOrdOp)

lta = nTri_Elem1(la)
ltb = nTri_Elem1(lb)
rFinal(:,:,:,:) = Zero

lc = 0
ld = 0
iAnga(1) = la
iAnga(2) = lb
iAnga(3) = lc
iAnga(4) = ld
Coora(:,1) = A(:)
Coora(:,2) = RB(:)
Coori(:,1:2) = Coora(:,1:2)
mabMin = nTri3_Elem1(max(la,lb)-1)
mabMax = nTri3_Elem1(la+lb)-1
if (EQ(A,RB)) mabMin = nTri3_Elem1(la+lb-1)

! Compute FLOPs and size of work array which Hrr will use.

call mHrr(la,lb,nFLOP,nMem)

! Find center to accumulate angular momentum on. (HRR)

if (la >= lb) then
  CoorAC(:,1) = A(:)
else
  CoorAC(:,1) = RB(:)
end if

! Modify Zeta if the two-electron code will be used!

if ((Nuclear_Model == Gaussian_Type) .or. (Nuclear_Model == mGaussian_Type)) then
  call mma_allocate(rKappa_mod,nZeta,label='rKappa_mod')
  rKappa_mod(:) = rKappa(:)*(TwoP54/Zeta(:))
end if

Q_Nuc = dbsc(iCnttp)%Charge

if (Q_Nuc /= Zero) then
  C(:) = CCoor(:)
# ifdef _DEBUGPRINT_
  call RecPrt('C',' ',C,1,3)
# endif

  CoorAC(:,2) = C(:)
  Coori(:,3) = C(:)
  Coori(:,4) = C(:)
  Coora(:,3) = C(:)
  Coora(:,4) = C(:)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute integrals with the Rys quadrature.
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  nT = nZeta
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  select case (Nuclear_Model)
    case (Gaussian_Type)

      ! Gaussian nuclear charge distribution

      NoSpecial = .false.
      Eta = dbsc(iCnttp)%ExpNuc
      EInv = One/Eta
      rKappcd = TwoP54/Eta
      ! Tag on the normalization
      rKappcd = rKappcd*(Eta/Pi)**OneHalf
      ! s-type function
      mcdMin = 0
      mcdMax = 0
      call Rys(iAnga,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,C,1,rKappa_mod,[rKappcd],Coori,Coora,CoorAC,mabmin,mabmax,mcdMin, &
               mcdMax,Array,nArr*nZeta,TERI,ModU2,vCff2D,vRys2D,NoSpecial)
      !                                                                *
      !*****************************************************************
      !                                                                *
    case (mGaussian_Type)

      ! Modified Gaussian nuclear charge distribution

      NoSpecial = .false.
      Eta = dbsc(iCnttp)%ExpNuc
      EInv = One/Eta
      rKappcd = TwoP54/Eta
      ! Tag on the normalization
      rKappcd = rKappcd*(Eta/Pi)**OneHalf/(One+Three*dbsc(iCnttp)%w_mGauss/(Two*Eta))
      ! s type function
      mcdMin = 0
      mcdMax = 0
      call Rys(iAnga,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,C,1,rKappa_mod,[rKappcd],Coori,Coora,CoorAC,mabmin,mabmax,mcdMin, &
               mcdMax,Array,nArr*nZeta,TERI,ModU2,vCff2D,vRys2D,NoSpecial)

      ! d type function w*(x**2+y**2+z**2)
      if (dbsc(iCnttp)%w_mGauss > Zero) then
        rKappcd = rKappcd*dbsc(iCnttp)%w_mGauss
        iAnga(3) = 2
        mcdMin = nTri3_Elem1(2+ld-1)
        mcdMax = nTri3_Elem1(2+ld)-1
        ! tweak the pointers
        ipOff = 1+nZeta*lta*ltb
        mArr = nArr-lta*ltb
        call Rys(iAnga,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,C,1,rKappa,[rKappcd],Coori,Coora,CoorAC,mabMin,mabMax,mcdMin, &
                 mcdMax,Array(ipOff),mArr*nZeta,TERI,ModU2,vCff2D,vRys2D,NoSpecial)
        iAnga(3) = 0

        ! Add the s and d contributions together!

        call Assemble_mGauss(Array,Array(ipOff),nZeta*(mabMax-mabMin+1))
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
    case (Point_Charge)

      ! Point-like nuclear charge distribution

      NoSpecial = .true.
      Eta = One
      EInv = One
      rKappcd = One
      mcdMin = 0
      mcdMax = 0
      call Rys(iAnga,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,C,1,rKappa,[rKappcd],Coori,Coora,CoorAC,mabMin,mabMax,mcdMin, &
               mcdMax,Array,nArr*nZeta,TNAI,Fake,XCff2D,XRys2D,NoSpecial)
  end select
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Use the HRR to compute the required primitive integrals.

  call HRR(la,lb,A,RB,Array,nZeta,nMem,ipIn)

  rFinal(:,:,:,:) = reshape(-Q_Nuc*Array(ipIn:ipIn+nZeta*lta*ltb*nComp-1),[nZeta,lta,ltb,nComp])
end if

if ((Nuclear_Model == Gaussian_Type) .or. (Nuclear_Model == mGaussian_Type)) call mma_deallocate(rKappa_mod)

return

end subroutine NAPrm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine ClsSew
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
************************************************************************
      use Real_Spherical, only: Sphere_Free
      use EFP_module
      use External_Centers
      use Basis_Info
      use Center_Info
      Use SOAO_Info
      use Symmetry_Info, only: Symmetry_Info_Free
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "stdalloc.fh"
#include "timtra.fh"
#include "rctfld.fh"
#include "nsd.fh"
#include "setup.fh"
#include "status.fh"
*
      If (Seward_Status.eq.InActive) Return
*
      Call Term_Ints(.False.,.True.)
      Call Free_RctFld(iXPolType)
      Call Free_HerRW()
      Call Sphere_Free()
      Call SOAO_Info_Free()
      Call Basis_Info_Free()
      Call SYmmetry_Info_Free()
      Call Center_Info_Free()
      Call External_Centers_Free()
      Call Free_iSD()
      Call Freek2()
      Call CloseR()
*
      If (lEFP) Then
         Deallocate(FRAG_TYPE)
         Deallocate(ABC)
         Deallocate(EFP_COORS)
         lEFP=.FALSE.
      End If
*
      Seward_Status=InActive
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHO_FOCKTWO_RED(rc,nBas,nDen,DoCoulomb,DoExchange,
     &           FactC,FactX,ipDLT,ipDSQ,ipFLT,ipFSQ,ipNocc,MinMem)

************************************************************************
*  Author : F. Aquilante
*
*  Purpose:
*          For a given set of total symmetric AO-densities
*          (hermitian matrix representation) this routine
*          computes the Coulomb and Exchange contributions
*          to the Fock matrix from Cholesky vectors in full storage
*
*          The vectors are indeed read in reduced set storage
*          and then reordered.
*
*          Coulomb term (Drs is the lower triangular matrix
*                        of r=s symmetry block. The diagonals
*                        are scaled by a factor 1/2 already in
*                        the packed density DLT, given as input)
*
*    F(pq) = F(pq) + FactC * Sum_J Lpq,J * (Sum_rs Drs*Lrs,J)
*
*
*          Exchange term (Drs is the squared matrix
*                        of r=s symmetry block.)
*
*    F(pq) = F(pq) - FactX * Sum_rJ  Lpr,J * (Sum_s Drs*Lqs,J)
*
*
*    Integral-fashion formula:
*
*    F(pq) =  Sum_rs Drs * [(pq|rs)  - 0.5 (ps|rq)]
*
*----------------------------------------------------------------------
*  DoCoulomb(nDen) :  specifies the densities for which coulomb term
*                     has to be computed
*
*  DoExchange(nDen) : specifies the densities for which exchange term
*                     has to be computed
*
*  FactC(nDen) : factor for the coulomb of the corresponding density
*  FactX(nDen) : factor for the exchange of the corresponding density
*
*  ip{X}LT(nDen) : pointer to the array containing {X} in LT storage
*  ip{X}FS(nDen) : pointer to the array containing {X} in SQ storage
*    {X=D,F --- Density, Fock matrix}
*
*  ipNocc(nDen) : pointer to the array of the Occupation numbers
*                 for the corresponding density
*
*  MinMem(nSym) : minimum amount of memory required to read
*                 a single Cholesky vector in full storage
*
************************************************************************

      Implicit Real*8 (a-h,o-z)

      Integer  rc,nDen,nBas(*)
      Real*8   FactC(nDen),FactX(nDen)
      Integer  KSQ1(8),ISTSQ(8),ISTLT(8),iSkip(8),MinMem(*)
      Integer  ipDLT(nDen),ipDSQ(nDen),ipNocc(nDen)
      Integer  ipFLT(nDen),ipFSQ(nDen)
      Logical  DoExchange(nDen),DoCoulomb(nDen),DoSomeX,DoSomeC,Debug
      Real*8   tread(2),tcoul(2),texch(2)
      Logical  timings

      COMMON   /CHOTIME /timings
      Character*50 CFmt
      Character*15 SECNAM
      Parameter (SECNAM = 'CHO_FOCKTWO_RED')

      parameter (zero = 0.0D0, one = 1.0D0)
      Logical DoRead
      parameter (DoRead = .true.)


#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

**************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
**************************************************


#ifdef _DEBUGPRINT_
c      Debug=.true.
      Debug=.false.! to avoid double printing in SCF-debug
#else
      Debug=.false.
#endif
      IREDC = -1  ! unknown reduced set in core

        CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        do i=1,2            ! 1 --> CPU   2 --> Wall
           tread(i) = zero  !time read/rreorder vectors
           tcoul(i) = zero  !time for computing Coulomb
           texch(i) = zero  !time for computing Exchange
        end do

C --- Tests on the type of calculation
        DoSomeC=.false.
        DoSomeX=.false.
        MaxSym=0
c
        jD=0
        do while (jD.lt.nDen .and. .not.DoSomeX)
         jD=jD+1
         DoSomeX=DoExchange(jD)
        end do
        jD=0
        do while (jD.lt.nDen .and. .not.DoSomeC)
         jD=jD+1
         DoSomeC=DoCoulomb(jD)
        end do

        if (DoSomeX) Then
           MaxSym=nSym !we want to do some exchange
        Else
           If (DoSomeC) Then
                   MaxSym = 1 !we want to do only Coulomb
           Else
                   Return  !we are lazy and won''t do anything
           End If
        End If

c ISTSQ: Offsets to full symmetry block in DSQ,FSQ
c ISTLT: Offsets to packed LT symmetry blocks in DLT,FLT
        ISTSQ(1)=0
        ISTLT(1)=0
      DO ISYM=2,NSYM
        NB=NBAS(ISYM-1)
        NB2=NB*NB
        NB3=(NB2+NB)/2
        ISTSQ(ISYM)=ISTSQ(ISYM-1)+NB2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NB3
      END DO

C *************** BIG LOOP OVER VECTORS SYMMETRY *****************
      DO jSym=1,MaxSym

      If (NumCho(jSym).lt.1) GOTO 1000


C ------------------------------------------------------

C --- Pointers to be used for the vectors
         do i=1,nSym
            KSQ1(i)=-6666
         end do

C SET UP THE READING
C ------------------
      Call GetMem('Maxmem','MAX ','REAL',KDUM,LWORK)

      If (MinMem(jSym) .gt. 0) Then
         nVec = Min(LWORK/MinMem(jSym),NumCho(jSym))
      Else
C         ***QUIT*** bad initialization
         WRITE(6,*) 'Cho_FockTwo_RED: bad initialization'
         rc=99
         CALL Abend()
         nVec = -9999  ! dummy assignment - avoid compiler warnings
      End If

C...this is ONLY for debug:
c      nVec = min(nVec,1)

      If (nVec .gt. 0) Then
         nBatch = (NumCho(jSym) - 1)/nVec + 1
      Else
C         ***QUIT*** insufficient memory
         WRITE(6,*) 'Cho_FockTwo_RED: Insufficient memory for batch'
         WRITE(6,*) 'LWORK= ',LWORK
         WRITE(6,*) 'min. mem. need= ',MinMem(jSym)
         WRITE(6,*) 'NumCho= ',NumCho(jsym)
         WRITE(6,*) 'jsym= ',jsym
         rc = 205
         CALL Abend()
         nBatch = -9999  ! dummy assignment
      End If


C *************** BATCHING  *****************
      DO iBatch = 1,nBatch

         If (iBatch .eq. nBatch) Then
            NumV = NumCho(jSym) - nVec*(nBatch - 1)
         Else
            NumV = nVec
         End If

         iVec = nVec*(iBatch - 1) + 1

C --- Allocate memory for reading the vectors
         kTOT = MinMem(jSym)*NumV
         Call GetMem('MemR','ALLO','REAL',kWab,kTOT)

c--- setup the skipping flags according to # Occupied
      do k=1,nSym
         iSkip(k)=0
         l=Muld2h(k,jsym) !L(kl) returned if nOcc(k or l) .ne.0
         if (k.eq.l) then
            iSkip(k) = 666 ! always contribute to Coulomb
         else
          do jDen=1,nDen
               iSkip(k) = iSkip(k) + iWork(ipNocc(jDen)+k-1)
     &                             + iWork(ipNocc(jDen)+l-1)
          end do
         endif
      end do


C Max dimension of a read symmetry block
        Nmax=0
        Do iSym=1,nSym
           if(NBAS(iSym).gt.Nmax .and. iSkip(iSym).ne.0)then
           Nmax = NBAS(iSym)
           iSymMax= iSym
           endif
        End Do

C --- Compute the total amount of memory needed to have the
C --- vectors in core (full storage)
         lChoV=0
         Do iSymq=1,nSym
            iSymp = muld2h(jSym,iSymq)
            IF (nBas(iSymq)*nBas(iSymp).ne.0) THEN
             If(iSymp.gt.iSymq .and. iSkip(iSymp).ne.0) then
               KSQ1(iSymp) = kWab + lChoV
               lChoV = lChoV + Nbas(iSymp)*Nbas(iSymq)*NumV
             Else
               if(iSymp.eq.iSymq .and. iSkip(iSymp).ne.0) then
                 KSQ1(iSymp) = kWab + lChoV
C --- Special trick for the vector L11 ; used to store X(a,Jb)
                 if(iSymp.eq.1.and.jSym.eq.1.and.DoSomeX)then
                    lChoV = lChoV + (Nmax**2) * NumV
                 else
                    lChoV = lChoV + Nbas(iSymp)*(Nbas(iSymp)+1)/2*NumV
                 endif
               endif
             Endif
            ENDIF
         End Do

         kLab = kWab + lChoV
         lScr = kTOT - lChoV

C --- Reading of the vectors is done in Reduced sets

      iSwap = min(1,(jSym-1)) ! L(ab,J) --> L(a,J,b) iff jSym.ne.1

      CALL CWTIME(TCR1,TWR1)

      Call CHO_X_getVfull(irc,Work(kLab),lscr,iVEC,NumV,jSym,iSwap,
     &                    IREDC,KSQ1,iSkip,DoRead)

       if (irc.ne.0) then
          rc = irc
          RETURN
       endif

       CALL CWTIME(TCR2,TWR2)
       tread(1) = tread(1) + (TCR2 - TCR1)
       tread(2) = tread(2) + (TWR2 - TWR1)

#ifdef _DEBUGPRINT_
       write(6,*) 'Batch ',iBatch,' of   ',nBatch,': NumV = ',NumV
       write(6,*) 'Total allocated :     ',kTOT,' at ',kWab
       write(6,*) 'Memory pointers KSQ1: ',(KSQ1(i),i=1,nSym)
       write(6,*) 'kLab:                 ',kLab
       write(6,*) 'lScr:                 ',lScr
       write(6,*) 'JSYM:                 ',jSym
#endif

C
C --- Reading Done!
C

C ********************************************************************
      DO jDen=1,nDen

       IF (jSym.eq.1.and.DoCoulomb(jDen)) THEN
C
C *************** BEGIN COULOMB CONTRIBUTION  ****************
C
C---- Computing the intermediate vector V(J)
C
C --- Contraction with the density matrix
C ---------------------------------------
C --- V{#J} <- V{#J} + sum_rr L(rr,{#J})*D(rr)
C==========================================================
C
         CALL CWTIME(TCC1,TWC1)

         CALL FZERO(Work(kLab),NumV)
         DO iSymr=1,nSym
         IF(nBas(iSymr).ne.0.and.iWork(ipNocc(jDen)+iSymr-1).ne.0)THEN

         ISDLT = ipDLT(jDen) + ISTLT(ISYMR)
         Naa = nBas(iSymr)*(nBas(iSymr)+1)/2

         CALL DGEMV_('T',Naa,NumV,
     &              ONE,Work(KSQ1(iSymr)),Naa,
     &              Work(ISDLT),1,ONE,Work(kLab),1)

         ENDIF
         End DO

C --- Contraction with the 2nd vector
C ---------------------------------------
C --- Fpp{#J} <- Fpp{#J} + FactC * sum_J L(pp,{#J})*V{#J}
C==========================================================
C
          DO iSyms=1,nSym
          IF(nBas(iSyms).ne.0)THEN

           ISFLT = ipFLT(jDen) + ISTLT(ISYMS)
           Naa = nBas(iSyms)*(nBas(iSyms)+1)/2

           CALL DGEMV_('N',Naa,NumV,
     &              FactC(jDen),Work(KSQ1(iSyms)),Naa,
     &              Work(kLab),1,ONE,Work(ISFLT),1)

          ENDIF
          End DO

        CALL CWTIME(TCC2,TWC2)
        tcoul(1) = tcoul(1) + (TCC2 - TCC1)
        tcoul(2) = tcoul(2) + (TWC2 - TWC1)

       ENDIF  ! jSym=1 & DoCoulomb

      END DO ! loop over densities for the Coulomb term

C *************** END COULOMB CONTRIBUTION  ****************

       IF (jSym.eq.1.and.DoSomeX) THEN
C WE INCLUDE THE DIAGONAL PART OF THE EXCHANGE HERE!!!!
C
C ********** REORDER AND SQUARE ONE VECTOR AT THE TIME *****
C     Reorder: L(rs,J) -> L(r,J,s).
C     CHOVEC(nrs,numv) ---> CHOVEC(nr,numv,ns)

         KQS1=0
         KQS2=0
         ISFSQ=0
         ISDSQ=0
         DO iSymr=1,nSym

          iSymr_Occ=0
          do jDen=1,nDen
             iSymr_Occ = iSymr_Occ + iWork(ipNocc(jDen)+iSymr-1)
          end do
          IF(nBas(iSymr).ne.0.and.iSymr_Occ.gt.0)THEN

             CALL CWTIME(TCREO1,TWREO1)

             KQS1 = KSQ1(ISYMR)
             KQS2 = kLab
             NRS  = NBAS(iSymr)*(NBAS(iSymr)+1)/2

             KOFF1=0
             KOFF2=0
             KOFF3=0
             iSQ = NBAS(iSymr)*NUMV
             Do JVEC=1,NUMV

                iLT = NRS*(JVEC-1)
                iVR = NBAS(iSymr)*(JVEC-1)

                Do jR=1,NBAS(iSymr)
                   Do jS=jR,NBAS(iSymr)

                      jSR = iTri(jS,jR)
                      KOFF1 = (KQS1-1) + iLT + jSR

                      KOFF2 = (KQS2-1) + iSQ*(jS-1) + iVR + jR

                      WORK(KOFF2) = WORK(KOFF1)

                      KOFF3 = (KQS2-1) + iSQ*(jR-1) + iVR + jS

                      WORK(KOFF3) = WORK(KOFF1)

                   End Do
                End Do
             End Do

             CALL CWTIME(TCREO2,TWREO2)
             tread(1) = tread(1) + (TCREO2 - TCREO1)
             tread(2) = tread(2) + (TWREO2 - TWREO1)

          DO jDen=1,nDen

           IF (DoExchange(jDen)) THEN

               IF (iWork(ipNocc(jDen)+iSymr-1).ne.0) THEN

               CALL CWTIME(TC1X1,TW1X1)

C              Calculate intermediate:
C              X(p,Js) = Sum(q) D(p,q) * L(q,Js).
C              -----------------------------------
               ISDSQ = ISTSQ(ISYMR) + ipDSQ(jDen)
               ISFSQ = ISTSQ(ISYMR) + ipFSQ(jDen)


               CALL DGEMM_('N','N',
     &               NBAS(ISYMR),NUMV*NBAS(ISYMR),NBAS(ISYMR),
     &               ONE,WORK(ISDSQ),NBAS(ISYMR),
     &                   Work(KQS2), NBAS(ISYMR),
     &               ZERO,WORK(kWab),NBAS(ISYMR))

C              Calculate exchange contribution:
C              F(p,q) = F(p,q) - FactX Sum(sJ) L(sJ,p) * X(sJ,q).
C              --------------------------------------------------

               CALL DGEMM_('T','N',
     &                NBAS(ISYMR),NBAS(ISYMR),NBAS(ISYMR)*NUMV,
     &             -FactX(jDen),WORK(KQS2),NBAS(ISYMR)*NUMV,
     &                          WORK(kWab),NBAS(ISYMR)*NUMV,
     &                      One,Work(ISFSQ),NBAS(ISYMR))


               CALL CWTIME(TC1X2,TW1X2)
               texch(1) = texch(1) + (TC1X2 - TC1X1)
               texch(2) = texch(2) + (TW1X2 - TW1X1)

               ENDIF

          ENDIF  ! DoExchange(jDen)

         END DO  ! loop over the densities

c         write(6,*)'Symmetry block of FSQ= ',isymr
c         call recprt('FSQ','',Work(ISFSQ),NBAS(ISYMR),NBAS(ISYMR))

        ENDIF  ! nbas.ne.0 & nOcc.ne.0

        END DO  !loop over Fock mat symmetries

       END IF  ! jSym=1 and DoSomeX

C ****************** END DIAGONAL EXCHANGE **********************
C
C ************ "OFF-DIAGONAL" EXCHANGE CONTRIBUTION  ************
C
       IF (jSym.ne.1) THEN

       DO jDen=1,nDen

       IF (DoExchange(jDen)) THEN
C --- COMPUTE EXCHANGE FOR OFF-DIAGONAL VECTORS

            CALL CWTIME(TC2X1,TW2X1)

            DO ISYMG = 1,NSYM

               ISYMB = MULD2H(ISYMG,JSYM)

            IF(nBas(iSymb)*nBas(iSymg).ne.0)THEN

               ISYMD = ISYMG     !only total symmetric Density
               ISYMA = ISYMB     !block diagonal Fock Matrix

             IF (ISYMG.gt.ISYMB .and. iSkip(iSymg).ne.0) THEN

               KQS1 = KSQ1(ISYMG)

C -------------------------------
C --- F(a,b) = - D(g,d) * (ad|gb)
C -------------------------------
               if (iWork(ipNocc(jDen)+iSymg-1).ne.0) then

               ISFSQ = ISTSQ(ISYMB) + ipFSQ(jDen)
               ISDSQ = ISTSQ(ISYMG) + ipDSQ(jDen)

C              Calculate intermediate:
C              X(d,Jb) = Sum(g) D(d,g) * L(g,Jb).
C              ----------------------------------

               CALL DGEMM_('N','N',
     &                    NBAS(ISYMD),NUMV*NBAS(ISYMB),NBAS(ISYMG),
     &                    ONE,Work(ISDSQ),NBAS(ISYMD),Work(KQS1),
     &                    NBAS(ISYMG),ZERO,WORK(kLab),NBAS(ISYMD))


C              F(a,b) = F(a,b) - Sum(dJ) L(dJ,a) * X(dJ,b).
C              -------------------------------------------

              CALL DGEMM_('T','N',
     &              NBAS(ISYMA),NBAS(ISYMB),NBAS(ISYMD)*NUMV,
     &              -FactX(jDen),WORK(KQS1),NBAS(ISYMD)*NUMV,
     & WORK(kLab),NBAS(ISYMD)*NUMV,ONE,Work(ISFSQ),NBAS(ISYMA))

c         write(6,*)'Symmetry block of FSQ= ',isyma
c         write(6,*)'Symmetry of the density= ',isymg
c         call recprt('FSQ','',Work(ISFSQ),NBAS(ISYMA),NBAS(ISYMA))
               endif
C -------------------------------
C --- F(g,d) = - D(a,b) * (ad|gb)
C -------------------------------
               if (iWork(ipNocc(jDen)+iSyma-1).ne.0) then

               ISFSQ = ISTSQ(ISYMG) + ipFSQ(jDen)
               ISDSQ = ISTSQ(ISYMB) + ipDSQ(jDen)

C              Calculate intermediate:
C              X(gJ,b) = Sum(a) L(gJ,a)* D(a,b).
C              ----------------------------------

               CALL DGEMM_('N','N',
     &                  NBAS(ISYMG)*NUMV,NBAS(ISYMB),NBAS(ISYMA),
     &                  ONE,Work(KQS1),NBAS(ISYMG)*NUMV,WORK(ISDSQ),
     &                  NBAS(ISYMA),ZERO,WORK(kLab),NBAS(ISYMG)*NUMV)


C              F(g,d) = F(g,d) - Sum(Jb) X(g,Jb) * L(d,Jb).
C              -------------------------------------------

              CALL DGEMM_('N','T',
     &              NBAS(ISYMG),NBAS(ISYMD),NUMV*NBAS(ISYMB),
     &              -FactX(jDen),WORK(kLab),NBAS(ISYMG),
     & WORK(KQS1),NBAS(ISYMD),ONE,Work(ISFSQ),NBAS(ISYMG))

c         write(6,*)'Symmetry block of FSQ= ',isymg
c         write(6,*)'Symmetry of the density= ',isyma
c         call recprt('FSQ','',Work(ISFSQ),NBAS(ISYMG),NBAS(ISYMG))
              endif
             ENDIF

            ENDIF
            END DO  ! loop over orbital symmetries

            CALL CWTIME(TC2X2,TW2X2)
            texch(1) = texch(1) + (TC2X2 - TC2X1)
            texch(2) = texch(2) + (TW2X2 - TW2X1)

C ************ END "OFF-DIAGONAL" EXCHANGE CONTRIBUTION  ***********


       END IF  ! DoExchange section

      END DO  ! end of the loop over densities

      ENDIF ! jSym.ne.1


C --- Free the memory
         Call GetMem('MemR','FREE','REAL',kWab,kTOT)

      END DO  ! end of the batch procedure

1000  CONTINUE

      END DO  ! loop over JSYM

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1

*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky SCF timing from '//SECNAM
      Write(6,CFmt)'-----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ/REORDER VECTORS             '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB                          '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'EXCHANGE                         '
     &                           //'         ',texch(1),texch(2)

         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


c Print the Fock-matrix
#ifdef _DEBUGPRINT_

      if(Debug) then !to avoid double printing in SCF-debug

      WRITE(6,'(6X,A)')'TEST PRINT FROM CHO_FOCKTWO_RED.'
      WRITE(6,'(6X,A)')'***** EXCHANGE MATRIX ***** '
      Do jDen=1,nDen
          WRITE(6,'(6X,A,I2)')'DENSITY TYPE: ',jDen
          WRITE(6,'(6X,A,I2)')'DoExchange: ',DoExchange(jDen)
          WRITE(6,*)
      if(DoExchange(jDen))then
      icount=0
      DO ISYM=1,NSYM
      ISQ=ipFSQ(jDen)+icount
        NB=NBAS(ISYM)
        IF ( NB.GT.0 ) THEN
          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
          call cho_output(Work(ISQ),1,NB,1,NB,NB,NB,1,6)
          icount=icount+NB**2
        END IF
      END DO
      endif
      End Do

      endif

#endif


      rc  = 0

      Return
      END

**************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CNF2TXT(IFORM,NORB,NCLS,NOPN,ICONF,LENGTH,TEXT)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IFORM, NORB, NCLS, NOPN, ICONF(*)
integer(kind=iwp), intent(out) :: LENGTH
character(len=*), intent(out) :: TEXT
integer(kind=iwp) :: IOCC, IORB, IREST, IW, IWORD, MXWR, NOCC, NWR
character :: SEP

MXWR = len(TEXT)
NWR = 1
TEXT(1:1) = '('
IWORD = 0 ! dummy initialize
if ((IFORM == 1) .or. (IFORM == 3)) then
  NOCC = NCLS+NOPN
  if (NCLS == 0) then
    NWR = 2
    TEXT(2:2) = ';'
  end if
  if (IFORM == 1) then
    do IOCC=1,NOCC
      IORB = ICONF(IOCC)
      SEP = ','
      if (IOCC == NCLS) SEP = ';'
      if (IORB < 10) then
        NWR = min(MXWR,NWR+2)
        write(TEXT(NWR-1:NWR),'(I1,A1)') IORB,SEP
      else if (IORB < 100) then
        NWR = min(MXWR,NWR+3)
        write(TEXT(NWR-2:NWR),'(I2,A1)') IORB,SEP
      else
        NWR = min(MXWR,NWR+4)
        write(TEXT(NWR-3:NWR),'(I3,A1)') IORB,SEP
      end if
    end do
  else
    do IOCC=1,NOCC
      IW = (3+IOCC)/4
      IREST = (3+IOCC)-4*IW
      if (IREST == 0) IWORD = ICONF(IW)
      IORB = mod(IWORD,256)
      IWORD = IWORD/256
      SEP = ','
      if (IOCC == NCLS) SEP = ';'
      if (IORB < 10) then
        NWR = min(MXWR,NWR+2)
        write(TEXT(NWR-1:NWR),'(I1,A1)') IORB,SEP
      else if (IORB < 100) then
        NWR = min(MXWR,NWR+3)
        write(TEXT(NWR-2:NWR),'(I2,A1)') IORB,SEP
      else
        NWR = min(MXWR,NWR+4)
        write(TEXT(NWR-3:NWR),'(I3,A1)') IORB,SEP
      end if
    end do
  end if
else if ((IFORM == 2) .or. (IFORM == 4)) then
  if (IFORM == 2) then
    do IORB=1,NORB
      IOCC = ICONF(IORB)
      NWR = min(MXWR,NWR+1)
      write(TEXT(NWR:NWR),'(I1)') IOCC
    end do
  else
    do IORB=1,NORB
      IW = (IORB+14)/15
      IREST = IORB+14-15*IW
      if (IREST == 0) IWORD = ICONF(IW)
      IOCC = mod(IWORD,4)
      IWORD = IWORD/4
      NWR = min(MXWR,NWR+1)
      write(TEXT(NWR:NWR),'(I1)') IOCC
    end do
  end if
end if
TEXT(NWR:NWR) = ')'
LENGTH = NWR

end subroutine CNF2TXT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine fiin(lmax)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "welcom.fh"
*
      fiint(0,0)=Pi*Two
      Do 10 i=0,lmax
         Do 11 j=0,lmax-i
            fiint(i,j)=Zero
            Do 12 k=0,j
               a=binom(j,k)
               iexp=i+k
               tal=pi*Two*a*(-One)**k
               if(iexp.ne.0)then
                  Do 13 l=1,iexp
                     al=Two*DBLE(l)
                     tal=tal*(al-One)/al
 13               Continue
                Endif
                fiint(i,j)=fiint(i,j)+tal
 12         Continue
 11      Continue
 10   Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine isoloop(Double)
      Implicit Real*8(a-h,o-z)
#include "Molcas.fh"
#include "WrkSpc.fh"
      Character*2 Element(MxAtom)
      Logical Double
*                                                                      *
************************************************************************
*                                                                      *
      Write (6,*)
      Call CollapseOutput(1,'   Isotopic shifts:')
      Write (6,'(3X,A)')    '   ----------------'
      Write (6,*)
*
      Call Get_nAtoms_All(nAtoms_All)
      Call Allocate_Work(ipCoor,3*nAtoms_All)
      Call Get_Coord_All(Work(ipCoor),nAtoms_All)
      Call Get_Name_All(Element)
*
      Write (6,*)
      Write (6,*)
      Write (6,*)'****************************************'
      Write (6,*)'*                                      *'
      Write (6,*)'* Isotope shifted frequencies in cm-1  *'
      Write (6,*)'*                                      *'
      Write (6,*)'****************************************'
      Write (6,*)
      n=3*nAtoms_All
      nTemp=6*2*n**2
      Call Getmem('ISOLOOP','ALLO','REAL',ipT,nTemp)
      Call Isotop_i(n,Element,nAtoms_All,Work(ipT),nTemp,Work(ipCoor),
     &              Double)
      Call Getmem('ISOLOOP','FREE','REAL',ipT,nTemp)
      Call Free_Work(ipCoor)
*
      Call CollapseOutput(0,'   Isotopic shifts:')
      Write(6,*)
*
      Return
      End
      Subroutine Isotop_i(n,Element,mAtoms,Temp,nTemp,Coord,Double)
      Use Isotopes
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "periodic_table.fh"
#include "constants2.fh"
#include "WrkSpc.fh"
      Integer AtNum, IsoNum, AtNum2, Subs, Subs2
      Real*8 Temp(nTemp), Coord(3,mAtoms)
      Real*8 MassIso
      Real*8 Mass(MxAtom)
      Character*2 Element(mAtoms)
      Logical EQ, Double, lmass, Found, Changed
      Character*3 cmass(MxAtom)
      Real*8 umass(MxAtom)
*                                                                      *
************************************************************************
*                                                                      *
      ipH=1
*
      Call qpg_iscalar('iMass',lmass)
      If (lmass) Then
         Call Get_iScalar('iMass',iMass)
         Call Get_cArray('cmass',cmass,3*iMass)
         Call Get_dArray('umass',umass,iMass)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Read the unsymmetrized Hessian from run file
*
      Call Get_dArray('FC-Matrix',Temp(ipH),n**2)
*
*---- Put in the initial masses and take backup copy
*
      Call Get_Mass_All(Mass,mAtoms)
      Call GetMem('DefaultMass','ALLO','REAL',ipDefMass,mAtoms)
      Call dCopy_(mAtoms,Mass,1,Work(ipDefMass),1)
*
      Do i=1,mAtoms
         Coord(1,i)=Abs(Coord(1,i))
         Coord(2,i)=Abs(Coord(2,i))
         Coord(3,i)=Abs(Coord(3,i))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Loop over common isotops
*
      ipH2=ipH+2*n**2
      ip1=ipH2+2*n**2
      ip2=ip1+2*n**2
      ipVal=ip2+2*n**2
      ipVec=ipVal+2*n**2
      Call Initialize_Isotopes()
*                                                                      *
************************************************************************
*                                                                      *
*---- Single substitutions
*
      Write (6,*)
      Write (6,*) ' Single substitutions:'
      Write (6,*) ' -----------------------'
      Write (6,*)
      Do i = 1, mAtoms
*
         If (i.gt.1) Then
            If(EQ(Coord(1,i),Coord(1,i-1))) Go To 94
         End If
*
         AtNum=iNuclearChargeFromSymbol(Element(i))
         If (lmass) Then
*
*           Do according to user list of isotopes.
*
            Subs=0
            Do nAt=1,iMass
               If (Element(i).eq.cmass(nAt)) Then
                  Mass(i)=UtoAU*umass(nAt)
                  Subs=1
               End If
            End Do
         Else
*
*           Get list of natural isotopes
*
            Subs=ElementList(AtNum)%Nat
         End If
*
         dMass = Mass(i)
         Do k = 1, Subs
            If (.not.lmass) Then
               IsoNum=ElementList(AtNum)%Isotopes(k)%A
               If (IsoNum.eq.nInt(dMass/UtoAU)) Cycle
               Call Isotope(IsoNum,AtNum,Mass(i))
            End If
*
            call dcopy_(n**2,Temp(ipH),1,Temp(ipH2),1)
            Write(6,*) 'Masses:'
            Write(6,*) '======='
            Write(6,'(20I4)') (nInt(mass(l)/UtoAU),l=1,mAtoms)
            Write(6,*)
            Write(6,*)
            Write(6,*) 'Frequencies:'
            Write(6,*) '============'
            call freq_i(n,Temp(ipH2),mass,Temp(ip1),Temp(ip2),
     &               Temp(ipVec),Temp(ipVal),ineg)
            call GFPrnt_i(Temp(ipVal),n)
         End Do
*        Put back the original mass
         Mass(i) = dMass
 94      Continue
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Full substitutions
*
      Write (6,*)
      Write (6,*) ' Full substitutions:'
      Write (6,*) ' -----------------------'
      Write (6,*)
      Do iElement=1,Num_Elem

         Found = .False.
         Do i = 1, mAtoms
            Found = Found .or. (PTab(iElement).eq.Element(i))
         End Do
*
*        Process if element found in the molecule.
*
         If (Found) Then
*
*           Loop over all natural isotopes of this element.
*
            Do k = 1, ElementList(iElement)%Nat
               IsoNum=ElementList(iElement)%Isotopes(k)%A
               Call Isotope(IsoNum,iElement,MassIso)
*
*              Substitute all instances.
*
               Changed = .False.
               Do i = 1, mAtoms
                  If (PTab(iElement).eq.Element(i)) Then
                     If (IsoNum.ne.nInt(Work(ipDefMass+i-1)/UtoAU))
     &                  Changed=.True.
                     Mass(i)=MassIso
                  End If
               End Do
*
               If (Changed) Then
                  call dcopy_(n**2,Temp(ipH),1,Temp(ipH2),1)
                  Write(6,*) 'Masses:'
                  Write(6,*) '======='
                  Write(6,'(20I4)') (nInt(mass(l)/UtoAU),l=1,mAtoms)
                  Write(6,*)
                  Write(6,*)
                  Write(6,*) 'Frequencies:'
                  Write(6,*) '============'
                  Call Freq_i(n,Temp(ipH2),mass,Temp(ip1),Temp(ip2),
     &                        Temp(ipVec),Temp(ipVal),ineg)
                  Call GFPrnt_i(Temp(ipVal),n)
               End If
*
            End Do
*
*           Restore the initial mass array
*
            Call dCopy_(mAtoms,Work(ipDefMass),1,Mass,1)
*
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Double substitutions
*
      If (Double) Then
      Write (6,*)
      Write (6,*) ' Double substitutions:'
      Write (6,*) ' -----------------------'
      Write (6,*)
*
      Do i = 1, mAtoms
         AtNum=iNuclearChargeFromSymbol(Element(i))
         If (lmass) Then
            Subs=0
            Do nAt=1,iMass
               If (Element(i).eq.cmass(nAt)) Then
                  Mass(i)=UtoAU*umass(nAt)
                  Subs=1
               End If
            End Do
         Else
            Subs=ElementList(AtNum)%Nat
         End If
*
*        All isotopes first atom
         dMass1 = Mass(i)
         Do k = 1, Subs
            If (.not.lmass) Then
               IsoNum=ElementList(AtNum)%Isotopes(k)%A
               If (IsoNum.eq.nInt(dMass1/UtoAU)) Cycle
               Call Isotope(IsoNum,AtNum,Mass(i))
            End If
*
*           Second atom
            Do j = i+1, mAtoms
               AtNum2=iNuclearChargeFromSymbol(Element(j))
               If (lmass) Then
                  Subs2=0
                  Do nAt=1,iMass
                     If (Element(j).eq.cmass(nAt)) Then
                        Mass(j)=UtoAU*umass(nAt)
                        Subs2=1
                     End If
                  End Do
               Else
                  Subs2=ElementList(AtNum2)%Nat
               End If
*
*              All isotopes for second atom
               dMass2 = Mass(j)
               Do l = 1, Subs2
                  If (.not.lmass) Then
                     IsoNum=ElementList(AtNum2)%Isotopes(l)%A
                     If (IsoNum.eq.nInt(dMass2/UtoAU)) Cycle
                     Call Isotope(IsoNum,AtNum2,Mass(j))
                  End If
*
                  call dcopy_(n**2,Temp(ipH),1,Temp(ipH2),1)
                  Write(6,*) 'Masses:'
                  Write(6,*) '======='
                  Write(6,'(20I4)')
     &                 (nInt(mass(m)/UtoAU),m=1,mAtoms)
                  Write(6,*)
                  Write(6,*)
                  Write(6,*) 'Frequencies:'
                  Write(6,*) '============'
                  call freq_i(n,Temp(ipH2),mass,Temp(ip1),
     &                Temp(ip2),Temp(ipVec),Temp(ipVal),ineg)
                  call GFPrnt_i(Temp(ipVal),n)

               End do
*              Put back the original mass
               Mass(j) = dMass2
            End do   ! End inner loop over atoms
*
         End Do
*        Put back the original mass
         Mass(i) = dMass1
      End Do ! End outer loop over atoms
*                                                                      *
************************************************************************
*                                                                      *
      End if
      Call GetMem('DefaultMass','FREE','REAL',ipDefMass,mAtoms)
*
*
      Return
      End
      Subroutine FREQ_i(nX,H,mass,Tmp1,Tmp2,EVec,EVal,iNeg)
      Implicit Real*8 (a-h,o-z)
      Real*8  Tmp1(nX,nX), Tmp2(nX,nX),H(nX,nX),
     &       EVec(2*nX,nX),
     &       EVal(2*nX),mass(*)

#include "constants2.fh"
*
      iprint=0
      call dcopy_(nX**2,[0.0d0],0,Tmp1,1)
      Do i = 1, nX
       ii=(i-1)/3+1
       Do j=1,nX
            H(i,j) = H(i,j)/mass(ii)
       End Do
      End Do
*
*-----Compute eigenvectors and eigenfunctions
*
      nAux = 2 * nX
      iOpt=1
      If ( nX.gt.0 ) then
        Call Not_DGeEv(iOpt,H,nX,
     &             EVal,EVec,nX,
     &             nX,Tmp2,nAux)
      End If
*
*-----Compute the harmonic frequencies
*
      iNeg=0
      Do 649 iHarm = 1, 2*nX, 2
         jHarm = (iHarm+1)/2
         temp = EVal(iHarm)
         If (temp.ge.0.0d0) Then
            EVal(jHarm) = Sqrt(temp)*autocm
         Else
            iNeg=iNeg+1
            EVal(jHarm) = -Sqrt(Abs(temp))*autocm
         End If
 649  Continue
      If (iPrint.ge.99) Call RecPrt('Converted EVal',' ',EVal,1,nX)
*
*-----Normalize
*
      Do iHarm = 1, nX
         r2=DDot_(nX,EVec(1,iHarm),2,EVec(1,iHarm),2)
         r2=1.0d0/Sqrt(r2)
         Call DScal_(nX,r2,EVec(1,iHarm),2)
      End Do
      If (iPrint.ge.99) Call RecPrt('Normalized EVec',' ',
     &                               EVec,nX*2,nX)
*
*-----Order, from low to high.
*
      Do iHarm = 1, nX-1
         Do jHarm = iHarm+1, nX
            If (EVal(jHarm).lt.EVal(iHarm)) Then
               rlow=EVal(iHarm)
               EVal(iHarm)=EVal(jHarm)
               EVal(jHarm)=rLow
               Call DSwap_(nX,EVec(1,iHarm),2,EVec(1,jHarm),2)
            End If
         End Do
      End Do
*
      Return
      End
      Subroutine GFPrnt_i(EVal,nDim)
      Implicit Real*8 (a-h,o-z)
      Real*8 EVal(nDim)
      Character*80 Format, Line*120
*
      LUt=6
      Inc = 6
      Do iHarm = 1, nDim, Inc
         Jnc=Min(Inc,nDim-iHarm+1)
         Write(Format,'(A,I3,A)') '(5X,A10,1x,',Jnc,'I10)'
         Write (LUt,Format) ' ',(i,i=iHarm,iHarm+Jnc-1)
         Write (LUt,*)
*
         Write(Format,'(A,I3,A)') '(A12,1x,',Jnc,'F10.2)'
         Line=' '
         Write (Line,Format) 'Freq.',(EVal(i),i=iHarm,iHarm+Jnc-1)
         Do i = 1, 120
            If (Line(i:i).eq.'-') Line(i:i)='i'
         End Do
         Write (LUt,'(5X,A)') Line
         Write (LUt,*)
*
         Write (LUt,*)
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine NOphase(a,n)
      Implicit Real*8 (a-h,o-z)
      Dimension a(n,n)
      sign=1.0d0
      Do 100 i=1,n
         If(sign*a(1,i).lt.0.0d0) Then
            Do 110 j=1,n
               a(j,i)=-a(j,i)
110         Continue
         End If
         sign=-sign
100   Continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine PCM_Cav_grd(Grad,nGrad)
      use PCM_arrays
      Implicit Real*8 (A-H,O-Z)
      Real*8 Grad(nGrad)
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
#include "WrkSpc.fh"
*
      iRout = 1
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the geometric contributions to
*     derivatives in solution
*
      Call GetMem('DerDM','Allo','Real',ip_DerDM,nTs*nTs)
      Call Get_nAtoms_All(MaxAto)
      Call GetMem('PCMGrd','Allo','Real',ip_PCMGrd,3*MaxAto)
      LcNAtm = ISlPar(42)
      Call GeoDer(LcNAtm,Conductor,nTs,nS,Eps,PCMSph,PCMiSph,PCM_N,
     &            PCMTess,PCM_SQ,Work(ip_DerDM),Work(ip_PCMGrd),
     &            dTes,dPnt,dRad,dCntr)
*     Call RecPrt('PCM_Cav_Grd','(5G20.10)',Work(ip_PCMGrd),3,MaxAto)
      Call GrdTr_Alaska(Work(ip_PCMGrd),MaxAto,Grad,nGrad)
      Call GetMem('PCMGrd','Free','Real',ip_PCMGrd,3*MaxAto)
      Call GetMem('DerDM','Free','Real',ip_DerDM,nTs*nTs)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine IFOCK(FC,NI,NJ,NK,FINI,II)

use Constants, only: Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: FC(*)
integer(kind=iwp), intent(in) :: NI, NJ, NK, II
real(kind=wp), intent(in) :: FINI
integer(kind=iwp) :: JKPOS

if (NI > 0) return
if ((NJ <= 0) .or. (NK <= 0)) return
JKPOS = NJ*(NJ-1)/2+NK
if (NK > NJ) JKPOS = NK*(NK-1)/2+NJ
if (II /= 0) then
  FC(JKPOS) = FC(JKPOS)+Two*FINI
else
  FC(JKPOS) = FC(JKPOS)-FINI
end if

return

end subroutine IFOCK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2002, Laura Gagliardi                                  *
!               2002, Roland Lindh                                     *
!***********************************************************************

subroutine Polar(ireturn)
!***********************************************************************
!      Author:Laura Gagliardi, Dipartimento di Chimica Fisica,         *
!             University of Palermo, ITALY. December 2002              *
!             Roland Lindh, Department of Chemical Physics, University *
!             of Lund, SWEDEN.                                         *
!***********************************************************************

use loprop_arrays, only: LP_context_type
use Data_Structures, only: Allocate_DT, Alloc1DArray_Type, Deallocate_DT
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
#include "Molcas.fh"
#include "timtra.fh"
integer(kind=iwp) :: i, i_f, iPert, iPlot, iPrint, lMax, LoProp_Mode, LuYou, mElem, MpProp_Level, nAtoms, nBas(8), nBas1, nBas2, &
                     nBasMax, nDim, nij, nOcOb, nOrb(8), nPert, nSize, nStateF, nStateI, nSym, nTemp, nThrs
real(kind=wp) :: Alpha, Bond_Threshold, CoC(3), Delta, Dlt, dLimmo(2), Energy_Without_FFPT, Ep, SubScale, Thrs1, Thrs2, ThrsMul
logical(kind=iwp) :: NoField, Standard, Utility, UserDen, PrintDen, SubtractDen, Restart, TDensity, Diffuse(3), Exists, LIonize
character(len=12) :: Opt_Method
type(LP_context_type) :: LP_context
type(Alloc1DArray_Type) :: D(0:6)
character(len=LenIn), allocatable :: LblCnt(:)
character(len=LenIn4), allocatable :: LblCnt4(:)
real(kind=wp), allocatable :: Cpl(:,:), CplT(:,:), EC(:,:), Ene_Occ(:), h0(:), MP(:,:,:), MPp(:,:), MPq(:), nxMP(:), Origin(:,:), &
                              Pol(:,:), sq_mu(:,:), sq_temp(:), tmp(:), TP(:), Ttot(:,:), Ttot_Inv(:,:), xMP(:), xxMP(:)
type(Alloc1DArray_Type), allocatable :: imu(:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
!define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
Utility = .false.
ireturn = 99
!                                                                      *
!***********************************************************************
!                                                                      *
! Prelude

call Init_LoProp(nSym,nBas,nOrb,CoC,nAtoms,LP_context,nSize,nBas1,nBas2,nBasMax)
!                                                                      *
!***********************************************************************
!                                                                      *
! Read the input
!
! NoField is defaulted to true if symmetry is implied.

NoField = nSym /= 1
call Readin_polar(NoField,Delta,MpProp_Level,Bond_Threshold,iPlot,iPrint,Standard,Opt_Method,UserDen,PrintDen,SubtractDen, &
                  SubScale,Restart,TDensity,nStateI,nStateF,Diffuse,dLimmo,Thrs1,Thrs2,nThrs,ThrsMul,Alpha,LIonize)
call mma_allocate(Ene_Occ,nBas1,label='Ene_Occ')
call InfoToMp(nSym,nBas,nBas1,Energy_Without_FFPT,Ene_Occ,nOcOb,UserDen,Restart)
!                                                                      *
!***********************************************************************
!                                                                      *
! Do the LoProp localization.

call mma_allocate(Ttot,nBas1,nBas1,label='Ttot')
call mma_allocate(Ttot_Inv,nBas1,nBas1,label='TtotInv')

call Localize_LoProp_Drv(Ttot,Ttot_Inv,nBas,LP_context%center,LP_context%otype,nBas1,nBas2,nSym,nBasMax,LP_context%PInv,Restart)

call mma_deallocate(LP_context%otype)
!                                                                      *
!***********************************************************************
!                                                                      *
! Read in the multipole moment integrals once and for all.

call Get_iScalar('Highest Mltpl',lMax)
write(u6,'(A,I2)') ' Multipole moments will be processed up to order ',lMax
write(u6,*)
mElem = (lMax+1)*(lMax+2)*(lMax+3)/6

nTemp = nBas1**2
call mma_allocate(tmp,nTemp,label='tmp')

call mma_allocate(Origin,[1,3],[0,lMax],label='Origin')
call mma_allocate(sq_mu,[1,nBas1**2],[0,mElem-1],label='sq_mu')
call mma_allocate(MPq,mElem,label='MPq')
call Allocate_DT(imu,[0,mElem-1],label='imu')
call Read_Multipole_Int(lMax,sq_mu,nBas,imu,Ttot,tmp,Origin,MPq,mElem,nBas1,nBas2,nBasMax,nTemp,nSym,LP_context%PInv,Restart, &
                        Utility)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the 1-particle density matrix

Dlt = -Delta
iPert = 0
call Get_Density_Matrix(D(0),nBas1,nBas2,nBasMax,nBas,nSym,LP_context%P,UserDen,PrintDen,SubtractDen,SubScale,LP_context%Q_Nuc, &
                        nAtoms,iPert,Restart,Utility,TDensity,nStateI,nStateF)

if (.not. NoField) then
  ! This assumes mElem >= 4, so lMax >= 1
  if (lMax < 1) call Abend()
  ! Read the one-electron hamiltonian.
  call mma_allocate(h0,nSize,label='h0')
  call Read_h0(nSize,h0,Restart)
  do iPert=1,6
    i_f = (iPert+1)/2
    Dlt = -Dlt
    if ((.not. Restart) .and. (.not. UserDen)) then
      call Comp_F(h0,imu(i_f)%A,nBas(1),Dlt,Ep,imu(0)%A,CoC(i_f),Origin(i_f,1))
    end if
    call Get_Density_Matrix(D(iPert),nBas1,nBas2,nBasMax,nBas,nSym,LP_context%P,UserDen,PrintDen,SubtractDen,SubScale, &
                            LP_context%Q_Nuc,nAtoms,iPert,Restart,Utility,TDensity,nStateI,nStateF)
  end do
  call mma_deallocate(h0)
end if
call Deallocate_DT(imu)
!                                                                      *
!***********************************************************************
!                                                                      *
!     S T A T I C   P R O P E R T I E S                                *
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute localized multipole moments

nPert = 2*3+1
if (NoField) nPert = 1
nij = (nAtoms*(nAtoms+1)/2)
call mma_allocate(MP,nij,mElem,nPert,label='MP')
call mma_allocate(sq_temp,nTemp,label='sq_temp')
call mma_allocate(EC,3,nij,label='EC')

call Local_Properties(LP_context%C,nAtoms,sq_mu,mElem,sq_temp,Origin,LP_context%center,Ttot_Inv,tmp,nij,nPert,D,MP,lMax,MPq,CoC, &
                      EC,LP_context%ANr,Standard,nBas1,nTemp,LP_context%Q_Nuc,Bond_Threshold,Opt_Method,iPlot,iPrint,nSym)

! If the dear user has requested to get diffuse distributions
! associated to the multipoles, go here.
if (Diffuse(1)) then
  call mma_allocate(TP,nAtoms,label='ToPoint')
  call mma_allocate(MPp,nij,mElem,label='NotToPoint')
  MPp(:,:) = MP(:,:,1)
  call CoreToPoint(nAtoms,MPp,TP)
  LuYou = IsFreeUnit(81)
  call OpnFl('DIFFPR',LuYou,Exists)
  call Diff_MotherGoose(Diffuse,nAtoms,nBas1,MPp,nij,EC,LP_context%ANr,Ttot,Ttot_Inv,lMax,TP,dLimmo,Thrs1,Thrs2,nThrs,iPrint, &
                        ThrsMul,LuYou)
  close(LuYou)
  call mma_deallocate(TP)
  call mma_deallocate(MPp)
end if

call mma_deallocate(Origin)
call mma_deallocate(sq_mu)
call mma_deallocate(Ttot)
call mma_deallocate(Ttot_Inv)
call mma_deallocate(sq_temp)
call mma_deallocate(LP_context%center)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(Pol,6,nij,label='Pol')
call mma_allocate(Cpl,6,nij,label='Cpl')
call mma_allocate(CplT,6,nij,label='CplT')

if (.not. NoField) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !      D Y N A M I C   P R O P E R T I E S                           *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute the fluctuating charges

  call Make_Fluctuating_Charges(nAtoms,LP_context%ANr,nij,nPert,MP,mElem,EC,Alpha)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Assemble the localized polarizabilities

  call Dynamic_Properties(tmp,nAtoms,MP,nij,nPert,mElem,Delta,EC,Pol,LP_context%ANr,Bond_Threshold,Cpl,CplT)

end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Print out the properties

call mma_allocate(LbLCnt,nAtoms,label='LblCnt')
call mma_allocate(LbLCnt4,nAtoms,label='LblCnt4')
call Get_cArray('LP_L',LblCnt4,LenIn4*nAtoms)
do i=1,nAtoms
  LblCnt(i) = LblCnt4(i)(1:LenIn)
end do
call mma_deallocate(LblCnt4)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate arrays needed in Print_Local

nDim = nij*mElem
call mma_allocate(xMP,nDim,label='xMP')
call mma_allocate(xxMP,nDim,label='xxMP')
call mma_allocate(nxMP,nDim,label='nxMP')
call Print_Local(MP,nij,mElem,LP_context%C,nAtoms,CoC,LP_context%Q_Nuc,lMax,LblCnt,MPq,EC,Pol,NoField,tmp,xMP,xxMP,nxMP, &
                 LP_context%ANr,nOcOb,Energy_Without_FFPT,Ene_Occ,MpProp_Level,Bond_Threshold,CplT,LIonize)

call mma_deallocate(LblCnt)
call mma_deallocate(Ene_Occ)
call mma_deallocate(xMP)
call mma_deallocate(xxMP)
call mma_deallocate(nxMP)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Pol)
call mma_deallocate(Cpl)
call mma_deallocate(CplT)

call mma_deallocate(MPq)
call mma_deallocate(EC)
call mma_deallocate(MP)
call mma_deallocate(tmp)
call mma_deallocate(LP_context%Q_Nuc)
call mma_deallocate(LP_context%ANr)
call mma_deallocate(LP_context%C)
call mma_deallocate(LP_context%P)
call mma_deallocate(LP_context%PInv)

! Set flag on runfile to identify that it can be used to restart a
! LoProp calculation in the future.

if (.not. Restart) then
  LoProp_Mode = 1
  if (NoField) then
    LoProp_Mode = 2
  end if
  call Put_iScalar('LoProp Restart',LoProp_Mode)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Cleanup so that finish will not scream.

nfld_tim = 0
nfld_stat = 0
!                                                                      *
!***********************************************************************
!                                                                      *
ireturn = 0
!                                                                      *
!***********************************************************************
!                                                                      *
end subroutine Polar

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

subroutine GASCI(ISM,ISPC)
! CI optimization in GAS space number ISPC for symmetry ISM
!
! Jeppe Olsen, Winter of 1995

use CandS, only: ICSM, ICSPC, ISSM, ISSPC
use lucia_data, only: Allocate_Local_Arrays, CBLTP, CI_VEC, CI1BT, CIBT, CLBT, CLEBT, Deallocate_Local_Arrays, ECORE, ECORE_ORIG, &
                      I12, I_ELIMINATE_GAS, I_RES_AB, IADVICE, IBSPGPFTP, ICISTR, IDC, IDIAG, IDISK, IGSOCC, IH1FORM, IPHGAS, &
                      IPRCIX, IREFSM, IRESTR, kvec3_length, LCSBLK, LUDIA, LUSC1, MNHL, MXINKA, MXNSTR, MXNTTS, MXPNGAS, MXPNSMST, &
                      MXSOOB, NCSF_PER_SYM, NELEC, NELFSPGP, NELFTP, NGAS, NHLFSPGP, NIRREP, NOBPT, NOBPTS, NOCSF, NOCTYP, NSMOB, &
                      NSTFSMSPGP, NSTSO, PSSIGN, VEC3, XISPSM
#ifdef _DEBUGPRINT_
use lucia_data, only: ICMBSPC, IGSOCCX, LCMBSPC
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ISM, ISPC
integer(kind=iwp) :: IATP, IATPM1, IATPM2, IBTP, IBTPM1, IBTPM2, IOCCLS_ARR(1), IOCTPA, IOCTPB, LBLOCK, LSCR12, LSCR2, MAXA, &
                     MAXA1, MAXB, MAXB1, MAXK, MX_NSPII, MXADKBLK, MXADKBLK_AS, MXCIJA, MXCIJAB, MXCIJB, MXCJ, MXCJ_ALLSYM, &
                     MXSTBL, MXSTBL0, MXSXBL, NAEL, NBATCH, NBEL, NBLOCK, NDET, NEL, NOCCLS, NOCTPA, NOCTPB, NTTS, NVAR, ZERO_ARR(1)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IGAS, II, JGASSPC, JJGASSPC
#endif
real(kind=wp) :: SHIFT
integer(kind=iwp), allocatable :: CIOIO(:), SVST(:)
integer(kind=iwp), external :: IMNMX

!MXACJ = 0
!MXACIJ = 0
!MXAADST = 0
! Normal integrals accessed
IH1FORM = 1
I_RES_AB = 0
! CI not CC
! Not just number conserving part
!IH_OCC_CONS_TEST = 0
!if (IH_OCC_CONS_TEST == 1) then
!  write(u6,*) ' IH_OCC_CONS set to one in GASCI'
!  IH_OCC_CONS = 1
!end if

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ====================================='
write(u6,*) ' Control has been transferred to GASCI'
write(u6,*) ' ====================================='
write(u6,*)
write(u6,'(A)') '  A few pertinent data :'
write(u6,*)
write(u6,'(A,I2)') '  CI space         ',ISPC
write(u6,*)
write(u6,*) ' Number of GAS spaces included ',LCMBSPC(ISPC)
write(u6,'(A,10I3)') '  GAS spaces included           ',(ICMBSPC(II,ISPC),II=1,LCMBSPC(ISPC))
write(u6,*)
write(u6,*) ' Occupation constraints :'
write(u6,*) '========================='
write(u6,*)
write(u6,*)
do JJGASSPC=1,LCMBSPC(ISPC)
  JGASSPC = ICMBSPC(JJGASSPC,ISPC)
  write(u6,*) ' Gas space  Min acc. occupation Max acc. occupation'
  write(u6,*) ' =================================================='
  do IGAS=1,NGAS
    write(u6,'(3X,I2,13X,I3,16X,I3)') IGAS,IGSOCCX(IGAS,1,JGASSPC),IGSOCCX(IGAS,2,JGASSPC)
  end do
end do
#endif

NDET = int(XISPSM(ISM,ISPC))
!NEL = NELCI(ISPC)
NEL = 0
#ifdef _DEBUGPRINT_
write(u6,*) ' Number of determinants/combinations  ',NDET
#endif
if (NDET == 0) then
  write(u6,*) ' The number of determinants/combinations is zero.'
  write(u6,*) ' I am sure that fascinating discussions about'
  write(u6,*) ' the energy of such a wave function exists,'
  write(u6,*) ' but I am just a dumb program, so I will stop'
  write(u6,*)
  write(u6,*) ' GASCI : Vanishing number of parameters'
  !stop ' GASCI : Vanishing number of parameters'
  call SYSABENDMSG('lucia_util/gasci','User error','')
end if
! Transfer to CANDS
ICSM = ISM
ISSM = ISM
ICSPC = ISPC
ISSPC = ISPC
! Complete operator
I12 = 2
! Class info
!if (ICLSSEL == 1) then
! Number of occupation classes
IATP = 1
IBTP = 2
NEL = NELFTP(IATP)+NELFTP(IBTP)
call OCCLS(1,NOCCLS,IOCCLS_ARR,NEL,NGAS,IGSOCC(:,1),IGSOCC(:,2),0,ZERO_ARR,NOBPT)

if (NOCSF == 1) then
  NVAR = NDET
else
  !*JESPER : Addition start
  !NVAR = NCSASM(ISM)
  NVAR = NCSF_PER_SYM(ISM)
  !*JESPER : Addition end
end if
#ifdef _DEBUGPRINT_
write(u6,*) '  NVAR in GASCI ',NVAR
#endif
! Allocate memory for diagonalization
!if (ISIMSYM == 0) then
LBLOCK = MXSOOB
!else
!  LBLOCK = MXSOOB_AS
!end if
LBLOCK = max(LBLOCK,LCSBLK)
! JESPER : Should reduce I/O
LBLOCK = max(int(XISPSM(IREFSM,1)),MXSOOB)
if (PSSIGN /= Zero) LBLOCK = int(Two*XISPSM(IREFSM,1))

! Information about block structure- needed by new PICO2 routine.
! Memory for partitioning of C vector
IATP = 1
IBTP = 2
NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)
NTTS = MXNTTS
call Allocate_Local_Arrays(NTTS,NIRREP)
! Additional info required to construct partitioning
call mma_allocate(CIOIO,NOCTPA*NOCTPB,Label='CIOIO')

call IAIBCM(ISPC,CIOIO)
call mma_allocate(SVST,1,Label='SVST')
call ZBLTP(ISM,NIRREP,IDC,CBLTP,SVST)
call mma_deallocate(SVST)

! Batches  of C vector
call PART_CIV2(IDC,NSTSO(IATP)%A,NSTSO(IBTP)%A,NOCTPA,NOCTPB,NIRREP,CIOIO,ISM,NBATCH,CLBT,CLEBT,CI1BT,CIBT,0)
! Number of BLOCKS
NBLOCK = CI1BT(NBATCH)+CLBT(NBATCH)-1

! Enabling the calculation of excited states in a new way. Lasse
! This can be realized for GAS1 to GASN (for the GAS version)
! Here we find which type should be eliminated in the diagonal and
! in the sigma vector calculation. This to satisfy RASSI.
! Insert if statement
if (I_ELIMINATE_GAS >= 1) call I_AM_SO_EXCITED(NBATCH,CIBT,CLBT,CI1BT)
! End of story for Lasse

call mma_deallocate(CLBT)
call mma_deallocate(CLEBT)
! Length of each block
call EXTRROW(CIBT,8,8,NBLOCK,CI1BT)
call mma_deallocate(CI1BT)

! Class divisions of dets
! (Well, in principle I am against class division, but I
!  realize that it is a fact so ...)

! If PICO2/SBLOCK are used, three blocks are used in PICO2, so...

! Largest block of strings in zero order space
MXSTBL0 = MXNSTR
! type of alpha and beta strings
IATP = 1
IBTP = 2
! alpha and beta strings with an electron removed
IATPM1 = 3
IBTPM1 = 4
! alpha and beta strings with two electrons removed
IATPM2 = 5
IBTPM2 = 6

NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)
! Largest number of strings of given symmetry and type
MAXA = 0
if (NAEL >= 1) then
  MAXA1 = IMNMX(NSTSO(IATPM1)%A,NIRREP*NOCTYP(IATPM1),2)
  !write(u6,*) ' MAXA1 1',MAXA1
  MAXA = max(MAXA,MAXA1)
  if (NAEL >= 2) then
    MAXA1 = IMNMX(NSTSO(IATPM2)%A,NIRREP*NOCTYP(IATPM2),2)
    MAXA = max(MAXA,MAXA1)
  end if
end if
MAXB = 0
if (NBEL >= 1) then
  MAXB1 = IMNMX(NSTSO(IBTPM1)%A,NIRREP*NOCTYP(IBTPM1),2)
  MAXB = max(MAXB,MAXB1)
  if (NBEL >= 2) then
    MAXB1 = IMNMX(NSTSO(IBTPM2)%A,NIRREP*NOCTYP(IBTPM2),2)
    MAXB = max(MAXB,MAXB1)
  end if
end if
MXSTBL = max(MAXA,MAXB,MXSTBL0)
if (IPRCIX >= 2) write(u6,*) ' Largest block of strings with given symmetry and type',MXSTBL
! Largest number of resolution strings and spectator strings
! that can be treated simultaneously
MAXK = min(MXINKA,MXSTBL)
! scratch space for projected matrices and a CI block

! Scratch space for CJKAIB resolution matrices
! Size of C(Ka,Jb,j),C(Ka,KB,ij)  resolution matrices
IOCTPA = IBSPGPFTP(IATP)
IOCTPB = IBSPGPFTP(IBTP)
call MXRESCPH(CIOIO,IOCTPA,IOCTPB,NOCTPA,NOCTPB,NIRREP,NSTFSMSPGP,MXPNSMST,NSMOB,MXPNGAS,NGAS,NOBPTS,MAXK,NELFSPGP,MXCJ,MXCIJA, &
              MXCIJB,MXCIJAB,MXSXBL,MXADKBLK,IPHGAS,NHLFSPGP,MNHL,IADVICE,MXCJ_ALLSYM,MXADKBLK_AS,MX_NSPII)
if (IPRCIX >= 2) then
  write(u6,*) 'GASCI  : MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL',MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL
  write(u6,*) ' MXADKBLK, MXADKBLK_AS',MXADKBLK,MXADKBLK_AS
end if
!if (ISIMSYM == 1) then
!  MXCJ = MAX(MXCJ_ALLSYM,MX_NSPII)
!  MXADKBLK_AS = MXADKBLK
!end if
! Using hardwired routines, MXCIJAB also used
LSCR2 = max(MXCJ,MXCIJA,MXCIJB,MXCIJAB,MX_NSPII)
if (IPRCIX >= 2) write(u6,*) ' Space for two resolution matrices ',2*LSCR2
LSCR12 = max(LBLOCK,2*LSCR2)
call mma_allocate(VEC3,LSCR12,Label='VEC3')
KVEC3_LENGTH = max(LSCR12,2*LBLOCK,KVEC3_LENGTH)

! CI diagonal - if required

if (IDIAG == 2) LUDIA = LUSC1
if (.not. ((IDIAG == 2) .and. (IRESTR == 1))) then
  if (ICISTR >= 2) IDISK(LUDIA) = 0
  I12 = 2
  SHIFT = ECORE_ORIG-ECORE
   ! Note that CI_VEC is used as a scratch array here and below.
  call GASDIAT(CI_VEC,LUDIA,SHIFT,ICISTR,I12,CBLTP,NBLOCK,CIBT)

  if ((NOCSF == 1) .and. (ICISTR == 1)) then
    IDISK(LUDIA) = 0
    call TODSC(CI_VEC,NVAR,-1,LUDIA)
  end if
  if (IPRCIX >= 2) write(u6,*) ' Diagonal constructed'
else
  write(u6,*) ' Diagonal not calculated'
end if

call Deallocate_Local_Arrays()
call mma_deallocate(CIOIO)
call mma_deallocate(VEC3)

end subroutine GASCI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine change7_cvb()
      implicit real*8 (a-h,o-z)
      logical changed
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "rls_cvb.fh"
      save icase

c  Inconsequential work arrays
      changed=.false.
      if((imethod.ne.4.and.ifinish.eq.0).or.
     >  (ifinish.eq.1.or.ifinish.eq.2))then
        icase=1
      elseif(imethod.eq.4.and.icrit.eq.1.and.ifinish.eq.0)then
        icase=2
      elseif(imethod.eq.4.and.icrit.eq.2.and.ifinish.eq.0)then
        icase=3
      else
        icase=4
      endif
      if(chpcmp_cvb(icase))changed=.true.
      if(changed)call touch_cvb('MEM7')
      return

      entry chop7_cvb()
      if(release(7))call mfreer_cvb(lw(1))
      release(7)=.true.
      release(8)=.false.

      if(icase.eq.1)then
        lw(1)= mstackr_cvb(norb*norb)
        lw(2)= mstackr_cvb(norb*norb)
        lw(3)= mstackr_cvb(norb*norb)

        lw(4)= mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))
        lw(5)= mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))
        lw(6)= mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))

        lw(7)= mstackr_cvb(nvb)
        lw(8)= mstackr_cvb(nvb)
        lw(9)= mstackr_cvb(ndetvb)
        lw(10)=mstackr_cvb(ndetvb)
        lw(11)=mstackr_cvb(ndetvb)
      elseif(icase.eq.2)then
        lw(1)= mstackr_cvb(norb*norb)
        lw(2)= mstackr_cvb(norb*norb)
        lw(3)= mstackr_cvb(norb*norb)

        lw(4)= mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))
        lw(5)= mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))
        lw(6)= mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))

        lw(7)= mstackr_cvb(nvb)
        lw(8)= mstackr_cvb(nvb)
        lw(9)= mstackr_cvb(ndetvb)
        lw(10)=mstackr_cvb(ndetvb)
        lw(11)=mstackr_cvb(ndetvb)
      elseif(icase.eq.3)then
        lw(1)= mstackr_cvb(norb*norb)
        lw(2)= mstackr_cvb(norb*norb)
        lw(3)= mstackr_cvb(norb*norb)

        lw(4)= mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))
        lw(5)= mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))
        lw(6)= mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))

        lw(7)= mstackr_cvb(nvb)
        lw(8)= mstackr_cvb(nvb)
        lw(9)= mstackr_cvb(ndetvb)
        lw(10)=mstackr_cvb(ndetvb)
        lw(11)=mstackr_cvb(ndetvb)
      endif
      if(anyslater)then
        nvb_alloc=ndetvb
      else
        nvb_alloc=ndetvb
      endif
      lw(12)=mstackr_cvb(norb*norb)
      lw(13)=mstackr_cvb(nvb_alloc)

      lv(5)=mstackr_cvb(ndetvb)

      ibasemx=max(ibasemx,mstackr_cvb(0))

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Pot_nuc(CCoor,pot,nGrid)

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nGrid
real(kind=wp), intent(in) :: CCoor(3,nGrid)
real(kind=wp), intent(out) :: pot(nGrid)
integer(kind=iwp) :: iDCRT(0:7), iGrid, iStabM(0:7), kCnt, kCnttp, kdc, lDCRT, LmbdT, nDCRT, nstabm
real(kind=wp) :: C(3), Fact, r12, TC(3)

! compute nuclear contribution to potential

pot(:) = Zero

!hjw is this always correct?
istabm(0) = 0
nstabm = 1

kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (dbsc(kCnttp)%Charge == Zero) cycle

  do kCnt=1,dbsc(kCnttp)%nCntr

    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    do lDCRT=0,nDCRT-1
      call OA(iDCRT(lDCRT),C,TC)

      do iGrid=1,nGrid
        r12 = sqrt((TC(1)-CCoor(1,iGrid))**2+(TC(2)-CCoor(2,iGrid))**2+(TC(3)-CCoor(3,iGrid))**2)
        if (r12 > 1.0e-8_wp) pot(iGrid) = pot(iGrid)+dbsc(kCnttp)%Charge*fact/r12
      end do

    end do
  end do
end do

return

end subroutine Pot_nuc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_Tra(COcc,CVir,Diag,DoDiag)
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: transform Cholesky vectors to (ai) MO basis.

use Cholesky, only: nSym
use ChoMP2, only: nT1am
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: COcc(*), CVir(*)
real(kind=wp), intent(inout) :: Diag(*)
logical(kind=iwp), intent(in) :: DoDiag
integer(kind=iwp) :: iSym, kOffD, lW
real(kind=wp), allocatable :: TraMax(:)

! Allocate remaining memory.
! --------------------------

call mma_maxDBLE(lw)
call mma_allocate(TraMax,lw,Label='TraMax')

kOffD = 1
do iSym=1,nSym

  ! Open files for MO vectors.
  ! --------------------------

  call ChoMP2_OpenF(1,1,iSym)

  ! Transform vectors.
  ! ------------------

  call ChoMP2_Tra_1(COcc,CVir,Diag(kOffD),DoDiag,TraMax,lW,iSym)
  if (DoDiag) kOffD = kOffD+nT1am(iSym)

  ! Close files for MO vectors.
  ! ---------------------------

  call ChoMP2_OpenF(2,1,iSym)

end do

! Free memory.
! ------------

call mma_deallocate(TraMax)

end subroutine ChoMP2_Tra

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! s-s interaction, normal case.
function CoulTN_1(RA,RB,C,dSepInv,ExpA,ExpB)

use Constants, only: One, Two, Quart
use Definitions, only: wp

implicit none
real(kind=wp) :: CoulTN_1
real(kind=wp), intent(in) :: RA, RB, C, dSepInv, ExpA, ExpB
real(kind=wp) :: T1, T2, TA, TB

T1 = Quart*(Two+C)
T2 = Quart*RA
TA = (One-C)**2*(T1+T2)*ExpA
T1 = Quart*(Two-C)
T2 = Quart*RB
TB = (One+C)**2*(T1+T2)*ExpB
CoulTN_1 = dSepInv*(One-TA-TB)

return

end function CoulTN_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine PSOAO1(nSO,MemPrm,MemMax,
     &                            iAnga, iCmpa,  iAO,     iFnc,
     &                            iBas,  iBsInc, jBas,  jBsInc,
     &                            kBas,  kBsInc, lBas,  lBsInc,
     &                            iPrim, iPrInc, jPrim, jPrInc,
     &                            kPrim, kPrInc, lPrim, lPrInc,
     &                            ipMem1,ipMem2,
     &                            Mem1,  Mem2,  MemPSO)
************************************************************************
*                                                                      *
*  Object: to partion the SO and AO block. It will go to some length   *
*          before it will start and break up the SO block. This will   *
*          reduce the total flop count. However, as we are breaking up *
*          the AO block this will affect the vectorization. Hence, at  *
*          some point it will actually be better to recompute the      *
*          primitives.                                                 *
*          Current stratergy:                                          *
*          1. Start reducing the length of the primitives in the order *
*             lPrim,jPrim.                                             *
*          2. Reduce the size of the SO block by reducing the number of*
*             basis functions in the order lBas, jBas.                 *
*          3. Terminate run telling job max and min of additional      *
*             memory needed to perform the calculation.                *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified to first order derivatives. January '92         *
************************************************************************
      use aces_stuff, only: nGamma, Gamma_On
      use PSO_Stuff
      use SOAO_Info, only: iAOtSO
      use Temporary_parameters, only: force_part_c, force_part_p
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "lCache.fh"
#include "pstat.fh"
      Integer   iAnga(4), iCmpa(4), nPam(4,0:7), iiBas(4),
     &          iFnc(4), iAO(4)
      Logical QiBas, QjBas, QkBas, QlBas, QjPrim, QlPrim, Fail
      Integer   iTwoj(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
*
*     Statement function to compute canonical index
*
      nElem(i) = (i+1)*(i+2)/2
*
      iRout = 10
      iPrint = nPrint(iRout)
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      iCmp = iCmpa(1)
      jCmp = iCmpa(2)
      kCmp = iCmpa(3)
      lCmp = iCmpa(4)
      iTotal = iTotal + 1
      mabcd=nElem(la)*nElem(lb)*nElem(lc)*nElem(ld)
      nabcd=iCmp*jCmp*kCmp*lCmp
*
      If (force_part_c) Then
         iBsInc = (iBas+1)/2
         jBsInc = (jBas+1)/2
         kBsInc = (kBas+1)/2
         lBsInc = (lBas+1)/2
      Else
         iBsInc = iBas
         jBsInc = jBas
         kBsInc = kBas
         lBsInc = lBas
      End If
      If (force_part_p) Then
         jPrInc = (jPrim+1)/2
         lPrInc = (lPrim+1)/2
      Else
         jPrInc = jPrim
         lPrInc = lPrim
      End If
      iPrInc = iPrim
      kPrInc = kPrim
*
 999  Continue
      QjPrim = .False.
      QlPrim = .True.
      QiBas  = .False.
      QjBas  = .False.
      QkBas  = .False.
      QlBas  = .False.
      Mem0 = MemMax
*
*-----*** Work1 ***
*
*-----Memory for 2nd order density matrix in SO basis.
*
      kSOInt = nSO*iBsInc*jBsInc*kBsInc*lBsInc
      Mem1 = kSOInt
*
*-----Allocate memory for MO to SO/AO transformation
*     of the 2nd order density matrix for this shell quadruplet.
*
      If (lPSO) Then
         iiBas(1) = iBsInc
         iiBas(2) = jBsInc
         iiBas(3) = kBsInc
         iiBas(4) = lBsInc
         Call ICopy(4*8,[0],0,nPam,1)
         MemPSO = 1
         nTmp2 = 0
*
         Do jPam = 1, 4
            iTmp1= 0
            nTmp1= 0
            Do j = 0, nIrrep-1
               Do i1 = 1, iCmpa(jPam)
                  If (iAOtSO(iAO(jPam)+i1,j)>0) Then
                      nPam(jPam,j) = nPam(jPam,j) + iiBas(jPam)
                      nTmp1= nTmp1+ iiBas(jPam)
                      iTmp1= iTmp1+ 1
                  End If
               End Do
            End Do
            MemPSO = MemPSO * nTmp1
            nTmp2 = nTmp2 + nTmp1
            iFnc(jPam) = iTmp1
         End Do
         MemScr=MemTra(nPam)
         nFac = 4
         nTmp2 = nTmp2 + 4
      Else
         MemScr=0
         MemPSO=0
         nFac = 0
         nTmp2 = 0
      End If
      MemAux0= MemPSO + MemScr + nFac*S%nDim + nTmp2 + 4
      If (Mem1+1+MemAux0.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem1+1+MemAux0-Mem0)
         QjPrim = .False.
         QlPrim = .False.
         QiBas  = .False.
         QjBas  = .False.
         QkBas  = .False.
         QlBas  = .True.
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) ' Memory allocation failed for Work1'
            Write (6,'(2I3,L1,2I3,L1)')
     &            iBas, iBsInc,QiBas, kBas, kBsInc,QkBas
            Write (6,'(2I3,L1,2I3,L1)')
     &            jBas, jBsInc,QjBas, lBas, lBsInc,QlBas
            Write (6,'(2I3,L1,2I3,L1)')
     &            jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim
            Write (6,*) MemMax,Mem0,Mem1,MemAux0+1
            Write (6,*) MemPSO,MemScr,4*S%nDim,nTmp2+4
            Call Abend()
         End If
         Go To 999
      End If
*-----Subtracte one additional word for getmem's internal error check
      Mem0 = Mem0 - Mem1 - 1
*
*-----*** Work2 and Work4 ***
*
*-----Memory for 2nd order density matrix in contracted basis (both
*     cartesian and spherical harmonic) and in primitive basis.
*     MemDeP: Target for desymmetrization
*     MemTrn: Scratch and target for decontraction
*     MemAux: Contracted 2nd order density matrix (if partial decon.)
*     MemSph: transformation spherical harmonics to cartesian, source
*             and target.
*     nGamma: temporary storage of bins as read from file.
*
      If (Gamma_On) Then
         iiBas(1) = iBas
         iiBas(2) = jBas
         iiBas(3) = kBas
         iiBas(4) = lBas
         nGamma = 1
*
         Do jPam = 1, 4
            nTmp1= 0
            Do j = 0, nIrrep-1
               Do i1 = 1, iCmpa(jPam)
                  If (iAOtSO(iAO(jPam)+i1,j)>0) Then
                      nTmp1= nTmp1+ iiBas(jPam)
                  End If
               End Do
            End Do
            nGamma = nGamma * nTmp1
         End Do
      Else
         nGamma=0
      End If
*
      MemDeP = nabcd * iBsInc*jBsInc*kBsInc*lBsInc
*
      MemTrn = mabcd * Max(iBsInc*jBsInc*kBsInc*lBsInc,
     &                     iPrInc*jPrInc*kPrInc*lPrInc)
*-----If partial decontraction we need to keep the contracted 2nd
*     order density matrix. (Work4)
      If (jPrInc.ne.jPrim .or. lPrInc.ne.lPrim) Then
         MemAux = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
      Else
         MemAux = 0
      End If
      MemSph = mabcd * iBsInc*jBsInc*kBsInc*lBsInc
      Mem2 = Max(MemTrn+MemAux,MemDeP,MemSph,nGamma+MemAux0)
      If (Mem2+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem2+1-Mem0)
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) ' Memory allocation failed for Work2'
            Write (6,'(2I3,L1,2I3,L1)')
     &            iBas, iBsInc,QiBas, kBas, kBsInc,QkBas
            Write (6,'(2I3,L1,2I3,L1)')
     &            jBas, jBsInc,QjBas, lBas, lBsInc,QlBas
            Write (6,'(2I3,L1,2I3,L1)')
     &            jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim
            Write (6,*) MemMax,Mem0,Mem1,Mem2
            Call Abend()
         End If
         Go To 999
      End If
*-----Subtracte one additional word for getmem's internal error check
      Mem0 = Mem0 - Mem2 - 1
*
*-----*** Work3 and Work5 ***
*
*-----Scratch for decontraction and transformation to spherical gaussian.
*     Working array for Rysg1.
*     Scratch area for resolving degeneracies due to the double coset
*     treatement of the symmetry.
*     MemTrn: Scratch for decontraction
*     MemRys: Scratch for calualation of primitive integral gradients.
*     MemScr: Scratch for prescreening
*
*     If mabcd=/=1 we need to do a transpose!
      iFac = 0
      If (mabcd.ne.1) iFac = 1
*
      nCache = (3*lCache)/4 - iBas*iPrim - jBas*jPrim
      lSize= iBsInc*jBsInc + Max(iBsInc*jPrInc,iPrInc*jBsInc)
      nVec1 = kBsInc*lBsInc * mabcd
      IncVec = Min(Max(1,nCache/lSize),nVec1)
      nA2 = Max(iBsInc*jPrInc,iPrInc*jBsInc)*IncVec
      nA3 = iPrInc*jPrInc*nVec1
      MemTrn=nA2+nA3
*
      nCache = (3*lCache)/4 - kBas*kPrim - lBas*lPrim
      lSize= kBsInc*lBsInc + Max(kBsInc*lPrInc,kPrInc*lBsInc)
      nVec1 = iPrInc*jPrInc * mabcd
      IncVec = Min(Max(1,nCache/lSize),nVec1)
      nA2 = Max(kBsInc*lPrInc,kPrInc*lBsInc)*IncVec
      MemTrn=Max(MemTrn,nA3+nA2,
     &           iFac*mabcd*iBsInc*jBsInc*kBsInc*lBsInc)
*
************************************************************************
*
      nCache = (3*lCache)/4 - kBas*kPrim - lBas*lPrim
      lSize= kBsInc*lBsInc + Max(kBsInc*lPrInc,kPrInc*lBsInc)
      nVec1 = iBsInc*jBsInc * mabcd
      IncVec = Min(Max(1,nCache/lSize),nVec1)
      nA2 = Max(kBsInc*lPrInc,kPrInc*lBsInc)*IncVec
      nA3 = kPrInc*lPrInc*nVec1
      MemTrn=Max(MemTrn,nA3+nA2)
*
      MemTrn=Max(MemTrn,nA2+nA3)
      nCache = (3*lCache)/4 - iBas*iPrim - jBas*jPrim
      lSize= iBsInc*jBsInc + Max(iBsInc*jPrInc,iPrInc*jBsInc)
      nVec1 = kPrInc*lPrInc * mabcd
      IncVec = Min(Max(1,nCache/lSize),nVec1)
      nA2 = Max(iBsInc*jPrInc,iPrInc*jBsInc)*IncVec
*
      MemTrn=Max(MemTrn,nA2+nA3,
     &           iFac*mabcd*iBsInc*jBsInc*kBsInc*lBsInc)
*
      MemRys=MemPrm * iPrInc*jPrInc*kPrInc*lPrInc
      MemScr=(2*mabcd+1)*iPrInc*jPrInc*kPrInc*lPrInc
     &      +iPrInc*jPrInc+kPrInc*lPrInc
      Mem3 = Max(MemTrn, MemRys, MemScr)
      If (Mem3+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem3+1-Mem0)
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) ' Memory allocation failed for Work3'
            Write (6,'(2I3,L1,2I3,L1)')
     &            iBas, iBsInc,QiBas, kBas, kBsInc,QkBas
            Write (6,'(2I3,L1,2I3,L1)')
     &            jBas, jBsInc,QjBas, lBas, lBsInc,QlBas
            Write (6,'(2I3,L1,2I3,L1)')
     &            jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim
            Write (6,*) MemMax,Mem0,Mem1,Mem2,Mem3
            Write (6,*) MemTrn,MemRys,MemPrm
            Call Abend()
         End If
         Go To 999
      End If
*-----Subtracte one additional word for getmem's internal error check
      Mem0 = Mem0 - Mem3 - 1
      MinXtr = Min(MinXtr,Mem0)
*
      MemSum=Mem1+Mem2+Mem3
      Mem2 = Mem2 + Mem3
*
      ipMem2 = ipMem1 + Mem1
*
      r1 = r1 + DBLE(iBsInc)/DBLE(iBas)
      r2 = r2 + DBLE(jBsInc)/DBLE(jBas)
      r3 = r3 + DBLE(kBsInc)/DBLE(kBas)
      r4 = r4 + DBLE(lBsInc)/DBLE(lBas)
      q1 = q1 + DBLE(iPrInc)/DBLE(iPrim)
      q2 = q2 + DBLE(jPrInc)/DBLE(jPrim)
      q3 = q3 + DBLE(kPrInc)/DBLE(kPrim)
      q4 = q4 + DBLE(lPrInc)/DBLE(lPrim)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RBuf_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IST,IADXS)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: LUHLFX, LL, LBuf, NOTU, KKTU, IADXS
real(kind=wp), intent(_OUT_) :: W(*)
integer(kind=iwp), intent(out) :: IST
!integer(kind=iwp) :: BLKSZ, MEMX, NBLCK

!call mma_maxDBLE(MEMX)
!BLKSZ = (NOTU-1)*IADXS
!NBLCK = MEMX/BLKSZ

!if ((NBLCK > 1) .and. (LBuf < 256)) then
!  call RBufF_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IADXS,MEMX)
!else
call RBufO_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IADXS)
!end if
IST = 1

return

end subroutine RBuf_tra2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine WEIGHT_SPGP(Z,NORBTP,NELFTP,NORBFTP,ISCR)
! construct vertex weights for given supergroup
!
! Reverse lexical ordering is used

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: Z(*), ISCR(*)
integer(kind=iwp), intent(in) :: NORBTP, NELFTP(NORBTP), NORBFTP(NORBTP)
integer(kind=iwp) :: KLFREE, KLMAX, KLMIN, KW, NEL, NORB

NORB = sum(NORBFTP)
NEL = sum(NELFTP)

#ifdef _DEBUGPRINT_
write(u6,*) ' Subroutine WEIGHT_SPGP in action'
write(u6,*) ' ================================'
write(u6,*) 'NELFTP'
call IWRTMA(NELFTP,1,NORBTP,1,NORBTP)
#endif

KLFREE = 1
KLMAX = KLFREE
KLFREE = KLFREE+NORB

KLMIN = KLFREE
KLFREE = KLFREE+NORB

KW = KLFREE
KLFREE = KW+(NEL+1)*(NORB+1)
! Max and min arrays for strings
call MXMNOC_SPGP(ISCR(KLMIN),ISCR(KLMAX),NORBTP,NORBFTP,NELFTP)
! Arc weights
call GRAPW(ISCR(KW),Z,ISCR(KLMIN),ISCR(KLMAX),NORB,NEL)

end subroutine WEIGHT_SPGP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine InitDB(nMult,natom,nAtQM,nGrdPt,Cord,Grid,T,TT,TTT,Ext,DB,IsMM)
! Compute DB = d(ExtPot[TtT^-1]Tt)/dq

use espf_global, only: MxExtPotComp
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nMult, natom, nAtQM, nGrdPt, IsMM(natom)
real(kind=wp), intent(in) :: Cord(3,natom), Grid(3,nGrdPt), T(nMult,nGrdPt), TT(nMult,nMult), TTT(nGrdPt,nMult), &
                             Ext(MxExtPotComp,natom)
real(kind=wp), intent(out) :: DB(nGrdPt,3,nAtQM)
real(kind=wp), allocatable :: DT(:,:,:,:), DTT(:,:,:,:), DTTT(:,:,:,:), DTTTT(:,:,:,:)

! Various derivatives

call mma_allocate(DT,nMult,nGrdPt,3,nAtQM,label='DT')
call mma_allocate(DTT,nMult,nMult,3,nAtQM,label='DTT')
call mma_allocate(DTTT,nMult,nGrdPt,3,nAtQM,label='DTTT')
call mma_allocate(DTTTT,nMult,nMult,3,nAtQM,label='DTTTT')

call CalcDT(nMult,nGrdPt,natom,nAtQM,IsMM,Cord,Grid,T,TT,DT,DTT,DTTTT,DTTT)

call mma_deallocate(DT)
call mma_deallocate(DTT)
call mma_deallocate(DTTTT)

! Finally dB = dTTT * V_ext + TTT * dV_ext

call CalcDB(nMult,nGrdPt,natom,nAtQM,IsMM,TTT,DTTT,Ext,DB)
call mma_deallocate(DTTT)

return

end subroutine InitDB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! calculate dd, ss and tt space
subroutine dd_drt_ci_new()

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, int_dd_drl, int_dd_offset, ipae, ipael, jml, jmr, jpad, jpadl, jpadlr, &
                         linelp, lpblock_dd, v_onevsqtwo, v_sqthreevsqtwo, w0gdd, w1gdd
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: jptyl, jptyr, lpb

w0gdd = v_onevsqtwo
w1gdd = -v_sqthreevsqtwo
idisk_lp = idisk_array(3)

do lpb=1,lpblock_dd
  call read_lp()
  IpaeL = iml+1
  Ipae = imr+1
  int_dd_drl = int_dd_offset(iml,imr)
  call logicg_dd(iml,imr)
  call get_jpty(jpadlr,jptyl,jptyr)
  call get_jp(jptyl,jml,jpadl,1)
  call get_jp(jptyr,jmr,jpad,1)
  !JMLR = Mul(JML,JMR)
  if (linelp <= 12) then
    call dd_ext_head_in_act()
  else
    call dd_ext_head_in_dbl()
  end if
end do

return

end subroutine dd_drt_ci_new

subroutine dd_ext_head_in_dbl()

use gugaci_global, only: ipae, ipael, jb_sys, jml, jmr, jpad, jpadl, jpadlr, jud, just, linelp, logic_dh, lp_lwei, lp_rwei, &
                         lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, nlg1, nlg2, norb_dz, norb_frz, vplp_w0, vplp_w1, &
                         vplpnew_w0, vplpnew_w1, w0_dd, w0_dv, w0_sd, w0_ss, w0_td, w0_tt, w0_vv, w1_dd, w1_ss, w1_st, w1_tt
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lmk, lmki, lpok, lr0, lra, lri, lrj, lrk, mpl, ni, nk
real(kind=wp) :: w0dd1, w0dd2, w0dd3, w0dv1, w0sd1, w0sd2, w0sd3, w0sd4, w0ss15, w0ss17, w0ss20, w0td1, w0tt2, w0tt3, w1dd1, &
                 w1dd2, w1ss15, w1ss17, w1tt2
integer(kind=iwp), external :: iwalk_ad

LOGIC_DH = .true.
JMLR = Mul(JML,JMR)
LPOK = JPADLR
select case (LPOK)
  case (1)
    !===================================================================
    ! SS(1)   ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
    ! SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
    ! SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
    ! SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
    ! SS(1-16) (11)-Drl(22)-         ACT -C"-
    ! SS(1-18) Drl(11)-C"(22)-       ACT -C"-
    ! SS(1-19) Drl(12)-C"(21)-       ACT -C"-
    ! SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
    ! SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1)   ACT 14: -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      if (JB_SYS > 0) then
        LRA = NLG1
        call SS_Drl_ACT_C_DD_EXT_SGT0()
      end if
      W0SS15 = W0_SS(15)
      W1SS15 = W1_SS(15)
      W0SS17 = W0_SS(17)
      W1SS17 = W1_SS(17)
      W0SS20 = W0_SS(20)
      if ((JML == 1) .and. (JMR == 1)) then
        ! SS(1-20) Drl(33)-C"(00)-       ACT -C"-
        do LR0=NORB_FRZ+1,NORB_DZ
          IWDL = JUST(LR0,LR0)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL) = Zero
          end do
          do LRK=1,NORB_DZ
            if (LRK == LR0) cycle
            call Drl_DD_EXT(LRK)
          end do
        end do
      end if
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          ! SS(1-15) (22)-Drl(11)-         ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS15
          end do
          call Drl_DD_EXT(LRJ)
          ! SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS17
          end do
          call Drl_DD_EXT(LRI)
          ! SS(1-20) (22)(11)Drl(33)-      ACT -C"-
          ! SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
          ! SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL) = Zero
          end do
          do LRK=1,NORB_DZ
            if (LRK == LRI) cycle
            if (LRK == LRJ) cycle
            call Drl_DD_EXT(LRK)
          end do
        end do
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call SS2_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,1)
          call SS4_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,1)
          call SS5_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,NK)
          call SS10_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,NK)
          call SS14_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,NK)
          !if (JROUTE_SYS > 1) then
          !  call SS1_EXT(LRI,LRJ)
          !  call Ar_BL_DD_EXT(LRI,LRJ,1)
          !  call SS3_EXT(LRI,LRJ)
          !  call Ar_BL_DD_EXT(LRI,LRJ,1)
          !end if
        end do
      end do
      if (JB_SYS > 0) then
        call SS_ArBr_ACT_C_DD_EXT_SGT0()
        call SS_S_Drl_ACT_C_DD_EXT_SGT0()
      end if
    end if

  case (2)
    !===================================================================
    ! ST(2)   ACT -C"-
    !if (JB_SYS > 0) call ST_Drl_ACT_C_DD_EXT()
    !if (JB_SYS > 0) call ST_ArBl_ACT_C_DD_EXT_SGT0()

    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    if (JB_SYS > 0) call ST_Drl_ACT_C_DD_EXT_SGT0()
    if (JB_SYS > 0) call ST_ArBl_ACT_C_DD_EXT_SGT0()
    do LRI=NORB_FRZ+1,NORB_DZ-1
      do LRJ=LRI+1,NORB_DZ
        call ST1_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,1)
        call ST2_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,NK)
        call ST4_EXT(LRI,LRJ,NK,1)
        if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,NK)
        call ST4_EXT(LRI,LRJ,NK,-1)
        if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,NK)
      end do
    end do

    do LRI=NORB_FRZ+1,NORB_DZ-1
      LMI = LSM_INN(LRI)
      do LRJ=LRI+1,NORB_DZ
        LMJ = LSM_INN(LRJ)
        LMIJ = Mul(LMI,LMJ)
        if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
        ! ST(2-5) (22)Drl(12)-          ACT -C"-
        IWDL = JUST(LRI,LRJ)
        IWDR = JUST(LRI,LRJ)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(5)
        end do
        call Drl_DD_EXT(LRJ)
        ! ST(2-6) Drl(22)-C"(12)-       ACT -C"-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(6)
        end do
        call Drl_DD_EXT(LRI)
        !---------------------------------------------------------------
        ! ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
        ! ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
        ! ST(2-7) Drl(12)-C"(22)-         ACT -C"-
        !---------------------------------------------------------------
      end do
    end do

  case (3)
    !===================================================================
    ! TS(3) D&R^L-  ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    if (JB_SYS > 0) then
      call TS_ArBl_ACT_C_DD_EXE_SGT0()
    end if
    do LRI=NORB_FRZ+1,NORB_DZ-1
      do LRJ=LRI+1,NORB_DZ
        call TS1_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,1)
        call TS2_EXT(LRI,LRJ,NK,1)
        if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,NK)
        call TS2_EXT(LRI,LRJ,NK,-1)
        if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,NK)
        call TS4_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_DD_EXT(LRI,LRJ,NK)
      end do
    end do

  case (4)
    !===================================================================
    ! STT(4) ArBl-  ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    LRA = NLG1
    call STT_ArBl_ACT_C_DD_EXT_SGT1()

  case (5)
    !===================================================================
    ! TTS(3) ArBl-  ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    call TTS_ArBl_ACT_C_DD_EXT_SGT1()
    call TTS_Drl_ACT_C_DD_EXT_SGT1()

  case default ! (6)
    !===================================================================
    ! SD(6)    ACT: -B&L-
    if (LINELP /= 17) return
    LRA = NLG1
    if (JB_SYS > 0) then
      call SD_Ar_ACT_Bl_DD_EXT_SGT0(LRA)
    end if
    do LRI=NORB_FRZ+1,NORB_DZ
      LMI = LSM_INN(LRI)
      if (LMI /= JMLR) cycle
      W0SD1 = W0_SD(1)
      W0SD2 = W0_SD(2)
      W0SD3 = -W0_SD(3)
      W0SD4 = -W0_SD(4)
      NI = mod(NORB_DZ-LRI,2)
      if (NI == 1) W0SD1 = -W0SD1
      if (NI == 1) W0SD2 = -W0SD2
      if (NI == 1) W0SD3 = -W0SD3
      if (NI == 1) W0SD4 = -W0SD4
      if ((JML == 1) .and. (LMI == JMR)) then
        ! SD(6-1) A&r(02)-
        IWDL = JUST(LRI,LRI)
        IWDR = JUD(LRI)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD1
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0SD1
        end do
        call Ar_BL_DD_EXT(LRI,LRA,1)
      end if
      ! SD(6-2) C(22)-A&r(13)-
      do LRK=NORB_FRZ+1,LRI-1
        LMK = LSM_INN(LRK)
        LMKI = Mul(LMK,LMI)
        if ((LMKI == JML) .and. (LMK == JMR)) then
          IWDL = JUST(LRK,LRI)
          IWDR = JUD(LRK)
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD2
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0SD2
          end do
          call Ar_BL_DD_EXT(LRI,LRA,1)
        end if
      end do
      ! SD(6-4) A&r(23)-C'(12)-
      do LRK=LRI+1,NORB_DZ
        LMK = LSM_INN(LRK)
        LMKI = Mul(LMK,LMI)
        if ((LMKI /= JML) .or. (LMK /= JMR)) cycle
        !......................03_01....................................
        !if (jroute_sys > 1) then
        !  ! SD(6-3) A&r(13)-C'(22)-
        !  IWDL = JUST(LRK,LRI)
        !  IWDR = JUD(LRK)
        !  do MPL=1,MHLP
        !    IWAL = LPNEW_LWEI(MPL)
        !    IWAR = LPNEW_RWEI(MPL)
        !    LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        !    LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        !  end do
        !  do MPL=1,MTYPE
        !    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD3
        !    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0SD3
        !  end do
        !  call Ar_BL_DD_EXT(LRI,LRA,1)
        !end if
        !.......................03_01...................................
        IWDL = JUST(LRI,LRK)
        IWDR = JUD(LRK)
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SD4
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0SD4
        end do
        call Ar_BL_DD_EXT(LRI,LRA,1)
      end do
    end do

  case (8)
    !===================================================================
    ! SDD(8) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call SDD_Ar_ACT_Bl_DD_EXT_SGT0(LRA)

  case (11)
    !===================================================================
    ! TT(11-1) (22)Ar(23)-Bl(32)-      IGF=1   ACT -C"-
    ! TT(11-1) Ar(23)-Bl(32)-C"(22)-  IGF=1    ACT -C"-
    ! TT(11-1) Ar(23)-C'(22)-Bl(32)-  IGF=-1    ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0TT2 = W0_TT(2)
      W1TT2 = W1_TT(2)
      W0TT3 = W0_TT(3)
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          ! TT(11-2) (22)Drl(22)-
          ! TT(11-2) Drl(22)-C"(22)-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT2
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TT2
          end do
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          call Drl_DD_EXT(LRI)
          call Drl_DD_EXT(LRJ)
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT3
            VPLP_W1(MPL) = Zero
          end do
          do LRK=1,NORB_DZ
            if (LRK == LRI) cycle
            if (LRK == LRJ) cycle
            LMK = LSM_INN(LRK)
            LMKI = Mul(LMK,LMI)
            ! TT(11-3) Drl(33)-C"(22)-C"(22)-
            ! TT(11-3) (22)Drl(33)-C"(22)-
            ! TT(11-3) (22)(22)Drl(33)-
            call Drl_DD_EXT(LRK)
          end do
        end do
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          call Ar_BL_DD_EXT(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          call Ar_BL_DD_EXT(LRI,LRJ,NK)
        end do
      end do
    end if

  case (12)
    !===================================================================
    ! TTTT(12) Drl- ArBl-  ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call TTTT_Drl_ACT_C_DD_EXT_SGT1()
    else
      call TTTT_ArBl_ACT_C_DD_EXT_SGT1()
    end if

  case (13)
    !===================================================================
    ! TD(13) ACT -B&L-
    if (LINELP /= 17) return
    LRA = NLG1
    do LRI=NORB_FRZ+1,NORB_DZ
      LMI = LSM_INN(LRI)
      if (LMI /= JMLR) cycle
      W0TD1 = W0_TD(1)
      NI = mod(NORB_DZ-LRI,2)
      if (NI == 1) W0TD1 = -W0TD1

      do LRK=NORB_FRZ+1,LRI-1
        LMK = LSM_INN(LRK)
        if (LMK == JMR) then
          ! TD(13-1) C(22)-A&r(23)-
          IWDL = JUST(LRK,LRI)
          IWDR = JUD(LRK)
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TD1
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0TD1
          end do
          call Ar_BL_DD_EXT(LRI,LRA,1)
        end if
      end do
      do LRK=LRI+1,NORB_DZ
        LMK = LSM_INN(LRK)
        if (LMK == JMR) then
          ! TD(13-1) A&r(23)-C'(22)-
          IWDL = JUST(LRI,LRK)
          IWDR = JUD(LRK)
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          do MPL=1,MTYPE
            VPLP_W0(MPL) = -VPLPNEW_W0(MPL)*W0TD1
            VPLP_W1(MPL) = -VPLPNEW_W1(MPL)*W0TD1
          end do
          call Ar_BL_DD_EXT(LRI,LRA,1)
        end if
      end do
    end do

  case (15)
    !===================================================================
    ! T1D1(15) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call TTDD_Ar_ACT_Bl_DD_EXT_SGT1(LRA)

  case (19)
    !===================================================================
    ! DD(19) ACT -C"- ..................................................
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0DD2 = W0_DD(2)
      W1DD2 = W1_DD(2)
      W0DD3 = W0_DD(3)
      do LRI=NORB_FRZ+1,NORB_DZ
        LMI = LSM_INN(LRI)
        if (LMI /= JML) cycle
        ! DD(19-2) Drl(22)-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD2
        end do
        IWDL = JUD(LRI)
        IWDR = IWDL
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        call Drl_DD_EXT(LRI)
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD3
          VPLP_W1(MPL) = Zero
        end do
        ! DD(19-3) (22)Drl(33)-
        ! DD(19-3) Drl(33)-C"(22)-
        do LRK=1,NORB_DZ
          if (LRK == LRI) cycle
          LMK = LSM_INN(LRK)
          LMKI = Mul(LMK,LMI)
          call Drl_DD_EXT(LRK)
        end do
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if (LMIJ /= JMLR) cycle
          W0DD1 = W0_DD(1)
          W1DD1 = W1_DD(1)
          NI = mod(LRJ-LRI,2)
          if (NI == 0) then
            W0DD1 = -W0DD1
            W1DD1 = -W1DD1
          end if
          if ((LMI == JML) .and. (LMJ == JMR)) then
            ! DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            do MPL=1,MTYPE
              VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD1
              VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD1
            end do
            IWDL = JUD(LRI)
            IWDR = JUD(LRJ)
            do MPL=1,MHLP
              IWAL = LPNEW_LWEI(MPL)
              IWAR = LPNEW_RWEI(MPL)
              LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            end do
            call Ar_BL_DD_EXT(LRI,LRJ,1)
          end if
        end do
      end do
    end if

  case (20)
    !===================================================================
    ! DDDD(19) ACT -C"- ................................................
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call DDDD_Drl_ACT_C_DD_EXT_SGT0()
    else
      call DDDD_ArBl_ACT_C_DD_EXT_SGT0()
    end if

  case (21)
    !===================================================================
    ! DD1(19) ACT -C"- .................................................
    if ((LINELP /= 14) .or. (NLG2 /= 2)) return
    call DD1_ArBl_ACT_C_DD_EXT_SGT0()

  case (22)
    !===================================================================
    ! D1D(19) ACT -C"- .................................................
    if (LINELP /= 14) return
    !if (NLG2 == 1) then
    call D1D_Drl_ACT_C_DD_EXT_SGT0()
    !else
    call D1D_ArBl_ACT_C_DD_EXT_SGT0()
    !end if

  case (23)
    !===================================================================
    ! DV(23) ACT -C'-..................................................
    if (LINELP /= 17) return
    LRA = NLG1
    do LRI=NORB_FRZ+1,NORB_DZ
      LMI = LSM_INN(LRI)
      if (LMI /= JMLR) cycle
      W0DV1 = W0_DV(1)
      NI = mod(NORB_DZ-LRI,2)
      if (NI == 1) W0DV1 = -W0DV1
      ! DV(23-1) A&r(23)-
      IWDL = JUD(LRI)
      IWDR = 0
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DV1
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0DV1
      end do
      call Ar_BL_DD_EXT(LRI,LRA,1)
    end do

  case (24)
    !===================================================================
    ! D1V(24) Ar- ACT -Bl-..............................................
    if (LINELP /= 17) return
    LRA = NLG1
    call D1V_Ar_ACT_Bl_DD_EXT_SGT0(LRA)

  case (25)
    !===================================================================
    ! VV(25) ACT -BL- ..................................................
    if ((LINELP /= 14) .or. (NLG2 /= 1)) return
    ! VV(25) Drl(33)-
    IWDL = 0
    IWDR = 0
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_VV
      VPLP_W1(MPL) = Zero
    end do
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
    end do
    do LRK=1,NORB_DZ
      call Drl_DD_EXT(LRK)
    end do

  case (7,9:10,14,16:18,26)
end select

return

end subroutine dd_ext_head_in_dbl

subroutine dd_ext_head_in_act()

use gugaci_global, only: linelp, logic_dh, nlg1, nlg2
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lrai, lraj

LOGIC_DH = .false.
LRAI = NLG1
LRAJ = NLG2
! line=5 A&r-B&l<-->EXT
if (LINELP == 5) then
  call Ar_BL_DD_EXT(lrai,lraj,1)
end if
! line=9 D&rl<-->EXT
if (LINELP == 9) then
  call Drl_DD_EXT(lrai)
end if

return

end subroutine dd_ext_head_in_act

subroutine ss_drt_ci_new()

use gugaci_global, only: idisk_array, idisk_lp, idownwei_g131415, iml, imr, ipae, ipael, iseg_downwei, jml, jmr, jpad, jpadl, &
                         jpadlr, linelp, lpblock_ss, nvalue_space_ss
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: imlr, jptyl, jptyr, lpb

call external_space_plpmode_value_ss()
idisk_lp = idisk_array(13)

do lpb=1,lpblock_ss
  call read_lp()
  IpaeL = iml+17
  Ipae = imr+17
  imlr = Mul(iml,imr)
  nvalue_space_ss = iseg_downwei(9+imlr)
  idownwei_g131415 = iseg_downwei(17+iml)
  !if (imlr == 1) imspace= i ml
  call logicg_st(iml,imr,4,4)      ! irtype=4(S),lptype=5:ArBl-
  call get_jpty(jpadlr,jptyl,jptyr)
  call get_jp(jptyl,jml,jpadl,1)
  call get_jp(jptyr,jmr,jpad,1)
  !JMLR = Mul(JML,JMR)
  if (linelp <= 12) then
    call ss_ext_head_in_act()
  else
    call ss_ext_head_in_dbl()
  end if
end do

return

end subroutine ss_drt_ci_new

subroutine ss_ext_head_in_dbl()

use gugaci_global, only: ipae, ipael, jb_sys, jml, jmr, jpad, jpadl, jpadlr, jud, just, linelp, logic_dh, lp_lwei, lp_rwei, &
                         lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, nlg1, nlg2, norb_dz, norb_frz, vplp_w0, vplp_w1, &
                         vplpnew_w0, vplpnew_w1, w0_dd, w0_dv, w0_ss, w0_tt, w0_vv, w1_dd, w1_ss, w1_st, w1_tt
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lpok, lr0, lra, lri, lrj, mpl, ni, nk
real(kind=wp) :: w0dd1, w0dd2, w0dd3, w0dv1, w0ss15, w0ss17, w0ss20, w0tt2, w0tt3, w1dd1, w1dd2, w1ss15, w1ss17, w1tt2
integer(kind=iwp), external :: iwalk_ad

LOGIC_DH = .true.
JMLR = Mul(JML,JMR)
LPOK = JPADLR
select case (LPOK)
  case (1)
    !===================================================================
    ! SS(1)   ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1-1)  Ar(01)-Bl(32)-        ACT -C"-
    ! SS(1-3)  Ar(13)-Bl(20)-        ACT -C"-
    ! SS(1-6)  (11)-Ar(23)-Bl(32)-   ACT -C"-
    ! SS(1-7)  Ar(13)-C'(21)-Bl(32)- ACT -C"-
    ! SS(1-8)  Ar(13)-C'(22)-Bl(31)- ACT -C"-
    ! SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
    ! SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
    ! SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
    ! SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
    ! SS(1-16) (11)-Drl(22)-         ACT -C"-
    ! SS(1-18) Drl(11)-C"(22)-       ACT -C"-
    ! SS(1-19) Drl(12)-C"(21)-       ACT -C"-
    ! SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
    ! SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1)   ACT 14: -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      if (JB_SYS > 0) call SS_Drl_ACT_C_EXT_AB_SGT0(1)
      W0SS15 = W0_SS(15)
      W1SS15 = W1_SS(15)
      W0SS17 = W0_SS(17)
      W1SS17 = W1_SS(17)
      W0SS20 = W0_SS(20)
      if ((JML == 1) .and. (JMR == 1)) then
        ! SS(1-20) Drl(33)-C"(00)-       ACT -C"-                  ! IPL(R)AD=
        do LR0=NORB_FRZ+1,NORB_DZ
          IWDL = JUST(LR0,LR0)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL) = Zero
          end do
          call Drl_SS_SUM(LR0,0)
        end do
      end if
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          ! SS(1-15) (22)-Drl(11)-         ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS15
          end do
          call Drl_SS_EXT(LRJ)
          ! SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS17
          end do
          call Drl_SS_EXT(LRI)
          ! SS(1-20) (22)(11)Drl(33)-      ACT -C"-
          ! SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
          ! SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL) = Zero
          end do
          call Drl_SS_SUM(LRI,LRJ)
        end do
      end do
    else
      if (JB_SYS > 0) then
        call SS_ArBl_ACT_C_EXT_AB_SGT0(1)
        call SS_S_Drl_ACT_C_EXT_AB_SGT0(1)
      end if
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call SS2_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_SS(LRI,LRJ,1)
          call SS4_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_SS(LRI,LRJ,1)
          call SS5_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_SS(LRI,LRJ,NK)
          call SS10_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_SS(LRI,LRJ,NK)
          call SS14_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_SS(LRI,LRJ,NK)
        end do
      end do
    end if

  case (2)
    ! ST(2)   ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    if (JB_SYS > 0) call ST_Drl_ACT_C_EXT_AB_SGT0(1)
    if (JB_SYS > 0) call ST_ArBl_ACT_C_EXT_AB_SGT0(1)
    do LRI=NORB_FRZ+1,NORB_DZ-1
      LMI = LSM_INN(LRI)
      do LRJ=LRI+1,NORB_DZ
        LMJ = LSM_INN(LRJ)
        LMIJ = Mul(LMI,LMJ)
        if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
        ! ST(2-5) (22)Drl(12)-          ACT -C"-
        IWDL = JUST(LRI,LRJ)
        IWDR = IWDL
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(5)
        end do
        call Drl_SS_EXT(LRJ)
        ! ST(2-6) Drl(22)-C"(12)-       ACT -C"-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(6)
        end do
        call Drl_SS_EXT(LRI)
        !---------------------------------------------------------------
        ! ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
        ! ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
        ! ST(2-7) Drl(12)-C"(22)-         ACT -C"-
        !---------------------------------------------------------------
      end do
    end do

  case (4)
    !===================================================================
    ! TS(3)   ACT -C"-  no used
    !===================================================================
    ! ST1(4) Ar-Bl- Drl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call STT_ArBl_ACT_C_EXT_AB_SGT1(1)

  case (5)
    !===================================================================
    ! T1S(5) Ar-Bl- Drl ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 /= 2)) return
    call TTS_Drl_ACT_C_EXT_AB_SGT1(1)
    call TTS_ArBl_ACT_C_EXT_AB_SGT1(1)

  case default ! (6)
    !===================================================================
    ! SD(6-1) ACT -B&L-
    if (LINELP /= 17) return
    LRA = NLG1
    call SD_AR_ACT_BL(1,LRA)
    if (JB_SYS > 0) call SD_AR_ACT_BL_SGT0(1,LRA)

  case (8)
    !===================================================================
    ! SD1(8) Ar ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    if (JB_SYS > 0) call SDD_AR_ACT_BL_SGT0(1,LRA)

  case (11)
    !===================================================================
    ! TT(11) AR-BL   ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0TT2 = W0_TT(2)
      W1TT2 = W1_TT(2)
      W0TT3 = W0_TT(3)
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          ! TT(11-2) (22)Drl(22)-
          ! TT(11-2) Drl(22)-C"(22)-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT2
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TT2
          end do
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          call Drl_SS_EXT(LRI)
          call Drl_SS_EXT(LRJ)
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT3
            VPLP_W1(MPL) = Zero
          end do
          ! TT(11-3) Drl(33)-C"(22)-C"(22)-
          ! TT(11-3) (22)Drl(33)-C"(22)-
          ! TT(11-3) (22)(22)Drl(33)-
          call Drl_SS_SUM(LRI,LRJ)
        end do
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          if (NK /= 0) call AR_BL_EXT_SS(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          if (NK /= 0) call AR_BL_EXT_SS(LRI,LRJ,NK)
        end do
      end do
    end if

  case (12)
    !===================================================================
    ! TTTT(12) Ar-Bl- Drl- ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call TTTT_Drl_ACT_C_EXT_AB_SGT0(1)
    else
      call TTTT_ArBl_ACT_C_EXT_AB_SGT0(1)
    end if

  case (13)
    !===================================================================
    ! TD(13) ACT -BL-
    if (LINELP /= 17) return
    LRA = NLG1
    call TD_AR_ACT_BL(1,LRA)

  case (15)
    !===================================================================
    ! T1D1(15) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call TTDD_AR_ACT_BL_SGT1(1,LRA)

  case (19)
    !===================================================================
    ! DD(19) ACT -C"- ..................................................
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0DD2 = W0_DD(2)
      W1DD2 = W1_DD(2)
      W0DD3 = W0_DD(3)
      do LRI=NORB_FRZ+1,NORB_DZ
        LMI = LSM_INN(LRI)
        if (LMI /= JML) cycle
        ! DD(19-2) Drl(22)-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD2
        end do
        IWDL = JUD(LRI)
        IWDR = IWDL
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        call Drl_SS_EXT(LRI)
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD3
          VPLP_W1(MPL) = Zero
        end do
        ! DD(19-3) (22)Drl(33)-
        ! DD(19-3) Drl(33)-C"(22)-
        call Drl_SS_SUM(LRI,0)
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if (LMIJ /= JMLR) cycle
          W0DD1 = W0_DD(1)
          W1DD1 = W1_DD(1)
          NI = mod(LRJ-LRI,2)
          if (NI == 0) then
            W0DD1 = -W0DD1
            W1DD1 = -W1DD1
          end if
          if ((LMI == JML) .and. (LMJ == JMR)) then
            ! DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            do MPL=1,MTYPE
              VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD1
            end do
            IWDL = JUD(LRI)
            IWDR = JUD(LRJ)
            do MPL=1,MHLP
              IWAL = LPNEW_LWEI(MPL)
              IWAR = LPNEW_RWEI(MPL)
              LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            end do
            call Ar_BL_EXT_SS(LRI,LRJ,1)
          end if
        end do
      end do
    end if

  case (20)
    !===================================================================
    ! D1D1(20) Drl- Ar-Bl- ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call D1D1_Drl_ACT_C_EXT_AB_SGT0(1)
    else
      call D1D1_ArBl_ACT_C_EXT_AB_SGT0(1)
    end if

  case (21)
    !===================================================================
    ! DD1(21) Ar-Bl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call DD1_ArBl_ACT_C_EXT_AB_SGT0(1)

  case (22)
    !===================================================================
    ! D1D(22) Ar-Bl- Drl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call D1D_ArBl_ACT_C_EXT_AB_SGT0(1)
    call D1D_Drl_ACT_C_EXT_AB_SGT0(1)

  case (23)
    !===================================================================
    ! DV(23) ACT -C'-..................................................
    if (LINELP /= 17) return
    LRA = NLG1
    do LRI=NORB_FRZ+1,NORB_DZ
      LMI = LSM_INN(LRI)
      if (LMI /= JMLR) cycle
      W0DV1 = W0_DV(1)
      NI = mod(NORB_DZ-LRI,2)
      if (NI == 1) W0DV1 = -W0DV1
      ! DV(23-1) A&r(23)-
      IWDL = JUD(LRI)
      IWDR = 0
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DV1
      end do
      call Ar_BL_EXT_SS(LRI,LRA,1)
    end do

  case (24)
    !===================================================================
    ! D1V(24) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call D1V_Ar_ACT_Bl_EXT_AB_SGT0(1,LRA)

  case (25)
    !===================================================================
    ! VV(25) ACT -C"- .false.
    if ((LINELP /= 14) .or. (NLG2 /= 1)) return
    !VV(25) Drl(33)-
    IWDL = 0
    IWDR = 0
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_VV
      VPLP_W1(MPL) = Zero
    end do
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
    end do
    call Drl_SS_SUM(0,0)
    !do lrk=1,norb_dz
    !  call Drl_ss_ext(lrk)
    !end do

  case (3,7,9:10,14,16:18,26)
end select

return

end subroutine ss_ext_head_in_dbl

subroutine ss_ext_head_in_act()

use gugaci_global, only: linelp, logic_dh, nlg1, nlg2
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lrai, lraj

LOGIC_DH = .false.
LRAI = NLG1
LRAJ = NLG2
! line=5 A&r-B&l<-->EXT
if (LINELP == 5) then
  call Ar_BL_EXT_SS(lrai,lraj,1)
end if
! line=9 D&rl<-->EXT
if (LINELP == 9) then
  call Drl_SS_EXT(lrai)
end if

return

end subroutine ss_ext_head_in_act

subroutine st_drt_ci_new()

use gugaci_global, only: idisk_array, idisk_lp, idownwei_g131415, iml, imr, ipae, ipael, iseg_downwei, jml, jmr, jpad, jpadl, &
                         jpadlr, linelp, lpblock_st, nvalue_space_ss
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: imlr, jptyl, jptyr, lpb

call external_space_plpmode_value_ST()
idisk_lp = idisk_array(12)

do lpb=1,lpblock_st
  call read_lp()
  IpaeL = iml+17
  Ipae = imr+9
  imlr = Mul(iml,imr)
  idownwei_g131415 = iseg_downwei(9+iml)  !(17+iml)???
  nvalue_space_ss = iseg_downwei(9+imlr)
  call logicg_st(iml,imr,4,3)             ! irtype=4(S),3(T)
  call get_jpty(jpadlr,jptyl,jptyr)
  call get_jp(jptyl,jml,jpadl,1)
  call get_jp(jptyr,jmr,jpad,1)
  !JMLR = Mul(JML,JMR)
  if (linelp <= 12) then
    call st_ext_head_in_act()
  else
    call st_ext_head_in_dbl()
  end if
end do

return

end subroutine st_drt_ci_new

subroutine st_ext_head_in_dbl()

use gugaci_global, only: ipae, ipael, jb_sys, jml, jmr, jpad, jpadl, jpadlr, jud, just, linelp, logic_dh, lp_lwei, lp_rwei, &
                         lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, nlg1, nlg2, norb_dz, norb_frz, vplp_w0, vplp_w1, &
                         vplpnew_w0, vplpnew_w1, w0_dd, w0_dv, w0_ss, w0_tt, w1_dd, w1_ss, w1_st, w1_tt
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lpok, lra, lri, lrj, lrk, mpl, ni, nk
real(kind=wp) :: w0dd1, w0dd2, w0dv1, w0ss15, w0ss17, w0ss20, w0tt2, w1dd1, w1dd2, w1ss15, w1ss17, w1tt2
integer(kind=iwp), external :: iwalk_ad

LOGIC_DH = .true.
JMLR = Mul(JML,JMR)
LPOK = JPADLR
select case (LPOK)
  case (1)
    !===================================================================
    ! SS(1)   ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1-1)  Ar(01)-Bl(32)-        ACT -C"-
    ! SS(1-3)  Ar(13)-Bl(20)-        ACT -C"-
    ! SS(1-6)  (11)-Ar(23)-Bl(32)-   ACT -C"-
    ! SS(1-7)  Ar(13)-C'(21)-Bl(32)- ACT -C"-
    ! SS(1-8)  Ar(13)-C'(22)-Bl(31)- ACT -C"-
    ! SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
    ! SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
    ! SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
    ! SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
    ! SS(1-16) (11)-Drl(22)-         ACT -C"-
    ! SS(1-18) Drl(11)-C"(22)-       ACT -C"-
    ! SS(1-19) Drl(12)-C"(21)-       ACT -C"-
    ! SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
    ! SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1)   ACT 14: -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      if (JB_SYS > 0) call SS_Drl_ACT_C_EXT_AB_SGT0(2)
      W0SS15 = W0_SS(15)
      W1SS15 = W1_SS(15)
      W0SS17 = W0_SS(17)
      W1SS17 = W1_SS(17)
      W0SS20 = W0_SS(20)
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          ! SS(1-15) (22)-Drl(11)-         ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS15
          end do
          call Drl_ST_EXT(LRJ)
          ! SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS17
          end do
          call Drl_ST_EXT(LRI)
          ! SS(1-20) (22)(11)Drl(33)-      ACT -C"-
          ! SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
          ! SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL) = Zero
          end do
          do LRK=1,NORB_DZ
            if (LRK == LRI) cycle
            if (LRK == LRJ) cycle
            call Drl_ST_EXT(LRK)
          end do
        end do
      end do
    else
      LRA = NLG1
      if (JB_SYS > 0) then
        call SS_ArBl_ACT_C_EXT_AB_SGT0(2)
        call SS_S_Drl_ACT_C_EXT_AB_SGT0(2)
      end if
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call SS2_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,1)
          call SS4_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,1)
          call SS5_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,NK)
          call SS10_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,NK)
          call SS14_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,NK)
        end do
      end do
    end if

  case (2)
    ! ST(2)   ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    if (JB_SYS > 0) call ST_Drl_ACT_C_EXT_AB_SGT0(2)
    if (JB_SYS > 0) call ST_ArBl_ACT_C_EXT_AB_SGT0(2)
    do LRI=NORB_FRZ+1,NORB_DZ-1
      do LRJ=LRI+1,NORB_DZ
        call ST1_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,1)
        call ST2_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,NK)
        call ST4_EXT(LRI,LRJ,NK,1)
        if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,NK)
        call ST4_EXT(LRI,LRJ,NK,-1)
        if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,NK)
      end do
    end do

    do LRI=NORB_FRZ+1,NORB_DZ-1
      LMI = LSM_INN(LRI)
      do LRJ=LRI+1,NORB_DZ
        LMJ = LSM_INN(LRJ)
        LMIJ = Mul(LMI,LMJ)
        if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
        ! ST(2-5) (22)Drl(12)-          ACT -C"-
        IWDL = JUST(LRI,LRJ)
        IWDR = IWDL
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(5)
        end do
        call Drl_ST_EXT(LRJ)
        ! ST(2-6) Drl(22)-C"(12)-       ACT -C"-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(6)
        end do
        call Drl_ST_EXT(LRI)
        !---------------------------------------------------------------
        ! ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
        ! ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
        ! ST(2-7) Drl(12)-C"(22)-         ACT -C"-
        !---------------------------------------------------------------
      end do
    end do

  case (3)
    !===================================================================
    ! TS(3) A&R-B^L-  ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    if (JB_SYS > 0) then
      call TS_ArBl_ACT_C_EXT_AB_SGT0(2)
    end if
    do LRI=NORB_FRZ+1,NORB_DZ-1
      do LRJ=LRI+1,NORB_DZ
        call TS1_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,1)
        call TS2_EXT(LRI,LRJ,NK,1)
        if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,NK)
        call TS2_EXT(LRI,LRJ,NK,-1)
        if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,NK)
        call TS4_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_ST(LRI,LRJ,NK)
      end do
    end do

  case (4)
    !===================================================================
    ! ST1(4) Ar-Bl- Drl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call STT_ArBl_ACT_C_EXT_AB_SGT1(2)

  case (5)
    !===================================================================
    ! T1S(5) Ar-Bl- Drl ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 /= 2)) return
    call TTS_Drl_ACT_C_EXT_AB_SGT1(2)
    call TTS_ArBl_ACT_C_EXT_AB_SGT1(2)

  case default ! (6)
    !===================================================================
    ! SD(6-1) ACT -B&L-
    if (LINELP /= 17) return
    LRA = NLG1
    call SD_AR_ACT_BL(2,LRA)
    if (JB_SYS > 0) call SD_AR_ACT_BL_SGT0(2,LRA)

  case (8)
    !===================================================================
    ! SD1(8) Ar ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    if (JB_SYS > 0) call SDD_AR_ACT_BL_SGT0(2,LRA)

  case (11)
    !===================================================================
    ! TT(11) Drl-  ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0TT2 = W0_TT(2)
      W1TT2 = W1_TT(2)
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          ! TT(11-2) (22)Drl(22)-
          ! TT(11-2) Drl(22)-C"(22)-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT2
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TT2
          end do
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          call Drl_ST_EXT(LRI)
          call Drl_ST_EXT(LRJ)
        end do
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          call AR_BL_EXT_TS(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          call AR_BL_EXT_ST(LRI,LRJ,NK)
        end do
      end do
    end if

  case (12)
    !===================================================================
    ! TTTT(12) Ar-Bl- Drl- ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call TTTT_Drl_ACT_C_EXT_AB_SGT0(2)
    else
      call TTTT_ArBl_ACT_C_EXT_AB_SGT0(2)
    end if

  case (13)
    !===================================================================
    ! TD(13) ACT -BL-
    if (LINELP /= 17) return
    LRA = NLG1
    call TD_AR_ACT_BL(2,LRA)

  case (15)
    !===================================================================
    ! T1D1(15) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call TTDD_AR_ACT_BL_SGT1(2,LRA)

  case (19)
    !===================================================================
    ! DD(19) ACT -C"- ..................................................
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0DD2 = W0_DD(2)
      W1DD2 = W1_DD(2)
      do LRI=NORB_FRZ+1,NORB_DZ
        LMI = LSM_INN(LRI)
        if (LMI /= JML) cycle
        ! DD(19-2) Drl(22)-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD2
        end do
        IWDL = JUD(LRI)
        IWDR = IWDL
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        call Drl_ST_EXT(LRI)
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if (LMIJ /= JMLR) cycle
          W0DD1 = W0_DD(1)
          W1DD1 = W1_DD(1)
          NI = mod(LRJ-LRI,2)
          if (NI == 0) then
            W0DD1 = -W0DD1
            W1DD1 = -W1DD1
          end if
          if ((LMI == JML) .and. (LMJ == JMR)) then
            ! DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            do MPL=1,MTYPE
              VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD1
            end do
            IWDL = JUD(LRI)
            IWDR = JUD(LRJ)
            do MPL=1,MHLP
              IWAL = LPNEW_LWEI(MPL)
              IWAR = LPNEW_RWEI(MPL)
              LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            end do
            call Ar_BL_EXT_ST(LRI,LRJ,1)
          end if
        end do
      end do
    end if

  case (20)
    !===================================================================
    ! D1D1(20) Drl- Ar-Bl- ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call D1D1_Drl_ACT_C_EXT_AB_SGT0(2)
    else
      call D1D1_ArBl_ACT_C_EXT_AB_SGT0(2)
    end if

  case (21)
    !===================================================================
    ! DD1(21) Ar-Bl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call DD1_ArBl_ACT_C_EXT_AB_SGT0(2)

  case (22)
    !===================================================================
    ! D1D(22) Ar-Bl- Drl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call D1D_ArBl_ACT_C_EXT_AB_SGT0(2)
    call D1D_Drl_ACT_C_EXT_AB_SGT0(2)

  case (23)
    !===================================================================
    ! DV(23) ACT -C'-..................................................
    if (LINELP /= 17) return
    LRA = NLG1
    do LRI=NORB_FRZ+1,NORB_DZ
      LMI = LSM_INN(LRI)
      if (LMI /= JMLR) cycle
      W0DV1 = W0_DV(1)
      NI = mod(NORB_DZ-LRI,2)
      if (NI == 1) W0DV1 = -W0DV1
      ! DV(23-1) A&r(23)-
      IWDL = JUD(LRI)
      IWDR = 0
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0DV1
      end do
      call Ar_BL_EXT_ST(LRI,LRA,1)
    end do

  case (24)
    !===================================================================
    ! D1V(24) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call D1V_Ar_ACT_Bl_EXT_AB_SGT0(2,LRA)

  case (25)
    !===================================================================
    ! VV(25) ACT -BL- ..................................................
    return

  case (7,9:10,14,16:18,26)
end select
return

end subroutine st_ext_head_in_dbl

subroutine st_ext_head_in_act()

use gugaci_global, only: linelp, logic_dh, nlg1, nlg2
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lrai, lraj

LOGIC_DH = .false.
LRAI = NLG1
LRAJ = NLG2
!line=5 A&r-B&l<-->EXT
if (LINELP == 5) then
  call Ar_BL_EXT_ST(lrai,lraj,1)
end if
!line=9 D&rl<-->EXT
if (LINELP == 9) then
  call Drl_ST_EXT(lrai)
end if

return

end subroutine st_ext_head_in_act

subroutine ts_drt_ci_new()

use gugaci_global, only: idisk_array, idisk_lp, idownwei_g131415, iml, imr, ipae, ipael, iseg_downwei, jml, jmr, jpad, jpadl, &
                         jpadlr, linelp, lpblock_ts, nvalue_space_ss
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: imlr, jptyl, jptyr, lpb

call external_space_plpmode_value_TS()
idisk_lp = idisk_array(9)
do lpb=1,lpblock_ts
  call read_lp()
  IpaeL = iml+9
  Ipae = imr+17
  imlr = Mul(iml,imr)
  idownwei_g131415 = iseg_downwei(9+iml)  !(17+iml)???
  nvalue_space_ss = iseg_downwei(9+imlr)
  call logicg_st(iml,imr,3,4)             ! irtype=4(S),3(T)
  call get_jpty(jpadlr,jptyl,jptyr)
  call get_jp(jptyl,jml,jpadl,1)
  call get_jp(jptyr,jmr,jpad,1)
  !JMLR = Mul(JML,JMR)
  if (linelp <= 12) then
    call ts_ext_head_in_act()
  else
    call ts_ext_head_in_dbl()
  end if
end do

return

end subroutine ts_drt_ci_new

subroutine ts_ext_head_in_dbl()

use gugaci_global, only: ipae, ipael, jb_sys, jml, jmr, jpad, jpadl, jpadlr, jud, just, linelp, logic_dh, lp_lwei, lp_rwei, &
                         lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, nlg1, nlg2, norb_dz, norb_frz, vplp_w0, vplp_w1, &
                         vplpnew_w0, vplpnew_w1, w0_dd, w0_dv, w0_ss, w0_tt, w1_dd, w1_ss, w1_st, w1_tt
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lpok, lra, lri, lrj, lrk, mpl, ni, nk
real(kind=wp) :: w0dd1, w0dd2, w0dv1, w0ss15, w0ss17, w0ss20, w0tt2, w1dd1, w1dd2, w1ss15, w1ss17, w1tt2
integer(kind=iwp), external :: iwalk_ad

LOGIC_DH = .true.
JMLR = Mul(JML,JMR)
LPOK = JPADLR
select case (LPOK)
  case (1)
    !===================================================================
    ! SS(1)   ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1-1)  Ar(01)-Bl(32)-        ACT -C"-
    ! SS(1-3)  Ar(13)-Bl(20)-        ACT -C"-
    ! SS(1-6)  (11)-Ar(23)-Bl(32)-   ACT -C"-
    ! SS(1-7)  Ar(13)-C'(21)-Bl(32)- ACT -C"-
    ! SS(1-8)  Ar(13)-C'(22)-Bl(31)- ACT -C"-
    ! SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
    ! SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
    ! SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
    ! SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
    ! SS(1-16) (11)-Drl(22)-         ACT -C"-
    ! SS(1-18) Drl(11)-C"(22)-       ACT -C"-
    ! SS(1-19) Drl(12)-C"(21)-       ACT -C"-
    ! SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
    ! SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1)   ACT 14: -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      if (JB_SYS > 0) call SS_Drl_ACT_C_EXT_AB_SGT0(3)
      W0SS15 = W0_SS(15)
      W1SS15 = W1_SS(15)
      W0SS17 = W0_SS(17)
      W1SS17 = W1_SS(17)
      W0SS20 = W0_SS(20)
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          ! SS(1-15) (22)-Drl(11)-         ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS15
          end do
          call Drl_TS_EXT(LRJ)
          ! SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS17
          end do
          call Drl_TS_EXT(LRI)
          ! SS(1-20) (22)(11)Drl(33)-      ACT -C"-
          ! SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
          ! SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL) = Zero
          end do
          do LRK=1,NORB_DZ
            if (LRK == LRI) cycle
            if (LRK == LRJ) cycle
            call Drl_TS_EXT(LRK)
          end do
        end do
      end do
    else
      if (JB_SYS > 0) then
        call SS_ArBl_ACT_C_EXT_AB_SGT0(3)
        call SS_S_Drl_ACT_C_EXT_AB_SGT0(3)
      end if
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call SS2_EXT(LRI,LRJ,NK)
          if (NK /= 0) call AR_BL_EXT_TS(LRI,LRJ,1)
          call SS4_EXT(LRI,LRJ,NK)
          if (NK /= 0) call AR_BL_EXT_TS(LRI,LRJ,1)
          call SS5_EXT(LRI,LRJ,NK)
          if (NK /= 0) call AR_BL_EXT_TS(LRI,LRJ,NK)
          call SS10_EXT(LRI,LRJ,NK)
          if (NK /= 0) call AR_BL_EXT_TS(LRI,LRJ,NK)
          call SS14_EXT(LRI,LRJ,NK)
          if (NK /= 0) call AR_BL_EXT_TS(LRI,LRJ,NK)
        end do
      end do
    end if

  case (2)
    ! ST(2)   ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    if (JB_SYS > 0) call ST_Drl_ACT_C_EXT_AB_SGT0(3)
    if (JB_SYS > 0) call ST_ArBl_ACT_C_EXT_AB_SGT0(3)
    do LRI=NORB_FRZ+1,NORB_DZ-1
      do LRJ=LRI+1,NORB_DZ
        call ST1_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_TS(LRI,LRJ,1)
        call ST2_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_TS(LRI,LRJ,NK)
        call ST4_EXT(LRI,LRJ,NK,1)
        if (NK /= 0) call Ar_BL_EXT_TS(LRI,LRJ,NK)
        call ST4_EXT(LRI,LRJ,NK,-1)
        if (NK /= 0) call Ar_BL_EXT_TS(LRI,LRJ,NK)
      end do
    end do

    do LRI=NORB_FRZ+1,NORB_DZ-1
      LMI = LSM_INN(LRI)
      do LRJ=LRI+1,NORB_DZ
        LMJ = LSM_INN(LRJ)
        LMIJ = Mul(LMI,LMJ)
        if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
        ! ST(2-5) (22)Drl(12)-          ACT -C"-
        IWDL = JUST(LRI,LRJ)
        IWDR = IWDL
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(5)
        end do
        call Drl_TS_EXT(LRJ)
        ! ST(2-6) Drl(22)-C"(12)-       ACT -C"-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(6)
        end do
        call Drl_TS_EXT(LRI)
        !---------------------------------------------------------------
        ! ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
        ! ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
        ! ST(2-7) Drl(12)-C"(22)-         ACT -C"-
        !---------------------------------------------------------------
      end do
    end do

  case (3)
    !===================================================================
    ! TS(3) D&R^L-  ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    if (JB_SYS > 0) then
      call TS_ArBl_ACT_C_EXT_AB_SGT0(3)
    end if
    do LRI=NORB_FRZ+1,NORB_DZ-1
      do LRJ=LRI+1,NORB_DZ
        call TS1_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_TS(LRI,LRJ,1)
        call TS2_EXT(LRI,LRJ,NK,1)
        if (NK /= 0) call Ar_BL_EXT_TS(LRI,LRJ,NK)
        call TS2_EXT(LRI,LRJ,NK,-1)
        if (NK /= 0) call Ar_BL_EXT_TS(LRI,LRJ,NK)
        call TS4_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_TS(LRI,LRJ,NK)
      end do
    end do

  case (4)
    !===================================================================
    ! ST1(4) Ar-Bl- Drl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call STT_ArBl_ACT_C_EXT_AB_SGT1(3)

  case (5)
    !===================================================================
    ! T1S(5) Ar-Bl- Drl ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 /= 2)) return
    call TTS_Drl_ACT_C_EXT_AB_SGT1(3)
    call TTS_ArBl_ACT_C_EXT_AB_SGT1(3)

  case default ! (6)
    !===================================================================
    ! SD(6-1) ACT -B&L-
    if (LINELP /= 17) return
    LRA = NLG1
    call SD_AR_ACT_BL(3,LRA)
    if (JB_SYS > 0) call SD_AR_ACT_BL_SGT0(3,LRA)

  case (8)
    !===================================================================
    ! SD1(8) Ar ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    if (JB_SYS > 0) call SDD_AR_ACT_BL_SGT0(3,LRA)

  case (11)
    !===================================================================
    ! TT(11) Drl-  ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0TT2 = W0_TT(2)
      W1TT2 = W1_TT(2)
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          ! TT(11-2) (22)Drl(22)-
          ! TT(11-2) Drl(22)-C"(22)-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT2
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TT2
          end do
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          call Drl_TS_EXT(LRI)
          call Drl_TS_EXT(LRJ)
        end do
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          call AR_BL_EXT_TS(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          call AR_BL_EXT_TS(LRI,LRJ,NK)
        end do
      end do
    end if

  case (12)
    !===================================================================
    ! TTTT(12) Ar-Bl- Drl- ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call TTTT_Drl_ACT_C_EXT_AB_SGT0(3)
    else
      call TTTT_ArBl_ACT_C_EXT_AB_SGT0(3)
    end if

  case (13)
    !===================================================================
    ! TD(13) ACT -BL-
    if (LINELP /= 17) return
    LRA = NLG1
    call TD_AR_ACT_BL(3,LRA)

  case (15)
    !===================================================================
    ! T1D1(15) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call TTDD_AR_ACT_BL_SGT1(3,LRA)

  case (19)
    !===================================================================
    ! DD(19) ACT -C"- ..................................................
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0DD2 = W0_DD(2)
      W1DD2 = W1_DD(2)
      do LRI=NORB_FRZ+1,NORB_DZ
        LMI = LSM_INN(LRI)
        if (LMI /= JML) cycle
        ! DD(19-2) Drl(22)-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD2
        end do
        IWDL = JUD(LRI)
        IWDR = IWDL
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        call Drl_TS_EXT(LRI)
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if (LMIJ /= JMLR) cycle
          W0DD1 = W0_DD(1)
          W1DD1 = W1_DD(1)
          NI = mod(LRJ-LRI,2)
          if (NI == 0) then
            W0DD1 = -W0DD1
            W1DD1 = -W1DD1
          end if
          if ((LMI == JML) .and. (LMJ == JMR)) then
            ! DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            do MPL=1,MTYPE
              VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD1
            end do
            IWDL = JUD(LRI)
            IWDR = JUD(LRJ)
            do MPL=1,MHLP
              IWAL = LPNEW_LWEI(MPL)
              IWAR = LPNEW_RWEI(MPL)
              LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            end do
            call AR_BL_EXT_TS(LRI,LRJ,1)
          end if
        end do
      end do
    end if

  case (20)
    !===================================================================
    ! D1D1(20) Drl- Ar-Bl- ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call D1D1_Drl_ACT_C_EXT_AB_SGT0(3)
    else
      call D1D1_ArBl_ACT_C_EXT_AB_SGT0(3)
    end if

  case (21)
    !===================================================================
    ! DD1(21) Ar-Bl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call DD1_ArBl_ACT_C_EXT_AB_SGT0(3)

  case (22)
    !===================================================================
    ! D1D(22) Ar-Bl- Drl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call D1D_ArBl_ACT_C_EXT_AB_SGT0(3)
    call D1D_Drl_ACT_C_EXT_AB_SGT0(3)

  case (23)
    !===================================================================
    ! DV(23) ACT -C'-..................................................
    if (LINELP /= 17) return
    LRA = NLG1
    do LRI=NORB_FRZ+1,NORB_DZ
      LMI = LSM_INN(LRI)
      if (LMI /= JMLR) cycle
      W0DV1 = W0_DV(1)
      NI = mod(NORB_DZ-LRI,2)
      if (NI == 1) W0DV1 = -W0DV1
      ! DV(23-1) A&r(23)-
      IWDL = JUD(LRI)
      IWDR = 0
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0DV1
      end do
      call Ar_BL_EXT_TS(LRI,LRA,1)
    end do

  case (24)
    !===================================================================
    ! D1V(24) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call D1V_Ar_ACT_Bl_EXT_AB_SGT0(3,LRA)

  case (25)
    !===================================================================
    ! VV(25) ACT -BL- ..................................................

  case (7,9:10,14,16:18,26)
end select

return

end subroutine ts_ext_head_in_dbl

subroutine ts_ext_head_in_act()

use gugaci_global, only: linelp, logic_dh, nlg1, nlg2
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lrai, lraj

LOGIC_DH = .false.
LRAI = NLG1
LRAJ = NLG2
!line=5 A&r-B&l<-->EXT
if (LINELP == 5) then
  call AR_BL_EXT_TS(lrai,lraj,1)
end if
!line=9 D&rl<-->EXT
if (LINELP == 9) then
  call Drl_TS_EXT(lrai)
end if

return

end subroutine ts_ext_head_in_act

subroutine tt_drt_ci_new()

use gugaci_global, only: idisk_array, idisk_lp, idownwei_g131415, iml, imr, ipae, ipael, iseg_downwei, jml, jmr, jpad, jpadl, &
                         jpadlr, linelp, lpblock_tt, nvalue_space_ss
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: imlr, jptyl, jptyr, lpb

call external_space_plpmode_value_tt()
idisk_lp = idisk_array(8)

do lpb=1,lpblock_tt
  call read_lp()
  IpaeL = iml+9
  Ipae = imr+9
  call logicg_st(iml,imr,3,3)      ! irtype=3(T),lptype=5:ArBl-
  imlr = Mul(iml,imr)
  !if (imlr == 1) imspace = iml
  nvalue_space_ss = iseg_downwei(9+imlr)
  idownwei_g131415 = iseg_downwei(9+iml)
  call get_jpty(jpadlr,jptyl,jptyr)
  call get_jp(jptyl,jml,jpadl,1)
  call get_jp(jptyr,jmr,jpad,1)
  !JMLR = Mul(JML,JMR)
  if (linelp <= 12) then
    call tt_ext_head_in_act()
  else
    call tt_ext_head_in_dbl()
  end if
end do

return

end subroutine tt_drt_ci_new

subroutine tt_ext_head_in_dbl()

use gugaci_global, only: ipae, ipael, jb_sys, jml, jmr, jpad, jpadl, jpadlr, jud, just, linelp, logic_dh, lp_lwei, lp_rwei, &
                         lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, nlg1, nlg2, norb_dz, norb_frz, vplp_w0, vplp_w1, &
                         vplpnew_w0, vplpnew_w1, w0_dd, w0_dv, w0_ss, w0_tt, w0_vv, w1_dd, w1_ss, w1_st, w1_tt
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lpok, lr0, lra, lri, lrj, lrk, mpl, ni, nk
real(kind=wp) :: w0dd1, w0dd2, w0dd3, w0dv1, w0ss15, w0ss17, w0ss20, w0tt2, w0tt3, w1dd1, w1dd2, w1ss15, w1ss17, w1tt2
integer(kind=iwp), external :: iwalk_ad

LOGIC_DH = .true.
JMLR = Mul(JML,JMR)
LPOK = JPADLR
select case (LPOK)
  case (1)
    !===================================================================
    ! SS(1)   ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1-1)  Ar(01)-Bl(32)-        ACT -C"-
    ! SS(1-3)  Ar(13)-Bl(20)-        ACT -C"-
    ! SS(1-6)  (11)-Ar(23)-Bl(32)-   ACT -C"-
    ! SS(1-7)  Ar(13)-C'(21)-Bl(32)- ACT -C"-
    ! SS(1-8)  Ar(13)-C'(22)-Bl(31)- ACT -C"-
    ! SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
    ! SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
    ! SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
    ! SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
    ! SS(1-16) (11)-Drl(22)-         ACT -C"-
    ! SS(1-18) Drl(11)-C"(22)-       ACT -C"-
    ! SS(1-19) Drl(12)-C"(21)-       ACT -C"-
    ! SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
    ! SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
    !-------------------------------------------------------------------
    ! SS(1)   ACT 14: -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      if (JB_SYS > 0) call SS_Drl_ACT_C_EXT_AB_SGT0(11)
      W0SS15 = W0_SS(15)
      W1SS15 = W1_SS(15)
      W0SS17 = W0_SS(17)
      W1SS17 = W1_SS(17)
      W0SS20 = W0_SS(20)
      if ((JML == 1) .and. (JMR == 1)) then
        ! SS(1-20) Drl(33)-C"(00)-       ACT -C"-                  ! IPL(R)AD=
        do LR0=NORB_FRZ+1,NORB_DZ
          IWDL = JUST(LR0,LR0)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL) = Zero
          end do
          !do lrk=1,norb_dz
          !  if (lrk == lr0) cycle
          !  call Drl_tt_ext(lrk)
          !end do
          call Drl_TT_SUM(LR0,0)
        end do
      end if
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          ! SS(1-15) (22)-Drl(11)-         ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS15
          end do
          call Drl_TT_EXT(LRJ)
          ! SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS17
          end do
          call Drl_TT_EXT(LRI)
          ! SS(1-20) (22)(11)Drl(33)-      ACT -C"-
          ! SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
          ! SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL) = Zero
          end do
          call Drl_TT_SUM(LRI,LRJ)
        end do
      end do
    else
      if (JB_SYS > 0) then
        call SS_ArBl_ACT_C_EXT_AB_SGT0(11)
        call SS_S_Drl_ACT_C_EXT_AB_SGT0(11)
      end if
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call SS2_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,1)
          call SS4_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,1)
          call SS5_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,NK)
          call SS10_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,NK)
          call SS14_EXT(LRI,LRJ,NK)
          if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,NK)
        end do
      end do
    end if

  case (2)
    !===================================================================
    ! ST(2)   ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    if (JB_SYS > 0) call ST_Drl_ACT_C_EXT_AB_SGT0(11)
    if (JB_SYS > 0) call ST_ArBl_ACT_C_EXT_AB_SGT0(11)
    do LRI=NORB_FRZ+1,NORB_DZ-1
      do LRJ=LRI+1,NORB_DZ
        call ST1_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,1)
        call ST2_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,NK)
        call ST4_EXT(LRI,LRJ,NK,1)
        if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,NK)
        call ST4_EXT(LRI,LRJ,NK,-1)
        if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,NK)
      end do
    end do

    do LRI=NORB_FRZ+1,NORB_DZ-1
      LMI = LSM_INN(LRI)
      do LRJ=LRI+1,NORB_DZ
        LMJ = LSM_INN(LRJ)
        LMIJ = Mul(LMI,LMJ)
        if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
        ! ST(2-5) (22)Drl(12)-          ACT -C"-
        IWDL = JUST(LRI,LRJ)
        IWDR = IWDL
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(5)
        end do
        call Drl_TT_EXT(LRJ)
        ! ST(2-6) Drl(22)-C"(12)-       ACT -C"-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = Zero
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1_ST(6)
        end do
        call Drl_TT_EXT(LRI)
        !---------------------------------------------------------------
        ! ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
        ! ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
        ! ST(2-7) Drl(12)-C"(22)-         ACT -C"-
        !---------------------------------------------------------------
      end do
    end do

  case (3)
    !===================================================================
    ! TS(3) D&R^L-  ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 == 1)) return
    if (JB_SYS > 0) then
      call TS_ArBl_ACT_C_EXT_AB_SGT0(11)
    end if
    do LRI=NORB_FRZ+1,NORB_DZ-1
      do LRJ=LRI+1,NORB_DZ
        call TS1_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,1)
        call TS2_EXT(LRI,LRJ,NK,1)
        if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,NK)
        call TS2_EXT(LRI,LRJ,NK,-1)
        if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,NK)
        call TS4_EXT(LRI,LRJ,NK)
        if (NK /= 0) call Ar_BL_EXT_TT(LRI,LRJ,NK)
      end do
    end do

  case (4)
    !===================================================================
    ! ST1(4) Ar-Bl- Drl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call STT_ArBl_ACT_C_EXT_AB_SGT1(11)

  case (5)
    !===================================================================
    ! T1S(5) Ar-Bl- Drl ACT -C"-
    if ((LINELP /= 14) .or. (NLG2 /= 2)) return
    call TTS_Drl_ACT_C_EXT_AB_SGT1(11)
    call TTS_ArBl_ACT_C_EXT_AB_SGT1(11)

  case default ! (6)
    !===================================================================
    ! SD(6-1) ACT -B&L-
    if (LINELP /= 17) return
    LRA = NLG1
    call SD_AR_ACT_BL(11,LRA)
    if (JB_SYS > 0) call SD_AR_ACT_BL_SGT0(11,LRA)

  case (8)
    !===================================================================
    ! SD1(8) Ar ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    if (JB_SYS > 0) call SDD_AR_ACT_BL_SGT0(11,LRA)

  case (11)
    !===================================================================
    ! TT(11) Drl-  ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0TT2 = W0_TT(2)
      W1TT2 = W1_TT(2)
      W0TT3 = W0_TT(3)
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if ((LMIJ /= JML) .or. (LMIJ /= JMR)) cycle
          ! TT(11-2) (22)Drl(22)-
          ! TT(11-2) Drl(22)-C"(22)-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT2
            VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TT2
          end do
          IWDL = JUST(LRI,LRJ)
          IWDR = IWDL
          do MPL=1,MHLP
            IWAL = LPNEW_LWEI(MPL)
            IWAR = LPNEW_RWEI(MPL)
            LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          end do
          call Drl_TT_EXT(LRI)
          call Drl_TT_EXT(LRJ)
          ! TT(11-3) Drl(33)-C"(22)-C"(22)-
          ! TT(11-3) (22)Drl(33)-C"(22)-
          ! TT(11-3) (22)(22)Drl(33)-
          do MPL=1,MTYPE
            VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT3
            VPLP_W1(MPL) = Zero
          end do
          !do lrk=1,norb_dz
          !  if (lrk == lri) cycle
          !  if (lrk == lrj) cycle
          !  call Drl_tt_ext(lrk)
          !end do
          call Drl_TT_SUM(LRI,LRJ)
        end do
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        do LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          call Ar_BL_EXT_TT(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          call Ar_BL_EXT_TT(LRI,LRJ,NK)
        end do
      end do
    end if

  case (12)
    !===================================================================
    ! TTTT(12) Ar-Bl- Drl- ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call TTTT_Drl_ACT_C_EXT_AB_SGT0(11)
    else
      call TTTT_ArBl_ACT_C_EXT_AB_SGT0(11)
    end if

  case (13)
    !===================================================================
    ! TD(13) ACT -B&L-
    if (LINELP /= 17) return
    LRA = NLG1
    call TD_AR_ACT_BL(11,LRA)

  case (15)
    !===================================================================
    ! T1D1(15) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call TTDD_AR_ACT_BL_SGT1(11,LRA)

  case (19)
    !===================================================================
    ! DD(19) ACT -C"- ..................................................
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      W0DD2 = W0_DD(2)
      W1DD2 = W1_DD(2)
      W0DD3 = W0_DD(3)
      do LRI=NORB_FRZ+1,NORB_DZ
        LMI = LSM_INN(LRI)
        if (LMI /= JML) cycle
        ! DD(19-2) Drl(22)-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD2
        end do
        IWDL = JUD(LRI)
        IWDR = IWDL
        do MPL=1,MHLP
          IWAL = LPNEW_LWEI(MPL)
          IWAR = LPNEW_RWEI(MPL)
          LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        end do
        call Drl_TT_EXT(LRI)
        ! DD(19-3) (22)Drl(33)-
        ! DD(19-3) Drl(33)-C"(22)-
        do MPL=1,MTYPE
          VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD3
          VPLP_W1(MPL) = Zero
        end do
        call Drl_TT_SUM(LRI,0)
        !do lrk=1,norb_dz
        !  if (lrk == lri) cycle
        !  call Drl_tt_ext(lrk)
        !end do
      end do
    else
      do LRI=NORB_FRZ+1,NORB_DZ-1
        LMI = LSM_INN(LRI)
        do LRJ=LRI+1,NORB_DZ
          LMJ = LSM_INN(LRJ)
          LMIJ = Mul(LMI,LMJ)
          if (LMIJ /= JMLR) cycle
          W0DD1 = W0_DD(1)
          W1DD1 = W1_DD(1)
          NI = mod(LRJ-LRI,2)
          if (NI == 0) then
            W0DD1 = -W0DD1
            W1DD1 = -W1DD1
          end if
          if ((LMI == JML) .and. (LMJ == JMR)) then
            ! DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            do MPL=1,MTYPE
              VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DD1
              VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1DD1
            end do
            IWDL = JUD(LRI)
            IWDR = JUD(LRJ)
            do MPL=1,MHLP
              IWAL = LPNEW_LWEI(MPL)
              IWAR = LPNEW_RWEI(MPL)
              LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            end do
            call Ar_BL_EXT_TT(LRI,LRJ,1)
          end if
        end do
      end do
    end if

  case (20)
    !===================================================================
    ! D1D1(20) Drl- Ar-Bl- ACT -C"-
    if (LINELP /= 14) return
    if (NLG2 == 1) then
      call D1D1_Drl_ACT_C_EXT_AB_SGT0(11)
    else
      call D1D1_ArBl_ACT_C_EXT_AB_SGT0(11)
    end if

  case (21)
    !===================================================================
    ! DD1(21) Ar-Bl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call DD1_ArBl_ACT_C_EXT_AB_SGT0(11)

  case (22)
    !===================================================================
    ! D1D(22) Ar-Bl- Drl- ACT -C"-
    if ((LINELP /= 14) .or. (nlg2 /= 2)) return
    call D1D_ArBl_ACT_C_EXT_AB_SGT0(11)
    call D1D_Drl_ACT_C_EXT_AB_SGT0(11)

  case (23)
    !===================================================================
    ! DV(23) ACT -C'-..................................................
    if (LINELP /= 17) return
    LRA = NLG1
    do LRI=NORB_FRZ+1,NORB_DZ
      LMI = LSM_INN(LRI)
      if (LMI /= JMLR) cycle
      W0DV1 = W0_DV(1)
      NI = mod(NORB_DZ-LRI,2)
      if (NI == 1) W0DV1 = -W0DV1
      ! DV(23-1) A&r(23)-
      IWDL = JUD(LRI)
      IWDR = 0
      do MPL=1,MHLP
        IWAL = LPNEW_LWEI(MPL)
        IWAR = LPNEW_RWEI(MPL)
        LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      end do
      do MPL=1,MTYPE
        VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0DV1
        VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W0DV1
      end do
      call Ar_BL_EXT_TT(LRI,LRA,1)
    end do

  case (24)
    !===================================================================
    ! D1V(24) Ar- ACT -Bl-
    if (LINELP /= 17) return
    LRA = NLG1
    call D1V_Ar_ACT_Bl_EXT_AB_SGT0(11,LRA)

  case (25)
    !===================================================================
    ! VV(25) ACT -BL- ..................................................
    if ((LINELP /= 14) .or. (NLG2 /= 1)) return
    ! VV(25) Drl(33)-
    IWDL = 0
    IWDR = 0
    do MPL=1,MTYPE
      VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0_VV
      VPLP_W1(MPL) = Zero
    end do
    do MPL=1,MHLP
      IWAL = LPNEW_LWEI(MPL)
      IWAR = LPNEW_RWEI(MPL)
      LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
      LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
    end do
    !call Drl_TT_SUM(0,0)
    do lrk=1,norb_dz
      call Drl_tt_ext(lrk)
    end do

  case (7,9:10,14,16:18,26)
end select

return

end subroutine tt_ext_head_in_dbl

subroutine tt_ext_head_in_act()

use gugaci_global, only: linelp, logic_dh, nlg1, nlg2
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lrai, lraj

LOGIC_DH = .false.
LRAI = NLG1
LRAJ = NLG2
!line=5 A&r-B&l<-->EXT
if (LINELP == 5) then
  call Ar_BL_EXT_TT(lrai,lraj,1)
end if
!line=9 D&rl<-->EXT
if (LINELP == 9) then
  call Drl_TT_EXT(lrai)
end if

return

end subroutine tt_ext_head_in_act

subroutine logicg_st(ilnodesm,irnodesm,iltype,irtype)

use gugaci_global, only: ism_g1415, ism_g2g4, logic_g13, logic_g1415, logic_g2g4a, logic_g2g4b, logic_g34a, logic_g34b, &
                         logic_g35a, logic_g35b, logic_g36a, logic_g36b, lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, &
                         lpend36b, lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, lpsta36b
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ilnodesm, irnodesm, iltype, irtype
integer(kind=iwp) :: iii, ilrsm

ilrsm = Mul(ilnodesm,irnodesm)
iii = 1      !index to determine lwei rwei iposint and nlinkorb
! G2G4a G2G4b G1415 G13
logic_g36a = .false.
logic_g36b = .false.
logic_g35a = .false.
logic_g35b = .false.
logic_g34a = .false.
logic_g34b = .false.

lpsta36a = iii
call do_g36mode(ilrsm,ilnodesm,iii)
lpend36a = iii-4
if (lpend36a >= lpsta36a) logic_g36a = .true.
lpsta35a = iii
call do_g35mode(ilrsm,ilnodesm,iii)
lpend35a = iii-4
if (lpend35a >= lpsta35a) logic_g35a = .true.
lpsta34a = iii
call do_g34mode(ilrsm,ilnodesm,iii)
lpend34a = iii-4
if (lpend34a >= lpsta34a) logic_g34a = .true.
if (ilrsm /= 1) then
  lpsta36b = iii
  call do_g36mode(ilrsm,irnodesm,iii)
  lpend36b = iii-4
  if (lpend36b >= lpsta36b) logic_g36b = .true.
  lpsta35b = iii
  call do_g35mode(ilrsm,irnodesm,iii)
  lpend35b = iii-4
  if (lpend35b >= lpsta35b) logic_g35b = .true.
  lpsta34b = iii
  call do_g34mode(ilrsm,irnodesm,iii)
  lpend34b = iii-4
  if (lpend34b >= lpsta34b) logic_g34b = .true.
else
  logic_g36b = logic_g36a
  lpsta36b = lpsta36a
  lpend36b = lpend36a
  logic_g35b = logic_g35a
  lpsta35b = lpsta35a
  lpend35b = lpend35a
  logic_g34b = logic_g34a
  lpsta34b = lpsta34a
  lpend34b = lpend34a
end if
logic_g2g4a = .false.
logic_g2g4b = .false.
logic_g1415 = .false.
logic_g13 = .false.

if ((irnodesm == 1) .and. (irtype == 4)) then        ! ir:S_1
  logic_g2g4a = .true.
  ism_g2g4 = ilnodesm
end if
if ((ilnodesm == 1) .and. (iltype == 4)) then        ! il:S_1
  logic_g2g4b = .true.
  ism_g2g4 = irnodesm
end if
if (ilnodesm == irnodesm) then                       ! ir:S_1
  logic_g1415 = .true.
  ism_g1415 = ilnodesm
end if

end subroutine logicg_st

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RdCmo_motra(CMO,Ovlp)
************************************************************************
*                                                                      *
*     Purpose:                                                         *
*     Read molecular orbitals from input                               *
*     iVecTyp=1  : obsolete, regarded as error                         *
*     iVecTyp=2  : read from unit INPORB in the same format            *
*     iVecTyp=3  : read from an old casscf interface unit JOBIPH.      *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (A-H,O-Z)
*
#include "motra_global.fh"
#include "trafo_motra.fh"
#include "files_motra.fh"
#include "SysDef.fh"
*
      Real*8 CMO(*), Ovlp(*)
      Logical okay
      Integer itemp2((LENIN8*MxOrb)/ItoB)
      Character ctemp2(LENIN8*MxOrb)
      Real*8  temp2(MxRoot)
      Dimension Dummy(1),iDummy(1)
*
*----------------------------------------------------------------------*
*     Read MO coefficients from input                                  *
*----------------------------------------------------------------------*
      If ( iVecTyp.eq.1 ) Then
        Write (6,*) 'RdCmo_motra: iVecTyp.eq.1'
        Write (6,*) 'This error means someone has put a bug into MOTRA!'
        Call Abend()
      End If
*----------------------------------------------------------------------*
*     Read MO coefficients from a formatted vector file                *
*----------------------------------------------------------------------*
      If ( iVecTyp.eq.2 ) Then
        call f_Inquire (FnInpOrb,okay)
        If ( okay ) Then
          lOcc = 0
          Call RdVec(FnInpOrb,LuInpOrb,'C',nSym,nBas,nBas,
     &          Cmo, Dummy, Dummy, iDummy,
     &          VecTit, 0, iErr)
        Else
          Write (6,*) 'RdCMO_motra: Error finding MO file'
          Call Abend()
        End If
      End If
*----------------------------------------------------------------------*
*     Read MO coefficients from JOBIPH generated by RASSCF             *
*----------------------------------------------------------------------*
      If ( iVecTyp.eq.3 ) Then
        call f_Inquire (FnJobIph,okay)
        If ( okay ) Then
          Call DaName(LuJobIph,FnJobIph)
          iDisk=0
          Call iDaFile( LuJobIph,2,TcJobIph,10,iDisk)
          iDisk=TcJobIph(1)
          Call WR_RASSCF_Info(LuJobIph,2,iDisk,
     &                        itemp2(1),itemp2(1),itemp2(1),itemp2(1),
     &                        itemp2,itemp2,itemp2,itemp2,
     &                        itemp2,mxSym,ctemp2,lenin8*mxOrb,
     &                        itemp2(1),ctemp2,144,
     &                        ctemp2,4*18*mxTit,
     &                        temp2(1),itemp2(1),itemp2(1),
     &                        itemp2,mxRoot,itemp2,itemp2,itemp2,
     &                        itemp2(1),itemp2(1),iPt2,temp2)
          iDisk=TcJobIph(2)
          if ( iPt2.ne.0 ) iDisk=TcJobIph(9)
          Call dDaFile(LuJobIph,2,Cmo,nTot2,iDisk)
          Call DaClos(LuJobIph)
          VecTit='JOBIPH'
        Else
          Write (6,*) 'RdCMO_motra: Error finding JOBIPH file'
          Call Abend()
        End If
      End If
*----------------------------------------------------------------------*
*     Normal termination                                               *
*----------------------------------------------------------------------*
      Call Ortho_Motra(nSym,nBas,nDel,Ovlp,Cmo)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015,2016, Ignacio Fdez. Galvan                        *
!***********************************************************************

subroutine Process_Gradients()

use Slapaf_Info, only: ApproxNADC, Energy, Energy0, Gx, Gx0, iState, iter, NAC, NADC, Request_Alaska, RootMap, TwoRunFiles
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: Columbus, i, nRoots, nsAtom, RC
real(kind=wp) :: E0, E1
logical(kind=iwp) :: Exists, Found
real(kind=wp), allocatable :: Ener(:), Grads(:,:,:)
integer(kind=iwp), external :: Read_Grad

Request_Alaska = .false.
nsAtom = size(Gx,2)
call mma_Allocate(Grads,3,nsAtom,3)

! First check that all the needed gradients are available
! and stop to compute them if they are not.
! For a two-RunFile job, this behaves as if it is one state.

if (TwoRunFiles) iState(:) = 0

if (iState(1) /= 0) iState(1) = RootMap(iState(1))
if (iState(2) /= 0) iState(2) = RootMap(iState(2))
i = max(iState(1),iState(2))
iState(2) = min(iState(1),iState(2))
iState(1) = i

if ((iState(1) /= 0) .and. (iState(2) /= 0)) then

  ! Two states

  do i=2,1,-1
    RC = Read_Grad(Grads(:,:,i),3*nsAtom,iState(i),0,0)
    if (RC == 0) then
      Request_Alaska = .true.
      call Put_iScalar('Relax CASSCF root',iState(i))
      call Put_iScalar('NumGradRoot',iState(i))
      iState(1) = iState(i)
      iState(2) = 0
      exit
    end if
  end do
  if ((.not. Request_Alaska) .and. NADC) then
    RC = Read_Grad(Grads(:,:,3),3*nsAtom,0,iState(1),iState(2))
    if (RC == 0) Request_Alaska = .true.
  end if

else

  ! One state

  iState(1) = 0
  iState(2) = 0
  call Qpg_iScalar('Relax CASSCF root',Exists)
  if (Exists) call Get_iScalar('Relax CASSCF root',iState(1))
  if (iState(1) == 0) iState(1) = 1
  RC = Read_Grad(Grads(:,:,1),3*nsAtom,iState(1),0,0)
  if (RC == 0) Request_Alaska = .true.
end if

if (Request_Alaska) then
  call mma_Deallocate(Grads)
  NADC = .false.
  return
end if

! Once the gradients are read, convert them to forces
! and store them as appropriate.

! Energy and gradient of the first (higher) state

nRoots = 1
call Qpg_iScalar('Number of roots',Found)
if (Found) call Get_iScalar('Number of roots',nRoots)
call mma_Allocate(Ener,nRoots)
call Get_dArray('Last energies',Ener,nRoots)
if (max(iState(1),iState(2)) > nRoots) then
  call WarningMessage(2,'Too few energies in RUNFILE')
  call Abend()
end if
Energy(iter) = Ener(iState(1))
E1 = Ener(iState(1))
Gx(:,:,iter) = -Grads(:,:,1)

! For a two-RunFile job, read the second energy
! and gradient from RUNFILE2

if (TwoRunFiles) then
  call NameRun('RUNFILE2')
  iState(2) = 0
  call Qpg_iScalar('Relax CASSCF root',Exists)
  if (Exists) call Get_iScalar('Relax CASSCF root',iState(2))
  if (iState(2) == 0) iState(2) = 1
  nRoots = 1
  call Qpg_iScalar('Number of roots',Found)
  if (Found) call Get_iScalar('Number of roots',nRoots)
  call mma_Deallocate(Ener)
  call mma_Allocate(Ener,nRoots)
  call Get_dArray('Last energies',Ener,nRoots)
  call Get_dArray('GRAD',Grads(:,:,2),3*nsAtom)
  call NameRun('#Pop')
  RC = -1
end if

if (iState(2) > 0) then

  ! With two states the Lagrangian is different!
  ! We will optimize on the average energy and have a constraint
  ! for the energy difference. We change the energies and gradients
  ! on the fly.

  E0 = Ener(iState(2))
  Energy(iter) = (E1+E0)*Half
  Energy0(iter) = E1-E0
  Gx(:,:,iter) = Half*(Gx(:,:,iter)-Grads(:,:,2))
  Gx0(:,:,iter) = Grads(:,:,2)-Grads(:,:,1)
  call Get_iScalar('Columbus',Columbus)

  ! In case of a true conical intersection there is also coupling.

  if (NADC) then
    call Get_iScalar('Columbus',Columbus)
    if (Columbus /= 1) then
      NAC(:,:,iter) = Grads(:,:,3)

      ! If the coupling derivative vector could not be calculated,
      ! use an approximate one.

      if (RC < 0) then
        ApproxNADC = .true.
        call Branching_Plane_Update(Gx,Gx0,NAC(:,:,iter),3*nsAtom,iter)
      end if
    end if
  end if
end if

call mma_Deallocate(Ener)
call mma_Deallocate(Grads)

return

end subroutine Process_Gradients

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************

function NGENE(NEL,MLTPL)
! Nr of genealogical spin couplings

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: NGENE
integer(kind=iwp), intent(in) :: NEL, MLTPL
integer(kind=iwp) :: IS2, ND, NU
integer(kind=iwp), external :: NOVERM

NGENE = 0
if (MLTPL <= 0) return
IS2 = MLTPL-1
if (NEL < IS2) return
NU = (NEL+IS2)/2
ND = (NEL-IS2)/2
if (NU+ND /= NEL) return
NGENE = NOVERM(NEL,NU)-NOVERM(NEL,NU+1)

end function NGENE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine PrMtrx(Label,lOper,nComp,ip,Matrix)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, Sweden, January '91                  *
************************************************************************
      Use Basis_Info, only: nBas
      use Gateway_global, only: PrPrt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
*     Local arrays
      Real*8 Matrix(*)
      Character Label*(*), Line*80
      Integer ip(nComp), lOper(nComp)
      Logical Type
*
*
      Do 10 iComp = 1, nComp
         ip1 = ip(iComp)
         iSmLbl = lOper(iComp)
         If (Prprt) iSmLbl = iAnd(1,iSmLbl)
         Type = .True.
         Do 30 iIrrep = 0, nIrrep - 1
            If (nBas(iIrrep).le.0) Go To 30
            Do 40 jIrrep = 0, iIrrep
               If (nBas(jIrrep).le.0) Go To 40
               If (iAnd(iSmLbl,2**iEor(iIrrep,jIrrep)).eq.0)
     &            Go To 40
               If (Type) Then
                  Type = .False.
                  Write (6,*)
                  Write (6,*)
                  Write (6,'(A,A,A,I2)')
     &                  ' SO Integrals of type ', Label,' Component ',
     &                     iComp
               End If
               Line=''
               If (iIrrep.eq.jIrrep) Then
                  Write (Line,'(1X,A,I1)')
     &            ' Diagonal Symmetry Block ', iIrrep+1
                  Call TriPrt(Line,' ',
     &                 Matrix(ip1),nBas(iIrrep))
                  ip1 = ip1 + nBas(iIrrep)*(nBas(iIrrep)+1)/2
               Else
                  Write (Line,'(1X,A,I1,A,I1)')
     &            ' Off-diagonal Symmetry Block ',
     &            iIrrep+1, ',' , jIrrep+1
                  Call RecPrt(Line,' ',
     &                        Matrix(ip1),nBas(iIrrep),nBas(jIrrep))
                  ip1 = ip1 + nBas(iIrrep)*nBas(jIrrep)
               End If
 40         Continue
 30      Continue
 10   Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION IMNMX(IVEC,NDIM,MINMAX)
*
*     Find smallest (MINMAX=1) or largest (MINMAX=2)
*     absolute value of elements in integer vector IVEC
*
      DIMENSION IVEC(*)
*
      IX = 0
      IF(NDIM.GT.0) THEN
        IX = -1
        IF(MINMAX.EQ.1) THEN
          IX=ABS(IVEC(1))
          DO I=2,NDIM
            IX=MIN(IX,ABS(IVEC(I)))
          END DO
        END IF
*
        IF(MINMAX.EQ.2) THEN
          IX=ABS(IVEC(1))
          DO I=2,NDIM
            IX=MAX(IX,ABS(IVEC(I)))
          END DO
        END IF
*
      ELSE IF(NDIM.EQ.0) THEN
*. No components : set to zero and write a warning
        IX = 0
        WRITE(6,*) ' Min/Max taken zero length vector set to zero'
      END IF
*
      IMNMX = IX
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Truncate_Grid(R,nR,nR_Eff,Radius_Max)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nR
real(kind=wp), intent(in) :: R(2,nR), Radius_Max
integer(kind=iwp), intent(inout) :: nR_Eff
integer(kind=iwp) :: i, nTmp

nTmp = nR_Eff
do i=1,nTmp
  if (R(1,i) > Radius_Max) then
    nR_Eff = i-1
    exit
  end if
end do

return

end subroutine Truncate_Grid

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SOAdd(SOInt,iBas,jBas,nSOInt,PrpInt,nPrp,lOper,iCmp,jCmp,iShell,jShell,iAO,jAO)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January '91                                              *
!***********************************************************************

use Index_Functions, only: iTri
use SOAO_Info, only: iAOtSO
use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iBas, jBas, nSOInt, nPrp, lOper, iCmp, jCmp, iShell, jShell, iAO, jAO
real(kind=wp), intent(in) :: SOInt(iBas*jBas,nSOInt)
real(kind=wp), intent(inout) :: PrpInt(nPrp)
integer(kind=iwp) :: i1, i2, IndAO1, IndAO2, Indij, ip, iPnt, iSO, iSO1, iSO2, j1, j12, j2, jSO, lSO, nRow
integer(kind=iwp), external :: iPntSO

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt(' In SOAdd:SOInt',' ',SOInt,iBas*jBas,nSOInt)
#endif

lSO = 0
do j1=0,nIrrep-1
  do i1=1,iCmp
    if (iAOtSO(iAO+i1,j1) < 0) cycle

    ! Scatter the SO's onto lower rectangular blocks and triangular
    ! diagonal blocks.

    do j2=0,j1
      j12 = ieor(j1,j2)
      if (.not. btest(lOper,j12)) cycle

      do i2=1,jCmp
        if (iAOtSO(jAO+i2,j2) < 0) cycle
        if ((iShell == jShell) .and. (j1 == j2) .and. (i1 < i2)) cycle

        lSO = lSO+1
        iSO1 = iAOtSO(iAO+i1,j1)
        iSO2 = iAOtSO(jAO+i2,j2)

        iPnt = iPntSO(j1,j2,lOper,nbas)
        do indAO1=1,iBas
          do indAO2=1,jBas
            ip = (indAO2-1)*iBas+indAO1

            ! Move one electron integral.

            iSO = iSO1+IndAO1-1
            jSO = iSO2+IndAO2-1

            ! Diagonal block. Store only unique elements
            if ((j1 == j2) .and. (iSO1 == iSO2) .and. (iSO < jSO)) cycle

            if (j1 == j2) then
              ! Diagonal symmetry block
              Indij = iPnt+iTri(iSO,jSO)
            else
              ! Off-diagonal symmetry block j1>j2
              nRow = nBas(j1)
              Indij = iPnt+nRow*(jSO-1)*nRow+iSO
            end if

            PrpInt(Indij) = PrpInt(Indij)+SOInt(ip,lSO)

          end do
        end do

      end do
    end do

  end do
end do

return

end subroutine SOAdd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991-1994, Jeppe Olsen                                 *
!***********************************************************************

subroutine RSBB2BN_MCLR(IASM,IATP,IBSM,IBTP,NIA,NIB,JASM,JATP,JBSM,JBTP,NJA,NJB,IAGRP,IBGRP,IAEL1,IAEL3,JAEL1,JAEL3,IBEL1,IBEL3, &
                        JBEL1,JBEL3,SB,CB,NTSOB,IBTSOB,MAXK,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,NSM,CJRES,SIRES,ISGN,ieaw,TimeDep)
! Combined alpha-beta double excitation
! contribution from given C block to given S block
! If IUSAB only half the terms are constructed
! =====
! Input
! =====
!
! IASM,IATP : Symmetry and type of alpha  strings in sigma
! IBSM,IBTP : Symmetry and type of beta   strings in sigma
! JASM,JATP : Symmetry and type of alpha  strings in C
! JBSM,JBTP : Symmetry and type of beta   strings in C
! NIA,NIB   : Number of alpha-(beta-) strings in sigma
! NJA,NJB   : Number of alpha-(beta-) strings in C
! IAGRP     : String group of alpha strings
! IBGRP     : String group of beta strings
! IAEL1(3)  : Number of electrons in RAS1(3) for alpha strings in sigma
! IBEL1(3)  : Number of electrons in RAS1(3) for beta  strings in sigma
! JAEL1(3)  : Number of electrons in RAS1(3) for alpha strings in C
! JBEL1(3)  : Number of electrons in RAS1(3) for beta  strings in C
! CB        : Input C block
! NTSOB     : Number of orbitals per type and symmetry
! IBTSOB    : base for orbitals of given type and symmetry
! IBORB     : Orbitals of given type and symmetry
! NSM       : Number of symmetries of orbitals
! MAXK      : Largest number of inner resolution strings treated at simult.
!
! ======
! Output
! ======
! SB : updated sigma block
!
! =======
! Scratch
! =======
! I1, XI1S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! I2, XI2S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! H          : Space for two electron integrals
!
! Jeppe Olsen, Winter of 1991
!
! Feb 92 : Loops restructured ; Generation of I2,XI2S moved outside
! October 1993 : IUSEAB added
! January 1994 : Loop restructured + ICJKAIB introduced
! February 1994 : Fetching and adding to transposed blocks

use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IASM, IATP, IBSM, IBTP, NIA, NIB, JASM, JATP, JBSM, JBTP, NJA, NJB, IAGRP, IBGRP, IAEL1, IAEL3, &
                                 JAEL1, JAEL3, IBEL1, IBEL3, JBEL1, JBEL3, NTSOB(3,*), IBTSOB(3,*), MAXK, NSM, ISGN, ieaw
real(kind=wp), intent(inout) :: SB(*)
real(kind=wp), intent(in) :: CB(*)
integer(kind=iwp), intent(_OUT_) :: I1(MAXK,*), I2(MAXK,*), I3(MAXK,*), I4(MAXK,*)
real(kind=wp), intent(_OUT_) :: XI1S(MAXK,*), XI2S(MAXK,*), XI3S(MAXK,*), XI4S(MAXK,*), XINT(*), CJRES(*), SIRES(*)
logical(kind=iwp), intent(in) :: TimeDep
integer(kind=iwp) :: IFIRST, II, IIOFF, IJSM, IJTYP, IKORD, IOFF, IOFFIN, IOFFOUT, IROUTE, ISM, ITP(3), ITYP, IXCHNG, J, JB, JJ, &
                     JOFF, JSM, JTP(3), JTYP, KABOT, KAEND, KATOP, KBBOT, KBEND, KBTOP, KLSM, KLTYP, KOFF, KSM, KTP(3), KTYP, LCJ, &
                     LOFF, LSM, LTP(3), LTYP, N1IND, N2IND, N3IND, NI, NIJTYP, NJ, NK, NKABTC, NKBBTC, NKLTYP, NL

IROUTE = 1
! Symmetry of allowed excitations
IJSM = Mul(IASM,JASM)
KLSM = Mul(IBSM,JBSM)
if ((IJSM == 0) .or. (KLSM == 0)) return
! Types of SX that connects the two strings
call SXTYP(NKLTYP,KTP,LTP,IBEL1,IBEL3,JBEL1,JBEL3)
call SXTYP(NIJTYP,ITP,JTP,IAEL1,IAEL3,JAEL1,JAEL3)
if ((NIJTYP == 0) .or. (NKLTYP == 0)) return
do IJTYP=1,NIJTYP
  ITYP = ITP(IJTYP)
  JTYP = JTP(IJTYP)
  ! TESTTING
  N1IND = 0
  N2IND = 0
  N3IND = 0
  if (ITYP == 1) N1IND = N1IND+1
  if (ITYP == 2) N2IND = N2IND+1
  if (ITYP == 3) N3IND = N3IND+1

  if (JTYP == 1) N1IND = N1IND+1
  if (JTYP == 2) N2IND = N2IND+1
  if (JTYP == 3) N3IND = N3IND+1

  do ISM=1,NSM
    JSM = Mul(ISM,IJSM)
    if (JSM == 0) cycle
    IOFF = IBTSOB(ITYP,ISM)
    JOFF = IBTSOB(JTYP,JSM)
    NI = NTSOB(ITYP,ISM)
    NJ = NTSOB(JTYP,JSM)
    if ((NI == 0) .or. (NJ == 0)) cycle
    ! Loop over batches of KA strings
    KABOT = 1-MAXK
    KATOP = 0
    do
      KABOT = KABOT+MAXK
      KATOP = KATOP+MAXK
      ! Find Ka strings that connect with Ja strings for given group of Jorbs
      call ADST(JOFF,NJ,JATP,JASM,IAGRP,KABOT,KATOP,I1,XI1S,MAXK,NKABTC,KAEND)
      call ADST(IOFF,NI,IATP,IASM,IAGRP,KABOT,KATOP,I3,XI3S,MAXK,NKABTC,KAEND)
      if (NKABTC == 0) exit
      ! Generate - if required C(Ka,Jb,j)
      IIOFF = 1
      LCJ = NJB*NKABTC
      do JJ=1,NJ
        if (JJ == 1) then
          IIOFF = 1
        else
          IIOFF = IIOFF+LCJ
        end if
        call GATRMT(CB,NJA,NJB,CJRES(IIOFF),NKABTC,NJB,I1(:,JJ),XI1S(:,JJ))
      end do

      ! We have now C gathered in the form C(Ka,Jb,j).
      ! If Ka is small, say 1, it can be advantageous to switch
      ! around to C(j,Ka,Jb). This is mediated by the switch IROUTE
      ! IROUTE = 1 : Normal (i.e. old) route,
      ! IROUTE = 2 : New route with j first
      ! IROUTE = 3 : C(Ka,j,Jb)

      if ((NJ >= NKABTC) .and. (NI >= NKABTC)) then
        IROUTE = 2
      else
        IROUTE = 3
      end if
      ! DOES THIS WORK?
      !9805EAW     IROUTE = 1
      if (TimeDep) IROUTE = 1

      if (IROUTE == 2) then
        ! C(Ka,Jb,j) => C(j,Ka,Jb)
        call TRNSPS(LCJ,NJ,CJRES,SIRES)
        CJRES(1:NJ*LCJ) = SIRES(1:NJ*LCJ)
      end if
      if (IROUTE == 3) then
        ! C(Ka,Jb,j) => C(Ka,j,JB)
        do JB=1,NJB
          do J=1,NJ
            IOFFIN = (J-1)*NJB*NKABTC+(JB-1)*NKABTC+1
            IOFFOUT = (JB-1)*NKABTC*NJ+(J-1)*NKABTC+1
            SIRES(IOFFOUT:IOFFOUT+NKABTC-1) = CJRES(IOFFIN:IOFFIN+NKABTC-1)
          end do
        end do
        CJRES(1:NJ*LCJ) = SIRES(1:NJ*LCJ)
      end if

      SIRES(1:NIB*NKABTC*NI) = Zero

      do KLTYP=1,NKLTYP
        KTYP = KTP(KLTYP)
        LTYP = LTP(KLTYP)
        ! Testing
        N1IND = 0
        N2IND = 0
        N3IND = 0
        if (ITYP == 1) N1IND = N1IND+1
        if (ITYP == 2) N2IND = N2IND+1
        if (ITYP == 3) N3IND = N3IND+1

        if (JTYP == 1) N1IND = N1IND+1
        if (JTYP == 2) N2IND = N2IND+1
        if (JTYP == 3) N3IND = N3IND+1

        if (KTYP == 1) N1IND = N1IND+1
        if (KTYP == 2) N2IND = N2IND+1
        if (KTYP == 3) N3IND = N3IND+1

        if (LTYP == 1) N1IND = N1IND+1
        if (LTYP == 2) N2IND = N2IND+1
        if (LTYP == 3) N3IND = N3IND+1
        do KSM=1,NSM
          IFIRST = 1
          LSM = Mul(KSM,KLSM)
          if (LSM == 0) cycle
          KOFF = IBTSOB(KTYP,KSM)
          LOFF = IBTSOB(LTYP,LSM)
          NK = NTSOB(KTYP,KSM)
          NL = NTSOB(LTYP,LSM)
          IKORD = 0

          if ((NK == 0) .or. (NL == 0)) cycle
          ! Loop over batches of KB strings
          KBBOT = 1-MAXK
          KBTOP = 0
          do
            KBBOT = KBBOT+MAXK
            KBTOP = KBTOP+MAXK
            ! obtain cb(KA,KB,jl) =  sum(JA,JB)<KA!a la!JA><KB!a jb !JB>C(JA,JB)

            call ADST(LOFF,NL,JBTP,JBSM,IBGRP,KBBOT,KBTOP,I2,XI2S,MAXK,NKBBTC,KBEND)
            call ADST(KOFF,NK,IBTP,IBSM,IBGRP,KBBOT,KBTOP,I4,XI4S,MAXK,NKBBTC,KBEND)
            if (NKBBTC == 0) exit

            ! Modern low copy version
            if (IFIRST == 1) then
              IXCHNG = 0
              if (IROUTE == 1) then
                ! Integrals stored as (j l i k)
                !write(u6,*) 'Timedep in rsbb2bn_mclr;',TimeDep
                if (TimeDep) then
                  call GETINT_td(XINT,JTYP,JSM,ITYP,ISM,LTYP,LSM,KTYP,KSM,0,0,iroute,ieaw)
                else
                  call GETINT_MCLR(XINT,JTYP,JSM,ITYP,ISM,LTYP,LSM,KTYP,KSM,IXCHNG,0,0,0,ieaw)
                end if
              else if (IROUTE == 2) then
                ! Integrals stored as (i j k l)
                if (TimeDep) then
                  call GETINT_td(XINT,ITYP,ISM,JTYP,JSM,KTYP,KSM,LTYP,LSM,0,0,iroute,ieaw)
                else
                  call GETINT_MCLR(XINT,ITYP,ISM,JTYP,JSM,KTYP,KSM,LTYP,LSM,IXCHNG,0,0,1,ieaw)
                end if
              else if (IROUTE == 3) then
                ! Integrals stored as (j i k l)
                if (TimeDep) then
                  call GETINT_td(XINT,JTYP,JSM,ITYP,ISM,KTYP,KSM,LTYP,LSM,0,0,iroute,ieaw)
                else
                  call GETINT_MCLR(XINT,JTYP,JSM,ITYP,ISM,KTYP,KSM,LTYP,LSM,IXCHNG,0,0,1,ieaw)
                end if
              end if
              if (ISGN == -1) XINT(1:NI*NJ*NK*NL) = -XINT(1:NI*NJ*NK*NL)
              IFIRST = 0
            end if
            call SKICKJ_MCLR(SIRES,CJRES,NKABTC,NIB,NJB,NKBBTC,XINT,NI,NJ,NK,NL,MAXK,I4,XI4S,I2,XI2S,IKORD,IROUTE)

            if (KBEND /= 0) exit
          end do
          ! End of loop over partitioning of beta strings
        end do
      end do
      ! Scatter out from s(Ka,Ib,i)
      ! Restore order !!
      if (IROUTE == 2) then
        call TRNSPS(NI,NIB*NKABTC,SIRES,CJRES)
        SIRES(1:NI*NIB*NKABTC) = CJRES(1:NI*NIB*NKABTC)
      end if
      if (IROUTE == 3) then
        do JB=1,NIB
          do J=1,NI
            IOFFIN = (J-1)*NIB*NKABTC+(JB-1)*NKABTC+1
            IOFFOUT = (JB-1)*NKABTC*NI+(J-1)*NKABTC+1
            CJRES(IOFFIN:IOFFIN+NKABTC-1) = SIRES(IOFFOUT:IOFFOUT+NKABTC-1)
          end do
        end do
        SIRES(1:NI*NIB*NKABTC) = CJRES(1:NI*NIB*NKABTC)
      end if
      do II=1,NI
        call SCARMT(SIRES((II-1)*NKABTC*NIB+1),NKABTC,NIB,SB,NIA,NIB,I3(:,II),XI3S(:,II))

      end do
      if (KAEND /= 0) exit
    end do
    ! End of loop over partitioning of alpha strings
  end do
end do

end subroutine RSBB2BN_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Bjorn O. Roos                                    *
************************************************************************
*--------------------------------------------*
* 1987  B. O. ROOS                           *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND, SWEDEN                 *
*--------------------------------------------*
      Subroutine tr2nsa3(CMO,X1,nX1,X2,nX2,pqUs,npqUS,
     &                   pqrU,npqrU)
C
C SECOND ORDER TWO-ELECTRON TRANSFORMATION ROUTINE
C
C THIS ROUTINE IS CALLED FOR EACH SYMMETRY BLOCK OF INTEGRALS
C (ISP,ISQ,ISR,ISS) WITH ISP.GE.ISQ AND ISR.GE.ISS.
C P,Q,R,S are SO indices.
C A,B are MO indices, counting only non-frozen and non-deleted.
C T,U are occupied MO indices, only non-frozen and non-deleted.
C INTEGRALS (AB/TU) ARE ALWAYS GENERATED
C EXCHANGE INTEGRALS (AT/BU) ARE GENERATED AS FOLLOWS:
C (AT/BU) IF ISP.GE.ISR
C (AT/UB) IF ISP.GT.ISS AND ISP.NE.ISQ
C (TA/BU) IF ISQ.GT.ISR AND ISP.NE.ISQ
C (TA/UB) IF ISQ.GE.ISS AND ISP.NE.ISQ
C
*     This and tr2NsB routines transform non-squared AO integrals. The
*     transformed MO integrals are stored as the same as Tr2Sq
*     subroutine does.
*
      Implicit real*8(a-h,o-z)
CPAM98      COMMON/INTTRA/ISP,ISQ,ISR,ISS,NBP,NBQ,NBR,NBS,NBPQ,NBRS,IRRST,
CPAM98     &              NOCP,NOCQ,NOCR,NOCS,NPQ,LADX,LRUPQ,LURPQ,LTUPQ,
CPAM98     &              NOP,NOQ,NOR,NOS,LMOP,LMOQ,LMOR,LMOS,LMOP2,LMOQ2,
CPAM98     &              LMOR2,LMOS2,IAD13,ITP,ITQ,ITR,ITS

#include "rasdim.fh"
#include "caspt2.fh"
#include "trafo.fh"
#include "intgrl.fh"

#include "SysDef.fh"
      DIMENSION CMO(NCMO)
      Dimension X1(nX1),X2(nX2)
      Dimension PQRU(nPQRU),PQUS(nPQUS)

      NSYMP=NSYM*(NSYM+1)/2
      NOTU=NOCR*NOCS
      IF(ISR.EQ.ISS) NOTU=(NOCR**2+NOCR)/2
      NOUS=NOCR*NBS
      NORU=NBR*NOCS
      icc  =NOP*NOQ*NOCR*NOCS
      icxc1=NOP*NOCQ*NOR*NOCS
      icxc3=NOP*NOCQ*NOCR*NOS
      icxc5=NOCP*NOQ*NOR*NOCS
      icxc7=NOCP*NOQ*NOCR*NOS
c
c Check for in core or out of core transformation
c
C     1. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|US) ON UNIT LUHLF1
      IPQMX1=NBPQ
      IF(NBPQ*NOUS.GT.LURPQ) THEN
       IPQMX1=LURPQ/NOUS
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|US)',IPQMX1
       IAD1S=0
       CALL dDAFILE(LUHLF1,0,PQUS,IPQMX1,IAD1S)
      ENDIF
      IAD1=0
      IOUT1=0
C     2. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|RU) ON UNIT LUHLF2
      IPQMX2=NBPQ
      IF(NBPQ*NORU.GT.LRUPQ) THEN
       IPQMX2=LRUPQ/NORU
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|RU)',IPQMX2
       IAD2S=0
       CALL dDAFILE(LUHLF2,0,PQRU,IPQMX2,IAD2S)
      ENDIF
      IAD2=0
      IOUT2=0
*C     3. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|TU) ON UNIT LUHLF3
*      IPQMX3=NBPQ
*      IF(NBPQ*NOTU.GT.LTUPQ) THEN
*       IPQMX3=LTUPQ/NOTU
*c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|TU)',IPQMX3
*       IAD3S=0
*       CALL dDAFILE(LUHLF3,0,PQTU,IPQMX3,IAD3S)
*      ENDIF
*      IAD3=0
*      IOUT3=0
c
c-----------------------------------------------------------------------
c Second half transformation Case 3 (AT,UB)
c  Calculated if ISR.ne.ISS. Both type 1 and 2. ISQ.ne.ISR, since
c  equality makes integral to be zero symmetrically.
c  Case 4 (BU,TA) need not be calculated, since always ISP.gt.ISS.
c-----------------------------------------------------------------------
      NOTU=NOCQ*NOCR
      If(ISR.ne.ISS.and.icxc3.ne.0)then
       LAS=(LRUPQ+LTUPQ)/NOTU
       LS=LAS/NOP
       IF(LS.GT.NBS) LS=NBS
       LAS=NOP*LS
       IAD2S=0
       CALL dDAFILE(LUHLF2,0,PQRU,LAS,IAD2S)
       IAD2=0
c Loop over u,s pair
       IS=0
       Do NS=1,NBS
        IS=IS+1
        Do NU=1,NOCR
c  Square if necessary
         IUS=NBS*(NU-1)+NS
         IPQST=1+NBPQ*(IUS-1)
         IF(IPQMX1.LT.NBPQ) THEN
          Call RBuf_tra2(LUHLF1,PQUS,NBPQ,IPQMX1,NOUS,IUS,IPQST,IAD1S)
         ENDIF
         If(ISP.eq.ISQ)then
          Call Square(PQUS(IPQST),X2,1,NBP,NBP)
         Else
          call dcopy_(NBPQ,PQUS(IPQST),1,X2,1)
         Endif
c Always ISQ.ne.ISR  i.e. s(T).ne.s(U)
c  (pq,Us) -> (pT,Us)
          CALL DGEMM_('T','N',
     &                NBP,NOCQ,NBQ,
     &                1.0d0,X2,NBQ,
     &                CMO(LMOQ2),NBQ,
     &                0.0d0,X1,NBP)
c  (pT,Us) -> (AT,Us)
          CALL DGEMM_('T','N',
     &                NOCQ,NOP,NBP,
     &                1.0d0,X1,NBP,
     &                CMO(LMOP),NBP,
     &                0.0d0,X2,NOCQ)
c  Store buffer
        IF(IS.GT.LS) THEN
         IS=1
cvv         DO I=1,NOTU
cvv          CALL dDAFILE(LUHLF2,1,PQRU(1+LAS*(I-1)),LAS,IAD2)
cvv         Enddo
        CALL dDAFILE(LUHLF2,1,PQRU,LAS*NOTU,IAD2)
        ENDIF
c  Sort
         NAT=0
         DO NA=1,NOP
          DO NT=1,NOCQ
           ITU=NOCR*(NT-1)+NU-1
           IF(ISQ.LT.ISR) ITU=NOCQ*(NU-1)+NT-1
           NAT=NAT+1
           PQRU(LAS*ITU+NOP*(IS-1)+NA)=X2(NAT)
          Enddo
         Enddo
c End of loop over u,s pair
        Enddo
       Enddo
c Store last buffer
       IF(LS.LT.NBS) THEN
cvv        DO I=1,NOTU
cvv         CALL dDAFILE(LUHLF2,1,PQRU(1+LAS*(I-1)),LAS,IAD2)
cvv        Enddo
       CALL dDAFILE(LUHLF2,1,PQRU,LAS*NOTU,IAD2)
       ENDIF
c
c  Trasform last index
c
       If(ISQ.ge.ISR)then
c  Store(type 1)
        ISPQRS=((ISQ**2-ISQ)/2+ISR-1)*NSYMP+(ISP**2-ISP)/2+ISS
        IAD2M(2,ISPQRS)=IAD13
        NTMAX=NOCQ
        NUMAX=NOCR
       Else
c  Store(type 2)
        ISPQRS=((ISR**2-ISR)/2+ISQ-1)*NSYMP+(ISP**2-ISP)/2+ISS
        IAD2M(3,ISPQRS)=IAD13
        NTMAX=NOCR
        NUMAX=NOCQ
       Endif
c Loop over t,u pair, always ISQ.ne.ISR
       IST=1-NBS*NOP
       KKTU=0
       Do NT=1,NTMAX
        Do NU=1,NUMAX
         IST=IST+NBS*NOP
         KKTU=KKTU+1
         IF(LS.LT.NBS)THEN
          Call RBuf_tra2(LUHLF2,PQRU,NBS*NOP,LAS,NOTU,KKTU,IST,IAD2S)
         ENDIF
c  (AT,Us) -> (AT,UB)
         CALL DGEMM_('T','T',
     &               NOS,NOP,NBS,
     &               1.0d0,CMO(LMOS2),NBS,
     &               PQRU(IST),NOP,
     &               0.0d0,X2,NOS)
C
C       WRITE THESE BLOCK OF INTEGRALS ON LUINTM
C
         CALL GADSum(X2,NOP*NOS)
         Call dDAFILE(LUINTM,1,X2,NOP*NOS,IAD13)
        Enddo
       Enddo
c End of loop over t,u pair
      Endif
c-----------------------------------------------------------------------
c Case 7 (TA,UB) and 8 (UB,TA)
c  Calculated if ISP.ne.ISQ.and.ISR.ne.ISS
c   Case 7, if ISQ.ge.ISS, always type 1
c   Case 8, if ISQ.lt.ISS.and.ISP.ne.ISR, always type 2
c-----------------------------------------------------------------------
      NOTU=NOCP*NOCR
      If(ISS.gt.ISQ.and.ISP.eq.ISR)goto 200
      If(ISP.ne.ISQ.and.ISR.ne.ISS.and.icxc7.ne.0)then
       LAS=(LRUPQ+LTUPQ)/NOTU
       LS=LAS/NOQ
       IF(LS.GT.NBS) LS=NBS
       LAS=NOQ*LS
       IAD2S=0
       CALL dDAFILE(LUHLF2,0,PQRU,LAS,IAD2S)
       IAD2=0
       IRU=0
c Loop over u,s pair
       IS=0
       Do NS=1,NBS
        IS=IS+1
        Do NU=1,NOCR
         IRU=NBS*(NU-1)+NS
         IPQST=1+NBPQ*(IRU-1)
         IF(IPQMX1.LT.NBPQ) THEN
          Call RBuf_tra2(LUHLF1,PQUS,NBPQ,IPQMX1,NOUS,IRU,IPQST,IAD1S)
         ENDIF
c Always ISP.gt.ISQ
c Square unnecessary
         If(ISP.eq.ISR)then
c (pq,Us) -> (Tq,Us)
          CALL DGEMM_('N','N',
     &                NBQ,NOCP-NU+1,NBP,
     &                1.0d0,PQUS(IPQST),NBQ,
     &                CMO(LMOP2+NBP*(NU-1)),NBP,
     &                0.0d0,X1,NBQ)
c (Tq,Us) -> (TA,Us)
          CALL DGEMM_('T','N',
     &                NOCP-NU+1,NOQ,NBQ,
     &                1.0d0,X1,NBQ,
     &                CMO(LMOQ),NBQ,
     &                0.0d0,X2,NOCP-NU+1)
         Else
c (pq,Us) -> (Tq,Us)
          CALL DGEMM_('N','N',
     &                NBQ,NOCP,NBP,
     &                1.0d0,PQUS(IPQST),NBQ,
     &                CMO(LMOP2),NBP,
     &                0.0d0,X1,NBQ)
c (Tq,Us) -> (TA,Us)
          CALL DGEMM_('T','N',
     &                NOCP,NOQ,NBQ,
     &                1.0d0,X1,NBQ,
     &                CMO(LMOQ),NBQ,
     &                0.0d0,X2,NOCP)
         Endif
c Store buffer
         IF(IS.GT.LS) THEN
          IS=1
cvv          DO I=1,NOTU
cvv           CALL dDAFILE(LUHLF2,1,PQRU(1+LAS*(I-1)),LAS,IAD2)
cvv          ENDDO
         CALL dDAFILE(LUHLF2,1,PQRU,LAS*NOTU,IAD2)
         ENDIF
c Sorting
* Note: LAS is supposed to be small enough that (NOCP*NOCR)*LAS is
* at most = (LRUPQ+LTUPQ). NU can be as large as NOCR, so ITU
* can become NOCR*NOCP-1.
* Thus (LAS*ITU+NOQ*(IS-1)+NA can become as large as:
* LAS*(NOCP*NOCR-1)+NOQ*(NBS-1)+NOQ=LAS*(NOCP*NOCR-1)+NOQ*NBS
* which may become nearly as large as (LRUPQ+LTUPQ)+NOQ*NBS.
* But when called, only the size LRUPQ has been reserved for
* use (tractl:LW6=LW5+LRUPQ) by the array PQRU!
* This may be deliberate, if it is intended that PQRU is
* overlaying i.e. extended above the LW6 address which is
* then assumed not to be used any longer....
         NAT=0
         DO NA=1,NOQ
          NTM=1
          IF(ISP.EQ.ISR) NTM=NU
          DO NT=NTM,NOCP
           ITU=NOCR*(NT-1)+NU-1
           If(ISP.eq.ISR)ITU=(NT*NT-NT)/2+NU-1
           NAT=NAT+1
        itst=LAS*ITU+NOQ*(IS-1)+NA
           PQRU(LAS*ITU+NOQ*(IS-1)+NA)=X2(NAT)
          Enddo
         Enddo
c End of Loop over u,s pair
        Enddo
       Enddo
c Store the last buffer
       IF(LS.LT.NBS) THEN
cvv        DO I=1,NOTU
cvv         CALL dDAFILE(LUHLF2,1,PQRU(1+LAS*(I-1)),LAS,IAD2)
cvv        Enddo
       CALL dDAFILE(LUHLF2,1,PQRU,LAS*NOTU,IAD2)
       ENDIF
       If(ISQ.ge.ISS) then
c   Store(Only type1)
        ISPQRS=((ISP**2-ISP)/2+ISR-1)*NSYMP+(ISQ**2-ISQ)/2+ISS
        IAD2M(2,ISPQRS)=IAD13
       Elseif(ISP.ne.ISR.and.ISQ.lt.ISS) then
c   Store(Only type2)
        ISPQRS=((ISP**2-ISP)/2+ISR-1)*NSYMP+(ISS**2-ISS)/2+ISQ
        IAD2M(3,ISPQRS)=IAD13
       Endif
       IST=1-NOQ*NBS
       KKTU=0
c Loop over t,u pair, If(ISP.eq.ISR)then loop should be triangle
       Do NT=1,NOCP
        Num=NOCR
        If(ISP.eq.ISR)Num=NT
        Do NU=1,Num
c  (TA,Us) -> (TA,UB)
         IST=IST+NOQ*NBS
         KKTU=KKTU+1
         IF(LS.LT.NBS)THEN
          Call RBuf_tra2(LUHLF2,PQRU,NBS*NOQ,LAS,NOTU,KKTU,IST,IAD2S)
         ENDIF
         If(ISQ.ge.ISS)then
          CALL DGEMM_('T','T',
     &                NOS,NOQ,NBS,
     &                1.0d0,CMO(LMOS),NBS,
     &                PQRU(IST),NOQ,
     &                0.0d0,X2,NOS)
         Else if(ISP.ne.ISR.and.ISS.gt.ISQ) then
          CALL DGEMM_('N','N',
     &                NOQ,NOS,NBS,
     &                1.0d0,PQRU(IST),NOQ,
     &                CMO(LMOS),NBS,
     &                0.0d0,X2,NOQ)
         Endif
C
C       WRITE THESE BLOCK OF INTEGRALS ON LUINTM
C
         Call GADSum(X2,NOQ*NOS)
         CALL dDAFILE(LUINTM,1,X2,NOQ*NOS,IAD13)
        Enddo
       Enddo
c End of Loop over t,u pair
      Endif
  200 Continue

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!               2002, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine WfCtl_Hess(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,iRHSDisp,iRHSCIDISP,converged)
!***********************************************************************
!                                                                      *
!     called from: MCLR                                                *
!                                                                      *
!----------------------------------------------------------------------*
!     Parallelization of perturbations, RL 2002.                       *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: Mul
use ipPage, only: ipclose, ipget, ipin, ipin1, ipnout, ipout, opout, W
use Para_Info, only: myRank, nProcs
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use Spool, only: LuWr
use MCLR_Data, only: CMO, FIMO, Int2, ipCI, ipDia, lDisp, LuTemp, n1Dens, n2Dens, nConf1, nDens, nDensC, XISPSM
use MCLR_procedures, only: CISigma
use input_mclr, only: Eps, ERASSCF, Fail, iBreak, iMethod, kPrint, lSave, nAsh, nCSF, nDisp, nIter, nRs2, nSym, nTPert, PotNuc, &
                      PT2, rIn_Ene, State_Sym, TimeDep
use dmrginfo, only: DoDMRG, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use MCLR_Data, only: nCMO
#endif

implicit none
integer(kind=iwp), intent(out) :: iKapDisp(nDisp), isigDisp(nDisp), iCIDisp(nDisp), iCIsigDisp(nDisp), iRHSDisp(nDisp), &
                                  iRHSCIDisp(nDisp)
logical(kind=iwp), intent(out) :: converged(8)
integer(kind=iwp) :: iD, iDis, iDisp, iLen, ipCID, ipCIT, ipPre2, ipS1, ipS2, ipST, iRank, istatus, iSym, iSym_Old, Iter, jDisp, &
                     jSpin, kkkSym, kkSym, Left, lLine, lPaper, LuWR_Save, nConf3, nPre2, pstate_sym
real(kind=wp) :: Clock(4), D_0, Delta, Delta0, DeltaC, DeltaK, EC, R1, R2, rAlpha, rAlphaC, rAlphaK, rBeta, rCHC, rdum(1), ReCo, &
                 Res, res_tmp, rEsci, rEsk, rGrad, Tim2, Tim3, Tim4
logical(kind=iwp) :: CI, cnvrgd, lPrint, Orb, Response
character(len=132) :: Line
character(len=72) :: SLine
character(len=8) :: Fmt2
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
integer(kind=iwp) :: iglfail
real(kind=wp) :: dfail
#endif
integer(kind=iwp), allocatable :: iPre(:), List(:,:)
real(kind=wp), allocatable :: Dens(:), dKappa(:), Kappa(:), Pens(:), rmoaa(:), Sc1(:), Sc2(:), Sc3(:), Sc4(:), Sigma(:), Temp1(:), &
                              Temp2(:), Temp3(:), Temp4(:)
integer(kind=iwp), parameter :: iTimeCC = 1, iTimeKK = 2, iTimeKC = 3, iTimeCK = 4
integer(kind=iwp), external :: IsFreeUnit, niPre, nPre
real(kind=wp), external :: DDot_
logical(kind=iwp), external :: Rsv_Tsk

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
SLine = 'Solving CP(CAS)HF equations'
call StatusLine('MCLR: ',SLine)

!----------------------------------------------------------------------*
!     Initialize blank and header lines                                *
!----------------------------------------------------------------------*
TIM2 = Zero
TIM3 = Zero
TIM4 = Zero

CLOCK(:) = Zero
lPaper = 132
lLine = 120
left = (lPaper-lLine)/2
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
!----------------------------------------------------------------------*

iDis = 0

fail = .false.
Converged(:) = .true.
lprint = .false.
!if (lSAVE) call DANAME(50,'RESIDUALS')
if (lSAVE) then
  write(LuWr,*) 'WfCtl: SAVE option not implemented'
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Start loop over the symmetry of the perturbations

if (btest(kprint,1)) lprint = .true.
#ifdef _DEBUGPRINT_
lprint = .true.
#endif
kksym = 1
kkksym = nsym
if (PT2) kkkSym = 1

! Set up parallelization over the loop over perturbations

call mma_allocate(List,2,nDisp,Label='List')
iDisp = 0
do iSym=kksym,kkksym
  List(1,iDisp+1:iDisp+lDisp(iSym)) = iSym
  List(2,iDisp+1:iDisp+lDisp(iSym)) = [(jDisp,jDisp=1,lDisp(iSym))]
  iDisp = iDisp+lDisp(iSym)
end do

! Change output unit

LuWr_save = LuWr
if (MyRank /= 0) then
  LuWr = 55
  LuWr = isFreeUnit(LuWr)
  call molcas_open(luwr,'Temp_OutPut')
end if

call Init_Tsk(id,nDisp)
#ifdef _MOLCAS_MPP_
! iglfail is global "array", a flag used to communicate to all processes
! if any of them failed, the communication need not be synchronous,
if (Is_Real_Par()) then
  if (.not. GA_Create(MT_DBL,1,1,'GlFail',0,0,iglfail)) call SysAbendMsg('wfctl_hess','failed to create global failed flag',' ')

  call GA_Zero(iglfail)
  dfail = Zero
end if
#endif

ipdia = 0
ipPre2 = 0
iSym_Old = 0
cnvrgd = .true.
do
  if (.not. Rsv_Tsk(id,iDisp)) exit
# ifdef _MOLCAS_MPP_
  ! Check if some other process failed
  if (Is_Real_Par()) then
    call GA_Get(iglfail,1,1,1,1,dfail,1)
    if (dfail > Zero) then
      fail = .true.
      exit
    end if
  end if
# endif
  iSym = List(1,iDisp)
  jDisp = List(2,iDisp)

  write(SLine,'(A,I3,A)') 'Solving CP(CAS)HF equations for perturbation ',iDisp,'.'
  call StatusLine('MCLR: ',SLine)

  !do iSym=kksym,kkksym

  ! Execute setup for symmetry block if a new one!

  if (iSym /= iSym_Old) then

    if (iSym_Old /= 0) then

      ! If a previous symmetry block was processed
      ! free all memory and remove from disk all data
      ! related to this symmetry

      call mma_deallocate(iPre)
      if (CI) then
        call ipclose(ipdia)
      else
        call ipclose(ipPre2)
      end if

      call Exp_Close()

    end if
    iSym_Old = iSym

    PState_SYM = Mul(State_Sym,iSym)
    nconf1 = ncsf(PState_Sym)
    CI = .false.
    if ((iMethod == 2) .and. (nconf1 > 0)) CI = .true.

    if (CI .and. (nconf1 == 1) .and. (isym == 1)) CI = .false.
    ! Initiate CSF <-> SD
    if (CI) call InCSFSD(Mul(iSym,State_Sym),State_sym)

    ! Calculate length of the density, Fock and Kappa matrix etc
    ! notice that this matrixes not necessary are symmetric.
    ! Store pointers.
    !
    ! Input:
    !        iSym : Symmetry of perturbation
    !
    ! Output: Commonblocks (Pointers.fh)

    PState_SYM = Mul(State_Sym,iSym)
    !nConf2 = nint(xispsm(PState_SYM,1))
    !nConf2 = ndtasm(PState_SYM)
    nconf3 = nint(max(xispsm(PState_SYM,1),xispsm(State_SYM,1)))
    !nconf3 = max(ndtasm(PState_SYM),ndtasm(State_SYM))

    if (doDMRG) then  ! yma
      nash(:) = RGras2(:)
      nrs2(:) = RGras2(:)
    end if

    call Setup_MCLR(iSym)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    !     Determine if we should page CI vectors

    !                                  [2]
    !       Calculate the diagonal of E    and store in core/disc

    if (CI) then
      call CIDia_MCLR(PState_Sym,rCHC)
      call ipout(ipdia)

      ! Allocate disk/memory space
      !
      ! This areas should be addressed through ipin
      ! ipout will page them out to disk and free the memory area
      ! if page mode is used
      !
      ! opout will release the memory area without update the disk

      ips1 = ipget(nconf3)
      ips2 = ipget(nconf3)
      ipst = ipget(nconf3)
      ipcit = ipget(nconf1)
      ipcid = ipget(nconf1)

    else
      ips1 = 0
      ips2 = 0
      ipst = 0
      ipcit = 0
      ipcid = 0
    end if

    call mma_allocate(iPre,nipre(isym),Label='iPre')
    npre2 = max(npre(isym),1)
    ! "max" just there to make sure that
    ! W(ipPre2) is allocated even if
    ! npre2(isym) is zero.
    ipPre2 = ipget(npre2)
    call ipin(ipPre2)
    call Prec(W(ipPre2)%A,iPre,isym)
    call ipout(ippre2)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! OK START WORKING, looping over the perturbations of the
    ! current symmetry

    !iDEND = lDisp(iSym)
    !if ((SewLab == 'NONE') .and. (.not. mckinley)) iDEND = 1

  end if

  !do jDisp=1,iDEnd
  !  iDisp = iDisp+1
  jspin = 0
  if (btest(nTPert(idisp),0)) jSpin = 1
  if (jspin == 0) then
    nconf1 = ncsf(PState_Sym)
  else
    nConf1 = nint(xispsm(Pstate_Sym,1))
  end if

  ! Allocate areas for scratch and state variables

  call mma_allocate(Kappa,nDensC,Label='Kappa')
  call mma_allocate(dKappa,nDens,Label='dKappa')
  call mma_allocate(Sigma,nDensC,Label='Sigma')
  call mma_allocate(Temp1,nDens,Label='Temp1')
  call mma_allocate(Temp2,nDensC,Label='Temp2')
  call mma_allocate(Temp3,nDens,Label='Temp3')
  call mma_allocate(Temp4,nDens,Label='Temp4')
  call mma_allocate(Sc1,nDens,Label='Sc1')
  call mma_allocate(Sc2,nDens,Label='Sc2')
  call mma_allocate(Sc3,nDens,Label='Sc3')
  call mma_allocate(Sc4,nDensC,Label='Sc4')
  Temp1(:) = Zero
  Kappa(:) = Zero
  dKappa(:) = Zero
  Sc1(:) = Zero
  if (CI) then
    call mma_allocate(Dens,n1Dens,Label='Dens')
    call mma_allocate(Pens,n2Dens,Label='Pens')

    Dens(:) = Zero
    Pens(:) = Zero
  end if
  if (iMethod == 2) then
    call mma_allocate(rmoaa,n2Dens,Label='rmoaa')
  else
    call mma_allocate(rmoaa,1,Label='rmoaa')
  end if
  rmoaa(:) = Zero
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Calculate RHS for the perturbation
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! (T1,T2,T3,T4,T5,T6,T7,Kappa1,CI1)

  !if (PT2) then
  !  call RHS_PT2(Temp4,Temp4,Temp4)
  !else
  call RHS(Sc1,Temp1,Temp3,Sc2,dKappa,Sc3,Temp4,ipST,iDisp,iSym-1,CMO,jdisp,CI)
# ifdef _DEBUGPRINT_
  write(LuWr,*) 'After RHS'
  write(LuWr,*) 'Sc1=',DDot_(nDens,Sc1,1,Sc1,1)
  write(LuWr,*) 'Kappa=',DDot_(nDensC,Kappa,1,Kappa,1)
  write(LuWr,*) 'Sc2=',DDot_(nDens,Sc2,1,Sc2,1)
  write(LuWr,*) 'dKap=',DDot_(nDens,dKappa,1,dKappa,1)
  write(LuWr,*) 'CMO=',DDot_(nCMO,CMO,1,CMO,1)
# endif
  !end if
  call opout(ipci)
  call mma_deallocate(Temp1)
  call mma_allocate(Temp1,nDensC,Label='Temp1')

  write(LuWr,*) 'Process perturbation number ',iDisp
  if (lprint) write(LuWr,*) '       Iteration         Delta     Res(kappa) Res(CI)'
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Write RHS to disk
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  iLen = nDensC
  iRHSDisp(iDisp) = iDis
  call Compress(Temp4,Sigma,iSym)
  r1 = ddot_(nDensC,Sigma,1,Sigma,1)
  call UnCompress(Sigma,Temp4,iSym)
  call dDaFile(LuTemp,1,Sigma,iLen,iDis)
  if (CI) then
    call ipin(ipCIT)
    W(ipCIT)%A(1:nConf1) = Zero
  end if
  call ipout(ipCIT)
  if (CI) then
    ilen = nconf1
    iRHSCIDisp(iDisp) = iDis
    call ipin(ipST)
    call dDaFile(LuTemp,1,W(ipST)%A,iLen,iDis)
    W(ipST)%A(1:nConf1) = -W(ipST)%A(1:nConf1)
  end if

  Sigma(:) = -Sigma(:)

# ifdef _DEBUGPRINT_
  call ipin(ipST)
  write(LuWr,*) 'ST=',DDot_(nConf1,W(ipST)%A,1,W(ipST)%A,1)
  write(LuWr,*) 'Sigma=',DDot_(nDensC,Sigma,1,Sigma,1)
  write(LuWr,*) 'Kappa=',DDot_(nDensC,Kappa,1,Kappa,1)
  write(LuWr,*) 'End RHS!'
# endif

  iter = 1
  call ipin(ipPre2)
  call DMInvKap(W(ipPre2)%A,iPre,Sigma,Kappa,Temp3,isym,iter)
  call opout(ippre2)
  r2 = ddot_(nDensC,Kappa,1,Kappa,1)
# ifdef _DEBUGPRINT_
  write(LuWr,*) 'DMinvKap'
  write(LuWr,*) 'Kap=',DDot_(nDensC,Kappa,1,Kappa,1)
  write(LuWr,*) 'End DMinvKap'
# endif
  if (r2 > r1) write(LuWr,Fmt2//'A,I3,A)') 'Warning  perturbation number ',idisp,' might diverge!'
  call UnCompress(Kappa,dKappa,iSym)

  if (CI) then
    call ipin(ipCId)
    call DMinvCI(ipST,W(ipCId)%A,rCHC,isym)
    call ipin(ipST)
    deltaC = ddot_(nConf1,W(ipST)%A,1,W(ipCId)%A,1)
    call ipout(ipcid)
  else
    deltaC = Zero
  end if
  deltaK = ddot_(nDensC,Kappa,1,Sigma,1)
  Kappa(:) = Zero
  delta = deltac+deltaK
# ifdef _DEBUGPRINT_
  if (abs(DeltaC) < 1.0e-12_wp) DeltaC = Zero
  write(LuWr,*) 'DeltaK, DeltaC, Delta=',DeltaK,DeltaC,Delta
# endif

  if (delta /= Zero) then
    delta0 = delta
#   ifdef _DEBUGPRINT_
    write(LuWr,*) 'Delta0=',Delta0
    write(LuWr,*) 'Start ITERATIONS'
    write(LuWr,*) 'Orb,CI=',ORB,CI
#   endif
    Orb = .true.
    TimeDep = .false.
    ReCo = -One
  end if
  !                                                                    *
  !*********************************************************************
  !          I   T   E   R   A   T   I   O   N   S                     *
  !*********************************************************************
  !                                                                    *
  do
    if (delta == Zero) exit

    if (doDMRG) then  ! It can be deleted
      nash(:) = RGras2(:)
      nrs2(:) = RGras2(:)
    end if

    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    !       O R B I T A L    P A R T
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    if (orb) then
      !                                                                *
      !*****************************************************************
      !                                                                *
      !           ~    ~
      ! Construct F,(ij|kl)
      !                                                                *
      !*****************************************************************
      !                                                                *

      call ipnout(-1)
      call RInt_generic(dKappa,rmoaa,rdum,Sc2,Temp3,Temp4,Sc3,isym,reco,jspin)
      Clock(iTimeKK) = Clock(iTimeKK)+Tim2

      !                                                                *
      !*****************************************************************
      !                                                                *
      ! kappa->CI
      !
      ! H(kappa)|0>
      !
      !     [2]
      ! S1=E   k (kappa TO CI)
      !                                                                *
      !*****************************************************************
      !                                                                *
      if (CI) then
        call CISigma(jspin,State_Sym,pstate_sym,Temp4,nDens,rmoaa,size(rmoaa),rdum,1,ipCI,ipS1,.true.)
        Clock(iTimeKC) = Clock(iTimeKC)+Tim3
#       ifdef _DEBUGPRINT_
        call ipin(ipCI)
        call ipin(ipS1)
        write(LuWr,*) 'CISigma'
        call RecPrt('CI','(3F10.4)',W(ipCI)%A,1,nConf1)
        call RecPrt('S1','(3F10.4)',W(ipS1)%A,1,nConf1)
        write(LuWr,*) 'CI=',DDot_(nConf1,W(ipCI)%A,1,W(ipCI)%A,1)
        write(LuWr,*) 'S1=',DDot_(nConf1,W(ipS1)%A,1,W(ipS1)%A,1)
        write(LuWr,*) 'End CISigma'
#       endif

        ! This will give us a better
        ! convergence in the PCG. Notice that
        !
        ! ~Inactive     ~
        ! E        + <0|H|0> = 0
        !
        ! when the wavefunction is converged.

        call ipin(ipS1)
        if (isym == 1) then
          call ipin(ipCI)
          rGrad = DDot_(nconf1,W(ipCI)%A,1,W(ipS1)%A,1)
          W(ipS1)%A(1:nConf1) = W(ipS1)%A(1:nConf1)-rgrad*W(ipCI)%A(1:nConf1)
        end if
        W(ipS1)%A(1:nConf1) = Two*W(ipS1)%A(1:nConf1)

        call opout(ipCI)
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
    end if
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    !       C I    P A R T
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    if (CI) then
      !                                                                *
      !*****************************************************************
      !                                                                *
      !       [2]
      ! S2 = E   CID  (CI TO CI) = <i|H|d> -E<i|d>
      !                                                                *
      !*****************************************************************
      !                                                                *
      call ipnout(-1)
      call CISigma(0,PState_Sym,Pstate_sym,FIMO,size(FIMO),Int2,size(Int2),rdum,1,ipCId,ipS2,.true.)
      EC = rin_ene+potnuc-ERASSCF(1)

      call ipin(ipCId)
      call ipin(ipS2)
      W(ipS2)%A(1:nConf1) = Two*(W(ipS2)%A(1:nConf1)+EC*W(ipCId)%A(1:nConf1))
      Clock(iTimeCC) = Clock(iTimeCC)+Tim4
      call ipout(ipS2)
      call opout(ipCId)
      call opout(ipCI)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! CI -> Kappa
      !
      !      [2]
      ! SC3=E   CID   (SC3=F(<d|E|0>+<0|E|d>)
      !                                                                *
      !*****************************************************************
      !                                                                *
      Response = .true.
      call ipnout(-1)
#     ifdef _DEBUGPRINT_
      call ipin(ipCI)
      call ipin(ipCId)
      call RecPrt('CI','(3F10.4)',W(ipCI)%A,1,nConf1)
      call RecPrt('CId','(3F10.4)',W(ipCId)%A,1,nConf1)
#     endif
      call CIDens(Response,ipCI,ipCId,State_sym,PState_Sym,Pens,Dens)     ! Jeppe's

#     ifdef _DEBUGPRINT_
      write(LuWr,*) 'After CIDens'
      write(LuWr,*) 'P=',DDot_(n2Dens,Pens,1,Pens,1)
      write(LuWr,*) 'De=',DDot_(n1Dens,Dens,1,Dens,1)
#     endif

      ! density for inactive= 2(<d|0>+<0|d>)

      d_0 = Zero

      ! This is just for debugging purpose.
      ! When we use it for actual calculations d_0 == 0

      if (isym == 1) then
        call ipin(ipCI)
        call ipin(ipCid)
        d_0 = ddot_(nconf1,W(ipCid)%A,1,W(ipCI)%A,1)
      end if
      if (Response) d_0 = d_0*Two

      call FockGen(d_0,Dens,Pens,Sc1,Sc3,isym)    ! Made
      !                                                                *
      !*****************************************************************
      !                                                                *
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Sc1  kappa-> kappa
    ! Sc3  CI -> kappa
    ! S1   kappa -> CI
    ! S2   CI -> CI
    ! dKap present step
    ! Kap  kappaX
    ! CIT  CIX
    ! CId  present step
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Add together
    !                                                                  *
    !*******************************************************************
    !                                                                  *
#   ifdef _DEBUGPRINT_
    write(LuWr,*) 'Add together!'
    write(LuWr,*) 'dKap=',DDot_(nDens,dKappa,1,dKappa,1)
    write(LuWr,*) 'Sc2=',DDot_(nDens,Sc2,1,Sc2,1)
    if (CI) then
      write(LuWr,*) 'Sc3=',DDot_(nDens,Sc3,1,Sc3,1)
      call ipin1(ipS2,nconf1)
      write(LuWr,*) 'S2=',DDot_(nConf1,W(ipS2)%A,1,W(ipS2)%A,1)
      call ipin1(ipS1,nconf1)
      write(LuWr,*) 'S1=',DDot_(nConf1,W(ipS1)%A,1,W(ipS1)%A,1)
    end if
    write(LuWr,*)
#   endif
    call ipnout(-1)
    if (CI) then
      Sc1(:) = Sc2(:)+Sc3(:)
    else
      Sc1(:) = Sc2(:)
    end if
    call Compress(Sc1,Temp1,isym)    ! ds
    call Compress(dKappa,Temp2,isym) ! DX
    if (CI) then
      call ipin1(ipS1,nconf1)
      call ipin1(ipS2,nconf1)
      W(ipS1)%A(1:nConf1) = W(ipS1)%A(1:nConf1)+W(ipS2)%A(1:nConf1)
      call opout(ipS2)
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    !                ######   #####   #####
    !                #     # #     # #     #
    !                #     # #       #
    !                ######  #       #  ####
    !                #       #       #     #
    !                #       #     # #     #
    !                #        #####   #####
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    !            delta
    ! rAlpha=------------
    !        dKappa:dSigma

    rAlphaC = Zero
    rAlphaK = Zero
    call ipin(ipS1)
    call ipin(ipCId)
    if (orb) rAlphaK = DDot_(nDensC,Temp1,1,Temp2,1)
    if (CI) rAlphaC = DDot_(nConf1,W(ipS1)%A,1,W(ipCId)%A,1)
    rAlpha = delta/(rAlphaK+rAlphaC)
#   ifdef _DEBUGPRINT_
    write(LuWr,*) 'At PCG'
    write(LuWr,*) 'S1=',DDot_(nConf1,W(ipS1)%A,1,W(ipS1)%A,1)
    write(LuWr,*) 'CId=',DDot_(nConf1,W(ipCId)%A,1,W(ipCId)%A,1)
    write(LuWr,*) 'rAlphaK, rAlphaC, rAlpha=',rAlphaK,rAlphaC,rAlpha
#   endif
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Kappa=Kappa+rAlpha*dKappa
    ! Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa

    if (orb) then
      Kappa(:) = Kappa(:)+ralpha*Temp2(:)
      Sigma(:) = Sigma(:)-ralpha*Temp1(:)
      resk = sqrt(ddot_(nDensC,Sigma,1,Sigma,1))
    end if
    resci = Zero
    if (CI) then
      call ipin(ipCIT)
      W(ipCIT)%A(1:nConf1) = W(ipCIT)%A(1:nConf1)+ralpha*W(ipCId)%A(1:nConf1)
      call ipout(ipCIT)
      call ipin1(ipST,nconf1)
      call ipin(ipS1)
      W(ipST)%A(1:nConf1) = W(ipST)%A(1:nConf1)-ralpha*W(ipS1)%A(1:nConf1)
      call opout(ipS1)
      call ipin(ipST)
      resci = sqrt(ddot_(nconf1,W(ipST)%A,1,W(ipST)%A,1))
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Precondition......
    !    -1
    ! S=M  Sigma

    call opout(ipCID)
    call ipin(ipS2)
    if (CI) call DMinvCI(ipST,W(ipS2)%A,rCHC,isym)
    call opout(ipCI)
    call opout(ipdia)

    call ipin(ipPre2)
    call DMInvKap(W(ipPre2)%A,iPre,Sigma,Sc4,Sc1,iSym,iter)
    call opout(ippre2)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    !      s:Sigma
    ! Beta=-------
    !       delta
    !
    ! delta=s:sigma
    !
    ! dKappa=s+Beta*dKappa

    if (CI) then
      call ipin(ipS2)
      call ipin(ipST)
      deltaC = ddot_(nConf1,W(ipST)%A,1,W(ipS2)%A,1)
      call ipout(ipST)
    else
      deltaC = Zero
    end if

    deltaK = ddot_(nDensC,Sigma,1,Sc4,1)
    if (.not. CI) then
      rBeta = deltaK/delta
      delta = deltaK
      Temp2(:) = rBeta*Temp2(:)+Sc4(:)
    else
      rbeta = (deltac+deltaK)/delta
      delta = deltac+deltaK
      call ipin(ipCID)
      W(ipCID)%A(1:nConf1) = rBeta*W(ipCID)%A(1:nConf1)
      Temp2(:) = rBeta*Temp2(:)
      call ipin(ipS2)
      W(ipCID)%A(1:nConf1) = W(ipCID)%A(1:nConf1)+W(ipS2)%A(1:nConf1)
      Temp2(:) = Temp2(:)+Sc4(:)
      call opout(ipS2)
      call ipout(ipCID)
    end if
#   ifdef _DEBUGPRINT_
    write(LuWr,*) 'rBeta, DeltaK, DeltaC=',rBeta,DeltaK,DeltaC
#   endif
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    !    ######  #    #  #####        #####    ####    ####
    !    #       ##   #  #    #       #    #  #    #  #    #
    !    #####   # #  #  #    #       #    #  #       #
    !    #       #  # #  #    #       #####   #       #  ###
    !    #       #   ##  #    #       #       #    #  #    #
    !    ######  #    #  #####        #        ####    ####
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    call UnCompress(Temp2,dKappa,isym)

    res = Zero ! dummy initialize
    res_tmp = -One
    if (iBreak == 1) then
      if (abs(delta) < abs(Eps**2*delta0)) exit
    else if (ibreak == 2) then
      res = sqrt(resk**2+resci**2)
      if (doDMRG) then ! yma
        !write(u6,*) 'resk**2, resci**2 ',resk**2,resci**2
        res = sqrt(resk**2+resci**2)
        ! And a bit loose in DMRG case
        if (res < abs(Eps)) exit
        if (sqrt(resk**2) < abs(Eps)) then
          if (abs(res_tmp-sqrt(resci**2)) < 1.0e-6_wp) exit
        end if
        res_tmp = sqrt(resci**2)
      else
        if (res < abs(Eps)) exit
      end if
    else
      if ((abs(delta) < abs(Eps**2*delta0)) .and. (res < abs(Eps))) exit
    end if
    if (iter >= niter) then
      cnvrgd = .false.
      exit
    end if
    if (lprint) &
      write(LuWr,Fmt2//'A,i2,A,F12.7,F12.7,F12.7,F12.7,F12.7)') '     ',iter,'       ',delta/delta0,resk,resci,deltac,deltak

    iter = iter+1

  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (.not. cnvrgd) then
    write(LuWr,Fmt2//'A,I4,A)') 'No convergence for perturbation no: ',idisp,'. Increase Iter.'
    converged(isym) = .false.
    fail = .true.
#   ifdef _MOLCAS_MPP_
    ! Set the global flag to signal a process failed
    if (Is_Real_Par()) then
      dfail = One
      call GA_Acc(iglfail,1,1,1,1,dfail,1,One)
    end if
#   endif

    exit
  else
    write(LuWr,Fmt2//'A,I4,A,I4,A)') 'Perturbation no: ',idisp,' converged in ',iter-1,' steps.'
    call ipnout(-1)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !         Write response to disk                                     *
  !                                                                    *
  !*********************************************************************
  !                                                                    *

  !write(LuWr,Fmt2//'A)') 'Writing response to one-file.'
  write(LuWr,*)
  iLen = nDensC
  iKapDisp(iDisp) = iDis
  call dDaFile(LuTemp,1,Kappa,iLen,iDis)
  iSigDisp(iDisp) = iDis
  call dDaFile(LuTemp,1,Sigma,iLen,iDis)
  if (CI) then
    ilen = nconf1
    iCIDisp(iDisp) = iDis
    call ipin(ipCIT)
    call dDaFile(LuTemp,1,W(ipCIT)%A,iLen,iDis)
    iCISigDisp(iDisp) = iDis
    call ipin(ipST)
    call dDaFile(LuTemp,1,W(ipST)%A,iLen,iDis)
  end if

  call mma_deallocate(Temp4)
  call mma_deallocate(Temp3)
  call mma_deallocate(Temp2)
  call mma_deallocate(Temp1)
  call mma_deallocate(Sigma)
  call mma_deallocate(dKappa)
  call mma_deallocate(Kappa)
  call mma_deallocate(Sc4)
  call mma_deallocate(Sc3)
  call mma_deallocate(Sc2)
  call mma_deallocate(Sc1)
  call mma_deallocate(rmoaa,safe='*')
  if (CI) then
    call mma_deallocate(Pens)
    call mma_deallocate(Dens)
  end if
end do
if (nProcs >= 2) then
  write(LuWr,*)
  write(LuWr,*) ' Perturbations were printed only by master node'
  write(LuWr,*)
end if

call Free_Tsk(id)
call mma_deallocate(List)
!                                                                      *
!***********************************************************************
!                                                                      *
! Free all memory and remove from disk all data
! related to the last symmetry

call mma_deallocate(iPre)
if (CI) then
  call ipclose(ipdia)
else
  call ipclose(ipPre2)
end if

call Exp_Close()
!                                                                      *
!***********************************************************************
!                                                                      *
! Flush the output from the other nodes.

do iRank=1,nProcs-1
  call GASync()
  if (iRank == MyRank) then
    rewind(LuWr)
    do
      read(LuWr,'(A)',iostat=istatus) Line
      if (istatus < 0) exit
      write(LuWr_Save,*) Line
    end do
  end if
  call GASync()
end do
if (MyRank /= 0) then
  close(LuWr)
  LuWr = LuWr_save
end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(LuWr,*) '********************************************************************************'
write(LuWr,*)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Final synchronization of the fail flag
#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  call GAdGOp_Scal(dfail,'max')
  Fail = Fail .or. (dfail > Zero)
end if
#endif
if (Fail) call Quit_OnConvError()
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine WfCtl_Hess

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RFMem(nHer,MemRF,la,lb,lr)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: nHer, MemRF
integer(kind=iwp), intent(in) :: la, lb, lr

nHer = (la+lb+lr+2)/2
MemRF = 3*nHer*(la+1)+3*nHer*(lb+1)+3*nHer*(lr+1)+3*(la+1)*(lb+1)*(lr+1)+2+3*nHer

return

end subroutine RFMem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Rotation(TotalM,TRotA,TRotB,TRotC,
     &                       nsRot,nFAtoms,lSlapaf)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "Molcas.fh"
#include "constants2.fh"
      Real*8 dEV, dVec(3)
#include "WrkSpc.fh"
      Real*8  CM(3)                         ! Center of masses
      Real*8  FCoor(3,mxAtom)               ! Full Coords
      Real*8  CCoor(3,mxAtom)               ! Mass-centered Coords
      Real*8  SOCoor(3,mxAtom)              ! Symmetry-Oriented Coords
      Real*8  Inrt(3,3), RotE(3), Vec(3,3)  ! Inertia components
      Real*8  Mass(mxAtom)                  ! Masses
      Character*(LENIN) FAtLbl(mxAtom)      ! Atomic labes
      Logical lSlapaf

*
* --- Get Atomic Full Labels, Coordinates & Mass - FAtLbl, FCoor, Mass
*
      Call GetFullCoord(FCoor,Mass,FAtLbl,nFAtoms,mxAtm,lSlapaf)
*
* --- Define the Center of Masses - CM()
*
      CM(1)  = 0.0d0
      CM(2)  = 0.0d0
      CM(3)  = 0.0d0
      TotalM = 0.0d0
      Do i=1, nFAtoms
        TotalM = TotalM + Mass(i)
        CM(1)  = CM(1) + Mass(i)*FCoor(1,i)
        CM(2)  = CM(2) + Mass(i)*FCoor(2,i)
        CM(3)  = CM(3) + Mass(i)*FCoor(3,i)
      EndDo
      CM(1)  = CM(1)/TotalM
      CM(2)  = CM(2)/TotalM
      CM(3)  = CM(3)/TotalM
*
* --- Shift coordinates in the center of masses - CCoord()
*
      Do i=1, nFAtoms
        CCoor(1,i) = FCoor(1,i) - CM(1)
        CCoor(2,i) = FCoor(2,i) - CM(2)
        CCoor(3,i) = FCoor(3,i) - CM(3)
      EndDo
*
* --- Compute the Inertia-matrix - Inrt(3,3)
*
      Do i = 1, 3
        Do j = 1, 3
          Inrt(i,j) = 0.0d0
        EndDo
      EndDo
      Do i = 1, nFAtoms
        dX = CCoor(1,i)
        dY = CCoor(2,i)
        dZ = CCoor(3,i)
        Inrt(1,1) = Inrt(1,1) + Mass(i) * (dY*dY+dZ*dZ) ! YY ZZ
        Inrt(2,1) = Inrt(2,1) - Mass(i) * dX * dY       ! XY
        Inrt(2,2) = Inrt(2,2) + Mass(i) * (dX*dX+dZ*dZ) ! XX ZZ
        Inrt(3,1) = Inrt(3,1) - Mass(i) * dX * dZ       ! XZ
        Inrt(3,2) = Inrt(3,2) - Mass(i) * dY * dZ       ! YZ
        Inrt(3,3) = Inrt(3,3) + Mass(i) * (dX*dX+dY*dY) ! XX YY
      EndDo
      Inrt(1,2) = Inrt(2,1)
      Inrt(1,3) = Inrt(3,1)
      Inrt(2,3) = Inrt(3,2)
*
* --- and diagonalize it - Inrt(3,3)
*
      Call GetMem('EVal','Allo','Real',ipEVal,3*(3+1)/2)
      Call GetMem('EVec','Allo','Real',ipEVec,3*3)
      Do i = 1, 3
        Do j = 1, 3
          ij=i*(i-1)/2 + j + ipEval -1
          Work(ij)=Inrt(i,j)
        End Do
      End Do
      call dcopy_(3*3,[Zero],0,Work(ipEVec),1)
      call dcopy_(3,[One],0,Work(ipEVec),3+1)
      Call Jacob (Work(ipEVal),Work(ipEVec),3,3)
      Call Jacord(Work(ipEVal),Work(ipEVec),3,3)
      Do i = 1, 3
        RotE(i)=Work(i*(i+1)/2+ipEVal-1)
        Do j = 1, 3
           Vec(i,j) = Work(ipEVec-1+i+(j-1)*3)
        EndDO
      End Do
*
*     Sort the principal axis such that z' is the one with the lowest
*     eigenvalue.
*
      Do i = 1, 2
        Do j = i+1, 3
          If (RotE(i).LT.RotE(j)) Then
            dEV     = RotE(i)
            dVec(1) = Vec(1,i)
            dVec(2) = Vec(2,i)
            dVec(3) = Vec(3,i)
              RotE(i)  = RotE(j)
              Vec(1,i) = Vec(1,j)
              Vec(2,i) = Vec(2,j)
              Vec(3,i) = Vec(3,j)
            RotE(j)  = dEV
            Vec(1,j) = dVec(1)
            Vec(2,j) = dVec(2)
            Vec(3,j) = dVec(3)
          End If
        EndDo
      EndDo
*
*     Rotate coords to Symmetry-Oriented
*
      Do iAtom=1, nFAtoms
        Do i = 1, 3
          dSum = 0.0d0
          Do j = 1, 3
            dSum = dSum + CCoor(j,iAtom) * Vec(j,i)
          EndDo
          SOCoor(i,iAtom) = dSum
        EndDo
      EndDo
*
* --- Rotational Symmetry factor - nsRot
*
      If (nsRot.EQ.0) nsRot = 1
      If (nFAtoms.EQ.2) then
        If (Mass(1).EQ.Mass(2)) nsRot = 2
      EndIf
*
      TRotA = 8.661377d01/(RotE(3)+1.0d-99)
      TRotB = 8.661377d01/(RotE(2)+1.0d-99)
      TRotC = 8.661377d01/(RotE(1)+1.0d-99)
*
**    Check if linear molecule
*
      nrot=3
      if (TRotA.gt.1.0d99) nrot=nrot-1
      if (TRotB.gt.1.0d99) nrot=nrot-1
      if (TRotC.gt.1.0d99) nrot=nrot-1
*
* --- Print results
*
      Write(6,'(A)') ' Mass-centered Coordinates (Angstrom):'
      Write(6,'(1X,A)')
     &    '********************************************************'
      Write(6,'(1X,A)')
     &    'Label        X           Y           Z          Mass  '
      Write(6,'(1X,A)')
     &    '--------------------------------------------------------'
      Do i=1,nFAtoms
         Write(6,'(1X,A,1X,3F12.6,1x,F12.5)')
     & FAtLbl(i),(Angstrom*SOCoor(j,i),j=1,3),Mass(i)
      EndDo
      Write(6,'(1X,A)')
     &    '--------------------------------------------------------'
      Write(6,'(A,F12.6)') ' Molecular mass:',TotalM
      Write(6,'(A,3F10.4)') ' Rotational Constants (cm-1):',
     &              (auTocm*Half/(uToau*RotE(i)),i=1,nrot)
      Write(6,'(A,3F10.4)') ' Rotational Constants (GHz) :',
     &              (1.0D-9*auToHz*Half/(uToau*RotE(i)),i=1,nrot)
      Write(6,'(A,3F10.4)') ' Rotational temperatures (K):',
     &                          (8.661377d01/RotE(i),i=1,nrot)
      Write(6,'(A,I2)') ' Rotational Symmetry factor: ',nsRot
*
      Call GetMem('EVec','Free','Real',ipEVec,3*3)
      Call GetMem('EVal','Free','Real',ipEVal,3*(3+1)/2)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     ----------------------------------
c
       subroutine exppqij (wrk,wrksize,
     & typv2,typp,typq,typr,typs,directyes,
     &                     inverseyes)
c
c     this routine realize reorganization to
c     #2 <p q i j> with given typv2 and typp-typs  <-  #1 <pp,qq|i,j>
c     #1 is in shape <pp,qq|i,j> for sympp,symqq,symi>=symj with types
c     pp,qq,i,j -5,5,1,1
c     #2 <p q i j> may be antisymetrized or not, two parameters (directyes,
c     inverseyes) can be deduced trom typv2 and typp-s, but for simplicity
c     thes are as input parameters
c     this routine do not allow to use typv2=2
c
c     typv2     - typ of final #2 (I)
c     typp-s    - types of ind. p-s (I)
c     directyes - 1 if direct <pqij> integrals are included (I)
c     inverseyes- 1 if inverse <qpij> integrals are included (I)
c
c     foreingh routines used: grc0
c     ccsort_mv0zero
c
c     it also defines new mapd2,mapi2 corresponding to #2
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       integer typv2,typp,typq,typr,typs,directyes,inverseyes
c
c     help variables
c
       integer symp,symq,symi,symj,possv2,lenght
       integer ii,iiv1d,iiv1i,possv1d,possv1i
       integer posst
c
c*    get mapd mapi of <p,q r,s> into mapd2,mapi2
c
       call ccsort_grc0 (4,typv2,typp,typq,typr,typs,1,
     & poss20,posst,mapd2,mapi2)
c
c*    realize reorganization psb
c
       do 100 ii=1,mapd2(0,5)
c
c*    def parameters of #2
       possv2=mapd2(ii,1)
       lenght=mapd2(ii,2)
       symp=mapd2(ii,3)
       symq=mapd2(ii,4)
       symi=mapd2(ii,5)
       symj=mapd2(ii,6)
c
c*    skip this step if lenght=0
       if (lenght.eq.0) then
       goto 100
       end if
c
c*    vanish #2
       call ccsort_mv0zero (lenght,lenght,wrk(possv2))
c
       if (symi.ge.symj) then
c*    case symi>=symj - integrals in #1 are in that shape
c
       if (directyes.eq.1) then
c**   def possition #1 direct (i.e. #1 <symp,symq| symi,symj>)
c     direct integrals are always used
       iiv1d=mapi1(symp,symq,symi)
       possv1d=mapd1(iiv1d,1)
c
c**   do #2 <p q i j> <- #1 <p,q|i,j> (i.e. direct)
c     N.B. Since #1 is  always >= symj
c     so in this case orede of indices in #1 and #2 is the same
       call  ireorg (wrk,wrksize,
     & symp,symq,symi,symj,typp,typq,typr,typs,
     & 1,2,3,4,5,5,1,1,
     & typv2,possv1d,possv2,1.0d0)
c
       end if
c
       if (inverseyes.eq.1) then
c
c**   def possition #1 inverse (i.e. #1 <symq,symp| symi,symj>)
c     inverse integrals are used only if antysymetry is required
       iiv1i=mapi1(symq,symp,symi)
       possv1i=mapd1(iiv1i,1)
c
c**   do #2 <p q i j> <- - #1 <q,p|i,j> (i.e. inverse)
c     N.B. Since #1 is  always >= symj
c     so in this case orede of indices in #1 and #2 are inversed 1<->2
       call  ireorg (wrk,wrksize,
     & symp,symq,symi,symj,typp,typq,typr,typs,
     & 2,1,3,4,5,5,1,1,
     & typv2,possv1i,possv2,-1.0d0)
c
       end if
c
       else
c*    case symi<symj - integrals in #1 are in inverse (symi>=symj) shape
c
       if (directyes.eq.1) then
c
c**   def possition #1 direct (i.e. #1 <symq,symp| symj,symi>)
c     direct integrals are always used
       iiv1d=mapi1(symq,symp,symj)
       possv1d=mapd1(iiv1d,1)
c
c**   do #2 <p q i j> <- #1 <q,p|j,i> (i.e. direct)
c     N.B. Since #1 is  always >= symj
c     so in this case orede of indices in #1 and #2 is inversed 1<->2, 3<->4
       call  ireorg (wrk,wrksize,
     & symp,symq,symi,symj,typp,typq,typr,typs,
     & 2,1,4,3,5,5,1,1,
     & typv2,possv1d,possv2,1.0d0)
c
       end if
c
       if (inverseyes.eq.1) then
c
c**   def possition #1 inverse (i.e. #1 <symp,symq| symj,symi>)
c     inverse integrals are used only if antysymetry is required
       iiv1i=mapi1(symp,symq,symj)
       possv1i=mapd1(iiv1i,1)
c
c**   do #2 <p q i j> <- - #1 <p,q|j,i> (i.e. inverse)
c     N.B. Since #1 is  always >= symj
c     so in this case orede of indices in #1 and #2 are inversed 3<->4
       call  ireorg (wrk,wrksize,
     & symp,symq,symi,symj,typp,typq,typr,typs,
     & 1,2,4,3,5,5,1,1,
     & typv2,possv1i,possv2,-1.0d0)
c
       end if
c
       end if
c
 100    continue
c
       return
       end
c
c     ----------------------------------------
c
       subroutine ireorg (wrk,wrksize,
     & symp,symq,symr,syms,typp,typq,typr,typs,
     & posspv1,possqv1,possrv1,posssv1,typpv1,typqv1,typrv1,typsv1,
     & typv2,possv10,possv20,fact)
c
c     this routine is up level routine for ireorg1 (also more detailed
c     description can be found there).
c     v1 must be of type 0, v2 can be 0,1,3 and 4
c     this routine only prepair some constants, required by ireorg1,
c     that can be deduced form input data - dimpq,dimrs,dimt-dimx
c
c     symp-s     - symetries of p-s (I)
c     typp-s     - types of indexes p-s in V2 (I)
c     possp-sv1  - possitions of p-s ind. in v1 (I)
c     typp-sv1   - types of indices, corresponding to p-s in V1 (I)
c     typv2      - type of V2 (0,1,2,4) (I)
c     possv10,20 - initial possitions of V1 and V2 in wrk (I)
c     fact       - multiplication factors (usually +-1.0d0) (I)
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       integer symp,symq,symr,syms,typp,typq,typr,typs
       integer posspv1,possqv1,possrv1,posssv1,typpv1,typqv1,typrv1,
     & typsv1
       integer typv2,possv10,possv20
       real*8 fact
c
c     help variables
c
       integer ind(1:4)
       integer rc,dimpq,dimrs
       integer :: nhelp=-1,mhelp=-1
c
c*    define dimensions of V1
c
       call ireorg2 (symp,typpv1,nhelp,rc)
       ind(posspv1)=nhelp
       call ireorg2 (symq,typqv1,nhelp,rc)
       ind(possqv1)=nhelp
       call ireorg2 (symr,typrv1,nhelp,rc)
       ind(possrv1)=nhelp
       call ireorg2 (syms,typsv1,nhelp,rc)
       ind(posssv1)=nhelp
c
c*    def dimpq,dimrs
c
       call ireorg2 (symp,typp,nhelp,rc)
       call ireorg2 (symq,typq,mhelp,rc)
c
       if (((typv2.eq.1).or.(typv2.eq.4)).and.(symp.eq.symq)) then
       dimpq=(nhelp*(nhelp-1))/2
       else
       dimpq=nhelp*mhelp
       end if
c
       call ireorg2 (symr,typr,nhelp,rc)
       call ireorg2 (syms,typs,mhelp,rc)
c
       if (((typv2.eq.3).or.(typv2.eq.4)).and.(symr.eq.syms)) then
       dimrs=(nhelp*(nhelp-1))/2
       else
       dimrs=nhelp*mhelp
       end if
c
c*    use ireorg1
c
       call ireorg1 (symp,symq,symr,syms,typp,typq,typr,typs,
     & posspv1,possqv1,possrv1,posssv1,typpv1,typqv1,typrv1,typsv1,
     & typv2,wrk(possv10),wrk(possv20),fact,dimpq,dimrs,
     & ind(1),ind(2),ind(3),ind(4))
c
       return
       end
c
c     ---------
c
       subroutine ireorg1 (symp,symq,symr,syms,typp,typq,typr,typs,
     & posspv1,possqv1,possrv1,posssv1,typpv1,typqv1,typrv1,typsv1,
     & typv2,v1,v2,fact,dimpq,dimrs,dimt,dimu,dimv,dimx)
c
c     this routine map v2(pq,rs) <+ fact . v1 (t,u,v,z)
c     v2 may be of type 0,1,3,4 (typv2) while type v1 is always 0
c     symp-syms and typp-typs are symmetries and types of p-s indexex
c     posspv1-posssv1 are corresponding possitions of p-s indexes in v1
c
c     symp-s     - symetries of p-s (I)
c     typp-s     - types of indexes p-s in V2 (I)
c     possp-sv1  - possitions of p-s ind. in v1 (I)
c     typp-sv1   - types of indices, corresponding to p-s in V1 (I)
c     typv2      - type of V2 (0,1,2,4) (I)
c     v1,v2      - arrays V1 and V2  (I,O)
c     fact       - multiplication factors (usually +-1.0d0) (I)
c     dimpq,rs   - dimensions of V2 (I)
c     dimt-x     - dimensions of V1 (I)
c
c
c     reorg.fh may not be included
#include "ccsort.fh"
       integer symp,symq,symr,syms,typp,typq,typr,typs
       integer posspv1,possqv1,possrv1,posssv1
       integer typpv1,typqv1,typrv1,typsv1,typv2
       integer dimpq,dimrs,dimt,dimu,dimv,dimx
       real*8 v2(1:dimpq,1:dimrs)
       real*8 v1(1:dimt,1:dimu,1:dimv,1:dimx)
       real*8 fact
c
c     help variables
c
       integer p,q,r,s,pq,rs,pup,qup,rup,sup,rc,pqyes,rsyes
       integer :: paddv1=-1,qaddv1=-1,raddv1=-1,saddv1=-1
       integer ind(1:4)
c
c*    def additive constants
c
       call ireorg3 (symp,typp,typpv1,paddv1,rc)
       call ireorg3 (symq,typq,typqv1,qaddv1,rc)
       call ireorg3 (symr,typr,typrv1,raddv1,rc)
       call ireorg3 (syms,typs,typsv1,saddv1,rc)
c
c*    def sumation limits
c
       call ireorg2 (symp,typp,pup,rc)
       call ireorg2 (symq,typq,qup,rc)
       call ireorg2 (symr,typr,rup,rc)
       call ireorg2 (syms,typs,sup,rc)
c
c*    def pqyes, rsyes (i.e. if there is a reduced sumations)
c
       if ((typv2.eq.1).or.(typv2.eq.4)) then
       if (symp.eq.symq) then
       pqyes=1
       else
       pqyes=0
       end if
       else
       pqyes=0
       end if
c
       if ((typv2.eq.3).or.(typv2.eq.4)) then
       if (symr.eq.syms) then
       rsyes=1
       else
       rsyes=0
       end if
       else
       rsyes=0
       end if
c
c
       if ((pqyes.eq.1).and.(rsyes.eq.1)) then
c
c*    case p>q, r>s
c
       rs=0
       do 100 r=2,rup
       ind(possrv1)=raddv1+r
       do 101 s=1,r-1
       ind(posssv1)=saddv1+s
       rs=rs+1
c
       pq=0
       do 102 p=2,pup
       ind(posspv1)=paddv1+p
       do 103 q=1,p-1
       ind(possqv1)=qaddv1+q
       pq=pq+1
c
       v2(pq,rs)=v2(pq,rs)+fact*v1(ind(1),ind(2),ind(3),ind(4))
c
 103    continue
 102    continue
 101    continue
 100    continue
c
       else if (pqyes.eq.1) then
c
c*    case p>q, r,s
c
       rs=0
       do 200 s=1,sup
       ind(posssv1)=saddv1+s
       do 201 r=1,rup
       ind(possrv1)=raddv1+r
       rs=rs+1
c
       pq=0
       do 202 p=2,pup
       ind(posspv1)=paddv1+p
       do 203 q=1,p-1
       ind(possqv1)=qaddv1+q
       pq=pq+1
c
       v2(pq,rs)=v2(pq,rs)+fact*v1(ind(1),ind(2),ind(3),ind(4))
c
 203    continue
 202    continue
 201    continue
 200    continue
c
       else if (rsyes.eq.1) then
c
c*    case p,q, r>s
c
       rs=0
       do 300 r=2,rup
       ind(possrv1)=raddv1+r
       do 301 s=1,r-1
       ind(posssv1)=saddv1+s
       rs=rs+1
c
       pq=0
       do 302 q=1,qup
       ind(possqv1)=qaddv1+q
       do 303 p=1,pup
       ind(posspv1)=paddv1+p
       pq=pq+1
c
       v2(pq,rs)=v2(pq,rs)+fact*v1(ind(1),ind(2),ind(3),ind(4))
c
 303    continue
 302    continue
 301    continue
 300    continue
c
       else
c
c*    case p,q, r,s
c
       rs=0
       do 400 s=1,sup
       ind(posssv1)=saddv1+s
       do 401 r=1,rup
       ind(possrv1)=raddv1+r
       rs=rs+1
c
       pq=0
       do 402 q=1,qup
       ind(possqv1)=qaddv1+q
       do 403 p=1,pup
       ind(posspv1)=paddv1+p
       pq=pq+1
c
       v2(pq,rs)=v2(pq,rs)+fact*v1(ind(1),ind(2),ind(3),ind(4))
c
 403    continue
 402    continue
 401    continue
 400    continue
c
       end if
c
       return
       end
c
c     ------------
c
       subroutine ireorg3 (symp,typp,typpv1,paddv1,rc)
c
c*    this routine def. constants to be added to index from v2
c     to determine proper index in v1
c     N.B. typp and typpv1 must be compatible (this is testet
c     in this version)
c
c     symp  - irrep of p index (I)
c     typp  - typ of p index in v2 (I)
c     typpv1- typ of corresponding p index in v1 (I)
c     paddv1- constant to be added (O) pv1 = pv2+paddv1
c     rc    - return (error) code (O)
c
#include "ccsort.fh"
       integer symp,typp,typpv1,paddv1,rc
c
       rc=0
c
       if ((typp.eq.1).or.(typp.eq.2)) then
          if ((typpv1.eq.1).or.(typpv1.eq.2).or.(typpv1.eq.5)) then
             paddv1=0
          else
             rc=1
c            RC=1 : typp=1 or 2, incompatible typpv1 (Stup)
             return
          end if
       else if (typp.eq.3) then
       if (typpv1.eq.3) then
          paddv1=0
       else if (typpv1.eq.4) then
           paddv1=nvb(symp)-nva(symp)
       else if (typpv1.eq.5) then
           paddv1=noa(symp)
       else
           rc=2
c          RC=2 : typp=3, incompatible typpv1 (Stup)
           return
       end if
       else if (typp.eq.4) then
       if (typpv1.eq.4) then
       paddv1=0
       else if (typpv1.eq.5) then
       paddv1=nob(symp)
       else
       rc=3
c     RC=3 : typp=4, incompatible typpv1 (Stup)
       return
       end if
       else if (typp.eq.5) then
       if (typpv1.eq.5) then
       paddv1=0
       else
c     RC=4 : typp=5, incompatible typpv1 (Stup)
       return
       end if
       else
       rc=5
c     RC=5 : improper typp (Stup)
       return
       end if
c
       return
       end
c
c     ------------
c
       subroutine ireorg2 (symp,typp,pup,rc)
c
c*    this routine def. sumation limits for given symp and typp
c     i.e. number of indexes for this symmetry and typ
c
c     symp  - irrep of p index (I)
c     typp  - typ of p index in v2 (I)
c     pup   - sumation limit
c     rc    - return (error) code (O)
c
#include "ccsort.fh"
       integer symp,typp,pup,rc
c
       if (typp.eq.1) then
       pup=noa(symp)
       else if (typp.eq.2) then
       pup=nob(symp)
       else if (typp.eq.3) then
       pup=nva(symp)
       else if (typp.eq.4) then
       pup=nvb(symp)
       else if (typp.eq.5) then
       pup=norb(symp)
       else
       rc=1
c     RC=1 : bad typp (Stup)
       return
       end if
c
       return
       end
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************

function optim_E(C,G,H,n)

use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: optim_E
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: C(n), G(n), H(n,n)
integer(kind=iwp) :: k

Optim_E = sum(C(:)*G(:))
do k=1,n
  Optim_E = Optim_E+Half*C(k)*sum(C(:)*H(k,:))
end do

end function optim_E

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Gunnar Karlstrom                                 *
*               2000, Roland Lindh                                     *
************************************************************************
      Subroutine eperm(D_Tot,nDens,Ravxyz,Cavxyz,nCavxyz_,dEF,
     &                 Grid,nGrid_,Cord,MaxAto,Z_Nuc,xfEF)
************************************************************************
*                                                                      *
*     Object:                                                          *
*                                                                      *
*     Authors: G. Karlstroem                                           *
*              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
*                                                                      *
*              and                                                     *
*                                                                      *
*              R. Lindh                                                *
*              Dept. of Chem. Phys., Univ. of Lund, Sweden.            *
*                                                                      *
*              March 2000                                              *
************************************************************************
      use external_centers
      use Symmetry_Info, only: nIrrep, iChBas
      use Basis_Info, only: nBas
      use Gateway_global, only: PrPrt
      Implicit Real*8 (a-h,o-z)
      External EFInt, EFMem
#include "real.fh"
#include "rctfld.fh"
#include "print.fh"
#include "stdalloc.fh"
      Real*8 D_Tot(nDens), Ravxyz(nCavxyz_), Cavxyz(nCavxyz_),
     &       dEF(4,nGrid_), Grid(3,nGrid_), Origin(3), CCoor(3),
     &       Cord(3,MaxAto), Z_Nuc(MaxAto),xfEF(4,nGrid_)
      Logical Save_tmp
      Character*8 Label
      Dimension FactOp(1), l_Oper(1)
      Integer, Allocatable:: ips(:), lOper(:), kOper(:)
      Real*8, Allocatable::  C_Coor(:,:), Nuc(:)
*                                                                      *
************************************************************************
*                                                                      *
*-----Statement Functions
*
      iOff(ixyz) = ixyz*(ixyz+1)*(ixyz+2)/6
*                                                                      *
************************************************************************
*                                                                      *
      iPrint=5
      If(.not.lRFCav) Goto 99  !Skip calculation of moments if no cavity
      Call FZero(Origin,3)
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute the multipole moment of the QC system,
*     both nuclear(1) and electronic(2).
*
*     Cavxyz: Multipole moments in cartesian basis
*     Ravxyz: temporary storage
*
      Call FZero(Cavxyz,nCavxyz_)
*
*---- 1) Compute M(nuc,nl), nuclear multipole moments
*
      Do iMax = 0, lMax
         ip = 1 + iOff(iMax)
         Call RFNuc(Origin,Ravxyz(ip),iMax)
      End Do

      If (iPrint.ge.99) Call RecPrt('Nuclear Multipole Moments',
     &                              ' ',Ravxyz,1,nCavxyz_)
*
*---- 2) Compute the electronic contribution to the charge distribution.
*
*     M(el,nl) =  - Sum(p,q) Dpq <p|M(nl)|q>
*
      nOpr=1
      FactOp=One
      l_Oper=1
*-----Reset array for storage of multipole moment expansion
      Do iMltpl = 1, lMax
         Do ix = iMltpl, 0, -1
            If (Mod(ix,2).eq.0) Then
               iSymX=1
            Else
               ixyz=1
               iSymX=2**IrrFnc(ixyz)
               If (Origin(1).ne.Zero) iSymX = iOr(iSymX,1)
            End If
            Do iy = iMltpl-ix, 0, -1
               If (Mod(iy,2).eq.0) Then
                  iSymY=1
               Else
                  ixyz=2
                  iSymY=2**IrrFnc(ixyz)
                  If (Origin(2).ne.Zero) iSymY = iOr(iSymY,1)
               End If
               iz = iMltpl-ix-iy
               If (Mod(iz,2).eq.0) Then
                  iSymZ=1
               Else
                  ixyz=4
                  iSymZ=2**IrrFnc(ixyz)
                  If (Origin(3).ne.Zero) iSymZ = iOr(iSymZ,1)
               End If
*
               iTemp = MltLbl(iSymX,MltLbl(iSymY,iSymZ))
               l_Oper=iOr(l_Oper,iTemp)
            End Do
         End Do
      End Do
      If (iPrint.ge.19) Then
         Write (6,*) '1st order total density'
         lOff = 1
         Do iIrrep = 0, nIrrep-1
            n = nBas(iIrrep)*(nBas(iIrrep)+1)/2
            Write (Label,'(A,I1)')
     &       'Diagonal Symmetry Block ',iIrrep+1
            Call Triprt(Label,' ',D_Tot(lOff),nBas(iIrrep))
            lOff = lOff + n
         End Do
      End If
*

      Call Drv1_RF(FactOp,nOpr,D_tot,nh1,Origin,l_Oper,Cavxyz,lMax)
*
      If (iPrint.ge.99) Call RecPrt('Electronic Multipole Moments',
     &                              ' ',Cavxyz,1,nCavxyz_)
*
*---- Add nuclear MM expansion to the electronic one
*
      Call DaXpY_(nCavxyz_,One,Ravxyz,1,Cavxyz,1)
*
      If (iPrint.ge.99) Call RecPrt('Electronic+Nuclear Moments',
     &                              ' ',Cavxyz,1,nCavxyz_)


      If(Allocated(XF)) Then
         Call XFMoment(lMax,Cavxyz,Ravxyz,nCavxyz_,Origin)
      EndIf

      If (iPrint.ge.99) Call RecPrt('Total Multipole Moments ',
     &                              ' ',Cavxyz,1,nCavxyz_)
*                                                                      *
************************************************************************
*                                                                      *
*---- Loop over the Langevin grid, compute EF and store in dEF.
*
*     The code here is initially with the loop over the grid outermost.
*     We might have to change this later on!
*
*     Be happy, don't worry!
*
 99   Continue
      rHrmt=One
      nOrdOp = 1
      nComp = 3
      Sig=-One
      ixyz=1
      iSymX = 2**IrrFnc(ixyz)
      ixyz=2
      iSymY = 2**IrrFnc(ixyz)
      ixyz=4
      iSymZ = 2**IrrFnc(ixyz)
      ixyz=3
      iSymXY = 2**IrrFnc(ixyz)
      ixyz=5
      iSymXZ = 2**IrrFnc(ixyz)
      ixyz=6
      iSymYZ = 2**IrrFnc(ixyz)
      ixyz=7
      iSyXYZ = 2**IrrFnc(ixyz)
*
      Call mma_allocate(ips,nComp,Label='ips')
      Call mma_allocate(lOper,nComp,Label='lOper')
      Call mma_allocate(kOper,nComp,Label='kOper')
      call mma_allocate(Nuc,nComp,Label='Nuc')
      Call mma_allocate(C_Coor,3,nComp,Label='CCoor')
*
      Save_tmp=PrPrt
      PrPrt=.True.
*
      Do iGrid = 1, nGrid_
         Write (Label,'(A,I5)') 'EF ',iGrid
         call dcopy_(3,Grid(1,iGrid),1,Ccoor,1)
         iSymC = 1
         If (Ccoor(1).ne.Zero) iSymC = iOr(iSymC,iSymX)
         If (Ccoor(2).ne.Zero) iSymC = iOr(iSymC,iSymY)
         If (Ccoor(3).ne.Zero) iSymC = iOr(iSymC,iSymZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero)
     &      iSymC = iOr(iSymC,iSymXY)
         If (Ccoor(1).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymC = iOr(iSymC,iSymXZ)
         If (Ccoor(2).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymC = iOr(iSymC,iSymYZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero .and.
     &       Ccoor(3).ne.Zero) iSymC = iOr(iSymC,iSyXYZ)
*
         iComp=0
         Do ix = nOrdOp, 0, -1
            Do iy = nOrdOp-ix, 0, -1
               iComp = iComp + 1
               iz = nOrdOp-ix-iy
               ixyz=0
               If (Mod(ix,2).ne.0) ixyz=iOr(ixyz,1)
               If (Mod(iy,2).ne.0) ixyz=iOr(ixyz,2)
               If (Mod(iz,2).ne.0) ixyz=iOr(ixyz,4)
               iSym = 2**IrrFnc(ixyz)
               If (Ccoor(iComp).ne.Zero ) iSym = iOr(iSym,1)
               lOper(iComp) = MltLbl(iSymC,iSym)
               kOper(iComp) = iChBas(iComp+1)
               call dcopy_(3,Ccoor,1,C_Coor(1,iComp),1)
            End Do
         End Do
*

         Call EFNuc(C_Coor,Z_Nuc,Cord,MaxAto,Nuc,nOrdOp)
         Call OneEl_Property(EFInt,EFMem,Label,
     &                       ips,lOper,nComp,C_Coor,
     &                       nOrdOp,Nuc,rHrmt,kOper,
     &                       D_Tot,nDens,dEF(1,iGrid),Sig)

*        Field contribution from XF
         Call EFXF(C_Coor,XF,nXF,nOrd_XF,iXPolType,
     &        xfEF(1,iGrid),XMolnr,nXMolnr,iGrid,scal14)
*
      End Do

*     Add XF contribution to the total field
      Call DaXpY_(4*nGrid,One,xfEF,1,dEF,1)

      PrPrt=Save_tmp
*
      Call mma_deallocate(C_Coor)
      Call mma_deallocate(Nuc)
      Call mma_deallocate(kOper)
      Call mma_deallocate(lOper)
      Call mma_deallocate(ips)
*                                                                      *
************************************************************************
*                                                                      *
*---- Loop over grid points and compute square norm of EF. Store the
*     largest of the latter in fmax (used in solver).
*
      fmax=Zero
      Do iGrid = 1, nGrid_
         ftest=dEF(1,iGrid)**2
     &        +dEF(2,iGrid)**2
     &        +dEF(3,iGrid)**2
         dEF(4,iGrid)=ftest
         fmax=Max(fmax,ftest)
      End Do ! iGrid

c      Call RecPrt('eperm: dEF ',' ',dEF,4,nGrid_)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
*               Steven Vancoillie                                      *
************************************************************************
C> @brief
C>  Procedure for computing 1-body, 2-body, and 3-body
C>  density elements with active indices only,
C>  and related matrices obtained from contractions with
C>  the diagonal one-electron Hamiltonian.
C> @author Per &Aring;ke Malmqvist
C> @modified_by Steven Vancoillie
C>
C> @details
C> Computation of the 1-, 2-, and 3-body density matrices defined as
C> \f{align}{
C> G1(t,u)         &= \langle 0 \lvert E_{tu} \rvert 0 \rangle \\
C> G2(t,u,v,x)     &= \langle 0 \lvert E_{tuvx} \rvert 0 \rangle \\
C> G3(t,u,v,x,y,z) &= \langle 0 \lvert E_{tuvxyz} \rvert 0 \rangle \\
C> \f}
C> and the contractions with the diagonal 1-el Hamiltonian
C> \f{align}{
C> F1(t,u)         &= \sum_w \langle 0 \lvert E_{tuww} \rvert 0 \rangle e_w \\
C> F2(t,u,v,x)     &= \sum_w \langle 0 \lvert E_{tuvxww} \rvert 0 \rangle e_w \\
C> F3(t,u,v,x,y,z) &= \sum_w \langle 0 \lvert E_{tuvxyzww} \rvert 0 \rangle e_w \\
C> \f}
C> Storage: \p G1 and \p G2 are simple two- and four-index arrays, and
C> includes also such zeroes that are implied by symmetry.
C> But \p G3 is quite large, and while it is stored with zeroes, it
C> is made more compact by calculating only the minimum amount of
C> unique values and storing the active indices in the array \p idxG3.
C> Later, the full matrix can be restored on the fly by using the
C> full permutational symmetry (see ::mksmat and ::mkbmat). The
C> same storage applies to the \f$ F \f$ matrices.
C>
C> @param[in]  IFF   switch to activate computation of \f$ F \f$ matrices
C> @param[in]  CI    wave function CI coefficients, with symmetry \c STSYM
C> @param[out] G1    1-body active density matrix
C> @param[out] G2    2-body active density matrix
C> @param[out] G3    process-local part of 3-body active density matrix
C> @param[out] F1    1-body active density matrix contracted with
C>                   diagonal 1-el Hamiltonian
C> @param[out] F2    2-body active density matrix contracted with
C>                   diagonal 1-el Hamiltonian
C> @param[out] F3    process-local part of 3-body active density matrix
C>                   contracted with diagonal 1-el Hamiltonian
C> @param[out] idxG3 table to translate from process-local array index
C>                   to active indices

      SUBROUTINE MKFG3(IFF,CI,G1,F1,G2,F2,G3,F3,idxG3,NLEV)
      use Symmetry_Info, only: Mul
      use caspt2_global, only: iPrGlb
      use fciqmc_interface, only: DoFCIQMC, mkfg3fciqmc
      use caspt2_global, only: do_grad, nbuf1_grad, nStpGrd,
     *                         iTasks_grad,nTasks_grad
      use PrintLevel, only: DEBUG, VERBOSE
      use gugx, only: CIS, SGS, L2ACT, EXS
      use stdalloc, only: mma_MaxDBLE, mma_allocate, mma_deallocate
      use Definitions, only: RtoB
      use caspt2_module, only: nActEl, nAshT, nBasT, nSym, STSym, EPSA
      use gugx, only: MxLev
      use pt2_guga, only: MxCI, nG1, nG2, nG3
      IMPLICIT NONE


      INTEGER, INTENT(IN) :: IFF, NLEV
      REAL*8, INTENT(IN) :: CI(MXCI)
      REAL*8, INTENT(OUT) :: G1(NLEV,NLEV),G2(NLEV,NLEV,NLEV,NLEV)
      REAL*8, INTENT(OUT) :: F1(NLEV,NLEV),F2(NLEV,NLEV,NLEV,NLEV)
      REAL*8, INTENT(OUT) :: G3(*), F3(*)
      INTEGER*1, INTENT(OUT) :: idxG3(6,*)

      INTEGER, PARAMETER :: I1=KIND(idxG3)
      LOGICAL RSV_TSK
      REAL*8 DG1,DG2,DG3,DF1,DF2,DF3
      REAL*8 F1SUM,F2SUM
      INTEGER I,J,IDX,JDX
      INTEGER IB,IBMN,IBMX,IBUF,NB,NBTOT,IBUF1
      INTEGER IP1,IP2,IP3,IP1MN,IP1MX,IP1I,IP1STA,IP1END,IP3MX,IQ1
      INTEGER IG3,IG3OFF
      INTEGER ISTU,ISVX,ISYZ
      INTEGER IT,IU,IV,IX,IY,IZ
      INTEGER ITLEV,IULEV,IVLEV,IXLEV,IYLEV,IZLEV
      INTEGER NBUF1
      INTEGER IOFFSET
      INTEGER ISSG1,ISSG2,ISP1
      INTEGER ITASK,ISUBTASK,ID,NTASKS,NSUBTASKS,MXTASK,MYTASK,MYBUFFER
      INTEGER NSGM1,NSGM2
      INTEGER NTRI1,NTRI2
      INTEGER MEMMAX, MEMMAX_SAFE
      INTEGER NLEV2
      INTEGER NCI,ICSF

      REAL*8, EXTERNAL :: DDOT_,DNRM2_

      ! translation tables for levels i,j to and from pair indices idx
      INTEGER IJ2IDX(MXLEV,MXLEV)
      INTEGER IDX2IJ(2,MXLEV**2)
      INTEGER ICNJ(MXLEV**2)
      INTEGER IP1_BUF(MXLEV**2)

      ! result buffer, maximum size is the largest possible ip1 range,
      ! which is set to nbuf1 later, i.e. a maximum of nlev2 <= mxlev**2
      REAL*8 BUFR(MXLEV**2)
      REAL*8, ALLOCATABLE:: BUF1(:,:), BUF2(:), BUFT(:), BUFD(:)
      INTEGER, ALLOCATABLE:: TASKLIST(:,:)

      Integer :: nMidV
      nMidV = CIS%nMidV

C Put in zeroes. Recognize special cases:
      IF(nlev.EQ.0) GOTO 999

      CALL DCOPY_(NG1,[0.0D0],0,G1,1)
      CALL DCOPY_(NG2,[0.0D0],0,G2,1)
      CALL DCOPY_(NG3,[0.0D0],0,G3,1)
      IF(IFF.ne.0) THEN
       CALL DCOPY_(NG1,[0.0D0],0,F1,1)
       CALL DCOPY_(NG2,[0.0D0],0,F2,1)
       CALL DCOPY_(NG3,[0.0D0],0,F3,1)
      END IF

      IF(NACTEL.EQ.0) GOTO 999

      NCI=CIS%NCSF(STSYM)
* This should not happen, but...
      IF(NCI.EQ.0) GOTO 999

C Here, for regular CAS or RAS cases.

C Special pair index idx2ij allows true RAS cases to be handled:
      nlev2=nlev**2
      ntri1=(nlev2-nlev)/2
      ntri2=(nlev2+nlev)/2
      idx=0
      do i=1,nlev-1
        do j=i+1,nlev
          idx=idx+1
          ij2idx(i,j)=idx
          idx2ij(1,idx)=i
          idx2ij(2,idx)=j
          jdx=nlev2+1-idx
          ij2idx(j,i)=jdx
          idx2ij(1,jdx)=j
          idx2ij(2,jdx)=i
        end do
      end do
      do i=1,nlev
        idx=ntri1+i
        ij2idx(i,i)=idx
        idx2ij(1,idx)=i
        idx2ij(2,idx)=i
      end do
      do idx=1,nlev2
        i=idx2ij(1,idx)
        j=idx2ij(2,idx)
        jdx=ij2idx(j,i)
        icnj(idx)=jdx
      end do

* Dummy values necessary for fooling syntax checkers:
      call mma_MaxDBLE(memmax)

* Use *almost* all remaining memory:
      memmax_safe=int(dble(memmax)*0.95D0)

* Buffers to compute CI expansion vectors into:
* <Psi0|E_ip1 | E_ip2 E_ip3|Psi0>
* buf1: bra buffer with E_ip1 excitations of Psi0
*       holds multiple CI vectors (allowed by memory)
* buf2: ket buffer for an E_ip3 excitation of Psi0
* buft: ket buffer for an E_ip2 excitation of E_ip3|Psi0>
* bufd: diagonal matrix elements to compute the F matrix
      nbuf1=max(1,min(nlev2,(memmax_safe-3*mxci)/mxci))
      !! if gradient, nbuf1 must be consistent here and in derfg3.f
      if (do_grad .or. nStpGrd==2) then
        !! Compute approximate available memory in derfg3.f
        !! allocated in DENS
        memmax_safe = memmax_safe - 16*NBAST**2 - 3*NASHT**2
        !! allocated (additionally) in CLagX
        memmax_safe = memmax_safe - 2*(NG1+NG2+NG3)
        nbuf1=max(1,min(nlev2,(memmax_safe-(6+nlev)*mxci)/mxci/3))
        nbuf1_grad = nbuf1
        nTasks_grad = 0
        iTasks_grad(:) = 0
      end if
      CALL mma_allocate(BUF1,MXCI,NBUF1,LABEL='BUF1')
      CALL mma_allocate(BUF2,MXCI,LABEL='BUF2')
      CALL mma_allocate(BUFT,MXCI,LABEL='BUFT')
      CALL mma_allocate(BUFD,MXCI,LABEL='BUFD')

C-SVC20100301: calculate maximum number of tasks possible
      MXTASK=(NTRI2-1)/NBUF1+1+(NTRI1-1)/NBUF1+1
      CALL mma_allocate (TaskList,mxTask,4,LABEL='TaskList')

      IF(iPrGlb.GE.VERBOSE) THEN
        WRITE(6,*)
        WRITE(6,'(2X,A)') 'Constructing G3/F3'
        WRITE(6,'(2X,A,F16.9,A)') ' memory avail: ',
     &    (memmax*RtoB)/1.0D9, ' GB'
        WRITE(6,'(2X,A,F16.9,A)') ' memory used:  ',
     &    (((nbuf1+3)*MXCI)*RtoB)/1.0D9, ' GB'
        call xFlush(6)
      ENDIF

      iG3OFF=0
* A *very* long loop over the symmetry of Sgm1 = E_ut Psi as segmentation.
* This also allows precomputing the Hamiltonian (H0) diagonal elements.
      DO issg1=1,nsym
        isp1=Mul(issg1,stsym)
        if (.not. DoFCIQMC) then
          nsgm1=CIS%ncsf(issg1)
          CALL H0DIAG_CASPT2(ISSG1,BUFD,CIS%NOW,CIS%IOW,NMIDV)
        end if

C-SVC20100301: calculate number of larger tasks for this symmetry, this
C-is basically the number of buffers we fill with sigma1 vectors.
      iTask=1
      ibuf1=0
      DO ip1=1,nlev2
        itlev=idx2ij(1,ip1)
        iulev=idx2ij(2,ip1)
        istu=Mul(SGS%ism(itlev),SGS%ism(iulev))
        IF (istu.EQ.isp1) THEN
          ibuf1=ibuf1+1
          ip1_buf(ibuf1)=ip1
          IF (ibuf1.EQ.1) TaskList(iTask,1)=ip1
        ENDIF
        IF (ibuf1.EQ.nbuf1.OR.(ibuf1.GT.0.AND.
     &         (ip1.EQ.ntri2.OR.ip1.EQ.nlev2))) THEN
            TaskList(iTask,2)=ip1_buf(ibuf1)
            TaskList(iTask,3)=ibuf1
            iTask=iTask+1
            ibuf1=0
        ENDIF
      ENDDO
      nTasks=iTask
      IF (ibuf1.EQ.0) nTasks=nTasks-1
C-SVC20100309: calculate number of inner loop iteration tasks.
      iOffSet=0
      DO iTask=1,nTasks
        TaskList(iTask,4)=iOffSet
        ip1sta=TaskList(iTask,1)
        ip1end=TaskList(iTask,2)
        ip3mx=ntri2
        if(ip1end.le.ntri2) ip3mx=ip1end
        if(ip1sta.gt.ntri2) ip3mx=ntri1
C-SVC20100309: Currently -we are going to limit this to the ip3-loop and
C-leave the ip2-loop intact.  This was based on the large overhead which
C-was observed for a very large number of small tasks.
C       iOffSet=iOffSet+ip3mx*ntri2-((ip3mx**2-ip3mx)/2)
        iOffSet=iOffSet+ip3mx
      ENDDO
      nSubTasks=iOffSet

      IF(iPrGlb.GE.VERBOSE) THEN
        WRITE(6,'(2X,A,I3,A,I6)') 'Sym: ',issg1,', #Tasks: ',nSubTasks
        call xFlush(6)
      ENDIF

      IF(iPrGlb.GE.DEBUG) THEN
        IF (nSubTasks .GT. 0) THEN
          WRITE(6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
C-position 12345678901234567890
     &    "--------",
     &    "------------",
     &    "----",
     &    "---------"
          WRITE(6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
C-position 12345678901234567890
     &    "task ID ",
     &    " ip1 range  ",
     &    "ip3 ",
     &    "#elements"
          WRITE(6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
C-position 12345678901234567890
     &    "--------",
     &    "------------",
     &    "----",
     &    "---------"
          call xFlush(6)
        END IF
      END IF

C-SVC20100301: initialize the series of subtasks
      Call Init_Tsk(ID, nSubTasks)

      myBuffer=0


 500  CONTINUE
C-SVC20100908: first check: can I actually do any task?
      IF ((NG3-iG3OFF).LT.nbuf1*ntri2) GOTO 501
C-SVC20100831: initialize counter for offset into G3
C-SVC20100302: BEGIN SEPARATE TASK EXECUTION
      If (.NOT.Rsv_Tsk(ID,iSubTask)) GOTO 501

      myTask=nTasks
      DO iTask=1,nTasks
        iBuf=iSubTask-TaskList(iTask,4)
        IF (iBuf.LE.0) THEN
          myTask=iTask-1
          goto 666
        ENDIF
      ENDDO
666   continue
      iTask=myTask

      iOffSet=TaskList(iTask,4)

C-SVC20100310: one task handles a range of ip1 values
C-that are in the buffer and one ip3 value, for which
C-a loop over ip2 values is then executed.
      ip1sta=TaskList(iTask,1)
      ip1end=TaskList(iTask,2)
      ip3=iSubTask-iOffSet

C-SVC20100301: fill the buffer with sigma vectors if they
C-have not been computed yet, else just get the number of
C-sigma vectors in the buffer.
      IF (myBuffer.NE.iTask) THEN
        ibuf1=0
        do ip1i=ip1sta,ip1end
         itlev=idx2ij(1,ip1i)
         iulev=idx2ij(2,ip1i)
         istu=Mul(SGS%ism(itlev),SGS%ism(iulev))
         it=L2ACT(itlev)
         iu=L2ACT(iulev)
         if(istu.eq.isp1) then
          ibuf1=ibuf1+1
          ip1_buf(ibuf1)=ip1i
          if (.not. DoFCIQMC) then
              call dcopy_(nsgm1,[0.0D0],0,BUF1(:,ibuf1),1)
              CALL SIGMA1(SGS,CIS,EXS,
     &                    IULEV,ITLEV,1.0D00,STSYM,CI,BUF1(:,ibuf1))
          end if
         end if
        end do
        myBuffer=iTask
      ELSE
        ibuf1=TaskList(iTask,3)
      ENDIF
C-SVC20100301: necessary batch of sigma vectors is now in the buffer
      if (.not. DoFCIQMC) then
          ! The ip1 buffer could be the same on different processes
          ! so only compute the G1 contribution when ip3 is 1, as
          ! this will only be one task per buffer.
          if (issg1.eq.stsym.AND.ip3.eq.1) then
            do ib=1,ibuf1
              idx=ip1_buf(ib)
              itlev=idx2ij(1,idx)
              iulev=idx2ij(2,idx)
              it=L2ACT(itlev)
              iu=L2ACT(iulev)
              G1(it,iu)=DDOT_(nsgm1,ci,1,BUF1(:,ib),1)
              IF(IFF.ne.0) then
                F1sum=0.0D0
                do i=1,nsgm1
                  F1sum=F1sum+CI(i)*BUF1(i,ib)*bufd(i)
                end do
                F1(it,iu)=F1sum-EPSA(iu)*G1(it,iu)
              end if
            end do
          end if
      end if

C     ip3mx=ntri2
C     if(ip1end.le.ntri2) ip3mx=ip1end
C     if(ip1sta.gt.ntri2) ip3mx=ntri1
C-SVC20100309: loop over ip3, ip2
C     do ip3=1,ip3mx

C-SVC20100309: PAM's magic formula
*     iCnt=iSubTask-iOffSet
*     ip3=int(dble(ntri2)+1.5D0 -
*    &     sqrt((dble(ntri2)+0.5d0)**2-2*iCnt+0.000001D0))
*     ip2=iCnt-((ip3-1)*ntri2-((ip3-1)*(ip3-2))/2 )+ip3-1

C-SVC20100309: use simpler procedure by keeping inner ip2-loop intact

      iq1=icnj(ip3)
* The indices corresponding to pair index p3:
      iylev=idx2ij(1,ip3)
      izlev=idx2ij(2,ip3)
      isyz=Mul(SGS%ism(iylev),SGS%ism(izlev))
      issg2=Mul(isyz,stsym)
      if (.not. DoFCIQMC) then
         nsgm2=CIS%ncsf(issg2)
      end if
      iy=L2ACT(iylev)
      iz=L2ACT(izlev)
      if (.not. DoFCIQMC) then
          call dcopy_(nsgm2,[0.0D0],0,BUF2,1)
          CALL SIGMA1(SGS,CIS,EXS,
     &                IYLEV,IZLEV,1.0D00,STSYM,CI,BUF2)
          if(issg2.eq.issg1) then
            do ib=1,ibuf1
              idx=ip1_buf(ib)
              itlev=idx2ij(1,idx)
              iulev=idx2ij(2,idx)
              it=L2ACT(itlev)
              iu=L2ACT(iulev)
              G2(it,iu,iy,iz)=DDOT_(nsgm1,BUF2,1,BUF1(:,ib),1)
              IF(IFF.ne.0) THEN
                F2sum=0.0D0
                do i=1,nsgm1
                  F2sum=F2sum+BUF2(i)*bufd(i)*buf1(i,ib)
                end do
                F2(it,iu,iy,iz)=F2sum
              END IF
            end do
          end if
      end if
      nbtot=0
      do ip2=ip3,ntri2
        ivlev=idx2ij(1,ip2)
        ixlev=idx2ij(2,ip2)
        isvx=Mul(SGS%ism(ivlev),SGS%ism(ixlev))
        iv=L2ACT(ivlev)
        ix=L2ACT(ixlev)
        if(isvx.ne.Mul(issg1,issg2)) goto 99
        if (.not. DoFCIQMC) then
            call dcopy_(nsgm1,[0.0D0],0,BUFT,1)
            CALL SIGMA1(SGS,CIS,EXS,
     &                  IVLEV,IXLEV,1.0D00,ISSG2,BUF2,BUFT)
        end if
*-----------
* Max and min values of index p1:
        ip1mx=ntri2
        if(ip3.le.ntri1) then
          ip1mx=nlev2
          if(ip2.gt.ntri1) ip1mx=iq1
        end if
        ip1mn=max(ip2,ip1sta)
        ip1mx=min(ip1mx,ip1end)
* The corresponding locations in the Sgm1 buffer:
        ibmn=999999
        ibmx=-999999
        do ib=ibuf1,1,-1
          ip1=ip1_buf(ib)
          if(ip1.ge.ip1mn)ibmn=ib
        end do
        do ib=1,ibuf1
          ip1=ip1_buf(ib)
          if(ip1.le.ip1mx)ibmx=ib
        end do
        nb=ibmx-ibmn+1
        if(nb.le.0) goto 99

*-----------
* Contract the Sgm1 wave functions with the Tau wave function.
        if (.not. DoFCIQMC) then
            call DGEMV_ ('T',nsgm1,nb,1.0D0,BUF1(:,ibmn),mxci,
     &           buft,1,0.0D0,bufr,1)
* and distribute this result into G3:
            call dcopy_(nb,bufr,1,G3(iG3OFF+1),1)
* and copy the active indices into idxG3:
        end if
        do ib=1,nb
         iG3=iG3OFF+ib
         idx=ip1_buf(ibmn-1+ib)
         itlev=idx2ij(1,idx)
         iulev=idx2ij(2,idx)
         iT=l2act(itlev)
         iU=l2act(iulev)
         idxG3(1,iG3)=int(iT,I1)
         idxG3(2,iG3)=int(iU,I1)
         idxG3(3,iG3)=int(iV,I1)
         idxG3(4,iG3)=int(iX,I1)
         idxG3(5,iG3)=int(iY,I1)
         idxG3(6,iG3)=int(iZ,I1)
        end do
        if (.not. DoFCIQMC) then
            IF(IFF.ne.0) THEN
* Elementwise multiplication of Tau with H0 diagonal - EPSA(IV):
                do icsf=1,nsgm1
                  buft(icsf)=
     &                 (bufd(icsf)-epsa(iv))*buft(icsf)
                end do
* so Tau is now = Sum(eps(w)*E_vxww) Psi. Contract and distribute:
                call DGEMV_ ('T',nsgm1,nb,1.0D0,BUF1(:,ibmn),mxci,
     &           buft,1,0.0D0,bufr,1)
                call dcopy_(nb,bufr,1,F3(iG3OFF+1),1)
            END IF
        end if
        iG3OFF=iG3OFF+nb
        nbtot=nbtot+nb
 99     continue
      end do
*     end do

      IF(iPrGlb.GE.DEBUG) THEN
        WRITE(6,'("DEBUG> ",I8,1X,"[",I4,"..",I4,"]",1X,I4,1X,I9)')
     &    iSubTask, ip1sta, ip1end, ip3, nbtot
        call xFlush(6)
      END IF
      !! consistent tasks must be executed here and in derfg3.f for grad
      if (do_grad .or. nStpGrd==2) then
        nTasks_grad = nTasks_grad + 1
        iTasks_grad(nTasks_grad) = iSubTask
      end if

CSVC: The master node now continues to only handle task scheduling,
C     needed to achieve better load balancing. So it exits from the task
C     list.  It has to do it here since each process gets at least one
C     task.

C-SVC20100301: end of the task
      GOTO 500

 501  CONTINUE

C-SVC20100302: no more tasks, wait here for the others, then proceed
C with next symmetry
      CALL Free_Tsk(ID)

      IF(iPrGlb.GE.DEBUG) THEN
        IF (nSubTasks .GT. 0) THEN
          WRITE(6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
C-position 12345678901234567890
     &    "--------",
     &    "------------",
     &    "----",
     &    "---------"
        END IF
      END IF

* End of sectioning loop over symmetry of Sgm1 wave functions.
      END DO
C-SVC20100831: set correct number of elements in new G3
      NG3=iG3OFF

      CALL mma_deallocate(TASKLIST)
      ! free CI buffers
      CALL mma_deallocate(BUF1)
      CALL mma_deallocate(BUF2)
      CALL mma_deallocate(BUFT)
      CALL mma_deallocate(BUFD)

C-SVC20100302: Synchronized add into the densitry matrices
C  only for the G1 and G2 replicate arrays
      CALL GADSUM(G1,NG1)
      CALL GADSUM(G2,NG2)

      CALL GADSUM(F1,NG1)
      CALL GADSUM(F2,NG2)

      if (DoFCIQMC) then
          call mkfg3fciqmc(G1,G2,G3,F1,F2,F3,idxG3,nLev)
      else
          ! Correction to G2: It is now = <0| E_tu E_yz |0>
          do iu=1,nlev
           do iz=1,nlev
            do it=1,nlev
             G2(it,iu,iu,iz)=G2(it,iu,iu,iz)-G1(it,iz)
            end do
           end do
          end do
        ! SVC20100310: took some spurious mirroring of G2 values out
        ! of the loops and put them here, after the parallel section has
        ! finished, so that GAdSUM works correctly.
          do ip1=ntri2+1,nlev2
           itlev=idx2ij(1,ip1)
           iulev=idx2ij(2,ip1)
           it=L2ACT(itlev)
           iu=L2ACT(iulev)
           do ip3=ntri1+1,ip1
            iylev=idx2ij(1,ip3)
            izlev=idx2ij(2,ip3)
            iy=L2ACT(iylev)
            iz=L2ACT(izlev)
            G2(it,iu,iy,iz)=G2(iz,iy,iu,it)
           end do
          end do
       ! Correction to G2: Some values not computed follow from symmetry
          do ip1=1,nlev2-1
           itlev=idx2ij(1,ip1)
           iulev=idx2ij(2,ip1)
           it=L2ACT(itlev)
           iu=L2ACT(iulev)
           do ip3=ip1+1,nlev2
            iylev=idx2ij(1,ip3)
            izlev=idx2ij(2,ip3)
            iy=L2ACT(iylev)
            iz=L2ACT(izlev)
            G2(it,iu,iy,iz)=G2(iy,iz,it,iu)
           end do
          end do
          IF(IFF.ne.0) THEN
           ! Correction to F2: It is now = <0| E_tu H0Diag E_yz |0>
           do iz=1,nlev
            do iy=1,nlev
             do iu=1,nlev
              do it=1,nlev
               F2(it,iu,iy,iz)=F2(it,iu,iy,iz)-
     &               (EPSA(iu)+EPSA(iy))*G2(it,iu,iy,iz)
              end do
             end do
            end do
           end do
           do iz=1,nlev
            do iu=1,nlev
             do it=1,nlev
              F2(it,iu,iu,iz)=F2(it,iu,iu,iz)-
     &              (F1(it,iz)+EPSA(iu)*G1(it,iz))
             end do
            end do
           end do
        ! SVC20100310: took some spurious mirroring of F2 values out
        ! of the loops and put them here, after the parallel section has
        ! finished, so that GAdSUM works correctly.
           do ip1=ntri2+1,nlev2
            itlev=idx2ij(1,ip1)
            iulev=idx2ij(2,ip1)
            it=L2ACT(itlev)
            iu=L2ACT(iulev)
            do ip3=ntri1+1,ip1
             iylev=idx2ij(1,ip3)
             izlev=idx2ij(2,ip3)
             iy=L2ACT(iylev)
             iz=L2ACT(izlev)
             F2(it,iu,iy,iz)=F2(iz,iy,iu,it)
            end do
           end do
      ! Correction to F2: Some values not computed follow from symmetry
           do ip1=1,nlev2-1
            itlev=idx2ij(1,ip1)
            iulev=idx2ij(2,ip1)
            it=L2ACT(itlev)
            iu=L2ACT(iulev)
            do ip3=ip1+1,nlev2
             iylev=idx2ij(1,ip3)
             izlev=idx2ij(2,ip3)
             iy=L2ACT(iylev)
             iz=L2ACT(izlev)
             F2(it,iu,iy,iz)=F2(iy,iz,it,iu)
            end do
           end do
          END IF

      ! Correction to G3: It is now <0| E_tu E_vx E_yz |0>
      ! Similar for F3 values.
          DO iG3=1,NG3
           iT=idxG3(1,iG3)
           iU=idxG3(2,iG3)
           iV=idxG3(3,iG3)
           iX=idxG3(4,iG3)
           iY=idxG3(5,iG3)
           iZ=idxG3(6,iG3)
      ! Correction: From <0| E_tu E_vx E_yz |0>, form <0| E_tuvxyz |0>
           if(iY.eq.iX) then
            G3(iG3)=G3(iG3)-G2(iT,iU,iV,iZ)
            IF(IFF.ne.0) F3(iG3)=
     &               F3(iG3)-(F2(iT,iU,iV,iZ)+EPSA(iu)*G2(iT,iU,iV,iZ))
            if(iv.eq.iu) then
             G3(iG3)=G3(iG3)-G1(iT,iZ)
             IF(IFF.ne.0) F3(iG3)=F3(iG3)-F1(iT,iZ)
            end if
           end if
           if(iV.eq.iU) then
             G3(iG3)=G3(iG3)-G2(iT,iX,iY,iZ)
             IF(IFF.ne.0) F3(iG3)=F3(iG3)-
     &                (F2(iT,iX,iY,iZ)+EPSA(iY)*G2(iT,iX,iY,iZ))
           end if
           if(iY.eq.iU) then
             G3(iG3)=G3(iG3)-G2(iV,iX,iT,iZ)
             IF(IFF.ne.0) F3(iG3)=
     &                F3(iG3)-(F2(iV,iX,iT,iZ)+EPSA(iU)*G2(iV,iX,iT,iZ))
           end if
           IF(IFF.ne.0) F3(iG3)=F3(iG3)-(EPSA(iU)+EPSA(iY))*G3(iG3)
          END DO
      end if

      IF(iPrGlb.GE.DEBUG) THEN
CSVC: if running parallel, G3/F3 are spread over processes,
C     so make sure that the _total_ fingerprint is computed
        dG1=DNRM2_(NG1,G1,1)
        dG2=DNRM2_(NG2,G2,1)
        dG3=DDOT_(NG3,G3,1,G3,1)
        CALL GADGOP_SCAL(dG3,'+')
        dG3=SQRT(dG3)
        dF1=DNRM2_(NG1,F1,1)
        dF2=DNRM2_(NG2,F2,1)
        dF3=DDOT_(NG3,F3,1,F3,1)
        CALL GADGOP_SCAL(dF3,'+')
        dF3=SQRT(dF3)

        WRITE(6,'("DEBUG> ",A)') "MKFG3: norms of the density matrices:"
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G1:", dG1
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G2:", dG2
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G3:", dG3
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "F1:", dF1
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "F2:", dF2
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "F3:", dF3
      ENDIF

 999  continue
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine gsinp_cvb(orbs,irdorbs,nvbinp,kbasiscvb_inp,mxaobf,mxorb,kbasis,strtvb)

use casvb_global, only: gsinp
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: mxorb, mxaobf, kbasis
real(kind=wp), intent(_OUT_) :: orbs(mxaobf,mxorb)
integer(kind=iwp), intent(_OUT_) :: irdorbs(mxorb), nvbinp, kbasiscvb_inp
real(kind=wp), intent(in) :: strtvb
integer(kind=iwp) :: idum(1), iorb, istr, mouse, mxread, nread
real(kind=wp), allocatable :: tmp(:)
integer(kind=iwp), parameter :: ncmp = 4, ngs = 7
character(len=*), parameter :: guess(ngs) = ['ORB     ','STRUC   ','READ    ','AOBASIS ','MOBASIS ','END     ','ENDGUESS']
logical(kind=iwp), external :: firsttime_cvb

#include "macros.fh"
unused_var(strtvb)

if (firsttime_cvb()) call touch_cvb('INPGS')
mouse = 1
do
  call fstring_cvb(guess,ngs,istr,ncmp,2)
  if (istr == 1) then
    ! 'ORB'
    call int_cvb(idum,1,nread,0)
    iorb = idum(1)
    if ((iorb <= 0) .or. (iorb > mxorb)) then
      write(u6,*) ' Illegal orbital number read :',iorb
      call abend_cvb()
    end if
    if (nread == 0) then
      write(u6,*) ' Orbital label in ORB keyword not found!'
      call abend_cvb()
    end if
    irdorbs(iorb) = mouse
    orbs(:,iorb) = Zero
    call real_cvb(orbs(:,iorb),mxaobf,nread,0)
  else if (istr == 2) then
    ! 'STRUC'
    !  If previous orb. permutation disable:
    call mma_deallocate(gsinp,safe='*')
    call mma_maxDBLE(mxread)
    mxread = mxread/2
    call mma_allocate(tmp,mxread,label='tmp')
    call realz_cvb(tmp,mxread,nvbinp,0)
    call mma_allocate(gsinp,nvbinp,label='gsinp')
    gsinp(:) = tmp(1:nvbinp)
    call mma_deallocate(tmp)
    kbasiscvb_inp = kbasis
  !else if (istr == 3) then
  !  ! 'READ'
  !  call fstring_cvb(readgs,nrdgs,istr2,ncmp,1)
  !  if (istr2 == 1) then
  !    ! 'ORB'
  !    iorb1 = 0
  !    iorb2 = 0
  !    call int_cvb(idum,1,nread,0)
  !    iorb1 = idum(1)
  !    if (nread == 0) then
  !      write(u6,*) ' No orbital number in READ,ORB keyword!'
  !      call abend_cvb()
  !    end if
  !    call fstring_cvb('TO      ',1,jstr,ncmp,1)
  !    if (jstr /= 0) then
  !      call int_cvb(idum,1,nread,0)
  !      iorb2 = idum(1)
  !      if (nread == 0) then
  !        write(u6,*) ' No orbital number after READ,...,TO, !'
  !        call abend_cvb()
  !      end if
  !    else
  !      iorb2 = iorb1
  !    end if
  !    jorb1 = iorb1
  !    jorb2 = iorb2
  !    call setstrtvb_cvb(strtvb)
  !    recordnm = strtvb
  !    do
  !      call fstring_cvb(readgs2,nrdgs2,istr3,ncmp,1)
  !      if (istr3 == 1) then
  !        call real_cvb(recordnm,1,nread,0)
  !        if (nread == 0) then
  !          write(u6,*) ' No identifier after READ,...,FROM, !'
  !          call abend_cvb()
  !        end if
  !      else if (istr3 == 2) then
  !        call int_cvb(idum,1,nread,0)
  !        jorb1 = idum(1)
  !        if (nread == 0) then
  !          write(u6,*) ' No orbital number after READ,...,AS, !'
  !          call abend_cvb()
  !        end if
  !        call fstring_cvb('TO      ',1,jstr,ncmp,1)
  !        if (jstr /= 0) then
  !          call int_cvb(idum,1,nread,0)
  !          jorb2 = idum(1)
  !          if (nread == 0) then
  !            write(u6,*) ' No orbital number after READ,...,TO, !'
  !            call abend_cvb()
  !          end if
  !        else
  !          jorb2 = jorb1
  !        end if
  !      end if
  !      if (istr3 == 0) exit
  !    end do
  !    call othergs_cvb(orbs,gsinp,recordnm,1,iorb1,iorb2,jorb1,jorb2)
  !  else if (istr2 == 2) then
  !    ! 'STRUC'
  !    istruc1 = 0
  !    istruc2 = 0
  !    call int_cvb(idum,1,nread,0)
  !    istruc1 = idum(1)
  !    if (nread == 0) then
  !      write(u6,*) ' No structure number in READ,STRUC keyword!'
  !      call abend_cvb()
  !    end if
  !    call fstring_cvb('TO      ',1,jstr,ncmp,1)
  !    if (jstr /= 0) then
  !      call int_cvb(idum,1,nread,0)
  !      istruc2 = idum(1)
  !      if (nread == 0) then
  !        write(u6,*) ' No structure number after READ,...,TO, !'
  !        call abend_cvb()
  !      end if
  !    else
  !      istruc2 = istruc1
  !    end if
  !    jstruc1 = istruc1
  !    jstruc2 = istruc2
  !    call setstrtvb_cvb(strtvb)
  !    recordnm = strtvb
  !    do
  !      call fstring_cvb(readgs2,nrdgs2,istr3,ncmp,1)
  !      if (istr3 == 1) then
  !        call real_cvb(recordnm,1,nread,0)
  !        if (nread == 0) then
  !          write(u6,*) ' No identifier after READ,...,FROM, !'
  !          call abend_cvb()
  !        end if
  !      else if (istr3 == 2) then
  !        call int_cvb(idum,1,nread,0)
  !        jstruc1 = idum(1)
  !        if (nread == 0) then
  !          write(u6,*) ' No structure number after READ,...,AS, !'
  !          call abend_cvb()
  !        end if
  !        call fstring_cvb('TO      ',1,jstr,ncmp,1)
  !        if (jstr /= 0) then
  !          call int_cvb(idum,1,nread,0)
  !          jstruc2 = idum(1)
  !          if (nread == 0) then
  !            write(u6,*) ' No structure number after READ,...,TO, !'
  !            call abend_cvb()
  !          end if
  !        else
  !          jstruc2 = jstruc1
  !        end if
  !      end if
  !      if (istr3 == 0) exit
  !    end do
  !    call othergs_cvb(orbs,gsinp,recordnm,2,istruc1,istruc2,jstruc1,jstruc2)
  !  else if (istr2 == 3) then
  !    ! 'ALL'
  !    call setstrtvb_cvb(strtvb)
  !    recordnm = strtvb
  !    call fstring_cvb('FROM    ',1,jstr,ncmp,1)
  !    if (jstr /= 0) then
  !      call real_cvb(recordnm,1,nread,0)
  !      if (nread == 0) then
  !        write(u6,*) ' No identifier after READ,...,FROM, !'
  !        call abend_cvb()
  !      end if
  !    end if
  !    call getguess_cvb(orbs,gsinp,recordnm,kbasiscvb_inp)
  !  end if
  else if (istr == 4) then
    ! 'AOBASIS'
    mouse = 2
  else if (istr == 5) then
    ! 'MOBASIS'
    mouse = 1
  end if
  ! 'END' , 'ENDGUESS' or unrecognized keyword -- end GUESS input:
  if ((istr == 0) .or. (istr == 6) .or. (istr == 7)) exit
end do

return

end subroutine gsinp_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,1995, Per-Olof Widmark                            *
*               1992,1995, Markus P. Fuelscher                         *
*               1992,1995, Piotr Borowski                              *
*               1992,1995, Martin Schuetz                              *
*               2016,2017, Roland Lindh                                *
************************************************************************
      SubRoutine MemAlo()
************************************************************************
*                                                                      *
*     purpose: allocate memory for density & fock metrices etc.        *
*                                                                      *
*     called from: SCF                                                 *
*                                                                      *
*     calls to: mma_allocate, FZero                                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher, P. Borowski and M.G. Schuetz       *
*     University of Lund, Sweden, 1992,95                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: split off from SOrb (Martin G. Schuetz, 1996)           *
*                                                                      *
************************************************************************
      use SCF_Arrays
      use Orb_Type
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "addr.fh"
#include "stdalloc.fh"
#include "lnklst.fh"
#include "infso.fh"
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Call Setup()
*
*---- Allocate memory for TrMat, CMO and occupation numbers
*
      nD=(iUHF+1)
      Call mma_allocate(TrM,nBB,nD,Label='TrM')
      Call mma_allocate(CMO,nBB,nD,Label='CMO')
*
*     Produce pointers to work for codes that still use GetMem and
*     (i)Work.
*
      mAdCMO    = ip_of_Work(CMO(1,1))
      mAdCMO_ab = mAdCMO + (nD-1)*nBB
*
      Call mma_allocate(Fock,nBT,nD,Label='Fock')
      Call FZero(Fock,nBT*nD)
*
      Call mma_allocate(OccNo,nnB,nD,Label='OccNo')
      Call FZero(OccNo,nnB*nD)
      Call mma_allocate(EOrb,nnB,nD,Label='EOrb')
      Call FZero(EOrb,nnB*nD)
      Call mma_allocate(OrbType,nnB,nD,Label='OrbType')
      Call ICopy(nnB*nD,[0],0,OrbType,1)

      nIt0=0
      Mx_nIter=Max(nIter(0),nIter(1)+nIt0)
*
*---- Allocate Dens and TwoHam
*.... a) permanently in core (apart from Dens and TwoHam)
      lthCor = 3*nBT + 2*nBB + 2*nnB + nnOc +
     &         MxOptm+1 + (MxOptm+1)**2 +
     &         MxIter + MxIter**2 +
     &         Mx_nIter*(Mx_nIter+1)/2+1
*.... b) space needed by PMat
      If (DSCF) Then
         lthPMt = 1024*1024 + 2*nBT
      Else
         lthPMt = nBB + 2*(MaxBas**2)
      End If
*.... c) the biggest scratch space is used by SubRoutine Diis
      lthgrd = nOO+nOV+2*nBT+nBT+3*MaxBas**2+nBT+nnB
      lthDii = Max(2*nOO,lthgrd)
      lthLiS = nOV+nBO+lthgrd
*
      lthTot = lthCor + Max(lthPMt,Max(lthDii,lthLiS))
     &       + MxIter*NodSiz*5
cmgs   this has to be fixed once in a more reasonable way...
c     MemRsv = lthTot
      MemRsv = 0
cmgs
      Call GetMem('SCF','Max','Real',iDum,MxMem)
      lthTot = lthTot + 5*nOV
      lthRst = MxMem - lthTot
      nDens  = Min(lthRst/(nBT*nD)/2,6)
C: We need at least 2 Dens in core at the same time for computing
C: the DIIS error vectors
      If (nDens.lt.2) Then
         Write (6,*) 'MemAlo: nDens.lt.2'
         Write (6,*) 'nDens=',nDens
         Call Abend()
      End If
C: Francesco Aquilante
C: for large basis sets reserve some extra memory for the
C: auxiliary matrices in egrad.f (limit set to 400 bsf)
C: We need at least 2 Dens in core... but the optimal performance
C: happens when we can read and store in memory 5 densities
      if (nBT.ge.80200)then
         nDens = Min(nDens,6)
      endif

      If (nDens.gt.Mx_nIter + 1) nDens = Mx_nIter + 1
      If (nDens.lt.2) nDens = 2
*
      nMem  = nDens - 1
*
      Call mma_allocate(Dens  ,nBT,nD,nDens,Label='Dens  ')
      Call FZero(Dens,nBT*nD*nDens)
      Call mma_allocate(TwoHam,nBT,nD,nDens,Label='TwoHam')
      Call FZero(TwoHam,nBT*nD*nDens)
      Call mma_allocate(Vxc,nBT,nD,nDens,Label='Vxc')
      Call FZero(Vxc,nBT*nD*nDens)
      Call mma_allocate(EDFT,MxIter,Label='EDFT')
      Call FZero(EDFT,MxIter)

*---  Allocate memory for diagonal Hessian with respect to the elements
*     of the anti-symmetric matrix kappa which represents the
*     rotations. Note that in the aufbau section that the size of this
*     matrix is not firmly know - the number of occupied orbitals in
*     each irrep is not known. For the unrestricted option the number
*     of alpha and beta orbitals may vary. Here we are generous and
*     allocate memory with a size that fits all.
*
*     lthH = 0
*     Do iSym = 1, nSym
*        nB = nBas(iSym)
*        mB = nB/2
*        lthH = lthH + (nB-mB)*mB
*     End Do
      If (Aufb) Then
         lthH = nBB
      Else
         lthH = nOV
      End If
      Call mma_allocate(HDiag,lthH,nD,Label='HDiag')
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!               2024, Giovanni Li Manni                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GEN_CONF_FOR_OCCLS(IOCCLS,IB_OCCLS,INITIALIZE_CONF_COUNTERS,NGAS,ISYM,MINOP,MAXOP,IONLY_NCONF,NTORB,NOBPT,NCONF_OP, &
                              NCONF,IBCONF_REO,IBCONF_OCC,ICONF,IDOREO,IZ_CONF,NCONF_ALL_SYM,ireo,nconf_tot)
! IONLY_NCONF = 1 :
!
! Generate number of configurations of occclass IOCCLS and sym ISYM
!
! IONLY_NCONF = 0 :
!
! Generate number and actual configurations of occclass IOCCLS
! and sym ISYM
!
! Input
! =====
! IOCCLS  : Number of electrons per gas space
! NOBPT   : Number of orbitals per gasspace
! IZ_CONF : Arc weights for configurations
! IBCONF_REO, IBCONF_OCC : Offset for reordering array and occupation array
!
! Output
! ======
! NCONF_OP : Number of configurations per number of open shells, all symmetries
! ICONF    : The actual configurations
! IREO     : Reorder array : Lex number => Actual number
!
! Jeppe Olsen, Nov. 2001
!
! G. Li Manni, June 2024: Scale-up capability for single SD ROHF type calculations

use lucia_data, only: MXPORB
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NGAS, IOCCLS(NGAS), IB_OCCLS, INITIALIZE_CONF_COUNTERS, ISYM, MINOP, MAXOP, IONLY_NCONF, NTORB, &
                                 NOBPT(NGAS), IBCONF_REO(*), IBCONF_OCC(*), IDOREO, IZ_CONF(*), nconf_tot
integer(kind=iwp), intent(inout) :: NCONF_OP(MAXOP+1), NCONF_ALL_SYM
integer(kind=iwp), intent(out) :: NCONF, ireo(nconf_tot)
integer(kind=iwp), intent(_OUT_) :: ICONF(*)
integer(kind=iwp) :: I, IB_OCC, IDUM, IDUM_ARR(1), ILEXNUM, INI, ISUM, ISYM_CONF, ISYMST, JCONF(2*MXPORB), JREO, NEL, NOCOB, &
                     NONEW, NOP_FOR_CONF, NOPEN
integer(kind=iwp), external :: ILEX_FOR_CONF_NEW

! Total number of electrons
NEL = sum(IOCCLS)
if (INITIALIZE_CONF_COUNTERS == 1) then
  NCONF_OP(:) = 0
  NCONF_ALL_SYM = 0
end if
! Loop over configurations
INI = 1
NCONF = 0
ISUM = 0
JCONF(:) = 0

do
  ! Generate an array of integers from 1 to NEL.
  ! It is the only CSF that matter for HS calculations.
  ! Skip any loop below... It is an overwhelmingly long loop.
  if ((NEL == MINOP) .and. (NEL == NOBPT(2))) then
    JCONF(1:NEL) = [(i,i=1,NEL)]
    NONEW = 0
  else
    call NEXT_CONF_FOR_OCCLS(JCONF,IOCCLS,NGAS,NOBPT,INI,NONEW)
  end if
  ISUM = ISUM+1
  INI = 0
  if (NONEW == 0) then
    ! Check symmetry and number of open orbitals for this space
    ISYM_CONF = ISYMST(JCONF,NEL)
    NOPEN = NOP_FOR_CONF(JCONF,NEL)
    NOCOB = NOPEN+(NEL-NOPEN)/2
    if ((NOPEN >= MINOP) .or. (IONLY_NCONF /= 0)) NCONF_ALL_SYM = NCONF_ALL_SYM+1
    if ((ISYM_CONF == ISYM) .and. (NOPEN >= MINOP)) then
      ! A new configuration to be included, reform and save in packed form
      NCONF = NCONF+1
      NCONF_OP(NOPEN+1) = NCONF_OP(NOPEN+1)+1
      if (IONLY_NCONF == 0) then
        ! Lexical number of this configuration
        IB_OCC = IBCONF_OCC(NOPEN+1)+(NCONF_OP(NOPEN+1)-1)*NOCOB
        call REFORM_CONF_OCC(JCONF,ICONF(IB_OCC),NEL,NOCOB)
        if (IDOREO /= 0) then
          ! Giovanni and Dongxia 2011.1.31
          ilexnum = ilex_for_conf_new(iconf(ib_occ),nocob,ntorb,nel,iz_conf,0,idum_arr,idum,idum)
          JREO = IBCONF_REO(NOPEN+1)-1+NCONF_OP(NOPEN+1)
          ! Giovanni and Dongxia 2011
          ireo(jreo) = ib_occls-1+ilexnum
        end if
      end if
    end if
    if ((NEL == MINOP) .and. (NEL == NOBPT(2))) exit
  else
    exit
  end if
  ! End if nonew = 0
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ======================================'
write(u6,*) ' Results from configuration generator :'
write(u6,*) ' ======================================'
write(u6,*)
write(u6,*) ' Occupation class in action :'
call IWRTMA(IOCCLS,1,NGAS,1,NGAS)
write(u6,*) ' Number of configurations of correct symmetry ',NCONF
write(u6,*) ' Number of configurations of all symmetries   ',NCONF_ALL_SYM
write(u6,*) ' Number of configurations for various number of open orbs'
call IWRTMA(NCONF_OP,1,MAXOP+1,1,MAXOP+1)
if (IONLY_NCONF == 0) then
  write(u6,*) ' Updated list of configurations (may not be the final...)'
  call WRT_CONF_LIST(ICONF,NCONF_OP,MAXOP,NEL)
  write(u6,*) ' Updated reordering of conf, Lex=>Act (may not be the final'
  call IWRTMA(IREO,1,NCONF_tot,1,NCONF_tot)
end if
#endif

end subroutine GEN_CONF_FOR_OCCLS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Ignacio Fdez. Galvan                             *
************************************************************************

* Wrapper for the OpenMolcas PrgmTranslate_Mod routine, so it works
* without using the module (i.e., from C). Some C-to-Fortran conversion
* needs to be done, which feels quite hackish.

#ifndef _HAVE_EXTRA_
#define MAXSTR 1024
      Subroutine PrgmTranslateC(InStr,l1,OutStr,l2,Par)
      Use ISO_C_Binding, Only: C_CHAR, C_NULL_CHAR
      Use Prgm
      Implicit None
      Character(Kind=C_CHAR), Intent(In) :: InStr(*)
      Character(Kind=C_CHAR), Intent(Out) :: OutStr(*)
      Integer, Intent(In) :: Par, l1
      Integer, Intent(Out) :: l2
      Character (Len=MAXSTR) :: TmpStr, TmpStr2
      Integer :: i
      TmpStr=''
      Do i=1,l1
        TmpStr(i:i)=InStr(i)
      End Do
      Call PrgmTranslate_Mod(TmpStr,l1,TmpStr2,l2,Par)
      Do i=1,l2
        OutStr(i)=TmpStr2(i:i)
      End Do
      OutStr(l2+1:l2+1)=C_NULL_CHAR
      End Subroutine PrgmTranslateC
#elif defined (NAGFOR)
c Some compilers do not like empty files
      Subroutine empty_prgmtranslatec
      End
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Roland Lindh                                     *
!***********************************************************************

function Compute_Rho(Weights,mGrid,iSpin)
!***********************************************************************
!      Author:Roland Lindh, Department of Chemical Physics, University *
!             of Lund, SWEDEN. November 2000                           *
!***********************************************************************

use nq_Grid, only: Rho
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: Compute_Rho
integer(kind=iwp), intent(in) :: mGrid, iSpin
real(kind=wp), intent(in) :: Weights(mGrid)
integer(kind=iwp) :: iGrid
real(kind=wp) :: d_alpha, d_beta, DTot

!                                                                      *
!***********************************************************************
!                                                                      *
Compute_Rho = Zero
if (iSpin == 1) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! iSpin=1

  do iGrid=1,mGrid

    d_alpha = Rho(1,iGrid)
    DTot = d_alpha

    ! Accumulate contributions to the integrated density

    Compute_Rho = Compute_Rho+DTot*Weights(iGrid)

  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! iSpin=/=1

  do iGrid=1,mGrid

    d_alpha = Rho(1,iGrid)
    d_beta = Rho(2,iGrid)
    DTot = d_alpha+d_beta

    ! Accumulate contributions to the integrated density

    Compute_Rho = Compute_Rho+DTot*Weights(iGrid)

  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *

return

end function Compute_Rho

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine InfoToMp(nSym,nBas,Energy_Without_FFPT,ip_Ene_Occ,
     &                   nOcOb,UserDen,Restart)
      Implicit real*8(a-h,o-z)

#include "WrkSpc.fh"
      Integer nBas(8)
      Character*8 Method
      Character*40 VTitle
      Character*6 FName
      Logical UserDen,Restart
      Dimension iDum(1)
*                                                                      *
************************************************************************
*                                                                      *
* Set some variables needed for creating the MpProp file.              *
*                                                                      *
************************************************************************
*                                                                      *
      NOCOB=0
      If(.not.UserDen) then
         nVec=0
         nOcc=0
         Do iSym = 1, nSym
            nVec = nVec + nBas(iSym)**2
            nOcc = nOcc + nBas(iSym)
         End Do
         Call Allocate_Work(ip_Ene_Occ,nOcc)
         If (Restart) Then
            Call Get_dScalar('MpProp Energy',Energy_Without_FFPT)
            Call Get_dArray('MpProp Orb Ener',Work(ip_Ene_occ),nOcc)
            Call Get_iScalar('MpProp nOcOb',nOcOb)
         Else
            Call Get_dScalar('Last energy',Energy_Without_FFPT)
            Call Put_dScalar('MpProp Energy',Energy_Without_FFPT)

            Call Allocate_Work(ip_Vec,nVec)
            Call Allocate_Work(ip_Occ,nOcc)

            Lu_   = 11
            FName ='INPORB'
            iDum  = 0
            iWarn = 2
            Call RdVec(FName,Lu_,'COE',nSym,nBas,nBas,Work(ip_Vec),
     &           Work(ip_Occ),Work(ip_Ene_Occ),iDum,VTitle,iWarn,iErr)
            Close(Lu_)

            Do i=0,nOcc-1
               If (Work(ip_Occ+i).ne.0.0D0) Then
               nOcOb = nOcOb + 1
               End If
            End Do
            Call Put_dArray('MpProp Orb Ener',Work(ip_Ene_occ),nOcc)
            Call Put_iScalar('MpProp nOcOb',nOcOb)

            Call Free_Work(ip_Vec)
            Call Free_Work(ip_Occ)
         End If
      Else  !Here we go if user give density as input. Need to put some
            !dummy values for later; also we give a value to the relax
            !method, which for now is called 'external'.
        Energy_Without_FFPT=0.0D0
        nOcc=0
        Do iSym = 1, nSym
           nOcc = nOcc + nBas(iSym)
        End Do
        Call Allocate_Work(ip_Ene_Occ,nOcc)
        Do i=0,nOcc-1
          Work(ip_Ene_Occ+i)=0.0D0
        Enddo
        Write(Method,'(A)')'External'
        Call Put_cArray('Relax Method',Method,8)
      Endif

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Get_CurviL(nq,nqRF,nqB,nqA,nqT,nqO,nsAtom,iIter,nIter,Cx,Process,Val,nB,qLbl,iRef,fconst,rMult,LuIC,Indq,iPrv, &
                      Grad_all,iGlow,iGhi,Proc_dB,iTabBonds,iTabAtoms,nBonds,nMax,iTabAI,mAtoms,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM, &
                      nB_Tot,ndB_Tot,mqB,Thr_small)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: nq, nqRF, nqB, nqA, nqT, nqO, mB_Tot, mdB_Tot
integer(kind=iwp), intent(in) :: nsAtom, iIter, nIter, nB, iRef, LuIC, iPrv, iGlow, iGhi, nBonds, iTabBonds(3,nBonds), nMax, &
                                 mAtoms, iTabAtoms(2,0:nMax,mAtoms), iTabAI(2,mAtoms), nB_Tot, ndB_Tot
real(kind=wp), intent(in) :: Cx(3,nsAtom,nIter), Thr_small
logical(kind=iwp), intent(in) :: Process, Proc_dB
real(kind=wp), intent(inout) :: Val(nB,nIter), fconst(nB), rMult(nb), Grad_all(9,iGlow:iGhi,nIter), BM(nB_Tot), dBM(ndB_Tot)
integer(kind=iwp), intent(inout) :: Indq(3,nB), iBM(nB_Tot), idBM(2,ndB_Tot), mqB(nB)
character(len=14), intent(inout) :: qLbl(nB)
integer(kind=iwp) :: nq_

!                                                                      *
!***********************************************************************
!                                                                      *
nq = 0
mB_Tot = 0
mdB_Tot = 0
if (Process) BM(:) = Zero
if (Proc_dB) dBM(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
if (Process) call RecPrt('BM initial',' ',BM,1,size(BM))
#endif
nq_ = nq
call RF_Coord(nq,nsAtom,iIter,nIter,Cx,Process,Val,nB,qLbl,iRef,fconst,rMult,LuIC,Indq,Proc_dB,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM, &
              nB_Tot,ndB_Tot,mqB)
nqRF = nq-nq_
#ifdef _DEBUGPRINT_
if (Process) call RecPrt('BM after RF_Coord',' ',BM,1,size(BM))
#endif

nq_ = nq
call Bond_List(nq,nsAtom,iIter,nIter,Cx,Process,Val,nB,qLbl,fconst,rMult,LuIC,Indq,Proc_dB,iTabBonds,nBonds,iTabAI,mAtoms,mB_Tot, &
               mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB)
nqB = nq-nq_
#ifdef _DEBUGPRINT_
if (Process) call RecPrt('BM after Bond_List',' ',BM,1,size(BM))
#endif

nq_ = nq
call Angle_List(nq,nsAtom,iIter,nIter,Cx,Process,Val,nB,qLbl,iRef,fconst,rMult,LuIC,Indq,Grad_all,iGlow,iGhi,iPrv,Proc_dB, &
                iTabBonds,nBonds,iTabAI,mAtoms,iTabAtoms,nMax,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB,Thr_small)
nqA = nq-nq_
#ifdef _DEBUGPRINT_
if (Process) call RecPrt('BM after Angle_List',' ',BM,1,size(BM))
#endif

nq_ = nq
call Torsion_List(nq,nsAtom,iIter,nIter,Cx,Process,Val,nB,qLbl,iRef,fconst,rMult,LuIC,Indq,iPrv,Proc_dB,iTabBonds,nBonds,iTabAI, &
                  mAtoms,iTabAtoms,nMax,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB)
nqT = nq-nq_
#ifdef _DEBUGPRINT_
if (Process) call RecPrt('BM after Torsion_List',' ',BM,1,size(BM))
#endif

nq_ = nq
call OutOfPlane_List(nq,nsAtom,iIter,nIter,Cx,Process,Val,nB,qLbl,iRef,fconst,rMult,LuIC,Indq,iPrv,Proc_dB,iTabBonds,nBonds, &
                     iTabAI,mAtoms,iTabAtoms,nMax,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB)
nqO = nq-nq_
#ifdef _DEBUGPRINT_
if (Process) call RecPrt('BM after OutOfPlane_List',' ',BM,1,size(BM))
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Get_CurviL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Init_LinAlg()
! Initialization procedure for linear algebra libraries (if needed)

#ifdef _DELAYED_

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iPr
character(len=1024) :: linalg_lib
character(len=8) :: linalg_info

linalg_lib = 'Internal'
call GetEnvf('MOLCAS_LINALG',linalg_lib)
call GetEnvf('MOLCAS_LINALG_INFO',linalg_info)
iPr = 0
call UpCase(linalg_info)
linalg_info = adjustl(linalg_info)
if ((linalg_info(1:1) /= ' ') .and. &
    (linalg_info(1:3) /= 'NO ') .and. &
    (linalg_info(1:4) /= 'OFF ') .and. &
    (linalg_info(1:1) /= '0')) iPr = 1
call Initialize_BLAS(linalg_lib,iPr)

#endif

end subroutine Init_LinAlg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_T_pair_builder

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_init_T_pair_builder,  &
             fmm_close_T_pair_builder, &
             fmm_gen_local_T_pairs,    &
             fmm_gen_nonlocal_T_pairs

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_T_pair_builder(scheme,pair_type)

      USE fmm_T_pair_mould,  ONLY: fmm_init_T_pair_mould
      USE fmm_T_pair_tests,  ONLY: fmm_init_T_pair_tests
      USE fmm_T_buffer,      ONLY: fmm_open_T_buffer

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      INTEGER(INTK), INTENT(IN) :: pair_type

      CALL fmm_init_T_pair_mould(scheme,pair_type)
      CALL fmm_init_T_pair_tests(scheme)
      CALL fmm_open_T_buffer(scheme)

   END SUBROUTINE fmm_init_T_pair_builder

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_close_T_pair_builder(scheme)

      USE fmm_T_pair_mould,  ONLY: fmm_close_T_pair_mould
      USE fmm_T_pair_tests,  ONLY: fmm_close_T_pair_tests
      USE fmm_T_buffer,      ONLY: fmm_close_T_buffer

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme

      CALL fmm_close_T_pair_mould
      CALL fmm_close_T_pair_tests
      CALL fmm_close_T_buffer(scheme)

   END SUBROUTINE fmm_close_T_pair_builder

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_gen_local_T_pairs(LHS,RHS,pair_type)

      USE fmm_T_pair_tests, ONLY: fmm_test_and_buffer_T_pair
      USE fmm_local_search, ONLY: fmm_get_local_paras

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(INOUT) :: LHS, RHS
      INTEGER(INTK),      INTENT(IN)    :: pair_type
      TYPE(gen_mm_paras) :: RHS_local
      TYPE(LHS_RHS_type) :: id
      INTEGER(INTK)      :: weight, i,j, ndim

      weight = 1
      NULLIFY (RHS_local%box_paras, RHS_local%raw_paras)

      SELECT CASE (pair_type)
         CASE (LHS_raw_RHS_raw)
            DO j = 1, SIZE(LHS%raw_paras)
               id%LHS = j
               DO i = 1, SIZE(RHS%raw_paras)
                  id%RHS = i
                  CALL fmm_test_and_buffer_T_pair(LHS,RHS,id,weight)
               END DO
            END DO
         CASE (LHS_box_RHS_box)
            DO j = 1, SIZE(LHS%box_paras)
               CALL fmm_get_local_paras(j,RHS,pair_type,RHS_local,ndim)
               IF (ndim == 0) CYCLE
               id%LHS = j
               DO i = 1, SIZE(RHS_local%box_paras)
                  id%RHS = i
                  CALL fmm_test_and_buffer_T_pair(LHS,RHS_local,id,weight)
               END DO
               IF (ASSOCIATED(RHS_local%box_paras)) THEN
                  DEALLOCATE (RHS_local%box_paras)
                  NULLIFY (RHS_local%box_paras)
               END IF
            END DO
         CASE DEFAULT
            CALL fmm_quit ('cannot reconcile requested T_pair type!')
      END SELECT

   END SUBROUTINE fmm_gen_local_T_pairs

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_gen_nonlocal_T_pairs(LHS,RHS,pair_type)

      USE fmm_T_pair_tests, ONLY: fmm_test_and_buffer_T_pair

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(INOUT) :: LHS, RHS
      INTEGER(INTK),      INTENT(IN)    :: pair_type
      TYPE(LHS_RHS_type) :: id
      INTEGER(INTK)      :: weight, i,j

      weight = 1

      SELECT CASE (pair_type)
         CASE (LHS_raw_RHS_raw)
            DO j = 1, SIZE(LHS%raw_paras)
               id%LHS = j
               DO i = 1, SIZE(RHS%raw_paras)
                  id%RHS = i
                  CALL fmm_test_and_buffer_T_pair(LHS,RHS,id,weight)
               END DO
            END DO
         CASE (LHS_box_RHS_box)
            DO j = 1, SIZE(LHS%box_paras)
               id%LHS = j
               DO i = 1, SIZE(RHS%box_paras)
                  id%RHS = i
                  CALL fmm_test_and_buffer_T_pair(LHS,RHS,id,weight)
               END DO
            END DO
         CASE DEFAULT
            CALL fmm_quit ('cannot reconcile requested T_pair type!')
      END SELECT

   END SUBROUTINE fmm_gen_nonlocal_T_pairs

!-------------------------------------------------------------------------------

END MODULE fmm_T_pair_builder

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine change1_cvb()
      implicit real*8 (a-h,o-z)
      logical changed
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "rls_cvb.fh"

c  Arrays for determinant handling (E_ij) and definition
c  of VB wavefunction :
      changed=.false.
      if(chpcmp_cvb(norb))changed=.true.
      if(chpcmp_cvb(nalf))changed=.true.
      if(chpcmp_cvb(nbet))changed=.true.
      if(chpcmp_cvb(nel))changed=.true.

      if(changed)call touch_cvb('CASPRINT')

      if(chpcmp_cvb(nconf))changed=.true.

      if(.not.changed)call cnfchk_cvb()
      nvb=nvb_cvb(kbasis)

      if(chpcmp_cvb(ndetvb))changed=.true.
      if(chpcmp_cvb(mxion))changed=.true.
      if(chpcmp_cvb(mnion))changed=.true.
      if(changed)call touch_cvb('MEM1')
      return

      entry chop1_cvb()
      if(release(1))call mfreei_cvb(ll(1))
      release(1)=.true.
      release(2)=.false.

c  Dimensions
      call icomb_cvb(norb,nalf,nda)
      call icomb_cvb(norb,nbet,ndb)
      do i=1,nfrag
      call icomb_cvb(norb,nalf_fr(i,1),nda_fr(i,1))
      call icomb_cvb(norb,nbet_fr(i,1),ndb_fr(i,1))
      enddo
      call icomb_cvb(norb-1,nalf-1,n1a)
      call icomb_cvb(norb-1,nbet-1,n1b)
      call icomb_cvb(norb,nalf-1,nam1)
      call icomb_cvb(norb,nbet-1,nbm1)
      ndet = nda*ndb
c  Symmetry of determinant strings :
      call getnci_cvb(ncivb,nel,nalf-nbet,0)
c  Identical indexing arrays may share memory :
      ll(1) = mstacki_cvb(norb*n1a)
      ll(2) = ll(1)
      if(.not.absym(4))ll(2) = mstacki_cvb(norb*n1b)
      ll(3) = mstacki_cvb(norb*nda)
      ll(4) = ll(3)
      if(.not.absym(4))ll(4) = mstacki_cvb(norb*ndb)
      ll(5) = mstacki_cvb(norb*(nam1+1))
      ll(6) = ll(5)
      if(.not.absym(4))ll(6) = mstacki_cvb(norb*(nbm1+1))

c  7 & 8 (PHAFRM & PHBFRM) taken out

      ll(9) = mstackr_cvb(norb*nam1)
      ll(10)= ll(9)
      if(.not.absym(4))ll(10)= mstackr_cvb(norb*nbm1)

c  Determinant dimensioning for VB wavefunction :
      ndavb=0
      ndbvb=0
      naprodvb=1
      nbprodvb=1
      nvbprod=1
      npvb=1
      do ifrag=1,nfrag
      ndavb=ndavb+nda_fr(1,ifrag)+1
      ndbvb=ndbvb+ndb_fr(1,ifrag)+1
      naprodvb=naprodvb*nda_fr(1,ifrag)
      nbprodvb=nbprodvb*ndb_fr(1,ifrag)
      nvbprod=nvbprod*ndetvb_fr(ifrag)
      npvb=npvb*ndetvb_fr(ifrag)
      enddo
      if(nfrag.le.1)then
        naprodvb=0
        nbprodvb=0
        nvbprod=0
      endif

      ll(11)= mstacki_cvb(npvb)
      ll(12)= mstacki_cvb(nda+1)
      ll(13)= mstacki_cvb(npvb)
      ll(14)= mstacki_cvb(ndb+1)
      ll(15)= mstacki_cvb(nconf*noe)
c  16 obsolete (former ioncty)
      ll(17)= mstacki_cvb(ndetvb)
c  Use 7 & 8 for IA12IND / IB12IND
      ll(7)= mstacki_cvb(naprodvb)
      ll(8)= mstacki_cvb(nbprodvb)

      ll(20)= mstacki_cvb(ndetvb)
      ll(21)= mstacki_cvb(ndavb)
      ll(22)= mstacki_cvb(ndetvb)
      ll(23)= mstacki_cvb(ndbvb)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ICISPS()
! Number of dets and combinations
! per symmetry for each type of internal space
!
! ====================
! Output  XISPSM is calculated
! ====================
!
! Jeppe Olsen, Winter 1991
! Last revision April 1991

use Str_Info, only: NOCTYP, STR
use MCLR_Data, only: IACTI, IASTFI, IBSTFI, IDC, MNR1IC, MNR3IC, MXR1IC, MXR3IC, MXSB, MXSOOB, NAELCI, NBELCI, NICISP, XISPSM
use input_mclr, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IATP, IBTP, ICI, IIDC, ISYM, MXCEXP, MXS, MXSOO, NCOMB
real(kind=wp) :: XNCOMB
integer(kind=iwp), allocatable :: LBLTP(:), LCVST(:)

! Local memory
call mma_allocate(LBLTP,nIrrep,Label='LBLTP')
!if ((IDC == 3) .or. (IDC == 4)) call mma_allocate(LCVST,nIrrep,Label='LCVST')
call mma_allocate(LCVST,nIrrep,Label='LCVST')

! Obtain array giving symmetry of sigma v reflection times string symmetry.
!if ((IDC == 3) .or. (IDC == 4)) call SIGVST(LCVST,nIrrep)

MXSB = 0
MXSOOB = 0
MXCEXP = 0
XISPSM(:,:) = Zero
do ICI=1,NICISP
  do ISYM=1,nIrrep
    IATP = IASTFI(ICI)
    IBTP = IBSTFI(ICI)
    !MS write(u6,*) ' NRASDT : ICI IATP IBTP ',ICI,IATP,IBTP
    if (NAELCI(ICI) == NBELCI(ICI)) then
      IIDC = IDC
    else
      IIDC = 1
    end if
    if (IACTI(ICI) == 1) then
      call ZBLTP(ISYM,nIrrep,IIDC,LBLTP,LCVST)
      call NRASDT(MNR1IC(ICI),MXR1IC(ICI),MNR3IC(ICI),MXR3IC(ICI),ISYM,nIrrep,NOCTYP(IATP),NOCTYP(IBTP),Str(IATP)%EL1, &
                  Str(IBTP)%EL1,Str(IATP)%NSTSO,Str(IBTP)%NSTSO,Str(IATP)%EL3,Str(IBTP)%EL3,NCOMB,XNCOMB,MXS,MXSOO,LBLTP)
      XISPSM(ISYM,ICI) = XNCOMB
      MXSOOB = max(MXSOOB,MXSOO)
      MXSB = max(MXSB,MXS)
      MXCEXP = max(MXCEXP,NCOMB)
    !else
    !  XISPSM(ISYM,ICI) = Zero
    end if
  end do
end do
call mma_deallocate(LCVST)
call mma_deallocate(LBLTP)

#ifdef _DEBUGPRINT_
write(u6,*) ' Number of internal combinations per symmetry'
write(u6,*) ' ==========================================='

do ICI=1,NICISP
  if (IACTI(ICI) == 1) then
    write(u6,*) ' Internal CI space ',ICI
    call WRTMAT(XISPSM(1,ICI),1,nIrrep,1,nIrrep)
  end if
end do
write(u6,*) ' Largest CI space                 ',MXCEXP
write(u6,*) ' Largest symmetry block           ',MXSB
write(u6,*) ' Largest Symmetry-type-type block ',MXSOOB
#endif

end subroutine ICISPS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Dresselhaus                                     *
!***********************************************************************

subroutine embPotInit(preparingOutput)
!***********************************************************************
!                                                                      *
! Object: routine to read in an embedding potential on a grid from a   *
!         file.                                                        *
!                                                                      *
! Called from: Seward                                                  *
!              DrvMO                                                   *
!              EmbPotOutput                                            *
!                                                                      *
!     Author: Thomas Dresselhaus                                       *
!                                                                      *
!***********************************************************************

use Embedding_Global, only: embDebug, embPotPath, nEmbGridPoints, outGridPath, outGridPathGiven, embGridCoord, embPotVal, embWeight
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6

implicit none
! Switch to toggle whether only information relevant for the
! output needs to be read
logical(kind=iwp), intent(in) :: preparingOutput

! iunit: Unit of input file (the embedding potential)
! i: Index
integer(kind=iwp) :: iunit, i
integer(kind=iwp), external :: isFreeUnit

embDebug = .false.

! Open the file
iunit = isFreeUnit(11)
if (preparingOutput .and. outGridPathGiven) then
  call molcas_open(iunit,outGridPath)
else
  call molcas_open(iunit,embPotPath)
end if

! TODO MAKE THIS READING PROCEDURE SAFE!!!

! Read in header of the file (just a line with one integer)
read(iunit,*) nEmbGridPoints

! Allocate memory for the grid points, potential and weights
call mma_allocate(embGridCoord,3,nEmbGridPoints,label='embG')
call mma_allocate(embPotVal,nEmbGridPoints,label='embP')
call mma_allocate(embWeight,nEmbGridPoints,label='embW')

! Read in data
do i=1,nEmbGridPoints
  if (preparingOutput .and. outGridPathGiven) then
    read(iunit,*) embGridCoord(:,i)
  else
    read(iunit,*) embGridCoord(:,i),embWeight(i),embPotVal(i)
  end if
end do

close(iunit)

if (embDebug) then
  write(u6,*) '---------------------------------------------------'
  write(u6,*) '---------------------------------------------------'
  write(u6,*) 'Potential has been read in. Coords:'
  do i=1,nEmbGridPoints
    if (mod(i,587) == 0) then
      write(u6,*) i,embGridCoord(:,i)
    end if
  end do
  write(u6,*) '---------------------------------------------------'
  write(u6,*) 'Potential value, weight'
  do i=1,nEmbGridPoints
    if (mod(i,587) == 0) then
      write(u6,*) i,embPotVal(i),embWeight(i)
    end if
  end do
  write(u6,*) '---------------------------------------------------'
  write(u6,*) '---------------------------------------------------'
end if

return

end subroutine embPotInit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Name_Full(Element)

use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

#include "intent.fh"

implicit none
character(len=2), intent(_OUT_) :: Element(*)
integer(kind=iwp) :: i, nAtMM, nAtom
logical(kind=iwp) :: Found
character(len=LenIn), allocatable :: LabMM(:)

call Get_nAtoms_All(nAtom)
call Get_Name_All(Element)

call Qpg_cArray('MMO Labels',Found,nAtMM)
if (Found) then
  nAtMM = nAtMM/LENIN
  call mma_allocate(LabMM,nAtMM,label='MMO Labels')
  call Get_cArray('MMO Labels',LabMM,LENIN*nAtMM)
  do i=1,nAtMM
    Element(nAtom+i) = LabMM(i)(1:2)
    if (Element(nAtom+i)(2:2) == '_') Element(nAtom+i)(2:2) = ' '
  end do
  call mma_deallocate(LabMM)
end if

end subroutine Get_Name_Full

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_WrRstC(iPass)
C
C     Purpose: write global restart info to disk.
C
      Implicit None
      Integer iPass
#include "cholesky.fh"
#include "choglob.fh"
#include "cho_para_info.fh"

      Integer iTmp

      Real*8 c1, c2, w1, w2

      Call Cho_Timer(c1,w1)
      If (Cho_Real_Par) Then
         Call Cho_P_IndxSwp()
         Call iSwap(nSym,NumCho,1,NumCho_G,1)
         iTmp = LuRst
         LuRst = LuRst_G
         Call Cho_WrRstC(iPass)
         LuRst = iTmp
         Call iSwap(nSym,NumCho,1,NumCho_G,1)
         Call Cho_P_IndxSwp()
      Else
         Call Cho_WrRstC(iPass)
      End If
      Call Cho_Timer(c2,w2)
      tMisc(1,3)=tMisc(1,3)+c2-c1
      tMisc(2,3)=tMisc(2,3)+w2-w1

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FockTwo_Drv(nSym,nBas,nAux,Keep,DLT,DSQ,FLT,nFLT,ExFac,nBMX)

use Fock_util_interface, only: CHOras_drv
use Fock_util_global, only: ALGO
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(8), nAux(8), Keep(8), nFLT, nBMX
real(kind=wp), intent(in) :: DLT(*), DSQ(*), ExFac
real(kind=wp), intent(inout) :: FLT(nFLT)
integer(kind=iwp) :: LBUF
real(kind=wp) :: CMO_DUMMY(1)
logical(kind=iwp) :: DoCholesky, GenInt
type(DSBA_Type) :: WFSQ(1)
real(kind=wp), allocatable :: Temp(:), W1(:), W2(:)

!                                                                      *
!***********************************************************************
!                                                                      *
! nAux is the number of occupied orbitals
GenInt = .false.
DoCholesky = .false.
if (ALGO == 0) GenInt = .true. ! use GenInt to regenerate integrals

call DecideOnCholesky(DoCholesky)

call Allocate_DT(WFSQ(1),nBas,nBas,nSym)
WFSQ(1)%A0(:) = Zero

if ((.not. DoCholesky) .or. GenInt) then
  call mma_allocate(W2,NBMX**2,Label='W2')
end if

call mma_allocate(Temp,nFlt,Label='Temp')
Temp(:) = Zero

call mma_maxDBLE(LBUF)
!                                                                      *
!***********************************************************************
!                                                                      *
! Standard building of the Fock matrix from Two-el integrals

if (.not. DoCholesky) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call mma_allocate(W1,LBUF,Label='W1')

  if (LBUF < 1+NBMX**2) then
    write(u6,*) ' FockTwo_Drv Error: Too little memory remains for the call to FOCKTWO.'
    write(u6,*) ' Largest allocatable array size LBUF=',LBUF
    write(u6,*) ' Max nr of bf in any symmetry,  NBMX=',NBMX
    write(u6,*) ' Required minimum size     1+NBMX**2=',1+NBMX**2
    write(u6,*) '    (All in Real*8-size words)'
    call ABEND()
  end if

  call FOCKTWO(nSym,nBas,nAux,Keep,DLT,DSQ,Temp,nFlt,WFSQ(1)%A0,LBUF,W1,W2,ExFac)

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Building of the Fock matrix regenerating the integrals on the fly

else if (DoCholesky .and. GenInt) then ! save some space for GenInt
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  LBUF = max(LBUF-LBUF/10,0)
  call mma_allocate(W1,LBUF,Label='W1')

  if (LBUF < 1+NBMX**2) then
    write(u6,*) ' FockTwo_Drv Error: Too little memory remains for the call to FOCKTWO.'
    write(u6,*) ' Largest allocatable array size LBUF=',LBUF
    write(u6,*) ' Max nr of bf in any symmetry,  NBMX=',NBMX
    write(u6,*) ' Required minimum size     1+NBMX**2=',1+NBMX**2
    write(u6,*) '    (All in Real*8-size words)'
    call ABEND()
  end if

  call FOCKTWO(nSym,nBas,nAux,Keep,DLT,DSQ,Temp,nFlt,WFSQ(1)%A0,LBUF,W1,W2,ExFac)

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !   Building of the Fock matrix directly from Cholesky vectors

else if (DoCholesky .and. (.not. GenInt)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! CMO_DUMMY is required call argument of choras_drv:
  ! (Not used, see logical flags in choras_drv)
  ! subroutine choras_drv(nSym,nBas,nOcc,DSQ,DLT,FLT,ExFac,WFSQ,CMO)
  call CHOras_drv(nSym,nBas,nAux,DSQ,DLT,Temp,ExFac,WFSQ,CMO_DUMMY)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call DaXpY_(nFlt,One,Temp,1,FLT,1)

call mma_deallocate(Temp)
if (allocated(W1)) call mma_deallocate(W1)
if (allocated(W2)) call mma_deallocate(W2)
call Deallocate_DT(WFSQ(1))

return

end subroutine FockTwo_Drv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKCXA(NSYM,NOSH,NCXA,TRA,CXA)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TRA(NCXA),CXA(NCXA)
      DIMENSION NOSH(NSYM)
      ISTA=1
      DO I=1,NSYM
        NDIMEN=NOSH(I)
        IF(NDIMEN.GT.0) THEN
          CALL MKCXAL(NDIMEN,TRA(ISTA),CXA(ISTA))
          ISTA=ISTA+NDIMEN**2
        END IF
      END DO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine tpidx2tpstr(TYPEINDEX,TYPESTRING,NB)

use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: TYPEINDEX(*), NB
character, intent(_OUT_) :: TYPESTRING(*)
integer(kind=iwp) :: i

do i=1,NB
  select case (TYPEINDEX(i))
    case (1)
      TYPESTRING(i) = 'F'
    case (2)
      TYPESTRING(i) = 'I'
    case (3)
      TYPESTRING(i) = '1'
    case (4)
      TYPESTRING(i) = '2'
    case (5)
      TYPESTRING(i) = '3'
    case (6)
      TYPESTRING(i) = 'S'
    case (7)
      TYPESTRING(i) = 'D'
  end select
end do

end subroutine tpidx2tpstr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,2020, Roland Lindh                                *
!***********************************************************************

function DblFac(n)
!***********************************************************************
!                                                                      *
! Object: to compute the double factorial of n.                        *
!                                                                      *
! Called from: NrmSph                                                  *
!                                                                      *
! Calling    : None                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: DblFac
integer(kind=iwp), intent(in) :: n
integer(kind=iwp) :: i
integer(kind=iwp), parameter :: cache_len = 10
real(kind=wp), parameter :: cache(cache_len) = [1.0_wp,2.0_wp,3.0_wp,8.0_wp,15.0_wp,48.0_wp,105.0_wp,384.0_wp,945.0_wp,3840.0_wp]

! ideally, if n < 0 this is undefined, but in molcas it is expected to be 1
if (n < 1) then
  DblFac = One
else if (n <= cache_len) then
  ! use cached values whenever possible
  DblFac = cache(n)
else
  DblFac = One
  do i=n,2,-2
    DblFac = DblFac*real(i,kind=wp)
  end do
end if

return

end function DblFac

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3reaintsta (wrk,wrksize)
c
c     this routine read integral file INTSTA (reorg), which contains
c     following integrals: foka,fokb,
c     <kl||ij>aaaa,<kl||ij>bbbb,<kl||ij>abab - naplano
c     <ka||ij>aaaa,<ka||ij>bbbb,<ka||ij>abab,<ka||ij>baab
c     <ab||ij>aaaa,<ab||ij>bbbb,<ab||ij>abab
c
c     two electron integrals are readed to their fix files,
c     foka,fokb are readed to N,P help files
c
c     use and destroy : N,P
c
#include "t31.fh"
#include "t32.fh"
#include "wrk.fh"
c
c     help variables
c
       integer lunsta,rc
c
c*    open INTSTA file
       lunsta=1
       if (iokey.eq.1) then
c      Fortran IO
c       open (unit=lunsta,file='INTSTA',form='unformatted')
       call molcas_binaryopen_vanilla(lunsta,'INTSTA')
c
       else
c      MOLCAS IO
       call daname (lunsta,'INTSTA')
       daddr(lunsta)=0
       end if
c
c1    read foka to N
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possn0,mapdn,mapin,rc)
c
c2    read fokb to P
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possp0,mapdp,mapip,rc)
c
c
c3    read <kl||ij>aaaa to W23 - naplano
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw230,mapdw23,mapiw23,rc)
c
c4    read <kl||ij>bbbb to W23 - naplano
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw230,mapdw23,mapiw23,rc)
c
c5    read <kl||ij>abab to W23 - naplano
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw230,mapdw23,mapiw23,rc)
c
c
c6    read <ie||mn>aaaa to W11
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw110,mapdw11,mapiw11,rc)
c
c7    read <ie||mn>bbbb to W12
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw120,mapdw12,mapiw12,rc)
c
c8    read <ie||mn>abab to W13
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw130,mapdw13,mapiw13,rc)
c
c9    read <ie||mn>baab to W14
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw140,mapdw14,mapiw14,rc)
c
c
c10   read <ab||ij>aaaa to W21
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw210,mapdw21,mapiw21,rc)
c
c11   read <ab||ij>bbbb to W22
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw220,mapdw22,mapiw22,rc)
c
c12   read <ab||ij>abab to W23
       call cct3_getmediate (wrk,wrksize,
     & lunsta,possw230,mapdw23,mapiw23,rc)
c
c*    close INTSTA file
c
       if (iokey.eq.1) then
c      Fortran IO
       close (lunsta)
c
       else
c      MOLCAS IO
       call daclos (lunsta)
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Valera Veryazov                                  *
************************************************************************
      Subroutine XMatReader(iZMUnit,LuWr,nAtoms,nXAtoms,nBasis,
     &  nAskAtoms, nxbas,xb_label,xb_bas,iErr)
      Implicit Integer (i-n)
      Implicit Real*8 (a-h,o-z)
#include "g_zmatconv.fh"
      Character*80 Line, Blank
      Character*3  Command
      Character*24 Words(7)
        character *(*) xb_label(*)
        character *(*) xb_bas(*)
       xb_label(1)=' '
       xb_bas(1)=' '
       nxbas=1
* nAtoms : Total number of real atoms. Include X dummy atoms: NAT(i)= 0
* nXAtoms: Total number of ghost (Z) atoms:                   NAT(i)=-1
* nBasis : Nummer of atom types requiring Basis Set
C  ***  nAskAtoms.EQ.-1  =>  Seward ZMAT input  => Use "End of"
C  ***  nAskAtoms.NE.-1  =>  GateWay ZMAT input => Use nAskAtoms

      iErr = 0
      Blank = ' '
      nAtoms  = 0
      nXAtoms = 0
      nBasis  = 0
      Do i = 1, 100 ! MaxNat
        BasReq(i) = .False.
      EndDo
      Do i = 1, MaxAtoms
        Symbols(i) = '     '
        NAT(i) = 0
        iZmat(i,1) = 0
        iZmat(i,2) = 0
        iZmat(i,3) = 0
        Zmat(i,1) = 0.0d0
        Zmat(i,2) = 0.0d0
        Zmat(i,3) = 0.0d0
      EndDo

* Read Line (or COMMAND)
10    If ((nAtoms + nXAtoms).EQ.nAskAtoms) GoTo 100
      Read(iZMUnit,'(A)',Err=9906,End=9999) Line
      If ( Line(1:1).EQ.'*' ) GoTo 10
      If ( Line.EQ.Blank ) GoTo 100
      Command = Line(1:3)
      Call UpCase(Command)
      If (Command.EQ.'END') GoTo 100
      iErr = 0
      NA = 0
      NB = 0
      NT = 0
      Dist  = 0.0d0
      Beta  = 0.0d0
      Theta = 0.0d0

*  Here we read number or a file.
      read(Line,*,err=666,end=666) NA
      IreadHere=1
      goto 667
666   continue
      Ireadhere=0
      iXU=iZMUnit+1
      call molcas_open(iXU,line)
      read(iXU,*) NA
667   continue
        if(Ireadhere.eq.1) then
            Read(iZMUnit,'(A)',Err=9906,End=9999) Line
        else
            Read(iXU,'(A)',Err=9906,End=9999) Line
        endif
      do i=1,NA
        if(Ireadhere.eq.1) then
            Read(iZMUnit,'(A)',Err=9906,End=9999) Line
        else
            Read(iXU,'(A)',Err=9906,End=9999) Line
        endif
      Call Pick_Words(Line,4,Nwords,Words)
      If (Nwords.LT.4) GoTo 9993
      Call FoundAtomicNumber(LuWr,Words(1),NAtom,iErr)
      If (iErr.NE.0) GoTo 9998
      If (NAtom.GE. 0) nAtoms  = nAtoms  + 1
      If (NAtom.EQ.-1) nXAtoms = nXAtoms + 1
      NAT(nAtoms + nXAtoms) = NAtom
      Symbols(nAtoms + nXAtoms) = Trim(Words(1))
      If (NAtom.GT. 0) BasReq(NAtom)=.True.

      Call Get_dNumber(Words(2),Dist,iErr)
      Zmat(nAtoms + nXAtoms, 1) = Dist
      Call Get_dNumber(Words(3),Dist,iErr)
      Zmat(nAtoms + nXAtoms, 2) = Dist
      Call Get_dNumber(Words(4),Dist,iErr)
      Zmat(nAtoms + nXAtoms, 3) = Dist

      enddo
      if(Ireadhere.eq.0) close(iXU)
* Pre-check Basis Set consistency  BasReq: Atom requiring Basis Set
100   nBasis = 0
      Do i = 1, 100
        If (BasReq(i)) nBasis = nBasis + 1
      EndDo

      GoTo 9999

9906  iErr = 1
      Write(LuWr,*) ' [XMatReader]: Unable to read x-matrix file !'
      GoTo 9999

9993  iErr = 1
      Write(LuWr,*) ' [XMatReader]: X-Matrix incomplete in line'
      Write(LuWr,*) '               ',Line
      GoTo 9999

9998  iErr = 1
      Write(LuWr,*) ' [XMatReader]: Error in line'
      Write(LuWr,*) '               ',Line
      GoTo 9999

9999  Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CheckAllOverlapIntegrals(doPrint,Tol2C,
     &                                        MAE,AB_MAE,
     &                                        MRNrm,AB_MRNrm)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: compare exact and fitted overlap for all atom pairs, i.e.
C              sum_J C(uv,J)*\int J(r)dr - S(uv)
C              The routine does NOT judge whether the MAE (or another
C              measure) is too large. However, it does check that
C              overlaps corresponding to 2C auxiliary functions are
C              represented exactly (to within the input tolerance
C              Tol2C).
C
C     Input:
C        doPrint  -- if true, print info
C        Tol2C    -- error tolerance for overlaps corresponding to
C                    2C auxiliary functions
C     Output:
C        MAE      -- max abs error
C        AB_MAE   -- atom pair corresponding to MAE
C        MRNrm    -- max relative error norm
C        AB_MRNrm -- atom pair corresponding to MRNRm
C
      Implicit None
      Logical doPrint
      Real*8  Tol2C
      Real*8  MAE
      Integer AB_MAE
      Real*8  MRNrm
      Integer AB_MRNrm
#include "WrkSpc.fh"
#include "localdf.fh"
#include "ldf_atom_pair_info.fh"

      Character*28 SecNam
      Parameter (SecNam='LDF_CheckAllOverlapIntegrals')

      Real*8   dDot_, Cho_dSumElm, LDF_AtomicDistance
      external ddot_, Cho_dSumElm, LDF_AtomicDistance

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair_wLD, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair_wLD, LDF_nBasAux_Pair

      Integer ip_Stat, l_Stat
      Integer ip_SBlocks
      Integer ip_AuxIntVec
      Integer AB
      Integer A, B
      Integer nAB
      Integer ip_C, l_C, l_Cmax
      Integer ipS
      Integer n2CErr, irc
      Integer AB_MAE_2CT

      Real*8  Nrm, Sm
      Real*8  SNrm, SSm
      Real*8  RMS, RNrm
      Real*8  MAE_2C, MAE_2CT

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      MAE=-9.9d9
      AB_MAE=-1
      MRNrm=-9.9d9
      AB_MRNrm=-1
      MAE_2C=0.0d0
      MAE_2CT=0.0d0
      AB_MAE_2CT=-1
      l_Cmax=0
      Do AB=1,NumberOfAtomPairs
         l_Cmax=max(l_Cmax,LDF_nBas_Atom(AP_Atoms(1,AB))
     &                    *LDF_nBas_Atom(AP_Atoms(2,AB))
     &                    *LDF_nBasAux_Pair_wLD(AB))
      End Do
      If (l_Cmax.lt.1) Return
      Call GetMem('Coeff','Allo','Real',ip_C,l_Cmax)
      Call LDF_AllocateBlockMatrix('Ovl',ip_SBlocks)
      Call LDF_GetBlockedOverlapMatrix(0,ip_SBlocks)
      Call LDF_AllocateAuxBasVector('Int',ip_AuxIntVec)
      Call LDF_ComputeAuxInt(ip_AuxIntVec)
      l_Stat=6
      Call GetMem('S_Stat','Allo','Real',ip_Stat,l_Stat)
      If (doPrint) Call Cho_Head('LDF Overlap Check','-',80,6)
      n2CErr=0
      Do AB=1,NumberOfAtomPairs
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
         l_C=nAB*LDF_nBasAux_Pair_wLD(AB)
         If (l_C.gt.0) Then
            Call LDF_CIO_ReadC_wLD(AB,Work(ip_C),l_C)
            ipS=iWork(ip_SBlocks-1+AB)
            If (doPrint) Then
               SNrm=sqrt(dDot_(nAB,Work(ipS),1,Work(ipS),1))
               SSm=Cho_dSumElm(Work(ipS),nAB)
            End If
            Call LDF_ComputeOverlapFromAuxInt(AB,
     &                                1.0d0,l_C,Work(ip_C),ip_AuxIntVec,
     &                                   -1.0d0,nAB,Work(ipS))
            If (LDF2) Then
               Call LDF_Check2COverlap(.False.,AB,nAB,Work(ipS),Tol2C,
     &                                 MAE_2C,irc)
               n2CErr=n2CErr+irc
               If (MAE_2C.gt.MAE_2CT) Then
                  MAE_2CT=MAE_2C
                  AB_MAE_2CT=AB
               End If
            End If
            If (nAB.lt.1) Then
               Call Cho_dZero(Work(ip_Stat),l_Stat)
               Nrm=0.0d0
               RMS=0.0d0
               Sm=0.0d0
            Else
               ipS=iWork(ip_SBlocks-1+AB)
               Call Statistics(Work(ipS),nAB,Work(ip_Stat),
     &                         1,2,3,4,5,6,0)
               Nrm=dDot_(nAB,Work(ipS),1,Work(ipS),1)
               RMS=sqrt(Nrm/dble(nAB))
               Nrm=sqrt(Nrm)
               Sm=Cho_dSumElm(Work(ipS),nAB)
            End If
            If (SNrm.gt.0.0d0) Then
               RNrm=Nrm/SNrm
            Else
               RNrm=0.0d0
            End If
            If (doPrint) Then
               Write(6,'(/,2X,A,10X,I10,2X,A,2I10,2X,A,1P,D20.10)')
     &         'Atom pair.........',AB,
     &         'Atoms.............',A,B,
     &         'Atomic distance...',LDF_AtomicDistance(A,B)
               Write(6,'(2X,A,5X,I15,2X,A,5X,I15,A)')
     &         'Dimension.........',nAB,
     &         'Auxiliary basis...',
     &         LDF_nBasAux_Pair(AB),' (w/o LinDep)'
               Write(6,'(1P,2(2X,A,D20.10))')
     &         'Norm of S.........',SNrm,
     &         'Sum of S..........',SSm
               Write(6,'(1P,2(2X,A,D20.10))')
     &         'Norm of error.....',Nrm,
     &         'Sum of error......',Sm
               Write(6,'(1P,2(2X,A,D20.10))')
     &         'Average error.....',Work(ip_Stat),
     &         'Standard deviation',Work(ip_Stat+5)
               Write(6,'(1P,2(2X,A,D20.10))')
     &         'Minimum error.....',Work(ip_Stat+2),
     &         'Maximum error.....',Work(ip_Stat+3)
               Write(6,'(1P,2(2X,A,D20.10))')
     &         'RMS error.........',RMS,
     &         'Abs average error.',Work(ip_Stat+1)
               Write(6,'(1P,2(2X,A,D20.10))')
     &         'Relative error nrm',RNrm,
     &         'Maximum abs error.',Work(ip_Stat+4)
               Write(6,'(1P,2X,A,D20.10)')
     &         'Max abs 2C error..',MAE_2C
               Call xFlush(6)
            End If
            If (Work(ip_Stat+4).gt.MAE) Then
               MAE=Work(ip_Stat+4)
               AB_MAE=AB
            End If
            If (RNrm.gt.MRNrm) Then
               MRNrm=RNrm
               AB_MRNrm=AB
            End If
         End If
      End Do
      Call GetMem('S_Stat','Free','Real',ip_Stat,l_Stat)
      Call LDF_DeallocateAuxBasVector('Int',ip_AuxIntVec)
      Call LDF_DeallocateBlockMatrix('Ovl',ip_SBlocks)
      Call GetMem('Coeff','Free','Real',ip_C,l_Cmax)

      If (doPrint) Then
         Write(6,*)
         If (AB_MAE.gt.0) Then
            Write(6,'(2X,A,1P,D20.10,1X,A,I10,2X,A,D20.10)')
     &      'Max abs error..........',MAE,'@AB=',AB_MAE,'Distance=',
     &      LDF_AtomicDistance(AP_Atoms(1,AB_MAE),AP_Atoms(2,AB_MAE))
         End If
         If (AB_MRNrm.gt.0) Then
            Write(6,'(2X,A,1P,D20.10,1X,A,I10,2X,A,D20.10)')
     &     'Max relative error norm',MRNrm,'@AB=',AB_MRNrm,'Distance=',
     &     LDF_AtomicDistance(AP_Atoms(1,AB_MRNrm),AP_Atoms(2,AB_MRNrm))
         End If
         If (AB_MAE_2CT.gt.0) Then
            Write(6,'(2X,A,1P,D20.10,1X,A,I10,2X,A,D20.10)')
     &      'Max abs 2C error.......',MAE_2CT,'@AB=',AB_MAE_2CT,
     &      'Distance=',
     &      LDF_AtomicDistance(AP_Atoms(1,AB_MAE_2CT),
     &                         AP_Atoms(2,AB_MAE_2CT))
         End If
         Write(6,'(2X,A,10X,I10,16X,A,1P,D20.10)')
     &   'Number of 2C errors....',n2CErr,'Tolerance=',Tol2C
         Call xFlush(6)
      End If

      If (n2CErr.gt.0) Then
         Call WarningMessage(2,SecNam//': too large 2C overlap errors')
         Write(6,'(A,1P,D20.10,2X,A,I10)')
     &   'Tolerance=',Tol2C,
     &   'Number of errors=',n2CErr
         Call LDF_Quit(1)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_ComputeOverlapFromAuxInt(AB,
     &                                        alpha,l_C,C,ip_AuxIntVec,
     &                                        beta,l_S,S)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: compute fitted overlap for atom pair AB, i.e.
C              S(uA vB) := alpha * sum_J C(uA vB,J) * \int J(r)dr
C                         + beta * S(uA vB)
C
      Implicit None
      Integer AB
      Real*8  alpha
      Integer l_C
      Real*8  C(l_C)
      Integer ip_AuxIntVec
      Real*8  beta
      Integer l_S
      Real*8  S(l_S)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

#if defined (_DEBUGPRINT_)
      Character*28 SecNam
      Parameter (SecNam='LDF_ComputeOverlapFromAuxInt')
#endif

      Integer  LDF_nAtom, LDF_nBas_Atom, LDF_nBasAux_Atom
      External LDF_nAtom, LDF_nBas_Atom, LDF_nBasAux_Atom

      Integer A, B
      Integer nAB
      Integer ipC
      Integer ipJ
      Integer M

      Integer i, j
      Integer AP_Atoms
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      If (nAB.lt.1) Return
#if defined (_DEBUGPRINT_)
      If (nAB.gt.l_S) Then
         Call WarningMessage(2,SecNam//': dimension mismatch [1]')
         Call LDF_Quit(1)
      End If
#endif

      If (beta.ne.1.0d0) Then
         If (abs(beta).lt.1.0d-24) Then
            Call fZero(S,nAB)
         Else
            Call dScal_(nAB,beta,S,1)
         End If
      End If
      ipC=1
      ipJ=iWork(ip_AuxIntVec-1+A)
      M=LDF_nBasAux_Atom(A)
      Call dGeMV_('N',nAB,M,
     &           alpha,C(ipC),nAB,Work(ipJ),1,
     &           1.0d0,S,1)
      If (B.ne.A) Then
         ipC=ipC+nAB*M
         ipJ=iWork(ip_AuxIntVec-1+B)
         M=LDF_nBasAux_Atom(B)
         Call dGeMV_('N',nAB,M,
     &              alpha,C(ipC),nAB,Work(ipJ),1,
     &              1.0d0,S,1)
      End If
      If (AP_2CFunctions(1,AB).gt.0) Then
         ipC=ipC+nAB*M
         ipJ=iWork(ip_AuxIntVec-1+LDF_nAtom()+AB)
         M=AP_2CFunctions(1,AB)
         Call dGeMV_('N',nAB,M,
     &              alpha,C(ipC),nAB,Work(ipJ),1,
     &              1.0d0,S,1)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Check2COverlap(doPrint,AB,l_S,S,Tol2C,MAE,irc)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: check that overlaps corresponding to 2C fitting functions
C              are represented to within the tolerance Tol2C. On exit,
C              irc is the number of too large errors and MAE is the max
C              abs 2C error.
C
      Implicit None
      Logical doPrint
      Integer AB
      Integer l_S
      Real*8  S(l_S)
      Real*8  Tol2C
      Real*8  MAE
      Integer irc
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_info.fh"
#include "ldf_atom_pair_info.fh"

      Character*18 SecNam
      Parameter (SecNam='LDF_Check2COverlap')

      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom

      Integer A, B
      Integer nAB
      Integer nSA, nSB
      Integer ip_Offset, l_Offset
      Integer iSA, iSB
      Integer iShellA
      Integer i2C
      Integer iA, iB
      Integer ipA, ip

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_2CFunctions
      Integer List2C
      Integer iOff
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      List2C(i,j)=iWork(AP_2CFunctions(2,AB)-1+4*(j-1)+i)
      iOff(i,j)=iWork(ip_Offset-1+nSA*(j-1)+i)

      irc=0
      MAE=0.0d0
      If (AP_2CFunctions(1,AB).lt.1) Return

      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      If (l_S.lt.nAB) Then
         Call WarningMessage(2,SecNam//': l_S < nAB')
         Call LDF_Quit(1)
      End If

      nSA=LDF_nShell_Atom(A)
      nSB=LDF_nShell_Atom(B)
      l_Offset=nSA*nSB
      Call GetMem('Offset','Allo','Inte',ip_Offset,l_Offset)
      Call LDF_uvOffset(AB,nSA,nSB,iWork(ip_Offset))
      ipA=LDF_lShell_Atom(A)-1
      Do i2C=1,AP_2CFunctions(1,AB)
         iSA=List2C(1,i2C)
         iA=List2C(2,i2C)
         iSB=List2C(3,i2C)
         iB=List2C(4,i2C)
         iShellA=iWork(ipA+iSA)
         ip=iOff(iSA,iSB)+nBasSh(iShellA)*(iB-1)+iA
         If (abs(S(ip)).gt.Tol2C) Then
            irc=irc+1
         End If
         MAE=max(MAE,abs(S(ip)))
      End Do
      Call GetMem('Offset','Free','Inte',ip_Offset,l_Offset)

      If (doPrint) Then
         Write(6,'(2X,A,I10,2X,A,1P,D20.10)')
     &   'AB=',AB,'Max abs 2C overlap error=',MAE
         Call xFlush(6)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Markus P. Fuelscher                              *
!               1991, Per Ake Malmqvist                                *
!***********************************************************************

subroutine SORT2B(iBin,nInts,iOrd,lSrtA,SrtArr,IOStk,lStk,nStk)
!***********************************************************************
!                                                                      *
!     Purpose: Store the sorted integrals on disk.                     *
!              Every record that is written contains a header of       *
!              length lTop which contains the number of integrals      *
!              on the record and its ordering number.                  *
!                                                                      *
!     Called from: Sort2                                               *
!                                                                      *
!     Calls to : PkI4,PkR8,DaFile                                      *
!                                                                      *
!     Calling parameters:                                              *
!     iBin   : Slice number                                            *
!     nInts  : no. of 2el integrals in slice                           *
!     iOrd   : ordering number of record                               *
!     SrtArr : Work space to keep the 2el integrals                    *
!                                                                      *
!     local data declarations:                                         *
!     PkVal  : I/O buffer contains packed integral values              *
!     IntLen : this buffer contains the length of the integrals        *
!              to be pack into the next buffer                         *
!                                                                      *
!*** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****

use sort_data, only: iDaTwo, iDVBin, lStRec, lTop, LuTwo, mDaTwo, nRec
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: iBin, nInts, lSrtA, lStk
integer(kind=iwp), intent(inout) :: iOrd, IOStk(lStk), nStk
real(kind=wp), intent(in) :: SrtArr(lSrtA)
integer(kind=iwp) :: iEnd, IntLen(4*lStRec), iOpt, iOptIO, iSave, iStart, iStk, jStk, kStk, llVRec, lVRec, mxVRec, nSave, nSaved
real(kind=wp) :: PkVal(lStRec), Dum(1)
#ifdef _DEBUGPRINT_
#include "print.fh"
integer(kind=iwp) :: iPrint, iRout
#endif

!----------------------------------------------------------------------*
!     pick up the print level                                          *
!----------------------------------------------------------------------*

#ifdef _DEBUGPRINT_
iRout = 86
iPrint = nPrint(iRout)
if (iPrint > 5) then
  write(u6,*) ' >>> Enter SORT2B <<<'
  write(u6,*) ' iBin  ',iBin
  write(u6,*) ' lSrtA ',lSrtA
  write(u6,*) ' nInts ',nInts
end if
if (iPrint >= 10) then
  call iVcPrt('stack of free records',' ',IOStk,nStk)
end if
#endif

!----------------------------------------------------------------------*
!     Transfer integrals from the sorting area to I/O buffer           *
!----------------------------------------------------------------------*
nRec(iBin) = 0
kStk = 0
nSaved = 0
iOpt = iDVBin(4,iBin)
do while (nSaved < nInts)
  iStart = nSaved+1
  iEnd = min(nSaved+4*lStRec,nInts)
  call R8Len(iOpt,1+iEnd-iStart,SrtArr(iStart),IntLen)
  mxVRec = (lStRec-lTop-1)*RtoB
  nSave = 0
  lVRec = 0
  do iSave=1,1+iEnd-iStart
    lVRec = lVRec+IntLen(iSave)
    if (lVRec < mxVRec) nSave = iSave
  end do
  if (nSave == 0) then
    write(u6,*)
    write(u6,'(2X,A,I3.3,A)') '*** Error in SORT2B ***'
    write(u6,'(2X,A)') 'nSave = 0'
    write(u6,*)
    call xFlush(u6)
    call Abend()
  end if
  lVRec = 0
  do iSave=1,nSave
    lVRec = lVRec+IntLen(iSave)
  end do
  if (lVRec > mxVRec) then
    write(u6,*)
    write(u6,'(2X,A,I3.3,A)') '*** Error in SORT2B ***'
    write(u6,'(2X,A)') 'An inconsistency has been deteced'
    write(u6,'(2X,A)') 'lVRec > mxVRec '
    write(u6,*)
    call xFlush(u6)
    call Abend()
  end if
  !--------------------------------------------------------------------*
  !   Pack integrals                                                   *
  !--------------------------------------------------------------------*
  call PKR8(iOpt,nSave,llVRec,SrtArr(iStart),PkVal(lTop+1))
  if (llVRec /= lVRec) then
    write(u6,*)
    write(u6,'(2X,A,I3.3,A)') '*** Error in SORT2B ***'
    write(u6,'(2X,A)') 'An inconsistency has been deteced'
    write(u6,'(2X,A)') 'llVBin # lVRec'
    write(u6,*)
    call xFlush(u6)
    call Abend()
  end if
  iOrd = iOrd+1
  PkVal(1) = 0
  PkVal(2) = iOrd
  PkVal(3) = nSave
  PkVal(4) = iOpt
  !--------------------------------------------------------------------*
  !   Write out the new record                                         *
  !--------------------------------------------------------------------*
  if (kStk < nStk) then
    ! use an old record, get address from IOStk
    kStk = kStk+1
    iDaTwo = IOStk(kStk)
  else
    iDaTwo = mDaTwo
    iOptIO = 0
    Dum(1) = Zero
    call dDAFILE(LuTwo,iOptIO,Dum,lStRec,mDaTwo)
  end if
# ifdef _DEBUGPRINT_
  if (iPrint >= 10) then
    write(u6,*) ' write record: iOrd,iDaTwo ',iOrd,iDaTwo
  end if
# endif

  ! Write out the buffer

  iOptIO = 1
  call dDAFILE(LuTwo,iOptIO,PkVal,lStRec,iDaTwo)

  nRec(iBin) = nRec(iBin)+1
  nSaved = nSaved+nSave

end do
!----------------------------------------------------------------------*
!     cleanup the stack of Record addresses                            *
!----------------------------------------------------------------------*
jStk = 0

! Do this only if the number of records was reduced

if (kStk < nStk) then

  ! Move unused record addresses to the start of IOStk!

  do iStk=kStk+1,nStk
    jStk = jStk+1
    IOStk(jStk) = IOStk(iStk)
  end do
end if
nStk = jStk

!----------------------------------------------------------------------*
!     exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine SORT2B

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Ignacio Fdez. Galvan                             *
************************************************************************

      subroutine Write_Input()
      use stdalloc
      implicit none
      integer :: LU,nAtoms,i
      real*8, allocatable :: Coord(:,:)
      character(len=2), allocatable :: Symbol(:)
      integer, external :: IsFreeUnit
#include "constants2.fh"

      ! read data from RUNFILE
      call Get_nAtoms_All(nAtoms)
      call mma_Allocate(Coord,3,nAtoms,label='Coord')
      call mma_Allocate(Symbol,nAtoms,label='Symbol')
      call Get_Coord_All(Coord,nAtoms)
      call Get_Name_All(Symbol)

      ! write interface input file
      LU=IsFreeUnit(11)
      call Molcas_Open(LU,'INPUT')
      write(LU,100) '[XYZ]'
      write(LU,101) nAtoms
      write(LU,100) 'angstrom'
      do i=1,nAtoms
        write(LU,102) Symbol(i),Angstrom*Coord(:,i)
      end do
      close(LU)

      ! clean up
      call mma_Deallocate(Coord)
      call mma_Deallocate(Symbol)
      return

100   format(A)
101   format(I6)
102   format(A2,1X,3F20.12)
      end subroutine Write_Input

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2000, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PGet1_Aces(PAO,ijkl,nPAO,iCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp,DSO,DSO_Var,DSSO,DSSO_Var,nDSO,Gmma,nGamma,iSO2cI,nSOs, &
                      iSO2Sh,PMax)
!***********************************************************************
!                                                                      *
!  Object: to assemble the 2nd order density matrix of a SCF wave      *
!          function from the 1st order density.                        *
!                                                                      *
!          The indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!          DSO: HF 1st order density                                   *
!          DSO_Var: 1st order density of correlated wf.                *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             January '92.                                             *
!                                                                      *
!     Modified to Aces 2 by RL, July 2000, Gainesville, FL, USA        *
!***********************************************************************

use Index_Functions, only: iTri
use SOAO_Info, only: iAOtSO
use pso_stuff, only: Gamma_MRCISD
use Constants, only: Zero, One, Quart, Four
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use pso_stuff, only: iD0Lbl, DVar, D0
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ijkl, nPAO, iCmp(4), iAO(4), iAOst(4), iBas, jBas, kBas, lBas, kOp(4), nDSO, nGamma, nSOs, &
                                 iSO2cI(2,nSOs), iSO2Sh(nSOs)
real(kind=wp), intent(out) :: PAO(ijkl,nPAO), PMax
real(kind=wp), intent(in) :: DSO(nDSO), DSO_Var(nDSO), DSSO(nDSO), DSSO_Var(nDSO), Gmma(nGamma)
integer(kind=iwp) :: i1, i2, i3, i4, iAOi, Index_A, Index_AB, Index_ABCD, Index_B, Index_C, Index_CD, Index_D, Indij, Indik, &
                     Indil, Indjk, Indjl, Indkl, iPAO, iShell_A, iShell_AB, iShell_B, iShell_C, iShell_CD, iShell_D, iSO, iSOi, &
                     jAOj, jSO, jSOj, kAOk, kSO, kSOk, lAOl, lSO, lSOl, nDim_A, nDim_AB, nDim_B, nDim_C, nDim_CD, nDim_D, nijkl
real(kind=wp) :: t14, Temp
real(kind=wp), parameter :: exfac = One
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, iComp
real(kind=wp), external :: DDOt_
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
iComp = 1
call PrMtrx('DSO     ',[iD0Lbl],iComp,1,D0)
call PrMtrx('DSO_Var ',[iD0Lbl],iComp,1,DVar)
write(u6,*) ' nBases..=',iBas,jBas,kBas,lBas
write(u6,*) 'iSO2Sh=',iSO2Sh
write(u6,*) 'iSO2cI(1)',(iSO2cI(1,i),i=1,nSOs)
write(u6,*) 'iSO2cI(2)',(iSO2cI(2,i),i=1,nSOs)
call RecPrt('PGet1: Gmma',' ',Gmma,1,nGamma)
#endif

! Quadruple loop over elements of the basis functions angular
! description.
! Observe that we will walk through the memory in PAO in a
! sequential way.

PMax = Zero
iPAO = 0
t14 = Quart*exfac
do i1=1,iCmp(1)
  do i2=1,iCmp(2)
    do i3=1,iCmp(3)
      do i4=1,iCmp(4)

        ! Unfold the way the eight indices have been reordered.
        iSO = iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
        jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
        kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
        lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

        iPAO = iPAO+1
        nijkl = 0
        do lAOl=0,lBas-1
          lSOl = lSO+lAOl
          iShell_D = iSO2Sh(lSOl)
          Index_D = iSO2cI(1,lSOl)
          nDim_D = iSO2cI(2,lSOl)
          do kAOk=0,kBas-1
            kSOk = kSO+kAOk
            iShell_C = iSO2Sh(kSOk)
            Index_C = iSO2cI(1,kSOk)
            nDim_C = iSO2cI(2,kSOk)
            nDim_CD = nDim_C*nDim_D
            iShell_CD = iTri(iShell_C,iShell_D)
            if (iShell_C > iShell_D) then
              Index_CD = (Index_D-1)*nDim_C+Index_C
            else if (iShell_C == iShell_D) then
              Index_CD = iTri(Index_C,Index_D)
            else
              Index_CD = (Index_C-1)*nDim_D+Index_D
            end if
            do jAOj=0,jBas-1
              jSOj = jSO+jAOj
              iShell_B = iSO2Sh(jSOj)
              Index_B = iSO2cI(1,jSOj)
              nDim_B = iSO2cI(2,jSOj)
              do iAOi=0,iBas-1
                iSOi = iSO+iAOi
                iShell_A = iSO2Sh(iSOi)
                Index_A = iSO2cI(1,iSOi)
                nDim_A = iSO2cI(2,iSOi)
                nDim_AB = nDim_A*nDim_B
                iShell_AB = iTri(iShell_A,iShell_B)
                if (iShell_A > iShell_B) then
                  Index_AB = (Index_B-1)*nDim_A+Index_A
                else if (iShell_A == iShell_B) then
                  Index_AB = iTri(Index_A,Index_B)
                else
                  Index_AB = (Index_A-1)*nDim_B+Index_B
                end if
                if (iShell_AB > iShell_CD) then
                  Index_ABCD = (Index_CD-1)*nDim_AB+Index_AB
                else if (iShell_AB == iShell_CD) then
                  Index_ABCD = iTri(Index_AB,Index_CD)
                else
                  Index_ABCD = (Index_AB-1)*nDim_CD+Index_CD
                end if
                nijkl = nijkl+1

                !*********** columbus interface ****************************************
                !do not reconstruct the two-particle density from the one-particle
                !density or partial two-particle densities but simply read them from
                !file
                if (gamma_mrcisd) then
                  temp = Gmma(Index_ABCD)
                else

                  ! D(ij)*D(kl)

                  Indij = iTri(iSOi,jSOj)
                  Indkl = iTri(kSOk,lSOl)
                  temp = DSO(Indij)*DSO(Indkl)+(DSO_Var(Indij)-DSO(Indij))*DSO(Indkl)+DSO(Indij)*(DSO_Var(Indkl)-DSO(Indkl))

                  ! -0.25*D(ik)*D(jl)

                  Indik = iTri(iSOi,kSOk)
                  Indjl = iTri(jSOj,lSOl)
                  temp = temp-t14*(DSO(Indik)*DSO(Indjl)+(DSO_Var(Indik)-DSO(Indik))*DSO(Indjl)+ &
                                   DSO(Indik)*(DSO_Var(Indjl)-DSO(Indjl))+DSSO(Indik)*DSSO(Indjl)+ &
                                   (DSSO_Var(Indik)-DSSO(Indik))*DSSO(Indjl)+DSSO(Indik)*(DSSO_Var(Indjl)-DSSO(Indjl)))

                  ! -0.25*D(il)*D(jk)

                  Indil = iTri(iSOi,lSOl)
                  Indjk = iTri(jSOj,kSOk)
                  temp = temp-t14*(DSO(Indil)*DSO(Indjk)+(DSO_Var(Indil)-DSO(Indil))*DSO(Indjk)+ &
                                   DSO(Indil)*(DSO_Var(Indjk)-DSO(Indjk))+DSSO(Indil)*DSSO(Indjk)+ &
                                   (DSSO_Var(Indil)-DSSO(Indil))*DSSO(Indjk)+DSSO(Indil)*(DSSO_Var(Indjk)-DSSO(Indjk)))

                  temp = temp+Four*Gmma(Index_ABCD)
                end if

                PMax = max(PMax,abs(temp))
                PAO(nijkl,iPAO) = temp

              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do
if (iPAO /= nPAO) then
  call WarningMessage(2,' Error in PGet1_Aces!')
  call Abend()
end if

#ifdef _DEBUGPRINT_
call RecPrt(' In PGet1:PAO ',' ',PAO,ijkl,nPAO)
do i=1,ijkl
  write(u6,*) DDot_(nPAO,PAO(i,1),ijkl,PAO(i,1),ijkl)
end do
#endif

return

end subroutine PGet1_Aces

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MergeBS(z1,n1,z2,n2,z,n,RatioThres,iDominantSet)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: n1, n2, iDominantSet
real(kind=wp), intent(in) :: z1(n1), z2(n2), RatioThres
real(kind=wp), intent(_OUT_) :: z(*)
integer(kind=iwp), intent(out) :: n
integer(kind=iwp) :: i, i1, i2, idum, iSetPrev, iSetThis, j, mPrim
real(kind=wp) :: ratio
integer(kind=iwp), allocatable :: ix1(:), ix2(:)
#ifdef _DEBUGPRINT_
#define _TEST_ .true.
#else
#define _TEST_ .false.
#endif
logical(kind=iwp), parameter :: IfTest = _TEST_

mPrim = n1+n2
call mma_allocate(ix1,mPrim,label='ix1')
call mma_allocate(ix2,mPrim,label='ix2')

iSetPrev = 0

do i=1,mPrim
  ix1(i) = i
  ix2(i) = i
end do

do i=1,n1-1
  do j=i+1,n1
    if (z1(ix1(i)) < z1(ix1(j))) then
      idum = ix1(i)
      ix1(i) = ix1(j)
      ix1(j) = idum
    end if
  end do
end do

do i=1,n2-1
  do j=i+1,n2
    if (z2(ix2(i)) < z2(ix2(j))) then
      idum = ix2(i)
      ix2(i) = ix2(j)
      ix2(j) = idum
    end if
  end do
end do

if (IfTest) then
  write(u6,'(A)')
  write(u6,'(4f20.4)') (z1(ix1(i)),i=1,n1)
  write(u6,'(A)')
  write(u6,'(4f20.4)') (z2(ix2(i)),i=1,n2)
end if

i = 0
i1 = 1
i2 = 1
do while ((i1 <= n1) .or. (i2 <= n2))
  i = i+1
  if (i > mPrim) then
    call WarningMessage(2,'Error in MergeBS')
    write(u6,*) ' MergeBS: i > mPrim',i,mPrim
    write(u6,*) ' MergeBS: raise mPrim and recompile'
    call Abend()
  end if
  if (i1 > n1) then
    z(i) = z2(ix2(i2))
    iSetThis = 2
    i2 = i2+1
  else if (i2 > n2) then
    z(i) = z1(ix1(i1))
    iSetThis = 1
    i1 = i1+1
  else if (z1(ix1(i1)) > z2(ix2(i2))) then
    z(i) = z1(ix1(i1))
    iSetThis = 1
    i1 = i1+1
  else
    z(i) = z2(ix2(i2))
    iSetThis = 2
    i2 = i2+1
  end if

  if (i == 1) then
    iSetPrev = iSetThis
  else
    ratio = z(i-1)/z(i)
    if (ratio >= RatioThres) then
      iSetPrev = iSetThis
    else
      if (iSetThis /= iDominantSet) then
        i = i-1
      else if (iSetThis == iDominantSet) then
        if (iSetPrev /= iDominantSet) then
          z(i-1) = z(i)
          i = i-1
        end if
        iSetPrev = iSetThis
      end if
    end if
  end if

end do

call mma_deallocate(ix1)
call mma_deallocate(ix2)

n = i
if (IfTest) then
  write(u6,'(I4)') n
  write(u6,'(4f20.4)') (z(i),i=1,n)
end if

end subroutine MergeBS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ITODS(IA,NDIM,MBLOCK,IFIL)
! TRANSFER ARRAY INTEGER IA(LENGTH NDIM) TO DISCFIL IFIL IN
! RECORDS WITH LENGTH NBLOCK.

use lucia_data, only: IDISK
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NDIM, MBLOCK, IFIL
integer(kind=iwp), intent(_IN_) :: IA(NDIM)
integer(kind=iwp) :: IDUMMY(1), ISTOP, NBACK, NBLOCK, NLABEL, NTRANS, START

NBLOCK = MBLOCK

if (NBLOCK <= 0) NBLOCK = NDIM
ISTOP = 0
NBACK = NDIM
! LOOP OVER RECORDS
do
  if (NBACK <= NBLOCK) then
    NTRANS = NBACK
    NLABEL = -NTRANS
  else
    NTRANS = NBLOCK
    NLABEL = NTRANS
  end if
  START = ISTOP+1
  ISTOP = START+NBLOCK-1
  NBACK = NBACK-NTRANS
  call IDAFILE(IFIL,1,IA(START),ISTOP-START+1,IDISK(IFIL))
  IDUMMY(1) = NLABEL
  call IDAFILE(IFIL,1,IDUMMY,1,IDISK(IFIL))
  if (NBACK == 0) exit
end do

end subroutine ITODS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETSH(IBASSH,NBASSH,NBSTSH,IBAS,NBAS,ISOSHL,
     &                     NSYM,NSHELL,NBAST)
      IMPLICIT NONE
      INTEGER NSYM, NSHELL, NBAST
      INTEGER IBASSH(NSYM,NSHELL), NBASSH(NSYM,NSHELL)
      INTEGER NBSTSH(NSHELL)
      INTEGER ISOSHL(NBAST)
      INTEGER IBAS(NSYM), NBAS(NSYM)

      INTEGER ISYM, IA, ISHL

      CALL IZERO(NBASSH,NSYM*NSHELL)
      DO ISYM = 1,NSYM
         DO IA = 1,NBAS(ISYM)
            ISHL = ISOSHL(IBAS(ISYM)+IA)
            NBASSH(ISYM,ISHL) = NBASSH(ISYM,ISHL) + 1
         END DO
      END DO

      DO ISHL = 1,NSHELL
         IBASSH(1,ISHL) = 0
         NBSTSH(ISHL) = NBASSH(1,ISHL)
         DO ISYM = 2,NSYM
            IBASSH(ISYM,ISHL) = NBSTSH(ISHL)
            NBSTSH(ISHL) = NBSTSH(ISHL) + NBASSH(ISYM,ISHL)
         END DO
      END DO

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,1996,2014, Per Ake Malmqvist                      *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE NEWFOCK(FIFA)
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
      REAL*8 FIFA(NFIFA)

      REAL*8 D,DDVX,E,EIGVAL
      INTEGER LDD,LDDTR,LDSQ,L2MDSQ,LINT,LSC,LSC1,LSC2,LSCR,
     &        LEV1,LEV2,LEIG,LXAI,LXMAT,LXPQ,LXQP
      INTEGER IFGFOCK
      INTEGER I,J
      INTEGER II,IP,IQ,IR,IS,IV,IX
      INTEGER ITOT,IA,IATOT,IT,ITTOT,ITABS,IU,IUTOT,IUABS,ITU
      INTEGER NA,NA2,NA3,MA,MI,MTRES,N3,NI,NIA,NINT,NO,
     &        NAS,NASQES,NASQT,NATR,NATRES,NOSQES,NOTRES,
     &        NS,NSCR,NSCR1,NSCR2,NSCR3,NSQES,NTRES
      INTEGER ISC,ISTLT,KFIFA
      INTEGER ID,IDDVX,IDREF,IDTT,IDTU,IDUT
      INTEGER IEPS,IEPSA,IEPSI,IEPSE
      INTEGER ISYM,ISYMPQ,ISYMRS
      REAL*8 VAL,VALTU,VALUT,X
c Purpose: Modify the standard fock matrix for experimental
c purposes. The string variable FOCKTYPE (character*8) has a
c keyword value given as input. The experimental user modifies
c this routine to suit his purposes, and links with the rest
c of the program. The Fock matrix is given as call parameter
c and returned after modification.
c To define the modified Fock matrix, a number of arrays on
c  LUONE may be useful. In addition, the active 1- and 2-
c electron density matrices, and the inactive Fock matrix
c FIMO, are awailable in workspace at WORK(LDREF),
c WORK(LPREF),WORK(LFIMO), and WORK(LFIFA).
c Two-electron integrals involving non-frozen, non-deleted
c orbitals, at most two secondary, are available from
c subroutines COUL and EXCH (See).
c Meaningful modifications must define a Fock operator
c which is invariant to transformations among inactives,
c among actives, and among virtuals.
c Coded 94-01-31 by Malmqvist, for CASPT2 MOLCAS-3.
c Modif 96-10-06 by Malmqvist, restructured, options added.
c Modif 14-03-19 by Malmqvist, restructured, options removed.

      IF(FOCKTYPE.EQ.'STANDARD') RETURN
      IF(IFCHOL) THEN
        WRITE(6,*)' Subroutine NEWFOCK is presently unable to use'
        WRITE(6,*)' Cholesky vectors. The FOCKTYPE variable is now'
        WRITE(6,*)' changed to STANDARD, and NEWFOCK returns without'
        WRITE(6,*)' action. This will be fixed as soon as possible.'
        FOCKTYPE='STANDARD'
      END IF

* Options MC and MC2 removed, PAM March 2014.
*CPAM96 The option FOCKTYPE='MC      ' added 961006. This option will
*C replace the active/active block with the MCSCF Fock matrix
*C while zeroing any non-diagonal blocks. This option is usually
*C quite ridiculous, but it can be used in very particular cases
*C when all active orbitals are singly occupied.
*CPAM96 The option FOCKTYPE='MC2     ' added 961006. Similar to the
*C above, but using as  active/active block the matrix
*C    D**(-1/2) FMC D**(-1/2)


CPAM A very long IF-block is replaced by a forward GOTO for clarity:
CPAM      IF((FOCKTYPE.EQ.'G1      '.OR.FOCKTYPE.EQ.'G2      '.OR.
CPAM     &   FOCKTYPE.EQ.'G3      ').AND.NASHT.GT.0) THEN
      IFGFOCK=0
      IF(FOCKTYPE.EQ.'G1      ') IFGFOCK=1
      IF(FOCKTYPE.EQ.'G2      ') IFGFOCK=1
      IF(FOCKTYPE.EQ.'G3      ') IFGFOCK=1

      IF(IFGFOCK.EQ.0) GOTO 300
      IF(IPRGLB.GE.USUAL) THEN
        WRITE(6,*)' THE FOCK MATRIX IS MODIFIED BY KEYWORD'//
     &               ' FOCKTYPE=',FOCKTYPE
      END IF
      IF(NASHT.LE.0) GOTO 300
c
c       Determine sizes of areas for memory allocation
        NASQT=0
        NATR=0
        DO 5 ISYM=1,NSYM
          NI=NISH(ISYM)
          NA=NASH(ISYM)
          NS=NSSH(ISYM)
          NO=NORB(ISYM)
          NASQT=NASQT+NA**2
          NATR=NATR+(NA*(NA+1))/2
    5   CONTINUE
        NINT=NOMX**2
        NSCR1=NAMX*MAX(2*NAMX,NIMX,NSMX)
        NSCR2=3*NAMX*(NAMX+1)
        NSCR3=NAMX*(3*NAMX+1)
        NSCR=NSCR1
        IF(FOCKTYPE.EQ.'G2      ') NSCR=NSCR2
        IF(FOCKTYPE.EQ.'G3      ') NSCR=NSCR3
c
c Allocate memory: Integral buffer and scratch array:
        CALL GETMEM('FINT','ALLO','REAL',LINT,2*NINT)
        LSCR=LINT+NINT
        CALL GETMEM('FSCR','ALLO','REAL',LSC,NSCR)
c Form symmetry-packed squares of density matrix DSQ, and
c similarly (2I-DSQ)
        CALL GETMEM('DSQ','ALLO','REAL',LDSQ,NASQT)
        CALL GETMEM('2MDSQ','ALLO','REAL',L2MDSQ,NASQT)
c Symmetry-packed triangles of D*(2I-D)
        CALL GETMEM('DDTR','ALLO','REAL',LDDTR,NATR)
c Temporary use of single square symmetry-block:
        CALL GETMEM('DD','ALLO','REAL',LDD,NAMX**2)
C The exchange matrix, A(pq)=sum over rs of (ps,rq)*DD(rs)
        CALL GETMEM('XMAT','ALLO','REAL',LXMAT,NOSQT)
        NSQES=0
        DO ISYM=1,NSYM
          NA=NASH(ISYM)
          DO IT=1,NA
            ITABS=IT+NAES(ISYM)
            DO IU=1,NA
              IUABS=IU+NAES(ISYM)
              IDREF=(ITABS*(ITABS-1))/2+IUABS
              D=WORK(LDREF-1+IDREF)
              IDTU=NSQES+IT+NA*(IU-1)
              IDUT=NSQES+IU+NA*(IT-1)
              WORK(LDSQ-1+IDTU)=D
              WORK(LDSQ-1+IDUT)=D
            END DO
          END DO
          DO I=1,NA*NA
            IDTU=NSQES+I
            WORK(L2MDSQ-1+IDTU)=-WORK(LDSQ-1+IDTU)
          END DO
          DO I=1,NA*NA,(NA+1)
            IDTT=NSQES+I
            WORK(L2MDSQ-1+IDTT)=2.0D0-WORK(LDSQ-1+IDTT)
          END DO
          NSQES=NSQES+NA**2
        END DO
c
c Create the matrix DDTR =D(2I-D) (triangular symmetry blocks)
C Use also temporary DD, single symmetry blocks of D*(2I-D):
        NTRES=0
        NSQES=0
        DO ISYM=1,NSYM
          NA=NASH(ISYM)
          IF(NA.GT.0) THEN
            N3=(NA*(NA+1))/2
            CALL DGEMM_('N','N',
     &                  NA,NA,NA,
     &                  1.0d0,WORK(LDSQ+NSQES),NA,
     &                  WORK(L2MDSQ+NSQES),NA,
     &                  0.0d0,WORK(LDD),NA)
            CALL TRIANG(NA,WORK(LDD))
            CALL DCOPY_(N3,WORK(LDD),1,WORK(LDDTR+NTRES),1)
            NTRES=NTRES+N3
            NSQES=NSQES+NA**2
          END IF
        END DO

C Calculation of the exchange matrix, A(pq)=sum over rs of (ps,rq)*DD(rs)
        CALL DCOPY_(NOSQT,[0.0D0],0,WORK(LXMAT),1)
        NOSQES=0
        DO ISYMPQ=1,NSYM
          NI=NISH(ISYMPQ)
          NA=NASH(ISYMPQ)
          NS=NSSH(ISYMPQ)
          NO=NORB(ISYMPQ)
          IF(NO.GT.0) THEN
            MTRES=0
            DO ISYMRS=1,NSYM
              MI=NISH(ISYMRS)
              MA=NASH(ISYMRS)
              DO IV=1,MA
                IR=IV+MI
                DO IX=1,IV
                  IS=IX+MI
                  CALL EXCH(ISYMPQ,ISYMRS,ISYMPQ,ISYMRS,IR,IS,
     &                      WORK(LINT),WORK(LSCR))
                  IDDVX=MTRES+(IV*(IV-1))/2+IX
                  DDVX=WORK(LDDTR-1+IDDVX)
                  IF(IR.EQ.IS) DDVX=0.5D0*DDVX
                  CALL DAXPY_(NO**2,DDVX,WORK(LINT),1,
     &                                  WORK(LXMAT+NOSQES),1)
                END DO
              END DO
              MTRES=MTRES+(MA*(MA+1))/2
            END DO
            DO IP=2,NO
              DO IQ=1,IP-1
                LXPQ=LXMAT+NOSQES-1+IP+NO*(IQ-1)
                LXQP=LXMAT+NOSQES-1+IQ+NO*(IP-1)
                VAL=0.5D0*(WORK(LXPQ)+WORK(LXQP))
                WORK(LXPQ)=VAL
                WORK(LXQP)=VAL
              END DO
            END DO
            NOSQES=NOSQES+NO**2
          END IF
        END DO
c
c Determine the correction to the Fock matrix
        IF(FOCKTYPE.EQ.'G1      ') THEN
C Focktype=g1 case. A very long IF block.
          NOSQES=0
          NOTRES=0
          NASQES=0
          DO 30 ISYMPQ=1,NSYM
            NI=NISH(ISYMPQ)
            NA=NASH(ISYMPQ)
            NS=NSSH(ISYMPQ)
            NO=NORB(ISYMPQ)
            NIA=NI+NA
            NAS=NA+NS
            IF(NIA*NAS.LE.0) GO TO 31
c
c the active-inactive block
            IF(NA*NI.GT.0) THEN
              CALL DGEMM_('N','N',
     &                    NA,NI,NA,
     &                    1.0d0,WORK(L2MDSQ+NASQES),NA,
     &                    WORK(LXMAT+NOSQES+NI),NO,
     &                    0.0d0,WORK(LSC),NA)
              DO IT=1,NA
                ITTOT=NI+IT
                DO II=1,NI
                  KFIFA=NOTRES+(ITTOT*(ITTOT-1))/2+II
                  ISC=IT+NA*(II-1)
                  FIFA(KFIFA)=FIFA(KFIFA)-WORK(LSC-1+ISC)
                END DO
              END DO
            ENDIF
c
c the secondary-inactive block
            IF(NS*NI.GT.0) THEN
              DO IA=1,NS
                IATOT=NI+NA+IA
                DO II=1,NI
                  KFIFA=NOTRES+(IATOT*(IATOT-1))/2+II
                  LXAI=LXMAT+NOSQES-1+IATOT+NO*(II-1)
                  FIFA(KFIFA)=FIFA(KFIFA)-2.0D0*WORK(LXAI)
                END DO
              END DO
            ENDIF
c
c the active-active block
            IF(NA.GT.0) THEN
              IX=NOSQES+NI+1+NO*NI
              CALL DGEMM_('N','N',
     &                    NA,NA,NA,
     &                    1.0d0,WORK(LDSQ+NASQES),NA,
     &                    WORK(LXMAT-1+IX),NO,
     &                    0.0d0,WORK(LSC+NA*NA),NA)
              CALL DGEMM_('N','N',
     &                    NA,NA,NA,
     &                    1.0d0,WORK(LSC+NA*NA),NA,
     &                    WORK(L2MDSQ+NASQES),NA,
     &                    0.0d0,WORK(LSC),NA)
              DO IT=1,NA
                ITTOT=NI+IT
                DO IU=1,IT
                  IUTOT=NI+IU
                  KFIFA=NOTRES+(ITTOT*(ITTOT-1))/2+IUTOT
                  VALTU=WORK(LSC-1+IT+NA*(IU-1))
                  VALUT=WORK(LSC-1+IU+NA*(IT-1))
                  FIFA(KFIFA)=FIFA(KFIFA)-0.5D0*(VALTU+VALUT)
                END DO
              END DO
            ENDIF
c
c the secondary-active block
            IF(NS*NA.GT.0) THEN
              IX=NOSQES+NI+NA+1+NO*NI
              CALL DGEMM_('N','N',
     &                    NS,NA,NA,
     &                    1.0d0,WORK(LXMAT-1+IX),NO,
     &                    WORK(LDSQ+NASQES),NA,
     &                    0.0d0,WORK(LSC),NS)
              DO IA=1,NS
                IATOT=NI+NA+IA
                DO IT=1,NA
                  ITTOT=NI+IT
                  KFIFA=NOTRES+(IATOT*(IATOT-1))/2+ITTOT
                  FIFA(KFIFA)=FIFA(KFIFA)-WORK(LSC-1+IA+NS*(IT-1))
                END DO
              END DO
            ENDIF
c
   31       CONTINUE
            NOSQES=NOSQES+NO**2
            NOTRES=NOTRES+(NO*(NO+1))/2
            NASQES=NASQES+NA**2
   30     CONTINUE
C Focktype=g1 case ends.
        ELSE
C Focktype=g2 or g3
          NOSQES=0
          NOTRES=0
          NASQES=0
          NATRES=0
          DO 130 ISYMPQ=1,NSYM
            NI=NISH(ISYMPQ)
            NA=NASH(ISYMPQ)
            NO=NORB(ISYMPQ)
            NIA=NI+NA
            NA2=NA*NA
            NA3=(NA+NA2)/2
            IF(NA.LE.0) GO TO 131
c
c Determine the matrix blocks of the correction to
c the Fock matrix and add them to the Fock matrix
c
C Form the selection matrix as a temporary square matrix.
C Compute it by spectral resolution.
C First, form a copy of the triangular D(2I-D) matrix block,
C and diagonalize it. The DDTR copy at LSC:
            CALL DCOPY_(NA3,WORK(LDDTR+NATRES),1,WORK(LSC),1)
C A unit matrix at LEV1, to become eigenvectors:
            LEV1=LSC+NA2
            CALL DCOPY_(NA2,[0.0D0],0,WORK(LEV1),1)
            CALL DCOPY_(NA, [1.0D0],0,WORK(LEV1),NA+1)
C A call to NIDiag diagonalizes the triangular matrix:
            CALL NIDiag(WORK(LSC),WORK(LEV1),NA,NA,0)
            CALL JACORD(WORK(LSC),WORK(LEV1),NA,NA)
C Make a copy of the eigenvector matrix:
            LEV2=LEV1+NA2
            CALL DCOPY_(NA2,WORK(LEV1),1,WORK(LEV2),1)
C Put eigenvalues at LEIG:
            LEIG=LEV2+NA2
            CALL VEIG(NA,WORK(LSC),WORK(LEIG))
C Now scale the second array of eigenvectors with any required
C function of the eigenvalues:
            DO J=1,NA
              EIGVAL=WORK(LEIG-1+J)
              IF(FOCKTYPE.EQ.'G2      ') THEN
                X=SQRT(MAX(0.0D0,EIGVAL))
              ELSE
                X=EIGVAL
              END IF
              DO I=1,NA
                WORK(LEV2-1+I+NA*(J-1))=X*WORK(LEV2-1+I+NA*(J-1))
              END DO
            END DO
C Now the selection matrix can be formed, at LSC:
            CALL DGEMM_('N','T',
     &                  NA,NA,NA,
     &                  1.0d0,WORK(LEV1),NA,
     &                  WORK(LEV2),NA,
     &                  0.0d0,WORK(LSC),NA)
C Obviously, the FOCKTYPE=G3 case can be obtained by just
C squaring the DDTR block into WORK(LSC).

C Focktype=g2 or g3
            IX=NOSQES+NI+1+NO*NI
            LSC1=LSC+NA2
            LSC2=LSC1+NA2
            CALL DGEMM_('N','N',
     &                  NA,NA,NA,
     &                  1.0d0,WORK(LSC),NA,
     &                  WORK(LXMAT-1+IX),NO,
     &                  0.0d0,WORK(LSC1),NA)
            CALL DGEMM_('N','N',
     &                  NA,NA,NA,
     &                  1.0d0,WORK(LSC1),NA,
     &                  WORK(LSC),NA,
     &                  0.0d0,WORK(LSC2),NA)
            DO IT=1,NA
              ITTOT=NI+IT
              DO IU=1,IT
                IUTOT=NI+IU
                KFIFA=NOTRES+(ITTOT*(ITTOT-1))/2+IUTOT
                ITU=IT+NA*(IU-1)
                FIFA(KFIFA)=FIFA(KFIFA)-WORK(LSC2-1+ITU)
              END DO
            END DO
c
  131       CONTINUE
            NOSQES=NOSQES+NO**2
            NOTRES=NOTRES+(NO*(NO+1))/2
            NASQES=NASQES+NA**2
            NATRES=NATRES+(NA*(NA+1))/2
  130     CONTINUE
        ENDIF
c
c
        CALL GETMEM('FSCR','FREE','REAL',LSC,NSCR)
        CALL GETMEM('FINT','FREE','REAL',LINT,NINT)
        CALL GETMEM('DSQ','FREE','REAL',LDSQ,NASQT)
        CALL GETMEM('2MDSQ','FREE','REAL',L2MDSQ,NASQT)
        CALL GETMEM('DD','FREE','REAL',LDD,NAMX**2)
        CALL GETMEM('DDTR','FREE','REAL',LDDTR,NATR)
        CALL GETMEM('XMAT','FREE','REAL',LXMAT,NOSQT)
 300  CONTINUE
c
c     Orbital energies, EPS, EPSI,EPSA,EPSE:
      IEPS=0
      IEPSI=0
      IEPSA=0
      IEPSE=0
      ISTLT=0
      DO 400 ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NO=NORB(ISYM)
        DO 401 I=1,NI
          E=FIFA(ISTLT+(I*(I+1))/2)
          IEPS=IEPS+1
          EPS(IEPS)=E
          IEPSI=IEPSI+1
          EPSI(IEPSI)=E
  401   CONTINUE
        DO 402 I=NI+1,NI+NA
          E=FIFA(ISTLT+(I*(I+1))/2)
          IEPS=IEPS+1
          EPS(IEPS)=E
          IEPSA=IEPSA+1
          EPSA(IEPSA)=E
  402   CONTINUE
        DO 403 I=NI+NA+1,NO
          E=FIFA(ISTLT+(I*(I+1))/2)
          IEPS=IEPS+1
          EPS(IEPS)=E
          IEPSE=IEPSE+1
          EPSE(IEPSE)=E
  403   CONTINUE
        ISTLT=ISTLT+(NO*(NO+1))/2
  400 CONTINUE
c
c     EASUM = contract EPSA with diagonal of active dens.
      EASUM=0.0D+00
      DO 410 ISYM=1,NSYM
        NA=NASH(ISYM)
        DO 411 I=1,NA
          ITOT=NAES(ISYM)+I
          ID=(ITOT*(ITOT+1))/2
          EASUM=EASUM+EPSA(ITOT)*WORK(LDREF-1+ID)
  411   CONTINUE
  410 CONTINUE
c
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Numerical_Gradient(ireturn)

#ifndef _HAVE_EXTRA_
use Prgm, only: PrgmFree
#endif
use Para_Info, only: MyRank, nProcs, Set_Do_Parallel
#if defined (_MOLCAS_MPP_) && !defined(_GA_)
use Para_Info, only: King
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, OneHalf, Angstrom, auTokcalmol
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
#include "LenIn.fh"
#include "standard_iounits.fh"
#include "WrkSpc.fh"
#include "timtra.fh"
#include "warnings.h"
real(kind=wp) :: Energy_Ref, FX(3), rDum(1), Dsp, EMinus, EPlus, Grada, Gradb, rDeg, rDelta, rMax, rTest, Sgn, TempX, TempY, &
                 TempZ, x, x0, y, y0, z, z0
integer(kind=iwp) :: iOper(0:7), jStab(0:7), iCoSet(0:7,0:7), iDispXYZ(3), rc, error, i, iAt, iAtom, ibla, iBlabla, iChxyz, iCoor, &
                     id_Tsk, iData, iDisp, iEm, iEp, ii, iMlt, iPL, iPL_Save, ipMltp, IPotFl, iQMChg, iR, iRank, iRC, irlxroot1, &
                     irlxroot2, iRoot, iSave, ITkQMMM, ixyz, j, LuWr_save, MaxDCR, mDisp, mInt, MltOrd, nAll, nAtMM, nAtoms, &
                     nCList, nDisp, nDisp2, nGNew, nGrad, nIrrep, nLambda, nMult, nRoots, nStab, nSym
character(len=8) :: Method
character(len=LenIn) :: Namei
character(len=10) :: ESPFKey
character(len=180) :: Line
logical(kind=iwp) :: DispX, DispY, DispZ, Is_Roots_Set, Found, External_Coor_List, Do_ESPF, StandAlone, Exists, DoTinker, NMCart, &
                     DynExtPot, DoDirect, KeepOld
integer(kind=iwp), allocatable :: IsMM(:)
real(kind=wp), allocatable :: EnergyArray(:,:), GradArray(:,:), OldGrads(:,:), Grad(:), GNew(:), MMGrd(:,:), BMtrx(:,:), &
                              TMtrx(:,:), Coor(:,:), Energies_Ref(:), XYZ(:,:), AllC(:,:), Disp(:), Deg(:,:), Mltp(:), C(:,:), &
                              Tmp2(:), Tmp(:,:)
character(len=LenIn), allocatable :: AtomLbl(:)
real(kind=wp), parameter :: ToHartree = One/auTokcalmol
integer(kind=iwp), external :: Read_Grad, IsFreeUnit, iPrintLevel, ip_of_Work, iChAtm, iDeg
character(len=180), external :: Get_Ln
logical(kind=iwp), external :: Rsv_Tsk, Reduce_Prt
#if defined (_MOLCAS_MPP_) && !defined(_GA_)
character(len=80) :: SSTMNGR
integer(kind=iwp) :: SSTMODE
logical(kind=iwp), external :: Rsv_Tsk_Even
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
interface
  subroutine RunTinker(nAtom,Cord,ipMltp,IsMM,MltOrd,DynExtPot,iQMChg,nAtMM,StandAlone,DoDirect)
    integer, intent(in) :: nAtom
    real*8, intent(in) :: Cord(3,nAtom)
    integer, intent(in) :: ipMltp
    integer, intent(in) :: IsMM(nAtom)
    integer, intent(in) :: MltOrd
    logical, intent(inout) :: DynExtPot
    integer, intent(in) :: iQMChg
    integer, intent(inout) :: nAtMM
    logical, intent(in) :: StandAlone
    logical, intent(in) :: DoDirect
  end subroutine RunTinker
end interface

!                                                                      *
!***********************************************************************
!                                                                      *
! Get the print level.

iPL_Save = iPrintLevel(-1)
iPL = iPL_Save

if (Reduce_Prt() .and. (iPL < 3)) iPL = 0
!                                                                      *
!***********************************************************************
!                                                                      *
ireturn = _RC_ALL_IS_WELL_

! Get information regarding the last method used

call Get_cArray('Relax Method',Method,8)
call DecideOnESPF(Do_ESPF)
Is_Roots_Set = .false.
call Qpg_iScalar('Number of roots',Is_Roots_Set)
if (Is_Roots_Set) then
  call Get_iScalar('Number of roots',nRoots)
  if (nRoots == 1) then
    iRoot = 1
  else
    call qpg_iScalar('NumGradRoot',Found)
    if (Found) then
      call Get_iScalar('NumGradRoot',iRoot)
    else
      iRoot = 1
    end if
  end if
else
  nRoots = 1
  iRoot = 1
end if
call mma_allocate(Energies_Ref,nRoots,Label='Energies_Ref')
!write(u6,*) 'Is_Roots_Set, nRoots, iRoot = ',Is_Roots_Set,nRoots,iRoot
if (iRoot > nRoots) then
  write(LuWr,*)
  write(LuWr,*) '****************** ERROR ******************'
  write(LuWr,*) 'It was selected to run numerical gradient'
  write(LuWr,*) 'using energies for root/state number ',iRoot
  write(LuWr,*) 'but only ',nRoots,' exists.'
  write(LuWr,*) '*******************************************'
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (nRoots > 1) then
  call Get_dArray('Last energies',Energies_Ref,nRoots)
else
  call Get_dScalar('Last energy',Energies_Ref(iRoot))
end if
call Get_iScalar('Unique atoms',nAtoms)
call mma_allocate(Coor,3,nAtoms,Label='Coor')
call mma_allocate(AtomLbl,nAtoms,Label='AtomLbl')
call Get_cArray('Unique Atom Names',AtomLbl,LenIn*nAtoms)
call Get_dArray('Unique Coordinates',Coor,3*nAtoms)
if (iPL_Save >= 3) call RecPrt('Original coordinates',' ',Coor,3,nAtoms)
!                                                                      *
!***********************************************************************
!                                                                      *
! If this is a QM/MM calculation, the gradient on the MM atoms
! is analytical (using the ESPF method for the QM/MM electrostatics)
! Accordingly, no need to loop over the MM atoms

DoTinker = .false.
DoDirect = .false.
ipMltp = ip_Dummy
call F_Inquire('ESPF.DATA',Exists)
if (Exists) then
  IPotFl = IsFreeUnit(15)
  call Molcas_Open(IPotFl,'ESPF.DATA')
  Line = ' '
  do while (index(Line,'ENDOFESPF ') == 0)
    Line = Get_Ln(IPotFl)
    if (index(Line,'TINKER ') /= 0) then
      DoTinker = .true.
    else if (index(Line,'DIRECT ') /= 0) then
      DoDirect = .true.
    else if (index(Line,'MLTORD ') /= 0) then
      call Get_I1(2,MltOrd)
      ibla = 0
      do ii=0,MltOrd
        ibla = ibla+(ii+2)*(ii+1)/2
      end do
      MltOrd = ibla
    else if (index(Line,'MULTIPOLE ') /= 0) then
      call Get_I1(2,nMult)
      call mma_allocate(Mltp,nMult,Label='Mltp')
      ipMltp = ip_of_Work(Mltp(1))
      do iMlt=1,nMult,MltOrd
        Line = Get_Ln(IPotFl)
        call Get_I1(1,iAt)
        call Get_F(2,Mltp(iMlt),MltOrd)
      end do
    end if
  end do
  close(IPotFl)
end if

nAtMM = 0
if (DoTinker) then
  call mma_allocate(IsMM,nAtoms,Label='IsMM')
  call MMCount(nAtoms,nAtMM,IsMM)
  if (nAtMM > 0) then
    iQMChg = 0
    StandAlone = .false.
    call RunTinker(nAtoms,Coor,ipMltp,IsMM,MltOrd,DynExtPot,iQMchg,iBlabla,StandAlone,DoDirect)
    call mma_allocate(MMGrd,3,nAtoms,Label='MMGrd')
    MMGrd(:,:) = Zero
    ITkQMMM = IsFreeUnit(15)
    call Molcas_Open(ITkQMMM,'QMMM')
    Line = ' '
    do while (index(Line,'TheEnd') == 0)
      Line = Get_Ln(ITkQMMM)
      if (index(Line,'MMGradient') /= 0) then
        call Get_I1(2,iAtom)
        call Get_F(3,FX,3)
        if (IsMM(iAtom) == 1) MMGrd(:,iAtom) = FX(:)
      end if
    end do
    call DScal_(3*nAtoms,Angstrom*ToHartree,MMGrd,1)
    close(ITkQMMM)
    if (iPL_Save >= 3) call RecPrt('MM Grad:',' ',MMGrd,3,nAtoms)
  end if
  if (allocated(Mltp)) call mma_deallocate(Mltp)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Pick up rDelta from the runfile
call Get_dScalar('Numerical Gradient rDelta',rDelta)
!                                                                      *
!***********************************************************************
!                                                                      *
! Check if there is a coordinate list from Slapaf on the run file.
! Read the B-matrix and T-matrix. To be used in case of
! differentiation in internal coordinates according to Slapaf.

if (nAtMM == 0) call GenCxCTL(iRC,NMCart,rDelta)

call qpg_dArray('CList',Found,nCList)
if (Found) then
  External_Coor_List = .true.
  call Get_iScalar('No of Internal Coordinates',mInt)
  call Get_iScalar('nLambda',nLambda)
  call mma_allocate(BMtrx,3*nAtoms,mInt,Label='BMtrx')
  call mma_allocate(TMtrx,mInt,mInt,Label='TMtrx')
  call Get_dArray('BMtrx',BMtrx,size(BMtrx))
  call Get_dArray('T-Matrix',TMtrx,mInt**2)
else
  NMCart = .false.
  External_Coor_List = .false.
  mInt = 3*nAtoms
  nLambda = 0
  call mma_allocate(BMtrx,3*nAtoms,3*nAtoms,Label='BMtrx')
  call mma_allocate(TMtrx,mInt,mInt,Label='TMtrx')
  BMtrx(:,:) = Zero
  do i=1,3*nAtoms
    BMtrx(i,i) = One
  end do
  TMtrx(:,:) = Zero
  do i=1,mInt
    TMtrx(i,i) = One
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if ((Method(5:7) == 'SCF') .or. &
    (Method(1:6) == 'KS-DFT') .or. &
    (Method(1:6) == 'CASSCF') .or. &
    (Method(1:6) == 'RASSCF') .or. &
    (Method(1:6) == 'GASSCF') .or. &
    (Method(1:6) == 'CASPT2') .or. &
    (Method(1:5) == 'MBPT2') .or. &
    (Method(1:5) == 'CCSDT') .or. &
    (Method(1:4) == 'CHCC') .or. &
    (Method(1:6) == 'MCPDFT') .or. &
    (Method(1:6) == 'MSPDFT') .or. &
    (Method(1:4) == 'CHT3') .or. &
    (Method(1:8) == 'EXTERNAL')) then
  if (iPL_Save >= 3) then
    write(LuWr,*)
    write(LuWr,'(A,A,A)') ' Numerical_Gradient: Original ',Method,' Energies:'
    write(LuWr,'(G21.14)') Energies_Ref(:)
    write(LuWr,*)
  end if
else
  write(LuWr,'(A,A,A)') 'Numerical gradient for ',Method,' is not implemented yet.'
  call Abend()
end if

nDisp2 = 2*3*nAtoms
call mma_Allocate(EnergyArray,nRoots,nDisp2)
call FZero(EnergyArray,nRoots*nDisp2)
!                                                                      *
!***********************************************************************
!                                                                      *
! Pick up symmetry information

call Get_iScalar('nSym',nSym)
nIrrep = nSym
call Get_iArray('Symmetry operations',iOper,nSym)
MaxDCR = nIrrep
!                                                                      *
!***********************************************************************
!                                                                      *
! Set up displacement vector

call Get_nAtoms_All(nAll)
call mma_allocate(AllC,3,nAll,Label='AllC')
call Get_Coord_All(AllC,nAll)
!                                                                      *
!***********************************************************************
!                                                                      *
if (External_Coor_List) then

  ! Externally define displacement list

  nDisp = mInt
  call mma_allocate(Disp,mInt,Label='Disp')
  call Get_dArray('DList',Disp,mInt)
  !call RecPrt('Dlist',' ',Disp,1,mInt)

else

  ! Cartesian displacement list

  nDisp = 3*nAtoms
  call mma_allocate(Disp,nDisp,Label='Disp')
  call FZero(Disp,nDisp)

  do i=1,nAtoms

    ! Find the stabilizer of this center

    iChxyz = iChAtm(Coor(:,i))
    call Stblz(iChxyz,nStab,jStab,MaxDCR,iCoSet)

    iDispXYZ(:) = 0
    do j=0,nStab-1
      if (btest(jStab(j),0)) then
        iDispXYZ(1) = iDispXYZ(1)-1
      else
        iDispXYZ(1) = iDispXYZ(1)+1
      end if
      if (btest(jStab(j),1)) then
        iDispXYZ(2) = iDispXYZ(2)-1
      else
        iDispXYZ(2) = iDispXYZ(2)+1
      end if
      if (btest(jStab(j),2)) then
        iDispXYZ(3) = iDispXYZ(3)-1
      else
        iDispXYZ(3) = iDispXYZ(3)+1
      end if
    end do

    ! If this is a MM atom, do not make displacements

    if (DoTinker .and. (IsMM(i) == 1)) iDispXYZ(:) = 0
    DispX = iDispXYZ(1) /= 0
    DispY = iDispXYZ(2) /= 0
    DispZ = iDispXYZ(3) /= 0
    x0 = Coor(1,i)
    y0 = Coor(2,i)
    z0 = Coor(3,i)

    ! Find the shortest distance to another atom!

    rMax = huge(rMax)
    do j=1,nAll
      x = AllC(1,j)
      y = AllC(2,j)
      z = AllC(3,j)
      rTest = sqrt((x-x0)**2+(y-y0)**2+(z-z0)**2)
      if (rTest == Zero) rTest = huge(rTest)
      rMax = min(rMax,rTest)
    end do
    if (DispX) Disp((i-1)*3+1) = rDelta*rMax
    if (DispY) Disp((i-1)*3+2) = rDelta*rMax
    if (DispZ) Disp((i-1)*3+3) = rDelta*rMax
  end do
  !call RecPrt('Disp',' ',Disp,1,nDisp)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(Deg,3,nAtoms,Label='Deg')
Deg(:,:) = Zero
do i=1,nAtoms
  rDeg = real(iDeg(Coor(:,i)),kind=wp)
  Deg(1,i) = rDeg
  Deg(2,i) = rDeg
  Deg(3,i) = rDeg
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(XYZ,3*nAtoms,2*nDisp,Label='XYZ')
XYZ(:,:) = Zero
if (External_Coor_List) then
  mDisp = nDisp*2
  call Get_dArray('CList',XYZ,3*nAtoms*mDisp)
else
  mDisp = 0
  do iDisp=1,nDisp2
    iCoor = (iDisp+1)/2
    if (Disp(icoor) /= Zero) then
      mDisp = mDisp+1

      ! Modify the geometry

      call dcopy_(3*nAtoms,Coor,1,XYZ(:,mDisp),1)
      Sgn = One
      if (mod(iDisp,2) == 0) Sgn = -One
      XYZ(iCoor,mDisp) = XYZ(iCoor,mDisp)+Sgn*Disp(icoor)
    end if
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Save the "new geometry" field from the RunFile, if any

call qpg_dArray('GeoNew',Found,nGNew)
if (.not. Found) nGNew = 0
if (nGNew > 0) then
  call mma_allocate(GNew,nGNew)
  call Get_dArray('GeoNew',GNew,nGNew)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Save global print level

iPL_Save = iPrintLevel(-1)
!iPL_Base = 0
!If (iPL_Save >= 3) iPl_Base = iPL_Save

#ifdef _DEBUGPRINT_
call RecPrt('BMtrx',' ',BMtrx,3*nAtoms,mInt)
call RecPrt('TMtrx',' ',TMtrx,mInt,mInt)
call RecPrt('Degeneracy vector',' ',Deg,3,nAtoms)
call RecPrt('Coordinate List',' ',XYZ,3*nAtoms,mDisp)
#endif

!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Loop over displacements                                              *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (iPL >= 2) then
  write(LuWr,*) 'Root to use: ',iRoot
  write(LuWr,*) 'Number of internal degrees            ',nDisp
  write(LuWr,*) 'Number of constraints                 ',nLambda
  write(LuWr,*) 'Number of displacements               ',nDisp*2
  if ((nAtMM /= 0) .and. DoTinker .and. (.not. DoDirect)) then
    write(LuWr,*) 'Number of MM degrees (analytical grad)',nAtMM*3
  end if
  write(LuWr,*) 'Effective number of displacements     ',2*(nDisp-nLambda-3*nAtMM)
  write(LuWr,*) 'Relative displacements                ',rDelta
  write(LuWr,*)
end if

! This printout is disabled since it means different things for
! externally defined coordinates or not.

if (iPL >= 3) then
# ifdef _HIDE_
  write(LuWr,'(1x,A)') '---------------------------------------------'
  write(LuWr,'(1x,A)') '               X           Y           Z     '
  write(LuWr,'(1x,A)') '---------------------------------------------'
  do iAtom=1,nAtoms
    TempX = Disp(3*(iAtom-1)+1)
    TempY = Disp(3*(iAtom-1)+2)
    TempZ = Disp(3*(iAtom-1)+3)
    Namei = AtomLbl(iAtom)
    write(LuWr,'(2X,A,3X,3F12.6)') Namei,TempX,TempY,TempZ
  end do
# endif
  write(LuWr,'(1x,A)') '---------------------------------------------'
  write(LuWr,*)
  write(LuWr,*) 'Here we go ...'
  write(LuWr,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Change output unit

LuWr_save = LuWr
if (MyRank /= 0) then
  LuWr = 55
  LuWr = isFreeUnit(LuWr)
  call molcas_open(luwr,'Temp_OutPut')
end if

! FM 16/4/2013
! ESPF charges are set to zero so that no microiterations will be
! performed during numerical gradient
! IFG: swap files, as now NG uses a subdirectory

iSave = 15
if (Do_ESPF) then
  iSave = IsFreeUnit(iSave)
  call Molcas_Open(iSave,'ESPF.SAV')
  iData = IsFreeUnit(iSave)
  call Molcas_Open(iData,'ESPF.DATA')
  do
    Line = Get_Ln(iData)
    ESPFKey = Line(1:10)
    if (ESPFKey == 'ENDOFESPF ') then
      write(iSave,'(A132)') Line
      exit
    else
      if (ESPFKey /= 'MULTIPOLE ') then
        write(iSave,'(A132)') Line
      else
        call Get_I1(2,nMult)
        do iMlt=1,nMult
          Line = Get_Ln(iData)
        end do
      end if
    end if
  end do
  close(iSave)
  close(iData)
end if
! FM End
!                                                                      *
!***********************************************************************
!                                                                      *
! Parallel loop over the nDisp displacements.
! Reserve task on global task list and get task range in return.
! Function will be false if no more tasks to execute.
#if !defined(_GA_) && defined(_MOLCAS_MPP_)
call getenvf('MOLCAS_SSTMNGR',SSTMNGR)
if (SSTMNGR(1:1) == 'Y') then
  SSTMODE = 1
else
  SSTMODE = 0
end if
if (SSTMODE == 1) then
  call Init_Tsk(id_Tsk,mDisp-2*nLambda)
else
  call Init_Tsk_Even(id_Tsk,mDisp-2*nLambda)
end if
#else
call Init_Tsk(id_Tsk,mDisp-2*nLambda)
#endif
call mma_allocate(C,3,nAtoms,Label='C')
do
# if defined (_MOLCAS_MPP_) && !defined(_GA_)
  if (SSTMODE == 1) then
    if (.not. Rsv_Tsk(id_Tsk,iDisp)) exit
  else
    if (.not. Rsv_Tsk_Even(id_Tsk,iDisp)) exit
  end if
# else
  if (.not. Rsv_Tsk(id_Tsk,iDisp)) exit
# endif

  ! Offset for the constraints

  iDisp = iDisp+2*nLambda

  ! Get the displaced geometry

  call dcopy_(3*nAtoms,xyz(:,iDisp),1,C,1)
  !call RecPrt('C',' ',C,3*nAtoms,1)
  call Put_Coord_New(C,nAtoms)

  ! Compute integrals

  !jPL = iPrintLevel(Max(iPL_Base,0)) ! Silent
  call Set_Do_Parallel(.false.)

  ! Switch to a new directory
  ! WARNING WARNING WARNING WARNING WARNING
  ! ugly hack, do not try this at home
  call SubWorkDir()
  ! WARNING WARNING WARNING WARNING WARNING

  call StartLight('seward')
  call init_run_use()
  call init_ppu(.true.)
  call Disable_Spool()
  call Seward(ireturn)
  call ReClose()
  if (iReturn /= 0) then
    write(LuWr,*) 'Numerical_Gradient failed ...'
    write(LuWr,*) 'Seward returned with return code, rc = ',iReturn
    write(LuWr,*) 'for the perturbation iDisp = ',iDisp
    call Abend()
  end if

  ! Compute the ESPF stuff

  if (Do_ESPF) then
    call StartLight('espf')
    call init_run_use()
    call Disable_Spool()
    StandAlone = .true.
    call ESPF(ireturn,StandAlone)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'ESPF returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  end if

  ! Compute the wave function

  if ((Method(5:7) == 'SCF') .or. &
      (Method(1:6) == 'KS-DFT') .or. &
      (Method(1:5) == 'MBPT2') .or. &
      (Method(1:4) == 'CHCC') .or. &
      (Method(1:4) == 'CHT3')) then
    call StartLight('scf')
    call init_run_use()
    call Disable_Spool()
    call xml_open('module',' ',' ',0,'scf')
    call SCF(iReturn)
    call xml_close('module')
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'SCF returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  else if ((Method(1:6) == 'RASSCF') .or. &
           (Method(1:6) == 'GASSCF') .or. &
           (Method(1:6) == 'CASSCF') .or. &
           (Method(1:6) == 'MCPDFT') .or. &
           (Method(1:6) == 'MSPDFT') .or. &
           (Method(1:6) == 'CASPT2') .or. &
           (Method(1:5) == 'CCSDT')) then
    call StartLight('rasscf')
    call init_run_use()
    call Disable_Spool()
    call RASSCF(ireturn)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'RASSCF returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  else if (Method(1:8) == 'EXTERNAL') then
    call StartLight('false')
    call init_run_use()
    call Disable_Spool()
    call False_program(ireturn)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'FALSE returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  end if

  if (Method(1:5) == 'MBPT2') then
    call StartLight('mbpt2')
    call init_run_use()
    call Disable_Spool()
    call MP2_Driver(ireturn)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'MBPT2 returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  end if

  if (Method(1:5) == 'CCSDT') then
    call StartLight('motra')
    call init_run_use()
    call Disable_Spool()
    call Motra(ireturn)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'Motra returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if

    call StartLight('ccsdt')
    call init_run_use()
    call Disable_Spool()
    call CCSDT(ireturn)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'CCSDT returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  end if

  if ((Method(1:4) == 'CHCC') .or. &
      (Method(1:4) == 'CHT3')) then
    call StartLight('chcc')
    call init_run_use()
    call Disable_Spool()
    call CHCC(ireturn)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'CHCC returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  end if

  if (Method(1:4) == 'CHT3') then
    call StartLight('cht3')
    call init_run_use()
    call Disable_Spool()
    call CHT3(ireturn)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'CHT3 returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  end if

  if (Method(1:6) == 'CASPT2') then
    call StartLight('caspt2')
    call init_run_use()
    call Disable_Spool()
    call CASPT2(ireturn)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'CASPT2 returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  end if

  if ((Method(1:6) == 'MCPDFT') .or. (Method(1:6) == 'MSPDFT')) then
    call StartLight('mcpdft')
    call init_run_use()
    call Disable_Spool()
    call MCPDFT(ireturn)
    call ReClose()
    if (iReturn /= 0) then
      write(LuWr,*) 'Numerical_Gradient failed ...'
      write(LuWr,*) 'MCPDFT returned with return code, rc = ',iReturn
      write(LuWr,*) 'for the perturbation iDisp = ',iDisp
      call Abend()
    end if
  end if

  !call Get_Energy(EnergyArray(iRoot,iDisp))
  if (nRoots > 1) then
    call Get_dArray('Last energies',EnergyArray(1,iDisp),nRoots)
  else
    call Get_dScalar('Last energy',EnergyArray(iRoot,iDisp))
  end if

  ! Restore directory and prgm database

  call ParentWorkDir()
  call prgmfree()
  call prgminit('numerical_gradient')

  call Set_Do_Parallel(.true.)

  if (iPL >= 2) then
    write(LuWr,200) '   * Point #',iDisp-2*nLambda,' of ',2*(nDisp-nLambda-3*nAtMM),' done.'
    write(LuWr,200) '    (Perturbation ',iDisp,')'
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
# if defined (_MOLCAS_MPP_) && !defined(_GA_)
  if (King() .and. (nProcs > 1) .and. (SSTMODE == 1)) exit
# endif
end do
!_MPP End Do
#if !defined(_GA_) && defined(_MOLCAS_MPP_)
if (SSTMODE == 1) then
  call Free_Tsk(id_Tsk)
else
  call Free_Tsk_Even(id_Tsk)
end if
#else
call Free_Tsk(id_Tsk)
#endif
call GADSum(EnergyArray,nRoots*mDisp)
call mma_deallocate(C)
call mma_deallocate(XYZ)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! End of Loop                                                          *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Flush the output from the other nodes.
!
do iRank=1,nProcs-1
  call GASync()
  if (iRank == MyRank) then
    rewind(LuWr)
    do
      read(LuWr,'(A)',iostat=error) Line
      if (error /= 0) exit
      write(LuWr_Save,*) Line
    end do
  end if
  call GASync()
end do
if (MyRank /= 0) then
  close(LuWr)
  LuWr = LuWr_save
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Restore the "new geometry" field to the RunFile, if any

if (nGNew == 0) then
  call Put_Coord_New([Zero],0)
else
  call Put_Coord_New(GNew,nGNew/3)
  call mma_deallocate(GNew)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if ((nProcs >= 2) .and. (iPL >= 2)) then
  write(LuWr,*)
  write(LuWr,*) ' Points were printed only by master node'
  write(LuWr,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Read old gradient(s) and convert to internal coordinates

call mma_Allocate(OldGrads,3*nAtoms,nRoots)
call FZero(OldGrads,3*nAtoms*nRoots)
call Get_lScalar('Keep old gradient',KeepOld)
if (KeepOld) then
  call Query_Grads(Found,i,j)
  if (Found .and. (i >= nRoots) .and. (j == 3*nAtoms)) then
    ! If there is a valid GRADS file, read each gradient
    do iR=1,nRoots
      rc = Read_Grad(OldGrads(1,iR),3*nAtoms,iR,0,0)
      if (rc <= 0) then
        write(LuWr,*)
        write(LuWr,'(2X,A,I4,A)') 'No gradient found for root ',iR,', using 0'
        write(LuWr,*)
      end if
    end do
  else
    ! If the GRADS file does not exist or has the wrong sizes,
    ! read a single gradient from the runfile
    call qpg_dArray('GRAD',Found,nGrad)
    if (Found) then
      call Get_dArray('GRAD',OldGrads(1,1),nGrad)
      do iR=2,nRoots
        call dCopy_(nGrad,OldGrads(1,1),1,OldGrads(1,iR),1)
      end do
      if (nRoots > 1) then
        write(LuWr,*)
        write(LuWr,'(2X,A)') 'Using stored gradient for all roots'
        write(LuWr,*)
      end if
    else
      write(LuWr,*)
      write(LuWr,'(2X,A)') 'No gradient found, using 0'
      write(LuWr,*)
    end if
  end if
end if
call mma_allocate(Tmp2,nDisp,Label='Tmp2')
do iR=1,nRoots
  call Eq_Solver('N',3*nAtoms,nDisp,1,BMtrx,.true.,rDum(1),OldGrads(1,iR),Tmp2)
  call FZero(OldGrads(1,iR),3*nAtoms)
  call Eq_Solver('N',nDisp,nDisp,1,TMtrx,.true.,rDum(1),Tmp2,OldGrads(1,iR))
end do
call mma_deallocate(Tmp2)
!                                                                      *
!***********************************************************************
!                                                                      *
!jPL = iPrintLevel(iPL_Save)
if (iPL_Save >= 3) call RecPrt('Energies','(8G16.10)',EnergyArray,nRoots,mDisp)
call mma_Allocate(GradArray,nDisp,nRoots)
call FZero(GradArray,nDisp*nRoots)
call mma_Allocate(Grad,nRoots)

iDisp = nLambda
do i=1,nDisp

  if (Disp(i) == Zero) then
    if (iPL_Save >= 3) then
      if (KeepOld) then
        write(u6,*) 'gradient set to old value'
      else
        write(u6,*) 'gradient set to zero'
      end if
    end if
    do iR=1,nRoots
      Grad(iR) = OldGrads(i,iR)
    end do
  else
    iDisp = iDisp+1
    do iR=1,nRoots
      iEp = iDisp*2-1
      EPlus = EnergyArray(iR,iEp)
      iEm = iDisp*2
      EMinus = EnergyArray(iR,iEm)
      Dsp = Disp(i)
      Grad(iR) = (EPlus-EMinus)/(Two*Dsp)

      ! If the gradient is not close to zero check that it is
      ! consistent. For CASPT2/CASSCF sometimes the active space
      ! breaks down and the computed gradient is rubbish. If we
      ! are lucky this happens only in one of the displacement
      ! directions. In that case compute the gradient with the
      ! one-point equation. The one with the lowest gradient is
      ! the one which is most likely to be correct.
      if (abs(Grad(iR)) > 0.1_wp) then
        Energy_Ref = Energies_Ref(iR)
        Grada = (EPlus-Energy_Ref)/Dsp
        Gradb = (Energy_Ref-EMinus)/Dsp
        if ((abs(Grad(iR)/Grada) > OneHalf) .or. (abs(Grad(iR)/Gradb) > OneHalf)) then
          if (abs(Grada) <= abs(Gradb)) then
            Grad(iR) = Grada
          else
            Grad(iR) = Gradb
          end if
        end if
      end if
    end do
  end if

  call dCopy_(nRoots,Grad,1,GradArray(i,1),nDisp)

end do
!call RecPrt('Grads (old)',' ',OldGrads,3*nAtoms,nRoots)
!call RecPrt('BMtrx',' ',BMtrx,3*nAtoms,nDisp)
!                                                                      *
!***********************************************************************
!                                                                      *
!     Compute the gradient in Cartesian coordinates
!
call mma_allocate(Tmp2,nDisp,Label='Tmp2')
call mma_allocate(Tmp,3,nAtoms,Label='Tmp')
do iR=1,nRoots
  Tmp2(:) = Zero
  Tmp(:,:) = Zero

  ! Transform the gradient in PCO basis to the internal coordinate
  ! format.

  call DGEMM_('N','N',nDisp,1,nDisp,One,TMtrx,nDisp,GradArray(1,iR),nDisp,Zero,Tmp2,nDisp)

  ! Transform internal coordinates to Cartesian.

  call DGEMM_('N','N',3*nAtoms,1,nDisp,One,BMtrx,3*nAtoms,Tmp2,nDisp,Zero,Tmp,3*nAtoms)
  !call RecPrt('Tmp',' ',Tmp,3,nAtoms)

  ! Modify with degeneracy factors.

  if (.not. NMCart) then
    do iAtom=1,nAtoms
      do ixyz=1,3
        Tmp(ixyz,iAtom) = Tmp(ixyz,iAtom)/Deg(ixyz,iAtom)
      end do
    end do
  end if

  ! Add the MM contribution for MM atoms

  if (nAtMM /= 0) then
    call daxpy_(3*nAtoms,One,MMGrd,1,Tmp,1)
  end if

  ! Apply Morokuma's scheme if needed

  call F_Inquire('QMMM',Exists)
  if (Exists .and. DoTinker) then
    call LA_Morok(nAtoms,Tmp,1)
  end if

  if (iR == iRoot) call Put_Grad(Tmp,3*nAtoms)
  call Add_Info('Grad',Tmp,3*nAtoms,6)
  call Store_grad(Tmp,3*nAtoms,iR,0,0)

  if (iPL >= 2) then
    write(LuWr,*)
    write(LuWr,'(1x,A,I5)') 'Numerical gradient, root ',iR
    write(LuWr,'(2x,A)') '---------------------------------------------'
    write(LuWr,'(2x,A)') '               X           Y           Z'
    write(LuWr,'(2x,A)') '---------------------------------------------'
    do iAtom=1,nAtoms
      TempX = Tmp(1,iAtom)
      TempY = Tmp(2,iAtom)
      TempZ = Tmp(3,iAtom)
      Namei = AtomLbl(iAtom)
      write(LuWr,'(2X,A,3X,3F12.6)') Namei,TempX,TempY,TempZ
    end do
    write(LuWr,'(2x,A)') '---------------------------------------------'
  end if
end do
call mma_deallocate(Tmp2)
call mma_deallocate(Tmp)
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate

call mma_deallocate(Deg)
call mma_deallocate(Disp)
call mma_deallocate(AllC)
call mma_Deallocate(TMtrx)
call mma_Deallocate(BMtrx)
call mma_Deallocate(EnergyArray)
call mma_Deallocate(GradArray)
call mma_Deallocate(OldGrads)
call mma_Deallocate(Grad)
call mma_deallocate(Coor)
call mma_deallocate(Energies_Ref)
call mma_deallocate(AtomLbl)
if (DoTinker) call mma_deallocate(IsMM)
if (nAtMM > 0) call mma_deallocate(MMGrd)

! Since Numerical_Gradient itself cleans up after the modules
! then it's necessary to force nfld_tim and nfld_stat to zero,
! or finish will scream.

nfld_tim = 0
nfld_stat = 0

! Restore iRlxRoot if changed as set by the RASSCF module.

if ((Method(1:6) == 'CASSCF') .or. &
    (Method(1:6) == 'RASSCF')) then
  call Get_iScalar('Relax CASSCF root',irlxroot1)
  call Get_iScalar('Relax Original root',irlxroot2)
  if (iRlxRoot1 /= iRlxRoot2) then
    call Put_iScalar('Relax CASSCF root',irlxroot2)
    call Put_iScalar('NumGradRoot',irlxroot2)
  end if
end if

return

200 format(A,I4,A,I4,A)

end subroutine Numerical_Gradient

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

subroutine TimesE2MSPDFT(Kap,ipCId,isym,reco,jspin,ipS2,KapOut,ipCiOut)

use ipPage, only: ipin, opout, W
use MCLR_Data, only: n2Dens, nConf1, nDens, nDensC
use input_mclr, only: nAsh, nRoots, nRS2, Weight
use dmrginfo, only: DoDMRG, LRRAS2, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Kap(nDensC), ReCo
integer(kind=iwp), intent(in) :: ipCId, isym, jspin, ipS2, ipCiOut
real(kind=wp), intent(out) :: KapOut(nDensC)
integer(kind=iwp) :: kRoot, lRoot
real(kind=wp) :: ECoff, rdum(1)
real(kind=wp), allocatable :: Temp3(:), Temp4(:), Sc1(:), Sc2(:), Sc3(:), RMOAA(:), MSHam(:)

call mma_allocate(RMOAA,n2Dens,Label='RMOAA')
call mma_allocate(Sc1,nDens,Label='Sc1')
call mma_allocate(Sc2,nDens,Label='Sc2')
call mma_allocate(Sc3,nDens,Label='Sc3')
call mma_allocate(Temp3,nDens,Label='Temp3')
call mma_allocate(Temp4,nDens,Label='Temp4')

if (doDMRG) then ! yma
  nash(:) = RGras2(:)
  nrs2(:) = RGras2(:)
end if
call Uncompress(Kap,Sc1,isym)

! Integral derivative !yma
call RInt_generic(SC1,rmoaa,rdum,Sc2,Temp3,Temp4,Sc3,isym,reco,jspin)

call Kap_CI(Temp4,nDens,rmoaa,n2Dens,ipCIOUT)
call Ci_Ci(ipcid,ipS2)
call CI_KAP(ipCid,Sc1,Sc3,isym)

Sc1(:) = Sc2(:)+Sc3(:)

call Compress(Sc1,KapOut,isym)   ! ds
!call RecPrt('Ex',' ',KapOut,nDensC,1)

call ipin(ipS2)
call ipin(ipCIOUT)
W(ipCIOUT)%A(1:nConf1*nroots) = W(ipCIOUT)%A(1:nConf1*nroots)+W(ipS2)%A(1:nConf1*nroots)
call opOut(ipCId)

! Adding Hkl contribution
call mma_allocate(MSHam,nRoots**2)
call CMSRdMat(MSHam,nRoots,nRoots,'ROT_HAM',7)
do kRoot=1,nRoots
  do lRoot=1,nRoots
    if (kRoot == lRoot) cycle
    ECOff = -MSHam(nRoots*(kRoot-1)+lRoot)*Weight(1)*Two
    W(ipCIOut)%A((kRoot-1)*nConf1+1:kRoot*nConf1) = W(ipCIOut)%A((kRoot-1)*nConf1+1:kRoot*nConf1)+ &
                                                    ECOff*W(ipCId)%A((lRoot-1)*nConf1+1:lRoot*nConf1)
  end do
end do
call mma_deallocate(MSHam)
! End of adding Hkl contribution

call mma_deallocate(Temp4)
call mma_deallocate(Temp3)
call mma_deallocate(Sc3)
call mma_deallocate(Sc2)
call mma_deallocate(Sc1)
call mma_deallocate(rmoaa)

if (doDMRG) nash(:) = LRras2(:)  ! yma

end subroutine TimesE2MSPDFT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_XCV_Distrib_SP(mySP,l_mySP,N_mySP)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Determine distribution of Shell Pairs according to their
C     dimension.
C
      Implicit None
      Integer l_mySP
      Integer mySP(l_mySP)
      Integer N_mySP
#include "cho_para_info.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer  Cho_iFindSmallest
      External Cho_iFindSmallest

      Integer iSP, iNode, n, iSym
      Integer ip_Dim, l_Dim

      Integer nnBstRSh
      Integer i, j, k
      nnBstRSh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)

#if defined (_DEBUGPRINT_)
      If (l_mySP.lt.nnShl) Then
         Call Cho_Quit('Dimension error in Cho_XCV_Distrib_SP',103)
      End If
#endif

      If (Cho_Real_Par) Then
         l_Dim=nProcs
         Call GetMem('ProcDim','Allo','Inte',ip_Dim,l_Dim)
         Call iZero(iWork(ip_Dim),l_Dim)
         N_mySP=0
         Do iSP=1,nnShl
            n=nnBstRSh(1,iSP,1)
            Do iSym=2,nSym
               n=n+nnBstRSh(iSym,iSP,1)
            End Do
            If (n.gt.0) Then
               iNode=Cho_iFindSmallest(iWork(ip_Dim),l_Dim)-1
               iWork(ip_Dim+iNode)=iWork(ip_Dim+iNode)+n
               If (iNode.eq.myRank) Then
                  N_mySP=N_mySP+1
                  mySP(N_mySP)=iSP
               End If
            End If
         End Do
         Call GetMem('ProcDim','Free','Inte',ip_Dim,l_Dim)
      Else
         N_mySP=0
         Do iSP=1,nnShl
            n=nnBstRSh(1,iSP,1)
            Do iSym=2,nSym
               n=n+nnBstRSh(iSym,iSP,1)
            End Do
            If (n.gt.0) Then
               N_mySP=N_mySP+1
               mySP(N_mySP)=iSP
            End If
         End Do
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DerCav(ToAng,nTs,nAt,nS,nAt3,Eps,Tessera,Q,Qtot,Der1,
     $  Dertes,DerPunt,DerCentr,DerRad,QDer,Sphere,iSphe,
     $  nOrd)
      Implicit Real*8(a-h,o-z)
      Dimension Sphere(4,*),iSphe(*),nOrd(*)
      Dimension Tessera(4,*),Q(2,*),Qtot(*)
      Dimension Der1(*)
      Dimension DerTes(nTs,nAt,3), DerPunt(nTs,nAt,3,3)
      Dimension DerRad(nS,nAt,3),DerCentr(nS,nAt,3,3)
      Dimension QDer(3,nAt,*)
      Save Zero,One,Two,Four
      Data Zero/0.0d0/,One/1.0d0/,Two/2.0d0/,Four/4.0d0/
*
*---- Derivative of the cavity factor U_x(q)=2 Pi Eps/(Eps-1) sum_i [Qtot**2 * n_x]
*
      dN=Zero ! Dummy initialization.
      Pi = Four*ATan(One)
      Fact = Two * PI * Eps / (Eps-One)
c     Double loop on atoms and coordinates
      Do 100 Index1 = 1, nAt3
        iAt1 = Int( (Index1-1)/3 ) + 1
        iCoord1 = Index1 - 3 * (iAt1-1)
        Do 101 Index2 = 1, nAt3
          iAt2 = Int( (Index2-1)/3 ) + 1
          iCoord2 = Index2 - 3 * (iAt2-1)
c         Derivative of the normal factor n_x
          Call Der_Norm(ToAng,iAt1,iCoord1,iAt2,iCOord2,nTs,nAt,nS,
     &    Tessera,Der1,DerRad,DerTes,DerPunt,Sphere,iSphe,nOrd)
c         Find out if atom iAt2 has a sphere around
          iAt2_S = 0
          Do iS = 1, nS
           If(iAt2.eq.nOrd(iS)) iAt2_S = iS
          EndDo
          Sum1 = Zero
          Sum2 = Zero
c         Loop on tesserae
          Do 200 iTs = 1, nTs
            L = iSphe(iTs)
            XN = - (Sphere(1,L) - Tessera(1,iTs)) / Sphere(4,L)
            YN = - (Sphere(2,L) - Tessera(2,iTs)) / Sphere(4,L)
            ZN = - (Sphere(3,L) - Tessera(3,iTs)) / Sphere(4,L)
            If(L.eq.iAt2_S) then
             if(iCoord2.eq.1)dN = XN
             if(iCoord2.eq.2)dN = YN
             if(iCoord2.eq.3)dN = ZN
            Else
              dCent = XN * DerCentr(L,iAt2,iCoord2,1)
     &              + YN * DerCentr(L,iAt2,iCoord2,2)
     &              + ZN * DerCentr(L,iAt2,iCoord2,3)
              dN = DerRad(L,iAt2,iCoord2) + dCent
            EndIf
            DerQ = QDer(iCoord1,iAt1,iTs)
            Sum1 = Sum1 + Two * Qtot(iTs) * DerQ * dN / Tessera(4,iTs)
            Sum2 = Sum2 + Qtot(iTs) * Qtot(iTs) * Der1(iTs)
  200     Continue
          UDer = Fact * (Sum1 + Sum2)
  101   Continue
  100 Continue
cpcm_solvent
c      write(6,
c    & '(''In DerCav tesserae coord., area, qnuc and qel'')')
c     Do Its = 1, nTs
c       write(6,'(6f12.6)')(Tessera(j,iTs),j=1,4),q(1,iTs),q(2,iTs)
c     EndDo
cpcm_solvent end
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Q)
      End

      Subroutine Der_Norm(ToAng,iAt1,iCoord1,iAt2,iCOord2,nTs,nAt,nS,
     &  Tessera,Der1,DerRad,DerTes,DerPunt,Sphere,iSphe,nOrd)
      Implicit Real*8(A-H,O-Z)
      Dimension Der1(*),Sphere(4,*),iSphe(*),nOrd(*),Tessera(4,*)
      Dimension DerTes(nTs,nAt,3), DerPunt(nTs,nAt,3,3)
      Dimension DerRad(nS,nAt,3)
      Data Zero, One /0.0d0, 1.0d0/
c
      AnToAU = One / ToAng
c     Find out if atom iAt1 has a sphere around
      iAt1_S = 0
      Do iS = 1, nS
        If(iAt1.eq.nOrd(iS)) iAt1_S = iS
      EndDo
*
*---- Compute the derivative of the normal vector over the tessera area
*
c     Loop on tiles
      dN = Zero ! Dummy initialization.
      Do 100 iTs = 1, nTs
        L = iSphe(iTs)
        Der1(iTs) = Zero
        If(L.eq.iAt1_S) then
          If(iCoord1.eq.1) dN = (Sphere(1,L)-Tessera(1,iTs))/Sphere(4,L)
          If(iCoord1.eq.2) dN = (Sphere(2,L)-Tessera(2,iTs))/Sphere(4,L)
          If(iCoord1.eq.3) dN = (Sphere(3,L)-Tessera(3,iTs))/Sphere(4,L)
          dN_Its = DerPunt(iTs,iAt2,iCoord2,iCoord1)
     &           + dN * DerRad(L,iAt2,iCoord2)
          dN_Its = - dN_Its / Sphere(4,L)
        else
          dN = Zero
          dN_Its = Zero
        EndIf
        SqArea = Tessera(4,iTs) * Tessera(4,iTs)
        Der_1 = - dN * DerTes(iTs,iAt2,iCoord2) * AnToAU / SqArea
        Der1(its) = - dN_Its / Tessera(4,iTs) - Der_1
  100  Continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018,2019, Roland Lindh                                *
*               2019, Mickael G. Delcey                                *
*               2019, Ignacio Fdez. Galvan                             *
************************************************************************
      SUBROUTINE PRPROP_TM_Exact(PROP,USOR,USOI,ENSOR,NSS,JBNUM,EigVec)
      USE RASSI_AUX
      USE kVectors
      USE do_grid, only: Do_Lebedev_Sym
#ifdef _HDF5_
      USE mh5, ONLY: mh5_put_dset
#endif
#include "compiler_features.h"
#ifndef POINTER_REMAP
      USE ISO_C_Binding
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION USOR(NSS,NSS),USOI(NSS,NSS),ENSOR(NSS)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='PRPROP_TM')
      parameter (THRSH=1.0D-10)
      parameter (ZERO=0.0D0)
#include "symmul.fh"
#include "rassi.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "WrkSpc.fh"
#include "constants.fh"
#include "stdalloc.fh"
      DIMENSION PROP(NSTATE,NSTATE,NPROP),JBNUM(NSTATE),
     &          EigVec(NSTATE,NSTATE)
#include "SysDef.fh"
#include "rassiwfn.fh"
      LOGICAL TMOgroup
      INTEGER IOFF(8),IJSS(4),IPRTMOM(14)
      CHARACTER*8 LABEL
      CHARACTER*6 STLNE1
      CHARACTER*52 STLNE2
      Integer, Dimension(:), Allocatable :: TMOgrp1,TMOgrp2,ISS_INDEX,
     &   iMask,jMask,iSSMask,jSSMask
      Real*8 TM_R(3), TM_I(3), TM_C(3)
      Real*8 wavevector(3), UK(3)
      Real*8 kPhase(2)
      Real*8, Allocatable :: pol_Vector(:,:), Rquad(:,:)
#ifdef _HDF5_
      Real*8, Allocatable, Target :: Storage(:,:,:,:)
      Real*8, Pointer :: flatStorage(:)
#endif
      Real*8, Allocatable:: TDMZZ(:),TSDMZZ(:),WDMZZ(:), SCR(:,:)
      Real*8, Allocatable:: VSOR(:,:), VSOI(:,:), TMP(:)

#define _TIME_TMOM_
#ifdef _TIME_TMOM_
      Call CWTime(TCpu1,TWall1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Before we start we need to backtransform the coefficients of the
*     SO states from the basis of the SF states which diagonalize the
*     SF Hamiltonian to the basis of the original (input) SF states.
*     This since all transition moments, whether retrieved from disk or
*     recomputed, are in the basis of the original SF states.
*
      Call mma_allocate(VSOR,NSS,NSS,Label='VSOR')
      Call mma_allocate(VSOI,NSS,NSS,Label='VSOI')
*
      Call USOTRANS(USOR,USOI,NSS,
     &              EigVec,NSTATE,
     &              VSOR,VSOI)
*
*                                                                      *
************************************************************************
*                                                                      *
      DEBYE=CONV_AU_TO_DEBYE_
      AU2REDR=2.0D2*DEBYE
      ! AFACTOR = 2*pi*e^2*E_h^2 / eps_0*m_e*c^3*h^2
      ! 1/c^3 (in a.u. of time ^ -1)
      AFACTOR = 2.0D0/CONST_C_IN_AU_**3
     &          /CONST_AU_TIME_IN_SI_
      HALF=0.5D0
      PI= CONST_PI_
      SPEED_OF_LIGHT=CONST_C_IN_AU_
      G_Elec=CONST_ELECTRON_G_FACTOR_

*define _TIME_TMOM_
#ifdef _TIME_TMOM_
      Call CWTime(TCpu1,TWall1)
#endif
C Compute transition strengths for spin-orbit states:
*
* Initial setup for exact operator
*
C printing threshold
      OSTHR=1.0D-5
      IF(DIPR) OSTHR = OSTHR_DIPR
      IF(DIPR) WRITE(6,30) 'Dipole printing threshold changed to ',OSTHR
! Again to avoid total negative transition strengths
      IF(QIPR) OSTHR = OSTHR_QIPR
      IF(QIPR) THEN
        WRITE(6,49)  'Printing threshold changed to ',OSTHR,
     &              ' since quadrupole threshold is given '
      END IF
! Rotatory strength threshold
      IF(RSPR) THEN
        WRITE(6,30) 'Rotatory strength printing threshold changed '//
     &             'to ',RSTHR
      ELSE
        RSTHR = 1.0D-07 !Default
      END IF
!
!     Reducing the loop over states - good for X-rays
!     At the moment memory is not reduced
!
      IF(REDUCELOOP) THEN
        IEND = LOOPDIVIDE
        JSTART = LOOPDIVIDE+1
      ELSE
        IEND = NSS
        JSTART = 1
      END IF
*
************************************************************************
*                                                                      *
*     Start of section for transition moments                          *
*                                                                      *
*     This section has two parts. (1) for matrix elements computed by  *
*     Seward, i.e. for a specific wavevector, (2) for the computation  *
*     of the isotropic oscillator strength.                            *
*                                                                      *
************************************************************************
*
*     Find the section of transition moments in the property list.
*
*     The operator is split in 4 different component, each with three
*     elements corresponding to differentiation in the x, y, and z
*     direction. The four parts are labels as:
*     TMOM  RS: The symmetric part of the real comp. of the op.
*     TMOM  RA: The asymmetric part of the real comp. of the op.
*     TMOM  IS: The symmetric part of the imaginary comp. of the op.
*     TMOM  IA: The asymmetric part of the imaginary comp. of the op.
*
************************************************************************
*                                                                      *
*     Section (1): Computation of k specific oscillator strength.      *
*     Section (2): Computation of the isotropic oscillator strength.   *
*                                                                      *
************************************************************************
*
*     Here we will use a Lebedev grid to integrate over all possible
*     directions of the wave vector, k. The property integrals will be
*     computed on the fly and traced with the density to generate the
*     corresponding values in the PROP matrix.
*
*     Find the slot on the one-electron file where we will store the
*     on-the-fly generated property integrals.
*
      IPRTMOM(:)=-1
      DO IPROP=1,NPROP
         IF (PNAME(IPROP).EQ.'TMOM  RS') THEN
            IF (IPRTMOM(0+ICOMP(IPROP)).EQ.-1)
     &          IPRTMOM(0+ICOMP(IPROP))=IPROP
         END IF
         IF (PNAME(IPROP).EQ.'TMOM  IS') THEN
            IF (IPRTMOM(3+ICOMP(IPROP)).EQ.-1)
     &          IPRTMOM(3+ICOMP(IPROP))=IPROP
         END IF
         IF (PNAME(IPROP).EQ.'TMOM  RA') THEN
            IF (IPRTMOM(6+ICOMP(IPROP)).EQ.-1)
     &          IPRTMOM(6+ICOMP(IPROP))=IPROP
         END IF
         IF (PNAME(IPROP).EQ.'TMOM  IA') THEN
            IF (IPRTMOM(9+ICOMP(IPROP)).EQ.-1)
     &          IPRTMOM(9+ICOMP(IPROP))=IPROP
         END IF
         IF (PNAME(IPROP).EQ.'TMOM0  R') THEN
            IF (IPRTMOM(13).EQ.-1) IPRTMOM(13)=IPROP
         END IF
         IF (PNAME(IPROP).EQ.'TMOM0  I') THEN
            IF (IPRTMOM(14).EQ.-1) IPRTMOM(14)=IPROP
         END IF
      ENDDO
      IF (ANY(IPRTMOM.EQ.-1)) Go To 666
*
*     Initiate the Seward environment
*
      nDiff=0
      Call IniSew(.FALSE.,nDiff)
*
*     Generate the quadrature points.
*
*     In the spin-coupled case, wave functions are complex and there is
*     not a simple relation between oscillator and rotatory strengths for
*     k and -k vectors, but there is between the integrals computed in
*     the spin-free basis, so we compute them only once and obtain separately
*     the results for k and -k, given by kPhase
*
      kPhase = [1.0D0, -1.0D0]
      If (Do_SK) Then
         nQuad = 1
         nVec=nk_Vector
         Call mma_allocate(Rquad,4,nQuad,label='SK')
         If (.Not.(PRRAW.Or.PRWEIGHT)) kPhase(2) = 0.0D0
      Else
         Call Setup_O()
         Call Do_Lebedev_Sym(L_Eff,nQuad,Rquad)
         nVec = 1
      End If
      If (Do_Pol) Call mma_allocate(pol_Vector,3,nVec*nQuad,Label='POL')
*
*     Initialize for density matrices.
*
      Call mma_Allocate(TDMZZ,nTDMZZ,Label='TDMZZ')
      Call mma_Allocate(TSDMZZ,nTDMZZ,Label='TSDMZZ')
      Call mma_Allocate(WDMZZ,nTDMZZ,Label='WDMZZ')
      nSCR=(NBST*(NBST+1))/2
      Call mma_allocate(SCR,nSCR,4,LABEL='SCR')

*
*     Allocate some temporary arrays for handling the
*     properties of the spin-orbit states.
*
      CALL GETMEM('DXR','ALLO','REAL',LDXR,3*NSS**2)
      CALL GETMEM('DXI','ALLO','REAL',LDXI,3*NSS**2)
      CALL GETMEM('DXRM','ALLO','REAL',LDXRM,3*NSS**2)
      CALL GETMEM('DXIM','ALLO','REAL',LDXIM,3*NSS**2)
      Call mma_Allocate(TMP,NSS**2,Label='TMP')
      CALL GETMEM('TMR','ALLO','REAL',LTMR,3*NSS**2)
      CALL GETMEM('TMI','ALLO','REAL',LTMI,3*NSS**2)
*
C     ALLOCATE A BUFFER FOR READING ONE-ELECTRON INTEGRALS
      NIP=4+(NBST*(NBST+1))/2
      CALL GETMEM('IP    ','ALLO','REAL',LIP,NIP)
#ifdef _HDF5_
*
*     Allocate vector to store all individual transition moments.
*     We do this for
*     all unique pairs ISO-JSO, iSO=/=JSO (NSS*(NSS-1)/2)
*         all k-vectors (2*nQuad or 2*nVec)
*             we store:
*                 the weight (1)
*                 the k-vector (3)
*                 we projected transition vector (real and imaginary parts) (2*3)
*
      nIJ=nSS*(nSS-1)/2
      ip_w       = 1
      ip_kvector = ip_w + 1
      ip_TMR     = ip_kvector + 3
      ip_TMI     = ip_TMR + 3
      nData      = ip_TMI + 3 - 1
      Call mma_allocate(Storage,nData,2*nQuad,nIJ,nVec,label='Storage')
      Call dCopy_(Size(Storage),[0.0D0],0,Storage,1)
#endif
*MGD group transitions
      TMOgroup=.false.
      ngroup1=IEND
      ngroup2=NSS-JSTART+1
      nmax2=1
      IF(REDUCELOOP.and.TMGr_thrs.ge.0.0d0) THEN
        TMOgroup=.true.
        THRS=TMGr_thrs
        i=IEND
        RefEne=0
        TAU=-1
        ngroup2=1
        Do j=JSTART,NSS
          if (ENSOR(J)-Refene.gt.TAU) then
              NGROUP2=NGROUP2+1
              Refene=ENSOR(J)
              ediff=Refene-ENSOR(I)
              TAU=ediff*THRS
           EndIf
        End Do
        Call mma_Allocate(TMOgrp2,NGROUP2,Label='TMOgrp2')
        ngroup2=0
        TAU=-1
        RefEne=0
        Do j=JSTART,NSS
          if (ENSOR(J)-Refene.gt.TAU) then
              NGROUP2=NGROUP2+1
              TMOgrp2(NGROUP2)=J
              Refene=ENSOR(J)
              ediff=Refene-ENSOR(I)
              TAU=ediff*THRS
           EndIf
        End Do
        TMOgrp2(ngroup2+1)=NSS+1
*
        j=JSTART
        Refene=ENSOR(j)
        TAU=-1
        ngroup1=1
        Do i=IEND,1,-1
          if (Refene-ENSOR(i).gt.TAU) then
            ngroup1=ngroup1+1
            Refene=ENSOR(i)
            ediff=ENSOR(j)-Refene
            Tau=ediff*THRS
          EndIf
        End Do
        Call mma_Allocate(TMOgrp1,NGROUP1,Label='TMOgrp1')
        Ntmp=Ngroup1
        Ngroup1=Ngroup1-1
        Refene=ENSOR(j)
        TAU=-1
        Do i=IEND,1,-1
          if (Refene-ENSOR(i).gt.TAU) then
            TMOgrp1(ntmp)=i+1
            ntmp=ntmp-1
            Refene=ENSOR(i)
            ediff=ENSOR(j)-Refene
            Tau=ediff*THRS
          EndIf
        End Do
        TMOgrp1(1)=1
        maxgrp1=0
        Do i=1,ngroup1
          maxgrp1=max(maxgrp1,TMOgrp1(i+1)-TMOgrp1(i))
        End Do
        maxgrp2=0
        Do i=1,ngroup2
          maxgrp2=max(maxgrp2,TMOgrp2(i+1)-TMOgrp2(i))
        End Do
        nmax2=maxgrp1*maxgrp2
      EndIF
*
*     Array for printing contributions from different directions
*
      CALL GETMEM('RAW   ','ALLO','REAL',LRAW,2*NQUAD*6*nmax2)
      CALL GETMEM('OSCSTR','ALLO','REAL',LF,2*nmax2)
      CALL GETMEM('MAXMIN','ALLO','REAL',LMAX,8*nmax2)
      LMAX_=0
*
      Do iVec = 1, nVec
*
         If (Do_SK) Then
            Rquad(1:3,1)=k_Vector(:,iVec)
            Rquad(4,1)=1.0D0   ! Dummy weight
         End If
*
      iPrint=0
      IJSO=0
*
      ThrSparse=1.0D-12
*
      Call mma_allocate(iMask,NState,LABEL='iMask')
      Call mma_allocate(jMask,NState,LABEL='jMask')
      Call mma_allocate(iSSMask,NSS,LABEL='iSSMask')
      Call mma_allocate(jSSMask,NSS,LABEL='jSSMask')
*
      CALL mma_allocate(ISS_INDEX,NState+1,LABEL='ISS_INDEX')
      ISS_INDEX(1)=0
      Do iState=1,NState
         Job=JBNUM(iState)
         ISS_INDEX(iState+1)=ISS_INDEX(IState)+MLTPLT(Job)
      End Do
*
      Do igrp=1,ngroup1
*
         If (TMOgroup) Then
            istart_=TMOgrp1(igrp)
            iend_=TMOgrp1(igrp+1)-1
            ENSOR1=0.5D0*(ENSOR(istart_)+ENSOR(iend_))
         Else
            istart_=igrp
            iend_=igrp
            ENSOR1=ENSOR(istart_)
         EndIf
*Screening
         Call iCopy(NState,[0],0,iMask,1)
         Call iCopy(NSS,[0],0,iSSMask,1)
         ISM=0
         ISSM=0
         ISFLoop: Do ISF=1,NState
           Do ISS=ISS_INDEX(ISF)+1,ISS_INDEX(ISF+1)
             Do ISO=istart_,iend_
               Temp=VSOR(ISS,ISO)**2 + VSOI(ISS,ISO)**2
               If (Temp.gt.ThrSparse) Then
                 ISM=ISM+1
                 iMask(ISM)=ISF
                 Do IMSS=ISS_INDEX(ISF)+1,ISS_INDEX(ISF+1)
                   ISSM=ISSM+1
                   iSSMask(ISSM)=IMSS
                 End Do
                 Cycle ISFLoop
               End If
             End Do
           End Do
         End Do ISFLoop
*
         Do jgrp=1,ngroup2
*
            If (TMOgroup) Then
              jstart_=TMOgrp2(jgrp)
              jend_=TMOgrp2(jgrp+1)-1
              ENSOR2=0.5D0*(ENSOR(jstart_)+ENSOR(jend_))
            Else
              jstart_=jgrp+jstart-1
              jend_=jgrp+jstart-1
              ENSOR2=ENSOR(jstart_)
            EndIf
            EDIFF_=ENSOR2-ENSOR1
            n12=(iend_-istart_+1)*(jend_-jstart_+1)
*Screening
            Call iCopy(NState,[0],0,jMask,1)
            Call iCopy(NSS,[0],0,jSSMask,1)
            JSM=0
            JSSM=0
            JSFLoop: Do JSF=1,NState
              Do JSS=ISS_INDEX(JSF)+1,ISS_INDEX(JSF+1)
                Do JSO=jstart_,jend_
                  Temp=VSOR(JSS,JSO)**2 + VSOI(JSS,JSO)**2
                  If (Temp.gt.ThrSparse) Then
                    JSM=JSM+1
                    jMask(JSM)=JSF
                    Do JMSS=ISS_INDEX(JSF)+1,ISS_INDEX(JSF+1)
                      JSSM=JSSM+1
                      jSSMask(JSSM)=JMSS
                    End Do
                    Cycle JSFLoop
                  End If
                End Do
              End Do
            End Do JSFLoop
*
            IJSS(1)=istart_
            IJSS(2)=iend_
            IJSS(3)=jstart_
            IJSS(4)=jend_
*
            WRITE(STLNE1,'(A6)') 'RASSI:'
            WRITE(STLNE2,'(A33,I5,A5,I5)')
     &         'Trans. intensities for SO groups ',igrp,' and ',jgrp
            Call StatusLine(STLNE1,STLNE2)
*
            IF (ABS(EDIFF_).LE.1.0D-8) CYCLE
            IF(EDIFF_.LT.0.0D0) CYCLE
            IJSO=IJSO+1
*
*           The energy difference is used to define the norm of the
*           wave vector.
*
            rkNorm=ABS(EDIFF_)/SPEED_OF_LIGHT
*
*           For the case the energy difference is negative we
*           need to change the sign of the B.s term to get
*           consistency.
*
            cst=SIGN(Half,EDIFF_)*g_Elec
*
*           Iterate over the quadrature points.
*
*           Initialize output arrays
*
            CALL DCOPY_(2*n12,[0.0D0],0,WORK(LF),1)
            CALL DCOPY_(2*NQUAD*6*n12,[0.0D0],0,WORK(LRAW),1)
            CALL DCOPY_(8*n12,[0.0D0],0,WORK(LMAX),1)
*
            Do iQuad = 1, nQuad
               iVec_=(iVec-1)*nQuad+iQuad
*
*              Generate the wavevector associated with this quadrature
*              point and pick up the associated quadrature weight.
*
               UK(:)=Rquad(1:3,iQuad)
               wavevector(:)=rkNorm*UK(:)
*
*              Note that the weights are normalized to integrate to
*              4*pi over the solid angles.
*
               Weight=Rquad(4,iQuad)
               If (.Not.Do_SK) Weight = Weight/(4.0D0*PI)
*
*              Generate the polarization vector
*
               If (Do_Pol) Then
                  pol_Vector(:,iVec_)=
     &               e_Vector-DDot_(3,UK,1,e_Vector,1)*UK
                  rNorm=DDot_(3,pol_Vector(:,iVec_),1,
     &                         pol_Vector(:,iVec_),1)
                  If (rNorm.gt.1.0D-12) Then
                     pol_Vector(:,iVec_)=pol_Vector(:,iVec_)/Sqrt(rNorm)
                  Else
                     pol_Vector(:,iVec_)=0.0D0
                  End If
               End If
*
*              Generate the property integrals associated with this
*              direction of the wave vector k.
*
               iOpt=2
               Call TMOMInt(wavevector,iOpt)
*
************************************************************************
*                                                                      *
*              Recompute the needed properties for all the spin-free   *
*              states.                                                 *
*                                                                      *
************************************************************************
*
               Do IPRP = 1,14
                  IPROP = IPRTMOM(IPRP)
                  Call FZero(PROP(1,1,IPROP),NSTATE**2)
               End Do

               DO ISS=1,ISM
*
*                 Does this spin-free state contribute to any of the
*                 two spin states? Check the corresponding coefficients.
*
                  i=iMask(ISS)
                  DO JSS=1,JSM
                     j=jMask(JSS)
*
*                    COMBINED SYMMETRY OF STATES:
                     JOB1=JBNUM(I)
                     JOB2=JBNUM(J)
                     LSYM1=IRREP(JOB1)
                     LSYM2=IRREP(JOB2)
                     ISY12=MUL(LSYM1,LSYM2)
*                    THE SYMMETRY CHECK MASK:
                     MASK=2**(ISY12-1)
*                    FIRST SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS OF
*                    TDMSCR
                     Call mk_IOFF(IOFF,nSYM,NBASF,ISY12)
*
*                    Pick up the transition density between the two
*                    states from disc. Generated in GTDMCTL.
*
                     IDISK=iDisk_TDM(I,J,1)
                     iEmpty=iDisk_TDM(I,J,2)
                     iOpt=2
                     iGO=5
                     CALL dens2file(TDMZZ,TSDMZZ,WDMZZ,nTDMZZ,
     &                              LUTDM,IDISK,iEmpty,iOpt,iGo,I,J)
                     Call MK_TWDM(nSym,TDMZZ,WDMZZ,nTDMZZ,SCR,nSCR,
     &                            IOFF,NBASF,ISY12)
*
*                    Compute the transition property of the property
*                    integrals between the two states.
*
                     DO IPRP = 1,14
                        IPROP = IPRTMOM(IPRP)
                        ITYPE=0
                        IF (PTYPE(IPROP).EQ.'HERMSING') ITYPE=1
                        IF (PTYPE(IPROP).EQ.'ANTISING') ITYPE=2
                        IF (PTYPE(IPROP).EQ.'HERMTRIP') ITYPE=3
                        IF (PTYPE(IPROP).EQ.'ANTITRIP') ITYPE=4
                        LABEL=PNAME(IPROP)
                        Call MK_PROP(PROP,IPROP,I,J,
     &                               LABEL,ITYPE,
     &                               WORK(LIP),NIP,SCR,nSCR,
     &                               MASK,ISY12,IOFF)
                     END DO
*
                  END DO ! J
               END DO ! I
*
*              LDXR & LDXI hold the component that does not change from k to -k
*              LDXRM & LDXIM hold the component that changes sign
*
               CALL DCOPY_(3*NSS**2,[0.0D0],0,WORK(LDXR),1)
               CALL DCOPY_(3*NSS**2,[0.0D0],0,WORK(LDXI),1)
               CALL DCOPY_(3*NSS**2,[0.0D0],0,WORK(LDXRM),1)
               CALL DCOPY_(3*NSS**2,[0.0D0],0,WORK(LDXIM),1)
               DO iCar = 1, 3
*
*              (1) the spin-free part.
*                 Note that the integrals are not computed for the
*                 momentum operator but rather for nabla. That is
*                 as we assemble to transition momentum we have to
*                 remember to put in a factor of -i.
*
                  LI_=LDXI+(iCar-1)*NSS**2
                  LRM_=LDXRM+(iCar-1)*NSS**2
*
*                 The real part (symmetric and anti-symmetric) becomes imaginary
*
                  CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(0+iCar),
     &                        0,ISS_INDEX,iMask,ISM,jMask,JSM)
                  CALL DAXPY_(NSS**2,-1.0D0,TMP,1,WORK(LI_),1)
                  CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(6+iCar),
     &                        0,ISS_INDEX,iMask,ISM,jMask,JSM)
                  CALL DAXPY_(NSS**2,-1.0D0,TMP,1,WORK(LI_),1)
*
*                 The imaginary part (symmetric and anti-symmetric) becomes real
*
                  CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(3+iCar),
     &                        0,ISS_INDEX,iMask,ISM,jMask,JSM)
                  CALL DAXPY_(NSS**2, 1.0D0,TMP,1,WORK(LRM_),1)
                  CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(9+iCar),
     &                        0,ISS_INDEX,iMask,ISM,jMask,JSM)
                  CALL DAXPY_(NSS**2, 1.0D0,TMP,1,WORK(LRM_),1)
*
*              (2) the spin-dependent part, magnetic
*
*                 iCar=1: 1/2(S(+)+S(-))
*                 iCar=2: 1/2i(S(+)-S(-))
*                 iCar=3: Sz
*
*                 Here we need to be very careful. The operator is
*                 similar to the L.S operator, the spin-orbit coupling.
*                 However, here we have that the operator is B.S. Thus
*                 we can do this in a similar fashion as the spin-orbit
*                 coupling, but with some important difference.
*
*                 For the spin-orbit coupling the L operator is divided
*                 into x-, y-, and z-components, that is the operator
*                 will be represented by three different integrals.
*                 For the integrals over B it is similar but the x-, y-,
*                 and z-components are constants outside of the integral.
*                 For example, the x-component is expressed as
*                 (k x e_l)_x <0|e^(i k.r)|n>. In this section we will
*                 handle the (k x e_l)_x part outside the loop over the
*                 Cartesian components.
*
*                 We have to note one further difference, the integrals
*                 are complex in this case.
*
*                 Let us now compute the contributions T(i), i=x,y,z
*
*                 In the equations we find that the y-component is imaginary,
*                 see the equations on page 234 in Per Ake's paper. Hence,
*                 the y-component is treated slightly differently.
*
*                 Actually, here we compute (<0|e^(i k.r)|n> x k), which
*                 will be later dotted with e_l.
*
*                 i*g/2*(s_y*k_z-s_z*k_y) -> T_x
*                 i*g/2*(s_z*k_x-s_x*k_z) -> T_y
*                 i*g/2*(s_x*k_y-s_y*k_x) -> T_z
*
*                 Note also that the "I" parts should change sign with kPhase,
*                 but so does wavevector, so the net result is the opposite.
*
                  IF (iCar.EQ.1) THEN
                     CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(13),
     &                           iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
                     CALL DAXPY_(NSS**2, wavevector(2)*cst,
     &                           TMP,1,WORK(LDXIM+2*NSS**2),1)
                     CALL DAXPY_(NSS**2,-wavevector(3)*cst,
     &                           TMP,1,WORK(LDXIM+1*NSS**2),1)
                     CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(14),
     &                           iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
                     CALL DAXPY_(NSS**2,-wavevector(2)*cst,
     &                           TMP,1,WORK(LDXR+2*NSS**2),1)
                     CALL DAXPY_(NSS**2, wavevector(3)*cst,
     &                           TMP,1,WORK(LDXR+1*NSS**2),1)
                  ELSE IF (iCar.EQ.2) THEN
*                    For the y-component we have to interchange the real and
*                    the imaginary components. The real component gets a
*                    minus sign due to the product i*i=-1
                     CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(14),
     &                               iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
                     CALL DAXPY_(NSS**2,-wavevector(3)*cst,
     &                           TMP,1,WORK(LDXI+0*NSS**2),1)
                     CALL DAXPY_(NSS**2, wavevector(1)*cst,
     &                           TMP,1,WORK(LDXI+2*NSS**2),1)
                     CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(13),
     &                           iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
                     CALL DAXPY_(NSS**2,-wavevector(3)*cst,
     &                           TMP,1,WORK(LDXRM+0*NSS**2),1)
                     CALL DAXPY_(NSS**2, wavevector(1)*cst,
     &                           TMP,1,WORK(LDXRM+2*NSS**2),1)
                  ELSE IF (iCar.EQ.3) THEN
                     CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(13),
     &                           iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
                     CALL DAXPY_(NSS**2, wavevector(1)*cst,
     &                           TMP,1,WORK(LDXIM+1*NSS**2),1)
                     CALL DAXPY_(NSS**2,-wavevector(2)*cst,
     &                           TMP,1,WORK(LDXIM+0*NSS**2),1)
                     CALL SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(14),
     &                           iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
                     CALL DAXPY_(NSS**2,-wavevector(1)*cst,
     &                           TMP,1,WORK(LDXR+1*NSS**2),1)
                     CALL DAXPY_(NSS**2, wavevector(2)*cst,
     &                           TMP,1,WORK(LDXR+0*NSS**2),1)
                  END IF
               END DO
*
*              Now we can compute the transition moments for k and -k
*
               DO kp = 1, 2
*
               IF (ABS(kPhase(kp)).LT.0.5d0) CYCLE
               CALL DCOPY_(3*NSS**2,WORK(LDXR),1,WORK(LTMR),1)
               CALL DCOPY_(3*NSS**2,WORK(LDXI),1,WORK(LTMI),1)
               CALL DAXPY_(3*NSS**2,kPhase(kp),
     &                     WORK(LDXRM),1,WORK(LTMR),1)
               CALL DAXPY_(3*NSS**2,kPhase(kp),
     &                     WORK(LDXIM),1,WORK(LTMI),1)
               DO iCar=1, 3
                  LR_=LTMR+(iCar-1)*NSS**2
                  LI_=LTMI+(iCar-1)*NSS**2
                  CALL ZTRNSF_MASKED(NSS,VSOR,VSOI,
     &                               WORK(LR_),WORK(LI_),
     &                               IJSS,iSSMask,ISSM,jSSMask,JSSM)
               END DO
*
               IJ_=0
               Do ISO=istart_,iend_
                 Do JSO=jstart_,jend_
                   IJ=(JSO-1)*NSS+ISO-1
                   IJ_=IJ_+1
                   LFIJ=LF+(ij_-1)*2
                   EDIFF=ENSOR(JSO)-ENSOR(ISO)
*
*              Store the vectors for this direction
*
                   Call DCopy_(3,Work(LTMR+IJ),NSS**2,TM_R,1)
                   Call DCopy_(3,Work(LTMI+IJ),NSS**2,TM_I,1)
#ifdef _HDF5_
*              Get proper triangular index
                   IJSO_=(JSO-1)*(JSO-2)/2+ISO
                   iQuad_=2*(iQuad-1)+kp
                   Storage(ip_w,iQuad_,IJSO_,iVec)=Weight
                   Call DCopy_(3,kPhase(kp)*Wavevector,1,
     &                  Storage(ip_kvector,iQuad_,IJSO_,iVec),1)
                   Call DCopy_(3,TM_R,1,
     &                  Storage(ip_TMR,iQuad_,IJSO_,iVec),1)
                   Call DCopy_(3,TM_I,1,
     &                  Storage(ip_TMI,iQuad_,IJSO_,iVec),1)
#endif
*
*              Project out the k direction from the real and imaginary components
*
                   Call DaXpY_(3,-DDot_(3,TM_R,1,UK,1),UK,1,TM_R,1)
                   Call DaXpY_(3,-DDot_(3,TM_I,1,UK,1),UK,1,TM_I,1)
*
*              Implicitly integrate over all directions of the
*              polarization vector to get the average value.
*
                   TM1 = DDot_(3,TM_R,1,TM_R,1)
                   TM2 = DDot_(3,TM_I,1,TM_I,1)
                   TM_2 = Half*(TM1+TM2)
*
*              Compute maximum and minimum oscillator strengths
*              and the corresponding polarization vectors
*
                   If (Do_SK) Then
                      LMAX_ = LMAX+8*(ij_-1)
                      TM3 = DDot_(3,TM_R,1,TM_I,1)
                      Rng = Sqrt((TM1-TM2)**2+4.0D0*TM3**2)
                      Work(LMAX_+0) = TM_2+Half*Rng
                      Work(LMAX_+4) = TM_2-Half*Rng
*                     The direction for the maximum
                      Ang = Half*Atan2(2.0D0*TM3,TM1-TM2)
                      Call daXpY_(3, Cos(Ang),TM_R,1,Work(LMAX_+1),1)
                      Call daXpY_(3, Sin(Ang),TM_I,1,Work(LMAX_+1),1)
*                     Normalize and compute the direction for the minimum
*                     as a cross product with k
                      rNorm = DDot_(3,Work(LMAX_+1),1,Work(LMAX_+1),1)
                      If (rNorm.gt.1.0D-12) Then
                         Call dScal_(3,1.0/Sqrt(rNorm),Work(LMAX_+1),1)
                         Work(LMAX_+5)=Work(LMAX_+2)*UK(3)-
     &                                 Work(LMAX_+3)*UK(2)
                         Work(LMAX_+6)=Work(LMAX_+3)*UK(1)-
     &                                 Work(LMAX_+1)*UK(3)
                         Work(LMAX_+7)=Work(LMAX_+1)*UK(2)-
     &                                 Work(LMAX_+2)*UK(1)
                         rNorm=DDot_(3,Work(LMAX_+5),1,Work(LMAX_+5),1)
                         Call dScal_(3,1.0/Sqrt(rNorm),Work(LMAX_+5),1)
                      Else
                         Call dCopy_(3,[0.0D0],0,Work(LMAX_+1),1)
                         Call dCopy_(3,[0.0D0],0,Work(LMAX_+5),1)
                      End If
                   End If
*
*              Oscillator strength for a specific polarization vector
*
                   If (Do_Pol) Then
                      TM1 = DDot_(3,TM_R,1,pol_Vector(1,iVec_),1)
                      TM2 = DDot_(3,TM_I,1,pol_Vector(1,iVec_),1)
                      TM_2 = TM1*TM1+TM2*TM2
                   End If
*
*              Compute the oscillator strength
*
                   F_Temp = 2.0D0*TM_2/EDIFF
                   If (Do_SK) Then
                      Work(LMAX_+0) = 2.0D0*Work(LMAX_+0)/EDIFF
                      Work(LMAX_+4) = 2.0D0*Work(LMAX_+4)/EDIFF
                   End If
*
*              Compute the rotatory strength, note that it depends on kPhase
*
                   TM_C(1) = TM_R(2)*TM_I(3)-TM_R(3)*TM_I(2)
                   TM_C(2) = TM_R(3)*TM_I(1)-TM_R(1)*TM_I(3)
                   TM_C(3) = TM_R(1)*TM_I(2)-TM_R(2)*TM_I(1)
                   TM_2 = 2.0D0*kPhase(kp)*DDot_(3,TM_C,1,UK,1)
                   R_Temp=0.75D0*SPEED_OF_LIGHT/EDIFF**2*TM_2
                   R_Temp=R_Temp*AU2REDR
*
*              Save the raw oscillator and rotatory strengths in a given direction
*
                   NQUAD_=2*NQUAD
                   LRAW_=LRAW+6*NQUAD_*(ij_-1)
                   IQUAD_=2*(IQUAD-1)+(kp-1)
                   WORK(LRAW_+IQUAD_+0*NQUAD_) = F_Temp
                   WORK(LRAW_+IQUAD_+1*NQUAD_) = R_Temp
*
*              Save the direction and weight too
*
                   WORK(LRAW_+IQUAD_+2*NQUAD_) = UK(1)*kPhase(kp)
                   WORK(LRAW_+IQUAD_+3*NQUAD_) = UK(2)*kPhase(kp)
                   WORK(LRAW_+IQUAD_+4*NQUAD_) = UK(3)*kPhase(kp)
                   WORK(LRAW_+IQUAD_+5*NQUAD_) = Weight
*
*              Do not accumulate if not doing an isotropic integration
*
                   If (Do_SK.And.(kp.gt.1)) Cycle
*
*              Accumulate to the isotropic oscillator strength
*
                   Work(LFIJ  )=Work(LFIJ  ) + Weight * F_Temp
*
*              Accumulate to the isotropic rotatory strength
*
                   Work(LFIJ+1)=Work(LFIJ+1) + Weight * R_Temp
                 End Do
               End Do
*
               End Do ! kp
*
            End Do ! iQuad
*
            IJ_=0
            Do ISO=istart_,iend_
              Do JSO=jstart_,jend_
                 IJ=(ISO-1)*NSS+JSO-1
                 IJ_=IJ_+1
                 LFIJ=LF+(ij_-1)*2
                 EDIFF=ENSOR(JSO)-ENSOR(ISO)
                 F=Work(LFIJ)
                 R=Work(LFIJ+1)
*
                 Call Add_Info('ITMS(SO)',[F],1,6)
                 Call Add_Info('ROTS(SO)',[R],1,4)
*
                 IF (Do_Pol) THEN
                   LMAX_=LMAX+8*(ij_-1)
                   F_CHECK=ABS(WORK(LMAX_+0))
                   R_CHECK=0.0D0 ! dummy assign
                 ELSE
                   F_CHECK=ABS(F)
                   R_CHECK=ABS(R)
                 END IF
                 IF ( (F_CHECK.LT.OSTHR).AND.(R_CHECK.LT.RSTHR) ) CYCLE
                 A =(AFACTOR*EDIFF**2)*F
*
                 If (iPrint.eq.0) Then
                   WRITE(6,*)
                   If (Do_SK) Then
                     CALL CollapseOutput(1,
     &                'Transition moment strengths (SO states):')
                     WRITE(6,'(3X,A)')
     &                '----------------------------------------'
                   If (Do_Pol) Then
                      iVec_=(iVec-1)*nQuad+1
                      WRITE(6,'(4x,a,3F10.6)')
     &                  'Direction of the polarization: ',
     &                  (pol_vector(k,iVec),k=1,3)
                   Else
                      WRITE(6,'(4x,a)')
     &                 'The oscillator strength is integrated '//
     &                 'over all directions of the polarization '//
     &                 'vector'
                   End If
                   WRITE(6,'(4x,a,3F10.6)')
     &                  'Direction of the k-vector: ',
     &                   Rquad(1:3,1)
                 Else
                   CALL CollapseOutput(1,
     &              'Isotropic transition moment strengths '//
     &              '(SO states):')
                   WRITE(6,'(3X,A)')
     &              '--------------------------------------'//
     &              '------------'
                 End If
                 IF (OSTHR.GT.0.0D0) THEN
                   WRITE(6,45)
     &                  'For osc. strength at least',OSTHR,'and '//
     &                  'red. rot. strength  at least',RSTHR
                 END IF
                 WRITE(6,*)
                 If (.NOT.Do_SK) Then
                   WRITE(6,'(4x,a,I4,a)')
     &               'Integrated over ',2*nQuad,' directions of the '//
     &               'wave vector'
                   WRITE(6,'(4x,a)')
     &               'The oscillator strength is '//
     &               'integrated over all directions of the polar'//
     &               'ization vector'
                   WRITE(6,*)
                 End If
                 WRITE(6,31) 'From', 'To', 'Osc. strength',
     &                     'Red. rot. str.', 'Total A (sec-1)'
                 WRITE(6,32)
                 iPrint=1
                 END IF
*
*     Regular print
*
                !Don't print osc. str. if below threshold
                 IF(F_CHECK.LT.OSTHR) THEN
                   WRITE(6,46) ISO,JSO,'below threshold',R,A
                 !Don't print rot. str. if below threshold
                 ELSE IF(R_CHECK.LT.RSTHR) THEN
                   WRITE(6,47) ISO,JSO,F,'below threshold',A
                 ELSE
                   WRITE(6,33) ISO,JSO,F,R,A
                 END IF

                 IF (Do_SK) THEN
                  WRITE(6,50) 'maximum',WORK(LMAX_+0),
     &               'for polarization direction:',
     &                WORK(LMAX_+1),WORK(LMAX_+2),WORK(LMAX_+3)
                  WRITE(6,50) 'minimum',WORK(LMAX_+4),
     &               'for polarization direction:',
     &                WORK(LMAX_+5),WORK(LMAX_+6),WORK(LMAX_+7)
                 END IF
*
*
*     Printing raw (unweighted) and direction for every transition
*
                 IF(PRRAW) THEN
                   WRITE(6,*)
                   WRITE(6,*)
                   WRITE(6,34) 'From', 'To', 'Raw osc. str.',
     &                         'Red. rot. str.','kx','ky','kz'
                   WRITE(6,35)
                   NQUAD_=2*NQUAD
                   LRAW_=LRAW+6*NQUAD_*(ij_-1)
                   DO IQUAD = 1, NQUAD
                     DO kp=1,2
                       IF (ABS(kPhase(kp)).LT.0.5D0) CYCLE
                       IQUAD_=2*(IQUAD-1)+(kp-1)
                       WRITE(6,33) ISO,JSO,
     &                 WORK(LRAW_+IQUAD_+0*NQUAD_),
     &                 WORK(LRAW_+IQUAD_+1*NQUAD_),
     &                 WORK(LRAW_+IQUAD_+2*NQUAD_),
     &                 WORK(LRAW_+IQUAD_+3*NQUAD_),
     &                 WORK(LRAW_+IQUAD_+4*NQUAD_)
                     END DO
                   END DO
                   WRITE(6,35)
                   WRITE(6,*)
                 END IF
*
*     Printing weighted and direction for every transition
*
            IF(PRWEIGHT) THEN
              WRITE(6,*)
              WRITE(6,*)
              WRITE(6,34) 'From', 'To', 'Weig. osc. str.',
     &                    'Red. rot. str.','kx','ky','kz'
              WRITE(6,35)
              NQUAD_=2*NQUAD
              LRAW_=LRAW+6*NQUAD_*(ij_-1)
              DO IQUAD = 1, NQUAD
                DO kp=1,2
                  IF (ABS(kPhase(kp)).LT.0.5D0) CYCLE
                  IQUAD_=2*(IQUAD-1)+(kp-1)
                  Weight=WORK(LRAW_+IQUAD_+5*NQUAD_)
                  WRITE(6,33) ISO,JSO,
     &            WORK(LRAW_+IQUAD_+0*NQUAD_)*Weight,
     &            WORK(LRAW_+IQUAD_+1*NQUAD_)*Weight,
     &            WORK(LRAW_+IQUAD_+2*NQUAD_),
     &            WORK(LRAW_+IQUAD_+3*NQUAD_),
     &            WORK(LRAW_+IQUAD_+4*NQUAD_)
                END DO
              END DO
              WRITE(6,35)
              WRITE(6,*)
            END IF
*
               End Do
            End Do
*
         END DO
      END DO
      Call mma_deallocate(iMask)
      Call mma_deallocate(jMask)
      Call mma_deallocate(iSSMask)
      Call mma_deallocate(jSSMask)
      Call mma_deallocate(ISS_INDEX)
*
      If (iPrint.EQ.1) THEN
         WRITE(6,32)
         If (Do_SK) Then
            CALL CollapseOutput(0,
     &            'Transition moment strengths (SO states):')
         Else
            CALL CollapseOutput(0,
     &            'Isotropic transition moment strengths (SO states):')
         End If
      END IF
*
      End Do ! iVec
#ifdef _TIME_TMOM_
      Call CWTime(TCpu2,TWall2)
      write(6,*) 'Time for TMOM : ',TCpu2-TCpu1,TWall2-TWall1
#endif
*
#ifdef _HDF5_
#ifdef POINTER_REMAP
      flatStorage(1:SIZE(Storage)) => Storage
#else
      Call C_F_Pointer(C_Loc(Storage), flatStorage, [SIZE(Storage)])
#endif
      Call mh5_put_dset(wfn_sos_tm,flatStorage)
      Nullify(flatStorage)
      Call mma_deallocate(Storage)
#endif
*
*     Do some cleanup
*
      CALL GETMEM('RAW   ','FREE','REAL',LRAW,2*NQUAD*6*nmax2)
      CALL GETMEM('IP    ','FREE','REAL',LIP,NIP)
      CALL GETMEM('DXR','FREE','REAL',LDXR,NSS**2)
      CALL GETMEM('DXI','FREE','REAL',LDXI,3*NSS**2)
      CALL GETMEM('DXRM','FREE','REAL',LDXRM,NSS**2)
      CALL GETMEM('DXIM','FREE','REAL',LDXIM,3*NSS**2)
      call mma_deallocate(TMP)
      if (TMOgroup) Then
        Call mma_DeAllocate(TMOgrp1)
        Call mma_DeAllocate(TMOgrp2)
      EndIf
      If (Do_Pol) Call mma_deallocate(pol_Vector)
      CALL GETMEM('TMR','FREE','REAL',LTMR,3*NSS**2)
      CALL GETMEM('TMI','FREE','REAL',LTMI,3*NSS**2)
      CALL GETMEM('OSCSTR','FREE','REAL',LF,2*nmax2)
      CALL GETMEM('MAXMIN','FREE','REAL',LMAX,8*nmax2)
*
      Call mma_deallocate(SCR)
      Call mma_deAllocate(TDMZZ)
      Call mma_deAllocate(TSDMZZ)
      Call mma_deAllocate(WDMZZ)
      If (.NOT.Do_SK) Call Free_O()
      Call mma_deAllocate(Rquad)
      Call ClsSew()

 666  Continue
      Call mma_deallocate(VSOR)
      Call mma_deallocate(VSOI)
*
30    FORMAT (5X,A,1X,ES15.8)
31    FORMAT (5X,2(1X,A4),4X,3(1X,A15))
32    FORMAT (5X,63('-'))
33    FORMAT (5X,2(1X,I4),5X,5(1X,ES15.8))
34    FORMAT (5X,2(1X,A4),5X,5(1X,A15))
35    FORMAT (5X,95('-'))
45    FORMAT (4X,2(A,1X,ES15.8,1X))
46    FORMAT (5X,2(1X,I4),5X,(1X,A15),2(1X,ES15.8))
47    FORMAT (5X,2(1X,I4),5X,(1X,ES15.8),(1X,A15),(1X,ES15.8))
49    FORMAT (5X,A,1X,ES15.8,1X,A)
50    FORMAT (10X,A7,3X,1(1X,ES15.8),5X,A27,3(1X,F7.4))
*
************************************************************************
*                                                                      *
*     End of section for transition moments                            *
*                                                                      *
************************************************************************
*
#ifdef _TIME_TMOM_
      Call CWTime(TCpu2,TWall2)
      write(6,*) 'Time for TMOM(SO) : ',TCpu2-TCpu1,TWall2-TWall1
#endif
      RETURN
      END Subroutine PRPROP_TM_Exact

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module PrintLevel

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: nRout = 1024
integer(kind=iwp), parameter :: SILENT = 0, TERSE = 1, USUAL = 2, VERBOSE = 3, DEBUG = 4, INSANE = 5

integer(kind=iwp) :: nPrint(nRout) = INSANE ! ?
logical(kind=iwp) :: Colorize = .true., Show = .false.

public :: Colorize, DEBUG, INSANE, nPrint, Show, SILENT, TERSE, USUAL, VERBOSE

end module PrintLevel

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine INT1(I,J,K,L,IT1,IT2,II,IID,JJ,JJD,JTYP,ITAI,L0,L1,L2,L3)
! I < J < K < L

use guga_global, only: COUP, ICOUP, ICOUP1, IJ, IWAY, IX, J1, J2
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: I, J, K, L, IT1, IT2, II, IID, JJ, JJD, JTYP, L0(*), L1(*), L2(*), L3(*)
integer(kind=iwp), intent(_OUT_) :: ITAI(*)
integer(kind=iwp) :: ICP1I, ICPI, ISTOP, ITAIL, ITYP, KM, LJ, LJM, LJS
logical(kind=iwp) :: first1, first2, first3, skip

LJS = IJ(L+1)+1
LJM = IJ(L)
ITYP = 0
do LJ=LJS,LJM
  ITAIL = IX(IT2+LJ)
  if (IT1 /= IT2) call TAIL(L,LJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
  IWAY(L) = 1
  loop_1: do
    KM = L
    J2(KM+1) = LJ
    J1(KM+1) = LJ
    call LOOP1(L,ISTOP,IT1,IT2)
    if (ISTOP == 1) exit loop_1
    first1 = .true.
    loop_2: do
      if (first1) then
        KM = KM-1
        IWAY(KM) = 1
        first1 = .false.
        if (KM == K) then
          IWAY(K) = 1
          skip = .false.
          loop_3: do
            if (.not. skip) then
              KM = K
              call LOOP3(KM,ISTOP,IT1,IT2)
              if (ISTOP /= 0) then
                KM = KM+1
                if (KM == L) cycle loop_1
                cycle loop_2
              end if
            end if
            skip = .false.
            KM = KM-1
            IWAY(KM) = 1
            first2 = KM == J
            loop_4: do
              if (first2) then
                KM = J
                if (IT1 >= IT2) then
                  call LOOP1(KM,ISTOP,IT1,IT2)
                else
                  call LOOP2(KM,ISTOP,IT1,IT2)
                end if
                if (ISTOP /= 0) then
                  KM = KM+1
                  if (KM == K) cycle loop_3
                  first2 = .false.
                  cycle loop_4
                end if
                loop_5: do
                  KM = KM-1
                  first3 = .false.
                  if (KM == 0) then
                    COUP(1) = COUP(1)*COUP(K)
                    if (abs(COUP(1)) >= 1.0e-6_wp) then
                      ICOUP(1) = ICOUP(J+1)+ICOUP(1)
                      ICOUP1(1) = ICOUP1(J+1)+ICOUP1(1)
                      call COMP1(LJ,ITYP,L,IT2,II,IID,JJ,JJD,JTYP,ITAI)
                    end if
                    KM = 1
                    if (KM == J) cycle loop_4
                  else
                    IWAY(KM) = 1
                    if (KM == I) first3 = .true.
                  end if
                  do
                    if (first3) then
                      IWAY(I) = 1
                      do
                        KM = I
                        if (IT1 >= IT2) then
                          call LOOP3(KM,ISTOP,IT1,IT2)
                        else
                          call LOOP4(KM,ISTOP,IT1,IT2)
                        end if
                        if (ISTOP == 1) exit
                        COUP(I) = COUP(I)*COUP(K)
                        if (abs(COUP(I)) < 1.0e-6_wp) cycle
                        ICPI = ICOUP(I)
                        ICP1I = ICOUP1(I)
                        ICOUP(I) = ICOUP(J+1)+ICPI
                        ICOUP1(I) = ICOUP1(J+1)+ICP1I
                        call COMP(I,LJ,ITYP,I,IT1,IT2)
                        ICOUP(I) = ICOUP(J+1)+ICP1I
                        ICOUP1(I) = ICOUP1(J+1)+ICPI
                        call COMP(I,LJ,ITYP,I,IT1,IT2)
                      end do
                      first3 = .false.
                    else
                      if (IT1 >= IT2) then
                        call LOOP5(KM,ISTOP,IT1,IT2)
                      else
                        call LOOP6(KM,ISTOP,IT1,IT2)
                      end if
                      if (ISTOP == 0) cycle loop_5
                    end if
                    KM = KM+1
                    if (KM == J) cycle loop_4
                  end do
                  if (.true.) exit loop_5
                end do loop_5
                exit loop_4
              else
                call PATH(KM,ISTOP,IT1,IT2)
                if (ISTOP == 0) then
                  skip = .true.
                  cycle loop_3
                end if
                KM = KM+1
                if (KM == K) cycle loop_3
              end if
            end do loop_4
            if (.true.) exit loop_3
          end do loop_3
        end if
      end if
      call LOOP5(KM,ISTOP,IT1,IT2)
      if (ISTOP == 0) then
        first1 = .true.
        cycle loop_2
      end if
      KM = KM+1
      if (KM == L) cycle loop_1
    end do loop_2
    if (.true.) exit loop_1
  end do loop_1
end do

return

end subroutine INT1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
************************************************************************
* Init_GTList
************************************************************************
      Subroutine Init_GTList
#include "tlist.fh"
#include "para_info.fh"
#include "WrkSpc.fh"
#include "status.fh"
*
      If (GT_Status.eq.Active) Return
      GT_Status=Active
*
      iTCnSt = 1
      If (.Not. Is_Real_Par() .OR. nProcs.eq.1) Return
#ifdef _MOLCAS_MPP_
*     create global tasklist...
      Call GATskL(.TRUE.,nTasks,igaTsk)
#endif
*
      Return
      End
      Subroutine ReInit_GTList
#include "tlist.fh"
#include "para_info.fh"
#include "WrkSpc.fh"
#include "status.fh"
*
      If (GT_Status.ne.Active) Then
         Write (6,*) 'ReInit_GTList: List not active!'
         Call Abend
      End If
      iTCnSt = 1
      If (.Not. Is_Real_Par() .OR. nProcs.eq.1) Return
#ifdef _MOLCAS_MPP_
*     initialize global tasklist...
      Call GATskL_Zero(igaTsk)
#endif
*
      Return
      End

************************************************************************
* Rsv_GTList
************************************************************************
      Logical Function Rsv_GTList(TskLw,TskHi,iOpt,NewBatch)
      Implicit Real*8 (a-h,o-z)
#ifdef _MOLCAS_MPP_
      External RsvTsk
      Integer RsvTsk
#endif
      Logical NewBatch
#include "tlist.fh"
#include "para_info.fh"
#include "WrkSpc.fh"
#include "real.fh"
*                                                                      *
************************************************************************
*                                                                      *
      Rsv_GTList=.False.
      If (.Not. Is_Real_Par() .OR. nProcs.eq.1) Then
         If (iTCnSt.eq.1) Then
            iTCnSt=iTCnSt+1
            iTskCan=iTskCan+1
            Rsv_GTList=.True.
            TskLw=One
            TskHi=PQ
            iStrt_TList=1
            If (iOpt.eq.0) Then
               NewBatch = .True.
            Else
               NewBatch = .False.
            End If
         End If
#ifdef _MOLCAS_MPP_
      Else
*
*------ NewBatch is true if
*        1) Batch never processed by the node before
*        2) The sequence of executed batches is broken
*
         If (iOpt.eq.0) Then
            MyTask=RsvTsk(igaTsk,iWork(ipTskL),nTasks,nTasks,iTCnST,
     &                    iStrt_TList,iEnd_TList)
            NewBatch = .True.
         Else If (iOpt.eq.1) Then
            MyTask=RsvTsk(igaTsk,iWork(ipTskL),nTasks,mTasks,iTCnST,
     &                    iStrt_TList,iEnd_TList)
            NewBatch = iStrt_TList.gt.mTasks
         Else If (iOpt.eq.2) Then
            MyTask=RsvTsk(igaTsk,iWork(ipTskL),nTasks,nTasks,iTCnST,
     &                    iStrt_TList,iEnd_TList)
            NewBatch = iStrt_TList.gt.mTasks .or.
     &                 iStrt_TList.ne.iTCnST
         Else
            MyTask=0
            Write (6,*) 'Rsv_GTList: Invalid option:',iOpt
            Call Abend
         End If
         If (MyTask.ge.1) Then
            Rsv_GTList=.True.
            TskLw=Work(ipTskM+2*(MyTask-1))
            TskHi=Work(ipTskM+2*(MyTask-1)+1)
            iTCnSt=iTCnSt+1
            iTskCan=iTskCan+1
         End If
#endif
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* Free_GTList
************************************************************************
      Subroutine Free_GTList
#include "tlist.fh"
#include "para_info.fh"
#include "WrkSpc.fh"
#include "status.fh"
*
      If (GT_Status.ne.Active) Return
      GT_Status=Inactive
*
      iTCnSt = 1
      If (.Not. Is_Real_Par() .OR. nProcs.eq.1) Return
#ifdef _MOLCAS_MPP_
*     create global tasklist...
      Call GATskL(.False.,nTasks,igaTsk)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!               2020,2021, Roland Lindh                                *
!***********************************************************************
!  Cho_X_CalculateGMat
!
!> @brief
!>   Calculate Cholesky \f$ G \f$ matrix (metric matrix)
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Calculate the metric matrix from Cholesky vectors (i.e. exact).
!>
!> \f[ G_{IJ} = \sum_{K=1}^{\min(I,J)} L_{IK} L_{JK} \f]
!>
!> The matrix is symmetric and stored on disk (file ``AVECXX``) in
!> triangular storage. The file is opened and closed in this
!> routine using routines ::DAName_MF_WA and ::DAClos, respectively
!> (i.e. \c FileName is opened as a word addressable multifile).
!> The calculation failed if \p irc is different from zero on exit.
!>
!> @note
!> This routine should *not* be used with DF.
!>
!> @param[out] irc Return code
!***********************************************************************

subroutine Cho_X_CalculateGMat(irc)

use Index_Functions, only: iTri, nTri_Elem
use Cholesky, only: iiBstR, InfVec, nnBstR, nSym, NumCho
use Cholesky_procedures, only: Cho_CGM_InfVec
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: i, iDisk, idRS2RS, iI, iJ, iLoc, iOpt, iRed, iRedC, iSym, j, K, kG_IJ, KK, KK1, KKK, kOffV, l_G, l_iRS2RS, &
                     l_Wrk, lUnit, mUSed, nVRead
real(kind=wp) :: V_J
logical(kind=iwp) :: isDF
character(len=6) :: FileName
integer(kind=iwp), pointer :: InfVcT(:,:,:)
integer(kind=iwp), allocatable :: iRS2RS(:), NVT(:)
real(kind=wp), allocatable :: G(:), Wrk(:)
#ifdef _DEBUGPRINT_
real(kind=wp), external :: ddot_
#endif

! Set return code.
! ----------------

irc = 0

! Refuse to perform calculation for DF.
! -------------------------------------

call DecideOnDF(isDF)
if (isDF) then
  irc = -1
  return
end if

! Scratch location in index arrays.
! ---------------------------------

iLoc = 3 ! do NOT change (used implicitly by reading routine)

! Get pointer to InfVec array for all vectors (needed for parallel
! runs) and the total number of vectors.
! ----------------------------------------------------------------

call mma_allocate(NVT,nSym,Label='NVT')
call Cho_CGM_InfVec(InfVcT,NVT,size(NVT))

! Copy rs1 to location 2.
! -----------------------

call Cho_X_RSCopy(irc,1,2)
if (irc /= 0) then
  irc = 1
  call Finish_this()
  return
end if

! Calculate triangular G matrix.
! G(IJ)=sum_K L(I,K)*L(J,K).
! ------------------------------

iRedC = -1
do iSym=1,nSym

  ! Open file.
  ! ----------

  write(FileName,'(A4,I2.2)') 'AVEC',iSym-1
  lUnit = 7
  call DAName_MF_WA(lUnit,FileName)
  iDisk = 0

  l_iRS2RS = nnBstR(iSym,1)
  call mma_allocate(iRS2RS,l_iRS2RS,Label='iRS2RS')
  iRS2RS(:) = 0
  l_G = nTri_Elem(NVT(iSym))
  call mma_allocate(G,l_G,Label='G')
  call mma_MaxDBLE(l_Wrk)
  call mma_allocate(Wrk,l_Wrk,Label='Wrk')
  Wrk(:) = Zero
  G(:) = Zero

  idRS2RS = -2
  KK1 = 1
  do while (KK1 <= NumCho(iSym))
    nVRead = 0
    mUsed = 0
    call Cho_X_VecRd(Wrk,size(Wrk),KK1,NumCho(iSym),iSym,nVRead,iRedC,mUsed)
    if (nVRead < 1) then
      irc = 2
      ! exit after deallocation
      call Finish_this()
      return
    end if
    kOffV = 0
    do KKK=0,nVRead-1
      KK = KK1+KKK
      iRed = InfVec(KK,2,iSym)
      if (iRedC /= iRed) then
        call Cho_X_SetRed(irc,iLoc,iRed)
        if (irc /= 0) then
          irc = 3
          ! exit after deallocation
          call Finish_this()
          return
        end if
        iRedC = iRed
      end if
      if (idRS2RS /= iRedC) then
        call Cho_RS2RS(iRS2RS,size(iRS2RS),2,iLoc,iRedC,iSym)
        idRS2RS = iRedC
      end if
      K = InfVec(KK,5,iSym)
      do J=K,NVT(iSym)
        iJ = iRS2RS(InfVcT(J,1,iSym)-iiBstR(iSym,1))
        V_J = Wrk(kOffV+iJ)
        do I=K,J
          iI = iRS2RS(InfVcT(I,1,iSym)-iiBstR(iSym,1))
          kG_IJ = iTri(I,J)
          G(kG_IJ) = G(kG_IJ)+Wrk(kOffV+iI)*V_J
        end do
      end do
      kOffV = kOffV+nnBstR(iSym,iLoc)
    end do
    KK1 = KK1+nVRead
  end do
  call Cho_GADGOP(G,size(G),'+')
  iOpt = 1
  call DDAFile(lUnit,iOpt,G,size(G),iDisk)
# ifdef _DEBUGPRINT_
  call TriPrt('G-matix',' ',G,NVT(iSym))
  write(u6,'(A,I2,A,ES16.7)') 'G matrix, sym.',iSym,': Norm = ',sqrt(dDot_(size(G),G,1,G,1))
# endif
  call mma_deallocate(Wrk)
  call mma_deallocate(G)
  call mma_deallocate(iRS2RS)

  ! Close file
  ! ----------
  call DAClos(lUnit)
end do

call Finish_this()

contains

subroutine Finish_this()

  call mma_deallocate(NVT)

end subroutine Finish_this

end subroutine Cho_X_CalculateGMat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_uvOffset(AB,nSA,nSB,iOff)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: compute offset array to shell blocks of, e.g.,
C              fitting coefficients. Diagonal atom pairs (A=B)
C              are treated as quadratic (i.e. no LT storage).
C
      Implicit None
      Integer AB
      Integer nSA
      Integer nSB
      Integer iOff(nSA,nSB)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Character*12 SecNam
      Parameter (SecNam='LDF_uvOffset')

      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom
#if defined (_DEBUGPRINT_)
      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom
#endif

      Integer A, B
      Integer ipA, ipB
      Integer iSA, iSB
      Integer iShellB
      Integer iCount

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      If (nSA.ne.LDF_nShell_Atom(A) .or. nSB.ne.LDF_nShell_Atom(B)) Then
         Call WarningMessage(2,SecNam//': illegal nSA/nSB')
         Call LDF_Quit(1)
      End If
      ipA=LDF_lShell_Atom(A)-1
      ipB=LDF_lShell_Atom(B)-1
      iCount=0
      Do iSB=1,nSB
         iShellB=iWork(ipB+iSB)
         Do iSA=1,nSA
            iOff(iSA,iSB)=iCount
            iCount=iCount+nBasSh(iWork(ipA+iSA))*nBasSh(iShellB)
         End Do
      End Do
#if defined (_DEBUGPRINT_)
      If (iCount.ne.LDF_nBas_Atom(A)*LDF_nBas_Atom(B)) Then
         Call WarningMessage(2,SecNam//': iCount error')
         Call LDF_Quit(1)
      End If
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Roland Lindh                                     *
!***********************************************************************

subroutine sssp(EFInt,Zeta,nZeta,P,lP,rKappAB,A,B,Eta,nEta,Q,lQ,rKappCD,C,D,CoorAC,TMax,iPntr,nPntr,x0,nMax,W6,W5,W4,W3,W2,W1,W0, &
                R6,R5,R4,R3,R2,R1,R0,ddx,HerW,HerR2,IsChi,ChiI2)
!***********************************************************************
!                                                                      *
! Object: to compute the primitive integrals of type (ss|sp).          *
!                                                                      *
!  Author:    Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN. 1994                                    *
!***********************************************************************

use Constants, only: Zero, One, Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, lP, nEta, lQ, nPntr, iPntr(nPntr), nMax, IsChi
real(kind=wp), intent(out) :: EFInt(nZeta,nEta,3)
real(kind=wp), intent(in) :: Zeta(nZeta), P(lP,3), rKappAB(nZeta), A(3), B(3), Eta(nEta), Q(lQ,3), rKappCD(nEta), C(3), D(3), &
                             CoorAC(3,2), TMax, x0(nMax), W6(nMax), W5(nMax), W4(nMax), W3(nMax), W2(nMax), W1(nMax), W0(nMax), &
                             R6(nMax), R5(nMax), R4(nMax), R3(nMax), R2(nMax), R1(nMax), R0(nMax), ddx, HerW, HerR2, ChiI2
integer(kind=iwp) :: iEta, iZeta, n
real(kind=wp) :: dddx, PQ2, PQx, PQy, PQz, PreFct, QCPQx, QCPQy, QCPQz, r, rho, T, w, xdInv, z, ZE, ZEInv, Zu2
logical(kind=iwp) :: ABeqCD
logical(kind=iwp), external :: EQ

xdInv = One/ddx
dddx = ddx/Ten+ddx

ABeqCD = EQ(A,B) .and. EQ(A,C) .and. EQ(A,D)

if (ABeqCD) then

  ! CCCC case

  EFInt(:,:,:) = Zero

else if (EQ(C,D)) then

  ! ABCC case

  do iEta=1,nEta
    do iZeta=1,nZeta
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      ZE = Zeta(iZeta)*Eta(iEta)
      rho = ZE*ZEInv
      PQx = (P(iZeta,1)-CoorAC(1,2))
      PQy = (P(iZeta,2)-CoorAC(2,2))
      PQz = (P(iZeta,3)-CoorAC(3,2))
      PQ2 = PQx**2+PQy**2+PQz**2
      T = rho*PQ2
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w = (((((W6(n)*z+W5(n))*z+W4(n))*z+W3(n))*z+W2(n))*z+W1(n))*z+w0(n)
        r = (((((R6(n)*z+R5(n))*z+R4(n))*z+R3(n))*z+R2(n))*z+R1(n))*z+R0(n)
        Zu2 = r*(Zeta(iZeta)*ZEInv)
        PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)*w
      else
        Zu2 = HerR2/(Eta(iEta)*PQ2)
        PreFct = rKappCD(iEta)*rKappAB(iZeta)*HerW/sqrt(ZE*PQ2)
      end if
      EFInt(iZeta,iEta,1) = PreFct*Zu2*PQx
      EFInt(iZeta,iEta,2) = PreFct*Zu2*PQy
      EFInt(iZeta,iEta,3) = PreFct*Zu2*PQz
    end do
  end do

else

  ! ABCD case

  do iEta=1,nEta
    do iZeta=1,nZeta
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      ZE = Zeta(iZeta)*Eta(iEta)
      rho = ZE*ZEInv
      PQx = P(iZeta,1)-Q(iEta,1)
      PQy = P(iZeta,2)-Q(iEta,2)
      PQz = P(iZeta,3)-Q(iEta,3)
      PQ2 = PQx**2+PQy**2+PQz**2
      T = rho*PQ2
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w = (((((W6(n)*z+W5(n))*z+W4(n))*z+W3(n))*z+W2(n))*z+W1(n))*z+w0(n)
        r = (((((R6(n)*z+R5(n))*z+R4(n))*z+R3(n))*z+R2(n))*z+R1(n))*z+R0(n)
        Zu2 = r*(Zeta(iZeta)*ZEInv)
        PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)*w
      else
        Zu2 = HerR2/(Eta(iEta)*PQ2)
        PreFct = rKappCD(iEta)*rKappAB(iZeta)*HerW/sqrt(ZE*PQ2)
      end if
      QCPQx = Q(iEta,1)-CoorAC(1,2)+Zu2*PQx
      QCPQy = Q(iEta,2)-CoorAC(2,2)+Zu2*PQy
      QCPQz = Q(iEta,3)-CoorAC(3,2)+Zu2*PQz
      EFInt(iZeta,iEta,1) = PreFct*QCPQx
      EFInt(iZeta,iEta,2) = PreFct*QCPQy
      EFInt(iZeta,iEta,3) = PreFct*QCPQz
    end do
  end do

end if

return

end subroutine sssp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrintTitles(LuVal,nShowMOs,isDensity,nMOs,GRef,isEner,Occ,iType,Crypt,NZ,E,ifpartial,isLine,isSphere,isColor,isLuscus, &
                       nCoor,nBlocks,nInc)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LuVal, nShowMOs, nMOs, GRef(*), iType(*), NZ(*), nCoor, nBlocks, nInc
logical(kind=iwp), intent(in) :: isDensity, isEner, ifpartial, isLine, isSphere, isColor, isLuscus
real(kind=wp), intent(in) :: Occ(*), E(*)
character(len=7), intent(in) :: Crypt
integer(kind=iwp) :: i, ib, j, Sizeof8 !, iActOrb
character(len=128) :: Line
character(len=10) :: LineT
character :: bb
#include "macros.fh"
unused_var(nBlocks)
unused_var(nInc)

Sizeof8 = 8
!iActOrb = 0
LineT = 'GridName= '
if (isLine) LineT = '#GridName='
!write(u6,*) 'here',nInc, nBlocks, nCoor
if (isLuscus) then
  !NFIRST = nInc

  !if (nBlocks == 1) NFIRST=nCoor

  !  ii = 0
  !  do i=1,nShowMOs
  !    write(Line,'(A17,1000i12)') ' File_pointers = ',((nFirst*(j-1)+ii)*Sizeof8,j=1,nBlocks)
  !    call PRINTLINE(LUVAL,LINE,12*nBlocks+17,.false.)
  !    ii = ii+nFirst*nBlocks
  !  end do
  write(Line,'(A,i22)') ' ORBOFF = ',nCoor*nShowMOs*Sizeof8
  !     & + 28*nShowMOs-20
  ! ?? -20?
  call PRINTLINE(LUVAL,LINE,32,.false.)
end if
do i=1,nShowMOs-merge(1,0,isDensity)-merge(1,0,isSphere)-merge(1,0,isColor)
  j = GRef(i)
  if (isEner) then
    !if ((Occ(j) > Zero) .and. (Occ(j) < Two)) then
    !  iActOrb = iActOrb+1
    !  if (isLuscus) then
    !    write(LINE,1010) 'VB orbital',iActOrb,' (',VBocc,')'
    !    call PRINTLINE(LUVAL,LINE,45,.false.)
    !  else
    !    write(line,'(2a,i4,5x,a,f4.2,a)') LineT,'VB orbital',iActOrb,' (',VBocc,')'
    !    call PrintLine(LuVal,line,38,.false.)
    !  end if
    !else
    ib = iType(j)
    bb = ' '
    if ((ib > 0) .and. (ib < 8)) bb = Crypt(ib:ib)
    if (isLuscus) then
      write(LINE,1000) NZ(j),NZ(j+nMOs),E(j),Occ(j),bb
      call PRINTLINE(LUVAL,LINE,72,.false.)
    else
      write(line,'(a,i2,i5,f12.4," (",f4.2,")",1x,a)') LineT,NZ(j),NZ(j+nMOs),E(j),Occ(j),bb
      call PrintLine(LuVal,line,38,.false.)
    end if
    !end if
  else
    !if ((Occ(j) > Zero) .and. (Occ(j) < Two)) then
    !  iActOrb = iActOrb+1
    !  if (isLuscus) then
    !    write(LINE,1010) iActOrb,VBocc
    !    call PRINTLINE(LUVAL,LINE,45,.false.)
    !  else
    !    write(line,'(2a,i4,5x,a,f4.2,a)') LineT,'VB orbital',iActOrb,' (',VBocc,')'
    !    call PrintLine(LuVal,line,30,.false.)
    !  end if
    !else
    ib = iType(j)
    bb = ' '
    if ((ib > 0) .and. (ib < 8)) bb = Crypt(ib:ib)
    if (isLuscus) then
      write(LINE,1020) NZ(j),NZ(j+nMOs),Occ(j),bb
      call PRINTLINE(LUVAL,LINE,53,.false.)
    else
      write(line,'(a,i2,i5," (",f8.6,")",1x,a)') LineT,NZ(j),NZ(j+nMOs),Occ(j),bb
      call PrintLine(LuVal,line,30,.false.)
    end if
    !end if
  end if
end do
if (isSphere) then
  write(line,'(a,a)') LineT,'  Sphere '
  call PrintLine(LuVal,line,19,.false.)
end if
if (isColor) then
  write(line,'(a,a)') LineT,'0 Color  '
  call PrintLine(LuVal,line,19,.false.)
end if
if (isDensity) then
  if (ifpartial) then
    if (isLuscus) then
      LINE = ' GridName= Density (partial)'
      call PRINTLINE(LUVAL,LINE,28,.false.)
    else
      write(line,'(a,a)') LineT,'  Density (partial)'
      call PrintLine(LuVal,line,29,.false.)
    end if
  else
    if (isLuscus) then
      LINE = ' GridName= Density'
      call PRINTLINE(LUVAL,LINE,18,.false.)
    else
      write(line,'(a,a)') LineT,'  Density'
      call PrintLine(LuVal,line,19,.false.)
    end if
  end if
end if
if (isLuscus) then
  LINE = ' <DENSITY>'
  call PRINTLINE(LUVAL,LINE,10,.false.)
end if

return

1000 format(1X,'GridName= Orbital sym=',i2,' index=',i5,' Energ=',F12.4,' occ=',F4.2,' type=',a1)
!1010 format(1X,'GridName= VB_orbital iActOrb= ',I4,' occ= ',F4.2)
1020 format(1X,'GridName= Orbital sym=',I2,' index=',I5,' occ=',F4.2,' type=',A1)

end subroutine PrintTitles

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       SubRoutine CISigma_td(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,
     &                       Int2a,nInt2a,ipCI1,ipCI2,NT, Have_2_el )
       use ipPage, only: W
       use Arrays, only: KAIN1, KINT2, KINT2A, TI1, TI2, pInt1
       Implicit Real*8(a-h,o-z)
c
c For the timeindep case ipS1 and ipS2 will be half as long
c Avoid sigmavec calls. 95% of the time in mclr is spent in sigmavec
c
*
#include "Pointers.fh"
#include "Input.fh"
#include "stdalloc.fh"
#include "genop.fh"
#include "cands.fh"
#include "detdim.fh"
#include "cstate_mclr.fh"
#include "cicisp_mclr.fh"
       Character NT
       integer kic(2),opout
       Logical Have_2_el
       Real*8, Target:: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
       Real*8, Allocatable:: CIDET(:)

       itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
*      Interface Anders to Jeppe
*      This interface initiates Jeppes common block
*      and will make it easier to use Anders modifications
*      of the CI routines
*
*      OK first tell Jeppe where the integrals are.
*
       If (nconf1.eq.0) return
*
*      One electron integrals
*
       KAIN1=>Int1
*
*      Two electron integrals
*      symmetric in perticle one and two
*
*
       KINT2 => Int2s
       KINT2a=> Int2a
*
*      Two electron integrals
*      anti symmetric in perticle one and two
*
*
       irefsm=iCSym
*
*      Do we have any twoelectron integrals?
*
       If (Have_2_el) Then
         i12=2
       Else
         i12=1
       End If
C
*
*      Symmetry of Sigma vector
*
       iSSM=iSSym
       kic(2)=2
       if (issm.eq.State_sym) kic(2)=1
*
*      Symmetry of CI vector
*
       iCSM=iCSym
       kic(1)=2
       if (icsm.eq.State_sym) kic(1)=1
*
*      Symmetry properties of operator
*
       ndet=nint(max(xispsm(iSSym,1),xispsm(iCSym,1)))
       ndet=Max(ndet,ncsf(icsym),ncsf(issym))
       If (ndet.eq.0) Return
       iOP=iEOr(iCSM-1,iSSm-1)+1
       If (iOp.eq.1) Then
         Call iCopy(nSym,ipCM,1,pInt1,1)
       Else
         Do iS=1,nSym
          jS=iEor(iS-1,iOp-1)+1
          pInt1(is)=ipMat(is,jS)
         End Do
       End If
*
*      Triplet/Singlet operator
*
       ist=iispin+1
       square=.false.
*                                                                      *
************************************************************************
*                                                                      *
       If (TIMEDEP) Then
*                                                                      *
************************************************************************
*                                                                      *
          If (NT.eq.'T')  square=.true.  ! The operator is not sym


          If (page) Then
             Write(6,*) 'Page not implemented for Timedependent'
     &              //' perturbations'
             Call Abend()
          End If

c         CIDET is here because sigmavec will destroy the first
C         input vector.
          Call mma_allocate(CIDET,nDet,Label='CIDET')
          irc=ipin(ipCI1)
          call dcopy_(nCSF(iCSM),W(ipCI1)%Vec,1,CIDET,1)

          irc=ipin(ipci2)
          Call SigmaVec(CIDET,W(ipci2)%Vec,kic)
C
          If (NT.eq.'N') Then
             Call mma_deallocate(CIDET)
             Return
          End If
c
          If (NT.eq.'S') Then

C.......... Symmetric operator, no transpose of integrals needed!
            irc=ipin(ipCI1)
            call dcopy_(nCSF(iCSM),W(ipCI1)%Vec(1+nConf1),1,
     &                  CIDET,1)
C
            irc=ipin(ipci2)
            Call SigmaVec(CIDET,W(ipci2)%Vec(1+nconf1),kic)

          Else  ! NT.ne.'S'

C.......... The operator is not sym --> transpose integrals! NT.ne.S
            irc=ipin(ipCI1)
            call dcopy_(nCSF(iCSM),W(ipCI1)%Vec,1,CIDET,1)

            Call mma_allocate(TI1,ndens2,Label='TI1')
            Call mma_allocate(TI2,ntash**4,Label='TI2')

            Do i=1,ntash
              Do j=1,ntash
               ij=i+ntash*(j-1)
               ji=j+ntash*(i-1)
               Do k=1,ntash
                Do l=1,ntash
                 kl=k+ntash*(l-1)
                 lk=l+ntash*(k-1)
                 If (ij.ge.kl) Then
                  ijkl=itri(ij,kl)
                  jilk=itri(ji,lk)
                  TI2(jilk)=int2s(ijkl)
                 End if
                End Do
               End Do
              End Do
            End Do

            Do is=1,nSym
             js=ieor(ieor(icsym-1,issym-1),is-1)+1
             If (nbas(js)*nbas(is).ne.0)
     &       Call DGETMO(Int1(ipmat(is,js)),nbas(is),
     &                 nbas(is),nbas(js),TI1(ipmat(js,is)),
     &                 nbas(js))
            End Do

            KAIN1=>TI1
            KINT2=>TI2

            irc=ipin(ipci2)
            Call SigmaVec(CIDET,W(ipci2)%Vec(1+nconf1),kic)

            KAIN1=>Null()
            KINT2=>Null()
            Call mma_deallocate(TI1)
            Call mma_deallocate(TI2)

         End If  ! End the transpose of integrals.
*
         Call mma_deallocate(CIDET)
*                                                                      *
************************************************************************
*                                                                      *
       Else   ! If not timedep
*                                                                      *
************************************************************************
*                                                                      *

          If (.not.page) Then
             Call mma_allocate(CIDET,nDet,Label='CIDET')
             irc=ipin(ipCI1)
             call dcopy_(nCSF(iCSM),W(ipCI1)%Vec,1,CIDET,1)
             irc=ipin(ipci2)
             Call SigmaVec(CIDET,W(ipci2)%Vec,kic)
             Call mma_deallocate(CIDET)
          Else
             irc=ipnout(ipci2)
             irc=ipin1(ipCI1,ndet)
             irc=ipin(ipci2)
             Call SigmaVec(W(ipCI1)%Vec,W(ipci2)%Vec,kic)
             irc=opout(ipci1)
          End If
*                                                                      *
************************************************************************
*                                                                      *
       End If
*                                                                      *
************************************************************************
*                                                                      *
*
       Return
#ifdef _WARNING_WORKAROUND_
       If (.False.) Call Unused_integer(irc)
#endif
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE IJIJ(INTSYM,HDIAG,FC,FIJIJ)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION INTSYM(*),HDIAG(*),FC(*),
     *          FIJIJ(*)
      DIMENSION HCOUT(nCOP)
*
      JSYM(L)=JSUNP(INTSYM,L)
*------
* POW: Unnecessary but warning stopping initializations
      inb=-1234567
*------
      IADD25=IAD25S
      IAD27=0
      IREF0=1
      CALL dDAFILE(Lu_27,2,HDIAG,IRC(1),IAD27)
*
*     WRITE(6,*) ' Hdiag'
*     WRITE(6,*) ( Hdiag(i),i=1,IRC(1) )
*
      IFS=0
      IVL=0
      IVSAVE=0
      ICOUPS=0
      ICOUP =0
      NSS=1
      IOUT=0
      ICHK=0
      IADD10=IAD10(3)
      TERM=0.0D00
300   CONTINUE
C READ A COP BUFFER:
      CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LENGTH=ICOP1(nCOP+1)
      IF(LENGTH.EQ.0)GO TO 300
      IF(LENGTH.LT.0)GO TO 350
C LOOP OVER THE COP BUFFER:
      DO 360 II=1,LENGTH
      IND=ICOP1(II)
      IF(ICHK.NE.0)GO TO 460
      IF(IND.NE.0)GO TO 361
      ICHK=1
      GO TO 360
460   ICHK=0
      INDI=IND
*      ICOUP=MOD(INDI,2**16)
*      IVL=MOD(INDI/2**16,2**8)
      ICOUP=IBITS(INDI, 0,16)
      IVL=IBITS(INDI,16,8)
      ICHK=0
      INS=1
      IF(IVSAVE.EQ.IVVER) THEN
        INS=ICOUPS
        INB=ICOUPS
      END IF
      IF(INB.NE.0) THEN
        DO 10 J=INS,INB
          IOUT=IOUT+1
          HCOUT(IOUT)=HDIAG(J)
          IF(IOUT.LT.nCOP)GO TO 10
          IF(IFS.EQ.0)THEN
            POTNUC=HCOUT(IREF0)
            IFS=1
          END IF
          DO 8831 KK=1,nCOP
            HCOUT(KK)=HCOUT(KK)-POTNUC
8831      CONTINUE
          CALL dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
          IOUT=0
10      CONTINUE
      END IF
      IF(IVL.NE.IVVER) THEN
        JJ=IRC(IVL)+ICOUP
        NSS=MUL(JSYM(JJ),LSYM)
        IF(IVL.EQ.IDVER)THEN
          INB=NVIR(NSS)
        ELSE
          INB=NVPAIR(NSS)
        END IF
        IF(INB.GT.0)CALL dDAFILE(Lu_27,2,HDIAG,INB,IAD27)
      END IF
      IVSAVE=IVL
      ICOUPS=ICOUP
      GO TO 360
361   CONTINUE
*      ITYP=MOD(IND,2)
*      IJJ=MOD(IND/2,2**11)
      ITYP=IBITS(IND,0,1)
      IJJ=IBITS(IND,1,11)
      IF(ITYP.EQ.0)TERM=COP(II)*FIJIJ(IJJ)
      IF(IVL.EQ.IVVER) THEN
        INB=ICOUP
        HDIAG(INB)=HDIAG(INB)+TERM
      ELSE IF(IVL.EQ.IDVER) THEN
        INB=0
        NA1=NVIRP(NSS)+1
        NA2=NVIRP(NSS)+NVIR(NSS)
        IF(NA2.LT.NA1)GO TO 360
        DO 365 NA=NA1,NA2
          INB=INB+1
          IF(ITYP.EQ.1) THEN
            IIJ=IROW(LN+NA)+IJJ
            TERM=COP(II)*FIJIJ(IIJ)
          END IF
          HDIAG(INB)=HDIAG(INB)+TERM
365     CONTINUE
      ELSE
        INB=0
        DO 375 NA=1,NVIRT
          NSA=MUL(NSS,NSM(LN+NA))
          NB1=NVIRP(NSA)+1
          NB2=NVIRP(NSA)+NVIR(NSA)
          IF(NB2.GT.NA)NB2=NA
          IF(NB2.LT.NB1)GO TO 375
          IIJ1=IROW(LN+NA)+IJJ
          DO 376 NB=NB1,NB2
            INB=INB+1
            IF(ITYP.EQ.1) THEN
              IIJ2=IROW(LN+NB)+IJJ
              TERM=COP(II)*(FIJIJ(IIJ1)+FIJIJ(IIJ2))
            END IF
            HDIAG(INB)=HDIAG(INB)+TERM
376       CONTINUE
375     CONTINUE
      END IF
360   CONTINUE
      GO TO 300
C EMPTY LAST BUFFER
350   CONTINUE
      DO 20 J=1,INB
        IOUT=IOUT+1
        HCOUT(IOUT)=HDIAG(J)
        IF(IOUT.LT.nCOP)GO TO 20
        IF(IFS.EQ.0)THEN
          POTNUC=HCOUT(IREF0)
          IFS=1
        END IF
        DO 8830 KK=1,nCOP
          HCOUT(KK)=HCOUT(KK)-POTNUC
8830    CONTINUE
        CALL dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
        IOUT=0
20    CONTINUE
      IF(IFS.EQ.0)THEN
        POTNUC=HCOUT(IREF0)
        IFS=1
      END IF
      DO 8829 KK=1,IOUT
        HCOUT(KK)=HCOUT(KK)-POTNUC
8829  CONTINUE
      CALL dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_real_array(FC)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Roland Lindh                                     *
!               2025, Lila Zapp                                        *
!***********************************************************************

subroutine GEK_Optimizer(mDiis,nDiis,Max_Iter,q_diis,g_diis,dq_diis,Energy,H_diis,dqdq,Step_Trunc,UpMeth,SORange)

use Index_Functions, only: iTri, nTri_Elem
use Kriging_mod, only: blavAI
use Kriging_procedures, only: Setup_Kriging
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four, Six, Ten, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: mDiis, nDiis, Max_Iter
real(kind=wp), intent(inout) :: q_diis(mDiis,nDiis+Max_Iter), g_diis(mDiis,nDiis+Max_Iter), Energy(nDiis+Max_Iter), &
                                H_diis(mDiis,mDiis)
real(kind=wp), intent(out) :: dq_diis(mDiis), dqdq
character, intent(out) :: Step_Trunc
character(len=6), intent(out) :: UpMeth
logical(kind=iwp), intent(in) :: SORange
integer(kind=iwp) :: i, ii, Iteration, Iteration_Micro, Iteration_Total, j, k
real(kind=wp) :: Beta_Disp, dqHdq, FAbs, Fact, RMS, RMSMx, SOFact, StepMax, Variance(1)
logical(kind=iwp) :: Converged, Terminate
character(len=6) :: UpMeth_
character :: Step_Trunc_
real(kind=wp), allocatable :: Val(:), Vec(:,:)
integer(kind=iwp), parameter :: nWindow = 20
real(kind=wp), parameter :: Beta_Disp_Min = 5.0e-3_wp, Beta_Disp_Seed = 0.05_wp, StepMax_Seed = 0.1_wp, Thr_RS = 1.0e-7_wp, &
                            ThrGrd = 1.0e-7_wp
real(kind=wp), external :: DDot_

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! We need to set the bias

blavAI = Ten
call Setup_Kriging(nDiis,mDiis,q_diis,g_diis,Energy,Hessian_HMF=H_diis)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Here starts the code doing the actual optimization

UpMeth = 'RVO'
Terminate = .false.
Step_Trunc = 'N'
Converged = .false.

if (SORange) then
  SOFact = One
else
  SOFact = 10000.0_wp
end if
Beta_Disp = Beta_Disp_Seed*SOFact
Iteration = nDiis-1
Iteration_Micro = 0
Iteration_Total = nDIIS-1
if (nDIIS > 1) Beta_Disp = min(Beta_Disp_Seed*SOFact,max(Beta_Disp_Min,abs(Energy(nDIIS)-Energy(nDIIS-1))))
#ifdef _DEBUGPRINT_
write(u6,*) 'Energy(nDIIS)-Energy(nDIIS-1)=',Energy(nDIIS)-Energy(nDIIS-1)
write(u6,*) 'nDIIS=',nDIIS
write(u6,*) 'Beta_Disp_Seed=',Beta_Disp_Seed*SOFact
write(u6,*) 'Beta_Disp_Min=',Beta_Disp_Min
write(u6,*) 'Beta_Disp=',Beta_Disp
#endif

do while (.not. Converged) ! Micro iterate on the surrogate model

  Iteration_Micro = Iteration_Micro+1
  Iteration_Total = Iteration_Total+1
  Iteration = Iteration+1

  !if (Iteration_Micro == Max_Iter) then
  !  write(u6,*)
  !  write(u6,*) 'S_GEK_Optimizer: Iteration_Micro==Max_Iter'
  !  write(u6,*) 'Abend!'
  !  write(u6,*)
  !  call Abend()
  !end if

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) '================================'
  write(u6,*) 'Micro Iteration=',Iteration_Micro
  write(u6,*) '================================'
  write(u6,*)
  write(u6,*) 'Step_Trunc:',Step_Trunc
  write(u6,*) '-----> Start RVO step'
# endif

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  Fact = One
  StepMax = StepMax_Seed*SOFact*real(Iteration_Micro,kind=wp)
  ! Loop to enforce restricted variance. Note, if the step restriction kicks in no problem since we will still microiterate.
  ! Normally a full step will be allowed -- no step restriction -- and the loop will be exited after the first iteration.
  do

    ! Compute the surrogate Hessian
    call Hessian_Kriging_Layer(q_diis(:,Iteration),H_diis,mDiis)
    !call Hessian_Kriging(q_diis(:,Iteration),H_diis,mDiis)

    call mma_allocate(Val,nTri_Elem(mDIIS),Label='Val')
    call mma_allocate(Vec,mDIIS,mDIIS,Label='Vec')

    call unitmat(Vec,mDIIS)
    do i=1,mDIIS
      do j=1,i
        Val(iTri(i,j)) = H_diis(i,j)
      end do
    end do

    call NIDiag_new(Val,Vec,mDIIS,mDIIS)
    call Jacord(Val,Vec,mDIIS,mDIIS)

    ! If negative eigenvalues then correct and signal that the micro iterations should be terminanted.
    do i=1,mDIIS
      ii = nTri_Elem(i)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Eigenvalue:',Val(ii)
#     endif
      if (Val(ii) < Zero) then
        Terminate = .true.
        do j=1,mDIIS
          do k=1,mDIIS
            H_Diis(j,k) = H_Diis(j,k)+Two*abs(Val(ii))*Vec(j,i)*Vec(k,i)
          end do
        end do
      end if
    end do

    call mma_deallocate(Vec)
    call mma_deallocate(Val)

#   ifdef _DEBUGPRINT_
    call RecPrt('q_diis(:,Iteration)',' ',q_diis(:,Iteration),mDIIS,1)
    call RecPrt('H_diis(updated)',' ',H_diis,mDIIS,mDIIS)
    write(u6,*) 'Step_Trunc:',Step_Trunc
#   endif

    Step_Trunc_ = Step_Trunc
    dqHdq = Zero
    call RS_RFO(H_diis,g_Diis(:,Iteration),mDiis,dq_diis,UpMeth_,dqHdq,StepMax,Step_Trunc_,Thr_RS)
    dq_diis(:) = -dq_diis(:)
    q_diis(:,Iteration+1) = q_diis(:,Iteration)+dq_diis(:)
    dqdq = sqrt(DDot_(size(dq_diis),dq_diis(:),1,dq_diis(:),1))

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) 'Subiteration: Step_Trunc, StepMax,dqdq:',Step_Trunc,StepMax,dqdq
    write(u6,*) 'Subiteration: Step_Trunc_        :',Step_Trunc_
    call RecPrt('dq_diis',' ',dq_diis,mDIIS,1)
    call RecPrt('q_diis(:,Iteration+1)',' ',q_diis(:,Iteration+1),mDIIS,1)
#   endif
    if (Step_Trunc == 'N') Step_Trunc = ' '   ! set to blank if not touched
    if (Step_Trunc//Step_Trunc_ == ' *') Step_Trunc = '.' ! Mark that we have had a step Reduction

    call Dispersion_Kriging_Layer(q_diis(:,Iteration+1),Variance,mDIIS)
    !call Dispersion_Kriging(q_diis(:,Iteration+1),Variance,mDIIS)

    ! Note that we might have converged because the step restriction kicked in. However, we will implicitly
    ! fix that during the second micro iteration.

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) 'Step_Trunc:',Step_Trunc
    write(u6,*) 'Beta_Disp =',Beta_Disp
    write(u6,*) 'Variance  =',Variance(1)
    write(u6,*) 'Fact      =',Fact
    write(u6,*) 'StepMax   =',StepMax
#   endif
    if ((Fact < 1.0e-5_wp) .or. (Variance(1) < Beta_Disp)) exit
    if (One-Variance(1)/Beta_Disp > 1.0e-3_wp) exit
    Fact = Half*Fact
    StepMax = Half*StepMax
    Step_Trunc = '*' ! This will only happen if the variance restriction kicks in

  end do  ! Restricted variance step
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Step_Trunc:',Step_Trunc
  write(u6,*) '-----> Exit RVO step'
  write(u6,*)
# endif

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! Compute the energy and the gradient of the surrogate model

  call Energy_Kriging_Layer(q_diis(:,Iteration+1),Energy(Iteration_Total+1),mDIIS)
  !call Energy_Kriging(q_diis(:,Iteration+1),Energy(Iteration_Total+1),mDIIS)
  call Gradient_Kriging_Layer(q_diis(:,Iteration+1),g_diis(:,Iteration+1),mDIIS)
  !call Gradient_Kriging(q_diis(:,Iteration+1),g_diis(:,Iteration+1),mDIIS)

  !dEner = Energy(Iteration_Total+1)-Energy(Iteration_Total)

# ifdef _DEBUGPRINT_
  write(u6,*) 'Energy(Iteration_Total+1):',Energy(Iteration_Total+1)
  call RecPrt('g_diis(:,Iteration+1)',' ',g_diis(:,Iteration+1),mDIIS,1)
# endif

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! Check on convergence criteria.

  FAbs = sqrt(DDot_(mDIIS,g_diis(:,Iteration+1),1,g_diis(:,Iteration+1),1)/real(mDIIS,kind=wp))
  RMS = sqrt(DDot_(mDIIS,dq_diis(:),1,dq_diis(:),1)/real(mDIIS,kind=wp))
  RMSMx = Zero
  do i=1,mDIIS
    RMSMx = max(RMSMx,abs(dq_diis(i)))
  end do
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'FAbs=',FAbs
  write(u6,*) 'RMS=',RMS
  write(u6,*) 'RMSMx=',RMSMx
  write(u6,*)
# endif
  if (Step_Trunc == '.') Step_Trunc = ' '
  Converged = ((FAbs < ThrGrd) .and. (RMS < Four*ThrGrd) .and. (RMSMx < ThrGrd*Six) .and. &
               ((Step_Trunc == ' ') .or. (Step_Trunc == '#')))
# ifdef _DEBUGPRINT_
  write(u6,*) 'Step_Trunc:',Step_Trunc
  write(u6,*) 'Converged:',Converged
# endif
  if (Step_Trunc == '*') Converged = .true.
  if ((.not. Converged) .and. (Iteration_Micro == Max_Iter)) Terminate = .true.
  if (Terminate) then
    Step_Trunc = '#'
    exit
  end if

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

end do  ! While not converged

#ifdef _DEBUGPRINT_
if (Converged) then
  write(u6,*) 'Converged'
else
  write(u6,*) 'Not converged!'
end if
write(u6,*) 'Energy(Iteration_Total+1):',Energy(Iteration_Total+1)
#endif
write(UpMeth(5:6),'(I2)') Iteration_Micro

! Compute the displacement in the reduced space relative to the last structure of the full space
dq_diis(:) = q_diis(:,Iteration+1)-q_diis(:,nDIIS)

#ifdef _DEBUGPRINT_
call RecPrt('dq_diis',' ',dq_diis(:),size(dq_diis),1)
call RecPrt('g_diis(:,Iteration+1)',' ',g_diis(:,Iteration+1),size(g_diis,1),1)
#endif

end subroutine GEK_Optimizer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2002, Roland Lindh                                     *
************************************************************************
      SubRoutine Cmbn_EF_DPnt(EF,nTs,DPnt,MxAto,DCntr,nS,iSph,Q,
     &                        Grad,nGrad)
********************************************************************
*                                                                  *
*      Combine EF with DPnt array.                                 *
*                                                                  *
*      Roland Lindh                                                *
*      020117                                                      *
*                                                                  *
********************************************************************
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8(a-h,o-z)
      parameter (tol=1d-8)
#include "Molcas.fh"
#include "disp.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 EF(3,2,nTs),DPnt(nTs,MxAto,3,3), Grad(nGrad),
     &       DCntr(nS,MxAto,3,3), Q(2,nTs)
      Integer iSph(nTs)
      Logical TF,TstFnc
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*
      iIrrep=0
*
      mdc=0
      iCen=1
      Do iCnttp=1,nCnttp
         If (dbsc(iCnttp)%Aux) Cycle
         Do iCnt=1,dbsc(iCnttp)%nCntr
            mdc=mdc+1
            nDispS = IndDsp(mdc,iIrrep)

            Do iCar=0,2
               iComp = 2**iCar
               If ( TF(mdc,iIrrep,iComp)) Then
                  nDispS = nDispS + 1
                  Do iTs = 1, nTs
                     jSph=iSph(iTs)
                     QTot=Q(1,iTs)+Q(2,iTs)
                     Grad(nDispS) = Grad(nDispS)
     &                  + QTot * (
     &                    (EF(1,1,iTs)-EF(1,2,iTs))
     &                  *(DPnt(iTs,iCen,iCar+1,1)
     &                   +DCntr(jSph,iCen,iCar+1,1))
     &                  + (EF(2,1,iTs)-EF(2,2,iTs))
     &                  *(DPnt(iTs,iCen,iCar+1,2)
     &                   +DCntr(jSph,iCen,iCar+1,2))
     &                  + (EF(3,1,iTs)-EF(3,2,iTs))
     &                  *(DPnt(iTs,iCen,iCar+1,3)
     &                   +DCntr(jSph,iCen,iCar+1,3))
     &                           )
                  End Do
               End If
            End Do
            iCen = iCen + nIrrep/dc(mdc)%nStab
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine  Gen_QVec(nIrrep,nBas_Aux)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Integer nBas_Aux(0:nIrrep-1), Lu_Q(0:7), Lu_A(0:7)
      Logical Out_Of_Core
      Character*6 Name_Q
*
      ThrQ=1.0D-14 ! Threshold for Inv_Cho_Factor
*
      mB=0
      nA_Diag=0
      Do iIrrep = 0, nIrrep-1
         nB = nBas_Aux(iIrrep)
         nA_Diag = nA_Diag + nB
         mB=Max(mB,nB)
*
         iSeed=55+iIrrep
         Lu_Q(iIrrep)=IsFreeUnit(iSeed)
         Write(Name_Q,'(A4,I2.2)') 'QMAT',iIrrep
         Call DaName_MF_WA(Lu_Q(iIrrep),Name_Q)
*
         iSeed=63+iIrrep
         Lu_A(iIrrep)=IsFreeUnit(iSeed)
         Write(Name_Q,'(A4,I2.2)') 'AVEC',iIrrep
         Call DaName_MF_WA(Lu_A(iIrrep),Name_Q)
      End Do
      nBfn2=mB**2
*
      Call Allocate_Work(ipZ,mB)
      Call Allocate_Work(ipX,mB)
      lScr=3*mB
      Call Allocate_Work(ip_Scr,lScr)
      Call GetMem('MemX','Max','Real',iDum,Mem_Max)
      Call GetMem('MemX','Allo','Real',ip_Mem,Mem_Max)
*
      Do iIrrep = 0, nIrrep-1
         nB = nBas_Aux(iIrrep)
         nQm=nB*(nB+1)/2
*
         Out_Of_Core = 2*nQm .gt. Mem_Max
         If (Out_Of_Core) Then
            MaxMem = Mem_Max - 2*nB
            mQm=MaxMem/2
            a=One
            b=-Two*DBLE(mQm)
            mB=INT(-a/Two + Sqrt( (a/Two)**2 - b ))
            kQm=mB*(mB+1)/2
            If (kQm.gt.mQm) Then
               Call WarningMessage(2,'Error in Gen_QVec')
               Write (6,*) 'kQm.gt.mQm!'
               Write (6,*) 'MaxMem=',MaxMem
               Write (6,*) 'nQm,mQm,kQm=',nQm,mQm,kQm
               Write (6,*) 'nB,mB=',nB,mB
               Call Abend()
            End If
            ip_Q_k = ip_Mem + 2*kQm
            ip_A_k = ip_Mem + 2*kQm + mB
         Else
            mB = nB
            kQm = nQm
            ip_Q_k = ip_Dummy
            ip_A_k = ip_Dummy
         End If
*
         ip_Qm=ip_Mem
         ip_Am=ip_Mem + kQm
         Call FZero(Work(ip_Qm),kQm)
         Call FZero(Work(ip_Am),kQm)
*
         iAddr=0
         Do kCol = 1, nB
*
            If (kCol.le.mB) Then
               iOff = (kCol-1)*kCol/2
               ip_A_l = ip_Am + iOff
            Else
               ip_A_l = ip_A_k
            End If
*
            iAddr_ = iAddr
            If (kCol.le.mB.and.kCol.eq.1) Then
               Call dDaFile(Lu_A(iIrrep),2,Work(ip_Am),kQm,iAddr_)
            Else If (kCol.gt.mB) Then
               Call dDaFile(Lu_A(iIrrep),2,Work(ip_A_l),kCol,iAddr_)
            End If
#ifdef _DEBUGPRINT_
            Write (6,*) 'kCol=',kCol
            Call TriPrt('Am',' ',Work(ip_Am),mB)
            Call RecPrt('Al',' ',Work(ip_A_l),1,kCol)
#endif
*
            If (kCol.le.mB) Then
               iOff = (kCol-1)*kCol/2
               ip_Q_l = ip_Qm + iOff
            Else
               ip_Q_l = ip_Q_k
            End If
*
            LinDep=2
            Call Inv_Cho_Factor(Work(ip_A_l),kCol,
     &                          Work(ip_Am),Work(ip_Qm),mB,
     &                          Lu_A(iIrrep),Lu_Q(iIrrep),
     &                          Work(ip_Scr),lScr,
     &                          Work(ipZ),Work(ipX),ThrQ,
     &                          Work(ip_Q_l),LinDep)

            If (LinDep.ne.0) Then
               Call WarningMessage(2,'Error in Gen_QVec')
               Write(6,*) 'Inv_Cho_Factor found linear dependence!'
               Call Abend()
            End If
#ifdef _DEBUGPRINT_
            Call TriPrt('Qm',' ',Work(ip_Qm),Min(mB,kCol))
            Call RecPrt('Ql',' ',Work(ip_Q_l),1,kCol)
#endif
*
*           Write the new A/Q-vector to file
*
            iAddr_=iAddr
            If (kCol.eq.mB) Then
               lQm=kCol*(kCol+1)/2
               Call dDaFile(Lu_Q(iIrrep),1,Work(ip_Qm),lQm,iAddr )
               Call dDaFile(Lu_A(iIrrep),1,Work(ip_Am),lQm,iAddr_)
            Else If (kCol.gt.mB) Then
               nQ_k=kCol
               Call dDaFile(Lu_Q(iIrrep),1,Work(ip_Q_l),nQ_k,iAddr )
               Call dDaFile(Lu_A(iIrrep),1,Work(ip_A_l),nQ_k,iAddr_)
            End If
*
         End Do    ! kCol
         Call DaClos(Lu_A(iIrrep))
      End Do       ! iIrrep
*
      Call GetMem('MemX','Free','Real',ip_Mem,Mem_Max)
      Call Free_Work(ip_Scr)
      Call Free_Work(ipX)
      Call Free_Work(ipZ)
*
*     Sort the Q-matrix to square storage.
*
      Call GetMem('iDiag','Allo','Inte',ip_iDiag,nA_Diag)
      ik = ip_iDiag
      Do iIrrep=0,nIrrep-1
         Do k=1,nBas_Aux(iIrrep)
            iWork(ik) = k  ! dummy assignement
            ik = ik + 1
         End Do
      End Do
      Call GetMem('MemMax','Max','Real',iDummy,MaxMem2)
      lScr=Min(MaxMem2,nBfn2)
      Call GetMem('Scr','Allo','Real',ip_Scr,lScr)
*
      Call SORT_Mat(irc,Work(ip_Dummy),nBas_Aux,nBas_Aux,
     &              iWork(ip_iDiag),nIrrep,Lu_Q,'Restore',
     &              lScr,Work(ip_Scr))
*
*     Note: after the 'Restore' call to Sort_mat, the Q-matrix is
*           no longer stored as upper-triangular but as squared
*           (zeros have been added).
*
      Call GetMem('Scr','Free','Real',ip_Scr,lScr)
      Call GetMem('iD_Diag','Free','Inte',ip_iDiag,nA_Diag)
*
      Do iIrrep=0,nIrrep-1
         Call DaClos(Lu_Q(iIrrep))
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fetch_init_const(nneq,neqv,nmax,exch,nLoc,nCenter,nT,nH,nTempMagn,nDir,nDirZee,nMult,nPair,MxRank1,MxRank2, &
                            old_aniso_format,iReturn)
! this routine looks into the file "single_aniso.input" for the "RESTart" keyword

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp, u5, u6

implicit none
integer(kind=iwp), intent(out) :: nneq, neqv, nmax, exch, nLoc, nCenter, nT, nH, nTempMagn, nDir, nDirZee, nMult, nPair, MxRank1, &
                                  MxRank2, iReturn
logical(kind=iwp), intent(in) :: old_aniso_format
integer(kind=iwp), parameter :: NMAXC = 99
integer(kind=iwp) :: i, idummy, iline, imaxrank(NMAXC,2), irank1, irank2, istatus, linenr, LUANISO, neqA(NMAXC), nexchA(NMAXC), &
                     nH_HEXP, nH_HINT, nT_TEXP, nT_TINT, nTempMagn_HEXP, nTempMagn_TMAG, sfs_check(NMAXC), sos_check(NMAXC)
real(kind=wp) :: rdummy, TempMagn(NMAXC)
logical(kind=iwp) :: ab_initio_all, ifHDF, KeyCoor, KeyHEXP, KeyPair, KeyTEXP !, KeyHINT, KeyITOJ, KeyMLTP, KeyMVEC, KeyNNEQ, &
                     !KeyTINT, KeyTMAG, KeyZEEM
character(len=280) :: line
character(len=180) :: namefile_aniso
character :: itype(NMAXC)
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: dbg = _DBG_
integer(kind=iwp), external :: Isfreeunit

#include "macros.fh"

iReturn = 0
nH = 0
nT = 0
nTempMagn = 1
nneq = 0
neqv = 0
nmax = 0
exch = 0
nCenter = 0
nDirZee = 0
nDir = 0
nMult = 0
nLoc = 0
nPair = 0
MxRank1 = 0
MxRank2 = 0
luaniso = 0
neqA(:) = 0
nexchA(:) = 0
sfs_check(:) = 0
sos_check(:) = 0
ab_initio_all = .false.
itype(:) = ' '
imaxrank(:,:) = 0

!namefile_aniso = ''
ifHDF = .false.

!KeyNNEQ = .false.
KeyPair = .false.
KeyCoor = .false.
KeyHEXP = .false.
KeyTEXP = .false.
!KeyTMAG = .false.
!KeyTINT = .false.
!KeyHINT = .false.
!KeyMLTP = .false.
!KeyMVEC = .false.
!KeyZEEM = .false.
!KeyITOJ = .false.
nH_HEXP = 0
nH_HINT = 0
nT_TEXP = 0
nT_TINT = 0
nTempMagn_HEXP = 0
nTempMagn_TMAG = 0
!=========== End of default settings====================================
rewind(u5)
do
  read(u5,'(A280)',iostat=istatus) LINE
  if (istatus < 0) call Error(2)
  call NORMAL(LINE)
  if (LINE(1:11) == '&POLY_ANISO') exit
end do
LINENR = 0
do
  read(u5,'(A280)',iostat=istatus) line
  if (istatus < 0) call Error(2)
  LINENR = LINENR+1
  call NORMAL(LINE)
  if ((LINE(1:1) == '*') .or. (LINE == ' ')) cycle

  select case (LINE(1:4))

    case ('END ','    ')
      exit

    case ('NNEQ')

      !KeyNNEQ = .true.
      read(u5,*) nneq,ab_initio_all,ifHDF

#     ifdef _DEBUGPRINT_
      write(u6,*) nneq,ab_initio_all,ifHDF
#     endif

      if (nneq < 0) then
        write(u6,'(A)') 'nneq<0! Must be positive!'
        call Quit_OnUserError()
      else if (nneq == 0) then
        write(u6,'(A)') 'nneq=0! Must be larger than zero!'
        call Quit_OnUserError()
      else if (nneq > NMAXC) then
        write(u6,'(A)') 'nneq>99! Must be smaller than this!'
        call Quit_OnUserError()
      end if

      read(u5,*) (neqA(i),i=1,nneq)
#     ifdef _DEBUGPRINT_
      write(u6,*) (neqA(i),i=1,nneq)
#     endif

      do i=1,nneq
        if (neqA(i) < 0) then
          write(u6,'(A,i2,A)') 'neq(',i,')<0! Must be positive!'
          call Quit_OnUserError()
        else if (neqA(i) == 0) then
          write(u6,'(A,i2,A)') 'neq(',i,')=0! Must be larger than zero!'
          call Quit_OnUserError()
        end if
      end do

      read(u5,*) (nexchA(i),i=1,nneq)
#     ifdef _DEBUGPRINT_
      write(u6,*) (nexchA(i),i=1,nneq)
#     endif

      do i=1,nneq
        if (nexchA(i) < 0) then
          write(u6,'(A,i2,A)') 'nexch(',i,')<0! Must be positive!'
          call Quit_OnUserError()
        else if (nexchA(i) == 0) then
          write(u6,'(A,i2,A)') 'nexch(',i,')=0! Must be larger than zero!'
          call Quit_OnUserError()
        end if
      end do

      neqv = 0
      neqv = maxval(neqA(1:nneq))
#     ifdef _DEBUGPRINT_
      write(u6,*) 'neqv = ',neqv
#     endif
      nmax = 0
      nmax = maxval(nexchA(1:nneq))
#     ifdef _DEBUGPRINT_
      write(u6,*) 'nmax = ',nmax
#     endif

      ! compute "exch"
      exch = 1
      do i=1,nneq
        exch = exch*nexchA(i)**neqA(i)
      end do
#     ifdef _DEBUGPRINT_
      write(u6,*) 'exch=',exch
#     endif

      if (.not. ab_initio_all) then
        read(u5,*,iostat=istatus) (itype(i),i=1,Nneq)
        if (istatus /= 0) call Error(1)
      else
        itype(1:nneq) = 'A'
      end if !ab_initio_all

      ! check the maximal number of local spin-orbit states
      sos_check = 0
      sfs_check = 0
      nCenter = sum(neqA(1:NNEQ))

      do i=1,NNEQ
        if (itype(i) == 'A') then
          if (ifHDF) then
            ! generating the name of the "aniso_input file for
            ! each center. Maxmimum 10 centers. CHAR(48)=0 (zero)
            if (i < 10) then
              write(namefile_aniso,'(4A)') 'aniso_hdf_',char(48+mod(i,10)),'.input'
            else if ((i >= 10) .and. (i <= 99)) then
              write(namefile_aniso,'(4A)') 'aniso_hdf_',char(48+mod(i/10,10)),char(48+mod(i,10)),'.input'
            end if

#           ifdef _HDF5_
            call read_hdf5_init(NAMEFILE_ANISO,sfs_check(I),sos_check(I))
#           ifdef _DEBUGPRINT_
            write(u6,*) ' sfs(I) ',sfs_check(I),' sos(I) ',sos_check(I)
#           endif
#           else
            call WarningMessage(2,'File '//trim(NAMEFILE_ANISO)//' cannot be opened. Molcas was compiled without HDF5 option.')
            call Quit_OnUserError()
#           endif
          else
            ! generating the name of the "aniso_input file for
            ! each center. Maxmimum 10 centers. CHAR(48)=0 (zero)
            if (i < 10) then
              write(namefile_aniso,'(4A)') 'aniso_',char(48+mod(i,10)),'.input'
            else if ((i >= 10) .and. (i <= 99)) then
              write(namefile_aniso,'(4A)') 'aniso_',char(48+mod(i/10,10)),char(48+mod(i,10)),'.input'
            end if
            LUANISO = Isfreeunit(20)
            call molcas_open(LUANISO,NAMEFILE_ANISO)

            if (old_aniso_format) then
              read(LUANISO,*) sfs_check(I),sos_check(I)
#             ifdef _DEBUGPRINT_
              write(u6,*) ' sfs(I) ',sfs_check(I),' sos(I) ',sos_check(I)
#             endif
            else
              call read_nss(LUANISO,sos_check(i),dbg)
              call read_nstate(LUANISO,sfs_check(i),dbg)
#             ifdef _DEBUGPRINT_
              write(u6,*) ' sfs(I) ',sfs_check(I),' sos(I) ',sos_check(I)
#             endif
            end if
            close(LUANISO)
          end if ! ifHDF

        else if ((itype(i) == 'B') .or. (itype(i) == 'C')) then
          sfs_check(I) = 1
          sos_check(I) = NexchA(i)
        end if

      end do ! NNEQ

      nLoc = maxval(sos_check(1:nneq))

      LINENR = LINENR+3

    case ('TEXP')

      KeyTexp = .true.
      read(u5,*) nT_TEXP

      if (nT_TEXP <= 0) then
        call WarningMessage(2,'TEXP: Number of temperature points <= 0! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'TEXP:: = nT_TEXP',nT_TEXP
#     endif

      LINENR = LINENR+1

    case ('HEXP')

      KeyHexp = .true.
      read(u5,*) nTempMagn_HEXP,(TempMagn(i),i=1,nTempMagn)
      unused_var(TempMagn)
      read(u5,*) nH_HEXP

      if (nH_HEXP <= 0) then
        call WarningMessage(2,'HEXP: Number of field points <= 0! ')
        call Quit_OnUserError()
      end if

      if (nTempMagn_HEXP <= 0) then
        call WarningMessage(2,'HEXP: Number of temperature points <= 0! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'HEXP:: = nH_HEXP ',nH_HEXP
      write(u6,*) 'HEXP:: = nTempMagn_HEXP ',nTempMagn_HEXP
#     endif
      LINENR = LINENR+2

    case ('HINT')

      !KeyHINT = .true.
      read(u5,*) rdummy,rdummy,nH_HINT

      if (nH_HINT <= 0) then
        call WarningMessage(2,'HINT: Number of field points <= 0! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'HINT:: = nH_HINT ',nH_HINT
#     endif
      LINENR = LINENR+1

    case ('TINT')

      !KeyTINT = .true.
      read(u5,*) rdummy,rdummy,nT_TINT

      if (nT_TINT <= 0) then
        call WarningMessage(2,'TINT: Number of temperature points <= 0! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'TINT:: = nT_TINT ',nT_TINT
#     endif
      LINENR = LINENR+1

    case ('TMAG')

      !KeyTMAG = .true.
      read(u5,*) nTempMagn_TMAG

      if (nTempMagn_TMAG <= 0) then
        call WarningMessage(2,'TMAG: Number of temperatureMAGN points <= 0! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'TMAG:: = nTempMagn_TMAG ',nTempMagn_TMAG
#     endif
      LINENR = LINENR+1

    case ('MVEC')

      !KeyMVEC = .true.
      read(u5,*) nDir

      if (nDir <= 0) then
        call WarningMessage(2,'MVEC: Number of nDir points <= 0! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'MVEC:: = nDir ',nDir
#     endif
      LINENR = LINENR+1

    case ('ZEEM')

      !KeyZEEM = .false.
      read(u5,*) nDirZee

      if (nDirZee <= 0) then
        call WarningMessage(2,'ZEEM: Number of nDirZee points <= 0! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'ZEEM:: = nDirZee ',nDirZee
#     endif
      LINENR = LINENR+1

    case ('MLTP')

      !KeyMLTP = .true.
      read(u5,*) nMult

      if (nMult <= 0) then
        call WarningMessage(2,'MLTP: Number of multiplets <= 0! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'MLTP:: =nMult ',nMult
#     endif
      LINENR = LINENR+1

    case ('LIN9','LIN3','LIN1','ALIN','PAIR','ITOJ')

      KeyPair = .true.
      read(u5,*,iostat=istatus) nPair
      if (istatus /= 0) call Error(1)

      if (nPair <= 0) then
        call WarningMessage(2,'PAIR OR LINx:: Number of interacting pairs <= 0!')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'PAIR:: =nPair ',nPair
#     endif

      if (LINE(1:4) == 'ITOJ') then
        iline = 0
        do i=1,npair
          imaxrank(i,1) = 0
          imaxrank(i,2) = 0

          read(u5,*,iostat=istatus) idummy,idummy,imaxrank(i,1),imaxrank(i,2)
          if (istatus /= 0) call Error(1)
          do irank1=1,2*imaxrank(i,1)+1
            do irank2=1,2*imaxrank(i,2)+1
              read(u5,*,iostat=istatus) idummy,idummy,idummy,idummy,rdummy,rdummy
              if (istatus /= 0) call Error(1)
              iline = iline+1
            end do
          end do
        end do ! i
        MxRank1 = maxval(imaxrank(1:npair,1))
        MxRank2 = maxval(imaxrank(1:npair,2))
        LINENR = LINENR+iline
      end if
      LINENR = LINENR+1

    case ('COOR')

      KeyCoor = .true.
      LINENR = LINENR+1

  end select

end do

if ((.not. KeyPair) .and. KeyCoor) nPair = nTri_Elem(nCenter-1)

if (KeyHexp) then
  nTempMagn = nTempMagn_HEXP
  nH = nH_HEXP
else
  nTempMagn = nTempMagn_TMAG
  nH = nH_HINT
end if

if (KeyTEXP) then
  nT = nT_TEXP
else
  nT = nT_TINT
end if

! in case the user did not set up some of the above keywords
! assume the following default ones:
if (nMult == 0) nMult = 1
if (nT == 0) nT = 31
if (nH == 0) nH = 11
if (nTempMagn == 0) nTempMagn = 1

! preliminary check the values:
#ifdef _DEBUGPRINT_
write(u6,*) 'nneq     =',nneq
write(u6,*) 'neqv     =',neqv
write(u6,*) 'exch     =',exch
write(u6,*) 'nLoc     =',nLoc
write(u6,*) 'nmax     =',nmax
write(u6,*) 'nCenter  =',nCenter
write(u6,*) 'nT       =',nT
write(u6,*) 'nH       =',nH
write(u6,*) 'nTempMagn=',ntempMagn
write(u6,*) 'nDir     =',nDir
write(u6,*) 'nDirZee  =',nDirZee
write(u6,*) 'nMult    =',nMult
write(u6,*) 'nPair    =',nPair
write(u6,*) 'MxRank1  =',MxRank1
write(u6,*) 'MxRank2  =',MxRank2
#endif

return

unused_var(idummy)
unused_var(rdummy)

contains

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

# include "warnings.h"

  select case (code)
    case (1)
      write(u6,*) ' FETCH_INIT_CONST: Error reading "poly_aniso.input" '
      write(u6,*) ' near line nr.',LINENR+1
    case (2)
      write(u6,*) ' FETCH_INIT_CONST: Unexpected End of input file.'
  end select
  call quit(_RC_INPUT_ERROR_)

end subroutine Error

end subroutine fetch_init_const

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per-Olof Widmark                                 *
************************************************************************
      Subroutine NatoUHF(DensA,DensB,FockA,FockB,nBT,CMO,nBB,Ovl,
     &                   Nato,Eta,Eps,nnB,
     &                   nSym,nBas,nOrb)
************************************************************************
*                                                                      *
* This routine computes the natural orbitals for a UHF wavefunction.   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University, Sweden                                     *
* Written: September 2006                                              *
*                                                                      *
************************************************************************
      Implicit None
#include "stdalloc.fh"
*----------------------------------------------------------------------*
* Dummy arguments                                                      *
*----------------------------------------------------------------------*
      Integer nBT, nBB, nnB
      Real*8  DensA(nBT)
      Real*8  DensB(nBT)
      Real*8  FockA(nBT)
      Real*8  FockB(nBT)
      Real*8  CMO(nBB)
      Real*8  Ovl(nBT)
      Real*8  Nato(nBB)
      Real*8  Eta(nnB)
      Real*8  Eps(nnB)
      Integer nSym
      Integer nBas(nSym)
      Integer nOrb(nSym)
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Integer MaxTri
      Integer MaxSqr
      Integer nTri
      Integer nSqr
      Integer nCMO
      Integer nEta
      Integer iOffTri
      Integer iOffSqr
      Integer iOffCMO
      Integer iOffEta
      Integer iSym
      Integer iOrb
      Integer indx
      Integer i
      Real*8  tmp
      Real*8, Dimension(:), Allocatable:: Dens, Fock, SMat, Aux1, Aux2,
     &                                    Aux3
*----------------------------------------------------------------------*
* Setup                                                                *
*----------------------------------------------------------------------*
      MaxTri=0
      MaxSqr=0
      nTri=0
      nSqr=0
      nCMO=0
      nEta=0
      Do iSym=1,nSym
         MaxTri=Max(MaxTri,nBas(iSym)*(nBas(iSym)+1)/2)
         MaxSqr=Max(MaxSqr,nBas(iSym)*nBas(iSym))
         nTri=nTri+nBas(iSym)*(nBas(iSym)+1)/2
         nSqr=nSqr+nBas(iSym)*nBas(iSym)
         nCMO=nCMO+nBas(iSym)*nOrb(iSym)
         nEta=nEta+nOrb(iSym)
      End Do
*----------------------------------------------------------------------*
* Allocate arrays                                                      *
*----------------------------------------------------------------------*
      Call mma_allocate(Dens,nTri,Label='Dens')
      Call mma_allocate(Fock,nTri,Label='Fock')
      Call mma_allocate(SMat,MaxSqr,Label='SMat')
      Call mma_allocate(Aux1,MaxSqr,Label='Aux1')
      Call mma_allocate(Aux2,MaxSqr,Label='Aux2')
      Call mma_allocate(Aux3,MaxSqr,Label='Aux3')
*----------------------------------------------------------------------*
* Add up the densities                                                 *
*----------------------------------------------------------------------*
      Do i=1,nTri
        Dens(i)=DensA(i)+DensB(i)
      End Do
*----------------------------------------------------------------------*
* Copy orbitals                                                        *
*----------------------------------------------------------------------*
      Do i=1,nCMO
         Nato(i)=CMO(i)
      End Do
*----------------------------------------------------------------------*
* Average Fock matrix.                                                 *
*----------------------------------------------------------------------*
      Do i=1,nTri
         Fock(i)=0.5d0*(FockA(i)+FockB(i))
      End Do
*     iOffTri=0
*     Do iSym=1,nSym
*        Call TriPrt('natouhf: Fock A','(20f10.4)',
*    &      FockA(1+iOffTri),nBas(iSym))
*        Call TriPrt('natouhf: Fock B','(20f10.4)',
*    &      FockB(1+iOffTri),nBas(iSym))
*        Call TriPrt('natouhf: Average Fock','(20f10.4)',
*    &      FockB(1+iOffTri),nBas(iSym))
*        iOffTri=iOffTri+nBas(iSym)*(nBas(iSym)+1)/2
*     End Do
*----------------------------------------------------------------------*
* Form density in MO basis: C(t)SDSC                                   *
*----------------------------------------------------------------------*
      iOffSqr=0
      iOffTri=0
      iOffCMO=0
      iOffEta=0
      Do iSym=1,nSym
         If(nBas(iSym).le.0) Goto 200
*
* Compute C(t)S (=aux1), but square S first
*
         Call Square(Ovl(iOfftri+1),Smat,1,nBas(iSym),nBas(iSym))
*        Call RecPrt('natouhf: Smat','(12f12.6)',Smat,
*    &               nBas(iSym),nBas(iSym))
         Call DGEMM_('T','N',
     &               nOrb(iSym),nBas(iSym),nBas(iSym),
     &               1.0d0,CMO(iOffCMO+1),nBas(iSym),
     &                     Smat,nBas(iSym),
     &               0.0d0,Aux1,nOrb(iSym))
*        Call RecPrt('natouhf: C(t)S','(12f12.6)',Aux1,
*    &               nOrb(iSym),nBas(iSym))
*
* Compute C(t)SD (=aux3), but first unfold D (=aux2)
*
         Call Dsq(Dens(1+iOffTri),Aux2,1,nBas(iSym),nBas(iSym))
*        Call RecPrt('natouhf: Density','(12f12.6)',Aux2,
*    &               nBas(iSym),nBas(iSym))
         Call DGEMM_('N','N',
     &               nOrb(iSym),nBas(iSym),nBas(iSym),
     &               1.0d0,Aux1,nOrb(iSym),
     &                     Aux2,nBas(iSym),
     &               0.0d0,Aux3,nOrb(iSym))
*        Call RecPrt('natouhf: C(t)SD','(12f12.6)',Aux3,
*    &               nOrb(iSym),nBas(iSym))
*
* Compute C(t)SDS (=aux1)
*
         Call DGEMM_('N','N',
     &               nOrb(iSym),nBas(iSym),nBas(iSym),
     &               1.0d0,Aux3,nOrb(iSym),
     &                     Smat,nBas(iSym),
     &               0.0d0,Aux1,nOrb(iSym))
*        Call RecPrt('natouhf: C(t)SDS','(12f12.6)',Aux1,
*    &               nOrb(iSym),nBas(iSym))
*
* Compute C(t)SDSC (=aux2)
*
         Call MxMt(Aux1,   1,nOrb(iSym),
     &             CMO(iOffCMO+1), 1,nBas(iSym),
     &             Aux2,
     &             nOrb(iSym),nBas(iSym))
*        Call TriPrt('natouhf: C(t)SDSC','(12f12.6)',
*    &           Aux2,nOrb(iSym))
*
* Shift diagonal slightly
*
         tmp=1.0d-6
         Do iOrb=1,nOrb(iSym)
            indx=iOrb*(iOrb+1)/2
            Aux2(indx)=Aux2(indx)+tmp
            tmp=0.5d0*tmp
         End Do
*        Call TriPrt('natouhf: C(t)SDSC + shift','(12f12.6)',
*    &           Aux2,nOrb(iSym))
*
* Diagonalize
*
         Call NIdiag(Aux2,Nato(iOffCMO+1),
     &               nOrb(iSym),nBas(iSym),0)
         Call Pickup(Aux2,Eta(iOffEta+1),nOrb(iSym))
         Do i=1,nOrb(iSym)
            Eta(iOffEta+i)=-Eta(iOffEta+i)
         End Do
         Call SortEig(Eta(iOffEta+1),Nato(iOffCMO+1),
     &                nOrb(iSym),nBas(iSym))
         Do i=1,nOrb(iSym)
            Eta(iOffEta+i)=-Eta(iOffEta+i)
         End Do
200      Continue
         iOffTri=iOffTri+nBas(iSym)*(nBas(iSym)+1)/2
         iOffSqr=iOffSqr+nBas(iSym)*nBas(iSym)
         iOffEta=iOffEta+nOrb(iSym)
         iOffCMO=iOffCMO+nBas(iSym)*nOrb(iSym)
      End Do
*----------------------------------------------------------------------*
* Compute diagonal of average Fock matrix                              *
*----------------------------------------------------------------------*
      Call MkEorb_(Fock,nBT,Nato,nBB,Eps,nnB,nSym,nBas,nOrb)
*     Call PriMO('natouhf: UHF nato',.true.,.true.,-1.0d0,1.0d6,
*    &           nSym,nBas,nOrb,Name,
*    &           Eps,Eta,Nato,3)
*----------------------------------------------------------------------*
* Deallocate arrays                                                    *
*----------------------------------------------------------------------*
      Call mma_deallocate(Aux3)
      Call mma_deallocate(Aux2)
      Call mma_deallocate(Aux1)
      Call mma_deallocate(SMat)
      Call mma_deallocate(Fock)
      Call mma_deallocate(Dens)
*----------------------------------------------------------------------*
* Done                                                                 *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine COUL(ISYP,ISYQ,ISYI,ISYJ,II,IJ,ERI,SCR)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ISYP, ISYQ, ISYI, ISYJ, II, IJ
real(kind=wp), intent(_OUT_) :: ERI(*), SCR(*)
integer(kind=iwp) :: I3, I34, I4, IDISK, IS12, IS34, ISY1, ISY2, ISY3, ISY4, NBUF, NDIM2M, NO1, NO2
logical(kind=iwp) :: TRANSP, TRIANG
#include "intgrl.fh"

! Return a matrix ERI(IP,IQ) of two-electron integrals (pq,ij).
! IP=1..NORB(ISYP), IQ=1..NORB(ISYQ),1<=II<=NOSH(ISYI),
! 1<=IJ<=NOSH(ISYJ). Normal Fortran storage order.

NDIM2M = (NSYMZ*(NSYMZ+1))/2
TRANSP = .false.
TRIANG = .false.
if (ISYP >= ISYQ) then
  ISY1 = ISYP
  ISY2 = ISYQ
  TRANSP = .true.
  !TYPE = 'TRANSPOS'
  if (ISYP == ISYQ) then
    TRIANG = .true.
  end if
  !if (ISYP == ISYQ) TYPE = 'TRIANGUL'
else
  ISY1 = ISYQ
  ISY2 = ISYP
  !TYPE = 'NORMAL  '
end if
if (ISYI >= ISYJ) then
  ISY3 = ISYI
  ISY4 = ISYJ
  I3 = II
  I4 = IJ
  if ((ISYI == ISYJ) .and. (II < IJ)) then
    I3 = IJ
    I4 = II
  end if
else
  ISY3 = ISYJ
  ISY4 = ISYI
  I3 = IJ
  I4 = II
end if

! Disk address to symmetry block:
IS12 = (ISY1*(ISY1-1))/2+ISY2
IS34 = (ISY3*(ISY3-1))/2+ISY4
IDISK = IAD2M(1,IS12+NDIM2M*(IS34-1))

! Record number, in symmetry block:
I34 = I4+NOSHZ(ISY4)*(I3-1)
if (ISY3 == ISY4) I34 = (I3*(I3-1))/2+I4

! Buffer sizes:
NO1 = NORBZ(ISY1)
NO2 = NORBZ(ISY2)
NBUF = NO1*NO2
if (TRIANG) NBUF = (NBUF+NO1)/2
if (NBUF == 0) return

! Address update for earlier records, then read:
IDISK = IDISK+NBUF*(I34-1)

if (.not. TRANSP) then
  call dDAFILE(LUINTMZ,2,ERI,NBUF,IDISK)
else
  call dDAFILE(LUINTMZ,2,SCR,NBUF,IDISK)

  if (.not. TRIANG) then
    call TRNSPS(NO2,NO1,SCR,ERI)
  else
    call SQUARE(SCR,ERI,NO1,1,NO1)
  end if
end if

return

end subroutine COUL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine setup_cho(nSym,nIsh,nAsh,nSsh,NumCho,mode)
* -------------------------
* This subroutine uses the input variables to compute
* ipsp,nisplit, nasplit,lsplit,ipnp,ipip each dimensioned (1:nsym),
* in common /chocaspt2/,
* and allocates fields at iwork() addresses ipsp(1:nsym),ipnp(1:nsym),
* ipunit_f(1:nsym), each with sizes lsplit(1:nsym), and
* ipip(1:nsym), each with sizes nsym*lsplit(1:nsym)
* -------------------------
      Implicit Real*8 (a-h,o-z)
      Integer nSym,nIsh(8),nAsh(8),nSsh(8)
      Integer NumCho(8)
      Integer iAorb(8),iIorb(8),iKorb(8)
      Character(len=*) mode
      Character(len=4) modecopy

#include "chocaspt2.fh"
#include "WrkSpc.fh"
      Integer  cho_irange
      External cho_irange

C *********************************************************************
      nIc(i,j) = iWork(ipsp(j)+i-1)
******
      nAc(i,j) = iWork(ipsp(j)+nisplit(j)+i-1)
******
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
C *********************************************************************

#ifdef _DEBUGPRINT_
      IFTEST=1
#else
      IFTEST=0
#endif

      modecopy=mode(1:4)
      Call UpCase(modecopy)
      if (modecopy.eq.'FREE') then
       Do jSym=1,nSym
        If (NumCho(jSym).gt.0) then
         Call GetMem('Unit_F','Free','Inte',ipunit_f(jSym),
     &                                         lsplit(jSym))
         Call GetMem('iPorb','Free','Inte',ipip(jSym),
     &                                        nSym*lsplit(jSym))
         Call GetMem('nPorb','Free','Inte',ipnp(jSym),lsplit(jSym))
         Call GetMem('Split','Free','Inte',ipsp(jSym),lsplit(jSym))
        End If
       End Do
       Return
      end if

      do i=1,8
       ipunit_f(i)=0
       ipsp(i)=0
       lsplit(i)=0
       nisplit(i)=0
       nasplit(i)=0
       ipnp(i)=0
       ipip(i)=0
       nksh(i)=0
       nkes(i)=0
       npsh(i)=0
       npes(i)=0
      end do

* PAM07: New arrays: 'k shells' = inactive+active orbitals
* 'p shells' = active+secondary orbitals
*  nksh(isym)= Nr of shells by symmetry, nkes=nr of k shells in Earlier Symmetries:
      nksum=0
      npsum=0
      do isym=1,nsym
       ni=nish(isym)
       na=nash(isym)
       ns=nssh(isym)
       nksh(isym)=ni+na
       npsh(isym)=na+ns
       nkes(isym)=nksum
       npes(isym)=npsum
       nksum=nksum+nksh(isym)
       npsum=npsum+npsh(isym)
      end do

* Local arrays:
* iIorb(iSym) = Nr of inactive orbitals in earlier symmetries.
* iAorb(iSym) = Nr of   active orbitals in earlier symmetries.
* iKorb(iSym) = iIorb(iSym) + iAorb(iSym)
      iIorb(1)=0
      iAorb(1)=0
      iKorb(1)=0
      Do iSym=2,nSym
         iIorb(iSym) = iIorb(iSym-1) + nIsh(iSym-1)
         iAorb(iSym) = iAorb(iSym-1) + nAsh(iSym-1)
         iKorb(iSym) = iIorb(iSym) + iAorb(iSym)
      End Do

* nIO   = total number of inactive orbitals.
* nAO   = total number of active orbitals.
* nOkrb = total number of inactive+active orbitals.
* nOrb  = total number of orbitals
      nOkrb=0
      nIO=0
      nAO=0
      nO=0
      Do iSym=1,nSym
         nOkrb = nOkrb + nIsh(iSym) + nAsh(iSym)
         nOrb = nIsh(iSym) + nAsh(iSym) + nSsh(iSym)
         nO = nO + nOrb*(nOrb+1)/2
         nIO = nIO + nIsh(iSym)
         nAO = nAO + nAsh(iSym)
      End Do

      xO = dble(nO)

* Task: set up the necessary administration of transformed Cholesky
* vectors. Each such vector is characterized by the composite symmetry
* label JSYM. Vectors with common JSYM are stored on the same unit.
* For a given JSYM, there are NumCho(jSym) vectors. These are separated
* into subsets -- batches -- There will be nISplit(jSym) batches with
* vectors with a fixed inactive orbital index (Inactive vectors), and
* nASplit(jSym) batches with vectors with a fixed active index
* (Active vectors). Each batch has vectors with fixed index within a
* range of size iWork(ipsp(jSym)+i-1) where i is in 1..nISplit(jSym) or
*  in nISplit(jSym)+1..nISplit(jSym)+nASplit(jSym).
* The vectors themselves have a size of iWork(ipnp(jSym)+i-1)
* The vectors are generally referred to as e.g. p#k, where #k stands
* for the fixed inactive or active orbital, while p is all the orbitals
* with a symmetry such that the compound symmetry label is JSYM.
* There will be a (possibly large) number of such vectors, each indexed
* with 'J' generally. This is the summation index in the definition of
* the cholesky vectors.
      Do jSym=1,nSym
         If (NumCho(jSym).lt.1) goto 99

         Call GetMem('MaxMem','Max','Real',Kdummy,MemMx)
         xMemMx = dble(MemMx)
* xMemMx = largest allocatable field.

         jfrac=1

 10         Continue
         Mem1 = 2*NumCho(jSym)/jfrac  ! hold 2 vectors in memory
         If (Mem1.eq.0 .and. jfrac.gt.1) then
            Write(6,*)' Setup_cho fails to set up the data structures'
            Write(6,*)' used for the Cholesky vectors.'
            Write(6,*)' Too little memory is available at this point.'
            Write(6,*)' Details:'
            xmb=xMemMx/1048576.0D0
            Write(6,'(1x,a,1x,f10.3)')
     &              ' Largest contiguous allocatable memory (MB):',xmb
            xmb=2.0D0*DBLE(NUMCHO(JSYM))/1048576.0D0
            Write(6,'(1x,a,1x,f10.3)')
     &              '                        2*NumCho(jSym) (MB):',xmb
            Write(6,*)' Divided up on jFrac pieces. jFrac=',jFrac
            Write(6,*)
     &            ' If this seems odd, please tell Molcas programmers.'
            Write(6,*)' Right now, the allocated memory is:'
            call getmem('list','list','real',kdummy,ndummy)
            Call Cho_x_Quit('setup_cho',
     &                          ': Sorry! Too little memory!!',' ')
         EndIf

         kfrac=0
         kfrac=kfrac+1
* Subdivide the set of orbitals into kfrac pieces of size .le. nKsp
         nKsp = nOkrb/kfrac
* If kfrac has grown too large, start again using kfrac=1 but larger jfrac
         If (nKsp .eq. 0) Then
             jfrac = jfrac + 1
             goto 10
         EndIf

* Loop over pieces of the orbital set:
         nPmax=0
         Do iK1=1,nOkrb,nKsp
          iK2=max(iK1-1+nKsp,nOkrb)
* For this piece, compute the number of (p,k) orbital pairs
* with p active or secondary, and with joint symmetry jSym:
          nP=0
          Do iK=iK1,iK2
           kS = cho_irange(iK,iKorb,nSym,.false.)
           jS = MulD2h(kS,jSym)
           nP = nP + nAsh(jS) + nSsh(jS)
          End Do
* nPmax will be the largest number of such pairs in any piece.
          nPmax=Max(nPmax,nP)
         End Do

* PAM:The following looks strange, since the max is over the same set
* of numbers no matter what jSym is.
         mRHS=0
         Do iS=1,nSym
            jS = MulD2h(iS,jSym)
            mRHS = Max( mRHS, Max(nAsh(jS),nSsh(jS)) )
         End Do

C --- Conversion to real*8 to avoid integer overflow on 32-bit machines

* PAM:Why would this be 'mem for right-hand side?'
         xRHS = dble(mRHS**2)           ! mem. for right hand side
         xLpk = dble(Mem1*nPmax*nKsp)   ! store Cholesky MO vectors
         xPIQK= dble((nPmax*nKsp)**2)   ! store integrals
         xmNeed= xO + xPIQK + Max(xLpk,2.0D0*xRHS) ! Fmat+integrals+rhs

* This also looks strange -- nIAc=all the inact+act orbitals no matter what.?
         nIAc =nOkrb

         jIAc = nIAc
         lsplit(jSym)=1
         Do while (jIAc .lt. nOkrb)
            lsplit(jSym) = lsplit(jSym) + 1
            jIAc = jIAc + nIAc
         End Do

* What does this mean? Simply that lsplit(jSym) will be 'the next'
* of something?
         lsplit(jSym) = lsplit(jSym) + 1 ! separate out Ina from Act

* Need xmNeedNow units of memory
*         xmNeedNow = xmNeed + dble((3+nSym)*lsplit(jSym))

* Allocate arrays, in all (3+nSym)*lsplit(jSym) elements:
         Call GetMem('Split','Allo','Inte',ipsp(jSym),lsplit(jSym))
         Call GetMem('nPorb','Allo','Inte',ipnp(jSym),lsplit(jSym))
         Call GetMem('iPorb','Allo','Inte',ipip(jSym),
     &                                        nSym*lsplit(jSym))
         Call GetMem('Unit_F','Allo','Inte',ipunit_f(jSym),
     &                                         lsplit(jSym))
         do i=1,lsplit(jSym)
          iwork(ipsp(jSym)-1+i)=0
          iwork(ipnp(jSym)-1+i)=0
          iwork(ipunit_f(jSym)-1+i)=0
          do j=1,nsym
           iwork(ipip(jSym)-1+j+nsym*(i-1))=0
          end do
         end do

         nmin=Min(nIO,nIAc)
         jS=0
         if(nmin.gt.0) jS=nIO/nmin
         Do i=0,jS-1
           iWork(ipsp(jSym)+i) = nmin
         End Do
         mDiff = jS*nmin - nIO
         If (mDiff .gt. 0) Then
            iWork(ipsp(jSym)+jS) = mDiff
            jS = jS + 1
         Endif
         nisplit(jSym) = jS

         nmin=Min(nAO,nIAc)
         jS=0
         if(nmin.gt.0) jS=nAO/nmin
         Do i=0,jS-1
           iWork(ipsp(jSym)+nisplit(jSym)+i) = nmin
         End Do
         mDiff = jS*nmin - nAO
         If (mDiff .gt. 0) Then
            iWork(ipsp(jSym)+nisplit(jSym)+jS) = mDiff
            jS = jS + 1
         Endif
         nasplit(jSym) = jS

* Note: The inactive orbitals will be partitioned.
* The isp=1..nisplit(jSym) is counter of the partitions.
* ioff will be the number of inactive orbitals in earlier partitions.
         ioff=0
         Do isp=1,nisplit(jSym)
* ioff+1 is the first orbital of partition isp.
            lS = cho_irange(ioff+1,iIorb,nSym,.false.)
* lS is its symmetry.
            iK = nIc(isp,jSym) + ioff
* Note: nIc(isp,jSym)=iWork(ipsp(jSym)+isp-1)
* iK is the last orbital of the partition, and kS its symmetry
            kS = cho_irange(iK,iIorb,nSym,.false.)

            nPorb=0
* Loop over the symmetry range of inactive orbitals in the partition
            Do iS=lS,kS
* jS is then the symmetry of its companion orbital in the pair.
               jS=MulD2h(iS,jSym)
* ipip(jSym) is pointer to an array dimensioned iP(nSym,nisplit(jSym))
* which is used for offsets. In some other array, after the position
* iP(jS,isp) follows space for nAsh(jS)+nSsh(jS) items.
               iWork(ipip(jSym)+nSym*(isp-1)+jS-1) = nPorb
* Update nPorb.
               nPorb = nPorb + nAsh(jS) + nSsh(jS)
            End Do

* ipnp(jSym) is pointer to an array dimensioned nP(nisplit(jSym))
* It gives the total size for the items mentioned above.
            iWork(ipnp(jSym)+isp-1) = nPorb
            ioff = ioff + nIc(isp,jSym)
         End Do

* Here follows similar arrays for the active orbitals.
* Addressing is the same, except we use iP(jS,nisplit(jSym)+isp)
* and nP(nisplit(jSym)+isp)
         ioff=0
         Do isp=1,nasplit(jSym)
            lS = cho_irange(ioff+1,iAorb,nSym,.false.)
            iw = nAc(isp,jSym) + ioff
            kS = cho_irange(iw,iAorb,nSym,.false.)
            nPorb=0
            Do iS=lS,kS
              jS=MulD2h(iS,jSym)
              iWork(ipip(jSym)+nSym*(nisplit(jSym)+isp-1)+jS-1)=nPorb
              nPorb = nPorb + nAsh(jS) + nSsh(jS)
            End Do
            iWork(ipnp(jSym)+nisplit(jSym)+isp-1) = nPorb
            ioff = ioff + nAc(isp,jSym)
         End Do

99       Continue

      End Do

      if (iftest.ne.0) then
      write(6,*)
      write(6,*)' setup_cho report:'
      write(6,*)
      write(6,'(1x,a,8i4)')' Inactive :',(nIsh(isym),isym=1,nSym)
      write(6,'(1x,a,8i4)')' Active   :',(nAsh(isym),isym=1,nSym)
      write(6,'(1x,a,8i4)')' Secondary:',(nSsh(isym),isym=1,nSym)
      write(6,*)
      write(6,'(1x,a,8i4)')' NumCho   :',(NumCho(isym),isym=1,nSym)
      write(6,*)
      write(6,*)' Partition  Fixed orbitals       nPorb space'
      do jsym=1,nsym
       write(6,*)' Symm:',jSym
       kend=0
       do isp=1,nisplit(jsym)
        ksta=kend+1
        kend=kend+iWork(ipsp(jSym)+isp-1)
        kstasym=cho_irange(ksta,iIorb,nSym,.false.)
        kendsym=cho_irange(kend,iIorb,nSym,.false.)
        nPorb=iWork(ipnp(jSym)+isp-1)
        write(6,'(1x,i4,5x,i4,a4,i4,2x,i1,a4,i1,5x,i4)')
     &        isp,ksta,' -- ',kend,kstasym,' -- ',kendsym,nPorb
        write(6,'(1x,a,8i8)')' iP Offsets:',(iWork(ipip(jSym)+
     &                 nSym*(isp-1)+MulD2h(jSym,iS)-1),iS=1,nSym)
       write(6,*)
       end do
       kend=0
       do isp=1,nasplit(jsym)
        ksta=kend+1
        kend=kend+iWork(ipsp(jSym)+nisplit(jSym)+isp-1)
        kstasym=cho_irange(ksta,iAorb,nSym,.false.)
        kendsym=cho_irange(kend,iAorb,nSym,.false.)
        nPorb=iWork(ipnp(jSym)+nisplit(jSym)+isp-1)
        write(6,'(1x,i4,5x,i4,a4,i4,2x,i1,a4,i1,5x,i4)')
     &        isp,ksta,' -- ',kend,kstasym,' -- ',kendsym,nPorb
        write(6,'(1x,a,8i8)')' iP Offsets:',
     &         (iWork(ipip(jSym)+nSym*(nisplit(jSym)+isp-1)+
     &                             MulD2h(jSym,iS)-1),iS=1,nSym)
       write(6,*)
       end do
      end do
      end if


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine check_mat(mat,dima,dimb)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dima, dimb
real(kind=wp), intent(in) :: mat(dima,dimb)
integer(kind=iwp) :: i, j

do i=1,dima
  do j=1,dimb
    if (abs(mat(i,j)) > 1.0e5_wp) write(u6,*) 'i,j,mat(i,j) ',i,j,mat(i,j)
  end do
end do

return

end subroutine check_mat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine simplify3 (i,uniorder,dkhorder,xorder,dkhscfflg,
     *               ordercounter,opcounter,operleng,oporder,evenodd,
     *               doperators,operators,xordercounter,xopcounter,
     *               xoperleng,xoporder,xevenodd,xdoperators,xoperators,
     *               wordercounter,wopsleng,woporder,eowops,dwops,wops,
     *               dkhzerothrsh)
c
c***************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 30.06.2005
c
c   first version: 23.07.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer i,uniorder,dkhorder,xorder,ordercounter(0:maxorder),
     *        opcounter,operleng(maxoperators),oporder(maxoperators,3),
     *        evenodd(maxoperators),xordercounter(0:maxorder),
     *        xopcounter,xoperleng(maxoperators),xoporder(maxoperators),
     *        xevenodd(maxoperators),
     *        wordercounter(maxorder),wopsleng(maxuops),
     *        woporder(maxuops,3),eowops(maxuops)
      real*8 doperators(maxoperators),
     *                 xdoperators(maxoperators),dwops(maxuops)
      character*(maxlength) wops(maxuops)
#if defined(_MOLCAS_) || defined(MOLPRO)
      character*(maxlength) opstring1,opstring2,xopstring1,xopstring2
      character operators(*),xoperators(*)
#else
      character*(maxlength) operators(maxoperators),
     *          xoperators(maxoperators)
#endif
c
      real*8 dkhzerothrsh(0:maxorder)
c
      logical dkhscfflg
      integer j,k,l,m,ilow
      intrinsic DABS
 240  continue
      ilow=1
      do 10 j=0,dkhorder
        do 20 k=ilow,ilow+ordercounter(j)-1
#if defined(_MOLCAS_) || defined(MOLPRO)
          call get_dkoperators(k,opstring1,operators)
#endif
          do 30 l=k+1,ilow+ordercounter(j)-1
#if defined(_MOLCAS_) || defined(MOLPRO)
            call get_dkoperators(l,opstring2,operators)
            if ( (operleng(k).eq.operleng(l)) .and.
     *               (oporder(k,3).eq.oporder(l,3)) .and.
     *               opstring1(1:operleng(k)).eq.
     *               opstring2(1:operleng(l)) ) then
#else
            if ( (operleng(k).eq.operleng(l)) .and.
     *               (oporder(k,3).eq.oporder(l,3)) .and.
     *               operators(k)(1:operleng(k)).eq.
     *                   operators(l)(1:operleng(l)) ) then
#endif
              doperators(k)=doperators(k)+doperators(l)
              do 40 m=l,opcounter
                operleng(m)=operleng(m+1)
                oporder(m,1)=oporder(m+1,1)
                oporder(m,2)=oporder(m+1,2)
                oporder(m,3)=oporder(m+1,3)
                evenodd(m)=evenodd(m+1)
                doperators(m)=doperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
                call copy_dkoperators(m+1,operators,m,operators)
#else
                operators(m)=operators(m+1)
#endif
  40          continue
              opcounter=opcounter-1
              ordercounter(j)=ordercounter(j)-1
              if (abs(doperators(k)).lt.dkhzero) then
                do 50 m=k,opcounter
                  operleng(m)=operleng(m+1)
                  oporder(m,1)=oporder(m+1,1)
                  oporder(m,2)=oporder(m+1,2)
                  oporder(m,3)=oporder(m+1,3)
                  evenodd(m)=evenodd(m+1)
                  doperators(m)=doperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
                call copy_dkoperators(m+1,operators,m,operators)
#else
                  operators(m)=operators(m+1)
#endif
  50            continue
                opcounter=opcounter-1
                ordercounter(j)=ordercounter(j)-1
              endif
              goto 240
            endif
  30      continue
  20    continue
        ilow=ilow+ordercounter(j)
  10  continue
c
      if (dynthrsh.ne.0 .and. dynthrsh.ne.1) then
        write (stdout,2045) dynthrsh
2045    format (/2X,'ERROR in SR simplify3: Parameter dynthrsh = ',I2,
     *          ' has illegal value!',//2X,'dynthrsh has to be 0 or 1.',
     *          //2X,'STOP.',/2X)
        Call Abend
      endif
      if (dynthrsh.eq.0) then
c
 440    continue
        ilow=1
        do 110 j=0,dkhorder
          do 120 k=ilow,ilow+ordercounter(j)-1
            if (abs(doperators(k)).lt.dkhzero) then
              do 130 m=k,opcounter-1
                operleng(m)=operleng(m+1)
                oporder(m,1)=oporder(m+1,1)
                oporder(m,2)=oporder(m+1,2)
                oporder(m,3)=oporder(m+1,3)
                evenodd(m)=evenodd(m+1)
                doperators(m)=doperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
                call copy_dkoperators(m+1,operators,m,operators)
#else
                operators(m)=operators(m+1)
#endif
 130          continue
              opcounter=opcounter-1
              ordercounter(j)=ordercounter(j)-1
              goto 440
            endif
 120      continue
          ilow=ilow+ordercounter(j)
 110    continue
c
      endif
c
      if (dynthrsh.eq.1) then
c
 540    continue
        ilow=1
        do 210 j=0,dkhorder
          do 220 k=ilow,ilow+ordercounter(j)-1
            if (abs(doperators(k)).lt.dkhzerothrsh(j)) then
              do 230 m=k,opcounter-1
                operleng(m)=operleng(m+1)
                oporder(m,1)=oporder(m+1,1)
                oporder(m,2)=oporder(m+1,2)
                oporder(m,3)=oporder(m+1,3)
                evenodd(m)=evenodd(m+1)
                doperators(m)=doperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
                call copy_dkoperators(m+1,operators,m,operators)
#else
                operators(m)=operators(m+1)
#endif
 230          continue
              opcounter=opcounter-1
              ordercounter(j)=ordercounter(j)-1
              goto 540
            endif
 220      continue
          ilow=ilow+ordercounter(j)
 210    continue
c
      endif
c
      if (.not.dkhscfflg) then
c
 640    continue
        ilow=1
        do 310 j=0,dkhorder
          do 320 k=ilow,ilow+xordercounter(j)-1
#if defined(_MOLCAS_) || defined(MOLPRO)
            call get_dkoperators(k,xopstring1,xoperators)
#endif
            do 330 l=k+1,ilow+xordercounter(j)-1
#if defined(_MOLCAS_) || defined(MOLPRO)
            call get_dkoperators(l,xopstring2,xoperators)
            if ( (xoperleng(k).eq.xoperleng(l)) .and.
     *               (xoporder(k).eq.xoporder(l)) .and.
     *               xopstring1(1:xoperleng(k)).eq.
     *               xopstring2(1:xoperleng(l)) ) then
#else
            if ( (xoperleng(k).eq.xoperleng(l)) .and.
     *               (xoporder(k).eq.xoporder(l)) .and.
     *               xoperators(k)(1:xoperleng(k)).eq.
     *                   xoperators(l)(1:xoperleng(l)) ) then
#endif
                xdoperators(k)=xdoperators(k)+xdoperators(l)
                do 340 m=l,xopcounter
                  xoperleng(m)=xoperleng(m+1)
                  xoporder(m)=xoporder(m+1)
                  xevenodd(m)=xevenodd(m+1)
                  xdoperators(m)=xdoperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
                  call copy_dkoperators(m+1,xoperators,m,xoperators)
#else
                  xoperators(m)=xoperators(m+1)
#endif
 340            continue
                xopcounter=xopcounter-1
                xordercounter(j)=xordercounter(j)-1
                if (abs(xdoperators(k)).lt.dkhzero) then
                  do 350 m=k,xopcounter
                    xoperleng(m)=xoperleng(m+1)
                    xoporder(m)=xoporder(m+1)
                    xevenodd(m)=xevenodd(m+1)
                    xdoperators(m)=xdoperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
                    call copy_dkoperators(m+1,xoperators,m,xoperators)
#else
                    xoperators(m)=xoperators(m+1)
#endif
 350              continue
                  xopcounter=xopcounter-1
                  xordercounter(j)=xordercounter(j)-1
                endif
                goto 640
              endif
 330        continue
 320      continue
          ilow=ilow+xordercounter(j)
 310    continue
c
        if (dynthrsh.eq.0) then
c
 740      continue
          ilow=1
          do 810 j=0,dkhorder
            do 820 k=ilow,ilow+xordercounter(j)-1
              if (abs(xdoperators(k)).lt.dkhzero) then
                do 830 m=k,xopcounter-1
                  xoperleng(m)=xoperleng(m+1)
                  xoporder(m)=xoporder(m+1)
                  xevenodd(m)=xevenodd(m+1)
                  xdoperators(m)=xdoperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
                  call copy_dkoperators(m+1,xoperators,m,xoperators)
#else
                  xoperators(m)=xoperators(m+1)
#endif
 830            continue
                xopcounter=xopcounter-1
                xordercounter(j)=xordercounter(j)-1
                goto 740
              endif
 820        continue
            ilow=ilow+xordercounter(j)
 810      continue
        endif
c
        if (dynthrsh.eq.1) then
c
 940      continue
          ilow=1
          do 910 j=0,dkhorder
            do 920 k=ilow,ilow+xordercounter(j)-1
              if (abs(xdoperators(k)).lt.dkhzerothrsh(j)) then
                do 930 m=k,xopcounter-1
                  xoperleng(m)=xoperleng(m+1)
                  xoporder(m)=xoporder(m+1)
                  xevenodd(m)=xevenodd(m+1)
                  xdoperators(m)=xdoperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
                  call copy_dkoperators(m+1,xoperators,m,xoperators)
#else
                  xoperators(m)=xoperators(m+1)
#endif
 930            continue
                xopcounter=xopcounter-1
                xordercounter(j)=xordercounter(j)-1
                goto 940
              endif
 920        continue
            ilow=ilow+xordercounter(j)
 910      continue
        endif
c
      endif
c
CMR      if (i.le.9) then
CMR        write (stdout,3197) i,i,opcounter
CMR3197    format (2X,'Number of operators after exploitation of ',
CMR     *          'commutator',/3X,'symmetry [W',I1,',E0] = -O',I1,
CMR     *          '  and combination of equal terms:',4X,I8)
CMR        if (.not.dkhscfflg) write (stdout,3198) xopcounter
CMR3198    format (2X,'Number of xoperators after combination of equal ',
CMR     *          'terms:',6X,I8)
CMR      endif
CMR      if (i.ge.10) then
CMR        write (stdout,3199) i,i,opcounter
CMR3199    format (2X,'Number of operators after exploitation of ',
CMR     *          'commutator',/3X,'symmetry [W',I2,',E0] = -O',I2,
CMR     *          '  and combination of equal terms:',2X,I8)
CMR        if (.not.dkhscfflg) write (stdout,3200) xopcounter
CMR3200    format (2X,'Number of xoperators after combination of equal ',
CMR     *          'terms:',6X,I8)
CMR      endif
c
      if (dbgflg.ge.1 .and. dkhscfflg) write (dbgunit,4036)
4036  format (/2X,'Terms occurring more than once have been summarized',
     *        ' for operators (SR "simplify3").')
      if (dbgflg.ge.1 .and. .not.dkhscfflg) write (dbgunit,4037)
4037  format (/2X,'Terms occurring more than once have been summarized',
     *        ' for operators and xoperators (SR "simplify3").')
c
      if (dbgflg.ge.2) then
        if (i.le.9) then
          write (dbgunit,5123) i+1,i,i
5123      format (/2X,'Terms of Hamiltonian H',I1,' = [U',I1,' * ',
     *            '(operators) * U',I1,'^t]:',/2X,52('-'))
          call output3 (dbgunit,opcounter,operleng,oporder,evenodd,
     *                  doperators,operators)
          if (.not.dkhscfflg) then
            write (dbgunit,5124) i+1,i,i
5124        format (/2X,'Terms of property X',I1,' = [U',I1,' * ',
     *              '(xoperators) * U',I1,'^t]:',/2X,50('-'))
            call output3b (dbgunit,xopcounter,xoperleng,xoporder,
     *                     xevenodd,xdoperators,xoperators)
          endif
        endif
c
        if (i.ge.10) then
          write (dbgunit,5125) i+1,i,i
5125      format (/2X,'Terms of Hamiltonian H',I2,' = [U',I2,' * ',
     *            '(operators) * U',I2,'^t]:',/2X,55('-'))
          call output3 (dbgunit,opcounter,operleng,oporder,evenodd,
     *                  doperators,operators)
          if (.not.dkhscfflg) then
            write (dbgunit,5126) i+1,i,i
5126        format (/2X,'Terms of property X',I2,' = [U',I2,' * ',
     *              '(xoperators) * U',I2,'^t]:',/2X,53('-'))
            call output3 (dbgunit,xopcounter,xoperleng,xoporder,
     *                    xevenodd,xdoperators,xoperators)
          endif
        endif
      endif
c
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(uniorder)
        call Unused_integer(xorder)
        call Unused_integer_array(wordercounter)
        call Unused_integer_array(wopsleng)
        call Unused_integer_array(woporder)
        call Unused_integer_array(eowops)
        call Unused_real_array(dwops)
        call Unused_character(wops)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_T_worker

   USE fmm_global_paras

   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_get_SPLTSQ_T_matrix,   &
             fmm_get_FLTSQ_T_matrix,    &
             fmm_get_boundary_T_matrix, &
             fmm_contract_Tq,           &
             fmm_postfac_Vff,           &
             fmm_scale_vec

CONTAINS

!------------------------------------------------------------------------------
! Get sparse (l+j <= LMAX), lower-triangular, square-based T-matrix
!FIXME: would be nice to allow possibility of building rectangular-based too

   SUBROUTINE fmm_get_SPLTSQ_T_matrix(LMAX,r_ab,T_matrix)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: r_ab(3)
      REAL(REALK),   INTENT(OUT) :: T_matrix(:,:)

      REAL(REALK) :: I_sh((1+LMAX)**2)

      CALL fmm_generate_I(LMAX,r_ab,I_sh)
      CALL fmm_generate_T(LMAX,fmm_SPLTSQ_JMAX,I_sh,T_matrix)

   END SUBROUTINE fmm_get_SPLTSQ_T_matrix

   FUNCTION fmm_SPLTSQ_JMAX(L,LMAX)
      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: L, LMAX
      INTEGER(INTK) :: fmm_SPLTSQ_JMAX
      fmm_SPLTSQ_JMAX = LMAX-L
   END FUNCTION fmm_SPLTSQ_JMAX

!------------------------------------------------------------------------------
! Get full (all elements built), lower-triangular, square T-matrix

   SUBROUTINE fmm_get_FLTSQ_T_matrix(LMAX,r_ab,T_matrix)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: r_ab(3)
      REAL(REALK),   INTENT(OUT) :: T_matrix(:,:)

      REAL(REALK) :: I_sh((1+2*LMAX)**2)

      CALL fmm_generate_I(2_INTK*LMAX,r_ab,I_sh)
      CALL fmm_generate_T(LMAX,fmm_FLTSQ_JMAX,I_sh,T_matrix)

   END SUBROUTINE fmm_get_FLTSQ_T_matrix

   FUNCTION fmm_FLTSQ_JMAX(l,LMAX)
      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: l, LMAX
      INTEGER(INTK) :: fmm_FLTSQ_JMAX
      fmm_FLTSQ_JMAX = LMAX
! Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(l)
   END FUNCTION fmm_FLTSQ_JMAX

!------------------------------------------------------------------------------
! Get single-column T-matrix for building boundary potential only

   SUBROUTINE fmm_get_boundary_T_matrix(LMAX,r_ab,T_matrix)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: r_ab(3)
      REAL(REALK),   INTENT(OUT) :: T_matrix(:,:)

      REAL(REALK) :: I_sh((1+2*LMAX)**2)

      CALL fmm_generate_I(2_INTK*LMAX,r_ab,I_sh)
      CALL fmm_generate_boundary_T(LMAX,I_sh,T_matrix)

   END SUBROUTINE fmm_get_boundary_T_matrix

!------------------------------------------------------------------------------

   SUBROUTINE fmm_generate_I(LMAX,vector,I_sh)

      ! Subroutine to generate Scaled Irregular solid harmonics
      ! See page 416, "Molecular Electronic Structure Theory".
      !--------------------------------------------------------
      ! I_sh(M,L)  == COS component of I_sh(M,L)
      ! I_sh(-M,L) == SIN component of I_sh(-M,L)
      ! where L and M are positive
      ! Note that I_sh(0,L) == COS component of I_sh(0,L) !
      ! In fact we combine (l,m) into a single index and
      ! we assume the order 0, -1,1,+1, -2,-1,0,+1,+2 ...
      !--------------------------------------------------------

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: vector(3)
      REAL(REALK),   INTENT(OUT) :: I_sh((LMAX+1)**2)

      REAL(REALK)   :: tmp1, tmp2, tmp3
      REAL(REALK)   :: x,y,z, r_2, r_minus2
      INTEGER(INTK) :: L,m, i,j,k,p,q,u, sign_L

      x = vector(1)
      y = vector(2)
      z = vector(3)
      r_2 = x**2 + y**2 + z**2
      r_minus2 = one/(r_2)

!FIXME;
      IF (r_2 < ZERO_VECT_TOL) THEN
         WRITE(6,'(3E25.15)') vector
         CALL fmm_quit('Why do we try to do a zero T_vector?')
      END IF

      IF (LMAX==0) THEN
         I_sh(1) = SQRT(r_minus2)
         RETURN
      END IF

      ! Start with initialization of lowest order terms
        I_sh(1) =  SQRT(r_minus2)
        I_sh(2) = -(y)*(r_minus2)*I_sh(1)
        I_sh(3) =  (z)*(r_minus2)*I_sh(1)
        I_sh(4) = -(x)*(r_minus2)*I_sh(1)

      ! Now iterate higher order terms
      sign_L = -1
      DO L = 2, LMAX
         sign_L = -sign_L
         i = (L+1)*(L+1)
         j = L*L+1
         p = j-2*L+1
         q = j-1
         tmp1 = (2*L-1)*r_minus2
         tmp2 = tmp1*y*sign_L
         tmp3 = tmp1*x
         !
         I_sh(i) = tmp2*I_sh(p) - tmp3*I_sh(q)
         I_sh(j) = tmp2*I_sh(q) + tmp3*I_sh(p)
         !
         p = p+L-1
         q = L*(L-3)+3
         u = q+L-2
         k = i-L
         tmp2 = tmp1*z
         DO m = 0, (L-2)
            tmp3 = (u-m*m)*(r_minus2)
            !
            I_sh(k+m) = tmp2*I_sh(p+m) - tmp3*I_sh(q+m)
            I_sh(k-m) = tmp2*I_sh(p-m) - tmp3*I_sh(q-m)
            ! I_sh(L,0)=0
            !
         END DO
         ! Now do (L, L-1) terms to avoid calling elements that do not exist
         m = L-1
         I_sh(k+m) = tmp2*I_sh(p+m)
         I_sh(k-m) = tmp2*I_sh(p-m)
      END DO

   END SUBROUTINE fmm_generate_I

!------------------------------------------------------------------------------

   SUBROUTINE fmm_generate_T(LMAX,JMAX,I_sh,T_matrix)

   ! Subroutine to generate Real Interaction Matrix for
   ! given point from Irregular Solid Harmonics (I_sh)
   ! cf Helgaker et. al. pp 415
   !-----------------------------------------------------------------------
   !  T_cos_cos(lm,jk) = 2*{I_cos(l+j,m+k) + (-1)^k*I_cos(l+j,m-k)}  etc.
   !
   ! Note we only write the non-zero elements here, and the precise form
   ! depends on the function JMAX passed in
   !-----------------------------------------------------------------------
   !FIXME: can optimise for j=l by noting that if we build just lower
   ! triangular, we need only half the elements there

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: I_sh(:)
      REAL(REALK),   INTENT(OUT) :: T_matrix(:,:)
      INTEGER(INTK), EXTERNAL    :: JMAX

      INTEGER(INTK) :: sign_k, sign_m
      INTEGER(INTK) :: L,J,k,m, q, pp,qq, u

      IF (LMAX==0) THEN
         T_matrix(1,1) = two*I_sh(1)     ! NB scaling to make T symmetric
         RETURN
      END IF

      L_loop: DO L = 0, LMAX
         qq = L*(L+1) +1
         J_loop: DO J = L, JMAX(L,LMAX)
            pp = J*(J+1) +1
            u = 1+(L+J)*(L+J+1)

            sign_m = -1
            positive_m: DO m = 0, L
               q = qq+m
               sign_m = -sign_m

               ! cos-cos terms
               !---------------

               sign_k = -1
               DO k = 0, MIN(m,J)
                  sign_k = -sign_k
                  ! (m+k)>0 and (m-k)>0
                  T_matrix(pp+k,q) = I_sh(u+(m+k)) + sign_k*I_sh(u+(m-k))
               END DO

               DO k = (m+1), J
                  ! (m+k)>0 and (m-k)<0
                  T_matrix(pp+k,q) = I_sh(u+(m+k)) + sign_m*I_sh(u+(-(m-k)))
               END DO

               ! cos-sin terms
               !---------------

               ! only need to consider (m+k)=0 separately as cannot
               ! also have (m-k)=0 unless k=0

               DO k = (-J), MIN((-m-1),-1)
                  ! (m+k)<0 and (m-k)>0
                  T_matrix(pp+k,q) = I_sh(u+(m+k)) + sign_m*I_sh(u+(-(m-k)))
               END DO

               DO k = MAX(-J,-m), MIN(-m,-1)
                  ! (m+k)=0 and (m-k)>0
                  T_matrix(pp+k,q) = sign_m*I_sh(u+(-(m-k)))
               END DO

               sign_k = 1
               DO k = -1, MAX((-m+1),(-J)), -1
                  sign_k = -sign_k
                  ! (m+k)>0 and (m-k)>0
                  T_matrix(pp+k,q) = -sign_m*sign_k*I_sh(u+(-(m+k)))         &
                                     +sign_m*I_sh(u+(-(m-k)))
               END DO

            END DO  positive_m

            sign_m = 1
            negative_m: DO m = -1, -L, -1
               q = qq+m
               sign_m = -sign_m

               ! sin-cos terms
               !---------------

               k = MIN(J,(-m))
               sign_k = 1
               IF (BTEST(k,0)) sign_k = -1
               ! (m+k)=0 and (m-k)<0
               T_matrix(pp+k,q) = sign_k*I_sh(u+(m-k))

               sign_k = -1
               DO k = 0, MIN((-m-1),J)
                  sign_k = -sign_k
                  ! (m+k)<0 and (m-k)<0
                 T_matrix(pp+k,q) = I_sh(u+(m+k)) + sign_k*I_sh(u+(m-k))
               END DO

               sign_k = -1
               IF (BTEST(J,0)) sign_k = 1
               DO k = J, (-m+1), -1
                  sign_k = -sign_k
                  ! (m+k)>0 and (m-k)<0
                  T_matrix(pp+k,q) = -sign_m*sign_k*I_sh(u+(-(m+k)))         &
                                     +sign_k*I_sh(u+(m-k))
               END DO

               ! sin-sin terms
               !---------------

               sign_k = -1
               IF (BTEST(J,0)) sign_k = 1
               DO k = (-J), m
                  sign_k = -sign_k
                  ! (m+k)<0 and (m-k)>0
                  T_matrix(pp+k,q) = -sign_m*sign_k*I_sh(u+(-(m+k)))         &
                                     +sign_k*I_sh(u+(m-k))
               END DO

               sign_k = 1
               DO k = -1, MAX((-J),(m+1)), -1
                  sign_k = -sign_k
                  ! (m+k)<0 and (m-k)<0
                  T_matrix(pp+k,q) = -sign_m*sign_k*I_sh(u+(-(m+k)))         &
                                     +sign_m*I_sh(u+(-(m-k)))
               END DO

            END DO  negative_m
         END DO     J_loop
      END DO        L_loop

   END SUBROUTINE fmm_generate_T

!------------------------------------------------------------------------------

   SUBROUTINE fmm_generate_boundary_T(LMAX,I_sh,T_matrix)

!FIXME comments!
! This is a simplified version of fmm_generate_T_matrix when building
! only the boundary potential, when only one column of the T_matrix
! is required.

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: I_sh(:)
      REAL(REALK),   INTENT(OUT) :: T_matrix(:,:)

      INTEGER(INTK) :: J,k, pp, u

      IF (LMAX==0) THEN
         T_matrix(1,1) = two*I_sh(1)     ! NB scaling to make T symmetric
         RETURN
      END IF

      DO J = 0, LMAX
         pp = J*(J+1) +1
         u = 1+(J)*(J+1)
         DO k = -J, J
            T_matrix(pp+k,1) = two*I_sh(u+k)
         END DO
      END DO

   END SUBROUTINE fmm_generate_boundary_T

!------------------------------------------------------------------------------

   FUNCTION fmm_contract_Tq(LMAX,vect,T_matrix)

     IMPLICIT NONE
     INTEGER(INTK), INTENT(IN) :: LMAX
     REAL(REALK),   INTENT(IN) :: vect(:)
     REAL(REALK),   INTENT(IN) :: T_matrix(:,:)
     REAL(REALK) :: fmm_contract_Tq(SIZE(vect))

     INTEGER(INTK) :: L, p,q,s, u, qmin,qmax

     ! do L=0 terms first
     p = (LMAX+1)*(LMAX+1)
     fmm_contract_Tq(1) = half*DOT_PRODUCT(vect(1:p),T_matrix(1:p,1))
     DO s = 2, p
        fmm_contract_Tq(s) = vect(1)*T_matrix(s,1)
     END DO

     contract: DO L = 1, LMAX

        u = L*(L+1) +1
        p = (LMAX-L+1)*(LMAX-L+1)

        qmin = u-L
        qmax = MIN( u+L, p )

        qloop: DO q = qmin, qmax
           fmm_contract_Tq(q) = fmm_contract_Tq(q)           &
                               + DOT_PRODUCT(vect(q:p),T_matrix(q:p,q))
           DO s = q+1, p
              fmm_contract_Tq(s) = fmm_contract_Tq(s) + T_matrix(s,q)*vect(q)
           END DO
        END DO qloop

        ! add on extra post-factors "after" contraction
        fmm_contract_Tq(u) = half*fmm_contract_Tq(u)    ! m=0

     END DO contract

   END FUNCTION fmm_contract_Tq

!------------------------------------------------------------------------------

   SUBROUTINE fmm_scale_vec(LMAX,scl_fact,scale_vec,prefactor)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: scl_fact
      REAL(REALK),   INTENT(OUT) :: scale_vec(:), prefactor

      INTEGER(INTK) :: L,L2, lo,hi, u
      REAL(REALK)   :: prefactor1, prevec

      prefactor1 = one/scl_fact

      prevec       = one
      scale_vec(1) = prevec
      DO L = 1, LMAX
         prevec = prefactor1*prevec
         L2 = L*L
         lo = L2+1
         hi = L2+2*L+1
         DO u = lo, hi
            scale_vec(u) = prevec
         END DO
      END DO

      IF (scl_fact < zero) THEN
         prefactor = -prefactor1
      ELSE
         prefactor =  prefactor1
      END IF

   END SUBROUTINE fmm_scale_vec

!------------------------------------------------------------------------------

   SUBROUTINE fmm_postfac_Vff(LMAX,Vff_tmp)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)    :: LMAX
      REAL(REALK),   INTENT(INOUT) :: Vff_tmp(:)

      INTEGER(INTK) :: l, u
      ! add extra postfactors  (for half**(delta(0,m))
      DO l = 0, LMAX
         u = l*(l+1) +1
         Vff_tmp(u) = half*Vff_tmp(u)
      END DO

   END SUBROUTINE fmm_postfac_Vff

!------------------------------------------------------------------------------

END MODULE fmm_T_worker

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GTSTTPS_2(IEL1,IEL3,NEL1,NEL3,ITYP)
! ITYP : type of strings with IEL1,IEL3 electrons
!
! ITYP known, find IEL1, IEL3

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(out) :: IEL1, IEL3
integer(kind=iwp), intent(in) :: NEL1(*), NEL3(*), ITYP

IEL1 = NEL1(ITYP)
IEL3 = NEL3(ITYP)

#ifdef _DEBUGPRINT_
write(u6,'(A,5I4)') ' GTSTTPS : IEL1 IEL3 ITYP ',IEL1,IEL3,ITYP
#endif

end subroutine GTSTTPS_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Freqanal(nDeg,nrvec,H,converged,
     &                    ELEC,iel,elout,ldisp,Lu_10)
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "stdalloc.fh"
      Logical converged(8)
      Real*8 H(*),elec(*),elout(*)
      logical Do_Molden
      Integer nrvec(*),nDeg(*),iel(3),ldisp(nsym)
      Real*8, Allocatable:: NMod(:), EVec(:), EVal(:), Intens(:),
     &                      RedMas(:), Tmp3(:), Temp(:)
#include "temperatures.fh"
*
      Call mma_allocate(NMod,nDisp**2,Label='NMod')
      Call mma_allocate(EVec,2*nDisp**2,Label='EVec')
      Call mma_allocate(EVal,nDisp*2,Label='EVal')
      Call mma_allocate(Intens,nDisp*2,Label='Intens')
      Call mma_allocate(RedMas,nDisp,Label='RedMas')
      ipNx=1
      nModes=0
      lModes=0
*
      Write (6,*)
      Write (6,*) '     ************************************'
      Write (6,*) '     *                                  *'
      Write (6,*) '     * Harmonic frequencies in cm-1     *'
      Write (6,*) '     * Intensities in km/mole           *'
      Write (6,*) '     *                                  *'
      Write (6,*) '     * No correction due to curvilinear *'
      write (6,*) '     * representations has been done    *'
      Write (6,*) '     *                                  *'
      Write (6,*) '     ************************************'
      Write (6,*)
      i1=1
      i3=1
      j=0
      ii=1
      Write(Lu_10,'(A)') '*PERTURBATIONS'
      Write(Lu_10,*) ldisp
      Write(Lu_10,'(A)') '*BEGIN NORMAL MODES'
      Write(Lu_10,'(A)') '*NOTICE THAT THEY ARE SYMMETRY ADAPTED'
      Write(Lu_10,'(A)') '*USING ORTHOGONAL TRANSFORMATIONS '
      WRITE(Lu_10,'(A)') '*AND NOT ALASKA TYPE'
*

!*    !> open normal mode file for "normal mode molpac" ! yma
      lnm_molpac=60
      lnm_molpac=isFreeUnit(lnm_molpac)
      Call Molcas_Open(lnm_molpac,'normal_modes_molpac')


      Do_Molden=.True.
      Do iSym=1,nSym
         nX=ldisp(isym)
         If (nX.ne.0) Then
            Write(6,*)
            Write(6,*) '   Symmetry ',chirr(isym)
            Write(6,*) '  =============='
            Write(6,*)
*
            If (converged(isym))  Then
               Call mma_allocate(Tmp3,nX**2,Label='Tmp3')
               Call FREQ(nX,H(i3),nDeg(i1),nrvec(i1),
     &                   Tmp3,EVec,EVal(i1),RedMas,iNeg)
               Call mma_deallocate(Tmp3)
*
               iCtl=0
               ll=0
               kk=j+1
               Do i=1,3
                  If (iel(i).eq.isym) Then
                     iCtl=1
                     ll=ll+1
                     Do k=1,nx
                        j=j+1
                        tmp=0.0d0
                        Do it=0,nx-1
                           Fact=Sqrt( DBLE(nDeg(i1+it)) )
                           tmp=tmp+EVec(1+2*(k-1)*nx+2*it)*
     &                             elec(ii+it)*Fact
                        End Do
                        elout(j)=tmp
                     End Do
                     ii=ii+nx
                  End If
               End Do
               Write(Lu_10,'(A,I1)') '*NORMAL MODES SYMMETRY: ',isym
*
*------------- Save normal modes for later generation of Molden input.
*
               call dcopy_(nX**2,EVec,2,NMod(ipNx),1)
               jpNx=ipNx

* =========================================================================
*                mass-weighted normal mode print out
* =========================================================================
               Call NM_MOPAC_print(EVal(i1),EVec,
     &              elout(kk),ll,nX,nX,iCtl,Intens(i1),Lu_10,
     &              i1-1,lnm_molpac)
* =========================================================================

               Do iX = 1, nX
*
*                 Transform from mass-weighted cartesian to cartesian for
*                 Molden.
*
                  rNorm=0.0D0
                  Do jX = 0, nX-1
                     Fact=Sqrt(DBLE(nDeg(jX+1)))
                     NMod(ipNx+jX) = NMod(ipNx+jX)/Fact
                     rNorm=rNorm+DBLE(nDeg(jX+1))*NMod(ipNx+jX)**2
                  End Do
                  Call DScal_(nX,1.0D0/Sqrt(rNorm),NMod(ipNx),1)
*
                  ipNx=ipNx+nX
                  lModes=lModes+nX
               End Do
               nModes=nModes+nX
               call dcopy_(nX**2,NMod(jpNx),1,EVec,2)
               Call GF_Print(EVal(i1),EVec,elout(kk),
     &                       ll,nX,nX,iCtl,Intens(i1),
     &                       RedMas,Lu_10,i1-1)
            Else
               Write(6,*)
               Write (6,*)'     NOT CONVERGED'
               Write(6,*)
               Do i=1,3
                  If (iel(i).eq.isym) Then
                     j=j+1
                     ii=ii+nx
                     elout(j)=-99999999D0
                  End If
               End Do
               Do_Molden=.False.
            End If
         End If
         i3=i3+nx*(nx+1)/2
         i1=i1+nx
      End Do
      nEig = i1 - 1
*
!*     !> close the normal mode file
       close(lnm_molpac) ! This is for normal_modes_molpac -- yma
!      call NM_MOPAC_SNF(nsym,ldisp,natoms) ! f90 not support ....

      If (nsym.eq.1) Then
         Call Print_Mode_Components(NMod,EVal,
     &                              nModes,lModes,lDisp)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(Temp,nEig,Label='Temp')
      call dcopy_(nEig,Eval,1,Temp,1)
*
*     For verification purpose we skip frequencies close to zero.
*
      Do i = 1, nEig
         If (Abs(Temp(i)).lt.5.0D0) Temp(i)=0.0D0
      End Do
      Call Add_Info('Harm_Freq',Temp,nEig,1)
      Call mma_deallocate(Temp)
*
      Do i = 1, nEig
         If (Abs(Intens(i)).lt.1.0D0) Intens(i)=0.0D0
      End Do
      Call Add_Info('IR_Intensities',Intens,nEig,1)
*                                                                      *
************************************************************************
*                                                                      *
      Write(Lu_10,'(A)') '*END NORMAL MODES'
*
*------------- Calculate thermodynamic properties----------
*
      If (nUserPT.eq.0 .and. nsRot.eq.0) then
        UserP=1.0d0
        nUserPT=NDefTemp
        Do i=1,NDefTemp
          UserT(i)=DefTemp(i)
        End Do
*       Call ThermoData(EVal,nEig)
      EndIf
      Call Thermo_Driver(UserT,UserP,nUserPT,nsRot,EVal,nEig,.False.)
*
*
*---- Write stuff on Molden input file
*
      If (Do_Molden)
     &   Call Freq_Molden(EVal,nModes,NMod,lModes,nSym,
     &                    Intens,lDisp,RedMas)
*
      Call mma_deallocate(NMod)
      Call mma_deallocate(evec)
      Call mma_deallocate(eval)
      Call mma_deallocate(intens)
      Call mma_deallocate(redmas)
*
      Return
      End

!      Subroutine NM_MOPAC_SNF(nsym,ldisp,nAtom)
! These used be a f90 file.. (now deleted dut to not work) -- yingjin
!
!        integer :: nsym, nAtom
!        integer :: ldisp(nsym)
!
!        write(*,*)nsym,natom
!        write(*,*)(ldisp(i),i=1,nsym)
!
!      end subroutine NM_MOPAC_SNF

*     Print normal modes in MOPAC format with symm -- yingjin
*     Only for ground state (no imaginary freqs)
      Subroutine NM_MOPAC_print(EVal,EVec,dDipM,iel,nX,nDim,ictl,IRInt,
     &                          Lu_10,iOff,lut)

      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "constants2.fh"
      Real*8 EVal(nDim), EVec(2,nX,nDim),dDipM(ndim,iel),IRInt(nDim)
      Parameter(Inc=6)
      Character*80 Format
      Character*(LENIN6) ChDisp(3*MxAtom),Label
      character*(10) char_num
      character charx

*
*      LUt=lnm_molpac
*
      Call Get_iScalar('nChDisp',nChDisp)
      If (nChDisp.lt.nX) Then
         Write(LUt,*) 'nm_MOPAC_Print: nChDisp.lt.nX!'
         Call Abend()
      End If
      Call Get_cArray('ChDisp',ChDisp,(LENIN6)*nChDisp)
*
      !> omit the eigenvalues which less than 5 cm^-1 (abs) -- yma
      idiscard=0
      imaginary=0
      Do iHarm = 1, Inc
*         write(*,*)"Eval(",iHarm,") = ",Eval(iHarm) ! for checking
         if(abs(Eval(iHarm)).lt.5.0)then
           idiscard=idiscard+1
         else if((Eval(iHarm)).lt.-5.0)then
           imaginary=imaginary+1
         end if
      end do

      write(LUt,*)
      write(LUt,*)
     &" Frequencies and mass-weighted normal coordinates " ! yma
      write(LUt,*)
     &" ================================================ "
      write(LUt,*)
      write(LUt,*)
     &"          eigenvalues  in  cm^-1                  "
      write(LUt,*)

      Do iHarm = 1+idiscard, nDim, Inc
         Jnc=Min(Inc,nDim-iHarm+1)
         Label='ROOT NO.: '
         Write(Format,'(A,I3,A)') '(1X,A10,',Jnc,'(I10))'
         Write (LUt,Format) Label,(i-idiscard,i=iHarm,iHarm+Jnc-1)
         Label='EIGVAL. : '
         Write(Format,'(A,I3,A)') '(1X,A10,2X,',Jnc,'(f10.3))'
         Write (LUt,Format) Label,(EVal(i),i=iHarm,iHarm+Jnc-1)
      Write (LUt,*)
      end do
      Write (LUt,*)
      Write (LUt,*)
      Write (LUt,*)

      char_num="0123456789"
      iIRInt=0
      Do iHarm = 1+idiscard, nDim, Inc
           Jnc=Min(Inc,nDim-iHarm+1)
           Label='root no.'
           Write(Format,'(A,I3,A)') '(4X,A8,',Jnc,'(I5,7X))'

           Write (LUt,Format) Label,(i-idiscard,i=iHarm,iHarm+Jnc-1)
           Write (LUt,*)
*
           Write(Format,'(A,I3,A)') '(8x,',Jnc,'F12.5)'
           Write (LUt,Format) (EVal(i),i=iHarm,iHarm+Jnc-1)
           Write (LUt,*)

           If (ictl.ne.0) Then
           Else
              Do i=1,Jnc
                 iIRInt=iIRInt+1
                 IRInt(iIRInt)=Zero
              enddo
           End if
*
           Do iInt = 1, nX
              inum_min=99
              inum_max=0
              do i=1,10
                charx=char_num(i:i)
                inum1=index(ChDisp(iInt+iOff)(1:LENIN6),charx)
                inum2=index(ChDisp(iInt+iOff)(1:LENIN6),charx,.true.)
                if(inum_min.gt.inum1.and.inum1.ne.0)inum_min=inum1
                if(inum_max.lt.inum2)inum_max=inum2
              end do
            Write(Format,'(A,I3,A)') '(1X,A,2x,A,A,A,',Jnc,'(F10.5,2x))'

              Write (LUt,Format) ChDisp(iInt+iOff)(LENIN6:LENIN6),
     &               ChDisp(iInt+iOff)(1:inum_min-1),
     &               ChDisp(iInt+iOff)(inum_max+1:4+inum_min),
     &               ChDisp(iInt+iOff)(inum_min:inum_max),
     &               (EVec(1,iInt,i),
     &               i=iHarm,iHarm+Jnc-1)

           End Do
           Write (LUt,*)
           Write (LUt,*)
           Write (LUt,*)
           Write (LUt,*)
           Write (LUt,*)
      End Do
           write(LUt,*)
           write(LUt,*)


      Return

c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(dDipM)
         Call Unused_integer(Lu_10)
      End If
      End Subroutine NM_MOPAC_print

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkT_C78od (T2,Tp,Tm,
     c             dimbe,dimga,dimbepp,dimgapp,addbepp,addgapp,no)
c
c        this routine do:
c       T2n(be',ga',u,v) <<-
c        C7                    T2+(be',ga',uv)
c        C8                    T2-(be',ga',uv)
c        for beSGrp.ne.gaSGrp
c
        implicit none
        integer dimbe,dimga,dimbepp,dimgapp,addbepp,addgapp,no
        real*8 T2(1:dimbe,1:dimga,1:no,1:no)
        real*8 Tp(1:dimbepp,1:dimgapp,1:no*(no+1)/2)
        real*8 Tm(1:dimbepp,1:dimgapp,1:no*(no-1)/2)
c
c        help variables
        integer u,v,be,ga,uvp,uvm,uup,bep,gap
c
c        diagonal part - contributoion from T+ only
        do u=1,no
        uup=u*(u+1)/2
c
c          cycle over be",ga"
          gap=addgapp
          do ga=1,dimgapp
            gap=gap+1
            bep=addbepp
            do be=1,dimbepp
              bep=bep+1
              T2(bep,gap,u,u)=T2(bep,gap,u,u)+Tp(be,ga,uup)
            end do
          end do
c
        end do
c
c
c        off diagonal - both T+,T-
        uvm=0
        do u=2,no
        uvp=u*(u-1)/2
        do v=1,u-1
          uvm=uvm+1
          uvp=uvp+1
c
c          cycle over be",ga"
          gap=addgapp
          do ga=1,dimgapp
            gap=gap+1
            bep=addbepp
            do be=1,dimbepp
              bep=bep+1
              T2(bep,gap,u,v)=T2(bep,gap,u,v)
     c                       +Tp(be,ga,uvp)+Tm(be,ga,uvm)
              T2(bep,gap,v,u)=T2(bep,gap,v,u)
     c                       +Tp(be,ga,uvp)-Tm(be,ga,uvm)
            end do
          end do
c
c          cycle over be",ga"
          gap=addgapp
          do ga=1,dimgapp
            gap=gap+1
            bep=addbepp
            do be=1,dimbepp
              bep=bep+1
c              T2(bep,gap,v,u)=T2(bep,gap,v,u)
c    c                       +Tp(be,ga,uvp)-Tm(be,ga,uvm)
            end do
          end do
c
        end do
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine vW_Ts(mGrid,Rho,nRho,nDmat,F_xc,dF_dRho,
     &                       ndF_dRho,Coeff,T_X)
************************************************************************
*                                                                      *
* Object:  compute Func for von Weizsacker KE functional               *
*          No potential computed!!!                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
*                                                                      *
************************************************************************
*                                                                      *
*
      One8=One/Eight
      Rho_min=T_X*1.0D-2
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute value of energy and integrand on the grid
*                                                                      *
************************************************************************
*                                                                      *
      If (nDmat.eq.1) Then

         Do iGrid = 1, mGrid
            d_sys=Two*Rho(1,iGrid)
            If (d_sys.lt.T_X) Go To 100
*
*------- Kinetic energy contributions
*
            snorm=Rho(2,iGrid)**2+Rho(3,iGrid)**2+Rho(4,iGrid)**2
            functional = Half*snorm/d_sys
            F_xc(iGrid)=F_xc(iGrid)+Coeff*functional
*
*
 100        Continue
*
         End Do
*
      ElseIf (nDmat.eq.2) Then


         Do iGrid = 1, mGrid
            da_sys =Max(Rho_Min,Rho(1,iGrid))
            db_sys =Max(Rho_Min,Rho(2,iGrid))
            DTot=da_sys+db_sys
            If (DTot.lt.T_X) Go To 200
*
*------- Kinetic energy contributions
*
            snorm=Rho(3,iGrid)**2+Rho(4,iGrid)**2+Rho(5,iGrid)**2
            functional = One8*snorm/da_sys
            snorm=Rho(6,iGrid)**2+Rho(7,iGrid)**2+Rho(8,iGrid)**2
            functional = functional + One8*snorm/db_sys
            F_xc(iGrid)=F_xc(iGrid)+Coeff*functional

*
 200        Continue
*
         End Do

      Else
         write(6,*) 'In vW_Ts: invalid # of densities. nDmat=  ',nDmat
         Call Abend()
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(df_dRho)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Roland Lindh                                     *
************************************************************************
      Subroutine Dispersion_Kriging_Layer(qInt,E_Disp,nInter)
      Use Limbo
      Implicit None
#include "stdalloc.fh"
      Integer nInter
      Real*8 qInt(nInter), E_Disp
      Real*8, Allocatable:: qInt_s(:)
*
      Call mma_allocate(qInt_s,nInter,Label='qInt_s')
*
      Call Trans_K(U,qInt,qInt_s,nInter,1)
      Call Dispersion_Kriging(qInt_s,E_Disp,nInter)
*
      Call mma_deallocate(qInt_s)
*
      End Subroutine Dispersion_Kriging_Layer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine real_cvb(arr,nmax,nread,ifc)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use casvb_global, only: inputmode
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nmax, ifc
real(kind=wp), intent(inout) :: arr(nmax)
integer(kind=iwp), intent(inout) :: nread
logical(kind=iwp) :: done

call real_cvb_internal(arr)

return

! This is to allow type punning without an explicit interface
contains

#include "intent.fh"

subroutine real_cvb_internal(arr)
  real(kind=wp), target, intent(_OUT_) :: arr(*)
  integer(kind=iwp), pointer :: iarr(:)
  integer(kind=iwp) :: i, ierr, ifcuse
  if (inputmode == 2) then
    call c_f_pointer(c_loc(arr(1)),iarr,[nread])
    call gethr_cvb(iarr,nread)
    nullify(iarr)
  else
    nread = 0
    if (nmax > 0) then
      ! Treat first field differently
      ifcuse = mod(ifc,4)
      if (ifcuse >= 2) ifcuse = 2
      call popfield_cvb(ifcuse)
      call rdreal_cvb(arr(1),ierr)
      done = .false.
      if (ierr <= 0) then
        nread = nread+1

        ifcuse = mod(ifc,2)
        done = .true.
        do i=2,nmax
          call popfield_cvb(ifcuse)
          call rdreal_cvb(arr(i),ierr)
          if (ierr > 0) then
            done = .false.
            exit
          end if
          nread = nread+1
        end do
      end if
      if (.not. done) then
        ! Crash if invalid field and IFC +4:
        if ((ierr == 4) .and. (ifc >= 4)) then
          write(u6,*) ' Invalid field found while reading real!'
          call abend_cvb()
        end if
        call pushfield_cvb()
      end if
    end if
    if (inputmode == 1) then
      call c_f_pointer(c_loc(arr(1)),iarr,[nread])
      call sethr_cvb(iarr,nread)
      nullify(iarr)
    end if
  end if
end subroutine real_cvb_internal

end subroutine real_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      SubRoutine Dstncs(Lbls,xyz,mCentr,Angstr,Max_Center,iCols)
************************************************************************
*                                                                      *
* Object: to compute distances from a coordinate list                  *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "stdalloc.fh"
#include "Molcas.fh"
      Real*8 xyz(3,mCentr)
      Character*(LENIN) Lbls(mCentr)
      Real*8, Allocatable:: BST(:)
      Integer, Allocatable:: iBST(:,:)
*
      lu=6
      If (mCentr.le.Max_Center) Then
*
         Do i = 1, 2
            Write (Lu,*)
            If (i.eq.1) Then
               Fact = One
               Write (Lu,'(19X,A)')
     &            ' *************************************** '
               Write (Lu,'(19X,A)')
     &            ' *    InterNuclear Distances / Bohr    * '
               Write (Lu,'(19X,A)')
     &            ' *************************************** '
            Else
               Fact = Angstr
               Write (Lu,'(19X,A)')
     &            ' ******************************************* '
               Write (Lu,'(19X,A)')
     &            ' *    InterNuclear Distances / Angstrom    * '
               Write (Lu,'(19X,A)')
     &            ' ******************************************* '
            End If
            Do icc = 1, mCentr, iCols
               Write (Lu,*)
               If (iCols.EQ.6) Write (Lu,'( 9X,6(5X,I2,1X,A,2X))')
     &               (ic,Lbls(ic),ic=icc,Min(icc+5,mCentr))
               If (iCols.EQ.5) Write (Lu,'( 9X,5(5X,I2,1X,A,2X))')
     &               (ic,Lbls(ic),ic=icc,Min(icc+4,mCentr))

               Do jc = icc, mCentr
                  x1 = xyz(1,jc)
                  y1 = xyz(2,jc)
                  z1 = xyz(3,jc)
                  If (iCols.EQ.6) Write (Lu,'(I5,1X,A,1X,6(F10.6,6X))')
     &                  jc,Lbls(jc),
     &                  ( Fact * Sqrt( (xyz(1,ic)-x1)**2 +
     &                                 (xyz(2,ic)-y1)**2 +
     &                                 (xyz(3,ic)-z1)**2 ),
     &                  ic = icc, Min(jc,icc+5,mCentr))
                  If (iCols.EQ.5) Write (Lu,'(I5,1X,A,1X,5(F10.6,6X))')
     &                  jc,Lbls(jc),
     &                  ( Fact * Sqrt( (xyz(1,ic)-x1)**2 +
     &                                 (xyz(2,ic)-y1)**2 +
     &                                 (xyz(3,ic)-z1)**2 ),
     &                  ic = icc, Min(jc,icc+4,mCentr))
              End Do
            End Do
         End Do
         Return
      Else
*
         Write (Lu,*)
         Write (Lu,'(19X,A)')
     &            ' ************************************************* '
         Write (Lu,'(19X,A)')
     &            ' **** InterNuclear Distances / Bohr, Angstrom **** '
         Write (Lu,'(19X,A)')
     &            ' ************************************************* '
         Write (Lu,*)
         Write (Lu,'(A)') '     Atom centers     '//
     &                    '    Bohr        Angstrom'
*
CVV   Set .false. to get faster printing without sorting.
*
         If (.true.) then
            Thr_R=(3.0D0/Angstr)**2
            Thr_D=1D-4
            Call mma_allocate(BST,mCentr**2,Label='BST')
            Call mma_allocate(iBST,2,mCentr**2,Label='iBST')
            iiBST=0
            Do icc = 1, mCentr
               x1 = xyz(1,icc)
               y1 = xyz(2,icc)
               z1 = xyz(3,icc)
               Do jcc = 1, icc-1
                  x2 = xyz(1,jcc)
                  y2 = xyz(2,jcc)
                  z2 = xyz(3,jcc)
                  R = (x2-x1)**2+(y2-y1)**2+(z2-z1)**2
                  If (R.le.Thr_R) then
                     iiBST=iiBST+1
                     BST(iiBST)=R
                     iBST(1,iiBST)=icc
                     iBST(2,iiBST)=jcc
                  End If
               End Do
            End Do
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
            do ii=1,iiBST
                R=sqrt(BST(ii))
                Write (Lu,'(2(I5,1X,A4),2(F10.6,6X))')
     &               iBST(1,ii),Lbls(iBST(1,ii)),
     &               iBST(2,ii),Lbls(iBST(2,ii)),
     &               R,R*Angstr
            end do
#endif
            MoreToGo=1
            Do While (MoreToGo.eq.1)
*
*              Find the shortest distance between any atoms
*
               R=100D0
               do ii=1,iiBST
                  R=MIN(R,BST(ii))
               enddo
*
               If (R.gt.90D0) Exit
*
               moretogo=0
               isfirst=1
               do ii=1,iiBST
*
                  If (abs(R-BST(ii)).lt.Thr_D) Then
                     If (isfirst.eq.1) Then
                        RR=SQRT(R)
                        Write (Lu,'(2(I5,1X,A),2(F10.6,6X))')
     &                         iBST(1,ii),Lbls(iBST(1,ii)),
     &                         iBST(2,ii),Lbls(iBST(2,ii)),
     &                         RR,RR*Angstr
                        isfirst=0
                     Else
                        Write (Lu,'(2(I5,1X,A),2(F10.6,6X))')
     &                  iBST(1,ii),Lbls(iBST(1,ii)),
     &                  iBST(2,ii),Lbls(iBST(2,ii))
                     End If
                     BST(ii)=100D0 ! Effectively remove from the list
                     moretogo=1
                   End If
               End Do
            End Do
            Call mma_deallocate(iBST)
            Call mma_deallocate(BST)
*
         Else
*
            Thr_R=3.0D0
            Do icc = 1, mCentr
               x1 = xyz(1,icc)
               y1 = xyz(2,icc)
               z1 = xyz(3,icc)
               Do jcc = 1, icc-1
                  x2 = xyz(1,jcc)
                  y2 = xyz(2,jcc)
                  z2 = xyz(3,jcc)
                  R = Sqrt((x2-x1)**2+(y2-y1)**2+(z2-z1)**2)
                  If (R*Angstr.le.Thr_R)
     &               Write (Lu,'(2(I5,1X,A),2(F10.6,6X))')
     &               icc,Lbls(icc), jcc,Lbls(jcc), R, R*Angstr
               End Do
            End Do
          End If
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_ZeroDiag_Rst(Diag,iSym,iABG)
!
! Purpose: zero diagonal element iABG (in global diagonal, rs1).
!          For serial runs, this is trivial. For parallel runs, we
!          need first to figure out if the treated diagonal element
!          is in fact present in the local diagonal.

use Cholesky, only: Cho_Real_Par, iiBstR, iL2G, IndRed, nnBstR
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Diag(*)
integer(kind=iwp), intent(in) :: iSym, iABG
integer(kind=iwp) :: iAB, iAB1, iAB2, jAB, kAB

if (Cho_Real_Par) then
  iAB1 = iiBstR(iSym,2)+1
  iAB2 = iAB1+nnBstR(iSym,2)-1
  do iAB=iAB1,iAB2
    jAB = IndRed(iAB,2)   ! addr in local rs1
    kAB = iL2G(jAB)       ! addr in global rs1
    if (kAB == iABG) then ! found...
      Diag(jAB) = Zero    ! now zero local diagonal elm.
      return
    end if
  end do
else
  Diag(iABG) = Zero
end if

end subroutine Cho_P_ZeroDiag_Rst

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine projspn_cvb(bikcof,
     > nel,nalf,nbet,ndet,ifns,
     > minalf,maxalf,nkalf,minspn,maxspn,nkspn,
     > locswp,lnoswp,locca,lnocca,ialfa,
     > xdet,xspin,iw,detphase)
      implicit real*8 (a-h,o-w,y-z),integer(x)
      dimension bikcof(ndet,ifns)
      dimension minalf(0:nel), maxalf(0:nel), nkalf(0:nel)
      dimension minspn(0:nel), maxspn(0:nel), nkspn(0:nel)
      dimension locswp(2*nbet), lnoswp(2*nbet), locca(nel), lnocca(nel)
      dimension ialfa(nalf),xdet(0:nel,0:nalf),xspin((nel+1)*(nalf+1))
      dimension iw(nel),detphase(ndet)

c  Phase factors between alpha-beta separated determinants
c  and determinants with ascending orbital numbers
      call dcopy_(ndet,[1d0],0,detphase,1)
      call asc2ab_cvb(detphase,1,nel,nalf)
c
c Projected spin functions (generated by orbital permutations
c                           on the first Kotani function)
c
c Set up maximum and minimum of spin functions:
      do 2000 iorb=0,nel
      minspn(iorb)=iorb-min(iorb/2,nbet)
      maxspn(iorb)=min(iorb,nalf)
2000  continue
      call weight_cvb(xspin,minspn,maxspn,nalf,nel)

      call imove_cvb(maxspn,nkspn,nel+1)
      call occupy_cvb(nkspn,nel,iw,iw(nalf+1))
c Set up maximum and minimum for determinants :
      do 2100 iorb=0,nel
      minalf(iorb)=max(iorb-nbet,0)
      maxalf(iorb)=min(iorb,nalf)
2100  continue
      call weight_cvb(xdet,minalf,maxalf,nalf,nel)
      call imove_cvb(maxalf,nkalf,nel+1)
      call occupy_cvb(nkalf,nel,locca,lnocca)
c Loop:
      index=1
c  Skip first function
      goto 2200
2300  inddet=1
c MAXSPN contains same elements as MAXALF
      call imove_cvb(maxspn,nkalf,nel+1)
      call occupy_cvb(nkalf,nel,locswp,lnoswp)
2400  continue
      do 2500 i=1,nalf
      ialfa(i)=iw(locswp(i))
2500  continue
2600  continue
      do 2700 i=2,nalf
        if(ialfa(i).lt.ialfa(i-1))then
          iswp=ialfa(i-1)
          ialfa(i-1)=ialfa(i)
          ialfa(i)=iswp
          goto 2600
        endif
2700  continue
      bikcof(minind_cvb(ialfa,nalf,nel,xdet),index)=bikcof(inddet,1)
     >  *detphase(inddet)*detphase(minind_cvb(ialfa,nalf,nel,xdet))
      call loind_cvb(nel,nalf,nkalf,minalf,maxalf,
     >                     locswp,lnoswp,inddet,xdet,*2400)
2200  call loind_cvb(nel,nalf,nkspn,minspn,maxspn,
     >                     iw,iw(nalf+1),index,xspin,*2300)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GSTTBL(C,CTT,IATP,IASM,IBTP,IBSM,NOCTPA,NOCTPB,NSASO,NSBSO,PSSIGN,ICOOSC,IDC,PLSIGN,LUC,SCR,NSMST,ISCALE,SCLFAC)
!***********************************************************************
! Variables status:
! C     = input CI vector
! CTT   = output CI vector in SD format
! obtain  determinant block (iatp iasm, ibtp ibsm)
! from vector packed in combination format according to IDC
!
! If ISCALE = 1, the routine scales and returns the block
! in determinant normalization, and SCLFAC = 1.0
!
! If ISCALE = 0, the routine does not perform any overall
! scaling, and a scale factor is returned in SCLFAC
!
! IF ISCALE = 0, zero blocks are not set explicitly to zero,
! instead zero is returned in SCLFAC
!
! ISCALE, SCLFAC added May 97

use lucia_data, only: IDISK
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: C(*)
real(kind=wp), intent(_OUT_) :: CTT(*), SCR(*)
integer(kind=iwp), intent(in) :: IATP, IASM, IBTP, IBSM, NOCTPA, NOCTPB, NSMST, NSASO(NSMST,*), NSBSO(NSMST,*), &
                                 ICOOSC(NOCTPA,NOCTPB,*), IDC, LUC, ISCALE
real(kind=wp), intent(in) :: PSSIGN, PLSIGN
real(kind=wp), intent(inout) :: SCLFAC
integer(kind=iwp) :: IAMPACK, IBASE, IDUMMY(1), IMZERO, ISGVST(1), LBL, LCOMB, LDET, NAST, NBST, NCI, NELMNT, NO_ZEROING, NRI
real(kind=wp) :: PSIGN

!write(u6,*) ' GSTTBL,  IATP,IASM,IBTP,IBSM,ISCALE'
!write(u6,*) IATP,IASM,IBTP,IBSM,ISCALE
! =================
! Read in from disc
! =================
if (LUC /= 0) then
  call IDAFILE(LUC,2,IDUMMY,1,IDISK(LUC))
  LBL = IDUMMY(1)
  call IDAFILE(LUC,2,IDUMMY,1,IDISK(LUC))
  !write(u6,*) ' LBL = ',LBL
  if (ISCALE == 1) then
    call FRMDSC(SCR,LBL,-1,LUC,IMZERO,IAMPACK)
  else
    NO_ZEROING = 1
    call FRMDSC2(SCR,LBL,-1,LUC,IMZERO,IAMPACK,NO_ZEROING)
  end if

  if ((IMZERO == 1) .and. (ISCALE == 0)) then
    SCLFAC = Zero
  else
    NAST = NSASO(IASM,IATP)
    NBST = NSBSO(IBSM,IBTP)
    if (LBL /= 0) then
      call SDCMRF(CTT,SCR,IATP,IBTP,IASM,IBSM,NAST,NBST,IDC,PSSIGN,PLSIGN,ISGVST,LDET,LCOMB,ISCALE,SCLFAC)
    else
      SCLFAC = Zero
    end if
  end if

  !write(u6,*) ' ISCALE and SCLFAC on return in GSTTBL',ISCALE,SCLFAC

else
  ! ISGVST and PLSIGN missing to make it work for IDC = 3,4
  ! =================
  ! Pack out from C
  ! =================
  if (ISCALE == 0) then
    write(u6,*) ' GSTTBL : LUC = 0 and ISCALE = 0'
    write(u6,*) ' I will scale as normal'
    SCLFAC = One
  end if
  ! Permutation sign
  ! To get rid of annoying compiler warning
  PSIGN = Zero
  if (IDC == 2) then
    PSIGN = PSSIGN
  else if (IDC == 3) then
    PSIGN = PLSIGN
  end if
  !PLSSGN = PLSIGN*PSSIGN
  ! check for different packing possibilities and unpack
  if ((IASM > IBSM) .or. (IDC == 1) .or. ((IDC == 3) .and. (IASM >= IBSM))) then
    !*************
    !* IASM > IBSM
    !*************
    if (IDC < 4) then
      ! Simple copy
      IBASE = ICOOSC(IATP,IBTP,IASM)
      NELMNT = NSASO(IASM,IATP)*NSBSO(IBSM,IBTP)
      CTT(1:NELMNT) = C(IBASE:IBASE+NELMNT-1)
      !write(u6,*) ' simple copy IBASE NELMNT ',IBASE,NELMNT
      !call WRTMAT(CTT,NSASO(IASM,IATP),NSBSO(IBSM,IBTP),NSASO(IASM,IATP),NSBSO(IBSM,IBTP))
    !idc else if (IDC == 4) then
    !      !MLMS packed
    !      if (IATP > IBTP) then
    !        IBASE = ICOOSC(IATP,IBTP,IASM)
    !        NELMNT = NSASO(IASM,IATP)*NSBSO(IBSM,IBTP)
    !        CTT(1:NELMNT) = C(IBASE:IBASE+NELMNT-1)
    !      else if (IATP == IBTP) then
    !        IBASE = ICOOSC(IATP,IATP,IASM)
    !        NAST = NSASO(IASM,IATP)
    !        call TRIPK32(CTT,C(IBASE),NAST,NAST,PLSIGN*PSSIGN)
    !      else if (IATP < IBTP) then
    !        IBASE = ICOOSC(IBTP,IATP,IASM)
    !        NROW = NSASO(IASM,IBTP)
    !        NCOL = NSBSO(IBSM,IATP)
    !        call TRPMT3(C(IBASE),NROW,NCOL,CTT)
    !        NELMNT = NROW*NCOL
    !        CTT(1:NELMNT) = PLSIGN*PSSIGN*CTT(1:NELMNT)
    !idc   end if
    end if
  else if (IASM == IBSM) then
    !*************
    !* IASM = IBSM
    !*************
    if ((IATP > IBTP) .or. (IDC == 3)) then
      ! simple copying
      IBASE = ICOOSC(IATP,IBTP,IASM)
      NELMNT = NSASO(IASM,IATP)*NSBSO(IBSM,IBTP)
      CTT(1:NELMNT) = C(IBASE:IBASE+NELMNT-1)
    else if (IATP == IBTP) then
      ! expand triangular packed matrix
      IBASE = ICOOSC(IATP,IBTP,IASM)
      NAST = NSASO(IASM,IATP)
      call TRIPK32(CTT,C(IBASE),NAST,NAST,PSSIGN)
    else if (IATP < IBTP) then
      ! transpose ibtp iasm iatp ibsm block
      IBASE = ICOOSC(IBTP,IATP,IASM)
      NRI = NSASO(IASM,IBTP)
      NCI = NSBSO(IASM,IATP)
      call TRPMT3(C(IBASE),NRI,NCI,CTT)
      if (PSSIGN == -One) CTT(1:NRI*NCI) = -CTT(1:NRI*NCI)
    end if
  else if (IASM < IBSM) then
    !*************
    !* IASM < IBSM
    !*************
    ! transpose ibtp ibsm iatp iasm block
    if (IDC < 4) then
      IBASE = ICOOSC(IBTP,IATP,IBSM)
      NRI = NSASO(IBSM,IBTP)
      NCI = NSBSO(IASM,IATP)
      if (IDC == 2) then
        call TRPMT3(C(IBASE),NRI,NCI,CTT)
      !else if (IDC == 3) then
      !  CTT(1:NRI*NCI) = C(IBASE:IBASE+NRI*NCI-1)
      end if
      if (PSIGN == -One) CTT(1:NRI*NCI) = -CTT(1:NRI*NCI)
    !idc else if (IDC  == 4) then
    !      if (IBTP > IATP) then
    !        IBASE = ICOOSC(IBTP,IATP,IBSM)
    !        NRI = NSASO(IBSM,IBTP)
    !        NCI = NSBSO(IASM,IATP)
    !        call TRPMT3(C(IBASE),NRI,NCI,CTT)
    !        if (PSSIGN == -One) CTT(1:NRI*NCI) = -CTT(1:NRI*NCI)
    !      else if (IBTP == IATP) then
    !        IBASE = ICOOSC(IBTP,IATP,IBSM)
    !        NRI   = NSASO(IBSM,IATP)
    !        NCI   = NSBSO(IASM,IATP)
    !        call TRIPK32(CTT,C(IBASE),NRI,NCI,PLSSGN)
    !        if (PLSIGN == -One) CTT(1:NRI*NCI) = -CTT(1:NRI*NCI)
    !      else if (IBTP < IATP) then
    !        IBASE = ICOOSC(IATP,IBTP,IBSM)
    !        NELMNT = NSASO(IBSM,IATP)*NSBSO(IASM,IBTP)
    !        CTT(1:NELMNT) = C(IBASE:IBASE+NELMNT-1)
    !        if (PLSIGN == -One) CTT(1:NELMNT) = -CTT(1:NELMNT)
    !idc   end if
    end if
  end if
end if

end subroutine GSTTBL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Kurt Pfingst                                           *
!***********************************************************************

subroutine CmbnKEr(Rnr,qC,Di,nZeta,la,lb,Zeta,rFinal,nComp,Alpha,nAlpha,Beta,nBeta)
!***********************************************************************
!     Author: Kurt Pfingst                                             *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two, Three, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nComp, nAlpha, nBeta
real(kind=wp), intent(in) :: Rnr(nZeta,0:la+lb+2), qC(nZeta,0:la+lb), Di(nZeta,-1:la+lb-1), Zeta(nZeta), Alpha(nAlpha), Beta(nBeta)
real(kind=wp), intent(out) :: rFinal(nZeta,nComp,nTri_Elem1(la),nTri_Elem1(lb))
#include "print.fh"
#include "nrmf.fh"
#include "rmat.fh"
#include "gam.fh"
integer(kind=iwp) :: ia, ialpha, ib, ibeta, iComp, ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyb, iza, izb, iZeta, k, kc, lrs, m, n, &
                     na, nb
real(kind=wp) :: b1, b1a, b2, b2a, b3, BBLoch, CConst1, CConst2, CConst3, ck1, const1, const2, const3, Fact, Fact1, Fact2, Fact3, &
                 ralpha, rbeta, rx1, ry1, rz1, W
character(len=80) :: Label

iRout = 134
iPrint = nPrint(iRout)

iComp = 1
do ixa=0,la
  do ixb=0,lb
    rx1 = real(ixb*(ixb-1),kind=wp)
    n = ixa+ixb
    do iya=0,la-ixa
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,lb-ixb
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)
        ry1 = real(iyb*(iyb-1),kind=wp)
        m = iya+iyb
        rz1 = real(izb*(izb-1),kind=wp)
        k = iza+izb

        ! Combine integrals
        ! define various factors
        !***************************************************
        ck1 = Two*real(ixb+iyb+izb,kind=wp)+Three
        !***************************************************
        !***************************************************
        const1 = rx1*gammath(n+m-2,k)*gammaph(m,n-2)
        !***************************************************
        const2 = ry1*gammath(n+m-2,k)*gammaph(m-2,n)
        !***************************************************
        const3 = rz1*gammath(n+m,k-2)*gammaph(m,n)
        !***************************************************
        !***************************************************
        CConst1 = const1+const2+const3
        !***************************************************
        CConst2 = ck1*gammath(n+m,k)*gammaph(m,n)
        !***************************************************
        CConst3 = gammath(n+m,k)*gammaph(m,n)
        !***************************************************
        ! Constants for Bloch term b1/b2/b3
        na = ixa+iya+iza
        nb = ixb+iyb+izb
        b1 = Half*(real(nb+1,kind=wp))*rmatr**(na+nb+1)
        b1a = Half*(real(na+1,kind=wp))*rmatr**(na+nb+1)
        W = gammath(n+m,k)*gammaph(m,n)

        ibeta = 1
        ialpha = 1
        kc = 1
        do iZeta=1,nZeta
          ralpha = Alpha(ialpha)
          rbeta = Beta(ibeta)
          b2 = rbeta*rmatr**(na+nb+3)
          b2a = ralpha*rmatr**(na+nb+3)
          b3 = exp(-Zeta(iZeta)*rmatr**2)
          BBLoch = W*b3*((b1-b2)-bParm*(b1-b2)*(b1a-b2a))
          rFinal(iZeta,iComp,ipa,ipb) = BBloch-(Half*CConst1*Rnr(iZeta,n+m+k-2)-rbeta*CConst2*Rnr(iZeta,n+m+k)+ &
                                                Two*rbeta**2*CConst3*Rnr(iZeta,n+m+k+2))
          if (iZeta == kc*nAlpha) then
            ibeta = ibeta+1
            ialpha = 0
            kc = kc+1
          end if
          ialpha = ialpha+1
        end do

      end do
    end do
  end do
end do

!***********************************************************************

if (iPrint >= 99) then
  write(u6,*) ' Result in Cmbnker1'
  do ia=1,(la+1)*(la+2)/2
    do ib=1,(lb+1)*(lb+2)/2
      write(Label,'(A,I2,A,I2,A)') ' rFinal(',ia,',',ib,')'
      call RecPrt(Label,' ',rFinal(:,:,ia,ib),nZeta,nComp)
    end do
  end do
end if

!***********************************************************************

! Add Coulomb contributions for photoionization calculations

if (abs(qCoul) > Epsq) then
  do ixa=0,la
    do ixb=0,lb
      do iya=0,la-ixa
        iza = la-ixa-iya
        ipa = C_Ind(la,ixa,iza)
        do iyb=0,lb-ixb
          izb = lb-ixb-iyb
          ipb = C_Ind(lb,ixb,izb)
          lrs = ixa+ixb+iya+iyb+iza+izb
          lcost = iza+izb
          lsint = ixa+ixb+iya+iyb
          lsinf = iya+iyb
          lcosf = ixa+ixb
          Fact = gammath(lsint,lcost)*gammaph(lsinf,lcosf)
          rFinal(:,iComp,ipa,ipb) = rFinal(:,iComp,ipa,ipb)+Fact*qCoul*qC(:,lrs)

        end do
      end do
    end do
  end do
end if

!***********************************************************************

if (iPrint >= 99) then
  write(u6,*) ' Result in Cmbnker2'
  do ia=1,(la+1)*(la+2)/2
    do ib=1,(lb+1)*(lb+2)/2
      write(Label,'(A,I2,A,I2,A)') ' rFinal(',ia,',',ib,')'
      call RecPrt(Label,' ',rFinal(:,:,ia,ib),nZeta,nComp)
    end do
  end do
end if

!***********************************************************************

! Add DIPOL contributions for photoionization calculations

if (abs(Dipol1) > Epsq) then
  do ixa=0,la
    do ixb=0,lb
      do iya=0,la-ixa
        iza = la-ixa-iya
        ipa = C_Ind(la,ixa,iza)
        do iyb=0,lb-ixb
          izb = lb-ixb-iyb
          ipb = C_Ind(lb,ixb,izb)
          lrs = ixa+ixb+iya+iyb+iza+izb
          ! Beitrag der x-Komponente
          lcost = iza+izb
          lsint = ixa+ixb+iya+iyb+1
          lsinf = iya+iyb
          lcosf = ixa+ixb+1
          Fact1 = Dipol(1)*gammath(lsint,lcost)*gammaph(lsinf,lcosf)
          ! Beitrag der y-Komponente
          lcost = iza+izb
          lsint = ixa+ixb+iya+iyb+1
          lsinf = iya+iyb+1
          lcosf = ixa+ixb
          Fact2 = Dipol(2)*gammath(lsint,lcost)*gammaph(lsinf,lcosf)
          ! Beitrag der z-Komponente
          lcost = iza+izb+1
          lsint = ixa+ixb+iya+iyb
          lsinf = iya+iyb
          lcosf = ixa+ixb
          Fact3 = Dipol(3)*gammath(lsint,lcost)*gammaph(lsinf,lcosf)
          ! Summe
          rFinal(:,iComp,ipa,ipb) = rFinal(:,iComp,ipa,ipb)+(Fact1+Fact2+Fact3)*Di(:,lrs)

        end do
      end do
    end do
  end do
end if

!***********************************************************************

return

end subroutine CmbnKEr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRWF_MRCI(ICSPCK,INTSYM,INDX,C,JREFX)

use mrci_global, only: CTRSH, IFIRST, IORB, IRC, JSC, LN, LSYM, NCONF, NFMO, NSM, NSYM, NVIR, NVIRP, NVIRT
use Symmetry_Info, only: Mul
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: ICSPCK(*), INTSYM(*), INDX(*), JREFX(*)
real(kind=wp), intent(inout) :: C(*)
integer(kind=iwp) :: I, II, II1, IIN, IJ, ILIM, ILSYM(32), IO, IOC(32), IORBI(32), IS, ISP(32), J, J1, J2, JCONF, JJ, JMAX, JMIN, &
                     JVIR, LN1, LN2, NA, NB, NREXT, NSI, NSJ
real(kind=wp) :: ACI, CI, CLIM, SCL
character(len=14) :: FRMT
character(len=12) :: CSFTYP
character(len=*), parameter :: FORM00 = '(1X,A,6X,53I2)', FORM01 = '(1X,A,3X,54I2)', FORM02 = '(1X,A,55I2)', &
                               FORM0 = '(1X,A,6X,34I3)', FORM1 = '(1X,A,3X,35I3)', FORM2 = '(1X,A,36I3)'
integer(kind=iwp), external :: ICUNP, JSUNP
real(kind=r8), external :: DDOT_

NA = 0
NB = 0
ILIM = 4
LN2 = LN+2
if (IFIRST /= 0) ILIM = 2
SCL = One/sqrt(DDOT_(NCONF,C,1,C,1))
C(1:NCONF) = SCL*C(1:NCONF)
do J=1,LN
  IORBI(J+2) = IORB(J)
  ILSYM(J+2) = NSM(J)
end do
JCONF = JSC(1)
write(u6,'(A,F5.3)') '      CI-COEFFICIENTS LARGER THAN ',CTRSH
do IS=1,NSYM
  if (NFMO(IS) > 0) then
    write(u6,*) ' NOTE: THE FOLLOWING ORBITALS WERE FROZEN'
    write(u6,*) ' ALREADY AT THE INTEGRAL TRANSFORMATION STEP'
    write(u6,*) ' AND DO NOT EXPLICITLY APPEAR:'
    write(u6,'(6X,A,8I4)') '  SYMMETRY:',(I,I=1,NSYM)
    write(u6,'(6X,A,8I4)') 'PRE-FROZEN:',(NFMO(I),I=1,NSYM)
    exit
  end if
end do
write(u6,*) ' ORDER OF SPIN-COUPLING: (PRE-FROZEN, NOT SHOWN)'
write(u6,*) '                         (FROZEN, NOT SHOWN)'
write(u6,*) '                          VIRTUAL'
write(u6,*) '                          ADDED VALENCE'
write(u6,*) '                          INACTIVE'
write(u6,*) '                          ACTIVE'
write(u6,*)
write(u6,*) ' ORBITALS ARE NUMBERED WITHIN EACH SEPARATE SYMMETRY.'
do I=1,NCONF
  CI = C(I)
  ACI = abs(C(I))
  if (I <= JCONF) then
    JMIN = 1
    NREXT = 0
    if (JREFX(I) /= 0) then
      CSFTYP = '   REFERENCE'
      CLIM = Zero
    else
      CSFTYP = '     VALENCE'
      CLIM = CTRSH
    end if
  else if (I <= JSC(2)) then
    NREXT = 1
    JMIN = 1+IRC(1)
    CSFTYP = '     DOUBLET'
    CLIM = CTRSH
  else if (I <= JSC(3)) then
    NREXT = 2
    JMIN = 1+IRC(2)
    CSFTYP = '     TRIPLET'
    CLIM = CTRSH
  else
    NREXT = 2
    JMIN = 1+IRC(3)
    CSFTYP = '     SINGLET'
    CLIM = CTRSH
  end if
  if (ACI < CLIM) exit
  JJ = I
  IJ = I
  if (NREXT > 0) then
    JMAX = IRC(ILIM)
    do J=JMIN,JMAX
      JJ = J
      if (INDX(J) >= IJ) then
        JJ = JJ-1
        exit
      end if
    end do
  end if
  NSJ = MUL(JSUNP(INTSYM,JJ),LSYM)
  JVIR = IJ-INDX(JJ)
  II1 = (JJ-1)*LN
  do II=1,LN
    II1 = II1+1
    ISP(II+2) = ICUNP(ICSPCK,II1)
    IOC(II+2) = (1+ISP(II+2))/2
  end do
  if (NREXT == 0) then
    FRMT = FORM0
    if (LN2 > 36) FRMT = FORM00
    LN1 = 3
  else if (NREXT == 1) then
    IO = JVIR+NVIRP(NSJ)+LN
    IORBI(2) = IORB(IO)
    IOC(2) = 1
    ISP(2) = 1
    ILSYM(2) = NSJ
    FRMT = FORM1
    if (LN2 > 36) FRMT = FORM01
    LN1 = 2
  else
    IIN = 0
    outer: do II=1,NVIRT
      NA = II
      NSI = MUL(NSJ,NSM(LN+II))
      J1 = NVIRP(NSI)+1
      J2 = NVIRP(NSI)+NVIR(NSI)
      if (J2 > II) J2 = II
      if (J2 >= J1) then
        do J=J1,J2
          NB = J
          IIN = IIN+1
          if (IIN == JVIR) exit outer
        end do
      end if
    end do outer
    IOC(1) = 1
    ISP(1) = 1
    ILSYM(1) = NSM(LN+NB)
    IO = LN+NB
    IORBI(1) = IORB(IO)
    if (NA == NB) then
      IORBI(2) = IORBI(1)
      IOC(2) = 2
      ISP(2) = 3
      ILSYM(2) = NSM(IO)
      CI = CI*sqrt(Half)
      if (abs(CI) < CTRSH) cycle
      FRMT = FORM1
      if (LN2 > 36) FRMT = FORM01
      LN1 = 2
    else
      IOC(2) = 1
      ISP(2) = 2
      if (CSFTYP == '     TRIPLET') ISP(2) = 1
      IO = LN+NA
      IORBI(2) = IORB(IO)
      ILSYM(2) = NSM(IO)
      FRMT = FORM2
      if (LN2 > 36) FRMT = FORM02
      LN1 = 1
    end if
  end if
  write(u6,*)
  write(u6,105) I,C(I),CSFTYP
  write(u6,FRMT) 'SYMMETRY     ',(ILSYM(J),J=LN1,LN2)
  write(u6,FRMT) 'ORBITALS     ',(IORBI(J),J=LN1,LN2)
  write(u6,FRMT) 'OCCUPATION   ',(IOC(J),J=LN1,LN2)
  write(u6,FRMT) 'SPIN-COUPLING',(ISP(J),J=LN1,LN2)
end do

return

105 format(/6X,'CONFIGURATION',I7,3X,'COEFFICIENT',F10.6,A)

end subroutine PRWF_MRCI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SUBROUTINE CHO_motra_drv(rc,nIsh,nAsh,nSsh,nFr,nFrVir,
     &                         ipPorb)

**********************************************************************
C
C      a,b,g,d:  AO-index
C      p,q,r,s:  MO-indeces (probably frozen/deleted are excluded)
C
**********************************************************************

      Implicit Real*8 (a-h,o-z)

      Integer   rc,nIsh(*),nAsh(*),nSsh(*), nFr(*), nFrVir(*)

      Real*8    tread(2),tmotr1(2),tmotr2(2)
      Logical   Debug,timings,DoRead
      Integer   nPorb(8),ipOrb(8),nPvir(8),nPocc(8)
      Integer   ipLpb(8),iSkip(8),LuLTra(4)
      Integer   kOff1(8),kOff1ij(8),kOff1ia(8),kOff1ai(8),kOff1ab(8)
      Character*6  Fname

      Character*50 CFmt
      Character*13 SECNAM
      Parameter (SECNAM = 'CHO_motra_drv')

      COMMON    /CHOTIME /timings

      parameter (zero = 0.0D0, one = 1.0D0)

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)

************************************************************************

#ifdef _DEBUGPRINT_
      Debug=.true.
#else
      Debug=.false.
#endif


      DoRead  = .false.
      IREDC = -1  ! unknown reduced set in core

      iSwap = 0  ! Lpb,J are returned by cho_x_getVtra
      kMOs = 1
      nMOs = 1


        CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        do i=1,2            ! 1 --> CPU   2 --> Wall
           tread(i) = zero   !time read/write vectors
           tmotr1(i) = zero  !time 1st MO half-transf.
           tmotr2(i) = zero  !time 2nd MO half-transf.
        end do

c --- Define MOs to be used by a given code
c -----------------------------------------
        do i=1,nSym
           nPorb(i) = nIsh(i) + nAsh(i) + nSsh(i) + nFr(i) + nFrVir(i)
           nPocc(i) = nFr(i) + nIsh(i) + nAsh(i)
           nPvir(i) = nSsh(i) + nFrVir(i)
        end do

C ==================================================================

c --- Various offsets & pointers
c ------------------------------
      ipOrb(1)=ipPorb
      DO ISYM=2,NSYM
        NB=NBAS(ISYM-1)
        NP=NPORB(ISYM-1)
        NP2=NB*NP
        ipOrb(ISYM)=ipOrb(ISYM-1)+NP2 !  MO coeff. symm pointers
      END DO

      iLoc = 3 ! use scratch location in reduced index arrays
      nType = 4

C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
      DO jSym=1,nSym
         If (NumCho(jSym).lt.1) GOTO 1000
*        Type refers to occ-occ 2 x vir-occ (with vir or occ as outer
*        index) and vir-vir transformed cholesky vectors. All integrals
*        we need can be constructed from these and the only redundancy
*        we get is frozen orbitals in an inner index.

         Do iType=1,nType
            iSeed = 7 + jSym-1
            LuLTra(iType) = IsFreeUnit(iSeed)
            Write(Fname,'(A4,I1,I1)') 'LTra',jSym,iType
            Call DANAME_MF_WA(LuLTra(iType),Fname)
         End Do
         Call ChoMP2_OpenF(1,1,jSym)
C --- Set up the skipping flags + some initializations --------
C -------------------------------------------------------------
         Do i=1,nSym
            k = Muld2h(i,JSYM)
            iSkip(i) = Min(1,nBas(i)*nBas(k)) ! skip Lik vector
            kOff1(i) = 0
            kOff1ij(i) = 0
            kOff1ia(i) = 0
            kOff1ai(i) = 0
            kOff1ab(i) = 0
            ipLpb(i) = -6666
         End Do

C -------------------------------------------------------------


C ****************     MEMORY MANAGEMENT SECTION    *****************
C ------------------------------------------------------------------
C --- compute memory needed to store at least 1 vector of JSYM
C --- and do all the subsequent calculations
C ------------------------------------------------------------------
         mTvec  = 0  ! mem for storing half-transformed vec Laq,J
         mTTvec = 0  ! mem for storing transformed vec Lpq,J

         do l=1,nSym
            k=Muld2h(l,JSYM)
            mTvec = mTvec + nPorb(k)*nBas(l)
            mTTvec = Max(mTTvec,nPorb(k)*nPorb(l))
         end do

         mvec = mTvec + mTTvec


C ------------------------------------------------------------------
C ------------------------------------------------------------------

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

         Do JRED=JRED1,JRED2
            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               call abend()
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.'
              Write(6,*)        'rc= ',irc
              call abend()
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec  = Min(LWORK/(nRS+mvec),nVrs)

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) 'LWORK= ',LWORK
               WRITE(6,*) 'min. mem. need= ',nRS+mTvec
               WRITE(6,*) 'reading ',nRS,' and transforming to ',mvec
               WRITE(6,*) 'of jsym= ',jsym,' and JRED= ',JRED
               rc = 33
               CALL Abend()
               NumBat = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
            Call GetMem('ChoT','Allo','Real',ipChoT,mvec*nVec)

C --- BATCH over the vectors ----------------------------

            NumBat = (nVrs-1)/nVec + 1
            DO iBatch=1,NumBat
               iAdr = 0
               If (iBatch.eq.NumBat) Then
                  JNUM = nVrs - nVec*(NumBat-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM
*
               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM) then
                  rc=77
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

*              The total number of elements in all cholesky-vectors
*              for this batch

               lChoT=0
               Do iSymp=1,nSym

                  iSymb = MulD2h(jSym,iSymp)

                  ipLpb(iSymp) = ipChoT + lChoT
                  lChoT = lChoT + nPorb(iSymp)*nBas(iSymb)*JNUM

               End Do

               ipLpq = ipChoT + lChot

C --------------------------------------------------------------------
C --- First half MO transformation  Lpb,J = sum_a  C(p,a) * Lab,J
C --------------------------------------------------------------------

               CALL CWTIME(TCM1,TWM1)

               CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                           JSYM,iSwap,IREDC,nMOs,kMOs,ipOrb,nPorb,
     &                           ipLpb,iSkip,DoRead)

               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif

               CALL CWTIME(TCM2,TWM2)
               tmotr1(1) = tmotr1(1) + (TCM2 - TCM1)
               tmotr1(2) = tmotr1(2) + (TWM2 - TWM1)

C --------------------------------------------------------------------
C --- 2nd half of MO transformation  Lpq,J = sum_b  Lpb,J * C(q,b)
C --------------------------------------------------------------------
               kOff2 = 0
               kOff2ij = 0
               kOff2ia = 0
               kOff2ai = 0
               kOff2ab = 0
               Do iSymb=1,nSym

                  iSymp = MulD2h(JSYM,iSymb)
                  NAp = nPorb(iSymp)
                  NAq = nPorb(iSymb) ! iSymb=iSymq

                  CALL CWTIME(TCM3,TWM3)

                  If(NAp*NAq.ne.0)Then
                     Do JVC=1,JNUM
                        ipLJpb = ipLpb(iSymp)
     &                         + nPorb(iSymp)*nBas(iSymb)*(JVC-1)
                        ipLJpq = ipLpq
     &                         + nPorb(iSymp)*nPorb(iSymb)*(JVC-1)
*


*                        ipLJai = ipLJia + nPocc(iSymP)*nPvir(iSymB)
*                        ipLJab = ipLJai + nPvir(iSymP)*nPocc(iSymB)
*
                        CALL DGEMM_('N','T',NAp,NAq,nBas(iSymb),
     &                             One,Work(ipLJpb),NAp,
     &                             Work(ipOrb(iSymb)),NAq,
     &                             Zero,Work(ipLJpq),NAp)
                        lChoMO = NAp*NAq
                        iAdr = 1 + kOff2 + kOff1(iSymB)
                        Call ddaFile(lUnit_F(jSym,1),1,
     &                               Work(ipLJpq),lChoMO,iAdr)
                        kOff1(iSymB) = kOff1(iSymB) + nPQ_prod(jSym)

*                        Write(6,*) 'Long ChoVec', JVC
*                        Do i = 0, lChoMO-1
*                           Write(6,*) Work(ipLJpq+i)
*                        End Do
*
                        Do iI = 1, nPocc(iSymP)
                           Do iJ = 1,nPocc(iSymB)
                              Work(ip_TmpL+(iJ-1)+(iI-1)*nPocc(iSymB)) =
     &                         Work(ipLJpq+(iJ-1)+(iI-1)*nPorb(iSymB))
                           End Do
                        End Do
                        lChoMOij = nPocc(iSymP)*nPocc(iSymB)
                        iType = 1
                        iAdrij = 1 + kOff2ij + kOff1ij(iSymB)
                        Call dDaFile(LuLtra(iType),1,
     &                               Work(ip_TmpL),
     &                               lChoMOij, iAdrij)

*                        Write(6,*) 'ChoVec nr', JVC
*                        Do i = 0, lChoMOij-1
*                          Write(6,*) Work(ip_TmpL+i)
*                        End Do

*                       Put L-vectors ia on disk
                        Do iI = 1, nPocc(iSymP)
                           Do iA = 1,nPvir(iSymB)
                              Work(ip_TmpL+(iA-1)+(iI-1)*nPvir(iSymB)) =
     &                         Work(ipLJpq+(iA+nPocc(iSymB)-1)+
     &                              (iI-1)*nPorb(iSymB))
                           End Do
                        End Do
                        iType = 2
                        lChoMOia = nPocc(iSymP)*nPvir(iSymB)
                        iAdria = 1 + kOff2ia + kOff1ia(iSymB)
                        Call dDaFile(LuLtra(iType),1,Work(ip_TmpL),
     &                               lChoMOia, iAdria)

*                        Write(6,*) 'ChoVec nr', JVC
*                        Do i = 0, lChoMOia-1
*                           Write(6,*) Work(ip_TmpL+i)
*                        End Do
*                       Put L-vectors ai on disk.
                        Do iA = 1, nPvir(iSymP)
                           Do iI = 1,nPocc(iSymB)
                              Work(ip_TmpL+(iI-1)+(iA-1)*nPocc(iSymB)) =
     &                         Work(ipLJpq+(iI-1)+
     &                              (iA+nPvir(iSymP)-1)*nPorb(iSymB))
                           End Do
                        End Do
                        iType = 3
                        lChoMOai = nPvir(iSymP)*nPocc(iSymB)
                        iAdrai = 1 + kOff2ai + kOff1ai(iSymB)
                        Call dDaFile(LuLtra(iType),1,Work(ip_TmpL),
     &                               lChoMOai, iAdrai)

*                        Write(6,*) 'ChoVec nr', JVC
*                        Do i = 0, lChoMOai-1
*                           Write(6,*) Work(ip_TmpL+i)
*                        End Do

*
*                       Put L-vectors ab on disk.
                        Do iA = 1, nPvir(iSymP)
                           Do iB = 1,nPvir(iSymB)
                              Work(ip_TmpL+(iB-1)+(iA-1)*nPvir(iSymB)) =
     &                         Work(ipLJpq+(iB+nPocc(iSymB)-1)+
     &                              (iA+nPvir(iSymP)-1)*nPorb(iSymB))
                           End Do
                        End Do
                        iType = 4
                        lChoMOab = nPvir(iSymP)*nPvir(iSymB)
                        iAdrab = 1 + kOff2ab + kOff1ab(iSymB)
                        Call dDaFile(LuLtra(iType),1,Work(ip_TmpL),
     &                                  lChoMOab, iAdrab)
*                        Write(6,*) 'ChoVec nr', JVC
*                        Do i = 0, lChoMOab-1
*                           Write(6,*) Work(ip_TmpL+i)
*                        End Do

                        kOff1ab(iSymB) = kOff1ab(iSymB)+
     &                                      nPQ_prodab(jSym)
                        kOff1ij(iSymB) = kOff1ij(iSymB)+
     &                                      nPQ_prodij(jSym)
                        kOff1ia(iSymB) = kOff1ia(iSymB)+
     &                                      nPQ_prodia(jSym)
                        kOff1ai(iSymB) = kOff1ai(iSymB)+
     &                                      nPQ_prodia(jSym)
*
                     End Do
                  EndIf
*
                  CALL CWTIME(TCM4,TWM4)
                  tmotr2(1) = tmotr2(1) + (TCM4 - TCM3)
                  tmotr2(2) = tmotr2(2) + (TWM4 - TWM3)

                  kOff2 = NAp*NAq + kOff2
                  kOff2ij = lChoMOij + kOff2ij
                  kOff2ia = lChoMOia + kOff2ia
                  kOff2ai = lChoMOai + kOff2ai
                  kOff2ab = lChoMOab + kOff2ab
               End Do

C --------------------------------------------------------------------
C --------------------------------------------------------------------

            END DO  ! end batch loop


C --- free memory
            Call GetMem('ChoT','Free','Real',ipChoT,mTvec*nVec)
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

999         CONTINUE


         END DO   ! loop over red sets

         Call ChoMP2_OpenF(2,1,jSym)
         Do i = 1, nType
            Call DaClos(LuLTra(i))
         End Do

1000     CONTINUE

      END DO   !loop over JSYM

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1
*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky timing from '//SECNAM
      Write(6,CFmt)'----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'MO transf. Cholesky vectors     CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ/WRITE VECTORS               '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'1st half-transf.                 '
     &                           //'         ',tmotr1(1),tmotr1(2)
         Write(6,'(2x,A26,2f10.2)')'2nd half-transf.                 '
     &                           //'         ',tmotr2(1),tmotr2(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


      rc  = 0

      Call Cho_X_final(rc)

      Return
      END

**************************************************************
**************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

!#define _DEBUGPRINT_
subroutine Setup_Kriging(nRaw,nInter,qInt,Grad,Energy,Hessian_HMF,HDiag)

use kriging_mod, only: blavAI, nSet, layer_U, set_l
! This will be in the same module
!use kriging_procedures, only: set_l_Array
use Index_Functions, only: iTri, nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nRaw, nInter
real(kind=wp), intent(in) :: qInt(nInter,nRaw), Grad(nInter,nRaw,nSet), Energy(nRaw,nSet)
real(kind=wp), intent(inout), optional :: Hessian_HMF(nInter,nInter), HDiag(nInter)
integer(kind=iwp) :: i, iInter, ij, jInter
real(kind=wp) :: Value_l
real(kind=wp), allocatable :: Array_l(:), dqInt_s(:,:,:), Energy_s(:,:), Hessian(:,:), HTri(:), qInt_s(:,:)

!                                                                      *
!***********************************************************************
!                                                                      *
if (present(Hessian_HMF)) then

  call mma_allocate(layer_U,nInter,nInter,Label='layer_U')

  call unitmat(layer_U,nInter)

  call mma_allocate(Hessian,nInter,nInter,Label='Hessian')
  call mma_allocate(HTri,nTri_Elem(nInter),Label='HTri')

  do iInter=1,nInter
    do jInter=1,iInter
      ij = iTri(iInter,jInter)
      HTri(ij) = Hessian_HMF(iInter,jInter)
    end do
  end do
  call NIDiag_new(HTri,layer_U,nInter,nInter)
  Hessian(:,:) = Zero
  do i=1,nInter
    Hessian(i,i) = HTri(iTri(i,i))
  end do

  call mma_deallocate(HTri)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Select between setting all ls to a single value or go in
  ! multiple l-value mode in which the l-value is set such that
  ! the kriging hessian reproduce the diagonal value of the HMF
  ! Hessian of the current structure.

# ifdef _DEBUGPRINT_
  call RecPrt('Setup_kriging: qInt',' ',qInt,nInter,nRaw)
  do i=1,nSet
    write(u6,*) 'iSet=',i
    call RecPrt('Setup_kriging: Energy',' ',Energy(:,i),1,nRaw)
    call RecPrt('Setup_kriging: Grad',' ',Grad(:,:,i),nInter,nRaw)
  end do
# endif
  call mma_allocate(Array_l,nInter,Label='Array_l')
  if (Set_l) then
    call Get_dScalar('Value_l',Value_l)
    Array_l(:) = Value_l
  else
    call Set_l_Array(Array_l,nInter,blavAI,Hessian=Hessian)
  end if
  call mma_deallocate(Hessian)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call mma_allocate(qInt_s,nInter,nRaw,Label="qInt_s")
  call mma_allocate(dqInt_s,nInter,nRaw,nSet,Label="dqInt_s")
  call mma_allocate(Energy_s,nRaw,nSet,Label="Energy_s")

  ! Transform to the basis which diagonalizes the HMF Hessian.

  call Trans_K(qInt,qInt_s,nInter,nRaw)
  do i=1,nSet
    call Trans_K(Grad(:,:,i),dqInt_s(:,:,i),nInter,nRaw)
  end do
  Energy_s(:,:) = Energy
  !                                                                    *
  !*********************************************************************
  !                                                                    *
# ifdef _DEBUGPRINT_
  call RecPrt('Setup_kriging: qInt_s',' ',qInt_s,nInter,nRaw)
  do i=1,nSet
    write(u6,*) 'iSet=',i
    call RecPrt('Setup_kriging: Energy_s',' ',Energy_s(:,i),1,nRaw)
    call RecPrt('Setup_kriging: dqInt_s',' ',dqInt_s(:,:,i),nInter,nRaw)
  end do
# endif
  call Start_Kriging(nRaw,nInter,qInt_s,dqInt_s,Energy_s)

  call mma_deallocate(Energy_s)
  call mma_deallocate(dqInt_s)
  call mma_deallocate(qInt_s)

else

  call mma_allocate(Array_l,nInter,Label='Array_l')
  if (Set_l) then
    call Get_dScalar('Value_l',Value_l)
    Array_l(:) = Value_l
  else
    call Set_l_Array(Array_l,nInter,blavAI,HDiag=HDiag)
  end if

  call Start_Kriging(nRaw,nInter,qInt,Grad,Energy)

end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Pass the l-values to the GEK routine. This will initiate the
! computation of the covariance matrix, and solve related GEK
! equations.

call Set_l_Kriging(Array_l,nInter)
call mma_deallocate(Array_l)

!                                                                      *
!***********************************************************************
!                                                                      *
return

#undef _DEBUGPRINT_
end subroutine Setup_Kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*----------------------------------------------------------------------*
* This subroutine reads from the formatted output of mpprop the        *
* coordinates of the expansion centers.                                *
*----------------------------------------------------------------------*
      Subroutine Get_Centers(nAt,xyz)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "files_qmstat.fh"
#include "warnings.fh"

      Dimension xyz(MxAt,MxAt,3)
      Character*13 TheLine
      Logical Exist

*Open the file
      Lu=40
      Lu=IsFreeUnit(40)
      Call Opnfl('MPPROP',Lu,Exist)
      If(.not.Exist) then
        Write(6,*)
        Write(6,*)' Can not locate output file from MpProp. '
        Call Quit(_RC_IO_ERROR_READ_)
      Endif
      Rewind(Lu)

*Read until you get standard line
10    Continue
        Read(Lu,'(A)') TheLine
      If(TheLine.ne.'* All centers') Go To 10
      Read(Lu,*) nCent

*Read atom centers.
      Do 15, i=1,nAt
        Read(Lu,'(A)') TheLine
        Read(Lu,*)(xyz(i,i,k),k=1,3)
        Do 25, j=1,10
          Read(Lu,'(A)') TheLine
25      Continue
15    Continue

*Read bond centers.
      Do 30, i=2,nAt
        Do 32, j=1,i-1
          Read(Lu,'(A)') TheLine
          Read(Lu,*)(xyz(i,j,k),k=1,3)
          Do 35, jj=1,10
            Read(Lu,'(A)') TheLine
35        Continue
32      Continue
30    Continue

*Square xyz for later convinience
      Do 40, i=2,nAt
        Do 42, j=1,i-1
          xyz(j,i,1)=xyz(i,j,1)
          xyz(j,i,2)=xyz(i,j,2)
          xyz(j,i,3)=xyz(i,j,3)
42      Continue
40    Continue

      Close(Lu)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrintResult(iUnit,FRMT,STR,iCount,STR2,Val,iRank)
! routine to print result in the form:
!      write(iUnit,FRMT) STR,iCount,STR2,(Val(i),i=1,iRank)
!  or, if iCount=0
!      write(iUnit,FRMT) STR,(Val(i),i=1,iRank)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iUnit, iCount, iRank
character(len=*), intent(in) :: FRMT, STR, STR2
real(kind=wp), intent(in) :: Val(iRank)
character(len=120) :: TMP
character(len=2), parameter :: Marker = '::'
#include "print.fh"

if (icolorize == 1) then
  if (iCount == 0) then
    write(TMP,FRMT) STR,Val(1:iRank)
  else
    write(TMP,FRMT) STR,iCount,STR2,Val(1:iRank)
  end if
  if (TMP(1:3) == '   ') TMP = TMP(3:)
  write(iUnit,'(a,a)') Marker,trim(TMP)
else
  if (iCount == 0) then
    write(iUnit,FRMT) STR,Val(1:iRank)
  else
    write(iUnit,FRMT) STR,iCount,STR2,Val(1:iRank)
  end if
end if

return

end subroutine PrintResult

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Bjorn O. Roos                                    *
*               1989, Per Ake Malmqvist                                *
*               1991, Jeppe Olsen                                      *
*               1991,1996, Markus P. Fuelscher                         *
*               2000, Thorstein Thorsteinsson                          *
************************************************************************
      Subroutine DavCtl(LW1, TUVX, IFINAL)
************************************************************************
*                                                                      *
*     CI control section                                               *
*                                                                      *
*     calling arguments:                                               *
*     LW1     : active Fock matrix                                     *
*               array of real*8                                        *
*     TUVX    : array of real*8                                        *
*               two-electron integrals (tu!vx)                         *
*     IFINAL  : integer                                                *
*               termination flag                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     B.O. Roos and P.Aa. Malmqvist                                    *
*     University of Lund, Sweden, 1989                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     - updated to use determinant based CI-procedures                 *
*       J. Olsen and M.P. Fuelscher, University of Lund, Sweden, 1991  *
*     - updated for MOLCAS version 3                                   *
*       J. Olsen and M.P. Fuelscher, University of Lund, Sweden, 1991  *
*     - updated for integral direct and reaction field calculations    *
*       M.P. Fuelscher, University of Lund, Sweden, 1996               *
*     - various modifications                                          *
*       T. Thorsteinsson, University of Lund, Sweden, 2000             *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Real*8 LW1
      Dimension LW1(*), TUVX(*)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "ciinfo.fh"
#include "WrkSpc.fh"
#include "output_ras.fh"
#include "lucia_ini.fh"
      Parameter(ROUTINE='DAVCTL  ')
C
C -------------------------------------------------------------------- C
C -- INITIALIZE THE DAVIDSON DIAGONALIZATION
C -------------------------------------------------------------------- C
C
      lRoots=lRoots+hroots
      Call Ini_David(lRoots,nConf,nDet,nSel,n_keep,nAc,LuDavid)

      IPRLEV=IPRLOC(3)
C
C -------------------------------------------------------------------- C
C --  COMPUTE THE DIAGONAL ELEMENTS OF THE HAMILTONIAN
C -------------------------------------------------------------------- C
C
C     LW4: TEMPORARY CI VECTOR IN CSF BASIS
C
      IF (IPRLEV.GE.20) WRITE(6,1100) 'INI_DAVID'
      CALL GETMEM('CIVEC','ALLO','REAL',LW4,NCONF)
      IF (IPRLEV.GE.20) WRITE(6,1100) 'CIDIA',LW4
      IF (NAC. GT. 0)
     &       CALL CIDIA_CI_UTIL(NAC,NCONF,LSYM,WORK(LW4),LW1,TUVX,
     &                          LUDAVID)
C
C -------------------------------------------------------------------- C
C -- OBTAIN STARTING VECTORS
C -------------------------------------------------------------------- C
C
      mSel=nSel
      IF (NAC .NE. 0) THEN
         Call GetMem('iSel','Allo','Integer',lSel,mSel)
         Call GetMem('ExplE','Allo','Real',lExplE,mSel)
         Call GetMem('ExplV','Allo','Real',lExplV,mSel*mSel)
      ELSE
         lSel=1
         lExplE=1
         lExplV=1
      ENDIF
      nMaxSel=nConf
      If (N_ELIMINATED_GAS_MOLCAS.gt.0) nmaxSel=nCSF_HEXS

      IF (IPRLEV.GE.20 .AND. NAC .NE. 0)
     &        WRITE(6,1100) 'CSTART',LW4,lSel,lExplE,lExplV
      Call CStart_CI_Util(WORK(LW4),LW1,TUVX,
     &     iWork(lSel),Work(lExplE),Work(lExplV),nMaxSel,IFINAL)

      CALL GETMEM('CIVEC','FREE','REAL',LW4,NCONF)
C
C -------------------------------------------------------------------- C
C -- DIAGONALIZATION SECTION
C -------------------------------------------------------------------- C

* PAM Jun 2006: Gradual lowering of threshold in first 3 iterations
*      If ( Iter.gt.1 ) Threshold=THFACT*ABS(CONV(4,ITER-1))
C Energy threshold for CI convergence criterion:
      If ( Iter.eq.1 ) THEN
        Threshold=THREN
      ELSE IF (ITER.gt.1 .and. ITER.le.3) THEN
        ThrRule=THFACT*ABS(CONV(4,ITER-1))
        Threshold=(DBLE(4-ITER)*THREN + DBLE(ITER)*ThrRule)*0.25D0
      ELSE
        Threshold=THFACT*ABS(CONV(4,ITER-1))
      END IF
* End of new rule, PAM Jun 2006
      Threshold=Max(Threshold,1.0D-9)
      If(NAC.eq.0) then
        ESize=ABS(EMY)
      else
        ESize=ABS(Work(lExplE))
      end if
      Threshold=Max(Threshold,ESize*1.0D-14)

C     LW5: CONVERGENCE PARAMETERS
      Call GetMem('CI_conv','Allo','Real',LW5,2*lRoots*MAXJT)
      IF (IPRLEV.GE.20 .AND. NAC .NE. 0)
     &        WRITE(6,1100) 'DAVID',LW5,lSel,lExplE,lExplV
      ITERCI=1
      If ( NAC.eq.0 ) then
        ENER(1,ITER)=EMY
      Else
        If (( nSel.eq.nConf ).or.
     &     (N_ELIMINATED_GAS_MOLCAS.gt.0.and.nSel.eq.nCSF_HEXS)) then
          Do jRoot = 1,lRoots-hRoots
            ENER(jRoot,ITER) = Work(lExplE+jRoot-1)
          End Do
        Else
* PAM Jun 2006: Limit the number of CI iterations in the
* first few macroiterations:
          If(KTIGHT.eq.0) ItLimit=min(12*ITER,MAXJT)
          If(KTIGHT.eq.1) ItLimit=MAXJT
* PAM Oct 2006: Full precision if this is final CI.
          IF (ICIONLY.eq.1 .or. IFINAL.eq.2) THEN
            Threshold=Max(1.0D-9,ESize*1.0D-14)
            ITLIMIT=MAXJT
          END IF
* PAM Feb 2009: New code in david5.
*           Call David5(nAc,lSym,nDet,MAXJT,ITERCI,
*          Call David5(nAc,lSym,nDet,ItLimit,ITERCI,
*     &      Work(LW5),Threshold,LW1, TUVX,
*     &      iWork(lSel),Work(lExplE),Work(lExplV))
*
           Call David5(nDet,ItLimit,IterCI,Work(LW5),Threshold,
     &                 iWork(lSel),Work(lExplE),Work(lExplV),
     &                 LW1,TUVX)

          Do jRoot = 1,lRoots-hRoots
            ENER(jRoot,ITER) = Work(LW5+2*(jRoot-1)+
     &        2*(ITERCI-1)*lRoots)
          End Do
        End If
      End If
      Call GetMem('CI_conv','Free','Real',LW5,2*lRoots*MAXJT)
      IF (NAC .NE. 0) THEN
         Call GetMem('ExplV','Free','Real',lExplV,mSel*mSel)
         Call GetMem('ExplE','Free','Real',lExplE,mSel)
         Call GetMem('iSel','Free','Integer',lSel,mSel)
      ENDIF
      nSel = mSel
      lRoots=lRoots-hroots
*
C
C -------------------------------------------------------------------- C
C -- CLEANUP AFTER THE DAVIDSON DIAGONALIZATION
C -------------------------------------------------------------------- C
C
C     LW4: TEMPORARY CI VECTOR IN CSF BASIS
C
      CALL GETMEM('CIVEC','ALLO','REAL',LW4,NCONF)
      IF (IPRLEV.GE.20) WRITE(6,1100) 'TERM_DAVID',LW4
      iDisk = IADR15(4)
      Call Term_David(ICICH,ITERCI,lRoots,nConf,Work(LW4),
     &                JOBIPH,LuDavid,iDisk)
      CALL GETMEM('CIVEC','FREE','REAL',LW4,NCONF)


      Return

1100  FORMAT(1X,/,1X,'WORK SPACE VARIABLES IN SUBR. CICTL: ',/,
     &       1X,'SUBSECTION: ',A,/,(1X,12I10,/))
      End
      Subroutine Ini_David(nRoots,nConf,nDet,nSel,n_keep,ntAsh,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Prepare address tables for further use by the Davidson           *
*     diagonalization scheme which is written in such a way that       *
*     the mechanism by which I/O is done is hidden in the subroutines  *
*     call load_xxx and save_xxx, where xxx stands may be one of       *
*     the following choices: H_diag, CI_vec, Sig_vec or Tmp_vec.       *
*     If possible (there is enough memory) a write through cache       *
*     mechanism is applied, that is to say all accessible memory is    *
*     used as a RAM-disk and dumped to physical disk in a FIFO mode.   *
*                                                                      *
*     calling arguments:                                               *
*     lRoots  : integer                                                *
*               number of roots to be optimized                        *
*     nConf   : integer                                                *
*               length of the CI vector in the CSF basis               *
*     nDet    : integer                                                *
*               length of the CI vector in the determinant basis       *
*     ntAsh   : integer                                                *
*               total number of active orbitals                        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)


#include "rasdim.fh"
#include "warnings.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "rasscf_lucia.fh"

      Character*8 Label


*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Ini_David: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( nRoots.lt.0 ) then
         Write(6,*) 'Ini_David: nRoots less than zero'
         Write(6,*) 'nRoots = ',nRoots
         Call Abend
      Endif
      If ( nRoots.gt.mxRoot ) then
         Write(6,*) 'Ini_David: nRoots greater than mxRoot'
         Write(6,*) 'nRoots, mxRoot = ',nRoots, mxRoot
         Call Abend
      Endif
      If ( nDet.lt.0 ) then
         Write(6,*) 'Ini_David: nDet less than zero'
         Write(6,*) 'nDet = ',nDet
         Call Abend
      Endif
      If ( ntAsh.lt.0 ) then
         Write(6,*) 'Ini_David: ntAsh less than 0'
         Write(6,*) 'ntAsh = ',ntAsh
         Call Abend
      Endif
      If ( ntAsh.gt.mxAct ) then
         Write(6,*) 'Ini_David: ntAsh greater than mxAct'
         Write(6,*) 'ntAsh, mxAct = ',ntAsh, mxAct
         Call Abend
      Endif
      n_Roots=nRoots
      nkeep=n_keep
*     If unitialized, determine a reasonable nkeep
      If (nkeep.eq.0) then
        nkeep=mxKeep*nRoots
        nkeep=min(nkeep,400)
        nkeep=max(nkeep,3*nRoots)
        nkeep=min(nkeep,mxkeep)
      else if (nkeep.gt.mxkeep) Then
        Call WarningMessage(2,'nkeep .gt. mxkeep. Reduce nkeep'//
     &      ' or increase mxkeep in src/Include/davctl.fh')
        Call Quit(_RC_INPUT_ERROR_)
      EndIf
*
      istart=0
      nvec=nkeep

*     check the amount of available memory and decide which algorithm
*     is to be used to save intermediate results
      MxMemStk  = 0
      MxDiskStk = 0
      Call GetMem(' ','Max ','Real',Max_free_Mem,Max_free_Mem)
      Max_free_Mem = Max_free_Mem - 3*(nDet+4)
      Max_free_Mem = Max_free_Mem - 3*(nConf+4)
      Max_free_Mem = Max_free_Mem - 2*(ntAsh**3+4)
      Max_free_Mem = Max_free_Mem - 5*(ntAsh**2+4)
      Max_used_Mem = (1 + 2*nKeep+2*nRoots)*(nConf+4)
* Calculate how much memory is needed in the rest of the Davidson
      Memory_Needed = 0
      If (ntAsh .EQ. 0) Then
         Memory_Needed = 0
      Else If (nSel .EQ. nConf) Then
         Memory_Needed = 2*nSel + nSel*nSel
      Else
* First: davctl
         Memory_Needed = 2*nSel + nSel*nSel
* Now: david5
         lTmp1 = nKeep
         lTmp2 = lTmp1*lTmp1
         lTmp3 = (lTmp2+lTmp1)/2
         Memory_Needed = Memory_Needed + 5*nDet + lTmp1 +
     &                   3*lTmp2 + 2*lTmp3 + 3*nRoots*nSel
* Then: lucia_util
         Memory_Needed = Memory_Needed + Memory_Needed_Lucia
      End If
*
      If ( Max_free_Mem.lt.(nConf+4+Memory_Needed) ) then
        MxMemStk  = 0
        MxDiskStk = 1 + 2*nkeep + 2*nRoots
        save_mode = on_disk
      Else If ( Max_free_Mem.ge.Max_used_Mem + Memory_Needed ) then
        MxMemStk  = 1 + 2*nkeep + 2*nRoots
        MxDiskStk = 0
        save_mode = in_core
      Else
        MxMemStk  = Max_free_Mem/(nConf+4+Memory_Needed)
        MxDiskStk = 1 + 2*nkeep + 2*nRoots - mxMemStk
        save_mode = mixed_mode_2
        If ( mxMemStk.lt.(nkeep+1) ) save_mode = mixed_mode_1
      End If
CFUE  Call GetMem(' ','nFld',' ',nMemStk,nMemStk)
CFUE  nMemStk = nMemStk - 30
CFUE  If ( MxMemStk.gt.nMemStk ) then
CFUE    MxMemStk  = nMemStk
CFUE    MxDiskStk = 1 + 2*mxKeep*nRoots + 2*nRoots - mxMemStk
CFUE    save_mode = mixed_mode_2
CFUE    If ( mxMemStk.lt.(mxKeep*nRoots+1) ) save_mode = mixed_mode_1
CFUE  End If
      nMemStk = 0
      nDiskStk = 0

*     the diagonalization can be run in core:
*     allocate memory for all vectors that will be needed
      If ( save_mode.eq.in_core ) then
        H_diag_RecNo = RecNo((1),(1))
        Write(Label,'(A,I3.3)') 'HvRcN',H_diag_RecNo
        Call GetMem(Label,'Allo','Real',iMem,nConf)
        memory_address(H_diag_RecNo) = iMem
        CI_vec_RecNo = 0
        Do iRoot = 1,nkeep
          CI_vec_RecNo = RecNo((2),iRoot)
          Write(Label,'(A,I3.3)') 'CvRcN',CI_vec_RecNo
          Call GetMem(Label,'Allo','Real',iMem,nConf)
          memory_address(CI_vec_RecNo) = iMem
        End Do
        Sig_vec_RecNo = 0
        Do iRoot = 1,nKeep
          Sig_vec_RecNo = RecNo((3),iRoot)
          Write(Label,'(A,I3.3)') 'SvRcN',Sig_vec_RecNo
          Call GetMem(Label,'Allo','Real',iMem,nConf)
          memory_address(Sig_vec_RecNo) = iMem
        End Do
        Do iRoot = 1,nRoots
          tmp_CI_vec_RecNo = RecNo((4),iRoot)
          Write(Label,'(A,I3.3)') 'TmpCv',iRoot
          Call GetMem(Label,'Allo','Real',iMem,nConf)
          memory_address(tmp_CI_vec_RecNo) = iMem
        End Do
        Do iRoot = 1,nRoots
          tmp_Sig_vec_RecNo = RecNo((5),iRoot)
          Write(Label,'(A,I3.3)') 'TmpSv',iRoot
          Call GetMem(Label,'Allo','Real',iMem,nConf)
          memory_address(tmp_Sig_vec_RecNo) = iMem
        End Do
      End If

*     the diagonalization must be run out of core:
*     allocate disk space for all vectors that will be needed
      If ( save_mode.eq.on_disk ) then
        iDisk  = 0
        H_diag_RecNo = RecNo((1),(1))
        disk_address(H_diag_RecNo) = iDisk
        Call DDafile(LuDavid,0,[0.0d0],nConf,iDisk)
        Do iRoot = 1,nkeep
          CI_vec_RecNo = RecNo((2),iRoot)
          disk_address(CI_vec_RecNo) = iDisk
          Call DDafile(LuDavid,0,[0.0d0],nConf,iDisk)
        End Do
        Do iRoot = 1,nKeep
          Sig_vec_RecNo = RecNo((3),iRoot)
          disk_address(Sig_vec_RecNo) = iDisk
          Call DDaFile(LuDavid,0,[0.0d0],nConf,iDisk)
        End Do
        Do iRoot = 1,nRoots
          tmp_CI_vec_RecNo = RecNo((4),iRoot)
          disk_address(tmp_CI_vec_RecNo) = iDisk
          Call DDaFile(LuDavid,0,[0.0d0],nConf,iDisk)
        End Do
        Do iRoot = 1,nRoots
          tmp_Sig_vec_RecNo = RecNo((5),iRoot)
          disk_address(tmp_Sig_vec_RecNo) = iDisk
          Call DDaFile(LuDavid,0,[0.0d0],nConf,iDisk)
        End Do
      End If

*     the diagonalization may be run in mixed mode:
*     allocate memory and disk space for all vectors that will be needed
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        Do nStk = 1,mxMemStk
          Write(Label,'(A,I4.4)') 'RAMD',nStk
          Call GetMem(Label,'Allo','Real',iMem,nConf)
          memory_address(nStk) = iMem
        End Do
        iDisk = 0
        Do nStk = 1,mxDiskStk
          disk_address(nStk) = iDisk
          Call DDaFile(LuDavid,0,[0.0d0],nConf,iDisk)
        End Do
        Do nStk = 1,(mxMemStk+mxDiskStk)
          LblStk(nStk) = '                '
        End Do
        save_in_memory = .true.
      End If


      Return
      End
      Subroutine Term_David(ICICH,iter,lRoots,nConf,Vector,
     &                      JOBIPH,LuDavid,iDisk)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Terminate the Davidson diagonalization                           *
*                                                                      *
*     calling arguments:                                               *
*     ICICH   : integer                                                *
*               switch enabling root selection                         *
*     JOBIPH  : integer                                                *
*               logical unit number of the JOBIPH file                 *
*     iDisk   : integer                                                *
*               disk address of the first CI vector on JOBIPH          *
*     iter    : integer                                                *
*               iteration count of the final result                    *
*     nConf   : integer                                                *
*               length of the CI vector in the CSF basis               *
*     Vector  : array of real*8                                        *
*               temporary vector of length nConf                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 Vector(nConf)


#include "rasdim.fh"
#include "davctl.fh"
#include "WrkSpc.fh"


*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Term_David: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( iter.lt.0 ) then
         Write(6,*) 'Term_David: iter less than 0'
         Write(6,*) 'iter = ',iter
         Call Abend
      Endif
      If ( iter.gt.mxCiIt ) then
         Write(6,*) 'Term_David: iter greater than mxCiIt'
         Write(6,*) 'iter, mxCiIt = ',iter, mxCiIt
         Call Abend
      Endif

*     Restore the final CI vectors and save them for further use.
*     If the root selectioning option has been enabled calculate
*     also the overlap elemtents with the test vectors
      If ( ICICH.eq.1 ) then
        Call GetMem('CIovlp1','Allo','Real',lOvlp1,lRoots*lRoots)
        Call dCopy_(lRoots*lRoots,[0.0d0], 0,Work(lOvlp1),(1))
        Call GetMem('CIovlp2','Allo','Real',lOvlp2,lRoots*lRoots)
        Call dCopy_(lRoots*lRoots,[0.0d0], 0,Work(lOvlp2),(1))
      End If
      Do iRoot = 1,lRoots
        Call Load_tmp_CI_vec(iRoot,nConf,Vector,LuDavid)
        Call DDaFile(JOBIPH,1,Vector,nConf,iDisk)
        If ( ICICH.eq.1 ) then
          Call CIovlp(iRoot,Work(lOvlp1),Work(lOvlp2),Vector)
        End if
      End Do

*     If the root selectioning option has been enabled
*     make a new choice of the current roots
      If ( ICICH.eq.1 ) then
        Call CIselect(Work(lOvlp1),Work(lOvlp2))
        Call GetMem('CIovlp2','Free','Real',lOvlp2,lRoots*lRoots)
        Call GetMem('CIovlp1','Free','Real',lOvlp1,lRoots*lRoots)
      End If

*     deallocate memory which was used as records of the RAM disk
      If ( save_mode.ne.on_disk ) then
        Do iRecNo = 1,MxMemStk
          iMem = memory_address(iRecNo)
          Call GetMem(' ','Free','Real',iMem,nConf)
        End Do
      End If


      Return
      End
      Subroutine Load_H_diag(nConf,H_diag,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Load the diagonal approximation of the CI Hamiltonian for        *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     H_diag  : array of real*8                                        *
*               diagonal approximation of the CI Hamiltonian           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 H_diag(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Load_H_diag: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy H_diag to new memory location
      If ( save_mode.eq.in_core ) then
        H_diag_RecNo = RecNo((1),(1))
        iMem = memory_address(H_diag_RecNo)
        Call dCopy_(nConf,Work(iMem),1,H_diag,1)
      End If

*     the diagonalization must be run out of core:
*     load H_diag from disk
      If ( save_mode.eq.on_disk ) then
        H_diag_RecNo = RecNo((1),(1))
        iDisk = disk_address(H_diag_RecNo)
        Call DDaFile(LuDavid,2,H_diag,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save H_diag
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        KeyWord = '                '
        Write(KeyWord,'(A)') 'H_diag'
        Call page_in(KeyWord,nConf,H_diag,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine Save_H_diag(nConf,H_diag,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Save the diagonal approximation of the CI Hamiltonian for        *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     H_diag  : array of real*8                                        *
*               diagonal approximation of the CI Hamiltonian           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 H_diag(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Save_H_diag: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy vector to new memory location
      If ( save_mode.eq.in_core ) then
        H_diag_RecNo = RecNo((1),(1))
        iMem = memory_address(H_diag_RecNo)
        Call dCopy_(nConf,H_diag,1,Work(iMem),1)
      End If

*     the diagonalization must be run out of core:
*     save H_diag on disk
      If ( save_mode.eq.on_disk ) then
        H_diag_RecNo = RecNo((1),(1))
        iDisk = disk_address(H_diag_RecNo)
        Call DDaFile(LuDavid,1,H_diag,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save H_diag
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        KeyWord = '                '
        Write(KeyWord,'(A)') 'H_diag'
        Call page_out(KeyWord,nConf,H_diag,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine Load_CI_vec(iRoot,nConf,CI_vec,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Load a CI vector                                                 *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     iRoot   : integer                                                *
*               root number                                            *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     CI_vec  : array of real*8                                        *
*               CI vector                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 CI_vec(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Load_CI_vec: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( iRoot.lt.0 ) then
         Write(6,*) 'Load_CI_vec: iRoot less than 0'
         Write(6,*) 'iRoot = ',iRoot
         Call Abend
      Endif
      If ( iRoot.gt.nkeep ) then
         Write(6,*) 'Load_CI_vec: iRoot greater than nkeep'
         Write(6,*) 'iRoot, nkeep = ',iRoot, nkeep
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy the CI vector to new memory location
      If ( save_mode.eq.in_core ) then
        CI_vec_RecNo = RecNo((2),iRoot)
        iMem = memory_address(CI_vec_RecNo)
        Call dCopy_(nConf,Work(iMem),1,CI_vec,1)
      End If

*     the diagonalization must be run out of core:
*     load the CI vector from disk
      If ( save_mode.eq.on_disk ) then
        CI_vec_RecNo = RecNo((2),iRoot)
        iDisk = disk_address(CI_vec_RecNo)
        Call DDaFile(LuDavid,2,CI_vec,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save
*     the CI vector
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        CI_vec_PageNo = PageNo(iRoot)
        KeyWord = '                '
        Write(KeyWord,'(A,I4.4)') 'CI_vec',CI_vec_PageNo
        Call page_in(KeyWord,nConf,CI_vec,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine Save_CI_vec(iRoot,nConf,CI_vec,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Save a CI vector                                                 *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     iRoot   : integer                                                *
*               root number                                            *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     CI_vec  : array of real*8                                        *
*               CI vector                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 CI_vec(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Save_CI_vec: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( iRoot.lt.0 ) then
         Write(6,*) 'Save_CI_vec: iRoot less than 0'
         Write(6,*) 'iRoot = ',iRoot
         Call Abend
      Endif
      If ( iRoot.gt.nkeep ) then
         Write(6,*) 'Save_CI_vec: iRoot greater than nkeep'
         Write(6,*) 'iRoot, nkeep = ',iRoot, nkeep
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy the CI vector to new memory location
      If ( save_mode.eq.in_core ) then
        CI_vec_RecNo = RecNo((2),iRoot)
        iMem = memory_address(CI_vec_RecNo)
        Call dCopy_(nConf,CI_vec,1,Work(iMem),1)
      End If

*     the diagonalization must be run out of core:
*     save the CI vector on disk
      If ( save_mode.eq.on_disk ) then
        CI_vec_RecNo = RecNo((2),iRoot)
        iDisk = disk_address(CI_vec_RecNo)
        Call DDaFile(LuDavid,1,CI_vec,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save
*     the CI vector
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        CI_vec_PageNo = PageNo(iRoot)
        KeyWord = '                '
        Write(KeyWord,'(A,I4.4)') 'CI_vec',CI_vec_PageNo
        Call page_out(KeyWord,nConf,CI_vec,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine Load_Sig_vec(iRoot,nConf,Sig_vec,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Load a sigma vector                                              *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     iRoot   : integer                                                *
*               root number                                            *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     Sig_vec : array of real*8                                        *
*               sigma vector                                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 Sig_vec(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Load_Sig_vec: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( iRoot.lt.0 ) then
         Write(6,*) 'Load_Sig_vec: iRoot less than 0'
         Write(6,*) 'iRoot = ',iRoot
         Call Abend
      Endif
      If ( iRoot.gt.nkeep ) then
         Write(6,*) 'Load_Sig_vec: iRoot greater than nkeep'
         Write(6,*) 'iRoot, nkeep = ',iRoot, nkeep
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy the sigma vector to new memory location
      If ( save_mode.eq.in_core ) then
        Sig_vec_RecNo = RecNo((3),iRoot)
        iMem = memory_address(Sig_vec_RecNo)
        Call dCopy_(nConf,Work(iMem),1,Sig_vec,1)
      End If

*     the diagonalization must be run out of core:
*     load the sigma vector from disk
      If ( save_mode.eq.on_disk ) then
        Sig_vec_RecNo = RecNo((3),iRoot)
        iDisk = disk_address(Sig_vec_RecNo)
        Call DDaFile(LuDavid,2,Sig_vec,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save
*     the sigma vector
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        Sig_vec_PageNo = PageNo(iRoot)
        KeyWord = '                '
        Write(KeyWord,'(A,I4.4)') 'Sig_vec',Sig_vec_PageNo
        Call page_in(KeyWord,nConf,Sig_vec,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine Save_Sig_vec(iRoot,nConf,Sig_vec,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Save a sigma vector                                              *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     iRoot   : integer                                                *
*               root number                                            *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     Sig_vec : array of real*8                                        *
*               sigma vector                                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 Sig_vec(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Save_Sig_vec: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( iRoot.lt.0 ) then
         Write(6,*) 'Save_Sig_vec: iRoot less than 0'
         Write(6,*) 'iRoot = ',iRoot
         Call Abend
      Endif
      If ( iRoot.gt.nkeep ) then
         Write(6,*) 'Save_Sig_vec: iRoot greater than nkeep'
         Write(6,*) 'iRoot, nkeep = ',iRoot, nkeep
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy the sigma vector to new memory location
      If ( save_mode.eq.in_core ) then
        Sig_vec_RecNo = RecNo((3),iRoot)
        iMem = memory_address(Sig_vec_RecNo)
        Call dCopy_(nConf,Sig_vec,1,Work(iMem),1)
      End If

*     the diagonalization must be run out of core:
*     save the sigma vector on disk
      If ( save_mode.eq.on_disk ) then
        Sig_vec_RecNo = RecNo((3),iRoot)
        iDisk = disk_address(Sig_vec_RecNo)
        Call DDaFile(LuDavid,1,Sig_vec,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save
*     the sigma vector
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        Sig_vec_PageNo = PageNo(iRoot)
        KeyWord = '                '
        Write(KeyWord,'(A,I4.4)') 'Sig_vec',Sig_vec_PageNo
        Call page_out(KeyWord,nConf,Sig_vec,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine Load_tmp_CI_vec(iRoot,nConf,CI_vec,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Load a temporary CI vector                                       *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     iRoot   : integer                                                *
*               root number                                            *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     CI_vec  : array of real*8                                        *
*               CI vector                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 CI_vec(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Load_tmp_CI_vec: nConf less than'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( iRoot.lt.0 ) then
         Write(6,*) 'Load_tmp_CI_vec: iRoot less than 0'
         Write(6,*) 'iRoot = ',iRoot
         Call Abend
      Endif
      If ( iRoot.gt.n_Roots ) then
         Write(6,*) 'Load_tmp_CI_vec: iRoot greater than nRoots'
         Write(6,*) 'iRoot, nRoots = ',iRoot, n_Roots
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy the CI vector to new memory location
      If ( save_mode.eq.in_core ) then
        tmp_CI_vec_RecNo = RecNo((4),iRoot)
        iMem = memory_address(tmp_CI_vec_RecNo)
        Call dCopy_(nConf,Work(iMem),1,CI_vec,1)
      End If

*     the diagonalization must be run out of core:
*     load the CI vector from disk
      If ( save_mode.eq.on_disk ) then
        tmp_CI_vec_RecNo = RecNo((4),iRoot)
        iDisk = disk_address(tmp_CI_vec_RecNo)
        Call DDaFile(LuDavid,2,CI_vec,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save
*     the CI vector
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        KeyWord = '                '
        Write(KeyWord,'(A,I4.4)') 'tmp_CI_vec',iRoot
        Call page_in(KeyWord,nConf,CI_vec,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine Save_tmp_CI_vec(iRoot,nConf,CI_vec,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Save a temporary CI vector                                       *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     iRoot   : integer                                                *
*               root number                                            *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     CI_vec  : array of real*8                                        *
*               CI vector                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 CI_vec(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Save_tmp_CI_vec: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( iRoot.lt.0 ) then
         Write(6,*) 'Save_tmp_CI_vec: iRoot less than 0'
         Write(6,*) 'iRoot = ',iRoot
         Call Abend
      Endif
      If ( iRoot.gt.n_Roots ) then
         Write(6,*) 'Save_tmp_CI_vec: iRoot greater than nRoots'
         Write(6,*) 'iRoot, nRoots = ',iRoot, n_Roots
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy the CI vector to new memory location
      If ( save_mode.eq.in_core ) then
        tmp_CI_vec_RecNo = RecNo((4),iRoot)
        iMem = memory_address(tmp_CI_vec_RecNo)
        Call dCopy_(nConf,CI_vec,1,Work(iMem),1)
      End If

*     the diagonalization must be run out of core:
*     save the CI vector on disk
      If ( save_mode.eq.on_disk ) then
        tmp_CI_vec_RecNo = RecNo((4),iRoot)
        iDisk = disk_address(tmp_CI_vec_RecNo)
        Call DDaFile(LuDavid,1,CI_vec,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save
*     the CI vector
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        KeyWord = '                '
        Write(KeyWord,'(A,I4.4)') 'tmp_CI_vec',iRoot
        Call page_out(KeyWord,nConf,CI_vec,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine Load_tmp_Sig_vec(iRoot,nConf,Sig_vec,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Load a temporary sigma vector                                    *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     iRoot   : integer                                                *
*               root number                                            *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     Sig_vec : array of real*8                                        *
*               sigma vector                                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 Sig_vec(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Load_tmp_Sig_vec: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( iRoot.lt.0 ) then
         Write(6,*) 'Load_tmp_Sig_vec: iRoot less than 0'
         Write(6,*) 'iRoot = ',iRoot
         Call Abend
      Endif
      If ( iRoot.gt.n_Roots ) then
         Write(6,*) 'Load_tmp_Sig_vec: iRoot greater than nRoots'
         Write(6,*) 'iRoot = ',n_Roots
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy the sigma vector to new memory location
      If ( save_mode.eq.in_core ) then
        tmp_Sig_vec_RecNo = RecNo((5),iRoot)
        iMem = memory_address(tmp_Sig_vec_RecNo)
        Call dCopy_(nConf,Work(iMem),1,Sig_vec,1)
      End If

*     the diagonalization must be run out of core:
*     load the sigma vector from disk
      If ( save_mode.eq.on_disk ) then
        tmp_Sig_vec_RecNo = RecNo((5),iRoot)
        iDisk = disk_address(tmp_Sig_vec_RecNo)
        Call DDaFile(LuDavid,2,Sig_vec,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save
*     the sigma vector
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        KeyWord = '                '
        Write(KeyWord,'(A,I4.4)') 'tmp_Sig_vec',iRoot
        Call page_in(KeyWord,nConf,Sig_vec,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine Save_tmp_Sig_vec(iRoot,nConf,Sig_vec,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Save a temporary sigma vector                                    *
*     further use by the Davidson diagonalization scheme               *
*                                                                      *
*     calling arguments:                                               *
*     iRoot   : integer                                                *
*               root number                                            *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     Sig_vec : array of real*8                                        *
*               sigma vector                                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 Sig_vec(nConf)


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"

      Character*16 KeyWord

      Call Timing(WTC_1,Swatch,Swatch,Swatch)

*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'Save_tmp_Sig_vec: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif
      If ( iRoot.lt.0 ) then
         Write(6,*) 'Save_tmp_Sig_vec: iRoot less than 0'
         Write(6,*) 'iRoot = ',iRoot
         Call Abend
      Endif
      If ( iRoot.gt.n_Roots ) then
         Write(6,*) 'Save_tmp_Sig_vec: iRoot greater than nRoots'
         Write(6,*) 'iRoot, nRoots = ',iRoot, n_Roots
         Call Abend
      Endif

*     the diagonalization can be run in core:
*     copy the sigma vector to new memory location
      If ( save_mode.eq.in_core ) then
        tmp_Sig_vec_RecNo = RecNo((5),iRoot)
        iMem = memory_address(tmp_Sig_vec_RecNo)
        Call dCopy_(nConf,Sig_vec,1,Work(iMem),1)
      End If

*     the diagonalization must be run out of core:
*     save the sigma vector on disk
      If ( save_mode.eq.on_disk ) then
        tmp_Sig_vec_RecNo = RecNo((5),iRoot)
        iDisk = disk_address(tmp_Sig_vec_RecNo)
        Call DDaFile(LuDavid,1,Sig_vec,nConf,iDisk)
      End If

*     the diagonalization may be run in mixed mode:
*     use the write through cache mechanism to load and save
*     the sigma vector
      If ( save_mode.eq.mixed_mode_1 .or.
     &     save_mode.eq.mixed_mode_2      ) then
        KeyWord = '                '
        Write(KeyWord,'(A,I4.4)') 'tmp_Sig_vec',iRoot
        Call page_out(KeyWord,nConf,Sig_vec,LuDavid)
      End If

      Call Timing(WTC_2,Swatch,Swatch,Swatch)
      WTC_2 = WTC_2 - WTC_1
      WTC_3 = WTC_3 + WTC_2

      Return
      End
      Subroutine page_out(KeyWord,nConf,Vector,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Save any vector for further use by the Davidson diagonalization  *
*     Labels identifying the vectors are kept in a stack and to        *
*     minimize a write through cache strategy is applied               *
*                                                                      *
*     calling arguments:                                               *
*     KeyWord : character*16                                           *
*               record identifier                                      *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     Vector  : array of real*8                                        *
*               any vector of length nConf                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 Vector(nConf)
      Character*16 KeyWord


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"


*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'page_out: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif

*     serach for a matching record identifier
      nStk = 0
      Do iStk = 1,(mxMemStk+mxDiskStk)
        If ( LblStk(iStk).eq.KeyWord ) nStk = iStk
      End Do

*     there is a matching record identifier:
*     overwrite the current record
      If ( nStk.ne.0 ) then
        If ( nStk.le.mxMemStk ) then
          iMem = memory_address(nStk)
          Call dCopy_(nConf,Vector,1,Work(iMem),1)
        Else
          iDisk = disk_address(nStk-mxMemStk)
          Call DDaFile(LuDavid,1,Vector,nConf,iDisk)
        End If
      End if

*     there is no matching record identifier:
*     create a new record
      If ( nStk.eq.0 ) then
        If ( save_mode.eq.mixed_mode_1 ) then
          If ( KeyWord(1:6).eq.'CI_vec' ) then
            If ( save_in_memory ) then
              nMemStk = nMemStk + 1
              iMem = memory_address(nMemStk)
              Call dCopy_(nConf,Vector,1,Work(iMem),1)
              LblStk(nMemStk) = KeyWord
              if ( nMemStk.eq.mxMemStk ) save_in_memory = .false.
            Else
              nMemStk = nMemStk + 1
              If ( nMemStk.gt.mxMemStk ) nMemStk = 1
              iMem = memory_address(nMemStk)
              nDiskStk = nDiskStk + 1
              If ( nDiskStk.gt.mxDiskStk ) nDiskStk = 1
              iDisk = disk_address(nDiskStk)
              Call DDaFile(LuDavid,1,Work(iMem),nConf,iDisk)
              Call dCopy_(nConf,Vector,1,Work(iMem),1)
              LblStk(mxMemStk+nDiskStk) = LblStk(nMemStk)
              LblStk(nMemStk) = KeyWord
            End If
          Else
            nDiskStk = nDiskStk + 1
            If ( nDiskStk.gt.mxDiskStk ) nDiskStk = 1
            iDisk = disk_address(nDiskStk)
            Call DDaFile(LuDavid,1,Vector,nConf,iDisk)
            LblStk(mxMemStk+nDiskStk) = KeyWord
          End If
        End If
        If ( save_mode.eq.mixed_mode_2 ) then
          If ( save_in_memory ) then
            nMemStk = nMemStk + 1
            iMem = memory_address(nMemStk)
            Call dCopy_(nConf,Vector,1,Work(iMem),1)
            LblStk(nMemStk) = KeyWord
            If ( nMemStk.eq.mxMemStk ) save_in_memory = .false.
          Else
            nMemStk = nMemStk + 1
            If ( nMemStk.gt.mxMemStk ) nMemStk = 1
            iMem = memory_address(nMemStk)
            nDiskStk = nDiskStk + 1
            If ( nDiskStk.gt.mxDiskStk ) nDiskStk = 1
            iDisk = disk_address(nDiskStk)
            Call DDaFile(LuDavid,1,Work(iMem),nConf,iDisk)
            Call dCopy_(nConf,Vector,1,Work(iMem),1)
            LblStk(mxMemStk+nDiskStk) = LblStk(nMemStk)
            LblStk(nMemStk) = KeyWord
          End if
        End If
      End if


      Return
      End
      Subroutine page_in(KeyWord,nConf,Vector,LuDavid)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Load any vector for further use by the Davidson diagonalization  *
*     which has been saved by the write through cache mechanism        *
*                                                                      *
*     calling arguments:                                               *
*     KeyWord : character*16                                           *
*               record identifier                                      *
*     nConf   : integer                                                *
*               length of the vector H_diag                            *
*     Vector  : array of real*8                                        *
*               any vector of length nConf                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Real*8 Vector(nConf)
      Character*16 KeyWord


#include "rasdim.fh"

#include "davctl.fh"
#include "WrkSpc.fh"


*     check input arguments
      If ( nConf.lt.0 ) then
         Write(6,*) 'page_in: nConf less than 0'
         Write(6,*) 'nConf = ',nConf
         Call Abend
      Endif

*     serach for a metching record identifier
      nStk = 0
      Do iStk = 1,(mxMemStk+mxDiskStk)
        If ( LblStk(iStk).eq.KeyWord ) nStk = iStk
      End Do
      If ( nStk.eq.0 ) then
         Write(6,*) 'page_in: nStk equal 0'
         Write(6,*) 'nStk = ',nStk
         Call Abend
      Endif

      If ( nStk.le.mxMemStk ) then
        iMem = memory_address(nStk)
        Call dCopy_(nConf,Work(iMem),1,Vector,1)
      Else
        iDisk = disk_address(nStk-mxMemStk)
        Call DDaFile(LuDavid,2,Vector,nConf,iDisk)
      End If


      Return
      End
      Integer Function PageNo(iRoot)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Compute the page number of a vector                              *
*                                                                      *
*     calling arguments:                                               *
*     iRoot   : integer                                                *
*               root number                                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)


#include "rasdim.fh"

#include "davctl.fh"

      itmp1 = iRoot
      If (iRoot.gt.n_Roots) then
        itmp1=n_Roots+mod(istart+iRoot-n_Roots-1,nvec-n_Roots)+1
      EndIf
      PageNo = itmp1

      Return
      End
      Integer Function RecNo(itype,iRoot)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Compute the Record number of a vector                            *
*                                                                      *
*     calling arguments:                                               *
*     itype   : integer                                                *
*               vector type: 1 = H_diag                                *
*                            2 = CI_vec                                *
*                            3 = Sig_vec                               *
*     iRoot   : integer                                                *
*               root number                                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)


#include "rasdim.fh"

#include "davctl.fh"

      RecNo = 0
      If ( itype.eq.1 ) then
        H_diag_RecNo = 1
        RecNo = H_diag_RecNo
      Else If ( itype.eq.2 ) then
        CI_vec_RecNo = 1+PageNo(iRoot)
        RecNo = CI_vec_RecNo
      Else If ( itype.eq.3 ) then
        Sig_vec_RecNo = 1+nkeep+PageNo(iRoot)
        RecNo = Sig_vec_RecNo
      Else If ( itype.eq.4 ) then
        tmp_CI_vec_RecNo = 1+2*nKeep+iRoot
        RecNo = tmp_CI_vec_RecNo
      Else If ( itype.eq.5 ) then
        tmp_Sig_vec_RecNo = 1+2*nKeep+n_Roots+iRoot
        RecNo = tmp_Sig_vec_RecNo
      Else
        Write(6,*) 'RecNo: itype does not match'
        Write(6,*) 'itype = ',itype
        Call Abend
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine Find_Distance(Ref,Point,Dir,Fact,Dist,nAtom,
     &                         BadConstraint)
      use Slapaf_Info, only: RefGeo
      use Slapaf_Parameters, only: MEP_Type
      Implicit None
#include "real.fh"
#include "stdalloc.fh"
      Integer, Intent(In) :: nAtom
      Real*8, Intent(In) :: Ref(3,nAtom),Dir(3,nAtom),Fact,Dist
      Real*8, Intent(Out) :: Point(3,nAtom)
      Logical, Intent(Out) :: BadConstraint
      Real*8, Allocatable :: OldRef(:,:),Dummy(:), Not_Allocated(:,:)
      Real*8 :: R,CurFact,PrevR,Correct
      Real*8, Parameter :: Thr = 1.0d-6
      Integer :: nCoor,i
      Real*8 rDum(1,1,1,1)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      Subroutine SphInt(xyz,nCent,OfRef,RR0,Bf,l_Write,Label,dBf,ldB)
      Integer nCent
      Real*8  xyz(3,nCent)
      Real*8, Allocatable, Target:: OfRef(:,:)
      Real*8  RR0
      Real*8  Bf(3,nCent)
      Logical l_Write
      Character(LEN=8) Label
      Real*8  dBf(3,nCent,3,nCent)
      Logical ldB
      End Subroutine SphInt
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      nCoor=3*nAtom
      Call mma_allocate(OldRef,3,nAtom,Label='OldRef')
      Call mma_allocate(Dummy,nCoor,Label='Dummy')
      OldRef(:,:) = RefGeo(:,:)
      RefGeo(:,:)    = Ref(:,:)

      R=Zero
      CurFact=Zero
      Correct=Fact
      i=0
      Do While (Abs(One-R/Dist).gt.Thr)

*       Add the scaled direction vector
        CurFact=CurFact+Correct
        Point(:,:) = Ref(:,:) + CurFact * Dir(:,:)

*       Align and measure distance
        PrevR=R
        Call Align(Point(:,:),Ref(:,:),nAtom)
        If (MEP_Type.eq.'SPHERE') Then
          Call SphInt(Point,nAtom,Not_Allocated,R,Dummy,
     &                .False.,'dummy   ',rDum,.False.)
        Else If (MEP_Type.eq.'TRANSVERSE') Then
          Call Transverse(Point,nAtom,R,Dummy,
     &                .False.,'dummy   ',rDum,.False.)
        End If

*       Stop if too many iterations or if the constraint is moving
*       in the wrong direction
        i=i+1
        If (i.gt.5.or.Correct*(R-PrevR).lt.Zero) Exit
        Correct=(One-R/Dist)*Fact
      End Do
      BadConstraint=(Abs(One-R/Dist).gt.Thr)

      RefGeo(:,:) = OldRef(:,:)
      Call mma_deallocate(OldRef)
      Call mma_deallocate(Dummy)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End Subroutine Find_Distance

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PickPoints(nPick,Pick,DPick,nEPP,EPCo,Coo,dLimmo,BS)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nEPP
integer(kind=iwp), intent(out) :: nPick, Pick(nEPP)
real(kind=wp), intent(out) :: DPick(nEPP)
real(kind=wp), intent(in) :: EPCo(3,nEPP), Coo(3), dLimmo(2), BS
integer(kind=iwp) :: iP
real(kind=wp) :: Distad, xtwo, ytwo, ztwo

nPick = 0
do iP=1,nEPP
  xtwo = (EPCo(1,iP)-Coo(1))**2
  ytwo = (EPCo(2,iP)-Coo(2))**2
  ztwo = (EPCo(3,iP)-Coo(3))**2
  Distad = sqrt(xtwo+ytwo+ztwo)
  if ((Distad < dLimmo(2)*BS) .and. (Distad > dLimmo(1)*BS)) then
    nPick = nPick+1
    Pick(nPick) = iP
    DPick(nPick) = Distad
  end if
end do

return

end subroutine PickPoints

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine P2Diff(mGrid,dF_dRho,ndF_dRho,Rho,nRho)
      Implicit Real*8 (A-H,O-Z)
      Dimension dF_dRho(ndF_dRho,mGrid)
      Dimension Rho(nRho,mGrid)
#include "nq_info.fh"
#include "real.fh"
#include "nq_index.fh"
      Real*8 MinDns
*
      MinDns=0.0001d0

      If (nRho.eq.2) Then
         Do iGrid=1,mGrid
            If (Abs(Rho(1,iGrid)-Rho(2,iGrid)).le.MinDns  .or.
     &         (Rho(1,iGrid)+Rho(2,iGrid))**2-
     &          4.0d0*Rho(1,iGrid)*Rho(2,iGrid).le. MinDns) Then
               dF_dRho(ipRa,iGrid) = 0.5d0*(dF_dRho(ipRa,iGrid) +
     &                                   dF_dRho(ipRb,iGrid))
               dF_dRho(ipRb,iGrid) = 0.0d0
            Else
               rab1 = 1.0d0/(Rho(1,iGrid)-Rho(2,iGrid))
               dFdRa = dF_dRho(ipRa,iGrid)
               dFdRb = dF_dRho(ipRb,iGrid)
               dF_dRho(ipRb,iGrid) = rab1* (dFdRb-dFdRa)
               dF_dRho(ipRa,iGrid) = rab1*
     &                              (Rho(1,iGrid)*dFdRa-
     &                              Rho(2,iGrid)*dFdRb)
            End If
         End Do   ! iGrid
      Else If (nRho.eq.8) Then


         Do iGrid=1,mGrid
            If(abs(Rho(1,iGrid)-Rho(2,iGrid)).le.MinDns.or.
     &        (Rho(1,iGrid)+Rho(2,iGrid))**2-
     &         4.0d0*Rho(1,iGrid)*Rho(2,iGrid).le.
     &         MinDns) Then
               dF_dRho_ = 0.5d0*(
     &              dF_dRho(ipRa,iGrid) + dF_dRho(ipRb,iGrid))
               dF_dRhox = 0.5d0*(
     &              dF_dRho(ipdRxa,iGrid) + dF_dRho(ipdRxb,iGrid))
               dF_dRhoy = 0.5d0*(
     &              dF_dRho(ipdRya,iGrid) + dF_dRho(ipdRyb,iGrid))
               dF_dRhoz = 0.5d0*(
     &              dF_dRho(ipdRza,iGrid) + dF_dRho(ipdRzb,iGrid))
*
               If (.True.) Then
               dF_dRho(ipRa,iGrid) = dF_dRho_
               dF_dRho(ipdRxa,iGrid) = dF_dRhox
               dF_dRho(ipdRya,iGrid) = dF_dRhoy
               dF_dRho(ipdRza,iGrid) = dF_dRhoz
               dF_dRho(ipRb,iGrid) = 0.0d0
               dF_dRho(ipdRxb,iGrid) = 0.0d0
               dF_dRho(ipdRyb,iGrid) = 0.0d0
               dF_dRho(ipdRzb,iGrid) = 0.0d0
               Else
               rho_tot=Rho(1,iGrid)+Rho(2,iGrid)
               dF_dRho(ipRa,iGrid) = 0.0d0
               dF_dRho(ipdRxa,iGrid) = 0.0d0
               dF_dRho(ipdRya,iGrid) = 0.0d0
               dF_dRho(ipdRza,iGrid) = 0.0d0
               dF_dRho(ipRb,iGrid) = 2.0d0*dF_dRho_/rho_tot -
     &         4.0d0*(Rho(3,iGrid)*dF_dRhox+
     &                Rho(4,iGrid)*dF_dRhoy+
     &                Rho(5,iGrid)*dF_dRhoz)/rho_tot/rho_tot
               dF_dRho(ipdRxb,iGrid) = 2.0d0*dF_dRhox/rho_tot
               dF_dRho(ipdRyb,iGrid) = 2.0d0*dF_dRhoy/rho_tot
               dF_dRho(ipdRzb,iGrid) = 2.0d0*dF_dRhoz/rho_tot
               End If

            Else
               rho_tot=Rho(1,iGrid)+Rho(2,iGrid)
               OnTop=Rho(1,iGrid)*Rho(2,iGrid)
               det=sqrt(rho_tot*rho_tot-4.0d0*OnTop)
               rho_x=Rho(3,iGrid)+Rho(6,iGrid)
               rho_y=Rho(4,iGrid)+Rho(7,iGrid)
               rho_z=Rho(5,iGrid)+Rho(8,iGrid)
               P2_x=Rho(3,iGrid)*Rho(2,iGrid)+
     &              Rho(1,iGrid)*Rho(6,iGrid)
               P2_y=Rho(4,iGrid)*Rho(2,iGrid)+
     &              Rho(1,iGrid)*Rho(7,iGrid)
               P2_z=Rho(5,iGrid)*Rho(2,iGrid)+
     &              Rho(1,iGrid)*Rho(8,iGrid)

      t0 = (1.D0/2.D0+rho_tot/det/2)*rho_x/det+(P2_x-(rho_tot/2+det/2)*
     &rho_x)*rho_tot/det**3
      t1 = (1.D0/2.D0+rho_tot/det/2)*rho_y/det+(P2_y-(rho_tot/2+det/2)*
     &rho_y)*rho_tot/det**3
      t2 = (1.D0/2.D0+rho_tot/det/2)*rho_z/det+(P2_z-(rho_tot/2+det/2)*
     &rho_z)*rho_tot/det**3
      t3 = (1.D0/2.D0+rho_tot/det/2)*rho_x/det+(P2_x-(rho_tot/2+det/2)*
     &rho_x)*rho_tot/det**3
      t4 = (1.D0/2.D0+rho_tot/det/2)*rho_y/det+(P2_y-(rho_tot/2+det/2)*
     &rho_y)*rho_tot/det**3
      t5 = (1.D0/2.D0+rho_tot/det/2)*rho_z/det+(P2_z-(rho_tot/2+det/2)*
     &rho_z)*rho_tot/det**3
      t6 = -rho_x/det**2-2*(P2_x-(rho_tot/2+det/2)*rho_x)/det**3
      t7 = -rho_y/det**2-2*(P2_y-(rho_tot/2+det/2)*rho_y)/det**3
      t8 = -rho_z/det**2-2*(P2_z-(rho_tot/2+det/2)*rho_z)/det**3
      t9 = rho_x/det**2+2*(P2_x-(rho_tot/2+det/2)*rho_x)/det**3
      t10 = rho_y/det**2+2*(P2_y-(rho_tot/2+det/2)*rho_y)/det**3
      t11 = rho_z/det**2+2*(P2_z-(rho_tot/2+det/2)*rho_z)/det**3
               rab1 = 1.0d0/(Rho(1,iGrid)-Rho(2,iGrid))
               dFdRa  = dF_dRho(ipRa,iGrid)
               dFdRb  = dF_dRho(ipRb,iGrid)
               dFdRax = dF_dRho(ipdRxa,iGrid)
               dFdRbx = dF_dRho(ipdRxb,iGrid)
               dFdRay = dF_dRho(ipdRya,iGrid)
               dFdRby = dF_dRho(ipdRyb,iGrid)
               dFdRaz = dF_dRho(ipdRza,iGrid)
               dFdRbz = dF_dRho(ipdRzb,iGrid)
      tmp3=dFdRax*t0+dFdRay*t1+dFdRaz*t2-
     &     dFdRbx*t3-dFdRby*t4-dFdRbz*t5
      tmp4=dFdRax*t6+dFdRay*t7+dFdRaz*t8+
     &     dFdRbx*t9+dFdRby*t10+dFdRbz*t11
*
              tmp1= (Rho(1,iGrid)*Rho(6,iGrid)-Rho(2,iGrid)*
     &                                Rho(3,iGrid))*(dFdRbx-dFdRax)+
     &              (Rho(1,iGrid)*Rho(7,iGrid)-Rho(2,iGrid)*
     &                                Rho(4,iGrid))*(dFdRby-dFdRay)+
     &              (Rho(1,iGrid)*Rho(8,iGrid)-Rho(2,iGrid)*
     &                                Rho(5,iGrid))*(dFdRbz-dFdRaz)
*
               tmp2= (Rho(6,iGrid)-Rho(3,iGrid))*(dFdRbx-dFdRax)+
     &               (Rho(7,iGrid)-Rho(4,iGrid))*(dFdRby-dFdRay)+
     &               (Rho(8,iGrid)-Rho(5,iGrid))*(dFdRbz-dFdRaz)
*
               dF_dRho(ipRa,iGrid) = rab1*
     &                             (Rho(1,iGrid)*dFdRa-
     &                              Rho(2,iGrid)*dFdRb)
     &                              -rab1*rab1*tmp1
               dF_dRho(ipdRxa,iGrid) = rab1*
     &                             (Rho(1,iGrid)*dFdRax-
     &                              Rho(2,iGrid)*dFdRbx)
               dF_dRho(ipdRya,iGrid) = rab1*
     &                             (Rho(1,iGrid)*dFdRay-
     &                              Rho(2,iGrid)*dFdRby)
               dF_dRho(ipdRza,iGrid) = rab1*
     &                             (Rho(1,iGrid)*dFdRaz-
     &                              Rho(2,iGrid)*dFdRbz)
*
               dF_dRho(ipRb,iGrid) = rab1*
     &                             (dFdRb-dFdRa) +
     &                              rab1*rab1*tmp2
c     &                              tmp4
               dF_dRho(ipdRxb,iGrid) = rab1*
     &                             (dFdRbx-dFdRax)
               dF_dRho(ipdRyb,iGrid) = rab1*
     &                             (dFdRby-dFdRay)
               dF_dRho(ipdRzb,iGrid) = rab1*
     &                             (dFdRbz-dFdRaz)
            End If
         End Do   ! iGrid

      Else
         Call WarningMessage(2,'P2Diff: Error')
         Write(6,*) 'nRho=',nRho
         Call Abend()
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1996,1998, Markus P. Fuelscher                    *
*               1993, Per Ake Malmqvist                                *
*               1998, Roland Lindh                                     *
************************************************************************
      Subroutine SORT3(MaxDax)
************************************************************************
*                                                                      *
*     Purpose: Up to this point the two electron integral file         *
*              has been used like a random stack of records. To        *
*              save hunting for records when reading the records       *
*              bring them into sequential order.                       *
*                                                                      *
*     Called from: Seward_main                                         *
*                                                                      *
*     Calls to : DaFile,DCopy,MkOrd,ClsOrd,ErrOrd                      *
*                                                                      *
*     Calling parameters:                                              *
*     MaxDax  : Higest disk adress of the final 2el integral file      *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDef  : definitions of the record structure                    *
*     TwoDat  : definitions of sorting flags and address tables        *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*     Srt1    : common block containing information the number of      *
*               bins and partitioning of symmetry blocks               *
*     Srt2    : common block containing information pertinent to       *
*               the bin sorting algorithm                              *
*                                                                      *
*     local data declarations:                                         *
*     Buf1   : I/O buffer contains packed integral values              *
*     Buf2   : I/O buffer contains packed integral values              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.-AA. Malmqvist                             *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*     - modified to use a virtual disk                                 *
*       M. P. Fuelscher, University of Lund, Sweden, 1996              *
*     - modified to get rid of all disk address calculations           *
*       M. P. Fuelscher, University of Lund, Sweden, 1998              *
*     - modified to eliminate copy statement                           *
*       R. Lindh, University of Lund, Sweden, 1998                     *
*     - modified to eliminate free records                             *
*       R. Lindh, University of Lund, Sweden, 1998                     *
*                                                                      *
************************************************************************
*
      use srt2
      Implicit Real*8 (A-H,O-Z)
*
#include "Molcas.fh"
#include "TwoDat.fh"
#include "srt0.fh"
#include "srt1.fh"

#include "SysDef.fh"
#include "print.fh"
#include "stdalloc.fh"

      Dimension Buf(2*lStRec)
      Integer, Allocatable:: SrtKey(:), SrtAdr(:)

*
*----------------------------------------------------------------------*
*     pick up the print level                                          *
*----------------------------------------------------------------------*
*
#ifdef _DEBUGPRINT_
      iRout = 88
      iPrint = nPrint(iRout)
      If ( iPrint.gt.5 ) Write(6,*) ' >>> Enter SORT3 <<<'
#endif
*
*----------------------------------------------------------------------*
*     Turn timing ON                                                   *
*----------------------------------------------------------------------*
*
*
*----------------------------------------------------------------------*
*     Scan once the two-electron integral file a pick up the sort      *
*     key as well as disk addresses                                    *
*----------------------------------------------------------------------*
*
      Call mma_allocate(SrtKey,mxOrd,Label='SrtKey')
      Call mma_allocate(SrtAdr,mxOrd,Label='SrtAdr')
      iOpt = 2
      iDisk = iDaTw0
      MaxDax=0
      Do iOrd = 1,mxOrd
         SrtAdr(iOrd) = iDisk
         MaxDax=Max(iDisk,MaxDax)
         Call dDAFILE(LuTwo,iOpt,Buf,lStRec,iDisk)
         SrtKey(iOrd) = Int(Buf(2))
      End Do
      MaxDax=iDisk
#ifdef _DEBUGPRINT_
      If ( iPrint.ge.10 ) then
        Call iVcPrt('Sort keys',' ',SrtKey,mxOrd)
        Call iVcPrt('Disk addresses',' ',SRtAdr,mxOrd)
      End If
#endif
*
*----------------------------------------------------------------------*
*     Sort records in ascending order of the sort key                  *
*----------------------------------------------------------------------*
*
      iWr=1
      iRd=2
*
*---- Loop over all records
*
      Do i = 1,mxOrd
        j1 = i
        j2 = SrtKey(i)
        If ( j2.ne.i ) then
          iB1 = 1
          iB2 = lStRec+1
          iDisk = SrtAdr(j1)
          Call dDAFILE(LuTwo,iRd,Buf(iB1),lStRec,iDisk)
          Do while ( j2.ne.i )
            iDisk = SrtAdr(j2)
            Call dDAFILE(LuTwo,iRd,Buf(iB2),lStRec,iDisk)
            iDisk = SrtAdr(j2)
            Call dDAFILE(LuTwo,iWr,Buf(iB1),lStRec,iDisk)
            iTmp=iB2
            iB2 = iB1
            iB1 = iTmp
            j1 = j2
            j2 = SrtKey(j2)
            SrtKey(j1) = j1
          End Do
          iDisk = SrtAdr(j2)
          Call dDAFILE(LuTwo,iWr,Buf(iB1),lStRec,iDisk)
          SrtKey(j2) = j2
        End If
      End Do
#ifdef _DEBUGPRINT_
      If ( iPrint.ge.10 ) then
        Call iVcPrt('Sort keys',' ',SrtKey,mxOrd)
      End If
#endif
*
*----------------------------------------------------------------------*
*     Update the disk start adressed of each slice                     *
*----------------------------------------------------------------------*
*
      j = 1
      Do iBin=1,nBin
        iDVBin(2,iBin) = SrtAdr(j)
        j = j+nRec(iBin)
      End Do
      Call mma_deallocate(SrtKey)
      Call mma_deallocate(SrtAdr)
*
*----------------------------------------------------------------------*
*     Write the final table of content to disk                         *
*----------------------------------------------------------------------*
*
      Call MkOrd(iDummy)
*
*----------------------------------------------------------------------*
*     Close the ordered 2el integral file                              *
*----------------------------------------------------------------------*
*
      iRc=-1
      iOpt=0
      Call ClsOrd(iRc,iOpt)
      If ( iRc.ne.0 ) Then
         Write (6,*) 'SORT3: Error closing ORDINT'
         Call Abend()
      End If
      Call DaClos(LuTmp)
*
*----------------------------------------------------------------------*
*     Release RAMD                                                     *
*----------------------------------------------------------------------*
*
      If (RAMD) Call GetMem('RAMD','Free','Real',ip_RAMD,RAMD_Size)
*
*----------------------------------------------------------------------*
*     Turn timing OFF and exit                                         *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!               Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine UpdateB(Col,nOrb2Loc,Lbl,nComp,Gamma_rot,iMO_s,iMO_t,Debug)
! Author: T.B. Pedersen
!
! Purpose: update MO dipole matrices for Boys localisation.
!          (Almost exact copy of UpdateP by Y. Carissan.)

use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nOrb2Loc, nComp, iMO_s, iMO_t
real(kind=wp), intent(out) :: Col(nOrb2Loc,2)
real(kind=wp), intent(inout) :: Lbl(nOrb2Loc,nOrb2Loc,nComp)
real(kind=wp), intent(in) :: Gamma_rot
logical(kind=iwp), intent(in) :: Debug
integer(kind=iwp) :: iComp
real(kind=wp) :: cos2g, cosg, cosing, Dss, Dst, Dtt, sin2g, sing
character(len=18) :: Label
#ifdef _DEBUGPRINT_
real(kind=wp) :: Dts, Tst
#endif

cosg = cos(Gamma_rot)
sing = sin(Gamma_rot)
cos2g = cosg*cosg
sin2g = sing*sing
cosing = cosg*sing

do iComp=1,nComp

  Dss = Lbl(iMO_s,iMO_s,iComp)
  Dst = Lbl(iMO_s,iMO_t,iComp)
  Dtt = Lbl(iMO_t,iMO_t,iComp)
# ifdef _DEBUGPRINT_
  Dts = Lbl(iMO_t,iMO_s,iComp)
  Tst = Dst-Dts
  if (abs(Tst) > 1.0e-14_wp) then
    write(u6,*) 'Broken symmetry in UpdateB!!'
    write(u6,*) 'MOs s and t: ',iMO_s,iMO_t
    write(u6,*) 'Component  : ',iComp
    write(u6,*) 'Dst  = ',Dst
    write(u6,*) 'Dts  = ',Dts
    write(u6,*) 'Diff = ',Tst
    call SysAbendMsg('UpdateB','Broken symmetry!','[1]')
  end if
# endif

  Col(:,1) = Lbl(:,iMO_s,iComp)
  Col(:,2) = Lbl(:,iMO_t,iComp)

  Lbl(:,iMO_s,iComp) = cosg*Col(:,1)+sing*Col(:,2)
  Lbl(:,iMO_t,iComp) = cosg*Col(:,2)-sing*Col(:,1)

  Lbl(iMO_s,iMO_s,iComp) = Dss*cos2g+Dtt*sin2g+Two*Dst*cosing
  Lbl(iMO_t,iMO_s,iComp) = (Dtt-Dss)*cosing+Dst*(cos2g-sin2g)
  Lbl(iMO_s,iMO_t,iComp) = Lbl(iMO_t,iMO_s,iComp)
  Lbl(iMO_t,iMO_t,iComp) = Dtt*cos2g+Dss*sin2g-Two*Dst*cosing

  Lbl(iMO_s,:,iComp) = Lbl(:,iMO_s,iComp)
  Lbl(iMO_t,:,iComp) = Lbl(:,iMO_t,iComp)

# ifdef _DEBUGPRINT_
  Dst = Lbl(iMO_s,iMO_t,iComp)
  Dts = Lbl(iMO_t,iMO_s,iComp)
  Tst = Dst-Dts
  if (abs(Tst) > 1.0e-14_wp) then
    write(u6,*) 'Broken symmetry in UpdateB!!'
    write(u6,*) 'MOs s and t: ',iMO_s,iMO_t
    write(u6,*) 'Component  : ',iComp
    write(u6,*) 'Dst  = ',Dst
    write(u6,*) 'Dts  = ',Dts
    write(u6,*) 'Diff = ',Tst
    call SysAbendMsg('UpdateB','Broken symmetry!','[2]')
  end if
# endif

end do

if (Debug) then
  write(u6,*) 'In UpdateB'
  write(u6,*) '----------'
  do iComp=1,nComp
    write(Label,'(A,I2,A,I4)') 'MO Dip',iComp,'   col',iMO_s
    call RecPrt(Label,' ',Lbl(:,iMO_s,iComp),nOrb2Loc,1)
    write(Label,'(A,I2,A,I4)') 'MO Dip',iComp,'   col',iMO_t
    call RecPrt(Label,' ',Lbl(:,iMO_t,iComp),nOrb2Loc,1)
  end do
end if

end subroutine UpdateB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function up2date_cvb(chr)

use casvb_global, only: charobj, nobj, up2date
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp) :: up2date_cvb
character(len=*), intent(in) :: chr
integer(kind=iwp) :: i, iobj

iobj = 0
do i=1,nobj
  if (charobj(i) == chr) iobj = i
end do
if (iobj == 0) then
  write(u6,*) ' Make object not found :',chr
  call abend_cvb()
end if
up2date_cvb = up2date(iobj)

return

end function up2date_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_GetZ(irc,
     &                    NVT,l_NVT,
     &                    nBlock,l_nBlock,
     &                    nV,l_nV1,l_nV2,
     &                    iV1,l_iV11,l_iV12,
     &                    ip_Z,l_Z1,l_Z2,Z,l_Z)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: get the Z vectors in core.
C
C     Input:
C        NVT(i): total no. of vectors in symmetry i
C        nBlock(i): no. of vector blocks in symmetry i
C        nV(j,i): number of vectors in block j of symmetry i
C        iV1(j,i): first vector in block j of symmetry i
C        ip_Z(j,i): pointer to triangular block j of symmetry i
C                   (here, j is a compound index j=iTri(k,l) for
C                    block k,l)
C
C     On exit, the Z vector blocks are stored in memory according
C     to ip_Z.
C
      use ChoSwp, only: InfVec
      Implicit None
      Integer irc
      Integer l_NVT
      Integer l_nBlock
      Integer l_nV1, l_nV2
      Integer l_iV11, l_iV12
      Integer l_Z1, l_Z2, l_Z
      Integer NVT(l_NVT)
      Integer nBlock(l_nBlock)
      Integer nV(l_NV1,l_NV2)
      Integer iV1(l_IV11,l_iV12)
      Integer ip_Z(l_Z1,l_Z2)
      Real*8  Z(l_Z)
#include "cholesky.fh"
#include "stdalloc.fh"
#if defined(_DEBUGPRINT_)
#include "choprint.fh"
#endif

      Integer iSym
      Integer iLoc, iRedC, iRed
      Integer l_Wrk
      Integer idRS2RS, KK1, nVRead, mUsed, kOffV
      Integer KK, KKK, iJ
      Integer jBlock, kBlock
      Integer kOffZ
      Integer J_inBlock, K_inBlock

      Integer  Cho_iRange
      External Cho_iRange

      Character(LEN=8), Parameter:: SecNam='Cho_GetZ'

      Real*8 C0, C1, W0, W1

#if defined (_DEBUGPRINT_)
      Integer nBlock_Max, nnB, n
      Integer, Parameter:: myDebugInfo=100
      Real*8, Parameter:: Tol=1.0d-14
#endif

      Integer, Pointer:: InfVct(:,:,:)

      Integer i, j, k, iTri

      Integer, Allocatable:: iRS2RS(:)
      Real*8, Allocatable:: Wrk(:)

      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      Subroutine Cho_X_GetIP_InfVec(InfVcT)
      Integer, Pointer:: InfVct(:,:,:)
      End Subroutine Cho_X_GetIP_InfVec
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
C     Set return code.
C     ----------------

      irc = 0

#if defined (_DEBUGPRINT_)
      ! Check input variables
      If (l_NVT.lt.nSym .or. l_nBlock.lt.nSym .or.
     &    l_nV2.lt.nSym .or. l_iV12.lt.nSym .or.
     &    l_Z2.lt.nSym) Then
         irc=-1
         Return
      End If
      nBlock_Max=nBlock(1)
      Do iSym=2,nSym
         nBlock_Max=max(nBlock_Max,nBlock(iSym))
      End Do
      nnB=nBlock_Max*(nBlock_Max+1)/2
      If (l_nV1.lt.nBlock_Max .or. l_iV11.lt.nBlock_Max .or.
     &    l_Z1.lt.nnB) Then
         irc=-2
         Return
      End If
      If (iPrint.ge.myDebugInfo) Then
         Call Cho_Head('Entering '//SecNam//':','*',80,LuPri)
         Write(LuPri,'(A,8I6)') 'NVT   :',(NVT(iSym),iSym=1,nSym)
         Write(LuPri,'(A,8I6)') 'nBlock:',(nBlock(iSym),iSym=1,nSym)
      End If
      n=0
      Do iSym=1,nSym
         If (iPrint.ge.myDebugInfo) Then
            Do i=1,nBlock(iSym)
               Write(LuPri,'(2X,A,I6,A,I2,A,I6,A,I6)')
     &         'Block',i,' of sym.',iSym,': nV=',nV(i,iSym),
     &         ' iV1=',iV1(i,iSym)
            End Do
         End If
         Do j=1,nBlock(iSym)
            Do i=j,nBlock(iSym)
               If (i.eq.j) Then
                  k=nV(i,iSym)*(nV(i,iSym)+1)/2
               Else
                  k=nV(i,iSym)*nV(j,iSym)
               End If
               n=n+k
               If (iPrint.ge.myDebugInfo) Then
                  Write(Lupri,'(5X,A,I6,A,I6,A,I2,A,I9)')
     &            'iBlock',i,' jBlock',j,' of Sym.',iSym,': ip_Z=',
     &            ip_Z(iTri(i,j),iSym)
                  Write(LuPri,'(5X,A,I6,A,I9)')
     &            '--> Block dimension:',k,'  Block ends at:',
     &            ip_Z(iTri(i,j),iSym)+k-1
               End If
            End Do
         End Do
      End Do
      k=NVT(1)*(NVT(1)+1)/2
      Do iSym=2,nSym
         k=k+NVT(iSym)*(NVT(iSym)+1)/2
      End Do
      If (iPrint.ge.myDebugInfo) Then
         Write(Lupri,'(A,I8)') 'Total dimension of Z (from blocks):',n
         Write(Lupri,'(A,I8)') 'Total dimension of Z (from NVT)   :',k
         Write(Lupri,'(A,I8)') '                        Difference:',n-k
      End If
      If (n.ne.k) Then
         irc=-3
         If (iPrint.ge.myDebugInfo) Then
            Write(LuPri,'(A)') 'Ooops! They disagree....'
            Write(LuPri,'(A,I4)')
     &      'Returning with code:',irc
         End If
         Return
      End If
#endif

C     Zero result array.
C     ------------------

      Do iSym=1,nSym
         Do kBlock=1,nBlock(iSym)
            Call FZero(Z(ip_Z(iTri(kBlock,kBlock),iSym)),
     &                     nV(kBlock,iSym)*(nV(kBlock,iSym)+1)/2)
            Do jBlock=kBlock+1,nBlock(iSym)
               Call FZero(Z(ip_Z(iTri(jBlock,kBlock),iSym)),
     &                        nV(jBlock,iSym)*nV(kBlock,iSym))
            End Do
         End Do
      End Do

C     Scratch location in index arrays.
C     ---------------------------------

      iLoc=3 ! do NOT change (used implicitly by reading routine)

C     Get pointer to InfVec array for all vectors.
C     Needed for parallel runs.
C     --------------------------------------------

      Call Cho_X_GetIP_InfVec(InfVcT)

C     Copy rs1 to location 2.
C     -----------------------

      ! Note: location 2 must contain rs1 throughout this routine! It is
      ! an assumption which is never checked, so do NOT change this call
      ! or modify contents of location 2.
      Call Cho_X_RSCopy(irc,1,2)
      If (irc .ne. 0) Then
         Write(LuPri,'(A,A,I5)') SecNam,': Cho_X_RSCopy returned code',
     &                           irc
         irc = 1
         Go To 1 ! exit after deallocation
      End If

C     Get Z vectors.
C     --------------

      iRedC = -1
      Do iSym = 1,nSym

         Call mma_allocate(iRS2RS,nnBstR(iSym,1),Label='iRS2RS')
         Call mma_maxDBLE(l_Wrk)
         Call mma_allocate(Wrk,l_Wrk,Label='Wrk')
         iRS2RS(:)=0
         idRS2RS = -2
         KK1 = 1
         Do While (KK1 .le. NumCho(iSym))
            nVRead = 0
            mUsed = 0
            Call Cho_Timer(C0,W0)
            Call Cho_X_VecRd(Wrk,SIZE(Wrk),KK1,NumCho(iSym),iSym,
     &                       nVRead,iRedC,mUsed)
            If (nVRead .lt. 1) Then
               irc = 2
               Go To 1 ! exit after deallocation
            End If
            Call Cho_Timer(C1,W1)
            tDecom(1,2)=tDecom(1,2)+(C1-C0)
            tDecom(2,2)=tDecom(2,2)+(W1-W0)
            nSys_Call=nSys_Call+1
            kOffV = 0
            Do KKK = 0,nVRead-1
               KK = KK1 + KKK
               iRed = InfVec(KK,2,iSym)
               If (iRedC .ne. iRed) Then
                  Call Cho_X_SetRed(irc,iLoc,iRed)
                  If (irc .ne. 0) Then
                     irc = 3
                     Go To 1 ! exit after deallocation
                  End If
                  iRedC = iRed
               End If
               If (idRS2RS .ne. iRedC) Then
                  Call Cho_RS2RS(iRS2RS,SIZE(iRS2RS),2,iLoc,iRedC,iSym)
                  idRS2RS = iRedC
               End If
               K = InfVec(KK,5,iSym)
               kBlock=Cho_iRange(K+1,iV1(1,iSym),nBlock(iSym),.True.)
#if defined (_DEBUGPRINT_)
               If (kBlock.lt.1 .or. kBlock.gt.nBlock(iSym)) Then
                  Call Cho_Quit('[BLOCK] Error detected in '//SecNam,
     &                          104)
               End If
#endif
               K_inBlock=K-iV1(kBlock,iSym)+1
               kOffZ=ip_Z(iTri(kBlock,kBlock),iSym)-1
               Do J_inBlock=K_inBlock,nV(kBlock,iSym)
                  J=iV1(kBlock,iSym)+J_inBlock-1
                  iJ=iRS2RS(InfVcT(J,1,iSym)-iiBstR(iSym,1))
                  Z(kOffZ+iTri(J_inBlock,K_inBlock))=Wrk(kOffV+iJ)
               End Do
               Do jBlock=kBlock+1,nBlock(iSym)
                  kOffZ=ip_Z(iTri(jBlock,kBlock),iSym)-1
     &                 +nV(jBlock,iSym)*(K_inBlock-1)
                  Do J_inBlock=1,nV(jBlock,iSym)
                     J=iV1(jBlock,iSym)+J_inBlock-1
                     iJ=iRS2RS(InfVcT(J,1,iSym)-iiBstR(iSym,1))
                     Z(kOffZ+J_inBlock)=Wrk(kOffV+iJ)
                  End Do
               End Do
               kOffV=kOffV+nnBstR(iSym,iLoc)
            End Do
            KK1=KK1+nVRead
         End Do
         Call mma_deallocate(Wrk)
         Call mma_deallocate(iRS2RS)

      End Do

C     Synchronize result array across nodes.
C     --------------------------------------

      Do iSym=1,nSym
         Do kBlock=1,nBlock(iSym)
            Call Cho_GAdGOp(Z(ip_Z(iTri(kBlock,kBlock),iSym)),
     &                      nV(kBlock,iSym)*(nV(kBlock,iSym)+1)/2,'+')
            Do jBlock=kBlock+1,nBlock(iSym)
               Call Cho_GAdGOp(Z(ip_Z(iTri(jBlock,kBlock),iSym)),
     &                         nV(jBlock,iSym)*nV(kBlock,iSym),'+')
            End Do
         End Do
      End Do

#if defined (_DEBUGPRINT_)
C     Check that diagonal elements of Z are strictly positive.
C     --------------------------------------------------------

      If (iPrint.ge.myDebugInfo) Then
         Call Cho_Head(SecNam//': Diagonal of Z Vector Matrix','=',80,
     &                 LuPri)
         Write(Lupri,'(A)') ' '
      End If
      n=0
      Do iSym=1,nSym
         Do jBlock=1,nBlock(iSym)
            kOffZ=ip_Z(iTri(jBlock,jBlock),iSym)-1
            Do J_inBlock=1,nV(jBlock,iSym)
               If (iPrint.ge.myDebugInfo) Then
                  Write(LuPri,'(A,I2,A,I6,A,1P,D15.6,A,D15.6)')
     &            'Sym=',iSym,
     &            '  J=',iV1(jBlock,iSym)+J_inBlock-1,
     &            '  Z(J,J)=',
     &            Z(kOffZ+iTri(J_inBlock,J_inBlock)),
     &            '  Squared=',
     &            Z(kOffZ+iTri(J_inBlock,J_inBlock))**2
               End If
               If (abs(Z(kOffZ+iTri(J_inBlock,J_inBlock))).lt.Tol
     &             .or. Z(kOffZ+iTri(J_inBlock,J_inBlock)).lt.-Tol)
     &         Then
                  n=n+1
                  If (iPrint.ge.myDebugInfo) Then
                     Write(LuPri,'(A)')
     &               '  --> Small or negative Z diagonal!'
                  End If
               End If
            End Do
         End Do
      End Do
      If (n.ne.0) Then
         irc=20
         Go To 1 ! return
      End If
      ! Check diagonal elements
      Call Cho_CheckDiagFromZ(irc,NVT,l_NVT,nBlock,l_nBlock,
     &                        nV,l_nV1,l_nV2,
     &                        iV1,l_iV11,l_iV12,
     &                        ip_Z,l_Z1,l_Z2,Z,l_Z,
     &                        iPrint.ge.myDebugInfo)
      If (irc.ne.0) Then
         Go To 1 ! return
      End If
#endif

C     Exit. If error termination.
C     -----------------------------------------------

    1 Continue

#ifndef _DEBUGPRINT_
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(NVT)
#endif
      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C Routine for checking integral diagonal diagonal
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SubRoutine Cho_CheckDiagFromZ(irc,
     &                              NVT,l_NVT,
     &                              nBlock,l_nBlock,
     &                              nV,l_nV1,l_nV2,
     &                              iV1,l_iV11,l_iV12,
     &                              ip_Z,l_Z1,l_Z2,Z,l_Z,
     &                              Report)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: Check integral diagonal from Z vectors:
C
C              (J|J) = sum[K=1,J] Z(J,K)*Z(J,K)
C
C              Return codes
C              irc=0: all is fine
C              irc<0: too negative diagonals encountered, but otherwise
C                     calculation seems converged
C              irc>0: calculation not converged
C
      Implicit None
      Integer irc
      Integer l_NVT
      Integer l_nBlock
      Integer l_nV1, l_nV2
      Integer l_iV11, l_iV12
      Integer l_Z1, l_Z2, l_Z
      Integer NVT(l_NVT)
      Integer nBlock(l_nBlock)
      Integer nV(l_NV1,l_NV2)
      Integer iV1(l_IV11,l_iV12)
      Integer ip_Z(l_Z1,l_Z2)
      Real*8  Z(l_Z)
      Logical Report
#include "cholesky.fh"
#include "stdalloc.fh"

      Character(LEN=18), Parameter:: SecNam='Cho_CheckDiagFromZ'

      Integer iSym
      Integer jBlock, kblock
      Integer J_inBlock, K_inBlock
      Integer kOffZ
      Integer iD
      Integer n1, n2, n3, n4, n5
      Integer nTot

      Real*8 Dmax, Damax, Dmin, Damin
      Integer, Pointer:: InfVct(:,:,:)

      Integer i, j
      Integer iTri

      Real*8, Allocatable:: IntDia(:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      Subroutine Cho_X_GetIP_InfVec(InfVcT)
      Integer, Pointer:: InfVct(:,:,:)
      End Subroutine Cho_X_GetIP_InfVec
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      ! Get pointer to global InfVec array
      Call Cho_X_getIP_InfVec(InfVcT)

      ! Allocate memory for exact integral diagonal
      Call mma_allocate(IntDia,nnBstRT(1),Label='IntDia')

      ! Read diagonal
      Call Cho_IODiag(IntDia,2)

      ! Subtract Z vector contributions
      Do iSym=1,nSym
         Do kBlock=1,nBlock(iSym)
            Do K_inBlock=1,nV(kBlock,iSym)
               kOffZ=ip_Z(iTri(kBlock,kBlock),iSym)-1
               Do J_inBlock=K_inBlock,nV(kBlock,iSym)
                  J=iV1(kBlock,iSym)+J_inBlock-1
                  iD=InfVcT(J,1,iSym)
                  IntDia(iD)=IntDia(iD)
     &            -Z(kOffZ+iTri(J_inBlock,K_inBlock))**2
               End Do
            End Do
            Do jBlock=kBlock+1,nBlock(iSym)
               Do K_inBlock=1,nV(kBlock,iSym)
                  kOffZ=ip_Z(iTri(jBlock,kBlock),iSym)-1
     &                 +nV(jBlock,iSym)*(K_inBlock-1)
                  Do J_inBlock=1,nV(jBlock,iSym)
                     J=iV1(jBlock,iSym)+J_inBlock-1
                     iD=InfVcT(J,1,iSym)
                     IntDia(iD)=IntDia(iD)
     &               -Z(kOffZ+J_inBlock)**2
                  End Do
               End Do
            End Do
         End Do
      End Do

      ! Total number of vectors
      ! ...should equal number of converged diagonals
      nTot=NVT(1)
      Do iSym=2,nSym
         nTot=nTot+NVT(iSym)
      End Do

      ! Count diagonals smaller than threshold
      n1=0
      n2=0
      n3=0
      n4=0
      n5=0
      Dmax=-9.0d9
      Damax=0.0d0
      Dmin=9.0d9
      Damin=9.0d9
      Do iSym=1,nSym
         Do J=1,NVT(iSym)
            iD=InfVcT(J,1,iSym)
            Dmax=max(Dmax,IntDia(iD))
            Damax=max(Damax,abs(IntDia(iD)))
            Dmin=min(Dmin,IntDia(iD))
            Damin=min(Damin,abs(IntDia(iD)))
            If (IntDia(iD).le.ThrCom) n1=n1+1
            If (IntDia(iD).lt.0.0d0)  n2=n2+1
            If (IntDia(iD).lt.ThrNeg) n3=n3+1
            If (IntDia(iD).lt.WarNeg) n4=n4+1
            If (IntDia(iD).lt.TooNeg) n5=n5+1
         End Do
      End Do

      ! Write a report if requested
      If (Report) Then
         Call Cho_Head(SecNam//': Report on (J|J) Diagonal from Z','=',
     &                 80,LuPri)
         Write(LuPri,'(/,A,I8)')
     &   'Total dimension of diagonal............',nnBstRT(1)
         Write(LuPri,'(A,I8)')
     &   'Number of Cholesky vectors.............',nTot
         Write(LuPri,'(A,I8)')
     &   'Converged diagonals....................',n1
         Write(LuPri,'(A,I8)')
     &   'Unconverged diagonals..................',nTot-n1
         Write(LuPri,'(A,I8)')
     &   'Negative diagonals.....................',n2
         Write(LuPri,'(A,I8)')
     &   'Neg. diag. that would be zeroed........',n3
         Write(LuPri,'(A,I8)')
     &   'Neg. diag. that would cause warning....',n4
         Write(LuPri,'(A,I8)')
     &   'Neg. diag. that would cause crash......',n5
         Write(LuPri,'(A,1P,D15.6)')
     &   'Max diagonal...........................',Dmax
         Write(LuPri,'(A,1P,D15.6)')
     &   'Min diagonal...........................',Dmin
         Write(LuPri,'(A,1P,D15.6)')
     &   'Max abs diagonal.......................',Damax
         Write(LuPri,'(A,1P,D15.6)')
     &   'Min abs diagonal.......................',Damin
      End If

      ! Deallocation
      Call mma_deallocate(IntDia)

      ! Set return code and return
      If (n1.eq.nTot) Then
         If (n5.ne.0) Then
            irc=-10
         Else
            irc=0
         End If
      Else
         irc=10
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Rd1Int_FFPT
*
************************************************************************
*                                                                      *
*     Objective: Read the header of the one-electron integral file     *
*                Extract also symmetry and basis set information.      *
*                In addition read the overlap, the nuclear attraction  *
*                and kinetic integrals.                                *
*                                                                      *
************************************************************************
*
      Implicit Real*8 ( A-H,O-Z )
*
#include "input.fh"
#include "WrkSpc.fh"
*
*
*----------------------------------------------------------------------*
*                                                                      *
*     Start procedure                                                  *
*     Read one-electron integral file header etc.                      *
*                                                                      *
*----------------------------------------------------------------------*
*
      iOpt=0
      iComp=1
      iSyLbl=0
*
      Call Get_cArray('Seward Title',Header,144)
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      Call Get_iScalar('Unique atoms',nAtoms)
      Call Get_dArray('Unique Coordinates',Coor,3*nAtoms)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine gets array integer data from the runfile.               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: August 2003                                                 *
!                                                                      *
!***********************************************************************
!  Get_iArray
!
!> @brief
!>   Read array data from runfile
!> @author Per-Olof Widmark
!>
!> @details
!> This routine gets array double data from the runfile.
!>
!> @param[in]  Label Name of field
!> @param[out] Data  Data to read from runfile
!> @param[in]  nData Length of array
!>
!> @see ::Put_iArray
!***********************************************************************

subroutine Get_iArray(Label,iData,nData)

use RunFile_data, only: i_run_IA_used, lw, nTocIA, sSpecialField
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: nData
integer(kind=iwp), intent(out) :: iData(nData)
integer(kind=iwp) :: i, item, RecIdx(nTocIA), RecLen(nTocIA)
character(len=lw) :: CmpLab1, CmpLab2, RecLab(nTocIA)

!----------------------------------------------------------------------*
! Read info from runfile.                                              *
!----------------------------------------------------------------------*
call cRdRun('iArray labels',RecLab,lw*nTocIA)
call iRdRun('iArray indices',RecIdx,nTocIA)
call iRdRun('iArray lengths',RecLen,nTocIA)
!----------------------------------------------------------------------*
! Locate item                                                          *
!----------------------------------------------------------------------*
item = -1
CmpLab1 = Label
call UpCase(CmpLab1)
do i=1,nTocIA
  CmpLab2 = RecLab(i)
  call UpCase(CmpLab2)
  if (CmpLab1 == CmpLab2) item = i
end do

if (item /= -1) then
  if (Recidx(item) == sSpecialField) then
    write(u6,*) '***'
    write(u6,*) '*** Warning, reading temporary iArray field'
    write(u6,*) '***   Field: ',Label
    write(u6,*) '***'
#   ifndef _DEVEL_
    call AbEnd()
#   endif
  end if
end if
!----------------------------------------------------------------------*
! Transfer data to arguments                                           *
!----------------------------------------------------------------------*
i_run_IA_used(item) = i_run_IA_used(item)+1
if (item == -1) call SysAbendMsg('get_iArray','Could not locate: ',Label)
if (RecIdx(item) == 0) call SysAbendMsg('get_iArray','Data not defined: ',Label)
if (Reclen(item) /= nData) call SysAbendMsg('get_iArray','Data of wrong length: ',Label)
call iRdRun(RecLab(item),iData,nData)
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine Get_iArray

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Matthew R. Hennefarth                            *
!***********************************************************************

module mspdft

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
private

character(len=8) :: mspdftmethod = ' Unknown'
real(kind=wp), allocatable :: heff(:,:)

public :: heff, mspdft_finalize, mspdft_init, mspdftmethod

contains

!> @brief Initializes mspdft calculation
!>
!>   Loads effective Hamiltonian from disk and initializes gradient variables as needed
!>
!> @author Matthew R. Hennefarth
subroutine mspdft_init()

  use rasscf_global, only: lroots
  use mcpdft_input, only: mcpdft_options
  use mspdftgrad, only: mspdftgrad_init

  character(len=18) :: matrix_info

  call mma_allocate(heff,lroots,lroots,label='heff')

  call readmat2('ROT_HAM',matrix_info,heff,size(heff,1),size(heff,2),7,len(matrix_info),'T')
  call determine_method(matrix_info)

  if (mcpdft_options%grad) call mspdftgrad_init()

end subroutine

!> @brief determines method by which effective Hamiltonian is constructed
!>
!>   Sets mspdftmethod and and writes to stdout
!>
!> @author Matthew R. Hennefarth
!>
!> @param[in] matrix_info string
subroutine determine_method(matrix_info)

  use PrintLevel, only: VERBOSE
  use mcpdft_output, only: iprloc

  character(len=*), intent(in) :: matrix_info
  integer(kind=iwp) :: print_level
  character(len=len(mspdftmethod)) :: buffer

  print_level = iPrLoc(1)
  buffer = trim(adjustl(matrix_info))

  select case (buffer)
    case ('XMS-PDFT','CMS-PDFT','FMS-PDFT','VMS-PDFT')
      mspdftmethod = buffer
      if (print_level > VERBOSE) write(u6,'(6X,A,A)') 'The MS-PDFT method is ',mspdftmethod
    case default
      if (print_level > VERBOSE) write(u6,'(6X,A)') 'The MS-PDFT calculation is based on a user-supplied rotation matrix'
  end select

end subroutine determine_method

!> @brief Performs the final parts of a MS-PDFT calculation
!>
!>   1. diagonalize heff
!>   2. print out the final results
!>   3. save to jobiph if requested
!>
!> @author Matthew R. Hennefarth
!>
!> @param[in]   nroots number of roots, or dimension of heff
subroutine mspdft_finalize(nroots)

  use mcpdft_output, only: iprloc
  use mspdft_util, only: print_effective_ham, print_final_energies, print_mspdft_vectors
  use mcpdft_input, only: mcpdft_options
  use write_pdft_job, only: writejob
  use PrintLevel, only: TERSE, USUAL
  use mspdftgrad, only: mspdftgrad_free

  integer(kind=iwp), intent(in) :: nroots
  integer(kind=iwp) :: info, dim_scratch, iprlev
  real(kind=wp) :: e_mspdft(nroots), si_pdft(nroots,nroots), wgronk(1)
  character(len=120) :: Line
  real(kind=wp), allocatable :: scratch(:)

  iprlev = iprloc(1)

  if (iprlev >= USUAL) then
    write(u6,*)
    write(Line,'(6X,2A)') MSPDFTMethod,' FINAL RESULTS'
    call CollapseOutput(1,Line)
    write(u6,'(6X,A)') repeat('-',len_trim(Line)-3)
    write(u6,*)

    if (mcpdft_options%otfnal%is_hybrid()) then
      write(u6,'(6X,3A)') 'Hybrid ',MSPDFTMethod,' Effective Hamiltonian'
    else
      write(u6,'(6X,2A)') mspdftmethod,' Effective Hamiltonian'
    end if
    call print_effective_ham(heff,nroots,10)
  end if

  ! Now we diagonalize the final MS-PDFT H-matrix
  ! Eigenvectors will be stored in heff.
  ! Eigenvalues will be stored in e_mspdft

  ! Since the dsyev_ call will override the heff with the orthonormal
  ! eigenvectors, I am going to set the new variable now.
  si_pdft = heff

  ! This first call is to get how big of a scratch we need
  call dsyev_('V','U',nroots,si_pdft,nroots,e_mspdft,wgronk,-1,info)

  dim_scratch = int(wgronk(1))
  call mma_allocate(scratch,dim_scratch,label='XScratch')
  ! Now we actually do the diagonalization
  call dsyev_('V','U',nroots,si_pdft,nroots,e_mspdft,scratch,dim_scratch,info)
  call mma_deallocate(scratch)

  if (iprlev >= TERSE) call print_final_energies(e_mspdft,nroots)

  ! Update information on the runfile for possible gradient calculations.
  call put_dArray('Last energies',e_mspdft,nroots)
  if (mcpdft_options%grad) call Put_dScalar('Last energy',e_mspdft(mcpdft_options%rlxroot))

  ! Add info the checkfile for testing!
  call Add_Info('MSPDFTE',e_mspdft,nroots,8)

  if (iprlev >= USUAL) then
    if (mcpdft_options%otfnal%is_hybrid()) then
      write(u6,'(6X,3A)') 'Hybrid ',MSPDFTMethod,' Eigenvectors:'
    else
      write(u6,'(6X,2A)') MSPDFTMethod,' Eigenvectors:'
    end if
    call print_mspdft_vectors(si_pdft,nroots)
  end if

  ! Added by Chen to write energies and states of MS-PDFT into JOBIPH
  if (mcpdft_options%wjob) call writejob(e_mspdft,nroots,si_pdft=si_pdft)

  if (iprlev >= USUAL) then
    call CollapseOutput(0,Line)
    write(u6,*)
  end if

  if (mcpdft_options%grad) then
    call put_lscalar('CalcNAC_Opt     ',.false.)
    call put_lscalar('MECI_via_SLAPAF',.false.)
    if (mcpdft_options%nac) then
      call mspdftgrad_misc(si_pdft,mcpdft_options%nac_states)
    else
      call put_iscalar('Relax CASSCF root',mcpdft_options%rlxroot)
      call mspdftgrad_misc(si_pdft,[mcpdft_options%rlxroot,mcpdft_options%rlxroot])
    end if
  end if

  ! Deallocate here!
  call mma_deallocate(heff)
  if (mcpdft_options%grad) call mspdftgrad_free()

end subroutine mspdft_finalize

end module mspdft

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Steven Vancoillie                                *
!***********************************************************************

module faroald
! written by Steven Vancoillie, summer 2014
!
! The faroald module handles sigma updates as the result of acting
! with the hamiltonian operator on a CI vector: s = H c, where s and c
! are CI expansions in determinant basis.
!
! The implementation follows the minimum operation count algorithm
! published by Olsen & Co in J. Chem. Phys. 89, 2185 (1988).

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp
#ifdef _PROF_
use, intrinsic :: iso_fortran_env, only: int64
use Definitions, only: u6
#endif

implicit none
private

! wavefunction info
integer(kind=iwp) :: my_nel, my_norb, mult, nela, nelb, nhoa, nhob, ndeta, ndetb, my_ndet

! excitation tables
type ex1_struct
  integer(kind=iwp) :: p, q, sgn, rank
end type

type(ex1_struct), allocatable :: ex1_a(:,:), ex1_b(:,:)
integer(kind=iwp) :: max_ex1a, max_ex1b, max_ex2a, max_ex2b, max_LRs

#ifdef _PROF_
integer(kind=int64) :: nflop
#endif

public :: ex1_a, ex1_b, ex1_init, max_LRs, max_ex1a, max_ex1b, max_ex2a, max_ex2b, mult, my_ndet, my_nel, my_norb, ndeta, ndetb, &
          nela, nelb, nhoa, nhob, sigma_update

! Extensions to mma interfaces

interface cptr2loff
  module procedure ex1_cptr2loff
end interface
interface mma_allocate
  module procedure ex1_mma_allo_2D, ex1_mma_allo_2D_lim
end interface
interface mma_deallocate
  module procedure ex1_mma_free_2D
end interface

public :: mma_allocate, mma_deallocate

contains

subroutine sigma_update(h,g,sgm,psi)
! The sigma update routine performs the following operation:
! |sgm> = H |psi>, with the hamiltonian defined by
! H = sum_tu h(t,u) E_tu + sum_tuvx g(t,u,v,x) E_tuvx.

  ! integrals
  real(kind=wp), intent(in) :: h(my_norb,my_norb), g(my_norb,my_norb,my_norb,my_norb)
  ! wavefunctions
  real(kind=wp), intent(out) :: sgm(:,:)
  real(kind=wp), intent(in) :: psi(:,:)
  integer(kind=iwp) :: t, u, v, & ! orbital indices
                       iasta, iaend, ibsta, ibend ! determinant index ranges
  real(kind=wp), allocatable :: k(:,:), psiT(:,:), sgmT(:,:)
# ifdef _PROF_
  ! profiling
  real(kind=wp) :: t1_cpu, t2_cpu, tot_cpu, t1_wall, t2_wall, tot_wall, walltime, flops
# endif

  ! Distributes a dimension over processes
  ! and returns the range of this process.
  call par_range(ndeta,iasta,iaend)
  call par_range(ndetb,ibsta,ibend)

# ifdef _PROF_
  ! initialize flop count
  nflop = 0

  call timing(t1_cpu,tot_cpu,t1_wall,tot_wall)
# endif

  ! Set the sigma vector to 0
  sgm = Zero

  ! First, construct a new effective one-electron integral matrix:
  ! k_tu = h_tu - 1/2 sum_v g_tvvu, to be used with sigma1/sigma2.
  call mma_allocate(k,my_norb,my_norb,label='k')
  do u=1,my_norb
    do t=1,my_norb
      ! g_tvvu = g_vtvu
      k(t,u) = Zero
      do v=1,my_norb
        k(t,u) = k(t,u)+g(v,t,v,u)
      end do
      k(t,u) = h(t,u)-Half*k(t,u)
    end do
  end do

  ! Second, for sigma2 and sigma3, we are better off with the transpose
  ! of sgm and/or psi, so allocate and assign them here.
  call mma_allocate(psiT,ndetb,ndeta,label='psiT')
  call dtrans(ndeta,ndetb,psi,ndeta,psiT,ndetb)

  ! Now the actual contributions to sigma are computed. For a singlet
  ! (mult = 1), sigma2 is not computed and sigma3 will only do half the
  ! work.  But at the end, the transpose of sigma has to be added to
  ! sigma. This should be more efficient than computing everything, but
  ! note that the transpose operation is also included in the timings
  ! used to compute the flop efficiency.

  call sigma1(k,g,sgm,psi,ibsta,ibend)

  if (mult /= 1) then
    ! we need efficient access to sgm by using the transpose
    call mma_allocate(sgmT,ndetb,ndeta,label='sgmT')
    call dtrans(ndeta,ndetb,sgm,ndeta,sgmT,ndetb)

    call sigma2(k,g,sgmT,psiT,iasta,iaend)

    call dtrans(ndetb,ndeta,sgmT,ndetb,sgm,ndeta)
    call mma_deallocate(sgmT)
  end if

  call sigma3(g,sgm,psiT,ibsta,ibend)

  ! sum over all processes
  call gadsum(sgm,ndeta*ndetb)

  if (mult == 1) then
    ! for Ms = 0 (only used for singlet), sgm := sgm + sgm^T
    call transadd(ndeta,sgm,ndeta)
  end if

  call mma_deallocate(psiT)
  call mma_deallocate(k)

# ifdef _PROF_
  call timing(t2_cpu,tot_cpu,t2_wall,tot_wall)

  walltime = t2_wall-t1_wall

  if (walltime /= Zero) then
    flops = nflop/walltime
    write(u6,'(1x,a,2(f10.3,a))') 'sigma update: ',walltime,' s, ',flops*1.0d-9,' Gflops.'
  end if
# endif

end subroutine sigma_update

subroutine sigma1(k,g,sgm,psi,ibsta,ibend)
! sigma1 = sum_jb sum_tu <jb|E_tu|ib> (h_kl - 1/2 sum_v <tv|vx>) C(ia,jb)
!    + 1/2 sum_jb sum_tuvx <jb|E_tu E_vx|ib> g_tuvx C(ia,jb)

  ! integrals
  real(kind=wp), intent(in) :: k(my_norb,my_norb), g(my_norb,my_norb,my_norb,my_norb)
  ! wavefunctions
  real(kind=wp), intent(inout) :: sgm(:,:)
  real(kind=wp), intent(in) :: psi(:,:)
  integer(kind=iwp), intent(in) :: ibsta, ibend
  ! local variables
  integer(kind=iwp) :: ib, jb, kb, t, u, v, x, tu, vx, sgn_tu, sgn_vx
  real(kind=wp), allocatable :: f(:)

  call mma_allocate(f,ndetb,label='f')

  do ib=ibsta,ibend
    ! f array construction
    f = Zero
    do tu=1,max_ex1b
      t = ex1_b(tu,ib)%p
      u = ex1_b(tu,ib)%q
      sgn_tu = ex1_b(tu,ib)%sgn
      kb = ex1_b(tu,ib)%rank
      f(kb) = f(kb)+sgn_tu*k(t,u)
      do vx=1,max_ex1b
        v = ex1_b(vx,kb)%p
        x = ex1_b(vx,kb)%q
        sgn_vx = ex1_b(vx,kb)%sgn
        jb = ex1_b(vx,kb)%rank
        f(jb) = f(jb)+Half*sgn_tu*sgn_vx*g(v,x,t,u)
      end do
    end do
    ! sigma addition
    kb = 0
    do jb=1,ndetb
      if (f(jb) /= Zero) then
        kb = kb+1
#       ifdef _PROF_
        nflop = nflop+2*ndeta
#       endif
        call daxpy_(ndeta,f(jb),psi(:,jb),1,sgm(:,ib),1)
      end if
    end do
    if (kb > max_ex2b) stop 'exceeded max double excitations'
  end do

  call mma_deallocate(f)

end subroutine sigma1

subroutine sigma2(k,g,sgm,psi,iasta,iaend)
! sigma2 = sum_ja sum_tu <ja|E_tu|ia> (h_kl - 1/2 sum_v <tv|vx>) C(ja,ib)
!    + 1/2 sum_ja sum_tuvx <ja|E_tu E_vx|ia> g_tuvx C(ja,ib)

  ! integrals
  real(kind=wp), intent(in) :: k(my_norb,my_norb), g(my_norb,my_norb,my_norb,my_norb)
  ! wavefunctions
  real(kind=wp), intent(inout) :: sgm(:,:)
  real(kind=wp), intent(in) :: psi(:,:)
  integer(kind=iwp), intent(in) :: iasta, iaend
  ! local variables
  integer(kind=iwp) :: ia, ja, ka, t, u, v, x, tu, vx, sgn_tu, sgn_vx
  real(kind=wp), allocatable :: f(:)

  call mma_allocate(f,ndeta,label='f')

  do ia=iasta,iaend
    ! f array construction
    f = Zero
    do tu=1,max_ex1a
      t = ex1_a(tu,ia)%p
      u = ex1_a(tu,ia)%q
      sgn_tu = ex1_a(tu,ia)%sgn
      ka = ex1_a(tu,ia)%rank
      f(ka) = f(ka)+sgn_tu*k(t,u)
      do vx=1,max_ex1a
        v = ex1_a(vx,ka)%p
        x = ex1_a(vx,ka)%q
        sgn_vx = ex1_a(vx,ka)%sgn
        ja = ex1_a(vx,ka)%rank
        f(ja) = f(ja)+Half*sgn_tu*sgn_vx*g(v,x,t,u)
      end do
    end do
    ! sigma addition
    ka = 0
    do ja=1,ndeta
      if (f(ja) /= Zero) then
        ka = ka+1
#       ifdef _PROF_
        nflop = nflop+2*ndeta
#       endif
        call daxpy_(ndetb,f(ja),psi(:,ja),1,sgm(:,ia),1)
      end if
    end do
    if (ka > max_ex2a) stop 'exceeded max double excitations'
  end do

  call mma_deallocate(f)

end subroutine sigma2

subroutine sigma3(g,sgm,psi,ibsta,ibend)
! sigma3(ia,ib) = sum_ja,jb sum_tu,vx <jb|E_tu|ib> <ja|E_vx|ia> g_tuvx C(ja,jb)

  ! integrals
  real(kind=wp), intent(in) :: g(my_norb,my_norb,my_norb,my_norb)
  ! wavefunctions
  real(kind=wp), intent(inout) :: sgm(:,:)
  real(kind=wp), intent(in) :: psi(:,:)
  ! determinant indices
  integer(kind=iwp), intent(in) :: ibsta, ibend
  integer(kind=iwp) :: i, n_couples, ib, jb, kb,  &
                       t, u, v, x, & !orbital indices
                       tu, sgn_tu
  integer(kind=iwp), allocatable :: ia(:), ja(:), sgn_vx(:)
  real(kind=wp), allocatable :: f(:), Ctmp(:,:), Vtmp(:)

  call mma_allocate(ja,max_LRs,label='ja')
  call mma_allocate(ia,max_LRs,label='ia')
  call mma_allocate(sgn_vx,max_LRs,label='sgn_vx')
  call mma_allocate(Ctmp,max_LRs,ndetb,label='Ctmp')
  call mma_allocate(Vtmp,max_LRs,label='Vtmp')
  call mma_allocate(f,ndetb,label='f')

  do v=1,my_norb
    do x=1,my_norb
      ! set up L(I), R(I), sgn(I) defined by L(ia) = E_tu R(ia)
      call LRs_init(v,x,nela,my_norb,ja,ia,sgn_vx,n_couples)
      do i=1,n_couples
        Ctmp(i,:) = psi(:,ja(i))*sgn_vx(i)
      end do
      do ib=ibsta,ibend
        f = Zero
        do tu=1,max_ex1b
          t = ex1_b(tu,ib)%p
          u = ex1_b(tu,ib)%q
          sgn_tu = ex1_b(tu,ib)%sgn
          jb = ex1_b(tu,ib)%rank
          ! for singlets, only tu >= vx are used
          if (mult == 1) then
            if (t < v) cycle
            if ((t == v) .and. (u < x)) cycle
            if ((t == v) .and. (u == x)) then
              f(jb) = f(jb)+sgn_tu*Half*g(t,u,v,x)
              cycle
            end if
          end if
          f(jb) = f(jb)+sgn_tu*g(t,u,v,x)
        end do
        ! V(ia) = sum_jb f(jb) C'(ia,jb) for all ia
        Vtmp = Zero
        kb = 0
        ! loop over non-identical excitations
        do tu=1,max_ex1b
          jb = ex1_b(tu,ib)%rank
          if ((jb /= ib) .and. (f(jb) /= Zero)) then
            kb = kb+1
#           ifdef _PROF_
            nflop = nflop+2*n_couples
#           endif
            call daxpy_(n_couples,f(jb),Ctmp(1,jb),1,Vtmp,1)
          end if
        end do
        ! contribution from the identical excitations
        if (f(ib) /= Zero) then
#         ifdef _PROF_
          nflop = nflop+2*n_couples
#         endif
          call daxpy_(n_couples,f(ib),Ctmp(1,ib),1,Vtmp,1)
        end if
        if (kb > max_ex1b) stop 'exceeded max single excitations'
        ! s3(R_ia,ib) = s3(R_ia,ib) + V(ia)
        do i=1,n_couples
          sgm(ia(i),ib) = sgm(ia(i),ib)+Vtmp(i)
        end do
      end do
    end do
  end do

  call mma_deallocate(ja)
  call mma_deallocate(ia)
  call mma_deallocate(sgn_vx)
  call mma_deallocate(Ctmp)
  call mma_deallocate(Vtmp)
  call mma_deallocate(f)

end subroutine sigma3

subroutine ex1_init(k,n,ex1_table)

  use second_quantization, only: binom_coef, ex1, fase, lex_init, lex_next, lexrank

  integer(kind=iwp), intent(in) :: k, n
  type(ex1_struct), intent(out) :: ex1_table(:,:)
  integer(kind=iwp) :: my_ndet, idet, det, tmp, p, q, pq, counter

  !write(u6,'(1x,a)') 'excitation table'
  !write(u6,'(1x,a)') 'p   q   I   J'
  my_ndet = binom_coef(k,n)
  det = lex_init(k,n)
  counter = 0
  do idet=1,my_ndet
    pq = 0
    do p=1,my_norb
      do q=1,my_norb
        tmp = ex1(p,q,det)
        if (tmp /= -1) then
          pq = pq+1
          ex1_table(pq,idet)%p = p
          ex1_table(pq,idet)%q = q
          ex1_table(pq,idet)%sgn = fase(tmp)
          ex1_table(pq,idet)%rank = lexrank(tmp)
          counter = counter+1
          !write(u6,'(1x,4i4)') p,q,idet,fase(tmp)*lexrank(tmp)
        end if
      end do
    end do
    det = lex_next(det)
  end do

end subroutine ex1_init

subroutine LRs_init(p,q,my_nel,my_norb,L,R,sgn,counter)
! for a pair of orbitals p and q, and determinants
! generated by my_nel electrons in my_norb spin orbitals,
! re-enumerate all non-vanishing couples connected
! through: jdet = E_pq idet. The number of couples
! is given by n_det, L(i) = jdet and R(i) = idet,
! where i is a counter from 1 to n_det. The sign of
! jdet is stored in the sgn array.

  use second_quantization, only: binom_coef, ex1, fase, lex_init, lex_next, lexrank

  integer(kind=iwp), intent(in) :: p, q, my_nel, my_norb
  integer(kind=iwp), intent(out) :: L(:), R(:), sgn(:), counter
  integer(kind=iwp) :: my_ndet, idet, det, tmp

  my_ndet = binom_coef(my_nel,my_norb)
  det = lex_init(my_nel,my_norb)
  counter = 0
  do idet=1,my_ndet
    tmp = ex1(p,q,det)
    if (tmp /= -1) then
      counter = counter+1
      R(counter) = idet
      sgn(counter) = fase(tmp)
      L(counter) = lexrank(tmp)
    end if
    det = lex_next(det)
  end do

end subroutine LRs_init

! Extensions to mma_interfaces, using preprocessor templates
! (see src/mma_util/stdalloc.f)

! Define ex1_cptr2loff, ex1_mma_allo_2D, ex1_mma_allo_2D_lim, ex1_mma_free_2D
#define _TYPE_ type(ex1_struct)
#  define _FUNC_NAME_ ex1_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ ex1_mma
#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'ex1_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

end module faroald

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1999, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE SBLOCKS( NSBLOCK, ISBLOCK,      CB,      SB,      C2,
     &                     ICOCOC,  ICSMOS,  ICBLTP,      NSSOA,
     &                      NSSOB,    NAEL,   IAGRP,    NBEL,   IBGRP,
     &                     IOCTPA,  IOCTPB,  NOCTPA,  NOCTPB,   NSMST,
     &                      NSMOB,   NSMSX,   NSMDX,  NOBPTS,  IOBPTS,
*
     &                    MXPNGAS,   ITSOB,      MAXK,    MAXI,
     &                                  LC,             XINT,    CSCR,
     &                       SSCR,    STSTSX,  STSTDX,  SXDXSX,
     &                      ADSXA,      NGAS,NELFSPGP,     IDC,
     &                         I1,    XI1S,      I2,    XI2S,   IDOH2,
*
     &                     MXPOBS,  ISTRFL,      PS,   IPRNT,     LUC,
     &                    ICJKAIB,   CJRES,   SIRES,      I3,    XI3S,
     &                         I4,    XI4S,  MXSXST,  MXSXBL,   MOCAA,
     &                         LCBLOCK,LECBLOCK,I1CBLOCK,
     &                    ICBLOCK,IRESTRICT,ICONSPA,ICONSPB, SCLFAC,
*
     &                      IPERTOP,IH0INSPC,  IH0SPC,ICBAT_RES,
     &                   ICBAT_INI,ICBAT_END,IUSE_PH, IPHGAS,I_RES_AB,
     &                          ISIMSYM,   XINT2)
*
* SUBROUTINE SBLOCKS --> 91
*
*
* Direct RAS routine employing combined MOC/n-1 resolution method
*
* Jeppe Olsen , Winter of 1991
*               Last modification : April 99
*
* =====
* Input
* =====
*
* NSBLOCK : Number of BLOCKS included
* ISBLOCK : Blocks included
*   ISBLOCK(1,*) : alpha type of block
*   ISBLOCK(2,*) : beta type of block
*   ISBLOCK(3,*) : sym of alpha in block
*   ISBLOCK(4,*) : Offset of block
*
* ICOCOC : Allowed type combinations for C
* ICSMOS : Symmetry array for C
* ICBLTP : Block types for C
* NACOB : Number of active orbitals
* NSSOA : Number of strings per type and symmetry for alpha strings
* NAEL  : Number of active alpha electrons
* NSSOB : Number of strings per type and symmetry for beta strings
* NBEL  : Number of active beta electrons
* NTSOB : Number of orbitals per type and symmetry
* NOBPTS: Orbitals of given type and symmetry
* IOBPTS: Offset for orbitals of given sym and type
*
* MAXIJ : Largest allowed number of orbital pairs treated simultaneously
* MAXK  : Largest number of N-2,N-1 strings treated simultaneously
* MAXI  : Max number of N strings treated simultaneously
*
* LI : Length of scratch array for integrals
* LC : Length of scratch array for C
* LS : Length of scratch array for S
* XINT : Scratch array for integrals
* CSCR : Scratch array for C vector
* SSCR : Scratch array for S vector
*
*
* ICJKAIB = 1 => construct C(Ka,Jb,j) and S(Ka,IB,i) as intermediate terms
*         = 0 => do not construct the above montioned matrices
* CJRES,SIRES : Space for above matrices
* The C and S vectors are accessed through routines that
* either fetches/disposes symmetry blocks or
* Symmetry-occupation-occupation blocks
*
*
* If IRESTRICT.NE. 0 THEN we are after :
* sigma(iblk) = summa(jblk.le.iblk) (2-delta(iblk,jblk))/2
*                                                 * <Iblk!H!Jblk>C(Jblk)


      IMPLICIT REAL*8(A-H,O-Z)
*. Specific input
      INTEGER ISBLOCK(8,*)
*.General input
      INTEGER ICOCOC(NOCTPA,NOCTPB)
      INTEGER ICSMOS(NSMST)
      INTEGER ICBLTP(*)
      INTEGER NSSOA(NSMST ,*), NSSOB(NSMST ,*)
      INTEGER STSTSX(NSMST,NSMST)
      INTEGER STSTDX(NSMST,NSMST), ADSXA(MXPOBS,2*MXPOBS)
      INTEGER SXDXSX(2*MXPOBS,4*MXPOBS)
      INTEGER NOBPTS(MXPNGAS,*),IOBPTS(MXPNGAS,*),ITSOB(*)
      INTEGER NELFSPGP(MXPNGAS,*)
      INTEGER ICONSPA(NOCTPA,NOCTPA), ICONSPB(NOCTPB,NOCTPB)
*.Scratch
      DIMENSION SB(*),CB(*),C2(*)
      DIMENSION XINT(*),XINT2(*),CSCR(*),SSCR(*)
      DIMENSION I1(*),I2(*),I3(*),I4(*),XI1S(*),XI2S(*),XI3S(*),XI4S(*)
      INTEGER   LCBLOCK(*),I1CBLOCK(*),ICBLOCK(8,*),LECBLOCK(*)
      DIMENSION ISTRFL(*)
*. Zero order Hamiltonian
      INTEGER IH0SPC(NOCTPA,NOCTPB)
      INTEGER IH0INSPC(*)
*
      DIMENSION CJRES(*),SIRES(*)
*
      DIMENSION LASM(4),LBSM(4),LATP(4),LBTP(4),LSGN(5),LTRP(5)
      DIMENSION SCLFAC(*)
#include "bk_approx.fh"
#include "io_util.fh"
*
      COMMON/H_OCC_CONS/IH_OCC_CONS

      DIMENSION C(1),ICOOSC(1),IPHGAS(*),iDUMMY(1)
      INTEGER DXSTST(1)
* IH_OCC_CONS =1 implies that we should employ occupation conserving
* part of Hamiltonian


*.
C-jwk-cleanup      REAL * 8 INPROD
*
*
C?    WRITE(6,*) ' IPERTOP in SBLOCKS = ', IPERTOP
c      IF(IH_OCC_CONS.EQ.1) THEN
c         WRITE(6,*) ' Occupation conserving part of Hamiltonian '
c      END IF
      NTEST = 000
      NTEST = MAX(NTEST,IPRNT)
      IF(NTEST.GE.10) THEN
         WRITE(6,*) ' ================='
         WRITE(6,*) ' SBLOCKS speaking :'
         WRITE(6,*) ' ================='
         WRITE(6,*)
         WRITE(6,*) ' Number of sigma blocks to be calculated ',
     &        NSBLOCK
         WRITE(6,*) ' TTSS for each ACTIVE sigma block'
         DO IBLOCK = 1, NSBLOCK
            IF(ISBLOCK(1,IBLOCK).GT.0)
     &           WRITE(6,'(10X,4I3,2I8)') (ISBLOCK(II,IBLOCK),II=1,4)
         END DO
         WRITE(6,*) ' IDC PS IPERTOP', IDC,PS,IPERTOP
         WRITE(6,*) ' IDOH2 = ',IDOH2
         WRITE(6,*) ' I_RES_AB=',I_RES_AB
         if ( DoBKAP ) then
          write(6,*) ' I am doing BK-type of approximation '
          write(6,*) ' It is based on orbital splitting '
          write(6,*) ' Min and Max for subspace with exact Hamiltonian '
          write(6,*) ' =============================================== '
          write(6,*) 'NGASBK : ',NGASBK
          write(6,*) '              Min. Occ.      Max. Occ.           '
          Do IGAS = 1, NGASBK
            write(6,'(A,I2,10X,I3,9X,I3)')
     &      '   GAS',IGAS,IOCCPSPC(IGAS,1),IOCCPSPC(IGAS,2)
          End do
         end if
      END IF
*
      IF(NTEST.GE.50) THEN
         WRITE(6,*) ' Initial C vector '
         CALL WRTVCD(CB,LUC,1,-1)
      END IF
* ===========================
* 1 : Arrays for accessing C
* ============================
*. Find batches of C - strings
      CALL PART_CIV2(      IDC,   ICBLTP,    NSSOA,    NSSOB,   NOCTPA,
     &                  NOCTPB,    NSMST,       LC,   ICOCOC,   ICSMOS,
     &                 NCBATCH,  LCBLOCK, LECBLOCK, I1CBLOCK,  ICBLOCK,
     &                       0,  ISIMSYM)
*. Find the active blocks on LUC, store info in SCLFAC
      CALL FIND_ACTIVE_BLOCKS(LUC,-1,SCLFAC,CB)
*
* Initialize sigma blocks
      DO JSBLOCK = 1, NSBLOCK
         IATP = ISBLOCK(1,JSBLOCK)
         IBTP = ISBLOCK(2,JSBLOCK)
         IASM = ISBLOCK(3,JSBLOCK)
         IBSM = ISBLOCK(4,JSBLOCK)
         IOFF = ISBLOCK(5,JSBLOCK)
         NASTR = NSSOA(IASM,IATP)
         NBSTR = NSSOB(IBSM,IBTP)
         ZERO = 0.0D0
         IF(ISBLOCK(1,JSBLOCK).GT.0)
     &        CALL SETVEC(SB(IOFF),ZERO,NASTR*NBSTR)
      END DO
* Loop over batches over C blocks
      IF(IDOH2.EQ.1) THEN
         MXEXC  = 2
      ELSE
         MXEXC = 1
      END IF
      IDISK(LUC)=0
      IF(ICBAT_RES.EQ.1) THEN
         WRITE(6,*) ' Restricted set of C batches '
         WRITE(6,*) ' ICBAT_INI ICBAT_END', ICBAT_INI,ICBAT_END
         JCBAT_INI = ICBAT_INI
         JCBAT_END = ICBAT_END
      ELSE
         JCBAT_INI = 1
         JCBAT_END = NCBATCH
      END IF
*
      JOFF = 0 ! jwk-cleanup
      DO 20000 JCBATCH = JCBAT_INI,JCBAT_END
*
*. Read C blocks into core
*
         ICOFF = 1
         NJBLOCK = LCBLOCK(JCBATCH)
         DO JJCBLOCK = 1, NJBLOCK
            JBLOCK = I1CBLOCK(JCBATCH)-1+JJCBLOCK
*. Will this block be needed ??
            INTERACT = 0
            IF(SCLFAC(JBLOCK).EQ. 1.0D0) THEN
               JATP = ICBLOCK(1,JBLOCK)
               JBTP = ICBLOCK(2,JBLOCK)
               JASM = ICBLOCK(3,JBLOCK)
               JBSM = ICBLOCK(4,JBLOCK)
               JOFF = ICBLOCK(5,JBLOCK)
               PL=1.D0
               CALL PRMBLK(     IDC,  ISTRFL,    JASM,    JBSM,    JATP,
     &                         JBTP,      PS,      PL,    LATP,    LBTP,
     &                         LASM,    LBSM,    LSGN,    LTRP,   NPERM)
               DO IPERM = 1, NPERM
                  LLASM = LASM(IPERM)
                  LLBSM = LBSM(IPERM)
                  LLATP = LATP(IPERM)
                  LLBTP = LBTP(IPERM)
*.Loop over Sigma blocks in batch
                  DO JSBLOCK = 1, NSBLOCK
                     IDENT = 0
                     IF(ISBLOCK(1,JSBLOCK).GT.0) THEN
                        IATP = ISBLOCK(1,JSBLOCK)
                        IBTP = ISBLOCK(2,JSBLOCK)
                        IASM = ISBLOCK(3,JSBLOCK)
                        IBSM = ISBLOCK(4,JSBLOCK)
*. Are the two blocks connected by allowed excitation
            CALL CON_BLOCKS( IATP, IBTP,LLATP,LLBTP, IASM,
     &                                   IBSM,LLASM,LLBSM,
     &                                  ICONSPA,
     &                                  ICONSPB,
     &                                  NOCTPA,
*
     &                                  NOCTPB,
     &                                  MXEXC,
     &                                  IH_OCC_CONS,
     &                                  INTERACT)
                        IDENT = 0
                        IF(IASM.EQ.JASM.AND.IATP.EQ.JATP.AND.
     &                       IBSM.EQ.JBSM.AND.IBTP.EQ.JBTP) IDENT = 1
*
                     END IF
                  END DO
               END DO
*.             ^ End of checking whether C-block is needed
            END IF
*           ^ Checking was only done for nonvanishing blocks
*
            ISCALE = 0
            IF(INTERACT.EQ.1) THEN
               CALL GSTTBL(       C,CB(JOFF),    JATP,    JASM,    JBTP,
     &                         JBSM,  ICOCOC,  NOCTPA,  NOCTPB,   NSSOA,
     &                        NSSOB,      PS,  ICOOSC,     IDC,      PL,
     &                          LUC,C2,   NSMST,  ISCALE,SCLFAC(JBLOCK))
*. Note in GSTTBL : ICOOSC only used for CI vectors in core,
            ELSE
*. not relevant
               CALL IDAFILE(LUC,2,iDUMMY,1,IDISK(LUC))
               LBL=iDUMMY(1)
               CALL IDAFILE(LUC,2,iDUMMY,1,IDISK(LUC))
               CALL SKPRCD2(LBL,-1,LUC)
               SCLFAC(JBLOCK) = 0.0D0
            END IF
*
            IF(NTEST.GE.100) THEN
               IF(INTERACT.EQ.1) THEN
                  WRITE(6,*) ' TTSS for C block read in  '
                  CALL IWRTMA(ICBLOCK(1,JBLOCK),4,1,4,1)
               ELSE
                  WRITE(6,*) ' TTSS for C block skipped  '
                  CALL IWRTMA(ICBLOCK(1,JBLOCK),4,1,4,1)
               END IF
            END IF
*
         END DO
*        ^ End of loop over Blocks
*
*. Loop over blocks of sigma and C in core and obtain  contribution from
*  given C block to given S block
*. Loop over C blocks
         DO 9000 ICBLK = I1CBLOCK(JCBATCH), I1CBLOCK(JCBATCH)-1+NJBLOCK
            JATP = ICBLOCK(1,ICBLK)
            JBTP = ICBLOCK(2,ICBLK)
            JASM = ICBLOCK(3,ICBLK)
            JBSM = ICBLOCK(4,ICBLK)
            ICOFF = ICBLOCK(5,ICBLK)
            NJA = NSSOA(JASM,JATP)
            NJB = NSSOB(JBSM,JBTP)
*
            IF(SCLFAC(ICBLK).NE.0.0D0) THEN
*. Other symmetry blocks that can be obtained from this block
               CALL PRMBLK(     IDC,  ISTRFL,    JASM,    JBSM,    JATP,
     &                         JBTP,      PS,      PL,    LATP,    LBTP,
     &                         LASM,    LBSM,    LSGN,    LTRP,   NPERM)
*. Start with transposed block
               DO 8765 IPERM = NPERM,1, -1
                  LLASM = LASM(IPERM)
                  LLBSM = LBSM(IPERM)
                  LLATP = LATP(IPERM)
                  LLBTP = LBTP(IPERM)
                  NLLA = NSSOA(LLASM,LLATP)
                  NLLB = NSSOB(LLBSM,LLBTP)
*. The routines assumes on input that the blocks are transposed, so,
*. Initial tour, IPERM = 1 corresponds always to no transpose, so transpose!
                  IF(IPERM.EQ.1) THEN
                     IF(IDC.EQ.2.AND.JATP.EQ.JBTP.AND.JASM.EQ.JBSM) THEN
*. Diagonal blocks, Transposing corresponds to scaling
                        IF(PS.EQ.-1.0D0) THEN
                           CALL SCALVE(CB(ICOFF),PS,NJA*NJB)
                        END IF
                     ELSE
*. ofdiagonal blocks, explicit transposing
                        CALL TRPMT3(CB(ICOFF),NJA,NJB,C2)
                        CALL COPVEC(C2,CB(ICOFF),NJA*NJB)
                     END IF
                  END IF
*
                  DO 10000 ISBLK = 1, NSBLOCK
                     IF(ISBLOCK(1,ISBLK) .GT. 0 ) THEN
                        IATP = ISBLOCK(1,ISBLK)
                        IBTP = ISBLOCK(2,ISBLK)
                        IASM = ISBLOCK(3,ISBLK)
                        IBSM = ISBLOCK(4,ISBLK)
                        ISOFF = ISBLOCK(5,ISBLK)
                        NIA = NSSOA(IASM,IATP)
                        NIB = NSSOB(IBSM,IBTP)
*
                        IF(NIA*NIB.EQ.0) GOTO 10000
                        IF(IRESTRICT.EQ.1.AND.
     &                       (JASM.GT.IASM.OR.
     &                       JASM.EQ.IASM.AND.JATP.GT.IATP.OR.
     &                  JASM.EQ.IASM.AND.JATP.EQ.IATP.AND.JBTP.GT.IBTP))
     &                       GOTO 10000
*. Are the two blocks connected by allowed excitation
            CALL CON_BLOCKS( IATP, IBTP,LLATP,LLBTP, IASM,IBSM,
     &           LLASM,LLBSM,ICONSPA,ICONSPB,
     &           NOCTPA,NOCTPB,MXEXC,IH_OCC_CONS,INTERACT)

*. IF BK approximation is active, check whether block should
* be calculated exactly (1), by diagonal (-1) or is set to zero (0).
             I_DO_EXACT_BLK = 1
             IF(DoBKAP) THEN
               CALL CHECK_BLOCKS_FOR_BK_APPROX(
     &              IATP,IBTP,LLATP,LLBTP,
     &              IASM,IBSM,LLASM,LLBSM,
     &              IOCTPA,IOCTPB,I_DO_EXACT_BLK)
             END IF
C. BK-like approximation stuff
             IF(INTERACT.EQ.0.OR.I_DO_EXACT_BLK.EQ.0) GOTO 10000

             IF(NTEST.GE.100) THEN
               WRITE(6,*) ' Next s block in batch : '
               write(6,*) ' ISBLK IASM IBSM IATP IBTP'
               write(6,'(5I5)')  ISBLK,IASM,IBSM,IATP,IBTP
             END IF
*
             IF(IDC.EQ.2.AND.IASM.EQ.IBSM.AND.IATP.EQ.IBTP.AND.
     &         ((LLBSM.GT.LLASM).OR.
     &         (LLASM.EQ.LLBSM).AND.(LLBTP.GT.LLATP)))
     &         GOTO 8764
*
             IF(NTEST.GE.60) THEN
               WRITE(6,*) ' RSSBCB will be called for '
               WRITE(6,*) ' Sigma block : '
               WRITE(6,*) ' ISOFF ', ISOFF
               WRITE(6,*) ' ISBLK IASM IBSM IATP IBTP'
               WRITE(6,'(5I5)')  ISBLK,IASM,IBSM,IATP,IBTP
               WRITE(6,*) ' C     block : '
               WRITE(6,*) ' ICBLK LLASM LLBSM LLATP LLBTP'
               WRITE(6,'(5I5)')  ICBLK,LLASM,LLBSM,LLATP,LLBTP
               WRITE(6,*) ' ICOFF ', ICOFF
               WRITE(6,*) ' Overall scale',SCLFAC(ICBLK)
             END IF
*
             IF(IRESTRICT.EQ.1.AND.
     &            ((IASM.EQ.LLASM.AND.IBSM.EQ.LLBSM.AND.
     &            IATP.EQ.LLATP.AND.IBTP.EQ.LLBTP     ) .OR.
     &            (IDC.EQ.2.AND.
     &            IASM.EQ.LLBSM.AND.IBSM.EQ.LLASM.AND.
     &         IATP.EQ.LLBTP.AND.IBTP.EQ.LLATP     )     ))THEN
                XFAC = 0.5D0*SCLFAC(ICBLK)
             ELSE
                XFAC = SCLFAC(ICBLK)
             END IF
*. Form of operator in action
C               IF(IPERTOP.NE.0) THEN
*. Not exact Hamiltonian in use
                      IPTSPC = IH0SPC(IATP,IBTP)
                      JPTSPC = IH0SPC(JATP,JBTP)
                      IJOP   = IH0INSPC(IPTSPC)
*
                      IF(IPTSPC.NE.JPTSPC) GOTO 8764
*. BK-like approximation stuff
                IF(I_DO_EXACT_BLK.EQ.1) THEN
                  CALL RSSBCB2(IASM,  IATP,  IBSM,  IBTP,
     &                         LLASM, LLATP, LLBSM, LLBTP,
     &                         NGAS,
     &                         NELFSPGP(1,IATP+IOCTPA-1),
     &                         NELFSPGP(1,IBTP+IOCTPB-1),
     &                         NELFSPGP(1,LLATP+IOCTPA-1),
     &                         NELFSPGP(1,LLBTP+IOCTPB-1),
     &                         NAEL, NBEL, IAGRP, IBGRP,SB(ISOFF),
     &                         CB(ICOFF),IDOH2,ADSXA,STSTSX,
     &                         DXSTST,STSTDX,SXDXSX,NOBPTS,IOBPTS,
     &                         MXPNGAS,ITSOB, MAXI, MAXK, SSCR,
     &                         CSCR,    I1,  XI1S,    I2,  XI2S,
     &                         XINT,    C2, NSMOB, NSMST, NSMSX,
     &                         NSMDX,   NIA,   NIB,  NLLA,  NLLB,
     &                         MXPOBS,   IDC,    CJRES,
     &                         SIRES,    I3,  XI3S,    I4,  XI4S,
     &                         MXSXBL,MXSXST, MOCAA,
     &                         IPRNT,IPERTOP,
     &                         XFAC,IUSE_PH,IPHGAS,
     &                         I_RES_AB,
     &                         XINT2)
                ELSE IF(I_DO_EXACT_BLK.EQ.-1) THEN
*. Giovanni.... transposing sigma and CI vectors:
                  CALL TRPMT3(SB(ISOFF),NIB,NIA,C2)
                  CALL COPVEC(C2,SB(ISOFF),NIA*NIB)
                  CALL TRPMT3(CB(ICOFF),NLLB,NLLA,C2)
                  CALL COPVEC(C2,CB(ICOFF),NLLA*NLLB)
                  FACTOR = 0.0D0
                  CALL ADDDIA_TERM(FACTOR,CB(ICOFF),SB(ISOFF),
     &                             IATP,IBTP,IASM,IBSM)
*. Giovanni.... transposing back sigma and CI vectors:
                  CALL TRPMT3(SB(ISOFF),NIA,NIB,C2)
                  CALL COPVEC(C2,SB(ISOFF),NIA*NIB)
                  CALL TRPMT3(CB(ICOFF),NLLA,NLLB,C2)
                  CALL COPVEC(C2,CB(ICOFF),NLLA*NLLB)
                END IF ! End BK stuff
* CALL RSSBCB2 --> 82
 8764                 CONTINUE
                   END IF
*                  ^ End if S-block should be calculated
10000           CONTINUE
*.              ^  End of loop over sigma blocks
 8765        CONTINUE
          END IF
*         ^ End of C-block is nonvanishing
 9000  CONTINUE
*.     ^ End of loop over C blocks in Batch
20000 CONTINUE
*.    ^End of loop over batches of C blocks
*
* Order
      DO  ISBLK = 1 , NSBLOCK
         IF(ISBLOCK(1,ISBLK).GT.0) THEN
            IATP = ISBLOCK(1,ISBLK)
            IBTP = ISBLOCK(2,ISBLK)
            IASM = ISBLOCK(3,ISBLK)
            IBSM = ISBLOCK(4,ISBLK)
            ISOFF  = ISBLOCK(5,ISBLK)
            ISOFFP = ISBLOCK(6,ISBLK)
            NIA = NSSOA(IASM,IATP)
            NIB = NSSOB(IBSM,IBTP)
            IF(ICJKAIB.NE.0) THEN
*. Tranpose sigma block was obtained, transpose to obtain correct block
               CALL TRPMT3(SB(ISOFF),NSSOB(IBSM,IBTP),
     &              NSSOA(IASM,IATP),C2)
               CALL COPVEC(C2,SB(ISOFF),
     &              NSSOA(IASM,IATP)* NSSOB(IBSM,IBTP))
            END IF
            IF(IDC.EQ.2.AND.IASM.EQ.IBSM.AND.IATP.EQ.IBTP)
     &           CALL TRPAD3(SB(ISOFF),PS,NSSOA(IASM,IATP))
*
         END IF
      END DO
*
      IF(NTEST.GE.50) THEN
         WRITE(6,*) ' output blocks from SBLOCKS '
         CALL WRTTTS(       SB,  ISBLOCK,  NSBLOCK,    NSMST,
     &                   NSSOA,    NSSOB,        1)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HrmFrq(nAtom,nInter,iNeg,dDipM,mTR,DipM,IRInt)

use Slapaf_Info, only: lDoubleIso, lTherm, nsRot, nUserPT, UserP, UserT
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtom, nInter, mTR
integer(kind=iwp), intent(out) :: iNeg
real(kind=wp), intent(inout) :: dDipM(3,nInter+mTR)
real(kind=wp), intent(in) :: DipM(3)
real(kind=wp), intent(out) :: IRInt(nInter+mTR)
integer(kind=iwp) :: iCtl, iEl, iOff, iSym, lModes, Lu_10, mDisp(8), nDoF, nIrrep, nModes, nSym, nX
real(kind=wp), allocatable :: EVal(:), EVec(:), RedMas(:), Temp(:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
nDoF = nInter+mTR
nX = 3*nAtom

call mma_allocate(EVec,nDoF**2,Label='EVec')
call mma_allocate(EVal,nDoF,Label='EVal')
call mma_allocate(RedMas,nDoF,Label='RedMas')
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute harmonic frequencies and dipole derivatives

call GF(nX,nDoF,nInter,EVec,EVal,RedMas,iNeg,dDipM,mTR,nAtom,DipM)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out frequencies and IR intensities

write(u6,10)
write(u6,10) ' Observe that the harmonic oscillator analysis is only valid at stationary points!'
write(u6,10)
write(u6,10) ' Note that rotational and translational degrees have been automatically removed,'
write(u6,10) ' if the energy is invariant to these degrees of freedom.'
write(u6,10)
write(u6,10)
write(u6,10) ' Harmonic frequencies in cm-1'
write(u6,10)
write(u6,10) ' IR Intensities in km/mol'
write(u6,10)

iOff = 0
iCtl = 1
iEl = 3
iSym = 1

call mma_allocate(Temp,3*nDoF,Label='Temp')
call DGeTMO(dDipM,3,3,nInter,Temp,nInter)

Lu_10 = 10
Lu_10 = IsFreeUnit(Lu_10)
call Molcas_Open(lu_10,'UNSYM')

write(Lu_10,'(A,I1)') '*NORMAL MODES SYMMETRY: ',isym
call GF_Print(EVal,EVec,Temp,iEl,nDoF,nInter,iCtl,IRInt,RedMas,Lu_10,iOff)

close(Lu_10)
call mma_deallocate(Temp)

if (lTherm) call Thermo_Driver(UserT,UserP,nUserPT,nsRot,EVal,nInter,lTherm)
!                                                                      *
!***********************************************************************
!                                                                      *
! Do single and double isotope substitutions

call Get_iScalar('NSYM',nIrrep)
if (nIrrep == 1) call IsoLoop(lDoubleIso)
!                                                                      *
!***********************************************************************
!                                                                      *
! Save normal modes for later generation of Molden input.

lModes = 0
nModes = 0
lModes = lModes+nInter*nDoF
nModes = nModes+nInter
!                                                                      *
!***********************************************************************
!                                                                      *
! Write stuff on Molden input file

nSym = 1
mDisp(:) = 0
mDisp(1) = nInter
call Print_Mode_Components(EVec,EVal,nModes,lModes,mDisp)
call Freq_Molden(EVal,nModes,EVec,lModes,nSym,IRInt,mDisp,RedMas)
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate memory

call mma_deallocate(RedMas)
call mma_deallocate(EVal)
call mma_deallocate(EVec)
!                                                                      *
!***********************************************************************
!                                                                      *
return

10 format(a)

end subroutine HrmFrq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRAONE_MOTRA(PAO,PMO,TEMP,CMO)
*
*     Transformation program: one-electron section
*
*     Objective: transformes a one-electron matrix PAO in AO-basis
*                to a molecular orbital matrix PMO.
*
*     Subroutine calls: none
*
*
      IMPLICIT REAL*8 (A-H,O-Z)
*

#include "motra_global.fh"
#include "WrkSpc.fh"
*
      Real*8 CMO(*)
      DIMENSION PAO(*),PMO(*),TEMP(*)
*
*
      ICMO=1
      IAO =1
      IMO =1
      DO 100 ISYM=1,NSYM
         ICMO=ICMO+NBAS(ISYM)*NFRO(ISYM)
         IOFF=1+NBAS(ISYM)*NBAS(ISYM)
         CALL SQUARE(PAO(IAO),TEMP(1),1,NBAS(ISYM),NBAS(ISYM))
C         CALL MXMA(CMO(ICMO),     NBAS(ISYM),1,
C     *             TEMP,          1,NBAS(ISYM),
C     *             TEMP(IOFF),    1,NORB(ISYM),
C     *             NORB(ISYM),NBAS(ISYM),NBAS(ISYM))
         CALL DGEMM_('T','N',NORB(ISYM),NBAS(ISYM),
     *                NBAS(ISYM),1.0d0,CMO(ICMO),
     *                 NBAS(ISYM),TEMP,NBAS(ISYM),
     *                 0.0d0,TEMP(IOFF),MAX(1,NORB(ISYM)))
         CALL MXMT(TEMP(IOFF),    1,NORB(ISYM),
     *             CMO(ICMO),     1,NBAS(ISYM),
     *             PMO(IMO),
     *             NORB(ISYM),NBAS(ISYM))
         ICMO=ICMO+NBAS(ISYM)*(NORB(ISYM)+NDEL(ISYM))
         IAO =IAO +NBAS(ISYM)*(NBAS(ISYM)+1)/2
         IMO =IMO +NORB(ISYM)*(NORB(ISYM)+1)/2
100   CONTINUE
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!***********************************************************************

#include "macros.fh"

!> This module defines an abstract class for CI-solvers.
!> If you inherit from CI_solver_t and override the deferred methods,
!> your initialization and cleanup will be automatically called.
module generic_CI
    use general_data, only : ntot, ntot1, ntot2
    use rasscf_data, only : nAcPar, nAcpr2, nroots
    use definitions, only: wp
    implicit none
    private
    public :: CI_solver_t

    type, abstract :: CI_solver_t
    contains
      procedure(CI_run_t), deferred :: run
      procedure(CI_cleanup_t), deferred :: cleanup
    end type

    abstract interface
!>  @brief
!>      Interface for procedure pointers to CI-solvers
!>
!>  @author Oskar Weser
!>
!>  @param[in] actual_iter The actual iteration number starting at 0.
!>      This means 0 is 1A, 1 is 1B, 2 is 2 and so on.
!>  @param[in] iroot specified roots for SA-CASSCF, e.g. 1,3,9,...
!>  @param[in] weight weights specified for roots for SA-CASSCF
!>  @param[in] CMO MO coefficients
!>  @param[in] DIAF DIAGONAL of Fock matrix useful for NECI
!>  @param[in] D1I_MO Inactive 1-dens matrix
!>  @param[in] TUVX Active 2-el integrals
!>  @param[in,out] F_In Fock matrix from inactive density
!>  @param[in,out] D1S_MO Average spin 1-dens matrix
!>  @param[out] DMAT Average 1 body density matrix
!>  @param[out] PSMAT Average symm. 2-dens matrix
!>  @param[out] PAMAT Average antisymm. 2-dens matrix

        subroutine CI_run_t(this, actual_iter, ifinal, iroot, weight, &
                            CMO, DIAF, D1I_AO, D1A_AO, TUVX, F_IN, &
                            D1S_MO, DMAT, PSMAT, PAMAT)
            import :: CI_solver_t, ntot, ntot1, ntot2, nAcPar, nAcpr2, nroots,&
                      wp

            class(CI_solver_t), intent(in) :: this
            integer, intent(in) :: actual_iter, iroot(nroots), ifinal
            real(wp), intent(in) :: weight(nroots), &
                                  CMO(nTot2), DIAF(nTot), D1I_AO(nTot2), &
                                  D1A_AO(nTot2), TUVX(nAcpr2)
            real(wp), intent(inout) :: F_In(nTot1), D1S_MO(nAcPar)
            real(wp), intent(out) :: DMAT(nAcpar), PSMAT(nAcpr2), PAMAT(nAcpr2)
        end subroutine

!>  @brief
!>      Interface to cleanup routine for CI-solvers
!>
!>  @details
!>  It would be nice to have automatic finalization.
!>  Unfortunately we have to support old compilers.
!>
!>  This method will be called at the end of rasscf.
!>
!>  @author Oskar Weser
        subroutine CI_cleanup_t(this)
            import :: CI_solver_t
            class(CI_solver_t), intent(inout) :: this
        end subroutine

    end interface

    contains

end module generic_CI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Print_T_Values(T_Values,iT_Sets,iANr,EC,Bond_Threshold,
     &                          nAtoms,nij,Standard,iWarnings,
     &                          Num_Warnings,iPrint)
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
      Real*8 T_Values(nij),EC(3,nij)
      Integer iT_Sets(nij),iANr(nAtoms),iWarnings(nij)
      Character*(LENIN) AtomLbl(MxAtom)
      Character*(LENIN4) AtomLbl4(MxAtom)
      Character*17 BondLbl
      Parameter (iLength=25)
      Character*(iLength) Warning
      Logical Standard
*
* Print header
*
      Call Get_cArray('LP_L',AtomLbl4,(LENIN4)*nAtoms)
      Do i=1,nAtoms
       AtomLbl(i)(1:LENIN)=AtomLbl4(i)(1:LENIN)
      EndDo
      ij = 0
      Write(6,*)
      If (Num_Warnings .gt. 0) Then
         Write(6,'(A,I3,A)')
     &              'During optimization of the expansion centers ',
     &              Num_Warnings, ' warnings were encountered.'
         Write(6,*)
         Write(6,'(A)') ' iAtom   jAtom   Atom(s)          Factor'
     &               // '   Bragg-Slater      t      Warning'
      Else
         Write(6,'(A)') ' iAtom   jAtom   Atom(s)          Factor'
     &               // '   Bragg-Slater      t'
      End If
*
* Print informations for the atoms
*
      Do iAtom = 1, nAtoms
         ii = iAtom*(iAtom+1)/2
         If ((iT_sets(ii) .eq. 1 .OR. iPrint .ge. 2)) Then
            Write(BondLbl, '(A)') AtomLbl(iAtom)
            Last_NonBlank = 0
            j = 0
            Do i = 1, 17
               If (BondLbl(i:i) .ne. ' ') Then
                  j = j + 1
                  BondLbl(j:j) = BondLbl(i:i)
                  Last_NonBlank = j
               End If
            End Do
            Do i = Last_NonBlank+1,17
               BondLbl(i:i) = ' '
            End Do
*
            If (Num_Warnings .gt. 0) Then
               Call Warnings(iWarnings(ii),Warning,iLength)
               If (iT_sets(ii) .eq. 1) Then
                  Write(6,'(1X,I3,5X,8X,A17,24X,F7.4,3X,A)')
     &               iAtom,BondLbl,T_Values(ij),Warning
               Else If (Standard) Then
                  Write(6,'(1X,I3,5X,8X,A17,24X,A,3X,A)')
     &               iAtom,BondLbl,'Standard',Warning
               Else
                  Write(6,'(1X,I3,5X,8X,A17,24X,A,3X,A)')
     &               iAtom,BondLbl,'Skipped',Warning
               End If
            Else
               If (iT_sets(ii) .eq. 1) Then
                  Write(6,'(1X,I3,5X,8X,A17,24X,F7.4)')
     &               iAtom,BondLbl,T_Values(ij)
               Else If (Standard) Then
                  Write(6,'(1X,I3,5X,8X,A17,24X,A)')
     &               iAtom,BondLbl,'Standard'
               Else
                  Write(6,'(1X,I3,5X,8X,A17,24X,A)')
     &               iAtom,BondLbl,'Skipped'
               End If
            End If
         End If
      End Do
*
      Write(6,'(79A)') ('-',i=1,79)
*
* Print informations for the bonds
*
      Do iAtom = 1, nAtoms
         ii = iAtom*(iAtom+1)/2
         Do jAtom = 1, iAtom-1
            ij = iAtom*(iAtom-1)/2+jAtom
            If ((iT_sets(ij) .eq. 1 .OR. iPrint .ge. 2)) Then
               jj = jAtom*(jAtom+1)/2
               Factor      = Zero
               Write(BondLbl,'(3A)') AtomLbl(iAtom),'-',
     &                               AtomLbl(jAtom)
               Radius_i    = Bragg_Slater(iANr(iAtom))
               Radius_j    = Bragg_Slater(iANr(jAtom))
               Bond_Length = Sqrt((EC(1,ii)-EC(1,jj))**2
     &                           +(EC(2,ii)-EC(2,jj))**2
     &                           +(EC(3,ii)-EC(3,jj))**2)
               Bond_Max    = Bond_Threshold*(Radius_i+Radius_j)
               Factor      = Bond_Length/Bond_Max
               bs_t        = Radius_i/(Radius_i+Radius_j)-Half
*
               Last_NonBlank = 0
               j = 0
               Do i = 1, 17
                  If (BondLbl(i:i) .ne. ' ') Then
                     j = j + 1
                     BondLbl(j:j) = BondLbl(i:i)
                     Last_NonBlank = j
                  End If
               End Do
               Do i = Last_NonBlank+1,17
                  BondLbl(i:i) = ' '
               End Do
*
               If (Num_Warnings .gt. 0) Then
                  Call Warnings(iWarnings(ij),Warning,iLength)
                  If (iT_sets(ij) .eq. 1) Then
               Write(6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,F7.4,3X,A)')
     &              iAtom,jAtom,BondLbl,Factor,BS_t,T_Values(ij),Warning
                  Else If (Standard) Then
                  Write(6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,A,3X,A)')
     &                iAtom,jAtom,BondLbl,Factor,BS_t,'Standard',Warning
                  Else
                  Write(6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,A,3X,A)')
     &                 iAtom,jAtom,BondLbl,Factor,BS_t,'Skipped',Warning
                  End If
               Else
                  If (iT_sets(ij) .eq. 1) Then
                   Write(6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,F7.4)')
     &                  iAtom,jAtom,BondLbl,Factor,BS_t,T_Values(ij)
                  Else If (Standard) Then
                     Write(6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,A)')
     &                  iAtom,jAtom,BondLbl,Factor,BS_t,'Standard'
                  Else
                     Write(6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,A)')
     &                  iAtom,jAtom,BondLbl,Factor,BS_t,'Skipped'
                  End If
               End If
            End If
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkampqmap(ammap,syma,rc)
! this routine prepares ammap

use ccsort_global, only: noa, mbas, NORB, NSYM, nvb, reclen
use Symmetry_Info, only: Mul
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: ammap(mbas,8,8)
integer(kind=iwp), intent(in) :: syma
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: a, irec, lengthmpq, nrecc, nrest, symam, symm, symp, symq

rc = 0

!T test, if there are any a in this symmetry

if (nvb(syma) == 0) then
  rc = 1
  ! RC=1 : there are no a in this symmetry
  return
end if

! def initial address

irec = 1

! loop over all combinations

do symm=1,nsym
  symam = mul(syma,symm)
  do symp=1,nsym
    symq = mul(symam,symp)

    ! define number of records required to store this block
    ! and determine shift in initial positions

    lengthmpq = noa(symm)*norb(symp)*norb(symq)
    nrecc = int(lengthmpq/reclen)
    nrest = lengthmpq-nrecc*reclen
    if (nrest > 0) nrecc = nrecc+1

    do a=1,nvb(syma)

      ammap(a,symm,symp) = irec
      irec = irec+nrecc

    end do
  end do
end do

return

end subroutine mkampqmap

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      REAL*8 FUNCTION CASVB_PYTHAG(A,B)
      REAL*8 A,B
C
C     FINDS sqrt(A**2+B**2) WITHOUT OVERFLOW OR DESTRUCTIVE UNDERFLOW
C
      REAL*8 P,R,S,T,U
      P = MAX(abs(A),abs(B))
      IF (P .EQ. 0.0D0) GO TO 20
      R = (MIN(abs(A),abs(B))/P)**2
10    CONTINUE
         T = 4.0D0 + R
         IF (T .EQ. 4.0D0) GO TO 20
         S = R/T
         U = 1.0D0 + 2.0D0*S
         P = U*P
         R = (S/U)**2 * R
      GO TO 10
20    CASVB_PYTHAG = P
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakeT2pd(T2p,Tau,aGrp,aSGrp)
! this routine does:
! Make T2p((a>b)",i>=j )  = Tau(i,j,(a>=b)")+Tau(j,i,a>=b)")
!                     from  Tau((a>=b)',i,j)
!
! parameter description:
! T2p   - T2+ array (O)
! Tau   - Tau array (I)
! xGrp  - Group of a (I)
! xSGrp - SubGroup of a (I)

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimGrpa, DimSGrpa, no
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: aGrp, aSGrp
real(kind=wp), intent(out) :: T2p(DimSGrpa(aSGrp),nTri_Elem(no))
real(kind=wp), intent(in) :: Tau(nTri_Elem(DimGrpa(aGrp)),no,no)
integer(kind=iwp) :: dimabp, dimap, dimapp, dimi, dimij

dimi = no
dimij = nTri_Elem(no)

dimap = DimGrpa(aGrp)
dimabp = nTri_Elem(dimap)

dimapp = DimSGrpa(aSGrp)

call makeT2pdHlp(T2p,Tau,aGrp,aSGrp,dimi,dimij,dimapp,dimabp)

return

end subroutine MakeT2pd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Transp_MOs(CMO1,CMO2,nSym,nFro,nIsh,nAsh,
     &                                     nSsh,nBas)
C
C        CMO1(alpha,p) -> CMO2(p,alpha)
C
C        At the same time, exclude Fro and Del orbitals
C
#include "implicit.fh"
      Integer nSym, nFro(nSym), nIsh(nSym), nAsh(nSym)
      Integer nSsh(nSym), nBas(nSym)
      Real*8  CMO1(*), CMO2(*)

      iCount = 0
      lCount = 0
      Do iSym = 1,nSym

         jCount = iCount + nBas(iSym)*nFro(iSym)

         nOrb=nIsh(iSym)+nAsh(iSym)+nSsh(iSym)

         Do i = 1,nOrb
            kOff1 = jCount + nBas(iSym)*(i-1) + 1
            kOff2 = lCount + i
            Call dCopy_(nBas(iSym),CMO1(kOff1),1,CMO2(kOff2),nOrb)
         End Do

         lCount = lCount + nOrb*nBas(iSym)
         iCount = iCount + nBas(iSym)**2

      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine DAN(Dens)
*
      use Basis_Info, only: nBas
      use pso_stuff
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "etwas.fh"
#include "WrkSpc.fh"
      Real*8 Dens(nDens)
      Integer na(0:7),ipcm(0:7)
*
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
      ipD=0
      nnA=0
      ndenssq=0
      ipCC=1
      Do i=0,nIrrep-1
         nDenssq=ndenssq+nBas(i)**2
         nA(i)=nnA
         ipcm(i)=ipCC
         nnA=nnA+nAsh(i)
         ipCC=ipCC+nBAs(i)**2
      End Do
*
      Call GetMem('Temp1','ALLO','REAL',ipTemp1,ndensSQ)
      Call GetMem('Temp2','ALLO','REAL',ipTemp2,ndensSQ)
      Call GetMem('Temp3','ALLO','REAL',ipUrk,ndensSQ)
*
      Do iS=0,nIrrep-1
         call dcopy_(nBas(is)**2,[0.0d0],0,Work(ipTemp1),1)
         If (nBas(is).gt.0) Then
            Do iB=1,nAsh(iS)
               iiB=nA(iS)+iB
               Do jB=1,nAsh(iS)
                  jjB=nA(iS)+jB
                  ijB=iTri(iiB,jjB)
                  ip1=ipTemp1+
     &                nBas(iS)*(nISh(iS)+iB-1)+nIsh(is)+jb -1
                  Work(ip1)=G1(ijB,1)
               End Do
            End Do
*
            Call DGEMM_('N','N',
     &                  nBas(is),nBas(is),nBas(is),
     &                  1.0d0,CMO(ipCM(iS),1),nBas(is),
     &                  Work(ipTemp1),nBas(is),
     &                  0.0d0,Work(ipUrk),nBas(is))
            Call DGEMM_('N','T',
     &                  nBas(is),nBas(is),nBas(is),
     &                  1.0d0,Work(ipUrk),nBas(is),
     &                  CMO(ipCM(is),1),nBas(is),
     &                  0.0d0,Work(ipTemp2),nBas(is))
*
            Do iBas=1,nBas(iS)
               Do jBas=1,iBas
                  ip1=(iBas-1)*nBas(iS)+jBas
                  ip2=iTri(iBas,jBas)
                  Fact=2.0d0
                  If (iBas.eq.jbas) Fact=1.0d0
                  Dens(ipD+ip2)=Work(ipTemp2+ip1-1)*Fact
               End Do
            End Do
            ipD=ipD+nBas(is)*(nBAs(is)+1)/2
         End If
      End Do
      Call GetMem('Temp1','FREE','REAL',ipTemp1,ndensSQ)
      Call GetMem('Temp2','FREE','REAL',ipTemp2,ndensSQ)
      Call GetMem('Temp3','FREE','REAL',ipUrk,ndensSQ)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Coul_DMB(GetFM,nDM,Rep_EN,FM,DMA,DMB,lFDM)

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, r8

implicit none
logical(kind=iwp), intent(in) :: GetFM
integer(kind=iwp), intent(in) :: nDM, lFDM
real(kind=wp), intent(out) :: Rep_EN
real(kind=wp), intent(inout) :: FM(lFDM)
real(kind=wp), intent(in) :: DMA(lFDM), DMB(lFDM)
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: irc
character(len=16) :: NamRfil
type(DSBA_Type) :: DLT, FLT(1)
real(kind=r8), external :: ddot_

if ((nDM > 2) .or. (nDM < 1)) then
  write(u6,*) ' In Coul_DMB: wrong value of nDM= ',nDM
  call SysAbendMsg('Coul_DMB ',' nDM must be 1 or 2 ',' ')
end if

if (GetFM) then

  call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI',Ref=FM)

  call Get_NameRun(NamRfil) ! save the old RUNFILE name
  call NameRun('AUXRFIL')   ! switch RUNFILE name

  call Allocate_DT(DLT,nBas,nBas,nSym,aCase='TRI')
  call get_dArray('D1ao',DLT%A0,lFDM)

  FLT(1)%A0(:) = Zero
  call CHO_FOCK_DFT_RED(irc,DLT,FLT)
  if (irc /= 0) then
    call SysAbendMsg('Coul_DMB ',' non-zero rc ',' ')
  end if
  call GADSum(FM,lFDM)

  call Deallocate_DT(DLT)
  call Deallocate_DT(FLT(1))

  call NameRun(NamRfil) ! switch back RUNFILE name

end if

Rep_EN = ddot_(lFDM,DMA,1,FM,1)
if (nDM == 2) then
  Rep_EN = Rep_EN+ddot_(lFDM,DMB,1,FM,1)
end if

return

end subroutine Coul_DMB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine findNextEffSeg(NvGrp,eff,Nprocs,eff_thrs,maxGrp,printkey)

use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: NvGrp
real(kind=wp), intent(out) :: eff
integer(kind=iwp), intent(in) :: Nprocs, maxGrp, printkey
real(kind=wp), intent(in) :: eff_thrs
integer(kind=iwp) :: tmp1, tmp2
real(kind=wp) :: tmp0

do
  ! calculate theoretical efficiency for o2v4 step
  tmp0 = Half*real(NvGrp**2,kind=wp)
  tmp1 = ceiling(tmp0) ! otazne ... zisti
  tmp0 = real(tmp1,kind=wp)/real(Nprocs,kind=wp)
  tmp2 = ceiling(tmp0)
  eff = Half*real(NvGrp**2,kind=wp)/real(tmp2*Nprocs,kind=wp) ! mozno daj tu tmp

  ! report Np and efficiency
  if (printkey >= 10) write(u6,'(A,i4,A,f6.2)') 'Efficiency check: ',NvGrp,', efficiency: ',eff*100

  if (((eff*100) >= eff_thrs) .or. (NvGrp >= maxGrp)) exit
  NvGrp = NvGrp+1
end do

return

end subroutine findNextEffSeg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_BackTra(iTyp,COcc,CVir,BaseName_AO,DoDiag,Diag)
C
C     Thomas Bondo Pedersen, Dec. 2007.
C
C     Purpose: Backtransform MO vectors to AO basis.
C              The result vectors are stored in lower triangular
C              storage.
C
C     Note: do not call this routine directly; use ChoMP2_VectorMO2AO()
C           instead !!
C
      Implicit None
      Integer iTyp
      Real*8  COcc(*), CVir(*)
      Character*3 BaseName_AO
      Logical DoDiag
      Real*8  Diag(*)
#include "cholesky.fh"
#include "choorb.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"

      Character*14 SecNam
      Parameter (SecNam = 'ChoMP2_BackTra')

      Character*4 FullName_AO

      Integer iSym, iSymb, iSyma, iSymi, iSymAl, iSymBe
      Integer nAB(8), iAB(8,8), nAB_Tot
      Integer lU_AO
      Integer ip_AOVec, l_AOVec, ip_Temp, l_Temp, ip_MOVec, l_MOVec
      Integer ip_Buf, l_Buf
      Integer MaxInCore, nVecInCore, nVecOnDisk, iVec, iOpt, iAdr, lVec
      Integer kCVir, kCOcc, kMOVec, kAOVec, kAOV, kTemp, kDiag
      Integer na, ni, nAl, AlBe, kD, kA

      Integer MulD2h, k, l
      MulD2h(k,l)=iEOr(k-1,l-1)+1

C     Set up index arrays.
C     --------------------

      Call iCopy(8*8,[0],0,iAB,1)
      nAB_Tot = 0
      Do iSym = 1,nSym
         nAB(iSym) = 0
         Do iSymb = 1,nSym
            iSyma = MulD2h(iSymb,iSym)
            iAB(iSyma,iSymb) = nAB(iSym)
            nAB(iSym) = nAB(iSym) + nBas(iSyma)*nBas(iSymb)
         End Do
         nAB_Tot = nAB_Tot + nAB(iSym)
      End Do

C     Backtransform.
C     --------------

      If (DoDiag) Then
         Call dCopy_(nAB_Tot,[0.0d0],0,Diag,1)
      End If

      kDiag = 0
      Do iSym = 1,nSym

         If (nAB(iSym) .lt. 1) Go To 100     ! cycle loop
         If (nMP2Vec(iSym) .lt. 1) Go To 100 ! cycle loop

         iOpt = 1
         Call ChoMP2_OpenF(iOpt,iTyp,iSym)
         Write(FullName_AO,'(A3,I1)') BaseName_AO,iSym
         lU_AO = 7
         Call daName_MF_WA(lU_AO,FullName_AO)

         l_AOVec = nAB(iSym)
         l_Temp  = nT1AOT(iSym)
         l_MOVec = nT1Am(iSym)
         Call GetMem('AOVec','Allo','Real',ip_AOVec,l_AOVec)
         Call GetMem('Temp','Allo','Real',ip_Temp,l_Temp)
         Call GetMem('MOVec','Allo','Real',ip_MOVec,l_MOVec)

         Call GetMem('GetMx','Max ','Real',ip_Buf,l_Buf)
         If (l_Buf .lt. nAB(iSym)) Then
            Call ChoMP2_Quit(SecNam,'Insufficient memory!',' ')
         Else
            Call GetMem('Buffer','Allo','Real',ip_Buf,l_Buf)
         End If
         MaxInCore = min(l_Buf/nAB(iSym),nMP2Vec(iSym))

         nVecOnDisk = 0
         nVecInCore = 0
         Do iVec = 1,nMP2Vec(iSym)

            iOpt = 2
            iAdr = nT1Am(iSym)*(iVec-1) + 1
            lVec = nT1Am(iSym)
            Call ddaFile(lUnit_F(iSym,iTyp),iOpt,Work(ip_MOVec),lVec,
     &                   iAdr)

            Do iSymi = 1,nSym
               iSyma  = MulD2h(iSymi,iSym)
               iSymAl = iSyma
               kCVir  = iAOVir(iSymAl,iSyma) + 1
               kMOVec = ip_MOVec + iT1Am(iSyma,iSymi)
               kTemp  = ip_Temp + iT1AOT(iSymi,iSymAl)
               na     = max(nVir(iSyma),1)
               nAl    = max(nBas(iSymAl),1)
               ni     = max(nOcc(iSymi),1)
               Call DGEMM_('T','T',nOcc(iSymi),nBas(iSymAl),nVir(iSyma),
     &                    1.0d0,Work(kMOVec),na,CVir(kCVir),nAl,
     &                    0.0d0,Work(kTemp),ni)
            End Do

            Do iSymBe = 1,nSym
               iSymAl = MulD2h(iSymBe,iSym)
               iSymi  = iSymBe
               kTemp  = ip_Temp + iT1AOT(iSymi,iSymAl)
               kCOcc  = iT1AOT(iSymi,iSymBe) + 1
               kAOVec = ip_AOVec + iAB(iSymAl,iSymBe)
               ni     = max(nOcc(iSymi),1)
               nAl    = max(nBas(iSymAl),1)
               Call DGEMM_('T','N',
     &                    nBas(iSymAl),nBas(iSymBe),nOcc(iSymi),
     &                    1.0d0,Work(kTemp),ni,COcc(kCOcc),ni,
     &                    0.0d0,Work(kAOVec),nAl)
            End Do

            If (DoDiag) Then
               kAOV = ip_AOVec - 1
               Do AlBe = 1,nAB(iSym)
                  kD = kDiag + AlBe
                  kA = kAOV + AlBe
                  Diag(kD) = Diag(kD) + Work(kA)*Work(kA)
               End Do
            End If

            Call dCopy_(nAB(iSym),Work(ip_AOVec),1,
     &                           Work(ip_Buf+nVecInCore),MaxInCore)
            nVecInCore = nVecInCore + 1

            If (nVecInCore.eq.MaxInCore .or.
     &          iVec.eq.nMP2Vec(iSym)) Then
               Do AlBe = 1,nAB(iSym)
                  iOpt = 1
                  iAdr = nMP2Vec(iSym)*(AlBe-1) + nVecOnDisk + 1
                  lVec = nVecInCore
                  Call ddaFile(lU_AO,iOpt,
     &                         Work(ip_Buf+MaxInCore*(AlBe-1)),lVec,
     &                         iAdr)
               End Do
               nVecOnDisk = nVecOnDisk + nVecInCore
               nVecInCore = 0
            End If

         End Do
#if defined (_DEBUGPRINT_)
         If (nVecOnDisk.ne.nMP2Vec(iSym) .or. nVecInCore.ne.0) Then
            Call ChoMP2_Quit(SecNam,'Logical bug detected!',' [1]')
         End If
#endif

         Call GetMem('Buffer','Free','Real',ip_Buf,l_Buf)
         Call GetMem('MOVec','Free','Real',ip_MOVec,l_MOVec)
         Call GetMem('Temp','Free','Real',ip_Temp,l_Temp)
         Call GetMem('AOVec','Free','Real',ip_AOVec,l_AOVec)

         Call daClos(lU_AO)
         iOpt = 2
         Call ChoMP2_OpenF(iOpt,iTyp,iSym)

  100    Continue ! cycle loop point

         If (DoDiag) kDiag = kDiag + nAB(iSym)

      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_OpenVR(iOpt)
C
C     Purpose: open (iOpt=1) or close (iOpt=2) local and global storage
C              files.
C
      Use Para_Info, Only: nProcs, Is_Real_Par
      Implicit None
      Integer iOpt
#include "cholesky.fh"
      Integer ID
#include "cho_para_info.fh"
#include "choglob.fh"
      Integer iSym
      Character*5 FNRed
      Character*6 FNRst, FNVec(8)
      Character*12 SecNam
      Parameter (SecNam = 'Cho_P_OpenVR')

C     Local files.
C     ------------

      If (Cho_Real_Par) Then
         ID = 1
      Else
         ID = 2
      End If
      Call Cho_OpenVR(iOpt,ID)

C     Global files for restart info and reduced set indices.
C     ------------------------------------------------------

      If (Cho_Real_Par) Then
         If (iOpt .eq. 1) Then
            LuRed_G = 7
            FNRed = 'CHRED'
            Call DAName_MF_WA(LuRed_G,FNRed)
            LuRst_G = 7
            FNRst = 'CHORST'
            Call DAName_MF_WA(LuRst_G,FNRst)
            Do iSym = 1,nSym
               LuCho_G(iSym) = 7
               Write(FNVec(iSym),'(A5,I1)') 'CHVEC',iSym
               Call DaName_MF_WA(LuCho_G(iSym),FNVec(iSym))
            End Do
         Else If (iOpt .eq. 2) Then
            If (LuRed_G .gt. 0) Then
               Call DAClos(LuRed_G)
               LuRed_G = 0
            End If
            If (LuRst_G .gt. 0) Then
               Call DAClos(LuRst_G)
               LuRst_G = 0
            End If
            Do iSym = 1,nSym
               If (LuCho_G(iSym) .gt. 0) Then
                  Call DaClos(LuCho_G(iSym))
                  LuCho_G(iSym) = 0
               End If
            End Do
         Else
            Write(Lupri,*) SecNam,': iOpt out of bounds: ',iOpt
            Call Cho_Quit('Error in '//SecNam,104)
         End If
      Else
         If (CHO_FAKE_PAR .and. nProcs.gt.1 .and. Is_Real_Par()) Then
            If (iOpt .eq. 1) Then
               If (CHO_ADRVEC .eq. 1) Then
                  Do iSym = 1,nSym
                     LuCho_G(iSym) = 7
                     Write(FNVec(iSym),'(A5,I1)') 'CHVCL',iSym
                     Call DaName_MF_WA(LuCho_G(iSym),FNVec(iSym))
                  End Do
               Else If (CHO_ADRVEC .eq. 2) Then
                  Do iSym = 1,nSym
                     LuCho_G(iSym) = 7
                     Write(FNVec(iSym),'(A5,I1)') 'CHVCL',iSym
                     Call DaName_MF(LuCho_G(iSym),FNVec(iSym))
                  End Do
               Else
                  Call Cho_Quit('CHO_ADRVEC out of bounds in '//SecNam,
     &                          102)
                  Call iZero(LuCho_G,nSym)
               End If
C              Swap units so that
C                 LuCho_G points to 'CHVEC'
C                 LuCho   points to 'CHVCL'
               Call iSwap(nSym,LuCho,1,LuCho_G,1)
            Else If (iOpt .eq. 2) Then
               Do iSym = 1,nSym
                  If (LuCho_G(iSym) .gt. 0) Then
                     Call DaClos(LuCho_G(iSym))
                     LuCho_G(iSym) = 0
                  End If
               End Do
            Else
               Write(Lupri,*) SecNam,': iOpt out of bounds: ',iOpt
               Call Cho_Quit('Error in '//SecNam,104)
            End If
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine getmoblk_cvb(cmoblk)

use casvb_global, only: filename, nbasisq_mo, strtmo
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: cmoblk(nbasisq_mo)
integer(kind=iwp) :: iad, iadr15(15), ibf, lujob

call mkfn_cvb(strtmo,ibf)
lujob = 15
call daname_cvb(lujob,filename(ibf))
iad = 0
call iDaFile(lujob,2,iadr15,15,iad)
iad = iadr15(2)
call dDaFile(lujob,2,cmoblk,nbasisq_mo,iad)
call daclos_cvb(lujob)

return

end subroutine getmoblk_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine x2c_makx(m,n,f,s,x)
C
C Make X matrix from m-dimensional (m=2n) Fork(f) and Overlap(s) matrix
C
C   X is the relation(transfer) matrix of Large--Small component coefficients
C   of electron solutions (positive energy solutions)
C
      implicit none
#include "WrkSpc.fh"
C Input
      integer m,n
      Real*8 f(m,m),s(m,m)
C Output
      Real*8 x(n,n)
C Temp
      integer i,j,k
      integer lwork,info,itmp,iw,itF,itS
C
      lwork = 8*m
      call getmem('TmpF ','ALLOC','REAL', itF, m*m+4 )
      call getmem('TmpS ','ALLOC','REAL', itS, m*m+4 )
      call getmem('Eig  ','ALLOC','REAL',  iw, m+4 )
      call getmem('Work ','ALLOC','REAL', itmp, lwork+4 )
C
C Copy Fock and Overlap matrix to temp arrays
C
      k = 0
      do i=1,m
        do j=1,m
          Work(itF+k) = f(j,i)
          Work(itS+k) = s(j,i)
          k = k + 1
        end do
      end do
C
C Diagonalization of Fock matrix with given overlap matrix
C
      call dsygv_(1,'V','L',m,Work(itF),m,Work(itS),m,
     &           Work(iw),Work(itmp),lwork,info)
C
C Calculate the X matrix from electron solutions
C
      k = 0
      do i=1,n
        do j=1,n
C          ! store large component coefficients of electron solutions (matrix A)
          Work(itF+k) = Work(itF-1+j+(i+n-1)*m)
C          ! store small component coefficients of electron solutions (matrix B)
          Work(itS+k) = Work(itF-1+j+n+(i+n-1)*m)
          k = k + 1
        end do
      end do
C     ! compute X=BA^{-1}
      call XDR_dmatinv(Work(itF),n)
      call dmxma(n,'N','N',Work(itS),Work(itF),x,1.d0)
C
C Free temp memories
C
      call getmem('TmpF ','FREE','REAL', itF, m*m+4 )
      call getmem('TmpS ','FREE','REAL', itS, m*m+4 )
      call getmem('Eig  ','FREE','REAL',  iw, m+4 )
      call getmem('Work ','FREE','REAL', itmp, lwork+4 )
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_X_Init_Par_DF(irc)
!
! Purpose: setup for parallel DF.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
#ifdef _DEBUGPRINT_
use Para_Info, only: MyRank
#endif
use Cholesky, only: nSym, NumCho, NumChT
#endif
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(out) :: irc
character(len=*), parameter :: SecNam = 'Cho_X_Init_Par_DF'
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: nV(8)
logical(kind=iwp) :: isSerial
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iSym
#endif

irc = 0

! Return if serial.
! -----------------

isSerial = (nProcs == 1) .or. (.not. Is_Real_Par())
if (isSerial) then
# ifdef _DEBUGPRINT_
  write(u6,*) SecNam,': serial run, nothing to do...'
  write(u6,*) '#nodes: ',nProcs,'  myRank: ',myRank
# endif
  return
# ifdef _DEBUGPRINT_
else
  write(u6,*) SecNam,': parallel run...'
  write(u6,*) '#nodes: ',nProcs,'  myRank: ',myRank
# endif
end if

! Reset number of vectors to the number on this node as stored on
! the runfile.
! ---------------------------------------------------------------

nV(1:nSym) = NumCho(1:nSym)
call Get_iArray('nVec_RI',NumCho,nSym)
NumChT = sum(NumCho(1:nSym))

#ifdef _DEBUGPRINT_
! Debug print.
! ------------

write(u6,*)
write(u6,*) 'Output from ',SecNam,':'
write(u6,*) 'NumCho before: ',(nV(iSym),iSym=1,nSym)
write(u6,*) 'NumCho after : ',(NumCho(iSym),iSym=1,nSym)
#endif

#else

irc = 0
#ifdef _DEBUGPRINT_
write(u6,*) SecNam,': serial run, nothing to do...'
#endif

#endif

end subroutine Cho_X_Init_Par_DF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Fake(U2,mT,nRys,ZEInv)
************************************************************************
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             May '90                                                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 U2(mT,nRys), ZEInv(mT)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(U2)
         Call Unused_real_array(ZEInv)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine ReaW3hlp1 (Ww,Wx,dima,dimbe,dimb,no,LunName,LunAux)
c
c        this routine do:
c        reconstruct  Ww(a",be',b,i)  for aSGrp>beSGrp
c        from (a",be'|b,i) records in V3 file LunName
c
        implicit none
        integer dima,dimbe,dimb,no,LunAux
        character*8 LunName
        real*8 Ww(1)
        real*8 Wx(1)
c
c        help variables
c
        integer length

*       open (unit=LunAux,file=LunName,form='unformatted')
        Call Molcas_BinaryOpen_Vanilla(LunAux,LunName)
c
        length=dima*dimbe*dimb*no
c
c        read block (a",be'|b,_i)
        call rea_chcc (LunAux,length,Ww(1))
cmp        call mv0zero (length,length,Ww(1))
c
        close (LunAux)
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_real_array(Wx)
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OptRMS_Slapaf(x,y,nAt,RMS,RMSMax)

use Symmetry_Info, only: VarR, VarT
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(inout) :: x(3,nAt)
real(kind=wp), intent(in) :: y(3,nAt)
real(kind=wp), intent(out) :: RMS, RMSMax
integer(kind=iwp) :: i, ixyz
real(kind=wp) :: diff, disp

! Only align if energy is rotational and translational invariant.
! (no weighting)

if (.not. (VarR .or. VarT)) then
  call Superpose(x,y,nAt,RMS,RMSMax)
else

  ! Otherwise, just compute RMS

  RMS = Zero
  RMSMax = Zero
  do i=1,nAt
    disp = Zero
    do ixyz=1,3
      diff = x(ixyz,i)-y(ixyz,i)
      RMS = RMS+diff**2
      disp = disp+diff**2
    end do
    if (sqrt(disp) > RMSMax) RMSMax = sqrt(disp)
  end do
  RMS = sqrt(RMS/real(nAt,kind=wp))
end if

return

end subroutine OptRMS_Slapaf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine queries the existence of array data on runfile.         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: August 2003                                                 *
!                                                                      *
!***********************************************************************
!  Qpg_cArray
!
!> @brief
!>   Check if a field exist on the runfile
!> @author Per-Olof Widmark
!>
!> @details
!> This routine queries the existence of array data on runfile.
!>
!> @param[in]  Label Name of field
!> @param[out] Found Was the field found
!> @param[out] nData Length of field
!>
!> @see ::Put_cArray
!***********************************************************************

subroutine Qpg_cArray(Label,Found,nData)

use RunFile_data, only: lw, nTocCA, sSpecialField
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: Label
logical(kind=iwp), intent(out) :: Found
integer(kind=iwp), intent(out) :: nData
integer(kind=iwp) :: i, item, iTmp, nTmp, RecIdx(nTocCA), RecLen(nTocCA)
character(len=lw) :: CmpLab1, CmpLab2, RecLab(nTocCA)

!----------------------------------------------------------------------*
! Read info from runfile.                                              *
!----------------------------------------------------------------------*
call ffRun('cArray labels',nTmp,iTmp)
if (nTmp == 0) then
  Found = .false.
  nData = 0
  return
end if
call cRdRun('cArray labels',RecLab,lw*nTocCA)
call iRdRun('cArray indices',RecIdx,nTocCA)
call iRdRun('cArray lengths',RecLen,nTocCA)
!----------------------------------------------------------------------*
! Locate item                                                          *
!----------------------------------------------------------------------*
item = -1
CmpLab1 = Label
call UpCase(CmpLab1)
do i=1,nTocCA
  CmpLab2 = RecLab(i)
  call UpCase(CmpLab2)
  if (CmpLab1 == CmpLab2) item = i
end do

! Do we read an old temporary field?

if (item /= -1) then
  if (RecIdx(item) == sSpecialField) then
    write(u6,*) '***'
    write(u6,*) '*** Warning, querying temporary cArray field'
    write(u6,*) '***   Field: ',Label
    write(u6,*) '***'
#   ifndef _DEVEL_
    call AbEnd()
#   endif
  end if
end if
!----------------------------------------------------------------------*
! Did we manage to find it?                                            *
!----------------------------------------------------------------------*
Found = .true.
if (item == -1) Found = .false.
if ((item /= -1) .and. (RecIdx(item) == 0)) Found = .false.
if (Found) then
  nData = RecLen(item)
else
  nData = 0
end if
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine Qpg_cArray

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Dmat_MCLR(CMO,OCC,D)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Compute the active one-body density                              *
*                                                                      *
*     calling arguments:                                               *
*     CMO     : input, array of real*8                                 *
*               MO-coefficients                                        *
*     OCC     : input, array of real*8                                 *
*               occupation numbers                                     *
*     D       : output, array of real*8                                *
*               total one-body density                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension CMO(*) , OCC(*) , D(*)


#include "Input.fh"
#include "WrkSpc.fh"

      iOff1 = 0
      iOff2 = 0
      iOff3 = 0
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        If ( iBas.ne.0 ) then
          Do i = 1,iBas
            ii = (i*i-i)/2
            Do j = 1,i
              Sum = 0.0d0
              Do k = 1,ibas
                Sum = Sum + OCC(iOff3+k)
     &                    * CMO(iOff1+(k-1)*iBas+i)
     &                    * CMO(iOff1+(k-1)*iBas+j)
              End Do
              D(iOff2+ii+j) = 2.0d0*Sum
              If (j.eq.i) D(iOff2+ii+j) = Sum
            End Do
          End Do
        End If
        iOff1 = iOff1 + iBas*iBas
        iOff2 = iOff2 + (iBas*iBas+iBas)/2
        iOff3 = iOff3 + iBas
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_MOTra_Inner(CMO,nCMOs,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,BName,Do_int,ihdf5,Do_ChoInit)
! Note: frozen and deleted orbitals are not included in the transformation.

use Symmetry_Info, only: Mul
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCMOs, nSym, nBas(nSym), nFro(nSym), nIsh(nSym), nAsh(nSym), nSsh(nSym), nDel(nSym), ihdf5
real(kind=wp), intent(in) :: CMO(nCMOs)
character(len=6), intent(in) :: BName
logical(kind=iwp), intent(in) :: Do_int, Do_ChoInit
integer(kind=iwp) :: irc, iSym, iSymp, iSymq, jSym, kdisk, Lu_Xint, lXint, n, nAux(8), nOrbp, nOrbq
real(kind=wp) :: FracMem
type(DSBA_Type), target :: CMOT(1)
real(kind=wp), allocatable :: xInt(:)
integer(kind=iwp), external :: isFreeUnit
#include "chotime.fh"

n = nBas(1)**2
do iSym=2,nSym
  n = n+nBas(iSym)**2
end do
if (n /= nCMOs) then
  ! The dimension of CMO is assumed to be nBas**2 in Transp_MOs
  ! with each symmetry block starting at
  !  sym=1: 1
  !  sym=2: 1+nBas(1)**2
  !  sym=3: 1+nBas(1)**2+nBas(2)**2
  ! etc.
  ! This differs from, e.g., subroutine PriMO where each
  ! symmetry block starts at
  !  sym=1: 1
  !  sym=2: 1+nBas(1)*nOrb(1)
  !  sym=3: 1+nBas(1)*nOrb(1)+nBas(2)*nOrb(2)
  ! etc.
  ! This is only a potential problem if orbitals were removed
  ! due to linear dependence (not deleted virtual orbitals)
  call WarningMessage(2,'Cho_MOTra_: n != nCMOs')
  write(u6,*) 'n,nCMOs=',n,nCMOs
  call Abend()
end if

nAux(1:nSym) = nBas(1:nSym)-nFro(1:nSym)-nDel(1:nSym)
call Allocate_DT(CMOT(1),nAux,nBas,nSym)

call Transp_MOs(CMO,CMOT(1)%A0,nSym,nFro,nIsh,nAsh,nSsh,nBas)

timings = .true.

if (Do_int) then
  Lu_Xint = 80
  Lu_Xint = isfreeunit(Lu_Xint)
  call DaName_mf_wa(Lu_Xint,'DIAGINT')
  lXint = 0
  do jSym=1,nSym
    do iSymq=1,nSym
      nOrbq = nIsh(iSymq)+nAsh(iSymq)+nSsh(iSymq)
      iSymp = Mul(iSymq,jSym)
      if (iSymp == iSymq) then
        lXint = lXint+nOrbq*(nOrbq+1)/2
      else if (iSymp < iSymq) then
        nOrbp = nIsh(iSymp)+nAsh(iSymp)+nSsh(iSymp)
        lXint = lXint+nOrbp*nOrbq
      end if
    end do
  end do
  call mma_allocate(xInt,lXint,Label='xInt')
else
  lXint = 1
  call mma_allocate(xInt,lXint,Label='xInt')
end if

if (Do_ChoInit) then
  FracMem = Zero ! in a parallel run set it to a sensible value
  irc = 0
  call Cho_X_Init(irc,FracMem) ! initialize cholesky info
  if (irc /= 0) then
    call WarningMessage(2,'Cho_MOTra_: non-zero rc from Cho_X_Init')
    write(u6,*) 'rc=',irc
    call Abend()
  end if
end if
call CHO_TR_drv(irc,nIsh,nAsh,nSsh,CMOT,BName,Do_int,ihdf5,xInt,lXint)
if (Do_ChoInit) then
  call Cho_X_final(irc)
  if (irc /= 0) then
    call WarningMessage(2,'Cho_MOTra_: non-zero rc from Cho_X_Final')
    write(u6,*) 'rc=',irc
    call Abend()
  end if
end if

if (Do_int) then
  call GADSum(xInt,lXint)
  kdisk = 0
  call ddafile(Lu_Xint,1,Xint,lXint,kdisk)
  call daclos(Lu_Xint)
end if
call mma_deallocate(XInt)
call Deallocate_DT(CMOT(1))

return

end subroutine Cho_MOTra_Inner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1994,1996, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine Tnchlf_h(Coeff1,nCntr1,nPrm1,Coeff2,nCntr2,nPrm2,lZeta,nVec,IncVec,A1,A2,A3,Indij)
!***********************************************************************
!                                                                      *
! Object: to do a half transformation. The loop over the two matrix-   *
!         matrix multiplications is segmented such that the end of the *
!         intermediate matrix will not push the start of the same out  *
!         from the cache.                                              *
!                                                                      *
! Author:     Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!                                                                      *
!             Modified to decontraction May 1996, by R. Lindh          *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCntr1, nPrm1, nCntr2, nPrm2, lZeta, nVec, IncVec, Indij(lZeta)
real(kind=wp), intent(in) :: Coeff1(nPrm1,nCntr1), Coeff2(nPrm2,nCntr2), A1(nCntr1,nCntr2,nVec)
real(kind=wp), intent(out) :: A2(nCntr2,IncVec*nPrm1), A3(nVec,lZeta)
integer(kind=iwp) :: iCntr1, iCntr2, iiVec, ijVec, iPrm1, iPrm2, iZeta, mVec
logical(kind=iwp) :: Seg1, Seg2

! Check if the basis set is segmented

Seg1 = .false.
loop1: do iPrm1=nPrm1,1,-1
  do iCntr1=nCntr1,1,-1
    if (Coeff1(iPrm1,iCntr1) == Zero) then
      Seg1 = .true.
      exit loop1
    end if
  end do
end do loop1

Seg2 = .false.
loop2: do iPrm2=nPrm2,1,-1
  do iCntr2=nCntr2,1,-1
    if (Coeff2(iPrm2,iCntr2) == Zero) then
      Seg2 = .true.
      exit loop2
    end if
  end do
end do loop2

! Set output matrix to zero

A3(:,:) = Zero

! Loop sectioning

do iiVec=1,nVec,IncVec
  mVec = min(IncVec,nVec-iiVec+1)
  ! Set intermediate matrix to zero
  A2(:,1:mVec*nPrm1) = Zero

  if (Seg1) then

    ! First quarter transformation

    do iPrm1=1,nPrm1
      ijVec = mVec*(iPrm1-1)+1
      do iCntr1=1,nCntr1
        ! Check for zero due to segmented basis
        if (abs(Coeff1(iPrm1,iCntr1)) > Zero) then
          do iCntr2=1,nCntr2
            A2(iCntr2,ijVec:ijVec+mVec-1) = A2(iCntr2,ijVec:ijVec+mVec-1)+Coeff1(iPrm1,iCntr1)*A1(iCntr1,iCntr2,iiVec:iiVec+mVec-1)
          end do
        end if
      end do
    end do

  else  ! Seg1

    ! First quarter transformation

    do iPrm1=1,nPrm1
      ijVec = mVec*(iPrm1-1)+1
      do iCntr1=1,nCntr1
        do iCntr2=1,nCntr2
          A2(iCntr2,ijVec:ijVec+mVec-1) = A2(iCntr2,ijVec:ijVec+mVec-1)+Coeff1(iPrm1,iCntr1)*A1(iCntr1,iCntr2,iiVec:iiVec+mVec-1)
        end do
      end do
    end do

  end if  ! Seg1

  if (Seg2) then

    ! Second quarter transformation

    do iCntr2=1,nCntr2
      do iZeta=1,lZeta
        iPrm2 = (Indij(iZeta)-1)/nPrm1+1
        iPrm1 = Indij(iZeta)-(iPrm2-1)*nPrm1
        ! Check for zero due to segmented basis
        if (abs(Coeff2(iPrm2,iCntr2)) > Zero) then
          ijVec = mVec*(iPrm1-1)+1
          A3(iiVec:iiVec+mVec-1,iZeta) = A3(iiVec:iiVec+mVec-1,iZeta)+Coeff2(iPrm2,iCntr2)*A2(iCntr2,ijVec:ijVec+mVec-1)
        end if
      end do
    end do

  else

    ! Second quarter transformation

    do iCntr2=1,nCntr2
      do iZeta=1,lZeta
        iPrm2 = (Indij(iZeta)-1)/nPrm1+1
        iPrm1 = Indij(iZeta)-(iPrm2-1)*nPrm1
        ijVec = mVec*(iPrm1-1)+1
        A3(iiVec:iiVec+mVec-1,iZeta) = A3(iiVec:iiVec+mVec-1,iZeta)+Coeff2(iPrm2,iCntr2)*A2(iCntr2,ijVec:ijVec+mVec-1)
      end do
    end do

  end if

  ! End of loop sectioning

end do

return

end subroutine Tnchlf_h

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000-2016, Valera Veryazov                             *
************************************************************************
      subroutine f_inquire(NAME,exist)
      Character*(*) name
      Integer StrnLn
      External StrnLn
      Logical exist
      Character*256 RealName
#ifdef _SOLARIS_
      Character*256 FTMP1,FTMP2
      Integer n,irc
      n=Len(name)
200   If(name(n:n).eq.' ') Then
         n=n-1
         Go To 200
      End If
      n=n+1
      ftmp1=name
      ftmp1(n:n)=Char(0)
      exist=.true.
      irc=-1
      FTMP2='                           '//
     &      '                           '
      Call PrgmTranslate(Name,RealName,lRealName)
      FTMP1(1:lRealName)=RealNAME(1:lRealName)
c         print *,'before fndlnk', FTMP1
      call fndlnk(irc,FTMP1,FTMP2)
      if (irc.ne.0) exist=.false.
#else

        Call PrgmTranslate(Name,RealName,lRealName)
c      print *,'Debug inquire:', RealNAME(1:lRealName)
        inquire(file=RealNAME(1:lRealName),exist=exist)
#endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!               2000, Valera Veryazov                                  *
!               2014, Thomas Dresselhaus                               *
!***********************************************************************

subroutine MOEvalDel(MOValueD,nMOs,nCoor,CCoor,CMOs,nCMO,DoIt)

use Definitions, only: wp, iwp

implicit none
integer, parameter :: nDrv = 1, mAO = 4
integer(kind=iwp), intent(in) :: nMOs, nCoor, nCMO, DoIt(nMOs)
real(kind=wp), intent(out) :: MOValueD(mAO,nCoor,nMOs)
real(kind=wp), intent(in) :: CCoor(3,nCoor), CMOs(nCMO)

call MOEval(MOValueD,nMOs,nCoor,CCoor,CMOs,nCMO,DoIt,nDrv,mAO)

return

end subroutine MOEvalDel

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine initwrk(length)
! this routine calculates required size of work space and
! defines initial positions of work vectors

use ccsort_global, only: fullprint, mapdri, mapiri, noa, NORB, NSYM, pos10, pos20, pos30, posri0, t3key
use Symmetry_Info, only: Mul
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: length
integer(kind=iwp) :: n, norbmax, sizempq, sizeri, sizev1, sizev2, sizevint, syma, symi, symj, symm, symmp, symp, sympq, sympqi, symq

!1 def maxsize of vint

norbmax = norb(1)
do n=1,nsym
  if (norb(n) > norbmax) norbmax = norb(n)
end do

sizevint = norbmax*norbmax*norbmax

!2 def size of <pq|i>=j>, <pq|i,j>

sizev1 = 0
sizev2 = 0
do symp=1,nsym
  do symq=1,nsym
    sympq = mul(symp,symq)
    do symi=1,nsym
      sympqi = mul(sympq,symi)
      symj = sympqi
      ! calc. length
      if (symj > symi) then
        sizev2 = sizev2+noa(symi)*noa(symj)*NORB(symp)*NORB(symq)
      else
        sizev1 = sizev1+noa(symi)*noa(symj)*NORB(symp)*NORB(symq)
        sizev2 = sizev2+noa(symi)*noa(symj)*NORB(symp)*NORB(symq)
      end if
    end do
  end do
end do

!3 def maxsize of <_am|pq>

sizempq = 0
do syma=1,nsym

  length = 0
  do symm=1,nsym
    do symp=1,nsym
      symmp = mul(symm,symp)
      symq = mul(syma,symmp)
      ! calc. length
      length = length+noa(symm)*NORB(symp)*NORB(symq)
    end do
  end do

  if (sizempq < length) sizempq = length

end do

!4 def maxsize of R_i if needed

sizeri = 0

if (t3key == 1) then
  do symi=1,nsym
    call ccsort_t3grc0(3,8,4,4,4,0,symi,1,length,mapdri,mapiri)
    length = length-1
    if (length > sizeri) sizeri = length
  end do
end if

! ******* distribution of memory ******

pos10 = 1+sizevint
pos20 = pos10+sizev1
pos30 = pos20+sizev2
posri0 = pos30+sizempq
length = posri0+sizeri-1

if (fullprint > 1) then
  write(u6,*)
  write(u6,'(6X,A)') 'size of help (work) vectors:'
  write(u6,'(6X,A)') '----------------------------'
  write(u6,*)
  write(u6,'(6X,A,I8)') 'Vints     V0 required : ',sizevint
  write(u6,'(6X,A,I8)') 'PQIJ ints V1 required : ',sizev1
  write(u6,'(6X,A,I8)') '          V2 required : ',sizev2
  write(u6,'(6X,A,I8)') 'AMIJ ints V3 required : ',sizempq
  write(u6,'(6X,A,I8)') 'R_i mtx   Ri required : ',sizeri
end if

if (fullprint >= 0) write(u6,'(6X,A,I20)') 'Required WRK size-sum : ',length

return

end subroutine initwrk

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NucInd(coor,kdc,ifgrd,ifhss,indgrd,indhss,
     &                  jfgrd,jfhss,jndgrd,jndhss,tr,ifg)
      use Real_Spherical
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "disp.fh"
#include "disp2.fh"

      Real*8 Coor(3,4)
      Integer IndGrd(0:2,0:1,0:(nIrrep-1)),
     &        IndHss(0:1,0:2,0:1,0:2,0:(nIrrep-1))
      Logical IfHss(0:1,0:2,0:1,0:2),IfGrd(0:2,0:1), TstFnc, TF,
     &        IfG(0:3),Tr(0:3)
      Integer JndGrd(0:2,0:3,0:(nIrrep-1)),
     &        JndHss(0:3,0:2,0:3,0:2,0:(nIrrep-1))
*
      Logical JfHss(0:3,0:2,0:3,0:2),JfGrd(0:2,0:3),EQ
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      IX(i1,i2)=i1*(i1-1)/2+i2
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*                                                                      *
************************************************************************
*                                                                      *
c     iRout = 150
c     iPrint = nPrint(iRout)
*
      Call ICopy(nIrrep*16*9,[0],0,JndHss,1)
      Call iCopy(nIrrep*4*3,[0],0,JndGrd,1)
      Call LCopy(144,[.False.],0,jfHss,1)
      Call LCopy(4,[.False.],0,Tr,1)
      Call LCopy(12,[.False.],0,jfGrd,1)
*
*     COPY CNTLR MATRIXES
*
      Do  iAtom = 0, 1
         Do iCar  = 0, 2
            JfGrd(iCar,iAtom) = Ifgrd(iCar,iAtom)
            Do iIrrep=0,nIrrep-1
               JndGrd(iCar,iAtom,iIrrep)=
     &              IndGrd(iCar,iAtom,iIrrep)
            End Do
            Do  jAtom = 0, 1
               Do  jCar = 0, 2
                  JfHss(iAtom,iCar,jAtom,jCar) =
     &                 IfHss(iAtom,iCar,jAtom,jCar)
                  Do iIrrep=0,nIrrep-1
                     JndHss(iAtom,iCar,jAtom,jCar,iIrrep) =
     &                    IndHss(iAtom,iCar,jAtom,jCar,iIrrep)
                  End Do ! iirrep
               End Do !jCar
            End Do ! jAtom
         End Do !iCar
      End Do !iAtom

*
*
*-----------Derivatives with respect to the operator is computed via the
*     translational invariance.
*
      nnIrrep=nIrrep
      If (sIrrep) nnIrrep=1
      Do  iIrrep=0,nnIrrep-1
         nDisp = IndDsp(kdc,iIrrep)
         Do  iCar = 0, 2
            iComp = 2**iCar
            If (TF(kdc,iIrrep,iComp)) Then
               nDisp = nDisp + 1
*
*--------------------Reset flags for the basis set centers so that we
*     will explicitly compute the derivatives with
*     respect to those centers. Activate flag for the
*     third center so that its derivative will be comp-
*     uted by the translational invariance.
*
               JndGrd(iCar,0,iIrrep) = Abs(JndGrd(iCar,0,iIrrep))
               JndGrd(iCar,1,iIrrep) = Abs(JndGrd(iCar,1,iIrrep))
               JndGrd(iCar,2,iIrrep) = -nDisp
               JfGrd(iCar,0) = .True.
               JfGrd(iCar,1) = .True.
               JfGrd(iCar,2) = .False.
            Else
               JndGrd(iCar,2,iIrrep) = 0
            End If
        End DO
      End DO
*
*     The third center is calculated by translation invariance
*     This requires the 2nd derivatives on the other centers.
*

      Do iCar=0,2
         Do jAtom=0,2
            if (jAtom.eq.2) Then
               iStop=iCar
            Else
               iStop=2
            End If
            Do jCar=0,iStop
               Do iIrrep=0,nIrrep-1
                  If ((JndGrd(iCar,    2,iIrrep).ne.0).and.
     &                (JndGrd(jCar,jAtom,iIrrep).ne.0)) Then
                     JndHss(2,iCar,jAtom,jCar,iIrrep)=
     &                    -IX(Max(Abs(JndGrd(iCar,2,iIrrep)),
     &                    Abs(JndGrd(jCar,jAtom,iIrrep))),
     &                    Min(Abs(JndGrd(iCar,2,iIrrep)),
     &                    Abs(JndGrd(jCar,jAtom,iIrrep))))

                     Tr(2)=.true.
                     If (jAtom.eq.2) Then
                        Maxi=Max(iCar,jCar)
                        Mini=Min(iCar,jCar)
                        jfHss(0,Maxi,0,Mini)=.true.
                        jfHss(1,Maxi,1,Mini)=.true.
                        jfHss(1,iCar,0,jCar)=.true.
                        jfHss(1,jCar,0,iCar)=.true.
                     Else
                        Maxi=Max(iCar,jCar)
                        Mini=Min(iCar,jCar)
                        jfHss(jAtom,Maxi,jAtom,Mini)=.true.
                        jfHss(1,iCar,0,jCar)=.true.
                        jfHss(1,jCar,0,iCar)=.true.
                     End If ! jAtom == 2
                  End If ! if indgrd
               End Do  ! iirrep
            End Do ! jCar
         End Do ! jAtom
      End Do ! iCar
*
      IfG(0)=.true.
      IfG(1)=.true.
      IfG(2)=.false.
      IfG(3)=.false.
      Do iCent=0,1
         If (EQ(Coor(1,iCent+1),Coor(1,3) ) ) Then
            IfG(iCent)=.false.
            Do iCar=0,2
               jfGrd(iCar,iCent)=.false.
               Do kCar=0,2
                  Do KCent=0,3
                     jfHss(iCent,iCar,kCent,kCar)=.false.
                     jfHss(kCent,kCar,iCent,iCar)=.false.
                     Do iIrrep=0,nIrrep-1
                        jndHss(iCent,iCar,kCent,kCar,iIrrep)=0
                        jndHss(kCent,kCar,iCent,iCar,iIrrep)=0
                     End Do !iIrrep
                  End Do ! kcent
               End Do !kCar
               Do iIrrep=0,nIrrep-1
                  jndGrd(iCar,iCent,iIrrep)=0
               End Do !iIrrep
            End Do !ICat
         End If ! uf eq
      End Do !icent
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine saverest1 (wrk,wrksize,
     & lunrst)
c
c     this routine save restart informations:
c     t13,t14,t21,t22,t23
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer lunrst
c
c     help variables
c
       integer rc
c
c0    return if need
       if (keyrst.eq.0) return
c
c1    rewind tape
       call filemanager (2,lunrst,rc)
c
c2    write T1aa
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt13,mapit13,rc)
c
c3    write T1bb
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt14,mapit14,rc)
c
c4    write T2aaaa
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt21,mapit21,rc)
c
c5    write T2bbbb
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt22,mapit22,rc)
c
c6    write T2abab
       call wrtmediate (wrk,wrksize,
     & lunrst,mapdt23,mapit23,rc)
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE CNFORD_GAS( IOCCLS, NOCCLS,   ISYM, PSSIGN, IPRCSF,
     &                      ICONF_OCC,ICONF_REO,ICTSDT,IBLOCK,NBLOCK)
*
* Generate configurations in ICONF
*
* Generate determinants in configuration order and obtain
* sign array for switching between the two formats.
*
*
* It is assumed that CSFDIM has been called
*
* Jeppe Olsen Dec. 2001 from CNFORD
*
*
#include "implicit.fh"
#include "mxpdim.fh"
#include "spinfo_lucia.fh"
#include "glbbas.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "cgas.fh"
*. Specific input
       INTEGER IOCCLS(NGAS,NOCCLS)
       INTEGER IBLOCK(8,NBLOCK)
*. Output
      INTEGER ICONF_OCC(*),ICONF_REO(*)
      DIMENSION ICTSDT(*)
*
      NTEST = 0
      NELEC = IELSUM(IOCCLS(1,1),NGAS)
C
      IDUM=1
      CALL GETMEM('ZSCR  ','ALLO','INTE',KLZSCR,(NOCOB+1)*(NELEC+1))
      CALL GETMEM('Z     ','ALLO','INTE',KLZ,NOCOB*NELEC*2)
      CALL GETMEM('OCMIN ','ALLO','INTE',KLOCMIN,NOCOB)
      CALL GETMEM('OCMAX ','ALLO','INTE',KLOCMAX,NOCOB)
*. Zero configuration reorder array using NCONF_ALL_SYM
      IZERO = 0
c     CALL ISETVC(WORK(KICONF_REO(ISYM)),IZERO,NCONF_ALL_SYM)
      CALL ISETVC(iWORK(KICONF_REO(ISYM)),IZERO,NCONF_tot)
*
* Generate configurations for all occupation classes
*
      IB_OCCLS = 1
      DO JOCCLS = 1, NOCCLS
*. Save offset to current occupation class
*
*        KIB_OCCLS seems no longer to be used. Therefore the call to
*        ITOR is commented out to avoid having unitialized arrays
*        floating around and in case of ITOR there's even written to
*        this undefined piece of memory.
*
*        / Jesper Wisborg Krogh, 2005-06-22
*
C_REMOVED         CALL ITOR(WORK(KIB_OCCLS(ISYM)),1,IB_OCCLS,JOCCLS)
*.Max and min arrays for strings
      CALL MXMNOC_OCCLS(iWORK(KLOCMIN),iWORK(KLOCMAX),
     &                  NGAS,NOBPT,IOCCLS(1,JOCCLS),MINOP,NTEST)
*. the arcweights
         CALL CONF_GRAPH(iWORK(KLOCMIN),iWORK(KLOCMAX),
     &                   NOCOB, NELEC,iWORK(KLZ),NCONF_P,iWORK(KLZSCR))
*
         IF(JOCCLS.EQ.1) THEN
            INITIALIZE_CONF_COUNTERS = 1
         ELSE
            INITIALIZE_CONF_COUNTERS = 0
         END IF
         IDOREO = 1
*. Lexical addressing for configurations of this type
         IB_OCCLS = IBCONF_ALL_SYM_FOR_OCCLS(JOCCLS)
*
         CALL GEN_CONF_FOR_OCCLS(IOCCLS(1,JOCCLS),
     &                           IB_OCCLS,
     &                           INITIALIZE_CONF_COUNTERS,
     &                             NGAS,  ISYM, MINOP, MAXOP, NSMST,
     &                                0,
*
     &                            NOCOB,
     &                            NOBPT,
     &                           NCONF_PER_OPEN(1,ISYM),
     &                           NCONF_OCCLS,
     &                           IB_CONF_REO,
*
     &                           IB_CONF_OCC,
     &                           iWORK(KICONF_OCC(ISYM)),
     &                           IDOREO,
     &                           iWORK(KLZ),
     &                           NCONF_ALL_SYM,
*
     &                           iwork(kiconf_reo(isym)),
     &                           nconf_tot)
c      write(6,*)'nconf_per_open after 2nd call of gen_conf_for_occls'
c      call iwrtma(nconf_per_open,1,4,1,4)
c     write(6,*)'nconf_tot in gen_conf_for_occls',nconf_tot
*
C     GEN_CONF_FOR_OCCLS(
C    &    IOCCLS,IB_OCCLS,INITIALIZE_CONF_COUNTERS,
C    &    NGAS,ISYM,MINOP,MAXOP,NSMST,IONLY_NCONF,NTORB,NOBPT,
C    &
C    NCONF_OP,IBCONF_REO,IBCONF_OCC,ICONF,IDOREO,IZ_CONF,IREO,NCONF_ALL_SYM)
CError  IB_OCCLS = IB_OCCLS + NCONF_ALL_SYM
      END DO
*
* Reorder Determinants from configuration order to ab-order
*
C          REO_GASDET(INBLOCK,NBLOCK,ISYM,IREO,SREO )
      CALL REO_GASDET(IBLOCK,NBLOCK,ISYM,ICTSDT)

C     CALL CNTOST(ICONF,SGNCTS,ICTSDT,IWORK,IDCNF(1),IREFSM,
C    &            IREFML,IREFG,XNDXCI,NORB,NEL,ORBSYM,
C    &            ICNFOK,IGENSG,ISGNA,ISGNB,IPRCSF)
*
      CALL GETMEM('ZSCR  ','FREE','INTE',KLZSCR,(NOCOB+1)*(NELEC+1))
      CALL GETMEM('Z     ','FREE','INTE',KLZ,NOCOB*NELEC*2)
      CALL GETMEM('OCMIN ','FREE','INTE',KLOCMIN,NOCOB)
      CALL GETMEM('OCMAX ','FREE','INTE',KLOCMAX,NOCOB)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_real(PSSIGN)
        CALL Unused_integer(IPRCSF)
        CALL Unused_integer_array(ICONF_OCC)
        CALL Unused_integer_array(ICONF_REO)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DMATRIX(E,F,Z,IPRINT)

C   THIS ROUTINE COMPUTES THE USUAL D-TENSOR ON THE BASIS OF COEFFICIENTS
C   OF THE STEVENS OPERATORS OF ORDER 2 (ES AND FS) AND DIAGONALIZE IT
C   TO OBTAIN THE MAIN ANISOTROPY AXES
C

      Implicit None
      Integer, parameter         :: wp=kind(0.d0)
      Integer, intent(in)        :: iprint
      Real(kind=8),intent(in)   :: Z(3,3)
      Complex(kind=8),intent(in):: E(0:2), F(0:2)
      Integer                    :: I, INFO, J
      Real(kind=8)              :: WD(3), CF,Unity(3,3), SMAT(3,3),
     &                              DMATR(3,3), ZD(3,3),
     &                              dtens(3), daxes(3,3), D_factor,
     &                              E_factor, diff12, diff23, ZD2(3,3)
      Complex(kind=8)           :: DMAT(3,3)


      CF=sqrt(3.0_wp/2.0_wp)

      DMAT(1,1) =  CF*E(2)-E(0)
      DMAT(2,2) = -CF*E(2)-E(0)
      DMAT(3,3) =  2.0_wp*E(0)
      DMAT(1,2) =  CF*F(2)
      DMAT(1,3) =  CF*E(1)
      DMAT(2,3) =  CF*F(1)
      DMAT(2,1) =  DMAT(1,2)
      DMAT(3,1) =  DMAT(1,3)
      DMAT(3,2) =  DMAT(2,3)

      Do i=1,3
        Do j=1,3
          DMATR(i,j)=DBLE(DMAT(i,j))
        End Do
      End Do

      Call DIAG_R2(DMATR,3,INFO,WD,ZD)

c  calculate the rotation matrix:
      Call dcopy_(3*3,[0.0_wp],0,Unity,1)
      Do i=1,3
        Unity(i,i)=1.0_wp
      End Do

      Call DGEMM_('N','N',3,3,3,1.0_wp,ZD,3,Unity,3,0.0_wp,SMAT,3)

C Set the dtens and daxes with respect to the gtens and maxes.
cccccccccccccccccccccccccccccccc
      dtens(:)=0.0_wp
      If ( (abs(SMAT(1,1)).gt.abs(SMAT(1,2))) .AND.
     &     (abs(SMAT(1,1)).gt.abs(SMAT(1,3))) ) Then
c  the WD(1) and ZD(i,1) correspond to gtens(1) and maxes(i,1)
        dtens(1)=WD(1)
        If (SMAT(1,1).gt.0.0_wp) Then
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(1,1) is larger than SMAT(1,2) and ' //
     &                     'SMAT(1,3) and is positive'
          End If
          Do i=1,3
            daxes(i,1)=ZD(i,1)
          End Do
        Else
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(1,1) is larger than SMAT(1,2) and ' //
     &                     'SMAT(1,3) and is negative'
          End If
          Do i=1,3
            daxes(i,1)=-ZD(i,1)
          End Do
        End If

      Else If ( (abs(SMAT(1,2)).gt.abs(SMAT(1,1))) .AND.
     &          (abs(SMAT(1,2)).gt.abs(SMAT(1,3))) ) Then
c the WD(1) and ZD(i,1) correspond to gtens(2) and maxes(i,2)
        dtens(1)=WD(2)
        If (SMAT(1,2).gt.0.0_wp) Then
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(1,2) is larger than SMAT(1,1) and ' //
     &                     'SMAT(1,3) and is positive'
          End If
          Do i=1,3
            daxes(i,1)=ZD(i,2)
          End Do
        Else
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(1,2) is larger than SMAT(1,1) and ' //
     &                     'SMAT(1,3) and is negative'
          End If
          Do i=1,3
            daxes(i,1)=-ZD(i,2)
          End Do
        End If

      Else If ( (abs(SMAT(1,3)).gt.abs(SMAT(1,1))) .AND.
     &          (abs(SMAT(1,3)).gt.abs(SMAT(1,2))) ) Then
c the WD(1) and ZD(i,1) correspond to gtens(3) and maxes(i,3)
        dtens(1)=WD(3)
        If (SMAT(1,3).gt.0.0_wp) Then
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(1,3) is larger than SMAT(1,1) and ' //
     &                     'SMAT(1,2) and is positive'
          End If
          Do i=1,3
            daxes(i,1)=ZD(i,3)
          End Do
        Else
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(1,3) is larger than SMAT(1,1) and ' //
     &                     'SMAT(1,2) and is negative'
          End If
          Do i=1,3
            daxes(i,1)=-ZD(i,3)
          End Do
        End If
      End If
cccccccccccccccccccccccccccccccc

      If ( (abs(SMAT(2,1)).gt.abs(SMAT(2,2))) .AND.
     &     (abs(SMAT(2,1)).gt.abs(SMAT(2,3))) ) Then
c  the WD(2) and ZD(i,2) correspond to gtens(1) and maxes(i,1)
        dtens(2)=WD(1)
        If (SMAT(2,1).gt.0.0_wp) Then
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(2,1) is larger than SMAT(2,2) and ' //
     &                     'SMAT(2,3) and is positive'
          End If
          Do i=1,3
            daxes(i,2)=ZD(i,1)
          End Do
        Else
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(2,1) is larger than SMAT(2,2) and ' //
     &                     'SMAT(2,3) and is negative'
          End If
          Do i=1,3
            daxes(i,2)=-ZD(i,1)
          End Do
        End If

      Else If ( (abs(SMAT(2,2)).gt.abs(SMAT(2,1))) .AND.
     &          (abs(SMAT(2,2)).gt.abs(SMAT(2,3))) ) Then
c the WD(2) and ZD(i,2) correspond to gtens(2) and maxes(i,2)
        dtens(2)=WD(2)
        If (SMAT(2,2).gt.0.0_wp) Then
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(2,2) is larger than SMAT(2,1) and ' //
     &                     'SMAT(2,3) and is positive'
          End If
          Do i=1,3
            daxes(i,2)=ZD(i,2)
          End Do
        Else
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(2,2) is larger than SMAT(2,1) and ' //
     &                     'SMAT(2,3) and is negative'
          End If
          Do i=1,3
            daxes(i,2)=-ZD(i,2)
          End Do
        End If

      Else If ( (abs(SMAT(2,3)).gt.abs(SMAT(2,1))) .AND.
     &          (abs(SMAT(2,3)).gt.abs(SMAT(2,2))) ) Then
c the WD(2) and ZD(i,2) correspond to gtens(3) and maxes(i,3)
        dtens(2)=WD(3)
        If (SMAT(2,3).gt.0.0_wp) Then
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(2,3) is larger than SMAT(2,1) and ' //
     &                     'SMAT(2,2) and is positive'
          End If
          Do i=1,3
            daxes(i,2)=ZD(i,3)
          End Do
        Else
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(2,3) is larger than SMAT(2,1) and ' //
     &                     'SMAT(2,2) and is negative'
          End If
          Do i=1,3
            daxes(i,2)=-ZD(i,3)
          End Do
        End If
      End If

cccccccccccccccccccccccccccccccc
      If ( (abs(SMAT(3,1)).gt.abs(SMAT(3,2))) .AND.
     &     (abs(SMAT(3,1)).gt.abs(SMAT(3,3))) ) Then
c  the WD(3) and ZD(i,3) correspond to gtens(1) and maxes(i,1)
        dtens(3)=WD(1)
        If (SMAT(3,1).gt.0.0_wp) Then
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(3,1) is larger than SMAT(3,2) and ' //
     &                     'SMAT(3,3) and is positive'
          End If
          Do i=1,3
            daxes(i,3) = ZD(i,1)
          End Do
        Else
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(3,1) is larger than SMAT(3,2) and ' //
     &                     'SMAT(3,3) and is negative'
          End If
          Do i=1,3
            daxes(i,3) =-ZD(i,1)
          End Do
        End If

      Else If ( (abs(SMAT(3,2)).gt.abs(SMAT(3,1))) .AND.
     &          (abs(SMAT(3,2)).gt.abs(SMAT(3,3))) ) Then
c the WD(3) and ZD(i,3) correspond to gtens(2) and maxes(i,2)
        dtens(3)=WD(2)
        If (SMAT(3,2).gt.0.0_wp) Then
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(3,2) is larger than SMAT(3,1) and ' //
     &                     'SMAT(3,3) and is positive'
          End If
          Do i=1,3
            daxes(i,3) = ZD(i,2)
          End Do
        Else
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(3,2) is larger than SMAT(3,1) and ' //
     &                     'SMAT(3,3) and is negative'
          End If
          Do i=1,3
            daxes(i,3) =-ZD(i,2)
          End Do
        End If

      Else If ( (abs(SMAT(3,3)).gt.abs(SMAT(3,1))) .AND.
     &          (abs(SMAT(3,3)).gt.abs(SMAT(3,2))) ) Then
c the WD(3) and ZD(i,3) correspond to gtens(3) and maxes(i,3)
        dtens(3)=WD(3)
        If (SMAT(3,3).gt.0.0_wp) Then
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(3,3) is larger than SMAT(3,1) and ' //
     &                     'SMAT(3,2) and is positive'
          End If
          Do i=1,3
            daxes(i,3)=ZD(i,3)
          End Do
        Else
          If(IPRINT.gt.2) Then
            Write(6,'(a)') 'SMAT(3,3) is larger than SMAT(3,1) and ' //
     &                     'SMAT(3,2) and is negative'
          End If
          Do i=1,3
            daxes(i,3)=-ZD(i,3)
          End Do
        End If
      End If

      Call DGEMM_('N','N',3,3,3,1.0_wp,Z,3,daxes,3,0.0_wp,ZD2,3)

      diff12=abs(dtens(1)-dtens(2))
      diff23=abs(dtens(2)-dtens(3))

      If(diff12.gt.diff23) Then
        D_factor=1.5_wp*dtens(1)
        E_factor=(dtens(2)-dtens(3))/2.0_wp
      Else
        D_factor=1.5_wp*dtens(3)
        E_factor=(dtens(1)-dtens(2))/2.0_wp
      End If



      If(iprint.gt.2) Then
        Write(6,'(20X,A)') 'D-TENSOR:'
        Write(6,*)
        Write(6,'(10X,A,10X,3(F9.5,2X))') '|  xx    xy    xz  |',
     &   (DMATR(1,J),J=1,3)
        Write(6,'(10X,A,10X,3(F9.5,2X))') '|  yx    yy    yz  |',
     &   (DMATR(2,J),J=1,3)
        Write(6,'(10X,A,10X,3(F9.5,2X))') '|  zx    zy    zz  |',
     &   (DMATR(3,J),J=1,3)
        Write(6,*)
      End If

      If(iprint.GE.2) Then
        Write(6,*)
        Write(6,'(A)') 'D TENSOR:'
        Write(6,'(90a)') ('-',i=1,84),'|'
        Write(6,'(A,4x,A,27x,A,21x,a,3x,a)') 'MAIN VALUES','|',
     &           'MAIN ANISOTROPY AXES','|',
     &           'x , y , z  -- initial Cartesian axes'
        Write(6,'(85a,3x,a)') ('-',i=1,15),'|',('-',i=1,36),'|',
     &           ('-',i=1,31), '|', 'Xm, Ym, Zm -- main magnetic axes'
        Write(6,
     &    '(15x,a,4x,a,5x,a,8x,a,8x,a,4x,a,5x,a,9x,a,9x,a,5x,a,3x,a)')
     &           '|','|','Xm','Ym','Zm','|','x','y','z','|',
     &           'Xa, Ya, Za -- main anisotropy axes'
        Write(6,'(90a)') ('-',i=1,15),'|',('-',i=1,4),'|',('-',i=1,31),
     &           '|',('-',i=1,31),'|'
        Write(6,'(A,F9.3,A,3F10.6,1x,A,3F10.6,1x,A)') ' Dx =',dtens(1),
     &           ' | Xa |',(daxes(j,1),j=1,3),'|',(ZD2(j,1),j=1,3),'|'
        Write(6,'(A,F9.3,A,3F10.6,1x,A,3F10.6,1x,A)') ' Dy =',dtens(2),
     &           ' | Ya |',(daxes(j,2),j=1,3),'|',(ZD2(j,2),j=1,3),'|'
        Write(6,'(A,F9.3,A,3F10.6,1x,A,3F10.6,1x,A)') ' Dz =',dtens(3),
     &           ' | Za |',(daxes(j,3),j=1,3),'|',(ZD2(j,3),j=1,3),'|'
        Write(6,'(90a)') ('-',i=1,84),'|'
        Write(6,*)
        Write(6,'(A)') '2-nd order ZFS Hamiltonian:'
        Write(6,*)
        Write(6,'(A)') 'H_zfs^{2}= D * [S_{Za}^2 - S*(S+1)/3] + E * '//
     &           '[S_{Xa}^2 - S_{Ya}^2]'
        Write(6,*)
        Write(6,'(A)') 'Anisotropy parameters: D = 3/2 * Dz;  E = '//
     &           '(Dx-Dy)/2;'
        Write(6,'(a,F9.4)') 'D = ', D_factor
        Write(6,'(a,F9.4)') 'E = ', E_factor
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Per Ake Malmqvist                                *
************************************************************************
      SUBROUTINE MKPROJ(CRVEC,CMO,TUVX)
      use stdalloc, only: mma_allocate, mma_deallocate
      use rasscf_global, only: CORESHIFT
      use general_data, only: NCRVEC,NTOT2,NASH,NBAS

      implicit None
      Real*8 CRVEC(NCRVEC), CMO(NTOT2)
      Real*8 TUVX(*)

      Real*8, Allocatable:: CS_TMP(:)
      REAL*8 CS_TU, CS_TUV, COREPROJ
      Integer NA, NB, IPOS, ITU, IT, IU, IVX, IV, IXMX, IX
      Real*8, External:: DDot_

      NA=NASH(1)
      NB=NBAS(1)

      CALL mma_allocate(CS_TMP,NB,Label='CS_TMP')
      DO IT=1,NA
        CS_TMP(IT)=DDOT_(NB,CMO((IT-1)*NB+1),1,CRVEC,1)
      END DO

      IPOS=0
      ITU=0
      DO IT=1,NA
        DO IU=1,IT
          CS_TU=CS_TMP(IT)*CS_TMP(IU)
          ITU=ITU+1
          IVX=0
          DO IV=1,IT
            CS_TUV=CS_TU*CS_TMP(IV)
            IXMX=IV
            IF(IT.eq.IV) IXMX=IU
            DO IX=1,IXMX
              IVX=IVX+1
              IPOS=IPOS+1
              COREPROJ=CS_TUV*CS_TMP(IX)
              TUVX(IPOS)=TUVX(IPOS)+CORESHIFT*COREPROJ
            END DO
          END DO
        END DO
      END DO

      CALL mma_deallocate(CS_TMP)

      END SUBROUTINE MKPROJ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ProdsS_1(AB,iAB,CMO,nMO,Y)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iAB, nMO
real(kind=wp), intent(in) :: AB(iAB*(iAB+1)/2), CMO(iAB,nMO)
real(kind=wp), intent(out) :: Y(iAB,nMO)
real(kind=wp), allocatable :: ABSq(:,:)

call mma_allocate(ABSq,iAB,iAB,Label='ABSq')
call SQUARE(AB,ABSq,1,iAB,iAB)
call DGEMM_('N','N',iAB,nMO,iAB,One,ABSq,iAB,CMO,iAB,Zero,Y,iAB)
call mma_deallocate(ABSq)

return

end subroutine ProdsS_1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine RdMx(RadMax,rExp,nExp,Cff,nCff,cdMax,EtMax)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             August '91                                               *
!***********************************************************************

use Constants, only: Zero, Two, Three, Pi
use Definitions, only: wp, iwp, r8

implicit none
real(kind=wp), intent(inout) :: RadMax, cdMax, EtMax
integer(kind=iwp), intent(in) :: nExp, nCff
real(kind=wp), intent(in) :: rExp(nExp), Cff(nExp,nCff)
#ifdef _DEBUGPRINT_
#include "print.fh"
#endif
integer(kind=iwp) :: iExp
real(kind=wp) :: Alpha, Beta, c, cc, Eta, Rho, ssss, Zeta
real(kind=r8), external :: DDot_

#ifdef _DEBUGPRINT_
iRout = 201
iPrint = nPrint(iRout)

call RecPrt('rExp',' ',rExp,nExp,1)
call RecPrt('Cff',' ',Cff,nExp,nCff)
#endif
do iExp=1,nExp

  cc = DDot_(nCff,Cff(iExp,1),nExp,Cff(iExp,1),nExp)
  c = sqrt(cc)

  Alpha = rExp(iExp)
  Beta = rExp(iExp)
  Zeta = Alpha+Beta
  if (Zeta > Zero) then
    Eta = Alpha+Beta
    Rho = (Zeta*Eta)/(Zeta+Eta)

    ssss = c**4*Two*sqrt(Rho/Pi)*(Pi/Zeta)**(Three/Two)*(Pi/Eta)**(Three/Two)
    if (sqrt(ssss) > RadMax) then
      RadMax = sqrt(ssss)
      EtMax = Eta
      cdMax = sqrt(ssss)
    end if
  end if

end do

end subroutine RdMx

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on May. 21, 2020, created this file.               *
! ****************************************************************

subroutine XMSRot(CMO,FI,FA)

use Index_Functions, only: nTri_Elem
use rasscf_global, only: LROOTS, NAC
use general_data, only: NTOT1, NTOT2
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: CMO(NTOT2), FI(NTOT1), FA(NTOT1)
real(kind=wp), allocatable :: EigVec(:,:), FckO(:,:), FckS(:,:), GDMat(:,:,:)

!FckO:  Fock matrix for MO
!FckS:  Fock matrix for states
!GDMat: density matrix or transition density matrix

! Allocating Memory
call mma_allocate(GDMat,nTri_Elem(lRoots),NAC,NAC)
call mma_allocate(FckO,NAC,NAC)
call mma_allocate(FckS,lRoots,lRoots)
call mma_allocate(EigVec,lRoots,lRoots)

call CalcFckO(CMO,FI,FA,FckO)

call GetGDMat(GDMAt)

call CalcFckS(FckO,GDMat,FckS)

call CalcEigVec(FckS,lRoots,EigVec)

call printmat('ROT_VEC','XMS-PDFT',eigvec,lroots,lroots,7,8,'N')
! Deallocating Memory
call mma_deallocate(GDMat)
call mma_deallocate(FckO)
call mma_deallocate(FckS)
call mma_deallocate(EigVec)

end subroutine XMSRot

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               2024, Matthew R Hennefarth                             *
!***********************************************************************

subroutine open_files_mcpdft(DSCF)

use Fock_util_global, only: docholesky
use general_data, only: jobiph, jobold, luinta, luintm, luonel
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp), intent(out) :: DSCF
#include "warnings.h"
integer(kind=iwp) :: iOpt, return_code
logical(kind=iwp) :: file_exists

!---  define logical unit numbers -------------------------------------*
!...  Job interface unit (-1 shows it has not been opened!)
JOBIPH = -1
!...  Old RASSCF job interface for input MO's and CI vector
JOBOLD = -1
!...  AO one-electron integrals
LUONEL = 16
!...  AO two-electron integrals
LUINTA = 40
!...  MO two-electron integrals
LUINTM = 13
! Opening the JOBIPH file is delayed till after input processing at end
! of READIN_RASSCF. Only then is file name known.

!--- open the one-electron integrals

return_code = -1
iOpt = 0
call OpnOne(return_code,iOpt,'ONEINT',LUONEL)
if (return_code /= _RC_ALL_IS_WELL_) then
  write(u6,*) 'MC-PDFT tried to open a file (ONEINT) containing'
  write(u6,*) 'one-electron integrals, but failed. Something is'
  write(u6,*) 'wrong with the file. Most probably it is simply'
  write(u6,*) 'missing: please check. It should have been created'
  write(u6,*) 'by SEWARD. Perhaps it is in the wrong directory?'
  call Abend()
end if

!---  open the ORDINT file --------------------------------------------*
call f_Inquire('ORDINT',file_exists)
call DecideOnDirect(.true.,file_exists,DSCF,DoCholesky)
if ((.not. DSCF) .and. (.not. DoCholesky)) then
  return_code = -1
  iOpt = 0
  call OpnOrd(return_code,iOpt,'ORDINT',LUINTA)
  if (return_code /= _RC_ALL_IS_WELL_) then
    write(u6,*) 'MC-PDFT tried to open a file (ORDINT) containing'
    write(u6,*) 'two-electron integrals, but failed. Something'
    write(u6,*) 'is wrong with the file. Most probably it is'
    write(u6,*) 'simply missing: Please check. It should have'
    write(u6,*) 'been created by SEWARD. Perhaps it is in the'
    write(u6,*) 'wrong directory?'
    call Abend()
  end if
else
  call f_Inquire('RUNFILE',file_exists)
  if (.not. file_exists) then
    write(u6,*) 'MC-PDFT tried to open a file (RUNFILE) containing'
    write(u6,*) 'data from previous program steps. Something'
    write(u6,*) 'is wrong with the file. Most probably it is'
    write(u6,*) 'simply missing: Please check. It should have'
    write(u6,*) 'been created by SEWARD.'
    call Abend()
  end if
end if
!---  open the file carrying the transfromed two-electron integrals ---*
call DaName(LUINTM,'TRAINT')

end subroutine open_files_mcpdft

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine Rys2Dg(xyz2D0,nT,nRys,la,lb,lc,ld,xyz2D1,IfGrad,
     &                  IndGrd,Coora,Alpha,Beta,Gamma,Delta,nZeta,
     &                  nEta,Scrtch,Temp,Index,ExpX,ExpY,mZeta,mEta)
************************************************************************
*                                                                      *
* Object: to compute the gradients of the 2D-integrals.                *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      External ExpX, ExpY
#include "print.fh"
#include "real.fh"
      Real*8 xyz2D0(nRys*nT,0:la+1,0:lb+1,0:lc+1,0:ld+1,3),
     &       xyz2D1(nRys*nT,0:la  ,0:lb  ,0:lc  ,0:ld  ,3,3),
     &       Coora(3,4),
     &       Alpha(nZeta), Beta(nZeta), Gamma(nEta), Delta(nEta),
     &       Scrtch(nRys*nT), Temp(nT)
      Logical IfGrad(3,4), EQ
      Integer IndGrd(3,4), Ind1(3), Ind2(3), Index(3,4)
*
      iRout = 249
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' In Rys2Dg: Alpha',' ',Alpha,1,nZeta)
         Call RecPrt(' In Rys2Dg: Beta ',' ',Beta ,1,nZeta)
         Call RecPrt(' In Rys2Dg: Gamma',' ',Gamma,1,nEta )
         Call RecPrt(' In Rys2Dg: Delta',' ',Delta,1,nEta )
         Write (6,*) ' IfGrad=',IfGrad
         Write (6,*) ' IndGrd=',IndGrd
      End If
#endif
      tOne = -One
      tTwo = Two
      nx = 0
      ny = 0
      nz = 0
      Call ICopy(12,[0],0,Index,1)
*
*     Differentiate with respect to the first center
*
      If (IfGrad(1,1) .or.IfGrad(2,1) .or.
     &                    IfGrad(3,1)) Then
         Call ExpX(Temp  ,mZeta,mEta,Alpha,One)
         Call Exp_2(Scrtch,nRys,nT,Temp,One)
*        If (iPrint.ge.99) Call RecPrt(
*    &      'Expanded exponents (alpha)',' ',Scrtch,
*    &      nT,nRys)
      End If
      nVec = 0
      If (IfGrad(1,1)) Then
         nx = nx + 1
         nVec = nVec + 1
         Ind1(nVec) = nx
         Ind2(nVec) = 1
         Index(1,1) = nx
      End If
      If (IfGrad(2,1)) Then
         ny = ny + 1
         nVec = nVec + 1
         Ind1(nVec) = ny
         Ind2(nVec) = 2
         Index(2,1) = ny
      End If
      If (IfGrad(3,1)) Then
         nz = nz + 1
         nVec = nVec + 1
         Ind1(nVec) = nz
         Ind2(nVec) = 3
         Index(3,1) = nz
      End If
      If (nVec.eq.0) Go To 211
*
      Do 101 id = 0, ld
         Do 201 ic = 0, lc
            Do 301 ib = 0, lb
               If (nVec.eq.3) Then
                  Do 501 iVec = 1, nT*nRys
                     xyz2D1(iVec,0,ib,ic,id,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,1,ib,ic,id,Ind2(1))
                     xyz2D1(iVec,0,ib,ic,id,Ind2(2),Ind1(2)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,1,ib,ic,id,Ind2(2))
                     xyz2D1(iVec,0,ib,ic,id,Ind2(3),Ind1(3)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,1,ib,ic,id,Ind2(3))
 501              Continue
                  If (la.ge.1) Then
                     Fact = tOne
                     Do 511 ia = 1, la
                        Do 521 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia+1,ib,ic,id,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia-1,ib,ic,id,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia+1,ib,ic,id,Ind2(2))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia-1,ib,ic,id,Ind2(2))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(2),Ind1(2)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia+1,ib,ic,id,Ind2(3))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia-1,ib,ic,id,Ind2(3))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(3),Ind1(3)) =
     &                          tmp1 + tmp2
 521                    Continue
                        Fact = Fact + tOne
 511                 Continue
                  End If
               Else If (nVec.eq.2) Then
                  Do 601 iVec = 1, nT*nRys
                     xyz2D1(iVec,0,ib,ic,id,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,1,ib,ic,id,Ind2(1))
                     xyz2D1(iVec,0,ib,ic,id,Ind2(2),Ind1(2)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,1,ib,ic,id,Ind2(2))
 601              Continue
                  If (la.ge.1) Then
                     Fact = tOne
                     Do 611 ia = 1, la
                        Do 621 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia+1,ib,ic,id,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia-1,ib,ic,id,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia+1,ib,ic,id,Ind2(2))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia-1,ib,ic,id,Ind2(2))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(2),Ind1(2)) =
     &                          tmp1 + tmp2
 621                    Continue
                        Fact = Fact + tOne
 611                 Continue
                  End If
               Else If (nVec.eq.1) Then
                  Do 701 iVec = 1, nT*nRys
                     xyz2D1(iVec,0,ib,ic,id,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,1,ib,ic,id,Ind2(1))
 701              Continue
                  If (la.ge.1) Then
                     Fact = tOne
                     Do 711 ia = 1, la
                        Do 721 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia+1,ib,ic,id,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia-1,ib,ic,id,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
 721                    Continue
                        Fact = Fact + tOne
 711                 Continue
                  End If
               End If
 301        Continue
 201     Continue
 101  Continue
*
*     Differentiate with respect to the second center
*
 211  Continue
      If (IfGrad(1,2) .or.IfGrad(2,2) .or.
     &                    IfGrad(3,2)) Then
         Call ExpX(Temp  ,mZeta,mEta,Beta,One)
         Call Exp_2(Scrtch,nRys,nT,Temp,One)
*        If (iPrint.ge.99) Call RecPrt(
*    &      'Expanded exponents (beta) ',' ',Scrtch,
*    &      nT,nRys)
      End If
      nVec = 0
      If (IfGrad(1,2)) Then
         nx = nx + 1
         nVec = nVec + 1
         Ind1(nVec) = nx
         Ind2(nVec) = 1
         Index(1,2) = nx
      End If
      If (IfGrad(2,2)) Then
         ny = ny + 1
         nVec = nVec + 1
         Ind1(nVec) = ny
         Ind2(nVec) = 2
         Index(2,2) = ny
      End If
      If (IfGrad(3,2)) Then
         nz = nz + 1
         nVec = nVec + 1
         Ind1(nVec) = nz
         Ind2(nVec) = 3
         Index(3,2) = nz
      End If
      If (nVec.eq.0) Go To 311
*
      Do 102 id = 0, ld
         Do 202 ic = 0, lc
            Do 302 ia = 0, la
               If (nVec.eq.3) Then
                  Do 502 iVec = 1, nT*nRys
                     xyz2D1(iVec,ia,0,ic,id,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,1,ic,id,Ind2(1))
                     xyz2D1(iVec,ia,0,ic,id,Ind2(2),Ind1(2)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,1,ic,id,Ind2(2))
                     xyz2D1(iVec,ia,0,ic,id,Ind2(3),Ind1(3)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,1,ic,id,Ind2(3))
 502              Continue
                  If (lb.ge.1) Then
                     Fact = tOne
                     Do 512 ib = 1, lb
                        Do 522 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib+1,ic,id,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib-1,ic,id,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib+1,ic,id,Ind2(2))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib-1,ic,id,Ind2(2))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(2),Ind1(2)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib+1,ic,id,Ind2(3))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib-1,ic,id,Ind2(3))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(3),Ind1(3)) =
     &                          tmp1 + tmp2
 522                    Continue
                        Fact = Fact + tOne
 512                 Continue
                  End If
               Else If (nVec.eq.2) Then
                  Do 602 iVec = 1, nT*nRys
                     xyz2D1(iVec,ia,0,ic,id,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,1,ic,id,Ind2(1))
                     xyz2D1(iVec,ia,0,ic,id,Ind2(2),Ind1(2)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,1,ic,id,Ind2(2))
 602              Continue
                  If (lb.ge.1) Then
                     Fact = tOne
                     Do 612 ib = 1, lb
                        Do 622 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib+1,ic,id,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib-1,ic,id,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib+1,ic,id,Ind2(2))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib-1,ic,id,Ind2(2))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(2),Ind1(2)) =
     &                          tmp1 + tmp2
 622                    Continue
                        Fact = Fact + tOne
 612                 Continue
                  End If
               Else If (nVec.eq.1) Then
                  Do 702 iVec = 1, nT*nRys
                     xyz2D1(iVec,ia,0,ic,id,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,1,ic,id,Ind2(1))
 702              Continue
                  If (lb.ge.1) Then
                     Fact = tOne
                     Do 712 ib = 1, lb
                        Do 722 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib+1,ic,id,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib-1,ic,id,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
 722                    Continue
                        Fact = Fact + tOne
 712                 Continue
                  End If
               End If
 302        Continue
 202     Continue
 102  Continue
*
*     Differentiate with respect to the third center
*
 311  Continue
      If (IfGrad(1,3) .or.IfGrad(2,3) .or.
     &                    IfGrad(3,3)) Then
         Call ExpY(Temp  ,mZeta,mEta,Gamma,One)
         Call Exp_2(Scrtch,nRys,nT,Temp,One)
*        If (iPrint.ge.99) Call RecPrt(
*    &      'Expanded exponents (gamma)',' ',Scrtch,
*    &      nT,nRys)
      End If
      nVec = 0
      If (IfGrad(1,3)) Then
         nx = nx + 1
         nVec = nVec + 1
         Ind1(nVec) = nx
         Ind2(nVec) = 1
         Index(1,3) = nx
      End If
      If (IfGrad(2,3)) Then
         ny = ny + 1
         nVec = nVec + 1
         Ind1(nVec) = ny
         Ind2(nVec) = 2
         Index(2,3) = ny
      End If
      If (IfGrad(3,3)) Then
         nz = nz + 1
         nVec = nVec + 1
         Ind1(nVec) = nz
         Ind2(nVec) = 3
         Index(3,3) = nz
      End If
      If (nVec.eq.0) Go To 411
*
      Do 103 id = 0, ld
         Do 203 ib = 0, lb
            Do 303 ia = 0, la
               If (nVec.eq.3) Then
                  Do 503 iVec = 1, nT*nRys
                     xyz2D1(iVec,ia,ib,0,id,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,1,id,Ind2(1))
                     xyz2D1(iVec,ia,ib,0,id,Ind2(2),Ind1(2)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,1,id,Ind2(2))
                     xyz2D1(iVec,ia,ib,0,id,Ind2(3),Ind1(3)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,1,id,Ind2(3))
 503              Continue
                  If (lc.ge.1) Then
                     Fact = tOne
                     Do 513 ic = 1, lc
                        Do 523 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic+1,id,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic-1,id,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic+1,id,Ind2(2))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic-1,id,Ind2(2))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(2),Ind1(2)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic+1,id,Ind2(3))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic-1,id,Ind2(3))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(3),Ind1(3)) =
     &                          tmp1 + tmp2
 523                    Continue
                        Fact = Fact + tOne
 513                 Continue
                  End If
               Else If (nVec.eq.2) Then
                  Do 603 iVec = 1, nT*nRys
                     xyz2D1(iVec,ia,ib,0,id,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,1,id,Ind2(1))
                     xyz2D1(iVec,ia,ib,0,id,Ind2(2),Ind1(2)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,1,id,Ind2(2))
 603              Continue
                  If (lc.ge.1) Then
                     Fact = tOne
                     Do 613 ic = 1, lc
                        Do 623 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic+1,id,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic-1,id,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic+1,id,Ind2(2))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic-1,id,Ind2(2))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(2),Ind1(2)) =
     &                          tmp1 + tmp2
 623                    Continue
                        Fact = Fact + tOne
 613                 Continue
                  End If
               Else If (nVec.eq.1) Then
                  Do 703 iVec = 1, nT*nRys
                     xyz2D1(iVec,ia,ib,0,id,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,1,id,Ind2(1))
 703              Continue
                  If (lc.ge.1) Then
                     Fact = tOne
                     Do 713 ic = 1, lc
                        Do 723 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic+1,id,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic-1,id,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
 723                    Continue
                        Fact = Fact + tOne
 713                 Continue
                  End If
               End If
 303        Continue
 203     Continue
 103  Continue
*
*     Differentiate with respect to the fourth center
*
 411  Continue
      If (IfGrad(1,4) .or. IfGrad(2,4) .or.
     &                     IfGrad(3,4)) Then
         Call ExpY(Temp  ,mZeta,mEta,Delta,One)
         Call Exp_2(Scrtch,nRys,nT,Temp,One)
*        If (iPrint.ge.99) Call RecPrt(
*    &      'Expanded exponents (delta)',' ',Scrtch,
*    &      nT,nRys)
      End If
      nVec = 0
      If (IfGrad(1,4)) Then
         nx = nx + 1
         nVec = nVec + 1
         Ind1(nVec) = nx
         Ind2(nVec) = 1
         Index(1,4) = nx
      End If
      If (IfGrad(2,4)) Then
         ny = ny + 1
         nVec = nVec + 1
         Ind1(nVec) = ny
         Ind2(nVec) = 2
         Index(2,4) = ny
      End If
      If (IfGrad(3,4)) Then
         nz = nz + 1
         nVec = nVec + 1
         Ind1(nVec) = nz
         Ind2(nVec) = 3
         Index(3,4) = nz
      End If
      If (nVec.eq.0) Go To 999
*
      Do 104 ic = 0, lc
         Do 204 ib = 0, lb
            Do 304 ia = 0, la
               If (nVec.eq.3) Then
                  Do 504 iVec = 1, nT*nRys
                     xyz2D1(iVec,ia,ib,ic,0,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,ic,1,Ind2(1))
                     xyz2D1(iVec,ia,ib,ic,0,Ind2(2),Ind1(2)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,ic,1,Ind2(2))
                     xyz2D1(iVec,ia,ib,ic,0,Ind2(3),Ind1(3)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,ic,1,Ind2(3))
 504              Continue
                  If (ld.ge.1) Then
                     Fact = tOne
                     Do 514 id = 1, ld
                        Do 524 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic,id+1,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic,id-1,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic,id+1,Ind2(2))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic,id-1,Ind2(2))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(2),Ind1(2)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic,id+1,Ind2(3))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic,id-1,Ind2(3))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(3),Ind1(3)) =
     &                          tmp1 + tmp2
 524                    Continue
                        Fact = Fact + tOne
 514                 Continue
                  End If
               Else If (nVec.eq.2) Then
                  Do 604 iVec = 1, nT*nRys
                     xyz2D1(iVec,ia,ib,ic,0,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,ic,1,Ind2(1))
                     xyz2D1(iVec,ia,ib,ic,0,Ind2(2),Ind1(2)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,ic,1,Ind2(2))
 604              Continue
                  If (ld.ge.1) Then
                     Fact = tOne
                     Do 614 id = 1, ld
                        Do 624 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic,id+1,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic,id-1,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic,id+1,Ind2(2))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic,id-1,Ind2(2))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(2),Ind1(2)) =
     &                          tmp1 + tmp2
 624                    Continue
                        Fact = Fact + tOne
 614                 Continue
                  End If
               Else If (nVec.eq.1) Then
                  Do 704 iVec = 1, nT*nRys
                     xyz2D1(iVec,ia,ib,ic,0,Ind2(1),Ind1(1)) =
     &                   tTwo * Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,ic,1,Ind2(1))
 704              Continue
                  If (ld.ge.1) Then
                     Fact = tOne
                     Do 714 id = 1, ld
                        Do 724 iVec = 1, nT*nRys
                           tmp1 = tTwo * Scrtch(iVec) *
     &                          xyz2D0(iVec,ia,ib,ic,id+1,Ind2(1))
                           tmp2 = Fact *
     &                          xyz2D0(iVec,ia,ib,ic,id-1,Ind2(1))
                           xyz2D1(iVec,ia,ib,ic,id,Ind2(1),Ind1(1)) =
     &                          tmp1 + tmp2
 724                    Continue
                        Fact = Fact + tOne
 714                 Continue
                  End If
               End If
 304        Continue
 204     Continue
 104  Continue
*
 999  Continue
*
*-----Sum over common centers
*
      Do 1000 iCent = 1, 3
         Do 2000 jCent = iCent+1, 4
            If (EQ(Coora(1,iCent),Coora(1,jCent))) Then
               Do 3000 iCar = 1, 3
*
                  If (IfGrad(iCar,iCent) .and.
     &                IfGrad(iCar,jCent) ) Then
*--------------------Change flags so gradient will not be assembled and
*                    that there will be no contribution to the gradient.
                     IfGrad(iCar,jCent) = .False.
                     IndGrd(iCar,jCent) = 0
                     i1 = Index(iCar,iCent)
                     i2 = Index(iCar,jCent)
                     Call DaXpY_(nRys*nT*(la+1)*(lb+1)*(lc+1)*(ld+1),
     &                          One,
     &                          xyz2D1(1,0,0,0,0,iCar,i2),1,
     &                          xyz2D1(1,0,0,0,0,iCar,i1),1)
                  End If
*
 3000          Continue
            End If
 2000    Continue
 1000 Continue
*
c     If (iPrint.ge.49) Then
c        Do 900 iCn = 1, 4
c           Do 901 iCar = 1, 3
c              If (IfGrad(iCar,iCn)) Then
c                 ij = Index(iCar,iCn)
c                 Do 902 ia = 0, la
c                    Do 903 ib = 0, lb
c                       Do 904 ic = 0, lc
c                          Do 905 id = 0, ld
c                             Write
c    &                         (Label,'(A,4(I2,'',''),A,'','',I2,A)')
c    &                           ' xyz2D1(',
c    &                           ia,ib,ic,id,ch(iCar),iCn,')'
c                             If (iPrint.ge.99) Then
c                                Call RecPrt(Label,' ',xyz2d1(1,ia,ib,
c    &                                    ic,id,iCar,ij),nT,nRys)
c                             Else
c                                Write (*,'(A)') Label
c                                Write (*,*) DDot_(nT*nRys,
c    &                            xyz2d1(1,ia,ib,ic,id,iCar,ij),1,
c    &                            xyz2d1(1,ia,ib,ic,id,iCar,ij),1)
c                             End If
c905                       Continue
c904                    Continue
c903                 Continue
c902              Continue
c              End If
c901        Continue
c900     Continue
c     End If
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkQ0 (V)
c
c        Q0(i,j,k,l) <- V(ij,kl)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:no*(no+1)/2,1:no*(no+1)/2)
c
c        help variables
        integer i,j,k,l,ij,kl
c
        kl=0
        do k=1,no
        do l=1,k
        kl=kl+1
          ij=0
          do i=1,no
          do j=1,i
          ij=ij+1
            Q0(i,j,k,l)=V(ij,kl)
            Q0(i,j,l,k)=V(ij,kl)
            Q0(j,i,k,l)=V(ij,kl)
            Q0(j,i,l,k)=V(ij,kl)
          end do
          end do
        end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2002, Roland Lindh                                     *
!***********************************************************************

subroutine Assemble_dVdB(NAInt,EFInt,nZeta,la,lb,A,B,C)
!***********************************************************************
!                                                                      *
!     Object: to assemble the derivative of the nuclear attraction     *
!             integrals with respect to the magnetic field.            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chemical Physics,                 *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb
real(kind=wp), intent(in) :: NAInt(nZeta*nTri_Elem1(la)*nTri_Elem1(lb)), A(3), B(3), C(3)
real(kind=wp), intent(inout) :: EFInt(nZeta*nTri_Elem1(la)*nTri_Elem1(lb),3)
integer(kind=iwp) :: iVec, nVec
real(kind=wp) :: EFInt_x, EFInt_y, EFInt_z, RAB(3)

RAB(:) = A-B

! Recombine in place!

nVec = size(EFInt,1)
do iVec=1,nVec
  EFInt_x = EFInt(iVec,1)
  EFInt_y = EFInt(iVec,2)
  EFInt_z = EFInt(iVec,3)
  EFInt(iVec,1) = RAB(2)*(EFInt_z+C(3)*NAInt(iVec))-RAB(3)*(EFInt_y+C(2)*NAInt(iVec))
  EFInt(iVec,2) = RAB(3)*(EFInt_x+C(1)*NAInt(iVec))-RAB(1)*(EFInt_z+C(3)*NAInt(iVec))
  EFInt(iVec,3) = RAB(1)*(EFInt_y+C(2)*NAInt(iVec))-RAB(2)*(EFInt_x+C(1)*NAInt(iVec))
end do

return

end subroutine Assemble_dVdB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Scf_Mcontrol(id_call)

use Para_Info, only: MyRank
use InfSCF, only: ALGO, dmpk, DThr, EThr, FThr, nIter, nScreen
use Cholesky, only: timings
use Constants, only: Zero
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: id_call
integer(kind=iwp) :: icount, icount0, istatus
character(len=512) :: List
character(len=32) :: Val

icount = 0

if (id_call == 1) then

  ! Label definitions

  write(List,100) 'SCF_started_OK:(-:-):',ALGO,timings,dmpK,EThr,DThr,FThr,nIter(1),nScreen

  ! Initialize the control system

  call MolcasControlInit(List)
  return

else

  ! Read the molcas control file

  !1
  call MolcasControl('Cho_ALGO',Val)
  if (Val(1:4) /= '    ') then
    read(Val,*,iostat=istatus) ALGO
    call Error_check()
    if (istatus /= 0) return
    write(u6,*) '--- Warning: Cho_ALGOrithm changed by user to the value ',ALGO
    icount = icount+1
  end if
  !2
  call MolcasControl('Chotime',Val)
  if (Val(1:4) /= '    ') then
    read(Val,*,iostat=istatus) timings
    call Error_check()
    if (istatus /= 0) return
    write(u6,*) '--- Warning: Cholesky timings visualization changed by user to the value ',timings
    icount = icount+1
  end if
  !3
  call MolcasControl('En_thr',Val)
  if (Val(1:4) /= '    ') then
    read(Val,*,iostat=istatus) Ethr
    call Error_check()
    if (istatus /= 0) return
    write(u6,*) '--- Warning: SCF Energy threshold changed by user to the value ',Ethr
    icount = icount+1
  end if
  !4
  call MolcasControl('D_thr',Val)
  if (Val(1:4) /= '    ') then
    read(Val,*,iostat=istatus) Dthr
    call Error_check()
    if (istatus /= 0) return
    write(u6,*) '--- Warning: SCF Density threshold changed by user to the value ',Dthr
    icount = icount+1
  end if
  !5
  call MolcasControl('F_thr',Val)
  if (Val(1:4) /= '    ') then
    read(Val,*,iostat=istatus) Fthr
    call Error_check()
    if (istatus /= 0) return
    write(u6,*) '--- Warning: SCF Fmat threshold changed by user to the value ',Fthr
    icount = icount+1
  end if
  !6
  call MolcasControl('MaxIter',Val)
  if (Val(1:4) /= '    ') then
    read(Val,*,iostat=istatus) nIter(1)
    call Error_check()
    if (istatus /= 0) return
    write(u6,*) '--- Warning: SCF Max # iterations changed by user to the value ',nIter(1)
    icount = icount+1
  end if
  !7
  call MolcasControl('nScreen',Val)
  if (Val(1:4) /= '    ') then
    read(Val,*,iostat=istatus) nScreen
    call Error_check()
    if (istatus /= 0) return
    write(u6,*) '--- Warning: Cholesky LK option nSCREEN changed by user to the value ',nScreen
    icount = icount+1
  end if
  !8
  call MolcasControl('dmpK',Val)
  if (Val(1:4) /= '    ') then
    read(Val,*,iostat=istatus) dmpK
    call Error_check()
    if (istatus /= 0) return
    write(u6,*) '--- Warning: Cholesky LK option DMPK changed by user to the value ',dmpK
    icount = icount+1
  end if

end if

icount0 = icount

! Get the true updated counter in parallel runs

call gaIgOP_SCAL(icount,'max')

if (MyRank == 0) then
  if (icount > icount0) then
    write(u6,*) ' Steering will NOT be activated this time because'
    write(u6,*) ' molcas.control file must be changed on node_0 !!'
    call gaIgOP_SCAL(icount,'min')
  end if
end if

if (icount > 0) then

  ! Trick to broadcast the values across nodes

  if (MyRank /= 0) then
    ALGO = 0
    nIter(1) = 0
    nScreen = 0
    dmpK = Zero
    EThr = Zero
    DThr = Zero
    FThr = Zero
  end if
  call gaIgOP_SCAL(ALGO,'+')
  call gaIgOP_SCAL(nScreen,'+')
  call gaIgOP(nIter(1),1,'+')
  call gadgOP_SCAL(dmpK,'+')
  call gadgOP_SCAL(EThr,'+')
  call gadgOP_SCAL(DThr,'+')
  call gadgOP_SCAL(FThr,'+')

  ! Update label values (note that "timings" is locally updated!)

  write(List,100) 'SCF_modified_by_user:',ALGO,timings,dmpK,EThr,DThr,FThr,nIter(1),nScreen

  ! Initialize the control system with the new values

  call MolcasControlInit(List)
  return

end if

return

100 format(A21,',Cho_ALGO=',I2,',Chotime=',L2,',dmpK=',ES11.4,',En_thr=',ES11.4,',D_thr=',ES11.4,',F_thr=',ES11.4,',MaxIter=',I4, &
           ',nScreen=',I4)

contains

subroutine Error_check()

  select case (istatus)
    case (:-1)
      write(u6,*) 'Scf_Mcontrol: reached end of file. ( icount= ',icount,' )'
    case (1:)
      write(u6,*) 'Scf_Mcontrol: error in data Input. ( icount= ',icount,' )'
  end select

end subroutine Error_check

end subroutine Scf_Mcontrol

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SCATTER(N,A,IND,B)

#include "intent.fh"

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, IND(N)
real(kind=wp), intent(_OUT_) :: A(*)
real(kind=wp), intent(in) :: B(N)
integer(kind=iwp) :: I

do I=1,N
  A(IND(I)) = B(I)
end do

return

end subroutine SCATTER

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RPA_Cleanup(irc)
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Clean up after RPA run (deallocate etc.)
C
      Implicit None
      Integer irc
#include "rpa_config.fh"
#include "rpa_data.fh"

      Integer  RPA_iUHF
      External RPA_iUHF

      Integer i

      irc=0

      ! Set "Relax Method" on Runfile
      Call Put_cArray('Relax Method',RPAModel,8)

      ! Deallocate memory
      Do i=1,RPA_iUHF()
         If (l_CMO(i).gt.0) Then
            Call GetMem('CMO(RPA)','Free','Real',ip_CMO(i),l_CMO(i))
         End If
         ip_CMO(i)=0
         l_CMO(i)=0
         If (l_EMO(i).gt.0) Then
            Call GetMem('EMO(RPA)','Free','Real',ip_EMO(i),l_EMO(i))
         End If
         ip_EMO(i)=0
         l_EMO(i)=0
         If (l_OccEn(i).gt.0) Then
            Call GetMem('OccEn','Free','Real',ip_OccEn(i),l_OccEn(i))
         End If
         ip_OccEn(i)=0
         l_OccEn(i)=0
         If (l_VirEn(i).gt.0) Then
            Call GetMem('OccEn','Free','Real',ip_VirEn(i),l_VirEn(i))
         End If
         ip_VirEn(i)=0
         l_VirEn(i)=0
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Log2Int(A,B,N)
      Logical A(N)
      Integer B(N)
*
      Do i = 1, N
         B(i)=0
         If (A(i)) B(i)=1
      End Do
*
      Return
      End
      Subroutine Int2Log(A,B,N)
      Integer A(N)
      Logical B(N)
*
      Do i = 1, N
         B(i)= A(i).eq.1
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SingP(nCalls,iQ_Atoms,ipStoreCoo,nPart2)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "WrkSpc.fh"

*
*-- If this is first call, issue a warning.
*
      If(nCalls.eq.0) then
        Write(6,*)
        Write(6,*)
        Write(6,*)'---->>>  WARNING  <<<----'
        Write(6,*)
        Write(6,*)'You have specified that a set of single-point '
     &//'calculations are to be preformed.'
        Write(6,*)'This means that the input will be given to some '
     &//'extent a new meaning.'
        Write(6,*)

*
*-- Put coordinates in a new vector if first call.
*
        kaunter=0
        nPart2=nPart
        Call GetMem('Store','Allo','Real',ipStoreCoo,nPart2*nCent*3)
        Do 11, iPart=1,nPart2
          Do 12, iCent=1,nCent
            kaunter=kaunter+1
            Work(ipStoreCoo+3*(kaunter-1))=Cordst(kaunter,1)
            Work(ipStoreCoo+3*(kaunter-1)+1)=Cordst(kaunter,2)
            Work(ipStoreCoo+3*(kaunter-1)+2)=Cordst(kaunter,3)
12        Continue
11      Continue

*
*-- Put dummies that will be substituted for the qm-region.
*
        nAllQm=(((iQ_Atoms-1)/nAtom)+1)*nCent
        Do 16, i=1,nAllQm
          Do 17, j=1,3
            Cordst(i,j)=0.0d0
17        Continue
16      Continue

*
*-- Put the coordinates of first iteration.
*
        Do 18, iCent=1,nCent
          Cordst(nAllQm+iCent,1)=Work(ipStoreCoo+3*(iCent-1))
          Cordst(nAllQm+iCent,2)=Work(ipStoreCoo+3*(iCent-1)+1)
          Cordst(nAllQm+iCent,3)=Work(ipStoreCoo+3*(iCent-1)+2)
18      Continue

*
*-- Set new value on some variables.
*
        nMicro=1
        nMacro=1
        DelX=0
        DelFi=0
        DelR=0
        QmEq=.true.
        nPart=(nAllQm/nCent)+1
        Write(6,*)
        Write(6,*)'Resetting for FIT:'
        Write(6,*)'Number of macrosteps:',nMacro
        Write(6,*)'Number of microsteps:',nMicro
        Write(6,*)'No translation, rotation or radie modification.'
        Write(6,*)'Take the QmEq path.'

*
*-- If not first call, then collect relevant coordinates.
*
      Else
        Initial1=(((iQ_Atoms-1)/nAtom)+1)*nCent
        Initial2=3*nCent*nCalls-1
        Do 21, iCent=1,nCent
        Cordst(Initial1+iCent,1)=Work(ipStoreCoo+Initial2+(iCent-1)*3+1)
        Cordst(Initial1+iCent,2)=Work(ipStoreCoo+Initial2+(iCent-1)*3+2)
        Cordst(Initial1+iCent,3)=Work(ipStoreCoo+Initial2+(iCent-1)*3+3)
21      Continue
      Endif

*
*-- Up-date nCalls.
*
      nCalls=nCalls+1


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine driverBas()

      implicit none
#include "info_expbas.fh"
      integer ireturn
      COMMON /iret/ ireturn
      call Readinp_expbas()
      if(DoExpbas) Call expbas(ireturn)
      if(DoDesy)   Call desym(0)

      Return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkV_A4(Vp,V,dimb,dima,no,dimij)
! this routine does:
! Vp(a,b,ij) <- (ai|bj) from V(b,j,a,i)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimb, dima, no, dimij
real(kind=wp), intent(out) :: Vp(dima,dimb,dimij)
real(kind=wp), intent(in) :: V(dimb,no,dima,no)
integer(kind=iwp) :: b, i, ij, j

ij = 0
do i=1,no
  do j=1,i
    ij = ij+1
    do b=1,dimb
      Vp(:,b,ij) = V(b,j,:,i)
    end do
  end do
end do

return

end subroutine MkV_A4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3aphlp4 (a,b,dimp,dimpq,dimpqr,ns,szkey)
c
c     this routine realize following procedure
c     for symp=symq=symr
c
c     B(pqr)=B(pqr)+ns.(A1(qr,p)-A2(pr,q)+A3(pq,r))
c
c     a      - A  matrix (I)
c     b      - B  matrix (I/O)
c     dimp   - dimension of p (q,r) index (I)
c     dimpq  - dimension of pq index (I)
c     dimpqr - dimension of pqr (I)
c     ns     - singum of the permutation (+-1) (I)
c     szkey  - set zero key (I)
c     = 0 no vanishing
c     = 1 set B=0 at the beggining
c
c     N.B. tie sumacie by sa mozno dali trochu vylepsit
c
       integer dimp,dimpq,dimpqr,ns,szkey
       real*8 a(1:dimpq,1:dimp)
       real*8 b(1:dimpqr)
c
c     help variables
c
       integer p,q,r,pqr,pq,pr,qr,pq0
c
c
       if (szkey.eq.1) then
       call cct3_mv0zero (dimpqr,dimpqr,b)
       end if
c
       if (ns.eq.1) then
c     phase +1
c
       pqr=0
c
       do 100 p=3,dimp
       pq0=(p-1)*(p-2)/2
       qr=0
       do 101 q=2,p-1
       pq=pq0+q
       pr=(p-1)*(p-2)/2
       do 102 r=1,q-1
       pr=pr+1
       qr=qr+1
       pqr=pqr+1
       b(pqr)=b(pqr)+a(qr,p)-a(pr,q)+a(pq,r)
 102    continue
 101    continue
 100    continue
c
       else
c     phase -1
c
       pqr=0
c
       do 200 p=3,dimp
       pq0=(p-1)*(p-2)/2
       qr=0
       do 201 q=2,p-1
       pq=pq0+q
       pr=(p-1)*(p-2)/2
       do 202 r=1,q-1
       pr=pr+1
       qr=qr+1
       pqr=pqr+1
       b(pqr)=b(pqr)-a(qr,p)+a(pr,q)-a(pq,r)
 202    continue
 201    continue
 200    continue
c
c
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,2008, Roland Lindh                                *
************************************************************************
      SubRoutine CntInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: to compute contact integrals.                                *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, Sweden, February '91                 *
*             Modified from D1Int January 2008.                        *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables

      Character*80 Label
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 150
      iPrint = nPrint(iRout)
*
      Call FZero(Final,nZeta*((la+1)*(la+2)/2)*((lb+1)*(lb+2)/2)*nIC)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+1)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+1)
      ipArr=nip
      na=(la+1)*(la+2)/2
      nb=(lb+1)*(lb+2)/2
      mArr=na*nb
      nip = nip + nZeta*mArr
      If (nip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'CntInt: nip-1.gt.nArr*nZeta')
         Write (6,*) 'nip=',nip
         Write (6,*) 'nArr,nZeta=',nArr,nZeta
         Call Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In CntInt: A',' ',A,1,3)
         Call RecPrt(' In CntInt: RB',' ',RB,1,3)
         Call RecPrt(' In CntInt: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In CntInt: P',' ',P,nZeta,3)
         Write (6,*) ' In CntInt: la,lb=',la,lb
      End If
*
*     Compute the contact terms.
*
      Call Contact(Zeta,P,nZeta,
     &             A,Array(ipAxyz),la,
     &             RB,Array(ipBxyz),lb,
     &             Ccoor,lOper,iCho,nIC,
     &             Array(ipArr),mArr,
     &             Final,iStabM,nStabM,nComp,rKappa)
*
      If (iPrint.ge.99) Then
         Do iIC = 1, nIC
         Do ia = 1, nElem(la)
            Do ib = 1, nElem(lb)
               Write (Label,'(A,I2,A,I2,A)')
     &               'Contact term(',ia,',',ib,')'
               Call RecPrt(Label,' ',Final(1,ia,ib,iIC),1,nZeta)
            End Do
         End Do
         End Do
      End If
*
*     Call GetMem(' Exit CntInt','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_real_array(ZInv)
         Call Unused_integer(nOrdOp)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module dcr_mod

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: MxIndx = 50, Mx = MxIndx*(MxIndx+1)/2
integer(kind=iwp) :: iDCR_all(0:7,Mx), Indx(MxIndx), Lambda_all(Mx), mDCR_all(Mx), nIndx
logical(kind=iwp) :: Done(Mx)

public :: DCR_Init, Done, iDCR_all, Indx, Lambda_all, mDCR_all, nIndx

contains

subroutine DCR_Init()

  nIndx = 0
  Done(:) = .false.

end subroutine DCR_Init

end module dcr_mod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GVWrite(Index,NTs,NEsfP,NAt,AtmC,IAt,Coor_Sph,Tessera,
     &                   NVert,Vert,ISphe,Q,ivts,MxVert)

      IMPLICIT REAL*8 (A-H,O-Z)
      Dimension NVert(*),Vert(3,MxVert,*),IVTS(MxVert,*),
     &          Tessera(4,nTs),Q(*)
      Dimension AtmC(3,nAt),IAt(nAt),Coor_Sph(4,*),ISphe(nTs)
C
C     Prepare the input file for GeomView (coloured polyhedra)
C
      Lu = 21
      Lu=IsFreeUnit(Lu)
      If(Index.eq.1) call molcas_open(Lu,'GV.off')
      If(Index.eq.2) call molcas_open(Lu,'GV1.off')
      NumV = 0
      Do 10 i = 1, NTs
        NumV = NumV + NVert(i)
  10  Continue
      Write(Lu,500)'COFF'
      Write(Lu,1000)NumV, NTs, NumV
      K = 0
      Last = 0
      If(Index.eq.2) then
        qmax=0.0d0
        qmin=0.0d0
        Do 2000 i = 1, NTs
          qt = q(i) / Tessera(4,i)
          if(qt.ge.qmax) qmax = qt
          if(qt.le.qmin) qmin = qt
 2000   continue
        Write(Lu,1100)QMin, QMax
      EndIf
      Do 2010 i = 1, NTs
        If(Index.eq.2) qt = q(i) / Tessera(4,i)
        N=ISphe(i)
        If(N.ne.Last) Write(Lu,1500)N
        Last = N
        If(Index.eq.1) Call Colour(NEsfP,NAt,AtmC,
     +                 IAt,Coor_Sph,N,C1,C2,C3)
        If(Index.eq.2) Call Colchg(i,qt,qmax,qmin,C1,C2,C3)
        Do 2020 j = 1, NVert(i)
          IVTS(j,i) = K
          K = K + 1
          write(Lu,2001)(VERT(jcord,j,i),jcord=1,3),C1,C2,C3,0.75,i
 2020 continue
 2010 continue
      Do 20 i = 1, NTs
        write(Lu,3000)NVert(i),(IVTS(j,i),j=1,nvert(i))
  20  Continue
      Close(Lu)
 500  Format(1x,a)
1000  Format(3i10)
1100  Format('# Minimum and maximum charge density ',2f12.6)
1500  Format('# Sphere number ',i4)
2001  Format('  ',3f16.9,4f5.2,' # Tess. ',i4)
3000  Format('  ',14i10)
      return
      end

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Subroutine Colour(NesfP,NAt,AtmC,IAt,Coor_Sph,
     +                  N,C1,C2,C3)
      IMPLICIT REAL*8(A-H,O-Z)
      Character*20 Col
      Dimension IAt(*),AtmC(3,*),Coor_Sph(4,*)
C
C     Assign tesserae colours for GeomView:
C     Carbon: green, nitrogen: blue, oxygen: red, hydrogen: light blue,
C     others: violet, added spheres: gray.
C
      Col=' '
      IOut=6
      Delta=1.d-03
      If(N.gt.NESFP)then
       Col = 'Gray'
       Call ColTss(IOut,Col,C1,C2,C3)
       Return
      EndIf
      I = 0
      Do 100 J = 1, NAt
        I = I + 1
        Diff = Sqrt( (AtmC(1,J)-Coor_Sph(1,N))**2
     &             + (AtmC(2,J)-Coor_Sph(2,N))**2
     &             + (AtmC(3,J)-Coor_Sph(3,N))**2 )
        If(Diff.lt.Delta) then
          if(IAt(I).eq.6)then
            Col = 'Green'
          elseif(IAt(I).eq.7)then
            Col = 'Blue'
          elseif(IAt(I).eq.8)then
            Col = 'Red'
          elseif(IAt(I).eq.1)then
            Col = 'Light Blue'
          else
            Col = 'Fuchsia'
          endif
        endif
 100  Continue
      Call ColTss(IOut,Col,C1,C2,C3)
      Return
      End

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Subroutine ColTss(IOut,Colour,C1,C2,C3)
      Implicit Real*8(A-H,O-Z)
C
C     Assigne tesserae colours for GeomView:
C
      Character*20 Colour
C
      If(Colour.eq.'White') then
        C1 = 1.0D0
        C2 = 1.0D0
        C3 = 1.0D0
      else if(Colour.eq.'Gray') then
        C1 = 0.66D0
        C2 = 0.66D0
        C3 = 0.66D0
      else if(Colour.eq.'Blue'.or.Colour.eq.'Dark Blue') then
        C1 = 0.0D0
        C2 = 0.0D0
        C3 = 1.0D0
      else if(Colour.eq.'Light Blue') then
        C1 = 0.0D0
        C2 = 1.0D0
        C3 = 1.0D0
      else if(Colour.eq.'Green') then
        C1 = 0.0D0
        C2 = 1.0D0
        C3 = 0.0D0
      else if(Colour.eq.'Yellow') then
        C1 = 1.0D0
        C2 = 1.0D0
        C3 = 0.0D0
      else if(Colour.eq.'Orange') then
        C1 = 1.0D0
        C2 = 0.5D0
        C3 = 0.0D0
      else if(Colour.eq.'Violet') then
        C1 = 0.6D0
        C2 = 0.0D0
        C3 = 1.0D0
      else if(Colour.eq.'Pink'.or.Colour.eq.'Light Red') then
        C1 = 1.0D0
        C2 = 0.5D0
        C3 = 1.0D0
      else if(Colour.eq.'Fuchsia') then
        C1 = 1.0D0
        C2 = 0.0D0
        C3 = 1.0D0
      else if(Colour.eq.'Red'.or.Colour.eq.'Dark Red') then
        C1 = 1.0D0
        C2 = 0.0D0
        C3 = 0.0D0
      else if(Colour.eq.'Black') then
        C1 = 0.0D0
        C2 = 0.0D0
        C3 = 0.0D0
      else
        C1 = 0.0D0  ! dummy assignement
        C2 = 0.0D0  ! dummy assignement
        C3 = 0.0D0  ! dummy assignement
        Write(IOut,'("Unrecognized colour in ColTss")')
        Call Abend()
        endIf
      Return
      End

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Subroutine ColChg(i,q,QMAX,QMIN,C1,C2,C3)
      Implicit Real*8(A-H,O-Z)
C
C     Assign tesserae colours for GeomView:
C
      Character*20 Colour
      Save Colour
      Data Colour /'                    '/
C
      Zero = DBLE(0)
      DPos = QMax / 2.d0
      DNeg = QMin / 2.d0
C     Total charge density < 0
      If(q.lt.DNeg) Colour = 'Dark Blue'
      If(q.ge.DNeg.and.q.lt.Zero) Colour = 'Light Blue'
C     Total charge density > 0
      If(q.ge.Zero.and.q.lt.DPos) Colour = 'Pink'
      If(q.ge.DPos) Colour = 'Red'
      Call ColTss(IOut,Colour,C1,C2,C3)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(i)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************

subroutine Local_Triang(nRow,A)
! This routine is a modification of the Per-AAke's Triang routine
! found in src/caspt2/triang.f
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nRow
real(kind=wp), intent(inout) :: A(nRow**2)
integer(kind=iwp) :: i, iFrom, iTo

! Convert a square matrix to triangular in-place.
iFrom = 1+nRow
iTo = 2
do i=2,nRow
  A(iTo:iTo+i-1) = A(iFrom:iFrom+i-1)
  iFrom = iFrom+nRow
  iTo = iTo+i
end do

return

end subroutine Local_Triang

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function arCos(Arg)
      Implicit Real*8 (a-h,o-z)
      Real*8 ArCos
      Character*72 Warning
#include "real.fh"
      A=Arg
      Delta=1.0D-12
      IF (ABS(A).GT.One) Then
         Write(Warning,3) A
3        FORMAT(1X,'Warning argument of aCos= ',1F21.18)
         If (ABS(A).lt.One+Delta) Then
            !Call WarningMessage(1,Warning)
            A=Sign(One,A)
         Else
            Call WarningMessage(2,Warning)
            Call Abend()
         End If
      End If
*
      ArCos=ACos(A)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GenVoronoi(nR_Eff,Alpha,rm,iNQ)
!***********************************************************************
!                                                                      *
!     This version of GenVoronoi computes the radial quadrature points *
!     and computes data useful for the angular quadrature.             *
!     The angular part is generated by Subblock.                       *
!                                                                      *
!***********************************************************************

use NQ_Structure, only: lMax_NQ, NQ_Data
use nq_Info, only: L_Quad, nR, Quadrature
use stdalloc, only: mma_allocate
use Constants, only: Zero, One, Three, Five, Seven, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: nR_Eff
real(kind=wp), intent(inout) :: Alpha(2), rm(2)
integer(kind=iwp), intent(in) :: iNQ
integer(kind=iwp) :: iANr, l_Max, mR
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iR
#endif
real(kind=wp) :: Dum(2,1), Radius_Max, RBS
logical(kind=iwp) :: Process
real(kind=wp), parameter :: TA_R(36) = [0.8_wp,0.9_wp,1.8_wp,1.4_wp,1.3_wp,1.1_wp,0.9_wp,0.9_wp,0.9_wp,0.9_wp,1.4_wp,1.3_wp, &
                                        1.3_wp,1.2_wp,1.1_wp,1.0_wp,1.0_wp,1.0_wp,1.5_wp,1.4_wp,1.3_wp,1.2_wp,1.2_wp,1.2_wp, &
                                        1.2_wp,1.2_wp,1.2_wp,1.1_wp,1.1_wp,1.1_wp,1.1_wp,1.0_wp,0.9_wp,0.9_wp,0.9_wp,0.9_wp]
real(kind=wp), external :: Bragg_Slater, Eval_RMax

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
write(u6,*) 'nR,L_Quad=',nR,L_Quad
#endif
if (L_Quad > lMax_NQ) then
  call WarningMessage(2,'GenVoronoi: L_Quad > lMax_NQ')
  write(u6,*) 'Redimension lMax_NQ in nq_structure'
  write(u6,*) 'lMax_NQ=',lMax_NQ
  write(u6,*) 'L_Quad=',L_Quad
  call Abend()
end if
l_Max = int(rm(1))
Radius_Max = Eval_RMax(Alpha(1),l_Max,rm(2))
#ifdef _DEBUGPRINT_
write(u6,*) 'Alpha(1)=',Alpha(1)
write(u6,*) 'l_max=',l_max
write(u6,*) 'rm(2)=',rm(2)
write(u6,*) 'Radius_Max=',Radius_Max
write(u6,*)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate radial quadrature points. Observe that the integrand
! vanishes at (r=0.0).

mR = nR
select case (Quadrature)

  case ('MHL')

    iANr = NQ_Data(iNQ)%Atom_Nr
    RBS = Bragg_Slater(iANr)
    Alpha(1) = RBS
    mR = nR-1
    call mma_allocate(NQ_Data(iNQ)%R_Quad,2,mR,Label='R_Quad')
    NQ_Data(iNQ)%R_Quad(:,:) = Zero
    call GenRadQuad_MHL(NQ_Data(iNQ)%R_Quad,nR,nR_Eff,Alpha(1))
    call Truncate_Grid(NQ_Data(iNQ)%R_Quad,mR,nR_Eff,Radius_Max)
    mR = nR_Eff

  case ('LOG3')

    rm(1) = Three
    ! alpha=5 (alpha=7 for alkali and rare earth metals)
    iANr = NQ_Data(iNQ)%Atom_Nr
    select case (iANr)
      case (3,4,11,12,19,20,37,38,55,56,87,88)
        Alpha(1) = Seven
      case default
        Alpha(1) = Five
    end select
    mR = nR-1
    call mma_allocate(NQ_Data(iNQ)%R_Quad,2,mR,Label='R_Quad')
    NQ_Data(iNQ)%R_Quad(:,:) = Zero
    call GenRadQuad_MK(NQ_Data(iNQ)%R_Quad,nR,nR_Eff,rm(1),Alpha(1))
    call Truncate_Grid(NQ_Data(iNQ)%r_Quad,mR,nR_Eff,Radius_Max)
    mR = nR_Eff

  case ('BECKE')

    iANr = NQ_Data(iNQ)%Atom_Nr
    RBS = Bragg_Slater(iANr)
    if (iANr == 1) then
      Alpha(1) = RBS
    else
      Alpha(1) = Half*RBS
    end if
    mR = nR-1
    call mma_allocate(NQ_Data(iNQ)%R_Quad,2,mR,Label='R_Quad')
    NQ_Data(iNQ)%R_Quad(:,:) = Zero
    call GenRadQuad_B(NQ_Data(iNQ)%R_Quad,nR,nR_Eff,Alpha(1))
    call Truncate_Grid(NQ_Data(iNQ)%R_Quad,mR,nR_Eff,Radius_Max)
    mR = nR_Eff

  case ('TA')

    Alpha(1) = -One
    iANr = NQ_Data(iNQ)%Atom_Nr
    if ((iANr < lbound(TA_R,1)) .or. (iANr > ubound(TA_R,1))) then
      call WarningMessage(2,'TA grid not defined')
      write(u6,*) ' TA grid not defined for atom number:',iANR
      call Abend()
    else
      Alpha(1) = TA_R(iANr)
    end if
    mR = nR-1
    call mma_allocate(NQ_Data(iNQ)%R_Quad,2,mR,Label='R_Quad')
    NQ_Data(iNQ)%R_Quad(:,:) = Zero
    call GenRadQuad_TA(NQ_Data(iNQ)%R_Quad,nR,nR_Eff,Alpha(1))
    call Truncate_Grid(NQ_Data(iNQ)%R_Quad,mR,nR_Eff,Radius_Max)
    mR = nR_Eff

  case ('LMG')

    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Generate radial quadrature. The first call will generate
    ! the size of the grid.

    nR = 1 ! Dummy size on the first call.
    Process = .false.
    call GenRadQuad_PAM(nR_Eff,rm,Alpha(1),Process,Dum,nR)

    nR = nR_Eff
    call mma_allocate(NQ_Data(iNQ)%R_Quad,2,nR,Label='R_Quad')
    NQ_Data(iNQ)%R_Quad(:,:) = Zero
    Process = .true.
    call GenRadQuad_PAM(nR_Eff,rm,Alpha(1),Process,NQ_Data(iNQ)%R_Quad,nR)
    mR = nR
    !                                                                  *
    !*******************************************************************
    !                                                                  *
#   ifdef _DEBUGPRINT_
    write(u6,*) 'GenRadQuad_PAM ----> GenVoronoi'
    write(u6,*) 'nR_Eff=',nR_Eff
    write(u6,*) 'rm : ',rm(1),rm(2)
    write(u6,*) 'Alpha : ',Alpha(1),Alpha(2)
#   endif

  case default

    call WarningMessage(2,'Invalid quadrature scheme:'//Quadrature)
    call Quit_OnUserError()

end select

NQ_Data(iNQ)%R_max = NQ_Data(iNQ)%R_Quad(1,mR)

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ******** The radial grid ********'
write(u6,*)
write(u6,*) 'Initial number of radial grid points=',nR
write(u6,*) 'iNQ=',iNQ
write(u6,*) 'Effective number of radial grid points=',nR_Eff
do iR=1,nR_Eff
  write(u6,*) NQ_Data(iNQ)%R_Quad(1,iR),NQ_Data(iNQ)%R_Quad(2,iR)
end do
write(u6,*)
write(u6,*) ' *********************************'
write(u6,*)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine GenVoronoi

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Roland Lindh                                     *
!***********************************************************************

subroutine NucAtt(mGrid,iSpin)
!***********************************************************************
!      Author:Roland Lindh, Department of Chemical Physics, University *
!             of Lund, SWEDEN. November 2000                           *
!***********************************************************************

use nq_Grid, only: F_xc, Grid, Rho, vRho
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mGrid, iSpin
integer(kind=iwp) :: i, iGrid, iOff, mCenter, n, nCenter, nSym
real(kind=wp) :: Attr, d_alpha, d_beta, DTot, Fact, x, y, z
integer(kind=iwp), allocatable :: nStab(:)
real(kind=wp), allocatable :: Eff(:), RA(:,:), ZA(:)

call Get_nAtoms_All(mCenter)
call mma_allocate(RA,3,mCenter,Label='RA')
call Get_Coord_All(RA,mCenter)

call Get_iScalar('Unique atoms',nCenter)
call mma_allocate(nStab,nCenter,Label='nStab')
call Get_iArray('nStab',nStab,nCenter)
call mma_allocate(Eff,nCenter,Label='Eff')
call Get_dArray('Effective Nuclear Charge',Eff,nCenter)

call Get_iScalar('nSym',nSym)

call mma_allocate(ZA,mCenter,Label='ZA')
iOff = 0
do i=1,nCenter
  n = nSym/nStab(i)
  ZA(iOff+1:iOff+n) = Eff(i)
  iOff = iOff+n
end do

call mma_deallocate(Eff)
call mma_deallocate(nStab)

!                                                                      *
!***********************************************************************
!                                                                      *

vRho(:,:) = Zero
if (iSpin == 1) then
  ! iSpin=1
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do iGrid=1,mGrid

    d_alpha = Rho(1,iGrid)
    DTot = Two*d_alpha

    ! Accumulate contributions to the nuclear attraction energy

    Attr = Zero
    do i=1,mCenter
      x = Grid(1,iGrid)-RA(1,i)
      y = Grid(2,iGrid)-RA(2,i)
      z = Grid(3,iGrid)-RA(3,i)
      Fact = ZA(i)/sqrt(x**2+y**2+z**2)
      Attr = Attr+Fact
    end do
    F_xc(iGrid) = F_xc(iGrid)-Attr*DTot

    vRho(1,iGrid) = -Attr

  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  ! iSpin=/=1
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do iGrid=1,mGrid

    d_alpha = Rho(1,iGrid)
    d_beta = Rho(2,iGrid)
    DTot = d_alpha+d_beta

    ! Accumulate contributions to the nuclear attraction energy

    Attr = Zero
    do i=1,mCenter
      x = Grid(1,iGrid)-RA(1,i)
      y = Grid(2,iGrid)-RA(2,i)
      z = Grid(3,iGrid)-RA(3,i)
      Fact = ZA(i)/sqrt(x**2+y**2+z**2)
      Attr = Attr+Fact
    end do
    F_xc(iGrid) = F_xc(iGrid)-Attr*DTot

    vRho(1,iGrid) = -Attr
    vRho(2,iGrid) = -Attr

  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *

call mma_deallocate(ZA)
call mma_deallocate(RA)

return

end subroutine NucAtt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKTG3(LSYM1,LSYM2,CI1,CI2,OVL,TG1,TG2,NTG3,TG3)
      IMPLICIT REAL*8 (a-h,o-z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "SysDef.fh"
#include "WrkSpc.fh"
#include "pt2_guga.fh"
      DIMENSION TG1(NASHT,NASHT),TG2(NASHT,NASHT,NASHT,NASHT)
      DIMENSION TG3(NTG3)
      DIMENSION CI1(MXCI),CI2(MXCI)
C Procedure for computing 1-body, 2-body, and 3-body transition
C density elements with active indices only.

C In: Wave functions CI1, with symmetry LSYM1, and CI2, with
C  symmetry LSYM2.
C
C Out: Transition density matrices, denoted here TG1, TG2 and TG3.
C Storage: TG1 and TG2 are simple two- and four-index arrays, and
C includes also such zeroes that are implied by symmetry.
C But TG3 is quite large, and while it is stored with zeroes, it
C is made more compact by the following addressing:

C <Psi1|E_tuvxyz|Psi2> is stored in TG3(ITG3) where
C    ITG3= ((i+1)*i*(i-1))/6 + (j*(j-1))/2 + k
C     i  = max(tu,vx,yz)
C     j  = mid(tu,vx,yz)
C     k  = min(tu,vx,yz)
C tu stands for the pair index tu= t + NASHT*(u-1), etc., and t is
C the usual active orbital number, when they are enumerated across
C all the symmetries (The ''absolute'' active index).


C Put in zeroes. Recognize special cases:
      OVL=1.0D0
      IF(NASHT.EQ.0) GOTO 999
      IF(LSYM1.NE.LSYM2) OVL=0.0D0
      CALL DCOPY_(NASHT**2,[0.0D0],0,TG1,1)
      CALL DCOPY_(NASHT**4,[0.0D0],0,TG2,1)
      CALL DCOPY_(NTG3,[0.0D0],0,TG3,1)
      IF(NACTEL.EQ.0) GOTO 999

      IF(ISCF.EQ.0) GOTO 100

C -Special code for the closed-shell or hi-spin cases:
C ISCF=1 for closed-shell, =2 for hispin
      OCC=2.0D0
      IF(ISCF.EQ.2) OCC=1.0D0
      DO IT=1,NASHT
        TG1(IT,IT)=OCC
      END DO
      IF(NACTEL.EQ.1) GOTO 999
      DO IT=1,NASHT
       DO IU=1,NASHT
        TG2(IT,IT,IU,IU)=TG1(IT,IT)*TG1(IU,IU)
        IF(IU.EQ.IT) THEN
         TG2(IT,IT,IU,IU)=TG2(IT,IT,IU,IU)-TG1(IT,IU)
         ELSE
          TG2(IT,IU,IU,IT)=-TG1(IT,IT)
         END IF
        END DO
       END DO
      IF(NACTEL.EQ.2) GOTO 999
       DO IT1=1,NLEV
        DO IU1=1,NLEV
         IND1=IT1+NASHT*(IU1-1)
         DO IT2=1,NLEV
          DO IU2=1,IU1
           IND2=IT2+NASHT*(IU2-1)
           IF(IND2.GT.IND1) GOTO 199
           DO IT3=1,NLEV
            DO IU3=1,IU2
             IND3=IT3+NASHT*(IU3-1)
             IF(IND3.GT.IND2) GOTO 198
             VAL=TG1(IT1,IU1)*TG1(IT2,IU2)*TG1(IT3,IU3)

C Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
C Add here the necessary Kronecker deltas times 2-body matrix
C elements and lower, so we get a true normal-ordered density matrix
C element.

C <PSI1|E(T1,U1,T2,U2,T3,U3)|PSI2>
C = <PSI1|E(T1,U1)E(T2,U2)E(T3,U3)|PSI2>
C -D(T3,U2)*(TG2(T1,U1,T2,U3)+D(T2,U1)*TG1(T1,U3))
C -D(T2,U1)*TG2(T1,U2,T3,U3)
C -D(T3,U1)*TG2(T2,U2,T1,U3)

      IF(IT3.EQ.IU2) THEN
        VAL=VAL-TG2(IT1,IU1,IT2,IU3)
        IF(IT2.EQ.IU1) THEN
          VAL=VAL-TG1(IT1,IU3)
        END IF
      END IF
      IF(IT2.EQ.IU1) THEN
        VAL=VAL-TG2(IT1,IU2,IT3,IU3)
      END IF
      IF(IT3.EQ.IU1) THEN
        VAL=VAL-TG2(IT2,IU2,IT1,IU3)
      END IF

C VAL is now =<PSI1|E(IT1,IU1,IT2,IU2,IT3,IU3)|PSI2>
      ITG3=((IND1+1)*IND1*(IND1-1))/6+(IND2*(IND2-1))/2+IND3
      TG3(ITG3)=VAL


 198        CONTINUE
           END DO
          END DO
 199      CONTINUE
         END DO
        END DO
       END DO
      END DO
      GOTO 999

 100  CONTINUE
C Here, for regular CAS or RAS cases.

C Special pair index allows true RAS cases to be handled:
      CALL GETMEM('IPTOLEV','ALLO','INTE',LP2LEV,2*NASHT**2)
      LP2LEV1=LP2LEV
      LP2LEV2=LP2LEV+NASHT**2
      IP=0
C First, IL < JL pairs.
      DO IL=1,NLEV-1
       DO JL=IL+1,NLEV
        IP=IP+1
        IWORK(LP2LEV1-1+IP)=IL
        IWORK(LP2LEV2-1+IP)=JL
       END DO
      END DO
C Then, IL = JL pairs.
      DO IL=1,NLEV
        IP=IP+1
        IWORK(LP2LEV1-1+IP)=IL
        IWORK(LP2LEV2-1+IP)=IL
      END DO
C Last, IL > JL pairs.
      DO IL=2,NLEV
       DO JL=1,IL-1
        IP=IP+1
        IWORK(LP2LEV1-1+IP)=IL
        IWORK(LP2LEV2-1+IP)=JL
       END DO
      END DO
C If now any matrix element E(t1u1)E(t2u2)..E(tnun) is arranged
C such that the pair indices are non-decreasing, then the matrix
C element can be correctly computed by performing explicit
C excitations within the RAS space.
C But we also need the 'usual' pair index in order to use the
C packed addressing.

      NCI1=NCSF(LSYM1)
C Overlap:
      IF(LSYM1.EQ.LSYM2) OVL=DDOT_(NCI1,CI1,1,CI2,1)
C Allocate as many vectors as possible:
C Wishful thinking:
      NVECS=2*NASHT**2+1
C But what is really available?
      CALL GETMEM('DUMMY','MAX ','REAL',L,NTG3WRK)
      NTG3WRK=MIN(MXCI*NVECS,NTG3WRK)
      NVECS=NTG3WRK/MXCI
      NTG3WRK=NVECS*MXCI
C Find optimal subdivision of available vectors:
      NYZBUF=NINT(DBLE(NVECS-1)/DBLE(NASHT))
      NYZBUF=MAX(1,NYZBUF)
      NTUBUF=MIN(NASHT**2,NVECS-1-NYZBUF)
      NYZBUF=NVECS-1-NTUBUF
C Insufficient memory?
      IF(NTUBUF.LE.0) THEN
        WRITE(6,*)' Too little memory left for MKTG3.'
        WRITE(6,*)' Need at least 3 vectors of length MXCI=',MXCI
        CALL ABEND()
      END IF
      IF(NTUBUF.LE.(NASHT**2)/5) THEN
        WRITE(6,*)' WARNING: MKTG3 will be inefficient owing to'
        WRITE(6,*)' small memory.'
      END IF
      CALL GETMEM('TG3WRK','ALLO','REAL',LTG3WRK,NTG3WRK)
C And divide it up:
      LSGM1=LTG3WRK
      LTAU=LSGM1+NTUBUF*MXCI
      LSGM2=LTAU+MXCI

C Sectioning loops over pair indices IP3 (ket side):
      DO IP3STA=1,NASHT**2,NYZBUF
       IP3END=MIN(NASHT**2,IP3STA-1+NYZBUF)
C Compute a section of sigma vectors E(YZ)*PSI2 to memory:
       LTO=LSGM2
       DO IP3=IP3STA,IP3END
C Translate to levels in the SGUGA coupling order:
        IL=IWORK(LP2LEV1-1+IP3)
        JL=IWORK(LP2LEV2-1+IP3)
        IY=L2ACT(IL)
        IZ=L2ACT(JL)
        IYS=IASYM(IY)
        IZS=IASYM(IZ)
        ISSG2=MUL(MUL(IYS,IZS),LSYM2)
        CALL DCOPY_(MXCI,[0.0D0],0,WORK(LTO),1)
C LTO is first element of Sigma2 = E(YZ) Psi2
        CALL SIGMA1_CP2(IL,JL,1.0D00,LSYM2,CI2,WORK(LTO),
     &    IWORK(LNOCSF),IWORK(LIOCSF),IWORK(LNOW),IWORK(LIOW),
     &    IWORK(LNOCP),IWORK(LIOCP),IWORK(LICOUP),
     &    WORK(LVTAB),IWORK(LMVL),IWORK(LMVR))
        IF(ISSG2.EQ.LSYM1) THEN
          TG1(IY,IZ)=DDOT_(NCI1,CI1,1,WORK(LTO),1)
        END IF
        LTO=LTO+MXCI
       END DO
C Sectioning loops over pair indices IP1 (bra side):
       DO IP1STA=IP3STA,NASHT**2,NTUBUF
        IP1END=MIN(NASHT**2,IP1STA-1+NTUBUF)
C Compute a section of sigma vectors E(UT)*PSI1 to memory:
        LTO=LSGM1
        DO IP1=IP1STA,IP1END
C Translate to levels:
         JL=IWORK(LP2LEV1-1+IP1)
         IL=IWORK(LP2LEV2-1+IP1)
         IT=L2ACT(IL)
         IU=L2ACT(JL)
         ITS=IASYM(IT)
         IUS=IASYM(IU)
         ISSG1=MUL(MUL(ITS,IUS),LSYM1)
         CALL DCOPY_(MXCI,[0.0D0],0,WORK(LTO),1)
         CALL SIGMA1_CP2(IL,JL,1.0D00,LSYM1,CI1,WORK(LTO),
     &    IWORK(LNOCSF),IWORK(LIOCSF),IWORK(LNOW),IWORK(LIOW),
     &    IWORK(LNOCP),IWORK(LIOCP),IWORK(LICOUP),
     &    WORK(LVTAB),IWORK(LMVL),IWORK(LMVR))
         LTO=LTO+MXCI
        END DO
C Now compute as many elements as possible:
        LFROM=LSGM2
        DO IP3=IP3STA,IP3END
         IY=L2ACT(IWORK(LP2LEV1-1+IP3))
         IZ=L2ACT(IWORK(LP2LEV2-1+IP3))
C LFROM will be start element of Sigma2=E(YZ) Psi2
         IYZ=IY+NASHT*(IZ-1)
         IYS=IASYM(IY)
         IZS=IASYM(IZ)
         ISSG2=MUL(MUL(IYS,IZS),LSYM2)
         DO IP2=IP3,IP1END
          IL=IWORK(LP2LEV1-1+IP2)
          JL=IWORK(LP2LEV2-1+IP2)
          IV=L2ACT(IL)
          IX=L2ACT(JL)
          IVX=IV+NASHT*(IX-1)
          IVS=IASYM(IV)
          IXS=IASYM(IX)
          ISTAU=MUL(MUL(IVS,IXS),ISSG2)
          NTAU=NCSF(ISTAU)
          CALL DCOPY_(MXCI,[0.0D0],0,WORK(LTAU),1)
C LTAU  will be start element of Tau=E(VX) Sigma2=E(VX) E(YZ) Psi2
          CALL SIGMA1_CP2(IL,JL,1.0D00,ISSG2,WORK(LFROM),WORK(LTAU),
     &     IWORK(LNOCSF),IWORK(LIOCSF),IWORK(LNOW),IWORK(LIOW),
     &     IWORK(LNOCP),IWORK(LIOCP),IWORK(LICOUP),
     &     WORK(LVTAB),IWORK(LMVL),IWORK(LMVR))
          IF(ISTAU.EQ.LSYM1) THEN
           TG2(IV,IX,IY,IZ)=DDOT_(NTAU,WORK(LTAU),1,CI1,1)
          END IF
          DO IP1=MAX(IP2,IP1STA),IP1END
           IT=L2ACT(IWORK(LP2LEV1-1+IP1))
           IU=L2ACT(IWORK(LP2LEV2-1+IP1))
           ITS=IASYM(IT)
           IUS=IASYM(IU)
           ISSG1=MUL(MUL(ITS,IUS),LSYM1)
           IF(ISSG1.EQ.ISTAU) THEN
            L=LSGM1+MXCI*(IP1-IP1STA)
            VAL=DDOT_(NTAU,WORK(LTAU),1,WORK(L),1)
            ITU=IT+NASHT*(IU-1)
C Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
C Code to put it in correct place:
            IF(ITU.LT.IVX) THEN
              IF(ITU.GE.IYZ) THEN
                JTU=IVX
                JVX=ITU
                JYZ=IYZ
              ELSE IF(IVX.LT.IYZ) THEN
                  JTU=IYZ
                  JVX=IVX
                  JYZ=ITU
              ELSE
                  JTU=IVX
                  JVX=IYZ
                  JYZ=ITU
              END IF
            ELSE
              IF(ITU.LT.IYZ) THEN
                JTU=IYZ
                JVX=ITU
                JYZ=IVX
              ELSE IF (IVX.GE.IYZ) THEN
                JTU=ITU
                JVX=IVX
                JYZ=IYZ
              ELSE
                JTU=ITU
                JVX=IYZ
                JYZ=IVX
              END IF
            END IF
            JTUVXYZ=((JTU+1)*JTU*(JTU-1))/6+(JVX*(JVX-1))/2+JYZ
            TG3(JTUVXYZ)=VAL

C End of symmetry requirement IF-clause:
           END IF
C End of IP1 loop.
          END DO
C End of IP2 loop.
         END DO
         LFROM=LFROM+MXCI
C End of IP3 loop.
        END DO
C End of IP1STA sectioning loop
       END DO
C End of IP3STA sectioning loop
      END DO
      CALL GETMEM('TG3WRK','FREE','REAL',LTG3WRK,NTG3WRK)
C Now the computed elements of TG2 contain <PSI1|E(IT1,IU1)E(IT2,IU2)|PSI2>
C and TG3 contains <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
C Add here the necessary Kronecker deltas times 2-body matrix
C elements and lower, so we get a true normal-ordered density matrix
C element.

C First, the 2-particle density matrix:
C <PSI1|E(T,U,V,X)|PSI2>  = <PSI1|E(TU)E(VX)|PSI2> - D(V,U)*TG2(T,U,V,X)
      DO IP1=1,NASHT**2
       IT=L2ACT(IWORK(LP2LEV1-1+IP1))
       IU=L2ACT(IWORK(LP2LEV2-1+IP1))
       DO IP2=1,IP1
        IV=L2ACT(IWORK(LP2LEV1-1+IP2))
        IX=L2ACT(IWORK(LP2LEV2-1+IP2))
        IF(IV.EQ.IU) TG2(IT,IU,IV,IX)=TG2(IT,IU,IV,IX)-TG1(IT,IX)
        TG2(IV,IX,IT,IU)=TG2(IT,IU,IV,IX)
       END DO
      END DO
C and then the 3-particle density matrix:
C <PSI1|E(T,U,V,X,Y,Z)|PSI2>  = <PSI1|E(TU)E(VX)E(YZ)|PSI2>
C -D(Y,X)*(TG2(T,U,V,Z)+D(V,U)*TG1(T,Z))
C -D(V,U)*TG2(T,X,Y,Z) C -D(Y,U)*TG2(V,X,T,Z)
      DO IP1=1,NASHT**2
       IT=L2ACT(IWORK(LP2LEV1-1+IP1))
       IU=L2ACT(IWORK(LP2LEV2-1+IP1))
       ITU=IT+NASHT*(IU-1)
       ITS=IASYM(IT)
       IUS=IASYM(IU)
       IS1=MUL(MUL(ITS,IUS),LSYM1)
       DO IP2=1,IP1
        IV=L2ACT(IWORK(LP2LEV1-1+IP2))
        IX=L2ACT(IWORK(LP2LEV2-1+IP2))
        IVX=IV+NASHT*(IX-1)
        IVS=IASYM(IV)
        IXS=IASYM(IX)
        IS2=MUL(MUL(IVS,IXS),IS1)
        DO IP3=1,IP2
         IY=L2ACT(IWORK(LP2LEV1-1+IP3))
         IZ=L2ACT(IWORK(LP2LEV2-1+IP3))
         IYS=IASYM(IY)
         IZS=IASYM(IZ)
         IS3=MUL(MUL(IYS,IZS),IS2)
         IF(IS3.EQ.LSYM2) THEN
          IYZ=IY+NASHT*(IZ-1)
          IF(ITU.LT.IVX) THEN
            IF(ITU.GE.IYZ) THEN
              JTU=IVX
              JVX=ITU
              JYZ=IYZ
            ELSE IF(IVX.LT.IYZ) THEN
                JTU=IYZ
                JVX=IVX
                JYZ=ITU
            ELSE
                JTU=IVX
                JVX=IYZ
                JYZ=ITU
            END IF
          ELSE
            IF(ITU.LT.IYZ) THEN
              JTU=IYZ
              JVX=ITU
              JYZ=IVX
            ELSE IF (IVX.GE.IYZ) THEN
              JTU=ITU
              JVX=IVX
              JYZ=IYZ
            ELSE
              JTU=ITU
              JVX=IYZ
              JYZ=IVX
            END IF
          END IF
          JTUVXYZ=((JTU+1)*JTU*(JTU-1))/6+(JVX*(JVX-1))/2+JYZ
          VAL=TG3(JTUVXYZ)
          IF(IY.EQ.IX) THEN
           VAL=VAL-TG2(IT,IU,IV,IZ)
           IF(IV.EQ.IU) THEN
            VAL=VAL-TG1(IT,IZ)
           END IF
          END IF
          IF(IV.EQ.IU) THEN
           VAL=VAL-TG2(IT,IX,IY,IZ)
          END IF
          IF(IY.EQ.IU) THEN
           VAL=VAL-TG2(IV,IX,IT,IZ)
          END IF
          TG3(JTUVXYZ)=VAL
         END IF
        END DO
       END DO
      END DO
      CALL GETMEM('IPTOLEV','FREE','INTE',LP2LEV,2*NASHT**2)

 999  CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine pvbcopy_cvb(cfrom,cto)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension cfrom(*),cto(*)

      icfrom=nint(cfrom(1))
      icto=nint(cto(1))
      if(iform_ci(icfrom).ne.0.or.iform_ci(icto).ne.0)then
        write(6,*)' Unsupported format in PVBCOPY'
        call abend_cvb()
      endif
      call pvbcopy2_cvb(work(iaddr_ci(icfrom)),work(iaddr_ci(icto)),
     >  iwork(ll(11)),iwork(ll(12)),dum,0)
      call setcnt2_cvb(icto,0)
      return
      end
      subroutine pvbdot_cvb(cfrom,cto,ret)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension cfrom(*),cto(*)
      icfrom=nint(cfrom(1))
      icto=nint(cto(1))
      if(iform_ci(icfrom).ne.0.or.iform_ci(icto).ne.0)then
        write(6,*)' Unsupported format in PVBDOT'
        call abend_cvb()
      endif
      call pvbcopy2_cvb(work(iaddr_ci(icfrom)),work(iaddr_ci(icto)),
     >  iwork(ll(11)),iwork(ll(12)),ret,1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RToCore(F,nBeta,ishll,lb,iAng,nveccb)
*******************************************************************************
*
* Transformation kernel to atomic orbials in normailized spherical harmonics
*
*******************************************************************************
*    @parameter F  The cartesian components of <A|core>
*    @parameter nBeta Number of exponents
*    @parameter ishll Shell number for ECP
*    @parameter lb angular momenta Ket
*    @parameter iAng angular momenta core
*    @parameter nveccb Number of derivatives
*******************************************************************************
*
      use Real_Spherical
      use Basis_Info
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"
      Real*8 F(*)

      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2

*******************************************************************************
      ncb=nelem(lb)*nelem(iang)
      nExpi=Shells(iShll)%nExp
      nBasisi=Shells(iShll)%nBasis
      Call Getmem('TMP1','ALLO','REAL',iptmp,
     &             nExpi*ncb*nVecCB*nBeta)
      Call Getmem('TMP2','ALLO','REAL',ipF,
     &             nExpi*ncb*nVecCB*nBeta)
*
*--------------And (almost) the same thing for the righthand side, form
*              KjCb from kjcb
*              1) jcb,K = k,jcb * k,K
*
      Call DGEMM_('T','N',
     &            nBeta*ncb*nVecCB,nBasisi,nExpi,
     &            1.0d0,F,nExpi,
     &            Shells(iShll)%pCff,nExpi,
     &            0.0d0,Work(ipTmp),nBeta*ncb*nVecCB)
*
*--------------2)  j,cbK -> cbK,j
*
      Call DgeTMo(Work(ipTmp),nBeta,nBeta,
     &            ncb*nVecCB*nBasisi,Work(ipF),
     &            ncb*nVecCB*nBasisi)
*
*--------------3) bKj,C = c,bKj * c,C
*
      Call DGEMM_('T','N',
     &            nElem(lb)*nVecCB*nBasisi*nBeta,
     &            (2*iAng+1),nElem(iAng),
     &            1.0d0,Work(ipF),nElem(iAng),
     &            RSph(ipSph(iAng)),nElem(iAng),
     &            0.0d0,Work(ipTmp),
     &            nElem(lb)*nVecCB*nBasisi*nBeta)
*
*--------------4) b,KjC -> KjC,b
*
      Call DgeTMo(Work(ipTmp),nElem(lb)*nVecCB,
     &            nElem(lb)*nVecCB,
     &            nBasisi*nBeta*(2*iAng+1),F,
     &            nBasisi*nBeta*(2*iAng+1))
*
      Call Getmem('TMP1','FREE','REAL',iptmp,
     &            nExpi*ncb*nVecCB*nBeta)
      Call Getmem('TMP2','FREE','REAL',ipF,
     &            nExpi*ncb*nVecCB*nBeta)
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETVEC1(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,SCR,LSCR)
!
! Purpose: read Cholesky vectors IVEC=IVEC1,....,IVEC1+NUMVEC-1
!          of symmetry ISYM from file. The vectors are returned
!          in the "current" reduced set. This routine attempts
!          to minimize gather/scatter operations and uses batched
!          reading to (hopefully) improve buffering.
!
! NOTE: the scratch array SCR(LSCR) is used to read vectors from
!       disk and should not be smaller than NNBSTR(ISYM,1)+1.

use Cholesky, only: Cho_AdrVec, InfVec, iScr, LuPri, nnBstR, nSys_call
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LENVEC, NUMVEC, IVEC1, ISYM, LSCR
real(kind=wp), intent(inout) :: CHOVEC(LENVEC,NUMVEC), SCR(LSCR)
integer(kind=iwp) :: IAB, IBATCH, IBVEC1, ILOC, IOFF(0:1), IRED, IRED1, IRED2, IREDC, IVEC2, JNUM, JNUM_RD, JRED, JVEC, JVEC1, &
                     JVEC2, JVEC_END, KBVEC1, KJUNK, KOFF, KSCR, KVEC, KVEC1, LEFT, LTOT, MINL, MUSED, NBATCH, NUMV, NVEC
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_GETVEC1'

! Some initializations.
! ---------------------

ILOC = 3
IVEC2 = IVEC1+NUMVEC-1

KJUNK = 1
KSCR = KJUNK+1
LEFT = LSCR-KSCR+1
if (LEFT <= 0) call CHO_QUIT('Insufficient scratch space in '//SECNAM,101)

SCR(KJUNK) = Zero
IOFF(0) = KJUNK

! Get reduced sets of first and last vector.
! ------------------------------------------

IRED1 = INFVEC(IVEC1,2,ISYM)
IRED2 = INFVEC(IVEC2,2,ISYM)

! Loop through reduced sets to be read.
! -------------------------------------

KVEC1 = 1
JVEC1 = IVEC1
do IRED=IRED1,IRED2

  ! Count vectors in this reduced set.
  ! ----------------------------------

  JNUM = 0
  JVEC = JVEC1-1
  do while (JVEC < IVEC2)
    JVEC = JVEC+1
    JRED = INFVEC(JVEC,2,ISYM)
    if (JRED == IRED) then
      JNUM = JNUM+1 ! increase counter
    else
      JVEC = IVEC2 ! break while loop
    end if
  end do

  ! Skip if this reduced set is empty.
  ! ----------------------------------

  if (JNUM /= 0) then

    ! Check vector range.
    ! -------------------

    if (LOCDBG) then
      JVEC2 = JVEC1+JNUM-1
      if (JVEC2 > IVEC2) then
        write(LUPRI,*) SECNAM,': IRED  = ',IRED
        write(LUPRI,*) SECNAM,': JNUM  = ',JNUM
        write(LUPRI,*) SECNAM,': JVEC1 = ',JVEC1
        write(LUPRI,*) SECNAM,': JVEC2 = ',JVEC2
        call CHO_QUIT('Vector index error in '//SECNAM,103)
      end if
    end if

    ! Read reduced set index arrays.
    ! ------------------------------

    call CHO_GETRED(IRED,ILOC,.false.)
    call CHO_SETREDIND(ILOC)

    ! If reduced sets are identical, simply read the vectors
    ! directly into CHOVEC array and go to next reduced set.
    ! ------------------------------------------------------

    if (NNBSTR(ISYM,3) == NNBSTR(ISYM,2)) then
      !if (CHO_ADRVEC == 1) then
      !  IOPT = 2
      !  IADR = INFVEC(JVEC1,3,ISYM)
      !  LTOT = NNBSTR(ISYM,2)*JNUM
      !  call DDAFILE(LUCHO(ISYM),IOPT,CHOVEC(1,KVEC1),LTOT,IADR)
      !  NSYS_CALL = NSYS_CALL+1
      !else if (CHO_ADRVEC == 2) then
      !  IOPT = 2
      !  LTOT = NNBSTR(ISYM,2)
      !  do KK=1,JNUM
      !    IADR = INFVEC(JVEC1+KK-1,3,ISYM)
      !    call DDAFILE(LUCHO(ISYM),IOPT,CHOVEC(1,KVEC1+KK-1),LTOT,IADR)
      !    NSYS_CALL = NSYS_CALL+1
      !  end do
      !else
      !  call CHO_QUIT('[1] CHO_ADRVEC error in '//SECNAM,102)
      !end if
      !-tbp: replaced above to make use of buffer in cho_vecrd.
      LTOT = NNBSTR(ISYM,2)*JNUM
      JVEC_END = JVEC1+JNUM-1
      JNUM_RD = 0
      IREDC = IRED
      MUSED = 0
      call CHO_VECRD(CHOVEC(1,KVEC1),LTOT,JVEC1,JVEC_END,ISYM,JNUM_RD,IREDC,MUSED)
      if (JNUM_RD /= JNUM) call CHO_QUIT('Logical error [RD1] in '//SECNAM,103)
      NSYS_CALL = NSYS_CALL+1
    else

      ! Set up batch over vectors to be read.
      ! -------------------------------------

      MINL = NNBSTR(ISYM,3)
      if (MINL < 1) then
        NVEC = 0
      else
        NVEC = min(LEFT/MINL,JNUM)
      end if
      if (NVEC < 1) then
        write(LUPRI,*) SECNAM,': insufficient scratch space:'
        write(LUPRI,*) 'LEFT = ',LEFT
        write(LUPRI,*) 'JNUM = ',JNUM
        write(LUPRI,*) 'MINL = ',MINL
        write(LUPRI,*) 'NVEC = ',NVEC
        write(LUPRI,*) 'Input:'
        write(LUPRI,*) 'IVEC1  = ',IVEC1
        write(LUPRI,*) 'NUMVEC = ',NUMVEC
        write(LUPRI,*) 'LENVEC = ',LENVEC
        write(LUPRI,*) 'ISYM   = ',ISYM
        call CHO_QUIT('Insufficient scratch space in '//SECNAM,104)
        NBATCH = 0 ! to avoid compiler warnings
      else
        NBATCH = (JNUM-1)/NVEC+1
      end if

      ! Set up mapping between reduced sets.
      ! ------------------------------------

      call CHO_RS2RS(ISCR,size(ISCR),2,3,IRED,ISYM)

      ! Start batch loop.
      ! -----------------

      do IBATCH=1,NBATCH

        if (IBATCH == NBATCH) then
          NUMV = JNUM-NVEC*(NBATCH-1)
        else
          NUMV = NVEC
        end if
        IBVEC1 = JVEC1+NVEC*(IBATCH-1)
        KBVEC1 = KVEC1+NVEC*(IBATCH-1)

        ! Read vectors.
        ! -------------

        !if (CHO_ADRVEC == 1) then
        !   IOPT = 2
        !   LTOT = NNBSTR(ISYM,3)*NUMV
        !   IADR = INFVEC(IBVEC1,3,ISYM)
        !   call DDAFILE(LUCHO(ISYM),IOPT,SCR(KSCR),LTOT,IADR)
        !   NSYS_CALL = NSYS_CALL+1
        !else if (CHO_ADRVEC == 2) then
        !   IOPT = 2
        !   LTOT = NNBSTR(ISYM,3)
        !   KTRG = KSCR
        !   do KK=1,NUMV
        !      IADR = INFVEC(IBVEC1+KK-1,3,ISYM)
        !      call DDAFILE(LUCHO(ISYM),IOPT,SCR(KTRG),LTOT,IADR)
        !      KTRG = KTRG+NNBSTR(ISYM,3)
        !      NSYS_CALL = NSYS_CALL+1
        !   end do
        !else
        !   call CHO_QUIT('[2] CHO_ADRVEC error in '//SECNAM,102)
        !end if
        !-tbp: replaced above to make use of buffer in cho_vecrd.
        LTOT = NNBSTR(ISYM,3)*NUMV
        JVEC_END = IBVEC1+NUMV-1
        JNUM_RD = 0
        IREDC = IRED
        MUSED = 0
        call CHO_VECRD(SCR(KSCR),LTOT,IBVEC1,JVEC_END,ISYM,JNUM_RD,IREDC,MUSED)
        if (JNUM_RD /= NUMV) call CHO_QUIT('Logical error [RD2] in '//SECNAM,103)
        if (CHO_ADRVEC == 1) then
          NSYS_CALL = NSYS_CALL+1
        else if (CHO_ADRVEC == 2) then
          NSYS_CALL = NSYS_CALL+NUMV
        else
          call CHO_QUIT('CHO_ADRVEC error in '//SECNAM,102)
        end if

        ! Copy vectors into result array.
        ! -------------------------------

        do JVEC=1,NUMV
          KVEC = KBVEC1+JVEC-1
          IOFF(1) = IOFF(0)+NNBSTR(ISYM,3)*(JVEC-1)
          do IAB=1,NNBSTR(ISYM,2)
            KOFF = IOFF(min(ISCR(IAB),1))+ISCR(IAB)
            CHOVEC(IAB,KVEC) = SCR(KOFF)
          end do
        end do

      end do
    end if
  end if

  ! Set next vector to be treated.
  ! ------------------------------

  KVEC1 = KVEC1+JNUM
  JVEC1 = JVEC1+JNUM

end do

end subroutine CHO_GETVEC1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine T3AMPL_BTI(OEH,OEP)
!mp subroutine T3AMPL_BTI(W,OEH,OEP)

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!    *** PROGRAM TRIPLY-UHF/RHF - REDUCED DIMENSION and timing - DRIVER
!
!    CALCULATION OF TRIPLE EXCITATION CONTRIBUTION TO
!    THE 4TH ORDER CORRELATION ENERGY OF MB RSPT AND CC-TRIPLES
!
!    Provides T3AMPL_BLOCKEDIMPROVED:  Accelerated algorithm.
!
!     Combines triply w/ trick by JN and limited I/Os by buffered
!     blocking scheme by PV. Blocks the virtual space to pieces
!     optimal either for parallelization or in using the available
!     memory
!     Involves also more robust and more reliable memory allocator.
!
! History
!     Buffered blocking scheme: PV, LAOG Grenoble, 16 april 2003.
!     First version w/ trick: JN, June 12, 2003
!     Parallel version: PV, 15 oct 2003.
!     Implemented integer offsets, PV, 14 may 2004.
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

use ChT3_global, only: gen_files, ICH, IOPT, IT, NOAB, NUAB, printkey, run_triples, t3_starta, t3_startb, t3_stopa, t3_stopb, &
                       TCpu, TCpu_l, TCpu0, TWall, TWall_l, TWall0
use Para_Info, only: MyRank, nProcs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6, r8

implicit none
real(kind=wp), intent(in) :: OEH(*), OEP(*)
integer(kind=iwp) :: i, id, isp, it1, IUHF, j, krem, LU(6), n, nga, ngb, ngc, nla, nlb, nuga, nugc, vblock
real(kind=wp) :: ccsdt, ccsdt4, cpu0_aaa, cpu0_aab, e_ccsd, e_scf, energ(4), enx1, tccsd, timerel, times(10), times_parr(10), &
                 totcpu, totwal, wall0_aaa, wall0_aab
#ifdef _MOLCAS_MPP_
real(kind=wp) :: real_buffer(1)
#endif
logical(kind=iwp) :: ifvo, scored, skip
character(len=6) :: FN
integer(kind=iwp), allocatable :: my_tsk(:,:)
real(kind=wp), allocatable :: la(:), t1a(:), t1b(:), tmp(:)
logical(kind=iwp), external :: rsv_tsk
real(kind=r8), external :: ddot_

!? nprocs0 = nprocs
! Uncomment the following to force sequential mode
! nprocs = 1

if (nprocs > 1) then
  write(u6,'(A,i4,A)') ' Parallel run on ',nprocs,' nodes'
else
  write(u6,'(A,i4,A)') ' Serial run'
end if
call xflush(u6)

! t^ijk_abc . D^abc_ijk =
!
! alpha-alpha-alpha (K_ab^ir+K_ab^jr-K_ac^kr)*(L_rc^jk+L_rc^ki+L_rc^ij)
! or beta-beta-beta   + permutations bca, acb
!        - M_abc^iki -M_abc^iij -M_abc^jjk+M_abc^jij-M_abc^kki+M_abc^kjk
!         + permutations bca cab
!
!        where    M_abc^ijk=K_ab^ir*L_ra^jk
!
!  strategy:   blocks the number of virtuals to pieces by ng
!              then everything in the memory!
!
! free everything from W(1) including Hermit space
! (PV) done for slaves in calling routine slave_T3AMPL_BTI
!
! parallelization: distribute common UHF
! (PV) done for slaves in calling routine slave_T3AMPL_BTI

!mp !!call gettim(cpu0,wall0)

do I=1,6
  LU(I) = 90+I
end do

times(:) = Zero
energ(:) = Zero

! calculate the T2-T3 contraction?  ifvo is the answer ! open-shell stuff !
!mp call get3dm('FOC-VO',w,noab(1)*nuab(1)+noab(2)*nuab(2),1,0)
!mp ifvo = ddot_(noab(1)*nuab(1)+noab(2)*nuab(2),w,1,w,1) > 1.0e-14_wp
ifvo = .false.

! parallelization:  do this on each host >>>>>>> start

! allocates for two arrays of the size T1

it1 = NUAB(1)*NOAB(1)+NUAB(2)*NOAB(2)

call mma_allocate(t1a,it1,label='t3_t1a')
call mma_allocate(t1b,it1,label='t3_t1b')

t1a(:) = Zero
t1b(:) = Zero

call mma_allocate(tmp,noab(1)*nuab(1),label='t3_t1')
call mma_allocate(la,it1,label='t3_la')

!mp ! read t1 amplitudes
if (printkey >= 10) write(u6,*) 'Reading ',it1,' t1_alpha, t1_beta amplitudes'
call GetRest_t3(la,tmp,e_ccsd)

!mp !write(u6,*) 'Ze t1 = ',ddot_(it1,la,1,la,1)

! t1a and t1b always remain in the memory -- small fields

! parallelization:   on each host <<<<<<< end  - block done

! Remaining space can be used for the blocking in-core algorithms

call mma_maxDBLE(krem)

if (printkey >= 10) then
  write(u6,*)
  write(u6,*) 'Available Memory before v_size_t3 = ',krem
  call xflush(u6)
end if

! determines the virtual block size
! vblock - the virtual orbitals block size
! look for optimal number with respect nprocs to v_size_t3

write(u6,*)
write(u6,'(2x,A)') 'Starting triply with blocked virtuals algorithm'
if (nprocs > 1) write(u6,*) ' Node Number ',MyRank

! Compute memory pattern.

call v_size_t3(vblock,nprocs,krem,printkey)

IUHF = 1 ! open-shell stuff
if (IOPT(1) == 0) IUHF = 0

if (printkey >= 10) write(u6,'(A,i1)') ' Closed-Shell calculation, IUHF = ',iuhf

! create K(beta-alpha,beta-alpha) and L(alpha-beta,beta-alpha)
!ndup = 0 !?????

!mp - print information on number of steps in loopa and loopb

call check_loops(nuab(1),vblock,nla,nlb)
write(u6,*)
write(u6,'(A,i6)') 'Number of steps in loopa : ',nla
write(u6,'(A,i6)') 'Number of steps in loopb : ',nlb

! checking :

if (t3_stopa > nla) then
  write(u6,*) 'Too many steps in t3_loopa requested in input'
  write(u6,*) 'T3_LOOPA from input : ',t3_starta,t3_stopa,t3_stopa-t3_startb+1
  write(u6,*) 'total T3_LOOPA steps : ',nla
  call abend()
end if

if (t3_stopb > nlb) then
  write(u6,*) 'Too many steps in t3_loopb requested in input'
  write(u6,*) 'T3_LOOPB from input : ',t3_startb,t3_stopb,t3_stopb-t3_startb+1
  write(u6,*) 'total T3_LOOPB steps : ',nlb
  call abend()
end if

!mp
if (gen_files) then

  write(u6,*)
  write(u6,*) 'Creating KMAT, LMAT Scratch Integral Files-----------------------------'
  write(u6,*)
  !mp
  call create_klvab_t3(vblock)
  !mp
  call CWTime(TCpu,TWall)

  if (printkey > 1) then
    write(u6,*)
    write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
    write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
    write(u6,*)
    write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
    write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
    write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
    write(u6,*)
  end if

  TCpu_l = TCpu
  TWall_l = TWall

  !mp

  write(u6,*) 'Create of Integrals done-------------------------------------------------'
  write(u6,*)
  !mp

else
  write(u6,*)
  write(u6,*) 'Skipping KMAT, LMAT scratch integral files generation as requested'
end if
!mp
cpu0_aaa = TCpu
wall0_aaa = TWall
!
if (.not. run_triples) then
  write(u6,*)
  write(u6,*) 'Exiting triples after scratch integral files generation as requested'
  return
  !? call abend()
end if
!mp

! creates K(alpha-alpha,alpha-alpha) (dummy for closed shell)
! (master only)
!mp
!mp ! open-shell stuff
!mp !
!mp !if (iuhf /= 0) then
!mp !  do isp=1,1+iuhf
!mp !    call create_klvaa_t3(w(la),vblock,isp)
!mp !  end do
!mp !end if

! parallelization: files KMATxy LMATxy x=A,B  y=A,B (BA - closed shell)
!                  generated on each host

! Sorting and initialization timing

!mp !call gettim(cpu1,wall1)  !  prerob na poriadne timingy
call CWTime(TCpu,TWall)
times(9) = times(9)+TCpu-TCpu0
times(10) = times(10)+TWall-TWall0

skip = .false.
do isp=1,1+iuhf

  nuga = nuab(isp)/vblock
  if ((nuga*vblock) < nuab(isp)) nuga = nuga+1
  nugc = nuab(3-isp)/vblock
  if ((nugc*vblock) < nuab(3-isp)) nugc = nugc+1
  ! creates K(alpha-alpha,alpha-alpha) (dummy for closed shell)
  !!if (iuhf /= 0) then   ! open-shell stuff.
  !!  call create_klvaa_t3(w(la),vblock,isp)
  !!end if
  FN = 'KMAT'//ich(isp)//ich(isp)
  call multi_opendir(FN,LU(1))
  FN = 'LMAT'//ich(isp)//ich(isp)
  call multi_opendir(FN,LU(2))

  ! parallelization: files KMATxx LMATxx are assumed to be available
  ! to all tasks on each host

  !                  not for closed shell
  !     alpha-alpha-alpha   or closed shell

  ! - skip t3loopa if needed

  if ((t3_starta < 0) .and. (t3_startb > 0)) then
    write(u6,*)
    write(u6,*) 'Skipping t3loopa on user request '
    write(u6,*)
  else

    if (t3_starta < 0) then
      i = 0
      do nga=1,nuga
        do ngb=1,nga
          do ngc=1,ngb
            i = i+1
          end do
        end do
      end do
    else
      i = t3_stopa-t3_starta+1
    end if
    call mma_allocate(my_tsk,3,i,label='my_tsk')

    i = 0
    if (t3_starta < 0) then
      do nga=1,nuga
        do ngb=1,nga
          do ngc=1,ngb
            i = i+1
            my_tsk(1,i) = nga
            my_tsk(2,i) = ngb
            my_tsk(3,i) = ngc
          end do
        end do
      end do
    else
      do nga=1,nuga
        do ngb=1,nga
          do ngc=1,ngb
            i = i+1
            if ((i >= t3_starta) .and. (i <= t3_stopa)) then
              my_tsk(1,i-t3_starta) = nga
              my_tsk(2,i-t3_starta) = ngb
              my_tsk(3,i-t3_starta) = ngc
            end if
          end do
        end do
      end do
    end if

    if (t3_starta > 0) then ! for correct deallocation
      i = t3_stopa-t3_starta+1
    end if

    write(u6,*)
    write(u6,*) '# of tasks to be parallelized in t3loop a = ',i
    id = 666
    scored = .false.
    call init_tsk(id,i)
    do while (rsv_tsk(id,j))

      nga = my_tsk(1,j)
      ngb = my_tsk(2,j)
      ngc = my_tsk(3,j)

      !mp
      !mp call mma_maxDBLE(maxspace)
      !mp write(u6,*) 'maxspace before ',maxspace
      !mp
      call t3loopa(oeh(noab(1)*(isp-1)+1),oep(nuab(1)*(isp-1)+1),t1a(noab(1)*nuab(1)*(isp-1)+1), &
                   t1b(noab(1)*nuab(1)*(isp-1)+1),nga,ngb,ngc,vblock,energ,isp,LU,ifvo,scored,enx1)
      !mp
      ! update 5th order terms

      n = noab(1)*nuab(1)
      !mp t1a(1:n) = t1a(1:n)+t1a(n+1:2*n)
      ccsdt = Two*(ddot_(n,la,1,t1a,1)+ddot_(n,la,1,t1a(n+1),1))

      !mp
      call CWTime(TCpu,TWall)
      !mp
      if (t3_starta < 0) then
        write(u6,'(A,i5,1x,3(i3,1x),2(f21.19,1x),2(f8.1,A,1x))') 'Tsk, nga, ngb, ngc, inc = ',j,nga,ngb,ngc,Two*enx1,ccsdt, &
                                                                 TCpu-TCpu_l,' CPU [s]',TWall-TWall_l,' Wall [s]'
      else
        write(u6,'(A,i5,1x,3(i3,1x),2(f21.19,1x),2(f8.1,A,1x))') 'Tsk, nga, ngb, ngc, inc = ',j+t3_starta-1,nga,ngb,ngc,Two*enx1, &
                                                                 ccsdt,TCpu-TCpu_l,' CPU [s]',TWall-TWall_l,' Wall [s]'
      end if

      TCpu_l = TCpu
      TWall_l = TWall
      !mp
      !mp call mma_maxDBLE(maxspace)
      !mp write(u6,*) 'maxspace after ',maxspace
      !mp

    end do
    write(u6,*) 't3loopa finished'
    write(u6,*)
    call Free_tsk(id)
    call mma_deallocate(my_tsk)

    !mp !call gettim(cpu1,wall1)            ! dorob timingy !!!!!!
    call CWTime(TCpu,TWall)
    times(isp) = times(isp)+TCpu-cpu0_aaa
    times(isp+4) = times(isp+4)+TWall-wall0_aaa

    write(u6,'(1X,5A,D12.4,A,D12.4,A)') 'Spin case ',ich(isp),ich(isp),ich(isp),' done:',TCpu-cpu0_aaa,' CPU [s]',TWall-wall0_aaa, &
                                        ' Wall [s]'
    call xflush(u6)
    !mp
    call CWTime(TCpu,TWall)

    if (printkey > 1) then
      write(u6,*)
      write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
      write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
      write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
      write(u6,*)
    end if

    TCpu_l = TCpu
    TWall_l = TWall
    !mp

  end if

  !mp
  cpu0_aab = TCpu
  wall0_aab = TWall
  !mp

  if ((t3_starta > 0) .and. (t3_startb < 0)) then
    write(u6,*)
    write(u6,*) 'Skipping t3loopb on user request '
    write(u6,*)
    skip = .true.
    exit
  end if

  ! alpha-alpha-beta or beta-beta-alpha only UHF
  !!if (IUHF /= 0)then
  !mp!!call gettim(cpu0,wall0)
  FN = 'KMAT'//ich(3-isp)//ich(isp)
  call multi_opendir(FN,LU(3))
  FN = 'LMAT'//ich(3-isp)//ich(isp)
  call multi_opendir(FN,LU(5))

  if (IUHF /= 0) then ! open-shell stuff
    FN = 'KMAT'//ich(isp)//ich(3-isp)
    call multi_opendir(FN,LU(4))
    FN = 'LMAT'//ich(isp)//ich(3-isp)
    call multi_opendir(FN,LU(6))
  else
    LU(4) = LU(3)
    LU(6) = LU(5)
  end if

  !mp
  i = 0
  if (t3_startb < 0) then
    do nga=1,nuga
      do ngb=1,nga
        do ngc=1,nugc
          i = i+1
        end do
      end do
    end do
  else
    i = t3_stopb-t3_startb+1
  end if
  call mma_allocate(my_tsk,3,i,label='my_tsk')

  i = 0
  if (t3_startb < 0) then
    do nga=1,nuga
      do ngb=1,nga
        do ngc=1,nugc
          i = i+1
          my_tsk(1,i) = nga
          my_tsk(2,i) = ngb
          my_tsk(3,i) = ngc
        end do
      end do
    end do
  else
    do nga=1,nuga
      do ngb=1,nga
        do ngc=1,nugc
          i = i+1
          if ((i >= t3_startb) .and. (i <= t3_stopb)) then
            my_tsk(1,i-t3_startb) = nga
            my_tsk(2,i-t3_startb) = ngb
            my_tsk(3,i-t3_startb) = ngc
          end if
        end do
      end do
    end do
  end if

  if (t3_startb > 0) then
    i = t3_stopb-t3_startb+1
  end if

  write(u6,*)
  write(u6,*) '# of tasks to be parallelized in t3loopb = ',i
  id = 667
  scored = .false.
  call init_tsk(id,i)
  do while (rsv_tsk(id,j))

    nga = my_tsk(1,j)
    ngb = my_tsk(2,j)
    ngc = my_tsk(3,j)
    !mp write(u6,'(A,4(i5,2x))') 'Tsk, nga, ngb, ngc = ',j,nga,ngb,ngc

    !mp
    !mp call mma_maxDBLE(maxspace)
    !mp write(u6,*) 'maxspace before ',maxspace
    !mp
    call t3loopb(oeh,oep,t1a,t1b,nga,ngb,ngc,vblock,energ(3),isp,LU,ifvo,scored,enx1)

    n = noab(1)*nuab(1)
    !mp??? t1a(1:n) = t1a(1:n)+t1a(n+1:2*n)
    ccsdt = Two*(ddot_(n,la,1,t1a,1)+ddot_(n,la,1,t1a(n+1),1))

    !mp
    call CWTime(TCpu,TWall)
    !mp
    if (t3_startb < 0) then
      write(u6,'(A,i5,1x,3(i3,1x),2(f21.19,1x),2(f8.1,A,1x))') 'Tsk, nga, ngb, ngc, inc = ',j,nga,ngb,ngc,Two*enx1,ccsdt, &
                                                               TCpu-TCpu_l,' CPU [s]',TWall-TWall_l,' Wall [s]'
    else
      write(u6,'(A,i5,1x,3(i3,1x),2(f21.19,1x),2(f8.1,A,1x))') 'Tsk, nga, ngb, ngc, inc = ',j+t3_startb-1,nga,ngb,ngc,Two*enx1, &
                                                               ccsdt,TCpu-TCpu_l,' CPU [s]',TWall-TWall_l,' Wall [s]'
    end if

    TCpu_l = TCpu
    TWall_l = TWall

    !mp
    !mp call mma_maxDBLE(maxspace)
    !mp write(u6,*) 'maxspace before ',maxspace
    !mp

  end do
  write(u6,*) 't3loopb finished'
  write(u6,*)
  call Free_tsk(id)
  call mma_deallocate(my_tsk)
  !mp write(u6,*) ' energ = ',energ
  !mp
  ! - deallocate arrays in t3loopb
  !
  !mp !call gettim(cpu1,wall1)  ! urob poriadne timingy !!!!
  call CWTime(TCpu,TWall)
  times(2+isp) = times(2+isp)+TCpu-cpu0_aab
  times(6+isp) = times(6+isp)+TWall-wall0_aab
  write(u6,'(1X,5A,D12.4,A,D12.4,A)') 'Spin case ',ich(isp),ich(isp),ich(3-isp),' done:',TCpu-cpu0_aab,' CPU [s]',TWall-wall0_aab, &
                                      ' Wall [s]'
  call xflush(u6)
  do i=3,6
    close(LU(i))
  end do
  !!end if   !! IUHF
  close(LU(1))
  close(LU(2))
end do        ! isp
if (.not. skip) then
  !mp !!call gettim(cpu0,wall0) ! urob timingy!
  !mp
  call CWTime(TCpu,TWall)

  if (printkey > 1) then
    write(u6,*)
    write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
    write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
    write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
    write(u6,*)
  end if
  TCpu_l = TCpu
  TWall_l = TWall
  !mp
end if

times_parr(:) = times

#ifdef _MOLCAS_MPP_

it1 = NUAB(1)*NOAB(1)+NUAB(2)*NOAB(2)
real_buffer(1) = ccsdt
call gadgop(real_buffer,size(real_buffer),'+')
ccsdt = real_buffer(1)
call gadgop(energ,4,'+')
call gadgop(times_parr,10,'+')

#endif

call xflush(u6)

! Add MPI_Reduce contribution to sorting timing
!mp !cmp call gettim(cpu1,wall1)
!mp !call CWTime(TCpu,TWall)
!mp !times(9) = times(9)+TCpu-TCpu0
!mp !times(10) = times(10)+TWall-TWall0

! T(CCSD)

if (IUHF == 0) then
  energ(2) = energ(1)
  energ(4) = energ(3)
end if
tccsd = energ(1)+energ(2)+energ(3)+energ(4)

!mp !if (IUHF == 0) then ! open-shell stuff
!mp !  call n = noab(1)*nuab(1)
!mp !  t1a(1:n) = t1a(1:n)+t1a(n+1:2*n)
!mp !  ccsdt = Two*ddot_(n,la,1,t1a,1)
!mp !else
!mp !  ccsdt = ddot_(noab(1)*nuab(1)+noab(2)*nuab(2),la,1,t1a,1)
!mp !  write(u6,*) 'ze co do ... ?'
!mp !  stop
!mp !end if

!mp for MOLCAS verify
call Get_dScalar('SCF energy',e_scf)
call Add_Info('CHT3ene',tccsd+ccsdt,1,6)
call Add_Info('E_CHT3',tccsd+ccsdt,1,6)
call Add_Info('E_HYPE',e_scf+e_ccsd+tccsd+ccsdt,1,6)
! for NUMERICAL_GRADIENTS
call Put_cArray('Relax Method','CHT3    ',8)
call Store_Energies(1,tccsd+ccsdt+e_ccsd+e_scf,1)
!mp

if (printkey > 1) then
  write(u6,*)
  write(u6,*) '--------------------------------------------------'
  write(u6,*)
  write(u6,*) 'GADGOPed energ & ccsdt values: '
  write(u6,*)
  write(u6,'(A,4(f15.12,1x))') 'energ (t2-w-t3 = 2*e1 + 2*e3) ',energ
  write(u6,*)
  write(u6,'(A,f15.12)') 'Sum                           ',Two*energ(1)+Two*energ(3)
  write(u6,'(A,f15.12)') 'ccsdt (e5th ord. ST)          ',ccsdt
  write(u6,*)
  write(u6,*) '--------------------------------------------------'
end if

! Contents of times array:
!
!              CPU      WALL
! sorting
! aaa           1        4
! bbb           2        6
! aab           3        7
! bba           4        8

! Master has only to sum up the results
times(:) = times/60.0_wp ! now in minutes
if (nprocs > 1) times_parr(:) = times_parr/60.0_wp

ccsdt4 = Zero
if (ifvo) then
  write(u6,*) 'ifvo correspond to open-shell system. Exiting'
  call abend()

  !mp !call get3dm('FOC-VO',w(la),noab(1)*nuab(1)+noab(2)*nuab(2),1,0)
  !mp !call map2_21_t3(w(la),w(t1a),nuab(1),noab(1))
  !mp !call map2_21_t3(w(noab(1)*nuab(1)+la),w(t1a+noab(1)*nuab(1)),nuab(2),noab(2))
  ! E4 T2FT3
  !mp !if (IUHF == 0) then
  !mp !  n = noab(1)*nuab(1)
  !mp !  w(t1b:t1b+n-1) = w(t1b:t1b+n-1)+w(t1b+n:n1b+2*n-1)
  !mp !  ccsdt4 = Two*ddot_(noab(1)*nuab(1),w(t1a),1,w(t1b),1)
  !mp !else
  !mp !  ccsdt4 = ddot_(noab(1)*nuab(1)+noab(2)*nuab(2),w(t1a),1,w(t1b),1)
  !mp !end if
end if

!RESULT(IT+3,5) = ccsdt4+ccsdt
if (IT == 0) then
  !RESULT(IT+1,5) = tccsd+ccsdt4+ccsdt
  if (ifvo) then
    write(u6,9993) TCCSD
    write(u6,9991) ccsdt4
    write(u6,9990) ccsdt
  end if
  write(u6,9994) TCCSD+ccsdt+ccsdt4
else
  !RESULT(IT+2,5) = TCCSD
  write(u6,9993) TCCSD
  if (ifvo) then
    write(u6,9991) ccsdt4
    write(u6,9990) ccsdt
    write(u6,9995) CCSDT+ccsdt4
  else
    write(u6,9995) CCSDT
  end if
end if

write(u6,*) '*************************************************'
write(u6,*)
write(u6,*) 'Final Results : '
write(u6,*)
write(u6,'(A,f15.12)') '   (T)     corr. = ',tccsd+ccsdt
write(u6,'(A,f15.12)') '   CCSD(T) corr. = ',e_ccsd+tccsd+ccsdt
write(u6,*)
write(u6,*) '*************************************************'
write(u6,*)

! Timing
if (nprocs > 1) write(u6,*) 'Master timings:'
if (times(10) <= Zero) then
  timerel = One
else
  timerel = times(9)/times(10)
end if
write(u6,'(1x,a,2f13.3,a,f6.3)') 'sorting cpu & wall',times(9),times(10),' (min);   cpu/wall=',timerel
if (times(5) <= Zero) then
  timerel = One
else
  timerel = times(1)/times(5)
end if
write(u6,'(1x,a,2f13.3,a,f6.3)') 'aaa     cpu & wall',times(1),times(5),' (min);   cpu/wall=',timerel
if (times(6) <= Zero) then
  timerel = One
else
  timerel = times(2)/times(6)
end if
if (IUHF /= 0) write(u6,'(1x,a,2f13.3,a,f6.3)') 'bbb     cpu & wall',times(2),times(6),' (min);   cpu/wall=',timerel
if (times(7) <= Zero) then
  timerel = One
else
  timerel = times(3)/times(7)
end if
write(u6,'(1x,a,2f13.3,a,f6.3)') 'aab     cpu & wall',times(3),times(7),' (min);   cpu/wall=',timerel
if (times(8) <= Zero) then
  timerel = One
else
  timerel = times(4)/times(8)
end if
if (IUHF /= 0) write(u6,'(1x,a,2f13.3,a,f6.3)') 'bba     cpu & wall',times(4),times(8),' (min);   cpu/wall=',timerel
totcpu = times(9)
totwal = times(10)
do i=1,4
  totcpu = totcpu+times(i)
  totwal = totwal+times(4+i)
end do
if (totwal <= Zero) then
  timerel = One
else
  timerel = totcpu/totwal
end if
write(u6,'(1x,a,2f13.3,a,f6.3)') 'total   cpu & wall',totcpu,totwal,' (min);   cpu/wall=',timerel

if (nprocs > 1) then
  ! Parallel timing
  totcpu = times_parr(9)
  totwal = times_parr(10)
  times(9) = times_parr(9)
  do i=1,4
    totcpu = totcpu+times_parr(i)
    totwal = totwal+times_parr(4+i)
  end do
  if (totwal <= Zero) then
    timerel = One
  else
    timerel = totcpu/totwal
  end if
  write(u6,*)
  write(u6,*) 'Aggregate parallel timings:'
  write(u6,'(1x,a,2f13.3,a,f6.3)') 'total   cpu & wall',totcpu,totwal,' (min);   cpu/wall=',timerel
end if

! Return
!mp call w_debug(.false.,.false.,'Triply done')
!? nprocs = nprocs0

call mma_deallocate(la)
call mma_deallocate(tmp)
call mma_deallocate(t1a)
call mma_deallocate(t1b)

return

9993 format(/1X,'T2-W-T3 contribution from current amplitudes ',D18.10)
9991 format(1X,'T2-F-T3 contribution from current amplitudes ',D18.10)
9990 format(1X,'T1-W-T3 contribution from current amplitudes ',D18.10)
9994 format(/1X,'4th order MBPT tripleexcitation contribution ',D18.10)
9995 format(/1X,'5th order noniterative E[5] ST correction ',D18.10/)

end subroutine T3AMPL_BTI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Prim_Density_Matrix(ip_D,nBas,ip_D_p,nPrim,TM)

      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Dimension TM(nPrim,nBas)

      Do i=1,nBas
        Do k=1,i-1
          Work(ip_D+i*(i-1)/2+k-1)=Work(ip_D+i*(i-1)/2+k-1)/2.0d0
        EndDo
      EndDo
      Call GetMem('D_p','ALLO','REAL',ip_D_p,nPrim*(nPrim+1)/2)
      Do i=1,nPrim
        Do k=1,i
          TmpDensity=0.0d0
          Do j=1,nBas
            Do l=1,nBas
              TMij=TM(i,j)
              TMkl=TM(k,l)
              If(j.lt.l) Then
                Djl=Work(ip_D+l*(l-1)/2+j-1)
              Else
                Djl=Work(ip_D+j*(j-1)/2+l-1)
              EndIf
              TmpDensity=TmpDensity+TMij*TMkl*Djl
            EndDo
          EndDo
          Work(ip_D_p+i*(i-1)/2+k-1)=TmpDensity
        EndDo
      EndDo

      Return
      End
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHO_REORDR(irc,scr,lscr,jVref,JVEC1,JNUM,NUMV,JSYM,
     &                      IREDC,iSwap,ipChoV,iSkip)
************************************************************
*   Author: F. Aquilante
*
*   Purpose:  SCR(lscr) contains JNUM cholesky vectors
*             starting from JVEC1 and stored in reduced
*             sets. The routine performs a reallocation
*             of these elements in a set of target
*             arrays identified by the pointers ipChoV.
*             In the target arrays, the vectors are
*             stored in full dimension and as a
*             subset of a a given NUMV number of vectors.
*             Each pointer should thereby point to a
*             location where the corresponding Cholesky
*             vector of a given unique symmetry pair
*             of indices has to be stored
*
*   Input:
*       Ivec1 =  first vector to be copied
*       JNum  =  # of vectors to be copied
*
*       NumV  =  total # of vectors in the target arrays
*
*       iSwap :   = 0   L(a,b,J) is returned
*                       (in LT-storage if sym(a)=sym(b))
*                 = 1   L(a,J,b) is returned
*                 = 2   L(a,J,b) is returned
*                       (in SQ-storage if sym(a)=sym(b))
*
*       iSkip(syma)=0 : skip the symmetry block a.
*                    Any vector L(ab) or L(ba) with syma x symb=JSYM
*                    won't be returned in the target array
*
*       IREDC :  reduced set in core at the moment of
*                the call to the routine.
*                Can be set to -1 by the calling routine
*
*********************************************************
      use ChoArr, only: nDimRS, iRS2F
      use ChoSwp, only: InfVec, IndRed
      Implicit Real*8 (a-h,o-z)
      Real*8  Scr(lscr)
      Integer ipChoV(*),iSkip(*)

#include "cholesky.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      Integer  cho_isao
      External cho_isao

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
************************************************************************

**********************************************************
C
C    From Reduced sets to full storage
C    ---------------------------------
C
C    iSwap = 0
C
C     L{a,b,J} ---> L(a,b,J)
C
C    iSwap = 1
C
C     L{a,b,J} ---> L(a,J,b)
C
C    iSwap = 2
C
C     L{a,b,J} ---> L(ab,J)  ! with squaring of the
C                            ! "diagonal" symmetry blocks
C
**********************************************************

      iLoc = 3 ! use scratch location in reduced index arrays


      IF (jSym.eq.1 .and. iSwap.eq.0) Then  ! L(ab),J

         NREAD = 0
         kchov = 0
         kchov2= 0
         DO JVEC=1,JNUM

            JRED = InfVec(JVEC1-1+JVEC,2,jSym)

            IF (JRED .NE. IREDC) THEN ! JRED is not the rs in core
               Call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
               IREDC = JRED
            END IF

            kscr = NREAD
            NREAD= NREAD + nDimRS(jSym,JRED)

            Do jRab=1,nnBstR(jSym,iLoc)

               kRab = iiBstr(jSym,iLoc) + jRab
               iRab = IndRed(kRab,iLoc)

               iag   = iRS2F(1,iRab)  !global address
               ibg   = iRS2F(2,iRab)

               iSyma = cho_isao(iag)  !symmetry block

               kscr  = kscr + 1

               If(iSkip(iSyma).ne.0)Then

                ias   = iag - ibas(iSyma)  !addr within that symm block
                ibs   = ibg - ibas(iSyma)

                iabf  = iTri(ias,ibs)
                kchov = (JVEC-1)*nBas(iSyma)*(nBas(iSyma)+1)/2 + iabf
     &                + ipChoV(iSyma) - 1

                Work(kchov) = Scr(kscr)

               EndIf

            End Do

         END DO


      ELSEIF (jSym.eq.1 .and. iSwap.eq.1) Then  ! LaJ,b

         NREAD = 0
         kchov = 0
         kchov2= 0
         DO JVEC=1,JNUM

            JRED = InfVec(JVEC1-1+JVEC,2,jSym)

            IF (JRED .NE. IREDC) THEN ! JRED is not the rs in core
               Call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
               IREDC = JRED
            END IF

            kscr = NREAD
            NREAD= NREAD + nDimRS(jSym,JRED)

            Do jRab=1,nnBstR(jSym,iLoc)

               kRab = iiBstr(jSym,iLoc) + jRab
               iRab = IndRed(kRab,iLoc)

               iag   = iRS2F(1,iRab)  !global address
               ibg   = iRS2F(2,iRab)

               iSyma = cho_isao(iag)  !symmetry block

               kscr  = kscr + 1

               If(iSkip(iSyma).ne.0)Then

                ias   = iag - ibas(iSyma)  !addr within that symm block
                ibs   = ibg - ibas(iSyma)

                kchov1 = nBas(iSyma)*NUMV*(ibs-1)
     &                 + nBas(iSyma)*(jVref+JVEC-2) + ias
     &                 + ipChoV(iSyma) - 1
                kchov2 = nBas(iSyma)*NUMV*(ias-1)
     &                 + nBas(iSyma)*(jVref+JVEC-2) + ibs
     &                 + ipChoV(iSyma) - 1

                Work(kchov1) = Scr(kscr)
                Work(kchov2) = Scr(kscr)

               EndIf

            End Do

         END DO


      ELSEIF (jSym.eq.1 .and. iSwap.eq.2) Then  ! L[ab],J

         NREAD = 0
         kchov = 0
         kchov2= 0
         DO JVEC=1,JNUM

            JRED = InfVec(JVEC1-1+JVEC,2,jSym)

            IF (JRED .NE. IREDC) THEN ! JRED is not the rs in core
               Call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
               IREDC = JRED
            END IF

            kscr = NREAD
            NREAD= NREAD + nDimRS(jSym,JRED)

            Do jRab=1,nnBstR(jSym,iLoc)

               kRab = iiBstr(jSym,iLoc) + jRab
               iRab = IndRed(kRab,iLoc)

               iag   = iRS2F(1,iRab)  !global address
               ibg   = iRS2F(2,iRab)

               iSyma = cho_isao(iag)  !symmetry block

               kscr  = kscr + 1

               If(iSkip(iSyma).ne.0)Then

                ias   = iag - ibas(iSyma)  !addr within that symm block
                ibs   = ibg - ibas(iSyma)

                kchov1 = nBas(iSyma)*nBas(iSyma)*(JVEC-1)
     &                 + nBas(iSyma)*(ibs-1) + ias
     &                 + ipChoV(iSyma) - 1
                kchov2 = nBas(iSyma)*nBas(iSyma)*(JVEC-1)
     &                 + nBas(iSyma)*(ias-1) + ibs
     &                 + ipChoV(iSyma) - 1

                Work(kchov1) = Scr(kscr)
                Work(kchov2) = Scr(kscr)

               EndIf

            End Do

         END DO


      ELSEIF (jSym.gt.1 .and. iSwap.eq.0) Then

         NREAD = 0
         kchov = 0
         kchov2= 0
         DO JVEC=1,JNUM

            JRED = InfVec(JVEC1-1+JVEC,2,jSym)

            IF (JRED .NE. IREDC) THEN ! JRED is not the rs in core
               Call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
               IREDC = JRED
            END IF

            kscr = NREAD
            NREAD= NREAD + nDimRS(jSym,JRED)

            Do jRab=1,nnBstR(jSym,iLoc)

               kRab = iiBstr(jSym,iLoc) + jRab
               iRab = IndRed(kRab,iLoc)

               iag   = iRS2F(1,iRab)  !global address
               ibg   = iRS2F(2,iRab)

               iSyma = cho_isao(iag)  !symmetry block
               iSymb = MulD2h(jSym,iSyma) ! sym(a) > sym(b)

               kscr  = kscr + 1

               If(iSkip(iSyma).ne.0)Then

                ias   = iag - ibas(iSyma)  !addr within that symm block
                ibs   = ibg - ibas(iSymb)

                kchov = nBas(iSyma)*nBas(iSymb)*(JVEC-1)
     &                + nBas(iSyma)*(ibs-1) + ias
     &                + ipChoV(iSyma) - 1

                Work(kchov) = Scr(kscr)

               EndIf

            End Do

         END DO


      ELSEIF (jSym.gt.1 .and. iSwap.eq.1) Then

         NREAD = 0
         kchov = 0
         kchov2= 0
         DO JVEC=1,JNUM

            JRED = InfVec(JVEC1-1+JVEC,2,jSym)

            IF (JRED .NE. IREDC) THEN ! JRED is not the rs in core
               Call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
               IREDC = JRED
            END IF

            kscr = NREAD
            NREAD= NREAD + nDimRS(jSym,JRED)

            Do jRab=1,nnBstR(jSym,iLoc)

               kRab = iiBstr(jSym,iLoc) + jRab
               iRab = IndRed(kRab,iLoc)

               iag   = iRS2F(1,iRab)  !global address
               ibg   = iRS2F(2,iRab)

               iSyma = cho_isao(iag)  !symmetry block
               iSymb = MulD2h(jSym,iSyma) ! sym(a) > sym(b)

               kscr  = kscr + 1

               If(iSkip(iSyma).ne.0)Then

                ias   = iag - ibas(iSyma)  !addr within that symm block
                ibs   = ibg - ibas(iSymb)

                kchov = nBas(iSyma)*NUMV*(ibs-1)
     &                + nBas(iSyma)*(jVref+JVEC-2) + ias
     &                + ipChoV(iSyma) - 1

                Work(kchov) = Scr(kscr)

               EndIf

            End Do

         END DO


      ELSE

       write(6,*)'Wrong parameters combination. JSYM,iSwap= ',JSYM,iSwap
       irc = 66
       Return

      ENDIF


      irc=0

      Return
      END

**************************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RPA_Setup()
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Set up RPA calculation:
C        - process input
C        - read reference orbitals
C
      Implicit None
#include "rpa_config.fh"

      Character*9 SecNam
      Parameter (SecNam='RPA_Setup')

      ! Register entry

      ! Define data in common blocks (dummy values).
      Call RPA_SetInc()

      ! Get and check integral representation from Runfile.
      Call RPA_SetIntegralRepresentation()
      Call RPA_CheckIntegralRepresentation()

      ! Pick up data from Runfile.
      Call RPA_RdRun()

      ! Process input.
      Call RPA_RdInp()

      ! Read orbitals and orbital energies.
      Call RPA_RdOrb()

      ! Postprocessing and print
      Call RPA_PPInp()

      ! Add info for testing
      Call RPA_Setup_Add_Info()

      ! Register exit

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CSDIAG(CSFDIA,DETDIA,NCNFTP,NTYP,
     &                   ICTSDT,NDTFTP,NCSFTP,IFLAG ,
     &                   NCNFCN,ICNFOK,IPRNT)
*
*.. obtain average CI diagonal elements and store in
*   CSFDIA as CSF diagonal
*
*
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CSFDIA(*),DETDIA(*)
      DIMENSION NCNFTP(NTYP),NDTFTP(NTYP),NCSFTP(NTYP)
      DIMENSION ICTSDT(*),ICNFOK(*)
*
      ICSOFF = 1
      IDTOFF = 1
      JCNABS = 0
      DO ITYP = 1, NTYP
        IDET = NDTFTP(ITYP)
        ICSF = NCSFTP(ITYP)
        ICNF = NCNFTP(ITYP)
        DO  JCNF = 1, ICNF
          JCNABS = JCNABS + 1
          EAVER = 0.0D0
          DO  JDET = 1, IDET
            EAVER = EAVER +DETDIA(ABS(ICTSDT(IDTOFF-1+JDET) ))
          End Do
          IF( IDET .NE. 0 )EAVER = EAVER/DBLE(IDET)
          CALL SETVEC(CSFDIA(ICSOFF),EAVER,ICSF)
          ICSOFF = ICSOFF + ICSF
          IDTOFF = IDTOFF + IDET
       End Do
      End Do
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(IFLAG)
        CALL Unused_integer(NCNFCN)
        CALL Unused_integer_array(ICNFOK)
        CALL Unused_integer(IPRNT)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine DeDe_SCF(Dens,TwoHam,nDens,mDens)

use Index_Functions, only: nTri_Elem
use k2_arrays, only: DeDe, Dq, Fq, ipD00, ipDeDe, ipDijS, ipOffD, MaxDe, MxDij, nDeDe, pDq, pFq
use Basis_Info, only: nBas
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDens
real(kind=wp), target, intent(inout) :: Dens(nDens)
real(kind=wp), target, intent(in) :: TwoHam(nDens)
integer(kind=iwp), intent(out) :: mDens
integer(kind=iwp) :: i, ij, mDeDe, mIndij, nDeDe_Tot, nField, nIndij, nr_of_Densities
logical(kind=iwp) :: DFT_Storage, Special_NoSym

nr_of_Densities = 1  ! Hardwired option

nIndij = nTri_Elem(S%nShlls)
nField = 2+nr_of_Densities
call mma_allocate(ipOffD,nField,nIndij,label='ipOffD')

! The array with desymmetrized densities contain two additional
! fields.
! ipD00 is a null matrix, which should simplify the logic.
! ipDijS is an auxiliary memory if not the whole set of a
!  desymmetrized density could be used.

nDeDe_tot = nDeDe+MaxDe*nIrrep+MxDij
call mma_allocate(DeDe,nDeDe_tot,Label='DeDe')
ipDeDe = 1
ipD00 = ipDeDe+nDeDe
ipDijS = ipD00+MaxDe*nIrrep
DeDe(:) = Zero

Special_NoSym = .true.
DFT_Storage = .false.
call mk_DeDe(Dens,nDens,nr_of_Densities,ipOffD,nIndij,ipDeDe,ipD00,MaxDe,mDeDe,mIndij,Special_NoSym,DFT_Storage,DeDe,nDeDe)
!                                                                      *
!***********************************************************************
!                                                                      *
! In case of no symmetry do a temporary square copy of the
! density matrix.

! Change the folded density to pure triangular form,
! i.e. off-diagonal elements are divided by two.

if (nIrrep == 1) then
  Dens(:) = Half*Dens(:)
  ij = 0
  do i=1,nBas(0)
    ij = ij+i
    Dens(ij) = Two*Dens(ij)
  end do
  mDens = nbas(0)*nbas(0)
  call mma_allocate(Dq,mDens,Label='Dq')
  call Square(Dens,Dq,1,nbas(0),nbas(0))
  pDq => Dq(:)

  call mma_allocate(Fq,mDens,Label='Fq')
  Fq(:) = Zero
  pFq => Fq(:)
else
  mDens = nDens
  pDq => Dens(:)
  pFq => Twoham(:)
end if

end subroutine DeDe_SCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c       this file contains:
c
c       DefParReord
c       DistMemReord
c       DistMemPerm
c       Ext_L2s
c       Ext_L2u
c       Ext_L1
c       Ext_L0
c       CVE2
c        MkT20p
c        MkT20u
c        InsL
c
c        integral based approach routines
c        Ext_W4
c          Ext_W4hlp1
c          Ext_W4hlp2
c          Ext_W4hlp3
c        Ext_W3
c
c        JoinLvec
c
c        DefW34y
c        DefW3y
c        DefW4y
c        DefW4y2
c
c       --------------------------------
c
        subroutine DefParReord (NaGrpR,maxdim)

c
c       This routine do:
c       define parameters in chcc_reord.fh using NaGrpR,maxdim
c
c       I/O parameter description:
c       NxGrpR   - # of groups in a (=b) set (I)
c       maxdim   - # maximal dimension of a (=b) Groups(O)
c
        implicit none
#include "chcc1.fh"
#include "chcc_reord.fh"
#include "chcc_files.fh"
c
        integer NaGrpR,maxdim
c
c       help variables
c
        real*8 rdim
        integer i,j
        integer Up(1:MaxGrp),Low(1:MaxGrp)
c
c
c1      define parameters of Groups of a set
c
        rdim=1.0d0*nv/(1.0d0*NaGrpR)
c
        do i=1,NaGrpR
c
           if (i.eq.1) then
             Up(i)=int(rdim*i)
             Low(i)=1
           else if (i.eq.NaGrpR) then
             Up(i)=nv
             Low(i)=Up(i-1)+1
           else
             Up(i)=int(rdim*i)
             Low(i)=Up(i-1)+1
           end if
c
           DimGrpaR(i)=(Up(i)-Low(i))+1
c
        end do
c
c
c2      find maximal dimensions of a'
c
        maxdim=DimGrpaR(1)
        do i=1,NaGrpR
          if (DimGrpaR(i).gt.maxdim) then
          maxdim=DimGrpaR(i)
          end if
        end do
c
c
c3.1    def L2Name, T2Name, I2Name,I3Name
c
        do i=1,MaxGrp
        do j=1,MaxGrp
          call DefParo3v3Hlp1(i,j,'L2',L2Name(i,j))
          call DefParo3v3Hlp1(i,j,'T2',T2Name(i,j))
          call DefParo3v3Hlp1(i,j,'I2',I2Name(i,j))
          call DefParo3v3Hlp1(i,j,'I3',I3Name(i,j))
        end do
        end do
c
c3.2    def L1Name,I1Name
c
        do i=1,MaxGrp
          call DefParo3v3Hlp2 (i,'L1vc',L1Name(i))
          call DefParo3v3Hlp2 (i,'I1in',I1Name(i))
        end do
c
c3.3    def L0Name,I0Name
c
        L0Name='L0vctr'
        I0Name='I0intg'
c
        return
        end
c
c       ------------------------------------
c
        subroutine DistMemReord (NaGrpR,maxdim,maxdimSG,NchBlk,
     c        PossV1,PossV2,PossV3,PossV4,PossM1,PossM2,
     c        PossT)

c
c       This routine do:
c       define initial possitions of OE,V1-V4,M1,2 arrays
c       described in Reord routine
c
c       Memory requirements:
c        intkey=0
c       V1   - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm;  oom}
c       V2   - max {ov'ov'; v'v'm, ov'm; oom}
c       V3   - max {ov'm; oom}
c       V4   - oom
c        intkey=0
c       V1   - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm; oom; V"V"V"V"}
c       V2   - max {ov'ov'; v'v'm, ov'm; oom}
c       V3   - max {ov'm; oom; V'V'M}
c       V4   - oom
c        M1   - V"V"m
c        M2   - max {V"V"M; OV"M)
c
c       I/O parameter description:
c       NxGrp    - # of groups in a,b,be,ga set (I)
c       maxdim   - maximal dimension of V' (I)
c       NChBlk   - # of Cholesky vectors in one Block - m' (I)
c       Possx    - initial possitinos of arrays (O-all)
c       PossT    - initial and last possition (I/O)
c
        implicit none
#include "chcc1.fh"
c
        integer NaGrpR,maxdim,maxdimSG,NchBlk
        integer PossV1,PossV2,PossV3,PossV4,PossM1,PossM2
        integer PossT
c
c       help variables
        integer length,nbas
c
c
c2      V1 file
c       V1   - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm;  oom, V"V"V"V"}
c
        nbas=no+nv
c
        length=maxdim*maxdim*no*no
        if ((nbas*nbas*NChBlk).gt.length) then
          length=nbas*nbas*NChBlk
        end if
        if ((no*maxdim*nc).gt.length) then
          length=no*maxdim*nc
        end if
        if ((maxdim*maxdim*nc).gt.length) then
          length=maxdim*maxdim*nc
        end if
        if ((no*no*nc).gt.length) then
          length=no*no*nc
        end if
        if ((intkey.eq.1).and.(length.le.maxdimSG**4)) then
          length=maxdimSG**4
        end if
c
        PossV1=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V1 ',PossV1,length
        end if
c
c3      V2 file
c       V2   - max {ov'ov'; v'v'm ; ov'm; oom}
c
        length=maxdim*maxdim*no*no
        if ((maxdim*maxdim*nc).gt.length) then
          length=maxdim*maxdim*nc
        end if
        if ((no*maxdim*nc).gt.length) then
          length=no*maxdim*nc
        end if
        if ((no*no*nc).gt.length) then
          length=no*no*nc
        end if
c
        PossV2=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V2 ',PossV2,length
        end if
c
c
c4      V3 file
c       V3   - max {ov'm; oom, V'V'M}
c
        length=no*maxdim*nc
        if ((no*no*nc).gt.length) then
          length=no*no*nc
        end if
        if ((intkey.eq.1).and.(length.le.maxdim*maxdim*nc)) then
          length=maxdim*maxdim*nc
        end if
c
        PossV3=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V3 ',PossV3,length
        end if
c
c5      V4 file
c       V4   - oom
c
        length=no*no*nc
c
        PossV4=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V4 ',PossV4,length
        end if
c
c6        M1   - V"V"m
c
        length=maxdimSG*maxdimSG*nc
        if (intkey.eq.0) then
          length=0
        end if
        PossM1=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM M1 ',PossM1,length
        end if
c
c7        M2   - max {V"V"M; OV"M)
c
        length=maxdimSG*maxdimSG*nc
        if (length.lt.no*nc*maxdimSG) then
          length=no*nc*maxdimSG
        end if
        if (intkey.eq.0) then
          length=0
        end if
        PossM2=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM M2 ',PossM2,length
        end if
c
        return
c Avoid unused argument warnings
        if (.false.) Call Unused_integer(NaGrpR)
        end
c
c
c       ------------------------------------
c
        subroutine DistMemPerm (PossT)
c
c       This routine do:
c       define initial possitions of Permanent
c
c       PossT    - initial and last possition (I/O)
c
        implicit none
#include "chcc1.fh"
c
        integer PossT
c
c       help variables
        integer length,nbas(1)
c
c
c1.1    Foo file
        length=no*no
        PossFoo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Foo ',PossFoo,length
        end if
c
c1.2    Fvo file
        length=no*nv
        PossFvo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Fvo ',PossFvo,length
        end if
c
c1.3    Fvv file
        length=nv*nv
        PossFvv=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Fvv ',PossFvv,length
        end if
c
c
c2      OE file
c
        call Get_iArray('nBas',nBas,1)
        length=nbas(1)
c
        PossOE=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM OE ',PossOE,length
        end if
c
c
c3.1    T1o file
        length=no*nv
        PossT1o=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM T1o ',PossT1o,length
        end if
c
c3.2    T1n file
        length=no*nv
        PossT1n=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM T1n ',PossT1n,length
        end if
c
c
c4.1    Hoo file
        length=no*no
        PossHoo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Hoo ',PossHoo,length
        end if
c
c4.2    Hvo file
        length=no*nv
        PossHvo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Hvo ',PossHvo,length
        end if
c
c4.3    Hvv file
        length=nv*nv
        PossHvv=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Hvv ',PossHvv,length
        end if
c
c
c5.1    Goo file
        length=no*no
        PossGoo=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Goo ',PossGoo,length
        end if
c
c5.2    Hvv file
        length=nv*nv
        PossGvv=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Gvv ',PossGvv,length
        end if
c
c6.1    A files @@ A file medzi fixnymi je na zamyslenie (lebo je o4)
        length=no*no*no*(no+1)/2
        PossA=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM A   ',PossA,length
        end if
        if (intkey.eq.0) then
          PossAex=PossT
          PossT=PossT+length
          if (printkey.ge.10) then
          write (6,*) 'DM Aex ',PossAex,length
          end if
        else
          PossAex=PossT
        end if
c
c
comega  PossFree - Possition of the space, where work arrays started
        PossFree=PossT
c
        return
        end
c
c
c       ---------------------
c
        subroutine Ext_L2s (V1,V2,
     c                      dima,dimab,dimc,adda,addb,nbs)
c
c       this routine do:
c       V2(a'b',m') <- V1(p,q,m') for aGrp=bGrp
c
        implicit none
        integer dima,dimab,dimc,adda,addb,nbs
        real*8 V1(1:nbs,1:nbs,1:dimc)
        real*8 V2(1:dimab,1:dimc)
c
c       help variables
        integer a,b,ab,m
c
        do m=1,dimc
        ab=0
        do a=1,dima
        do b=1,a
        ab=ab+1
        V2(ab,m)=V1(adda+a,addb+b,m)
        end do
        end do
        end do
c
        return
        end
c
c       ---------------------
c
        subroutine Ext_L2u (V1,V2,
     c                      dima,dimb,dimc,adda,addb,nbs)
c
c       this routine do:
c       V2(a',b',m') <- V1(p,q,m') for aGrp>bGrp
c
        implicit none
        integer dima,dimb,dimc,adda,addb,nbs
        real*8 V1(1:nbs,1:nbs,1:dimc)
        real*8 V2(1:dima,1:dimb,1:dimc)
c
c       help variables
        integer a,b,m
c
        do m=1,dimc
        do b=1,dimb
        do a=1,dima
        V2(a,b,m)=V1(adda+a,addb+b,m)
        end do
        end do
        end do
c
        return
        end
c
c       ---------------------
c
        subroutine  Ext_L1 (V1,V2,
     c                      no,dima,dimc,adda,nbs)
c
c       this routine do:
c       V2(i,a',m') <- V1(p,q,m')
c
        implicit none
        integer no,dima,dimc,adda,nbs
        real*8 V1(1:nbs,1:nbs,1:dimc)
        real*8 V2(1:no,1:dima,1:dimc)
c
c       help variables
        integer i,a,m
c
        do m=1,dimc
        do a=1,dima
        do i=1,no
        V2(i,a,m)=V1(i,adda+a,m)
        end do
        end do
        end do
c
        return
        end
c
c       ---------------------
c
        subroutine  Ext_L0 (V1,V2,
     c                      no,dimij,dimc,nbs)
c
c       this routine do:
c       V2(i,j,m') <- V1(p,q,m')
c
        implicit none
        integer no,dimij,dimc,nbs
        real*8 V1(1:nbs,1:nbs,1:dimc)
        real*8 V2(1:dimij,1:dimc)
c
c       help variables
        integer i,j,ij,m
c
        do m=1,dimc
        ij=0
        do i=1,no
        do j=1,i
        ij=ij+1
        V2(ij,m)=V1(i,j,m)
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine CVE2 (V,oe,dima,dimb,adda,addb,no,e2,e2os)
c
c       this routine do:
c       e2  =e2   + sum(a',b',i,j)[(a'i|b'j).{2(a'i|b'j)-(a'j|b'i)}]/Dija'b'
c       e2os=e2os + sum(a',b',i,j)[(a'i|b'j).{ (a'i|b'j)          }]/Dija'b'
c       N.B. Cierny Vypocet E2
c       N.B.2 qvajt odflaknute
c
        implicit none
        integer dima,dimb,adda,addb,no
        real*8 V(1:dima,1:no,1:dimb,1:no)
        real*8 oe(*)
        real*8 e2,e2os
c
c       help variables
        integer i,j,a,b
        real*8 dijab
c
c
        do j=1,no
          do b=1,dimb
            do i=1,no
              do a=1,dima
                dijab=oe(i)+oe(j)-oe(adda+a)-oe(addb+b)
                e2  =e2   +
     &     V(a,i,b,j)*(2.0d0*V(a,i,b,j)-V(a,j,b,i))/dijab
                e2os=e2os +
     &     V(a,i,b,j)*(      V(a,i,b,j)           )/dijab
              end do
            end do
          end do
        end do
c
c
        return
        end
c
c       --------------------------------
c
        subroutine MkT20p (T2,V,oe,dima,adda,no)
c
c       this routine do:
c       T2(a'b',i,j)=(a'i|b'j)/Dija'b'
c        for aGrp.eq.bGrp
c       N.B.2 qvajt odflaknute, neurobene
c
        implicit none
        integer dima,adda,no
        real*8 V(1:dima,1:no,1:dima,1:no)
        real*8 T2(1:dima*(dima+1)/2,1:no,1:no)
        real*8 oe(*)
c
c       help variables
        integer i,j,a,b,ab
        real*8 dijab
c
c
        do j=1,no
          do i=1,no
            ab=0
            do a=1,dima
            do b=1,a
              ab=ab+1
              dijab=oe(i)+oe(j)-oe(adda+a)-oe(adda+b)
              T2(ab,i,j)=V(a,i,b,j)/dijab
            end do
            end do
          end do
        end do
c
c
        return
        end
c
c       --------------------------------
c
        subroutine MkT20u (T2,V,oe,dima,dimb,adda,addb,no)
c
c       this routine do:
c       T2(a',b',i,j)=(a'i|b'j)/Dija'b'
c        for aGrp.ne.bGrp
c       N.B.2 qvajt odflaknute
c
        implicit none
        integer dima,dimb,adda,addb,no
        real*8 T2(1:dima,1:dimb,1:no,1:no)
        real*8 V(1:dima,1:no,1:dimb,1:no)
        real*8 oe(*)
c
c       help variables
        integer i,j,a,b
        real*8 dijab
c
c
        do j=1,no
          do i=1,no
            do b=1,dimb
              do a=1,dima
                dijab=oe(i)+oe(j)-oe(adda+a)-oe(addb+b)
                T2(a,b,i,j)=V(a,i,b,j)/dijab
              end do
            end do
          end do
        end do
c
c
        return
        end
c
c       --------------------------------
c
        subroutine InsL (Ll,Lg,ncLoc,nc,ncOff,dim1)
c
c        this routine do:
c        insert Llocal(ml,dim1) into Lglobal(m,dim1)
c        on a corresponding place
c
        implicit none
        integer ncLoc,nc,ncOff,dim1
        real*8 Ll(1:ncLoc,1:dim1)
        real*8 Lg(1:nc,1:dim1)
c
c        help variables
        integer m,p
c
        do p=1,dim1
          do m=1,ncLoc
            Lg(ncOff+m,p)=Ll(m,p)
          end do
        end do
c
        return
        end
c
c       --------------------------------
c       --------------------------------
c
        subroutine Ext_W4 (V2,M1,
     c                     nc,dima,dimb,dimab,dimapp,dimbpp,dimabpp,
     c                     addapp,addbpp,aGrp,bGrp,aSGrp,bSGrp)
c
c        this routine is a control routine to:
c        Extract M1(m,a"b") <- V2(m,a'b')
c        for all combinations of aGrp,bGrp,aSGrp,bSGrp
c
        implicit none
        integer nc,dima,dimb,dimab,dimapp,dimbpp,dimabpp
        integer addapp,addbpp,aGrp,bGrp,aSGrp,bSGrp
        real*8 M1(1)
        real*8 V2(1)
c
        if (aGrp.eq.bGrp) then
c          case V2(m,a'b')
          if (aSGrp.eq.bSGrp) then
c            subcase M1(m,a"b") <- V2(m,a'b')
            call Ext_W4hlp1 (V2,M1,nc,dima,dimab,dimapp,dimabpp,addapp)
          else
c            subcase M1(m,a",b") <- V2(m,a'b')
            call Ext_W4hlp2 (V2,M1,
     c                       nc,dima,dimab,dimapp,dimbpp,addapp,addbpp)
          end if
        else
c          case M1(m,a",b") <- V2(m,a',b')
          call Ext_W4hlp3 (V2,M1,
     c                     nc,dima,dimb,dimapp,dimbpp,addapp,addbpp)
        end if
c
        return
        end
c
c       --------------------------------
c
        subroutine Ext_W4hlp1 (V2,M1,
     c                         nc,dima,dimab,dimapp,dimabpp,addapp)
c
c        this routine do:
c        Extract M1(m,a"b") <- V2(m,a'b')
c
        implicit none
        integer nc,dima,dimab,dimapp,dimabpp,addapp
        real*8 V2(1:nc,1:dimab)
        real*8 M1(1:nc,1:dimabpp)
c
c        help variables
c
        integer a,ab,app,bpp,abpp,m
c
        abpp=0
        do app=1,dimapp
        a=addapp+app
        ab=a*(a-1)/2+addapp
        do bpp=1,app
        ab=ab+1
        abpp=abpp+1
c
          do m=1,nc
          M1(m,abpp)=V2(m,ab)
          end do
c
        end do
        end do
c
        return
c Avoid unused argument warnings
        if (.false.) Call Unused_integer(dima)
        end
c
c       --------------------------------
c
        subroutine Ext_W4hlp2 (V2,M1,
     c                       nc,dima,dimab,dimapp,dimbpp,addapp,addbpp)
c
c        this routine do:
c        Extract M1(m,a",b") <- V2(m,a'b')
c
        implicit none
        integer nc,dima,dimab,dimapp,dimbpp,addapp,addbpp
        real*8 V2(1:nc,1:dimab)
        real*8 M1(1:nc,1:dimapp,1:dimbpp)
c
c        help variables
c
        integer a,ab,app,bpp,m
c
        do app=1,dimapp
        a=addapp+app
        ab=a*(a-1)/2+addbpp
        do bpp=1,dimbpp
        ab=ab+1
c
          do m=1,nc
          M1(m,app,bpp)=V2(m,ab)
          end do
c
        end do
        end do
c
        return
c Avoid unused argument warnings
        if (.false.) Call Unused_integer(dima)
        end
c
c       --------------------------------
c
        subroutine Ext_W4hlp3 (V2,M1,
     c                     nc,dima,dimb,dimapp,dimbpp,addapp,addbpp)
c
c        this routine do:
c        Extract M1(m,a",b") <- V2(m,a',b')
c
        implicit none
        integer nc,dima,dimb,dimapp,dimbpp,addapp,addbpp
        real*8 V2(1:nc,1:dima,1:dimb)
        real*8 M1(1:nc,1:dimapp,1:dimbpp)
c
c        help variables
c
        integer a,b,app,bpp,m
c
        do app=1,dimapp
        a=addapp+app
        do bpp=1,dimbpp
        b=addbpp+bpp
c
          do m=1,nc
          M1(m,app,bpp)=V2(m,a,b)
          end do
c
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Ext_W3 (V3,M2,nc,no,dimc,dimcpp,addcpp)
c
c        this routine do:
c         Extract M2(m,c",i) <- V3(m,c',i)
c
        implicit none
        integer nc,no,dimc,dimcpp,addcpp
        real*8 V3(1:nc,1:dimc,1:no)
        real*8 M2(1:nc,1:dimcpp,1:no)
c
c        help varibles
        integer m,i,c,cpp
c
        do i=1,no
          c=addcpp
          do cpp=1,dimcpp
          c=c+1
            do m=1,nc
              M2(m,cpp,i)=V3(m,c,i)
            end do
          end do
        end do
c
        return
        end
c
c        ---------------------------
c
        subroutine JoinLvec (wrk,wrksize,
     c             PossV1,PossV2,NaGrpR,LunAux)
c
c       This routine do:
c        Join L0-L2 files (Global, dimensioned as nc)
c        from local L0-L2 files (dimensioned as ncLoc)
c        N.B. This file have sense only for paralell run
c
c
c       Structure of Cholesky vector files
c
c       L0(m,IJ)    L0vctr  I>=J
c
c       L1(m,I ,A') L1vcxx xx - Group of A'
c@@        kokot som, ze som to takto urobil, prerobit na L(m,a,i) to treba
c
c       L2(m,A'B')  L2xxyy xx - Group of A', A'>=B'
c                          yy - Group of B'
c
c       Memory requirements:
c        real:
c       V1   - max {ov'm; v'v'm;  oom}
c       V2   - max {v'v'm, ov'm; oom}
c        actual:
c       reord routine requirements are used (DistMemReord)
c
        implicit none
        integer PossV1,PossV2,NaGrpR,LunAux
#include "chcc1.fh"
#include "chcc_reord.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
#include "wrk.fh"
#ifdef _MOLCAS_MPP_
#include "para_info.fh"
#include "chcc_parcc.fh"
c
c       help variables
        character*6 LunName
        integer aGrp,bGrp
        integer dim1,dima,dimb,dimab
        integer i,ncLoc,ncOff
c
c
c7.0        calculate ncOffset for given node
        ncLoc=NChLoc(myRank)
        ncOff=0
        if (myRank.gt.0) then
          do i=0,myRank-1
          ncOff=ncOff+NChLoc(i)
          end do
        end if
c
c
c
c7.1        Make global L0
        LunName=L0Name
c
c7.1.1  Read Local L0 = V2(ml,ij) on proper place in V2
        dim1=ncLoc*no*(no+1)/2
        call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
c7.1.2        Vanish V1(m,ij)
        dim1=nc*no*(no+1)/2
        call mv0zero (dim1,dim1,wrk(PossV1))
c
c7.1.3        Insert V2(ml,ij) -> V1(m,ij)
        dim1=no*(no+1)/2
        call InsL (wrk(PossV2),wrk(PossV1),ncLoc,nc,ncOff,dim1)
c
c##        Synchronizacny bod
c7.1.4        Allreduce V1
        dim1=nc*no*(no+1)/2
        call gadgop (wrk(PossV1),dim1,'+')
c
c7.1.5        Save L0 (Global)
        dim1=nc*no*(no+1)/2
        call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c
c
c7.2    make global L1 files
c
        do aGrp=1,NaGrpR
        dima=DimGrpaR(aGrp)
        LunName=L1Name(aGrp)
c
c7.2.1  read L1 = V2(ml,i,a') back into file
        dim1=no*dima*ncLoc
        call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
c7.2.2        Vanish V1(m,i,a')
        dim1=nc*no*dima
        call mv0zero (dim1,dim1,wrk(PossV1))
c
c7.2.3        Insert V2(ml,i,a') -> V1(m,i,a')
        dim1=no*dima
        call InsL (wrk(PossV2),wrk(PossV1),ncLoc,nc,ncOff,dim1)
c
c##        Synchronizacny bod
c7.2.4        Allreduce V1
        dim1=nc*no*dima
        call gadgop (wrk(PossV1),dim1,'+')
c
c7.2.5        Save V1(m,i,a') (Global)
        dim1=nc*no*dima
        call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
        end do
c
c
c
c2.3    Make glogal L2(m,a'b') files
c
        do aGrp=1,NaGrpR
        dima=DimGrpaR(aGrp)
        do bGrp=1,aGrp
        dimb=DimGrpaR(bGrp)
        if(aGrp.eq.bGrp) then
          dimab=dima*(dima+1)/2
        else
          dimab=dima*dimb
        end if
        LunName=L2Name(aGrp,bGrp)
c
c
c7.3.1  read L2 = V2(ml,a'b') back into file
        dim1=dimab*ncLoc
        call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
c7.3.2        Vanish V1(m,a'b')
        dim1=nc*dimab
        call mv0zero (dim1,dim1,wrk(PossV1))
c
c7.3.3        Insert V2(ml,a',b') -> V1(m,a',b')
        dim1=dimab
        call InsL (wrk(PossV2),wrk(PossV1),ncLoc,nc,ncOff,dim1)
c
c##        Synchronizacny bod
c7.3.4        Allreduce V1
        dim1=nc*dimab
        call gadgop (wrk(PossV1),dim1,'+')
c
c7.3.5        Save V1(ml,a',b') (Global)
        dim1=nc*dimab
        call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
        end do
        end do
c
#else
c Avoid unused argument warnings
        if (.false.) then
          call Unused_real_array(wrk)
          call Unused_integer(PossV1)
          call Unused_integer(PossV2)
          call Unused_integer(NaGrpR)
          call Unused_integer(LunAux)
        end if
#endif
c
        return
        end
c
c        ---------------------------
c
        subroutine  DefW34y (aGrp,bGrp,w3y,w4y,NaGrp)
c
c        this routine do:
c        define w3y and w4y keys, which indicates, if atleast one
c        W3/W4 file need to be calculated on this node for given a',b'
c
        implicit none
        integer aGrp,bGrp,w3y,w4y,NaGrp
#include "chcc1.fh"
#include "o2v4.fh"
#ifdef _MOLCAS_MPP_
#include "chcc_parcc.fh"
c
c        help variables
        integer aSGrp,bSGrp,abSGrp,bSGrpUp,cSGrp,cdSGrp
        integer NSGrp
c
        w3y=0
        w4y=0
c
c       cycle over a">=b" subgroups for a',b'
        do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
        if (aGrp.eq.bGrp) then
          bSGrpUp=aSGrp
        else
          bSGrpUp=GrpaUp(bGrp)
        end if
        do bSGrp=GrpaLow(bGrp),bSGrpUp
        abSGrp=aSGrp*(aSGrp-1)/2+bSGrp
c
c          cycle over all c"
          NSGrp=GrpaUp(NaGrp)
          do cSGrp=1,NSGrp
          if (InqW3(abSGrp,cSGrp)) then
            w3y=w3y+1
          end if
          end do
c
c          cycle over all c">=d"
          do cdSGrp=1,NSGrp*(NSGrp+1)/2
          if (InqW4(abSGrp,cdSGrp)) then
            w4y=w4y+1
          end if
          end do
c
c       end cycle over a">=b" subgroups
        end do
        end do
c
#else
        w3y=1
        w4y=1
c Avoid unused argument warnings
        if (.false.) then
          call Unused_integer(aGrp)
          call Unused_integer(bGrp)
          call Unused_integer(NaGrp)
        end if
#endif
c
        return
        end
c
c        ---------------------------
c
        subroutine  DefW3y (aGrp,bGrp,cGrp,w3y)
c
c        this routine do:
c        define w3y key, which indicates, if atleast one
c        W3 file need to be calculated on this node for given
c        a',b',c'
c
        implicit none
        integer aGrp,bGrp,cGrp,w3y
#include "chcc1.fh"
#include "o2v4.fh"
#ifdef _MOLCAS_MPP_
#include "chcc_parcc.fh"
c
c        help variables
        integer aSGrp,bSGrp,abSGrp,bSGrpUp,cSGrp
c
        w3y=0
c
c       cycle over a">=b" subgroups for a',b'
        do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
        if (aGrp.eq.bGrp) then
          bSGrpUp=aSGrp
        else
          bSGrpUp=GrpaUp(bGrp)
        end if
        do bSGrp=GrpaLow(bGrp),bSGrpUp
        abSGrp=aSGrp*(aSGrp-1)/2+bSGrp
c
c          cycle over c" for c'
          do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
          if (InqW3(abSGrp,cSGrp)) then
            w3y=w3y+1
          end if
          end do
c
c       end cycle over a">=b" subgroups
        end do
        end do
c
#else
        w3y=1
c Avoid unused argument warnings
        if (.false.) then
          call Unused_integer(aGrp)
          call Unused_integer(bGrp)
          call Unused_integer(cGrp)
        end if
#endif
c
        return
        end
c
c        ---------------------------
c
        subroutine  DefW4y (aGrp,bGrp,cGrp,dGrp,w4y)
c
c        this routine do:
c        define w4y key, which indicates, if atleast one
c        W4 file need to be calculated on this node for
c        given a',b',c',d'
c
        implicit none
        integer aGrp,bGrp,cGrp,dGrp,w4y
#include "chcc1.fh"
#include "o2v4.fh"
#ifdef _MOLCAS_MPP_
#include "chcc_parcc.fh"
c
c        help variables
        integer aSGrp,bSGrp,abSGrp,bSGrpUp,cSGrp,cdSGrp,dSGrp,dSGrpUp
c
        w4y=0
c
c       cycle over a">=b" subgroups for a',b'
        do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
        if (aGrp.eq.bGrp) then
          bSGrpUp=aSGrp
        else
          bSGrpUp=GrpaUp(bGrp)
        end if
        do bSGrp=GrpaLow(bGrp),bSGrpUp
        abSGrp=aSGrp*(aSGrp-1)/2+bSGrp
c
c          cycle over  c">=d" for c',d'
          do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
          if (cGrp.eq.dGrp) then
            dSGrpUp=cSGrp
          else
            dSGrpUp=GrpaUp(dGrp)
          end if
          do dSGrp=GrpaLow(dGrp),dSGrpUp
          cdSGrp=cSGrp*(cSGrp-1)/2+dSGrp
            if (InqW4(abSGrp,cdSGrp)) then
              w4y=w4y+1
            end if
          end do
          end do
c
c       end cycle over a">=b" subgroups
        end do
        end do
c
#else
        w4y=1
c Avoid unused argument warnings
        if (.false.) then
          call Unused_integer(aGrp)
          call Unused_integer(bGrp)
          call Unused_integer(cGrp)
          call Unused_integer(dGrp)
        end if
#endif
c
        return
        end
c
c        ---------------------------
c
        subroutine  DefW4y2 (aSGrp,bSGrp,cGrp,dGrp,w4y)
c
c        this routine do:
c        define w4y key, which indicates, if atleast one
c        W4 file need to be calculated on this node for
c        given a",b",c',d'
c
        implicit none
        integer aSGrp,bSGrp,cGrp,dGrp,w4y
#include "chcc1.fh"
#include "o2v4.fh"
#ifdef _MOLCAS_MPP_
#include "chcc_parcc.fh"
c
c        help variables
        integer abSGrp,cSGrp,cdSGrp,dSGrp,dSGrpUp
c
        w4y=0
c
c       def abSGrp
        abSGrp=aSGrp*(aSGrp-1)/2+bSGrp
c
c          cycle over  c">=d" for c',d'
          do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
          if (cGrp.eq.dGrp) then
            dSGrpUp=cSGrp
          else
            dSGrpUp=GrpaUp(dGrp)
          end if
          do dSGrp=GrpaLow(dGrp),dSGrpUp
          cdSGrp=cSGrp*(cSGrp-1)/2+dSGrp
            if (InqW4(abSGrp,cdSGrp)) then
              w4y=w4y+1
            end if
          end do
          end do
c
c
#else
        w4y=1
c Avoid unused argument warnings
        if (.false.) then
          call Unused_integer(aSGrp)
          call Unused_integer(bSGrp)
          call Unused_integer(cGrp)
          call Unused_integer(dGrp)
        end if
#endif
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,1994, Per Ake Malmqvist                           *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE PCLOSE
      IMPLICIT REAL*8 (A-H,O-Z)
C
C  PER-AAKE MALMQUIST 92-12-07
C  Deallocates everything concerned with SGUGA, incl CI array.


#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "pt2_guga.fh"

      IF(DoCumulant) RETURN
      IF(NACTEL.EQ.0) RETURN
      IF(ISCF.NE.0) RETURN
      CALL GETMEM('MVL','FREE','INTEG',LMVL,NMVL)
      CALL GETMEM('MVR','FREE','INTEG',LMVR,NMVR)
      CALL GETMEM('NOW','FREE','INTEG',LNOW,NNOW)
      CALL GETMEM('IOW','FREE','INTEG',LIOW,NIOW)
      CALL GETMEM('NOCP','FREE','INTEG',LNOCP,NNOCP)
      CALL GETMEM('IOCP','FREE','INTEG',LIOCP,NIOCP)
      CALL GETMEM('NOCSF','FREE','INTEG',LNOCSF,NNOCSF)
      CALL GETMEM('IOCSF','FREE','INTEG',LIOCSF,NIOCSF)
      CALL GETMEM('ICASE','FREE','INTEG',LICASE,NICASE)
      CALL GETMEM('ICOUP','FREE','INTEG',LICOUP,(3*NICOUP+1)/2)
      CALL GETMEM('VTAB','FREE','REAL',LVTAB,NVTAB)
      CALL GETMEM('SGTMP','FREE','REAL',LSGTMP,NSGTMP)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Roland Lindh                                     *
!               2014, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine QNR(nInter,nIter,dq,H,g)
!***********************************************************************
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             December '94                                             *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Ten
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nInter, nIter
real(kind=wp), intent(inout) :: dq(nInter,nIter)
real(kind=wp), intent(in) :: H(nInter,nInter), g(nInter,nIter+1)
integer(kind=iwp) :: Info, k, maxk, recomp
real(kind=wp) :: alpha, beta, rr, RelThr
real(kind=wp), allocatable :: Ap(:), Lo(:,:), p(:), r(:), y(:), z(:)
real(kind=wp), parameter :: Thr = 1.0e-20_wp
real(kind=wp), external :: ddot_

! Compute a new independent geometry by relaxation of
! the gradient vector.

call mma_allocate(r,nInter)
call mma_allocate(p,nInter)
call mma_allocate(Ap,nInter)
call mma_allocate(z,nInter)
call mma_allocate(y,nInter)

dq(:,nIter) = Zero

maxk = max(10,nInter**2)
recomp = max(50,int(nInter/Ten))
r(:) = g(:,nIter)

call mma_allocate(Lo,nInter,nInter,label='Lo')

! With a dense matrix, the preconditioner could be replaced with
! something else, otherwise this is just solving the system with
! a direct method
Lo(:,:) = H(:,:)
call dpotrf_('L',nInter,Lo,nInter,info)

call DSyMV('L',nInter,-One,H,nInter,dq(:,nIter),1,One,r,1)
z(:) = r(:)
call DPoTrS('L',nInter,1,Lo,nInter,z,nInter,info)
p(:) = z(:)
rr = DDot_(nInter,z,1,r,1)
RelThr = Thr*max(rr,One)
k = 1
do while ((abs(rr) >= RelThr) .and. (k <= maxk))
  call dGeMV_('nInter',nInter,nInter,One,H,nInter,p,1,Zero,Ap,1)
  alpha = rr/DDot_(nInter,p,1,Ap,1)
  dq(:,nIter) = dq(:,nIter)+alpha*p(:)
  beta = rr
  if (mod(k,recomp) == 0) then
    r(:) = g(:,nIter)
    call dGeMV_('N',nInter,nInter,-One,H,nInter,dq(:,nIter),1,One,r,1)
  else
    r(:) = r(:)-alpha*Ap(:)
  end if
  z(:) = r(:)
  call DPoTrS('L',nInter,1,Lo,nInter,z,nInter,info)
  rr = DDot_(nInter,z,1,r,1)
  p(:) = p(:)*rr/beta+z(:)
  k = k+1
end do
call mma_deallocate(Lo)

! Set the return value
if (k <= maxk) then
  info = k
else
  info = -1
end if

call mma_deallocate(r)
call mma_deallocate(p)
call mma_deallocate(Ap)
call mma_deallocate(z)
call mma_deallocate(y)

if (Info < 0) call SysAbendMsg('QNR','Conjugate gradients not converged',' ')

#ifdef _DEBUGPRINT_
write(u6,*) 'CG converged in ',Info,' iterations'
call RecPrt(' H ',' ',H,nInter,nInter)
call RecPrt(' dq',' ',dq(1,nIter),1,nInter)
#endif

return

end subroutine QNR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AverMEP(Kword,Eint,Poli,iCi,SumElcPot,NCountField,PertElcInt,iQ_Atoms,nBas,nOcc,natyp,nntyp)

use qmstat_global, only: AvElcPot, ChaNuc, FieldNuc, iPrint, MxMltp, nMlt, outxyz, PertNElcInt
use Index_Functions, only: iTri, nTri3_Elem, nTri_Elem
use Data_Structures, only: Alloc1DArray_Type, Allocate_DT, Deallocate_DT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Three, OneHalf
use Definitions, only: wp, iwp, u6

implicit none
character(len=4), intent(inout) :: Kword
integer(kind=iwp), intent(in) :: iCi, NCountField, iQ_Atoms, nBas, nntyp, nOcc(nntyp), natyp(nntyp)
real(kind=wp), intent(in) :: Eint(iCi,10), Poli(iCi,10)
real(kind=wp), intent(inout) :: SumElcPot(iCi,10)
real(kind=wp), intent(out) :: PertElcInt(nTri_Elem(nBas))
integer(kind=iwp) :: i, i1, i2, iB1, iB2, iiDum(1), iLuField, indMME, iOpt, irc, iSmLbl, iTyp, j, kaunta, Lu_One, nSize, nTyp
real(kind=wp) :: Tra
logical(kind=iwp) :: Exists
integer(kind=iwp), allocatable :: Dum(:,:), iCent(:)
real(kind=wp), allocatable :: AvTemp(:), ForceNuc(:,:), H0(:), H1(:)
type(Alloc1DArray_Type), allocatable :: MME(:)
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

call UpCase(Kword)
!**************
! This subroutine includes three different options. All have to do with the
! calculation of a Mean Electrostatic Potential, Field and Field gradients,
! and to evalute the perturbation of them in the One electron Hamiltoniam
! this perturbation is added to the SEWARD One Electron File.
! Option 1: Add the components of Potential, etc
! Option 2: Obtain the Average
! Option 3: Calculate the electrostatic perturbation energy integrals
!           and add them to the one-electron file.
! Calculations involve up to the field gradients because the charge density
! is expanded to the quadrupoles. If the expansion is bigger the number 10
! must be changed, but also all the eqscf and eqras subroutines shoud be
! changed. In the last option the array nMlt is used instead of the
! number so if a smaller expantion is used, non problem,
! since this index takes care of that.
!*****************

select case (Kword(1:4))

  case default !('ADD ')
    do i=1,iCi
      do j=1,10 !Charges(1),Dipoles(3),Quadrupoles(6)
        SumElcPot(i,j) = SumElcPot(i,j)+Eint(i,j)+Poli(i,j)
      end do
    end do
    if (iPrint >= 9) then
      write(u6,*) 'Total Sum Potential'
      do i=1,iCi
        write(u6,*) SumElcPot(i,:)
      end do
    end if

  case ('AVER')
    AvElcPot(:,:) = SumElcPot/real(NCountField,kind=wp)

    ! Charges (1),Dipoles(3),Quadrupoles(6)

    ! The order of Field gradients is changed in order to follow the same order than Molcas
    ! This change is due to the different order of quadrupoles in QmStat and Molcas.
    ! QmStat:xx,xy,yy,xz,yz,zz Molcas:xx,xy,xz,yy,yz,zz
    call mma_allocate(AvTemp,iCi,label='AvTemp')
    AvTemp(:) = AvElcPot(:,8)
    AvElcPot(:,8) = AvElcPot(:,7)
    AvElcPot(:,8) = AvTemp
    call mma_deallocate(AvTemp)

    !*******************************
    ! This multiplication comes because the off-diagonal
    ! quadrupoles must be multiplied by two since we use
    ! a triangular form to compute the Interaction
    ! Energy with the Electric Field Gradient.
    ! Since it is easier to multiply the Average potential
    ! than the quadrupole for each pair of bases, we perform
    ! the multiplication here
    !**********************
    AvElcPot(:,6) = Two*AvElcPot(:,6)
    AvElcPot(:,7) = Two*AvElcPot(:,7)
    AvElcPot(:,9) = Two*AvElcPot(:,9)
    !**********************
    if (iPrint >= 9) then
      write(u6,*) 'Total Averg Potential'
      do i=1,iCi
        write(u6,*) AvElcPot(i,:)
      end do
    end if

  case ('PERT')
    ! First we read the multipoles expansion for each pair of bases.
    ! The index iCent(i) will give us to which center belongs each pair of bases.

    call mma_allocate(outxyz,3,nTri_Elem(iQ_Atoms),label='outxyz')
    call mma_allocate(iCent,nTri_Elem(nBas),label='iCent')
    call mma_allocate(Dum,nBas,nBas,label='Dummy')
    call Allocate_DT(MME,[1,nTri3_Elem(MxMltp)],label='MME')
    call MultiNew(iQ_Atoms,nBas,nOcc,natyp,nntyp,MME,iCent,Dum,nMlt,outxyz,.false.)
    call mma_deallocate(Dum)

    !*********************
    ! Calculate the forces for the nuclei these forces will compensate partially
    ! the forces due to the electrons, They will be printed and added to the
    ! RUNFILE in the optimization procedure after Alaska module
    !********************
    ! This model does not work for calculating the forces in the nuclei
    ! with a Slater representation since you have to calculate the field
    ! in a set of point charges and not in distributed charges as the field
    ! is calculated when used Slater representation also there is a more
    ! dark and complicated problem about the string interaction keeping
    ! together the distributed electronic charge and the point nuclear
    !  charge under different forces.
    !*********************
    call mma_allocate(ForceNuc,3,iQ_Atoms,label='ForceNuc')
    do i=1,iQ_Atoms
      ForceNuc(:,i) = ChaNuc(i)*AvElcPot(i,2:4)
    end do
    iLuField = IsFreeUnit(63)
    call OpnFl(FieldNuc,iLuField,Exists)
    write(u6,*) 'FieldNuc',FieldNuc
    do i=1,iQ_Atoms
      write(iLuField,*) ForceNuc(:,i)
    end do
    close(iLuField)

    if (iPrint >= 9) then
      write(u6,*) 'Nuclei charge and Forces'
      do i=1,iQ_Atoms
        write(u6,*) ChaNuc(i),ForceNuc(:,i)
      end do
    end if
    call mma_deallocate(ForceNuc)
    !********************

    nTyp = 0
    do i=1,nMlt
      nTyp = nTyp+nTri_Elem(i)
    end do
    PertElcInt(:) = Zero

    ! Put quadrupoles in Buckingham form.

    do i1=1,nBas
      do i2=1,i1
        indMME = iTri(i1,i2)
        do j=5,10
          MME(j)%A(indMME) = MME(j)%A(indMME)*OneHalf
        end do
        Tra = (MME(5)%A(indMME)+MME(8)%A(indMME)+MME(10)%A(indMME))/Three
        MME(5)%A(indMME) = MME(5)%A(indMME)-Tra
        MME(8)%A(indMME) = MME(8)%A(indMME)-Tra
        MME(10)%A(indMME) = MME(10)%A(indMME)-Tra
      end do
    end do

    irc = -1
    Lu_One = IsFreeUnit(49)
    call OpnOne(irc,0,'ONEINT',Lu_One)
    if (irc /= 0) then
      write(u6,*)
      write(u6,*) 'ERROR! Could not open one-electron integral file.'
      call Quit(_RC_IO_ERROR_READ_)
    end if

    ! We read the size of the unperturbed Hamiltonian 'OneHam 0' in OneInt.

    irc = -1
    iOpt = 1
    iSmLbl = 1
    nSize = 0
    call iRdOne(irc,iOpt,'OneHam 0',1,iiDum,iSmLbl)
    nSize = iiDum(1)
    if (irc /= 0) then
      write(u6,*)
      write(u6,*) 'ERROR! Failed to read number of one-electron integrals.'
      call Quit(_RC_IO_ERROR_READ_)
    end if
    if (nSize == 0) then
      write(u6,*)
      write(u6,*) 'ERROR! Problem reading size of unperturbed Hamiltonian in OneInt'
      call Quit(_RC_IO_ERROR_READ_)
    end if

    ! Memory allocation for the unperturbed Hamiltonian
    call mma_allocate(H0,nSize,label='MAver')
    irc = -1
    iOpt = 6
    iSmLbl = 0

    ! Read the unperturbed Hamiltonian
    call RdOne(irc,iOpt,'OneHam 0',1,H0,iSmLbl) !Collect non perturbed integrals
    call mma_allocate(H1,nSize,label='MAver1')
    if (iPrint >= 9) call TriPrt('Non Perturb One-e',' ',H0,nBas)

    ! We perform the multiplication for each pair of bases in a triangular form.
    ! The perturbation is added to the unperturbed Hamiltonian 'H0'.

    kaunta = 0
    do iB1=1,nBas
      do iB2=1,iB1
        kaunta = kaunta+1
        indMME = iTri(iB1,iB2)
        do iTyp=1,nTyp
          PertElcInt(indMME) = PertElcInt(indMME)+AvElcPot(iCent(kaunta),iTyp)*MME(iTyp)%A(indMME)
        end do
        H1(kaunta) = H0(kaunta)+PertElcInt(indMME)
      end do
    end do
    call mma_deallocate(iCent)
    call Deallocate_DT(MME)

    if (iPrint >= 9) call TriPrt('H0+Elec One-e',' ',H1,nBas)

    ! The non-Electrostatic perturbation is added. The PertNElcInt array comes
    ! through the module qmstat_global

    if (iPrint >= 10) call TriPrt('PertNElcInt-e',' ',PertNElcInt,nBas)

    H1(:) = H1+PertNElcInt

    if (iPrint >= 9) call TriPrt('H0+Elec+nonEl One-e',' ',H1,nBas)

    ! The perturbed Hamiltonian 'H1' is writen in OneInt.
    irc = -1
    iOpt = 0
    iSmLbl = 1
    call WrOne(irc,iOpt,'OneHam  ',1,H1,iSmLbl) !Write perturbed integrals
    if (iPrint >= 9) call TriPrt('Perturb One-e',' ',H1,nBas)

    if (iPrint >= 10) call TriPrt('Non Perturb One-e AGAIN',' ',H0,nBas)

    call ClsOne(irc,Lu_One)

    call mma_deallocate(H0)
    call mma_deallocate(H1)

end select

return

end subroutine AverMEP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine T1_div(T1n,OE,no,nv)
! this routine does:
! T1n(a,i) = T1n(a,i)/(e(i)-e(a))
!
! division of T1n amplitides by denominator

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: no, nv
real(kind=wp), intent(inout) :: T1n(nv,no)
real(kind=wp), intent(in) :: OE(no+nv)
integer(kind=iwp) :: i

do i=1,no
  T1n(:,i) = T1n(:,i)/(OE(i)-OE(no+1:no+nv))
end do

return

end subroutine T1_div

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Bjorn O. Roos                                    *
!***********************************************************************

subroutine Vibinp(ncase,ngrid,nvib,Umin,Umax,Rout,PotR,E0,dE0,Redm,Teas,Req,sc,temp)
!***********************************************************************
!  Object: Read input and construct default input parameters           *
!  written by Bjoern Roos in March 1991                                *
!***********************************************************************

use Vibrot_globals, only: Atom1, Atom2, dRo, EoutO, iad12, iad13, iadvib, iallrot, IfPrWf, iobs, iplot, iscale, ispc, J1A, J1B, &
                          J2A, J2B, lambda, n0, n02, nop, npin, npobs, npoint, nRot_Max, nvib1, nvib21, Obsin, R0o, R1o, RinO, &
                          Titobs, Vibwvs, Vibwvs1, Vibwvs2
use Constants, only: Zero, One, Five, UTOAU
use Definitions, only: wp, iwp, r8, u6

implicit none
integer(kind=iwp), intent(out) :: ncase, ngrid, nvib
real(kind=wp), intent(out) :: Umin, Umax, E0, dE0, Redm, Teas, Req, sc, temp
real(kind=wp), intent(out) :: Rout(npoint+4), PotR(npoint+4)
integer(kind=iwp) :: LuIn, LuIn1, ntit1, ntit2, i, j, k, ii, kk, iadvi1, iadvi2, ich1, ich2, IERR, iOpt, iplotp, ipot, isn1, &
                     isn1x, isn2, isn2x, ist, lambdx, ngridx, nobsi
logical(kind=iwp) :: skip, exists
real(kind=wp) :: del, dRp, O0, Oeq, R0p, R1p, Redm1, Redmx, Reqx, Rmax, Rmin, Rn1, Rout0, U, Umaxx, Uminx, xMass1, xMass2, xxx, &
                 Rin(npin), Ein(npin)
character(len=2) :: At1x, At2x
character(len=4) :: word, Diatom, Diatomx
! For storing character data using gather/scatter DAFILE operations, it
! is imperative that the strings are aligned on integers.
! Assume an 8-byte character string is always dividible into integers.
! Else, IntCh and (maybe) Title1 and Title2 must be changed.
character(len=8) :: IntCh
character(len=80) :: Title1(10), Title2(10)
character(len=180) :: Line, l84, l84x
integer(kind=iwp), parameter :: ntab = 19
character(len=*), parameter :: tabinp(ntab) = ['TITL','ATOM','GRID','RANG','VIBR','ROTA','ORBI','NOSP','OBSE','STEP', &
                                               'POTE','ROVI','TRAN','ASYM','PRWF','SCAL','TEMP','ALLR','END ']
integer(kind=iwp), external :: IsFreeUnit, iNuclearChargeFromSymbol, iMostAbundantIsotope
real(kind=r8), external :: dNuclearMass
character(len=180), external :: Get_Ln, Get_Ln_EOF

LuIn = IsFreeUnit(11)
call SpoolInp(LuIn)

! Set default values to input variables

Atom1 = ''
Atom2 = ''
ipot = 0        ! Indicator for potential input
ngrid = 199     ! Maximum number of grid points
Rmin = One
Rmax = Five     ! Integration range
Umin = log(Rmin)
Umax = log(Rmax)
nvib = 3
nvib1 = nvib-1  ! Number of vibrational states
J1A = 0
J2A = 5         ! Range of rotational quantum numbers
lambda = 0      ! Orbital angular momentum quantum number
dE0 = 4.0e-4_wp ! Start value for step size in eigenvalue search
ispc = 1        ! Spectroscopic constants will be computed
iobs = 0        ! No calculation of matrix elements for operators
Teas = Zero     ! Asymtotic energy difference between two potentials
iplotp = 0      ! No plot file for the potential
iscale = 0      ! No scaling of input potential (BOR in June 2001)
temp = 300.0_wp ! Temperature for Boltzmann weighting
iallrot = 0     ! No calculation of transition between all rot. levels
IfPrWf = 0      ! PAM97: New key word PRWF, flagged by IfPrWf > 0, default=0:
Title1(:) = ''

! Position input file

rewind(LuIn)
call RdNLst(LuIn,'VibRot')

! Read input data from input file

ntit1 = 0
skip = .false.
input: do
  if (skip) then
    skip = .false.
  else
    read(LuIn,'(a)') line
    call Upcase(line)
    if (line(1:1) == '*') cycle input
    word = line(1:4)
    if (Word == '') Word = 'END'
  end if

  select case (word)

    case (tabinp(1))
      ! Read title lines. Maximum 10 is allowed.
      do
        read(LuIn,'(a)') line
        word = line(1:4)
        call Upcase(word)
        do i=1,ntab
          if (word == tabinp(i)) then
            skip = .true.
            cycle input
          end if
        end do
        if (ntit1 < 10) then
          ntit1 = ntit1+1
          read(line,'(a)') Title1(ntit1)
        end if
      end do

    case (tabinp(2))
      ! Read isotope numbers
      ! isn1 and isn2 are the isotope numbers for atoms 1 and 2,
      ! Atom1 and Atom2 the corresponding chemical symbols
      ! Masses are read from the next one/two lines if one/two
      ! of the isotope numbers are negative.
      ! Else the masses are obtained from the tables in ISOTOPE.
      ! if isn=0 the mass for the most abundant isotope will be used
      Line = Get_Ln(LuIn)
      call Upcase(line)
      ii = 0
      ist = 0
      do i=1,80
        if (line(i:i) == ' ') cycle
        if (i < ist) cycle
        ii = ii+1
        kk = 0
        do k=i,80
          if (line(k:k) == ' ') exit
          kk = kk+1
        end do
        ist = i+kk
        if (ii == 1) then
          call Get_I1(1,isn1)
        else if (ii == 2) then
          call Get_S(2,Atom1(1:kk),1)
        else if (ii == 3) then
          call Get_I1(3,isn2)
        else if (ii == 4) then
          call Get_S(4,Atom2(1:kk),1)
          exit
        end if
      end do

      if (Atom1 == 'D') then
        ich1 = 1
      else if (Atom1 == 'T') then
        ich1 = 1
      else
        ich1 = iNuclearChargeFromSymbol(Atom1)
      end if
      if (isn1 == 0) then
        if (Atom1 == 'D') then
          isn1 = 2
        else if (Atom1 == 'T') then
          isn1 = 3
        else
          isn1 = iMostAbundantIsotope(ich1)
        end if
        xMass1 = dNuclearMass(ich1,isn1)
      else if (isn1 > 0) then
        xMass1 = dNuclearMass(ich1,isn1)
      else
        read(LuIn,*) xMass1
        xMass1 = UTOAU*xMass1
      end if

      if (Atom2 == 'D') then
        ich2 = 1
      else if (Atom2 == 'T') then
        ich2 = 1
      else
        ich2 = iNuclearChargeFromSymbol(Atom2)
      end if
      if (isn2 == 0) then
        if (Atom2 == 'D') then
          isn2 = 2
        else if (Atom2 == 'T') then
          isn2 = 3
        else
          isn2 = iMostAbundantIsotope(ich2)
        end if
        xMass2 = dNuclearMass(ich2,isn2)
      else if (isn2 > 0) then
        xMass2 = dNuclearMass(ich2,isn2)
      else
        read(LuIn,*) xMass2
        xMass2 = UTOAU*xMass2
      end if

      Redm = xMass1*xMass2/(xMass1+xMass2)

    case (tabinp(3))
      ! Read number of grid points for numerical integration (max: npoint)
      Line = Get_Ln(LuIn)
      call Get_I1(1,ngrid)
      if (mod(ngrid,2) == 0) ngrid = ngrid-1 ! ngrid should be odd
      if (ngrid >= npoint) ngrid = npoint-1

    case (tabinp(4))
      ! Read upper and lower integration range in atomic units
      Line = Get_Ln(LuIn)
      call Get_F1(1,Rmin)
      call Get_F1(2,RMax)
      Umin = log(Rmin)
      Umax = log(Rmax)

    case (tabinp(5))
      ! Read number of vibrational quantum numbers
      Line = Get_Ln(LuIn)
      call Get_I1(1,nvib)
      n0 = 0
      nvib1 = nvib-1

    case (tabinp(6))
      ! Read range for rotational quantum numbers
      Line = Get_Ln(LuIn)
      call Get_I1(1,J1A)
      call Get_I1(2,J2A)
      if (J2A >= nRot_Max) then
        write(u6,*)
        write(u6,*) '********************************'
        write(u6,*) ' VIBINP Error: J2A > nRot_Max.'
        write(u6,'(1x,a,2i6)') 'J2A:',J2A
        write(u6,*) '********************************'
        call Quit_OnUserError()
      end if

    case (tabinp(7))
      ! Read orbital angular momentum quantum number
      Line = Get_Ln(LuIn)
      call Get_I1(1,lambda)

    case (tabinp(8))
      ! Read flag for spectroscopic constants
      ispc = 0

    case (tabinp(9))
      ! Read input for calculation of matrix elements of observables
      ! like the dipole operator, etc.
      iobs = iobs+1
      iplot(iobs) = 0
      if (iobs > 10) then
        write(u6,*)
        write(u6,*) '***************************'
        write(u6,*) ' VIBINP Error: IOBS > 10.'
        write(u6,'(1x,a,2i6)') 'IOBS:',IOBS
        write(u6,*) '***************************'
        call Quit_OnUserError()
      end if

      !VV: make it really nasty. if it looks like a file - read from the file
      !    else-  this is a title
      read(LuIn,'(a)') Line
      call f_inquire(Line(1:index(Line,' ')-1),exists)
      if (exists) then
        LuIn1 = IsFreeUnit(15)
        call molcas_open(LuIn1,Line(1:index(Line,' ')-1))
        Line = Get_Ln(LuIn1)
      else
        LuIn1 = LuIn
      end if
      Titobs(iobs) = trim(Line)
      !write(u6,*) ' In VIBINP. IOBS=',IOBS
      !write(u6,*) ' TITOBS just read:'
      !write(u6,'(a80)') TITOBS(IOBS)
      nobsi = 0
      do
        Line = Get_Ln_EOF(LuIn1)
        if ((Line(1:3) == 'EOF') .and. (LuIn1 /= LuIn)) then
          close(LuIn1)
          Line = Get_Ln(LuIn)
        end if
        word = line(1:4)
        call Upcase(word)
        do i=1,ntab
          if (word == tabinp(i)) then
            skip = .true.
            cycle input
          end if
        end do
        if (word == 'PLOT') exit
        nobsi = nobsi+1
        if (NOBSI > NPIN) then
          write(u6,*)
          write(u6,*) '**********************************'
          write(u6,*) ' VIBINP Error: NOBSI > NPIN'
          write(u6,'(1x,a,2i6)') 'NOBSI,NPIN:',NOBSI,NPIN
          write(u6,*) '**********************************'
          call Quit_OnUserError()
        end if
        npobs(iobs) = nobsi
        call Get_F1(1,RinO(nobsi,iobs))
        call Get_F1(2,Obsin(nobsi,iobs))
      end do
      do
        Line = Get_Ln(LuIn)
        if (line(1:1) /= '*') exit
      end do
      call Get_F1(1,R0o(iobs))
      call Get_F1(2,R1o(iobs))
      call Get_F1(3,dRo(iobs))
      iplot(iobs) = 1

    case (tabinp(10))
      ! Read starting value for step size in eigenvalue search
      Line = Get_Ln(LuIn)
      call Get_F1(1,dE0)

    case (tabinp(11))
      ! Read potential
      ipot = 1
      nop = 0
      Line = Get_Ln(LuIn)
      xxx = 999.97_wp
      read(line,*,iostat=IERR) xxx
      if ((xxx == 999.97_wp) .or. (IERR /= 0)) then
        call f_inquire(line,exists)
        write(u6,*) line
        if (.not. exists) then
          write(u6,*) 'File with potential non-existent'
          write(u6,*) 'File=',trim(line)
          call Abend()
        end if
        LuIn1 = IsFreeUnit(15)
        call molcas_open(LuIn1,line)
      else
        backspace(LuIn)
        Luin1 = Luin
      end if
      do
        Line = Get_Ln_EOF(LuIn1)
        if ((Line(1:3) == 'EOF') .and. (LuIn1 /= LuIn)) then
          close(LuIn1)
          Line = Get_Ln(LuIn)
        end if
        word = line(1:4)
        call Upcase(word)
        do i=1,ntab
          if (word == tabinp(i)) then
            skip = .true.
            cycle input
          end if
        end do
        if (word == 'PLOT') exit
        nop = nop+1
        if (NOP > NPIN) then
          write(u6,*)
          write(u6,*) '**********************************'
          write(u6,*) ' VIBINP Error: NOP > NPIN'
          write(u6,'(1x,a,2i6)') 'NOP,NPIN:',NOP,NPIN
          write(u6,*) '**********************************'
          call Quit_OnUserError()
        end if
        call Get_F(1,Rin(nop),1)
        call Get_F(2,Ein(nop),1)
      end do
      Line = Get_Ln(LuIn)
      call Get_F1(1,R0p)
      call Get_F1(2,R1p)
      call Get_F1(3,dRp)
      iplotp = 1
      if (LuIn1 /= LuIn) close(LuIn1)

    case (tabinp(12))
      ! Calculation of ro-vibrational wave functions (ncase=1)
      ncase = 1

    case (tabinp(13))
      ! Calculation of transition moments (ncase=2)
      ncase = 2

    case (tabinp(14))
      ! Asymptotic energy difference between two potentials
      Line = Get_Ln(LuIn)
      call Get_F1(1,Teas)

    case (tabinp(15))
      ! Flag for printing the wave function.
      IfPrWf = 1

    case (tabinp(16))
      ! Scaling of input potential such that the binding energy is 0.1 au.
      iscale = 1

    case (tabinp(17))
      ! Temperature for vibrational averaging
      Line = Get_Ln(LuIn)
      call Get_F1(1,Temp)

    case (tabinp(18))
      ! ALLRotational
      iallrot = 1

    case (tabinp(19))
      exit input

    case default
      write(u6,*)
      write(u6,*) '******************************************'
      write(u6,*) ' VIBINP Error: Input line not recognized.'
      write(u6,*) ' Input line, in upper case:'
      write(u6,'(a)') line
      write(u6,*) ' Extracted keyword: ',word
      write(u6,*) '******************************************'
      call Quit_OnUserError()
  end select
end do input

if (J1A < lambda) then
  write(u6,*)
  write(u6,*) '********************************'
  write(u6,*) ' VIBINP Warning: J1A < Lambda.'
  write(u6,'(1x,a,2i6)') 'J1A,Lambda:',J1A,Lambda
  write(u6,*) ' J1A is now reset to Lambda.'
  write(u6,*) '********************************'
  J1A = lambda
end if

if (J2A < J1A) then
  write(u6,*)
  write(u6,*) '***************************'
  write(u6,*) ' VIBINP Error: J2A < J1A.'
  write(u6,'(1x,a,2i6)') 'J2A,J1A:',J2A,J1A
  write(u6,*) '***************************'
  call Quit_OnUserError()
end if

! Check for input error

if (ncase == 1) then
  if ((Atom1 == '  ') .or. (Atom2 == '  ')) then
    write(u6,*)
    write(u6,*) '**********************************'
    write(u6,*) ' VIBINP Error: No atoms in input.'
    write(u6,*) '**********************************'
    call Quit_OnUserError()
  end if
end if

! Retrieve data from Vibwvs1 and Vibwvs2 (ncase=2)

if (ncase == 2) then
  iadvi1 = 0
  call iDafile(Vibwvs1,2,iad12,100,iadvi1)
  iOpt = 2
  call WR_VibRot_Info1(Vibwvs1,iOpt,iadvi1,ntit1,J1A,J2A,lambda,n0,nvib1,Redm,Umax,Umin,ngrid,isn1,isn2,Req,xMass1,xMass2)
  call cDaFile(Vibwvs1,iOpt,Title1,10*80,iadvi1)
  call cDaFile(Vibwvs1,iOpt,IntCh,8,iadvi1)

  Atom1 = IntCh(1:2)
  Atom2 = IntCh(5:6)
  Rmin = exp(Umin)
  Rmax = exp(Umax)
  iadvi2 = 0
  call iDafile(Vibwvs2,2,iad13,100,iadvi2)
  iOpt = 2
  call WR_VibRot_Info1(Vibwvs2,iOpt,iadvi2,ntit2,J1B,J2B,lambdx,n02,nvib21,Redmx,Umaxx,Uminx,ngridx,isn1x,isn2x,Reqx,xMass1,xMass2)
  call cDaFile(Vibwvs2,iOpt,Title2,10*80,iadvi2)
  call cDaFile(Vibwvs2,iOpt,IntCh,8,iadvi2)
  At1x = IntCh(1:2)
  At2x = IntCh(5:6)

  ! Check for consistency of data on files

  IERR = 0
  if ((Atom1 /= At1x) .or. (Atom2 /= At2x)) then
    write(u6,*)
    write(u6,*) '***************************************'
    write(u6,*) ' VIBINP Error: Inconsistent data.'
    write(u6,'(1x,a,1x,a,1x,a)') 'ATOM1,AT1X:',ATOM1,AT1X
    IERR = 1
  end if
  if (abs(Redm-Redmx) > 1.d-06) then
    write(u6,*)
    write(u6,*) '***************************************'
    write(u6,*) ' VIBINP Error: REDM /= REDMX'
    write(u6,'(1x,a,2f16.6)') 'REDM,REDMX:',REDM,REDMX
    IERR = 1
  end if
  if (Umax /= Umaxx) then
    write(u6,*)
    write(u6,*) '***************************************'
    write(u6,*) ' VIBINP Error: UMAX /= UMAXX'
    write(u6,'(1x,a,2f16.6)') 'UMAX,UMAXX:',UMAX,UMAXX
    IERR = 1
  end if
  if (Umin /= Uminx) then
    write(u6,*)
    write(u6,*) '***************************************'
    write(u6,*) ' VIBINP Error: UMIN /= UMINX'
    write(u6,'(1x,a,2f16.6)') 'UMIN,UMINX:',UMIN,UMINX
    IERR = 1
  end if
  if (NGrid /= NGridx) then
    write(u6,*)
    write(u6,*) '***************************************'
    write(u6,*) ' VIBINP Error: NGrid /= NGridX'
    write(u6,'(1x,a,2i8)') 'NGrid,NGridX:',NGrid,NGridX
    IERR = 1
  end if
  if (Isn1 /= Isn1x) then
    write(u6,*)
    write(u6,*) '***************************************'
    write(u6,*) ' VIBINP Error: Isn1 /= Isn1X'
    write(u6,'(1x,a,2i8)') 'Isn1,Isn1X:',Isn1,Isn1X
    IERR = 1
  end if
  if (Isn2 /= Isn2x) then
    write(u6,*)
    write(u6,*) '***************************************'
    write(u6,*) ' VIBINP Error: Isn2 /= Isn2X'
    write(u6,'(1x,a,2i8)') 'Isn2,Isn2X:',Isn2,Isn2X
    IERR = 1
  end if
  if (IERR /= 0) then
    write(u6,*) '*****************************************'
    write(u6,*) ' VIBINP: Irrecoverable errors.'
    write(u6,*) ' Transition calculation, but data on the'
    write(u6,*) ' two VibWvs files are not compatible.'
    write(u6,*) '*****************************************'
    call Quit_OnUserError()
  end if
end if

! Section for print output of input information

ii = 0
Diatom = ''
Diatomx(1:2) = Atom1
Diatomx(3:4) = Atom2
do i=1,4
  if (Diatomx(i:i) /= ' ') then
    ii = ii+1
    Diatom(ii:ii) = Diatomx(i:i)
  end if
end do
if (ncase == 1) write(u6,1100) Diatom
if (ncase == 2) write(u6,1101) Diatom

if (ncase == 2) write(u6,1190)
do i=1,ntit1
  write(u6,*) Title1(i)
end do
write(u6,1200) J1A,J2A,lambda,n0,nvib1,isn1,Atom1,xMass1,isn2,Atom2,xMass2,Redm
if (ncase == 2) then
  write(u6,1191)
  do i=1,ntit2
    write(u6,*) Title2(i)
  end do
  write(u6,1201) J1B,J2B,lambdx,n02,nvib21,isn1,At1x,xMass1,isn2,At2x,xMass2,Redmx
end if

! Numerical integration data

del = (Umax-Umin)/(ngrid-1)
write(u6,1300) ngrid,del,Rmin,Rmax,Umin,Umax

if ((ispc == 0) .and. (ncase == 1)) write(u6,1400)
if ((ispc /= 0) .and. (ncase == 1)) write(u6,1500)
if (iobs == 0) write(u6,1600)
if (iobs /= 0) write(u6,1700) iobs
if ((ipot == 0) .and. (ncase == 1)) then
  write(u6,*)
  write(u6,*) '**********************************'
  write(u6,*) ' VIBINP Error: IPOT=0 and NCASE=1'
  write(u6,*) '**********************************'
  call Quit_OnUserError()
end if

! Print input potential

if (ipot /= 0) then
  write(u6,1800)
  do i=1,nop
    write(u6,1810) Rin(i),Ein(i)
  end do
  if ((Rin(1) > Rmax) .or. (Rin(nop) < Rmin)) then
    write(u6,*)
    write(u6,*) '****************************'
    write(u6,*) ' VIBINP Error: Potential is'
    write(u6,*) ' not within defined range.'
    write(u6,*) '****************************'
    call Quit_OnUserError()
  end if
  if (iplotp /= 0) write(u6,1820)
end if

! Compute radial coordinates

U = Umin-del
Rout0 = exp(U)
do i=1,ngrid
  U = U+del
  Rout(i) = exp(U)
end do
Rn1 = exp(U+del)
Rout(ngrid+1) = Rout0
Rout(ngrid+2) = Rn1
if (ipot /= 0) call POT(Rin,Ein,Rout,PotR,ngrid+2,1,E0,Req,R0p,R1p,dRp,nop,Title1(1),iplotp,Redm,sc,0)
iadvib = 0
if (ncase == 1) then
  ! Store data on Vibwvs (ncase=1)
  call iDafile(Vibwvs,1,iad12,100,iadvib)
  iOpt = 1
  Redm1 = Redm*sc
  isn1 = abs(isn1)
  isn2 = abs(isn2)
  call WR_VibRot_Info1(Vibwvs,iOpt,iadvib,ntit1,J1A,J2A,lambda,n0,nvib1,Redm1,Umax,Umin,ngrid,isn1,isn2,Req,xMass1,xMass2)
  IntCh(1:4) = Atom1
  IntCh(5:8) = Atom2
  call cDaFile(Vibwvs,iOpt,Title1,10*80,iadvib)
  call cDaFile(Vibwvs,iOpt,IntCh,8,iadvib)
end if

! Fit observable input
Rout0 = Rout(ngrid+1)
do i=1,iobs
  Rout(ngrid+1) = Req
  call POT(RinO(1,i),Obsin(1,i),Rout,EoutO(1,i),ngrid+1,2,O0,Oeq,R0o(i),R1o(i),dRo(i),npobs(i),Titobs(i),iplot(i),Redm,sc,iobs)
end do
Rout(ngrid+1) = Rout0

! Print observable input data

if (iobs /= 0) then
  write(u6,1900)
  do i=1,iobs,4
    write(u6,1910) (Titobs(k)(1:18),k=i,min(i+3,iobs))
    l84 = ' '
    do k=i,min(i+3,iobs)
      l84(24*(k-i)+1:24*(k-i)+10) = '     R(au)'
      l84(24*(k-i)+11:24*(k-i+1)) = '        Value '
    end do
    write(u6,'(a)') trim(l84)
    do j=1,npin
      l84 = ' '
      do k=i,min(i+3,iobs)
        if (j <= npobs(k)) write(l84(24*(k-i)+1:24*(k-i+1)),'(1x,F9.4,F14.6)') RinO(j,k),Obsin(j,k)
      end do
      if (l84 /= ' ') write(u6,'(a)') trim(l84)
    end do
    l84 = ' '
    l84x = ' '
    do k=i,min(i+3,iobs)
      if (iplot(i) /= 0) l84(24*(k-i)+1:24*(k-i)+14) = '     Plot file'
      if (iplot(i) == 0) l84(24*(k-i)+1:24*(k-i)+17) = '     No plot file'
      write(l84x(24*(k-i)+1:24*(k-i+1)),'(F10.4,F14.6)') Req,EoutO(ngrid+1,k)
    end do
    write(u6,'(a)') trim(l84)
    write(u6,*) ' Interpolated value at equilibrium for state 1:'
    write(u6,'(a)') trim(l84x)
  end do
end if

return

1100 format(/1x,'Vibration-Rotation spectrum for the ',a4,' molecule.')
1101 format(/1x,'Transition moments for the ',a4,' molecule.')
1190 format(/1x,'State number 1')
1191 format(/1x,'State number 2')
1200 format(/1x,'Rotational quantum number range ',2i3 &
            /1x,'Electronic angular momentum     ',i3 &
            /1x,'Vibrational quantum number range',2i3 &
            /1x,'Mass of atom ',i3,1x,a2,f15.6,' au' &
            /1x,'Mass of atom ',i3,1x,a2,f15.6,' au' &
            /1x,'Reduced mass       ',f15.6,' au')
1201 format(/1x,'Rotational quantum number range ',2i3 &
            /1x,'Electronic angular momentum     ',i3 &
            /1x,'Vibrational quantum number range',2i3 &
            /1x,'Mass of atom ',i3,1x,a2,f15.6,' au' &
            /1x,'Mass of atom ',i3,1x,a2,f15.6,' au' &
            /1x,'Reduced mass       ',f15.6,' au')
1300 format(/1x,'Statistics for numerical integration' &
            /1x,'Number of steps         ',i5 &
            /1x,'Step length             ',f10.6 &
            /1x,'Radial integration range',2f10.6,' au' &
            /1x,'logarithmic range       ',2f10.6)
1400 format(/1x,'Spectroscopic constants will not be computed')
1500 format(/1x,'Spectroscopic constants will be computed')
1600 format(1x,'Matrix elements of operators will not be computed')
1700 format(1x,'Matrix elements of',i3,' operators will be computed')
1800 format(/1x,'Potential read from input'/6x,' R(au)     E(au)')
1810 format(1x,2f12.6)
1820 format(1x,'A plot file of the potential will be generated')
1900 format(/1x,'Input data for observables')
1910 format(/1x,4a24)

end subroutine Vibinp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, IBM                                              *
!***********************************************************************

function EQ(A,B)
!***********************************************************************
!                                                                      *
! Object: to return the value .true. if A and B are the same centers.  *
!                                                                      *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: EQ
real(kind=wp), intent(in) :: A(3), B(3)

EQ = all(A(:) == B(:))

return

end function EQ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_DBGINT_S(ISHLQ,NSHLQ,PRTLAB)
C
C     Purpose: regenerate and check a specified set of integrals.
C
C     NOTE: this is *not* meant for production calculations, only for
C           debugging, as:
C           1) full Cholesky vectors are read
C           2) calculations are performed in full (no use of red. sets
C              apart from first)
C
      use ChoArr, only: nBstSh
#include "implicit.fh"
      INTEGER ISHLQ(4,NSHLQ)
      LOGICAL PRTLAB
#include "cholesky.fh"
#include "choorb.fh"
#include "stdalloc.fh"

      CHARACTER(LEN=16), PARAMETER:: SECNAM = 'CHO_MCA_DBGINT_S'

      INTEGER, EXTERNAL:: CHO_F2SP

      Real*8 XLBAS(8)

      CHARACTER(LEN=8) LABEL

      Real*8, Allocatable:: INT1(:), WRK(:)

      MULD2H(I,J)=IEOR(I-1,J-1)+1
      ITRI(I,J)=MAX(I,J)*(MAX(I,J)-3)/2+I+J

C     Return if nothing specified.
C     ----------------------------

      IF (NSHLQ .LT. 1) RETURN

C     Force computation of full shell quadruple.
C     ------------------------------------------

      IF (IFCSEW .NE. 1) THEN
         WRITE(LUPRI,*) SECNAM,': WARNING: resetting IFCSEW from ',
     &                  IFCSEW,' to 1.'
         WRITE(LUPRI,*) SECNAM,
     &   ': memory demands are significantly increased by this!'
         IFCSEW = 1
      END IF

C     Initializations.
C     ----------------

      GLMAX = 0.0D0
      GLMIN = 1.0D15
      GLRMS = 0.0D0
      XTCMP = 0.0D0
      XPECT = 0.0D0

C     Make first reduced set the current reduced set.
C     -----------------------------------------------

      CALL CHO_RSCOPY(1,2)

C     Allocate memory for largest integral quadruple.
C     -----------------------------------------------

      LINTMX = MX2SH*MX2SH
      Call mma_allocate(INT1,LINTMX,Label='INT1')

C     Allocate max. memory
C     ----------------------------------------------------------

      Call mma_maxDBLE(LWRK)
      Call mma_allocate(WRK,LWRK/2,Label='WRK')
      CALL XSETMEM_INTS(LWRK/2)

C     Print header.
C     -------------

      CALL CHO_HEAD('Integral Error Analysis','=',80,LUPRI)
      WRITE(LUPRI,'(/,A,/,A)')
     & '    C     D     A     B   Abs. Min.    Abs. Max.      RMS',
     & '--------------------------------------------------------------'

C     Loop over specified shell quadruples.
C     -------------------------------------

      DO I = 1,NSHLQ

         ISHLC = ISHLQ(1,I)
         ISHLD = ISHLQ(2,I)
         ISHLA = ISHLQ(3,I)
         ISHLB = ISHLQ(4,I)

         IF (ISHLC.GT.0 .AND. ISHLD.GT.0 .AND.
     &       ISHLA.GT.0 .AND. ISHLB.GT.0) THEN

            IF (ISHLD .EQ. ISHLC) THEN
               NUMCD = NBSTSH(ISHLC)*(NBSTSH(ISHLC) + 1)/2
            ELSE
               NUMCD = NBSTSH(ISHLC)*NBSTSH(ISHLD)
            END IF
            IF (ISHLB .EQ. ISHLA) THEN
               NUMAB = NBSTSH(ISHLA)*(NBSTSH(ISHLA) + 1)/2
            ELSE
               NUMAB = NBSTSH(ISHLA)*NBSTSH(ISHLB)
            END IF
            LINT1 = NUMCD*NUMAB ! actual space needed for (CD|AB)

C           Compute expected number of comparisons.
C           ---------------------------------------

            XPECTL = DBLE(LINT1)
            XPECT  = XPECT + XPECTL

C           Calculate shell quadruple (CD|AB).
C           ----------------------------------

            ISHLCD = CHO_F2SP(ITRI(ISHLC,ISHLD))
            ISHLAB = CHO_F2SP(ITRI(ISHLA,ISHLB))
            IF (ISHLAB.LT.1 .OR. ISHLCD.LT.1) THEN
               CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
            END IF

            INT1(1:LINT1)=0.0d0
            CALL CHO_MCA_INT_1(ISHLCD,ISHLAB,INT1,LINT1,.FALSE.)

C           Calculate integrals from Cholesky vectors.
C           ------------------------------------------

            CALL CHO_DBGINT_CHO(INT1,NUMCD,NUMAB,WRK,
     &                          LWRK/2,ERRMAX,ERRMIN,ERRRMS,NCMP,
     &                          ISHLCD,ISHLAB)

C           Write report.
C           -------------

            IF (NCMP .LT. 1) THEN
               WRITE(LUPRI,'(4(I5,1X),5X,A)')
     &         ISHLC,ISHLD,ISHLA,ISHLB,' !!! nothing compared !!! '
            ELSE
               XCMP  = DBLE(NCMP)
               XTCMP = XTCMP + XCMP
               RMS   = SQRT(ERRRMS/XCMP)
               IF (PRTLAB) THEN
                  CALL CHO_INTCHK_ID_OF(LABEL,I,-1)
                  WRITE(LUPRI,'(4(I5,1X),1P,3(D12.4,1X),A,A,A)')
     &            ISHLC,ISHLD,ISHLA,ISHLB,ERRMIN,ERRMAX,RMS,
     &            '(',LABEL,')'
               ELSE
                  WRITE(LUPRI,'(4(I5,1X),1P,3(D12.4,1X))')
     &            ISHLC,ISHLD,ISHLA,ISHLB,ERRMIN,ERRMAX,RMS
               END IF
            END IF

            IF (ABS(ERRMAX) .GT. ABS(GLMAX)) THEN
               GLMAX = ERRMAX
            END IF
            IF (ABS(ERRMIN) .LT. ABS(GLMIN)) THEN
               GLMIN = ERRMIN
            END IF
            GLRMS = GLRMS + ERRRMS

         END IF

      END DO

C     Print end of table.
C     -------------------

      WRITE(LUPRI,'(A)')
     & '--------------------------------------------------------------'
      IF (XTCMP .LT. 1.0D0) THEN
         WRITE(LUPRI,'(A,23X,A)')
     &   'Total:',' !!! nothing compared !!! '
      ELSE
         GLRMS = SQRT(GLRMS/XTCMP)
         WRITE(LUPRI,'(A,18X,1P,3(D12.4,1X))')
     &   'Total:',GLMIN,GLMAX,GLRMS
      END IF
      WRITE(LUPRI,'(A)')
     & '--------------------------------------------------------------'

C     Release all memory allocated here (and release seward memory).
C     --------------------------------------------------------------

      CALL XRLSMEM_INTS
      Call mma_deallocate(WRK)
      Call mma_deallocate(INT1)

C     Check total number of comparisons.
C     ----------------------------------

      DO ISYM = 1,NSYM
         XLBAS(ISYM) = DBLE(NBAS(ISYM))
      END DO
      XNINT = 0.0D0
      DO ISYM = 1,NSYM
         XXLBST = 0.0D0
         DO ISYMB = 1,NSYM
            ISYMA = MULD2H(ISYMB,ISYM)
            IF (ISYMA .EQ. ISYMB) THEN
               XXLBST = XXLBST + XLBAS(ISYMA)*(XLBAS(ISYMA)+1.0D0)/2.0D0
            ELSE IF (ISYMA .GT. ISYMB) THEN
               XXLBST = XXLBST + XLBAS(ISYMA)*XLBAS(ISYMB)
            END IF
         END DO
         XNINT = XNINT + XXLBST*(XXLBST + 1.0D0)/2.0D0
      END DO

      IF (ABS(XTCMP-XPECT) .GT. 1.0D-15) THEN
         WRITE(LUPRI,'(/,A)')
     &   'WARNING: not all integrals checked:'
      ELSE
         WRITE(LUPRI,*)
      END IF
      WRITE(LUPRI,'(A,1P,D20.10)')
     & 'Total number of integral comparisons    :',XTCMP
      WRITE(LUPRI,'(A,1P,D20.10)')
     & 'Total number expected (full shell pairs):',XPECT
      WRITE(LUPRI,'(A,1P,D20.10)')
     & 'Total number of unique integrals        :',XNINT

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mreallocr_cvb(ipoint,nword)
c  Memory allocator (heap). Reallocate pointer.
      implicit real*8 (a-h,o-z)
#include "memman_cvb.fh"
#include "WrkSpc.fh"
#include "files_cvb.fh"

      if(memdebug)write(6,*)'     Enter mreallocr: nword & pointer :',
     >  nword,ipoint

      ipoint_g=ipoint-ioff_r

c      call getmem('casvb','CHAN','REAL',ipoint_g,nword)

c  Read and write data -- not efficient but safe and simple :
      call getmem('casvb','LENG','REAL',ipoint_g,nword_old)
      nword_move=min(nword,nword_old)
      call wrr_cvb(work(ipoint),nword_move,recn_tmp06,0)
      call mfreer_cvb(ipoint)
      ipoint=mheapr_cvb(nword)
      call rdr_cvb(work(ipoint),nword_move,recn_tmp06,0)

      if(memdebug)write(6,*)'     mreallocr : nword & pointer :',
     >  nword,ipoint
      return
      end
      integer function mavailr_cvb()
c  Memory allocator (heap). Returns number of real*8 words free.
      implicit real*8 (a-h,o-z)
#include "memman_cvb.fh"

      call getmem('casvb','MAX ','REAL',ipoint_g,nword)
      mavailr_cvb=nword
      if(memdebug)write(6,*)'     mavailr :',mavailr_cvb
      return
      end
c
c  -- Integer routines - just front-ends for real*8 ---
c
      integer function mheapi_cvb(nword)
      implicit real*8 (a-h,o-z)
#include "idbl_cvb.fh"
#include "memman_cvb.fh"

      if(memdebug)write(6,*)'   Enter mheapi: nword :',nword
      nwordr=(nword+idbl-1)/idbl
      iraddr=mheapr_cvb(nwordr)
      mheapi_cvb=(iraddr-1)*idbl+1
      if(memdebug)write(6,*)'   mheapi: nword & pointer :',
     >  nword,mheapi_cvb
      return
      end
      integer function mstacki_cvb(nword)
      implicit real*8 (a-h,o-z)
#include "idbl_cvb.fh"
#include "memman_cvb.fh"

      if(memdebug)write(6,*)'   Enter mstacki: nword :',nword
      nwordr=(nword+idbl-1)/idbl
      iraddr=mstackr_cvb(nwordr)
      mstacki_cvb=(iraddr-1)*idbl+1
      if(memdebug)write(6,*)'   mstacki: nword & pointer :',
     >  nword,mstacki_cvb
      return
      end
      integer function mavaili_cvb()
      implicit real*8 (a-h,o-z)
#include "idbl_cvb.fh"
#include "memman_cvb.fh"

      mavaili_cvb=mavailr_cvb()*idbl
      if(memdebug)write(6,*)'   mavaili :',mavaili_cvb
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  RassiHandM
*
*> @brief
*>   Make a multicenter multipole expansion of the various densities in the RASSI-state Hamiltonian to be.
*>   We also construct the gas-phase RASSI-state Hamiltonian
*> @author A. Ohrn
*>
*> @details
*> First construct the unperturbed RASSI-state Hamiltonian. The \c RasEne
*> are given in input (could be changed later). Then we obtain the
*> MME of the densities of each unique pair of AO-basis functions,
*> which we with the transition density matrices transform to their
*> RASSI-state counterparts---a process that requires some knowledge
*> about that matrix. For example, it should be noted that the matrix
*> is triangularily stored *with* corrections made for the difference
*> between diagonal and non-diagonal elements; therefore we do not
*> need to treat them differently, like we have to in the subroutine
*> ::scfhandm. If requested, we compute total charges and dipoles of
*> every state and print.
*>
*> @note
*> Requires Qfread and of course a RASSI-computation and also MPPROP.
*>
*> @param[in] nBas  Number of contracted AO-basis functions
*> @param[in] nOcc  Number of basis functions on the \f$ i \f$ th atom-type.
*> @param[in] natyp Number of atoms of the \f$ i \f$ th atom-type
*> @param[in] nntyp Number of atom-types
************************************************************************
      Subroutine RassiHandM(nBas,iQ_Atoms,nOcc,natyp,nntyp)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "qm2.fh"
#include "files_qmstat.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension nBas(MxSym),natyp(MxAt),nOcc(MxBas)
      Dimension iMME(MxMltp*(MxMltp+1)*(MxMltp+2)/6),iCent(MxBas*MxBas)
      Character MMElab*20,ChCo*2

*
*-- A modest entrance.
*

*
*-- Zeros.
*
      kaunt=0
      iCi=iQ_Atoms*(iQ_Atoms+1)/2
      nSav1=0
      nSav2=0
      Do 1, i=1,nState
        Do 2, j=1,i
          kaunt=kaunt+1
          Do 3, k=1,iCi
            RasCha(kaunt,k)=0
            RasDip(kaunt,1,k)=0
            RasDip(kaunt,2,k)=0
            RasDip(kaunt,3,k)=0
            RasQua(kaunt,1,k)=0
            RasQua(kaunt,2,k)=0
            RasQua(kaunt,3,k)=0
            RasQua(kaunt,4,k)=0
            RasQua(kaunt,5,k)=0
            RasQua(kaunt,6,k)=0
3         Continue
2       Continue
1     Continue

*
*-- Construct H_0 with external perturbation if requested. Construct
*   a copy also.
*
      Write(6,*)
      If(.not.AddExt) then
        Write(6,*)'     Constructs H_0.'
      Else
        Write(6,*)'     Constructs H_0 with external perturbation.'
      Endif
      Call Chk_OneHam(nBas)
      Call RasH0(nBas(1))
      kaunter=0
      Do 11, i=1,nState
        Do 12, j=1,i
          kaunter=kaunter+1
          HMatSOld(kaunter)=HmatState(kaunter)
12      Continue
11    Continue
      Write(6,*)'     ...Done!'
      Write(6,*)

*
*-- Here the MME is performed. First the expansion is performed in the
*   AO-basis. Then depending on whether we use a reduced MO-basis or
*   not, the proper approach is chosen.
*
*
*-- Say what we do.
*
      Write(6,*)
      Write(6,*)'     Multicenter multipole expanding the charge'
     &//' density expressed in RASSI eigenstates.'

*
*-- Frist obtain MME in AO-basis.
*
      Call GetMem('Dummy','Allo','Inte',iDum,nBas(1)**2)
      Call MultiNew(iQ_Atoms,nBas(1),nOcc,natyp,nntyp,iMME,iCent
     &             ,iWork(iDum),nMlt,outxyzRAS
     &             ,SlExpQ,lSlater)
      Call GetMem('Dummy','Free','Inte',iDum,nBas(1)**2)

*
*-- Set nTyp, which is number of unique multipole components.
*
      nTyp=0
      Do 100, i=1,nMlt
        nTyp=nTyp+i*(i+1)/2
100   Continue

*
*-- Transform to State-basis. The logical flag MoAveRed decides which
*   path to go in this subroutine.
*
      Call StateMME(MoAveRed,nBas(1),nRedMO,nState,nTyp,iCi,iBigT,iMME
     &             ,iCent,ipAvRed,RasCha,RasDip,RasQua)

*
*-- Deallocate the MME in AO-basis.
*
      Do 106,i=1,nTyp
        Write(ChCo,'(I2.2)')i
        Write(MMElab,*)'MME'//ChCo
        Call GetMem(MMElab,'Free','Real',iMME(i),nSize)
106   Continue

*
*-- Buckinghamification of the quadrupoles.
*
        kaunter=0
        Do 991, i=1,nState
          Do 992, j=1,i
            kaunter=kaunter+1
            Do 993, k=1,ici
              Do 994, l=1,6
                RasQua(kaunter,l,k)=RasQua(kaunter,l,k)*1.5
994           Continue
              Tra=RasQua(kaunter,1,k)+RasQua(kaunter,3,k)
     &           +RasQua(kaunter,6,k)
              Tra=Tra/3
              RasQua(kaunter,1,k)=RasQua(kaunter,1,k)-Tra
              RasQua(kaunter,3,k)=RasQua(kaunter,3,k)-Tra
              RasQua(kaunter,6,k)=RasQua(kaunter,6,k)-Tra
993         Continue
992       Continue
991     Continue
*
*--- And do some printing if asked for.
*
      If(iPrint.ge.10) then
        Write(6,*)
        Write(6,*)'    Distributed multipoles for each state'
        Do 31, i=1,nState
          k=i*(i+1)/2
          Write(6,*)'     State ',i
          Do 32, j=1,iCi
            Write(6,*)'        Center ',j
            Q=-RasCha(k,j)
            If(j.le.iQ_Atoms) Q=Q+ChaNuc(j)
            Write(6,*)'          ',Q
            D1=-RasDip(k,1,j)
            D2=-RasDip(k,2,j)
            D3=-RasDip(k,3,j)
            Write(6,*)'          ',D1,D2,D3
32        Continue
31      Continue
      Endif
      If(iPrint.ge.5) then
        Write(6,*)
        Write(6,*)'    Summed multipoles for each state (not state-over'
     &//'laps)'
        Write(6,*)'              Charge  Dipole(x)   Dipole(y)   Dipole'
     &//'(z)   Quadrup(xx) Quadrup(xy) Quadrup(xz) Quadrup(yy) Quadrup('
     &//'yz) Quadrup(zz)'
      Endif
      Do 26, i=1,nState  !Total charge and dipole.
        k=i*(i+1)/2
        qEl=0
        dipx=0
        dipy=0
        dipz=0
        dipx0=0
        dipy0=0
        dipz0=0
        quaxx=0
        quaxy=0
        quaxz=0
        quayy=0
        quayz=0
        quazz=0
        quaDxx=0
        quaDxy=0
        quaDxz=0
        quaDyx=0
        quaDyy=0
        quaDyz=0
        quaDzx=0
        quaDzy=0
        quaDzz=0
        quaQxx=0
        quaQxy=0
        quaQxz=0
        quaQyy=0
        quaQyz=0
        quaQzz=0
        qtot=0
        dTox=0
        dToy=0
        dToz=0
        dQxx=0
        dQxy=0
        dQxz=0
        dQyy=0
        dQyz=0
        dQzz=0
        Trace1=0
        Trace2=0
        Trace3=0
        Do 27, j=1,iCi
          qEl=qEl+RasCha(k,j)
          dipx=dipx+RasDip(k,1,j)
          dipy=dipy+RasDip(k,2,j)
          dipz=dipz+RasDip(k,3,j)
          dipx0=dipx0+RasCha(k,j)*outxyzRAS(j,1)
          dipy0=dipy0+RasCha(k,j)*outxyzRAS(j,2)
          dipz0=dipz0+RasCha(k,j)*outxyzRAS(j,3)
          quaxx=quaxx+RasQua(k,1,j)
          quaxy=quaxy+RasQua(k,2,j)
          quaxz=quaxz+RasQua(k,4,j)
          quayy=quayy+RasQua(k,3,j)
          quayz=quayz+RasQua(k,5,j)
          quazz=quazz+RasQua(k,6,j)
          quaDxx=quaDxx+RasDip(k,1,j)*(outxyzRAS(j,1)-CT(1))
          quaDxy=quaDxy+RasDip(k,1,j)*(outxyzRAS(j,2)-CT(2))
          quaDxz=quaDxz+RasDip(k,1,j)*(outxyzRAS(j,3)-CT(3))
          quaDyx=quaDyx+RasDip(k,2,j)*(outxyzRAS(j,1)-CT(1))
          quaDyy=quaDyy+RasDip(k,2,j)*(outxyzRAS(j,2)-CT(2))
          quaDyz=quaDyz+RasDip(k,2,j)*(outxyzRAS(j,3)-CT(3))
          quaDzx=quaDzx+RasDip(k,3,j)*(outxyzRAS(j,1)-CT(1))
          quaDzy=quaDzy+RasDip(k,3,j)*(outxyzRAS(j,2)-CT(2))
          quaDzz=quaDzz+RasDip(k,3,j)*(outxyzRAS(j,3)-CT(3))
          quaQxx=quaQxx+RasCha(k,j)*(outxyzRAS(j,1)-CT(1))
     &                             *(outxyzRAS(j,1)-CT(1))
          quaQxy=quaQxy+RasCha(k,j)*(outxyzRAS(j,1)-CT(1))
     &                             *(outxyzRAS(j,2)-CT(2))
          quaQxz=quaQxz+RasCha(k,j)*(outxyzRAS(j,1)-CT(1))
     &                             *(outxyzRAS(j,3)-CT(3))
          quaQyy=quaQyy+RasCha(k,j)*(outxyzRAS(j,2)-CT(2))
     &                             *(outxyzRAS(j,2)-CT(2))
          quaQyz=quaQyz+RasCha(k,j)*(outxyzRAS(j,2)-CT(2))
     &                             *(outxyzRAS(j,3)-CT(3))
          quaQzz=quaQzz+RasCha(k,j)*(outxyzRAS(j,3)-CT(3))
     &                             *(outxyzRAS(j,3)-CT(3))
27      Continue
        Do 28, kk=1,iQ_Atoms
          qtot=qtot+ChaNuc(kk)
          dTox=dTox+ChaNuc(kk)*outxyzRAS(kk,1)
          dToy=dToy+ChaNuc(kk)*outxyzRAS(kk,2)
          dToz=dToz+ChaNuc(kk)*outxyzRAS(kk,3)
          dQxx=dQxx+ChaNuc(kk)*(outxyzRAS(kk,1)-CT(1))
     &                        *(outxyzRAS(kk,1)-CT(1))
          dQxy=dQxy+ChaNuc(kk)*(outxyzRAS(kk,1)-CT(1))
     &                        *(outxyzRAS(kk,2)-CT(2))
          dQxz=dQxz+ChaNuc(kk)*(outxyzRAS(kk,1)-CT(1))
     &                        *(outxyzRAS(kk,3)-CT(3))
          dQyy=dQyy+ChaNuc(kk)*(outxyzRAS(kk,2)-CT(2))
     &                        *(outxyzRAS(kk,2)-CT(2))
          dQyz=dQyz+ChaNuc(kk)*(outxyzRAS(kk,2)-CT(2))
     &                        *(outxyzRAS(kk,3)-CT(3))
          dQzz=dQzz+ChaNuc(kk)*(outxyzRAS(kk,3)-CT(3))
     &                        *(outxyzRAS(kk,3)-CT(3))
28      Continue
*--- Observe! qTot is not just a check. It is used later as a sign
*             to see if QM-region is charged.
        qtot=qtot-qEl
        dTox=dTox-dipx-dipx0
        dToy=dToy-dipy-dipy0
        dToz=dToz-dipz-dipz0
        Trace1=dQxx+dQyy+dQzz
        Trace2=-quaDxx-quaDyy-quaDzz
        Trace3=-quaQxx-quaQyy-quaQzz
        Trace1=Trace1/3
        Trace2=2*Trace2/3
        Trace3=Trace3/3
        dQxx=1.5*(dQxx-2*quaDxx-quaQxx-Trace1-Trace2-Trace3)-quaxx
        dQyy=1.5*(dQyy-2*quaDyy-quaQyy-Trace1-Trace2-Trace3)-quayy
        dQzz=1.5*(dQzz-2*quaDzz-quaQzz-Trace1-Trace2-Trace3)-quazz
        dQxy=1.5*(dQxy-quaDxy-quaDyx-quaQxy)-quaxy
        dQxz=1.5*(dQxz-quaDxz-quaDzx-quaQxz)-quaxz
        dQyz=1.5*(dQyz-quaDyz-quaDzy-quaQyz)-quayz
        If(iPrint.ge.5) then
          Write(6,9001)'      State ',i,'  ',qtot,dTox,dToy,dToz,dQxx
     &                                      ,dQxy,dQxz,dQyy,dQyz,dQzz
        Endif
        If(.not.abs(qtot).le.0.0001) ChargedQM=.true.
26    Continue
*Jose This format has problems to print anions
*9001  Format(A,i2,A,F5.3,9(F12.8))
9001  Format(A,i2,A,F5.1,9(F12.8))
      Write(6,*)'     ...Done!'

*----------------------------------------------------------------------*
* The end has come.                                                    *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1999, Jeppe Olsen                                 *
!***********************************************************************

subroutine SBLOCKS(NSBLOCK,ISBLOCK,CB,SB,C2,ICOCOC,ICSM,NSSOA,NSSOB,NAEL,IAGRP,NBEL,IBGRP,IOCTPA,IOCTPB,NOCTPA,NOCTPB,NSMST,NSMOB, &
                   NOBPTS,MXPNGAS,MAXK,MAXI,XINT,CSCR,SSCR,NGAS,NELFSPGP,IDC,I1,XI1S,I2,XI2S,IDOH2,ISTRFL,PS,LUC,ICJKAIB,CJRES, &
                   SIRES,I3,XI3S,I4,XI4S,MOCAA,LCBLOCK,LECBLOCK,I1CBLOCK,ICBLOCK,IRESTRICT,ICONSPA,ICONSPB,SCLFAC,IH0SPC, &
                   ICBAT_RES,ICBAT_INI,ICBAT_END,IPHGAS,I_RES_AB)
! SUBROUTINE SBLOCKS --> 91
!
! Direct RAS routine employing combined MOC/n-1 resolution method
!
! Jeppe Olsen, Winter of 1991
!              Last modification : April 99
!
! =====
! Input
! =====
!
! NSBLOCK : Number of BLOCKS included
! ISBLOCK : Blocks included
!   ISBLOCK(1,*) : alpha type of block
!   ISBLOCK(2,*) : beta type of block
!   ISBLOCK(3,*) : sym of alpha in block
!   ISBLOCK(4,*) : Offset of block
!
! ICOCOC : Allowed type combinations for C
! ICSM   : Symmetry for C
! NACOB  : Number of active orbitals
! NSSOA  : Number of strings per type and symmetry for alpha strings
! NAEL   : Number of active alpha electrons
! NSSOB  : Number of strings per type and symmetry for beta strings
! NBEL   : Number of active beta electrons
! NTSOB  : Number of orbitals per type and symmetry
! NOBPTS : Orbitals of given type and symmetry
!
! MAXIJ  : Largest allowed number of orbital pairs treated simultaneously
! MAXK   : Largest number of N-2,N-1 strings treated simultaneously
! MAXI   : Max number of N strings treated simultaneously
!
! LI     : Length of scratch array for integrals
! LS     : Length of scratch array for S
! XINT   : Scratch array for integrals
! CSCR   : Scratch array for C vector
! SSCR   : Scratch array for S vector
!
! ICJKAIB = 1 => construct C(Ka,Jb,j) and S(Ka,IB,i) as intermediate terms
!         = 0 => do not construct the above montioned matrices
! CJRES,SIRES : Space for above matrices
! The C and S vectors are accessed through routines that
! either fetches/disposes symmetry blocks or
! Symmetry-occupation-occupation blocks
!
! If IRESTRICT /= 0 THEN we are after :
! sigma(iblk) = summa(jblk <= iblk) (2-delta(iblk,jblk))/2
!                                                 * <Iblk!H!Jblk>C(Jblk)

use lucia_data, only: IDISK
use spinfo, only: DOBKAP
#ifdef _DEBUGPRINT_
use spinfo, only: NGASBK, IOCCPSPC
#endif
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NSBLOCK, ISBLOCK(8,*), NOCTPA, NOCTPB, ICOCOC(NOCTPA,NOCTPB), NSMST, ICSM, NSSOA(NSMST,*), &
                                 NSSOB(NSMST,*), NAEL, IAGRP, NBEL, IBGRP, NSMOB, MXPNGAS, NOBPTS(MXPNGAS,*), MAXK, MAXI, NGAS, &
                                 NELFSPGP(MXPNGAS,*), IDC, IDOH2, ISTRFL(*), LUC, ICJKAIB, MOCAA, IRESTRICT, &
                                 ICONSPA(NOCTPA,NOCTPA), ICONSPB(NOCTPB,NOCTPB), IH0SPC(NOCTPA,NOCTPB), ICBAT_RES, ICBAT_INI, &
                                 ICBAT_END, IPHGAS(*), I_RES_AB
real(kind=wp), intent(inout) :: CB(*), SB(*), XI1S(*), XI2S(*), XI3S(*), XI4S(*)
real(kind=wp), intent(_OUT_) :: C2(*), XINT(*), CSCR(*), SSCR(*), CJRES(*), SIRES(*), SCLFAC(*)
integer(kind=iwp), intent(out) :: IOCTPA, IOCTPB
integer(kind=iwp), intent(inout) :: I1(*), I2(*), I3(*), I4(*)
real(kind=wp), intent(in) :: PS
integer(kind=iwp), intent(_OUT_) :: LCBLOCK(*), LECBLOCK(*), I1CBLOCK(*), ICBLOCK(8,*)
integer(kind=iwp) :: I_DO_EXACT_BLK, IASM, IATP, IBSM, IBTP, ICBLK, ICOFF, ICOOSC(1), iDUMMY(1), INTERACT, IOFF, IPERM, IPTSPC, &
                     ISBLK, ISCALE, ISOFF, JASM, JATP, JBLOCK, JBSM, JBTP, JCBAT_END, JCBAT_INI, JCBATCH, JJCBLOCK, JOFF, JPTSPC, &
                     JSBLOCK, LASM(4), LATP(4), LBL, LBSM(4), LBTP(4), LLASM, LLATP, LLBSM, LLBTP, LSGN(5), LTRP(5), MXEXC, NASTR, &
                     NBSTR, NCBATCH, NIA, NIB, NJA, NJB, NJBLOCK, NLLA, NLLB, NPERM
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IBLOCK, IGAS, II
#endif
real(kind=wp) :: C(1), FACTOR, PL, XFAC
! IH_OCC_CONS = 1 implies that we should employ occupation conserving part of Hamiltonian
integer(kind=iwp), parameter :: IH_OCC_CONS = 0

#ifdef _DEBUGPRINT_
write(u6,*) ' ================='
write(u6,*) ' SBLOCKS speaking :'
write(u6,*) ' ================='
write(u6,*)
write(u6,*) ' Number of sigma blocks to be calculated ',NSBLOCK
write(u6,*) ' TTSS for each ACTIVE sigma block'
do IBLOCK=1,NSBLOCK
  if (ISBLOCK(1,IBLOCK) > 0) write(u6,'(10X,4I3,2I8)') (ISBLOCK(II,IBLOCK),II=1,4)
end do
write(u6,*) ' IDC PS',IDC,PS
write(u6,*) ' IDOH2 = ',IDOH2
write(u6,*) ' I_RES_AB=',I_RES_AB
if (DoBKAP) then
  write(u6,*) ' I am doing BK-type of approximation'
  write(u6,*) ' It is based on orbital splitting'
  write(u6,*) ' Min and Max for subspace with exact Hamiltonian'
  write(u6,*) ' ==============================================='
  write(u6,*) 'NGASBK : ',NGASBK
  write(u6,*) '              Min. Occ.      Max. Occ.'
  do IGAS=1,NGASBK
    write(u6,'(A,I2,10X,I3,9X,I3)') '   GAS',IGAS,IOCCPSPC(IGAS,1),IOCCPSPC(IGAS,2)
  end do
end if

write(u6,*) ' Initial C vector'
call WRTVCD(CB,LUC,1,-1)
#endif
! ==========================
! 1 : Arrays for accessing C
! ==========================
! Find batches of C - strings
call PART_CIV2(IDC,NSSOA,NSSOB,NOCTPA,NOCTPB,NSMST,ICOCOC,ICSM,NCBATCH,LCBLOCK,LECBLOCK,I1CBLOCK,ICBLOCK,0)
! Find the active blocks on LUC, store info in SCLFAC
call FIND_ACTIVE_BLOCKS(LUC,-1,SCLFAC,CB)

! Initialize sigma blocks
do JSBLOCK=1,NSBLOCK
  IATP = ISBLOCK(1,JSBLOCK)
  IBTP = ISBLOCK(2,JSBLOCK)
  IASM = ISBLOCK(3,JSBLOCK)
  IBSM = ISBLOCK(4,JSBLOCK)
  IOFF = ISBLOCK(5,JSBLOCK)
  NASTR = NSSOA(IASM,IATP)
  NBSTR = NSSOB(IBSM,IBTP)
  if (ISBLOCK(1,JSBLOCK) > 0) SB(IOFF:IOFF+NASTR*NBSTR-1) = Zero
end do
! Loop over batches over C blocks
if (IDOH2 == 1) then
  MXEXC = 2
else
  MXEXC = 1
end if
IDISK(LUC) = 0
if (ICBAT_RES == 1) then
  write(u6,*) ' Restricted set of C batches'
  write(u6,*) ' ICBAT_INI ICBAT_END',ICBAT_INI,ICBAT_END
  JCBAT_INI = ICBAT_INI
  JCBAT_END = ICBAT_END
else
  JCBAT_INI = 1
  JCBAT_END = NCBATCH
end if

JOFF = 0 ! jwk-cleanup
do JCBATCH=JCBAT_INI,JCBAT_END

  ! Read C blocks into core

  ICOFF = 1
  NJBLOCK = LCBLOCK(JCBATCH)
  do JJCBLOCK=1,NJBLOCK
    JBLOCK = I1CBLOCK(JCBATCH)-1+JJCBLOCK
    ! Will this block be needed ??
    INTERACT = 0
    if (SCLFAC(JBLOCK) == One) then
      JATP = ICBLOCK(1,JBLOCK)
      JBTP = ICBLOCK(2,JBLOCK)
      JASM = ICBLOCK(3,JBLOCK)
      JBSM = ICBLOCK(4,JBLOCK)
      JOFF = ICBLOCK(5,JBLOCK)
      PL = One
      call PRMBLK(IDC,ISTRFL,JASM,JBSM,JATP,JBTP,PS,PL,LATP,LBTP,LASM,LBSM,LSGN,LTRP,NPERM)
      do IPERM=1,NPERM
        LLASM = LASM(IPERM)
        LLBSM = LBSM(IPERM)
        LLATP = LATP(IPERM)
        LLBTP = LBTP(IPERM)
        ! Loop over Sigma blocks in batch
        do JSBLOCK=1,NSBLOCK
          if (ISBLOCK(1,JSBLOCK) > 0) then
            IATP = ISBLOCK(1,JSBLOCK)
            IBTP = ISBLOCK(2,JSBLOCK)
            IASM = ISBLOCK(3,JSBLOCK)
            IBSM = ISBLOCK(4,JSBLOCK)
            ! Are the two blocks connected by allowed excitation
            call CON_BLOCKS(IATP,IBTP,LLATP,LLBTP,IASM,IBSM,LLASM,LLBSM,ICONSPA,ICONSPB,NOCTPA,NOCTPB,MXEXC,IH_OCC_CONS,INTERACT)

          end if
        end do
      end do
      ! End of checking whether C-block is needed
    end if
    ! Checking was only done for nonvanishing blocks

    ISCALE = 0
    if (INTERACT == 1) then
      call GSTTBL(C,CB(JOFF),JATP,JASM,JBTP,JBSM,NOCTPA,NOCTPB,NSSOA,NSSOB,PS,ICOOSC,IDC,PL,LUC,C2,NSMST,ISCALE,SCLFAC(JBLOCK))
      ! Note in GSTTBL : ICOOSC only used for CI vectors in core,
    else
      ! not relevant
      call IDAFILE(LUC,2,iDUMMY,1,IDISK(LUC))
      LBL = iDUMMY(1)
      call IDAFILE(LUC,2,iDUMMY,1,IDISK(LUC))
      call SKPRCD2(LBL,-1,LUC)
      SCLFAC(JBLOCK) = Zero
    end if

#   ifdef _DEBUGPRINT_
    if (INTERACT == 1) then
      write(u6,*) ' TTSS for C block read in'
      call IWRTMA(ICBLOCK(1,JBLOCK),4,1,4,1)
    else
      write(u6,*) ' TTSS for C block skipped'
      call IWRTMA(ICBLOCK(1,JBLOCK),4,1,4,1)
    end if
#   endif

  end do
  ! End of loop over Blocks

  ! Loop over blocks of sigma and C in core and obtain  contribution from
  ! given C block to given S block
  ! Loop over C blocks
  do ICBLK=I1CBLOCK(JCBATCH),I1CBLOCK(JCBATCH)-1+NJBLOCK
    JATP = ICBLOCK(1,ICBLK)
    JBTP = ICBLOCK(2,ICBLK)
    JASM = ICBLOCK(3,ICBLK)
    JBSM = ICBLOCK(4,ICBLK)
    ICOFF = ICBLOCK(5,ICBLK)
    NJA = NSSOA(JASM,JATP)
    NJB = NSSOB(JBSM,JBTP)

    if (SCLFAC(ICBLK) /= Zero) then
      ! Other symmetry blocks that can be obtained from this block
      call PRMBLK(IDC,ISTRFL,JASM,JBSM,JATP,JBTP,PS,PL,LATP,LBTP,LASM,LBSM,LSGN,LTRP,NPERM)
      ! Start with transposed block
      do IPERM=NPERM,1,-1
        LLASM = LASM(IPERM)
        LLBSM = LBSM(IPERM)
        LLATP = LATP(IPERM)
        LLBTP = LBTP(IPERM)
        NLLA = NSSOA(LLASM,LLATP)
        NLLB = NSSOB(LLBSM,LLBTP)
        ! The routines assumes on input that the blocks are transposed, so,
        ! Initial tour, IPERM = 1 corresponds always to no transpose, so transpose!
        if (IPERM == 1) then
          if ((IDC == 2) .and. (JATP == JBTP) .and. (JASM == JBSM)) then
            ! Diagonal blocks, Transposing corresponds to scaling
            if (PS == -One) CB(ICOFF:ICOFF+NJA*NJB-1) = -CB(ICOFF:ICOFF+NJA*NJB-1)
          else
            ! off-diagonal blocks, explicit transposing
            call TRPMT3(CB(ICOFF),NJA,NJB,C2)
            CB(ICOFF:ICOFF+NJA*NJB-1) = C2(1:NJA*NJB)
          end if
        end if

        do ISBLK=1,NSBLOCK
          if (ISBLOCK(1,ISBLK) <= 0) cycle
          IATP = ISBLOCK(1,ISBLK)
          IBTP = ISBLOCK(2,ISBLK)
          IASM = ISBLOCK(3,ISBLK)
          IBSM = ISBLOCK(4,ISBLK)
          ISOFF = ISBLOCK(5,ISBLK)
          NIA = NSSOA(IASM,IATP)
          NIB = NSSOB(IBSM,IBTP)

          if (NIA*NIB == 0) cycle
          if ((IRESTRICT == 1) .and. &
              ((JASM > IASM) .or. (JASM == IASM) .and. (JATP > IATP) .or. (JASM == IASM) .and. (JATP == IATP) .and. &
               (JBTP > IBTP))) cycle
          ! Are the two blocks connected by allowed excitation
          call CON_BLOCKS(IATP,IBTP,LLATP,LLBTP,IASM,IBSM,LLASM,LLBSM,ICONSPA,ICONSPB,NOCTPA,NOCTPB,MXEXC,IH_OCC_CONS,INTERACT)

          ! IF BK approximation is active, check whether block should
          ! be calculated exactly (1), by diagonal (-1) or is set to zero (0).
          I_DO_EXACT_BLK = 1
          if (DoBKAP) call CHECK_BLOCKS_FOR_BK_APPROX(IATP,IBTP,LLATP,LLBTP,IASM,IBSM,LLASM,LLBSM,IOCTPA,IOCTPB,I_DO_EXACT_BLK)
          ! BK-like approximation stuff
          if ((INTERACT == 0) .or. (I_DO_EXACT_BLK == 0)) cycle

#         ifdef _DEBUGPRINT_
          write(u6,*) ' Next s block in batch :'
          write(u6,*) ' ISBLK IASM IBSM IATP IBTP'
          write(u6,'(5I5)') ISBLK,IASM,IBSM,IATP,IBTP
#         endif

          if ((IDC == 2) .and. (IASM == IBSM) .and. (IATP == IBTP) .and. &
              ((LLBSM > LLASM) .or. (LLASM == LLBSM) .and. (LLBTP > LLATP))) cycle

#         ifdef _DEBUGPRINT_
          write(u6,*) ' RSSBCB will be called for'
          write(u6,*) ' Sigma block :'
          write(u6,*) ' ISOFF ',ISOFF
          write(u6,*) ' ISBLK IASM IBSM IATP IBTP'
          write(u6,'(5I5)') ISBLK,IASM,IBSM,IATP,IBTP
          write(u6,*) ' C     block :'
          write(u6,*) ' ICBLK LLASM LLBSM LLATP LLBTP'
          write(u6,'(5I5)') ICBLK,LLASM,LLBSM,LLATP,LLBTP
          write(u6,*) ' ICOFF ',ICOFF
          write(u6,*) ' Overall scale',SCLFAC(ICBLK)
#         endif

          if ((IRESTRICT == 1) .and. &
              (((IASM == LLASM) .and. (IBSM == LLBSM) .and. (IATP == LLATP) .and. (IBTP == LLBTP)) .or. &
               ((IDC == 2) .and. (IASM == LLBSM) .and. (IBSM == LLASM) .and. (IATP == LLBTP) .and. (IBTP == LLATP)))) then
            XFAC = Half*SCLFAC(ICBLK)
          else
            XFAC = SCLFAC(ICBLK)
          end if
          ! Form of operator in action
          !if (IPERTOP /= 0) then
          ! Not exact Hamiltonian in use
          IPTSPC = IH0SPC(IATP,IBTP)
          JPTSPC = IH0SPC(JATP,JBTP)

          if (IPTSPC /= JPTSPC) cycle
          ! BK-like approximation stuff
          if (I_DO_EXACT_BLK == 1) then
            call RSSBCB2(IASM,IATP,IBSM,IBTP,LLASM,LLATP,LLBSM,LLBTP,NGAS,NELFSPGP(:,IATP+IOCTPA-1),NELFSPGP(:,IBTP+IOCTPB-1), &
                         NELFSPGP(:,LLATP+IOCTPA-1),NELFSPGP(:,LLBTP+IOCTPB-1),NAEL,NBEL,IAGRP,IBGRP,SB(ISOFF),CB(ICOFF),IDOH2, &
                         NOBPTS,MAXI,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,XINT,C2,NSMOB,NSMST,NIA,NIB,NLLA,NLLB,IDC,CJRES,SIRES,I3,XI3S, &
                         I4,XI4S,MOCAA,XFAC,IPHGAS,I_RES_AB)
          else if (I_DO_EXACT_BLK == -1) then
            ! Giovanni.... transposing sigma and CI vectors:
            call TRPMT3(SB(ISOFF),NIB,NIA,C2)
            SB(ISOFF:ISOFF+NIA*NIB-1) = C2(1:NIA*NIB)
            call TRPMT3(CB(ICOFF),NLLB,NLLA,C2)
            CB(ICOFF:ICOFF+NLLA*NLLB-1) = C2(1:NLLA*NLLB)
            FACTOR = Zero
            call ADDDIA_TERM(FACTOR,CB(ICOFF),SB(ISOFF),IATP,IBTP,IASM,IBSM)
            ! Giovanni.... transposing back sigma and CI vectors:
            call TRPMT3(SB(ISOFF),NIA,NIB,C2)
            SB(ISOFF:ISOFF+NIA*NIB-1) = C2(1:NIA*NIB)
            call TRPMT3(CB(ICOFF),NLLA,NLLB,C2)
            CB(ICOFF:ICOFF+NLLA*NLLB-1) = C2(1:NLLA*NLLB)
          end if ! End BK stuff
          ! CALL RSSBCB2 --> 82
        end do
        ! End of loop over sigma blocks
      end do
    end if
    ! End of C-block is nonvanishing
  end do
  ! End of loop over C blocks in Batch
end do
! End of loop over batches of C blocks

! Order
do ISBLK=1,NSBLOCK
  if (ISBLOCK(1,ISBLK) > 0) then
    IATP = ISBLOCK(1,ISBLK)
    IBTP = ISBLOCK(2,ISBLK)
    IASM = ISBLOCK(3,ISBLK)
    IBSM = ISBLOCK(4,ISBLK)
    ISOFF = ISBLOCK(5,ISBLK)
    NIA = NSSOA(IASM,IATP)
    NIB = NSSOB(IBSM,IBTP)
    if (ICJKAIB /= 0) then
      ! Tranpose sigma block was obtained, transpose to obtain correct block
      call TRPMT3(SB(ISOFF),NSSOB(IBSM,IBTP),NSSOA(IASM,IATP),C2)
      SB(ISOFF:ISOFF+NSSOA(IASM,IATP)*NSSOB(IBSM,IBTP)-1) = C2(1:NSSOA(IASM,IATP)*NSSOB(IBSM,IBTP))
    end if
    if ((IDC == 2) .and. (IASM == IBSM) .and. (IATP == IBTP)) call TRPAD3(SB(ISOFF),PS,NSSOA(IASM,IATP))

  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' output blocks from SBLOCKS'
call WRTTTS(SB,ISBLOCK,NSBLOCK,NSMST,NSSOA,NSSOB,1)
#endif

end subroutine SBLOCKS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! complex number in runfile
subroutine Put_zArray(Label,zData,nData)

use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: nData
complex(kind=wp), intent(in) :: zData(nData)

call Put_dArray('R'//Label,real(zData),nData)
call Put_dArray('I'//Label,aimag(zData),nData)

return

end subroutine Put_zArray

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Union(iU,nU,iV,nV,iR,iM,nM)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nU, iU(nU), nV, iV(nV), iR
integer(kind=iwp), intent(out) :: iM(8), nM
integer(kind=iwp) :: i, iRV
logical(kind=iwp), external :: RinT

! M is formed as U union RU

iM(1:nU) = iU(:) ! copy the first elements
nM = nU
do i=1,nV
  iRV = ieor(iR,iV(i))
  if (.not. RinT(iM,nM,iRV)) then
    nM = nM+1
    iM(nM) = iRV
  end if
end do

return

end subroutine Union

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine Screen_g(PAO,Scrtch,mPAO,
     &                    nZeta,nEta,mZeta,mEta,lZeta,lEta,
     &                    Zeta,ZInv,P,xA,xB,Data1,nAlpha,nBeta,IndZ,
     &                    Eta, EInv,Q,xG,xD,Data2,nGamma,nDelta,IndE,
     &                    iphX1,iphY1,iphZ1,iphX2,iphY2,iphZ2,CutGrd,
     &                    l2DI,ab,abg,nab,cd,cdg,ncd,PreScr,nScrtch,
     &                    IsChi,ChiI2)
************************************************************************
*                                                                      *
* Object: to prescreen the integral derivatives.                       *
*                                                                      *
*   nZeta, nEta : unpartioned length of primitives.                    *
*                                                                      *
*   mZeta, mEta : section length due to partioning. These are usually  *
*                 equal to nZeta and nEta.                             *
*                                                                      *
*   lZeta, lEta : section length after prescreening.                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             March '92                                                *
*             April '92 modified for gradient estimate                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
#include "print.fh"
#include "real.fh"
      Real*8 PAO(mZeta*mEta*mPAO),Scrtch(nScrtch),
     &       Zeta(nZeta), ZInv(nZeta), P(nZeta,3),
     &        Eta(nEta),  EInv(nEta),  Q(nEta, 3),
     &       xA(nZeta), xB(nZeta), xG(nEta), xD(nEta),
     &       Data1(nZeta*(nDArray-1)), Data2(nEta*(nDArray-1)),
     &       ab(nZeta,nab), abg(nZeta,nab),
     &       cd(nEta ,ncd), cdg(nEta ,ncd),
     &       ChiI2
      Logical l2DI, PreScr, ZPreScr, EPreScr
      Integer IndZ(mZeta), IndE(mEta), IsChi
*
      iRout = 180
      iPrint = nPrint(iRout)
      LOut=6
      If (iPrint.ge.99) Then
         Call RecPrt(' Data1',' ',Data1,nZeta,nDArray-1)
         Call RecPrt(' Data2',' ',Data2,nEta ,nDArray-1)
         If (l2DI) Then
            Call RecPrt(' ab   ',' ',ab,nZeta,nab)
            Call RecPrt(' cd   ',' ',cd ,nEta ,ncd)
            Call RecPrt(' abg  ',' ',abg,nZeta,nab)
            Call RecPrt(' cdg  ',' ',cdg,nEta ,ncd)
         End If
         Call RecPrt('2nd order density matrix',' ',
     &               PAO,mZeta*mEta,mPAO)
      End If
      If (PreScr.and..Not.l2DI) Then
         Write (LOut,*) ' Screen: .Not.l2DI no activated',
     &      '  prescr=',prescr,'  l2di=',l2di
         Call Abend()
      End If
*
      Cut2=CutGrd
      lZeta=0
      lEta =0
      tOne = One
      ip=1
*
*-----Compute the prefactor. There are
*     four sections of code here which will take care of the
*     different cases of triangularization.
*
      ipFac = ip
      ip = ip + mZeta*mEta
      ij = ipFac-1
      Do iEta = 1, mEta
         Et   = Data2(ip_Z    (iEta,nEta))
         rKCD = Data2(ip_Kappa(iEta,nEta))
         Do iZeta = 1, mZeta
            Zt   = Data1(ip_Z    (iZeta,nZeta))
            rKAB = Data1(ip_Kappa(iZeta,nZeta))
            ij = ij + 1
            if (IsChi.eq.1) then
               Scrtch(ij)=rKAB*rKCD*
     &                    Sqrt(tOne/(Zt+Et+(Zt*Et*ChiI2)*Dble(IsChi)))
            else
               Scrtch(ij) = rKAB*rKCD*Sqrt(tOne/(Zt+Et))
            endif
         End Do
      End Do
      If (iPrint.ge.99) Call RecPrt(' Collected prefactors',' ',
     &                               Scrtch(ipFac),mZeta,mEta)
*
*-----Modify the 2nd order density matrix with the prefactor.
*
      ipPAO = ip
      ip = ip + mZeta*mEta*mPAO
      ipOAP = ip
      ip = ip + mZeta*mEta*mPAO
      jPAO = 1
      Do iPAO = 1, mPAO
         Do iZE = 0, mZeta*mEta-1
            PAO(jPAO+iZE)=Scrtch(ipFac+iZE)*PAO(jPAO+iZE)
         End Do
         jPAO = jPAO + mZeta*mEta
      End Do
      If (iPrint.ge.49)
     &   Call RecPrt(' Modified 2nd order density matrix',' ',
     &               PAO,mZeta*mEta,mPAO)
*
*-----Scan the modified 2nd order density matrix for the
*     largest absolute value.
*
      vMax = DNrm2_(mZeta*mEta*mPAO,PAO,1)
*-----Skip prescreening if too low.
      If (PreScr.and.Abs(vMax).lt.0.5D-4*CutGrd) Then
         lZeta = 0
         lEta  = 0
         Go To 999
      End If
*
*-----Assemble gradient estimate
*-----Multiply modified density matrix with the gradient
*     estimate.
*-----Compress all indices except zeta in ipZ
*-----Compress all indices except eta in ipE
*
      If (PreScr) Then
*
         ipZ = ip
         ip = ip + mZeta
         ipE = ip
         ip = ip + mEta
         Do i=1,mZeta+mEta
           Scrtch(ipZ+i-1)=Zero
         End Do
         Do icd = 1, ncd
            Do iEta = 1, mEta
               alpha = cd (iEta,icd)
               beta  = cdg(iEta,icd)
               iZE = (iEta-1)*mZeta
               Do iab = 1, nab
                  iabcd = (icd-1)*nab + iab
                  iOff = (iabcd-1)*mZeta*mEta+iZE
                  Do iZeta = 1, mZeta
                     temp=(alpha*abg(iZeta,iab)+beta*ab(iZeta,iab))*
     &                    PAO(iZeta+iOff)
                        Scrtch(ipZ+iZeta-1)=Scrtch(ipZ+iZeta-1)
     &                                     +Abs(temp)
                        Scrtch(ipE+iEta -1)=Scrtch(ipE+iEta -1)
     &                                     +Abs(temp)
                  End Do
               End Do
            End Do
         End Do
      Else
         ipZ = 1
         ipE = 1
      End If
*
      If (ip-1.gt.nScrtch) Then
         Write (LOut,*) ' Screen: ip-1.gt.nScrtch'
         Write (LOut,*) 'ip-1=',ip-1
         Write (LOut,*) 'nScrtch=',nScrtch
         Call Abend()
      End If
*
      rEta=DBLE(nEta*mPAO)
      qEta=DBLE(mEta*mPAO)
      rqEta=rEta/qEta
      ZPreScr=PreScr
      If (PreScr) Then
         iMin=iDMin(mZeta,Scrtch(ipZ),1)
         zMin=Scrtch(ipZ-1+iMin)
         If (zMin.ge.Cut2/rqEta) Then
            ZPreScr=.False.
         End If
         If (iPrint.ge.99) Call RecPrt(' Screening array(Eta)',' ',
     &                     Scrtch(ipZ),mZeta,1)
      End If
*
      rZeta=DBLE(nZeta*mPAO)
      qZeta=DBLE(mZeta*mPAO)
      rqZeta=rZeta/qZeta
      EPreScr=PreScr
      If (PreScr) Then
         iMin=iDMin(mEta,Scrtch(ipE),1)
         eMin=Abs(Scrtch(ipE-1+iMin))
         If (eMin.ge.Cut2/rqZeta) Then
            EPreScr=.False.
         End If
         If (iPrint.ge.99) Call RecPrt(' Screening array(Zeta)',' ',
     &                     Scrtch(ipE),mEta,1)
      End If
*
*-----Prescreen Zeta
*
      Px = One
      Py = One
      Pz = One
      If (iphX1.ne.1) Px = -Px
      If (iphY1.ne.1) Py = -Py
      If (iphZ1.ne.1) Pz = -Pz
      lZeta=0
      If (ZPreScr) Then
         Do iZeta = 1, mZeta
            If (Scrtch(ipZ+iZeta-1).ge.Cut2/rqEta) Then
               lZeta=lZeta+1
               Zeta(lZeta)  = Data1(ip_Z    (iZeta,nZeta))
               P(lZeta,1)   = Data1(ip_PCoor(iZeta        ,nZeta))*Px
               P(lZeta,2)   = Data1(ip_PCoor(iZeta+  nZeta,nZeta))*Py
               P(lZeta,3)   = Data1(ip_PCoor(iZeta+2*nZeta,nZeta))*Pz
               xA(lZeta)    = Data1(ip_Alpha(iZeta,nZeta,1))
               xB(lZeta)    = Data1(ip_Beta (iZeta,nZeta,2))
               ZInv(lZeta)  = Data1(ip_ZInv (iZeta,nZeta))
               ip2 = ipOAP + mEta*mPAO*(lZeta-1) - 1
               Do iEP = 1, mEta*mPAO
                  Scrtch(ip2+iEP)=PAO((iEP-1)*mZeta+iZeta)
               End Do
            End If
         End Do
      Else
         Do iZeta = 1, mZeta
            lZeta=lZeta+1
            Zeta(lZeta)  = Data1(ip_Z    (iZeta,nZeta))
            P(lZeta,1)   = Data1(ip_PCoor(iZeta        ,nZeta))*Px
            P(lZeta,2)   = Data1(ip_PCoor(iZeta+  nZeta,nZeta))*Py
            P(lZeta,3)   = Data1(ip_PCoor(iZeta+2*nZeta,nZeta))*Pz
            xA(lZeta)    = Data1(ip_Alpha(iZeta,nZeta,1))
            xB(lZeta)    = Data1(ip_Beta (iZeta,nZeta,2))
            ZInv(lZeta)  = Data1(ip_ZInv (iZeta,nZeta))
         End Do
         If (EPreScr) Call DGeTMO(PAO,mZeta,mZeta,mEta*mPAO,
     &                     Scrtch(ipOAP),mEta*mPAO)
      End If
      If (lZeta.eq.0) Go To 999
*
*
*-----Prescreen Eta
*
      Qx = One
      Qy = One
      Qz = One
      If (iphX2.ne.1) Qx = -Qx
      If (iphY2.ne.1) Qy = -Qy
      If (iphZ2.ne.1) Qz = -Qz
      lEta=0
      If (EPreScr) Then
         Do iEta = 1, mEta
            If (Scrtch(ipE+iEta-1).ge.Cut2/rqZeta) Then
               lEta=lEta+1
               Eta(lEta)   = Data2(ip_Z   (iEta,nEta))
               Q(lEta,1)   = Data2(ip_PCoor(iEta       ,nEta))*Qx
               Q(lEta,2)   = Data2(ip_PCoor(iEta+  nEta,nEta))*Qy
               Q(lEta,3)   = Data2(ip_PCoor(iEta+2*nEta,nEta))*Qz
               xG(lEta)    = Data2(ip_Alpha(iEta,nEta,1))
               xD(lEta)    = Data2(ip_Beta (iEta,nEta,2))
               EInv(lEta)  = Data2(ip_ZInv (iEta,nEta))
               ip1 = ipOAP + iEta-1
               ip2 = ipPAO + (lEta-1)*mPAO*lZeta-1
               Do jPZ =1,mPAO*lZeta
                  Scrtch(ip2+jPZ)=Scrtch((jPZ-1)*mEta+ip1)
               End Do
            End If
         End Do
         ipP = ipPAO
         l1=mPAO
         l2=lZeta*lEta
      Else
         Do iEta = 1, mEta
            lEta=lEta+1
            Eta(lEta)   = Data2(ip_Z   (iEta,nEta))
            Q(lEta,1)   = Data2(ip_PCoor(iEta       ,nEta))*Qx
            Q(lEta,2)   = Data2(ip_PCoor(iEta+  nEta,nEta))*Qy
            Q(lEta,3)   = Data2(ip_PCoor(iEta+2*nEta,nEta))*Qz
            xG(lEta)    = Data2(ip_Alpha(iEta,nEta,1))
            xD(lEta)    = Data2(ip_Beta (iEta,nEta,2))
            EInv(lEta)  = Data2(ip_ZInv (iEta,nEta))
         End Do
         ipP = ipOAP
         l1=lEta*mPAO
         l2=lZeta
      End If
      If (lEta.eq.0) Go To 999
*
*---- Pick up the screened two-particle density.
*     .Not.PreScr            : density is already in PAO
*
*     Transpose mPAO,zeta,eta to zeta,eta,mPAO   or
*               eta,mPAO,zeta to zeta,eta,mPAO
*
      If (PreScr) Then
         If (ZPreScr.or.EPreScr) Then
            Call DGeTMO(Scrtch(ipP),l1,l1,l2,PAO,l2)
         End If
      End If
*
 999  Continue
      If (iPrint.ge.39) Call RecPrt(' PAO',' ',
     &                              PAO,lZeta*lEta,mPAO)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(IndZ)
         Call Unused_integer_array(IndE)
         Call Unused_integer(nAlpha)
         Call Unused_integer(nBeta)
         Call Unused_integer(nGamma)
         Call Unused_integer(nDelta)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Francesco Aquilante                              *
!***********************************************************************

subroutine DrvEMB_(nh1,KSDFT,Do_Grad,Grad,nGrad,DFTFOCK)
!***********************************************************************
!***********************************************************************
!** Orbital-Free Embedding calculation (gradients)                   ***
!**                                                                  ***
!**                                                                  ***
!** Author: F. Aquilante, Geneva Nov  2010                           ***
!**                                                                  ***
!***********************************************************************
!***********************************************************************

use OFembed, only: Xsigma, dFMD
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nh1, nGrad
character(len=*), intent(inout) :: KSDFT
logical(kind=iwp), intent(in) :: Do_Grad
real(kind=wp), intent(out) :: Grad(nGrad)
character(len=4), intent(in) :: DFTFOCK
#include "debug.fh"
integer(kind=iwp) :: i, iSpin, kSpin, nD, nFckDim
real(kind=wp) :: d_Alpha, d_Beta, DSpn, DTot, Energy_NAD, Fakt_, Func_A, Func_AB, Func_B, Func_X
character(len=16) :: NamRfil
real(kind=wp), allocatable :: Grad_A(:), F_DFT(:,:), D_DS(:,:), Fcorr(:,:)
real(kind=wp), external :: Xlambda

Debug = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. Do_Grad) then
  call WarningMessage(2,'DrvEMB_: Do_Grad must be .true.')
  call Abend()
end if
Grad(:) = Zero
call mma_allocate(Grad_A,nGrad,Label='Grad_A')
Grad_A(:) = Zero
!***********************************************************************
!                                                                      *
!     Setup of density matrices for subsys B (environment)             *
!                                                                      *
!***********************************************************************
call Get_NameRun(NamRfil) ! save the old RUNFILE name
call NameRun('AUXRFIL')   ! switch RUNFILE name
!                                                                      *
!***********************************************************************
!                                                                      *
nD = 4
call mma_allocate(F_DFT,nh1,nD,Label='F_DFT')
call mma_allocate(D_DS,nh1,nD,Label='D_DS')

! Get the density matrix of the environment (rho_B)

call Get_iScalar('Multiplicity',kSpin)
call Get_D1ao(D_DS(1,1),nh1)
!call RecPrt('D_DS(1,1)',' ',D_DS(1,1),nh1,1)

! Get the spin density matrix of the environment

if (kSpin /= 1) then
  call Get_D1Sao(D_DS(1,2),nh1)
  !call RecPrt('D1Sao',' ',D_DS(1,2),nh1,1)
end if

! Compute alpha and beta density matrices of the environment

nFckDim = 2
if (kSpin == 1) then
  D_DS(:,1) = Half*D_DS(:,1)
  D_DS(:,2) = D_DS(:,1)
  nFckDim = 1
else
  do i=1,nh1
    DTot = D_DS(i,1)
    DSpn = D_DS(i,2)
    d_Alpha = Half*(DTot+DSpn)
    d_Beta = Half*(DTot-DSpn)
    D_DS(i,1) = d_Alpha
    D_DS(i,2) = d_Beta
  end do
  !call RecPrt('Da',' ',D_DS(1,1),nh1,1)
  !call RecPrt('Db',' ',D_DS(1,2),nh1,1)
end if

if (KSDFT(1:4) == 'NDSD') then

  call wrap_DrvNQ(KSDFT,F_DFT,nFckDim,Func_B,D_DS,nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK)

  KSDFT(1:4) = 'LDTF' !set to Thomas-Fermi for subsequent calls
end if

!***********************************************************************
!                                                                      *
!     Setup of density matrices for subsys A                           *
!                                                                      *
!***********************************************************************
call NameRun(NamRfil)    ! switch back RUNFILE name

! Get the density matrix for rho_A

call Get_D1ao(D_DS(1,3),nh1)
!call RecPrt('D_DS(1,3)',' ',D_DS(1,3),nh1,1)

call Get_iScalar('Multiplicity',iSpin)
if ((iSpin == 1) .and. (kSpin /= 1)) then
  call WarningMessage(0,' Non-singlet environment perturbation on singlet state!'// &
                      ' Spin-components of the OFE potential will be averaged.')
end if

! Get the spin density matrix of A

if (iSpin /= 1) then
  call Get_D1Sao(D_DS(1,4),nh1)
  !call RecPrt('D1Sao',' ',D_DS(1,4),nh1,1)
end if

! Compute alpha and beta density matrices of subsystem A

nFckDim = 2
if (iSpin == 1) then
  D_DS(:,3) = Half*D_DS(:,3)
  D_DS(:,4) = D_DS(:,3)
  if (kSpin == 1) nFckDim = 1
else
  do i=1,nh1
    DTot = D_DS(i,3)
    DSpn = D_DS(i,4)
    d_Alpha = Half*(DTot+DSpn)
    d_Beta = Half*(DTot-DSpn)
    D_DS(i,3) = d_Alpha
    D_DS(i,4) = d_Beta
  end do
  !call RecPrt('Da',' ',D_DS(1,3),nh1,1)
  !call RecPrt('Db',' ',D_DS(1,4),nh1,1)
end if

call wrap_DrvNQ(KSDFT,F_DFT(1,3),nFckDim,Func_A,D_DS(1,3),nh1,nFckDim,Do_Grad,Grad_A,nGrad,DFTFOCK)

call daxpy_(nGrad,-One,Grad_A,1,Grad,1)

! Fraction of correlation potential from A (cases: HF or Trunc. CI)
if (dFMD > Zero) then

  Grad_A(:) = Zero
  call mma_allocate(Fcorr,nh1,nFckDim,Label='Fcorr')

  call cwrap_DrvNQ(KSDFT,nFckDim,Func_A,D_DS(1,3),nh1,nFckDim,Do_Grad,Grad_A,nGrad,DFTFOCK,Fcorr)

  call get_dScalar('NAD dft energy',Energy_NAD)
  Fakt_ = Xlambda(abs(Energy_NAD),Xsigma)
  call daxpy_(nGrad,Fakt_,Grad_A,1,Grad,1)

  call mma_deallocate(Fcorr)
end if

call mma_deallocate(Grad_A)

call Get_NameRun(NamRfil) ! save the old RUNFILE name
call NameRun('AUXRFIL')   ! switch RUNFILE name

call wrap_DrvNQ('NUCATT_EMB',F_DFT,nFckDim,Func_X,D_DS(1,3),nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK)

call NameRun(NamRfil)   ! switch back RUNFILE name

!***********************************************************************
!                                                                      *
!     Calculation on the supermolecule                                 *
!                                                                      *
!***********************************************************************
nFckDim = 2
if ((iSpin == 1) .and. (kSpin == 1)) then
  nFckDim = 1
  call daxpy_(nh1,One,D_DS(1,3),1,D_DS(1,1),1)
else
  call daxpy_(nh1,One,D_DS(1,3),1,D_DS(1,1),1)
  call daxpy_(nh1,One,D_DS(1,4),1,D_DS(1,2),1)
end if

call wrap_DrvNQ(KSDFT,F_DFT,nFckDim,Func_AB,D_DS,nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK)

call mma_deallocate(F_DFT)
call mma_deallocate(D_DS)

return

end subroutine DrvEMB_

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_SrtDrv(irc,DelOrig)
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: presort Cholesky vectors according to batch structure in
!          MP2 program.
!
! DelOrig: input : flag for deleting original vector files.
!          output: flag to tell that at least 1 symmetry block has
!                  in fact been deleted.

use Cholesky, only: nSym, NumCho
use ChoMP2, only: DecoMP2, LnT1am, lUnit, lUnit_F, nBatch, nMP2Vec, nT1am
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
logical(kind=iwp), intent(inout) :: DelOrig
integer(kind=iwp) :: iAdr, iBat, iBatch, iClos, iOpt, iSym, iTyp, iVec1, kChoMO, kSort, lChoMO, LnT1amx, lSort, lTot, lWrk, &
                     MinMem, nBat, nSrtVec, NumV, NumVec
real(kind=wp), allocatable :: Wrk(:)
character(len=*), parameter :: SecNam = 'ChoMP2_SrtDrv'

irc = 0
if (nBatch < 1) return

! Allocate available memory.
! --------------------------

call mma_maxDBLE(lWrk)
call mma_allocate(Wrk,lWrk,Label='Wrk')

! Set vector type (i.e., transformed vectors or vectors from (ai|bj)
! decomposition. Decide whether original files should be deleted.
! ------------------------------------------------------------------

if (DecoMP2) then
  iTyp = 2
else
  iTyp = 1
end if

if (DelOrig) then
  iClos = 3
else
  iClos = 2
end if
DelOrig = .false.

! Start symmetry loop.
! --------------------

do iSym=1,nSym

  ! Set number of vectors.
  ! ----------------------

  if (iTyp == 1) then
    nSrtVec = NumCho(iSym)
  else if (iTyp == 2) then
    nSrtVec = nMP2Vec(iSym)
  else
    irc = -1
    call Finish_this()
    return
  end if

  if ((nT1am(iSym) > 0) .and. (nSrtVec > 0)) then

    ! Set up vector batch.
    ! --------------------

    LnT1amx = 0
    do iBatch=1,nBatch
      LnT1amx = max(LnT1amx,LnT1am(iSym,iBatch))
    end do

    MinMem = nT1am(iSym)+LnT1amx
    NumVec = min(lWrk/MinMem,nSrtVec)
    if (NumVec < 1) then
      irc = 1
      call Finish_this()
      return
    else
      nBat = (nSrtVec-1)/NumVec+1
    end if

    ! Open full vector file.
    ! ----------------------

    call ChoMP2_OpenF(1,iTyp,iSym)

    ! Start batch loop.
    ! -----------------

    do iBat=1,nBat

      if (iBat == nBat) then
        NumV = nSrtVec-NumVec*(nBat-1)
      else
        NumV = NumVec
      end if
      iVec1 = NumVec*(iBat-1)+1

      ! Read batch of vectors.
      ! ----------------------

      lChoMO = nT1am(iSym)*NumV

      kChoMO = 1

      iOpt = 2
      lTot = lChoMO
      iAdr = nT1am(iSym)*(iVec1-1)+1
      call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kChoMO),lChoMO,iAdr)

      ! Sort and write to disk.
      ! -----------------------

      kSort = 1+lChoMO
      lSort = lWrk-lChoMO
      do iBatch=1,nBatch
        lTot = LnT1am(iSym,iBatch)*NumV
        if (lSort < lTot) call SysAbendMsg(SecNam,'sort batch error','[0]')
        call ChoMP2_Srt(Wrk(kChoMO),Wrk(kSort),NumV,iSym,iBatch)
        call ChoMP2_OpenB(1,iSym,iBatch)
        iOpt = 1
        iAdr = LnT1am(iSym,iBatch)*(iVec1-1)+1
        call ddaFile(lUnit(iSym,iBatch),iOpt,Wrk(kSort),lTot,iAdr)
        call ChoMP2_OpenB(2,iSym,iBatch)
      end do

    end do

    ! Close (and possibly delete) full vector file.
    ! ---------------------------------------------

    call ChoMP2_OpenF(iClos,iTyp,iSym)
    DelOrig = iClos == 3

  end if

end do

call Finish_this()

contains

subroutine Finish_this()

  call mma_deallocate(Wrk)

end subroutine Finish_this

end subroutine ChoMP2_SrtDrv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Order_Arrays(mode,A1,N1,N2,P2,SCR1)

      Implicit Real*8 (a-h,o-z)
      Character*4 mode
      Integer N1, N2
      Real*8  A1(N1,N2), P2(N2), SCR1(N1)

      If (mode.eq.'decr') Then
         Do j=1,N2-1
            Do k=j+1,N2
               If (P2(j).lt.P2(k)) Then
                  tmp=P2(j)
                  P2(j)=P2(k)
                  P2(k)=tmp
                  call dcopy_(N1,A1(1,j),1,SCR1(1),1)
                  call dcopy_(N1,A1(1,k),1,A1(1,j),1)
                  call dcopy_(N1,SCR1(1),1,A1(1,k),1)
               EndIf
            End Do
         End Do
      ElseIf (mode.eq.'incr') Then
         Do j=1,N2-1
            Do k=j+1,N2
               If (P2(j).gt.P2(k)) Then
                  tmp=P2(j)
                  P2(j)=P2(k)
                  P2(k)=tmp
                  call dcopy_(N1,A1(1,j),1,SCR1(1),1)
                  call dcopy_(N1,A1(1,k),1,A1(1,j),1)
                  call dcopy_(N1,SCR1(1),1,A1(1,k),1)
               EndIf
            End Do
         End Do
      Else
         write(6,*) ' In routine Order_Arrays: wrong mode! '
         Call Abend
      EndIf

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_CompVec(Diag,xInt,VecK,QDiag,Wrk,lWrk,iSym,iPass)
!
! Purpose: compute vectors from decomposition of the qualified
!          diagonal integral block. VecK contains the nQual(iSym)
!          vectors from that decomposition. xInt contains the
!          integral columns. The vectors are returned in xInt.
!          Wrk (dimension lWrk) is work space allocated in calling
!          routine. QDiag contains the qualified diagonals.

use Cholesky, only: Cho_DiaChk, iiBstR, IndRed, INF_PROGRESS, IPRINT, LuPri, nnBstR, nnZTot, nQual, NumCho, NumChT, Tol_DiaChk
use Constants, only: One, Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: lWrk
real(kind=wp), intent(inout) :: Diag(*), xInt(*), QDiag(*), Wrk(lWrk)
real(kind=wp), intent(in) :: VecK(*)
integer(kind=iwp), intent(in) :: iSym, iPass
integer(kind=iwp) :: i, iABG, iVec, iVecT, j, jAB, jAB1, kInt, kK0, kOff, kOff0, nConv, nErr, nNeg, nNegT
real(kind=wp) :: Fac, OlDiag, QDmax, Tol, xC, xM, yM, zM
logical(kind=iwp), parameter :: LocDbg = .false.
character(len=*), parameter :: SecNam = 'Cho_CompVec'
integer(kind=iwp), external :: Cho_P_IndxParentDiag

! Subtract previous vectors.
! --------------------------

call Cho_Subtr(xInt,Wrk,lWrk,iSym)

! Debug: check diagonal elements in updated integrals.
! ----------------------------------------------------

if (Cho_DiaChk .or. LocDbg) then
  Tol = Tol_DiaChk
  nErr = 0
  call Cho_P_ChkInt(xINT,Diag,iSym,nErr,Tol,.true.)
  if (nErr /= 0) then
    write(Lupri,*) SecNam,': ',nErr,' diagonal errors found!'
    write(Lupri,*) '          Integral pass: ',iPass
    write(Lupri,*) '          #Tests: ',nQual(iSym)
    !write(Lupri,*) '          Printing integrals:'
    !call Cho_Output(xINT,1,nnBstR(iSym,2),1,nQual(iSym),nnBstR(iSym,2),nQual(iSym),1,Lupri)
    call Cho_Quit('Diagonal errors in '//SecNam,104)
  else
    write(Lupri,*) SecNam,': comparison of qual. integrals and current diagonal: no errors !'
  end if
end if

! Set max. diagonal for screening.
! --------------------------------

QDmax = QDiag(1)

! Compute vectors.
! ----------------

do i=1,nQual(iSym)

  kOff0 = nnBstR(iSym,2)*(i-1)
  kK0 = nQual(iSym)*(i-1)

  ! Compute vector.
  ! ---------------

  xC = QDiag(i)
  Fac = One/sqrt(abs(xC))
  kOff = kOff0
  xInt(kOff+1:kOff+nnBstR(iSym,2)) = Fac*xInt(kOff+1:kOff+nnBstR(iSym,2))

  ! Zero elements corresponding to zero diagonals.
  ! ----------------------------------------------

  do jAB=1,nnBstR(iSym,2)
    jAB1 = IndRed(iiBstR(iSym,2)+jAB,2)
    if (Diag(jAB1) == Zero) xInt(kOff0+jAB) = Zero
  end do

  ! Update diagonal.
  ! ----------------

  do jAB=1,nnBstR(iSym,2)
    jAB1 = IndRed(iiBstR(iSym,2)+jAB,2)
    kOff = kOff0+jAB
    Diag(jAB1) = Diag(jAB1)-xInt(kOff)**2
  end do

  ! Update Qdiag.
  ! -------------

  do j=i,nQual(iSym)
    QDiag(j) = QDiag(j)-VecK(kK0+j)**2
  end do
  OlDiag = QDiag(i)
  QDiag(i) = Zero

  ! Get index (1st reduced set) of the parent diagonal for this
  ! vector (global index!).
  ! -----------------------------------------------------------

  iABG = Cho_P_IndxParentDiag(i,iSym)

  ! Zero treated diagonal element.
  ! ------------------------------

  call Cho_P_ZeroDiag(Diag,iSym,iABG)

  ! Check for and zero negative diagonals, count converged, and
  ! find max. diagonal element.
  ! -----------------------------------------------------------

  call Cho_ChkDia_A4(Diag,QDmax,iSym,nNeg,nNegT,nConv,xM,yM,zM)

  ! nnZTot is the total number of zeroed negative diagonals,
  ! updated for statistics purposes.
  ! --------------------------------------------------------

  nnZTot = nnZTot+nNeg

  ! Subtract this vector from remaining integral columns,
  ! M([gd],{ab}_j) -= K({ab}_j,i)*L([gd],NumCho+i)
  ! -----------------------------------------------------

  kOff = kOff0
  do j=i+1,nQual(iSym)
    Fac = -VecK(kK0+j)
    kInt = nnBstR(iSym,2)*(j-1)
    xInt(kInt+1:kInt+nnBstR(iSym,2)) = xInt(kInt+1:kInt+nnBstR(iSym,2))+Fac*xInt(kOff+1:kOff+nnBstR(iSym,2))
  end do

  ! Print.
  ! ------

  if (iPrint >= Inf_Progress) then
    iVec = NumCho(iSym)+i
    iVecT = NumChT+i
    do j=i+1,nQual(iSym)
      xM = max(xM,QDiag(j))
    end do
    write(Lupri,'(I3,3(1X,I9),2(1X,ES11.3),2(1X,I4),1X,ES11.3)') iSym,iVec,iVecT,iABG,xC,OlDiag,nConv,nNeg,xM
  end if

end do

if (iPrint >= Inf_Progress) call XFlush(Lupri)

end subroutine Cho_CompVec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!***********************************************************************

#include "macros.fh"

!> This module defines an abstract class for CI-solvers.
!> If you inherit from CI_solver_t and override the deferred methods,
!> your initialization and cleanup will be automatically called.
module generic_CI

implicit none
private

public :: CI_solver_t

type, abstract :: CI_solver_t
contains
  procedure(CI_run_t), deferred :: run
  procedure(CI_cleanup_t), deferred :: cleanup
end type CI_Solver_t

abstract interface

  !> @brief
  !> Interface for procedure pointers to CI-solvers
  !>
  !> @author Oskar Weser
  !>
  !> @param[in] actual_iter The actual iteration number starting at 0. This means 0 is 1A, 1 is 1B, 2 is 2 and so on.
  !> @param[in] iroot specified roots for SA-CASSCF, e.g. 1,3,9,...
  !> @param[in] weight weights specified for roots for SA-CASSCF
  !> @param[in] CMO MO coefficients
  !> @param[in] DIAF DIAGONAL of Fock matrix useful for NECI
  !> @param[in] D1I_MO Inactive 1-dens matrix
  !> @param[in] TUVX Active 2-el integrals
  !> @param[in,out] F_In Fock matrix from inactive density
  !> @param[in,out] D1S_MO Average spin 1-dens matrix
  !> @param[out] DMAT Average 1 body density matrix
  !> @param[out] PSMAT Average symm. 2-dens matrix
  !> @param[out] PAMAT Average antisymm. 2-dens matrix
  subroutine CI_run_t(this,actual_iter,ifinal,iroot,weight,CMO,DIAF,D1I_AO,D1A_AO,TUVX,F_IN,D1S_MO,DMAT,PSMAT,PAMAT)

    use general_data, only: ntot, ntot1, ntot2
    use rasscf_global, only: nAcPar, nAcpr2, nroots
    use Definitions, only: wp, iwp

    import :: CI_solver_t
    class(CI_solver_t), intent(in) :: this
    integer(kind=iwp), intent(in) :: actual_iter, ifinal, iroot(nroots)
    real(wp), intent(in) :: weight(nroots), CMO(nTot2), DIAF(nTot), D1I_AO(nTot2), D1A_AO(nTot2), TUVX(nAcpr2)
    real(wp), intent(inout) :: F_In(nTot1), D1S_MO(nAcPar)
    real(wp), intent(out) :: DMAT(nAcpar), PSMAT(nAcpr2), PAMAT(nAcpr2)

  end subroutine CI_run_t

  !> @brief
  !> Interface to cleanup routine for CI-solvers
  !>
  !> @details
  !> It would be nice to have automatic finalization.
  !> Unfortunately we have to support old compilers.
  !>
  !> This method will be called at the end of rasscf.
  !>
  !> @author Oskar Weser
  subroutine CI_cleanup_t(this)

    import :: CI_solver_t
    class(CI_solver_t), intent(inout) :: this

  end subroutine CI_cleanup_t

end interface

end module generic_CI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
************************************************************************
      SubRoutine GetDens(FName,Density,iPrint)
************************************************************************
*                                                                      *
* Object: to get the 1 particle density from file INPORB               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Chem. Phys.                       *
*             University of Lund, SWEDEN                               *
*             January 2000                                             *
************************************************************************
      use PrpPnt
      use Basis_Info, only: nBas
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
#  include "mh5.fh"
#endif
      Character Line*80
      Character*(*) FName
      Logical Density
      Dimension Dummy(1),iDummy(1)
*
      nDen=n2Tri(1)
      nVec=S%n2Tot
      nOcc=S%nDim
      If (Density) Call mma_allocate(Den,nDen,label='Den')
      iadDen=1
      Call mma_allocate(Vec,nVec,label='Vec')
      Call mma_allocate(Occ,nOcc,label='Occ')
      iadDen=1
      iadVec=1
      iadOcc=1
      iOpt = 1
#ifdef _HDF5_
      If (mh5_is_hdf5(FName)) Then
         id_file=mh5_open_file_r(FName)
         Call RdVec_HDF5(id_file,'CO',nIrrep,nBas,
     &                   Vec,Occ,Dummy,iDummy)
         Call mh5_close_file(id_file)
         Write (6,*)
         Write (6,'(A,1X,A)') ' Vectors read from HDF5 file:',
     &                        Trim(FName)
         Write (6,*)
      Else
#endif
         LuVec = 19
         Call RdVec(FName,LuVec,'CO',nIrrep,nBas,nBas,
     &              Vec, Occ, Dummy, iDummy, Line,0,iErr)
         Write (6,*)
         Write (6,'(A)') ' Header from vector file:'
         Write (6,*)
         Write (6,'(A)') Line(:mylen(Line))
         Write (6,*)
#ifdef _HDF5_
      End If
#endif
*
      If (Density) Then
*
*        Build the density matrix.
*
         call dcopy_(nDen,[Zero],0,Den,1)
*
         ictv=iadVec
         icto=iadOcc
         ictd=iadDen
         Do iIrrep=0,nIrrep-1
            Do iBas=1,nBas(iIrrep)
               icv=ictv
               ico=icto
               icd=ictd
               Do j1=0,nBas(iIrrep)-1
                  Do j2=0,j1-1
                     Den(icd)=Den(icd)+Occ(ico)*Vec(icv+j1)
     &                                   *Two  *Vec(icv+j2)
                    icd=icd+1
                  End Do
                  Den(icd)=Den(icd)+Occ(ico)*Vec(icv+j1)
     &                                      *Vec(icv+j1)
                  icd=icd+1
               End Do
               ictv=ictv+nBas(iIrrep)
               icto=icto+1
            End Do
            ictd=ictd+nBas(iIrrep)*(nBas(iIrrep)+1)/2
         End Do
         iadVec=iadDen
         iadOcc=iadDen
         nOcc = nDen
         nVec = nDen
         If (iPrint.ge.10) Call PrMtrx(' Density matrix',[1],1,
     &                                 [iadDen],Den)
*
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

module External_Centers

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: iXPolType = 0, nData_XF = 0, nDMS = 0, nEF = 0, nOrd_XF = 1, nOrdEF = -1, nRP = 0, nWel = 0, nXF = 0, &
                     nXMolnr = 0
real(kind=wp) :: Dxyz(3) = Zero
integer(kind=iwp), allocatable :: XEle(:), XMolnr(:,:)
real(kind=wp), allocatable :: AMP_Center(:), DMS_Centers(:,:), EF_Centers(:,:), OAM_Center(:), OMQ_Center(:), RP_Centers(:,:,:), &
                              Wel_Info(:,:), XF(:,:)

public :: AMP_Center, DMS_Centers, Dxyz, EF_Centers, External_Centers_Dmp, External_Centers_Free, External_Centers_Get, iXPolType, &
          nData_XF, nDMS, nEF, nOrd_XF, nOrdEF, nRP, nWel, nXF, nXMolnr, OAM_Center, OMQ_Center, RP_Centers, Wel_Info, XEle, XF, &
          XMolnr

!                                                                      *
!***********************************************************************
!                                                                      *
contains
!                                                                      *
!***********************************************************************
!                                                                      *
subroutine External_Centers_Dmp()

  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp), allocatable :: iDmp(:)
  real(kind=wp), allocatable :: DMS_Ext(:,:), RP_Temp(:,:,:)

  if (allocated(EF_Centers)) then
    call Put_dArray('EF_Centers',EF_Centers,3*nEF)
  end if
  if (allocated(OAM_Center)) then
    call Put_dArray('OAM_Center',OAM_Center,3)
  end if
  if (allocated(OMQ_Center)) then
    call Put_dArray('OMQ_Center',OMQ_Center,3)
  end if
  if (allocated(DMS_Centers)) then
    call mma_allocate(DMS_Ext,3,nDMS+1,Label='DMS_Ext')
    DMS_ext(1:3,1:nDMS) = DMS_Centers(1:3,1:nDMS)
    DMS_ext(1:3,nDMS+1) = Dxyz(1:3)
    call Put_dArray('DMS_Centers',DMS_Ext,3*(nDMS+1))
    call mma_deallocate(DMS_Ext)
  end if
  if (allocated(Wel_Info)) then
    call Put_dArray('Wel_Info',Wel_Info,3*nWel)
  end if
  if (allocated(AMP_Center)) then
    call Put_dArray('AMP_Center',AMP_Center,3)
  end if
  if (allocated(RP_Centers)) then
    call mma_allocate(RP_Temp,3,nRP/3,2)
    RP_Temp(:,:,1) = RP_Centers(:,1:nRP/3,1)
    RP_Temp(:,:,2) = RP_Centers(:,1:nRP/3,2)
    call Put_dArray('RP_Centers',RP_Temp,nRP*2)
    call mma_deallocate(RP_Temp)
  end if
  if (allocated(XF)) then
    call Put_dArray('XF',XF,nData_XF*nXF)
  end if
  if (allocated(XMolnr)) then
    call Put_iArray('XMolnr',XMolnr,nXMolnr*nXF)
  end if
  if (allocated(XEle)) then
    call Put_iArray('XEle',XEle,nXF)
  end if
  call mma_Allocate(iDmp,3,Label='iDmp')
  iDmp(1) = nOrdEF
  iDmp(2) = nOrd_XF
  iDmp(3) = iXPolType
  call Put_iArray('Misc',iDmp,3)
  call mma_deallocate(iDmp)

  return

end subroutine External_Centers_Dmp
!                                                                      *
!***********************************************************************
!                                                                      *
subroutine External_Centers_Free()

  use stdalloc, only: mma_deallocate

  if (allocated(EF_Centers)) then
    call mma_deallocate(EF_Centers)
    nEF = 0
  end if
  if (allocated(OAM_Center)) call mma_deallocate(OAM_Center)
  if (allocated(OMQ_Center)) call mma_deallocate(OMQ_Center)
  if (allocated(DMS_Centers)) then
    call mma_deallocate(DMS_Centers)
    nDMS = 0
  end if
  if (allocated(Wel_Info)) then
    call mma_deallocate(Wel_Info)
    nWel = 0
  end if
  if (allocated(AMP_Center)) call mma_deallocate(AMP_Center)
  if (allocated(RP_Centers)) then
    call mma_deallocate(RP_Centers)
    nRP = 0
  end if
  if (allocated(XF)) then
    call mma_deallocate(XF)
    call mma_deallocate(XMolnr)
    call mma_deallocate(XEle)
    nData_XF = 0
    nXF = 0
    nXMolnr = 0
    nOrdEF = -1
    nOrd_XF = 1
    iXPolType = 0
  end if

  return

end subroutine External_Centers_Free
!                                                                      *
!***********************************************************************
!                                                                      *
subroutine External_Centers_Get()

  use stdalloc, only: mma_allocate, mma_deallocate
  use Definitions, only: u6

  integer(kind=iwp) :: Len2
  logical(kind=iwp) :: Found
  integer(kind=iwp), allocatable :: iDmp(:)
  real(kind=wp), allocatable :: DMS_Ext(:,:)

  call qpg_dArray('EF_Centers',Found,Len2)
  if (Found) then
    nEF = Len2/3
    if (allocated(EF_Centers)) then
      if (size(EF_Centers,2) /= nEF) then
        write(u6,*) 'SIZE(EF_Centers,2) /= nEF'
        call Abend()
      end if
    else
      call mma_allocate(EF_Centers,3,nEF,Label='EF_Centers')
    end if
    call Get_dArray('EF_Centers',EF_Centers,3*nEF)
  end if

  call qpg_dArray('OAM_Center',Found,Len2)
  if (Found) then
    if (.not. allocated(OAM_Center)) then
      call mma_allocate(OAM_Center,3,Label='OAM_Center')
    end if
    call Get_dArray('OAM_Center',OAM_Center,3)
  end if

  call qpg_dArray('OMQ_Center',Found,Len2)
  if (Found) then
    if (.not. allocated(OMQ_Center)) then
      call mma_allocate(OMQ_Center,3,Label='OMQ_Center')
    end if
    call Get_dArray('OMQ_Center',OMQ_Center,3)
  end if

  call qpg_dArray('DMS_Centers',Found,Len2)
  if (Found) then
    nDMS = Len2/3-1
    if (allocated(DMS_Centers)) then
      if (size(DMS_Centers,2) /= nDMS) then
        write(u6,*) 'SIZE(DMS_Centers,2) /= nDMS'
        call Abend()
      end if
    else
      call mma_allocate(DMS_Centers,3,nDMS,Label='DMS_Centers')
    end if
    call mma_allocate(DMS_Ext,3,nDMS+1,Label='DMS_Ext')
    call Get_dArray('DMS_Centers',DMS_Ext,3*(nDMS+1))
    DMS_Centers(1:3,1:nDMS) = DMS_Ext(1:3,1:nDMS)
    Dxyz(1:3) = DMS_Centers(1:3,nDMS+1)
    call mma_deallocate(DMS_Ext)
  end if

  call qpg_dArray('Wel_Info',Found,Len2)
  if (Found) then
    nWel = Len2/3
    if (allocated(Wel_Info)) then
      if (size(Wel_Info,2) /= nWel) then
        write(u6,*) 'SIZE(Wel_Info,2) /= nWel'
        call Abend()
      end if
    else
      call mma_allocate(Wel_Info,3,nWel,Label='Wel_Info')
    end if
    call Get_dArray('Wel_Info',Wel_Info,3*nWel)
  end if

  call qpg_dArray('AMP_Center',Found,Len2)
  if (Found) then
    if (.not. allocated(AMP_Center)) then
      call mma_allocate(AMP_Center,3,Label='AMP_Center')
    end if
    call Get_dArray('AMP_Center',AMP_Center,3)
  end if

  call qpg_dArray('RP_Centers',Found,Len2)
  if (Found) then
    nRP = Len2/2
    if (allocated(RP_Centers)) then
      if (size(RP_Centers,2) /= nRP/3) then
        write(u6,*) 'SIZE(RP_Centers,2) /= nRP/3'
        call Abend()
      end if
    else
      call mma_allocate(RP_Centers,3,nRP/3,2,Label='RP_Centers')
    end if
    call Get_dArray('RP_Centers',RP_Centers,2*nRP)
  end if

  call qpg_iArray('XEle',Found,Len2)
  if (Found) then
    nXF = Len2
    if (.not. allocated(XEle)) then
      call mma_allocate(XEle,nXF,Label='XEle')
    end if
    call Get_iArray('XEle',XEle,nXF)

    call qpg_iArray('XMolnr',Found,Len2)
    nXMolnr = Len2/nXF
    if (.not. allocated(XMolnr)) then
      call mma_allocate(XMolnr,nXMolnr,nXF,Label='XMolnr')
    end if
    call Get_iArray('XMolnr',XMolnr,nXMolnr*nXF)

    call qpg_dArray('XF',Found,Len2)
    nData_XF = Len2/nXF
    if (.not. allocated(XF)) then
      call mma_allocate(XF,nData_XF,nXF,Label='XF')
    end if
    call Get_dArray('XF',XF,nData_XF*nXF)
  end if
  call mma_Allocate(iDmp,3,Label='iDmp')
  call Get_iArray('Misc',iDmp,3)
  nOrdEF = iDmp(1)
  nOrd_XF = iDmp(2)
  iXPolType = iDmp(3)
  call mma_deallocate(iDmp)

end subroutine External_Centers_Get
!                                                                      *
!***********************************************************************
!                                                                      *
end module External_Centers

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FCIN(FLT,nFLT,DLT,FSQ,DSQ,EMY,CMO)

#include "intent.fh"

use motra_global, only: Debug, iPrint, nBas, nFro, nSym, nTot1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: nFLT
real(kind=wp), intent(inout) :: FLT(nFLT)
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(_OUT_) :: DLT(*), FSQ(*), DSQ(*)
real(kind=wp), intent(out) :: EMY
integer(kind=iwp) :: ISTLTT, ISYM, LBUF, n_Bas, NB, NPQ, NTFRO
real(kind=wp) :: EONE, ETWO
real(kind=wp), allocatable :: Temp(:), W1(:), W2(:)
logical(kind=iwp) :: DoCholesky
integer(kind=iwp), external :: mma_avmem

! Construct the one-electron density matrix for frozen space

call DONEI(DLT,DSQ,CMO)

! Compute the one-electron energy contribution to EMY

EONE = Zero
do NPQ=1,NTOT1
  EONE = EONE+DLT(NPQ)*FLT(NPQ)
end do
EMY = EONE
if ((IPRINT >= 5) .or. (DEBUG /= 0)) then
  write(u6,'(6X,A,E20.10)') 'ONE-ELECTRON CORE ENERGY:',EONE
end if

! Quit here if there are no frozen orbitals

NTFRO = 0
n_Bas = 0
do ISYM=1,NSYM
  NTFRO = NTFRO+NFRO(ISYM)
  n_Bas = max(n_Bas,nBas(iSym))
end do
if (NTFRO == 0) then
  return
end if

! Compute the two-electron contribution to the Fock matrix

call mma_allocate(Temp,nFlt,label='Temp')
Temp(:) = Zero

call DecideOnCholesky(DoCholesky)

if (DoCholesky) then
  call Cho_Fock_MoTra(nSym,nBas,nFro,DLT,DSQ,FLT,nFLT,FSQ,One)

  ! Print the Fock-matrix

  if ((IPRINT >= 5) .or. (DEBUG /= 0)) then
    write(u6,'(6X,A)') 'Fock matrix in AO basis'
    ISTLTT = 1
    do ISYM=1,NSYM
      NB = NBAS(ISYM)
      if (NB > 0) then
        write(u6,'(6X,A,I2)') 'symmetry species:',ISYM
        call TRIPRT(' ',' ',Temp(ISTLTT),NB) ! ??? Temp is zero
        ISTLTT = ISTLTT+NB*(NB+1)/2
      end if
    end do
  end if

else

  call mma_allocate(W2,n_Bas**2,label='FCIN2')
  LBUF = int(mma_avmem()*0.9_wp,kind=iwp)/RtoB
  call mma_allocate(W1,LBUF,label='FCIN1')

  call FTWOI(DLT,DSQ,Temp,nFlt,FSQ,LBUF,W1,W2)

  call mma_deallocate(W2)
  call mma_deallocate(W1)
end if

call DaXpY_(nFlt,One,Temp,1,Flt,1)
call mma_deallocate(Temp)

! Add the two-electron contribution to EMY
ETWO = -EONE
do NPQ=1,NTOT1
  ETWO = ETWO+DLT(NPQ)*FLT(NPQ)
end do
EMY = EONE+Half*ETWO
if ((IPRINT >= 5) .or. (DEBUG /= 0)) then
  write(u6,'(6X,A,E20.10)') 'TWO-ELECTRON CORE ENERGY:',ETWO
end if

! Exit

return

end subroutine FCIN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c generate and print csfs
      subroutine found_a_config(ndl,de,npr)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common /mcorb/ lsmorb(max_orb),noidx(8)
      common/config/ndr,nwalk(0:max_orb)
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      dimension  nwalk_gamess(max_orb),norbindex(max_orb),
     :     norbsymm(max_orb),norbwalk(max_orb)
      character*18 form1

      ndr=ndl
      nst=norb_all
      ndy=norb_ext
      do l=1,norb_ext+norb_act
        nwalk(l)=0
      enddo
      no_dz=nst-norb_dz+1
      do l=no_dz,nst
        nwalk(l)=3
      enddo
      ndimsum=0
      if(npr.eq.1.or.npr.eq.0) then
        jpae=jv
        ipae=1
        jaedownwei=iseg_downwei(ipae)
        jpad=1
        iw_sta(jpad,ipae)=ndimsum
        call seg_drt()                     !   jpad_upwei(*)        = jp
        iwupwei=jpad_upwei(jpad)               !   iw_sta(jpad,jpae)
        iw_downwei(jpad,ipae)=ndim             !   iw_downwei(jpad,jpae)
        ndimsum=ndimsum+ndim*jaedownwei*iwupwei  !   iseg_dim(jpae)    =
        call config_act()                       !   jpae_upwei(jpae)  =
        goto 110
      endif

      jpae=jv
      ipae=1
      jaedownwei=iseg_downwei(ipae)
      do jpad=1,mxnode
        iw_sta(jpad,ipae)=ndimsum
        if(nu_ad(jpad).eq.0) cycle
        call seg_drt()                     !   jpad_upwei(*)        = jp
        iwupwei=jpad_upwei(jpad)               !   iw_sta(jpad,jpae)
        iw_downwei(jpad,ipae)=ndim             !   iw_downwei(jpad,jpae)
        ndimsum=ndimsum+ndim*jaedownwei*iwupwei  !   iseg_dim(jpae)    =
        if(ndim .eq. 0) cycle                !   jpae_sta(jpae)    = jpa
        call config_act()                       !   jpae_upwei(jpae)  =
      enddo
      do im=1,8
        jpae=jd(im)
        ipae=1+im
        iw_sta(1:mxnode,ipae)=ndimsum
        if(nu_ae(ipae).eq.0) cycle
        jaedownwei=iseg_downwei(ipae)
        do jpad=1,mxnode
          iw_sta(jpad,ipae)=ndimsum
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          iwupwei=jpad_upwei(jpad)
          iw_downwei(jpad,ipae)=ndim
          ndimsum=ndimsum+ndim*jaedownwei*iwupwei
          if(ndim .eq. 0) cycle
          call config_act()
          ista=iw_sta(jpad,ipae)+1
        enddo
      enddo
      do im=1,8
        jpae=jt(im)
        ipae=9+im
        iw_sta(1:mxnode,ipae)=ndimsum
        if(nu_ae(ipae).eq.0) cycle
        jaedownwei=iseg_downwei(ipae)
        do jpad=1,mxnode
          iw_sta(jpad,ipae)=ndimsum
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          iwupwei=jpad_upwei(jpad)
          iw_downwei(jpad,ipae)=ndim
          ndimsum=ndimsum+ndim*jaedownwei*iwupwei
          if(ndim .eq. 0) cycle
          call config_act()
        enddo
      enddo
      do im=1,8
        jpae=js(im)
        ipae=17+im
        if(nu_ae(ipae).eq.0) cycle
        do jpad=1,mxnode
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          if(ndim .eq. 0) cycle
          call config_act()
        enddo
      enddo
      call config_dbl()
      call config_ext()

110   continue
      if(npr.eq.0) return

      nwalk_gamess(1:norb_all)=0
      do i=1,nst
        nwalk_gamess(i)=nwalk(nst-i+1)
      enddo
      if(npr.eq.1) then
        write(6,1000) ndr,de
      else
        sqde=de*de
        write(6,1001) ndr,de,sqde
      endif

      if(intgen.eq.1) then
        ! gamess integral
        i=0
        j=0
        do i=norb_frz+1,nst
          if(nwalk_gamess(map_orb_order(i)).gt.0) then
            j=j+1
            norbindex(j)=i
            norbsymm(j)=lsmorb(i)
            norbwalk(j)=nwalk_gamess(map_orb_order(i))
          endif
        enddo

        !write(form1,2010) "(4x,i4,1x,",ng_sm,"(1x","i"
        write(form1,1010) "(4x,a4,",j,"(1x,i3))"
        write(6,form1) "norb",(norbindex(i),i=1,j)
        write(6,form1) "sym ",(norbsymm(i),i=1,j)
        write(6,form1) "walk",(norbwalk(i),i=1,j)
      else
        i=0
        j=0
        do im=1,ng_sm
          ns=noidx(im)+nlsm_frz(im)+1
          if(im.eq.ng_sm) then
            ne=norb_all
          else
            ne=noidx(im+1)
          endif
          do i=ns,ne
            if(nwalk_gamess(map_orb_order(i)).gt.0) then
              j=j+1
              noi=i-noidx(im)
              norbindex(j)=noi
              norbsymm(j)=im
              norbwalk(j)=nwalk_gamess(map_orb_order(i))
            endif
          enddo
        enddo

        write(form1,1010) "(4x,a4,",j,"(1x,i3))"
        write(6,form1) "norb",(norbindex(i),i=1,j)
        write(6,form1) "sym ",(norbsymm(i),i=1,j)
        write(6,form1) "walk",(norbwalk(i),i=1,j)
      endif

      return
1000  format(/4x,"csf",i8,6x,"scf energy",f18.8,/)
1001  format(/4x,"csf",i8,2x,"coef",f10.6,2x,"weight",1x,f8.6/)
1010  format(a7,i3,a8)
      end

      subroutine config_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/config/ndr,nwalk(0:max_orb)
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
!      dimension ndr(max_innorb)
      REAL*8, pointer :: jph(:),jeh(:),jwh(:)
c      common/ptlph/jph,jeh,jwh,th,thh
      common/ptlph/jph,jeh,jwh
c     write(6,*)'               ***** start h-diaelm *****'
c      write(6,*)   '   diagonal_act_d:',jpad,ipae
      nsum=0
      do lr=norb_dz+1,norb_inn
        jp0=no(lr-1)+1
        jp1=no(lr)
        lr0=lr
        do jp=jp0,jp1
          if(iy(1,jp).eq.0) cycle
c  800
          do idl=2,3
            mpe=jj_sub(idl,jp)
            if(mpe.eq.0) cycle
c            wt = voint(lr0,lr0)    ! hnil=1
            jw=iy(idl,jp)
c           call prodel(3,wt,jp,mpe,jw)
            call prodel_conf(3,jp,mpe,jw,lr0,0,idl-1)
          enddo
          mpe=jj_sub(4,jp)
          if(mpe.ne.0) then
c            wt = vdint(lr0,lr0)+2.d0*voint(lr0,lr0)     !idl=4 hnil=2
            jw=iy(4,jp)
c           call prodel(3,wt,jp,mpe,jw)
            call prodel_conf(3,jp,mpe,jw,lr0,0,3)
          endif
        enddo
      enddo
      return
      end


      subroutine config_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/config/ndr,nwalk(0:max_orb)
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      data dzero/0.d0/
      if(norb_dbl.eq.0) return
      do ipae=1,25
        if(nu_ae(ipae).eq.0) cycle
        iwdownv=iw_downwei(1,ipae)
        do iwa=0,iwdownv-1
c       zz=' doub_800_v'
          iwad=iwalk_ad(1,ipae,iwa,0)
c          call prodel(1,wt0,0,ipae,iwad)
          call prodel_conf(1,0,ipae,iwad,0,0,1)
        enddo
      enddo
c       jps=js(1)
      do 100 lr0=norb_frz+1,norb_dz
        mr0=mul_tab(lsm_inn(lr0),ns_sm)
        iwd=jud(lr0)
          jpad =1+mr0
          jpad1=jpad+24
c         wld=wt0-voint(lr0,lr0)-vdint(lr0,lr0)
c          wls=wld-voint(lr0,lr0)
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpad,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpad,ipae,iwa,iwd)
c             call prodel(1,wld,0,ipae,iwad)
              call prodel_conf(1,0,ipae,iwad,lr0,0,2)     !d
            enddo
          enddo

          if(jb_sys.gt.0) then
            do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpad1,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpad1,ipae,iwa,iwd)
c             call prodel(1,wld,0,ipae,iwad)
              call prodel_conf(1,0,ipae,iwad,lr0,0,5)     !dd
            enddo
          enddo
        endif
         jpad=17+ns_sm
          iwd=just(lr0,lr0)
          do ipae=1,25
          if(nu_ae(ipae).eq.0) cycle
          iwdownv=iw_downwei(jpad,ipae)
          do iwa=0,iwdownv-1
            iwad=iwalk_ad(jpad,ipae,iwa,iwd)
c         call prodel(1,wls,0,ipae,iwad)
            call prodel_conf(1,0,ipae,iwad,lr0,0,4)     !s
        enddo
        enddo

      if(lr0.eq.norb_dz) goto 100
c           wld0=wld

      do 200 lr=lr0+1,norb_dz
        mr=mul_tab(mr0,lsm_inn(lr))
        jpat=9+mr
        jpas=17+mr
        jpat1=jpat+24
        iws=just(lr0,lr)
        iwt=iws            !
c          wld=wld0-voint(lr,lr)-vdint(lr,lr)
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
c           call prodel(1,wld,0,ipae,iwad)
              call prodel_conf(1,0,ipae,iwad,lr0,lr,3)   !t
          enddo
            if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
              do iwa=0,iwdownv-1
                iwad=iwalk_ad(jpat1,ipae,iwa,iwt)         !tt
c             call prodel(1,wld,0,ipae,iwad)
              call prodel_conf(1,0,ipae,iwad,lr0,lr,6)
            enddo
          endif
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
c           call prodel(1,wld,0,ipae,iwad)
              call prodel_conf(1,0,ipae,iwad,lr0,lr,4)   !s
          enddo
            if(jb_sys.gt.0) then
            iws1=just(lr,lr0)
              do iwa=0,iwdownv-1
                iwad=iwalk_ad(jpas,ipae,iwa,iws1)
c             call prodel(1,wld,0,ipae,iwad)
              call prodel_conf(1,0,ipae,iwad,lr0,lr,7)      !ss
            enddo
          endif
        enddo
200     continue
100   continue
      return
      end

      subroutine config_ext()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/config/ndr,nwalk(0:max_orb)
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      character*10 cc
        cc=' out_800_d'
        jws0=0
      do mra=1,8
        ipae=1+mra
        lasta=ibsm_ext(mra)
        laend=iesm_ext(mra)
        lrzz=laend-lasta+1
        lrzz=lrzz*(lrzz-1)/2
        jws0=jws0+lrzz
        jw=0
        do la=lasta,laend
c        jpd=jd(mra)
          jw=jw+1
          lra=norb_all-la+1
c        wld=voint(lra,lra)
c         call prodel(2,wld,0,ipae,jw)
          call prodel_conf(2,0,ipae,jw,la,0,2)      !d
        enddo
      enddo

!      zz=' out_800_s'
c       jps=js(1)

      jweis=jws0
      do la=1,norb_ext
c        jpd=jd(mra)
        lra=norb_all-la+1
        jweis=jweis+1
c        wls=2.d0*voint(lra,lra)+vdint(lra,lra)
c       call prodel(2,wls,0,18,jweis)
        call prodel_conf(2,0,18,jweis,la,0,4)      !s
      enddo
      do im=1,8
        jws=0
        jwt=0
        ipat=9+im
        ipas=17+im
        do la=2,norb_ext
         lra=norb_all-la+1
         ima=lsm(la)
         do 600 lb=1,la-1
           lrb=norb_all-lb+1
           imb=lsm(lb)
           mr=mul_tab(ima,imb)
           if(mr.ne.im) goto 600
c          jps=js(mr)
c          jpt=jt(mr)
           jws=jws+1
           jwt=jwt+1
c            wls=voint(lra,lra)+voint(lrb,lrb)
c            wlt=wls
c           wls=wls+voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=-3/2
c            wlt=wlt-voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=1/2

c          call prodel(2,wls,0,ipas,jws)
c           call prodel(2,wlt,0,ipat,jwt)
            call prodel_conf(2,0,ipas,jws,la,lb,4)      !s
            call prodel_conf(2,0,ipat,jwt,la,lb,3)      !t
600       continue
          enddo
      enddo
      return
      end

!  idb=1  in dbl_space      ity_up=0-5             jd_type,jd_im,iwd
!  idb=2  in ext_space      ity_down=0-3          je_type,je_im,iwe
!  idb=3  in act_space      ity_up=0-5,itdown=0,3      jp ,mpe,iwa
      subroutine prodel_conf(idb,mg1,mg2,mg3,lr01,lr02,jpty)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/config/ndr,nwalk(0:max_orb)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)

      goto(100,200,300),idb
! in dbl_space
! jpty=  1,  2,  3,  4,  5,  6,  7
!        v   d   t   s  dd  tt  ss
100   ipae=mg2
      iwad=mg3
      lr1=norb_all-lr01+1
      lr2=norb_all-lr02+1
        isegdownwei=iseg_downwei(ipae)
        do mm=iwad+1,iwad+isegdownwei
          if(mm.eq.ndr) then
         goto(1,2,3,4,5,6,7),jpty
1         goto 1000
2         nwalk(lr1)=2
          goto 1000
3         nwalk(lr1)=2
          nwalk(lr2)=2
          goto 1000
4         nwalk(lr1)=2
          nwalk(lr2)=1
          if(lr02.eq.0) then
            nwalk(lr1)=0
          endif
          if(lr01.eq.0) then
            nwalk(lr2)=0
          endif
          goto 1000
5         nwalk(lr1)=1
          goto 1000
6         nwalk(lr1)=1
          nwalk(lr2)=1
          goto 1000
7         nwalk(lr1)=1
          nwalk(lr2)=2
          goto 1000
          endif
        enddo
      goto 1000

! in ext_space
! jpty=  1,  2,  3,  4
!        v   d   t   s
 200  ipae=mg2
      iwe=mg3
      lr1=lr01
      lr2=lr02
      do jdbl=1,mxnode
        if(nu_ad(jdbl).eq.0) cycle
        iw=iw_downwei(jdbl,ipae)
        iwupwei=jpad_upwei(jdbl)
        do iwa=0,iw-1
          do iwd=0,iwupwei-1
            mm=iwalk_ad(jdbl,ipae,iwa,iwd)+iwe
            if(mm.eq.ndr) then
              goto(10,20,30,40),jpty
10            goto 1000
20            nwalk(lr1)=1
              goto 1000
30            nwalk(lr1)=1
              nwalk(lr2)=1
              goto 1000
40            nwalk(lr1)=2
              nwalk(lr2)=1
              if(lr02.eq.0) then
                nwalk(lr1)=3
              endif
              goto 1000
            endif
          enddo
        enddo
      enddo
      goto 1000
! in act_space
300   jp=mg1
      mpe=mg2
      jw=mg3
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jph=jphy(jp)
      in=ihy(jph)
      lwnu=iy(1,mpe)
      lr1=norb_all-lr01+1
      do jwu=jph+1,jph+in
        iwa=jw+ihy(jwu)-1
        do jwd=1,lwnu
          iwa=iwa+1
          do iwd=0,iwupwei-1
            iwad=iwalk_ad(jpad,ipae,iwa,iwd)
            do iwe=1,isegdownwei
              mm=iwe+iwad
              if(mm.eq.ndr) then
              nwalk(lr1)=jpty
                goto 1000
              endif
            enddo
          enddo
        enddo
      enddo
1000  return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      Subroutine RPA_RdRun()
C
C     Thomas Bondo Pedersen
C
C     Read data from Runfile.
C
      Implicit None
#include "rpa_config.fh"
#include "rpa_data.fh"
      Character*9 SecNam
      Parameter (SecNam='RPA_RdRun')

      Integer  RPA_iUHF
      External RPA_iUHF

      Character*8 Model

      Logical Warn

      Integer iUHF
      Integer iSym
      Integer i

      ! Register entry

      ! Set type of SCF reference wave function
      ! Note: in RPA, iUHF=1 means restricted, 2 means unrestricted.
      Call Get_cArray('Relax Method',Model,8)
      Call Get_iScalar('SCF mode',iUHF)
      iUHF=iUHF+1 ! correct for convention in SCF
      If (Model(1:7).eq.'RHF-SCF') Then
         If (iUHF.eq.1) Then
            Reference='RHF'
            Warn=.false.
         Else
            Reference='UHF'
            warn=.true.
         End If
      Else If (Model(1:7).eq.'UHF-SCF') Then
         If (iUHF.eq.1) Then
            Reference='RHF'
            Warn=.true.
         Else
            Reference='UHF'
            Warn=.false.
         End If
      Else If (Model(1:6).eq.'KS-DFT') Then
         Warn=.false.
         If (iUHF.eq.1) Then
            Reference='RKS'
         Else
            Reference='UKS'
         End If
      Else If (Model(1:8).eq.'dRPA@RHF' .or.
     *         Model(1:8).eq.'SOSX@RHF') Then
         If (iUHF.eq.1) Then
            Reference='RHF'
            Warn=.false.
         Else
            Reference='UHF'
            Warn=.true.
         End If
      Else If (Model(1:8).eq.'dRPA@UHF' .or.
     *         Model(1:8).eq.'SOSX@UHF') Then
         If (iUHF.eq.1) Then
            Reference='RHF'
            Warn=.true.
         Else
            Reference='UHF'
            Warn=.false.
         End If
      Else If (Model(1:8).eq.'dRPA@RKS' .or.
     *         Model(1:8).eq.'SOSX@RKS') Then
         If (iUHF.eq.1) Then
            Reference='RKS'
            Warn=.false.
         Else
            Reference='UKS'
            Warn=.true.
         End If
      Else If (Model(1:8).eq.'dRPA@UKS' .or.
     *         Model(1:8).eq.'SOSX@UKS') Then
         If (iUHF.eq.1) Then
            Reference='RKS'
            Warn=.true.
         Else
            Reference='UKS'
            Warn=.false.
         End If
      Else
         Write(6,'(A,A)') 'Reference model from Runfile: ',Model
         Write(6,'(A,I8)') 'iUHF from Runfile:            ',iUHF-1
         Call RPA_Warn(2,'Illegal reference wave function in RPA')
         Reference='Non'
         Warn=.false.
      End If
      If (Warn) Then
         Call RPA_Warn(1,
     *                'Runfile restricted/unrestricted conflict in RPA')
         Write(6,'(A,A)') 'Reference model from Runfile: ',Model
         Write(6,'(A,I8)') 'iUHF from Runfile:            ',iUHF-1
         Write(6,'(A,A,A)') 'Assuming ',Reference,' reference!'
         Call xFlush(6)
      End If

      ! Get nuclear potential energy
      Call Get_dScalar('PotNuc',NuclearRepulsionEnergy(1))

      ! Get DFT functional
      If (Reference(2:3).eq.'KS') Then
         Call Get_cArray('DFT functional',DFTFunctional,16)
      Else
         DFTFunctional='Hartree-Fock'
      End If

      ! Get number of irreps
      Call Get_iScalar('nSym',nSym)
      If (nSym.lt.1 .or. nSym.gt.8) Then
         Call RPA_Warn(3,'nSym out of bonds in RPA')
      End If

      ! Get iUHF (RPA convention: 1->RHF, 2->UHF)
      !          (as opposed to SCF: 0->RHF, 1->UHF)
      iUHF=RPA_iUHF()

      ! Get number of basis functions, orbitals, occupied,
      ! frozen (in SCF), deleted
      Call Get_iArray('nBas',nBas,nSym)
      Call Get_iArray('nOrb',nOrb,nSym)
      Call Get_iArray('nDel',nDel(1,1),nSym)
      Call Get_iArray('nFro',nFro(1,1),nSym)
      Call Get_iArray('nIsh',nOcc(1,1),nSym)
      If (iUHF.eq.2) Then
         ! unrestricted: read data for beta spin
         Call Get_iArray('nIsh_ab',nOcc(1,2),nSym)
      End If

      ! Check for orbitals frozen in SCF and check consistency.
      Do iSym=1,nSym
         If (nFro(iSym,1).ne.0) Then
            Write(6,'(A,8I8)') 'nFro=',(nFro(i,1),i=1,nSym)
            Call RPA_Warn(4,
     &                    SecNam//': Some orbitals were frozen in SCF!')
         End If
         If (nDel(iSym,1).ne.(nBas(iSym)-nOrb(iSym))) Then
            Write(6,'(A,8I8)') 'nBas=     ',(nBas(i),i=1,nSym)
            Write(6,'(A,8I8)') 'nOrb=     ',(nOrb(i),i=1,nSym)
            Write(6,'(A,8I8)') 'nBas-nOrb=',((nBas(i)-nOrb(i)),i=1,nSym)
            Write(6,'(A,8I8)') 'nDel=     ',(nDel(i,1),i=1,nSym)
            Call RPA_Warn(4,SecNam//': nDel != nBas-nOrb')
         End If
      End Do

      ! Set default frozen (core) orbitals
      Call Get_iArray('Non valence orbitals',nFro(1,1),nSym)
      Do iSym=1,nSym
         If (nFro(iSym,1).gt.nOcc(iSym,1)) Then
            If (iUHF.eq.1) Then
               Write(6,'(A,8I8)') 'nOcc=',(nOcc(i,1),i=1,nSym)
               Write(6,'(A,8I8)') 'nFro=',(nFro(i,1),i=1,nSym)
               Call RPA_Warn(4,SecNam//': nFro > nOrb')
            Else
               Write(6,'(A,8I8)') 'nOcc(alpha)=',(nOcc(i,1),i=1,nSym)
               Write(6,'(A,8I8)') 'nFro(alpha)=',(nFro(i,1),i=1,nSym)
               Call RPA_Warn(4,SecNam//': nFro > nOrb [alpha]')
            End If
         End If
      End Do
      If (iUHF.eq.2) Then
         Do iSym=1,nSym
            nFro(iSym,2)=nFro(iSym,1)
            If (nFro(iSym,2).gt.nOcc(iSym,2)) Then
               Write(6,'(A,8I8)') 'nOcc(beta)=',(nOcc(i,2),i=1,nSym)
               Write(6,'(A,8I8)') 'nFro(beta)=',(nFro(i,2),i=1,nSym)
               Call RPA_Warn(4,SecNam//': nFro > nOrb [beta]')
            End If
         End Do
      Else
         Do iSym=1,nSym
            nFro(iSym,2)=0
         End Do
      End If

      ! Compute number of virtual orbitals
      Do i=1,iUHF
         Do iSym=1,nSym
            nVir(iSym,i)=nOrb(iSym)-nOcc(iSym,i)
         End Do
      End Do

      ! Set default deleted (virtual) orbitals
      Call iZero(nDel,16)

      ! Register exit

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! All points. A bunch of special cases, see ABOne and ABBoth for more details.
subroutine ABNone(iLA,iLB,dMulA,Rinv,Colle)

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, Two, Three
use Definitions, only: wp, iwp

! Maximum multipole implemented
#define _MxM_ 2

implicit none
integer(kind=iwp), intent(in) :: iLA, iLB
real(kind=wp), intent(in) :: dMulA(nTri_Elem1(_MxM_)), Rinv
real(kind=wp), intent(out) :: Colle(3)
real(kind=wp) :: d3, Pi1, Pi2, Sigma

Colle(:) = Zero

if (iLA == 0) then
  if (iLB == 0) then
    Sigma = dMulA(1)
    Colle(1) = Sigma*Rinv
  else if (iLB == 1) then
    Sigma = dMulA(1)
    Colle(1) = Sigma*Rinv**2
  else if (iLB == 2) then
    Sigma = dMulA(1)
    Colle(1) = Sigma*Rinv**3
  end if
else if (iLA == 1) then
  if (iLB == 0) then
    Sigma = dMulA(3)
    Colle(1) = Sigma*Rinv**2
  else if (iLB == 1) then
    Sigma = dMulA(3)
    Pi1 = dMulA(1)
    Pi2 = dMulA(2)
    Colle(1) = Two*Sigma*(Rinv**3)
    Colle(2) = Pi1*(Rinv**3)
    Colle(3) = Pi2*(Rinv**3)
  else if (iLB == 2) then
    d3 = sqrt(Three)
    Sigma = dMulA(3)
    Pi1 = dMulA(1)
    Pi2 = dMulA(2)
    Colle(1) = Three*Sigma*(Rinv**4)
    Colle(2) = d3*Pi1*(Rinv**4)
    Colle(3) = d3*Pi2*(Rinv**4)
  end if

! Jose* This is for Quadrupoles in Classical. We do not use in QmStat.
!--------------------------------------
!else if (iLA == 2) then
!  if (iLB == 0) then
!    Sigma = dMulA(3)
!    Colle(1) = Sigma*Rinv**3
!  else if (iLB == 1) then
!    d3 = sqrt(Three)
!    Sigma = dMulA(3)
!    Pi1 = dMulA(2)
!    Pi2 = dMulA(4)
!    Colle(1) = Three*Sigma*(Rinv**4)
!    Colle(2) = d3*Pi1*(Rinv**4)
!    Colle(3) = d3*Pi2*(Rinv**4)
!  else if (iLB == 2) then
!    Sigma = dMulA(3)
!    Pi1 = dMulA(2)
!    Pi2 = dMulA(4)
!    ! Jose. Remember dMulB(1)=sqrt(3)*xy
!    !            and dMulB(5)=Half*sqrt(3)*(x2-y2)
!    Del1 = dMulA(1)
!    Del2 = dMulA(5)
!    Colle(1) = Six*Sigma*(Rinv**5)
!    Colle(2) = Four*Pi1*(Rinv**5)
!    Colle(3) = Four*Pi2*(Rinv**5)
!    Colle(4) = Del1*(Rinv**5)
!    Colle(5) = Del2*(Rinv**5)
!  end if
!--------------------------------------
end if

return

end subroutine ABNone

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GenRadQuad_MHL(R,nR,nR_Eff,Alpha)

use Constants, only: One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nR
real(kind=wp), intent(out) :: R(2,nR-1)
integer(kind=iwp), intent(out) :: nR_Eff
real(kind=wp), intent(in) :: Alpha
integer(kind=iwp) :: iR
real(kind=wp) :: x

! Last point at infinity is eliminated

#ifdef _DEBUGPRINT_
write(u6,*) 'EM Algorithm (Murray, Handy, Laming)'
write(u6,*) 'Alpha=',Alpha
write(u6,*) 'nR=',nR
#endif
do iR=1,nR-1
  x = real(iR,kind=wp)/real(nR,kind=wp)
  R(1,iR) = Alpha*(x/(One-x))**2
  R(2,iR) = R(1,iR)**2*Two*Alpha*x/(One-x)**3/real(nR,kind=wp)
end do
nR_Eff = nR-1

return

end subroutine GenRadQuad_MHL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine DerCtr(mdci,mdcj,mdck,mdcl,ldot,
     &                  JfGrd,IndGrd,JfHss,IndHss,JfG,mbatch)
*                                                                      *
************************************************************************
*                                                                      *
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "disp.fh"
#include "disp2.fh"
      Logical JfHss(4,3,4,3),IfHss(4,3,4,3),JfGrd(3,4),IfGrd(3,4),
     &        TF,TstFnc,IfG(4),JfG(4),ldot
      Integer IndHss(4,3,4,3,0:7),JndHss(4,3,4,3,0:7),
     &        IndGrd(3,4,0:7),JndGrd(3,4,0:7),iCo(4)
*define _OLD_CODE_
#ifdef _OLD_CODE_
      Integer iCom(0:7,0:7),iStabM(0:7), idcrr(0:7)
      Logical chck
#endif
*
      Ind(i1,i2)=i1*(i1-1)/2+i2
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*
       nnIrrep=nIrrep
       Call lCopy(12,[.false.],0,ifgrd,1)
       If (sIrrep) nnIrrep=1
*
      Do 3000 iIrrep=0,nnIrrep-1
         nDisp = IndDsp(mdci,iIrrep)
         Do 3001 iCar = 0, 2
            iComp = 2**iCar
            If (TF(mdci,iIrrep,iComp)) Then
               nDisp = nDisp + 1
               IndGrd(iCar+1,1,iIrrep) = nDisp
               IfGrd(iCar+1,1) = .True.
            Else
               IndGrd(iCar+1,1,iIrrep) = 0
            End If
 3001    Continue
 3000 Continue
      Do 3100 iIrrep=0,nnIrrep-1
         nDisp = IndDsp(mdcj,iIrrep)
         Do 3101 iCar = 0, 2
            iComp = 2**iCar
            If (TF(mdcj,iIrrep,iComp)) Then
               nDisp = nDisp + 1
               IndGrd(iCar+1,2,iIrrep) = nDisp
               IfGrd(iCar+1,2) = .True.
            Else
               IndGrd(iCar+1,2,iIrrep) = 0
            End If
 3101    Continue
 3100 Continue
      Do 3200 iIrrep=0,nnIrrep-1
         nDisp = IndDsp(mdck,iIrrep)
         Do 3201 iCar = 0, 2
            iComp = 2**iCar
            If (TF(mdck,iIrrep,iComp)) Then
               nDisp = nDisp + 1
               IndGrd(iCar+1,3,iIrrep) = nDisp
               IfGrd(iCar+1,3) = .True.
            Else
               IndGrd(iCar+1,3,iIrrep) = 0
            End If
 3201    Continue
 3200  Continue
       Do 3300 iIrrep=0,nnIrrep-1
          nDisp = IndDsp(mdcl,iIrrep)
          Do 3301 iCar = 0, 2
             iComp = 2**iCar
             If (TF(mdcl,iIrrep,iComp)) Then
                nDisp = nDisp + 1
                IndGrd(iCar+1,4,iIrrep) = nDisp
                IfGrd(iCar+1,4) = .True.
             Else
                IndGrd(iCar+1,4,iIrrep) = 0
             End If
 3301    Continue
 3300 Continue
      Do iIrrep=0,nnIrrep-1
         Do 3333 iCar = 1, 3
            Do 4444 iSh = 1, 4
               JndGrd(iCar,iSh,iIrrep) =
     &            IndGrd(iCar,iSh,iIrrep)
               JfGrd(iCar,iSh) =
     &            IfGrd(iCar,iSh)
 4444        Continue
 3333     Continue
      End Do
      iCo(1)=mdci
      iCo(2)=mdcj
      iCo(3)=mdck
      iCo(4)=mdcl
      Call iCopy(144*nirrep,[0],0,IndHss,1)
      Call iCopy(144*nirrep,[0],0,jndHss,1)
      Call lCopy(144,[.false.],0,IfHss,1)
      Call lCopy(144,[.false.],0,JfHss,1)
      if (.not.ldot) Return
*
      Do iAtom=1,4
         Do jAtom=1,iAtom
*
*        This segment of the code is not really needed.
*        If turned on it should not do much of a difference.
*
#ifdef _OLD_CODE_
            Call DCR(LmbdR,dc(iCo(iAtom))%iStab,dc(iCo(iAtom))%nStab,
     &                     dc(iCo(jAtom))%iStab,dc(iCo(jAtom))%nStab,
     &                     iDCRR,nDCRR)
*
*-----------Find the stabilizer for A and B
*
            Call Inter(dc(iCo(iAtom))%iStab,dc(iCo(iAtom))%nStab,
     &                 dc(iCo(jAtom))%iStab,dc(iCo(jAtom))%nStab,
     &                 iStabM,nStabM)
*
*          Generate all possible (left) CoSet
*          To the stabil. of A and B
*
            Do iIrrep = 0, nIrrep-1
               Do jOper = 0, nStabM-1
                  iCoM(iIrrep,jOper) =
     &                 iEor(iOper(iIrrep),iStabM(jOper))
               End Do
            End Do
*
*           Order the Coset so we will have the unique ones first
*           Check uniqueness
*
            nMax = 1
            Do 435 j = 1, nIrrep-1
               Do 436 i = 0, nMax - 1
                  Do 437 ielem = 0, nStabM-1
                    If (iCoM(i,1).eq.iCoM(j,ielem))
     &                  Go To 435
 437              Continue
 436           Continue
*
*----------Move unique CoSet
*
               nMax = nMax + 1
               Do 438 ielem = 0, nStabM-1
                  iTmp = iCoM(nMax-1,ielem)
                  iCoM(nMax-1,ielem) = iCoM(j,ielem)
                  iCoM(j,ielem) = iTmp
 438           Continue
               If (nMax.eq.nIrrep/nStabM) Go To 439
 435        Continue
 439        Continue
*
*           Check if the derivative is needed in the present symmetry
*
            nCoM=nIrrep/nStabM
*
            Do iCar=1,3
               if (iAtom.eq.jAtom) Then
                   istop=iCar
               Else
                   iStop=3
               End If
               Do jCar=1,istop
                  iComp=iEOr(2**(iCar-1),2**(jCar-1))
                  Chck=TstFnc(iCoM,0,iComp,nStabM)
                  If (Chck)
     &                 IfHss(iAtom,iCar,jAtom,jCar)=.true.
               End Do
            End Do
#endif
*
*               Calculate the index for the derivative
*
            Do  iIrrep=0,nnIrrep-1
                Do iCar=1,3
                   if (iAtom.eq.jAtom) Then
                      istop=iCar
                   Else
                      iStop=3
                   End If
                   Do jCar=1,istop
            IfHss(iAtom,iCar,jAtom,jCar)=.true.
                        If ((jndGrd(iCar,iAtom,iIrrep).gt.0).and.
     &                     (jndGrd(jCar,jAtom,iIrrep).gt.0))
     &                  Then
                            IndHss(iAtom,iCar,jAtom,jCar,iIrrep)=
     &                      Ind(Max(JndGrd(iCar,iAtom,iIrrep),
     &                          jndGrd(jCar,jAtom,iIrrep)),
     &                      Min(jndGrd(iCar,iAtom,iIrrep),
     &                      jndGrd(jCar,jAtom,iIrrep)))
                         Else
                            IndHss(iAtom,iCar,jAtom,jCar,iIrrep)=0
                         End If
                   End Do
                End Do
            End Do
          End Do
      End Do
*
*              Scramble the control array for the hessian
*
      Call LCopy(4,[.true.],0,Ifg,1)
      Do iAtom=1,4
         JfG(iAtom)=IfG(iAtom)
         Do jAtom=1,iAtom
            Do iCar=1,3
              If (iAtom.eq.jAtom) Then
                 iStop=iCar
              Else
                 iStop=3
              End If
              Do jCar=1,iStop
                 If (iAtom.ge.jAtom) Then
                    JfHss(iAtom,iCar,jAtom,jCar)=
     &              IfHss(iAtom,iCar,jAtom,jCar)
                 Else If (iAtom.lt.jAtom) Then
                    JfHss(iAtom,iCar,jAtom,jCar)=
     &              IfHss(jAtom,jCar,iAtom,iCar)
                 End If
              End Do
           End Do
         End Do
       End Do
       If (sIrrep) Then
        Do ii=1,4
         Do ic1=1,3
          If (indgrd(ic1,ii,0).eq.0)
     &       jfgrd(ic1,ii)=.false.
          Do ij=1,4
           Do ic2=1,3
            If (Indhss(ii,ic1,ij,ic2,0).eq.0)
     &           JfHss(ii,ic1,ij,ic2)=.false.
           End Do
          End Do
         End Do
        End Do
       End If
*----------------------------------------------------------------
*
*  End Hess
*
*----------------------------------------------------------------------*
       Return
c Avoid unused argument warnings
       If (.False.) Call Unused_integer(mbatch)
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_GetQuadraticDiagonal(ip)
C
C     NOTE: this code is redundant!!
C     As of March 2011, the diagonal is stored quadratically from the
C     beginning.
C
C     TODO/FIXME: remove this file.
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: get AP diagonals stored quadratically (for A=B).
C              On return, ip can be used in the same way as ip_AP_Diag
C              from ldf_atom_pair_info.fh.
C              To deallocate the quadratic diagonal,
C              call LDF_FreeQuadraticDiagonal(ip).
C
      Implicit None
      Integer ip
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_bas.fh"
#include "ldf_qdiag.fh"

      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom

      Integer AB
      Integer A, B
      Integer ip_QDAA, l_QDAA
      Integer ipQ
      Integer nSA, ipA
      Integer iSA, iSB
      Integer iShellA, iShellB
      Integer iA, iB
      Integer n
      Integer ip_iOffPk, l_iOffPk

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer ipDPk
      Integer iOffPk
      Integer iTri
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      ipDPk(i)=iWork(ip_AP_Diag-1+i)
      iOffPk(i,j)=iWork(ip_iOffPk-1+nSA*(j-1)+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      Call WarningMessage(2,
     &'LDF_GetQuadraticDiagonal: this code is redundant, don''t use it')
      Call LDF_Quit(1)

      If (l_AP_QDiag.eq.NumberOfAtomPairs) Then ! already there
         ip=ip_AP_QDiag
      Else If (l_AP_QDiag.eq.0) Then ! set up quadratic diagonal blocks
         l_AP_QDiag=NumberOfAtomPairs
         Call GetMem('QDPtr','Allo','Inte',ip_AP_QDiag,l_AP_QDiag)
         ip=ip_AP_QDiag
         Do AB=1,NumberOfAtomPairs
            A=AP_Atoms(1,AB)
            B=AP_Atoms(2,AB)
            If (A.eq.B) Then
               l_QDAA=LDF_nBas_Atom(A)**2
               Call GetMem('QDAA','Allo','Real',ip_QDAA,l_QDAA)
               ipQ=ip_QDAA-1
               nSA=LDF_nShell_Atom(A)
               ipA=LDF_lShell_Atom(A)-1
               l_iOffPk=nSA**2
               Call GetMem('iOffPk','Allo','Inte',ip_iOffPk,l_iOffPk)
               n=0
               Do iSA=1,nSA
                  iShellA=iWork(ipA+iSA)
                  Do iSB=1,iSA-1
                     iWork(ip_iOffPk-1+nSA*(iSB-1)+iSA)=n
                     iWork(ip_iOffPk-1+nSA*(iSA-1)+iSB)=n
                     iShellB=iWork(ipA+iSB)
                     n=n+nBasSh(iShellA)*nBasSh(iShellB)
                  End Do
                  iWork(ip_iOffPk-1+nSA*(iSA-1)+iSA)=n
                  n=n+nBasSh(iShellA)*(nBasSh(iShellA)+1)/2
               End Do
               Do iSB=1,nSA
                  iShellB=iWork(ipA+iSB)
                  Do iSA=1,nSA
                     iShellA=iWork(ipA+iSA)
                     If (iSA.eq.iSB) Then
                        Do iB=1,nBasSh(iShellB)
                           Do iA=1,nBasSh(iShellA)
                              Work(ipQ+nBasSh(iShellA)*(iB-1)+iA)=
     &                        Work(ipDPk(AB)-1+iOffPk(iSA,iSA)
     &                             +iTri(iA,iB))
                           End Do
                        End Do
                     Else If (iSA.gt.iSB) Then
                        Call dCopy_(nBasSh(iShellA)*nBasSh(iShellB),
     &                             Work(ipDPk(AB)+iOffPk(iSA,iSB)),1,
     &                             Work(ipQ+1),1)
                     Else
                        Do iA=1,nBasSh(iShellA)
                           Call dCopy_(nBasSh(iShellB),
     &                                Work(ipDPk(AB)+iOffPk(iSB,iSA)
     &                                     +nBasSh(iShellB)*(iA-1)),1,
     &                                Work(ipQ+iA),nBasSh(iShellA))
                        End Do
                     End If
                     ipQ=ipQ+nBasSh(iShellA)*nBasSh(iShellB)
                  End Do
               End Do
               Call GetMem('iOffPk','Free','Inte',ip_iOffPk,l_iOffPk)
               iWork(ip_AP_QDiag-1+AB)=ip_QDAA
            Else
               iWork(ip_AP_QDiag-1+AB)=iWork(ip_AP_Diag-1+AB)
            End If
         End Do
      Else
         Call WarningMessage(2,'QDiag management corrupted!')
         Call LDF_Quit(1)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_FreeQuadraticDiagonal(ip)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: free quadratic diagonals (see also LDF_QuadraticDiagonal)
C
      Implicit None
      Integer ip
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_qdiag.fh"

      Character*25 SecNam
      Parameter (SecNam='LDF_FreeQuadraticDiagonal')

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Integer AB
      Integer A, B
      Integer ip_QDAA, l_QDAA

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      If (l_AP_QDiag.gt.0) Then
         If (ip.ne.ip_AP_QDiag) Then
            Call WarningMessage(2,SecNam//': ip mismatch!')
            Call LDF_Quit(1)
         End If
         Do AB=1,NumberOfAtomPairs
            A=AP_Atoms(1,AB)
            B=AP_Atoms(2,AB)
            If (A.eq.B) Then
               l_QDAA=LDF_nBas_Atom(A)**2
               ip_QDAA=iWork(ip_AP_QDiag-1+AB)
               Call GetMem('QDAA','Free','Real',ip_QDAA,l_QDAA)
            End If
         End Do
         Call GetMem('QDPtr','Free','Inte',ip_AP_QDiag,l_AP_QDiag)
         ip_AP_QDiag=0
         l_AP_QDiag=0
         ip=0
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DRT0_MCLR(A0,B0,C0,NVERT,DRT,DOWN,NTMP,TMP)
C
C     PURPOSE: CONSTRUCT THE UNRESTRICTED GUGA TABLE
C
      IMPLICIT INTEGER (A-Z)
C
      DIMENSION DRT(NVERT,5),DOWN(NVERT,0:3),TMP(NTMP)
      PARAMETER(LTAB=1,NTAB=2,ATAB=3,BTAB=4,CTAB=5)
      DIMENSION DA(0:3),DB(0:3),DC(0:3)
      DATA DA /0,0,1,1/, DB /0,1,-1,0/, DC /1,0,1,0/
C
C
C     SET UP TOP ROW
C
      NACTEL=2*A0+B0
      NLEV=A0+B0+C0
      DRT(1,LTAB)=NLEV
      DRT(1,NTAB)=NACTEL
      DRT(1,ATAB)=A0
      DRT(1,BTAB)=B0
      DRT(1,CTAB)=C0
      VSTA=1
      VEND=1
C
C     LOOP OVER ALL LEVELS
C
      DO 100 LEV=NLEV,1,-1
        MXADDR=((LEV+1)*(LEV+2))/2
        DO 10 I=1,MXADDR
          TMP(I)=0
10      CONTINUE
C
C     LOOP OVER VERTICES
C
        DO 30 VUP=VSTA,VEND
          AUP=DRT(VUP,ATAB)
          BUP=DRT(VUP,BTAB)
          CUP=DRT(VUP,CTAB)
C
C     LOOP OVER CASES
C     AND STORE ONLY VALID CASE NUMBERS WITH ADRESSES
C
          DO 20 STEP=0,3
            DOWN(VUP,STEP)=0
            ADWN=AUP-DA(STEP)
            IF(ADWN.LT.0) GOTO 20
            BDWN=BUP-DB(STEP)
            IF(BDWN.LT.0) GOTO 20
            CDWN=CUP-DC(STEP)
            IF(CDWN.LT.0) GOTO 20
            BC=BDWN+CDWN
            ADDR=1+(BC*(BC+1))/2 + CDWN
            TMP(ADDR)=4*VUP+STEP
            DOWN(VUP,STEP)=ADDR
20        CONTINUE
30      CONTINUE
        VDWN=VEND
C
C     NOW INSERT VALID CASES INTO DRT TABLE
C
        DO 40 ADDR=1,MXADDR
          VUPS=TMP(ADDR)
          IF(VUPS.EQ.0) GOTO 40
          VUP=VUPS/4
          STEP=MOD(VUPS,4)
          VDWN=VDWN+1
          DRT(VDWN,ATAB)=DRT(VUP,ATAB)-DA(STEP)
          DRT(VDWN,BTAB)=DRT(VUP,BTAB)-DB(STEP)
          DRT(VDWN,CTAB)=DRT(VUP,CTAB)-DC(STEP)
          TMP(ADDR)=VDWN
40      CONTINUE
C
C     CREATE DOWN CHAIN TABLE
C
        DO 60 VUP=VSTA,VEND
          DO 50 STEP=0,3
            DWN=DOWN(VUP,STEP)
            IF(DWN.NE.0) DOWN(VUP,STEP)=TMP(DWN)
50        CONTINUE
60      CONTINUE
        VSTA=VEND+1
        VEND=VDWN
100   CONTINUE
C
C     ADDING THE ZERO LEVEL TO DRT AND DOWNCHAIN TABLE
C
      DO 110 I=1,5
        DRT(VEND,I)=0
110   CONTINUE
      DO 120 STEP=0,3
        DOWN(VEND,STEP)=0
120   CONTINUE
C
C     COMPLETE DRT TABLE BY ADDING NO. OF ORBITALS AND ELECTRONS
C     INTO THE FIRST AND SECOND COLUMN
C
      DO 130 VERT=1,VEND
        DRT(VERT,LTAB)=DRT(VERT,ATAB)+DRT(VERT,BTAB)+DRT(VERT,CTAB)
        DRT(VERT,NTAB)=2*DRT(VERT,ATAB)+DRT(VERT,BTAB)
130   CONTINUE
C
C
C     EXIT
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ci_reconstruct(istate,nSDET,vector,indexSD)

use dmrginfo, only: LRRAS2, MS2_RGLR, nDets_RGLR, nEle_RGLR, nStates_RGLR, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: istate, nsdet
real(kind=wp), intent(out) :: vector(nsdet) ! determinants
integer(kind=iwp), intent(out) :: indexSD(nsdet) ! index
integer(kind=iwp) :: i, idet, idx_det, iorbLR, iorbLR0, irrep_diff(8), irrep_pre, j, lcheckpoint, ndets_mclr, nDets_Total, &
                     nele_alpha, nele_beta, nele_mod, neletol, norb, norbLR, rc
real(kind=wp) :: dtmp
logical(kind=iwp) :: IFFILE
character(len=200) :: tmp_run
integer(kind=iwp), allocatable :: ele_conf(:,:), ele_orb_alpha(:), ele_orb_beta(:), electron(:,:), inum(:), isgn(:), itype(:), &
                                  pre_ele(:)
real(kind=wp), allocatable :: dV(:,:)
character(len=100), allocatable :: checkpoint(:) ! for many states
integer(kind=iwp), external :: IsFreeUnit

! Slater determinant data
!  itype    : excitation type
!  inum     : determinant number
!  isgn     : determinant phase
!  electron : determinant
!  ele_conf : electron configuration
!  dV       : for many states

! The total electrons
neletol = nele_RGLR

! Check if there is single electron
nele_mod = mod(neletol,2)

! electrons in alpha or beta orbitals
if (nele_mod == 0) then
  ! If no single electron
  nele_alpha = neletol/2+ms2_RGLR/2
  nele_beta = neletol/2-ms2_RGLR/2
else
  nele_alpha = neletol/2+ms2_RGLR/2+1
  nele_beta = neletol/2-ms2_RGLR/2
end if

! Read in all the name of checkpoint file
lcheckpoint = 20
lcheckpoint = isFreeUnit(lcheckpoint)
call Molcas_Open(lcheckpoint,'dmrg_for_mclr.parameters')
call mma_allocate(checkpoint,nstates_RGLR,label='checkpoint')
checkpoint = ''
do i=1,6
  read(lcheckpoint,*)
end do
do i=1,nstates_RGLR
  read(lcheckpoint,*) checkpoint(i)
  read(lcheckpoint,*)
end do
close(lcheckpoint)

! reconstructing dets for current state
do i=istate,istate
  write(u6,*) trim(checkpoint(i))
end do

! preparing for point group symmetry
norb = sum(RGras2(:))
norbLR = sum(LRras2(:))
irrep_diff(:) = RGras2(:)-LRras2(:)

call mma_allocate(pre_ele,norbLR,label='pre_ele'); pre_ele = 0
iorbLR0 = 1
iorbLR = 0
irrep_pre = 0
do i=1,8
  iorbLR = iorbLR+LRras2(i)
  if (i /= 1) irrep_pre = irrep_pre+irrep_diff(i-1)
  do j=iorbLR0,iorbLR,1
    pre_ele(j) = irrep_pre
    write(u6,*) 'j,pre_ele(j)',j,pre_ele(j)
  end do
  iorbLR0 = iorbLR+1 ! At least work for C1
end do

write(u6,*) 'pre_ele, ndets_RGLR',pre_ele,ndets_RGLR
write(u6,*) 'nalpha,  nbeta     ',nele_alpha,nele_beta

! DETs read from mclr_dets.initial
open(UNIT=117,file='mclr_dets.initial',status='OLD')
call mma_allocate(itype,ndets_RGLR,Label='itype')
call mma_allocate(inum,ndets_RGLR,Label='inum')
call mma_allocate(isgn,ndets_RGLR,Label='isgn')
call mma_allocate(electron,neletol,ndets_RGLR,Label='electron')
call mma_allocate(ele_conf,norb,ndets_RGLR,Label='ele_conf')
call mma_allocate(dV,nstates_RGLR,ndets_RGLR,Label='dV')
itype(:) = 1
inum(:) = 1
isgn(:) = 1
electron(:,:) = 0
ele_conf(:,:) = 0
dV(:,:) = Zero
do idet=1,ndets_RGLR
  read(117,'(1X,I8,6X)',advance='no') itype(idet)
  do i=1,neletol
    read(117,'(1X,I5)',advance='no') electron(i,idet)
  end do
  read(117,'(5X,I3)',advance='no') isgn(idet)
  read(117,'(11X,I20)') inum(idet)
end do
close(117)

write(u6,*) 'before get the executable file'

! get the executable file
call systemf('cp /home/eth/yma/Maquis_MPSLR/build/applications/srcas/srcas $PWD',rc)

write(u6,*) 'before get the executable file'

call mma_allocate(ele_orb_alpha,norb,label='ele_orb_alpha')
call mma_allocate(ele_orb_beta,norb,label='ele_orb_beta')
! All of the DETs into Maquis format
open(unit=118,file='dets.mclr')
do idet=1,ndets_RGLR
  !write(u6,*) 'idet',idet
  ele_orb_alpha = 0
  ele_orb_beta = 0
  do i=1,neletol
    if (electron(i,idet) > 0) then ! With preconditioner
      j = abs(electron(i,idet))
      ele_orb_alpha(j+pre_ele(j)) = 1
    else
      j = abs(electron(i,idet))
      ele_orb_beta(j+pre_ele(j)) = 1
    end if
  end do
  ! The same style also used in Maquis input
  do i=1,norb
    if ((ele_orb_alpha(i) == 1) .and. (ele_orb_beta(i) == 1)) ele_conf(i,idet) = 4
    if ((ele_orb_alpha(i) == 1) .and. (ele_orb_beta(i) == 0)) ele_conf(i,idet) = 3
    if ((ele_orb_alpha(i) == 0) .and. (ele_orb_beta(i) == 1)) ele_conf(i,idet) = 2
    if ((ele_orb_alpha(i) == 0) .and. (ele_orb_beta(i) == 0)) ele_conf(i,idet) = 1
    !write(u6,*) 'ele_conf(i,idet)',ele_conf(i,idet)
  end do
  do i=1,norb
    write(118,'(I1)',advance='no') ele_conf(i,idet)
    !write(u6,*) 'ele_conf(',i,',idet)',ele_conf(i,idet)
  end do
  write(118,*)
end do
close(118)
call mma_deallocate(ele_orb_alpha)
call mma_deallocate(ele_orb_beta)

write(u6,*) 'After write dets.mclr file'

! Test for part of DETS
! The way of "open file" need to be written
!                                  Yingjin 2015.8.13
call systemf('wc -l dets.mclr > dets.mclr.info',rc)
open(unit=118,file='dets.mclr.info')
read(118,*) ndets_total
close(118)
! If too many determinants,
! try to use the single, double, triple gradually untill 9999 (as the maximum)
if (ndets_total > 9999) call systemf('head -9999 dets.mclr > ELE_CISR_FOR_MCLR',rc)

! Recover the determinants, off-diagional multiply 2
! ========= should be improved by Hash etc. ==========
do i=istate,istate
  !write(u6,*) 'dV(i,idet)',i
  open(unit=118,file='GET_COEFF_IN_LIST')
  call f_inquire('ELE_CISR_FOR_MCLR',IFFILE)
  if (IFFILE) then
    tmp_run = './srcas '//trim(checkpoint(i))//' dets.mclr 1.0 1.0 0 ELE_CISR_FOR_MCLR > CIRE.scratch'
  else
    tmp_run = './srcas '//trim(checkpoint(i))//' dets.mclr 1.0 1.0 0 dets.mclr > CIRE.scratch'
  end if
  write(118,*) trim(tmp_run)
  close(118)
  call systemf('chmod +x GET_COEFF_IN_LIST',rc)
  call systemf('./GET_COEFF_IN_LIST',rc)
  ! read in the dets-coefficients
  open(unit=118,file='det_coeff.tmp')
  read(118,*) ndets_mclr
  do idet=1,ndets_mclr
    read(118,*) idx_det,dV(i,idx_det)
    !write(u6,*) idx_det,dV(i,idx_det)
  end do
  close(118)
  ! off-diagional multiply 2
  do idet=1,ndets_RGLR
    if (itype(idet) == 1) then
      dV(i,idet) = -dV(i,idet)
    else
      dtmp = sqrt((dV(i,idet)**2)*Two)
      dV(i,idet) = -sign(dtmp,dV(i,idet))
    end if
    !write(u6,*) 'i,idet,dV',i,idet,dV(i,idet)
  end do
end do

indexSD(1:ndets_RGLR) = [(i,i=1,ndets_RGLR)] ! inum(i)*isgn(i)
indexSD(ndets_RGLR+1:) = 0
vector(1:ndets_RGLR) = dV(istate,:)
vector(ndets_RGLR+1:) = Zero
dtmp = sum(vector(1:ndets_RGLR)**2)

write(u6,*) 'nele_alpha,nele_beta',nele_alpha,nele_beta
write(u6,*) 'Total CI weight is ',dtmp
write(u6,*) ' ================================================'
write(u6,*) '  IF for frequency, the CI weight must be'
write(u6,*) '      very close to 1 (i.e. 0.9999)'
write(u6,*) ' ------------------------------------------------'
write(u6,*) '  IF gradients in state-averaged case,'
write(u6,*) '      even very few is stil OK (e.g. 0.1)'
write(u6,*) '      however, better around 0.9'
write(u6,*) ' ================================================'
call xflush(u6)

!stop

call mma_deallocate(checkpoint)
call mma_deallocate(pre_ele)
call mma_deallocate(dV)
call mma_deallocate(ele_conf)
call mma_deallocate(electron)
call mma_deallocate(isgn)
call mma_deallocate(inum)
call mma_deallocate(itype)

end subroutine ci_reconstruct

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GETDPREF(DREF,NDREF,PREF,NPREF)
! Get active 1-density and 2-density matrices GAMMA1 and
! GAMMA2, and construct DREF and PREF which are in a tringular
! storage.

use Index_Functions, only: iTri, nTri_Elem
use caspt2_global, only: iPrGlb
use PrintLevel, only: DEBUG
use caspt2_module, only: NASHT, NG1, NG2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF
real(kind=wp), intent(out) :: DREF(NDREF), PREF(NPREF)
integer(kind=iwp) :: I, IJ, IJKL, IJKLT, IJLK, IJT, J, JI, JIKL, JILK, K, KL, KLT, L, LK, N2
real(kind=wp) :: P1, P2
real(kind=wp), allocatable :: G1(:), G2(:)

! Remember: NDREF=1 if NASHT=0. Similar NPREF.
DREF(1) = Zero
PREF(1) = Zero
if (NASHT == 0) return
! Active density 1-matrix:
call mma_allocate(G1,NG1,LABEL='G1')
call PT2_GET(NG1,'GAMMA1',G1)
do I=1,NASHT
  IJ = nTri_Elem(I-1)
  DREF(IJ+1:IJ+I) = G1(I:I+NASHT*(I-1):NASHT)
end do
call mma_deallocate(G1)

! CONSTRUCT PREF, 2-ELECTRON DENSITY MATRIX:
call mma_allocate(G2,NG2,LABEL='G2')
call PT2_GET(NG2,'GAMMA2',G2)
IJT = 0
IJKLT = 0
N2 = NASHT**2
do I=1,NASHT
  do J=1,I
    IJT = IJT+1
    IJ = I+NASHT*(J-1)
    JI = J+NASHT*(I-1)
    KLT = 0
    do K=1,NASHT
      do L=1,K
        KLT = KLT+1
        if (KLT > IJT) cycle
        IJKLT = IJKLT+1
        KL = K+NASHT*(L-1)
        LK = L+NASHT*(K-1)

        P1 = Half*G2(IJ+N2*(KL-1))
        P2 = Half*G2(IJ+N2*(LK-1))
        IJKL = iTri(IJ,KL)
        IJLK = iTri(IJ,LK)
        JIKL = iTri(JI,KL)
        JILK = iTri(JI,LK)
        PREF(IJKL) = P1
        PREF(IJLK) = P2
        PREF(JIKL) = P2
        PREF(JILK) = P1
      end do
    end do
  end do
end do

call mma_deallocate(G2)

if (IPRGLB >= DEBUG) then
  write(u6,*) ' GETDPREF has constructed DREF and PREF.'
end if

end subroutine GETDPREF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*      SUBROUTINE SORTB(BUFOUT,INDOUT,ACBDS,ACBDT,ISAB,BFACBD,NINTGR)
      SUBROUTINE SORTB(BUFS,INDS,ACBDS,ACBDT,ISAB,BFACBD,NINTGR)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "warnings.fh"
#include "mrci.fh"
c      DIMENSION BUFOUT(NBSIZ2,NCHN2)
*PAM04      DIMENSION BUFOUT(*)
      DIMENSION BUFS(NBITM2,NCHN2)
c      DIMENSION INDOUT(RTOI*NBSIZ2,NCHN2)
*PAM04      DIMENSION INDOUT(*)
      DIMENSION INDS(NBITM2+2,NCHN2)
      DIMENSION ACBDS(*),ACBDT(*), BFACBD(*)
c      DIMENSION ISAB(NVIRT,NVIRT)
      DIMENSION ISAB(*)
C SORTS INTEGRALS (AB/CD)
C FOR FIXED A,C ALL B,D
      DIMENSION NORB0(9)

      NVT=IROW(NVIRT+1)
      NOVST=LN*NVIRT+1
      IAD16=0

*PAM04C Buffer layout:
*PAM04      IBOFF2=RTOI*NBITM2
*PAM04      IBBC2=IBOFF2+NBITM2+1
*PAM04      IBDA2=IBBC2+1

      NORB0(1)=0
      DO I=1,NSYM
        NORB0(I+1)=NORB0(I)+NORB(I)
      END DO

      INSOUT=0
      IACMAX=0
      DO 50 ISTEP=1,IPASS
      IAD50=0
      CALL iDAFILE(LUTRA,2,iTraToc,nTraToc,IAD50)
      IDISK=0
      IACMIN=IACMAX+1
      IACMAX=IACMAX+NCHN2
      IF(IACMAX.GT.NVT)IACMAX=NVT
      IF(IACMIN.GT.IACMAX)GO TO 50

C Initialize Buffer Counts and BackChain Links.
      DO IREC=1,NCHN2
*PAM04        INDOUT(IBBC2+(IREC-1)*RTOI*NBSIZ2)=0
*PAM04        INDOUT(IBDA2+(IREC-1)*RTOI*NBSIZ2)=-1
       INDS(NBITM2+1,IREC)=0
       INDS(NBITM2+2,IREC)=-1
      END DO

C Loop over symmetry blocks of all-virtual integrals.
      DO 313 NSP=1,NSYM
      NOP=NORB(NSP)
      DO 312 NSQ=1,NSP
      NSPQ=MUL(NSP,NSQ)
      NOQ=NORB(NSQ)
      DO 311 NSR=1,NSP
      NSPQR=MUL(NSPQ,NSR)
      NOR=NORB(NSR)
      NSSM=NSR
      IF(NSR.EQ.NSP)NSSM=NSQ
      DO 310 NSS=1,NSSM
      IF(NSS.NE.NSPQR)GO TO 310
      NOS=NORB(NSS)
      NORBP=NOP*NOQ*NOR*NOS
      IF(NORBP.EQ.0)GO TO 310

      CALL dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)

C Loop over index quadruples in this symm block
      IOUT=0
      DO 309 NV=1,NOR
      NXM=NOS
      IF(NSR.EQ.NSS)NXM=NV
      DO 308 NX=1,NXM
      NTM=1
      IF(NSP.EQ.NSR)NTM=NV
      DO 307 NT=NTM,NOP
      NUMIN=1
      IF(NSP.EQ.NSR.AND.NT.EQ.NV)NUMIN=NX
      NUMAX=NOQ
      IF(NSP.EQ.NSQ)NUMAX=NT
      DO 306 NU=NUMIN,NUMAX

C MO integral value is made accessable at TIBUF(IOUT)
      IOUT=IOUT+1
      IF(IOUT.GT.NTIBUF) THEN
         CALL dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
         IOUT=1
      END IF

C M1..M4 seqential number of orbitals.
      M1=ICH(NORB0(NSP)+NT)
      M2=ICH(NORB0(NSQ)+NU)
      M3=ICH(NORB0(NSR)+NV)
      M4=ICH(NORB0(NSS)+NX)
      IF(M1.LE.LN.OR.M2.LE.LN)GO TO 306
      IF(M3.LE.LN.OR.M4.LE.LN)GO TO 306

C Permute orbital indices to canonical order
C and put integral value in FINI
      N1=M1
      N2=M2
      IF(M1.GT.M2)GO TO 11
      N1=M2
      N2=M1
11    N3=M3
      N4=M4
      IF(M3.GT.M4)GO TO 12
      N3=M4
      N4=M3
12    NI=N1
      NJ=N2
      NK=N3
      NL=N4
      IF(NI.GT.NK)GO TO 502
      IF(NI.EQ.NK)GO TO 14
      NI=N3
      NJ=N4
      NK=N1
      NL=N2
      GO TO 502
14    IF(NJ.GT.NL)GO TO 502
      NL=N2
      NJ=N4
502   FINI=TIBUF(IOUT)

C Compute virtual indices.
      NA=NI-LN
      NB=NJ-LN
      NC=NK-LN
      ND=NL-LN
      ITURN=0
      IF(NA.EQ.NB.AND.NC.EQ.ND)GO TO 306
107   IAC=IROW(NA)+NC
      IF(IAC.LT.IACMIN)GO TO 106
      IF(IAC.GT.IACMAX)GO TO 106
      IF(NA.EQ.NC.AND.NB.EQ.ND)FINI=FINI/2
      NAC=IAC-IACMIN+1
*PAM04      IPOS=INDOUT(IBBC2+(NAC-1)*RTOI*NBSIZ2)+1
*PAM04      INDOUT(IBBC2+(NAC-1)*RTOI*NBSIZ2)=IPOS
      IPOS=INDS(NBITM2+1,NAC)+1
      INDS(NBITM2+1,NAC)=IPOS
*PAM04      BUFOUT(IPOS+(NAC-1)*NBSIZ2)=FINI
*PAM04      INDOUT(IBOFF2+IPOS+(NAC-1)*RTOI*NBSIZ2)=NB+2**8*ND
      INDS(IPOS,NAC)=NB+2**8*ND
      BUFS(IPOS,NAC)=FINI
      IF(IPOS.LT.NBITM2)GO TO 106
C Save this buffer if filled up.
      JDISK=IDISK
*PAM04      CALL dDAFILE(Lu_60,1,INDOUT(1+(NAC-1)*RTOI*NBSIZ2),NBSIZ2,IDISK)
      CALL iDAFILE(Lu_60,1,INDS(1,NAC),NBITM2+2,IDISK)
      CALL dDAFILE(Lu_60,1,BUFS(1,NAC),NBITM2,IDISK)
*PAM04      INDOUT(IBBC2+(NAC-1)*RTOI*NBSIZ2)=0
*PAM04      INDOUT(IBDA2+(NAC-1)*RTOI*NBSIZ2)=JDISK
      INDS(NBITM2+1,NAC)=0
      INDS(NBITM2+2,NAC)=JDISK

106   IF(ITURN.EQ.1)GO TO 306
      IF(NA.EQ.NC.AND.NB.EQ.ND)GO TO 306
      IF(NA.EQ.NB.OR.NC.EQ.ND)GO TO 306
      ITURN=1
      NC=NL-LN
      ND=NK-LN
      GO TO 107
306   CONTINUE
307   CONTINUE
308   CONTINUE
309   CONTINUE
310   CONTINUE
311   CONTINUE
312   CONTINUE
313   CONTINUE
C EMPTY LAST BUFFERS
      NOVM=IACMAX-IACMIN+1
      If ( (NOVST+IACMIN-1+NOVM).gt.mChain ) then
        WRITE(6,*)'SORTB Error: NOVST+IACMIN-1+NOVM > MCHAIN'
        WRITE(6,*)'NOVST =',NOVST
        WRITE(6,*)'IACMIN=',IACMIN
        WRITE(6,*)'NOVM  =',NOVM
        WRITE(6,*)'MCHAIN=',MCHAIN
        WRITE(6,*)'  (See code).'
        CALL QUIT(_RC_GENERAL_ERROR_)
      End If
      DO 150 I=1,NOVM
      JDISK=IDISK
*PAM04      CALL dDAFILE(Lu_60,1,INDOUT(1+(I-1)*RTOI*NBSIZ2),NBSIZ2,IDISK)
      CALL iDAFILE(Lu_60,1,INDS(1,I),NBITM2+2,IDISK)
      CALL dDAFILE(Lu_60,1,BUFS(1,I),NBITM2,IDISK)
      LASTAD(NOVST+IACMIN-1+I)=JDISK
150   CONTINUE
      DO 40 ISYM=1,NSYM
        IST1=IRC(3)+JJS(ISYM+9)+1
        IFIN1=IRC(3)+JJS(ISYM+10)
        INPS=IFIN1-IST1+1
        IST2=IRC(2)+JJS(ISYM)+1
        IFIN2=IRC(2)+JJS(ISYM+1)
        INPT=IFIN2-IST2+1
        ITAIL=INPS+INPT
        IF(ITAIL.EQ.0)GO TO 40
        IN1=-NVIRT
        DO 55 NA=1,NVIRT
          IN1=IN1+NVIRT
          DO 60 NC=1,NA
            IAC=IROW(NA)+NC
            IF(IAC.LT.IACMIN)GO TO 60
            IF(IAC.GT.IACMAX)GO TO 60
            IF(NA.EQ.1)GO TO 60
            NSAC=MUL(NSM(LN+NA),NSM(LN+NC))
            NSACL=MUL(NSAC,LSYM)
            IF(NSACL.NE.ISYM)GO TO 60
            ISAC=ISAB(NA+(NC-1)*NVIRT)
            NSC=NSM(LN+NC)
            NDMAX=NVIRP(NSC)+NVIR(NSC)
            IF(NDMAX.GT.NA)NDMAX=NA
            INS=ISAB(NA+(NDMAX-1)*NVIRT)
            CALL FZERO(ACBDS,INS)
            CALL FZERO(ACBDT,INS)
            IADR=LASTAD(NOVST+IAC)
201         CONTINUE
*PAM04            CALL dDAFILE(Lu_60,2,INDOUT,NBSIZ2,IADR)
            CALL iDAFILE(Lu_60,2,INDS,NBITM2+2,IADR)
            CALL dDAFILE(Lu_60,2,BUFS,NBITM2,IADR)
*PAM04            LENGTH=INDOUT(IBBC2)
*PAM04            IADR=INDOUT(IBDA2)
            LENGTH=INDS(NBITM2+1,1)
            IADR=INDS(NBITM2+2,1)
            IF(LENGTH.EQ.0)GO TO 209
            DO 202 KK=1,LENGTH
*PAM04              INND=INDOUT(IBOFF2+KK)
              INND=INDS(KK,1)
CPAM96              NB=IAND(INND,255)
CPAM96              ND=IAND(ISHFT(INND,-8),255)
*              NB=MOD(INND,2**8)
*              ND=MOD(INND/2**8,2**8)
              NB=IBITS(INND, 0,8)
              ND=IBITS(INND, 8,8)

              IBDS=ISAB(NB+(ND-1)*NVIRT)
*PAM04              ACBDS(IBDS)=ACBDS(IBDS)+BUFOUT(KK)
*PAM04              IF(NB.GT.ND)ACBDT(IBDS)=ACBDT(IBDS)+BUFOUT(KK)
*PAM04              IF(NB.LT.ND)ACBDT(IBDS)=ACBDT(IBDS)-BUFOUT(KK)
              ACBDS(IBDS)=ACBDS(IBDS)+BUFS(KK,1)
              IF(NB.GT.ND)ACBDT(IBDS)=ACBDT(IBDS)+BUFS(KK,1)
              IF(NB.LT.ND)ACBDT(IBDS)=ACBDT(IBDS)-BUFS(KK,1)
202         CONTINUE
209         IF(IADR.NE.-1) GO TO 201
            ILOOP=0
72          INSB=INS
73          INB=KBUFF1-INSOUT
            INUMB=INSB
            IF(INSB.GT.INB)INUMB=INB
            IST=INS-INSB+1
            IF(ILOOP.EQ.0)
     *      CALL DCOPY_(INUMB,ACBDS(IST),1,BFACBD(INSOUT+1),1)
            IF(ILOOP.EQ.1)
     *      CALL DCOPY_(INUMB,ACBDT(IST),1,BFACBD(INSOUT+1),1)
            INSOUT=INSOUT+INUMB
            IF(INSOUT.LT.KBUFF1)GO TO 75
            CALL dDAFILE(Lu_80,1,BFACBD,KBUFF1,IAD16)
            INSOUT=0
75          INSB=INSB-INUMB
            IF(INSB.GT.0)GO TO 73
            ILOOP=ILOOP+1
            IF(ILOOP.EQ.1)GO TO 72
60        CONTINUE
55      CONTINUE
40    CONTINUE
50    CONTINUE
C EMPTY LAST BUFFER
      IF(INSOUT.NE.0) CALL dDAFILE(Lu_80,1,BFACBD,KBUFF1,IAD16)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NINTGR)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016, Ignacio Fdez. Galvan                             *
************************************************************************
      SUBROUTINE Process_Track()
      use Slapaf_Info, only: RootMap
      use Slapaf_parameters, only: Request_RASSI
      IMPLICIT NONE
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
      INTEGER :: nOv,nRoots,i
      INTEGER, DIMENSION(:), ALLOCATABLE :: OldMap,RootIdx
      INTEGER, DIMENSION(2) :: MaxId
      REAL*8, DIMENSION(:), ALLOCATABLE :: Ovlp
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: Overlaps
      LOGICAL :: Found,Done
      CHARACTER(LEN=8) :: Method
*
      CALL Get_cArray('Relax Method',Method,8)
      IF ((Method .NE. 'CASSCF')  .AND.
     &    (Method .NE. 'RASSCF')  .AND.
     &    (Method .NE. 'CASSCFSA').AND.
     &    (Method .NE. 'RASSCFSA').AND.
     &    (Method .NE. 'CASPT2')  .AND.
     &    (Method .NE. 'RASPT2')  ) THEN
      CALL WarningMessage(2,'Error in Process_Track')
        WRITE(6,*) '***************** ERROR ********************'
        WRITE(6,*) ' The TRACK keyword can only be used with'
        WRITE(6,*) ' states computed by the RASSCF or CASPT2'
        WRITE(6,*) ' programs.'
        WRITE(6,*) '********************************************'
        CALL Quit_OnUserError()
      END IF
*
* Find the number of roots, and whether state overlaps are available
*
      nRoots=1
      CALL Qpg_iScalar('Number of roots',Found)
      IF (Found) CALL Get_iScalar('Number of roots',nRoots)
      CALL qpg_dArray('State Overlaps',Found,nOv)
      IF (Found.AND.(nOv.EQ.(2*nRoots)**2)) THEN
        Request_RASSI = .FALSE.
      ELSE
        Request_RASSI = .TRUE.
      END IF
*
* Make sure that the root mapping is only done once per iteration
*
      CALL Qpg_iScalar('Track Done',Done)
      CALL Get_lScalar('Track Done',Done)
      IF (Request_RASSI .OR. Done) RETURN
*
* Modify the root map according to the overlaps:
*
*   RootMap(i) = N
*
* where i is the original root number (at iter=1), and N is the
* root number at the current iteration.
*
      CALL mma_allocate(Ovlp,nOv)
      CALL mma_allocate(Overlaps,nRoots,nRoots)
      CALL get_dArray('State Overlaps',Ovlp,nOv)
      DO i=1,nRoots
        Overlaps(:,i)=Ovlp((2*i-1)*nRoots+1:2*i*nRoots)
      END DO
      CALL mma_deallocate(Ovlp)
      IF (nPrint(1).GE.5) THEN
        CALL RecPrt('Overlaps with previous states','',
     &              Overlaps,nRoots,nRoots)
        CALL mma_allocate(OldMap,nRoots)
        CALL iCopy(nRoots,RootMap,1,OldMap,1)
      END IF
      CALL mma_allocate(RootIdx,nRoots)
      DO i=1,nRoots
        MaxId=MAXLOC(ABS(Overlaps))
        RootIdx(MaxId(1))=MaxId(2)
        Overlaps(MaxId(1),:)=Zero
        Overlaps(:,MaxId(2))=Zero
      END DO
      DO i=1,nRoots
        RootMap(i)=RootIdx(RootMap(i))
      END DO
      CALL Put_iArray('Root Mapping',RootMap,nRoots)
      IF (nPrint(1).GE.5) THEN
        WRITE(6,*)
        WRITE(6,100) 'Root map'
        WRITE(6,*)
        WRITE(6,100) 'Original  Prev.  This'
        WRITE(6,100) '  root    iter.  iter.'
        WRITE(6,100) '----------------------'
        DO i=1,nRoots
          WRITE(6,101) i,OldMap(i),RootMap(i)
        END DO
        WRITE(6,100) '----------------------'
        WRITE(6,*)
        CALL mma_deallocate(OldMap)
      END IF
100   FORMAT(3X,A)
101   FORMAT(3X,I6,1X,I6,1X,I6)

      CALL mma_deallocate(RootIdx)
      CALL mma_deallocate(Overlaps)
*
* Update the RunFile for automatic gradients
*
      CALL Qpg_iScalar('Relax CASSCF root',Found)
      IF (Found) THEN
        Call Get_iScalar('Relax CASSCF root',i)
        IF (RootMap(i).NE.i) THEN
          CALL Put_iScalar('Relax CASSCF root',RootMap(i))
          CALL Put_iScalar('Relax Original root',RootMap(i))
        END IF
      END IF
      CALL Qpg_iScalar('NumGradRoot',Found)
      IF (Found) THEN
        Call Get_iScalar('NumGradRoot',i)
        IF (RootMap(i).NE.i)
     &    CALL Put_iScalar('NumGradRoot',RootMap(i))
      END IF
      CALL Put_lScalar('Track Done',.TRUE.)
*
      RETURN
*
      END SUBROUTINE Process_Track

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
*               Thomas Bondo Pedersen                                  *
*               Francesco Aquilante                                    *
************************************************************************
      SubRoutine BasFun_Atom_(nBas_per_Atom,nBas_Start,Name,
     &                        jBas,nBas,nAtoms,DoPrint)
C
C     Author: Y. Carissan / T. B. Pedersen
C             [adapted to cases with symmetry by F. Aquilante]
C
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
      Integer jBas, nBas, nAtoms
      Integer nBas_per_Atom(nAtoms), nBas_Start(nAtoms)
      Character*(LENIN8) Name(nBas)
      Character*(LENIN) AtName(nAtoms)
      Logical DoPrint

      Character*12 SecNam
      Parameter (SecNam = 'BasFun_Atom_')

      Integer iAt, kBas, iCount

      Character*(LENIN)  Lbl
      Character*80 Txt, Formt


C     Counters.
C     ---------

C IFG: To count basis functions per atom, we need a list of atom names,
C      since there is no guarantee all atoms will be present in a give irrep
      Call Get_cArray('Unique Atom Names',AtName,(LENIN)*nAtoms)

      kBas = jBas
      Do iAt = 1, nAtoms
         nBas_per_Atom(iAt) = 0
         Lbl = AtName(iAt)
         Do While ((Name(kBas)(1:LENIN).eq.Lbl) .and. (kBas.le.nBas))
            nBas_per_Atom(iAt) = nBas_per_Atom(iAt) + 1
            kBas = kBas + 1
         End Do
      End Do

C     Offsets.
C     --------

      iCount = 0
      Do iAt = 1,nAtoms
         nBas_Start(iAt) = iCount + 1
         iCount = iCount + nBas_per_Atom(iAt)
      End Do
      jCount = iCount + jBas - 1
      If (jCount .ne. nBas) Then
         Write(Txt,'(A,I9,A,I9)') 'jCount =',jCount,'  nBas =',nBas
         Call SysAbendMsg(SecNam,'jCount.NE.nBas',Txt)
      End If

C     Print.
C     ------

      If (DoPrint) Then
         Write(Formt,'(3(a6,i3,a5))') '(/,a6,',nAtoms,'i5,/,',
     &                                '   a6,',nAtoms,'i5,/,',
     &                                '   a6,',nAtoms,'i5)'
         Write(6,Formt) 'Atom  ',(iAt,iAt=1,nAtoms),
     &                  'Start ',(nBas_Start(iAt),iAt=1,nAtoms),
     &                  'nBas  ',(nBas_per_Atom(iAt),iAt=1,nAtoms)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine makecivbhs_cvb(civbh,civbs,orbs)
! Construct CIVBS ( = T(s) * CIVB ) & CIVBH ( = T(O)*H*T(O) * CIVB ):

use casvb_global, only: icnt_ci, ndet, norb
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: civbh(0:ndet), civbs(0:ndet)
real(kind=wp), intent(in) :: orbs(norb,norb)
integer(kind=iwp) :: icivbh, icivbs

icivbh = nint(civbh(0))
icivbs = nint(civbs(0))
if ((icnt_ci(icivbs) == 4) .and. (icnt_ci(icivbh) == 5)) then
  return
else if (icnt_ci(icivbs) == 4) then
  call applyth_cvb(civbh,orbs)
else if (icnt_ci(icivbs) == 5) then
  call applyts_cvb(civbs,orbs)
else
  call applyths_cvb(civbh,civbs,orbs)
end if
icnt_ci(icivbs) = 4
icnt_ci(icivbh) = 5

return

end subroutine makecivbhs_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Christian Ander                                  *
************************************************************************
      Subroutine EU(dq,dg,gi,H,nH)
      Implicit Real*8   (a-h,o-z)
      Real*8 H(nH,nH), dq(nH), dg(nH), gi(nH)
#include "WrkSpc.fh"
*
      Call Allocate_Work(ip_M,    nH**2      )
      Call Allocate_Work(ip_WorkM,nH**2      )
      Call Allocate_Work(ip_E    ,nH**2      )
      Call Allocate_Work(ip_EVec ,nH**2      )
      Call Allocate_Work(ip_u    ,nH         )
      Call Allocate_Work(ip_v    ,nH         )
      Call Allocate_Work(ip_EVal ,nH*(nH+1)/2)
      Call Allocate_Work(ip_p    ,nH         )
      Call Allocate_Work(ip_f    ,nH         )
      Call Allocate_Work(ip_WorkV,nH         )
*
      Call EU_(dq,dg,gi,H,nH,Work(ip_M),Work(ip_WorkM),
     &         Work(ip_E),Work(ip_EVec),Work(ip_u),Work(ip_v),
     &         Work(ip_Eval),Work(ip_p),Work(ip_f),Work(ip_WorkV))
*
      Call Free_Work(ip_WorkV)
      Call Free_Work(ip_f    )
      Call Free_Work(ip_p    )
      Call Free_Work(ip_EVal )
      Call Free_Work(ip_v    )
      Call Free_Work(ip_u    )
      Call Free_Work(ip_EVec )
      Call Free_Work(ip_E    )
      Call Free_Work(ip_WorkM)
      Call Free_Work(ip_M   )
*
      Return
      End
      Subroutine EU_(dq,dg,gi,H,nH,M,WorkM,E,EVec,u,v,Eval,p,f,WorkV)
      Implicit None
*                                                                      *
*     Implemented by Christian Ander, 2005, christian@eximius.se       *
*                                                                      *
************************************************************************
*                                                                      *
*     Hessian update method; EU ;from Bofill "Remarks on the Updated   *
*     Hessian Matrix Methods" 2003.                                    *
*                                                                      *
*     Vectors are column vectors.                                      *
*                                                                      *
*     Stuff to do:                                                     *
*                  Double definition for gi, check again if gi is more *
*                  correct.                                            *
*                                                                      *
*                  the expression for dE is makeing the surface wierd  *
************************************************************************
*                                                                      *
*     gi    :  gradient from previous it.(nH)
*     dg    :  gradient difference       (nH)
*     de    :  energy constant           (real*8)
*     dq    :  Perturbation Geometry     (nH)
*     Eval  :  EigenValues of Hessian    (nH*(nH+1)/2)
*     Evec  :  EigenVector(s) of Hessian (nH,nH)
*     M     :  M-Matrix                  (nH,nH)
*     E     :  Error matrix              (nH,nH)
*     WorkM :  Temporary working matrix  (nH,nH)
*     WorkV :  Temporary working vector  (nH)
*     WorkR :  Temporary working varii   (real*8)
*     H     :  Hessian                   (nH,nH)
*     nH    :  Hessian size              (integer)
*     p,f   :  Multi-used vectors        (nh)
*     mi    :  Used varii                (real*8)
*
#include "real.fh"
      Integer nH, i, j, ij, ii
      Real*8 M(nH,nH), WorkM(nH,nH), E(nH,nH), Evec(nH,nH), H(nH,nH)
      Real*8 dq(nH), u(nH),  v(nH), dg(nH), gi(nH), Eval(nH*(nH+1)/2)
      Real*8 p(nH) , f(nH), WorkV(nH)
      Real*8 WorkR, de, mi, ddot_, lim
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUG
#ifdef _DEBUGPRINT_
*     Make a comment in logfile
      write(6,*) 'hello from eu.f'
      Call RecPrt('H matrix',' ',H,nH,nH)
#endif
*
*---- Calculate Eval and Evec
*
*     Make a triangular form of H that Jacob/NIDiag accepts
*
       Do i=1,nH
         Do j=1,i
            ij = i*(i-1)/2 + j
            EVal(ij) = (H(i,j) + H(j,i)) / 2.0d0
         End Do
      End Do
*
*     Make a unit Matrix
*
      Call FZero(Evec, nH**2)
      call dcopy_(nH,[1.0d0],0,Evec,nH+1)
*
*     Get the eigenvalues and eigenvectors
*
      Call NIDiag_new(Eval,Evec,nH,nH,0)
#ifdef _DEBUGPRINT_
      Call RecPrt('Evec matrix',' ',Evec,nH,nH)
#endif
*
*---- Calculate mi, diagonal elements of M matrix (eq. 18)
*
      Call FZero(M,nH**2)
#ifdef _DEBUGPRINT_
      Call RecPrt('gi-vector',' ',gi,1,nH)
      Call RecPrt('dq-vector',' ',dq,1,nH)
#endif
*
*     p = <t|dq>
*
      Call DGEMM_('N','N',
     &            1,nH,nH,
     &            1.0d0,dq,1,
     &            Evec,nH,
     &            0.0d0,p,1)
*
*     f = <t|gi>
*
      Call DGEMM_('N','N',
     &            1,nH,nH,
     &            1.0d0,gi,1,
     &            Evec,nH,
     &            0.0d0,f,1)
*
#ifdef _DEBUG
      Call RecPrt('p-vector',' ',p,1,nH)
      Call RecPrt('f-vector',' ',f,1,nH)
#endif
*
*- -  The mi calculation loop
*
      Do i  = 1, nH
*
*     If p(i) = 0 we ignore this mode
         lim  = 0.0000005D0
         if ( p(i).LT.-lim .OR. p(i).GT.lim ) Then
*
*     The triangular indexation, ii.
         ii = i*(i+1)/2
*
*     Negative sign for the TS-reaction coordinate.
*     WorkR = (-)f*p
*
            if ( Eval(ii).GT.0.0D0) Then
               WorkR = f(i)*p(i)
               de = Abs(1.0d0/(2.0d0 * Eval(ii) * p(i)**2) + WorkR)
            Else
               WorkR = -f(i)*p(i)
               de = 1.0d0
            End If
*
            mi = Exp(-(1.0d0/2.0d0*Abs(Eval(ii)) * p(i)**2 + WorkR +
     &           f(i)**2 / ( 2.0D0*Abs(Eval(ii)) )) / de) *
     &           Sqrt( Abs(Eval(ii)) / (2.0D0*Pi*de) )
*
*     Experimental! (worked well)
*
*           mi = (1-Exp(-mi/1))*1
*
*     Store mi value in M
            M(i,i) = 1.0d0
#ifdef _DEBUGPRINT_
            write(6,*) "mi ", mi, "  Energy ", de,"  Eigenvalue "
     &           ,Eval(ii)
#endif
*
*     p(i) = 0, so mi is set to zero.
         Else
            M(i,i) = 1.0d0
            ii = i*(i+1)/2
#ifdef _DEBUGPRINT_
            write(6,*) "mi = p 1.0  Eigenvalue ",Eval(ii)
#endif
         End If
      End Do
*
*---- Building of M-matrix (equation 16)
*
*     M = WorkM * T^T = T * M * T^T
*
      Call DGEMM_('N','N',
     &            nH,nH,nH,
     &            1.0d0,Evec,nH,
     &            M,nH,
     &            0.0d0,WorkM,nH)
      Call DGEMM_('N','T',
     &            nH,nH,nH,
     &            1.0d0,WorkM,nH,
     &            Evec,nH,
     &            0.0d0,M,nH)
#ifdef _DEBUGPRINT_
      Call RecPrt('M-matrix',' ',M,nH,nH)
#endif
correct
*
*---- Building of error matrix E (equation 5)
*
*- -  u = ( dq^T * M * dq )^-1 *  M * dq = ( dq^T * WorkV )^-1 * WorkV
*       = WorkR * WorkV
*
*     WorkV = M * dq
*
      WorkR = DDot_(nH,dq,1,dq,1)
#ifdef _DEBUGPRINT_
      write(6,*)WorkR, " = <dq|dq>, should be one?"
#endif
      Call DGEMM_('N','N',
     &            nH,1,nH,
     &            1.0d0,M,nH,
     &            dq,nH,
     &            0.0d0,WorkV,nH)
*
*     WorkR = ( dq^T * WorkV )^-1
*
      WorkR = DDot_(nH,dq,1,WorkV,1)
      if (WorkR.NE.0.0D0) then
         WorkR = 1.0d0 / WorkR
      End If
*
*     u = u + WorkR * WorkV
*
      Call FZero(u,nH)
      Call DaxPy_(nH,WorkR,WorkV,1,u,1)
*
*- -  v = dg - H * dq (equation 3, quasi-Newton condition)
*
*     according to the paper, we want the Next iterationstep, but
*     who doesn't? So we take the current and the previously.
*
      call dcopy_(nH,dg,1,v,1)
      Call DGEMM_('N','N',nH,1,nH,
     &           -1.0d0, H ,nH ,
     &                   dq,nH ,
     &            1.0d0, v ,nH )
*
*- -  E = v*u^T + u*v^T - ( v^T*dq ) u*u^T (equation 5)
*
*     E = v*u^T
*
      Call DGEMM_('N','N',
     &            nH,nH,1,
     &            1.0d0,v,nH,
     &            u,1,
     &            0.0d0,E,nH)
*
*     WorkR = -v^T*dq
*
      WorkR = -DDot_(nH,v,1,dq,1)
*
*     E = E + WorkR * u*u^T = v*u^T - ( v^T*dq ) * u*u^T
*
      Call DGEMM_('N','N',nH,nH,1,
     &            WorkR ,u ,  nH,
     &                   u ,  1 ,
     &            1.0d0 ,E ,  nH )
*
*     E = E + u*v^T = v*u^T - ( v^T*dq ) u*u^T + u*v^T
*
      Call DGEMM_('N','N',nH,nH,1,
     &            1.0d0 ,u ,  nH,
     &                   v ,  1 ,
     &            1.0d0 ,E ,  nH )
#ifdef _DEBUGPRINT_
      Call RecPrt('Error matrix',' ',E,nH,nH)
#endif
*
*---- The new Hessian (H = H + E, equation 1)
*
      Call DaxPy_(nH*nH,1.0d0,E,1,H,1)
#ifdef _DEBUGPRINT_
      Call RecPrt('new Hessian',' ',H,nH,nH)
#endif
*
*     Checking the Quasi-Newton condition.
*
*     WorkV = H * dq
*
      Call DGEMM_('N','N',
     &            nH,1,nH,
     &            1.0d0,H,nH,
     &            dq,nH,
     &            0.0d0,WorkV,nH)
*
*     WorkV = WorkV - dg = 0.00
*
#ifdef _DEBUGPRINT_
      Call DaxPy_(nH,-1.0d0,dg,1,WorkV,1)
      Call RecPrt('Quasi-Newton',' ',WorkV,1,nH)
*
      write(6,*) 'goodby from eu.f'
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Get_nAtoms_Full
!
!> @author I. Fdez. Galv&aacute;n
!>
!> @details
!> Get number of all atoms (not only symmetry unique) from RUNFILE,
!> including MM atoms otherwise invisible to gateway/slapaf.
!>
!> @param[out] nAtoms_Full Number of all atoms in the system
!***********************************************************************

subroutine Get_nAtoms_Full(nAtoms_Full)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: nAtoms_Full
integer(kind=iwp) :: nAtMM, nAtom
logical(kind=iwp) :: Found

call Get_nAtoms_All(nAtom)
call Qpg_dArray('MMO Coords',Found,nAtMM)
nAtoms_Full = nAtom+nAtMM/3

return

end subroutine Get_nAtoms_Full

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Francesco Aquilante                              *
************************************************************************
      SubRoutine DrvN1_EMB(Grad,Temp,nGrad)
************************************************************************
*                                                                      *
* Object: to compute the molecular gradient contribution due to the    *
*         inter-subsystem nuclear repulsion energy                     *
*                                                                      *
* Called from: Alaska                                                  *
*                                                                      *
* Author : F. Aquilante, Geneva, Nov 2010                              *
************************************************************************
      Use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "SysDef.fh"
#include "print.fh"
#include "real.fh"
#include "disp.fh"
#include "rctfld.fh"
#include "WrkSpc.fh"
#include "status.fh"
      Real*8 A(3), B(3), RB(3), Grad(nGrad), Temp(nGrad)
      Integer iDCRR(0:7)
      Logical EQ, TstFnc
      Character*16 NamRfil
      Character*80 Lab
*
************************************************************************
*     Statement function for Charges of subsystem B
      Charge_B(i) = Work(ip_ChargeB+i-1)
************************************************************************
*
      If (nIrrep .gt. 1) Then
         Call WarningMessage(2,'Error in DrvN1_Emb')
         Write(6,*)'Sorry, OFE gradient code does not understand'
         Write(6,*)'the use of subsystem symmetry!'
         Call Quit_OnUserError()
      EndIf
      iRout = 33
      iPrint = nPrint(iRout)
*
      iIrrep = 0
      call dcopy_(nGrad,[Zero],0,Temp,1)
*
      Call Get_NameRun(NamRfil) ! save the old RUNFILE name
      Call NameRun('AUXRFIL')   ! switch RUNFILE name
*
      Call GetMem('B-Charges','Allo','Real',ip_ChargeB,nCnttp)
      Call Get_dArray('Nuclear charge',Work(ip_ChargeB),nCnttp)
*
      Call NameRun(NamRfil)   ! switch back to old RUNFILE name
*
      ZA=1.0d0
      iCnttp=1
      Do while (iCnttp.le.nCnttp .and. ZA.gt.0.0d0)
         ZA = dbsc(iCnttp)%Charge
         iCnttp = iCnttp + 1
      End Do
      iCnttp_B=iCnttp-1  ! start of atoms of subsystem B
*
      If (iCnttp_B.eq.1) Then ! subsystem B comes first
         ZB=0.0d0
         nCnttp_B=1
         Do while (nCnttp_B.le.nCnttp .and. ZB.eq.0.0d0)
            ZB = dbsc(nCnttp_B)%Charge
            nCnttp_B = nCnttp_B + 1
         End Do
         nCnttp_B=nCnttp_B-1  ! end of atoms of subsystem B
      Else
         nCnttp_B=nCnttp
      EndIf
*
      mdc = 0
*-----Loop over centers with the same charge (A-subsystem)
      Do iCnttp = 1, nCnttp
         ZA = dbsc(iCnttp)%Charge
         If (iCnttp.ge.iCnttp_B .and. iCnttp.le.nCnttp_B
     &                          .and. ZA.gt.0.0d0) Then
            Call WarningMessage(2,'Internal error in DrvN1_Emb')
            Write(6,*)' Subsystems must come one after the other'
            Call Abend()
         EndIf
         If (ZA.eq.Zero) Go To 101
*--------Loop over all unique centers of this group (A-subsystem)
         Do iCnt = 1, dbsc(iCnttp)%nCntr
            A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
            ndc = 0
            Do jCnttp = iCnttp_B, nCnttp_B  ! (B-subsystem)

               ZB = Charge_B(jCnttp)

               If (ZB.eq.Zero) Go To 201
               ZAZB = ZA * ZB
               jCntMx = dbsc(jCnttp)%nCntr
               Do jCnt = 1, jCntMx
                  B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
                  Fact = One
*                 Factor due to resticted summation
                  If (EQ(A,B)) Fact = Half
*
*                 Find the DCR for the two centers
*
                  Call DCR(LmbdR,
     &                     dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,
     &                     dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                     iDCRR,nDCRR)
*
                  PreFct = Fact*ZAZB*DBLE(nIrrep)/DBLE(LmbdR)
                  Do iR = 0, nDCRR-1
                     Call OA(iDCRR(iR),B,RB)
                     nOp = NrOpr(iDCRR(iR))
                     If (EQ(A,RB)) Go To 301
                     r12 = Sqrt((A(1)-RB(1))**2 +
     &                          (A(2)-RB(2))**2 +
     &                          (A(3)-RB(3))**2 )
*
*                    The factor u/g will ensure that the value of the
*                    gradient in symmetry adapted and no symmetry basis
*                    will have the same value.
*
                     fab=One
                     dfab=Zero
                     If (dbsc(iCnttp)%ECP) Then
*-----------------------Add contribution from M1 operator
                        Cnt0M1=Zero
                        Cnt1M1=Zero
                        Do iM1xp=1, dbsc(iCnttp)%nM1
                          Gamma =dbsc(iCnttp)%M1xp(iM1xp)
                          CffM1 =dbsc(iCnttp)%M1cf(iM1xp)
                          Cnt0M1=Cnt0M1+(CffM1*Exp(-Gamma*r12**2))
                          Cnt1M1=Cnt1M1+Gamma*(CffM1*Exp(-Gamma*r12**2))
                        End Do
                        fab=fab+Cnt0M1
                        dfab=dfab-Two*r12*Cnt1M1
*-----------------------Add contribution from M2 operator
                        Cnt0M2=Zero
                        Cnt1M2=Zero
                        Do iM2xp=1, dbsc(iCnttp)%nM2
                          Gamma =dbsc(iCnttp)%M2xp(iM2xp)
                          CffM2 =dbsc(iCnttp)%M2cf(iM2xp)
                          Cnt0M2=Cnt0M2+(CffM2*Exp(-Gamma*r12**2))
                          Cnt1M2=Cnt1M2+Gamma*(CffM2*Exp(-Gamma*r12**2))
                        End Do
                        fab=fab+r12*Cnt0M2
                        dfab=dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
                     End If
                     If (dbsc(jCnttp)%ECP) Then
*-----------------------Add contribution from M1 operator
                        Cnt0M1=Zero
                        Cnt1M1=Zero
                        Do iM1xp=1, dbsc(jCnttp)%nM1
                          Gamma =dbsc(jCnttp)%M1xp(iM1xp)
                          CffM1 =dbsc(jCnttp)%M1cf(iM1xp)
                          Cnt0M1=Cnt0M1+(CffM1*Exp(-Gamma*r12**2))
                          Cnt1M1=Cnt1M1+Gamma*(CffM1*Exp(-Gamma*r12**2))
                        End Do
                        fab=fab+Cnt0M1
                        dfab=dfab-Two*r12*Cnt1M1
*-----------------------Add contribution from M2 operator
                        Cnt0M2=Zero
                        Cnt1M2=Zero
                        Do iM2xp=1, dbsc(jCnttp)%nM2
                          Gamma =dbsc(jCnttp)%M2xp(iM2xp)
                          CffM2 =dbsc(jCnttp)%M2cf(iM2xp)
                          Cnt0M2=Cnt0M2+(CffM2*Exp(-Gamma*r12**2))
                          Cnt1M2=Cnt1M2+Gamma*(CffM2*Exp(-Gamma*r12**2))
                        End Do
                        fab=fab+r12*Cnt0M2
                        dfab=dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
                     End If
                     df_dr=(dfab*r12-fab)/r12**2
*
                     If (.Not.dbsc(iCnttp)%pChrg) Then
                     nDisp = IndDsp(mdc+iCnt,iIrrep)
                     igu=nIrrep/dc(mdc+iCnt)%nStab
                     Do iCar = 0, 2
                        dr_dA=(A(iCar+1)-RB(iCar+1))/r12
                        iComp = 2**iCar
                        If ( TstFnc(dc(mdc+iCnt)%iCoSet,
     &                     iIrrep,iComp,dc(mdc+iCnt)%nStab) ) Then
                           nDisp = nDisp + 1
                           If (Direct(nDisp)) Then
                              Temp(nDisp) = Temp(nDisp) +
     &                           One/DBLE(igu) * PreFct *
     &                           dr_dA * df_dr
                           End If
                        End If
                     End Do
                     End If
 301                 Continue
                  End Do
               End Do
 201           Continue
               ndc = ndc + dbsc(jCnttp)%nCntr
            End Do
         End Do
 101     Continue
         mdc = mdc + dbsc(iCnttp)%nCntr
      End Do
      If (iPrint.ge.15) Then
         Lab=' OFE Nuclear Repulsion Contribution'
         Call PrGrad(Lab,Temp,nGrad,ChDisp,5)
      End If
*
      Call GetMem('B-Charges','Free','Real',ip_ChargeB,nCnttp)
*
      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function FNDMNX(VECTOR,NDIM,MINMAX)
! FIND SMALLEST(MINMAX=1) OR LARGEST(MINMAX=2)
! ABSOLUTE VALUE OF ELEMENTS IN VECTOR

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: FNDMNX
integer(kind=iwp), intent(in) :: NDIM, MINMAX
real(kind=wp), intent(in) :: VECTOR(NDIM)
integer(kind=iwp) :: I
real(kind=wp) :: res

res = Zero
if (NDIM > 0) then

  if (MINMAX == 1) then
    res = huge(res)
    do I=1,NDIM
      res = min(res,abs(VECTOR(I)))
    end do
  else if (MINMAX == 2) then
    do I=1,NDIM
      res = max(res,abs(VECTOR(I)))
    end do
  end if

end if

FNDMNX = res

return

end function FNDMNX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_Allo_iScr(DoDummy)
C
C     Purpose: allocate iScr array for reading and reordering vectors.
C              If (DoDummy): make dummy (length 1) allocation.
C
      Implicit None
      Logical DoDummy
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer iSym

      If (DoDummy) Then
         l_iScr = 1
      Else
         l_iScr = nnBstR(1,1)
         Do iSym = 2,nSym
            l_iScr = max(l_iScr,nnBstR(iSym,1))
         End Do
      End If
      Call Cho_Mem('ISCR','Allo','Inte',ip_iScr,l_iScr)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine schmidtt2_cvb(c,sxc,nvec,t,nt,sao,n,metr)
      implicit real*8 (a-h,o-z)
      dimension c(n,nvec),sxc(n,nvec),t(nt,nvec),sao(*)
      save thresh,one
      data thresh/1d-20/,one/1d0/

      do 100 i=1,nvec
      do 200 j=1,i-1
      fac=-ddot_(n,c(1,i),1,sxc(1,j),1)
      call daxpy_(n,fac,c(1,j),1,c(1,i),1)
      call daxpy_(nt,fac,t(1,j),1,t(1,i),1)
200   continue
      if(metr.ne.0)call saoon_cvb(c(1,i),sxc(1,i),1,sao,n,metr)
      cnrm=ddot_(n,c(1,i),1,sxc(1,i),1)
      if(cnrm.lt.thresh)then
        write(6,*)' Warning : near-singularity in orthonormalization.'
        write(6,*)' Vector norm :',cnrm
      endif
      fac=one/sqrt(cnrm)
      call dscal_(n,fac,c(1,i),1)
      if(metr.ne.0)call dscal_(n,fac,sxc(1,i),1)
      call dscal_(nt,fac,t(1,i),1)
100   continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_REOINI()
!
! Purpose: initializations for vector reordering.

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use Cholesky, only: NABPK, NBAS, NNBST, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ISYM, ISYMA, ISYMB

NNBST(1:NSYM) = 0
do ISYMA=1,NSYM
  do ISYMB=1,ISYMA-1
    NABPK(ISYMA,ISYMB) = NBAS(ISYMA)*NBAS(ISYMB)
    NABPK(ISYMB,ISYMA) = NABPK(ISYMA,ISYMB)
    ISYM = MUL(ISYMB,ISYMA)
    NNBST(ISYM) = NNBST(ISYM)+NABPK(ISYMA,ISYMB)
  end do
  NABPK(ISYMA,ISYMA) = nTri_Elem(NBAS(ISYMA))
  NNBST(1) = NNBST(1)+NABPK(ISYMA,ISYMA)
end do

call CHO_OPFVEC(1,0)

end subroutine CHO_REOINI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!               2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine GenerateP(Ovlp,cMO,BName,nBasis,nOrb2Loc,nAtoms,nBas_per_Atom,nBas_Start,PA,Debug)
! Author: Yannick Carissan.
!
! Modifications:
!    - October 6, 2005 (Thomas Bondo Pedersen):
!      Reduce operation count and use BLAS.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nBasis, nOrb2Loc, nAtoms, nBas_per_Atom(*), nBas_Start(*)
real(kind=wp), intent(in) :: Ovlp(nBasis,nBasis), cMO(nBasis,*)
real(kind=wp), intent(out) :: PA(nOrb2Loc,nOrb2Loc,nAtoms)
character(len=LenIn8), intent(in) :: BName(*)
logical(kind=iwp), intent(in) :: Debug
integer(kind=iwp) :: iAt, iMO_s, iMO_t
real(kind=wp) :: PAst, PAts
character(len=LenIn8) :: PALbl
real(kind=wp), allocatable :: SBar(:,:)

call mma_Allocate(SBar,nBasis,nOrb2Loc,Label='SBar')

! Compute Sbar(mu,s) = sum_{nu} Ovlp(mu,nu) * cMO(nu,s)

call DGEMM_('N','N',nBasis,nOrb2Loc,nBasis,One,Ovlp,nBasis,cMO,nBasis,Zero,Sbar,nBasis)

do iAt=1,nAtoms

  ! Compute MA(s,t) = sum_{mu_in_A} cMO(mu,s) * Sbar(mu,t)

  call DGEMM_('T','N',nOrb2Loc,nOrb2Loc,nBas_per_Atom(iAt),One,cMO(nBas_Start(iAt),1),nBasis,Sbar(nBas_Start(iAt),1),nBasis,Zero, &
              PA(1,1,iAt),nOrb2Loc)

  ! Compute <s|PA|t> by symmetrization of MA.

  do iMO_s=1,nOrb2Loc
    do iMO_t=iMO_s+1,nOrb2Loc
      PAst = PA(iMO_s,iMO_t,iAt)
      PAts = PA(iMO_t,iMO_s,iAt)
      PA(iMO_s,iMO_t,iAt) = Half*(PAst+PAts)
      PA(iMO_t,iMO_s,iAt) = PA(iMO_s,iMO_t,iAt)
    end do !iMO_t
  end do !iMO_s

end do !iAt

if (Debug) then
  write(u6,*) 'In GenerateP'
  write(u6,*) '------------'
  do iAt=1,nAtoms
    PALbl = 'PA__'//BName(nBas_Start(iAt))(1:LenIn)
    call RecPrt(PALbl,' ',PA(:,:,iAt),nOrb2Loc,nOrb2Loc)
  end do
end if

call mma_deallocate(SBar)

return

end subroutine GenerateP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine initialize_blas(lib,prlev)
  use link_blas
  implicit none
  character(len=*), intent(in) :: lib
  integer, intent(in) :: prlev
  call lb_initialize(lib,prlev)
end subroutine initialize_blas

subroutine close_blas()
  use link_blas
  implicit none
  call lb_close()
end subroutine close_blas

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986,1995, Bernd Artur Hess                            *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

subroutine TrSmr2(A,B,C,N,H,G,W)
! Performs the equivalent operations as two calls to TrSmr
! RESULT IS IN C = G^T * (B^T * A * B) * G
! and where C and A are triangular packed.

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: A(N*(N+2)/2), B(N,N), G(N,N)
real(kind=wp), intent(out) :: C(N*(N+1)/2), H(N,N), W(N,N)

call Square(A,W,n,1,n)
call DGEMM_('T','N',n,n,n,One,B,n,W,n,Zero,H,n)
call DGEMM_('N','N',n,n,n,One,H,n,B,n,Zero,W,n)
call DGEMM_('T','N',n,n,n,One,G,n,W,n,Zero,H,n)
call dGemm_tri('N','N',n,n,n,One,H,n,G,n,Zero,C,n)

return

end subroutine TrSmr2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Ignacio Fdez. Galvan                             *
************************************************************************
*  Davidson
*
*> @brief
*>   Compute the lowest \p k eigenvalues of a symmetric matrix.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Simple application of the Davidson procedure to obtain the lowest \p k eigenvalues
*> and corresponding eigenvectors of a symmetric matrix.
*> On input, \p Vec can contain an initial guess for the eigenvectors (from a previous
*> run with smaller \p k, for example), only the non-zero vectors are used.
*>
*> @param[in]     A   Symmetric matrix, in upper triangular packed format
*> @param[in]     n   Size of the matrix
*> @param[in]     k   Number of lowest eigenvalues to compute
*> @param[out]    Eig Lowest eigenvalues
*> @param[in,out] Vec Lowest eigenvectors
*> @param[out]    iRC Return code (0 if converged)
************************************************************************
      SUBROUTINE Davidson(A,n,k,Eig,Vec,iRC)
      IMPLICIT NONE
      INTEGER n,k,iRC
      REAL*8 A(n*(n+1)/2),Eig(k),Vec(n,k)
      REAL*8, DIMENSION(:), ALLOCATABLE :: Eig_old, EVec, Sub, Ab, Proj,
     &                                     EVal
      REAL*8 Aux,Thr,Thr2,Thr3,Conv,Alpha
      real*8 ddot_
      INTEGER mk,old_mk,mink,maxk,ig,info,nTmp,iter,maxiter
      INTEGER i,j,ii,jj
      INTEGER ipVec,ipTmp,ipVal,ipDum,ipIndex
      INTEGER ipDiag,ipTVec,ipTAV,ipTRes
      LOGICAL Last,Augmented,Reduced
      external ddot_
      PARAMETER (Thr=1.0D-7, maxiter=300, Thr2=1.0D-16, Thr3=1.0D-16)
*
#include "stdalloc.fh"
#include "real.fh"
#include "WrkSpc.fh"
      INTEGER iPrint,iRout
#include "print.fh"

*define _DEBUGPRINT_
* Diagonal preconditioned residue (Davidson)
#define DAV_DPR 1
* Inverse-iteration generalized Davidson (Olsen et al.)
#define DAV_IIGD 2
* Generalized Jacobi-Davidson (Sleijpen et al.) (DO NOT USE IT)
#define DAV_GJD 3

      iRout=216
      iPrint=nPrint(iRout)

#ifdef _DEBUGPRINT_
      CALL TriPrt('Initial matrix','',A,n)
#endif

*---- Initialize some parameters
*      mk   = subspace size (initially k)
*      maxk = maximum subspace size (25 if k=1)
*      mink = subspace size to reduce to when the maximum is exceeded (5 if k=1)
*
      IF (k.GT.n) THEN
        CALL SysAbendMsg('Davidson','Wrong k value.','')
      END IF
      mink=MIN(MAX(k+2,5),n)
      maxk=MIN(5*mink,n)
      mk=k
      iRC=0

*---- If all the eigenvalues are wanted, better solve the system directly
*      and return
*
      IF (mk.GE.n) THEN
        CALL GetMem('Values ','Allo','Real',ipVal,n)
        CALL GetMem('Vectors','Allo','Real',ipVec,n*n)
        CALL DZero(Work(ipVec),n*n)
        DO j=1,n
          jj=(j-1)*n
          DO i=1,j
            Work(ipVec+jj+i-1)=A(j*(j-1)/2+i)
          END DO
        END DO
        CALL Allocate_Work(ipDum,1)
        call dsyev_('V','U',n,Work(ipVec),n,Work(ipVal),Work(ipDum),
     &                       -1,info)
        nTmp=INT(Work(ipDum))
        CALL Allocate_Work(ipTmp,nTmp)
        call dsyev_('V','U',n,Work(ipVec),n,Work(ipVal),Work(ipTmp),
     &                       nTmp,info)
        CALL JacOrd2(Work(ipVal),Work(ipVec),n,n)
        CALL Free_Work(ipTmp)
        CALL Free_Work(ipDum)
        call dcopy_(k,Work(ipVal),1,Eig,1)
        call dcopy_(n*k,Work(ipVec),1,Vec,1)
        CALL GetMem('Values ','Free','Real',ipVal,n)
        CALL GetMem('Vectors','Free','Real',ipVec,n*n)
#ifdef _DEBUGPRINT_
        IF (iPrint .GE. 99) THEN
          CALL RecPrt('Eigenvalues',' ',Eig,1,n)
          WRITE(6,*)
        END IF
        WRITE(6,'(A)') 'Complete system solved'
#endif
        RETURN
      END IF

*---- Allocate matrices
*      Sub  = Vectors (columns) defining the subspace (maximum maxk vectors)
*      Ab   = A*b vectors (A * Sub)
*      EVal  = Set of computed eigenvalues (maximum maxk elements)
*      EVec  = Set of computed eigenvectors, in the subspace (maximum maxk*maxk)
*
      CALL mma_allocate(Eig_old,k,label="Eig_old")
      Call mma_allocate(Sub,n*maxk,Label='Sub')
      Call mma_allocate(Ab ,n*maxk,Label='Ab ')
      Call mma_allocate(Proj,maxk*maxk,Label='Proj')
      Call mma_allocate(EVal,maxk     ,Label='EVal')
      Call mma_allocate(EVec,maxk*maxk,Label='EVec')
      CALL DZero(Ab,n*maxk)
      CALL DZero(EVal,maxk)
      CALL DZero(EVec,maxk*maxk)

*---- Build an index of sorted diagonal elements in A
*
      CALL Allocate_iWork(ipIndex,n)
      DO i=1,n
        iWork(ipIndex+i-1)=i
      END DO
      DO i=1,n
        ii=iWork(ipIndex+i-1)
        Aux=A(ii*(ii+1)/2)
        ii=i
        DO j=i,n
          jj=iWork(ipIndex+j-1)
          IF (A(jj*(jj+1)/2) .LT. Aux) THEN
            Aux=A(jj*(jj+1)/2)
            ii=j
          END IF
        END DO
        IF (ii .NE. i) THEN
          jj=iWork(ipIndex+ii-1)
          iWork(ipIndex+ii-1)=iWork(ipIndex+i-1)
          iWork(ipIndex+i-1)=jj
        END IF
      END DO

*---- Setup the initial subspace
*      Read the non-linear-dependent columns from the initial eigenvector matrix
*      Fill up to mk with selected base vectors from the initial matrix
*       (those corresponding to the lowest diagonal elements)
*      The rest is set to zero, just in case
*
      nTmp=0
      CALL Allocate_Work(ipTmp,n)
      DO i=1,k
        call dcopy_(n,Vec(1,i),1,Work(ipTmp),1)
        CALL Add_Vector(n,nTmp,Sub,Work(ipTmp),Thr3)
      END DO
*
      ii=0
      CALL DZero(Work(ipTmp),n)
      DO WHILE ((nTmp .LT. mk) .AND. (ii .LT. n))
        ii=ii+1
        jj=iWork(ipIndex+ii-1)
        Work(ipTmp+jj-1)=One
        CALL Add_Vector(n,nTmp,Sub,Work(ipTmp),Thr3)
        Work(ipTmp+jj-1)=Zero
      END DO
*     ig will be a global counter to loop across all n base vectors
      ig=ii
      CALL Free_Work(ipTmp)
      CALL DZero(Sub(1+mk*n),(maxk-mk)*n)

*---- Iterative procedure starts here
*      mk     = subspace size at each iteration
*      old_mk = value of mk at the previous iteration
*
      Augmented=.FALSE.
      Reduced=.FALSE.
      Last=.FALSE.
      old_mk=0
      iter=0
      CALL Allocate_Work(ipDum,1)
      CALL Allocate_Work(ipDiag,n)
      CALL Allocate_Work(ipTVec,n)
      CALL Allocate_Work(ipTAV,n)
      CALL Allocate_Work(ipTRes,n)
      DO WHILE (.NOT. Last)
        iter=iter+1
        IF (iter .GT. 1) call dcopy_(k,Eig,1,Eig_old,1)
#ifdef _DEBUGPRINT_
        IF (.NOT. Reduced) THEN
          WRITE(6,'(A)') '---------------'
          WRITE(6,'(A,1X,I5)') 'Iteration',iter
        END IF
        IF (iPrint .GE. 99)
     &    CALL RecPrt('Orthonormalized subspace',' ',Sub,n,mk)
#endif

*----   Compute the matrix product
*        Ab = A * Sub
*        Only the new vectors since the last iterations need to be calculated
*
        CALL Allocate_Work(ipTmp,n)
        DO i=1,n
*         Reconstruct a row (or column) of the matrix A
          DO j=1,i
            Work(ipTmp+j-1)=A(i*(i-1)/2+j)
          END DO
          DO j=i+1,n
            Work(ipTmp+j-1)=A(j*(j-1)/2+i)
          END DO
*         Compute the i-th element of each new column
          DO j=old_mk,mk-1
            Ab(j*n+i)=DDot_(n,Work(ipTmp),1,Sub(1+j*n),1)
          END DO
        END DO
        CALL Free_Work(ipTmp)

*----   Compute the matrix to diagonalize (symmetric)
*        Proj = Sub^t * Ab
*        Again, only the new rows/columns are needed
*
        IF (old_mk .EQ. 0) THEN
           CALL DGeMM_('T','N',
     &                 mk,mk,n,
     &                 One,Sub,n,
     &                     Ab,n,
     &                 Zero,Proj,maxk)
        ELSE
          DO i=0,mk-1
            DO j=MAX(old_mk,i),mk-1
              Proj(1+i*maxk+j)=DDot_(n,Sub(1+j*n),1,
     &                                     Ab(1+i*n),1)
            END DO
          END DO
        END IF

*----   Compute the eigenvalues of the projected matrix
*        Make sure the eigenpairs are sorted
*        If the subspace has been reduced, no need to compute new eigenpairs
*
        IF (.NOT. Reduced) THEN
#ifdef _DEBUGPRINT_
          WRITE(6,'(2X,A,1X,I5)') 'Solving for subspace size:',mk
#endif
          call dcopy_(maxk*maxk,Proj,1,EVec,1)
          call dsyev_('V','L',mk,EVec,maxk,EVal,
     &                          Work(ipDum),-1,info)
          nTmp=INT(Work(ipDum))
          CALL Allocate_Work(ipTmp,nTmp)
          call dsyev_('V','L',mk,EVec,maxk,EVal,
     &                          Work(ipTmp),nTmp,info)
          CALL Free_Work(ipTmp)
          CALL JacOrd2(EVal,EVec,mk,maxk)
          call dcopy_(k,EVal,1,Eig,1)
#ifdef _DEBUGPRINT_
          CALL RecPrt('Current guess',' ',Eig,1,k)
#endif
        END IF
#ifdef _DEBUGPRINT_
        IF (iPrint .GE. 99) THEN
          CALL RecPrt('Eigenvalues',' ',EVal,1,mk)
          CALL SubRecPrt('Subspace Eigenvectors',' ',EVec,
     &      maxk,mk,mk)
          WRITE(6,*)
        END IF
#endif

*----   Check for convergence
*        Converge if the change in the eigenvalues is small
*         (but if a mink size has been reached)
*        Converge if the full system has been solved
*        Stop if the number of iterations exceeds the maximum
*        Stop if no new vectors to add are found
*
        IF (iter .GT. 1) THEN
          Conv=Zero
          DO i=1,k
            IF (ABS(Eig(i)) .GT. Thr2) THEN
              Conv=MAX(Conv,ABS((Eig(i)-Eig_old(i))/Eig(i)))
            ELSE
              Conv=MAX(Conv,ABS(Eig(i)-Eig_old(i)))
            END IF
          END DO
#ifdef _DEBUGPRINT_
          IF (Augmented)
     &      WRITE(6,'(2X,A,1X,G12.6)') 'Maximum relative eigenvalue '//
     &                                 'change:',Conv
#endif
        ELSE
          Conv=Ten*Thr
        END IF
        old_mk=mk
        IF (Augmented .AND. (Conv .LE. Thr) .AND. (mk .GE. mink)) THEN
#ifdef _DEBUGPRINT_
          WRITE(6,'(A)') 'Converged due to small change'
#endif
          Last=.TRUE.
        ELSE IF (mk .EQ. n) THEN
#ifdef _DEBUGPRINT_
          WRITE(6,'(A)') 'Complete system solved'
#endif
          Last=.TRUE.
        ELSE IF (iter .GE. maxiter) THEN
#ifdef _DEBUGPRINT_
          WRITE(6,'(A)') 'Not converged'
#endif
          Last=.TRUE.
          iRC=1

*----   Reduce the subspace size if it exceeds the maximum (maxk)
*        Sub' = Sub * Vec(1:mink)
*        Sub' should be orthonormal if Sub is orthonormal
*        (A reduction does not consume an iteration)
*       There is also a reduction if the process is stagnated
*
        ELSE IF ((MIN(mk+k,n) .GT. maxk) .OR. (iRC .EQ. 2)) THEN
          IF (iRC .EQ. 2) iRC=0
#ifdef _DEBUGPRINT_
          WRITE(6,'(2X,A,1X,I5)') 'Reducing search space to',mink
#endif
          CALL Allocate_Work(ipTmp,mink*n)
          CALL DGeMM_('N','N',n,mink,mk,One,Sub,n,
     &                                      EVec,maxk,
     &                                  Zero,Work(ipTmp),n)
          call dcopy_(mink*n,Work(ipTmp),1,Sub,1)
          CALL Free_Work(ipTmp)

*----     To make sure Sub' is orthonormal, add the vectors one by one
*
          j=0
          i=0
          DO WHILE ((j .LT. mink) .AND. (i .LT. mk))
            i=i+1
            Call Add_Vector(n,j,Sub,Sub(1+(i-1)*n),Thr3)
          END DO

*----     j should be mink, but who knows...
*
#ifdef _DEBUGPRINT_
          IF (j .LT. mink) THEN
            WRITE(6,'(2X,A,1X,I5)') 'Fewer vectors found:',j
          END IF
#endif
          CALL DZero(Sub(1+j*n),(maxk-j)*n)
          CALL DZero(Ab(1+j*n),(maxk-j)*n)
          CALL DZero(EVec,maxk*maxk)
          DO i=0,j-1
            EVec(1+i*(maxk+1))=One
          END DO
          mk=j
          old_mk=0
          Augmented=.FALSE.
          Reduced=.TRUE.
          iter=iter-1

*----   Expand the subspace
*        For each eigenpair i of the first k,
*        check convergence for the residuals r:
*         r = Ab * Vec(i) - Val(i) * Sub * Vec(i)
*        Add a new vector, orthonormalized with the previous vectors,
*        computed from r and the eigenpair
*        (different possible variants)
*
        ELSE
          CALL Allocate_Work(ipTmp,n)
          Conv=Zero
          jj=0
          DO i=0,k-1
*           Vector in full space: Sub*Vec(i)
            Call dGeMV_('N',n,mk,One,Sub,n,
     &                              EVec(1+i*maxk),1,
     &                          Zero,Work(ipTVec),1)
*           Product of matrix and vector: Ab*Vec(i)
            Call dGeMV_('N',n,mk,One,Ab,n,
     &                              EVec(1+i*maxk),1,
     &                          Zero,Work(ipTAV),1)
*           Residual: (A-Val(i))*Vec(i) = Ab*Vec(i) - Val(i)*Sub*Vec(i)
            call dcopy_(n,Work(ipTAV),1,Work(ipTRes),1)
            call daxpy_(n,-EVal(1+i),Work(ipTVec),1,Work(ipTRes),1)
            Conv=MAX(Conv,DDot_(n,Work(ipTRes),1,Work(ipTRes),1))

*----       Scale vector, orthonormalize, and add to subspace
*
#define DAV_METH DAV_IIGD
#if DAV_METH == DAV_DPR
*           Diagonal matrix to scale the vectors: 1/(A(j,j)-Val(i))
            DO j=0,n-1
              Aux=A((j+1)*(j+2)/2)-Eval(1+i)
              Work(ipDiag+j)=One/SIGN(MAX(ABS(Aux),Thr2),Aux)
            END DO
*           scale
            DO j=0,n-1
              Work(ipTmp+j)=Work(ipTRes+j)*Work(ipDiag+j)
            END DO
#elif DAV_METH == DAV_IIGD
*           Diagonal matrix to scale the vectors: 1/(A(j,j)-Val(i))
            DO j=0,n-1
              Aux=A((j+1)*(j+2)/2)-EVal(1+i)
              Work(ipDiag+j)=One/SIGN(MAX(ABS(Aux),Thr2),Aux)
            END DO
*           scale
            DO j=0,n-1
              Work(ipTmp+j)=Work(ipTRes+j)*Work(ipDiag+j)
            END DO
            Alpha=Zero
            DO j=0,n-1
              Alpha=Alpha+Work(ipDiag+j)*Work(ipTVec+j)**2
            END DO
            Alpha=DDot_(n,Work(ipTVec),1,Work(ipTmp),1)/Alpha
*           subtract
            DO j=0,n-1
              Work(ipTVec+j)=Work(ipTVec+j)*Work(ipDiag+j)
            END DO
            call daxpy_(n,-Alpha,Work(ipTVec),1,Work(ipTmp),1)
#elif DAV_METH == DAV_GJD
*   DO NOT USE THIS VARIANT!
* This is not practical as it stands, the equation should be
* solved only approximately, and it is not efficient to do this
* for each of the possibly many eigenpairs
            CALL Allocate_Work(ipP1,n*n)
*           project: (I-|v><v|) (A-e*I) (I-|v><v|) =
*                    A - e*I + (<v|P>+e)*|v><v| - |v><P| - |P><v|
*           e = Val(i); |P> = A|v>
            Aux=DDot_(n,Work(ipTVec),1,Work(ipTAV),1)
            DO kk=0,n-1
              ll=kk*(kk+1)/2
              DO ii=0,kk
                Work(ipP1+ii*n+kk)=A(ll+ii+1)+
     &            (Aux+EVal(1+i))*Work(ipTVec+ii)*Work(ipTVec+kk)-
     &            Work(ipTAV+ii)*Work(ipTVec+kk)-
     &            Work(ipTAV+kk)*Work(ipTVec+ii)
              END DO
              Work(ipP1+kk*n+kk)=Work(ipP1+kk*n+kk)-EVal(1+i)
            END DO
            iWork(ipDum)=0
*           solve the equation
            CALL CG_Solver(n,n*n,Work(ipP1),iWork(ipDum),Work(ipTRes),
     &                     Work(ipTmp),info,5)
#ifdef _DEBUGPRINT_
            WRITE(6,*) 'CG iterations',info
#endif
            CALL Free_Work(ipP1)
#endif
            IF (mk+jj .LE. n-1) THEN
              jj=mk+jj
              CALL Add_Vector(n,jj,Sub,Work(ipTmp),Thr3)
              jj=jj-mk
            END IF
          END DO
#ifdef _DEBUGPRINT_
          WRITE(6,'(2X,A,1X,G12.6)') 'Maximum residual:',Conv
#endif
          IF ((Conv .LT. Thr3) .AND. (mk .GE. mink)) THEN
#ifdef _DEBUGPRINT_
            WRITE(6,'(A)') 'Converged due to small residual'
#endif
            Last=.TRUE.
          ELSE
            mk=MIN(mk+jj,n)

*----       If no new vector is found to add to the subspace, we are in trouble
*            -Try to find a non-linear-dependent base vector in the original matrix
*
            IF (jj .EQ. 0) THEN
#ifdef _DEBUGPRINT_
              WRITE(6,'(A)') 'Process stagnated'
#endif
              IF (mk .LT. maxk) THEN
                CALL DZero(Work(ipTmp),n)
                i=0
                DO WHILE ((jj .LT. 1) .AND. (i .LT. n))
                  i=i+1
                  ig=MOD(ig,n)+1
                  ii=iWork(ipIndex+ig-1)
                  Work(ipTmp+ii-1)=One
                  jj=mk+jj
                  CALL Add_Vector(n,jj,Sub,Work(ipTmp),Thr3)
                  Work(ipTmp+ii-1)=Zero
                  jj=jj-mk
                END DO
                mk=MIN(mk+jj,n)
                IF (jj .GT. 0) Augmented=.TRUE.
              END IF
              IF (jj .EQ. 0) THEN
                Augmented=.FALSE.
                iRC=2
              ENDIF
            ELSE
              Augmented=.TRUE.
            END IF
          END IF
          CALL Free_Work(ipTmp)
          Reduced=.FALSE.
        END IF
      END DO
      CALL Free_Work(ipDum)
      CALL Free_Work(ipDiag)
      CALL Free_Work(ipTVec)
      CALL Free_Work(ipTAV)
      CALL Free_Work(ipTRes)
      CALL Free_iWork(ipIndex)

*---- Store the current lowest k eigenvectors (in the full space)
*      Vec' = Sub * Vec(1:k)
*
      CALL DGeMM_('N','N',n,k,mk,One,Sub,n,EVec,maxk,
     &                           Zero,Vec,n)

      Call mma_deallocate(Sub)
      Call mma_deallocate(Ab)
      Call mma_deallocate(Proj)
      Call mma_deallocate(EVal)
      Call mma_deallocate(EVec)
      CALL mma_deallocate(Eig_old)

      END

************************************************************************
*  Add_Vector
*
*> @brief
*>   Add (or not) a vector to an orthonormal set
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Adds a given vector to an existing set of orthonormal vectors.
*> The vector is orthogonalized against the existing set and, if the remainder
*> is large enough, it will be normalized and added to the set.
*> The input matrix with the initial set must have size at least \p n (\p m+1).
*> On output, \p m will be increased by 1 if the vector was added, and unchanged
*> otherwise.
*>
*> @param[in]     n   Size of the vectors
*> @param[in,out] m   Number of vectors in the subspace
*> @param[in,out] Sub Subspace of vectors
*> @param[in,out] Vec Vector to be added
*> @param[in]     Thr Threshold for linear dependence check
************************************************************************
      SUBROUTINE Add_Vector(n,m,Sub,Vec,Thr)
      IMPLICIT NONE
      INTEGER n,m,i
      REAL*8 Sub(n,m+1),Vec(n),Thr,Aux,DDot_
      external ddot_
#include "real.fh"

      DO i=1,m
        Aux=DDot_(n,Sub(1,i),1,Vec,1)
        call daxpy_(n,-Aux,Sub(1,i),1,Vec,1)
      END DO
      Aux=DDot_(n,Vec,1,Vec,1)
      IF (ABS(Aux) .GT. Thr) THEN
*----   Safety net: orthonormalize again before adding it
        call dscal_(n,One/SQRT(Aux),Vec,1)
        DO i=1,m
          Aux=DDot_(n,Sub(1,i),1,Vec,1)
          call daxpy_(n,-Aux,Sub(1,i),1,Vec,1)
        END DO
        m=m+1
        Aux=DDot_(n,Vec,1,Vec,1)
        call dscal_(n,One/SQRT(Aux),Vec,1)
        call dcopy_(n,Vec,1,Sub(1,m),1)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine caspt2_grad_invaria1(NDPT2,DPT2)
! Put zero to wrong (incomplete) density matrix elements
! If the MRPT2 energy is non-invariant with respect to rotations among the inactive and secondary orbital spaces,
! we cannot determine the off-diagonal elements (in the iagonal block) as in TRDNS2D.
! Therefore, remove the off-diagonal elements. They are computed in caspt2_grad_invaria2 using orbital derivatives.
! The diagonal elements are correct.

use caspt2_module, only: nAsh, nIsh, nOrb, nSsh, nSym
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDPT2
real(kind=wp), intent(inout) :: DPT2(NDPT2)
integer(kind=iwp) :: ia, ib, idab, idij, idtu, ii, ij, IOFDAB(8), IOFDIJ(8), is, isym, na, ni, no, ns

IDIJ = 0
do IS=1,NSYM
  NI = NISH(IS)
  NA = NASH(IS)
  NO = NORB(IS)
  IDTU = IDIJ+NO*NI+NI
  IDAB = IDTU+NO*NA+NA
  IOFDIJ(IS) = IDIJ
  IOFDAB(IS) = IDAB
  IDIJ = IDIJ+NO*NO
end do

do isym=1,nsym
  NI = NISH(ISYM)
  NS = NSSH(ISYM)
  NO = NORB(ISYM)
  do ii=1,ni
    do ij=1,ni
      if (ii == ij) cycle
      IDIJ = IOFDIJ(ISYM)+II+NO*(IJ-1)
      DPT2(IDIJ) = Zero
    end do
  end do
  do ia=1,ns
    do ib=1,ns
      if (ia == ib) cycle
      IDAB = IOFDAB(ISYM)+IA+NO*(IB-1)
      DPT2(IDAB) = Zero
    end do
  end do
end do

end subroutine caspt2_grad_invaria1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine creq(q,rint,G2,idsym)
! Constructs the Q matrix

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use MCLR_Data, only: ipMatBA, ipMO, nA, nDens
use input_mclr, only: nAsh, nOrb, nSym
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Q(nDens)
real(kind=wp), intent(in) :: rint(*), G2(*)
integer(kind=iwp), intent(in) :: idSym
integer(kind=iwp) :: iAsh, iij, ijS, ikl, ipG, ipi, ipQ, ipS, iS, jAsh, jS, kAsh, kS, lAsh, lS

! Q = (pj|kl)d
!  pi         ijkl

Q(:) = Zero
do iS=1,nSym
  ipS = Mul(is,idsym)
  if (norb(ips) /= 0) then

    do jS=1,nsym
      ijS = Mul(is,js)
      do kS=1,nSym
        ls = Mul(ijs,ks)
        do iAsh=1,nAsh(is)
          do jAsh=1,nAsh(js)
            iij = iTri(iAsh+nA(is),jAsh+nA(jS))
            do kAsh=1,nAsh(ks)
              do lAsh=1,nAsh(ls)
                ikl = iTri(lAsh+nA(lS),kAsh+nA(kS))
                ipQ = ipMatba(ips,is)+norb(ips)*(iAsh-1)
                ipG = iTri(iij,ikl)
                ipi = ipMO(js,ks,ls)+(norb(ips)*(jAsh-1+nAsh(js)*(kAsh-1+nAsh(ks)*(lAsh-1))))
                Q(ipQ:ipQ+norb(ips)-1) = Q(ipQ:ipQ+norb(ips)-1)+G2(ipG)*rint(ipI:ipI+norb(ips)-1)
              end do
            end do
          end do
        end do
      end do
    end do
  end if
end do

end subroutine creq

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per Ake Malmqvist                                      *
!               Jesper Wisborg Krogh                                   *
!***********************************************************************
!  Chk4NAN
!
!> @brief
!>   Check whether an array contains NANs
!> @author Per &Aring;ke Malmqvist
!> @modified_by Jesper Wisborg Krogh
!>
!> @details
!> The routine checks the elements of the input array for NANs. If any are found,
!> up to 100 of these will be listed. Upon return \p iErr contains the number of
!> NANs found.
!>
!> @param[in]  nDim  Total dimension of array
!> @param[in]  Array Array to be checked
!> @param[out] Ierr  Return code
!***********************************************************************

subroutine Chk4NAN(nDim,Array,Ierr)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(in) :: Array(nDim)
integer(kind=iwp), intent(out) :: Ierr
integer(kind=iwp) :: I, iCount
real(kind=wp) :: CheckSum
character(len=16) :: str16

ICOUNT = 0
CHECKSUM = sum(ARRAY)
write(STR16,'(G16.7)') CHECKSUM
call NORMAL(STR16)
if (STR16(1:1) == 'N') then
  write(u6,*) '!!! WARNING !!!'
  write(u6,*) 'NANs encountered'
  write(u6,*)
  write(u6,*) ' The numbers in the array will now be checked.'
  write(u6,*) ' There are ',NDIM,' elements.'
  do I=1,nDim
    write(STR16,'(G16.7)') ARRAY(I)
    call NORMAL(STR16)
    if (STR16(1:1) == 'N') then
      ICOUNT = ICOUNT+1
      if (iCount <= 100) write(u6,*) ' Element nr.',I,' is ',ARRAY(I)
    end if
  end do
  if (ICOUNT > 100) write(u6,*) ' ...too many. I give up here.'
  write(u6,*) 'There were a total of ',iCount,' NANs'
end if

iErr = iCount

return

end subroutine Chk4NAN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001,2020,  Roland Lindh                               *
*               Sergey Gusarov                                         *
************************************************************************
      SubRoutine GetPAM(lUnit,iCnttp)
************************************************************************
*                                                                      *
*    Objective: To read potential information, for DMFT calculations   *
*               This means that we read (from input stream)            *
*               the potential terms (PAM)                              *
*                                                                      *
* Called from: GetBs                                                   *
*                                                                      *
* Calling    : RecPrt, Rdbsl                                           *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*                                                                      *
*     Modified: Sergey Gusarov SPb State Ubiv, Russia.                 *
************************************************************************
      Use Basis_Info
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "real.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: Array(:)
      Character*180 Line, Get_Ln
*     External Get_Ln
      Integer nPAM2
      Logical test
#ifdef _DEBUGPRINT_
      data test /.True./
#else
      data test /.False./
#endif
*
      if (test) Write (6,*) ' Reading PAM potencials'
      nArray=10000
      Call mma_Allocate(Array,nArray,Label='Array')
*
      iStrt = 1
      Line=Get_Ln(lUnit)
      If (Index(Line,'PAM').eq.0) Then
         Call WarningMessage(2,
     &              'ERROR: Keyword PAM expected, offending line : '
     &            //Line)
         Call Quit_OnUserError()
      Endif
      Line=Get_Ln(lUnit)
      Call Get_i1(1,nPAM2)
      dbsc(iCnttp)%nPAM2=nPAM2
      Do iPAM_Ang=0, nPAM2
         Line=Get_Ln(lUnit)
         Call Get_i1(1,nPAM2Prim)
         Call Get_i1(2,nPAM2Bas)
         Array(iStrt)=DBLE(nPAM2Prim)
         Array(iStrt+1)=DBLE(nPAM2Bas)
         iStrt=iStrt+2
         iEnd = iStrt + nPAM2Prim - 1
*
*   Read exponents
*
         If (nPAM2Prim.gt.0) then
            Call read_v(lUnit,Array,iStrt,iEnd,1,Ierr)
            If (Ierr.ne.0) Then
               Call WarningMessage(2,
     &                     'GetBS: Error reading GPA exponents')
               Call Abend()
            End If
         End If
*
*   Read coefficents
*
      iStrt = iEnd + 1
         iEnd  = iStrt + nPAM2Prim*nPAM2Bas - 1
         Do 288 iPrim = 0, nPAM2Prim - 1
            Call Read_v(lUnit,Array,iStrt+iPrim,iEnd,nPAM2Prim,ierr)
            If(ierr.ne.0) Then
               Call WarningMessage(2,
     &                         'GetBS: Error in reading GPA!!!')
               Call Abend()
            End if
 288     Continue
         iStrt = iEnd + 1
      End Do
*
      Call mma_allocate(dbsc(iCnttp)%PAM2,iEnd,Label='PAM2')
      dbsc(iCnttp)%PAM2(:)=Array(:)
*
      Call mma_deAllocate(Array)
      Return
      End
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SGPrint(SGS)
      use definitions, only: iwp, u6
      use gugx, only: SGStruct
      implicit None
      Type (SGStruct), intent(in):: SGS

      integer(kind=iwp) nLev, nVert, MidLev, MVSta, MVEnd, i, iv, ic

C Unpack structure SGS:
      nLev   =SGS%nLev
      nVert  =SGS%nVert
      MidLev =SGS%MidLev
      MVSta  =SGS%MVSta
      MVEnd  =SGS%MVEnd

      Write(u6,*)' Split-Graph UGA. Graph description:'
      Write(u6,*)' Nr of levels:',nLev
      Write(u6,*)' Orbital symmetry labels:'
      Write(u6,'(1x,30i2)')(SGS%ISm(i),i=1,nLev)
      Write(u6,*)' Nr of vertices:',nVert
      Write(u6,*)
      Write(u6,*)' Vertex    L  N    A  B  C      '//
     &               'Downchain table        Upchain table'
      Write(u6,*)
      Do iv=1,nVert
        Write(u6,'(1x,i4,5x,2i3,2x,3i3,5x,4i4,5x,4i4)')iv,
     &  (SGS%DRT(iv,i-1),i=1,5),
     &  (SGS%Down(iv,ic),ic=0,3),
     &  (SGS%Up  (iv,ic),ic=0,3)
      End Do
      Write(u6,*)
      Write(u6,*)' Mid Level:',MidLev
      Write(u6,*)' Mid Vertices:',MVSta,'...',MVEnd
      Write(u6,*)
      Write(u6,*)' Modified Arc Weight table:'
      Write(u6,*)'           Coupling case number'
      Write(u6,*)' Vertex      0    1    2    3'
      Write(u6,*)
      Do iv=1,nVert
        Write(u6,'(1x,i4,5x,4i5)')
     &             iv,(SGS%MAW(iv,ic),ic=0,3)
      End Do
      End Subroutine SGPrint

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Giovanni Li Manni                                *
*               2013, Dongxia Ma                                       *
************************************************************************
      SUBROUTINE DmatDmat_m(Dmat,DDarray)
c *******************************************************************
c     Purpose: To construct an array containing Dpq*Drs elements
c              (product of one-body density matrix elements) ordered
c              according to the ordering of the 2-electron integrals
c              elements g(pqrs).
C
c     Author : Giovanni Li Manni and Dongxia Ma
c     Date   : June 21st 2013 ... When Minnesotan summer seems to arrive!
c *******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      PARAMETER (ROUTINE='DMATDMAT')
      DIMENSION Dmat(*),DDarray(*), iOffOrb(nSym)

      nTest = 000
      IF(nTest.ge.1000) THEN
        write(6,*)('*', i=1,70)
        WRITE(6,*)' Entering DmatDmat routine'
        write(6,*)('*', i=1,70)
        write(6,*) ' One body Dmat in INPUT:'
        CALL TRIPRT('Aver. 1-body Dmat in MO in DmatDmat',' ',Dmat,NAC)
      END IF
c Initialization of variables

      iorp       = 0
      iOffOrb(1) = 0
      indx1      = 0

      Do iSym = 2, nSym
        iOffOrb(iSym) = iOffOrb(iSym-1) + NaSh(iSym-1)
      End do

      IF(nTest.ge.1000) THEN
        write(6,*)('*', i=1,70)
        WRITE(6,*)' Offsets for Orbitals: Sym, Offset value'
        write(6,*)('*', i=1,70)
        do iSym = 1, nSym
          write(6,*) iSym, iOffOrb(iSym)
        end do
      END IF

      call FZero(DDarray,istorp(nSym+1))

      IF(nTest.ge.1000) THEN
        write(6,*)('*', i=1,70)
        WRITE(6,*)'array of Dpq*Drs elements size :',istorp(nSym+1)
      END IF

      If(nTest.ge.1000) then
        write(6,*)('*', i=1,70)
        write(6,*) '  iorp  iPsm  iQsm  iRsm  iSsm'//
     &             '  iOrbP iOrbQ iOrbR iOrbS'//
     &             '            Dpq           Drs'
      End If
      DO iPsm=1, nSym
        Do iOrbP=1, NASh(iPsm)
          DO iQsm=1,nSym
            If(NASh(iQsm).eq.0) goto 10  ! next iQsm
            iSmPQ = ieor(iPsm-1, iQsm -1)+1
            indx2      = 0
            DO iRsm=1,nSym
              iSsm = ieor(iSmPQ-1,iRsm-1)+1
              If(min(NASh(iRsm),NASh(iSsm)).eq.0.OR.
     &           iSsm.gt.iRsm)  goto 20  !next iRsm
              nRS = NASh(iRsm)*NASh(iSsm)
              if(iSsm.eq.iRsm) then
                nRS=NASh(iRsm)*(NASh(iRsm)+1)/2
              end if
              If(iRsm.ne.iSsm.OR.iQsm.ne.iPsm) then
                iorp = iorp+nRS*NASh(iQsm)
                goto 20 !next iRsm
              End If
              Do iOrbR=1,NASH(iRsm)
                DO iOrbS=1,iOrbR
                  FACT= 1.0d0
                  IF(iOrbR.ne.iOrbS) FACT= 2.0d0
                  Do iOrbQ=1,NASH(iQsm)
                    iorp = iorp +1
                    iMaxPQ=max(iOrbP,iOrbQ)
                    iminPQ=min(iOrbP,iOrbQ)
                    iMaxRS=max(iOrbR,iOrbS)
                    iminRS=min(iOrbR,iOrbS)
                    indxDpq = indx1+iMaxPQ*(iMaxPQ-1)/2 + iminPQ
                    indxDrs = indx2+iMaxRS*(iMaxRS-1)/2 + iminRS
                    DDarray(iorp)=Dmat(indxDpq)*Dmat(indxDrs)*FACT
                    If(nTest.ge.1000) then
                      write(6,'(9I6,5X,2F15.8)') iorp,
     &                           iPsm,iQsm,iRsm,iSsm,
     &                           iOrbP+iOffOrb(iPsm),
     &                           iOrbQ+iOffOrb(iQsm),
     &                           iOrbR+iOffOrb(iRsm),
     &                           iOrbS+iOffOrb(iSsm),
     &                           Dmat(indxDpq),
     &                           Dmat(indxDrs)
                    End If
                  End Do ! Loop over iOrbQ
                End Do ! Loop over iOrbS
              End Do ! Loop over iOrbR
20            CONTINUE
              indx2=indx2+NASH(iRsm)*(NASH(iRsm)+1)/2
            End Do ! loop over iRsm
10          CONTINUE
          End Do ! Loop over iQsm
        End Do ! Loop over iOrbP
        indx1 = indx1 + NASH(iPsm)*(NASH(iPsm)+1)/2
      End Do ! Loop over iPsm
      IF(nTest.ge.1000) THEN
        write(6,*)('*', i=1,70)
        WRITE(6,*)'array of Dpq*Drs elements in output from DmatDmat'
        call wrtmat(DDarray,1,istorp(nSym+1),1,istorp(nSym+1))
        write(6,*)('*', i=1,70)
        write(6,*) 'End of DmatDmat routine'
        write(6,*)('*', i=1,70)
      END IF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 22, 2021, created this file.               *
! ****************************************************************
subroutine Calc_Pot1(Pot1,TabMO,mAO,mGrid,nMOs,P2_ontop,nP2_ontop,MOs)

use nq_Grid, only: GradRho, vRho, vSigma, Weights
use nq_pdft, only: d2RdRho2, d2RdRhodPi, d2ZdR2, dEdRho, dEdRhox, dEdRhoy, dEdRhoz, dF_dRhoapb, dF_dRhoamb, dF_dRhoxamb, &
                   dF_dRhoxapb, dF_dRhoyamb, dF_dRhoyapb, dF_dRhozamb, dF_dRhozapb, dRdPi, dRdRho, dRhodx, dRhody, dRhodz, dZdR, &
                   dZdRho, fta, ftb, ftc, GradPidFdRho, GradRdFdRho, GradRhodFdRho, lft, lGGA, Pass1, Pass2, Pass3, RatioA, RhoAB, &
                   ThrsNT, ZetaA
use nq_Info, only: mIrrep, mOrb, nOrbt, nPot1, OffBasFro, OffOrb, OffOrb2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four, Six, Twelve, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Pot1(nPot1)
integer(kind=iwp), intent(in) :: mAO, mGrid, nMOs, nP2_ontop
real(kind=wp), intent(in) :: TabMO(mAO,mGrid,nMOs), MOs(mGrid,nOrbt), P2_ontop(nP2_ontop,mGrid)
integer(kind=iwp) :: iGrid, iIrrep, iMO, iOff1, IOff2, iOrb
real(kind=wp) :: dEdRhop2, dF_dRhoax, dF_dRhoay, dF_dRhoaz, dF_dRhobx, dF_dRhoby, dF_dRhobz, Diff1, dRdx, dRdy, dRdz
! PreMO is MO multiplied with things needed for potential calculation
real(kind=wp), allocatable :: PreMO(:,:)

call mma_allocate(PreMO,mGrid,nOrbt)
PreMO(:,:) = MOs

! black terms in the notes
do iGrid=1,mGrid
  if (Pass1(iGrid)) then
    dF_dRhoapb(iGrid) = vRho(1,iGrid)+vRho(2,iGrid)
    dF_dRhoamb(iGrid) = vRho(1,iGrid)-vRho(2,iGrid)
    dRdRho(iGrid) = RatioA(iGrid)*(-Two/RhoAB(iGrid))
    dZdRho(iGrid) = dZdR(iGrid)*dRdRho(iGrid)
    dEdRho(iGrid) = dF_dRhoapb(iGrid)+dF_dRhoamb(iGrid)*(ZetaA(iGrid)+RhoAB(iGrid)*dZdRho(iGrid))
    dRdPi(iGrid) = Four/RhoAB(iGrid)**2
  else
    dRdPi(iGrid) = Zero
    dF_dRhoapb(iGrid) = Zero
    dF_dRhoamb(iGrid) = Zero
    dEdRho(iGrid) = Zero
  end if
end do

! red terms in the notes
if (lGGA) then
  do iGrid=1,mGrid
    if (Pass1(iGrid)) then
      dF_dRhoax = Two*vSigma(1,iGrid)*GradRho(1,iGrid)+vSigma(2,iGrid)*GradRho(4,iGrid)
      dF_dRhobx = Two*vSigma(3,iGrid)*GradRho(4,iGrid)+vSigma(2,iGrid)*GradRho(1,iGrid)
      dF_dRhoay = Two*vSigma(1,iGrid)*GradRho(2,iGrid)+vSigma(2,iGrid)*GradRho(5,iGrid)
      dF_dRhoby = Two*vSigma(3,iGrid)*GradRho(5,iGrid)+vSigma(2,iGrid)*GradRho(2,iGrid)
      dF_dRhoaz = Two*vSigma(1,iGrid)*GradRho(3,iGrid)+vSigma(2,iGrid)*GradRho(6,iGrid)
      dF_dRhobz = Two*vSigma(3,iGrid)*GradRho(6,iGrid)+vSigma(2,iGrid)*GradRho(3,iGrid)
      dF_dRhoxapb(iGrid) = dF_dRhoax+dF_dRhobx
      dF_dRhoxamb(iGrid) = dF_dRhoax-dF_dRhobx
      dF_dRhoyapb(iGrid) = dF_dRhoay+dF_dRhoby
      dF_dRhoyamb(iGrid) = dF_dRhoay-dF_dRhoby
      dF_dRhozapb(iGrid) = dF_dRhoaz+dF_dRhobz
      dF_dRhozamb(iGrid) = dF_dRhoaz-dF_dRhobz

      dRhodx(iGrid) = GradRho(1,iGrid)+GradRho(4,iGrid)
      dRhody(iGrid) = GradRho(2,iGrid)+GradRho(5,iGrid)
      dRhodz(iGrid) = GradRho(3,iGrid)+GradRho(6,iGrid)

      GradRhodFdRho(iGrid) = (dF_dRhoxamb(iGrid)*dRhodx(iGrid)+dF_dRhoyamb(iGrid)*dRhody(iGrid)+dF_dRhozamb(iGrid)*dRhodz(iGrid))
      dEdRho(iGrid) = dEdRho(iGrid)+dZdRho(iGrid)*GradRhodFdRho(iGrid)

      dEdRhox(iGrid) = dF_dRhoxapb(iGrid)+ZetaA(iGrid)*dF_dRhoxamb(iGrid)
      dEdRhoy(iGrid) = dF_dRhoyapb(iGrid)+ZetaA(iGrid)*dF_dRhoyamb(iGrid)
      dEdRhoz(iGrid) = dF_dRhozapb(iGrid)+ZetaA(iGrid)*dF_dRhozamb(iGrid)

    else
      dF_dRhoxapb(iGrid) = Zero
      dF_dRhoxamb(iGrid) = Zero
      dF_dRhoyapb(iGrid) = Zero
      dF_dRhoyamb(iGrid) = Zero
      dF_dRhozapb(iGrid) = Zero
      dF_dRhozamb(iGrid) = Zero
      GradRhodFdRho(iGrid) = Zero
      dEdRhox(iGrid) = Zero
      dEdRhoy(iGrid) = Zero
      dEdRhoz(iGrid) = Zero
    end if
  end do
  ! green and blue terms in the notes
  if (lft) then
    do iGrid=1,mGrid
      if (Pass1(iGrid)) then
        dRdX = dRdRho(iGrid)*dRhodX(iGrid)+dRdPi(iGrid)*P2_ontop(2,iGrid)
        dRdY = dRdRho(iGrid)*dRhodY(iGrid)+dRdPi(iGrid)*P2_ontop(3,iGrid)
        dRdZ = dRdRho(iGrid)*dRhodZ(iGrid)+dRdPi(iGrid)*P2_ontop(4,iGrid)
        GradRdFdRho(iGrid) = dRdX*dF_dRhoxamb(iGrid)+dRdY*dF_dRhoyamb(iGrid)+dRdZ*dF_dRhozamb(iGrid)
        GradPidFdRho(iGrid) = P2_ontop(2,iGrid)*dF_dRhoxamb(iGrid)+P2_ontop(3,iGrid)*dF_dRhoyamb(iGrid)+ &
                              P2_ontop(4,iGrid)*dF_dRhozamb(iGrid)
        d2RdRho2(iGrid) = Six*RatioA(iGrid)/RhoAB(iGrid)**2
        d2RdRhodPi(iGrid) = -Two*dRdPi(iGrid)/RhoAB(iGrid)
        if (Pass2(iGrid)) then
          d2ZdR2(iGrid) = Two*dZdR(iGrid)**3
        else if (Pass3(iGrid)) then
          Diff1 = RatioA(iGrid)-ThrsNT
          d2ZdR2(iGrid) = (20.0_wp*fta*Diff1**2+Twelve*ftb*Diff1+Six*ftc)*Diff1
        else
          d2ZdR2(iGrid) = Zero
        end if
        dEdRho(iGrid) = dEdRho(iGrid)+(dZdR(iGrid)+RhoAB(iGrid)*d2ZdR2(iGrid)*dRdRho(iGrid))*GradRdFdRho(iGrid)+ &
                        RhoAB(iGrid)*dZdR(iGrid)*d2RdRho2(iGrid)*GradRhodFdRho(iGrid)+ &
                        RhoAB(iGrid)*dZdR(iGrid)*d2RdRhodPi(iGrid)*GradPidFdRho(iGrid)
        dEdRhop2 = RhoAB(iGrid)*dZdRho(iGrid)
        ! end of dEdRho term
        ! now dEdRhoprime terms
        dEdRhox(iGrid) = dEdRhox(iGrid)+dEdRhop2*dF_dRhoxamb(iGrid)
        dEdRhoy(iGrid) = dEdRhoy(iGrid)+dEdRhop2*dF_dRhoyamb(iGrid)
        dEdRhoz(iGrid) = dEdRhoz(iGrid)+dEdRhop2*dF_dRhozamb(iGrid)
      else
        GradRdFdRho(iGrid) = Zero
        GradPidFdRho(iGrid) = Zero
        d2RdRho2(iGrid) = Zero
        d2RdRhodPi(iGrid) = Zero
        d2ZdR2(iGrid) = Zero
      end if
    end do
  end if
end if

dEdRho(:) = Half*dEdRho

do iGrid=1,mGrid
  PreMO(iGrid,:) = PreMO(iGrid,:)*dEdRho(iGrid)
end do

if (lGGA) then
  do iIrrep=0,mIrrep-1
    do iOrb=1,mOrb(iIrrep)
      IOff1 = iOrb+OffOrb(iIrrep)
      iMO = iOrb+OffBasFro(iIrrep)
      do iGrid=1,mGrid
        PreMO(iGrid,IOff1) = PreMO(iGrid,IOff1)+TabMO(2,iGrid,iMO)*dEdRhox(iGrid)+TabMO(3,iGrid,iMO)*dEdRhoy(iGrid)+ &
                             TabMO(4,iGrid,iMO)*dEdRhoz(iGrid)
      end do
    end do
  end do
end if

do iGrid=1,mGrid
  PreMO(iGrid,:) = PreMO(iGrid,:)*Weights(iGrid)
end do

do iIrrep=0,mIrrep-1
  IOff1 = OffOrb(iIrrep)+1
  IOff2 = OffOrb2(iIrrep)+1
  call DGEMM_('T','N',mOrb(iIrrep),mOrb(iIrrep),mGrid,One,PreMO(:,IOff1:),mGrid,MOs(:,IOff1:),mGrid,One,Pot1(iOff2:),mOrb(iIrrep))
end do

call mma_deallocate(PreMO)

return

end subroutine Calc_Pot1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function mxorth_cvb(a,n)
! Returns .TRUE. if A is orthogonal.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: mxorth_cvb
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: a(n,n)
integer(kind=iwp) :: i, j
real(kind=wp) :: tst
real(kind=wp), allocatable :: at(:,:), c(:,:)
real(kind=wp), parameter :: thresh = 1.0e-8_wp

call mma_allocate(at,n,n,label='at')
call mma_allocate(c,n,n,label='c')
! AT <= A transpose
do i=1,n
  at(i,:) = a(:,i)
end do
call mxatb_cvb(at,a,n,n,n,c)
call mma_deallocate(at)
! C identity ??
mxorth_cvb = .true.
outer: do j=1,n
  do i=1,n
    if (i /= j) then
      tst = abs(c(i,j))
    else
      tst = abs(c(i,j)-One)
    end if
    if (tst > thresh) then
      mxorth_cvb = .false.
      exit outer
    end if
  end do
end do outer
call mma_deallocate(c)

return

end function mxorth_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine bino(lmax)

use welcom, only: binom
use Constants, only: Zero, One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lMax
integer(kind=iwp) :: i, j

binom(:,:) = Zero
binom(0,0) = One
do i=1,lmax
  do j=0,i
    binom(i,j) = binom(i-1,j-1)+binom(i-1,j)
  end do
end do

return

end subroutine bino

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************

      SubRoutine ChoMP2g_DensDrv(irc,EOcc,EVir,EFro,CMO)

*     Jonas Bostrom, Feb 2010
*
*     Purpose: To Compute MP2 density from Cholesky MO-vectors and
*              decomposed MP2 amplitudes.

#include "implicit.fh"
#include "stdalloc.fh"

      Real*8 EOcc(*), EVir(*), EFro(*),CMO(*)
      Character*7  ThisNm
      Character*15 SecNam
      Parameter (SecNam = 'ChoMP2g_DensDrv', ThisNm = 'DensDrv')

      Integer lWrk
      Real*8, Allocatable:: Wrk(:)

      irc = 0

      Call mma_maxDBLE(lWrk)
*     Leave 5% of the memory unallocated
*     ----------------------------------
#ifdef _I8_
      lWrk = lWrk*19/20
#else
      lWrk = lWrk-lWrk/20
#endif
      Call mma_allocate(Wrk,lWrk,Label='Wrk')
*     Wrk(:)=0.0D0

      Call ChoMP2g_Reord_R(irc,Wrk,lWrk)

      Call ChoMP2g_density1(irc,EOcc,EVir,EFro,Wrk,lWrk)
      Call ChoMP2g_density2(irc,EOcc,EVir,EFro,Wrk,lWrk)

      Call mma_deallocate(Wrk)

      Call ChoMP2g_density3(irc,CMO)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CON_BLOCKS(IATP,IBTP,JATP,JBTP,IASM,IBSM,JASM,JBSM,ICONSPA,ICONSPB,NOCTPA,NOCTPB,MXEXC,IH_OCC_CONS,INTERACT)
! Does CI blocks IATP IBTP interact with blocks JATP JBTP
!
! Input
! =====
! IATP IBTP JATP JBTP : Supergroups, relative numbers
! IOCTPA, IOBTPB : Offset for type
! ICONSPA, ICONSPB : Connection matrices giving exciation
!                    level between two string types
! MXEXC : Largest excitation level
! IH_OCC_CONS : = 1 => Use only occupation conserving part of
!                      Hamiltonian
!
! Output
! ======
! INTERACT : =1 => The two blocks does interact
!
! Jeppe Olsen, April 99

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: IATP, IBTP, JATP, JBTP, IASM, IBSM, JASM, JBSM, NOCTPA, ICONSPA(NOCTPA,NOCTPA), NOCTPB, &
                                 ICONSPB(NOCTPB,NOCTPB), MXEXC, IH_OCC_CONS
integer(kind=iwp), intent(inout) :: INTERACT
integer(kind=iwp) :: IA_EXC, IB_EXC

IA_EXC = ICONSPA(IATP,JATP)
IB_EXC = ICONSPB(IBTP,JBTP)
if (IH_OCC_CONS == 0) then
  ! Usual one- or two- electron operator
  if (MXEXC == 1) then
    if (((IA_EXC <= 1) .and. (IBTP == JBTP) .and. (IBSM == JBSM)) .or. &
        ((IB_EXC <= 1) .and. (IATP == JATP) .and. (IASM == JASM))) INTERACT = 1
  else if (MXEXC == 2) then
    if (((IA_EXC <= 1) .and. (IB_EXC <= 1)) .or. ((IA_EXC == 2) .and. (IBTP == JBTP) .and. (IBSM == JBSM)) .or. &
        ((IB_EXC == 2) .and. (IATP == JATP) .and. (IASM == JASM))) INTERACT = 1
  end if
!else
!  ! Orbital conserving part of  Hamiltonian
!  if ((IA_EXC == IB_EXC) .and. (IB_EXC <= 1)) then
!    IATP_ABS = IATP+IOCTPA-1
!    IBTP_ABS = IBTP+IOCTPB-1
!    JATP_ABS = JATP+IOCTPA-1
!    JBTP_ABS = JBTP+IOCTPB-1
!    ! Find Orb space where alpha strings differ
!    IPGAS = 0
!    IMGAS = 0
!    do IGAS=1,NGAS
!      IAEL = NELFSPGP(IGAS,IATP_ABS)
!      JAEL = NELFSPGP(IGAS,JATP_ABS)
!      if (IAEL-JAEL == 1) IPGAS = IGAS
!      if (IAEL-JAEL == -1)IMGAS = IGAS
!    end do
!    if (IPGAS /= 0) then
!      IPDIF = NELFSPGP(IPGAS,IBTP_ABS)-NELFSPGP(IPGAS,JBTP_ABS)
!    else
!      IPDIF = 0
!    end if
!    ! corresponding differences in beta
!    if (IMGAS /= 0) then
!      IMDIF = NELFSPGP(IMGAS,IBTP_ABS)-NELFSPGP(IMGAS,JBTP_ABS)
!    else
!      IMDIF = 0
!    end if
!    if ((IPGAS == 0) .and. (IMGAS == 0)) INTERACT = 1
!    if ((IPGAS /= 0) .and. (IMGAS /= 0)) then
!      if ((IPDIF == -1) .and. (IMDIF == 1)) INTERACT = 1
!    end if
!  end if
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from CONBLOCKS'
write(u6,*) ' IATP IBTP JATP JBTP ',IATP,IBTP,JATP,JBTP
write(u6,*) ' IH_OCC_CONS, INTERACT = ',IH_OCC_CONS,INTERACT
#endif

end subroutine CON_BLOCKS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Trafo

! CONTROL DATA FOR TRANSFORMATION SECTION

use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: IAD13, IADOUT(3*36*36), ISP, ISQ, ISR, ISS, ITP, ITQ, ITR, ITS, LMOP, LMOP2, LMOQ, LMOQ2, LMOR, LMOR2, LMOS, &
                     LMOS2, LRUPQ, LTUPQ, LURPQ, NBP, NBPQ, NBQ, NBR, NBRS, NBS, NOCP, NOCQ, NOCR, NOCS, NOP, NOQ, NOR, NOS, NPQ

public :: IAD13, IADOUT, ISP, ISQ, ISR, ISS, LMOP, LMOP2, LMOQ, LMOQ2, LMOR, LMOR2, LMOS, LMOS2, LRUPQ, LTUPQ, LURPQ, NBP, NBPQ, &
          NBQ, NBR, NBRS, NBS, NOCP, NOCQ, NOCR, NOCS, NOP, NOQ, NOR, NOS, NPQ
public :: ITP, ITQ, ITR, ITS

end module Trafo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine diiscf(diispoint,ndiis)
! this routine closes 1-ndiis Temp files for DIIS procedure
! lun's are stored in stack (diispoint)
!
! diispoint - stack of lun numbers (I)
! ndiis     - size of diis procedure (I)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: diispoint(4), ndiis
integer(kind=iwp) :: lun, rc

if (ndiis > 0) then
  lun = diispoint(1)
  call filemanager(3,lun,rc)
end if

if (ndiis > 1) then
  lun = diispoint(2)
  call filemanager(3,lun,rc)
end if

if (ndiis > 2) then
  lun = diispoint(3)
  call filemanager(3,lun,rc)
end if

if (ndiis > 3) then
  lun = diispoint(4)
  call filemanager(3,lun,rc)
end if

return

end subroutine diiscf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE T_ROW_TO_H(T,H,K,TKK)
*
* Set H integrals
*
*    Column K : H(P,K) = T(P,K)/T(K,K), P.NE.K
*    Other Columns     = 0
* - and return T_{kk} in TKK
*
*
* Jeppe Olsen, Jan 98
* For rotation of CI vectors
*
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "mxpdim.fh"
#include "glbbas.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "lucinp.fh"
*. Input ( in blocked form)
      DIMENSION T(*)
*. Output ( also in blocked form)
      DIMENSION H(*)
*
      KSM = ISMFSO(K)
      KOFF = IBSO(KSM)
      KREL = K - KOFF + 1
      NK = NTOOBS(KSM)

*
      ZERO = 0.0D0
      CALL SETVEC(H,ZERO,NTOOB**2)
*
      IOFF = IFRMR(IWORK(KPGINT1A(1)),1,KSM)
      CALL COPVEC(T(IOFF+(KREL-1)*NK),H(IOFF+(KREL-1)*NK),NK)
      TKK = H(IOFF-1+(KREL-1)*NK+KREL)
      IF(TKK .NE. 0.0D0) THEN
        FAC = 1.0D0/TKK
        CALL SCALVE(H(IOFF+(KREL-1)*NK),FAC,NK)
C       H(IOFF-1+(K-1)*NK+K) = H(IOFF-1+(K-1)*NK+K) -1.0D0
        H(IOFF-1+(KREL-1)*NK+KREL) = 0.0D0
      ELSE
C       TKK = 1.0D0
        TKK = 0.0D0
      END IF
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Tra_Ctl2(CMO,PUVX,TUVX,D1I,FI,D1A,FA,IPR,lSquare,ExFac)
!***********************************************************************
!                                                                      *
!     main control section for:                                        *
!     - transformation of ERIs from AO to MO basis                     *
!     - Fock matrix generation                                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*), D1I(*), D1A(*), ExFac
real(kind=wp), intent(inout) :: PUVX(*)
real(kind=wp), intent(_OUT_) :: TUVX(*)
real(kind=wp), intent(out) :: FI(*), FA(*)
integer(kind=iwp), intent(in) :: IPR
logical(kind=iwp), intent(in) :: lSquare
#include "rasdim.fh"
#include "general.fh"
integer(kind=iwp) :: iAsh, iBas, iDisk, iFro, iIsh, ij_Bas_pairs, ij_Orb_pairs, ijSym, iOff, iOrb, iStack, iSym, jAsh, jBas, jFro, &
                     jIsh, jOrb, jSym, kAsh, kBas, kFro, kIsh, kl_bas_pairs, kl_Orb_pairs, kOrb, kSym, kSymMax, lAsh, lBas, lFro, &
                     lIsh, lOrb, lSym, nPUVX, off_ltMat(mxSym), off_PUVX(mxSym,mxSym,mxSym), off_sqMat(mxSym)

if (IPR > 1) then
  write(u6,*)
  write(u6,*) ' Enter transformation section'
  write(u6,*) ' ============================'
  write(u6,*)
end if

! generate offsets

iStack = 0
do iSym=1,nSym
  off_sqMat(iSym) = iStack
  iBas = nBas(iSym)
  iStack = iStack+iBas*iBas
end do

iStack = 0
do iSym=1,nSym
  off_ltMat(iSym) = iStack
  iBas = nBas(iSym)
  iStack = iStack+(iBas*iBas+iBas)/2
end do

iStack = 0
do iSym=1,nSym
  iOrb = nOrb(iSym)
  do jSym=1,nSym
    jAsh = nAsh(jSym)
    ijSym = Mul(iSym,jSym)
    do kSym=1,nSym
      kAsh = nAsh(kSym)
      lSym = Mul(ijSym,kSym)
      if (lSym <= kSym) then
        lAsh = nAsh(lSym)
        kl_Orb_pairs = kAsh*lAsh
        if (kSym == lSym) kl_Orb_pairs = (kAsh*kAsh+kAsh)/2
        off_PUVX(iSym,jSym,kSym) = iStack
        iStack = iStack+iOrb*jAsh*kl_Orb_pairs
      end if
    end do
  end do
end do
nPUVX = iStack

! Init Fock matrices
FI(1:nTot1) = Zero
FA(1:nTot1) = Zero

! start transformation section

if (IPR >= 5) then
  write(u6,*) ' Symmetry  Basis functions   total orbitals    active orbitals'
  write(u6,*) ' -------------------------------------------------------------'
end if
do iSym=1,nSym
  iBas = nBas(iSym)
  iOrb = nOrb(iSym)
  iFro = nFro(iSym)
  iIsh = nIsh(iSym)
  iAsh = nAsh(iSym)
  do jSym=1,iSym
    jBas = nBas(jSym)
    jOrb = nOrb(jSym)
    jFro = nFro(jSym)
    jIsh = nIsh(jSym)
    jAsh = nAsh(jSym)
    ijSym = Mul(iSym,jSym)
    kSymMax = nSym
    if (.not. lSquare) kSymMax = iSym
    do kSym=1,kSymMax
      kBas = nBas(kSym)
      kOrb = nOrb(kSym)
      kFro = nFro(kSym)
      kIsh = nIsh(kSym)
      kAsh = nAsh(kSym)
      lSym = Mul(ijSym,kSym)
      if (lSym <= kSym) then
        lBas = nBas(lSym)
        lOrb = nOrb(lSym)
        lFro = nFro(lSym)
        lIsh = nIsh(lSym)
        lAsh = nAsh(lSym)

        if (iBas*jBas*kBas*lBas /= 0) then
          ij_Bas_pairs = iBas*jBas
          ij_Orb_pairs = iAsh*jAsh
          if (iSym == jSym) then
            ij_Bas_pairs = (iBas*iBas+iBas)/2
            ij_Orb_pairs = (iAsh*iAsh+iAsh)/2
          end if
          kl_Bas_pairs = kBas*lBas
          kl_Orb_pairs = kAsh*lAsh
          if (kSym == lSym) then
            kl_Bas_pairs = (kBas*kBas+kBas)/2
            kl_Orb_pairs = (kAsh*kAsh+kAsh)/2
          end if
          call TraDrv(IPR,lSquare,iSym,jSym,kSym,lSym,iBas,jBas,kBas,lBas,iOrb,jOrb,kOrb,lOrb,iFro,jFro,kFro,lFro,iIsh,jIsh,kIsh, &
                      lIsh,iAsh,jAsh,kAsh,lAsh,ij_Bas_pairs,kl_Bas_pairs,ij_Orb_pairs,kl_Orb_pairs,off_PUVX,off_sqMat,off_ltMat, &
                      mxSym,CMO,PUVX,D1I,FI,D1A,FA,ExFac)
        end if

      end if
    end do
  end do
end do
if (IPR >= 5) then
  write(u6,*) ' -------------------------------------------------------------'
end if

! Synchronize Fock matrices if running parallel:
call GADsum(FI,nTot1)
call GADsum(FA,nTot1)

! print FI and FA
if (IPR >= 10) then
  write(u6,*)
  write(u6,*) ' FI in AO-basis'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    if (iOrb > 0) call TriPrt(' ',' ',FI(iOff),iOrb)
    iOff = iOff+(iOrb*iOrb+iOrb)/2
  end do
  write(u6,*)
  write(u6,*) ' FA in AO-basis'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    if (iOrb > 0) call TriPrt(' ',' ',FA(iOff),iOrb)
    iOff = iOff+(iOrb*iOrb+iOrb)/2
  end do
end if

! Synchronize PUVX if running parallel:
call GAdsum(PUVX,nPUVX)

! select integrals TUVX
call Get_TUVX(PUVX,TUVX)

! save integrals on disk
iDisk = 0
call DDaFile(LUINTM,1,PUVX,nPUVX,iDisk)

return

end subroutine Tra_Ctl2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PotGrd(Grad,nGrad)

use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(out) :: Grad(nGrad)
integer(kind=iwp) :: ii, iIrrep, iPrint, iRout, lOper(1), nComp, nDens, nOrdOp
real(kind=wp) :: C(3), TCpu1, TCpu2, TWall1, TWall2
logical(kind=iwp) :: DiffOp
character(len=80) :: Label
character(len=8) :: Method
real(kind=wp), allocatable :: D_Var(:)
external :: PCMGrd1, PCMMmg
#include "Molcas.fh"
#include "disp.fh"
#include "print.fh"

! Prologue
iRout = 131
iPrint = nPrint(iRout)
call CWTime(TCpu1,TWall1)

! Allocate memory for density

nDens = 0
do iIrrep=0,nIrrep-1
  nDens = nDens+nBas(iIrrep)*(nBas(iIrrep)+1)/2
end do

! Get the method label
!write(u6,*) ' Read Method label'
call Get_cArray('Relax Method',Method,8)

! Read the variational 1st order density matrix
! density matrix in AO/SO basis
!write(u6,*) ' Read density matrix'
call mma_allocate(D_Var,nDens,Label='D_Var')
call Get_D1ao_Var(D_var,nDens)

if (iPrint >= 99) then
  write(u6,*) 'variational 1st order density matrix'
  ii = 1
  do iIrrep=0,nIrrep-1
    write(u6,*) 'symmetry block',iIrrep
    call TriPrt(' ',' ',D_Var(ii),nBas(iIrrep))
    ii = ii+nBas(iIrrep)*(nBas(iIrrep)+1)/2
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! nOrdOp: order/rank of the operator
! lOper: lOper of each component of the operator

nOrdOp = 0
nComp = nTri_Elem1(nOrdOp)
C(:) = Zero
lOper(1) = 1
DiffOp = .true.
call OneEl_g_pcm(PCMGrd1,PCMMmG,Grad,nGrad,DiffOp,C,D_Var,nDens,lOper,nComp,nOrdOp,Label)
call PrGrad_pcm(' TEST (PCM) contribution',Grad,nGrad,ChDisp,5)
!                                                                      *
!***********************************************************************
!                                                                      *
! Epilogue, end

call mma_deallocate(D_Var)

call CWTime(TCpu2,TWall2)
call SavTim(3,TCpu2-TCpu1,TWall2-TWall1)

return

end subroutine PotGrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FOCKOC_m(FOCC,F,CMO)
C
C     RASSCF program version IBM-3090: SX section
C
C     PURPOSE: Construct a fock matrix for the occupied orbitals and
C              write it on the job interphase for later use in
C              the RASSCF gradient programs.
C              The fock matrix is in MO basis with the frozen orbitals
C              excluded. It is symmetry blocked in contrast to earlier
C              versions.
C
C     called from FOCK if IFINAL=1.
C
C          ********** IBM-3090 MOLCAS Release: 90 02 22 **********
C

      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='FOCKOC  ')
#include "wadr.fh"
#include "WrkSpc.fh"

      DIMENSION FOCC(*),F(*),CMO(*)

C

      ISTFCK=0
      IPQ=0
* Loop over symmetry:
      DO ISYM=1,NSYM
       NIO=NISH(ISYM)
       NAO=NASH(ISYM)
       NOO=NIO+NAO
       NO=NORB(ISYM)
       IF(NOO.NE.0) THEN
        DO NP=1,NOO
         DO NQ=1,NOO
          IPQ=IPQ+1
          FOCC(IPQ)=F(ISTFCK+NO*(NQ-1)+NP)
         END DO
        END DO
       ENDIF
       ISTFCK=ISTFCK+NO**2
      END DO
C
      IAD15=IADR15(5)
      CALL DDAFILE(JOBIPH,1,FOCC,IPQ,IAD15)
C
c fock matrices added -- R L 921008.
*
*-----Start processing the all occupied indices Fock matrix
*
      Call GetMem('Scr1','ALLO','REAL',ipScr1,no2m)
      Call GetMem('Scr2','ALLO','REAL',ipScr2,no2m)


* NOTE: FOCC is nowadays allocated alredy in RASSCF.
* Disk address ipFocc is in /WADR/
*      Call GetMem('FOcc','ALLO','REAL',ipFocc,nTot1)
      call dcopy_(nTot1,[0.0D0],0,Work(ipFocc),1)
#ifdef _DEBUGPRINT_
      Write(LF,*) 'nTot1=',nTot1
#endif
      nFock = 0
      Do iSym = 1, nSym
         nFock = nFock + (nISh(iSym)+nASh(iSym))**2
      End Do
      Call GetMem('Fockoc','ALLO','REAL',ipFock,nFock)
      iAd15 = iAdr15(5)
*-----Read Fock matrix in MO basis from JOBIPH.
      Call DDaFile(Jobiph,2,Work(ipFock),nFock,iAd15)
#ifdef _DEBUGPRINT_
      Call RecPrt('Fock(MO)',' ',Work(ipFock),1,nFock)
#endif
*
*-----Construct the occupied part of the Fock matrix in SO/AO basis.
*
      ISTFCK= 1! ipFock
      jFock = ipFocc
      iCMo  = 1
* A long loop over symmetry:
      Do ISYM=1,NSYM
*        Hmm maybe you should check so I use correct nbas/norb
         NO = nOrb(isym)
         IF (NO.NE.0) THEN
*
*-----------Transform to SO/AO basis.
*
#ifdef _DEBUGPRINT_
            Write(LF,*) 'iSym=',iSym
            Call RecPrt('F(iStFck)',' ',F(iStFck),nOrb(iSym),
     &                                            nOrb(iSym))
            Call RecPrt('CMO(iCMO)',' ',CMO(iCMO),nBas(iSym),
     &                                            nBas(iSym))
#endif
            Call DGEMM_('N','N',
     &                  nBas(iSym),nOrb(isym),nOrb(isym),
     &                  1.0d0,CMO(iCMo),nBas(iSym),
     &                  F(iStFck),nOrb(isym),
     &                  0.0d0,Work(ipScr1),nBas(iSym))
            Call DGEMM_('N','T',
     &                  nBas(iSym),nBas(iSym),nOrb(isym),
     &                  1.0d0,Work(ipScr1),nBas(iSym),
     &                  CMO(iCMo),nBas(iSym),
     &                  0.0d0,Work(ipScr2),nBas(iSym))
            ij = jFock
            Do iBas = 1, nBas(iSym)
               Do jBas = 1, iBas-1
                  kl = ipScr2-1 + nBas(iSym)*(jBas-1) + iBas
                  lk = ipScr2-1 + nBas(iSym)*(iBas-1) + jBas
                  Work(ij) = Work(kl) + Work(lk)
                  ij = ij + 1
               END DO
               kl = ipScr2-1 + nBas(iSym)*(iBas-1) + iBas
               If (ij-jFock+1.gt.nTot1) Then
                  Write(LF,*) ij,jFock,nTot1
                  Call Abend()
               End If
               Work(ij) = Work(kl)
               ij = ij + 1
            END DO
         END IF
#ifdef _DEBUGPRINT_
         Call TriPrt('FAO',' ',Work(jFock),nBas(iSym))
#endif
         jFock = jFock + nBas(iSym)*(nBas(iSym)+1)/2
         iCMo  = iCMo  + nBas(iSym)**2
         ISTFCK=ISTFCK+NO**2
* End of long loop over symmetry
      END DO
      Call GetMem('Fockoc','FREE','REAL',ipFock,nFock)
      Call GetMem('Scr2','FREE','REAL',ipScr2,no2m)
      Call GetMem('Scr1','FREE','REAL',ipScr1,no2m)
*
c End of addition, R L 921008.
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mult (wrk,wrksize,
     & ninda,nindb,nindc,nindsum,
     & mapda,mapia,ssa,mapdb,mapib,ssb,mapdc,mapic,ssc,
     & possc0,rc)
c
c     ninda   - # of indexes in matrix A (Input)
c     nindb   - # of indexes in matrix B (Input)
c     nindc   - # of indexes in matrix C (Input, for test)
c     nindsum - # of sumation indexes    (Input)
c     mapda   - direct map matrix corresponding to A  (Input)
c     mapia   - inverse map matrix corresponding to A  (Input)
c     ssa     - overall symmetry state of matrix A (Input)
c     mapdb   - direct map matrix corresponding to B  (Input)
c     mapib   - inverse map matrix corresponding to B  (Input)
c     ssb     - overall symmetry state of matrix B (Input)
c     mapdc   - direct map matrix corresponding to C  (Output)
c     mapic   - inverse map matrix corresponding to C  (Output)
c     ssc     - overall symmetry state of matrix C  (Output)
c     possc0  - initial possition of matrix C  (Input)
c
c
c     This routine realize matrix-matrix and matrix-vector multiplications
c     A(indA)*B(indB)=C(indC) or A(indA)*B(indB)=Y(indC)
c
c     N.B.
c     ninda, nindb, and nindsum are independent,
c     nindc is tested if it is in agreement with previous ones - for test
c     typA, typB are tested if they are in mutual agreement
c
c
c     Table of implemented processes
c
c     nindA   nindB  nindsum =>nindC        Operation               Implemented
c     4       4       4       0     A(pqrs)*B(pqrs)  =S             Not yet
c     4       4       3       2     A(p,qrs)*B(qrs,t)=C(p,t)          Yes
c     4       4       2       4     A(pq,rs)*B(rs,tu)=C(pq,tu)        Yes
c     4       4       1       6     A(pqr,s)*B(s,tuv)=C(pqr,tuv)      No
c     4       4       0       8     A(pqrs)*B(tuvz)=C(pqrs,tuvz)      No
c
c     4       3       3       1     A(p,qrs)*B(qrs)  =Y(p)            Yes
c     4       3       2       3     A(pq,rs)*B(rs,t) =C(pq,t)         Yes
c     4       3       1       5     A(pqr,s)*B(s,tu) =C(pqr,tu)       No
c     4       3       0       7     A(pqrs)*B(tuv)   =C(pqrs,tuv)     No
c
c     4       2       2       2     A(pq,rs)*B(pq)   =Y(pq)           Yes
c     4       2       1       4     A(pqr,s)*B(s,t)  =C(pqr,t)        Yes
c     4       2       0       6     A(pqrs)*B(tu)    =C(pqrs,tu)      No
c
c     4       1       1       3     A(pqr,s)*B(s)    =Y(pqr)        Not yet
c     4       1       0       5     A(pqrs)*B(t)     =C(pqrs,t)       No
c
c     3       4       3       1     A(pqr) *B(pqr,s) =Y(s)          Not need
c     3       4       2       3     A(p,qr)*B(qr,st) =C(p,st)         Yes
c     3       4       1       5     A(pq,r)*B(r,stu) =C(pq,stu)       No
c     3       4       0       7     A(pqr)*B(stuv) =C(pqr,stuv)       No
c
c     3       3       3       0     A(pqr) *B(pqr)   =S             Not yet
c     3       3       2       2     A(p,qr)*B(qr,s)  =C(p,s)          Yes
c     3       3       1       4     A(pq,r)*B(r,st)  =C(pq,st)        Yes
c     3       3       0       6     A(pqr) *B(stu)   =C(pqrmstu)      No
c
c     3       2       2       1     A(p,qr)*B(qr)    =Y(p)            Yes
c     3       2       1       3     A(pq,r)*B(r,s)   =C(pq,s)         Yes
c     3       2       0       5     A(pqr) *B(st)    =C(pqr,st)       No
c
c     3       1       1       2     A(pq,r)*B(r)     =Y(pq)         Not yet
c     3       1       0       4     A(pqr) *B(s)     =C(pqr,s)        No
c
c     2       4       2       2     A(pq) *B(pq,rs)  =Y(rs)         Not need
c     2       4       1       4     A(p,q)*B(q,rst)  =C(p,rst)        Yes
c     2       4       0       6     A(pq) *B(rstu)   =C(pq,rstu)      No
c
c     2       3       2       1     A(pq) *B(pq,r)   =Y(r)          Not need
c     2       3       1       3     A(p,q)*B(q,rs)   =C(p,rs)         Yes
c     2       3       0       5     A(pq) *B(rst)    =C(pq,rst)       No
c
c     2       2       2       0     A(pq) *B(pq)     =S             Not yet
c     2       2       1       2     A(p,q)*B(q,r)    =C(p,r)          Yes
c     2       2       0       4     A(pq) *B(rs)     =C(pq,rs)        No
c
c     2       1       1       1     A(p,q)*B(q)      =Y(p)          Not yet
c     2       1       0       3     A(pq) *B(r)      =C(pq,r)         No
c
c     1       4       1       3     A(p)*B(p,qrs)    =Y(qrs)        Not need
c     1       4       0       5     A(p)*B(qrst)     =C(p,qrst)       No
c
c     1       3       1       2     A(p)*B(p,qr)     =Y(qr)         Not need
c     1       3       0       4     A(p)*B(qrs)      =C(p,qrs)        No
c
c     1       2       1       1     A(p)*B(p,q)      =Y(q)          Not need
c     1       2       0       3     A(p)*B(qr)       =C(p,qr)         No
c
c     1       1       1       0     A(p)*B(p)        =S             Not yet
c     1       1       0       2     A(p)*B(q)        =C(p,q)          No
c
c     Legend used in error messeges:
c     NCI = Not Currently Implemented
c     Stup= Stupidity
c     @   = inproper value
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer ninda,nindb,nindc,nindsum,ssa,ssb,ssc,possc0,rc
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
c     help variables
c
       integer mvec(1:4096,1:7)
       integer typa,typb,ix

       rc=0
       ssc=mmul(ssa,ssb)
       typa=mapda(0,6)
       typb=mapdb(0,6)
c
c
c
       if (ninda.eq.4) then
c
c     ****** nind A = 4  ******
c
       if (nindb.eq.4) then
c
c44   *** nind A =4, B=4
c
       if (nindsum.eq.1) then
c     RC=1 : nindA=4, nindB=4, nindsum=1 (too large metiate, NCI)
       rc=1
       return
c
       else if (nindsum.eq.2) then
c
c     case A(pqrs)*B(rstu)=C(pqtu)
c
c     tests
c
       if (nindc.ne.4) then
c     RC=2 : nindA=4, nindB=4, nindsum=2 (# of ind. in C is not 4, Stup)
       rc=2
       return
       end if
c
       if (typa.eq.2) then
c     RC=3 : nindA=4, nindB=4, nindsum=2 (typA is 2, Stup)
       rc=3
       return
       end if
c
       if (typb.eq.2) then
c     RC=4 : nindA=4, nindB=4, nindsum=2 (typB is 2, Stup)
       rc=4
       return
       end if
c
       if ((typa.eq.3).or.(typa.eq.4)) then
c     there is  r>s in A
       if ((typb.eq.4).or.(typb.eq.1)) then
c     OK
       else
c     RC=5 : nindA=4, nindB=4, nindsum=2 (typA incompatible with typB , Stup)
       rc=5
       return
       end if
       else
c     there is no r>s in A
       if ((typb.eq.4).or.(typb.eq.1)) then
c     RC=5 : nindA=4, nindB=4, nindsum=2 (typA incompatible with typB , Stup)
       rc=5
       return
       else
c     OK
       end if
       end if
c
c     call grc44C and multc0
c
       call grc44C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,2,possc0,ix)
c
       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.3) then
c
c     case A(pqrs)*B(qrst)=C(pt)
c
c     tests
c
       if (nindc.ne.2) then
c     RC=6 : nindA=4, nindB=4, nindsum=3 (# of ind. in C is not 2, Stup)
       rc=6
       return
       end if
c
       if (typa.eq.1) then
c     RC=7 : nindA=4, nindB=4, nindsum=3 (typA is 1, Stup)
       rc=7
       return
       end if
c
       if (typb.eq.3) then
c     RC=8 : nindA=4, nindB=4, nindsum=3 (typB is 3, Stup)
       rc=8
       return
       end if
c
       if ((typa.eq.2).and.(typb.ne.1)) then
c     RC=9 : nindA=4, nindB=4, nindsum=3 (typA incomp. with typB, Stup)
       rc=9
       return
       end if
c
       if ((typa.eq.3).and.(typb.ne.2)) then
c     RC=9 : nindA=4, nindB=4, nindsum=3 (typA incomp. with typB, Stup)
c     like in previous case
       rc=9
       return
       end if
c
c     call grc44C and multc0
c
       call grc44C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,1,possc0,ix)
c
       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.4) then
c     RC=10: nindA=4, nindB=4, nindsum=4 (NCI)
       rc=10
       return
c
       else
c     RC=11: nindA=4, nindB=4, nindsum=@ (Stup)
       rc=11
       return
       end if
c
       else if (nindb.eq.3) then
c
c43   *** nind A =4, B=3
c
       if (nindsum.eq.3) then
c
c     case A(pqrs)*B(qrs)=Y(p)
c
c     tests
c
       if (nindc.ne.1) then
c     RC=12: nindA=4, nindB=3, nindsum=3 (# of index in C is not 1, Stup)
       rc=12
       return
       end if
c
       if ((typa.eq.1).or.(typa.eq.4)) then
c     RC=13: nindA=4, nindB=3, nindsum=3 (typA is 1 or 4, Stup)
       rc=13
       return
       end if
c
       if ((typa.eq.2).and.(typb.ne.1)) then
c     RC=14: nindA=4, nindB=3, nindsum=3 (typA incomp. with typB, Stup)
       rc=14
       return
       end if
c
       if ((typa.eq.3).and.(typb.ne.2)) then
c     RC=14: nindA=4, nindB=3, nindsum=3 (typA incomp. with typB, Stup)
c     like in previous case
       rc=14
       return
       end if
c
c     call grc43y and multy0
c
       call grc43y (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,possc0,ix)

       call multy0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.2) then
c
c     case A(pqrs)*B(rst)=C(pqt)
c
c     tests
c
       if (nindc.ne.3) then
c     RC=15: nindA=4, nindB=3, nindsum=2 (# of index in C is not 3, Stup)
       rc=15
       return
       end if
c
       if (typa.eq.2) then
c     RC=16: nindA=4, nindB=3, nindsum=2 (typA is 2, Stup)
       rc=16
       return
       end if
c
       if (typb.eq.2) then
c     RC=17: nindA=4, nindB=3, nindsum=2 (typB is 2, Stup)
       rc=17
       return
       end if
c
       if (((typa.eq.3).or.(typa.eq.4)).and.(typb.ne.1)) then
c     RC=18: nindA=4, nindB=3, nindsum=2 (typA incomp. with typB, Stup)
       rc=18
       return
       end if
c
c     call grc43c and multc0
c
       call grc43c (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,2,possc0,ix)

       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.1) then
c     RC=19: nindA=4, nindB=3, nindsum=1 (too large mediate, NCI)
       rc=19
       return
c
       else
c     RC=20: nindA=4, nindB=3, nindsum=@ (Stup)
       rc=20
       return
       end if
c
       else if (nindb.eq.2) then
c
c42   *** nind A =4, B=2
c
       if (nindsum.eq.1) then
c
c     case A(pqr,s)*B(s,t)=C(pqr,t)
c
c     tests
c
       if (nindc.ne.4) then
c     RC=21: nindA=4, nindB=2, nindsum=1 (# of index in C is not 4, Stup)
       rc=21
       return
       end if
c
       if ((typa.eq.3).or.(typa.eq.4)) then
c     RC=22: nindA=4, nindB=2, nindsum=1 (typA is 3 or 4, Stup)
       rc=22
       return
       end if
c
       if (typb.eq.1) then
c     RC=23: nindA=4, nindB=2, nindsum=1 (typA is 1, Stup)
       rc=23
       return
       end if
c
c     call grc42c and multc0
c
       call grc42c (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,3,possc0,ix)
c
       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.2) then
c
c     case A(pqrs)*B(rs)=Y(pq)
c
c     tests
c
       if (nindc.ne.2) then
c     RC=24: nindA=4, nindB=2, nindsum=2 (# of index in C is not 2, Stup)
       rc=24
       return
       end if
c
       if (typa.eq.2) then
c     RC=25: nindA=4, nindB=2, nindsum=2 (typA is 2, Stup)
       rc=25
       return
       end if
c
       if (((typa.eq.3).or.(typa.eq.4)).and.(typb.ne.1)) then
c     RC=26: nindA=4, nindB=2, nindsum=2 (typA incomp. with typB, Stup)
       rc=26
       return
       end if
c
c     call grc42y and multy0
c
       call grc42y (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,possc0,ix)
c
       call multy0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else
c     RC=27: nindA=4, nindB=2, nindsum=@ (Stup)
       rc=27
       return
       end if
c
       else if (nindb.eq.1) then
c
c41   *** nind A =4, B=1
c
c     RC=28: nindA=4, nindB=1 (NCI)
       rc=28
       return
c
       else
c
c4@   *** nind A =4, B=@
c
c     RC=29  : nindA=4, nindB=@ (Stup)
       rc=29
       return
       end if
c
       else if (ninda.eq.3) then
c
c     ****** nind A = 3  ******
c
       if (nindb.eq.4) then
c
c34   *** nind A =3, B=4
c
       if (nindsum.eq.1) then
c     RC=30: nindA=3, nindB=4, nindsum=1 (too large mediate, NCI)
       rc=30
       return
c
       else if (nindsum.eq.2) then
c
c     case A(p,qr)*B(qr,st)=C(p,st)
c
c     tests
c
       if (nindc.ne.3) then
c     RC=31: nindA=3, nindB=4, nindsum=2 (# of ind. in C is not 3, Stup)
       rc=31
       return
       end if
c
       if (typa.eq.1) then
c     RC=32: nindA=3, nindB=4, nindsum=2 (typA is 1, Stup)
       rc=32
       return
       end if
c
       if (typb.eq.2) then
c     RC=33: nindA=3, nindB=4, nindsum=2 (typB is 2, Stup)
       rc=33
       return
       end if
c
       if (((typb.eq.1).or.(typb.eq.4)).and.(typa.ne.2)) then
c     RC=34: nindA=3, nindB=4, nindsum=2 (typA incomp. with typB, Stup)
       rc=34
       return
       end if
c
c     call grc34c and multc0
c
       call grc34c (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,1,possc0,ix)
c
       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.3) then
c     RC=35: nindA=3, nindB=4, nindsum=3 (NCI)
       rc=35
       return
       end if
c
       else if (nindb.eq.3) then
c
c33   *** nind A =3, B=3
c
       if (nindsum.eq.1) then
c
c     case A(pq,r)*B(r,st)=A(pq,st)
c
c     tests
c
       if (nindc.ne.4) then
c     RC=36: nindA=3, nindB=3, nindsum=1 (# of ind. in C is not 4, Stup)
       rc=36
       return
       end if
c
       if (typa.eq.2) then
c     RC=37: nindA=3, nindB=3, nindsum=1 (typA is 2, Stup)
       rc=37
       return
       end if
c
       if (typb.eq.1) then
c     RC=38: nindA=3, nindB=3, nindsum=1 (typB is 1, Stup)
       rc=38
       return
       end if
c
c     call grc34c and multc0
c
       call grc34c (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,2,possc0,ix)

       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.2) then
c
c     case A(p,qr)*B(rq,s)=C(p,s)
c
c     tests
c
       if (nindc.ne.2) then
c     RC=39: nindA=3, nindB=3, nindsum=2 (# of ind. in C is not 2, Stup)
       rc=39
       return
       end if
c
       if (typa.eq.1) then
c     RC=40: nindA=3, nindB=3, nindsum=2 (typA is 1, Stup)
       rc=40
       return
       end if
c
       if (typb.eq.2) then
c     RC=41: nindA=3, nindB=3, nindsum=2 (typB is 2, Stup)
       rc=41
       return
       end if
c
       if ((typa.eq.2).and.(typb.ne.1)) then
c     RC=42: nindA=3, nindB=3, nindsum=2 (typA incomp. with typB, Stup)
       rc=42
       return
       end if
c
c     call grc33c and multc0
c
       call grc33c (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,1,possc0,ix)

       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.3) then
c     RC=43: nindA=3, nindB=3, nindsum=3 (NCI)
       rc=43
       return
       end if
c
       else if (nindb.eq.2) then
c
c32   *** nind A =3, B=2
c
       if (nindsum.eq.1) then
c
c     case A(pq,r)*B(r,s)=C(pq,s)
c
c     tests
c
       if (nindc.ne.3) then
c     RC=44: nindA=3, nindB=2, nindsum=1 (# of ind. in C is not 3, Stup)
       rc=44
       return
       end if
c
       if (typa.eq.2) then
c     RC=45: nindA=3, nindB=2, nindsum=1 (typA is 2, Stup)
       rc=45
       return
       end if
c
       if (typb.eq.1) then
c     RC=46: nindA=3, nindB=2, nindsum=1 (typB is 1, Stup)
       rc=46
       return
       end if
c
c     call grc32c and multc0
c
       call grc32c (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,2,possc0,ix)

       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.2) then
c
c     case A(p,qr)*B(qr)=C(p)
c
c     tests
c
       if (nindc.ne.1) then
c     RC=47: nindA=3, nindB=2, nindsum=2 (# of ind. in C is not 1, Stup)
       rc=47
       return
       end if
c
       if (typa.eq.1) then
c     RC=48: nindA=3, nindB=2, nindsum=2 (typA is 1, Stup)
       rc=48
       return
       end if
c
       if ((typb.eq.1).and.(typa.ne.2)) then
c     RC=49: nindA=3, nindB=2, nindsum=2 (typA incomp. with typB, Stup)
       rc=49
       return
       end if
c
c     call grc32y and multy0
c
       call grc32y (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,possc0,ix)
c
       call multy0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else
c     RC=50: nindA=3, nindB=2, nindsum=@ (Stup)
       rc=50
       return
       end if
c
       else if (nindb.eq.1) then
c
c31   *** nind A =3, B=1
c
c     RC=51: nindA=3, nindB=1 (NCI)
       rc=51
       return
c
       else
c
c3@   *** nind A =3, B=@
c
c     RC=52: nindA=3, nindB=@ (Stup)
       rc=52
       return
       end if
c
       else if (ninda.eq.2) then
c
c     ****** nind A = 2  ******
c
       if (nindb.eq.4) then
c
c24   *** nind A =2, B=4
c
       if (nindsum.eq.1) then
c
c     case A(p,q)*B(q,rst)=C(p,rst)
c
c     tests
c
       if (nindc.ne.4) then
c     RC=53: nindA=2, nindB=4, nindsum=1 (# of ind. in C is not 4, Stup)
       rc=53
       return
       end if
c
       if (typa.eq.1) then
c     RC=54: nindA=2, nindB=4, nindsum=1 (typA is 1, Stup)
       rc=54
       return
       end if
c
       if ((typb.eq.1).or.(typb.eq.4)) then
c     RC=55: nindA=2, nindB=4, nindsum=1 (typB is 1 or 4, Stup)
       rc=55
       return
       end if
c
c     call grc24c and multc0
c
       call grc24C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,1,possc0,ix)
c
       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.2) then
c     RC=56: nindA=2, nindB=4, nindsum=2 (NCI)
       rc=56
       return
c
       else
c     RC=57: nindA=2, nindB=4, nindsum=@ (Stup)
       rc=57
       return
       end if
c
       else if (nindb.eq.3) then
c
c23   *** nind A =2, B=3
c
       if (nindsum.eq.1) then
c
c     case A(p,q)*B(q,rs)=C(p,rs)
c
c     tests
c
       if (nindc.ne.3) then
c     RC=58: nindA=2, nindB=3, nindsum=1 (# of ind. in C is not 3, Stup)
       rc=58
       return
       end if
c
       if (typa.eq.1) then
c     RC=59: nindA=2, nindB=3, nindsum=1 (typA is 1, Stup)
       rc=59
       return
       end if
c
       if (typb.eq.1) then
c     RC=60: nindA=2, nindB=3, nindsum=1 (typB is 1, Stup)
       rc=60
       return
       end if
c
c     call grc23c and multc0
c
       call grc23C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,1,possc0,ix)

       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.2) then
c     RC=61: nindA=2, nindB=3, nindsum=2 (NCI)
       rc=61
       return
c
       else
c     RC=62: nindA=2, nindB=3, nindsum=@ (Stup)
       rc=62
       return
       end if
c
       else if (nindb.eq.2) then
c
c22   *** nind A =2, B=2
c
       if (nindsum.eq.1) then
c
c     case A(p,q)*B(q,r)=C(p,r)
c
c     tests
c
       if (nindc.ne.2) then
c     RC=63: nindA=2, nindB=2, nindsum=1 (# of ind. in C is not 2, Stup)
       rc=63
       return
       end if
c
       if (typa.eq.1) then
c     RC=64: nindA=2, nindB=2, nindsum=1 (typA is 1, Stup)
       rc=64
       return
       end if
c
       if (typb.eq.1) then
c     RC=65: nindA=2, nindB=2, nindsum=1 (typB is 1, Stup)
       rc=65
       return
       end if
c
c     call grc22c and multc0
c
       call grc22C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,1,possc0,ix)
c
       call multc0 (wrk,wrksize,
     & mvec,ix,mapdc,1)
c
       else if (nindsum.eq.2) then
c     RC=66: nindA=2, nindB=2, nindsum=2 (NCI)
       rc=66
       return
c
       else
c     RC=67: nindA=2, nindB=2, nindsum=@ (Stup)
       rc=67
       return
       end if
c
       else if (nindb.eq.1) then
c
c21   *** nind A =2, B=1
c
c     RC=68: nindA=2, nindB=1 (NCI)
       rc=68
       return
c
       else
c
c2@   *** nind A =2, B=@
c
c     RC=69: nindA=2, nindB=@
       rc=69
       return
       end if
c
       else if (ninda.eq.1) then
c
c     ****** nind A = 1  ******
c
c1x   RC=70: nind=1 (NCI)
       rc=70
       return
c
       else
c
c     ****** nind A = @  ******
c
c@x   RC=71: inproper nindA
       rc=71
       return
       end if
c
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKTDZZ(CMOA,CMOB,TDMAB,TDMZZ,iRC)

use Cntrl, only: LSYM1, LSYM2
use Symmetry_Info, only: MUL, nIrrep
use rassi_data, only: NBASF, NCMO, NOSH, NTDMAB, NTDMZZ
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CMOA(NCMO), CMOB(NCMO), TDMAB(NTDMAB)
real(kind=wp), intent(out) :: TDMZZ(NTDMZZ)
integer(kind=iwp), intent(in) :: iRC
integer(kind=iwp) :: IST, ISTCA, ISTCB, ISTCMO(8), ISTTA, ISTTZ, ISY1, ISY12, ISY2, NB1, NB2, NO1, NO2, NSCR
real(kind=wp), allocatable :: SCR(:)

if (iRC == 0) then
  TDMZZ(:) = Zero
  return
end if
! ISTCMO()=START INDEX FOR CMO ARRAY SYMMETRY BLOCKS.
ISY12 = MUL(LSYM1,LSYM2)
! NSCR=SIZE NEEDED FOR TEMPORARY MATRIX PRODUCT.
NSCR = 0
IST = 1
do ISY1=1,nIrrep
  ISTCMO(ISY1) = IST
  NO1 = NOSH(ISY1)
  IST = IST+NO1*NBASF(ISY1)
  ISY2 = MUL(ISY1,ISY12)
  NSCR = max(NSCR,NO1*NBASF(ISY2))
end do
call mma_allocate(SCR,NSCR,Label='SCR')
ISTTA = 1
ISTCA = 1
ISTTZ = 1
do ISY1=1,nIrrep
  ISY2 = MUL(ISY1,ISY12)
  ISTCB = ISTCMO(ISY2)
  NO1 = NOSH(ISY1)
  NO2 = NOSH(ISY2)
  NB1 = NBASF(ISY1)
  NB2 = NBASF(ISY2)
  if (NB1*NB2 /= 0) then
    if (NO1*NO2 == 0) then
      TDMZZ(ISTTZ:ISTTZ+NB1*NB2-1) = Zero
    else
      call DGEMM_('N','T',NO1,NB2,NO2,One,TDMAB(ISTTA),NO1,CMOB(ISTCB),NB2,Zero,SCR,NO1)
      call DGEMM_('N','N',NB1,NB2,NO1,One,CMOA(ISTCA),NB1,SCR,NO1,Zero,TDMZZ(ISTTZ),NB1)
      ISTTA = ISTTA+NO1*NO2
    end if
  end if
  ISTCA = ISTCA+NB1*NO1
  ISTTZ = ISTTZ+NB1*NB2
end do
call mma_deallocate(SCR)

end subroutine MKTDZZ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetInc()
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Initialize all entries in LDF include files.
C
C     localdf.fh
C     localdf_print.fh
C     localdf_bas.fh
C     localdf_int.fh
C     localdf_int2.fh
C     localdf_int3.fh
C     ldf_atom_info.fh
C     ldf_atom_pair_info.fh
C     ldf_cio.fh
C     ldf_a2ap.fh
C     ldf_integral_prescreening_info.fh
C     ldf_qdiag.fh
C     ldf_oneel.fh
C     ldf_charge_constraint_info.fh
C     ldf_atomiclabels.fh
C
      Implicit None
#include "localdf.fh"
#include "localdf_print.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"
#include "ldf_atom_info.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_cio.fh"
#include "ldf_a2ap.fh"
#include "ldf_integral_prescreening_info.fh"
#include "ldf_qdiag.fh"
#include "ldf_oneel.fh"
#include "ldf_charge_constraint_info.fh"
#include "ldf_atomiclabels.fh"

C     localdf.fh
C     ===========

      LDF2=.False.
      VerifyFit=.False.
      CheckPairIntegrals=.False.
      CheckOverlapIntegrals=.False.
      Thr_Prescreen=-1.0d9
      Thr_Accuracy=-1.0d9
      LDF_Run_Mode=0
      LDF_Constraint=-1
      WriteUnconstrainedC=.False.
      UseUniqueAtomPairs=.False.

C     localdf_print.fh
C     =================

      iPrint=0

C     localdf_bas.fh
C     ===============

      nBas_Valence=0
      nBas_Auxiliary=0
      nShell_Valence=0
      nShell_Auxiliary=0
      ip_iSOShl=0
      l_iSOShl=0
      ip_iShlSO=0
      l_iShlSO=0
      ip_nBasSh=0
      l_nBasSh=0

C     localdf_int.fh
C     ===============

      SHA=0
      SHB=0
      SHC=0
      SHD=0
      SPAB=0
      SPCD=0
      ip_IndxG=0
      l_IndxG_1=0
      l_IndxG_2=0
      ip_IndxG2=0
      l_IndxG2_1=0
      l_IndxG2_2=0
      ip_2CList=0
      l_2CList_1=0
      l_2CList_2=0
      ip_iOff=0
      l_iOff=0
      nRow_G=0
      nRow_uvJ=0
      iOffuv=0

C     localdf_int2.fh
C     ================

      Call LDF_Set_localdf_int2()

C     localdf_int3.fh
C     ================

      Call LDF_Set_localdf_int3()

C     ldf_atom_info.fh
C     =================

      LDF_AtomInfo_Status=LDF_AtomInfo_Unset
      NumberOfAtoms=0
      ip_Coord=0
      l_Coord=0
      ip_A_Unique=0
      l_A_Unique=0
      ip_A_Shells=0
      l_A_Shells=0
      ip_A_AuxShells=0
      l_A_AuxShells=0

C     ldf_atom_pair_info.fh
C     ======================

      LDF_AtomPairInfo_Status=LDF_AtomPairInfo_Unset
      NumberOfAtomPairs=0
      ip_AP_Atoms=0
      l_AP_Atoms=0
      ip_AP_Unique=0
      l_AP_Unique=0
      ip_AP_Diag=0
      l_AP_Diag=0
      ip_AP_DiagBak=0
      l_AP_DiagBak=0
      ip_AP_1CLinDep=0
      l_AP_1CLinDep=0
      ip_AP_2CFunctions=0
      l_AP_2CFunctions=0
      ip_AP_DiskC=0
      l_AP_DiskC=0

C     ldf_cio.fh.
C     ============

      Lu_LDFC=0
      LastAtomPair=0
      ip_LDFC_Buffer=0
      l_LDFC_Buffer=0
      ip_LDFC_Blocks=0
      l_LDFC_Blocks=0

C     ldf_a2ap.fh.
C     =============

      ip_A2AP=0
      l_A2AP=0

C     ldf_integral_prescreening_info.fh.
C     ===================================

      ip_GDiag_1C=0
      l_GDiag_1C=0
      ip_GDiag_1C_Mx=0
      l_GDiag_1C_Mx=0
      ip_GDiag_1C_Sm=0
      l_GDiag_1C_Sm=0
      ip_GDiag_2C=0
      l_GDiag_2C=0
      ip_GDiag_2C_Mx=0
      l_GDiag_2C_Mx=0
      ip_GDiag_2C_Sm=0
      l_GDiag_2C_Sm=0
      ip_IDiag=0
      l_IDiag=0
      ip_IDiag_Mx=0
      l_IDiag_Mx=0
      ip_IDiag_Sm=0
      l_IDiag_Sm=0

C     ldf_qdiag.fh.
C     ==============

      ip_AP_QDiag=0
      l_AP_QDiag=0

C     ldf_oneel.fh.
C     ==============

      OperatorLabel='IS_UNSET'
      nComp=0
      nIC=0
      Call iZero(iStabO,8)
      nStabO=0
      ip_lOper=0
      l_lOper=0
      ip_kOper=0
      l_kOper=0
      ip_CCoor=0
      l_CCoor=0
      ip_xZeta=0
      l_xZeta=0
      ip_xZI=0
      l_xZI=0
      ip_xKappa=0
      l_xKappa=0
      ip_xPCoor=0
      l_xPCoor=0
      rHrmt=-9.9d9

C     ldf_charge_constraint_info.fh.
C     ===============================

      ChargeConstraintSet=.False.
      ip_CC_AuxIntVec=0
      ip_CC_Overlap=0
      l_CC_Overlap=0
      ip_CC_lambda=0
      l_CC_lambda=0

C     ldf_atomiclabels.fh.
C     =====================

      AtomicLabelsSet=.False.
      ip_AtomicLabels=0
      l_AtomicLabels=0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Set_localdf_int2()
      Implicit None
#include "localdf_int2.fh"

      SHA=0
      SHB=0
      SHC=0
      SHD=0

      SPAB=0
      SPCD=0

      ip_AB_IndxG=0
      l_AB_IndxG_1=0
      l_AB_IndxG_2=0
      ip_AB_IndxG2=0
      l_AB_IndxG2_1=0
      l_AB_IndxG2_2=0
      ip_AB_2CList=0
      l_AB_2CList_1=0
      l_AB_2CList_2=0

      ip_CD_IndxG=0
      l_CD_IndxG_1=0
      l_CD_IndxG_2=0
      ip_CD_IndxG2=0
      l_CD_IndxG2_1=0
      l_CD_IndxG2_2=0
      ip_CD_2CList=0
      l_CD_2CList_1=0
      l_CD_2CList_2=0

      nAB=0
      nCD=0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Set_localdf_int3()
      Implicit None
#include "localdf_int3.fh"

      SHA=0
      SHB=0
      SHC=0
      SHD=0

      nRow=0
      iRow0=0
      iCol0=0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gencoulDIM(l1,l2,l3,l4,makemean,icont4)
!bs SUBROUTINE to calculate the dimemsion of the radial integral
!bs arrays. BASICALLY GENCOUL WITHOUT EXPLICIT INTEGRAL CALCULATION
!bs integrals for the four angular momenta l1-l4

use AMFI_global, only: Lblocks, Lfirst, Llast, Lstarter, Lvalues, nblock, ncontrac
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: l1, l2, l3, l4
logical(kind=iwp), intent(in) :: makemean
integer(kind=iwp), intent(out) :: icont4
integer(kind=iwp) :: incl1, incl3, Lanf, Lend, nanz

!bs first of all, this routine determines, for which L
!bs values the radial integrals have to be solved
!bs initialize the number of blocks for the different
!bs l-combinations
!bs no (ss|ss) contributions
if ((l1 == 0) .and. (l2 == 0) .and. (l3 == 0) .and. (l4 == 0)) return
! no integrals for <ss|ss>
if (makemean) then
  nblock = 1  ! sp sp are the first, so the first block
  Lstarter(1) = 1
else
  call SysAbendMsg('gencoulDIM','only mean-field with this version',' ')
end if
!bs keep track of L-values for later purposes
Lvalues(1) = l1
Lvalues(2) = l2
Lvalues(3) = l3
Lvalues(4) = l4
!bs now nanz is given the new value
nanz = ncontrac(l1)*ncontrac(l2)*ncontrac(l3)*ncontrac(l4)

!bs prepare the powers needed for cfunctx
!
! There are seven different CASES of integrals following
!  (   A  --  C)
!
! The structure is the same for all cases, therefore comments can be found only on case A

!bs ####################################################################
!bs   the (+2) cases          CASE A
!bs ####################################################################
incl1 = 1  !  Those increments define the case
incl3 = 1
!bs determine the possible L-values for the integrals by checking for triangular equation

call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)

!bs returns first and last L-values (Lanf,Lend), for which
!bs radial integrals have to be calculated
if (Lend-Lanf >= 0) then
  !bs if there are blocks
  Lblocks(1) = (Lend-Lanf)/2+1 ! L increases in steps of 2, due to parity conservation
  Lfirst(1) = Lanf
  Llast(1) = Lend
else
  Lblocks(1) = 0
end if
!bs ####################################################################
!bs   the (0) cases         CASE  B
!bs ####################################################################
incl1 = 0
incl3 = 0
call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
if (Lend-Lanf >= 0) then
  Lblocks(2) = (Lend-Lanf)/2+1
  Lfirst(2) = Lanf
  Llast(2) = Lend
  Lblocks(3) = (Lend-Lanf)/2+1
  Lfirst(3) = Lanf
  Llast(3) = Lend
else
  Lblocks(2) = 0
  Lblocks(3) = 0
end if
Lstarter(2) = Lstarter(1)+nanz*Lblocks(1)
Lstarter(3) = Lstarter(2)+nanz*Lblocks(2)
!bs ####################################################################
!bs   the (-2) cases      CASE C
!bs ####################################################################
if ((l1 == 0) .or. (l3 == 0)) then
  Lblocks(4) = 0
else
  incl1 = -1
  incl3 = -1
  call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
  if (Lend-Lanf >= 0) then
    Lblocks(4) = (Lend-Lanf)/2+1
    Lfirst(4) = Lanf
    Llast(4) = Lend
  else
    Lblocks(4) = 0
  end if
end if
Lstarter(4) = Lstarter(3)+nanz*Lblocks(3)

!BS now the whole purpose of this routine

icont4 = Lstarter(4)+nanz*Lblocks(4)

return

end subroutine gencoulDIM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKBA_F3(ISYM,BA,MBA,NG3,F3,idxG3)

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use SUPERINDEX, only: KTUV
use caspt2_module, only: IASYM, NASHT, nTUVES
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: ISYM, MBA, NG3
real(kind=wp), intent(inout) :: BA(MBA)
real(kind=wp), intent(in) :: F3(NG3)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: iG3, ISADR, iST, iSU, ISUP, iSV, iSX, iSY, iSZ, iT, iTU, ituvs, iU, iV, iVX, iX, ixyzs, iY, iYZ, iZ, JSUP, jSYM
real(kind=wp) :: F3VAL

!-SVC20100831: determine indices in SA where a certain F3 value will end up
do iG3=1,NG3
  iT = idxG3(1,iG3)
  iU = idxG3(2,iG3)
  iV = idxG3(3,iG3)
  iX = idxG3(4,iG3)
  iY = idxG3(5,iG3)
  iZ = idxG3(6,iG3)
  iST = IASYM(iT)
  iSU = IASYM(iU)
  iSV = IASYM(iV)
  iSX = IASYM(iX)
  iSY = IASYM(iY)
  iSZ = IASYM(iZ)
  ituvs = Mul(IST,Mul(ISU,ISV))
  ixyzs = Mul(ISX,Mul(ISY,ISZ))
  if (ituvs /= ixyzs) cycle
  iTU = iT+NASHT*(iU-1)
  iVX = iV+NASHT*(iX-1)
  iYZ = iY+NASHT*(iZ-1)
  F3VAL = -F3(iG3)
  !-SVC20100829: 12 equivalent cases, of which the second
  !  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
  !  - F(tuvxyz) -> BA(xut,vyz)
  jSYM = Mul(IASYM(iX),Mul(IASYM(iU),IASYM(iT)))
  if (jSYM == iSYM) then
    ISUP = KTUV(iX,iU,iT)-nTUVES(jSYM)
    JSUP = KTUV(iV,iY,iZ)-nTUVES(jSYM)
    if (JSUP <= ISUP) then
      ISADR = iTri(ISUP,JSUP)
      BA(ISADR) = BA(ISADR)+F3VAL
    end if
  end if
  if (.not. ((iTU == iVX) .and. (iVX == iYZ))) then
    if (.not. ((iTU == iVX) .or. (iTU == iYZ) .or. (iVX == iYZ))) then
      !  - F(vxtuyz) -> BA(uxv,tyz)
      jSYM = Mul(IASYM(iU),Mul(IASYM(iX),IASYM(iV)))
      if (jSYM == iSYM) then
        ISUP = KTUV(iU,iX,iV)-nTUVES(jSYM)
        JSUP = KTUV(iT,iY,iZ)-nTUVES(jSYM)
        if (JSUP <= ISUP) then
          ISADR = iTri(ISUP,JSUP)
          BA(ISADR) = BA(ISADR)+F3VAL
        end if
      end if
      !  - F(yzvxtu) -> BA(xzy,vtu)
      jSYM = Mul(IASYM(iX),Mul(IASYM(iZ),IASYM(iY)))
      if (jSYM == iSYM) then
        ISUP = KTUV(iX,iZ,iY)-nTUVES(jSYM)
        JSUP = KTUV(iV,iT,iU)-nTUVES(jSYM)
        if (JSUP <= ISUP) then
          ISADR = iTri(ISUP,JSUP)
          BA(ISADR) = BA(ISADR)+F3VAL
        end if
      end if
      !  - F(tuyzvx) -> BA(zut,yvx)
      jSYM = Mul(IASYM(iZ),Mul(IASYM(iU),IASYM(iT)))
      if (jSYM == iSYM) then
        ISUP = KTUV(iZ,iU,iT)-nTUVES(jSYM)
        JSUP = KTUV(iY,iV,iX)-nTUVES(jSYM)
        if (JSUP <= ISUP) then
          ISADR = iTri(ISUP,JSUP)
          BA(ISADR) = BA(ISADR)+F3VAL
        end if
      end if
    end if
    !  - F(yztuvx) -> BA(uzy,tvx)
    jSYM = Mul(IASYM(iU),Mul(IASYM(iZ),IASYM(iY)))
    if (jSYM == iSYM) then
      ISUP = KTUV(iU,iZ,iY)-nTUVES(jSYM)
      JSUP = KTUV(iT,iV,iX)-nTUVES(jSYM)
      if (JSUP <= ISUP) then
        ISADR = iTri(ISUP,JSUP)
        BA(ISADR) = BA(ISADR)+F3VAL
      end if
    end if
    !  - F(vxyztu) -> BA(zxv,ytu)
    jSYM = Mul(IASYM(iZ),Mul(IASYM(iX),IASYM(iV)))
    if (jSYM == iSYM) then
      ISUP = KTUV(iZ,iX,iV)-nTUVES(jSYM)
      JSUP = KTUV(iY,iT,iU)-nTUVES(jSYM)
      if (JSUP <= ISUP) then
        ISADR = iTri(ISUP,JSUP)
        BA(ISADR) = BA(ISADR)+F3VAL
      end if
    end if
  end if
  if ((iT == iU) .and. (iV == iX) .and. (iY == iZ)) cycle
  if ((iT == iU) .and. (iV == iZ) .and. (iX == iY)) cycle
  if ((iX == iV) .and. (iT == iZ) .and. (iU == iY)) cycle
  if ((iZ == iY) .and. (iV == iU) .and. (iX == iT)) cycle
  !  - F(utxvzy) -> BA(vtu,xzy)
  jSYM = Mul(IASYM(iV),Mul(IASYM(iT),IASYM(iU)))
  if (jSYM == iSYM) then
    ISUP = KTUV(iV,iT,iU)-nTUVES(jSYM)
    JSUP = KTUV(iX,iZ,iY)-nTUVES(jSYM)
    if (JSUP <= ISUP) then
      ISADR = iTri(ISUP,JSUP)
      BA(ISADR) = BA(ISADR)+F3VAL
    end if
  end if
  if ((iTU == iVX) .and. (iVX == iYZ)) cycle
  if (.not. ((iTU == iVX) .or. (iTU == iYZ) .or. (iVX == iYZ))) then
    !  - F(xvutzy) -> BA(tvx,uzy)
    jSYM = Mul(IASYM(iT),Mul(IASYM(iV),IASYM(iX)))
    if (jSYM == iSYM) then
      ISUP = KTUV(iT,iV,iX)-nTUVES(jSYM)
      JSUP = KTUV(iU,iZ,iY)-nTUVES(jSYM)
      if (JSUP <= ISUP) then
        ISADR = iTri(ISUP,JSUP)
        BA(ISADR) = BA(ISADR)+F3VAL
      end if
    end if
    !  - F(zyxvut) -> BA(vyz,xut)
    jSYM = Mul(IASYM(iV),Mul(IASYM(iY),IASYM(iZ)))
    if (jSYM == iSYM) then
      ISUP = KTUV(iV,iY,iZ)-nTUVES(jSYM)
      JSUP = KTUV(iX,iU,iT)-nTUVES(jSYM)
      if (JSUP <= ISUP) then
        ISADR = iTri(ISUP,JSUP)
        BA(ISADR) = BA(ISADR)+F3VAL
      end if
    end if
    !  - F(utzyxv) -> BA(ytu,zxv)
    jSYM = Mul(IASYM(iY),Mul(IASYM(iT),IASYM(iU)))
    if (jSYM == iSYM) then
      ISUP = KTUV(iY,iT,iU)-nTUVES(jSYM)
      JSUP = KTUV(iZ,iX,iV)-nTUVES(jSYM)
      if (JSUP <= ISUP) then
        ISADR = iTri(ISUP,JSUP)
        BA(ISADR) = BA(ISADR)+F3VAL
      end if
    end if
  end if
  !  - F(zyutxv) -> BA(tyz,uxv)
  jSYM = Mul(IASYM(iT),Mul(IASYM(iY),IASYM(iZ)))
  if (jSYM == iSYM) then
    ISUP = KTUV(iT,iY,iZ)-nTUVES(jSYM)
    JSUP = KTUV(iU,iX,iV)-nTUVES(jSYM)
    if (JSUP <= ISUP) then
      ISADR = iTri(ISUP,JSUP)
      BA(ISADR) = BA(ISADR)+F3VAL
    end if
  end if
  !  - F(xvzyut) -> BA(yvx,zut)
  jSYM = Mul(IASYM(iY),Mul(IASYM(iV),IASYM(iX)))
  if (jSYM == iSYM) then
    ISUP = KTUV(iY,iV,iX)-nTUVES(jSYM)
    JSUP = KTUV(iZ,iU,iT)-nTUVES(jSYM)
    if (JSUP <= ISUP) then
      ISADR = iTri(ISUP,JSUP)
      BA(ISADR) = BA(ISADR)+F3VAL
    end if
  end if
end do

end subroutine MKBA_F3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! TODO(matthew-hennefarth): Remove iPrLoc from MC-PDFT module
module mcpdft_output

use Definitions, only: iwp, u6

implicit none
private

integer(kind=iwp) :: iPrGlb = 0, iPrLoc(7)

public :: iPrGlb, iPrLoc, set_print_level

contains

! Determines the global print level and local print levels
! Note, that it is impossible for iPrLoc to ever differ from
! iPrGlb, and therefore iPrLoc should just be removed from
! this module all together
subroutine set_print_level()

  use PrintLevel, only: DEBUG, SILENT, USUAL

  integer(kind=iwp) :: i
  integer(kind=iwp), external :: iPrintLevel
  logical(kind=iwp), external :: reduce_prt

  iPrGlb = iPrintLevel(-1)
  ! If inside an optimization loop, set down the print level
  ! unless we *really* want a lot of output
  if (reduce_prt()) iPrGlb = max(iPrGlb-USUAL,SILENT)

  iPrLoc(:) = iPrGlb

  if (iPrGlb >= DEBUG) then
    write(u6,*) ' set_print_level: Print levels have been set to'
    write(u6,*) '  Global print level iPrGlb=',iPrGlb
    write(u6,*) '  Individual sections print levels, iPrLoc:'
    write(u6,'(1x,7I5)') (iPrLoc(i),i=1,7)
  end if

end subroutine set_print_level

end module mcpdft_output

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Init_PPList()
      use TList_Mod
      Use Para_Info, only: MyRank, nProcs, Is_Real_Par
      Implicit Real*8 (a-h,o-z)
      Logical:: Debug=.False.
      Integer, Pointer:: TskList(:,:)
*
      If (Debug) Then
         If (PP_Status) Then
            Write (6,*) 'Init_PPList: Active'
         Else
            Write (6,*) 'Init_PPList: InActive'
         End If
      End If

      If (PP_Status) Return
      PP_Status=.True.
*
      iTskCan=0
      mTasks=0
      iStrt_TList=0
      iEnd_TList=nTasks+1
      If (.Not. Is_Real_Par() .OR. nProcs.eq.1) Return

      TskList(1:nTasks,1:2) => TskL(1:2*nTasks)
*     call izero(TskL(1:nTasks),nTasks)
      TskList(:,1)=0
      Do iTsk = 0, nTasks-1
*       TskL(1+iTsk)=MOD(iTsk+MyRank,nTasks)+1
        TskList(1+iTsk,1)=MOD(iTsk+MyRank,nTasks)+1
      End Do
c     Write (*,*) (TskL(iTsk),iTsk = 1, nTasks)
*
*---- Copy list in inverse order to ensure the proper order if
*     reinitiated at once.
*
      iE = nTasks-1
*     call izero(TskL(1+nTasks:2*nTasks),nTasks)
      TskList(:,2)=0
      Do i = 0, nTasks-1
*        TskL(1+nTasks+iE) = TskL(i+1)
         TskList(1+iE,2) = TskList(i+1,1)
         iE = iE - 1
      End Do
      TskList => Null()
*
      QLast(1)=Not_Used
      QLast(2)=Not_Used
*
      Return
      End
      Subroutine ReInit_PPList(Semi_Direct)
      Use Para_Info, only: MyRank, nProcs
      use TList_Mod
      Implicit Real*8 (a-h,o-z)
      Logical Semi_Direct
      Logical:: Debug=.False.
      Integer, Pointer:: TskList(:,:)
*
      If (Debug) Then
         If (PP_Status) Then
            Write (6,*) 'ReInit_PPList: Active'
         Else
            Write (6,*) 'ReInit_PPList: InActive'
         End If
      End If
      If (.NOT.PP_Status) Then
         Write (6,*) 'ReInit_PPList: List is not active!'
         Call Abend()
      End If
      iTskCan=0
      mTasks=iStrt_TList
      If (nProcs.eq.1) Then
         iStrt_TList=0
         iEnd_TList=nTasks+1
         Return
      End If
*
      If (Semi_Direct) Then
         TskList(1:nTasks,1:2) => TskL(1:2*nTasks)
*
*---- Copy first the task indices of tasks that were exectuted
*        Call ICopy(mTasks,TskL(1+nTasks:2*nTasks),1,TskL(1:mTasks),1)
         Call ICopy(mTasks,TskList(:,2),1,TskList(:,1),1)
c     Write (*,*) 'mTasks=',mTasks
*
*---- Now copy task indices of tasks which were not executed by this node.
*     Change the order so that the first task it the largest in the list.
*
         iE = mTasks
         iCount = 1
         Do i = mTasks, nTasks-1
            If (iCount .gt. myRank) Then
*              TskL(1+i) = TskL(i+1+nTasks)
               TskList(1+i,1) = TskList(i+1,2)
            Else
*              TskL(1+i) = TskL(iE+1+nTasks)
               TskList(1+i,1) = TskList(iE+1,2)
               iE = iE - 1
               iCount = iCount + 1
            Endif
         Enddo

c        Write (*,*) (TskL(iTsk),iTsk = 1, nTasks)
c        Write (*,*) 'mTasks=',mTasks
*
         TskList => Null()
      End If
*
      iStrt_TList=0
      iEnd_TList=nTasks+1
*
      QLast(1)=Not_Used
      QLast(2)=Not_Used
*
      Return
      End
*
      Subroutine Free_PPList()
      use TList_Mod
      Use Para_Info, only: nProcs, Is_Real_Par
#include "stdalloc.fh"
*
      If (.NOT.Allocated(TskL)) Return
      PP_Status=.False.
*
      If (.Not. Is_Real_Par() .OR. nProcs.eq.1) Return
      Call mma_deallocate(TskL)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine party2_cvb(iperm,n,party)
      implicit real*8(a-h,o-z)
      dimension iperm(n)

c  Following caters for non-contiguous integers :
      ntransp=0
100   continue
      do 200 i=1,n-1
      if(iperm(i).gt.iperm(i+1))then
        ntransp=ntransp+1
        iswp=iperm(i)
        iperm(i)=iperm(i+1)
        iperm(i+1)=iswp
        do 300 j=i-1,1,-1
        if(iperm(j).gt.iperm(j+1))then
          ntransp=ntransp+1
          iswp=iperm(j)
          iperm(j)=iperm(j+1)
          iperm(j+1)=iswp
        endif
300     continue
        goto 100
      endif
200   continue
      if(mod(ntransp-n,2).eq.0)then
        party=1d0
      else
        party=-1d0
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ICPMT2(     AIN,    AOUT,    NINR,    NINC,   NOUTR,
     &                     NOUTC,   IZERO)
*
* Copy INTEGER matrix AIN to AOUT . Dimensions can differ
*
* If IZERO .ne. 0 , AOUT is zeroed  first
      IMPLICIT REAL*8           (A-H,O-Z)
*. Input
      INTEGER AIN(NINR,NINC)
*. Output
      INTEGER AOUT(NOUTR,NOUTC)
*
      IF(IZERO.NE.0) CALL ISETVC(AOUT,0,NOUTR*NOUTC)
      DO 100 J = 1, NINC
       CALL ICOPVE(AIN(1,J),AOUT(1,J),NINR)
  100 CONTINUE
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine ao2mo_cvb(orbsao,orbs,norb1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
#include "mo_cvb.fh"
      dimension orbsao(nbas_mo,norb1),orbs(norb,norb1)

      if(norb1.eq.0)return
      i1=mstackr_cvb(nbas_mo*norb)
      call getmo_cvb(w(i1),3,0)
      call mxattb_cvb(w(i1),orbsao,norb,nbas_mo,norb1,orbs)
      call mfreer_cvb(i1)
      return
      end
      subroutine mo2ao_cvb(orbs,orbsao,norb1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
#include "mo_cvb.fh"
      dimension orbsao(nbas_mo,norb1),orbs(norb,norb1)
      if(norb1.eq.0)return
      i1=mstackr_cvb(nbas_mo*norb)
      call getmo_cvb(w(i1),2,0)
      call mxatb_cvb(w(i1),orbs,nbas_mo,norb,norb1,orbsao)
      call mfreer_cvb(i1)
      return
      end
      subroutine lmo2ao_cvb(orbs,orbsao,norb1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
#include "mo_cvb.fh"
      dimension orbsao(nbas_mo,norb1),orbs(norb,norb1)
      if(norb1.eq.0)return
      i1=mstackr_cvb(nbas_mo*norb)
      call getmo_cvb(w(i1),2,1)
      call mxatb_cvb(w(i1),orbs,nbas_mo,norb,norb1,orbsao)
      call mfreer_cvb(i1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION CHO_IDOT(N,IVEC1,INC1,IVEC2,INC2)
      IMPLICIT NONE
      INTEGER N, INC1, INC2
      INTEGER IVEC1(*), IVEC2(*)

      INTEGER I, ISUM, I1, I2

      CHO_IDOT = 0
      IF (N.LT.1) RETURN
      ISUM = 0
      IF (INC1.EQ.1 .AND. INC2.EQ.1) THEN
         DO I = 1,N
            ISUM = ISUM + IVEC1(I)*IVEC2(I)
         END DO
      ELSE
         I1 = 1
         I2 = 1
         IF (INC1 .LT. 0) I1 = (-N+1)*INC1 + 1
         IF (INC2 .LT. 0) I2 = (-N+1)*INC2 + 1
         DO I = 1,N
            ISUM = ISUM + IVEC1(I1)*IVEC2(I2)
            I1 = I1 + INC1
            I2 = I2 + INC2
         END DO
      END IF
      CHO_IDOT = ISUM

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine FNO_MP2(irc,nSym,nBas,nFro,nIsh,nSsh,nDel,CMOI,EOcc,EVir,vfrac,DoMP2,EMP2)
! Purpose:  setup of Frozen Natural Orbitals MP2 (FNO-MP2).
!
! Author:   F. Aquilante  (Geneva, Nov  2008)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nFro(nSym), nIsh(nSym)
integer(kind=iwp), intent(inout) :: nSsh(nSym), nDel(nSym)
real(kind=wp), intent(inout) :: CMOI(*), EVir(*)
real(kind=wp), intent(in) :: EOcc(*), vfrac
logical(kind=iwp), intent(in) :: DoMP2
real(kind=wp), intent(out) :: EMP2
integer(kind=iwp) :: i, ifr, ii, ioff, iSkip, iSym, ito, j, jD, jOcc, jOff, jp, jVir, k, kfr, kij, kOff, kto, lij, lnDel(8), &
                     lnFro(8), lnOcc(8), lnOrb(8), lnVir(8), lOff, nAuxO(8), nBasT, nBmx, nBx, NCMO, nOA, nOrb, ns_V(8), nSQ, &
                     nSsh_t, nSx, ntri, nVV
real(kind=wp) :: Dummy, STrDF, STrDP, tmp, TrDF(8), TrDP(8)
integer(kind=iwp), allocatable :: iD(:)
real(kind=wp), allocatable :: CMO(:,:), OrbE(:,:), X(:)
real(kind=wp), external :: ddot_
#include "Molcas.fh"
#include "chfnopt.fh"

irc = 0
MP2_small = .false.

!----------------------------------------------------------------------*
!     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
!----------------------------------------------------------------------*

nBasT = 0
ntri = 0
nSQ = 0
nBmx = 0
nOrb = 0
nVV = 0
do i=1,nSym
  ns_V(i) = 0
  nBasT = nBasT+nBas(i)
  nOrb = nOrb+nFro(i)+nIsh(i)+nSsh(i)+nDel(i)
  ntri = ntri+nBas(i)*(nBas(i)+1)/2
  nSQ = nSQ+nBas(i)**2
  nVV = nVV+nSsh(i)**2
  nBmx = max(nBmx,nBas(i))
end do
if (nBasT > mxBas) then
  write(u6,'(/6X,A)') 'The number of basis functions exceeds the present limit'
  call Abend()
end if

NCMO = nSQ
call mma_allocate(CMO,NCMO,2,label='LCMO')
CMO(:,1) = CMOI(1:NCMO)

nOA = 0
do iSym=1,nSym  ! setup info
  lnFro(iSym) = nFro(iSym)
  lnOcc(iSym) = nIsh(iSym)
  nOA = nOA+lnOcc(iSym)
  lnVir(iSym) = nSsh(iSym)
  lnOrb(iSym) = lnOcc(iSym)+lnVir(iSym)
  lnDel(iSym) = nDel(iSym)
end do

call mma_allocate(OrbE,nOrb,4,label='Eorb')
jOff = 1
kOff = 1
lOff = 1
do iSym=1,nSym
  jp = lOff+nFro(iSym)
  jOcc = jOff
  call dcopy_(nIsh(iSym),EOcc(jOcc),1,OrbE(jp,1),1)
  jVir = kOff
  jp = jp+nIsh(iSym)
  call dcopy_(nSsh(iSym),EVir(jVir),1,OrbE(jp,1),1)
  jOff = jOff+nIsh(iSym)
  kOff = kOff+nSsh(iSym)
  lOff = lOff+nBas(iSym)
end do
iOff = 1
jOff = 1
kOff = 1
do iSym=1,nSym
  ifr = iOff+nFro(iSym)
  ito = jOff
  call dcopy_(nIsh(iSym),OrbE(ifr,1),1,OrbE(ito,3),1)
  ifr = iOff+nFro(iSym)+nIsh(iSym)
  ito = kOff
  call dcopy_(nSsh(iSym),OrbE(ifr,1),1,OrbE(ito,4),1)
  iOff = iOff+nBas(iSym)
  jOff = jOff+nIsh(iSym)
  kOff = kOff+nSsh(iSym)
end do
call mma_allocate(X,nVV+nOA,label='Dmat')
X(:) = Zero

call FnoMP2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,X(1:nVV),X(nVV+1:))
CMO(:,2) = Zero
iOff = 1
do iSym=1,nSym
  kfr = iOff+nBas(iSym)*nFro(iSym)
  kto = iOff+nBas(iSym)*lnFro(iSym)
  call dcopy_(nBas(iSym)*lnOcc(iSym),CMO(kfr,1),1,CMO(kto,2),1)
  kfr = iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
  kto = kto+nBas(iSym)*lnOcc(iSym)
  call dcopy_(nBas(iSym)*lnVir(iSym),CMO(kfr,1),1,CMO(kto,2),1)
  iOff = iOff+nBas(iSym)**2
end do
call Check_Amp2(nSym,lnOcc,lnVir,iSkip)
if (iSkip > 0) then
  call ChoMP2_Drv(irc,Dummy,CMO(:,2),OrbE(:,3),OrbE(:,4))
  if (irc /= 0) then
    write(u6,*) 'MP2 pseudodensity calculation failed !'
    call Abend()
  end if
else
  write(u6,*)
  write(u6,*) 'There are ZERO amplitudes T(ai,bj) with the given '
  write(u6,*) 'combinations of inactive and virtual orbitals !! '
  write(u6,*) 'Check your input and rerun the calculation! Bye!!'
  call Abend()
end if

! Diagonalize the pseudodensity to get natural virtual orbitals
! -------------------------------------------------------------
iOff = 1
jOff = 1
do iSym=1,nSym
  if (nSsh(iSym) > 0) then
    jD = iOff
    ! Eigenvectors will be in increasing order of eigenvalues
    call Eigen_Molcas(nSsh(iSym),X(jD),OrbE(:,2),OrbE(:,1))
    ! Reorder to get relevant eigenpairs first
    do j=1,nSsh(iSym)/2
      do i=1,nSsh(iSym)
        lij = jD-1+nSsh(iSym)*(j-1)+i
        kij = jD-1+nSsh(iSym)**2-(nSsh(iSym)*j-i)
        tmp = X(lij)
        X(lij) = X(kij)
        X(kij) = tmp
      end do
      tmp = OrbE(j,2)
      OrbE(j,2) = OrbE(nSsh(iSym)-j+1,2)
      OrbE(nSsh(iSym)-j+1,2) = tmp
    end do

    ! Compute new MO coeff. : X=C*U
    kfr = jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
    kto = jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
    call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym),One,CMO(kfr,2),nBas(iSym),X(jD),nSsh(iSym),Zero,CMO(kto,1),nBas(iSym))
    iOff = iOff+nSsh(iSym)**2
    TrDF(iSym) = ddot_(nSsh(iSym),OrbE(:,2),1,[One],0)
    ns_V(iSym) = int(vfrac*nSsh(iSym))
    TrDP(iSym) = ddot_(ns_V(iSym),OrbE(:,2),1,[One],0)
  end if
  jOff = jOff+nBas(iSym)**2
end do
write(u6,*) '------------------------------------------------------'
write(u6,*) '   Symm.     Trace     (Full Dmat)     (Partial Dmat) '
write(u6,*) '------------------------------------------------------'
STrDF = Zero
STrDP = Zero
do iSym=1,nSym
  write(u6,'(4X,I4,14X,G13.6,5X,G13.6)') iSym,TrDF(iSym),TrDP(iSym)
  STrDF = STrDF+TrDF(iSym)
  STrDP = STrDP+TrDP(iSym)
end do
write(u6,*) '------------------------------------------------------'
write(u6,'(A,G13.6,5X,G13.6)') '   Sum :              ',STrDF,STrDP
write(u6,*) '------------------------------------------------------'

! Update the nSsh, nDel for FNO-MP2
nSsh_t = 0
do iSym=1,nSym
  lnOrb(iSym) = lnOrb(iSym)-nSsh(iSym)+ns_V(iSym)
  nDel(iSym) = nDel(iSym)+nSsh(iSym)-ns_V(iSym)
  nSsh(iSym) = ns_V(iSym)
  nSsh_t = nSsh_t+nSsh(iSym)
  nAuxO(iSym) = nBas(iSym)-nDel(iSym)
end do
call Put_iArray('nDelPT',nDel,nSym)
call Put_iArray('nOrb',nAuxO,nSym)

! Reset MP2_small for this new call to ChoMP2_Drv
call Check_Amp2(nSym,lnOcc,nSsh,iSkip)
MP2_small = iSkip > 0
if (MP2_small) then

  call FnoMP2_putInf(nSym,lnOrb,lnOcc,lnFro,nDel,nSsh,X(1:nVV),X(nVV+1:))

  call mma_allocate(iD,nOrb,label='iD_orb')
  do k=1,nOrb
    iD(k) = k
  end do
  lOff = 1
  kOff = 1
  jOff = 1
  iOff = 1
  do iSym=1,nSym  ! canonical orb. in the reduced virtual space
    jD = iOff
    call Get_Can_Lorb(OrbE(lOff,4),OrbE(jOff,1),nSsh(iSym),lnVir(iSym),iD,X(jD))

    kfr = kOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
    kto = kOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
    nBx = max(1,nBas(iSym))
    nSx = max(1,nSsh(iSym))
    call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym),One,CMO(kfr,1),nBx,X(jD),nSx,Zero,CMOI(kto),nBx)

    lOff = lOff+lnVir(iSym)
    kOff = kOff+nBas(iSym)**2
    jOff = jOff+nSsh(iSym)
    iOff = iOff+lnVir(iSym)**2
  end do
  call mma_deallocate(iD)

  ! Copy the new Evir to output array
  call dcopy_(nSsh_t,OrbE(:,1),1,EVir,1)

  write(u6,*)
  write(u6,'(A,8I4)') ' Secondary orbitals after selection:',(nSsh(i),i=1,nSym)
  write(u6,'(A,8I4)') ' Deleted orbitals after selection:  ',(nDel(i),i=1,nSym)
  write(u6,*)
  write(u6,*) 'Energies of the active virtual orbitals '
  ii = 0
  do iSym=1,nSym
    if (nSsh(iSym) /= 0) then
      write(u6,*)
      write(u6,'(A,I2,(T40,5F14.6))') ' symmetry species',iSym,(EVir(ii+k),k=1,nSsh(iSym))
      ii = ii+nSsh(iSym)
    end if
  end do
  write(u6,*)

  EMP2 = DeMP2
  DeMP2 = Zero
  if (DoMP2) call ChoMP2_Drv(irc,Dummy,CMOI,OrbE(:,3),OrbE(:,1))
  if (irc /= 0) then
    write(u6,*) 'MP2 in truncated virtual space failed !'
    call Abend()
  end if
  EMP2 = -One*(EMP2-DeMP2)
  if (DoMP2) then
    DeMP2 = EMP2
    !write(u6,*)
    !write(u6,'(1x,a,f18.10,a)')'FNO correction:       ',EMP2,'   (estimate)   '
    !write(u6,*)
  else
    EMP2 = Zero
  end if
else
  write(u6,*)
  write(u6,*) 'We found ZERO amplitudes T(ai,bj) with the final '
  write(u6,*) 'combinations of inactive and virtual orbitals !! '
  write(u6,*) 'Check your input and rerun the calculation! Bye!!'
  call Abend()
end if

! Update runfile for subsequent calcs (e.g., CHCC)
iOff = 1
jOff = 1
kOff = 1
do iSym=1,nSym
  ifr = iOff
  ito = kOff+nFro(iSym)
  call dcopy_(nIsh(iSym),EOcc(ifr),1,OrbE(ito,1),1)
  ifr = jOff
  ito = ito+nIsh(iSym)
  call dcopy_(nSsh(iSym),EVir(ifr),1,OrbE(ito,1),1)
  iOff = iOff+nIsh(iSym)
  jOff = jOff+nSsh(iSym)
  kOff = kOff+nBas(iSym)
end do
call Put_dArray('OrbE',OrbE(:,1),nOrb)
call Put_dArray('Last orbitals',CMOI,NCMO)

call mma_deallocate(X)
call mma_deallocate(OrbE)

call mma_deallocate(CMO)

return

end subroutine FNO_MP2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine caspt2_grad_invaria1(DPT2)
!
! Put zero to wrong (incomplete) density matrix elements
!
  use Constants, only: Zero
  use definitions, only: iwp,wp
  use caspt2_module, only: nSym, nIsh, nAsh, nSsh, nOrb

  implicit none

  real(kind=wp), intent(inout) :: DPT2(*)
  integer(kind=iwp) :: IOFDIJ(8), IOFDAB(8)

  integer(kind=iwp) :: idij, is, ni, na, ns, no, idtu, idab, isym, ii, ij, ia, ib

  IDIJ = 0
  DO IS = 1,NSYM
    NI = NISH(IS)
    NA = NASH(IS)
    NO = NORB(IS)
    IDTU = IDIJ+NO*NI+NI
    IDAB = IDTU+NO*NA+NA
    IOFDIJ(IS) = IDIJ
    IOFDAB(IS) = IDAB
    IDIJ = IDIJ+NO*NO
  END DO

  do isym = 1, nsym
    NI = NISH(ISYM)
    NS = NSSH(ISYM)
    NO = NORB(ISYM)
    do ii = 1, ni
      do ij = 1, ni
        if (ii == ij) cycle
        IDIJ = IOFDIJ(ISYM)+II+NO*(IJ-1)
        DPT2(IDIJ) = Zero
      end do
    end do
    do ia = 1, ns
      do ib = 1, ns
        if (ia == ib) cycle
        IDAB = IOFDAB(ISYM)+IA+NO*(IB-1)
        DPT2(IDAB) = Zero
      end do
    end do
  end do

end subroutine caspt2_grad_invaria1
!
!-----------------------------------------------------------------------
!
subroutine caspt2_grad_invaria2(DPT2,OLag)
!
! Compute pseudo-density in the inactive and secondary orbital blocks
! for MRPT2 methods that are not invariant with respect to orbital
! rotations among inactive and secondary orbitals using the canonical
! condition of MOs
!
  use Constants, only: Half
  use definitions, only: iwp,wp
  use caspt2_module, only: nSym, nDel, nIsh, EPSI, nSsh, nAsh, EPSE, nBas, nFro

  implicit none

  real(kind=wp), intent(inout) :: DPT2(*)
  real(kind=wp), intent(in)    :: OLag(*)

  integer(kind=iwp) :: iMO, iSym, nOrbI, nFroI, nIshI, nAshI, nSshI, iOrb, jOrb
  real(kind=wp) :: Tmp

  iMO  = 1
  DO iSym = 1, nSym
    nOrbI = nBas(iSym)-nDel(iSym)
    nFroI = nFro(iSym)
    nIshI = nIsh(iSym)
    If (nOrbI > 0 .and. nIshI > 0) Then
      Do iOrb = nFroI+1, nFroI+nIshI
        Do jOrb = iOrb+1, nFroI+nIshI
          Tmp = -Half*(OLag(iMO+iOrb-1+nOrbI*(jOrb-1))  &
                      -OLag(iMO+jOrb-1+nOrbI*(iOrb-1))) &
              /(EPSI(iOrb-nFroI)-EPSI(jOrb-nFroI))
!           write (*,*) epsi(iorb-nfroi),epsi(jorb-nfroi)
          DPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) = Tmp
          DPT2(iMO+jOrb-1+nOrbI*(iOrb-1)) = Tmp
        End Do
      End Do
    End If
    nSshI = nSsh(iSym)
    nAshI = nAsh(iSym)
    If (nOrbI > 0 .and. nSshI > 0) Then
      Do iOrb = nOrbI-nSshI+1, nOrbI
        Do jOrb = iOrb+1, nOrbI
          Tmp = -Half*(OLag(iMO+iOrb-1+nOrbI*(jOrb-1))  &
                      -OLag(iMO+jOrb-1+nOrbI*(iOrb-1))) &
              /(EPSE(iOrb-nFroI-nIshI-nAshI)-EPSE(jOrb-nFroI-nIshI-nAshI))
          DPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) = Tmp
          DPT2(iMO+jOrb-1+nOrbI*(iOrb-1)) = Tmp
        End Do
      End Do
    End If
    iMO  = iMO  + nOrbI*nOrbI
  End Do

end subroutine caspt2_grad_invaria2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
*               1993, Per-Olof Widmark                                 *
************************************************************************
      Subroutine GetOrd(rc,Square,nSym,nBas,nSkip)
************************************************************************
*                                                                      *
*    Purpose: Read the table of content from the OrdInt file           *
*                                                                      *
*    Calling parameters:                                               *
*    nSym   : contains on return the number of irred. rep.             *
*    nBas   : contains on return the number of basis functions per     *
*             irred. rep.                                              *
*    nSkip  : contains on return the skipping flag per irred. rep.     *
*    rc     : return code                                              *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    TwoDat : table of contents and auxiliary information              *
*    TowRc  : Table of return code                                     *
*    PkCtl  : packing table                                            *
*    TowID  : Table of file identifiers                                *
*                                                                      *
*    Local data declarations: none                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.O. Widmark                                 *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
#include "TwoDat.fh"
#include "PkCtl.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "Molcas.fh"
#include "warnings.h"
*
      Dimension nBas(0:7),nSkip(0:7)
*
      Logical DoCholesky
      Logical Square
      Character TheName*16
      Data TheName/'GetOrd'/
*----------------------------------------------------------------------*
*     Start the procedure                                              *
*----------------------------------------------------------------------*
      rc=rc0000

*----------------------------------------------------------------------*
*     Cholesky cheating: set output variables regardless of OrdInt file*
*     Note that all elements of nSkip are zero (no skipping)           *
*     Square is set false (arbitrarily)                                *
*     Skip data relating to this file (Toc etc.) entirely....          *
*----------------------------------------------------------------------*
      Call decideoncholesky(DoCholesky)
      If (DoCholesky) Then
         Call Get_iScalar('nSym',nSym)
         Call Get_iArray('nBas',nBas,nSym)
         Do iSym = 0,7
            nSkip(iSym) = 0
         End Do
         Square = .false.
         Return
      End If
*----------------------------------------------------------------------*
*     Pick up the file definitions                                     *
*----------------------------------------------------------------------*
      Open=AuxTwo(isStat)
*----------------------------------------------------------------------*
*     Check the file status                                            *
*----------------------------------------------------------------------*
      If ( Open.ne.1 ) Then
        rc=rcTC01
            Call SysAbendMsg(TheName,
     * 'The ORDINT file has not been opened',' ')
      End If
*---------------------------------------------------------------------*
*     Check the ordering parameter                                    *
*---------------------------------------------------------------------*
      If ( TocTwo(isOrd).lt.0 .or. TocTwo(isOrd).gt.1 ) then
        rc=rcTC02
            Call SysWarnMsg(TheName,
     * 'The file carries an invalid ordering parameter',' ')
       Call SysValueMsg ('TocTwo(isOrd)', TocTwo(isOrd))

      End If
      Square=TocTwo(isOrd).eq.1
*---------------------------------------------------------------------*
*     Check the number of symmetry operations                         *
*---------------------------------------------------------------------*
      nSym=TocTwo(isSym)
      If ( nSym.ne.1 .and. nSym.ne.2 .and.
     &     nSym.ne.4 .and. nSym.ne.8 ) then
        rc=rcTC03
            Call SysWarnMsg(TheName,
     * 'The file carries an invalid number '//
     * 'of irreducible representations',' ')
       Call SysValueMsg ('nSym', nSym)

      End If
      nPairs=nSym*(nSym+1)/2
      iBatch=0
      Do iSym=1,nSym
        Do jSym=1,iSym
          Do kSym=1,nSym
            Do lSym=1,kSym
              If ( ieor(iSym-1,jSym-1).eq.ieor(kSym-1,lSym-1) ) then
                ijPair=jSym+iSym*(iSym-1)/2
                klPair=lSym+kSym*(kSym-1)/2
                iSyBlk=(ijPair-1)*nPairs+klPair
                iBatch=iBatch+1
                nBatch(iSyBlk)=iBatch
              End If
            End Do
          End Do
        End Do
      End Do
*---------------------------------------------------------------------*
*     Check number of basis function                                  *
*---------------------------------------------------------------------*
      ntBas=0
      Do iSym=0,(nSym-1)
         nBas(iSym)=TocTwo(isBas+iSym)
         ntBas=ntBas+nBas(iSym)
         If ( nBas(iSym).lt.0) then
            Call SysWarnMsg(TheName,
     *                      'Invalid number of basis functions',' ')
            Call SysValueWarnMsg ('iSym', iSym)
            Call SysCondMsg('nBas(iSym).ge.0',nBas(iSym),'<',0)
         End If
*
         if( nBas(iSym).gt.mxBas ) then
            Call SysWarnMsg(TheName,
     *                      'Invalid number of basis functions',' ')
            Call SysValueWarnMsg ('iSym', iSym)
         Call SysCondMsg('nBas(iSym).lt.mxBas',nBas(iSym),'>',mxBas)
        End If
      End Do
      If ( ntBas.le.0) then
            Call SysWarnMsg(TheName,
     * 'Invalid number of basis functions',' ')
       Call SysCondMsg('ntBas.gt.0',ntBas,'<=',0)
      End If
      If ( ntBas.gt.mxOrb ) then
            Call SysWarnMsg(TheName,
     * 'Invalid number of basis functions',' ')
       Call SysCondMsg('ntBas.lt.mxOrb',ntBas,'>',mxOrb)
      End If
*---------------------------------------------------------------------*
*     Check the skip parameters                                       *
*---------------------------------------------------------------------*
      Do iSym=0,(nSym-1)
        nSkip(iSym)=TocTwo(isSkip+iSym)
        If ( nSkip(iSym).lt.0  ) then
            Call SysAbendMsg(TheName,
     * 'The table of skiping parameters is spoiled',' ')
        End If
      End Do
*---------------------------------------------------------------------*
*     Check table of disk adresses                                    *
*---------------------------------------------------------------------*
      mxDAdr=TocTwo(isMxDa)
      If ( mxDAdr.lt.0 ) then
            Call SysWarnMsg(TheName,
     * 'The file carries an invalid disk address',' ')
       Call SysCondMsg('mxDAdr.ge.0',mxDAdr,'<',0)

      End If
      Do iTab=0,175
        If ( TocTwo(isDAdr+iTab).lt.0 .or.
     &       TocTwo(isDAdr+iTab).gt. mxDAdr ) then
            Call SysWarnMsg(TheName,
     * 'The table of disk adresses is spoiled',' ')
       Call SysValueWarnMsg ('iTab', iTab)
       Call SysCondMsg('TocTwo(isDAdr+iTab).lt.mxDAdr',
     *   TocTwo(isDAdr+iTab),'>',mxDAdr)

        End If
      End Do
*---------------------------------------------------------------------*
*     Generate and check packing table                                *
*---------------------------------------------------------------------*
      Call Int2Real(TocTwo(isPkTh),PkThrs)
      Call Int2Real(TocTwo(isPkCt),PkCutof)
      If ( PkThrs.lt.0 ) then
            Call SysAbendMsg(TheName,
     * 'The accuracy threshold for unpacking is spoiled',' ')
      End If
      Call Int2Real(TocTwo(isPkSc),PkScal)
      If ( PkScal.ne.1.0D0 .and. PkScal.ne.2.0D0 .and.
     &     PkScal.ne.4.0D0 .and. PkScal.ne.8.0D0 ) then
            Call SysAbendMsg(TheName,
     * 'The scaling constant for unpacking is spoiled',' ')
      End If
      iPack=TocTwo(isPkPa)
      If ( iPack.lt.0 .or. iPack.gt.1 ) then
            Call SysWarnMsg(TheName,
     * 'The packing flag is spoiled',' ')
       Call SysValueMsg ('iPack', iPack)
      End If
      If( TocTwo(isPkPa).eq.0 ) Pack=.true.
      If( TocTwo(isPkPa).eq.1 ) Pack=.false.
      iAssm=TocTwo(isPkAs)
      If ( iAssm.lt.0 .or. iAssm.gt.1 ) then
            Call SysWarnMsg(TheName,
     * 'The assembler flag is spoiled',' ')
       Call SysValueMsg ('iAssm', iAssm)
      End If
      If( TocTwo(isPkAs).eq.0 ) Assm=.true.
      If( TocTwo(isPkAs).eq.1 ) Assm=.false.
      Do iExp=0,4095
        PkTab(iExp)=TocTwo(isPkTb+iExp)
        If ( PkTab(iExp).lt.1 ) then
            Call SysWarnMsg(TheName,
     * 'The packing table is spoiled',' ')
       Call SysValueWarnMsg ('iExp', iExp)
       Call SysCondMsg('PkTab(iExp).gt.0 ',
     *   PkTab(iExp),'<',1)
        End If
      End Do
*---------------------------------------------------------------------*
*     exit                                                            *
*---------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Ignacio Fdez. Galvan                             *
************************************************************************
*  Sp_Pack
*
*> @ingroup Sparse
*> @brief
*>   Store a matrix in sparse format
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> An input matrix \p A will be stored in a sparse format, as two vectors \p Sp and \p ij_Sp.
*> Only elements with an absolute value larger than \p Thr will be kept.
*> An error is raised if the number of stored elements is larger than \p nmax.
*> The sizes of \p Sp and \p ij_Sp must be at least \f$ n + k + 1 \f$, where \f$ k \f$ is the number of
*> non_zero off-diagonal elements of \p A.
*>
*> @param[in]  n     Size of the matrix
*> @param[in]  A     Input matrix, in dense (conventional) format
*> @param[in]  nmax  Maximum size of the stored vectors
*> @param[out] Sp    Output matrix in sparse format
*> @param[out] ij_Sp Index vector for the sparse output matrix
*> @param[in]  Sym   Flag specifying whether to use the symmetric format
*> @param[in]  Thr   Threshold to discard small elements
************************************************************************
      SUBROUTINE Sp_Pack(n,A,nmax,Sp,ij_Sp,Sym,Thr)
      IMPLICIT NONE
      INTEGER n, nmax, ij_Sp(*), i, j, nij
      REAL*8 A(n,n), Sp(*), Thr
      LOGICAL Sym
#include "real.fh"

      ij_Sp(1)=n+2
      nij=n+1
      IF (Sym) THEN
        DO i=1,n
          Sp(i)=A(i,i)
          DO j=1,i-1
            IF (ABS(A(i,j)).LE.Thr) THEN
              nij=nij+1
              IF (nij.GT.nmax) THEN
                CALL SysAbendMsg('Sp_Pack',
     &          'Too many non-zero elements.','')
              END IF
              Sp(nij)=A(i,j)
              ij_Sp(nij)=j
            END IF
          END DO
          ij_Sp(i+1)=nij+1
        END DO
        Sp(n+1)=One
      ELSE
        DO i=1,n
          Sp(i)=A(i,i)
          DO j=1,n
            IF ((j.NE.i).AND.(ABS(A(i,j)).LE.Thr)) THEN
              nij=nij+1
              IF (nij.GT.nmax) THEN
                CALL SysAbendMsg('Sp_Pack',
     &          'Too many non-zero elements.','')
              END IF
              Sp(nij)=A(i,j)
              ij_Sp(nij)=j
            END IF
          END DO
          ij_Sp(i+1)=nij+1
        END DO
        Sp(n+1)=Zero
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine DMSMem( &
#                 define _CALLING_
#                 include "mem_interface.fh"
                 )

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: MemDer, MmEFP, nOrder

Mem = 0
nHer = 0
call EFMmP(nOrder,MmEFP,la,lb+1,lr-1)
Mem = max(Mem,MmEFP)
nHer = max(nHer,nOrder)
call EFMmP(nOrder,MmEFP,la,lb,lr-1)
Mem = max(Mem,MmEFP)
nHer = max(nHer,nOrder)

! Add a scratch area for intermediate integrals

MemDer = 3*(nTri_Elem1(la)*nTri_Elem1(lb+1)+nTri_Elem1(la)*nTri_Elem1(lb))
Mem = Mem+MemDer
Mem = Mem+nTri_Elem1(la)*nTri_Elem1(lb)*9

return

end subroutine DMSMem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE DENSCT_CPF(H,LIC0)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION H(LIC0)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      CALL DENSCT_INTERNAL(H)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE DENSCT_INTERNAL(H)
      USE ISO_C_BINDING
      REAL*8, TARGET :: H(*)
      INTEGER, POINTER :: iH1(:),iH2(:),iH3(:),iH34(:)
C
      CALL C_F_POINTER(C_LOC(H(LW(1))),iH1,[1])
      CALL DENS_CPF(H(LW(26)),H(LW(62)),iH1,A)
      NULLIFY(iH1)
C
C     MULTIPLY C BY MP
C
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(34))),iH34,[1])
      CALL NPSET(iH2,iH3,H(LW(26)),H(LW(30)),H(LW(31)),
     *H(LW(72)),H(LW(27)),H(LW(28)),H(LW(32)),iH34)
      NULLIFY(iH2,iH3,iH34)
*
      CALL ONECT(H)
      IF(A.GT.D1) THEN
        WRITE(6,*)'DENSCT_CPF Error: A>1.0D0 (See code.)'
      END IF
      CALL NATCT(H,LIC0)
*
      RETURN
      END SUBROUTINE DENSCT_INTERNAL
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Jeppe Olsen                                      *
!***********************************************************************

subroutine NSTRSO_MCLR(NEL,NORB1,NORB2,NORB3,NELMN1,NELMX1,NELMN3,NELMX3,IOC,NSTASO,NOCTYP,NSM,IOTYP)
! Number of strings per type and symmetry
!
! Jeppe Olsen Winter of 1990

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NEL, NORB1, NORB2, NORB3, NELMN1, NELMX1, NELMN3, NELMX3, NOCTYP, NSM, IOTYP
integer(kind=iwp), intent(out) :: IOC(NEL), NSTASO(NOCTYP,NSM)
integer(kind=iwp) :: i, IEL1, IEL2, IEL3, IFRST1, IFRST2, IFRST3, IORB1F, IORB1L, IORB2F, IORB2L, IORB3F, IORB3L, ISYM, ITYP, &
                     NONEW1, NONEW2, NONEW3, NSTRIN
integer(kind=iwp), external :: ISYMST_MCLR, IOCTP2_MCLR

NSTASO(:,:) = 0
NSTRIN = 0
IORB1F = 1
IORB1L = IORB1F+NORB1-1
IORB2F = IORB1L+1
IORB2L = IORB2F+NORB2-1
IORB3F = IORB2L+1
IORB3L = IORB3F+NORB3-1
! Loop over possible partitionings between RAS1,RAS2,RAS3
outer: do IEL1=NELMX1,NELMN1,-1
  inner: do IEL3=NELMN3,NELMX3,1
    if (IEL1 > NORB1) cycle outer
    if (IEL3 > NORB3) cycle inner
    IEL2 = NEL-IEL1-IEL3
    if ((IEL2 < 0) .or. (IEL2 > NORB2)) cycle inner
    IFRST1 = 1
    ! Loop over RAS 1 occupancies
    RAS1occ: do
      if (IEL1 /= 0) then
        if (IFRST1 == 1) then
          IOC(1:IEL1) = [(i,i=1,IEL1)]
          IFRST1 = 0
        else
          call NXTORD(IOC,IEL1,IORB1F,IORB1L,NONEW1)
          if (NONEW1 == 1) cycle inner
        end if
      end if
      IFRST2 = 1
      IFRST3 = 1
      ! Loop over RAS 2 occupancies
      RAS2occ: do
        if (IEL2 /= 0) then
          if (IFRST2 == 1) then
            IOC(IEL1+1:IEL1+IEL2) = [(i,i=IORB2F,IORB2F+IEL2-1)]
            IFRST2 = 0
          else
            call NXTORD(IOC(IEL1+1),IEL2,IORB2F,IORB2L,NONEW2)
            if (NONEW2 == 1) then
              if (IEL1 /= 0) cycle RAS1occ
              if (IEL1 == 0) cycle inner
            end if
          end if
        end if
        IFRST3 = 1
        ! Loop over RAS 3 occupancies
        RAS3occ: do
          if (IEL3 /= 0) then
            if (IFRST3 == 1) then
              IOC(IEL1+IEL2+1:IEL1+IEL2+IEL3) = [(i,i=IORB3F,IORB3F+IEL3-1)]
              IFRST3 = 0
            else
              call NXTORD(IOC(IEL1+IEL2+1),IEL3,IORB3F,IORB3L,NONEW3)
              if (NONEW3 == 1) then
                if (IEL2 /= 0) cycle RAS2occ
                if (IEL1 /= 0) cycle RAS1occ
                cycle inner
              end if
            end if
          end if
          ! Next string has been constructed, Enlist it!
          NSTRIN = NSTRIN+1
          ! Symmetry of string
          ISYM = ISYMST_MCLR(IOC,NEL)
          !      ISYMST_MCLR(STRING,NEL)
          ! occupation type of string
          ITYP = IOCTP2_MCLR(IOC,NEL,IOTYP)
          !      IOCTP2_MCLR(STRING,NEL)

          NSTASO(ITYP,ISYM) = NSTASO(ITYP,ISYM)+1

          if (IEL3 == 0) exit RAS3occ
        end do RAS3occ
        if ((IEL3 /= 0) .or. (IEL2 == 0)) exit RAS2occ
      end do RAS2occ
      if ((IEL3 /= 0) .or. (IEL2 /= 0) .or. (IEL1 == 0)) exit RAS1occ
    end do RAS1occ
  end do inner
end do outer

end subroutine NSTRSO_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetConstraint(Constraint)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: set info for constrained LDF.
C              To unset, call LDF_UnsetConstraint()
C
      Implicit None
      Integer Constraint

      Character*17 SecNam
      Parameter (SecNam='LDF_SetConstraint')

      If (Constraint.eq.-1) Then ! no constraint
         Return
      Else If (Constraint.eq.0) Then ! charge constraint
         Call LDF_SetChargeConstraint()
      Else ! unknown constraint
         Call WarningMessage(2,SecNam//': illegal constraint')
         Write(6,'(A,I10)') 'Constraint=',Constraint
         Call LDF_Quit(1)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_UnsetConstraint(Constraint)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: unset info for constrained LDF.
C
      Implicit None
      Integer Constraint

      Character*17 SecNam
      Parameter (SecNam='LDF_SetConstraint')

      If (Constraint.eq.-1) Then ! no constraint
         Return
      Else If (Constraint.eq.0) Then ! charge constraint
         Call LDF_UnsetChargeConstraint()
      Else ! unknown constraint
         Call WarningMessage(2,SecNam//': illegal constraint')
         Write(6,'(A,I10)') 'Constraint=',Constraint
         Call LDF_Quit(1)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine BSSint
      use Basis_Info
      use Symmetry_Info, only: nIrrep
      Implicit real*8(a-h,o-z)
#include "Molcas.fh"
#include "rinfo.fh"
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "wldata.fh"
#include "oneswi.fh"
#include "RelLight.fh"
      integer ipaddr(3)
      Character*8 Label
      Logical IfTest
      Data IfTest/.False./
*
      iRout=77
      iPrint=nPrint(iRout)
#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif
*
*     Save basis set info from contracted run
*
      if(iprint.ge.10) write(6,*) ' In dkint', ncnttp
      kCof=0
      kAng=0
      kExp=0
      kC=0
*
*     Normalize coefficients
*
      do iCnttp=1,nCnttp
        Do icnt = 1, dbsc(iCnttp)%nCntr
        kC=kC+1
c           Do iAngr=0,nAngr(icnt)
           Do iAngr=0,nAngr(kC)
c              rI=iAngr+1.0d0+half
               rI=DBLE(iAngr)+One+Half
              kAng=kAng+1
              Do iBas=1,nBasisr(kAng)
                 Sum=Zero
                 kExpi=kExp
                 kCofi=kCof
                 Do iExp=1,nPrimr(kAng)
                    kExpi=kExpi+1
                    kCofi=kCofi+1
                    rExpi=rExp(kExpi)
c                    write(6,'(a11,f20.8)') ' Exponents',rExpi
                    rCofi=rCof(kCofi)
                    kExpj=kExp
                    kCofj=kCof
                    Do jExp=1,nPrimr(kAng)
                       kExpj=kExpj+1
                       kCofj=kCofj+1
                       rExpj=rExp(kExpj)
                       rCofj=rCof(kCofj)
                       Sum=Sum+rCofi*rCofj*
     &                 (Two*sqrt(rExpi*rExpj)/(rExpi+rExpj))**rI
                    Enddo
                 Enddo
                 rNorm=One/sqrt(Sum)
                 if(iprint.ge.10) write(6,*) ' rNorm', kAng,rNorm
                   Do iExp=1,nPrimr(kAng)
                      rCof(kCof+iExp)=rCof(kCof+iExp)*rNorm
                     if(iprint.ge.10) then
                         write(6,'(a24,f20.6)')
     &                   ' normalized coefficients',
     &                   rCof(kCof+iExp)
                     endif
                   Enddo
                 kCof=kCof+nPrimr(kAng)
              Enddo
              kExp=kExp+nPrimr(kAng)
           Enddo
        Enddo
      Enddo
*
      i=0
      If(iPrint.ge.10) then
      Do L=1,nrSym
         write(6,*) ' Irreducible representation', L
         Do ibas=1,nrBas(L)
         i=i+1
         write(6,'(20i4)') i, icent(i),lnang(i),lmag(i)
         enddo
      enddo
      endif
*
*     Close ONEINT and re-open ONEREL
*
      nSym=nIrrep
      iOpt=0
      Call ClsOne(iRC,iOpt)
      iOpt = 0
      iRC = -1
      Lu_One=2
      Call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
      If (iRC.ne.0) Go To 9999
*
      Call OneBas('PRIM')
      Call Get_iArray('nBas_Prim',nbas,nSym)
*
      If(iPrint.ge.10) then
         write(6,'(a11,10i5)') ' Symmetries', nSym
         write(6,'(a11,10i5)') ' Primitive basis fcns',
     &                          (nBas(i),i=0,nSym-1)
      Endif
*
*
*     Allocate memory for relativistic part
*
*
      LenIntf=0
      LenIntf1=0
      Do L=0,nSym-1
      n=nBas(L)
      LenIntf=LenIntf+n*n+4
      LenIntf1=LenIntf1+n+4
      Enddo
*
*
      CALL GetMem('Eigf    ','ALLO','REAL',iEigf,LenIntf)
      CALL GetMem('Sinvf   ','ALLO','REAL',iSinvf,LenIntf)
      CALL GetMem('Revtf   ','ALLO','REAL',iRevtf,LenIntf)
      CALL GetMem('Aaf     ','ALLO','REAL',iAaf,LenIntf1)
      CALL GetMem('Rrf     ','ALLO','REAL',iRrf,LenIntf1)
      call dcopy_(LenIntf,[Zero],0,Work(iEigf),1)
      call dcopy_(LenIntf,[Zero],0,Work(iSinvf),1)
      call dcopy_(LenIntf,[Zero],0,Work(iRevtf),1)
      call dcopy_(LenIntf1,[Zero],0,Work(iAaf),1)
      call dcopy_(LenIntf1,[Zero],0,Work(iRrf),1)
*
      VELIT=CLightAU
      iSizep=0
      Do L=0,nSym-1
         iSizep=iSizep + nBas(L)*(nBas(L)+1)/2
      Enddo
        If(iPrint.ge.10) write(6,*) ' iSizep', iSizep
*
      CALL GetMem('Kin     ','ALLO','REAL',iK,iSizep+4)
      CALL GetMem('SS      ','ALLO','REAL',iSS,iSizep+4)
      CALL GetMem('V       ','ALLO','REAL',iV,iSizep+4)
      CALL GetMem('pVp     ','ALLO','REAL',ipVp,iSizep+4)
*
      If (iprint.ge.20) write(6,*) '  indices', iss, ik, iv, ipvp
      Label='Mltpl  0'
      iComp=1
      iOpt=0
      iRC = -1
      Call RdOne(iRC,iOpt,Label,1,Work(iSS),lOper)
      If (iRC.ne.0) then
         Write (6,*) 'BSSInt: Error reading from ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend
      End If
c         write(6,'(8f9.4)') (Work(iSS+k),k=0,iSizep-1)
      nComp=1
      ipaddr(1)=iSS
      If (iPrint.ge.20) Call PrMtrx(Label,[lOper],nComp,ipaddr,Work)
      Label='Attract '
      iRC = -1
      Call RdOne(iRC,iOpt,Label,1,Work(iV),lOper)
      If (iRC.ne.0) then
         Write (6,*) 'BSSInt: Error reading from ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend
      End If
      Label='Kinetic '
      iRC = -1
      Call RdOne(iRC,iOpt,Label,1,Work(iK),lOper)
      If (iRC.ne.0) then
         Write (6,*) 'BSSInt: Error reading from ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend
      End If
      Label='pVp     '
      iRC = -1
      Call RdOne(iRC,iOpt,Label,1,Work(ipVp),lOper)
      If (iRC.ne.0) then
         Write (6,*) 'BSSInt: Error reading from ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend
      End If
*
      nComp=3
      Call GetMem ('lOper1  ','ALLO','INTE',ip2,nComp)
      Call GetMem ('ipl     ','ALLO','INTE',ipV,nComp)
         ixyz=1
         iWork(ip2  ) = 2**IrrFnc(ixyz)
         ixyz=2
         iWork(ip2+1) = 2**IrrFnc(ixyz)
         ixyz=4
         iWork(ip2+2) = 2**IrrFnc(ixyz)
*
      Call GetMem ('iiVpf   ','ALLO','INTE',iVpf,nComp)
      Call GetMem ('iipVf   ','ALLO','INTE',ipVf,nComp)
*
*
C     Read pV matrix , elements <iSyma|pV|iSymb>,
C     iSymb.le.iSyma !
*
      DO iComp=1,nComp
*
      Label='pV      '
      iRC = -1
      iSmlbl=iWork(ip2+iComp-1)
      LenInt=n2Tri(iSmlbl)
      Call GetMem ('pV      ','ALLO','REAL',iWork(ipV+iComp-1),LenInt+4)
      ip4=iWork(ipV+iComp-1)
      Call RdOne(iRC,iOpt,Label,iComp,Work(ip4),iSmlbl)
*
*
      ENDDO
*
*     Call PrMtrx('pV      ',iWork(ip2),nComp,iWork(ipV),Work)
*
*
*
C     Read Vp matrix , elements <iSyma|Vp|iSymb>,
C     iSymb.le.iSyma !
*
*
C     Read Vp matrix
*
      Label='Vp      '
*
      Call GetMem ('ipk     ','ALLO','INTE',iVp,nComp)
*
      DO iComp=1,nComp
*
      iRC = -1
      iSmlbl=iWork(ip2+iComp-1)
      LenInt=n2Tri(iSmlbl)
      Call GetMem ('Vp      ','ALLO','REAL',iWork(iVp+iComp-1),LenInt+4)
      ip5=iWork(iVp+iComp-1)
      Call RdOne(iRC,iOpt,Label,iComp,Work(ip5),iSmlbl)
      ENDDO


*     Call PrMtrx(Label,iWork(ip2),nComp,iWork(iVp),Work)
*
*
C     Build the whole matrix <iSyma|pV|iSymb> lower triangel
C     and put into a Work(ip6+ip1+k) and the upper triange
C     and put into a Work(ip6+LenInt+iip1+k).
C     For 'Vp' matrix the same , p7 instead of p6
*
*
      Do iComp =1,nComp
*
        iSmlbl=iWork(ip2+iComp-1)
        LenInt=n2Tri(iSmlbl)
*
        Call GetMem ('pVf     ','ALLO','REAL',
     &              iWork(ipVf+iComp-1),2*LenInt+4)
        Call GetMem ('Vpf     ','ALLO','REAL',
     &              iWork(iVpf+iComp-1),2*LenInt+4)
*
        ip4=iWork(ipV+iComp-1)
        ip5=iWork(iVp+iComp-1)
        ip6=iWork(ipVf+iComp-1)
        ip7=iWork(iVpf+iComp-1)
        ip1=0
        iip1=0
*
      Do iSyma=0,nSym-1
        na=nBas(iSyma)
        If (na.eq.0) go to 81
*
      Do iSymb=0,iSyma
        nb=nBas(iSymb)
        If (nb.eq.0) go to 82
        If (iAnd(iSmLbl,2**iEor(iSyma,iSymb)).eq.0)
     &  Go to 82
      If (iSyma.eq.iSymb) Then
        iSize=na*(na+1)/2
C
C     Elements <iSyma|pV|iSyma> and <iSyma|Vp|iSyma>
C
      Do k=0,iSize-1
        Work(ip6+ip1+k)=Work(ip4+ip1+k)
        Work(ip7+ip1+k)=Work(ip5+ip1+k)
      Enddo
        ip1=ip1+na*(na+1)/2
      Else
        iSize=na*nb
C
C     Elements <iSyma|pV|iSymb> and <iSymb|pV|iSyma> = -<iSyma|Vp|iSymb>
C     AND
C     Elements <iSyma|Vp|iSymb> and <iSymb|Vp|iSyma> = -<iSyma|pV|iSymb>
C
      Do k=0,iSize-1
        Work(ip6+ip1+k)=Work(ip4+ip1+k)
        Work(ip7+ip1+k)=Work(ip5+ip1+k)
        Work(ip6+LenInt+4+iip1+k)=-Work(ip5+ip1+k)
        Work(ip7+LenInt+4+iip1+k)=-Work(ip4+ip1+k)
      Enddo
        ip1=ip1+na*nb
        iip1=iip1+na*nb
      End If
*
 82   Continue
      Enddo
 81   Continue
      Enddo
*
*
C
C
*     WRITE(*,*) 'Created  whole matrix (NAxNB) PV '
C
*     WRITE(*,*) 'pV matrix <iSyma|pV|iSymb> '
*     WRITE(*,*)
*     WRITE(*,*) (Work(iWork(ipVf+iComp-1)+i),i=0,LenInt-1)
*     WRITE(*,*)
*     WRITE(*,*)
*     WRITE(*,*) 'pV matrix <iSymb|pV|iSyma> if iSyma.ne.iSymb
*    &            otherwise zero matrix '
*     WRITE(*,*)
*     WRITE(*,*) (Work(iWork(ipVf+iComp-1)+LenInt+4+i),i=0,LenInt-1)
*
*
C     Create the whole matrix (NAxNB) VP
C
*     WRITE(*,*) 'Create the whole matrix (NAxNB) VP '
*
*     WRITE(*,*)
*     WRITE(*,*) 'Vp matrix <iSyma|Vp|iSymb> '
*     WRITE(*,*)
*     WRITE(*,*) (Work(iWork(iVpf+iComp-1)+i),i=0,LenInt-1)
*     WRITE(*,*)
*     WRITE(*,*)
*     WRITE(*,*)
*     WRITE(*,*) 'Vp matrix <iSymb|Vp|iSyma> if iSyma.ne.iSymb
*    &            otherwise zero matrix '
*     WRITE(*,*)
*     WRITE(*,*)
*     WRITE(*,*) (Work(iWork(iVpf+iComp-1)+LenInt+4+i),i=0,LenInt-1)
*
*
C     End of iComp loop
*
      Enddo
*
*
*
*     Main loop  1
      epsilon=1.d-10
      k=0
      L=0
      k1=0
      k2=0
      Do L = 0, nSym-1
*
*
         n=nBas(L)
         iSize=n*(n+1)/2
CAJS protection against zero dimension representation
         if (iSize.eq.0) goto 9
CAJS
*   put zeroes
         Len=4*(iSize+4)+5*(n*n+4)+5*(n+4)
         CALL GetMem('Scratch ','ALLO','REAL',iCr,Len+4)
         call dcopy_(Len,[Zero],0,Work(iCr),1)
         CALL GetMem('Scratch ','FREE','REAL',iCr,Len+4)
*
*        Allocate
*
         CALL GetMem('Bu      ','ALLO','REAL',iBu,isize+4)
         CALL GetMem('P       ','ALLO','REAL',iP,isize+4)
         CALL GetMem('G       ','ALLO','REAL',iG,isize+4)
         CALL GetMem('Ev2     ','ALLO','REAL',iEv2,isize+4)
         CALL GetMem('Eig     ','ALLO','REAL',iEig,n*n+4)
         CALL GetMem('Sinv    ','ALLO','REAL',iSinv,n*n+4)
         CALL GetMem('Revt    ','ALLO','REAL',iRevt,n*n+4)
         CALL GetMem('Aux     ','ALLO','REAL',iAux,n*n+4)
         CALL GetMem('Ove     ','ALLO','REAL',iOve,n*n+4)
         CALL GetMem('Ew      ','ALLO','REAL',iEw,n+4)
         CALL GetMem('E       ','ALLO','REAL',iE,n+4)
         CALL GetMem('Aa      ','ALLO','REAL',iAa,n+4)
         CALL GetMem('Rr      ','ALLO','REAL',iRr,n+4)
         CALL GetMem('Tt      ','ALLO','REAL',iTt,n+4)
*
*        Debug output on unit idbg
         If(IfTest)Then
           idbg=41
         Else
           idbg=-1
         Endif
*
*
*   call to package relsewb
         CALL SCFCLI2(idbg,epsilon,Work(iSS+k),Work(iK+k),Work(iV+k),
     *   Work(ipVp+k),n,iSize,VELIT,Work(iBu),Work(iP),
     *   Work(iG),Work(iEv2),Work(iEig),Work(iSinv),Work(iRevt),
     *        Work(iAux),Work(iOve),Work(iEw),Work(iE),Work(iAa),
     *        Work(iRr),Work(iTt))
*
*
*
*
*
         call dcopy_(n*n+4,Work(iEig),1,Work(iEigf+k1),1)
         call dcopy_(n*n+4,Work(iSinv),1,Work(iSinvf+k1),1)
         call dcopy_(n*n+4,Work(iRevt),1,Work(iRevtf+k1),1)
         call dcopy_(n+4,Work(iAa),1,Work(iAaf+k2),1)
         call dcopy_(n+4,Work(iRr),1,Work(iRrf+k2),1)
*
*
*
*
*
         CALL GetMem('Bu      ','FREE','REAL',iBu,isize+4)
         CALL GetMem('P       ','FREE','REAL',iP,isize+4)
         CALL GetMem('G       ','FREE','REAL',iG,isize+4)
         CALL GetMem('Ev2     ','FREE','REAL',iEv2,isize+4)
         CALL GetMem('Eig     ','FREE','REAL',iEig,n*n+4)
         CALL GetMem('Sinv    ','FREE','REAL',iSinv,n*n+4)
         CALL GetMem('Revt    ','FREE','REAL',iRevt,n*n+4)
         CALL GetMem('Aux     ','FREE','REAL',iAux,n*n+4)
         CALL GetMem('Ove     ','FREE','REAL',iOve,n*n+4)
         CALL GetMem('Ew      ','FREE','REAL',iEw,n+4)
         CALL GetMem('E       ','FREE','REAL',iE,n+4)
         CALL GetMem('Aa      ','FREE','REAL',iAa,n+4)
         CALL GetMem('Rr      ','FREE','REAL',iRr,n+4)
         CALL GetMem('Tt      ','FREE','REAL',iTt,n+4)
 9       k=k+isize
         k1=k1+n*n+4
         k2=k2+n+4
      Enddo
*
*
*
*     Main loop  2
      nComp=3
*
      Do iComp=1,nComp
*
      ip6=iWork(ipVf+iComp-1)
      ip7=iWork(iVpf+iComp-1)
      ip1=0
      iip1=0
      epsilon=1.d-10
      kh=0
      k1a=0
      k2a=0
      iSmlbl=iWork(ip2+iComp-1)
      LenInt=n2Tri(iSmlbl)
*
      Do iSyma = 0, nSym-1
*
         na=nBas(iSyma)
         iSizea=na*(na+1)/2
CAJS protection against zero dimension representation
         if (iSizea.le.0) goto 19
CAJS
*
       k1b=0
       k2b=0
*
       Do iSymb=0,nSym-1
*
       nb=nBas(iSymb)
       iSizeb=nb*(nb+1)/2
       If (iSizeb.le.0) goto 29
       iSizeab=na*nb
       If (iAnd(iSmlbl,2**iEor(iSyma,iSymb)).eq.0)
     *    Go to 29
*
*
       Call GetMem('ipVa    ','ALLO','REAL',ifa,iSizea)
       Call GetMem('iVpa    ','ALLO','REAL',if2a,iSizea)
*
       If (iSyma.eq.iSymb) Then
*
       call dcopy_(iSizea,[Zero],0,Work(ifa),1)
       call dcopy_(iSizea,[Zero],0,Work(if2a),1)
       Do k=0,iSizea-1
       Work(ifa+k)=Work(ip6+ip1+k)
       Work(if2a+k)=Work(ip7+ip1+k)
       Enddo
       ip1=ip1+iSizea
       End If
*
*
       Call GetMem('ifpV    ','ALLO','REAL',if,iSizeab)
       Call GetMem('ifVp    ','ALLO','REAL',if2,iSizeab)
       Call GetMem('ScpV    ','ALLO','REAL',iScpV,iSizeab)
       Call GetMem('ScVp    ','ALLO','REAL',iScVp,iSizeab)
       call dcopy_(iSizeab,[Zero],0,Work(if),1)
       call dcopy_(iSizeab,[Zero],0,Work(if2),1)
       call dcopy_(iSizeab,[Zero],0,Work(iScpV),1)
       call dcopy_(iSizeab,[Zero],0,Work(iScVp),1)
*
       If (iSyma.gt.iSymb) Then

       Do k=0,iSizeab-1
       Work(if+k) = Work(ip6+ip1+k)
       Work(if2+k) = Work(ip7+ip1+k)
       Enddo
       ip1=ip1+na*nb
*
*
       End If
*
       If (iSyma.lt.iSymb) Then
*
       Do k=0,iSizeab-1
       Work(if+k)=Work(ip6+iip1+LenInt+4+k)
       Work(if2+k)=Work(ip7+iip1+LenInt+4+k)
       Enddo
       CALL DCOPY_(iSizeab,Work(if),1,Work(iScpV),1)
       CALL DCOPY_(iSizeab,Work(if2),1,Work(iScVp),1)
*
       iip1=iip1+na*nb
       End If
*
*
*
*
*
*
*
*
*        Allocate
*
         CALL GetMem('Bu2     ','ALLO','REAL',iBu2,na*nb+4)
         CALL GetMem('Bu4     ','ALLO','REAL',iBu4,na*nb+4)
         CALL GetMem('Bu6     ','ALLO','REAL',iBu6,na*na+4)
         CALL GetMem('Bu      ','ALLO','REAL',iBu,iSizea+4)
         CALL GetMem('P       ','ALLO','REAL',iP,iSizea+4)
         CALL GetMem('G2      ','ALLO','REAL',iG2,na*nb+4)
         CALL GetMem('Ev4     ','ALLO','REAL',iEv4,isizea+4)
         CALL GetMem('Eig4    ','ALLO','REAL',iEig4,na*na+4)
*        CALL GetMem('Sinv    ','ALLO','REAL',iSinv,n*n+4)
*        CALL GetMem('Revt    ','ALLO','REAL',iRevt,n*n+4)
         CALL GetMem('Aux2    ','ALLO','REAL',iAux2,na*nb+4)
         CALL GetMem('Cmm1    ','ALLO','REAL',iCmm1,na*nb+4)
         CALL GetMem('Cmm2    ','ALLO','REAL',iCmm2,na*nb+4)
         CALL GetMem('Ew4     ','ALLO','REAL',iEw4,na+4)
*        CALL GetMem('E       ','ALLO','REAL',iE,n+4)
*        CALL GetMem('Tt      ','ALLO','REAL',iTt,n+4)

*
*
*
      call dcopy_(na*nb+4,[Zero],0,Work(iBu2),1)
      call dcopy_(na*nb+4,[Zero],0,Work(iBu4),1)
      call dcopy_(na*na+4,[Zero],0,Work(iBu6),1)
      call dcopy_(na*na+4,[Zero],0,Work(iEig4),1)
      call dcopy_(na+4,[Zero],0,Work(iEw4),1)
      call dcopy_(iSizea+4,[Zero],0,Work(iEv4),1)
      call dcopy_(na*nb+4,[Zero],0,Work(iG2),1)
      call dcopy_(na*nb+4,[Zero],0,Work(iAux2),1)
      call dcopy_(na*nb+4,[Zero],0,Work(iCmm1),1)
      call dcopy_(na*nb+4,[Zero],0,Work(iCmm2),1)
*
*
*
*
*
*
*
*     Calculate the matrix elements of the
*     following commutator :
*     Revta*AAA*<a|[bp,V]|b>store in CMM1(iSyma,iSymb) matrix,
*
*
*
         CALL VPBMBPV(idbg,epsilon,Work(iEigf+k1a),
     *   Work(iEigf+k1b),
     *   Work(iRevtf+k1a),Work(iSinvf+k1a),
     *   Work(iSinvf+k1b),na,nb,iSizea,iSizeb,VELIT,
     *   Work(iAaf+k2a),Work(iAaf+k2b),
     *   Work(iRrf+k2a),Work(iRrf+k2b),
     *   Work(if ),Work(if2),iSyma,iSymb,Work(iBu2),
     *   Work(iG2),Work(iAux2),Work(iCmm1),Work(iBu4),
     *   Work(iCmm2),Work(ifa),Work(if2a),Work(iScpV),
     *   Work(iScVp))
*
*
*
      call dcopy_(na*nb+4,[Zero],0,Work(iBu2),1)
      call dcopy_(na*nb+4,[Zero],0,Work(iBu4),1)
      call dcopy_(na*na+4,[Zero],0,Work(iBu6),1)
      call dcopy_(na*nb+4,[Zero],0,Work(iG2),1)
      call dcopy_(na*nb+4,[Zero],0,Work(iAux2),1)
      call dcopy_(na*na+4,[Zero],0,Work(iEig4),1)
*
*
*
*        call to package relsewc, BSS up to the fourth order in alpha
C
         CALL SCFCLI4(idbg,epsilon,
     *   Work(iSS+kh),Work(iK+kh),
     *   Work(iRevtf+k1a),Work(iSinvf+k1a),
     *   na,nb,iSizea,iSizeb,VELIT,
     *   Work(iAaf+k2a),Work(iAaf+k2b),
     *   iSyma,iSymb,Work(iCmm1),
     *   Work(iCmm2),Work(iEv4),Work(iBu2),Work(iBu6),
     *   Work(iEig4),Work(iEw4),Work(iP))
*
*
*
*
*
*        Free a space
*
*
*
C
         CALL GetMem('Bu2     ','FREE','REAL',iBu2,na*nb+4)
         CALL GetMem('Bu4     ','FREE','REAL',iBu4,na*nb+4)
         CALL GetMem('Bu6     ','FREE','REAL',iBu6,na*na+4)
         CALL GetMem('Bu      ','FREE','REAL',iBu,iSizea+4)
         CALL GetMem('P       ','FREE','REAL',iP,iSizea+4)
         CALL GetMem('G2      ','FREE','REAL',iG2,na*nb+4)
         CALL GetMem('Ev4     ','FREE','REAL',iEv4,isizea+4)
         CALL GetMem('Eig4    ','FREE','REAL',iEig4,na*na+4)
*        CALL GetMem('Sinv    ','FREE','REAL',iSinv,n*n+4)
*        CALL GetMem('Revt    ','FREE','REAL',iRevt,n*n+4)
         CALL GetMem('Aux2    ','FREE','REAL',iAux2,na*nb+4)
         CALL GetMem('Cmm1    ','FREE','REAL',iCmm1,na*nb+4)
         CALL GetMem('Cmm2    ','FREE','REAL',iCmm2,na*nb+4)
         CALL GetMem('Ew4     ','FREE','REAL',iEw4,na+4)
*        CALL GetMem('E       ','FREE','REAL',iE,n+4)
*        CALL GetMem('Tt      ','FREE','REAL',iTt,n+4)
*
*
*
         Call GetMem('ifpV    ','FREE','REAL',if,iSizeab)
         Call GetMem('ifVp    ','FREE','REAL',if2,iSizeab)
         Call GetMem('ScpV    ','FREE','REAL',iScpV,iSizeab)
         Call GetMem('ScVp    ','FREE','REAL',iScVp,iSizeab)
*
*
*
         Call GetMem('ipVa    ','FREE','REAL',ifa,iSizea)
         Call GetMem('iVpa    ','FREE','REAL',if2a,iSizea)
*
 29   Continue
      k1b=k1b+nb*nb+4
      k2b=k2b+nb+4
      Enddo
 19   kh=kh+iSizea
      k1a=k1a+na*na+4
      k2a=k2a+na+4
      Enddo
      Enddo
*
*
      Do iComp=1,nComp
      iSmlbl=iWork(ip2+iComp-1)
      LenInt=n2Tri(iSmlbl)
      Call GetMem ('pVf     ','FREE','REAL',
     &              iWork(ipVf+iComp-1),2*LenInt+4)
      Call GetMem ('Vpf     ','FREE','REAL',
     &              iWork(iVpf+iComp-1),2*LenInt+4)
      Enddo
*
      do iComp=1,nComp
      iSmlbl=iWork(ip2+iComp-1)
      LenInt=n2Tri(iSmlbl)
      Call GetMem ('Vp      ','FREE','REAL',iWork(iVp+iComp-1),LenInt+4)
      enddo
      Call GetMem ('ipk     ','FREE','INTE',iVp,nComp)
*
      do iComp=1,nComp
      iSmlbl=iWork(ip2+iComp-1)
      LenInt=n2Tri(iSmlbl)
      Call GetMem ('pV      ','FREE','REAL',iWork(ipV+iComp-1),LenInt+4)
      enddo
*
*
      Call GetMem ('iiVpf   ','FREE','INTE',iVpf,nComp)
      Call GetMem ('iipVf   ','FREE','INTE',ipVf,nComp)
*
*
*
      Call GetMem ('ipl     ','FREE','INTE',ipV,nComp)
      Call GetMem ('lOper1  ','FREE','INTE',ip2,nComp)

      CALL GetMem('pVp     ','FREE','REAL',ipVp,iSizep+4)
*
*     open arrays in contracted basis
*
      iSizec=0
      do L=1,nSym
         iSizec=iSizec+nrBas(L)*(nrBas(L)+1)/2
      enddo
      CALL GetMem('H       ','ALLO','REAL',iH,iSizec+4)
      Call FZero(Work(iH),iSizec+4)
      CALL GetMem('H_nr    ','ALLO','REAL',iH_nr,iSizec+4)
      Call FZero(Work(iH_nr),iSizec+4)
      CALL GetMem('H_temp  ','ALLO','REAL',iH_temp,iSizec+4)
      Call FZero(Work(iH_temp),iSizec+4)
*
*     compute stripped non-relativistic H
*
      Label='Kinetic '
      Call RdOne(iRC,iOpt,Label,1,Work(iSS),lOper)
      If (iRC.ne.0) then
         Write (6,*) 'BSSInt: Error reading from ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend
      End If
C
C
      Label='Attract '
      Call RdOne(iRC,iOpt,Label,1,Work(iV),lOper)
      If (iRC.ne.0) then
         Write (6,*) 'BSSInt: Error reading from ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend
      End If
C
C
      Call DaXpY_(iSizep+4,One,Work(iSS),1,Work(iV),1)
C
C
C
C
C
      call dcopy_(4,[Zero],0,Work(iH_temp+iSizec),1)
      Call repmat(idbg,Work(iV),Work(iH_temp))
*
C
C
C
      CALL GetMem('V       ','FREE','REAL',iV,iSizep+4)
      CALL GetMem('SS      ','FREE','REAL',iSS,iSizep+4)
*
*     Close ONEREL and re-open ONEINT
*
      iOpt = 0
      iRC = -1
      Call ClsOne(iRC,iOpt)
      If (iRC.ne.0) Go To 9999
      iOpt = 0
      iRC = -1
      Lu_One=2
      Call OpnOne(iRC,iOpt,'ONEINT',Lu_One)
      If (iRC.ne.0) Go To 9999
*
*
*     Transform to contracted basis
*
*     The Hamiltonian is now in Kin.
*


C
      Call repmat(idbg,Work(iK),Work(iH))
*
      CALL GetMem('Kin     ','FREE','REAL',iK,iSizep+4)
*
      iOpt = 0
      iRC = -1
      Label='OneHam 0'
      Call RdOne(iRC,iOpt,Label,1,Work(iH_nr),lOper)
      If (iRC.ne.0) then
         Write (6,*) 'BSSInt: Error reading from ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend
      End If
      iOpt = 0
      iRC = -1
*
*     final Hamiltonian computed as H(nrel) + ( Hrel(s) - Hnrel(s))
*     where (s) is stripped and with full charge
*
      Call DaXpY_(iSizec+4,-One,Work(iH_temp),1,Work(iH),1)
      Call DaXpY_(iSizec+4,One,Work(iH_nr),1,Work(iH),1)
*
      Call Get_iArray('nBas',nBas,nSym)
      If(iPrint.ge.10) then
         write(6,'(a11,10i5)') ' Symmetries', nSym
         write(6,'(a11,10i5)') ' Contracted',(nBas(i),i=0,nSym-1)
      Endif
      Label='OneHam 0'
      lOper=1
      nComp=1
      ipaddr(1)=iH
      If (iPrint.ge.20) Call PrMtrx(Label,[lOper],nComp,ipaddr,Work)
*
*     Replace 1-el Hamiltonian on ONEINT
*
      iRC = -1
      Call WrOne(iRC,iOpt,Label,1,Work(iH),lOper)
      Label='OneHam  '
      Call WrOne(iRC,iOpt,Label,1,Work(iH),lOper)
      If (iRC.ne.0) then
         Write (6,*) 'BSSInt: Error writing to ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend
      End If
*
      CALL GetMem('OneHam  ','FREE','REAL',iH,iSizec+4)
      CALL GetMem('H_nr    ','FREE','REAL',iH_nr,iSizec+4)
      CALL GetMem('H_temp  ','FREE','REAL',iH_temp,iSizec+4)
*
*
      CALL GetMem('Eigf    ','FREE','REAL',iEigf,LenIntf)
      CALL GetMem('Sinvf   ','FREE','REAL',iSinvf,LenIntf)
      CALL GetMem('Revtf   ','FREE','REAL',iRevtf,LenIntf)
      CALL GetMem('Aaf     ','FREE','REAL',iAaf,LenIntf1)
      CALL GetMem('Rrf     ','FREE','REAL',iRrf,LenIntf1)
      Return
*
 9999 Continue
      Write (6,*) ' *** Error in subroutine BSSint ***'
      Write (6,*) '     Abend in subroutine OpnOne'
      Call Abend
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_T_pair_builder

use fmm_global_paras, only: INTK, scheme_paras, gen_mm_paras, LHS_RHS_type, LHS_raw_RHS_raw, LHS_box_RHS_box
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_init_T_pair_builder, &
          fmm_close_T_pair_builder, &
          fmm_gen_local_T_pairs, &
          fmm_gen_nonlocal_T_pairs

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_T_pair_builder(scheme,pair_type)

  use fmm_T_pair_mould, only: fmm_init_T_pair_mould
  use fmm_T_pair_tests, only: fmm_init_T_pair_tests
  use fmm_T_buffer, only: fmm_open_T_buffer

  implicit none
  type(scheme_paras), intent(in) :: scheme
  integer(INTK), intent(in)      :: pair_type

  call fmm_init_T_pair_mould(scheme,pair_type)
  call fmm_init_T_pair_tests(scheme)
  call fmm_open_T_buffer(scheme)

end subroutine fmm_init_T_pair_builder

!-------------------------------------------------------------------------------

subroutine fmm_close_T_pair_builder()

  use fmm_T_pair_mould, only: fmm_close_T_pair_mould
  use fmm_T_pair_tests, only: fmm_close_T_pair_tests
  use fmm_T_buffer, only: fmm_close_T_buffer

  implicit none

  call fmm_close_T_pair_mould()
  call fmm_close_T_pair_tests()
  call fmm_close_T_buffer()

end subroutine fmm_close_T_pair_builder

!-------------------------------------------------------------------------------

subroutine fmm_gen_local_T_pairs(LHS,RHS,pair_type)

  use fmm_T_pair_tests, only: fmm_test_and_buffer_T_pair
  use fmm_local_search, only: fmm_get_local_paras

  implicit none
  type(gen_mm_paras), intent(inout) :: LHS, RHS
  integer(INTK), intent(in)         :: pair_type
  type(gen_mm_paras) :: RHS_local
  type(LHS_RHS_type) :: id
  integer(INTK) :: weight, i, j, ndim

  weight = 1
  nullify(RHS_local%box_paras,RHS_local%raw_paras)

  select case (pair_type)
    case (LHS_raw_RHS_raw)
      do j=1,size(LHS%raw_paras)
        id%LHS = j
        do i=1,size(RHS%raw_paras)
          id%RHS = i
          call fmm_test_and_buffer_T_pair(LHS,RHS,id,weight)
        end do
      end do
    case (LHS_box_RHS_box)
      do j=1,size(LHS%box_paras)
        call fmm_get_local_paras(j,RHS,pair_type,RHS_local,ndim)
        if (ndim == 0) cycle
        id%LHS = j
        do i=1,size(RHS_local%box_paras)
          id%RHS = i
          call fmm_test_and_buffer_T_pair(LHS,RHS_local,id,weight)
        end do
        if (associated(RHS_local%box_paras)) then
          deallocate(RHS_local%box_paras)
          nullify(RHS_local%box_paras)
        end if
      end do
    case default
      call fmm_quit('cannot reconcile requested T_pair type!')
  end select

end subroutine fmm_gen_local_T_pairs

!-------------------------------------------------------------------------------

subroutine fmm_gen_nonlocal_T_pairs(LHS,RHS,pair_type)

  use fmm_T_pair_tests, only: fmm_test_and_buffer_T_pair

  implicit none
  type(gen_mm_paras), intent(inout) :: LHS, RHS
  integer(INTK), intent(in)         :: pair_type
  type(LHS_RHS_type) :: id
  integer(INTK) :: weight, i, j

  weight = 1

  select case (pair_type)
    case (LHS_raw_RHS_raw)
      do j=1,size(LHS%raw_paras)
        id%LHS = j
        do i=1,size(RHS%raw_paras)
          id%RHS = i
          call fmm_test_and_buffer_T_pair(LHS,RHS,id,weight)
        end do
      end do
    case (LHS_box_RHS_box)
      do j=1,size(LHS%box_paras)
        id%LHS = j
        do i=1,size(RHS%box_paras)
          id%RHS = i
          call fmm_test_and_buffer_T_pair(LHS,RHS,id,weight)
        end do
      end do
    case default
      call fmm_quit('cannot reconcile requested T_pair type!')
  end select

end subroutine fmm_gen_nonlocal_T_pairs

!-------------------------------------------------------------------------------

end module fmm_T_pair_builder

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine UnFold(A,nAA,B,nBB,nSym,nBas)
!***********************************************************************
!                                                                      *
!     purpose: Expand the density matrix to full storage and scale     *
!              off-diagonal elements                                   *
!                                                                      *
!                                                                      *
!     input:                                                           *
!       A       : triangular matrix of length nAA                      *
!       nSym    : number of blocks to be expanded                      *
!       nBas    : leading dimensions in each block                     *
!                                                                      *
!     output:                                                          *
!       B       : expanded matrix of length nBB                        *
!                                                                      *
!     called from: PMat                                                *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAA, nBB, nSym, nBas(nSym)
real(kind=wp), intent(in) :: A(nAA)
real(kind=wp), intent(out) :: B(nBB)
integer(kind=iwp) :: ib, iSym, jb, k1, k2, l1, l2, l3, nb
real(kind=wp) :: Factor

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

k1 = 0
k2 = 0
Factor = Half
do iSym=1,nSym
  nb = nBas(iSym)
  do ib=1,nb
    do jb=1,(ib-1)
      l1 = jb+(ib-1)*nb+k2
      l2 = ib+(jb-1)*nb+k2
      l3 = jb+ib*(ib-1)/2+k1
      B(l1) = Factor*A(l3)
      B(l2) = Factor*A(l3)
    end do
    l2 = ib+(ib-1)*nb+k2
    l3 = ib+ib*(ib-1)/2+k1
    B(l2) = A(l3)
  end do
  k1 = k1+nb*(nb+1)/2
  k2 = k2+nb*nb
end do

end subroutine UnFold

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
************************************************************************
      Subroutine ppss(EFInt,Zeta,ZInv,nZeta,P,lP,rKappAB,A,B,
     &                       Eta,EInv, nEta,Q,lQ,rKappCD,C,D,
     &                CoorAC,TMax,
     &                iPntr,nPntr,x0,nMax,CW6,CW5,CW4,CW3,CW2,CW1,CW0,
     &                                    CR6,CR5,CR4,CR3,CR2,CR1,CR0,
     &                ddx,HerW,HerR2,IsChi,ChiI2)
************************************************************************
*                                                                      *
* Object: to compute the primitive integrals of type (pp|ss).          *
*                                                                      *
*  Author:    Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN. 1994                                    *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 EFInt(nZeta,nEta,9), Zeta(nZeta), Eta(nEta),
     &       CoorAC(3,2), ZInv(nZeta), EInv(nEta),
     &       P(lP,3), Q(lQ,3), A(3), B(3), C(3), D(3),
     &       rKappAB(nZeta), rKappCD(nEta),
     &       x0(nMax),
     &       CW6(nMax,2), CW5(nMax,2), CW4(nMax,2), CW3(nMax,2),
     &       CW2(nMax,2), CW1(nMax,2), CW0(nMax,2),
     &       CR6(nMax,2), CR5(nMax,2), CR4(nMax,2), CR3(nMax,2),
     &       CR2(nMax,2), CR1(nMax,2), CR0(nMax,2),
     &       HerW(2), HerR2(2)
      Integer iPntr(nPntr)
      Logical ABeqCD, EQ
*
*
      xdInv=One/ddx
      dddx = ddx/10d0 + ddx
*
      ABeqCD = EQ(A,B) .and. EQ(A,C) .and. EQ(A,D)
      If (           ABeqCD            ) Go To 100
      If (     EQ(A,B).and..Not.EQ(C,D)) Go To 200
      If (.Not.EQ(A,B).and.     EQ(C,D)) Go To 300
      If (     EQ(A,B).and.     EQ(C,D)) Go To 400
*
*-----ABCD case
*
      Do 10 iEta = 1, nEta
         Do 20 iZeta = 1, nZeta
            ZEInv = One/(Eta(iEta)+Zeta(iZeta)
     >              +(Eta(iEta)*Zeta(iZeta)*ChiI2)*Dble(IsChi))
            rho = Zeta(iZeta)*(Eta(iEta)*ZEInv)
            PQx = P(iZeta,1)-Q(iEta,1)
            PQy = P(iZeta,2)-Q(iEta,2)
            PQz = P(iZeta,3)-Q(iEta,3)
            T = rho * (PQx**2 + PQy**2 + PQz**2)
            If (T.lt.TMax) Then
               n = iPntr(Int((T+dddx)*xdInv))
               z = T - x0(n)
               w1=(((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+
     &            CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
               w2=(((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+
     &            CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
               r1=(((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+
     &            CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
               r2=(((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+
     &            CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
            Else
               ai = 1.0D0/T
               si = Sqrt(ai)
               w1= HerW(1)*si
               w2= HerW(2)*si
               r1= HerR2(1)*ai
               r2= HerR2(2)*ai
            End If
            Eu21 =   r1*(Eta(iEta)*ZEInv)
            Eu22 =   r2*(Eta(iEta)*ZEInv)
            PAQPx1 = (P(iZeta,1) - CoorAC(1,1)) - Eu21 * PQx
            PAQPx2 = (P(iZeta,1) - CoorAC(1,1)) - Eu22 * PQx
            PAQPy1 = (P(iZeta,2) - CoorAC(2,1)) - Eu21 * PQy
            PAQPy2 = (P(iZeta,2) - CoorAC(2,1)) - Eu22 * PQy
            PAQPz1 = (P(iZeta,3) - CoorAC(3,1)) - Eu21 * PQz
            PAQPz2 = (P(iZeta,3) - CoorAC(3,1)) - Eu22 * PQz
            B101 = (Half - Half * Eu21) * ZInv(iZeta)
            B102 = (Half - Half * Eu22) * ZInv(iZeta)
            x101= PAQPx1
            x102= PAQPx2
            x201= PAQPx1*x101 + B101
            x202= PAQPx2*x102 + B102
            y101= PAQPy1
            y102= PAQPy2
            y201= PAQPy1*y101 + B101
            y202= PAQPy2*y102 + B102
            z101= PAQPz1*w1
            z102= PAQPz2*w2
            z201= PAQPz1*z101 + B101*w1
            z202= PAQPz2*z102 + B102*w2
            PreFct = rKappCD(iEta) * rKappAB(iZeta) * Sqrt(ZEInv)
            EFInt(iZeta,iEta,1) = PreFct * (     x101*w1+     x102*w2)
            EFInt(iZeta,iEta,2) = PreFct * (     y101*w1+     y102*w2)
            EFInt(iZeta,iEta,3) = PreFct * (     z101   +     z102   )
            EFInt(iZeta,iEta,4) = PreFct * (     x201*w1+     x202*w2)
            EFInt(iZeta,iEta,5) = PreFct * (x101*y101*w1+x102*y102*w2)
            EFInt(iZeta,iEta,6) = PreFct * (x101*z101   +x102*z102   )
            EFInt(iZeta,iEta,7) = PreFct * (     y201*w1+     y202*w2)
            EFInt(iZeta,iEta,8) = PreFct * (y101*z101   +y102*z102   )
            EFInt(iZeta,iEta,9) = PreFct * (     z201   +     z202   )
 20      Continue
 10   Continue
      Go To 99
*
*-----AAAA case
*
 100  Continue
      z = - x0(1)
      w1=(((((CW6(1,1)*z+CW5(1,1))*z+CW4(1,1))*z+CW3(1,1))*z+
     &   CW2(1,1))*z+CW1(1,1))*z+Cw0(1,1)
      w2=(((((CW6(1,2)*z+CW5(1,2))*z+CW4(1,2))*z+CW3(1,2))*z+
     &   CW2(1,2))*z+CW1(1,2))*z+Cw0(1,2)
      r1=(((((CR6(1,1)*z+CR5(1,1))*z+CR4(1,1))*z+CR3(1,1))*z+
     &   CR2(1,1))*z+CR1(1,1))*z+CR0(1,1)
      r2=(((((CR6(1,2)*z+CR5(1,2))*z+CR4(1,2))*z+CR3(1,2))*z+
     &   CR2(1,2))*z+CR1(1,2))*z+CR0(1,2)
      Do 11 iEta = 1, nEta
         Do 21 iZeta = 1, nZeta
            ZEInv = One/(Eta(iEta)+Zeta(iZeta)
     >              +(Eta(iEta)*Zeta(iZeta)*ChiI2)*Dble(IsChi))
            Eu21 =   r1*(Eta(iEta)*ZEInv)
            Eu22 =   r2*(Eta(iEta)*ZEInv)
            B101 = (Half - Half * Eu21) * ZInv(iZeta)
            B102 = (Half - Half * Eu22) * ZInv(iZeta)
            PreFct = rKappCD(iEta) * rKappAB(iZeta) * Sqrt(ZEInv)
            EFInt(iZeta,iEta,1) = (PreFct * (B101*w1+B102*w2))
            EFInt(iZeta,iEta,2) = Zero
            EFInt(iZeta,iEta,3) = Zero
            EFInt(iZeta,iEta,4) = (PreFct * (B101*w1+B102*w2))
            EFInt(iZeta,iEta,5) = Zero
            EFInt(iZeta,iEta,6) = (PreFct * (B101*w1+B102*w2))
 21      Continue
 11   Continue
      Go To 99
*
*-----AACD case
*
 200  Continue
      Do 12 iEta = 1, nEta
         Do 22 iZeta = 1, nZeta
         PQx = CoorAC(1,1)-Q(iEta,1)
         PQy = CoorAC(2,1)-Q(iEta,2)
         PQz = CoorAC(3,1)-Q(iEta,3)
         PQ2 = (PQx**2 + PQy**2 + PQz**2)
            ZEInv = One/(Eta(iEta)+Zeta(iZeta)
     >              +(Eta(iEta)*Zeta(iZeta)*ChiI2)*Dble(IsChi))
            rho = Zeta(iZeta)*(Eta(iEta)*ZEInv)
            T = rho * PQ2
            If (T.lt.TMax) Then
               n = iPntr(Int((T+dddx)*xdInv))
               z = T - x0(n)
               w1=(((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+
     &            CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
               w2=(((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+
     &            CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
               r1=(((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+
     &            CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
               r2=(((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+
     &            CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
            Else
               ai = 1.0D0/T
               si = Sqrt(ai)
               w1= HerW(1)*si
               w2= HerW(2)*si
               r1= HerR2(1)*ai
               r2= HerR2(2)*ai
            End If
            Eu21 =   r1*(Eta(iEta)*ZEInv)
            Eu22 =   r2*(Eta(iEta)*ZEInv)
            PAQPx1 =  - Eu21 * PQx
            PAQPx2 =  - Eu22 * PQx
            PAQPy1 =  - Eu21 * PQy
            PAQPy2 =  - Eu22 * PQy
            PAQPz1 =  - Eu21 * PQz
            PAQPz2 =  - Eu22 * PQz
            B101 = (Half - Half * Eu21) * ZInv(iZeta)
            B102 = (Half - Half * Eu22) * ZInv(iZeta)
            x101= PAQPx1
            x102= PAQPx2
            x201= PAQPx1*x101 + B101
            x202= PAQPx2*x102 + B102
            y101= PAQPy1
            y102= PAQPy2
            y201= PAQPy1*y101 + B101
            y202= PAQPy2*y102 + B102
            z101= PAQPz1*w1
            z102= PAQPz2*w2
            z201= PAQPz1*z101 + B101*w1
            z202= PAQPz2*z102 + B102*w2
            PreFct = rKappCD(iEta) * rKappAB(iZeta) * Sqrt(ZEInv)
            EFInt(iZeta,iEta,1) = PreFct * (     x201*w1+     x202*w2)
            EFInt(iZeta,iEta,2) = PreFct * (x101*y101*w1+x102*y102*w2)
            EFInt(iZeta,iEta,3) = PreFct * (x101*z101   +x102*z102   )
            EFInt(iZeta,iEta,4) = PreFct * (     y201*w1+     y202*w2)
            EFInt(iZeta,iEta,5) = PreFct * (y101*z101   +y102*z102   )
            EFInt(iZeta,iEta,6) = PreFct * (     z201   +     z202   )
 22      Continue
 12   Continue
      Go To 99
*
*-----ABCC case
*
 300  Continue
      Do 13 iEta = 1, nEta
         Do 23 iZeta = 1, nZeta
            ZEInv = One/(Eta(iEta)+Zeta(iZeta)
     >              +(Eta(iEta)*Zeta(iZeta)*ChiI2)*Dble(IsChi))
            rho = Zeta(iZeta)*(Eta(iEta)*ZEInv)
            PQx = P(iZeta,1)-CoorAC(1,2)
            PQy = P(iZeta,2)-CoorAC(2,2)
            PQz = P(iZeta,3)-CoorAC(3,2)
            T = rho * (PQx**2 + PQy**2 + PQz**2)
            If (T.lt.TMax) Then
               n = iPntr(Int((T+dddx)*xdInv))
               z = T - x0(n)
               w1=(((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+
     &            CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
               w2=(((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+
     &            CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
               r1=(((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+
     &            CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
               r2=(((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+
     &            CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
            Else
               ai = 1.0D0/T
               si = Sqrt(ai)
               w1= HerW(1)*si
               w2= HerW(2)*si
               r1= HerR2(1)*ai
               r2= HerR2(2)*ai
            End If
            Eu21 =   r1*(Eta(iEta)*ZEInv)
            Eu22 =   r2*(Eta(iEta)*ZEInv)
            PAQPx1 = (P(iZeta,1) - CoorAC(1,1)) - Eu21 * PQx
            PAQPx2 = (P(iZeta,1) - CoorAC(1,1)) - Eu22 * PQx
            PAQPy1 = (P(iZeta,2) - CoorAC(2,1)) - Eu21 * PQy
            PAQPy2 = (P(iZeta,2) - CoorAC(2,1)) - Eu22 * PQy
            PAQPz1 = (P(iZeta,3) - CoorAC(3,1)) - Eu21 * PQz
            PAQPz2 = (P(iZeta,3) - CoorAC(3,1)) - Eu22 * PQz
            B101 = (Half - Half * Eu21) * ZInv(iZeta)
            B102 = (Half - Half * Eu22) * ZInv(iZeta)
            x101= PAQPx1
            x102= PAQPx2
            x201= PAQPx1*x101 + B101
            x202= PAQPx2*x102 + B102
            y101= PAQPy1
            y102= PAQPy2
            y201= PAQPy1*y101 + B101
            y202= PAQPy2*y102 + B102
            z101= PAQPz1*w1
            z102= PAQPz2*w2
            z201= PAQPz1*z101 + B101*w1
            z202= PAQPz2*z102 + B102*w2
            PreFct = rKappCD(iEta) * rKappAB(iZeta) * Sqrt(ZEInv)
            EFInt(iZeta,iEta,1) = PreFct * (     x101*w1+     x102*w2)
            EFInt(iZeta,iEta,2) = PreFct * (     y101*w1+     y102*w2)
            EFInt(iZeta,iEta,3) = PreFct * (     z101   +     z102   )
            EFInt(iZeta,iEta,4) = PreFct * (     x201*w1+     x202*w2)
            EFInt(iZeta,iEta,5) = PreFct * (x101*y101*w1+x102*y102*w2)
            EFInt(iZeta,iEta,6) = PreFct * (x101*z101   +x102*z102   )
            EFInt(iZeta,iEta,7) = PreFct * (     y201*w1+     y202*w2)
            EFInt(iZeta,iEta,8) = PreFct * (y101*z101   +y102*z102   )
            EFInt(iZeta,iEta,9) = PreFct * (     z201   +     z202   )
 23      Continue
 13   Continue
      Go To 99
*
*-----AACC case
*
 400  Continue
      PQx = CoorAC(1,1)-CoorAC(1,2)
      PQy = CoorAC(2,1)-CoorAC(2,2)
      PQz = CoorAC(3,1)-CoorAC(3,2)
      PQ2 = (PQx**2 + PQy**2 + PQz**2)
      Do 14 iEta = 1, nEta
         Do 24 iZeta = 1, nZeta
            ZEInv = One/(Eta(iEta)+Zeta(iZeta)
     >              +(Eta(iEta)*Zeta(iZeta)*ChiI2)*Dble(IsChi))
            rho = Zeta(iZeta)*(Eta(iEta)*ZEInv)
            T = rho * PQ2
            If (T.lt.TMax) Then
               n = iPntr(Int((T+dddx)*xdInv))
               z = T - x0(n)
               w1=(((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+
     &            CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
               w2=(((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+
     &            CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
               r1=(((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+
     &            CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
               r2=(((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+
     &            CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
            Else
               ai = 1.0D0/T
               si = Sqrt(ai)
               w1= HerW(1)*si
               w2= HerW(2)*si
               r1= HerR2(1)*ai
               r2= HerR2(2)*ai
            End If
            Eu21 =   r1*(Eta(iEta)*ZEInv)
            Eu22 =   r2*(Eta(iEta)*ZEInv)
            PAQPx1 =  - Eu21 * PQx
            PAQPx2 =  - Eu22 * PQx
            PAQPy1 =  - Eu21 * PQy
            PAQPy2 =  - Eu22 * PQy
            PAQPz1 =  - Eu21 * PQz
            PAQPz2 =  - Eu22 * PQz
            B101 = (Half - Half * Eu21) * ZInv(iZeta)
            B102 = (Half - Half * Eu22) * ZInv(iZeta)
            x101= PAQPx1
            x102= PAQPx2
            x201= PAQPx1*x101 + B101
            x202= PAQPx2*x102 + B102
            y101= PAQPy1
            y102= PAQPy2
            y201= PAQPy1*y101 + B101
            y202= PAQPy2*y102 + B102
            z101= PAQPz1*w1
            z102= PAQPz2*w2
            z201= PAQPz1*z101 + B101*w1
            z202= PAQPz2*z102 + B102*w2
            PreFct = rKappCD(iEta) * rKappAB(iZeta) * Sqrt(ZEInv)
            EFInt(iZeta,iEta,1) = PreFct * (     x201*w1+     x202*w2)
            EFInt(iZeta,iEta,2) = PreFct * (x101*y101*w1+x102*y102*w2)
            EFInt(iZeta,iEta,3) = PreFct * (x101*z101   +x102*z102   )
            EFInt(iZeta,iEta,4) = PreFct * (     y201*w1+     y202*w2)
            EFInt(iZeta,iEta,5) = PreFct * (y101*z101   +y102*z102   )
            EFInt(iZeta,iEta,6) = PreFct * (     z201   +     z202   )
 24      Continue
 14   Continue
*
 99   Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(EInv)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_Energ()
! calc energy from T1c and t2c

use chcc_global, only: no, nv, Q21, T1c, T2c
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: a, b, i, j
real(kind=wp) :: e

e = Zero

do j=1,no
  do i=1,no
    do b=1,nv
      do a=1,nv
        e = e+(Two*Q21(a,i,b,j)-Q21(a,j,b,i))*(T2c(a,b,i,j)+T1c(a,i)*T1c(b,j))
      end do
    end do
  end do
end do

write(u6,*) ' Energia Checkeroo',e

return

end subroutine Chck_Energ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Markus P. Fuelscher                              *
*               1991, Per Ake Malmqvist                                *
************************************************************************
      Subroutine MkSrt0(iSquar,nIrrep,nBas,iSkip)
************************************************************************
*                                                                      *
*     Purpose: Set up all information needed to compute 2el integral   *
*              adresses in the subroutine PLF2 and INDSFT2.            *
*                                                                      *
*     Called from: Sort0                                               *
*                                                                      *
*     Calls to : none                                                  *
*                                                                      *
*     Calling parameters:                                              *
*     iSquar  : ordering flag                                          *
*     nIrrep  : number of irreducible representations                  *
*     nBas    : number of basis functions per irred. rep.              *
*     nSkip   : flag to exlude symmetry combinations                   *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*                                                                      *
*     local data declarations: none                                    *
*                                                                      *
**** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****
*
      Implicit Integer (A-Z)
*
#include "srt0.fh"
#include "print.fh"
#include "SysCtl.fh"
      Dimension nBas(*),iSkip(*)
*
      iRout = 80
      iPrint = nPrint(iRout)
      if ( iPrint.gt.10) Write(6,*) ' >>> Enter MKSRT0 <<<'
*----------------------------------------------------------------------*
*     Gather information on desired ordering scheme                    *
*----------------------------------------------------------------------*
*
      Square=.true.
      If( iSquar.eq.0 )  Square=.false.
*
*----------------------------------------------------------------------*
*     Gather data on the number of symmetry operations                 *
*----------------------------------------------------------------------*
*
      nSyOp=nIrrep
      mxSyP=nSyOp*(nSyOp+1)/2
*
*----------------------------------------------------------------------*
*     Gather data on the number of basis functions                     *
*----------------------------------------------------------------------*
*
      Do iSymi=1,nSyOp
        nBs(iSymi)=nBas(iSymi)
      End Do
*
*----------------------------------------------------------------------*
*     Put flags to exclude symmetry combinations into common block     *
*----------------------------------------------------------------------*
*
      Do 20 iSymi=1,nSyOp
        nSkip(iSymi)=iSkip(iSymi)
20    Continue
*
*----------------------------------------------------------------------*
*     Precompute the dimension of the symmetry blocks                  *
*     and symmetry block numbers for pairs of symmtry indices          *
*----------------------------------------------------------------------*
*
      Do 30 iSymi=1,nSyOp
        iBsi=nBs(iSymi)
        DimSyB(iSymi,iSymi)=iBsi*(iBsi+1)/2
        TriSyB(iSymi,iSymi)=iSymi*(iSymi+1)/2
        Do 40 jSymj=1,iSymi-1
          jBsj=nBs(jSymj)
          DimSyB(iSymi,jSymj)=iBsi*jBsj
          DimSyB(jSymj,iSymi)=jBsj*iBsi
          TriSyB(iSymi,jSymj)=jSymj+iSymi*(iSymi-1)/2
          TriSyB(jSymj,iSymi)=jSymj+iSymi*(iSymi-1)/2
40      Continue
30    Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Input_MCLR

! nActEl                : Number of active electrons
! iSpin                 : Spin of state
! nSym                  : Number of symmetries
! State_Sym             : Symmetry of state
! nConf                 : Number of configurations in state sym
! nAtoms                : Guess
! lRoots                : State from CASSCF
! nRoots                : nr of states from CASSCF
! nHole1                : nr of holes RAS1
! nElec3                : nr of el in RAS3
! nBas                  : Number of basis functions
! nOrb                  : Number of basis functions
! nFro                  : Nr of frozen orb (not allowed)
! nDel                  : Nr of deleted orbitals (not allowed)
! nIsh                  : nr of inactive orbitals
! nAsh                  : number of active orbitals
! nRs1                  : number of Rs1
! nRs2                  : nr     of rs2
! nRs3                  : nr     of rs3
! nSkip                 : Not active
! iRoot                 : nonono
! iPt2                  : CASPT2 orbitals
! iMethod               : 1=SCF 2=RASSCF  RELAX
! niter                 : Max number of iterations
! nDisp                 : Total number of perturbations
! nCSF                  : Number of CSFs in diff symmetries
! kprint                : print level
! iBreak                : Break criteria
! LuAChoVec             : Unit for storage of half-transformed Cho vectors
! LuIChoVec             : Unit for storage of half-transformed Cho vectors
! LuChoInt              : Unit for storage of integrals (ii|ab)
! Perturbation          : The type of perturbation
! AtLbl                 : Label on Atom    ONEINT
! chirr                 : Irreps
! lCalc                 : True: the perturbation should be calculated
! CASINT                : CASPT2 type integrals
! fail                  : Calculation didnt converge
! Timedep               : Time-dependent calculation
! iMCPD                 : CAS-PDFT calculation
! iMSPD                 : MS-PDFT calculation
! McKinley              : Input read from McKinley True if MCKINT exists
! PT2                   : Read in RHS from CASPT2
! SPINPOL               : Calculate spin polarization for casscf
! double                : Double isotope substitutions
! newCho                : Switch to the new Cholesky algorithm
! PotNuc, ERASSCF, ESCF : Energies
! Eps                   : The threshold for PCG
! rin_ene               : Inactive energy
! Omega                 : Frequency of the time-dependent perturbation
! UserP, UserT          : User-defined Temperatures and Pressure
!
! nTPert
! ======
!
! MCKINT or rdinp
!
! Bit 1 Singlet(0)/Triplet(1) operator
! Bit 2 One electron contribution to perturbation (1=true)
! Bit 3 Two electron contribution to perturbation (1=true)
! Bit 4 Connection contribution to perturbation (1=true)
! Bit 5 McKinley(1) Seward(0)

use Molcas, only: LenIn, MxAtom, MxRoot, MxSym
use RASDim, only: MxTit
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: itociph = 64, mxPer = 255

integer(kind=iwp) :: iaddressQDAT, iBreak, iMethod, iPt2, iRoot(mxRoot), iSpin, ispop, iToc(itociph), kprint, lRoots, &
                     LuAChoVec(8), LuChoInt(2), LuIChoVec(8), mTit, nActEl, nAsh(mxSym), nAtoms, nBas(mxSym), nConf, nCSF(8), &
                     nDel(mxSym), nDisp, nElec3, nFro(mxSym), nHole1, NIRREP, nIsh(mxSym), niter, nOrb(mxSym), nRoots, &
                     nRs1(mxSym), nRs2(mxSym), nRs3(mxSym), nSkip(mxSym), nsRot, nSym, ntAsh, ntAsqr, ntAtri, ntBas, ntBsqr, &
                     ntBtri, ntIsh, ntIsqr, ntItri, nTPert(mxPer), nUserPT, State_Sym
real(kind=wp) :: Coor(3,MxAtom), Eps, ERASSCF(mxroot), ESCF, Omega, PotNuc, rin_ene, UserP, UserT(64), Weight(mxroot)
logical(kind=iwp) :: CASINT, debug, double, fail, iMCPD, iMSPD, lCalc(3*MxAtom+3), McKinley, newCho, page, PT2, RASSI, lSave, &
                     SPINPOL, Timedep, TwoStep
character(len=LenIn) :: AtLbl(MxAtom)
character(len=72) :: Header1I(2), HeaderJP(2), TitleJp(mxTit)
character(len=16) :: Perturbation
character(len=8) :: TitleIN(180)
character(len=4) :: StepType
character(len=3) :: chirr(8)

public :: AtLbl, CASINT, chirr, Coor, debug, double, Eps, ERASSCF, ESCF, fail, Header1I, HeaderJP, iaddressQDAT, iBreak, iMCPD, &
          iMethod, iMSPD, iPt2, iRoot, iSpin, ispop, iToc, itociph, kprint, lCalc, lRoots, LuAChoVec, LuChoInt, LuIChoVec, &
          McKinley, mTit, nActEl, nAsh, nAtoms, nBas, nConf, nCSF, nDel, nDisp, nElec3, newCho, nFro, nHole1, NIRREP, nIsh, niter, &
          nOrb, nRoots, nRs1, nRs2, nRs3, nSkip, nsRot, nSym, ntAsh, ntAsqr, ntAtri, ntBas, ntBsqr, ntBtri, ntIsh, ntIsqr, ntItri, &
          nTPert, nUserPT, Omega, page, Perturbation, PotNuc, PT2, RASSI, rin_ene, lSave, SPINPOL, State_Sym, StepType, Timedep, &
          TitleIN, TitleJp, TwoStep, UserP, UserT, Weight

end module Input_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PolScf(iDist,iDistIm,iDT,iFI,iFP,iFil,iCStart
     &                 ,iTri,VMat,Smat,DiFac,Ract,icnum,Energy
     &                 ,NVarv,iMOC,Haveri,iQ_Atoms,ip_ExpVal,Poli)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "qm1.fh"
#include "numbers.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension Poli(MxQCen,10),VMat(MxOT),FFp(nPol*nPart,3)
      Dimension VpolMat(MxOT),Smat(MxOT),RoMat(MxOT)
      Dimension EEigen(MxOrb)
      Dimension iDT(3),iFI(3),iFP(3),iFil(MxQCen,10)
      Logical JaNej,Haveri

*
*-- Allocate and initialize the eigenvector matrix with the unit matrix.
*
      iOrba=iOrb(1)
      Call GetMem('Coeff','Allo','Real',iMOC,iOrba**2)
      call dcopy_(iOrba**2,[ZERO],iZERO,Work(iMOC),iONE)
      call dcopy_(iOrba,[ONE],iZERO,Work(iMOC),iOrba+1)

*
*-- Define some numbers.
*
      nQMCent=(iQ_Atoms*(iQ_Atoms+1))/2
      nPolCent=nPart*nPol
      Rinv=1.0d0/Ract
      R2inv=Rinv**2
      PolFac=DiFac/Ract**3
      Egun=0.0d0

*
*-- Compute some distances needed for the polarization. See polras for
*   some additional information on this.
*
      Call Memory_PolPrep('Allo',ixx,iyy,izz,irr3,ixxi,iyyi,izzi
     &                   ,iGri,nPol,nPart)
      Call PolPrep(iDist,iDistIM,Work(ixx),Work(iyy),Work(izz)
     &            ,Work(irr3),Work(ixxi),Work(iyyi),Work(izzi)
     &            ,Work(iGri),iCNum,nPolCent)

*
*-- Polarization loop commencing.
*
      NVarv=0
7912  Continue
      NVarv=NVarv+1
      Energy=0.0d0
      Call PolSolv(iDT,iFI,iFP,Work(ixx),Work(iyy),Work(izz),Work(irr3)
     &            ,Work(ixxi),Work(iyyi),Work(izzi),Work(iGri),FFp
     &            ,iCNum,r2Inv,DiFac,nPolCent)
      Call Densi_MO(Romat,Work(iMOC),1,iOcc1,iOrb(1),iOrb(1))
      If(Mp2DensCorr) Call DCorrCorr(Romat,DenCorrD,Trace_MP2
     &                              ,iOrb(1),iOcc1)
      Call Polink(Energy,iCall,nPolCent,nQMCent,iFil,VpolMat,FFp
     &          ,PolFac,Poli,iCstart,iTri,iQ_Atoms,qTot,ChaNuc,xyzMyQ
     &          ,xyzMyI,xyzMyP,Romat,xyzQuQ,CT)

*
*-- Construct the Fock-matrix from two-electron super-matrix and
*   one-electron matrix, with solvent perturbations added.
*
      Do 801, i=1,iTri
        FockM(i)=0.0d0
        Do 802, j=1,iTri
          FockM(i)=FockM(i)+RoMat(j)*Work(iSupM+iTri*(i-1)+j-1)
802     Continue
        OneEl=HHmat(i)+Vmat(i)+VpolMat(i)+Smat(i)
        FockM(i)=FockM(i)+OneEl
*---- See Szabo-Ostlund eq. 3.184.
        Energy=Energy+(FockM(i)+OneEl)*RoMat(i)
801   Continue
*-- Add potential-nuclear energy.
      Energy=Potnuc+Energy*0.5

*
*-- If energy is strange, scream!
*
      If(Energy.gt.0) then
        Write(6,*)
        Write(6,*)'  SCF energy is positive. Serious error somewhere.'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif

*
*-- Diagonalize the Fock-matrix. Eigenvalues are sorted.
*
      Call GetMem('Scratch','Allo','Real',iScratch,iOrba**2)
      Call Diag_Driver('V','A','L',iOrba,FockM,Work(iScratch)
     &                ,iOrba,Dummy,Dummy,iDum,iDum,EEigen,Work(iMOC)
     &                ,iOrba,1,-1,'J',nFound,iErr)
      Call GetMem('Scratch','Free','Real',iScratch,iOrba**2)

*
*-- Check if polarization loop has converged.
*
      Call HaveWeConv(iCNum,iCStart,iQ_Atoms,nPolCent,iDT,FFp,xyzMyI
     &               ,Egun,Energy,NVarv,JaNej,Haveri)
      If(Haveri) GoTo 8108
      If(.not.JaNej) GoTo 7912

8108  Continue

*
*-- Deallocate.
*
      Call Memory_PolPrep('Free',ixx,iyy,izz,irr3,ixxi,iyyi,izzi,iGri
     &                   ,nPol,nPart)

*
*-- If expectation values are extracted, make a detour.
*
      If(lExtr(6))Call Expectus('SCF  ',HHmat,Vmat,VpolMat,Smat
     &                         ,MxOT,iMOC,iOrba,.false.,iOcc1
     &                         ,ip_ExpVal)

*
*-- The end is near, hold me!
*

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GF_on_the_Fly(iDo_dDipM)
      use Symmetry_Info, only: nIrrep
      use Slapaf_Info, only:  Coor
      use Slapaf_Parameters, only: nDimBC, mTROld
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 DipM(3)
      Integer mDisp(8)
      Real*8, Allocatable:: EVec(:), EVal(:), RedMas(:), dDipM(:),
     &                      IRInt(:), Temp(:), NMod(:)
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      lUt=6
*
      nX=3*SIZE(Coor,2)
      nAtom=SIZE(Coor,2)
      nInter=nDimBC-mTROld
      mTR=mTROld
      nDoF=nDimBC
*
      Call mma_allocate(EVec,2*nX**2,Label='EVec')
      Call mma_allocate(EVal,2*nX,Label='EVal')
      Call mma_allocate(RedMas,nX,Label='RedMas')
      Call mma_allocate(dDipM,3*nDoF,Label='dDipM')
      dDipM(:)=Zero
*                                                                      *
************************************************************************
*                                                                      *
      DipM(:)=Zero
      Call GF(nX,nDoF,nInter,EVec,EVal,RedMas,iNeg,dDipM,mTR,nAtom,DipM)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('EVec',' ',EVec,2*nX,nX)
      Call RecPrt('EVal',' ',EVal,2,nX)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Write out frequencies and IR intensities
*
      Write (LUt,10)
      Write (LUt,10) ' Observe that the harmonic oscillator analysis'
     &             //' is only valid at stationary points!'
      Write (LUt,10)
      Write (LUt,10) ' Note that rotational and translational degrees'
     &             //' have been automatically removed,'
      Write (LUt,10) ' if the energy is invariant to these degrees'
     &             //' of freedom.'
      Write (LUt,10)
      Write (LUt,10)
      Write (LUt,10) ' Harmonic frequencies in cm-1'
      Write (LUt,10)
      If (iDo_dDipM.eq.1) Then
         Write (LUt,10) ' IR Intensities in km/mol'
         Write (LUt,10)
      End If
      Write (LUt,10) ' Normal modes in gf_on_the_fly.f '
10    Format(a)
*
      iOff=0
      iCtl=iDo_dDipM
      iEl =3
      jSym=1
*
      Call mma_allocate(Temp,3*nDoF,Label='Temp')
*
      Call DGeTMO(dDipM,3,3,nInter,Temp,nInter)
*
      Call mma_deallocate(dDipM)

      Call mma_allocate(IRInt,nDoF,Label='IRInt')
*
      Lu_10=10
      Lu_10=IsFreeUnit(Lu_10)
      Call Molcas_Open(lu_10,'UNSYM')
*
      Write(Lu_10,'(A,I1)') '*NORMAL MODES SYMMETRY: ',jsym
      Call GF_Print(EVal,EVec,Temp,iEl,nDoF,nInter,iCtl,IRInt,RedMas,
     &              Lu_10,iOff)
*
      Close(Lu_10)
      Call mma_deallocate(Temp)
*
      Call Add_Info('Approx. Freq.',EVal,nInter,1)
*                                                                      *
************************************************************************
*                                                                      *
*-----Save normal modes for later generation of Molden input.
*
      nDisp=nDoF
      Call mma_allocate(NMod,nDisp**2,Label='NMod')
*
      lModes=0
      nModes=0
      nX=nDoF
      call dcopy_(nX*nInter,EVec,2,NMod,1)
      lModes=lModes+nInter*nX
      nModes=nModes+nInter
#ifdef _DEBUGPRINT_
      Call RecPrt('NModes',' ',NMod,nX,nInter)
#endif
*
      If (nIrrep.eq.1) Then
         Call Print_Mode_Components(NMod,EVal,nModes,lModes,mDisp)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Write stuff on Molden input file
*
      mSym=1
      Call ICopy(8,[0],0,mDisp,1)
      mDisp(1)=nInter
      Call Freq_Molden(EVal,nModes,NMod,lModes,mSym,IRInt,mDisp,RedMas)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(NMod)
      Call mma_deallocate(IRInt)
      Call mma_deallocate(RedMas)
      Call mma_deallocate(EVal)
      Call mma_deallocate(EVec)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CSFDIM_GAS(IOCCLS,NOCCLS,ISYM,IPRCSF)
*
* Initializing routine for CSF-DET expansions
*
* information about the number of dets,csf's for
* each symmetry. CI space is defined by the NOCCLS
* occupation classes IOCCLS
*
*
* DETERMINE BASE ADRESSES
*             KDFTP : OPEN SHELL DETERMINANTS OF PROTO TYPE
*             KCFTP : BRANCHING DIAGRAMS FOR PROTO TYPES
*             KDTOC  : CSF-DET TRANSFORMATION FOR PROTO TYPES
*             KICONF_OCC(I) : SPACE FOR STORING  NCNSM
*                        CONFIGURATION EXPANSIONS
* Local memory requirements : IWORK(NACTOB)
*
* ( Spin signaled by PSSIGN in CIINFO)
*
* Adapted for GAS calculations and LUCIA, Dec. 2001

#include "implicit.fh"
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "cstate.fh"
#include "glbbas.fh"
#include "cgas.fh"
#include "spinfo_lucia.fh"
#include "warnings.h"
#include "gasstr.fh"
* Input type of occupation classes
      INTEGER IOCCLS(NGAS,*)
      INTEGER IDUM_ARR(1)
      INTEGER TMP_CNF(MXPORB+1),HEXS_CNF(MXPORB+1),
     &        maxingas(N_ELIMINATED_GAS)
*
      IDUM = 0
      IDUM_ARR=0
*
      NTEST = 00
      NTEST = MAX(IPRCSF,NTEST)
      IF(NTEST.GE.10) WRITE(6,*) '  PSSIGN : ', PSSIGN
      IF(NTEST.GE.10) WRITE(6,*) ' MULTS, MS2 = ', MULTS,MS2
      NELEC = IELSUM(IOCCLS(1,1),NGAS)
*
*.. Define parameters in SPINFO
*
*. Allowed number of open orbitals
      MINOP = ABS(MS2)
      CALL MAX_OPEN_ORB(MAXOP,IOCCLS,NGAS,NOCCLS,NOBPT)
      IF( NTEST .GE. 6 )
     &WRITE(6,*) ' MINOP MAXOP ',MINOP,MAXOP
C
C.. Number of prototype sd's and csf's per configuration prototype
C
           ITP = 0
      DO IOPEN = 0, MAXOP
        ITP = IOPEN + 1
*. Unpaired electrons :
        IAEL = (IOPEN + MS2 ) / 2
        IBEL = (IOPEN - MS2 ) / 2
        IF(IAEL+IBEL .EQ. IOPEN .AND. IAEL-IBEL .EQ. MS2 .AND.
     &            IAEL .GE. 0 .AND. IBEL .GE. 0) THEN
          IF(PSSIGN.EQ. 0.0D0 .OR. IOPEN .EQ. 0 ) THEN
*. Number of determinants is in general set to number of combinations
            NPDTCNF(ITP) = IBION_LUCIA(IOPEN,IAEL)
            NPCMCNF(ITP) = NPDTCNF(ITP)
          ELSE
            NPDTCNF(ITP) = IBION_LUCIA(IOPEN,IAEL)/2
            NPCMCNF(ITP) = NPDTCNF(ITP)
          END IF
          IF(IOPEN .GE. MULTS-1) THEN
            NPCSCNF(ITP) = IWEYLF(IOPEN,MULTS)
          ELSE
            NPCSCNF(ITP) = 0
          END IF
        ELSE
          NPDTCNF(ITP) = 0
          NPCMCNF(ITP) = 0
          NPCSCNF(ITP) = 0
        END IF
      END DO
*
      IF(NTEST.GE.5) THEN
      IF(PSSIGN .EQ. 0.0D0 ) THEN
        WRITE(6,*) '  (Combinations = Determinants ) '
      ELSE
        WRITE(6,*) '  (Spin combinations in use ) '
      END IF
      WRITE(6,'(/A)') ' Information about prototype configurations '
      WRITE(6,'( A)') ' ========================================== '
      WRITE(6,'(/A)')
     &'  Open orbitals   Combinations    CSFs '
      DO IOPEN = MINOP,MAXOP,2
        WRITE(6,'(5X,I3,10X,I6,7X,I6)')
     &  IOPEN,NPCMCNF(IOPEN+1),NPCSCNF(IOPEN+1)
      END DO
*
      END IF
C
C.. Number of Configurations per occupation type
C
      If (NOCCLS.gt.MXPCSM) Then
         WRITE(6,*)' A known bug has reoccurred -- It seems that'
         WRITE(6,*)' the named constant MXPCSM must be increased'
         WRITE(6,*)' from its current value MXPCSM=',MXPCSM
         WRITE(6,*)' to AT LEAST NOCCLS=',NOCCLS
         WRITE(6,*)' This parameter is found in the file'
         WRITE(6,*)'  <molcas>/src/lucia_util/mxpdim.fh'
         WRITE(6,*)' Change it. Then ''cd'' to molcas root'
         WRITE(6,*)' directory and give command ''make''.'
         WRITE(6,*)' But this may also be a bug. Please tell the'
         WRITE(6,*)' molcas developers!'
         Call Quit(_RC_INTERNAL_ERROR_)
      End If
*MGD : max occupation in removed GAS spaces
      Do i=1,N_ELIMINATED_GAS
        iGAS=IELIMINATED_IN_GAS(i)
        maxingas(i)=0
        DO JOCCLS = 1, NOCCLS
          maxingas(i)=max(IOCCLS(iGAS,JOCCLS),maxingas(i))
        End Do
      End Do
      Do i=1,maxop+1
        HEXS_CNF(i)=0
        NCONF_PER_OPEN(i,ISYM)=0
      End Do

*
      DO JOCCLS = 1, NOCCLS
        IF(JOCCLS.EQ.1) THEN
          INITIALIZE_CONF_COUNTERS = 1
        ELSE
          INITIALIZE_CONF_COUNTERS = 0
        END IF
*
        IDOREO = 0
        IF(JOCCLS.EQ.1) THEN
          NCONF_ALL_SYM_PREV = 0
        ELSE
          NCONF_ALL_SYM_PREV = NCONF_ALL_SYM
        END IF
        Do i=1,maxop+1
          TMP_CNF(i)=0
        End Do
        CALL GEN_CONF_FOR_OCCLS(IOCCLS(1,JOCCLS),
     &                             IDUM,
     &                          INITIALIZE_CONF_COUNTERS,
     &                             NGAS,   ISYM,  MINOP,  MAXOP,  NSMST,
     &                                1,
*
     &                            NOCOB,
     &                            NOBPT,
     &                          TMP_CNF,
     &                          NCONF_OCCLS,
     &                          IB_CONF_REO,
*
     &                          IB_CONF_OCC,
     &                          IDUM_ARR,IDOREO,IDUM_ARR,NCONF_ALL_SYM,
     &                          idum_arr,
     &                          nconf_tot)
         Do i=1,maxop+1
           NCONF_PER_OPEN(i,ISYM)=NCONF_PER_OPEN(i,ISYM)+TMP_CNF(i)
         End Do
*MGD add to hexs_cnf only if the configuration does not have max occupation
* in the selected GAS space
         If (N_ELIMINATED_GAS.gt.0) Then
           ielim=0
           Do j=1,N_ELIMINATED_GAS
             jGAS=IELIMINATED_IN_GAS(j)
             If (IOCCLS(jGAS,JOCCLS).eq.maxingas(j)) ielim=1
             IF(I_ELIMINATE_GAS.GT.1) THEN
               If (IOCCLS(jGAS,JOCCLS).eq.maxingas(j)-1) ielim=1
             END IF
           End Do
           If (ielim.eq.0) Then
             Do i=1,maxop+1
               HEXS_CNF(i)=HEXS_CNF(i)+TMP_CNF(i)
             End Do
           EndIf
         EndIf
c.. testing
c      write(6,*)'nconf_per_open after first call of gen_conf_for_occls'
c      call iwrtma(nconf_per_open,1,4,1,4)
c
*. NCONF_ALL_SYM is accumulated, so
           IF(JOCCLS.EQ.1) THEN
             NCONF_ALL_SYM_FOR_OCCLS(JOCCLS) = NCONF_ALL_SYM
             IBCONF_ALL_SYM_FOR_OCCLS(JOCCLS) = 1
           ELSE
* PAM2009: It was discovered that these two arrays could be overrun.
* The arrays are declared in spinfo_lucia.fh, and their dimension
* is MXPCSM, which is set in mxpdim.fh -- both included above.
* So MXPCSM is now increased from 20 to 40 -- if this is not a final
* solution remains to be discovered:
             NCONF_ALL_SYM_FOR_OCCLS(JOCCLS) = NCONF_ALL_SYM
     &   -   NCONF_ALL_SYM_PREV
*
             IBCONF_ALL_SYM_FOR_OCCLS(JOCCLS) =
     &       IBCONF_ALL_SYM_FOR_OCCLS(JOCCLS-1)
     &   +    NCONF_ALL_SYM_FOR_OCCLS(JOCCLS-1)

          END IF
      END DO
*. Number of CSF's in expansion
      CALL NCNF_TO_NCOMP(MAXOP,NCONF_PER_OPEN(1,ISYM),NPCSCNF,
     &                   NCSF)
*. Number of SD's in expansion
      CALL NCNF_TO_NCOMP(MAXOP,NCONF_PER_OPEN(1,ISYM),NPDTCNF,
     &                    NSD)
*. Number of combinations in expansion
      CALL NCNF_TO_NCOMP(MAXOP,NCONF_PER_OPEN(1,ISYM),NPCMCNF,
     &                    NCMB)
*MGD
      nCSF_HEXS=0
      If (N_ELIMINATED_GAS.gt.0) Then
        CALL NCNF_TO_NCOMP(MAXOP,HEXS_CNF,NPCSCNF,
     &                   NCSF_HEXS)
      EndIf
*
      NCSF_PER_SYM(ISYM) = NCSF
      NSD_PER_SYM(ISYM) = NSD
      NCONF_PER_SYM(ISYM) = IELSUM(NCONF_PER_OPEN(1,ISYM),MAXOP+1)
      IF(NTEST.GE.5) THEN
        WRITE(6,*) ' Number of CSFs  ', NCSF
        WRITE(6,*) ' Number of SDs   ', NSD
        WRITE(6,*) ' Number of Confs ', NCONF_PER_SYM(ISYM)
        WRITE(6,*) ' Number of CMBs  ', NCMB
      END IF
C
*. Total number of configurations and length of configuration list
C     INFO_CONF_LIST(NCONF_PER_OPEN,MAXOP,NEL,
C    &                          LENGTH_LIST,NCONF_TOT,IB_REO,IB_OCC)
      CALL INFO_CONF_LIST(NCONF_PER_OPEN(1,ISYM),
     &                    MAXOP,NELEC,LENGTH_LIST,NCONF_TOT,IB_CONF_REO,
     &                    IB_CONF_OCC)
C.. Permanent and local memory for csf routines
C
C    memory for CSDTMT arrays.
C    Largest block of proto type combinations .
C    Largest number of prototype csf's
C
      LIDT = 0
      LICS = 0
      LDTOC = 0
      MXPTBL = 0
      MXDT = 0
      LCONF = 0
      DO IOPEN = 0, MAXOP
        ITP = IOPEN + 1
        LIDT = LIDT + NPCMCNF(ITP) * IOPEN
        LICS = LICS + NPCSCNF(ITP) * IOPEN
        LDTOC= LDTOC + NPCSCNF(ITP)*NPCMCNF(ITP)
        MXDT =   MAX(MXDT,NPCMCNF(ITP) )
        MXPTBL = MAX(NPCMCNF(ITP)*IOPEN,MXPTBL)
      END DO
C. Memory needed to store ICONF array
      LCONF = 0
      ILCNF = 0
*
C     LDET = NSD
      LLCONF = 0
      ILLCNF = 0
      DO IOPEN = 0, MAXOP
        ITYP = IOPEN + 1
        ICL = ( NELEC-IOPEN)/2
        LLCONF = LLCONF + NCONF_PER_OPEN(ITYP,ISYM)*(IOPEN+ICL)
        ILLCNF = ILLCNF + NCONF_PER_OPEN(ITYP,ISYM)
      END DO
C?    WRITE(6,*) ' MEMORY FOR HOLDING CONFS OF SYM... ',ISYM,LLCONF
      LCONF = MAX(LCONF,LLCONF)
      ILCNF = MAX(ILCNF,ILLCNF)
*
       IF(NTEST.GE.5) THEN
       WRITE(6,'(/A,I8)')
     & '  Memory for holding list of configurations ',LCONF
       WRITE(6,'(/A,I8)')
     & '  Size of CI expansion (combinations)',NSD
       WRITE(6,'(/A,I8)')
     & '  Size of CI expansion (confs)',ILCNF
       END IF
C
C. permanent memory for csf proto type arrays
C
      CALL GETMEM('DFTP  ','ALLO','INTE',KDFTP,LIDT)
      CALL GETMEM('CFTP  ','ALLO','INTE',KCFTP,LICS)
      CALL GETMEM('D_TO_C','ALLO','REAL',KDTOC,LDTOC)
C     CALL MEMADD(KDFTP,LIDT,KFREE,1)
C     CALL MEMADD(KCFTP,LICS,KFREE,1)
C     CALL MEMADD(KDTOC,LDTOC,KFREE,2)
      IF( NTEST .GE.6 ) THEN
        WRITE(6,*) ' MEMORY ALLOCATION IN CSFDIM : '
        WRITE(6,*) ' POINTERS FOR PROTOTYPE INFORMATION '
        WRITE(6,'(A,3I7)') ' KDFTP KCFTP KDTOC ',KDFTP,KCFTP,KDTOC
      END IF
C
C. PERMANENT ARRAYS FOR
C. HOLDING CONFIGURATION EXPANSIONS AND REORDER ARRAYS
C
*. Occupation of configurations
      CALL GETMEM('CNFOCC','ALLO','INTE',KICONF_OCC(ISYM),LCONF)
*. Reorder array for configurations
c     CALL MEMMAN(KICONF_REO(ISYM),NCONF_ALL_SYM,'ADDL  ',1,'CNFREO')
      CALL GETMEM('CNFREO','ALLO','INTE',KICONF_REO(ISYM),NCONF_TOT)
*. Reorder array for determinants, index and sign
      CALL GETMEM('SDREOI','ALLO','INTE',KSDREO_I(ISYM),NSD)
*. Sign array is kept real for compatibility
c.. Giovanni and Dongxia decided to delete 'SDREOS' array since it is not used
c     CALL MEMMAN(KSDREO_S(ISYM),NSD,'ADDL  ',1,'SDREOS')
c..
COLD  CALL MEMADD(KICONF(ICNSM),LCONF,KFREE,1)
COLD  CALL MEMADD(KICTS(ICNSM),LDET ,KFREE,1)
COLD  CALL MEMADD(KSCTS(ICNSM),LDET ,KFREE,2)
c     write(6,*)'check me!! dimensions:'
c     write(6,*)'nconf_all_sym =',nconf_all_sym
c     write(6,*)'nconf_tot =', nconf_tot
C
c     ntest=10
      IF( NTEST .GE. 6 ) THEN
        WRITE(6,*) ' KICONF_OCC,  kiconf_reo = ',
     &  KICONF_OCC(ISYM), kiconf_reo(isym)
        WRITE(6,*) ' KSDREO_I',KSDREO_I(ISYM)
      END IF
*
* Arrays for addressing prototype determinants for each number of orbitals
*
      DO IOPEN = MINOP, MAXOP
        ITYP = IOPEN + 1
*
        IALPHA = (IOPEN+MS2)/2
        LZ = IOPEN*IALPHA
        LPTDT = IBION_LUCIA(IOPEN,IALPHA)
        CALL GETMEM('Z_PTDT','ALLO','INTE',KZ_PTDT(ITYP),LZ)
        CALL GETMEM('RE_PTD','ALLO','INTE',KREO_PTDT(ITYP),LPTDT)
      END DO
*
* Array giving first determinant with given number of electrons
* in list of determinants ordered  according to the number of open orbitals
*
      IZERO = 0
      CALL ISETVC(IB_SD_FOR_OPEN,IZERO,MAXOP+1)
      IB = 1
      DO IOPEN = MINOP, MAXOP
        IB_SD_FOR_OPEN(IOPEN+1) = IB
        IF(MOD(IOPEN-MS2,2).EQ.0) THEN
          IB = IB + NCONF_PER_OPEN(IOPEN+1,ISYM)*NPCMCNF(IOPEN+1)
        END IF
      END DO
*
      RETURN
      END

      SUBROUTINE CSFDIM_FREE(ISYM)
* Free resources allocated by CSFDIM_GAS

#include "implicit.fh"
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "cstate.fh"
#include "glbbas.fh"
#include "cgas.fh"
#include "spinfo_lucia.fh"
#include "warnings.h"

      DO IOPEN = MINOP, MAXOP
        ITYP = IOPEN + 1
*
        IALPHA = (IOPEN+MS2)/2
        LZ = IOPEN*IALPHA
        LPTDT = IBION_LUCIA(IOPEN,IALPHA)
        CALL GETMEM('Z_PTDT','FREE','INTE',KZ_PTDT(ITYP),LZ)
        CALL GETMEM('RE_PTD','FREE','INTE',KREO_PTDT(ITYP),LPTDT)
      END DO

c     LDET = NSD_PER_SYM(ISYM)
c     LCONF = 0
c     LLCONF = 0
c     DO IOPEN = 0, MAXOP
c       ITYP = IOPEN + 1
* FIXME: NELEC is undefined
c       ICL = ( NELEC-IOPEN)/2
c       LLCONF = LLCONF + NCONF_PER_OPEN(ITYP,ISYM)*(IOPEN+ICL)
c     END DO
c     LCONF = MAX(LCONF,LLCONF)

      CALL GETMEM('DFTP  ','FREE','INTE',KDFTP,LIDT)
      CALL GETMEM('CFTP  ','FREE','INTE',KCFTP,LICS)
      CALL GETMEM('D_TO_C','FREE','REAL',KDTOC,LDTOC)

      CALL GETMEM('CNFOCC','FREE','INTE',KICONF_OCC(ISYM),LCONF)
      CALL GETMEM('CNFREO','FREE','INTE',KICONF_REO(ISYM),NCONF_TOT)
      CALL GETMEM('SDREOI','FREE','INTE',KSDREO_I(ISYM),LDET)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Bingbing Suo                                     *
************************************************************************
C 04 Jul 2008 -BSUO- generalized davidson diagnolization routines
      subroutine gdavdiag(istate,mtidx,veistate)
#include "drt_h.fh"
      parameter (maxdimlu=1000,maxdimgit=10000)

c compute (h00-rouk)-1, and save the low triagular part of the
c inverse matrix at value_tmp(1:lent1-1)
      call cimtinverse(ndimt,veistate)

c h00 (h00-rouk)-1 * vector1(1:ndim)

      lent0=1
      lent1=maxdimlu*maxdimlu
      lent2=lent1+ndimt
      value_lpext(lent1+1:lent2)=vector1(mtidx+1:mtidx+ndimt)
c subroutine dsymv in blas is used
c      call dsymv('l',ndimt,1.0,ndimt,value_lpext(1),1,
c     *           vector1(mtidx+1),1)
      call matmultv(value_lpext,ndimt,maxdimlu,
     *              value_lpext(lent1+1:lent1+ndimt),
     *              vector1(mtidx+1:ndimt))
c   from h00+1 to nci_dim
      do l=ndimt+1,nci_dim
         depff=vector2(l)-veistate
c               if(abs(depff).le.depc) depff=depc
         vector1(mtidx+l)=vector1(mtidx+l)/depff
      enddo

c Avoid unused argument warnings
      if (.false.) call Unused_integer(istate)
      end

      subroutine matmultv(a,n,np,x,y)
c matrix a(n,n), vector x(n),y(n)
c ax=y
      implicit real*8 (a-h,o-z)
      dimension a(np,np),x(n),y(n)

      y(1:n)=0.d0
      do i=1,n
        do j=1,n
          y(i)=y(i)+a(i,j)*x(j)
        enddo
      enddo

      return
c...end of matmulv
      end

      subroutine cimtinverse(ndimt,vrouk)
#include "drt_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      character*256 filename

      parameter (maxdimlu=1000,maxdimgit=10000)

c      is=1
c      if(is.eq.1) then
c v'-v space is chosen as h0 part in gdvdd
c        ndimt=iw_sta(2,1)
c      else
c v'+d'+t'+s'-v space
c        ndimt=iw_sta(1,2)
c      endif

c      if(ndimt.le.maxdimlu) then
        filename=tmpdir(1:len_str)//"/fort.23"
        lent=len_str+8
!        write(6,*) "new diag"
!        stop 1999
!        open(nf23,file=filename(1:lent),form="unformatted")
!        read(nf23) ndimt,lent,value_lpext(1:lent)
!        close(nf23)
        neh0=maxdimlu*maxdimlu
        num=2*neh0+lent
        if(num.gt.max_tmpvalue) then
          write(6,*) "no enough scracht vectors, error 1000"
     *               ,num,max_tmpvalue,neh0,lent,ndimt
#ifdef MOLPRO
#else
      call abend()
#endif
#ifdef _XIANEST_
#endif
!         call abend
!          stop 1000
        endif
        value_lpext(2*neh0+1:2*neh0+lent)=value_lpext(1:lent)
        call matinverse(value_lpext,
     *                  value_lpext(neh0+1:neh0+maxdimlu**2),ndimt,
     *                  maxdimlu,value_lpext(2*neh0+1:2*neh0+lent),lent,
     *                  vrouk)
c      endif

c      stop 1000
c the inverse matrix a is also a symmetric matrix,
c so we only need to keep the low triagular part of a.
c      call savelowtra(value_lpext(1),value_lpext(neh0+1),ndimt,
c     *                maxdimlu,neh0)
      value_lpext(1:neh0)=value_lpext(neh0+1:2*neh0)
      value_lpext(neh0+1:2*neh0)=0.d0
      return
      end

      subroutine matinverse(a,y,n,np,valvec,lent,vrouk)
      implicit real*8 (a-h,o-z)
      parameter (maxdimlu=1000,maxdimgit=10000)
      integer np, indx(n)
      dimension a(np,np),y(np,np),valvec(lent)
      parameter (zero=0.d0)
*i64  parameter (zero=0.e0)

      k=0
      do i=1,n
       do j=1,i-1
          k=k+1
          a(i,j)=valvec(k)
          a(j,i)=valvec(k)
        enddo
        k=k+1
        a(i,i)=valvec(k)-vrouk
      enddo
c      write(6,*) "ndim0 v-v,",np
c      do i=1,10
c        write(6,"(10(f12.6,1x))") a(i,1:10)
c      enddo
c      stop 888

!      temporay desiable next five line because these code is not used now
c      info = 0
c subroutine dgetrf in lapack is used
c      call dgetrf_lapack( n, n, a, n, indx, info )
c      info = 0
c      lwork = n*n
c subroutine dgetri in lapack is used
c      call dgetri_lapack( n, a, n, indx, y, lwork, info )

c      !y(1:np,1:np)=zero
c      !do i=1,n
c      !  y(i,i)=1.0
c      !enddo
c      !call ludcmp(a,n,np,indx,d)
c      !do i=1,n
c      !   call lubksb(a,n,np,indx,y(1,i))
c      !enddo

      return
      if (.false.) then
        call Unused_integer_array(indx)
        call Unused_real_array(y)
      endif
      end

      subroutine savelowtra(varry,a,ndimt,maxdimlu,neh0)
      implicit real*8 (a-h,o-z)
      dimension varry(neh0),a(maxdimlu,maxdimlu)
      parameter (dzero=0.d0)
*i64  parameter (dzero=0.e0)

      varry(1:neh0)=dzero
      k=0
      do i=1,ndimt
        do j=1,i-1
          k=k+1
          varry(k)=a(i,j)
        enddo
        k=k+1
        varry(k)=a(i,i)
      enddo

      return
c...end of savelowtra
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C
      FUNCTION IPHASE(IDRT,IUP,IWALK)
C
C     PURPOSE: THE SYMMETRIC GROUP APPROACH AND THE UNITARY GROUP
C              APPROACH DIFFER IN THE PHASE CONVETION. FIND THE
C              PHASE FACTOR RELATING THE CSFS IN EITHER BASIS.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "gugx.fh"
C
      DIMENSION IDRT(NVERT,5),IUP(NVERT,0:3),IWALK(NLEV)
C
C     FIND THE MIDVERTEX AND THE COMBINED WALK SYMMETRY
C
      IPHASE=1
      IVERT=NVERT
      DO 100 LEV=1,NLEV
        ICASE=IWALK(LEV)
        IVERT=IUP(IVERT,ICASE)
        IF( ICASE.EQ.2 .OR. ICASE.EQ.3 ) THEN
          ISIGN=(-1)**IDRT(IVERT,4)
          IPHASE=IPHASE*ISIGN
        ENDIF
100   CONTINUE
C
C     EXIT
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_DBGINT_A()
!
! Purpose: regenerate and check all integrals (or the number
!          of columns specified in input).
!
! NOTE: this is *not* meant for production calculations, only for
!       debugging, as:
!       1) full Cholesky vectors are read
!       2) calculations are performed in full (no use of red. sets
!          apart from first)
!       3) full integral symmetry not used
!          (only partial particle permutation symmetry)

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use Cholesky, only: IFCSEW, iSP2F, LuPri, MX2SH, NBAS, nBstSh, nCol_chk, nnShl, nSym
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ISAB1, ISAB2, ISCD1, ISCD2, ISHLA, ISHLAB, ISHLB, ISHLC, ISHLCD, ISHLD, ISYM, ISYMA, ISYMB, LINT1, LINTMX, &
                     LWRK, NCMP, NUMAB, NUMCD
real(kind=wp) :: ERRMAX, ERRMIN, ERRRMS, GLMAX, GLMIN, GLRMS, RMS, XLBAS(8), XNINT, XPECT, XPECTL, XTCMP, XXLBST
real(kind=wp), allocatable :: Int1(:), Wrk(:)
character(len=*), parameter :: SECNAM = 'CHO_MCA_DBGINT_A'

! Force computation of full shell quadruple.
! ------------------------------------------

if (IFCSEW /= 1) then
  write(LUPRI,*) SECNAM,': WARNING: resetting IFCSEW from ',IFCSEW,' to 1.'
  write(LUPRI,*) SECNAM,': memory demands are significantly increased by this!'
  IFCSEW = 1
end if

! Initializations.
! ----------------

GLMAX = Zero
GLMIN = 1.0e15_wp
GLRMS = Zero
XTCMP = Zero
XPECT = Zero

! Make first reduced set the current reduced set.
! -----------------------------------------------

call CHO_RSCOPY(1,2)

! Allocate memory for largest integral quadruple.
! -----------------------------------------------

LINTMX = MX2SH*MX2SH
call mma_allocate(INT1,LINTMX,Label='INT1')

! Allocate max. memory.
! ---------------------

call mma_maxDBLE(LWRK)
call mma_allocate(WRK,LWRK/2,Label='WRK')
call XSETMEM_INTS(LWRK/2)

! Print header.
! -------------

call CHO_HEAD('Integral Error Analysis','=',80,LUPRI)
write(LUPRI,'(/,A,/,A)') '    C     D     A     B   Abs. Min.    Abs. Max.      RMS', &
                         '--------------------------------------------------------------'

! Loop over shell quadruples.
! ---------------------------

ISAB1 = 1
if (NCOL_CHK > 0) then
  ISAB2 = min(NCOL_CHK,NNSHL)
else
  ISAB2 = NNSHL
end if

do ISHLAB=ISAB1,ISAB2

  call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)
  if (ISHLB == ISHLA) then
    NUMAB = nTri_Elem(NBSTSH(ISHLA))
  else
    NUMAB = NBSTSH(ISHLA)*NBSTSH(ISHLB)
  end if

  if (NCOL_CHK > 0) then
    ISCD1 = 1
    ISCD2 = NNSHL
  else
    ISCD1 = ISHLAB
    ISCD2 = NNSHL
  end if

  do ISHLCD=ISCD1,ISCD2

    call CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.true.)
    if (ISHLD == ISHLC) then
      NUMCD = nTri_Elem(NBSTSH(ISHLC))
    else
      NUMCD = NBSTSH(ISHLC)*NBSTSH(ISHLD)
    end if
    LINT1 = NUMCD*NUMAB ! actual space needed for (CD|AB)

    ! Compute expected number of comparisons.
    ! ---------------------------------------

    XPECTL = real(LINT1,kind=wp)
    XPECT = XPECT+XPECTL

    ! Calculate shell quadruple (CD|AB).
    ! ----------------------------------

    INT1(1:LINT1) = Zero
    call CHO_MCA_INT_1(ISHLCD,ISHLAB,INT1,LINT1,.false.)

    ! Calculate integrals from Cholesky vectors.
    ! ------------------------------------------

    call CHO_DBGINT_CHO(INT1,NUMCD,NUMAB,WRK,LWRK/2,ERRMAX,ERRMIN,ERRRMS,NCMP,ISHLCD,ISHLAB)

    ! Write report.
    ! -------------

    if (NCMP < 1) then
      write(LUPRI,'(4(I5,1X),5X,A)') ISHLC,ISHLD,ISHLA,ISHLB,' !!! nothing compared !!! '
    else
      RMS = sqrt(ERRRMS/real(NCMP,kind=wp))
      write(LUPRI,'(4(I5,1X),3(ES12.4,1X))') ISHLC,ISHLD,ISHLA,ISHLB,ERRMIN,ERRMAX,RMS
    end if

    if (abs(ERRMAX) > abs(GLMAX)) GLMAX = ERRMAX
    if (abs(ERRMIN) < abs(GLMIN)) GLMIN = ERRMIN
    GLRMS = GLRMS+ERRRMS
    if (NCMP > 0) XTCMP = XTCMP+real(NCMP,kind=wp)

  end do

end do

! Print end of table.
! -------------------

write(LUPRI,'(A)') '--------------------------------------------------------------'
if (XTCMP < One) then
  write(LUPRI,'(A,23X,A)') 'Total:',' !!! nothing compared !!! '
else
  GLRMS = sqrt(GLRMS/XTCMP)
  write(LUPRI,'(A,18X,3(ES12.4,1X))') 'Total:',GLMIN,GLMAX,GLRMS
end if
write(LUPRI,'(A)') '--------------------------------------------------------------'

! Release all memory allocated here (and release seward memory).
! --------------------------------------------------------------

call XRLSMEM_INTS()
call mma_deallocate(WRK)
call mma_deallocate(INT1)

! Check total number of comparisons.
! ----------------------------------

XLBAS(1:NSYM) = real(NBAS(1:NSYM),kind=wp)
XNINT = Zero
do ISYM=1,NSYM
  XXLBST = Zero
  do ISYMB=1,NSYM
    ISYMA = MUL(ISYMB,ISYM)
    if (ISYMA == ISYMB) then
      XXLBST = XXLBST+XLBAS(ISYMA)*(XLBAS(ISYMA)+One)*Half
    else if (ISYMA > ISYMB) then
      XXLBST = XXLBST+XLBAS(ISYMA)*XLBAS(ISYMB)
    end if
  end do
  XNINT = XNINT+XXLBST*(XXLBST+One)*Half
end do

if (abs(XTCMP-XPECT) > 1.0e-15_wp) then
  write(LUPRI,'(/,A)') 'WARNING: not all integrals checked:'
else
  write(LUPRI,*)
end if
write(LUPRI,'(A,ES20.10)') 'Total number of integral comparisons    :',XTCMP
write(LUPRI,'(A,ES20.10)') 'Total number expected (full shell pairs):',XPECT
write(LUPRI,'(A,ES20.10)') 'Total number of unique integrals        :',XNINT

end subroutine CHO_MCA_DBGINT_A

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               1991, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Drvh2(Hess,Temp,nHess,show)
************************************************************************
*                                                                      *
* Object: driver for computation of gradient with respect to the one-  *
*         electron hamiltonian and the overlap matrix. The former will *
*         be contracted with the "variational" first order density     *
*         matrix and the latter will be contracted with the generalized*
*         Fock matrix.                                                 *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
*             Anders Bernhardsson Dept. of Theoretical Chemistry,      *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      use Basis_Info, only: nCnttp, dbsc, nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External NaHss,OvrHss, KneHss,PrjHss,SROHss,M1Hss,PCMHss
      External NaMmH,OvrMmH, KneMmH,PrjMMH,sroMMH,M1MMH,PCMMMH
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "rctfld.fh"
      Character Label*80
      Real*8    Hess(nHess), Temp(nHess)
      Logical DiffOp,show, lECP
      Real*8, Allocatable:: Fock(:), D0(:)
*                                                                      *
************************************************************************
*                                                                      *
*     iRout = 131
*     iPrint = nPrint(iRout)
      iprint=0
      if (show) iPrint = 12
      Call CWTime(TCpu1,TWall1)
      Call StatusLine(' McKinley:',
     &                ' Computing 1-electron 2rd order derivatives')
*                                                                      *
************************************************************************
*                                                                      *
*     Get the variational density matrix and the occupied Fock matrix.
*
      nFock = 0
      nDens = 0
      Do 1 iIrrep = 0, nIrrep - 1
         nFock = nFock + nBas(iIrrep)*(nBas(iIrrep)+1)/2
         nDens = nDens + nBas(iIrrep)*(nBas(iIrrep)+1)/2
 1    Continue
*
*     Read the variational 1st order density matrix
*     density matrix in AO/SO basis
      Call mma_allocate(D0,nDens,Label='D0')
      Call Get_D1ao_Var(D0,nDens)
*     Read the generalized Fock matrix
*     Fock matrix in AO/SO basis
      Call mma_allocate(Fock,nFock,Label='Fock')
      Call Get_Fock_Occ(Fock,nFock)
*                                                                      *
************************************************************************
*                                                                      *
*...  Prologue
      nComp = 1
      Call GetMem('Coor','Allo','Real',ipC,3*nComp)
      Call GetMem('lOper','Allo','Inte',ip1,nComp)
      call dcopy_(nComp*3,[Zero],0,Work(ipC),1)
      iWork(ip1) = 1
************************************************************************
*1)                                                                    *
*     Trace the generalized Fock matrix with the gradient of the       *
*     overlap matrix.                                                  *
*                                                                      *
************************************************************************
*
      DiffOp = .False.
      call dcopy_(nHess,[Zero],0,Temp,1)
      Label  = ' The Renormalization Contribution'
      Call Dot1El(OvrHss,OvrMmH,Temp,nHess,DiffOp,Work(ipC),
     &           Fock,nFock,iWork(ip1),nComp,Label)
      If (show) write(6,*) label
      If (show) Call HssPrt(Hess,nHess)
      Call DaXpY_(nHess,-One,Temp,1,Hess,1)
*
************************************************************************
*2)                                                                    *
*     Trace the "variational" zero  order density matrix with the      *
*     gradient of the kinetic energy integrals.                        *
*                                                                      *
************************************************************************
*
      DiffOp = .False.
      call dcopy_(nHess,[Zero],0,Temp,1)
      Label  = ' The Kinetic Energy Contribution'
      Call Dot1El(KneHss,KneMmH,Temp,nHess,DiffOp,Work(ipC),
     &            D0,nFock,iWork(ip1),nComp,Label)
      If (show) write(6,*) label
      If (show) Call HssPrt(Temp,nHess)
      Call DaXpY_(nHess,-One,Temp,1,Hess,1)
*
************************************************************************
*3)                                                                    *
*     Trace the "variational" zero  order density matrix with the      *
*     gradient of the nuclear attraction integrals.                    *
*                                                                      *
************************************************************************
*
      DiffOp = .True.
      Label = ' The Nuclear Attraction Contribution'
      call dcopy_(nHess,[Zero],0,Temp,1)
      Call Dot1El(NAHss,NAMmH,Temp,nHess,DiffOp,Work(ipC),
     &            D0,nFock,iWork(ip1),nComp,Label)
      If (show) write(6,*) label
      if (show) Call HssPrt(Temp,nHess)
      Call DaXpY_(nHess,One,Temp,1,Hess,1)
*
************************************************************************
*3)                                                                    *
*     Trace the "variational" zero  order density matrix with the      *
*     gradient of the ECP integrals.                                   *
*                                                                      *
************************************************************************
*
      lECP = .False.
      DO i = 1, nCnttp
         lECP = lECP .or. dbsc(i)%ECP
      End Do
      If (lECP) Then
        DiffOp = .True.
        Label = ' The Projection (ECP) Contribution'
        call dcopy_(nHess,[Zero],0,Temp,1)
        Call Dot1El(PrjHss,PRJMMH,Temp,nHess,DiffOp,Work(ipC),
     &               D0,nFock,iWork(ip1),nComp,Label)
        If (show) write(6,*) label
        if (show) Call HssPrt(Temp,nHess)
        Call DaXpY_(nHess,One,Temp,1,Hess,1)
*
        DiffOp = .True.
        Label = ' The Spec. Res. (ECP) Contribution'
        call dcopy_(nHess,[Zero],0,Temp,1)
        Call Dot1El(SROHss,SROMMH,Temp,nHess,DiffOp,Work(ipC),
     &               D0,nFock,iWork(ip1),nComp,Label)
        if (show) Write(6,*) Label,'first part '
        if (show) Call HssPrt(Temp,nHess)
        Call DaXpY_(nHess,One,Temp,1,Hess,1)
*
        DiffOp = .True.
        Label = ' The M1 (ECP) Contribution'
        call dcopy_(nHess,[Zero],0,Temp,1)
        Call Dot1El(m1Hss,m1MMH,Temp,nHess,DiffOp,Work(ipC),
     &               D0,nFock,iWork(ip1),nComp,Label)
        if (show) Write(6,*) Label,'second part '
        if (show) Call HssPrt(Temp,nHess)
        Call DaXpY_(nHess,One,Temp,1,Hess,1)
      End If
*
************************************************************************
*4)                                                                    *
*     Trace the "variational" zero  order density matrix with the      *
*     gradient of the PCM integrals.                                   *
*                                                                      *
************************************************************************
*
      If (PCM) Then
        DiffOp = .True.
        Label = ' The PCM Contribution'
        call dcopy_(nHess,[Zero],0,Temp,1)
        Call Dot1El(PCMHss,PCMMMH,Temp,nHess,DiffOp,Work(ipC),
     &               D0,nFock,iWork(ip1),nComp,Label)
        If (show) write(6,*) label
        if (show) Call HssPrt(Temp,nHess)
        Call DaXpY_(nHess,One,Temp,1,Hess,1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Epilogue, end
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('lOper','Free','Inte',ip1,nComp)
      Call GetMem('Coor','Free','Real',ipC,3*nComp)
      Call mma_deallocate(Fock)
      Call mma_deallocate(D0)
      If (iprint.ge.12) Call HssPrt(Hess,nHess)
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu2,TWall2)
      Call SavTim(3,TCpu2-TCpu1,TWall2-TWall1)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GF_Mult(G,F,GF,nDoF)
      Implicit Real*8 (a-h,o-z)
      Real*8 G(nDoF**2),F(nDoF**2),GF(nDoF*(nDoF+1)/2)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*     Form the GF-matrix (actually G^(1/2)FG^(1/2))
*
      Do iX = 1, nDoF
         ii = (iX-1)*nDoF + iX
         XMass_i = Sqrt(G(ii))
         Do jX = 1, iX
            jj = (jX-1)*nDoF + jX
            XMass_j = Sqrt(G(jj))
            ij = (jX-1)*nDoF + iX
            ijT= iX*(iX-1)/2+jX
            GF(ijT) = XMass_i*XMass_j*F(ij)
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call TriPrt('G^(1/2)FG^(1/2)',' ',GF,nDoF)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995,2001, Roland Lindh                                *
*               2003, Michael Diedenhofen                              *
************************************************************************
      SubRoutine COSGrd(
#define _CALLING_
#include "grd_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of electronic COSMO cont. *
*         integrals.                                                   *
*                                                                      *
*             M. Diedenhofen Nov. 2003                                 *
*             changes pcmgrd routines which do not take into account   *
*             the contribution of a non fixed grid                     *
*     Author of orig routine: Roland Lindh,                            *
*             Dept. of Theoretical Chemistry, University               *
*             of Lund, Sweden, May '95                                 *
*                                                                      *
*             Modified to PCM gradients September 2001, Lund, by       *
*             R. Lindh.                                                *
************************************************************************
      use PCM_arrays, only: PCM_SQ, PCMTess
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
      External TNAI1, Fake, Cff2D
#include "Molcas.fh"
#include "real.fh"
#include "print.fh"
#include "disp.fh"
#include "rctfld.fh"

#include "grd_interface.fh"

*     Local variables
      Integer iDCRT(0:7)
      Real*8 C(3), TC(3), Coori(3,4), CoorAC(3,2)
      Logical NoLoop, JfGrad(3,4)
      Integer iAnga(4), iStb(0:7), JndGrd(3,4), lOp(4), iuvwx(4)
      Character ChOper(0:7)*3
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 151
      iPrint = nPrint(iRout)
*
      nRys=nHer
*
*---- Modify the density matrix with the prefactor
*
      nDAO = nElem(la) * nElem(lb)
      Do iDAO = 1, nDAO
         Do iZeta = 1, nZeta
            Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
            DAO(iZeta,iDAO) = Fact * DAO(iZeta,iDAO)
         End Do
      End Do
      If (iPrint.ge.99) Call RecPrt('DAO',' ',DAO,nZeta,nDAO)
*
      nip = 1
      ipA = nip
      nip = nip + nAlpha*nBeta
      ipB = nip
      nip = nip + nAlpha*nBeta
      ipDAO = nip
      nip = nip + nAlpha*nBeta*nElem(la)*nElem(lb)*nElem(nOrdOp)
      If (nip-1.gt.nZeta*nArr) Then
         Call WarningMessage(2,'Error in COSGrd')
         Write (6,*) 'nip-1.gt.nZeta*nArr'
         Call Abend()
      End If
      nArray = nZeta*nArr - nip + 1
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = nOrdOp
      iAnga(4) = 0
      call dcopy_(3, A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
*
*     Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
       call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
       call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      lOp(1) = kOp(1)
      lOp(2) = kOp(2)
*
      ipAOff = ipA
      Do iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
      End Do
*
      ipBOff = ipB
      Do iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
      End Do
*
      llOper = lOper(1)
*
*     Loop over the tiles
*
      Do iTs = 1, nTs
         Q=PCM_SQ(1,iTs)
         NoLoop = Q.eq.Zero
         If (NoLoop) Go To 111
*------- Pick up the tile coordinates
         C(1) = PCMTess(1,iTs)
         C(2) = PCMTess(2,iTs)
         C(3) = PCMTess(3,iTs)
         kat = nint(PCMTess(4,iTs))
         If (iPrint.ge.99) Call RecPrt('C',' ',C,3,1)
*
*------- Generate stabilizor of C
*
         nStb=1
         iStb(0)=0
*
*--------Find the DCR for M and S
*
         Call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
         Fact = -DBLE(nStabM) / DBLE(LmbdT)
*
         If (iPrint.ge.99) Then
            Write (6,*) ' Q=',Q
            Write (6,*) ' Fact=',Fact
            Call RecPrt('DAO*Fact*Q',' ',Array(ipDAO),nZeta*nDAO,
     &                   nElem(nOrdOp))
            Write (6,*) ' m      =',nStabM
            Write (6,'(9A)') '(M)=',(ChOper(iStabM(ii)),
     &            ii = 0, nStabM-1)
            Write (6,*) ' s      =',nStb
            Write (6,'(9A)') '(S)=',(ChOper(iStb(ii)),
     &            ii = 0, nStb-1)
            Write (6,*) ' LambdaT=',LmbdT
            Write (6,*) ' t      =',nDCRT
            Write (6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),
     &            ii = 0, nDCRT-1)
         End If
         iuvwx(3) = nStb
         iuvwx(4) = nStb

         Call ICopy(6,IndGrd,1,JndGrd,1)
         Do i = 1, 3
            Do j = 1, 2
               JfGrad(i,j) = IfGrad(i,j)
            End Do
         End Do
c        skip contributions if the segment belongs to the atom
         if(mdc.eq.kat) then
c             skip 1 center
              JfGrad(1,1) = .false.
              JfGrad(2,1) = .false.
              JfGrad(3,1) = .false.
         endif
         if(ndc.eq.kat) then
c             skip 2 center
              JfGrad(1,2) = .false.
              JfGrad(2,2) = .false.
              JfGrad(3,2) = .false.
         endif
*
*         set up third center
*
          iIrrep=0
          nDisp = IndDsp(kat,iIrrep)
          Do iCar = 0, 2
             nDisp = nDisp + 1
             JndGrd(iCar+1,1) = Abs(JndGrd(iCar+1,1))
             JndGrd(iCar+1,2) = Abs(JndGrd(iCar+1,2))
             JndGrd(iCar+1,3) = -nDisp
             JfGrad(iCar+1,3) = .False.
          enddo

         Call ICopy(3,[0],0,JndGrd(1,4),1)
         JfGrad(1,4) = .False.
         JfGrad(2,4) = .False.
         JfGrad(3,4) = .False.

         mGrad = 0
         Do iCar = 1, 3
            Do i = 1, 3
               If (JfGrad(iCar,i)) mGrad = mGrad + 1
            End Do
         End Do
         If (iPrint.ge.99) Write (6,*) ' mGrad=',mGrad
         If (mGrad.eq.0) Go To 111
*
         Do lDCRT = 0, nDCRT-1
            lOp(3) = NrOpr(iDCRT(lDCRT))
            lOp(4) = lOp(3)
            Call OA(iDCRT(lDCRT),C,TC)
            call dcopy_(3,TC,1,CoorAC(1,2),1)
            call dcopy_(3,TC,1,Coori(1,3),1)
            call dcopy_(3,TC,1,Coori(1,4),1)
*
            Call DYaX(nZeta*nDAO,Fact*Q,DAO,1,Array(ipDAO),1)
*
*           Compute integrals with the Rys quadrature.
*
            nT = nZeta
            nDiff=1
            mRys=nRys

            Call Rysg1(iAnga,mRys,nT,
     &                 Array(ipA),Array(ipB),[One],[One],
     &                 Zeta,ZInv,nZeta,
     &                 [One],[One],1,
     &                 P,nZeta,TC,1,Coori,Coori,CoorAC,
     &                 Array(nip),nArray,
     &                 TNAI1,Fake,Cff2D,
     &                 Array(ipDAO),nDAO*nElem(nOrdOp),
     &                 Grad,nGrad,JfGrad,JndGrd,lOp,iuvwx)
*
*           Call RecPrt(' In COSgrd:Grad',' ',Grad,nGrad,1)
         End Do  ! End loop over DCRs
*
111      Continue
      End Do     ! End loop over centers in the external field
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Final)
         Call Unused_real_array(Ccoor)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine cre_prep()

use rhodyn_data, only: flag_dyson, flag_so, lrootstot, maxlroots, maxnconf, N, nconftot, prep_ci, prep_csfsoi, prep_csfsor, &
                       prep_dipolei, prep_dipoler, prep_dm_i, prep_dm_r, prep_do, prep_fhi, prep_fhr, prep_hcsf, prep_id, &
                       prep_uci, prep_vcsfi, prep_vcsfr
use mh5, only: mh5_create_dset_real, mh5_create_file, mh5_init_attr

implicit none

! creating intermediate preparation file
prep_id = mh5_create_file('RDPREP')

call mh5_init_attr(prep_id,'MOLCAS_MODULE','RHODYN')

! CI coefficients
prep_ci = mh5_create_dset_real(prep_id,'CI_COEFF',3,[maxnconf,maxlroots,N])
call mh5_init_attr(prep_ci,'description','CI coefficients')

! SF hamiltonians
prep_hcsf = mh5_create_dset_real(prep_id,'SFS_HAM',3,[maxnconf,maxnconf,N])
call mh5_init_attr(prep_hcsf,'description','SF Hamiltonians')

! U_CI
prep_uci = mh5_create_dset_real(prep_id,'U_CI',2,[nconftot,lrootstot])
call mh5_init_attr(prep_uci,'description','trafo matrix accounting for spin-degeneracy')

! SO-Hamiltonian in CSF basis, V_CSF
if (flag_so) then
  prep_vcsfr = mh5_create_dset_real(prep_id,'V_CSF_R',2,[nconftot,nconftot])
  call mh5_init_attr(prep_vcsfr,'description','SO-Hamiltonian in CSF basis, real part')
  prep_vcsfi = mh5_create_dset_real(prep_id,'V_CSF_I',2,[nconftot,nconftot])
  call mh5_init_attr(prep_vcsfi,'description','SO-Hamiltonian in CSF basis, imaginary part')
end if

! Full Hamiltonian in CSF basis, HTOT_CSF
prep_fhr = mh5_create_dset_real(prep_id,'FULL_H_R',2,[nconftot,nconftot])
call mh5_init_attr(prep_fhr,'description','Hamiltonian in CSF basis, real part')
prep_fhi = mh5_create_dset_real(prep_id,'FULL_H_I',2,[nconftot,nconftot])
call mh5_init_attr(prep_fhi,'description','Hamiltonian in CSF basis, imaginary part')

! CSF2SO
if (flag_so) then
  prep_csfsor = mh5_create_dset_real(prep_id,'CSF2SO_R',2,[nconftot,lrootstot])
  call mh5_init_attr(prep_csfsor,'description','CSF2SO_R')
  prep_csfsoi = mh5_create_dset_real(prep_id,'CSF2SO_I',2,[nconftot,lrootstot])
  call mh5_init_attr(prep_csfsoi,'description','CSF2SO_I')
end if

! Dipole matrices
prep_dipoler = mh5_create_dset_real(prep_id,'DIP_MOM_R',3,[lrootstot,lrootstot,3])
call mh5_init_attr(prep_dipoler,'description','Dipole matrices, real part')
prep_dipolei = mh5_create_dset_real(prep_id,'DIP_MOM_I',3,[lrootstot,lrootstot,3])
call mh5_init_attr(prep_dipolei,'description','Dipole matrices, imaginary part')

! Initial density matrix in CSF basis
prep_dm_r = mh5_create_dset_real(prep_id,'DM0_R',2,[nconftot,nconftot])
call mh5_init_attr(prep_dm_r,'description','Initial density matrix, real part')
prep_dm_i = mh5_create_dset_real(prep_id,'DM0_I',2,[nconftot,nconftot])
call mh5_init_attr(prep_dm_i,'description','Initial density matrix, imaginary part')

! Dyson amplitudes matrix
if (flag_dyson) then
  prep_do = mh5_create_dset_real(prep_id,'DYSAMP',2,[lrootstot,lrootstot])
  call mh5_init_attr(prep_do,'description','Matrix of Dyson amplitudes in SF basis if number of spin manifolds >2, otw in SO')
end if

end subroutine cre_prep

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Readin_vb()
!***********************************************************************
!                                                                      *
!     Read the input                                                   *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use gas_data, only: IGSOCCX, NGAS, NGSSH
use rasscf_global, only: iRlxRoot, iROOT, iZROT, NAC, NACPAR, NACPR2, NIN, NO2M, NORBT, NROOTS, NSEC, NTIT, NTOT3, NTOT4, Title
use jobiph_j, only: ispin_j, lsym_j, nactel_j, ndel_j, nelec3_j, nfro_j, nhole1_j, nish_j, nrs1_j, nrs2_j, nrs3_j, title_j
use general_data, only: INVEC, ISPIN, NACTEL, NASH, NBAS, NDEL, NDELT, NELEC3, NFRO, NFROT, NHOLE1, NISH, NORB, NRS1, NRS1T, NRS2, &
                        NRS2T, NRS3, NRS3T, NSSH, NSYM, NTOT, NTOT1, NTOT2, NTOTSP, STSYM, STSYM
use Molcas, only: MxSym
use RASDim, only: MxTit
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IGAS, II, ISYM, ITU, NAO, NGSSH_HI, NGSSH_LO, NT, NU

!---  set INVEC -> get MOs from JOBIPH file ---------------------------*
INVEC = 3
!---  Initialize ------------------------------------------------------*
Title(:) = ' '

!---  Read input from standard input ----------------------------------*
!---  process TITLE    command ----------------------------------------*
ntit = 0
do ii=1,mxtit
  if (len_trim(title_j(ii)) > 0) then
    ntit = ntit+1
    title(ntit) = title_j(ii)
  end if
end do
!---  process NACT command --------------------------------------------*
nactel = nactel_j
nhole1 = nhole1_j
nelec3 = nelec3_j
!---  process SPIN command --------------------------------------------*
ispin = ispin_j
!---  process SYMM command --------------------------------------------*
stsym = lsym_j
!---  process FROZ command --------------------------------------------*
nfro(:) = nfro_j(:)
!---  process INAC command --------------------------------------------*
nish(:) = nish_j(:)
!---  process RAS1 command --------------------------------------------*
nrs1(:) = nrs1_j(:)
!---  process RAS2 command --------------------------------------------*
nrs2(:) = nrs2_j(:)
!---  process RAS3 command --------------------------------------------*
nrs3(:) = nrs3_j(:)
!---  process DELE command --------------------------------------------*
ndel(:) = ndel_j(:)

if ((nroots > 1) .and. (irlxroot == 0)) iRlxRoot = iroot(nroots)
if (nroots == 1) iRlxRoot = 0
!---  complete orbital specifications ---------------------------------*
NASH(1:mxsym) = NRS1(1:mxsym)+NRS2(1:mxsym)+NRS3(1:mxsym)
NORB(1:mxsym) = NBAS(1:mxsym)-NFRO(1:mxsym)-NDEL(1:mxsym)
NSSH(1:mxsym) = NORB(1:mxsym)-NISH(1:mxsym)-NASH(1:mxsym)

! SVC: convert CAS/RAS to general GAS description here, then we only
! need to copy it for lucia later, which always uses GAS description.
NGSSH(1,1:NSYM) = NRS1(1:NSYM)
NGSSH(2,1:NSYM) = NRS2(1:NSYM)
NGSSH(3,1:NSYM) = NRS3(1:NSYM)
IGSOCCX(1,1) = max(2*sum(NRS1(1:NSYM))-NHOLE1,0)
IGSOCCX(1,2) = 2*sum(NRS1(1:NSYM))
IGSOCCX(2,1) = NACTEL-NELEC3
IGSOCCX(2,2) = NACTEL
IGSOCCX(3,1) = NACTEL
IGSOCCX(3,2) = NACTEL

!---  Compute IZROT. IZROT is a matrix (lower triangular over the -----*
!     active space), which specifies which t,u rotations should be
!     avoided, since the orbitals belong to the same RAS space.
!     This is the only way the RAS concept is explicitly used in the
!     SX section of the program.
ITU = 0
do ISYM=1,mxsym
  NAO = NASH(ISYM)
  if (NAO > 1) then
    do NT=2,NAO
      do NU=1,NT-1
        ITU = ITU+1
        IZROT(ITU) = 0
        !SVC: check if NU<NT are included in the same gas space
        NGSSH_LO = 0
        do IGAS=1,NGAS
          NGSSH_HI = NGSSH_LO+NGSSH(IGAS,ISYM)
          if ((NU > NGSSH_LO) .and. (NT <= NGSSH_HI)) IZROT(ITU) = 1
          NGSSH_LO = NGSSH_HI
        end do
      end do
    end do
  end if
end do
!---  complete the input processing -----------------------------------*
NTOT = sum(NBAS(1:NSYM))
NTOT1 = sum(nTri_Elem(NBAS(1:NSYM)))
NTOT2 = sum(NBAS(1:NSYM)**2)
NO2M = maxval(NBAS(1:NSYM)**2)
NIN = sum(NISH(1:NSYM))
NAC = sum(NASH(1:NSYM))
NDELT = sum(NDEL(1:NSYM))
NFROT = sum(NFRO(1:NSYM))
NSEC = sum(NSSH(1:NSYM))
NORBT = sum(NORB(1:NSYM))
NTOT3 = sum(nTri_Elem(NORB(1:NSYM)))
NTOTSP = sum(nTri_Elem(NASH(1:NSYM)))
NTOT4 = sum(NORB(1:NSYM)**2)
NRS1T = sum(NRS1(1:NSYM))
NRS2T = sum(NRS2(1:NSYM))
NRS3T = sum(NRS3(1:NSYM))
NACPAR = nTri_Elem(NAC)
NACPR2 = nTri_Elem(NACPAR)

call Put_iArray('nIsh',nIsh,nSym)
call Put_iArray('nAsh',nAsh,nSym)

end subroutine Readin_vb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Diff_MotherGoose(Diffuse,nAt,nB,MP,nij,EC,ANr,Ttot,Ttot_Inv,lMax,TP,dLimmo,Thrs1,Thrs2,nThrs,iPrint,ThrsMul,LuYou)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: Diffuse(3)
integer(kind=iwp), intent(in) :: nAt, nB, nij, ANr(nAt), lMax, nThrs, iPrint, LuYou
real(kind=wp), intent(in) :: MP(nij,*), EC(3,nij), Ttot(nB,nB), Ttot_Inv(nB,nB), TP(nAt), dLimmo(2), Thrs1, Thrs2, ThrsMul
integer(kind=iwp) :: lMaxF
real(kind=wp), allocatable :: Pot_Expo(:), Pot_Fac(:), Pot_Point(:)
logical(kind=iwp), allocatable :: Diffed(:)

! Sag hej till publiken.

write(u6,'(A)') '  Enter Slater charge distribution section.'

! Take different route for the different methods for getting
! diffuse distributions.

call mma_allocate(Pot_Expo,nij*2,label='Pot_Expo')
call mma_allocate(Pot_Point,nij,label='Pot_Point')
call mma_allocate(Pot_Fac,nij*4,label='Pot_Fac')
call mma_allocate(Diffed,nij*2,label='Diffed')

if (Diffuse(2)) then
  write(u6,'(A)') '    ---Run a non-linear fit, (Levenberg-Marquart).'
  write(u6,'(A)') '        Thresholds'
  write(u6,991) '           Delta                   :',Thrs1
  write(u6,991) '           Lambda                  :',Thrs2
  write(u6,991) '           Factor                  :',ThrsMul
  write(u6,992) '           Min. decreasing steps   :',nThrs
  write(u6,'(A)') '        Local limit factors'
  write(u6,993) '           Low:',dLimmo(1),'     High:',dLimmo(2)
  call Diff_Numerical(nAt,nB,MP,nij,EC,ANr,Ttot,Ttot_Inv,lMax,TP,dLimmo,Thrs1,Thrs2,nThrs,iPrint,ThrsMul,Pot_Expo,Pot_Point, &
                      Pot_Fac,Diffed)
else if (Diffuse(3)) then
  write(u6,*)
  write(u6,*) 'Not programmed yet, bitte sehr.'
  call Abend()
end if

! Print, analyze uzw, the result of the diffuse stuff.

call WeGotThis(nAt,nB,MP,nij,EC,lMax,iPrint,Pot_Expo,Pot_Point,Pot_Fac,Diffed)

! Generate file with information for other programs.

lMaxF = 1
call YouGetThis(EC,Pot_Expo,Pot_Point,Pot_Fac,Diffed,MP,lMax,lMaxF,nij,LuYou)

call mma_deallocate(Pot_Expo)
call mma_deallocate(Pot_Point)
call mma_deallocate(Pot_Fac)
call mma_deallocate(Diffed)

return

991 format(A,E12.5)
992 format(A,I2)
993 format(2(A,F10.5))

end subroutine Diff_MotherGoose

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SETRED(DIAG)
!
! Purpose: set next reduced set. A copy of the previous set
!          is stored in location 3.

use Cholesky, only: Cho_TrcNeg, Cho_UseAbs, Damp, iAtomShl, iiBstR, iiBstRSh, IndRed, iSP2F, LuPri, Mode_Screen, nnBstR, nnBstRSh, &
                    nnBstRT, nnShl, nSym, ScDiag, ThrCom
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: DIAG(*)
integer(kind=iwp) :: IAB, INEG, ISHLA, ISHLAB, ISHLB, ISYM, JAB, JAB1, JAB2, KAB, MSYM, NNEG
real(kind=wp) :: TST, XM
character(len=*), parameter :: SECNAM = 'CHO_SETRED'

MSYM = size(iiBstRSh,1)

! Debug print.
! ------------

if (CHO_TRCNEG) then
  write(LUPRI,*)
  write(LUPRI,*) SECNAM,': tracing of negative diagonals activated.'
  write(LUPRI,*) SECNAM,': flag SCDIAG     is ',SCDIAG
  write(LUPRI,*) SECNAM,': flag CHO_USEABS is ',CHO_USEABS
  if (SCDIAG) write(LUPRI,*) SECNAM,': MODE_SCREEN     is ',MODE_SCREEN
  write(LUPRI,*) SECNAM,': checking for negative diagonals in first reduced set:'
  NNEG = 0
  do ISYM=1,NSYM
    JAB1 = IIBSTR(ISYM,1)+1
    JAB2 = JAB1+NNBSTR(ISYM,1)-1
    INEG = 0
    do JAB=JAB1,JAB2
      if (DIAG(JAB) < Zero) INEG = INEG+1
    end do
    NNEG = NNEG+INEG
    write(LUPRI,*) SECNAM,': #negative in symmetry ',ISYM,': ',INEG
  end do
  write(LUPRI,*) SECNAM,': total #negative: ',NNEG
end if

! Copy index arrays from location 2 to location 3.
! ------------------------------------------------

call CHO_RSCOPY(2,3)

! Re-initialize index arrays at location 2.
! -----------------------------------------

IndRed(:,2) = 0
iiBstRSh(:,:,2) = 0
nnBstRSh(:,:,2) = 0
iiBstr(1:MSYM,2) = 0
nnBstr(1:MSYM,2) = 0
NNBSTRT(2) = 0

! Set new reduced set: mapping and SP counter.
! --------------------------------------------

if (SCDIAG) then  ! do screening

  if (MODE_SCREEN == 1) then ! both conv. and unconv. included

    if (CHO_USEABS) then ! neg. diag. might be included

      KAB = 0
      do ISYM=1,NSYM
        if (NNBSTR(ISYM,3) > 0) then

          JAB1 = IIBSTR(ISYM,3)+1
          JAB2 = JAB1+NNBSTR(ISYM,3)-1

          IAB = INDRED(JAB1,3)
          XM = abs(DIAG(IAB))
          do JAB=JAB1+1,JAB2
            IAB = INDRED(JAB,3)
            XM = max(XM,abs(DIAG(IAB)))
          end do

          if (XM > THRCOM) then  ! only if not converged
            do ISHLAB=1,NNSHL
              JAB1 = IIBSTR(ISYM,3)+IIBSTRSH(ISYM,ISHLAB,3)+1
              JAB2 = JAB1+NNBSTRSH(ISYM,ISHLAB,3)-1
              do JAB=JAB1,JAB2
                IAB = INDRED(JAB,3)
                TST = sqrt(abs(DIAG(IAB))*XM)*DAMP(2)
                if (TST > THRCOM) then
                  KAB = KAB+1
                  INDRED(KAB,2) = IAB
                  NNBSTRSH(ISYM,ISHLAB,2) = NNBSTRSH(ISYM,ISHLAB,2)+1
                end if
              end do
            end do
          end if

        end if
      end do

    else ! neg. diag. excluded

      KAB = 0
      do ISYM=1,NSYM
        if (NNBSTR(ISYM,3) > 0) then

          JAB1 = IIBSTR(ISYM,3)+1
          JAB2 = JAB1+NNBSTR(ISYM,3)-1

          IAB = INDRED(JAB1,3)
          XM = abs(DIAG(IAB))
          do JAB=JAB1+1,JAB2
            IAB = INDRED(JAB,3)
            XM = max(XM,abs(DIAG(IAB)))
          end do

          if (XM > THRCOM) then  ! only if not converged
            do ISHLAB=1,NNSHL
              JAB1 = IIBSTR(ISYM,3)+IIBSTRSH(ISYM,ISHLAB,3)+1
              JAB2 = JAB1+NNBSTRSH(ISYM,ISHLAB,3)-1
              do JAB=JAB1,JAB2
                IAB = INDRED(JAB,3)
                if (DIAG(IAB) > Zero) then ! neg=>conv
                  TST = sqrt(DIAG(IAB)*XM)*DAMP(2)
                  if (TST > THRCOM) then
                    KAB = KAB+1
                    INDRED(KAB,2) = IAB
                    NNBSTRSH(ISYM,ISHLAB,2) = NNBSTRSH(ISYM,ISHLAB,2)+1
                  end if
                end if
              end do
            end do
          end if

        end if
      end do

    end if

  else if (MODE_SCREEN == 2) then ! only unconv. included

    if (CHO_USEABS) then ! neg. diag. might be included

      KAB = 0
      do ISYM=1,NSYM
        if (NNBSTR(ISYM,3) > 0) then

          do ISHLAB=1,NNSHL
            JAB1 = IIBSTR(ISYM,3)+IIBSTRSH(ISYM,ISHLAB,3)+1
            JAB2 = JAB1+NNBSTRSH(ISYM,ISHLAB,3)-1
            do JAB=JAB1,JAB2
              IAB = INDRED(JAB,3)
              if (abs(DIAG(IAB)) > THRCOM) then
                KAB = KAB+1
                INDRED(KAB,2) = IAB
                NNBSTRSH(ISYM,ISHLAB,2) = NNBSTRSH(ISYM,ISHLAB,2)+1
              end if
            end do
          end do

        end if
      end do

    else ! neg. diag. excluded

      KAB = 0
      do ISYM=1,NSYM
        if (NNBSTR(ISYM,3) > 0) then

          do ISHLAB=1,NNSHL
            JAB1 = IIBSTR(ISYM,3)+IIBSTRSH(ISYM,ISHLAB,3)+1
            JAB2 = JAB1+NNBSTRSH(ISYM,ISHLAB,3)-1
            do JAB=JAB1,JAB2
              IAB = INDRED(JAB,3)
              if (DIAG(IAB) > THRCOM) then
                KAB = KAB+1
                INDRED(KAB,2) = IAB
                NNBSTRSH(ISYM,ISHLAB,2) = NNBSTRSH(ISYM,ISHLAB,2)+1
              end if
            end do
          end do

        end if
      end do

    end if

  else if (MODE_SCREEN == 3) then ! only 1-center unconv. incl.

    if (CHO_USEABS) then ! neg. diag. might be included

      KAB = 0
      do ISYM=1,NSYM
        if (NNBSTR(ISYM,3) > 0) then

          do ISHLAB=1,NNSHL
            call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)
            if (IATOMSHL(ISHLA) == IATOMSHL(ISHLB)) then
              JAB1 = IIBSTR(ISYM,3)+IIBSTRSH(ISYM,ISHLAB,3)+1
              JAB2 = JAB1+NNBSTRSH(ISYM,ISHLAB,3)-1
              do JAB=JAB1,JAB2
                IAB = INDRED(JAB,3)
                if (abs(DIAG(IAB)) > THRCOM) then
                  KAB = KAB+1
                  INDRED(KAB,2) = IAB
                  NNBSTRSH(ISYM,ISHLAB,2) = NNBSTRSH(ISYM,ISHLAB,2)+1
                end if
              end do
            end if
          end do

        end if
      end do

    else ! neg. diag. excluded

      KAB = 0
      do ISYM=1,NSYM
        if (NNBSTR(ISYM,3) > 0) then

          do ISHLAB=1,NNSHL
            call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)
            if (IATOMSHL(ISHLA) == IATOMSHL(ISHLB)) then
              JAB1 = IIBSTR(ISYM,3)+IIBSTRSH(ISYM,ISHLAB,3)+1
              JAB2 = JAB1+NNBSTRSH(ISYM,ISHLAB,3)-1
              do JAB=JAB1,JAB2
                IAB = INDRED(JAB,3)
                if (DIAG(IAB) > THRCOM) then
                  KAB = KAB+1
                  INDRED(KAB,2) = IAB
                  NNBSTRSH(ISYM,ISHLAB,2) = NNBSTRSH(ISYM,ISHLAB,2)+1
                end if
              end do
            end if
          end do

        end if
      end do

    end if

  else ! MODE_SCREEN out of bounds

    write(LUPRI,*) SECNAM,': MODE_SCREEN = ',MODE_SCREEN
    call CHO_QUIT('MODE_SCREEN out of bounds in '//SECNAM,103)

  end if

else ! no screening; remove zero diagonals and check convergence

  if (CHO_USEABS) then ! neg diag might be incl.

    KAB = 0
    do ISYM=1,NSYM
      if (NNBSTR(ISYM,3) > 0) then

        JAB1 = IIBSTR(ISYM,3)+1
        JAB2 = JAB1+NNBSTR(ISYM,3)-1

        IAB = INDRED(JAB1,3)
        XM = abs(DIAG(IAB))
        do JAB=JAB1+1,JAB2
          IAB = INDRED(JAB,3)
          XM = max(XM,abs(DIAG(IAB)))
        end do

        if (XM > THRCOM) then  ! only if not converged
          do ISHLAB=1,NNSHL
            JAB1 = IIBSTR(ISYM,3)+IIBSTRSH(ISYM,ISHLAB,3)+1
            JAB2 = JAB1+NNBSTRSH(ISYM,ISHLAB,3)-1
            do JAB=JAB1,JAB2
              IAB = INDRED(JAB,3)
              if (abs(DIAG(IAB)) > Zero) then
                KAB = KAB+1
                INDRED(KAB,2) = IAB
                NNBSTRSH(ISYM,ISHLAB,2) = NNBSTRSH(ISYM,ISHLAB,2)+1
              end if
            end do
          end do
        end if

      end if
    end do

  else ! neg diag excl.

    KAB = 0
    do ISYM=1,NSYM
      if (NNBSTR(ISYM,3) > 0) then

        JAB1 = IIBSTR(ISYM,3)+1
        JAB2 = JAB1+NNBSTR(ISYM,3)-1

        IAB = INDRED(JAB1,3)
        XM = abs(DIAG(IAB))
        do JAB=JAB1+1,JAB2
          IAB = INDRED(JAB,3)
          XM = max(XM,abs(DIAG(IAB)))
        end do

        if (XM > THRCOM) then  ! only if not converged
          do ISHLAB=1,NNSHL
            JAB1 = IIBSTR(ISYM,3)+IIBSTRSH(ISYM,ISHLAB,3)+1
            JAB2 = JAB1+NNBSTRSH(ISYM,ISHLAB,3)-1
            do JAB=JAB1,JAB2
              IAB = INDRED(JAB,3)
              if (DIAG(IAB) > Zero) then
                KAB = KAB+1
                INDRED(KAB,2) = IAB
                NNBSTRSH(ISYM,ISHLAB,2) = NNBSTRSH(ISYM,ISHLAB,2)+1
              end if
            end do
          end do
        end if

      end if
    end do

  end if

end if

! Set remaining index arrays.
! ---------------------------

call CHO_SETREDIND(2)

! Debug print.
! ------------

if (CHO_TRCNEG) then
  write(LUPRI,*) SECNAM,': checking for negative diagonals in next reduced set:'
  NNEG = 0
  do ISYM=1,NSYM
    JAB1 = IIBSTR(ISYM,2)+1
    JAB2 = JAB1+NNBSTR(ISYM,2)-1
    INEG = 0
    do JAB=JAB1,JAB2
      IAB = INDRED(JAB,2)
      if (DIAG(IAB) < Zero) INEG = INEG+1
    end do
    NNEG = NNEG+INEG
    write(LUPRI,*) SECNAM,': #negative in symmetry ',ISYM,': ',INEG
  end do
  write(LUPRI,*) SECNAM,': total #negative: ',NNEG
end if

end subroutine CHO_SETRED

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Init_Data()
!***********************************************************************
!                                                                      *
!     Initialize variables in common blocks                            *
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use MCLR_Data, only: FNCSF2SD, FnHlf2, FNHlf3, FnJob, FnMck, FnMOTRA, FnPT2, FnQDAT, FnTemp, FNTrI1, FNTrI2, FNTRi3, FNTRI4, &
                     FNTRI5, FnTwo, LUCSF2SD, LUHlf2, LUHlf3, LuJob, LuMck, LuMOTRA, LuPt2, LuQDAT, LuTemp, LUTrI1, LUTrI2, &
                     LUTRi3, LUTRI4, LUTRI5, LuTwo
use input_mclr, only: nsRot, nUserPT, State_Sym, UserP, UserT
use Constants, only: Zero, One

implicit none

!----------------------------------------------------------------------*
!     Define files (file names and unit numbers)                       *
!----------------------------------------------------------------------*
FnJob = 'JOBIPH'
LuJob = 10
FnMck = 'MCKINT'
LuMck = 15
FnPT2 = '.RLXPT2'
LuPT2 = 17
FnTemp = 'RESP'
LuTemp = 19
FnCSF2SD = 'REORD'
LuCSF2SD = 20

FnTwo = 'ORDINT'
LuTwo = 40
FnHLF2 = 'TEMP06'
LuHLF2 = 50
FnHLF3 = 'TEMP07'
LuHLF3 = 60

FNTRI1 = 'TEMP01'
LUTRI1 = 24
FNTRI2 = 'TEMP02'
LUTRI2 = 25
FNTRI3 = 'TEMP03'
LUTRI3 = 26
FNTRI4 = 'TEMP04'
LUTRI4 = 27
FNTRI5 = 'TEMP05'
LUTRI5 = 28
! files used only within the TwoStep Run of MCLR
FnQDAT = 'QDAT' ! some temporary data is stored here
LuQDAT = 29
! this file is exactly the same as TEMP01, but is not deleted
FnMOTRA = 'MOTRA'
LuMOTRA = 30

State_Sym = 1
nUserPT = 0
UserP = One
UserT(:) = Zero
nsRot = 0

!----------------------------------------------------------------------*
!     Normal termination                                               *
!----------------------------------------------------------------------*

end subroutine Init_Data

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016, Steven Vancoillie                                *
*               2018, Ignacio Fdez. Galvan                             *
************************************************************************
      module pt2wfn
      integer :: pt2wfn_id
      logical :: pt2wfn_is_h5 = .False.
      integer :: pt2wfn_refene, pt2wfn_energy
      integer :: pt2wfn_mocoef, pt2wfn_occnum, pt2wfn_orbene
      integer :: pt2wfn_cicoef
      integer :: pt2wfn_heff
      integer :: pt2wfn_dens
      save

      contains

      subroutine pt2wfn_init
*     SVC: Create a wavefunction file. If another .wfn file already
*     exists, it will be overwritten.
      use refwfn, only: refwfn_active
#ifdef _HDF5_
      use refwfn, only: refwfn_is_h5
      use mh5, only: mh5_create_file, mh5_init_attr,
     &               mh5_create_dset_str, mh5_create_dset_real,
     &               mh5_put_dset, mh5_close_dset
#endif
      implicit none
#include "rasdim.fh"
#include "caspt2.fh"
#include "stdalloc.fh"
#include "pt2_guga.fh"
#ifdef _HDF5_

      integer :: dsetid, ndmat, i
      character(len=1), allocatable :: typestring(:)
#endif

      If (refwfn_active) Then
        Call WarningMessage(2,'Active reference wavefunction file, '//
     &    'cannot create new PT2 wavefunction file, aborting!')
        Call AbEnd
      End If

#ifdef _HDF5_
      If (refwfn_is_h5) Then
        pt2wfn_is_h5 = .True.
*     create a new wavefunction file!
        pt2wfn_id = mh5_create_file('PT2WFN')
*     no JOBMIX for HDF5 files
        ifmix = .False.

*     set module type
        call mh5_init_attr (pt2wfn_id,'MOLCAS_MODULE', 'CASPT2')

*     copy basic molecular information to the HDF5 file
        call run2h5_molinfo(pt2wfn_id)
        call one2h5_ovlmat(pt2wfn_id, nsym, nbas)
        call one2h5_fckint(pt2wfn_id, nsym, nbas)
        call one2h5_crtmom(pt2wfn_id, nsym, nbas)

*     set wavefunction type
        if (NRAS1T+NRAS3T.EQ.0) then
          call mh5_init_attr (pt2wfn_id,'CI_TYPE', 'CAS')
        else
          call mh5_init_attr (pt2wfn_id,'CI_TYPE', 'RAS')
        end if

*     general wavefunction attributes
        call mh5_init_attr (pt2wfn_id,'SPINMULT', iSpin)
        call mh5_init_attr (pt2wfn_id,'LSYM', stSym)
        call mh5_init_attr (pt2wfn_id,'NACTEL', nActEl)
        call mh5_init_attr (pt2wfn_id,'NHOLE1', nHole1)
        call mh5_init_attr (pt2wfn_id,'NELEC3', nEle3)
        call mh5_init_attr (pt2wfn_id,'NCONF',  nConf)
        call mh5_init_attr (pt2wfn_id,'NSTATES', NSTATE)

        call mh5_init_attr (pt2wfn_id,'L2ACT', 1, [mxAct], L2ACT)
        call mh5_init_attr (pt2wfn_id,'A2LEV', 1, [mxAct], LEVEL)

*     molecular orbital type index
        call mma_allocate(typestring, nbast)
        call orb2tpstr(NSYM,NBAS,
     $        NFRO,NISH,NRAS1,NRAS2,NRAS3,NSSH,NDEL,
     $        typestring)
        dsetid = mh5_create_dset_str(pt2wfn_id,
     $        'MO_TYPEINDICES', 1, [NBAST],1)
        call mh5_init_attr(dsetid, 'DESCRIPTION',
     $        'Type index of the molecular orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
        call mh5_put_dset(dsetid, typestring)
        call mma_deallocate(typestring)
        call mh5_close_dset(dsetid)

*     roots
        call mh5_init_attr (pt2wfn_id,
     $        'STATE_ROOTID', 1, [NSTATE], MSTATE)
        call mh5_init_attr (pt2wfn_id,
     $        'ROOT2STATE', 1, [LROOTS], ROOT2STATE)

*     reference energy (for each CI root)
        pt2wfn_refene = mh5_create_dset_real (pt2wfn_id,
     $        'STATE_REFWF_ENERGIES', 1, [NSTATE])
        call mh5_init_attr(pt2wfn_refene, 'DESCRIPTION',
     $        'Reference energy for each state, '//
     $        'arranged as array of [NSTATES]')

*     PT2 energy (for each CI root)
        pt2wfn_energy = mh5_create_dset_real (pt2wfn_id,
     $        'STATE_PT2_ENERGIES', 1, [NSTATE])
        call mh5_init_attr(pt2wfn_energy, 'DESCRIPTION',
     $        'PT2 energy for each state, '//
     $        'arranged as array of [NSTATES]')

*     molecular orbital coefficients
        pt2wfn_mocoef = mh5_create_dset_real(pt2wfn_id,
     $        'MO_VECTORS', 1, [NBSQT])
        call mh5_init_attr(pt2wfn_mocoef, 'DESCRIPTION',
     $        'Coefficients of the average orbitals, '//
     $        'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')

*     molecular orbital occupation numbers
*     (most probably empty, but left for compatibility)
        pt2wfn_occnum = mh5_create_dset_real(pt2wfn_id,
     $        'MO_OCCUPATIONS', 1, [NBAST])
        call mh5_init_attr(pt2wfn_occnum, 'DESCRIPTION',
     $        'Occupation numbers of the average orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')

*     molecular orbital energies
*     (most probably empty, but left for compatibility)
        pt2wfn_orbene = mh5_create_dset_real(pt2wfn_id,
     $        'MO_ENERGIES', 1, [NBAST])
        call mh5_init_attr(pt2wfn_orbene, 'DESCRIPTION',
     $        'Orbital energies of the average orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')

*     CI data for each root
        pt2wfn_cicoef = mh5_create_dset_real(pt2wfn_id,
     $        'CI_VECTORS', 2, [nConf, NSTATE])
        call mh5_init_attr(pt2wfn_cicoef, 'DESCRIPTION',
     $        'Coefficients of configuration state functions '//
     $        'in Split-GUGA ordering for each STATE, '//
     $        'arranged as matrix of size [NCONF,NSTATES]')

*     effective Hamiltonian coefficients
        If (IFMSCOUP) Then
          pt2wfn_heff = mh5_create_dset_real(pt2wfn_id,
     $        'H_EFF', 2, [NSTATE, NSTATE])
          call mh5_init_attr(pt2wfn_heff, 'DESCRIPTION',
     $        'Effective (X)MS-CASPT2 Hamiltonian, '//
     $        'arranged as matrix of size [NSTATES,NSTATES]')
        End If

*     density matrices
        If (IFPROP) Then
          ndmat=0
          Do i=1,NSYM
            ndmat=ndmat+(NORB(i)**2+NORB(i))/2
          End Do

          pt2wfn_dens = mh5_create_dset_real(pt2wfn_id,
     $        'DENSITY_MATRIX', 2, [ndmat, NSTATE])
          call mh5_init_attr(pt2wfn_dens, 'DESCRIPTION',
     $        '1-body density matrix, arranged as blocks of size '//
     $        'NDMAT=sum([NORB(i)*(NORB(i)+1)/2], i=1,#irreps), '//
     $        'where NORB excludes frozen and deleted orbitals, '//
     $        'for each state: [NDMAT,NSTATES].')
        End If

      Else
#endif
        pt2wfn_is_h5 = .False.
#ifdef _HDF5_
      End If
#endif
      end subroutine

      subroutine pt2wfn_data
#ifdef _HDF5_
      use mh5, only: mh5_put_dset
#endif
      implicit none
#include "rasdim.fh"
#include "caspt2.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
      real*8, allocatable :: BUF(:)
      integer :: ISTATE, IDISK

      If (pt2wfn_is_h5) Then
        call mma_allocate(BUF,NCONF)
        IDISK = IDCIEX
        DO ISTATE=1,NSTATE
          CALL DDAFILE(LUCIEX,2,BUF,NCONF,IDISK)
          call mh5_put_dset(pt2wfn_cicoef,BUF,[NCONF,1],[0,ISTATE-1])
        END DO
        call mma_deallocate(BUF)

        call mma_allocate(BUF,NCMO)
        IDISK = IAD1M(1)
        CALL DDAFILE(LUONEM,2,BUF,NCMO,IDISK)
        call mh5_put_dset(pt2wfn_mocoef,BUF)
        call mma_deallocate(BUF)
      End If
#endif
      end subroutine

      subroutine pt2wfn_estore(Heff)
#ifdef _HDF5_
      use mh5, only: mh5_put_dset
#endif
      implicit none
#include "rasdim.fh"
#include "caspt2.fh"
      real*8 :: Heff(nstate,nstate)
#ifdef _HDF5_
      If (pt2wfn_is_h5) Then
        call mh5_put_dset(pt2wfn_energy, ENERGY)
        call mh5_put_dset(pt2wfn_refene, REFENE)
        If (IFMSCOUP) Then
          call mh5_put_dset(pt2wfn_heff, Heff)
        End If
      End If
#else
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Heff)
#endif
      end subroutine

      subroutine pt2wfn_densstore(Dmat,nDmat)
#ifdef _HDF5_
      use mh5, only: mh5_put_dset
#endif
      implicit none
#include "rasdim.fh"
#include "caspt2.fh"
      integer :: nDmat
      real*8 :: Dmat(nDmat)
#ifdef _HDF5_
      If (pt2wfn_is_h5) Then
        call mh5_put_dset(pt2wfn_dens, Dmat,
     $                    [nDmat, 1], [0, JSTATE-1])
      End If
#else
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Dmat)
#endif
      end subroutine

      subroutine pt2wfn_close
#ifdef _HDF5_
      use mh5, only: mh5_close_file
      if (pt2wfn_is_h5) then
        call mh5_close_file(pt2wfn_id)
      end if
      pt2wfn_id = -1
#endif
      end subroutine
      end module

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_QUALIFY_1(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
C
C     Purpose: qualify diagonals ("qualify until full").
C
#include "implicit.fh"
      DIMENSION DIAG(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      IIBSTRSH(I,J,K)=IWORK(ip_IIBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)

      IF (NNBSTRSH(ISYM,ISHLAB,2) .GT. 0) THEN
         I  = IIBSTR(ISYM,2) + IIBSTRSH(ISYM,ISHLAB,2)
         I2 = I + NNBSTRSH(ISYM,ISHLAB,2)
         MAXQ = MIN(MAXQUAL-NQUAL(ISYM),LEFT/NNBSTR(ISYM,2))
         NUMQ = 0
         DO WHILE ((I.LT.I2) .AND. (NUMQ.LT.MAXQ))
            I = I + 1
            J = INDRED(I,2)
            IF (DIAG(J) .GE. DIAMIN(ISYM)) THEN
               NUMQ = NUMQ + 1
               KOFF = ip_IQUAB + MAXQUAL*(ISYM-1)
     &              + IOFFQ(ISYM) + NUMQ - 1
               IWORK(KOFF) = I
            END IF
         END DO
         NQUAL(ISYM) = NQUAL(ISYM) + NUMQ
         MEM0 = MEM0 + NUMQ*NNBSTR(ISYM,2)
         LEFT = MEM  - MEM0
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_UpdateDiagonal(iAtomPair,l_CBar,CBar,irc)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: Update integral diagonal for atom pair iAtomPair,
C                 (uv|uv)=(uv|uv)-sum(K) CBar[uv,K]^2
C              Check for (too) negative diagonals.
C
C     Return codes:
C        irc=0: all ok
C        irc>1: too negative diagonals encountered (irc will be the
C               number of too negative diagonals)
C
C
      Implicit None
      Integer iAtomPair
      Integer l_CBar
      Real*8  CBar(l_CBar)
      Integer irc
#include "localdf.fh"
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBasAux_Pair, LDF_AtomPair_DiagDim
      External LDF_nBasAux_Pair, LDF_AtomPair_DiagDim

      Integer M
      Integer nuv
      Integer ip_D
      Integer K
      Integer uvK
      Integer uv

      ! Get dimensions
      M=LDF_nBasAux_Pair(iAtomPair)
      nuv=LDF_AtomPair_DiagDim(iAtomPair)

      ! Update diagonal
      ip_D=iWork(ip_AP_Diag-1+iAtomPair)-1
      Do K=0,M-1
         uvK=nuv*K
         Do uv=1,nuv
            Work(ip_D+uv)=Work(ip_D+uv)-CBar(uvK+uv)**2
         End Do
      End Do

      ! Check for too negative diagonals
      irc=0
      Do uv=1,nuv
         If (Work(ip_D+uv).lt.TooNegative) Then
            irc=irc+1
         End If
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Cmo(CMO,nCMO)

use RunFile_data, only: lw
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCMO
real(kind=wp), intent(out) :: CMO(nCMO)
integer(kind=iwp) :: mCMO
logical(kind=iwp) :: Found
character(len=lw) :: Label

Label = 'Last orbitals'
call qpg_dArray(Label,Found,mCmo)
if (.not. Found) Label = 'Guessorb'
call Get_dArray_chk(Label,CMO,nCMO)

return

end subroutine Get_Cmo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*----------------------------------------------------------------------*
* A routine inspired by the wr_motra_info utility.                     *
*----------------------------------------------------------------------*
      Subroutine WrRdSim(iLu,iOpt,iDisk,iTcSim,nTcSim,Etot
     &,Radie,nPart,Gamma,Gam,Esav)
      Implicit Real*8 (a-h,o-z)
      Dimension iTcSim(nTcSim)
      Dimension Dum(1),iDum(1)

      Call iDaFile(iLu,iOpt,iTcSim,nTcSim,iDisk)
      Dum(1)=Etot
      Call dDaFile(iLu,iOpt,Dum,1,iDisk)
      Etot=Dum(1)
      Dum(1)=Radie
      Call dDaFile(iLu,iOpt,Dum,1,iDisk)
      Radie=Dum(1)
      iDum(1)=nPart
      Call iDaFile(iLu,iOpt,iDum,1,iDisk)
      nPart=iDum(1)
      Dum(1)=Gamma
      Call dDaFile(iLu,iOpt,Dum,1,iDisk)
      Gamma=Dum(1)
      Dum(1)=Gam
      Call dDaFile(iLu,iOpt,Dum,1,iDisk)
      Gam=Dum(1)
      Dum(1)=Esav
      Call dDaFile(iLu,iOpt,Dum,1,iDisk)
      Esav=Dum(1)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Markus P. Fuelscher                              *
!***********************************************************************

subroutine RdInp_Motra()
!***********************************************************************
!                                                                      *
! Subroutine RdInp                                                     *
!                                                                      *
! Purpose: Read input from inputstream                                 *
!                                                                      *
!**** M.P. Fuelscher, University of Lund, Sweden, 1991 *****************

use motra_global, only: CutThrs, FnInpOrb, iAutoCut, iCTonly, iDoInt, ihdf5, iOneOnly, iPrint, iRFpert, iVecTyp, nBas, nDel, nFro, &
                        nOrb, nOrbt, nOrbtt, nSym, nTit, Title
use Constants, only: Zero
use Definitions, only: iwp, u6

implicit none
#include "chotraw.fh"
integer(kind=iwp) :: iCmd, istatus, iSym, jCmd, LuSpool, mxTit, nDel2(nSym)
character(len=180) :: Line
logical(kind=iwp) :: Skip
integer(kind=iwp), parameter :: nCmd = 16, lCmd = 4
character(len=lCmd), parameter :: CmdTab(nCmd) = ['TITL','FROZ','DELE','PRIN','MOLO','LUMO','JOBI','ONEL','FILE','AUTO', &
                                                  'EXTR','RFPE','CTON','DIAG','HDF5','END ']
character(len=180), external :: Get_Ln

iCTonly = 0
iDoInt = 0
ihdf5 = 0
tv2disk = 'PQK'
!----------------------------------------------------------------------*
! Initialize some arrays                                               *
!----------------------------------------------------------------------*
nDel(:) = 0
nOrb(:) = 0
CutThrs(:) = Zero
mxTit = size(Title)
call Get_iArray('Non valence orbitals',nFro,nSym)
!----------------------------------------------------------------------*
! Locate "start of input"                                              *
!----------------------------------------------------------------------*
LuSpool = 17
call SpoolInp(LuSpool)
rewind(LuSpool)
call RdNLst(LuSpool,'MOTRA')
!----------------------------------------------------------------------*
! Read the input stream line by line and identify key command          *
!----------------------------------------------------------------------*
Skip = .false.
input: do
  if (.not. Skip) then
    read(LuSpool,'(A)') Line
    if ((Line(1:72) == ' ') .or. (Line(1:1) == '*')) cycle
    call UpCase(Line)
  end if
  Skip = .false.
  jCmd = 0
  do iCmd=1,nCmd
    if (Line(1:lCmd) == CmdTab(iCmd)(1:lCmd)) jCmd = iCmd
  end do
  if (jCmd == 0) then
    write(u6,*) 'RdInp: Unknown command at line: ',trim(Line)
    call Abend()
  end if
  !----------------------------------------------------------------------*
  ! Branch to the processing of the command sections                     *
  !----------------------------------------------------------------------*
  select case (jCmd)
    case (1)
      !---  Process the "TITLe" command -------------------------------*
      nTit = 0
      do
        do
          read(LuSpool,'(A)') Line
          if ((Line(1:72) /= ' ') .and. (Line(1:1) /= '*')) exit
        end do
        call UpCase(Line)
        if (nTit > 0) then
          do iCmd=1,nCmd
            if (Line(1:lCmd) == CmdTab(iCmd)(1:lCmd)) then
              Skip = .true.
              cycle input
            end if
          end do
        end if
        nTit = nTit+1
        if (nTit <= mxTit) Title(nTit) = trim(Line)
      end do
    case (2)
      !---  Process the "FROZen orbitals" command ---------------------*

      if (iPrint >= 0) then
        write(u6,*)
        write(u6,'(6X,A)') '*** WARNING: Default frozen orbitals is overwritten by user input.'
        write(u6,'(6X,A,8I4)') '*** Default values:',(nFro(iSym),iSym=1,nSym)
      end if

      do
        read(LuSpool,'(A)') Line
        if ((Line(1:72) /= ' ') .and. (Line(1:1) /= '*')) exit
      end do
      read(Line,*,iostat=istatus) nFro(1:nSym)
      if (istatus /= 0) call Error()
    case (3)
      !---  Process the "DELEted orbitals" command --------------------*
      do
        read(LuSpool,'(A)') Line
        if ((Line(1:72) /= ' ') .and. (Line(1:1) /= '*')) exit
      end do
      read(Line,*,iostat=istatus) nDel(1:nSym)
      if (istatus /= 0) call Error()
    case (4)
      !---  Process the "PRINt level" command -------------------------*
      do
        read(LuSpool,'(A)') Line
        if ((Line(1:72) /= ' ') .and. (Line(1:1) /= '*')) exit
      end do
      read(Line,*,iostat=istatus) iPrint
      if (istatus /= 0) call Error()
    case (5)
      !---  Process the "MOLOrb" command ------------------------------*
      iVecTyp = 1
    case (6)
      !---  Process the "LUMOrb" command ------------------------------*
      iVecTyp = 2
    case (7)
      !---  Process the "JOBIph" command ------------------------------*
      iVecTyp = 3
    case (8)
      !---  Process the "ONEL only" command ---------------------------*
      iOneOnly = 1
    case (9)
      !---  Process the "FILEORB" command------------------------------*
      iVecTyp = 2
      Line = Get_Ln(LuSpool)
      write(u6,*) ' RdInp_Motra before calling fileorb.'
      write(u6,*) ' Line:'//line(1:60)
      write(u6,*) '   Calling fileorb now...'
      call fileorb(Line,FnInpOrb)
      write(u6,*) '   Back from fileorb.'
      write(u6,*) ' Line:'//line(1:60)
      write(u6,*) FnInpOrb
    case (10)
      !---  Process the "AUTO delete" command--------------------------*
      iAutoCut = 1
      do
        read(LuSpool,'(A)') Line
        if ((Line(1:72) /= ' ') .and. (Line(1:1) /= '*')) exit
      end do
      read(Line,*,iostat=istatus) CutThrs(1:nSym)
      if (istatus /= 0) call Error()
    case (11)
      !---  Process the "EXTRact" command------------------------------*
      write(u6,*) 'The EXTRACT option is redundant and is ignored!'
    case (12)
      !---  Process the "RFperturbation" command ----------------------*
      iRFpert = 1
    case (13)
      !---  Process the "CTonly" to perform exclusively CD vectors transform-*
      Line = Get_Ln(LuSpool)
      call UpCase(Line)
      Line = adjustl(Line)
      tv2disk = Line(1:3)
      if ((tv2disk /= 'PQK') .and. (tv2disk /= 'KPQ')) tv2disk = 'PQK' !def
      iCTonly = 1
    case (14)
      !---  Process the "DIAGonal ERI evaluation" command -------------*
      iDoInt = 1
    case (15)
      !---  Process the "HDF5 output file" command --------------------*
      ihdf5 = 1
    case (16)
      !---  Process the "END of input" command ------------------------*
      exit
    case default
  end select
end do input

! New rules for title lines... warning needed?
if (nTit > mxTit) then
  write(u6,*) ' NOTE: New input specifications says TITLE keyword'
  write(u6,*) ' must be followed by exactly one title line.'
  nTit = mxTit
end if

! Check for deleted orbitals

call Get_iArray('nDel',nDel2,nSym)
do iSym=1,nSym
  if (nDel2(iSym) > nDel(iSym)) then
    write(u6,*)
    write(u6,*) 'Orbitals deleted at an earlier stage.'
    write(u6,*) 'iSym=',iSym
    write(u6,*) 'Input value  :',nDel(iSym)
    write(u6,*) 'Earlier value:',nDel2(iSym)
    write(u6,*)
    write(u6,*) 'Input value is now updated to earlier value!'
    write(u6,*)
    nDel(iSym) = nDel2(iSym)
  end if
end do
!----------------------------------------------------------------------*
! Normal termination                                                   *
!----------------------------------------------------------------------*
nOrbt = 0
nOrbtt = 0
do iSym=1,nSym
  nOrb(iSym) = nBas(iSym)-nFro(iSym)-nDel(iSym)
  nOrbt = nOrbt+nOrb(iSym)
  nOrbtt = nOrbtt+nOrb(iSym)*(nOrb(iSym)+1)/2
end do
call Put_iArray('nFro',nFro,nSym)
close(LuSpool)

return

contains

subroutine Error()
  write(u6,*) 'RdInp: error readin input file!'
  write(u6,*) 'Command=',CmdTab(jCmd)
  call Abend()
end subroutine

end subroutine RdInp_Motra

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
      SUBROUTINE Init_Dynamix
      IMPLICIT REAL*8 (a-h,o-z)
#include "MD.fh"
#include "WrkSpc.fh"
C      CHARACTER*180 Lines(10)
*
C#ifdef _SKIP_
C      Lines(1 )=_MOLCAS_VERSION_
C#ifdef _DEMO_
C      Lines(2 )='DEMO VERSION '
C#else
C      Lines(2 )=' '
C#endif
c      Lines(3 )=' '
C      Lines(4 )='D Y N A M I X'
C      Lines(5 )=' '
C      Lines(6 )='Written by Igor Schapiro'
C      Lines(7 )=' '
C      Lines(8 )='A program for molecular dynamics simulations'
C      Lines(9 )=' '
C      Lines(10)='Code compiled :'//_BUILD_DATE_
C      lLine=Len(Lines(1))
c      CALL Banner(Lines,10,lLine)
*
C      WRITE (6,*)
C      WRITE (6,'(A,I8,A)')   ' The Dynamix program has ',
C     &      mxMem,' double precision words memory available.'
C      WRITE (6,'(A,I8,A)')   '                       ',
C     &      mxMem*8/(1024**2),' MB'
C      WRITE (6,*)
C#endif
C
C     Set the defalut values
C
      CALL Get_nAtoms_Full(natom)
      THERMO=0
      TEMP=298.15
      VELO=0
      POUT=0
      PIN=natom*3
      iPrint=2
      DT=1.0D1
      TIME=0.0D0
      RESTART=0.0D0
      lH5Restart= .False.
*
*      Etot0=0.0D0
*
      RETURN
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

!>  @brief
!>  Transform the inactive one-body density from MO to AO basis
!>
!>  @author
!>  Markus P. Fuelscher
!>
!>  @details
!>  The underlying equation is the basis transformatin:
!>  \f[ D^{\text{AO}} = C D C^\dagger \f]
!>  For inactive orbitals it simplifies to:
!>  \f[D^{\text{AO}, I} = C^I D^I (C^I)^\dagger = 2 C^I \mathbf{1} (C^I)^\dagger = 2 C (C^I)^\dagger \f]
!>  Where (\f$ C^I, D^I \f$) are the coefficients and densities of the inactive MOs.
!>
!>  @param[in] CMO The MO-coefficients
!>  @param[out] D1I_AO The inactive one-body density matrix in AO-space
subroutine Get_D1I_RASSCF(CMO,D1I_AO)
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use general_data, only: nBas, nFro, nIsh, nSym
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(_OUT_) :: D1I_AO(*)
integer(kind=iwp) :: ista, iSym, nb, nbsq, nfi

ista = 1
do isym=1,nsym
  nb = nbas(isym)
  nbsq = nb**2
  nfi = nfro(isym)+nish(isym)
  if (nb > 0) then
    d1i_AO(ista:ista+nbsq-1) = Zero
    if (nfi > 0) call DGEMM_('N','T',nb,nb,nfi, &
                             Two,cmo(ista),nb, &
                             cmo(ista),nb, &
                             Zero,d1i_AO(ista),nb)
    ista = ista+nbsq
  end if
end do

end subroutine Get_D1I_RASSCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PickOrb(Nz,Sort,Gref,Sort_ab,Gref_ab,E,Occ,E_ab,Occ_ab,nShowMOs,nShowMOs_ab,isEner,nMOs,myTitle,iType)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

#include "intent.fh"

use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use grid_it_globals, only: iMaxDown, iMaxUp, iReq, isAll, iAuMO, isUHF, itRange, NoSort, nReq, Region
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nMOs, iType(nMOs)
integer(kind=iwp), intent(_OUT_) :: NZ(*)
integer(kind=iwp), intent(out) :: Sort(nMOs), Sort_ab(merge(nMOs,0,isUHF)), nShowMOs, nShowMOs_ab
integer(kind=iwp), intent(inout) :: Gref(nMOs), Gref_ab(merge(nMOs,0,isUHF))
real(kind=wp), intent(inout) :: E(nMOs), E_ab(merge(nMOs,0,isUHF))
real(kind=wp), intent(in) :: Occ(nMOs), Occ_ab(merge(nMOs,0,isUHF))
logical(kind=iwp), intent(inout) :: isEner
character(len=*), intent(in) :: myTitle
integer(kind=iwp) :: i, iActive, ief, ief_ab, ii, ii_ab, iia, iib, ik, ik_ab, il, il_ab, ishift, ispin, j
real(kind=wp) :: ef, ef_ab, eps, R, s

ispin = index(myTitle,' spin')

ik_ab = 0
ii_ab = 0
il_ab = 0
nShowMOs_ab = 0
Sort(:) = 0
if (isUHF) Sort_ab(:) = 0

ishift = 0
do i=0,nIrrep-1
  if (nBas(i) > 0) then
    do j=1,nBas(i)
      NZ(j+ishift) = i+1
      NZ(j+ishift+nMOs) = j
    end do
  end if
  ishift = ishift+nBas(i)
end do

eps = 1.0e-6_wp
! if no input, but TypeIndex contains 123
if ((iAuMO == -1) .and. (.not. isAll)) then
  iActive = 0
  do i=1,nMOs
    if ((iType(i) >= 3) .and. (iType(i) <= 5)) iActive = iActive+1
  end do
  if (iActive > 0) then
    ii = 1
    do i=1,nMOs
      if ((iType(i) >= 3) .and. (iType(i) <= 5)) then
        Gref(ii) = i
        ii = ii+1
      end if
    end do
    nShowMOs = iActive
    return

  end if
end if

if ((iAuMo == -1) .and. (ispin > 0)) then
  iAuMO = 1
  Region(1) = -Two+eps
  Region(2) = -eps
  itRange = 0
  isEner = .false.
end if

if (isAll) then
  Region(1) = -1000.0_wp
  Region(2) = 1000.0_wp
else
  if ((iAuMO == 1) .and. (itRange == 1)) then
    s = Region(1)
    Region(1) = min(-Region(2),-Region(1))
    Region(2) = max(-Region(2),-s)
    s = Region(1)
    Region(1) = -Region(2)
    Region(2) = -s
  end if
  if ((iAuMO == -1) .and. (itRange == 0)) then
    iAuMO = 1
    Region(1) = -Two+eps
    Region(2) = -eps
  end if
  if ((iAuMO == -1) .and. isEner) then
    Region(1) = -1000.0_wp
    Region(2) = 1000.0_wp
  end if
end if

! 1. user defined number of orbitals. No auto function at all.

if (iAuMO == 0) then
  ishift = 0
  do i=0,nIrrep-1
    if (nBas(i) > 0) then
      Sort(i+1) = ishift
      ! use Sort as temp
    end if
    ishift = ishift+nBas(i)
  end do

  do i=1,nReq
    iia = iReq(i*2-1)
    iib = iReq(i*2)
    if ((iia <= 0) .or. (iia > nIrrep) .or. (iib < 0) .or. (iib > nBas(iia-1))) then
      write(u6,'(a)') 'Requested orbital does not exist'
      call Quit_OnUserError()

    end if
    Gref(i) = Sort(iia)+iib
    if (isUHF) Gref_ab(i) = Gref(i)
  end do

  nShowMOs = nReq
  if (isUHF) nShowMOs_ab = nReq
  return
end if
!***********************************************************************
! Well. The user didn't make an exact request. we need to choose orbitals.
if (itRange == 0) then
  isEner = .false.
  R = Region(2)
  Region(2) = -Region(1)
  Region(1) = -R
end if

Sort(:) = 0
if (.not. isEner) then
  E(:) = -Occ(:)
  if (isUHF) E_ab(:) = -Occ_ab(:)
end if

! Well, now we need to choose rest (nGrid-1) grids.

! Make stupid sorting...

if (NoSort) then
  ik = 0
  do i=1,nMOs
    if ((E(i) > Region(1)) .and. (E(i) < Region(2))) then
      !write(u6,*) 'EE',E(i),Region(1),Region(2)
      ik = ik+1
      Sort(i) = ik
    end if
  end do
  ik_ab = ik
else

  ik = 0
  do i=1,nMOs
    if ((E(i) > Region(1)) .and. (E(i) < Region(2))) then
      do j=1,nMOs
        if ((E(j) >= E(i)) .and. (E(j) >= Region(1)) .and. (E(j) <= Region(2))) then
          if (E(j) == E(i)) then
            if (Occ(j) <= Occ(i)) then
              Sort(i) = Sort(i)+1
              if (ik < Sort(i)) ik = Sort(i)
            end if
          else
            Sort(i) = Sort(i)+1
            if (ik < Sort(i)) ik = Sort(i)
          end if
        end if
      end do
    end if
  end do

  if (isUHF) then
    ik_ab = 0
    do i=1,nMOs
      if ((E_ab(i) > Region(1)) .and. (E_ab(i) < Region(2))) then
        do j=1,nMOs
          if ((E_ab(j) >= E_ab(i)) .and. (E_ab(j) >= Region(1)) .and. (E_ab(j) <= Region(2))) then
            if (E_ab(j) == E_ab(i)) then
              if (Occ_ab(j) <= Occ_ab(i)) then
                Sort_ab(i) = Sort_ab(i)+1
                if (ik_ab < Sort_ab(i)) ik_ab = Sort_ab(i)
              end if
            else
              Sort_ab(i) = Sort_ab(i)+1
              if (ik_ab < Sort_ab(i)) ik_ab = Sort_ab(i)
            end if
          end if
        end do
      end if
    end do
  end if
end if
if ((iAuMO == -1) .and. isEner .and. (.not. isAll)) then
  ef = -1000.0_wp
  ief = 1
  ef_ab = ef
  ief_ab = ief
  do i=1,nMOs
    if ((E(i) > ef) .and. (Occ(i) > eps)) then
      ef = E(i)
      ief = i
    end if
    if (isUHF) then
      if ((E_ab(i) > ef_ab) .and. (Occ_ab(i) > eps)) then
        ef_ab = E(i)
        ief_ab = i
      end if
    end if
  end do
  !write(u6,*) 'ef=',ef
  !write(u6,*) 'ief=',ief,ief_ab
  ii = Sort(ief)
  if (isUHF) ii_ab = Sort_ab(ief_ab)
  do i=1,nMOs
    if ((Sort(i) > ii+iMaxUp) .or. (Sort(i) < ii-iMaxDown)) Sort(i) = 0
    if (isUHF) then
      if ((Sort_ab(i) > ii_ab+iMaxUp) .or. (Sort_ab(i) < ii_ab-iMaxDown)) Sort_ab(i) = 0
    end if
  end do
end if

il = 0
do j=1,ik
  do i=1,nMOs
    if (Sort(i) == j) then
      il = il+1
      GRef(il) = i
    end if
  end do
end do
if (isUHF) then
  il_ab = 0
  do j=1,ik_ab
    do i=1,nMOs
      if (Sort_ab(i) == j) then
        il_ab = il_ab
        GRef_ab(il_ab+1) = i
      end if
    end do
  end do
end if
nShowMOs = il
if (isUHF) nShowMOs_ab = il_ab

return

end subroutine PickOrb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ResortD(D_Old,D_New,iBas,iCmp,jBas,jCmp)
      Implicit Real*8 (a-h,o-z)
*
      Real*8 D_Old(iBas,jBas,iCmp,jCmp), D_New(iBas,iCmp,jBas,jCmp)
*
      Do jC = 1, jCmp
         Do jB = 1, jBas
            Do iC = 1, iCmp
               Do iB = 1, iBas
                  D_New(iB,iC,jB,jC)=D_Old(iB,jB,iC,jC)
               End Do
            End Do
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine GetIntPoss
c
c        this routine read T3IntPos array from the first record
c        of t3nam file
c
        implicit none
#include "t31.fh"
c
        integer lun
c
       lun=1
       call daname (lun,t3nam)
       daddr(lun)=0
       call idafile (lun,2,T3IntPos,maxorb,daddr(lun))
       call daclos (lun)
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
CSVC: modified to convert to the use of byte lengths/offests by the
C     underlying I/O routines (2016)
      Subroutine dDaFile(Lu,iOpt,Buf,lBuf_,iDisk_)

      Implicit None

#include "SysDef.fh"
#include "fio.fh"

      Integer Lu, iOpt, lBuf_, iDisk_
      Real*8 Buf(lBuf_)

      Integer lBuf, iDisk

      Call dDaFile_Internal(Buf)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine dDaFile_Internal(Buf)
      Use Iso_C_Binding
      Real*8, Target :: Buf(*)
      Character, Pointer :: cBuf(:)
      lBuf=lBuf_*RtoB
      iDisk=iDisk_*MBL(Lu)

      Call C_F_Pointer(C_Loc(Buf(1)),cBuf,[lBuf])
      Call bDaFile(Lu,iOpt,cBuf,lBuf,iDisk)
      Nullify(cBuf)

      iDisk_=(iDisk+MBL(Lu)-1)/MBL(Lu)

      Return
      End Subroutine dDaFile_Internal
*
      End


      Subroutine cDaFile(Lu,iOpt,Buf,lBuf_,iDisk_)

      Implicit None

#include "SysDef.fh"
#include "fio.fh"

      Integer Lu, iOpt, lBuf_, iDisk_
      Character*1 Buf(lBuf_)

      Integer lBuf, iDisk

      lBuf=lBuf_
      iDisk=iDisk_*MBL(Lu)

      Call bDaFile(Lu,iOpt,Buf,lBuf,iDisk)

      iDisk_=(iDisk+MBL(Lu)-1)/MBL(Lu)

      Return
      End


      Subroutine iDaFile(Lu,iOpt,Buf,lBuf_,iDisk_)

      Implicit None

#include "SysDef.fh"
#include "fio.fh"

      Integer Lu, iOpt, lBuf_, iDisk_
      Integer Buf(lBuf_)

      Integer lBuf, iDisk

      Call iDaFile_Internal(Buf)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine iDaFile_Internal(Buf)
      Use Iso_C_Binding
      Integer, Target :: Buf(*)
      Character, Pointer :: cBuf(:)
      lBuf=lBuf_*ItoB
      iDisk=iDisk_*MBL(Lu)

      Call C_F_Pointer(C_Loc(Buf(1)),cBuf,[lBuf])
      Call bDaFile(Lu,iOpt,cBuf,lBuf,iDisk)
      Nullify(cBuf)

      iDisk_=(iDisk+MBL(Lu)-1)/MBL(Lu)

      Return
      End Subroutine iDaFile_Internal
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ext(wrk,wrksize,nind,exttyp,u,v,ssu,ssv,ssx,a,ssa,b,ssb,rc)
! this routine realizes extraction
!
! A(indA) -> B_u(indB) for given u
!
! nind   - # of indices in matrix A  (Input)
! exttyp - type of extraction :  (Input)
!          1 - A(pqrs) -> B_p (qrs); A(pqr) -> B_p(qr) ; A(pq) -> B_p(q)
!          2 - A(pqrs) -> B_q (prs); A(pqr) -> B_q(p,r); A(pq) -> B_q(p)
!          3 - A(pqrs) -> B_r (pqs); A(pqr) -> B_r(pq)
!          4 - A(pqrs) -> B_s (pqr)
!          5 - A(pqrs) -< A_pq(rs) ; A(pqr) -> B_pq(r)
!          6 - A(pqrs) -> B_qr(p,s); A(pqr) -> B_pq(r)
!          7 - A(pqrs) -> B_rs(pq)
!          8 - A(pqrs) -> B_pqr(s)
!          9 - A(pqrs) -> B_qrs(p)
! u      - value of 1st fix index (I)
! v      - value of 2nd fix index (I)
! ssu    - symmetry of 1st fix index (I)
! ssv    - symmetry of 2nd fix index (I)
! ssx    - symmetry of 3rd fix index (I)
! a      - A  (Input)
! ssa    - overall symmetry state of matrix A  (Input)
! b      - B  (Input/Output)
! ssb    - overall symmetry state of matrix B  (Output)
! rc     - return (error) code  (Output)
!
! Table of extractions
!
! nind  exttyp          Operation             Implementation
!
! 4       1     A(p,q,r,s) -> B _p(q,r,s)          Yes
!               A(pq,r,s)  -> B _p(q,r,s)          Yes
!               A(p,qr,s)  -> B _p(qr,s)           NCI
!               A(p,q,rs)  -> B _p(q,rs)           Yes
!               B(pq,rs)   -> B _p(q,rs)           Yes
!
! 4       2     A(p,q,r,s) -> B _q(p,r,s)          Yes
!               A(pq,r,s)  -> B _q(p,r,s)     No (use 4,1)
!               A(p,qr,s)  -> B _q(p,r,s)          NCI
!               A(p,q,rs)  -> B _q(p,rs)           Yes
!               B(pq,rs)   -> B _q(p,rs)      No (use 4,1)
!
! 4       3     A(p,q,r,s) -> B _r(p,q,s)          Yes
!               A(pq,r,s)  -> B _r(pq,s)           Yes
!               A(p,qr,s)  -> B _r(p,q,s)     No (use 4.2 - NCI)
!               A(p,q,rs)  -> B _r(p,q,s)          Yes
!               B(pq,rs)   -> B _r(pq,s)           Yes
!
! 4       4     A(p,q,r,s) -> B _s(p,q,r)          Yes
!               A(pq,r,s)  -> B _s(pq,r)           Yes
!               A(p,qr,s)  -> B _s(p,qr)           NCI
!               A(p,q,rs)  -> B _s(p,q,r)     No (use 4,3)
!               B(pq,rs)   -> B _s(pq,r)      No (use 4,3)
!
! 4       5     A(p,q,r,s) -> B _p_q (r,s)         Yes
!               A(pq,r,s)  -> B _pq (r,s)          NCI
!               A(p,qr,s)  -> B _p_q (r,s)         NCI
!               A(p,q,rs)  -> B _p_q (rs)          NCI
!               A(pq,rs)   -> B _pq (rs)           Yes
!
! 4       6     any case                           NCI
!
! 4       7     A(p,q,r,s) -> B _r_s (p,q)         Yes
!               A(pq,r,s)  -> B _r_s (pq)          NCI
!               A(p,qr,s)  -> B _r_s (p,q)         NCI
!               A(p,q,rs)  -> B _r_s (rs)          Yes
!               A(pq,rs)   -> B _pq (rs)           Yes
!
! 4      8,9    any case                           NCI
!
! 3   any case  any case                           NCI
!
! 2       1     A(p,q)     -> B _p (q)             Yes
!               A(pq)      -> B _p (q)             NCI
!
! 2       2     A(p,q)     -> B _q (p)             Yes
!               A(pq)      -> B _q (p)             NCI

use CCT3_global, only: dimm, Map_Type, mmul, nshf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, nind, exttyp, u, v, ssu, ssv, ssx, ssa
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: a
type(Map_Type), intent(inout) :: b
integer(kind=iwp), intent(out) :: ssb
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp) :: dimp, dimq, dimr, dims, ia, ib, jjind, key, nhelp1, nhelp2, posa, posb, post, signum, symp, symq, symr, syms, &
                     typa, typb

! To fix some warnings
symr = 0
!0.* some general tests

if (a%d(0,6) == 2) then
  ! RC=2  : nind=4, typA=2 (NCI)
  rc = 2
  return
end if

!0.* def typa and ssB

typa = a%d(0,6)
if (exttyp <= 4) then
  ! one external index
  ssb = mmul(ssa,ssu)
else if (exttyp <= 7) then
  ! two external indices
  nhelp1 = mmul(ssu,ssv)
  ssb = mmul(ssa,nhelp1)
else
  ! three external indices
  nhelp1 = mmul(ssu,ssv)
  nhelp2 = mmul(nhelp1,ssx)
  ssb = mmul(nhelp2,ssa)
end if

if (nind == 4) then

  !4 A(pqrs) -> B(stv)

  if (exttyp == 1) then

    !4.1 A(pqrs) -> B_p(qrs)

    if (typa == 0) then

      !4.1.0 **** case A(p,q,r,s) -> B_p(q,r,s) ****

      !4.1.0.* get b%d,b%i
      typb = 0
      call cct3_grc0(3,typb,a%d(0,2),a%d(0,3),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.1.0.* def symmetry of all indices
        symq = b%d(ib,3)
        symr = b%d(ib,4)
        syms = b%d(ib,5)

        !4.1.0.* find proper A
        ia = a%i(ssu,symq,symr)

        !4.1.0.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.1.0.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))
        nhelp1 = dimq*dimr*dims

        !4.1.0.* realize extraction
        call exth1(wrk(posa),wrk(posb),dimp,nhelp1,u,1)

      end do

    else if (typa == 1) then

      !4.1.1**** case A(pq,r,s) -> B_p(q,r,s) ****

      typb = 0
      call cct3_grc0(3,typb,a%d(0,2),a%d(0,3),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.1.1.* def symmetry of all indices
        symq = b%d(ib,3)
        symr = b%d(ib,4)
        syms = b%d(ib,5)

        !4.1.1.* def key su>sq - 1 ; su=sq - 2 ; su<sq - 3
        if (ssu > symq) then
          key = 1
        else if (ssu == symq) then
          key = 2
        else
          key = 3
        end if

        !4.1.1.* find proper A
        if (key < 3) then
          ia = a%i(ssu,symq,symr)
        else
          ia = a%i(symq,ssu,symr)
        end if

        !4.1.1.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.1.1.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))

        !4.1.1.* realize extraction
        if (key == 1) then
          nhelp1 = dimq*dimr*dims
          call exth1(wrk(posa),wrk(posb),dimp,nhelp1,u,1)
        else if (key == 2) then
          nhelp1 = dimp*(dimp-1)/2
          nhelp2 = dimr*dims
          call exth4(wrk(posa),wrk(posb),dimp,nhelp1,nhelp2,u)
        else
          ! key=3
          nhelp1 = dimr*dims
          call exth3(wrk(posa),wrk(posb),dimq,dimp,nhelp1,u,-1)
        end if

      end do

    else if (typa == 2) then

      !4.1.2 **** case A(p,qr,s) -> B_p(qr,s) ****
      ! NCI

    else if (typa == 3) then

      !4.1.3 **** case A(p,q,rs) -> B_p(q,rs) ****

      typb = 2
      call cct3_grc0(3,typb,a%d(0,2),a%d(0,3),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.1.3.* def symmetry of all indices
        symq = b%d(ib,3)
        symr = b%d(ib,4)
        syms = b%d(ib,5)

        !4.1.3.* find proper A
        ia = a%i(ssu,symq,symr)

        !4.1.3.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.1.3.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))
        if (symr == syms) then
          nhelp1 = dimq*dimr*(dimr-1)/2
        else
          nhelp1 = dimq*dimr*dims
        end if

        !4.1.3.* realize extraction
        call exth1(wrk(posa),wrk(posb),dimp,nhelp1,u,1)

      end do

    else if (typa == 4) then

      !4.1.4 **** case A(pq,rs) -> B_p(q,rs) ****

      typb = 2
      call cct3_grc0(3,typb,a%d(0,2),a%d(0,3),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.1.4.* def symmetry of all indices
        symq = b%d(ib,3)
        symr = b%d(ib,4)
        syms = b%d(ib,5)

        !4.1.4.* def key su>sq - 1 ; su=sq - 2 ; su<sq - 3
        if (ssu > symq) then
          key = 1
        else if (ssu == symq) then
          key = 2
        else
          key = 3
        end if

        !4.1.4.* find proper A
        if (key < 3) then
          ia = a%i(ssu,symq,symr)
        else
          ia = a%i(symq,ssu,symr)
        end if

        !4.1.4.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.1.4.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))

        !4.1.4.* realize extraction

        if (key == 1) then
          if (symr == syms) then
            nhelp1 = dimq*dimr*(dimr-1)/2
          else
            nhelp1 = dimq*dimr*dims
          end if
          call exth1(wrk(posa),wrk(posb),dimp,nhelp1,u,1)

        else if (key == 2) then
          nhelp1 = dimp*(dimp-1)/2
          if (symr == syms) then
            nhelp2 = dimr*(dimr-1)/2
          else
            nhelp2 = dimr*dims
          end if
          call exth4(wrk(posa),wrk(posb),dimp,nhelp1,nhelp2,u)

        else
          ! key=3
          if (symr == syms) then
            nhelp1 = dimr*(dimr-1)/2
          else
            nhelp1 = dimr*dims
          end if
          call exth3(wrk(posa),wrk(posb),dimq,dimp,nhelp1,u,-1)
        end if

      end do

    end if

  else if (exttyp == 2) then

    !4.2 A(pqrs) -> B_q(prs)

    if ((typa == 0) .or. (typa == 3)) then

      !4.2.0 case A(p,q,r,s) -> B_q(p,r,s)

      typb = 0
      call cct3_grc0(3,typb,a%d(0,1),a%d(0,3),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.2.0.* def symmetry of all indices
        symp = b%d(ib,3)
        symr = b%d(ib,4)
        syms = b%d(ib,5)

        !4.2.0.* find proper A
        ia = a%i(symp,ssu,symr)

        !4.2.0.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.2.0.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))
        nhelp1 = dimr*dims

        !4.2.0.* realize extraction
        call exth3(wrk(posa),wrk(posb),dimp,dimq,nhelp1,u,1)

      end do

    else if (typa == 1) then

      !4.2.1 case A(pq,r,s) -> B_q(p,r,s)

      ! RC=3 : nind=4, typA=1, exttyp=2 (NI - Use exttyp 1)
      rc = 3
      return

    else if (typa == 2) then

      !4.2.2 case A(p,qr,s) -> B_q(p,r,s)

      ! RC=4 : nind=4, typA=2 (NCI)
      rc = 4
      return

    else if (typa == 3) then

      !4.2.3 case A(p,q,rs) -> B_q(p,rs)

      typb = 2
      call cct3_grc0(3,typb,a%d(0,1),a%d(0,3),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.2.3.* def symmetry of all indices
        symp = b%d(ib,3)
        symr = b%d(ib,4)
        syms = b%d(ib,5)

        !4.2.3.* find proper A
        ia = a%i(symp,ssu,symr)

        !4.2.3.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.2.3.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))
        if (symr == syms) then
          nhelp1 = dimr*(dimr-1)/2
        else
          nhelp1 = dimr*dims
        end if

        !4.2.3.* realize extraction
        call exth3(wrk(posa),wrk(posb),dimp,dimq,nhelp1,u,1)

      end do

    else if (typa == 4) then

      !4.2.4 case A(pq,r,s) -> B_q(p,r,s)

      ! RC=5 : nind=4, typA=4, exttyp=2 (NI - Use exttyp 1)
      rc = 5
      return

    end if

  else if (exttyp == 3) then

    !4.3 A(pqrs) -> B_r(pqs)

    if (typa == 0) then

      !4.3.0 case A(p,q,r,s) -> B_r(p,q,s)

      typb = 0
      call cct3_grc0(3,typb,a%d(0,1),a%d(0,2),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.3.0.* def symmetry of all indices
        symp = b%d(ib,3)
        symq = b%d(ib,4)
        syms = b%d(ib,5)

        !4.3.0.* find proper A
        ia = a%i(symp,symq,ssu)

        !4.3.0.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.3.0.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))
        nhelp1 = dimp*dimq

        !4.3.0.* realize extraction
        call exth3(wrk(posa),wrk(posb),nhelp1,dimr,dims,u,1)

      end do

    else if (typa == 1) then

      !4.3.1 case A(pq,r,s) -> B_r(pq,s)

      typb = 1
      call cct3_grc0(3,typb,a%d(0,1),a%d(0,2),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.3.1.* def symmetry of all indices
        symp = b%d(ib,3)
        symq = b%d(ib,4)
        syms = b%d(ib,5)

        !4.3.1.* find proper A
        ia = a%i(symp,symq,ssu)

        !4.3.1.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.3.1.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))
        if (symp == symq) then
          nhelp1 = dimp*(dimp-1)/2
        else
          nhelp1 = dimp*dimq
        end if

        !4.3.1.* realize extraction
        call exth3(wrk(posa),wrk(posb),nhelp1,dimr,dims,u,1)

      end do

    else if (typa == 2) then

      !4.3.2 case A(p,qr,s) -> B_r(p,q,s)

      ! RC=6 : nind=4, typA=2 (NCI)
      rc = 6
      return

    else if (typa == 3) then

      !4.3.3 case A(p,q,rs) -> B_r(p,q,s)

      typb = 0
      call cct3_grc0(3,typb,a%d(0,1),a%d(0,2),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.3.3.* def symmetry of all indices
        symp = b%d(ib,3)
        symq = b%d(ib,4)
        syms = b%d(ib,5)

        !4.3.3.* def key su>ss - 1 ; su=ss - 2 ; su<ss - 3
        if (ssu > syms) then
          key = 1
        else if (ssu == syms) then
          key = 2
        else
          key = 3
        end if

        !4.3.3.* find proper A
        if (key < 3) then
          ia = a%i(symp,symq,ssu)
        else
          ia = a%i(symp,symq,symr)
        end if

        !4.3.3.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.3.3.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))

        !4.3.3.* realize extraction
        if (key == 1) then
          nhelp1 = dimp*dimq
          call exth3(wrk(posa),wrk(posb),nhelp1,dimr,dims,u,1)
        else if (key == 2) then
          nhelp1 = dimp*dimq
          nhelp2 = dimr*(dimr-1)/2
          call exth5(wrk(posa),wrk(posb),nhelp1,dimr,nhelp2,u)
        else
          ! key=3
          nhelp1 = dimp*dimq
          call exth3(wrk(posa),wrk(posb),nhelp1,dims,dimr,u,-1)
        end if

      end do

    else if (typa == 4) then

      !4.3.4 case A(pq,rs) -> B_r(pq,s)

      typb = 1
      call cct3_grc0(3,typb,a%d(0,1),a%d(0,2),a%d(0,4),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.3.4.* def symmetry of all indices
        symp = b%d(ib,3)
        symq = b%d(ib,4)
        syms = b%d(ib,5)

        !4.3.4.* def key su>ss - 1 ; su=ss - 2 ; su<ss - 3
        if (ssu > syms) then
          key = 1
        else if (ssu == syms) then
          key = 2
        else
          key = 3
        end if

        !4.3.4.* find proper A
        if (key < 3) then
          ia = a%i(symp,symq,ssu)
        else
          ia = a%i(symp,symq,syms)
        end if

        !4.3.4.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.3.4.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))

        !4.3.4.* realize extraction
        if (key == 1) then
          if (symp == symq) then
            nhelp1 = dimp*(dimq-1)/2
          else
            nhelp1 = dimp*dimq
          end if
          call exth3(wrk(posa),wrk(posb),nhelp1,dimr,dims,u,1)
        else if (key == 2) then
          if (symp == symq) then
            nhelp1 = dimp*(dimq-1)/2
          else
            nhelp1 = dimp*dimq
          end if
          nhelp2 = dimr*(dimr-1)/2
          call exth5(wrk(posa),wrk(posb),nhelp1,dimr,nhelp2,u)
        else
          ! key=3
          if (symp == symq) then
            nhelp1 = dimp*(dimq-1)/2
          else
            nhelp1 = dimp*dimq
          end if
          nhelp1 = nhelp1*dimr
          call exth2(wrk(posa),wrk(posb),nhelp1,dims,u,-1)
        end if

      end do

    end if

  else if (exttyp == 4) then

    !4.4  case A(pqrs) -> B_s(pqr)

    if (typa == 0) then

      !4.4.0case A(p,q,r,s) -> B_s(p,q,r)

      typb = 0
      call cct3_grc0(3,typb,a%d(0,1),a%d(0,2),a%d(0,3),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.4.0.*      def symmetry of all indices
        symp = b%d(ib,3)
        symq = b%d(ib,4)
        symr = b%d(ib,5)

        !4.4.0.*      find proper A
        ia = a%i(symp,symq,symr)

        !4.4.0.*      def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.4.0.*      def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))
        nhelp1 = dimp*dimq*dimr

        !4.4.0.*      realize extraction
        call exth2(wrk(posa),wrk(posb),nhelp1,dims,u,1)

      end do

    else if (typa == 1) then

      !4.4.1 case A(pq,r,s) -> B_s(pq,r)

      typb = 1
      call cct3_grc0(3,typb,a%d(0,1),a%d(0,2),a%d(0,3),0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.4.1.* def symmetry of all indices
        symp = b%d(ib,3)
        symq = b%d(ib,4)
        symr = b%d(ib,5)

        !4.4.1.* find proper A
        ia = a%i(symp,symq,symr)

        !4.4.1.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.4.1.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))

        !4.4.1.* realize extraction
        if (symp == symq) then
          nhelp1 = dimp*(dimq-1)*dimr/2
        else
          nhelp1 = dimp*dimq*dimr
        end if
        call exth2(wrk(posa),wrk(posb),nhelp1,dims,u,1)

      end do

    else if (typa == 2) then

      !4.4.2 case A(p,qr,s) -> B_s(p,qr)

      ! RC=7 : nind=4, typA=2  (NCI)
      rc = 7
      return

    else if (typa == 3) then

      !4.4.3 case A(p,q,rs) -> B_s(p,q,r)

      ! RC=8 : nind=4, typA=3, exttyp=4 (NI - Use exttyp 3)
      rc = 8
      return

    else if (typa == 4) then

      !4.4.4 case A(pq,rs) -> B_s(pq,r)

      ! RC=9 : nind=4, typA=4, exttyp=4 (NI - Use exttyp 3)
      rc = 9
      return

    end if

  else if (exttyp == 5) then

    !4.5 case A(pqrs) -> B_pq(rs)

    if (typa == 0) then

      !4.5.0 case A(p,q,r,s) -> B_p_q(r,s)

      typb = 0
      call cct3_grc0(2,typb,a%d(0,3),a%d(0,4),0,0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.5.0.* def symmetry of all indices
        symr = b%d(ib,3)
        syms = b%d(ib,4)

        !4.5.0.* find proper A
        ia = a%i(ssu,ssv,symr)

        !4.5.0.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.5.0.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))
        nhelp1 = dimp*dimq
        nhelp2 = dimr*dims
        jjind = (v-1)*dimp+u

        !4.5.0.* realize extraction
        call exth1(wrk(posa),wrk(posb),nhelp1,nhelp2,jjind,1)

      end do

    else if (typa == 4) then

      !4.5.4 case A(pq,rs) -> B_pq(rs)

      typb = 1
      call cct3_grc0(2,typb,a%d(0,3),a%d(0,4),0,0,ssb,b,post)

      if (ssu >= ssv) then
        !4.5.4.1 case symp >= symq

        do ib=1,b%d(0,5)

          !4.5.4.1.* def symmetry of all indices
          symr = b%d(ib,3)
          syms = b%d(ib,4)

          !4.5.4.1.* find proper A
          ia = a%i(ssu,ssv,symr)

          !4.5.4.1.* def positions of A and B
          posa = a%d(ia,1)
          posb = b%d(ib,1)

          !4.5.4.1.* def dimensions
          dimp = dimm(a%d(0,1),a%d(ia,3))
          dimq = dimm(a%d(0,2),a%d(ia,4))
          dimr = dimm(a%d(0,3),a%d(ia,5))
          dims = dimm(a%d(0,4),a%d(ia,6))

          if (ssu == ssv) then
            nhelp1 = dimp*(dimp-1)/2
          else
            nhelp1 = dimp*dimq
          end if

          if (symr == syms) then
            nhelp2 = dimr*(dimr-1)/2
          else
            nhelp2 = dimr*dims
          end if

          !4.5.4.1.* def joined index and signum
          signum = 1
          if (ssu == ssv) then
            if (u > v) then
              jjind = nshf(u)+v
            else if (u == v) then
              jjind = 0
              signum = 0
            else
              jjind = nshf(v)+u
              signum = -1
            end if
          else
            jjind = (v-1)*dimp+u
          end if

          !4.5.4.1.* realize extraction
          call exth1(wrk(posa),wrk(posb),nhelp1,nhelp2,jjind,signum)

        end do

      else
        !4.5.4.2 case symp < symq

        do ib=1,b%d(0,5)

          !4.5.4.2.* def symmetry of all indices
          symr = b%d(ib,3)
          syms = b%d(ib,4)

          !4.5.4.2.* find proper A
          ia = a%i(ssv,ssu,symr)

          !4.5.4.2.* def positions of A and B
          posa = a%d(ia,1)
          posb = b%d(ib,1)

          !4.5.4.2.* def dimensions
          dimq = dimm(a%d(0,1),a%d(ia,3))
          dimp = dimm(a%d(0,2),a%d(ia,4))
          dimr = dimm(a%d(0,3),a%d(ia,5))
          dims = dimm(a%d(0,4),a%d(ia,6))

          nhelp1 = dimp*dimq

          if (symr == syms) then
            nhelp2 = dimr*(dimr-1)/2
          else
            nhelp2 = dimr*dims
          end if

          !4.5.4.2.*   def joined index and signum
          signum = -1
          jjind = (u-1)*dimp+v

          !4.5.4.2.* realize extraction
          call exth1(wrk(posa),wrk(posb),nhelp1,nhelp2,jjind,signum)

        end do

      end if

    else
      ! RC=10 , nindA=4, exttyp=5, typa is nou 0,4 (NCI)
      rc = 10
      return
    end if

  else if (exttyp == 7) then

    !4.7 case A(pqrs) -> B_rs(pq)

    if (typa == 0) then

      !4.7.0 case A(p,q,r,s) -> B_r_s(p,q)

      typb = 0
      call cct3_grc0(2,typb,a%d(0,1),a%d(0,2),0,0,ssb,b,post)

      do ib=1,b%d(0,5)

        !4.7.0.* def symmetry of all indices
        symp = b%d(ib,3)
        symq = b%d(ib,4)

        !4.7.0.* find proper A
        ia = a%i(symp,symq,ssu)

        !4.7.0.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !4.7.0.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))
        dimr = dimm(a%d(0,3),a%d(ia,5))
        dims = dimm(a%d(0,4),a%d(ia,6))
        nhelp1 = dimp*dimq
        nhelp2 = dimr*dims
        jjind = (v-1)*dimr+u

        !4.7.0.* realize extraction
        call exth2(wrk(posa),wrk(posb),nhelp1,nhelp2,jjind,1)

      end do

    else if (typa == 3) then

      !4.7.3 case A(p,q,rs) -> B_rs(p,q)

      typb = 2
      call cct3_grc0(2,typb,a%d(0,1),a%d(0,2),0,0,ssb,b,post)

      if (ssu >= ssv) then
        !4.7.3.1 case symr >= syms

        do ib=1,b%d(0,5)

          !4.7.3.1.* def symmetry of all indices
          symp = b%d(ib,3)
          symq = b%d(ib,4)

          !4.7.3.1.* find proper A
          ia = a%i(symp,symq,ssu)

          !4.7.3.1.* def positions of A and B
          posa = a%d(ia,1)
          posb = b%d(ib,1)

          !4.7.3.1.* def dimensions
          dimp = dimm(a%d(0,1),a%d(ia,3))
          dimq = dimm(a%d(0,2),a%d(ia,4))
          dimr = dimm(a%d(0,3),a%d(ia,5))
          dims = dimm(a%d(0,4),a%d(ia,6))

          if (ssu == ssv) then
            nhelp1 = dimr*(dimr-1)/2
          else
            nhelp1 = dimr*dims
          end if

          nhelp2 = dimp*dimq

          !4.7.3.1.* def joined index and signum
          signum = 1
          if (ssu == ssv) then
            if (u > v) then
              jjind = nshf(u)+v
            else if (u == v) then
              jjind = 0
              signum = 0
            else
              jjind = nshf(v)+u
              signum = -1
            end if
          else
            jjind = (v-1)*dimr+u
          end if

          !4.7.3.1.* realize extraction
          call exth2(wrk(posa),wrk(posb),nhelp2,nhelp1,jjind,signum)

        end do

      else
        !4.7.3.2 case symp < symq

        do ib=1,b%d(0,5)

          !4.7.3.2.* def symmetry of all indices
          symp = b%d(ib,3)
          symq = b%d(ib,4)

          !4.7.3.2.* find proper A
          ia = a%i(symp,symq,ssv)

          !4.7.3.2.* def positions of A and B
          posa = a%d(ia,1)
          posb = b%d(ib,1)

          !4.7.3.2.* def dimensions
          dimq = dimm(a%d(0,1),a%d(ia,3))
          dimp = dimm(a%d(0,2),a%d(ia,4))
          dimr = dimm(a%d(0,3),a%d(ia,5))
          dims = dimm(a%d(0,4),a%d(ia,6))

          nhelp1 = dimr*dims

          nhelp2 = dimp*dimq

          !4.7.3.2.*   def joined index and signum
          signum = -1
          jjind = (u-1)*dimr+v

          !4.7.3.2.* realize extraction
          call exth2(wrk(posa),wrk(posb),nhelp2,nhelp1,jjind,signum)

        end do

      end if

    else if (typa == 4) then

      !4.7.4 case A(pq,rs) -> B_rs(pq)

      typb = 1
      call cct3_grc0(2,typb,a%d(0,1),a%d(0,2),0,0,ssb,b,post)

      if (ssu >= ssv) then
        !4.7.4.1 case symr >= syms

        do ib=1,b%d(0,5)

          !4.7.4.1.* def symmetry of all indices
          symp = b%d(ib,3)
          symq = b%d(ib,4)

          !4.7.4.1.* find proper A
          ia = a%i(symp,symq,ssu)

          !4.7.4.1.* def positions of A and B
          posa = a%d(ia,1)
          posb = b%d(ib,1)

          !4.7.4.1.* def dimensions
          dimp = dimm(a%d(0,1),a%d(ia,3))
          dimq = dimm(a%d(0,2),a%d(ia,4))
          dimr = dimm(a%d(0,3),a%d(ia,5))
          dims = dimm(a%d(0,4),a%d(ia,6))

          if (ssu == ssv) then
            nhelp1 = dimr*(dimr-1)/2
          else
            nhelp1 = dimr*dims
          end if

          if (symp == symq) then
            nhelp2 = dimp*(dimp-1)/2
          else
            nhelp2 = dimp*dimq
          end if

          !4.7.4.1.* def joined index and signum
          signum = 1
          if (ssu == ssv) then
            if (u > v) then
              jjind = nshf(u)+v
            else if (u == v) then
              jjind = 0
              signum = 0
            else
              jjind = nshf(v)+u
              signum = -1
            end if
          else
            jjind = (v-1)*dimr+u
          end if

          !4.7.4.1.* realize extraction
          call exth2(wrk(posa),wrk(posb),nhelp2,nhelp1,jjind,signum)

        end do

      else
        !4.7.4.2 case symp < symq

        do ib=1,b%d(0,5)

          !4.7.4.2.* def symmetry of all indices
          symp = b%d(ib,3)
          symq = b%d(ib,4)

          !4.7.4.2.* find proper A
          ia = a%i(symp,symq,ssv)

          !4.7.4.2.* def positions of A and B
          posa = a%d(ia,1)
          posb = b%d(ib,1)

          !4.7.4.2.* def dimensions
          dimq = dimm(a%d(0,1),a%d(ia,3))
          dimp = dimm(a%d(0,2),a%d(ia,4))
          dimr = dimm(a%d(0,3),a%d(ia,5))
          dims = dimm(a%d(0,4),a%d(ia,6))

          nhelp1 = dimr*dims

          if (symp == symq) then
            nhelp2 = dimp*(dimp-1)/2
          else
            nhelp2 = dimp*dimq
          end if

          !4.7.4.2.* def joined index and signum
          signum = -1
          jjind = (u-1)*dimr+v

          !4.7.4.2.* realize extraction
          call exth2(wrk(posa),wrk(posb),nhelp2,nhelp1,jjind,signum)

        end do

      end if

    else
      ! RC=11 , nindA=4, exttyp=7, typa is nou 0,4 (NCI)
      rc = 11
      return
    end if

  else
    ! RC=12  nindA=4, exttyp 1,2,3,4,5 or 7 (Stup/NCI)
    rc = 12
    return

  end if

else if (nind == 2) then

  if (exttyp == 1) then

    !2.1 case A(p q) -> A _p(q)

    if (typa == 0) then

      !2.1.0 case A(p,q) -> B _p(q)

      typb = 0
      call cct3_grc0(1,typb,a%d(0,2),0,0,0,ssb,b,post)

      do ib=1,b%d(0,5)

        !2.1.0.* def symmetry of all indices
        symq = b%d(ib,3)

        !2.1.0.* find proper A
        ia = a%i(ssu,1,1)

        !2.1.0.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !2.1.0.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))

        !2.1.0.* realize extraction
        call exth1(wrk(posa),wrk(posb),dimp,dimq,u,1)

      end do

    else
      ! RC=13  : nindA=2, exttyp=1, typa is not 0 (NCI)
      rc = 13
      return
    end if

  else if (exttyp == 2) then

    !2.2 case A(p q) -> A _q(p)

    if (typa == 0) then

      !2.2.0 case A(p,q) -> B _q(p)

      typb = 0
      call cct3_grc0(1,typb,a%d(0,1),0,0,0,ssb,b,post)

      do ib=1,b%d(0,5)

        !2.2.0.* def symmetry of all indices
        symp = b%d(ib,3)

        !2.2.0.* find proper A
        ia = a%i(symp,1,1)

        !2.2.0.* def positions of A and B
        posa = a%d(ia,1)
        posb = b%d(ib,1)

        !2.2.0.* def dimensions
        dimp = dimm(a%d(0,1),a%d(ia,3))
        dimq = dimm(a%d(0,2),a%d(ia,4))

        !2.2.0.* realize extraction
        call exth2(wrk(posa),wrk(posb),dimp,dimq,u,1)

      end do

    else
      ! RC=14  : nindA=2, exttyp=2, typa is not 0 (NCI)
      rc = 14
      return
    end if

  else
    ! RC=15  : nindA=2, exttyp is not 1,2 (Stup)
    rc = 15
    return

  end if

else
  ! RC=16  nindA is not 2 or 4 (NCI)
  rc = 16
  return

end if

return

end subroutine ext

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Map2_21 (A,B,d1,d2)
c
c       this routine do:
c       map B(21) <- A(12)
c
        implicit none
        integer d1,d2
        real*8 A(1:d1,1:d2)
        real*8 B(1:d2,1:d1)
c
c       help variables
        integer i1,i2
c
        do i1=1,d1
        do i2=1,d2
        b(i2,i1)=a(i1,i2)
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine contcasb1SO(l1,l2,l3,l4,nstart,primints,
     *scratch1,scratch2,cont4SO)
cbs   contraction for powers (0)  with alpha1
cbs   this is one of the cases b in the documentation
      implicit real*8 (a-h,o-z)
#include "para.fh"
#include "param.fh"
      dimension ncont(4),nprim(4),primints(*),scratch1(*),scratch2(*),
     *cont4SO(*)
      ncont(1)=ncontrac(l1)
      ncont(2)=ncontrac(l2)
      ncont(3)=ncontrac(l3)
      ncont(4)=ncontrac(l4)
      nprod=ncont(1)*ncont(2)*ncont(3)*ncont(4)
      nprim(1)=nprimit(l1)
      nprim(2)=nprimit(l2)
      nprim(3)=nprimit(l3)
      nprim(4)=nprimit(l4)
cbs   copy primitive integrals to scratch1
      ilength=nprim(1)*nprim(2)*nprim(3)*nprim(4)
      do IRUN=1,ilength
      scratch1(IRUN)=primints(IRUN)
      enddo
      call contract(
     *contrarray(iaddtyp4(l1)),
     *contrarray(iaddtyp1(l2)),
     *contrarray(iaddtyp3(l3)),
     *contrarray(iaddtyp1(l4)),
     *ncont,   ! i-th element is number of contracted functions i. index
     *nprim,   ! i-th element is number of primitive functions  i. index
     *scratch1,scratch2)
      call dcopy_(nprod,scratch1(1),1,cont4SO(nstart),1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Modify_NQ_grid()

use Grid_On_Disk, only: iGrid_Set, Intermediate
use nq_Info, only: Crowding, L_Quad, L_Quad_Save, nR, nR_Save, Quadrature, ThrC, Threshold, Threshold_save
use Constants, only: One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), parameter :: L_Quad_Low = 23, nR_Low = 50
real(kind=wp), parameter :: Threshold_High = 1.0e-7_wp

!                                                                      *
!***********************************************************************
!                                                                      *
! Reduce the size and the accuracy of the grid temporarily

L_Quad_Save = L_Quad
Threshold_save = Threshold
nR_Save = nR
ThrC = Crowding

L_Quad = min(L_Quad,L_Quad_Low)
if (Quadrature(1:3) == 'LMG') then
  Threshold = max(Threshold_High,Threshold)
else
  nR = min(nR_Low,nR)
end if
Crowding = max(ThrC-Two,One)

write(u6,*)
write(u6,*) 'Modify the NQ grid!'
write(u6,*)
call Funi_Print()
!                                                                      *
!***********************************************************************
!                                                                      *
! Change the Grid set index.

iGrid_Set = Intermediate
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Modify_NQ_grid

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Prepare(nGrdPt,ipGrid,ipB,ipGrdI)
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iChTbl
      Implicit Real*8 (A-H,O-Z)
*
*     Some stuff for preparing the gradient integral computation
*
#include "espf.fh"
*
#include "disp.fh"
      Logical TstFnc, DoRys
      Character*1 xyz(0:2)
      Data xyz/'x','y','z'/
*
*
      LuWr=6
      DoRys = .True.
      nDiff = 3
      Call IniSew(DoRys,nDiff)
*
*     Copy the grid coordinates and weights in ONE array
*     This is the only solution I found to pass info trough oneel_g !
*
      Do iPnt = 1, nGrdPt
         Work(ipGrdI+(iPnt-1)*4  ) = Work(ipGrid+(iPnt-1)*3  )
         Work(ipGrdI+(iPnt-1)*4+1) = Work(ipGrid+(iPnt-1)*3+1)
         Work(ipGrdI+(iPnt-1)*4+2) = Work(ipGrid+(iPnt-1)*3+2)
         Work(ipGrdI+(iPnt-1)*4+3) = Work(ipB+iPnt-1)
      EndDo
*
      nCnttp_Valence=0
      Do iCnttp = 1, nCnttp
         If (dbsc(iCnttp)%Aux) Exit
         nCnttp_Valence = nCnttp_Valence+1
      End Do
*
*---- Compute number of centers and displacements. Ignore pseudo centers.
*     If any pseudo centers disable use of translational and rotational
*     invariance.
*
      mDisp = 0
      mdc = 0
      Do 10 iCnttp = 1, nCnttp_Valence
         If (dbsc(iCnttp)%pChrg) Then
             mdc = mdc + dbsc(iCnttp)%nCntr
             Go To 10
         End If
         Do 20 iCnt = 1, dbsc(iCnttp)%nCntr
            mdc = mdc + 1
            mDisp = mDisp + 3*(nIrrep/dc(mdc)%nStab)
 20      Continue
 10   Continue
*
*
*     Initialize the Direct array. Why? I don't know.
*
      Do i = 1, 3*MxAtom
         Direct(i) = .True.
      EndDo
*
*     Generate symmetry adapted cartesian displacements
*
      Call ICopy(MxAtom*8,[0],0,IndDsp,1)
      Call ICopy(MxAtom*3,[0],0,InxDsp,1)
      call dcopy_(3*MxSym*MxAtom,[One],0,Disp_Fac,1)
      Call ICopy(3*MxAtom,[1],0,mult_Disp,1)
      nDisp = 0
      Do iIrrep = 0, nIrrep-1
         lDisp(iIrrep) = 0
*        Loop over basis function definitions
         mdc = 0
         mc = 1
         Do iCnttp = 1, nCnttp_Valence
*           Loop over unique centers associated with this basis set.
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = mdc + 1
               IndDsp(mdc,iIrrep) = nDisp
*              Loop over the cartesian components
               Do iCar = 0, 2
                  iComp = 2**iCar
                  If ( TstFnc(dc(mdc)%iCoSet,
     &                       iIrrep,iComp,dc(mdc)%nStab) .and.
     &                .Not.dbsc(iCnttp)%pChrg ) Then
                      nDisp = nDisp + 1
                      If (iIrrep.eq.0) InxDsp(mdc,iCar+1) = nDisp
                      lDisp(iIrrep) = lDisp(iIrrep) + 1
                      mult_Disp(nDisp)=nIrrep/dc(mdc)%nStab
                      If (iIrrep.eq.0) Then
                         Do jOper = 0, nIrrep-1
                            Disp_Fac(iCar+1,jOper,mdc)=
     &                        iPrmt( jOper ,iComp) *iChTbl(iIrrep,jOper)
                         End Do
                      End If
                      Write (ChDisp(nDisp),'(A,1X,A1)')
     &                       dc(mdc)%LblCnt,xyz(iCar)

                  End If
               End Do
               mc = mc + nIrrep/dc(mdc)%nStab
            End Do
         End Do
*
      End Do
*
      If (nDisp.ne.mDisp) Then
         Call WarningMessage(2,'Error in espf/prepare')
         Write (LuWr,*)
     &      ' Wrong number of symmetry adapted displacements',
     &       nDisp,'=/=',mDisp
         Call Abend()
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

!>  @brief
!>    Transform the active one-body density from MO to AO basis
!>
!>  @author
!>    Markus P. Fuelscher
!>
!>  @details
!>  The underlying equation is the basis transformatin:
!>  \f[ D^{\text{AO}} = C D C^\dagger \f]
!>  For the aktive orbitals this becomes:
!>  \f[ D^{\text{AO}, A} = C^A D^A (C^A)^\dagger \f]
!>  Where (\f$ C^A, D^A \f$) are the coefficients and densities of the active MOs.
!>
!>  @param[in] CMO The MO-coefficients
!>  @param[in] D1A_MO The active one-body density matrix in MO-space
!>  @param[out] D1A_AO The active one-body density matrix in AO-space
subroutine Get_D1A_RASSCF(CMO,D1A_MO,D1A_AO)
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use general_data, only: nAsh, nBas, nFro, nIsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*), D1A_MO(*)
real(kind=wp), intent(_OUT_) :: D1A_AO(*)
integer(kind=iwp) :: iAsh, iBas, iFro, iIsh, iOff1, iOff2, iSym
real(kind=wp), allocatable :: Tmp1(:), Tmp2(:)

iOff1 = 1
iOff2 = 1
do iSym=1,nSym
  iBas = nBas(iSym)
  iAsh = nAsh(iSym)
  iIsh = nIsh(iSym)
  iFro = nFro(iSym)
  D1A_AO(iOff2:iOff2+iBas*iBas-1) = Zero
  if (iAsh /= 0) then
    call mma_allocate(Tmp1,iAsh*iAsh,Label='Tmp1')
    call mma_allocate(Tmp2,iAsh*iBas,Label='Tmp2')
    call Square(D1A_MO(iOff1),Tmp1,1,iAsh,iAsh)
    call DGEMM_('N','T',iBas,iAsh,iAsh, &
                One,CMO(iOff2+(iFro+iIsh)*iBas),iBas, &
                Tmp1,iAsh, &
                Zero,Tmp2,iBas)
    call DGEMM_('N','T',iBas,iBas,iAsh, &
                One,Tmp2,iBas, &
                CMO(iOff2+(iFro+iIsh)*iBas),iBas, &
                Zero,D1A_AO(iOff2),iBas)
    call mma_deallocate(Tmp2)
    call mma_deallocate(Tmp1)
  end if
  iOff1 = iOff1+nTri_Elem(iAsh)
  iOff2 = iOff2+iBas*iBas
end do

end subroutine Get_D1A_RASSCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
cmp      SUBROUTINE create_klvab_t3(G,vblock)
      SUBROUTINE create_klvab_t3(vblock)
C
C  creates K(alpha-beta,alpha-beta),K(beta-alpha,alpha-beta)
C  DA files KMATBA and KMATAB, LMATBA and LMATAB
C  creates L(alpha-beta,alpha-beta),K(beta-alpha,alpha-beta)
C  max G at this place
C  both matrices have to be available at a time (unfortunately)
C
C  parallelization irrelevant at the moment
C  implemented integer offsets, PV, 14 may 2004.
C
      IMPLICIT NONE
#include "ndisk.fh"
#include "dupfiles.fh"
cmp
#include "cht3_ccsd1.fh"
#include "ccsd_t3compat.fh"
#include "WrkSpc.fh"
cmpn
#include "cht3_reord.fh"
        integer i_blk,j_blk,b2_chk
        integer ngaf,ngal,ngbf,ngbl
        integer nind_ngbf,nind_ngbl,nind_ngaf,nind_ngal
        integer length,length1,length2
        integer it_exp,RAD_tmp
        integer a_tmp,b1_tmp,j_tmp
        integer nga,ngb
cmp
cmpn        integer AADT_tmp,it
c       integer jjj
cmp
cmpn
cmp      real*8 G(*),ddot_
c     real*8 ddot_
cmp      integer it,ix,ig,iscr, KADT, IJS, RAD, AADT, IADR
      integer ix,ig,iscr, KADT, IJS, RAD, AADT, IADR
      integer isp,is2,ias,vblock,n,i,j,k,lu,iasblock,ias_aa
      INTEGER A,A1,A2,B1,IADT,BADT,NSTEP,ISTEP
      CHARACTER FN*6,ich*1
      INTEGER IOPT,NOAB,NNOAB,NUAB,NNUAB,NNU,IUHF,NNO,ISPA,NNRED
      integer adim, last,last_aa,nug
c     integer bdim
      COMMON/UHF/NOAB(2),NNOAB(3),NUAB(2),NNUAB(3),ICH(3)
      COMMON/IOIND/IOPT(96)
cmp
        integer itmp,il1_1,il2_1,il0,il1,it2_tmp,itmp2
        logical switch
cmp
        if (printkey.ge.10) then
        write (6,*)
        write (6,*) '------ DimGrpaR ------'
        write (6,'(8(i5,2x))') (DimGrpaR(a_tmp),a_tmp=1,NvGrp)
        write (6,*)
        end if
c
c - calculate overall memory requirements
c
        call check_create_klvab_t3_mem (vblock)
c
cmp      call w_rescope(G,'G create KL')
cmp      call w_free(g,0,'G klvab ')
      N=noab(1)+nuab(1)
      NNRED=NOAB(1)*(NOAB(1)+1)/2
      IUHF=0
      IF(IOPT(76).NE.0)THEN
         IUHF=1
         NNRED=NNOAB(3)
      ENDIF
      LU=98

cmp      call w_alloc(it,NNOAB(3)*NNUAB(3),'IT klvab ')
cmp      call w_alloc(ix,vblock*vblock*n,'IX klvab ')
cmpn        call GetMem('create_it','Allo','Real',it,
cmpn     & NNOAB(3)*NNUAB(3))
        call GetMem('c1_ix','Allo','Real',ix,
     & vblock*vblock*n)
cmp!
c!      FN(1:6)='T2OLDC'
c!      CALL GET3DM(FN,G(it),NNUAB(3),NNRED,0)
cmp!

cmp        call w_alloc(it2_tmp,maxdim*maxdim*no*no,'ITMP klvab ')
cmp        call w_alloc(itmp,maxdim*maxdim*no*no,'ITMP klvab ')
cmpn        call GetMem('create_it2_tmp','Allo','Real',it2_tmp,
cmpn     & maxdim*maxdim*no*no)
cmpn        call GetMem('create_itmp','Allo','Real',itmp,
cmpn     & maxdim*maxdim*no*no)
c
cmp        call gather_t2(G(it),G(it2_tmp),G(itmp))
cmpn        call gather_t2(Work(it),Work(it2_tmp),Work(itmp))
c
c
cmp        call w_free(G(it2_tmp),0,'ITMP klvab ')
cmpn        call GetMem('create_itmp','Free','Real',itmp,
cmpn     & maxdim*maxdim*no*no)
cmpn        call GetMem('create_it2_tmp','Free','Real',it2_tmp,
cmpn     & maxdim*maxdim*no*no)

cmpn        write (6,*) 'T2 regenerated from MOLCAS'
cmpn        write (6,*)
c
cmp      call dscal_(NNUAB(3)*NNRED,-1.d0,G(it),1)
cmp         call dscal_(NNUAB(3)*NNOAB(3),-1.d0,G(it),1)
cmpn         call dscal_(NNUAB(3)*NNOAB(3),-1.d0,Work(it),1)
cmp      IF(IUHF.EQ.0) call decomp2ind(G(it),NNUAB(3),noab(1),NUAB(1))
       !!write(6,*)ddot_(nnoab(3)*nnuab(3),G(it),1,G(it),1)
c
C number of blocks written in a single multiwrite
C
      iasblock=vblock*vblock*N/nblock
      if((iasblock*nblock).lt.(vblock*vblock*N))iasblock=iasblock+1
C
      do isp=1,IUHF+1
         is2=3-isp
         FN(1:4)='KMAT'
         FN(6:6)=ich(isp)
         FN(5:5)=ich(3-isp)
         Write (6,*) 'FN,LU=',FN,LU
         call multi_opendir(FN,LU)
         ndup=ndup+1
         if (ndup.gt.ndupmx)
     $        call barf('create_klvab_t3 -- ndupmx exceeded')
         !!write(6,*) FN, isp,ndup
         dupfil(ndup)=FN
         if(IUHF.eq.0)then
         FN(6:6)=ich(isp)
         FN(5:5)=ich(isp)
         call multi_opendir(FN,LU+1)
         !!ndup=ndup+1
         if (ndup.gt.ndupmx)
     $        call barf('create_klvab_t3 -- ndupmx exceeded')
         !!write(6,*) FN, isp,ndup+1
         dupfil(ndup+1)=FN
         endif
C currently using 3-dim (big field) - will be replaced after changing
C stepiv and the rest
         nnu=(nuab(is2)*(nuab(is2)+1))/2
cmp         call w_alloc(ig,(nuab(isp)*nnu),'IG klvab')
cmp         call w_alloc(iscr,nuab(is2)*nuab(is2),'IG iscr')
cmp
        call GetMem('c1_ig','Allo','Real',ig,
     & nuab(isp)*nnu)
        call GetMem('c1_iscr','Allo','Real',iscr,
     & nuab(is2)*nuab(is2))
cmp
         IAS=1
         IAS_AA=1
c
         DO K=1,noab(isp)
!!            IF(IUHF.EQ.1)THEN
               KADT=(K-1)*NNUAB(3)*(NOAB(2)*(2-ISP)+ISP-1)
!!            ELSE
!!               KADT=0
!!            ENDIF

cmp!            FN(1:5)='VVVAI'
cmp!            FN(6:6)=ICH(ISP)
cmp!            CALL GET3DM(FN,G(IG),NNU,NUAB(ISP),K)
        if (printkey.gt.1) then
        write (6,*) 'Regenerating VVVo integrals for o = ',K
        end if
cmp
cmp         call w_alloc(il1_1,nc*maxdim,'IL1_1 iscr')
cmp         call w_alloc(il2_1,nc*maxdim*maxdim,'IL2_1 iscr')
cmp         call w_alloc(itmp,
cmp     & max(nc*maxdim*maxdim,nc*no*maxdim,maxdim*maxdim*maxdim),
cmp     & 'ITMP iscr')
cmp
        call GetMem('cc_il1_1','Allo','Real',il1_1,
     & nc*maxdim)
        call GetMem('cc_il2_1','Allo','Real',il2_1,
     & nc*maxdim*maxdim)
        call GetMem('cc_itmp','Allo','Real',itmp,
     & max(nc*maxdim*maxdim,nc*no*maxdim,maxdim*maxdim*maxdim))
cmp
cmp        call gen_vvvo(K,G(IG),G(il1_1),G(il2_1),G(itmp))
        call gen_vvvo(K,Work(IG),
     & Work(il1_1),Work(il2_1),Work(itmp))
cmp       write(6,*) ddot_(nnu*nuab(isp),G(ig),1,G(ig),1)
cmp        call zeroma (G(ig),1,NNU*NUAB(ISP))
c
cmp        call w_free(G(il1_1),0,'IL1_1 iscr')
        call GetMem('cc_itmp','Free','Real',itmp,
     & max(nc*maxdim*maxdim,nc*no*maxdim,maxdim*maxdim*maxdim))
        call GetMem('cc_il2_1','Free','Real',il2_1,
     & nc*maxdim*maxdim)
        call GetMem('cc_il1_1','Free','Real',il1_1,
     & nc*maxdim)
cmp
            call delf(FN,K,K)
       if(iuhf.eq.0)
     $call klvaa_vvv(ix,ig,iscr,vblock,N,nug,
     $LU+1,last_aa,iasblock,K,ias_aa)
cmpn     $call klvaa_vvv(ix,it,ig,iscr,vblock,N,nug,
cmpn     $LU+1,last_aa,iasblock,K,ias_aa)
cmp     $call klvaa_vvv(G,ix,it,ig,iscr,vblock,N,nug,
cmp     $LU+1,last_aa,iasblock,K,ias_aa)
c

!!       call xflush(6)
C   (c>d|AK)

cmpn
        nga=0
cmpn
            DO A1=1,NUAB(ISP),vblock
               A2=A1+min(vblock,nuab(isp)-A1+1)-1
               adim=A2-A1+1
        nga=nga+1
        ngb=0
               do B1=1,NUAB(IS2),vblock
        ngb=ngb+1
                  NSTEP=min(vblock,nuab(is2)-B1+1)
!!    bdim=NSTEP
                  IJS=(A1-1)*NNU+IG
cmpn
cmpn        write (6,*)
cmpn        write (6,*) '================================='
cmpn        write (6,*) ' nga, ngb',nga,ngb
cmpn        write (6,*) '================================='
cmpn        write (6,*)
c
c - check the largest b2
c
cmpn        b2_chk=b1-1+vblock
        b2_chk=b1-1+min(vblock,nuab(is2)-B1+1)
c
c - find out which T2 blocked files will be needed
c   for particular nga, ngb
c
cmpn        write (6,'(A,4(i5,2x))') 'a1,a2,b1,b2_chk = ',a1,a2,b1,b2_chk
c
        switch=.false.
        if (nga.lt.ngb) then
cmpn        write (6,*) 'switching nga, ngb',ngb,nga
        switch=.true.
c
        call block_interf(b1,b2_chk,a1,a2,
     &   ngaf,ngal,nind_ngaf,nind_ngal,
     &   ngbf,ngbl,nind_ngbf,nind_ngbl)
c
        else
c
        call block_interf(a1,a2,b1,b2_chk,
     &   ngaf,ngal,nind_ngaf,nind_ngal,
     &   ngbf,ngbl,nind_ngbf,nind_ngbl)
c
        end if
c
cmpn        write (6,'(A,4(i5,2x))') 'ngaf, ngal, nind_ngaf, nind_ngal',
cmpn     & ngaf,ngal,nind_ngaf,nind_ngal
cmpn        write (6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',
cmpn     & ngbf,ngbl,nind_ngbf,nind_ngbl
c
c - read amplitudes from T2_ngaf_ngbf ...  T2_ngaf_ngbl, nga>=ngb
c                           ....               ....
c                        T2ngal_ngbf  ...  T2_ngal_ngbl, nga>=ngb
c
c - calculate memory requirements (consider squared T2(a',a'))
c
          length1=0
        do i_blk=ngaf,ngal
          length1=length1+DimGrpaR(i_blk)
        end do
c
          length2=0
        do j_blk=ngbf,ngbl
          length2=length2+DimGrpaR(j_blk)
        end do
c
cmpn        write (6,*) 'length1, vblock = ',length1,vblock
cmpn        write (6,*) 'length2, vblock = ',length2,vblock
c
        length=length1*length2*no*no
cmpn        write (6,*) 'length for blocked T2 amplitudes = ',length
c
c - setup memory
c
cmpn        write (6,*) 'allocating t2_exp = ',length
        call GetMem('it2_exp','Allo','Real',it_exp,length)
c
c - read pertinent files and store them in the new blocked structure
c
        call GetMem('cd_it2tmp','Allo','Real',it2_tmp,
     & maxdim*maxdim*no*no)
        call GetMem('cd_itmp','Allo','Real',itmp,
     & maxdim*maxdim*no*no)
c
        call gather_t2_blocked(length1,length2,
     & ngaf,ngal,ngbf,ngbl,
     & Work(it_exp),Work(it2_tmp),Work(itmp),
     & switch)
c
        call GetMem('cd_itmp','Free','Real',itmp,
     & maxdim*maxdim*no*no)
        call GetMem('cd_it2tmp','Free','Real',it2_tmp,
     & maxdim*maxdim*no*no)

        call dscal_(length,-1.d0,Work(it_exp),1)
c
                  do A=A1,A2
cmp                     CALL EXPA1_UHF(G(IJS),1,NUAB(IS2),1,G(ISCR))
                     CALL EXPA1_UHF(Work(IJS),1,NUAB(IS2),1,Work(ISCR))
                     IJS=IJS+NNU
C  Gix       <ng*ng|R,k>
!! not needed      B2=B1+min(ng,nuab(is2)-B1+1))-1
cmpn
        if (nga.lt.ngb) then
          a_tmp=a-nind_ngbf
          b1_tmp=b1-nind_ngaf
        else
          a_tmp=a-nind_ngaf
          b1_tmp=b1-nind_ngbf
        end if
cmp        write (6,'(A,2(i5,2x),A,i5,2x)') 'b1,   a     ,i,k = ',b1,a,
cmp     & '    i',k
C  mv T2(B,A,I,K) >> G(ix)
cmpn
                     DO I=1,NOAB(IS2)
                        ISPA=ISP
                        !!IF(IUHF.EQ.1)THEN
                           IADT=(I-1)*NNUAB(3)*(NOAB(2)*(2-IS2)+IS2-1)
                        !!ELSE
                        !!   IADT=(MAX(K,I)-1)*(MAX(K,I))/2+MIN(K,I)
                        !!   IADT=(IADT-1)*NNUAB(3)
                        !!   IF(K.LT.I)ISPA=IS2
                        !!ENDIF
                        BADT=(2-ISPA)*B1+(ISPA-1)*(B1-1)*NUAB(2)
cmpn!!!
cmpn                        AADT_tmp=IADT+KADT+BADT+A*(ISPA-1)
cmpn     $                       +(2-ISPA)*(A-1)*NUAB(2)+IT-1
cmpn!!!
C  T2 <A,B,J,K> for isp=1 T2 <B,A,K,J> for isp=2
!!      RAD=(I-1)*vblock*vblock+(A-A1)*vblock+IX
                        RAD=(I-1)*adim*nstep+(A-A1)*nstep +IX
                        ISTEP=(ISPA-1)*NUAB(2)+2-ISPA
cmpn
        if (nga.ge.ngb) then ! nga> ngb

cmp        write (6,'(A,4(i5,2x),3x,i5)') '(I)  a_tmp,b1_tmp,k,i  nstep = ',
cmp     & a_tmp,b1_tmp,k,i,nstep
c T2(B,A,I,K) =? T2(A,B1,K,I)
          do j_tmp=0,NSTEP-1  ! istep je 1 ak dobre tusim
c
          AADT=(I-1)*length1*length2*NOAB(2)+(K-1)*length1*length2+
     &   (b1_tmp-1+j_tmp)*length1+a_tmp+it_exp-1
c
          RAD_tmp=RAD+j_tmp
c
          Work(RAD_tmp)=Work(AADT)
cmp
cmpn        if (abs(Work(AADT)-Work(AADT_tmp+j_tmp)).
cmpn     & gt.0.00001d0) then
cmpn           write (*,*) 'halohaha 1',AADT,AADT_tmp+j_tmp,
cmpn     & Work(AADT),Work(AADT_tmp+j_tmp)
cmpn           stop
cmpn        end if
cmp
          end do
c
        else ! nga < ngb
c
cmp        write (6,'(A,4(i5,2x),3x,i5)') '(II) b1_tmp,a_tmp,k,i   nstep = ',
cmp     & b1_tmp,a_tmp,i,k,nstep
c T2(B,A,I,K)
          do j_tmp=0,NSTEP-1  ! istep je 1 ak dobre tusim
c
cmp          AADT=(k-1)*length1*length2*NOAB(2)+(i-1)*length1*length2+
cmp!          AADT=(i-1)*length1*length2*NOAB(2)+(k-1)*length1*length2+
          AADT=(K-1)*length1*length2*NOAB(2)+(I-1)*length1*length2+
     &   (a_tmp-1)*length1+b1_tmp+j_tmp+it_exp-1
c
          RAD_tmp=RAD+j_tmp
c
          Work(RAD_tmp)=Work(AADT)
cmp
cmpn        if (abs(Work(AADT)-Work(AADT_tmp+j_tmp)).
cmpn     & gt.0.00001d0) then
cmpn           write (*,*) 'halohaha 2',AADT,AADT_tmp+j_tmp,
cmpn     & Work(AADT),Work(AADT_tmp+j_tmp)
cmpn           stop
cmpn        end if
cmp
c
          end do
        end if
c
cmpn                        call dcopy_(NSTEP,Work(AADT),ISTEP,Work(RAD),1)
cmpn
                     enddo      ! I
                     RAD=noab(is2)*adim*nstep+(A-A1)*nstep+IX
                     DO IADR=ISCR+B1-1,ISCR+NUAB(IS2)*NUAB(IS2)-1,
     $                    NUAB(IS2)
cmp                        call dcopy_(NSTEP,G(IADR),1,G(RAD),1)
                        call dcopy_(NSTEP,Work(IADR),1,Work(RAD),1)
                        RAD = RAD+adim*nstep
                     enddo      ! IADR
                  enddo         ! A
      !!write(6,'(A,4I5,4x,D15.10)')
     !!$'block-w: K,a1,b1,IAS,ddot',K,a1,b1,ias,
     !!$ ddot_(N*vblock*vblock,G(IX),1,G(IX),1)
cmp                  call multi_wridir(G(IX),N*vblock*vblock,LU,IAS,last)

cmp
cmp!!        do jjj=0,N*vblock*vblock-1
cmp!!        if (abs(Work(ix+jjj)).gt.10000) then
cmp!!          write (6,*) 'prasa 1 ',jjj,Work(ix+jjj)
cmp!!          stop
cmp!!        end if
cmp!!        end do
cmp
                  call multi_wridir(Work(IX),N*vblock*vblock,
     & LU,IAS,last)
        !!write (6,*) 'N*vblock*vblock,LU,last ',
     !!& N*vblock*vblock,LU,last
                  ias=ias+iasblock
cmp
        call GetMem('it2_exp','Free','Real',it_exp,length)
cmp
               enddo            ! B1
            enddo               ! A1
         enddo                  ! K
        if (printkey.gt.1) then
        write (6,*) 'VVVo integrals regenerated from MOLCAS'
        write (6,*)
        end if
cmp
         close (LU)
         dupblk(ndup)=last
         if(IUHF.EQ.0)then
         close(LU+1)
         ndup=ndup+1
         dupblk(ndup)=last_aa
         endif
!         write(6,*) FN, isp, IAS
cmp         call w_memchk('IG klvab ')
cmp         call w_free(g(ig),0,'IG klvab ')
cmp
        call GetMem('c1_iscr','Free','Real',iscr,
     & nuab(is2)*nuab(is2))
        call GetMem('c1_ig','Free','Real',ig,
     & nuab(isp)*nnu)
cmp
      enddo                     ! ISP

cmp      call dscal_(NNUAB(3)*NNOAB(3),-1.d0,G(it),1)
cmpn      call dscal_(NNUAB(3)*NNOAB(3),-1.d0,Work(it),1)
cmp??
        call GetMem('c1_ix','Free','Real',ix,
     & vblock*vblock*n)
cmp??
      do isp=1,IUHF+1
cmp         call w_memchk('IX klvab ')
cmp         call w_free(g(ix),0,'IX klvab ')
cmp
         is2=3-isp
         iasblock=nnoab(3)*vblock*N/nblock
         if((iasblock*nblock).lt.(nnoab(3)*vblock*N))iasblock=iasblock+1
         FN(1:4)='LMAT'
         FN(5:5)=ich(3-isp)
         FN(6:6)=ich(isp)
         call multi_opendir(FN,LU)
         ndup=ndup+1
         if (ndup.gt.ndupmx)
     $        call barf('create_klvab_t3 -- ndupmx exceeded')
!         write(6,*) FN, isp,ndup
         dupfil(ndup)=FN
C
         FN(1:5)='OOVAI'
         FN(6:6)=ICH(ISP)
cmp         call w_alloc(ix,noab(isp)*noab(IS2)*vblock*n,'IX klvabo ')
        call GetMem('c2_ix','Allo','Real',ix,
     & noab(isp)*noab(IS2)*vblock*n)
         nno=noab(is2)*(noab(is2)+1)/2
cmp         call w_alloc(ig,noab(isp)*nuab(isp)*nno,'IG klvabo')
cmp         call w_alloc(iscr,vblock*noab(IS2)*noab(IS2),'ISCRo klvabo ')
        call GetMem('c2_ig','Allo','Real',ig,
     & noab(isp)*nuab(isp)*nno)
        call GetMem('c2_iscr','Allo','Real',iscr,
     & vblock*noab(IS2)*noab(IS2))
cmp
cmp!         CALL GET3DM(FN,G(ig),NNO,NUAB(ISP)*NOAB(ISP),0)
cmp
cmp          call w_alloc(il0,nc*nno,'IL0 klvabo')
cmp          call w_alloc(il1,nc*no*nv,'IL1 klvabo')
cmp          call w_alloc(itmp,
cmp     & max(nc*nno,nc*no*maxdim,nc*no*nv),'ITMP klvabo')
cmp
        call GetMem('cr_il0','Allo','Real',il0,
     & nc*nno)
        call GetMem('cr_il1','Allo','Real',il1,
     & nc*no*nv)
        call GetMem('cr_itmp','Allo','Real',itmp,
     & max(nc*nno,nc*no*maxdim,nc*no*nv))
cmp
        call gen_oovo (Work(ig),Work(il0),Work(il1),Work(itmp))
cmp        call gen_oovo (G(ig),G(il0),G(il1),G(itmp))
cmp        write(6,*)ddot_(NNO*NUAB(ISP)*NOAB(ISP),G(ig),1,G(ig),1)
cmp        call zeroma (G(ig),1,NNO*NUAB(ISP)*NOAB(ISP))
c
cmp        call w_free(G(il0),0,'IL0 klvab')
        call GetMem('cr_itmp','Free','Real',itmp,
     & max(nc*nno,nc*no*maxdim,nc*no*nv))
        call GetMem('cr_il1','Free','Real',il1,
     & nc*no*nv)
        call GetMem('cr_il0','Free','Real',il0,
     & nc*nno)

        if (printkey.gt.1) then
         write (6,*) 'OOVO integrals regenerated from MOLCAS'
        end if
cmp
         IAS=1
cmpn
        nga=0
cmpn
         do A1=1,NUAB(ISP),vblock
            A2=A1+min(vblock,nuab(isp)-(A1-1))-1
            NSTEP=min(vblock,nuab(isp)-(A1-1))
cmpn
        nga=nga+1
c
cmp        write (6,*)
cmp        write (6,*) '================================='
cmp        write (6,*) ' nga ',nga
cmp        write (6,*) '================================='
cmp        write (6,*)
c
cmp        write (6,'(A,2(i5,2x))') 'b1,b2 = ',a1,a2
c
cmp        call block_interf(1,1,a1,a2,
        call block_interf(1,nuab(1),a1,a2,
     &   ngaf,ngal,nind_ngaf,nind_ngal,
     &   ngbf,ngbl,nind_ngbf,nind_ngbl)
c
cmp        write (6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',
cmp     & ngbf,ngbl,nind_ngbf,nind_ngbl
c
c - read amplitudes T2(nv,vblock,j<i)
c
c - calculate memory requirements
c
        length1=nuab(isp)
c
          length2=0
        do i_blk=ngbf,ngbl
          length2=length2+DimGrpaR(i_blk)
        end do
c
cmp        write (6,*) 'length1, NUAB   = ',length1,NUAB(1)
cmp        write (6,*) 'length2, vblock = ',length2,vblock
c
        length=length1*length2*no*no
cmp        write (6,*) 'length for blocked T2 amplitudes = ',length
c
c - setup memory
c
cmp        write (6,*) 'allocating t2_exp = ',length
        call GetMem('it3_exp','Allo','Real',it_exp,length)
c
c - read pertinent files and store them in the new blocked structure
c
        call GetMem('it2_tmp','Allo','Real',it2_tmp,
     & maxdim*maxdim*no*no)
        call GetMem('itmp2','Allo','Real',itmp2,
     & maxdim*maxdim*no*no)
c
        call gather_t2_fblocked(length1,length2,
     & ngaf,ngal,ngbf,ngbl,
     & Work(it_exp),Work(it2_tmp),Work(itmp2))
c
        call GetMem('itmp2','Free','Real',itmp2,
     & maxdim*maxdim*no*no)
        call GetMem('it2_tmp','Free','Real',it2_tmp,
     & maxdim*maxdim*no*no)
c
cmpn
            do k=1,noab(isp)
               !!IF(IUHF.EQ.1) THEN
                  KADT=(K-1)*NNUAB(3)*(NOAB(2)*(2-ISP)+ISP-1)
               !!ELSE
               !!   KADT=0
               !!ENDIF
               IJS=ig+(A1-1)*nno+(k-1)*nuab(isp)*nno
cmp               CALL EXPA1_UHF(G(IJS),nstep,NOAB(IS2),1,G(iscr))
               CALL EXPA1_UHF(Work(IJS),nstep,NOAB(IS2),1,Work(iscr))
               do I=1,noab(is2)
                  ISPA=ISP
                  !!IF(IUHF.EQ.1) THEN
                     IADT=(I-1)*NNUAB(3)*(NOAB(2)*(2-IS2)+IS2-1)
                  !!ELSE
                   !!  IADT=(MAX(K,I)-1)*(MAX(K,I))/2+MIN(K,I)
                   !!  IADT=(IADT-1)*NNUAB(3)
                   !!  IF(K.LT.I)ISPA=IS2
                  !!ENDIF
c
                  DO A=A1,A2

cmpn
        a_tmp=a-nind_ngbf
c
        AADT=(K-1)*noab(2)*NUAB(2)*length2+
     &       (i-1)*NUAB(2)*length2+
     &       (a_tmp-1)*NUAB(2)+it_exp
cmpn
C copies T
                     BADT=2-ISPA+(ISPA-1)*NUAB(2)
C  T2 <A,B,J,K> for isp=1 T2 <B,A,K,J> for isp=2
                     ISTEP=(ISPA-1)*NUAB(2)+2-ISPA
                     RAD=(I-1)*nstep*n+(A-A1)*n+IX+noab(is2)
     $                    +(K-1)*noab(is2)*nstep*N
cmp                     call dcopy_(nuab(is2),G(AADT),ISTEP,G(RAD),1)
cmp
                     call dcopy_(nuab(is2),Work(AADT),ISTEP,Work(RAD),1)
                  enddo         ! A
               enddo            ! I
C copies OOVO
               DO J=1,noab(is2)
                  DO A=1,NSTEP
                     RAD=IX+(A-1)*n+(J-1)*nstep*N+(K-1)*noab(is2)
     $                    *nstep*N
                     IADR=ISCR+(A-1)*noab(is2)*noab(is2)+(j-1)*noab(is2)
cmp                     call dcopy_(noab(is2),G(IADR),1,G(RAD),1)
                     call dcopy_(noab(is2),Work(IADR),1,Work(RAD),1)
                  enddo         ! A
               enddo            ! J
            enddo               ! K
!!      write(6,'(A,2I5,4x,D15.10)')
!!     $'block-w:a1,IAS,ddot',a1,ias,ddot_(N*vblock*nnoab(3),g(ix),1,g(ix),1)
!!      write(6,'(a,a,2I4,D16.8)')'block-w',ich(isp),(A1/vblock)+1,IAS,
!!     $ddot_(N*nnoab(3)*NSTEP,g(ix),1,g(ix),1)
cmp            call multi_wridir(G(IX),N*nstep*nnoab(3),LU,IAS,last)
cmp
cmp!!        do jjj=0,N*nstep*nnoab(3)-1
cmp!!        if (abs(Work(ix+jjj)).gt.10000) then
cmp!!          write (*,*) 'prasa 2 ',jjj,Work(ix+jjj)
cmp!!          stop
cmp!!        end if
cmp!!        end do
cmp
            call multi_wridir(Work(IX),N*nstep*nnoab(3),LU,IAS,last)
cmp
            IAS=IAS+iasblock
cmpn
        call GetMem('it3_exp','Free','Real',it_exp,length)
cmpn
         enddo                  ! A1
         close (LU)
!         write(6,*) FN, isp, IAS
         dupblk(ndup)=last
         if(IUHF.EQ.0)then
         FN(1:4)='LMAT'
         FN(6:6)=ich(isp)
         FN(5:5)=ich(isp)
         call multi_opendir(FN,LU)
         ndup=ndup+1
         if (ndup.gt.ndupmx)
     $        call barf('create_klvab_t3 -- ndupmx exceeded')
!         write(6,*) FN, isp,ndup
         dupfil(ndup)=FN
C   this is to ensure correct copy to slaves
         IAS_AA=1
cmp        write (6,*) 'test 1 na iscr ',vblock*noab(IS2)*noab(IS2)
cmp        write (6,*) 'test 1 na ig ',noab(isp)*nuab(isp)*nno
cmp        write (6,*) 'test 1 na ix ',noab(isp)*noab(IS2)*vblock*n
cmp         call klvaa_oovo(G,ix,it,ig,iscr,vblock,N,nug,
cmpn         call klvaa_oovo(ix,it,ig,iscr,vblock,N,nug,
         call klvaa_oovo(ix,ig,iscr,vblock,N,nug,
     $LU,last_aa,ias_aa)
cmp
cmp        write (6,*) 'klvaa_oovo finished'
cmp
         close(LU)
         ndup=ndup
         dupblk(ndup)=last_aa
         endif
      enddo                     ! ISP
cmp      call w_memchk('all klvab ')
cmp      call w_free(g(it),0,'IT klvab ')
c iscr a ig sa odalokuju v klva_oovo
cmp @@@        call GetMem('create_iscr','Free','Real',iscr,
cmp @@@     & vblock*noab(IS2)*noab(IS2))
cmp @@@        call GetMem('create_ig','Free','Real',ig,
cmp @@@     & noab(isp)*nuab(isp)*nno)
cmp ???
cmp??       call GetMem('c2_ix','Free','Real',ix,
cmp??     & noab(isp)*noab(IS2)*vblock*n)
cmpn        call GetMem('create_it','Free','Real',it,
cmpn     & NNOAB(3)*NNUAB(3))
      call xflush(6)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RDMGRD(JOB,IDISP,LABEL,STYPE,ISYMP,NARRAY,ARRAY)
! Purpose: Read in the derivatives of 1-electron integrals
! of some operator, with respect to some displacement IDISP.
! ISYMP is the symmetry irrep label of the derivatives.

use rassi_aux, only: ipglob
use Cntrl, only: LuMck, MINAME, NJOB
use Symmetry_Info, only: MUL, nIrrep
use rassi_data, only: NBASF
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: JOB, IDISP, ISYMP, NARRAY
character(len=8), intent(inout) :: LABEL
character(len=8), intent(in) :: STYPE
real(kind=wp), intent(out) :: ARRAY(NARRAY)
integer(kind=iwp) :: I, IA1, IA2, IAOFF(8), IOPT, IRC, IS, ISCODE, ISUM, ITOFF(8), J, JS, LT, NBI, NBIJ, NBJ, NTEMP
real(kind=wp) :: F
real(kind=wp), allocatable :: TEMP(:)

if ((JOB < 1) .or. (JOB > NJOB)) then
  write(u6,*) ' RASSI/RDMGRD: Invalid JOB parameter.'
  write(u6,*) ' JOB:',JOB
  call ABEND()
end if

if (IPGLOB > 3) then
  write(u6,*) ' RDMGRD called for JOB=',JOB
  write(u6,*) ' perturbed by displacement nr.',IDISP
  write(u6,*) ' MckInt file name:',MINAME(JOB)
  write(u6,*) ' Operator name LABEL=',LABEL
  write(u6,*) ' Symmetry type STYPE=',STYPE
  write(u6,*) ' Irrep label   ISYMP=',ISYMP
  write(u6,*) ' Length NARRAY=',NARRAY
end if

! Open MCKINT file:
IRC = -1
IOPT = 0
call OPNMCK(IRC,IOPT,MINAME(JOB),LUMCK)
if (IRC /= 0) then
  write(u6,*) 'RASSI/RDMGRD: Failed to open '//MINAME(JOB)
  write(u6,*) 'Unit nr LUMCK=',LUMCK
  write(u6,*) 'Option code IOPT=',IOPT
  write(u6,*) 'Return code IRC =',IRC
  call ABEND()
end if

! Addressing integral blocks in the buffer:
ISUM = 0
do IS=1,nIrrep
  JS = MUL(IS,ISYMP)
  if (IS >= JS) then
    ITOFF(IS) = ISUM
    ITOFF(JS) = ISUM
    NBI = NBASF(IS)
    NBJ = NBASF(JS)
    NBIJ = NBI*NBJ
    if (IS == JS) NBIJ = (NBIJ+NBI)/2
    ISUM = ISUM+NBIJ
  end if
end do
NTEMP = ISUM
! Read MCKINT file:
IOPT = 0
ISCODE = 2**(ISYMP-1)
! Get temporary buffer to read data by RDMCK calls
call mma_allocate(TEMP,NTEMP,Label='TEMP')
! Read 1-electron integral derivatives:
IRC = NTEMP
call dRDMCK(IRC,IOPT,LABEL,IDISP,TEMP,ISCODE)
if (IRC /= 0) then
  write(u6,*) 'RDMGRD: RDMGRD failed to read '//MINAME(JOB)
  write(u6,*) '  Displacement IDISP=',IDISP
  write(u6,*) '    Option code IOPT=',IOPT
  write(u6,*) '    Data label LABEL=',LABEL
  write(u6,*) 'Symmetry code ISCODE=',ISCODE
  write(u6,*) '    Return code IRC =',IRC
  call ABEND()
end if

! Addressing integral blocks in ARRAY:
ISUM = 0
do IS=1,nIrrep
  IAOFF(IS) = ISUM
  ISUM = ISUM+NBASF(IS)*NBASF(MUL(IS,ISYMP))
end do
if (ISUM > NARRAY) then
  write(u6,*) 'RASSI/RDMGRD: Output ARRAY has insufficient length.'
  write(u6,*) ' Input parameter NARRAY=',NARRAY
  write(u6,*) ' Needed size       ISUM=',ISUM
  call ABEND()
end if
! Move buffer integrals into ARRAY in proper format:
do IS=1,nIrrep
  NBI = NBASF(IS)
  if (NBI <= 0) cycle
  if (ISYMP == 1) then
    LT = 1+ITOFF(IS)
    IA1 = 1+IAOFF(IS)
    call SQUARE(TEMP(LT),ARRAY(IA1),1,NBI,NBI)
    if (STYPE(1:4) == 'ANTI') then
      do J=1,NBI-1
        do I=J+1,NBI
          ARRAY(IA1-1+I+NBI*(J-1)) = -ARRAY(IA1-1+J+NBI*(I-1))
        end do
      end do
    end if
  else
    JS = MUL(IS,ISYMP)
    if (IS < JS) cycle
    NBJ = NBASF(JS)
    if (NBJ <= 0) cycle
    LT = 1+ITOFF(IS)
    IA1 = 1+IAOFF(IS)
    IA2 = 1+IAOFF(JS)
    ARRAY(IA1:IA1+NBI*NBJ-1) = TEMP(LT:LT+NBI*NBJ-1)
    if (STYPE(1:4) == 'ANTI') then
      F = -One
    else
      F = One
    end if
    do I=1,NBI
      do J=1,NBJ
        ARRAY(IA2-1+J+NBJ*(I-1)) = F*ARRAY(IA1-1+I+NBI*(J-1))
      end do
    end do
  end if
end do
! Get rid of temporary buffer
call mma_deallocate(TEMP)

! Close MCKINT file:
IRC = -1
IOPT = 0
call CLSMCK(IRC,IOPT)
if (IRC /= 0) then
  write(u6,*) 'RASSI/RDMGRD: Failed to close '//MINAME(JOB)
  write(u6,*) 'Unit nr LUMCK=',LUMCK
  write(u6,*) 'Option code IOPT=',IOPT
  write(u6,*) 'Return code IRC =',IRC
  call ABEND()
end if

end subroutine RDMGRD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkangL0(Lmax,l1,l2,l3,l4,m1,m2,m3,m4,angintSO,angintOO,Lfirst,Llast,Lblocks,ncont1,ncont2,ncont3,ncont4,caseaSO, &
                   caseb1SO,caseb2SO,casecSO,caseaOO,caseb1OO,caseb2OO,casecOO,preroots,clebsch,dummy,bonn,breit,sameorb)
!bs subroutine for combining radial integrals with angular
!bs factors for the block with l1,l2,l3,l4,m1,m2,m3m,m4
!bs this routine mkangL0 = make angular factors for the L0-part
!bs includes both, spin-same and spin-other-orbit parts.

use Constants, only: Zero, One, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lmax, l1, l2, l3, l4, m1, m2, m3, m4, Lfirst(4), Llast(4), Lblocks(4), ncont1, ncont2, ncont3, &
                                 ncont4
real(kind=wp), intent(out) :: angintSO(ncont1,ncont2,ncont3,ncont4), angintOO(ncont1,ncont2,ncont3,ncont4), dummy(0:2*Lmax+1)
real(kind=wp), intent(in) :: caseaSO(ncont1*ncont2*ncont3*ncont4,*), caseb1SO(ncont1*ncont2*ncont3*ncont4,*), &
                             caseb2SO(ncont1*ncont2*ncont3*ncont4,*), casecSO(ncont1*ncont2*ncont3*ncont4,*), &
                             caseaOO(ncont1*ncont2*ncont3*ncont4,*), caseb1OO(ncont1*ncont2*ncont3*ncont4,*), &
                             caseb2OO(ncont1*ncont2*ncont3*ncont4,*), casecOO(ncont1*ncont2*ncont3*ncont4,*), preroots(2,0:Lmax), &
                             clebsch(3,2,-Lmax:Lmax,0:Lmax)
logical(kind=iwp), intent(in) :: bonn, breit, sameorb
integer(kind=iwp) :: Kfirst, Klast, L, Lrun, M, ncontall
real(kind=wp) :: cheater, factor
real(kind=wp), external :: LMdepang
!bs all the arrays with the radial integrals for
!bs this combination of l-values
! caseaSO:  (2,0)   integrals with alpha1*alpha3
! caseb1SO: (0,0)   integrals with alpha1
! caseb2SO: (0,0)   integrals with alpha3
! casecSO:  (-2,0)  integrals with factor 1
! caseaOO:  (2,0)   integrals with alpha1*alpha3
! caseb1OO: (0,0)   integrals with alpha1
! caseb2OO: (0,0)   integrals with alpha3
! casecOO:  (-2,0)  integrals with factor 1
! preroots: some prefactors: sqrt( (l(+1))/(2l+1))
! clebsch:  some clebsch gordans, that appear regulary

!write(u6,*) 'begin mkangL0 ',l1,l2,l3,l4,m1,m2,m3,m4

ncontall = ncont1*ncont2*ncont3*ncont4
!bs cheater introduced to correct signs, because they were different from HERMIT
if (mod(l1+l2+l3+l4,4) == 2) then
  cheater = One
else
  cheater = -One
end if
!bs cleaning up
if (bonn .or. breit .or. sameorb) then
  angintSO(:,:,:,:) = Zero
else
  angintSO(:,:,:,:) = Zero
  angintOO(:,:,:,:) = Zero
end if
!bs starting with the same-orbit-contributions
!bs first term: ########################################################
factor = -preroots(2,l1)*preroots(2,l3)*clebsch(1,2,m1,l1)*clebsch(1,2,m3,l3)
if (factor /= Zero) then
  !bs get the L,M dependent coefficients
  if (Lblocks(1) > 0) then
    dummy(:) = Zero
    M = m2-m4
    Lrun = 1
    do L=Lfirst(1),Llast(1),2
      dummy(L) = LMdepang(L,M,l1+1,l2,l3+1,l4,m1-1,m2,m3-1,m4,cheater)
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,Four*factor*dummy(L),caseaOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
end if
!bs second term: #######################################################
factor = -preroots(1,l1)*preroots(2,l3)*clebsch(1,1,m1,l1)*clebsch(1,2,m3,l3)
if (factor /= Zero) then
  dummy(:) = Zero
  Klast = 0
  Kfirst = 2*Lmax+1 ! just to be sure ..
  !bs get the L,M dependent coefficients
  if (Lblocks(1) > 0) then
    M = m2-m4
    Kfirst = Lfirst(1)
    Klast = Llast(1)
    Lrun = 1
    do L=Lfirst(1),Llast(1),2
      dummy(L) = LMdepang(L,M,l1-1,l2,l3+1,l4,m1-1,m2,m3-1,m4,cheater)
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,Four*factor*dummy(L),caseaOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(3) > 0) then
    M = m2-m4
    if (Lfirst(3) < Kfirst) then
      do L=Lfirst(3),Kfirst,2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3+1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Kfirst = Lfirst(3)
    end if
    if (Llast(3) > Klast) then
      do L=Klast,Llast(3),2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3+1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Klast = Llast(3)
    end if
    Lrun = 1
    do L=Lfirst(3),Llast(3),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2SO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2SO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2OO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
end if
!bs third term: ########################################################
factor = -preroots(2,l1)*preroots(1,l3)*clebsch(1,2,m1,l1)*clebsch(1,1,m3,l3)
if (factor /= Zero) then
  dummy(:) = Zero
  Klast = 0
  Kfirst = 2*Lmax+1 ! just to be sure ..
  !bs get the L,M dependent coefficients
  if (Lblocks(1) > 0) then
    M = m2-m4
    Kfirst = Lfirst(1)
    Klast = Llast(1)
    Lrun = 1
    do L=Lfirst(1),Llast(1),2
      dummy(L) = LMdepang(L,M,l1+1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,Four*factor*dummy(L),caseaOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(2) > 0) then
    M = m2-m4
    if (Lfirst(2) < Kfirst) then
      do L=Lfirst(2),Kfirst,2
        dummy(L) = LMdepang(L,M,l1+1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Kfirst = Lfirst(2)
    end if
    if (Llast(2) > Klast) then
      do L=Klast,Llast(2),2
        dummy(L) = LMdepang(L,M,l1+1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Klast = Llast(2)
    end if
    Lrun = 1
    do L=Lfirst(2),Llast(2),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1SO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1SO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1OO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
end if
!bs fourth term: #######################################################
factor = -preroots(1,l1)*preroots(1,l3)*clebsch(1,1,m1,l1)*clebsch(1,1,m3,l3)
if (factor /= Zero) then
  dummy(:) = Zero
  Klast = 0
  Kfirst = 2*Lmax+1 ! just to be sure ..
  !bs get the L,M dependent coefficients
  if (Lblocks(1) > 0) then
    M = m2-m4
    Kfirst = Lfirst(1)
    Klast = Llast(1)
    Lrun = 1
    do L=Lfirst(1),Llast(1),2
      dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,Four*factor*dummy(L),caseaOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(2) > 0) then
    M = m2-m4
    if (Lfirst(2) < Kfirst) then
      do L=Lfirst(2),Kfirst,2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Kfirst = Lfirst(2)
    end if
    if (Llast(2) > Klast) then
      do L=Klast,Llast(2),2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Klast = Llast(2)
    end if
    Lrun = 1
    do L=Lfirst(2),Llast(2),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1SO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1SO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1OO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(3) > 0) then
    M = m2-m4
    if (Lfirst(3) < Kfirst) then
      do L=Lfirst(3),Kfirst,2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Kfirst = Lfirst(3)
    end if
    if (Llast(3) > Klast) then
      do L=Klast,Llast(3),2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Klast = Llast(3)
    end if
    Lrun = 1
    do L=Lfirst(3),Llast(3),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2SO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2SO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2OO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(4) > 0) then
    M = m2-m4
    if (Lfirst(4) < Kfirst) then
      do L=Lfirst(4),Kfirst,2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Kfirst = Lfirst(4)
    end if
    if (Llast(4) > Klast) then
      do L=Klast,Llast(4),2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1-1,m2,m3-1,m4,cheater)
      end do
      Klast = Llast(4)
    end if
    Lrun = 1
    do L=Lfirst(4),Llast(4),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,real(4*l1*l3+2*l1+2*l3+1,kind=wp)*factor*dummy(L),casecSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,real(4*l1*l3+2*l1+2*l3+1,kind=wp)*factor*dummy(L),casecSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,real(4*l1*l3+2*l1+2*l3+1,kind=wp)*factor*dummy(L),casecOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
end if
!bs fifth term: ########################################################
factor = preroots(2,l1)*preroots(2,l3)*clebsch(3,2,m1,l1)*clebsch(3,2,m3,l3)
if (factor /= Zero) then
  dummy(:) = Zero
  !bs get the L,M dependent coefficients
  if (Lblocks(1) > 0) then
    M = m2-m4
    Lrun = 1
    do L=Lfirst(1),Llast(1),2
      dummy(L) = LMdepang(L,M,l1+1,l2,l3+1,l4,m1+1,m2,m3+1,m4,cheater)
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,Four*factor*dummy(L),caseaOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
end if
!bs sixth term: ########################################################
factor = preroots(1,l1)*preroots(2,l3)*clebsch(3,1,m1,l1)*clebsch(3,2,m3,l3)
if (factor /= Zero) then
  dummy(:) = Zero
  Klast = 0
  Kfirst = 2*Lmax+1 ! just to be sure ..
  !bs get the L,M dependent coefficients
  if (Lblocks(1) > 0) then
    M = m2-m4
    Kfirst = Lfirst(1)
    Klast = Llast(1)
    Lrun = 1
    do L=Lfirst(1),Llast(1),2
      dummy(L) = LMdepang(L,M,l1-1,l2,l3+1,l4,m1+1,m2,m3+1,m4,cheater)
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,Four*factor*dummy(L),caseaOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(3) > 0) then
    M = m2-m4
    if (Lfirst(3) < Kfirst) then
      do L=Lfirst(3),Kfirst,2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3+1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Kfirst = Lfirst(3)
    end if
    if (Llast(3) > Klast) then
      do L=Klast,Llast(3),2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3+1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Klast = Llast(3)
    end if
    Lrun = 1
    do L=Lfirst(3),Llast(3),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2SO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2SO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2OO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
end if
!bs seventh term: ######################################################
factor = preroots(2,l1)*preroots(1,l3)*clebsch(3,2,m1,l1)*clebsch(3,1,m3,l3)
if (factor /= Zero) then
  dummy(:) = Zero
  Klast = 0
  Kfirst = 2*Lmax+1 ! just to be sure ..
  !bs get the L,M dependent coefficients
  if (Lblocks(1) > 0) then
    M = m2-m4
    Kfirst = Lfirst(1)
    Klast = Llast(1)
    Lrun = 1
    do L=Lfirst(1),Llast(1),2
      dummy(L) = LMdepang(L,M,l1+1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,Four*factor*dummy(L),caseaOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(2) > 0) then
    M = m2-m4
    if (Lfirst(2) < Kfirst) then
      do L=Lfirst(2),Kfirst,2
        dummy(L) = LMdepang(L,M,l1+1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Kfirst = Lfirst(2)
    end if
    if (Llast(2) > Klast) then
      do L=Klast,Llast(2),2
        dummy(L) = LMdepang(L,M,l1+1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Klast = Llast(2)
    end if
    Lrun = 1
    do L=Lfirst(2),Llast(2),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1SO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1SO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1OO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
end if
!bs eighth term: #######################################################
factor = preroots(1,l1)*preroots(1,l3)*clebsch(3,1,m1,l1)*clebsch(3,1,m3,l3)
if (factor /= Zero) then
  dummy(:) = Zero
  Klast = 0
  Kfirst = 2*Lmax+1 ! just to be sure ..
  !bs get the L,M dependent coefficients
  if (Lblocks(1) > 0) then
    M = m2-m4
    Kfirst = Lfirst(1)
    Klast = Llast(1)
    Lrun = 1
    do L=Lfirst(1),Llast(1),2
      dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,Four*factor*dummy(L),caseaSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,Four*factor*dummy(L),caseaOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(2) > 0) then
    M = m2-m4
    if (Lfirst(2) < Kfirst) then
      do L=Lfirst(2),Kfirst,2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Kfirst = Lfirst(2)
    end if
    if (Llast(2) > Klast) then
      do L=Klast,Llast(2),2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Klast = Llast(2)
    end if
    Lrun = 1
    do L=Lfirst(2),Llast(2),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1SO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1SO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,-real(2+4*l3,kind=wp)*factor*dummy(L),caseb1OO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(3) > 0) then
    M = m2-m4
    if (Lfirst(3) < Kfirst) then
      do L=Lfirst(3),Kfirst,2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Kfirst = Lfirst(3)
    end if
    if (Llast(3) > Klast) then
      do L=Klast,Llast(3),2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Klast = Llast(3)
    end if
    Lrun = 1
    do L=Lfirst(3),Llast(3),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2SO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2SO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,-real(2+4*l1,kind=wp)*factor*dummy(L),caseb2OO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
  if (Lblocks(4) > 0) then
    M = m2-m4
    if (Lfirst(4) < Kfirst) then
      do L=Lfirst(4),Kfirst,2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Kfirst = Lfirst(4)
    end if
    if (Llast(4) > Klast) then
      do L=Klast,Llast(4),2
        dummy(L) = LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3+1,m4,cheater)
      end do
      Klast = Llast(4)
    end if
    Lrun = 1
    do L=Lfirst(4),Llast(4),2
      if (dummy(L) /= Zero) then
        if (bonn .or. breit .or. sameorb) then
          call daxpy_(ncontall,real(4*l1*l3+2*l1+2*l3+1,kind=wp)*factor*dummy(L),casecSO(:,Lrun),1,angintSO,1)
        else
          call daxpy_(ncontall,real(4*l1*l3+2*l1+2*l3+1,kind=wp)*factor*dummy(L),casecSO(:,Lrun),1,angintSO,1)
          call daxpy_(ncontall,real(4*l1*l3+2*l1+2*l3+1,kind=wp)*factor*dummy(L),casecOO(:,Lrun),1,angintOO,1)
        end if
      end if
      Lrun = Lrun+1
    end do
  end if
end if

return

end subroutine mkangL0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      Subroutine  MemRg1(iAnga,nRys,MemPrm)
************************************************************************
*                                                                      *
* Modified to gradients 1991 R. Lindh, Dept. of Theoretical Chemistry, *
* University of Lund.                                                  *
************************************************************************
      Implicit Real*8 (a-h,o-z)
*
*     This routine will compute the memory requirement of Rysg1
*     Memory requirement is per primitive!
*
c#include "print.fh"
#include "itmax.fh"
      Integer iAnga(4)
*
*     Statement function
*
      nElem(i) = (i+1)*(i+2)/2
*
c     iRout = 13
c     iPrint = nPrint(iRout)
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      nRys = (la+lb+lc+ld+2 +1)/2
*
      MemPrm = 0
      nPAO = nElem(la)*nElem(lb)*nElem(lc)*nElem(ld)
*     1st order gradient of [ab|cd]
*     MemPrm = MemPrm + nPAO * 9
      nabMax = la+lb +1
      ncdMax = lc+ld +1
      nabcd = (nabMax+1)*(ncdMax+1)
      lB10=Max(Min(nabMax-1,1),0)
      lB01=Max(Min(ncdMax-1,1),0)
      lB00=Max(Min(Min(nabMax,ncdMax),1),0)
*     2D-Integrals
      n2D0=Max(nabcd,
     &         (la+2)*(lb+2)*(ncdMax+1),
     &         (la+2)*(lb+2)*(lc+2)*(ld+2))
      MemPrm = MemPrm + 3*nRys*n2D0
*     1st order gradient of the 2D-integrals
      n2D1=Max(nabcd,
     &         (la+2)*(lb+2)*(ncdMax+1),
     &         (la+1)*(lb+1)*(lc+1)*(ld+1)*3)
      MemPrm = MemPrm + 3*nRys*n2D1
*     Coefficients for recurrence relations
      MemPrm = MemPrm + 3*nRys + 3*nRys + 3*nRys*(lB10+lB01+lB00)
*     Roots
      MemPrm = MemPrm + nRys
*     The inverse of the arguments
      MemPrm = MemPrm + 1
*     Arguments
      MemPrm = MemPrm + 1
*     Expanded versions of Zeta, ZetInv, Eta, EtaInv,
*     P and Q
      MemPrm = MemPrm + 10
*     If (iPrint.ge.99) Then
*        Write (*,*) ' [ab|cd] 1st grad.   :', nPAO*9
*        Write (*,*) ' 2D-integrals        :', n2D0*3*nRys
*        Write (*,*) ' 2D-integrals (1st)  :', n2D1*3*nRys
*        Write (*,*) ' PAQP vector         :', 3*nRys
*        Write (*,*) ' QCPQ vector         :', 3*nRys
*        Write (*,*) ' B10 coefficients    :', nRys*3*lB10
*        Write (*,*) ' B00 coefficients    :', nRys*3*lB00
*        Write (*,*) ' B01 coefficients    :', nRys*3*lB01
*        Write (*,*) ' Roots               :', nRys
*        Write (*,*) ' Inverse arguments   :', 1
*        Write (*,*) ' Arguments           :', 1
*     End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021-2023, Vladislav Kochetov                          *
!***********************************************************************

#include "macros.fh"

module rhodyn_utils
!***********************************************************************
! module contains some auxiliary routines
!***********************************************************************

use linalg_mod, only: mult
#ifdef _ADDITIONAL_RUNTIME_CHECK_
use linalg_mod, only: abort_
#endif
use wigner_util, only: w3j
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, cZero
use Definitions, only: wp, iwp, u6

implicit none
private

public :: check_hermicity, compare_matrices, dashes, get_kq_order, print_c_matrix, removeColumn, removeLineAndColumn, sortci, &
          transform, WERDM, WERDM_back, WERSO, WERSO_back

interface removeLineAndColumn
  module procedure :: removeLineAndColumnR, removeLineAndColumnZ
end interface
interface removeColumn
  module procedure :: removeColumnR, removeColumnZ
end interface
interface transform
  module procedure :: transformR, transformZ
end interface

contains

subroutine dashes(length)
  ! print the line of dashes of length 'length' to the standard output

  integer(kind=iwp), intent(in), optional :: length
  integer(kind=iwp) :: i, l

  if (present(length)) then
    l = length
  else
    l = 72
  end if
  do i=1,l
    write(u6,'(A)',advance='no') '-'
  end do
  write(u6,*)

end subroutine dashes

subroutine removeLineAndColumnZ(a,remLCarray)
  ! cut complex matrix a(n,m), i.e. delete rows and columns not given by array remLCarray(k)
  ! thus the result is matrix a of size (k,k)

  complex(kind=wp), allocatable, intent(inout) :: a(:,:)
  integer(kind=iwp), intent(in) :: remLCarray(:)
  integer(kind=iwp) :: i, j, l, m, n, k
  complex(kind=wp), allocatable :: b(:)
  logical(kind=iwp), allocatable :: mask(:,:)

  ! sizes
  n = size(a,1)
  m = size(a,2)
  k = size(remLCarray)
  call mma_allocate(mask,n,m,label='mask')
  ! mask creation
  l = 0
  mask(:,:) = .false.
  do i=1,n
    do j=1,m
      if (any(remLCarray == i) .and. any(remLCarray == j)) then
        mask(i,j) = .true.
        l = l+1
      end if
    end do
  end do
  call mma_allocate(b,l,label='b')
  ! copy remaining elements into temp b
  b(:) = pack(a,mask)
  call mma_deallocate(a)
  call mma_allocate(a,k,k,label='a')
  ! copy back
  a(:,:) = reshape(b,[k,k])
  call mma_deallocate(b)
  call mma_deallocate(mask)

end subroutine removeLineAndColumnZ

subroutine removeLineAndColumnR(a,remLCarray)
  ! cut real matrix a(n,m), i.e. delete rows and columns not given by array remLCarray(k)
  ! thus the result is matrix a of size (k,k)

  real(kind=wp), allocatable, intent(inout) :: a(:,:)
  integer(kind=iwp), intent(in) :: remLCarray(:)
  integer(kind=iwp) :: i, j, l, m, n, k
  real(kind=wp), allocatable :: b(:)
  logical(kind=iwp), allocatable :: mask(:,:)

  ! sizes
  n = size(a,1)
  m = size(a,2)
  k = size(remLCarray)
  call mma_allocate(mask,n,m,label='a')
  ! mask creation
  l = 0
  mask(:,:) = .false.
  do i=1,n
    do j=1,m
      if (any(remLCarray == i) .and. any(remLCarray == j)) then
        mask(i,j) = .true.
        l = l+1
      end if
    end do
  end do
  call mma_allocate(b,l,label='b')
  ! copy remaining elements into temp b
  b(:) = pack(a,mask)
  call mma_deallocate(a)
  call mma_allocate(a,k,k,label='a')
  ! copy back
  a(:,:) = reshape(b,[k,k])
  call mma_deallocate(b)
  call mma_deallocate(mask)

end subroutine removeLineAndColumnR

subroutine removeColumnZ(a,remCarray)
  ! cut complex matrix a(n,m), i.e. delete columns not given by array remCarray(k)
  ! thus the result is matrix a of size (n,k)

  complex(kind=wp), allocatable, intent(inout) :: a(:,:)
  integer(kind=iwp), intent(in) :: remCarray(:)
  integer(kind=iwp) :: j, l, m, n, k
  complex(kind=wp), allocatable :: b(:)
  logical(kind=iwp), allocatable :: mask(:,:)

  ! sizes
  n = size(a,1)
  m = size(a,2)
  k = size(remCarray)
  call mma_allocate(mask,n,m,label='mask')
  ! mask creation
  l = 0
  mask(:,:) = .false.
  do j=1,m
    if (any(remCarray == j)) then
      mask(:,j) = .true.
      l = l+n
    end if
  end do
  call mma_allocate(b,l,label='b')
  ! copy remaining elements into temp b
  b(:) = pack(a,mask)
  call mma_deallocate(a)
  call mma_allocate(a,n,k,label='a')
  ! copy back
  a(:,:) = reshape(b,[n,k])
  call mma_deallocate(b)
  call mma_deallocate(mask)

end subroutine removeColumnZ

subroutine removeColumnR(a,remCarray)
  ! cut real matrix a(n,m), i.e. delete columns not given by array remCarray(k)
  ! thus the result is matrix a of size (n,k)

  real(kind=wp), allocatable, intent(inout) :: a(:,:)
  integer(kind=iwp), intent(in) :: remCarray(:)
  integer(kind=iwp) :: j, l, m, n, k
  real(kind=wp), allocatable :: b(:)
  logical(kind=iwp), allocatable :: mask(:,:)

  ! sizes
  n = size(a,1)
  m = size(a,2)
  k = size(remCarray)
  call mma_allocate(mask,n,m,label='mask')
  ! mask creation
  l = 0
  mask(:,:) = .false.
  do j=1,m
    if (any(remCarray == j)) then
      mask(:,j) = .true.
      l = l+n
    end if
  end do
  call mma_allocate(b,l,label='b')
  ! copy remaining elements into temp b
  b(:) = pack(a,mask)
  call mma_deallocate(a)
  call mma_allocate(a,n,k,label='a')
  ! copy back
  a(:,:) = reshape(b,[n,k])
  call mma_deallocate(b)
  call mma_deallocate(mask)

end subroutine removeColumnR

subroutine transformZ(a,u,b,order)
  ! perform orthogonal transformation with transformation matrix
  ! order = True (default): direct transform : b = u^C * a * u
  ! order = False         : inverse transform: b = u   * a * u^C

  complex(kind=wp), intent(in) :: a(:,:), u(:,:)
  complex(kind=wp), intent(out) :: b(:,:)
  logical(kind=iwp), intent(in), optional :: order
  integer(kind=iwp) :: m, n
  complex(kind=wp), allocatable :: temp(:,:)
  logical(kind=iwp) :: order_

  if (present(order)) then
    order_ = order
  else
    order_ = .true.
  end if
  m = size(u,1)
  n = size(u,2)
  if (order_) then
    ASSERT(m == size(a,1))
    call mma_allocate(temp,n,m,label='temp')
    call mult(u,a,temp,.true.,.false.)
    call mult(temp,u,b,.false.,.false.)
  else
    ASSERT(n == size(a,1))
    call mma_allocate(temp,m,n,label='temp')
    call mult(u,a,temp,.false.,.false.)
    call mult(temp,u,b,.false.,.true.)
  end if
  call mma_deallocate(temp)

end subroutine transformZ

subroutine transformR(a,u,b,order)
  ! perform orthogonal transformation with transformation matrix
  ! order = True (default): direct transform : b = u^T * a * u
  ! order = False       : inverse transform: b = u   * a * u^T

  real(kind=wp), intent(in) :: a(:,:), u(:,:)
  real(kind=wp), intent(out) :: b(:,:)
  logical(kind=iwp), intent(in), optional :: order
  integer(kind=iwp) :: m, n
  real(kind=wp), allocatable :: temp(:,:)
  logical(kind=iwp) :: order_

  if (present(order)) then
    order_ = order
  else
    order_ = .true.
  end if
  m = size(u,1)
  n = size(u,2)
  if (order_) then
    ASSERT(m == size(a,1))
    call mma_allocate(temp,n,m,label='temp')
    call mult(u,a,temp,.true.,.false.)
    call mult(temp,u,b,.false.,.false.)
  else
    ASSERT(n == size(a,1))
    call mma_allocate(temp,m,n,label='temp')
    call mult(u,a,temp,.false.,.false.)
    call mult(temp,u,b,.false.,.true.)
  end if
  call mma_deallocate(temp)

end subroutine transformR

subroutine sortci(N1,A,WR,C,print_level)

  integer(kind=iwp), intent(in) :: N1, print_level
  real(kind=wp), intent(inout) :: A(N1,N1)
  real(kind=wp), intent(out) :: WR(N1), C(N1,N1)
  integer(kind=iwp) :: INFO, k, l, LWORK
  real(kind=wp), allocatable :: diag(:,:), B(:,:), WORK(:)

  if (print_level > 3) then
    call mma_allocate(B,N1,N1,label='B')
    call mma_allocate(diag,N1,N1,label='diag')
    B(:,:) = A(:,:)
  end if
  LWORK = 2*N1
  call mma_allocate(WORK,LWORK,label='WORK')
  call dsyev_('V','U',N1,A,N1,WR,WORK,LWORK,INFO)
  if (INFO /= 0) then
    write(u6,*) 'ERROR in sortci'
    call Abend()
  end if
  call dsyev_('V','U',N1,A,N1,WR,WORK,LWORK,INFO)
  call mma_deallocate(WORK)
  C(:,:) = A(:,:)
  if (print_level > 3) then
    call transform(B,C,diag)
    call dashes()
    write(u6,*) 'Printout the diagonalized matrix:'
    call dashes()
    do k=1,10
      write(u6,*) (diag(k,l),l=1,10)
    end do
    call mma_deallocate(B)
    call mma_deallocate(diag)
  end if

end subroutine sortci

subroutine compare_matrices(A,B,n,header,thrs)
  ! check if complex matrices A and B are equal within given threshold thrs

  integer(kind=iwp), intent(in) :: n
  complex(kind=wp), intent(in) :: A(n,n), B(n,n)
  character(len=*), intent(in) :: header
  real(kind=wp), intent(in) :: thrs
  integer(kind=iwp) :: i
  logical(kind=iwp) :: AB_equal

  call dashes()
  write(u6,*) header
  AB_equal = .true.
  do i=1,n
    if (all(abs(A(:,i)-B(:,i)) < thrs)) then
      cycle
    else
      AB_equal = .false.
      write(u6,*) "error in",i
      exit
    end if
  end do
  if (AB_equal) write(u6,*) "matrices are equal"
  call dashes()

end subroutine compare_matrices

subroutine ITO(n,k,q,spins,projs,T)
  ! calculates the matrix <SM|T^K_Q|S'M'> of irreducible tensor operator

  integer(kind=iwp), intent(in) :: n, k, q
  real(kind=wp), intent(in) :: spins(n), projs(n)
  real(kind=wp), intent(out) :: T(n,n)
  integer(kind=iwp) :: i, j
  real(kind=wp) :: s1, s2, m1, m2, fact

  do i=1,n
    do j=1,n
      s1 = spins(i)
      s2 = spins(j)
      m1 = projs(i)
      m2 = projs(j)
      fact = sqrt(real((2*k+1),kind=wp))
      if (mod(int(s1-m1),2) == 1) fact = -fact
      T(i,j) = fact*W3J(s1,real(k,kind=wp),s2,-m1,real(q,kind=wp),m2)
    end do
  end do

end subroutine ITO

subroutine WERDM(rho,n_so,n_sf,k,q,spins,projs,so_sf,RED)
  ! calculates the elements of Wigner-Eckart reduced density matrix for fixed values of K, Q

  integer(kind=iwp), intent(in) :: n_so, n_sf, k, q, so_sf(n_so)
  complex(kind=wp), intent(in) :: rho(n_so,n_so)
  real(kind=wp), intent(in) :: spins(n_so), projs(n_so)
  complex(kind=wp), intent(out) :: RED(n_sf,n_sf)
  integer(kind=iwp) :: i, j, ii, jj
  real(kind=wp) :: T(n_so,n_so)

  RED = cZero
  ! calculate matrix of ITO
  call ITO(n_so,k,q,spins,projs,T)
  do i=1,n_so
    do j=1,n_so
      ! determine sf indices
      ii = so_sf(i)
      jj = so_sf(j)
      RED(ii,jj) = RED(ii,jj)+rho(i,j)*T(i,j)
    end do
  end do

end subroutine WERDM

subroutine WERDM_back(RED,n_so,n_sf,len_sph,k_ranks,q_proj,spins,projs,so_sf,rho_back)
  ! calculates the density matrix in SO basis from the elements of
  ! Wigner-Eckart reduced density matrix, which are stored in 3d-matrix
  ! (len_sph,n_sf,n_sf)

  integer(kind=iwp), intent(in) :: n_so, n_sf, len_sph, k_ranks(len_sph), q_proj(len_sph), so_sf(n_so)
  complex(kind=wp), intent(in) :: RED(len_sph,n_sf,n_sf)
  real(kind=wp), intent(in) :: spins(n_so), projs(n_so)
  complex(kind=wp), intent(out) :: rho_back(n_so,n_so)
  integer(kind=iwp) :: i, j, ii, jj, k, q, l
  real(kind=wp) :: T(n_so,n_so)

  rho_back = cZero
  do l=1,len_sph
    k = k_ranks(l)
    q = q_proj(l)
    ! calculate matrix of ITO
    call ITO(n_so,k,q,spins,projs,T)
    do i=1,n_so
      do j=1,n_so
        ! determine sf indices
        ii = so_sf(i)
        jj = so_sf(j)
        rho_back(i,j) = rho_back(i,j)+RED(l,ii,jj)*T(i,j)
      end do
    end do
  end do

end subroutine WERDM_back

subroutine WERSO(vso,n_so,n_sf,so_sf,spins,projs,redvso)
  ! calculates matrix elements of Wigner-Eckart reduced spin-orbit Hamiltonian
  ! <iSM|Vso|jS'M'> = sqrt(3) sum_{m=0,+-1} (-1)^{S-M+m} 3j{S1S'-MmM'} <iS||Vso||jS'>

  integer(kind=iwp), intent(in) :: n_so, n_sf, so_sf(n_so)
  complex(kind=wp), intent(in) :: vso(n_so,n_so)
  real(kind=wp), intent(in) :: spins(n_so), projs(n_so)
  complex(kind=wp), intent(out) :: redvso(n_sf,n_sf,3)
  real(kind=wp) :: s1, s2, m1, m2, threejsymb
  integer(kind=iwp) :: i, j, ii, jj, m

  redvso = cZero
  do i=1,n_so
    do j=1,n_so
      s1 = spins(i)
      s2 = spins(j)
      m1 = projs(i)
      m2 = projs(j)
      ! determine sf indices
      ii = so_sf(i)
      jj = so_sf(j)
      do m=0,2,1
        threejsymb = W3J(s1,One,s2,-m1,real((m-1),kind=wp),m2)
        if (threejsymb /= Zero) then ! this condition should be checked carefully
          !!!!! test
          !if (redvso(ii,jj,m+1) /= cZero) then
          !  write(u6,*) 'Matrix red VSOC element filled twice', redvso(ii,jj,m+1)
          !  write(u6,*) 'ii,jj = ', ii,jj
          !  write(u6,*) 'i,j   = ', i,j
          !  write(u6,*) 'm     = ', m+1
          !  write(u6,*) 's1,s2 = ', s1,s2
          !  write(u6,*) 'now = ', (-1)**(nint(s1-m1+m-1))*vso(i,j)/sqrt(Three)/threejsymb
          !end if
          redvso(ii,jj,m+1) = (-1)**(nint(s1-m1+m-1))*vso(i,j)/sqrt(Three)/threejsymb
        end if
      end do
    end do
  end do

end subroutine WERSO

subroutine WERSO_back(redvso,n_so,n_sf,so_sf,spins,projs,vso)
  ! calculates matrix elements of Wigner-Eckart reduced spin-orbit Hamiltonian
  ! <iSM|Vso|jS'M'> = sqrt(3) sum_{m=0,+-1} (-1)^{S-M+m} 3j{S1S'-MmM'} <iS||Vso||jS'>

  integer(kind=iwp), intent(in) :: n_so, n_sf, so_sf(n_so)
  complex(kind=wp), intent(in) :: redvso(n_sf,n_sf,3)
  real(kind=wp), intent(in) :: spins(n_so), projs(n_so)
  complex(kind=wp), intent(out) :: vso(n_so,n_so)
  real(kind=wp) :: s1, s2, m1, m2
  integer(kind=iwp) :: i, j, ii, jj, m

  vso = cZero
  do i=1,n_so
    do j=1,n_so
      s1 = spins(i)
      s2 = spins(j)
      m1 = projs(i)
      m2 = projs(j)
      ! determine sf indices
      ii = so_sf(i)
      jj = so_sf(j)
      do m=0,2,1
        vso(i,j) = vso(i,j)+(-1)**(nint(s1-m1+m-1))*sqrt(Three)*W3J(s1,One,s2,-m1,real((m-1),kind=wp),m2)*redvso(ii,jj,m+1)
      end do
    end do
  end do

end subroutine WERSO_back

subroutine print_c_matrix(A,n,header)
  ! prints any complex matrix

  integer(kind=iwp), intent(in) :: n
  complex(kind=wp), intent(in) :: A(n,n)
  character(len=*), intent(in) :: header
  integer(kind=iwp) :: i, j

  call dashes()
  write(u6,*) header
  do i=1,n
    write(u6,*) (A(i,j),j=1,n)
  end do

end subroutine print_c_matrix

subroutine check_hermicity(A,n,A_name,thrs)
  ! check whether matrix A is hermitian
  ! pops a warning only if hermicity is violated

  integer(kind=iwp), intent(in) :: n
  complex(kind=wp), intent(in) :: A(n,n)
  character(len=*), intent(in) :: A_name
  real(kind=wp), intent(in) :: thrs
  real(kind=wp) :: abserror, diff
  integer(kind=iwp) :: i, j

  abserror = Zero
  do i=1,n
    do j=1,i
      diff = abs(real(A(i,j))-real(A(j,i)))
      if ((diff >= thrs) .and. (diff >= abserror)) abserror = diff
      diff = abs(aimag(A(i,j))+aimag(A(j,i)))
      if ((diff >= thrs) .and. (diff >= abserror)) abserror = diff
    end do
  end do
  if (abserror >= thrs) then
    call WarningMessage(1,'Non-hermitian matrix obtained!')
    write(u6,'(a,1x,a,1x,a,1x,g28.16)') 'Matrix',A_name,'Abs Error =',abserror
  end if

end subroutine check_hermicity

function get_kq_order(k_prime,q_prime)
  integer(kind=iwp) :: get_kq_order
  integer(kind=iwp), intent(in) :: k_prime, q_prime
  integer(kind=iwp) :: k, q

  k = 0
  get_kq_order = 0
  do while (k <= k_prime)
    do q=-k,k,1
      get_kq_order = get_kq_order+1
      if (q == q_prime .and. k == k_prime) return
    end do
    k = k+1
  end do

end function get_kq_order

end module rhodyn_utils

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_box_packer

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_init_pkd_paras,              &
             fmm_shift_and_pack_paras

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_pkd_paras(deepest_level,scheme,raw_paras,pkd_paras)

      USE fmm_box_utils, ONLY: fmm_box_centre, fmm_parent_box, fmm_grain

      IMPLICIT NONE
      INTEGER(INTK),      INTENT(IN)    :: deepest_level
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      TYPE(raw_mm_paras), INTENT(INOUT) :: raw_paras(:)
      TYPE(box_mm_paras), POINTER       :: pkd_paras(:)

      TYPE(box_mm_paras) :: tmp_paras(SIZE(raw_paras))
      INTEGER(INTK)      :: i, l_up, box(3), foo
      INTEGER(INTK)      :: tmp_map(SIZE(raw_paras))
      REAL(REALK)        :: grain

      l_up = deepest_level-1
      grain = fmm_grain(scheme,l_up)
      DO i = 1, SIZE(raw_paras)
         tmp_paras(i)%box(:) = raw_paras(i)%box(:)
         tmp_paras(i)%cntr(:) = raw_paras(i)%box_cntr(:)
         tmp_paras(i)%bra = raw_paras(i)%bra
         tmp_paras(i)%level = deepest_level
         tmp_paras(i)%id = i
         box(:) = fmm_parent_box(tmp_paras(i)%box(:))
         tmp_paras(i)%cntr_up(:) = fmm_box_centre(box,grain)
         tmp_paras(i)%map_up = 0   ! not defined yet
      END DO

      IF (ASSOCIATED(pkd_paras)) CALL fmm_quit ('paras should be nullified!')
      IF (.FALSE.) THEN
         ! just build unpacked paras
         foo = SIZE(raw_paras)
         ALLOCATE (pkd_paras(foo))
         pkd_paras(:) = tmp_paras(:)
         tmp_map = (/ (i,i=1,SIZE(raw_paras)) /)
      ELSE
         ! combine paras in same box and branch (i.e. packed form)
         CALL pack_boxed_paras(tmp_paras,pkd_paras,tmp_map)
      END IF
      ! store map of packing indices (raw:boxed)
      raw_paras(:)%map_up = tmp_map(:)

   END SUBROUTINE fmm_init_pkd_paras

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_shift_and_pack_paras(level,scheme,paras_in,paras_out)

      USE fmm_box_utils, ONLY: fmm_box_centre, fmm_grain,              &
                               fmm_parent_box, fmm_parent_bra

      IMPLICIT NONE
      INTEGER(INTK),      INTENT(IN)    :: level
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      TYPE(box_mm_paras), INTENT(INOUT) :: paras_in(:)
      TYPE(box_mm_paras), POINTER       :: paras_out(:)

      TYPE(box_mm_paras) :: tmp_paras(SIZE(paras_in))
      INTEGER(INTK)      :: i, l_down, l_up, box(3), foo
      INTEGER(INTK)      :: tmp_map(SIZE(paras_in))
      REAL(REALK)        :: grain, grain_up

      ! build tmp array for unpacked paras at next level up
      l_down = level+1
      l_up = level-1
      grain = fmm_grain(scheme,level)
      grain_up = fmm_grain(scheme,l_up)
      DO i = 1, SIZE(paras_in)
         tmp_paras(i)%box = fmm_parent_box(paras_in(i)%box)
         tmp_paras(i)%cntr(:) = fmm_box_centre(tmp_paras(i)%box,grain)
         tmp_paras(i)%bra = fmm_parent_bra(paras_in(i)%bra)
         tmp_paras(i)%level = level
         tmp_paras(i)%id = i
         box(:) = fmm_parent_box(tmp_paras(i)%box(:))
         tmp_paras(i)%cntr_up(:) = fmm_box_centre(box,grain_up)
         tmp_paras(i)%map_up = 0   ! not defined yet
      END DO

      IF (.FALSE.) THEN
         ! just build unpacked paras
         foo = SIZE(paras_in)
         ALLOCATE (paras_out(foo))
         paras_out(:) = tmp_paras(:)
         tmp_map = (/ (i,i=1,SIZE(paras_in)) /)
      ELSE
         ! combine paras in same box and branch (i.e. packed form)
         CALL pack_boxed_paras(tmp_paras,paras_out,tmp_map)
      END IF
      ! store map of packing indices (raw:boxed)
      paras_in(:)%map_up = tmp_map(:)

   END SUBROUTINE fmm_shift_and_pack_paras

!-------------------------------------------------------------------------------

   SUBROUTINE pack_boxed_paras(paras_in,paras_out,map)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: paras_in(:)
      TYPE(box_mm_paras), POINTER       :: paras_out(:)
      INTEGER(INTK),      INTENT(OUT)   :: map(:)

      TYPE(box_mm_paras) :: tmp_paras(SIZE(paras_in))
      INTEGER(INTK) :: i, k

      CALL fmm_sort_wrt_boxes_and_branches(1_INTK,paras_in)

      map(:) = 0
      tmp_paras(1) = paras_in(1)
      tmp_paras(1)%id = 1
      map(paras_in(1)%id) = 1

      k = 1
      DO i = 2, SIZE(paras_in)

         IF (paras_in(i)%box(3) /= paras_in(i-1)%box(3)) THEN
            k = k+1
         ELSE IF (paras_in(i)%box(2) /= paras_in(i-1)%box(2)) THEN
            k = k+1
         ELSE IF (paras_in(i)%box(1) /= paras_in(i-1)%box(1)) THEN
            k = k+1
         ELSE IF (paras_in(i)%bra /= paras_in(i-1)%bra) THEN
            k = k+1
         END IF

         tmp_paras(k) = paras_in(i)
         tmp_paras(k)%id = k
         map(paras_in(i)%id) = k

      END DO

      ! store packed parameters in exactly allocated array
      ALLOCATE (paras_out(k))
      paras_out = tmp_paras(1:k)

   END SUBROUTINE pack_boxed_paras

!-------------------------------------------------------------------------------

   RECURSIVE SUBROUTINE fmm_sort_wrt_boxes_and_branches(xyz,paras)

      USE fmm_sort_paras, ONLY: fmm_quicksort_wrt_boxes,      &
                                fmm_quicksort_wrt_branches

      IMPLICIT NONE
      INTEGER(INTK),      INTENT(IN)    :: xyz
      TYPE(box_mm_paras), INTENT(INOUT) :: paras(:)

      INTEGER(INTK) :: i, lo, hi
      REAL(REALK)   :: q1,q2

      IF (SIZE(paras) == 1) RETURN

      ! sort only if needed
      q1 = paras(1)%box(xyz)
      DO i = 2, SIZE(paras)
         q2 = paras(i)%box(xyz)
         IF ( q2 < q1 ) THEN
            CALL fmm_quicksort_wrt_boxes(paras,xyz)
            EXIT
         END IF
         q1 = q2
      END DO

      ! sub-sort next box component
      lo = 1
      DO i = 2, SIZE(paras)
         q1 = paras(i-1)%box(xyz)
         q2 = paras(i)%box(xyz)
         IF ( q2 /= q1 ) THEN
            hi = i-1
            IF (xyz == 3) THEN
               CALL fmm_quicksort_wrt_branches(paras(lo:hi))
            ELSE
               CALL fmm_sort_wrt_boxes_and_branches(xyz+1_INTK,paras(lo:hi))
            END IF
            lo = i
         END IF
      END DO

      ! do last batch
      hi = SIZE(paras)
      IF (xyz == 3) THEN
         CALL fmm_quicksort_wrt_branches(paras(lo:hi))
      ELSE
         CALL fmm_sort_wrt_boxes_and_branches(xyz+1_INTK,paras(lo:hi))
      END IF

   END SUBROUTINE fmm_sort_wrt_boxes_and_branches

!-------------------------------------------------------------------------------

END MODULE fmm_box_packer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine noperm(wrk,wrksize,a,b,post)
! realize mapping without permutation
! define %d, %i

use ccsd_global, only: Map_Type, nsym
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: a
type(Map_Type), intent(inout) :: b
integer(kind=iwp), intent(out) :: post
integer(kind=iwp) :: ib

! def b%i

b%i(1:nsym,1:nsym,1:nsym) = a%i(1:nsym,1:nsym,1:nsym)

! def initial values

b%d(0,:) = a%d(0,:)

post = b%pos0
do ib=1,a%d(0,5)
  b%d(ib,2:6) = a%d(ib,2:6)
  b%d(ib,1) = post
  post = post+b%d(ib,2)

  call map11(wrk(a%d(ib,1)),wrk(b%d(ib,1)),a%d(ib,2),1)

end do

return

end subroutine noperm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_V12(V,V12,nDim)

use Index_Functions, only: iTri, nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(inout) :: V(nDim,nDim)
real(kind=wp), intent(out) :: V12(nDim,nDim)
integer(kind=iwp) :: i, j
real(kind=wp) :: tmp
real(kind=wp), allocatable :: Vec(:,:), VTri(:)

call mma_allocate(Vec,nDim,nDim,Label='Vec')
call mma_allocate(VTri,nTri_Elem(nDim),Label='VTri')

Vec(:,:) = Zero
call dcopy_(nDim,[One],0,Vec,nDim+1)

do i=1,nDim
  do j=1,i
    VTri(iTri(i,j)) = V(i,j)
  end do
end do

call JACOB(VTri,Vec,nDim,nDim)

V12(:,:)= Zero
do i=1,nDim
# ifdef _DEBUGPRINT_
  tmp = VTri(iTri(i,i))
  write(u6,*) 'i,tmp=',i,tmp
# endif
  tmp = sqrt(VTri(iTri(i,i)))
  if (tmp < 1.0e-90_wp) then
    V12(i,i) = 1.0e90_wp
  else
    V12(i,i) = One/tmp
  end if
end do

call DGEMM_('N','T',nDim,nDim,nDim,One,V12,nDim,Vec,nDim,Zero,V,nDim)
call DGEMM_('N','N',nDim,nDim,nDim,One,Vec,nDim,V,nDim,Zero,V12,nDim)

call mma_deallocate(VTri)
call mma_deallocate(Vec)

return

end subroutine Compute_V12

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE CONF_ARC_W(IOCC_MIN,IOCC_MAX, NORB,  NEL,IVERTEXW,
     &                        IARCW)
*
* Obtain arcweights for single and double occupied arcs
* from vertex weights
*
* Jeppe Olsen, October 2001
*
#include "implicit.fh"
*. Input
      INTEGER IVERTEXW(NORB+1,NEL+1)
      INTEGER IOCC_MIN(NORB),IOCC_MAX(NORB)
*. Output
      INTEGER IARCW(NORB,NEL,2)
      IZERO = 0
      CALL ISETVC(IARCW,IZERO,2*NORB*NEL)
* IARCW(I,J,K) is weight of arc with occupation K ending at (I,J)
* IARCW(I,J,K) = Sum(J-K < L <= J)   IVERTEXW(I-1,L)
      DO I = 1, NORB
       DO J = 1, NEL
        IF(IOCC_MIN(I).LE.J .AND. J.LE.IOCC_MAX(I)) THEN
          DO K = 1, NEL
            IF(K.EQ.1) IARCW(I,J,K) = IVERTEXW(I-1+1,J+1)
            IF(K.EQ.2.AND.J.GE.2) IARCW(I,J,K) = IVERTEXW(I-1+1,J+1)
     &                                         + IVERTEXW(I-1+1,J-1+1)
          END DO
        END IF
       END DO
      END DO
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Arc weights for single occupied arcs '
        CALL IWRTMA(IARCW(1,1,1),NORB,NEL,NORB,NEL)
        WRITE(6,*) ' Arc weights for double occupied arcs '
        CALL IWRTMA(IARCW(1,1,2),NORB,NEL,NORB,NEL)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Bond_Tester(Coor,nAtoms,iTab,nx,ny,nz,ix,iy,iz,iAtom,
     &                       iRow,iANr,Schlegel,iOptC,iTabBonds,nBonds,
     &                       nBondMax,iTabAtoms,nMax,ThrB,ThrB_vdW)
      Implicit Real*8 (a-h,o-z)
#define _VDW_
#include "ddvdt.fh"
      Real*8 Coor(3,nAtoms)
      Integer iTab(0:nMax,nx,ny,nz), iANr(nAtoms),
     &        iTabBonds(3,nBondMax), iTabAtoms(2,0:nMax,nAtoms)
      Logical Help, Schlegel
#include "bondtypes.fh"
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*define _TIME_
#ifdef _TIME_
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Check box indices for consistency
*
      If (ix.lt.1.or.ix.gt.nx) Go To 199
      If (iy.lt.1.or.iy.gt.ny) Go To 199
      If (iz.lt.1.or.iz.gt.nz) Go To 199
      Nr=iTab(0, ix,iy,iz) ! nr of atoms in the box.
      If (Nr.eq.0) Go To 199
#ifdef _DEBUGPRINT_
      Write (6,*) 'Bond_Tester: iAtom,ix,iy,iz=',iAtom,ix,iy,iz
#endif
*
      iRow=iTabRow(iANr(iAtom))
      nVal_i=0
      nn=iTabAtoms(1,0,iAtom)
      Do i = 1, nn
         If (iTabBonds(3,iTabAtoms(2,i,iAtom)).eq.Covalent_Bond)
     &       nVal_i=nVal_i+1
      End Do
*
*     Loop over all atoms in the box
*
      If (ThrB.lt.ThrB_vdw) ivdW=vdW_Bond
      Do Ir = 1, Nr
         jAtom=iTab(Ir,ix,iy,iz)
C        If (iAtom.le.jAtom) Go To 99
         If (iAtom.ge.jAtom) Go To 99
         jRow =iTabRow(iANr(jAtom))
         Help = iRow.gt.3.or.jRow.gt.3
#ifdef _DEBUGPRINT_
         Write (6,*) ' jAtom, iAnr(jAtom)=',jAtom, iAnr(jAtom)
         Write (6,*) 'Help=',Help
#endif
*
         x = Coor(1,iAtom)-Coor(1,jAtom)
         y = Coor(2,iAtom)-Coor(2,jAtom)
         z = Coor(3,iAtom)-Coor(3,jAtom)
         rij2 = x**2 + y**2 + z**2
         r0 = rAv(iRow,jRow)
         alpha=aAv(iRow,jRow)
*
*--------Test if we have a bond iAtom-jAtom
*
         If (Schlegel.or.Help) Then
            Rab=Sqrt(rij2)
            RabCov=CovRad(iANr(iAtom))+CovRad(iANr(jAtom))
#ifdef _DEBUGPRINT_
            Write (6,*) 'Rab=',Rab
            Write (6,*) CovRad(iANr(iAtom)),CovRad(iANr(jAtom))
#endif
            If (Rab.le.1.25d0*RabCov) Then
*
*              covalent bond
*
               test=1.0D0
               test_vdW=0.0D0
*
*              Skip if we are looking for vdW bonds
*
               If (ThrB.gt.ThrB_vdW) Go To 99
            Else If (Rab.gt.1.25d0*RabCov .and.
     &               Rab.le.2.00D0*RabCov) Then
*
*              vdW's bond
*
               test=0.0D0
               test_vdW=ThrB_VdW
            Else
*
*              No Bond!
*
               Go To 99
            End If
         Else
            test=Exp(alpha*(r0**2-rij2))
            If (iAnd(iOptC,2048).eq.2048) Then
               r0_vdW=r_ref_vdW(iRow,jRow)
               test_vdW=Exp(-alpha_vdW*(r0_vdW-SQRT(rij2))**2)
            Else
               test_vdW=0.0D0
            End If
#ifdef _DEBUGPRINT_
            Write (6,*)
            Write (6,*) 'Bond_Tester: iAtom,jAtom=',iAtom,jAtom
            Write (6,*) 'Bond_Tester: test=',test,ThrB
            Write (6,*) 'Bond_Tester: test_vdW=',test_vdW,ThrB_vdW
#endif
*
*           If the valence force constant small but not too small
*           denote the bond as an vdW's bond.
            Test_vdW=Max(Test_vdW,Test)
*
*           If already valence bond skip if also vdW bond. We picked
*           up this bond before!
*
            If (test.ge.ThrB .and. Test_vdW.ge.ThrB_vdW) Go To 99
*
*           If none skip
*
            If (test.lt.ThrB .and. test_vdW.lt.ThrB_vdW) Go To 99
*
*           Some logic to see if vdw bond should be included.
*           Hydrogen-hydrogen is always included.
*
            If (iANr(iAtom).ne.1 .or. iANr(jAtom).ne.1) Then
*
*              Skip if any of the atoms has more than 6 valence bonds
*              and the other at least 1 valence bond.
               nVal_j=0
               nn=iTabAtoms(1,0,jAtom)
               Do i = 1, nn
                  If ( iTabBonds(3,iTabAtoms(2,i,jAtom)) .eq.
     &                 Covalent_Bond) nVal_j=nVal_j+1
               End Do
               If ((nVal_i.ge.6.and.nVal_j.ge.1) .or.
     &             (nVal_j.ge.6.and.nVal_i.ge.1)     ) Go To 99
            End If
         End If
*
         If (nBonds+1.gt.nBondMax) Then
            Write (6,*) 'Bond_Tester: nBonds+1.gt.nBondMax'
            Write (6,*) 'nBonds+1=',nBonds+1
            Write (6,*) 'nBondMax=',nBondMax
            Call Abend()
         End If
*
         nBonds = nBonds + 1
         iTabBonds(1,nBonds)=iAtom
         iTabBonds(2,nBonds)=jAtom
*
         If (test.ge.ThrB) Then
            ivdW=Covalent_Bond
         Else If (test_vdW.ge.ThrB_vdW) Then
            ivdW=vdW_Bond
         Else
            Write (6,*) 'Bond_Tester: Illegal operation'
            Call Abend()
            ivdW=99
         End If
         iTabBonds(3,nBonds)=ivdW
*
         nNeighbor=iTabAtoms(1,0,iAtom)
         If (nNeighbor+1.gt.nMax) Then
            Write (6,*) 'Bond_Tester(1): nNeighbor+1.gt.nMax'
            Write (6,*) 'iAtom=',iAtom
            Write (6,*) 'nNeighbor=',nNeighbor
            Write (6,*) 'nMax=',nMax
            Call Abend()
         End If

         nNeighbor=nNeighbor+1
         iTabAtoms(1,0,iAtom) = nNeighbor
         iTabAtoms(1,nNeighbor,iAtom)=jAtom
         iTabAtoms(2,nNeighbor,iAtom)=nBonds
*
         nNeighbor=iTabAtoms(1,0,jAtom)
         If (nNeighbor+1.gt.nMax) Then
            Write (6,*) 'Bond_Tester(2): nNeighbor+1.gt.nMax'
            Write (6,*) 'jAtom=',jAtom
            Write (6,*) 'nNeighbor=',nNeighbor
            Write (6,*) 'nMax=',nMax
            Call Abend()
         End If
         nNeighbor=nNeighbor+1
         iTabAtoms(1,0,jAtom) = nNeighbor
         iTabAtoms(1,nNeighbor,jAtom)=iAtom
         iTabAtoms(2,nNeighbor,jAtom)=nBonds
*
 99      Continue
      End Do
*
 199  Continue
#ifdef _TIME_
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _GROMACS_

subroutine Fetch_QMMM(CastMM,nCastMM)

use, intrinsic :: iso_c_binding, only: c_char, c_int, c_loc, c_ptr
use Isotopes, only: PTab
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
#include "LenIn.fh"
integer(kind=iwp), intent(in) :: nCastMM
integer(kind=iwp), intent(in) :: CastMM(nCastMM)
#include "qmmm.fh"
integer(kind=iwp) :: iAtGMX, iAtNmbGMX, iAtOut, iCastMM, iFirst, iGrpGMX, iLast, iOk, iXYZ, LuXYZ, nAtGMX, nAtIn, nAtOut
logical(kind=iwp) :: Exists
character(len=LenIn) :: Symbol
character(len=256) :: LogFileName, Message, TPRFileName
type(c_ptr) :: ipCR, ipGMS
integer(kind=iwp), allocatable :: AT(:)
real(kind=wp), allocatable :: CoordGMX(:,:), CoordMMO(:,:)
character(len=LenIn), allocatable :: LabMMO(:)
integer(kind=iwp), external :: isFreeUnit
interface
  subroutine mmslave_done(gms) bind(C,NAME='mmslave_done_')
    import :: c_ptr
    type(c_ptr), value :: gms
  end subroutine mmslave_done
  function mmslave_init(cr,log_) bind(C,NAME='mmslave_init_')
    import :: c_char, c_ptr
    type(c_ptr) :: mmslave_init
    type(c_ptr), value :: cr
    character(kind=c_char) :: log_(*)
  end function mmslave_init
  function mmslave_get_atomnumber(gms,id) bind(C,NAME='mmslave_get_atomnumber_')
    import :: c_int, c_ptr
    integer(kind=c_int) :: mmslave_get_atomnumber
    type(c_ptr), value :: gms
    integer(kind=c_int), value :: id
  end function mmslave_get_atomnumber
  function mmslave_get_group_id(gms,id) bind(C,NAME='mmslave_get_group_id_')
    import :: c_int, c_ptr
    integer(kind=c_int) :: mmslave_get_group_id
    type(c_ptr), value :: gms
    integer(kind=c_int), value :: id
  end function mmslave_get_group_id
  function mmslave_natoms(gms) bind(C,NAME='mmslave_natoms_')
    import :: c_int, c_ptr
    integer(kind=c_int) :: mmslave_natoms
    type(c_ptr), value :: gms
  end function mmslave_natoms
  function mmslave_read_tpr(tpr,gms) bind(C,NAME='mmslave_read_tpr_')
    import :: c_char, c_int, c_ptr
    integer(kind=c_int) :: mmslave_read_tpr
    character(kind=c_char) :: tpr(*)
    type(c_ptr), value :: gms
  end function mmslave_read_tpr
  function init_commrec() bind(C,NAME='init_commrec_')
    import :: c_ptr
    type(c_ptr) :: init_commrec
  end function init_commrec
end interface

! Initialize Gromacs mmslave
ipCR = init_commrec()
call prgmtranslate('GMX.LOG',LogFileName,iLast)
LogFileName(iLast+1:iLast+1) = char(0)
ipGMS = mmslave_init(ipCR,LogFileName)

! Tell Gromacs to read tpr file
TPRFileName = TPRDefName
iLast = len_trim(TPRFileName)
call f_inquire(TPRFileName,Exists)
if (.not. Exists) then
  Message = 'File '//TPRFileName(1:iLast)//' not found'
  call WarningMessage(2,Message)
  call Quit_OnUserError()
end if
TPRFileName(iLast+1:iLast+1) = char(0)
iOk = mmslave_read_tpr(TPRFileName,ipGMS)
if (iOk /= 1) then
  Message = 'Error reading tpr file'
  call WarningMessage(2,Message)
  call Quit_OnUserError()
end if

! Fetch coordinates from Gromacs
nAtGMX = mmslave_natoms(ipGMS)
call mma_allocate(CoordGMX,3,nAtGMX)
CoordGMX(:,:) = Zero
iOk = mmslave_copyX_wrapper(ipGMS,int(nAtGMX,kind=c_int),CoordGMX)
if (iOk /= 1) then
  Message = 'Fetch_QMMM: mmslave_copyx is not ok'
  call WarningMessage(2,Message)
  call Abend()
end if

! Find out and count atom types
nAtIn = 0
nAtOut = 0
call mma_allocate(AT,nAtGMX)
do iAtGMX=1,nAtGMX
  iGrpGMX = mmslave_get_group_id(ipGMS,int(iAtGMX-1,kind=c_int))
  if (iGrpGMX == QMGMX) then
    AT(iAtGMX) = QM
  else if (iGrpGMX == MMGMX) then
    AT(iAtGMX) = MMO
  else
    Message = 'Fetch_QMMM: unknown index group'
    call WarningMessage(2,Message)
    call Abend()
  end if
end do
do iCastMM=1,nCastMM
  if (AT(CastMM(iCastMM)) == QM) then
    Message = 'Attempting to cast atom of QM type'
    call WarningMessage(2,Message)
    call Quit_OnUserError()
  else if (AT(CastMM(iCastMM)) == MMI) then
    Message = 'Attempting to cast atom of MMI type'
    call WarningMessage(2,Message)
    call Quit_OnUserError()
  end if
  AT(CastMM(iCastMM)) = MMI
end do
do iAtGMX=1,nAtGMX
  if ((AT(iAtGMX) == QM) .or. (AT(iAtGMX) == MMI)) then
    nAtIn = nAtIn+1
  else
    nAtOut = nAtOut+1
  end if
end do

! Put QM and inner MM atoms in xyz file and outer MM atoms on runfile
LuXYZ = 1
LuXYZ = isFreeUnit(LuXYZ)
call molcas_open(LuXYZ,'GMX.XYZ')
write(LuXYZ,'(i5,/)') nAtIn
call mma_allocate(CoordMMO,3,nAtOut)
call mma_allocate(LabMMO,nAtOut)
iAtOut = 1
do iAtGMX=1,nAtGMX
  iAtNmbGMX = mmslave_get_atomnumber(ipGMS,int(iAtGMX-1,kind=c_int))
  iFirst = index(PTab(iAtNmbGMX),' ')+1
  if (AT(iAtGMX) == QM) then
    Symbol = PTab(iAtNmbGMX)(iFirst:2)
  else
    Symbol = PTab(iAtNmbGMX)(iFirst:2)//'_MM'
  end if
  if ((AT(iAtGMX) == QM) .or. (AT(iAtGMX) == MMI)) then
    write(LuXYZ,'(a8,3E24.15E3)') Symbol(1:5),(CoordGMX(iXYZ,iAtGMX)*NmToAng,iXYZ=1,3)
  else
    do iXYZ=1,3
      CoordMMO(iXYZ,iAtOut) = CoordGMX(iXYZ,iAtGMX)
    end do
    LabMMO(iAtOut) = Symbol
    iAtOut = iAtOut+1
  end if
end do
close(LuXYZ)
call Put_iArray('Atom Types',AT,nAtGMX)
CoordMMO(:,:) = CoordMMO/AuToNm
call Put_dArray('MMO Coords',CoordMMO,3*nAtOut)
call Put_cArray('MMO Labels',LabMMO(1),LenIn*nAtOut)

! Clean up
call mma_deallocate(CoordGMX)
call mma_deallocate(AT)
call mma_deallocate(CoordMMO)
call mma_deallocate(LabMMO)
call mmslave_done(ipGMS)

return

contains

function mmslave_copyx_wrapper(gms,natoms,x)

  integer(kind=iwp) :: mmslave_copyx_wrapper
  type(c_ptr) :: gms
  integer(kind=c_int) :: natoms
  real(kind=wp), target :: x(*)
  interface
    function mmslave_copyx(gms,natoms,x) bind(C,NAME='mmslave_copyx_')
      import :: c_int, c_ptr
      integer(kind=c_int) :: mmslave_copyx
      type(c_ptr), value :: gms, x
      integer(kind=c_int), value :: natoms
    end function mmslave_copyx
  end interface

  mmslave_copyx_wrapper = mmslave_copyx(gms,natoms,c_loc(x(1)))

end function mmslave_copyx_wrapper

end subroutine Fetch_QMMM

#elif !defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(Fetch_QMMM)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HZ(ARR)

use mrci_global, only: ESMALL, HZERO, NRROOT, SZERO
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: ARR(NRROOT,NRROOT,11)
integer(kind=iwp) :: I, I1, I2, I3, I4, IO2, IO3, IO4, J, J1, J2, J3, J4, K
real(kind=wp) :: SUM1, SUM2, SUM3
integer(kind=iwp), parameter :: IX1F = 1, IX2F = 2, IRR = 3, IX1R = 4, IX2R = 5, IX1X1 = 6, IX2X1 = 7, IX2X2 = 8, IFDF = 9, &
                                IFDR = 10, IRDR = 11
real(kind=wp), allocatable :: TMP(:,:)

! THIS SUBROUTINE FORMS THE OVERLAP AND H-ZERO MATRIX ELEMENTS
! IN THE BASIS OF PSI, RHO, XI1, AND XI2 FUNCTIONS.
!
!write(u6,*)
!write(u6,*)' CHECK PRINTS IN HZ.'
!write(u6,*)' X1F ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IX1F),J=1,NRROOT)
!end do
!write(u6,*)' X2F ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IX2F),J=1,NRROOT)
!end do
!write(u6,*)' RR ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IRR),J=1,NRROOT)
!end do
!write(u6,*)' X1R ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IX1R),J=1,NRROOT)
!end do
!write(u6,*)' X2R ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IX2R),J=1,NRROOT)
!end do
!write(u6,*)' X1X1 ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IX1X1),J=1,NRROOT)
!end do
!write(u6,*)' X2X1 ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IX2X1),J=1,NRROOT)
!end do
!write(u6,*)' X2X2 ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IX2X2),J=1,NRROOT)
!end do
!write(u6,*)' FDF ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IFDF),J=1,NRROOT)
!end do
!write(u6,*)' FDR ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IFDR),J=1,NRROOT)
!end do
!write(u6,*)' RDR ARRAY:'
!do I=1,NRROOT
!  write(u6,'(1X,5F15.6)') (ARR(I,J,IRDR),J=1,NRROOT)
!end do
! FIRST, CREATE OVERLAP MATRIX, AND INITIALIZE HZERO MATRIX WITH ALL
! TERMS THAT DO NOT REQUIRE MATRIX MULTIPLIES:
do I1=1,NRROOT
  I2 = I1+NRROOT
  I3 = I1+2*NRROOT
  I4 = I1+3*NRROOT
  do J1=1,NRROOT
    J2 = J1+NRROOT
    J3 = J1+2*NRROOT
    J4 = J1+3*NRROOT
    SZERO(I1,J1) = Zero
    SZERO(I2,J1) = Zero
    SZERO(I3,J1) = ARR(I1,J1,IX1F)
    SZERO(I4,J1) = ARR(I1,J1,IX2F)
    SZERO(I2,J2) = ARR(I1,J1,IRR)
    SZERO(I3,J2) = ARR(I1,J1,IX1R)
    SZERO(I4,J2) = ARR(I1,J1,IX2R)
    SZERO(I3,J3) = ARR(I1,J1,IX1X1)
    SZERO(I4,J3) = ARR(I1,J1,IX2X1)
    SZERO(I4,J4) = ARR(I1,J1,IX2X2)
    HZERO(I1,J1) = Zero
    if (I1 == J1) then
      SZERO(I1,J1) = One
      HZERO(I1,J1) = ESMALL(I1)
    end if
    HZERO(I2,J1) = ARR(I1,J1,IRR)
    HZERO(I3,J1) = ARR(I1,J1,IX1F)*ESMALL(J1)+ARR(I1,J1,IX1R)
    HZERO(I4,J1) = ARR(I1,J1,IX2F)*ESMALL(J1)+ARR(I1,J1,IX2R)
    HZERO(I2,J2) = ARR(I1,J1,IRDR)
    HZERO(I3,J2) = ESMALL(I1)*ARR(I1,J1,IX1R)
    HZERO(I4,J2) = ESMALL(I1)*ARR(I1,J1,IX2R)+ARR(I1,J1,IRR)
    HZERO(I3,J3) = ARR(I1,J1,IX1X1)*ESMALL(J1)-ARR(J1,I1,IX1F)
    HZERO(I4,J3) = ARR(I1,J1,IX2X1)*ESMALL(J1)
    HZERO(I4,J4) = ARR(I1,J1,IX2X2)*ESMALL(J1)+ARR(I1,J1,IX2R)
  end do
end do
IO2 = NRROOT
IO3 = 2*NRROOT
IO4 = 3*NRROOT
do I=1,NRROOT
  do J=1,NRROOT
    SUM2 = HZERO(IO3+I,IO2+J)
    SUM3 = HZERO(IO4+I,IO2+J)
    do K=1,NRROOT
      SUM2 = SUM2+ARR(I,K,IX1F)*(ARR(K,J,IRR)-ARR(K,J,IFDR))
      SUM3 = SUM3+ARR(I,K,IX2F)*(ARR(K,J,IRR)-ARR(K,J,IFDR))
    end do
    HZERO(IO3+I,IO2+J) = SUM2
    HZERO(IO4+I,IO2+J) = SUM3
  end do
end do
do I=1,NRROOT
  do J=1,NRROOT
    SUM2 = Zero
    SUM3 = Zero
    do K=1,NRROOT
      SUM2 = SUM2+ARR(I,K,IX1F)*ARR(J,K,IX1F)
      SUM3 = SUM3+ARR(I,K,IX2F)*ARR(J,K,IX1F)
    end do
    HZERO(IO3+I,IO3+J) = HZERO(IO3+I,IO3+J)-SUM2*ESMALL(J)
    HZERO(IO3+J,IO3+I) = HZERO(IO3+J,IO3+I)-SUM2*ESMALL(J)
    HZERO(IO4+I,IO3+J) = HZERO(IO4+I,IO3+J)-SUM3*ESMALL(J)
  end do
end do
do I=1,NRROOT
  do J=1,NRROOT
    SUM2 = Zero
    SUM3 = Zero
    do K=1,NRROOT
      SUM2 = SUM2+ARR(I,K,IX2F)*ARR(J,K,IX1F)
      SUM3 = SUM3+ARR(I,K,IX2F)*ARR(J,K,IX2F)
    end do
    HZERO(IO4+I,IO3+J) = HZERO(IO4+I,IO3+J)-SUM2*ESMALL(I)
    HZERO(IO4+I,IO4+J) = HZERO(IO4+I,IO4+J)-SUM3*ESMALL(I)
    HZERO(IO4+J,IO4+I) = HZERO(IO4+J,IO4+I)-SUM3*ESMALL(I)
  end do
end do
call mma_allocate(TMP,NRROOT,NRROOT,label='TMP')
do I=1,NRROOT
  do J=1,NRROOT
    SUM1 = Zero
    do K=1,NRROOT
      SUM1 = SUM1+ARR(I,K,IFDF)*ARR(J,K,IX1F)
    end do
    TMP(I,J) = SUM1
  end do
end do
do I=1,NRROOT
  do J=1,NRROOT
    SUM2 = HZERO(IO3+I,IO3+J)
    SUM3 = HZERO(IO4+I,IO3+J)
    do K=1,NRROOT
      SUM2 = SUM2+ARR(I,K,IX1F)*TMP(K,J)
      SUM3 = SUM3+ARR(I,K,IX2F)*TMP(K,J)
    end do
    HZERO(IO3+I,IO3+J) = SUM2
    HZERO(IO4+I,IO3+J) = SUM3
  end do
end do
do I=1,NRROOT
  do J=1,NRROOT
    SUM1 = Zero
    do K=1,NRROOT
      SUM1 = SUM1+ARR(I,K,IFDF)*ARR(J,K,IX2F)
    end do
    TMP(I,J) = SUM1
  end do
end do
do I=1,NRROOT
  do J=1,NRROOT
    SUM3 = HZERO(IO4+I,IO4+J)
    do K=1,NRROOT
      SUM3 = SUM3+ARR(I,K,IX2F)*TMP(K,J)
    end do
    HZERO(IO4+I,IO4+J) = SUM3
  end do
end do
do I=1,NRROOT
  do J=1,NRROOT
    TMP(I,J) = ESMALL(I)*ARR(J,I,IX1F)+ARR(J,I,IX1R)
  end do
end do
do I=1,NRROOT
  do J=1,NRROOT
    SUM2 = HZERO(IO3+I,IO3+J)
    SUM3 = HZERO(IO4+I,IO3+J)
    do K=1,NRROOT
      SUM2 = SUM2+ARR(I,K,IX1F)*TMP(K,J)+ARR(I,K,IX1R)*ARR(J,K,IX1F)
      SUM3 = SUM3+ARR(I,K,IX2F)*TMP(K,J)+ARR(I,K,IX2R)*ARR(J,K,IX1F)
    end do
    HZERO(IO3+I,IO3+J) = SUM2
    HZERO(IO4+I,IO3+J) = SUM3
  end do
end do
do I=1,NRROOT
  do J=1,NRROOT
    TMP(I,J) = ESMALL(I)*ARR(J,I,IX2F)+ARR(J,I,IX2R)
  end do
end do
do I=1,NRROOT
  do J=1,NRROOT
    SUM3 = HZERO(IO4+I,IO4+J)
    do K=1,NRROOT
      SUM3 = SUM3+ARR(I,K,IX2F)*TMP(K,J)+ARR(I,K,IX2R)*ARR(J,K,IX2F)
    end do
    HZERO(IO4+I,IO4+J) = SUM3
  end do
end do
call mma_deallocate(TMP)
do I1=1,NRROOT
  I2 = I1+NRROOT
  I3 = I1+2*NRROOT
  I4 = I1+3*NRROOT
  do J1=1,NRROOT
    J2 = J1+NRROOT
    J3 = J1+2*NRROOT
    J4 = J1+3*NRROOT
    HZERO(I1,J2) = HZERO(J2,I1)
    HZERO(I1,J3) = HZERO(J3,I1)
    HZERO(I1,J4) = HZERO(J4,I1)
    HZERO(I2,J3) = HZERO(J3,I2)
    HZERO(I2,J4) = HZERO(J4,I2)
    HZERO(I3,J4) = HZERO(J4,I3)
    SZERO(I1,J2) = SZERO(J2,I1)
    SZERO(I1,J3) = SZERO(J3,I1)
    SZERO(I1,J4) = SZERO(J4,I1)
    SZERO(I2,J3) = SZERO(J3,I2)
    SZERO(I2,J4) = SZERO(J4,I2)
    SZERO(I3,J4) = SZERO(J4,I3)
  end do
end do

return

end subroutine HZ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

subroutine MCLR_banner()

use Definitions, only: u6

implicit none

! figlet -f larry3d.flf MCLR
write(u6,100) "        ____     __       ____"
write(u6,100) " /'\_/`\/\  _`\  /\ \     /\  _`\"
write(u6,100) "/\      \ \ \/\_\\ \ \    \ \ \L\ \"
write(u6,100) "\ \ \__\ \ \ \/_/_\ \ \  __\ \ ,  /"
write(u6,100) " \ \ \_/\ \ \ \L\ \\ \ \L\ \\ \ \\ \"
write(u6,100) "  \ \_\\ \_\ \____/ \ \____/ \ \_\ \_\"
write(u6,100) "   \/_/ \/_/\/___/   \/___/   \/_/\/ /"
write(u6,100) ""
write(u6,100) ""

100 format(16x,a)

end subroutine MCLR_banner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Igor Schapiro                                    *
!***********************************************************************
!
! *********************************************************************
! *                                                                   *
! *  Writes out the forces and energies for Gromacs                   *
! *                                                                   *
! * 18/01/2008                                                        *
! * Igor Schapiro                                                     *
! *                                                                   *
! *********************************************************************

subroutine GROM(irc)

use Dynamix_Globals, only: iPrint, INSANE
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer :: natom, i, j, filenum
character(len=80) :: filename
real(kind=wp), allocatable :: xyz(:), force(:)
character(len=2), allocatable :: atom(:)
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

if (IPRINT == INSANE) write(u6,*) ' Entering GROM'

write(u6,*) '**** Writes out Forces and Energies for Gromacs ****'

call DxRdNAtomStnd(natom)
call mma_allocate(atom,natom)
call mma_allocate(xyz,natom*3)
call mma_allocate(force,natom*3)

! Read atom, their coordinates and forces

call DxRdStnd(natom,atom,xyz,force)

! Write the energies and forces to file

filenum = IsFreeUnit(81)
filename = 'MOL2GROM'
call Molcas_Open(filenum,filename)
write(filenum,*) natom
do i=1,natom
  write(filenum,'(3es20.10)') (force((i-1)*3+j),j=1,3)
end do
close(filenum)

call mma_deallocate(atom)
call mma_deallocate(xyz)
call mma_deallocate(force)

irc = _RC_ALL_IS_WELL_

return

end subroutine GROM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NEXT_CONF_FOR_OCCLS(ICONF,IOCCLS,NGAS,NOBPT,INI,NONEW)
! Obtain next configuration for occupation class
!
! Jeppe Olsen, Nov. 2001

use lucia_data, only: MXPNGAS, MXPORB
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(inout) :: ICONF(*)
integer(kind=iwp), intent(in) :: NGAS, IOCCLS(NGAS), NOBPT(NGAS), INI
integer(kind=iwp), intent(out) :: NONEW
integer(kind=iwp) :: IBEL(MXPNGAS), IBORB(MXPNGAS), ICONF_GAS(MXPORB), IGAS, INI_L, JBEL, JBORB, JEL, JGAS, JORB, NEL_GAS, &
                     NONEW_L, NORB_GAS
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: NEL

! Total number of electrons
NEL = sum(IOCCLS)
#endif
!write(u6,*) ' NEXT_CONF ... NEL, NGAS = ',NEL,NGAS
! Offset for orbitals and electrons
do IGAS=1,NGAS
  if (IGAS == 1) then
    IBORB(IGAS) = 1
    IBEL(IGAS) = 1
  else
    IBORB(IGAS) = IBORB(IGAS-1)+NOBPT(IGAS-1)
    IBEL(IGAS) = IBEL(IGAS-1)+IOCCLS(IGAS-1)
  end if
end do

NONEW = 1

if (INI == 1) then

  ! Initial configuration

  NONEW = 0
  INI_L = 1
  NONEW_L = 0
  do IGAS=1,NGAS
    ! Initial configuration for this GASSPACE
    NEL_GAS = IOCCLS(IGAS)
    NORB_GAS = NOBPT(IGAS)
    !write(u6,*) ' IGAS, NEL_GAS, NORB_GAS = ',IGAS,NEL_GAS,NORB_GAS
    call NXT_CONF(ICONF_GAS,NEL_GAS,NORB_GAS,INI_L,NONEW_L)
    if (NONEW_L == 1) then
      NONEW = 1
      exit
    else
      JBEL = IBEL(IGAS)
      JBORB = IBORB(IGAS)
      JEL = IOCCLS(IGAS)
      JORB = NOBPT(IGAS)
      call REFORM_CONF_FOR_GAS2(ICONF_GAS,ICONF,JBORB,JBEL,MXPORB,JEL)
    end if
  end do

# ifdef _DEBUGPRINT_
  if (IGAS > NGAS) then
    write(u6,*) ' Initial configuration'
    call IWRTMA(ICONF,1,NEL,1,NEL)
  end if
# endif

else

  ! Next configuration

  ! Loop over GAS spaces and find first GASspace where a new configuration
  ! could be obtained
  do IGAS=1,NGAS
    !write(u6,*) ' IGAS = ',IGAS
    ! Remove the offsets for this space
    JBEL = IBEL(IGAS)
    JBORB = IBORB(IGAS)
    JEL = IOCCLS(IGAS)
    JORB = NOBPT(IGAS)
    !write(u6,*) ' JBEL, JBORB, JEL, JORB = ',JBEL,JBORB,JEL,JORB
    call REFORM_CONF_FOR_GAS1(ICONF_GAS,ICONF,JBORB,JBEL,MXPORB,JEL)
    ! Generate next configuration for this space
    INI_L = 0
    call NXT_CONF(ICONF_GAS,JEL,JORB,INI_L,NONEW_L)
    if (NONEW_L == 0) then
      NONEW = 0
      ! Configuration in space IGAS, was increased. Copy this and reset configurations
      ! in previous gasspaces to initial form
      call REFORM_CONF_FOR_GAS2(ICONF_GAS,ICONF,JBORB,JBEL,MXPORB,JEL)

      do JGAS=1,IGAS-1
        JBEL = IBEL(JGAS)
        JBORB = IBORB(JGAS)
        JEL = IOCCLS(JGAS)
        JORB = NOBPT(JGAS)
        call REFORM_CONF_FOR_GAS1(ICONF_GAS,ICONF,JBORB,JBEL,MXPORB,JEL)
        INI_L = 1
        call NXT_CONF(ICONF_GAS,JEL,JORB,INI_L,NONEW_L)
        call REFORM_CONF_FOR_GAS2(ICONF_GAS,ICONF,JBORB,JBEL,MXPORB,JEL)
      end do
      ! Get out of the loop
      exit
    end if
  end do
  ! End of loop over gasspaces
end if
! End if switch between initialization/next

#ifdef _DEBUGPRINT_
if (NONEW == 1) then
  write(u6,*) ' No new configuration'
else
  write(u6,*) ' New configuration'
  call IWRTMA(ICONF,1,NEL,1,NEL)
end if
#endif

end subroutine NEXT_CONF_FOR_OCCLS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2007, Roland Lindh                                *
************************************************************************
      SubRoutine PGet2_RI2(iCmp,iBas,jBas,kBas,lBas,
     &                  Shijij, iAO, iAOst, nijkl,PSO,nPSO,
     &                  ExFac,CoulFac,PMax,V_K,mV_K,Z_p_K,nSA,
     &                  nZ_p_k)
************************************************************************
*  Object: to assemble the 2nd order density matrix of a SCF wave      *
*          function from the 1st order density matrix.                 *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*                                                                      *
*             Modified to RI-DFT, March 2007                           *
************************************************************************
      use Basis_Info, only: nBas, nBas_Aux
      use SOAO_Info, only: iAOtSO
      use pso_stuff, only: nnp, lPSO, lsa, DMdiag
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "WrkSpc.fh"
#include "exterm.fh"
#include "chomp2g_alaska.fh"
      Real*8 PSO(nijkl,nPSO), V_K(mV_K,nSA),Z_p_K(nZ_p_k,*)
      Integer iCmp(4), iAO(4), iAOst(4)
      Logical Shijij, Found
*     Local Array
      Integer jSym(0:7), lSym(0:7)
      Integer iTwoj(0:7),CumnnP(0:7),CumnnP2(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      iRout = 39
      iPrint = nPrint(iRout)
      iPrint=99
      Call RecPrt('V_K',' ',V_K,1,mV_K)
#endif

      Call CWTime(Cpu1,Wall1)
*                                                                      *
************************************************************************
*                                                                      *
      lOper=1
      PMax=Zero
      iSO=1
      ip_CikJ = ip_CijK
      nMaxBas = Max(jBas,lBas)
*
      Call FZero(PSO,nijkl*nPSO)
*
      If (lPSO) Then
        CumnnP(0)=0
        CumnnP2(0)=0
        Do i=1,nIrrep-1
          nB = nBas_Aux(i-1)
          If (i.eq.1) nB = nB-1
          CumnnP(i)=CumnnP(i-1)+nnP(i-1)
          CumnnP2(i)=CumnnP2(i-1)+nnP(i-1)*nB
        End Do
      End If
*
      Call Qpg_iScalar('SCF mode',Found)
      If (Found) Then
         Call Get_iScalar('SCF mode',iUHF) ! either 0 or 1
      Else
         iUHF=0
      EndIf

*                                                                      *
************************************************************************
*                                                                      *
      Fac = One/Four
      MemSO2 = 0
*                                                                      *
************************************************************************
*                                                                      *
*     Pure DFT
*
      If (ExFac.eq.Zero) Then
*                                                                      *
************************************************************************
*                                                                      *
      Do i2 = 1, iCmp(2)
         njSym = 0
         Do j = 0, nIrrep-1
            If (iAOtSO(iAO(2)+i2,j)>0) Then
               jSym(njSym) = j
               njSym = njSym + 1
            End If
         End Do
*
         Do i4 = 1, iCmp(4)
            nlSym = 0
            Do j = 0, nIrrep-1
               If (iAOtSO(iAO(4)+i4,j)>0) Then
                  lSym(nlSym) = j
                  nlSym = nlSym + 1
               End If
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*           Loop over irreps which are spanned by the basis function.
*
            Do js = 0, njSym-1
               j2 = jSym(js)
               jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
*
               Do ls = 0, nlSym-1
                  j4 = lSym(ls)
                  If (j2.ne.j4) Go To 410
                  lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
*
                  MemSO2 = MemSO2 + 1
                  If (j2.ne.0) Go To 410
*
                  mijkl = 0
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl - nBas(j4)
                     Do jAOj = 0, jBas-1
                        jSOj = jSO + jAOj - nBas(j2)
                        mijkl = mijkl + 1
*
*-----------------------Coulomb contribution
                        If (j2.eq.0) Then
*---------------------------j4.eq.0 also
                           temp=V_K(jSOj,1)*V_K(lSOl,1)*Coulfac
*                          temp=Zero
                        Else
                           temp = Zero
                        End If
*
                        PMax=Max(PMax,Abs(Temp))
                        PSO(mijkl,MemSO2) =  Fac * temp
*
                     End Do
                  End Do
*
 410              Continue
               End Do
            End Do
*
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Hybrid DFT and HF
*
      Else If (iMP2prpt .ne. 2 .and. .Not.lPSO .and. iUHF.eq.0 ) Then
*                                                                      *
************************************************************************
*                                                                      *
      Do i2 = 1, iCmp(2)
         njSym = 0
         Do j = 0, nIrrep-1
            If (iAOtSO(iAO(2)+i2,j)>0) Then
               jSym(njSym) = j
               njSym = njSym + 1
            End If
         End Do
*
         Do i4 = 1, iCmp(4)
            nlSym = 0
            Do j = 0, nIrrep-1
               If (iAOtSO(iAO(4)+i4,j)>0) Then
                  lSym(nlSym) = j
                  nlSym = nlSym + 1
               End If
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*           Loop over irreps which are spanned by the basis function.
*
            Do js = 0, njSym-1
               j2 = jSym(js)
               jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
*
               Do ls = 0, nlSym-1
                  j4 = lSym(ls)
                  If (j2.ne.j4) Go To 510
                  lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
*
                  MemSO2 = MemSO2 + 1
*
                  Call FZero(Work(ip_A),jBas*lBas)
*
                  Do iSym = 1, nIrrep
                     kSym = iEor(j2,iSym-1)+1
                     nik = nIJ1(iSym,kSym,iSO)
*
                     If (nik.eq.0) Go To 520
*
                     jSOj= jSO-nBas(j2)
                     iAdrJ = nik*(jSOj-1)+iAdrCVec(j2+1,iSym,iSO)
                     Call dDaFile(LuCVector(j2+1,iSO),2,Work(ip_CikJ),
     &                            nik*jBas,iAdrJ)
*
                     If (lSO.ne.jSO) Then
                        ip_CikL = ip_CikJ + nik*nMaxBas
                        lSOl=lSO-nBas(j4)
                        iAdrL = nik*(lSOl-1)+iAdrCVec(j4+1,iSym,iSO)
                        Call dDaFile(LuCVector(j4+1,iSO),2,
     &                               Work(ip_CikL),nik*lBas,iAdrL)
                        ip_V2 = ip_CikL
                     Else
                        ip_V2 = ip_CikJ
                     End If
*
                     Fact=One
                     If (iSym.ne.kSym) Fact=Half
                     Call DGEMM_('T','N',jBas,lBas,nik,
     &                           Fact,Work(ip_CikJ),nik,
     &                           Work(ip_V2),nik,
     &                           1.0D0,Work(ip_A),jBas)
*
 520                 Continue
*
                  End Do

                  mijkl = 0
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl - nBas(j4)
                     Do jAOj = 0, jBas-1
                        jSOj = jSO + jAOj - nBas(j2)
                        mijkl = mijkl + 1
*
*-----------------------Coulomb contribution
                        If (j2.eq.0) Then
*---------------------------j4.eq.0 also
                           temp=V_K(jSOj,1)*V_K(lSOl,1)*Coulfac
*                          temp=Zero
                        Else
                           temp = Zero
                        End If
*
*-----------------------Exchange contribution
                        temp = temp
     &                       - ExFac*Work(ip_A+mijkl-1)
*
                        PMax=Max(PMax,Abs(Temp))
                        PSO(mijkl,MemSO2) =  Fac * temp
*
                     End Do
                  End Do
*
 510              Continue
               End Do
            End Do
*
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Hybrid UDFT and UHF
*
      Else If (iMP2prpt .ne. 2 .and. .Not.lPSO .and. iUHF.eq.1 ) Then
*
         Write (6,*) 'Pget2_RI2: UDFT/UHF not implemented yet.'
         Call Abend()
*                                                                      *
************************************************************************
*                                                                      *
*     CASSCF
*
      Else If (iMP2prpt .ne. 2 .and. lPSO .and. .Not. LSA) Then
*                                                                      *
************************************************************************
*                                                                      *
      Do i2 = 1, iCmp(2)
         njSym = 0
         Do j = 0, nIrrep-1
            If (iAOtSO(iAO(2)+i2,j)>0) Then
               jSym(njSym) = j
               njSym = njSym + 1
            End If
         End Do
*
         Do i4 = 1, iCmp(4)
            nlSym = 0
            Do j = 0, nIrrep-1
               If (iAOtSO(iAO(4)+i4,j)>0) Then
                  lSym(nlSym) = j
                  nlSym = nlSym + 1
               End If
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*           Loop over irreps which are spanned by the basis function.
*
            Do js = 0, njSym-1
               j2 = jSym(js)
               jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
*
               Do ls = 0, nlSym-1
                  j4 = lSym(ls)
                  If (j2.ne.j4) Go To 610
                  lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
*
                  MemSO2 = MemSO2 + 1
*
                  Call FZero(Work(ip_A),jBas*lBas)
*
                  Do iSym = 1, nIrrep
                     kSym = iEor(j2,iSym-1)+1
                     nik = nIJ1(iSym,kSym,iSO)
*
                     If (nik.eq.0) Go To 620
*
                     jSOj= jSO-nBas(j2)
                     iAdrJ = nik*(jSOj-1)+iAdrCVec(j2+1,iSym,iSO)
                     Call dDaFile(LuCVector(j2+1,iSO),2,Work(ip_CikJ),
     &                            nik*jBas,iAdrJ)
*
                     If (lSO.ne.jSO) Then
                        ip_CikL = ip_CikJ + nik*nMaxBas
                        lSOl=lSO-nBas(j4)
                        iAdrL = nik*(lSOl-1)+iAdrCVec(j4+1,iSym,iSO)
                        Call dDaFile(LuCVector(j4+1,iSO),2,
     &                               Work(ip_CikL),nik*lBas,iAdrL)
                        ip_V2 = ip_CikL
                     Else
                        ip_V2 = ip_CikJ
                     End If
*
                     Fact=One
                     If (iSym.ne.kSym) Fact=Half
                     Call DGEMM_('T','N',jBas,lBas,nik,
     &                           Fact,Work(ip_CikJ),nik,
     &                           Work(ip_V2),nik,
     &                           1.0D0,Work(ip_A),jBas)
*
 620                 Continue
*
                  End Do
*
                  mijkl = 0
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl - nBas(j4)
                     Do jAOj = 0, jBas-1
                        jSOj = jSO + jAOj - nBas(j2)
                        mijkl = mijkl + 1
*
*-----------------------Coulomb contribution
                        If (j2.eq.0) Then
*---------------------------j4.eq.0 also
                           temp=V_K(jSOj,1)*V_K(lSOl,1)*Coulfac
*                          temp=Zero
                        Else
                           temp = Zero
                        End If
*
*-----------------------Exchange contribution
                        temp = temp
     &                       - ExFac*Work(ip_A+mijkl-1)
*
                        temp2=0.0d0
                        jpSOj=CumnnP2(j2)+(jSOj-1)*nnP(j2)
                        jpSOl=CumnnP2(j2)+(lSOl-1)*nnP(j2)
                        Do jp=1,nnP(j2)
                          temp2=temp2+sign(1.0d0,
     &                          DMdiag(CumnnP(j2)+jp,1))*
     &                          Z_p_K(jpSOj+jp,1)*Z_p_K(jpSOl+jp,1)
                        End Do
                        temp=temp+temp2
*
                        PMax=Max(PMax,Abs(Temp))
                        PSO(mijkl,MemSO2) =  Fac * temp
*
                     End Do
                  End Do
*
 610              Continue
               End Do
            End Do
*
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     SA-CASSCF
*
      Else If ( iMP2prpt .ne. 2 .and. lPSO .and. lSA ) Then
*                                                                      *
************************************************************************
*                                                                      *
      Write (6,*) 'Pget2_ri2: SA-CASSCF not implemented yet'
      Call Abend()
*
      Do i2 = 1, iCmp(2)
         njSym = 0
         Do j = 0, nIrrep-1
            If (iAOtSO(iAO(2)+i2,j)>0) Then
               jSym(njSym) = j
               njSym = njSym + 1
            End If
         End Do
*
         Do i4 = 1, iCmp(4)
            nlSym = 0
            Do j = 0, nIrrep-1
               If (iAOtSO(iAO(4)+i4,j)>0) Then
                  lSym(nlSym) = j
                  nlSym = nlSym + 1
               End If
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*           Loop over irreps which are spanned by the basis function.
*
            Do js = 0, njSym-1
               j2 = jSym(js)
               jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
*
               Do ls = 0, nlSym-1
                  j4 = lSym(ls)
                  If (j2.ne.j4) Go To 710
                  lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
*
                  MemSO2 = MemSO2 + 1
*
                  Call FZero(Work(ip_A),jBas*lBas)
*
                  Do iSym = 1, nIrrep
                     kSym = iEor(j2,iSym-1)+1
                     nik = nIJ1(iSym,kSym,iSO)
*
                     If (nik.eq.0) Go To 720
*
                     jSOj= jSO-nBas(j2)
                     iAdrJ = nik*(jSOj-1)+iAdrCVec(j2+1,iSym,iSO)
                     Call dDaFile(LuCVector(j2+1,iSO),2,Work(ip_CikJ),
     &                            nik*jBas,iAdrJ)
*
                     If (lSO.ne.jSO) Then
                        ip_CikL = ip_CikJ + nik*nMaxBas
                        lSOl=lSO-nBas(j4)
                        iAdrL = nik*(lSOl-1)+iAdrCVec(j4+1,iSym,iSO)
                        Call dDaFile(LuCVector(j4+1,iSO),2,
     &                               Work(ip_CikL),nik*lBas,iAdrL)
                        ip_V2 = ip_CikL
                     Else
                        ip_V2 = ip_CikJ
                     End If
*
                     Fact=One
                     If (iSym.ne.kSym) Fact=Half
                     Call DGEMM_('T','N',jBas,lBas,nik,
     &                           Fact,Work(ip_CikJ),nik,
     &                           Work(ip_V2),nik,
     &                           1.0D0,Work(ip_A),jBas)
*
 720                 Continue
*
                  End Do

                  mijkl = 0
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl - nBas(j4)
                     Do jAOj = 0, jBas-1
                        jSOj = jSO + jAOj - nBas(j2)
                        mijkl = mijkl + 1
*
*-----------------------Coulomb contribution
                        If (j2.eq.0) Then
*---------------------------j4.eq.0 also
                           temp=CoulFac*(V_K(lSOl,1)*V_K(jSOj,2)+
     &                                   V_K(lSOl,2)*V_K(jSOj,1)+
     &                                   V_K(lSOl,3)*V_K(jSOj,4)+
     &                                   V_K(lSOl,4)*V_K(jSOj,3))
*                          temp=Zero
                        Else
                           temp = Zero
                        End If
*
*-----------------------Exchange contribution
                        temp = temp
     &                       - ExFac*Work(ip_A+mijkl-1)
*
                        PMax=Max(PMax,Abs(Temp))
                        PSO(mijkl,MemSO2) =  Fac * temp
*
                     End Do
                  End Do
*
 710              Continue
               End Do
            End Do
*
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     MP2
*
      Else
*                                                                      *
************************************************************************
*                                                                      *
      Write (6,*) 'Pget2_ri2: MP2 not implemented yet'
      Call Abend()
*
      Do i2 = 1, iCmp(2)
         njSym = 0
         Do j = 0, nIrrep-1
            If (iAOtSO(iAO(2)+i2,j)>0) Then
               jSym(njSym) = j
               njSym = njSym + 1
            End If
         End Do
*
         Do i4 = 1, iCmp(4)
            nlSym = 0
            Do j = 0, nIrrep-1
               If (iAOtSO(iAO(4)+i4,j)>0) Then
                  lSym(nlSym) = j
                  nlSym = nlSym + 1
               End If
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*           Loop over irreps which are spanned by the basis function.
*
            Do js = 0, njSym-1
               j2 = jSym(js)
               jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
*
               Do ls = 0, nlSym-1
                  j4 = lSym(ls)
                  If (j2.ne.j4) Go To 810
                  lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
*
                  MemSO2 = MemSO2 + 1
*
                  Call FZero(Work(ip_A),jBas*lBas)
*
                  Do iSym = 1, nIrrep
                     kSym = iEor(j2,iSym-1)+1
                     nik = nIJ1(iSym,kSym,iSO)
*
                     If (nik.eq.0) Go To 820
*
                     jSOj= jSO-nBas(j2)
                     iAdrJ = nik*(jSOj-1)+iAdrCVec(j2+1,iSym,iSO)
                     Call dDaFile(LuCVector(j2+1,iSO),2,Work(ip_CikJ),
     &                            nik*jBas,iAdrJ)
*
                     If (lSO.ne.jSO) Then
                        ip_CikL = ip_CikJ + nik*nMaxBas
                        lSOl=lSO-nBas(j4)
                        iAdrL = nik*(lSOl-1)+iAdrCVec(j4+1,iSym,iSO)
                        Call dDaFile(LuCVector(j4+1,iSO),2,
     &                               Work(ip_CikL),nik*lBas,iAdrL)
                        ip_V2 = ip_CikL
                     Else
                        ip_V2 = ip_CikJ
                     End If
*
                     Fact=One
                     If (iSym.ne.kSym) Fact=Half
                     Call DGEMM_('T','N',jBas,lBas,nik,
     &                           Fact,Work(ip_CikJ),nik,
     &                           Work(ip_V2),nik,
     &                           1.0D0,Work(ip_A),jBas)
*
 820                 Continue
*
                  End Do
*
                  mijkl = 0
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl - nBas(j4)
                     Do jAOj = 0, jBas-1
                        jSOj = jSO + jAOj - nBas(j2)
                        mijkl = mijkl + 1
*
*-----------------------Coulomb contribution
                        If (j2.eq.0) Then
*---------------------------j4.eq.0 also
                           temp=V_K(jSOj,1)*V_K(lSOl,1)*Coulfac
*                          temp=Zero
                        Else
                           temp = Zero
                        End If
*
*-----------------------Exchange contribution
                        temp = temp
     &                       - ExFac*Work(ip_A+mijkl-1)
*
                        PMax=Max(PMax,Abs(Temp))
                        PSO(mijkl,MemSO2) =  Fac * temp
*
                     End Do
                  End Do
*
 810              Continue
               End Do
            End Do
*
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (nPSO.ne.MemSO2) Then
        Write (6,*) ' PGet2: nPSO.ne.MemSO2'
        Write (6,*) nPSO, MemSO2
        Call Abend()
      End If
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' In PGet2_RI2:PSO ',' ',PSO,nijkl,nPSO)
      End If
      Call GetMem(' Exit PGet2_RI2','CHECK','REAL',iDum,iDum)
#endif
*
      Call CWTime(Cpu2,Wall2)
      Cpu = Cpu2 - Cpu1
      Wall = Wall2 - Wall1
      tavec(1) = tavec(1) + Cpu
      tavec(2) = tavec(2) + Wall
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iBas)
         Call Unused_integer(kBas)
         Call Unused_logical(Shijij)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MATCG(     CIN,    COUT,   NROWI,   NROWO,  IROWI1,
     &                    NGCOL,    IGAT,  GATSGN)
*
* Gather columns of CIN with phase
*
* COUT(IR,IC) = GATSGN(IC)*CIN(IR+IROWI1-1,IGAT(IC)) if IGAT(IC) .ne.0
* COUT(IR,IC) = 0                           if IGAT(IC) .ne.0
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER IGAT(*)
      DIMENSION GATSGN(*)
      DIMENSION CIN(NROWI,*),COUT(NROWO,*)
*
C?    write(6,*) ' MATCG NROWI,NROWO,IROWI1,NGCOL '
C?    write(6,*)         NROWI,NROWO,IROWI1,NGCOL
      DO 100 IG = 1, NGCOL
C?      write(6,*) ' igat,sign ',IGAT(IG),GATSGN(IG)
        IF(IGAT(IG).EQ.0) THEN
          DO 20 IR = 1, NROWO
            COUT(IR,IG)=0.0D0
   20     CONTINUE
        ELSE
         IGFRM = IGAT(IG)
         SIGN = GATSGN(IG)
         DO 30 IR = 1, NROWO
           COUT(IR,IG) = SIGN*CIN(IROWI1-1+IR,IGFRM)
   30    CONTINUE
        END IF
  100 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' Column gathered matrix '
        CALL WRTMAT(COUT,NROWO,NGCOL,NROWO,NGCOL)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Get_Grad_Full
!
!> @brief
!>   Get gradient from RUNFILE
!> @author I. Fdez. Galv&aacute;n
!>
!> @details
!> Place Cartesian gradient (in a.u.) into array \p Grad_Full(3,*).
!> Includes MM atoms otherwise invisible to gateway/slapaf.
!>
!> @param[out] Grad_Full   Array of gradient
!> @param[in]  nAtoms_Full Number of atoms
!***********************************************************************

subroutine Get_Grad_Full(Grad_Full,nAtoms_Full)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms_Full
real(kind=wp), intent(out) :: Grad_Full(3,nAtoms_Full)
integer(kind=iwp) :: nAtoms_All, nAtoms_Fullx, nGrad, nGradMM
logical(kind=iwp) :: Found

call Get_nAtoms_Full(nAtoms_Fullx)
if (nAtoms_Full /= nAtoms_Fullx) then
  write(u6,*) 'Get_Grad_Full: nAtoms_Full /= nAtoms_Fullx'
  write(u6,*) 'nAtoms_Full=',nAtoms_Full
  write(u6,*) 'nAtoms_Fullx=',nAtoms_Fullx
  call Abend()
end if
call Get_nAtoms_All(nAtoms_All)
if (nAtoms_Full < nAtoms_All) then
  write(u6,*) 'Get_Coord_Full: nAtoms_Full < nAtoms_All'
  write(u6,*) 'nAtoms_Full=',nAtoms_Full
  write(u6,*) 'nAtoms_Fullx=',nAtoms_All
  call Abend()
end if
call Qpg_dArray('GRAD',Found,nGrad)
if ((.not. Found) .or. (nGrad == 0)) then
  write(u6,*) 'Get_Grad_Full: Did not find GRAD'
  call Abend()
end if
call Get_dArray('GRAD',Grad_Full,nGrad)
call Qpg_dArray('MMO Grad',Found,nGradMM)
if (Found) call Get_dArray('MMO Grad',Grad_Full(:,nAtoms_All+1:),nGradMM)

return

end subroutine Get_Grad_Full

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************

subroutine Averd(ireturn)
!-- Compute average density and corresponding natural orbitals. Two
!   possibilities exists, either construct average from input orbitals,
!   or from density matrices.
!
!   Author: Anders Ohrn.

use Averd_global, only: Wset
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: i, iB, iB1, iB2, iC, icomp, iD, iDs, iDt, iDummy(7,8), iErr, ind, indB, indS, indt, iO, iopt, iPrint, iset, &
                     irc, iSym, isyml, itBas, j, k, kaunt, kaunter, lsmat, Luinp, LuOut, nB, nBS, nBT, nOrb, nSet, nSym, ntot, ntot2
real(kind=wp) :: Dum, Dummy(1), Sqroot, Thr, Thro, ThrOcc, Wsum
logical(kind=iwp) :: PrOcc, PrEne, DensityBased
character(len=72) :: Title
character(len=7) :: Fname
character(len=10) :: OLabel
character(len=40) :: Titorb
character(len=128) :: OrbFile
character(len=4000) :: BsLbl
character(len=3) :: PLab
integer(kind=iwp), external :: IsFreeUnit
integer(kind=iwp), allocatable :: nBas(:)
real(kind=wp), allocatable :: AUX(:), CMO(:), Dao(:), Dtemp(:), DTmp(:), Occ(:), OccNat(:), Occs(:), Orbs(:), OrtoD(:), OrtoDt(:), &
                              S(:), Si(:), Sp(:), Ss(:), St(:), Trani(:), Trans(:), Vecs(:), Zeros(:)
#include "Molcas.fh"

!-- Banner.

ireturn = 99

!-- Define defaults and initialize.

call Init_ave(Title,iPrint,PrOcc,PrEne,DensityBased,ThrOcc,Dummy(1),iDummy(1,1))

!-- Read input.

nSet = 0
call Get_Averd_input(Title,iPrint,nSet,DensityBased,ThrOcc)
if (.not. allocated(Wset)) call mma_allocate(Wset,nSet,label='Wset')

!-- Read some information from RUNFILE.

call Get_iScalar('nSym',nSym)
call mma_allocate(nBas,nSym,label='nBas')
call Get_iArray('nBas',nBas,nSym)
itBas = 0
do iSym=1,nSym
  itBas = itBas+nBas(isym)
end do
call Get_cArray('Unique Basis Names',BsLbl,LenIn8*itBas)

!-- Some dimensions.

lsmat = 0
ntot = 0
ntot2 = 0
do i=1,nSym
  lsmat = lsmat+(nBas(i)*(nBas(i)+1))/2
  ntot = ntot+nBas(i)
  ntot2 = ntot2+nBas(i)**2
end do

!-- Read AO-basis overlap matrix.

call mma_allocate(S,lsmat+4,label='Overlap')
OLabel = 'Mltpl  0'
irc = 0
iopt = 6
icomp = 1
isyml = 1
call RdOne(irc,iopt,OLabel,icomp,S,isyml)
if (iprint >= 99) then
  ind = 1
  do iSym=1,nSym
    call TriPrt('Overlap Matrix',' ',S(ind),nBas(iSym))
    ind = ind+nBas(iSym)*(nBas(iSym)+1)/2
  end do
end if

!-- Normalize weights.

Wsum = sum(Wset(:))
Wset(:) = Wset(:)/Wsum

!-- Print some Bla Bla...

if (iprint >= 2) then
  call Print_Input(Title,nSym,nBas,wSet,nSet)
end if

!-- Do the dirty work. Different paths for orbital- and density-based
!   averageing.

call mma_allocate(Dao,ntot2,'Density')
Dao(:) = Zero
if (.not. DensityBased) then
  Luinp = 10
  call mma_allocate(CMO,ntot2,label='Orbitals')
  call mma_allocate(Occ,ntot,label='Occ')
  do iset=1,nSet
    Fname = 'NAT001'
    write(Fname(4:6),'(i3.3)') iset
    ! Read orbital coefficients and occupation numbers.
    call RdVec(Fname,Luinp,'CO',nSym,nBas,nBas,CMO,Occ,Dummy,iDummy,Titorb,0,iErr)
    iC = 1
    iO = 1
    iD = 1
    ! Up-date average density matrix.
    do isym=1,nSym
      kaunter = 0
      do i=1,nBas(iSym)
        do j=1,nBas(iSym)
          do k=1,nBas(iSym)
            Dao(iD+kaunter) = Dao(iD+kaunter)+Wset(iSet)*Occ(iO+k-1)*CMO(iC+i+(k-1)*nBas(iSym)-1)*CMO(iC+j+(k-1)*nBas(iSym)-1)
          end do
          kaunter = kaunter+1
        end do
      end do
      iC = iC+nBas(isym)**2
      iD = iD+nBas(isym)**2
      iO = iO+nBas(isym)
    end do
    ! Print print print.
    if (iPrint >= 5) then
      ThrO = 1.0e-5_wp
      call Primo(Titorb,PrOcc,PrEne,ThrO,Dummy(1),nSym,nBas,nBas,BsLbl,Dummy,Occ,CMO,-1)
    end if
  end do
  call mma_deallocate(CMO)
  call mma_deallocate(Occ)
else
  call mma_allocate(Dtemp,lsmat,label='DensityT')
  Dtemp(:) = Zero
  do iset=1,nSet
    Fname = 'RUN001'
    write(Fname(4:6),'(i3.3)') iset
    call NameRun(Fname)
    ! Collect density from runfile.
    call mma_allocate(DTmp,lsmat,Label='DTmp')
    call Get_D1ao(Dtmp,lsmat)
    call DaxPy_(lsmat,Wset(iset),Dtmp,1,Dtemp,1)
    call mma_deallocate(DTmp)
  end do
  ! Square the density matrix.
  iDt = 1
  iDs = 1
  do iSym=1,nSym
    nB = nBas(iSym)
    call Dsq(Dtemp(iDt),Dao(iDs),1,nB,nB)
    iDt = iDt+nB*(nB+1)/2
    iDs = iDs+nB**2
  end do
  call mma_deallocate(Dtemp)
end if

call mma_deallocate(Wset)

!-- With the average density in store, lets orthogonalize (canonical),
!   then diagonalize to get natural orbitals.

indT = 1
indS = 1
indB = 1
call mma_allocate(Orbs,ntot2,label='NatOrbAcc')
call mma_allocate(Occs,ntot,label='NatOccAcc')
do iSym=1,nSym
  nBT = nBas(iSym)*(nBas(iSym)+1)/2
  nBS = nBas(iSym)**2
  call mma_allocate(Vecs,nBS,label='EigV')
  call mma_allocate(St,nBT,label='St')
  call mma_allocate(Si,nBT,label='Si')
  call mma_allocate(Ss,nBS,label='Ss')
  call mma_allocate(Sp,nBS,label='Sp')
  call mma_allocate(AUX,nBS,label='AUX')
  call mma_allocate(Trans,nBS,label='TransS')
  call mma_allocate(Trani,nBS,label='TransSi')
  call mma_allocate(OrtoD,nBS,label='OrthoDensS')
  call mma_allocate(OrtoDt,nBT,label='OrthoDensT')
  call mma_allocate(OccNat,nBas(iSym),label='Occs')
  St(:) = Zero
  Si(:) = Zero
  kaunter = 1
  do iB1=1,nBas(iSym)
    do iB2=1,nBas(iSym)
      Vecs(kaunter) = Zero
      if (iB1 == iB2) Vecs(kaunter) = One
      kaunter = kaunter+1
    end do
  end do
  call Jacob(S(indT),Vecs,nBas(iSym),nBas(iSym))
  do i=1,nBas(iSym)
    Sqroot = sqrt(S(indT+i*(i+1)/2-1))
    St(i*(i+1)/2) = Sqroot
    Si(i*(i+1)/2) = One/Sqroot
  end do
  call Square(St,Ss,1,nBas(iSym),nBas(iSym))
  call Square(Si,Sp,1,nBas(iSym),nBas(iSym))
  call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One,Vecs,nBas(iSym),Ss,nBas(iSym),Zero,AUX,nBas(iSym))
  call Dgemm_('N','T',nBas(iSym),nBas(iSym),nBas(iSym),One,AUX,nBas(iSym),Vecs,nBas(iSym),Zero,Trans,nBas(iSym))
  call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One,Vecs,nBas(iSym),Sp,nBas(iSym),Zero,AUX,nBas(iSym))
  call Dgemm_('N','T',nBas(iSym),nBas(iSym),nBas(iSym),One,AUX,nBas(iSym),Vecs,nBas(iSym),Zero,Trani,nBas(iSym))
  call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One,Trans,nBas(iSym),Dao(indS),nBas(iSym),Zero,AUX,nBas(iSym))
  call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One,AUX,nBas(iSym),Trans,nBas(iSym),Zero,OrtoD,nBas(iSym))
  kaunter = 1
  do iB1=1,nBas(iSym)
    do iB2=1,nBas(iSym)
      Vecs(kaunter) = Zero
      if (iB1 == iB2) Vecs(kaunter) = One
      kaunter = kaunter+1
    end do
  end do
  kaunter = 1
  do i=1,nBas(iSym)
    do j=1,i
      OrtoDt(kaunter) = OrtoD(i+(j-1)*nBas(iSym))
      kaunter = kaunter+1
    end do
  end do
  call Jacob(OrtoDt,Vecs,nBas(iSym),nBas(iSym))
  call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One,Trani,nBas(iSym),Vecs,nBas(iSym),Zero,AUX,nBas(iSym))
  kaunt = 1
  kaunter = 1
  do i=1,nBas(iSym)
    do j=1,i
      if (i == j) then
        OccNat(kaunt) = OrtoDt(kaunter)
        kaunt = kaunt+1
      end if
      kaunter = kaunter+1
    end do
  end do
  call Jacord3(OccNat,AUX,nBas(iSym),nBas(iSym))
  call Add_Info('AVERD_OCC',OccNat,5,5)
  if (iPrint >= 5) then
    write(Titorb,'(a)') 'All average orbitals in this irrep.'
    Thr = -One
    call Primo(Titorb,.true.,.false.,Thr,Dum,1,nBas(iSym),nBas(iSym),BsLbl,Dummy,OccNat,AUX,-1)
  end if
  call dcopy_(nBS,AUX,1,Orbs(indS),1)
  call dcopy_(nBas(iSym),OccNat,1,Occs(indB),1)
  call mma_deallocate(Vecs)
  call mma_deallocate(St)
  call mma_deallocate(Si)
  call mma_deallocate(Ss)
  call mma_deallocate(Sp)
  call mma_deallocate(AUX)
  call mma_deallocate(Trans)
  call mma_deallocate(Trani)
  call mma_deallocate(OrtoD)
  call mma_deallocate(OrtoDt)
  call mma_deallocate(OccNat)
  indT = indT+nBT
  indS = indS+nBS
  indB = indB+nBas(iSym)
end do
write(u6,*)
write(u6,*)
write(u6,*)
write(u6,*) '---Average natural orbital generation completed!---'
write(u6,*)

!-- Write average orbitals to a file with the same format as
!   SCF-orbitals. To the outfile are orbital energies added just
!   to make the NEMO happy, the numbers are just bosh!

write(u6,*)
write(u6,*)
write(u6,*) 'Average orbitals put on AVEORB'
write(u6,*)
write(u6,*) 'NB: Dummy orbital energies added to AVEORB for compatability reasons.'
write(u6,*) '    They have no physical meaning.'
call mma_allocate(Zeros,ntot,label='Zeros')
Zeros(:) = Zero
LuOut = 65
LuOut = IsFreeUnit(LuOut)
Title = 'Average Orbitals'
OrbFile = 'AVEORB'
Plab = 'COE'
call WrVec(OrbFile,LuOut,Plab,nSym,nBas,nBas,Orbs,Occs,Zeros,iDummy,Title)

!-- Say something about orbital occupation.

write(u6,*)
write(u6,*)
write(u6,'(a)') ' |  Average orbital occupation.'
write(u6,'(a)') ' |-----------------------------'
write(u6,'(a,e18.8)') ' |    Threshold: ',ThrOcc
write(u6,*)
nOrb = 0
iO = 0
do iSym=1,nSym
  do iB=1,nBas(iSym)
    if (Occs(iO+iB) < ThrOcc) cycle
    nOrb = nOrb+1
  end do
  write(u6,'(a,i2,a,i4)') '      Symmetry:',iSym,'   Number of orbitals below threshold:',nOrb
  iO = iO+nBas(iSym)
end do
write(u6,*)
call mma_deallocate(nBas)
call mma_deallocate(Zeros)
call mma_deallocate(Orbs)
call mma_deallocate(Occs)
call mma_deallocate(Dao)
call mma_deallocate(S)

!-- Good Bye.

ireturn = 0

return

end subroutine Averd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Bjorn O. Roos                                          *
!               1991, Roland Lindh                                     *
!***********************************************************************

subroutine Decode(LBL,string,N,Hit)
!***********************************************************************
! Object: to find the character string 'string' between                *
!         dots N-1 and N in the label LBL of length lLBL               *
!         blanks in string are removed                                 *
! Called from: Rdbsl                                                   *
! Subroutine calls: none                                               *
!                                                                      *
! Author: Bjoern Roos, University of Lund, Sweden                      *
!***********************************************************************

use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: LBL
character(len=*), intent(out) :: string
integer(kind=iwp), intent(in) :: N
logical(kind=iwp), intent(inout) :: Hit
integer(kind=iwp) :: i, i1, idot, lLBL, lstring
character(len=80) :: xstring
character, parameter :: dot = '.'

!write(u6,'(1x,a)') LBL
i1 = 1
idot = 0
lstring = 0
lLBL = len(LBL)
do i=1,lLBL
  if (LBL(i:i) /= dot) cycle
  idot = idot+1
  if (idot == N-1) i1 = i+1
  if (idot == N) then
    xstring = ' '
    !write(u6,'(1x,A,/,1X,A)') ' xstring=',xstring
    if (i > i1) xstring = LBL(i1:i-1)
    !write(u6,'(1x,A,/,1X,A)') ' xstring=',xstring
    lstring = i-i1
    exit
  end if
end do
if (idot == N) then
  ! Pack the string

  Hit = .true.
  i1 = 0
  string = ' '
  do i=1,lstring
    if (xstring(i:i) == ' ') cycle
    i1 = i1+1
    string(i1:i1) = xstring(i:i)
  end do
else if (Hit) then
  call WarningMessage(2,'Decode: error in basis set label')
  write(u6,'(A,A)') 'LBL=',LBL
  call Abend()
end if

return

end subroutine Decode

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  RdInput_Quater
*
*> @brief
*>   Reads the input of the quater program
*> @author Y. Carissan
*>
*> @param[out] U1 vector needed for the rotation
*> @param[out] U2 vector needed for the rotation
*> @param[out] V1 vector needed for the rotation
*> @param[out] V2 vector needed for the rotation
*>
*> @details
*> Reads the input of the quater program.
************************************************************************
      Subroutine RdInput_Quater(U1,U2,V1,V2)
      Implicit none
#include "WrkSpc.fh"
#include "debug.fh"
#include "geoms.fh"
#include "options.fh"
      Integer iLU
      integer ig,iat
      Real*8 U1(3),U2(3),V1(3),V2(3)
      Character*180 Get_Ln
      character*6 cName
      External Get_Ln
      Character Line*180
      Character key*20
      Logical AxisSet,NewAxisSet,Geo1Set,Geo2Set
      Logical XYZ1Set,XYZ2Set

      AxisSet=.false.
      NewAxisSet=.false.
      Geo1Set=.false.
      Geo2Set=.false.
      XYZ1Set=.false.
      XYZ2Set=.false.
      rotate=.true.
      translate=.true.
      ngeoms=1
      Call SpoolInp(iLU)
c
c skip &quater &end
c
      Line=Get_ln(iLU)
666   continue
c      Do
        Line=Get_ln(iLU)
        Call Put_ln(Line)
        Call Get_S(1,key,1)
        if (debug) Write(6,*) 'KEY:',key
        if (key(1:4).eq.'AXIS') then
          Line=Get_ln(iLU)
          Call Put_ln(Line)
          Call Get_F(1,U1,3)
          Line=Get_ln(iLU)
          Call Put_ln(Line)
          Call Get_F(1,U2,3)
          AxisSet=.true.
        else if (key(1:4).eq.'NEWA') then
          Line=Get_ln(iLU)
          Call Put_ln(Line)
          Call Get_F(1,V1,3)
          Line=Get_ln(iLU)
          Call Put_ln(Line)
          Call Get_F(1,V2,3)
          NewAxisSet=.true.
        else if (key(1:4).eq.'DEBU') then
          debug=.true.
        else if (key(1:4).eq.'GEO1') then
          call readgeo(iLU,1)
          Geo1Set=.true.
        else if (key(1:4).eq.'GEO2') then
          call readgeo(iLU,2)
          Geo2Set=.true.
        else if (key(1:4).eq.'XYZ1') then
          Line=Get_ln(iLU)
          Call Put_ln(Line)
          Call Get_I(1,XYZ1,3)
          XYZ1Set=.true.
        else if (key(1:4).eq.'XYZ2') then
          Line=Get_ln(iLU)
          Call Put_ln(Line)
          Call Get_I(1,XYZ2,3)
          XYZ2Set=.true.
!        else if (key(1:4).eq.'NGEO') then
!          Line=Get_ln(iLU)
!          Call Put_ln(Line)
!          Call Get_I(1,ngeoms,1)
        else if (key(1:4).eq.'NOTR') then
          translate=.false.
        else if (key(1:4).eq.'NORO') then
          rotate=.false.
        else if (key(1:4).eq.'END ') then
          GoTo 999
        else
          Call SysAbendMsg("RdInput_Quater",
     &          "Keyword not relevant : ",key)
        endif
      goto 666

999   continue
      if (.not.AxisSet) then
        if (.not.XYZ1Set) then
          Call SysAbendMsg("RdInput_Quater",
     &      "Reference Axis not set",
     &      "AXIS or XYZ1 Keyword mandatory")
        end if
      else
        if (XYZ1Set) then
          Call SysAbendMsg("RdInput_Quater",
     &      "Reference Axis not set properly",
     &      "AXIS and XYZ1 Keywords are exclusive")
        end if
      end if

      if (.not.NewAxisSet) then
        if (.not.XYZ2Set) then
          Call SysAbendMsg("RdInput_Quater",
     &      "New Axis not set :","NEWAXIS or XYZ2 Keyword mandatory")
        end if
      else
        if (XYZ2Set) then
          Call SysAbendMsg("RdInput_Quater",
     &      "New Axis not set properly",
     &      "NEWAXIS and XYZ2 Keywords are exclusive")
        end if
      end if

      if (XYZ1Set.and..not.GEO1Set) then
          Call SysAbendMsg("RdInput_Quater",
     &      "XYZ1 keyword requires GEO1 definition",
     &      "")
      end if

      if (XYZ2Set.and..not.GEO2Set) then
          Call SysAbendMsg("RdInput_Quater",
     &      "XYZ2 keyword requires GEO2 definition",
     &      "")
      end if

      if (translate.and..not.(XYZ1Set.and.XYZ2Set)) then
          Call SysAbendMsg("RdInput_Quater",
     &      "Translation cannot be done if both",
     &      "XYZ1 and XYZ2 are not set")
      end if

      if (XYZ1Set) Call SetVect(nat(1),Work(ipgeo(1)),XYZ1,V1,V2)
      if (XYZ2Set) Call SetVect(nat(2),Work(ipgeo(2)),XYZ2,U1,U2)

      Call Getmem("TEST","List","Real",ig,ig)

      do ig=3,ngeoms+2
        if (ig.lt.10) then
          Write(cName,'(a5,i1)') "GEOM0",ig
          title(ig)=cName
        else if (ig.lt.100) then
          Write(cName,'(a4,i2)') "GEOM",ig
          title(ig)=cName
        end if
        nat(ig)=nat(2)
        do iat=1,nat(ig)
          geolbl(iat,ig)=geolbl(iat,2)
        end do
        Call GetMem(cName,"Allo","Real",ipgeo(ig),3*nat(ig))
      end do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_T_worker

use fmm_global_paras, only: INTK, REALK, LUPRI, ZERO_VECT_TOL, Zero, One, Two, Half
use fmm_utils, only: fmm_quit

implicit none
private
! Public procedures
public :: fmm_get_SPLTSQ_T_matrix, &
          fmm_get_FLTSQ_T_matrix, &
          fmm_get_boundary_T_matrix, &
          fmm_contract_Tq, &
          fmm_postfac_Vff, &
          fmm_scale_vec

contains

!------------------------------------------------------------------------------
! Get sparse (l+j <= LMAX), lower-triangular, square-based T-matrix
!FIXME: would be nice to allow possibility of building rectangular-based too

subroutine fmm_get_SPLTSQ_T_matrix(LMAX,r_ab,T_matrix)

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: r_ab(3)
  real(REALK), intent(out)  :: T_matrix(:,:)

  real(REALK) :: I_sh((1+LMAX)**2)

  call fmm_generate_I(LMAX,r_ab,I_sh)
  call fmm_generate_T(LMAX,fmm_SPLTSQ_JMAX,I_sh,T_matrix)

end subroutine fmm_get_SPLTSQ_T_matrix

function fmm_SPLTSQ_JMAX(L,LMAX)
  implicit none
  integer(INTK), intent(in) :: L, LMAX
  integer(INTK) :: fmm_SPLTSQ_JMAX
  fmm_SPLTSQ_JMAX = LMAX-L
end function fmm_SPLTSQ_JMAX

!------------------------------------------------------------------------------
! Get full (all elements built), lower-triangular, square T-matrix

subroutine fmm_get_FLTSQ_T_matrix(LMAX,r_ab,T_matrix)

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: r_ab(3)
  real(REALK), intent(out)  :: T_matrix(:,:)

  real(REALK) :: I_sh((1+2*LMAX)**2)

  call fmm_generate_I(2*LMAX,r_ab,I_sh)
  call fmm_generate_T(LMAX,fmm_FLTSQ_JMAX,I_sh,T_matrix)

end subroutine fmm_get_FLTSQ_T_matrix

function fmm_FLTSQ_JMAX(L,LMAX)
# include "macros.fh"
  implicit none
  integer(INTK), intent(in) :: L, LMAX
  integer(INTK) :: fmm_FLTSQ_JMAX
  unused_var(L)
  fmm_FLTSQ_JMAX = LMAX
end function fmm_FLTSQ_JMAX

!------------------------------------------------------------------------------
! Get single-column T-matrix for building boundary potential only

subroutine fmm_get_boundary_T_matrix(LMAX,r_ab,T_matrix)

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: r_ab(3)
  real(REALK), intent(out)  :: T_matrix(:,:)

  real(REALK) :: I_sh((1+2*LMAX)**2)

  call fmm_generate_I(2*LMAX,r_ab,I_sh)
  call fmm_generate_boundary_T(LMAX,I_sh,T_matrix)

end subroutine fmm_get_boundary_T_matrix

!------------------------------------------------------------------------------

subroutine fmm_generate_I(LMAX,vector,I_sh)

  ! Subroutine to generate Scaled Irregular solid harmonics
  ! See page 416, "Molecular Electronic Structure Theory".
  !--------------------------------------------------------
  ! I_sh(M,L)  == COS component of I_sh(M,L)
  ! I_sh(-M,L) == SIN component of I_sh(-M,L)
  ! where L and M are positive
  ! Note that I_sh(0,L) == COS component of I_sh(0,L) !
  ! In fact we combine (l,m) into a single index and
  ! we assume the order 0, -1,1,+1, -2,-1,0,+1,+2 ...
  !--------------------------------------------------------

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: vector(3)
  real(REALK), intent(out)  :: I_sh((LMAX+1)**2)

  real(REALK) :: tmp1, tmp2, tmp3
  real(REALK) :: x, y, z, r_2, r_minus2
  integer(INTK) :: L, m, i, j, k, p, q, u, sign_L

  x = vector(1)
  y = vector(2)
  z = vector(3)
  r_2 = x**2+y**2+z**2
  r_minus2 = one/(r_2)

  !FIXME;
  if (r_2 < ZERO_VECT_TOL) then
    write(LUPRI,'(3E25.15)') vector
    call fmm_quit('Why do we try to do a zero T_vector?')
  end if

  if (LMAX == 0) then
    I_sh(1) = sqrt(r_minus2)
    return
  end if

  ! Start with initialization of lowest order terms
  I_sh(1) = sqrt(r_minus2)
  I_sh(2) = -(y)*(r_minus2)*I_sh(1)
  I_sh(3) = (z)*(r_minus2)*I_sh(1)
  I_sh(4) = -(x)*(r_minus2)*I_sh(1)

  ! Now iterate higher order terms
  sign_L = -1
  do L=2,LMAX
    sign_L = -sign_L
    i = (L+1)*(L+1)
    j = L*L+1
    p = j-2*L+1
    q = j-1
    tmp1 = (2*L-1)*r_minus2
    tmp2 = tmp1*y*sign_L
    tmp3 = tmp1*x
    !
    I_sh(i) = tmp2*I_sh(p)-tmp3*I_sh(q)
    I_sh(j) = tmp2*I_sh(q)+tmp3*I_sh(p)
    !
    p = p+L-1
    q = L*(L-3)+3
    u = q+L-2
    k = i-L
    tmp2 = tmp1*z
    do m=0,(L-2)
      tmp3 = (u-m*m)*(r_minus2)
      !
      I_sh(k+m) = tmp2*I_sh(p+m)-tmp3*I_sh(q+m)
      I_sh(k-m) = tmp2*I_sh(p-m)-tmp3*I_sh(q-m)
      ! I_sh(L,0)=0
      !
    end do
    ! Now do (L, L-1) terms to avoid calling elements that do not exist
    m = L-1
    I_sh(k+m) = tmp2*I_sh(p+m)
    I_sh(k-m) = tmp2*I_sh(p-m)
  end do

end subroutine fmm_generate_I

!------------------------------------------------------------------------------

subroutine fmm_generate_T(LMAX,JMAX,I_sh,T_matrix)

  ! Subroutine to generate Real Interaction Matrix for
  ! given point from Irregular Solid Harmonics (I_sh)
  ! cf Helgaker et. al. pp 415
  !-----------------------------------------------------------------------
  !  T_cos_cos(lm,jk) = 2*{I_cos(l+j,m+k) + (-1)^k*I_cos(l+j,m-k)}  etc.
  !
  ! Note we only write the non-zero elements here, and the precise form
  ! depends on the function JMAX passed in
  !-----------------------------------------------------------------------
  !FIXME: can optimise for j=l by noting that if we build just lower
  ! triangular, we need only half the elements there

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: I_sh(:)
  real(REALK), intent(out)  :: T_matrix(:,:)
  integer(INTK), external   :: JMAX

  integer(INTK) :: sign_k, sign_m
  integer(INTK) :: L, J, k, m, q, pp, qq, u

  if (LMAX == 0) then
    T_matrix(1,1) = two*I_sh(1)     ! NB scaling to make T symmetric
    return
  end if

  L_loop: do L=0,LMAX
    qq = L*(L+1)+1
    J_loop: do J=L,JMAX(L,LMAX)
      pp = J*(J+1)+1
      u = 1+(L+J)*(L+J+1)

      sign_m = -1
      positive_m: do m=0,L
        q = qq+m
        sign_m = -sign_m

        ! cos-cos terms
        !---------------

        sign_k = -1
        do k=0,min(m,J)
          sign_k = -sign_k
          ! (m+k)>0 and (m-k)>0
          T_matrix(pp+k,q) = I_sh(u+(m+k))+sign_k*I_sh(u+(m-k))
        end do

        do k=(m+1),J
          ! (m+k)>0 and (m-k)<0
          T_matrix(pp+k,q) = I_sh(u+(m+k))+sign_m*I_sh(u+(-(m-k)))
        end do

        ! cos-sin terms
        !---------------

        ! only need to consider (m+k)=0 separately as cannot
        ! also have (m-k)=0 unless k=0

        do k=(-J),min((-m-1),-1)
          ! (m+k)<0 and (m-k)>0
          T_matrix(pp+k,q) = I_sh(u+(m+k))+sign_m*I_sh(u+(-(m-k)))
        end do

        do k=max(-J,-m),min(-m,-1)
          ! (m+k)=0 and (m-k)>0
          T_matrix(pp+k,q) = sign_m*I_sh(u+(-(m-k)))
        end do

        sign_k = 1
        do k=-1,max((-m+1),(-J)),-1
          sign_k = -sign_k
          ! (m+k)>0 and (m-k)>0
          T_matrix(pp+k,q) = -sign_m*sign_k*I_sh(u+(-(m+k)))+sign_m*I_sh(u+(-(m-k)))
        end do

      end do positive_m

      sign_m = 1
      negative_m: do m=-1,-L,-1
        q = qq+m
        sign_m = -sign_m

        ! sin-cos terms
        !---------------

        k = min(J,(-m))
        sign_k = 1
        if (btest(k,0)) sign_k = -1
        ! (m+k)=0 and (m-k)<0
        T_matrix(pp+k,q) = sign_k*I_sh(u+(m-k))

        sign_k = -1
        do k=0,min((-m-1),J)
          sign_k = -sign_k
          ! (m+k)<0 and (m-k)<0
          T_matrix(pp+k,q) = I_sh(u+(m+k))+sign_k*I_sh(u+(m-k))
        end do

        sign_k = -1
        if (btest(J,0)) sign_k = 1
        do k=J,(-m+1),-1
          sign_k = -sign_k
          ! (m+k)>0 and (m-k)<0
          T_matrix(pp+k,q) = -sign_m*sign_k*I_sh(u+(-(m+k)))+sign_k*I_sh(u+(m-k))
        end do

        ! sin-sin terms
        !---------------

        sign_k = -1
        if (btest(J,0)) sign_k = 1
        do k=(-J),m
          sign_k = -sign_k
          ! (m+k)<0 and (m-k)>0
          T_matrix(pp+k,q) = -sign_m*sign_k*I_sh(u+(-(m+k)))+sign_k*I_sh(u+(m-k))
        end do

        sign_k = 1
        do k=-1,max((-J),(m+1)),-1
          sign_k = -sign_k
          ! (m+k)<0 and (m-k)<0
          T_matrix(pp+k,q) = -sign_m*sign_k*I_sh(u+(-(m+k)))+sign_m*I_sh(u+(-(m-k)))
        end do

      end do negative_m
    end do J_loop
  end do L_loop

end subroutine fmm_generate_T

!------------------------------------------------------------------------------

subroutine fmm_generate_boundary_T(LMAX,I_sh,T_matrix)

!FIXME comments!
! This is a simplified version of fmm_generate_T_matrix when building
! only the boundary potential, when only one column of the T_matrix
! is required.

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: I_sh(:)
  real(REALK), intent(out)  :: T_matrix(:,:)

  integer(INTK) :: J, k, pp, u

  if (LMAX == 0) then
    T_matrix(1,1) = two*I_sh(1)     ! NB scaling to make T symmetric
    return
  end if

  do J=0,LMAX
    pp = J*(J+1)+1
    u = 1+(J)*(J+1)
    do k=-J,J
      T_matrix(pp+k,1) = two*I_sh(u+k)
    end do
  end do

end subroutine fmm_generate_boundary_T

!------------------------------------------------------------------------------

function fmm_contract_Tq(LMAX,vect,T_matrix)

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: vect(:)
  real(REALK), intent(in)   :: T_matrix(:,:)
  real(REALK) :: fmm_contract_Tq(size(vect))

  integer(INTK) :: L, p, q, s, u, qmin, qmax

  ! do L=0 terms first
  p = (LMAX+1)*(LMAX+1)
  fmm_contract_Tq(1) = half*dot_product(vect(1:p),T_matrix(1:p,1))
  do s=2,p
    fmm_contract_Tq(s) = vect(1)*T_matrix(s,1)
  end do

  contract: do L=1,LMAX

    u = L*(L+1)+1
    p = (LMAX-L+1)*(LMAX-L+1)

    qmin = u-L
    qmax = min(u+L,p)

    qloop: do q=qmin,qmax
      fmm_contract_Tq(q) = fmm_contract_Tq(q)+dot_product(vect(q:p),T_matrix(q:p,q))
      do s=q+1,p
        fmm_contract_Tq(s) = fmm_contract_Tq(s)+T_matrix(s,q)*vect(q)
      end do
    end do qloop

    ! add on extra post-factors "after" contraction
    fmm_contract_Tq(u) = half*fmm_contract_Tq(u)    ! m=0

  end do contract

end function fmm_contract_Tq

!------------------------------------------------------------------------------

subroutine fmm_scale_vec(LMAX,scl_fact,scale_vec,prefactor)

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: scl_fact
  real(REALK), intent(out)  :: scale_vec(:), prefactor

  integer(INTK) :: L, L2, lo, hi, u
  real(REALK) :: prefactor1, prevec

  prefactor1 = one/scl_fact

  prevec = one
  scale_vec(1) = prevec
  do L=1,LMAX
    prevec = prefactor1*prevec
    L2 = L*L
    lo = L2+1
    hi = L2+2*L+1
    do u=lo,hi
      scale_vec(u) = prevec
    end do
  end do

  if (scl_fact < zero) then
    prefactor = -prefactor1
  else
    prefactor = prefactor1
  end if

end subroutine fmm_scale_vec

!------------------------------------------------------------------------------

subroutine fmm_postfac_Vff(LMAX,Vff_tmp)

  implicit none
  integer(INTK), intent(in)  :: LMAX
  real(REALK), intent(inout) :: Vff_tmp(:)

  integer(INTK) :: l, u
  ! add extra postfactors  (for half**(delta(0,m))
  do l=0,LMAX
    u = l*(l+1)+1
    Vff_tmp(u) = half*Vff_tmp(u)
  end do

end subroutine fmm_postfac_Vff

!------------------------------------------------------------------------------

end module fmm_T_worker

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PtOkt0(H0,RR,nSize,Temp,nTemp)
!***********************************************************************
!                                                                      *
!     Objective: Construct the modified Hamiltonian,                   *
!                i.e., add quadrupole perturbation operator            *
!                                                                      *
!***********************************************************************

use FFPT_Global, only: nAtoms, nBas, nSym, ComStk, ComVal, Coor
use Constants, only: Zero, One, Three, Five, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSize, nTemp
real(kind=wp), intent(inout) :: H0(nSize), RR(nSize), Temp(nTemp)
character(len=8) :: Label
character(len=20) :: PriLbl
logical(kind=iwp) :: Exec, Orig
integer(kind=iwp) :: idum(1), iAtm, iComp, iOpt1, iOpt2, iRc, iSyLbl, nInts
real(kind=wp) :: Alpha, Cntr(3), X, XOrig, Y, YOrig, Z, ZOrig
logical(kind=iwp), parameter :: Debug = .false.

!----------------------------------------------------------------------*
!                                                                      *
!     Start procedure                                                  *
!     Check if the command has been specified on input                 *
!                                                                      *
!----------------------------------------------------------------------*

Exec = .false.
Exec = Exec .or. ComStk(2,6,1,1)
Exec = Exec .or. ComStk(2,6,1,2)
Exec = Exec .or. ComStk(2,6,1,3)
Exec = Exec .or. ComStk(2,6,1,4)
Exec = Exec .or. ComStk(2,6,1,5)
Exec = Exec .or. ComStk(2,6,1,6)
Exec = Exec .or. ComStk(2,6,1,7)
Exec = Exec .or. ComStk(2,6,1,8)
Exec = Exec .or. ComStk(2,6,1,9)
Exec = Exec .or. ComStk(2,6,1,10)
if (.not. Exec) then
  return
end if

!----------------------------------------------------------------------*
!     Check if a origin has been specified                             *
!     The unspecified components of the origin are set to 0.0 !        *
!     If no origin has been given pick the center of mass!             *
!----------------------------------------------------------------------*

Orig = .false.
Orig = Orig .or. ComStk(2,6,2,1)
Orig = Orig .or. ComStk(2,6,2,2)
Orig = Orig .or. ComStk(2,6,2,3)
Orig = Orig .or. ComStk(2,6,2,4)

if (Orig) then
  XOrig = Zero
  YOrig = Zero
  ZOrig = Zero
  if (ComStk(2,6,2,1)) XOrig = ComVal(2,6,2,1)
  if (ComStk(2,6,2,2)) YOrig = ComVal(2,6,2,2)
  if (ComStk(2,6,2,3)) ZOrig = ComVal(2,6,2,3)
  if (ComStk(2,6,2,4)) then
    iAtm = int(ComVal(2,6,2,4),kind=iwp)
    if (iAtm < 0 .or. iAtm > nAtoms) then
      write(u6,*) 'PtOkt0: You specified a invalid atom number as the origin of the perturbation operator.'
      call Abend()
    end if
    XOrig = Coor(1,iAtm)
    YOrig = Coor(2,iAtm)
    ZOrig = Coor(3,iAtm)
  end if
else
  call Get_dArray('Center of Mass',Cntr,3)
  XOrig = Cntr(1)
  YOrig = Cntr(2)
  ZOrig = Cntr(3)
end if
if (Debug) write(u6,'(6X,A,3F12.6)') 'Origin of the perturbation operator =',XOrig,YOrig,ZOrig

!----------------------------------------------------------------------*
!     Loop over components                                             *
!----------------------------------------------------------------------*

do iComp=1,10
  if (ComStk(2,6,1,iComp)) then
    if (iComp == 1 .or. iComp == 4 .or. iComp == 6) then
      call PtOkt1('XR',Temp,RR)
    else if (iComp == 2 .or. iComp == 7 .or. iComp == 9) then
      call PtOkt1('YR',Temp,RR)
    else if (iComp == 3 .or. iComp == 8 .or. iComp == 10) then
      call PtOkt1('ZR',Temp,RR)
    end if
    Label = 'MltPl  3'
    PriLbl = 'MltPl  3; Comp =    '
    write(PriLbl(19:20),'(I2)') iComp
    iRc = -1
    iOpt1 = 1
    iOpt2 = 0
    iSyLbl = 0
    call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
    nInts = idum(1)
    if (iRc /= 0) call error()
    call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
    if (iRc /= 0) call error()
    call CmpInt(Temp,nInts,nBas,nSym,iSyLbl)
    X = Temp(nInts+1)
    Y = Temp(nInts+2)
    Z = Temp(nInts+3)
    if (X /= XOrig .or. Y /= YOrig .or. Z /= ZOrig) then
      write(u6,*) 'PtOkt0: Input error, no matching center is found.'
      call Abend()
    end if
    Alpha = Five
    call DSCAL_(nInts+4,Alpha,Temp,1)
    if (iComp == 1 .or. iComp == 7 .or. iComp == 10) then
      Alpha = -Three
      call daxpy_(nInts,Alpha,RR,1,Temp,1)
      Temp(nInts+4) = Temp(nInts+4)+Alpha*RR(nInts+4)
    else if (iComp /= 5) then
      Alpha = -One
      call daxpy_(nInts,Alpha,RR,1,Temp,1)
      Temp(nInts+4) = Temp(nInts+4)+Alpha*RR(nInts+4)
    end if
    Alpha = Half*ComVal(2,6,1,iComp)
    call daxpy_(nInts,Alpha,Temp,1,H0,1)
    H0(nInts+4) = H0(nInts+4)-Alpha*Temp(nInts+4)
    if (Debug) then
      write(u6,'(6X,A,F8.6)') 'weight =',ComVal(2,6,1,iComp)
      PriLbl = 'MltPl  3; Comp =    '
      write(PriLbl(19:20),'(I2)') iComp
      call PrDiOp(PriLbl,nSym,nBas,Temp)
    end if
  end if
end do

!----------------------------------------------------------------------*
!     Normal Exit                                                      *
!----------------------------------------------------------------------*

return

contains

!----------------------------------------------------------------------*
!     Error Exit                                                       *
!----------------------------------------------------------------------*
subroutine error()

  write(u6,*) 'PtOkt0: Error reading ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()

end subroutine error

end subroutine PtOkt0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994,1999, Per Ake Malmqvist                           *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
! 1999: GEMINAL R12 ENABLED                  *
!--------------------------------------------*

subroutine SIGMA_CASPT2(ALPHA,BETA,IVEC,JVEC)
! Compute |JVEC> := BETA* |JVEC> + ALPHA* (H0-E0)* |IVEC>
! where the vectors are represented in transformed basis and
! are  stored at positions IVEC and JVEC on the LUSOLV unit.

use Index_Functions, only: nTri_Elem
use Fockof, only: FAI, FAI_Full, FAT, FAT_Full, FIA, FIA_Full, FIT, FIT_Full, FTA, FTA_Full, FTI, FTI_Full, IOFFIA, IOFFIT, IOFFTA
use EQSOLV, only: IFCoup
use Sigma_data, only: IFTEST, NFDXP, NFMV, NFR1, NFSCA
use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array, GA_Arrays
use caspt2_global, only: FIFA, LISTS
use caspt2_module, only: CPUSGM, FockType, G1SecIn, MaxIt, nActEl, nAsh, nASup, nCases, nInDep, nIsh, nISup, nOrb, nSsh, nSym, &
                         ThrShn, ThrShS, TIOSGM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: ALPHA, BETA
integer(kind=iwp), intent(in) :: IVEC, JVEC
integer(kind=iwp) :: iCASE1, iCase2, IfC, IFIFA, IMLTOP, ISYM, ISYM1, ISYM2, lCX, lg_CX, lg_D2, lg_Sgm2, lg_SgmX, lSgm2_Sta, &
                     lSgmX, lSgmX_Sta, Max_MESG_Size, NA, NAS1, NAS2, nCX, ND1, ND2, NFIA, NFIT, NFTA, NI, NIS1, NIS2, NO, NS, &
                     nSgm1, nSgm2, nSgm2_Blk, nSgmX, nSgmX_blk
real(kind=wp) :: CPU, CPU0, CPU1, Fact, TIO, TIO0, TIO1, XTST
real(kind=wp), allocatable :: D1(:), D2(:), SGM1(:), SGM2(:)
real(kind=wp), external :: RHS_DDot, DDot_

#ifdef _DEBUGPRINT_
write(u6,*) ' Entering SIGMA.'
write(u6,*) ' Compute |JVEC> := Beta*|JVEC> + Alpha*(H0-E0)|IVEC>'
write(u6,'(1x,a,2f15.6)') 'Alpha,Beta:',Alpha,Beta
write(u6,'(1x,a,2i5)') 'IVEC,JVEC:',IVEC,JVEC
#endif

! If the G1 correction to the Fock matrix is used, then the
! inactive/virtual coupling elements (which are non-zero for the
! case of average CASSCF) cannot be used in the CASPT2 equations.
if ((FOCKTYPE == 'G1') .and. (.not. G1SECIN)) then
  IFCOUP(12,5) = 0
  IFCOUP(13,5) = 0
end if

IFTEST = 0
! Flop counts:
NFSCA = 0
NFDXP = 0
NFMV = 0
NFR1 = 0
! First compute diagonal block contributions:
!TEST write(u6,*) ' First, do it for (H0(diag)-E0).'
call PSGMDIA(ALPHA,BETA,IVEC,JVEC)
if (ALPHA == Zero) return
if (MAXIT == 0) return
!TEST write(u6,*) ' From now on, scaling with BETA is already done.'
!TEST write(u6,*) ' Test print after SGMDIA call in SIGMA:'
!TEST write(u6,*) ' Should be zero, in first iteration.'
!TEST call OVLPRT(JVEC,JVEC,OVLAPS)
! From now on, scaling with BETA is already done.

! Transform to standard representation:
call PTRTOC(0,IVEC,IVEC)
call PTRTOC(1,JVEC,JVEC)

! Set up non-diagonal blocks of Fock matrix:
! SVC: add transposed fock matrix blocks
NFIT = 0
NFIA = 0
NFTA = 0
do ISYM=1,NSYM
  NI = NISH(ISYM)
  NA = NASH(ISYM)
  NS = NSSH(ISYM)
  IOFFIT(ISYM) = NFIT
  IOFFIA(ISYM) = NFIA
  IOFFTA(ISYM) = NFTA
  NFIT = NFIT+NA*NI
  NFIA = NFIA+NS*NI
  NFTA = NFTA+NS*NA
end do
NFIT = NFIT+1 !?
NFIA = NFIA+1 !?
NFTA = NFTA+1 !?

call mma_allocate(FIT_Full,NFIT,Label='FIT_Full')
call mma_allocate(FTI_Full,NFIT,Label='FTI_Full')

call mma_allocate(FIA_Full,NFIA,Label='FIA_Full')
call mma_allocate(FAI_Full,NFIA,Label='FAI_Full')

call mma_allocate(FTA_Full,NFTA,Label='FTA_Full')
call mma_allocate(FAT_Full,NFTA,Label='FAT_Full')

IFIFA = 1
do ISYM=1,NSYM
  NI = NISH(ISYM)
  NA = NASH(ISYM)
  NS = NSSH(ISYM)
  NO = NORB(ISYM)

  if (NO > 0) then
    FIT(ISYM)%A(1:NA*NI) => FIT_Full(IOFFIT(ISYM)+1:IOFFIT(ISYM)+NA*NI)
    FTI(ISYM)%A(1:NA*NI) => FTI_Full(IOFFIT(ISYM)+1:IOFFIT(ISYM)+NA*NI)

    FIA(ISYM)%A(1:NS*NI) => FIA_Full(IOFFIA(ISYM)+1:IOFFIA(ISYM)+NS*NI)
    FAI(ISYM)%A(1:NS*NI) => FAI_Full(IOFFIA(ISYM)+1:IOFFIA(ISYM)+NS*NI)

    FTA(ISYM)%A(1:NS*NA) => FTA_Full(IOFFTA(ISYM)+1:IOFFTA(ISYM)+NS*NA)
    FAT(ISYM)%A(1:NS*NA) => FAT_Full(IOFFTA(ISYM)+1:IOFFTA(ISYM)+NS*NA)

    call FBLOCK(FIFA(IFIFA),NO,NI,NA,NS,FIT(ISYM)%A(:),FTI(ISYM)%A(:),FIA(ISYM)%A(:),FAI(ISYM)%A(:),FTA(ISYM)%A(:),FAT(ISYM)%A(:))

    IFIFA = IFIFA+nTri_Elem(NO)
  end if

end do

call TIMING(CPU0,CPU,TIO0,TIO)
! Loop over types and symmetry block of sigma vector:
do ICASE1=1,11
  do ISYM1=1,NSYM
    if (NINDEP(ISYM1,ICASE1) == 0) cycle
    NIS1 = NISUP(ISYM1,ICASE1)
    NAS1 = NASUP(ISYM1,ICASE1)
    NSGM2 = NIS1*NAS1
    if (NSGM2 == 0) cycle

    call mma_allocate(SGM2,NSGM2,Label='SGM2')
    SGM2(:) = Zero

    if (ICASE1 == 1) then
      NSGM1 = NASH(ISYM1)*NISH(ISYM1)
    else if (ICASE1 == 4) then
      NSGM1 = NASH(ISYM1)*NSSH(ISYM1)
    else if ((ICASE1 == 5) .and. (ISYM1 == 1)) then
      NSGM1 = NIS1
    else
      NSGM1 = 0
    end if
    call mma_allocate(SGM1,max(1,NSGM1),LABEL='SGM1')
    SGM1(:) = Zero

    IMLTOP = 0
    do ICASE2=ICASE1+1,NCASES
      IFC = IFCOUP(ICASE2,ICASE1)
      if (IFC == 0) cycle
      do ISYM2=1,NSYM
        if (NINDEP(ISYM2,ICASE2) == 0) cycle
        NIS2 = NISUP(ISYM2,ICASE2)
        NAS2 = NASUP(ISYM2,ICASE2)
        NCX = NIS2*NAS2
        if (NCX == 0) cycle

        call RHS_ALLO(NAS2,NIS2,lg_CX)
        call RHS_READ(NAS2,NIS2,lg_CX,ICASE2,ISYM2,IVEC)
        ! SVC: for case H (12,13) we can now pass the distributed array ID to
        ! the SGM subroutines
        if ((ICASE2 == 12) .or. (ICASE2 == 13)) then
          LCX = lg_CX
          XTST = RHS_DDOT(NAS2,NIS2,lg_CX,lg_CX)
        else
          LCX = Allocate_GA_Array(NCX,'CX')
          call RHS_GET(NAS2,NIS2,lg_CX,GA_Arrays(LCX)%A)
          call RHS_FREE(lg_CX)
          XTST = DDOT_(NCX,GA_Arrays(LCX)%A,1,GA_Arrays(LCX)%A,1)
        end if

        if (XTST > 1.0e12_wp) then
          write(u6,'(1x,a,6i10)') ' SIGMA A. ICASE2,ISYM2:',ICASE2,ISYM2
          call Crash()
        end if

#       ifdef _DEBUGPRINT_
        write(u6,*) ' ISYM1,ICASE1:',ISYM1,ICASE1
        write(u6,*) ' ISYM2,ICASE2:',ISYM2,ICASE2
        write(u6,*) ' SIGMA calling SGM with IMLTOP=',IMLTOP
#       endif
        ! Compute contribution SGM2 <- CX, and SGM1 <- CX  if any
        call SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,SGM1,size(SGM1),SGM2,size(SGM2),LCX,LISTS,size(LISTS))

        if ((ICASE2 == 12) .or. (ICASE2 == 13)) then
          call RHS_FREE(lg_CX)
        else
          call Deallocate_GA_Array(LCX)
        end if

        ! Check for colossal values of SGM2 and SGM1
        XTST = DDOT_(NSGM2,SGM2,1,SGM2,1)
        if (XTST > 1.0e12_wp) then
          write(u6,'(1x,a,6i10)') ' SIGMA B. ICASE1,ISYM1:',ICASE1,ISYM1
          write(u6,'(1x,a,6i10)') '          ICASE2,ISYM2:',ICASE2,ISYM2
          call Crash()
        end if

        if (NSGM1 > 0) then
          XTST = DDOT_(NSGM1,SGM1,1,SGM1,1)
          if (XTST > 1.0e12_wp) then
            write(u6,'(1x,a,6i10)') ' SIGMA B2. ICASE1,ISYM1:',ICASE1,ISYM1
            write(u6,'(1x,a,6i10)') '           ICASE2,ISYM2:',ICASE2,ISYM2
            call Crash()
          end if
        end if

      end do
    end do

    !-SVC: sum the replicate arrays:
    MAX_MESG_SIZE = 2**27
    do LSGM2_STA=1,NSGM2,MAX_MESG_SIZE
      NSGM2_BLK = min(MAX_MESG_SIZE,NSGM2-LSGM2_STA+1)
      call GADGOP(SGM2(LSGM2_STA:),NSGM2_BLK,'+')
    end do

    if (NSGM1 > 0) call GADGOP(SGM1,NSGM1,'+')

    !XTST2 = DDOT_(NSGM2,SGM2,1,SGM2,1)
    !XTST1 = Zero
    !if (NSGM1 > 0) XTST1 = DDOT_(NSGM1,SGM1,1,SGM1,1)
    !write(u6,'(1x,a,a,i2,2f16.6)') 'Contr. SGM2, SGM1, ',cases(icase1),isym1,xtst2,xtst1

    ! If there are 1-electron contributions, add them into the 2-el
    ! part (This requires a non-empty active space.)
    if (NSGM1 > 0) then
      FACT = One/real(max(1,NACTEL),kind=wp)
      if (ICASE1 == 1) then
        call SPEC1A(IMLTOP,FACT,ISYM1,SGM2,size(SGM2),SGM1,size(SGM1))
      else if (ICASE1 == 4) then
        call SPEC1C(IMLTOP,FACT,ISYM1,SGM2,size(SGM2),SGM1,size(SGM1))
      else if ((ICASE1 == 5) .and. (ISYM1 == 1)) then
        call SPEC1D(IMLTOP,FACT,SGM2,size(SGM2),SGM1,size(SGM1))
      end if

      XTST = DDOT_(NSGM2,SGM2,1,SGM2,1)
      if (XTST > 1.0e12_wp) then
        write(u6,'(1x,a,6i10)') ' SIGMA C. ICASE1,ISYM1:',ICASE1,ISYM1
        call Crash()
      end if

    end if
    call mma_deallocate(SGM1)

    !-SVC: no need for the replicate arrays any more, fall back to one array
    call RHS_ALLO(NAS1,NIS1,lg_SGM2)
    call RHS_PUT(NAS1,NIS1,lg_SGM2,SGM2)
    call mma_deallocate(SGM2)

    ! Add to sigma array. Multiply by S to  lower index.
    NSGMX = NSGM2
    call RHS_ALLO(NAS1,NIS1,lg_SGMX)
    call RHS_READ(NAS1,NIS1,lg_SGMX,ICASE1,ISYM1,JVEC)

    XTST = RHS_DDOT(NAS1,NIS1,lg_SGMX,lg_SGMX)
    if (XTST > 1.0e12_wp) then
      write(u6,'(1x,a,6i10)') ' SIGMA D. ICASE1,ISYM1:',ICASE1,ISYM1
      write(u6,'(1x,a,6i10)') '          ICASE2,ISYM2:',ICASE2,ISYM2
      call Crash()
    end if

    !if ((ICASE1 /= 12) .and. (ICASE1 /= 13)) then
    call RHS_STRANS(NAS1,NIS1,ALPHA,lg_SGM2,lg_SGMX,ICASE1,ISYM1)
    !else
    !  call RHS_DAXPY(NAS1,NIS1,ALPHA,lg_SGM2,lg_SGMX)
    !end if
    call RHS_FREE(lg_SGM2)

    XTST = RHS_DDOT(NAS1,NIS1,lg_SGMX,lg_SGMX)
    if (XTST > 1.0e12_wp) then
      write(u6,'(1x,a,6i10)') ' SIGMA E. ICASE1,ISYM1:',ICASE1,ISYM1
      write(u6,'(1x,a,6i10)') '          ICASE2,ISYM2:',ICASE2,ISYM2
      call Crash()
    end if

    ! Write SGMX to disk.
    call RHS_SAVE(NAS1,NIS1,lg_SGMX,ICASE1,ISYM1,JVEC)
    call RHS_FREE(lg_SGMX)
  end do
end do

IMLTOP = 1
! Loop over types and symmetry block of CX vector:
do ICASE1=1,11
  do ISYM1=1,NSYM
    if (NINDEP(ISYM1,ICASE1) == 0) cycle
    NIS1 = NISUP(ISYM1,ICASE1)
    NAS1 = NASUP(ISYM1,ICASE1)
    ND2 = NIS1*NAS1
    if (ND2 == 0) cycle

    call RHS_ALLO(NAS1,NIS1,lg_D2)
    call RHS_SCAL(NAS1,NIS1,lg_D2,Zero)
    ! Contract S*CX to form D2. Also form D1 from D2, if needed.

    NCX = ND2
    call RHS_ALLO(NAS1,NIS1,lg_CX)
    call RHS_READ(NAS1,NIS1,lg_CX,ICASE1,ISYM1,IVEC)

    XTST = RHS_DDOT(NAS1,NIS1,lg_CX,lg_CX)
    if (XTST > 1.0e12_wp) then
      write(u6,'(1x,a,6i10)') ' SIGMA F. ICASE1,ISYM1:',ICASE1,ISYM1
      call Crash()
    end if

    if ((ICASE1 /= 12) .and. (ICASE1 /= 13)) then
      call RHS_STRANS(NAS1,NIS1,ALPHA,lg_CX,lg_D2,ICASE1,ISYM1)
    else
      call RHS_DAXPY(NAS1,NIS1,ALPHA,lg_CX,lg_D2)
    end if
    call RHS_FREE(lg_CX)

    !PAM Sanity check:
    XTST = RHS_DDOT(NAS1,NIS1,lg_D2,lg_D2)
    if (XTST > 1.0e12_wp) then
      write(u6,'(1x,a,6i10)') ' SIGMA G1 ICASE1,ISYM1:',ICASE1,ISYM1
      write(u6,'(1x,a,6i10)') '          ICASE2,ISYM2:',ICASE2,ISYM2
      call Crash()
    end if

    call mma_allocate(D2,ND2,Label='D2')
    call RHS_GET(NAS1,NIS1,lg_D2,D2)
    call RHS_FREE(lg_D2)

    ND1 = 0
    IMLTOP = 1
    FACT = One/real(max(1,NACTEL),kind=wp)
    if (ICASE1 == 1) then
      ND1 = NASH(ISYM1)*NISH(ISYM1)
      if (ND1 > 0) then
        call mma_allocate(D1,ND1,Label='D1')
        D1(:) = Zero
        call SPEC1A(IMLTOP,FACT,ISYM1,D2,size(D2),D1,size(D1))
      end if
    else if (ICASE1 == 4) then
      ND1 = NASH(ISYM1)*NSSH(ISYM1)
      if (ND1 > 0) then
        call mma_allocate(D1,ND1,Label='D1')
        D1(:) = Zero
        call SPEC1C(IMLTOP,FACT,ISYM1,D2,size(D2),D1,size(D1))
      end if
    else if ((ICASE1 == 5) .and. (ISYM1 == 1)) then
      ND1 = NIS1
      if (ND1 > 0) then
        call mma_allocate(D1,ND1,Label='D1')
        D1(:) = Zero
        call SPEC1D(IMLTOP,FACT,D2,size(D2),D1,size(D1))
      end if
    end if
    if (.not. allocated(D1)) call mma_allocate(D1,1,Label='D1')

    if (ND1 > 0) then
      XTST = DDOT_(ND1,D1,1,D1,1)
      if (XTST > 1.0e12_wp) then
        write(u6,'(1x,a,6i10)') ' SIGMA G2 ICASE1,ISYM1:',ICASE1,ISYM1
        write(u6,'(1x,a,6i10)') '          ICASE2,ISYM2:',ICASE2,ISYM2
        call Crash()
      end if
    end if

    do ICASE2=ICASE1+1,NCASES
      if (IFCOUP(ICASE2,ICASE1) == 0) cycle
      do ISYM2=1,NSYM
        if (NINDEP(ISYM2,ICASE2) == 0) cycle
        NIS2 = NISUP(ISYM2,ICASE2)
        NAS2 = NASUP(ISYM2,ICASE2)
        NSGMX = NIS2*NAS2
        if (NSGMX == 0) cycle

        if ((ICASE2 == 12) .or. (ICASE2 == 13)) then
          call RHS_ALLO(NAS2,NIS2,lg_SGMX)
          call RHS_READ(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
          LSGMX = lg_SGMX
        else
          LSGMX = Allocate_GA_Array(NSGMX,'SGMX')
        end if

        ! SVC: this array is just zero....
        !XTST = DDOT_(NSGMX,GA_Array(LSGMX)%A,1,GA_Array(LSGMX)%A,1)
        !if (XTST > 1.0e12_wp) then
        !  write(u6,'(1x,a,6i10)') ' SIGMA H. ICASE1,ISYM1:',ICASE1,ISYM1
        !  write(u6,'(1x,a,6i10)') '          ICASE2,ISYM2:',ICASE2,ISYM2
        !  call Crash()
        !end if

#       ifdef _DEBUGPRINT_
        write(u6,*) ' ISYM1,ICASE1:',ISYM1,ICASE1
        write(u6,*) ' ISYM2,ICASE2:',ISYM2,ICASE2
        write(u6,*) ' SIGMA calling SGM with IMLTOP=',IMLTOP
#       endif
        ! Compute contribution SGMX <- D2, and SGMX <- D1  if any
        call SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,D1,size(D1),D2,size(D2),LSGMX,LISTS,size(LISTS))

        if ((ICASE2 == 12) .or. (ICASE2 == 13)) then
          XTST = RHS_DDOT(NAS2,NIS2,lg_SGMX,lg_SGMX)
        else
          XTST = DDOT_(NSGMX,GA_Arrays(LSGMX)%A,1,GA_Arrays(LSGMX)%A,1)
        end if

        if (XTST > 1.0e12_wp) then
          write(u6,'(1x,a,6i10)') ' SIGMA I. ICASE1,ISYM1:',ICASE1,ISYM1
          write(u6,'(1x,a,6i10)') '          ICASE2,ISYM2:',ICASE2,ISYM2
          call Crash()
        end if

        if ((ICASE2 /= 12) .and. (ICASE2 /= 13)) then
          MAX_MESG_SIZE = 2**27
          do LSGMX_STA=1,NSGMX,MAX_MESG_SIZE
            NSGMX_BLK = min(MAX_MESG_SIZE,NSGMX-LSGMX_STA+1)
            call GADGOP(GA_Arrays(LSGMX)%A(LSGMX_STA),NSGMX_BLK,'+')
          end do
          call RHS_ALLO(NAS2,NIS2,lg_SGMX)
          call RHS_READ(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
          call RHS_ADD(NAS2,NIS2,lg_SGMX,GA_Arrays(LSGMX)%A)
          call Deallocate_GA_Array(LSGMX)
        end if

        !-SVC: no need for the replicate arrays any more, fall back to one array
        call RHS_SAVE(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
        call RHS_FREE(lg_SGMX)
      end do
    end do
    call mma_deallocate(D2)
    call mma_deallocate(D1)
  end do
end do

call TIMING(CPU1,CPU,TIO1,TIO)
CPUSGM = CPUSGM+(CPU1-CPU0)
TIOSGM = TIOSGM+(TIO1-TIO0)

#ifdef _DEBUGPRINT_
write(u6,*) ' End of SIGMA. Flop counts:'
write(u6,'(a,i12)') ' In MLTSCA:',NFSCA
write(u6,'(a,i12)') ' In MLTDXP:',NFDXP
write(u6,'(a,i12)') ' In MLTMV :',NFMV
write(u6,'(a,i12)') ' In MLTR1 :',NFR1
write(u6,*)
#endif

call mma_deallocate(FIT_Full)
call mma_deallocate(FTI_Full)
call mma_deallocate(FIA_Full)
call mma_deallocate(FAI_Full)
call mma_deallocate(FTA_Full)
call mma_deallocate(FAT_Full)
do iSym=1,nSym
  nullify(FIT(iSym)%A,FTI(iSym)%A,FIA(iSym)%A,FAI(iSym)%A,FTA(iSym)%A,FAT(iSym)%A)
end do

! Transform contrav C  to eigenbasis of H0(diag):
call PTRTOSR(1,IVEC,IVEC)
! Transform covar. sigma to eigenbasis of H0(diag):
call PTRTOSR(0,JVEC,JVEC)

contains

subroutine Crash()

  write(u6,*) ' Colossal value detected in SIGMA.'
  write(u6,*) ' This implies that the thresholds used for linear'
  write(u6,*) ' dependence removal must be increased.'
  write(u6,*) ' Present values, THRSHN, THRSHS:',THRSHN,THRSHS
  write(u6,*) ' Use keyword THRESHOLD in input to increase these'
  write(u6,*) ' values and then run again.'
  call ABEND()

end subroutine Crash

end subroutine SIGMA_CASPT2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PT2CLS()

use INPUTDATA, only: CLEANUP_INPUT
use SUPERINDEX, only: SUPFREE
use PT2WFN, only: PT2WFN_CLOSE
use sguga, only: CIS, EXS, SG_Free, SGS
#ifdef _DMRG_
use qcmaquis_interface, only: qcmaquis_interface_deinit
use qcmaquis_interface_cfg, only: dmrg_file
use qcmaquis_info, only: qcmaquis_info_deinit
use caspt2_module, only: DMRG
#endif
#if 0
! NOT TESTED
use OFembed, only: FMaux
#endif
use ChoCASPT2, only: NASplit, NISplit, NumCho_PT2
use caspt2_global, only: CMOPT2, DMIX, DREF, DWGT, FIFA, FIMO, IDCIEX, IDSCT, IDTCEX, PREF, TAT, TORB, Weight
use caspt2_module, only: IfChol, nAsh, nIsh, nSsh, nSym
use stdalloc, only: mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: irc, iSym

if (IfChol) then
  ! Finalize Cholesky information
  call Cho_X_Final(irc)
  if (irc /= 0) then
    write(u6,*) 'CASPT2: Non-zero rc in Cho_X_Final'
    call QUIT(irc)
  end if
  ! Delete files of MO Cholesky vectors.
  do iSym=1,nSym
    call Cho_Caspt2_OpenF(3,1,iSym,nIsplit(iSym)) !close+delete
    call Cho_Caspt2_OpenF(3,2,iSym,nAsplit(iSym)) !close+delete
  end do
  ! Deallocate memory used as index arrays in the setup section
  call setup_cho(nSym,nIsh,nAsh,nSsh,NumCho_pt2,'FREE')
# if 0
  ! NOT TESTED
  call mma_deallocate(FMaux,safe='*')
# endif
  ! deallocate chovec_io arrays
  call trachosz_free()
end if

! Deallocate SGUGA tables:
call SG_Free(SGS,CIS,EXS)

! dealloacte DMRG stuff
#ifdef _DMRG_
if (DMRG) then
  call mma_deallocate(dmrg_file%qcmaquis_checkpoint_file)
  call qcmaquis_info_deinit()
  call qcmaquis_interface_deinit()
end if
#endif

! Deallocate MAGEB, etc, superindex tables:
call SUPFREE()
! Deallocate global array for Fock matrix, etc:
call mma_deallocate(IDCIEX)
call mma_deallocate(IDTCEX)
call mma_deallocate(FIFA)
call mma_deallocate(FIMO)
call mma_deallocate(DREF)
call mma_deallocate(PREF)
call mma_deallocate(DMIX)
call mma_deallocate(DWGT)
! Deallocate global orbital transformation arrays:
call mma_deallocate(TORB)
call mma_deallocate(TAT)
! Deallocate global orbital arrays:
call mma_deallocate(CMOPT2)
! Deallocate global RHS disk offsets (allocated in eqctl1):
call mma_deallocate(IDSCT)

call pt2wfn_close()
! Close all files:
call CLSFLS_CASPT2()

! Weight array is allocated in refwfn_info
call mma_deallocate(Weight)

! free input struct
call CleanUp_Input()

end subroutine PT2CLS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Exp4(A,B,dima2,dima,dimp2,dimp)
! this routine does:
! expand A(ab,pq) -> B(b,a,p,q)
! for matrices, where A(ab,pq)=A(ab,qp)=A(ba,pq)=A(ba,qp)
!  N.B. kvajto odflaknute
!
! parameter description:
! A       - input matrix (I)
! B       - output matrix (O)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima2, dima, dimp2, dimp
real(kind=wp), intent(in) :: A(dima2,dimp2)
real(kind=wp), intent(out) :: B(dima,dima,dimp,dimp)
integer(kind=iwp) :: a1, ab, p, pq

pq = 0
do p=1,dimp

  ab = 0
  do a1=1,dima
    B(a1,1:a1-1,p,1:p-1) = A(ab+1:ab+a1-1,pq+1:pq+p-1)
    B(a1,1:a1-1,1:p,p) = A(ab+1:ab+a1-1,pq+1:pq+p)
    B(1:a1,a1,p,1:p-1) = A(ab+1:ab+a1,pq+1:pq+p-1)
    B(1:a1,a1,1:p,p) = A(ab+1:ab+a1,pq+1:pq+p)
    ab = ab+a1
  end do

  pq = pq+p
end do

return

end subroutine Exp4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE T_TO_NK_VECS(      T,   KORB,      C,  LUCIN, LUCOUT,
     &                          NSSOA,  NSSOB, NBLOCK, IBLOCK,   NAEL,
     &                           NBEL,  IASTR,  IBSTR,  IBLTP,  NSMST,
     &                         ICISTR,   NORB, IKAOCC, IKBOCC)
*
* Multiply Vector in LUCIN with t **NK_op to yield vector on LUCOUT
*
* Both files are initially rewinded
*
*
* Jeppe Olsen, Feb. 1998
*

      IMPLICIT REAL*8(A-H,O-Z)
#include "io_util.fh"
*. General input
      DIMENSION NSSOA(NSMST,*), NSSOB(NSMST,*)
*. Scratch
      DIMENSION C(*)
      DIMENSION IASTR(NAEL,*),IBSTR(NBEL,*)
      DIMENSION IKAOCC(*),IKBOCC(*)
*. Specific input
      DIMENSION IBLOCK(8,NBLOCK)
      DIMENSION IBLTP(*)
      DIMENSION IDUM(1)
*
      IDISK(LUCIN)=0
      IDISK(LUCOUT)=0
*
      T2 = T**2
      DO JBLOCK = 1, NBLOCK
        IATP = IBLOCK(1,JBLOCK)
        IBTP = IBLOCK(2,JBLOCK)
        IASM = IBLOCK(3,JBLOCK)
        IBSM = IBLOCK(4,JBLOCK)
C?      WRITE(6,*) ' IATP IBTP IASM IBSM ', IATP,IBTP,IASM,IBSM
*. Obtain alpha strings of sym IASM and type IATP
        IDUM(1) = 0
        CALL GETSTR_TOTSM_SPGP(      1,   IATP,   IASM,   NAEL, NASTR1,
     &                           IASTR,   NORB,      0,   IDUM,   IDUM)
*. Occupation of orb KORB
        DO JSTR = 1, NASTR1
          KOCC = 0
          DO JAEL = 1, NAEL
            IF(IASTR(JAEL,JSTR).EQ.KORB) KOCC = 1
          END DO
          IKAOCC(JSTR) = KOCC
        END DO
C?      WRITE(6,*) ' IKAOCC array '
C?      CALL IWRTMA(IKAOCC,1,NASTR1,1,NASTR1)


*. Obtain Beta  strings of sym IBSM and type IBTP
        IDUM(1) = 0
        CALL GETSTR_TOTSM_SPGP(      2,   IBTP,   IBSM,   NBEL, NBSTR1,
     &                           IBSTR,   NORB,      0,   IDUM,   IDUM)
C?      WRITE(6,*) ' After GETSTR, NBSTR1=',NBSTR1
*. Occupation of orb KORB
        DO JSTR = 1, NBSTR1
C?        write(6,*) ' JSTR = ', JSTR
          KOCC = 0
          DO JBEL = 1, NBEL
C?          write(6,*) JBEL, IBSTR(JBEL,JSTR)
            IF(IBSTR(JBEL,JSTR).EQ.KORB) KOCC = 1
          END DO
          IKBOCC(JSTR) = KOCC
        END DO
C?      WRITE(6,*) ' IKBOCC array '
C?      CALL IWRTMA(IKBOCC,1,NBSTR1,1,NBSTR1)
*
        IF(IBLTP(IASM).EQ.2) THEN
          IRESTR = 1
        ELSE
          IRESTR = 0
        END IF
C?      WRITE(6,*) ' IBLTP ', IBLTP(IASM)
*
        NIA = NSSOA(IASM,IATP)
        NIB = NSSOB(IBSM,IBTP)
C?      WRITE(6,*) ' NIA NIB ', NIA,NIB
*
        IMZERO = 0
        IF( ICISTR.GE.2 ) THEN
*. Read in a Type-Type-symmetry block
          CALL IDAFILE(LUCIN,2,IDUM,1,IDISK(LUCIN))
          LDET=IDUM(1)
          CALL IDAFILE(LUCIN,2,IDUM,1,IDISK(LUCIN))
          CALL FRMDSC(        C,     LDET,       -1,    LUCIN,   IMZERO,
     &                  IAMPACK)
        END IF
        IF(IMZERO.NE.1) THEN
*
          IDET = 0
          DO  IB = 1,NIB
            IF(IRESTR.EQ.1.AND.IATP.EQ.IBTP) THEN
              MINIA = IB
            ELSE
              MINIA = 1
            END IF
            DO  IA = MINIA,NIA
*
              IDET = IDET + 1
C?            WRITE(6,*) ' IA IB IDET',IA,IB,IDET
              KABOCC = IKAOCC(IA)+IKBOCC(IB)
              IF(KABOCC.EQ.1) THEN
                C(IDET) = T*C(IDET)
              ELSE IF(KABOCC.EQ.2) THEN
                C(IDET) = T2 *C(IDET)
              END IF
            END DO
*           ^ End of loop over alpha strings
          END DO
*         ^ End of loop over beta strings
*
        END IF
*       ^ End of if statement for nonvanishing blocks
*. Save result on LUCOUT
        CALL ITODS([LDET],1,-1,LUCOUT)
        CALL TODSC(C,LDET,-1,LUCOUT)
      END DO
*     ^ End of loop over blocks
*. This is the end, the end of every file my friend, the end
       CALL ITODS([-1],1,-1,LUCOUT)

      RETURN
      END
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CI_SELECT_MRCI(NREF,AREF,PLEN,NSEL,CISEL,NRROOT,IROOT)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NREF, NSEL, NRROOT
real(kind=wp), intent(in) :: AREF(NREF,NREF), CISEL(NREF,*)
real(kind=wp), intent(out) :: PLEN(NREF)
integer(kind=iwp), intent(out) :: IROOT(NRROOT)
integer(kind=iwp) :: I, IR, ISEL, J, JJ, JMAX
real(kind=wp) :: PL, PMAX, SUM1, SUM2

if (NSEL == 0) return
! SELECTION BY PROJECTION ONTO SPACE SPANNED BY CISEL VECTORS. IROOT()
! IS SET TO SELECT THE NRROOT VECTORS WITH MAX PROJECTED LENGTH.
do J=1,NREF
  SUM1 = Zero
  do ISEL=1,NSEL
    SUM2 = Zero
    do I=1,NREF
      SUM2 = SUM2+AREF(I,J)*CISEL(I,ISEL)
    end do
    SUM1 = SUM1+SUM2**2
  end do
  PLEN(J) = SUM1+J*1.0e-12_wp
end do
! SELECT BY MAGNITUDE OF PLEN:
do J=1,NRROOT
  PMAX = PLEN(1)
  JMAX = 1
  do JJ=2,NREF
    if (PMAX < PLEN(JJ)) then
      PMAX = PLEN(JJ)
      JMAX = JJ
    end if
  end do
  PLEN(JMAX) = -PMAX
end do
I = 0
do IR=1,NREF
  PL = PLEN(IR)
  if (PL < Zero) then
    I = I+1
    IROOT(I) = IR
    PL = -PL
  end if
  PLEN(IR) = PL-IR*1.0e-12_wp
end do

return

end subroutine CI_SELECT_MRCI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************
!#define _DEBUGPRINT_

Module Center_Info
Implicit None
Private
Public :: dc, n_dc, Center_Info_Init, Center_Info_Dmp, Center_Info_Get, Center_Info_Free

#include "Molcas.fh"
#include "stdalloc.fh"
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!    D E C L A R E   D E R I V E D   T Y P E S
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
Type Distinct_centers
!   Sequence
    Integer :: iChCnt=0
    Integer :: iStab(0:7)=[0,0,0,0,0,0,0,0]
    Integer :: nStab=0
    Integer :: iCoSet(0:7,0:7)=ReShape([0,0,0,0,0,0,0,0,                    &
                                        0,0,0,0,0,0,0,0,                    &
                                        0,0,0,0,0,0,0,0,                    &
                                        0,0,0,0,0,0,0,0,                    &
                                        0,0,0,0,0,0,0,0,                    &
                                        0,0,0,0,0,0,0,0,                    &
                                        0,0,0,0,0,0,0,0,                    &
                                        0,0,0,0,0,0,0,0],[8,8])
    Character(LEN=LENIN4):: LblCnt=''
End Type Distinct_centers
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     E N D   D E C L A R E   D E R I V E D   T Y P E S
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Integer, Parameter:: nFields=1+8+1+64
Logical :: Initiated = .FALSE.
Integer :: n_dc=0
Type (Distinct_centers), Allocatable:: dc(:)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!
Interface
   Subroutine Abend()
   End Subroutine Abend
   Subroutine Put_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Put_iArray
   Subroutine Get_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Get_iArray
   Subroutine Qpg_iArray(Label,Found,nData)
   Character*(*) Label
   Logical       Found
   Integer       nData
   End Subroutine Qpg_iArray
End Interface
!
!***********************************************************************
!***********************************************************************
!
Contains
!
!***********************************************************************
!***********************************************************************
!
!     This to make either the initial allocation of dbsc and Shells according to the default sizes
!     as defined by the parameters in Molcas.fh or according to the actual sizes as recorded on the
!     run file.
!
Subroutine Center_Info_Init()
If (Initiated) Then
   Write (6,*) 'Center_Info already initiated!'
   Write (6,*) 'May the is a missing call to Center_Info_Free.'
   Call Abend()
End If
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Enter Center_Info_Init'
#endif
If (n_dc.eq.0) Then
   Allocate(dc(1:MxAtom))
Else
   Allocate(dc(1:n_dc))
End If
Initiated=.True.
#ifdef _DEBUGPRINT_
Write (6,*) 'Exit Center_Info_Init'
#endif
Return
End Subroutine Center_Info_Init
!
!***********************************************************************
!***********************************************************************
!
Subroutine Center_Info_Dmp()
!
Integer i, j, k, licDmp, lcDmp
Integer, Allocatable:: iDmp(:)
Character(LEN=1), Allocatable:: cDmp(:)
!
!     Integer dc stuff
!
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Enter Center_Info_Dmp'
Write (6,*) 'n_dc=',n_dc
#endif
licDmp=n_dc*nFields
Call mma_Allocate(iDmp,licDmp+1,Label='iDmp')
j=0
Do i = 1, n_dc
   iDmp(j+1)=dc(i)%iChCnt
   j=j+1
   iDmp(j+1:j+8)=dc(i)%iStab(0:7)
   j=j+8
   iDmp(j+1)=dc(i)%nStab
   j=j+1
   iDmp(j+1:j+8)=dc(i)%iCoSet(:,0)
   j=j+8
   iDmp(j+1:j+8)=dc(i)%iCoSet(:,1)
   j=j+8
   iDmp(j+1:j+8)=dc(i)%iCoSet(:,2)
   j=j+8
   iDmp(j+1:j+8)=dc(i)%iCoSet(:,3)
   j=j+8
   iDmp(j+1:j+8)=dc(i)%iCoSet(:,4)
   j=j+8
   iDmp(j+1:j+8)=dc(i)%iCoSet(:,5)
   j=j+8
   iDmp(j+1:j+8)=dc(i)%iCoSet(:,6)
   j=j+8
   iDmp(j+1:j+8)=dc(i)%iCoSet(:,7)
   j=j+8
End Do
iDmp(licDmp+1)=n_dc
Call Put_iArray('icDmp',iDmp,licDmp+1)
Call mma_deallocate(iDmp)

lcDmp=n_dc*LENIN4
#ifdef _DEBUGPRINT_
Write (6,*) 'lcDmp=',n_dc
#endif
Call mma_allocate(cDmp,lcDmp,Label='cDmp')
k = 0
Do i = 1, n_dc
   Do j = 1, LENIN4
      cDmp(k+j) = dc(i)%LblCnt(j:j)
   End Do
   k = k + LENIN4
End Do
#ifdef _DEBUGPRINT_
Write (6,*) 'cDmp=',cDmp(1:lcDmp)
#endif
Call Put_cArray('dc: cDmp',cDmp(1),lcDmp)
Call mma_deallocate(cDmp)
#ifdef _DEBUGPRINT_
Write (6,*) 'Exit Center_Info_Dmp'
#endif
Return
End Subroutine Center_Info_Dmp
!
!***********************************************************************
!***********************************************************************
!
Subroutine Center_Info_Get()
!
Integer, Allocatable:: iDmp(:)
Character(LEN=1), Allocatable:: cDmp(:)
Logical Found
Integer i, j, k, Len,lcDmp

#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Enter Center_Info_Get'
#endif
Call qpg_iArray('icDmp',Found,Len)
Call mma_Allocate(iDmp,Len,Label='iDmp')
If (Found) Then
   Call Get_iArray('icDmp',iDmp,Len)
Else
   Write (6,*) 'Center_Info_Get: icDmp not found!'
   Call Abend()
End If
lcDmp=Len-1
n_dc=lcDmp/nFields
!
!     Initiate the memory allocation of dc
!
If (.Not.Initiated) Call Center_Info_Init()
#ifdef _DEBUGPRINT_
Write (6,*) 'iDmp(1:Len)=',iDmp(1:Len)
Write (6,*) 'Len=',Len
Write (6,*) 'n_dc=',n_dc
Write (6,*) 'lcDmp=',lcDmp
#endif
j=0
Do i = 1, n_dc
   dc(i)%iChCnt = iDmp(j+1)
   j = j + 1
   dc(i)%iStab(0:7) = iDmp(j+1:j+8)
   j = j + 8
   dc(i)%nStab  = iDmp(j+1)
   j = j + 1
   dc(i)%iCoSet(:,0) = iDmp(j+1:j+8)
   j = j + 8
   dc(i)%iCoSet(:,1) = iDmp(j+1:j+8)
   j = j + 8
   dc(i)%iCoSet(:,2) = iDmp(j+1:j+8)
   j = j + 8
   dc(i)%iCoSet(:,3) = iDmp(j+1:j+8)
   j = j + 8
   dc(i)%iCoSet(:,4) = iDmp(j+1:j+8)
   j = j + 8
   dc(i)%iCoSet(:,5) = iDmp(j+1:j+8)
   j = j + 8
   dc(i)%iCoSet(:,6) = iDmp(j+1:j+8)
   j = j + 8
   dc(i)%iCoSet(:,7) = iDmp(j+1:j+8)
   j = j + 8
End Do
Call mma_deAllocate(iDmp)
!
lcDmp=n_dc*LENIN4
#ifdef _DEBUGPRINT_
Write (6,*) 'lcDmp=',lcDmp
#endif
!
Call qpg_cArray('dc: cDmp',Found,Len)
If (Len/=lcDmp) Then
   Write (6,*) 'Center_Info_Get: Len /= lcDmp'
   Call Abend()
End If
Call mma_Allocate(cDmp,lcDmp,Label='cDmp')
Call Get_cArray('dc: cDmp',cDmp(1),lcDmp)
#ifdef _DEBUGPRINT_
Write (6,*) 'cDmp=',cDmp(1:lcDmp)
#endif
k=0
Do i = 1, n_dc
   Do j = 1, LENIN4
      dc(i)%LblCnt(j:j)  = cDmp(k+j)
   End Do
   k = k + LENIN4
End Do
Call mma_deAllocate(cDmp)
#ifdef _DEBUGPRINT_
Write (6,*) 'Exit Center_Info_Get'
#endif
!
End Subroutine Center_Info_Get
!
!***********************************************************************
!***********************************************************************
!
Subroutine Center_Info_Free()
!
!     Deallocate all allocatable parts of dc.
!
If (.Not.Allocated(dc)) Return
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Enter Center_Info_Free'
#endif
Deallocate(dc)
n_dc=0
Initiated=.False.
!
#ifdef _DEBUGPRINT_
Write (6,*) 'Exit Center_Info_Free'
#endif
Return
End Subroutine Center_Info_Free
!
!***********************************************************************
!***********************************************************************
!
End Module Center_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SETREDIND(IRED)
!
! Purpose: set index arrays for reduced set IRED. The counter
!          array NNBSTRSH must be set on entry.

use Cholesky, only: iiBstR, iiBstRSh, nnBstR, nnBstRSh, nnBstRT, nnShl, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IRED
integer(kind=iwp) :: ISHLAB, ISYM, J
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: mmShl, mSym
#endif
character(len=*), parameter :: SECNAM = 'CHO_SETREDIND'

J = IRED

#ifdef _DEBUGPRINT_
MSYM = size(iiBstRSh,1)
MMSHL = size(iiBstRSh,2)
if ((NNSHL /= MMSHL) .or. (NSYM /= MSYM)) call CHO_QUIT('[1] Dimension error in '//SECNAM,104)
if ((J < 1) .or. (J > 3)) call CHO_QUIT('[2] Dimension error in '//SECNAM,104)
#endif

if (NNSHL < 1) then ! may occur in parallel runs
  NNBSTRT(J) = 0
  IIBSTR(1:NSYM,J) = 0
  NNBSTR(1:NSYM,J) = 0
  return
end if

NNBSTRT(J) = 0
do ISYM=1,NSYM
  IIBSTRSH(ISYM,1,J) = 0
  NNBSTR(ISYM,J) = NNBSTRSH(ISYM,1,J)
  do ISHLAB=2,NNSHL
    IIBSTRSH(ISYM,ISHLAB,J) = NNBSTR(ISYM,J)
    NNBSTR(ISYM,J) = NNBSTR(ISYM,J)+NNBSTRSH(ISYM,ISHLAB,J)
  end do
  IIBSTR(ISYM,J) = NNBSTRT(J)
  NNBSTRT(J) = NNBSTRT(J)+NNBSTR(ISYM,J)
end do

end subroutine CHO_SETREDIND

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Anders Bernhardsson                              *
!               1999, Coen de Graaf                                    *
!***********************************************************************

subroutine Dens_IF_SCF(COEFF,CMO,Mode)
! A small stupid interface for creating the alpha and beta
! occupation numbers and corresponding molecular orbitals,
! used in MOLDEN.
!
! EAW 990118
!
! For SCF it gets even more 'stupid', just reading the MO coefficients and
! dumping it into a large matrix of dimension nTot x nTot
!   (Coen de Graaf, Oct. 99)

use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: COEFF(*), CMO(*)
character, intent(in) :: Mode
integer(kind=iwp) :: i, ip1, ip2, iS, nBas(0:7), nIrrep, nTot, nTot2

! COEN WANTED IT AS A BLOCKED MATRIX, SO HERE THEY COME...

call Get_iScalar('nSym',nIrrep)
call Get_iArray('nBas',nBas,nIrrep)
nTot = 0
nTot2 = 0
do iS=0,nIrrep-1
  nTot = nTot+nBas(iS)
  nTot2 = nTot2+nBas(iS)**2
end do

ip1 = 1
ip2 = 1
if (Mode == 'F') COEFF(:nTot**2) = Zero
!call RecPrt('COEFF',' ',Coeff,nTot,nTot)
do iS=0,nIrrep-1
  if (Mode == 'B') CMO(ip1:ip1+nbas(is)**2-1) = Zero
  !call RecPrt('CMO',' ',CMO(ip1),nbas(is),nbas(is))
  do i=1,nbas(is)
    if (Mode == 'F') call dcopy_(nbas(is),CMO(ip1),1,COEFF(ip2),1)
    if (Mode == 'B') call dcopy_(nbas(is),COEFF(ip2),1,CMO(ip1),1)
    ip1 = ip1+nbas(is)
    ip2 = ip2+nTot
  end do
  !call RecPrt('CMO',' ',CMO(ip1-nbas(is)**2),nbas(is),nbas(is))
  ip2 = ip2+nbas(is)
end do
!call RecPrt('COEFF',' ',Coeff,nTot,nTot)

end subroutine Dens_IF_SCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HssPrt_MCLR(ideg,Hess,ldisp)

use Index_Functions, only: iTri, nTri_Elem
use input_mclr, only: ChIrr, nIrrep, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ideg(*), ldisp(nsym)
real(kind=wp), intent(in) :: Hess(*)
integer(kind=iwp) :: i, iaa, idisp, ii, iIrrep, j, jj, kDisp(8)
character(len=39) :: Title
real(kind=wp), allocatable :: Temp(:)

iDisp = 0
do iIrrep=1,nIrrep
  kDisp(iIrrep) = iDisp
  iDisp = iDisp+lDisp(iIrrep)
  write(u6,*) lDisp(iIrrep)
end do

call mma_allocate(Temp,iDisp**2,Label='Temp')
iaa = 0
do iIrrep=1,nIrrep
  if (ldisp(iirrep) /= 0) then
    write(title,'(A,A)') 'Hessian in Irrep ',chirr(iIrrep)

    do i=1,lDisp(iirrep)
      do j=1,i
        ii = iTri(i,j)
        jj = iaa+iTri(i,j)
        Temp(ii) = Hess(jj)*sqrt(real(ideg(i+kdisp(iirrep))*ideg(j+kdisp(iirrep)),kind=wp))
      end do
    end do
    call TriPrt(title,' ',Temp,ldisp(iirrep))
    iaa = iaa+nTri_Elem(ldisp(iirrep))
  end if
end do
call mma_deallocate(Temp)

end subroutine HssPrt_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine t_create (sused,scrleng,scrchar,tnumber,tcounter,
     *                     ttimes,tmult,t,tscrleng,tscrchar,ttimestot)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 12.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer sused,scrleng(maxsnumber),tnumber,tcounter(maxsnumber),
     *        ttimes(maxsnumber),tmult(maxsnumber),tscrleng(maxsnumber),
     *        ttimestot
c
      character*(4) t(maxsnumber)
      character*(9) scrchar(maxsnumber)
      character*(11) tscrchar(maxsnumber)
c
      integer j
      character*(3) dkh_int2char
c
c
      do 10 j=1,sused
        tcounter(j)=1
        ttimes(j)=0
        tmult(j)=0
        t(j)='    '
        tscrchar(j)='           '
        tscrleng(j)=0
  10  continue
      tnumber=0
      ttimestot=0
      do 20 j=1,sused
        t(j)(1:4)='T'//dkh_int2char(j)
        tscrleng(j)=scrleng(j)+2
        tscrchar(j)(1:tscrleng(j))='P'//scrchar(j)(1:scrleng(j))//'P'
 20   continue
c
      if (dbgflg.ge.1) then
        write (dbgunit,1001)
1001    format (/2X,'Creation and initialization of scratch arrays ',
     *          '"t" successful.')
      endif
c
      if (dbgflg.ge.3) then
         write (dbgunit,1156)sused
 1156    format (/2X,'The following ',I3,' Txxx-matrices have been set',
     *           ' up:',//2X,'Txxx',2X,'tscrchar',4X,'tmult',2X,
     *           'tscrleng',/)
         do 6298 j=1,sused
           write (dbgunit,8877) t(j),tscrchar(j),tmult(j),tscrleng(j)
8877       format (2X,A4,2X,A11,2X,I3,5X,I3)
6298     continue
      endif

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DSQ(A,B,ICB,IRB,NROW)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*),B(*)
      IND=0
      DO 10 IROW=0,NROW-1
      DO 11 ICOL=0,IROW
         IND=IND+1
         B(1+IROW*ICB+ICOL*IRB)=0.5D0*A(IND)
         B(1+ICOL*ICB+IROW*IRB)=0.5D0*A(IND)
11    CONTINUE
10    CONTINUE
      DO 20 IROW=0,NROW-1
         B(1+IROW*(ICB+IRB))=2.0D0*B(1+IROW*(ICB+IRB))
20    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Shell_MxDens(Dens,DMax,nSkal)
!***********************************************************************
!                                                                      *
!  Subroutine Shell_MxDens:   returns max density values for each      *
!                             shell pair...                            *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: nIrrep
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSkal
real(kind=wp), intent(in) :: dens(*)
real(kind=wp), intent(out) :: dmax(nskal,nskal)
integer(kind=iwp) :: i, ia, ie, ij, ijOff, irp, iSh, j, ja, je, jSh, m, n
integer(kind=iwp), external :: nbfshl

ijoff = 0
dmax(:,:) = Zero
do irp=0,nirrep-1
  ie = 0
  do iSh=1,nSkal
    n = nbfshl(ish,irp)
    ia = ie+1
    ie = ie+n
    je = 0
    do jSh=1,iSh
      m = nbfshl(jsh,irp)
      ja = je+1
      je = je+m
      do i=ia,ie
        ij = nTri_Elem(i-1)+ja+ijoff
        do j=ja,min(i,je)
          dmax(jsh,ish) = max(dmax(jsh,ish),abs(dens(ij)))
          ij = ij+1
        end do
      end do
      dmax(ish,jsh) = dmax(jsh,ish)
    end do
  end do
  ijoff = ijoff+nTri_Elem(ie)
end do

end subroutine Shell_MxDens

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExtractM(M,L2,cGrp,deGrp,cSGrp,deSGrp)
! this routine does:
! extract M(m,c",de") from L2(m,c',de')
!
! parameter description:
! M     - M file (O)
! L     - L2 file (O)
! xGrp  - c,delta Group (I)
! xSGrp - c,delta Group (I)

use chcc_global, only: DimGrpa, DimSGrpa, DimSGrpbe, GrpaLow, GrpbeLow, nc
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: M(*)
real(kind=wp), intent(in) :: L2(*)
integer(kind=iwp), intent(in) :: cGrp, deGrp, cSGrp, deSGrp
integer(kind=iwp) :: depp, i, incL20, k, lenMCpp, posL20, posM0

!1 Initial settings

!1.1 def length of mc" block (=increment for posM0)
lenMCpp = nc*DimSGrpa(cSGrp)

!1.2 def posM0
posM0 = 1

!1.3 def posL20
posL20 = 1
k = 0
if (deSGrp > Grpbelow(deGrp)) then
  do i=Grpbelow(deGrp),deSGrp-1
    k = k+DimSGrpbe(i)
  end do
end if
posL20 = posL20+nc*DimGrpa(cGrp)*k

k = 0
if (cSGrp > Grpalow(cGrp)) then
  do i=Grpalow(cGrp),cSGrp-1
    k = k+DimSGrpa(i)
  end do
end if
posL20 = posL20+nc*k

!1.4 def increment for posL20
incL20 = dimGrpa(cGrp)*nc

!2 cycle over de"
do depp=1,DimSgrpbe(deSGrp)

  !2.1 copy block of #mc" size
  M(posM0:posM0+lenMCpp-1) = L2(PosL20:PosL20+lenMCpp-1)

  !2.2 upgrade posM0 and posL20 for next use
  posM0 = posM0+lenMCpp
  posL20 = posL20+incL20

end do

return

end subroutine ExtractM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MatInvert(A,n)
! Inverts a square matrix

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: A(n,n)
integer(kind=iwp) :: err, nw
real(kind=wp) :: dum(1)
integer(kind=iwp), allocatable :: ipiv(:)
real(kind=wp), allocatable :: wrk(:)

call mma_allocate(ipiv,n)
call dGeTRF_(n,n,A,n,ipiv,err)
call dGeTRI_(n,A,n,ipiv,dum,-1,err)
nw = int(dum(1))
call mma_allocate(wrk,nw)
call dGeTRI_(n,A,n,ipiv,wrk,nw,err)
call mma_deallocate(ipiv)
call mma_deallocate(wrk)

return

end subroutine MatInvert

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
* Not properly worked through. Do not use!
*
      Subroutine Mbpt2Corr(nBas,Cmo)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "qm1.fh"
#include "qminp.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "warnings.fh"
      Real*8, Allocatable:: Diff(:)
      Dimension Cmo(MxBas**2)

      Write(6,*)
      Write(6,*)'MP2 density correction is requested.'
      Write(6,*)' -- perturbative correlation correction to the solute '
     &//'density.'
*
*-- No-no zone!
*
      Write(6,*)
      Write(6,*)'THIS OPTION IS NOT PROPERLY WORKED THROUGH! SHOULD NOT'
     &//' BE USED!'
      Call Quit(_RC_GENERAL_ERROR_)
*--- Check that the density difference is sound.
      iT=nBas*(nBas+1)/2
      Call mma_allocate(Diff,iT,Label='Diff')
      Call Get_D1ao(Diff,iT)
      If(iPrint.ge.10) then
        Call TriPrt('Non-reduced difference density matrix',' '
     &             ,Diff,nBas)
      Endif
*--- Transform density difference to orbital basis.
      Call GetMem('SqDenA','Allo','Real',ipSqD,nBas**2)
      Call GetMem('SqDenM','Allo','Real',ipSqE,nBas**2)
      Call GetMem('TEMP','Allo','Real',ipTEMP,nBas**2)
      Call GetMem('Inv','Allo','Real',iI,nBas**2)
      Call GetMem('RedSq','Allo','Real',iRedSq,nBas**2)
      call dcopy_(nBas**2,[ZERO],iZERO,Work(ipSqD),iONE)
      call dcopy_(iOrb(1)**2,[ZERO],iZERO,Work(ipSqE),iONE)
      call dcopy_(nBas*iOrb(1),[ZERO],iZERO,Work(ipTEMP),iONE)
*--- Do not forget the density matrix convention in Molcas.
      Call Dsq(Diff,Work(ipSqD),iONE,nBas,nBas)
*--- Inverse of orbital file and transformation.
      Call Minv(Cmo,Work(iI),Ising,Det,nBas)
      Call Dgemm_('N','N',nBas,nBas,nBas,ONE,Work(iI),nBas,Work(ipSqD)
     &          ,nBas,ZERO,Work(ipTEMP),nBas)
      Call Dgemm_('N','T',nBas,nBas,nBas,ONE,Work(ipTEMP),nBas,Work(iI)
     &          ,nBas,ZERO,Work(ipSqE),nBas)
*--- Remove all except the suck-out orbitals.
      kaunt1=0
      Do i=1,nBas
        Do j=1,nBas
          If(i.le.iOrb(1).and.j.le.iOrb(1)) then
            Work(iRedSq+kaunt1)=Work(ipSqE+kaunt1)
          Else
            Work(iRedSq+kaunt1)=0.0d0
          Endif
          kaunt1=kaunt1+1
        Enddo
      Enddo
*--- Make a check of the trace. Should be small.
      kaunter=0
      Trace_MP2=0
      Do 108, iB1=1,nBas
        do jjj=1,nBas
          If(iB1.eq.jjj)Trace_MP2=Trace_MP2+Work(iRedSq+kaunter)
          kaunter=kaunter+1
        enddo
108   Continue
      If(iPrint.ge.10) then
        Write(6,*)'Trace: ',Trace_MP2
      Endif
*--- Make things a bit more tidy.
      kaunt1=0
      kaunt2=0
      Do i=1,iOrb(1)
        Do j=1,nBas
          If(j.le.iOrb(1)) then
            Work(ipSqE+kaunt1)=Work(iRedSq+kaunt2)
            kaunt1=kaunt1+1
          Endif
          kaunt2=kaunt2+1
        Enddo
      Enddo
      Call SqToTri_q(Work(ipSqE),DenCorrD,iOrb(1))

*--- Transform back if we want to keep things in AO-basis. Not
*    used in QMSTAT at the present. If you wish, comment away the
*    code below 'make things a bit more tidy' and you are in
*    ready to rumble.
*      Call Dgemm_('N','N',nBas,nBas,nBas,ONE,Cmo,nBas
*     &          ,Work(iRedSq),nBas,ZERO,Work(ipTEMP),nBas)
*      Call Dgemm_('N','T',nBas,nBas,nBas,ONE,Work(ipTEMP),nBas
*     &          ,Cmo,nBas,ZERO,Work(ipSqE),nBas)
*      k=0
*      Do i=1,nBas
*        Do j=1,nBas
*          If(i.ne.j)Work(ipSqE+k)=Work(ipSqE+k)*2
*            k=k+1
*        Enddo
*      Enddo
*      Call SqToTri_q(Work(ipSqE),Work(ipTrDiffD),nBas)
*      If(iPrint.ge.10) then
*        Call TriPrt('Reduced difference density matrix',' '
*     &             ,Work(ipTrDiffD),nBas)
*      Endif

      Call mma_deallocate(Diff)
      Call GetMem('SqDenA','Free','Real',ipSqD,nBas**2)
      Call GetMem('SqDenM','Free','Real',ipSqE,nBas**2)
      Call GetMem('TEMP','Free','Real',ipTEMP,nBas**2)
      Call GetMem('Inv','Free','Real',iI,nBas**2)
      Call GetMem('RedSq','Free','Real',iRedSq,nBas**2)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Ben Swerts                                             *
!               2016, Liviu Ungur                                      *
!***********************************************************************

subroutine FragPInt( &
#                   define _CALLING_
#                   include "int_interface.fh"
                   )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of Fragment AIEMP         *
!         projection integrals                                         *
!                                                                      *
!     Author: Ben Swerts                                               *
!     based on seward/prjint.f                                         *
!   Modified: Liviu Ungur                                              *
!                                                                      *
! additional info:                                                     *
!       mdci, mdci = show the type number (i.e. from 1 to nCnttp) of   *
!                    the corresponding "fragment" atom. Must never take*
!                    values of the atoms from the "central region"     *
!   iCnttp, jCnttp = index number of the the type of the fragment atom *
!  nFragType(mdci) = number of different basis sets (kinds of atoms)   *
!                    are in the "fragment"                             *
!  nFragCoor(mdci) = number of atoms of the fragment "mdci"            *
!                    must be 1, as we expanded atoms in one atom/group *
!                    check also the "FragExpand" subroutine            *
!  nFragDens(mdci) = nBas of the entire fragment type "mdci"           *
!***********************************************************************

use Real_Spherical, only: ipSph, RSph
use iSD_data, only: iSD
use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep, iChTbl
use Index_Functions, only: iTri, nTri_Elem1
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
! Local variables
integer(kind=iwp) :: iAng, iBas, iCnttp, iComp, iCurCenter, iCurCnttp, iCurMdc, iIC, iIrrep, iLoc, iPrim, ip, ipF1, ipF2, ipIJ, &
                     ipK1, ipK2, ipP1, ipP2, ipTmp, ipZ1, ipZ2, ipZI1, ipZI2, iS, iSbasis, iSend, iShll, iSize, iSlocal, iSstart, &
                     iStemp, jAng, jBas, jCnttp, jPrim, jS, jShll, jSize, jSlocal, lDCRT, llOper, LmbdT, mArr, maxDensSize, mdci, &
                     nac, ncb, nDCRT, nOp, nSkal, jSbasis, iCnt, jCnt, iDCRT(0:7)
real(kind=wp) :: C(3), TC(3), B(3), TB(3), Fact, Factor, Xg
logical(kind=iwp) :: EnergyWeight
! external functions:
integer(kind=iwp), external :: NrOpr
!real(kind=r8), external :: DNRM2_
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ia, ib
character(len=24) :: Label
#endif
#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(P)
unused_var(nHer)
unused_var(iCho)
unused_var(PtChrg)
unused_var(iAddPot)

#ifdef _DEBUGPRINT_
! data for individual fragments:
write(u6,*) ' In FragPInt:    nCnttp          = ',nCnttp
write(u6,*) ' In FragPInt: dbsc(nCnttp)%mdci  = ',(dbsc(i)%mdci,i=1,nCnttp)
write(u6,*) ' In FragPInt:     dbsc(nCnttp)%nCntr  = ',(dbsc(i)%nCntr,i=1,nCnttp)
write(u6,*) ' In FragPInt: nFragType(nCnttp)  = ',(dbsc(i)%nFragType,i=1,nCnttp)
write(u6,*) ' In FragPInt: nFragCoor(nCnttp)  = ',(dbsc(i)%nFragCoor,i=1,nCnttp)
write(u6,*) ' In FragPInt: nFragDens(nCnttp)  = ',(dbsc(i)%nFragDens,i=1,nCnttp)
write(u6,*) ' In FragPInt: nFragDens(nCnttp)  = ',(dbsc(i)%nFragDens,i=1,nCnttp)

write(u6,*) ' In FragPInt: nAlpha,nBeta=',' ',nAlpha,nBeta
write(u6,*) ' In FragPInt: Alpha=',' ',Alpha
write(u6,*) ' In FragPInt: Beta=',' ',Beta

write(u6,*) ' In FragPInt: nZeta=',' ',nZeta
write(u6,*) ' In FragPInt:  nArr=',' ',nArr
write(u6,*) ' In FragPInt:   nIC=',' ',nIC
write(u6,*) ' In FragPInt: la,lb=',' ',la,lb
write(u6,*) ' In FragPInt: nTri_Elem1(la)=',' ',nTri_Elem1(la)
write(u6,*) ' In FragPInt: nTri_Elem1(lb)=',' ',nTri_Elem1(lb)
call RecPrt(' In FragPInt: A     ',' ',A,1,3)
call RecPrt(' In FragPInt: RB    ',' ',RB,1,3)
call RecPrt(' In FragPInt: Ccoor ',' ',Ccoor,1,3)
call RecPrt(' In FragPInt: P     ',' ',P,nZeta,3)
call RecPrt(' In FragPInt: Array ',' ',Array,nZeta,nArr)
call TrcPrt(' In FragPInt: Array ',' ',Array,nZeta,nArr)
#endif

rFinal(:,:,:,:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! Setup the fragment shells

call Free_iSD()
call Set_Basis_Mode('Fragments')
call SetUp_iSD()
call Nr_Shells(nSkal)
#ifdef _DEBUGPRINT_
write(u6,*) 'nSkal_Fragment,nAlpha,nBeta = ',nSkal,nAlpha,nBeta
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Reserve space for the largest possible fragment energy weighted
! density matrix and one combination of shells of it.
maxDensSize = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%nFragType > 0) then
    maxDensSize = max(maxDensSize,dbsc(iCnttp)%nFragDens*(dbsc(iCnttp)%nFragDens+1)/2)
#   ifdef _DEBUGPRINT_
    write(u6,'(A,i2,A,i6)') 'nFragDens(',iCnttp,')=',dbsc(iCnttp)%nFragDens
#   endif
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over all shells belonging to the fragments

llOper = lOper(1)
iComp = 1
iCurMdc = 0         ! The mdc value of the current fragment placeholder
iCurCnttp = 1       ! The Cnttp of the fragment placeholder
iCurCenter = 999999 ! The index of the fragment in the fragment placeholder list of centers
iSstart = 0         ! The index into the full shells list for the first shell of a fragment
isEnd = nSkal       ! The index into the full shells list for the last shell of a fragment
iSbasis = 0         ! The basis function index relative to the start of the fragment
do iS=1,nSkal
  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  mdci = iSD(10,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  iSize = nTri_Elem1(iAng)
  C(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
  ! some printouts:
# ifdef _DEBUGPRINT_
  write(u6,*) 'In FragPInt: iS=',iS,' iShll =',iShll
  write(u6,*) 'In FragPInt: iS=',iS,' iAng  =',iAng
  write(u6,*) 'In FragPInt: iS=',iS,' iBas  =',iBas
  write(u6,*) 'In FragPInt: iS=',iS,' iPrim =',iPrim
  write(u6,*) 'In FragPInt: iS=',iS,' mdci  =',mdci
  write(u6,*) 'In FragPInt: iS=',iS,' iCnttp=',iCnttp
  write(u6,*) 'In FragPInt: iS=',iS,' iSize =',iSize
  write(u6,*) 'In FragPInt: iS=',iS,' iCurMdc =',iCurMdc
  write(u6,*) 'In FragPInt: nFragCoor(',iCnttp,') =',dbsc(iCnttp)%nFragCoor
# endif

  if (Shells(iShll)%Transf .and. Shells(iShll)%Prjct) iSize = 2*iAng+1
  if (abs(dbsc(iCnttp)%nFragCoor) /= iCurMdc) then
    ! update fragment related quantities
    iCurMdc = abs(dbsc(iCnttp)%nFragCoor)
    iSstart = iS
    iSend = nSkal
    do iStemp=iSstart+1,nSkal
      if (abs(dbsc(iSD(13,iStemp))%nFragCoor) /= iCurMdc) then
        iSend = iStemp-1
        exit
      end if
    end do
    iSbasis = 1
    iCurCenter = iCurCenter+1

#   ifdef _DEBUGPRINT_
    write(u6,*) 'start of new fragment encountered'
    write(u6,*) 'iSstart,iSend,iCurCnttp,iCurCenter =',iSstart,iSend,iCurCnttp,iCurCenter
#   endif

    if (iCurCenter > dbsc(iCurCnttp)%nCntr) then
      iCurCenter = 1
      do jCnttp=iCurCnttp+1,nCnttp
        if (dbsc(jCnttp)%nFragType > 0) then
          iCurCnttp = jCnttp
          exit
        end if
      end do

      ! update the energy weighted density matrix of the current fragment
      EnergyWeight = .true.
      call MakeDens(dbsc(iCurCnttp)%nFragDens,dbsc(iCurCnttp)%nFragEner,dbsc(iCurCnttp)%FragCoef,dbsc(iCurCnttp)%FragEner, &
                    EnergyWeight,Array)
#     ifdef _DEBUGPRINT_
      call TriPrt('Energy weighted fragment dens',' ',Array,dbsc(iCurCnttp)%nFragDens)
#     endif
      ! include the minus sign of -2eta_i
      call DScal_(dbsc(iCurCnttp)%nFragDens*(dbsc(iCurCnttp)%nFragDens+1)/2,-One,Array,1)
#     ifdef _DEBUGPRINT_
      call TriPrt('-1 Energy weighted fragment dens',' ',Array,dbsc(iCurCnttp)%nFragDens)
#     endif
      if (maxDensSize < dbsc(iCurCnttp)%nFragDens*(dbsc(iCurCnttp)%nFragDens+1)/2) call Abend() !'maxIJSize'
    end if
  end if
# ifdef _DEBUGPRINT_
  write(u6,*) '  iShll,iAng,mdci,iCnttp,iCurMdc,iCurCnttp',iShll,iAng,mdci,iCnttp,iCurMdc,iCurCnttp
  write(u6,*) '  iPrim,iBas =',iPrim,iBas
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Loop over all other shells belonging to the same fragment
  jSbasis = 1
# ifdef _DEBUGPRINT_
  write(u6,'(3(A,i4))') 'iS = ',iS,' iSstart=',iSstart,' iSEnd=',iSend
# endif
  do jS=iSstart,iSend
    jShll = iSD(0,jS)
    jAng = iSD(1,jS)
    jBas = iSD(3,jS)
    jPrim = iSD(5,jS)
    jCnttp = iSD(13,jS)
    jCnt = iSD(14,jS)
    jSize = nTri_Elem1(jAng)
    B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
#   ifdef _DEBUGPRINT_
    write(u6,'(A,i6,A,i16)') 'In FragPInt: jS=',jS,' jShll =',jShll
    write(u6,'(A,i6,A,i16)') 'In FragPInt: jS=',jS,' jAng  =',jAng
    write(u6,'(A,i6,A,i16)') 'In FragPInt: jS=',jS,' jBas  =',jBas
    write(u6,'(A,i6,A,i16)') 'In FragPInt: jS=',jS,' jPrim =',jPrim
    write(u6,'(A,i6,A,i16)') 'In FragPInt: jS=',jS,' jCnttp=',jCnttp
    write(u6,'(A,i6,A,i16)') 'In FragPInt: jS=',jS,' jSize =',jSize
#   endif

    if (Shells(jShll)%Transf .and. Shells(jShll)%Prjct) jSize = 2*jAng+1
#   ifdef _DEBUGPRINT_
    write(u6,*) '    jShll,jAng,jCnttp =',jShll,jAng,jCnttp
    write(u6,*) '    jPrim,jBas =',jPrim,jBas
#   endif
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Create a rectangular matrix sized (iBas*nTri_Elem1(iAng),jBas*nTri_Elem1(jAng))
    ! from the energy weighted density matrix (desymmetrized)
    ! contains values from iSbasis to iSbasis + iBas*nTri_Elem1(iAng) - 1
    !             and from jSbasis to jSbasis + jBas*nTri_Elem1(jAng) - 1
    ipIJ = 1+maxDensSize
#   ifdef _DEBUGPRINT_
    write(u6,*) '    ipIJ=',ipIJ
    write(u6,*) '    extracting values from',iSbasis,' to',iSbasis+iBas*iSize-1,', and from',jSbasis,' to',jSbasis+jBas*jSize-1
#   endif
    do iSlocal=iSbasis,iSbasis+iBas*iSize-1
      do jSlocal=jSbasis,jSbasis+jBas*jSize-1
        iLoc = ipIJ+(jSlocal-jSbasis)*iBas*iSize+iSlocal-iSbasis
#       ifdef _DEBUGPRINT_
        write(u6,'(A,i3,A,i3,A,i4,A,i8)') 'iTri(',iSlocal,',',jSlocal,')=',iTri(iSlocal,jSlocal),' iLoc=',iLoc
#       endif
        Array(iLoc) = Array(iTri(iSlocal,jSlocal))
        if (iSlocal /= jSlocal) Array(iLoc) = Array(iLoc)/Two
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Filling (',iSlocal-iSbasis+1,',',jSlocal-jSbasis+1,') from (',iSlocal,',',jSlocal,')'
#       endif
      end do
    end do
#   ifdef _DEBUGPRINT_
    call RecPrt('W(KC,LD)',' ',Array(ipIJ),iBas*iSize,jBas*jSize)
#   endif
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! DCR stuff (iS and jS have always the same symmetry character)

    call DCR(LmbdT,iStabM,nStabM,dc(mdci)%iStab,dc(mdci)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Loop over symmetry operations acting on the basis.

    do lDCRT=0,nDCRT-1
      call OA(iDCRT(lDCRT),C,TC)
      call OA(iDCRT(lDCRT),B,TB)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Calculate the overlap integral < alpha | is >

      ip = ipIJ+maxDensSize
      ipF1 = ip
      nac = nTri_Elem1(la)*nTri_Elem1(iAng)
      ip = ip+nAlpha*nac*iPrim
      ipP1 = ip
      ip = ip+3*nAlpha*iPrim
      ipZ1 = ip
      ip = ip+nAlpha*iPrim
      ipK1 = ip
      ip = ip+nAlpha*iPrim
      ipZI1 = ip
      ip = ip+nAlpha*iPrim
      if (ip-1 > nArr*nZeta) then
        write(u6,*) '  ip-1 > nArr*nZeta(1) in FragPInt'
        call Abend()
      end if
      mArr = (nArr*nZeta-(ip-1))/nZeta

      call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,iPrim,Alpha,Shells(iShll)%Exp)
      call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,iPrim,A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))

      nHer = (la+iAng+2)/2
      call MltPrm(Alpha,nAlpha,Shells(iShll)%Exp,iPrim,Array(ipZ1),Array(ipZI1),Array(ipK1),Array(ipP1),Array(ipF1),nAlpha*iPrim, &
                  iComp,la,iAng,A,TC,nHer,Array(ip),mArr,CCoor,nOrdOp)
#     ifdef _DEBUGPRINT_
      call RecPrt('<alpha|iS> (aBas x X)',' ',Array(ipF1),nAlpha*iPrim,nac)
#     endif
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Calculate the overlap integral < jS | beta >

      ip = ip-6*nAlpha*iPrim
      ipF2 = ip
      ncb = nTri_Elem1(jAng)*nTri_Elem1(lb)
      ip = ip+jPrim*nBeta*ncb
      ipP2 = ip
      ip = ip+3*jPrim*nBeta
      ipZ2 = ip
      ip = ip+jPrim*nBeta
      ipK2 = ip
      ip = ip+jPrim*nBeta
      ipZI2 = ip
      ip = ip+jPrim*nBeta
      if (ip-1 > nArr*nZeta) then
        write(u6,*) '  ip-1 > nArr*nZeta(2) in FragPInt'
        call Abend()
      end if
      mArr = (nArr*nZeta-(ip-1))/nZeta

      call ZXia(Array(ipZ2),Array(ipZI2),jPrim,nBeta,Shells(jShll)%Exp,Beta)
      call SetUp1(Shells(jShll)%Exp,jPrim,Beta,nBeta,TB,RB,Array(ipK2),Array(ipP2),Array(ipZI2))

      nHer = (jAng+lb+2)/2
      call MltPrm(Shells(jShll)%Exp,jPrim,Beta,nBeta,Array(ipZ2),Array(ipZI2),Array(ipK2),Array(ipP2),Array(ipF2),jPrim*nBeta, &
                  iComp,jAng,lb,TB,RB,nHer,Array(ip),mArr,CCoor,nOrdOp)
      ip = ip-6*jPrim*nBeta
      ipTmp = ip
      ip = ip+max(nAlpha*nac*max(iPrim,jBas),nBeta*ncb*jBas)
      if (ip-1 > nArr*nZeta) then
        write(u6,*) '  ip-1 > nArr*nZeta(3) in FragPInt'
        call Abend()
      end if
#     ifdef _DEBUGPRINT_
      call RecPrt('<jS|beta> (bBas x Y)',' ',Array(ipF2),nBeta*jPrim,ncb)
#     endif
      if ((ipTmp-ipF2) < nBeta*jPrim*ncb) stop 'sizetest 1'
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Assemble the calculated quantities and contract
      !
      ! Calculate Contraction over components of the fragment
      ! orbitals of type <A|iS>coef<jS|B> where we now have in
      ! Array(ipF1) the cartesian components of <A|iS>, and
      ! similarily, in Array(ipF2), we have stored the cartesian
      ! components of <jS|B>. Observe that the fragment orbitals are
      ! orthonomal atomic orbitals. Hence, the transformation
      ! to the spherical harmonics has to be for normalized
      ! spherical harmonics.
      !
      ! nAlpha = i               nTri_Elem1(la) = a
      ! nBeta  = j               nTri_Elem1(lb) = b
      ! iPrim = k (iBas = K)     nTri_Elem1(iAng) = c (iSize = C)
      ! jPrim = l (jBas = L)     nTri_Elem1(jAng) = d (jSize = D)
      !
      !---From the lefthandside overlap, form iKaC from ikac by
      !   1) i,kac -> k,aci

      call DgeTMo(Array(ipF1),nAlpha,nAlpha,iPrim*nac,Array(ipTmp),iPrim*nac)
#     ifdef _DEBUGPRINT_
      call RecPrt('<alpha|iS>^T (X x aBas)',' ',Array(ipTmp),iPrim*nac,nAlpha)
#     endif
      if ((ip-ipTmp) < nAlpha*iPrim*nac) stop 'sizetest 2'

      !---2) aciK =  k,aci * k,K

      call DGEMM_('T','N',nac*nAlpha,iBas,iPrim,One,Array(ipTmp),iPrim,Shells(iShll)%pCff,iPrim,Zero,Array(ipF1),nAlpha*nac)
#     ifdef _DEBUGPRINT_
      call RecPrt('<alpha|iS>(regrouped, X x iPrim)',' ',Array(ipTmp),nAlpha*nac,iPrim)
      call RecPrt('Coeffs of iS (iPrim x iBas)',' ',Shells(iShll)%pCff,iPrim,iBas)
      call RecPrt('<alpha|iS>(re) * Coeffs of iS (X x iBas)',' ',Array(ipF1),nAlpha*nac,iBas)
#     endif
      if ((ipF2-ipF1) < nAlpha*iBas*nac) stop 'sizetest 3'

      !---4) a,ciK -> ciKa

      call DgeTMo(Array(ipF1),nTri_Elem1(la),nTri_Elem1(la),nTri_Elem1(iAng)*nAlpha*iBas,Array(ipTmp),nTri_Elem1(iAng)*nAlpha*iBas)
#     ifdef _DEBUGPRINT_
      call RecPrt('result (regrouped, nTri_Elem1(la) x X)',' ',Array(ipF1),nTri_Elem1(la),nTri_Elem1(iAng)*nAlpha*iBas)
      call RecPrt('transpose of result (X x nTri_Elem1(la))',' ',Array(ipTmp),nTri_Elem1(iAng)*nAlpha*iBas,nTri_Elem1(la))
#     endif
      if ((ip-ipTmp) < nAlpha*iBas*nTri_Elem1(iAng)*nTri_Elem1(la)) stop 'sizetest 6'

      !---5) iKa,C = c,iKa * c,C

      if (Shells(iShll)%Transf .and. Shells(iShll)%Prjct) then
        call DGEMM_('T','N',iBas*nTri_Elem1(la)*nAlpha,iSize,nTri_Elem1(iAng),One,Array(ipTmp),nTri_Elem1(iAng),RSph(ipSph(iAng)), &
                    nTri_Elem1(iAng),Zero,Array(ipF1),nAlpha*iBas*nTri_Elem1(la))
#       ifdef _DEBUGPRINT_
        call RecPrt('result (regrouped, X x nTri_Elem1(iAng))',' ',Array(ipTmp),nTri_Elem1(la)*nAlpha*iBas,nTri_Elem1(iAng))
        call RecPrt('Spher of iS (nTri_Elem1(iAng) x (2*iAng+1))',' ',RSph(ipSph(iAng)),nTri_Elem1(iAng),(2*iAng+1))
        call RecPrt('result in spherical gaussians (X x iSize',' ',Array(ipF1),nAlpha*iBas*nTri_Elem1(la),iSize)
#       endif
      else
        ! in this case nTri_Elem1(iAng) = iSize
        call DgeTMo(Array(ipTmp),nTri_Elem1(iAng),nTri_Elem1(iAng),iBas*nTri_Elem1(la)*nAlpha,Array(ipF1), &
                    iBas*nTri_Elem1(la)*nAlpha)
      end if
      if ((ipF2-ipF1) < nAlpha*iBas*nTri_Elem1(la)*iSize) stop 'sizetest 7'

      !---And (almost) the same thing for the righthand side, form
      !   LjDb from ljdb
      !   1) jdb,L = l,jdb * l,L
      call DGEMM_('T','N',nBeta*ncb,jBas,jPrim,One,Array(ipF2),jPrim,Shells(jShll)%pCff,jPrim,Zero,Array(ipTmp),nBeta*ncb)
#     ifdef _DEBUGPRINT_
      call RecPrt('<jS|beta>(regrouped, X x jPrim)',' ',Array(ipF2),nBeta*ncb,jPrim)
      call RecPrt('Coeffs of jS (jPrim x jBas)',' ',Shells(jShll)%pCff,jPrim,jBas)
      call RecPrt('<jS|beta>(re) * Coeffs of jS (Y x jBas)',' ',Array(ipTmp),nBeta*ncb,jBas)
#     endif
      if ((ip-ipTmp) < nBeta*jBas*ncb) stop 'sizetest 8'

      !---2)  j,dbL -> dbL,j

      call DgeTMo(Array(ipTmp),nBeta,nBeta,jBas*ncb,Array(ipF2),jBas*ncb)
#     ifdef _DEBUGPRINT_
      call RecPrt('transposed right 1 (Y x bBas)',' ',Array(ipF2),jBas*ncb,nBeta)
#     endif
      if ((ipTmp-ipF2) < nBeta*jBas*ncb) stop 'sizetest 9'

      !---3) bLj,D = d,bLj * d,D

      if (Shells(jShll)%Transf .and. Shells(jShll)%Prjct) then
        call DGEMM_('T','N',nTri_Elem1(lb)*jBas*nBeta,jSize,nTri_Elem1(jAng),One,Array(ipF2),nTri_Elem1(jAng),RSph(ipSph(jAng)), &
                    nTri_Elem1(jAng),Zero,Array(ipTmp),nTri_Elem1(lb)*jBas*nBeta)
#       ifdef _DEBUGPRINT_
        call RecPrt('multiply right 2 (Y x jSize)',' ',Array(ipTmp),nBeta*jBas*nTri_Elem1(lb),jSize)
#       endif
      else
        ! in this case nTri_Elem1(jAng) = jSize
        call DgeTMo(Array(ipF2),nTri_Elem1(jAng),nTri_Elem1(jAng),jBas*nTri_Elem1(lb)*nBeta,Array(ipTmp),jBas*nTri_Elem1(lb)*nBeta)
      end if
      if ((ip-ipTmp) < nBeta*jBas*nTri_Elem1(lb)*jSize) stop 'sizetest 10'

      !---4) b,LjD -> LjD,b

      call DgeTMo(Array(ipTmp),nTri_Elem1(lb),nTri_Elem1(lb),jBas*nBeta*jSize,Array(ipF2),jBas*nBeta*jSize)
#     ifdef _DEBUGPRINT_
      call RecPrt('transposed right 2 (Y x nTri_Elem1(lb)',' ',Array(ipF2),jBas*nBeta*jSize,nTri_Elem1(lb))
#     endif

      if ((ipTmp-ipF2) < nBeta*jBas*nTri_Elem1(lb)*jSize) stop 'sizetest 11'

      !---Next Contract (iKaC)*W(KLCD)*(LjDb) producing ijab,
      !   by the following procedure:
      !   Loop over a and b
      !     Loop over C
      !       Contract iK(aC)*Kj(Cb), over K producing ij(aCb),
      !         accumulate to ij(ab)
      !     End loop C
      !   End Loop b and a
      !
      ! Total size of ipF1 = nAlpha*nTri_Elem1(la) * iBas*iSize  -> ordered as (nAlpha, iBas,  nTri_Elem1(la), iSize)
      !               ipF2 = nBeta*nTri_Elem1(lb)  * jBas*jSize                (jBas,   nBeta, jSize,          nTri_Elem1(lb))
      !                  W = iBas*iSize * jBas*jSize                           (iBas,   iSize, jBas,           jSize)

#     ifdef _DEBUGPRINT_
      write(u6,*) ' Current contents of rFinal():'
      do ia=1,nTri_Elem1(la)
        do ib=1,nTri_Elem1(lb)
          write(Label,'(A,I2,A,I2,A)') ' rFinal(',ia,',',ib,')'
          call RecPrt(Label,' ',rFinal(:,ia,ib,:),nAlpha,nBeta)
        end do
      end do
#     endif

      iIC = 0
      do iIrrep=0,nIrrep-1
        if (btest(llOper,iIrrep)) then
          iIC = iIC+1
          nOp = NrOpr(iDCRT(lDCRT))
          Xg = real(iChTbl(iIrrep,nOp),kind=wp)
          ! Half is needed because we do a complete loop over iS,jS
          Factor = Xg*Fact*Half
          !write(u6,'(A,i24)') 'FragPInt:  ipIJ=',ipIJ
          !print(u6,*) 'CALL FragPCont'
          call xFlush(u6)

          call FragPCont(Array(ipF1),nAlpha,iBas,nTri_Elem1(la),iSize,Array(ipF2),jBas,nBeta,jSize,nTri_Elem1(lb),Array(ipIJ), &
                         rFinal(:,:,:,iIC),Factor)
        end if
      end do
      if (iIC /= nIC) stop 'iIC /= nIC'

#     ifdef _DEBUGPRINT_
      write(u6,*) ' After contraction:'
      do ia=1,nTri_Elem1(la)
        do ib=1,nTri_Elem1(lb)
          write(Label,'(A,I2,A,I2,A)') ' rFinal(',ia,',',ib,')'
          call RecPrt(Label,' ',rFinal(:,ia,ib,:),nAlpha,nBeta)
        end do
      end do
#     endif

    end do ! end loop over lDCR

    jSbasis = jSbasis+jBas*jSize
  end do ! end loop over jS
  call xFlush(u6)

  iSbasis = iSbasis+iBas*iSize
end do ! end loop over iS
call xFlush(u6)

#ifdef _DEBUGPRINT_
write(u6,*) ' Result in FragPInt'
do ia=1,nTri_Elem1(la)
  do ib=1,nTri_Elem1(lb)
    write(Label,'(A,I2,A,I2,A)') ' rFinal(',ia,',',ib,')'
    call RecPrt(Label,' ',rFinal(:,ia,ib,:),nAlpha,nBeta)
  end do
end do
#endif
! add some verification data
! this check is to ensure that Add_Info is called only on the Master node
! The reason being that the execution of this Kernel routine is split on
! diffeent nodes eariler in the code.
! OneEl -> OneEl_ -> OneEl_IJ -> this routine.
! Normally, the Add_Info must be called after the parallelization is finalized,
! i.e. in the OneEl function.
!if (MyRank == 0) then
!  do ia=1,nTri_Elem1(la)
!    do ib=1,nTri_Elem1(lb)
!      dA = Zero
!      dA = dnrm2_(nAlpha*nBeta,rFinal(1,ia,ib,1),1)
!      if (dA > 1.0e-6_wp) then
!        write(label,'(A,i2,A,i2)') 'Fragpint: ',ia,' ib ',ib
!        call Add_Info(label,dA,1,6)
!      end if
!      call xFlush(u6)
!    end do
!  end do
!end if
call Free_iSD()
call Set_Basis_Mode('Valence')
call SetUp_iSD()
call Nr_Shells(nSkal)

return

end subroutine FragPInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_CHKCONF(NCONFL,VERBOSE)
C
C     Purpose: check configuration, return the number of errors NCONFL.
C
      IMPLICIT NONE
      INTEGER NCONFL
      LOGICAL VERBOSE
#include "cholesky.fh"
#include "choorb.fh"
#include "chosubscr.fh"
#include "chosimri.fh"
#include "cho_para_info.fh"

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_CHKCONF')

      LOGICAL REPORT
      INTEGER NNN, MMM, INEGRR
      REAL*8  XLBUF, XMBUF

C     Initialize.
C     -----------

      NCONFL = 0
      REPORT = VERBOSE

C     Check that output unit is appropriately set.
C     (Upper bound not checked, as it may vary.)
C     --------------------------------------------

      IF (LUPRI .LT. 1) THEN
         NCONFL = NCONFL + 1
         REPORT = .FALSE.
      END IF

C     Check decomposition algorithm.
C     ------------------------------

      IF (CHO_DECALG.LT.1 .OR. CHO_DECALG.GT.CHO_NDECALG) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,A,I4)') 'Illegal decomposition algorithm, ',
     &                     'CHO_DECALG = ',CHO_DECALG
         END IF
         NCONFL = NCONFL + 1
      END IF
      IF (Cho_Real_Par) THEN
         IF (CHO_DECALG.NE.4 .AND. CHO_DECALG.NE.5 .AND.
     &       CHO_DECALG.NE.6) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A,I4)')
     &                        'Illegal decomposition algorithm, ',
     &                        'CHO_DECALG = ',CHO_DECALG
               WRITE(LUPRI,'(A,A)')
     &                        'Only parallel algorithm is allowed ',
     &                        'for parallel execution'
            END IF
            NCONFL = NCONFL + 1
         END IF
      END IF

C     Cancel exclusion of 2-center diagonals in case of symmetry.
C     ----------------------------------------------------------

      IF (CHO_NO2CENTER) THEN
         IF (NSYM .NE. 1) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A)') 'Exclusion of 2-center diagonals ',
     &                        'only implemented for C1 point group.'
            END IF
            NCONFL = NCONFL + 1
         END IF
      END IF

C     Cancel 1-center decomposition in case of symmetry.
C     --------------------------------------------------

      IF (CHO_1CENTER) THEN
         IF (NSYM .NE. 1) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A)') '1-center decomposition ',
     &                        'only implemented for C1 point group.'
            END IF
            NCONFL = NCONFL + 1
         END IF
      END IF

C     Checks specific to RI simulation.
C     ---------------------------------

      IF (CHO_SIMRI) THEN
         IF (.NOT. CHO_1CENTER) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A)') '1-center decomposition required ',
     &                        'for RI simulation.'
            END IF
            NCONFL = NCONFL + 1
         END IF
         IF (CHO_DECALG .NE. 2) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A)') 'RI simulation can only be ',
     &                        'executed with the two-step algorithm.'
            END IF
            NCONFL = NCONFL + 1
         END IF
         IF (RSTCHO) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A)') 'RI simulation can not be ',
     &                        'executed with decomposition restart.'
            END IF
            NCONFL = NCONFL + 1
         END IF
      END IF

C     Check for conflicts for specific algorithms.
C     --------------------------------------------

      IF (CHO_DECALG.EQ.2 .OR. CHO_DECALG.EQ.5) THEN
         IF (.NOT. SCDIAG) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A)')
     &                        'Screening must be turned on for two-',
     &                        'step decomposition algorithm.'
            END IF
            NCONFL = NCONFL + 1
         END IF
         IF (IFCSEW .NE. 2) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A,A)') 'The interface to Seward must ',
     &                        'be "2" (reduced set communication)',
     &                        ' for two-step algorithm.'
               WRITE(LUPRI,'(A,I4)') 'Current value is IFCSEW=',IFCSEW
            END IF
            NCONFL = NCONFL + 1
         END IF
         IF (RSTCHO) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A)') 'Decomposition restart is not ',
     &                              'possible for two-step algorithm.'
            END IF
            NCONFL = NCONFL + 1
         END IF
      END IF

      IF (CHO_DECALG.EQ.5) THEN
         IF (BLOCKSIZE.LT.1) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A,I8)')
     &         'BlockSize must be strictly positive.',
     &         'Current value is BlockSize=',BlockSize
            END IF
            NCONFL=NCONFL+1
         END IF
      END IF

C     Check max. number of Cholesky vectors and reduced sets.
C     -------------------------------------------------------

      IF (MAXVEC .LT. 1) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,I8)') 'Max. number of vectors < 1: ',MAXVEC
         END IF
         NCONFL = NCONFL + 1
      END IF
      IF (MAXRED .LT. 1) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,I8)')
     &      'Max. number of reduced sets < 1: ',MAXRED
         END IF
         NCONFL = NCONFL + 1
      END IF

C     Check qualification algorithm.
C     ------------------------------

      IF (IALQUA .LT. 0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,I4,A)')
     &                     'Qualification algorithm reset from ',
     &                     IALQUA,' to 1'
         END IF
         IALQUA = 1
      ELSE IF (IALQUA .GT. NALQUA) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,I4,A,I4)')
     &                   'Qualification algorithm reset from ',
     &                   IALQUA,' to ',NALQUA
         END IF
         IALQUA = NALQUA
      END IF

C     Decomposition threshold.
C     ------------------------

      IF (THRCOM .LT. 0.0D0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,1P,D15.6,A,D15.6,A)')
     &                     'Decomposition threshold not positive: ',
     &                     THRCOM,' (default value: ',THRDEF,
     &                     ')'
         END IF
         NCONFL = NCONFL + 1
      END IF

C     Diagonal prescreening threshold.
C     --------------------------------

      IF (CHO_PRESCREEN) THEN
         IF (THR_PRESCREEN .GT. THRCOM) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A,1P,D15.6,A,D15.6)')
     &                        'Diagonal prescreening threshold is ',
     &                        'greater than decomposition threshold: ',
     &                        THR_PRESCREEN,' > ',THRCOM
            END IF
            NCONFL = NCONFL + 1
         END IF
      END IF

C     Screening threshold for vector subtraction.
C     -------------------------------------------

      IF (CHO_SSCREEN) THEN
         IF (SSTAU .LT. 0.0D0) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A,1P,D15.6)')
     &                        'Screening threshold for vector ',
     &                        'subtraction not positive: ',SSTAU
            END IF
            NCONFL = NCONFL + 1
         END IF
      END IF

C     Buffer length.
C     --------------

      IF (LBUF .LT. 1) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,I8)') 'Buffer length < 1: ',LBUF
         END IF
         NCONFL = NCONFL + 1
      ELSE
         XLBUF = DBLE(LBUF)
         XMBUF = DBLE(NBAST)*(DBLE(NBAST)+1.0D0)/2.0D0
         IF (XLBUF .GT. XMBUF) THEN ! make sure LBUF is not too large
            LBUF = NINT(XMBUF)
         END IF
      END IF

C     Memory split for qualified columns.
C     -----------------------------------

      IF (N1_QUAL .GE. N2_QUAL) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,2I5)') 'N1_QUAL >= N2_QUAL: ',
     &                     N1_QUAL,N2_QUAL
         END IF
         NCONFL = NCONFL + 1
      END IF
      IF (N1_QUAL.LT.1 .OR. N2_QUAL.LT.1) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,2I5)')
     &                     'N1_QUAL and/or N2_QUAL < 1: ',
     &                     N1_QUAL,N2_QUAL
         END IF
         NCONFL = NCONFL + 1
      END IF

C     Memory split for buffered reading of previous vectors.
C     Max. #vectors in each call to DGEMM in subtraction.
C     (CHO_IOVEC=3,4 only.)
C     ------------------------------------------------------

      IF (CHO_IOVEC.EQ.3 .OR. CHO_IOVEC.EQ.4) THEN
         IF (N2_VECRD .LT. N1_VECRD) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,2I5)') 'N1_VECRD >= N2_VECRD: ',
     &                        N1_VECRD,N2_VECRD
            END IF
            NCONFL = NCONFL + 1
         END IF
         IF (N1_VECRD.LT.1 .OR. N2_VECRD.LT.1) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,2I5)') 'N1_VECRD and/or N2_VECRD < 1: ',
     &                        N1_VECRD,N2_VECRD
            END IF
            NCONFL = NCONFL + 1
         END IF
         IF (N_SUBTR .LT. 1) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,I8)') 'N_SUBTR: ',N_SUBTR
            END IF
            NCONFL = NCONFL + 1
         END IF
      END IF

C     Memory fraction used for vector buffer.
C     ---------------------------------------

      IF (FRAC_CHVBUF .LT. 0.0D0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,1P,D15.6,A)') 'FRAC_CHVBUF=',FRAC_CHVBUF,
     &                     ' resetting value to 0.0D0'
         END IF
         FRAC_CHVBUF = 0.0D0
      ELSE IF (FRAC_CHVBUF .GT. 0.9D0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,1P,D15.6,A)') 'FRAC_CHVBUF=',FRAC_CHVBUF,
     &                     ' resetting value to 0.9D0'
         END IF
         FRAC_CHVBUF = 0.9D0
      END IF

C     Threshold for discarding elements of initial diagonal.
C     ------------------------------------------------------

      IF (THRDIAG .GT. THRCOM) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,A,1P,D15.6)')
     &                     'Threshold for discarding initial diagonals',
     &                     ': ',THRDIAG
            WRITE(LUPRI,'(A,1P,D15.6)')
     &                     'is larger than decomposition threshold: ',
     &                     THRCOM
         END IF
         NCONFL = NCONFL + 1
      END IF

C     Damping factors.
C     ----------------

      IF (DAMP(1) .LT. 1.0D0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,1P,D15.6)')
     &      'First damping factor < 1: ',DAMP(1)
         END IF
         NCONFL = NCONFL + 1
      END IF
      IF (DAMP(2) .LT. 1.0D0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,1P,D15.6)')
     &      'Second damping factor < 1: ',DAMP(2)
         END IF
         NCONFL = NCONFL + 1
      END IF

C     Span factor.
C     ------------

      IF (SPAN .GT. 1.0D0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,1P,D15.6)') 'Span factor > 1: ',SPAN
         END IF
         NCONFL = NCONFL + 1
      ELSE IF (ABS(1.0D0-SPAN).lt.1.0d-4) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A)')
     &      'Span factor is too close to 1. Will use 0.9999 instead.'
         END IF
         SPAN=0.9999d0
      END IF

C     Max. #shell pairs allowed before proceeding to deco.
C     Max. #qualifieds allowed to proceed to decomposition.
C     Min. #qualifieds needed to proceed to decomposition.
C     -----------------------------------------------------

      NNN = NSHELL*(NSHELL + 1)/2
      IF (MXSHPR.LT.0 .OR. MXSHPR.GT.NNN) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,A,I8)') 'Max. #shell pairs allowed ',
     &                     'before proceeding to deco. is: ',MXSHPR
            WRITE(LUPRI,'(A)') 'Resetting generic: 0'
         END IF
         MXSHPR = 0
      END IF
      IF (MAXQUAL .LT. 1) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,A,I8)') 'Max. number of qualifieds is ',
     &                     'non-positive: ',MAXQUAL
            WRITE(LUPRI,'(A,A,I8)') 'Using instead: ',ABS(MAXQUAL)
         END IF
         MAXQUAL = ABS(MAXQUAL)
      END IF
      MMM = NSYM*MAXQUAL
      IF (MINQUAL.LT.1 .OR. MINQUAL.GT.MMM) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,A,I8)') 'Min. #qualified needed ',
     &                     'before proceeding to deco. is: ',MINQUAL
            WRITE(LUPRI,'(A,I8)') 'resetting to: ',MMM
         END IF
         MINQUAL = MMM
      END IF

C     Handling of negative diagonals.
C     -------------------------------

      INEGRR = 0
      IF (THRNEG .GT. 0.0D0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,1P,D15.6)')
     &                     'Threshold for zeroing neg. diag. > 0: ',
     &                     THRNEG
         END IF
         INEGRR = INEGRR + 1
         NCONFL = NCONFL + 1
      END IF
      IF (WARNEG .GT. 0.0D0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,A,1P,D15.6)')
     &                     'Threshold for warning about neg. diag. ',
     &                     ' > 0: ',WARNEG
         END IF
         INEGRR = INEGRR + 1
         NCONFL = NCONFL + 1
      END IF
      IF (TOONEG .GT. 0.0D0) THEN
         IF (REPORT) THEN
            WRITE(LUPRI,'(A,A,1P,D15.6)')
     &                      'Threshold for shutdown due to neg. diag. ',
     &                     ' > 0: ',TOONEG
         END IF
         INEGRR = INEGRR + 1
         NCONFL = NCONFL + 1
      END IF
      IF (INEGRR .EQ. 0) THEN
         IF (THRNEG .LT. WARNEG) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A,1P,D15.6,D15.6)')
     &                      'Threshold for zeroing neg. diag. > ',
     &                       'threshold for warning about neg. diag.: ',
     &                        THRNEG,WARNEG
            END IF
            NCONFL = NCONFL + 1
         END IF
         IF (WARNEG .LT. TOONEG) THEN
            IF (REPORT) THEN
               WRITE(LUPRI,'(A,A,1P,D15.6,D15.6)')
     &                     'Threshold for warning about neg. diag. > ',
     &                     'threshold for shutdown due to neg. diag.: ',
     &                     WARNEG,TOONEG
            END IF
            NCONFL = NCONFL + 1
         END IF
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine IJIJ(INTSYM,HDIAG,FIJIJ)

use mrci_global, only: IAD25S, IDVER, IRC, IROW, IVVER, LN, LSYM, Lu_25, Lu_27, LUSYMB, NSM, NVIR, NVIRT, NVPAIR, NVIRP, POTNUC
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: INTSYM(*)
real(kind=wp), intent(_OUT_) :: HDIAG(*)
real(kind=wp), intent(in) :: FIJIJ(*)
integer(kind=iwp) :: IAD27, IADD10, IADD25, ICHK, ICOUP, ICOUPS, IFS, II, IIJ, IIJ1, IIJ2, IJJ, INB, IND, INDI, INS, IOUT, IREF0, &
                     ITYP, IVL, IVSAVE, J, JJ, KK, LENGTH, NA, NA1, NA2, NB, NB1, NB2, NSA, NSS
real(kind=wp) :: HCOUT(nCOP), TERM
integer(kind=iwp), external :: JSUNP

!------
! POW: Unnecessary but warning stopping initializations
INB = -1234567
!------
IADD25 = IAD25S
IAD27 = 0
IREF0 = 1
call dDAFILE(Lu_27,2,HDIAG,IRC(1),IAD27)

!write(u6,*) ' Hdiag'
!write(u6,*) (Hdiag(i),i=1,IRC(1))

IFS = 0
IVL = 0
IVSAVE = 0
ICOUPS = 0
ICOUP = 0
NSS = 1
IOUT = 0
ICHK = 0
IADD10 = IAD10(3)
TERM = Zero
do
  ! READ A COP BUFFER:
  call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
  call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
  LENGTH = ICOP1(nCOP+1)
  if (LENGTH < 0) exit
  ! LOOP OVER THE COP BUFFER:
  do II=1,LENGTH
    IND = ICOP1(II)
    if (ICHK == 0) then
      if (IND == 0) then
        ICHK = 1
      else
        !ITYP = mod(IND,2)
        !IJJ = mod(IND/2,2**11)
        ITYP = ibits(IND,0,1)
        IJJ = ibits(IND,1,11)
        if (ITYP == 0) TERM = COP(II)*FIJIJ(IJJ)
        if (IVL == IVVER) then
          INB = ICOUP
          HDIAG(INB) = HDIAG(INB)+TERM
        else if (IVL == IDVER) then
          INB = 0
          NA1 = NVIRP(NSS)+1
          NA2 = NVIRP(NSS)+NVIR(NSS)
          do NA=NA1,NA2
            INB = INB+1
            if (ITYP == 1) then
              IIJ = IROW(LN+NA)+IJJ
              TERM = COP(II)*FIJIJ(IIJ)
            end if
            HDIAG(INB) = HDIAG(INB)+TERM
          end do
        else
          INB = 0
          do NA=1,NVIRT
            NSA = MUL(NSS,NSM(LN+NA))
            NB1 = NVIRP(NSA)+1
            NB2 = NVIRP(NSA)+NVIR(NSA)
            if (NB2 > NA) NB2 = NA
            if (NB2 < NB1) cycle
            IIJ1 = IROW(LN+NA)+IJJ
            do NB=NB1,NB2
              INB = INB+1
              if (ITYP == 1) then
                IIJ2 = IROW(LN+NB)+IJJ
                TERM = COP(II)*(FIJIJ(IIJ1)+FIJIJ(IIJ2))
              end if
              HDIAG(INB) = HDIAG(INB)+TERM
            end do
          end do
        end if
      end if
    else
      ICHK = 0
      INDI = IND
      !ICOUP = mod(INDI,2**16)
      !IVL = mod(INDI/2**16,2**8)
      ICOUP = ibits(INDI,0,16)
      IVL = ibits(INDI,16,8)
      ICHK = 0
      INS = 1
      if (IVSAVE == IVVER) then
        INS = ICOUPS
        INB = ICOUPS
      end if
      if (INB /= 0) then
        do J=INS,INB
          IOUT = IOUT+1
          HCOUT(IOUT) = HDIAG(J)
          if (IOUT < nCOP) cycle
          if (IFS == 0) then
            POTNUC = HCOUT(IREF0)
            IFS = 1
          end if
          do KK=1,nCOP
            HCOUT(KK) = HCOUT(KK)-POTNUC
          end do
          call dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
          IOUT = 0
        end do
      end if
      if (IVL /= IVVER) then
        JJ = IRC(IVL)+ICOUP
        NSS = MUL(JSUNP(INTSYM,JJ),LSYM)
        if (IVL == IDVER) then
          INB = NVIR(NSS)
        else
          INB = NVPAIR(NSS)
        end if
        if (INB > 0) call dDAFILE(Lu_27,2,HDIAG,INB,IAD27)
      end if
      IVSAVE = IVL
      ICOUPS = ICOUP
    end if
  end do
end do
! EMPTY LAST BUFFER
do J=1,INB
  IOUT = IOUT+1
  HCOUT(IOUT) = HDIAG(J)
  if (IOUT < nCOP) cycle
  if (IFS == 0) then
    POTNUC = HCOUT(IREF0)
    IFS = 1
  end if
  do KK=1,nCOP
    HCOUT(KK) = HCOUT(KK)-POTNUC
  end do
  call dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
  IOUT = 0
end do
if (IFS == 0) then
  POTNUC = HCOUT(IREF0)
  IFS = 1
end if
do KK=1,IOUT
  HCOUT(KK) = HCOUT(KK)-POTNUC
end do
call dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)

return

end subroutine IJIJ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine make_cvb(chr)

use casvb_global, only: charobj, i_dep_on_j, ioffs, iprint, mustdeclare, nobj, up2date
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: chr
integer(kind=iwp) :: i, iobj, mkobj
logical(kind=iwp) :: done

do
  iobj = 0
  do i=1,nobj
    if (charobj(i) == chr) iobj = i
  end do
  if (iobj /= 0) exit
  if (mustdeclare) then
    write(u6,*) ' Make object not found :',chr
    call abend_cvb()
  end if
  call decl_cvb(chr)
end do

! Make sure all "parent" objects are up-to-date:
do
  mkobj = iobj
  do
    done = .false.
    do i=ioffs(mkobj)+1,ioffs(mkobj+1)
      if (.not. up2date(i_dep_on_j(i))) then
        mkobj = i_dep_on_j(i)
        done = .true.
        exit
      end if
    end do
    if (.not. done) exit
  end do
  if (.not. up2date(mkobj)) then
    if (iprint >= 1) write(u6,'(/,a,i3,2a)') ' Making object no.',mkobj,', name : ',charobj(mkobj)
    call rules_cvb(charobj(mkobj))
    up2date(mkobj) = .true.
  end if
  if (mkobj == iobj) exit
end do

return

end subroutine make_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NATSPIN_RASSI(DMAT,TDMZZ,VNAT,OCC,EIGVEC)

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use rassi_aux, only: iDisk_TDM
use Cntrl, only: LuTDM, NrNATO, nState
use Symmetry_Info, only: nIrrep
use rassi_data, only: NBASF, NBMX, NBSQ, NBST, NBTRI, NTDMZZ
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: DMAT(NBSQ), TDMZZ(NTDMZZ), VNAT(NBSQ), OCC(NBST)
real(kind=wp), intent(in) :: EIGVEC(NSTATE,NSTATE)
integer(kind=iwp) :: I, I1, I2, ICMP, ID, ID1, ID2, IDISK, iDummy(7,8), IEMPTY, IGO, II, IJ, INV, IOCC, IOPT, IRC, ISCR, ISTOCC, &
                     ISYLAB, ISYM, J, JI, KEIG, LE, LE1, LS, LS1, LUXXVEC, LV, LV1, NB, NEIG, NSCR, NSZZ, NVEC, NVEC2
real(kind=wp) :: Dummy(1), SumOcc, X
character(len=14) :: FNAME
character(len=8) :: KNUM, LABEL
real(kind=wp), allocatable :: SZZ(:), VEC(:), VEC2(:), SCR(:), EIG(:)
integer(kind=iwp), external :: ISFREEUNIT
real(kind=wp), external :: DDOT_

! ALLOCATE WORKSPACE AREAS.
NSZZ = NBTRI
NVEC = NBSQ
NVEC2 = NBMX**2
NSCR = NBMX**2
NEIG = NBST
call mma_allocate(SZZ,NSZZ,Label='SZZ')
call mma_allocate(VEC,NVEC,Label='VEC')
call mma_allocate(VEC2,NVEC2,Label='VEC2')
call mma_allocate(SCR,NSCR,Label='SCR')
call mma_allocate(EIG,NEIG,Label='EIG')
! READ ORBITAL OVERLAP MATRIX.
IRC = -1
IOPT = ibset(ibset(0,sNoOri),sNoNuc)
ICMP = 1
ISYLAB = 1
LABEL = 'MLTPL  0'
call RDONE(IRC,IOPT,LABEL,ICMP,SZZ,ISYLAB)
if (IRC /= 0) then
  write(u6,*)
  write(u6,*) '      *** ERROR IN SUBROUTINE  NATSPIN ***'
  write(u6,*) '      OVERLAP INTEGRALS ARE NOT AVAILABLE'
  write(u6,*)
  call ABEND()
end if
! DIAGONALIZE EACH SYMMETRY BLOCK OF THE OVERLAP MATRIX.
LS = 1
LV = 1
LE = 1
do ISYM=1,nIrrep
  NB = NBASF(ISYM)
  call unitmat(VEC(LV:LV+NB**2-1),NB)
  call JACOB(SZZ(LS),VEC(LV),NB,NB)
  ! SCALE EACH VECTOR TO OBTAIN AN ORTHONORMAL BASIS.
  LS1 = LS
  LV1 = LV
  LE1 = LE
  do I=1,NB
    EIG(LE1) = SZZ(LS1)
    VEC(LV1:LV1+NB-1) = VEC(LV1:LV1+NB-1)/sqrt(max(SZZ(LS1),1.0e-14_wp))
    LS1 = LS1+I+1
    LV1 = LV1+NB
    LE1 = LE1+1
  end do
  LS = LS+nTri_Elem(NB)
  LV = LV+NB**2
  LE = LE+NB
end do
call mma_deallocate(SZZ)

! VERY LONG LOOP OVER EIGENSTATES KEIG.
do KEIG=1,NRNATO

  DMAT(:) = Zero
  ! DOUBLE LOOP OVER RASSCF WAVE FUNCTIONS, TRIANGULAR.
  do I=1,NSTATE
    do J=1,I
      ! WEIGHT WITH WHICH THIS TDM CONTRIBUTES IS EIGVEC(I,KEIG)*EIGVEC(J,KEIG).
      ! HOWEVER, WE ARE LOOPING TRIANGULARLY AND WILL RESTORE SYMMETRY BY
      ! ADDING TRANSPOSE AFTER DMAT HAS BEEN FINISHED, SO I=J IS SPECIAL CASE:
      X = EIGVEC(I,KEIG)*EIGVEC(J,KEIG)
      if (abs(X) > 1.0e-12_wp) then
        iDisk = iDisk_TDM(J,I,1)
        iEmpty = iDisk_TDM(J,I,2)
        if (btest(iEmpty,1)) then
          iDisk = iDisk_TDM(J,I,1)
          iOpt = 2
          iGo = ibset(0,1)
          ! PICK UP TRANSITION SPIN DENSITY MATRIX FOR THIS PAIR OF RASSCF STATES:
          call dens2file(Dummy,TDMZZ,Dummy,nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,I,J)
          if (I == J) X = Half*X
          DMAT(1:NTDMZZ) = DMAT(1:NTDMZZ)+X*TDMZZ(:)
        end if
      end if
    end do
  end do
  ! LOOP OVER SYMMETRY BLOCKS OF DMAT.
  ID = 1
  INV = 1
  IOCC = 0
  LV = 1
  LE = 1
  do ISYM=1,nIrrep
    NB = NBASF(ISYM)
    ! TRANSFORM TO ORTHONORMAL BASIS. THIS REQUIRES THE CONJUGATE
    ! BASIS, BUT SINCE WE USE CANONICAL ON BASIS THIS AMOUNTS TO A
    ! SCALING WITH THE EIGENVECTORS OF THE OVERLAP MATRIX:
    call DGEMM_('N','N',NB,NB,NB,One,DMAT(ID),NB,VEC(LV),NB,Zero,SCR,NB)
    call DGEMM_('T','N',NB,NB,NB,One,VEC(LV),NB,SCR,NB,Zero,DMAT(ID),NB)
    ID1 = ID
    ID2 = ID
    do I=1,NB
      call DSCAL_(NB,EIG(LE-1+I),DMAT(ID1),NB)
      DMAT(ID2:ID2+NB-1) = EIG(LE-1+I)*DMAT(ID2:ID2+NB-1)
      ID1 = ID1+1
      ID2 = ID2+NB
    end do
    ! SYMMETRIZE THIS BLOCK INTO SCRATCH AREA, TRIANGULAR STORAGE:
    ISCR = 1
    do I=1,NB
      do J=1,I
        IJ = I+NB*(J-1)
        JI = J+NB*(I-1)
        SCR(ISCR) = DMAT(ID-1+IJ)+DMAT(ID-1+JI)
        ISCR = ISCR+1
      end do
    end do
    ! DIAGONALIZE THE DENSITY MATRIX BLOCK:
    call unitmat(VEC2,NB)
    call JACOB(SCR,VEC2,NB,NB)
    call JACORD(SCR,VEC2,NB,NB)
    ! JACORD ORDERS BY INCREASING EIGENVALUE. REVERSE THIS ORDER.
    II = 0
    do I=1,NB
      II = II+I
      OCC(IOCC+NB+1-I) = SCR(II)
    end do
    IOCC = IOCC+NB
    ! REEXPRESS THE EIGENVECTORS IN AO BASIS FUNCTIONS. REVERSE ORDER.
    call DGEMM_('N','N',NB,NB,NB,One,VEC(LV),NB,VEC2,NB,Zero,SCR,NB)
    I1 = 1
    I2 = INV+NB**2
    do I=1,NB
      I2 = I2-NB
      VNAT(I2:I2+NB-1) = SCR(I1:I1+NB-1)
      I1 = I1+NB
    end do
    ID = ID+NB**2
    INV = INV+NB**2
    LV = LV+NB**2
    LE = LE+NB
  end do

  ! WRITE OUT THIS SET OF NATURAL SPIN ORBITALS. THE FILES WILL BE NAMED
  ! SSORB.1, SSORB.2, ...

  write(KNUM,'(I8)') KEIG
  KNUM = adjustl(KNUM)
  FNAME = 'SSORB.'//KNUM
  write(u6,'(A,I2)') ' NATURAL SPIN ORBITALS FOR EIGENSTATE NR ',KEIG
  write(u6,'(A,A)') ' ORBITALS ARE WRITTEN ONTO FILE ID = ',FNAME
  write(u6,'(A)') ' OCCUPATION NUMBERS:'
  ISTOCC = 0
  do I=1,nIrrep
    NB = NBASF(I)
    if (NB /= 0) then
      write(u6,'(A,I2)') ' SYMMETRY SPECIES:',I
      write(u6,'(1X,10F8.5)') (OCC(ISTOCC+J),J=1,NB)
    end if
    ISTOCC = ISTOCC+NB
  end do
  LuxxVec = isfreeunit(50)
  call WRVEC(FNAME,LUXXVEC,'CO',nIrrep,NBASF,NBASF,VNAT,OCC,Dummy,iDummy,'* NATURAL SPIN ORBITALS FROM RASSI EIGENSTATE NR '// &
             trim(KNUM))
  SUMOCC = DDOT_(sum(NBASF),OCC,1,OCC,1)
  call ADD_INFO('NATSPIN',[SUMOCC],1,5)

  ! End of very long loop over eigenstates KEIG.
end do

write(u6,*) repeat('*',80)
call mma_deallocate(VEC)
call mma_deallocate(VEC2)
call mma_deallocate(SCR)
call mma_deallocate(EIG)

end subroutine NATSPIN_RASSI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
*               Ajitha Devarajan                                       *
************************************************************************
      Subroutine DFT_IntX(Do_NInt_d,Do_NInt,
     &                    Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
     &                    FckInt,nFckInt,SOTemp,nSOTemp,
     &                    TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
     &                    nSym,iSpin,Flop,Rho,nRho,Scr,nScr,
     &                    Fact,ndc,mAO,TabAOMax,T_X,list_bas,nFn)
************************************************************************
*                                                                      *
* Object: to compute contributions to                                  *
*                                                                      *
*         <m|dF/drho|n> ; integrals over the potential                 *
*                                                                      *
*         where                                                        *
*                                                                      *
*         F(r)=rho(r)*e(rho(r),grad[rho(r)])                           *
*                                                                      *
*      Author:Roland Lindh, Department of Chemical Physics, University *
*             of Lund, SWEDEN. November 2000                           *
*             D.Ajitha:Modifying for the new Kernel outputs            *
************************************************************************
      use iSD_data
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Do_NInt_d, Do_NInt
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "debug.fh"
#include "nsd.fh"
#include "setup.fh"
      Real*8 Weights(mGrid), SOTemp(nSOTemp,iSpin), Fact(ndc**2),
     &       TabAO(nTabAO), Scr(nScr*mGrid), Rho(nRho,mGrid),
     &       AOInt(nAOInt*nAOInt,iSpin), FckInt(nFckInt,iSpin),
     &       dF_dRho(ndF_dRho,mGrid), TabAOMax(nlist_s)
      Integer nOp(2), list_s(2,nlist_s), ipTabAO(nlist_s),
     &        list_bas(2,nlist_s)
*                                                                      *
************************************************************************
*                                                                      *
*---- Evaluate the desired AO integrand here from the AOs, accumulate
*     contributions to the SO integrals on the fly.
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Debug=.True.
#endif
      VMax=0.0D0
      iSmLbl=1
*
      nGrid_Tot=0
      Do ilist_s=1,nlist_s
         iSkal = list_s(1,ilist_s)
         TMax_i=TabAOMax(ilist_s)
         If (TMax_i.le.T_X) Go To 999
         kDCRE = list_s(2,ilist_s)
         iShll = iSD( 0,iSkal)
         iAng  = iSD( 1,iSkal)
         iCmp  = iSD( 2,iSkal)
         iBas  = iSD( 3,iSkal)
         iBas_Eff=list_bas(1,ilist_s)
         iAO   = iSD( 7,iSkal)
         mdci  = iSD(10,iSkal)
         iShell= iSD(11,iSkal)
*
         nOp(1) = NrOpr(kDCRE)
*
         Do jlist_s=ilist_s,nlist_s
            jSkal = list_s(1,jlist_s)
            TMax_j=TabAOMax(jlist_s)
            If (TMax_j.le.T_X) Go To 998
            kDCRR = list_s(2,jlist_s)
            jShll = iSD( 0,jSkal)
            jAng  = iSD( 1,jSkal)
            jCmp  = iSD( 2,jSkal)
            jBas  = iSD( 3,jSkal)
            jBas_Eff=list_bas(1,jlist_s)
            jAO   = iSD( 7,jSkal)
            mdcj  = iSD(10,jSkal)
            jShell= iSD(11,jSkal)
*
            nOp(2) = NrOpr(kDCRR)
*
            nSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
*
            ij = (mdcj-1)*ndc + mdci
*                                                                      *
************************************************************************
*                                                                      *
            If (ilist_s.eq.jlist_s) Then
               Call Do_NInt_d(AOInt,nAOInt,ndF_dRho, dF_dRho,
     &                        Weights,mGrid,Rho,nRho,
     &                        Scr, TabAO(ipTabAO(iList_s)),iCmp,
     &                        iBas_Eff,nGrid_Tot,iSpin,mAO,nFn)
               jx = iDAMax_(iSpin*mAO*mGrid*iBas_Eff*iCmp,Scr,1)
               VMax=Abs(Scr(jx))
            Else
               If (VMax*TMax_j.le.T_X) Go To 998
               Call Do_NInt(AOInt,nAOInt,mGrid,
     &                      Scr,iCmp,iBas_Eff,
     &                      TabAO(ipTabAO(jList_s)),jCmp,jBas_Eff,
     &                      nGrid_Tot,iSpin,mAO,nFn)
            End If
*
            Do iD = 1, iSpin
*
#ifdef _DEBUGPRINT_
               If (Debug) Then
                  nAOInt_j=jBas_Eff*jCmp
                  nAOInt_i=iBas_Eff*iCmp
                  mAOInt=nAOInt_i*nAOInt_j
                  Call RecPrt('Kernel: AOInt',' ',AOInt(1,iD),1,mAOInt)
               End If
#endif
               If (nIrrep.ne.1) Then
*
*---------------- Distribute contributions to the SO integrals
*
                  nIC = 1
                  iIC = 1
                  Call FZero(SOTemp(1,iD),iBas*jBas*nSO)
                  Call SymAdd2(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                         iShell,jShell,iShll,jShll,
     &                         iAO,jAO,AOInt(1,iD),
     &                         iBas,iBas_Eff,jBas,jBas_Eff,
     &                         nIC,iIC,SOTemp(1,iD),nSO,nOp,
     &                         iSkal,jSkal)
*
*---------------- Here scatter the result
*
                  If (Fact(ij).ne.One)
     &               Call DScal_(nSO*iBas*jBas,Fact(ij),SOTemp(1,iD),1)
*
                  Call SOAdd(SOTemp(1,iD),iBas,jBas,nSO,
     &                       FckInt(1,iD),nFckInt,iSmLbl,
     &                       iCmp,jCmp,iShell,jShell,
     &                       iSkal.eq.jSkal,iAO,jAO)
*
               Else
*
                  Call AOAdd_nq(AOInt(1,iD),iBas,iBas_Eff,jBas,jBas_Eff,
     &                          FckInt(1,iD),nFckInt,
     &                          iCmp,jCmp,iShell,jShell,iAO,jAO)

*
               End If
*
            End Do                  ! iD
*                                                                      *
************************************************************************
*                                                                      *
*
 998        Continue
         End Do                     ! jlist_s
 999     Continue
      End Do                        ! ilist_s
      Flop=Flop+DBLE(nGrid_Tot)
*
#ifdef _DEBUGPRINT_
      Debug=.False.
#endif
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(nSym)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine ConMax(A,nPrim,mPrim,B,nCont,C,mCont)
************************************************************************
*                                                                      *
* Object: to find the largest element in the contraction matrix  for   *
*         each primitive index.                                        *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             July '91                                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 A(nPrim,mPrim), B(nPrim,nCont), C(mPrim,mCont)
#include "print.fh"
#include "real.fh"
*
      Do iPrim = 1, nPrim
         Temp= Zero
*        Do iCont = 1, nCont
*           If (Abs(B(iPrim,iCont)).gt.Temp)
*    &         Temp = Abs(B(iPrim,iCont))
*        End Do
         Temp=DDot_(nCont,B(iPrim,1),nPrim,B(iPrim,1),nPrim)
         Do jPrim = 1, mPrim
            A(iPrim,jPrim) = Temp
         End Do
      End Do
*
      Do jPrim = 1, mPrim
*        Temp = Zero
*        Do jCont = 1, mCont
*           If (Abs(C(jPrim,jCont)).gt.Temp)
*    &         Temp = Abs(C(jPrim,jCont))
*        End Do
         Temp=DDot_(mCont,C(jPrim,1),mPrim,C(jPrim,1),mPrim)
         Do iPrim = 1, nPrim
*           A(iPrim,jPrim) = A(iPrim,jPrim)*Temp
            A(iPrim,jPrim) = Sqrt(A(iPrim,jPrim)*Temp)
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Subroutine with purpose to initialize and set defaults for the input section.
subroutine Qmstat_Init()

use qmstat_global, only: Anal, ATitle, ChargedQM, Cordst, Cut_Elc, Cut_Ex1, Cut_Ex2, DelFi, DelOrAdd, DelR, DelX, Diel, DifSlExp, &
                         Disp, DispDamp, dLJRep, EdSt, EigV, EneLim, Exdt1, Exdtal, Exrep10, Exrep2, Exrep4, Exrep6, FieldDamp, &
                         FieldNuc, Forcek, iExtr_Atm, iExtra, iLuSaIn, iLuSaUt, iLuStIn, iLuStUt, iNrIn, iNrUt, iOrb, iPrint, &
                         iRead, iSeed, itMax, lCiSelect, lExtr, lMltSlC, lQuad, lSlater, MoAveRed, Mp2DensCorr, MxPut, nAtom, &
                         nCent, nCha, nEqState, nLvlShift, nMacro, nMicro, nPart, nPol, nSlSiteC, ParallelT, Pol, PolLim, Pres, &
                         Qmeq, QmProd, Qsta, RassiM, rStart, SaFilIn, SaFilUt, Sexre1, Sexre2, Sexrep, SimEx, SlExpC, SlFactC, &
                         SlPC, StFilIn, StFilUt, Surf, Temp
use stdalloc, only: mma_allocate
use Constants, only: Zero, One, Six, Ten, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i, j

!IO_stuff
StFilIn = 'STFIL0'
SaFilIn = 'SAFIL0'
StFilUt = 'STFIL0'
SaFilUt = 'SAFIL0'
SimEx = 'EXTRA0'
!Jose: File for the optimization procedure
FieldNuc = 'AVENUC'
RassiM = 'RASSIM'
EigV = 'EIGV'
iNrIn = -1
iNrUt = 0
iLuStIn = 8+iNrIn
iLuStUt = 16+iNrUt
iLuSaIn = 24+iNrIn
iLuSaUt = 32+iNrUt
iRead = 0
! Defaults
nEqState = 1
Cut_Ex1 = Ten
Cut_Ex2 = Zero
DelX = Zero
DelFi = Zero
DelR = Zero
Temp = 300.0_wp
call GetSeed(ISEED)
iPrint = 1
NMACRO = 1
NMICRO = 1
RSTART = 80.0_wp
NPART = 0
nAtom = 3
NCENT = 5
NPOL = 3
NCHA = 4
!Jose.Slater Penetration
nSlSiteC = 5
lMltSlC = 0
!****
nLvlShift = 0
call mma_allocate(iExtr_Atm,0,label='iExtr_Atm')
call mma_allocate(Qsta,NCHA,label='Qsta')
QSTA(1) = 0.5836_wp
QSTA(2) = 0.5836_wp
QSTA(3) = -0.5836_wp
QSTA(4) = -0.5836_wp
call mma_allocate(Pol,NPOL,label='Pol')
POL(1) = 5.932_wp
POL(2) = 0.641_wp
POL(3) = 0.641_wp
!Jose.Slater Penetration
Cut_Elc = Six
DifSlExp = 1.0e-3_wp

call mma_allocate(SlFactC,4,nSlSiteC,label='SlFactC')
SlFactC(1,1) = -Half
SlFactC(1,2) = -0.4164_wp
SlFactC(1,3) = -0.4164_wp
SlFactC(1,4) = -0.5836_wp
SlFactC(1,5) = -0.5836_wp
SlFactC(2:4,:) = Zero
call mma_allocate(SlExpC,2,nSlSiteC,label='SlExpC')
SlExpC(1,1) = 2.5552_wp
SlExpC(1,2) = 2.6085_wp
SlExpC(1,3) = 2.6085_wp
SlExpC(1,4) = 2.5552_wp
SlExpC(1,5) = 2.5552_wp
SlExpC(2,:) = Zero
call mma_allocate(SlPC,nSlSiteC,label='SlPC')
SlPC(1) = Half
SlPC(2) = One
SlPC(3) = One
SlPC(4) = Zero
SlPC(5) = Zero
!******************************
Exrep2 = Zero
Exrep4 = Zero
Exrep6 = Zero
Exrep10 = Zero
call mma_allocate(sExRep,nAtom,nAtom,label='sExRep')
call mma_allocate(sExRe1,nAtom,nAtom,label='sExRe1')
call mma_allocate(sExRe2,nAtom,nAtom,label='sExRe2')
sExRep(1,1) = 2.092338_wp
sExRe1(1,1) = 158.998_wp
sExRe2(1,1) = 4.66009e10_wp
sExRep(2,1) = 2.112447_wp
sExRe1(2,1) = 8.31922_wp
sExRe2(2,1) = 97560.62_wp
sExRep(2,2) = 1.075803_wp
sExRe1(2,2) = 0.06521_wp
sExRe2(2,2) = 1121941276.0_wp
sExRep(3,1) = 2.112447_wp
sExRe1(3,1) = 8.31922_wp
sExRe2(3,1) = 97560.62_wp
sExRep(3,2) = 1.075803_wp
sExRe1(3,2) = 0.06521_wp
sExRe2(3,2) = 1121941276.0_wp
sExRep(3,3) = 1.075803_wp
sExRe1(3,3) = 0.06521_wp
sExRe2(3,3) = 1121941276.0_wp
do I=1,NATOM
  do J=1,I
    SEXREP(J,I) = SEXREP(I,J)
    SEXRE1(J,I) = SEXRE1(I,J)
    SEXRE2(J,I) = SEXRE2(I,J)
  end do
end do
call mma_allocate(Disp,NPOL,NPOL,label='Disp')
Disp(1,1) = 11.338_wp
Disp(2,1) = 3.38283_wp
Disp(2,2) = 0.627068_wp
Disp(3,1) = 3.38283_wp
Disp(3,2) = 0.627068_wp
Disp(3,3) = 0.627068_wp
do I=1,NPOL
  do J=1,I
    DISP(J,I) = DISP(I,J)
  end do
end do
call mma_allocate(Cordst,3,MxPut*nCent,label='Cordst')
CORDST(1,1) = Zero
CORDST(1,2) = Zero
CORDST(1,3) = Zero
CORDST(1,4) = 0.3126_wp
CORDST(1,5) = -0.3126_wp
CORDST(2,1) = Zero
CORDST(2,2) = 1.43_wp
CORDST(2,3) = -1.43_wp
CORDST(2,4) = Zero
CORDST(2,5) = Zero
CORDST(3,1) = 0.3_wp
CORDST(3,2) = -0.807_wp
CORDST(3,3) = -0.807_wp
CORDST(3,4) = -0.1191_wp
CORDST(3,5) = -0.1191_wp
ForceK = 1.0e-3_wp
dLJrep = Zero
Pres = One
PolLim = 1.0e-4_wp
EneLim = 1.0e-7_wp
itMax = 30
Exdtal = 30.0_wp
Exdt1 = 0.06_wp
Surf = 30.0_wp
iOrb(2) = 5
Diel = 80.0_wp
iExtra = 0
Qmeq = .false.
FieldDamp = .false.
DispDamp = .false.
QmProd = .false.
ChargedQM = .false.
ATitle = .false.
Anal = .false.
ParallelT = .false.
Mp2DensCorr = .false.
MoAveRed = .false.
lCiSelect = .false.
EdSt = .false.
DelOrAdd(:) = .false.
lExtr(:) = .false.
lSlater = .true.
lQuad = .false.

return

end subroutine Qmstat_Init

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine pvb_2_cvb(cfrom,cto,csk,
     >  iapr,ixapr,mult)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension cfrom(nda,ndb),cto(nda,ndb),csk(ndetvb)
      dimension iapr(ndetvb),ixapr(nda+1)

      if(mult.eq.-1)then
        idetvb=0
        do 50 ia=1,nda
        do 51 ixa=ixapr(ia),ixapr(ia+1)-1
        idetvb=idetvb+1
        ib=iapr(ixa)
        csk(idetvb)=cfrom(ia,ib)
51      continue
50      continue
      elseif(mult.eq.0)then
        call fzero(cto,nda*ndb)
        idetvb=0
        do 100 ia=1,nda
        do 101 ixa=ixapr(ia),ixapr(ia+1)-1
        idetvb=idetvb+1
        ib=iapr(ixa)
        cto(ia,ib)=cfrom(ia,ib)
        csk(idetvb)=cfrom(ia,ib)
101     continue
100     continue
      elseif(mult.eq.1)then
        csk(1)=zero
        do 200 ia=1,nda
        do 201 ixa=ixapr(ia),ixapr(ia+1)-1
        csk(1)=csk(1)+cto(ia,iapr(ixa))*cfrom(ia,iapr(ixa))
201     continue
200     continue
      elseif(mult.eq.2)then
        call fzero(cto,nda*ndb)
        idetvb=0
        do 300 ia=1,nda
        do 301 ixa=ixapr(ia),ixapr(ia+1)-1
        idetvb=idetvb+1
        ib=iapr(ixa)
        cto(ia,ib)=csk(idetvb)
301     continue
300     continue
      elseif(mult.eq.3)then
        csk(1)=zero
        idetvb=0
        do 400 ia=1,nda
        do 401 ixa=ixapr(ia),ixapr(ia+1)-1
        idetvb=idetvb+1
c CFROM is really CDETVB
        csk(1)=csk(1)+cto(ia,iapr(ixa))*cfrom(idetvb,1)
401     continue
400     continue
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_WrDiag()
C
C     Purpose: store global diagonal on disk (Parallel only).
C              NB: on exit, initial global diagonal is stored!
C
      use ChoSwp, only: Diag_G
      Implicit None
#include "cholesky.fh"
#include "choglob.fh"
#include "cho_para_info.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: Diag_L(:)

      If (Cho_Real_Par) Then
         Call mma_allocate(Diag_L,nnBstRT(1),Label='Diag_L')
         Call Cho_IODiag(Diag_L,2)
         Call Cho_P_SyncDiag(Diag_L,1)
         Call Cho_P_IndxSwp()
         Call Cho_IODiag(Diag_G,1)
         Call Cho_P_IndxSwp()
         Call mma_deallocate(Diag_L)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Denis Jelovina                                   *
!***********************************************************************

#include "compiler_features.h"
#ifdef _MOLCAS_MPP_

! if act="C" checks if array x(N) is identical across processes
!            returns stat=.true. if data are identical
!            oterwise returns stat=.false.
!            value of stat is rank-independent
! if act="S" copy data from master to all processes

subroutine check_parallel_data(x,n,stat,act)

use Para_Info, only: MyRank, nProcs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: x(n)
logical(kind=iwp), intent(out) :: stat
character, intent(in) :: act
integer(kind=iwp) :: irank, k, this
real(kind=wp), allocatable :: x_prll(:,:)

stat = .true.
if (nProcs == 1) return

call mma_allocate(x_prll,n,nProcs,label='x_prll')
x_prll(:,:) = Zero

this = MyRank+1
x_prll(:,this) = x
call GADsum(x_prll,n*nProcs)

if (act == 'C') then
  do irank=1,nProcs
    ! comparing MyRank vs rank irank
    if (irank == this) cycle
    do k=1,n
      if (x_prll(k,irank) /= x_prll(k,this)) then
        stat = .false.
        exit
      end if
    end do
  end do

else if (act == 'S') then
  ! copy data from master to MyRank
  if (this /= 1) x(:) = x_prll(:,1)

else
  write(u6,*) 'check_parallel_data(), illegal value:'
  write(u6,*) 'act=',act
  write(u6,*) 'correct function call!!'
  call abort()
end if

call mma_deallocate(x_prll)

return

end subroutine check_parallel_data

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(check_parallel_data)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#include "molcastypes.fh"
#define MH5_MAX_LBL_LEN 256

*     create a HDF5 file and return a handle to it
      function mh5_create_file (filename) result(lu)
      use iso_c_binding
      implicit none
      character(len=*) :: filename
      integer :: lu
      interface
        function mh5c_create_file(filename) result(lu)
     &   bind(C, name='mh5c_create_file')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT) :: lu
        character(kind=C_CHAR) :: filename(*)
        end function
      end interface
      integer :: lrealname
      character(len=4096) :: realname
      call prgmtranslate(filename, realname, lrealname)
      realname(lrealname+1:lrealname+1)=C_NULL_CHAR
      lu = mh5c_create_file(realname)
      end function

      function mh5_open_file_rw (filename) result (lu)
      use iso_c_binding
      implicit none
      character(len=*) :: filename
      integer :: lu
      interface
        function mh5c_open_rw(filename) result(lu)
     &   bind(C, name='mh5c_open_file_rw')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT) :: lu
        character(kind=C_CHAR) :: filename(*)
        end function
      end interface
      integer :: lrealname
      character(len=4096) :: realname
      call prgmtranslate(filename, realname, lrealname)
      realname(lrealname+1:lrealname+1)=C_NULL_CHAR
      lu = mh5c_open_rw(realname)
      end function

      function mh5_open_file_r (filename) result (lu)
      use iso_c_binding
      implicit none
      character(len=*) :: filename
      integer :: lu
      interface
        function mh5c_open_r(filename) result(lu)
     &   bind(C, name='mh5c_open_file_r')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT) :: lu
        character(kind=C_CHAR) :: filename(*)
        end function
      end interface
      integer :: lrealname
      character(len=4096) :: realname
      call prgmtranslate(filename, realname, lrealname)
      realname(lrealname+1:lrealname+1)=C_NULL_CHAR
      lu = mh5c_open_r(realname)
      end function

      subroutine mh5_close_file (lu)
      use iso_c_binding
      implicit none
      integer :: lu
      interface
        function mh5c_close_file(lu) result(ierr)
     &   bind(C, name='mh5c_close_file')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      integer :: ierr
      ierr = mh5c_close_file(lu)
      end subroutine

*     check if a file is in the HDF5 format
      logical function mh5_is_hdf5 (filename)
      use iso_c_binding
      implicit none
      character(len=*) :: filename
      interface
        function mh5c_is_hdf5(filename) result (rc)
     &   bind(C, name='mh5c_is_hdf5')
        use iso_c_binding
        implicit none
        character(kind=c_char) :: filename(*)
        integer(MOLCAS_C_INT) :: rc
        end function
      end interface
      integer :: rc
      integer :: lrealname
      character(len=4096) :: realname
      logical :: exists
      call prgmtranslate(filename, realname, lrealname)
      call f_inquire(realname,exists)
      if (exists) then
        realname(lrealname+1:lrealname+1)=C_NULL_CHAR
        rc = mh5c_is_hdf5(realname)
      else
        rc = 0
      end if
      if      (rc > 0) then
        mh5_is_hdf5 = .true.
      else if (rc == 0) then
        mh5_is_hdf5 = .false.
      else
        mh5_is_hdf5 = .false.
        call abend
      end if
      end function

*     check for existence of dataset/attribute by id,
*     where id could be a file or dataset id.
      logical function mh5_exists_dset (id, name)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: id
      character(len=*) :: name
      interface
        function mh5c_exists_dset(id, name) result (rc)
     &   bind(C, name='mh5c_exists_dset')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        character(len=c_char) :: name(*)
        integer(MOLCAS_C_INT) :: rc
        end function
      end interface
      integer :: rc
      call f2c_upcase(name,mh5_lbl)
      rc = mh5c_exists_dset(id, mh5_lbl)
      if      (rc > 0) then
        mh5_exists_dset = .true.
      else if (rc == 0) then
        mh5_exists_dset = .false.
      else
        mh5_exists_dset = .false.
        call abend
      end if
      end function

      logical function mh5_exists_attr (id, name)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: id
      character(len=*) :: name
      interface
        function mh5c_exists_attr(id, name) result (rc)
     &   bind(C, name='mh5c_exists_attr')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT) :: rc
        end function
      end interface
      integer :: rc
      call f2c_upcase(name,mh5_lbl)
      rc = mh5c_exists_attr(id, mh5_lbl)
      if      (rc > 0) then
        mh5_exists_attr = .true.
      else if (rc == 0) then
        mh5_exists_attr = .false.
      else
        mh5_exists_attr = .false.
        call abend
      end if
      end function
*     open/close dataset

      function mh5_open_dset (lu, dsetname) result(dsetid)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: lu
      character(len=*) :: dsetname
      integer :: dsetid
      interface
        function mh5c_open_dset(lu, dsetname) result(dsetid)
     &   bind(C, name='mh5c_open_dset')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT) :: dsetid
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: dsetname(*)
        end function
      end interface

      call f2c_upcase(dsetname,mh5_lbl)
      dsetid = mh5c_open_dset(lu,mh5_lbl)
      end function

      subroutine mh5_close_dset (dsetid)
      use iso_c_binding
      implicit none
      integer :: dsetid
      interface
        function mh5c_close_dset(dsetid) result(ierr)
     &   bind(C, name='mh5c_close_dset')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dsetid
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      if (mh5c_close_dset(dsetid) < 0) call abend
      end subroutine

      function mh5_open_attr (lu, attrname) result(attrid)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: lu
      character(len=*) :: attrname
      integer :: attrid
      interface
        function mh5c_open_attr(lu, attrname) result(attrid)
     &   bind(C, name='mh5c_open_attr')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT) :: attrid
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: attrname(*)
        end function
      end interface

      call f2c_upcase(attrname,mh5_lbl)
      attrid = mh5c_open_attr(lu,mh5_lbl)
      end function

      subroutine mh5_close_attr (attrid)
      use iso_c_binding
      implicit none
      integer :: attrid
      interface
        function mh5c_close_attr(attrid) result(ierr)
     &   bind(C, name='mh5c_close_attr')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: attrid
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      if (mh5c_close_attr(attrid) < 0) call abend
      end subroutine

*======================
*     ATTRIBUTES
*======================

      function mh5_create_attr_scalar_int (lu, name) result (dset_id)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: lu
      character(len=*) :: name
      integer :: dset_id
      interface
        function mh5c_create_attr_scalar_int(lu, name) result (dset_id)
     &   bind(C, name='mh5c_create_attr_scalar_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT) :: dset_id
        end function
      end interface

      call f2c_upcase(name,mh5_lbl)
      dset_id = mh5c_create_attr_scalar_int(lu, mh5_lbl)
      end function

      function mh5_create_attr_scalar_real (lu, name) result (dset_id)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: lu
      character(len=*) :: name
      integer :: dset_id
      interface
        function mh5c_create_attr_scalar_real(lu, name) result (dset_id)
     &   bind(C, name='mh5c_create_attr_scalar_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT) :: dset_id
        end function
      end interface

      call f2c_upcase(name,mh5_lbl)
      dset_id = mh5c_create_attr_scalar_real(lu, mh5_lbl)
      end function

      function mh5_create_attr_scalar_str (lu, name, size)
     &        result (dset_id)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: lu
      character(len=*) :: name
      integer :: size
      integer :: dset_id
      interface
        function mh5c_create_attr_scalar_str(lu, name, size)
     &          result (dset_id)
     &          bind(C, name='mh5c_create_attr_scalar_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: size
        integer(MOLCAS_C_INT) :: dset_id
        end function
      end interface

      call f2c_upcase(name,mh5_lbl)
      dset_id = mh5c_create_attr_scalar_str(lu, mh5_lbl, size)
      end function

      subroutine mh5_put_attr_scalar_int (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      integer :: value
      integer :: ierr
      interface
        function mh5c_put_attr_scalar_int(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_put_attr_scalar_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        integer(MOLCAS_C_INT) :: value
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_put_attr_scalar_int(dset_id, value)
      end subroutine

      subroutine mh5_put_attr_scalar_real (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      real*8 :: value
      integer :: ierr
      interface
        function mh5c_put_attr_scalar_real(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_put_attr_scalar_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        real(MOLCAS_C_REAL) :: value
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_put_attr_scalar_real(dset_id, value)
      end subroutine

      subroutine mh5_put_attr_scalar_str (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      character(len=*) :: value
      integer :: ierr
      interface
        function mh5c_put_attr_scalar_str(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_put_attr_scalar_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        character(kind=c_char) :: value(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_put_attr_scalar_str(dset_id, value)
      end subroutine


      subroutine mh5_get_attr_scalar_int (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      integer :: value
      integer :: ierr
      interface
        function mh5c_get_attr_scalar_int(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_get_attr_scalar_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        integer(MOLCAS_C_INT) :: value
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_attr_scalar_int(dset_id, value)
      end subroutine

      subroutine mh5_get_attr_scalar_real (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      real*8 :: value
      integer :: ierr
      interface
        function mh5c_get_attr_scalar_real(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_get_attr_scalar_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        real(MOLCAS_C_REAL) :: value
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_attr_scalar_real(dset_id, value)
      end subroutine

      subroutine mh5_get_attr_scalar_str (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      character(len=*) :: value
      integer :: ierr
      interface
        function mh5c_get_attr_scalar_str(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_get_attr_scalar_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        character(kind=c_char) :: value(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_attr_scalar_str(dset_id, value)
      end subroutine

      function mh5_create_attr_array_int (lu, name, rank, dims)
     &        result(attr_id)
      use iso_c_binding
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      integer :: attr_id
      interface
        function mh5c_create_attr_array_int(lu, name, rank, dims)
     &   result(ierr) bind(C, name='mh5c_create_attr_array_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: rank
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl

      call f2c_upcase(name,mh5_lbl)
      attr_id = mh5c_create_attr_array_int(lu, mh5_lbl, rank, dims)
      end function

      function mh5_create_attr_array_real (lu, name, rank, dims)
     &        result(attr_id)
      use iso_c_binding
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      integer :: attr_id
      interface
        function mh5c_create_attr_array_real(lu, name, rank, dims)
     &   result(ierr) bind(C, name='mh5c_create_attr_array_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: rank
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl

      call f2c_upcase(name,mh5_lbl)
      attr_id = mh5c_create_attr_array_real(lu, mh5_lbl, rank, dims)
      end function

      function mh5_create_attr_array_str (lu, name, rank, dims, size)
     &        result(attr_id)
      use iso_c_binding
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      integer :: size
      integer :: attr_id
      interface
        function mh5c_create_attr_array_str(lu, name, rank, dims, size)
     &   result(ierr) bind(C, name='mh5c_create_attr_array_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: rank
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT), VALUE :: size
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl

      call f2c_upcase(name,mh5_lbl)
      attr_id = mh5c_create_attr_array_str(
     &        lu, mh5_lbl, rank, dims, size)
      end function


      subroutine mh5_put_attr_array_int (attr_id, buffer)
      use iso_c_binding
      implicit none
      integer :: attr_id
      integer :: buffer(*)
      integer :: ierr
      interface
        function mh5c_put_attr_array_int(id, buffer)
     &   result(ierr) bind(C, name='mh5c_put_attr_array_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_put_attr_array_int(attr_id, buffer)
      if (ierr < 0) call abend
      end subroutine

      subroutine mh5_put_attr_array_real (attr_id, buffer)
      use iso_c_binding
      implicit none
      integer :: attr_id
      real*8 :: buffer(*)
      integer :: ierr
      interface
        function mh5c_put_attr_array_real(id, buffer)
     &   result(ierr) bind(C, name='mh5c_put_attr_array_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        real(MOLCAS_C_REAL) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_put_attr_array_real(attr_id, buffer)
      if (ierr < 0) call abend
      end subroutine

      subroutine mh5_put_attr_array_str (attr_id, buffer)
      use iso_c_binding
      implicit none
      integer :: attr_id
      character :: buffer(*)
      integer :: ierr
      interface
        function mh5c_put_attr_array_str(id, buffer)
     &   result(ierr) bind(C, name='mh5c_put_attr_array_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        character(kind=c_char) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_put_attr_array_str(attr_id, buffer)
      if (ierr < 0) call abend
      end subroutine


      subroutine mh5_get_attr_array_int (attr_id, buffer)
      use iso_c_binding
      implicit none
      integer :: attr_id
      integer :: buffer(*)
      integer :: ierr
      interface
        function mh5c_get_attr_array_int(id, buffer)
     &   result(ierr) bind(C, name='mh5c_get_attr_array_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_attr_array_int(attr_id, buffer)
      if (ierr < 0) call abend
      end subroutine

      subroutine mh5_get_attr_array_real (attr_id, buffer)
      use iso_c_binding
      implicit none
      integer :: attr_id
      real*8 :: buffer(*)
      integer :: ierr
      interface
        function mh5c_get_attr_array_real(id, buffer)
     &   result(ierr) bind(C, name='mh5c_get_attr_array_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        real(MOLCAS_C_REAL) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_attr_array_real(attr_id, buffer)
      if (ierr < 0) call abend
      end subroutine

      subroutine mh5_get_attr_array_str (attr_id, buffer)
      use iso_c_binding
      implicit none
      integer :: attr_id
      character :: buffer(*)
      integer :: ierr
      interface
        function mh5c_get_attr_array_str(id, buffer)
     &   result(ierr) bind(C, name='mh5c_get_attr_array_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        character(kind=c_char) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_attr_array_str(attr_id, buffer)
      if (ierr < 0) call abend
      end subroutine

* Convenience wrappers: 'init' and 'fetch'

* init: create, put, close
      subroutine mh5_init_attr_scalar_int (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: value
      integer :: attr_id
      integer :: mh5_create_attr_scalar_int
      attr_id = mh5_create_attr_scalar_int(lu, name)
      call mh5_put_attr_scalar_int(attr_id, value)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_init_attr_scalar_real (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      real*8 :: value
      integer :: attr_id
      integer :: mh5_create_attr_scalar_real
      attr_id = mh5_create_attr_scalar_real(lu, name)
      call mh5_put_attr_scalar_real(attr_id, value)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_init_attr_scalar_str (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      character(len=*) :: value
      integer :: attr_id
      integer :: mh5_create_attr_scalar_str
      attr_id = mh5_create_attr_scalar_str(lu, name, len(value))
      call mh5_put_attr_scalar_str(attr_id, value)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_init_attr_array_int (lu, name, rank, dims, buffer)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      integer :: buffer(*)
      integer :: attr_id
      integer :: mh5_create_attr_array_int
      attr_id = mh5_create_attr_array_int(lu, name, rank, dims)
      call mh5_put_attr_array_int(attr_id, buffer)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_init_attr_array_real(lu, name, rank, dims, buffer)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      real*8 :: buffer(*)
      integer :: attr_id
      integer :: mh5_create_attr_array_real
      attr_id = mh5_create_attr_array_real(lu, name, rank, dims)
      call mh5_put_attr_array_real(attr_id, buffer)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_init_attr_array_str (
     &        lu, name, rank, dims, buffer, size)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      character :: buffer(*)
      integer :: size
      integer :: attr_id
      integer :: mh5_create_attr_array_str
      attr_id = mh5_create_attr_array_str(lu, name, rank, dims, size)
      call mh5_put_attr_array_str(attr_id, buffer)
      call mh5_close_attr(attr_id)
      end subroutine

* fetch: open, get, close
      subroutine mh5_fetch_attr_scalar_int (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: value
      integer :: attr_id
      integer :: mh5_open_attr
      attr_id = mh5_open_attr(lu, name)
      call mh5_get_attr_scalar_int(attr_id, value)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_fetch_attr_scalar_real (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      real*8 :: value
      integer :: attr_id
      integer :: mh5_open_attr
      attr_id = mh5_open_attr(lu, name)
      call mh5_get_attr_scalar_real(attr_id, value)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_fetch_attr_scalar_str (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      character(len=*) :: value
      integer :: attr_id
      integer :: mh5_open_attr
      attr_id = mh5_open_attr(lu, name)
      call mh5_get_attr_scalar_str(attr_id, value)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_fetch_attr_array_int (lu, name, buffer)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: buffer(*)
      integer :: attr_id
      integer :: mh5_open_attr
      attr_id = mh5_open_attr(lu, name)
      call mh5_get_attr_array_int(attr_id, buffer)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_fetch_attr_array_real(lu, name, buffer)
      implicit none
      integer :: lu
      character(len=*) :: name
      real*8 :: buffer(*)
      integer :: attr_id
      integer :: mh5_open_attr
      attr_id = mh5_open_attr(lu, name)
      call mh5_get_attr_array_real(attr_id, buffer)
      call mh5_close_attr(attr_id)
      end subroutine

      subroutine mh5_fetch_attr_array_str (lu, name, buffer)
      implicit none
      integer :: lu
      character(len=*) :: name
      character :: buffer(*)
      integer :: attr_id
      integer :: mh5_open_attr
      attr_id = mh5_open_attr(lu, name)
      call mh5_get_attr_array_str(attr_id, buffer)
      call mh5_close_attr(attr_id)
      end subroutine

*====================
*     DATASETS
*====================

      function mh5_create_dset_scalar_int (lu, name) result (dset_id)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: lu
      character(len=*) :: name
      integer :: dset_id
      interface
        function mh5c_create_dset_scalar_int(lu, name) result (dset_id)
     &   bind(C, name='mh5c_create_dset_scalar_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT) :: dset_id
        end function
      end interface

      call f2c_upcase(name,mh5_lbl)
      dset_id = mh5c_create_dset_scalar_int(lu, mh5_lbl)
      end function

      function mh5_create_dset_scalar_real (lu, name) result (dset_id)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: lu
      character(len=*) :: name
      integer :: dset_id
      interface
        function mh5c_create_dset_scalar_real(lu, name) result (dset_id)
     &   bind(C, name='mh5c_create_dset_scalar_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT) :: dset_id
        end function
      end interface

      call f2c_upcase(name,mh5_lbl)
      dset_id = mh5c_create_dset_scalar_real(lu, mh5_lbl)
      end function

      function mh5_create_dset_scalar_str (lu, name, size)
     &        result (dset_id)
      use iso_c_binding
      implicit none
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      integer :: lu
      character(len=*) :: name
      integer :: size
      integer :: dset_id
      interface
        function mh5c_create_dset_scalar_str(lu, name, size)
     &          result (dset_id)
     &          bind(C, name='mh5c_create_dset_scalar_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: size
        integer(MOLCAS_C_INT) :: dset_id
        end function
      end interface

      call f2c_upcase(name,mh5_lbl)
      dset_id = mh5c_create_dset_scalar_str(lu, mh5_lbl, size)
      end function

      subroutine mh5_put_dset_scalar_int (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      integer :: value
      integer :: ierr
      interface
        function mh5c_put_dset_scalar_int(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_put_dset_scalar_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        integer(MOLCAS_C_INT) :: value
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_put_dset_scalar_int(dset_id, value)
      end subroutine

      subroutine mh5_put_dset_scalar_real (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      real*8 :: value
      integer :: ierr
      interface
        function mh5c_put_dset_scalar_real(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_put_dset_scalar_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        real(MOLCAS_C_REAL) :: value
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_put_dset_scalar_real(dset_id, value)
      end subroutine

      subroutine mh5_put_dset_scalar_str (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      character(len=*) :: value
      integer :: ierr
      interface
        function mh5c_put_dset_scalar_str(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_put_dset_scalar_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        character(kind=c_char) :: value(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_put_dset_scalar_str(dset_id, value)
      end subroutine


      subroutine mh5_get_dset_scalar_int (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      integer :: value
      integer :: ierr
      interface
        function mh5c_get_dset_scalar_int(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_get_dset_scalar_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        integer(MOLCAS_C_INT) :: value
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_dset_scalar_int(dset_id, value)
      end subroutine

      subroutine mh5_get_dset_scalar_real (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      real*8 :: value
      integer :: ierr
      interface
        function mh5c_get_dset_scalar_real(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_get_dset_scalar_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        real(MOLCAS_C_REAL) :: value
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_dset_scalar_real(dset_id, value)
      end subroutine

      subroutine mh5_get_dset_scalar_str (dset_id, value)
      use iso_c_binding
      implicit none
      integer :: dset_id
      character(len=*) :: value
      integer :: ierr
      interface
        function mh5c_get_dset_scalar_str(dset_id, value) result (ierr)
     &   bind(C, name='mh5c_get_dset_scalar_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: dset_id
        character(kind=c_char) :: value(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_dset_scalar_str(dset_id, value)
      end subroutine

      function mh5_create_dset_array_int (lu, name, rank, dims, dyn)
     &        result(dset_id)
      use iso_c_binding
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      logical, optional :: dyn
      integer :: dset_id
      interface
        function mh5c_create_dset_array_int(lu, name, rank, dims)
     &   result(ierr) bind(C, name='mh5c_create_dset_array_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: rank
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
        function mh5c_create_dset_array_dyn_int(lu, name, rank, dims)
     &   result(ierr) bind(C, name='mh5c_create_dset_array_dyn_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: rank
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      logical :: isdyn

      isdyn = .false.
      if (present(dyn)) isdyn = dyn

      call f2c_upcase(name,mh5_lbl)
      if (isdyn) then
        dset_id = mh5c_create_dset_array_dyn_int(lu, mh5_lbl, rank,
     &                                           dims)
      else
        dset_id = mh5c_create_dset_array_int(lu, mh5_lbl, rank, dims)
      end if
      end function

      function mh5_create_dset_array_real (lu, name, rank, dims, dyn)
     &        result(dset_id)
      use iso_c_binding
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      logical, optional :: dyn
      integer :: dset_id
      interface
        function mh5c_create_dset_array_real(lu, name, rank, dims)
     &   result(ierr) bind(C, name='mh5c_create_dset_array_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: rank
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
        function mh5c_create_dset_array_dyn_real(lu, name, rank, dims)
     &   result(ierr) bind(C, name='mh5c_create_dset_array_dyn_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: rank
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      logical :: isdyn

      isdyn = .false.
      if (present(dyn)) isdyn = dyn

      call f2c_upcase(name,mh5_lbl)
      if (isdyn) then
        dset_id = mh5c_create_dset_array_dyn_real(lu, mh5_lbl, rank,
     &                                            dims)
      else
        dset_id = mh5c_create_dset_array_real(lu, mh5_lbl, rank, dims)
      end if
      end function

      function mh5_create_dset_array_str (lu, name, rank, dims, size,
     &                                    dyn)
     &        result(dset_id)
      use iso_c_binding
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      integer :: size
      logical, optional :: dyn
      integer :: dset_id
      interface
        function mh5c_create_dset_array_str(lu, name, rank, dims, size)
     &   result(ierr) bind(C, name='mh5c_create_dset_array_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: rank
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT), VALUE :: size
        integer(MOLCAS_C_INT) :: ierr
        end function
        function mh5c_create_dset_array_dyn_str(lu, name, rank, dims,
     &                                          size)
     &   result(ierr) bind(C, name='mh5c_create_dset_array_dyn_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: lu
        character(kind=c_char) :: name(*)
        integer(MOLCAS_C_INT), VALUE :: rank
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT), VALUE :: size
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
      logical :: isdyn

      isdyn = .false.
      if (present(dyn)) isdyn = dyn

      call f2c_upcase(name,mh5_lbl)
      if (isdyn) then
        dset_id = mh5c_create_dset_array_dyn_str(
     &          lu, mh5_lbl, rank, dims, size)
      else
        dset_id = mh5c_create_dset_array_str(
     &          lu, mh5_lbl, rank, dims, size)
      end if
      end function

      subroutine mh5_put_dset_array_int (dset_id, buffer, exts, offs)
      use iso_c_binding
      implicit none
      integer :: dset_id
      integer :: buffer(*)
      integer, optional :: exts(*), offs(*)
      integer :: ierr
      interface
        function mh5c_put_dset_array_int(id, exts, offs, buffer)
     &   result(ierr) bind(C, name='mh5c_put_dset_array_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: exts(*), offs(*)
        integer(MOLCAS_C_INT) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
        function mh5c_put_dset_array_int_full(id, buffer)
     &   result(ierr) bind(C, name='mh5c_put_dset_array_int_full')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      if (present(exts).and.present(offs)) then
        ierr = mh5c_put_dset_array_int(dset_id, exts, offs, buffer)
      else if (present(exts).or.present(offs)) then
        ierr = -1
        call abend
      else
        ierr = mh5c_put_dset_array_int_full(dset_id, buffer)
      end if
      end subroutine

      subroutine mh5_put_dset_array_real (dset_id, buffer, exts, offs)
      use iso_c_binding
      implicit none
      integer :: dset_id
      real*8 :: buffer(*)
      integer, optional :: exts(*), offs(*)
      integer :: ierr
      interface
        function mh5c_put_dset_array_real(id, exts, offs, buffer)
     &   result(ierr) bind(C, name='mh5c_put_dset_array_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: exts(*), offs(*)
        real(MOLCAS_C_REAL) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
        function mh5c_put_dset_array_real_full(id, buffer)
     &   result(ierr) bind(C, name='mh5c_put_dset_array_real_full')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        real(MOLCAS_C_REAL) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      if (present(exts).and.present(offs)) then
        ierr = mh5c_put_dset_array_real(dset_id, exts, offs, buffer)
      else if (present(exts).or.present(offs)) then
        ierr = -1
        call abend
      else
        ierr = mh5c_put_dset_array_real_full(dset_id, buffer)
      end if
      end subroutine

      subroutine mh5_put_dset_array_str (dset_id, buffer, exts, offs)
      use iso_c_binding
      implicit none
      integer :: dset_id
      character :: buffer(*)
      integer, optional :: exts(*), offs(*)
      integer :: ierr
      interface
        function mh5c_put_dset_array_str(id, exts, offs, buffer)
     &   result(ierr) bind(C, name='mh5c_put_dset_array_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: exts(*), offs(*)
        character(kind=c_char) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
        function mh5c_put_dset_array_str_full(id, buffer)
     &   result(ierr) bind(C, name='mh5c_put_dset_array_str_full')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        character(kind=c_char) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      if (present(exts).and.present(offs)) then
        ierr = mh5c_put_dset_array_str(dset_id, exts, offs, buffer)
      else if (present(exts).or.present(offs)) then
        ierr = -1
        call abend
      else
        ierr = mh5c_put_dset_array_str_full(dset_id, buffer)
      end if
      end subroutine


      subroutine mh5_get_dset_array_int (dset_id, buffer, exts, offs)
      use iso_c_binding
      implicit none
      integer :: dset_id
      integer :: buffer(*)
      integer, optional :: exts(*), offs(*)
      integer :: ierr
      interface
        function mh5c_get_dset_array_int(id, exts, offs, buffer)
     &   result(ierr) bind(C, name='mh5c_get_dset_array_int')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: exts(*), offs(*)
        integer(MOLCAS_C_INT) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
        function mh5c_get_dset_array_int_full(id, buffer)
     &   result(ierr) bind(C, name='mh5c_get_dset_array_int_full')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      if (present(exts).and.present(offs)) then
        ierr = mh5c_get_dset_array_int(dset_id, exts, offs, buffer)
      else if (present(exts).or.present(offs)) then
        ierr = -1
        call abend
      else
        ierr = mh5c_get_dset_array_int_full(dset_id, buffer)
      end if
      end subroutine

      subroutine mh5_get_dset_array_real (dset_id, buffer, exts, offs)
      use iso_c_binding
      implicit none
      integer :: dset_id
      real*8 :: buffer(*)
      integer, optional :: exts(*), offs(*)
      integer :: ierr
      interface
        function mh5c_get_dset_array_real(id, exts, offs, buffer)
     &   result(ierr) bind(C, name='mh5c_get_dset_array_real')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: exts(*), offs(*)
        real(MOLCAS_C_REAL) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
        function mh5c_get_dset_array_real_full(id, buffer)
     &   result(ierr) bind(C, name='mh5c_get_dset_array_real_full')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        real(MOLCAS_C_REAL) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      if (present(exts).and.present(offs)) then
        ierr = mh5c_get_dset_array_real(dset_id, exts, offs, buffer)
      else if (present(exts).or.present(offs)) then
        ierr = -1
        call abend
      else
        ierr = mh5c_get_dset_array_real_full(dset_id, buffer)
      end if
      end subroutine

      subroutine mh5_get_dset_array_str (dset_id, buffer, exts, offs)
      use iso_c_binding
      implicit none
      integer :: dset_id
      character :: buffer(*)
      integer, optional :: exts(*), offs(*)
      integer :: ierr
      interface
        function mh5c_get_dset_array_str(id, exts, offs, buffer)
     &   result(ierr) bind(C, name='mh5c_get_dset_array_str')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: exts(*), offs(*)
        character(kind=c_char) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
        function mh5c_get_dset_array_str_full(id, buffer)
     &   result(ierr) bind(C, name='mh5c_get_dset_array_str_full')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        character(kind=c_char) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      if (present(exts).and.present(offs)) then
        ierr = mh5c_get_dset_array_str(dset_id, exts, offs, buffer)
      else if (present(exts).or.present(offs)) then
        ierr = -1
        call abend
      else
        ierr = mh5c_get_dset_array_str_full(dset_id, buffer)
      end if
      end subroutine

      subroutine mh5_extend_dset_array(dset_id, dims)
      implicit none
      integer :: dset_id
      integer :: dims(*)
      integer :: ierr
      interface
        function mh5c_extend_dset_array(id, dims)
     &   result(ierr) bind(C, name='mh5c_extend_dset_array')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_extend_dset_array(dset_id, dims)
      if (ierr .lt. 0) then
        call abend
      end if
      end subroutine

      subroutine mh5_get_dset_array_dims(dset_id, dims)
      implicit none
      integer :: dset_id
      integer :: dims(*)
      integer :: ierr
      interface
        function mh5c_get_dset_array_dims(id, dims)
     &   result(ierr) bind(C, name='mh5c_get_dset_array_dims')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: dims(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface

      ierr = mh5c_get_dset_array_dims(dset_id, dims)
      if (ierr .lt. 0) then
        call abend
      end if
      end subroutine

* Convenience wrappers: 'init' and 'fetch'

* init: create, put, close
      subroutine mh5_init_dset_scalar_int (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: value
      integer :: dset_id
      integer :: mh5_create_dset_scalar_int
      dset_id = mh5_create_dset_scalar_int(lu, name)
      call mh5_put_dset_scalar_int(dset_id, value)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_init_dset_scalar_real (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      real*8 :: value
      integer :: dset_id
      integer :: mh5_create_dset_scalar_real
      dset_id = mh5_create_dset_scalar_real(lu, name)
      call mh5_put_dset_scalar_real(dset_id, value)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_init_dset_scalar_str (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      character(len=*) :: value
      integer :: dset_id
      integer :: mh5_create_dset_scalar_str
      dset_id = mh5_create_dset_scalar_str(lu, name, len(value))
      call mh5_put_dset_scalar_str(dset_id, value)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_init_dset_array_int (lu, name, rank, dims, buffer,
     &                                    dyn)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      integer :: buffer(*)
      logical, optional :: dyn
      integer :: ierr
      integer :: dset_id
      interface
        function mh5_create_dset_array_int (lu, name, rank, dims, dyn)
     &   result(dset_id)
        use iso_c_binding
        implicit none
        integer :: lu
        character(len=*) :: name
        integer :: rank
        integer :: dims(*)
        logical, optional :: dyn
        integer :: dset_id
        end function
        function mh5c_put_dset_array_int_full(id, buffer)
     &   result(ierr) bind(C, name='mh5c_put_dset_array_int_full')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        integer(MOLCAS_C_INT) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      logical :: isdyn
      isdyn = .false.
      if (present(dyn)) isdyn = dyn
      dset_id = mh5_create_dset_array_int(lu, name, rank, dims, isdyn)
      ierr = mh5c_put_dset_array_int_full(dset_id, buffer)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_init_dset_array_real(lu, name, rank, dims, buffer,
     &                                    dyn)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      real*8 :: buffer(*)
      logical, optional :: dyn
      integer :: ierr
      integer :: dset_id
      interface
        function mh5_create_dset_array_real (lu, name, rank, dims, dyn)
     &   result(dset_id)
        use iso_c_binding
        implicit none
        integer :: lu
        character(len=*) :: name
        integer :: rank
        integer :: dims(*)
        logical, optional :: dyn
        integer :: dset_id
        end function
        function mh5c_put_dset_array_real_full(id, buffer)
     &   result(ierr) bind(C, name='mh5c_put_dset_array_real_full')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        real(MOLCAS_C_REAL) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      logical :: isdyn
      isdyn = .false.
      if (present(dyn)) isdyn = dyn
      dset_id = mh5_create_dset_array_real(lu, name, rank, dims, dyn)
      ierr = mh5c_put_dset_array_real_full(dset_id, buffer)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_init_dset_array_str(
     &        lu, name, rank, dims, buffer, size, dyn)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: rank
      integer :: dims(*)
      character :: buffer(*)
      integer :: size
      logical, optional :: dyn
      integer :: ierr
      integer :: dset_id
      interface
        function mh5_create_dset_array_str (lu, name, rank, dims, size,
     &                                      dyn)
     &   result(dset_id)
        use iso_c_binding
        implicit none
        integer :: lu
        character(len=*) :: name
        integer :: rank
        integer :: dims(*)
        integer :: size
        logical, optional :: dyn
        integer :: dset_id
        end function
        function mh5c_put_dset_array_str_full(id, buffer)
     &   result(ierr) bind(C, name='mh5c_put_dset_array_str_full')
        use iso_c_binding
        implicit none
        integer(MOLCAS_C_INT), VALUE :: id
        character(kind=c_char) :: buffer(*)
        integer(MOLCAS_C_INT) :: ierr
        end function
      end interface
      logical :: isdyn
      isdyn = .false.
      if (present(dyn)) isdyn = dyn
      dset_id = mh5_create_dset_array_str(lu, name, rank, dims, size,
     &                                    isdyn)
      ierr = mh5c_put_dset_array_str_full(dset_id, buffer)
      call mh5_close_dset(dset_id)
      end subroutine

* fetch: open, get, close
      subroutine mh5_fetch_dset_scalar_int (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: value
      integer :: dset_id
      integer :: mh5_open_dset
      dset_id = mh5_open_dset(lu, name)
      call mh5_get_dset_scalar_int(dset_id, value)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_fetch_dset_scalar_real (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      real*8 :: value
      integer :: dset_id
      integer :: mh5_open_dset
      dset_id = mh5_open_dset(lu, name)
      call mh5_get_dset_scalar_real(dset_id, value)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_fetch_dset_scalar_str (lu, name, value)
      implicit none
      integer :: lu
      character(len=*) :: name
      character(len=*) :: value
      integer :: dset_id
      integer :: mh5_open_dset
      dset_id = mh5_open_dset(lu, name)
      call mh5_get_dset_scalar_str(dset_id, value)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_fetch_dset_array_int (lu, name, buffer, exts, offs)
      implicit none
      integer :: lu
      character(len=*) :: name
      integer :: buffer(*)
      integer, optional :: exts(*), offs(*)
      integer :: dset_id
      integer :: mh5_open_dset
      interface
        subroutine mh5_get_dset_array_int (dset_id, buffer, exts, offs)
        implicit none
        integer :: dset_id
        integer :: buffer(*)
        integer, optional :: exts(*), offs(*)
        end subroutine
      end interface
      dset_id = mh5_open_dset(lu, name)
      call mh5_get_dset_array_int(dset_id, buffer, exts, offs)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_fetch_dset_array_real(lu, name, buffer, exts, offs)
      implicit none
      integer :: lu
      character(len=*) :: name
      real*8 :: buffer(*)
      integer, optional :: exts(*), offs(*)
      integer :: dset_id
      integer :: mh5_open_dset
      interface
        subroutine mh5_get_dset_array_real (dset_id, buffer, exts, offs)
        implicit none
        integer :: dset_id
        real*8 :: buffer(*)
        integer, optional :: exts(*), offs(*)
        end subroutine
      end interface
      dset_id = mh5_open_dset(lu, name)
      call mh5_get_dset_array_real(dset_id, buffer, exts, offs)
      call mh5_close_dset(dset_id)
      end subroutine

      subroutine mh5_fetch_dset_array_str(lu, name, buffer, exts, offs)
      implicit none
      integer :: lu
      character(len=*) :: name
      character :: buffer(*)
      integer, optional :: exts(*), offs(*)
      integer :: dset_id
      integer :: mh5_open_dset
      interface
        subroutine mh5_get_dset_array_str (dset_id, buffer, exts, offs)
        implicit none
        integer :: dset_id
        character :: buffer(*)
        integer, optional :: exts(*), offs(*)
        end subroutine
      end interface
      dset_id = mh5_open_dset(lu, name)
      call mh5_get_dset_array_str(dset_id, buffer, exts, offs)
      call mh5_close_dset(dset_id)
      end subroutine

* convert Fortran string to uppercased, null-terminated C string
      subroutine f2c_upcase(name, lbl)
      use iso_c_binding
      implicit none
      character(len=*) :: name, lbl
      if (len(name) .gt. len(lbl)-1) then
        call AbEnd
      end if
      lbl = TRIM(name)//C_NULL_CHAR
      call upcase(lbl)
      end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine two2mean13(carteSO,occup,AOcoeffs,onecart,ncontmf,norbsum,noccorb)
!bs gives the two first contributions
!bs < i M | j M >  with Malpha  and Mbeta
!bs the other orbit parts cancel

use AMFI_global, only: MxcontL
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ncontmf, norbsum, noccorb
real(kind=wp), intent(in) :: carteSO(ncontmf,ncontmf,norbsum,norbsum), occup(*), AOcoeffs(MxcontL,*)
real(kind=wp), intent(inout) :: onecart(MxcontL,MxcontL)
integer(kind=iwp) :: icartleft, icartright, Mrun
real(kind=wp) :: coeff

do icartleft=1,norbsum
  do icartright=1,norbsum
    coeff = Zero
    do Mrun=1,noccorb
      coeff = coeff+occup(Mrun)*AOcoeffs(icartleft,Mrun)*AOcoeffs(icartright,Mrun)
    end do
    onecart(1:ncontmf,1:ncontmf) = onecart(1:ncontmf,1:ncontmf)+coeff*carteSO(1:ncontmf,1:ncontmf,icartleft,icartright)
  end do
end do
!write(u6,*) 'effective integrals'
!do jrun=1,ncontmf
!  write(u6,'(4E20.14)') (onecart(irun,jrun),irun=1,ncontmf)
!end do

return

end subroutine two2mean13

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Francesco Aquilante                              *
************************************************************************
      SUBROUTINE FNOMP2_Drv(irc,EMP2,CMOI,EOcc,EVir)

#include "implicit.fh"
      Real*8 EMP2, CMOI(*), EOcc(*), EVir(*)
C
      Logical DoDens_
      Integer ChoAlg_
#include "orbinf2.fh"
#include "corbinf.fh"
#include "chomp2_cfg.fh"

      DoDens_= DoDens
      DoDens = .false.
      ChoAlg_= ChoAlg
      ChoAlg = 2

      CALL FNO_MP2(irc,nSym,nBas,nFro,nOcc,nExt,nDel,
     &                      CMOI,EOcc,EVir,vkept,DoMP2,XEMP2)
      If (irc .ne. 0) Then
         Write(6,*) 'FNO_MP2 returned ',irc
         Call SysAbendMsg('FNO_MP2',
     &                    'Non-zero return code from FNO_MP2',
     &                    ' ')
      EndIf

      ChoAlg = ChoAlg_
      DoDens = DoDens_
      DoFNO = .false.
      Call ChoMP2_Drv(irc,EMP2,CMOI,EOcc,EVir)
      EMP2=EMP2+XEMP2

      Return
      End
*****************************************************************************
*                                                                           *
*****************************************************************************

      SUBROUTINE FNO_MP2(irc,nSym,nBas,nFro,nIsh,nSsh,nDel,
     &                       CMOI,EOcc,EVir,vfrac,DoMP2,EMP2)
*****************************************************************************
*                                                                           *
*     Purpose:  setup of Frozen Natural Orbitals MP2 (FNO-MP2).             *
*                                                                           *
*     Author:   F. Aquilante  (Geneva, Nov  2008)                           *
*                                                                           *
*****************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
*
      Integer nBas(nSym),nFro(nSym),nIsh(nSym),nSsh(nSym),
     &        nDel(nSym),nAuxO(8)
      Real*8  CMOI(*), EOcc(*), EVir(*), EMP2, vfrac
      Logical DoMP2
      Real*8  DeMP2
      Logical MP2_small
      Common / ChFNOPT/ DeMP2, MP2_small
*
      Integer ns_V(8)
      Integer lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
      Real*8  TrDF(8), TrDP(8)
*
*
      irc=0
      MP2_small=.false.
*
*----------------------------------------------------------------------*
*     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
*----------------------------------------------------------------------*
*
      nBasT=0
      ntri=0
      nSQ=0
      nBmx=0
      nOrb=0
      nVV=0
      Do i=1,nSym
        ns_V(i)=0
        nBasT=nBasT+nBas(i)
        nOrb=nOrb+nFro(i)+nIsh(i)+nSsh(i)+nDel(i)
        ntri=ntri+nBas(i)*(nBas(i)+1)/2
        nSQ=nSQ+nBas(i)**2
        nVV=nVV+nSsh(i)**2
        nBmx=Max(nBmx,nBas(i))
      End Do
      IF(nBasT.GT.mxBas) then
       Write(6,'(/6X,A)')
     & 'The number of basis functions exceeds the present limit'
       Call Abend
      Endif
*
      NCMO=nSQ
      CALL GETMEM('LCMO','ALLO','REAL',LCMO,2*NCMO)
      iCMO=LCMO+NCMO
      CALL DCOPY_(NCMO,CMOI,1,WORK(LCMO),1)
*
      nOA=0
      Do iSym=1,nSym  ! setup info
         lnFro(iSym)=nFro(iSym)
         lnOcc(iSym)=nIsh(iSym)
         nOA=nOA+lnOcc(iSym)
         lnVir(iSym)=nSsh(iSym)
         lnOrb(iSym)=lnOcc(iSym)+lnVir(iSym)
         lnDel(iSym)=nDel(iSym)
      End Do
*
      Call GetMem('Eorb','Allo','Real',ipOrbE,4*nOrb)
      jOff=0
      kOff=0
      lOff=0
      Do iSym=1,nSym
         jp=ipOrbE+lOff+nFro(iSym)
         jOcc=jOff+1
         call dcopy_(nIsh(iSym),EOcc(jOcc),1,Work(jp),1)
         jVir=kOff+1
         jp=jp+nIsh(iSym)
         call dcopy_(nSsh(iSym),EVir(jVir),1,Work(jp),1)
         jOff=jOff+nIsh(iSym)
         kOff=kOff+nSsh(iSym)
         lOff=lOff+nBas(iSym)
      End Do
      ip_ZZ=ipOrbE
      ipEorb=ipOrbE+nOrb
      ip_Z=ipEorb
      kEOcc=ipEorb+nOrb
      kEVir=kEOcc+nOrb
      ioff=0
      joff=0
      koff=0
      Do iSym=1,nSym
         ifr=ipOrbE+ioff+nFro(iSym)
         ito=kEOcc+joff
         call dcopy_(nIsh(iSym),Work(ifr),1,Work(ito),1)
         ifr=ipOrbE+ioff+nFro(iSym)+nIsh(iSym)
         ito=kEVir+koff
         call dcopy_(nSsh(iSym),Work(ifr),1,Work(ito),1)
         ioff=ioff+nBas(iSym)
         joff=joff+nIsh(iSym)
         koff=koff+nSsh(iSym)
      End Do
      Call GetMem('Dmat','Allo','Real',ip_X,nVV+nOA)
      ip_Y=ip_X+nVV
      Call FZero(Work(ip_X),nVV+nOA)
*
      Call FnoMP2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,ip_X,ip_Y)
      Call FZero(Work(iCMO),NCMO)
      iOff=0
      Do iSym=1,nSym
         kfr=LCMO+iOff+nBas(iSym)*nFro(iSym)
         kto=iCMO+iOff+nBas(iSym)*lnFro(iSym)
         call dcopy_(nBas(iSym)*lnOcc(iSym),Work(kfr),1,Work(kto),1)
         kfr=LCMO+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
         kto=kto+nBas(iSym)*lnOcc(iSym)
         call dcopy_(nBas(iSym)*lnVir(iSym),Work(kfr),1,Work(kto),1)
         iOff=iOff+nBas(iSym)**2
      End Do
      Call Check_Amp2(nSym,lnOcc,lnVir,iSkip)
      If (iSkip.gt.0) Then
         Call ChoMP2_Drv(irc,Dummy,Work(iCMO),Work(kEOcc),Work(kEVir))
         If(irc.ne.0) then
           write(6,*) 'MP2 pseudodensity calculation failed !'
           Call Abend
         Endif
      Else
         write(6,*)
         write(6,*)'There are ZERO amplitudes T(ai,bj) with the given '
         write(6,*)'combinations of inactive and virtual orbitals !! '
         write(6,*)'Check your input and rerun the calculation! Bye!!'
         Call Abend
      Endif
*
*     Diagonalize the pseudodensity to get natural virtual orbitals
*     -------------------------------------------------------------
      iOff=0
      jOff=0
      Do iSym=1,nSym
         if (nSsh(iSym).gt.0) then
           jD=ip_X+iOff
*     Eigenvectors will be in increasing order of eigenvalues
           Call Eigen_Molcas(nSsh(iSym),Work(jD),Work(ip_Z),Work(ip_ZZ))
*     Reorder to get relevant eigenpairs first
           Do j=1,nSsh(iSym)/2
              Do i=1,nSsh(iSym)
                 lij=jD-1+nSsh(iSym)*(j-1)+i
                 kij=jD-1+nSsh(iSym)**2-(nSsh(iSym)*j-i)
                 tmp=Work(lij)
                 Work(lij)=Work(kij)
                 Work(kij)=tmp
              End Do
              tmp=Work(ip_Z-1+j)
              Work(ip_Z-1+j)=Work(ip_Z+nSsh(iSym)-j)
              Work(ip_Z+nSsh(iSym)-j)=tmp
           End Do
*
*     Compute new MO coeff. : X=C*U
           kfr=iCMO+jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
           kto=LCMO+jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
           Call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym),
     &                        1.0d0,Work(kfr),nBas(iSym),
     &                              Work(jD),nSsh(iSym),
     &                        0.0d0,Work(kto),nBas(iSym))
           iOff=iOff+nSsh(iSym)**2
           TrDF(iSym)=ddot_(nSsh(iSym),Work(ip_Z),1,[1.0d0],0)
           ns_V(iSym)=int(vfrac*nSsh(iSym))
           TrDP(iSym)=ddot_(ns_V(iSym),Work(ip_Z),1,[1.0d0],0)
         endif
         jOff=jOff+nBas(iSym)**2
      End Do
      write(6,*)'------------------------------------------------------'
      write(6,*)'   Symm.     Trace     (Full Dmat)     (Partial Dmat) '
      write(6,*)'------------------------------------------------------'
      STrDF=0.0d0
      STrDP=0.0d0
      Do iSym=1,nSym
        write(6,'(4X,I4,14X,G13.6,5X,G13.6)') iSym,TrDF(iSym),TrDP(iSym)
        STrDF=STrDF+TrDF(iSym)
        STrDP=STrDP+TrDP(iSym)
      End Do
      write(6,*)'------------------------------------------------------'
      write(6,'(A,G13.6,5X,G13.6)')'   Sum :              ',STrDF,STrDP
      write(6,*)'------------------------------------------------------'
*
*     Update the nSsh, nDel for FNO-MP2
      nSsh_t=0
      Do iSym=1,nSym
         lnOrb(iSym)=lnOrb(iSym)-nSsh(iSym)+ns_V(iSym)
         nDel(iSym)=nDel(iSym)+nSsh(iSym)-ns_V(iSym)
         nSsh(iSym)=ns_V(iSym)
         nSsh_t=nSsh_t+nSsh(iSym)
         nAuxO(iSym)=nBas(iSym)-nDel(iSym)
      End Do
      Call Put_iArray('nDelPT',nDel,nSym)
      Call Put_iArray('nOrb',nAuxO,nSym)
*
*     Reset MP2_small for this new call to ChoMP2_Drv
      Call Check_Amp2(nSym,lnOcc,nSsh,iSkip)
      MP2_small = iSkip .gt. 0
      If (MP2_small) Then
*
         Call FnoMP2_putInf(nSym,lnOrb,lnOcc,lnFro,nDel,nSsh,ip_X,ip_Y)
*
         Call GetMem('iD_orb','Allo','Inte',ip_iD,nOrb)
         Do k=1,nOrb
            iWork(ip_iD-1+k) = k
         End Do
         lOff=0
         kOff=0
         jOff=0
         iOff=0
         Do iSym=1,nSym  ! canonical orb. in the reduced virtual space
            jD=ip_X+iOff
            Call Get_Can_Lorb(Work(kEVir+lOff),Work(ipOrbE+jOff),
     &                        nSsh(iSym),lnVir(iSym),
     &                        iWork(ip_iD),Work(jD),iSym)

            kfr=LCMO+kOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
            kto=1+kOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
            nBx=Max(1,nBas(iSym))
            nSx=Max(1,nSsh(iSym))
            Call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym),
     &                         1.0d0,Work(kfr),nBx,
     &                               Work(jD),nSx,
     &                         0.0d0,CMOI(kto),nBx)

            lOff=lOff+lnVir(iSym)
            kOff=kOff+nBas(iSym)**2
            jOff=jOff+nSsh(iSym)
            iOff=iOff+lnVir(iSym)**2
         End Do
         Call GetMem('iD_orb','Free','Inte',ip_iD,nOrb)
         kEVir=ipOrbE
*
*   Copy the new Evir to output array
         call dcopy_(nSsh_t,Work(kEVir),1,EVir,1)
*
         Write(6,*)
         Write(6,'(A,8I4)')
     & ' Secondary orbitals after selection:',(nSsh(i),i=1,nSym)
         Write(6,'(A,8I4)')
     & ' Deleted orbitals after selection:  ',(nDel(i),i=1,nSym)
         Write(6,*)
         Write(6,*) 'Energies of the active virtual orbitals '
         ii=0
         Do iSym=1,nSym
            If ( nSsh(iSym).ne.0 ) then
               Write(6,*)
               Write(6,'(A,I2,(T40,5F14.6))')
     &            ' symmetry species',iSym,(EVir(ii+k),k=1,nSsh(iSym))
               ii=ii+nSsh(iSym)
            End If
         End Do
         Write(6,*)
*
         EMP2=DeMP2
         DeMP2=0.0d0
         If (DoMP2) Call ChoMP2_Drv(irc,Dummy,CMOI,Work(kEOcc),
     &                                  Work(kEVir))
         If(irc.ne.0) then
           write(6,*) 'MP2 in truncated virtual space failed !'
           Call Abend
         Endif
         EMP2 = -1.0d0*(EMP2-DeMP2)
         If (DoMP2) Then
            DeMP2=EMP2
c            write(6,*)
c            write(6,'(1x,a,f18.10,a)')'FNO correction:       ',EMP2,
c     &                                '   (estimate)   '
c            write(6,*)
         Else
            EMP2=0.0d0
         EndIf
      Else
         write(6,*)
         write(6,*)'We found  ZERO amplitudes T(ai,bj) with the final '
         write(6,*)'combinations of inactive and virtual orbitals !! '
         write(6,*)'Check your input and rerun the calculation! Bye!!'
         Call Abend
      EndIf
*
*     Update runfile for subsequent calcs (e.g., CHCC)
      ioff=0
      joff=0
      koff=0
      Do iSym=1,nSym
         ifr=1+ioff
         ito=ipOrbE+koff+nFro(iSym)
         call dcopy_(nIsh(iSym),EOcc(ifr),1,Work(ito),1)
         ifr=1+joff
         ito=ito+nIsh(iSym)
         call dcopy_(nSsh(iSym),EVir(ifr),1,Work(ito),1)
         ioff=ioff+nIsh(iSym)
         joff=joff+nSsh(iSym)
         koff=koff+nBas(iSym)
      End Do
      Call Put_dArray('OrbE',Work(ipOrbE),nOrb)
      Call Put_dArray('Last orbitals',CMOI,NCMO)
*
      Call GetMem('Dmat','Free','Real',ip_X,nVV+nOA)
      Call GetMem('Eorb','Free','Real',ipOrbE,4*nOrb)
*
      CALL GETMEM('LCMO','FREE','REAL',LCMO,2*NCMO)
*
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      SubRoutine FnoMP2_putInf(mSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,
     &                         ip_X,ip_Y)
C
C     Purpose: put info in MP2 common blocks.
C
#include "implicit.fh"
      Integer lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
      Integer ip_X, ip_Y
C
#include "corbinf.fh"
#include "chomp2_cfg.fh"
C
C
      nSym = mSym
C
      Do iSym = 1,nSym
         nOrb(iSym) = lnOrb(iSym)
         nOcc(iSym) = lnOcc(iSym)
         nFro(iSym) = lnFro(iSym)
         nDel(iSym) = lnDel(iSym)
         nExt(iSym) = lnVir(iSym)
      End Do
C
      DoFNO=.true.
      ip_Dab=ip_X
      ip_Dii=ip_Y
      l_Dab=nExt(1)
      l_Dii=nOcc(1)
      Do iSym=2,nSym
         l_Dab=l_Dab+nExt(iSym)**2
         l_Dii=l_Dii+nOcc(iSym)
      End Do
C
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine natureorb(nsbas,nsall,nsdel,ngsm,den1,lden,cmo,lcmo,
     *                     bsbl,lenb,cno,occ,nmo,pror)
      implicit none
      integer :: nsbas(8),nsall(8),nsdel(8)
      integer :: ngsm,lden,lcmo,lenb,nmo
      real*8 :: cmo(lcmo),cno(lcmo),occ(nmo)
      real*8 :: den1(lden)
      character bsbl(lenb)*1
      real*8 :: pror
!-----------------------------------------------------
      integer :: nsfrz(8),nsort(nmo)
      integer :: nc,nc0,nc1,nc2,nc3,nc4,nc5
      integer :: im,i,j
      real*8 :: buff(nmo**2)
      real*8 :: val
      character*128 :: header

      header="MRCISD Natrual orbital"
      nc0=1
      do im=1,ngsm
        if(nsall(im).eq.0) cycle
        nc1=nsall(im)*(nsall(im)+1)/2
        nc0=nc0+nc1
      enddo
!      open(100,file="dat2")
!      open(200,file="dat1")
!      do i=1,1293
!        read(100,*) den1(i)
!        write(200,"(f14.8)") den1(i)
!      enddo
!      close(100)
!      close(200)


      val=0
      cno=cmo
      nc0=1
      nc1=1
      nc2=1
      do im=1,ngsm
        if(nsbas(im).eq.0) cycle
        nsfrz(im)=nsbas(im)-nsall(im)-nsdel(im)
! For density matrix, we only have correlated orbital density matrix
        buff=0.d0
        nc=nsall(im)*(nsall(im)+1)/2
! Dagnolize density matrix in symmetry block im and transform MO
! Copy density matrix
        buff(1:nc)=den1(nc2:nc2+nc-1)
        nc3=nc1+nsfrz(im)*nsbas(im)
        call jacob(buff,cno(nc3),nsall(im),nsbas(im))
! OCC num from diagonal element
        nc3=nc0
        occ(nc3:nc3+nsfrz(im)-1)=2.d0
        nc3=nc3+nsfrz(im)
        do i=1,nsall(im)
          nc=i*(i+1)/2
          occ(nc3)=buff(nc)
          nc3=nc3+1
        enddo

! Sort nature orbital in OCC num decreasing order
        buff=0.d0
! Sort and copy correlated nature orb
        do i=1,nsall(im)
          nsort(i)=i
        enddo
        nc=nc0+nsfrz(im)-1
        do i=1,nsall(im)
          nc3=i
          do j=i+1,nsall(im)
            if(occ(nc+j).gt.occ(nc+i)) then
              val=occ(nc+j)
              occ(nc+j)=occ(nc+i)
              occ(nc+i)=val
              nc3=j
            endif
          enddo
          nsort(i)=nc3
        enddo

        buff=0.d0
        nc3=nsbas(im)**2
        buff(1:nc3)=cno(nc1:nc1+nc3-1)
! Copy sorted orbital
        nc=nc1+nsfrz(im)*nsbas(im)
        nc5=1+nsfrz(im)*nsbas(im)
        do i=1,nsall(im)
          j=nsort(i)
          nc3=nc+(i-1)*nsbas(im)
          nc4=nc5+(j-1)*nsbas(im)
          cno(nc3:nc3+nsbas(im)-1)=buff(nc4:nc4+nsbas(im)-1)
        enddo

! do nothing for deleted orbital
!        nc3=1+(nsfrz(im)+nsall(im))*nsbas(im)
!        nc=nsdel(im)*nsbas(im)-1
!        cno(nc3:nc3+nc)=buff(nc3:nc3+nc)

!100     continue
        nc0=nc0+nsbas(im)
        nc1=nc1+nsbas(im)**2
        nc2=nc2+nsall(im)*(nsall(im)+1)/2
      enddo

!      nc0=1
!      do im=1,ngsm
!        if(nsbas(im).eq.0) cycle
!        print*, " "
!        print*, "SYM",im
!        print"(10(1xf8.4))", occ(nc0:nc0+nsbas(im)-1)
!        nc0=nc0+nsbas(im)
!      enddo

      call primo(Header,.true.,.false.,pror,0.d0,ngsm,nsbas,nsbas,
     *           bsbl,[val],occ,cno,-1)

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  PrintGeom
!
!> @brief
!>   Print the geometry
!> @author Y. Carissan
!>
!> @details
!> Print the geometry.
!>
!> @param[in] iLU   Logic unit number
!> @param[in] Nat   number of atoms
!> @param[in] title title to be printed
!> @param[in] Geom  XYZ coordinates
!> @param[in] lbl   Atom labels
!***********************************************************************

#include "macros.fh"

subroutine PrintGeom(iLU,Nat,title,Geom,lbl)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iLU, nat
character(len=20), intent(in) :: title, lbl(nat)
real(kind=wp), intent(in) :: Geom(3,nat)
integer(kind=iwp) :: iat
unused_var(lbl)

write(u6,'(a8,i1)') '--- GEOM'
write(u6,'(i4)') nat
write(u6,*) title
do iat=1,nat
  !if (debug) then
  !  ! lbl is not defined. I'll comment out this statement
  !  ! until someone needs it and replace it with the
  !  ! the standard printout.
  !  write(u6,'(i3,5x,a10,8x,3f16.8)') iat,lbl(iat),Geom(:,iat)
  !else
  !  write(u6,   '(5x,a10,8x,3f16.8)')     lbl(iat),Geom(:,iat)
  !end if
  write(u6,'(i3,5x,3f16.8)') iat,Geom(:,iat)
end do

if (iLU /= -1) then
  write(iLU,'(a8,i1)') '--- GEOM'
  write(iLU,'(i4)') nat
  write(iLU,*) title
  do iat=1,nat
    !write(iLU,     '(a10,8x,3f16.8)')     lbl(iat),Geom(:,iat)
    write(iLU,'(i3,5x,3f16.8)') iat,Geom(:,iat)
  end do
end if

return

end subroutine PrintGeom

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines:
c
c     t3sgl
c     t3sgl11
c     t3sgl121
c     t3sgl122
c     t3sgl131
c     t3sgl132
c     t3sgl141
c     t3sgl142
c     t3sgl143
c     t3sgl211
c     t3sgl212
c     t3sgl221
c     t3sgl222
c     t3sgl223
c     t3sgl311
c     t3sgl312
c     t3sgl321
c     t3sgl322
c     t3sgl323
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
       subroutine t3sgl (wrk,wrksize,
     & mapdw,ssw,mapds1,mapis1,mapds2,mapis2,
     & mapdd1,mapid1,mapdd2,mapid2,
     & typdiv,i,j,k,symi,symj,symk,rc1,
     & mapdm1,mapim1,possm10,mapdh1,mapih1,possh10,
     & mapdm2,mapim2,possm20,mapdh2,mapih2,possh20,
     & mapdm3,mapim3,possm30,mapdh3,mapih3,possh30)

c
c     mapdw  - direct map matrix of W (Input)
c     ssw    - overall symmetry state of matrix W (V) (Input)
c     mapds1 - direct map matrix of S1 (Input)
c     mapis1 - inverse map matrix of S1 (Input)
c     mapds2 - direct map matrix of S2 (Input)
c     mapis2 - inverse map matrix of S2 (Input)
c     mapdd1 - direct map matrix of D1 (Input)
c     mapid1 - inverse map matrix of D1 (Input)
c     mapdd2 - direct map matrix of D2 (Input)
c     mapid2 - inverse map matrix of D2 (Input)
c     (order is aa>ab>bb,
c     if there is only one spin, use any map's for 2)
c     typsgl - typ of operation (see Table) (Input)
c     i      - value of occupied index i (Inlut)
c     j      - value of occupied index j (Inlut)
c     k      - value of occupied index k (Inlut)
c     symi   - symmetry of index i (Input)
c     symj   - symmetry of index j (Input)
c     symk   - symmetry of index k (Input)
c     rc     - return (error) code (Output)
c     mapd,mapi,poss - parameterrs for M1-3,H1-3 files (I)
c
c     this routine add contributions from diconnected
c     singles, namely:
c
c     W_ijk(abc) <- P [ U1(_i,a) . U2(_jk,bc) ]
c
c     for following types of W
c
c     typsgl         Operation                   Implemented
c     1     W(abc) <- +s1(_i,a) . d1(_jk,bc)
c     -s1(_i,b) . d1(_jk,ac)
c     +s1(_i,c) . d1(_jk,ab)
c
c     -s1(_j,a) . d1(_ik,bc)
c     +s1(_j,b) . d1(_ik,ac)
c     -s1(_j,c) . d1(_ik,ab)
c
c     +s1(_k,a) . d1(_ij,bc)
c     -s1(_k,b) . d1(_ij,ac)
c     +s1(_k,c) . d1(_ij,ab)        Yes
c
c
c     2     W(ab,c)<- +s1(_i,a) . d2(_j,_k,b,c)
c     -s1(_i,b) . d2(_j,_k,a,c)
c
c     -s1(_j,a) . d2(_i,_k,b,c)
c     +s1(_j,b) . d2(_i,_k,a,c)
c
c     +s2(_k,c) . d1(_ij,ab)        Yes
c
c
c     3     W(a,bc)<- +s1(_i,a) . d2(_jk,b,c)
c
c     +s1(_j,b) . d2(_i,_k,a,c)
c     -s1(_j,c) . d2(_i,_k,a,b)
c
c     -s1(_k,b) . d2(_i,_j,a,c)
c     +s1(_k,c) . d2(_i,_j,a,b)     Yes
c
c
c
c     N.B. spin combinations aaa,bbb for 1; aab for 2; and abb for 3
c     are authomatically assumed
c
#include "t31.fh"
#include "wrk.fh"
c
       integer ssw,typdiv,i,j,k,symi,symj,symk,rc
       integer mapdw(0:512,1:6)
       integer mapds1(0:512,1:6)
       integer mapds2(0:512,1:6)
       integer mapdd1(0:512,1:6)
       integer mapdd2(0:512,1:6)
       integer mapis1(1:8,1:8,1:8)
       integer mapis2(1:8,1:8,1:8)
       integer mapid1(1:8,1:8,1:8)
       integer mapid2(1:8,1:8,1:8)
c
       integer possm10
       integer mapdm1(0:512,1:6)
       integer mapim1(1:8,1:8,1:8)
       integer possm20
       integer mapdm2(0:512,1:6)
       integer mapim2(1:8,1:8,1:8)
       integer possm30
       integer mapdm3(0:512,1:6)
       integer mapim3(1:8,1:8,1:8)
       integer possh10
       integer mapdh1(0:512,1:6)
       integer mapih1(1:8,1:8,1:8)
       integer possh20
       integer mapdh2(0:512,1:6)
       integer mapih2(1:8,1:8,1:8)
       integer possh30
       integer mapdh3(0:512,1:6)
       integer mapih3(1:8,1:8,1:8)
c
c     help variables
c
       integer iw,possw
       integer id1,id2,id3,possd1,possd2,possd3
       integer is1,is2,is3,posss1,posss2,posss3
       integer syma,symb,symc,dima,dimb,dimc
       integer nhelp1,nhelp2
       integer rc1,ssh1,ssh2,ssh3,ssm1,ssm2,ssm3
       integer symij,symik,symjk,symab,symac,symbc
c
c
c0.*  some tests
c
c
c
       if (typdiv.eq.1) then
c
c1    case W(pqr)
c
c1.*  ext H1(a) <= S1(a,i) for given i
       call ext(wrk,wrksize,
     & 2,2,i,0,0,symi,0,0,mapds1,mapis1,1,
     & possh10,mapdh1,mapih1,ssh1,rc1)
c
c1.*  ext H2(a) <= S1(a,j) for given j
       call ext(wrk,wrksize,
     & 2,2,j,0,0,symj,0,0,mapds1,mapis1,1,
     & possh20,mapdh2,mapih2,ssh2,rc1)
c
c1.*  ext H3(a) <= S1(a,k) for given k
       call ext(wrk,wrksize,
     & 2,2,k,0,0,symk,0,0,mapds1,mapis1,1,
     & possh30,mapdh3,mapih3,ssh3,rc1)
c
c1.*  ext M1(bc) <= D1(bc,jk) for given jk
       call ext(wrk,wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdd1,mapid1,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c1.*  ext M2(bc) <= D1(bc,ik) for given ik
       call ext(wrk,wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdd1,mapid1,1,
     & possm20,mapdm2,mapim2,ssm2,rc1)
c
c1.*  ext M3(bc) <= D1(bc,ij) for given ij
       call ext(wrk,wrksize,
     & 4,7,i,j,0,symi,symj,0,mapdd1,mapid1,1,
     & possm30,mapdm3,mapim3,ssm3,rc1)
c
c
       do 100 iw=1,mapdw(0,5)
c
c1.*  def possition of W
       possw=mapdw(iw,1)
c
c1.*  def symmetry status
       syma=mapdw(iw,3)
       symb=mapdw(iw,4)
       symc=mapdw(iw,5)
c
c1.*  def dimensions
       dima=dimm(mapdw(0,1),syma)
       dimb=dimm(mapdw(0,2),symb)
       dimc=dimm(mapdw(0,3),symc)
c1.*
       symij=mmul(symi,symj)
       symik=mmul(symi,symk)
       symjk=mmul(symj,symk)
       symab=mmul(syma,symb)
       symac=mmul(syma,symc)
       symbc=mmul(symb,symc)
c
c1.*  realize packing
c
       if (syma.eq.symc) then
c1.a  case syma=symb=symc
c
c
c1.a.1----  first triade   W(abc) <- +s1(_i,a) . d1(_jk,bc)
c     -s1(_i,b) . d1(_jk,ac)
c     +s1(_i,c) . d1(_jk,ab)
c
       if ((symi.eq.syma).and.(symjk.eq.symbc)) then
c1.a.1.*      find address for s1,d1
       is1=mapih1(1,1,1)
       id1=mapim1(symb,1,1)
c
c1.a.1.*      def possition of s1,d1
       posss1=mapdh1(is1,1)
       possd1=mapdm1(id1,1)
c
c1.a.1.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
       nhelp2=dima*(dima-1)*(dima-2)/6
c
c1.a.1.*      add singly
       call t3sglh11 (wrk(possw),dima,nhelp1,nhelp2,
     & wrk(posss1),wrk(possd1),1)
       end if
c
c
c1.a.2----  2-nd. triade   W(abc) <- -s1(_j,a) . d1(_ik,bc)
c     +s1(_j,b) . d1(_ik,ac)
c     -s1(_j,c) . d1(_ik,ab)
c
       if ((symj.eq.syma).and.(symik.eq.symbc)) then
c1.a.2.*      find address for s1,d1
       is1=mapih2(1,1,1)
       id1=mapim2(symb,1,1)
c
c1.a.2.*      def possition of s1,d1
       posss1=mapdh2(is1,1)
       possd1=mapdm2(id1,1)
c
c1.a.2.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
       nhelp2=dima*(dima-1)*(dima-2)/6
c
c1.a.2.*      add singly
       call t3sglh11 (wrk(possw),dima,nhelp1,nhelp2,
     & wrk(posss1),wrk(possd1),-1)
       end if
c
c
c1.a.3----  3-rd. triade   W(abc) <- +s1(_k,a) . d1(_ij,bc)
c     -s1(_k,b) . d1(_ij,ac)
c     +s1(_k,c) . d1(_ij,ab)
c
       if ((symk.eq.syma).and.(symij.eq.symbc)) then
c
c1.a.3.*      find address for s1,d1
       is1=mapih3(1,1,1)
       id1=mapim3(symb,1,1)
c
c1.a.3.*      def possition of s1,d1
       posss1=mapdh3(is1,1)
       possd1=mapdm3(id1,1)
c
c1.a.3.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
       nhelp2=dima*(dima-1)*(dima-2)/6
c
c1.a.3.*      add singly
       call t3sglh11 (wrk(possw),dima,nhelp1,nhelp2,
     & wrk(posss1),wrk(possd1),1)
       end if
c
c
       else if (syma.eq.symb) then
c1.b  case syma=symb.ne.symc
c
c
c1.b.1----  first triade   W(abc) <- +s1(_i,a) . d1(_jk,bc)
c     -s1(_i,b) . d1(_jk,ac)
c     +s1(_i,c) . d1(_jk,ab)
c
       if ((symi.eq.syma).and.(symjk.eq.symbc)) then
c     if syma=symi, then obviously symc.ne.symi
c1.b.1.*      find address for s1,d1
       is1=mapih1(1,1,1)
       id1=mapim1(syma,1,1)
c
c1.b.1.*      def possition of s1,d1
       posss1=mapdh1(is1,1)
       possd1=mapdm1(id1,1)
c
c1.b.1.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
c
c1.b.1.*      add singly
       call t3sglh121 (wrk(possw),dima,nhelp1,dimc,
     & wrk(posss1),wrk(possd1),1)
       else if ((symc.eq.symi).and.(symjk.eq.symab)) then
c1.b.1.*      find address for s3,d3
       is3=mapih1(1,1,1)
       id3=mapim1(syma,1,1)
c
c1.b.1.*      def possition of s1,d3
       posss3=mapdh1(is3,1)
       possd3=mapdm1(id3,1)
c
c1.b.1.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
c
c1.b.1.*      add singly
       call t3sglh122 (wrk(possw),dima,nhelp1,dimc,
     & wrk(posss3),wrk(possd3),1)
       end if
c
c
c1.b.2----  2-nd. triade   W(abc) <- -s1(_j,a) . d1(_ik,bc)
c     +s1(_j,b) . d1(_ik,ac)
c     -s1(_j,c) . d1(_ik,ab)
c
       if ((symj.eq.syma).and.(symik.eq.symbc)) then
c     if syma=symj, then obviously symc.ne.symj
c1.b.2.*      find address for s1,d1
       is1=mapih2(1,1,1)
       id1=mapim2(syma,1,1)
c
c1.b.2.*      def possition of s1,d1
       posss1=mapdh2(is1,1)
       possd1=mapdm2(id1,1)
c
c1.b.2.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
c
c1.b.2.*      add singly
       call t3sglh121 (wrk(possw),dima,nhelp1,dimc,
     & wrk(posss1),wrk(possd1),-1)
       else if ((symc.eq.symj).and.(symik.eq.symab)) then
c1.b.2.*      find address for s3,d3
       is3=mapih2(1,1,1)
       id3=mapim2(syma,1,1)
c
c1.b.2.*      def possition of s1,d3
       posss3=mapdh2(is3,1)
       possd3=mapdm2(id3,1)
c
c1.b.2.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
c
c1.b.2.*      add singly
       call t3sglh122 (wrk(possw),dima,nhelp1,dimc,
     & wrk(posss3),wrk(possd3),-1)
       end if
c
c
c1.b.3----  3-rd. triade   W(abc) <- +s1(_k,a) . d1(_ij,bc)
c     -s1(_k,b) . d1(_ij,ac)
c     +s1(_k,c) . d1(_ij,ab)
c
       if ((symk.eq.syma).and.(symij.eq.symbc)) then
c     if syma=symk, then obviously symc.ne.symk
c1.b.3.*      find address for s1,d1
       is1=mapih3(1,1,1)
       id1=mapim3(syma,1,1)
c
c1.b.3.*      def possition of s1,d1
       posss1=mapdh3(is1,1)
       possd1=mapdm3(id1,1)
c
c1.b.3.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
c
c1.b.3.*      add singly
       call t3sglh121 (wrk(possw),dima,nhelp1,dimc,
     & wrk(posss1),wrk(possd1),1)
       else if ((symc.eq.symk).and.(symij.eq.symab)) then
c1.b.3.*      find address for s3,d3
       is3=mapih3(1,1,1)
       id3=mapim3(syma,1,1)
c
c1.b.3.*      def possition of s1,d3
       posss3=mapdh3(is3,1)
       possd3=mapdm3(id3,1)
c
c1.b.3.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
c
c1.b.3.*      add singly
       call t3sglh122 (wrk(possw),dima,nhelp1,dimc,
     & wrk(posss3),wrk(possd3),1)
       end if
c
c
       else if (symb.eq.symc) then
c1.c  case syma.ne.symb=symc
c
c1.c.1----  first triade   W(abc) <- +s1(_i,a) . d1(_jk,bc)
c     -s1(_i,b) . d1(_jk,ac)
c     +s1(_i,c) . d1(_jk,ab)
c
       if ((symi.eq.syma).and.(symjk.eq.symbc)) then
c     if syma=symi, then obviously symb(symc).ne.symi
c1.c.1.*      find address for s1,d1
       is1=mapih1(1,1,1)
       id1=mapim1(symb,1,1)
c
c1.c.1.*      def possition of s1,d1
       posss1=mapdh1(is1,1)
       possd1=mapdm1(id1,1)
c
c1.c.1.*      def additional dimensions
       nhelp1=dimb*(dimb-1)/2
c
c1.c.1.*      add singly
       call t3sglh131 (wrk(possw),dima,dimb,nhelp1,
     & wrk(posss1),wrk(possd1),1)
       else if ((symb.eq.symi).and.(symjk.eq.symac)) then
c1.c.1.*      find address for s3,d3
       is2=mapih1(1,1,1)
       id2=mapim1(syma,1,1)
c
c1.c.1.*      def possition of s1,d3
       posss2=mapdh1(is2,1)
       possd2=mapdm1(id2,1)
c
c1.c.1.*      def additional dimensions
       nhelp1=dimb*(dimb-1)/2
c
c1.c.1.*      add singly
       call t3sglh132 (wrk(possw),dima,dimb,nhelp1,
     & wrk(posss2),wrk(possd2),1)
       end if
c
c
c1.c.2----  2-nd. triade   W(abc) <- -s1(_j,a) . d1(_ik,bc)
c     +s1(_j,b) . d1(_ik,ac)
c     -s1(_j,c) . d1(_ik,ab)
c
       if ((symj.eq.syma).and.(symik.eq.symbc)) then
c     if syma=symj, then obviously symb(symc).ne.symi
c1.c.2.*      find address for s1,d1
       is1=mapih2(1,1,1)
       id1=mapim2(symb,1,1)
c
c1.c.2.*      def possition of s1,d1
       posss1=mapdh2(is1,1)
       possd1=mapdm2(id1,1)
c
c1.c.2.*      def additional dimensions
       nhelp1=dimb*(dimb-1)/2
c
c1.c.2.*      add singly
       call t3sglh131 (wrk(possw),dima,dimb,nhelp1,
     & wrk(posss1),wrk(possd1),-1)
       else if ((symb.eq.symj).and.(symik.eq.symac)) then
c1.c.2.*      find address for s3,d3
       is2=mapih2(1,1,1)
       id2=mapim2(syma,1,1)
c
c1.c.2.*      def possition of s1,d3
       posss2=mapdh2(is2,1)
       possd2=mapdm2(id2,1)
c
c1.c.2.*      def additional dimensions
       nhelp1=dimb*(dimb-1)/2
c
c1.c.2.*      add singly
       call t3sglh132 (wrk(possw),dima,dimb,nhelp1,
     & wrk(posss2),wrk(possd2),-1)
       end if
c
c
c1.c.3----  3-rd. triade   W(abc) <- +s1(_k,a) . d1(_ij,bc)
c     -s1(_k,b) . d1(_ij,ac)
c     +s1(_k,c) . d1(_ij,ab)
c
       if ((symk.eq.syma).and.(symij.eq.symbc)) then
c     if syma=symk, then obviously symb(symc).ne.symk
c1.c.3.*      find address for s1,d1
       is1=mapih3(1,1,1)
       id1=mapim3(symb,1,1)
c
c1.c.3.*      def possition of s1,d1
       posss1=mapdh3(is1,1)
       possd1=mapdm3(id1,1)
c
c1.c.3.*      def additional dimensions
       nhelp1=dimb*(dimb-1)/2
c
c1.c.3.*      add singly
       call t3sglh131 (wrk(possw),dima,dimb,nhelp1,
     & wrk(posss1),wrk(possd1),1)
       else if ((symb.eq.symk).and.(symij.eq.symac)) then
c1.c.3.*      find address for s3,d3
       is2=mapih3(1,1,1)
       id2=mapim3(syma,1,1)
c
c1.c.3.*      def possition of s1,d3
       posss2=mapdh3(is2,1)
       possd2=mapdm3(id2,1)
c
c1.c.3.*      def additional dimensions
       nhelp1=dimb*(dimb-1)/2
c
c1.c.3.*      add singly
       call t3sglh132 (wrk(possw),dima,dimb,nhelp1,
     & wrk(posss2),wrk(possd2),1)
       end if
c
c
       else
c1.d  case syma.ne.symb.ne.symc
c
c1.d.1----  first triade   W(abc) <- +s1(_i,a) . d1(_jk,bc)
c     -s1(_i,b) . d1(_jk,ac)
c     +s1(_i,c) . d1(_jk,ab)
c
       if ((symi.eq.syma).and.(symjk.eq.symbc)) then
c1.d.1.*      find address for s1,d1
       is1=mapih1(1,1,1)
       id1=mapim1(symb,1,1)
c
c1.d.1.*      def possition of s1,d1
       posss1=mapdh1(is1,1)
       possd1=mapdm1(id1,1)
c
c1.d.1.*      add singly
       call t3sglh141 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),1)
       else if ((symi.eq.symb).and.(symjk.eq.symac)) then
c1.d.1.*      find address for s2,d2
       is2=mapih1(1,1,1)
       id2=mapim1(syma,1,1)
c
c1.d.1.*      def possition of s1,d1
       posss2=mapdh1(is2,1)
       possd2=mapdm1(id2,1)
c
c1.d.1.*      add singly
       call t3sglh142 (wrk(possw),dima,dimb,dimc,
     & wrk(posss2),wrk(possd2),1)
       else if ((symi.eq.symc).and.(symjk.eq.symab)) then
c1.d.1.*      find address for s1,d1
       is3=mapih1(1,1,1)
       id3=mapim1(syma,1,1)
c
c1.d.1.*      def possition of s1,d1
       posss3=mapdh1(is3,1)
       possd3=mapdm1(id3,1)
c
c1.d.1.*      add singly
       call t3sglh143 (wrk(possw),dima,dimb,dimc,
     & wrk(posss3),wrk(possd3),1)
       end if
c
c
c1.d.2----  2-nd. triade   W(abc) <- -s1(_j,a) . d1(_ik,bc)
c     +s1(_j,b) . d1(_ik,ac)
c     -s1(_j,c) . d1(_ik,ab)
c
       if ((symj.eq.syma).and.(symik.eq.symbc)) then
c1.d.2.*      find address for s1,d1
       is1=mapih2(1,1,1)
       id1=mapim2(symb,1,1)
c
c1.d.2.*      def possition of s1,d1
       posss1=mapdh2(is1,1)
       possd1=mapdm2(id1,1)
c
c1.d.2.*      add singly
       call t3sglh141 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),-1)
       else if ((symj.eq.symb).and.(symik.eq.symac)) then
c1.d.2.*      find address for s2,d2
       is2=mapih2(1,1,1)
       id2=mapim2(syma,1,1)
c
c1.d.2.*      def possition of s1,d1
       posss2=mapdh2(is2,1)
       possd2=mapdm2(id2,1)
c
c1.d.2.*      add singly
       call t3sglh142 (wrk(possw),dima,dimb,dimc,
     & wrk(posss2),wrk(possd2),-1)
       else if ((symj.eq.symc).and.(symik.eq.symab)) then
c1.d.2.*      find address for s1,d1
       is3=mapih2(1,1,1)
       id3=mapim2(syma,1,1)
c
c1.d.2.*      def possition of s1,d1
       posss3=mapdh2(is3,1)
       possd3=mapdm2(id3,1)
c
c1.d.2.*      add singly
       call t3sglh143 (wrk(possw),dima,dimb,dimc,
     & wrk(posss3),wrk(possd3),-1)
       end if
c
c
c1.d.3----  3-rd. triade   W(abc) <- +s1(_k,a) . d1(_ij,bc)
c     -s1(_k,b) . d1(_ij,ac)
c     +s1(_k,c) . d1(_ij,ab)
c
       if ((symk.eq.syma).and.(symij.eq.symbc)) then
c1.d.3.*      find address for s1,d1
       is1=mapih3(1,1,1)
       id1=mapim3(symb,1,1)
c
c1.d.3.*      def possition of s1,d1
       posss1=mapdh3(is1,1)
       possd1=mapdm3(id1,1)
c
c1.d.3.*      add singly
       call t3sglh141 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),1)
       else if ((symk.eq.symb).and.(symij.eq.symac)) then
c1.d.3.*      find address for s2,d2
       is2=mapih3(1,1,1)
       id2=mapim3(syma,1,1)
c
c1.d.3.*      def possition of s1,d1
       posss2=mapdh3(is2,1)
       possd2=mapdm3(id2,1)
c
c1.d.3.*      add singly
       call t3sglh142 (wrk(possw),dima,dimb,dimc,
     & wrk(posss2),wrk(possd2),1)
       else if ((symk.eq.symc).and.(symij.eq.symab)) then
c1.d.3.*      find address for s1,d1
       is3=mapih3(1,1,1)
       id3=mapim3(syma,1,1)
c
c1.d.3.*      def possition of s1,d1
       posss3=mapdh3(is3,1)
       possd3=mapdm3(id3,1)
c
c1.d.3.*      add singly
       call t3sglh143 (wrk(possw),dima,dimb,dimc,
     & wrk(posss3),wrk(possd3),1)
       end if
c
c
       end if
c
 100    continue
c
c
       else if (typdiv.eq.2) then
c2    case W(pq,r)
c
c2.*  ext H1(a) <= S1(a,i) for given i
       call ext(wrk,wrksize,
     & 2,2,i,0,0,symi,0,0,mapds1,mapis1,1,
     & possh10,mapdh1,mapih1,ssh1,rc1)
c
c2.*  ext H2(a) <= S1(a,j) for given j
       call ext(wrk,wrksize,
     & 2,2,j,0,0,symj,0,0,mapds1,mapis1,1,
     & possh20,mapdh2,mapih2,ssh2,rc1)
c
c2.*  ext H3(a) <= S2(a,k) for given k
       call ext(wrk,wrksize,
     & 2,2,k,0,0,symk,0,0,mapds2,mapis2,1,
     & possh30,mapdh3,mapih3,ssh3,rc1)
c
c2.*  ext M1(bc) <= D2(bc,jk) for given jk
       call ext(wrk,wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdd2,mapid2,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.*  ext M2(bc) <= D2(bc,ik) for given ik
       call ext(wrk,wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdd2,mapid2,1,
     & possm20,mapdm2,mapim2,ssm2,rc1)
c
c2.*  ext M3(bc) <= D1(bc,ij) for given ij
       call ext(wrk,wrksize,
     & 4,7,i,j,0,symi,symj,0,mapdd1,mapid1,1,
     & possm30,mapdm3,mapim3,ssm3,rc1)
c
c
       do 200 iw=1,mapdw(0,5)
c
c2.*  def possition of W
       possw=mapdw(iw,1)
c
c2.*  def symmetry status
       syma=mapdw(iw,3)
       symb=mapdw(iw,4)
       symc=mapdw(iw,5)
c
c2.*  def dimensions
       dima=dimm(mapdw(0,1),syma)
       dimb=dimm(mapdw(0,2),symb)
       dimc=dimm(mapdw(0,3),symc)
c2.*
       symij=mmul(symi,symj)
       symik=mmul(symi,symk)
       symjk=mmul(symj,symk)
       symab=mmul(syma,symb)
       symac=mmul(syma,symc)
       symbc=mmul(symb,symc)
c
c2.*  add singles
       if (syma.eq.symb) then
c2.a  case syma=symb,symc
c
c2.a.11.st.diade  W(ab,c)<- +s1(_i,a) . d2(_j,_k,b,c)
c     -s1(_i,b) . d2(_j,_k,a,c)
c
       if ((syma.eq.symi).and.(symjk.eq.symbc)) then
c2.a.1.*      find address for s1,d1
       is1=mapih1(1,1,1)
       id1=mapim1(syma,1,1)
c
c2.a.1.*      def possition of s1,d1
       posss1=mapdh1(is1,1)
       possd1=mapdm1(id1,1)
c
c2.a.1.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
c
c2.a.1.*      add singly
       call t3sglh211 (wrk(possw),dima,nhelp1,dimc,
     & wrk(posss1),wrk(possd1),1)
       end if
c
c2.a.22.nd.diade        W(ab,c)<- -s1(_j,a) . d2(_i,_k,b,c)
c     +s1(_j,b) . d2(_i,_k,a,c)
c
       if ((syma.eq.symj).and.(symik.eq.symbc)) then
c2.a.2.*      find address for s1,d1
       is1=mapih2(1,1,1)
       id1=mapim2(syma,1,1)
c
c2.a.2.*      def possition of s1,d1
       posss1=mapdh2(is1,1)
       possd1=mapdm2(id1,1)
c
c2.a.1.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
c
c2.a.2.*      add singly
       call t3sglh211 (wrk(possw),dima,nhelp1,dimc,
     & wrk(posss1),wrk(possd1),-1)
       end if
c
c2.a.33.rd. part  W(ab,c)<- +s2(_k,c) . d1(_ij,ab)
c
       if ((symc.eq.symk).and.(symij.eq.symab)) then
c2.a.3.*      find address for s1,d1
       is1=mapih3(1,1,1)
       id1=mapim3(syma,1,1)
c
c2.a.3.*      def possition of s1,d1
       posss1=mapdh3(is1,1)
       possd1=mapdm3(id1,1)
c
c2.a.3.*      def additional dimensions
       nhelp1=dima*(dima-1)/2
c
c2.a.3.*      add singly
       call t3sglh212 (wrk(possw),dima,nhelp1,dimc,
     & wrk(posss1),wrk(possd1),1)
       end if
c
       else
c2.b  case syma>symb,symc
c
c2.b.11.st.diade  W(a>b,c)<- +s1(_i,a) . d2(_j,_k,b,c)
c     -s1(_i,b) . d2(_j,_k,a,c)
c
       if ((syma.eq.symi).and.(symjk.eq.symbc)) then
c2.b.1.*      find address for s1,d1
       is1=mapih1(1,1,1)
       id1=mapim1(symb,1,1)
c
c2.b.1.*      def possition of s1,d1
       posss1=mapdh1(is1,1)
       possd1=mapdm1(id1,1)
c
c2.b.1.*      add singly
       call t3sglh221 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),1)
       else if ((symb.eq.symi).and.(symjk.eq.symac)) then
c2.b.1.*      find address for s2,d2
       is2=mapih1(1,1,1)
       id2=mapim1(syma,1,1)
c
c2.b.1.*      def possition of s1,d1
       posss2=mapdh1(is2,1)
       possd2=mapdm1(id2,1)
c
c2.b.1.*      add singly
       call t3sglh222 (wrk(possw),dima,dimb,dimc,
     & wrk(posss2),wrk(possd2),1)
       end if
c
c2.a.22.nd.diade        W(ab,c)<- -s1(_j,a) . d2(_i,_k,b,c)
c     +s1(_j,b) . d2(_i,_k,a,c)
c
       if ((syma.eq.symj).and.(symik.eq.symbc)) then
c2.b.2.*      find address for s1,d1
       is1=mapih2(1,1,1)
       id1=mapim2(symb,1,1)
c
c2.b.2.*      def possition of s1,d1
       posss1=mapdh2(is1,1)
       possd1=mapdm2(id1,1)
c
c2.b.2.*      add singly
       call t3sglh221 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),-1)
       else if ((symb.eq.symj).and.(symik.eq.symac)) then
c2.b.2.*      find address for s2,d2
       is2=mapih2(1,1,1)
       id2=mapim2(syma,1,1)
c
c2.b.2.*      def possition of s1,d1
       posss2=mapdh2(is2,1)
       possd2=mapdm2(id2,1)
c
c2.b.2.*      add singly
       call t3sglh222 (wrk(possw),dima,dimb,dimc,
     & wrk(posss2),wrk(possd2),-1)
       end if
c
c2.a.33.rd. part  W(ab,c)<- +s2(_k,c) . d1(_ij,ab)
c
       if ((symc.eq.symk).and.(symij.eq.symab)) then
c2.b.3.*      find address for s1,d1
       is3=mapih3(1,1,1)
       id3=mapim3(syma,1,1)
c
c2.b.3.*      def possition of s1,d1
       posss3=mapdh3(is3,1)
       possd3=mapdm3(id3,1)
c
c2.b.3.*      add singly
       call t3sglh223 (wrk(possw),dima,dimb,dimc,
     & wrk(posss3),wrk(possd3),1)
       end if
c
       end if
c
 200    continue
c
c
       else if (typdiv.eq.3) then
c3    case B(p,qr)
c
c3.*  ext H1(a) <= S1(a,i) for given i
       call ext(wrk,wrksize,
     & 2,2,i,0,0,symi,0,0,mapds1,mapis1,1,
     & possh10,mapdh1,mapih1,ssh1,rc1)
c
c3.*  ext H2(a) <= S2(a,j) for given j
       call ext(wrk,wrksize,
     & 2,2,j,0,0,symj,0,0,mapds2,mapis2,1,
     & possh20,mapdh2,mapih2,ssh2,rc1)
c
c3.*  ext H3(a) <= S2(a,k) for given k
       call ext(wrk,wrksize,
     & 2,2,k,0,0,symk,0,0,mapds2,mapis2,1,
     & possh30,mapdh3,mapih3,ssh3,rc1)
c
c3.*  ext M1(bc) <= D2(bc,jk) for given jk
       call ext(wrk,wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdd2,mapid2,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.*  ext M2(bc) <= D1(bc,ik) for given ik
       call ext(wrk,wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdd1,mapid1,1,
     & possm20,mapdm2,mapim2,ssm2,rc1)
c
c3.*  ext M3(bc) <= D1(bc,ij) for given ij
       call ext(wrk,wrksize,
     & 4,7,i,j,0,symi,symj,0,mapdd1,mapid1,1,
     & possm30,mapdm3,mapim3,ssm3,rc1)
c
c
       do 300 iw=1,mapdw(0,5)
c
c3.*  def possition of W,V
       possw=mapdw(iw,1)
c
c3.*  def symmetry status
       syma=mapdw(iw,3)
       symb=mapdw(iw,4)
       symc=mapdw(iw,5)
c
c3.*  def dimensions
       dima=dimm(mapdw(0,1),syma)
       dimb=dimm(mapdw(0,2),symb)
       dimc=dimm(mapdw(0,3),symc)
c
c3.*  realize packing
c
       if (symb.eq.symc) then
c3.a  case syma,symb=symc
c
c3.a.11.st  part  W(a,bc)<- +s1(_i,a) . d2(_jk,b,c)
c
       if (symi.eq.syma) then
c3.a.1.*      find address for s1,d1
       is1=mapih1(1,1,1)
       id1=mapim1(symb,1,1)
c
c3.a.1.*      def possition of s1,d1
       posss1=mapdh1(is1,1)
       possd1=mapdm1(id1,1)
c
c3.a.1.*      def additional dimensions
       nhelp1=dimb*(dimb-1)/2
c
c3.a.1.*      add singly
       call t3sglh312 (wrk(possw),dima,dimb,nhelp1,
     & wrk(posss1),wrk(possd1),1)
       end if
c
c3.a.22.nd.diade        W(a,bc)<- +s1(_j,b) . d2(_i,_k,a,c)
c     -s1(_j,c) . d2(_i,_k,a,b)
c
       if (symj.eq.symb) then
c3.a.2.*      find address for s1,d1
       is1=mapih2(1,1,1)
       id1=mapim2(syma,1,1)
c
c3.a.2.*      def possition of s1,d1
       posss1=mapdh2(is1,1)
       possd1=mapdm2(id1,1)
c
c3.a.2.*      def additional dimensions
       nhelp1=dimb*(dimb-1)/2
c
c3.a.2.*      add singly
       call t3sglh311 (wrk(possw),dima,dimb,nhelp1,
     & wrk(posss1),wrk(possd1),1)
       end if
c
c
c3.a.33.rd.diade  W(a,bc)<- -s1(_k,b) . d2(_i,_j,a,c)
c     +s1(_k,c) . d2(_i,_j,a,b)
c
       if (symk.eq.symb) then
c3.a.3.*      find address for s1,d1
       is1=mapih3(1,1,1)
       id1=mapim3(syma,1,1)
c
c3.a.3.*      def possition of s1,d1
       posss1=mapdh3(is1,1)
       possd1=mapdm3(id1,1)
c
c3.a.3.*      def additional dimensions
       nhelp1=dimb*(dimb-1)/2
c
c3.a.3.*      add singly
       call t3sglh311 (wrk(possw),dima,dimb,nhelp1,
     & wrk(posss1),wrk(possd1),-1)
       end if
c
       else
c3.b  case syma,symb.ne.symc
c
c3.b.11.st  part  W(a,bc)<- +s1(_i,a) . d2(_jk,b,c)
c
       if (symi.eq.syma) then
c3.b.1.*      find address for s1,d1
       is1=mapih1(1,1,1)
       id1=mapim1(symb,1,1)
c
c3.b.1.*      def possition of s1,d1
       posss1=mapdh1(is1,1)
       possd1=mapdm1(id1,1)
c
c3.b.1.*      add singly
       call t3sglh323 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),1)
       end if
c
c3.b.22.nd.diade        W(a,bc)<- +s1(_j,b) . d2(_i,_k,a,c)
c     -s1(_j,c) . d2(_i,_k,a,b)
c
       if (symj.eq.symb) then
c3.b.2.*      find address for s1,d1
       is1=mapih2(1,1,1)
       id1=mapim2(syma,1,1)
c
c3.b.2.*      def possition of s1,d1
       posss1=mapdh2(is1,1)
       possd1=mapdm2(id1,1)
c
c3.b.2.*      add singly
       call t3sglh321 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),1)
       else if (symj.eq.symc) then
c3.b.2.*      find address for s1,d1
       is1=mapih2(1,1,1)
       id1=mapim2(syma,1,1)
c
c3.b.2.*      def possition of s1,d1
       posss1=mapdh2(is1,1)
       possd1=mapdm2(id1,1)
c
c3.b.2.*      add singly
       call t3sglh322 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),1)
       end if
c
c
c3.b.33.rd.diade  W(a,bc)<- -s1(_k,b) . d2(_i,_j,a,c)
c     +s1(_k,c) . d2(_i,_j,a,b)
c
       if (symk.eq.symb) then
c3.b.3.*      find address for s1,d1
       is1=mapih3(1,1,1)
       id1=mapim3(syma,1,1)
c
c3.b.3.*      def possition of s1,d1
       posss1=mapdh3(is1,1)
       possd1=mapdm3(id1,1)
c
c3.b.3.*      add singly
       call t3sglh321 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),-1)
       else if (symk.eq.symc) then
c3.b.3.*      find address for s1,d1
       is1=mapih3(1,1,1)
       id1=mapim3(syma,1,1)
c
c3.b.3.*      def possition of s1,d1
       posss1=mapdh3(is1,1)
       possd1=mapdm3(id1,1)
c
c3.b.3.*      add singly
       call t3sglh322 (wrk(possw),dima,dimb,dimc,
     & wrk(posss1),wrk(possd1),-1)
       end if
c
c
       end if
c
 300    continue
c
c
       else
c     RC=1 , typdiv is not 1,2,3 (NCI)
       rc=1
       return
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(ssw)
       end
c
c     -----------------------------
c
       subroutine t3sglh11 (w,dima,dimab,dimabc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma=symb=symc
c
c     W(abc)  <-  + S1 _i(a) . D1 _jk(bc)
c     - S1 _i(b) . D1 _jk(ac)
c     + S1 _i(c) . D1 _jk(ab)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b,c) index (I)
c     dimab  - dimension of ab (ac,bc) index (I)
c     dimabc - dimension of abc index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
#include "t31.fh"
       integer dima,dimab,dimabc,ns
       real*8 w(1:dimabc)
       real*8 s1(1:dima)
       real*8 d1(1:dimab)
c
c     help variables
c
       integer a,b,c,ab0,ac0,bc0,abc
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       abc=0
       do 100 a=3,dima
       s=s1(a)
       do 101 b=2,a-1
       bc0=nshf(b)
       do 102 c=1,b-1
       abc=abc+1
       w(abc)=w(abc)+d1(bc0+c)*s
 102    continue
 101    continue
 100    continue
c
       abc=0
       do 110 a=3,dima
       ac0=nshf(a)
       do 111 b=2,a-1
       s=s1(b)
       do 112 c=1,b-1
       abc=abc+1
       w(abc)=w(abc)-d1(ac0+c)*s
 112    continue
 111    continue
 110    continue
c
       abc=0
       do 120 a=3,dima
       ab0=nshf(a)
       do 121 b=2,a-1
       s=d1(ab0+b)
       do 122 c=1,b-1
       abc=abc+1
       w(abc)=w(abc)+s1(c)*s
 122    continue
 121    continue
 120    continue
c
       else
c     phase -1
c
       abc=0
       do 200 a=3,dima
       s=s1(a)
       do 201 b=2,a-1
       bc0=nshf(b)
       do 202 c=1,b-1
       abc=abc+1
       w(abc)=w(abc)-d1(bc0+c)*s
 202    continue
 201    continue
 200    continue
c
       abc=0
       do 210 a=3,dima
       ac0=nshf(a)
       do 211 b=2,a-1
       s=s1(b)
       do 212 c=1,b-1
       abc=abc+1
       w(abc)=w(abc)+d1(ac0+c)*s
 212    continue
 211    continue
 210    continue
c
       abc=0
       do 220 a=3,dima
       ab0=nshf(a)
       do 221 b=2,a-1
       s=d1(ab0+b)
       do 222 c=1,b-1
       abc=abc+1
       w(abc)=w(abc)-s1(c)*s
 222    continue
 221    continue
 220    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh121 (w,dima,dimab,dimc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma=symb > symc
c
c     W(ab,c) <-  + S1 _i(a) . D1 _jk(b,c)
c     - S1 _i(b) . D1 _jk(a,c)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b) index (I)
c     dimab   - dimension of ab index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimab,dimc,ns
       real*8 w(1:dimab,1:dimc)
       real*8 s1(1:dima)
       real*8 d1(1:dima,1:dimc)
c
c     help variables
c
       integer a,b,c,ab
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 100 c=1,dimc
       ab=0
       do 101 a=2,dima
       s=s1(a)
       do 102 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)+d1(b,c)*s
 102    continue
 101    continue
 100    continue
c
       do 110 c=1,dimc
       ab=0
       do 111 a=2,dima
       s=d1(a,c)
       do 112 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)-s1(b)*s
 112    continue
 111    continue
 110    continue
c
       else
c     phase -1
c
       do 200 c=1,dimc
       ab=0
       do 201 a=2,dima
       s=s1(a)
       do 202 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)-d1(b,c)*s
 202    continue
 201    continue
 200    continue
c
       do 210 c=1,dimc
       ab=0
       do 211 a=2,dima
       s=d1(a,c)
       do 212 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)+s1(b)*s
 212    continue
 211    continue
 210    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh122 (w,dima,dimab,dimc,s3,d3,ns)
c
c     this routine add following contribution to W
c     for syma=symb > symc
c
c     W(ab,c) <-  + S3 _i(c) . D3 _jk(ab)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b) index (I)
c     dimab   - dimension of ab index (I)
c     dimc   - dimension of c index (I)
c     s3     - S3 matrix (I)
c     d3     - D3 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimab,dimc,ns
       real*8 w(1:dimab,1:dimc)
       real*8 s3(1:dimc)
       real*8 d3(1:dimab)
c
c     help variables
c
       integer c,ab
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 120 c=1,dimc
       s=s3(c)
       do 121 ab=1,dimab
       w(ab,c)=w(ab,c)+d3(ab)*s
 121    continue
 120    continue
c
       else
c     phase -1
c
       do 220 c=1,dimc
       s=s3(c)
       do 221 ab=1,dimab
       w(ab,c)=w(ab,c)-d3(ab)*s
 221    continue
 220    continue
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dima)
       end
c
c     ---------------
c
       subroutine t3sglh131 (w,dima,dimb,dimbc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma=symb > symc
c
c     W(a,bc) <-  + S1 _i(a) . D1 _jk(bc)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b) index (I)
c     dimab   - dimension of ab index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimbc,ns
       real*8 w(1:dima,1:dimbc)
       real*8 s1(1:dima)
       real*8 d1(1:dimbc)
c
c     help variables
c
       integer a,bc
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 100 bc=1,dimbc
       s=d1(bc)
       do 101 a=1,dima
       w(a,bc)=w(a,bc)+s1(a)*s
 101    continue
 100    continue
c
       else
c     phase -1
c
       do 200 bc=1,dimbc
       s=d1(bc)
       do 201 a=1,dima
       w(a,bc)=w(a,bc)-s1(a)*s
 201    continue
 200    continue
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dimb)
       end
c
c     ---------------
c
       subroutine t3sglh132 (w,dima,dimb,dimbc,s2,d2,ns)
c
c     this routine add following contribution to W
c     for syma=symb > symc
c
c     W(a,bc) <-  - S2 _i(b) . D2 _jk(a,c)
c     + S2 _i(c) . D2 _jk(a,b)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b) index (I)
c     dimab   - dimension of ab index (I)
c     dimc   - dimension of c index (I)
c     s2     - S2 matrix (I)
c     d2     - D2 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimbc,ns
       real*8 w(1:dima,1:dimbc)
       real*8 s2(1:dimb)
       real*8 d2(1:dima,1:dimb)
c
c     help variables
c
       integer a,b,c,bc
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       bc=0
       do 110 b=2,dimb
       s=s2(b)
       do 111 c=1,b-1
       bc=bc+1
       do 112 a=1,dima
       w(a,bc)=w(a,bc)-d2(a,c)*s
 112    continue
 111    continue
 110    continue
c
       bc=0
       do 120 b=2,dimb
       do 121 c=1,b-1
       s=s2(c)
       bc=bc+1
       do 122 a=1,dima
       w(a,bc)=w(a,bc)+d2(a,b)*s
 122    continue
 121    continue
 120    continue
c
       else
c     phase -1
c
       bc=0
       do 210 b=2,dimb
       s=s2(b)
       do 211 c=1,b-1
       bc=bc+1
       do 212 a=1,dima
       w(a,bc)=w(a,bc)+d2(a,c)*s
 212    continue
 211    continue
 210    continue
c
       bc=0
       do 220 b=2,dimb
       do 221 c=1,b-1
       s=s2(c)
       bc=bc+1
       do 222 a=1,dima
       w(a,bc)=w(a,bc)-d2(a,b)*s
 222    continue
 221    continue
 220    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh141 (w,dima,dimb,dimc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma>symb>symc
c
c     W(a,b,c) <- + S1 _i(a) . D1 _jk(b,c)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s1(1:dima)
       real*8 d1(1:dimb,1:dimc)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 100 c=1,dimc
       do 101 b=1,dimb
       s=d1(b,c)
       do 102 a=1,dima
       w(a,b,c)=w(a,b,c)+s1(a)*s
 102    continue
 101    continue
 100    continue
c
       else
c     phase = -1
c
       do 200 c=1,dimc
       do 201 b=1,dimb
       s=d1(b,c)
       do 202 a=1,dima
       w(a,b,c)=w(a,b,c)-s1(a)*s
 202    continue
 201    continue
 200    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh142 (w,dima,dimb,dimc,s2,d2,ns)
c
c     this routine add following contribution to W
c     for syma>symb>symc
c
c     W(a,b,c) <- - S2 _i(b) . D2 _jk(a,c)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s2     - S2 matrix (I)
c     d2     - D2 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s2(1:dimb)
       real*8 d2(1:dima,1:dimc)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 110 c=1,dimc
       do 111 b=1,dimb
       s=s2(b)
       do 112 a=1,dima
       w(a,b,c)=w(a,b,c)-d2(a,c)*s
 112    continue
 111    continue
 110    continue
c
       else
c     phase = -1
c
       do 210 c=1,dimc
       do 211 b=1,dimb
       s=s2(b)
       do 212 a=1,dima
       w(a,b,c)=w(a,b,c)+d2(a,c)*s
 212    continue
 211    continue
 210    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh143 (w,dima,dimb,dimc,s3,d3,ns)
c
c     this routine add following contribution to W
c     for syma>symb>symc
c
c     W(a,b,c) <- + S3 _i(c) . D3 _jk(a,b)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s3     - S3 matrix (I)
c     d3     - D3 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s3(1:dimc)
       real*8 d3(1:dima,1:dimb)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 120 c=1,dimc
       s=s3(c)
       do 121 b=1,dimb
       do 122 a=1,dima
       w(a,b,c)=w(a,b,c)+d3(a,b)*s
 122    continue
 121    continue
 120    continue
c
       else
c     phase = -1
c
       do 220 c=1,dimc
       s=s3(c)
       do 221 b=1,dimb
       do 222 a=1,dima
       w(a,b,c)=w(a,b,c)-d3(a,b)*s
 222    continue
 221    continue
 220    continue
c
       end if
c
       return
       end
c
c     -----------------------------
c
       subroutine t3sglh211 (w,dima,dimab,dimc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma=symb;symc
c
c     W(ab,c) <-  + S1 _i(a) . D1 _jk(b,c)
c     - S1 _i(b) . D1 _jk(a,c)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b) index (I)
c     dimab  - dimension of ab  index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimab,dimc,ns
       real*8 w(1:dimab,1:dimc)
       real*8 s1(1:dima)
       real*8 d1(1:dima,1:dimc)
c
c     help variables
c
       integer a,b,c,ab
       real*8 s
c
       if (ns.eq.1) then
c     phase + 1
c
       do 100 c=1,dimc
       ab=0
       do 101 a=2,dima
       s=s1(a)
       do 102 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)+d1(b,c)*s
 102    continue
 101    continue
 100    continue
c
       do 110 c=1,dimc
       ab=0
       do 111 a=2,dima
       s=d1(a,c)
       do 112 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)-s1(b)*s
 112    continue
 111    continue
 110    continue
c
       else
c     phase - 1
c
       do 200 c=1,dimc
       ab=0
       do 201 a=2,dima
       s=s1(a)
       do 202 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)-d1(b,c)*s
 202    continue
 201    continue
 200    continue
c
       do 210 c=1,dimc
       ab=0
       do 211 a=2,dima
       s=d1(a,c)
       do 212 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)+s1(b)*s
 212    continue
 211    continue
 210    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh212 (w,dima,dimab,dimc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma=symb;symc
c
c     W(ab,c) <-  + S1 _i(c) . D1 _jk(ab)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b) index (I)
c     dimab  - dimension of ab (ac,bc) index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimab,dimc,ns
       real*8 w(1:dimab,1:dimc)
       real*8 s1(1:dimc)
       real*8 d1(1:dimab)
c
c     help variables
c
       integer c,ab
       real*8 s
c
       if (ns.eq.1) then
c     phase + 1
c
       do 100 c=1,dimc
       s=s1(c)
       do 101 ab=1,dimab
       w(ab,c)=w(ab,c)+d1(ab)*s
 101    continue
 100    continue
c
       else
c     phase - 1
c
       do 200 c=1,dimc
       s=s1(c)
       do 201 ab=1,dimab
       w(ab,c)=w(ab,c)-d1(ab)*s
 201    continue
 200    continue
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dima)
       end
c
c     ---------------
c
       subroutine t3sglh221 (w,dima,dimb,dimc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma>symb;symc
c
c     W(a,b;c) <- + S1 _i(a) . D1 _jk(b,c)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s1(1:dima)
       real*8 d1(1:dimb,1:dimc)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase + 1
c
       do 100 c=1,dimc
       do 101 b=1,dimb
       s=d1(b,c)
       do 102 a=1,dima
       w(a,b,c)=w(a,b,c)+s1(a)*s
 102    continue
 101    continue
 100    continue
c
       else
c     phase - 1
c
       do 200 c=1,dimc
       do 201 b=1,dimb
       s=d1(b,c)
       do 202 a=1,dima
       w(a,b,c)=w(a,b,c)-s1(a)*s
 202    continue
 201    continue
 200    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh222 (w,dima,dimb,dimc,s2,d2,ns)
c
c     this routine add following contribution to W
c     for syma>symb;symc
c
c     W(a,b;c) <- - S2 _i(b) . D2 _jk(a,c)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s2     - S2 matrix (I)
c     d2     - D2 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s2(1:dimb)
       real*8 d2(1:dima,1:dimc)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase + 1
c
       do 110 c=1,dimc
       do 111 b=1,dimb
       s=s2(b)
       do 112 a=1,dima
       w(a,b,c)=w(a,b,c)-d2(a,c)*s
 112    continue
 111    continue
 110    continue
c
       else
c     phase - 1
c
       do 210 c=1,dimc
       do 211 b=1,dimb
       s=s2(b)
       do 212 a=1,dima
       w(a,b,c)=w(a,b,c)+d2(a,c)*s
 212    continue
 211    continue
 210    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh223 (w,dima,dimb,dimc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma>symb;symc
c
c     W(a,b;c) <- + S1 _i(c) . D1 _jk(a,b)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s1(1:dimc)
       real*8 d1(1:dima,1:dimb)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase + 1
c
       do 100 c=1,dimc
       s=s1(c)
       do 101 b=1,dimb
       do 102 a=1,dima
       w(a,b,c)=w(a,b,c)+d1(a,b)*s
 102    continue
 101    continue
 100    continue
c
       else
c     phase - 1
c
       do 200 c=1,dimc
       s=s1(c)
       do 201 b=1,dimb
       do 202 a=1,dima
       w(a,b,c)=w(a,b,c)-d1(a,b)*s
 202    continue
 201    continue
 200    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh311 (w,dima,dimb,dimbc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma;symb=symc
c
c     W(a;bc)  <- + S1 _i(b) . D1 _jk(a,c)
c     - S1 _i(c) . D2 _jk(a,b)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b (c) index (I)
c     dimbc  - dimension of bc index (I)
c     s1     - S1 matrix (I)
c     s2     - S2 matrix (I)
c     d1     - D1 matrix (I)
c     d2     - D2 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimbc,ns
       real*8 w(1:dima,1:dimbc)
       real*8 s1(1:dimb)
       real*8 d1(1:dima,1:dimb)
c
c     help variables
c
       integer a,b,c,bc
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       bc=0
       do 100 b=2,dimb
       s=s1(b)
       do 101 c=1,b-1
       bc=bc+1
       do 102 a=1,dima
       w(a,bc)=w(a,bc)+d1(a,c)*s
 102    continue
 101    continue
 100    continue
c
       bc=0
       do 110 b=2,dimb
       do 111 c=1,b-1
       bc=bc+1
       s=s1(c)
       do 112 a=1,dima
       w(a,bc)=w(a,bc)-d1(a,b)*s
 112    continue
 111    continue
 110    continue
c
       else
c     phase - 1
c
       bc=0
       do 200 b=2,dimb
       s=s1(b)
       do 201 c=1,b-1
       bc=bc+1
       do 202 a=1,dima
       w(a,bc)=w(a,bc)-d1(a,c)*s
 202    continue
 201    continue
 200    continue
c
       bc=0
       do 210 b=2,dimb
       do 211 c=1,b-1
       bc=bc+1
       s=s1(c)
       do 212 a=1,dima
       w(a,bc)=w(a,bc)+d1(a,b)*s
 212    continue
 211    continue
 210    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh312 (w,dima,dimb,dimbc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma;symb=symc
c
c     W(a;bc)  <- + S1 _i(a) . D1 _jk(bc)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b (c) index (I)
c     dimbc  - dimension of bc index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimbc,ns
       real*8 w(1:dima,1:dimbc)
       real*8 s1(1:dima)
       real*8 d1(1:dimbc)
c
c     help variables
c
       integer a,bc
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 100 bc=1,dimbc
       s=d1(bc)
       do 101 a=1,dima
       w(a,bc)=w(a,bc)+s1(a)*s
 101    continue
 100    continue
c
       else
c     phase - 1
c
       do 200 bc=1,dimbc
       s=d1(bc)
       do 201 a=1,dima
       w(a,bc)=w(a,bc)-s1(a)*s
 201    continue
 200    continue
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dimb)
       end
c
c     ---------------
c
       subroutine t3sglh321 (w,dima,dimb,dimc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma;symb>symc
c
c     W(a;b,c) <- + S1 _i(b) . D1 _jk(a,c)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s1(1:dimb)
       real*8 d1(1:dima,1:dimc)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 100 c=1,dimc
       do 101 b=1,dimb
       s=s1(b)
       do 102 a=1,dima
       w(a,b,c)=w(a,b,c)+d1(a,c)*s
 102    continue
 101    continue
 100    continue
c
       else
c     phase -1
c
       do 200 c=1,dimc
       do 201 b=1,dimb
       s=s1(b)
       do 202 a=1,dima
       w(a,b,c)=w(a,b,c)-d1(a,c)*s
 202    continue
 201    continue
 200    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh322 (w,dima,dimb,dimc,s2,d2,ns)
c
c     this routine add following contribution to W
c     for syma;symb>symc
c
c     W(a;b,c) <- - S2 _i(c) . D2 _jk(a,b)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s2     - S2 matrix (I)
c     d2     - D2 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s2(1:dimc)
       real*8 d2(1:dima,1:dimb)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 110 c=1,dimc
       s=s2(c)
       do 111 b=1,dimb
       do 112 a=1,dima
       w(a,b,c)=w(a,b,c)-d2(a,b)*s
 112    continue
 111    continue
 110    continue
c
       else
c     phase -1
c
       do 210 c=1,dimc
       s=s2(c)
       do 211 b=1,dimb
       do 212 a=1,dima
       w(a,b,c)=w(a,b,c)+d2(a,b)*s
 212    continue
 211    continue
 210    continue
c
       end if
c
       return
       end
c
c     ---------------
c
       subroutine t3sglh323 (w,dima,dimb,dimc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma;symb>symc
c
c     W(a;b,c) <- + S1 _i(a) . D1 _jk(b,c)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimc,ns
       real*8 w(1:dima,1:dimb,1:dimc)
       real*8 s1(1:dima)
       real*8 d1(1:dimb,1:dimc)
c
c     help variables
c
       integer a,b,c
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 100 c=1,dimc
       do 101 b=1,dimb
       s=d1(b,c)
       do 102 a=1,dima
       w(a,b,c)=w(a,b,c)+s1(a)*s
 102    continue
 101    continue
 100    continue
c
       else
c     phase -1
c
       do 200 c=1,dimc
       do 201 b=1,dimb
       s=d1(b,c)
       do 202 a=1,dima
       w(a,b,c)=w(a,b,c)-s1(a)*s
 202    continue
 201    continue
 200    continue
c
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine IAIBCM_GAS(LCMBSPC,ICMBSPC,MNMXOC,NOCTPA,NOCTPB,IOCA,IOCB,NELFTP,MXPNGAS,NGAS,IOCOC)
! Allowed combinations of alpha and beta types, GAS version
!
! =====
! Input
! =====
!
! LCMBSPC : Number of GAS spaces included in this expnasion
! ICMBSPC : Gas spaces included in this expansion
!
! MXMNOC(IGAS,1,IGASSPC) : Min accumulated occ for AS 1-IGAS for space IGASSPC
! MXMNOC(IGAS,2,IGASSPC) : Max accumulated occ for AS 1-IGAS for space IGASSPC
!
! NOCTPA : Number of alpha types
! NOCTPB : Number of beta types
!
! IOCA(IGAS,ISTR) occupation of AS IGAS for alpha string type ISTR
! IOCB(IGAS,ISTR) occupation of AS IGAS for beta  string type ISTR
!
! MXPNGAS : Largest allowed number of gas spaces
! NGAS    : Actual number of gas spaces
!
! ======
! Output
! ======
!
! IOCOC(IATP,IBTP) == 1 =>     allowed combination
! IOCOC(IATP,IBTP) == 0 => not allowed combination

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: LCMBSPC, ICMBSPC(LCMBSPC), MXPNGAS, MNMXOC(MXPNGAS,2,*), NOCTPA, NOCTPB, IOCA(MXPNGAS,NOCTPA), &
                                 IOCB(MXPNGAS,NOCTPB), NELFTP(*), NGAS
integer(kind=iwp), intent(out) :: IOCOC(NOCTPA,NOCTPB)
integer(kind=iwp) :: IAMOKAY, IATP, IBTP, IEL, IGAS, INC, JCMBSPC, JJCMBSPC
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: II

write(u6,*) ' IAICBM_GAS entered'
write(u6,*) ' ==================='
write(u6,*)
write(u6,*) ' Number of GAS spaces included ',LCMBSPC
write(u6,*) ' GAS spaces included ',(ICMBSPC(II),II=1,LCMBSPC)
write(u6,*)
write(u6,*) ' IOCA and IOCB'
call IWRTMA(IOCA,NGAS,NOCTPA,MXPNGAS,NGAS)
call IWRTMA(IOCB,NGAS,NOCTPB,MXPNGAS,NGAS)
#endif

IOCOC(:,:) = 0
do IATP=1,NOCTPA
  do IBTP=1,NOCTPB
    ! is this combination allowed in any of the GAS spaces included
    INC = 0
    do JJCMBSPC=1,LCMBSPC
      JCMBSPC = ICMBSPC(JJCMBSPC)
      IEL = 0
      IAMOKAY = 1
      do IGAS=1,NGAS
        IEL = IEL+NELFTP(IOCA(IGAS,IATP))+NELFTP(IOCB(IGAS,IBTP))
        if ((IEL < MNMXOC(IGAS,1,JCMBSPC)) .or. (IEL > MNMXOC(IGAS,2,JCMBSPC))) IAMOKAY = 0
      end do
      if (IAMOKAY == 1) INC = 1
    end do

    !if (I_RE_MS2_SPACE /= 0) then
    !  ! Spin projection after space I_RE_MS2_SPACE :
    !  MS2_INTERM = 0
    !  do IGAS=1,I_RE_MS2_SPACE
    !    MS2_INTERM = MS2_INTERM+NELFTP(IOCA(IGAS,IATP))-NELFTP(IOCB(IGAS,IBTP))
    !  end do
    !  if (MS2_INTERM /= I_RE_MS2_VALUE) INC = 0
    !end if

    ! Congratulations, you are allowed
    if (INC == 1) IOCOC(IATP,IBTP) = 1
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' Matrix giving allowed combinations of types'
write(u6,*)
call IWRTMA(IOCOC,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
#endif

end subroutine IAIBCM_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE H0DIAG_CASPT2(ISYCI,DIAG,NOW,IOW)
      IMPLICIT REAL*8 (A-H,O-Z)
C INPUT ARRAYS:

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "pt2_guga.fh"
#include "WrkSpc.fh"
      DIMENSION DIAG(MXCI),NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)

C PURPOSE: FORM AN ARRAY OF DIAGONAL HAMILTONIAN MATRIX ELEMENTS
C FOR THE SPECIFIED TOTAL SYMMETRY ISYCI

      CALL DCOPY_(MXCI,[0.0D0],0,DIAG,1)
      IEMU=1
      DO MV=1,NMIDV
        DO ISYUP=1,NSYM
          NUP=NOW(1,ISYUP,MV)
          IF(NUP.EQ.0) GOTO 30
          ISYDWN=MUL(ISYUP,ISYCI)
          NDWN=NOW(2,ISYDWN,MV)
          IF(NDWN.EQ.0) GOTO 30
          ICS=LICASE+IOW(1,ISYUP,MV)
          JCS=LICASE+IOW(2,ISYDWN,MV)
          NC=NUP*NDWN
          CALL DIELMV(IWORK(ICS),IWORK(JCS),NUP,NDWN,DIAG(IEMU))
          IEMU=IEMU+NC
  30      CONTINUE
        END DO
      END DO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Giovanni Ghigo                                   *
!***********************************************************************

subroutine put_tra_comm(IBD2M,NSYMX,NORBX,NOSHX,LUINTMX)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IBD2M(3,36*36), NSYMX, NORBX(8), NOSHX(8), LUINTMX
#include "intgrl.fh"

IAD2M(:,:) = IBD2M(:,:)
NSYMZ = NSYMX
NORBZ(:) = NORBX(:)
NOSHZ(:) = NOSHX(:)
LUINTMZ = LUINTMX

return

end subroutine put_tra_comm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Steven Vancoillie                                *
************************************************************************
************************************************************************
* Written by Steven Vancoillie, May 2011
* A set of subroutines that can handle RHS arrays in either a serial or
* parallel environment, depending on the situation.
************************************************************************
* --> when running serially, the RHS arrays are stored on LUSOLV and are
* loaded into the WORK array when needed.
* --> when running in parallel, the RHS arrays are stored on disk as
* disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
* number referring to the case, symmetry, and RHS vector respectively,
* and are loaded onto a global array when needed.
************************************************************************
      subroutine resdia(nRow,nCol,W,LDW,dIn,dIs,dOvl)

      use definitions, only: wp, iwp
      use caspt2_global, only: imag_shift, real_shift,
     &                         sigma_p_epsilon, sigma_p_exponent

      implicit none

      integer(kind=iwp), intent(in)    :: nRow, nCol, LDW
      real(kind=wp),     intent(inout) :: W(LDW,*), dOvl
      real(kind=wp),     intent(in)    :: dIn(*), dIs(*)

      integer(kind=iwp)                :: i, j, p
      real(kind=wp)                    :: delta, delta_inv, tmp,
     &                                    sigma, epsilon

      dOvl = 0.0_wp
      do j = 1,nCol
        do i = 1,nRow
          ! energy denominator plus real shift
          delta = dIn(i) + dIs(j) + real_shift
          ! inverse denominator plus imaginary shift
          delta_inv = delta/(delta**2 + imag_shift**2)
          ! multiply by (inverse) sigma-p regularizer
          epsilon = sigma_p_epsilon
          p = sigma_p_exponent
          if (epsilon > 0.0_wp) then
            sigma = 1.0_wp/epsilon**p
            delta_inv = delta_inv * (1.0_wp - exp(-sigma*abs(delta)**p))
          end if
          tmp = delta_inv * W(i,j)
          dOvl = dOvl + tmp * W(i,j)
          W(i,j) = tmp
        end do
      end do

      end subroutine resdia

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      subroutine sgmdia(nRow,nCol,W,LDW,dIn,dIs)

      use definitions, only: wp, iwp
      use caspt2_global, only: imag_shift, real_shift,
     &                         sigma_p_epsilon, sigma_p_exponent

      implicit none

      integer(kind=iwp), intent(in)    :: nRow, nCol, LDW
      real(kind=wp),     intent(inout) :: W(LDW,*)
      real(kind=wp),     intent(in)    :: dIn(*), dIs(*)

      integer(kind=iwp)                :: i, j, p
      real(kind=wp)                    :: delta, sigma, epsilon

      do j = 1,nCol
        do i = 1,nRow
          ! energy denominator plus real shift
          delta = dIn(i) + dIs(j) + real_shift
          ! add the imaginary shift
          delta = delta + imag_shift**2/delta
          ! multiply by sigma-p regularizer
          epsilon = sigma_p_epsilon
          p = sigma_p_exponent
          if (epsilon > 0.0_wp) then
            sigma = 1.0_wp/epsilon**p
            delta = delta/(1.0_wp - exp(-sigma * abs(delta)**p))
          end if

          W(i,j) = delta * W(i,j)
        end do
      end do

      end subroutine sgmdia

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994,1995, Roland Lindh                                *
!               1994, Luis Seijo                                       *
!***********************************************************************

subroutine SROGrd( &
#                 define _CALLING_
#                 include "grd_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of MP integrals.          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, and Luis Seijo, Dept. of Applied Phys-  *
!             ical Chemistry, the Free University of Madrid, Spain,    *
!             September '94.                                           *
!                                                                      *
!             Modified to gradients April '95. R. Lindh                *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Her_RW, only: HerR, HerW, iHerR, iHerW
use Real_Spherical, only: ipSph, RSph
use Symmetry_Info, only: iOper
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: i, ia, iaC, iAng, ib, iC, iCar, iCb, iCent, iCmp, iDCRT(0:7), iGamma, iIrrep, ip, ipA, ipaC, ipAxyz, ipB, &
                     ipBxyz, ipC, ipCb, ipCxyz, ipF1, ipF1a, ipF2, ipF2a, ipK1, ipK2, ipP1, ipP2, ipQ1, iPrint, ipRxyz, ipTmp, &
                     ipZ1, ipZ2, ipZI1, ipZI2, iRout, iShll, iStrt, iuvwx(4), iVec, j, JndGrd(3,4), kCnt, kCnttp, kdc, ld, lDCRT, &
                     LmbdT, lOp(4), mGrad, mVec, mVecAC, mVecCB, nac, ncb, nDAO, nDCRT, nDisp, nExpi, n_Her, nVecAC, nVecCB
real(kind=wp) :: C(3), Fact, TC(3)
character(len=80) :: Label
logical(kind=iwp) :: ABeq(3), EQ, JfGrad(3,4)
real(kind=r8), external :: DNrm2_
logical(kind=iwp), external :: TF
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"

#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(nHer)

iRout = 191
iPrint = nPrint(iRout)

if (iPrint >= 49) then
  call RecPrt(' In SROGrd: A',' ',A,1,3)
  call RecPrt(' In SROGrd: RB',' ',RB,1,3)
  call RecPrt(' In SROGrd: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In SROGrd: P',' ',P,nZeta,3)
  write(u6,*) ' In SROGrd: la,lb=',' ',la,lb
end if

nDAO = nTri_Elem1(la)*nTri_Elem1(lb)
iIrrep = 0
iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
lOp(1) = iOper(kOp(1))
lOp(2) = iOper(kOp(2))

kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (.not. dbsc(kCnttp)%ECP) cycle
  if (dbsc(kCnttp)%nSRO <= 0) cycle
  do kCnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    iuvwx(3) = dc(kdc+kCnt)%nStab
    iuvwx(4) = dc(kdc+kCnt)%nStab
    JndGrd(:,1:2) = IndGrd(:,:)
    do i=1,3
      do j=1,2
        JfGrad(i,j) = IfGrad(i,j)
      end do
    end do

    nDisp = IndDsp(kdc+kCnt,iIrrep)
    do iCar=0,2
      JfGrad(iCar+1,3) = .false.
      iCmp = 2**iCar
      if (TF(kdc+kCnt,iIrrep,iCmp) .and. (.not. dbsc(kCnttp)%pChrg)) then
        nDisp = nDisp+1
        if (Direct(nDisp)) then
          JndGrd(iCar+1,1) = abs(JndGrd(iCar+1,1))
          JndGrd(iCar+1,2) = abs(JndGrd(iCar+1,2))
          JndGrd(iCar+1,3) = -nDisp
          JfGrad(iCar+1,1) = .true.
          JfGrad(iCar+1,2) = .true.
        else
          JndGrd(iCar+1,3) = 0
        end if
      else
        JndGrd(iCar+1,3) = 0
      end if
    end do
    JndGrd(:,4) = 0
    JfGrad(1,4) = .false.
    JfGrad(2,4) = .false.
    JfGrad(3,4) = .false.
    mGrad = 0
    do iCar=1,3
      do i=1,2
        if (JfGrad(iCar,i)) mGrad = mGrad+1
      end do
    end do
    if (mGrad == 0) cycle

    do lDCRT=0,nDCRT-1
      lOp(3) = iDCRT(lDCRT)
      lOp(4) = lOp(3)
      call OA(iDCRT(lDCRT),C,TC)
      if (EQ(A,RB) .and. EQ(A,TC)) cycle
      do iAng=0,dbsc(kCnttp)%nSRO-1
        iShll = dbsc(kCnttp)%iSRO+iAng
        nExpi = Shells(iShll)%nExp
        if (nExpi == 0) cycle

        ip = 1
        ipC = ip
        ip = ip+nExpi**2

        if (iPrint >= 49) call RecPrt(' The Akl matrix',' ',Shells(iShll)%Akl(1,1,1),nExpi,nExpi)
        call dcopy_(nExpi**2,Shells(iShll)%Akl(1,1,1),1,Array(ipC),1)
        if (EQ(A,RB) .and. EQ(A,TC) .and. dbsc(kCnttp)%NoPair) then
          call DaXpY_(nExpi**2,One,Shells(iShll)%Akl(1,1,2),1,Array(ipC),1)
          if (iPrint >= 49) call RecPrt(' The Adl matrix',' ',Shells(iShll)%Akl(1,1,2),nExpi,nExpi)
        end if

        ipF1 = ip
        nac = nTri_Elem1(la)*nTri_Elem1(iAng)*4
        ip = ip+nAlpha*nExpi*nac
        ipP1 = ip
        ip = ip+3*nAlpha*nExpi
        ipZ1 = ip
        ip = ip+nAlpha*nExpi
        ipK1 = ip
        ip = ip+nAlpha*nExpi
        ipZI1 = ip
        ip = ip+nAlpha*nExpi
        if (ip-1 > nArr*nZeta) then
          write(u6,*) '  ip-1 > nArr*nZeta(1) in SROGrd'
          write(u6,*) ' nArr, nZeta=',nArr,nZeta
          write(u6,*) ' nac, nAlpha=',nac,nAlpha
          write(u6,*) ' nExpi=',nExpi
          call Abend()
        end if

        ! Calculate Effective center and exponent for <A|alm>

        call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,nExpi,Alpha,Shells(iShll)%Exp)
        call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))

        ! Calculate Overlap <A|core> and derivative <A'|core>

        n_Her = ((la+1)+iAng+2)/2
        ipAxyz = ip
        ip = ip+nAlpha*nExpi*3*n_Her*(la+2)
        ipCxyz = ip
        ip = ip+nAlpha*nExpi*3*n_Her*(iAng+1)
        ipRxyz = ip
        ip = ip+nAlpha*nExpi*3*n_Her*(nOrdOp+1)
        ipQ1 = ip
        ip = ip+nAlpha*nExpi*3*(la+2)*(iAng+1)*(nOrdOp+1)
        ipA = ip
        ip = ip+nAlpha*nExpi
        if (ip-1 > nArr*nZeta) then
          write(u6,*) '  ip-1 > nArr*nZeta(1b) in SROGrd'
          call Abend()
        end if
        ABeq(1) = A(1) == TC(1)
        ABeq(2) = A(2) == TC(2)
        ABeq(3) = A(3) == TC(3)
        call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,A,Array(ipAxyz),la+1,HerR(iHerR(n_Her)),n_Her,ABeq)
        call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,TC,Array(ipCxyz),iAng,HerR(iHerR(n_Her)),n_Her,ABeq)
        ABeq(1) = .false.
        ABeq(2) = .false.
        ABeq(3) = .false.
        call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(n_Her)),n_Her,ABeq)
        if (iPrint >= 49) then
          write(u6,*) ' Array(ipAxyz)=',DNrm2_(nAlpha*nExpi*3*n_Her*(la+2),Array(ipAxyz),1)
          write(u6,*) ' Array(ipCxyz)=',DNrm2_(nAlpha*nExpi*3*n_Her*(iAng+1),Array(ipCxyz),1)
          write(u6,*) ' Array(ipRxyz)=',DNrm2_(nAlpha*nExpi*3*n_Her*(nOrdOp+1),Array(ipRxyz),1)
        end if
        call Assmbl(Array(ipQ1),Array(ipAxyz),la+1,Array(ipRxyz),nOrdOp,Array(ipCxyz),iAng,nAlpha*nExpi,HerW(iHerW(n_Her)),n_Her)
        iStrt = ipA
        do iGamma=1,nExpi
          call dcopy_(nAlpha,Alpha,1,Array(iStrt),1)
          iStrt = iStrt+nAlpha
        end do
        if (iPrint >= 49) then
          write(u6,*) ' Array(ipA)=',DNrm2_(nAlpha*nExpi,Array(ipA),1)
        end if
        call rKappa_Zeta(Array(ipK1),Array(ipZ1),nExpi*nAlpha)
        ld = 1
        call CmbnAC(Array(ipQ1),nAlpha*nExpi,la,iAng,Array(ipK1),Array(ipF1),Array(ipA),JfGrad(1,1),ld,nVecAC)
        if (iPrint >= 49) then
          write(u6,*) ' Array(ipQ1)=',DNrm2_(nAlpha*nExpi*3*(la+2)*(iAng+1)*(nOrdOp+1),Array(ipQ1),1)
          write(u6,*) ' Array(ipA)=',DNrm2_(nAlpha*nExpi,Array(ipA),1)
        end if
        ip = ip-nAlpha*nExpi*(6+3*n_Her*(la+2)+3*n_Her*(iAng+1)+3*n_Her*(nOrdOp+1)+3*(la+2)*(iAng+1)*(nOrdOp+1)+1)

        ipF2 = ip
        ncb = nTri_Elem1(iAng)*nTri_Elem1(lb)*4
        ip = ip+nExpi*nBeta*ncb
        ipP2 = ip
        ip = ip+3*nExpi*nBeta
        ipZ2 = ip
        ip = ip+nExpi*nBeta
        ipK2 = ip
        ip = ip+nExpi*nBeta
        ipZI2 = ip
        ip = ip+nExpi*nBeta
        if (ip-1 > nArr*nZeta) then
          write(u6,*) '  ip-1 > nArr*nZeta(2) in SROGrd'
          call Abend()
        end if

        ! Calculate Effective center and exponent for <blm|B>

        call ZXia(Array(ipZ2),Array(ipZI2),nExpi,nBeta,Shells(iShll)%Exp,Beta)
        call SetUp1(Shells(iShll)%Exp,nExpi,Beta,nBeta,TC,RB,Array(ipK2),Array(ipP2),Array(ipZI2))

        ! Calculate Overlap <core|B> and <core|B'>

        n_Her = ((iAng+1)+lb+2)/2
        ipCxyz = ip
        ip = ip+nBeta*nExpi*3*n_Her*(iAng+1)
        ipBxyz = ip
        ip = ip+nBeta*nExpi*3*n_Her*(lb+2)
        ipRxyz = ip
        ip = ip+nBeta*nExpi*3*n_Her*(nOrdOp+1)
        ipQ1 = ip
        ip = ip+nBeta*nExpi*3*(iAng+1)*(lb+2)*(nOrdOp+1)
        ipB = ip
        ip = ip+nBeta*nExpi
        if (ip-1 > nArr*nZeta) then
          write(u6,*) '  ip-1 > nArr*nZeta(2b) in SROGrd'
          call Abend()
        end if
        ABeq(1) = TC(1) == RB(1)
        ABeq(2) = TC(2) == RB(2)
        ABeq(3) = TC(3) == RB(3)
        call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,TC,Array(ipCxyz),iAng,HerR(iHerR(n_Her)),n_Her,ABeq)
        call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,RB,Array(ipBxyz),lb+1,HerR(iHerR(n_Her)),n_Her,ABeq)
        ABeq(1) = .false.
        ABeq(2) = .false.
        ABeq(3) = .false.
        call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(n_Her)),n_Her,ABeq)
        if (iPrint >= 49) then
          write(u6,*) ' Array(ipCxyz)=',DNrm2_(nBeta*nExpi*3*n_Her*(iAng+1),Array(ipCxyz),1)
          write(u6,*) ' Array(ipBxyz)=',DNrm2_(nBeta*nExpi*3*n_Her*(lb+2),Array(ipBxyz),1)
          write(u6,*) ' Array(ipRxyz)=',DNrm2_(nBeta*nExpi*3*n_Her*(nOrdOp+1),Array(ipRxyz),1)
        end if
        call Assmbl(Array(ipQ1),Array(ipCxyz),iAng,Array(ipRxyz),nOrdOp,Array(ipBxyz),lb+1,nExpi*nBeta,HerW(iHerW(n_Her)),n_Her)
        iStrt = ipB
        do iGamma=1,nExpi
          call dcopy_(nBeta,Beta,1,Array(iStrt),nExpi)
          iStrt = iStrt+1
        end do
        if (iPrint >= 49) then
          write(u6,*) ' Array(ipB)=',DNrm2_(nExpi*nBeta,Array(ipB),1)
        end if
        call rKappa_Zeta(Array(ipK2),Array(ipZ2),nExpi*nBeta)
        ld = 1
        call CmbnCB(Array(ipQ1),nExpi*nBeta,iAng,lb,Array(ipK2),Array(ipF2),Array(ipB),JfGrad(1,2),ld,nVecCB)
        if (iPrint >= 49) then
          write(u6,*) ' Array(ipQ1)=',DNrm2_(nExpi*nBeta*3*(la+2)*(iAng+1)*(nOrdOp+1),Array(ipQ1),1)
          write(u6,*) ' Array(ipB)=',DNrm2_(nExpi*nBeta,Array(ipB),1)
        end if
        ip = ip-nBeta*nExpi*(6+3*n_Her*(lb+2)+3*n_Her*(iAng+1)+3*n_Her*(nOrdOp+1)+3*(lb+2)*(iAng+1)*(nOrdOp+1)+1)
        nac = nTri_Elem1(la)*nTri_Elem1(iAng)*nVecAC
        ncb = nTri_Elem1(iAng)*nTri_Elem1(lb)*nVecCB
        ipTmp = ip
        ip = ip+max(nAlpha*nExpi*nac,nExpi*nBeta*ncb)
        if (ip-1 > nArr*nZeta) then
          write(u6,*) '  ip-1 > nArr*nZeta(3) in SROGrd'
          call Abend()
        end if
        nac = nTri_Elem1(la)*nTri_Elem1(iAng)
        ncb = nTri_Elem1(iAng)*nTri_Elem1(lb)

        ! Calculate Contraction over the spectral resolvent basis
        ! set of the type <A|alm>A(l;ab)<blm|B> where we now have in
        ! Array(ipF1) the cartesian components of <A|alm>, and
        ! similarily, in Array(ipF2), we have stored the cartesian
        ! components of <alm|B>. Observe that as opposed to the
        ! projection operator that this contraction is done in the
        ! primitive basis.

        ! From the lefthandside overlap, form ikaCx from ikacx by
        ! 1) ika,cx -> cx,ika

        call DgeTMo(Array(ipF1),nAlpha*nExpi*nTri_Elem1(la),nAlpha*nExpi*nTri_Elem1(la),nTri_Elem1(iAng)*nVecAC,Array(ipTmp), &
                    nTri_Elem1(iAng)*nVecAC)

        ! 2) xika,C = c,xika * c,C

        call DGEMM_('T','N',nVecAC*nAlpha*nExpi*nTri_Elem1(la),(2*iAng+1),nTri_Elem1(iAng),One,Array(ipTmp),nTri_Elem1(iAng), &
                    RSph(ipSph(iAng)),nTri_Elem1(iAng),Zero,Array(ipF1),nVecAC*nAlpha*nExpi*nTri_Elem1(la))

        ! 3) x,ikaC -> ikaC,x

        call DGetMo(Array(ipF1),nVecAC,nVecAC,nAlpha*nExpi*nTri_Elem1(la)*(2*iAng+1),Array(ipTmp), &
                    nAlpha*nExpi*nTri_Elem1(la)*(2*iAng+1))
        call dcopy_(nVecAC*nAlpha*nExpi*nTri_Elem1(la)*(2*iAng+1),Array(ipTmp),1,Array(ipF1),1)

        ! And (almost) the same thing for the righthand side, form
        ! kjCbx from kjcbx
        ! ) kj,cbx -> cbx,kj

        call DgeTMo(Array(ipF2),nBeta*nExpi,nBeta*nExpi,ncb*nVecCB,Array(ipTmp),ncb*nVecCB)

        ! 2) bxkj,C = c,bxkj * c,C

        call DGEMM_('T','N',nTri_Elem1(lb)*nVecCB*nExpi*nBeta,(2*iAng+1),nTri_Elem1(iAng),One,Array(ipTmp),nTri_Elem1(iAng), &
                    RSph(ipSph(iAng)),nTri_Elem1(iAng),Zero,Array(ipF2),nTri_Elem1(lb)*nVecCB*nExpi*nBeta)

        ! 3) bx,kjC -> kjC,bx

        call DgeTMo(Array(ipF2),nTri_Elem1(lb)*nVecCB,nTri_Elem1(lb)*nVecCB,nExpi*nBeta*(2*iAng+1),Array(ipTmp), &
                    nExpi*nBeta*(2*iAng+1))
        call dcopy_(nExpi*nBeta*(2*iAng+1)*nTri_Elem1(lb)*nVecCB,Array(ipTmp),1,Array(ipF2),1)

        ! Next Contract (ikaC)*(klC)*(ljCb) over k,l and C,
        ! producing ijab,
        ! by the following procedure:
        ! Loop over a and b
        !   Loop over C
        !     Contract ik(aC)*kl(C), over k producing il(aC),
        !     Contract il(aC)*lj(Cb), over l producing ij(aCb)
        !       accumulate to ij(ab)
        !   End loop C
        ! End Loop b and a

        rFinal(:,:,:,1,:) = Zero

        mVec = 0
        mVecAC = 1
        mVecCB = 1
        do iCar=1,3
          do iCent=1,2
            if (JfGrad(iCar,iCent)) then
              mVec = mVec+1
              if (iCent == 1) then
                mVecAC = mVecAC+1
                ipF1a = ipF1+(mVecAC-1)*nAlpha*nExpi*nTri_Elem1(la)*(2*iAng+1)
                ipF2a = ipF2
              else
                ipF1a = ipF1
                mVecCB = mVecCB+1
                ipF2a = ipF2+(mVecCB-1)*nExpi*nBeta*(2*iAng+1)*nTri_Elem1(lb)
              end if

              do ib=1,nTri_Elem1(lb)
                do ia=1,nTri_Elem1(la)
                  if (iPrint >= 99) write(u6,*) ' ia,ib=',ia,ib

                  do iC=1,(2*iAng+1)
                    if (iPrint >= 99) write(u6,*) ' iC,=',iC
                    iaC = (iC-1)*nTri_Elem1(la)+ia
                    ipaC = (iaC-1)*nAlpha*nExpi+ipF1a
                    iCb = (ib-1)*(2*iAng+1)+iC
                    ipCb = (iCb-1)*nExpi*nBeta+ipF2a

                    if (iPrint >= 99) then
                      call RecPrt('<ia|iC>',' ',Array(ipaC),nAlpha,nExpi)
                      call RecPrt('<iC|ib>',' ',Array(ipCb),nExpi,nBeta)
                    end if

                    call DGEMM_('N','N',nAlpha,nExpi,nExpi,One,Array(ipaC),nAlpha,Array(ipC),nExpi,Zero,Array(ipTmp),nAlpha)
                    call DGEMM_('N','N',nAlpha,nBeta,nExpi,Fact,Array(ipTmp),nAlpha,Array(ipCb),nExpi,One,rFinal(:,ia,ib,1,mVec), &
                                nAlpha)

                  end do
                end do
              end do

            end if
          end do
        end do

        if (iPrint >= 49) then
          do iVec=1,mVec
            write(u6,*) iVec,sqrt(DNrm2_(nZeta*nTri_Elem1(la)*nTri_Elem1(lb),rFinal(:,:,:,1,iVec),1))
          end do
        end if
        if (iPrint >= 99) then
          write(u6,*) ' Result in SROGrd'
          do ia=1,nTri_Elem1(la)
            do ib=1,nTri_Elem1(lb)
              do iVec=1,mVec
                write(Label,'(A,I2,A,I2,A)') ' rFinal(',ia,',',ib,')'
                call RecPrt(Label,' ',rFinal(:,ia,ib,1,iVec),nAlpha,nBeta)
              end do
            end do
          end do
        end if

        ! Distribute contributions to the gradient

        call Distg1X(rFinal,DAO,nZeta,nDAO,mVec,Grad,nGrad,JfGrad,JndGrd,iuvwx,lOp)

      end do
    end do
  end do
end do

return

end subroutine SROGrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mr0u3wt
     & (ddx, ddy,
     & nop, incx, incy,
     & x, y,
     & scal)
C
C     scalar = sum (x(ix) * y(iy))
C
#include "ccsd1.fh"
       integer ddx, ddy
       integer nop, incx, incy
       real*8  x(1:ddx), y(1:ddy)
       real*8  scal
       real*8 ddot_
C
C      help vraiables
C
       integer i, ix, iy
C
       if (mhkey.eq.1) then
c      ESSL
       scal=ddot_(nop,x,incx,y,incy)
C
       else
c      Fortran matrix handling
C
C      return for no operations
C
       scal = 0.0d0
       if (nop.le.0) return
C
       if (incx.eq.1.and.incy.eq.1) then
C
C      inc's = 1
C
       do 10 i = 1, nop
       scal = scal + x(i)*y(i)
 10    continue
C
       else
C
c      other type increments
C
       ix = 1
       iy = 1
       if (incx.lt.0) ix = 1-(nop-1)*incx
       if (incy.lt.0) iy = 1-(nop-1)*incy
C
       do 20 i = 1,nop
       scal = scal + x(ix)*y(iy)
       ix = ix + incx
       iy = iy + incy
 20    continue
C
       end if
C
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PNT2DM(   I12SM,   NSMOB,   NSMSX,    OSXO,    IPSM,
     &                      JPSM,    IJSM,    ISM2,   IPNTR,  MXPOBS)
*
* Pointer to two dimensional array
*
* =====
* Input
* =====
* I12SM  : ne.0 => restrict to lower half
*          eq.0 => complete matrix
* NSMOB : Number of orbital symmetries
* NSMSX : Number of SX      symmetries
* OSXO  : Symmetry of orbital, SX => symmetry of other orbital
* IPSM : Number of orbitals per symmetry for index 1
* JPSM : Number of orbitals per symmetry for index 2
* IJSM  : Symmetry of two index array
*
* =======
* Output
* =======
* IPNTR : Pointer to block with first index of given symmetry
*         = 0 indicates forbidden block
* ISM2  : symmetry of second index for given first index
*
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
      INTEGER OSXO(MXPOBS,2*MXPOBS),IPSM(*),JPSM(*)
*.Output
      DIMENSION IPNTR(*),ISM2(*)
*
      CALL ISETVC(IPNTR,0,NSMOB)
      CALL ISETVC(ISM2 ,0,NSMOB)
      IOFF = 1
      DO 100 ISM = 1,NSMOB
        JSM = OSXO(ISM,IJSM)
        IF(JSM.EQ.0) GOTO 100
        IF(I12SM.EQ.0.OR.ISM.GE.JSM) THEN
*. Allowed block
          IPNTR(ISM) = IOFF
          ISM2(ISM) = JSM
          IF(I12SM.GT.0.AND.ISM.EQ.JSM) THEN
            IOFF = IOFF + IPSM(ISM)*(IPSM(ISM)+1)/2
          ELSE
            IOFF = IOFF + IPSM(ISM)*JPSM(JSM)
          END IF
        END IF
  100 CONTINUE
*
      NTEST = 0
      IF(NTEST.GE.1) THEN
        WRITE(6,*) ' dimension of two-dimensional array ',IOFF-1
      END IF
      IF(NTEST.GE.5) THEN
        WRITE(6,*) ' Pointer '
        CALL IWRTMA(IPNTR,1,NSMOB,1,NSMOB)
        WRITE(6,*) ' Symmetry of other array '
        CALL IWRTMA(ISM2,1,NSMOB,1,NSMOB)
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NSMSX)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine VVVO_Drv(nSym,nBas,nFro,Keep,iSym,iSymI,iSymJ,iSymK,iSymL,lT2AO,T2AO,vLag,nOcc,nBasT,nBMX,CMO,DPT2AO,DPT2CAO,FPT2AO, &
                    FPT2CAO,DIA,DI,FIFA,FIMO)

use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(8), nFro(8), Keep(8), iSym, iSymI, iSymJ, iSymK, iSymL, lT2AO, nOcc, nBasT, nBMX
real(kind=wp), intent(in) :: T2AO(lT2AO), CMO(nBasT**2), DPT2AO(nBasT**2), DPT2CAO(nBasT**2), DIA(nBasT**2), DI(nBasT**2)
real(kind=wp), intent(inout) :: vLag(nBasT**2), FPT2AO(nBasT**2), FPT2CAO(nBasT**2), FIFA(nBasT**2), FIMO(nBasT**2)
integer(kind=iwp) :: LBUF
logical(kind=iwp) :: DoCholesky
real(kind=wp), allocatable :: W1(:), W2(:), WRK(:)

! nAux is the number of occupied orbitals
DoCholesky = .false.
call DecideOnCholesky(DoCholesky)
!if (DoCholesky .and. (ALGO == 2)) then
!  !! I assume ALGO=2 does not exist (it is not documented and under
!  !! debugging, according to rasscf/cho_rasscf_rdinp)
!  call abend()
!end if

call mma_allocate(W2,NBMX*NBMX,Label='W2')
call mma_allocate(WRK,nBasT*nBasT,Label='WRK')

call mma_MaxDBLE(LBUF)
if (DoCholesky) LBUF = NBMX*NBMX+1

! Standard building of the Fock matrix from Two-el integrals

call mma_allocate(W1,LBUF,Label='W1')

if (LBUF < 1+NBMX**2) then
  write(u6,*) ' FockTwo_Drv Error: Too little memory remains for the call to FOCKTWO.'
  write(u6,*) ' Largest allocatable array size LBUF=',LBUF
  write(u6,*) ' Max nr of bf in any symmetry,  NBMX=',NBMX
  write(u6,*) ' Required minimum size     1+NBMX**2=',1+NBMX**2
  write(u6,*) '    (All in Real*8-size words)'
  call ABEND()
end if

if (DoCholesky) then
  call VVVOX2(Keep,iSym,iSymI,iSymJ,iSymK,iSymL,nBasT,vLag,CMO,WRK,DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,FIFA,FIMO)
else
  call VVVOX(nSym,nBas,nFro,Keep,iSymI,iSymJ,iSymK,iSymL,NBMX,T2AO,vLag,CMO,nOcc,nBasT,LBUF,W1,W2,WRK,DPT2AO,DPT2CAO,FPT2AO, &
             FPT2CAO,DIA,DI,FIFA,FIMO)
end if
!! vLag must be transposed
!! In VVVOX(2) subroutines, vLag(p,mu) is constructed.
WRK(1:nBasT**2) = vLag(1:nBasT**2)
call trnsps(nBasT,nBasT,WRK,vLag)
call mma_deallocate(WRK)
call mma_deallocate(W1)
call mma_deallocate(W2)

end subroutine VVVO_Drv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! inner space loop calculation,
! loops in dbl space, dbl-act space, act space
!***********************************************************************
!   ar      =1 (+a^r)     drr     =2 (+d^rr)   drl     =3 (+d^rl)
!   arbr    =4 (+d^rr)    arbl    =5 (+d^rl)   ard_l^r =6 (+a^l)
!   drrb^r  =7 (+a^r)     drlb^r  =8 (+a^l)    drlb^l  =9 (+a^r)
!   arbrb^r =10 (+a^r)    arblb^r =11 (+a^l)   arblb^l =12 (+a^r)
!   drl        =13 (*)
!***********************************************************************

subroutine inner_space_loop()

implicit none

!wsc0 = c_time()
call dbl_space_loop()
!wsc1 = c_time()
call act_space_cloop()
call act_space_ploop()
!wsc2 = c_time()
!write(u6,'(2x,2(a5,f12.4))') 'dbl',wsc1-wsc0,'act',wsc2-wsc1

return

end subroutine inner_space_loop

subroutine act_space_cloop()        ! one sub_drt

use gugaci_global, only: ipae, jpad, jpae, mxnode, ndim, norb_act, nu_ad, nu_ae
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ipae_, jpad_

if (norb_act == 0) return
do ipae_=1,25
  ipae = ipae_ ! ipae is in global module, is this necessary?
  jpae = nu_ae(ipae)
  if (jpae == 0) cycle
  do jpad_=1,mxnode
    jpad = jpad_ ! jpad is in global module, is this necessary?
    if (nu_ad(jpad) == 0) cycle
    call seg_drt()
    if (ndim == 0) cycle
    call copy_to_drtl()
    call cloop_in_act()
  end do
end do

return

end subroutine act_space_cloop

subroutine act_space_ploop()        ! two sub_drt with same ipae

use gugaci_global, only: ipae, jpad, jpadl, jpae, mxnode, ndim, norb_act, nu_ad, nu_ae
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ipae_, jpad_, jpadl_

if (norb_act == 0) return
do ipae_=1,25
  ipae = ipae_ ! ipae is in global module, is this necessary?
  jpae = nu_ae(ipae)
  if (jpae == 0) cycle
  do jpadl_=1,mxnode                               ! jpadl
    jpadl = jpadl_ ! jpadl is in global module, is this necessary?
    if (nu_ad(jpadl) == 0) cycle
    jpad = jpadl
    call seg_drt()
    if (ndim == 0) cycle
    call copy_to_drtl()
    do jpad_=1,mxnode                               !jpadr
      jpad = jpad_ ! jpad is in global module, is this necessary?
      if (nu_ad(jpad) == 0) cycle
      call seg_drt()
      if (ndim == 0) cycle
      !if ((ipae == 18) .and. (jpadl == 2) .and. (jpad == 1)) write(u6,*)
      call ploop_in_act()
    end do
  end do
end do

return

end subroutine act_space_ploop

subroutine cloop_in_act()

use gugaci_global, only: logic_br, lsm_inn, norb_dz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lmi, lmij, lmj, lmk, lml, lrai, lraj, lrak, lral, lsmij, mh

do lrai=norb_dz+1,norb_inn-1
  lmi = lsm_inn(lrai)
  do lraj=lrai+1,norb_inn
    lmj = lsm_inn(lraj)
    lmij = Mul(lmi,lmj)
    !-------------------------------------------------------------------
    ! line=8 d&r&r--d^r^r
    call head_drr_at_given_orb(mh,lrai)
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrai+1,lraj-1)
    call tail_drr_at_given_orb(mh)
    !write(u6,'(6i6)') 8,mh,lrai,lraj,0,0
    if (mh /= 0) call act_cloop(8,mh,lrai,lraj,0,0)
    !-------------------------------------------------------------------
    ! line=9 d&r&l--d^r^l
    call head_drl_at_given_orb(mh,lrai)
    call link_c2_to_given_orb(mh,lrai+1,lraj-1)
    call tail_drl_at_given_orb(mh)
    !write(u6,'(6i6)') 9,mh,lrai,lraj,0,0
    if (mh /= 0) call act_cloop(9,mh,lrai,lraj,0,0)
    lsmij = Mul(lmi,lmj)
    !-------------------------------------------------------------------
    if (lsmij == 1) then
      !-----------------------------------------------------------------
      ! line=1 a&r--a^r
      call head_ar_at_given_orb(mh,lrai)
      call link_c1_to_given_orb_coe(mh,lrai+1,lraj-1)
      call tail_ar_at_given_orb_coe(mh,lraj)
      !write(u6,'(6i6)') 1,mh,lrai,lraj,0,0
      if (mh /= 0) call act_cloop(1,mh,lrai,lraj,0,0)
      !call save_clp(1,mh,lra,0)
      !-----------------------------------------------------------------
      ! line=2 a&r-d^r&l-a^l
      do lrak=lrai+1,lraj-1
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lrak-1)
        call link_d10_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrak+1,lraj-1)
        call tail_al_at_given_orb(mh)
        !write(u6,'(6i6)') 2,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop(2,mh,lrai,lraj,lrak,0)
      end do
      !-----------------------------------------------------------------
      ! line=3 a&r-b&r-d^r^r
      do lrak=lraj+1,norb_inn
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b4_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call tail_drr_at_given_orb(mh)
        !write(u6,'(6i6)') 3,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop(3,mh,lrai,lraj,lrak,0)
        !---------------------------------------------------------------
        ! line=5 a&r-b&l-d^r^l
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b3_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call tail_drl_at_given_orb(mh)
        !write(u6,'(6i6)') 5,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop(5,mh,lrai,lraj,lrak,0)
      end do
      !-----------------------------------------------------------------
      do lrak=norb_dz+1,lrai-1
        ! line=10 d&rr--b^r--a^r
        call head_drr_at_given_orb(mh,lrak)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lrak+1,lrai-1)
        call link_b2_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call tail_ar_at_given_orb(mh)
        !write(u6,'(6i6)') 10,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop(10,mh,lrai,lraj,lrak,0)
        !---------------------------------------------------------------
        ! line=11 d&r&l-b^r-a^l
        call head_drl_at_given_orb(mh,lrak)
        call link_c2_to_given_orb(mh,lrak+1,lrai-1)
        call link_b2_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call tail_al_at_given_orb(mh)
        !write(u6,'(6i6)') 11,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop(11,mh,lrai,lraj,lrak,0)
        !---------------------------------------------------------------
        ! line=12 d&r&l-b^l-a^r
        call head_drl_at_given_orb(mh,lrak)
        call link_c2_to_given_orb(mh,lrak+1,lrai-1)
        call link_b1_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call tail_ar_at_given_orb(mh)
        !write(u6,'(6i6)') 12,mh,lrai,lraj,lrak,0
        if (mh /= 0) call act_cloop(12,mh,lrai,lraj,lrak,0)
      end do
    end if
    if (lraj > norb_inn-2) cycle
    do lrak=lraj+1,norb_inn
      lmk = lsm_inn(lrak)
      lmk = Mul(lmij,lmk)
      do lral=lrak+1,norb_inn
        lml = lsm_inn(lral)
        lml = Mul(lmk,lml)
        if (lml /= 1) cycle
        ! line=4  a&r--b&r--b^r--a^r
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b4_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call link_b2_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrak+1,lral-1)
        call tail_ar_at_given_orb(mh)
        !write(u6,'(6i6)') 4,mh,lrai,lral,lraj,lrak
        if (mh /= 0) call act_cloop(4,mh,lrai,lral,lraj,lrak)
        !---------------------------------------------------------------
        ! line=6  a&r--b&l--b^r--a^l
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b3_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call link_b2_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrak+1,lral-1)
        call tail_al_at_given_orb(mh)
        !write(u6,'(6i6)') 6,mh,lrai,lral,lraj,lrak
        if (mh /= 0) call act_cloop(6,mh,lrai,lral,lraj,lrak)
        !---------------------------------------------------------------
        ! line=7 a&r--b&l--b^l--a^r
        call head_ar_at_given_orb(mh,lrai)
        call link_c1_to_given_orb(mh,lrai+1,lraj-1)
        call link_b3_at_given_orb(mh)
        logic_br(1:mh) = .true.
        call link_c2_to_given_orb(mh,lraj+1,lrak-1)
        call link_b1_at_given_orb(mh)
        call link_c1_to_given_orb(mh,lrak+1,lral-1)
        call tail_ar_at_given_orb(mh)
        !write(u6,'(6i6)') 7,mh,lrai,lral,lraj,lrak
        if (mh /= 0) call act_cloop(7,mh,lrai,lral,lraj,lrak)
        !---------------------------------------------------------------
      end do
    end do
  end do
end do

return

end subroutine cloop_in_act

subroutine ploop_in_act()

use gugaci_global, only: logic_br, norb_dz, norb_inn
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lrai, lraj, lrak, lral, mh

!=======================================================================
do lrai=norb_dz+1,norb_inn
  ! line=25 -c"-d^r^r
  logic_br(1) = .true.
  call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
  call tail_drr_at_given_orb(mh)
  if (mh /= 0) call lp_act_tail(25,mh,0,lrai)
  !---------------------------------------------------------------------
  ! line=26 -c"-d^r^l
  logic_br(1) = .true.
  call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
  call tail_drl_at_given_orb(mh)
  if (mh /= 0) call lp_act_tail(26,mh,0,lrai)
  !=====================================================================
  ! line=23 -c'-a^l
  call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
  call tail_al_at_given_orb(mh)
  if (mh /= 0) call lp_act_tail(23,mh,0,0)
  !---------------------------------------------------------------------
  ! line=24 -c'-a^r
  call link_c1_to_given_orb_coe(mh,norb_dz+1,lrai-1)
  call tail_ar_at_given_orb_coe(mh,lrai)
  if (mh /= 0) call lp_act_tail(24,mh,0,0)
  !=====================================================================
  do lrak=lrai+1,norb_inn
    !-------------------------------------------------------------------
    ! line=30 -c'-b&r-d^r^r
    call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b4_at_given_orb(mh)
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrai+1,lrak-1)
    call tail_drr_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail(30,mh,lrai,0)
    !-------------------------------------------------------------------
    ! line=31 -c'-b&l-d^r^l
    call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b3_at_given_orb(mh)
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrai+1,lrak-1)
    call tail_drl_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail(31,mh,lrai,0)
  end do
  !=====================================================================
  do lrak=norb_dz+1,lrai-1
    !-------------------------------------------------------------------
    ! line=35 -c'-d^r&l-a^l
    call link_c1_to_given_orb(mh,norb_dz+1,lrak-1)
    call link_d10_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrak+1,lrai-1)
    call tail_al_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail(35,mh,lrak,lrak)
  end do
  !=====================================================================
  do lraj=lrai+1,norb_inn
    !-------------------------------------------------------------------
    ! line=27 -c"-b^r-a^r
    call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b2_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrai+1,lraj-1)
    call tail_ar_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail(27,mh,0,lrai)
    !-------------------------------------------------------------------
    ! line=28 -c"-b^l-a^r
    call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b1_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrai+1,lraj-1)
    call tail_ar_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail(28,mh,0,lrai)
    !-------------------------------------------------------------------
    ! line=29 -c"-b^r-a^l
    call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b2_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrai+1,lraj-1)
    call tail_al_at_given_orb(mh)
    if (mh /= 0) call lp_act_tail(29,mh,0,lrai)
    !-------------------------------------------------------------------
    do lral=lraj+1,norb_inn
      !-----------------------------------------------------------------
      ! line=32 -c'-b&r-c"-b^r-a^r
      call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
      call link_b4_at_given_orb(mh)
      logic_br(1:mh) = .true.
      call link_c2_to_given_orb(mh,lrai+1,lraj-1)
      call link_b2_at_given_orb(mh)
      call link_c1_to_given_orb(mh,lraj+1,lral-1)
      call tail_ar_at_given_orb(mh)
      if (mh /= 0) call lp_act_tail(32,mh,lrai,lraj)
      !-----------------------------------------------------------------
      ! line=33 -c'-b&l-c"-b^r-a^l
      call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
      call link_b3_at_given_orb(mh)
      logic_br(1:mh) = .true.
      call link_c2_to_given_orb(mh,lrai+1,lraj-1)
      call link_b2_at_given_orb(mh)
      call link_c1_to_given_orb(mh,lraj+1,lral-1)
      call tail_al_at_given_orb(mh)
      if (mh /= 0) call lp_act_tail(33,mh,lrai,lraj)
      !-----------------------------------------------------------------
      ! line=34 -c'-b&l-c"-b^l-a^r
      call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
      call link_b3_at_given_orb(mh)
      logic_br(1:mh) = .true.
      call link_c2_to_given_orb(mh,lrai+1,lraj-1)
      call link_b1_at_given_orb(mh)
      call link_c1_to_given_orb(mh,lraj+1,lral-1)
      call tail_ar_at_given_orb(mh)
      if (mh /= 0) call lp_act_tail(34,mh,lrai,lraj)
    end do
  end do
  !---------------------------------------------------------------------
end do

return

end subroutine ploop_in_act

subroutine lp_act_tail(lin,mh,lrg0,lrs0)

use gugaci_global, only: jpel, jper, jph_, jwl, jwr, line, lpnew_coe, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, lrg, lrs, &
                         mhlp, norb_dz, norb_inn, vplpnew_w0, vplpnew_w1, w0, w1
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, mh, lrg0, lrs0
integer(kind=iwp) :: iorb, mhlp_
integer(kind=iwp), allocatable :: lpcoe(:)

call mma_allocate(lpcoe,[norb_dz+1,norb_inn],label='lpcoe')
line = lin
lrg = lrg0
lrs = lrs0
jph_ = 0
do mhlp_=1,mh
  mhlp = mhlp_ ! mhlp is in global module, is this necessary?
  jpel = lpnew_ltail(mhlp)
  jper = lpnew_rtail(mhlp)
  jwl = lpnew_lwei(mhlp)
  jwr = lpnew_rwei(mhlp)
  w0 = vplpnew_w0(mhlp)
  w1 = vplpnew_w1(mhlp)
  if (line == 24) then
    do iorb=norb_dz+1,norb_inn
      lpcoe(iorb) = lpnew_coe(iorb,mhlp)
    end do
  end if
  call dbl_head_act_tail(lpcoe)
end do
call mma_deallocate(lpcoe)

return

end subroutine lp_act_tail

subroutine tail_ar_at_given_orb_coe(mh,lract)       !a^r:lstep>rst

use gugaci_global, only: istep_occ, iy, iyl, ja, jb, jj_sub, jjl_sub, jm, lp_coe, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, &
                         lpnew_coe, lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, norb_dz, vplp_w0, vplp_w1, &
                         vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp), intent(in) :: lract
integer(kind=iwp) :: iactploop, idb, idocc, ilc, ilstep, ind0, iorb, irc, irstep, jbr, kcoe, lphead, lpltail, lplwei, lplwei0, &
                     lpnew, lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, lr, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: isla2(4) = [21,31,57,62]

iorb = lract
lpnew = 0
do iactploop=1,mh
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  do ilstep=1,4
    ilc = istep_occ(ilstep)
    lpnextltail = jjl_sub(ilstep,lpltail)
    if (lpnextltail == 0) cycle
    do irstep=1,ilstep-1
      irc = istep_occ(irstep)
      idocc = abs(ilc-irc)
      if (idocc /= 1) cycle
      lpnextrtail = jj_sub(irstep,lprtail)
      if (lpnextrtail == 0) cycle

      if (ja(lpnextltail) /= ja(lpnextrtail)) cycle
      if (jb(lpnextltail) /= jb(lpnextrtail)) cycle
      if (jm(lpnextltail) /= jm(lpnextrtail)) cycle

      ind0 = (idb+2)*16+(ilstep-1)*4+irstep
      jbr = jb(lprtail)
      do ni=1,4
        if (ind0 /= isla2(ni)) cycle
        call stermla2(w,ww,ni,jbr)
        lpnew = lpnew+1
        lpnew_head(lpnew) = lphead
        lpnew_ltail(lpnew) = lpnextltail
        lpnew_rtail(lpnew) = lpnextrtail
        lplwei = lplwei0
        lprwei = lprwei0
        if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
        if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
        lpnew_lwei(lpnew) = lplwei
        lpnew_rwei(lpnew) = lprwei
        vplpnew_w0(lpnew) = w0*w
        vplpnew_w1(lpnew) = w1*ww
        if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
          lpnew = lpnew-1
        end if
        do lr=norb_dz+1,iorb-1
          lpnew_coe(lr,lpnew) = lp_coe(lr,iactploop)
        end do
        kcoe = 0
        if (ilstep == 4) kcoe = 100
        lpnew_coe(iorb,lpnew) = kcoe
      end do
    end do
  end do
end do

mh = lpnew
!call change_vplp_pointer_arrays()

end subroutine tail_ar_at_given_orb_coe

subroutine act_cloop(lin,mh,lr0,lr,lrg0,lrs0)

use gugaci_global, only: jpel, jper, jph_, jwl, jwr, line, lpnew_coe, lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, &
                         lpnew_rwei, lrg, lrs, mhlp, norb_dz, norb_inn, vint_ci, voint, vplpnew_w0, vplpnew_w1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, mh, lr0, lr, lrg0, lrs0
integer(kind=iwp) :: l, list, kcoe, mhlp_, nocc
real(kind=wp) :: tcoe, vlop0, vlop1, wl
integer(kind=iwp), allocatable :: lpcoe(:)
integer(kind=iwp), external :: list3, list4

line = lin
lrg = lrg0
lrs = lrs0
do mhlp_=1,mh
  mhlp = mhlp_ ! mhlp is in global module, is this necessary?
  jph_ = lpnew_head(mhlp)
  jpel = lpnew_ltail(mhlp)
  jper = lpnew_rtail(mhlp)
  jwl = lpnew_lwei(mhlp)
  jwr = lpnew_rwei(mhlp)
  vlop0 = vplpnew_w0(mhlp)
  vlop1 = vplpnew_w1(mhlp)

  select case (line)
    case default ! (1)
      call mma_allocate(lpcoe,[norb_dz+1,norb_inn],label='lpcoe')
      do l=norb_dz+1,lr
        lpcoe(l) = lpnew_coe(l,mhlp)
      end do
      wl = voint(lr0,lr)
      do l=lr0,lr
        list = list3(lr0,lr,l)
        kcoe = lpcoe(l)
        call neoc(kcoe,nocc,tcoe)
        wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
      end do
      wl = wl*vlop0
      call mma_deallocate(lpcoe)

    case (2)
      list = list3(lr0,lr,lrg)
      wl = vlop0*vint_ci(list)

    case (3)
      !list = list3(lr0,lrg,lrg)
      list = list3(lr0,lr,lrg)
      wl = (vlop0+vlop1)*vint_ci(list)

    case (4)
      list = list4(lr0,lrg,lrs,lr)
      wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list))

    case (5)
      !list = list3(lr0,lrg,lr)
      list = list3(lr0,lr,lrg)
      wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

    case (6)
      list = list4(lr0,lrg,lrs,lr)
      wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

    case (7)
      list = list4(lr0,lrg,lrs,lr)
      wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2)

    case (8)
      wl = vlop0*voint(lr,lr0)*Half

    case (9)
      wl = (vlop0-vlop1)*voint(lr,lr0)

    case (10)
      !list = list3(lrg,lr,lr0)
      list = list3(lr0,lr,lrg)
      wl = (vlop0+vlop1)*vint_ci(list)

    case (11)
      !list = list3(lrg,lr,lr0)
      list = list3(lr0,lr,lrg)
      wl = (vlop0-vlop1)*vint_ci(list)

    case (12)
      !list = list3(lrg,lr,lr0)
      list = list3(lr0,lr,lrg)
      wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)
  end select
  call prodab(2,jph_,jpel,jwl,jwr,0,wl,jper)
end do

return

end subroutine act_cloop

!subroutine dbl_head_act_tail_0(lpcoe)
!
!use gugaci_global, only: jb_sys, jml, jmr, jpad, jpadl, jpel, jper, jud, just, jwl, jwr, kk, line, lrg, lrs, lsm_inn, map_jplr, &
!                         norb_dz, norb_frz, norb_inn, ns_sm, vint_ci, voint, w0, w0_d1s, w0_d1t1, w0_d1v, w0_ds, w0_dt, w0_dv, &
!                         w0_td, w0_vv, w1, w1_d1s, w1_d1t1, w1_ds, w1_dt, w1_t1v, w1_td, w1_tv
!use Symmetry_Info, only: Mul
!use Constants, only: Zero, Two, Half
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: lpcoe(norb_dz+1:norb_inn)
!integer(kind=iwp) :: imd, imi, imij, imj, itypadl, itypadr, iwdl, iwdr, jmlr, kcoe, l, list, lmd, lmi, lmij, lmj, lpok, lr, lr0, &
!                     lra, lrd, lri, lrj, lrk, ni, nocc
!real(kind=wp) :: tcoe, vlop0, vlop1, w0ds1, w0ds3, w0dv1, w0dv2, w0td1, w0td2, w0td3, w0td4, w0td5, w1ds, w1ds3, w1td2, w1td3, &
!                 w1tv, wl, wl_430
!integer(kind=iwp), external :: list3, list4
!
!lra = kk(jpel)-1
!jml = mod((jpadl-1),8)
!jmr = mod((jpad-1),8)
!itypadl = (jpadl-1)/8+2
!itypadr = (jpad-1)/8+2
!if (jml == 0) then
!  jml = 8
!  itypadl = itypadl-1
!end if
!if (jmr == 0) then
!  jmr = 8
!  itypadr = itypadr-1
!end if
!if (jpadl == 1) itypadl = 1
!if (jpad == 1) itypadr = 1
!if (jpadl == 1) jml = ns_sm
!if (jpad == 1) jmr = ns_sm
!jml = Mul(jml,ns_sm)
!jmr = Mul(jmr,ns_sm)
!jmlr = Mul(jml,jmr)
!lpok = map_jplr(itypadl,itypadr)
!if (lpok == 0) return
!select case (line)
!  case default ! (23)
!    !line=23:-a^l<-->ds(7),dds(9),dt(14),ddtt(16)
!    select case (lpok)
!      case default ! (7)
!        ! ds(7-1) ar(23)-drl(30)-
!        do lri=norb_frz+1,norb_dz
!          lmi = lsm_inn(lri)
!          if (jmr == 1) then
!            iwdr = just(lri,lri)
!            do lrd=norb_frz+1,lri-1
!              lmd = lsm_inn(lrd)
!              if (lmd /= jml) cycle
!              iwdl = jud(lrd)
!              w0ds1 = w0_ds(1)
!              ni = mod(norb_dz-lrd,2)
!              if (ni == 0) w0ds1 = -w0ds1
!              vlop0 = w0*w0ds1
!              list = list3(lrd,lra,lri)
!              wl = vlop0*vint_ci(list)          !   3.2
!              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!            end do
!          end if
!          do lrj=lri+1,norb_dz
!            ! ds(7-3) ar(23)-bl(32)-br(31)-
!            lmj = lsm_inn(lrj)
!            lmij = Mul(lmi,lmj)
!            if (lmij /= jmr) cycle
!            do lrd=norb_frz+1,lri-1
!              iwdr = just(lri,lrj)
!              lmd = lsm_inn(lrd)
!              if (lmd /= jml) cycle
!              iwdl = jud(lrd)
!              w0ds3 = w0_ds(3)
!              w1ds3 = w1_ds(3)
!              ni = mod(norb_dz-lrj+lri-lrd,2)
!              if (ni == 0) w0ds3 = -w0ds3
!              if (ni == 0) w1ds3 = -w1ds3
!              vlop0 = w0*w0ds3
!              vlop1 = w1*w1ds3
!              list = list4(lrd,lri,lrj,lra)
!              wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
!              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!              if (jb_sys > 0) then
!                ! ds(7-2) ar(23)-bl(31)-br(32)-         the symmetry problem
!                iwdr = just(lrj,lri)
!                w0ds3 = w0_ds(2)
!                w1ds3 = w1_ds(2)
!                ni = mod(norb_dz-lrj+lri-lrd,2)
!                if (ni == 0) w0ds3 = -w0ds3
!                if (ni == 0) w1ds3 = -w1ds3
!                vlop0 = w0*w0ds3
!                vlop1 = w1*w1ds3
!                list = list4(lrd,lri,lrj,lra)
!                wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
!                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!              end if
!            end do
!          end do
!        end do
!
!      case (9)
!        do lri=norb_frz+1,norb_dz
!          ! d1s(9-1) ar(13)-drl(30)-
!          lmi = lsm_inn(lri)
!          do lrd=norb_frz+1,lri-1
!            lmd = lsm_inn(lrd)
!            if ((lmd == jml) .and. (jmr == 1)) then
!              iwdr = just(lri,lri)
!              iwdl = jud(lrd)
!              w0ds1 = w0_d1s(1)
!              ni = mod(norb_dz-lri+lri-lrd,2)
!              if (ni == 0) w0ds1 = -w0ds1
!              vlop0 = w0*w0ds1
!              list = list3(lrd,lra,lri)
!              wl = vlop0*vint_ci(list)          !   3.2
!              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!            end if
!            ! d1s(9-4) drl(12)-br(31)-
!            if ((jml == lmd) .and. (jmr == Mul(lmd,lmi))) then
!              iwdr = just(lrd,lri)
!              iwdl = jud(lrd)
!              w1ds = w1_d1s(4)
!              if (mod(norb_dz-lri,2) == 1) w1ds = -w1ds
!              vlop1 = w1*w1ds
!              list = list3(lri,lra,lrd)
!              wl = -vlop1*vint_ci(list)
!              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!            end if
!          end do
!        end do
!        do lri=norb_frz+1,norb_dz
!          lmi = lsm_inn(lri)
!          do lrj=lri+1,norb_dz
!            ! d1s(9-3) ar(13)-bl(32)-br(31)-
!            lmj = lsm_inn(lrj)
!            lmij = Mul(lmi,lmj)
!            if (lmij /= jmr) cycle
!            do lrd=norb_frz+1,lri-1
!              iwdr = just(lri,lrj)
!              lmd = lsm_inn(lrd)
!              if (lmd /= jml) cycle
!              iwdl = jud(lrd)
!              w0ds3 = w0_d1s(3)
!              w1ds3 = w1_d1s(3)
!              ni = mod(norb_dz-lrj+lri-lrd,2)
!              if (ni == 0) w0ds3 = -w0ds3
!              if (ni == 0) w1ds3 = -w1ds3
!              vlop0 = w0*w0ds3
!              vlop1 = w1*w1ds3
!              list = list4(lrd,lri,lrj,lra)
!              wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
!              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!              if (jb_sys > 0) then
!                ! d1s(9-2)   ar(13)-bl(31)-br(32)-   the symmetry problem
!                iwdr = just(lrj,lri)
!                w0ds3 = w0_d1s(2)
!                w1ds3 = w1_d1s(2)
!                ni = mod(norb_dz-lrj+lri-lrd,2)
!                if (ni == 0) w0ds3 = -w0ds3
!                if (ni == 0) w1ds3 = -w1ds3
!                vlop0 = w0*w0ds3
!                vlop1 = w1*w1ds3
!                list = list4(lrd,lri,lrj,lra)
!                wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
!                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!              end if
!            end do
!          end do
!        end do
!
!      case (14)
!        ! dt(14) ar(23)-bl(32)-br(32)-
!        do lri=norb_frz+1,norb_dz-1
!          lmi = lsm_inn(lri)
!          do lrj=lri+1,norb_dz
!            lmj = lsm_inn(lrj)
!            lmij = Mul(lmi,lmj)
!            if (lmij /= jmr) cycle
!            iwdr = just(lri,lrj)
!            do lrd=norb_frz+1,lri-1
!              lmd = lsm_inn(lrd)
!              lmd = Mul(lmd,1)
!              if (lmd /= jml) cycle
!              iwdl = jud(lrd)
!              vlop0 = w0*w0_dt
!              vlop1 = w1*w1_dt
!              ni = mod(lri-lrd+norb_dz-lrj,2)
!              if (ni == 0) then
!                vlop0 = -vlop0
!                vlop1 = -vlop1
!              end if
!              list = list4(lrd,lri,lrj,lra)
!              wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1) !1.1
!              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!            end do
!          end do
!        end do
!
!      case (16)
!        ! d1t1(16)  ar(13)-bl(31)-br(31)-
!        do lri=norb_frz+1,norb_dz-1
!          lmi = lsm_inn(lri)
!          do lrj=lri+1,norb_dz
!            lmj = lsm_inn(lrj)
!            lmij = Mul(lmi,lmj)
!            if (lmij /= jmr) cycle
!            iwdr = just(lri,lrj)
!            do lrd=norb_frz+1,lri-1
!              lmd = lsm_inn(lrd)
!              lmd = Mul(lmd,1)
!              if (lmd /= jml) cycle
!              iwdl = jud(lrd)
!              vlop0 = w0*w0_d1t1
!              vlop1 = w1*w1_d1t1
!              ni = mod(lri-lrd+norb_dz-lrj,2)
!              if (ni == 0) then
!                vlop0 = -vlop0
!                vlop1 = -vlop1
!              end if
!              list = list4(lrd,lri,lrj,lra)
!              wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1) !1.1
!              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!            end do
!          end do
!        end do
!
!      case (1:6,8,10:13,15,17:26)
!    end select
!
!  case (24)
!    ! line=24:-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
!    select case (lpok)
!      case default !(6)
!        call sd_head_dbl_tail_act(lra,lpcoe)
!
!      case (8)
!        call sdd_head_dbl_tail_act(lra,lpcoe)
!
!      case (13)
!        !call td_head_dbl_tail_act(lra,lpcoe)
!        ! td(13-1) (22)a&(23)
!        ! td(13-1) a&(23)c'(22)
!        ! td(13-5) (22)d&&l(33)b^l(23)
!        do lri=norb_frz+1,norb_dz
!          lmi = lsm_inn(lri)
!          if (lmi /= jmlr) cycle
!          w0td1 = w0_td(1)
!          w0td4 = w0_td(4)
!          w0td5 = w0_td(5)
!          ni = mod(norb_dz-lri,2)
!          if (ni == 1) w0td1 = -w0td1
!          if (ni == 1) w0td4 = -w0td4
!          if (ni == 1) w0td5 = -w0td5
!
!          ! td(13-1) a&(23)c'(22)
!          do lrd=lri+1,norb_dz
!            lmd = lsm_inn(lrd)
!            if (lmd /= jmr) cycle
!            iwdl = just(lri,lrd)
!            iwdr = jud(lrd)
!            vlop0 = -w0*w0td1
!            list = list3(lri,lra,lri)
!            wl = voint(lri,lra)+vint_ci(list)           !310,act_coe,610,7
!            list = list3(lri,lra,lrd)
!            wl = wl+vint_ci(list+1)
!            do lr=lri+1,norb_dz
!              if (lr == lrd) cycle
!              list = list3(lri,lra,lr)
!              wl = wl+Two*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,coe=
!            end do
!            do lrk=norb_dz+1,lra
!              list = list3(lri,lra,lrk)
!              kcoe = lpcoe(lrk)
!              call neoc(kcoe,nocc,tcoe)
!              wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
!            end do
!            wl = wl*vlop0
!            ! td(13-5) d&rl(33)b^l(23)c'(22)
!            vlop0 = -w0*w0td5
!            do lrk=1,lri-1
!              list = list3(lri,lra,lrk)
!              wl = wl-vlop0*(Two*vint_ci(list+1)-vint_ci(list))
!            end do
!            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!          end do
!          !-------------------------------------------------------------
!          do lrd=norb_frz+1,lri-1
!            lmd = lsm_inn(lrd)
!            if (lmd /= jmr) cycle
!            iwdl = just(lrd,lri)
!            iwdr = jud(lrd)
!            ! td(13-1) (22)a&(23)
!            vlop0 = w0*w0td1
!            list = list3(lri,lra,lri)
!            wl = vlop0*(voint(lri,lra)+vint_ci(list))             !310,act_c
!            do lr=lri+1,norb_dz
!              list = list3(lri,lra,lr)
!              wl = wl+vlop0*(Two*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2,
!            end do
!            do lrk=norb_dz+1,lra
!              list = list3(lri,lra,lrk)
!              kcoe = lpcoe(lrk)
!              call neoc(kcoe,nocc,tcoe)
!              wl = wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
!            end do
!            !wl = wl*vlop0
!            ! td(13-4) d&r&l(22)b^l(23)
!            vlop0 = w0*w0td4
!            vlop1 = w1*w0td4
!            list = list3(lri,lra,lrd)
!            wl = wl+(vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)
!            ! td(13-5) d&rl(33)c"(22)b^l(23)
!            vlop0 = w0*w0td5
!            do lrk=1,lri-1
!              if (lrk == lrd) cycle
!              list = list3(lri,lra,lrk)
!              wl = wl+vlop0*(vint_ci(list)-Two*vint_ci(list+1))      !4.3
!            end do
!            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!          end do
!        end do
!        do lri=norb_frz+1,norb_dz-1
!          lmi = lsm_inn(lri)
!          do lrj=lri+1,norb_dz
!            lmj = lsm_inn(lrj)
!            lmij = Mul(lmi,lmj)
!            if (lmij /= jml) cycle
!            iwdl = just(lri,lrj)
!
!            ! td(13-2) a&(23)b&r(23)b^r(32)
!            do lrd=lrj+1,norb_dz
!              lmd = lsm_inn(lrd)
!              if (lmd /= jmr) cycle
!              w0td2 = w0_td(2)
!              w1td2 = w1_td(2)
!              ni = mod(lrj-lri+norb_dz-lrd,2)
!              if (ni == 0) w0td2 = -w0td2
!              if (ni == 0) w1td2 = -w1td2
!
!              iwdr = jud(lrd)
!              vlop0 = w0*w0td2
!              vlop1 = w1*w1td2
!              list = list4(lri,lrj,lrd,lra)
!              wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list)) !1.3
!              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!            end do
!            ! td(13-3) a&(23)b&l(32)b^l(23)
!            do lrd=lri+1,lrj-1
!              lmd = lsm_inn(lrd)
!              if (lmd /= jmr) cycle
!              iwdr = jud(lrd)
!              w0td3 = w0_td(3)
!              w1td3 = w1_td(3)
!              ni = mod(lrd-lri+norb_dz-lrj,2)
!              if (ni == 0) w0td3 = -w0td3
!              if (ni == 0) w1td3 = -w1td3
!              vlop0 = w0*w0td3                !d6-8
!              vlop1 = w1*w1td3
!              list = list4(lri,lrd,lrj,lra)
!              wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2) !1.2
!              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!            end do
!          end do
!        end do
!
!      case (15)
!        call ttdd_head_dbl_tail_act(lra,lpcoe)
!
!      case (23)
!        ! dv(23-1) ar(23)-
!        ! dv(23-2) drl(33)-bl(23)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_dv(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          vlop1 = w1*w0dv1
!          !*************************************************************
!          lr0 = lrd
!          lr = kk(jpel)-1
!          list = list3(lr0,lr,lr0)
!          wl = vlop0*(voint(lr0,lr)+vint_ci(list))       !310+710
!          do l=lr0+1,norb_dz
!            list = list3(lr0,lr,l)
!            nocc = 2
!            tcoe = -Half
!            wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))  !dbl_
!          end do
!          do l=norb_dz+1,lr
!            list = list3(lr0,lr,l)
!            kcoe = lpcoe(l)
!            call neoc(kcoe,nocc,tcoe)
!            wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))   !act_c
!          end do
!          wl_430 = Zero
!          w0dv2 = w0_dv(2)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv2 = -w0dv2
!          do lrk=1,lrd-1
!            list = list3(lr0,lr,lrk)
!            vlop0 = w0*w0dv2
!            wl_430 = wl_430+vlop0*(vint_ci(list)-Two*vint_ci(list+1))
!          end do
!          wl = wl+wl_430
!          !*************************************************************
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (24)
!        ! d1v(24-1) ar(13)-
!        ! d1v(24-2) drl(33)-bl(13)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_d1v(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d24-1
!          vlop1 = w1*w0dv1
!          !*************************************************************
!          lr0 = lrd
!          lr = kk(jpel)-1
!          list = list3(lr0,lr,lr0)
!          wl = vlop0*(voint(lr0,lr)+vint_ci(list))       !310+710
!          do l=lr0+1,norb_dz
!            list = list3(lr0,lr,l)
!            nocc = 2
!            tcoe = -Half
!            wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))  !dbl_
!          end do
!          do l=norb_dz+1,lr
!            list = list3(lr0,lr,l)
!            kcoe = lpcoe(l)
!            call neoc(kcoe,nocc,tcoe)
!            wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))   !act_c
!          end do
!          wl_430 = Zero
!          w0dv2 = w0_d1v(2)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv2 = -w0dv2
!          do lrk=1,lrd-1
!            list = list3(lr0,lr,lrk)
!            vlop0 = w0*w0dv2
!            wl_430 = wl_430+vlop0*(vint_ci(list)-Two*vint_ci(list+1))
!          end do
!          wl = wl+wl_430
!          !*************************************************************
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (1:5,7,9:12,14,16:22,25:26)
!    end select
!
!  case (25)
!    ! line=25:-d^r^r<-->sv(10),tv(17),ttv(18)
!    select case (lpok)
!      case default ! (10)
!        call sv_head_dbl_tail_act(lra)
!
!      case (17)
!        ! tv(17) ar(23)-br(23)-
!        iwdr = 0
!        do lri=norb_frz+1,norb_dz
!          imi = lsm_inn(lri)
!          do lrj=lri,norb_dz
!            imj = lsm_inn(lrj)
!            imij = Mul(imi,imj)
!            if (imij /= jml) cycle
!            iwdl = just(lri,lrj)
!            vlop1 = w1*w1_tv             !d17 vlop0=0
!            list = list3(lri,lrj,lra)
!            wl = vlop1*vint_ci(list)        !2.1                  !!!!!
!            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!          end do
!        end do
!
!      case (18)
!        ! t1v(18) ar(13)-br(13)-
!        iwdr = 0
!        do lri=norb_frz+1,norb_dz
!          imi = lsm_inn(lri)
!          do lrj=lri,norb_dz
!            imj = lsm_inn(lrj)
!            imij = Mul(imi,imj)
!            if (imij /= jml) cycle
!            iwdl = just(lri,lrj)
!            vlop1 = w1*w1_t1v             !d18 vlop0=0
!            list = list3(lri,lrj,lra)
!            wl = vlop1*vint_ci(list)        !2.1                  !!!!!
!            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!          end do
!        end do
!
!      case (1:9,11:16,19:26)
!    end select
!    ! tmp for spin=0
!
!  case (26)
!    ! line=26:-d^r^l<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(19
!    select case (lpok)
!      case default ! (1)
!        call ss_head_dbl_tail_act(lra)
!
!      case (2)
!        call st_head_dbl_tail_act(lra)
!
!      case (3)
!        call ts_head_dbl_tail_act(lra)
!
!      case (4)
!        call stt_head_dbl_tail_act(lra)
!
!      case (5)
!        call tts_head_dbl_tail_act(lra)
!
!      case (11)
!        call tt_head_dbl_tail_act(lra)
!
!      case (12)
!        call tttt_head_dbl_tail_act(lra)
!
!      case (19)
!        call dd_head_dbl_tail_act(lra)
!
!      case (20)
!        call dddd_head_dbl_tail_act(lra)
!
!      case (21)
!        call dd1_head_dbl_tail_act(lra)
!
!      case (22)
!        call d1d_head_dbl_tail_act(lra)
!
!      case (25)
!        ! vv(25) drl(33)-
!        if (jwl == jwr) return
!        vlop0 = w0*w0_vv             !d25
!        wl = Zero
!        iwdl = 0
!        iwdr = 0
!        do lri=1,norb_dz
!          wl = wl+vlop0*voint(lri,lra)
!        end do
!        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!
!      case (6:10,13:18,23:24,26)
!    end select
!
!  case (27)
!    ! sv(10),tv(17),ttv(18)
!    ! line=27:-b^r-a^r<-->sv(10),tv(17),ttv(18)
!    select case (lpok)
!      case default ! (10)
!        call sv_head_dbl_tail_act(lra)
!
!      case (17)
!        ! tv(17) ar(23)-br(23)-
!        iwdr = 0
!        do lri=norb_frz+1,norb_dz
!          lmi = lsm_inn(lri)
!          do lrj=lri+1,norb_dz
!            lmj = lsm_inn(lrj)
!            lmij = Mul(lmi,lmj)
!            if (lmij /= jml) cycle
!            w1tv = w1_tv
!            if (mod(lrj-lri,2) == 0) w1tv = -w1tv
!            iwdl = just(lri,lrj)
!            vlop1 = w1*w1tv             !d17
!            list = list4(lri,lrj,lrs,lra)
!            wl = vlop1*(vint_ci(list)-vint_ci(list+2)) !1.3 vlop0=0      !!!!!
!            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!          end do
!        end do
!
!      case (18)
!        ! t1v(18) ar(13)-br(13)-
!        iwdr = 0
!        do lri=norb_frz+1,norb_dz-1
!          lmi = lsm_inn(lri)
!          do lrj=lri+1,norb_dz
!            lmj = lsm_inn(lrj)
!            lmij = Mul(lmi,lmj)
!            if (lmij /= jml) cycle
!            w1tv = w1_t1v
!            if (mod(lrj-lri,2) == 0) w1tv = -w1tv
!            iwdl = just(lri,lrj)
!            vlop1 = w1*w1tv             !d17
!            list = list4(lri,lrj,lrs,lra)
!            wl = vlop1*(vint_ci(list)-vint_ci(list+2)) !1.3 vlop0=0      !!!!!
!            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!          end do
!        end do
!
!      case (1:9,11:16,19:26)
!    end select
!    ! tmp for spin=0
!
!  case (28)
!    ! line=28:-b^l-a^r<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(
!    select case (lpok)
!      case default ! (1)
!        call ss_head_dbl_tail_act(lra)
!
!      case (2)
!        call st_head_dbl_tail_act(lra)
!
!      case (3)
!        call ts_head_dbl_tail_act(lra)
!
!      case (4)
!        call stt_head_dbl_tail_act(lra)
!
!      case (5)
!        call tts_head_dbl_tail_act(lra)
!
!      case (11)
!        call tt_head_dbl_tail_act(lra)
!
!      case (12)
!        call tttt_head_dbl_tail_act(lra)
!
!      case (19)
!        call dd_head_dbl_tail_act(lra)
!
!      case (20)
!        call dddd_head_dbl_tail_act(lra)
!
!      case (21)
!        call dd1_head_dbl_tail_act(lra)
!
!      case (22)
!        call d1d_head_dbl_tail_act(lra)
!
!      case (25)
!        ! vv(25) drl(33)-
!        vlop0 = w0*w0_vv             !d25
!        wl = Zero
!        iwdl = 0
!        iwdr = 0
!        do lrk=1,norb_dz
!          list = list3(lrs,lra,lrk)
!          wl = wl+vlop0*(vint_ci(list)-Two*vint_ci(list+1))   !4.3 vlop1=0
!        end do
!        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!
!      case (6:10,13:18,23:24,26)
!    end select
!
!  case (29)
!    ! line=29:-b^r-a^l<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(
!    select case (lpok)
!      case default ! (1)
!        call ss_head_dbl_tail_act(lra)
!
!      case (2)
!        call st_head_dbl_tail_act(lra)
!
!      case (3)
!        call ts_head_dbl_tail_act(lra)
!
!      case (4)
!        call stt_head_dbl_tail_act(lra)
!
!      case (5)
!        call tts_head_dbl_tail_act(lra)
!
!      case (11)
!        call tt_head_dbl_tail_act(lra)
!
!      case (12)
!        call tttt_head_dbl_tail_act(lra)
!
!      case (19)
!        call dd_head_dbl_tail_act(lra)
!
!      case (20)
!        call dddd_head_dbl_tail_act(lra)
!
!      case (21)
!        call dd1_head_dbl_tail_act(lra)
!
!      case (22)
!        call d1d_head_dbl_tail_act(lra)
!
!      case (25)
!        ! vv(25) drl(33)-
!        if (jwl >= jwr) return
!        vlop0 = w0*w0_vv             !d25
!        wl = Zero
!        iwdl = 0
!        iwdr = 0
!        do lrk=1,norb_dz
!          list = list3(lrs,lra,lrk)
!          wl = vlop0*vint_ci(list)      !4.2  vlop1=0         !!!!!
!        end do
!        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!
!      case (6:10,13:18,23:24,26)
!    end select
!
!  case (30)
!    ! line=30:-b&r-d^r^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
!    select case (lpok)
!      case default ! (6)
!        ! sd(6-3) a&r(13)c'(22)-
!        call dbl_sd_act_comp(3,lra)
!        ! sd(6-3) tmp for spin=0
!
!      case (8)
!        call dbl_sdd_act_comp(3,lra)
!
!      case (13)
!        call dbl_td_act_comp(3,lra)
!
!      case (15)
!        call dbl_ttdd_act_comp(3,lra)
!
!      case (23)
!        ! dv(23-1) ar(23)-
!        ! dv(23-2) drl(33)-bl(23)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_dv(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                   !d23-1
!          vlop1 = w1*w0dv1
!          list = list3(lrd,lrg,lra)
!          wl = (vlop0+vlop1)*vint_ci(list)        !2.1       !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (24)
!        ! d1v(24-1)  ar(13)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_d1v(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                   !d23-1
!          vlop1 = w1*w0dv1
!          list = list3(lrd,lrg,lra)
!          wl = (vlop0+vlop1)*vint_ci(list)        !2.1       !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (1:5,7,9:12,14,16:22,25:26)
!    end select
!
!  case (31)
!    ! line=31:-b&l-d^r^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
!    select case (lpok)
!      case default ! (6)
!        call dbl_sd_act_comp(5,lra)
!
!      case (8)
!        call dbl_sdd_act_comp(5,lra)
!
!      case (13)
!        call dbl_td_act_comp(5,lra)
!
!      case (15)
!        call dbl_ttdd_act_comp(5,lra)
!
!      case (23)
!        ! dv(23-1) ar(23)-
!        ! dv(23-2) drl(33)-bl(23)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_dv(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          vlop1 = w1*w0dv1
!          list = list3(lrd,lrg,lra)
!          wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*(vint_ci(list)) !2.2          !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (24)
!        ! d1v(24-1)  ar(13)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_d1v(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          vlop1 = w1*w0dv1
!          list = list3(lrd,lrg,lra)
!          wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*(vint_ci(list)) !2.2          !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (1:5,7,9:12,14,16:22,25:26)
!    end select
!
!  case (32)
!    ! line=32:-b&r-b^r-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
!    select case (lpok)
!      case default ! (6)
!        call dbl_sd_act_comp(4,lra)
!
!      case (8)
!        call dbl_sdd_act_comp(4,lra)
!
!      case (13)
!        call dbl_td_act_comp(4,lra)
!
!      case (15)
!        call dbl_ttdd_act_comp(4,lra)
!
!      case (23)
!        ! dv(23-1) ar(23)-
!        ! dv(23-2) drl(33)-bl(23)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_dv(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          vlop1 = w1*w0dv1
!          list = list4(lrd,lrg,lrs,lra)
!          wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list)) !1.3        !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (24)
!        ! d1v(24-1)  ar(13)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_d1v(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          vlop1 = w1*w0dv1
!          list = list4(lrd,lrg,lrs,lra)
!          wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list)) !1.3        !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (1:5,7,9:12,14,16:22,25:26)
!    end select
!
!  case (33)
!    ! line=33:-b&l-b^r-a^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
!    select case (lpok)
!      case default ! (6)
!        call dbl_sd_act_comp(6,lra)
!
!      case (8)
!        call dbl_sdd_act_comp(6,lra)
!
!      case (13)
!        call dbl_td_act_comp(6,lra)
!
!      case (15)
!        call dbl_ttdd_act_comp(6,lra)
!
!      case (23)
!        ! dv(23-1) ar(23)-
!        ! dv(23-2) drl(33)-bl(23)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_dv(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          vlop1 = w1*w0dv1
!          list = list4(lrd,lrg,lrs,lra)
!          wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list) !1.1          !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (24)
!        ! d1v(24-1)  ar(13)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_d1v(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          vlop1 = w1*w0dv1
!          list = list4(lrd,lrg,lrs,lra)
!          wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list) !1.1          !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (1:5,7,9:12,14,16:22,25:26)
!    end select
!
!  case (34)
!    ! line=34:-b&l-b^l-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
!    select case (lpok)
!      case default ! (6)
!        call dbl_sd_act_comp(7,lra)
!
!      case (8)
!        call dbl_sdd_act_comp(7,lra)
!
!      case (13)
!        call dbl_td_act_comp(7,lra)
!
!      case (15)
!        call dbl_ttdd_act_comp(7,lra)
!
!      case (23)
!        ! dv(23-1) ar(23)-
!        ! dv(23-2) drl(33)-bl(23)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_dv(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          vlop1 = w1*w0dv1
!          list = list4(lrd,lrg,lrs,lra)
!          wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2) !1.2      !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (24)
!        ! d1v(24-1)  ar(13)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_d1v(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          vlop1 = w1*w0dv1
!          list = list4(lrd,lrg,lrs,lra)
!          wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2) !1.2      !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (1:5,7,9:12,14,16:22,25:26)
!    end select
!
!  case (35)
!    ! line=35:-d&r^l-a^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
!    select case (lpok)
!      case default !(6)
!        call dbl_sd_act_comp(2,lra)
!
!      case (8)
!        call dbl_sdd_act_comp(2,lra)
!
!      case (13)
!        call dbl_td_act_comp(2,lra)
!
!      case (15)
!        call dbl_ttdd_act_comp(2,lra)
!
!      case (23)
!        ! dv(23-1) ar(23)-
!        ! dv(23-2) drl(33)-bl(23)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_dv(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          list = list3(lrd,lra,lrg)
!          wl = vlop0*vint_ci(list)          !3.2         !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (24)
!        ! d1v(24-1)  ar(13)-
!        iwdr = 0
!        do lrd=norb_frz+1,norb_dz
!          imd = lsm_inn(lrd)
!          if (imd /= jml) cycle
!          iwdl = jud(lrd)
!          w0dv1 = w0_d1v(1)
!          ni = mod(norb_dz-lrd,2)
!          if (ni == 1) w0dv1 = -w0dv1
!          vlop0 = w0*w0dv1                !d23-1
!          list = list3(lrd,lra,lrg)
!          wl = vlop0*vint_ci(list)          !3.2         !!!!!
!          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!        end do
!
!      case (1:5,7,9:12,14,16:22,25:26)
!    end select
!end select
!
!return
!
!end subroutine dbl_head_act_tail_0

subroutine dbl_td_act_comp(lin,lra)

use gugaci_global, only: jml, jmr, jpel, jper, jud, just, jwl, jwr, lrg, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_td, w1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0td1, wl

! td(13-1) (22)a&(23)
! td(13-1) a&(23)c'(22)
! td(13-2) a&(23)b&r(23)b^r(32)
! td(13-3) a&(23)b&l(32)b^l(23)
! td(13-4) d&r&l(22)b^l(23)
! td(13-5) (22)d&&l(33)b^l(23)
! td(13-5) d&rl(33)c"(22)b^l(23)
! td(13-5) d&rl(33)b^l(23)c'(22)

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_td(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0td1 = -w0td1
  end if

  ! td(13-1) a&(23)c'(22)
  vlop0 = -w0*w0td1
  vlop1 = -w1*w0td1
  call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
  ! td(13-1) (22)a&(23)
  vlop0 = w0*w0td1
  vlop1 = w1*w0td1
  call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
  !---------------------------------------------------------------------
end do

return

end subroutine dbl_td_act_comp

subroutine dbl_ttdd_act_comp(lin,lra)

use gugaci_global, only: jml, jmr, jpel, jper, jud, just, jwl, jwr, lrg, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_t1d1, w1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0td1, wl

! t1d1(15-1)  ar(13)-
! t1d1(15-1)  ar(13)-c'(11)-

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_t1d1(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0td1 = -w0td1
  end if
  ! t1d1(15-1)  ar(13)-c'(11)-
  vlop0 = -w0*w0td1
  vlop1 = -w1*w0td1
  call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
  ! t1d1(15-1)  (11)ar(13)-
  vlop0 = w0*w0td1
  vlop1 = w1*w0td1
  call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
  !---------------------------------------------------------------------
end do

return

end subroutine dbl_ttdd_act_comp

subroutine comp_loop(line,lr0,lrg,lrs,lr,vlop0,vlop1,wl)

use gugaci_global, only: vint_ci, voint
use Constants, only: Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: line, lr0, lrg, lrs, lr
real(kind=wp), intent(in) :: vlop0, vlop1
real(kind=wp), intent(out) :: wl
integer(kind=iwp) :: list
integer(kind=iwp), external :: list3, list4

select case (line)
  case default ! (1)
    !do l=norb_dz+1,lr-1
    ! lpcoe(l) = lp_coe(l,mpl)
    !end do
    !lpcoe(lr) = kcoe
    !wl = voint(lr0,lr)
    !do l=lr0,lr
    !  list = list3(lr0,lr,l)
    !  kcoe = lpcoe(l)
    !  call neoc(kcoe,nocc,tcoe)
    !  wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
    !end do
    !wl = wl*vlop0

  case (2)
    list = list3(lr0,lr,lrs)   ! lrg
    wl = vlop0*vint_ci(list)

  case (3)
    list = list3(lr0,lrg,lr)
    wl = (vlop0+vlop1)*vint_ci(list)

  case (4)
    list = list4(lr0,lrg,lrs,lr)
    wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list))

  case (5)
    list = list3(lr0,lrg,lr)
    wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

  case (6)
    list = list4(lr0,lrg,lrs,lr)
    wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

  case (7)
    list = list4(lr0,lrg,lrs,lr)
    wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2)

  case (8)
    wl = vlop0*voint(lr,lr0)*Half

  case (9)
    wl = (vlop0-vlop1)*voint(lr,lr0)

  case (10)
    list = list3(lrs,lr,lr0)      ! lrg
    wl = (vlop0+vlop1)*vint_ci(list)

  case (11)
    list = list3(lrs,lr,lr0)      ! lrg
    wl = (vlop0-vlop1)*vint_ci(list)

  case (12)
    list = list3(lrs,lr,lr0)      ! lrg
    wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list)

end select

return

end subroutine comp_loop

subroutine dbl_sd_act_comp(lin,lra)
! sd(6-1) a&r(02)-
! sd(6-2) (22)a&(13)-
! sd(6-3) a&r(13)c'(22)-
! sd(6-4) a&r(23)c'(12)-

use gugaci_global, only: jb_sys, jml, jmr, jpel, jper, jud, just, jwl, jwr, lrg, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_sd, w1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0sd1, w0sd2, w0sd3, w0sd4, wl

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd1 = w0_sd(1)
  w0sd2 = w0_sd(2)
  w0sd3 = w0_sd(3)
  w0sd4 = w0_sd(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd3 = -w0sd3
    w0sd4 = -w0sd4
  end if
  if ((jml == 1) .and. (lmi == jmr)) then
    ! sd(6-1) a&r(02)-
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    vlop0 = w0*w0sd1
    vlop1 = w1*w0sd1
    call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end if
  ! sd(6-2) (22)a&(13)-
  vlop0 = w0*w0sd2
  vlop1 = w1*w0sd2
  call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
  ! sd(6-4) a&r(23)-c'(12)-
  vlop0 = -w0*w0sd4
  vlop1 = -w1*w0sd4
  call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
  ! sd(6-3) a&r(13)c'(22)-
  if (jb_sys > 0) then
    vlop0 = -w0*w0sd3
    vlop1 = -w1*w0sd3
    call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
    do lrk=lri+1,norb_dz
      lmk = lsm_inn(lrk)
      if (lmk /= jmr) cycle
      iwdl = just(lrk,lri)
      iwdr = jud(lrk)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
  end if
end do

return

end subroutine dbl_sd_act_comp

subroutine dbl_sdd_act_comp(lin,lra)
!sd1(8-1)    ar(01)-
!sd1(8-2)    (11)ar(23)-
!sd1(8-3)    ar(13)-c'(21)-
!sd1(8-4)    ar(23)-c'(11)-

use gugaci_global, only: jb_sys, jml, jmr, jpel, jper, jud, just, jwl, jwr, lrg, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_sd1, w1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0sd1, w0sd2, w0sd3, w0sd4, wl

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd1 = w0_sd1(1)
  w0sd2 = w0_sd1(2)
  w0sd3 = w0_sd1(3)
  w0sd4 = w0_sd1(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd3 = -w0sd3
    w0sd4 = -w0sd4
  end if
  if ((jml == 1) .and. (lmi == jmr)) then
    ! sd1(8-1)    ar(01)-
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    vlop0 = w0*w0sd1
    vlop1 = w1*w0sd1
    call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end if
  ! sd1(8-2)    (11)ar(23)-
  vlop0 = w0*w0sd2
  vlop1 = w1*w0sd2
  call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
  ! sd1(8-4)    ar(23)-c'(11)-
  vlop0 = -w0*w0sd4
  vlop1 = -w1*w0sd4
  call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
  ! sd1(8-3)    ar(13)-c'(21)-
  if (jb_sys > 0) then
    vlop0 = -w0*w0sd3
    vlop1 = -w1*w0sd3
    call comp_loop(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl)
    do lrk=lri+1,norb_dz
      lmk = lsm_inn(lrk)
      if (lmk /= jmr) cycle
      iwdl = just(lrk,lri)
      iwdr = jud(lrk)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
  end if
end do

return

end subroutine dbl_sdd_act_comp

subroutine ext_space_loop()

use gugaci_global, only: iseg_downwei, iseg_sta, iseg_upwei, isegdownwei, isegsta, isegupwei, nu_ae
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: inx, ism

ism = 0
do inx=18,25
  ism = ism+1
  if (nu_ae(inx) == 0) cycle
  isegsta = iseg_sta(inx)
  isegupwei = iseg_upwei(inx)
  isegdownwei = iseg_downwei(inx)
  call g_ss_ext_sequence(ism,4)
end do
ism = 0
do inx=10,17
  ism = ism+1
  if (nu_ae(inx) == 0) cycle
  isegsta = iseg_sta(inx)
  isegupwei = iseg_upwei(inx)
  isegdownwei = iseg_downwei(inx)
  call g_tt_ext_sequence(ism)
end do
ism = 0
do inx=2,9
  ism = ism+1
  if (nu_ae(inx) == 0) cycle
  isegsta = iseg_sta(inx)
  isegupwei = iseg_upwei(inx)
  isegdownwei = iseg_downwei(inx)
  call g_dd_ext_sequence(ism)
end do

return

end subroutine ext_space_loop

subroutine g_tt_ext_sequence(ism)

use gugaci_global, only: ibsm_ext, icano_nnend, icano_nnsta, icnt_base, iesm_ext, iwt_orb_ext, m_jc, m_jd, max_tmpvalue, ng_sm
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ism
integer(kind=iwp) :: ic, ic_sta, icano_nn, icend, id, id_sta, idend, idsta, isma, ismb, ismc, ismd

icano_nnsta = 2
icnt_base = 0
do ismd=1,ng_sm
  ismc = Mul(ism,ismd)
  if (ismc > ismd) cycle
  id_sta = ibsm_ext(ismd)
  idsta = id_sta
  idend = iesm_ext(ismd)
  ic_sta = ibsm_ext(ismc)
  icend = iesm_ext(ismc)
  if (ismd == ismc) idsta = idsta+1
  do id=idsta,idend
    m_jd = id-id_sta+1
    do ic=ic_sta,min(icend,id-1)
      m_jc = ic-ic_sta+1
      icano_nn = iwt_orb_ext(ic,id)
      if (icnt_base+icano_nn-1 > max_tmpvalue) then
        call complete_ext_loop()
        icnt_base = 0
        icano_nnsta = icano_nn
      end if
      icano_nnend = icano_nn
      do ismb=1,ismd-1
        isma = Mul(ism,ismb)
        if (isma > ismb) cycle
        if (ismc > ismb) then
          call g12_t_diffsym(isma,ismb,ismc)
        else if (ismc > isma) then
          call g11a_t_diffsym(isma,ismb,ismc)
        else
          call g11b_t_diffsym(isma,ismb,ismc)
        end if
      end do
      if (ism == 1) then
        isma = ismd
        call g1112_t_symaaaa(isma,ic,id)
      else
        isma = Mul(ism,ismd)
        call g11a11b_t_symaacc(isma,ismd,ic,id)
      end if
      call g36_t_ext(ismc,ic,id)
      !write(u6,*) '  g36',value_lpext(1)
      call g5_t_ext(ismd,ic,id)
      !write(u6,*) '  g5' ,value_lpext(1)
      if (ism == 1) call g9_t_ext(ismd,ic,id)
      !write(u6,*) '  g9',value_lpext(1)
      icnt_base = icnt_base+icano_nn-1
    end do
  end do
end do
call complete_ext_loop()

end subroutine g_tt_ext_sequence

subroutine dbl_head_act_tail(lpcoe)

use gugaci_global, only: jb_sys, jml, jmr, jpad, jpadl, jpel, jper, jud, just, jwl, jwr, kk, line, lrg, lrs, lsm_inn, map_jplr, &
                         norb_dz, norb_frz, norb_inn, ns_sm, vint_ci, voint, w0, w0_d1s, w0_d1t1, w0_d1v, w0_ds, w0_dt, w0_dv, &
                         w0_td, w0_vv, w1, w1_d1s, w1_d1t1, w1_ds, w1_dt, w1_t1v, w1_td, w1_tv
use Symmetry_Info, only: Mul
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lpcoe(norb_dz+1:norb_inn)
integer(kind=iwp) :: imd, imi, imij, imj, itypadl, itypadr, iwdl, iwdr, jmlr, kcoe, l, list, lmd, lmi, lmij, lmj, lpok, lr, lr0, &
                     lra, lrd, lri, lrj, lrk, ni, nocc
real(kind=wp) :: tcoe, vlop0, vlop1, w0ds1, w0ds2, w0ds3, w0dv1, w0dv2, w0td1, w0td2, w0td3, w0td4, w0td5, w1ds, w1ds2, w1ds3, &
                 w1td2, w1td3, w1tv, wl, wl_430
integer(kind=iwp), external :: list3, list4

lra = kk(jpel)-1
jml = mod((jpadl-1),8)
jmr = mod((jpad-1),8)
itypadl = (jpadl-1)/8+2
itypadr = (jpad-1)/8+2
if (jml == 0) then
  jml = 8
  itypadl = itypadl-1
end if
if (jmr == 0) then
  jmr = 8
  itypadr = itypadr-1
end if
if (jpadl == 1) itypadl = 1
if (jpad == 1) itypadr = 1
if (jpadl == 1) jml = ns_sm
if (jpad == 1) jmr = ns_sm
jml = Mul(jml,ns_sm)
jmr = Mul(jmr,ns_sm)
jmlr = Mul(jml,jmr)
lpok = map_jplr(itypadl,itypadr)
if (lpok == 0) return
select case (line)
  case default ! (23)
    ! line=23:-a^l<-->ds(7),dds(9),dt(14),ddtt(16)
    select case (lpok)
      case default !(7)
        ! ds(7-2) ar(23)-bl(31)-br(32)-

        ! ds(7-1) ar(23)-drl(30)-
        do lri=norb_frz+1,norb_dz
          lmi = lsm_inn(lri)
          if (jmr == 1) then
            iwdr = just(lri,lri)
            do lrd=norb_frz+1,lri-1
              lmd = lsm_inn(lrd)
              if (lmd /= jml) cycle
              iwdl = jud(lrd)
              w0ds1 = w0_ds(1)
              ni = mod(norb_dz-lri+lri-lrd,2)
              if (ni == 0) w0ds1 = -w0ds1
              vlop0 = w0*w0ds1
              list = list3(lrd,lra,lri)
              wl = vlop0*vint_ci(list)          !   3.2
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            end do
          end if
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jmr) cycle
            do lrd=norb_frz+1,lri-1
              lmd = lsm_inn(lrd)
              if (lmd /= jml) cycle
              list = list4(lrd,lri,lrj,lra)
              iwdl = jud(lrd)
              w0ds2 = w0_ds(2)
              w1ds2 = w1_ds(2)
              w0ds3 = w0_ds(3)
              w1ds3 = w1_ds(3)
              ni = mod(norb_dz-lrj+lri-lrd,2)
              if (ni == 0) then
                w0ds2 = -w0ds2
                w1ds2 = -w1ds2
                w0ds3 = -w0ds3
                w1ds3 = -w1ds3
              end if
              ! ds(7-3) ar(23)-bl(32)-br(31)-
              iwdr = just(lri,lrj)
              vlop0 = w0*w0ds3
              vlop1 = w1*w1ds3
              wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
              if (jb_sys > 0) then
                ! ds(7-2) ar(23)-bl(31)-br(32)-         the symmetry problem
                iwdr = just(lrj,lri)
                vlop0 = w0*w0ds2
                vlop1 = w1*w1ds2
                wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
              end if
            end do
          end do
        end do

      case (9)
        do lri=norb_frz+1,norb_dz
          ! d1s(9-1) ar(13)-drl(30)-
          lmi = lsm_inn(lri)
          do lrd=norb_frz+1,lri-1
            lmd = lsm_inn(lrd)
            if ((lmd == jml) .and. (jmr == 1)) then
              iwdr = just(lri,lri)
              iwdl = jud(lrd)
              w0ds1 = w0_d1s(1)
              ni = mod(norb_dz-lri+lri-lrd,2)
              if (ni == 0) w0ds1 = -w0ds1
              vlop0 = w0*w0ds1
              list = list3(lrd,lra,lri)
              wl = vlop0*vint_ci(list)          !   3.2
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            end if
            ! d1s(9-4) drl(12)-br(31)-
            if ((jml == lmd) .and. (jmr == Mul(lmd,lmi))) then
              iwdr = just(lrd,lri)
              iwdl = jud(lrd)
              w1ds = w1_d1s(4)
              if (mod(norb_dz-lri,2) == 1) w1ds = -w1ds
              vlop1 = w1*w1ds
              list = list3(lri,lra,lrd)
              wl = -vlop1*vint_ci(list)
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            end if
          end do
        end do
        do lri=norb_frz+1,norb_dz
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            ! d1s(9-3) ar(13)-bl(32)-br(31)-
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jmr) cycle
            do lrd=norb_frz+1,lri-1
              iwdr = just(lri,lrj)
              lmd = lsm_inn(lrd)
              if (lmd /= jml) cycle
              iwdl = jud(lrd)
              w0ds3 = w0_d1s(3)
              w1ds3 = w1_d1s(3)
              ni = mod(norb_dz-lrj+lri-lrd,2)
              if (ni == 0) w0ds3 = -w0ds3
              if (ni == 0) w1ds3 = -w1ds3
              vlop0 = w0*w0ds3
              vlop1 = w1*w1ds3
              list = list4(lrd,lri,lrj,lra)
              wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
              if (jb_sys > 0) then
                ! d1s(9-2)   ar(13)-bl(31)-br(32)-   the symmetry problem
                iwdr = just(lrj,lri)
                w0ds3 = w0_d1s(2)
                w1ds3 = w1_d1s(2)
                ni = mod(norb_dz-lrj+lri-lrd,2)
                if (ni == 0) w0ds3 = -w0ds3
                if (ni == 0) w1ds3 = -w1ds3
                vlop0 = w0*w0ds3
                vlop1 = w1*w1ds3
                list = list4(lrd,lri,lrj,lra)
                wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)            !1.1
                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
              end if
            end do
          end do
        end do

      case (14)
        ! dt(14) ar(23)-bl(32)-br(32)-
        do lri=norb_frz+1,norb_dz-1
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jmr) cycle
            iwdr = just(lri,lrj)
            do lrd=norb_frz+1,lri-1
              lmd = lsm_inn(lrd)
              if (lmd /= jml) cycle
              iwdl = jud(lrd)
              vlop0 = w0*w0_dt
              vlop1 = w1*w1_dt
              ni = mod(lri-lrd+norb_dz-lrj,2)
              if (ni == 0) then
                vlop0 = -vlop0
                vlop1 = -vlop1
              end if
              list = list4(lrd,lri,lrj,lra)
              wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1) !1.1
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            end do
          end do
        end do

      case (16)
        ! d1t1(16)  ar(13)-bl(31)-br(31)-
        do lri=norb_frz+1,norb_dz-1
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jmr) cycle
            iwdr = just(lri,lrj)
            do lrd=norb_frz+1,lri-1
              lmd = lsm_inn(lrd)
              lmd = Mul(lmd,1)
              if (lmd /= jml) cycle
              iwdl = jud(lrd)
              vlop0 = w0*w0_d1t1
              vlop1 = w1*w1_d1t1
              ni = mod(lri-lrd+norb_dz-lrj,2)
              if (ni == 0) then
                vlop0 = -vlop0
                vlop1 = -vlop1
              end if
              list = list4(lrd,lri,lrj,lra)
              wl = (vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1) !1.1
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            end do
          end do
        end do

      case (1:6,8,10,13,15,17:26)
    end select

  case (24)
    ! line=24:-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        ! sd(6-1) a&r(02)-
        ! sd(6-2) c(22)a&(13)-
        ! sd(6-3) a&r(13)c'(22)-
        ! sd(6-4) a&r(23)c'(12)-
        ! sd(6-5) a&r(23)b&r(13)b^r(32)
        ! sd(6-6) a&r(13)b&r(23)b^r(32)
        ! sd(6-7) a&r(13)b&l(32)b^l(23)
        ! sd(6-8) a&r(23)b&l(32)b^l(13)
        ! sd(6-9) d&r&r(03)b^r(32)
        ! sd(6-10) d&r&l(12)b^l(23)
        ! sd(6-11) d&r&l(22)b^l(13)
        ! sd(6-12) d&r&l(33)b^l(02)
        ! sd(6-13) (22)d&r&l(33)b^l(13)
        ! sd(6-14) d&r&l(33)c"(22)b^l(13)
        ! sd(6-15) d&r&l(33)b^l(13)c'(22)
        ! sd(6-16) d&r&l(33)b^l(23)c'(12)
        ! sd(6-1) a&r(02)-
        call sd_head_dbl_tail_act(lra,lpcoe)

      case (8)
        call sdd_head_dbl_tail_act(lra,lpcoe)

      case (13)
        ! td(13-1) (22)a&(23)
        ! td(13-1) a&(23)c'(22)
        ! td(13-5) (22)d&&l(33)b^l(23)
        do lri=norb_frz+1,norb_dz
          lmi = lsm_inn(lri)
          if (lmi /= jmlr) cycle
          w0td1 = w0_td(1)
          w0td4 = w0_td(4)
          w0td5 = w0_td(5)
          ni = mod(norb_dz-lri,2)
          if (ni == 1) w0td1 = -w0td1
          if (ni == 1) w0td4 = -w0td4
          if (ni == 1) w0td5 = -w0td5

          ! td(13-1) a&(23)c'(22)
          do lrd=lri+1,norb_dz
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdl = just(lri,lrd)
            iwdr = jud(lrd)
            vlop0 = -w0*w0td1
            list = list3(lri,lra,lri)
            wl = voint(lri,lra)+vint_ci(list)         !310,act_coe,610,7
            list = list3(lri,lra,lrd)
            wl = wl+vint_ci(list+1)
            do lr=lri+1,norb_dz
              if (lr == lrd) cycle
              list = list3(lri,lra,lr)
              wl = wl+Two*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,coe=
            end do
            do lrk=norb_dz+1,lra
              list = list3(lri,lra,lrk)
              kcoe = lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            end do
            wl = wl*vlop0
            ! td(13-5) d&rl(33)b^l(23)c'(22)
            vlop0 = -w0*w0td5
            do lrk=1,lri-1
              list = list3(lri,lra,lrk)
              wl = wl-vlop0*(Two*vint_ci(list+1)-vint_ci(list))
            end do
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          end do
          !-------------------------------------------------------------
          do lrd=norb_frz+1,lri-1
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdl = just(lrd,lri)
            iwdr = jud(lrd)
            ! td(13-1) (22)a&(23)
            vlop0 = w0*w0td1
            list = list3(lri,lra,lri)
            wl = vlop0*(voint(lri,lra)+vint_ci(list))             !310,act_c
            do lr=lri+1,norb_dz
              list = list3(lri,lra,lr)
              wl = wl+vlop0*(Two*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2,
            end do
            do lrk=norb_dz+1,lra
              list = list3(lri,lra,lrk)
              kcoe = lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              wl = wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            end do
            !wl = wl*vlop0
            ! td(13-4) d&r&l(22)b^l(23)
            vlop0 = w0*w0td4
            vlop1 = w1*w0td4
            list = list3(lri,lra,lrd)
            wl = wl+(vlop0-vlop1)*vint_ci(list)-Two*vlop0*vint_ci(list+1)
            ! td(13-5) d&rl(33)c"(22)b^l(23)
            vlop0 = w0*w0td5
            do lrk=1,lri-1
              if (lrk == lrd) cycle
              list = list3(lri,lra,lrk)
              wl = wl+vlop0*(vint_ci(list)-Two*vint_ci(list+1))      !4.3
            end do
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          end do
        end do
        do lri=norb_frz+1,norb_dz-1
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jml) cycle
            iwdl = just(lri,lrj)

            ! td(13-2) a&(23)b&r(23)b^r(32)
            do lrd=lrj+1,norb_dz
              lmd = lsm_inn(lrd)
              if (lmd /= jmr) cycle
              w0td2 = w0_td(2)
              w1td2 = w1_td(2)
              ni = mod(lrj-lri+norb_dz-lrd,2)
              if (ni == 0) w0td2 = -w0td2
              if (ni == 0) w1td2 = -w1td2

              iwdr = jud(lrd)
              vlop0 = w0*w0td2
              vlop1 = w1*w1td2
              list = list4(lri,lrj,lrd,lra)
              wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list)) !1.3
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            end do
            ! td(13-3) a&(23)b&l(32)b^l(23)
            do lrd=lri+1,lrj-1
              lmd = lsm_inn(lrd)
              if (lmd /= jmr) cycle
              iwdr = jud(lrd)
              w0td3 = w0_td(3)
              w1td3 = w1_td(3)
              ni = mod(lrd-lri+norb_dz-lrj,2)
              if (ni == 0) w0td3 = -w0td3
              if (ni == 0) w1td3 = -w1td3
              vlop0 = w0*w0td3                !d6-8
              vlop1 = w1*w1td3
              list = list4(lri,lrd,lrj,lra)
              wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2) !1.2
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            end do
          end do
        end do

      case (15)
        call ttdd_head_dbl_tail_act(lra,lpcoe)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          !*************************************************************
          lr0 = lrd
          lr = kk(jpel)-1
          list = list3(lr0,lr,lr0)
          wl = vlop0*(voint(lr0,lr)+vint_ci(list))       !310+710
          do l=lr0+1,norb_dz
            list = list3(lr0,lr,l)
            nocc = 2
            tcoe = -Half
            wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))  !dbl_
          end do
          do l=norb_dz+1,lr
            list = list3(lr0,lr,l)
            kcoe = lpcoe(l)
            call neoc(kcoe,nocc,tcoe)
            wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))   !act_c
          end do
          wl_430 = Zero
          w0dv2 = w0_dv(2)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv2 = -w0dv2
          do lrk=1,lrd-1
            list = list3(lr0,lr,lrk)
            vlop0 = w0*w0dv2
            wl_430 = wl_430+vlop0*(vint_ci(list)-Two*vint_ci(list+1))
          end do
          wl = wl+wl_430
          !*************************************************************
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (24)
        ! d1v(24-1) ar(13)-
        ! d1v(24-2) drl(33)-bl(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d24-1
          vlop1 = w1*w0dv1
          !*************************************************************
          lr0 = lrd
          lr = kk(jpel)-1
          list = list3(lr0,lr,lr0)
          wl = vlop0*(voint(lr0,lr)+vint_ci(list))       !310+710
          do l=lr0+1,norb_dz
            list = list3(lr0,lr,l)
            nocc = 2
            tcoe = -Half
            wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))  !dbl_
          end do
          do l=norb_dz+1,lr
            list = list3(lr0,lr,l)
            kcoe = lpcoe(l)
            call neoc(kcoe,nocc,tcoe)
            wl = wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))   !act_c
          end do
          wl_430 = Zero
          w0dv2 = w0_d1v(2)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv2 = -w0dv2
          do lrk=1,lrd-1
            list = list3(lr0,lr,lrk)
            vlop0 = w0*w0dv2
            wl_430 = wl_430+vlop0*(vint_ci(list)-Two*vint_ci(list+1))
          end do
          wl = wl+wl_430
          !*************************************************************
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (25)
    ! line=25:-d^r^r<-->sv(10),tv(17),ttv(18)
    select case (lpok)
      case default ! (10)
        call sv_head_dbl_tail_act(lra)

      case (17)
        ! tv(17) ar(23)-br(23)-
        iwdr = 0
        do lri=norb_frz+1,norb_dz
          imi = lsm_inn(lri)
          do lrj=lri,norb_dz
            imj = lsm_inn(lrj)
            imij = Mul(imi,imj)
            if (imij /= jml) cycle
            iwdl = just(lri,lrj)
            vlop1 = w1*w1_tv             !d17 vlop0=0
            list = list3(lri,lrj,lra)
            wl = vlop1*vint_ci(list)        !2.1                  !!!!!
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          end do
        end do

      case (18)
        ! t1v(18) ar(13)-br(13)-
        iwdr = 0
        do lri=norb_frz+1,norb_dz
          imi = lsm_inn(lri)
          do lrj=lri,norb_dz
            imj = lsm_inn(lrj)
            imij = Mul(imi,imj)
            if (imij /= jml) cycle
            iwdl = just(lri,lrj)
            vlop1 = w1*w1_t1v             !d18 vlop0=0
            list = list3(lri,lrj,lra)
            wl = vlop1*vint_ci(list)        !2.1                  !!!!!
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          end do
        end do

      case (1:9,11:16,19:26)
    end select

  case (26)
    ! line=26:-d^r^l<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(19
    select case (lpok)
      case default ! (1)
        call ss_head_dbl_tail_act(lra)

      case (2)
        call st_head_dbl_tail_act(lra)

      case (3)
        call ts_head_dbl_tail_act(lra)

      case (4)
        call stt_head_dbl_tail_act(lra)

      case (5)
        call tts_head_dbl_tail_act(lra)

      case (11)
        call tt_head_dbl_tail_act(lra)

      case (12)
        call tttt_head_dbl_tail_act(lra)

      case (19)
        call dd_head_dbl_tail_act(lra)

      case (20)
        call dddd_head_dbl_tail_act(lra)

      case (21)
        call dd1_head_dbl_tail_act(lra)

      case (22)
        call d1d_head_dbl_tail_act(lra)

      case (25)
        ! vv(25) drl(33)-
        if (jwl == jwr) return
        vlop0 = w0*w0_vv             !d25
        wl = Zero
        iwdl = 0
        iwdr = 0
        do lri=1,norb_dz
          wl = wl+vlop0*voint(lri,lra)
        end do
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)

      case (6:10,13:18,23:24,26)
    end select

  case (27)
    ! line=27:-b^r-a^r<-->sv(10),tv(17),ttv(18)
    select case (lpok)
      case default ! (10)
        call sv_head_dbl_tail_act(lra)

      case (17)
        ! tv(17) ar(23)-br(23)-
        iwdr = 0
        do lri=norb_frz+1,norb_dz
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jml) cycle
            w1tv = w1_tv
            if (mod(lrj-lri,2) == 0) w1tv = -w1tv
            iwdl = just(lri,lrj)
            vlop1 = w1*w1tv             !d17
            list = list4(lri,lrj,lrs,lra)
            wl = vlop1*(vint_ci(list)-vint_ci(list+2)) !1.3 vlop0=0      !!!!!
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          end do
        end do

      case (18)
        ! t1v(18) ar(13)-br(13)-
        iwdr = 0
        do lri=norb_frz+1,norb_dz-1
          lmi = lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj = lsm_inn(lrj)
            lmij = Mul(lmi,lmj)
            if (lmij /= jml) cycle
            w1tv = w1_t1v
            if (mod(lrj-lri,2) == 0) w1tv = -w1tv
            iwdl = just(lri,lrj)
            vlop1 = w1*w1tv             !d17
            list = list4(lri,lrj,lrs,lra)
            wl = vlop1*(vint_ci(list)-vint_ci(list+2)) !1.3 vlop0=0      !!!!!
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          end do
        end do

      case (1:9,11:16,19:26)
    end select

  case (28)
    ! line=28:-b^l-a^r<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(
    select case (lpok)
      case default ! (1)
        call ss_head_dbl_tail_act(lra)

      case (2)
        call st_head_dbl_tail_act(lra)

      case (3)
        call ts_head_dbl_tail_act(lra)

      case (4)
        call stt_head_dbl_tail_act(lra)

      case (5)
        call tts_head_dbl_tail_act(lra)

      case (11)
        call tt_head_dbl_tail_act(lra)

      case (12)
        call tttt_head_dbl_tail_act(lra)

      case (19)
        call dd_head_dbl_tail_act(lra)

      case (20)
        call dddd_head_dbl_tail_act(lra)

      case (21)
        call dd1_head_dbl_tail_act(lra)

      case (22)
        call d1d_head_dbl_tail_act(lra)

      case (25)
        ! vv(25) drl(33)-
        vlop0 = w0*w0_vv             !d25
        wl = Zero
        iwdl = 0
        iwdr = 0
        do lrk=1,norb_dz
          list = list3(lrs,lra,lrk)
          wl = wl+vlop0*(vint_ci(list)-Two*vint_ci(list+1))   !4.3 vlop1=0
        end do
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)

      case (6:10,13:18,23:24,26)
    end select

  case (29)
    ! line=29:-b^r-a^l<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(
    select case (lpok)
      case default ! (1)
        call ss_head_dbl_tail_act(lra)

      case (2)
        call st_head_dbl_tail_act(lra)

      case (3)
        call ts_head_dbl_tail_act(lra)

      case (4)
        call stt_head_dbl_tail_act(lra)

      case (5)
        call tts_head_dbl_tail_act(lra)

      case (11)
        call tt_head_dbl_tail_act(lra)

      case (12)
        call tttt_head_dbl_tail_act(lra)

      case (19)
        call dd_head_dbl_tail_act(lra)

      case (20)
        call dddd_head_dbl_tail_act(lra)

      case (21)
        call dd1_head_dbl_tail_act(lra)

      case (22)
        call d1d_head_dbl_tail_act(lra)

      case (25)
        ! vv(25) drl(33)-
        if (jwl >= jwr) return
        vlop0 = w0*w0_vv             !d25
        wl = Zero
        iwdl = 0
        iwdr = 0
        do lrk=1,norb_dz
          list = list3(lrs,lra,lrk)
          wl = vlop0*vint_ci(list)      !4.2  vlop1=0         !!!!!
        end do
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)

      case (6:10,13:18,23:24,26)
    end select

  case (30)
    ! line=30:-b&r-d^r^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        ! sd(6-3) a&r(13)c'(22)-
        call dbl_sd_act_comp(3,lra)
        ! sd(6-3) tmp for spin=0

      case (8)
        call dbl_sdd_act_comp(3,lra)

      case (13)
        call dbl_td_act_comp(3,lra)

      case (15)
        call dbl_ttdd_act_comp(3,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                   !d23-1
          vlop1 = w1*w0dv1
          list = list3(lrd,lrg,lra)
          wl = (vlop0+vlop1)*vint_ci(list)        !2.1       !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                   !d23-1
          vlop1 = w1*w0dv1
          list = list3(lrd,lrg,lra)
          wl = (vlop0+vlop1)*vint_ci(list)        !2.1
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (31)
    ! line=31:-b&l-d^r^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp(5,lra)

      case (8)
        call dbl_sdd_act_comp(5,lra)

      case (13)
        call dbl_td_act_comp(5,lra)

      case (15)
        call dbl_ttdd_act_comp(5,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          list = list3(lrd,lrg,lra)
          wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*(vint_ci(list)) !2.2          !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          list = list3(lrd,lrg,lra)
          wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*(vint_ci(list)) !2.2          !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (32)
    ! line=32:-b&r-b^r-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp(4,lra)

      case (8)
        call dbl_sdd_act_comp(4,lra)

      case (13)
        call dbl_td_act_comp(4,lra)

      case (15)
        call dbl_ttdd_act_comp(4,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          list = list4(lrd,lrg,lrs,lra)
          wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list)) !1.3        !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do
      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          list = list4(lrd,lrg,lrs,lra)
          wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list)) !1.3        !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (33)
    ! line=33:-b&l-b^r-a^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp(6,lra)

      case (8)
        call dbl_sdd_act_comp(6,lra)

      case (13)
        call dbl_td_act_comp(6,lra)

      case (15)
        call dbl_ttdd_act_comp(6,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          list = list4(lrd,lrg,lrs,lra)
          wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list) !1.1          !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          list = list4(lrd,lrg,lrs,lra)
          wl = vlop0*(vint_ci(list)-Two*vint_ci(list+1))-vlop1*vint_ci(list) !1.1          !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (34)
    ! line=34:-b&l-b^l-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp(7,lra)

      case (8)
        call dbl_sdd_act_comp(7,lra)

      case (13)
        call dbl_td_act_comp(7,lra)

      case (15)
        call dbl_ttdd_act_comp(7,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          list = list4(lrd,lrg,lrs,lra)
          wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2) !1.2      !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          vlop1 = w1*w0dv1
          list = list4(lrd,lrg,lrs,lra)
          wl = vlop0*(vint_ci(list+2)-Two*vint_ci(list+1))-vlop1*vint_ci(list+2) !1.2      !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select

  case (35)
    ! line=35:-d&r^l-a^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
    select case (lpok)
      case default ! (6)
        call dbl_sd_act_comp(2,lra)

      case (8)
        call dbl_sdd_act_comp(2,lra)

      case (13)
        call dbl_td_act_comp(2,lra)

      case (15)
        call dbl_ttdd_act_comp(2,lra)

      case (23)
        ! dv(23-1) ar(23)-
        ! dv(23-2) drl(33)-bl(23)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_dv(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          list = list3(lrd,lra,lrs)
          wl = vlop0*vint_ci(list)          !3.2         !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (24)
        ! d1v(24-1)  ar(13)-
        iwdr = 0
        do lrd=norb_frz+1,norb_dz
          imd = lsm_inn(lrd)
          if (imd /= jml) cycle
          iwdl = jud(lrd)
          w0dv1 = w0_d1v(1)
          ni = mod(norb_dz-lrd,2)
          if (ni == 1) w0dv1 = -w0dv1
          vlop0 = w0*w0dv1                !d23-1
          list = list3(lrd,lra,lrg)
          wl = vlop0*vint_ci(list)          !3.2         !!!!!
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        end do

      case (1:5,7,9:12,14,16:22,25:26)
    end select
end select

return

end subroutine dbl_head_act_tail

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************
!  Cho_X_getVfull
!
!> @brief
!>   Reorder Cholesky vectors from reduced to full storage
!> @author F. Aquilante
!>
!> @details
!> This routine reorders Cholesky vectors from reduced to
!> full storage. For \p DoRead = ``.true.`` the vectors are read from
!> disk using array \p RedVec as scratch space, whereas for
!> \p DoRead = ``.false.`` the reduced vectors must be supplied in
!> array \p RedVec.
!>
!> Given a set of target arrays (\p Wab),
!> the routine reorders \p NUMV Cholesky
!> vectors of compound symmetry \p ISYM starting with
!> vector \p JVEC1 and returns them in the target arrays.
!> Each pointer should thereby point to a
!> location where the corresponding Cholesky
!> vector of a given unique symmetry pair
!> of indices has to be stored.
!>
!> - \p iSwap = ``0``: \f$ L(a,b,J) \f$ is returned (in LT-storage if \f$ \mathrm{sym}(a)=\mathrm{sym}(b) \f$)
!> - \p iSwap = ``1``: \f$ L(a,J,b) \f$ is returned
!> - \p iSwap = ``2``: \f$ L(a,J,b) \f$ is returned (in SQ-storage if \f$ \mathrm{sym}(a)=\mathrm{sym}(b) \f$)
!>
!> - \p iSkip(syma) = ``0``: skip the symmetry block \f$ a \f$. Any vector \f$ L_{ab} \f$ or \f$ L_{ba} \f$
!>                           with \c syma &times; \c symb = \p ISYM won't be returned in the target array
!>
!> - \p IREDC: reduced set in core at the moment of the call to the routine.
!>             Can be set to ``-1`` (= unknown or undefined) by the calling routine.
!>
!> @param[out]    irc     return code
!> @param[in,out] RedVec  vectors stored in reduced set(s) [\p DoRead option off]
!>                        or scratch space for reading reduced vectors [\p DoRead option on]
!> @param[in]     lRedVec size of the \p RedVec
!> @param[in]     IVEC1   first vector to read
!> @param[in]     NUMV    number of vectors to read starting from \p IVEC1
!> @param[in]     ISYM    compound symmetry of the Cholesky vectors
!> @param[in]     iSwap   type of the full storage for the returned Cholesky vectors
!> @param[in,out] IREDC   current reduced set in core (location ``3``)
!> @param[in,out] Wab     target arrays
!> @param[in]     iSkip   skipping parameters for each symmetry block \f$ (ab) \f$ of compound symmetry \p ISYM
!> @param[in]     DoRead  flag for reading reduced vectors from disk
!***********************************************************************

subroutine Cho_X_getVfull(irc,RedVec,lRedVec,IVEC1,NUMV,ISYM,iSwap,IREDC,Wab,iSkip,DoRead)

use Symmetry_Info, only: Mul
use Cholesky, only: nBas, nSym
use Data_structures, only: SBA_Type
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: lRedVec, IVEC1, NUMV, ISYM, iSwap, iSkip(*)
real(kind=wp), intent(inout) :: RedVec(lRedVec)
integer(kind=iwp), intent(inout) :: IREDC
type(SBA_Type), intent(inout) :: Wab
logical(kind=iwp), intent(in) :: DoRead
integer(kind=iwp) :: i, ipChoV(8), ipVec(8), iSymp, iSymq, IVEC2, j, JNUM, JVEC1, jVref, MUSED, MXUSD, n2BSF(8,8), nnBSF(8,8)

MXUSD = 0
MUSED = 0

ipChoV(1:nSym) = Wab%ipOff(1:nSym)

ipVec(1:nSym) = ipChoV(1:nSym)

call set_nnBSF(nSym,nBas,nnBSF,n2BSF)

if (iSwap == 0) then

  do iSymq=1,nSym
    iSymp = mul(iSym,iSymq)
    if ((nnBSF(iSymp,iSymq) > 0) .and. ((iSymp >= iSymq) .and. (iSkip(iSymp) /= 0))) Wab%SB(iSymp)%A2(:,:) = Zero
  end do

else if ((iSwap == 1) .or. (iSwap == 2)) then

  do iSymq=1,nSym
    iSymp = mul(iSym,iSymq)
    if ((n2BSF(iSymp,iSymq) > 0) .and. ((iSymp >= iSymq) .and. (iSkip(iSymp) /= 0))) Wab%SB(iSymp)%A2(:,:) = Zero
  end do

else

  write(u6,*) 'Wrong parameter! iSwap= ',iSwap
  irc = 66
  return

end if

if (DoRead) then

  JVEC1 = IVEC1
  IVEC2 = JVEC1+NUMV-1

  do while (jVec1 <= iVec2)
    call CHO_VECRD(RedVec,lRedVec,JVEC1,IVEC2,ISYM,JNUM,IREDC,MUSED)
    MXUSD = max(MXUSD,MUSED)

    if ((JNUM <= 0) .or. (JNUM > IVEC2-JVEC1+1)) then
      irc = 77
      return
    end if

    jVref = JVEC1-IVEC1+1
    call cho_Reordr(irc,RedVec,lRedVec,jVref,JVEC1,JNUM,NUMV,ISYM,IREDC,iSwap,ipVec,Wab%A0,iSkip)

    if (irc /= 0) return

    jVec1 = jVec1+JNUM

    do i=1,nSym
      j = mul(i,ISYM)
      if ((j >= i) .and. (iSkip(j) /= 0)) then
        if (iSwap == 0) then
          ipVec(j) = ipVec(j)+nnBSF(j,i)*JNUM
        else if (iSwap == 1) then
          ipVec(j) = ipChoV(j)
        else if (iSwap == 2) then
          ipVec(j) = ipVec(j)+n2BSF(j,i)*JNUM
        end if
      end if
    end do

  end do  ! end the while loop

else ! only reorder

  JNUM = NUMV

  call cho_Reordr(irc,RedVec,lRedVec,1,IVEC1,JNUM,NUMV,ISYM,IREDC,iSwap,ipVec,Wab%A0,iSkip)

  if (irc /= 0) return

end if

irc = 0

return

end subroutine Cho_X_getVfull

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************
SUBROUTINE pgek()
use kriging_mod, only: x, y, nPoints, nInter
Implicit None
#include "real.fh"
#include "stdalloc.fh"
Real*8, Allocatable:: Mean_univariate(:), Mean_bivariate(:)
Real*8, Allocatable:: Variance_univariate(:), Variance_bivariate(:)
Integer i, j,  l
Real*8 tmp, dx, dy
! Mutual information array
!Real*8 MI(nInter)
Real*8, Allocatable::  MI(:)
! universal kernal density estimators.
!Real*8 px(nPoints,nInter)
!Real*8 py(nPoints)
!Real*8 pxy(nPoints,nInter)
Real*8, Allocatable:: px(:,:), py(:), pxy(:,:)
! the 2 x 2 covariance matrix (used to compute the transformation variable in the bivariate case)
Real*8 Sigma(2,2), Sigma_Inverse(2,2)
Real*8 d, d_h, h, u_j, K_u_j, Norm_Sigma

Write (6,*) 'PGEK: nPoints=',nPoints
Write (6,*) 'PGEK: nInter=',nInter
Call RecPrt('y',' ',y,1,nPoints)
Call RecPrt('x',' ',x,nInter,nPoints)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!    Allocate memory

Call mma_allocate(Mean_univariate,nInter+1,Label='Mean_univariate')
Call mma_allocate(Mean_bivariate,nInter,Label='Mean_bivariate')
Call mma_allocate(Variance_univariate,nInter+1,Label='Variance_univariate')
Call mma_allocate(Variance_bivariate,nInter,Label='Variance_bivariate')
Call mma_allocate(MI,nInter,Label='MI')
Call mma_allocate(px,nPoints,nInter,Label='px')
Call mma_allocate(py,nPoints,Label='py')
Call mma_allocate(pxy,nPoints,nInter,Label='pxy')

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!  Compute the mean for all variables - coordinate components and the energy
!  univariate --  x and y -- and bivariate -- xy
!  Compute the variance of the same

Do i = 1, nInter
  Mean_Univariate(i)    =Zero
  Mean_bivariate(i)     =Zero
  Variance_Univariate(i)=Zero
  Variance_bivariate(i) =Zero
  Do j = 1, nPoints
    Mean_Univariate(i)    =Mean_Univariate(i)    + x(i,j)
    Mean_bivariate(i)     =Mean_bivariate(i)     + x(i,j)*y(j)
    Variance_Univariate(i)=Variance_Univariate(i)+ (x(i,j))**2
    Variance_bivariate(i) =Variance_bivariate(i) + (x(i,j)*y(j))**2
  End Do
End Do
Mean_Univariate(nInter+1)    =Zero
Variance_Univariate(nInter+1)=Zero
Do j = 1, nPoints
  Mean_Univariate(nInter+1)    =Mean_Univariate(nInter+1)     + y(j)
  Variance_Univariate(nInter+1)=Variance_Univariate(nInter+1) + y(j)**2
End Do
Mean_Univariate(:)    = Mean_Univariate(:)    /DBLE(nPoints)
Mean_Bivariate(:)     = Mean_Bivariate(:)     /DBLE(nPoints)
Variance_Univariate(:)= Variance_Univariate(:)/DBLE(nPoints)
Variance_Bivariate(:) = Variance_Bivariate(:) /DBLE(nPoints)

Call RecPrt('Mean - x ',' ',Mean_Univariate(:),nInter,1)
Call RecPrt('Mean - xy ',' ',Mean_Bivariate(:),nInter,1)
Call RecPrt('Variance - x ',' ',Variance_Univariate(:),nInter,1)
Call RecPrt('Variance - xy ',' ',Variance_Bivariate(:),nInter,1)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Compute the Gaussian bandwidth

d_h = Two
h = (Four/(d_h + Two))**(One/(Four+d_h)) * DBLE(nPoints)**(-One/(Four+d_h))
Write (6,*) 'd_h=',d_h
Write (6,*) 'h=',h

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Compute the universal kernel density estimators px, py, and pxy
! also known as Parzen window

! 1) the univariate cases

d=One
Write (6,*) 'd=',d


!  a) Compute px(i,l)

Do l = 1, nInter
   Do i = 1, nPoints

      Norm_Sigma=Abs(Variance_Univariate(l))
      tmp=Zero
      Do j = 1, nPoints
         u_j = (x(l,i)-x(l,j))**2 / (h**2 * Variance_univariate(l))
         K_u_j = One/((Two*Pi)**(d/Two) * h**d * sqrt(Norm_Sigma)) * Exp(-u_j/Two)
         tmp=tmp+K_u_j
      End Do

      px(i,l)=tmp/DBLE(nPoints)

   End Do
End Do
Call RecPrt('px',' ',px,nPoints,nInter)

!  b) Compute py(i)

Do i = 1, nPoints

   Norm_Sigma=Abs(Variance_Univariate(l))
   tmp=Zero
   Do j = 1, nPoints
      u_j = (y(i)-y(j))**2 / (h**2 * Variance_univariate(l))
      K_u_j = One/((Two*Pi)**(d/Two) * h**d * sqrt(Norm_Sigma)) * Exp(-u_j/Two)
      tmp=tmp+K_u_j
   End Do

   py(i)=tmp/DBLE(nPoints)

End Do
Call RecPrt('py',' ',py,nPoints,1)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! 2) the bivariate case, pxy(i,l)

d=Two
Write (6,*) 'd=',d

Do l = 1, nInter
   Do i = 1, nPoints

!     Assemble the 2 x 2 covariance matrix
      Sigma(1,1)=Variance_univariate(l)  ! p(x_l^2)
      Sigma(1,2)=Variance_bivariate(l)   ! p(x_ly)
      Sigma(2,1)=Sigma(1,2)
      Sigma(2,2)=Variance_univariate(nInter+1) ! p(y^2)
      Call RecPrt('Sigma',' ',Sigma,2,2)
      Norm_Sigma=Sigma(1,1)*Sigma(2,2)-Sigma(1,2)*Sigma(2,1)  ! The determinant of the 2 x 2 sigma matrix
      Write (6,*) 'Norm_Sigma=',Norm_Sigma
      Sigma_Inverse(1,1)= Sigma(2,2)/Norm_Sigma
      Sigma_Inverse(1,2)=-Sigma(1,2)/Norm_Sigma
      Sigma_Inverse(2,1)=-Sigma(2,1)/Norm_Sigma
      Sigma_Inverse(2,2)=-Sigma(1,1)/Norm_Sigma
      Call RecPrt('Sigma_Inverse',' ',Sigma_Inverse,2,2)

      tmp=Zero
      Do j = 1, nPoints
         dx = x(l,i)-x(l,j)
         dy = y(i)-y(j)
         u_j = ( dx*dx * Sigma_Inverse(1,1)   &
                +dx*dy * Sigma_Inverse(1,2)   &
                +dy*dx * Sigma_Inverse(2,1)   &
                +dy*dy * Sigma_Inverse(2,2) ) &
               / h**2
         Write (6,*)' u_j=',u_j
         K_u_j = One/((Two*Pi)**(d/Two) * h**d * sqrt(Abs(Norm_Sigma))) * Exp(-u_j/Two)
         Write (6,*)' K_u_j=',K_u_j
         tmp=tmp+K_u_j
      End Do

      pxy(i,l)=tmp/DBLE(nPoints)

   End Do
End Do

Call RecPrt('pxy',' ',pxy,nPoints,nInter)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Assemble the Mutual Information, MI(l), for each variable l

Do l = 1, nInter
   tmp=0.0D0
   Do i = 1, nPoints
      tmp = tmp + pxy(i,l) * log10(pxy(i,l)/(px(i,l)*py(i)))
   End Do
   MI(l)=tmp
End Do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

Write (*,*) 'Mutual Information'
Write (*,*) '=================='
Do i = 1, nInter
   Write (6,'(i4,E10.2)') i, MI(i)
End Do
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     Deallocate memory

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

Call mma_deallocate(MI)
Call mma_deallocate(px)
Call mma_deallocate(py)
Call mma_deallocate(pxy)
Call mma_deallocate(Variance_univariate)
Call mma_deallocate(Variance_bivariate)
Call mma_deallocate(Mean_bivariate)
Call mma_deallocate(Mean_univariate)

END SUBROUTINE pgek

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3sglh131 (w,dima,dimb,dimbc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma=symb > symc
c
c     W(a,bc) <-  + S1 _i(a) . D1 _jk(bc)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b) index (I)
c     dimab   - dimension of ab index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimbc,ns
       real*8 w(1:dima,1:dimbc)
       real*8 s1(1:dima)
       real*8 d1(1:dimbc)
c
c     help variables
c
       integer a,bc
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 100 bc=1,dimbc
       s=d1(bc)
       do 101 a=1,dima
       w(a,bc)=w(a,bc)+s1(a)*s
 101    continue
 100    continue
c
       else
c     phase -1
c
       do 200 bc=1,dimbc
       s=d1(bc)
       do 201 a=1,dima
       w(a,bc)=w(a,bc)-s1(a)*s
 201    continue
 200    continue
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dimb)
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8


      SUBROUTINE RandomGauss(ValMean,Sigma,iseed,nflag,buffer,Val)
      IMPLICIT REAL*8 (a-h,o-z)

C       ValMean is the mean, and sigma is the standard deviation.
C       nFlag is a binary (0,1) variable for returning the appropiate random value

C When x and y are two variables from [0, 1), uniformly
C distributed, then
C
C    cos(2*pi*x)*sqrt(-2*log(1-y))
C    sin(2*pi*x)*sqrt(-2*log(1-y))
C
C are two *independent* variables with normal distribution
C (mu = 0, sigma = 1).
C (Lambert Meertens)
C (corrected version; bug discovered by Mike Miller, fixed by LM)
      IF (nFlag.eq.0) THEN

          alpha = abs(Random_Molcas(iseed))
          beta  = abs(Random_Molcas(iseed))

          PI=4.D0*ATAN(1.D0)
          X2pi = alpha * (2.d0*Pi)
          G2rad = sqrt(-2.d0 * log(1.d0 - beta ))

          Z1 = cos(X2pi) * G2rad
          Z2 = sin(X2pi) * G2rad
          Val = ValMean + Z1*Sigma
          buffer = ValMean + Z2*Sigma
          nFlag = 1
      ELSE
         Val = buffer
         nFlag = 0


      END IF
c      write (6,*) 'PI:' , PI
c      write (6,*) 'X2pi:', X2pi
c      write (6,*) 'G2grad: ', G2rad
c      write (6,*) 'buffer:', buffer
c      write (6,*) 'Z1 and Z2', Z1, Z2
c      write (6,*) 'Alpha & Beta', alpha, beta
c      write (6,*) 'VAL into RANDOM:', val
      RETURN

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DeDe_Mck(FD,nFD,ipOffD,nOffD,DDen,lDDen,mDeDe,mIndij)
      use k2_arrays, only: MaxDe
      Real*8 FD(nFD), DDen(lDDen)
      Integer ipOffD(nOffD)
      Logical Special_NoSym, DFT_Storage
*
      Special_NoSym=.False.
      DFT_Storage=.False.
      nr_of_Densities=1
*
      ipDeDe=1
      ipD00=1
!     ipDijS is controlled in the calling routine
      Call mk_DeDe(FD,nFD,nr_of_Densities,ipOffD,nOffD,ipDeDe,ipD00,
     &             MaxDe,mDeDe,mIndij,Special_NoSym,DFT_Storage,
     &             DDen,lDDen)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine embPotRdRun()

use Embedding_Global, only: embOutDensPath, embOutEspPath, embOutGradPath, embOutHessPath, embPotInBasis, embPotPath, &
                            embWriteDens, embWriteEsp, embWriteGrad, embWriteHess, outGridPath, outGridPathGiven
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ioUnit
integer(kind=iwp), external :: isFreeUnit

! Open the file
ioUnit = isFreeUnit(1)
call molcas_open(ioUnit,'EMBPOT_RUNFILE')

read(ioUnit,'(l1)') embPotInBasis
read(ioUnit,'(a256)') embPotPath
read(ioUnit,'(l1)') outGridPathGiven
read(ioUnit,'(a256)') outGridPath
read(ioUnit,'(l1)') embWriteDens
read(ioUnit,'(a256)') embOutDensPath
read(ioUnit,'(l1)') embWriteEsp
read(ioUnit,'(a256)') embOutEspPath
read(ioUnit,'(l1)') embWriteGrad
read(ioUnit,'(a256)') embOutGradPath
read(ioUnit,'(l1)') embWriteHess
read(ioUnit,'(a256)') embOutHessPath

close(ioUnit)

return

end subroutine embPotRdRun

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module motra_global

use Definitions, only: wp, iwp

implicit none
private

#include "mxdm.fh"

!----------------------------------------------------------------------*
! Allocate space to store the system description                       *
!----------------------------------------------------------------------*
integer(kind=iwp) :: nBas(mxSym), nDel(mxSym), nFro(mxSym), nOrb(mxSym), nSym
real(kind=wp) :: PotNuc
character(len=LenIn8), allocatable :: BsLbl(:)

!----------------------------------------------------------------------*
! Allocate space to store the MO-coefficients and occupations          *
!----------------------------------------------------------------------*
real(kind=wp), allocatable :: CMO(:), HOne(:), Kine(:), Occ(:), Ovlp(:)
! Occ is never allocated?

!----------------------------------------------------------------------*
! Allocate space to store the one-electron inntegral file header and   *
! the header of the input source of MO coefficients                    *
!----------------------------------------------------------------------*
character(len=80) :: VecTit
character(len=144) :: Header

!----------------------------------------------------------------------*
! Allocate space to store the title                                    *
!----------------------------------------------------------------------*
integer(kind=iwp) :: nTit
character(len=72) :: Title(mxTit)

!----------------------------------------------------------------------*
! Allocate space to store logical switches for routing and printing    *
!----------------------------------------------------------------------*
integer(kind=iwp) :: Debug, iAutoCut, ihdf5, iOneOnly, iPrint, iRFpert, iVecTyp

!----------------------------------------------------------------------*
! Save cutting threshold for AUTO cut option                           *
!----------------------------------------------------------------------*
real(kind=wp) :: CutThrs(mxSym)

!----------------------------------------------------------------------*
! Store file names and unit numbers.                                   *
!----------------------------------------------------------------------*
! InpOrb, JobIph: Input files for MO coefficients
! TwoAO:          two-electron integrals in AO basis
! OneMO, TwoMO:   one- and two-electron integrals in MO basis
! Half:           half transformed two-electron integrals
integer(kind=iwp) :: LuHalf, LuInpOrb, LuJobIph, LuOneMO, LuTwoAO, LuTwoMO
character(len=8) :: FnHalf, FnOneMO, FnTwoAO, FnTwoMO
character(len=180) :: FnInpOrb, FnJobIph

integer(kind=iwp) :: iCTonly, iDoInt
integer(kind=iwp) :: nTot1, nTot2, n2max, nOrbt, nOrbtt, ISP, ISQ, ISR, ISS, NBP, NBQ, NBR, NBS, NOP, NOQ, NOR, NOS, LMOP, LMOQ, &
                     LMOR, LMOS, NBPQ, NBRS, NOVX, LTUVX, IAD13

public :: BsLbl, CMO, CutThrs, Debug, FnHalf, FnInpOrb, FnJobIph, FnOneMO, FnTwoAO, FnTwoMO, Header, HOne, IAD13, iAutoCut, &
          iCTonly, iDoInt, ihdf5, iOneOnly, iPrint, iRFpert, ISP, ISQ, ISR, ISS, iVecTyp, LMOP, Kine, LMOQ, LMOR, LMOS, LTUVX, &
          LuHalf, LuInpOrb, LuJobIph, LuOneMO, LuTwoAO, LuTwoMO, N2MAX, nBas, NBP, NBPQ, NBQ, NBR, NBRS, NBS, nDel, nFro, NOP, &
          NOQ, NOR, nOrb, nOrbt, nOrbtt, NOS, NOVX, nSym, nTit, nTot1, nTot2, Occ, Ovlp, PotNuc, Title, VecTit

end module motra_global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExV_X42(Vp,V,dimab,no)
! this routine does:
! Vp(a,b,i) <- V(a,b,i,i)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimab, no
real(kind=wp), intent(out) :: Vp(dimab,no)
real(kind=wp), intent(in) :: V(dimab,no,no)
integer(kind=iwp) :: i

do i=1,no
  Vp(:,i) = V(:,i,i)
end do

return

end subroutine ExV_X42

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ECP_shells(iAtmNr,List)
#include "itmax.fh"
      Integer List(0:iTabMx)
*                                                                      *
************************************************************************
*                                                                      *
      Call ICopy(iTabMx+1,[0],0,List,1)
*                                                                      *
************************************************************************
*                                                                      *
* Dummy
      If (iAtmNr.eq.0) Then
         list(0)=0
         list(1)=0
         list(2)=0
         list(3)=0
* H-He
      Else If((iAtmNr.gt.2) .and. (iAtmNr.le.4)) Then
         list(0)=1
         list(1)=0
         list(2)=0
         list(3)=0
      Else If(iAtmNr.le.10) Then
         list(0)=1
         list(1)=1
         list(2)=0
         list(3)=0
      Else If(iAtmNr.le.12) Then
         list(0)=1
         list(1)=0
         list(2)=0
         list(3)=0
      Else If(iAtmNr.le.18) Then
         list(0)=1
         list(1)=1
         list(2)=0
         list(3)=0
      Else If(iAtmNr.le.20) Then
         list(0)=1
         list(1)=0
         list(2)=0
         list(3)=0
      Else If(iAtmNr.le.30) Then
         list(0)=1
         list(1)=0
         list(2)=1
         list(3)=0
      Else If(iAtmNr.le.36) Then
         list(0)=1
         list(1)=1
         list(2)=1
         list(3)=0
      Else If(iAtmNr.le.38) Then
         list(0)=1
         list(1)=0
         list(2)=0
         list(3)=0
      Else If(iAtmNr.le.48) Then
         list(0)=1
         list(1)=0
         list(2)=1
         list(3)=0
      Else If(iAtmNr.le.54) Then
         list(0)=1
         list(1)=1
         list(2)=1
         list(3)=0
      Else If(iAtmNr.le.56) Then
         list(0)=1
         list(1)=0
         list(2)=0
         list(3)=0
      Else If(iAtmNr.le.70) Then
         list(0)=1
         list(1)=0
         list(2)=0
         list(3)=1
      Else If(iAtmNr.le.80) Then
         list(0)=1
         list(1)=0
         list(2)=1
         list(3)=1
      Else If(iAtmNr.le.86) Then
         list(0)=1
         list(1)=1
         list(2)=1
         list(3)=1
      Else If(iAtmNr.le.88) Then
         list(0)=1
         list(1)=0
         list(2)=0
         list(3)=0
      Else If(iAtmNr.le.102) Then
         list(0)=1
         list(1)=0
         list(2)=0
         list(3)=1
      Else If(iAtmNr.le.112) Then
         list(0)=1
         list(1)=0
         list(2)=1
         list(3)=1
      Else If(iAtmNr.le.118) Then
         list(0)=1
         list(1)=1
         list(2)=1
         list(3)=1
      Else If(iAtmNr.le.120) Then
         list(0)=1
         list(1)=0
         list(2)=0
         list(3)=0
      Else
          Write (6,*) 'ECP_shells can not handle atom numbers beyond'
     &               //' 112.'
          Call Abend()
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2006,2007, Markus Reiher                          *
*               2004,2006, Alexander Wolf                              *
************************************************************************
c
      subroutine dkhparser_driver (nbas,isize,dkhscfflg,dkhorder,xorder,
     *                             s,t,v,pvp,x,pxp,clight,paramtype,
     *                             dkhmemmax,mem,no_hamil,no_prop,nbasp,
     *                             nbaso,LDKroll,indx2,nAtom,maxsiz,
     *                             nblock,LDKpert)
c
c*************************************************************************************************
c
c                  Implementation of the scalar-relativistic
c
c                       I N F I N I T E - O R D E R
c
c      G E N E R A L I Z E D   D O U G L A S - K R O L L - H E S S  (DKH)
c
c                         T R A N S F O R M A T I O N
c
c                                    F O R
c
c             H A M I L T O N I A N   A N D   P R O P E R T Y
c
c                 2006 Markus Reiher and Alexander Wolf, ETH Zurich
c                      Infinite-order DKH
c                      {markus.reiher,alexander.wolf}@phys.chem.ethz.ch
c
c
c   Reference to the arbitrary/infinite-order DKH method:
c
c     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 2037-2047   part I   [Theory]
c     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 10945-10956 part II  [Algorithm]
c     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064102      part III (Properties-Theory)
c     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064103      part IV  (Properties-Implementation)
c
c   Reference to the generalized DKH method:
c
c     A. Wolf, M. Reiher, B.A. Hess, J. Chem. Phys. 117 (2002) 9215-9226
c
c--------------------------------------------------------------------------------------------------
c
c   This SR is the memory manager for the numeric part of DKHPACK,
c     i.e., the infinite-order DKH package.
c     (you may replace this routine by C or F90 memory allocation)
c
c   This is the first routine to be called by dkhparser2.
c
c   Input:
c
c       nbas        No. of basisfcts.
c       isize       nbas*(nbas+1)/2
c       clight      velocity of light (137.035989500D0)
c                     (if this is zero, it is set here)
c       t(isize)    non-relativistic kinetic energy: p**2/2
c       v(isize)    external electron-nucleus potential
c       pvp(isize)  matrix representation of <pxVpx>+<pyVpy>+<pzVpz>
c                     in the given original basis set
c       s(isize)    overlap matrix
c       x(isize)    property matrix X
c       pxp(isize)  matrix representation of <pxXpx>+<pyXpy>+<pzXpz>
c                     in the given original basis set
c
c       no_hamil    flag to switch of the one-electron Hamiltonian transformation
c       no_prop     flag to switch of the one-electron property transformation
c       nbasp       one dimension of matrices for property trafo (=nbas, if props
c                     are to be calculated, =1 if no_prop)
c       nbaso       one dimension of matrices for Hamiltonian trafo (=nbas, if suff.
c                     RAM available, =1 if matrices are stored to disk)
c       LDKroll      flag for the Local DKH procedure
c
c   Output:
c
c       t(isize)    DKH Hamiltonian (pos.space) up to dkhorder
c       x(isize)    DKH transformed property X (pos.space) up to xorder
c
c
c   This SR belongs to dkhparser_numeric (dkhparser2)
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.2.0
c
c   last modified: 26.02.2007  M. Reiher (ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************************************
c
      implicit none
#include "dkhparameters.fh"
#include "WrkSpc.fh"
      Integer DKHMemMax
c
      logical dkhscfflg,no_hamil,no_prop,LDKroll
      integer nbas,isize,dkhorder,xorder,nbasp,nbaso
c
      REAL*8 s(isize),t(isize),v(isize),pvp(isize),x(isize),
     *                 pxp(isize),clight
c
      integer nexts,snumber,tnumber,unumber,scrno1,scrno2,
     *        nbassq,i,nbassqp,nbassqo
      parameter (scrno1=3)
c
c  Note: scrno1 must be 4.
c        scrno2 must be 5 for hamil and prop or 3 for hamil-only.
c          hence, scrno2 is set below
c
      integer iv,in,id,iy,if,ig,ix,ii,ij,ik,il,im,irevt,itran,
     *        isinv,iaa,irr,itt,ipp,ie,iew,iscr1,iscr2,iscr3,
     *        iscr5,iscr8,iscrt,iscrsq,nAtom,maxsiz,nblock,
     *        ihsm,ieigsm,issm,indx2(nAtom),iewsm,exnbas
      Logical LDKpert
c
c  Allocate super vector 'mem'
      REAL*8 mem(dkhmemmax)
c
c
      character*(3) paramtype
      character*(maxlength) scrtxt
c
c
c------------------------------------------------------------------------------
c
c          Meaning of parameters, array sizes, and arrays:
c
c   dkhmemax   :  length of global memory array (set in dkhparameters.h)
c   maxorder :  max. DKH order 'parser2' can deal with (set in dkhparameters.h)
c
c   eigunit  :  unit for output of 1s-eigenvalues for Z=1,..,137
c                 ('eigenvalues.dat')
c   outunit1 :  unit for output of final even DKH operators stored as lower
c                 triangular matrices  ('dkhops.21')
c   outunit2 :  unit for output of final even property operators X_i
c                 (pos-space) stored as lower triangular matrices ('dkhops.22')
c  dkhunit1  :  unit for final DKH operators ('dkhops.11')
c  dkhunit2  :  unit for final property operators X ('dkhops.12')
c  dkhunit3  :  unit for auxiliary matrices Sxxx ('dkhops.13')
c  dkhunit4  :  unit for auxiliary matrices Txxx ('dkhops.14')
c  dkhunit5  :  unit for auxiliary matrices Uxxx ('dkhops.15')
c
c   snumber  :  no. of Sxxx matrices
c   tnumber  :  no. of Txxx matrices
c   unumber  :  no. of Uxxx matrices
c   scrno1   :  no. of temp. rectangular scratch matrices
c   scrno2   :  no. of temp. triangular scratch matrices
c
c   scr1(1,1,snumber) :  Sxxx matrices               (rectangular)
c   scr2(1,1,tnumber) :  Txxx matrices               (rectangular)
c   scr3(1,1,unumber) :  Uxxx matrices               (rectangular)
c   scr5(1,1,scrno1)  :  temp. scratch matrices      (rectangular)
c   scr8(1,scrno2)    :  temp. scratch matrices of
c                          length 'isize'            (triangular)
c
c
c
      if (no_prop) then
        scrno2=3
      else
        scrno2=5
      end if
c
c-----------------------------------------------------------
c  1. Read in number of auxiliary matrices Sxxx, Txxx, Uxxx,
c       and check clight, dkhorder, xorder
c-----------------------------------------------------------
c
c  Initialize scrtxt, clight
      do 10 i=1,maxlength
        scrtxt(i:i)=' '
  10  continue
      if (clight.eq.0.0d0) clight=137.035989500d0
c
c  Read in number 'snumber' of required scratch Sxxx-matrices, (i.e., the number
c    of employed Sxxx-matrices of symbolic PARSER procedure 'dkhparser1') and
c    the chosen unitary parametrization 'paramtype'
#ifndef MOLPRO
#ifdef _MOLCAS_
      Call Molcas_Open(dkhunit3,'dkhops.13')
#else
      open (dkhunit3, file='dkhops.13', status='OLD',
     *      form='FORMATTED')
#endif
#endif
      rewind(dkhunit3)
      read (dkhunit3,'(A50)') scrtxt(1:50)
      read (dkhunit3,'(A50)') scrtxt(1:50)
c  Check dkhorder and determine paramtype
      call ordertest (dkhorder,paramtype,scrtxt,1)
      read (dkhunit3,'(A50)') scrtxt(1:50)
c  Check xorder
      call ordertest (xorder,paramtype,scrtxt,0)
      read (dkhunit3,'(A50)') scrtxt(1:50)
      if (scrtxt(15:15).eq.'F' .and. dkhscfflg) then
        write (stdout,1040) dkhscfflg
1040    format (/2X,'ERROR in SR "dkhparser_driver": dkhscfflg = ',L1,
     *          ' does not correspond to the settings of "dkhops.13"',
     *          //2X,'STOP.',/2X)
        Call Abend()
      endif
      if (scrtxt(15:15).eq.'T' .and. .not.dkhscfflg) then
        write (stdout,1041) dkhscfflg
1041    format (/2X,'ERROR in SR "dkhparser_driver": dkhscfflg = ',L1,
     *          ' does not correspond to the settings of "dkhops.13"',
     *          //2X,'STOP.',/2X)
        call Abend
      endif
1050  read (dkhunit3,'(A3)') scrtxt(1:3)
      if (scrtxt(1:3).ne.'+++') goto 1050
      read (dkhunit3,'(I3)') snumber
#ifndef MOLPRO
      close (dkhunit3)
#endif
c
c  Read in number 'tnumber' of required scratch Txxx-matrices, (i.e., the number
c    of employed Txxx-matrices of symbolic PARSER procedure 'dkhparser1')
#ifndef MOLPRO
#ifdef _MOLCAS_
      Call Molcas_Open(dkhunit4,'dkhops.14')
#else
      open (dkhunit4, file='dkhops.14', status='OLD',
     *      form='FORMATTED')
#endif
#endif
      rewind(dkhunit4)
1051  read (dkhunit4,'(A3)') scrtxt(1:3)
      if (scrtxt(1:3).ne.'+++') goto 1051
      read (dkhunit4,'(I3)') tnumber
#ifndef MOLPRO
      close (dkhunit4)
#endif
c
c  Read in number 'unumber' of required scratch Uxxx-matrices, (i.e., the number
c    of employed Uxxx-matrices of symbolic PARSER procedure 'dkhparser1')
#ifndef MOLPRO
#ifdef _MOLCAS_
      Call Molcas_Open(dkhunit5,'dkhops.15')
#else
      open (dkhunit5, file='dkhops.15', status='OLD',
     *      form='FORMATTED')
#endif
#endif
      rewind(dkhunit5)
1052  read (dkhunit5,'(A3)') scrtxt(1:3)
      if (scrtxt(1:3).ne.'+++') goto 1052
      read (dkhunit5,'(I3)') unumber
#ifndef MOLPRO
      close (dkhunit5)
#endif
      If (LDKroll.and.(.not.LDKpert)) Then
        exnbas=nbas
        nbas=maxsiz
        if (nbaso.eq.exnbas) nbaso=maxsiz
        if (nbasp.eq.exnbas) nbasp=maxsiz
      End If
c
c
c-----------------------------------
c  2. Allocate memory vector mem
c-----------------------------------
c
      nbassq=nbas*nbas
      nbassqp=nbasp*nbasp
      nbassqo=nbaso*nbaso
      nexts=1
c
c  Note: Full square matrices are (consequently) used throughout, though it
c        should be possible to use symmetry, i.e., lower triangular matrices
c        only.
c        --> This is left to future work!
c
c  Allocate basic matrices (V,N,D,Y,F,G,Z,Q,X,I,J,K,L,M) first
      iv=nexts
      in=iv+nbassqo
      id=in+nbassqo
      iy=id+nbassqo
      if=iy+nbassqo
      ig=if+nbassqo
      ix=ig+nbassqo
      ii=ix+nbassqp
      ij=ii+nbassqp
      ik=ij+nbassqp
      il=ik+nbassqp
      im=il+nbassqp
      nexts=im+nbassqp
c
c  Allocate transformation matrices
      irevt=nexts
      itran=irevt+nbassq
      If (LDKroll.and.(.not.LDKpert)) Then
         isinv=itran+exnbas*maxsiz
         ieigsm=isinv+maxsiz*maxsiz
         ihsm=ieigsm+maxsiz*maxsiz
         issm=ihsm+maxsiz*(maxsiz+1)/2
         nexts=issm+maxsiz*maxsiz
      Else
         ieigsm=ip_Dummy
         ihsm=ip_Dummy
         issm=ip_Dummy
         isinv=itran+nbassq
         nexts=isinv+nbassq
      End If
c
c  Allocate kinematical factors
      iaa=nexts
      irr=iaa+nbas
      itt=irr+nbas
      If (LDKroll.and.(.not.LDKpert)) Then
        iewsm=itt+maxsiz
        ipp=iewsm+maxsiz
      Else
        iewsm=ip_Dummy
        ipp=itt+nbas
      End If
      ie=ipp+nbas
      iew=ie+nbas
      If (LDKroll.and.(.not.LDKpert)) Then
         nexts=iew+exnbas
      Else
         nexts=iew+nbas
      End If
c
c  Allocate (permanent) auxiliary matrices: Sxxx,  Txxx,  Uxxx
c                                           (scr1) (scr2) (scr3)
      iscr1=nexts
      iscr2=iscr1+nbassqo*snumber
      iscr3=iscr2+nbassqo*tnumber
      nexts=iscr3+nbassqo*unumber
c
c  Allocate rectangular (scr5), triangular (scr8)
c    scratch structures
      iscr5=nexts
      If (LDKroll.and.(.not.LDKpert)) Then
         iscr8=iscr5+maxsiz*exnbas*2
         iscrt=iscr8+isize*3
         iscrsq=iscrt+scrno2*maxsiz*(maxsiz+1)/2
         nexts=iscrsq+maxsiz*maxsiz*scrno1
      Else
         iscrt=ip_Dummy
         iscrsq=ip_Dummy
         iscr8=iscr5+nbassq*scrno1
         nexts=iscr8+isize*scrno2
      End If
c
c  Check memory
      if (nexts-1.ne.dkhmemmax) then
        write (stdout,1070) dkhmemmax,nexts
1070    format (2X,'SR dkhparser_driver: There is not enough memory ',
     *          'for DKH!',//2X,'Now:      dkhmemmax = ',I9,/2X,
     *          'Required: dkhmemmax = ',I9,//2X,'Increase parameter ',
     *          'dkhmemmax in "dkhparameters.h".',//2X,'STOP.',/)
        call Abend
      endif
c
c
c-------------------------------------------------------
c  3. Call dkh_main, where DKH Hamiltonian is evaluated
c-------------------------------------------------------
c
      If (LDKroll.and.(.not.LDKpert)) Then
         Call ldkh (s,t,v,pvp,x,pxp,dkhorder,xorder,paramtype,dkhscfflg,
     *           exnbas,isize,clight,mem(iv),mem(in),mem(id),mem(iy),
     *           mem(if),mem(ig),mem(ix),mem(ii),mem(ij),mem(ik),
     *           mem(im),mem(irevt),mem(itran),mem(isinv),mem(iaa),
     *           mem(irr),mem(itt),mem(ipp),mem(ie),mem(iew),snumber,
     *           tnumber,unumber,scrno1,scrno2,mem(iscr1),mem(iscr2),
     *           mem(iscr3),mem(iscr5),mem(iscr8),no_hamil,no_prop,
     *           nbasp,nbaso,indx2,maxsiz,nblock,nAtom,
     *           mem(iscrsq),mem(iscrt),mem(issm),mem(ihsm),
     *           mem(iewsm),mem(ieigsm))
      Else
      call dkhparser_numeric (s,t,v,pvp,x,pxp,dkhorder,xorder,paramtype,
     *           dkhscfflg,nbas,isize,clight,mem(iv),mem(in),mem(id),
     *           mem(iy),mem(if),mem(ig),mem(ix),
     *           mem(ii),mem(ij),mem(ik),mem(il),mem(im),mem(irevt),
     *           mem(itran),mem(isinv),mem(iaa),mem(irr),mem(itt),
     *           mem(ipp),mem(ie),mem(iew),snumber,tnumber,unumber,
     *           scrno1,scrno2,mem(iscr1),mem(iscr2),mem(iscr3),
     *           mem(iscr5),mem(iscr8),no_hamil,no_prop,nbasp,nbaso,
     *           LDKroll,indx2,nAtom,maxsiz,nblock)
      End If
c
      return
      end
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!***********************************************************************

function NCASTR_MCLR(IAC,NSTTPI,NTPSTI,ICLSI,NOBATP,NOBTP,IELPTP)
! Number of allowed annihilation/creations from a given group of strings
!
! Jeppe Olsen, June 1994

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: NCASTR_MCLR
integer(kind=iwp), intent(in) :: IAC, NTPSTI, NSTTPI(NTPSTI), ICLSI, NOBTP, NOBATP(NOBTP), IELPTP(NOBTP,*)
integer(kind=iwp) :: ICLSO, IOBTP, ISTTP, ITPO, LCA, NENTRY

LCA = 0
!write(u6,*) ' NCASTR: IELPTP array'
!write(u6,*) ' ===================='
!write(u6,*) ' Number of occupation types ',NTPSTI
!call iwrtma(IELPTP,NOBTP,NTPSTI,NOBTP,NTPSTI)
!write(u6,*) ' NOBTP NTPSTI ',NOBTP,NTPSTI
!write(u6,*) ' Number of strings per type:'
!write(u6,*) (NSTTPI(I),I=1,NTPSTI)
do IOBTP=1,NOBTP
  do ISTTP=1,NTPSTI
    ! Type of resulting string
    call NEWTYP_MCLR(ICLSI,ISTTP,[IAC],[IOBTP],1,ICLSO,ITPO)
    !write(u6,*) ' IOBTP ISTTP => ITPO, ICLSO'
    !write(u6,*) IOBTP,ISTTP,ITPO,ICLSO
    !write(u6,*) ' IELPTP = ',IELPTP(IOBTP,ISTTP)
    !write(u6,*) ' NOBATP = ',NOBATP(IOBTP)
    if (IAC == 1) then
      NENTRY = IELPTP(IOBTP,ISTTP)
    else
      NENTRY = NOBATP(IOBTP)-IELPTP(IOBTP,ISTTP)
    end if
    !write(u6,*) ' NENTRY = ',NENTRY
    if (ITPO > 0) LCA = LCA+NENTRY*NSTTPI(ISTTP)

  end do
end do

!write(u6,*) ' Number of generated strings ',LCA
NCASTR_MCLR = LCA

return

end function NCASTR_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine inn_ext_ss_drl_loop_unpack_g(iplplwei,iplprwei)

use gugaci_global, only: ibsm_ext, iesm_ext, index_lpext, index_lpext1, ism_g2g4, iwt_sm_s_ext, logic_g2g4a, logic_g2g4b, &
                         logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, lpend34a, lpend34b, lpend35a, &
                         lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, lpsta36b, &
                         ng_sm, value_lpext, value_lpext1, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, indexlp, indexlp1, irwtmp, isma, &
                     ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) ' ss_test 2/2'
ii = 1
ii0 = ii
if (logic_g2g4a) then
  ii = ii0
  mm0 = iplplwei
  nn0 = iplprwei+iwt_sm_s_ext
  mm = mm0
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1

      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii+1)
        indexlp1 = index_lpext1(ii+1)

        !if (indexlp /= 0) then
        valuelp = value_lpext(ii+1)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*(vector1(nna)+vector1(nnb))*valuelp
        !end if
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii+1)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*(vector1(nna)+vector1(nnb))*valuelp1
        !end if
        ii = ii+2
      end do
    end do
  end do
end if
if (logic_g2g4b) then
  ii = ii0
  mm0 = iplprwei
  nn0 = iplplwei+iwt_sm_s_ext
  mm = mm0
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii+1)
        indexlp1 = index_lpext1(ii+1)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii+1)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*(vector1(nna)+vector1(nnb))*valuelp
        !end if
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii+1)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*(vector1(nna)+vector1(nnb))*valuelp1
        !end if
        ii = ii+2
      end do
    end do
  end do
end if
!iaddii = (ii-ii0)/2
ii0 = ii-1

do icle=1,2
  if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta36 = lpsta36a
      lpend36 = lpend36a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta36 = lpsta36b
      lpend36 = lpend36b
    end if
    do iii=lpsta36,lpend36,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      ii = ii0+lpext_wei(iii+2)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(ii)
        indexlp1 = index_lpext1(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if

        mm = mm+1
        nn = nn+1
      end do
    end do
  end if

  if (((icle == 1) .and. logic_g35a) .or. ((icle == 2) .and. logic_g35b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta35 = lpsta35a
      lpend35 = lpend35a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta35 = lpsta35b
      lpend35 = lpend35b
    end if
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        indexlp1 = index_lpext1(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if
  !cycle

  if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta34 = lpsta34a
      lpend34 = lpend34a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta34 = lpsta34b
      lpend34 = lpend34b
    end if
    do iii=lpsta34,lpend34,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      iij = ii0+lpext_wei(iii+2)
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        indexlp1 = index_lpext1(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if

end do

end subroutine inn_ext_ss_drl_loop_unpack_g

subroutine inn_ext_st_drl_loop_unpack_g(iplplwei,iplprwei)

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, index_lpext, index_lpext1, ism_g2g4, iwt_sm_s_ext, logic_g1415, &
                         logic_g2g4a, logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, &
                         lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, &
                         lpsta35b, lpsta36a, lpsta36b, ng_sm, value_lpext, value_lpext1, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, indexlp, indexlp1, irwtmp, isma, &
                     ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) ' st_test 2/2'

ii = 1
if (logic_g1415) then
  mm = iplplwei
  nn = iplprwei
  do i=1,idownwei_g131415
    mm = mm+1
    nn = nn+1
    indexlp = index_lpext(ii)
    indexlp1 = index_lpext1(ii)
    !if (indexlp /= 0) then
    valuelp = value_lpext(ii)
    vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    !end if
    !if (indexlp1 /= 0) then
    valuelp1 = value_lpext1(ii)
    vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    !end if
    ii = ii+1
  end do
end if

ii0 = ii
if (logic_g2g4a) then
  ii = ii0
  mm0 = iplplwei
  nn0 = iplprwei+iwt_sm_s_ext
  mm = mm0            !severe_error
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1

      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1

        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        ii = ii+1

        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        ii = ii+1
      end do
    end do
  end do
end if
if (logic_g2g4b) then
  ii = ii0
  mm0 = iplprwei
  nn0 = iplplwei+iwt_sm_s_ext
  mm = mm0             !severe_error
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1

        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        ii = ii+1

        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        ii = ii+1

      end do
    end do
  end do
end if
ii0 = ii-1
do icle=1,2
  if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta36 = lpsta36a
      lpend36 = lpend36a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta36 = lpsta36b
      lpend36 = lpend36b
    end if
    do iii=lpsta36,lpend36,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      ii = ii0+lpext_wei(iii+2)

      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        mm = mm+1
        nn = nn+1
      end do
    end do
  end if
  if ((icle == 1) .and. logic_g35a) then
    mm0 = iplplwei
    nn0 = iplprwei
    lpsta35 = lpsta35a
    lpend35 = lpend35a
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  else if ((icle == 2) .and. logic_g35b) then
    mm0 = iplprwei
    nn0 = iplplwei
    lpsta35 = lpsta35b
    lpend35 = lpend35b
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if

  if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta34 = lpsta34a
      lpend34 = lpend34a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta34 = lpsta34b
      lpend34 = lpend34b
    end if
    do iii=lpsta34,lpend34,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if

end do

end subroutine inn_ext_st_drl_loop_unpack_g

subroutine inn_ext_tt_drl_loop_unpack_g(iplplwei,iplprwei,n1415)

use gugaci_global, only: idownwei_g131415, index_lpext, index_lpext1, logic_g1415, logic_g34a, logic_g34b, logic_g35a, logic_g35b, &
                         logic_g36a, logic_g36b, lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, &
                         lpsta34b, lpsta35a, lpsta35b, lpsta36a, lpsta36b, value_lpext, value_lpext1, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei, n1415
integer(kind=iwp) :: i, icle, ii, ii0, iii, iij, ilwtmp, indexlp, indexlp1, irwtmp, lpend34, lpend35, lpend36, lpsta34, lpsta35, &
                     lpsta36, mm, mm0, nn, nn0
real(kind=wp) :: valuelp, valuelp1
logical(kind=iwp) :: logic_g14150, logic_g34b0, logic_g35b0, logic_g36b0

!write(u6,*) '  tt_test 2/2'
logic_g14150 = logic_g1415
logic_g36b0 = logic_g36b
logic_g35b0 = logic_g35b
logic_g34b0 = logic_g34b
if (iplplwei == iplprwei) then
  logic_g14150 = .false.
  logic_g36b0 = .false.
  logic_g35b0 = .false.
  logic_g34b0 = .false.
end if
ii = 1
if (logic_g14150) then
  mm = iplplwei
  nn = iplprwei
  !ii = iista
  do i=1,idownwei_g131415
    mm = mm+1
    nn = nn+1
    indexlp = index_lpext(ii)
    !if (indexlp /= 0) then
    valuelp = value_lpext(ii)
    vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    !end if
    indexlp1 = index_lpext1(ii)
    !if (indexlp1 /= 0) then
    valuelp1 = value_lpext1(ii)
    vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    !end if
    ii = ii+1
  end do
end if

ii0 = n1415         !severe_error

do icle=1,2
  if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b0)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta36 = lpsta36a
      lpend36 = lpend36a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta36 = lpsta36b
      lpend36 = lpend36b
    end if
    do iii=lpsta36,lpend36,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      ii = ii0+lpext_wei(iii+2)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        mm = mm+1
        nn = nn+1
      end do
    end do
  end if

  if (((icle == 1) .and. logic_g35a) .or. ((icle == 2) .and. logic_g35b0)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta35 = lpsta35a
      lpend35 = lpend35a
    else if ((icle == 2) .and. logic_g35b0) then
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta35 = lpsta35b
      lpend35 = lpend35b
    end if
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = -value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if
  !cycle

  if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b0)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta34 = lpsta34a
      lpend34 = lpend34a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta34 = lpsta34b
      lpend34 = lpend34b
    end if
    do iii=lpsta34,lpend34,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do

    end do
  end if

end do

end subroutine inn_ext_tt_drl_loop_unpack_g

subroutine inn_ext_ts_drl_loop_unpack_g(iplplwei,iplprwei)

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, index_lpext, index_lpext1, ism_g2g4, iwt_sm_s_ext, logic_g1415, &
                         logic_g2g4a, logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, &
                         lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, &
                         lpsta35b, lpsta36a, lpsta36b, ng_sm, value_lpext, value_lpext1, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, indexlp, indexlp1, irwtmp, isma, &
                     ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) '  ts_test 2/2'
ii = 1
!logic_g1415 = .false.
!logic_g2g4a = .false.
!logic_g2g4b = .false.
!logic_g36a = .false.
!logic_g36b = .false.
!logic_g35a = .false.
!logic_g35b = .false.
!logic_g34a = .false.
!logic_g34b = .false.
if (logic_g1415) then
  mm = iplplwei
  nn = iplprwei
  do i=1,idownwei_g131415
    mm = mm+1
    nn = nn+1
    indexlp = index_lpext(ii)
    !if (indexlp /= 0) then
    valuelp = value_lpext(ii)
    vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    !end if
    indexlp1 = index_lpext1(ii)
    !if (indexlp1 /= 0) then
    valuelp1 = value_lpext1(ii)
    vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    !end if
    ii = ii+1
  end do
end if
ii0 = ii
if (logic_g2g4a) then
  ii = ii0
  mm0 = iplplwei
  nn0 = iplprwei+iwt_sm_s_ext
  mm = mm0            !severe_error
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        ii = ii+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        ii = ii+1
      end do
    end do
  end do
end if
if (logic_g2g4b) then
  ii = ii0
  mm0 = iplprwei
  nn0 = iplplwei+iwt_sm_s_ext
  mm = mm0             !severe_error
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        ii = ii+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        ii = ii+1
      end do
    end do
  end do
end if

ii0 = ii-1         !severe_error

do icle=1,2
  if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta36 = lpsta36a
      lpend36 = lpend36a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta36 = lpsta36b
      lpend36 = lpend36b
    end if
    do iii=lpsta36,lpend36,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      ii = ii0+lpext_wei(iii+2)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        mm = mm+1
        nn = nn+1
      end do
    end do
  end if

  if ((icle == 1) .and. logic_g35a) then
    mm0 = iplplwei
    nn0 = iplprwei
    lpsta35 = lpsta35a
    lpend35 = lpend35a
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  else if ((icle == 2) .and. logic_g35b) then
    mm0 = iplprwei
    nn0 = iplplwei
    lpsta35 = lpsta35b
    lpend35 = lpend35b
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if

  if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta34 = lpsta34a
      lpend34 = lpend34a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta34 = lpsta34b
      lpend34 = lpend34b
    end if
    do iii=lpsta34,lpend34,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if
end do

end subroutine inn_ext_ts_drl_loop_unpack_g

subroutine inn_ext_ss_loop_unpack_g(iplplwei,iplprwei)

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, index_lpext, index_lpext1, ism_g2g4, iwt_sm_s_ext, logic_g1415, &
                         logic_g2g4a, logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, &
                         lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, &
                         lpsta35b, lpsta36a, lpsta36b, ng_sm, nvalue_space_ss, value_lpext, value_lpext1, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, indexlp, indexlp1, irwtmp, isma, &
                     ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) ' ss_test 1/2'
ii = 1
if (logic_g1415) then
  mm = iplplwei
  nn = iplprwei
  do i=1,idownwei_g131415

    mm = mm+1
    nn = nn+1
    indexlp = index_lpext(ii)
    !if (indexlp /= 0) then
    valuelp = value_lpext(ii)
    vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    !end if
    indexlp1 = index_lpext1(ii)
    !if (indexlp1 /= 0) then
    valuelp1 = value_lpext1(ii)
    vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    !end if
    ii = ii+1

    indexlp = index_lpext(ii)
    if (indexlp /= 0) then
      valuelp = value_lpext(ii)
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    end if
    indexlp1 = index_lpext1(ii)
    if (indexlp1 /= 0) then
      valuelp1 = value_lpext1(ii)
      vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    end if
    ii = ii+1
  end do
end if

ii0 = ii
if (logic_g2g4a) then
  ii = ii0
  mm0 = iplplwei
  nn0 = iplprwei+iwt_sm_s_ext
  mm = mm0
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nna)*valuelp1
        !end if
        ii = ii+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nnb)*valuelp1
        !end if
        ii = ii+1

      end do
    end do
  end do
end if
if (logic_g2g4b) then
  ii = ii0
  mm0 = iplprwei
  nn0 = iplplwei+iwt_sm_s_ext
  mm = mm0
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nnb)*valuelp1
        !end if
        ii = ii+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nna)*valuelp1
        !end if
        ii = ii+1

      end do
    end do
  end do
end if
!iaddii = ii-ii0)/2
ii0 = ii-1

do icle=1,2
  if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta36 = lpsta36a
      lpend36 = lpend36a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta36 = lpsta36b
      lpend36 = lpend36b
    end if
    do iii=lpsta36,lpend36,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      ii = ii0+lpext_wei(iii+2)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if

        mm = mm+1
        nn = nn+1
      end do
    end do
  end if

  if (((icle == 1) .and. logic_g35a) .or. ((icle == 2) .and. logic_g35b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta35 = lpsta35a
      lpend35 = lpend35a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta35 = lpsta35b
      lpend35 = lpend35b
    end if
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if

  if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta34 = lpsta34a
      lpend34 = lpend34a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta34 = lpsta34b
      lpend34 = lpend34b
    end if
    do iii=lpsta34,lpend34,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      iij = ii0+lpext_wei(iii+2)
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if
  ii0 = ii0+nvalue_space_ss
end do

end subroutine inn_ext_ss_loop_unpack_g

subroutine inn_ext_st_loop_unpack_g(iplplwei,iplprwei)

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, index_lpext, index_lpext1, ism_g2g4, iwt_sm_s_ext, logic_g1415, &
                         logic_g2g4a, logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, &
                         lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, &
                         lpsta35b, lpsta36a, lpsta36b, ng_sm, nvalue_space_ss, value_lpext, value_lpext1, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, indexlp, indexlp1, irwtmp, isma, &
                     ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) ' st_test 1/2'
ii = 1
if (logic_g1415) then
  mm = iplplwei
  nn = iplprwei
  do i=1,idownwei_g131415
    mm = mm+1
    nn = nn+1
    indexlp = index_lpext(ii)
    !if (indexlp /= 0) then
    valuelp = value_lpext(ii)
    vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    !end if
    indexlp1 = index_lpext1(ii)
    !if (indexlp1 /= 0) then
    valuelp1 = value_lpext1(ii)
    vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    !end if
    ii = ii+1

    indexlp = index_lpext(ii)
    if (indexlp /= 0) then
      valuelp = value_lpext(ii)
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    end if
    indexlp1 = index_lpext1(ii)
    if (indexlp1 /= 0) then
      valuelp1 = value_lpext1(ii)
      vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    end if
    ii = ii+1
  end do
end if

ii0 = ii
if (logic_g2g4a) then
  ii = ii0
  mm0 = iplplwei
  nn0 = iplprwei+iwt_sm_s_ext
  mm = mm0            !severe_error
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nna)*valuelp1
        !end if
        ii = ii+1

        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nnb)*valuelp1
        !end if
        ii = ii+1
      end do
    end do
  end do
end if

if (logic_g2g4b) then
  ii = ii0
  mm0 = iplprwei
  nn0 = iplplwei+iwt_sm_s_ext
  mm = mm0
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)

        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        valuelp1 = value_lpext1(ii)
        !if (indexlp1 /= 0) then
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nnb)*valuelp1
        !end if
        ii = ii+1

        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nna)*valuelp1
        !end if
        ii = ii+1

      end do
    end do
  end do
end if
ii0 = ii-1

do icle=1,2
  if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta36 = lpsta36a
      lpend36 = lpend36a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta36 = lpsta36b
      lpend36 = lpend36b
    end if
    do iii=lpsta36,lpend36,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      ii = ii0+lpext_wei(iii+2)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        mm = mm+1
        nn = nn+1
      end do
    end do
  end if

  !write(u6,*) 'st_g35a',iplplwei,iplprwei,vector2(137)
  if ((icle == 1) .and. logic_g35a) then
    mm0 = iplplwei
    nn0 = iplprwei
    lpsta35 = lpsta35a
    lpend35 = lpend35a
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  else if ((icle == 2) .and. logic_g35b) then
    mm0 = iplprwei
    nn0 = iplplwei
    lpsta35 = lpsta35b
    lpend35 = lpend35b
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = -value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if

  !write(u6,*) 'st_g34',iplplwei,iplprwei,vector2(137)
  if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta34 = lpsta34a
      lpend34 = lpend34a
    else if ((icle == 2) .and. logic_g34b) then
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta34 = lpsta34b
      lpend34 = lpend34b
    end if
    do iii=lpsta34,lpend34,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      iij = ii0+lpext_wei(iii+2)
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = -value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if
  ii0 = ii0+nvalue_space_ss
end do

end subroutine inn_ext_st_loop_unpack_g

subroutine inn_ext_ts_loop_unpack_g(iplplwei,iplprwei)

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, index_lpext, index_lpext1, ism_g2g4, iwt_sm_s_ext, logic_g1415, &
                         logic_g2g4a, logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, &
                         lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, &
                         lpsta35b, lpsta36a, lpsta36b, ng_sm, nvalue_space_ss, value_lpext, value_lpext1, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, indexlp, indexlp1, irwtmp, isma, &
                     ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) '  ts_test 1/2 '
ii = 1
if (logic_g1415) then
  mm = iplplwei
  nn = iplprwei
  do i=1,idownwei_g131415
    mm = mm+1
    nn = nn+1
    indexlp = index_lpext(ii)
    !if (indexlp /= 0) then
    valuelp = value_lpext(ii)
    vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    !end if
    indexlp1 = index_lpext1(ii)
    !if (indexlp1 /= 0) then
    valuelp1 = value_lpext1(ii)
    vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    !end if
    ii = ii+1

    indexlp = index_lpext(ii)
    if (indexlp /= 0) then
      valuelp = value_lpext(ii)
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    end if
    indexlp1 = index_lpext1(ii)
    if (indexlp1 /= 0) then
      valuelp1 = value_lpext1(ii)
      vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    end if
    ii = ii+1
  end do
end if

ii0 = ii
if (logic_g2g4a) then
  ii = ii0
  mm0 = iplplwei
  nn0 = iplprwei+iwt_sm_s_ext
  mm = mm0            !severe_error
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nna)*valuelp1
        !end if
        ii = ii+1

        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nnb)*valuelp1
        !end if
        ii = ii+1

      end do
    end do
  end do
end if
if (logic_g2g4b) then
  ii = ii0
  mm0 = iplprwei
  nn0 = iplplwei+iwt_sm_s_ext
  mm = mm0             !severe_error
  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g2g4)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    nna = nn0+ibsta-1
    do ib=ibsta,ibend
      nna = nna+1
      nnb = nn0+iasta-1
      do ia=iasta,min(iaend,ib-1)
        mm = mm+1
        nnb = nnb+1
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nnb)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nnb)*valuelp1
        !end if
        ii = ii+1

        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nna)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nna)*valuelp1
        !end if
        ii = ii+1

      end do
    end do
  end do
end if
ii0 = ii-1

do icle=1,2
  if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta36 = lpsta36a
      lpend36 = lpend36a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta36 = lpsta36b
      lpend36 = lpend36b
    end if
    do iii=lpsta36,lpend36,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      ii = ii0+lpext_wei(iii+2)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        mm = mm+1
        nn = nn+1
      end do
    end do
  end if

  if ((icle == 1) .and. logic_g35a) then
    mm0 = iplplwei
    nn0 = iplprwei
    lpsta35 = lpsta35a
    lpend35 = lpend35a
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = -value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  else if ((icle == 2) .and. logic_g35b) then
    mm0 = iplprwei
    nn0 = iplplwei
    lpsta35 = lpsta35b
    lpend35 = lpend35b
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if

  if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta34 = lpsta34a
      lpend34 = lpend34a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta34 = lpsta34b
      lpend34 = lpend34b
    end if
    do iii=lpsta34,lpend34,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = -value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        iij = iij+1
        mm = mm+1
      end do
    end do
  end if
  ii0 = ii0+nvalue_space_ss
end do

end subroutine inn_ext_ts_loop_unpack_g

subroutine inn_ext_tt_loop_unpack_g(iplplwei,iplprwei)

use gugaci_global, only: idownwei_g131415, index_lpext, index_lpext1, logic_g1415, logic_g34a, logic_g34b, logic_g35a, logic_g35b, &
                         logic_g36a, logic_g36b, lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, &
                         lpsta34b, lpsta35a, lpsta35b, lpsta36a, lpsta36b, nvalue_space_ss, value_lpext, value_lpext1, vector1, &
                         vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, icle, ii, ii0, iii, iij, ilwtmp, indexlp, indexlp1, irwtmp, lpend34, lpend35, lpend36, lpsta34, lpsta35, &
                     lpsta36, mm, mm0, nn, nn0
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) '  tt_test 1/2'
ii = 1
if (logic_g1415) then
  mm = iplplwei
  nn = iplprwei

  do i=1,idownwei_g131415
    mm = mm+1
    nn = nn+1
    indexlp = index_lpext(ii)
    !if (indexlp /= 0) then
    valuelp = value_lpext(ii)
    vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    !end if
    indexlp1 = index_lpext1(ii)
    !if (indexlp1 /= 0) then
    valuelp1 = value_lpext1(ii)
    vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    !end if

    ii = ii+1

    indexlp = index_lpext(ii)
    if (indexlp /= 0) then
      valuelp = value_lpext(ii)
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    end if
    indexlp1 = index_lpext1(ii)
    if (indexlp1 /= 0) then
      valuelp1 = value_lpext1(ii)
      vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    end if
    ii = ii+1
  end do
end if

ii0 = ii-1

do icle=1,2
  if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta36 = lpsta36a
      lpend36 = lpend36a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta36 = lpsta36b
      lpend36 = lpend36b
    end if
    do iii=lpsta36,lpend36,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      ii = ii0+lpext_wei(iii+2)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(ii)
        !if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(ii)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if
        mm = mm+1
        nn = nn+1
      end do
    end do
  end if

  if (((icle == 1) .and. logic_g35a) .or. ((icle == 2) .and. logic_g35b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta35 = lpsta35a
      lpend35 = lpend35a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta35 = lpsta35b
      lpend35 = lpend35b
    end if
    do iii=lpsta35,lpend35,4
      mm = mm0+lpext_wei(iii)
      nn = nn0+lpext_wei(iii+1)
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = -value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = -value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if

        iij = iij+1
        mm = mm+1
      end do
    end do
  end if
  !cycle

  if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
    if (icle == 1) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta34 = lpsta34a
      lpend34 = lpend34a
    else
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta34 = lpsta34b
      lpend34 = lpend34b
    end if
    do iii=lpsta34,lpend34,4
      ilwtmp = lpext_wei(iii)
      irwtmp = lpext_wei(iii+1)
      mm = mm0+ilwtmp
      nn = nn0+irwtmp
      iij = ii0+lpext_wei(iii+2)

      do i=1,lpext_wei(iii+3)
        indexlp = index_lpext(iij)
        !if (indexlp /= 0) then
        valuelp = value_lpext(iij)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        !end if
        indexlp1 = index_lpext1(iij)
        !if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(iij)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        !end if

        iij = iij+1
        mm = mm+1
      end do
    end do
  end if
  ii0 = ii0+nvalue_space_ss
end do

end subroutine inn_ext_tt_loop_unpack_g

subroutine gsd_sequence_extspace_g(iplplwei,iplprwei)

use gugaci_global, only: index_lpext, index_lpext1, ivaluesta_g26, iweista_g25, iweista_g26, iweista_g28, logic_g25a, logic_g25b, &
                         logic_g26, logic_g28a, nint_g25, nint_g28, nwei_g25, nwei_g26, nwei_g28, v_sqtwo, value_lpext, &
                         value_lpext1, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, ilpvalue, indexlp, indexlp1, itmp, mm, nn, nn0
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) '  sd_test 1/2','  ds_test 1'

ilpvalue = 0
if (logic_g25a) then
  mm = iplplwei+iweista_g25-1
  nn0 = iplprwei
  do itmp=1,nint_g25
    ilpvalue = ilpvalue+1
    indexlp = index_lpext(ilpvalue)
    valuelp = value_lpext(ilpvalue)
    indexlp1 = index_lpext1(ilpvalue)
    valuelp1 = value_lpext1(ilpvalue)
    nn = nn0
    do i=1,nwei_g25
      mm = mm+1
      nn = nn+1
      !if (indexlp /= 0) then
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      !end if
      if (indexlp1 /= 0) then
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
    end do
  end do
else if (logic_g25b) then
  mm = iplplwei+iweista_g25-1
  nn0 = iplprwei
  ilpvalue = ilpvalue+1
  do itmp=2,nint_g25
    ilpvalue = ilpvalue+1
    indexlp = index_lpext(ilpvalue)
    valuelp = value_lpext(ilpvalue)
    indexlp1 = index_lpext1(ilpvalue)
    valuelp1 = value_lpext1(ilpvalue)
    nn = nn0
    do i=1,itmp-1
      mm = mm+1
      nn = nn+1
      !if (indexlp /= 0) then
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      !end if
      if (indexlp1 /= 0) then
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
    end do
  end do

  mm = iplplwei+iweista_g28-1
  nn = iplprwei
  nn = nn+1
  do itmp=2,nwei_g28
    nn = nn+1
    ilpvalue = 0
    do i=1,itmp-1
      ilpvalue = ilpvalue+1
      mm = mm+1
      indexlp = index_lpext(ilpvalue)
      !if (indexlp /= 0) then
      valuelp = value_lpext(ilpvalue)
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      !end if
      indexlp1 = index_lpext1(ilpvalue)
      if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ilpvalue)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
    end do
  end do
else if (logic_g28a) then
  mm = iplplwei+iweista_g28-1
  nn0 = iplprwei
  do nn=nn0+1,nn0+nwei_g28
    ilpvalue = 0
    do i=1,nint_g28
      ilpvalue = ilpvalue+1
      mm = mm+1
      indexlp = index_lpext(ilpvalue)
      !if (indexlp /= 0) then
      valuelp = value_lpext(ilpvalue)
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      !end if
      indexlp1 = index_lpext1(ilpvalue)
      if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ilpvalue)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
    end do
  end do
end if

if (logic_g26) then
  ilpvalue = ivaluesta_g26
  mm = iplplwei+iweista_g26
  nn0 = iplprwei
  do nn=nn0+1,nn0+nwei_g26
    ilpvalue = ilpvalue+1
    indexlp = index_lpext(ilpvalue)
    !if (indexlp /= 0) then
    valuelp = value_lpext(ilpvalue)*v_sqtwo
    vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    !end if
    indexlp1 = index_lpext1(ilpvalue)
    if (indexlp1 /= 0) then
      valuelp1 = value_lpext1(ilpvalue)*v_sqtwo
      vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    end if
    mm = mm+1
  end do
end if
!write(u6,*)  'out sd 1'

end subroutine gsd_sequence_extspace_g

subroutine gtd_sequence_extspace_g(iplplwei,iplprwei)

use gugaci_global, only: index_lpext, index_lpext1, iweista_g25, iweista_g28, logic_g25a, logic_g25b, logic_g28a, nint_g25, &
                         nint_g28, nwei_g25, nwei_g28, value_lpext, value_lpext1, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, ilpvalue, indexlp, indexlp1, itmp, mm, nn, nn0
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) ' td_test _1/2',' dt_test '
ilpvalue = 0
if (logic_g25a) then
  mm = iplplwei+iweista_g25-1
  nn0 = iplprwei
  do itmp=1,nint_g25
    ilpvalue = ilpvalue+1
    indexlp = index_lpext(ilpvalue)
    valuelp = value_lpext(ilpvalue)
    indexlp1 = index_lpext1(ilpvalue)
    valuelp1 = value_lpext1(ilpvalue)

    nn = nn0
    do i=1,nwei_g25
      mm = mm+1
      nn = nn+1
      !if (indexlp /= 0) then
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      !end if
      if (indexlp1 /= 0) then
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
    end do
  end do
else if (logic_g25b) then
  mm = iplplwei+iweista_g25-1
  nn0 = iplprwei
  ilpvalue = ilpvalue+1
  do itmp=2,nint_g25
    ilpvalue = ilpvalue+1
    indexlp = index_lpext(ilpvalue)
    valuelp = value_lpext(ilpvalue)
    indexlp1 = index_lpext1(ilpvalue)
    valuelp1 = value_lpext1(ilpvalue)

    nn = nn0
    do i=1,itmp-1
      mm = mm+1
      nn = nn+1
      !if (indexlp /= 0) then
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      !end if
      if (indexlp1 /= 0) then
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
    end do
  end do
  mm = iplplwei+iweista_g28-1
  nn = iplprwei
  nn = nn+1
  do itmp=2,nwei_g28
    nn = nn+1
    ilpvalue = 0
    do i=1,itmp-1
      ilpvalue = ilpvalue+1
      mm = mm+1
      indexlp = index_lpext(ilpvalue)
      !if (indexlp /= 0) then
      valuelp = -value_lpext(ilpvalue)
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      !end if
      indexlp1 = index_lpext1(ilpvalue)
      if (indexlp1 /= 0) then
        valuelp1 = -value_lpext1(ilpvalue)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
    end do
  end do
else if (logic_g28a) then
  mm = iplplwei+iweista_g28-1
  nn0 = iplprwei
  do nn=nn0+1,nn0+nwei_g28

    ilpvalue = 0
    do i=1,nint_g28
      ilpvalue = ilpvalue+1
      mm = mm+1
      indexlp = index_lpext(ilpvalue)
      !if (indexlp /= 0) then
      valuelp = -value_lpext(ilpvalue)
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      !end if
      indexlp1 = index_lpext1(ilpvalue)
      if (indexlp1 /= 0) then
        valuelp1 = -value_lpext1(ilpvalue)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
    end do
  end do
end if

end subroutine gtd_sequence_extspace_g

subroutine gdv_sequence_extspace_g(ilw,irw)

use gugaci_global, only: ilsegdownwei, index_lpext, index_lpext1, value_lpext, value_lpext1, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ilw, irw
integer(kind=iwp) :: iij, indexlp, indexlp1, mm, nn
real(kind=wp) :: valuelp, valuelp1

mm = ilw
nn = irw+1

do iij=1,ilsegdownwei
  mm = mm+1
  indexlp = index_lpext(iij)
  !if (indexlp /= 0) then
  valuelp = value_lpext(iij)
  vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
  !end if
  indexlp1 = index_lpext1(iij)
  if (indexlp1 /= 0) then
    valuelp1 = value_lpext1(iij)
    vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
  end if
end do

end subroutine gdv_sequence_extspace_g

subroutine complete_sd_ar_ext_loop_g(ilwei,irwei,isdownwei)

use gugaci_global, only: icano_nnend, icano_nnsta, index_lpext, index_lpext1, value_lpext, value_lpext1, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ilwei, irwei, isdownwei
integer(kind=iwp) :: ilpvalue, indexlp, indexlp1, mm, mm0, mmtmp, nn, nntmp
real(kind=wp) :: valuelp, valuelp1

!write(u6,*) 'sd_test 2/2','  td_test_2/2 2'
ilpvalue = 0
mm0 = ilwei
nn = irwei+icano_nnsta-1
do nntmp=icano_nnsta,icano_nnend
  nn = nn+1
  mm = mm0
  do mmtmp=1,isdownwei
    ilpvalue = ilpvalue+1
    mm = mm+1
    indexlp = index_lpext(ilpvalue)
    valuelp = value_lpext(ilpvalue)
    vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
    indexlp1 = index_lpext1(ilpvalue)
    if (indexlp1 /= 0) then

      valuelp1 = value_lpext1(ilpvalue)
      vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
    end if
  end do
end do
!write(u6,*) 'out sd 2'

return

end subroutine complete_sd_ar_ext_loop_g

subroutine gdv_sequence_extspace1_g(ilw,irw,n)

use gugaci_global, only: dm1tmp, ilsegdownwei, index_lpext3, index_lpext4, index_lpext5, value_lpext3, value_lpext4, value_lpext5, &
                         vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ilw, irw, n
integer(kind=iwp) :: ilpvalue, indexlp2, indexlp3, indexlp4, mm, nii, nn
real(kind=wp) :: valuelp2, valuelp3, valuelp4

mm = ilw
nn = irw+1

do ilpvalue=1,ilsegdownwei
  mm = mm+1
  indexlp2 = index_lpext5(ilpvalue)
  valuelp2 = value_lpext5(ilpvalue)
  dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2

  do nii=1,n
    indexlp3 = index_lpext3(ilpvalue,nii)
    !if (indexlp3 /= 0) then
    valuelp3 = value_lpext3(ilpvalue,nii)
    vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
    !end if

    indexlp4 = index_lpext4(ilpvalue,nii)
    if (indexlp4 /= 0) then
      valuelp4 = value_lpext4(ilpvalue,nii)
      vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
    end if
  end do
end do

end subroutine gdv_sequence_extspace1_g

subroutine gtd_sequence_extspace1_g(iplplwei,iplprwei,n)

use gugaci_global, only: dm1tmp, index_lpext3, index_lpext4, index_lpext5, iweista_g25, iweista_g28, logic_g25a, logic_g25b, &
                         logic_g28a, nint_g25, nint_g28, nwei_g25, nwei_g28, value_lpext3, value_lpext4, value_lpext5, vector1, &
                         vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei, n
integer(kind=iwp) :: i, ilpvalue, indexlp2, indexlp3, indexlp4, itmp, mm, nii, nn, nn0
real(kind=wp) :: valuelp2, valuelp3, valuelp4

!write(u6,*) ' td_test _1/2',' dt_test '
ilpvalue = 0
if (logic_g25a) then
  mm = iplplwei+iweista_g25-1
  nn0 = iplprwei
  do itmp=1,nint_g25
    ilpvalue = ilpvalue+1
    indexlp2 = index_lpext5(ilpvalue)
    valuelp2 = value_lpext5(ilpvalue)
    nn = nn0
    do i=1,nwei_g25
      mm = mm+1
      nn = nn+1
      dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
      do nii=1,n
        indexlp3 = index_lpext3(ilpvalue,nii)
        !if (indexlp3 /= 0) then
        valuelp3 = value_lpext3(ilpvalue,nii)
        vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
        !end if
        indexlp4 = index_lpext4(ilpvalue,nii)
        if (indexlp4 /= 0) then
          valuelp4 = value_lpext4(ilpvalue,nii)
          vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
        end if
      end do
    end do
  end do
else if (logic_g25b) then
  mm = iplplwei+iweista_g25-1
  nn0 = iplprwei
  ilpvalue = ilpvalue+1
  do itmp=2,nint_g25
    ilpvalue = ilpvalue+1
    indexlp2 = index_lpext5(ilpvalue)
    valuelp2 = value_lpext5(ilpvalue)

    nn = nn0
    do i=1,itmp-1
      mm = mm+1
      nn = nn+1
      dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
      do nii=1,n
        indexlp3 = index_lpext3(ilpvalue,nii)
        !if (indexlp3 /= 0) then
        valuelp3 = value_lpext3(ilpvalue,nii)
        vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
        !end if
        indexlp4 = index_lpext4(ilpvalue,nii)
        if (indexlp4 /= 0) then
          valuelp4 = value_lpext4(ilpvalue,nii)
          vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
        end if
      end do
    end do
  end do
  mm = iplplwei+iweista_g28-1
  nn = iplprwei
  nn = nn+1
  do itmp=2,nwei_g28
    nn = nn+1
    ilpvalue = 0
    do i=1,itmp-1
      ilpvalue = ilpvalue+1
      indexlp2 = index_lpext5(ilpvalue)
      valuelp2 = -value_lpext5(ilpvalue)
      mm = mm+1
      dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
      do nii=1,n
        indexlp3 = index_lpext3(ilpvalue,nii)
        !if (indexlp3 /= 0) then
        valuelp3 = -value_lpext3(ilpvalue,nii)
        vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
        !end if
        indexlp4 = index_lpext4(ilpvalue,nii)
        if (indexlp4 /= 0) then
          valuelp4 = -value_lpext4(ilpvalue,nii)
          vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
        end if
      end do
    end do
  end do
else if (logic_g28a) then
  mm = iplplwei+iweista_g28-1
  nn0 = iplprwei
  do nn=nn0+1,nn0+nwei_g28

    ilpvalue = 0
    do i=1,nint_g28
      ilpvalue = ilpvalue+1
      indexlp2 = index_lpext5(ilpvalue)
      valuelp2 = -value_lpext5(ilpvalue)
      mm = mm+1
      dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
      do nii=1,n
        indexlp3 = index_lpext3(ilpvalue,nii)
        !if (indexlp3 /= 0) then
        valuelp3 = -value_lpext3(ilpvalue,nii)
        vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
        !end if
        indexlp4 = index_lpext4(ilpvalue,nii)
        if (indexlp4 /= 0) then
          valuelp4 = -value_lpext4(ilpvalue,nii)
          vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
        end if
      end do
    end do
  end do
end if

end subroutine gtd_sequence_extspace1_g

subroutine gsd_sequence_extspace1_g(iplplwei,iplprwei,n)

use gugaci_global, only: dm1tmp, index_lpext3, index_lpext4, index_lpext5, ivaluesta_g26, iweista_g25, iweista_g26, iweista_g28, &
                         logic_g25a, logic_g25b, logic_g26, logic_g28a, nint_g25, nint_g28, nwei_g25, nwei_g26, nwei_g28, &
                         v_sqtwo, value_lpext3, value_lpext4, value_lpext5, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei, n
integer(kind=iwp) :: i, ilpvalue, indexlp2, indexlp3, indexlp4, itmp, mm, nii, nn, nn0
real(kind=wp) :: valuelp2, valuelp3, valuelp4

!write(u6,*) '  sd_test 1/2','  ds_test 0'

ilpvalue = 0
if (logic_g25a) then
  mm = iplplwei+iweista_g25-1
  nn0 = iplprwei
  do itmp=1,nint_g25
    ilpvalue = ilpvalue+1
    indexlp2 = index_lpext5(ilpvalue)
    valuelp2 = value_lpext5(ilpvalue)

    nn = nn0
    do i=1,nwei_g25
      mm = mm+1
      nn = nn+1
      dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
      do nii=1,n
        indexlp3 = index_lpext3(ilpvalue,nii)
        !if (indexlp3 /= 0) then
        valuelp3 = value_lpext3(ilpvalue,nii)
        vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
        !end if
        indexlp4 = index_lpext4(ilpvalue,nii)
        if (indexlp4 /= 0) then
          valuelp4 = value_lpext4(ilpvalue,nii)
          vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
        end if
      end do
    end do
  end do
else if (logic_g25b) then
  mm = iplplwei+iweista_g25-1
  nn0 = iplprwei
  ilpvalue = ilpvalue+1
  do itmp=2,nint_g25
    ilpvalue = ilpvalue+1
    indexlp2 = index_lpext5(ilpvalue)
    valuelp2 = value_lpext5(ilpvalue)

    nn = nn0
    do i=1,itmp-1
      mm = mm+1
      nn = nn+1
      dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
      do nii=1,n
        indexlp3 = index_lpext3(ilpvalue,nii)
        !if (indexlp3 /= 0) then
        valuelp3 = value_lpext3(ilpvalue,nii)
        vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
        !end if
        indexlp4 = index_lpext4(ilpvalue,nii)
        if (indexlp4 /= 0) then
          valuelp4 = value_lpext4(ilpvalue,nii)
          vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
        end if
      end do

    end do
  end do

  mm = iplplwei+iweista_g28-1
  nn = iplprwei
  nn = nn+1
  do itmp=2,nwei_g28
    nn = nn+1
    ilpvalue = 0
    do i=1,itmp-1
      ilpvalue = ilpvalue+1
      indexlp2 = index_lpext5(ilpvalue)
      valuelp2 = value_lpext5(ilpvalue)
      mm = mm+1
      dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
      do nii=1,n
        indexlp3 = index_lpext3(ilpvalue,nii)
        !if (indexlp3 /= 0) then
        valuelp3 = value_lpext3(ilpvalue,nii)
        vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
        !end if
        indexlp4 = index_lpext4(ilpvalue,nii)
        if (indexlp4 /= 0) then
          valuelp4 = value_lpext4(ilpvalue,nii)
          vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
        end if
      end do
    end do
  end do
else if (logic_g28a) then
  mm = iplplwei+iweista_g28-1
  nn0 = iplprwei
  do nn=nn0+1,nn0+nwei_g28
    ilpvalue = 0
    do i=1,nint_g28
      ilpvalue = ilpvalue+1
      indexlp2 = index_lpext5(ilpvalue)
      valuelp2 = value_lpext5(ilpvalue)
      mm = mm+1
      dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
      do nii=1,n
        indexlp3 = index_lpext3(ilpvalue,nii)
        !if (indexlp3 /= 0) then
        valuelp3 = value_lpext3(ilpvalue,nii)
        vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
        !end if
        indexlp4 = index_lpext4(ilpvalue,nii)
        if (indexlp4 /= 0) then
          valuelp4 = value_lpext4(ilpvalue,nii)
          vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
        end if
      end do
    end do
  end do
end if

if (logic_g26) then
  ilpvalue = ivaluesta_g26
  mm = iplplwei+iweista_g26
  nn0 = iplprwei
  do nn=nn0+1,nn0+nwei_g26
    ilpvalue = ilpvalue+1
    indexlp2 = index_lpext5(ilpvalue)
    valuelp2 = value_lpext5(ilpvalue)*v_sqtwo

    dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
    do nii=1,n
      indexlp3 = index_lpext3(ilpvalue,nii)
      !if (indexlp3 /= 0) then
      valuelp3 = value_lpext3(ilpvalue,nii)*v_sqtwo
      vector2(indexlp3) = vector2(indexlp3)+vector1(mm)*vector1(nn)*valuelp3
      !end if
      indexlp4 = index_lpext4(ilpvalue,nii)
      if (indexlp4 /= 0) then
        valuelp4 = value_lpext4(ilpvalue,nii)*v_sqtwo
        vector2(indexlp4) = vector2(indexlp4)+vector1(mm)*vector1(nn)*valuelp4
      end if
    end do
    mm = mm+1
  end do
end if
!write(u6,*) 'out ds 0'

end subroutine gsd_sequence_extspace1_g

subroutine inn_ext_dd_loop_unpack_g(iplplwei,iplprwei)

use gugaci_global, only: ildownwei_segdd, index_lpext, index_lpext1, int_dd_drl, irdownwei_segdd, logic_g49a, logic_g49b, &
                         logic_g50, value_lpext, value_lpext1, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplwei, iplprwei
integer(kind=iwp) :: i, icle, ii, ildownwei, indexlp, indexlp1, irdownwei, j, mm, mm0, nn
real(kind=wp) :: valuelp, valuelp1

!write(nf2,*) 'logic_g49b',logic_g50,logic_g49a,logic_g49b

ii = 1
if (logic_g50) then
  if (logic_g49b) then
    mm = iplplwei
    nn = iplprwei
    do i=1,ildownwei_segdd
      mm = mm+1
      nn = nn+1
      indexlp = index_lpext(ii)
      if (indexlp /= 0) then
        valuelp = value_lpext(ii)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      end if
      indexlp1 = index_lpext1(ii)
      if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ii)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
      ii = ii+1
    end do
  end if

  ii = ii+int_dd_drl
  mm0 = iplplwei
  nn = iplprwei+1
  do icle=1,2
    do j=2,ildownwei_segdd
      nn = nn+1
      mm = mm0
      do i=1,j-1
        mm = mm+1
        indexlp = index_lpext(ii)
        if (indexlp /= 0) then
          valuelp = value_lpext(ii)
          vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
        end if
        indexlp1 = index_lpext1(ii)
        if (indexlp1 /= 0) then
          valuelp1 = value_lpext1(ii)
          vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
        end if
        ii = ii+1
      end do
    end do
    if (.not. logic_g49b) exit
    mm0 = iplprwei
    nn = iplplwei+1
  end do

else               !drl=.true.

  ii = ii+int_dd_drl
  if (logic_g49a) then
    mm0 = iplplwei
    nn = iplprwei
    ildownwei = ildownwei_segdd
    irdownwei = irdownwei_segdd
  else
    mm0 = iplprwei
    nn = iplplwei
    ildownwei = irdownwei_segdd
    irdownwei = ildownwei_segdd
  end if
  do j=1,irdownwei
    nn = nn+1
    mm = mm0
    do i=1,ildownwei
      mm = mm+1
      indexlp = index_lpext(ii)
      !if (indexlp /= 0) then
      valuelp = value_lpext(ii)
      vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      !end if
      indexlp1 = index_lpext1(ii)
      !if (indexlp1 /= 0) then
      valuelp1 = value_lpext1(ii)
      vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      !end if
      ii = ii+1
    end do
  end do
end if

end subroutine inn_ext_dd_loop_unpack_g

subroutine inn_ext_sv_loop_unpack_g(ilw,irw)

use gugaci_global, only: ilsegdownwei, index_lpext, index_lpext1, value_lpext, value_lpext1, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ilw, irw
integer(kind=iwp) :: iij, indexlp, indexlp1, mm, nn
real(kind=wp) :: valuelp, valuelp1

mm = ilw
nn = irw+1
do iij=1,ilsegdownwei
  mm = mm+1
  indexlp = index_lpext(iij)
  !if (indexlp /= 0) then
  valuelp = value_lpext(iij)
  vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
  !end if
  indexlp1 = index_lpext1(iij)
  if (indexlp1 /= 0) then
    valuelp1 = value_lpext1(iij)
    vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
  end if
end do

end subroutine inn_ext_sv_loop_unpack_g

! density matrix formation : vector2=ci*<i|epq,rs|j>*cj and dm1=ci*<i|e
! for norb_act<>0         mg1,mg2,mg3,mg4,mg5:
! idb=1  in dbl_space      ity_up=0-5               0 ,jpad,iwdl,iwdr,
! idb=2  in act_space      ity_up=0-5,itdown=0,3      jph, jpe,iwal,iwa
! idb=3  between dbl and act   ity_up=0-5,itdown=0,3      jpe,iwdl,iwdr,

! this subroutine prodab_1 does the dm1 part, which corresponds to voin
subroutine prodab_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6,mg7)

use gugaci_global, only: log_prod
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr, mg6, mg7
real(kind=wp), intent(in) :: wl

if (log_prod == 1) call prodab_h_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6,mg7)
if (log_prod == 2) call prodab_h0_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6,mg7)

return

end subroutine prodab_1

subroutine prodab_h_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6,mg7)

use gugaci_global, only: dm1tmp, ican_a, ihy, ipae, ipael, iseg_downwei, iw_downwei, iy, jpad, jpad_upwei, jpadl, jphy, loputmp, &
                         nu_ae, vector1
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr, mg6, mg7
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, ipae_, isegdownwei, iwa, iwadl, iwadr, iwal, iwar, iwd, iwdl, iwdown, iwdr, iwe, iwl, iwr, iwupwei, &
                     jpe, jph, jpl, jpy, jwd, jwnu, jwu, lp, lwnu, m, mg67, mm, mp, nn
integer(kind=iwp), allocatable :: lopu(:,:)
integer(kind=iwp), external :: iwalk_ad

select case (idb)
  case default ! (1)
    ! in dbl_space
    jpad = mg2
    iwdl = mg3
    iwdr = mg4
    do ipae_=1,25
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdown = iw_downwei(jpad,ipae)
      if (iwdown == 0) cycle
      lwnu = iseg_downwei(ipae)
      do iwa=0,iwdown-1
        iwadl = iwalk_ad(jpad,ipae,iwa,iwdl)
        iwadr = iwalk_ad(jpad,ipae,iwa,iwdr)
        mm = iwadl
        nn = iwadr
        do m=1,lwnu
          mm = mm+1
          nn = nn+1
          !vector2(mm) = vector2(mm)+vector1(nn)*wl
          !vector2(nn) = vector2(nn)+vector1(mm)*wl
          !vector2(mm) = vector2(mm)+vector1(nn)*wl
          !vector2(nn) = vector2(nn)+vector1(mm)*wl
          mg67 = ican_a(mg7)+mg6
          dm1tmp(mg67) = dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
        end do
      end do
    end do

  case (2)
    ! in act_space
    if (jpad /= jpadl) return
    jph = mg1
    jpl = mg2
    !iwal = mg3
    !iwar = mg4
    iwupwei = jpad_upwei(jpad)
    isegdownwei = iseg_downwei(ipae)
    jpy = jphy(jph)
    in_ = ihy(jpy)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
    do lp=1,mp
      iwl = lopu(1,lp)-1
      iwr = lopu(2,lp)-1
      jpe = lopu(3,lp)
      lwnu = iy(1,jpe)
      do jwu=jpy+1,jpy+in_
        iwal = iwl+ihy(jwu)
        iwar = iwr+ihy(jwu)
        do jwd=1,lwnu
          iwal = iwal+1
          iwar = iwar+1
          do iwd=0,iwupwei-1
            iwadl = iwalk_ad(jpadl,ipael,iwal,iwd)
            iwadr = iwalk_ad(jpad,ipae,iwar,iwd)
            do iwe=1,isegdownwei
              mm = iwadl+iwe
              nn = iwadr+iwe
              !vector2(mm) = vector2(mm)+vector1(nn)*wl
              !vector2(nn) = vector2(nn)+vector1(mm)*wl
              !vector2(mm) = vector2(mm)+vector1(nn)*wl
              !vector2(nn) = vector2(nn)+vector1(mm)*wl
              mg67 = ican_a(mg7)+mg6
              dm1tmp(mg67) = dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
              !write(nf2,'(4i4,4f18.10)') mg6,mg7,mm,nn,wl,vector1(mm),vector1(nn),dm1tmp(mg67)
            end do
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)

  case (3)
    ! between act and dbl
    jpl = mg1
    iwdl = mg2
    iwdr = mg3
    isegdownwei = iseg_downwei(ipae)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
    do lp=1,mp
      iwal = lopu(1,lp)-1
      iwar = lopu(2,lp)-1
      jpe = lopu(3,lp)
      jwnu = iy(1,jpe)
      do ii=1,jwnu
        iwal = iwal+1
        iwar = iwar+1
        mm = iwalk_ad(jpadl,ipael,iwal,iwdl)
        nn = iwalk_ad(jpad,ipae,iwar,iwdr)
        do iwe=1,isegdownwei
          mm = mm+1        ! iwl=iwalk_ad
          nn = nn+1        ! iwl=iwalk_ad
          !vector2(mm) = vector2(mm)+vector1(nn)*wl
          !vector2(nn) = vector2(nn)+vector1(mm)*wl
          !vector2(mm) = vector2(mm)+vector1(nn)*wl
          !vector2(nn) = vector2(nn)+vector1(mm)*wl
          mg67 = ican_a(mg7)+mg6
          dm1tmp(mg67) = dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
          !write(nf2,'(a9,3i8,3f18.10)') '1_dbl_act',mg6,mm,nn,wl,vector1(mm),vector1(nn)
        end do
      end do
    end do
    call mma_deallocate(lopu)

end select

return

end subroutine prodab_h_1

subroutine prodab_h0_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6,mg7)

use gugaci_global, only: dm1tmp, ican_a, ihy, ipae, ipael, iseg_downwei, iw_downwei, iy, jpad, jpad_upwei, jpadl, jphy, loputmp, &
                         nu_ae, vector1
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr, mg6, mg7
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, ipae_, isegdownwei, iwa, iwadl, iwadr, iwal, iwar, iwd, iwdl, iwdown, iwdr, iwe, iwl, iwr, iwupwei, &
                     jpe, jph, jpl, jpy, jwd, jwnu, jwu, lp, lwnu, m, mg67, mm, mp, nn
integer(kind=iwp), allocatable :: lopu(:,:)
integer(kind=iwp), external :: iwalk_ad

select case (idb)
  case default ! (1)
    ! in dbl_space
    jpad = mg2
    iwdl = mg3
    iwdr = mg4
    do ipae_=1,25
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdown = iw_downwei(jpad,ipae)
      if (iwdown == 0) cycle
      lwnu = iseg_downwei(ipae)
      do iwa=0,iwdown-1
        iwadl = iwalk_ad(jpad,ipae,iwa,iwdl)
        iwadr = iwalk_ad(jpad,ipae,iwa,iwdr)
        mm = iwadl
        nn = iwadr
        do m=1,lwnu
          mm = mm+1
          nn = nn+1
          !if (mm > nn) mntmp = mm*(mm-1)/2+nn
          !if (nn > mm) mntmp = nn*(nn-1)/2+mm
          !vector2(mntmp) = vector2(mntmp)+wl
          mg67 = ican_a(mg7)+mg6
          dm1tmp(mg67) = dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
          !if (mntmp == 2) write(u6,*) '  102',vector2(mntmp),wl
        end do
      end do
    end do

  case (2)
    ! in act_space
    if (jpad /= jpadl) return
    jph = mg1
    jpl = mg2
    !iwal = mg3
    !iwar = mg4
    iwupwei = jpad_upwei(jpad)
    isegdownwei = iseg_downwei(ipae)
    jpy = jphy(jph)
    in_ = ihy(jpy)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
    do lp=1,mp
      iwl = lopu(1,lp)-1
      iwr = lopu(2,lp)-1
      jpe = lopu(3,lp)
      lwnu = iy(1,jpe)
      do jwu=jpy+1,jpy+in_
        iwal = iwl+ihy(jwu)
        iwar = iwr+ihy(jwu)
        do jwd=1,lwnu
          iwal = iwal+1
          iwar = iwar+1
          do iwd=0,iwupwei-1
            iwadl = iwalk_ad(jpadl,ipael,iwal,iwd)
            iwadr = iwalk_ad(jpad,ipae,iwar,iwd)
            do iwe=1,isegdownwei
              mm = iwadl+iwe
              nn = iwadr+iwe
              !if (mm > nn) mntmp = mm*(mm-1)/2+nn
              !if (nn > mm) mntmp = nn*(nn-1)/2+mm
              !vector2(mntmp) = vector2(mntmp)+wl
              mg67 = ican_a(mg7)+mg6
              dm1tmp(mg67) = dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
              !if (mntmp == 2) write(u6,*) '  202',vector2(mntmp),wl
            end do
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)

  case (3)
    ! between act and dbl
    jpl = mg1
    iwdl = mg2
    iwdr = mg3
    isegdownwei = iseg_downwei(ipae)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
    do lp=1,mp
      iwal = lopu(1,lp)-1
      iwar = lopu(2,lp)-1
      jpe = lopu(3,lp)
      jwnu = iy(1,jpe)
      do ii=1,jwnu
        iwal = iwal+1
        iwar = iwar+1
        mm = iwalk_ad(jpadl,ipael,iwal,iwdl)
        nn = iwalk_ad(jpad,ipae,iwar,iwdr)
        do iwe=1,isegdownwei
          mm = mm+1             ! iwl=iwalk_ad
          nn = nn+1             ! iwl=iwalk_ad
          !if (mm > nn) mntmp = mm*(mm-1)/2+nn
          !if (nn > mm) mntmp = nn*(nn-1)/2+mm
          !vector2(mntmp) = vector2(mntmp)+wl
          mg67 = ican_a(mg7)+mg6
          dm1tmp(mg67) = dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
          !if (mntmp == 2) write(u6,*) '  302',vector2(mntmp),wl
        end do
      end do
    end do
    call mma_deallocate(lopu)

end select

return

end subroutine prodab_h0_1

!this subroutine prodab_2 does the dm2 part, which corresponds to vint_c
subroutine prodab_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6)

use gugaci_global, only: log_prod
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr, mg6
real(kind=wp), intent(in) :: wl

if (log_prod == 1) call prodab_h_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6)
if (log_prod == 2) call prodab_h0_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6)

return

end subroutine prodab_2

subroutine prodab_h_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6)

use gugaci_global, only: ihy, ipae, ipael, iseg_downwei, iw_downwei, iy, jpad, jpad_upwei, jpadl, jphy, loputmp, nu_ae, vector1, &
                         vector2
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr, mg6
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, ipae_, isegdownwei, iwa, iwadl, iwadr, iwal, iwar, iwd, iwdl, iwdown, iwdr, iwe, iwl, iwr, iwupwei, &
                     jpe, jph, jpl, jpy, jwd, jwnu, jwu, lp, lwnu, m, mm, mp, nn
integer(kind=iwp), allocatable :: lopu(:,:)
integer(kind=iwp), external :: iwalk_ad

select case (idb)
  case default ! (1)
    ! in dbl_space
    jpad = mg2
    iwdl = mg3
    iwdr = mg4
    do ipae_=1,25
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdown = iw_downwei(jpad,ipae)
      if (iwdown == 0) cycle
      lwnu = iseg_downwei(ipae)
      do iwa=0,iwdown-1
        iwadl = iwalk_ad(jpad,ipae,iwa,iwdl)
        iwadr = iwalk_ad(jpad,ipae,iwa,iwdr)
        mm = iwadl
        nn = iwadr
        do m=1,lwnu
          mm = mm+1
          nn = nn+1
          !vector2(mm) = vector2(mm)+vector1(nn)*wl
          !vector2(nn) = vector2(nn)+vector1(mm)*wl
          !vector2(mm) = vector2(mm)+vector1(nn)*wl
          !vector2(nn) = vector2(nn)+vector1(mm)*wl
          vector2(mg6) = vector2(mg6)+vector1(nn)*wl*vector1(mm)
          !if (mg6 == 29) write(nf2,'(i8,2i4,4f18.10)') mg6,mm,nn,vector2(mg6),vector1(mm),wl,vector1(nn)
        end do
      end do
    end do

  case (2)
    ! in act_space
    if (jpad /= jpadl) return
    jph = mg1
    jpl = mg2
    !iwal = mg3
    !iwar = mg4
    iwupwei = jpad_upwei(jpad)
    isegdownwei = iseg_downwei(ipae)
    jpy = jphy(jph)
    in_ = ihy(jpy)

    call mma_allocate(lopu,4,loputmp,label='loputmp')
    call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
    do lp=1,mp
      iwl = lopu(1,lp)-1
      iwr = lopu(2,lp)-1
      jpe = lopu(3,lp)
      lwnu = iy(1,jpe)
      do jwu=jpy+1,jpy+in_
        iwal = iwl+ihy(jwu)
        iwar = iwr+ihy(jwu)
        do jwd=1,lwnu
          iwal = iwal+1
          iwar = iwar+1
          do iwd=0,iwupwei-1
            iwadl = iwalk_ad(jpadl,ipael,iwal,iwd)
            iwadr = iwalk_ad(jpad,ipae,iwar,iwd)
            do iwe=1,isegdownwei
              mm = iwadl+iwe
              nn = iwadr+iwe
              !vector2(mm) = vector2(mm)+vector1(nn)*wl
              !vector2(nn) = vector2(nn)+vector1(mm)*wl
              !vector2(mm) = vector2(mm)+vector1(nn)*wl
              !vector2(nn) = vector2(nn)+vector1(mm)*wl
              vector2(mg6) = vector2(mg6)+vector1(nn)*wl*vector1(mm)
              !if (mg6 == 15) write(nf2,'(2i4,4f18.10)') mm,nn,wl,vector1(mm),vector1(nn),vector2(mg6)
              !write(nf2,'(a3,2i4,i8,2f18.10)') 'act',mm,nn,mg6,vector1(mm),vector1(nn)
            end do
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)

  case (3)
    ! between act and dbl
    jpl = mg1
    iwdl = mg2
    iwdr = mg3
    isegdownwei = iseg_downwei(ipae)

    call mma_allocate(lopu,4,loputmp,label='loputmp')
    call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
    do lp=1,mp
      iwal = lopu(1,lp)-1
      iwar = lopu(2,lp)-1
      jpe = lopu(3,lp)
      jwnu = iy(1,jpe)
      do ii=1,jwnu
        iwal = iwal+1
        iwar = iwar+1
        mm = iwalk_ad(jpadl,ipael,iwal,iwdl)
        nn = iwalk_ad(jpad,ipae,iwar,iwdr)
        do iwe=1,isegdownwei
          mm = mm+1             ! iwl=iwalk_ad
          nn = nn+1             ! iwl=iwalk_ad
          !vector2(mm) = vector2(mm)+vector1(nn)*wl
          !vector2(nn) = vector2(nn)+vector1(mm)*wl
          !vector2(mm) = vector2(mm)+vector1(nn)*wl
          !vector2(nn) = vector2(nn)+vector1(mm)*wl
          vector2(mg6) = vector2(mg6)+vector1(nn)*wl*vector1(mm)
        end do
      end do
    end do
    call mma_deallocate(lopu)

end select

return

end subroutine prodab_h_2

subroutine prodab_h0_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6)

use gugaci_global, only: ihy, ipae, ipael, iseg_downwei, iw_downwei, iy, jpad, jpad_upwei, jpadl, jphy, loputmp, nu_ae, vector1, &
                         vector2
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr, mg6
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, ipae_, isegdownwei, iwa, iwadl, iwadr, iwal, iwar, iwd, iwdl, iwdown, iwdr, iwe, iwl, iwr, iwupwei, &
                     jpe, jph, jpl, jpy, jwd, jwnu, jwu, lp, lwnu, m, mm, mntmp, mp, nn
integer(kind=iwp), allocatable :: lopu(:,:)
integer(kind=iwp), external :: iwalk_ad

select case (idb)
  case default ! (1)
    ! in dbl_space
    jpad = mg2
    iwdl = mg3
    iwdr = mg4
    mntmp = 0
    do ipae_=1,25
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdown = iw_downwei(jpad,ipae)
      if (iwdown == 0) cycle
      lwnu = iseg_downwei(ipae)
      do iwa=0,iwdown-1
        iwadl = iwalk_ad(jpad,ipae,iwa,iwdl)
        iwadr = iwalk_ad(jpad,ipae,iwa,iwdr)
        mm = iwadl
        nn = iwadr
        do m=1,lwnu
          mm = mm+1
          nn = nn+1
          if (mm > nn) then
            mntmp = mm*(mm-1)/2+nn
          else
            mntmp = nn*(nn-1)/2+mm
          end if
          !vector2(mntmp) = vector2(mntmp)+wl
          vector2(mg6) = vector2(mg6)+vector1(mntmp)*wl*vector1(mntmp)

          !if (mntmp == 2) write(u6,*) '  102',vector2(mntmp),wl
        end do
      end do
    end do

  case (2)
    ! in act_space
    if (jpad /= jpadl) return
    jph = mg1
    jpl = mg2
    !iwal = mg3
    !iwar = mg4
    iwupwei = jpad_upwei(jpad)
    isegdownwei = iseg_downwei(ipae)
    jpy = jphy(jph)
    in_ = ihy(jpy)

    call mma_allocate(lopu,4,loputmp,label='loputmp')
    call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
    do lp=1,mp
      iwl = lopu(1,lp)-1
      iwr = lopu(2,lp)-1
      jpe = lopu(3,lp)
      lwnu = iy(1,jpe)
      do jwu=jpy+1,jpy+in_
        iwal = iwl+ihy(jwu)
        iwar = iwr+ihy(jwu)
        do jwd=1,lwnu
          iwal = iwal+1
          iwar = iwar+1
          do iwd=0,iwupwei-1
            iwadl = iwalk_ad(jpadl,ipael,iwal,iwd)
            iwadr = iwalk_ad(jpad,ipae,iwar,iwd)
            do iwe=1,isegdownwei
              mm = iwadl+iwe
              nn = iwadr+iwe
              if (mm > nn) then
                mntmp = mm*(mm-1)/2+nn
              else
                mntmp = nn*(nn-1)/2+mm
              end if
              !vector2(mntmp) = vector2(mntmp)+wl
              vector2(mg6) = vector2(mg6)+vector1(mntmp)*wl*vector1(mntmp)

              !if (mntmp == 2) write(u6,*) '  202',vector2(mntmp),wl
            end do
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)

  case (3)
    ! between act and dbl
    jpl = mg1
    iwdl = mg2
    iwdr = mg3
    isegdownwei = iseg_downwei(ipae)

    call mma_allocate(lopu,4,loputmp,label='loputmp')
    call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
    do lp=1,mp
      iwal = lopu(1,lp)-1
      iwar = lopu(2,lp)-1
      jpe = lopu(3,lp)
      jwnu = iy(1,jpe)
      do ii=1,jwnu
        iwal = iwal+1
        iwar = iwar+1
        mm = iwalk_ad(jpadl,ipael,iwal,iwdl)
        nn = iwalk_ad(jpad,ipae,iwar,iwdr)
        do iwe=1,isegdownwei
          mm = mm+1             ! iwl=iwalk_ad
          nn = nn+1             ! iwl=iwalk_ad
          if (mm > nn) then
            mntmp = mm*(mm-1)/2+nn
          else
            mntmp = nn*(nn-1)/2+mm
          end if
          !vector2(mntmp) = vector2(mntmp)+wl
          vector2(mg6) = vector2(mg6)+vector1(mntmp)*wl*vector1(mntmp)

          !if (mntmp == 2) write(u6,*) '  302',vector2(mntmp),wl
        end do
      end do
    end do
    call mma_deallocate(lopu)

end select

return

end subroutine prodab_h0_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ComputeCoulombIntermediates(Timing,nD,ip_DBlocks,
     &                                                    ip_V,ip_CNorm)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Compute Coulomb intermediates
C
C              V(J) = sum_uv C(uv,J)*D(uv)
C
C              using LDF fitting coefficients.
C              If ip_CNorm>0 on entry, Frobenius norms of the fitting
C              coefficients are computed as a byproduct, stored as:
C              Work(ip_CNorm-1+4*(AB-1)+1)
C                  =sum_uAvBJ sqrt[C(uAvB,J)**2]       {all J}
C              Work(ip_CNorm-1+4*(AB-1)+2)
C                  =sum_uAvBJA sqrt[C(uAvB,JA)**2]     {J on A}
C              Work(ip_CNorm-1+4*(AB-1)+3)
C                  =sum_uAvBJB sqrt[C(uAvB,JB)**2]     {J on B}
C              Work(ip_CNorm-1+4*(AB-1)+4)
C                  =sum_uAvBJAB sqrt[C(uAvB,JAB)**2]   {J on AB (2CF)}
C
C     FOR BLOCKED VERSION: Call LDF_ComputeCoulombIntermediates0
C
      Implicit None
      Logical Timing
      Integer nD
      Integer ip_DBlocks(nD)
      Integer ip_V(nD)
      Integer ip_CNorm
#if defined (_MOLCAS_MPP_)
#include "para_info.fh"
#endif
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*31 SecNam
      Parameter (SecNam='LDF_ComputeCoulombIntermediates')

      Logical  Rsv_Tsk
      External Rsv_Tsk

      Integer  LDF_nBas_Atom, LDF_nBasAux_Atom
      Integer  LDF_nBasAux_Pair_wLD, LDF_nAtom
      External LDF_nBas_Atom, LDF_nBasAux_Atom
      External LDF_nBasAux_Pair_wLD, LDF_nAtom

      real*8 ddot_
      external ddot_

      Logical doNorm

      Real*8 tC1, tC2
      Real*8 tW1, tW2

      Integer TaskListID
      Integer iD
      Integer ip_C, l_C
      Integer iAtomPair
      Integer iAtom, jAtom, nAtom
      Integer nuv, M
      Integer ipD, ipV, ipC

      Integer i, j
      Integer AP_Atoms
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      If (Timing) Call CWTIme(tC1,tW1)

      ! Initialize V arrays
      Do iD=1,nD
         Call LDF_ZeroAuxBasVector(ip_V(iD))
      End Do

      ! Allocate array for storing coefficients
      l_C=0
      Do iAtomPair=1,NumberOfAtomPairs
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         nuv=LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
         M=LDF_nBasAux_Pair_wLD(iAtomPair)
         l_C=max(l_C,nuv*M)
      End Do
      Call GetMem('LDFCBlk','Allo','Real',ip_C,l_C)

      ! compute norm?
      doNorm=ip_CNorm.gt.0
#if defined (_MOLCAS_MPP_)
      ! Init norm array
      If (nProcs.gt.1 .and. Is_Real_Par()) Then
         If (doNorm) Then
            Call Cho_dZero(Work(ip_CNorm),4*NumberOfAtomPairs)
         End If
      End If
#endif

      ! Compute V
      nAtom=LDF_nAtom()
      Call Init_Tsk(TaskListID,NumberOfAtomPairs)
      Do While (Rsv_Tsk(TaskListID,iAtomPair))
         Call LDF_CIO_ReadC_wLD(iAtomPair,Work(ip_C),l_C)
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         nuv=LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
         ipC=ip_C
         M=LDF_nBasAux_Atom(iAtom)
         If (doNorm) Then
            Work(ip_CNorm+4*(iAtomPair-1))
     &                  =sqrt(dDot_(nuv*LDF_nBasAux_Pair_wLD(iAtomPair),
     &                                      Work(ip_C),1,Work(ip_C),1))
            Work(ip_CNorm+4*(iAtomPair-1)+1)
     &                       =sqrt(dDot_(nuv*M,Work(ipC),1,Work(ipC),1))
         End If
         Do iD=1,nD
            ipD=iWork(ip_DBlocks(iD)-1+iAtomPair)
            ipV=iWork(ip_V(iD)-1+iAtom)
            Call dGeMV_('T',nuv,M,
     &                 1.0d0,Work(ipC),nuv,
     &                 Work(ipD),1,1.0d0,Work(ipV),1)
         End Do
         If (jAtom.ne.iAtom) Then
            ipC=ipC+nuv*M
            M=LDF_nBasAux_Atom(jAtom)
            If (doNorm) Then
               Work(ip_CNorm+4*(iAtomPair-1)+2)
     &                       =sqrt(dDot_(nuv*M,Work(ipC),1,Work(ipC),1))
            End If
            Do iD=1,nD
               ipD=iWork(ip_DBlocks(iD)-1+iAtomPair)
               ipV=iWork(ip_V(iD)-1+jAtom)
               Call dGeMV_('T',nuv,M,
     &                    1.0d0,Work(ipC),nuv,
     &                    Work(ipD),1,1.0d0,Work(ipV),1)
            End Do
         Else
            If (doNorm) Then
               Work(ip_CNorm+4*(iAtomPair-1)+2)
     &                                 =Work(ip_CNorm+4*(iAtomPair-1)+1)
            End If
         End If
         If (AP_2CFunctions(1,iAtomPair).gt.0) Then
            ipC=ipC+nuv*M
            M=AP_2CFunctions(1,iAtomPair)
            If (doNorm) Then
               Work(ip_CNorm+4*(iAtomPair-1)+3)
     &                       =sqrt(dDot_(nuv*M,Work(ipC),1,Work(ipC),1))
            End If
            Do iD=1,nD
               ipD=iWork(ip_DBlocks(iD)-1+iAtomPair)
               ipV=iWork(ip_V(iD)-1+nAtom+iAtomPair)
               Call dGeMV_('T',nuv,M,
     &                    1.0d0,Work(ipC),nuv,
     &                    Work(ipD),1,1.0d0,Work(ipV),1)
            End Do
         Else
            If (doNorm) Then
               Work(ip_CNorm+4*(iAtomPair-1)+3)=0.0d0
            End If
         End If
      End Do
      Call Free_Tsk(TaskListID)
      If (Timing) Then
         Call CWTIme(tC2,tW2)
         Write(6,'(A,2(1X,F12.2),A)')
     &   'Time spent computing Coulomb (V) intermediates:   ',
     &   tC2-tC1,tW2-tW1,' seconds'
      End If

      ! Deallocation
      Call GetMem('LDFCBlk','Free','Real',ip_C,l_C)

#if defined (_MOLCAS_MPP_)
      ! Get complete V and norm on all nodes
      If (nProcs.gt.1 .and. Is_Real_Par()) Then
         If (Timing) Call CWTime(tC1,tW1)
         Do iD=1,nD
            Call LDF_P_AddAuxBasVector(ip_V(iD))
         End Do
         If (doNorm) Then
            Call GAdGOp(Work(ip_CNorm),4*NumberOfAtomPairs,'+')
         End If
         If (Timing) Then
            Call CWTime(tC2,tW2)
            Write(6,'(A,2(1X,F12.2),A)')
     &      'Parallel overhead for Coulomb (V) intermediates:  ',
     &      tC2-tC1,tW2-tW1,' seconds'
         End If
      End If
#endif

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_ComputeCoulombIntermediates0(nD,
     &                                            ip_DBlocks,ip_VBlocks)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Compute Coulomb intermediates
C
C              V(J) = sum_uv C(uv,J)*D(uv)
C
C              using LDF fitting coefficients.
C
C     BLOCKED VERSION
C
      Implicit None
      Integer nD
      Integer ip_DBlocks(nD)
      Integer ip_VBlocks(nD)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Logical  Rsv_Tsk
      External Rsv_Tsk

      Integer TaskListID
      Integer iAtomPair
      Integer iAtom, jAtom
      Integer ip_C, l_C
      Integer iD
      Integer ipV, ipD
      Integer nuv, M

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

#if defined (_MOLCAS_MPP_)
      ! Initialize V arrays
      Do iD=1,nD
         Call LDF_ZeroBlockVector(ip_VBlocks(iD))
      End Do
#endif

      ! Allocate array for storing coefficients
      l_C=0
      Do iAtomPair=1,NumberOfAtomPairs
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         nuv=LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
         M=LDF_nBasAux_Pair(iAtomPair)
         l_C=max(l_C,nuv*M)
      End Do
      Call GetMem('LDFCBlk','Allo','Real',ip_C,l_C)

      ! Compute atom pair blocks of V
      Call Init_Tsk(TaskListID,NumberOfAtomPairs)
      Do While (Rsv_Tsk(TaskListID,iAtomPair))
         ! Get dimensions
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         nuv=LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
         M=LDF_nBasAux_Pair(iAtomPair)
         ! Read coefficients for this atom pair
         Call LDF_CIO_ReadC(iAtomPair,Work(ip_C),l_C)
         ! Compute V for this atom pair and for each density
         Do iD=1,nD
            ipD=iWork(ip_DBlocks(iD)-1+iAtomPair)
            ipV=iWork(ip_VBlocks(iD)-1+iAtomPair)
            Call dGeMV_('T',nuv,M,
     &                 1.0d0,Work(ip_C),nuv,
     &                 Work(ipD),1,0.0d0,Work(ipV),1)
         End Do
      End Do
      Call Free_Tsk(TaskListID)

      ! Deallocation
      Call GetMem('LDFCBlk','Free','Real',ip_C,l_C)

#if defined (_MOLCAS_MPP_)
      ! Get complete V on all nodes
      Do iD=1,nD
         Call LDF_P_AddBlockVector(ip_VBlocks(iD))
      End Do
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

subroutine RHSOD_D(IVEC)

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use SUPERINDEX, only: KTU, MAREL, MIA, MIREL, MTREL, MTU
use CHOVEC_IO, only: ChoVec_Read, ChoVec_Size, NVTOT_CHOSYM
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB
#else
use fake_GA, only: GA_Arrays
#endif
use caspt2_global, only: FIMO, iPrGlb
use caspt2_module, only: NACTEL, NASH, NASHT, NASUP, NIAES, NISH, NISUP, NORB, NSSH, NSYM, NTUES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: IA, IAABS, IAEND, IAEND1, IAEND2, IAJ, IAJTOT, IASTA, IASTA1, IASTA2, IATOT, iCASE, IDX, IFIMOES, IIEND, &
                     IISTA, IJ, IJABS, IOAJ, IOAV, IOBRA1(8,8), IOBRA2(8,8), IOFFAJ, IOFFAV, IOFFTJ, IOFFTV, IOKET1(8,8), &
                     IOKET2(8,8), IOTJ, IOTV, ISYA, ISYJ, ISYM, ISYT, ISYV, IT, ITABS, ITV, IUABS, IUU, IV, IVABS, lg_W, MW, NAS, &
                     NAS1, NBRABUF1, NBRABUF2, NFIMOES(8), NIS, NKETBUF1, NKETBUF2, NV, NW
real(kind=wp) :: ACTINV, AJTV, AVTJ, FAJ, ONEADD
real(kind=wp), allocatable :: BRABUF1(:), BRABUF2(:), KETBUF1(:), KETBUF2(:)
real(kind=wp), external :: DDot_

if (iPrGlb >= DEBUG) write(u6,*) 'RHS on demand: case D'

!***********************************************************************
! Case D (5,6):
! D1(tv,aj)=(aj,tv) + FIMO(a,j)*Kron(t,v)/NACTEL
! D2(tv,aj)=(tj,av)
!***********************************************************************

!***********************************************************************
!SVC: read in all the cholesky vectors (need all symmetries)
!***********************************************************************
call CHOVEC_SIZE(4,NBRABUF1,IOBRA1)
call CHOVEC_SIZE(2,NKETBUF1,IOKET1)

call mma_allocate(BRABUF1,NBRABUF1,LABEL='BRABUF1')
call mma_allocate(KETBUF1,NKETBUF1,LABEL='KETBUF1')

call CHOVEC_READ(4,BRABUF1,NBRABUF1)
call CHOVEC_READ(2,KETBUF1,NKETBUF1)

call CHOVEC_SIZE(3,NBRABUF2,IOBRA2)
call CHOVEC_SIZE(1,NKETBUF2,IOKET2)

call mma_allocate(BRABUF2,NBRABUF2,LABEL='BRABUF2')
call mma_allocate(KETBUF2,NKETBUF2,LABEL='KETBUF2')

call CHOVEC_READ(3,BRABUF2,NBRABUF2)
call CHOVEC_READ(1,KETBUF2,NKETBUF2)

iCASE = 5
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
! set up FIMO access
ACTINV = One/real(max(1,NACTEL),kind=wp)
IFIMOES = 0
do ISYM=1,NSYM
  NFIMOES(ISYM) = IFIMOES
  IFIMOES = IFIMOES+nTri_Elem(NORB(ISYM))
end do

do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  ! cases D1, D2 share the RHS along the tu superindex
  NAS1 = NAS/2
  IASTA1 = IASTA
  IAEND1 = IAEND/2
  IASTA2 = IAEND1+1
  IAEND2 = IAEND

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  do IAJ=IISTA,IIEND
    IAJTOT = IAJ+NIAES(ISYM)
    IJABS = MIA(1,IAJTOT)
    IAABS = MIA(2,IAJTOT)
    IA = MAREL(1,IAABS)
    ISYA = MAREL(2,IAABS)
    IJ = MIREL(1,IJABS)
    ISYJ = MIREL(2,IJABS)
    do ITV=IASTA1,IAEND1 ! these are always all elements
      ITABS = MTU(1,ITV+NTUES(ISYM))
      IVABS = MTU(2,ITV+NTUES(ISYM))
      IT = MTREL(1,ITABS)
      ISYT = MTREL(2,ITABS)
      IV = MTREL(1,IVABS)
      ISYV = MTREL(2,IVABS)
      ! compute integral (aj,tv)
      NV = NVTOT_CHOSYM(Mul(ISYA,ISYJ))
      IOAJ = IA-1+NSSH(ISYA)*(IJ-1)
      IOTV = IT-1+NASH(ISYT)*(IV-1)
      IOFFAJ = 1+IOBRA1(ISYA,ISYJ)+NV*IOAJ
      IOFFTV = 1+IOKET1(ISYT,ISYV)+NV*IOTV
      AJTV = DDOT_(NV,BRABUF1(IOFFAJ),1,KETBUF1(IOFFTV),1)

      ! D1(tv,aj)=(aj,tv) + FIMO(a,j)*Kron(t,v)/NACTEL
      ! integrals only
      IDX = ITV+NAS*(IAJ-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = AJTV
#     else
      GA_Arrays(lg_w)%A(IDX) = AJTV
#     endif
    end do
    ! now, dress with FIMO(a,j), only if T==V, so ISYT==ISYV, so if ISYM==1
    if (ISYM == 1) then
      IATOT = IA+NISH(ISYA)+NASH(ISYA)
      FAJ = FIMO(NFIMOES(ISYA)+iTri(IATOT,IJ))
      ONEADD = FAJ*ACTINV
      do IUABS=1,NASHT
        IUU = KTU(IUABS,IUABS)
        IDX = IUU+NAS*(IAJ-IISTA)
#       ifdef _MOLCAS_MPP_
        DBL_MB(MW+IDX-1) = DBL_MB(MW+IDX-1)+ONEADD
#       else
        GA_Arrays(lg_w)%A(IDX) = GA_Arrays(lg_w)%A(IDX)+ONEADD
#       endif
      end do
    end if
    do ITV=IASTA2,IAEND2 ! these are always all elements
      ITABS = MTU(1,ITV-NAS1+NTUES(ISYM))
      IVABS = MTU(2,ITV-NAS1+NTUES(ISYM))
      IT = MTREL(1,ITABS)
      ISYT = MTREL(2,ITABS)
      IV = MTREL(1,IVABS)
      ISYV = MTREL(2,IVABS)
      ! compute integral (av,tj)
      NV = NVTOT_CHOSYM(Mul(ISYA,ISYV))
      IOAV = IA-1+NSSH(ISYA)*(IV-1)
      IOTJ = IT-1+NASH(ISYT)*(IJ-1)
      IOFFAV = 1+IOBRA2(ISYA,ISYV)+NV*IOAV
      IOFFTJ = 1+IOKET2(ISYT,ISYJ)+NV*IOTJ
      AVTJ = DDOT_(NV,BRABUF2(IOFFAV),1,KETBUF2(IOFFTJ),1)

      ! D2(tv,aj)=(av,tj) + FIMO(a,j)*Kron(t,v)/NACTEL
      IDX = ITV+NAS*(IAJ-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = AVTJ
#     else
      GA_Arrays(lg_w)%A(IDX) = AVTJ
#     endif
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)

end do
!***********************************************************************

call mma_deallocate(BRABUF1)
call mma_deallocate(KETBUF1)

call mma_deallocate(BRABUF2)
call mma_deallocate(KETBUF2)

!***********************************************************************

end subroutine RHSOD_D

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Quater_globals

use Definitions, only: wp, iwp

implicit none
private

! debug
logical(kind=iwp) :: debug
! options
logical(kind=iwp) :: translate, rotate
! geoms
integer(kind=iwp), parameter :: MAXGEOMS = 100
integer(kind=iwp) :: ngeoms, XYZ1(3), XYZ2(3)
type geoitem
  integer(kind=iwp) :: nat
  real(kind=wp), allocatable :: geo(:,:)
  character(len=20) :: title
  character(len=20), allocatable :: geolbl(:)
end type geoitem
type(geoitem) :: list(MAXGEOMS)
! rotation
logical(kind=iwp) :: matrixSet
real(kind=wp) :: RotMatrix(3,3)

public :: debug
public :: translate, rotate
public :: ngeoms, list, XYZ1, XYZ2
public :: matrixSet, RotMatrix

end module Quater_globals

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PROPER (PROP,ISTATE,JSTATE,TDMZZ,WDMZZ)
      use rassi_global_arrays, only : JBNUM
      use RASSI_AUX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='PROPER')
#include "Molcas.fh"
#include "cntrl.fh"
#include "rassi.fh"
#include "symmul.fh"
#include "Files.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      DIMENSION TDMZZ(NTDMZZ),WDMZZ(NTDMZZ)
      DIMENSION IOFF(8)
      CHARACTER*8 LABEL
      REAL*8 PROP(NSTATE,NSTATE,NPROP)
      Save iDiskSav !(For ToFile)
      SAVE ICALL
      DATA ICALL /0/
      Real*8, Allocatable:: SCR(:,:)

C COMBINED SYMMETRY OF STATES:
      JOB1=JBNUM(ISTATE)
      JOB2=JBNUM(JSTATE)
      LSYM1=IRREP(JOB1)
      LSYM2=IRREP(JOB2)
      ISY12=MUL(LSYM1,LSYM2)
C THE SYMMETRY CHECK MASK:
      MASK=2**(ISY12-1)
C ALLOCATE A BUFFER FOR READING ONE-ELECTRON INTEGRALS
      NIP=4+(NBST*(NBST+1))/2
      CALL GETMEM('IP    ','ALLO','REAL',LIP,NIP)
C FIRST SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS OF TDMSCR
      Call mk_IOFF(IOFF,nSYM,NBASF,ISY12)
C CALCULATE THE SYMMETRIC AND ANTISYMMETRIC FOLDED TRANS D MATRICES
C AND SIMILAR WE-REDUCED SPIN DENSITY MATRICES
      NSCR=(NBST*(NBST+1))/2
      Call mma_allocate(SCR,nSCR,4,LABEL='SCR')
      SCR(:,:)=0.0D0
      Call MK_TWDM(nSym,TDMZZ,WDMZZ,nTDMZZ,SCR,nSCR,iOFF,NBASF,ISY12)
*
C AT THIS POINT, THE SYMMETRICALLY AND ANTISYMMETRICALLY FOLDED
C DENSITY MATRICES, AND WE-REDUCED SPIN DENSITY MATRICES, HAVE BEEN
C CALCULATED BEGINNING IN SCR.
C LOOP OVER ALL REQUIRED ONE-ELECTRON OPERATORS:
C
C-------------------------------------------
CTL2004-start
C-------------------------------------------
      IF (NONA.AND.(ISTATE.EQ.MAX(NONA_ISTATE,NONA_ISTATE))
     &        .AND.(JSTATE.EQ.MIN(NONA_ISTATE,NONA_JSTATE))) THEN
C
C IF NONADIABATIC COUPLINGS ARE REQUIRED LET'S COMPUTE THEM RIGHT NOW!
C
         CALL COMP_NAC(ISTATE, JSTATE, SCR, 4*nSCR, ISY12, IOFF, LCI1)
      END IF
C WE CONTINUE WITH THE NORMAL CALCULATION OF PROPERTIES...
C-------------------------------------------
CTL2004-end
C-------------------------------------------
*If requested by user, put SCR in an unformatted file for later
*use by another program. (A.Ohrn)
      If(ToFile) then
        Call DaName(LuToM,FnToM)
        If(iCall.eq.0) then  !Make room for table-of-contents
          iDisk=0
          Call ICOPY(nState*(nState+1)/2,[-1],0,TocM,1)
          Call iDaFile(LuToM,1,TocM,nState*(nstate+1)/2,iDisk)
          TocM(1)=iDisk
          iDiskSav=iDisk
          iCall=1
        Endif
        If (iState.lt.jState) Then
*
*          For the rest of the code to work this can not be violated.
*
           Write (6,*) 'Proper: iState.lt.jState'
           Call Abend()
        End If
        i=iState
        j=jState
        indCall=i*(i-1)/2+j  !Which call this is
        ToCM(indCall)=iDiskSav
        ind=indCall+1
        iDisk=iDiskSav
*       Write (*,*) 'IndCall,iDisk=',IndCall,iDisk
        Call dDaFile(LuToM,1,SCR,4*nSCR,iDisk) !The THING.
        iDiskSav=iDisk  !Save diskaddress.
        iDisk=0
        Call iDaFile(LuToM,1,TocM,nState*(nState+1)/2,iDisk)
                            !Put table of contents.
        Call DaClos(LuToM)
      Endif
*End of ToFile
*     Write (*,*) 'ISTATE,JSTATE=',ISTATE,JSTATE
      DO IPROP=1,NPROP
        PROP(ISTATE,JSTATE,IPROP)=0.0D00
        LABEL=PNAME(IPROP)

        CALL UPCASE(LABEL)

c If the user wants the ASD term, it is the same as
c the EF2 term without the nuclear contribution
        IF(LABEL(1:3).EQ.'ASD') THEN
          LABEL(1:3) = 'EF2'
          !write(6,*)"EF2---->ASD Here"
        END IF
        IF(LABEL(1:4).EQ.'TMOM') CYCLE

        IF(LABEL(1:4).EQ.'PSOP') THEN
          LABEL(1:4) = 'PSOI'
        !write(6,*)"PSOI---->PSOP Here"
        END IF

        IF(LABEL(1:6).EQ.'DMP   ') THEN
          LABEL(1:6) = 'DMS  1'

        END IF

        ITYPE=0
        IF(PTYPE(IPROP).EQ.'HERMSING') ITYPE=1
        IF(PTYPE(IPROP).EQ.'ANTISING') ITYPE=2
        IF(PTYPE(IPROP).EQ.'HERMTRIP') ITYPE=3
        IF(PTYPE(IPROP).EQ.'ANTITRIP') ITYPE=4
        IF(ITYPE.EQ.0) THEN
          WRITE(6,*)'RASSI/PROPER internal error.'
          WRITE(6,*)'Erroneous property type.'
          WRITE(6,*)'PTYPE(IPROP)=',PTYPE(IPROP)
          CALL ABEND()
        END IF
*
        Call MK_PROP(PROP,IPROP,ISTATE,JSTATE,LABEL,ITYPE,
     &               WORK(LIP),NIP,SCR,NSCR,MASK,ISY12,IOFF)
*
      END DO
      Call mma_deallocate(SCR)
      CALL GETMEM('      ','FREE','REAL',LIP,NIP)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_GetLQ(QVec,l_QVec,LstQSP,nQSP)
C
C     Purpose: extract elements corresponding to qualified columns from
C              the Cholesky vectors in buffer and/or on disk.
C
      use ChoVecBuf, only: nVec_in_Buf
      Implicit None
      Integer l_QVec, nQSP
      Real*8, Target::  QVec(l_Qvec)
      Integer LstQSP(nQSP)
#include "cholesky.fh"

      Character*9 SecNam
      Parameter (SecNam = 'Cho_GetLQ')

      Integer iV1(8), nV(8)
      Integer nTot, iSym
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      SubRoutine Cho_VecBuf_GetLQ(QVec,l_QVec)
      Integer l_QVec
      Real*8, Target::  QVec(l_QVec)
      End SubRoutine Cho_VecBuf_GetLQ
      End Interface
*                                                                      *
************************************************************************
*                                                                      *

C     Check input.
C     ------------

      If (nQSP .lt. 1) Return
      nTot = NumCho(1)
      Do iSym = 2,nSym
         nTot = nTot + NumCho(iSym)
      End Do
      If (nTot .lt. 1) Return

      nTot = nQual(1)
      Do iSym = 2,nSym
         nTot = nTot + nQual(iSym)
      End Do
      If (nTot .lt. 1) Return

C     Extract from vectors in buffer.
C     -------------------------------

      Call Cho_VecBuf_GetLQ(QVec,l_QVec)

C     Extract from vectors on disk.
C     -----------------------------

      Do iSym = 1,nSym
         iV1(iSym) = nVec_in_Buf(iSym) + 1
         nV(iSym) = NumCho(iSym) - nVec_in_Buf(iSym)
      End Do
      Call Cho_VecDsk_GetLQ(QVec,l_QVec,LstQSP,nQSP,iV1,nV,nSym)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
*     Compute the difference with the previous gradient
*
      Subroutine dGrd()
      Implicit None
#include "mxdm.fh"
#include "real.fh"
#include "infscf.fh"
#include "infso.fh"
#include "stdalloc.fh"
#include "WrkSpc.fh"
#include "file.fh"
#include "llists.fh"
      Integer nD,jpgrd,inode
      Real*8, Dimension(:,:), Allocatable:: Scr
      Integer, External :: LstPtr
      nD=iUHF+1
      Call mma_allocate(Scr,nOV,nD,Label='Scr')
      jpgrd=LstPtr(LuGrd,iter,LLGrad)
      Call GetNod(iter-1,LLGrad,inode)
      If (inode.eq.0) Then
         Write (6,*) 'inode.eq.0'
         Call Abend()
      End If
      Call iVPtr(LuGrd,Scr,nOV*nD,inode)
      Call DaXpY_(nOV*nD,-One,Work(jpgrd),1,Scr,1)
      Call DScal_(nOV*nD,-One,Scr,1)
      Call PutVec(Scr,nOV*nD,LudGd,iter-1,MemRsv,'NOOP',LLdGrd)
      Call mma_deallocate(Scr)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine setb (wrk,wrksize,
     & mapda,mapdb,factor)
c
c     this routine do
c     B = factor . A
c
c     mapda  - direct map of A (I)
c     mapdb  - direct map of B (I)
c     factor - numerical factor (I)
c
c     mediate B must have defined maps, and their must be
c     of identicat type as those for A. If they are not defined,
c     use grc0 before setb
c
c     N.B. this routine should be done using matrix operations

#include "wrk.fh"
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       real*8 factor
c
c     help variables
c
       integer possa0,possb0,length,nhelp
c
c
c1    def the length of the mediate
       nhelp=mapda(0,5)
       length=mapda(nhelp,1)+mapda(nhelp,2)-mapda(1,1)
       if (length.eq.0) return
c
c2    def initial possitions
       possa0=mapda(1,1)
       possb0=mapdb(1,1)
c
c3    set B=f.A
       do 100 nhelp=0,length-1
       wrk(possb0+nhelp)=factor*wrk(possa0+nhelp)
 100    continue
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mktauhelp1(t2,t11,t12,dima,dimb,dimi,dimj,fact)
! this routine does:
! t2(a,b,i,j) = t2(a,b,i,j) + fact [T11(a,i).T12(b,j)]
!
! t2      - T2 matrix (I/O)
! t11     - T1 amplitudes corresponding to spin ia (I)
! t12     - T1 amplitudes corresponding to spin jb (I)
! dima    - 1 dimension of T2 (I)
! dimb    - 2 dimension of T2 (I)
! dimi    - 3 dimension of T2 (I)
! dimj    - 4 dimension of T2 (I)
! fact    - numerical factor (I)
!
! N.B. symi must be syma and symj must be symb

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimi, dimj
real(kind=wp), intent(inout) :: t2(dima,dimb,dimi,dimj)
real(kind=wp), intent(in) :: t11(dima,dimi), t12(dimb,dimj), fact
integer(kind=iwp) :: b, i, j

do j=1,dimj
  do i=1,dimi
    do b=1,dimb
      t2(:,b,i,j) = t2(:,b,i,j)+fact*(t11(:,i)*t12(b,j))
    end do
  end do
end do

return

end subroutine mktauhelp1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DBLOCK(D)
! RASSCF program version IBM-3090: SX section
!
! Purpose: To symmetry-block a full matrix d over the active orbital
!          the result is overlaid on the input matrix.
!
! ********** IBM-3090 release 88 10 10 **********

use rasscf_global, only: ITRI
use general_data, only: NASH, NSYM
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: D(*)
integer(kind=iwp) :: IA, ISYM, ITU, NA, NAT, NAU, NTU

IA = NASH(1)
NTU = ITRI(IA+1)
do ISYM=2,NSYM
  NA = NASH(ISYM)
  if (NA == 0) cycle
  do NAT=1,NA
    do NAU=1,NAT
      NTU = NTU+1
      ITU = ITRI(NAT+IA)+NAU+IA
      D(NTU) = D(ITU)
    end do
  end do
  IA = IA+NASH(ISYM)
end do

end subroutine DBLOCK

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
        subroutine finalize (length,operator,stimes,ttimes,t)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 13.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer length,stimes(maxsnumber),ttimes(maxsnumber),k,pos,idum
      character*(maxlength) operator
      character*(4) t(maxsnumber)
      integer dkh_char2int
1000  continue
      pos=0
      pos=index(operator(1:length),'[PVP]')
      if (pos.gt.0) then
        operator(pos:pos)='Y'
        do 100 k=pos+1,length-4
          operator(k:k)=operator(k+4:k+4)
 100    continue
        operator(length-3:length)='    '
        length=length-4
        goto 1000
      endif
1100  continue
      pos=0
      pos=index(operator(1:length),'[PXP]')
      if (pos.gt.0) then
        operator(pos:pos)='K'
        do 110 k=pos+1,length-4
          operator(k:k)=operator(k+4:k+4)
 110    continue
        operator(length-3:length)='    '
        length=length-4
        goto 1100
      endif
1500  continue
      pos=0
      pos=index(operator(1:length),'PVP')
      if (pos.gt.0) then
        operator(pos:pos)='D'
        do 150 k=pos+1,length-2
          operator(k:k)=operator(k+2:k+2)
 150    continue
        operator(length-1:length)='  '
        length=length-2
        goto 1500
      endif
1510  continue
      pos=0
      pos=index(operator(1:length),'PXP')
      if (pos.gt.0) then
        operator(pos:pos)='J'
        do 151 k=pos+1,length-2
          operator(k:k)=operator(k+2:k+2)
 151    continue
        operator(length-1:length)='  '
        length=length-2
        goto 1510
      endif
 500  continue
      pos=0
      pos=index(operator(1:length),'PS')
      if (pos.gt.0) then
        idum=dkh_char2int(3,operator(pos+2:pos+4))
        if (operator(pos+5:pos+5).ne.'P') then
          write (stdout,2003)
2003      format (2X,'ERROR in SR "finalize" while substituting ',
     *            'PSxxxP structure.',//2X,'STOP.',/2X)
          CALL Abend
        endif
        ttimes(idum)=ttimes(idum)+1
        stimes(idum)=stimes(idum)-1
        operator(pos:pos+3)=t(idum)
        do 10 k=pos+4,length-2
          operator(k:k)=operator(k+2:k+2)
  10    continue
        operator(length-1:length)='  '
        length=length-2
        goto 500
      endif
2000  continue
      pos=0
      pos=index(operator(1:length),'[V]')
      if (pos.gt.0) then
        operator(pos:pos)='N'
        do 200 k=pos+1,length-2
          operator(k:k)=operator(k+2:k+2)
 200    continue
        operator(length-1:length)='  '
        length=length-2
        goto 2000
      endif
2010  continue
      pos=0
      pos=index(operator(1:length),'[X]')
      if (pos.gt.0) then
        operator(pos:pos)='I'
        do 210 k=pos+1,length-2
          operator(k:k)=operator(k+2:k+2)
 210    continue
        operator(length-1:length)='  '
        length=length-2
        goto 2010
      endif
2500  continue
      pos=0
      pos=index(operator(1:length),'PE01P')
      if (pos.gt.0) then
        operator(pos:pos)='G'
        do 250 k=pos+1,length-4
          operator(k:k)=operator(k+4:k+4)
 250    continue
        operator(length-3:length)='    '
        length=length-4
        goto 2500
      endif
2520  continue
      pos=0
      pos=index(operator(1:length),'PCE0P')
      if (pos.gt.0) then
        operator(pos:pos)='M'
        do 254 k=pos+1,length-4
          operator(k:k)=operator(k+4:k+4)
 254    continue
        operator(length-3:length)='    '
        length=length-4
        goto 2520
      endif
3000  continue
      pos=0
      pos=index(operator(1:length),'E01')
      if (pos.gt.0) then
        operator(pos:pos)='F'
        do 300 k=pos+1,length-2
          operator(k:k)=operator(k+2:k+2)
 300    continue
        operator(length-1:length)='  '
        length=length-2
        goto 3000
      endif
3040  continue
      pos=0
      pos=index(operator(1:length),'CE0')
      if (pos.gt.0) then
        operator(pos:pos)='L'
        do 330 k=pos+1,length-2
          operator(k:k)=operator(k+2:k+2)
 330    continue
        operator(length-1:length)='  '
        length=length-2
        goto 3040
      endif
3500  continue
      pos=0
      pos=index(operator(1:length),'PP')
      if (pos.gt.0) then
        operator(pos:pos)='Z'
        do 350 k=pos+1,length-1
          operator(k:k)=operator(k+1:k+1)
 350    continue
        operator(length:length)=' '
        length=length-1
        goto 3500
      endif
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DistMemo3v3jk (NvGrp,maxdim,
     c        PossV1,PossV2,PossV3,PossV4,
     c        PossH1,PossH2,PossH3,PossH4,PossH5,
     c        PossK,PossQ,
     c        PossT)

c
c       This routine do:
c       define initial possitions of H,V,XY
c       described in o3v3jk routine
c
c
c       I/O parameter description:
c       NvGrp    - # of groups in a,b,be,ga set (I)
c       maxdim   - maximal dimension of V'
c       Possx    - initial possitinos of arrays (O-all)
c       PossT    - initial and last possition (I/O)
c
c        requirements for o3v3jk:
c        H1 - max {v'o}
c        H2 - max {v'o}
c        H3 - max {v'v'}
c        H4 - max {v'o}
c        H5 - max {v'o}
c        V1 - max {v'ooo, v'v'oo, o2oo}
c        V2 - max {oooo, v'v'oo, v'ooo}
c        V3 - max {v'v'oo}
c        V4 - max {v'ooo}
c        PX - max {v'v'oo}
c        QY - max {v'v'oo}
c
        implicit none
#include "chcc1.fh"
c
        integer NvGrp,maxdim
        integer PossV1,PossV2,PossV3,PossV4
        integer PossH1,PossH2,PossH3,PossH4,PossH5
        integer PossK,PossQ
        integer PossT
c
c       help variables
        integer length
c
c
c1      Q,K (used also as X,Y)
c
        length=no*no*maxdim*maxdim
c
        PossQ=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Q  ',PossQ,length
        end if
        PossK=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM K  ',PossK,length
        end if
c
c2.1    V1 file - max {v'ooo, v'v'oo, o2oo}
c
        length=no*no*maxdim*maxdim
        if (no*maxdim*nc.gt.length) then
          length=no*maxdim*nc
        end if
        if (no*no*no*maxdim.gt.length) then
          length=no*no*no*maxdim
        end if
        if (no*no*no*(no+1)/2.gt.length) then
          length=no*no*no*(no+1)/2
        end if
c
        PossV1=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V1 ',PossV1,length
        end if
c
c2.2    V2 files - max {oooo, v'v'oo, v'ooo}
c
        length=no*no*maxdim*maxdim
        if (no*no*no*maxdim.gt.length) then
          length=no*no*no*maxdim
        end if
        if (no*no*no*no.gt.length) then
          length=no*no*no*no
        end if
c
        PossV2=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V2 ',PossV2,length
        end if
c
c2.3    V3 file - max {v'v'oo}
c
        length=no*no*maxdim*maxdim
        PossV3=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V3 ',PossV3,length
        end if
c
c2.4    V4 file - max {v'ooo}
c
        length=no*no*no*maxdim
        PossV4=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V4 ',PossV4,length
        end if
c
c3      H1,2 files
c
        length=no*maxdim
c
        PossH1=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM H1 ',PossH1,length
        end if
        PossH2=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM H2 ',PossH2,length
        end if
c
c3.2    H3 file
c
        length=maxdim*maxdim
        if (no*maxdim.gt.length) then
          length=no*maxdim
        end if
c
        PossH3=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM H3 ',PossH3,length
        end if
c
c3.3        H4,H5 file
c
        length=no*maxdim
c
        PossH4=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM H4 ',PossH4,length
        end if
        PossH5=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM H5 ',PossH5,length
        end if
c
c
        if (printkey.ge.10) then
        write (6,*) 'PossT ',PossT
        end if
c
        return
c Avoid unused argument warnings
        if (.false.) Call Unused_integer(NvGrp)
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Cho_VecBuf_GetLQ(QVec,l_QVec)
!
! Purpose: extract elements corresponding to qualified diagonals
!          from vectors in buffer.

use Cholesky, only: CHVBUF, iiBstR, ip_CHVBUF_SYM, iQuAB, nnBstR, nQual, nSym, nVec_in_Buf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: l_QVec
real(kind=wp), target, intent(out) :: QVec(l_QVec)
integer(kind=iwp) :: iAB, iE, iQ, iS, iSym, iVec, kOffQ, lCol, lRow, nVecTot(8)
real(kind=wp), pointer :: BVec(:,:), Q(:,:)

! Check if there is any buffer at all.
! ------------------------------------

if (.not. allocated(CHVBUF)) return

! Extract from each symmetry block.
! ---------------------------------

call Cho_P_GetGV(nVecTot,nSym)

kOffQ = 0
do iSym=1,nSym

  lCol = nVec_in_Buf(iSym)
  if (lCol < 1) cycle
  lRow = nnBstR(iSym,2)
  iS = ip_ChVBuf_Sym(iSym)
  iE = iS-1+lRow*lCol
  BVec(1:lRow,1:lCol) => CHVBUF(iS:iE)

  lRow = nQual(iSym)
  if (lRow < 1) cycle
  iS = kOffQ+1
  iE = iS-1+lRow*lCol
  Q(1:lRow,1:lCol) => QVec(iS:iE)

  if (nQual(iSym) > 0) then
    do iVec=1,nVec_in_Buf(iSym)
      do iQ=1,nQual(iSym)
        iAB = iQuAB(iQ,iSym)-iiBstR(iSym,2)
        Q(iQ,iVec) = BVec(iAB,iVec)
      end do
    end do
    kOffQ = kOffQ+nQual(iSym)*nVecTot(iSym)
  end if
end do

nullify(BVec,Q)

end subroutine Cho_VecBuf_GetLQ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE TWOCT(H)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      DIMENSION H(*)
      CALL TWOCT_INTERNAL(H)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE TWOCT_INTERNAL(H)
      USE ISO_C_BINDING
      REAL*8, TARGET :: H(*)
      INTEGER, POINTER :: iH2(:),iH3(:),iH4(:),iH39(:),iH47(:),iH51(:)
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      IF(ISDCI.EQ.0.AND.ICPF.EQ.0.AND.INCPF.EQ.0)GO TO 30
C CPF, ACPF AND SDCI
      IF(ITER.EQ.1)GO TO 25
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL DIAGC_CPF(iH2,H(LW(26)),H(LW(27)))
      NULLIFY(iH2)
      IF(IFIRST.NE.0)GO TO 15
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(51))),iH51,[1])
      CALL ABCI(iH2,iH3,H(LW(26)),H(LW(27)),
     *H(LW(50)),iH51,H(LW(52)),H(LW(53)),H(LW(54)))
      NULLIFY(iH2,iH3,iH51)
15    CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(47))),iH47,[1])
      CALL IJKL_CPF(iH2,iH3,H(LW(26)),H(LW(27)),
     *H(LW(46)),H(LW(47)),iH47,H(LW(31)),H(LW(32)))
      NULLIFY(iH2,iH3,iH47)
      IF(IFIRST.NE.0)GO TO 25
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(4))),iH4,[1])
      CALL ABCD(iH2,iH3,iH4,H(LW(26)),H(LW(27)),
     *H(LW(57)),H(LW(58)),H(LW(59)))
      NULLIFY(iH2,iH3,iH4)
25    CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(39))),iH39,[1])
      CALL FAIBJ_CPF(iH2,iH3,H(LW(26)),H(LW(27)),H(LW(36)),
     *H(LW(37)),H(LW(38)),H(LW(39)),iH39,H(LW(40)),H(LW(41)),
     *H(LW(42)),H(LW(43)),H(LW(31)),H(LW(32)))
      NULLIFY(iH2,iH3,iH39)
      GO TO 50
C     MCPF
30    IF(ITER.EQ.1)GO TO 45
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL MDIAGC(iH2,H(LW(26)),H(LW(27)),H(LW(28)),H(LW(29)),
     *H(LW(31)),IRC(ILIM))
      NULLIFY(iH2)
      IF(IFIRST.NE.0)GO TO 35
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(51))),iH51,[1])
      CALL MABCI(iH2,iH3,H(LW(26)),H(LW(27)),
     *H(LW(50)),iH51,H(LW(52)),H(LW(53)),H(LW(54)),
     *H(LW(28)),H(LW(29)),H(LW(31)),IRC(ILIM))
      NULLIFY(iH2,iH3,iH51)
35    CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(47))),iH47,[1])
      CALL MIJKL(iH2,iH3,H(LW(26)),H(LW(27)),
     *H(LW(46)),H(LW(47)),iH47,H(LW(28)),H(LW(29)),H(LW(31)),
     *H(LW(32)),IRC(ILIM))
      NULLIFY(iH2,iH3,iH47)
      IF(IFIRST.NE.0)GO TO 45
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(4))),iH4,[1])
      CALL MABCD(iH2,iH3,iH4,H(LW(26)),H(LW(27)),
     *H(LW(57)),H(LW(58)),H(LW(59)),H(LW(28)),H(LW(29)),
     *H(LW(31)),IRC(ILIM))
      NULLIFY(iH2,iH3,iH4)
45    CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(39))),iH39,[1])
      CALL MFAIBJ(iH2,iH3,H(LW(26)),H(LW(27)),H(LW(36)),
     *H(LW(37)),H(LW(38)),H(LW(39)),iH39,H(LW(40)),H(LW(41)),
     *H(LW(42)),H(LW(43)),H(LW(28)),H(LW(29)),H(LW(31)),H(LW(32)),
     *IRC(ILIM))
      NULLIFY(iH2,iH3,iH39)
50      Continue
      RETURN
      END SUBROUTINE TWOCT_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

function SumLeg(K_Lap,W,X,Delta)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: SumLeg
integer(kind=iwp), intent(in) :: K_Lap
real(kind=wp), intent(in) :: W(K_Lap), X(K_Lap), Delta
integer(kind=iwp) :: I
real(kind=wp) :: Dum
real(kind=wp), external :: FuncLe

Dum = Zero
do I=1,K_Lap
  Dum = Dum+W(I)*FuncLe(X(I),Delta)
end do
SumLeg = Dum

return

end function SumLeg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine PAM2Mem( &
#                  define _CALLING_
#                  include "mem_interface.fh"
                  )
!***********************************************************************
!  Object: to compute the number of real*8 the kernel routine will     *
!          need for the computation of a matrix element between two    *
!          cartesian Gaussian functions with the total angular momentum*
!          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
!          lr is the order of the operator (this is only used when the *
!          integrals are computed with the Hermite-Gauss quadrature).  *
!                                                                      *
!  Called from: OneEl                                                  *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: nComp

nComp = nTri_Elem1(lr)

nHer = (la+lb+lr+2)/2
Mem = 3*nHer*(la+1)+3*nHer*(lb+1)+3*nHer*(lr+1)+3*(la+1)*(lb+1)*(lr+1)+5+nTri_Elem1(la)*nTri_Elem1(lb)*nComp

return

end subroutine PAM2Mem

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_sort_T_pairs

! Sorting module with a very simple O(N^2) insertion sort
! algorithm or using the average O(NlogN) Quicksort algorithm
!
! Sort array of interaction T-pairs using Quicksort wrt
!     (a) RHS index
!     (b) T-vector component
!     (c) T-vector modulus (ratio)

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_quicksort_wrt_RHS,           &
             fmm_quicksort_wrt_vector,        &
             fmm_quicksort_wrt_ratio

   ! criteria for switching from Quicksort to Insertion-Sort algorithms
   INTEGER(INTK), PARAMETER :: quicksort_CUTOFF = 10

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE insertion_sort_wrt_RHS(arr)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)
      TYPE(T_pair_single) :: tmp
      INTEGER(INTK) :: i, j

      iloop: DO i = 1, SIZE(arr)
         tmp = arr(i)
         DO j = (i-1), 1, -1
            IF (arr(j)%paras%RHS_id > tmp%paras%RHS_id) THEN
               arr(j+1) = arr(j)
            ELSE
               arr(j+1) = tmp
               CYCLE iloop
            END IF
         END DO
         arr(1) = tmp
      END DO iloop

   END SUBROUTINE insertion_sort_wrt_RHS

!-------------------------------------------------------------------------------

   SUBROUTINE RHS_swap_elements(arr,i,j)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),       INTENT(IN)    :: i, j
      TYPE(T_pair_single) :: tmp

      tmp = arr(i)
      arr(i) = arr(j)
      arr(j) = tmp

   END SUBROUTINE RHS_swap_elements

!-------------------------------------------------------------------------------
! Subroutine to return the median of first, last, and centre array elements.
! order these and hide the pivot (median) as the second to last array element
! (acts as a sentinel whilst the last is the largest and put in correct place.)

   FUNCTION RHS_median_of_three(arr,left,right)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),       INTENT(IN)    :: left, right
      INTEGER(INTK) :: RHS_median_of_three
      INTEGER(INTK) :: cntr

      cntr = (left + right)/2

      IF (arr(left)%paras%RHS_id > arr(cntr)%paras%RHS_id)  &
         CALL RHS_swap_elements(arr,left,cntr)
      IF (arr(left)%paras%RHS_id > arr(right)%paras%RHS_id)  &
         CALL RHS_swap_elements(arr,left,right)
      IF (arr(cntr)%paras%RHS_id > arr(right)%paras%RHS_id)  &
         CALL RHS_swap_elements(arr,cntr,right)

      CALL RHS_swap_elements(arr,cntr,right-1_INTK)
      RHS_median_of_three = arr(right-1)%paras%RHS_id

   END FUNCTION RHS_median_of_three

!-------------------------------------------------------------------------------

   RECURSIVE SUBROUTINE fmm_quicksort_wrt_RHS(arr)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)

      INTEGER(INTK) :: left, right
      INTEGER(INTK) :: i,j, pivot

      left = 1
      right = SIZE(arr)

      IF (left + quicksort_CUTOFF > right) THEN
         ! array too small for Quicksort to be efficient, so don't use it
         CALL insertion_sort_wrt_RHS(arr)
         RETURN
      END IF

      pivot = RHS_median_of_three(arr,left,right)
      ! partition array elements about chosen pivot
      i = left
      j = right-2
      DO ! until left, right pointers cross
         ! increment left until large element found
         DO WHILE ( arr(i)%paras%RHS_id < pivot )
            i = i+1
         END DO
         ! increment right until small element found
         DO WHILE ( arr(j)%paras%RHS_id > pivot )
            j = j-1
         END DO
         IF (i < j) THEN
            ! swap items (i,j)
            CALL RHS_swap_elements(arr,i,j)
            ! now increment (i,j) to avoid infinite loop if both = pivot
            i = i+1
            j = j-1
         ELSE
            EXIT
         END IF
      END DO
      ! i is now the position where the pivot should be
      ! swap pivot back to middle of array
      CALL RHS_swap_elements(arr,i,right-1_INTK)

      ! now sort sub-arrays either side of pivot
      CALL fmm_quicksort_wrt_RHS( arr( left:(i-1) ) )
      CALL fmm_quicksort_wrt_RHS( arr( (i+1):right ) )

   END SUBROUTINE fmm_quicksort_wrt_RHS

!-------------------------------------------------------------------------------
! Insertion sort for sorting of T-pair batch wrt 1 component of T-vector
!-----------------------------------------------------------------------

   SUBROUTINE insertion_sort_wrt_vector(arr,xyz)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),       INTENT(IN)    :: xyz

      TYPE(T_pair_single) :: tmp
      INTEGER(INTK) :: i, j

      iloop: DO i = 1, SIZE(arr)
         tmp = arr(i)
         DO j = (i-1), 1, -1
            IF (arr(j)%r_ab(xyz) > tmp%r_ab(xyz)) THEN
               arr(j+1) = arr(j)
            ELSE
               arr(j+1) = tmp
               CYCLE iloop
            END IF
         END DO
         arr(1) = tmp
      END DO iloop

   END SUBROUTINE insertion_sort_wrt_vector

!-------------------------------------------------------------------------------
! Quicksort for sorting of T-pair batch wrt 1 component of T-vector
!------------------------------------------------------------------

   SUBROUTINE vector_swap_elements(arr,i,j)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),       INTENT(IN)    :: i, j
      TYPE(T_pair_single) :: tmp

      tmp = arr(i)
      arr(i) = arr(j)
      arr(j) = tmp

   END SUBROUTINE vector_swap_elements

!-------------------------------------------------------------------------------
! subroutine to return the median of first, last, and centre array elements.
! order these and hide the pivot (median) as the second to last array element
! (acts as a sentinel whilst the last is the largest and put in correct place.)

   FUNCTION vector_median_of_three(arr,left,right,xyz)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),       INTENT(IN)    :: left, right
      INTEGER(INTK),       INTENT(IN)    :: xyz

      REAL(REALK)   :: vector_median_of_three
      INTEGER(INTK) :: cntr

      cntr = (left + right)/2

      IF (arr(left)%r_ab(xyz) > arr(cntr)%r_ab(xyz))  &
         CALL vector_swap_elements(arr,left,cntr)
      IF (arr(left)%r_ab(xyz) > arr(right)%r_ab(xyz))  &
         CALL vector_swap_elements(arr,left,right)
      IF (arr(cntr)%r_ab(xyz) > arr(right)%r_ab(xyz))  &
         CALL vector_swap_elements(arr,cntr,right)

      CALL vector_swap_elements(arr,cntr,right-1_INTK)
      vector_median_of_three = arr(right-1)%r_ab(xyz)

   END FUNCTION vector_median_of_three

!-------------------------------------------------------------------------------

   RECURSIVE SUBROUTINE fmm_quicksort_wrt_vector(arr,xyz)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),       INTENT(IN)    :: xyz

      INTEGER(INTK) :: left, right
      INTEGER(INTK) :: i,j
      REAL(REALK)   :: pivot

      left = 1
      right = SIZE(arr)

      IF (left + quicksort_CUTOFF > right) THEN
         ! array too small for Quicksort to be efficient, so don't use it
         CALL insertion_sort_wrt_vector(arr,xyz)
         RETURN
      END IF

      pivot = vector_median_of_three(arr,left,right,xyz)
      ! partition array elements about chosen pivot
      i = left
      j = right-2
      DO ! until left, right pointers cross
         ! increment left until large element found
         DO WHILE ( arr(i)%r_ab(xyz) < pivot )
            i = i+1
         END DO
         ! increment right until small element found
         DO WHILE ( arr(j)%r_ab(xyz) > pivot )
            j = j-1
         END DO
         IF (i < j) THEN
            ! swap items (i,j)
            CALL vector_swap_elements(arr,i,j)
            ! now increment (i,j) to avoid infinite loop if both = pivot
            i = i+1
            j = j-1
         ELSE
            EXIT
         END IF
      END DO
      ! i is now the position where the pivot should be
      ! swap pivot back to middle of array
      CALL vector_swap_elements(arr,i,right-1_INTK)

      ! now sort sub-arrays either side of pivot
      CALL fmm_quicksort_wrt_vector( arr( left:(i-1) ),xyz )
      CALL fmm_quicksort_wrt_vector( arr( (i+1):right ),xyz )

   END SUBROUTINE fmm_quicksort_wrt_vector

!-------------------------------------------------------------------------------
! Insertion sort for sorting of T-pair batch wrt T-vector modulus (ratio)
!------------------------------------------------------------------------

   SUBROUTINE insertion_sort_wrt_ratio(arr)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)

      TYPE(T_pair_single) :: tmp
      INTEGER(INTK) :: i, j

      iloop: DO i = 1, SIZE(arr)
         tmp = arr(i)
         DO j = (i-1), 1, -1
            IF (arr(j)%paras%ratio > tmp%paras%ratio) THEN
               arr(j+1) = arr(j)
            ELSE
               arr(j+1) = tmp
               CYCLE iloop
            END IF
         END DO
         arr(1) = tmp
      END DO iloop

   END SUBROUTINE insertion_sort_wrt_ratio

!-------------------------------------------------------------------------------
! Quicksort for sorting of T-pair batch wrt T-vector modulus (ratio)
!-------------------------------------------------------------------

   SUBROUTINE ratio_swap_elements(arr,i,j)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),       INTENT(IN)    :: i, j
      TYPE(T_pair_single) :: tmp

      tmp = arr(i)
      arr(i) = arr(j)
      arr(j) = tmp

   END SUBROUTINE ratio_swap_elements

!-------------------------------------------------------------------------------
! subroutine to return the median of first, last, and centre array elements.
! order these and hide the pivot (median) as the second to last array element
! (acts as a sentinel whilst the last is the largest and put in correct place.)

   FUNCTION ratio_median_of_three(arr,left,right)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),       INTENT(IN)    :: left, right

      REAL(REALK)   :: ratio_median_of_three
      INTEGER(INTK) :: cntr

      cntr = (left + right)/2

      IF (arr(left)%paras%ratio > arr(cntr)%paras%ratio)  &
         CALL ratio_swap_elements(arr,left,cntr)
      IF (arr(left)%paras%ratio > arr(right)%paras%ratio)  &
         CALL ratio_swap_elements(arr,left,right)
      IF (arr(cntr)%paras%ratio > arr(right)%paras%ratio)  &
         CALL ratio_swap_elements(arr,cntr,right)

      CALL ratio_swap_elements(arr,cntr,right-1_INTK)
      ratio_median_of_three = arr(right-1)%paras%ratio

   END FUNCTION ratio_median_of_three

!-------------------------------------------------------------------------------

   RECURSIVE SUBROUTINE fmm_quicksort_wrt_ratio(arr)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(INOUT) :: arr(:)

      INTEGER(INTK) :: left, right
      INTEGER(INTK) :: i,j
      REAL(REALK)   :: pivot

      left = 1
      right = SIZE(arr)

      IF (left + quicksort_CUTOFF > right) THEN
         ! array too small for Quicksort to be efficient, so don't use it
         CALL insertion_sort_wrt_ratio(arr)
         RETURN
      END IF

      pivot = ratio_median_of_three(arr,left,right)
      ! partition array elements about chosen pivot
      i = left
      j = right-2
      DO ! until left, right pointers cross
         ! increment left until large element found
         DO WHILE ( arr(i)%paras%ratio < pivot )
            i = i+1
         END DO
         ! increment right until small element found
         DO WHILE ( arr(j)%paras%ratio > pivot )
            j = j-1
         END DO
         IF (i < j) THEN
            ! swap items (i,j)
            CALL ratio_swap_elements(arr,i,j)
            ! now increment (i,j) to avoid infinite loop if both = pivot
            i = i+1
            j = j-1
         ELSE
            EXIT
         END IF
      END DO
      ! i is now the position where the pivot should be
      ! swap pivot back to middle of array
      CALL ratio_swap_elements(arr,i,right-1_INTK)

      ! now sort sub-arrays either side of pivot
      CALL fmm_quicksort_wrt_ratio( arr( left:(i-1) ) )
      CALL fmm_quicksort_wrt_ratio( arr( (i+1):right ) )

   END SUBROUTINE fmm_quicksort_wrt_ratio

!-------------------------------------------------------------------------------

END MODULE fmm_sort_T_pairs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine csf2det_cvb(vec,detvec,isym_loc,iWay)
      use csfbas, only: cts, kdtoc
      implicit real*8 (a-h,o-z)
#include "ciinfo.fh"
#include "rasdim.fh"
#include "rasscf.fh"
#include "WrkSpc.fh"
      dimension vec(*),detvec(*)

      if(iWay.eq.1)then
        if ( nac.eq.0 ) then
          detvec(1)=vec(1)
          return
        endif

        jCopy = 0
        call csdtvc(vec,detvec,iway,work(kdtoc),
     >              cts,isym_loc,jcopy)
      elseif(iWay.eq.2)then
        if ( nac.eq.0 ) then
          vec(1)=detvec(1)
          return
        endif

        jCopy = 0
        call csdtvc(vec,detvec,iway,work(kdtoc),
     >              cts,isym_loc,jcopy)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3_bta_abc(nuga,nugc,kab,kcb,kca,kac,kbc,kc,la,lb,lxa,lxb,lxc,mi,mij,adim,bdim,cdim,N,noab_a,noab_b,lu,iasblock,nga, &
                      ngb,ngc,oehi,oehk,oepa,oepb,oepc,enx,vab,vcb,vca,t1aa,t1ba,t1ab,t1bb,t1ac,t1bc,t3a,t3b,ifvo)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nuga, nugc, adim, bdim, cdim,N, noab_a, noab_b, lu(6), iasblock(5), nga, ngb, ngc
real(kind=wp), intent(_OUT_) :: kab(adim*bdim,N,*), kcb(cdim*bdim,N,*), kca(cdim*adim,N,*), kc(*), la(N*adim,*), lb(N*bdim,*), &
                                lxa(N*adim,*), lxb(N*bdim,*), lxc(N*cdim,*), mi(adim*bdim*cdim,*), mij(*), vab(adim*bdim,*), &
                                vcb(bdim*cdim,*), vca(adim*cdim,*), t3a(*), t3b(*)
real(kind=wp), intent(out) :: kac(cdim*adim,N), kbc(cdim*bdim,N)
real(kind=wp), intent(in) :: oehi(*), oehk(*), oepa(*), oepb(*), oepc(*)
real(kind=wp), intent(inout) :: enx, t1aa(noab_a,*), t1ba(noab_a,*), t1ab(noab_a,*), t1bb(noab_a,*), t1ac(noab_b,*), t1bc(noab_b,*)
logical(kind=iwp), intent(in) :: ifvo
integer(kind=iwp) :: a, ab, b, ba, c, i, ias, iasabi, iasack, iasbck, iascai, iascbi, ij, ik, j, jk, k, ki, kj, nadim, nbdim, &
                     ncdim, ngab_offset, ngac_offset, ngbc_offset, ngca_offset, ngcb_offset, nno_a, nnoab, nuga_offset, nugc_offset
real(kind=wp) :: den, dena, denb, denc, xx, yy

! iasblock(1) > ka,kb,kc   iasblock(2) > la,lb iasblock(3) > lxa,lxc,lxb
!!sumt3 = Zero
nno_a = nTri_Elem(noab_a-1)
nnoab = noab_a*noab_b
nadim = adim*bdim
nbdim = bdim*cdim
ncdim = adim*cdim
nuga_offset = iasblock(1)*nTri_Elem(nuga)
nugc_offset = iasblock(1)*nuga*nugc
ias = iasblock(2)*(nga-1)+1
call multi_readir(la,nno_a*adim*N,lu(2),ias)
ias = iasblock(2)*(ngb-1)+1
call multi_readir(lb,nno_a*bdim*N,lu(2),ias)
ias = iasblock(3)*(nga-1)+1
call multi_readir(lxa,nnoab*adim*N,lu(5),ias)
ias = iasblock(3)*(ngb-1)+1
call multi_readir(lxb,nnoab*bdim*N,lu(5),ias)
ias = iasblock(3)*(ngc-1)+1
call multi_readir(lxc,nnoab*cdim*N,lu(6),ias)

! vvoo ints reading
ngab_offset = iasblock(4)*(nTri_Elem(nga-1)+ngb-1)+1
ias = iasblock(2)*nuga+ngab_offset
call multi_readir(vab,nno_a*nadim,lu(2),ias)
ngca_offset = iasblock(5)*(nugc*(nga-1)+ngc-1)+1
ias = iasblock(2)*nuga+iasblock(4)*nTri_Elem(nuga)+ngca_offset
call multi_readir(vca,nnoab*ncdim,lu(2),ias)
ngcb_offset = iasblock(5)*(nugc*(ngb-1)+ngc-1)+1
ias = iasblock(2)*nuga+iasblock(4)*nTri_Elem(nuga)+ngcb_offset
call multi_readir(vcb,nnoab*nbdim,lu(2),ias)
! end readin vvoo ints

ngab_offset = iasblock(1)*(nTri_Elem(nga-1)+ngb-1)+1
ngac_offset = iasblock(1)*(nuga*(ngc-1)+nga-1)+1
ngbc_offset = iasblock(1)*(nuga*(ngc-1)+ngb-1)+1
ngca_offset = iasblock(1)*(nugc*(nga-1)+ngc-1)+1
ngcb_offset = iasblock(1)*(nugc*(ngb-1)+ngc-1)+1
! saves reading:
do i=1,noab_a
  iasabi = (i-1)*nuga_offset+ngab_offset
  call multi_readir(kab(:,:,i),N*nadim,lu(1),iasabi)
end do
do i=1,noab_a
  iascai = (i-1)*nugc_offset+ngca_offset
  call multi_readir(kca(:,:,i),N*ncdim,lu(3),iascai)
  !mp
  !mp write(u6,*) 'ze tak teraz ju dam',i
  !mp call check_mat(kca(1,1,i),1,N*ncdim)
  !mp
end do
do i=1,noab_a
  iascbi = (i-1)*nugc_offset+ngcb_offset
  call multi_readir(kcb(:,:,i),N*nbdim,lu(3),iascbi)
end do
do k=1,noab_b
  iasbck = (k-1)*nugc_offset+ngbc_offset
  call multi_readir(kbc,N*nbdim,lu(4),iasbck)
  iasack = (k-1)*nugc_offset+ngac_offset
  call multi_readir(kac,N*ncdim,lu(4),iasack)
  ! start calculating prefactors:
  !mp
  do i=1,noab_a
    ik = (k-1)*noab_a+i
    ki = (i-1)*noab_b+k
    !mp
    ! K_ab^ir x L_rc^ik     cba
    call DGEMM_('T','T',cdim,nadim,N,one,lxc(:,ik),N,kab(:,:,i),nadim,zero,mi(:,i),cdim)
    ! K_bc^ir x L_ra^ki          cba
    call DGEMM_('N','N',nbdim,adim,N,one,kcb(:,:,i),nbdim,lxa(:,ki),N,one,mi(:,i),nbdim)
    !mp
    !mp do imm=0,adim*nbdim-1
    !mp   if (abs(mi(1+imm,i)) > 1.0e5_wp) then
    !mp     write(u6,*) 'uz mi dojebane 2',imm+1,i,mi(1+imm,i)
    !mp     stop
    !mp   end if
    !mp end do
    !mp

    ! K_ac^ir x L_rb^ki     cab
    call DGEMM_('N','N',ncdim,bdim,N,one,kca(:,:,i),ncdim,lxb(:,ki),N,zero,t3b,ncdim)
    !mp
    ab = 1
    do a=1,adim
      ba = (a-1)*cdim+1
      do b=1,bdim
        mi(ab:ab+cdim-1,i) = mi(ab:ab+cdim-1,i)-t3b(ba:ba+cdim-1)
        ab = ab+cdim
        ba = ba+ncdim
      end do
    end do
  end do    ! i
  !mp
  ! end prefactors
  ij = 0
  do i=2,noab_a
    ki = (i-1)*noab_b+k
    ik = (k-1)*noab_a+i
    kj = k-noab_b
    jk = (k-1)*noab_a
    do j=1,i-1
      ij = ij+1
      kj = kj+noab_b
      jk = jk+1
      !mp
      ! K_ac^kr x L_rb^ij        bac
      call DGEMM_('T','T',bdim,ncdim,N,-one,lb(:,ij),N,kac,ncdim,zero,t3b,bdim)
      ! K_bc^kr x L_ra^ij        abc
      call DGEMM_('T','T',adim,nbdim,N,one,la(:,ij),N,kbc,nbdim,zero,t3a,adim)
      ! transpose the first two indices
      !mp
      ab = 1
      do c=1,cdim
        ba = (c-1)*nadim+1
        do b=1,bdim
          call daxpy_(adim,One,t3a(ab),1,t3b(ba),bdim)
          ba = ba+1
          ab = ab+adim
        end do
      end do
      ! t3b  bac
      call map2_21_t3(t3b,t3a,nadim,cdim)
      ! cba in t3a
      ! K_ab^ir x L_rc^jk  -K_ab^jr x L_rc^ik
      !call ka(1:N*nadim) = ka(1:N*nadim)-kb(1:N*nadim)
      kc(1:N*nadim) = pack(kab(:,:,i)-kab(:,:,j),.true.)
      mij(1:N*cdim) = lxc(:,jk)+lxc(:,ik)
      call DGEMM_('T','T',cdim,nadim,N,one,mij,N,kc,nadim,one,t3a,cdim)
      ! K_ab^ir x L_rc^jk
      !!call DGEMM_('T','T',cdim,nadim,N,one,lxc(1,jk),N,ka,nadim,one,t3a,cdim)
      ! -K_ab^jr x L_rc^ik
      !!call DGEMM_('T','T',cdim,nadim,N,-one,lxc(1,ik),N,kb,nadim,one,t3a,cdim)

      ! K_bc^ir x L_ra^kj -K_bc^jr x L_ra^ki         cba
      kc(1:N*nbdim) = pack(kcb(:,:,i)-kcb(:,:,j),.true.)
      mij(1:N*adim) = lxa(:,kj)+lxa(:,ki)
      call DGEMM_('N','N',nbdim,adim,N,one,kc,nbdim,mij,N,one,t3a,nbdim)
      ! K_bc^ir x L_ra^kj          cba
      !!call DGEMM_('N','N',nbdim,adim,N,one,ka,nbdim,lxa(1,kj),N,one,t3a,nbdim)
      ! -K_bc^jr x L_ra^ki         cba
      !!call DGEMM_('N','N',nbdim,adim,N,-one,kb,nbdim,lxa(1,ki),N,one,t3a,nbdim)
      ! K_ac^ir x L_rb^kj  -K_ac^jr x L_rb^ki      cab
      kc(1:N*ncdim) = pack(kca(:,:,i)-kca(:,:,j),.true.)
      mij(1:N*bdim) = lxb(:,kj)+lxb(:,ki)
      call DGEMM_('N','N',ncdim,bdim,N,one,kc,ncdim,mij,N,zero,t3b,ncdim)
      ! K_ac^ir x L_rb^kj      cab
      !!call DGEMM_('N','N',ncdim,bdim,N,one,ka,ncdim,lxb(1,kj),N,zero,t3b,ncdim)
      ! -K_ac^jr x L_rb^ki     cab
      !!call DGEMM_('N','N',ncdim,bdim,N,-one,kb,ncdim,lxb(1,ki),N,one,t3b,ncdim)
      !mp
      ab = 1
      do a=1,adim
        ba = (a-1)*cdim+1
        do b=1,bdim
          t3a(ab:ab+cdim-1) = t3a(ab:ab+cdim-1)-t3b(ba:ba+cdim-1)
          ab = ab+cdim
          ba = ba+ncdim
        end do
      end do

      !mp do a=1,adim
      !mp   do b=1,bdim
      !mp     do c=1,cdim
      !mp       ab = c+(b-1)*cdim+(a-1)*bdim*cdim
      !mp       ba = c+(a-1)*cdim+(b-1)*adim*cdim
      !mp       t3a(ab) = t3a(ab)-t3b(ba)
      !mp     end do
      !mp   end do
      !mp end do

      t3a(1:nadim*cdim) = t3a(1:nadim*cdim)-mi(:,i)+mi(:,j)
      den = oehi(i)+oehi(j)+oehk(k)
      ab = 0
      do a=1,adim
        ba = ab+1
        dena = den-oepa(a)
        do b=1,bdim
          denb = dena-oepb(b)
          do c=1,cdim
            denc = denb-oepc(c)
            ab = ab+1
            !mp if ((i == 14) .and. (j == 1) .and. (k == 1)) then
            !mp   write(u6,'(A,3(i5,x),3(f18.10,x))') 'a,b,c, oepa(a), oepb(b), oepc(c)',a,b,c,oepa(a),oepb(b),oepc(c)
            !mp   write(u6,*) 'denc = ',denc
            !mp   write(u6,*) 'ab, t3a(ab) ',ab,t3a(ab)
            !mp end if
            xx = t3a(ab)
            yy = xx/denc
            !!sumt3 = sumt3+xx
            enx = enx+yy*xx
            !mp if ((i == 14) .and. (j == 1) .and. (k == 1)) write(u6,'(A,3(f18.10,x))') 'xx,yy,enx = ',xx,yy,enx
            t3a(ab) = yy
          end do
        end do
        call map2_21_t3(t3a(ba),t3b(ba),cdim,bdim)
      end do
      call DGEMM_('N','T',1,cdim,nadim,one,vab(:,ij),1,t3a,cdim,one,t1ac(k,1),noab_b)
      call DGEMM_('N','N',1,adim,nbdim,-one,vcb(:,kj),1,t3a,nbdim,one,t1aa(i,1),noab_a)
      call DGEMM_('N','N',1,adim,nbdim,one,vcb(:,ki),1,t3a,nbdim,one,t1aa(j,1),noab_a)
      call DGEMM_('N','T',1,bdim,ncdim,-one,vca(:,ki),1,t3b,bdim,one,t1ab(j,1),noab_a)
      call DGEMM_('N','T',1,bdim,ncdim,one,vca(:,kj),1,t3b,bdim,one,t1ab(i,1),noab_a)
      if (ifvo) then
        call DGEMM_('N','T',1,cdim,nadim,one,kab(:,i,j),1,t3a,cdim,one,t1bc(k,1),noab_b)
        call DGEMM_('N','N',1,adim,nbdim,one,kcb(:,k,j),1,t3a,nbdim,one,t1ba(i,1),noab_a)
        call DGEMM_('N','N',1,adim,nbdim,-one,kcb(:,k,i),1,t3a,nbdim,one,t1ba(j,1),noab_a)
        call DGEMM_('N','T',1,bdim,ncdim,one,kca(:,k,i),1,t3b,bdim,one,t1bb(j,1),noab_a)
        call DGEMM_('N','T',1,bdim,ncdim,-one,kca(:,k,j),1,t3b,bdim,one,t1bb(i,1),noab_a)
      end if
      !mp write(u6,'(3(i5,x),f18.10)') i,j,k,enx
    end do !j
  end do !i
end do !k

return

end subroutine t3_bta_abc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DMat_CPCM(iAt,iC,nTs,nS,nAt,fact,Tessera,DerMat,DerTes,DerPunt,DerCentr,iSphe)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iAt, iC, nTs, nS, nAt, iSphe(nTs)
real(kind=wp), intent(in) :: fact, Tessera(4,nTs), DerTes(nTs,nAt,3), DerPunt(nTs,nAt,3,3), DerCentr(nS,nAt,3,3)
real(kind=wp), intent(out) :: DerMat(nTs,nTs)
integer(kind=iwp) :: ITs, JTs, L, LJ
real(kind=wp) :: DIJ, DXIJ, DYIJ, DZIJ, PROD, XIJ, YIJ, ZIJ

! Compute the derivative of the CPCM matrix wrt atom iat, coord. ic

! Loop on tesserae
do ITs=1,NTs
  L = ISPHE(ITs)
  do JTs=1,NTs
    LJ = ISPHE(JTs)
    ! Diagonal elements
    if (ITs == JTs) then
      DerMat(ITs,ITs) = fact*DERTES(ITs,iAt,IC)/(Tessera(4,ITs)*sqrt(Tessera(4,ITs)))
    else
      ! Off diagonal elements
      XIJ = Tessera(1,ITs)-Tessera(1,JTs)
      YIJ = Tessera(2,ITs)-Tessera(2,JTs)
      ZIJ = Tessera(3,ITs)-Tessera(3,JTs)
      DIJ = sqrt(XIJ*XIJ+YIJ*YIJ+ZIJ*ZIJ)
      DXIJ = DERPUNT(ITs,iAt,IC,1)+DERCENTR(L,iAt,IC,1)-DERPUNT(JTs,iAt,IC,1)-DERCENTR(LJ,iAt,IC,1)
      DYIJ = DERPUNT(ITs,iAt,IC,2)+DERCENTR(L,iAt,IC,2)-DERPUNT(JTs,iAt,IC,2)-DERCENTR(LJ,iAt,IC,2)
      DZIJ = DERPUNT(ITs,iAt,IC,3)+DERCENTR(L,iAt,IC,3)-DERPUNT(JTs,iAt,IC,3)-DERCENTR(LJ,iAt,IC,3)
      PROD = (XIJ*DXIJ+YIJ*DYIJ+ZIJ*DZIJ)/DIJ**3
      DerMat(ITs,JTs) = -PROD
    end if
  end do
end do

return

end subroutine DMat_CPCM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MODRHS(IVEC,FIMO,NFIMO)

use Index_Functions, only: iTri, nTri_Elem
use SUPERINDEX, only: KTU, KTUV
use caspt2_module, only: NACTEL, NAES, NASH, NASHT, NASUP, NINDEP, NISH, NISUP, NORB, NSSH, NSYM, NTUES, NTUV, NTUVES
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, NFIMO
real(kind=wp), intent(in) :: FIMO(NFIMO)
integer(kind=iwp) :: IA, IAJ, IATOT, ICASE, IFOFF, IJ, ISYJ, ISYM, ISYT, ISYU, IT, ITABS, ITTOT, IU, IUABS, IUU, IVABS, IW1, IW2, &
                     IWD, IX, IXABS, IXTOT, IYABS, IYYW, IYYWA, lg_A, lg_C, lg_D, NAJ, NAS, NAT, NAX, NIJ, NIS, NIT, NIX, NO, NSJ, &
                     NSX, NWA, NWC, NWD
real(kind=wp) :: ONEADD, rSUM, Val
real(kind=wp), allocatable :: WA(:), WC(:), WD(:)

!**************************************************************
! Case A:
ICASE = 1
IFOFF = 0
do ISYM=1,NSYM
  NAS = NTUV(ISYM)
  NIS = NISH(ISYM)
  NWA = NAS*NIS
  if (NINDEP(ISYM,1)*NWA /= 0) then
    call mma_allocate(WA,NWA,Label='WA')
    call RHS_ALLO(NAS,NIS,lg_A)
    ! Read W from disk:
    call RHS_READ(NAS,NIS,lg_A,ICASE,ISYM,IVEC)
    call RHS_GET(NAS,NIS,lg_A,WA)
    ! Insert one-electron contribution to coupling <A|0>:
    ! WA(tvv,j)=FIMO(t,j)/NACTEL (+two-electron part)
    ISYJ = ISYM
    ISYT = ISYM
    NAT = NASH(ISYT)
    NIT = NISH(ISYT)
    do IT=1,NAT
      ITTOT = NIT+IT
      ITABS = NAES(ISYT)+IT
      do IJ=1,NIT
        Val = FIMO(IFOFF+iTri(ITTOT,IJ))/real(max(1,NACTEL),kind=wp)
        do IVABS=1,NASHT
          IW1 = KTUV(ITABS,IVABS,IVABS)-NTUVES(ISYM)
          IW2 = IJ
          WA(IW1+NAS*(IW2-1)) = WA(IW1+NAS*(IW2-1))+Val
        end do
      end do
    end do
    call RHS_PUT(NAS,NIS,lg_A,WA)
    ! Put W on disk:
    call RHS_SAVE(NAS,NIS,lg_A,ICASE,ISYM,IVEC)
    call RHS_FREE(lg_A)
    call mma_deallocate(WA)

  end if
  ! End of loop over ISYM.
  NO = NORB(ISYM)
  IFOFF = IFOFF+nTri_Elem(NO)
end do

!**************************************************************
! Case C:
ICASE = 4
IFOFF = 0
do ISYM=1,NSYM
  NAS = NTUV(ISYM)
  NIS = NSSH(ISYM)
  NWC = NAS*NIS
  if (NINDEP(ISYM,4)*NWC /= 0) then
    call mma_allocate(WC,NWC,LABEL='WC')
    call RHS_ALLO(NAS,NIS,lg_C)
    ! Read W from disk:
    call RHS_READ(NAS,NIS,lg_C,ICASE,ISYM,IVEC)
    call RHS_GET(NAS,NIS,lg_C,WC)
    ! Insert one-electron contribution to coupling <C|0>:
    ! WC(xuu,a)=(FIMO(a,x)-sum((ay,yx), y=1,NASHT) )/NACTEL (+ two-el part)
    NIX = NISH(ISYM)
    NAX = NASH(ISYM)
    NSX = NSSH(ISYM)
    do IX=1,NAX
      IXTOT = NIX+IX
      IXABS = NAES(ISYM)+IX
      do IA=1,NSX
        IATOT = NIX+NAX+IA
        rSUM = FIMO(IFOFF+iTri(IATOT,IXTOT))
        do IYABS=1,NASHT
          IYYW = KTUV(IYABS,IYABS,IXABS)-NTUVES(ISYM)
          IYYWA = IYYW+NAS*(IA-1)
          rSUM = rSUM-WC(IYYWA)
        end do
        ONEADD = rSUM/real(max(1,NACTEL),kind=wp)
        do IUABS=1,NASHT
          IW1 = KTUV(IXABS,IUABS,IUABS)-NTUVES(ISYM)
          IW2 = IA
          WC(IW1+NAS*(IW2-1)) = WC(IW1+NAS*(IW2-1))+ONEADD
        end do
      end do
    end do
    call RHS_PUT(NAS,NIS,lg_C,WC)
    ! Put W on disk:
    call RHS_SAVE(NAS,NIS,lg_C,ICASE,ISYM,IVEC)
    call RHS_FREE(lg_C)
    call mma_deallocate(WC)

  end if
  ! End of loop over ISYM.
  NO = NORB(ISYM)
  IFOFF = IFOFF+nTri_Elem(NO)
end do

!**************************************************************
! Case D1:
ICASE = 5
ISYM = 1

NAS = NASUP(ISYM,5)
NIS = NISUP(ISYM,5)
NWD = NAS*NIS
if (NINDEP(ISYM,5)*NWD /= 0) then
  call mma_allocate(WD,NWD,LABEL='WD')
  call RHS_ALLO(NAS,NIS,lg_D)
  ! Read W from disk:
  call RHS_READ(NAS,NIS,lg_D,ICASE,ISYM,IVEC)
  call RHS_GET(NAS,NIS,lg_D,WD)

  ! Insert one-electron contribution to coupling <D1|0>:
  ! Compute WD1(vv,aj)=FIMO(a,j)/NACTEL (+ two-el part)
  IFOFF = 0
  IAJ = 0
  do ISYJ=1,NSYM
    NIJ = NISH(ISYJ)
    NAJ = NASH(ISYJ)
    NSJ = NSSH(ISYJ)
    do IA=1,NSJ
      IATOT = NIJ+NAJ+IA
      do IJ=1,NIJ
        ONEADD = FIMO(IFOFF+iTri(IATOT,IJ))/real(max(1,NACTEL),kind=wp)
        IAJ = IAJ+1
        do ISYU=1,NSYM
          do IU=1,NASH(ISYU)
            IUABS = NAES(ISYU)+IU
            IUU = KTU(IUABS,IUABS)-NTUES(ISYM)
            IWD = IUU+NAS*(IAJ-1)
            WD(IWD) = WD(IWD)+ONEADD
          end do
        end do
      end do
    end do
    NO = NORB(ISYJ)
    IFOFF = IFOFF+nTri_Elem(NO)
  end do
  call RHS_PUT(NAS,NIS,lg_D,WD)

  ! Put W on disk:
  call RHS_SAVE(NAS,NIS,lg_D,ICASE,ISYM,IVEC)
  call RHS_FREE(lg_D)
  call mma_deallocate(WD)
end if

end subroutine MODRHS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AID(INTSYM,INDX,C,DMO,A,B,FK)

use mrci_global, only: ENP, IRC, IREST, IROW, ITER, LN, LSYM, LUSYMB, NSM, NSYM, NVIR, NVIRP, SQ2, SQ2INV
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: INTSYM(*), INDX(*)
real(kind=wp), intent(inout) :: C(*), DMO(*), FK(*)
real(kind=wp), intent(_OUT_) :: A(*), B(*)
integer(kind=iwp) :: IADD10, ICHK, ICP1, ICP2, IFT, II, IJOLD, ILEN, IND, INDA, INDB, INK, INMY, INNY, IPOB(9), ITYP, MYL, MYSYM, &
                     NA, NA1, NA2, NAK, NK, NSK, NVM, NYL, NYSYM
real(kind=wp) :: COPI
integer(kind=iwp), external :: JSUNP

! SCRATCH AREAS: A(),B() AND FK().
call CSCALE(INDX,INTSYM,C,SQ2)
ICHK = 0
IJOLD = 0
NK = 0
NSK = 1
IADD10 = IAD10(9)
! READ A COP BUFFER
do
  call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
  call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
  ILEN = ICOP1(nCOP+1)
  if (ILEN == 0) cycle
  if (ILEN < 0) exit
  ! LOOP THROUGH THE COP BUFFER:
  do II=1,ILEN
    IND = ICOP1(II)
    if (ICHK == 0) then
      if (IND == 0) then
        ! IND=0 INDICATES END OF THIS BLOCK OF COUPLING COEFFS.
        ICHK = 1
      else
        if (INK == 0) cycle
        ITYP = ibits(IND,0,6)
        ICP2 = ibits(IND,6,13)
        ICP1 = ibits(IND,19,13)
        if (ITYP > 1) then
          if ((ITER == 1) .and. (IREST == 0)) cycle
          INDA = IRC(1)+ICP1
          INDB = IRC(ITYP)+ICP2
          INMY = INDX(INDA)+1
          INNY = INDX(INDB)+1
          MYSYM = JSUNP(INTSYM,INDA)
          NYSYM = MUL(MYSYM,NSK)
          MYL = MUL(MYSYM,LSYM)
          NYL = MUL(NYSYM,LSYM)
          IFT = 0
          if (ITYP == 2) IFT = 1
          call IPO(IPOB,NVIR,MUL,NSYM,NYL,IFT)
          NVM = NVIR(MYL)
          B(1:INK) = Zero
          COPI = COP(II)/ENP
          if (NYL /= 1) then
            if (NSK > MYL) then
              call FMMM(C(INMY),C(INNY+IPOB(NSK)),B,1,INK,NVM)
            else
              call FMMM(C(INNY+IPOB(MYL)),C(INMY),B,INK,1,NVM)
              if (IFT == 1) COPI = -COPI
            end if
          else
            if (IFT == 0) call SQUAR(C(INNY+IPOB(MYL)),A,NVM)
            if (IFT == 1) call SQUARN(C(INNY+IPOB(MYL)),A,NVM)
            call FMMM(C(INMY),A,B,1,INK,NVM)
          end if
          FK(1:INK) = FK(1:INK)+COPI*B(1:INK)
        else
          INDA = ICP1
          INDB = IRC(1)+ICP2
          INNY = INDX(INDB)+1
          COPI = C(INDA)*COP(II)/ENP
          FK(1:INK) = FK(1:INK)+COPI*C(INNY:INNY+INK-1)
        end if
      end if
    else
      ! ICHK=1 INDICATES BEGINNING OF A NEW BLOCK OF COUPLING COEFFS.
      ICHK = 0
      if (IJOLD /= 0) then
        ! PUT AWAY FK INTO DMO
        NA1 = NVIRP(NSK)+1
        NA2 = NVIRP(NSK)+NVIR(NSK)
        INK = 0
        if (NA2 < NA1) cycle
        do NA=NA1,NA2
          INK = INK+1
          NAK = IROW(LN+NA)+NK
          DMO(NAK) = FK(INK)
        end do
      end if
      NK = IND
      IJOLD = NK
      NSK = NSM(NK)
      ! PICK OUT ELEMENTS FROM DMO AND PUT INTO FK:
      NA1 = NVIRP(NSK)+1
      NA2 = NVIRP(NSK)+NVIR(NSK)
      INK = 0
      if (NA2 < NA1) cycle
      do NA=NA1,NA2
        INK = INK+1
        NAK = IROW(LN+NA)+NK
        FK(INK) = DMO(NAK)
      end do
    end if
  end do
end do
NA1 = NVIRP(NSK)+1
NA2 = NVIRP(NSK)+NVIR(NSK)
INK = 0
do NA=NA1,NA2
  INK = INK+1
  NAK = IROW(LN+NA)+NK
  DMO(NAK) = FK(INK)
end do
call CSCALE(INDX,INTSYM,C,SQ2INV)

return

end subroutine AID

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Per Ake Malmqvist                                *
*               2019, Stefano Battaglia                                *
************************************************************************
      subroutine xdwinit(Heff,H0,U0)

      use output_caspt2, only:iPrGlb,usual,verbose,debug,insane
      use definitions, only:wp,iwp,u6

      implicit none

#include "rasdim.fh"
#include "caspt2.fh"
#include "pt2_guga.fh"
#include "WrkSpc.fh"

      Real(kind=wp),intent(inout) :: Heff(Nstate,Nstate)
      Real(kind=wp),intent(inout) :: H0(Nstate,Nstate)
      Real(kind=wp),intent(inout) :: U0(Nstate,Nstate)

      Real(kind=wp) :: wgt,FIJ

      Integer(kind=iwp) :: LCIRef,LCIXMS,LDAVE,iState,iDisk,I,J


* Allocate memory for CI array state averaged 1-RDM
      call getmem('LCI','ALLO','REAL',LCI,NCONF)
      call getmem('LDAVE','ALLO','REAL',LDAVE,NDREF)
      call dcopy_(NDREF,[0.0_wp],0,WORK(LDAVE),1)

* Set the weight for the density averaging
      wgt = 1.0_wp/real(Nstate,kind=wp)

* Loop over all states to compute the state-average density matrix
      do Istate=1,Nstate

        if (ISCF.NE.0) then
* Special case for a single Slater determinant
          WORK(LCI)=1.0_wp
        else
* Get the CI array
          call loadCI(WORK(LCI), Istate)
        end if

* Compute 1-particle active density matrix GAMMA1
        call POLY1(WORK(LCI))

* Restructure GAMMA1 as DREF array
        call GETDREF(WORK(LDREF))

* Average the density
        call DAXPY_(NDREF,wgt,WORK(LDREF),1,WORK(LDAVE),1)

      end do

      if (IPRGLB.GE.INSANE) then
        write(u6,*)' State-average 1-RDM'
        do I=1,NASHT
          write(u6,'(1x,14f10.6)')(WORK(LDAVE+(I*(I-1))/2+J-1),J=1,I)
        end do
        write(u6,*)
      end if

* Copy the state-average 1-RDM into LDREF and release memory
* for both the CI array and LDAVE
      call dcopy_(NDREF,WORK(LDAVE),1,WORK(LDREF),1)
      call getmem('LCI','FREE','REAL',LCI,NCONF)
      call getmem('LDAVE','FREE','REAL',LDAVE,NDREF)

* Load CASSCF MO coefficients
      call getmem('LCMO','ALLO','REAL',LCMO,NCMO)
      iDisk=IAD1M(1)
      call ddafile(LUONEM,2,WORK(LCMO),NCMO,iDisk)

* Build the state-average Fock matrix in MO basis
      if (IfChol) then
* INTCTL2 uses TraCho2 and FMatCho to get matrices in MO basis.
        call INTCTL2(.false.)
      else
* INTCTL1 uses TRAONE and FOCK_RPT2 to get the matrices in MO basis.
        call INTCTL1(WORK(LCMO))
      end if

* Loop again over all states to compute H0 in the model space
* Loop over ket functions
      do J=1,Nstate
* Loop over bra functions
        do I=1,Nstate
* Compute matrix element <I|F|J> and store it into H0
          FIJ = 0.0_wp
          call FOPAB(WORK(LFIFA),I,J,FIJ)
          H0(I,J) = FIJ
        end do
      end do
* End of loop over states

      if (IPRGLB.ge.USUAL) then
        write(u6,*)
        write(u6,*)' H0 in the original model space basis:'
        call prettyprint(H0,Nstate,Nstate)
      end if

* Diagonalize H0 in the model space
      call eigen(H0,U0,Nstate)

* Transform the Fock matrix in the new basis
      call transmat(H0,U0,Nstate)
        if (IPRGLB.ge.USUAL) then
          write(u6,*)' H0 eigenvectors:'
          call prettyprint(U0,Nstate,Nstate)
        end if
        if (IPRGLB.ge.DEBUG) then
          write(u6,*)' H0 in the rotated model space basis:'
          call prettyprint(H0,Nstate,Nstate)
        end if

* As well as Heff
      call transmat(Heff,U0,Nstate)
      if (IPRGLB.ge.VERBOSE) then
        write(u6,*)' Heff[1] in the rotated model space basis:'
        call prettyprint(Heff,Nstate,Nstate)
      end if

* Mix the CI arrays according to the H0 eigenvectors. Assume we can
* put all the original ones in memory, but put the resulting vectors
* one by one in a buffer.
        if (IPRGLB.ge.VERBOSE) then
          write(u6,'(A)')' The CASSCF states are now rotated'//
     &                  ' according to the H0 eigenvectors'
          write(u6,*)
        end if

      call getmem('CIREF','ALLO','REAL',LCIref,Nstate*Nconf)
* Load the CI arrays into memory
      do I=1,Nstate
        call loadCI(WORK(LCIref+Nconf*(I-1)),I)
      end do

      call getmem('CIXMS','ALLO','REAL',LCIXMS,Nconf)
      do J=1,Nstate
* Transform the states
        call dgemm_('N','N',Nconf,1,Nstate,
     &              1.0_wp,WORK(LCIREF),Nconf,U0(:,J),Nstate,
     &              0.0_wp,WORK(LCIXMS),Nconf)

* Write the rotated CI coefficients back into LUCIEX and REPLACE the
* original unrotated CASSCF states. Note that the original states
* are still available in the JobIph file
        call writeCI(WORK(LCIXMS),J)

        if (IPRGLB.ge.VERBOSE) then
          write(u6,'(1x,a,i3)')
     &    ' The CI coefficients of rotated model state nr. ',MSTATE(J)
          call PRWF_CP2(STSYM,NCONF,WORK(LCIXMS),CITHR)
        end if
      end do

* Release all memory
      call getmem('CIREF','FREE','REAL',LCIREF,Nstate*NCONF)
      call getmem('CIXMS','FREE','REAL',LCIXMS,NCONF)
      call getmem('LCMO','FREE','REAL',LCMO,NCMO)


      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DecideOnDirect(CanDoDirect,FoundTwoEls,DoDirect,DoCholesky)
!-----------------------------------------------------------------------
!                                                                      -
!  All modules using two-electron integrals should call this routine   -
!  to decide whether to do the calculation integral-direct.            -
!                                                                      -
!  On input:     CanDoDirect : Direct capability of module (T/F).      -
!                FoundTwoEls : Two-electron integral file available.   -
!                                                                      -
!  On exit:      DoDirect:     Do calculation integral-direct.         -
!                DoCholesky:   Do Cholesky calculation                 -
!                                                                      -
!-----------------------------------------------------------------------

use Definitions, only: iwp, u6

implicit none
logical(kind=iwp), intent(in) :: CanDoDirect, FoundTwoEls
logical(kind=iwp), intent(out) :: DoDirect, DoCholesky
integer(kind=iwp) :: iOptSeward
logical(kind=iwp) :: AlwaysDirect, isDirect, Expert, NeverDirect

! Read option variable set in Seward
call Get_iScalar('System BitSwitch',iOptSeward)

call DecideOnCholesky(DoCholesky)
if (DoCholesky) then
  DoDirect = btest(iOptSeward,13)
  return
end if

isDirect = btest(iOptSeward,0)
Expert = btest(iOptSeward,1)
AlwaysDirect = isDirect .and. (.not. Expert)
NeverDirect = (.not. isDirect) .and. (.not. Expert)

if (AlwaysDirect) then
  if (.not. CanDoDirect) then
    write(u6,'(A)') ' Error, cannot do integral-direct calculation!'
    write(u6,'(A)') ' Turn off DIRECT option in SEWARD input.'
    call Abend()
  else
    DoDirect = .true.
  end if
else if ((.not. FoundTwoEls) .and. (NeverDirect .or. (.not. CanDoDirect))) then
  ! No integrals, no direct calculation (allowed) - we have to crash!
  write(u6,'(2A)') ' Two-electron integral file was not found!'
  if (CanDoDirect) write(u6,'(A)') ' Try keyword DIRECT in SEWARD.'
  call Abend()
else if (.not. FoundTwoEls) then
  DoDirect = .true.
else
  DoDirect = .false.
end if

return

end subroutine DecideOnDirect

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,2000, Roland Lindh                                *
!***********************************************************************

subroutine CmbnMP_GIAO(Rnxyz,nZeta,la,lb,lr,Zeta,rKappa,rFinal,nComp,nB,RAB,C)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!                                                                      *
!             Modified to GIAO 1st derivatives by R. Lindh in Tokyo,   *
!              Japan, January 2000.                                    *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Half, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, lr, nComp, nB
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la,0:lb,0:lr+1), Zeta(nZeta), rKappa(nZeta), RAB(3), C(3)
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nComp,nB)
integer(kind=iwp) :: iBx, iBy, iBz, iComp, ipa, ipb, ix, ix_(3,2), ixa, ixb, iy, iya, iyaMax, iyb, iybMax, iz, iza, izb, iZeta
real(kind=wp) :: Fact, temp, tempy, tempz

do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        ! Combine multipole moment integrals

        do iBx=1,3
          iBy = iBx+1
          if (iBy > 3) iBy = iBy-3
          iBz = iBy+1
          if (iBz > 3) iBz = iBz-3
          ix_(:,:) = 0
          ix_(iBz,:) = 1
          iComp = 0
          do ix=lr,0,-1
            do iy=lr-ix,0,-1
              iz = lr-ix-iy
              iComp = iComp+1
              do iZeta=1,nZeta
                Fact = rKappa(iZeta)*Zeta(iZeta)**(-OneHalf)
                temp = Rnxyz(iZeta,1,ixa,ixb,ix)*Rnxyz(iZeta,2,iya,iyb,iy)*Rnxyz(iZeta,3,iza,izb,iz)
                tempz = Rnxyz(iZeta,1,ixa,ixb,ix+ix_(1,1))*Rnxyz(iZeta,2,iya,iyb,iy+ix_(2,1))*Rnxyz(iZeta,3,iza,izb,iz+ix_(3,1))
                tempy = Rnxyz(iZeta,1,ixa,ixb,ix+ix_(1,2))*Rnxyz(iZeta,2,iya,iyb,iy+ix_(2,2))*Rnxyz(iZeta,3,iza,izb,iz+ix_(3,2))

                ! The term has only an imaginary component

                rFinal(iZeta,ipa,ipb,iComp,iBx) = Half*Fact*(RAB(iBy)*(Tempz+C(iBz)*Temp)-RAB(iBz)*(Tempy+C(iBy)*Temp))
              end do
            end do
          end do
        end do  ! iB

      end do
    end do
  end do
end do

return

end subroutine CmbnMP_GIAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION NSXFSM(NSMOB,MXPOBS,NO1PS,NO2PS,ISXSM,ADSXA,
     &ISYM,IPRNT)
*
* Number of single excitations of symmetry ISXSM
*
* ISYM = 0 : All symmetry allowed excitations
* ISYM = 1 : Only excitations a+iaj with I.ge.J
* ISYM =-1 : Only excitations a+iaj with I.gt.J
      INTEGER ADSXA(MXPOBS,2*MXPOBS)
      INTEGER NO1PS(*),NO2PS(*)
*
      MSXFSM = 0
C?    WRITE(6,*) ' NSMOB ',NSMOB
      DO 100 IO1SM = 1,NSMOB
        IO2SM = ADSXA(IO1SM,ISXSM)
C?      WRITE(6,*) ' IO1SM,IO2SM',IO1SM,IO2SM
        IF(ISYM.EQ.0.OR.IO1SM.GT.IO2SM) THEN
          MSXFSM = MSXFSM + NO1PS(IO1SM)*NO2PS(IO2SM)
        ELSE IF( ISYM.EQ. 1 .AND. IO1SM.EQ.IO2SM) THEN
          MSXFSM = MSXFSM + NO1PS(IO1SM)*(NO1PS(IO1SM)+1)/2
        ELSE IF( ISYM.EQ.-1 .AND. IO1SM.EQ.IO2SM) THEN
          MSXFSM = MSXFSM + NO1PS(IO1SM)*(NO1PS(IO1SM)-1)/2
        END IF
  100 CONTINUE
*
      NSXFSM = MSXFSM
*
      NTEST = 0
      NTEST = MAX(NTEST,IPRNT)

      IF(NTEST.NE.0) THEN
        WRITE(6,*)
     &  ' Number of single excitations of symmetry ',ISXSM,',',NSXFSM
      END IF
*
      RETURN
      END
* Output

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine inn_ext_ss_drl_loop_unpack_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(*,*) ' ss_test 2/2'
      ii=1
      ii0=ii
      if ( logic_g2g4a ) then
         ii=ii0
         mm0=iplplwei
         nn0=iplprwei+iwt_sm_s_ext
         mm=mm0
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1

               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii+1)
                  indexlp1=index_lpext1(ii+1)

!         if(indexlp.ne.0) then
           valuelp=value_lpext(ii+1)
           vector2(indexlp)=vector2(indexlp)
     :       +vector1(mm)*(vector1(nna)+vector1(nnb))*valuelp
!         end if
!         if(indexlp1.ne.0) then
           valuelp1=value_lpext1(ii+1)
           vector2(indexlp1)=vector2(indexlp1)
     :       +vector1(mm)*(vector1(nna)+vector1(nnb))*valuelp1
!         end if
                  ii=ii+2
               enddo
            enddo
         enddo
      endif
      if ( logic_g2g4b ) then
         ii=ii0
         mm0=iplprwei
         nn0=iplplwei+iwt_sm_s_ext
         mm=mm0
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii+1)
                  indexlp1=index_lpext1(ii+1)
!         if(indexlp.ne.0) then
           valuelp=value_lpext(ii+1)
           vector2(indexlp)=vector2(indexlp)
     :       +vector1(mm)*(vector1(nna)+vector1(nnb))*valuelp
!         end if
!         if(indexlp1.ne.0) then
           valuelp1=value_lpext1(ii+1)
           vector2(indexlp1)=vector2(indexlp1)
     :       +vector1(mm)*(vector1(nna)+vector1(nnb))*valuelp1
!         end if
                  ii=ii+2
               enddo
            enddo
         enddo
      endif
!     iaddii=(ii-ii0)/2
      ii0=ii-1

      do icle=1,2
      if ( icle.eq.1 .and. logic_g36a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta36=lpsta36a
         lpend36=lpend36a
      elseif (  icle.eq.2 .and. logic_g36b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta36=lpsta36b
         lpend36=lpend36b
      else
            goto 936
      endif
         do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(ii)
               indexlp1=index_lpext1(ii)
!         if(indexlp.ne.0) then
           valuelp=value_lpext(ii)
           vector2(indexlp)=vector2(indexlp)
     :       +vector1(mm)*vector1(nn)*valuelp
!         end if
!         if(indexlp1.ne.0) then
           valuelp1=value_lpext1(ii)
           vector2(indexlp1)=vector2(indexlp1)
     :       +vector1(mm)*vector1(nn)*valuelp1
!         end if

               mm=mm+1
               nn=nn+1
            enddo
         enddo
936   continue

      if ( icle.eq.1 .and. logic_g35a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta35=lpsta35a
         lpend35=lpend35a
      elseif (  icle.eq.2 .and. logic_g35b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta35=lpsta35b
         lpend35=lpend35b
      else
            goto 935
      endif

         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
               indexlp1=index_lpext1(iij)
!         if(indexlp.ne.0) then
           valuelp=value_lpext(iij)
           vector2(indexlp)=vector2(indexlp)
     :       +vector1(mm)*vector1(nn)*valuelp
!         end if
!         if(indexlp1.ne.0) then
           valuelp1=value_lpext1(iij)
           vector2(indexlp1)=vector2(indexlp1)
     :       +vector1(mm)*vector1(nn)*valuelp1
!         end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
935      continue
!     cycle

      if ( icle.eq.1 .and. logic_g34a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta34=lpsta34a
         lpend34=lpend34a
      elseif (  icle.eq.2 .and. logic_g34b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta34=lpsta34b
         lpend34=lpend34b
      else
            goto 934
      endif
         do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
               indexlp1=index_lpext1(iij)
!         if(indexlp.ne.0) then
           valuelp=value_lpext(iij)
           vector2(indexlp)=vector2(indexlp)
     :       +vector1(mm)*vector1(nn)*valuelp
!         end if
!         if(indexlp1.ne.0) then
           valuelp1=value_lpext1(iij)
           vector2(indexlp1)=vector2(indexlp1)
     :       +vector1(mm)*vector1(nn)*valuelp1
!         end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
934   continue

      enddo
      end


      subroutine inn_ext_st_drl_loop_unpack_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(*,*) ' st_test 2/2'

      ii=1
      if ( logic_g1415 ) then
      mm=iplplwei
      nn=iplprwei
      do i=1,idownwei_g131415
         mm=mm+1
         nn=nn+1
         indexlp=index_lpext(ii)
         indexlp1=index_lpext1(ii)
!         if(indexlp.ne.0) then
           valuelp=value_lpext(ii)
           vector2(indexlp)=vector2(indexlp)
     :       +vector1(mm)*vector1(nn)*valuelp
!         end if
!         if(indexlp1.ne.0) then
           valuelp1=value_lpext1(ii)
           vector2(indexlp1)=vector2(indexlp1)
     :       +vector1(mm)*vector1(nn)*valuelp1
!         end if
         ii=ii+1
      enddo
      endif

      ii0=ii
      if ( logic_g2g4a ) then
         ii=ii0
         mm0=iplplwei
         nn0=iplprwei+iwt_sm_s_ext
            mm=mm0            !severe_error
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1

               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1

                  indexlp=index_lpext(ii)
!         if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!         end if
                  ii=ii+1

                  indexlp=index_lpext(ii)
!          if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!          end if
                  ii=ii+1
               enddo
            enddo
         enddo
      endif
      if ( logic_g2g4b ) then
         ii=ii0
         mm0=iplprwei
         nn0=iplplwei+iwt_sm_s_ext
            mm=mm0             !severe_error
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1

                  indexlp=index_lpext(ii)
!         if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!         end if
                  ii=ii+1

                  indexlp=index_lpext(ii)
!         if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!         end if
                  ii=ii+1

               enddo
            enddo
         enddo
      endif
      ii0=ii-1
      do icle=1,2
      if ( icle.eq.1 .and. logic_g36a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta36=lpsta36a
         lpend36=lpend36a
      elseif (  icle.eq.2 .and. logic_g36b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta36=lpsta36b
         lpend36=lpend36b
      else
            goto 936
      endif
         do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)

            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(ii)
!         if(indexlp.ne.0) then
               valuelp=value_lpext(ii)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!         end if
               mm=mm+1
               nn=nn+1
            enddo
         enddo
936   continue
      if ( icle.eq.1 .and. logic_g35a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta35=lpsta35a
         lpend35=lpend35a
         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!          if(indexlp.ne.0) then
               valuelp=value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!          end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
      elseif (  icle.eq.2 .and. logic_g35b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta35=lpsta35b
         lpend35=lpend35b
         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!           if(indexlp.ne.0) then
               valuelp=-value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!           end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
      endif

      if ( icle.eq.1 .and. logic_g34a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta34=lpsta34a
         lpend34=lpend34a
      elseif (  icle.eq.2 .and. logic_g34b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta34=lpsta34b
         lpend34=lpend34b
      else
            goto 934
      endif
         do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!           if(indexlp.ne.0) then
               valuelp=-value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!           end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
934   continue
      enddo

      end

      subroutine inn_ext_tt_drl_loop_unpack_g(iplplwei,iplprwei,n1415)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      logical logic_g14150,logic_g34b0,logic_g35b0,logic_g36b0
c     write(*,*) '  tt_test 2/2'
      logic_g14150=logic_g1415
      logic_g36b0=logic_g36b
      logic_g35b0=logic_g35b
      logic_g34b0=logic_g34b
      if(iplplwei.eq.iplprwei) then
         logic_g14150=.false.
         logic_g36b0=.false.
         logic_g35b0=.false.
         logic_g34b0=.false.
      endif
      ii=1
      if ( logic_g14150 ) then
      mm=iplplwei
      nn=iplprwei
!     ii=iista
      do i=1,idownwei_g131415
         mm=mm+1
         nn=nn+1
         indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
         indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
         ii=ii+1
      enddo
      endif

      ii0=n1415         !severe_error

      do icle=1,2
      if ( icle.eq.1 .and. logic_g36a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta36=lpsta36a
         lpend36=lpend36a
      elseif (  icle.eq.2 .and. logic_g36b0 ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta36=lpsta36b
         lpend36=lpend36b
      else
            goto 936
      endif
         do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
               valuelp=value_lpext(ii)
               vector2(indexlp)=vector2(indexlp)
     :            +vector1(mm)*vector1(nn)*valuelp
!       end if
               indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
               valuelp1=value_lpext1(ii)
               vector2(indexlp1)=vector2(indexlp1)
     :            +vector1(mm)*vector1(nn)*valuelp1
!       end if
               mm=mm+1
               nn=nn+1
            enddo
         enddo
936   continue

      if ( icle.eq.1 .and. logic_g35a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta35=lpsta35a
         lpend35=lpend35a
      elseif (  icle.eq.2 .and. logic_g35b0 ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta35=lpsta35b
         lpend35=lpend35b
      else
            goto 935
      endif

         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
               valuelp=-value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :            +vector1(mm)*vector1(nn)*valuelp
!       end if
               indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
               valuelp1=-value_lpext1(iij)
               vector2(indexlp1)=vector2(indexlp1)
     :            +vector1(mm)*vector1(nn)*valuelp1
!       end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
935      continue
!     cycle

      if ( icle.eq.1 .and. logic_g34a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta34=lpsta34a
         lpend34=lpend34a
      elseif (  icle.eq.2 .and. logic_g34b0 ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta34=lpsta34b
         lpend34=lpend34b
      else
            goto 934
      endif
         do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
               valuelp=value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :            +vector1(mm)*vector1(nn)*valuelp
!       end if
               indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
               valuelp1=value_lpext1(iij)
               vector2(indexlp1)=vector2(indexlp1)
     :            +vector1(mm)*vector1(nn)*valuelp1
!       end if
               iij=iij+1
               mm=mm+1
            enddo

         enddo
934   continue

      enddo
      end

      subroutine inn_ext_ts_drl_loop_unpack_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(*,*) '  ts_test 2/2'
      ii=1
c      logic_g1415=.false.
c      logic_g2g4a=.false.
c      logic_g2g4b=.false.
c      logic_g36a=.false.
c      logic_g36b=.false.
c      logic_g35a=.false.
c      logic_g35b=.false.
c      logic_g34a=.false.
c      logic_g34b=.false.
      if ( logic_g1415 ) then
      mm=iplplwei
      nn=iplprwei
      do i=1,idownwei_g131415
         mm=mm+1
         nn=nn+1
         indexlp=index_lpext(ii)
!        if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!        end if
         indexlp1=index_lpext1(ii)
!        if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!        end if
         ii=ii+1
      enddo
      endif
      ii0=ii
      if ( logic_g2g4a ) then
         ii=ii0
         mm0=iplplwei
         nn0=iplprwei+iwt_sm_s_ext
            mm=mm0            !severe_error
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii)
!        if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!        end if
                  ii=ii+1
                  indexlp=index_lpext(ii)
!         if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!         end if
                  ii=ii+1
               enddo
            enddo
         enddo
      endif
      if ( logic_g2g4b ) then
         ii=ii0
         mm0=iplprwei
         nn0=iplplwei+iwt_sm_s_ext
            mm=mm0             !severe_error
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii)
!         if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!         end if
                  ii=ii+1
                  indexlp=index_lpext(ii)
!         if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!         end if
                  ii=ii+1
               enddo
            enddo
         enddo
      endif

      ii0=ii-1         !severe_error

      do icle=1,2
      if ( icle.eq.1 .and. logic_g36a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta36=lpsta36a
         lpend36=lpend36a
      elseif (  icle.eq.2 .and. logic_g36b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta36=lpsta36b
         lpend36=lpend36b
      else
            goto 936
      endif
         do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(ii)
!          if(indexlp.ne.0) then
               valuelp=value_lpext(ii)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!          end if
               mm=mm+1
               nn=nn+1
            enddo
         enddo
936   continue

      if ( icle.eq.1 .and. logic_g35a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta35=lpsta35a
         lpend35=lpend35a
         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!           if(indexlp.ne.0) then
               valuelp=-value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!           end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
      elseif (  icle.eq.2 .and. logic_g35b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta35=lpsta35b
         lpend35=lpend35b
         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!           if(indexlp.ne.0) then
               valuelp=value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!           end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
      endif

      if ( icle.eq.1 .and. logic_g34a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta34=lpsta34a
         lpend34=lpend34a
      elseif (  icle.eq.2 .and. logic_g34b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta34=lpsta34b
         lpend34=lpend34b
      else
            goto 934
      endif
         do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!           if(indexlp.ne.0) then
               valuelp=-value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!           end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
934   continue
      enddo
      end


      subroutine inn_ext_ss_loop_unpack_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(*,*) ' ss_test 1/2'
      ii=1
      if ( logic_g1415 ) then
      mm=iplplwei
      nn=iplprwei
      do i=1,idownwei_g131415

         mm=mm+1
         nn=nn+1
         indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
         indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
         ii=ii+1

         indexlp=index_lpext(ii)
       if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
        vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
       end if
         indexlp1=index_lpext1(ii)
       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
       end if
         ii=ii+1
      enddo
      endif

      ii0=ii
      if ( logic_g2g4a ) then
         ii=ii0
         mm0=iplplwei
         nn0=iplprwei+iwt_sm_s_ext
         mm=mm0
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii)
!            if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!            end if
                  indexlp1=index_lpext1(ii)
!            if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nna)*valuelp1
!            end if
                  ii=ii+1
                  indexlp=index_lpext(ii)
!            if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!            end if
                  indexlp1=index_lpext1(ii)
!            if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nnb)*valuelp1
!            end if
                  ii=ii+1

               enddo
            enddo
         enddo
      endif
      if ( logic_g2g4b ) then
         ii=ii0
         mm0=iplprwei
         nn0=iplplwei+iwt_sm_s_ext
         mm=mm0
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii)
!            if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!            end if
                  indexlp1=index_lpext1(ii)
!            if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nnb)*valuelp1
!            end if
                  ii=ii+1
                  indexlp=index_lpext(ii)
!            if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!            end if
                  indexlp1=index_lpext1(ii)
!            if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nna)*valuelp1
!            end if
                  ii=ii+1

               enddo
            enddo
         enddo
      endif
!     iaddii=(ii-ii0)/2
      ii0=ii-1

      do icle=1,2
      if ( icle.eq.1 .and. logic_g36a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta36=lpsta36a
         lpend36=lpend36a
      elseif (  icle.eq.2 .and. logic_g36b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta36=lpsta36b
         lpend36=lpend36b
      else
            goto 936
      endif
         do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
                  indexlp=index_lpext(ii)
!            if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!            end if
                  indexlp1=index_lpext1(ii)
!            if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!            end if

               mm=mm+1
               nn=nn+1
            enddo
         enddo
936   continue

      if ( icle.eq.1 .and. logic_g35a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta35=lpsta35a
         lpend35=lpend35a
      elseif (  icle.eq.2 .and. logic_g35b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta35=lpsta35b
         lpend35=lpend35b
      else
            goto 935
      endif

         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!            if(indexlp.ne.0) then
               valuelp=value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!            end if
               indexlp1=index_lpext1(iij)
!            if(indexlp1.ne.0) then
               valuelp1=value_lpext1(iij)
               vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!            end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
935      continue

      if ( icle.eq.1 .and. logic_g34a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta34=lpsta34a
         lpend34=lpend34a
      elseif (  icle.eq.2 .and. logic_g34b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta34=lpsta34b
         lpend34=lpend34b
      else
            goto 934
      endif
         do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!            if(indexlp.ne.0) then
               valuelp=value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!            end if
               indexlp1=index_lpext1(iij)
!            if(indexlp1.ne.0) then
               valuelp1=value_lpext1(iij)
               vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!            end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
934   continue
      ii0=ii0+nvalue_space_ss
      enddo
      end


      subroutine inn_ext_st_loop_unpack_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(*,*) ' st_test 1/2'
      ii=1
      if ( logic_g1415 ) then
      mm=iplplwei
      nn=iplprwei
      do i=1,idownwei_g131415
         mm=mm+1
         nn=nn+1
         indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
         indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
         ii=ii+1

         indexlp=index_lpext(ii)
       if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
       end if
         indexlp1=index_lpext1(ii)
       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
       end if
         ii=ii+1
      enddo
      endif


      ii0=ii
      if ( logic_g2g4a ) then
         ii=ii0
         mm0=iplplwei
         nn0=iplprwei+iwt_sm_s_ext
            mm=mm0            !severe_error
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nna)*valuelp1
!       end if
                  ii=ii+1

                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nnb)*valuelp1
!       end if
                  ii=ii+1
               enddo
            enddo
         enddo
      endif

      if ( logic_g2g4b ) then
         ii=ii0
         mm0=iplprwei
         nn0=iplplwei+iwt_sm_s_ext
            mm=mm0
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)

                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
                  valuelp1=value_lpext1(ii)
!       if(indexlp1.ne.0) then
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nnb)*valuelp1
!       end if
                  ii=ii+1

                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nna)*valuelp1
!       end if
                  ii=ii+1

               enddo
            enddo
         enddo
      endif
      ii0=ii-1

      do icle=1,2
      if ( icle.eq.1 .and. logic_g36a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta36=lpsta36a
         lpend36=lpend36a
      elseif (  icle.eq.2 .and. logic_g36b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta36=lpsta36b
         lpend36=lpend36b
      else
            goto 936
      endif
         do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
               mm=mm+1
               nn=nn+1
            enddo
         enddo
936   continue

c      write(*,*)'st_g35a',iplplwei,iplprwei,vector2(137)
      if ( icle.eq.1 .and. logic_g35a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta35=lpsta35a
         lpend35=lpend35a
         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
               valuelp=value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
               indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
               valuelp1=value_lpext1(iij)
               vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
      elseif (  icle.eq.2 .and. logic_g35b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta35=lpsta35b
         lpend35=lpend35b
         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
               valuelp=-value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
               indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
               valuelp1=-value_lpext1(iij)
               vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
      endif

c      write(*,*)'st_g34',iplplwei,iplprwei,vector2(137)
      if ( icle.eq.1 .and. logic_g34a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta34=lpsta34a
         lpend34=lpend34a
      elseif (  icle.eq.2 .and. logic_g34b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta34=lpsta34b
         lpend34=lpend34b
      else
            goto 934
      endif
         do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            do i=1,lpext_wei(iii+3)
               indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
               valuelp=-value_lpext(iij)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
               indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
               valuelp1=-value_lpext1(iij)
               vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
934   continue
      ii0=ii0+nvalue_space_ss
      enddo
      end


      subroutine inn_ext_ts_loop_unpack_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(*,*) '  ts_test 1/2 '
      ii=1
      if ( logic_g1415 ) then
      mm=iplplwei
      nn=iplprwei
      do i=1,idownwei_g131415
         mm=mm+1
         nn=nn+1
         indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
         indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
         ii=ii+1

         indexlp=index_lpext(ii)
       if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
       end if
         indexlp1=index_lpext1(ii)
       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
       end if
         ii=ii+1
      enddo
      endif

      ii0=ii
      if ( logic_g2g4a ) then
         ii=ii0
         mm0=iplplwei
         nn0=iplprwei+iwt_sm_s_ext
            mm=mm0            !severe_error
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nna)*valuelp1
!       end if
                  ii=ii+1

                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nnb)*valuelp1
!       end if
                  ii=ii+1

               enddo
            enddo
         enddo
      endif
      if ( logic_g2g4b ) then
         ii=ii0
         mm0=iplprwei
         nn0=iplplwei+iwt_sm_s_ext
            mm=mm0             !severe_error
         do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
               nna=nna+1
               nnb=nn0+iasta-1
               do ia=iasta,min(iaend,ib-1)
                  mm=mm+1
                  nnb=nnb+1
                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nnb)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nnb)*valuelp1
!       end if
                  ii=ii+1

                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nna)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nna)*valuelp1
!       end if
                  ii=ii+1

               enddo
            enddo
         enddo
      endif
      ii0=ii-1

      do icle=1,2
      if ( icle.eq.1 .and. logic_g36a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta36=lpsta36a
         lpend36=lpend36a
      elseif (  icle.eq.2 .and. logic_g36b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta36=lpsta36b
         lpend36=lpend36b
      else
            goto 936
      endif
         do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
               mm=mm+1
               nn=nn+1
            enddo
         enddo
936   continue

      if ( icle.eq.1 .and. logic_g35a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta35=lpsta35a
         lpend35=lpend35a
         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            do i=1,lpext_wei(iii+3)
                  indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
                  valuelp=-value_lpext(iij)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
                  indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
                  valuelp1=-value_lpext1(iij)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
      elseif (  icle.eq.2 .and. logic_g35b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta35=lpsta35b
         lpend35=lpend35b
         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            do i=1,lpext_wei(iii+3)
                  indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(iij)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
                  indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(iij)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
      endif

      if ( icle.eq.1 .and. logic_g34a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta34=lpsta34a
         lpend34=lpend34a
      elseif (  icle.eq.2 .and. logic_g34b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta34=lpsta34b
         lpend34=lpend34b
      else
            goto 934
      endif
         do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
                  indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
                  valuelp=-value_lpext(iij)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
                  indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
                  valuelp1=-value_lpext1(iij)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
               iij=iij+1
               mm=mm+1
            enddo
         enddo
934   continue
      ii0=ii0+nvalue_space_ss
      enddo
      end


      subroutine inn_ext_tt_loop_unpack_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(*,*) '  tt_test 1/2'
      ii=1
      if ( logic_g1415 ) then
      mm=iplplwei
      nn=iplprwei

      do i=1,idownwei_g131415
         mm=mm+1
         nn=nn+1
         indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
         indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if

         ii=ii+1

         indexlp=index_lpext(ii)
       if(indexlp.ne.0) then
         valuelp=value_lpext(ii)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
       end if
         indexlp1=index_lpext1(ii)
       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(ii)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
       end if
         ii=ii+1
      enddo
      endif

      ii0=ii-1

      do icle=1,2
      if ( icle.eq.1 .and. logic_g36a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta36=lpsta36a
         lpend36=lpend36a
      elseif (  icle.eq.2 .and. logic_g36b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta36=lpsta36b
         lpend36=lpend36b
      else
            goto 936
      endif
         do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
                  indexlp=index_lpext(ii)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(ii)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
                  indexlp1=index_lpext1(ii)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(ii)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if
               mm=mm+1
               nn=nn+1
            enddo
         enddo
936   continue

      if ( icle.eq.1 .and. logic_g35a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta35=lpsta35a
         lpend35=lpend35a
      elseif (  icle.eq.2 .and. logic_g35b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta35=lpsta35b
         lpend35=lpend35b
      else
            goto 935
      endif

         do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
                  indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
                  valuelp=-value_lpext(iij)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
                  indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
                  valuelp1=-value_lpext1(iij)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if

               iij=iij+1
               mm=mm+1
            enddo
         enddo
935      continue
!     cycle

      if ( icle.eq.1 .and. logic_g34a ) then
         mm0=iplplwei
         nn0=iplprwei
         lpsta34=lpsta34a
         lpend34=lpend34a
      elseif (  icle.eq.2 .and. logic_g34b ) then
         mm0=iplprwei
         nn0=iplplwei
         lpsta34=lpsta34b
         lpend34=lpend34b
      else
            goto 934
      endif
         do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)

            do i=1,lpext_wei(iii+3)
                  indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
                  valuelp=value_lpext(iij)
                  vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
                  indexlp1=index_lpext1(iij)
!       if(indexlp1.ne.0) then
                  valuelp1=value_lpext1(iij)
                  vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!       end if

               iij=iij+1
               mm=mm+1
            enddo
         enddo
934   continue
      ii0=ii0+nvalue_space_ss
      enddo
      end

      subroutine gsd_sequence_extspace_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      parameter (v_sqtwo=1.414213562373095d0 )
c      write(*,*) '  sd_test 1/2','  ds_test 1'

      ilpvalue=0
      if ( logic_g25a ) then
         mm=iplplwei+iweista_g25-1
         nn0=iplprwei
         do itmp=1,nint_g25
            ilpvalue=ilpvalue+1
            indexlp=index_lpext(ilpvalue)
            valuelp=value_lpext(ilpvalue)
            indexlp1=index_lpext1(ilpvalue)
            valuelp1=value_lpext1(ilpvalue)
            nn=nn0
            do i=1,nwei_g25
               mm=mm+1
               nn=nn+1
!            if(indexlp.ne.0) then
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!            end if
              if(indexlp1.ne.0) then
                vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
              end if
            enddo
         enddo
      elseif ( logic_g25b ) then
         mm=iplplwei+iweista_g25-1
         nn0=iplprwei
         ilpvalue=ilpvalue+1
         do itmp=2,nint_g25
            ilpvalue=ilpvalue+1
            indexlp=index_lpext(ilpvalue)
            valuelp=value_lpext(ilpvalue)
            indexlp1=index_lpext1(ilpvalue)
            valuelp1=value_lpext1(ilpvalue)
            nn=nn0
            do i=1,itmp-1
               mm=mm+1
               nn=nn+1
!            if(indexlp.ne.0) then
              vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!            end if
              if(indexlp1.ne.0) then
                vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
              end if
            enddo
         enddo

         mm=iplplwei+iweista_g28-1
         nn=iplprwei
         nn=nn+1
         do itmp=2,nwei_g28
            nn=nn+1
            ilpvalue=0
            do i=1,itmp-1
               ilpvalue=ilpvalue+1
               mm=mm+1
               indexlp=index_lpext(ilpvalue)
!            if(indexlp.ne.0) then
               valuelp=value_lpext(ilpvalue)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!            end if
              indexlp1=index_lpext1(ilpvalue)
              if(indexlp1.ne.0) then
                valuelp1=value_lpext1(ilpvalue)
                vector2(indexlp1)=vector2(indexlp1)
     :                    +vector1(mm)*vector1(nn)*valuelp1
              end if
           enddo
         enddo
      elseif ( logic_g28a ) then
         mm=iplplwei+iweista_g28-1
         nn0=iplprwei
         do nn=nn0+1,nn0+nwei_g28
            ilpvalue=0
            do i=1,nint_g28
               ilpvalue=ilpvalue+1
               mm=mm+1
               indexlp=index_lpext(ilpvalue)
!            if(indexlp.ne.0) then
               valuelp=value_lpext(ilpvalue)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!            end if
              indexlp1=index_lpext1(ilpvalue)
              if(indexlp1.ne.0) then
                valuelp1=value_lpext1(ilpvalue)
                vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
              end if
            enddo
          enddo
      endif

      if ( logic_g26 ) then
         ilpvalue=ivaluesta_g26
         mm=iplplwei+iweista_g26
         nn0=iplprwei
         do nn=nn0+1,nn0+nwei_g26
           ilpvalue=ilpvalue+1
           indexlp=index_lpext(ilpvalue)
!          if(indexlp.ne.0) then
           valuelp=value_lpext(ilpvalue)*v_sqtwo
           vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!          end if
           indexlp1=index_lpext1(ilpvalue)
           if(indexlp1.ne.0) then
             valuelp1=value_lpext1(ilpvalue)*v_sqtwo
             vector2(indexlp1)=vector2(indexlp1)
     :                  +vector1(mm)*vector1(nn)*valuelp1
           end if
           mm=mm+1
         enddo
      endif
c      print*, "out sd 1"

      end

      subroutine gtd_sequence_extspace_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      common /cont_tmp/icount_ext
      parameter (   v_sqtwo=1.414213562373095d0 )
c     write(*,*) ' td_test _1/2',' dt_test '
      ilpvalue=0
      if ( logic_g25a ) then
         mm=iplplwei+iweista_g25-1
         nn0=iplprwei
         do itmp=1,nint_g25
            ilpvalue=ilpvalue+1
            indexlp=index_lpext(ilpvalue)
            valuelp=value_lpext(ilpvalue)
            indexlp1=index_lpext1(ilpvalue)
            valuelp1=value_lpext1(ilpvalue)

            nn=nn0
            do i=1,nwei_g25
               mm=mm+1
               nn=nn+1
!            if(indexlp.ne.0) then
              vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!            end if
            if(indexlp1.ne.0) then
              vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
            end if
           enddo
         enddo
      elseif ( logic_g25b ) then
         mm=iplplwei+iweista_g25-1
         nn0=iplprwei
         ilpvalue=ilpvalue+1
         do itmp=2,nint_g25
            ilpvalue=ilpvalue+1
            indexlp=index_lpext(ilpvalue)
            valuelp=value_lpext(ilpvalue)
            indexlp1=index_lpext1(ilpvalue)
            valuelp1=value_lpext1(ilpvalue)

            nn=nn0
            do i=1,itmp-1
               mm=mm+1
               nn=nn+1
!            if(indexlp.ne.0) then
              vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!            end if
            if(indexlp1.ne.0) then
              vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
            end if
            enddo
         enddo
         mm=iplplwei+iweista_g28-1
         nn=iplprwei
         nn=nn+1
         do itmp=2,nwei_g28
            nn=nn+1
            ilpvalue=0
            do i=1,itmp-1
              ilpvalue=ilpvalue+1
              mm=mm+1
              indexlp=index_lpext(ilpvalue)
!          if(indexlp.ne.0) then
              valuelp=-value_lpext(ilpvalue)
              vector2(indexlp)=vector2(indexlp)
     :                 +vector1(mm)*vector1(nn)*valuelp
!          end if
             indexlp1=index_lpext1(ilpvalue)
             if(indexlp1.ne.0) then
               valuelp1=-value_lpext1(ilpvalue)
               vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
             end if
            enddo
         enddo
      elseif ( logic_g28a ) then
         mm=iplplwei+iweista_g28-1
         nn0=iplprwei
         do nn=nn0+1,nn0+nwei_g28

            ilpvalue=0
            do i=1,nint_g28
               ilpvalue=ilpvalue+1
               mm=mm+1
               indexlp=index_lpext(ilpvalue)
!          if(indexlp.ne.0) then
               valuelp=-value_lpext(ilpvalue)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!          end if
               indexlp1=index_lpext1(ilpvalue)
          if(indexlp1.ne.0) then
               valuelp1=-value_lpext1(ilpvalue)
               vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
          end if
            enddo
         enddo
      endif
      end


      subroutine gdv_sequence_extspace_g(ilw,irw)
#include "drt_h.fh"
#include "lpextmode_h.fh"

      mm=ilw
      nn=irw+1

      do iij=1,ilsegdownwei
         mm=mm+1
         indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
         valuelp=value_lpext(iij)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
         indexlp1=index_lpext1(iij)
         if(indexlp1.ne.0) then
           valuelp1=value_lpext1(iij)
           vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
         end if
      enddo
      end

      subroutine complete_sd_ar_ext_loop_g(ilwei,irwei,isdownwei)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
c      write(*,*) 'sd_test 2/2','  td_test_2/2 2'
      ilpvalue=0
      mm0=ilwei
      nn=irwei+icano_nnsta-1
      do nntmp=icano_nnsta,icano_nnend
       nn=nn+1
       mm=mm0
       do mmtmp=1,isdownwei
          ilpvalue=ilpvalue+1
          mm=mm+1
          indexlp=index_lpext(ilpvalue)
          valuelp=value_lpext(ilpvalue)
          vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
          indexlp1=index_lpext1(ilpvalue)
          if(indexlp1.ne.0) then

            valuelp1=value_lpext1(ilpvalue)
            vector2(indexlp1)=vector2(indexlp1)
     :                    +vector1(mm)*vector1(nn)*valuelp1
          endif
        enddo
      enddo
c      print*, "out sd 2"
      return
      end

      subroutine gdv_sequence_extspace1_g(ilw,irw,n)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "grad_h.fh"
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)

      mm=ilw
      nn=irw+1

      do ilpvalue=1,ilsegdownwei
         mm=mm+1
         indexlp2=index_lpext5(ilpvalue)
         valuelp2=value_lpext5(ilpvalue)
         dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2

         do nii=1,n
            indexlp3=index_lpext3(ilpvalue,nii)
!          if(indexlp3.ne.0) then
            valuelp3=value_lpext3(ilpvalue,nii)
            vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!          end if

            indexlp4=index_lpext4(ilpvalue,nii)
          if(indexlp4.ne.0) then
            valuelp4=value_lpext4(ilpvalue,nii)
            vector2(indexlp4)=vector2(indexlp4)
     :                   +vector1(mm)*vector1(nn)*valuelp4
          end if
         enddo
      enddo
      end


      subroutine gtd_sequence_extspace1_g(iplplwei,iplprwei,n)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "grad_h.fh"
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /cont_tmp/icount_ext
      parameter (   v_sqtwo=1.414213562373095d0 )
c     write(*,*) ' td_test _1/2',' dt_test '
      ilpvalue=0
      if ( logic_g25a ) then
         mm=iplplwei+iweista_g25-1
         nn0=iplprwei
         do itmp=1,nint_g25
            ilpvalue=ilpvalue+1
            indexlp2=index_lpext5(ilpvalue)
            valuelp2=value_lpext5(ilpvalue)
            nn=nn0
            do i=1,nwei_g25
               mm=mm+1
               nn=nn+1
               dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
               do nii=1,n
                 indexlp3=index_lpext3(ilpvalue,nii)
!          if(indexlp3.ne.0) then
                 valuelp3=value_lpext3(ilpvalue,nii)
                 vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!          end if
                 indexlp4=index_lpext4(ilpvalue,nii)
          if(indexlp4.ne.0) then
                 valuelp4=value_lpext4(ilpvalue,nii)
                 vector2(indexlp4)=vector2(indexlp4)
     :                   +vector1(mm)*vector1(nn)*valuelp4
          end if
              enddo
           enddo
         enddo
      elseif ( logic_g25b ) then
         mm=iplplwei+iweista_g25-1
         nn0=iplprwei
         ilpvalue=ilpvalue+1
         do itmp=2,nint_g25
            ilpvalue=ilpvalue+1
            indexlp2=index_lpext5(ilpvalue)
            valuelp2=value_lpext5(ilpvalue)

            nn=nn0
            do i=1,itmp-1
               mm=mm+1
               nn=nn+1
               dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
               do nii=1,n
                 indexlp3=index_lpext3(ilpvalue,nii)
!             if(indexlp3.ne.0) then
                 valuelp3=value_lpext3(ilpvalue,nii)
                 vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!             end if
                 indexlp4=index_lpext4(ilpvalue,nii)
             if(indexlp4.ne.0) then
                 valuelp4=value_lpext4(ilpvalue,nii)
                 vector2(indexlp4)=vector2(indexlp4)
     :                   +vector1(mm)*vector1(nn)*valuelp4
             end if
              enddo
            enddo
         enddo
         mm=iplplwei+iweista_g28-1
         nn=iplprwei
         nn=nn+1
         do itmp=2,nwei_g28
            nn=nn+1
            ilpvalue=0
            do i=1,itmp-1
               ilpvalue=ilpvalue+1
               indexlp2=index_lpext5(ilpvalue)
               valuelp2=-value_lpext5(ilpvalue)
               mm=mm+1
               dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
               do nii=1,n
                 indexlp3=index_lpext3(ilpvalue,nii)
!             if(indexlp3.ne.0) then
                 valuelp3=-value_lpext3(ilpvalue,nii)
                 vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!             end if
                 indexlp4=index_lpext4(ilpvalue,nii)
             if(indexlp4.ne.0) then
                 valuelp4=-value_lpext4(ilpvalue,nii)
                 vector2(indexlp4)=vector2(indexlp4)
     :                   +vector1(mm)*vector1(nn)*valuelp4
             end if
              enddo
            enddo
         enddo
      elseif ( logic_g28a ) then
         mm=iplplwei+iweista_g28-1
         nn0=iplprwei
         do nn=nn0+1,nn0+nwei_g28

            ilpvalue=0
            do i=1,nint_g28
               ilpvalue=ilpvalue+1
               indexlp2=index_lpext5(ilpvalue)
               valuelp2=-value_lpext5(ilpvalue)
               mm=mm+1
               dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
               do nii=1,n
                 indexlp3=index_lpext3(ilpvalue,nii)
!             if(indexlp3.ne.0) then
                 valuelp3=-value_lpext3(ilpvalue,nii)
                 vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!             end if
                 indexlp4=index_lpext4(ilpvalue,nii)
             if(indexlp4.ne.0) then
                 valuelp4=-value_lpext4(ilpvalue,nii)
                 vector2(indexlp4)=vector2(indexlp4)
     :                   +vector1(mm)*vector1(nn)*valuelp4
             end if
               enddo
            enddo
         enddo
      endif
      end

      subroutine gsd_sequence_extspace1_g(iplplwei,iplprwei,n)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "grad_h.fh"
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      parameter (v_sqtwo=1.414213562373095d0 )
c      write(*,*) '  sd_test 1/2','  ds_test 0'

      ilpvalue=0
      if ( logic_g25a ) then
         mm=iplplwei+iweista_g25-1
         nn0=iplprwei
         do itmp=1,nint_g25
            ilpvalue=ilpvalue+1
            indexlp2=index_lpext5(ilpvalue)
            valuelp2=value_lpext5(ilpvalue)

            nn=nn0
            do i=1,nwei_g25
               mm=mm+1
               nn=nn+1
               dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
               do nii=1,n
                 indexlp3=index_lpext3(ilpvalue,nii)
!             if(indexlp3.ne.0) then
                 valuelp3=value_lpext3(ilpvalue,nii)
                 vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!             end if
                 indexlp4=index_lpext4(ilpvalue,nii)
                 if(indexlp4.ne.0) then
                   valuelp4=value_lpext4(ilpvalue,nii)
                   vector2(indexlp4)=vector2(indexlp4)
     :                     +vector1(mm)*vector1(nn)*valuelp4
                 end if
                enddo
            enddo
         enddo
      elseif ( logic_g25b ) then
         mm=iplplwei+iweista_g25-1
         nn0=iplprwei
         ilpvalue=ilpvalue+1
         do itmp=2,nint_g25
            ilpvalue=ilpvalue+1
            indexlp2=index_lpext5(ilpvalue)
            valuelp2=value_lpext5(ilpvalue)

            nn=nn0
            do i=1,itmp-1
               mm=mm+1
               nn=nn+1
               dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
               do nii=1,n
                 indexlp3=index_lpext3(ilpvalue,nii)
!             if(indexlp3.ne.0) then
                 valuelp3=value_lpext3(ilpvalue,nii)
                 vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!             end if
                 indexlp4=index_lpext4(ilpvalue,nii)
             if(indexlp4.ne.0) then
                 valuelp4=value_lpext4(ilpvalue,nii)
                 vector2(indexlp4)=vector2(indexlp4)
     :                   +vector1(mm)*vector1(nn)*valuelp4
             end if
                enddo

            enddo
         enddo

         mm=iplplwei+iweista_g28-1
         nn=iplprwei
         nn=nn+1
         do itmp=2,nwei_g28
            nn=nn+1
            ilpvalue=0
            do i=1,itmp-1
               ilpvalue=ilpvalue+1
               indexlp2=index_lpext5(ilpvalue)
               valuelp2=value_lpext5(ilpvalue)
               mm=mm+1
               dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
               do nii=1,n
                  indexlp3=index_lpext3(ilpvalue,nii)
!             if(indexlp3.ne.0) then
                  valuelp3=value_lpext3(ilpvalue,nii)
                  vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!             end if
                  indexlp4=index_lpext4(ilpvalue,nii)
             if(indexlp4.ne.0) then
                  valuelp4=value_lpext4(ilpvalue,nii)
                  vector2(indexlp4)=vector2(indexlp4)
     :                   +vector1(mm)*vector1(nn)*valuelp4
             end if
               enddo
            enddo
         enddo
      elseif ( logic_g28a ) then
         mm=iplplwei+iweista_g28-1
         nn0=iplprwei
         do nn=nn0+1,nn0+nwei_g28
            ilpvalue=0
            do i=1,nint_g28
               ilpvalue=ilpvalue+1
               indexlp2=index_lpext5(ilpvalue)
               valuelp2=value_lpext5(ilpvalue)
               mm=mm+1
               dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
               do nii=1,n
                  indexlp3=index_lpext3(ilpvalue,nii)
!             if(indexlp3.ne.0) then
                  valuelp3=value_lpext3(ilpvalue,nii)
                  vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!             end if
                  indexlp4=index_lpext4(ilpvalue,nii)
             if(indexlp4.ne.0) then
                  valuelp4=value_lpext4(ilpvalue,nii)
                  vector2(indexlp4)=vector2(indexlp4)
     :                   +vector1(mm)*vector1(nn)*valuelp4
             end if
               enddo
            enddo
         enddo
      endif

      if ( logic_g26 ) then
         ilpvalue=ivaluesta_g26
         mm=iplplwei+iweista_g26
         nn0=iplprwei
         do nn=nn0+1,nn0+nwei_g26
            ilpvalue=ilpvalue+1
            indexlp2=index_lpext5(ilpvalue)
            valuelp2=value_lpext5(ilpvalue)*v_sqtwo

            dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
            do nii=1,n
               indexlp3=index_lpext3(ilpvalue,nii)
!             if(indexlp3.ne.0) then
               valuelp3=value_lpext3(ilpvalue,nii)*v_sqtwo
               vector2(indexlp3)=vector2(indexlp3)
     :                   +vector1(mm)*vector1(nn)*valuelp3
!             end if
               indexlp4=index_lpext4(ilpvalue,nii)
             if(indexlp4.ne.0) then
               valuelp4=value_lpext4(ilpvalue,nii)*v_sqtwo
               vector2(indexlp4)=vector2(indexlp4)
     :                   +vector1(mm)*vector1(nn)*valuelp4
             end if
            enddo
            mm=mm+1
         enddo
      endif
c      print*, "out ds 0"

      end


      subroutine inn_ext_dd_loop_unpack_g(iplplwei,iplprwei)
#include "drt_h.fh"
#include "lpextmode_h.fh"

c      write(nf2,*) 'logic_g49b',logic_g50,logic_g49a,logic_g49b

      ii=1
      if ( logic_g50 ) then
         if ( logic_g49b) then
            mm=iplplwei
            nn=iplprwei
            do i=1,ildownwei_segdd
               mm=mm+1
               nn=nn+1
              indexlp=index_lpext(ii)
           if(indexlp.ne.0) then
              valuelp=value_lpext(ii)
              vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
           end if
              indexlp1=index_lpext1(ii)
           if(indexlp1.ne.0) then
              valuelp1=value_lpext1(ii)
              vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
           end if
               ii=ii+1
            enddo
         endif

         ii=ii+int_dd_drl
         mm0=iplplwei
         nn=iplprwei+1
         do icle=1,2
         do j=2,ildownwei_segdd
            nn=nn+1
            mm=mm0
            do i=1,j-1
               mm=mm+1
               indexlp=index_lpext(ii)
           if(indexlp.ne.0) then
               valuelp=value_lpext(ii)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
           end if
               indexlp1=index_lpext1(ii)
           if(indexlp1.ne.0) then
               valuelp1=value_lpext1(ii)
               vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
           end if
               ii=ii+1
            enddo
         enddo
         if ( .not. logic_g49b ) exit
         mm0=iplprwei
         nn=iplplwei+1
         enddo

      else               !drl=.true.


          ii=ii+int_dd_drl
         if ( logic_g49a ) then
            mm0=iplplwei
            nn=iplprwei
             ildownwei=ildownwei_segdd
             irdownwei=irdownwei_segdd
         else
            mm0=iplprwei
            nn=iplplwei
             ildownwei=irdownwei_segdd
             irdownwei=ildownwei_segdd
         endif
         do j=1,irdownwei
            nn=nn+1
            mm=mm0
            do i=1,ildownwei
              mm=mm+1
               indexlp=index_lpext(ii)
!           if(indexlp.ne.0) then
               valuelp=value_lpext(ii)
               vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!           end if
               indexlp1=index_lpext1(ii)
!           if(indexlp1.ne.0) then
               valuelp1=value_lpext1(ii)
               vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
!           end if
               ii=ii+1
            enddo
         enddo
      endif
      end

      subroutine inn_ext_sv_loop_unpack_g(ilw,irw)
#include "drt_h.fh"
#include "lpextmode_h.fh"

      mm=ilw
      nn=irw+1
      do iij=1,ilsegdownwei
         mm=mm+1
         indexlp=index_lpext(iij)
!       if(indexlp.ne.0) then
         valuelp=value_lpext(iij)
         vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
!       end if
         indexlp1=index_lpext1(iij)
       if(indexlp1.ne.0) then
         valuelp1=value_lpext1(iij)
         vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
       end if
      enddo
      end


!  density matrix formation : vector2=ci*<i|epq,rs|j>*cj and dm1=ci*<i|e
!  for norb_act<>0         mg1,mg2,mg3,mg4,mg5:
!  idb=1  in dbl_space      ity_up=0-5               0 ,jpad,iwdl,iwdr,
!  idb=2  in act_space      ity_up=0-5,itdown=0,3      jph, jpe,iwal,iwa
!  idb=3  betwin dbl and act   ity_up=0-5,itdown=0,3      jpe,iwdl,iwdr,

!  this subroutine prodab_1 does the dm1 part, which corresponds to voin
      subroutine prodab_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6,mg7)
#include "drt_h.fh"
      if(log_prod.eq.1) call prodab_h_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,
     *                                  mg6,mg7)
      if(log_prod.eq.2) call prodab_h0_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,
     *                                  mg6,mg7)
      return
      end

      subroutine prodab_h_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6,mg7)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lopu(4,loputmp)
#include "grad_h.fh"
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)

      goto(100,200,300),idb
! in dbl_space
100   jpad=mg2
      iwdl=mg3
      iwdr=mg4
      do ipae=1,25
        if(nu_ae(ipae).eq.0) cycle
        iwdown=iw_downwei(jpad,ipae)
        if(iwdown.eq.0) cycle
        lwnu=iseg_downwei(ipae)
        do iwa=0,iwdown-1
          iwadl=iwalk_ad(jpad,ipae,iwa,iwdl)
          iwadr=iwalk_ad(jpad,ipae,iwa,iwdr)
          mm=iwadl
          nn=iwadr
          do m=1,lwnu
            mm=mm+1
            nn=nn+1
c101        vector2(mm)=vector2(mm)+vector1(nn)*wl
c          vector2(nn)=vector2(nn)+vector1(mm)*wl
c          vector2(mm)=vector2(mm)+vector1(nn)*wl
c          vector2(nn)=vector2(nn)+vector1(mm)*wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
          enddo
        enddo
      enddo
      goto 1000
! in act_space
200   if(jpad.ne.jpadl) return
      jph=mg1
      jpl=mg2
c     iwal=mg3
c     iwar=mg4
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jpy=jphy(jph)
      in=ihy(jpy)

      call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
      do lp=1,mp
        iwl=lopu(1,lp)-1
        iwr=lopu(2,lp)-1
        jpe=lopu(3,lp)
        lwnu=iy(1,jpe)
        do jwu=jpy+1,jpy+in
          iwal=iwl+ihy(jwu)
          iwar=iwr+ihy(jwu)
          do jwd=1,lwnu
            iwal=iwal+1
            iwar=iwar+1
            do iwd=0,iwupwei-1
              iwadl=iwalk_ad(jpadl,ipael,iwal,iwd)
              iwadr=iwalk_ad(jpad,ipae,iwar,iwd)
              do iwe=1,isegdownwei
                mm=iwadl+iwe
                nn=iwadr+iwe
c201        vector2(mm)=vector2(mm)+vector1(nn)*wl
c           vector2(nn)=vector2(nn)+vector1(mm)*wl
c              vector2(mm)=vector2(mm)+vector1(nn)*wl
c              vector2(nn)=vector2(nn)+vector1(mm)*wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
c             write(nf2,'(4i4,4f18.10)')mg6,mg7, mm,nn,wl,
c     :       vector1(mm),vector1(nn),dm1tmp(mg67)
              enddo
            enddo
          enddo
        enddo
      enddo
      goto 1000
! betwin act and dbl
300   jpl =mg1
      iwdl=mg2
      iwdr=mg3
      isegdownwei=iseg_downwei(ipae)

      call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
      do lp=1,mp
        iwal=lopu(1,lp)-1
        iwar=lopu(2,lp)-1
        jpe= lopu(3,lp)
        jwnu=iy(1,jpe)
        do ii=1,jwnu
          iwal=iwal+1
          iwar=iwar+1
          mm=iwalk_ad(jpadl,ipael,iwal,iwdl)
          nn=iwalk_ad(jpad,ipae,iwar,iwdr)
          do iwe=1,isegdownwei
            mm=mm+1                  ! iwl=iwalk_ad
            nn=nn+1                  ! iwl=iwalk_ad
c301        vector2(mm)=vector2(mm)+vector1(nn)*wl
c           vector2(nn)=vector2(nn)+vector1(mm)*wl
c           vector2(mm)=vector2(mm)+vector1(nn)*wl
c            vector2(nn)=vector2(nn)+vector1(mm)*wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
c            write(nf2,'(a9,3i8,3f18.10)') '1_dbl_act',mg6,mm,nn,wl,
c     :             vector1(mm),vector1(nn)
            enddo
        enddo
      enddo
      goto 1000
1000  return
      end

      subroutine prodab_h0_1(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6,mg7)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lopu(4,loputmp)
#include "grad_h.fh"
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)

      goto(100,200,300),idb
! in dbl_space
100   jpad=mg2
      iwdl=mg3
      iwdr=mg4
      do ipae=1,25
        if(nu_ae(ipae).eq.0) cycle
        iwdown=iw_downwei(jpad,ipae)
        if(iwdown.eq.0) cycle
        lwnu=iseg_downwei(ipae)
        do iwa=0,iwdown-1
          iwadl=iwalk_ad(jpad,ipae,iwa,iwdl)
          iwadr=iwalk_ad(jpad,ipae,iwa,iwdr)
          mm=iwadl
          nn=iwadr
          do m=1,lwnu
            mm=mm+1
            nn=nn+1
              if(mm.gt.nn) mntmp=mm*(mm-1)/2+nn
              if(nn.gt.mm) mntmp=nn*(nn-1)/2+mm
c             vector2(mntmp)=vector2(mntmp)+wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
!              if(mntmp.eq.2) then
!                write(*,*)'  102',vector2(mntmp),wl
!           endif
          enddo
        enddo
      enddo
      goto 1000
! in act_space
200   if(jpad.ne.jpadl) return
      jph=mg1
      jpl=mg2
c     iwal=mg3
c     iwar=mg4
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jpy=jphy(jph)
      in=ihy(jpy)

      call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
      do lp=1,mp
        iwl=lopu(1,lp)-1
        iwr=lopu(2,lp)-1
        jpe=lopu(3,lp)
        lwnu=iy(1,jpe)
        do jwu=jpy+1,jpy+in
          iwal=iwl+ihy(jwu)
          iwar=iwr+ihy(jwu)
          do jwd=1,lwnu
            iwal=iwal+1
            iwar=iwar+1
            do iwd=0,iwupwei-1
              iwadl=iwalk_ad(jpadl,ipael,iwal,iwd)
              iwadr=iwalk_ad(jpad,ipae,iwar,iwd)
              do iwe=1,isegdownwei
                mm=iwadl+iwe
                nn=iwadr+iwe
              if(mm.gt.nn) mntmp=mm*(mm-1)/2+nn
              if(nn.gt.mm) mntmp=nn*(nn-1)/2+mm
c             vector2(mntmp)=vector2(mntmp)+wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
!              if(mntmp.eq.2) then
!                write(*,*)'  202',vector2(mntmp),wl
!           endif
              enddo
            enddo
          enddo
        enddo
      enddo
      goto 1000
! betwin act and dbl
300   jpl =mg1
      iwdl=mg2
      iwdr=mg3
      isegdownwei=iseg_downwei(ipae)

      call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
      do lp=1,mp
        iwal=lopu(1,lp)-1
        iwar=lopu(2,lp)-1
        jpe= lopu(3,lp)
        jwnu=iy(1,jpe)
        do ii=1,jwnu
          iwal=iwal+1
          iwar=iwar+1
          mm=iwalk_ad(jpadl,ipael,iwal,iwdl)
          nn=iwalk_ad(jpad,ipae,iwar,iwdr)
          do iwe=1,isegdownwei
            mm=mm+1                  ! iwl=iwalk_ad
            nn=nn+1                  ! iwl=iwalk_ad
              if(mm.gt.nn) mntmp=mm*(mm-1)/2+nn
              if(nn.gt.mm) mntmp=nn*(nn-1)/2+mm
c             vector2(mntmp)=vector2(mntmp)+wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(nn)*wl*vector1(mm)
!              if(mntmp.eq.2) then
!                write(*,*)'  302',vector2(mntmp),wl
!           endif
          enddo
        enddo
      enddo
      goto 1000
1000  return
      end


!this subroutine prodab_2 does the dm2 part, which corresponds to vint_c
      subroutine prodab_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6)
#include "drt_h.fh"
      if(log_prod.eq.1) call prodab_h_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,
     *                                  mg6)
      if(log_prod.eq.2) call prodab_h0_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,
     *                                  mg6)
      return
      end

      subroutine prodab_h_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lopu(4,loputmp)
#include "grad_h.fh"

      goto(100,200,300),idb
! in dbl_space
100   jpad=mg2
      iwdl=mg3
      iwdr=mg4
      do ipae=1,25
        if(nu_ae(ipae).eq.0) cycle
        iwdown=iw_downwei(jpad,ipae)
        if(iwdown.eq.0) cycle
        lwnu=iseg_downwei(ipae)
        do iwa=0,iwdown-1
          iwadl=iwalk_ad(jpad,ipae,iwa,iwdl)
          iwadr=iwalk_ad(jpad,ipae,iwa,iwdr)
          mm=iwadl
          nn=iwadr
          do m=1,lwnu
            mm=mm+1
            nn=nn+1
c101        vector2(mm)=vector2(mm)+vector1(nn)*wl
c          vector2(nn)=vector2(nn)+vector1(mm)*wl
c          vector2(mm)=vector2(mm)+vector1(nn)*wl
c          vector2(nn)=vector2(nn)+vector1(mm)*wl
            vector2(mg6)=vector2(mg6)+vector1(nn)*wl*vector1(mm)
c       if(mg6.eq.29)
c     :     write(nf2,'(i8,2i4,4f18.10)')mg6,mm,nn,vector2(mg6),
c     :                          vector1(mm),wl,vector1(nn)
           enddo
        enddo
      enddo
      goto 1000
! in act_space
200   if(jpad.ne.jpadl) return
      jph=mg1
      jpl=mg2
c     iwal=mg3
c     iwar=mg4
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jpy=jphy(jph)
      in=ihy(jpy)

      call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
      do lp=1,mp
        iwl=lopu(1,lp)-1
        iwr=lopu(2,lp)-1
        jpe=lopu(3,lp)
        lwnu=iy(1,jpe)
        do jwu=jpy+1,jpy+in
          iwal=iwl+ihy(jwu)
          iwar=iwr+ihy(jwu)
          do jwd=1,lwnu
            iwal=iwal+1
            iwar=iwar+1
            do iwd=0,iwupwei-1
              iwadl=iwalk_ad(jpadl,ipael,iwal,iwd)
              iwadr=iwalk_ad(jpad,ipae,iwar,iwd)
              do iwe=1,isegdownwei
                mm=iwadl+iwe
                nn=iwadr+iwe
c201        vector2(mm)=vector2(mm)+vector1(nn)*wl
c           vector2(nn)=vector2(nn)+vector1(mm)*wl
c              vector2(mm)=vector2(mm)+vector1(nn)*wl
c              vector2(nn)=vector2(nn)+vector1(mm)*wl
            vector2(mg6)=vector2(mg6)+vector1(nn)*wl*vector1(mm)
c       if(mg6.eq.15)  write(nf2,'(2i4,4f18.10)')
c     :          mm,nn,wl,vector1(mm),vector1(nn),vector2(mg6)
c            write(nf2,'(a3,2i4,i8,2f18.10)') 'act',mm,nn,mg6,
c     :       vector1(mm),vector1(nn)
            enddo
            enddo
          enddo
        enddo
      enddo
      goto 1000
! betwin act and dbl
300   jpl =mg1
      iwdl=mg2
      iwdr=mg3
      isegdownwei=iseg_downwei(ipae)

      call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
      do lp=1,mp
        iwal=lopu(1,lp)-1
        iwar=lopu(2,lp)-1
        jpe= lopu(3,lp)
        jwnu=iy(1,jpe)
        do ii=1,jwnu
          iwal=iwal+1
          iwar=iwar+1
          mm=iwalk_ad(jpadl,ipael,iwal,iwdl)
          nn=iwalk_ad(jpad,ipae,iwar,iwdr)
          do iwe=1,isegdownwei
            mm=mm+1                  ! iwl=iwalk_ad
            nn=nn+1                  ! iwl=iwalk_ad
c301        vector2(mm)=vector2(mm)+vector1(nn)*wl
c           vector2(nn)=vector2(nn)+vector1(mm)*wl
c           vector2(mm)=vector2(mm)+vector1(nn)*wl
c            vector2(nn)=vector2(nn)+vector1(mm)*wl
            vector2(mg6)=vector2(mg6)+vector1(nn)*wl*vector1(mm)
          enddo
        enddo
      enddo
      goto 1000
1000  return
      end

      subroutine prodab_h0_2(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr,mg6)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lopu(4,loputmp)
#include "grad_h.fh"

      goto(100,200,300),idb
! in dbl_space
100   jpad=mg2
      iwdl=mg3
      iwdr=mg4
      mntmp=0
      do ipae=1,25
        if(nu_ae(ipae).eq.0) cycle
        iwdown=iw_downwei(jpad,ipae)
        if(iwdown.eq.0) cycle
        lwnu=iseg_downwei(ipae)
        do iwa=0,iwdown-1
          iwadl=iwalk_ad(jpad,ipae,iwa,iwdl)
          iwadr=iwalk_ad(jpad,ipae,iwa,iwdr)
          mm=iwadl
          nn=iwadr
          do m=1,lwnu
            mm=mm+1
            nn=nn+1
              if(mm.gt.nn) then
                mntmp=mm*(mm-1)/2+nn
              else
                mntmp=nn*(nn-1)/2+mm
              endif
c             vector2(mntmp)=vector2(mntmp)+wl
            vector2(mg6)=vector2(mg6)+vector1(mntmp)*wl*vector1(mntmp)

!              if(mntmp.eq.2) then
!                write(*,*)'  102',vector2(mntmp),wl
!           endif
          enddo
        enddo
      enddo
      goto 1000
! in act_space
200   if(jpad.ne.jpadl) return
      jph=mg1
      jpl=mg2
c     iwal=mg3
c     iwar=mg4
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jpy=jphy(jph)
      in=ihy(jpy)

      call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
      do lp=1,mp
        iwl=lopu(1,lp)-1
        iwr=lopu(2,lp)-1
        jpe=lopu(3,lp)
        lwnu=iy(1,jpe)
        do jwu=jpy+1,jpy+in
          iwal=iwl+ihy(jwu)
          iwar=iwr+ihy(jwu)
          do jwd=1,lwnu
            iwal=iwal+1
            iwar=iwar+1
            do iwd=0,iwupwei-1
              iwadl=iwalk_ad(jpadl,ipael,iwal,iwd)
              iwadr=iwalk_ad(jpad,ipae,iwar,iwd)
              do iwe=1,isegdownwei
                mm=iwadl+iwe
                nn=iwadr+iwe
              if(mm.gt.nn) then
                mntmp=mm*(mm-1)/2+nn
              else
                mntmp=nn*(nn-1)/2+mm
              endif
c             vector2(mntmp)=vector2(mntmp)+wl
            vector2(mg6)=vector2(mg6)+vector1(mntmp)*wl*vector1(mntmp)

!              if(mntmp.eq.2) then
!                write(*,*)'  202',vector2(mntmp),wl
!           endif
              enddo
            enddo
          enddo
        enddo
      enddo
      goto 1000
! betwin act and dbl
300   jpl =mg1
      iwdl=mg2
      iwdr=mg3
      isegdownwei=iseg_downwei(ipae)

      call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
      do lp=1,mp
        iwal=lopu(1,lp)-1
        iwar=lopu(2,lp)-1
        jpe= lopu(3,lp)
        jwnu=iy(1,jpe)
        do ii=1,jwnu
          iwal=iwal+1
          iwar=iwar+1
          mm=iwalk_ad(jpadl,ipael,iwal,iwdl)
          nn=iwalk_ad(jpad,ipae,iwar,iwdr)
          do iwe=1,isegdownwei
            mm=mm+1                  ! iwl=iwalk_ad
            nn=nn+1                  ! iwl=iwalk_ad
              if(mm.gt.nn) then
                mntmp=mm*(mm-1)/2+nn
              else
                mntmp=nn*(nn-1)/2+mm
              endif
c             vector2(mntmp)=vector2(mntmp)+wl
            vector2(mg6)=vector2(mg6)+vector1(mntmp)*wl*vector1(mntmp)

!              if(mntmp.eq.2) then
!                write(*,*)'  302',vector2(mntmp),wl
!           endif
          enddo
        enddo
      enddo
      goto 1000
1000  return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Cllct(Strng,Vector,Val,nAtom,Coor,nCntr,mCntr,xyz,Temp,Ind,Typ,qMss,TMtrx,Lbl,lWrite,Deg,lAtom)
!***********************************************************************
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             May '91                                                  *
!***********************************************************************

use Symmetry_Info, only: iOper, nIrrep
use Slapaf_Info, only: AtomLbl, dMass
use PrintLevel, only: nPrint
use Molcas, only: LenIn
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: Strng
integer(kind=iwp), intent(in) :: nAtom, nCntr, mCntr
real(kind=wp), intent(out) :: Vector(3,nAtom), Val, xyz(3,nCntr+mCntr), Temp(3,nCntr+mCntr), qMss(nCntr+mCntr), &
                              TMtrx(3,nAtom,3,(nCntr+mCntr)), Deg
real(kind=wp), intent(in) :: Coor(3,nAtom)
integer(kind=iwp), intent(out) :: Ind(nCntr+mCntr,2)
character(len=6), intent(in) :: Typ
character(len=8), intent(in) :: Lbl
logical(kind=iwp), intent(inout) :: lWrite
logical(kind=iwp), intent(out) :: lAtom(nAtom)
integer(kind=iwp) :: i, iEnd, iFrst, iIrrep, iPhase, iPrint, iRout, isAtom, ixyz, j, jsAtom, nCent, nPar1, nPar2
real(kind=wp) :: Axis(3), Dummy(1), Perp_Axis(3,2), tx, ty, tz
logical(kind=iwp) :: ldB, lWarn
character(len=LenIn+5) :: Label
character(len=LenIn) :: AtName
character(len=3) :: Oper
real(kind=wp), external :: D_Bend, D_Bond, D_Cart, D_Trsn

iRout = 50
iPrint = nPrint(iRout)
ldB = .false.
lWarn = lWrite
if (iPrint > 20) lWrite = .true.
#ifdef _DEBUGPRINT_
call RecPrt(' In Cllct: Coor',' ',Coor,3,nAtom)
#endif

iFrst = 1
nCent = nCntr+mCntr

! Pick up cartesian coordinates associated with the
! internal coordinate

do ixyz=1,nCent
  call NxtWrd(Strng,iFrst,iEnd)
  Label = Strng(iFrst:iEnd)
  nPar1 = index(Label,'(')
  nPar2 = index(Label,')')
  iPhase = 0
  if ((nPar1 /= 0) .and. (nPar2 /= 0)) then
    AtName = '    '
    AtName = Label(1:nPar1-1)
    Oper = Label(nPar1+1:nPar2-1)
    call UpCase(Oper)
    if (index(Oper,'X') /= 0) iPhase = ieor(iPhase,1)
    if (index(Oper,'Y') /= 0) iPhase = ieor(iPhase,2)
    if (index(Oper,'Z') /= 0) iPhase = ieor(iPhase,4)

    ! Check if operator belongs to the current point group

    i = 0
    do j=1,nIrrep-1
      if (iPhase == iOper(j)) i = j
    end do
    if (i == 0) then
      call WarningMessage(2,'Error in Cllclt')
      write(u6,*) '*********** ERROR ***********'
      write(u6,*) ' Undefined symmetry operator '
      write(u6,*) '*****************************'
      write(u6,*) ' ',Oper
      write(u6,*)
      call Quit_OnUserError()
    end if
  else if ((nPar1 == 0) .and. (nPar2 == 0)) then
    AtName = '    '
    AtName = Strng(iFrst:iEnd)
    Oper = ' '
  else
    call WarningMessage(2,'Error in Cllclt')
    write(u6,*) '********** ERROR **********'
    write(u6,*) ' Syntax error in:'
    write(u6,*) ' ',Label
    write(u6,*) '***************************'
    write(u6,*)
    call Quit_OnUserError()
  end if

  ! Find corresponding coordinate

  jsAtom = 0
  do isAtom=1,nAtom
    if (AtName == AtomLbl(isAtom)) jsAtom = isAtom
  end do
  if (jsAtom == 0) then
    call WarningMessage(2,'Error in Cllclt')
    write(u6,*) '********** ERROR **********'
    write(u6,*) ' Unrecognizable atom label '
    write(u6,*) ' ',trim(AtName)
    write(u6,*) '***************************'
    write(u6,*)
    call Quit_OnUserError()
  end if
  lAtom(jsAtom) = .false.

  ! Store away the unique center index and the operator

  Ind(ixyz,1) = jsAtom
  Ind(ixyz,2) = iPhase
  xyz(:,ixyz) = Coor(:,jsAtom)
  ! Generate actual coordinate
  if (btest(iPhase,0)) xyz(1,ixyz) = -xyz(1,ixyz)
  if (btest(iPhase,1)) xyz(2,ixyz) = -xyz(2,ixyz)
  if (btest(iPhase,2)) xyz(3,ixyz) = -xyz(3,ixyz)
  if (Typ == 'DISSOC') qMss(ixyz) = dMass(jsAtom)
  iFrst = iEnd+1
end do

#ifdef _DEBUGPRINT_
call RecPrt(' Coordinates',' ',xyz,3,nCent)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Process the internal coordinate

if (Typ == 'X     ') then
  Val = xyz(1,1)
  Temp(:,:) = Zero
  Temp(1,1) = One
  if (lWrite) write(u6,'(1X,A,A,2X,F10.4,A)') Lbl,' : x-component=',Val,'/ bohr'
  Deg = D_Cart(Ind(1,1),nIrrep)
else if (Typ == 'Y     ') then
  Val = xyz(2,1)
  Temp(:,:) = Zero
  Temp(2,1) = One
  if (lWrite) write(u6,'(1X,A,A,2X,F10.4,A)') Lbl,' : y-component=',Val,'/ bohr'
  Deg = D_Cart(Ind(1,1),nIrrep)
else if (Typ == 'Z     ') then
  Val = xyz(3,1)
  Temp(:,:) = Zero
  Temp(3,1) = One
  if (lWrite) write(u6,'(1X,A,A,2X,F10.4,A)') Lbl,' : z-component=',Val,'/ bohr'
  Deg = D_Cart(Ind(1,1),nIrrep)
else if (Typ == 'STRTCH') then
  call Strtch(xyz,nCent,Val,Temp,lWrite,Lbl,Dummy,ldB)
  Deg = D_Bond(Ind(1:2,1),Ind(1:2,2),nIrrep)
else if (Typ == 'LBEND1') then
  call CoSys(xyz,Axis,Perp_Axis)
  call LBend(xyz,nCent,Val,Temp,lWrite,Lbl,Dummy,ldB,Axis,Perp_Axis(1,1),.false.)
  Deg = D_Bend(Ind(1:3,1),Ind(1:3,2),nIrrep)
else if (Typ == 'LBEND2') then
  call CoSys(xyz,Axis,Perp_Axis)
  call LBend(xyz,nCent,Val,Temp,lWrite,Lbl,Dummy,ldB,Axis,Perp_Axis(1,2),.true.)
  Deg = D_Bend(Ind(1:3,1),Ind(1:3,2),nIrrep)
else if (Typ == 'BEND  ') then
  call Bend(xyz,nCent,Val,Temp,lWrite,lWarn,Lbl,Dummy,ldB)
  Deg = D_Bend(Ind(1:3,1),Ind(1:3,2),nIrrep)
else if (Typ == 'TRSN  ') then
  call Trsn(xyz,nCent,Val,Temp,lWrite,lWarn,Lbl,Dummy,ldB)
  Deg = D_Trsn(Ind(1:4,1),Ind(1:4,2),nIrrep)
else if (Typ == 'OUTOFP') then
  call OutOfP(xyz,nCent,Val,Temp,lWrite,lWarn,Lbl,Dummy,ldB)
  Deg = D_Trsn(Ind(1:4,1),Ind(1:4,2),nIrrep)
else if (Typ == 'DISSOC') then
  call Dissoc(xyz,nCntr,mCntr,qMss,Val,Temp,lWrite,Lbl,Dummy,ldB)
  Deg = One
else
  call WarningMessage(2,'Error in Cllclt')
  write(u6,'(A,A)') ' Type declaration is corrupted: ',trim(Typ)
  call Quit_OnUserError()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
Deg = sqrt(Deg)

! Symmetrize and normalize
! Observe that the B matrix is defined in both symmetry adapted
! internal coordinates and symmetry adapted cartesian coordinates.

#ifdef _DEBUGPRINT_
call RecPrt(' Transformation vector',' ',Temp,3,nCent)
#endif

! Symmetrization of P: 1/g Sum over G of X(G)*GPG
!
! i) project away symmetry breaking displacements
! ii) divide the contribution for each center with
!     the multiplicity, g/u
! iii) sum over unique centers.

Vector(:,:) = Zero
TMtrx(:,:,:,:) = Zero
do ixyz=1,nCent
  jsAtom = Ind(ixyz,1)
  iPhase = Ind(ixyz,2)
  tx = One
  ty = One
  tz = One

  ! Step i
  ! Project away nonsymmetric displacements

  ! Restrict loop to the stabilizers of the center.
  do iIrrep=0,nIrrep-1
    if ((Coor(1,jsAtom) /= Zero) .and. btest(iOper(iIrrep),0)) cycle
    if ((Coor(2,jsAtom) /= Zero) .and. btest(iOper(iIrrep),1)) cycle
    if ((Coor(3,jsAtom) /= Zero) .and. btest(iOper(iIrrep),2)) cycle

    if (btest(iOper(iIrrep),0)) tx = Zero
    if (btest(iOper(iIrrep),1)) ty = Zero
    if (btest(iOper(iIrrep),2)) tz = Zero
  end do

  ! Step ii

  ! Rotate vector back to the unique center

  if (btest(iPhase,0)) tx = -tx
  if (btest(iPhase,1)) ty = -ty
  if (btest(iPhase,2)) tz = -tz
  TMtrx(1,jsAtom,1,ixyz) = tx
  TMtrx(2,jsAtom,2,ixyz) = ty
  TMtrx(3,jsAtom,3,ixyz) = tz
end do
call dGeMV_('N',3*nAtom,3*nCent,One,TMtrx,3*nAtom,Temp,1,Zero,Vector,1)
#ifdef _DEBUGPRINT_
call RecPrt('TMtrx',' ',TMtrx,3*nAtom,3*nCent)
call RecPrt(' symmetry adapted vector',' ',Vector,3,nAtom)
#endif

return

end subroutine Cllct

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SphCar(Win,nab,nijx,Scrt,nScrt,Coeff1,n1,Tr1,Pr1,Coeff2,n2,Tr2,Pr2,Wout,mab)
!***********************************************************************
!                                                                      *
!  Object: to project an one-electrom matrix from spherical harmonics  *
!          to cartesians.                                              *
!                                                                      *
!          Matrix on input  AB,ij                                      *
!          Matrix on output ij,ab                                      *
!                                                                      *
! Called from: OneEl                                                   *
!                                                                      *
! Calling    : RecPrt                                                  *
!              DGEMM_   (ESSL)                                         *
!              DGeTMO   (ESSL)                                         *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             February '90                                             *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN                                          *
!             Modified spherical harmonics to cartesians October '91.  *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nab, nijx, nScrt, n1, n2, mab
real(kind=wp), intent(in) :: Win(nab*nijx), Coeff1(nTri_Elem1(n1),nTri_Elem1(n1)), Coeff2(nTri_Elem1(n2),nTri_Elem1(n2))
real(kind=wp), intent(out) :: Scrt(nScrt), Wout(mab*nijx)
logical(kind=iwp), intent(in) :: Tr1, Pr1, Tr2, Pr2
integer(kind=iwp) :: k1, k2, l1, l2

l1 = nTri_Elem1(n1)
k1 = l1
if (Pr1) k1 = 2*n1+1
l2 = nTri_Elem1(n2)
k2 = l2
if (Pr2) k2 = 2*n2+1
#ifdef _DEBUGPRINT_
call recprt(' Win',' ',Win,nab,nijx)
call recprt('Coeff1',' ',Coeff1,l1,l1)
call recprt('Coeff2',' ',Coeff2,l2,l2)
#endif

if (Tr1 .and. Tr2) then

  ! Starting with A,Bij transforming to Bij,a

  call DGEMM_('T','T',k2*nijx,l1,k1,One,Win,k1,Coeff1,l1,Zero,Scrt,k2*nijx)

  ! Transform B,ija to ij,ab

  call DGEMM_('T','T',nijx*l1,l2,k2,One,Scrt,k2,Coeff2,l2,Zero,Wout,nijx*l1)

else if (Tr2) then

  ! Transpose from aB,ij to B,ija

  call DGeTmO(Win,l1,l1,k2*nijx,Scrt,k2*nijx)

  ! Start transforming B,ija to ij,ab

  call DGEMM_('T','T',nijx*l1,l2,k2,One,Scrt,k2,Coeff2,l2,Zero,Wout,nijx*l1)
else

  ! Starting with A,bij transforming to a,bij

  call DGEMM_('N','N',l1,l2*nijx,k1,One,Coeff1,l1,Win,k1,Zero,Scrt,l1)

  ! Transpose to ij,ab

  call DGeTmO(Scrt,l1*l2,l1*l2,nijx,Wout,nijx)
end if

return

end subroutine SphCar

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
*               1993, Per Boussard                                     *
************************************************************************
      SubRoutine M1Int(
#define _CALLING_
#include "int_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of the M1 integrals used  *
*         ECP calculations. The operator is the nuclear attraction     *
*         operator times a s-type gaussian function.                   *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by ECPMem                 *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
*             Physics, University of Stockholm, Sweden, October '93.   *
************************************************************************
      use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
      External TNAI, Fake, Cff2D, XRys2D
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables
      Real*8 C(3), TC(3), CoorAC(3,2), Coori(3,4), Coora(3,4)
      Character*80 Label
      Integer iDCRT(0:7), iAnga(4)
      Logical EQ, NoSpecial
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      iRout = 193
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In M1Int: A',' ',A,1,3)
         Call RecPrt(' In M1Int: RB',' ',RB,1,3)
         Call RecPrt(' In M1Int: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In M1Int: P',' ',P,nZeta,3)
         Write (6,*) ' In M1Int: la,lb=',' ',la,lb
      End If
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = 0
      iAnga(4) = 0
      mabMin = nabSz(Max(la,lb)-1)+1
      mabMax = nabSz(la+lb)
      If (EQ(A,RB)) mabMin=nabSz(la+lb-1)+1
      mAInt  = (mabMax-mabMin+1)
*
*     Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
       call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
       call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
*-----Compute FLOP's and size of work array which HRR will use.
*
      Call mHrr(la,lb,nFlop,nMem)
*
*-----Allocate Scratch for primitives and work area for HRR
*
      ip = 1
      ipAInt = ip
      k = nabSz(la+lb) - nabSz(Max(la,lb)-1)
      ip = ip + nZeta*Max(k,nMem)
      ipK = ip
      ip = ip + nZeta
      ipZ = ip
      ip = ip + nZeta
      ipZI = ip
      ip = ip + nZeta
      ipPx = ip
      ip = ip + nZeta
      ipPy = ip
      ip = ip + nZeta
      ipPz = ip
      ip = ip + nZeta
      If (ip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'M1Int: ip-1.gt.nArr*nZeta')
         Write (6,*) ' nArr,nZeta=',nArr,nZeta
         Write (6,*) ' nMem=',nMem
         Call Abend()
      End If
      ipTmp = ip
      mArray = nArr*nZeta - ip + 1
*
      call dcopy_(nZeta*Max(k,nMem),[Zero],0,Array(ipAInt),1)
*
*-----Loop over nuclear centers.
*
      kdc = 0
      Do 100 kCnttp = 1, nCnttp
         If (.Not.dbsc(kCnttp)%ECP) Go To 111
         If (dbsc(kCnttp)%nM1.eq.0) Go To 111
         Do 101 kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3)= dbsc(kCnttp)%Coor(1:3,kCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
            Do 102 lDCRT = 0, nDCRT-1
               Call OA(iDCRT(lDCRT),C,TC)
               call dcopy_(3,A,1,Coora(1,1),1)
               call dcopy_(3,RB,1,Coora(1,2),1)
               call dcopy_(6,Coora(1,1),1,Coori(1,1),1)
               If (.Not.EQ(A,RB) .or. .Not.EQ(A,TC)) Then
                  Coori(1,1) = Coori(1,1)+One
*                 Coora(1,1) = Coora(1,1)+One
               End If
               call dcopy_(3,TC,1,CoorAC(1,2),1)
               call dcopy_(3,TC,1,Coori(1,3),1)
               call dcopy_(3,TC,1,Coori(1,4),1)
               call dcopy_(3,TC,1,Coora(1,3),1)
               call dcopy_(3,TC,1,Coora(1,4),1)
*
               Do 1011 iM1xp=1, dbsc(kCnttp)%nM1
                  Gamma = dbsc(kCnttp)%M1xp(iM1xp)
*
*-----------------Modify the original basis. Observe that
*                 simplification due to A=B are not valid for the
*                 exponent index, eq. P-A=/=0.
*
                  Do 1012 iZeta = 1, nZeta
                     PTC2 = (P(iZeta,1)-TC(1))**2
     &                    + (P(iZeta,2)-TC(2))**2
     &                    + (P(iZeta,3)-TC(3))**2
                     Tmp0 = Zeta(iZeta)+Gamma
                     Tmp1 = Exp(-Zeta(iZeta)*Gamma*PTC2/Tmp0)
                     Array(ipK+iZeta-1)  = rKappa(iZeta) * Tmp1
                     Array(ipZ+iZeta-1)  = Tmp0
                     Array(ipZI+iZeta-1) = One/Tmp0
                     Array(ipPx+iZeta-1) =
     &                  (Zeta(iZeta)*P(iZeta,1)+Gamma*TC(1))/Tmp0
                     Array(ipPy+iZeta-1) =
     &                  (Zeta(iZeta)*P(iZeta,2)+Gamma*TC(2))/Tmp0
                     Array(ipPz+iZeta-1) =
     &                  (Zeta(iZeta)*P(iZeta,3)+Gamma*TC(3))/Tmp0
 1012             Continue
*
*-----------------Compute integrals with the Rys quadrature.
*
                  nT = nZeta
                  NoSpecial=.True.
                  Call Rys(iAnga,nT,Array(ipZ),Array(ipZI),nZeta,
     &                     [One],[One],1,Array(ipPx),nZeta,TC,1,
     &                     Array(ipK),[One],Coori,Coora,CoorAC,
     &                     mabmin,mabmax,0,0,Array(ipTmp),mArray,
     &                     TNAI,Fake,Cff2D,XRys2D,NoSpecial)
*
*-----------------Accumulate result for all nuclei. Take the charge on
*                 the center into account.
*
                  Factor = -dbsc(kCnttp)%Charge*dbsc(kCnttp)%M1cf(iM1xp)
     &                   * Fact
                  Call DaXpY_(nZeta*mAInt,Factor,Array(ipTmp),1,
     &                       Array(ipAInt),1)
                  If (iPrint.ge.99) Then
                     Call Recprt(' [a+b,0|A|0] in Array',' ',
     &                           Array(ipTmp),nZeta,mAInt)
                     Call RecPrt(' [a+b,0|A|0] in AInt',' ',
     &                           Array(ipAInt),nZeta,mAInt)
                  End If
*
 1011          Continue
 102        Continue
 101     Continue
 111     kdc = kdc + dbsc(kCnttp)%nCntr
 100  Continue
*
*-----Use the HRR to compute the required primitive integrals.
*
      Call HRR(la,lb,A,RB,Array(ipAInt),nZeta,nMem,ipIn)
      ii = ipAInt + ipIn - 1
*-----Move result
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,Array(ii),1,Final,1)
*
      If (iPrint.ge.99) Then
         Write (6,*) ' Result in M1Int'
         Do 150 ia = 1, nElem(la)
            Do 250 ib = 1, nElem(lb)
               Write (Label,'(A,I2,A,I2,A)')
     &               ' Final(',ia,',',ib,')'
               Call RecPrt(Label,' ',Final(1,ia,ib,1),nAlpha,nBeta)
 250        Continue
 150     Continue
      End If
*
*     Call GetMem(' Exit M1Int','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_real_array(ZInv)
         Call Unused_integer(nHer)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iChO)
         Call Unused_integer(nOrdOp)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
SUBROUTINE FULLCI(NEL,NORB,MULT,ONEINT,TWOINT,ECORE)
  ! Computes the CASPT2 second-order energy of the wavefunction PSI, provided
  ! that the full Fock matrix and necessary 1- and 2-el integrals are given.
  USE ISO_FORTRAN_ENV, ONLY: REAL64
  USE SECOND_QUANTIZATION
  USE WAVEFUNCTION
  USE DENSITY
  USE FOCKMATRIX
  USE ORBINT
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: NEL, NORB, MULT
  REAL(REAL64), INTENT(IN) :: ONEINT(NORB,NORB), TWOINT(NORB,NORB,NORB,NORB)
  REAL(REAL64), INTENT(IN) :: ECORE

  TYPE(WFN) :: PSI, SGM
  REAL(REAL64), ALLOCATABLE :: D1(:,:), D2(:,:,:,:)

  REAL(REAL64), ALLOCATABLE :: H(:,:,:,:), E(:)

  REAL(REAL64), ALLOCATABLE :: WORK(:)
  INTEGER, ALLOCATABLE :: IWORK(:)
  INTEGER :: LWORK, LIWORK, ISUPPZ(2), INFO
  REAL(REAL64) :: VL, VU
  INTEGER :: IL, IU

  INTEGER :: IA, IB, DETA, DETB, NDET
  INTEGER :: P, Q, R, S

  ! initialize the wavefunction

  CALL WFN_INIT(PSI,NEL,NORB,MULT)
  CALL WFN_INIT(SGM,NEL,NORB,MULT)

  ! construct the Full-CI hamiltonian

  ALLOCATE(H(PSI%NDETA,PSI%NDETB,PSI%NDETA,PSI%NDETB))

  DETB=LEX_INIT(PSI%NELB,PSI%NORB)
  DO IB=1,PSI%NDETB
    DETA=LEX_INIT(PSI%NELA,PSI%NORB)
    DO IA=1,PSI%NDETA

      SGM%COEF=0.0D0
      ! operate with sum over h_pq E_pq
      DO P=1,NORB
        DO Q=1,NORB
          CALL DET_EX1(ONEINT(P,Q),P,Q,DETA,DETB,SGM)
          DO R=1,NORB
            DO S=1,NORB
              CALL DET_EX2(0.5D0*TWOINT(P,Q,R,S),P,Q,R,S,DETA,DETB,SGM)
            END DO
          END DO
        END DO
      END DO

      H(:,:,IA,IB)=SGM%COEF
      H(IA,IB,IA,IB)=H(IA,IB,IA,IB)+ECORE

      DETA=LEX_NEXT(DETA)
    END DO
    DETB=LEX_NEXT(DETB)
  END DO

  ! diagonalize the entire hamiltonian
  NDET=PSI%NDETA*PSI%NDETB
  LWORK=NDET**2
  LIWORK=10*NDET
  ALLOCATE(WORK(LWORK))
  ALLOCATE(IWORK(LIWORK))
  ALLOCATE(E(NDET))
  IL=1
  IU=1

  ! find all eigenvalues/eigenvectors of H
  !call dsyev_('V','U',NCI,H,NCI,SPEC,WORK,NWORK,INFO)

  ! find lowest eigenvalue/eigenvector of H
  call dsyevr_('V','I','U',NDET,H,NDET,VL,VU,IL,IU,0.0D0,1,E,PSI%COEF,NDET,ISUPPZ,WORK,LWORK,IWORK,LIWORK,INFO)
  IF (INFO.NE.0) STOP 'FULLCI: diagonalization of FCI hamiltonian failed'

  WRITE(*,'(1X,A,F21.14)') 'Full-CI GS energy:', E(1)

  CALL WFN_PRINT(PSI,0.05D0)

  ALLOCATE(D1(NORB,NORB))
  ALLOCATE(D2(NORB,NORB,NORB,NORB))
  CALL D1_ANN(PSI,D1)
  CALL D2_ANN(PSI,D2)

  CALL WFN_ENERGY(0,NORB,0,D1,D2,ONEINT,TWOINT)

END SUBROUTINE FULLCI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE STRINF_GAS(STIN,IPRNT)
*
* Obtain string information for GAS expansion
*
* =====
*.Input
* =====
*
* /LUCINP/,/ORBINP/,/CSM/, /CGAS/, /GASSTR/
*
* =====
*.Output
* =====
*
* /STRINP/,/STINF/,/STRBAS/ and string information in STIN
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
*     (and /LUCINP/ not occuring here )
#include "mxpdim.fh"
#include "orbinp.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "strbas.fh"
#include "csm.fh"
#include "cstate.fh"
#include "lucinp.fh"
#include "stinf.fh"
#include "strinp.fh"
#include "irat.fh"
#include "crun.fh"
* modification Jeppe + Giovanni + Dongxia.
#include "distsym.fh"
*
#include "WrkSpc.fh"
*
      INTEGER STIN(*)
      INTEGER ZERO_ARR(1), IDUM(1)
*. A bit of scratch
C     DIMENSION IOCTYP(MXPNGAS)
*
*
* Some dummy initializtions
      LAC = 0 ! jwk-cleanup
*
      NTEST = 00
      NTEST = MAX(NTEST,IPRNT)
*
**.2 : Number of classes per string type and mappings between
**.    string types (/STINF/)
*
      CALL ZSTINF_GAS(IPRNT)
*
**.3 : Static memory for string information
*
       CALL MEMSTR_GAS
*
** 4 : Info about group of strings
*
*.First free address
*
*     Find maximum needed length of scratch.
*       MAXSCR = 2*NACOB+(IEL+1)(NACOB+1)
*       with IEL = MAX(NELFGP(IGRP=1,NGRP)
*
         IEL = 0
         DO IGRP = 1, NGRP
            IEL = MAX(IEL, NELFGP(IGRP))
         ENDDO
         NACOB_EFFECTIVE = NACOB
         IF (NACOB .EQ. 0) NACOB_EFFECTIVE = 1
         MAXSCR = 2*NACOB_EFFECTIVE +(IEL+1)*(NACOB_EFFECTIVE+1) +NSMST
         CALL GETMEM('KFREEL','ALLO','INTE',KFREEL, MAXSCR)
      DO IGRP = 1, NGRP
*. A gas group can be considered as a RAS group with 0 electrons in
*  RAS1, RAS3 !
        IGAS = IGSFGP(IGRP)
        IF(IGAS.EQ.1) THEN
          NORB1 = 0
        ELSE
          NORB1 = IELSUM(NOBPT,IGAS-1)
        END IF
        NORB2 = NOBPT(IGAS)
        NORB3 = NACOB-NORB1-NORB2
        MNRS1X = 0
        MXRS1X = 0
        MNRS3X = 0
        MXRS3X = 0
        IEL = NELFGP(IGRP)
        IOCTYPX = 1
*. Reverse lexical adresing schemes for each group of string
        CALL WEIGHT_LUCIA(STIN(KZ(IGRP)),IEL,  NORB1,  NORB2,  NORB3,
     &                      MNRS1X,MXRS1X, MNRS3X,  MXRS3X,STIN(KFREEL),
     &                      IPRNT )
*. Number of strings per symmetry in a given group
        CALL NSTRSO_GAS(     IEL,   NORB1,   NORB2,   NORB3,  MNRS1X,
     &                    MXRS1X,  MNRS3X,  MXRS3X,STIN(KFREEL),NACOB,
     &                  STIN(KNSTSGP(1)),
     &                  STIN(KISTSGP(1)),IOCTYPX,NSMST,IGRP,IPRNT)
*. Construct the strings ordered by symmetry
        CALL GENSTR_GAS(     IEL,  MNRS1X,  MXRS1X,  MNRS3X,  MXRS3X,
     &                  STIN(KISTSGP(1)),
     &                   IGRP,IOCTYPX,NSMST,STIN(KZ(IGRP)),STIN(KFREEL),
     &                  STIN(KSTREO(IGRP)),
     &                  STIN(KOCSTR(IGRP)),
*
     &                  STIN(KFREEL+IOCTYPX*NSMST),IGRP,IPRNT)
*
       CALL ICOPVE2(STIN(KNSTSGP(1)),1+(IGRP-1)*NSMST,NSMST,
     &              NSTFSMGP(1,IGRP))
       CALL ICOPVE2(STIN(KISTSGP(1)),1+(IGRP-1)*NSMST,NSMST,
     &              ISTFSMGP(1,IGRP))
      END DO
      CALL GETMEM('KFREEL','FREE','INTE',KFREEL, MAXSCR)
*
      INGRP_VAL = NGRP
      CALL GETMEM('ISMDFGP','ALLO','INTE',ISMDFGP, NSMST*NGRP)
      CALL GETMEM('NACTSYM','ALLO','INTE',NACTSYM, NGRP)
      CALL GETMEM('ISMSCR','ALLO','INTE',ISMSCR, NGRP)
      call SMDFGP_GEN(NGRP,NSMST,MXPNSMST,NSTFSMGP,
     &                iWork(NACTSYM),iWork(ISMDFGP))
*
      IF(NTEST.GE.10) THEN
        write(6,*) 'NGRP', NGRP
        write(6,*) 'NSMST*NGRP', NSMST*NGRP
        WRITE(6,*) ' Number of strings per group and symmetry '
        CALL IWRTMA10(STIN(KNSTSGP(1)),NSMST,NGRP,NSMST,NGRP)
        WRITE(6,*) ' Number of strings per group and symmetry(2) '
        CALL IWRTMA10(NSTFSMGP,NSMST,NGRP,MXPNSMST,NGRP)
      END IF
*
*. Min and max of sym for each group
*
      DO IGP = 1, NGRP
       MX = 1
       DO ISM = 1, NSMST
         IF(NSTFSMGP(ISM,IGP).GT.0) MX = ISM
       END DO
*
       MN = NSMST
       DO ISM = NSMST,1,-1
         IF(NSTFSMGP(ISM,IGP).GT.0) MN = ISM
       END DO
*
       MINMAX_SM_GP(1,IGP) = MN
       MINMAX_SM_GP(2,IGP) = MX
*
      END DO
      IF(NTEST.GT.5) THEN
        WRITE(6,*) ' MINMAX array for sym of groups '
        WRITE(6,*) ' =============================='
        CALL IWRTMA(MINMAX_SM_GP,2,NGRP,2,NGRP)
      END IF
*
*
* 4.5 : Creation/Annihilation mappings between different
*       types of strings
*
      DO IGRP = 1, NGRP
*
        IGAS = IGSFGP(IGRP)
        NGSOBP = NOBPT(IGAS)
*. First orbital in GAS spacce
        IGSOB = IELSUM(NOBPT,IGAS-1)+1
        IEL = NELFGP(IGRP)
        NSTINI = NSTFGP(IGRP)
*
*. Type of mapping : Only creation                  (LAC = 1)
*                    Only annihilation              (LAC = 2)
*                    Both annihilation and creation (LAC = 3)
* If only annihilation is present the string mapping arrays
* will only be over electronns
        IF(     ISTAC(IGRP,1).NE.0.AND.ISTAC(IGRP,2).NE.0) THEN
          LAC = 3
          IEC = 1
          LROW = NGSOBP
        ELSE IF(ISTAC(IGRP,1).NE.0.AND.ISTAC(IGRP,2).EQ.0) THEN
          LAC = 1
          IEC = 2
          LROW = IEL
        ELSE IF(ISTAC(IGRP,1).EQ.0.AND.ISTAC(IGRP,2).NE.0) THEN
          LAC = 2
          IEC = 0
          LROW = NGSOBP
        ELSE IF(ISTAC(IGRP,1).EQ.0.AND.ISTAC(IGRP,2).EQ.0) THEN
          LAC = 0
          IEC = 0
          LROW = 0
        END IF
*. Zero
        IF(LAC.NE.0) THEN
          IZERO = 0
          CALL ISETVC(STIN(KSTSTM(IGRP,1)),IZERO,LROW*NSTINI)
          CALL ISETVC(STIN(KSTSTM(IGRP,2)),IZERO,LROW*NSTINI)
        END IF
*
        IF(ISTAC(IGRP,2).NE.0) THEN
          JGRP = ISTAC(IGRP,2)
          CALL CRESTR_GAS(STIN(KOCSTR(IGRP)),
     &                    NSTFGP(IGRP),NSTFGP(JGRP),IEL,NGSOBP,  IGSOB,
     &                    STIN(KZ(JGRP)),STIN(KSTREO(JGRP)),0,IDUM,IDUM,
     &                    STIN(KSTSTM(IGRP,1)),
     &                    STIN(KSTSTM(IGRP,2)),NACOB,IPRNT)
*
        END IF
        IF(ISTAC(IGRP,1).NE.0) THEN
          JGRP = ISTAC(IGRP,1)
          CALL ANNSTR_GAS(STIN(KOCSTR(IGRP)),
     &                    NSTFGP(IGRP),NSTFGP(JGRP),IEL,NGSOBP,  IGSOB,
     &                    STIN(KZ(JGRP)),STIN(KSTREO(JGRP)),0,IDUM,IDUM,
     &                    STIN(KSTSTM(IGRP,1)),
     &                    STIN(KSTSTM(IGRP,2)),NACOB,IEC,LROW,IPRNT)
*
        END IF
      END DO
*
*
*. Now to supergroups , i.e. strings of with given number of elecs in
*  each GAspace
*
      CALL ISETVC(NSTFSMSPGP,0,MXPNSMST*NTSPGP)
      MXNSTR = -1
      DO ITP = 1, NSTTYP
*. Loop over supergroups of given type . i.e. strings
*  with given occupation in each GAS space
        DO IGRP = 1, NSPGPFTP(ITP)
          IGRPABS = IGRP-1 + IBSPGPFTP(ITP)
          CALL NSTPTP_GAS(    NGAS,
     &                    ISPGPFTP(1,IGRPABS),
     &                    IWORK(KNSTSGP(1)),
     &                   NSMST,IWORK(KNSTSO(ITP)),IGRP,MXNSTRFSG,NSMCLS,
     &                     NSMCLSE,NSMCLSE1)
*
*
          MXSMCLS   = MAX(MXSMCLS,NSMCLS)
          MXSMCLSE  = MAX(MXSMCLSE,NSMCLSE)
          MXSMCLSE1 = MAX(MXSMCLSE1,NSMCLSE1)
*
          MXNSTR = MAX(MXNSTR,MXNSTRFSG)
        END DO
*
        CALL ICOPMT(iWORK(KNSTSO(ITP)),
     &                  NSMST,
     &              NSPGPFTP(ITP),
     &              NSTFSMSPGP(1,IBSPGPFTP(ITP)),
     &               MXPNSMST,NSPGPFTP(ITP))
*. Corresponding offset array : Each supergroup is generated individually
*. so each supergroup starts with offset 1 !
        CALL ZSPGPIB(iWORK(KNSTSO(ITP)),iWORK(KISTSO(ITP)),
     &               NSPGPFTP(ITP),NSMST)
*
        IF(NTEST.GE.5) THEN
          WRITE(6,*)
     &    ' Number of strings per sym (row) and supergroup(column)',
     &    ' for type = ', ITP
          CALL IWRTMA(iWORK(KNSTSO(ITP)),NSMST,NSPGPFTP(ITP),
     &                NSMST,NSPGPFTP(ITP))
          WRITE(6,'(A,3I6)') ' NSMCLS,NSMCLSE,NSMCLSE1=',
     &                         NSMCLS,NSMCLSE,NSMCLSE1
          WRITE(6,*)
        END IF
*
      END DO
*. Number of electron in each AS for each supergroup
      CALL ZNELFSPGP(IPRNT)
*
* Number of holes per supergroup
      DO IISPGP = 1, NTSPGP
        NHOLE = 0
        DO IGAS = 1, NGAS
          IF(IPHGAS(IGAS).EQ.2) NHOLE = NHOLE + NELFSPGP(IGAS,IISPGP)
        END DO
        NHLFSPGP(IISPGP) = NHOLE
      END DO
      IF(NTEST.GE.10) THEN
      WRITE(6,*) ' Number of electrons in hole spaces per supergroup '
      CALL IWRTMA(NHLFSPGP,1,NTSPGP,1,NTSPGP)
      END IF
*. Largest number of strings belonging to given supergroup
*. Largest Occupation block for given supergroup and sym
      MAX_STR_OC_BLK = -1
      MAX_STR_SPGP = 0
      DO ISPGP = 1, NTSPGP
        NSTR = IELSUM(NSTFSMSPGP(1,ISPGP),NSMST)
        MAX_STR_SPGP = MAX(MAX_STR_SPGP,NSTR)
        NEL = IELSUM(NELFSPGP(1,ISPGP),NGAS)
        DO ISTSM = 1, NSMST
          MAX_STR_OC_BLK
     &  = MAX(MAX_STR_OC_BLK,(NEL+4)*NSTFSMSPGP(ISTSM,ISPGP))
CMOD &  = MAX(MAX_STR_OC_BLK,NEL*NSTFSMSPGP(ISTSM,ISPGP))
        END DO
      END DO
*
      IF(NTEST.GE.2) THEN
      WRITE(6,*)
     & ' Largest number of strings of given supergroup        ',
     & MAX_STR_SPGP
      WRITE(6,*) ' Largest block of string occupations ',
     &              MAX_STR_OC_BLK
*
      WRITE(6,*)
     & ' Largest number of strings of given supergroup and sym', MXNSTR
      END IF
C?    WRITE(6,'(A,3I6)') ' MXSMCLS,MXSMCLSE,MXSMCLSE1 = ',
C?   &                     MXSMCLS,MXSMCLSE,MXSMCLSE1
*
*
* Possible occupation classes
*
      ZERO_ARR(1)=0
      CALL OCCLS(         2,  NMXOCCLS,IWORK(KIOCLS),  NACTEL,    NGAS,
     &           IGSOCC(1,1),IGSOCC(1,2),       0,ZERO_ARR,   NOBPT)
*
* Maps creation/annihilation of given gas orb from given supergroup
* gives new supergroup.
*
      IZERO = 0
      CALL ISETVC(iWORK(KSPGPCR),IZERO,NGAS*NTSPGP)
      CALL ISETVC(iWORK(KSPGPAN),IZERO,NGAS*NTSPGP)
*
      DO ISTTYP = 1,NSTTYP
*. Creation map from this type
        IIEL = NELFTP(ISTTYP)
*. Type of string with one elec more
        ISTTYPC = 0
        DO JSTTYP = 1, NSTTYP
          IF(MOD(ISTTYP,2).EQ.MOD(JSTTYP,2).AND.
     &       NELFTP(JSTTYP).EQ.IIEL+1           ) ISTTYPC = JSTTYP
        END DO
C?      WRITE(6,*) ' ISTTYP and ISTTYPC ',ISTTYP,ISTTYPC
        IF(NSPGPFTP(ISTTYP).GT.0) THEN
*
        IF(ISTTYPC.GE.1.AND.NSPGPFTP(ISTTYPC).GT.0) THEN
           CALL SPGP_AC(NELFSPGP(1,1),
     &                  NSPGPFTP(ISTTYP),
     &                  NELFSPGP(1,1),NSPGPFTP(ISTTYPC),NGAS,MXPNGAS,2,
     &                  iWORK(KSPGPCR),
     &                  IBSPGPFTP(ISTTYP),
     &                  IBSPGPFTP(ISTTYPC))
        ELSE
        END IF
*. Annihilation maps
        ISTTYPA = 0
        DO JSTTYP = 1, NSTTYP
          IF(MOD(ISTTYP,2).EQ.MOD(JSTTYP,2).AND.
     &       NELFTP(JSTTYP).EQ.IIEL-1           ) ISTTYPA = JSTTYP
        END DO
C?      WRITE(6,*) 'ISTTYP, ISTTYPA', ISTTYP,ISTTYPA
        IF(ISTTYPA.GE.1 .AND.NSPGPFTP(ISTTYPA).GT.0) THEN
           CALL SPGP_AC(NELFSPGP(1,1),
     &                  NSPGPFTP(ISTTYP),
     &                  NELFSPGP(1,1),NSPGPFTP(ISTTYPA),NGAS,MXPNGAS,1,
     &                  iWORK(KSPGPAN),
     &                  IBSPGPFTP(ISTTYP),
     &                  IBSPGPFTP(ISTTYPA))
        END IF
        END IF
      END DO
*
C     WRITE(6,*) ' Memory Check at end of STRINF_GAS  '
      CALL MEMCHK
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Ignacio Fdez. Galvan                             *
************************************************************************
*
* Compute and store roots and weights for a shifted Legendre quadrature,
* used for boot-strapping Rys roots and weights.
* Different sets of roots and weights are computed
*
      Module Leg_RW
      Implicit None
      Integer, Dimension(11), Parameter :: naux=[30,35,40,45,50,
     &                                           55,60,65,70,75,300]
      Real*8, Dimension(:,:), Allocatable :: Leg_r, Leg_w

      Contains

      Subroutine SetAux(eps)
      Real*8, Intent(In) :: eps
      Integer, Parameter :: nquad=Size(naux)
      Real*8, Dimension(:), Allocatable :: a, b
      Integer :: maux, i, j, Err
#include "stdalloc.fh"
#include "real.fh"
      If (Allocated(Leg_r)) Return
      maux = MaxVal(naux)
      Call mma_allocate(Leg_r,maux,nquad,label="Leg_r")
      Call mma_allocate(Leg_w,maux,nquad,label="Leg_w")
      Call mma_allocate(a,maux)
      Call mma_allocate(b,maux)
      Do j = 1, nquad
        Do i = 1, naux(j)
          a(i) = Half
          If (i == 1) Then
            b(1) = One
          Else
            b(i) = Quart/(Four-One/(i-1)**2)
          End If
        End Do
        Call GaussQuad(naux(j),a,b,eps,Leg_r(1,j),Leg_w(1,j),Err)
        If (Err.ne.0) Then
          write(6,*) Err
          Call WarningMessage(2,'Error in GaussQuad')
          Call AbEnd()
        End If
        Do i = 1, naux(j)
          Leg_r(i,j)=Leg_r(i,j)*Leg_r(i,j)
        End Do
      End Do
      Call mma_deallocate(a)
      Call mma_deallocate(b)
      End Subroutine SetAux

      Subroutine UnSetAux
#include "stdalloc.fh"
      If (Allocated(Leg_r)) Call mma_deallocate(Leg_r)
      If (Allocated(Leg_w)) Call mma_deallocate(Leg_w)
      End Subroutine UnSetAux

      End Module Leg_RW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Naoki Nakatani                                   *
!***********************************************************************

subroutine BLOCK_DENSI_RASSCF(jRoot,D,DS,PS,PA,PT)
! Load 2RDM from Block DMRG and compute D, DS, PS, and PA
! Written by N. Nakatani, Oct. 2014
!
! D   : 1-El density matrix
!
! DS  : spin density matrix
!
! PS  : symmetrized 2-El density matrix
!
! PA  : anti-symmetrized 2-El density matrix
!
! PT  : working space for 2-El density matrix (NAC**4)

use rasscf_data, only: NACPAR, NACPR2, NAC, mxSym
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: jRoot
real(kind=wp), intent(out) :: D(NACPAR), DS(NACPAR), PS(NACPR2), PA(NACPR2)
real(kind=wp), intent(inout) :: PT(NAC,NAC,NAC,NAC)
#include "general.fh"
integer(kind=iwp) :: I, IJ_pack, IJKL_pack, J, K, L, LLIM
real(kind=wp) :: D1sum

D(:) = Zero
DS(:) = Zero
PS(:) = Zero
PA(:) = Zero

if (NACTEL > 1) then
  call block_load2pdm(NAC,PT,jRoot,jRoot)
  ! No spin density is obtained from Spin-adapted DMRG (Block's default)
  ! TODO: 1-El density matrix should be computed with spin-orbital index
  !       to store spin density with Block code...
  IJ_pack = 1
  do J=1,NAC
    do I=1,J
      D1sum = Zero
      do K=1,NAC
        D1sum = D1sum+PT(K,K,I,J)
      end do
      D(IJ_pack) = D1sum/(NACTEL-1)
      !DS(IJ_pack) = Zero
      IJ_pack = IJ_pack+1
    end do
  end do

  IJKL_pack = 0
  do I=1,NAC
    do J=1,I
      do K=1,I
        LLIM = K
        if (K == I) LLIM = J
        do L=1,LLIM
          IJKL_pack = IJKL_pack+1
          if (K == L) then
            PS(IJKL_pack) = Half*PT(L,K,J,I)
            !PA(IJKL_pack) = Zero
          else
            PS(IJKL_pack) = Half*(PT(L,K,J,I)+PT(K,L,J,I))
            PA(IJKL_pack) = Half*(PT(L,K,J,I)-PT(K,L,J,I))
          end if
        end do
      end do
    end do
  end do
else
  ! special case for NACTEL = 1
  call block_load1pdm(NAC,PT,jRoot,jRoot)
  IJ_pack = 1
  do J=1,NAC
    do I=1,J
      D(IJ_pack) = PT(I,J,1,1)
      IJ_pack = IJ_pack+1
    end do
  end do
end if

return

end subroutine BLOCK_DENSI_RASSCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine AF3X3LEV(RDIST,DELTAE,C3val,C6val,C8val,De,ULR)
!=======================================================================
!*** Simplified version of AF3x3potRet which does not return derivatives

use Constants, only: Zero, One, Two, Three, Six, Eight, Twelve
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: RDIST, DELTAE, C3val, C6val, C8val, De
real(kind=wp), intent(out) :: ULR
integer(kind=iwp) :: I, J, L
real(kind=wp) :: DDe(3,3), DM1(3,3), DM3(3,3), DM5(3,3), DR(3,3), EIGVEC(3,1), H(3,3), M1, M3, M5, Q(3,3), RDIST2, RDIST3, RET, &
                 RETPi, RETSig, W(3)

M1 = C3val
M3 = C6val
M5 = C8val
! what is this number?
RET = 9.36423830e-4_wp*RDIST
RETSig = cos(RET)+(RET)*sin(RET)
RETPi = RETSig-RET**2*cos(RET)
RDIST2 = RDIST**2
RDIST3 = RDIST*RDIST2
!write(25,*) 'Variables = "r", "U(r)","U(r)-U(r)^2/(4De)"'
!write(25,*) 'zone T = "U(r)"'
! Initialize interaction matrix to 0.0
do I=1,3
  H(I,I) = Zero
end do
! Prepare interation matrix  H
H(1,1) = -(M1*RETSig+M3/(RDIST3)+M5/(RDIST3*RDIST2))/(Three*RDIST3)
H(1,2) = -sqrt(Two)*H(1,1)
H(2,1) = H(1,2)
H(1,3) = M1*RETPi/(sqrt(Six)*RDIST3)
H(3,1) = H(1,3)
H(2,2) = 2*H(1,1)+DELTAE
H(2,3) = H(1,3)/sqrt(Two)
H(3,2) = H(2,3)
H(3,3) = DELTAE
! Prepare radial derivative of interaction matrix (? is it needed ?)
DR(1,1) = (THree*M1*RETSig+Six*M3/RDIST3+Eight*M5/(RDIST3*RDIST2))/(Three*RDIST3*RDIST)
DR(1,2) = -sqrt(Two)*DR(1,1)
DR(2,1) = DR(1,2)
DR(2,2) = Two*DR(1,1)
DR(1,3) = -Three*H(1,3)/RDIST
DR(3,1) = DR(1,3)
DR(2,3) = -Three*H(2,3)/RDIST
DR(3,2) = DR(2,3)
DR(3,3) = Zero
! Partial derivative of interaction matric  H  w.r.t.  C3
DM1(1,1) = -(RETSig+M1/(Two*De*RDIST3))/(Three*RDIST3)
DM1(1,2) = -sqrt(Two)*DM1(1,1)
DM1(2,1) = DM1(1,2)
DM1(2,2) = Two*DM1(1,1)
DM1(1,3) = RETPi/(sqrt(Six)*RDIST3)
DM1(3,1) = DM1(1,3)
DM1(2,3) = DM1(1,3)/sqrt(Two)
DM1(3,2) = DM1(2,3)
DM1(3,3) = Zero
! Partial derivative of interaction matric  H  w.r.t.  C6
DM3(1,1) = -One/(Three*RDIST3**2)
DM3(1,2) = -sqrt(Two)*DM3(1,1)
DM3(1,3) = Zero
DM3(2,1) = DM3(1,2)
DM3(2,2) = Two*DM3(1,1)
DM3(2,3) = Zero
DM3(3,1) = DM3(1,3)
DM3(3,2) = DM3(2,3)
DM3(3,3) = Zero
! Partial derivative of interaction matric  H  w.r.t.  C8
DM5(1,1) = DM3(1,1)/(RDIST2)
DM5(1,2) = DM3(1,2)/(RDIST2)
DM5(1,3) = Zero
DM5(2,1) = DM3(1,2)
DM5(2,2) = DM3(2,2)/(RDIST2)
DM5(2,3) = Zero
DM5(3,1) = DM5(1,3)
DM5(3,2) = DM5(2,3)
DM5(3,3) = Zero
! Partial derivative of interaction matric  H  w.r.t.  De
DDe(1,1) = M1**2/(Twelve*(RDIST3*De)**2)
DDe(1,2) = -sqrt(Two)*DDe(1,1)
DDe(1,3) = Zero
DDe(2,1) = DDe(1,2)
DDe(2,2) = Two*DDe(1,1)
DDe(2,3) = Zero
DDe(3,1) = DDe(1,3)
DDe(3,2) = DDe(2,3)
DDe(3,3) = Zero
! Call subroutine to prepare and invert interaction matrix  H
call ZHEEVJ3(H,Q,W)
L = 1
! Nor - identify the lowest eigenvalue of  H  and label it  L
do J=2,3
  if (W(J) < W(L)) L = J
end do
ULR = -W(L)
EIGVEC(:,1) = Q(:,L)
write(u6,*) EIGVEC
!write(25,600) RDIST,ULR
!600 format(2ES16.7)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccc
!Modulus = SQRABS(Z)
!Modulus = real(Z,kind=wp)**2

return

end subroutine AF3X3LEV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FIJTD(INTSYM,INDX,C1,C2,TDMO)

use mrci_global, only: IRC, IVVER, LSYM, LUSYMB, NBAST, NVIR, NVPAIR
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: INTSYM(*), INDX(*)
real(kind=wp), intent(in) :: C1(*), C2(*)
real(kind=wp), intent(inout) :: TDMO(NBAST,NBAST)
integer(kind=iwp) :: IADD10, IC1, IC2, ICHK, IIN, ILEN, IND, INDA, INDB, INDI, INUM, IVL, NA, NB, NI, NK, NS1, NS1L
real(kind=wp) :: TERM
integer(kind=iwp), external :: JSUNP
real(kind=r8), external :: DDOT_

!------
! POW: Unnecessary but warning stopping initializations
NI = -1234567
NK = -1234567
!------
ICHK = 0
IADD10 = IAD10(8)
do
  call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
  call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
  ILEN = ICOP1(nCOP+1)
  if (ILEN < 0) exit
  do IIN=1,ILEN
    IND = ICOP1(IIN)
    if (ICHK /= 0) then
      ICHK = 0
      INDI = IND
      NI = ibits(INDI,0,10)
      NK = ibits(INDI,10,10)
    else if (IND == 0) then
      ICHK = 1
    else
      IVL = ibits(IND,0,6)
      IC2 = ibits(IND,6,13)
      IC1 = ibits(IND,19,13)
      if (IVL == IVVER) then
        TDMO(NI,NK) = TDMO(NI,NK)+COP(IIN)*C1(IC1)*C2(IC2)
        if (NI /= NK) TDMO(NK,NI) = TDMO(NK,NI)+COP(IIN)*C2(IC1)*C1(IC2)
      else
        INDA = IRC(IVL)+IC1
        INDB = IRC(IVL)+IC2
        NA = INDX(INDA)
        NB = INDX(INDB)
        NS1 = JSUNP(INTSYM,INDA)
        NS1L = MUL(NS1,LSYM)
        INUM = NVIR(NS1L)
        if (IVL >= 2) INUM = NVPAIR(NS1L)
        TERM = DDOT_(INUM,C1(NA+1),1,C2(NB+1),1)
        TDMO(NI,NK) = TDMO(NI,NK)+COP(IIN)*TERM
        if (NI /= NK) then
          TERM = DDOT_(INUM,C2(NA+1),1,C1(NB+1),1)
          TDMO(NK,NI) = TDMO(NK,NI)+COP(IIN)*TERM
        end if
      end if
    end if
  end do
end do

return

end subroutine FIJTD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1992, Roland Lindh                                *
*               1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Inputh(Run_MCLR)
************************************************************************
*                                                                      *
* Object: input module for the gradient code                           *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             September 1991                                           *
*                                                                      *
*             Modified to complement GetInf, January 1992              *
************************************************************************
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iChTbl, iOper, lIrrep, lBsFnc
      use Temporary_Parameters
      use Real_Info, only: CutInt
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "Molcas.fh"
#include "real.fh"
#include "disp.fh"
#include "disp2.fh"
#include "iavec.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "SysDef.fh"
      Logical TstFnc, Type, Slct
c      Logical DoCholesky
      Character*1 xyz(0:2)
      Character*8 Label,labelop
      Character*32 Label2
      character*4 lab
      Logical Run_MCLR
      Character*80  KWord, Key
      Integer iSym(3), iTemp(3*MxAtom)
      Data xyz/'x','y','z'/
*
c      Call DecideOnCholesky(DoCholesky)
c      If (DoCholesky) Then
c       write(6,*)'** Cholesky or RI/DF not yet implemented in McKinley '
c       call abend()
c      EndIf

      iRout=99
      Do i = 1, nRout
         nPrint(i) = 5
      End Do
      show=.false.
      Onenly = .False.
      nmem=0
      Test   = .False.
      TRSymm = .false.
      lEq    = .False.
      Slct   = .False.
      PreScr   = .true.
      lGrd=.True.
      lHss=.True.
      Nona=.false.
      Run_MCLR=.True.
      CutInt = 1.0D-07
      ipert=2
      iCntrl=1
      Call lCopy(mxpert,[.true.],0,lPert,1)
      sIrrep=.false.
      iprint=0
      Do 109 i = 1, 3*MxAtom
         IndxEq(i) = i
 109  Continue
*
*     KeyWord directed input
*
      LuRd=5
      Call RdNLst(LuRd,'MCKINLEY')
 998  Read(5,'(A72)',END=977,ERR=988) Key
      KWord = Key
      Call UpCase(KWord)
      If (KWord(1:1).eq.'*')    Go To 998
      If (KWord.eq.'')       Go To 998
*     If (KWord(1:4).eq.'EQUI') Go To 935
*     If (KWord(1:4).eq.'NOTR') Go To 952
*     If (KWord(1:4).eq.'NOIN') Go To 953
      If (KWord(1:4).eq.'SHOW') Go To 992
      If (KWord(1:4).eq.'MEM ') Go To 697
*
      If (KWord(1:4).eq.'CUTO') Go To 942
      If (KWord(1:4).eq.'VERB') Go To 912
      If (KWord(1:4).eq.'NOSC') Go To 965
      If (KWord(1:4).eq.'ONEO') Go To 990
      If (KWord(1:4).eq.'SELE') Go To 960
      If (KWord(1:4).eq.'REMO') Go To 260
      If (KWord(1:4).eq.'PERT') Go To 975
      If (KWord(1:4).eq.'TEST') Go To 991
      If (KWord(1:4).eq.'EXTR') Go To 971
      If (KWord(1:4).eq.'NONA') Go To 972
      If (KWord(1:4).eq.'NOMC') Go To 973
      If (KWord(1:4).eq.'END ') Go To 997
      Write (6,*) 'InputH: Illegal keyword'
      Write (6,'(A,A)') 'KWord=',KWord
      Call Abend()
 977  Write (6,*) 'InputH: end of input file.'
      Write (6,'(A,A)') 'Last command=',KWord
      Call Abend()
 988  Write (6,*) 'InputH: error reading input file.'
      Write (6,'(A,A)') 'Last command=',KWord
      Call Abend()
*                                                                      *
****** MEM  ************************************************************
*                                                                      *
 697  Read(5,*) nmem
      nmem=nmem*1048576/rtob
      goto 998
*                                                                      *
****** PERT ************************************************************
*                                                                      *
*     Select which part of the Hessian will be compiuted.
*
975   Read(5,'(A)',Err=988) KWord
      If (KWord(1:1).eq.'*') Go To 975
      If (KWord.eq.'')    Go To 975
      Call UpCase(KWord)
      Lab=KWORD(1:4)
      If (KWORD(1:4).eq.'HESS') Then
         ipert=2
      Else If (KWORD(1:4).eq.'GEOM') Then
         ipert=1
      Else
         Write (6,*) 'InputH: Illegal perturbation keyword'
         Write (6,'(A,A)') 'KWord=',KWord
         Call Abend()
      End If

      Goto 998
*                                                                      *
****** EQUI ************************************************************
*                                                                      *
*     Equivalence option
*
*935  Continue
*     lEq=.True.
*936  Read(5,'(A)',Err=988) KWord
*     If (KWord(1:1).eq.'*') Go To 936
*     If (KWord.eq.'')    Go To 936
*     Read(KWord,*) nGroup
*     Do 937 iGroup = 1, nGroup
*938     Read(5,'(A)',Err=988) KWord
*        If (KWord(1:1).eq.'*') Go To 938
*        If (KWord.eq.'')    Go To 938
*        Read(KWord,*) nElem,(iTemp(iElem),iElem=1,nElem)
*        Do 939 iElem=2,nElem
*           IndxEq(iTemp(iElem)) = iTemp(1)
*           Direct(iTemp(iElem)) = .False.
*939      Continue
*937   Continue
*     Go To 998
*                                                                      *
****** CUTO ************************************************************
*                                                                      *
*     Cuttoff for computing primitive gradients
*
 942  Read(5,*) Cutint
*     If (KWord(1:1).eq.'*') Go To 942
*     If (KWord.eq.'')    Go To 942
*     Read(KWord,*,Err=988) CutInt
      CutInt = Abs(CutInt)
      Go To 998
*                                                                      *
****** NOIN ************************************************************
*                                                                      *
*     Disable the utilization of translational and
*     rotational invariance of the energy in the
*     computation of the molecular gradient.
*
*953  TRSymm=.False.
*     Go To 998
*                                                                      *
****** SELE ************************************************************
*                                                                      *
*     selection option
*
 960  Continue
      slct=.true.
      Call lCopy(mxpert,[.false.],0,lPert,1)
*962  Continue
      Read(5,*) nslct
*     If (KWord(1:1).eq.'*') Go To 962
*     If (KWord.eq.'')    Go To 962
*     Read(KWord,*) nSlct
*
      Read(5,*) (iTemp(iElem),iElem=1,nSlct)
      Do 964 iElem=1,nSlct
         lpert(iTemp(iElem)) = .True.
964   Continue
      Go To 998
*                                                                      *
****** REMO ************************************************************
*                                                                      *
 260  Continue
      Slct=.true.
      Read(5,*) nslct
*
      Read(5,*) (iTemp(iElem),iElem=1,nSlct)
      Do 264 iElem=1,nSlct
         lpert(iTemp(iElem)) = .false.
264   Continue
      Go To 998
*                                                                      *
****** NOSC ************************************************************
*                                                                      *
*     Change default for the prescreening.
*
 965  PreScr  = .False.
      Go To 998
*                                                                      *
****** ONEO ************************************************************
*                                                                      *
*     Do not compute two electron integrals.
*
 990  Onenly = .TRUE.
      Go To 998
*                                                                      *
****** TEST ************************************************************
*                                                                      *
*     Process only the input.
*
 991  Test = .TRUE.
      Go To 998
*                                                                      *
****** SHOW ************************************************************
*                                                                      *
*-----Raise the printlevel to show gradient contributions
*
 992  Continue
      Show=.true.
      Go To 998
*                                                                      *
****** EXTR ************************************************************
*                                                                      *
*     Put the program name and the time stamp onto the extract file
*
971   Write (6,*) 'InputH: EXTRACT option is redundant and is ignored!'
      Go To 998
*                                                                      *
****** VERB ************************************************************
*                                                                      *
*     Verbose output
*
 912  nPrint( 1)=6
      nPrint(99)=6
      Go To 998
*                                                                      *
****** NONA ************************************************************
*                                                                      *
*     Compute the anti-symmetric overlap gradient only.
*
972   Nona=.true.
      Run_MCLR=.False.
      Go To 998
*                                                                      *
****** NOMC ************************************************************
*                                                                      *
*     Request no automatic run of MCLR
*
973   Run_MCLR=.False.
      Go To 998
************************************************************************
*                                                                      *
*                          End of input section.                       *
*                                                                      *
************************************************************************
 997  Continue
*
      iPrint=nPrint(iRout)
*
      iOpt = 1
      if (onenly) iopt=0
      iRC = -1
      Lu_Mck=35
      Call OpnMck(irc,iOpt,'MCKINT',Lu_Mck)
      If (iRC.ne.0) Then
         Write (6,*) 'InputH: Error opening MCKINT'
         Call Abend()
      End If
      If (ipert.eq.1) Then
        Label2='Geometry'
        LabelOp='PERT    '
        irc=-1
        iopt=0
        Call cWrMck(iRC,iOpt,LabelOp,1,Label2,iDummer)
        sIrrep=.true.
        iCntrl=1
      Else If (ipert.eq.2) Then
        Label2='Hessian'
        LabelOp='PERT    '
        Call cWrMck(iRC,iOpt,LabelOp,1,Label2,iDummer)
        iCntrl=1
      Else If (ipert.eq.3) Then
        LabelOp='PERT    '
        Label2='Magnetic'
        Call cWrMck(iRC,iOpt,LabelOp,1,Label2,iDummer)
        Write (6,*) 'InputH: Illegal perturbation option'
        Write (6,*) 'iPert=',iPert
        Call Abend()
      Else If (ipert.eq.4) Then
        LabelOp='PERT    '
        Label2='Relativistic'
        Call cWrMck(iRC,iOpt,LabelOp,1,Label2,iDummer)
        Write (6,*) 'InputH: Illegal perturbation option'
        Write (6,*) 'iPert=',iPert
        Call Abend()
      Else
        Write (6,*) 'InputH: Illegal perturbation option'
        Write (6,*) 'iPert=',iPert
        Call Abend()
      End If

*     If (lEq)  TRSymm=.False.
*     If (Slct) TRSymm=.False.
*
      mDisp = 0
      mdc = 0
      Do 10 iCnttp = 1, nCnttp
         Do 20 iCnt = 1, dbsc(iCnttp)%nCntr
            mdc = mdc + 1
            mDisp = mDisp + 3*(nIrrep/dc(mdc)%nStab)
 20      Continue
 10   Continue
*
      Write (6,*)
      Write (6,'(20X,A,E10.3)')
     &  ' Threshold for contributions to the gradient or Hessian:',
     &   CutInt
      Write (6,*)
*
      If (Nona) Then
         Write (6,*)
         Write (6,'(20X,A)')
     &   ' McKinley only is computing the antisymmetric gradient '//
     &   ' of the overlap integrals for the NonAdiabatic Coupling.'
         Write (6,*)
      End If
*
      If (iCntrl.eq.1) Then
*
*
*     Generate symmetry adapted cartesian displacements
*
      If (iPrint.ge.6) Then
      Write (6,*)
      Write (6,'(20X,A)')
     &           '********************************************'
      Write (6,'(20X,A)')
     &           '* Symmetry Adapted Cartesian Displacements *'
      Write (6,'(20X,A)')
     &           '********************************************'
      Write (6,*)
      End If
      Call ICopy(MxAtom*8,[0],0,IndDsp,1)
      Call ICopy(MxAtom*3,[0],0,InxDsp,1)
      Call GetMem('ATDISP','ALLO','INTE',ipad,mdisp)
      Call GetMem('DEGDISP','ALLO','INTE',ipdd,mdisp)
      nDisp = 0
      Do 100 iIrrep = 0, nIrrep-1
         lDisp(iIrrep) = 0
         Type = .True.
*        Loop over basis function definitions
         mdc = 0
         mc = 1
         Do 110 iCnttp = 1, nCnttp
*           Loop over unique centers associated with this basis set.
            Do 120 iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = mdc + 1
               IndDsp(mdc,iIrrep) = nDisp
*              Loop over the cartesian components
               Do 130 iCar = 0, 2
                  iComp = 2**iCar
                  If ( TstFnc(dc(mdc)%iCoSet,
     &                       iIrrep,iComp,dc(mdc)%nStab) ) Then
                      nDisp = nDisp + 1
                      If (nDisp.gt.mDisp) Then
                         Write (6,*) 'nDisp.gt.mDisp'
                         Call Abend
                      End If
                      If (iIrrep.eq.0) InxDsp(mdc,iCar+1) = nDisp
                      lDisp(iIrrep) = lDisp(iIrrep) + 1
                      If (Type) Then
                         If (iPrint.ge.6) Then
                         Write (6,*)
                         Write (6,'(10X,A,A)')
     &                    ' Irreducible representation : ',
     &                      lIrrep(iIrrep)
                         Write (6,'(10X,2A)')
     &                      ' Basis function(s) of irrep: ',
     &                       lBsFnc(iIrrep)
                         Write (6,*)
                         Write (6,'(A)')
     &                   ' Basis Label        Type   Center Phase'
                         End If
                         Type = .False.
                      End If
                      If (iPrint.ge.6)
     &                Write (6,'(I4,3X,A8,5X,A1,7X,8(I3,4X,I2,4X))')
     &                      nDisp,dc(mdc)%LblCnt,xyz(iCar),
     &                      (mc+iCo,iPrmt(
     &                      NrOpr(dc(mdc)%iCoSet(iCo,0)),iComp)*
     &                      iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0))),
     &                      iCo=0,nIrrep/dc(mdc)%nStab-1 )
                      Write (ChDisp(nDisp),'(A,1X,A1)')
     &                       dc(mdc)%LblCnt,xyz(iCar)
                      iwork(ipad+ndisp-1)=icnttp
                      iwork(ipdd+ndisp-1)=nIrrep/dc(mdc)%nStab
                  End If
*
 130           Continue
               mc = mc + nIrrep/dc(mdc)%nStab
 120        Continue
 110     Continue
*
 100  Continue
*
      If (nDisp.ne.mDisp) Then
         Write (6,*) 'InputH: nDisp.ne.mDisp'
         Write (6,*) 'nDisp,mDisp=',nDisp,mDisp
         Call Abend()
      End If
      If (sIrrep) Then
         ndisp=ldisp(0)
         Do i= 1,nIrrep-1
            lDisp(i)=0
         End Do
      End If
      Call GetMem('TDISP','Allo','INTE',ipTD,ndisp)
      Call ICopy(nDisp,[30],0,iWork(ipTD),1)
      iOpt = 0
      iRC = -1
      labelOp='ndisp   '
      Call iWrMck(iRC,iOpt,labelop,1,[ndisp],iDummer)
      If (iRC.ne.0) Then
         Write (6,*) 'InputH: Error writing to MCKINT'
         Write (6,'(A,A)') 'labelOp=',labelOp
         Call Abend()
      End If
      LABEL='DEGDISP'
      iRc=-1
      iOpt=0
      Call iWrMck(iRC,iOpt,Label,idum,iwork(ipdd),idum)
      If (iRC.ne.0) Then
         Write (6,*) 'InputH: Error writing to MCKINT'
         Write (6,'(A,A)') 'LABEL=',LABEL
         Call Abend()
      End If
      Call GetMem('DEGDISP','Free','INTE',ipdd,mDisp)
      LABEL='NRCTDISP'
      iRc=-1
      iOpt=0
      Call iWrMck(iRC,iOpt,Label,idum,iwork(ipad),idum)
      If (iRC.ne.0) Then
         Write (6,*) 'InputH: Error writing to MCKINT'
         Write (6,'(A,A)') 'LABEL=',LABEL
         Call Abend()
      End If
      Call GetMem('ATDISP','Free','INTE',ipad,mDisp)
      LABEL='TDISP'
      iRc=-1
      iOpt=0
      Call iWrMck(iRC,iOpt,Label,idum,iWork(ipTD),idum)
      If (iRC.ne.0) Then
         Write (6,*) 'InputH: Error writing to MCKINT'
         Write (6,'(A,A)') 'LABEL=',LABEL
         Call Abend()
      End If
      Call GetMem('TDISP','FREE','INTE',ipTD,ndisp)
*
      Else If (iCntrl.eq.2) Then
          Write(6,*) 'Svaret aer 48 '
      Else If (iCntrl.eq.3) Then
          Write(6,*) 'Svaret aer 48'
      End If
*
*     Set up the angular index vector
*
      i = 0
      Do 1000 iR = 0, iTabMx
         Do 2000 ix = iR, 0, -1
            Do 3000 iy = iR-ix, 0, -1
               iz = iR-ix-iy
               i = i + 1
               ixyz(1,i) = ix
               ixyz(2,i) = iy
               ixyz(3,i) = iz
 3000       Continue
 2000    Continue
 1000 Continue
*
*     Set up data for the utilization of the translational
*     and rotational invariance of the energy.
*
      If (TRSymm) Then
         iSym(1) = 0
         iSym(2) = 0
         iSym(3) = 0
         Do 15 i = 1, Min(nIrrep-1,5)
            j = i
            If (i.eq.3) j = 4
            Do 16 k = 1, 3
               If (iAnd(iOper(j),2**(k-1)).ne.0) iSym(k) = 2**(k-1)
   16       Continue
   15    Continue
         nTR = 0
*--------Translational equations
         Do 150 i = 1, 3
            If (iSym(i).eq.0) nTR = nTR + 1
 150     Continue
         If (iPrint.ge.99) Write (6,*) ' nTR=',nTR
*--------Rotational equations
         Do 160 i = 1,3
            j = i+1
            If (j.gt.3) j = j-3
            k = i+2
            If (k.gt.3) k = k-3
            ijSym = iEor(iSym(j),iSym(k))
            If (ijSym.eq.0) nTR = nTR + 1
 160     Continue
         If (nTR.eq.0) Then
            TRSymm = .False.
            Go To 9876
         End If
         If (iPrint.ge.99) Write (6,*) ' nTR=',nTR
         Call GetMem('Amtrx','Allo','Real',ipAm,lDisp(0)**2)
         Call GetMem('Temp ','Allo','Real',ipTmp,nTR**2)
         Call GetMem('Coor ','Allo','Real',ipC,lDisp(0)*4)
         Call GetMem('Car  ','Allo','Inte',ipCar,lDisp(0))
*
         call dcopy_(nTR*lDisp(0),[Zero],0,Work(ipAm),1)
         call dcopy_(4*lDisp(0),[Zero],0,Work(ipC),1)
*
*        Generate temporary information of the symmetrical
*        displacements.
*
        ldsp = 0
         mdc = 0
         iIrrep = 0
         Do 2100 iCnttp = 1, nCnttp
            Do 2200 iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = mdc + 1
*              Call RecPrt(' Coordinates',' ',
*    &                     dbsc(iCnttp)%Coor(1,iCnt),1,3)
               Fact = Zero
               iComp = 0
               If (dbsc(iCnttp)%Coor(1,iCnt).ne.Zero)
     &            iComp = iOr(iComp,1)
               If (dbsc(iCnttp)%Coor(2,iCnt).ne.Zero)
     &            iComp = iOr(iComp,2)
               If (dbsc(iCnttp)%Coor(3,iCnt).ne.Zero)
     &            iComp = iOr(iComp,4)
               Do 2250 jIrrep = 0, nIrrep-1
                  If ( TstFnc(dc(mdc)%iCoSet,
     &                        jIrrep,iComp,dc(mdc)%nStab) ) Then
                     Fact = Fact + One
                  End If
 2250          Continue
               Do 2300 iCar = 0, 2
                  iComp = 2**iCar
                  If ( TstFnc(dc(mdc)%iCoSet,
     &                        iIrrep,iComp,dc(mdc)%nStab) ) Then
                     ldsp = ldsp + 1
*--------------------Transfer the coordinates
                     ip = 4*(ldsp-1) + ipC
                     call dcopy_(3,dbsc(iCnttp)%Coor(:,iCnt),1,
     &                          Work(ip),1)
*--------------------Transfer the multiplicity factor
                     Work(ip+3) = Fact
                     iWork(ipCar-1+ldsp) = iCar + 1
                  End If
 2300          Continue
 2200       Continue
 2100    Continue
         If (iPrint.ge.99) Then
            Call RecPrt(' Information',' ',Work(ipC),4,lDisp(0))
            Write (6,*) (iWork(i),i=ipCar,ipCar+lDisp(0)-1)
         End If
*
*--------Set up coefficient for the translational equations
*
         iTR = 0
         Do 1110 i = 1,3
            If (iSym(i).ne.0) Go To 1110
            iTR = iTR + 1
            Do 1120 ldsp = 1, lDisp(0)
               If (iWork(ipCar+ldsp-1).eq.i) Then
                  ipOut= ipC + 4*(ldsp-1) + 3
                  ipIn = nTR*(ldsp-1) + iTR + ipAm - 1
                  Work(ipIn) = Work(ipOut)
               End If
 1120       Continue
 1110    Continue
*
*--------Set up coefficient for the rotational invariance
*
         Do 1210 i = 1, 3
            j = i + 1
            If (j.gt.3) j = j - 3
            k = i + 2
            If (k.gt.3) k = k - 3
            ijSym = iEor(iSym(j),iSym(k))
            If (ijSym.ne.0) Go To 1210
            iTR = iTR + 1
            Do 1220 ldsp = 1, lDisp(0)
               ipIn = nTR*(ldsp-1) + iTR + ipAm - 1
               ipOut = ipC + 4*(ldsp-1)
               If (iWork(ipCar+ldsp-1).eq.j) Then
                  Fact = Work(ipOut+3) * Work(ipOut+k-1)
                  Work(ipIn) = Fact
               Else If (iWork(ipCar+ldsp-1).eq.k) Then
                  Fact = Work(ipOut+3) * Work(ipOut+j-1)
                  Work(ipIn) = -Fact
               End If
 1220       Continue
 1210    Continue
         If (iPrint.ge.99)
     &      Call RecPrt(' The A matrix',' ',Work(ipAm),nTR,lDisp(0))
*
*--------Now, transfer the coefficient of those gradients which will
*        not be computed directly.
*        The matrix to compute the inverse of is determined via
*        a Gram-Schmidt procedure.
*
*--------Pick up the other vectors
         Do 1230 iTR = 1, nTR
*           Write (*,*) ' Looking for vector #',iTR
            ovlp = Zero
            kTR = 0
*-----------Check all the remaining vectors
            Do 1231 ldsp = 1, lDisp(0)
               Do 1235 jTR = 1, iTR-1
                  If (iTemp(jTR).eq.ldsp) Go To 1231
 1235          Continue
*              Write (*,*) ' Checking vector #', ldsp
               ipNew = ipAm + nTR*(ldsp-1)
               ipIn = ipTmp + nTR*(iTR-1)
               call dcopy_(nTR,Work(ipNew),1,Work(ipIn),1)
*              Call RecPrt(' Vector',' ',Work(ipIn),nTR,1)
*--------------Gram-Schmidt orthonormalize against accepted vectors
               Do 1232 lTR = 1, iTR-1
                  ipOld = ipTmp + nTR*(lTR-1)
                  alpha = DDot_(nTR,Work(ipIn),1,Work(ipOld),1)
*                 Write (*,*) ' <x|y> =', alpha
                  Call DaXpY_(nTR,-alpha,Work(ipOld),1,Work(ipIn),1)
 1232          Continue
*              Call RecPrt(' Remainings',' ',Work(ipIn),nTR,1)
               alpha = DDot_(nTR,Work(ipIn),1,Work(ipIn),1)
*              Write (*,*) ' Remaining overlap =', alpha
*--------------Check the remaining magnitude of vector after Gram-Schmidt
               If (alpha.gt.ovlp) Then
                  kTR = ldsp
                  ovlp = alpha
               End If
 1231       Continue
            If (kTR.eq.0) Then
               Write (6,*) ' No Vector found!'
               Call Abend
            End If
*           Write (*,*) ' Selecting vector #', kTR
*-----------Pick up the "best" vector
            ipNew = ipAm + nTR*(kTR-1)
            ipIn = ipTmp + nTR*(iTR-1)
            call dcopy_(nTR,Work(ipNew),1,Work(ipIn),1)
            Do 1233 lTR = 1, iTR-1
               ipOld = ipTmp + nTR*(lTR-1)
               alpha = DDot_(nTR,Work(ipIn),1,Work(ipOld),1)
               Call DaXpY_(nTR,-alpha,Work(ipOld),1,Work(ipIn),1)
 1233       Continue
            alpha = DDot_(nTR,Work(ipIn),1,Work(ipIn),1)
            Call DScal_(nTR,One/Sqrt(alpha),Work(ipIn),1)
            iTemp(iTR) = kTR
 1230    Continue
         Do 1234 iTR = 1, nTR
            ipNew = ipAm + nTR*(iTemp(iTR)-1)
            ipIn  = ipTmp + nTR*(iTR-1)
            call dcopy_(nTR,Work(ipNew),1,Work(ipIn),1)
            call dcopy_(nTR,[Zero],0,Work(ipNew),1)
 1234    Continue
         If (iPrint.ge.99) Then
            Call RecPrt(' The A matrix',' ',Work(ipAm),nTR,lDisp(0))
            Call RecPrt(' The T matrix',' ',Work(ipTmp),nTR,nTR)
            Write (6,*) (iTemp(iTR),iTR=1,nTR)
         End If
*
*        Compute the inverse of the T matrix
*
         Call MatInvert(Work(ipTmp),nTR)
         If (IPrint.ge.99)
     &      Call RecPrt(' The T-1 matrix',' ',Work(ipTmp),nTR,nTR)
         Call DScal_(nTR**2,-One,Work(ipTmp),1)
*
*        Generate the complete matrix
*
         Call GetMem(' Temp2','Allo','Real',ipScr,nTR*lDisp(0))
         Call DGEMM_('N','N',
     &               nTR,lDisp(0),nTR,
     &               1.0d0,Work(ipTmp),nTR,
     &               Work(ipAm),nTR,
     &               0.0d0,Work(ipScr),nTR)
         If (IPrint.ge.99)
     &      Call RecPrt(' A-1*A',' ',Work(ipScr),nTR,lDisp(0))
         call dcopy_(lDisp(0)**2,[Zero],0,Work(ipAm),1)
         call dcopy_(lDisp(0),[One],0,Work(ipAm),lDisp(0)+1)
         Do 1250 iTR = 1, nTR
            ldsp = iTemp(iTR)
            ipOut = ipScr + iTR - 1
            ipIn  = ipAM  + ldsp - 1
            call dcopy_(lDisp(0),Work(ipOut),nTR,Work(ipIn),lDisp(0))
 1250    Continue
         If (iPrint.ge.99)
     &      Call RecPrt('Final A matrix',' ',
     &                  Work(ipAm),lDisp(0),lDisp(0))
*
*
         Call GetMem(' Temp2','Free','Real',ipScr,nTR*lDisp(0))
         Call GetMem('Car  ','Free','Inte',ipCar,lDisp(0))
         Call GetMem('Coor ','Free','Real',ipC,lDisp(0)*4)
         Call GetMem('Temp ','Free','Real',ipTmp,nTR**2)
         Do 1501 iTR = 1, nTR
            ldsp = iTemp(iTR)
            LPert(ldsp)=.False.
 1501    Continue
*
         Write (6,*)
         Write (6,'(20X,A,A)')
     &      ' Automatic utilization of translational and',
     &      ' rotational invariance of the energy is employed.'
         Write (6,*)
         Do 7000 i = 1, lDisp(0)
            If (lpert(i)) Then
               Write (6,'(25X,A,A)') Chdisp(i), ' is independent'
            Else
               Write (6,'(25X,A,A)') Chdisp(i), ' is dependent'
            End If
 7000    Continue
         Write (6,*)
*
      Else
         nTR = 0
         If (iPrint.ge.6) Then
         Write (6,*)
         Write (6,'(20X,A,A)')
     &      ' No automatic utilization of translational and',
     &      ' rotational invariance of the energy is employed.'
         Write (6,*)
         End If
      End If
*
      If (Slct) Then
         Write (6,*)
         Write (6,'(20X,A)') ' The Selection option is used'
         Write (6,*)
         Do 7100 i = 1, lDisp(0)
            If (lpert(i)) Then
               Write (6,'(25X,A,A)') Chdisp(i), ' is computed'
            Else
               Write (6,'(25X,A,A)') Chdisp(i), ' is set to zero'
            End If
 7100    Continue
         Write (6,*)
      End If
*
 9876 Continue
      Call Datimx(KWord)
      Call ICopy(nIrrep,[0],0,nFck,1)
      Do iIrrep=0,nIrrep-1
        If (iIrrep.ne.0) Then
          Do jIrrep=0,nIrrep-1
           kIrrep=NrOpr(iEOR(ioper(jIrrep),ioper(iIrrep)))
           If (kIrrep.lt.jIrrep)
     &     nFck(iIrrep)=nFck(iIrrep)+nBas(jIrrep)*nBas(kIrrep)
          End Do
        Else
           Do jIrrep=0,nIrrep-1
             nFck(0)=nFck(0)+nBas(jIrrep)*(nBas(jIrrep)+1)/2
           End Do
        End If
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mxgendiag_cvb(a,s,eigval,n)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: a(n,n), s(n,n)
real(kind=wp), intent(out) :: eigval(n)
integer(kind=iwp) :: info, lwrk
real(kind=wp) :: dum(1)
real(kind=wp), allocatable :: wrk(:)

info = 0
lwrk = -1
call dsygv_(1,'V','U',n,a,n,s,n,eigval,dum,lwrk,info)
lwrk = nint(dum(1))
call mma_allocate(wrk,lwrk,label='wrk')
call dsygv_(1,'V','U',n,a,n,s,n,eigval,wrk,lwrk,info)
call mma_deallocate(wrk)
if (info /= 0) then
  write(u6,*) ' Error in generalized diagonalization!'
  write(u6,*) ' Dsygv exited with code:',info
  call abend_cvb()
end if

return

end subroutine mxgendiag_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine gentkin(L,TKIN,nprims,exponents,rootOVLPinv)
      implicit real*8 (a-h,o-z)
#include "para.fh"
cbs   subroutine to generate the kinetic energy
      dimension TKIN(nprims,nprims),exponents(*),
     *dummy(MxprimL,MxprimL),dummy2(MxprimL,MxprimL),
     *rootOVLPinv(MxprimL,MxprimL)
cbs   one triangular part of the matrix
      do irun2=1,nprims
      do irun1=1,irun2
              dummy(irun1,irun2)=
     *        Tkinet(l,exponents(irun1),
     *        exponents(irun2))
      enddo
      enddo
cbs   copy to the other triangular part....
      do irun2=1,nprims-1
      do irun1=irun2+1,nprims
              dummy(irun1,irun2)=dummy(irun2,irun1)
      enddo
      enddo
cbs   now transform by rootovlp*dummy*rootovlp
      do jrun=1,nprims
      do irun=1,nprims
              TKIN(irun,jrun)=0d0
              dummy2(irun,jrun)=0d0
      enddo
      enddo
      do irun=1,nprims
      do jrun=1,nprims
      do krun=1,nprims
              dummy2(irun,jrun)=dummy2(irun,jrun)+
     *        dummy(irun,krun)*rootovlpinv(krun,jrun)
      enddo
      enddo
      enddo
      do irun=1,nprims
      do jrun=1,nprims
      do krun=1,nprims
              Tkin(irun,jrun)=Tkin(irun,jrun)+
     *        dummy2(krun,jrun)*rootovlpinv(irun,krun)
      enddo
      enddo
      enddo
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Jie J. Bao                                       *
************************************************************************
      Subroutine RotState()
      use stdalloc, only: mma_allocate, mma_deallocate
      use rasscf_global, only: ICMSP, ITER, IXMSP, LROOTS, IADR15,
     &                         Ener
      use PrintLevel, only: DEBUG,USUAL
      use output_ras, only: LF,IPRLOC
      use general_data, only: JOBIPH,NCONF
      use Molcas, only: MxRoot
      use RASDim, only: MxIter
      Implicit None


* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Mar. 13, 2020, created this file.               *
* ****************************************************************


      Integer NHrot                ! storing info in H0_Rotate.txt
      Integer NRState            ! storing info in Do_Rotate.txt
      Integer rcidisk
      INTEGER JRoot,IPRLEV
      CHARACTER(Len=18)::MatInfo
      Real*8, Allocatable:: CIVEC(:,:), CIScr(:,:), HScr(:), State(:),
     &                      HRot(:,:)
      Integer i, iad15

      IPRLEV=IPRLOC(3)

      IF(IPRLEV.ge.USUAL) THEN
      write(LF,*)
      write(LF,*) repeat('=',71)
      write(LF,*)
      write(LF,'(11X,A)')'Do_Rotate.txt is found in scratch directory.'
      IF(IXMSP.eq.1) THEN
       write(LF,'(11X,A)')
     & 'Following properties are for XMS intermediate states.'
      ELSE IF(ICMSP.eq.1) THEN
       write(LF,'(11X,A)')
     & 'Following properties are for CMS intermediate states.'
      ELSE
       write(LF,'(11X,A)')
     & 'Following properties are for intermediate states'
       write(LF,'(11X,A)')
     & ' obtained from the user-supplied rotation matrix'
      ENDIF
      ENDIF

      NRState=lRoots**2
      NHRot=NRState

      CALL mma_allocate(CIVec,nConf,lRoots,Label='CIVec')
      CALL mma_allocate(CIScr,nConf,lRoots,Label='CIScr')
      CALL mma_allocate(HScr,NHRot,Label='HScr')
      CALL mma_allocate(State,NRState,Label='State')
      CALL mma_allocate(HRot,lRoots,lRoots,Label='HRot')


*JB   read rotation matrix in Do_Rotate.txt
      CALL ReadMat2('ROT_VEC',MatInfo,State,lRoots,lRoots,
     &              7,18,'T')
      iF(IPRLEV.GE.DEBUG) Then
        write(LF,*)'rotation matrix'
        CALL RecPrt(' ',' ',State,lRoots,lRoots)
      eND iF
      HRot(:,:)=0.0D0
      NHRot=lRoots**2
      Do I=1,lRoots
        HRot(I,I)=ENER(I,ITER)
      End Do
      Call DGEMM_('t','n',lRoots,lRoots,lRoots,1.0D0,State,
     &     lRoots,HRot,lRoots,0.0D0,HScr,lRoots)
      Call DGEMM_('n','n',lRoots,lRoots,lRoots,1.0D0,HScr,
     &     lRoots,State,lRoots,0.0D0,HRot,lRoots)
      CALL PrintMat2('ROT_HAM',MatInfo,HRot,lRoots,lRoots,
     &              7,18,'T')
      if(IPRLEV.GE.DEBUG) Then
       write(LF,'(6X,A)') 'Rotated Hamiltonian matrix '
       Call RecPrt('HRot',' ',hRot,lRoots,lRoots)
      End if

*JB   read CI vector from jobiph
      rcidisk=IADR15(4)
      Do jRoot = 1,lRoots
        Call DDafile(JOBIPH,2,CIScr(:,jRoot),nConf,rcidisk)
      End Do
      Call DGEMM_('n','n',NConf,lRoots,lRoots,1.0D0,CIScr,
     &     nConf,State,lRoots,0.0D0,CIVec,nConf)

C     updating final energies as those for rotated states
      rcidisk=IADR15(4)
      Do I=1,lRoots
        Call DDafile(JOBIPH,1,CIVec(:,I),nConf,rcidisk)
        ENER(I,ITER)=HRot(I,I)
      End Do
      IAD15 = IADR15(6)
      CALL DDAFILE(JOBIPH,1,ENER,mxRoot*mxIter,IAD15)


      IF(IPRLEV.GE.DEBUG) Then
      write(LF,'(2A)')'Printing the coeff of the first CSF',
     &' for each state'
      Do I=1,lRoots
        write(LF,*) CIVec(1,I)
      End Do
      End If

      Call mma_deallocate(HScr)
      Call mma_deallocate(CIScr)
      Call mma_deallocate(State)
      Call mma_deallocate(CIVec)
      Call mma_deallocate(HRot)

      IF(IPRLEV.ge.USUAL) THEN
      write(LF,*)
      write(LF,*) repeat('=',71)
      END IF

      End Subroutine RotState

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Ben Swerts                                             *
!               2016, Liviu Ungur                                      *
!***********************************************************************

subroutine Drv2El_FAIEMP()
!***********************************************************************
!                                                                      *
!  Object: driver for the central-fragment interaction 2-electron      *
!          integrals (based on drv2el_3center_RI and drv2el_scf)       *
!                                                                      *
!     Author: Ben Swerts                                               *
!   Modified: Liviu Ungur                                              *
!***********************************************************************

use k2_arrays, only: pDq, pFq
use Basis_Info, only: dbsc, nBas, nBas_Frag, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep, iOper
use Gateway_Info, only: ThrInt, CutInt
use Integral_Interfaces, only: DeDe_SCF
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Quart
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), parameter :: nTInt = 1
integer(kind=iwp) :: iTOffs(8,8,8), nBas_Valence(0:7), i, j, iCnt, iCnttp, iDpos, iFpos, iIrrep, ijS, iOpt, iRC, iS, jS, lS, kS, &
                     klS, maxDens, mdc, lOper, mDens, nBasC, nBT, nBVT, nBVTi, nFock, nij, nOneHam, Nr_Dens, nSkal, nSkal_Valence
real(kind=wp) :: TInt(nTInt), A_int, Cnt, Disc, Disc_Mx, Dtst, ExFac, P_Eff, TCpu1, TCpu2, Thize, ThrAO, TMax_all, TskHi, TskLw, &
                 TWall1, TWall2
logical(kind=iwp) :: W2Disc, PreSch, FreeK2, Verbose, Indexation, DoIntegrals, DoFock, DoGrad, NoCoul, NoExch, lNoSkip, EnergyWeight
character(len=8) :: Label
integer(kind=iwp), allocatable :: ij(:)
real(kind=wp), allocatable, target :: Dens(:), Fock(:)
real(kind=wp), allocatable :: DMax(:,:), FragDensSO(:), OneHam(:), TMax(:,:)
external :: No_Routine
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iFD
character(len=80) :: Line
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
call xFlush(u6)
ExFac = One
Nr_Dens = 1
DoIntegrals = .false.
NoCoul = .false.
NoExch = .false.
!W2Disc = .false.
W2Disc = .true.

! Handle both the valence and the fragment basis set

call Set_Basis_Mode('Valence')
call Nr_Shells(nSkal_Valence)
call Free_iSD()
call Set_Basis_Mode('WithFragments')
call SetUp_iSD()
nBT = 0
nBVT = 0
do i=0,nIrrep-1
  nBas_Valence(i) = nBas(i)
  nBVT = nBVT+nBas(i)*(nBas(i)+1)/2
  nBas(i) = nBas(i)+nBas_Frag(i)
  nBT = nBT+nBas(i)*(nBas(i)+1)/2
end do
!                                                                      *
!***********************************************************************
!                                                                      *
!---  Construct custom density matrix

call mma_allocate(Dens,nBT,Label='Dens')
call mma_allocate(Fock,nBT,Label='Fock')
! Valence part is zero
Dens(:) = Zero
Fock(:) = Zero
! Each fragment needs it's (symmetrized) density matrix added along the
! diagonal.
! This density matrix first has to be constructed from the MO coeffs
! so allocate space for the largest possible density matrix
maxDens = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%nFragType > 0) maxDens = max(maxDens,dbsc(iCnttp)%nFragDens*(dbsc(iCnttp)%nFragDens+1)/2)
end do
call mma_allocate(FragDensSO,maxDens,label='FragDSO')

iDpos = 1 ! position in the total density matrix
do iIrrep=0,nIrrep-1
  nBasC = nBas_Valence(iIrrep)
  iDpos = iDpos+nBasC*(nBasC+1)/2
  mdc = 0
  do iCnttp=1,nCnttp
    if (dbsc(iCnttp)%nFragType <= 0) then
      mdc = mdc+dbsc(iCnttp)%nCntr
    else

      ! construct the density matrix
      EnergyWeight = .false.
      !call MakeDens(dbsc(iCnttp)%nFragDens,dbsc(iCnttp)%nFragEner,dbsc(iCnttp)%FragCoef,dbsc(iCnttp)%FragEner,EnergyWeight, &
      !              FragDensAO)
      call MakeDens(dbsc(iCnttp)%nFragDens,dbsc(iCnttp)%nFragEner,dbsc(iCnttp)%FragCoef,dbsc(iCnttp)%FragEner,EnergyWeight, &
                    FragDensSO)
      ! create the symmetry adapted version if necessary
      ! (fragment densities are always calculated without symmetry)
#     ifdef _DEBUGPRINT_
      call TriPrt('Fragment density',' ',FragDensSO,dbsc(iCnttp)%nFragDens)
#     endif

      do iCnt=1,dbsc(iCnttp)%nCntr
        mdc = mdc+1
        ! only add fragment densities that are active in this irrep
        ! => the following procedure still has to be verified thoroughly
        !    but appears to be working
        if (iand(dc(mdc)%iChCnt,iIrrep) == iOper(iIrrep)) then
          ! add it at the correct location in the large custom density matrix
          iFpos = 1
          ! position in fragment density matrix
          do i=1,dbsc(iCnttp)%nFragDens
            iDpos = iDpos+nBasC
            do j=0,i-1
              Dens(iDpos+j) = FragDensSO(iFpos+j)
            end do
            iDpos = iDpos+i
            iFpos = iFpos+i
          end do
          nBasC = nBasC+dbsc(iCnttp)%nFragDens
        end if
      end do
    end if
  end do
end do
#ifdef _DEBUGPRINT_
iFD = 1
do iIrrep=0,nIrrep-1
  call TriPrt('Combined density',' ',Dens(iFD),nBas(iIrrep))
  iFD = iFD+nBas(iIrrep)*(nBas(iIrrep)+1)/2
end do
#endif
call mma_deallocate(FragDensSO)
!                                                                      *
!***********************************************************************
!                                                                      *
!-----Desymmetrize the custom density matrix
!
! Should be possible to reduce the storage space for the Fock matrix
! and only store the top nBas_Valence(0) rows (non-symmetry case tested)

call AlloK2()
call DeDe_SCF(Dens,Fock,nBT,mDens)
#ifdef _DEBUGPRINT_
if (nIrrep == 1) then
  call RecPrt('Desymmetrized Density:',' ',pDq,nBas(0),nBas(0))
else
  iFD = 1
  do iIrrep=0,nIrrep-1
    call TriPrt('Desymmetrized density',' ',pDq(iFD),nBas(iIrrep))
    iFD = iFD+nBas(iIrrep)*(nBas(iIrrep)+1)/2
  end do
end if
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize for 2-electron integral evaluation. Do not generate
! tables for indexation.

ThrAO = Zero
Indexation = .false.
DoFock = .true.
DoGrad = .false.
call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
!                                                                      *
!***********************************************************************
!                                                                      *
Thize = 1.0e-6_wp
PreSch = .false.
Disc_Mx = Zero

Disc = Zero
TskHi = Zero
TskLw = Zero
ThrInt = CutInt   ! Integral neglect threshold from SCF
!                                                                      *
!***********************************************************************
!                                                                      *
!---  Compute entities for prescreening at shell level

call mma_allocate(TMax,nSkal,nSkal,label='TMax')
call Shell_MxSchwz(nSkal,TMax)
TMax_all = Zero
do iS=1,nSkal
  do jS=1,iS
    TMax_all = max(TMax_all,TMax(iS,jS))
  end do
end do
call mma_allocate(DMax,nSkal,nSkal,label='DMax')
call Shell_MxDens(Dens,DMax,nSkal)
!                                                                      *
!***********************************************************************
!                                                                      *
! Create list of non-vanishing pairs

call mma_allocate(ij,nSkal*(nSkal+1),label='ij')
nij = 0
do iS=1,nSkal
  do jS=1,iS
    if (TMax_All*TMax(iS,jS) >= CutInt) then
      nij = nij+1
      ij(nij*2-1) = iS
      ij(nij*2) = jS
    end if
  end do
end do
P_Eff = real(nij,kind=wp)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
call CWTime(TCpu1,TWall1)

! Now do a quadruple loop over shells

!ijS = int((One+sqrt(Eight*TskLw-Three))/Two)
ijS = 1
iS = ij(ijS*2-1)
jS = ij(ijS*2)
!klS = int(TskLw-real(ijS,kind=wp)*(real(ijS,kind=wp)-One)/Two)
klS = 1
kS = ij(klS*2-1)
lS = ij(klS*2)
do
  if (ijS > int(P_Eff)) exit
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! density prescreening (results in iS > nSkal_Valence)
  A_int = TMax(iS,jS)*TMax(kS,lS)
  Dtst = max(DMax(is,ls)*Quart,DMax(is,ks)*Quart,DMax(js,ls)*Quart,DMax(js,ks)*Quart,DMax(is,js),DMax(ks,ls))
  lNoSkip = A_int*Dtst >= ThrInt
  ! only calculate needed integrals and only update the valence part of the
  ! Fock matrix (iS > nSkal_Valence, lS <= nSkal_Valence, jS and kS
  ! belonging to different regions)
  if (jS <= nSkal_Valence) then
    lNoSkip = lNoSkip .and. (kS > nSkal_Valence)
  else
    lNoSkip = lNoSkip .and. (kS <= nSkal_Valence)
  end if
  lNoSkip = lNoSkip .and. (lS <= nSkal_Valence)

  if (lNoSkip) then
    call Eval_Ints_New_Inner(iS,jS,kS,lS,TInt,nTInt,iTOffs,No_Routine,pDq,pFq,mDens,[ExFac],Nr_Dens,[NoCoul],[NoExch],Thize, &
                             W2Disc,PreSch,Disc_Mx,Disc,Cnt,DoIntegrals,DoFock)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Drv2El_FAIEMP: for iS, jS, kS, lS =',is,js,ks,ls
    if (nIrrep == 1) then
      call RecPrt('updated Fock',' ',pFq,nBas(0),nBas(0))
    else
      iFD = 1
      do iIrrep=0,nIrrep-1
        call TriPrt('updated Fock',' ',pFq(iFD),nBas(iIrrep))
        iFD = iFD+nBas(iIrrep)*(nBas(iIrrep)+1)/2
      end do
    end if
#   endif
  end if
  klS = klS+1
  if (klS > ijS) then
    ijS = ijS+1
    klS = 1
  end if
  iS = ij(ijS*2-1)
  jS = ij(ijS*2)
  kS = ij(klS*2-1)
  lS = ij(klS*2)
end do

! Use a time slot to save the number of tasks and shell
! quadruplets processed by an individual node
call SavStat(1,One,'+')
call SavStat(2,TskHi-TskLw+One,'+')
!
call CWTime(TCpu2,TWall2)
call SavTim(1,TCpu2-TCpu1,TWall2-TWall1)
!                                                                      *
!***********************************************************************
!                                                                      *
!                         E P I L O G U E                              *
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(ij)
call mma_deallocate(DMax)
call mma_deallocate(TMax)
!                                                                      *
!***********************************************************************
!                                                                      *
!     Terminate integral environment.

Verbose = .false.
FreeK2 = .true.
call Term_Ints(Verbose,FreeK2)

call Free_DeDe(Dens,Fock,nBT)

call mma_deallocate(Dens)
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*)
write(u6,'(a)') 'SO Integrals of type Frag2El Component 1'
iFD = 1
do iIrrep=0,nIrrep-1
  write(Line,'(1X,A,I1)') ' Diagonal Symmetry Block ',iIrrep+1
  call TriPrt(Line,' ',Fock(iFD),nBas_Valence(iIrrep))
  iFD = iFD+nBas_Valence(iIrrep)*(nBas_Valence(iIrrep)+1)/2
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Write the results to the one electron integral file
!
! read the one electron hamiltonian
Label = 'OneHam  '
iRC = -1
iOpt = 0
call mma_allocate(OneHam,nBVT+4,label='OneHam')
call RdOne(iRC,iOpt,Label,1,OneHam,lOper)
if (iRC /= 0) then
  write(u6,*) 'Drv2El_FAIEMP: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
! add the calculated results
nOneHam = 1 ! counter in the OneHam matrices (small)
nFock = 1   ! counter in the Fock matrices (larger)
do iIrrep=0,nIrrep-1
  nBVTi = nBas_Valence(iIrrep)*(nBas_Valence(iIrrep)+1)/2
  call daxpy_(nBVTi,One,Fock(nFock),1,OneHam(nOneHam),1)
  nOneHam = nOneHam+nBVTi
  nFock = nFock+nBas(iIrrep)*(nBas(iIrrep)+1)/2
end do

! write out the results
#ifdef _DEBUGPRINT_
iFD = 1
do iIrrep=0,nIrrep-1
  call TriPrt('OneHam at end',' ',OneHam(iFD),nBas_Valence(iIrrep))
  iFD = iFD+nBas_Valence(iIrrep)*(nBas_Valence(iIrrep)+1)/2
end do
#endif
iRC = -1
call WrOne(iRC,iOpt,Label,1,OneHam,lOper)
if (iRC /= 0) then
  write(u6,*) 'Drv2El_FAIEMP: Error writing to ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
iRC = -1
Label = 'OneHam 0'
call WrOne(iRC,iOpt,Label,1,OneHam,lOper)
if (iRC /= 0) then
  write(u6,*) 'Drv2El_FAIEMP: Error writing to ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if

! cleanup
call mma_deallocate(OneHam)
call mma_deallocate(Fock)
!                                                                      *
!***********************************************************************
!***********************************************************************
!***********************************************************************
!                                                                      *
call Free_iSD()
call Set_Basis_Mode('Valence')
call SetUp_iSD()
do i=0,nIrrep-1
  nBas(i) = nBas_Valence(i)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Drv2El_FAIEMP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this routines are installed here temrorarry
c     for final version they will be part of SYMM routines
c
c      wrtmediate
c      wrtmap
c      rea
c      wri
c      grc0
c      ccsort_mv0zero
c      dawrtmediate
c      dawrtmap
c      dawri
c      darea
c
c     ----------------------------
c
       subroutine ccsort_wrtmediate (wrk,wrksize,
     & lun,mapd,mapi,rc)
c
c     this routine write required mediate to opened unformatted file
c     with number lun
c     it also store mapd and mapi of the given mediade
c
c     lun   - Logical unit number of file, where mediate will be stored (Input)
c     mapd  - direct map matrix corresponding to given mediate (Input)
c     mapi  - inverse map matrix corresponding to given mediate (Input)
c     rc    - return (error) code (Output)
c
c     N.B.
c     all mediates are storred as follows
c     1 - mapd, mapi
c     2 - one record with complete mediate
c
#include "wrk.fh"
       integer lun,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer im,lenght,poss0
c
       rc=0
c
c1    write mapd
c
       write (lun) mapd,mapi
c
c2    calculate overall lenght
c
       lenght=0
c
       do 100 im=1,mapd(0,5)
       lenght=lenght+mapd(im,2)
 100    continue
c
c     write mediate in one block
c
       if (lenght.eq.0) then
c     RC=1 : there is nothing to write, lenght of mediate is 0
       rc=1
       return
       end if
c
       poss0=mapd(1,1)
       call ccsort_wri (lun,lenght,wrk(poss0))
c
       return
       end
c
c     ----------------------------
c
       subroutine ccsort_wrtmap (lun,mapd,mapi,rc)
c
c     this routine write required mapd and mapi to opened unformatted file
c     with number lun
c
c     lun   - Logical unit number of file, where mediate will be stored (Input)
c     mapd  - direct map matrix corresponding to given mediate (Input)
c     mapi  - inverse map matrix corresponding to given mediate (Input)
c     rc    - return (error) code (Output)
c
       integer lun,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
       rc=0
c
c1    write mapd
c
       write (lun) mapd,mapi
c
       return
       end
c
c     ----------------------------
c
       subroutine ccsort_rea (lun,lenght,vector)
c
c     this routine read lenght-R8 numbers from opened unformatted file
c     with number lun form the given possition as one record
c
c     lun    - Logical unit number of file, where mediate is stored (Input)
c     lenght - # of R8 numbers to be read  (Input)
c     vector - space, where numbers are stored after reading  (Output)

c
       integer lun,lenght,i
       real*8 vector(1:lenght)
c
       read (lun) (vector(i),i=1,lenght)
c
       return
       end
c
c     ----------------------------
c
       subroutine ccsort_wri (lun,lenght,vector)
c
c     this routine write lenght-R8 numbers to opened unformatted file
c     with number lun at the given possition as one record
c
c     lun    - Logical unit number of file, where mediate will be stored (Input)
c     lenght - # of R8 numbers to be written  (Input)
c     vector - space, where numbers are stored  (Input)

c
       integer lun,lenght
       real*8 vector(1:lenght)
c
       write (lun) vector
c
       return
       end
c
c     ----------------------------
c
       subroutine ccsort_grc0 (nind,typ,typp,typq,typr,typs,stot,
     & poss0,posst,mapd,mapi)
c
c     this routine defines mapd and mapi for given intermediat
c
#include "ccsort.fh"
       integer nind,typ,typp,typq,typr,typs,stot,poss0,posst
c
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c     integer mul(1:8,1:8)
       integer dimm(1:4,1:8)
c
c     help variables
c
       integer sp,sq,sr,ss,spq,spqr
       integer nsymq,nsymr
       integer poss,i,nhelp1,nhelp2,nhelp3,nhelp4
c
c*    !!!!!!!! def dimm to je tu len terazky !!!!
c
       do i=1,nsym
       dimm(1,i)=noa(i)
       dimm(2,i)=nob(i)
       dimm(3,i)=nva(i)
       dimm(4,i)=nvb(i)
       end do
c
c     vanishing mapi files
c
       do nhelp1=1,nsym
       do nhelp2=1,nsym
       do nhelp3=1,nsym
       mapi(nhelp3,nhelp2,nhelp1)=0
       end do
       end do
       end do
c
c      To get rid of tiring compiler warning
       poss=0
       if (nind.eq.1) then
c
c     matrix A(p)
c
       i=1
       poss=poss0
       sp=mul(stot,1)
c
       nhelp1=dimm(typp,sp)
c
c     def mapi
       mapi(1,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       mapd(i,2)=nhelp1
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=0
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
       else if (nind.eq.2) then
c
c     matrix A(p,q)
c
       i=1
       poss=poss0
c
       do 100 sp=1,nsym
c
       sq=mul(stot,sp)
       if ((typ.eq.1).and.(sp.lt.sq)) then
c     Meggie out
       goto 100
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
c
c     def mapi
       mapi(sp,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2
       end if
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 100    continue
c
       else if (nind.eq.3) then
c
c     matrix A(p,q,r)
c
       i=1
       poss=poss0
c
       do 200 sp=1,nsym
       if (typ.eq.1) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 201 sq=1,nsymq
       spq=mul(sp,sq)
c
       sr=mul(stot,spq)
       if ((typ.eq.2).and.(sq.lt.sr)) then
c     Meggie out
       goto 201
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
c
c     def mapi
       mapi(sp,sq,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)*nhelp3/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3
       end if
c
c     def sym p,q,r
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 201    continue
 200    continue
c
       else if (nind.eq.4) then
c
c     matrix A(p,q,r,s)
c
       i=1
       poss=poss0
c
       do 300 sp=1,nsym
       if ((typ.eq.1).or.(typ.eq.4)) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 301 sq=1,nsymq
       spq=mul(sp,sq)
       if (typ.eq.2) then
       nsymr=sq
       else
       nsymr=nsym
       end if
c
       do 302 sr=1,nsymr
       spqr=mul(spq,sr)
c
       ss=mul(stot,spqr)
       if (((typ.eq.3).or.(typ.eq.4)).and.(sr.lt.ss)) then
c     Meggie out
       goto 302
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
       nhelp4=dimm(typs,ss)
c
c     def mapi
       mapi(sp,sq,sr)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp3-1)*nhelp4/2
       else if ((typ.eq.3).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else if (typ.eq.4) then
       if ((sp.eq.sq).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*(nhelp4-1)/4
       else if (sp.eq.sq) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if (sr.eq.ss) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
c
c     def sym p,q,r,s
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=ss
c
       poss=poss+mapd(i,2)
       i=i+1
c
 302    continue
 301    continue
 300    continue
c
       end if

c
       posst=poss
c
c     definition of other coll
c
       mapd(0,1)=typp
       mapd(0,2)=typq
       mapd(0,3)=typr
       mapd(0,4)=typs
       mapd(0,5)=i-1
       mapd(0,6)=typ
c
       return
       end
c
c     -----------------------------
c
       SUBROUTINE ccsort_mv0zero
     & (DD,LENGTH,MAT)
C
       INTEGER           DD
       INTEGER           LENGTH
       real*8  MAT(1:DD)
       INTEGER           INIT
       real*8  ZERO
C
       DATA              ZERO/0.0D+00/
C
C     ...loop over all elements
C
       DO 10 INIT=1,LENGTH
       MAT(INIT) = ZERO
 10     CONTINUE
C
       RETURN
       END
c
c     -----------------------------
c
       subroutine dawrtmediate (wrk,wrksize,
     & lun,mapd,mapi,rc)
c
c     this routine write required mediate to opened unformatted file
c     with number lun
c     it also store mapd and mapi of the given mediade
c
c     lun   - Logical unit number of file, where mediate will be stored (Input)
c     mapd  - direct map matrix corresponding to given mediate (Input)
c     mapi  - inverse map matrix corresponding to given mediate (Input)
c     rc    - return (error) code (Output)
c
c     N.B.
c     all mediates are storred as follows
c     1 - mapd, mapi
c     2 - one record with complete mediate
c
#include "wrk.fh"
       integer lun,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer im,lenght,poss0
c
       rc=0
c
c1    write mapd
c
      call dawrtmap (lun,mapd,mapi,rc)
c
c2    calculate overall lenght
c
       lenght=0
c
       do 100 im=1,mapd(0,5)
       lenght=lenght+mapd(im,2)
 100    continue
c
c     write mediate in one block
c
       if (lenght.eq.0) then
c     RC=1 : there is nothing to write, lenght of mediate is 0
       rc=1
       return
       end if
c
       poss0=mapd(1,1)
       call dawri (lun,lenght,wrk(poss0))
c
       return
       end
c
c     ----------------------------
c
       subroutine dawrtmap (lun,mapd,mapi,rc)
c
c     this routine write required mapd and mapi to opened unformatted file
c     with number lun
c
c     lun   - Logical unit number of file, where mediate will be stored (Input)
c     mapd  - direct map matrix corresponding to given mediate (Input)
c     mapi  - inverse map matrix corresponding to given mediate (Input)
c     rc    - return (error) code (Output)
c
#include "files_ccsd.fh"
#include "reorg.fh"

#include "SysDef.fh"
c
       integer lun,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
       rc=0
c
c1    write mapd
c
       if (iokey.eq.1) then
c      Fortran IO
       write (lun) mapd,mapi
c
       else
c      MOLCAS IO
       call idafile (lun,1,mapd,3078,daddr(lun))
       call idafile (lun,1,mapi,512,daddr(lun))
       end if
c
       return
       end
c
c     ----------------------------
c
       subroutine dawri (lun,lenght,vector)
c
c     this routine write lenght-R8 numbers to opened unformatted file
c     with number lun at the given possition as one record
c
c     lun    - Logical unit number of file, where mediate will be stored (Input)
c     lenght - # of R8 numbers to be written  (Input)
c     vector - space, where numbers are stored  (Input)

c
#include "files_ccsd.fh"
#include "reorg.fh"

#include "SysDef.fh"
c
       integer lun,lenght
       real*8 vector(1:lenght)
c
       if (iokey.eq.1) then
c      Fortran IO
       write (lun) vector
c
       else
c      MOLCAS IO
       call ddafile (lun,1,vector,lenght,daddr(lun))
       end if
c
       return
       end
c
c     ----------------------------
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Print_EigenValues(H,nH)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 H(nH*(nH+1)/2)
*
      Lu=6
*
      Call GetMem('EVal','Allo','Real',ipEVal,nH*(nH+1)/2)
      Call GetMem('EVec','Allo','Real',ipEVec,nH*nH)
*
*---- Copy elements for H
*
      call dcopy_(nH*(nH+1)/2,H,1,Work(ipEVal),1)
*
*---- Set up a unit matrix
*
      call dcopy_(nH*nH,[Zero],0,Work(ipEVec),1)
      call dcopy_(nH,[One],0,Work(ipEVec),nH+1)
*
*---- Compute eigenvalues and eigenvectors
*
      Call Jacob (Work(ipEVal),Work(ipEVec),nH,nH)
      Call Jacord(Work(ipEVal),Work(ipEVec),nH,nH)
*
*---- Print out the result
*
      Write (Lu,*)
      Write (Lu,*) 'Eigenvalues of the matrix'
      Write (Lu,*)
      Write (Lu,'(10F15.8)') (Work(i*(i+1)/2+ipEVal-1),i=1,nH)
*
      Call GetMem('EVec','Free','Real',ipEVec,nH*nH)
      Call GetMem('EVal','Free','Real',ipEVal,nH*(nH+1)/2)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DrvRF(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq,iCharge)

use External_Centers, only: iXPolType
use rctfld_module, only: lLangevin, lRF, lRFCav, PCM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nh1
real(kind=wp), intent(inout) :: h1(nh1), TwoHam(nh1), RepNuc
real(kind=wp), intent(in) :: D(nh1)
logical(kind=iwp), intent(in) :: First, Dff, NonEq
integer(kind=iwp), intent(inout) :: iCharge
integer(kind=iwp) :: iComp, iOpt, iRC, iSyLbl
real(kind=wp) :: EEE, ERfSelf, RepNuc_RF, RepNucXX(1)
real(kind=wp), save :: RepNuc_Temp
character(len=8) :: Label
real(kind=wp), allocatable :: h1_RF(:), h1_XX(:), RFld(:,:)
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. lRF) return

call Set_Basis_Mode('Valence')
call Setup_iSD()

call Init_RctFld(NonEq,iCharge)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(RFld,nh1,2,Label='RFld')
RFld(:,2) = Zero
if (First) RepNuc_Temp = RepNuc
!                                                                      *
!***********************************************************************
!                                                                      *
if (lLangevin .or. (iXPolType > 0)) then

  ! Reaction field a la polarizabilities and Langevin dipole
  ! moments on a grid in a cavity in a dielectric medium.

  call Langevin(h1,RFld(:,2),D,RepNuc,nh1,First,Dff,NonEq)

else if (PCM) then

  ! Reaction field a la PCM

  call DrvPCM(h1,RFld(:,2),D,RepNuc,nh1,First,Dff,NonEq)

else if (lRFCav) then

  ! Reaction field a la cavity in dielectric medium.

  call RctFld(h1,RFld(:,2),D,RepNuc,nh1,First,Dff,NonEq)

else
  call WarningMessage(2,'I do not know what reaction field type to use.')
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the original one-electron hamiltonian and add the reaction
! field contribution to it.

Label = 'h1    XX'
call Get_Temp(Label,RFld(:,1),nh1)
RFld(:,1) = h1(:)-RFld(:,1)
! Add contribution to the TwoHam array
TwoHam(:) = TwoHam(:)+RFld(:,2)

! Store away information for perturbative calculations

RFld(:,1)= RFld(:,1)+RFld(:,2)

ERFSelf = RepNuc-RepNuc_Temp
EEE = DDot_(nh1,RFld(1,2),1,D,1)
ERFSelf = ERFSelf-Half*EEE

call Put_dScalar('RF Self Energy',ERFSelf)
call Put_dArray('Reaction field',RFld(1,1),nh1)
call mma_deallocate(RFld)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out the matrix elements of the reaction field potential
! to be exploited in subsequent codes like, CC, MP2, and CASPT2.

Label = 'PotNucXX'
call Get_Temp(Label,RepNucXX,1)
RepNuc_RF = RepNuc-RepNucXX(1)

call mma_allocate(h1_RF,nh1+4,Label='h1_RF')
call mma_allocate(h1_XX,nh1,Label='h1_XX')

Label = 'h1    XX'
call Get_Temp(Label,h1_XX,nh1)
h1_RF(1:nh1) = h1(1:nh1)-h1_XX(1:nh1)
h1_RF(nh1+1:) = Zero
call mma_deallocate(h1_XX)

h1_RF(nh1+3) = RepNuc_RF

iSyLbl = 1
iRc = -1
iOpt = 0
iComp = 1
Label = 'OneHamRF'
call WrOne(iRc,iOpt,Label,iComp,h1_RF,iSyLbl)

call mma_deallocate(h1_RF)
!                                                                      *
!***********************************************************************
!                                                                      *
call Free_iSD()

return

end subroutine DrvRF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_ReoQual(iQScr,IDK,nK)
      Implicit None
      Integer iQScr(*), IDK(*), nK(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
#include "cho_para_info.fh"

      Call Cho_ReoQual(iWork(ip_iQuAB),MaxQual,nSym,iQScr,IDK,nK,nQual)
      If (Cho_Real_Par) Then
         Call Cho_P_QualSwp()
         Call Cho_ReoQual(iWork(ip_iQuAB),MaxQual,nSym,iQScr,IDK,nK,
     &                    nQual)
         Call Cho_P_QualSwp()
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FAIBJ(INTSYM,INDX,C,S,ABIJ,AIBJ,AJBI,A,B,F,FSEC)

use mrci_global, only: IRC, IREST, IROW, ITER, LASTAD, LN, Lu_60, LUSYMB, NBITM3, NSM, NSYM, NVIR, NVIRT, SQ2, SQ2INV
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: INTSYM(*), INDX(*)
real(kind=wp), intent(inout) :: C(*), S(*), ABIJ(*), AIBJ(*), AJBI(*), FSEC(*)
real(kind=wp), intent(_OUT_) :: A(*), B(*), F(*)
integer(kind=iwp) :: IAB, IADD10, IADR, IASYM, IBSYM, ICHK, iCoup, iCoup1, IFAB, IFT, IFTA, IFTB, II, IIN, IJ1, ILIM, INDA, INDB, &
                     INDCOP, INDI, INMY, INNY, INS, IPF, IPF1, IPOA(9), IPOB(9), IPOF(9), ISTAR, ITURN, iTyp, JTURN, LENBUF, &
                     LENCOP, MYL, MYSYM, NI, NJ, NOT2, NOVST, NSIJ, NVIRA, NVIRB, NVIRC, NYL, NYSYM
real(kind=wp) :: COPI, CPL, CPLA, FAC, FACS, TERM
integer(kind=iwp), allocatable :: iBuf(:)
real(kind=wp), allocatable :: Buf(:)
logical(kind=iwp) :: Skip
real(kind=r8), external :: DDOT_

call mma_allocate(Buf,NBITM3,label='Buf')
call mma_allocate(iBuf,NBITM3+2,label='iBuf')

!vv this code is a real compiler killer!

! POW: Unnecessary but warningstopping initializations
iTyp = -1234567
iCoup = -1234567
iCoup1 = -1234567

call CSCALE(INDX,INTSYM,C,SQ2)
call CSCALE(INDX,INTSYM,S,SQ2INV)
ICHK = 0
IFAB = 0
NOVST = LN*NVIRT+1+(NVIRT*(NVIRT+1))/2
NOT2 = IROW(LN+1)

IADD10 = IAD10(6)

! Long loop, reading buffers until end of buffers is signalled
! by length field holding a negative number.
do
  call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
  call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
  LENCOP = ICOP1(nCOP+1)
  if (LENCOP < 0) exit

  ! Loop over the elements of this buffer
  do II=1,LENCOP
    INDCOP = ICOP1(II)
    if (ICHK == 0) then
      if (INDCOP == 0) then
        ICHK = 1
      else
        if (IFAB == 1) then
          CPLA = COP(II)
          IFAB = 0
        else
          IFAB = ibits(INDCOP,0,1)
          ITURN = ibits(INDCOP,1,1)
          ITYP = ibits(INDCOP,2,3)
          ICOUP = ibits(INDCOP,5,13)
          ICOUP1 = ibits(INDCOP,18,13)
          CPL = COP(II)
          CPLA = Zero
          if (IFAB /= 0) cycle
          if (ITURN == 0) then
            ! FIRST ORDER INTERACTION
            INDA = ICOUP
            INDB = IRC(ITYP+1)+ICOUP1
            ISTAR = 1
            if (ITYP == 1) ISTAR = INS+1
            if (INS /= 0) then
              COPI = CPL*C(INDA)
              S(INDX(INDB)+1:INDX(INDB)+INS) = S(INDX(INDB)+1:INDX(INDB)+INS)+COPI*FSEC(ISTAR:ISTAR+INS-1)
              TERM = DDOT_(INS,FSEC(ISTAR),1,C(INDX(INDB)+1),1)
              S(INDA) = S(INDA)+CPL*TERM
            end if
            cycle
          end if
        end if

        ! INTERACTIONS BETWEEN DOUBLES AND
        ! INTERACTIONS BETWEEN SINGLES
        if ((ITER /= 1) .or. (IREST /= 0)) then

          call faibj2(IFTA,IFTB,ICOUP1,ICOUP,INDA,INDB,MYSYM,INTSYM,NYSYM,NSIJ,MYL,NYL,FACS,IPOA,IPOB,INMY,INNY,INDX,iTYP)

          if (ITYP == 5) then
            ! DOUBLET-DOUBLET INTERACTIONS
            IIN = IPOF(MYL+1)-IPOF(MYL)
            if (IIN /= 0) then
              IPF = IPOF(MYL)+1
              F(1:IIN) = CPL*AIBJ(IPF:IPF+IIN-1)+CPLA*ABIJ(IPF:IPF+IIN-1)
              if (INDA == INDB) call DCOPY_(NVIR(MYL),[Zero],0,F,NVIR(MYL)+1)
              call DGEMV_('T',NVIR(MYL),NVIR(NYL),FACS,F,NVIR(MYL),C(INMY),1,One,S(INNY),1)
              if (INDA /= INDB) then
                call DGEMV_('N',NVIR(MYL),NVIR(NYL),FACS,F,NVIR(MYL),C(INNY),1,One,S(INMY),1)
              end if
            end if
          else
            ! TRIPLET-SINGLET, SINGLET-TRIPLET,
            ! TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS

            call loop70(C,S,ABIJ,AIBJ,AJBI,A,B,F,IPOF,IPOA,IPOB,MYL,NYL,INDA,INDB,INMY,INNY,IFTB,IFTA,FACS,IAB,CPL,CPLA,NVIRA, &
                        NVIRC,NVIRB)

          end if
        end if
      end if
    else
      ICHK = 0

      ! Unpack indices NI and NJ from INDCOP
      INDI = INDCOP
      NI = ibits(INDI,0,10)
      NJ = ibits(INDI,10,10)

      NSIJ = MUL(NSM(NI),NSM(NJ))
      call IPO(IPOF,NVIR,MUL,NSYM,NSIJ,-1)
      IJ1 = IROW(NI)+NJ
      ILIM = IPOF(NSYM+1)
      ! Clear matrices ABIJ, AIBJ, and AJBI.
      ABIJ(1:ILIM) = Zero
      AIBJ(1:ILIM) = Zero
      AJBI(1:ILIM) = Zero
      if ((ITER == 1) .and. (IREST == 0)) then
        Skip = .true.
      else
        ! READ (AB/IJ) INTEGRALS

        IADR = LASTAD(NOVST+IJ1)
        JTURN = 0
        Skip = .false.
      end if
      do
        if (Skip) then
          Skip = .false.
        else
          call iDAFILE(Lu_60,2,iBuf,NBITM3+2,IADR)
          call dDAFILE(Lu_60,2,Buf,NBITM3,IADR)
          LENBUF = iBuf(NBITM3+1)
          IADR = iBuf(NBITM3+2)
          call faibj5(LENBUF,JTURN,iBuf,Buf,AIBJ,ABIJ)

          if (IADR /= -1) cycle
          if (JTURN == 1) exit
        end if

        ! READ (AI/BJ) INTEGRALS

        IADR = LASTAD(NOVST+NOT2+IJ1)
        JTURN = 1
      end do

      ! CONSTRUCT FIRST ORDER MATRICES

      FAC = One
      if (NI == NJ) FAC = Half
      IIN = 0

      IFT = 0
      call faibj3(NSIJ,IFT,AIBJ,FSEC,FAC,IIN,INS,IPOA,IPOF)

      if ((ITER /= 1) .or. (IREST /= 0)) then
        do IASYM=1,NSYM
          NVIRA = NVIR(IASYM)
          if (NVIRA == 0) cycle
          IBSYM = MUL(NSIJ,IASYM)
          NVIRB = NVIR(IBSYM)
          if (NVIRB == 0) cycle
          IPF = IPOF(IASYM)+1
          IPF1 = IPOF(IBSYM)+1
          if (IASYM > IBSYM) then
            call MTRANS(AIBJ(IPF1),AJBI(IPF),NVIRA,NVIRB)
          else if (NSIJ /= 1) then
            call MTRANS(ABIJ(IPF1),ABIJ(IPF),NVIRA,NVIRB)
            call MTRANS(AIBJ(IPF1),AJBI(IPF),NVIRA,NVIRB)
          else
            call SQUAR2(ABIJ(IPF),NVIRA)
            if (NI == NJ) call SQUAR2(AIBJ(IPF),NVIRA)
            call MTRANS(AIBJ(IPF),AJBI(IPF),NVIRA,NVIRB)
          end if
        end do
      end if
    end if
  end do
end do

call CSCALE(INDX,INTSYM,C,SQ2INV)
call CSCALE(INDX,INTSYM,S,SQ2)
call mma_deallocate(Buf)
call mma_deallocate(iBuf)

return

end subroutine FAIBJ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine IniReord_t3(NaGrp)
! nacitanie vsupu a inicializacia premnennych
! a tlac primitivnej hlavicky pre Reord procesz

use ChT3_global, only: gen_files, LunAux, nc, nfr, no, nv, printkey, run_triples, t3_starta, t3_startb, t3_stopa, t3_stopb
#ifdef _MOLCAS_MPP_
use Para_Info, only: MyRank, nProcs
use stdalloc, only: mma_allocate, mma_deallocate
#endif
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: NaGrp
#include "cholesky.fh"
integer(kind=iwp) :: LuSpool, ndelvirt, nOcc(8), nOrb(8), rc
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: jal1, jal2
integer(kind=iwp), allocatable :: NChLoc(:)
#endif
real(kind=wp) FracMem
character(len=80) :: LINE
character(len=3) :: msg

! setup defaults

call Get_iArray('nOrb',nOrb,1)
call Get_iArray('nIsh',nOcc,1)

no = nOcc(1)
nv = nOrb(1)-nOcc(1)

FracMem = Zero
call Cho_X_init(rc,FracMem) ! initialize cholesky info

! take local # of Cholesky Vectors on this node
#ifdef _MOLCAS_MPP_

call mma_allocate(NChLoc,NProcs,label='NChLoc')
NChLoc(:) = 0

NChLoc(MyRank+1) = NumCho(1)

call gaigop(NChLoc,NProcs,'+')

jal2 = 0
do jal1=1,NProcs
  jal2 = jal2+NChLoc(jal1)
end do

call mma_deallocate(NChLoc)

nc = jal2
#else
nc = NumCho(1)
#endif

call Cho_X_final(rc)

ndelvirt = 0
LunAux = 13
!mhkey = 1
!generkey = 1
!mp !NaGrp = 1
call get_iScalar('CHCCLarge',NaGrp)
!restkey = 0
printkey = 1

! t3 specific keywords

gen_files = .true.
run_triples = .true.
t3_starta = -1
t3_stopa = -1
t3_startb = -1
t3_stopb = -1

!mp read input file

LuSpool = 17
call SpoolInp(LuSpool)
rewind(LuSpool)
do
  read(LuSpool,'(A80)') LINE
  call UPCASE(LINE)
  if (index(LINE,'&CHT3') /= 0) exit
end do
do
  read(LuSpool,'(A80)') LINE
  if (LINE(1:1) == '*') cycle
  call UPCASE(LINE)

  select case (LINE(1:4))

    case ('TITL')
      read(LuSpool,*)

    case ('FROZ') ! FROZen
      read(LuSpool,*) nfr
      if ((nfr < 0) .or. (nfr >= no)) then
        write(u6,*)
        write(u6,*) 'Ilegal value for FROZen keyword : ',nfr
        call abend()
      end if
      no = no-nfr

    case ('DELE') ! DELEted
      read(LuSpool,*) ndelvirt
      if ((ndelvirt < 0) .or. (ndelvirt >= nv)) then
        write(u6,*)
        write(u6,*) 'Ilegal value for DELEted keyword : ',ndelvirt
        call abend()
      end if
      nv = nv-ndelvirt

    !mp !case ('LARG') ! LARGegroup
    !mp !  read(LuSpool,*) NaGrp
    !mp !  if ((NaGrp < 1) .or. (NaGrp > 32)) then
    !mp !    write(u6,*)
    !mp !    write(u6,*) 'Ilegal value for LARGegroup keyword : ',NaGrp
    !mp !    write(u6,*) 'Large segmentation must be <= 32'
    !mp !    call abend()
    !mp !  end if

    !mp !case ('LUNA') !... toto sa nikdy nevyuzivalo
    !mp !  read(LuSpool,*) LunAux

    !case ('MHKE') ! MHKEy
    !  read(LuSpool,*) mhkey
    !  if ((mhkey < 0) .or. (mhkey > 2)) then
    !    mhkey = 1
    !    write(u6,*)
    !    write(u6,*) ' Warning!!! ',' MHKEy out of range, changed to 1'
    !  end if

    case ('REST') ! RESTart
      !restkey = 1
      write(u6,*)
      write(u6,*) 'RESTart option is temporary disabled'
      write(u6,*) 'No Restart possible (... yet).'
      call abend()

    case ('PRIN') ! PRINtkey
      read(LuSpool,*) printkey
      if (((printkey < 0) .or. (printkey > 10)) .or. ((printkey > 2) .and. (printkey < 10))) then

        write(u6,*)
        write(u6,*) 'Ilegal value of the PRINtkey keyword: ',printkey
        write(u6,*) ' Use: 1  (Minimal) '
        write(u6,*) '      2  (Minimal + Timings)'
        write(u6,*) '      10 (Debug) '
        call abend()
      end if

    case ('NOGE') ! NOGEnerate
      gen_files = .false.

    case ('NOTR') ! NOTRiples
      run_triples = .false.

    case ('ALOO') ! ALOOp
      read(LuSpool,*) t3_starta,t3_stopa
      if ((t3_starta < -1) .or. (t3_stopa < -1)) then
        write(u6,*) 'ALOOp values can be either: '
        write(u6,*) '-1 : indicating normal run, or'
        write(u6,*) 'positive numbers!'
        call abend()
      end if

    case ('BLOO') ! BLOOp
      read(LuSpool,*) t3_startb,t3_stopb
      if ((t3_startb < -1) .or. (t3_stopb < -1)) then
        write(u6,*) 'BLOOp values can be either: '
        write(u6,*) '-1 : indicating normal run, or'
        write(u6,*) 'positive numbers!'
        call abend()
      end if

    case ('END ')
      exit

  end select
end do

call Close_LuSpool(LuSpool)

!! take care of the cholesky vectors segmentation
!! to lead to < 100 blocks

!mp checks
if (t3_starta > t3_stopa) then
  write(u6,*) 'Mismatch in input : '
  write(u6,*) 'T3_STARTA = ',t3_starta
  write(u6,*) 'T3_STOPA = ',t3_stopa
  call abend()
end if

if (t3_startb > t3_stopb) then
  write(u6,*) 'Mismatch in input : '
  write(u6,*) 'T3_STARTB = ',t3_startb
  write(u6,*) 'T3_STOPB = ',t3_stopb
  call abend()
end if

if ((t3_starta < 0) .and. (t3_stopa > 0)) then
  write(u6,*) 'Mismatch in input : '
  write(u6,*) 'T3_STARTA = ',t3_starta
  write(u6,*) 'T3_STOPA = ',t3_stopa
  call abend()
end if

if ((t3_startb < 0) .and. (t3_stopb > 0)) then
  write(u6,*) 'Mismatch in input : '
  write(u6,*) 'T3_STARTB = ',t3_startb
  write(u6,*) 'T3_STOPB = ',t3_stopb
  call abend()
end if

!mp !if ((t3_starta < 0) .and. (t3_startb < 0)) then
!mp !  write(u6,*) 'This restart combination not implemented'
!mp !  write(u6,*) 'T3_STARTA = ',t3_starta
!mp !  write(u6,*) 'T3_STARTB = ',t3_startb
!mp !  call abend()
!mp !end if

!2 tlac hlavicky
write(u6,*)
write(u6,*) '    Cholesky Based Closed-Shell (T) code'
write(u6,*)
write(u6,*) '--------------------------------------------------'

write(u6,'(A,i9)') ' Frozen Orbitals                   : ',nfr
write(u6,'(A,i9)') ' Occupied Orbitals                 : ',no
write(u6,'(A,i9)') ' Virtual Orbitals                  : ',nv
write(u6,'(A,i9)') ' Total number of Cholesky Vectors  : ',nc

write(u6,*) '--------------------------------------------------'

write(u6,'(A,i9)') ' Large Virtual Segmentation        : ',NaGrp

write(u6,*) '--------------------------------------------------'

msg = 'No'
if (gen_files) msg = 'Yes'

write(u6,'(A,A5)') ' Generate Triples Scratch Files?        : ',msg

msg = 'No'
if (.not. run_triples) msg = 'Yes'

write(u6,'(A,A5)') ' Stop after Scratch Files generation?   : ',msg

write(u6,*) '--------------------------------------------------'

if (t3_starta == -1) then
  write(u6,'(A,i4)') ' Calculating full loop A                '
else
  write(u6,'(A,i4)') ' VO index triplet to start with in loop A : ',t3_starta
  write(u6,'(A,i4)') ' VO index triplet to stop  at   in loop A : ',t3_stopa
end if

if (t3_starta == -1) then
  write(u6,'(A,i4)') ' Calculating full loop B                '
else
  write(u6,'(A,i4)') ' VO index triplet to start with in loop B : ',t3_startb
  write(u6,'(A,i4)') ' VO index triplet to stop  at   in loop B : ',t3_stopb
end if

write(u6,*) '--------------------------------------------------'

write(u6,'(A,i9)') ' Lun Number for Aux. Matrixes      : ',LunAux
!write(u6,'(A,i9)') ' BLAS/FTN Matrix Handling          : ',mhkey

!msg = 'No'
!if (restkey == 1) msg = 'Yes'

!write(u6,'(A,A10)') ' Start from RstFil ?               : ',msg
write(u6,'(A,i9)') ' Print level                       : ',printkey

write(u6,*) '--------------------------------------------------'
write(u6,*)

return

end subroutine IniReord_t3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine fraginp_cvb(ip_iconfs)
      implicit real*8 (a-h,o-z)
      parameter (nstrin=2,ncmp=4)
      character*8 string(nstrin)
      dimension dum(1)
      save string
      data string/'WAVE    ','CON    '/
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "malloc_cvb.fh"

1000  call fstring_cvb(string,nstrin,istr,ncmp,2)
      if(istr.eq.1)then
c 'WAVE'
        nfrag=nfrag+1
        nel_fr(nfrag)=0
        call int_cvb(nel_fr(nfrag),1,nread,1)
        nMs_fr(nfrag)=0
        nS_fr(nfrag)=0
        nalf_fr(1,nfrag)=0
        nbet_fr(1,nfrag)=0
        i2s_fr(1,nfrag)=-1
100     Scurr=-one
        call real_cvb(dum,1,nread,1)
        Scurr=dum(1)
        if(Scurr.ne.-one)then
          nS_fr(nfrag)=nS_fr(nfrag)+1
          i2s_fr(nS_fr(nfrag),nfrag)=nint(2d0*Scurr)
          goto 100
        endif
      elseif(istr.eq.2)then
c 'CON'
        if(nfrag.eq.0)then
          nfrag=1
          nel_fr(nfrag)=0
          nMs_fr(nfrag)=0
          nS_fr(nfrag)=0
          nalf_fr(1,nfrag)=0
          nbet_fr(1,nfrag)=0
          i2s_fr(1,nfrag)=-1
        endif

        mxconf=max(mavaili_cvb()-1000,0)/noe
        call mrealloci_cvb(ip_iconfs,noe*mxconf)
        nconf_fr(nfrag)=1
        nconf=nconf+1
200     continue
        if(mxconf.lt.nconf)then
          write(6,*)' Insufficient memory for configuration read',
     >      mavaili_cvb(),mxconf,nconf
          call abend_cvb()
        endif
        call izero(iw(noe*(nconf-1)+ip_iconfs),noe)
        call int_cvb(iw(noe*(nconf-1)+ip_iconfs),noe,nread,1)
        call fstring_cvb('CON',1,istr2,3,2)
        if(istr2.ne.0)then
          nconf_fr(nfrag)=nconf_fr(nfrag)+1
          nconf=nconf+1
          goto 200
        endif
        call mrealloci_cvb(ip_iconfs,noe*nconf)
      endif
      if(istr.ne.0)goto 1000
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1998,2025, Roland Lindh                 *
!               1990, IBM                                              *
!***********************************************************************

subroutine Drv2El_ijij(Pair_Index,nPairs,TMax,nSkal)
!***********************************************************************
!                                                                      *
!  Object: driver for two-electron integrals.                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Modified for k2 loop. August '91                         *
!             Modified to minimize overhead for calculations with      *
!             small basis sets and large molecules. Sept. '93          *
!             Modified driver. Jan. '98                                *
!             Modified driver for (ij|ij) integrals. Jan '25           *
!***********************************************************************

use iSD_data, only: iSD
use setup, only: mSkal
use Basis_Info, only: dbsc
use Gateway_Info, only: CutInt
use Integral_interfaces, only: Int_PostProcess, int_wrout
use Int_Options, only: Disc_Mx, DoFock, DoIntegrals
use Basis_Info, only: Shells
use k2_arrays, only: Sew_Scr
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nPairs, Pair_Index(2,nPairs), nSkal
real(kind=wp), intent(inout) :: TMax(nSkal,nSkal)
integer(kind=iwp) :: iCnttp, ijS, iS, iShll, jCnttp, jS, jShll
real(kind=wp) :: A_int, Save_Disc_Mx
logical(kind=iwp) :: Deallocate_Sew_Scr, SaveVar(2)
character(len=72) :: SLine
real(kind=wp), allocatable :: TInt(:)
integer(kind=iwp), parameter :: nTInt = 1
procedure(int_wrout) :: Integral_ijij
procedure(int_wrout), pointer :: Int_postprocess_Save

!                                                                      *
!***********************************************************************
!                                                                      *
! Store the current setting of the integral environment
SaveVar(1) = DoIntegrals
SaveVar(2) = DoFock
Save_Disc_Mx = Disc_Mx
! Note that Int_PostProcess is a pointer, and according to the Fortran
! standard Int_PostProcess_Save will point to the target of Int_PostProcess.
! This will allow restoring the original Int_PostProcess association
! at the end, even if Int_PostProcess_Save goes out of scope after.
Int_PostProcess_Save => Int_PostProcess

! Setup the integral environment consistent with Drv2el_ijij

DoIntegrals = .true.
DoFock = .false.
Disc_Mx = Zero
Int_PostProcess => Integral_ijij

! check if the Seward scratch array is already allocated externally.
! If so do not deallocate on exit
Deallocate_Sew_Scr = .not. allocated(Sew_Scr)

SLine = 'Computing 2-electron integrals'
call StatusLine('Seward: ',SLine)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(TInt,nTint,Label='TInt')
!                                                                      *
!***********************************************************************
!                                                                      *

do ijS=1,nPairs
  iS = Pair_Index(1,ijS)
  jS = Pair_Index(2,ijS)

  iCnttp = iSD(13,iS)
  jCnttp = iSD(13,jS)
  if (dbsc(iCnttp)%fMass /= dbsc(jCnttp)%fMass) cycle

  iShll = iSD(0,iS)

  ! In case of auxiliary basis sets we want the iS index to point at the dummy shell.
  if (Shells(iShll)%Aux .and. (iS /= mSkal)) cycle

  jShll = iSD(0,jS)

  ! In case the first shell is the dummy auxiliary basis shell make sure that
  ! the second shell, jS, also is an auxiliary basis shell.
  if (Shells(iShll)%Aux .and. (.not. Shells(jShll)%Aux)) cycle

  ! Make sure that the second shell never is the dummy auxiliary basis shell.
  if (Shells(jShll)%Aux .and. (jS == mSkal)) cycle

  A_int = TMax(iS,jS)*TMax(iS,jS)
  if (A_Int < CutInt) cycle

  call Eval_IJKL(iS,jS,iS,jS,TInt,nTInt)
  !write(u6,*) iS,jS,Tmax(iS,jS),sqrt(abs(TInt(1)))
  TMax(iS,jS) = sqrt(abs(TInt(1)))
  TMax(jS,iS) = TMax(iS,jS)

end do

call mma_deallocate(TInt)

! Restore the status the integral environment as before the call.

DoIntegrals = SaveVar(1)
DoFock = SaveVar(2)
Disc_Mx = Save_Disc_Mx
Int_PostProcess => Int_PostProcess_Save

if (Deallocate_Sew_Scr) call mma_deallocate(Sew_Scr)

end subroutine Drv2El_ijij

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DZAXPY(N,DA,DX,INCX,DY,INCY,DZ,INCZ)
C
C     MULTIPLY A VECTOR, X, BY A SCALAR, ADD TO A VECTOR, Y, AND
C     STORE THE RESULT IN THE VECTOR Z.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DX(*),DY(*),DZ(*)
      DATA ZERO /0.0D+00/
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C          NOT EQUAL TO 1
C
      IY = 1
      IZ = 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      IF(INCZ.LT.0)IZ = (-N+1)*INCZ + 1
      IF (DA .NE. ZERO ) THEN
         IX = 1
         IF(INCX.LT.0)IX = (-N+1)*INCX + 1
         DO I = 1,N
           DZ(IY) = DY(IY) + DA*DX(IX)
           IX = IX + INCX
           IY = IY + INCY
           IZ = IZ + INCZ
         End Do
      ELSE
         DO I = 1,N
           DZ(IY) = DY(IY)
           IY = IY + INCY
           IZ = IZ + INCZ
         End Do
      END IF
      RETURN
C
C        CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C        CLEAN-UP LOOP
C
   20 M = MOD(N,4)
      IF (DA .NE. ZERO ) THEN
         IF( M .NE. 0 ) THEN
            DO I = 1,M
              DZ(I) = DY(I) + DA*DX(I)
            END DO
            IF( N .LT. 4 ) RETURN
         END IF
         MP1 = M + 1
         DO I = MP1,N,4
           DZ(I) = DY(I) + DA*DX(I)
           DZ(I + 1) = DY(I + 1) + DA*DX(I + 1)
           DZ(I + 2) = DY(I + 2) + DA*DX(I + 2)
           DZ(I + 3) = DY(I + 3) + DA*DX(I + 3)
         END DO
      ELSE
         IF( M .NE. 0 ) THEN
            DO I = 1,M
              DZ(I) = DY(I)
            END DO
            IF( N .LT. 4 ) RETURN
         END IF
         MP1 = M + 1
         DO I = MP1,N,4
           DZ(I) = DY(I)
           DZ(I + 1) = DY(I + 1)
           DZ(I + 2) = DY(I + 2)
           DZ(I + 3) = DY(I + 3)
         END DO
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

function Log2(n)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: Log2
integer(kind=iwp), intent(in) :: n
integer(kind=iwp) :: m

m = n
Log2 = 0
do while (m > 1)
  m = m/2
  Log2 = Log2+1
end do

return

end function Log2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine chngcont(coeffs,coeffst1,coeffst1a,coeffst2,
     *coeffst2a,ncont,nprims,evec,
     *type1,type2,work,work2,work3,MxprimL,
     *rootOVLP,OVLPinv,exponents)
c###############################################################################
cbs   purpose: makes out of old contraction coefficients(in normalized functions)
cbs   new coefficients including the kinematical factors
cbs   using the diagonal matrices on type1 and type2 (see subroutine kinemat)
cbs   coeffst1a and coeffst2a additionally include the exponents alpha
cbs   (that is why ....a). So the exponents in the integrals are moved
cbs   to the contraction coefficients and not in some way into the primitive
cbs   integrals.
cbs
cbs   the different cases for contracted integrals differ later on in the
cbs   choice of different sets of contraction coefficients.
cbs
c###############################################################################
      implicit real*8 (a-h,o-z)
      dimension coeffs(nprims,ncont),! original contraction coefficients
     *coeffst1(nprims,ncont),        ! A * cont coeff
     *coeffst1a(nprims,ncont),       ! A * alpha*cont coeff
     *coeffst2a(nprims,ncont),       ! c*A/(E+m) * cont coeff
     *coeffst2(nprims,ncont),        ! c*A/(E+m) * alpha *cont coeff
     *evec(nprims,nprims),
     *work(nprims,nprims) ,
     *work2(nprims,nprims) ,
     *work3(nprims,nprims) ,
     *rootOVLP(MxprimL,*),
     *OVLPinv(MxprimL,*),
     *type1(*),type2(*),
     *exponents(*)
cbs
cbs   first new coefficients for type1 (A)
cbs   generate a transformation matrix on work
cbs
      do J=1,nprims
      do I=1,nprims
      work(I,J)=0d0
      work2(I,J)=0d0
      work3(I,J)=0d0
      enddo
      enddo
cbs   build up the transformation matrix
      do K=1,nprims
      do J=1,nprims
      do I=1,nprims
      work(I,J)=work(I,J)+evec(I,K)*type1(K)*evec(J,K)
      enddo
      enddo
      enddo
      do K=1,nprims
      do J=1,nprims
      do I=1,nprims
      work2(I,J)=work2(I,J)+work(I,K)*rootOVLP(K,J)
      enddo
      enddo
      enddo
      do K=1,nprims
      do J=1,nprims
      do I=1,nprims
      work3(I,J)=work3(I,J)+rootOVLP(I,K)*work2(K,J)
      enddo
      enddo
      enddo
      do J=1,nprims
      do I=1,nprims
      work(I,J)=0d0
      enddo
      enddo
      do K=1,nprims
      do J=1,nprims
      do I=1,nprims
      work(J,I)=work(J,I)+OVLPinv(I,K)*work3(K,J)
      enddo
      enddo
      enddo
      do K=1,ncont
      do I=1,nprims
      coeffst1(I,K)=0d0
      enddo
      enddo
cbs   now transform the vectors
      do K=1,ncont
      do J=1,nprims
      do I=1,nprims
      coeffst1(I,K)=coeffst1(I,K)+work(J,I)*coeffs(J,K)
      enddo
      enddo
      enddo
cbs
cbs   now with exponent
cbs
      do K=1,ncont
      do I=1,nprims
      coeffst1a(I,K)=exponents(I)*coeffst1(I,K)
      enddo
      enddo
cbs
cbs   and now the same for the other type  A/(E+m)
cbs
      do J=1,nprims
      do I=1,nprims
      work(I,J)=0d0
      work2(I,J)=0d0
      work3(I,J)=0d0
      enddo
      enddo
cbs   build up the transformation matrix
      do K=1,nprims
      do J=1,nprims
      do I=1,nprims
      work(I,J)=work(I,J)+evec(I,K)*type2(K)*evec(J,K)
      enddo
      enddo
      enddo
      do K=1,nprims
      do J=1,nprims
      do I=1,nprims
      work2(I,J)=work2(I,J)+work(I,K)*rootOVLP(K,J)
      enddo
      enddo
      enddo
      do K=1,nprims
      do J=1,nprims
      do I=1,nprims
      work3(I,J)=work3(I,J)+rootOVLP(I,K)*work2(K,J)
      enddo
      enddo
      enddo
      do J=1,nprims
      do I=1,nprims
      work(I,J)=0d0
      enddo
      enddo
      do K=1,nprims
      do J=1,nprims
      do I=1,nprims
      work(J,I)=work(J,I)+OVLPinv(I,K)*work3(K,J)
      enddo
      enddo
      enddo
      do K=1,ncont
      do I=1,nprims
      coeffst2(I,K)=0d0
      enddo
      enddo
cbs   now transform the vectors
      do K=1,ncont
      do J=1,nprims
      do I=1,nprims
      coeffst2(I,K)=coeffst2(I,K)+work(J,I)*coeffs(J,K)
      enddo
      enddo
      enddo
cbs
cbs   now with exponent
cbs
      do K=1,ncont
      do I=1,nprims
      coeffst2a(I,K)=exponents(I)*coeffst2(I,K)
      enddo
      enddo
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SIGVST(ISGVST,NSMST)
*
* Obtain ISGVST(ISM) : Symmetry of sigma v on string of symmetry ism
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER ISGVST(*)
*
      DO 100 ISM = 1, NSMST
C            MLSM(IML,IPARI,ISM,TYPE,IWAY)
        CALL MLSM(IML,IPARI,ISM,'ST',2)
        MIML = - IML
        CALL MLSM(MIML,IPARI,MISM,'ST',1)
        ISGVST(ISM) = MISM
  100 CONTINUE
*
      NTEST = 1
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' ISGVST array '
        WRITE(6,*) ' ============ '
        CALL IWRTMA(ISGVST,1,NSMST,1,NSMST)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      integer function ioemrg_cvb(ia1,na1,ia2,na2)
      implicit real*8 (a-h,o-z)
      dimension ia1(na1),ia2(na2)

      n1=1
      n2=1
      ioe=0
100   continue
      if(n1.gt.na1)then
        ioemrg_cvb=1-2*mod(ioe,2)
        return
      elseif(n2.gt.na2)then
        ioe=ioe+(na1-n1+1)*na2
        ioemrg_cvb=1-2*mod(ioe,2)
        return
      endif
      if(ia1(n1).lt.ia2(n2))then
        ioe=ioe+n2-1
        n1=n1+1
      elseif(ia1(n1).gt.ia2(n2))then
        n2=n2+1
      elseif(ia1(n1).eq.ia2(n2))then
        ioemrg_cvb=0
        return
      endif
      goto 100
      end
      integer function ioemrg2_cvb(ia1,na1,ia2,na2,ia12)
      implicit real*8 (a-h,o-z)
      dimension ia1(na1),ia2(na2),ia12(*)

      n1=1
      n2=1
      ioe=0
      n12=1
100   continue
      if(n1.gt.na1)then
        ioemrg2_cvb=1-2*mod(ioe,2)
        do i=n2,na2
        ia12(n12)=ia2(i)
        n12=n12+1
        enddo
        return
      elseif(n2.gt.na2)then
        ioe=ioe+(na1-n1+1)*na2
        ioemrg2_cvb=1-2*mod(ioe,2)
        do i=n1,na1
        ia12(n12)=ia1(i)
        n12=n12+1
        enddo
        return
      endif
      if(ia1(n1).lt.ia2(n2))then
        ioe=ioe+n2-1
        ia12(n12)=ia1(n1)
        n1=n1+1
        n12=n12+1
      elseif(ia1(n1).gt.ia2(n2))then
        ia12(n12)=ia2(n1)
        n2=n2+1
        n12=n12+1
      elseif(ia1(n1).eq.ia2(n2))then
        ioemrg2_cvb=0
        return
      endif
      goto 100
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine POLY_ANISO_1( nneq, neqv, nmax, exch, nLoc,
     &                         nCenter, nT, nH, nTempMagn, nDir,
     &                         nDirZee, nMult, nPair, MxRank1, MxRank2,
     &                         old_aniso_format, iReturn )

      Implicit None
#include "warnings.h"
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
!======================================================================
c  definition of the cluster:

      Integer                       :: mem,RtoB,CtoB,ItoB
!     number of non-equivalent sites
      Integer                       :: nneq
!     number of equivalent sites of each type, neqv = MAXVAL(neq(:))
      Integer                       :: neqv
      Integer                       :: nCenter
      Integer, allocatable          :: neq(:)
c  definition of the local metal sites
!     number of spin-orbit states. nLoc = MAXVAL(nss(:));
      Integer                       :: nLoc
      Integer, allocatable          :: nss(:), nsfs(:)
c      Integer       :: nsfs(nneq), multiplicity(nneq,nLoc)
      Real(kind=8), allocatable    :: gtens_input(:,:)
!                                      gtens_input(3,nneq)
      Real(kind=8), allocatable    :: D_fact(:), EoverD_fact(:)
!     definition of the main local axes in general coord system
      Real(kind=8), allocatable    :: riso(:,:,:)
      Real(kind=8), allocatable    :: R_LG( :,:,:,:)
!                                      R_LG( nneq,neqv,3,3)
      Real(kind=8), allocatable    :: R_ROT(:,:,:,:)
!                                      R_ROT(nneq,neqv,3,3)
!     spin orbit energies on individual metal sites
      Real(kind=8), allocatable    :: eso(:,:), eso_au(:,:)
      Complex(kind=8), allocatable :: dipso(:,:,:,:)
      Complex(kind=8), allocatable ::  s_so(:,:,:,:)
      Character(Len=1)              :: itype(nneq)
      Character(Len=180)            :: namefile_aniso(nneq)
      Logical                       :: ifHDF
      Logical, intent(in)           :: old_aniso_format
      Logical                       :: DoPlot
c  definition of the exchange:
!     total number of exchange states
      Integer                       :: exch
!     number of metal pairs (number of interactions)
      Integer                       :: nPair
!     exchange basis, nmax = MAXVAL(nexch(:))
      Integer                       :: nmax
      Integer, intent(in)           :: MxRank1, MxRank2
      Integer, allocatable          :: nexch(:)
!     index of the metal site in a given interacting pair
      Integer, allocatable          :: i_pair(:,:)
!     index of rank ITOs for JITO exchange definition
      Integer, allocatable          :: imaxrank(:,:)
      Logical                       :: AnisoLines1
      Logical                       :: AnisoLines3
      Logical                       :: AnisoLines9
      Logical                       :: Dipol
      Logical                       :: DM_exchange
      Logical                       :: decompose_exchange
      Logical                       :: JITO_exchange
!     Lines exchange    ( 1 parameter / interacting pair)
      Real(kind=8), allocatable    :: Jex(:)
!     Anisotropic Lines ( 3 parameter / interacting pair)
      Real(kind=8), allocatable    :: JAex(:,:)
!     Anisotropic Lines full ( 9 parameters / interacting pair)
      Real(kind=8), allocatable    :: JAex9(:,:,:)
!     Anisotropic Lines ( 3 parameter / interacting pair)
      Real(kind=8), allocatable    :: JDMex(:,:)
      Real(kind=8), allocatable    :: JITOexR(:,:,:,:,:)
      Real(kind=8), allocatable    :: JITOexI(:,:,:,:,:)
!     exchange spectrum
      Real(kind=8), allocatable    :: W(:)
!     exchange eigenstates
      Complex(kind=8), allocatable :: Z(:,:)
      Complex(kind=8), allocatable :: dipexch(:,:,:)
! exchange magnetic moment
      Complex(kind=8), allocatable ::  s_exch(:,:,:)
! exchange spin moment
      ! options used in connection with KE
      Integer                       :: lant, multLn, KEOPT
      Logical                       :: KE
      Real(kind=8)                 :: tpar, upar
      ! options used in connection with Dipol-Dipol interaction
      Real(kind=8), allocatable    :: MagnCoords(:,:)
!                                      MagnCoords(nneq,3)

      Integer                       :: nTempMagn
c  definition of g and D tensors
      Logical                       :: compute_g_tensors
      Integer                       :: nMult
!     multiplicity of each multiplet
      Integer, allocatable          :: nDim(:)
!     gtensor of each multiplet
      Real(kind=8), allocatable    :: gtens(:,:)
!     main axes of each multiplet
      Real(kind=8), allocatable    :: maxes(:,:,:)
c  definition of data for susceptibility
      Integer                       :: nT
      Logical                       :: compute_susceptibility
      Logical                       :: tinput
      Real(kind=8)                 :: tmin, tmax, dltT0

      Real(kind=8), allocatable    ::     T(:)
      Real(kind=8), allocatable    :: XTexp(:)
      Real(kind=8), allocatable    :: XT_no_field(:)
      Real(kind=8), allocatable    :: chit_exp(:)
      Real(kind=8), allocatable    :: Texp(:)

      Real(kind=8), allocatable    :: XLM(:,:,:,:)
      Real(kind=8), allocatable    :: ZLM(:,:)
      Real(kind=8), allocatable    :: XRM(:,:,:,:)
      Real(kind=8), allocatable    :: ZRM(:,:)
      ! options related to XT_MoverH
      Real(kind=8)                 :: Xfield

c  definition of data for magnetization:
      Integer                       :: nH, nM
      Integer                       :: iopt
      Real(kind=8), allocatable    :: TempMagn(:)
      Real(kind=8), allocatable    :: Hexp(:), Mexp(:,:)
      Real(kind=8)                 :: thrs, em
      Real(kind=8)                 :: hmin, hmax, dltH0
      Logical                       :: hinput
      Logical                       :: compute_magnetization
      Logical                       :: compute_Mdir_vector
      Logical                       :: zeeman_energy
      Logical                       :: m_paranoid
      Logical                       :: m_accurate
      Logical                       :: smagn
      ! options used to set up nM and EM
      Integer                       :: encut_definition
      Integer                       :: nK, mG ! encut_definition=1;
      Integer                       :: ncut   ! encut_definition=2;
      Real(kind=8)                 :: encut_rate ! encut_definition=3;

c  magnetization torque
      Logical                       :: compute_torque
      Integer                       :: AngPoints, nP
c  Zeeman energy and M vector
      Integer                       :: nDir, nDirZee, nDirTot
      Integer, allocatable          :: LuZee(:)
      Real(kind=8), allocatable    :: dirX(:), dirY(:), dirZ(:)
      Real(kind=8), allocatable    :: dir_weight(:,:)
c  definition of mean field parameter
      Real(kind=8)                 :: zJ
c  definintion of the crystal axes:
      Logical                       :: Do_structure_abc
      Real(kind=8)                 :: cryst(6)
! a, b, c, alpha, beta, gamma
      Real(kind=8)                 :: coord(3)
! Cartesian coordinates of the main metal site, or center
c  definitions for blocking barrier
      Integer                       :: nBlock
      Logical                       :: compute_barrier
c  options for automatic fitting of parameters:
      Logical                       :: fitCHI !-- not used so far
      Logical                       :: fitM !-- not used so far

      Integer                       :: iPrint
      Integer                       :: idim
      Integer                       :: imltpl
      Integer                       :: Ifunct
      Integer                       :: iReturn
      Integer                       :: i,i1,i2,j,l
      Integer                       :: l1(2),l2(2),l3(2),l4(2),l5(2)
      Integer                       :: imanIfold
      Integer                       :: ibuf
c      Integer                      :: nsta
c      Integer                      :: icase, nmagmult
      Logical                       :: check_title
      Character(Len=180)            :: Title
      Logical                       :: GRAD
      Logical                       :: dbg
      Character(Len=180)            :: fname
      Real(wp)                      :: conv_au_to_cm1
      Integer                       :: LuAniso
      Integer, external             :: IsFreeUnit

      dbg=.false.
c---------------------------------------------------------------------
      ! Constants:
      GRAD=.false.
      conv_au_to_cm1=2.194746313702E5_wp
c---------------------------------------------------------------------
      ! Allocate memory for all arrays:
c---------------------------------------------------------------------
      If(dbg) Write(6,*) '      exch = ',exch
      If(dbg) Write(6,*) '     nPair = ',nPair
      If(dbg) Write(6,*) '     nMult = ',nMult
      If(dbg) Write(6,*) '      nneq = ',nneq
      If(dbg) Write(6,*) '      neqv = ',neqv
      If(dbg) Write(6,*) '      nLoc = ',nLoc
      If(dbg) Write(6,*) '   nDirZee = ',nDirZee
      If(dbg) Write(6,*) '      nDir = ',nDir
      If(dbg) Write(6,*) '        nH = ',nH
      If(dbg) Write(6,*) '        nT = ',nT
      If(dbg) Write(6,*) ' nTempMagn = ',nTempMagn
      If(dbg) Write(6,*) 'old_format = ',old_aniso_format
      If(dbg) Write(6,*) 'old_format = ',old_aniso_format
      If(dbg) Write(6,*) '   MxRank1 = ',MxRank1
      If(dbg) Write(6,*) '   MxRank2 = ',MxRank2

      mem=0
      RtoB=8
      CtoB=16
      ItoB=8

      ! exchange energy spectrum
      Call mma_allocate(W,exch,'W')
      Call dcopy_(exch,[0.0_wp],0,W,1)
      mem=exch*RtoB
      ! exchange eigenvectors:
      Call mma_allocate(Z,exch,exch,'Z')
      Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,Z,1)
      mem=mem+exch*exch*CtoB
      ! magnetic moment
      Call mma_allocate(dipexch,3,exch,exch,'dipexch')
      Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,dipexch,1)
      mem=mem+3*exch*exch*CtoB
      ! spin moment
      Call mma_allocate( s_exch,3,exch,exch,'s_exch')
      Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0, s_exch,1)
      mem=mem+3*exch*exch*CtoB
      ! allocated memory counter
      If(dbg) Write(6,'(A,I16)') 'mem 1 =',mem

      ! index of metal site for each interacting pair:
      Call mma_allocate(i_pair,nPair,2,'i_pair')
      Call icopy(nPair*2,[0],0,i_pair,1)
      mem=mem+nPair*2*ItoB
      ! exchange Lines-1 parameter
      Call mma_allocate(Jex,nPair,'Jex')
      Call dcopy_(nPair,[0.0_wp],0,Jex,1)
      mem=mem+nPair*RtoB
      ! exchange Lines-3 parameter
      Call mma_allocate(JAex,nPair,3,'Jex')
      Call dcopy_(nPair*3,[0.0_wp],0,JAex,1)
      mem=mem+nPair*3*RtoB
      ! exchange Lines-9 parameter
      Call mma_allocate(JAex9,nPair,3,3,'Jex')
      Call dcopy_(nPair*3*3,[0.0_wp],0,JAex9,1)
      mem=mem+nPair*3*3*RtoB
      ! exchange Dzyaloshinsky-Morya parameter
      Call mma_allocate(JDMex,nPair,3,'Jex')
      Call dcopy_(nPair*3,[0.0_wp],0,JDMex,1)
      mem=mem+nPair*3*RtoB
      ! index of ITO ranks for for each interacting pair:
      Call mma_allocate(imaxrank,nPair,2,'imaxrank')
      Call icopy(nPair*2,[0],0,imaxrank,1)
      mem=mem+nPair*2*ItoB
      ! exchange JITO
      l1(1)=1;         l1(2)=nPair
      l2(1)=1;         l2(2)=MxRank1
      l3(1)=-MxRank1;  l3(2)=MxRank1
      l4(1)=1;         l4(2)=MxRank2
      l5(1)=-MxRank2;  l5(2)=MxRank2
      ibuf=nPair*MxRank1*MxRank2*(2*MxRank1+1)*(2*MxRank2+1)
      If(dbg) Write(6,'(A,I10)') 'nPair  =',nPair
      If(dbg) Write(6,'(A,I10)') 'MxRank1=',MxRank1
      If(dbg) Write(6,'(A,I10)') 'MxRank2=',MxRank2
      If(dbg) Write(6,'(A,I10)') 'ibuf   =',ibuf
      Call xFlush(6)
      Call mma_allocate(JITOexR,l1,l2,l3,l4,l5,'JITOexR')
      Call mma_allocate(JITOexI,l1,l2,l3,l4,l5,'JITOexI')
      Call dcopy_(ibuf,[0.0_wp],0,JITOexR,1)
      Call dcopy_(ibuf,[0.0_wp],0,JITOexI,1)
      mem=mem+2*ibuf*RtoB
      ! allocated memory counter
      If(dbg) Write(6,'(A,I16)') 'mem 2 =',mem

      ! index of metal site for each interacting pair:
      Call mma_allocate(nDim,nMult,'nDim')
      Call icopy(nMult,[0],0,nDim,1)
      mem=mem+nMult*ItoB
      ! g_tensor for each multiplet
      Call mma_allocate(gtens,nMult,3,'gtens')
      Call dcopy_(nMult*3,[0.0_wp],0,gtens,1)
      mem=mem+nMult*3*RtoB
      ! main axes of the g tensor for each multiplet
      Call mma_allocate(maxes,nMult,3,3,'maxes')
      Call dcopy_(nMult*3*3,[0.0_wp],0,maxes,1)
      mem=mem+nMult*3*3*RtoB
      ! allocated memory counter
      If(dbg) Write(6,'(A,I16)') 'mem 3 =',mem

      ! number of equivalent centers, per type
      Call mma_allocate(neq,nneq,'neq')
      Call icopy(nneq,[0],0,neq,1)
      mem=mem+nneq*ItoB
      ! local number of spin orbit states:
      Call mma_allocate(nss,nneq,'nss')
      Call icopy(nneq,[0],0,nss,1)
      mem=mem+nneq*ItoB
      ! local number of spin free states:
      Call mma_allocate(nsfs,nneq,'nsfs')
      Call icopy(nneq,[0],0,nsfs,1)
      mem=mem+nneq*ItoB
      ! local basis for exchange:
      Call mma_allocate(nexch,nneq,'nexch')
      Call icopy(nneq,[0],0,nexch,1)
      mem=mem+nneq*ItoB
      ! gtens_input(:,:)
      Call mma_allocate(gtens_input,3,nneq,'gtens_input')
      Call dcopy_(3*nneq,[0.0_wp],0,gtens_input,1)
      mem=mem+3*nneq*RtoB
      ! D_fact
      Call mma_allocate(D_fact,nneq,'D_fact')
      Call dcopy_(nneq,[0.0_wp],0,D_fact,1)
      mem=mem+nneq*RtoB
      ! EoverD_fact
      Call mma_allocate(EoverD_fact,nneq,'EoverD_fact')
      Call dcopy_(nneq,[0.0_wp],0,EoverD_fact,1)
      mem=mem+nneq*RtoB
      ! MagnCoords()
      Call mma_allocate(MagnCoords,nneq,3,'MagnCoords')
      Call dcopy_(nneq*3,[0.0_wp],0,MagnCoords,1)
      mem=mem+nneq*3*RtoB
      ! riso
      Call mma_allocate(riso,nneq,3,3,'riso')
      Call dcopy_(3*3*nneq,[0.0_wp],0,riso,1)
      mem=mem+9*nneq*RtoB


      ! R_LG
      Call mma_allocate(r_lg,nneq,neqv,3,3,'r_lg')
      Call dcopy_(nneq*neqv*3*3,[0.0_wp],0,r_lg,1)
      mem=mem+nneq*neqv*3*3*RtoB
      ! R_ROT
      Call mma_allocate(r_rot,nneq,neqv,3,3,'r_rot')
      Call dcopy_(nneq*neqv*3*3,[0.0_wp],0,r_rot,1)
      mem=mem+nneq*neqv*3*3*RtoB

      ! local spin orbit states
      Call mma_allocate(eso,nneq,nLoc,'eso')
      Call dcopy_( nneq*nLoc,[0.0_wp],0,eso,1)
      mem=mem+nneq*nLoc*RtoB
      Call mma_allocate(eso_au,nneq,nLoc,'eso_au')
      Call dcopy_( nneq*nLoc,[0.0_wp],0,eso_au,1)
      mem=mem+nneq*nLoc*RtoB
      ! local magnetic moment
      Call mma_allocate(dipso,nneq,3,nLoc,nLoc,'dipso')
      Call zcopy_(3*nneq*nLoc*nLoc,[(0.0_wp,0.0_wp)],0,dipso,1)
      mem=mem+3*nneq*nLoc*nLoc*CtoB
      ! local spin moment
      Call mma_allocate( s_so,nneq,3,nLoc,nLoc,'s_so')
      Call zcopy_(3*nneq*nLoc*nLoc,[(0.0_wp,0.0_wp)],0, s_so,1)
      mem=mem+3*nneq*nLoc*nLoc*CtoB

      ! allocated memory counter
      If(dbg) Write(6,'(A,I16)') 'mem 4 =',mem

      ! unit numbers of the files containing Zeeman states
      Call mma_allocate(LuZee,nDirZee,'LuZee')
      Call icopy(nDirZee,[0],0,LuZee,1)
      mem=mem+nDirZee*ItoB
!     directional vectors for the magnetic field, for computing Zeeman states
      Call mma_allocate(dir_weight,nDirZee,3,'dir_weight')
      Call dcopy_(3*nDirZee,[0.0_wp],0,dir_weight,1)
      mem=mem+3*nDirZee*ItoB
      ! allocated memory counter
      If(dbg) Write(6,'(A,I16)') 'mem 5 =',mem

      ! magnetization vectors
      Call mma_allocate(dirX,nDir,'dirX')
      Call mma_allocate(dirY,nDir,'dirY')
      Call mma_allocate(dirZ,nDir,'dirZ')
      mem=mem+3*nDir*RtoB
      Call dcopy_(nDir,[0.0_wp],0,dirX,1)
      Call dcopy_(nDir,[0.0_wp],0,dirY,1)
      Call dcopy_(nDir,[0.0_wp],0,dirZ,1)
      ! allocated memory counter
      If(dbg) Write(6,'(A,I16)') 'mem 6 =',mem

      ! experimental field points:
      Call mma_allocate(Hexp,nH,'Hexp')
      Call dcopy_(nH,[0.0_wp],0,Hexp,1)
      mem=mem+nH*RtoB
      ! experimental magnetisation:
      Call mma_allocate(Mexp,nH,nTempMagn,'Mexp')
      Call dcopy_(nH*nTempMagn,[0.0_wp],0,Mexp,1)
      mem=mem+nH*nTempMagn*RtoB
      ! temperature points for magnetization:
      Call mma_allocate(TempMagn,nTempMagn,'TempMagn')
      Call dcopy_(nTempMagn,[0.0_wp],0,TempMagn,1)
      mem=mem+nTempMagn*RtoB
      ! allocated memory counter
      If(dbg) Write(6,'(A,I16)') 'mem 7 =',mem

      ! XT for local centers, all states
      Call mma_allocate(XLM,nCenter,nTempMagn,3,3,'XLM')
      Call dcopy_(nCenter*nTempMagn*3*3,[0.0_wp],0,XLM,1)
      mem=mem+nCenter*nTempMagn*3*3*RtoB
      ! Statistical sum for local centers, all states
      Call mma_allocate(ZLM,nCenter,nTempMagn,'ZLM')
      Call dcopy_(nCenter*nTempMagn,[0.0_wp],0,ZLM,1)
      mem=mem+nCenter*nTempMagn*RtoB
      ! XT for local centers, exchange states
      Call mma_allocate(XRM,nCenter,nTempMagn,3,3,'XRM')
      Call dcopy_(nCenter*nTempMagn*3*3,[0.0_wp],0,XRM,1)
      mem=mem+nCenter*nTempMagn*3*3*RtoB
      ! Statistical sum for local centers, exchange states
      Call mma_allocate(ZRM,nCenter,nTempMagn,'ZRM')
      Call dcopy_(nCenter*nTempMagn,[0.0_wp],0,ZRM,1)
      mem=mem+nCenter*nTempMagn*RtoB
      ! allocated memory counter
      If(dbg) Write(6,'(A,I16)') 'mem 8 =',mem

      ! T expeirimental given by user in the input
      Call mma_allocate(Texp,nT,'Texp')
      Call dcopy_(nT,[0.0_wp],0,Texp,1)
      mem=mem+nT*RtoB
      ! XT expeirimental given by user in the input
      Call mma_allocate(chit_exp,nT,'chit_exp')
      Call dcopy_(nT,[0.0_wp],0,chit_exp,1)
      mem=mem+nT*RtoB

!     -- add nTempMagn points, so that all measurables are computed at once...
!     temperature points for which XT will be computed
      Call mma_allocate(T,(nTempMagn+nT),'Temperature')
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,T,1)
      mem=mem+(nT+nTempMagn)*RtoB
      ! XT experimental tmagn XTexp+Tmagn
      Call mma_allocate(XTexp,(nTempMagn+nT),'XTexp')
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,XTexp,1)
      mem=mem+(nT+nTempMagn)*RtoB
      ! XT in the absence of the magnetic field
      Call mma_allocate(XT_no_field,(nTempMagn+nT),'XT_no_field')
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,XT_no_field,1)
      mem=mem+(nT+nTempMagn)*RtoB
      ! allocated memory counter
      If(dbg) Write(6,'(A,I16)') 'mem 9 =',mem

      Write(6,'(A,I16,A)') 'The code allocated at least:',mem,
     &                     ' bytes of memory for this run.'
      Call xFlush(6)
c---------------------------------------------------------------------
      ! set default values of the main variables and arrays:
      If(dbg) Write(6,*) 'Enter set_defaults'
        Call set_defaults( nneq, nTempMagn, nDir, nDirZee, nMult,
     &                     neq, nexch, nK, mG, ncut, nP,
     &                     AngPoints, nBlock, encut_definition,
     &                     iopt, iPrint,
     &                     dltT0, dltH0, zJ, tmin, tmax, hmin, hmax,
     &                     XField, thrs, TempMagn,
     &                     cryst, coord, encut_rate, gtens_input,
     &                     D_fact, EoverD_fact, riso,
     &                     decompose_exchange, AnisoLines1,
     &                     AnisoLines3, AnisoLines9, DM_exchange,
     &                     Dipol, KE, JITO_exchange, fitCHI, fitM,
     &                     Do_structure_abc, doplot,
     &                     compute_g_tensors, tinput,
     &                     compute_susceptibility,
     &                     compute_torque, compute_barrier,
     &                     compute_magnetization, hinput,
     &                     compute_Mdir_vector, zeeman_energy,
     &                     m_paranoid, m_accurate, smagn,
     &                     itype )
      If(dbg) Write(6,*) 'Exit set_defaults'
      If(dbg.and.(neqv.gt.1)) Write(6,*) 'Enter fetch_neq'
      If(neqv.gt.1) Call fetch_neq(nneq,neq(1:nneq),nexch(1:nneq))
      If(dbg.and.(neqv.gt.1)) Write(6,*) 'Exit fetch_neq'

c---------------------------------------------------------------------
c      ! read the Standard Input:
      If(dbg) Write(6,*) 'Enter Readin_poly'
      Call Readin_poly(nneq, neq, neqv, exch, nCenter,
     &                 nT, nH, nTempMagn, nDir, nDirZee,
     &                 nMult, nPair, nexch, nDim, i_pair,
     &                 lant, multLn, iPrint, keopt,
     &                 encut_definition, nK, mG, iopt, nP,
     &                 AngPoints, ncut, LUZee, MxRank1, MxRank2,
     &                 imaxrank,
     &                 TempMagn, R_LG, R_ROT, Jex, JAex, JAex9, JDMex,
     &                 JITOexR, JITOexI,
     &                 tpar, upar, cryst, coord,
     &                 Xfield, gtens_input, D_fact, EoverD_fact, riso,
     &                 MagnCoords, thrs, tmin, tmax,
     &                 hmin, hmax, Texp(1:nT), chit_exp(1:nT),
     &                 Hexp, Mexp, encut_rate,
     &                 zJ, dirX, dirY, dirZ,
     &                 dir_weight,
     &                 Title, itype,
     &                 ifHDF,
     &                 compute_g_tensors, compute_magnetization,
     &                 TINPUT, HINPUT, Do_structure_abc, doplot,
     &                 compute_Mdir_vector, zeeman_energy,
     &                 m_paranoid, m_accurate, smagn,
     &                 compute_susceptibility, decompose_exchange,
     &                 KE, fitCHI, fitM, compute_torque,
     &                 compute_barrier, Dipol, check_title,
     &                 AnisoLines1, AnisoLines3, AnisoLines9,
     &                 DM_exchange, JITO_exchange )
      If(dbg) Write(6,*) 'Exit Readin_poly'
      Call xFlush(6)
c---------------------------------------------------------------------
c     ! fetch the data from aniso_x.input files: (formatted ANISOINPUT)
      Do i=1,nneq
         If(dbg) Write(6,'(A,A)') 'itype(i)=',itype(i)
         If(dbg) Call xFlush(6)
         If(dbg) Write(6,*) '   nss(i)=', nss(i)
         If(dbg) Call xFlush(6)
         If(dbg) Write(6,*) '  nsfs(i)=', nsfs(i)
         If(dbg) Call xFlush(6)
         If(dbg) Write(6,*) ' nexch(i)=', nexch(i)
         If(dbg) Call xFlush(6)
         If(dbg) Write(6,*) '     nLoc=', nLoc
         If(dbg) Call xFlush(6)
         If(dbg) Write(6,*) ' gtens_input(1:3,i)=',
     &                       (gtens_input(j,i),j=1,3)
         If(dbg) Call xFlush(6)
         If(dbg) Write(6,*) 'D_fact(i)=',D_fact(i)
         If(dbg) Call xFlush(6)
         If(dbg) Write(6,*) 'eso(i,1:nexch(i))=',
     &                       (eso(i,j),j=1,nexch(i))
         If(dbg) Write(6,*) 'old_aniso_format=',old_aniso_format
         If(dbg) Call xFlush(6)

         If ((itype(i).eq.'B').OR.(itype(i).eq.'C')) Then

            If(dbg) Write(6,*) 'Enter generate_isotrop_site'
            If(dbg) Call xFlush(6)
            Call generate_isotrop_site( nss(i), nsfs(i), nexch(i),
     &                                  nLoc, gtens_input(1:3,i),
     &                                  riso(i,1:3,1:3), D_fact(i),
     &                                  EoverD_fact(i),
     &                                  eso(i,1:nexch(i)),
     &                             dipso(i,1:3,1:nexch(i),1:nexch(i)),
     &                              s_so(i,1:3,1:nexch(i),1:nexch(i)) )
            If(dbg) Write(6,*) 'Exit generate_isotrop_site'
            If(dbg) Call xFlush(6)

         Else If (itype(i).eq.'A') Then

            If(ifHDF) Then
               ! set their names:
               If(i<10) Then
                  Write(namefile_aniso(i),'(4A)') 'aniso_hdf_',
     &                      CHAR(48+mod( int( i     ),10)),'.input'
                  If(dbg) Write(6,'(A,i2,A,A)') 'namefile_aniso(',i,
     &              ')=', namefile_aniso(i)
               Else If(i>=10 .and. i<=99) Then
                  Write(namefile_aniso(i),'(4A)') 'aniso_hdf_',
     &                      CHAR(48+mod( int((i)/10 ),10)),
     &                      CHAR(48+mod( int( i     ),10)),'.input'
               End If
               If(dbg) Write(6,*) 'PA:  namefile_aniso(i)=',
     &                             trim(namefile_aniso(i))

#ifdef _HDF5_
               If(dbg) Write(6,*) 'Enter read_hdf5_poly'
               Call read_hdf5_init(namefile_aniso(i),nsfs(i),nss(i))
               If(dbg) Write(6,*) 'i=', i,'nsfs(i),nss(i)=',
     &                                     nsfs(i),nss(i)
               Call read_hdf5_poly( namefile_aniso(i),
     &                              nss(i),
     &                              nsfs(i),
     &                              eso(i,1:nss(i)),
     &                             dipso(i,1:3,1:nss(i),1:nss(i)),
     &                              s_so(i,1:3,1:nss(i),1:nss(i)),
     &                              iReturn )
               If(dbg) Write(6,*) 'Exit read_hdf5_poly'
               If(dbg) Write(6,*) 'ESO(i)=',(ESO(i,j),j=1,nss(i))
#else
               Call WarningMessage(2,'File '//trim(namefile_aniso(i))//
     &                              ' cannot be opened. Molcas was'//
     &                              ' compiled without HDF5 option.')
               Call Quit_OnUserError()
#endif
            Else
               ! set their names:
               If(i<10) Then
                  Write(namefile_aniso(i),'(4A)') 'aniso_',
     &                      CHAR(48+mod( int( i     ),10)),'.input'
               Else If(i>=10 .and. i<=99) Then
                  Write(namefile_aniso(i),'(4A)') 'aniso_',
     &                      CHAR(48+mod( int((i)/10 ),10)),
     &                      CHAR(48+mod( int( i     ),10)),'.input'
               End If

               If (old_aniso_format) Then
                  ! get the information from OLD formatted
                  ! aniso.input file:
                  If(dbg) Write(6,*) 'Enter read_formatted_aniso_poly'
                  !print *, 'nss(i) =', nss(i)
                  !print *, 'nsfs(i)=', nsfs(i)
                  !print *, 'nLoc   =', nLoc
                  Call xFlush(6)

                  Call read_formatted_aniso_poly(
     &                                 namefile_aniso(i),
     &                                 nss(i),
     &                                 nsfs(i),
     &                                 nLoc,
     &                                 eso(i,1:nLoc),
     &                                dipso(i,1:3,1:nLoc,1:nLoc),
     &                                 s_so(i,1:3,1:nLoc,1:nLoc),
     &                                 iReturn )
                  If(dbg) Write(6,*) 'Exit read_formatted_aniso_poly'

               Else ! old_aniso_format is false, i.e. the default

                  ! get the information from NEW formatted
                  ! aniso.input file:
                  If(dbg) Write(6,*)
     &                'read formatted_aniso_poly_NEW'
                   LuAniso=IsFreeUnit(81)
                   Call molcas_open(LuAniso,namefile_aniso(i))
                   ! nss(i) is yet undefined up till this place
                   Call read_nss( LuAniso, nss(i), dbg )
                   Call read_nstate( LuAniso, nsfs(i), dbg )
                   eso_au(i,1:nss(i))=0.0_wp
                   Call read_eso( LuAniso, nss(i),
     &                            eso_au(i,1:nss(i)),dbg)
                   If(dbg) Write(6,*) 'poly_aniso: eso_au=',
     &                                (eso_au(i,j),j=1,nss(i))
                   Call read_magnetic_moment ( LuAniso, nss(i),
     &                     dipso(i,1:3,1:nss(i),1:nss(i)), dbg )
                   IF (dbg) WRITE (6,*) 'Call read_spin_moment'
                   FLUSH(6)
                   Call read_spin_moment ( LuAniso, nss(i),
     &                      s_so(i,1:3,1:nss(i),1:nss(i)), dbg )
                   ! compute the relative spin-orbit energies in cm-1
                   do j=1,nss(i)
                     eso(i,j)=(eso_au(i,j)-eso_au(i,1))*conv_au_to_cm1
                   end do
                   Close(LuAniso)

               End If
            End if ! ifHDF
         Else
            Call quit(_RC_INTERNAL_ERROR_)
         End If
      End Do


      IF(DBG) THEN
         Do i=1, nneq
            Write(6,*) 'MAGNETIC MOMENT  ON  SITE 1'
            Call prMom('site i',dipso(i,1:3,1:nss(i),1:nss(i)),nss(i))
            Write(6,*) 'SPIN MOMENT  ON  SITE 1'
            Call prMom('site i', s_so(i,1:3,1:nss(i),1:nss(i)),nss(i))
         End Do
      END IF




      If(dbg) Write(6,*) 'Enter input_process'
      Call input_process( nneq, neq, neqv, nmax, nCenter, nexch,
     &                    nDir, nDirZee, nDirTot, nH, nT, exch,
     &                    nBlock, nTempMagn, iopt, nMult, nDim,
     &                    nPair, i_pair, nP, AngPoints, lant,
     &                    multLn, KEOPT, encut_definition, nK,
     &                    mG, ncut, nsfs, nss, nLoc,
     &                    MxRank1, MxRank2, imaxrank, iPrint,

     &                    R_LG, gtens_input, dirX, dirY, dirZ,
     &                    dir_weight, zJ, cryst, coord, hmin,
     &                    hmax, TempMagn, thrs, Hexp, Mexp,
     &                    tmin, tmax, chit_exp, Texp, Xfield,
     &                    Jex, JAex, JAex9, JDMex, tpar, upar,
     &                    MagnCoords, encut_rate, eso,
     &                    JITOexR, JITOexI,

     &                    Title, itype, namefile_aniso,

     &                    Do_structure_abc, old_aniso_format,
     &                    compute_barrier, fitCHI, fitM, hinput,
     &                    tinput, compute_magnetization,
     &                    compute_Mdir_vector, zeeman_energy,
     &                    m_paranoid, m_accurate, smagn,
     &                    compute_g_tensors,compute_torque,
     &                    compute_susceptibility, AnisoLines1,
     &                    AnisoLines3, AnisoLines9, Dipol,
     &                    check_title, KE, DM_exchange, JITO_exchange )
      If(dbg) Write(6,*) 'Exit input_process'

c at this moment all input values are set. proceed to compute various
c properties:
c---------------------------------------------------------------------
c in case J coupling parameters are not known, proceed to get them from
c a minimization scheme between caclulated and measured magnetic susceptibility
c
c the function below optimizes the N+1 parameters:
c N - exchange couplings J, and one parameter for total shIft of all experimental points;
c      If (fitCHI) Then
c      Call fitCHI()
c      End If
cc at this point all J parameters are known; we can proceed to compute
c the energy spectrum and the resulting properties
c---------------------------------------------------------------------
c      Lines=.true.
c      If(AnisoLines.eqv..true.) Then
c      Lines=.false.
c      End If
c      Dipol=dipole_included
c      KE=exch_long

      If(dbg) Write(6,*) 'Dipol         = ', Dipol
      If(dbg) Write(6,*) 'AnisoLines1   = ', AnisoLines1
      If(dbg) Write(6,*) 'AnisoLines3   = ', AnisoLines3
      If(dbg) Write(6,*) 'AnisoLines9   = ', AnisoLines9
      If(dbg) Write(6,*) 'DM_exchange   = ', DM_exchange
      If(dbg) Write(6,*) 'JITO_exchange = ', JITO_exchange
      If(dbg) Write(6,*) 'nmax          = ', nmax

      Call exchctl( exch, nneq, neqv, neq, nexch,
     &              nmax, nCenter, npair, i_pair,
     &              MxRank1, MxRank2, imaxrank,
     &              Jex, JAex, JAex9, JDMex, JITOexR, JITOexI,
     &              eso(1:nneq,1:nmax),
     &              s_so(1:nneq,1:3,1:nmax,1:nmax),
     &              dipso(1:nneq,1:3,1:nmax,1:nmax),
     &             MagnCoords, R_ROT, R_LG, riso, tpar, upar, lant,
     &              itype, Dipol, AnisoLines1, AnisoLines3,
     &              AnisoLines9, KE, KEOPT, DM_exchange, JITO_exchange,
     &               W, Z, S_EXCH, DIPEXCH, iPrint, mem )
cc---------------------------------------------------------------------
!     generate an 'aniso -like file' for testign exchange proj in SA
      fname='ANISOINPUT_POLY'
      Call write_formatted_aniso_poly( fname, exch, W,
     &                                  dipexch, s_exch)
cc---------------------------------------------------------------------
c compute the magnetic moments on individual metal sites, for
c the lowest NSTA exchange states;
C     NMAX = maximal number of local states which participate into the exchange coupling
      Call MOMLOC2( exch, nmax, nneq, neq, neqv,
     &              r_rot, nCenter, nExch, W, Z,
     &              dipexch, s_exch,
     &              dipso(1:nneq,1:3,1:nmax,1:nmax),
     &               s_so(1:nneq,1:3,1:nmax,1:nmax)  )

c---------------------------------------------------------------------
      If(compute_g_tensors) Then
         If(dbg) Write(6,'(A,90I3)') 'nmult= ',nmult
         If(dbg) Write(6,'(A,90I3)') 'ndim() = ',ndim(1:nmult)

         Ifunct=0
         Do imltpl=1,nmult
            iReturn=0
            i1=1           +Ifunct
            i2=ndim(imltpl)+Ifunct

            If (ndim(imltpl)<=1) Go To 10
            If (i2>exch) Go To 20

            If(dbg) Write(6,'(A,90I3)') 'ndim(imltpl)=',ndim(imltpl)
            If(dbg) Call prmom('PA: s_exch:',
     &               s_exch(1:3,i1:i2,i1:i2),ndim(imltpl))
            If(dbg) Call prmom('PA: dip_exch:',
     &              dipexch(1:3,i1:i2,i1:i2),ndim(imltpl))

            Call g_high( w(i1:i2), GRAD,
     &                    s_exch(1:3, i1:i2, i1:i2),
     &                   dipexch(1:3, i1:i2, i1:i2),
     &                   imltpl, ndim(imltpl),
     &                   Do_structure_abc,
     &                   cryst, coord,
     &                   gtens(imltpl,1:3),
     &                   maxes(imltpl,1:3,1:3),
     &                   iprint )

10          Continue
            Ifunct=Ifunct+ndim(imltpl)
            If( iReturn.ne.0) stop
         End Do ! imltpl
20       Continue
      End If

!----------------------------------------------------------------------|
      !   >> AB INITIO BLOCKING BARRIER FOR SMMs <<
      If ( compute_barrier ) Then
        If ( nBlock.ne.0 ) Then
          imanifold=1

          Write(6,'(A)') 'UBAR:: matrix elements of the (input) '//
     &                  'magnetic moment '
          Write(6,'(A)') '                |'//
     &                   '         - projection - X -        |'//
     &                   '         - projection - Y -        |'//
     &                   '         - projection - Z -        |'
          Write(6,'(A)') '----------------|'//
     &                   '----- Real ------|---- Imaginary --|'//
     &                   '----- Real ------|---- Imaginary --|'//
     &                   '----- Real ------|---- Imaginary --|'
          Do i=1,nBlock
            Do j=1,i
            Write(6,'(A,i2,A,i2,A,6ES18.10)') '< ',i,'|M_xyz|',j,' > ',
     &                                        (dipexch(l,i,j),l=1,3)
            End Do
          End Do

          Call  BARRIER( nBlock, dipexch(1:3,1:nBlock,1:nBlock),
     &                   W(1:nBlock), imanIfold, nMult, nDim(1:nMult),
     &                   DoPlot, iprint )

        Else
           Write(6,'(A)') 'nBlock parameter is not defined. '
           Write(6,'(A)') 'Did you specify the MLTP keyword in the '//
     &                    'input?'
           Write(6,'(A)') 'If the problem persists,please, '//
     &                    'submit a bug report.'
        End If
      End If



!---------------------------------------------------------------------
!             MAGNETIC SUSCEPTIBILITY
!---------------------------------------------------------------------
       If (compute_susceptibility .AND. (nT>0) ) Then

         ! set nT, T(i) and XTexp(i) arrays:
          Call set_T( nT, nTempMagn, TINPUT, TempMagn, Tmin, Tmax,
     &                chit_exp, Texp, T, XTexp )

          ! XT at H=0
          Call susceptibility_pa( exch, nLoc, nCenter, nneq,
     &                         neqv, neq, nss, nexch, nTempMagn,
     &                         nT, Tmin, Tmax, XTexp,
     &                         eso, dipso, s_so, W, dipexch,
     &                         s_exch, T, R_LG, zJ, tinput,
     &                         XLM, ZLM, XRM, ZRM, iopt, XT_no_field,
     &                         DoPlot, mem )

         If( Xfield.ne.0.0_wp ) Then
          ! XT at H>0:

           Call set_nm( exch, ncut, encut_definition, nk, mg,
     &                  nTempMagn, hmax, w, encut_rate, TempMagn,
     &                  nM, EM, dbg )
          Do i=1,nT+nTempMagn
             Write(6,*) i,  T(i)
          End Do
          If(dbg) Write(6,*) 'nm    =',nm
          If(dbg) Write(6,*) 'Tmin  =',Tmin
          If(dbg) Write(6,*) 'Tmax  =',Tmax
          If(dbg) Write(6,*) 'THRS  =',THRS
          If(dbg) Write(6,*) 'smagn =',smagn
          If(dbg) Write(6,*) 'm_par =',m_paranoid
          If(dbg) Write(6,*) 'm_acc =',m_accurate
          If(dbg) Write(6,*) 'tinpu =',tinput

          ! nm = exch
           Call XT_dMoverdH( exch, nLoc, nCenter, nneq, neqv, neq,
     &                       nss, nexch, nTempMagn, nT, exch, iopt, mem,
     &                       Tmin, Tmax, XTexp, eso, w, T, R_ROT,
     &                       zJ, Xfield, EM, THRS, XT_no_field,
     &                       dipso, s_so, dipexch, s_exch,
     &                       tinput, smagn, m_paranoid, m_accurate,
     &                       doplot )
         End If
      Else
         Write(6,'(A)') 'Computation of the magnetic susceptibility'//
     &                  '... skipped by the user'
       End If
!---------------------------------------------------------------------
!             MAGNETIC TORQUE
!---------------------------------------------------------------------

       If (compute_torque) Then
!        set the NM- number of states to be exactly diagonalized in Zeeman Interaction
         Call set_nm( exch, ncut, encut_definition, nk, mg,
     &                nTempMagn, hmax, w, encut_rate, TempMagn,
     &                nM, EM, dbg )

         ! nm = exch
         Call torque_pa( nneq, nCenter, neq, neqv, nLoc, exch,
     &                nTempMagn, nH, exch, AngPoints, nexch,
     &                iopt, nss, mem,
     &                smagn, m_paranoid, m_accurate,
     &                TempMagn, w, hmin, hmax, dltH0, EM, zJ, THRS,
     &                hexp,
     &                dipexch, s_exch, dipso, s_so, eso,
     &                hinput, r_rot, XLM, ZLM, XRM, ZRM )

      Else
         Write(6,'(A)') 'Computation of the magnetization torque ... '//
     &                  'skipped by the user'
      End If !compute_torque
!---------------------------------------------------------------------
!             MOLAR MAGNETIZATION
!---------------------------------------------------------------------
      If(compute_magnetization .AND. (nH>0) ) Then
!        set the NM- number of states to be exactly diagonalized in Zeeman Interaction
         Call set_nm( exch, ncut, encut_definition, nk, mg,
     &                nTempMagn, hmax, w, encut_rate, TempMagn,
     &                nM, EM, dbg )

         Call magnetization_pa( exch, nLoc, nM, nH, nneq, neq, neqv,
     &                       nCenter, nTempMagn, nDir, nDirZee,
     &                       nDirTot, nss, nexch, iopt, LUZee,
     &                       TempMagn, hexp, mexp, hmin, hmax, em,
     &                       zJ, thrs, dirX, dirY, dirZ, dir_weight,
     &                       w, dipexch, s_exch, dipso, s_so, eso,
     &                       hinput, r_rot, XLM, ZLM, XRM, ZRM,
     &                       zeeman_energy, compute_Mdir_vector,
     &                       m_paranoid, m_accurate, smagn, mem,
     &                       doplot )
      Else
         Write(6,'(A)') 'Computation of the molar magnetization ... '//
     &                  'skipped by the user'
      End If !compute_magnetization

!---------------------------------------------------------------------
! Deallocate memory for big arrays:
!---------------------------------------------------------------------
      Call mma_deallocate(W)
      Call mma_deallocate(Z)
      Call mma_deallocate(dipexch)
      Call mma_deallocate(s_exch)
      Call mma_deallocate(i_pair)
      Call mma_deallocate(Jex)
      Call mma_deallocate(JAex)
      Call mma_deallocate(JAex9)
      Call mma_deallocate(JDMex)
      Call mma_deallocate(imaxrank)
      Call mma_deallocate(JITOexR)
      Call mma_deallocate(JITOexI)

      Call mma_deallocate(nDim)
      Call mma_deallocate(gtens)
      Call mma_deallocate(maxes)
      Call mma_deallocate(neq)
      Call mma_deallocate(nss)
      Call mma_deallocate(nsfs)
      Call mma_deallocate(nexch)
      Call mma_deallocate(gtens_input)
      Call mma_deallocate(D_fact)
      Call mma_deallocate(EoverD_fact)
      Call mma_deallocate(MagnCoords)
      Call mma_deallocate(riso)
      Call mma_deallocate(r_lg)
      Call mma_deallocate(r_rot)
      Call mma_deallocate(eso)
      Call mma_deallocate(eso_au)
      Call mma_deallocate(dipso)
      Call mma_deallocate(s_so)

      Call mma_deallocate(LuZee)
      Call mma_deallocate(dir_weight)

      Call mma_deallocate(dirX)
      Call mma_deallocate(dirY)
      Call mma_deallocate(dirZ)

      ! experimental field points:
      Call mma_deallocate(Hexp)
      Call mma_deallocate(Mexp)
      Call mma_deallocate(TempMagn)

      Call mma_deallocate(XLM)
      Call mma_deallocate(ZLM)
      Call mma_deallocate(XRM)
      Call mma_deallocate(ZRM)
      Call mma_deallocate(Texp)
      Call mma_deallocate(chit_exp)
      Call mma_deallocate(T)
      Call mma_deallocate(XTexp)
      Call mma_deallocate(XT_no_field)
!---------------------------------------------------------------------
      Write(6,*)
      Write(6,'(10A)') (('-@-#-$-%-&-*-'),idim=1,10)
      Write(6,*)
      Write(6,'(10X,A)') 'HAPPY   LANDING !!!   POLY_ANISO ENDED  OK !'
      Write(6,*)
      Write(6,'(10A)') (('-*-&-%-$-#-@-'),idim=1,10)
      Call xFlush(6)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DXTYP_GAS(   NDXTP,     ITP,     JTP,     KTP,     LTP,
     &                        NOBTP,      IL,      IR)
*
* Obtain types of I,J,K,l so
* <L!a+I a+K a L a J!R> is nonvanishing
* only combinations with type(I) .ge. type(K) and type(J).ge.type(L)
* are included
*
      INTEGER IL(NOBTP),IR(NOBTP)
      INTEGER ITP(*),JTP(*),KTP(*),LTP(*)
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' DXTYP_GAS in action '
        WRITE(6,*) ' ===================='
        WRITE(6,*) ' Occupation of left string '
        CALL IWRTMA(IL,1,NOBTP,1,NOBTP)
        WRITE(6,*) ' Occupation of right string '
        CALL IWRTMA(IR,1,NOBTP,1,NOBTP)
      END IF
*
*. Number of differing occupations
      NANNI = 0
      NCREA = 0
      NDIFT = 0
*
      ICREA1 = 0
      ICREA2 = 0
      IANNI1 = 0
      IANNI2 = 0
      DO IOBTP = 1, NOBTP
        NDIFT = NDIFT + ABS(IL(IOBTP)-IR(IOBTP))
        NDIF = IL(IOBTP)-IR(IOBTP)
        IF(NDIF.EQ.2) THEN
*. two electrons of type IOBTP must be created
          ICREA1 = IOBTP
          ICREA2 = IOBTP
          NCREA = NCREA + 2
        ELSE IF (NDIF .EQ. -2 ) THEN
*. Two electrons of type IOBTP must be annihilated
          IANNI1 = IOBTP
          IANNI2 = IOBTP
          NANNI = NANNI + 2
        ELSE IF (NDIF.EQ.1) THEN
*. one electron of type IOBTP must be created
          IF(NCREA.EQ.0) THEN
            ICREA1 = IOBTP
          ELSE
            ICREA2 = IOBTP
          END IF
          NCREA = NCREA + 1
        ELSE IF (NDIF.EQ.-1) THEN
* One electron of type IOBTP must be annihilated
          IF(NANNI.EQ.0) THEN
            IANNI1 = IOBTP
          ELSE
            IANNI2 = IOBTP
          END IF
          NANNI = NANNI + 1
        END IF
      END DO
*
      IF(NTEST.GE.1000) THEN
        WRITE(6,*)  ' NCREA, NANNI ', NCREA, NANNI
        WRITE(6,*)  ' ICREA1, IANNI1 ', ICREA1,IANNI1
        WRITE(6,*)  ' ICREA2, IANNI2 ', ICREA2,IANNI2
      END IF
*
      NDXTP = 0
      IF(NDIFT.GT.4) THEN
        NDXTP = 0
      ELSE
      IF(NCREA.EQ.0.AND.NANNI.EQ.0) THEN
*. strings identical, include diagonal excitions  itp = jtp, ktp=ltp
        DO IJTP = 1, NOBTP
          IF(IR(IJTP).GE.1) THEN
            DO KLTP = 1, IJTP
              IF((IJTP.NE.KLTP.AND.IR(KLTP).GE.1).OR.
     &           (IJTP.EQ.KLTP.AND.IR(KLTP).GE.2)) THEN
                 NDXTP = NDXTP + 1
                 ITP(NDXTP) = IJTP
                 JTP(NDXTP) = IJTP
                 KTP(NDXTP) = KLTP
                 LTP(NDXTP) = KLTP
              END IF
            END DO
          END IF
        END DO
*. Strings differ by single excitation
      ELSE IF( NCREA.EQ.1.AND.NANNI.EQ.1) THEN
*. diagonal excitation plus creation in ICREA1 and annihilation in IANNI1
        DO IDIA = 1, NOBTP
          IF((IDIA.NE.IANNI1.AND.IR(IDIA).GE.1).OR.
     &       (IDIA.EQ.IANNI1.AND.IR(IDIA).GE.2)) THEN
             NDXTP = NDXTP + 1
             ITP(NDXTP) = MAX(ICREA1,IDIA)
             KTP(NDXTP) = MIN(ICREA1,IDIA)
             JTP(NDXTP) = MAX(IANNI1,IDIA)
             LTP(NDXTP) = MIN(IANNI1,IDIA)
          END IF
        END DO
      ELSE IF(NCREA.EQ.2.AND.NANNI.EQ.2) THEN
*. Strings differ by double excitation
        NDXTP = 1
        ITP(1) = ICREA2
        KTP(1) = ICREA1
        JTP(1) = IANNI2
        LTP(1) = IANNI1
      END IF
      END IF
*
      IF(NTEST.NE.0) THEN
        WRITE(6,'(A,I4)')
     &  ' Number of connecting double excitations ', NDXTP
        IF(NDXTP.NE.0) THEN
          WRITE(6,*) '  ITYP KTYP LTYP JTYP '
          WRITE(6,*) '  ===================='
          DO  IDX = 1,NDXTP
            WRITE(6,'(1H ,4I5)')ITP(IDX),KTP(IDX),LTP(IDX),JTP(IDX)
          END DO
        END IF
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine CalcbX(bX,LOK,R,H)

use Index_Functions, only: nTri_Elem
use MCLR_Data, only: IRLXROOT
use input_mclr, only: nRoots
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: bX(nTri_Elem(nRoots-1))
real(kind=wp), intent(in) :: LOK(nRoots,nRoots), R(nRoots,nRoots), H(nRoots,nRoots)
integer(kind=iwp) :: I, IKL, K, L, M, N
real(kind=wp) :: TempD

bX(:) = Zero
I = irlxroot
do K=2,nRoots
  do L=1,K-1
    IKL = nTri_Elem(K-2)+L
    bX(IKL) = R(K,I)**2*LOK(L,K)-R(L,I)**2*LOK(K,L)
    do M=2,nRoots
      do N=1,M-1
        TempD = Zero
        if (M == K) TempD = TempD+H(N,L)
        if (N == K) TempD = TempD+H(L,M)
        if (M == L) TempD = TempD-H(N,K)
        if (N == L) TempD = TempD-H(K,M)
        bX(IKL) = bX(IKL)+TempD*R(M,I)*R(N,I)
      end do
    end do
  end do
end do
bX(:) = Two*bX(:)

end subroutine CalcbX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION ISGNUM2
     &         (NLEV,NVERT,MIDLEV,MIDV1,MIDV2,NMIDV,MXUP,MXDWN,
     &          IDOWN,IUP,IDAW,IRAW,IUSGN,ILSGN,IWALK)
C
C     PURPOSE: FOR ANY GIVEN WALK (STEP VECTOR) COMPUTE THE
C              LEXICAL NUMBER IN THE SPLIT GUGA REPRESENTATION
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION IDOWN(NVERT,0:3),IUP(NVERT,0:3)
      DIMENSION IDAW(NVERT,0:4),IRAW(NVERT,0:4)
      DIMENSION IUSGN(MXUP,NMIDV),ILSGN(MXDWN,NMIDV)
      DIMENSION IWALK(NLEV)
C
C
C     FIND THE MIDVERTEX AND THE COMBINED WALK SYMMETRY
C
      MIDV=1
      DO 100 LEV=NLEV,(MIDLEV+1),-1
        ICASE=IWALK(LEV)
        MIDV=IDOWN(MIDV,ICASE)
100   CONTINUE
      MIDV=MIDV-MIDV1+1
C
C     FIND REVERSE ARC WEIGHT FOR THE UPPER WALK
C
      IRAWSUM=1
      LV=1
      DO 110 LEV=NLEV,(MIDLEV+1),-1
        IC=IWALK(LEV)
        LV=IDOWN(LV,IC)
        IRAWSUM=IRAWSUM+IRAW(LV,IC)
110   CONTINUE
      IUW=IUSGN(IRAWSUM,MIDV)
C
C     FIND DIRECT ARC WEIGHT FOR THE LOWER WALK
C
      IDAWSUM=1
      LV=NVERT
      DO 120 LEV=1,MIDLEV
        IC=IWALK(LEV)
        LV=IUP(LV,IC)
        IDAWSUM=IDAWSUM+IDAW(LV,IC)
120   CONTINUE
      ILW=ILSGN(IDAWSUM,MIDV)
C
C     COMPUTE LEXICAL ORDERING NUMBER
C
      ISGNUM2=IUW+ILW
C
C
C     EXIT
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(MIDV2)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SCDTTS(BLOCKS,IBLOCK,NBLOCK,NSMST,NSASO,NSBSO,IDC)
! Scale batch of
! blocks between determinant and combination form
!
! dets to combs
!
! The blocks are assumed to be in packed form !!
!
! Jeppe Olsen, August 1995

use Index_Functions, only: nTri_Elem
use Constants, only: Two, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(inout) :: BLOCKS(*)
integer(kind=iwp), intent(in) :: NBLOCK, IBLOCK(8,NBLOCK), NSMST, NSASO(NSMST,*), NSBSO(NSMST,*), IDC
integer(kind=iwp) :: IASM, IATP, IBSM, IBTP, IOFFP, IPACK, JBLOCK, NELMNT, NIA, NIB
real(kind=wp), parameter :: SQ2 = sqrt(Two), SQ2I = sqrt(Half)

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ======================='
write(u6,*) ' Information from SCDTTS'
write(u6,*) ' ======================='
write(u6,*) ' Input vector'
call WRTTTS(BLOCKS,IBLOCK,NBLOCK,NSMST,NSASO,NSBSO,2)
#endif

do JBLOCK=1,NBLOCK

  IATP = IBLOCK(1,JBLOCK)
  IBTP = IBLOCK(2,JBLOCK)
  IASM = IBLOCK(3,JBLOCK)
  IBSM = IBLOCK(4,JBLOCK)
  IOFFP = IBLOCK(6,JBLOCK)
  if (IBLOCK(1,JBLOCK) > 0) then
    ! Is this block diagonal in packed form
    if ((IASM == IBSM) .and. (IATP == IBTP)) then
      IPACK = 1
    else
      IPACK = 0
    end if
    NIA = NSASO(IASM,IATP)
    NIB = NSBSO(IBSM,IBTP)
    if (IPACK == 1) then
      NELMNT = nTri_Elem(NIA)
    else
      NELMNT = NIA*NIB
    end if
    ! Ms combinations
    if (IDC == 2) then
      BLOCKS(IOFFP:IOFFP+NELMNT-1) = SQ2*BLOCKS(IOFFP:IOFFP+NELMNT-1)
      if (IPACK == 1) call SCLDIA(BLOCKS(IOFFP),SQ2I,NIA,1)
    end if

  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Output vector'
call WRTTTS(BLOCKS,IBLOCK,NBLOCK,NSMST,NSASO,NSBSO,2)
#endif

end subroutine SCDTTS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Anders Bernhardsson                              *
!***********************************************************************

subroutine ExpHinvv(rdia,v,u,alpha,beta)
! Preconditioning of the state transfer part
! of the  electronic hessian with an subunit
! described with the Explicit hessian and
! the rest with the diagonal
!
!                            -1
! |u> = alpha|u> + beta  (H -E ) |v>
!                          0  0

use MCLR_Data, only: H0F, H0S, nConf1, nExp, SBIDT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: rdia(nConf1), v(nConf1), alpha, beta
real(kind=wp), intent(inout) :: u(nConf1)
integer(kind=iwp) :: i, iRC, j
real(kind=wp), allocatable :: Tmp1(:), Tmp4(:)

if (nExp /= 0) then
  call mma_allocate(Tmp1,nExp,Label='Tmp1')
  call mma_allocate(Tmp4,nExp,Label='Tmp4')

  do i=1,nExp
    j = SBIDT(i)
    Tmp1(i) = v(j)
    Tmp4(i) = u(j)
  end do

  irc = 0
  call dgetrs_('N',NEXP,1,H0S,nexp,H0F,Tmp1,nexp,irc)
  if (irc /= 0) then
    write(u6,*) 'Error in DGETRS called from exphinvv'
    call Abend()
  end if
end if

if ((alpha == Zero) .and. (beta == One)) then
  u(:) = rDia(:)*v(:)
else if (alpha == Zero) then
  u(:) = beta*rDia(:)*v(:)
else if (alpha == One) then
  u(:) = u(:)+beta*rDia(:)*v(:)
else
  u(:) = alpha*u(:)+beta*rDia(:)*v(:)
end if

if (nExp /= 0) then
  do i=1,nExp
    j = SBIDT(i)
    u(j) = alpha*Tmp4(i)+beta*Tmp1(i)
  end do
  call mma_deallocate(Tmp1)
  call mma_deallocate(Tmp4)
end if

end subroutine ExpHinvv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine set_T( nT, nTempMagn, TINPUT, TempMagn, Tmin, Tmax,
     &                  chit_exp, Texp,
     &                  T, XTexp )

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
c input:
      Integer, intent(in)       :: nT, nTempMagn
      Logical, intent(in)       :: TINPUT
      Real(kind=8), intent(in) :: Tmin, Tmax, TempMagn(nTempMagn),
     &                             Texp(nT), chit_exp(nT)
      Real(kind=8), intent(out):: T(nT+nTempMagn), XTexp(nT+nTempMagn)
c local variables:
      Integer :: i
      Real(kind=8) :: dltt


      ! set nT, T(i) and XTexp(i) arrays:
      T=0.0_wp
      XTexp=0.0_wp
!---------------------------------------------------------------------!
      If ( TINPUT ) Then
      ! case 1:  T(iT) computed from input values: Texp, and nTempMagn
      !          nTempMagn = 0
         If ( nTempMagn > 0  ) Then
            Do i=1, nTempMagn
               T(i)=TempMagn(i)
            End Do
            Do i= 1, nT
                   T(i+nTempMagn) =    Texp(i)
               XTexp(i+nTempMagn) =chit_exp(i)
            End Do
         Else
            Do i = 1, nT
               T(i)     =     Texp(i)
               XTexp(i) = chit_exp(i)
            End Do
         End If
      Else
      ! case 2:  T(iT) computed from input values: Tmin, Tmax, nT
      !          and nTempMagn
         dltt=0.0_wp
         dltt=(tmax-tmin)/(dble(nT-1))

         If ( nTempMagn > 0 ) Then
            Do i=1, nTempMagn
               T(i)=TempMagn(i)
            End Do

            T(1+nTempMagn)=0.0001_wp
            Do i = 2, nT
               T(i+nTempMagn) = Tmin + dltt*dble(i-1)
            End Do
         Else !compute_magnetization

            T(1)=0.0001_wp
            Do i = 2, nT
               T(i) = Tmin + dltt*dble(i-1)
            End Do
         End If
      End If !tinput

!---------------------------------------------------------------------!

      ! check for T=0 values and replace them
      ! with a definite nonzero value:
      Do i=1,nT+nTempMagn
        If( abs(T(i)) .le. tiny(0.0_wp) ) Then
            T(i) = 0.0001_wp
        End If
      End Do

      Return
      End subroutine set_T

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Luis Manuel Frutos                               *
*               2015, Ignacio Fdez. Galvan                             *
*               2015, Alessio Valentini                                *
************************************************************************
      subroutine surfacehop(return)
      use Tully_variables
      implicit none
#include "warnings.fh"
#include "stdalloc.fh"
      integer return
      integer NSTATE, LUIPH, IAD, ITOC15(15)
      integer NCI, IDISK, I
      real*8, allocatable :: CIBigArray(:)


      call initial_surfacehop()
      call rdinp_surfacehop()

      LUIPH=20
      call DANAME(LUIPH,"JOBIPH")
      IAD=0
      call IDAFILE(LUIPH,2,ITOC15,15,IAD)
      call getIphInfo(LUIPH,NCI,NSTATE,ITOC15)
      call mma_allocate(CIBigArray,NCI*NSTATE)
      CIBigArray(:)=0.0D0

      IDISK=ITOC15(4)
      do I=1, NSTATE
         call DDAFILE(LUIPH,2,CIBigArray(NCI*(I-1)+1),NCI,IDISK)
      end do
      call DACLOS(LUIPH)

*      call recprt('CI coefficients',"",CIBigArray,NCI,NSTATE)

      call tully(CIBigArray,NSTATE,NCI)

      call mma_deallocate(CIBigArray)
      return=_RC_ALL_IS_WELL_
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine prgrad_cvb(grad,n)

use casvb_global, only: ipr, norb, nprorb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: grad(n)
real(kind=wp), allocatable :: tmp(:,:)

if (ipr(3) < 2) return
call mma_allocate(tmp,norb,norb,label='tmp')
call mxunfold_cvb(grad,tmp,norb)
write(u6,'(/,a)') ' Orbital gradient :'
call mxprint_cvb(tmp,norb,norb,0)
if (n-nprorb > 0) then
  write(u6,'(a)') ' Structure coefficient gradient :'
  call mxprint_cvb(grad(nprorb+1),1,n-nprorb,0)
end if
call mma_deallocate(tmp)

return

end subroutine prgrad_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine READIN_MRCI()

use mrci_global, only: BNAME, CISEL, CSEL, CSPCK, CTRSH, ENP, ETHRE, GFAC, ICH, ICPF, IFIRST, INDX, INTSY, IORB, IPRINT, IRC, &
                       IREFCI, IREST, IROW, IROOT, ISAB, ITOC17, ITRANS, JJS, JREFX, KBUFF1, LN, LSYM, LUONE, LUSYMB, MAXIT, &
                       MEMPRM, MEMTOT, MEMWRK, MXREF, MXVEC, NASH, NBAS, NBAST, NBMAX, NBTRI, NCMO, NCSHT, NCSPCK, NCOMP, NCVAL, &
                       NDEL, NDMO, NELEC, NFMO, NFRO, NISH, NORB, NORBT, NREF, NRROOT, NSEL, NSM, NSYM, NVIR, NVIRP, NVIRT, &
                       POTNUC, SSEL, SQNLIM, THRORB
use guga_util_global, only: IAD10, nIOCR
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Two
use Definitions, only: wp, iwp, u5, u6

implicit none
#include "Molcas.fh"
#include "warnings.h"
integer(kind=iwp) :: I, IADD10, iCmd, IDISK, IGFAC, IIN, ILIM, INTNUM, IO, IOM, iOpt, IORBS, IR, iRef, ISC(4), istatus, ISUM, &
                     ISYM, IT, IU, IV, IVA, IX1, IX2, IX3, IX4, IY1, IY2, IY3, IY4, J, jCmd, jEnd, JJ, jStart, LN1, LN2, LV, MXVC, &
                     NAMSIZ, NASHI, NASHT, NBASI, NC, NCSH(8), NCSHI, NDELI, NDELT, NDMOI, NDMOT, NFMOI, NFMOT, NFROI, NFROT, &
                     NINTSY, nIRC, NISHI, NISHT, NIWLK, nJJS, NORBI, NOTOT(8), NREFWR, NRF, NRLN1, nTit, NVAL(8), NVALI, NVALT, &
                     NVIRI, NVT, NVT2
real(kind=wp) :: SPIN
logical(kind=iwp) :: Skip
character(len=88) :: ModLine
character(len=72) :: Line, Title(10)
character(len=4) :: Command
integer(kind=iwp), allocatable :: IOCR(:)
character(len=4), parameter :: Cmd(19) = ['TITL','THRP','PRIN','FROZ','DELE','MAXI','ECON','REST','ROOT','ACPF','SDCI','GVAL', &
                                          'PROR','REFC','SELE','NRRO','MXVE','TRAN','END ']

! Initialize data and set defaults

IOM = MXORB
KBUFF1 = 2*9600
ETHRE = 1.0e-8_wp
SQNLIM = 1.0e-10_wp
CTRSH = 0.05_wp
THRORB = 1.0e-5_wp
ENP = One
NRROOT = 1
NSEL = 0
IPRINT = 1
MAXIT = 20
IREST = 0
ICPF = 0
IREFCI = 0
ITRANS = 0
IGFAC = 0
MXVC = 0
do I=1,8
  NFRO(I) = 0
  NDEL(I) = 0
  NBAS(I) = 0
  NORB(I) = 0
end do
do I=1,IOM+1
  IROW(I) = I*(I-1)/2
end do
do I=1,12
  IROOT(I) = I
end do
nTit = 0

! Read the header of the ONEINT file

NAMSIZ = LENIN8*MXORB
IDISK = 0
call WR_MOTRA_Info(LUONE,2,iDisk,ITOC17,64,POTNUC,NSYM,NBAS,NORB,NFMO,NDMO,8,BNAME,NAMSIZ)

!---  Read input from standard input ----------------------------------*
call RdNLst(u5,'MRCI')
Skip = .false.
jCmd = 0
do
  if (Skip) then
    Skip = .false.
  else
    read(u5,'(A)',iostat=istatus) Line
    if (istatus < 0) call Error(1)
    Command = Line(1:4)
    call UpCase(Command)
    if (Command(1:1) == '*') cycle
    if (Command == ' ') cycle
    jCmd = 0
    do iCmd=1,size(Cmd)
      if (Command == Cmd(iCmd)) jCmd = iCmd
    end do
  end if
  select case (jCmd)

    case default
      write(u6,*) 'READIN Error: Command not recognized.'
      write(u6,*) 'The command is:'//''''//Command//''''
      call QUIT(_RC_INPUT_ERROR_)

    case (1) !TITL
      !---  process TITL command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        Command = Line(1:4)
        call UpCase(Command)
        if (Command(1:1) == '*') cycle
        jCmd = 0
        do iCmd=1,size(Cmd)
          if (Command == Cmd(iCmd)) jCmd = iCmd
        end do
        if (jCmd /= 0) exit
        nTit = nTit+1
        if (nTit <= size(Title)) Title(nTit) = Line
      end do
      Skip = .true.

    case (2) !THRP
      !---  process THRP command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) CTRSH
      if (istatus > 0) call Error(2)

    case (3) !PRIN
      !---  process PRIN command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) IPRINT
      if (istatus > 0) call Error(2)

    case (4) !FROZ
      !---  process FROZ command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      ModLine = Line//' 0 0 0 0 0 0 0 0'
      read(ModLine,*,iostat=istatus) (NFRO(I),I=1,8)
      if (istatus > 0) call Error(2)

    case (5) !DELE
      !---  process DELE command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      ModLine = Line//' 0 0 0 0 0 0 0 0'
      read(ModLine,*,iostat=istatus) (NDEL(I),I=1,8)
      if (istatus > 0) call Error(2)

    case (6) !MAXI
      !---  process MAXI command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) MAXIT
      if (istatus > 0) call Error(2)

    case (7) !ECON
      !---  process ECON command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) ETHRE
      if (istatus > 0) call Error(2)

    case (8) !REST
      !---  process REST command --------------------------------------*
      IREST = 1

    case (9) !ROOT
      !---  process ROOT command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) (IROOT(I),I=1,NRROOT)
      if (istatus > 0) call Error(2)

    case (10) !ACPF
      !---  process ACPF command --------------------------------------*
      ICPF = 1

    case (11) !SDCI
      !---  process SDCI command --------------------------------------*
      ICPF = 0

    case (12) !GVAL
      !---  process GVAL command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) GFAC
      if (istatus > 0) call Error(2)
      IGFAC = 1

    case (13) !PROR
      !---  process PROR command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) THRORB
      if (istatus > 0) call Error(2)

    case (14) !REFC
      !---  process REFC command --------------------------------------*
      IREFCI = 1

    case (15) !SELE
      !---  process SELE command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) NSEL
      if (istatus > 0) call Error(2)
      JJ = 0
      do I=1,NSEL
        read(u5,*,iostat=istatus) NC,(CSEL(JJ+J),SSEL(JJ+J),J=1,NC)
        if (istatus < 0) call Error(1)
        if (istatus > 0) call Error(2)
        JJ = JJ+NC
        NCOMP(I) = NC
      end do

    case (16) !NRRO
      !---  process NRRO command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) NRROOT
      if (istatus > 0) call Error(2)
      if (NRROOT > MXVEC) then
        write(u6,1610) NRROOT,MXVEC
        call quit(_RC_INPUT_ERROR_)
      end if
      do I=1,NRROOT
        IROOT(I) = I
      end do

    case (17) !MXVE
      !---  process MXVE command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) MXVC
      if (istatus > 0) call Error(2)
      if (mxvc > mxvec) then
        write(u6,1710) mxvc,mxvec
        call quit(_RC_INPUT_ERROR_)
      end if

    case (18) !TRAN
      !---  process TRAN command --------------------------------------*
      ITRANS = 1

    case (19) !END
      exit

  end select
end do
!---  The end of the input is reached, print the title ----------------*
if (ntit == 0) then
  ntit = 1
  title(1) = ' ( No title was given )'
end if
write(u6,*)
write(u6,'(6X,120A1)') ('*',i=1,120)
write(u6,'(6X,120A1)') '*',(' ',i=1,118),'*'
write(u6,'(6X,57A1,A6,57A1)') '*',(' ',i=1,56),'Title:',(' ',i=1,56),'*'
do i=1,nTit
  call Center_Text(Title(i))
  write(u6,'(6X,24A1,A72,24A1)') '*',(' ',j=1,23),Title(i),(' ',j=1,23),'*'
end do
write(u6,'(6X,120A1)') '*',(' ',i=1,118),'*'
write(u6,'(6X,120A1)') ('*',i=1,120)
write(u6,*)

!---  print the coordinates of the system -----------------------------*
call PrCoor()

!---  read the header of CIGUGA ---------------------------------------*

! Read the header of the CIGUGA file

IADD10 = 0
call iDAFILE(LUSYMB,2,IAD10,9,IADD10)
iOpt = 2
nJJS = 18
nIRC = 4
call mma_allocate(IOCR,nIOCR,label='IOCR')
call WR_GUGA(LUSYMB,iOpt,IADD10,NREF,SPIN,NELEC,LN,NSYM,NCSPCK,NINTSY,IFIRST,INTNUM,LSYM,NRF,LN1,NRLN1,NASH,NISH,8,IRC,nIRC,JJS, &
             nJJS,NVAL,IOCR,nIOCR)
if (ICPF == 1) then
  write(u6,*) '      THIS IS AN   A C P F   CALCULATION'
else
  write(u6,*) '      THIS IS AN   S D C I   CALCULATION'
  write(u6,*) '      (But an ACPF correction will be computed)'
end if
if (IGFAC == 0) then
  GFAC = Two/NELEC
  write(u6,*) '      USE THE DEFAULT ACPF G-VALUE GFAC=',GFAC
else
  write(u6,*) '      THE ACPF G-VALUE HAS BEEN SET TO GFAC=',GFAC
end if
write(u6,*)
if (IREST /= 0) write(u6,*) '      RESTARTED CALCULATION.'
write(u6,*) '      A SMALL CI IS PERFORMED INVOLVING ONLY THE REFERENCE STATES.'
write(u6,*) '      THIS REFERENCE CI WILL USE THE FOLLOWING ROOT SELECTION CRITERIA:'
write(u6,*)
write(u6,*)
if (MXVC == 0) MXVC = max(NRROOT,10)
if (NSEL == 0) then
  write(u6,*) '      ROOT SELECTION BY ENERGY ORDERING.'
  if (NRROOT == 1) then
    write(u6,'(A,I8)') '      ONE SINGLE ROOT, NUMBER ',IROOT(1)
  else
    write(u6,*) '      THE FOLLOWING ROOTS WILL BE SELECTED:'
    write(u6,'(1X,/(1x,12I3))') (IROOT(I),I=1,NRROOT)
  end if
else
  write(u6,*) '      ROOT SELECTION BY PROJECTION: THE EIGENVECTORS OF'
  write(u6,*) '      THE REFERENCE CI ARE ORDERED BY DECREASING SIZE OF'
  write(u6,*) '      THEIR PROJECTIONS ONTO A SELECTION SPACE.'
  if (NRROOT == 1) then
    write(u6,*) '     SELECT THE EIGENVECTOR WITH LARGEST PROJECTION.'
  else
    write(u6,'(A,I2,A)') '      SELECT THE ',NRROOT,' EIGENVECTORS WITH LARGEST PROJECTION.'
  end if
  write(u6,*) '      THE SELECTION SPACE IS SPANNED BY THE FOLLOWING VECTORS (NONZERO COMPONENTS ONLY):'
  JJ = 0
  do I=1,NSEL
    write(u6,'(6X,A,I2)') ' VECTOR NR. ',I
    NC = NCOMP(I)
    write(u6,'(11X,I2,5X,A20,F12.8)') (J,SSEL(JJ+J),CSEL(JJ+J),J=1,NC)
    JJ = JJ+NC
  end do
end if
write(u6,*)
if (IREFCI == 0) then
  if (IREST == 0) then
    write(u6,*) '      THE REFERENCE CI IS FOLLOWED BY THE FULL SPACE'
    write(u6,*) '      CALCULATION, WHERE THE SELECTION CRITERION'
    write(u6,*) '      IS MAXIMUM OVERLAP WITH THE ROOT(S) SELECTED IN'
    write(u6,*) '      THE REFERENCE CI.'
  else
    write(u6,*) '      THE REFERENCE CI IS FOLLOWED BY THE FULL SPACE'
    write(u6,*) '      CALCULATION, WITH ITERATIONS RESTARTED FROM'
    write(u6,*) '      CI VECTOR(S) READ FROM FILE. THE ROOT SELECTION'
    write(u6,*) '      CRITERION IS MAXIMUM OVERLAP WITH THE START'
    write(u6,*) '      VECTORS.'
  end if
else
  write(u6,*) '      ONLY THE REFERENCE CI WAS REQUESTED.'
end if
if (LN > IOM) then
  write(u6,*) 'READIN Error: Too many orbitals.'
  write(u6,'(1X,A,2I5)') 'actual,allowed:',LN,IOM
  call QUIT(_RC_INPUT_ERROR_)
end if
NISHT = 0
LV = 0
do I=1,NSYM
  NISHT = NISHT+NISH(I)
  LV = LV+NVAL(I)
end do
IIN = 0
IR = 0
IVA = 0
IU = NISHT+LV
IT = LV
IV = LN
NBAST = 0
NORBT = 0
NFMOT = 0
NFROT = 0
NASHT = 0
NVALT = 0
NVIRT = 0
NCSHT = 0
NDELT = 0
NDMOT = 0
do I=1,NSYM
  NORBI = NORB(I)
  NBASI = NBAS(I)
  NFMOI = NFMO(I)
  NFROI = NFRO(I)
  NISHI = NISH(I)
  NASHI = NASH(I)
  NVALI = NVAL(I)
  NDELI = NDEL(I)
  NDMOI = NDMO(I)
  NVIR(I) = NORBI-NFROI-NASHI-NISHI-NVALI-NDELI
  NVIRI = NVIR(I)
  NCSH(I) = NISHI+NASHI+NVALI+NVIRI
  NCSHI = NCSH(I)
  NBAST = NBAST+NBASI
  NORBT = NORBT+NORBI
  NFMOT = NFMOT+NFMOI
  NFROT = NFROT+NFROI
  NASHT = NASHT+NASHI
  NVALT = NVALT+NVALI
  NVIRT = NVIRT+NVIRI
  NCSHT = NCSHT+NCSHI
  NDELT = NDELT+NDELI
  NDMOT = NDMOT+NDMOI
  do J=1,NFROI
    IIN = IIN+1
    IR = IR-1
    ICH(IIN) = IR
  end do
  do J=1,NISHI
    IIN = IIN+1
    IT = IT+1
    ICH(IIN) = IT
    NSM(IT) = I
  end do
  do J=1,NASHI
    IIN = IIN+1
    IU = IU+1
    ICH(IIN) = IU
    NSM(IU) = I
  end do
  do J=1,NVALI
    IIN = IIN+1
    IVA = IVA+1
    ICH(IIN) = IVA
    NSM(IVA) = I
  end do
  do J=1,NVIRI
    IIN = IIN+1
    IV = IV+1
    ICH(IIN) = IV
    NSM(IV) = I
  end do
  do J=1,NDELI
    IIN = IIN+1
    ICH(IIN) = 0
  end do
end do
IORBS = 0
do ISYM=1,NSYM
  NOTOT(ISYM) = 0
end do
do ISYM=1,NSYM
  IO = NOTOT(ISYM)
  do I=1,NFMO(ISYM)+NFRO(ISYM)
    IO = IO+1
  end do
  NOTOT(ISYM) = IO
end do
do ISYM=1,NSYM
  IO = NOTOT(ISYM)
  do I=1,NISH(ISYM)
    IO = IO+1
    IORBS = IORBS+1
    IORB(IORBS) = IO
  end do
  NOTOT(ISYM) = IO
end do
do ISYM=1,NSYM
  IO = NOTOT(ISYM)
  do I=1,NASH(ISYM)
    IO = IO+1
    IORBS = IORBS+1
    IORB(IORBS) = IO
  end do
  NOTOT(ISYM) = IO
end do
do ISYM=1,NSYM
  IO = NOTOT(ISYM)
  do I=1,NVAL(ISYM)
    IO = IO+1
    IORBS = IORBS+1
    IORB(IORBS) = IO
  end do
  NOTOT(ISYM) = IO
end do
do ISYM=1,NSYM
  IO = NOTOT(ISYM)
  do I=1,NVIR(ISYM)
    IO = IO+1
    IORBS = IORBS+1
    IORB(IORBS) = IO
  end do
  NOTOT(ISYM) = IO
end do
! NR OF VIRTUALS IN PREVIOUS SYMMETRIES:
ISUM = 0
do I=1,NSYM
  NVIRP(I) = ISUM
  ISUM = ISUM+NVIR(I)
end do
NCMO = 0
NBMAX = 0
do I=1,NSYM
  if (NBAS(I) > NBMAX) NBMAX = NBAS(I)
  NCMO = NCMO+NBAS(I)**2
end do
NBTRI = (NBAST*(NBAST+1))/2
NVT = IROW(NVIRT+1)
NVT2 = IROW(NVIRT)
write(u6,*)
write(u6,'(A)') '      MALMQVIST DIAGONALIZATION'
write(u6,*)
write(u6,'(A,I8)') '      PRINT LEVEL                   ',IPRINT
write(u6,'(A,I12)') '      WORKSPACE WORDS, (Re(wp)) ',MEMTOT
write(u6,'(A,I8)') '      MAXIMUM NR OF ORBITALS        ',IOM
write(u6,'(A,I8)') '      MAX NR OF STORED CI/SGM ARR.  ',MXVC
write(u6,'(A,I8)') '      MAX NR OF ITERATIONS          ',MAXIT
write(u6,'(A,D9.2)') '      ENERGY CONVERGENCE THRESHOLD ',ETHRE
write(u6,'(A,F8.1)') '      SPIN QUANTUM NUMBER           ',SPIN
write(u6,'(A,I8)') '      CORRELATED ELECTRONS          ',NELEC
write(u6,'(A,I8)') '      WAVE FUNCTION SYMMETRY LABEL  ',LSYM
write(u6,'(A,I8)') '      POINT GROUP ORDER             ',NSYM
write(u6,*)
write(u6,101) 'SYMMETRY LABEL:',(I,I=1,NSYM)
write(u6,101) 'INACTIVE ORBITALS',(NISH(I),I=1,NSYM),NISHT
write(u6,101) 'ACTIVE ORBITALS',(NASH(I),I=1,NSYM),NASHT
write(u6,101) 'ADDED VALENCE ORB',(NVAL(I),I=1,NSYM),NVALT
write(u6,101) 'VIRTUAL ORBITALS',(NVIR(I),I=1,NSYM),NVIRT
write(u6,*)
write(u6,101) 'SUM:CORREL ORBITALS',(NCSH(I),I=1,NSYM),NCSHT
write(u6,*)
write(u6,101) 'FROZEN ORBITALS',(NFRO(I),I=1,NSYM),NFROT
write(u6,101) 'DELETED ORBITALS',(NDEL(I),I=1,NSYM),NDELT
write(u6,*)
write(u6,101) 'SUM:ORBITALS IN CI',(NORB(I),I=1,NSYM),NORBT
write(u6,*)
write(u6,101) 'PRE-FROZEN ORBITALS',(NFMO(I),I=1,NSYM),NFMOT
write(u6,101) 'PRE-DELETED ORBITALS',(NDMO(I),I=1,NSYM),NDMOT
write(u6,101) 'SUM:   TOTAL BASIS',(NBAS(I),I=1,NSYM),NBAST
write(u6,*)
if (LN1 == 0) then
  write(u6,*) '      ONE CLOSED SHELL REFERENCE STATE'
else
  write(u6,'(6X,I4,A)') NREF,' REFERENCE STATES'
  NREFWR = min(NREF,1000/LN1)
  LN2 = min(32,LN1)
  write(u6,'(6X,A,T47)') 'Occupation of the reference states'
  if (NREFWR < NREF) then
    write(u6,'(6X,A,I3,A)') '( Only the ',NREFWR,' first are listed)'
  end if
  write(u6,'(6X,A,T25,32I2)') 'Active orbital nr.',(I,I=1,LN2)
  jEnd = 0
  do iRef=1,NREFWR
    jStart = jEnd+1
    jEnd = jEnd+LN1
    write(u6,'(6X,A,I3,T25,32I2)') 'Ref nr',IREF,(IOCR(j),j=jStart,jStart-1+LN2)
  end do
end if
call mma_deallocate(IOCR)
write(u6,*)
if (INTNUM /= 0) write(u6,*) '      FIRST ORDER INTERACTING SPACE.'
IX1 = IRC(1)
IX2 = IRC(2)-IRC(1)
ISC(1) = IX1
ISC(2) = ISC(1)+IX2*NVIRT
IY1 = ISC(1)
IY2 = ISC(2)-ISC(1)
if (IFIRST == 0) then
  ILIM = 4
  IX3 = IRC(3)-IRC(2)
  IX4 = IRC(4)-IRC(3)
  ISC(3) = ISC(2)+IX3*NVT2
  ISC(4) = ISC(3)+IX4*NVT
  IY3 = ISC(3)-ISC(2)
  IY4 = ISC(4)-ISC(3)
  if (IPRINT >= 10) then
    write(u6,*)
    write(u6,*) '      INTERNAL WALKS:'
    write(u6,215) IX1,IX2,IX3,IX4
    write(u6,*)
    write(u6,*) '      FORMAL CONFIGURATIONS:'
    write(u6,215) IY1,IY2,IY3,IY4
    write(u6,'(6X,A,I7)') '                  TOTAL:',ISC(ILIM)
  end if
else
  ILIM = 2
  if (IPRINT >= 10) then
    write(u6,*)
    write(u6,*) '      INTERNAL WALKS:'
    write(u6,216) IX1,IX2
    write(u6,*)
    write(u6,*) '      FORMAL CONFIGURATIONS:'
    write(u6,216) IY1,IY2
    write(u6,'(6X,A,I7)') '                  TOTAL:',ISC(ILIM)
  end if
end if
NIWLK = IRC(ILIM)
NCVAL = IRC(1)
! ----------------------------------------------------------------------
if (NVIRT > 255) then
  write(u6,*)
  write(u6,*) ' Sorry -- The MRCI code uses internal integer codes'
  write(u6,*) ' where the index of virtual orbitals is kept in'
  write(u6,*) ' 8-bit fields. This cannot easily be increased'
  write(u6,*) ' and limits the number of virtual orbitals to '
  write(u6,*) ' 255. Your input asks for more virtuals than this.'
  write(u6,*) ' The program cannot run.'
  call Quit(_RC_INPUT_ERROR_)
end if
! ----------------------------------------------------------------------
! ALLOCATION OF DATA PERMANENTLY IN CORE
!

! CSPCK - ARRAY OF BIT-PACKED GUGA CASE NUMBERS OF INTERNAL WALKS.
! CONSISTS OF NCSPCK INTEGERS.

call mma_allocate(CSPCK,NCSPCK,label='CSPCK')
call iDAFILE(LUSYMB,2,CSPCK,NCSPCK,IADD10)

! INTSY - ARRAY OF BIT-PACKED SYMMETRY LABELS OF INTERNAL WALKS.
! CONSISTS OF NINTSY INTEGERS.

call mma_allocate(INTSY,NINTSY,label='INTSY')
call iDAFILE(LUSYMB,2,INTSY,NINTSY,IADD10)

! INDX - START POSITION IN CI ARRAY OF EACH INTERNAL-WALK-BLOCK

call mma_allocate(INDX,NIWLK,label='INDX')

! ISAB - ORDERING NR OF EACH VIRTUAL PAIR WITHIN ITS COMB-SYMM

call mma_allocate(ISAB,NVIRT,NVIRT,label='ISAB')

! JREFX - FOR EACH VALENCE CSF, EITHER 0 OR ITS REFERENCE NR.

call mma_allocate(JREFX,NCVAL,label='JREFX')
IADD10 = IAD10(2)
call iDAFILE(LUSYMB,2,JREFX,NCVAL,IADD10)

! PROJECTION SELECTION VECTORS

call mma_allocate(CISEL,NREF,NSEL,label='CISEL')

! START OF NON-PERMANENT AREA:

call INDMAT(CSPCK,INTSY,INDX,ISAB,JREFX,CISEL)
if (NREF > MXREF) then
  write(u6,*) 'READIN Error: Too many references.'
  write(u6,'(1X,A,2I6)') ' actual, allowed:',NREF,MXREF
  call QUIT(_RC_INPUT_ERROR_)
end if

! Total available memory (at start of program) is MEMTOT
! Available now is MEMWRK
! Already (permanently) allocated is MEMPRM

call mma_maxdble(MemWrk)
MEMPRM = MEMTOT-MEMWRK

call ALLOC_MRCI()

return

101 format(6X,A,T47,9I5)
215 format(/,6X,'                 VALENCE',I7,/,6X,' DOUBLET COUPLED SINGLES',I7,/,6X,' TRIPLET COUPLED DOUBLES',I7, &
           /,6X,' SINGLET COUPLED DOUBLES',I7)
216 format(/,6X,'                 VALENCE',I7,/,6X,' DOUBLET COUPLED SINGLES',I7)
1610 format('Too many roots,',i3,', max allowed is',i3)
1710 format('Too many vectors,',i3,', max allowed is',i3)

contains

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  select case (code)
    case (1)
      write(u6,*) 'READIN Error: Premature end of file while reading.'
    case (2)
      write(u6,*) 'READIN Error: I/O error during internal read.'
      write(u6,*) 'The line that could not be read is:'
      write(u6,*) Line
  end select
  call Quit(_RC_IO_ERROR_READ_)

end subroutine Error

end subroutine READIN_MRCI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Martin Schuetz                                         *
*               Roland Lindh                                           *
*               2015, Steven Vancoillie                                *
*               2017, Ignacio Fdez. Galvan                             *
************************************************************************

************************************************************************
* Wrapper routines agains the GA-ChemIO or MPI-IO package.             *
* (EAF = exclusive access file)                                        *
*                                                                      *
* If not an mpp installation the AIX-IO facility will be used.         *
************************************************************************

#ifdef ADD_
#define eaf_open eaf_open_
#define eaf_close eaf_close_
#define eaf_awrite eaf_awrite_
#define eaf_aread eaf_aread_
#define eaf_write eaf_write_
#define eaf_read eaf_read_
#define eaf_wait eaf_wait_
#endif

************************************************************************
*                                                                      *
      Subroutine EAFOpen(Lu,FName)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Character*(*) FName
      Integer Lu
      Integer  isfreeunit
      External isfreeunit
#ifdef _MOLCAS_MPP_
      Character*200 FN
      Integer  iRC
#ifdef _HAVE_EXTRA_
      Integer  n
#endif
#include "molcas_eaf.fh"
#endif
#ifdef _MOLCAS_MPP_
      If(Is_Real_Par()) Then
      FN=FName
      Call Ext_Rank(FN)
#ifdef _HAVE_EXTRA_
      n=Len_Trim(FName)
      FN(n+1:n+1)=Char(0)
      iRC=molcas_eaf_open(FN,Lu)
#else
      iRC=eaf_open(FN,eaf_rw,Lu)
#endif
      If (iRC.ne.0) Then
         Write (6,*) 'EAFOpen: Abort!'
         Write (6,*) 'iRC=',iRC
         Write (6,*) 'Lu=',Lu
         Write (6,*) 'Fname=',FName
         Write (6,*) 'EAF_Err_Code =',iRC
         Call Abend()
      End If
      Else
#endif
      Lu=isfreeunit(7)
      Call DaName_MF(Lu,FName)
#ifdef _MOLCAS_MPP_
      End If
#endif
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine EAFClose(Lu)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer Lu
#ifdef _MOLCAS_MPP_
      Integer  iRC
#include "molcas_eaf.fh"
#endif
#ifdef _MOLCAS_MPP_
      If(Is_Real_Par()) Then
#ifdef _HAVE_EXTRA_
      iRC=molcas_eaf_close(Lu)
#else
      iRC=eaf_close(Lu)
#endif
      If (iRC.ne.0) Then
         Write (6,*) 'EAFClose: Abort!'
         Write (6,*) 'EAF_Err_Code =',iRC
         Call Abend()
      End If
      Else
#endif
      Call DaClos(Lu)
#ifdef _MOLCAS_MPP_
      End If
#endif
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine EAFAWrite(Lu,Buf,nBuf,Disk,id)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer Lu, nBuf, Buf(nBuf), id
      Real*8 Disk
#ifdef _MOLCAS_MPP_
      Integer  iRC
#include "molcas_eaf.fh"
#include "SysDef.fh"
#endif
#ifdef _MOLCAS_MPP_
      If(Is_Real_Par()) Then
#ifdef _HAVE_EXTRA_
      iRC=molcas_eaf_awrite(Lu,Disk,Buf,nBuf*ItoB,id)
#else
      iRC=eaf_awrite(Lu,Disk,Buf,nBuf*ItoB,id)
      Disk=Disk+Dble(nBuf*ItoB)
#endif
      If (iRC.ne.0) Then
         Write (6,*) 'EAFAWrite: Abort!'
         Write (6,*) 'EAF_Err_Code =',iRC
         Call Abend()
      End If
      Else
#endif
      id=0
      Call EAFWrite(Lu,Buf,nBuf,Disk)
#ifdef _MOLCAS_MPP_
      End If
#endif
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine EAFARead(Lu,Buf,nBuf,Disk,id)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer Lu, nBuf, Buf(nBuf), id
      Real*8 Disk
#ifdef _MOLCAS_MPP_
      Integer  iRC
#include "molcas_eaf.fh"
#include "SysDef.fh"
#endif
#ifdef _MOLCAS_MPP_
      If(Is_Real_Par()) Then
#ifdef _HAVE_EXTRA_
      iRC=molcas_eaf_aread(Lu,Disk,Buf,nBuf*ItoB,id)
#else
      iRC=eaf_aread(Lu,Disk,Buf,nBuf*ItoB,id)
      Disk=Disk+Dble(nBuf*ItoB)
#endif
      If (iRC.ne.0) Then
         Write (6,*) 'EAFARead: Abort!'
         Write (6,*) 'EAF_Err_Code =',iRC
         Call Abend()
      End If
      Else
#endif
      id=0
      Call EAFRead(Lu,Buf,nBuf,Disk)
#ifdef _MOLCAS_MPP_
      End If
#endif
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine EAFWrite(Lu,Buf,nBuf,Disk)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer Lu, nBuf, Buf(nBuf)
      Real*8 Disk
      Integer iDisk
#ifdef _MOLCAS_MPP_
      Integer  iRC
#include "molcas_eaf.fh"
#include "SysDef.fh"
#endif
#ifdef _MOLCAS_MPP_
      If(Is_Real_Par()) Then
#ifdef _HAVE_EXTRA_
      iRC=molcas_eaf_write(Lu,Disk,Buf,nBuf*ItoB)
#else
      iRC=eaf_write(Lu,Disk,Buf,nBuf*ItoB)
      Disk=Disk+Dble(nBuf*ItoB)
#endif
      If (iRC.ne.0) Then
         Write (6,*) 'EAFWrite: Abort!'
         Write (6,*) 'EAF_Err_Code =',iRC
         Call Abend()
      End If
      Else
#endif
      iDisk=Int(Disk)
      Call iDaFile(Lu,1,Buf,nBuf,iDisk)
      Disk=Dble(iDisk)
#ifdef _MOLCAS_MPP_
      End If
#endif
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine EAFRead(Lu,Buf,nBuf,Disk)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer Lu, nBuf, Buf(nBuf)
      Real*8 Disk
      Integer iDisk
#ifdef _MOLCAS_MPP_
      Integer  iRC
#include "molcas_eaf.fh"
#include "SysDef.fh"
#endif
#ifdef _MOLCAS_MPP_
      If(Is_Real_Par()) Then
#ifdef _HAVE_EXTRA_
      iRC=molcas_eaf_read(Lu,Disk,Buf,nBuf*ItoB)
#else
      iRC=eaf_read(Lu,Disk,Buf,nBuf*ItoB)
      Disk=Disk+Dble(nBuf*ItoB)
#endif
      If (iRC.ne.0) Then
         Write (6,*) 'EAFRead: Abort!'
         Write (6,*) 'EAF_Err_Code =',iRC
         Call Abend()
      End If
      Else
#endif
      iDisk=Int(Disk)
      Call iDaFile(Lu,2,Buf,nBuf,iDisk)
      Disk=Dble(iDisk)
#ifdef _MOLCAS_MPP_
      End If
#endif
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine EAFWait(Lu,id)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer Lu, id
#ifdef _MOLCAS_MPP_
      Integer iRC
#include "molcas_eaf.fh"
#endif
#ifdef _MOLCAS_MPP_
      If(Is_Real_Par()) Then
#ifdef _HAVE_EXTRA_
      iRC=molcas_eaf_wait(Lu,id)
#else
      iRC=eaf_wait(Lu,id)
#endif
      If (iRC.ne.0) Then
         Write (6,*) 'EAFWait: Abort!'
         Write (6,*) 'EAF_Err_Code =',iRC
         Call Abend()
      End If
      End If
#endif
      Return
#ifndef _MOLCAS_MPP_
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(Lu)
         Call Unused_integer(id)
      End If
#endif
      End
*                                                                      *
************************************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
************************************************************************
      Subroutine Do_Batch(Kernel,Func,
     &                    Grid,Weights,Rho,mGrid,nRho,
     &                    list_s,nlist_s,List_Exp,List_Bas,
     &                    Index,nIndex,AOInt,nAOInt,
     &                    FckInt,nFckDim,nFckInt,SOTemp,nSOTemp,
     &                    TabAO,ipTabAO,mAO,nTabAO,nSym,
     &                    Dens,nDens,nD,
     &                    ndF_dRho,nP2_ontop,ndF_dP2ontop,nShell,
     &                    Do_Mo,Do_TwoEl,l_Xhol,
     &                    TmpPUVX,nTmpPUVX,TabMO,TabSO,
     &                    nMOs,CMOs,nCMO,DoIt,
     &                    P2mo,np2act,D1mo,nd1mo,P2_ontop,
     &                    Do_Grad,Grad,nGrad,dRho_dR,ndRho_dR,nGrad_Eff,
     &                    list_g,IndGrd,iTab,Temp,F_xc,dW_dR,iNQ,Maps2p,
     &                    dF_dRho,dF_dP2ontop,DFTFOCK,LOE_DB,LTEG_DB)
************************************************************************
*      Author:Roland Lindh, Department of Chemical Physics, University *
*             of Lund, SWEDEN. November 2000                           *
************************************************************************
      use iSD_data
      use Real_Spherical
      use Basis_Info
      use Center_Info
      use Phase_Info
      use KSDFT_Info
      Implicit Real*8 (A-H,O-Z)
      External Kernel
#include "SysDef.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "debug.fh"
#include "ksdft.fh"
#include "nq_info.fh"
#include "nsd.fh"
#include "setup.fh"
#include "pamint.fh"
#include "grid_on_disk.fh"
      Integer list_s(2,nlist_s),List_Exp(nlist_s),DoIt(nMOs),
     &        ipTabAO(nlist_s+1,2), IndGrd(nGrad_Eff),
     &        list_g(3,nlist_s), iTab(4,nGrad_Eff), Index(nIndex),
     &        Maps2p(nShell,0:nSym-1), List_Bas(2,nlist_s)
      Real*8 A(3), RA(3), Grid(3,mGrid), Weights(mGrid),
     &       Rho(nRho,mGrid), AOInt(nAOInt*nAOInt,nD),
     &       dF_dRho(ndF_dRho,mGrid), TabAO(nTabAO), Grad(nGrad),
     &       FckInt(nFckInt,nFckDim),
     &       Dens(nDens,nD), SOTemp(nSOTemp,nD),
     &       TabMO(mAO,mGrid,nMOs),TabSO(mAO,mGrid,nMOs),
     &       CMOs(nCMO),P2mo(np2act),D1mo(nd1mo),
     &       P2_ontop(nP2_ontop,mGrid) , Temp(nGrad),
     &       dRho_dR(ndRho_dR,mGrid,nGrad_Eff), F_xc(mGrid),
     &       dW_dR(nGrad_Eff,mGrid),dF_dP2ontop(ndF_dP2ontop,mGrid)
      Real*8 TmpPUVX(nTmpPUVX)
      Logical Do_Grad,Do_Mo,Do_TwoEl,Unpack
      Logical l_Xhol, l_tanhr,l_casdft
      Logical ft
      Character*4 DFTFOCK
      Integer dindex
      Real*8 dTot_d,ratio_d,Zeta_d
      Integer nAOs
      Real*8 P2_ontop_d(nP2_ontop,nGrad_Eff,mGrid)
      Integer ntot1
      Integer LOE_DB,LTEG_DB
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Logical Debug_Save
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 112
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*        Initializing MCPDFT global variable                           *
************************************************************************
*                                                                      *
      l_casdft = KSDFA(1:5).eq.'TLSDA'   .or.
     &           KSDFA(1:6).eq.'TLSDA5'  .or.
     &           KSDFA(1:5).eq.'TBLYP'   .or.
     &           KSDFA(1:6).eq.'TSSBSW'  .or.
     &           KSDFA(1:5).eq.'TSSBD'  .or.
     &           KSDFA(1:5).eq.'TS12G'  .or.
     &           KSDFA(1:4).eq.'TPBE'    .or.
     &           KSDFA(1:5).eq.'FTPBE'   .or.
     &           KSDFA(1:7).eq.'TREVPBE' .or.
     &           KSDFA(1:8).eq.'FTREVPBE'.or.
     &           KSDFA(1:6).eq.'FTLSDA'  .or.
     &           KSDFA(1:5).eq.'TOPBE'   .or.
     &           KSDFA(1:6).eq.'FTOPBE'  .or.
     &           KSDFA(1:6).eq.'FTBLYP'
************************************************************************
#ifdef _DEBUGPRINT_
      Debug_Save=Debug
      Debug=Debug.or.iPrint.ge.99
*
      If (Debug) Then
         Write (6,*) ' In Do_Batch'
         Write (6,*) ' nRho=',nRho
         Write (6,*) 'Grid=',DDot_(mGrid,Grid(1,1),3,Grid(1,1),3),
     &                       DDot_(mGrid,Grid(2,1),3,Grid(2,1),3),
     &                       DDot_(mGrid,Grid(3,1),3,Grid(3,1),3),
     &                       DDot_(mGrid,Weights  ,1,Weights  ,1), mGrid
      End If
#endif
*                                                                      *
      mRho=-1
      thrsrho=1.0d-15
      thrsrho2=1.0d-15
      thrsrho3=0.9000000000d0
      thrsrho4=1.1500000000d0
      thrspi = 1.0d-15
      Ab1=-4.756065601d+2
      Bb1=-3.794733192d+2
      Cb1=-8.538149682d+1
      l_tanhr=.false.

      If (Functional_Type.eq.CASDFT_Type) Then
         mRho = nP2_ontop
      Else If(DFTFOCK.eq.'DIFF'.and.nD.eq.2) Then
         mRho = nRho/nD
      Else If(l_casdft) then !GLM
      mRho = nP2_ontop
      End If
*
      If (mRho.ne.-1) Then
         Call GetMem('Rho_I','Allo','Real',ipRhoI,mGrid*mRho)
         Call GetMem('Rho_A','Allo','Real',ipRhoA,mGrid*mRho)
         call dcopy_(mGrid*mRho,[Zero],0 ,Work(ipRhoI), 1)
         call dcopy_(mGrid*mRho,[Zero],0 ,Work(ipRhoA), 1)
      Else
         ipRhoI = ip_Dummy
         ipRhoA = ip_Dummy
      End If
************************************************************************
*                                                                      *
      ipSOS=0 ! dummy initialize
*                                                                      *
************************************************************************
*                                                                      *
*---- Evaluate the AOs on the grid points.                             *
*                                                                      *
************************************************************************
*
      Call FZero(TabAO,nTabAO)
c      write(6,*) 'nTabAO value in do_batch.f=', nTabAO
      UnPack=.False.
      If (NQ_Direct.eq.Off .and. (Grid_Status.eq.Use_Old .and.
     &      .Not.Do_Grad         .and.
     &    Functional_Type.eq.Old_Functional_Type)) Then
C        Write (*,*) 'Read from disk!'
*
*------- Retrieve the AOs from disc
*
C        Write (*,*) 'iDisk_Grid=',iDisk_Grid
         Call iDaFile(Lu_Grid,2,ipTabAO,2*(nlist_s+1),iDisk_Grid)
C        Write (*,*) 'ipTabAO(*,1)=',(ipTabAO(i,1),i=1,nlist_s+1)
C        Write (*,*) 'ipTabAO(*,2)=',(ipTabAO(i,2),i=1,nlist_s+1)
         mTabAO=ipTabAO(nlist_s+1,2)-1
C        Write (*,*) 'iDisk_Grid,mTabAO=',iDisk_Grid,mTabAO
         Call dDaFile(Lu_Grid,2,TabAO,mTabAO,iDisk_Grid)
C        Call RecPrt('TabAO from disk',' ',TabAO,1,mTabAO)
         Unpack=Packing.eq.On
*
      Else
*
*------- Generate the values of the AOs on the grid
*
         Call FZero(Work(ipMem),nMem)
         ipxyz=ipMem
*
         iOff = 1
         Do ilist_s=1,nlist_s
            ish=list_s(1,ilist_s)

            iShll = iSD( 0,iSh)
            iAng  = iSD( 1,iSh)
            iCmp  = iSD( 2,iSh)
            iBas  = iSD( 3,iSh)
            iBas_Eff = List_Bas(1,ilist_s)
            iPrim = iSD( 5,iSh)
            iPrim_Eff=List_Exp(ilist_s)
            iAO   = iSD( 7,iSh)
            mdci  = iSD(10,iSh)
            iShell= iSD(11,iSh)
            iShll = iSD(0,iSh)
            iCnttp= iSD(13,iSh)
            iCnt  = iSD(14,iSh)
            A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
            nDrv     = mRad - 1
            nForm    = 0
            Do iDrv  = 0, nDrv
               nForm = nForm + nElem(iDrv)
            End Do
            nTerm    = 2**nDrv
            nAngular = 5*nForm*nTerm
            nxyz     = mGrid*3*(iAng+mRad)
            nRadial  = iBas_Eff*mGrid*mRad
            ipRadial = ipxyz + nxyz
            ipAng_   = ipRadial + nRadial
            ipAng    = ip_of_iWork_d(Work(ipAng_))
*
            iR=list_s(2,ilist_s)
*
            ipx=iPhase(1,iR)
            ipy=iPhase(2,iR)
            ipz=iPhase(3,iR)
            px=DBLE(iPhase(1,iR))
            py=DBLE(iPhase(2,iR))
            pz=DBLE(iPhase(3,iR))
            RA(1) = px*A(1)
            RA(2) = py*A(2)
            RA(3) = pz*A(3)
            iSym=NrOpr(iR)
#ifdef _DEBUGPRINT_
            If (debug) Write (6,*) 'mAO=',mAO
            If (iPrim_Eff.le.0 .or. iPrim_Eff.gt.iPrim) Then
               Call WarningMessage(2,'Do_batch: error in iPrim_Eff!')
               Write (6,*) '          iPrim=',iPrim
               Write (6,*) '          iPrim_Eff=',iPrim_Eff
               Call Abend()
            End If
#endif
*
*---------- Evaluate AOs at RA
*
#ifdef _DEBUGPRINT_
            iPrint_132=nPrint(132)
            If (Debug) nPrint(132)=99
#endif
            ipTabAO(iList_s,1)=iOff
*                                                                      *
c            write(6,*) 'iOff =', iOff
            Call AOEval(iAng,mGrid,Grid,Work(ipxyz),RA,
     &                  Shells(iShll)%Transf,
     &                  RSph(ipSph(iAng)),nElem(iAng),iCmp,
     &                  iWork(ipAng),nTerm,nForm,T_X,mRad,
     &                  iPrim,iPrim_Eff,Shells(iShll)%Exp,
     &                  Work(ipRadial),
     &                  iBas_Eff,
     &                  Shells(iShll)%pCff(1,iBas-iBas_Eff+1),
     &                  TabAO(iOff),
     &                  mAO,px,py,pz,ipx,ipy,ipz)
            iOff = iOff + mAO*mGrid*iBas_Eff*iCmp
#ifdef _DEBUGPRINT_
            nPrint(132)=iPrint_132
#endif
*
         End Do
*                write(6,*) 'AOValue in do_batch:'
*         write(6,'(10G20.10)') (TabAO(i),i=1,nTabAO)
         ipTabAO(nList_s+1,1)=iOff
*
*        AOs are packed and written to disk.
*
         If (NQ_Direct.eq.Off .and. (Grid_Status.eq.Regenerate .and.
     &       .Not.Do_Grad)) Then
*
            If (Packing.eq.On) Then
               Unpack=.True.
*
*------------- Pack before they are put on disc
*
               jOff = 1
               Do ilist_s=1,nlist_s
                  ish=list_s(1,ilist_s)
                  iCmp  = iSD( 2,iSh)
                  iBas  = iSD( 3,iSh)
                  iBas_Eff = List_Bas(1,ilist_s)
                  nData=mAO*mGrid*iBas_Eff*iCmp
*
*                 Check if we should store any AO's at all!
*
                  iOff = ipTabAO(ilist_s,1)
                  ix=iDAMax_(nData,TabAO(iOff),1)
                  AOMax=Abs(TabAO(iOff-1+ix))
                  If (AOMax.ge.T_X) Then
                     If (nData.gt.nTmp) Then
                        Call WarningMessage(2,'nData.gt.nTmp')
                        Call Abend()
                     End If
                     call dcopy_(nData,TabAO(iOff),1,Work(ipTmp),1)
                     Call PkR8(0,nData,nByte,Work(ipTmp),TabAO(jOff))
                     mData = (nByte+RtoB-1)/RtoB
                     If (mData.gt.nData) Then
                        Call WarningMessage(2,'mData.gt.nData')
                        Write (6,*) 'nData=',nData
                        Write (6,*) 'nData=',nData
                        Call Abend()
                     End If
                  Else
                     nByte=0
                     mData = 0
                  End If
                  ipTabAO(iList_s,2)=nByte
                  jOff = jOff + mData
               End Do
               ipTabAO(nList_s+1,2)=jOff
            Else
               ipTabAO(nList_s+1,2)=ipTabAO(nList_s+1,1)
            End If
*
            Call iDaFile(Lu_Grid,1,ipTabAO,2*(nlist_s+1),iDisk_Grid)
            mTabAO=ipTabAO(nList_s+1,2)-1
            Call dDaFile(Lu_Grid,1,TabAO,mTabAO,iDisk_Grid)
*
         End If
*
      End If
*
*---- Unpack AOs
*
      If (Unpack) Then
*
         jOff = ipTabAO(nlist_s+1,2)
         Do ilist_s=nlist_s,1,-1
            ish=list_s(1,ilist_s)
            iCmp  = iSD( 2,iSh)
            iBas  = iSD( 3,iSh)
            iBas_Eff = List_Bas(1,ilist_s)
            nData=mAO*mGrid*iBas_Eff*iCmp
            nByte=ipTabAO(ilist_s,2)
*
            iOff = ipTabAO(ilist_s,1)
            If (nByte.gt.0) Then
               mData = (nByte+RtoB-1)/RtoB
               jOff = jOff - mData
               If (mData.gt.nTmp) Then
                  Call WarningMessage(2,'mData.gt.nTmp')
                  Call Abend()
               End If
               Call UpkR8(0,nData,nByte,TabAO(jOff),Work(ipTmp))
               call dcopy_(nData,Work(ipTmp),1,TabAO(iOff),1)
            Else
               mData=0
               Call FZero(TabAO(iOff),nData)
            End If
         End Do
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Evaluate some MOs on the grid                                    *
*                                                                      *
************************************************************************
*                                                                      *
      If (Do_MO) Then
         Call FZero(TabMO,mAO*mGrid*nMOs)
         Call FZero(TabSO,mAO*mGrid*nMOs)
*
         Do ilist_s=1,nlist_s
            ish=list_s(1,ilist_s)
            iCmp  = iSD( 2,iSh)
            iBas  = iSD( 3,iSh)
            iBas_Eff = List_Bas(1,ilist_s)
            iPrim = iSD( 5,iSh)
            iAO   = iSD( 7,iSh)
            mdci  = iSD(10,iSh)
            iShell= iSD(11,iSh)
*
*---------- Allocate memory for SO and MO
*
cGLM            kAO   = iCmp*iBas_Eff*mGrid
            kAO   = iCmp*iBas*mGrid
            nDeg  = nSym/dc(mdci)%nStab
            nSO   = kAO*nDeg*mAO
            ipSOs = ipMem
            Call FZero(Work(ipSOs),nSO)
*
            iR=list_s(2,ilist_s)
            iSym=NrOpr(iR)
*
*---------- Distribute contributions of AOs if this particular shell
*           on to the SOs of this shell. The SOs are only stored
*           temporarily!
*
            Call SOAdpt_NQ(TabAO(ipTabAO(iList_s,1)),mAO,mGrid,iBas,
     &                  iBas_Eff,iCmp,iSym,Work(ipSOs),nDeg,iAO)
*
            Call GetMem('TmpCM','Allo','Real',ipTmpCMO,nCMO)
            Call GetMem('TDoIt','Allo','Inte',ipTDoIt,nMOs)
            Call  SODist2(Work(ipSOs),mAO,mGrid,iBas,
     &                   iCmp,nDeg,TabSO,
     &                   nMOs,iAO,Work(ipTmpCMO),
     &                   nCMO,iWork(ipTDoIt))
            Call GetMem('TmpCM','Free','Real',ipTmpCMO,nCMO)
            Call GetMem('TDoIt','Free','Inte',ipTDoIt,nMOs)
*
            Call  SODist(Work(ipSOs),mAO,mGrid,iBas,iCmp,nDeg,TabMO,
     &                  nMOs,iAO,CMOs,nCMO,DoIt)
*
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute density and grad_density
*                                                                      *
************************************************************************
*                                                                      *
      If (Functional_type.eq.LDA_type) Then
*
         Call Rho_LDA(Dens,nDens,nD,Rho,nRho,mGrid,
     &                list_s,nlist_s,TabAO,ipTabAO,mAO,nTabAO,nSym,
     &                Work(ip_Fact),ndc,Work(ipTabAOMax),
     &                list_bas,Index,nIndex)
*
         If (Do_Grad)
     &      Call dRho_dR_LDA(Dens,nDens,nD,dRho_dR,ndRho_dr,
     &                       mGrid,list_s,nlist_s,
     &                       TabAO,ipTabAO,mAO,nTabAO,nSym,
     &                       nGrad_Eff,list_g,Maps2p,
     &                       nShell,Grid_Type,Fixed_Grid,
     &                       Work(ip_Fact),ndc,Work(ipTmp),T_X,
     &                       list_bas,Index,nIndex)

**************************************************************************
* TLSDA,TLSDA5                                                           *
**************************************************************************
       If(KSDFA(1:5).eq.'TLSDA'.or.KSDFA(1:6).eq.'TLSDA5') then !GLM
        if(Debug) write(6,*) 'in do_batch.f for TLSDA option'

**************************************************************************
* Comp_d is a function to integrate densities or gradients or whatever...*
* as long as it is worth integrating it.. to the limit of a horse! hehe  *
* iSwitch (last entry) will dictate what quantity will be integrated:    *
*  iSwitch = 0  total density                                            *
*  iSwitch = 1  alpha density                                            *
*  iSwitch = 2  beta density                                             *
*  ......                                                                *
*  iSwitch = 10 the horse!                                               *
**************************************************************************
        T_Rho=T_X*1.0D-4
        Dens_t1=Dens_t1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,0)
        Dens_a1=Dens_a1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,1)
        Dens_b1=Dens_b1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,2)
**************************************************************************
         Call Fzero(P2_ontop,nP2_ontop*mGrid)
       If (.not.Do_Grad) then !regular MO-based run

         Call Do_P2glm(P2mo,np2act,D1mo,nd1mo,TabMO,mAO,mGrid,
     &                 nMOs,P2_ontop,nP2_ontop,Work(ipRhoI),
     &                 Work(ipRhoA),mRho,Do_Grad)

       Else !AO-based run for gradients
         nP2_ontop_d = nP2_ontop*mGrid*nGrad_Eff
         P2_ontop_d(:,:,:) = 0
         !Determine number of AOs:
         nAOs = nMOs
      ft=.false.
        Call  Do_P2GLM_grad(TabAO,nTabAO,mAO,mGrid,ipTabAO,
     &          P2_ontop,nP2_ontop,Do_Grad,nGrad_Eff,
     &          list_s,nlist_s,list_bas,Index,nIndex,
     &          P2mo,np2act,D1mo,nd1mo,TabMO,list_g,P2_ontop_d,
     &      Work(ipRhoI),Work(ipRhoA),mRho,nMOs,CMOs,nAOs,nCMO,
     &      TabSO,nsym,ft)
       End If

       If(.not.Do_Grad) then
         do iGrid=0,mGrid-1
          dTot=Rho(1,iGrid+1)+Rho(2,iGrid+1)
          ratio = 0.0d0
            write(LuMT,'(3(F10.6,A),5(F17.10,A))')
     &       Grid(1,iGrid+1),',',
     &       Grid(2,iGrid+1),',',
     &       Grid(3,iGrid+1),',',
     &       Rho(1,iGrid+1)*Weights(iGrid+1),',',
     &       Rho(2,iGrid+1)*Weights(iGrid+1),',',
     &       dTot*Weights(iGrid+1),',',
     &       Weights(iGrid+1),',',
     &       dTot
cGLM          if(dTot.ge.thrsrho.and.P2_ontop(1,iGrid+1).ge.thrsrho) then
          if(dTot.ge.thrsrho) then
            ratio = 4.0d0*P2_ontop(1,iGrid+1)/(dTot**2.0d0)
            if(l_tanhr) ratio = tanh(ratio)
            if((1.0d0-ratio).gt.thrsrho2) then
             Zeta  = sqrt(1.0d0-ratio)
* Compute alpha and beta densities when ratio < 1
             Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
             Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
            else
             Zeta  = 0.0d0
* Compute alpha and beta densities when ratio > 1
             Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
             Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
            end if
*           ^ end conditional on ratio values
* Compute gradients
          end if
*         ^ end if for little rho
          write(LuMC,'(3(F10.6,A),7(F17.10,A))')
     &          Grid(1,iGrid+1),',',
     &          Grid(2,iGrid+1),',',
     &          Grid(3,iGrid+1),',',
     &          Rho(1,iGrid+1)*Weights(iGrid+1),',',
     &          Rho(2,iGrid+1)*Weights(iGrid+1),',',
     &          dTot*Weights(iGrid+1),',',
     &          Weights(iGrid+1),',',
     &          dTot,',',
     &          P2_ontop(1,iGrid+1),',',
     &          ratio
         end do
*        ^ end loop over grid points
       Else !GRADIENT CALCULATION
           do iGrid=0,mGrid-1
           dTot=Rho(1,iGrid+1)+Rho(2,iGrid+1)
            do dindex=1,nGrad_Eff
              dTot_d=dRho_dr(1,iGrid+1,dindex)+dRho_dr(2,iGrid+1,dindex)
              ratio = 0.0d0
              ratio_d = 0.0d0
cGLM           if(dTot.ge.thrsrho.and.P2_ontop(1,iGrid+1).ge.thrsrho) then
           if(dTot.ge.thrsrho) then
             ratio = 4.0d0*P2_ontop(1,iGrid+1)/(dTot**2.0d0)
             ratio_d = 4.0d0*P2_ontop_d(1,dindex,iGrid+1)/(dTot**2.0d0)
     &                - 8*P2_ontop(1,iGrid+1)*dTot_d/(dTot**3.0d0)

             if((1.0d0-ratio).gt.thrsrho2) then
              Zeta  = sqrt(1.0d0-ratio)
              Zeta_d = -ratio_d/(2*Zeta)

* Compute alpha and beta densities
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0

              dRho_dr(1,iGrid+1,dindex) =
     &        Zeta_d*dTot/2.0d0+(1.0d0+Zeta)*dTot_d/2.0d0
              dRho_dr(2,iGrid+1,dindex) =
     &        -Zeta_d*dTot/2.0d0+(1.0d0-Zeta)*dTot_d/2.0d0

             else
              Zeta  = 0.0d0
              Zeta_d  = 0.0d0

              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
              dRho_dr(1,iGrid+1,dindex)= dTot_d/2.0d0
              dRho_dr(2,iGrid+1,dindex)= dTot_d/2.0d0


             end if
           end if
            end do!ngrad_eff
#ifdef _DEBUGPRINT_
          !if(dTot.ge.thrsrho.and.P2_ontop(1,iGrid+1).ge.thrsrho) then
!         write(*,*) Grid(1,iGrid+1),Grid(2,iGrid+1),Grid(3,iGrid+1)
          if(Grid(1,iGrid+1).eq.0d0.and.
     &    Grid(2,iGrid+1).eq.0d0) then
          write(97,'(3F12.6,12E12.4)')
     &(Grid(i,iGrid+1),i=1,3),dRho_dr(1,iGrid+1,6),dRho_dr(1,iGrid+1,9),
     &dRho_dr(2,iGrid+1,6),dRho_dr(2,iGrid+1,9),p2_ontop_d(1,6,iGrid+1),
     &p2_ontop_d(1,9,iGrid+1),
     &dTot,dTot_d,Rho(1,iGrid+1),Rho(2,iGrid+1),Zeta,p2_ontop(1,iGrid+1)
          write(98,'(3F12.6,12E12.4)')
     &Grid(1,iGrid+1),-Grid(2,iGrid+1),-Grid(3,iGrid+1),
     &dRho_dr(1,iGrid+1,6),dRho_dr(1,iGrid+1,9),
     &dRho_dr(2,iGrid+1,6),dRho_dr(2,iGrid+1,9),
     &-p2_ontop_d(1,6,iGrid+1),-p2_ontop_d(1,9,iGrid+1),
     &dTot,dTot_d,Rho(1,iGrid+1),Rho(2,iGrid+1),Zeta,p2_ontop(1,iGrid+1)
          end if
          !end if
#endif

!          write(LuMC,'(3F12.6,5E12.4)')
!     &(Grid(i,iGrid+1),i=1,3),Rho(1,iGrid+1),
!     &Rho(2,iGrid+1),dTot,P2_ontop_d(1,iGrid+1),ratio
           end do!igrid
       End if !not gradient or gradient
       End if !tlsda
#ifdef _DEBUGPRINT_
!       Close(97)
!       Close(98)
#endif


cRKCft
************************************************************************
* FTLSDA                                                               *
************************************************************************

       If(KSDFA(1:6).eq.'FTLSDA') then !GLM

         T_Rho=T_X*1.0D-4
         Dens_t1=Dens_t1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,0)
         Dens_a1=Dens_a1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,1)
         Dens_b1=Dens_b1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,2)

         Call Fzero(P2_ontop,nP2_ontop*mGrid)
       If (.not.Do_Grad) then !regular MO-based run
         Call Do_P2glm(P2mo,np2act,D1mo,nd1mo,TabMO,mAO,mGrid,
     &                 nMOs,P2_ontop,nP2_ontop,Work(ipRhoI),
     &                 Work(ipRhoA),mRho,Do_Grad)

!      Call Do_P2GLM_AO(P2AO,np2AO,TabAO,mAO,mGrid,nAOs,
!     &          P2_ontop,nP2_ontop,Do_Grad,nGrad_Eff,
!     &          list_s,nlist_s,list_bas,Index,nIndex)


       Else !AO-based run for gradients
!        write(*,*) 'nlist_s',nlist_s
         nP2_ontop_d = nP2_ontop*mGrid*nGrad_Eff
!         Call GetMem('P2_ontop_d','Allo','Real',ipP2_d,nP2_ontop_d)
!         Call FZero(Work(ipP2_d),nP2_ontop_d)
         P2_ontop_d(:,:,:) = 0
         !Determine number of AOs:
         nAOs = nMOs
      ft=.true.
        Call  Do_P2GLM_grad(TabAO,nTabAO,mAO,mGrid,ipTabAO,
     &          P2_ontop,nP2_ontop,Do_Grad,nGrad_Eff,
     &          list_s,nlist_s,list_bas,Index,nIndex,
     &          P2mo,np2act,D1mo,nd1mo,TabMO,list_g,P2_ontop_d,
     &      Work(ipRhoI),Work(ipRhoA),mRho,nMOs,CMOs,nAOs,nCMO,
     &      TabSO,nsym,ft)
       End If

         If(.not.Do_Grad) then
          do iGrid=0,mGrid-1
           dTot=Rho(1,iGrid+1)+Rho(2,iGrid+1)
           ratio = 0.0d0
           write(LuMT,'(3(F10.6,A),5(F17.10,A))')
     &       Grid(1,iGrid+1),',',
     &       Grid(2,iGrid+1),',',
     &       Grid(3,iGrid+1),',',
     &       Rho(1,iGrid+1)*Weights(iGrid+1),',',
     &       Rho(2,iGrid+1)*Weights(iGrid+1),',',
     &       dTot*Weights(iGrid+1),',',
     &       Weights(iGrid+1),',',
     &       dTot
cGLM       if(dTot.ge.thrsrho.and.P2_ontop(1,iGrid+1).ge.thrsrho) then
           if(dTot.ge.thrsrho) then
             ratio = 4.0d0*P2_ontop(1,iGrid+1)/(dTot**2.0d0)
             if(((1.0d0-ratio).gt.thrsrho2).and.(ratio.lt.thrsrho3))then
              Zeta  = sqrt(1.0d0-ratio)
* Compute alpha and beta densities
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
             end if
*           ^ end if
              if((ratio.ge.thrsrho3).and.(ratio.le.thrsrho4)) then
                Zeta = (Ab1*(ratio-1.15d0)**5.0d0) +
     &         (Bb1*(ratio-1.15d0)**4.0d0) + (Cb1*(ratio-1.15d0)**3.0d0)
* Compute alpha and beta densities
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
             end if
*         ^ end if over spline
              if (ratio.gt.thrsrho4) then
              Zeta  = 0.0d0
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
             end if
           end if
*         ^ end if for little rho
          write(LuMC,'(3(F10.6,A),7(F17.10,A))')
     &          Grid(1,iGrid+1),',',
     &          Grid(2,iGrid+1),',',
     &          Grid(3,iGrid+1),',',
     &          Rho(1,iGrid+1)*Weights(iGrid+1),',',
     &          Rho(2,iGrid+1)*Weights(iGrid+1),',',
     &          dTot*Weights(iGrid+1),',',
     &          Weights(iGrid+1),',',
     &          dTot,',',
     &          P2_ontop(1,iGrid+1),',',
     &          ratio
          end do

!******************************************************************
         Else !Gradient calculation
!           do i=1,nP2_ontop_d
!             write(*,*) Work(ipP2_d-1+i)
!           end do
!         Call Fzero(Work(ipP2_d),mGrid*nGrad_Eff)
           do iGrid=0,mGrid-1
!      if(.false.)then
           dTot=Rho(1,iGrid+1)+Rho(2,iGrid+1)
            do dindex=1,nGrad_Eff
              dTot_d=dRho_dr(1,iGrid+1,dindex)+dRho_dr(2,iGrid+1,dindex)
              ratio = 0.0d0
              ratio_d = 0.0d0
cGLM      if(dTot.ge.thrsrho.and.P2_ontop(1,iGrid+1).ge.thrsrho) then
           if(dTot.ge.thrsrho) then
             ratio = 4.0d0*P2_ontop(1,iGrid+1)/(dTot**2.0d0)
!             ratio_d= 4.0d0*P2_ontop_d(dindex,iGrid+1)/(dTot**2.0d0)
!             ratio_d=4.0d0*Work(ipP2_d - 1 +
!     &               (dindex-1)*mGrid+iGrid)/(dTot**2.0d0)
              ratio_d = 4*P2_ontop_d(1,dindex,iGrid+1)/(dTot**2.0d0)
     &                - 8*P2_ontop(1,iGrid+1)*dTot_d/(dTot**3.0d0)
!             ratio_d= 0


             if(((1.0d0-ratio).gt.thrsrho2).and.(ratio.lt.thrsrho3))then
              Zeta  = sqrt(1.0d0-ratio)
              Zeta_d = -ratio_d/(2*Zeta)

* Compute alpha and beta densities
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0

              dRho_dr(1,iGrid+1,dindex) =
     &        Zeta_d*dTot/2.0d0+(1.0d0+Zeta)*dTot_d/2.0d0
              dRho_dr(2,iGrid+1,dindex) =
     &        -Zeta_d*dTot/2.0d0+(1.0d0-Zeta)*dTot_d/2.0d0

             end if

!      end if
              if((ratio.ge.thrsrho3).and.(ratio.le.thrsrho4)) then
                Zeta = (Ab1*(ratio-1.15d0)**5.0d0) +
     &         (Bb1*(ratio-1.15d0)**4.0d0) + (Cb1*(ratio-1.15d0)**3.0d0)
                Zeta_d = 5*Ab1*(ratio-1.15d0)**4 * ratio_d
     &        + 4*Bb1*(ratio-1.15d0)**3 * ratio_d
     &        + 3*Cb1*(ratio-1.15d0)**2 * ratio_d

* Compute alpha and beta densities
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
              dRho_dr(1,iGrid+1,dindex) =
     &        Zeta_d*dTot/2.0d0+(1.0d0+Zeta)*dTot_d/2.0d0
              dRho_dr(2,iGrid+1,dindex) =
     &        -Zeta_d*dTot/2.0d0+(1.0d0-Zeta)*dTot_d/2.0d0

             end if
*         ^ end if over spline
              if (ratio.gt.thrsrho4) then
              Zeta  = 0.0d0
              Zeta_d  = 0.0d0

              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
              dRho_dr(1,iGrid+1,dindex)= dTot_d/2.0d0
              dRho_dr(2,iGrid+1,dindex)= dTot_d/2.0d0
             end if
           end if
*          ^ end if for little rho
          write(LuMC,'(3(F10.6,A),7(F17.10,A))')
     &          Grid(1,iGrid+1),',',
     &          Grid(2,iGrid+1),',',
     &          Grid(3,iGrid+1),',',
     &          Rho(1,iGrid+1)*Weights(iGrid+1),',',
     &          Rho(2,iGrid+1)*Weights(iGrid+1),',',
     &          dTot*Weights(iGrid+1),',',
     &          Weights(iGrid+1),',',
     &          dTot,',',
     &          P2_ontop(1,iGrid+1),',',
     &          ratio
          end do!loop over effective coordinates
          end do!loop over gridpts
!         Call GetMem('P2_ontop_d','Free','Real',ipP2_d,mGrid*nGrad_Eff)
         End If!Gradient calculation

*        ^ end loop over grid points
c         write(6,*)'spinDens aft on-top density'
c         do iGrid=1,mGrid
c           write(6,'(2E12.6)') Rho(1,iGrid), Rho(2,iGrid)
c         end do
       End if


*      ^ end if for GLM stuff
C        If (Do_Hess)
C    &      Call d2Rho_dR2_LDA(Dens,nDens,nD,dRho_dR,d2Rho_dr2,
C    &                         ndRho_dr,mGrid,list_s,nlist_s,
C    &                         TabAO,ipTabAO,mAO,nTabAO,nSym,
C    &                         nGrad_Eff,list_g,Maps2p,
C    &                         nShell,Grid_Type,Fixed_Grid,
C    &                         Work(ip_Fact),ndc,Work(ipTmp),T_X,
C    &                         list_bas,Index,nIndex)
*
      Else If (Functional_type.eq.GGA_type) Then
*
         Call Rho_GGA(Dens,nDens,nD,Rho,nRho,mGrid,
     &                list_s,nlist_s,TabAO,ipTabAO,mAO,nTabAO,nSym,
     &                Work(ip_Fact),ndc,Work(ipTabAOMax),
     &                list_bas,Index,nIndex)
*
         If (Do_Grad)
     &      Call dRho_dR_GGA(Dens,nDens,nD,dRho_dR,ndRho_dr,
     &                       mGrid,list_s,nlist_s,
     &                       TabAO,ipTabAO,mAO,nTabAO,nSym,
     &                       nGrad_Eff,list_g,Maps2p,
     &                       nShell,Grid_Type,Fixed_Grid,
     &                       Work(ip_Fact),ndc,Work(ipTmp),T_X,
     &                       list_bas,Index,nIndex)

************************************************************************
* TBLYP,TPBE,TREVPBE,TSSBSW,TSSBD,TS12G                                *
************************************************************************

      if(KSDFA(1:5).eq.'TBLYP'.or. !GLM
     &   KSDFA(1:4).eq.'TPBE'.or.
     &   KSDFA(1:6).eq.'TSSBSW'.or.
     &   KSDFA(1:5).eq.'TSSBD'.or.
     &   KSDFA(1:5).eq.'TS12G'.or.
     &   KSDFA(1:5).eq.'TOPBE'.or.
     &   KSDFA(1:7).eq.'TREVPBE') then
*  iSwitch = 0  total density
*  iSwitch = 1  alpha density
*  iSwitch = 2  beta density
        T_Rho=T_X*1.0D-4
        Dens_t1=Dens_t1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,0)
        Dens_a1=Dens_a1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,1)
        Dens_b1=Dens_b1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,2)
c        write(6,*) 'in do_batch.f for GLM=GGA options'
C         If (Do_MO) Then
C            Call Do_RhoIA(nRho,mGrid,Rho,Work(ipRhoI),
C     &                    Work(ipRhoA),mRho,TabMO,mAO,
C     &                    nMOs,D1mo,nd1mo)
C         Else
C            Call WarningMessage(2,' We need MO for RhoIA')
C            Call Abend()
C         End If

         Call Fzero(P2_ontop,nP2_ontop*mGrid)
       If (.not.Do_Grad) then !regular MO-based run
         Call Do_P2glm(P2mo,np2act,D1mo,nd1mo,TabMO,mAO,mGrid,
     &                 nMOs,P2_ontop,nP2_ontop,Work(ipRhoI),
     &                 Work(ipRhoA),mRho,Do_Grad)
       Else !AO-based run for gradients
         nP2_ontop_d = nP2_ontop*mGrid*nGrad_Eff
         P2_ontop_d(:,:,:) = 0
         !Determine number of AOs:
         nAOs = nMOs
      ft=.false.
        Call  Do_P2GLM_grad(TabAO,nTabAO,mAO,mGrid,ipTabAO,
     &          P2_ontop,nP2_ontop,Do_Grad,nGrad_Eff,
     &          list_s,nlist_s,list_bas,Index,nIndex,
     &          P2mo,np2act,D1mo,nd1mo,TabMO,list_g,P2_ontop_d,
     &      Work(ipRhoI),Work(ipRhoA),mRho,nMOs,CMOs,nAOs,nCMO,
     &      TabSO,nsym,ft)
       End If


c         write(6,*) 'X -- Y -- Z -- P2 -- gradX -- gradY -- gradZ'
c         do iGrid=1,mGrid
c             write(6,'(3F8.3,4E12.4)') (Grid(i,iGrid),i=1,3),
c     &       P2_ontop(1,iGrid),
c     &       P2_ontop(2,iGrid),P2_ontop(3,iGrid),P2_ontop(4,iGrid)
c         end do

C         write(6,*)'X Y Z d_a d_b grXa grYa grZa grXb grYb grZb bf P2'
C         do iGrid=1,mGrid
C           write(6,'(3F8.3,8E12.4)')
C     &           (Grid(i,iGrid),i=1,3),(Rho(j,iGrid),j=1,8)
C         end do
c         write(6,*) 'thrsrho', thrsrho
c         write(6,*) 'thrsrho2', thrsrho2

       If(.not.Do_Grad) then
         do iGrid=0,mGrid-1
          dTot=Rho(1,iGrid+1)+Rho(2,iGrid+1)
          grad_x = Rho(3,iGrid+1)+Rho(6,iGrid+1)
          grad_y = Rho(4,iGrid+1)+Rho(7,iGrid+1)
          grad_z = Rho(5,iGrid+1)+Rho(8,iGrid+1)
          ratio = 0.0d0
          write(LuMT,'(3(F10.6,A),5(F17.10,A))')
     &       Grid(1,iGrid+1),',',
     &       Grid(2,iGrid+1),',',
     &       Grid(3,iGrid+1),',',
     &       Rho(1,iGrid+1)*Weights(iGrid+1),',',
     &       Rho(2,iGrid+1)*Weights(iGrid+1),',',
     &       dTot*Weights(iGrid+1),',',
     &       Weights(iGrid+1),',',
     &       dTot
cGLM       if(dTot.ge.thrsrho.and.abs(P2_ontop(1,iGrid+1)).ge.
cGLM     &                               0.25*thrsrho**3.0d0)then
          if(dTot.ge.thrsrho) then
            ratio = 4.0d0*P2_ontop(1,iGrid+1)/(dTot**2.0d0)
            if(l_tanhr) ratio = tanh(ratio)
            if((1.0d0-ratio).gt.thrsrho2) then
             Zeta  = sqrt(1.0d0-ratio)
             pi_p_x = (1.0d0 - zeta**2.0d0)*dTot*grad_x/2.0d0
             pi_p_y = (1.0d0 - zeta**2.0d0)*dTot*grad_y/2.0d0
             pi_p_z = (1.0d0 - zeta**2.0d0)*dTot*grad_z/2.0d0
* Compute alpha and beta densities for ratio < 1
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
* Compute  gradients
*              write(6,*) 'zeta, ratio, dTot',Zeta, ratio, dTot
*              write(6,*) 'Rho_grad = ', grad_x, grad_y, grad_z
*              write(6,*) 'P2_grad  = ',
*     &     P2_ontop(2,iGrid+1),P2_ontop(3,iGrid+1),P2_ontop(4,iGrid+1)
c              write(6,*) 'P2_p-pi_p =', P2_ontop(2,iGrid+1)-pi_p_x,
c     &        P2_ontop(3,iGrid+1)-pi_p_y, P2_ontop(4,iGrid+1)-pi_p_z
*              write(6,*) 'Old Rho = ',
*     &        Rho(3,iGrid+1),Rho(4,iGrid+1),Rho(5,iGrid+1),
*     &        Rho(6,iGrid+1),Rho(7,iGrid+1),Rho(8,iGrid+1)
        if(l_tanhr) then
          Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
     &    + ((ratio**2.0d0 - 1.0d0)
     &    *(P2_ontop(2,iGrid+1)-(grad_x*4.0d0*P2_ontop(1,iGrid+1)/dTot))
     &    /(dTot*zeta))
c
          Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
     &    + ((ratio**2.0d0 - 1.0d0)
     &    *(P2_ontop(3,iGrid+1)-(grad_y*4.0d0*P2_ontop(1,iGrid+1)/dTot))
     &    /(dTot*zeta))
c
          Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
     &    + ((ratio**2.0d0 - 1.0d0)
     &    *(P2_ontop(4,iGrid+1)-(grad_z*4.0d0*P2_ontop(1,iGrid+1)/dTot))
     &    /(dTot*zeta))
c
          Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
     &    - ((ratio**2.0d0 - 1.0d0)
     &    *(P2_ontop(2,iGrid+1)-(grad_x*4.0d0*P2_ontop(1,iGrid+1)/dTot))
     &    /(dTot*zeta))
c
          Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
     &    - ((ratio**2.0d0 - 1.0d0)
     &    *(P2_ontop(3,iGrid+1)-(grad_y*4.0d0*P2_ontop(1,iGrid+1)/dTot))
     &    /(dTot*zeta))
c
          Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0
     &    - ((ratio**2.0d0 - 1.0d0)
     &    *(P2_ontop(4,iGrid+1)-(grad_z*4.0d0*P2_ontop(1,iGrid+1)/dTot))
     &    /(dTot*zeta))
        else
              Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
*     &                         + ratio*grad_x/(2.0d0*Zeta)
*     &                         - P2_ontop(2,iGrid+1)/(dTot*Zeta)
              Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
*     &                         + ratio*grad_y/(2.0d0*Zeta)
*     &                         - P2_ontop(3,iGrid+1)/(dTot*Zeta)
              Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
*     &                         + ratio*grad_z/(2.0d0*Zeta)
*     &                         - P2_ontop(4,iGrid+1)/(dTot*Zeta)
              Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
*     &                         - ratio*grad_x/(2.0d0*Zeta)
*     &                         + P2_ontop(2,iGrid+1)/(dTot*Zeta)
              Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
*     &                         - ratio*grad_y/(2.0d0*Zeta)
*     &                         + P2_ontop(3,iGrid+1)/(dTot*Zeta)
              Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0
*     &                         - ratio*grad_z/(2.0d0*Zeta)
*     &                         + P2_ontop(4,iGrid+1)/(dTot*Zeta)
        end if ! End tanh option
*              write(6,*) 'New Rho = ',
*     &        Rho(3,iGrid+1),Rho(4,iGrid+1),Rho(5,iGrid+1),
*     &        Rho(6,iGrid+1),Rho(7,iGrid+1),Rho(8,iGrid+1)
           else
             Zeta  = 0.0d0
             pi_p_x = (1.0d0 - zeta**2.0d0)*dTot*grad_x/2.0d0
             pi_p_y = (1.0d0 - zeta**2.0d0)*dTot*grad_y/2.0d0
             pi_p_z = (1.0d0 - zeta**2.0d0)*dTot*grad_z/2.0d0
* Compute alpha and beta densities if ratio > 1
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
* Compute  gradients
              Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
              Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
              Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
              Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
              Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
              Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0
           end if
*          ^ end conditional regarding the ratio
          end if
*         ^ end if over little density
          write(LuMC,'(3(F10.6,A),7(F17.10,A))')
     &          Grid(1,iGrid+1),',',
     &          Grid(2,iGrid+1),',',
     &          Grid(3,iGrid+1),',',
     &          Rho(1,iGrid+1)*Weights(iGrid+1),',',
     &          Rho(2,iGrid+1)*Weights(iGrid+1),',',
     &          dTot*Weights(iGrid+1),',',
     &          Weights(iGrid+1),',',
     &          dTot,',',
     &          P2_ontop(1,iGrid+1),',',
     &          ratio
        end do!end loop over grid points

       Else !GRADIENT CALCULATION
           do iGrid=0,mGrid-1
           dTot=Rho(1,iGrid+1)+Rho(2,iGrid+1)
           grad_x = Rho(3,iGrid+1)+Rho(6,iGrid+1)
           grad_y = Rho(4,iGrid+1)+Rho(7,iGrid+1)
           grad_z = Rho(5,iGrid+1)+Rho(8,iGrid+1)
            do dindex=1,nGrad_Eff
              dTot_d=dRho_dr(1,iGrid+1,dindex)+dRho_dr(2,iGrid+1,dindex)
              dTot_dx=dRho_dr(3,iGrid+1,dindex)
     &               +dRho_dr(6,iGrid+1,dindex)
              dTot_dy=dRho_dr(4,iGrid+1,dindex)
     &               +dRho_dr(7,iGrid+1,dindex)
              dTot_dz=dRho_dr(5,iGrid+1,dindex)
     &               +dRho_dr(8,iGrid+1,dindex)
              ratio = 0.0d0
              ratio_d = 0.0d0
cGLM          if(P2_ontop(1,iGrid+1).lt.0.0d0) P2_ontop(1,iGrid+1)
cGLM     &                                           = 0.0d0
cGLM       if(dTot.ge.thrsrho.and.abs(P2_ontop(1,iGrid+1))
cGLM     &                           .ge.0.25*thrsrho**3.0d0) then
          if(dTot.ge.thrsrho) then
              ratio = 4.0d0*P2_ontop(1,iGrid+1)/(dTot**2.0d0)
              ratio_d = 4.0d0*P2_ontop_d(1,dindex,iGrid+1)/(dTot**2.0d0)
     &                - 8*P2_ontop(1,iGrid+1)*dTot_d/(dTot**3.0d0)

              if((1.0d0-ratio).gt.thrsrho2) then
               Zeta  = sqrt(1.0d0-ratio)
               Zeta_d = -ratio_d/(2*Zeta)

* Compute alpha and beta densities
               Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
               Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
               Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
               Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
               Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
               Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
               Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
               Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0

               dRho_dr(1,iGrid+1,dindex) =
     &         Zeta_d*dTot/2.0d0+(1.0d0+Zeta)*dTot_d/2.0d0
               dRho_dr(2,iGrid+1,dindex) =
     &         -Zeta_d*dTot/2.0d0+(1.0d0-Zeta)*dTot_d/2.0d0
               dRho_dr(3,iGrid+1,dindex) =
     &         Zeta_d*grad_x/2.0d0+(1.0d0+Zeta)*dTot_dx/2.0d0
               dRho_dr(4,iGrid+1,dindex) =
     &         Zeta_d*grad_y/2.0d0+(1.0d0+Zeta)*dTot_dy/2.0d0
               dRho_dr(5,iGrid+1,dindex) =
     &         Zeta_d*grad_z/2.0d0+(1.0d0+Zeta)*dTot_dz/2.0d0
               dRho_dr(6,iGrid+1,dindex) =
     &         -Zeta_d*grad_x/2.0d0+(1.0d0-Zeta)*dTot_dx/2.0d0
               dRho_dr(7,iGrid+1,dindex) =
     &         -Zeta_d*grad_y/2.0d0+(1.0d0-Zeta)*dTot_dy/2.0d0
               dRho_dr(8,iGrid+1,dindex) =
     &         -Zeta_d*grad_z/2.0d0+(1.0d0-Zeta)*dTot_dz/2.0d0
              else
               Zeta  = 0.0d0
               Zeta_d  = 0.0d0

               Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
               Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
               Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
               Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
               Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
               Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
               Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
               Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0

               dRho_dr(1,iGrid+1,dindex) =
     &         Zeta_d*dTot/2.0d0+(1.0d0+Zeta)*dTot_d/2.0d0
               dRho_dr(2,iGrid+1,dindex) =
     &         -Zeta_d*dTot/2.0d0+(1.0d0-Zeta)*dTot_d/2.0d0
               dRho_dr(3,iGrid+1,dindex) =
     &         Zeta_d*grad_x/2.0d0+(1.0d0+Zeta)*dTot_dx/2.0d0
               dRho_dr(4,iGrid+1,dindex) =
     &         Zeta_d*grad_y/2.0d0+(1.0d0+Zeta)*dTot_dy/2.0d0
               dRho_dr(5,iGrid+1,dindex) =
     &         Zeta_d*grad_z/2.0d0+(1.0d0+Zeta)*dTot_dz/2.0d0
               dRho_dr(6,iGrid+1,dindex) =
     &         -Zeta_d*grad_x/2.0d0+(1.0d0-Zeta)*dTot_dx/2.0d0
               dRho_dr(7,iGrid+1,dindex) =
     &         -Zeta_d*grad_y/2.0d0+(1.0d0-Zeta)*dTot_dy/2.0d0
               dRho_dr(8,iGrid+1,dindex) =
     &         -Zeta_d*grad_z/2.0d0+(1.0d0-Zeta)*dTot_dz/2.0d0
              end if!Threshrho_2
            end if!little density (threshrho)
          end do!ngrad_eff
        end do!gridpt
       end if!Gradient calculation
*       ^ end loop over grid points
c         write(6,*)'X Y Z spinDens and grad aft on-top density'
*         do iGrid=1,mGrid
*           write(6,'(3F8.3,3E12.4,4A)')
*     &           (Grid(i,iGrid),i=1,3),
*     &           Rho(1,iGrid), Rho(2,iGrid),(Rho(1,iGrid)+Rho(2,iGrid)),
*     &           '  ciao'
*         end do
*         do iGrid=1,mGrid
*            write(6,'(3F12.6,8E14.6,8A)')
*     &           (Grid(i,iGrid),i=1,3),
*     &           Rho(1,iGrid),Rho(2,iGrid),
*     &           Rho(3,iGrid),Rho(4,iGrid),Rho(5,iGrid),
*     &           Rho(6,iGrid),Rho(7,iGrid),Rho(8,iGrid),
*     &           ' after'
*         end do
      end if
*     ^ End if over GLM stuff
************************************************************************
* FTBLYP,FTPBE,FTREVPBE                                                *
************************************************************************
      if(KSDFA(1:6).eq.'FTBLYP'.or. !GLM
     &   KSDFA(1:5).eq.'FTPBE'.or.
     &   KSDFA(1:6).eq.'FTOPBE'.or.
     &   KSDFA(1:8).eq.'FTREVPBE') then
*  *
        T_Rho=T_X*1.0D-4
        Dens_t1=Dens_t1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,0)
        Dens_a1=Dens_a1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,1)
        Dens_b1=Dens_b1+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,2)

          Call Fzero(P2_ontop,nP2_ontop*mGrid)
       If (.not.Do_Grad) then !regular MO-based run
         Call Do_P2glm(P2mo,np2act,D1mo,nd1mo,TabMO,mAO,mGrid,
     &                 nMOs,P2_ontop,nP2_ontop,Work(ipRhoI),
     &                 Work(ipRhoA),mRho,Do_Grad)
       Else !AO-based run for gradients
         nP2_ontop_d = nP2_ontop*mGrid*nGrad_Eff
         P2_ontop_d(:,:,:) = 0
         !Determine number of AOs:
         nAOs = nMOs

      ft=.true.
        Call  Do_P2GLM_grad(TabAO,nTabAO,mAO,mGrid,ipTabAO,
     &          P2_ontop,nP2_ontop,Do_Grad,nGrad_Eff,
     &          list_s,nlist_s,list_bas,Index,nIndex,
     &          P2mo,np2act,D1mo,nd1mo,TabMO,list_g,P2_ontop_d,
     &      Work(ipRhoI),Work(ipRhoA),mRho,nMOs,CMOs,nAOs,nCMO,
     &      TabSO,nsym,ft)
       End If
*
       If(.not.Do_Grad) then
         do iGrid=0,mGrid-1
          dTot=Rho(1,iGrid+1)+Rho(2,iGrid+1)
          grad_x = Rho(3,iGrid+1)+Rho(6,iGrid+1)
          grad_y = Rho(4,iGrid+1)+Rho(7,iGrid+1)
          grad_z = Rho(5,iGrid+1)+Rho(8,iGrid+1)
          ratio = 0.0d0
          write(LuMT,'(3(F10.6,A),5(F17.10,A))')
     &       Grid(1,iGrid+1),',',
     &       Grid(2,iGrid+1),',',
     &       Grid(3,iGrid+1),',',
     &       Rho(1,iGrid+1)*Weights(iGrid+1),',',
     &       Rho(2,iGrid+1)*Weights(iGrid+1),',',
     &       dTot*Weights(iGrid+1),',',
     &       Weights(iGrid+1),',',
     &       dTot
cGLM      if(dTot.ge.thrsrho.and.P2_ontop(1,iGrid+1).ge.thrsrho) then
          if(dTot.ge.thrsrho) then
            ratio = 4.0d0*P2_ontop(1,iGrid+1)/(dTot**2.0d0)
            if(((1.0d0-ratio).gt.thrsrho2).and.(ratio.lt.thrsrho3)) then
             Zeta  = sqrt(1.0d0-ratio)
             pi_p_x = (1.0d0 - zeta**2.0d0)*dTot*grad_x/2.0d0
             pi_p_y = (1.0d0 - zeta**2.0d0)*dTot*grad_y/2.0d0
             pi_p_z = (1.0d0 - zeta**2.0d0)*dTot*grad_z/2.0d0
* Compute alpha and beta densities
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
* compute gradients
              Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
     &                         + ratio*grad_x/(2.0d0*Zeta)
     &                         - P2_ontop(2,iGrid+1)/(dTot*Zeta)
              Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
     &                         + ratio*grad_y/(2.0d0*Zeta)
     &                         - P2_ontop(3,iGrid+1)/(dTot*Zeta)
              Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
     &                         + ratio*grad_z/(2.0d0*Zeta)
     &                         - P2_ontop(4,iGrid+1)/(dTot*Zeta)
              Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
     &                         - ratio*grad_x/(2.0d0*Zeta)
     &                         + P2_ontop(2,iGrid+1)/(dTot*Zeta)
              Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
     &                         - ratio*grad_y/(2.0d0*Zeta)
     &                         + P2_ontop(3,iGrid+1)/(dTot*Zeta)
              Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0
     &                         - ratio*grad_z/(2.0d0*Zeta)
     &                         + P2_ontop(4,iGrid+1)/(dTot*Zeta)
*          ^ end if over unwanted ratios
            else if((ratio.ge.thrsrho3).and.(ratio.le.thrsrho4)) then

               Zeta = (Ab1*(ratio-1.15d0)**5.0d0) +
     &        (Bb1*(ratio-1.15d0)**4.0d0) + (Cb1*(ratio-1.15d0)**3.0d0)

             pi_p_x = (1.0d0 - zeta**2.0d0)*dTot*grad_x/2.0d0
             pi_p_y = (1.0d0 - zeta**2.0d0)*dTot*grad_y/2.0d0
             pi_p_z = (1.0d0 - zeta**2.0d0)*dTot*grad_z/2.0d0

* Compute alpha and beta densities

              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0

              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0

* Compute  gradients
               Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((10.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            - (5.0d0*ratio*grad_x))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((8.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            - (4.0d0*ratio*grad_x))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((6.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            - (3.0d0*ratio*grad_x))

               Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((10.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            - (5.0d0*ratio*grad_y))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((8.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            - (4.0d0*ratio*grad_y))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((6.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            - (3.0d0*ratio*grad_y))

               Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((10.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            - (5.0d0*ratio*grad_z))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((8.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            - (4.0d0*ratio*grad_z))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((6.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            - (3.0d0*ratio*grad_z))

               Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((-10.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            + (5.0d0*ratio*grad_x))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((-8.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            + (4.0d0*ratio*grad_x))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((-6.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            + (3.0d0*ratio*grad_x))

               Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((-10.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            + (5.0d0*ratio*grad_y))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((-8.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            + (4.0d0*ratio*grad_y))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((-6.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            + (3.0d0*ratio*grad_y))

              Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((-10.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            + (5.0d0*ratio*grad_z))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((-8.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            + (4.0d0*ratio*grad_z))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((-6.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            + (3.0d0*ratio*grad_z))

*         ^ end if over spline
           else if (ratio.gt.thrsrho4) then
             Zeta  = 0.0d0
* Compute alpha and beta densities
              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
* Compute  gradients
              Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
              Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
              Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
              Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
              Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
              Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0
           end if
*          ^ end if over zeta=0
          end if
*         ^ end if over little density
          write(LuMC,'(3(F10.6,A),7(F17.10,A))')
     &          Grid(1,iGrid+1),',',
     &          Grid(2,iGrid+1),',',
     &          Grid(3,iGrid+1),',',
     &          Rho(1,iGrid+1)*Weights(iGrid+1),',',
     &          Rho(2,iGrid+1)*Weights(iGrid+1),',',
     &          dTot*Weights(iGrid+1),',',
     &          Weights(iGrid+1),',',
     &          dTot,',',
     &          P2_ontop(1,iGrid+1),',',
     &          ratio
        end do
*       ^ end loop over grid points


        Else !GRADIENT CALCULATION
           do iGrid=0,mGrid-1
           dTot=Rho(1,iGrid+1)+Rho(2,iGrid+1)
           grad_x = Rho(3,iGrid+1)+Rho(6,iGrid+1)
           grad_y = Rho(4,iGrid+1)+Rho(7,iGrid+1)
           grad_z = Rho(5,iGrid+1)+Rho(8,iGrid+1)
            do dindex=1,nGrad_Eff
              dTot_d=dRho_dr(1,iGrid+1,dindex)+dRho_dr(2,iGrid+1,dindex)
              dTot_dx=dRho_dr(3,iGrid+1,dindex)
     &               +dRho_dr(6,iGrid+1,dindex)
              dTot_dy=dRho_dr(4,iGrid+1,dindex)
     &               +dRho_dr(7,iGrid+1,dindex)
              dTot_dz=dRho_dr(5,iGrid+1,dindex)
     &               +dRho_dr(8,iGrid+1,dindex)
              ratio = 0.0d0
              ratio_d = 0.0d0
cGLM        if(dTot.ge.thrsrho.and.P2_ontop(1,iGrid+1).ge.thrsrho) then
            if(dTot.ge.thrsrho) then
              ratio = 4.0d0*P2_ontop(1,iGrid+1)/(dTot**2.0d0)
              ratio_d = 4.0d0*P2_ontop_d(1,dindex,iGrid+1)/(dTot**2.0d0)
     &                - 8.0d0*P2_ontop(1,iGrid+1)*dTot_d/(dTot**3.0d0)
              ratio_dx = 4.0d0*P2_ontop(2,iGrid+1)/(dTot**2.0d0)
     &                   -2.0d0*ratio/dTot*grad_x
              ratio_dy = 4.0d0*P2_ontop(3,iGrid+1)/(dTot**2.0d0)
     &                   -2.0d0*ratio/dTot*grad_y
              ratio_dz = 4.0d0*P2_ontop(4,iGrid+1)/(dTot**2.0d0)
     &                   -2.0d0*ratio/dTot*grad_z
             d_ratiox = 4.0d0*P2_ontop_d(2,dindex,iGrid+1)/(dTot**2.0d0)
     &                 -8.0d0*P2_ontop(2,iGrid+1)*dTot_d/(dTot**3.0d0)
     &                 -2.0d0*ratio/dTot*dTot_dx
     &             -8.0d0*grad_x/(dtot**3)*P2_ontop_d(1,dindex,iGrid+1)
     &             +6d0*ratio*grad_x/(dtot**2) * dtot_d
!     &                 -2.0d0*grad_x/dTot*ratio_d
!     &                 +2.0d0*grad_x*ratio/(dTot**2.0d0)*dTot_d
             d_ratioy = 4.0d0*P2_ontop_d(3,dindex,iGrid+1)/(dTot**2.0d0)
     &                 -8.0d0*P2_ontop(3,iGrid+1)*dTot_d/(dTot**3.0d0)
     &                 -2.0d0*ratio/dTot*dTot_dy
     &             -8.0d0*grad_y/(dtot**3)*P2_ontop_d(1,dindex,iGrid+1)
     &             +6d0*ratio*grad_y/(dtot**2) * dtot_d
!     &                 -2.0d0*grad_y/dTot*ratio_d
!     &                 +2.0d0*grad_y*ratio/(dTot**2.0d0)*dTot_d
            d_ratioz = 4.0d0*P2_ontop_d(4,dindex,iGrid+1)/(dTot**2.0d0)
     &                 -8.0d0*P2_ontop(4,iGrid+1)*dTot_d/(dTot**3.0d0)
     &                 -2.0d0*ratio/dTot*dTot_dz
     &             -8.0d0*grad_z/(dtot**3)*P2_ontop_d(1,dindex,iGrid+1)
     &             +6d0*ratio*grad_z/(dtot**2) * dtot_d
!     &                 -2.0d0*grad_z/dTot*ratio_d
!     &                 +2.0d0*grad_z*ratio/(dTot**2.0d0)*dTot_d
           if(((1.0d0-ratio).gt.thrsrho2).and.(ratio.lt.thrsrho3)) then
!           if(.false.) then
               Zeta  = sqrt(1.0d0-ratio)
               Zeta_d = -1.0d0*ratio_d/(2*Zeta)
               Zeta_dx = -1.0d0*ratio_dx/(2*Zeta)
               Zeta_dy = -1.0d0*ratio_dy/(2*Zeta)
               Zeta_dz = -1.0d0*ratio_dz/(2*Zeta)
               !dZeta/dLambda
               d_Zetax = -1.0d0*d_ratiox/(2.0d0*Zeta)
     &                  +ratio_dx/(2.0d0*Zeta**2.0d0)*Zeta_d
               d_Zetay = -1.0d0*d_ratioy/(2.0d0*Zeta)
     &                  +ratio_dy/(2.0d0*Zeta**2.0d0)*Zeta_d
               d_Zetaz = -1.0d0*d_ratioz/(2.0d0*Zeta)
     &                  +ratio_dz/(2.0d0*Zeta**2.0d0)*Zeta_d
! Compute alpha and beta densities
               Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
               Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
               Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
     &                          +0.5d0*dTot*Zeta_dx
               Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
     &                          +0.5d0*dTot*Zeta_dy
               Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
     &                          +0.5d0*dTot*Zeta_dz
               Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
     &                          -0.5d0*dTot*Zeta_dx
               Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
     &                          -0.5d0*dTot*Zeta_dy
               Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0
     &                          -0.5d0*dTot*Zeta_dz

               dRho_dr(1,iGrid+1,dindex) =
     &         Zeta_d*dTot/2.0d0+(1.0d0+Zeta)*dTot_d/2.0d0
               dRho_dr(2,iGrid+1,dindex) =
     &         -Zeta_d*dTot/2.0d0+(1.0d0-Zeta)*dTot_d/2.0d0

               dRho_dr(3,iGrid+1,dindex) =
     &         Zeta_d*grad_x/2.0d0+(1.0d0+Zeta)*dTot_dx/2.0d0
     &         +dTot/2.0d0*d_Zetax+Zeta_dx/2.0d0*dTot_d

               dRho_dr(4,iGrid+1,dindex) =
     &         Zeta_d*grad_y/2.0d0+(1.0d0+Zeta)*dTot_dy/2.0d0
     &         +dTot/2.0d0*d_Zetay+Zeta_dy/2.0d0*dTot_d

               dRho_dr(5,iGrid+1,dindex) =
     &         Zeta_d*grad_z/2.0d0+(1.0d0+Zeta)*dTot_dz/2.0d0
     &         +dTot/2.0d0*d_Zetaz+Zeta_dz/2.0d0*dTot_d

               dRho_dr(6,iGrid+1,dindex) =
     &         -Zeta_d*grad_x/2.0d0+(1.0d0-Zeta)*dTot_dx/2.0d0
     &         -dTot/2.0d0*d_Zetax-Zeta_dx/2.0d0*dTot_d

               dRho_dr(7,iGrid+1,dindex) =
     &         -Zeta_d*grad_y/2.0d0+(1.0d0-Zeta)*dTot_dy/2.0d0
     &         -dTot/2.0d0*d_Zetay-Zeta_dy/2.0d0*dTot_d

               dRho_dr(8,iGrid+1,dindex) =
     &         -Zeta_d*grad_z/2.0d0+(1.0d0-Zeta)*dTot_dz/2.0d0
     &         -dTot/2.0d0*d_Zetaz-Zeta_dz/2.0d0*dTot_d

*
            else if((ratio.ge.thrsrho3).and.(ratio.le.thrsrho4)) then
            !else if(.false.) then

               Zeta = (Ab1*(ratio-1.15d0)**5.0d0) +
     &        (Bb1*(ratio-1.15d0)**4.0d0) + (Cb1*(ratio-1.15d0)**3.0d0)
               Deriv =(5.0d0*Ab1*(ratio-1.15d0)**4.0d0)
     &               +(4.0d0*Bb1*(ratio-1.15d0)**3.0d0)
     &               +(3.0d0*Cb1*(ratio-1.15d0)**2.0d0)
               d_Deriv = (20.0d0*Ab1*(ratio-1.15d0)**3.0d0)
     &               +(12.0d0*Bb1*(ratio-1.15d0)**2.0d0)
     &               +(6.0d0*Cb1*(ratio-1.15d0)**1.0d0)

               Zeta_d = ratio_d*Deriv
               Zeta_dx = ratio_dx*Deriv
               Zeta_dy = ratio_dy*Deriv
               Zeta_dz = ratio_dz*Deriv
               !dZeta/dLambda
               d_Zetax = d_ratiox*Deriv+ratio_dx*d_Deriv*ratio_d
               d_Zetay = d_ratioy*Deriv+ratio_dy*d_Deriv*ratio_d
               d_Zetaz = d_ratioz*Deriv+ratio_dz*d_Deriv*ratio_d


* Compute alpha and beta densities

              Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0

              Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0

* Compute  gradients
               Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((10.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            - (5.0d0*ratio*grad_x))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((8.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            - (4.0d0*ratio*grad_x))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((6.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            - (3.0d0*ratio*grad_x))
!
               Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((10.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            - (5.0d0*ratio*grad_y))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((8.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            - (4.0d0*ratio*grad_y))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((6.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            - (3.0d0*ratio*grad_y))

               Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((10.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            - (5.0d0*ratio*grad_z))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((8.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            - (4.0d0*ratio*grad_z))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((6.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            - (3.0d0*ratio*grad_z))

               Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((-10.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            + (5.0d0*ratio*grad_x))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((-8.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            + (4.0d0*ratio*grad_x))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((-6.0d0*P2_ontop(2,iGrid+1)/dTot)
     &            + (3.0d0*ratio*grad_x))

               Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((-10.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            + (5.0d0*ratio*grad_y))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((-8.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            + (4.0d0*ratio*grad_y))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((-6.0d0*P2_ontop(3,iGrid+1)/dTot)
     &            + (3.0d0*ratio*grad_y))

              Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0
     &           + (Ab1*(ratio-1.15d0)**4.0d0)
     &            * ((-10.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            + (5.0d0*ratio*grad_z))
     &           + (Bb1*(ratio-1.15d0)**3.0d0)
     &            * ((-8.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            + (4.0d0*ratio*grad_z))
     &           + (Cb1*(ratio-1.15d0)**2.0d0)
     &            * ((-6.0d0*P2_ontop(4,iGrid+1)/dTot)
     &            + (3.0d0*ratio*grad_z))

               dRho_dr(1,iGrid+1,dindex) =
     &         Zeta_d*dTot/2.0d0+(1.0d0+Zeta)*dTot_d/2.0d0

               dRho_dr(2,iGrid+1,dindex) =
     &         -Zeta_d*dTot/2.0d0+(1.0d0-Zeta)*dTot_d/2.0d0

               dRho_dr(3,iGrid+1,dindex) =
     &         Zeta_d*grad_x/2.0d0+(1.0d0+Zeta)*dTot_dx/2.0d0
     &         +dTot/2.0D0*d_Zetax+Zeta_dx/2.0d0*dTot_d

               dRho_dr(4,iGrid+1,dindex) =
     &         Zeta_d*grad_y/2.0d0+(1.0d0+Zeta)*dTot_dy/2.0d0
     &         +dTot/2.0d0*d_Zetay+Zeta_dy/2.0d0*dTot_d

               dRho_dr(5,iGrid+1,dindex) =
     &         Zeta_d*grad_z/2.0d0+(1.0d0+Zeta)*dTot_dz/2.0d0
     &         +dTot/2.0d0*d_Zetaz+Zeta_dz/2.0d0*dTot_d

               dRho_dr(6,iGrid+1,dindex) =
     &         -1.0d0*Zeta_d*grad_x/2.0d0+(1.0d0-Zeta)*dTot_dx/2.0d0
     &         -dTot/2.0D0*d_Zetax-Zeta_dx/2.0d0*dTot_d

               dRho_dr(7,iGrid+1,dindex) =
     &         -1.0d0*Zeta_d*grad_y/2.0d0+(1.0d0-Zeta)*dTot_dy/2.0d0
     &         -dTot/2.0D0*d_Zetay-Zeta_dy/2.0d0*dTot_d

               dRho_dr(8,iGrid+1,dindex) =
     &         -1.0d0*Zeta_d*grad_z/2.0d0+(1.0d0-Zeta)*dTot_dz/2.0d0
     &         -dTot/2.0D0*d_Zetaz-Zeta_dz/2.0d0*dTot_d

             else
               Zeta  = 0.0d0
               Zeta_d  = 0.0d0

!               Rho(1,iGrid+1)=0
!               Rho(2,iGrid+1)=0
!               Rho(3,iGrid+1)= 0
!               Rho(4,iGrid+1)= 0
!               Rho(5,iGrid+1)= 0
!               Rho(6,iGrid+1)= 0
!               Rho(7,iGrid+1)= 0
!               Rho(8,iGrid+1)= 0
!               dRho_dr(1,iGrid+1,dindex) =0
!               dRho_dr(2,iGrid+1,dindex) =0
!               dRho_dr(3,iGrid+1,dindex) =0
!               dRho_dr(4,iGrid+1,dindex) =0
!               dRho_dr(5,iGrid+1,dindex) =0
!               dRho_dr(6,iGrid+1,dindex) =0
!               dRho_dr(7,iGrid+1,dindex) =0
!               dRho_dr(8,iGrid+1,dindex) = 0

               Rho(1,iGrid+1)=(1.0d0+Zeta)*dTot/2.0d0
               Rho(2,iGrid+1)=(1.0d0-Zeta)*dTot/2.0d0
               Rho(3,iGrid+1)= (1.0d0+Zeta)*grad_x/2.0d0
               Rho(4,iGrid+1)= (1.0d0+Zeta)*grad_y/2.0d0
               Rho(5,iGrid+1)= (1.0d0+Zeta)*grad_z/2.0d0
               Rho(6,iGrid+1)= (1.0d0-Zeta)*grad_x/2.0d0
               Rho(7,iGrid+1)= (1.0d0-Zeta)*grad_y/2.0d0
               Rho(8,iGrid+1)= (1.0d0-Zeta)*grad_z/2.0d0
!
               dRho_dr(1,iGrid+1,dindex) =
     &         Zeta_d*dTot/2.0d0+(1.0d0+Zeta)*dTot_d/2.0d0
               dRho_dr(2,iGrid+1,dindex) =
     &         -Zeta_d*dTot/2.0d0+(1.0d0-Zeta)*dTot_d/2.0d0
               dRho_dr(3,iGrid+1,dindex) =
     &         Zeta_d*grad_x/2.0d0+(1.0d0+Zeta)*dTot_dx/2.0d0
               dRho_dr(4,iGrid+1,dindex) =
     &         Zeta_d*grad_y/2.0d0+(1.0d0+Zeta)*dTot_dy/2.0d0
               dRho_dr(5,iGrid+1,dindex) =
     &         Zeta_d*grad_z/2.0d0+(1.0d0+Zeta)*dTot_dz/2.0d0
               dRho_dr(6,iGrid+1,dindex) =
     &         -Zeta_d*grad_x/2.0d0+(1.0d0-Zeta)*dTot_dx/2.0d0
               dRho_dr(7,iGrid+1,dindex) =
     &         -Zeta_d*grad_y/2.0d0+(1.0d0-Zeta)*dTot_dy/2.0d0
               dRho_dr(8,iGrid+1,dindex) =
     &         -Zeta_d*grad_z/2.0d0+(1.0d0-Zeta)*dTot_dz/2.0d0
              end if!Threshrho_2
            end if! little density (threshrho)
          end do!ngrad_eff
        end do!gridpt
       end if!
       end if
C        If (Do_Hess)
C    &      Call dRho_dR_GGA(Dens,nDens,nD,dRho_dR,d2Rho_dR2,
C    &                       ndRho_dr,mGrid,list_s,nlist_s,
C    &                       TabAO,ipTabAO,mAO,nTabAO,nSym,
C    &                       nGrad_Eff,list_g,Maps2p,
C    &                       nShell,Grid_Type,Fixed_Grid,
C    &                       Work(ip_Fact),ndc,Work(ipTmp),T_X,
C    &                       list_bas,Index,nIndex)
*
      Else If (Functional_type.eq.CASDFT_type) Then
*
         Call Rho_CAS(Dens,nDens,nD,Rho,nRho,mGrid,
     &                list_s,nlist_s,TabAO,ipTabAO,mAO,nTabAO,nSym,
     &                Work(ip_Fact),ndc,Work(ipTabAOMax),
     &                list_bas,Index,nIndex)
*
C        If (Do_Grad)
C    &      Call dRho_dR_CAS(Dens,nDens,nD,dRho_dR,ndRho_dr,
C    &                       mGrid,list_s,nlist_s,
C    &                       TabAO,ipTabAO,mAO,nTabAO,nSym,
C    &                       nGrad_Eff,list_g,Maps2p,
C    &                       nShell,Grid_Type,Fixed_Grid,
C    &                       Work(ip_Fact),ndc,Work(ipTmp),T_X,
C    &                       list_bas,Index,nIndex)
C        If (Do_Hess)
C    &      Call dRho_dR_CAS(Dens,nDens,nD,dRho_dR,d2Rho_dR2,
C    &                       ndRho_dr,mGrid,list_s,nlist_s,
C    &                       TabAO,ipTabAO,mAO,nTabAO,nSym,
C    &                       nGrad_Eff,list_g,Maps2p,
C    &                       nShell,Grid_Type,Fixed_Grid,
C    &                       Work(ip_Fact),ndc,Work(ipTmp),T_X,
C    &                       list_bas,Index,nIndex)
*------- Compute P2_OnTop at the grid
         Call Do_P2new(P2mo,np2act,D1mo,nd1mo,TabMO,mAO,mGrid,
     &                 nMOs,P2_ontop,nP2_ontop,Work(ipRhoI),
     &                 Work(ipRhoA),mRho)
*
      Else If (Functional_type.eq.meta_GGA_type1) Then
*
         Call Rho_meta_GGA1(nD,Rho,nRho,mGrid,
     &                     list_s,nlist_s,TabAO,ipTabAO,mAO,nTabAO,
     &                     Work(ip_Fact),ndc,Work(ipTabAOMax),
     &                     list_bas,Index,nIndex)
*
         If (Do_Grad)
     &      Call dRho_dR_meta_GGA1
     &                      (nD,dRho_dR,ndRho_dr,
     &                       mGrid,list_s,nlist_s,
     &                       TabAO,ipTabAO,mAO,nTabAO,nSym,
     &                       nGrad_Eff,list_g,Maps2p,nShell,
     &                       Work(ip_Fact),ndc,Work(ipTmp),T_X,
     &                       list_bas,Index,nIndex)
*
      Else If (Functional_type.eq.meta_GGA_type2) Then
*
         Call Rho_meta_GGA2(nD,Rho,nRho,mGrid,
     &                     list_s,nlist_s,TabAO,ipTabAO,mAO,nTabAO,
     &                     Work(ip_Fact),ndc,Work(ipTabAOMax),
     &                     list_bas,Index,nIndex)
*
         If (Do_Grad)
     &      Call dRho_dR_meta_GGA2
     &                      (nD,dRho_dR,ndRho_dr,
     &                       mGrid,list_s,nlist_s,
     &                       TabAO,ipTabAO,mAO,nTabAO,nSym,
     &                       nGrad_Eff,list_g,Maps2p,nShell,
     &                       Work(ip_Fact),ndc,Work(ipTmp),T_X,
     &                       list_bas,Index,nIndex)
      End If
*
*     Integrate out the number of electrons
*
      if(l_casdft) then
        T_Rho=T_X*1.0D-4
        Dens_t2=Dens_t2+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,0)
        Dens_a2=Dens_a2+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,1)
        Dens_b2=Dens_b2+Comp_d(Weights,mGrid,Rho,nRho,nD,T_Rho,2)
      end if
*
*     Integrate out the number of electrons, |grad|, and tau
*
      T_Rho=T_X*1.0D-4
      If (Functional_type.eq.LDA_Type) Then
         Dens_I=Dens_I+Compute_Rho (Weights,mGrid,Rho,nRho,nD,T_Rho)
      Else If (Functional_type.eq.GGA_type) Then
         Dens_I=Dens_I+Compute_Rho (Weights,mGrid,Rho,nRho,nD,T_Rho)
         Grad_I=Grad_I+Compute_Grad(Weights,mGrid,Rho,nRho,nD,T_Rho)
      Else If (Functional_type.eq.meta_GGA_type1) Then
         Dens_I=Dens_I+Compute_Rho (Weights,mGrid,Rho,nRho,nD,T_Rho)
         Grad_I=Grad_I+Compute_Grad(Weights,mGrid,Rho,nRho,nD,T_Rho)
         Tau_I =Tau_I +Compute_Tau (Weights,mGrid,Rho,nRho,nD,T_Rho)
      Else If (Functional_type.eq.meta_GGA_type2) Then
         Dens_I=Dens_I+Compute_Rho (Weights,mGrid,Rho,nRho,nD,T_Rho)
         Grad_I=Grad_I+Compute_Grad(Weights,mGrid,Rho,nRho,nD,T_Rho)
         Tau_I =Tau_I +Compute_Tau (Weights,mGrid,Rho,nRho,nD,T_Rho)
      End If
C     Write (*,*) Dens_I,Grad_I,Tau_I
*                                                                      *
************************************************************************
*                                                                      *
*        For New Functionals which use P2_OnTop (like NEWF)
      If (DFTFOCK.eq.'DIFF'.and.nD.eq.2) Then
*        For "Normal" Functionals
         If (Do_MO.and..not.(Functional_type.eq.CASDFT_Type)) Then
            Call Do_RhoIA(nRho,mGrid,Rho,Work(ipRhoI),
     &                    Work(ipRhoA),mRho,TabMO,mAO,
     &                    nMOs,D1mo,nd1mo)
         Else
            Call WarningMessage(2,' We need MO for RhoIA')
            Call Abend()
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-- (A.Ohrn): Here I add the routine which constructs the kernel for
*   the Xhole application. A bit 'cheating' but hey what da hey!
*
      If(l_Xhol) then
#ifdef _NOT_USED_TESTED_OR_MAINTAINED_
        Call Xhole(nRho,mGrid,Rho,Grid,mAO,nMOs,TabMO,ndF_dRho,nD,
     &             dF_dRho,Weights,ip_OrbDip,Func)
#endif
        Go To 1979
      Endif
************************************************************************
*                                                                      *
*---- Evaluate the functional on the grid                              *
*                                                                      *
************************************************************************
*                                                                      *
      Call FZero(dF_dRho,ndF_dRho*mGrid)
      Call FZero(F_xc,mGrid)
      Call mma_allocate(F_xca,mGrid,Label='F_xca')
      Call mma_allocate(F_xcb,mGrid,Label='F_xcb')
      Call mma_allocate(tmpB,mGrid,Label='tmpB')
      F_xca(:)=Zero
      F_xcb(:)=Zero
      tmpB(:)=Zero
*
*1)   evaluate the energy density, the derivative of the functional with
*     respect to rho and grad rho.
*
      Call Kernel(mGrid,Rho,nRho,P2_ontop,
     &            nP2_ontop,nD,F_xc,dF_dRho,
     &            ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_Rho)
cGLM     &            nP2_ontop,nD,F_xc,F_xca,F_xcb,dF_dRho,
cGLM     &            ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_Rho,Work(ip_tmpB))
*
      If (nD.eq.2.and.DFTFOCK.eq.'DIFF') Then
         Call P2Diff(mGrid,dF_dRho,ndF_dRho,Rho,nRho)
      End If
*
*     Integrate the energy of the functional
*
      Func=Func+DDot_(mGrid,Weights,1,F_xc,1)
cGLM     write(6,*) 'Func in do_batch =', Func
      Funcaa=Funcaa+DDot_(mGrid,Weights,1,F_xca,1)
      Funcbb=Funcbb+DDot_(mGrid,Weights,1,F_xcb,1)
      Funccc=Funccc+DDot_(mGrid,Weights,1,tmpB,1)
      call xflush(6)
      Call mma_deallocate(F_xca)
      Call mma_deallocate(F_xcb)
      Call mma_deallocate(tmpB)
*                                                                      *
************************************************************************
*                                                                      *
1979  Continue  !Jump here and skip the call to the kernel.

      If (.Not.Do_Grad) Then
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the DFT contribution to the Fock matrix                  *
*                                                                      *
************************************************************************
*                                                                      *
         If (Functional_type.eq.LDA_Type) Then
*
*2)         form matrix elements for the potential, from derivative of
*           the functional with  respect to rho, respectively.
*
            If (nD.eq.2.and.DFTFOCK.eq.'DIFF') Then
*
               If(Do_TwoEl) Call Calc_PUVX2(TmpPUVX,nTmpPUVX,TabMO,mAO,
     &                                   mGrid,nMOs,dF_dRho,
     &                                   ndF_dRho,nD,Weights)
*
               Call ConvdFdRho(mGrid,dF_dRho,ndF_dRho,
     &                      Work(ipRhoI),Work(ipRhoA),mRho)
               Call Do_Int_CASDFT2(Weights,mGrid,mAO,
     &                             TabSO,nMOs,TabMO,nMOs,
     &                             nD,FckInt,nFckInt,nFckDim,
     &                             Work(ipRhoI),Work(ipRhoA),mRho,
     &                             dF_dRho,ndF_dRho,
     &                             dF_dP2ontop,ndF_dP2ontop,
     &                             TmpPUVX,nTmpPUVX)
*
            Else
!First, calculate some sizes:
             NFINT=nTmpPUVX
             NTOT1=nFckInt

             If(KSDFA(1:5).eq.'TLSDA') then
               If(do_pdftPot) then
!               CALL GETMEM('OE_OT','ALLO','REAL',LOE_DB,NTOT1)
!               CALL GETMEM('TEG_OT','ALLO','REAL',LTEG_DB,NFINT)

!               CALL DCOPY_(NTOT1,0.0D0,0,WORK(LOE_DB),1)!NTOT1
!               CALL DCOPY_(NFINT,0.0D0,0,WORK(LTEG_DB),1)

!               Call Get_dArray('ONTOPO',work(LOE_DB),NTOT1)
!               Call Get_dArray('ONTOPT',work(LTEG_DB),NFINT)

               Call Calc_OTPUVX(Work(LTEG_DB),TabMO,mAO,mGrid,
     &         nMOs,P2_ontop,nP2_ontop,Rho,nRho,dF_dRho,
     &         ndF_dRho,Work(ipRhoI),Work(ipRhoA),mRho,Weights,
     &         D1MO,nD1MO,nsym)

!
               Call Calc_OTOE(Work(LOE_DB),TabMO,mAO,mGrid,
     &         nMOs,P2_ontop,nP2_ontop,Rho,nRho,dF_dRho,
     &         ndF_dRho,Work(ipRhoI),Work(ipRhoA),mRho,Weights,
     &         nsym)

!               Call Put_dArray('ONTOPO',work(LOE_DB),NTOT1)
!               Call Put_dArray('ONTOPT',work(LTEG_DB),NFINT)

!               CALL GETMEM('OE_OT','FREE','REAL',LOE_DB,NTOT1)
!               CALL GETMEM('TEG_OT','FREE','REAL',LTEG_DB,NFINT)
               end if
             else If(KSDFA(1:6).eq.'FTLSDA') then
               If(do_pdftPot) then

!               CALL GETMEM('OE_OT','ALLO','REAL',LOE_DB,NTOT1)
!               CALL GETMEM('TEG_OT','ALLO','REAL',LTEG_DB,NFINT)

!               CALL DCOPY_(NTOT1,0.0D0,0,WORK(LOE_DB),1)!NTOT1
!               CALL DCOPY_(NFINT,0.0D0,0,WORK(LTEG_DB),1)

!               Call Get_dArray('ONTOPO',work(LOE_DB),NTOT1)
!               Call Get_dArray('ONTOPT',work(LTEG_DB),NFINT)


               Call Calc_OTPUVX_ftlsda2(Work(LTEG_DB),TabMO,mAO,mGrid,
     &         nMOs,P2_ontop,nP2_ontop,Rho,nRho,dF_dRho,
     &         ndF_dRho,Work(ipRhoI),Work(ipRhoA),mRho,Weights,
     &         D1MO,nD1MO,nsym)

!               tmpor = Work(loe_db)
!
               Call Calc_OTOEf(Work(LOE_DB),TabMO,mAO,mGrid,
     &         nMOs,P2_ontop,nP2_ontop,Rho,nRho,dF_dRho,
     &         ndF_dRho,Work(ipRhoI),Work(ipRhoA),mRho,Weights,
     &         nsym)

!               Call Put_dArray('ONTOPO',work(LOE_DB),NTOT1)
!               Call Put_dArray('ONTOPT',work(LTEG_DB),NFINT)

               Call xflush(6)
!               CALL GETMEM('OE_OT','FREE','REAL',LOE_DB,NTOT1)
!               CALL GETMEM('TEG_OT','FREE','REAL',LTEG_DB,NFINT)
               end if
             end if

             If(KSDFA(1:5).ne.'TLSDA'.and.KSDFA(1:6).ne.'FTLSDA') then
                 Call DFT_Int(Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
     &                      FckInt,nFckInt,SOTemp,nSOTemp,
     &                      TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
     &                      nSym,nD,Flop,Rho,nRho,Work(ipTmp),nTmp,
     &                      Work(ip_Fact),ndc,mAO,Work(ipTabAOMax),T_Y,
     &                      list_bas,Functional_type,nAOMax)
             End If
           End If
*                                                                      *
************************************************************************
*                                                                      *
        Else If (Functional_type.eq.GGA_type   .or.
     &           Functional_type.eq.CASDFT_type     ) Then     ! CGG
*
*2)        form matrix elements for the potential, from derivative of
*          the functional with  respect to rho, respectively.
*
*          and
*
*3)        form contributions to the matrix elements of the potenial
*          from the derivative of the functional with respect to grad
*          rho.
*
           If (nD.eq.2.and.DFTFOCK.eq.'DIFF') Then
***************
              If (Do_TwoEl) Call Calc_PUVX2(TmpPUVX,nTmpPUVX,TabMO,
     &                                   mAO,mGrid,nMOs,dF_dRho,
     &                                   ndF_dRho,nD,Weights)
              If (.not.(Functional_Type.eq.CASDFT_Type))
     &        Call ConvdFdRho(mGrid,dF_dRho,ndF_dRho,
     &                             Work(ipRhoI),Work(ipRhoA),mRho)
              Call Do_Int_CASDFT2(Weights,mGrid,mAO,
     &                            TabSO,nMOs,TabMO,nMOs,
     &                            nD,FckInt,nFckInt,nFckDim,
     &                            Work(ipRhoI),Work(ipRhoA),mRho,
     &                            dF_dRho,ndF_dRho,
     &                            dF_dP2ontop,ndF_dP2ontop,
     &                            TmpPUVX,nTmpPUVX)
******************
           Else
             NFINT=nTmpPUVX
             NTOT1=nFckInt

             If(KSDFA(1:4).eq.'TPBE'.or.
     &               KSDFA(1:5).eq.'TOPBE'.or.
     &               KSDFA(1:5).eq.'TBLYP'.or.
     &               KSDFA(1:7).eq.'TREVPBE') then

               If(do_pdftPot) then
!               CALL GETMEM('OE_OT','ALLO','REAL',LOE_DB,NTOT1)
!               CALL GETMEM('TEG_OT','ALLO','REAL',LTEG_DB,NFINT)

!               CALL DCOPY_(NTOT1,0.0D0,0,WORK(LOE_DB),1)!NTOT1
!               CALL DCOPY_(NFINT,0.0D0,0,WORK(LTEG_DB),1)

!               Call Get_dArray('ONTOPO',work(LOE_DB),NTOT1)
!               Call Get_dArray('ONTOPT',work(LTEG_DB),NFINT)

               Call Calc_OTPUVXGGA_2(Work(LTEG_DB),TabMO,mAO,mGrid,
     &         nMOs,P2_ontop,nP2_ontop,Rho,nRho,dF_dRho,
     &         ndF_dRho,Work(ipRhoI),Work(ipRhoA),mRho,Weights,
     &         D1MO,nD1MO,nsym)

               Call Calc_OTOEGGA(Work(LOE_DB),TabMO,mAO,mGrid,
     &         nMOs,P2_ontop,nP2_ontop,Rho,nRho,dF_dRho,
     &         ndF_dRho,Work(ipRhoI),Work(ipRhoA),mRho,Weights,
     &         nsym)

!               Call Put_dArray('ONTOPO',work(LOE_DB),NTOT1)
!               Call Put_dArray('ONTOPT',work(LTEG_DB),NFINT)

!               CALL GETMEM('OE_OT','FREE','REAL',LOE_DB,NTOT1)
!               CALL GETMEM('TEG_OT','FREE','REAL',LTEG_DB,NFINT)
              end if
             Else If(KSDFA(1:5).eq.'FTPBE'.or.
     &               KSDFA(1:6).eq.'FTOPBE'.or.
     &               KSDFA(1:6).eq.'FTBLYP'.or.
     &               KSDFA(1:8).eq.'FTREVPBE') then
               If(do_pdftPot) then
!               CALL GETMEM('OE_OT','ALLO','REAL',LOE_DB,NTOT1)
!               CALL GETMEM('TEG_OT','ALLO','REAL',LTEG_DB,NFINT)

!               CALL DCOPY_(NTOT1,0.0D0,0,WORK(LOE_DB),1)!NTOT1
!               CALL DCOPY_(NFINT,0.0D0,0,WORK(LTEG_DB),1)

!               Call Get_dArray('ONTOPO',work(LOE_DB),NTOT1)
!               Call Get_dArray('ONTOPT',work(LTEG_DB),NFINT)

               Call Calc_OTPUVXGGA_ft(Work(LTEG_DB),TabMO,mAO,mGrid,
     &         nMOs,P2_ontop,nP2_ontop,Rho,nRho,dF_dRho,
     &         ndF_dRho,Work(ipRhoI),Work(ipRhoA),mRho,Weights,
     &         D1MO,nD1MO,nsym)

               Call Calc_OTOEGGA_ft(Work(LOE_DB),TabMO,mAO,mGrid,
     &         nMOs,P2_ontop,nP2_ontop,Rho,nRho,dF_dRho,
     &         ndF_dRho,Work(ipRhoI),Work(ipRhoA),mRho,Weights,
     &         nsym)

!               Call Put_dArray('ONTOPO',work(LOE_DB),NTOT1)
!               Call Put_dArray('ONTOPT',work(LTEG_DB),NFINT)

!               CALL GETMEM('OE_OT','FREE','REAL',LOE_DB,NTOT1)
!               CALL GETMEM('TEG_OT','FREE','REAL',LTEG_DB,NFINT)
              end if
             end if
!FIND NTOT1,NFINT equivalents

!               Call DFT_Int(Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
!     &                      FckInt,nFckInt,SOTemp,nSOTemp,
!     &                      TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
!     &                      nSym,nD,Flop,Rho,nRho,Work(ipTmp),nTmp,
!     &                      Work(ip_Fact),ndc,mAO,Work(ipTabAOMax),T_Y,
!     &                      list_bas,Functional_type,nAOMax)
             If(.not.l_casdft) then
               Call DFT_Int(Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
     &                      FckInt,nFckInt,SOTemp,nSOTemp,
     &                      TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
     &                      nSym,nD,Flop,Rho,nRho,Work(ipTmp),nTmp,
     &                      Work(ip_Fact),ndc,mAO,Work(ipTabAOMax),T_Y,
     &                      list_bas,Functional_type,nAOMax)
             end if
           End If
*                                                                      *
************************************************************************
*                                                                      *
        Else If (Functional_type.eq.meta_GGA_type1 .or.
     &           Functional_Type.eq.meta_GGA_type2) Then
*
*2)        form matrix elements for the potential, from derivative of
*          the functional with  respect to rho, respectively.
*
*          and
*
*3)        form contributions to the matrix elements of the potenial
*          from the derivative of the functional with respect to grad
*          rho.
*
*         and
*
*4)       form contributions to the matrix elements of the potential
*         from the derivatives of the functional with respect to nabla
*         rho and/or tau.
*
          Call DFT_Int(Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
     &                 FckInt,nFckInt,SOTemp,nSOTemp,
     &                 TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
     &                 nSym,nD,Flop,Rho,nRho,Work(ipTmp),nTmp,
     &                 Work(ip_Fact),ndc,mAO,Work(ipTabAOMax),T_Y,
     &                 list_bas,Functional_type,nAOMax)
*                                                                      *
************************************************************************
*                                                                      *
         Else
            Call WarningMessage(2,'Wrong type of functional')
            Call Abend()
         End If    !  Functional Type
*                                                                      *
************************************************************************
*                                                                      *
*    Compute the DFT contribution to the gradient                      *
*                                                                      *
************************************************************************
*                                                                      *
      Else
*
         Call DFT_Grad(Grad,nGrad,dF_dRho,ndF_dRho,nD,Grid,mGrid,
     &                 dRho_dR,ndRho_dR,nGrad_Eff,Rho,nRho,IndGrd,
     &                 Weights,iTab,Temp,F_xc,dW_dR,iNQ)
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If(mRho.ne.-1) Then
        Call GetMem('Rho_I','Free','Real',ipRhoI,mGrid*mRho)
        Call GetMem('Rho_A','Free','Real',ipRhoA,mGrid*mRho)
      End If
#ifdef _DEBUGPRINT_
      Debug=Debug_Save
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2007, Roland Lindh                                *
************************************************************************
      SubRoutine PGet2_RI3(iCmp,iBas,jBas,kBas,lBas,
     &                  Shijij, iAO, iAOst, nijkl,PSO,nPSO,
     &                  DSO,DSSO,nDSO,ExFac,CoulFac,PMax,V_k,mV_k,
     &                  ZpK,nSA,nAct)
************************************************************************
*  Object: to assemble the 2nd order density matrix of a SCF wave      *
*          function from the 1st order density matrix.                 *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*                                                                      *
*             Modified for 3-center RI gradients, March 2007           *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use pso_stuff, only: lPSO, nnp, Thpkl, ipAorb
      use Basis_Info, only: nBas, nBas_Aux
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "real.fh"
#include "print.fh"
#include "exterm.fh"
      Real*8 PSO(nijkl,nPSO), DSO(nDSO,nSA), DSSO(nDSO), V_k(mV_k,nSA),
     &       Zpk(*)
      Integer iCmp(4), iAO(4), iAOst(4)
      Logical Shijij
*     Local Array
      Integer jSym(0:7), kSym(0:7), lSym(0:7), nAct(0:7)
      Integer iTwoj(0:7),nCumnnP(0:7),nCumnnP2(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
#include "ymnij.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      kYmnij(l)=iWork(ipYmnij(1)-1+l)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 39
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      iPrint=99
      If (iPrint.ge.99) Then
         iComp = 1
         Call PrMtrx(' In PGET_RI3:DSO ',[iD0Lbl],iComp,1,D0)
         Call RecPrt('V_K',' ',V_K,1,mV_K)
         Write (6,*)
         Write (6,*) 'Distribution of Ymnij'
         Do iSym = 1, nIrrep
           If (nYmnij(iSym,1).gt.0) Then
           Write (6,*) 'iSym=',iSym
           Do i= iOff_Ymnij(iSym,1)+1,iOff_Ymnij(iSym,1)+nYmnij(iSym,1)
              Write (6,*) 'kYmnij=',kYmnij(i)
           End Do
           End If
         End Do
         Write (6,*) 'jbas,kbas,lbas=',jBas,kBas,lBas
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(Cpu1,Wall1)
*
      Fac = One / Four
      lOper=1
      PMax=Zero
      iSO = 1
      Call FZero(PSO,nijkl*nPSO)
*
      If (lPSO) Then
         nCumnnP(0)=0
         nBas_Aux(0)=nBas_Aux(0)-1
         Do i=1,nIrrep-1
           nCumnnP(i)=nCumnnP(i-1)+nnP(i-1)*nBas_Aux(i-1)
         End Do
         nBas_Aux(0)=nBas_Aux(0)+1
      EndIf
*
*     i2, j2, jBas: auxiliary basis
*     i3, j3, kBas: valence basis
*     i4, j4, lBas: valence basis
*
*     Note when j2 is symmetric then we can have both Coulomb and
*     exchange contributions, while for j2 asymmetric we will
*     only have exchange contributions
*
      MemSO2 = 0
      Do i2 = 1, iCmp(2)
         njSym = 0
         Do j = 0, nIrrep-1
           If (iAOtSO(iAO(2)+i2,j)>0) Then
               jSym(njSym) = j
               njSym = njSym + 1
            End If
         End Do
         Do i3 = 1, iCmp(3)
            nkSym = 0
            Do 301 j = 0, nIrrep-1
               If (iAOtSO(iAO(3)+i3,j)>0) Then
                  kSym(nkSym) = j
                  nkSym = nkSym + 1
               End If
301         Continue
            Do i4 = 1, iCmp(4)
               nlSym = 0
               Do 401 j = 0, nIrrep-1
                  If (iAOtSO(iAO(4)+i4,j)>0) Then
                     lSym(nlSym) = j
                     nlSym = nlSym + 1
                  End If
 401           Continue
*              Write (*,*)
*              Write (*,*) 'i2,i3,i4=',i2,i3,i4
*              Write (*,*) '=================='
*              Write (*,*)
*
*------Loop over irreps which are spanned by the basis function.
*
          Do js = 0, njSym-1
             j2 = jSym(js)
*            nJ = nChOrb(j2,iSO)
             nJ = jBas
*
             If (lPSO) Then
               ntmp=0
               Do j4=0,nIrrep-1
                 j3=iEOR(j4,j2)
                 If (j3.le.j4) nCumnnP2(j3)=ntmp
                 If (j3.eq.j4) ntmp=ntmp+nAct(j3)*(nAct(j3)+1)/2
                 If (j3.lt.j4) ntmp=ntmp+nAct(j3)*nAct(j4)
               End Do
               Do j4=0,nIrrep-1
                 j3=iEOR(j4,j2)
                 If (j3.gt.j4) nCumnnP2(j3)=nCumnnP2(j4)
               End Do
             EndIf
*
*
             Do 310 ks = 0, nkSym-1
                j3 = kSym(ks)
                j23 = iEor(j2,j3)
                nk = nYmnij(j3+1,1)
                kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)
*
*               Pointers to the full list of the X_mu,i elements
*               Note this list runs over all basis functions mu
*               (kBas*iCmp(3)). Here we only want to pick up the
*               subblock for a fixed iCmp(3) value.
*
                If (nk.lt.nChOrb(j3,iSO).and.ExFac.ne.Zero.and.
     &              nk.gt.0) Then
*
*                  Offset to where the block starts (jbas,kbas,i3)
*
                   jp_Xki=ip_CMOi(1) + iOff_CMOi(j3+1,1)
     &                   + nChOrb(j3,iSO)*(kSO-1)-1
*
*                  Loop over the auxiliary basis functions which has
*                  significant contributions to the k shell.
*
                   imo=0
                   Do k = 1, nk
                      kmo=kYmnij(k+iOff_Ymnij(j3+1,1))
*
                      jCMOk=jp_Xki+kmo
                      jr   =jr_Xki(1)+imo
                      call dcopy_(kBas,Work(jCMOk),nChOrb(j3,iSO),
     &                                 Work(jr),  nk)
*
                      imo = imo +1
                   End Do
*                  Reset pointers
                   jp_Xki=jr_Xki(1)
*                  Write (*,*) 'i3,j3=',i3,j3
*                  Call RecPrt('X(i,mu)C',' ',Work(jp_Xki),nk,kBas)
                Else If (ExFac.ne.Zero.and.nk.gt.0) Then
                   jp_Xki=ip_CMOi(1) + iOff_CMOi(j3+1,1)
     &                   + nChOrb(j3,iSO)*(kSO-1)
*                  Write (*,*) 'i3,j3=',i3,j3
*                  Call RecPrt('X(i,mu)R',' ',Work(jp_Xki),nk,kBas)
                Else
                   jp_Xki=ip_Dummy
                End If
*
                Do 410 ls = 0, nlSym-1
                   j4 = lSym(ls)
*                  Write (*,*)
*                  Write (*,*) 'j2,j3,j4=',j2,j3,j4
*                  Write (*,*)
                   If (j23.ne.j4) Go To 410
*                  Write (*,*) 'Pass symmetry check'
*                  Write (*,*) 'j2,j3,j4=',j2,j3,j4
                   nl = nYmnij(j4+1,1)
*                  Write (*,*) 'j4,nl=',j4,nl
                   lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
*
*                  Pointers to the full list of the X_mu,i elements
*
                   If (nl.lt.nChOrb(j4,iSO).and.ExFac.ne.Zero.and.
     &                 nl.gt.0) Then
                      jp_Xli=ip_CMOi(1) + iOff_CMOi(j4+1,1)
     &                      + nChOrb(j4,iSO)*(lSO-1)-1
                      imo=0
                      Do l = 1, nl
                         lmo=kYmnij(l+iOff_Ymnij(j4+1,1))
*
                         jCMOl=jp_Xli+lmo
                         jr   =jr_Xli(1)+imo
                         call dcopy_(lBas,Work(jCMOl),nChOrb(j4,iSO),
     &                                    Work(jr),   nl)
*
                         imo = imo +1
                      End Do
*                     Reset pointers
                      jp_Xli=jr_Xli(1)
*                     Write (*,*) 'i4,j4=',i4,j4
*                     Call RecPrt('X(j,nu)C',' ',Work(jp_Xli),nl,lBas)
                   Else If (ExFac.ne.Zero.and.nl.gt.0) Then
                      jp_Xli=ip_CMOi(1) + iOff_CMOi(j4+1,1)
     &                      + nChOrb(j4,iSO)*(lSO-1)
*                     Write (*,*) 'i4,j4=',i4,j4
*                     Call RecPrt('X(j,nu)R',' ',Work(jp_Xli),nl,lBas)
                   Else
                      jp_Xli=ip_Dummy
                   End If
*
                   MemSO2 = MemSO2 + 1
*                  Write (6,*) 'MemSO2=',MemSO2
*
                   jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
                   jSO_off = jSO - nBas(j2)
*
                   ExFac_ = ExFac
                   If (nJ*nk*nl.eq.0) ExFac=Zero
*                  Write (6,*) 'i2,i3,i4=',i2,i3,i4
*                  Write (6,*) 'nJ,nk,nl=',nJ,nk,nl
*                  Write (6,*) 'ExFac=',ExFac
*                                                                      *
************************************************************************
*                                                                      *
*                  Read a block of C_kl^J and transform it to
*                  AO basis.
*
                   If (ExFac.ne.Zero) Then
*
*                  Read C(i,j,J) for a fix i2 value
*
                   lCVec = nIJR(j3+1,j4+1,iSO)*jBas
                   iAdr =  iAdrCVec(j2+1,j3+1,1)
     &                  +  nIJR(j3+1,j4+1,iSO)*(jSO_Off-1)
                   Call dDaFile(LuCVector(j2+1,1),2,Work(ip_Cijk),
     &                          lCVec,iAdr)
*                  Call RecPrt('C(ij,K)',' ',Work(ip_CijK),
*    &                         nIJR(j3+1,j4+1,iSO),jBas)
*
*                  Extract only those C_kl^Js for which we deem k and l
*                  to belong to the shell-pair and to be of
*                  significance. Use temporary memory location at
*                  ip_CilK.
*
                   If (nk*nl.lt.nChOrb(j3,iSO)*nChOrb(j4,iSO)) Then
                      ij=0
                      Do j=1,nl
                         jmo=kYmnij(j+iOff_Ymnij(j4+1,1))
                         Do i=1,nk
                            imo=kYmnij(i+iOff_Ymnij(j3+1,1))
*
                            jC=ip_Cijk-1+nChOrb(j3,iSO)*(jmo-1)+imo
                            jr=ip_CilK+ij
*
*                           For this particular ij combination pick
*                           the whole row.
*
                            call dcopy_(jBas,Work(jC),nChOrb(j3,iSO)*
     &                                               nChOrb(j4,iSO),
     &                                      Work(jr),nk*nl)
                            ij=ij+1
                         End Do
                      End Do
*
*                     Copy back to original memory position.
*
                      call dcopy_(nk*nl*jBas,Work(ip_CilK),1,
     &                                      Work(ip_CijK),1)
                   End If
*
*                  Transform according to Eq. 16 (step 4) and
*                  generate B_kl^J. This is a transformation from
*                  the MO basis, ij, to the AO basis mn.
*
*                  E(jK,m) = Sum_i C(i,jK)' * X(i,m)
*
*                  Call RecPrt('C(ij,K)',' ',Work(ip_CijK),
*    &                         nk*nl,jBas)
*                  Call RecPrt('X(i,mu)',' ',Work(jp_Xki),
*    &                          nk,kBas)
                   Call dGEMM_('T','N',nl*jBas,kBas,nk,
     &                        1.0D0,Work(ip_CijK),nk,
     &                              Work(jp_Xki),nk,
     &                        0.0D0,Work(ip_CilK),nl*jBas)
*
*                  B(Km,n) = Sum_j E(j, Km)' * X(j,n)
*
                   Call dGEMM_('T','N',jBas*kBas,lBas,nl,
     &                         1.0D0,Work(ip_CilK),nl,
     &                               Work(jp_Xli),nl,
     &                         0.0D0,Work(ip_BklK),jBas*kBas)
*                  Write (*,*) 'i2,i3,i4=',i2,i3,i4
*                  Write (*,*) 'MemSO2=',MemSO2
*                  Call RecPrt('B_kl^K',' ',Work(ip_BklK),
*    &                         jBas,kBas*lBas)

                   End If
*
*                  Write (6,*)
*                  Write (6,*) 'j2,j3,j4=',j2,j3,j4
*                  Write (6,*)
*                                                                      *
************************************************************************
*                                                                      *
*                  Active term (CASSCF and SA-CASSCF)
*
                   If (lPSO) Then
                     Call dzero(Thpkl,jBas*kBas*lBas)
                     If (nAct(j3)*nAct(j4).eq.0) Go to 21
                     Do iVec=1,nAVec
                       iMO1=1
                       iMO2=1
                       iVec_=iVec
                       fact=1.0d0
                       If (iVec.eq.2) iMO2=2
                       If (iVec.eq.3) fact=2.0d0
                       If (iVec.eq.4) Then
                         iMO1=2
                         iVec_=2
                       EndIf
*
                       Do jAOj = 0, jBas-1
                         jSOj = jSO + jAOj - nBas(j2)
                         jp=nCumnnP(j2)+(jSOj-1)*nnP(j2)+nCumnnP2(j3)
                         Do lAOl = 0, lBas-1
                           lSOl = lSO + lAOl
                           lp=(lSOl-1)*nAct(j4)+ipAOrb(j4,iMO1)

                           If (j3.eq.j4) Then
                             Do kAct=1,nAct(j3)
*Zpk(*,iVec)
                               tmp=ddot_(kAct,Zpk(jp+kAct*(kAct-1)/2+1),
     &                             1,Work(lp),1)
                               Do lAct=kAct+1,nAct(j4)
                                 tmp=tmp+Zpk(jp+lAct*(lAct-1)/2+kAct)*
     &                               Work(lp+lAct-1)
                               End Do
                               Work(ip_Cilk+kAct-1)=tmp
                             End Do
                           Else
                             If (j3.lt.j4) Then
                               Call dGeMV_('N',nAct(j3),nAct(j4),1.0d0,
     &                                    Zpk(jp+1),nAct(j3),Work(lp),1,
     &                                    0.0d0,Work(ip_CilK),1)
                             Else
                               Call dGeMV_('T',nAct(j4),nAct(j3),1.0d0,
     &                                    Zpk(jp+1),nAct(j4),Work(lp),1,
     &                                    0.0d0,Work(ip_CilK),1)
                             EndIf
                           EndIf
*
                           iThpkl= jAOj+ lAOl*kBas*jBas+1
                           kp=ipAOrb(j3,iMO2)+(kSO-1)*nAct(j3)
                           Call dGeMV_('T',nAct(j3),kBas,1.0d0,
     &                         Work(kp),
     &                         nAct(j3),Work(ip_Cilk),1,1.0d0,
     &                         Thpkl(iThpkl),jBas)

                         End Do
                       End Do
                     End Do
 21                  Continue
                   EndIf
*
*                                                                      *
************************************************************************
*                                                                      *
                   If (ExFac .ne. Zero) Then
*                                                                      *
************************************************************************
*                                                                      *
*
#define _EXCHANGE_
                     If (j3.ne.j4) Then
                       If (lPSO) Then
*                     Exchange and active contributions
#define _ACTIVE_
#include "pget2_ri3.fh"
#undef _ACTIVE_
                       Else
*                     Exchange contribution
#include "pget2_ri3.fh"
                       EndIf
                     Else
#define _COULOMB_
                       If (lPSO) Then
*                     Coulomb, Exchange and active contributions
#define _ACTIVE_
#include "pget2_ri3.fh"
#undef _ACTIVE_
                       Else
*                     Coulomb and Exchange contributions
#include "pget2_ri3.fh"
                       EndIf
#undef _COULOMB_
                     End If
#undef _EXCHANGE_
*                                                                      *
************************************************************************
*                                                                      *
                   Else If (ExFac.eq.Zero .and. j3.eq.j4) Then
*                                                                      *
************************************************************************
*                                                                      *
*
#define _COULOMB_
                       If (lPSO) Then
*                     Coulomb and active contributions
#define _ACTIVE_
#include "pget2_ri3.fh"
#undef _ACTIVE_
                       Else
*                     Coulomb only contribution
#include "pget2_ri3.fh"
                       EndIf
#undef _COULOMB_
*                                                                      *
************************************************************************
*                                                                      *
                   End If
*                                                                      *
************************************************************************
*                                                                      *
*
                   ExFac = ExFac_
*
 410            Continue
 310         Continue
          End Do
*
            End Do
         End Do
      End Do
      If (nPSO.ne.MemSO2) Then
        Write (6,*) ' PGET_RI3: nPSO.ne.MemSO2'
        Write (6,*) nPSO, MemSO2
        Call Abend
      End If
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' In PGET_RI3:PSO ',' ',PSO,nijkl,nPSO)
      End If
      Call GetMem(' Exit PGET_RI3','CHECK','REAL',iDum,iDum)
#endif

      Call CWTime(Cpu2,Wall2)
      Cpu = Cpu2 - Cpu1
      Wall = Wall2 - Wall1
      tbvec(1) = tbvec(1) + Cpu
      tbvec(2) = tbvec(2) + Wall
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iBas)
         Call Unused_logical(Shijij)
         Call Unused_real_array(DSSO)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE IAIBCM_GAS(LCMBSPC,ICMBSPC, MNMXOC, NOCTPA, NOCTPB,
     &                         IOCA,   IOCB, NELFTP,MXPNGAS,   NGAS,
     &                        IOCOC,IPRNT,I_RE_MS2_SPACE,I_RE_MS2_VALUE)
*
* Allowed combinations of alpha and beta types, GAS version
*
*
* =====
*.Input
* =====
*
* LCMBSPC : Number of GAS spaces included in this expnasion
* ICMBSPC : Gas spaces included in this expansion
*
* MXMNOC(IGAS,1,IGASSPC) : Min accumulated occ for AS 1-IGAS for space IGASSPC
* MXMNOC(IGAS,2,IGASSPC) : Max accumulated occ for AS 1-IGAS for space IGASSPC
*
* NOCTPA : Number of alpha types
* NOCTPB : Number of beta types
*
* IOCA(IGAS,ISTR) occupation of AS IGAS for alpha string type ISTR
* IOCB(IGAS,ISTR) occupation of AS IGAS for beta  string type ISTR
*
* MXPNGAS : Largest allowed number of gas spaces
* NGAS    : Actual number of gas spaces

*
* ======
*.Output
* ======
*
* IOCOC(IATP,IBTP)  = 1 =>      allowed combination
* IOCOC(IATP,IBTP)  = 0 => not allowed combination
*
*.Input
      INTEGER ICMBSPC(LCMBSPC)
      INTEGER MNMXOC(MXPNGAS,2,*)
C     INTEGER MNOCC(NGAS),MXOCC(NGAS)
      INTEGER IOCA(MXPNGAS,NOCTPA),IOCB(MXPNGAS,NOCTPB)
      INTEGER NELFTP(*)
*.Output
      INTEGER IOCOC(NOCTPA,NOCTPB)
*
      NTEST = 0
      NTEST = MAX(NTEST,IPRNT)
      IF(NTEST.GE.10) THEN
        WRITE(6,*) ' IAICBM_GAS entered '
        WRITE(6,*) ' ==================='
        WRITE(6,*)
        WRITE(6,*) ' Number of GAS spaces included ', LCMBSPC
        WRITE(6,*) ' GAS spaces included ',(ICMBSPC(II),II=1,LCMBSPC)
        WRITE(6,*)
        IF(NTEST.GE.20) THEN
          WRITE(6,*) ' IOCA and IOCB '
          CALL IWRTMA(IOCA,NGAS,NOCTPA,MXPNGAS,NGAS)
          CALL IWRTMA(IOCB,NGAS,NOCTPB,MXPNGAS,NGAS)
        END IF
      END IF
*
      CALL ISETVC(IOCOC,0,NOCTPA*NOCTPB)
      DO 100 IATP = 1, NOCTPA
         DO 90 IBTP = 1, NOCTPB
*. is this combination allowed in any of the GAS spaces included
           INCLUDE = 0
           DO JJCMBSPC = 1, LCMBSPC
             JCMBSPC = ICMBSPC(JJCMBSPC)
             IEL = 0
             IAMOKAY = 1
             DO IGAS = 1, NGAS
               IEL = IEL
     &             + NELFTP(IOCA(IGAS,IATP))+NELFTP(IOCB(IGAS,IBTP))
               IF(IEL.LT.MNMXOC(IGAS,1,JCMBSPC).OR.
     &            IEL.GT.MNMXOC(IGAS,2,JCMBSPC))
     &         IAMOKAY = 0
             END DO
             IF(IAMOKAY.EQ.1) INCLUDE = 1
           END DO
*
c           IF(I_RE_MS2_SPACE.NE.0) THEN
c*. Spin projection after space I_RE_MS2_SPACE :
c             MS2_INTERM = 0
c             DO IGAS = 1, I_RE_MS2_SPACE
c               MS2_INTERM = MS2_INTERM +
c     &         NELFTP(IOCA(IGAS,IATP))-NELFTP(IOCB(IGAS,IBTP))
c             END DO
c             IF(MS2_INTERM.NE.I_RE_MS2_VALUE) THEN
c               INCLUDE = 0
c             END IF
c           END IF

           IF(INCLUDE .EQ.1) THEN
*. Congratulations , you are allowed
              IOCOC(IATP,IBTP) = 1
          END IF
   90   CONTINUE
  100 CONTINUE
*
      IF ( NTEST .GE. 10 ) THEN
        WRITE(6,*)
        WRITE(6,*) ' Matrix giving allowed combinations of types '
        WRITE(6,*)
        CALL IWRTMA(IOCOC,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_integer(I_RE_MS2_SPACE)
         CALL Unused_integer(I_RE_MS2_VALUE)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

function Cho_VecBuf_Integrity_OK(Tol,Report)
!
! Thomas Bondo Pedersen, September 2012.
!
! Check Cholesky vector buffer integrity: compute norm and sum of
! vectors in the buffer and compare these values to the table
! generated at buffer initialization.

use Cholesky, only: CHVBFI, CHVBUF, InfVec, ip_CHVBFI_SYM, ip_CHVBUF_SYM, l_CHVBFI_SYM, LuPri, nDimRS, nSym, nVec_in_Buf
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: Cho_VecBuf_Integrity_OK
real(kind=wp), intent(in) :: Tol
logical(kind=iwp), intent(in) :: Report
integer(kind=iwp) :: ipV, iSym, jRed, jVec, n, nErr
logical(kind=iwp) :: OK
real(kind=wp) :: Nrm, Sm
real(kind=wp), external :: dDot_

nErr = 0
if (allocated(CHVBUF) .and. allocated(CHVBFI) .and. allocated(nDimRS)) then
  do iSym=1,nSym
    if ((nVec_in_Buf(iSym) > 0) .and. (l_ChVBfI_Sym(iSym) > 0)) then
      ipV = ip_ChVBuf_Sym(iSym)
      do jVec=1,nVec_in_Buf(iSym)
        jRed = InfVec(jVec,2,iSym)
        n = nDimRS(iSym,jRed)
        Nrm = sqrt(dDot_(n,CHVBUF(ipV),1,CHVBUF(ipV),1))
        Sm = sum(CHVBUF(ipV:ipV+n-1))
        OK = (abs(Nrm-CHVBFI(1,ip_ChVBfI_Sym(iSym)+jVec)) < Tol) .and. (abs(Sm-CHVBFI(2,ip_ChVBfI_Sym(iSym)+jVec)) < Tol)
        if (.not. OK) then
          nErr = nErr+1
          if (Report) then
            write(LuPri,'(A,I7,A,I2,A,I9)') 'Buffer corrupted: vector',jVec,' sym.',iSym,' dim.',n
            write(LuPri,'(3X,3(A,ES25.16))') 'Norm=',Nrm,' Reference=',CHVBFI(1,ip_ChVBfI_Sym(iSym)+jVec),' Diff=', &
                                                Nrm-CHVBFI(1,ip_ChVBfI_Sym(iSym)+jVec)
            write(LuPri,'(3X,3(A,ES25.16))') 'Sum= ',Sm,' Reference=',CHVBFI(2,ip_ChVBfI_Sym(iSym)+jVec),' Diff=', &
                                                Sm-CHVBFI(2,ip_ChVBfI_Sym(iSym)+jVec)
          end if
        end if
        ipV = ipV+n
      end do
    end if
  end do
end if
if (Report) then
  if (nErr /= 0) then
    write(LuPri,'(A,I7,A,ES25.16)') 'Buffer corrupted for ',nErr,' vectors. Tolerance=',Tol
  else
    write(LuPri,'(A,ES25.16)') 'Buffer integrity OK. Tolerance=',Tol
  end if
end if
Cho_VecBuf_Integrity_OK = nErr == 0

end function Cho_VecBuf_Integrity_OK

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine max5h2 (wrk,wrksize,
     & nind,mapd,mapi,rmax,imax,text)
c
c     this routine write:
c     a) note
c     b) 5 maximal elements with their indexes in given vector V
c     c) euclidian norm
c
c     nind  - number of indexes in V (I)
c     mapd  - direct map of V (I)
c     mapi  - inverese map of V (I)
c     rmax  - store of maximal values (I)
c     imax  - store of corr. indexes (I)
c     text  - notice (I)
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer nind
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
       integer imax(1:8,1:5)
       real*8 rmax (1:5)
       character*8 text
c
c     help variables
c
       integer nhelp1,nhelp2,rc
       real*8 scalar
c
c1    write notice
c
       write(6,101) text
 101    format (' Five largest amplitudes of :',a8)
c
c2    write 5 maximal amplitudes
c
       write(6,102)
 102    format ('  SYMA   SYMB   SYMI   SYMJ     A      B',
     &          '      I      J     VALUE')
       do 10 nhelp1=1,5
       write(6,103) (imax(nhelp2,nhelp1),nhelp2=1,8),rmax(nhelp1)
 103    format (8(2x,i3,2x),f15.10)
 10     continue
c
c3    write euclidian norm
c
c3.1  calc euclidian norm
       call multdot (wrk,wrksize,
     & nind,mapd,mapi,1,mapd,mapi,1,scalar,rc)
       scalar=sqrt(scalar)
c
       write(6,104) scalar
 104    format (' Euclidian norm is :',f17.10)
c
       write(6,*)
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992, Roland Lindh                                *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine Drvk2_mck(mdede,New_Fock)
!***********************************************************************
!                                                                      *
!  Object: to precompute all pair entites as zeta, kappa, P.           *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             June '91, modified for k2 loop.                          *
!             January '92, modified to gradient calculations.          *
!             April '92, modified to use the Cauchy-Schwarz inequality *
!              to estimate the integral derivatives.                   *
!              Modified 1995 for 2nd derivatives by AB                 *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem1
use k2_setup, only: Data_k2, Indk2, nk2
use k2_arrays, only: DoGrad_, DoHess_
use iSD_data, only: iSD
use Basis_Info, only: dbsc, Shells
use Symmetry_Info, only: iOper, nIrrep
use Sizes_of_Seward, only: S
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: mdede
logical(kind=iwp), intent(in) :: New_Fock
#include "ndarray.fh"
integer(kind=iwp) :: iAng, iAngV(4), iAO, iBas, iBasi, iBsInc, iCmp, iCmpV(4), iCnt, iCnttp, iDCRR(0:7), iDeSiz, ijCmp, ijShll, &
                     iShllV(2), ipM001, ipM002, ipM003, ipM004, iPrim, iPrimi, iPrInc, iS, iShell, iShll, iSmLbl, jAng, jAO, jBas, &
                     jBasj, jBsInc, jCmp, jCnt, jCnttp, jpk2, jPrim, jPrimj, jPrInc, jS, jShell, jShll, kBask, kBsInc, kPrimk, &
                     kPrInc, lBasl, lBsInc, lPriml, lPrInc, M001, M002, M003, M004, M00d, Maxk2, MaxMem, mdci, mdcj, MemPrm, &
                     MemTmp, mk2, nBasi, nBasj, nDCRR, nHrrab, nMemab, nSkal, nSO, nZeta
real(kind=wp) :: Coor(3,2), TCpu1, TCpu2, TWall1, TWall2
real(kind=wp), allocatable :: Con(:), Data_k2_local(:), Wrk(:)
integer(kind=iwp), external :: MemSO1

!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TCpu1,TWall1)
call mma_MaxDBLE(Maxk2)
maxk2 = maxk2/2
call mma_allocate(Data_k2_local,Maxk2)
jpk2 = 1
nk2 = 0
mdede = 0
mk2 = 0

DoGrad_ = .false.
DoHess_ = .true.
!                                                                      *
!***********************************************************************
!                                                                      *
call Nr_Shells(nSkal)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(Con,S%m2Max,Label='Con')
!                                                                      *
!***********************************************************************
!                                                                      *
MemTmp = 0
do iAng=0,S%iAngMx
  MemTmp = max(MemTmp,(S%MaxPrm(iAng)*nTri_Elem1(iAng))**2)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_MaxDBLE(MaxMem)
call mma_allocate(Wrk,MaxMem,Label='Wrk')
ipM001 = 1
!                                                                      *
!***********************************************************************
!                                                                      *
do iS=1,nSkal
  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  mdci = iSD(10,iS)
  iShell = iSD(11,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  Coor(1:3,1) = dbsc(iCnttp)%Coor(1:3,iCnt)

  iAngV(1) = iAng
  iShllV(1) = iShll
  iCmpV(1) = nTri_Elem1(iAng)

  do jS=1,iS
    jShll = iSD(0,jS)
    jAng = iSD(1,jS)
    jCmp = iSD(2,jS)
    jBas = iSD(3,jS)
    jPrim = iSD(5,jS)
    jAO = iSD(7,jS)
    mdcj = iSD(10,jS)
    jShell = iSD(11,jS)
    jCnttp = iSD(13,jS)
    jCnt = iSD(14,jS)
    Coor(1:3,2) = dbsc(jCnttp)%Coor(1:3,jCnt)

    iAngV(2) = jAng
    iShllV(2) = jShll
    iCmpV(2) = nTri_Elem1(jAng)

    ! Compute FLOP's for the transfer equation.

    call mHrr(iAng,jAng,nHrrab,nMemab)
    ijCmp = nTri_Elem1(iAng)*nTri_Elem1(jAng)

    iPrimi = iPrim
    jPrimj = jPrim
    nBasi = Shells(iShllV(1))%nBasis
    nBasj = Shells(iShllV(2))%nBasis

    kPrimk = 1
    lPriml = 1
    iBasi = iPrimi
    jBasj = jPrimj
    kBask = 1
    lBasl = 1

    nZeta = iPrimi*jPrimj

    call ConMax(Con,iPrimi,jPrimj,Shells(iShll)%pCff,nBasi,Shells(jShll)%pCff,nBasj)

    iAngV(3:4) = iAngV(1:2)
    iCmpV(3:4) = iCmpV(1:2)

    ijShll = iTri(iShell,jShell)

    nSO = 1

    ! Compute memory request for the primitives, i.e. how much memory
    ! is needed up to the transfer equation.

    call MemRys(iAngV,MemPrm)

    ! Decide on the partioning of the shells based on
    ! the available memory and the requested memory.

    call PSOAO0_h(nSO,nMemab,nMemab,MemPrm,MaxMem,iAngV,iCmpV,iBasi,iBsInc,jBasj,jBsInc,kBask,kBsInc,lBasl,lBsInc,iPrimi,iPrInc, &
                  jPrimj,jPrInc,kPrimk,kPrInc,lPriml,lPrInc,ipM001,ipM002,ipM003,ipM004,M001,M002,M003,M004,M00d)
    if ((iBasi /= iBsInc) .or. (jBasj /= jBsInc)) then
      write(u6,*) 'Drvk2: (iBasi /= iBsInc) .or. (jBasj /= jBsInc)'
      write(u6,*) 'iBasi,iBsInc=',iBasi,iBsInc
      write(u6,*) 'jBasj,jBsInc=',jBasj,jBsInc
      call Abend()
    end if

    ! Find the Double Coset Representatives for center A and B.

    iDCRR(0:nIrrep-1) = iOper(0:nIrrep-1)
    nDCRR = nIrrep

    ! Compute all pair entities (zeta, kappa, Px, Py, Pz, ZInv, alpha,
    ! beta, [nm|nm] and derivative entity, a total of ten different
    ! entities) for all possible unique pairs of centers generated
    ! for the symmetry unique centers A and B.

    call k2Loop_mck(Coor,iAngV,iCmpV,iDCRR,nDCRR,Data_k2_local(jpk2),ijCmp,Shells(iShllV(1))%Exp,iPrimi,Shells(iShllV(2))%Exp, &
                    jPrimj,Shells(iShllV(1))%pCff,iBas,Shells(iShllV(2))%pCff,jBas,nMemab,Wrk(ipM002),M002,Wrk(ipM003),M003,mdci, &
                    mdcj)

    Indk2(1,ijShll) = jpk2
    Indk2(2,ijShll) = nDCRR
    nk2 = nk2+(nZeta*nDArray+nDScalar)*nDCRR
    mk2 = mk2+nDCRR

    if (New_Fock) then
      iDeSiz = 1+iPrim*jPrim+iCmp*jCmp
    else
      iDeSiz = 1+iPrim*jPrim+(iBas*jBas+1)*iCmp*jCmp
    end if
    iSmLbl = 1
    nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
    if (nSO > 0) mDeDe = mDeDe+iDeSiz*nDCRR

    jpk2 = 1+nk2

  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Wrk)
call mma_deallocate(Con)
!                                                                      *
!***********************************************************************
!                                                                      *
! Resize the memory to the actual size

call move_alloc(Data_k2_local,Data_k2)
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,'(20X,A)') ' *** The k2 entities have been precomputed ***'
write(u6,'(I7,A,I7,A)') mk2,' blocks of k2 data were computed and',nk2,' Word(*8) of memory is used for storage.'
write(u6,'(A)') ' The prescreening is based on the integral estimates.'
#endif

call CWTime(TCpu2,TWall2)
call SavTim(2,TCpu2-TCpu1,TWall2-TWall1)

return

end subroutine Drvk2_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine MOAcc(AOInt,nint,Temp1,Temp2,Temp3,nTemp,
     &      MOInt,nMO,ishell,
     &      Ci,nCi,Cj,nCj,Ck,nCk,Cl,nCl,moip,nACO,pert,nOp,
     &      iBasa,iCmpa,icar,icnt,indgrd,D,fact,iao,iaost,
     &      Buffer,Tempi,nij,nkl,nbasi,nbasj,icmp,jcmp)
************************************************************************
*                                                                      *
*     Transforms a batch of unsymmetrized integrals to                 *
*     active integral batches and FM                                   *
*     All MO combinations are constructed                              *
*     They will be needed with unsymmetric perurbations                *
*                                                                      *
*     Author: Anders Bernhardsson, Dept. of Theoretical Chemistry,     *
*             University of Lund, Sweden. Januar '96                   *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChTbl, iOper
      use Real_Info, only: CutInt
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "etwas.fh"
c#include "print.fh"
      Real*8 AOInt(nkl,nij),MOint(nMO),
     &       Temp1(nTemp),Temp2(naco,naco),
     &       Ck(nCk),Cl(nCl),D(*),
     &       Buffer(nbasi,icmp,nbasj,jcmp,0:nirrep-1,
     &       nAco*(naco+1)/2,*)
      Integer moip(0:7),nOp(4),
     &          ishell(4),iao(4),iAOST(4),
     &          ibasa(4),icmpa(4),indgrd(3,4,0:7)
      Logical pert(0:7)
      Real*8 Prmt(0:7)

      Data Prmt/1.d0,-1.d0,-1.d0,1.d0,-1.d0,1.d0,1.d0,-1.d0/

*
*     Statement Function
*
      xPrmt(i,j) = Prmt(iAnd(i,j))
*
      iCB=2**(icar-1)
      rFact=xPrmt(ioper(nOp(icnt)),icb)*fact
*
      iBas=iBasa(1)
      jBas=iBasa(2)
      kBas=iBasa(3)
      lBas=iBasa(4)
*
      kCmp=iCmpa(3)
      lCmp=iCmpa(4)
      kk=0
      Do kIrrep=0,nIrrep-1
       sfact=DBLE(ichtbl(kirrep,nop(3)))
       Do kAsh=1,nAsh(kIrrep)
        Do k=1,kcmp*kbas
         kk=kk+1
         Ck(kk)=Ck(kk)*sFact
        End Do
       End Do
      End Do
      kk=0
      Do kIrrep=0,nIrrep-1
       sfact=DBLE(ichtbl(kirrep,nop(4)))
       Do kAsh=1,nAsh(kIrrep)
        Do k=1,lcmp*lbas
         kk=kk+1
         Cl(kk)=Cl(kk)*sFact
        End Do
       End Do
      End Do
      rk = DNrm2_(nck,ck,1)
      rl = DNrm2_(ncl,cl,1)
      ij=0
      nt=lBas*lCmp*kcmp*kbas
      Do jc=1,jcmp
       Do jb=1+iaost(2),iaost(2)+jbas
        Do ic=1,icmp
        Do ib=1+iaost(1),iaost(1)+ibas
*
          ij=ij+1
          vij = DNrm2_(nt,AOInt(1,ij),1)
          If (Abs(vij*rk*rl).lt.cutint) goto 1000
          ipC=0
          Do kAsh=1,nAco
           ipM=(kAsh-1)*lbas*lcmp
           il=0
           Do i=1,lbas*lcmp
            Temp1(i+ipM)=0.0d0
            Do k=1,kCmp*kBas
             il=il+1
             Temp1(i+ipM)=Temp1(ipm+i)+Ck(k+ipc)*AOINT(il,ij)
            End Do
           End Do
           ipC=ipC+kBas*kCmp
          End Do
          ipC=0
          Do lAsh=1,naco
           il=0
           Do kash=1,naco
            Temp2(kash,lash)=0.0d0
            Do l=1,lbas*lcmp
             il=il+1
             Temp2(kash,lash)=Temp2(kash,lash)+
     &            Cl(ipc+l)*Temp1(il)
            End Do
           End Do
            ipC=ipC+lBas*lCmp
          End Do
*
          If (iShell(3).ne.ishell(4)) Then

          do iSPert=0,nIrrep-1
          If (pert(isPert)) Then
           rFact2=rFact*DBLE(iChtbl(ispert,nop(icnt)))
           llash=0
           k=abs(indgrd(icar,icnt,ispert))
           j=0
           Do lIrr=0,nIrrep-1
            Do lAsh=1,nAsh(lIrr)
             Do kIrr=0,lIrr
              irest=iEOR(iEOR(ioper(ispert),ioper(kirr)),ioper(lirr))
              kMax=nAsh(kIrr)
              If (kIrr.eq.lIrr) kMax=lAsh
              Do kAsh=1,kMax
               kk=kash+moip(kirr)
               ll=lash+moip(lirr)
               j=j+1
               Do jIrr=0,nIrrep-1
                rPj=DBLE(iChTbl(jIrr,nop(2)))
                 iirr=nropr(ieor(iOPER(jirr),irest))
                 rPij=rPj*DBLE(iChTbl(iIrr,nop(1)))*rfact2
                 buffer(ib,ic,jb,jc,iirr,j,k)=
     &               buffer(ib,ic,jb,jc,iirr,j,k)+
     &               rpij*Temp2(kk,ll)+
     &               rpij*Temp2(ll,kk)
               End Do
              End Do
             End Do
            End Do
           End Do
          End If
          End Do
          Else
*
          do iSPert=0,nIrrep-1
          If (pert(isPert)) Then
           rFact2=rFact*DBLE(iChtbl(ispert,nop(icnt)))
           llash=0
           k=abs(indgrd(icar,icnt,ispert))
           j=0
           Do lIrr=0,nIrrep-1
            Do lAsh=1,nAsh(lIrr)
             Do kIrr=0,lIrr
              irest=iEOR(iEOR(ioper(ispert),ioper(kirr)),ioper(lirr))
              kMax=nAsh(kIrr)
              If (kIrr.eq.lIrr) kMax=lAsh
              Do kAsh=1,kMax
               kk=kash+moip(kirr)
               ll=lash+moip(lirr)
               j=j+1
               Do jIrr=0,nIrrep-1
                rPj=DBLE(iChTbl(jIrr,nop(2)))
                iirr=nropr(ieor(iOPER(jirr),irest))
                rPij=rPj*DBLE(iChTbl(iIrr,nop(1)))*rfact2
                buffer(ib,ic,jb,jc,iirr,j,k)=
     &              buffer(ib,ic,jb,jc,iirr,j,k)+
     &              rpij*Temp2(kk,ll)
               End Do
              End Do
             End Do
            End Do
           End Do
          End If
          End Do
          End if
 1000     Continue
         End Do
        End Do
       End Do
      End Do
*
      kk=0
      Do kIrrep=0,nIrrep-1
       sfact=DBLE(ichtbl(kirrep,nop(3)))
       Do kAsh=1,nAsh(kIrrep)
        Do k=1,kcmp*kbas
         kk=kk+1
         Ck(kk)=Ck(kk)*sFact
        End Do
       End Do
      End Do
      kk=0
      Do kIrrep=0,nIrrep-1
       sfact=DBLE(ichtbl(kirrep,nop(4)))
       Do kAsh=1,nAsh(kIrrep)
        Do k=1,lcmp*lbas
         kk=kk+1
         Cl(kk)=Cl(kk)*sFact
        End Do
       End Do
      End Do

      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nint)
         Call Unused_real(Temp3)
         Call Unused_real_array(MOInt)
         Call Unused_real(Ci)
         Call Unused_integer(nCi)
         Call Unused_real(Cj)
         Call Unused_integer(nCj)
         Call Unused_real_array(D)
         Call Unused_integer_array(iao)
         Call Unused_real(Tempi)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************
! based on rhsall2
!
! In principle, For E = T_{ij}^{ab}*(ia|jb).
! With p and q for general orbitals,
! L_{pq} = (pa|jb)*T_{qj}^{ab} + (ip|jb)*T_{ij}^{qb}
!        + (ia|pb)*T_{iq}^{ab} + (ia|jp)*T_{ij}^{aq}
! For the first term, with P and Q for auxiliary orbitals
! L_{pq}(1) = (pa|jb)*T_{qj}^{ab}
!           = (pa|P)*(P|jb) * T_{qj}^{ab} (2c-2e is omitted?)
!           = (pa|P) * tilde{T}_{qa}^P
!           = C_{mu p}*C_{nu a}*(mu nu|P) * tilde{T}_{qa}^P
!           = C_{mu p} * (mu nu|P) * V_{nu q}^P
! where
! tilde{T}_{ia}^P = T_{ij}^{ab} * (P|jb)
! V_{mu p}^P      = tilde{T}_{pa}^P * C_{mu a}
!
! Dimension of tilde{T} will be the same as that of (ia|P) in MO,
! where (i,a) = (inact,active), (inact,virtual), (active,virtual)
!
! tilde{T} is constructed in this file.
! tilde{T} -> V_{mu p}^P transformations, contraction with 3c-2e,
! and construction of the orbital Lagrangian (L_{pq}) is elsewhere
! ... maybe in OLagVVVO
!
!-----------------------------------------------------------------------
!
! For the ERI derivative calculation,
! d(mu nu|rho sigma)/da
! = d/da (mu nu|P) (P|Q)^-1 (Q|rho sigma)
! = d(mu nu|P)/da (P|Q)^-1 (Q|rho sigma)
!   + (mu nu|P) d(P|Q)^-1/da (Q|rho sigma)
!   + (mu nu|P) (P|Q)^-1 d(Q|rho sigma)/da
! = d(mu nu|P)/da (P|Q)^-1 (Q|rho sigma)
!   - (mu nu|P) (P|R)^-1 d(R|S)/da (S|Q)^-1 (Q|rho sigma)
!   + (mu nu|P) (P|Q)^-1 d(Q|rho sigma)/da
! = d(mu nu|P)/da (tP|rho sigma)
!   - (mu nu|tP) d(P|Q)/da (tQ|rho sigma)
!   + (mu nu|tP) d(P|rho sigma)/da
! where (mu nu|tP) = (mu nu|Q)*(Q|P)^-1
!
! D_{mu nu rho sigma}*d(mu nu|rho sigma)/da
! = d(mu nu|P)/da (tP|rho sigma) * D_{mu nu rho sigma}
!   - (mu nu|tP) d(P|Q)/da (tQ|rho sigma) * D_{mu nu rho sigma}
!   + (mu nu|tP) d(P|rho sigma)/da * D_{mu nu rho sigma}
! = d(mu nu|P)/da tD_{mu nu}^tP
!   - (mu nu|tP) d(P|Q)/da tD_{mu nu}^tQ
!   + tD_{rho sigma}^tP d(P|rho sigma)/da
! where tD_{mu nu}^tP = D_{mu nu rho sigma} * (rho sigma|tP)
! In practice, tD_{pq}^tP is constructed and saved in disk.
! This will be read when 3c-2e ERI derivatives are concerned,
! and MO->AO transformations will be done on-the-fly.
! Note that MO coefficients of CASPT2 have to be used.
!
! For 2c-2e ERI derivatives,
! D(tP,tQ) = tD_{pq} * C_{mu p} C_{nu q} * (mu nu|tP)
! then saved.

subroutine OLagNS_RI(iSym0,NBSQT,MaxVec_PT2,DPT2C,DPT2Canti,A_PT2)

use Symmetry_Info, only: Mul
use CHOVEC_IO, only: NVLOC_CHOBATCH
use PrintLevel, only: VERBOSE
use EQSOLV, only: IVECC2
use fake_GA, only: GA_Arrays
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB, GA_Create_Irreg, GA_Destroy, GA_NNodes, GA_NodeId, MT_DBL
use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array
use Para_Info, only: Is_Real_Par
#endif
use caspt2_global, only: do_csf, iPrGlb, iStpGrd
use caspt2_module, only: HZERO, NACTEL, NAES, NAGEB, NAGEBES, NAGTB, NAGTBES, NASH, NASUP, NBTCH, NBTCHES, NFRO, NIES, NIGEJ, &
                         NIGEJES, NIGTJ, NIGTJES, NINABX, NINDEP, NISH, NISUP, NSECBX, NSES, NSSH, NSYM, NTGEU, NTGEUES, NTGTU, &
                         NTGTUES, NTU, NTUES, NTUV, NTUVES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Half, Quart, OneHalf
use Definitions, only: wp, iwp, u6

#include "macros.fh"

implicit none
integer(kind=iwp), intent(in) :: iSym0, NBSQT, MaxVec_PT2
real(kind=wp), intent(inout) :: DPT2C(NBSQT), DPT2Canti(NBSQT), A_PT2(MaxVec_PT2,MaxVec_PT2)
integer(kind=iwp) :: IAABS, IAEND, IAGEC, IAGTC, IAJ, IAJSTA, iAtot, IB, IB1, IB2, IBEND, IBGRP, IBSTA, ICABS, ICASE, ICEND, ICL, &
                     ICLSTA, IJABS, IJEND, IJGEL, IJGTL, iJtot, ILABS, ILEND, ILMAX, IO, IO1, IO2, IOFFCV, ipT, ipTanti, ipTM, &
                     ipTP, ISAB, ISI, ISIJ, iStpGrd_sav, ISYA, ISYAC, ISYC, ISYII, ISYJ, ISYJL, ISYL, iSym, ISYT, ISYU, ISYV, &
                     ISYX, ITABS, iTtot, IUABS, iUtot, IVABS, IVMAX, iVtot, IW, IW1, IW2, IXABS, IXMAX, iXtot, JBEND, JBGRP, &
                     JBSTA, JGEL, JGTL, JOFFCV, JSYM, KAJ, KCL, MXBGRP, MXPIQK, NADDBUF, NAS, NAS1, NASM, NASP, NASZ, NBGRP, nBra, &
                     NBXSZA, NBXSZC, NBXSZJ, NBXSZL, NCHOBUF, NCSZ, NIN, NINM, NINP, NIS, NISM, NISP, NJSZ, nKet, nOrbA, nSh(8,3), &
                     NV, NVEC, NVI, NVJ, NW, NWA, NWBM, NWBP, NWC, NWD, NWEM, NWEP, NWFM, NWFP, NWGM, NWGP, NWHM, NWHP
real(kind=wp) :: SCL, SCL1, SCLNEL
integer(kind=iwp), allocatable :: BGRP(:,:)
real(kind=wp), allocatable :: BRA(:), BRAD(:), KET(:), KETD(:), PIQK(:)
integer(kind=iwp), parameter :: Inactive = 1, Active = 2, Virtual = 3
real(kind=wp), parameter :: SQ2 = sqrt(Two), SQ3 = sqrt(Three), SQ05 = sqrt(Half), SQ32 = sqrt(OneHalf)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: i, lg_V, lg_V1, myRank, ndim2, NPROCS
integer(kind=iwp), allocatable :: map2(:)
#endif

nSh(1:nSym,Inactive) = NISH(1:nSym)
nSh(1:nSym,Active) = NASH(1:nSym)
nSh(1:nSym,Virtual) = NSSH(1:nSym)

if (IPRGLB >= VERBOSE) write(u6,'(1X,A)') ' Using RHSALL2+ADDRHS algorithm'

!iVec = iVecX
iSym = iSym0
SCLNEL = One/real(max(1,NACTEL),kind=wp)
!                                                                      *
!***********************************************************************
!                                                                      *
do JSYM=1,NSYM

  IB1 = NBTCHES(JSYM)+1
  IB2 = NBTCHES(JSYM)+NBTCH(JSYM)

  MXBGRP = IB2-IB1+1
  if (MXBGRP <= 0) cycle
  call mma_allocate(BGRP,2,MXBGRP,Label='BGRP')
  BGRP(1,1:IB2-IB1+1) = [(IB,IB=IB1,IB2)]
  BGRP(2,1:IB2-IB1+1) = [(IB,IB=IB1,IB2)]
  NBGRP = MXBGRP

  !! With iStpGrd = -1, we try to allocate 4 large arrays
  iStpGrd_sav = iStpGrd
  iStpGrd = -1
  call MEMORY_ESTIMATE(JSYM,BGRP,NBGRP,NCHOBUF,MXPIQK,NADDBUF)
  iStpGrd = iStpGrd_sav
  if (IPRGLB > VERBOSE) then
    write(u6,*)
    write(u6,'(A,I12)') '  Number of Cholesky batches: ',IB2-IB1+1
    write(u6,'(A,I12)') '  Number of batch groups:     ',NBGRP
    write(u6,*)
  end if
  ! buffers are kept allocated until the end of JSYM loop.
  call mma_allocate(PIQK,MXPIQK,Label='PIQK')
  call mma_allocate(BRA,NCHOBUF,Label='BRABUF')
  call mma_allocate(KET,NCHOBUF,Label='KETBUF')
  call mma_allocate(BRAD,NCHOBUF,Label='BRAD')
  call mma_allocate(KETD,NCHOBUF,Label='KETD')

  ! Loop over groups of batches of Cholesky vectors

  IOFFCV = 1
  do IBGRP=1,NBGRP

    IBSTA = BGRP(1,IBGRP)
    IBEND = BGRP(2,IBGRP)

    NV = sum(NVLOC_CHOBATCH(IBSTA:IBEND))

    if (IPRGLB > VERBOSE) then
      write(u6,'(A,I12)') '  Cholesky vectors in this group = ',NV
      write(u6,*)
    end if

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      myRank = GA_NodeID()
      NPROCS = GA_nNodes()

      call mma_allocate(MAP2,NPROCS,Label='MAP2')
      MAP2(:) = 0
      MAP2(myRank+1) = NV
      call GAIGOP(MAP2,NPROCS,'+')
      ndim2 = sum(map2)

      do i=nprocs,2,-1
        map2(i) = sum(map2(1:i-1))+1
      end do
      map2(1) = 1
    end if
#   endif
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read kets (Cholesky vectors) in the form L(VX), all symmetries:

    call Get_Cholesky_Vectors(Active,Active,JSYM,KET,size(KET),nKet,IBSTA,IBEND)
    KETD(1:nKet) = Zero

    if (HZERO == 'DYALL') call OLagNS_RI2(Active,Active,Active,Active,'N ',size(KET),size(KET),KET,KET,KETD,KETD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read bra (Cholesky vectors) in the form L(TJ): All symmetries

    call Get_Cholesky_Vectors(Inactive,Active,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    BRAD(1:nBra) = Zero
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Assemble contributions to TJVX
    ! Loop over the bras and kets, form <A|0>

    call OLagNS_RI2(Inactive,Active,Active,Active,'A ',size(BRA),size(KET),BRA,KET,BRAD,KETD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! TJVL RHSB
    ! TJVL: Use TJ buffer as if it was VL, form <B|0>

    !nKet = nBra
    call OLagNS_RI2(Inactive,Active,Inactive,Active,'B ',size(BRA),size(BRA),BRA,BRA,BRAD,BRAD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read bra (Cholesky vectors) in the form L(AJ), form <D1|0>
    ! We still have L(VX) vectors in core, at KETS.

    call Cholesky_Vectors(1,Inactive,Active,JSYM,BRAD,size(BRAD),nBra,IBSTA,IBEND)
    call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    BRAD(1:nBra) = Zero
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AJVX RHSD1
    ! Loop over the bra and ket vectors.

    call OLagNS_RI2(Inactive,Virtual,Active,Active,'D1',size(BRA),size(KET),BRA,KET,BRAD,KETD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AJCL RHSH
    ! AJCL: Use AJ buffer still in core as if it was CL, form <H|0>

    !nKet = nBra
    call OLagNS_RI2(Inactive,Virtual,Inactive,Virtual,'H ',size(BRA),size(BRA),BRA,BRA,BRAD,BRAD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read Bra (Cholesky vectors)= L(AU)

    call Cholesky_Vectors(1,Inactive,Virtual,JSYM,BRAD,size(BRAD),nBra,IBSTA,IBEND)
    call Get_Cholesky_Vectors(Active,Virtual,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    BRAD(1:nBra) = Zero
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AUVX RHSC
    ! AUVX: Loop over the bras and kets

    call OLagNS_RI2(Active,Virtual,Active,Active,'C ',size(BRA),size(KET),BRA,KET,BRAD,KETD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AUCX RHSF
    ! AUCX: Use AU buffer still in core as if it was CX, form <F|0>

    !     nKet = nBra
    call OLagNS_RI2(Active,Virtual,Active,Virtual,'F ',size(BRA),size(BRA),BRA,BRA,BRAD,BRAD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read kets (Cholesky vectors) in the form L(VL), all symmetries:

    call Cholesky_Vectors(1,Active,Active,JSYM,KETD,size(KETD),nKet,IBSTA,IBEND)
    call Get_Cholesky_Vectors(Inactive,Active,JSYM,KET,size(KET),nKet,IBSTA,IBEND)
    call Cholesky_Vectors(2,Inactive,Active,JSYM,KETD,size(KETD),nKet,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AUVL RHSD2
    ! Loop over bras and kets, form <D2|0>.

    call OLagNS_RI2(Active,Virtual,Inactive,Active,'D2',size(BRA),size(KET),BRA,KET,BRAD,KETD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read kets (Cholesky vectors) in the form L(CL), all symmetries:

    call Cholesky_Vectors(1,Inactive,Active,JSYM,KETD,size(KETD),nKet,IBSTA,IBEND)
    call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,KET,size(KET),nKet,IBSTA,IBEND)
    call Cholesky_Vectors(2,Inactive,Virtual,JSYM,KETD,size(KETD),nKet,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AUCL RHSG
    ! Loop over bras and kets, form  <G|0>

    call OLagNS_RI2(Active,Virtual,Inactive,Virtual,'G ',size(BRA),size(KET),BRA,KET,BRAD,KETD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read bra vectors AJ

    call Cholesky_Vectors(1,Active,Virtual,JSYM,BRAD,size(BRAD),nBra,IBSTA,IBEND)
    call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    BRAD(1:nBra) = KETD(1:nBra)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read kets in the form L(VL)

    call Get_Cholesky_Vectors(Inactive,Active,JSYM,KET,size(KET),nKet,IBSTA,IBEND)
    call Cholesky_Vectors(2,Inactive,Active,JSYM,KETD,size(KETD),nKet,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AJVL RHSE
    ! AJVL: Loop over bras and kets. Form <E|0>

    call OLagNS_RI2(Inactive,Virtual,Inactive,Active,'E ',size(BRA),size(KET),BRA,KET,BRAD,KETD)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! End of loop over batches, IB
    call Cholesky_Vectors(1,Inactive,Virtual,JSYM,BRAD,size(BRAD),nBra,IBSTA,IBEND)
    call Cholesky_Vectors(1,Inactive,Active,JSYM,KETD,size(KETD),nKet,IBSTA,IBEND)
    !! Construct A_PT2
    NVI = NV
    JOFFCV = 1
    do JBGRP=1,NBGRP

      JBSTA = BGRP(1,JBGRP)
      JBEND = BGRP(2,JBGRP)

      NVJ = sum(NVLOC_CHOBATCH(JBSTA:JBEND))

      !! BraAI
      call Cnst_A_PT2(Inactive,Active)

      !! BraSI
      call Cnst_A_PT2(Inactive,Virtual)

      !! BraSA
      call Cnst_A_PT2(Active,Virtual)

      !! BraAA
      call Cnst_A_PT2(Active,Active)
      JOFFCV = JOFFCV+NVJ
    end do !! end of JBGRP loop
    IOFFCV = IOFFCV+NVI
  end do !! end of IBGRP loop
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call mma_deallocate(BRA)
  call mma_deallocate(KET)
  call mma_deallocate(BRAD)
  call mma_deallocate(KETD)
  call mma_deallocate(PIQK)
  call mma_deallocate(BGRP)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! End of loop over JSYM
end do
#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) call mma_deallocate(map2)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Synchronized add RHS partial arrays from all nodes into each node.

!-SVC: read the DRA's from disk and copy them all to LUSOLV to continue
!      in serial mode.  FIXME: this call has to be removed when we reach
!      full parallel capabilities
!call SYNRHS(IVEC)
!-SVC: at this point, the RHS elements are on disk, both in LUSOLV and
!      as DRAs with the name RHS_XX_XX_XX with XX a number representing
!      the case, symmetry, and rhs vector respectively.

A_PT2(:,:) = Two*A_PT2(:,:)

if (NBGRP /= 0) SCLNEL = SCLNEL/real(NBGRP,kind=wp)
DPT2C(1:NBSQT) = DPT2C(1:NBSQT)*SCLNEL
if (do_csf) DPT2Canti(1:NBSQT) = DPT2Canti(1:NBSQT)*SCLNEL

#ifdef _MOLCAS_MPP_
if (is_real_par()) call GADGOP(A_PT2,MaxVec_PT2**2,'+')
#endif

return

contains

subroutine OLagNS_RI2(ITI,ITP,ITK,ITQ,iCase,nBra,nKet,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD)

  use caspt2_global, only: iPrGlb
  use PrintLevel, only: DEBUG

  integer(kind=iwp), intent(in) :: ITI, ITP, ITK, ITQ, nBra, nKet
  character(len=2), intent(in) :: iCase
  real(kind=wp), intent(in) :: Cho_Bra(nBra), Cho_Ket(nKet)
  real(kind=wp), intent(inout) :: Cho_BraD(nBra), Cho_KetD(nKet)
  integer(kind=iwp) :: ISYI, ISYK, ISYP, ISYQ, KPI, KQK, LBRASM, LKETSM, NBRASM, NI, NK, NKETSM, NP, NPI, NPIQK, NQ, NQK
  real(kind=wp) :: TotCPU0, TotCPU1, TotWall0, TotWall1

  if (iPrGlb >= DEBUG) write(u6,*) 'Processing RHS block '//iCase

  LBRASM = 1
  call CWTime(TotCPU0,TotWall0)
  do ISYI=1,NSYM
    NI = NSH(ISYI,ITI)
    if (NI == 0) cycle
    ISYP = Mul(ISYI,JSYM)
    NP = NSH(ISYP,ITP)
    if (NP == 0) cycle
    NPI = NP*NI
    NBRASM = NPI*NV

    LKETSM = 1
    do ISYK=1,NSYM
      NK = NSH(ISYK,ITK)
      if (NK == 0) cycle
      ISYQ = Mul(ISYK,JSYM)
      NQ = NSH(ISYQ,ITQ)
      if (NQ == 0) cycle
      NQK = NQ*NK
      NKETSM = NQK*NV

      ! SVC: we need an NPI*NQK to store the 2-electron integrals, and 2
      ! buffers (values+indices) for sorting them.  Later, we can try to get
      ! rid of the buffer that stores the values and only use an index buffer
      ! and the two-electron integrals for the scatter operation.  For the
      ! buffer, any size can be taken, but assuming there is enough memory
      ! available, it's set to the size of the two-electron integrals unless
      ! larger than some predefined maximum buffer size.
      NPIQK = NPI*NQK
      if (NPIQK > MXPIQK) then
        if (iCase == 'H') then
          KPI = MXPIQK/NQK
          NPIQK = KPI*NQK
        else if (iCase == 'G') then
          KQK = MXPIQK/NPI
          NPIQK = NPI*KQK
        else
          write(u6,*) ' NPIQK > MXPIQK and case != G or H'
          write(u6,'(A,A2)') ' CASE =   ',iCase
          write(u6,'(A,I12)') ' NPIQK =  ',NPIQK
          write(u6,'(A,I12)') ' MXPIQK = ',MXPIQK
          write(u6,*) ' This should not happen, please report.'
          call AbEnd()
        end if
      end if

      if (NPIQK <= 0) then
        write(u6,'(1X,A)') ' ADDRHS: zero-sized NPIQK'
        call AbEnd()
      end if

      !! NBUFF(=nAddBuf) is removed
      select case (iCase)
        case ('A ')
          call OLagNS_RI_A(ISYI,ISYK,NP,NI,NQ,NK,PIQK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case ('B ')
          call OLagNS_RI_B(ISYI,ISYK,NP,NI,NQ,NK,PIQK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case ('D1')
          call OLagNS_RI_D1(ISYI,ISYK,NP,NI,NQ,NK,PIQK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case ('H ')
          call OLagNS_RI_H(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case ('C ')
          call OLagNS_RI_C(ISYI,ISYK,NP,NI,NQ,NK,PIQK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case ('F ')
          call OLagNS_RI_F(ISYI,ISYK,NP,NI,NQ,NK,PIQK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case ('D2')
          call OLagNS_RI_D2(ISYI,ISYK,NP,NI,NQ,NK,PIQK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case ('G ')
          call OLagNS_RI_G(ISYI,ISYK,NP,NI,NQ,NK,PIQK,NPIQK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case ('E ')
          call OLagNS_RI_E(ISYI,ISYK,NP,NI,NQ,NK,PIQK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case ('N ')
          call OLagNS_RI_N(ISYI,ISYK,NP,NI,NQ,NK,Cho_Bra(LBRASM),Cho_Ket(LKETSM),Cho_BraD(LBRASM),Cho_KetD(LKETSM),NV)
        case default
          call Abend()
      end select

      LKETSM = LKETSM+NKETSM
    end do
    LBRASM = LBRASM+NBRASM
  end do
  call CWTime(TotCPU1,TotWall1)
  if (IPRGLB >= VERBOSE) write(u6,'(" CPU/Wall Time (Case ",A2,"):",2f10.2)') iCase,totcpu1-totcpu0,totwall1-totwall0

  return

end subroutine OLagNS_RI2

subroutine OLagNS_RI_A(ISYI,ISYK,NT,NJ,NV,NX,TJVX,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use SUPERINDEX, only: KTUV
  use caspt2_global, only: do_csf

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NT, NJ, NV, NX, NCHO
  real(kind=wp), intent(out) :: TJVX(NT,NJ,NV,NX)
  real(kind=wp), intent(in) :: Cho_Bra(NT,NJ,NCHO), Cho_Ket(NV,NX,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NT,NJ,NCHO), Cho_KetD(NV,NX,NCHO)
  integer(kind=iwp) :: IJ, IT, IV, IX, nOrbT_

  ISYJ = ISYI
  ISYX = ISYK

  ISYT = Mul(JSYM,ISYJ)
  ISYV = Mul(JSYM,ISYX)
  ISYM = ISYJ
  if (NINDEP(ISYM,1) == 0) return
  NAS = NTUV(ISYM)
  NIS = NISH(ISYM)
  NWA = NAS*NIS
  if (NWA == 0) return

  ! ---- A

  !! Read the T-amplitude
  ICASE = 1
  nIN = nINDEP(iSym,iCase)
  nAS = nASup(iSym,iCase)
  if (nIN /= 0) then
    nIS = nISup(iSym,iCase)
    nVec = nAS*nIS
    if (nVec /= 0) then
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        ! copy global array to local buffer
        call RHS_ALLO(nAS,nIS,lg_V)
        call RHS_READ(nAS,nIS,lg_V,iCase,iSym,iVecC2)
        ipT = Allocate_GA_Array(nAS*nIS,'ipT')
        call GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipT)%A,nAS)
        if (do_csf) then
          call RHS_READ(nAS,nIS,lg_V,iCase,iSym,7)
          ipTanti = Allocate_GA_Array(nAS*nIS,'ipTanti')
          call GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipTanti)%A,nAS)
        end if
        call RHS_FREE(lg_V)
        call GASYNC()
      else
#     endif
        call RHS_ALLO(nAS,nIS,ipT)
        call RHS_READ(nAS,nIS,ipT,iCase,iSym,iVecC2)
        if (do_csf) then
          call RHS_ALLO(nAS,nIS,ipTanti)
          call RHS_READ(nAS,nIS,ipTanti,iCase,iSym,7)
        end if
#     ifdef _MOLCAS_MPP_
      end if
#     endif
    end if
  end if

  TJVX(:,:,:,:) = Zero

  nOrbT_ = nFro(iSyT)+nIsh(iSyT)+nAsh(iSyT)+nSsh(iSyT)
  do IT=1,NT
    ITABS = IT+NAES(ISYT)
    iTtot = iT+nFro(iSyT)+nIsh(iSyT)
    do IJ=1,NJ
      !IJABS = IJ+NIES(ISYJ)
      iJtot = iJ+nFro(iSyJ)

      do IV=1,NV
        IVABS = IV+NAES(ISYV)
        if (ISYV == ISYX) then !! not sure
          !! ONEADD contributions
          IW1 = KTUV(ITABS,IVABS,IVABS)-NTUVES(ISYM)
          IW2 = IJ
          IW = IW1+NAS*(IW2-1)

          DPT2C(iTtot+nOrbT_*(iJtot-1)) = DPT2C(iTtot+nOrbT_*(iJtot-1))+Two*GA_Arrays(ipT)%A(IW)
          if (do_csf) DPT2Canti(iTtot+nOrbT_*(iJtot-1)) = DPT2Canti(iTtot+nOrbT_*(iJtot-1))+Two*GA_Arrays(ipTanti)%A(IW)
        end if
        do IX=1,NX
          IXABS = IX+NAES(ISYX)
          IW1 = KTUV(ITABS,IVABS,IXABS)-NTUVES(ISYM)
          IW2 = IJ
          IW = IW1+NAS*(IW2-1)
          TJVX(IT,IJ,IV,IX) = GA_Arrays(ipT)%A(IW)
        end do
      end do
    end do
  end do

  call DGEMM_('T','N',NV*NX,NCHO,NT*NJ,One,TJVX,NT*NJ,Cho_Bra,NT*NJ,One,Cho_KetD,NV*NX)
  call DGEMM_('N','N',NT*NJ,NCHO,NV*NX,One,TJVX,NT*NJ,Cho_Ket,NV*NX,One,Cho_BraD,NT*NJ)

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
    call deallocate_GA_array(ipT)
    if (do_CSF) call deallocate_GA_array(ipTanti)
  else
# endif
    call RHS_FREE(ipT)
    if (do_csf) call RHS_FREE(ipTanti)

# ifdef _MOLCAS_MPP_
  end if
# endif

  return

end subroutine OLagNS_RI_A

subroutine OLagNS_RI_B(ISYI,ISYK,NT,NJ,NV,NL,TJVL,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use SUPERINDEX, only: KIGEJ, KIGTJ, KTGEU, KTGTU

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NT, NJ, NV, NL, NCHO
  real(kind=wp), intent(out) :: TJVL(NT,NJ,NV,NL)
  real(kind=wp), intent(in) :: Cho_Bra(NT,NJ,NCHO), Cho_Ket(NV,NL,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NT,NJ,NCHO), Cho_KetD(NV,NL,NCHO)
  integer(kind=iwp) :: IJ, IL, IT, IV

  ISYJ = ISYI
  ISYL = ISYK

  ISYT = Mul(JSYM,ISYJ)
  ISYV = Mul(JSYM,ISYL)
  if (ISYT < ISYV) return
  ISYM = Mul(ISYJ,ISYL) !!

  if (NINDEP(ISYM,2) > 0) then
    ! The plus combination:
    ICASE = 2
    NASP = NTGEU(ISYM)
    NISP = NIGEJ(ISYM)
    NWBP = NASP*NISP
  else
    NWBP = 0
  end if
  if (NINDEP(ISYM,3) > 0) then
    ! The minus combination:
    ICASE = 3
    NASM = NTGTU(ISYM)
    NISM = NIGTJ(ISYM)
    NWBM = NASM*NISM
  else
    NWBM = 0
  end if
  if (max(NWBP,NWBM) <= 0) return

  TJVL(:,:,:,:) = Zero

  if ((NWBP > 0) .and. (NINDEP(ISYM,2) > 0)) then
    !! Read the T-amplitude
    ICASE = 2
    nINP = nINDEP(iSym,iCase)
    nASP = nASup(iSym,iCase)
    if (nINP /= 0) then
      nISP = nISup(iSym,iCase)
      nVec = nASP*nISP
      if (nVec /= 0) then
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          ! copy global array to local buffer
          call RHS_ALLO(nASP,nISP,lg_V)
          call RHS_READ(nASP,nISP,lg_V,iCase,iSym,iVecC2)
          ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
          call GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A,nASP)
          call RHS_FREE(lg_V)
          call GASYNC()
        else
#       endif
          call RHS_ALLO(nASP,nISP,ipTP)
          call RHS_READ(nASP,nISP,ipTP,iCase,iSym,iVecC2)
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      end if
    end if

    do IT=1,NT
      ITABS = IT+NAES(ISYT)
      IVMAX = NV
      if (ISYV == ISYT) IVMAX = IT
      do IV=1,IVMAX
        IVABS = IV+NAES(ISYV)
        SCL1 = Half
        IW1 = KTGEU(ITABS,IVABS)-NTGEUES(ISYM)
        if (ITABS == IVABS) SCL1 = Quart
        do IJ=1,NJ
          IJABS = IJ+NIES(ISYJ)
          do IL=1,NL
            ILABS = IL+NIES(ISYL)
            SCL = SCL1
            if (IJABS >= ILABS) then
              IW2 = KIGEJ(IJABS,ILABS)-NIGEJES(ISYM)
              if (IJABS == ILABS) SCL = SQ2*SCL1
            else
              IW2 = KIGEJ(ILABS,IJABS)-NIGEJES(ISYM)
            end if
            IW = IW1+NASP*(IW2-1)
            TJVL(IT,IJ,IV,IL) = SCL*GA_Arrays(ipTP)%A(IW)
          end do
        end do
      end do
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTP)
    else
#   endif
      call RHS_FREE(ipTP)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  if (NINDEP(ISYM,3) > 0) then
    !! Read the T-amplitude
    ICASE = 3
    nINM = nINDEP(iSym,iCase)
    nASM = nASup(iSym,iCase)
    if (nINM /= 0) then
      nISM = nISup(iSym,iCase)
      nVec = nASM*nISM
      if (nVec /= 0) then
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          ! copy global array to local buffer
          call RHS_ALLO(nASM,nISM,lg_V)
          call RHS_READ(nASM,nISM,lg_V,iCase,iSym,iVecC2)
          ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
          call GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A,nASM)
          call RHS_FREE(lg_V)
          call GASYNC()
        else
#       endif
          call RHS_ALLO(nASM,nISM,ipTM)
          call RHS_READ(nASM,nISM,ipTM,iCase,iSym,iVecC2)
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      end if
    end if

    do IT=1,NT
      ITABS = IT+NAES(ISYT)
      IVMAX = NV
      if (ISYV == ISYT) IVMAX = IT-1
      do IV=1,IVMAX
        IVABS = IV+NAES(ISYV)
        IW1 = KTGTU(ITABS,IVABS)-NTGTUES(ISYM)
        do IJ=1,NJ
          IJABS = IJ+NIES(ISYJ)
          do IL=1,NL
            ILABS = IL+NIES(ISYL)
            if (IJABS > ILABS) then
              IW2 = KIGTJ(IJABS,ILABS)-NIGTJES(ISYM)
              SCL = Half
            else if (IJABS < ILABS) then
              IW2 = KIGTJ(ILABS,IJABS)-NIGTJES(ISYM)
              SCL = -Half
            else
              cycle
            end if
            IW = IW1+NASM*(IW2-1)
            TJVL(IT,IJ,IV,IL) = TJVL(IT,IJ,IV,IL)+SCL*GA_Arrays(ipTM)%A(IW)
          end do
        end do
      end do
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTM)
    else
#   endif
      call RHS_FREE(ipTM)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  call DGEMM_('T','N',NV*NL,NCHO,NT*NJ,One,TJVL,NT*NJ,Cho_Bra,NT*NJ,One,Cho_KetD,NV*NL)
  call DGEMM_('N','N',NT*NJ,NCHO,NV*NL,One,TJVL,NT*NJ,Cho_Ket,NV*NL,One,Cho_BraD,NT*NJ)

  return

end subroutine OLagNS_RI_B

subroutine OLagNS_RI_C(ISYI,ISYK,NA,NU,NV,NX,AUVX,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use SUPERINDEX, only: KTUV
  use caspt2_global, only: do_csf

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NU, NV, NX, NCHO
  real(kind=wp), intent(out) :: AUVX(NA,NU,NV,NX)
  real(kind=wp), intent(in) :: Cho_Bra(NA,NU,NCHO), Cho_Ket(NV,NX,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NA,NU,NCHO), Cho_KetD(NV,NX,NCHO)
  integer(kind=iwp) :: IA, IU, IV, IX
  real(kind=wp) :: ValCF

  ISYU = ISYI
  ISYX = ISYK

  ISYA = Mul(JSYM,ISYU)
  ISYV = Mul(JSYM,ISYX)
  ISYM = ISYA !!
  if (NINDEP(ISYM,4) == 0) return
  NAS = NTUV(ISYM)
  NIS = NSSH(ISYM)
  NWC = NAS*NIS
  if (NWC == 0) return

  ! ---- C

  !! Read the T-amplitude
  ICASE = 4
  nIN = nINDEP(iSym,iCase)
  nAS = nASup(iSym,iCase)
  if (nIN /= 0) then
    nIS = nISup(iSym,iCase)
    nVec = nIN*nIS
    if (nVec /= 0) then
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        call RHS_ALLO(nAS,nIS,lg_V)
        call RHS_READ(nAS,nIS,lg_V,iCase,iSym,iVecC2)
        ipT = Allocate_GA_Array(nAS*nIS,'ipT')
        call GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipT)%A,nAS)
        if (do_csf) then
          call RHS_READ(nAS,nIS,lg_V,iCase,iSym,7)
          ipTanti = Allocate_GA_Array(nAS*nIS,'ipTanti')
          call GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipTanti)%A,nAS)
        end if
        call RHS_FREE(lg_V)
        call GASYNC()
      else
#     endif
        call RHS_ALLO(nAS,nIS,ipT)
        call RHS_READ(nAS,nIS,ipT,iCase,iSym,iVecC2)
        if (do_csf) then
          call RHS_ALLO(nAS,nIS,ipTanti)
          call RHS_READ(nAS,nIS,ipTanti,iCase,iSym,7)
        end if
#     ifdef _MOLCAS_MPP_
      end if
#     endif
    end if
  end if

  AUVX(:,:,:,:) = Zero

  nOrbA = nFro(iSyA)+nIsh(iSyA)+nAsh(iSyA)+nSsh(iSyA)
  do IA=1,NA
    iAtot = iA+nFro(iSyA)+nIsh(iSyA)+nAsh(iSyA)
    do IU=1,NU
      IUABS = IU+NAES(ISYU)
      iUtot = iU+nFro(iSyU)+nIsh(iSyU)
      do IV=1,NV
        IVABS = IV+NAES(ISYV)
        ValCF = Zero
        if (ISYV == ISYX) then !! not sure
          !! ONEADD contributions
          IW1 = KTUV(IUABS,IVABS,IVABS)-NTUVES(ISYM)
          IW2 = IA
          IW = IW1+NAS*(IW2-1)

          ValCF = GA_Arrays(ipT)%A(IW)*Two
          DPT2C(iAtot+nOrbA*(iUtot-1)) = DPT2C(iAtot+nOrbA*(iUtot-1))+ValCF
          if (do_csf) DPT2Canti(iAtot+nOrbA*(iUtot-1)) = DPT2Canti(iAtot+nOrbA*(iUtot-1))+Two*GA_Arrays(ipTanti)%A(IW)
          ValCF = ValCF*SCLNEL
        end if
        do IX=1,NX
          IXABS = IX+NAES(ISYX)
          IW1 = KTUV(IUABS,IVABS,IXABS)-NTUVES(ISYM)
          IW2 = IA
          IW = IW1+NAS*(IW2-1)

          AUVX(IA,IU,IV,IX) = AUVX(IA,IU,IV,IX)+GA_Arrays(ipT)%A(IW)
          AUVX(IA,IX,IU,IX) = AUVX(IA,IX,IU,IX)-ValCF*Half
        end do
      end do
    end do
  end do

  call DGEMM_('T','N',NV*NX,NCHO,NA*NU,One,AUVX,NA*NU,Cho_Bra,NA*NU,One,Cho_KetD,NV*NX)
  call DGEMM_('N','N',NA*NU,NCHO,NV*NX,One,AUVX,NA*NU,Cho_Ket,NV*NX,One,Cho_BraD,NA*NU)

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
    call deallocate_GA_array(ipT)
    if (do_CSF) call deallocate_GA_array(ipTanti)
  else
# endif
    call RHS_FREE(ipT)
    if (do_csf) call RHS_FREE(ipTanti)
# ifdef _MOLCAS_MPP_
  end if
# endif

  return

end subroutine OLagNS_RI_C

subroutine OLagNS_RI_D1(ISYI,ISYK,NA,NJ,NV,NX,AJVX,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use SUPERINDEX, only: KTU
  use caspt2_global, only: do_csf

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NJ, NV, NX, NCHO
  real(kind=wp), intent(out) :: AJVX(NV,NX,NA*NJ)
  real(kind=wp), intent(in) :: Cho_Bra(NA,NJ,NCHO), Cho_Ket(NV,NX,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NA,NJ,NCHO), Cho_KetD(NV,NX,NCHO)
  integer(kind=iwp) :: IA, IASTA, IJ, IJSTA, IOFFD(8,8), ISA, ISW, IV, IX

  ISYJ = ISYI
  ISYX = ISYK

  do ISW=1,NSYM
    IO = 0
    do ISA=1,NSYM
      IOFFD(ISA,ISW) = IO
      ISI = Mul(ISA,ISW)
      IO = IO+NSSH(ISA)*NISH(ISI)
    end do
  end do

  ISYA = Mul(JSYM,ISYJ)
  ISYV = Mul(JSYM,ISYX)
  ISYM = JSYM !!!
  if (NINDEP(ISYM,5) == 0) return
  NAS1 = NTU(ISYM)
  NAS = 2*NAS1
  NIS = NISUP(ISYM,5)
  NWD = NAS*NIS
  if (NWD == 0) return

  ! ---- D1

  !! Read the T-amplitude
  ICASE = 5
  nIN = nINDEP(iSym,iCase)
  nAS = nASup(iSym,iCase)
  if (nIN /= 0) then
    nIS = nISup(iSym,iCase)
    nVec = nAS*nIS
    if (nVec /= 0) then
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        call RHS_ALLO(nAS,nIS,lg_V)
        call RHS_READ(nAS,nIS,lg_V,iCase,iSym,iVecC2)
        ipT = Allocate_GA_Array(nAS*nIS,'ipT')
        call GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipT)%A,nAS)
        if (do_csf) then
          call RHS_READ(nAS,nIS,lg_V,iCase,iSym,7)
          ipTanti = Allocate_GA_Array(nAS*nIS,'ipTanti')
          call GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipTanti)%A,nAS)
        end if
        call RHS_FREE(lg_V)
        call GASYNC()
      else
#     endif
        call RHS_ALLO(nAS,nIS,ipT)
        call RHS_READ(nAS,nIS,ipT,iCase,iSym,iVecC2)
        if (do_csf) then
          call RHS_ALLO(nAS,nIS,ipTanti)
          call RHS_READ(nAS,nIS,ipTanti,iCase,iSym,7)
        end if
#     ifdef _MOLCAS_MPP_
      end if
#     endif
    end if
  end if

  NBXSZA = NSECBX
  NBXSZJ = NINABX

  do IASTA=1,NA,NBXSZA
    IAEND = min(IASTA-1+NBXSZA,NA)
    NASZ = IAEND-IASTA+1
    do IJSTA=1,NJ,NBXSZJ
      IJEND = min(IJSTA-1+NBXSZJ,NJ)
      NJSZ = IJEND-IJSTA+1

      IAJSTA = 1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
      AJVX(:,:,:) = Zero

      nOrbA = nFro(iSyA)+nIsh(iSyA)+nAsh(iSyA)+nSsh(iSyA)
      IAJ = 0
      do IJ=IJSTA,IJEND
        iJtot = iJ+nFro(iSyJ)
        do IA=IASTA,IAEND
          iAtot = iA+nFro(iSyA)+nIsh(iSyA)+nAsh(iSyA)
          IAJ = IAJ+1
          do IX=1,NX
            IXABS = IX+NAES(ISYX)
            iXtot = iX+nFro(iSyX)+nIsh(iSyX)
            do IV=1,NV
              IVABS = IV+NAES(ISYV)
              iVtot = iV+nFro(iSyV)+nIsh(iSyV)
              IW1 = KTU(IVABS,IXABS)-NTUES(ISYM)
              IW2 = IOFFD(ISYA,ISYM)+IJ+NJ*(IA-1)
              IW = IW1+NAS*(IW2-1)

              if (iVtot == iXtot) then
                DPT2C(iAtot+nOrbA*(iJtot-1)) = DPT2C(iAtot+nOrbA*(iJtot-1))+Two*GA_Arrays(ipT)%A(IW)
                if (do_csf) DPT2Canti(iAtot+nOrbA*(iJtot-1)) = DPT2Canti(iAtot+nOrbA*(iJtot-1))+Two*GA_Arrays(ipTanti)%A(IW)
              end if
              AJVX(IV,IX,IAJ) = GA_Arrays(ipT)%A(IW)
            end do
          end do
        end do
      end do

      call DGEMM_('T','N',NASZ*NJSZ,NCHO,NV*NX,One,AJVX,NV*NX,Cho_Ket,NV*NX,One,Cho_BraD(IAJSTA,1,1),NA*NJ)
      call DGEMM_('N','N',NV*NX,NCHO,NASZ*NJSZ,One,AJVX,NV*NX,Cho_Bra(IAJSTA,1,1),NA*NJ,One,Cho_KetD,NV*NX)

    end do
  end do

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
    call deallocate_GA_array(ipT)
    if (do_CSF) call deallocate_GA_array(ipTanti)
  else
# endif
    call RHS_FREE(ipT)
    if (do_csf) call RHS_FREE(ipTanti)
# ifdef _MOLCAS_MPP_
  end if
# endif

  return

end subroutine OLagNS_RI_D1

subroutine OLagNS_RI_D2(ISYI,ISYK,NA,NU,NV,NL,AUVL,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use SUPERINDEX, only: KTU

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NU, NV, NL, NCHO
  real(kind=wp), intent(out) :: AUVL(NA,NU,NV,NL)
  real(kind=wp), intent(in) :: Cho_Bra(NA,NU,NCHO), Cho_Ket(NV,NL,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NA,NU,NCHO), Cho_KetD(NV,NL,NCHO)
  integer(kind=iwp) :: IA, IL, IOFFD(8,8), ISYA, ISYW, IU, IV

  ISYU = ISYI
  ISYL = ISYK

  do ISYW=1,NSYM
    IO = 0
    do ISYA=1,NSYM
      IOFFD(ISYA,ISYW) = IO
      ISYII = Mul(ISYA,ISYW)
      IO = IO+NSSH(ISYA)*NISH(ISYII)
    end do
  end do

  ISYA = Mul(JSYM,ISYU)
  ISYV = Mul(JSYM,ISYL)
  ISYM = Mul(ISYU,ISYV)
  if (NINDEP(ISYM,5) == 0) return
  NAS1 = NTU(ISYM)
  NAS = 2*NAS1
  NIS = NISUP(ISYM,5)
  NWD = NAS*NIS
  if (NWD == 0) return

  ! ---- D2

  !! Read the T-amplitude
  ICASE = 5
  nIN = nINDEP(iSym,iCase)
  nAS = nASup(iSym,iCase)
  if (nIN /= 0) then
    nIS = nISup(iSym,iCase)
    nVec = nAS*nIS
    if (nVec /= 0) then
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        call RHS_ALLO(nAS,nIS,lg_V)
        call RHS_READ(nAS,nIS,lg_V,iCase,iSym,iVecC2)
        ipT = Allocate_GA_Array(nAS*nIS,'ipT')
        call GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipT)%A,nAS)
        if (do_csf) then
          call RHS_READ(nAS,nIS,lg_V,iCase,iSym,7)
          ipTanti = Allocate_GA_Array(nAS*nIS,'ipTanti')
          call GA_GET(lg_V,1,nAS,1,nIS,GA_Arrays(ipTanti)%A,nAS)
        end if
        call RHS_FREE(lg_V)
        call GASYNC()
      else
#     endif
        call RHS_ALLO(nAS,nIS,ipT)
        call RHS_READ(nAS,nIS,ipT,iCase,iSym,iVecC2)
        if (do_csf) then
          call RHS_ALLO(nAS,nIS,ipTanti)
          call RHS_READ(nAS,nIS,ipTanti,iCase,iSym,7)
        end if
#     ifdef _MOLCAS_MPP_
      end if
#     endif
    end if
  end if

  AUVL(:,:,:,:) = Zero

  do IA=1,NA
    do IU=1,NU
      IUABS = IU+NAES(ISYU)
      do IV=1,NV
        IVABS = IV+NAES(ISYV)
        do IL=1,NL
          IW1 = NAS1+KTU(IVABS,IUABS)-NTUES(ISYM)
          IW2 = IOFFD(ISYA,ISYM)+IL+NL*(IA-1)
          IW = IW1+NAS*(IW2-1)
          AUVL(IA,IU,IV,IL) = GA_Arrays(ipT)%A(IW)
        end do
      end do
    end do
  end do

  call DGEMM_('T','N',NV*NL,NCHO,NA*NU,One,AUVL,NA*NU,Cho_Bra,NA*NU,One,Cho_KetD,NV*NL)
  call DGEMM_('N','N',NA*NU,NCHO,NV*NL,One,AUVL,NA*NU,Cho_Ket,NV*NL,One,Cho_BraD,NA*NU)

  if ((nIN /= 0) .and. (nVec /= 0)) then
#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipT)
      if (do_CSF) call deallocate_GA_array(ipTanti)
    else
#   endif
      call RHS_FREE(ipT)
      if (do_csf) call RHS_FREE(ipTanti)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  return

end subroutine OLagNS_RI_D2

subroutine OLagNS_RI_E(ISYI,ISYK,NA,NJ,NV,NL,AJVL,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use SUPERINDEX, only: KIGEJ, KIGTJ

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NJ, NV, NL, NCHO
  real(kind=wp), intent(out) :: AJVL(NV,NL,NA*NJ)
  real(kind=wp), intent(in) :: Cho_Bra(NA,NJ,NCHO), Cho_Ket(NV,NL,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NA,NJ,NCHO), Cho_KetD(NV,NL,NCHO)
  integer(kind=iwp) :: IA, IASTA, IJ, IJSTA, IL, IOFF1(8), IOFF2(8), ISA, IV

  ISYJ = ISYI
  ISYL = ISYK

  ISYA = Mul(JSYM,ISYJ)
  ISYV = Mul(JSYM,ISYL)
  ISYM = ISYV
  ISYJL = Mul(ISYJ,ISYL)

  ! Set up offset table:
  IO1 = 0
  IO2 = 0
  do ISA=1,NSYM
    IOFF1(ISA) = IO1
    IOFF2(ISA) = IO2
    ISIJ = Mul(ISA,ISYM)
    IO1 = IO1+NSSH(ISA)*NIGEJ(ISIJ)
    IO2 = IO2+NSSH(ISA)*NIGTJ(ISIJ)
  end do

  NAS = NASH(ISYM)
  NISP = NISUP(ISYM,6)
  NISM = NISUP(ISYM,7)
  !NIS = NISP+NISM
  NWEP = NAS*NISP
  NWEM = NAS*NISM
  NW = NWEP+NWEM
  if (NW == 0) return

  ! ---- EP

  if (NWEP > 0) then
    !! Read the T-amplitude
    ICASE = 6
    nINP = nINDEP(iSym,iCase)
    nASP = nASup(iSym,iCase)
    if (nINP /= 0) then
      nISP = nISup(iSym,iCase)
      nVec = nINP*nISP
      if (nVec /= 0) then
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          ! copy global array to local buffer
          call RHS_ALLO(nASP,nISP,lg_V)
          call RHS_READ(nASP,nISP,lg_V,iCase,iSym,iVecC2)
          ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
          call GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A,nASP)
          call RHS_FREE(lg_V)
          call GASYNC()
        else
#       endif
          call RHS_ALLO(nASP,nISP,ipTP)
          call RHS_READ(nASP,nISP,ipTP,iCase,iSym,iVecC2)
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      end if
    end if

    NBXSZA = NSECBX
    NBXSZJ = NINABX

    do IASTA=1,NA,NBXSZA
      IAEND = min(IASTA-1+NBXSZA,NA)
      NASZ = IAEND-IASTA+1
      do IJSTA=1,NJ,NBXSZJ
        IJEND = min(IJSTA-1+NBXSZJ,NJ)
        NJSZ = IJEND-IJSTA+1

        IAJSTA = 1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
        AJVL(:,:,:) = Zero

        IAJ = 0
        do IJ=IJSTA,IJEND
          IJABS = IJ+NIES(ISYJ)
          do IA=IASTA,IAEND
            !IAABS = IA+NSES(ISYA)
            IAJ = IAJ+1

            do IV=1,NV
              !IVABS = IV+NAES(ISYV)
              do IL=1,NL
                ILABS = IL+NIES(ISYL)
                SCL = SQ05
                if (IJABS >= ILABS) then
                  JGEL = KIGEJ(IJABS,ILABS)-NIGEJES(ISYJL)
                  if (IJABS == ILABS) SCL = One
                else
                  JGEL = KIGEJ(ILABS,IJABS)-NIGEJES(ISYJL)
                end if
                IW1 = IV
                IW2 = IA+NA*(JGEL-1)+IOFF1(ISYA)
                IW = IW1+NAS*(IW2-1)

                AJVL(IV,IL,IAJ) = SCL*GA_Arrays(ipTP)%A(IW)
              end do
            end do
          end do
        end do

        call DGEMM_('T','N',NASZ*NJSZ,NCHO,NV*NL,One,AJVL,NV*NL,Cho_Ket,NV*NL,One,Cho_BraD(IAJSTA,1,1),NA*NJ)
        call DGEMM_('N','N',NV*NL,NCHO,NASZ*NJSZ,One,AJVL,NV*NL,Cho_Bra(IAJSTA,1,1),NA*NJ,One,Cho_KetD,NV*NL)

      end do
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTP)
    else
#   endif
      call RHS_FREE(ipTP)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  ! ---- EM

  if (NWEM > 0) then
    !! Read the T-amplitude
    ICASE = 7
    nINM = nINDEP(iSym,iCase)
    nASM = nASup(iSym,iCase)
    if (nINM /= 0) then
      nISM = nISup(iSym,iCase)
      nVec = nINM*nISM
      if (nVec /= 0) then
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          ! copy global array to local buffer
          call RHS_ALLO(nASM,nISM,lg_V)
          call RHS_READ(nASM,nISM,lg_V,iCase,iSym,iVecC2)
          ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
          call GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A,nASM)
          call RHS_FREE(lg_V)
          call GASYNC()
        else
#       endif
          call RHS_ALLO(nASM,nISM,ipTM)
          call RHS_READ(nASM,nISM,ipTM,iCase,iSym,iVecC2)
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      end if
    end if

    NBXSZA = NSECBX
    NBXSZJ = NINABX

    do IASTA=1,NA,NBXSZA
      IAEND = min(IASTA-1+NBXSZA,NA)
      NASZ = IAEND-IASTA+1
      do IJSTA=1,NJ,NBXSZJ
        IJEND = min(IJSTA-1+NBXSZJ,NJ)
        NJSZ = IJEND-IJSTA+1

        IAJSTA = 1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
        AJVL(:,:,:) = Zero

        IAJ = 0
        do IJ=IJSTA,IJEND
          IJABS = IJ+NIES(ISYJ)
          do IA=IASTA,IAEND
            !IAABS = IA+NSES(ISYA)
            IAJ = IAJ+1

            do IV=1,NV
              !IVABS = IV+NAES(ISYV)
              do IL=1,NL
                ILABS = IL+NIES(ISYL)
                if (IJABS /= ILABS) then
                  if (IJABS > ILABS) then
                    SCL = SQ32
                    JGTL = KIGTJ(IJABS,ILABS)-NIGTJES(ISYJL)
                  else
                    SCL = -SQ32
                    JGTL = KIGTJ(ILABS,IJABS)-NIGTJES(ISYJL)
                  end if
                  IW1 = IV
                  IW2 = IA+NA*(JGTL-1)+IOFF2(ISYA)
                  IW = IW1+NAS*(IW2-1)

                  AJVL(IV,IL,IAJ) = SCL*GA_Arrays(ipTM)%A(IW)
                end if
              end do
            end do
          end do
        end do

        call DGEMM_('T','N',NASZ*NJSZ,NCHO,NV*NL,One,AJVL,NV*NL,Cho_Ket,NV*NL,One,Cho_BraD(IAJSTA,1,1),NA*NJ)
        call DGEMM_('N','N',NV*NL,NCHO,NASZ*NJSZ,One,AJVL,NV*NL,Cho_Bra(IAJSTA,1,1),NA*NJ,One,Cho_KetD,NV*NL)

      end do
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTM)
    else
#   endif
      call RHS_FREE(ipTM)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  return

end subroutine OLagNS_RI_E

subroutine OLagNS_RI_F(ISYI,ISYK,NA,NU,NC,NX,AUCX,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use SUPERINDEX, only: KTGTU, KTGEU, KAGTB, KAGEB

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NU, NC, NX, NCHO
  real(kind=wp), intent(out) :: AUCX(NA,NU,NC,NX)
  real(kind=wp), intent(in) :: Cho_Bra(NA,NU,NCHO), Cho_Ket(NC,NX,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NA,NU,NCHO), Cho_KetD(NC,NX,NCHO)
  integer(kind=iwp) :: IA, IC, IU, IX

  ISYU = ISYI
  ISYX = ISYK

  if (ISYU < ISYX) return

  ISYA = Mul(JSYM,ISYU)
  ISYC = Mul(JSYM,ISYX)
  ISYM = Mul(ISYU,ISYX) !!

  if (NINDEP(ISYM,8) > 0) then
    ! The plus combination:
    NASP = NTGEU(ISYM)
    NISP = NAGEB(ISYM)
    NWFP = NASP*NISP
  else
    NWFP = 0
  end if
  if (NINDEP(ISYM,9) > 0) then
    ICASE = 9
    ! The minus combination:
    NASM = NTGTU(ISYM)
    NISM = NAGTB(ISYM)
    NWFM = NASM*NISM
  else
    NWFM = 0
  end if
  if (NWFP+NWFM <= 0) return

  AUCX(:,:,:,:) = Zero

  ! ---- FP

  if ((NWFP > 0) .and. (NINDEP(ISYM,8) > 0)) then
    !! Read the T-amplitude
    ICASE = 8
    nINP = nINDEP(iSym,iCase)
    nASP = nASup(iSym,iCase)
    if (nINP /= 0) then
      nISP = nISup(iSym,iCase)
      nVec = nINP*nISP
      if (nVec /= 0) then
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          ! copy global array to local buffer
          call RHS_ALLO(nASP,nISP,lg_V)
          call RHS_READ(nASP,nISP,lg_V,iCase,iSym,iVecC2)
          ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
          call GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A,nASP)
          call RHS_FREE(lg_V)
          call GASYNC()
        else
#       endif
          call RHS_ALLO(nASP,nISP,ipTP)
          call RHS_READ(nASP,nISP,ipTP,iCase,iSym,iVecC2)
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      end if
    end if

    do IU=1,NU
      IUABS = IU+NAES(ISYU)
      IXMAX = NX
      if (ISYU == ISYX) IXMAX = IU
      do IX=1,IXMAX
        IXABS = IX+NAES(ISYX)
        SCL1 = Half
        if (IUABS == IXABS) SCL1 = Quart
        IW1 = KTGEU(IUABS,IXABS)-NTGEUES(ISYM)
        do IA=1,NA
          IAABS = IA+NSES(ISYA)
          do IC=1,NC
            ICABS = IC+NSES(ISYC)
            SCL = SCL1
            if (IAABS >= ICABS) then
              IW2 = KAGEB(IAABS,ICABS)-NAGEBES(ISYM)
              if (IAABS == ICABS) SCL = SQ2*SCL1
            else
              IW2 = KAGEB(ICABS,IAABS)-NAGEBES(ISYM)
            end if
            IW = IW1+NASP*(IW2-1)
            AUCX(IA,IU,IC,IX) = SCL*GA_Arrays(ipTP)%A(IW)
          end do
        end do
      end do
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTP)
    else
#   endif
      call RHS_FREE(ipTP)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  ! ---- FM

  if ((NWFM > 0) .and. (NINDEP(ISYM,9) > 0)) then
    !! Read the T-amplitude
    ICASE = 9
    nINM = nINDEP(iSym,iCase)
    nASM = nASup(iSym,iCase)
    if (nINM /= 0) then
      nISM = nISup(iSym,iCase)
      nVec = nINM*nISM
      if (nVec /= 0) then
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          ! copy global array to local buffer
          call RHS_ALLO(nASM,nISM,lg_V)
          call RHS_READ(nASM,nISM,lg_V,iCase,iSym,iVecC2)
          ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
          call GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A,nASM)
          call RHS_FREE(lg_V)
          call GASYNC()
        else
#       endif
          call RHS_ALLO(nASM,nISM,ipTM)
          call RHS_READ(nASM,nISM,ipTM,iCase,iSym,iVecC2)
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      end if
    end if

    do IU=1,NU
      IUABS = IU+NAES(ISYU)
      IXMAX = NX
      if (ISYU == ISYX) IXMAX = IU-1
      do IX=1,IXMAX
        IXABS = IX+NAES(ISYX)
        IW1 = KTGTU(IUABS,IXABS)-NTGTUES(ISYM)
        do IA=1,NA
          IAABS = IA+NSES(ISYA)
          do IC=1,NC
            ICABS = IC+NSES(ISYC)
            if (IAABS > ICABS) then
              IW2 = KAGTB(IAABS,ICABS)-NAGTBES(ISYM)
              SCL = -Half
            else if (IAABS < ICABS) then
              IW2 = KAGTB(ICABS,IAABS)-NAGTBES(ISYM)
              SCL = Half
            else
              cycle
            end if
            IW = IW1+NASM*(IW2-1)
            AUCX(IA,IU,IC,IX) = AUCX(IA,IU,IC,IX)+SCL*GA_Arrays(ipTM)%A(IW)
          end do
        end do
      end do
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTM)
    else
#   endif
      call RHS_FREE(ipTM)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  call DGEMM_('T','N',NC*NX,NCHO,NA*NU,One,AUCX,NA*NU,Cho_Bra,NA*NU,One,Cho_KetD,NC*NX)
  call DGEMM_('N','N',NA*NU,NCHO,NC*NX,One,AUCX,NA*NU,Cho_Ket,NC*NX,One,Cho_BraD,NA*NU)

  return

end subroutine OLagNS_RI_F

subroutine OLagNS_RI_G(ISYI,ISYK,NA,NU,NC,NL,AUCL,NAUCL,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use SUPERINDEX, only: KAGEB, KAGTB

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NU, NC, NL, NAUCL, NCHO
  real(kind=wp), intent(out) :: AUCL(NA,NU,NC*NL)
  real(kind=wp), intent(in) :: Cho_Bra(NA,NU,NCHO), Cho_Ket(NC,NL,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NA,NU,NCHO), Cho_KetD(NC,NL,NCHO)
  integer(kind=iwp) :: IA, IC, ICSTA, IL, ILSTA, IOFF1(8), IOFF2(8), ISI, IU

  ISYU = ISYI
  ISYL = ISYK

  ISYA = Mul(JSYM,ISYU)
  ISYC = Mul(JSYM,ISYL)
  ISYM = ISYU
  ISYAC = Mul(ISYA,ISYC)
  ! Set up offset table:
  IO1 = 0
  IO2 = 0
  do ISI=1,NSYM
    IOFF1(ISI) = IO1
    IOFF2(ISI) = IO2
    ISAB = Mul(ISI,ISYM)
    IO1 = IO1+NISH(ISI)*NAGEB(ISAB)
    IO2 = IO2+NISH(ISI)*NAGTB(ISAB)
  end do

  ! Allocate W with parts WP,WM
  NAS = NASH(ISYM)
  NISP = NISUP(ISYM,10)
  NISM = NISUP(ISYM,11)
  !NIS = NISP+NISM
  NWGP = NAS*NISP
  NWGM = NAS*NISM
  !NWG = NWGP+NWGM

  !LDGP = NAS
  !LDGM = NAS

  ! ---- GP

  if (NWGP > 0) then
    !! Read the T-amplitude
    ICASE = 10
    nINP = nINDEP(iSym,iCase)
    nASP = nASup(iSym,iCase)
    if (nINP /= 0) then
      nISP = nISup(iSym,iCase)
      nVec = nINP*nISP
      if (nVec /= 0) then
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          ! copy global array to local buffer
          call RHS_ALLO(nASP,nISP,lg_V)
          call RHS_READ(nASP,nISP,lg_V,iCase,iSym,iVecC2)
          ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
          call GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A,nASP)
          call RHS_FREE(lg_V)
          call GASYNC()
        else
#       endif
          call RHS_ALLO(nASP,nISP,ipTP)
          call RHS_READ(nASP,nISP,ipTP,iCase,iSym,iVecC2)
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      end if
    end if

    NBXSZC = NSECBX
    KCL = NAUCL/(NA*NU)
    NBXSZL = KCL/NC
    if (NBXSZL <= 0) then
      write(u6,*) 'Not enough memory in ADDRHSG, I give up'
      call Abend()
    end if

    do ICSTA=1,NC,NBXSZC
      ICEND = min(ICSTA-1+NBXSZC,NC)
      NCSZ = ICEND-ICSTA+1
      do ILSTA=1,NL,NBXSZL
        ILEND = min(ILSTA-1+NBXSZL,NL)
        !NLSZ = ILEND-ILSTA+1

        ICLSTA = 1+NL*(ICSTA-1)+NCSZ*(ILSTA-1)
        AUCL(:,:,:) = Zero

        ICL = 0
        !IBUF = 0
        do IL=ILSTA,ILEND
          !ILABS = IL+NIES(ISYL)
          do IC=ICSTA,ICEND
            ICABS = IC+NSES(ISYC)
            ICL = ICL+1

            do IA=1,NA
              IAABS = IA+NSES(ISYA)
              SCL = SQ05
              if (IAABS >= ICABS) then
                IAGEC = KAGEB(IAABS,ICABS)-NAGEBES(ISYAC)
                if (IAABS == ICABS) SCL = One
              else
                IAGEC = KAGEB(ICABS,IAABS)-NAGEBES(ISYAC)
              end if
              do IU=1,NU
                !IUABS = IU+NAES(ISYU)
                IW1 = IU
                IW2 = IL+NL*(IAGEC-1)+IOFF1(ISYL)
                IW = IW1+NAS*(IW2-1)

                AUCL(IA,IU,ICL) = SCL*GA_Arrays(ipTP)%A(IW)
              end do
            end do
          end do
        end do

        call DGEMM_('N','N',NA*NU,NCHO,ICL,One,AUCL,NA*NU,Cho_Ket(ICLSTA,1,1),NC*NL,One,Cho_BraD,NA*NU)
        call DGEMM_('T','N',ICL,NCHO,NA*NU,One,AUCL,NA*NU,Cho_Bra,NA*NU,One,Cho_KetD(ICLSTA,1,1),NC*NL)

      end do
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTP)
    else
#   endif
      call RHS_FREE(ipTP)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  ! ---- GM

  if (NWGM > 0) then
    !! Read the T-amplitude
    ICASE = 11
    nINM = nINDEP(iSym,iCase)
    nASM = nASup(iSym,iCase)
    if (nINM /= 0) then
      nISM = nISup(iSym,iCase)
      nVec = nINM*nISM
      if (nVec /= 0) then
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          ! copy global array to local buffer
          call RHS_ALLO(nASM,nISM,lg_V)
          call RHS_READ(nASM,nISM,lg_V,iCase,iSym,iVecC2)
          ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
          call GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A,nASM)
          call RHS_FREE(lg_V)
          call GASYNC()
        else
#       endif
          call RHS_ALLO(nASM,nISM,ipTM)
          call RHS_READ(nASM,nISM,ipTM,iCase,iSym,iVecC2)
#       ifdef _MOLCAS_MPP_
        end if
#       endif
      end if
    end if

    NBXSZC = NSECBX
    KCL = NAUCL/(NA*NU)
    NBXSZL = KCL/NC
    if (NBXSZL <= 0) then
      write(u6,*) 'Not enough memory in ADDRHSG, I give up'
      call Abend()
    end if

    do ICSTA=1,NC,NBXSZC
      ICEND = min(ICSTA-1+NBXSZC,NC)
      NCSZ = ICEND-ICSTA+1
      do ILSTA=1,NL,NBXSZL
        ILEND = min(ILSTA-1+NBXSZL,NL)
        !NLSZ = ILEND-ILSTA+1

        ICLSTA = 1+NL*(ICSTA-1)+NCSZ*(ILSTA-1)
        AUCL(:,:,:) = Zero

        ICL = 0
        !IBUF = 0
        do IL=ILSTA,ILEND
          !ILABS = IL+NIES(ISYL)
          do IC=ICSTA,ICEND
            ICABS = IC+NSES(ISYC)
            ICL = ICL+1

            do IA=1,NA
              IAABS = IA+NSES(ISYA)
              if (IAABS > ICABS) then
                IAGTC = KAGTB(IAABS,ICABS)-NAGTBES(ISYAC)
                SCL = SQ32
              else if (IAABS < ICABS) then
                IAGTC = KAGTB(ICABS,IAABS)-NAGTBES(ISYAC)
                SCL = -SQ32
              else
                cycle
              end if
              do IU=1,NU
                !IUABS = IU+NAES(ISYU)
                IW1 = IU
                IW2 = IL+NL*(IAGTC-1)+IOFF2(ISYL)
                IW = IW1+NAS*(IW2-1)

                AUCL(IA,IU,ICL) = SCL*GA_Arrays(ipTM)%A(IW)
              end do
            end do
          end do
        end do

        call DGEMM_('N','N',NA*NU,NCHO,ICL,One,AUCL,NA*NU,Cho_Ket(ICLSTA,1,1),NC*NL,One,Cho_BraD,NA*NU)
        call DGEMM_('T','N',ICL,NCHO,NA*NU,One,AUCL,NA*NU,Cho_Bra,NA*NU,One,Cho_KetD(ICLSTA,1,1),NC*NL)

      end do
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTM)
    else
#   endif
      call RHS_FREE(ipTM)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  return

end subroutine OLagNS_RI_G

!! ADDRHSH
subroutine OLagNS_RI_H(ISYI,ISYK,NA,NJ,NC,NL,AJCL,NAJCL,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use SUPERINDEX, only: KAGEB, KAGTB, KIGEJ, KIGTJ

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NA, NJ, NC, NL, NAJCL, NCHO
  real(kind=wp), intent(out) :: AJCL(NC*NL,NA*NJ)
  real(kind=wp), intent(in) :: Cho_Bra(NA,NJ,NCHO), Cho_Ket(NC,NL,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NA,NJ,NCHO), Cho_KetD(NC,NL,NCHO)
  integer(kind=iwp) :: IA, IASTA, IC, ICSTA, IJ, IJSTA, IL, ILSTA

  ISYJ = ISYI
  ISYL = ISYK

  if (ISYJ < ISYL) return
  ISYA = Mul(JSYM,ISYJ)
  ISYC = Mul(JSYM,ISYL)
  ISYM = Mul(ISYA,ISYC)
  ISYAC = ISYM
  ISYJL = ISYM

  NASP = NAGEB(ISYM)
  NISP = NIGEJ(ISYM)
  NWHP = NASP*NISP
  if (NWHP == 0) return
  NASM = NAGTB(ISYM)
  NISM = NIGTJ(ISYM)
  NWHM = NASM*NISM

  !LDHP = NASP
  !LDHM = NASM

  ! ---- HP

  !! Read the T-amplitude
  ICASE = 12
  nINP = nINDEP(iSym,iCase)
  nASP = nASup(iSym,iCase)
  nVec = 0
  if (nINP /= 0) then
    nISP = nISup(iSym,iCase)
    nVec = nINP*nISP
    if (nVec /= 0) then
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        ! copy global array to local buffer
        call RHS_ALLO(nASP,nISP,lg_V)
        call RHS_READ(nASP,nISP,lg_V,iCase,iSym,iVecC2)
        ipTP = Allocate_GA_Array(nASP*nISP,'ipTP')
        call GA_GET(lg_V,1,nASP,1,nISP,GA_Arrays(ipTP)%A,nASP)
        call RHS_FREE(lg_V)
        call GASYNC()
      else
#     endif
        call RHS_ALLO(nASP,nISP,ipTP)
        call RHS_READ(nASP,nISP,ipTP,iCase,iSym,iVecC2)
#     ifdef _MOLCAS_MPP_
      end if
#     endif
    end if
  end if

  NBXSZA = NSECBX
  KAJ = NAJCL/(NC*NL)
  NBXSZJ = KAJ/NA
  if (NBXSZJ <= 0) then
    write(u6,*) 'Not enough memory in ADDRHSH, I give up'
    call Abend()
  end if

  NBXSZC = NSECBX
  NBXSZL = NINABX

  do IASTA=1,NA,NBXSZA
    IAEND = min(IASTA-1+NBXSZA,NA)
    NASZ = IAEND-IASTA+1
    do IJSTA=1,NJ,NBXSZJ
      IJEND = min(IJSTA-1+NBXSZJ,NJ)
      NJSZ = IJEND-IJSTA+1

      IAJSTA = 1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
      AJCL(:,:) = Zero

      do ICSTA=1,NC,NBXSZC
        ICEND = min(ICSTA-1+NBXSZC,NC)
        NCSZ = ICEND-ICSTA+1
        do ILSTA=1,NL,NBXSZL
          ILEND = min(ILSTA-1+NBXSZL,NL)
          !NLSZ = ILEND-ILSTA+1

          ICLSTA = 1+NL*(ICSTA-1)+NCSZ*(ILSTA-1)

          IAJ = 0
          !IBUF = 0
          do IJ=IJSTA,IJEND
            IJABS = IJ+NIES(ISYJ)
            ILMAX = NL
            if (ISYJ == ISYL) ILMAX = IJ
            do IA=IASTA,IAEND
              IAABS = IA+NSES(ISYA)
              IAJ = IAJ+1

              ICL = 0
              do IL=ILSTA,min(ILEND,ILMAX)
                ILABS = IL+NIES(ISYL)
                SCL1 = One
                IJGEL = KIGEJ(IJABS,ILABS)-NIGEJES(ISYJL)
                if (IJABS == ILABS) SCL1 = SQ05
                do IC=ICSTA,ICEND
                  ICABS = IC+NSES(ISYC)
                  ICL = ICL+1

                  SCL = SCL1
                  if (IAABS >= ICABS) then
                    IAGEC = KAGEB(IAABS,ICABS)-NAGEBES(ISYAC)
                    if (IAABS == ICABS) SCL = SQ2*SCL1
                  else
                    IAGEC = KAGEB(ICABS,IAABS)-NAGEBES(ISYAC)
                  end if
                  IW = IAGEC+NAGEB(ISYM)*(IJGEL-1)

                  AJCL(ICLSTA+ICL-1,IAJ) = SCL*GA_Arrays(ipTP)%A(IW)
                end do
              end do
            end do
          end do

        end do
      end do
      call DGEMM_('T','N',NASZ*NJSZ,NCHO,NC*NL,One,AJCL,NC*NL,Cho_Ket,NC*NL,One,Cho_BraD(IAJSTA,1,1),NA*NJ)
      call DGEMM_('N','N',NC*NL,NCHO,NASZ*NJSZ,One,AJCL,NC*NL,Cho_Ket(IAJSTA,1,1),NC*NL,One,Cho_BraD,NA*NJ)

    end do
  end do

  if (nVec /= 0) then
#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTP)
    else
#   endif
      call RHS_FREE(ipTP)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  ! ---- HM

  !! Read the T-amplitude
  ICASE = 13
  nINM = nINDEP(iSym,iCase)
  nASM = nASup(iSym,iCase)
  nVec = 0
  if (nINM /= 0) then
    nISM = nISup(iSym,iCase)
    nVec = nASM*nISM
    if (nVec /= 0) then
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        ! copy global array to local buffer
        call RHS_ALLO(nASM,nISM,lg_V)
        call RHS_READ(nASM,nISM,lg_V,iCase,iSym,iVecC2)
        ipTM = Allocate_GA_Array(nASM*nISM,'ipTM')
        call GA_GET(lg_V,1,nASM,1,nISM,GA_Arrays(ipTM)%A,nASM)
        call RHS_FREE(lg_V)
        call GASYNC()
      else
#     endif
        call RHS_ALLO(nASM,nISM,ipTM)
        call RHS_READ(nASM,nISM,ipTM,iCase,iSym,iVecC2)
#     ifdef _MOLCAS_MPP_
      end if
#     endif
    end if
  end if

  NBXSZA = NSECBX
  KAJ = NAJCL/(NC*NL)
  NBXSZJ = KAJ/NA
  if (NBXSZJ <= 0) then
    write(u6,*) 'Not enough memory in ADDRHSH, I give up'
    call Abend()
  end if
  NBXSZC = NSECBX
  NBXSZL = NINABX

  do IASTA=1,NA,NBXSZA
    IAEND = min(IASTA-1+NBXSZA,NA)
    NASZ = IAEND-IASTA+1
    do IJSTA=1,NJ,NBXSZJ
      IJEND = min(IJSTA-1+NBXSZJ,NJ)
      NJSZ = IJEND-IJSTA+1

      IAJSTA = 1+NJ*(IASTA-1)+NASZ*(IJSTA-1)
      AJCL(:,:) = Zero

      do ICSTA=1,NC,NBXSZC
        ICEND = min(ICSTA-1+NBXSZC,NC)
        NCSZ = ICEND-ICSTA+1
        do ILSTA=1,NL,NBXSZL
          ILEND = min(ILSTA-1+NBXSZL,NL)
          !NLSZ = ILEND-ILSTA+1

          ICLSTA = 1+NL*(ICSTA-1)+NCSZ*(ILSTA-1)

          IAJ = 0
          !IBUF = 0
          do IJ=IJSTA,IJEND
            IJABS = IJ+NIES(ISYJ)
            ILMAX = NL
            if (ISYJ == ISYL) ILMAX = IJ-1
            do IA=IASTA,IAEND
              IAABS = IA+NSES(ISYA)
              IAJ = IAJ+1

              ICL = 0
              do IL=ILSTA,min(ILMAX,ILEND)
                ILABS = IL+NIES(ISYL)
                IJGTL = KIGTJ(IJABS,ILABS)-NIGTJES(ISYJL)
                do IC=ICSTA,ICEND
                  ICABS = IC+NSES(ISYC)
                  ICL = ICL+1

                  if (IAABS > ICABS) then
                    IAGTC = KAGTB(IAABS,ICABS)-NAGTBES(ISYAC)
                    SCL = SQ3
                  else if (IAABS < ICABS) then
                    IAGTC = KAGTB(ICABS,IAABS)-NAGTBES(ISYAC)
                    SCL = -SQ3
                  else
                    cycle
                  end if
                  IW = IAGTC+NAGTB(ISYM)*(IJGTL-1)

                  AJCL(ICLSTA+ICL-1,IAJ) = SCL*GA_Arrays(ipTM)%A(IW)
                end do
              end do
            end do
          end do

        end do
      end do
      call DGEMM_('T','N',NASZ*NJSZ,NCHO,NC*NL,One,AJCL,NC*NL,Cho_Ket,NC*NL,One,Cho_BraD(IAJSTA,1,1),NA*NJ)
      call DGEMM_('N','N',NC*NL,NCHO,NASZ*NJSZ,One,AJCL,NC*NL,Cho_Ket(IAJSTA,1,1),NC*NL,One,Cho_BraD,NA*NJ)
    end do
  end do

  if (nVec /= 0) then
#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call deallocate_GA_array(ipTM)
    else
#   endif
      call RHS_FREE(ipTM)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
  end if

  unused_var(cho_bra)
  unused_var(cho_ketd)

  return

end subroutine OLagNS_RI_H

subroutine OLagNS_RI_N(ISYI,ISYK,NT,NU,NV,NX,Cho_Bra,Cho_Ket,Cho_BraD,Cho_KetD,NCHO)

  use BDerNEV, only: Gder

  integer(kind=iwp), intent(in) :: ISYI, ISYK, NT, NU, NV, NX, NCHO
  real(kind=wp), intent(in) :: Cho_Bra(NT,NU,NCHO), Cho_Ket(NV,NX,NCHO)
  real(kind=wp), intent(inout) :: Cho_BraD(NT,NU,NCHO), Cho_KetD(NV,NX,NCHO)
  integer(kind=iwp) :: ISYU, ISYX

  ISYU = ISYI
  ISYX = ISYK
  if (ISYU < ISYX) return

  ! here, the contribution is halved, because bra/ket vectors are
  ! multiplied by two later
  call DGEMM_('T','N',NV*NX,NCHO,NT*NU,Half,Gder(:,:,:,:),NT*NU,Cho_Bra(:,:,:),NT*NU,One,Cho_KetD(:,:,:),NV*NX)
  call DGEMM_('N','N',NT*NU,NCHO,NV*NX,Half,Gder(:,:,:,:),NT*NU,Cho_Ket(:,:,:),NV*NX,One,Cho_BraD(:,:,:),NT*NU)

end subroutine OLagNS_RI_N

subroutine Cnst_A_PT2(block1,block2)

  integer(kind=iwp), intent(in) :: block1, block2
  integer(kind=iwp) :: ndim1
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: IHIV1, ILOV1, iRank, JHIV1, JLOV1, MV1
  logical(kind=iwp) :: bstat
# endif

  ndim1 = nSh(iSym0,block1)*nSh(iSym0,block2)
  if (ndim1 == 0) return

# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    !! The BRAD vector is first put from local BRA(:) to the
    !! global LG_V1 array. The data is shared among all processes.
    !! The bare Cholesky vector (KET(:)) is local.

    !! NV(I): Number of local Cholesky vectors for BRA(:)
    !! NDIM2: number of total Cholesky vectors for this batch
    !!        (usually NV*NPROCS)
    !! NVJ: number of local Cholesky vectors for KET(:)
    bStat = GA_CREATE_IRREG(MT_DBL,NDIM1,NDIM2,'BRAD',1,1,MAP2,NPROCS,LG_V1)
    call Cholesky_Vectors(2,block1,block2,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    !! finds out the range of the global array g_a that process
    !! iproc owns.
    call GA_DISTRIBUTION(LG_V1,MYRANK,ILOV1,IHIV1,JLOV1,JHIV1)
    !! provides access to local data in the specified patch of
    !! the array owned by the calling process
    call GA_ACCESS(LG_V1,ILOV1,IHIV1,JLOV1,JHIV1,MV1,NDIM1)
    ! can't use array statement because DBL_MB is out of bounds!
    !DBL_MB(MV1:MV1+NDIM1*(JHIV1-JLOV1+1)-1) = BRA(1:NDIM1*(JHIV1-JLOV1+1))
    call DCOPY_(NDIM1*(JHIV1-JLOV1+1),BRA,1,DBL_MB(MV1),1)
    !! releases access to a global array, when the data was
    !! accessed for writing
    call GA_RELEASE_UPDATE(LG_V1,ILOV1,IHIV1,JLOV1,JHIV1)
    call GA_SYNC()

    !! ket is ndim1*NVJ dimension
    call Get_Cholesky_Vectors(block1,block2,JSYM,KET,size(KET),nKet,JBSTA,JBEND)

    do iRank=0,NPROCS-1
      call GA_DISTRIBUTION(LG_V1,iRank,ILOV1,IHIV1,JLOV1,JHIV1)
      call GA_GET(LG_V1,ILOV1,IHIV1,JLOV1,JHIV1,BRA,NDIM1)
      call DGEMM_('T','N',JHIV1-JLOV1+1,NVJ,ndim1,One,BRA,ndim1,KET,ndim1,One,A_PT2(IOFFCV+JLOV1-1,JOFFCV+MAP2(myRank+1)-1), &
                  MaxVec_PT2)
    end do
    bStat = GA_DESTROY(LG_V1)
    unused_var(bStat)
  else
# endif
    call Cholesky_Vectors(2,block1,block2,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    call Get_Cholesky_Vectors(block1,block2,JSYM,KET,size(KET),nKet,JBSTA,JBEND)
    call DGEMM_('T','N',NVI,NVJ,ndim1,One,BRA,ndim1,KET,ndim1,One,A_PT2(IOFFCV,JOFFCV),MaxVec_PT2)
# ifdef _MOLCAS_MPP_
  end if
# endif

end subroutine Cnst_A_PT2

end subroutine OLagNS_RI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine MkAno
      Implicit Real*8 (a-h,o-z)
#include "parm.fh"
#include "common.fh"
#include "symlab.fh"
      Dimension s(MxS*(MxS+1)/2),u(MxS*MxS),c(MxS*MxS),d(MxS*(MxS+1))
      Dimension q(MxS*(MxS+1)/2)
      Integer nContr(0:MxLqn)
      Dimension OccNo(MxBasX)
      call molcas_open(17,'ANO')
c      Open(Unit=17,File='ANO',Form='FORMATTED')
      iPtr=1
      Write(6,*)
      Call CollapseOutput(1,'   Contraction coefficients')
      Write(6,'(3X,A)')     '   ------------------------'
*
* Loop over angular quantum number
*
      nOccNo=0
      ChkSum=0.0
      Do 1000 iLqn=0,MxLqn
         n=nPrim(iLqn)
         nContr(iLqn)=0
         If(n.le.0) Go To 1000
         Write(6,*)
         Write(6,*) '*** Contraction coefficients for the ',
     &              type(iLqn*(iLqn+1)+1)(3:3),' shell ***'
         Write(6,*)
         nTri=n*(n+1)/2
         Do 100 i=1,n
         Do 101 j=1,n
           ind=j+(i-1)*n
           u(ind)=0.0d0
101      Continue
100      Continue
         Do 200 i=1,n
           ind=i+(i-1)*n
           u(ind)=1.0d0
200      Continue
         Do 300 i=1,nTri
            s(i)=Ssym(iPtr-1+i)
300      Continue
*        Call TriPrt('s matrix','(6F12.6)',s,n)
*        Write(*,*) 'u matrix'
*        Call sqprt(u,n)
         Call Jacob(s,u,n,n)
*        Call TriPrt('s matrix','(6F12.6)',s,n)
*        Write(*,*) 'u matrix'
*        Call sqprt(u,n)
*        Write(*,*)
         Do 400 i=1,n
            s(i)=sqrt(s(i*(i+1)/2))
400      Continue
         Do 500 i=1,n
         Do 501 j=1,n
            t=0.0d0
            p=0.0d0
            Do 510 k=1,n
               t=t+u(i+(k-1)*n)/s(k)*u(j+(k-1)*n)
               p=p+u(i+(k-1)*n)*s(k)*u(j+(k-1)*n)
510         Continue
            c(j+(i-1)*n)=t
            q(j+(i-1)*n)=p
501      Continue
500      Continue
         Do 600 i=1,n
         Do 601 j=1,i
            t=0.0d0
            Do 610 k=1,n
            Do 611 l=1,n
               ind=Min(k,l)+Max(k,l)*(Max(k,l)-1)/2
               p=q(i+(k-1)*n)*tDsym(ind+iPtr-1)*q(j+(l-1)*n)
*              Write(*,'(a,f12.6)') '   p:',p
               t=t+p
611         Continue
610         Continue
            d(j+i*(i-1)/2)=t
601      Continue
600      Continue
*        Call TriPrt('d matrix','(6F12.6)',d,n)
*        Write(*,*) 'c matrix'
*        Call sqprt(c,n)
         Call Jacob(d,c,n,n)
*        Call TriPrt('d matrix','(6F12.6)',d,n)
*        Write(*,*) 'c matrix'
*        Call sqprt(c,n)
*        Write(*,*)
         nBig=0
         Do 700 i=1,n
            d(i)=d(i*(i+1)/2)
            If(d(i).gt.thr) nBig=nBig+1
700      Continue
*        nBig=n
         nContr(iLqn)=nBig
         Call Sort_genano(d,c,n,n)
         Do 750 i=1,nContr(iLqn)
            OccNo(i+nOccNo)=d(i)
750      Continue
         nOccNo=nOccNo+nContr(iLqn)
*        Write(*,*) 'c matrix'
*        Call sqprt(c,n)
         Call NOphase(c,n)
*        Write(*,*) 'c matrix'
*        Call sqprt(c,n)
*        Write(*,*)
         Write(6,'(a,10(1x,f9.4))') 'occ    ',(d(i),i=1,nBig)
         Write(6,'(a,10(1x,f9.4))') 'lg(occ)',
     &      (Log10(d(i)+1.0d-12),i=1,nBig)
         Write(6,*)

         Do 800 j=1,n
            Write(6,'(7x,10(1x,f9.4))') (c(j+(i-1)*n),i=1,nBig)
800      Continue
         Do 850 i=1,nBig
            Do 851 j=1,n
               Do 852 k=1,n
                  ChkSum=ChkSum+d(i)*c(j+(i-1)*n)*c(k+(i-1)*n)
852            Continue
851         Continue
850      Continue
*        Write(17,*) 'Coefficients for the ',type(iLqn*(iLqn+1)+1),
*    &               ' shell.'
*        Write(17,*)
         Write(17,'(2i5)') n,nBig
         If(rowise) Then
            If(n*nBig.gt.0) Then
               Do 900 i=1,nBig
                  Write(17,'(10(1x,f15.10))') (c(j+(i-1)*n),j=1,n)
900            Continue
            End If
         Else
            If(n*nBig.gt.0) Then
               Do 950 j=1,n
                  Write(17,'(10(1x,f15.10))') (c(j+(i-1)*n),i=1,nBig)
950            Continue
            End If
         EndIf
*        Write(17,*)
*        Write(17,*)
         iPtr=iPtr+(2*iLqn+1)*nTri
1000  Continue
      Call CollapseOutput(0,'   Contraction coefficients')
      Write(6,*)
c      Write(6,'(a,f12.6)') 'Check sum is',ChkSum
      Call Add_Info('GENANO_CHKSUM',[ChkSum],1,5)
      Close(Unit=17)
      call molcas_open(18,'FIG')
c      Open(Unit=18,File='FIG',Form='FORMATTED')
      Call FigOpn(18)
      Call FigPrt(18,Title,MxLqn,nContr,OccNo)
      Call FigCls(18)
      Close(Unit=18)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!               2024, Giovanni Li Manni                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine STRTYP_GAS()
! Find groups of strings in each GA space
!
! Output : /GASSTR/
!
! Jeppe Olsen,  Oct 1994
! G. Li Manni, June 2024: Scale-up capability for single SD ROHF type calculations

use lucia_data, only: IBGPSTR, IBSPGPFTP, IGSFGP, IGSOCC, IGSOCCX, IPHGAS, ISPGPFTP, ISTAC, MNGSOC, MNGSOC, MS2, MXGSOC, MXGSOC, &
                      MXPSTT, NACTEL, NCISPC, NELEC, NELFGP, NELFSPGP, NELFTP, NGAS, NGPSTR, NGRP, NMXOCCLS, NOBPT, NOCTYP, &
                      NSPGPFTP, NSTFGP, NSTTP, NSTTYP, NTSPGP
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: I_AM_OKAY, I_DIM, IADD, IBASSPC(1), IBTYP, IDEL, IEL, IGAS, IGRP, IOCCLS(1), IOCTYP(MXPSTT), IOELMX, IOFF, &
                     IRED, IREOSPGP(MXPSTT), ISCR(MXPSTT), ISPGP, ISPGP_N, ITYP, JGAS, JGRP, MAXSUB, MNA, MNA1, MNAB, MNAL, MNB, &
                     MNB1, MNBL, MXA, MXA1, MXAB, MXAL, MXB, MXB1, MXBL, NABEL, NAEL, NBEL, NEL, NELEC_REF, NOCCLS, NONEW, NSPGP, &
                     NSPGP_TOT
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: MNELFGP(NGAS), MXELFGP(NGAS)
#endif
integer(kind=iwp), external :: IBINOM

! As input NCISPC GAS spaces IGSOCCX are given.
! Obtain space that cantains all these as special cases

!write(u6,*) ' NCISPC ',NCISPC
do IGAS=1,NGAS
  IGSOCC(IGAS,1) = minval(IGSOCCX(IGAS,1,1:NCISPC))
  IGSOCC(IGAS,2) = maxval(IGSOCCX(IGAS,2,1:NCISPC))
  !write(u6,*) ' MINI and MAXI for ISPC = 1 ',IGSOCC(IGAS,1),IGSOCC(IGAS,2)
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Compound GAS space :'
write(u6,*) ' ===================='
write(u6,'(A)')
write(u6,'(A)') '         Min. occ    Max. occ'
write(u6,'(A)') '         ========    ========'
do IGAS=1,NGAS
  write(u6,'(A,I2,3X,I3,9X,I3)') '   GAS',IGAS,IGSOCC(IGAS,1),IGSOCC(IGAS,2)
end do
#endif

! Find min and max number of elecs in each subspace

do IGAS=1,NGAS
  if (IGAS == 1) then
    MNGSOC(IGAS) = IGSOCC(IGAS,1)
    MXGSOC(IGAS) = IGSOCC(IGAS,2)
  else
    MXGSOC(IGAS) = IGSOCC(IGAS,2)-IGSOCC(IGAS-1,1)
    MNGSOC(IGAS) = max(0,IGSOCC(IGAS,1)-IGSOCC(IGAS-1,2))
  end if
end do

! Particle and hole spaces  :
! Hole spaces are always more than half occupied

!IPHGASL = 0
!IPHGAS1(:) = 0
!NPHGAS = 0
!do IGAS=1,NGAS
!  if (IUSE_PH == 1) then
!    ! P/H separation for compound space
!    if (MNGSOC(IGAS) > NOBPT(IGAS)) then
!      IPHGAS(IGAS) = 2
!      IPHGASL = IGAS
!      NPHGAS = NPHGAS+1
!    else
!      IPHGAS(IGAS) = 1
!    end if
!    ! P/H separation for initial space
!    if (IGAS == 1) then
!      MIN_OC1 = IGSOCCX(IGAS,1,1)
!    else
!      MIN_OC1 = IGSOCCX(IGAS,1,1)-IGSOCCX(IGAS-1,2,1)
!    end if
!    if (MIN_OC1 > NOBPT(IGAS)) then
!      IPHGAS1(IGAS) = 2
!    else
!      IPHGAS1(IGAS) = 1
!    end if
!  else if (IUSE_PH == 0) then
!    IPHGAS(IGAS) = 1
!    IPHGAS1(IGAS) = 1
!  end if
!end do
IPHGAS(1:NGAS) = 1
! Large number of particle and hole orbitals
!MXTSOB_P = 0
!MXTSOB_H = 0
!do IGAS=1,NGAS
!  if (IPHGAS1(IGAS) == 1) then
!    MXTSOB_P = max(MXTSOB_P,NOBPT(IGAS))
!  else
!    MXTSOB_H = max(MXTSOB_H,NOBPT(IGAS))
!  end if
!end do
!#ifdef _DEBUGPRINT_
!write(u6,*) ' MXTSOB_H, MXTSOB_P = ',MXTSOB_H,MXTSOB_P
!#endif

!if (IUSE_PH == 1) then
!  IPHGAS(1) = 2
!  do I=1,100
!    write(u6,*) ' First space enforced to hole spaces'
!  end do
!end if

! In the following I assume that the hole spaces are the first NPGAS spaces
! (only used when calculating min number of electrons, so it can be modified easily)
! Min number of electrons in hole spaces
!#ifdef _DEBUGPRINT_
!write(u6,*) ' IPHGASL, NPHGAS ',IPHGASL,NPHGAS
!#endif
!_Jesper if (IPHGASL /= NPHGAS) then
!_Jesper   write(u6,*) ' The hole spaces are not the first orbital spaces'
!_Jesper   stop ' The hole spaces are not the first orbital spaces'
!_Jesper end if
!MNHL = IGSOCC(IPHGASL,1)
!MNHL = 0
!do IGAS = 1, NGAS
!  if (IPHGAS(IGAS) == 2) MNHL = MNHL+MNGSOC(IGAS)
!end do

#ifdef _DEBUGPRINT_
!write(u6,*) ' IPHGASL:',IPHGASL
!if (IPHGASL > 0) write(u6,*) 'IGSOCC(IPHGASL,1):',IGSOCC(IPHGASL,1)

write(u6,*)
write(u6,'(A)') ' Min and Max occupation in each GAS space:'
write(u6,'(A)') ' ========================================='
write(u6,*)
do IGAS=1,NGAS
  write(u6,'(A,I2,4X,2I3)') '  GAS',IGAS,MNGSOC(IGAS),MXGSOC(IGAS)
end do

write(u6,*) ' Particle(1) or hole(2) spaces (for compound space)'
call IWRTMA(IPHGAS,1,NGAS,1,NGAS)
!write(u6,*) ' Particle(1) or hole(2) spaces (for initial space)'
!call IWRTMA(IPHGAS1,1,NGAS,1,NGAS)
#endif

! Occupation classes corresponding to largest CI space

IBASSPC(1) = 0
call OCCLS(1,NOCCLS,IOCCLS,NACTEL,NGAS,IGSOCC(:,1),IGSOCC(:,2),0,IBASSPC,NOBPT)
NMXOCCLS = NOCCLS

! Split into alpha and beta parts

! Number of alpha. and beta electrons

NAEL = (MS2+NACTEL)/2
NBEL = (NACTEL-MS2)/2

if (NAEL+NBEL /= NACTEL) then
  write(u6,*) '  MS2 NACTEL NAEL NBEL'
  write(u6,'(5I4)') MS2,NACTEL,NAEL,NBEL
  write(u6,*) ' STOP : NUMBER OF ELECTRONS AND MULTIPLICITY INCONSISTENT'
  !stop ' NUMBER OF ELECTRONS INCONSISTENT WITH MULTIPLICITY'
  call SYSABENDMSG('lucia_util/strtyp_gas','Internal error','')
end if

#ifdef _DEBUGPRINT_
write(u6,*) '  MS2 NACTEL NAEL NBEL'
write(u6,'(5I6)') MS2,NACTEL,NAEL,NBEL
#endif

if (NAEL+NBEL /= NACTEL) then
  write(u6,*) '  MS2 NACTEL NAEL NBEL'
  write(u6,'(5I4)') MS2,NACTEL,NAEL,NBEL
  write(u6,*) ' STOP : NUMBER OF ELECTRONS AND MULTIPLICITY INCONSISTENT'
  !stop ' NUMBER OF ELECTRONS INCONSISTENT WITH MULTIPLICITY'
  call SYSABENDMSG('lucia_util/strtyp_gas','Internal error','')
end if

! Number of electrons to be subtracted or added

MAXSUB = 2
! electrons are only added for systems that atleast have halffilled shells
IGRP = 0
MXAL = NAEL
MNAL = NAEL
MXBL = NBEL
MNBL = NBEL
do IGAS=1,NGAS
  ! occupation constraints 1
  MXA1 = min(MXGSOC(IGAS),NOBPT(IGAS),MXAL)
  MXB1 = min(MXGSOC(IGAS),NOBPT(IGAS),MXBL)
  MNA1 = max(0,MNGSOC(IGAS)-MXA1)
  MNB1 = max(0,MNGSOC(IGAS)-MXB1)

  ! Additional checks can be made here
  MXA = MXA1
  MXB = MXB1
  MNA = MNA1
  MNB = MNB1

  MXAL = MXAL-MNA
  MNAL = max(0,MNAL-MXA)
  MXBL = MXBL-MNB
  MNBL = max(0,MNBL-MXB)

# ifdef _DEBUGPRINT_
  write(u6,*) ' Occupation numbers for IGAS = ',IGAS
  write(u6,*) ' MXAL MNAL MXBL MNBL ',MXAL,MNAL,MXBL,MNBL
  write(u6,*) ' MXA MNA MXB MNB ',MXA,MNA,MXB,MNB
# endif

  MNAB = min(MNA,MNB)
  MXAB = max(MXA,MXB)

  ! Additional holes only allowed in particle spaces
  if (IPHGAS(IGAS) == 1) then
    MNAB = max(0,MNAB-MAXSUB)
  else if (IPHGAS(IGAS) == 2) then
    MNAB = MNAB
  end if
  ! For coupled cluster- could be refined ...
  MNAB = 0
  if (IPHGAS(IGAS) == 2) MXAB = min(MXAB+2,NOBPT(IGAS))

# ifdef _DEBUGPRINT_
  write(u6,*) ' MNAB,MXAB',MNAB,MXAB
# endif
  NGPSTR(IGAS) = MXAB-MNAB+1
  if ((Nactel == MS2) .and. (Nactel > 2) .and. (Nactel == NOBPT(2)) .and. (IGAS == 2)) then
    NGPSTR(IGAS) = 4 ! Either EMPTY, (FULL-2), (FULL -1), FULL
    MNAB = NAEL-2
  end if
  IBGPSTR(IGAS) = IGRP+1
# ifdef _DEBUGPRINT_
  MNELFGP(IGAS) = MNAB
  MXELFGP(IGAS) = MXAB
# endif

  IADD = 0
  do JGRP=IGRP+1,IGRP+NGPSTR(IGAS)
    if (JGRP > MXPSTT) then
      write(u6,*) ' Too many string groups'
      write(u6,*) ' Current limit ',MXPSTT
      write(u6,*) ' STOP : GASSTR, Too many string groups'
      !stop' GASSTR, Too many string groups'
      call SYSABENDMSG('lucia_util/gasstr','Internal error','')
    end if

    if ((Nactel == MS2) .and. (Nactel > 2) .and. (Nactel == NOBPT(2)) .and. (IGAS == 2) .and. (JGRP == 2)) then
      IEL = 0
    else
      IADD = IADD+1
      IEL = MNAB-1+IADD
    end if
    NELFGP(JGRP) = IEL
    IGSFGP(JGRP) = IGAS
    NSTFGP(JGRP) = IBINOM(NOBPT(IGAS),IEL)
  end do
  IGRP = IGRP+NGPSTR(IGAS)
end do
NGRP = IGRP

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,'(A)') ' Information about Groups of strings'
write(u6,'(A)') ' ==================================='
write(u6,*)
write(u6,*) '     GAS  MNEL  MXEL IBGRP  NGRP'
write(u6,*) '    ============================'
do IGAS=1,NGAS
  write(u6,'(5(2X,I4))') IGAS,MNELFGP(IGAS),MXELFGP(IGAS),IBGPSTR(IGAS),NGPSTR(IGAS)
end do
write(u6,'(A,I3)') ' Total number of groups generated ',NGRP

write(u6,'(A)') ' Information about each string group'
write(u6,'(A)') ' ==================================='
write(u6,*)
write(u6,'(A)') ' GROUP  GAS   NEL      NSTR'
write(u6,'(A)') ' =========================='
do IGRP=1,NGRP
  write(u6,'(3(2X,I4),2X,I8)') IGRP,IGSFGP(IGRP),NELFGP(IGRP),NSTFGP(IGRP)
end do
#endif

! Creation-annihilation connections between groups

do IGRP=1,NGRP
  ISTAC(IGRP,1) = 0
  ISTAC(IGRP,2) = 0
  do JGRP=1,NGRP
    if ((IGSFGP(IGRP) == IGSFGP(JGRP)) .and. (NELFGP(IGRP) == NELFGP(JGRP)-1)) ISTAC(IGRP,2) = JGRP
    if ((IGSFGP(IGRP) == IGSFGP(JGRP)) .and. (NELFGP(IGRP) == NELFGP(JGRP)+1)) ISTAC(IGRP,1) = JGRP
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ======================================'
write(u6,*) ' Annihilation / Creation connections'
write(u6,*) ' ======================================'
write(u6,*)
call IWRTMA(ISTAC,NGRP,2,MXPSTT,2)
#endif

! Construct number of type (combinations of groups) with nael and nbel strings

! Type 1 : NAEL electrons
!      2 : NBEL ELECTRONS
!      3 : NAEL -1 ELECTRONS
!      4 : NBEL -1 ELECTRONS
!      5 : NAEL -2 ELECTRONS
!      6 : NBEL -2 ELECTRONS

NSTTYP = 6
NSTTP = 6

!if (IUSE_PH == 1) then
!  ! allow N+1,N+2 resolution string
!  NSTTYP = 10
!  NSTTP = 10
!end if
! alpha
NELEC(1) = NAEL
NELFTP(1) = NAEL
! beta
NELEC(2) = NBEL
NELFTP(2) = NBEL
! alpha -1
NELEC(3) = NAEL-1
NELFTP(3) = NAEL-1
! beta  -1
NELEC(4) = NBEL-1
NELFTP(4) = NBEL-1
! alpha -2
NELEC(5) = NAEL-2
NELFTP(5) = NAEL-2
! beta  -2
NELEC(6) = NBEL-2
NELFTP(6) = NBEL-2

!if (IUSE_PH == 1) then
!  ! Alpha + 1
!  NELEC(7) = NAEL+1
!  NELFTP(7) = NAEL+1
!  ! beta  + 1
!  NELEC(8) = NBEL+1
!  NELFTP(8) = NBEL+1
!  ! Alpha + 2
!  NELEC(9) = NAEL+2
!  NELFTP(9) = NAEL+2
!  ! beta  + 2
!  NELEC(10) = NBEL+2
!  NELFTP(10) = NBEL+2
!end if
! Can easily be extended to relativistic case !!
NOCTYP(1:NSTTYP) = 0
NSPGPFTP(1:NSTTYP) = 0

! Loop over types, i.e.  given number of electrons

IOFF = 1
NABEL = NAEL+NBEL
NSPGP_TOT = 0
do ITYP=1,NSTTYP
  ! Number of electrons in reference space (alpha or beta)
  if (mod(ITYP,2) == 1) then
    ! alpha type
    NELEC_REF = NELEC(1)
  else
    ! beta type
    NELEC_REF = NELEC(2)
  end if
  ! If we are studying beta type, and number of alpha and beta
  ! electrons are identical, just refer to alpha
  if ((NAEL == NBEL) .and. (mod(ITYP,2) == 0)) then
    IBSPGPFTP(ITYP) = IBSPGPFTP(ITYP-1)
    NOCTYP(ITYP) = NOCTYP(ITYP-1)
    NSPGPFTP(ITYP) = NSPGPFTP(ITYP-1)
  else
    ! Number of electrons removed compared to reference
    IDEL = NELEC(ITYP)-NELEC_REF
    !write(u6,*) '  GASSPC : ITYP IDEL ',ITYP,IDEL
    ! Initial type of strings, relative to offset for given group
    IOCTYP(1:NGAS) = 1
    NSPGP = 0
    IBSPGPFTP(ITYP) = IOFF
    if (NELEC(ITYP) < 0) then
      NOCTYP(ITYP) = 0
      NSPGPFTP(ITYP) = 0
      cycle
    end if
    ! Number of electrons in present type
    ! Loop over  SUPER GROUPS with current nomenclature!
    NONEW = 0
    do while (NONEW == 0)
      ! Number of electrons in present supergroup
      NEL = 0
      do IGAS=1,NGAS
        NEL = NEL+NELFGP(IOCTYP(IGAS)+IBGPSTR(IGAS)-1)
      end do

      if (NEL > NELEC(ITYP)) then
        ! If the number of electrons is to large find next number that
        ! can be correct.
        ! The following uses that within a given GAS space
        ! the number of elecs increases as the type number increases

        ! First integer  that can be reduced
        IRED = 0
        do IGAS=1,NGAS
          if (IOCTYP(IGAS) /= 1) then
            IRED = IGAS
            exit
          end if
        end do
        if (IRED == NGAS) then
          NONEW = 1
        else if (IRED < NGAS) then
          IOCTYP(IRED) = 1
          ! Increase remanining part
          call NXTNUM2(IOCTYP(IRED+1),NGAS-IRED,1,NGPSTR(IRED+1),NONEW)
        end if
        cycle
      end if

      if (NEL == NELEC(ITYP)) then
        ! test 1 has been passed, check additional occupation constraints

        I_AM_OKAY = 1
        ! Number of extra holes in hole spaces
        !E if (IUSE_PH == 1) then
        !E   IDELP = 0
        !E   IDELM = 0
        !E   do IGAS=1,NGAS
        !E     if (IPHGAS(IGAS) == 2) then
        !E       NELH = NELFGP(IOCTYP(IGAS)+IBGPSTR(IGAS)-1)
        !E       if (NELH < MNGSOC(IGAS)) IDELM = IDELM+MNGSOC(IGAS)-NELH
        !E       if (NELH > MXGSOC(IGAS)) IDELP = IDELP+NELH-MXGSOC(IGAS)
        !E     end if
        !E   end do
        !E   if ((IDELM > 0) .or. (IDELP > MAX(0,IDEL))) then
        !E     I_AM_OKAY = 0
        !E     write(u6,*) ' P/H rejected supergroup'
        !E     call IWRTMA(IOCTYP,1,NGAS,1,NGAS)
        !E     write(u6,*) ' IDELM, IDELP ',IDELM,IDELP
        !E   end if
        !E end if

        ! Check from above

        do IGAS=NGAS,1,-1
          ! Number of electrons when all electrons of AS IGAS have been added
          if (IGAS == NGAS) then
            IEL = max(NABEL,NABEL+IDEL)
          else
            IEL = IEL-NELFGP(IOCTYP(IGAS+1)+IBGPSTR(IGAS+1)-1)
            if (IEL < max(IGSOCC(IGAS,1),IGSOCC(IGAS,1)+IDEL)) I_AM_OKAY = 0
          end if
        end do

        ! Check from below

        IEL = 0
        IOELMX = 0
        do IGAS=1,NGAS
          IEL = IEL+NELFGP(IOCTYP(IGAS)+IBGPSTR(IGAS)-1)
          IOELMX = IOELMX+NOBPT(IGAS)
          if (IEL+IOELMX < min(IGSOCC(IGAS,1),IGSOCC(IGAS,1)+IDEL)) I_AM_OKAY = 0
        end do

        if (I_AM_OKAY == 1) then
          ! passed !!!
          NSPGP = NSPGP+1
          ! Copy supergroup to ISPGPFTP with absolute group numbers
          ISPGPFTP(1:NGAS,IOFF-1+NSPGP) = IOCTYP(1:NGAS)+IBGPSTR(1:NGAS)-1
        end if

      end if
      ! Next type of strings
      call NXTNUM2(IOCTYP,NGAS,1,NGPSTR,NONEW)
    end do
    ! End of loop over possible supergroups, save information about current type
    IOFF = IOFF+NSPGP
    NOCTYP(ITYP) = NSPGP
    NSPGPFTP(ITYP) = NSPGP
    NSPGP_TOT = NSPGP_TOT+NSPGP
  end if
end do
NTSPGP = NSPGP_TOT

if (NSPGP_TOT > MXPSTT) then
  write(u6,*) ' Too many super groups = ',NSPGP_TOT
  write(u6,*) ' Increase MXPSTT to this value'
  write(u6,*) ' See you later'
  write(u6,*)
  write(u6,*) ' STOP Increase MXPSTT'
  !stop ' Increase MXPSTT'
  call SYSABENDMSG('lucia_util/strtyp_gas','Internal error','')
end if

! Reorder supergroups according to dimension

do ITYP=1,NSTTP
  IBTYP = IBSPGPFTP(ITYP)
  NSPGP = NSPGPFTP(ITYP)
  ! Dimension of supergroups
  do ISPGP=1,NSPGP
    I_DIM = 1
    do JGAS=1,NGAS
      I_DIM = I_DIM*NSTFGP(ISPGPFTP(JGAS,ISPGP+IBTYP-1))
    end do
    IOCTYP(ISPGP) = I_DIM
  end do
  ! Reorder
  !    ORDINT(IINST,IOUTST,NELMNT,INO)
  call ORDINT(IOCTYP,ISCR,NSPGP,IREOSPGP)
  !write(u6,*) ' IREO array'
  !call IWRTMA(IREOSPGP,1,NSPGP,1,NSPGP)
  ! And reorder the definition of supergroups
  NELFSPGP(1:NGAS,1:NSPGP) = ISPGPFTP(1:NGAS,IBTYP:IBTYP+NSPGP-1)
  do ISPGP_N=1,NSPGP
    ISPGPFTP(1:NGAS,ISPGP_N+IBTYP-1) = NELFSPGP(1:NGAS,IREOSPGP(ISPGP_N))
  end do

end do
! End of loop over types

#ifdef _DEBUGPRINT_
write(u6,*) ' Total number of super groups ',NTSPGP
write(u6,*) ' Number of alpha supergroups  ',NSPGPFTP(1)
write(u6,*) ' Number of beta  supergroups  ',NSPGPFTP(2)
write(u6,*)
write(u6,*)

write(u6,*) ' Information about types of strings'
write(u6,*) ' =================================='
write(u6,*)
do ITYP=1,NSTTYP
  write(u6,*)
  write(u6,*) '      Type : ',ITYP
  write(u6,*) '      ==============='
  write(u6,*) '      Number of electrons  ',NELFTP(ITYP)
  write(u6,*) '      Number of super groups ',NSPGPFTP(ITYP)
  write(u6,*) '      Supergroups'
  do ISPGP=1,NSPGPFTP(ITYP)
    IOFF = IBSPGPFTP(ITYP)
    call IWRTMA(ISPGPFTP(1,IOFF-1+ISPGP),1,NGAS,1,NGAS)
  end do
end do
#endif

end subroutine STRTYP_GAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ChkIfKey()
! ------------------------------------------------------------
! Check if the next item on luinput is a string that starts with
! a keyword. Print warning else.
! ------------------------------------------------------------

use input_ras, only: LUInput, nKeys, CMD
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iCmd
character(len=180) :: Line
character(len=4) :: Command

read(LUInput,*) Line
Command = Line(1:4)
call UpCase(Command)
do iCmd=1,NKeys
  if (Command == Cmd(iCmd)) return
end do
write(u6,*) ' ****************************************************'
write(u6,*) ' ChkIfKey Warning: The following line seems intended'
write(u6,*) ' to give some keyword input, but was not recognized:'
write(u6,*) ' '''//line(1:32)//''''
write(u6,*) ' Spelling or syntactic mistake? Ignored!'
write(u6,*) ' ****************************************************'

end subroutine ChkIfKey

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! auxiliary constant pool: ready only up to g-valence/g-core

module AMatrix

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: lp1 = 5, lp12 = lp1**2, lp13 = lp1*(lp1+1)/2
integer(kind=iwp) :: KOSUU(lp13), NYU(lp1,lp13)
real(kind=wp) :: DFAC(lp12), RCA(lp1,lp13)

public :: DFAC, KOSUU, lp1, lp12, NYU, RCA

end module AMatrix

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#ifdef _DMRG_
************************************************************************
*                                                                      *
*  Purpose:  read DMRG input in QCMaquis style                         *
*                                                                      *
************************************************************************
      subroutine socc_dmrg_rdinp(luinput,initial_occ,nrs2t,nroots)

      use qcmaquis_interface_utility_routines, only: lower_to_upper

      implicit none

      integer, intent(in)    :: luinput
      integer, intent(in)    :: nrs2t, nroots
      integer, intent(inout) :: initial_occ(nrs2t,nroots)

      integer                :: i, j, k, io, ls
      character(len=800)     :: string
      character(len=  1)     :: tag

      i = 1
      do
        if(i > nroots) exit

        string(1:800) = ""
        read(luinput,'(a)',IOSTAT=io) string
        if (is_iostat_end(io)) exit
        if (io>0) call SysAbendMsg('socc_dmrg_rdinp',
     &                 'problem reading QCMaquis SOCC input','')
        ls = len_trim(string)
        j = 0
        do k = 1, ls

          tag = string(k:k)
          if(tag == ' ' .or. tag == ',') cycle

          j = j + 1
          if(j > nrs2t) exit

          call lower_to_upper(tag)

          if(tag == 'U')then
            initial_occ(j,i) = 3
          else if(tag == 'D')then
            initial_occ(j,i) = 2
          else if(tag == '2')then
            initial_occ(j,i) = 4
          else if(tag == '0')then
            initial_occ(j,i) = 1
          else
            call SysAbendMsg('socc_dmrg_rdinp',
     &           'problem reading QCMaquis SOCC input:',
     &           'unknown orbital occupation: I know U, D, 2, 0')
          end if
        end do

        if(j /= nrs2t) call SysAbendMsg('socc_dmrg_rdinp',
     &                      'problem reading QCMaquis SOCC input:',
     &                      'wrong number of active orbitals')
        i = i + 1
      end do

      end subroutine socc_dmrg_rdinp
#else
      subroutine socc_dmrg_rdinp()
      implicit none
      end subroutine socc_dmrg_rdinp
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Readin_poly(nneq, neq, neqv, exch, nCenter,
     &                       nT, nH, nTempMagn, nDir, nDirZee,
     &                       nMult, nPair, nexch, nDim,
     &                       i_pair, lant, multLn, iPrint, keopt,
     &                       encut_definition, nK, mG, iopt, nP,
     &                       AngPoints, ncut, LUZee, MxRank1, MxRank2,
     &                       imaxrank,

     &                       TempMagn, R_LG, R_ROT, Jex, JAex, JAex9,
     &                       JDMex, JITOexR, JITOexI,
     &                       tpar, upar, cryst, coord, Xfield,
     &                       gtens_input, D_fact, EoverD_fact, riso,
     &                       MagnCoords, thrs, tmin, tmax, hmin, hmax,
     &                       Texp, chit_exp, Hexp, Mexp, encut_rate,
     &                       zJ, dirX, dirY, dirZ, dir_weight,

     &                       Title, itype,

     &                       ifHDF,
     &                       compute_g_tensors, compute_magnetization,
     &                       TINPUT,HINPUT, Do_structure_abc, DoPlot,
     &                       compute_Mdir_vector, zeeman_energy,
     &                       m_paranoid, m_accurate, smagn,
     &                       compute_susceptibility, decompose_exchange,
     &                       KE, fitCHI, fitM, compute_torque,
     &                       compute_barrier, Dipol, check_title,
     &                       AnisoLines1, AnisoLines3, AnisoLines9,
     &                       DM_exchange, JITO_exchange)
C
C  THIS ROUTINE READS THE standard input.
C
      Implicit None
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
#include "mgrid.fh"
#include "warnings.fh"

c  definition of the cluster:
      Integer       :: nneq, neqv, neq(nneq), nCenter
      Logical       :: ifHDF
c  definition of the local metal sites
      Real(kind=8) :: R_LG( nneq,neqv,3,3)
      Real(kind=8) :: R_ROT(nneq,neqv,3,3)
      Real(kind=8) :: gtens_input(3,nneq)
      Real(kind=8) :: D_fact(nneq)
      Real(kind=8) :: EoverD_fact(nneq)
      Real(kind=8), intent(out) :: riso(nneq,3,3)
      Character(Len=1)  :: itype(nneq)
c  definition of the exchange:
!     total number of exchange states
      Integer       :: exch
!     number of metal pairs (number of interactions)
      Integer       :: nPair
!     exchange basis, nmax= MAX(nexch(:))
      Integer       :: nexch(nneq)
!     index of the metal site in a given interacting pair
      Integer       :: i_pair(nPair,2)
      Logical       :: AnisoLines1, AnisoLines3, AnisoLines9
      Logical       :: Dipol, DM_exchange
!     Lines exchange    ( 1 parameter / interacting pair)
      Real(kind=8) :: Jex(nPair)
!     Anisotropic Lines ( 3 parameter / interacting pair)
      Real(kind=8) :: JAex(nPair,3)
!     Anisotropic Lines full ( 9 parameters / interacting pair)
      Real(kind=8) :: JAex9(nPair,3,3)
      Real(kind=8) :: JDMex(nPair,3)
      ! options used in connection with ITO exchange:
      Logical             :: JITO_exchange
      Integer, intent(in) :: MxRank1, MxRank2
      Integer, intent(out):: imaxrank(npair,2)
      Real(kind=8), intent(out) ::
     &                 JITOexR(nPair,MxRank1,-MxRank1:MxRank1,
     &                               MxRank2,-MxRank2:MxRank2)
      Real(kind=8), intent(out) ::
     &                 JITOexI(nPair,MxRank1,-MxRank1:MxRank1,
     &                               MxRank2,-MxRank2:MxRank2)

      ! options used in connection with KE
      Integer       :: lant, KEOPT, multLn
      Logical       :: KE
      Real(kind=8) :: tpar, upar
      ! options used in connection with Dipol-Dipol interaction
      Real(kind=8) :: MagnCoords(nneq,3)

c  definition of g and D tensors
      Integer       :: nMult
      Integer       :: nDim(nMult)
      Logical       :: compute_g_tensors
c  definition of data for susceptibility
      Integer       :: nT
      Logical       :: tinput, compute_susceptibility
      Real(kind=8) :: tmin, tmax
      Real(kind=8) :: chit_exp(nT), Texp(nT)
      ! options related to XT_MoverH
      Real(kind=8) :: Xfield
c  definition of data for magnetization:
      Integer       :: nH
      Integer       :: nTempMagn
      Integer       :: iopt
      Real(kind=8) :: TempMagn(nTempMagn)
      Real(kind=8) :: Hexp(nH), Mexp(nH,nTempMagn)
      Real(kind=8) :: thrs
      Real(kind=8) :: hmin, hmax
      Logical       :: hinput
      Logical       :: compute_magnetization
      Logical       :: compute_Mdir_vector
      Logical       :: zeeman_energy
      Logical       :: m_paranoid
      Logical       :: m_accurate
      Logical       :: smagn
      ! options used to set up nM and EM
      Integer       :: encut_definition
      Integer       :: nK, mG ! encut_definition=1;
      Integer       :: ncut   ! encut_definition=2;
      Real(kind=8) :: encut_rate ! encut_definition=3;
c decompose exchange
      Logical       :: decompose_exchange

c  magnetization torque
      Integer       :: nP
      Integer       :: AngPoints
      Logical       :: compute_torque
c  Zeeman energy and M vector
      Integer       :: nDir, nDirZee
      Integer       :: LUZee(nDirZee)
      Real(kind=8) :: dirX(nDir), dirY(nDir), dirZ(nDir)
      Real(kind=8) :: dir_weight(nDirZee,3)
c  definition of mean field parameter
      Real(kind=8) :: zJ
c  definintion of the crystal axes:
      Logical       :: Do_structure_abc
      Real(kind=8) :: cryst(6) ! a, b, c, alpha, beta, gamma
!     Cartesian coordinates of the main metal site, or center
      Real(kind=8) :: coord(3)
c  definitions for blocking barrier
      Logical       :: compute_barrier
c  options for automatic fitting of parameters:
      Logical       :: fitCHI !-- not used so far
      Logical       :: fitM !-- not used so far
c  definition of print level
      Integer       :: iPrint
      Logical       :: check_title
      Character(Len=180):: Title
      Logical       :: DoPlot


c--------- LOCAL VARIABLES --------------------
      Integer       :: Input
      Real(kind=8) :: check_dir_weight(3*nDirZee),tmp,sum
      Integer       :: ll,i,j,l,k,m,n,icount_b_sites,lp,ic,jc
      Integer       :: linenr, inneq, irank1, irank2, iproj1, iproj2
      Integer       :: duplicate_check(nPair), nind(exch,2)
      Integer       :: nst, ASUM, jrank1,jrank2,jproj1,jproj2
      Integer       :: i1,i2,lb1,lb2
!     index of the metal site in a given interacting pair
c      Integer       :: nind(nPair,2)
c      Integer       :: ind_exch(nneq)
c      Real(lind=wp) :: magncoords(2*maxanisofiles,3)
      Real(kind=8) :: finddetr, detR
      Real(kind=8) :: tmpR(3,3)
      Logical       :: nosym
      External      :: finddetr

c variables connected to computation of g and d tensors
      Logical       :: check_nneq_presence, readgfact, ab_initio_all
      Logical       :: tcheck, hcheck, encut_check
      Logical       :: check_symm_presence
      Logical       :: checktmag

      Real(kind=8) :: t2, t1

      Character(Len=2)  :: lanth
c      Character(Len=14) :: namefile_energy(nDirZee)
      Character(Len=21) :: namefile_energy
      Character(Len=288):: Line, ctmp, string

      Integer :: IsFreeUnit
      External :: IsFreeUnit

      Logical :: DBG




      DBG=.false.

      check_nneq_presence   = .true.
      check_title           = .false.
      icount_B_sites        = 0
      i_pair                = 0
      nosym                 = .true.
      ENCUT_check           = .false.
      TINPUT                = .false.
      HINPUT                = .false.
      TCHECK                = .false.
      HCHECK                = .false.
      Do i=1,nneq
         Do j=1,Neq(i)
            R_rot(i,j,1,1)=1.0_wp
            R_rot(i,j,2,2)=1.0_wp
            R_rot(i,j,3,3)=1.0_wp
             R_lg(i,j,1,1)=1.0_wp
             R_lg(i,j,2,2)=1.0_wp
             R_lg(i,j,3,3)=1.0_wp
         End Do
      End Do
      check_symm_presence=.true.
      If (neqv>1) check_symm_presence=.false.


      If(DBG) Write(6,'(A,  i6)') 'RDIN:      nneq=',nneq
      If(DBG) Write(6,'(A,  i6)') 'RDIN:      neqv=',neqv
      If(DBG) Write(6,'(A,  i6)') 'RDIN:     nPair=',nPair
c      If(DBG) Write(6,'(A,99I6)') 'RDIN:  i_pair(:,1)=',
c     &                                    (i_pair(i,1),i=1,nPair)
c      If(DBG) Write(6,'(A,99I6)') 'RDIN:  i_pair(:,2)=',
c     &                                    (i_pair(i,2),i=1,nPair)
      If(DBG) Write(6,'(A,99i6)') 'RDIN:     neq()=',(neq(i),i=1,nneq)
      If(DBG) Write(6,'(A,99i6)') 'RDIN:   nexch()=',(nexch(i),i=1,nneq)


C=========== End of default settings====================================
      Input = 5
      Rewind(Input)
50    READ(Input,'(A72)',End=998) LINE
      If(DBG) write(6,'(A)') LINE
      Call NORMAL(LINE)
      If(LINE(1:5).ne.'&POLY') Go To 50
      LINENR=0

100   Call xFlush(6)
      READ(Input,'(A72)',End=998) LINE
      LINENR=LINENR+1
      Call NORMAL(LINE)
      If(LINE(1:1).eq.'*')   Go To 100
      If(LINE     .eq.' ')   Go To 100
      If(LINE(1:3).eq.'END') Go To 210 !End


* ------------ TITL ---------------------------------------------------**
      If (LINE(1:4).eq.'TITL') Then

         READ(Input,*,ERR=997) ctmp

         If(DBG) write(6,'(A)') ctmp
         check_title=.true.
         Title = trim(ctmp)
         LINENR=LINENR+1
         Go To 100
      End If



*---  process MLTP command --------------------------------------------**
      If (LINE(1:4).eq.'MLTP') Then

         READ(Input,*,ERR=997) NMULT

         If(DBG) write(6,'(A,i4)') 'NMULT =',NMULT

         READ(Input,*,Err=997) (NDIM(i),i=1,NMULT)

         Do i=1,NMULT
            If( NDIM(i)<0 ) Then
               ctmp=''
               Write(ctmp,'(A,I2,A)') 'MLTP: the dimension of the '//
     &                                'multiplet ',i,' is negative!!!'
               Call WarningMessage(2,ctmp)
               Call quit(_RC_INPUT_ERROR_)
            Else If ( NDIM(i)==0 ) Then
               ctmp=''
               Write(ctmp,'(A,I2,A)') 'MLTP: the dimension of the '//
     &                                'multiplet ',i,' is zero!!!'
               Call WarningMessage(2,ctmp)
               Call quit(_RC_INPUT_ERROR_)
            End If
         End Do

         If(DBG) write(6,'(A,100i4)') 'NDIM: ',(NDIM(i),i=1,NMULT)
         compute_g_tensors=.true.
         LINENR=LINENR+2
         Go To 100
      End If



*---  process TINT command --------------------------------------------**
      If (LINE(1:4).eq.'TINT') Then
         compute_susceptibility=.true.
         If(TINPUT.EQV..FALSE.) Then
            TCHECK=.TRUE.
            t1=0.0_wp
            t2=0.0_wp

            READ(Input,*,ERR=997) t1, t2, nT

            If( (t1<0).OR.(t2<0)) Then
               Call WarningMessage(2,
     &                  'TINT: negative temperature requested! ')
               Call quit(_RC_INPUT_ERROR_)
            End If
            If( (t1-t2)>0.0_wp) Then
               Tmin=t2
               Tmax=t1
            Else If ( (t1-t2)<0.0_wp ) Then
               Tmin=t1
               Tmax=t2
            Else ! t1==t2
               Call WarningMessage(2,
     &                  'TINT: temperature interval == 0! ' )
               Call quit(_RC_INPUT_ERROR_)
            End If

            If(DBG) write(6,'(A,2E15.7,i6)') 'Tmin, Tmax, nT: ',
     &                                    Tmin, Tmax, nT
         Else
            goto 590
         End If
         LINENR=LINENR+1
         Go To 100
      End If



*---  process HINT command --------------------------------------------**
      If (LINE(1:4).eq.'HINT') Then
         If(HINPUT.EQV..FALSE.) Then
            HCHECK=.TRUE.
            compute_magnetization=.true.
            t1=0.0_wp
            t2=0.0_wp

            READ(Input,*,ERR=997) t1, t2, nH

            If ( (t1<0).OR.(t2<0) ) Then
               Call WarningMessage(2,
     &                  'HINT: negative field requested! ')
               Call quit(_RC_INPUT_ERROR_)
            End If
            If ( (t1-t2)>0.0_wp ) Then
               Hmin=t2
               Hmax=t1
            Else If ( (t1-t2)<0.0_wp ) Then
               Hmin=t1
               Hmax=t2
            Else ! t1==t2
               Call WarningMessage(2,
     &                  'HINT: temperature interval == 0! ')
               Call quit(_RC_INPUT_ERROR_)
            End If


            If(DBG) write(6,'(A,2E15.7,i6)') 'Hmin, Hmax, nH: ',
     &                                    Hmin, Hmax, nH
         Else
            Go To 591
         End If
         LINENR=LINENR+1
         Go To 100
      End If



*---  process THRS command --------------------------------------------**
      If (LINE(1:4).eq.'THRS') Then

         READ(Input,*,ERR=997) THRS

         If ( thrs<0.0_wp ) Then
            Call WarningMessage(2,'THRS: negative threshold for '//
     &                            ' average M!!! ')
            Write(6,'(A)') 'Set to default thrs=1d-10'
         End If

         If(DBG) write(6,'(A,E15.7)') 'THRS: ', THRS
         LINENR=LINENR+1
         Go To 100
      End If


*---  process XFIE command --------------------------------------------**
      If (LINE(1:4).eq.'XFIE') Then
         compute_susceptibility=.true.

         READ(Input,*,ERR=997) tmp

         If ( tmp<0.0_wp ) Then
            Call WarningMessage(2,'XFIE: negative value of the'//
     &                            ' applied field !')
            Write(6,'(A)') 'Set to positive !'
            Xfield=abs(tmp)
         Else If (tmp==0.0_wp) Then
            Call WarningMessage(2,'XFIE: zero value of the'//
     &                            ' applied field !')
            Write(6,'(A)') 'Field-applied XT will not be computed!'
         Else
            Xfield=tmp
         End If
         If(DBG) write(6,'(A,E15.7)') 'XFIE: ',xField

         LINENR=LINENR+1
         Go To 100
      End If


*---  process PLOT command --------------------------------------------**
      If (LINE(1:4).eq.'PLOT') Then
         DoPlot=.true.

         If(DBG) write(6,'(A,L2)') 'PLOT: ',DoPlot

         LINENR=LINENR+1
         Go To 100
      End If


*---  process IOPT command --------------------------------------------**
      If (LINE(1:4).eq.'IOPT') Then

         READ(Input,*,ERR=997)  I  !option for computing MSUM and XTSUM

         If ( (i<0).or.(i>3) ) Then
            Call WarningMessage(2,'IOPT: value out of range!!!')
            Write(6,'(A)') 'Set to default !'
            iopt=1
         Else
            iopt=i
         End If

         If(DBG) write(6,'(A,I6)') 'IOPT: ',IOPT
         LINENR=LINENR+1
         Go To 100
      End If


*---  process SMAG command --------------------------------------------**
      If (LINE(1:4).eq.'SMAG') Then
         smagn=.true.
         compute_magnetization=.true.
         If(DBG) write(6,'(A,L2)') 'SMAG: ',smagn
         LINENR=LINENR+1
         Go To 100
      End If


*---  process MACC command --------------------------------------------**
      If (LINE(1:4).eq.'MACC') Then
         compute_magnetization=.true.  ! request for computation of M(H)
         m_accurate=.true.             ! request for computation of M(H)
         If(DBG) write(6,'(A,L2)') 'MACC: ',m_accurate
         LINENR=LINENR+1
         Go To 100
      End If


*---  process FITX command --------------------------------------------**
      If (LINE(1:4).eq.'FITX') Then
         fitCHI=.true.
         LINENR=LINENR+1
         Go To 100
      End If


*---  process FITM command --------------------------------------------**
      If (LINE(1:4).eq.'FITM') Then
         fitM=.true.
         LINENR=LINENR+1
         Go To 100
      End If


*---  process MPAR command --------------------------------------------**
      If (LINE(1:4).eq.'MPAR') Then
         m_paranoid=.true.             ! request for computation of M(H)
         compute_magnetization=.true.
         If(DBG) write(6,'(A,L2)') 'MPAR: ',m_paranoid
         LINENR=LINENR+1
         Go To 100
      End If


*---  process TORQ command --------------------------------------------**
      If (LINE(1:4).eq.'TORQ') Then

         compute_torque=.true.         ! request for computation of M(H)
         READ(Input,*,ERR=997) i        ! number of angular points

         If ( i<=0 ) Then
            Call WarningMessage(2,'TORQ: nP value out of range!!!')
            Write(6,'(A)') 'Set to default !'
            nP=45
         Else
            nP=i
         End If

         If(DBG) write(6,'(A)') 'TORQ: nP=',nP
         AngPoints=nP+1
         LINENR=LINENR+1
         Go To 100
      End If


*---  process MAVE command --------------------------------------------**
      If (LINE(1:4).eq.'MAVE') Then
         compute_magnetization=.true.  ! request for computation of M(H)

         READ(Input,*,ERR=997) i,j  !nsymm, ngrid

         If ( (i<=0).or.(i>=4) ) Then
            Call WarningMessage(2,'MAVE: nSYMM value out of range!!!')
            Write(6,'(A)') 'Set to default !'
            nsymm=1
         Else
            nsymm=i
         End If

         If ( (j<=0).or.(j>=33) ) Then
            Call WarningMessage(2,'MAVE: nGRID value out of range!!!')
            Write(6,'(A)') 'Set to default !'
            ngrid=15
         Else
            ngrid=i
         End If

         If(DBG) write(6,'(2(A,i6))')' nsymm:  ', nsymm,
     &                               ' ngrid:  ', ngrid
         LINENR=LINENR+1
         Go To 100
      End If


*---  process NCUT command --------------------------------------------**
      If (LINE(1:4).eq.'NCUT') Then
         If(ENCUT_check) Then
            Go To 595
         Else
            ENCUT_check=.true.
!           request for computation of M(H)
            compute_magnetization=.true.
            encut_definition=1

            READ(Input,*,ERR=997) i ! NCUT
!           E_cut= exchange_energy(Ncut)

            If ( (i<=0).or.(i>exch) ) Then
               Call WarningMessage(2,'NCUT: value out of range!!!')
               Write(6,'(A)') 'Set to full exchange basis.'
               nCUT=exch
            Else
               nCUT=i
            End If
            If(DBG) write(6,'(A,2i6)') 'ncut:  ', nCut

            LINENR=LINENR+1
            Go To 100
         End If
      End If


*---  process ENCU command --------------------------------------------**
      If (LINE(1:4).eq.'ENCU') Then
         If(ENCUT_check) Then
            Go To 595
         Else
            ENCUT_check=.true.
!           request for computation of M(H)
            compute_magnetization=.true.
            encut_definition=2

            READ(Input,*,ERR=997) NK, MG
!           E_cut = NK * K_Boltz + MG * mu_Bohr
            If(DBG) write(6,'(A,2i6)') 'encu:  nK, mG=',NK, MG

            LINENR=LINENR+1
            Go To 100
         End If
      End If

*---  process ERAT command --------------------------------------------**
      If (LINE(1:4).eq.'ERAT') Then
         If(ENCUT_check) Then
            Go To 595
         Else
            ENCUT_check=.true.
!           request for computation of M(H)
            compute_magnetization=.true.
            encut_definition=3

            READ(Input,*,ERR=997) encut_rate
!           Ncut = INT(nexch*encut_rate); E_cut= E(Ncut)
            If(DBG) write(6,'(A,i6)') 'encut_rate=',encut_rate

            LINENR=LINENR+1
            Go To 100
         End If
      End If

*---  process ZJPR command --------------------------------------------*
      If (LINE(1:4).eq.'ZJPR') Then
         READ(Input,*,ERR=997) ZJ
         If(DBG) write(6,'(A,E18.10)') 'zJ    =',zJ
         LINENR=LINENR+1
         Go To 100
      End If

*---  process PRLV command --------------------------------------------*
      If (LINE(1:4).eq.'PRLV') Then
         READ(Input,*,ERR=997) iPrint
         If(DBG) write(6,'(A,i6)') 'iPrint=',iPrint
         LINENR=LINENR+1
         Go To 100
      End If

*---  process COOR command --------------------------------------------*
      If (LINE(1:4).eq.'COOR') Then
         Dipol=.true.
         If(DBG) write(6,'(A)') 'isite   MagnCoords:'
         Do i=1,nneq
            READ(Input,*,ERR=997) (MagnCoords(i,l),l=1,3)
            If(DBG) write(6,'(i3,5x,3E18.10)') i,(MagnCoords(i,l),l=1,3)
         End Do
         LINENR=LINENR+nneq
         Go To 100
      End If

*---  process MVEC command --------------------------------------------**
      If (LINE(1:4).eq.'MVEC') Then
         compute_magnetization=.true.  ! request for computation of M(H)
         compute_Mdir_vector=.true.

         READ(Input,*,ERR=997) nDir
         If(DBG) write(6,'(A,i3)') 'nDir = ',nDir

         Do i=1,nDir
            READ(Input,*,ERR=997) DirX(i), DirY(i), DirZ(i)
            If(DBG) write(6,'(i3,5x,3E18.10)') i,DirX(i),DirY(i),DirZ(i)
         End Do
c  some processing:
         Do i=1,nDir
            sum = 0.0_wp
            sum = DirX(i)*DirX(i)+DirY(i)*DirY(i)+DirZ(i)*DirZ(i)
            If ( sum .eq. 0.0_wp ) Then
               Write(6,'(a,i3,a)') 'error: MVEC  vector ',i,
     &                             'has the modulus = 0.0_wp.'
               Write(6,'(a     )') 'the program will stop now.'
               Call quit(_RC_INPUT_ERROR_)
            End If
            If ( ABS(sum-1.0_wp).gt.0.5d-13 ) Then
               Write(6,'(a,i3,a)') 'the vector ',i,'was re-normalized.'
               tmp=dirX(i)/sqrt(sum)
               dirX(i)=tmp
               tmp=dirY(i)/sqrt(sum)
               dirY(i)=tmp
               tmp=dirZ(i)/sqrt(sum)
               dirZ(i)=tmp
            End If
         End Do
c
         LINENR=LINENR+NDIR+1
         Go To 100
      End If

*---  process TEXP command --------------------------------------------*
      If (LINE(1:4).eq.'TEXP') Then
         compute_susceptibility=.true.
         If(TCHECK.EQV..FALSE.) Then
            TINPUT=.TRUE.

            READ(Input,*,ERR=997) NT
            If(DBG) write(6,'(A,i3)') 'nT = ',nT

            Do i=1,NT
               texp(i)=0.0_wp
               chit_exp(i)=0.0_wp

               READ(Input,*,ERR=997) texp(i), chit_exp(i)

               ! check and clean negative values:
               If(    texp(i)<0.0_wp)     texp(i)=abs(    texp(i))
               If(chit_exp(i)<0.0_wp) chit_exp(i)=abs(chit_exp(i))
            End Do
            tmin=texp(1)
            tmax=texp(nT)
         Else
            Go To 590
         End If
         LINENR=LINENR+NT+1
         Go To 100
      End If

*---  process HEXP command --------------------------------------------*
      If (LINE(1:4).eq.'HEXP') Then
         compute_magnetization=.true.
         If(checkTMAG) Then
            Write(6,'(A)') 'The data provided in TMAG will be ignored.'
         End If

         If(HCHECK.EQV..FALSE.) Then
            HINPUT=.TRUE.

            READ(Input,*) nTempMagn, (TempMagn(i),i=1,nTempMagn)
            READ(Input,*) nH
            If(DBG) Write(6,*) 'HEXP: nTempMagn =',nTempMagn
            If(DBG) Write(6,*) 'HEXP: TempMagn()=',
     &                          (TempMagn(i),i=1,nTempMagn)
            If(DBG) Write(6,*) 'HEXP: nH        =',nH

            If ( nH <0 ) nH=abs(nH)
            If ( nH==0 ) Call Quit_OnUserError()

            Do i=1,nH
               hexp(i)=0.0_wp
               Do j=1,nTempMagn
                  Mexp(i,j)=0.0_wp
               End Do
            End Do

            Do i=1,nH
               READ(Input,*,ERR=997) Hexp(i),
     &                              (Mexp(i,j),j=1,nTempMagn)
               ! check and clean negative values:
               If(hexp(i)<0.0_wp) hexp(i)=abs(hexp(i))
               Do j=1,nTempMagn
                  If(Mexp(i,j)<0.0_wp) Mexp(i,j)=abs(Mexp(i,j))
               End Do
            End Do
            hmin=hexp(1)
            hmax=hexp(nH)
         Else
            Go To 591
         End If
         LINENR=LINENR+NH+2
         Go To 100
      End If
*---  process TMAG command --------------------------------------------*
      If (LINE(1:4).eq.'TMAG') Then
         If(HINPUT.EQV..FALSE.) Then
            compute_magnetization=.true.
            checkTMAG=.true.

            READ(Input,*,ERR=997) nTempMagn,(TempMagn(i),i=1,nTempMagn)
            If(DBG) Write(6,*) 'TMAG: nTempMagn =',nTempMagn
            If(DBG) Write(6,*) 'TMAG: TempMagn()=',
     &                               (TempMagn(i),i=1,nTempMagn)

            ! check and clean for zero / negative values:
            Do i=1, nTempMagn
               If ( TempMagn(i) < 0.0_wp) Then
                  Call WarningMessage(2,'TMAG: negative temperature '//
     &                                  'requested! ')
                  WRITE(6,'(A)') 'Set to positive.'
                       TempMagn(i)=abs(TempMagn(i))
               Else If ( TempMagn(i)==0.0_wp ) Then
                  Call WarningMessage(2,'TMAG: zero temperature '//
     &                                  'requested! ')
                  WRITE(6,'(A)') 'Set to 0.0001 K.'
                       TempMagn(i)=0.0001_wp
               End If
            End Do
         Else
            Write(6,'(A)') 'TMAG data is taken from HEXP.'
         End If
         LINENR=LINENR+1
         Go To 100
      End If
*---  process NNEQ command --------------------------------------------*
c this is the most important keyword for Poly_Aniso
      If (LINE(1:4).eq.'NNEQ') Then
!        number of non-equivalent centers; type of all centers
         READ(Input,*,ERR=997)  NNEQ, ab_initio_all, ifHDF
         If(DBG) Write(6,'(A,i4,A,L2,A,L2)') 'NNEQ=', NNEQ,
     &                          ' ab_initio_all=',ab_initio_all,
     &                          ' ifHDF=', ifHDF
!        number of equivalent centers of type "i"
         READ(Input,*,ERR=997) (NEQ(i)  ,i=1,Nneq)
         If(DBG) Write(6,'(A,100I4)') 'NEQ(I)=',(NEQ(i),i=1,nneq)
!        number of RASSI wf for exchange
         READ(Input,*,ERR=997) (Nexch(i),i=1,Nneq)
         If(DBG) Write(6,'(A,100I4)') 'NExch(I)=',(NExch(i),i=1,nneq)

         Do i=1,nneq
            If(Nexch(i).lt.0) Then
               Write(6,'(A,i1,a)') 'The number of functions taken '//
     &                             'in the exchange interaction '//
     &                             'from center of type ',i,
     &                             ' is negative!'
               Write(6,'(A     )') 'The program has to stop, '//
     &                             'since the input is not reasonable.'
               Call quit(_RC_INPUT_ERROR_)
            Else If(Nexch(i).eq.0) Then
               Write(6,'(A,i1,a)') 'The number of functions taken '//
     &                             'in the exchange interaction '//
     &                             'from center of type ',i,
     &                             ' is 0 (zero).'
               Write(6,'(A)') 'The program has to stop, since '//
     &                        'the input is not reasonable.'
               Call quit(_RC_INPUT_ERROR_)
            End If
         End Do
         check_nneq_presence=.true.
         Do i=1,nneq
            If (neq(i).gt.1) Then
               nosym = .false.
            End If
         End Do
c        Write(6,'(A,i5)') 'exch = ', exch
         If(exch.eq.1) Then
            Write(6,'(3/)')
            Write(6,'(100A)') ('#',i=1,100)
            Write(6,'(3/)')
            Write(6,'(A)') 'The size of the exchange matrix is 1. '//
     &                     'Is this really what you intended '//
     &                     'to compute?'
            Write(6,'(A)') 'The program will continue...'
            Write(6,'(3/)')
            Write(6,'(100A)') ('#',i=1,100)
            Write(6,'(3/)')
         End If

c         Do i=1,nCenter
c            ind_exch(i)=i
c         End Do

!        If the EXCH is above the limit => exit with an error
         If(exch > 15000) Then
            Write(6,'(A)') 'The number of exchange states is very large'
            Write(6,'(A)') 'EXCH=',exch
            Write(6,'(A)') 'The calculation will continue, but might '//
     &                     'take a LOT of time'
            Write(6,'(A)') 'We recomend to switch OFF the '//
     &                     'computation of powder magnetization'
         End If

         If(ab_initio_all .eqv. .false.) Then
            readgfact=.true.

!           type of the center:   A -- the information is read from aniso_ion.input
!                                 B -- the center is isotropic with g factor read from the input
!                                 C -- the center is anisotropic with
            READ(Input,*,ERR=997) (itype(i),i=1,Nneq)
            If(DBG) Write(6,'(A,100A3)') 'itype: ',(itype(i),i=1,nneq)
            If(DBG) Call xFlush(6)
            icount_B_sites=0
            Do i=1,nneq
               If ((itype(i).eq.'B').OR.(itype(i).eq.'C')) Then
                  icount_B_sites=icount_B_sites+1
                  READ(Input,*,ERR=997) (gtens_input(l,i),l=1,3),
     &                                   D_fact(i), EoverD_fact(i)
                  If(DBG) Write(6,'(A,i4,A,3E20.10, 2(A,E20.10) )')
     &                   'gtens_input(',i,')=',(gtens_input(l,i),l=1,3),
     &                   ' D = ', D_fact(i),' E/D =', EoverD_fact(i)
                  If( (itype(i).eq.'C').AND.(
     &               (gtens_input(1,i).ne.gtens_input(2,i)).OR.
     &               (gtens_input(1,i).ne.gtens_input(3,i)).OR.
     &               (gtens_input(2,i).ne.gtens_input(3,i))) ) Then
                      Do ic=1,3
                         READ(Input,*,ERR=997) (riso(i,jc,ic),jc=1,3)
                      End Do

                  Else
                      riso(i,1:3,1:3)=0.0_wp
                      Do ic=1,3
                          riso(i,ic,ic)=1.0_wp
                      End Do
                  End if
               End If

               If(abs(D_fact(i)) > 0.0_wp) Then
                   If( abs(EoverD_fact(i)/D_fact(i)) >
     &                                 0.3333333333333333333_wp ) Then
                   Write(string,'(A,i3,A)') 'NNEQ: |E/D| for center',i,
     &              ' > 1/3'
                   Call WarningMessage(2,trim(string))
                   WRITE(6,'(A,i3,A)') '|E/D| for center ',i,
     &                                 ' is set to 1/3'
                   End If
               End If
            End Do
         Else
            Do i=1,nneq
               itype(i)='A'
            End Do
         End If !ab_initio_all
         LINENR=LINENR+3+icount_B_sites
         If(DBG) Call xFlush(6)
         Go To 100
      End If
*---  process LIN9 command --------------------------------------------*
      If (LINE(1:4).eq.'LIN9') Then
         AnisoLines9=.true.

         READ(Input,*,ERR=997) npair
         If(DBG) Write(6,'(A,i6)')'LIN9:  nPair=',nPair

         Do i=1,npair
            Do j=1,3
               Do k=1,3
                  JAex9(i,j,k)=0.0_wp
               End Do
            End Do
            i_pair(i,1)=0
            i_pair(i,2)=0

            ! the convention for 9 exchange interactions is
            ! Jxx, Jxy, Jxz, Jyx, Jyy, Jyz, Jzx, Jzy, Jzz
            READ(Input,*,ERR=997) i_pair(i,1),i_pair(i,2),
     &                              (JAex9(i,1,j),j=1,3),
     &                              (JAex9(i,2,j),j=1,3),
     &                              (JAex9(i,3,j),j=1,3)
           If(DBG) Write(6,'(A,2I3,9F10.6)') 'LIN9: ',
     &      i_pair(i,1),i_pair(i,2),
     &                                       (JAex9(i,1,j),j=1,3),
     &                                       (JAex9(i,2,j),j=1,3),
     &                                       (JAex9(i,3,j),j=1,3)
         End Do
         LINENR=LINENR+npair+1
         Go To 100
      End If



*---  process LIN3 command --------------------------------------------*
      If (LINE(1:4).eq.'ALIN' .OR. LINE(1:4).eq.'LIN3') Then
         AnisoLines3=.true.

         READ(Input,*,ERR=997) npair
         If(DBG) Write(6,'(A,i6)')'nPair=',nPair

         Do i=1,npair
            Do j=1,3
               JAex(i,j)=0.0_wp
            End Do
            i_pair(i,1)=0
            i_pair(i,2)=0

            ! the convention for 3 exchange interactions is
            ! Jxx, Jyy, Jzz
            READ(Input,*,ERR=997) i_pair(i,1),i_pair(i,2),
     &                            (JAex(i,j),j=1,3)
            If(DBG) Write(6,'(A,i6)') i_pair(i,1),i_pair(i,2),
     &                            (JAex(i,j),j=1,3)
         End Do
         LINENR=LINENR+npair+1
         Go To 100
      End If


*---  process JITO command --------------------------------------------*
      If (LINE(1:4).eq.'ITOJ') Then
         JITO_exchange=.true.

         READ(Input,*,ERR=997) npair
         If(DBG) Write(6,'(A,i6)') 'nPair=',nPair
         JITOexR=0.0_wp
         JITOexI=0.0_wp

         Do i=1,npair
            i_pair(i,1)=0
            i_pair(i,2)=0
            imaxrank(i,1)=0
            imaxrank(i,2)=0

            ! the convention for exchange interactions is
            !
            READ(Input,*,ERR=997) i_pair(i,1),i_pair(i,2),
     &                          imaxrank(i,1),imaxrank(i,2)
              Do irank1=1,imaxrank(i,1),2
               Do iproj1=-irank1,irank1
                Do irank2=1,imaxrank(i,2),2
                 Do iproj2=-irank2,irank2
                  READ(Input,*,ERR=997) jrank1, jproj1, jrank2, jproj2,
     &               JITOexR(i,jrank1,jproj1,jrank2,jproj2),
     &               JITOexI(i,jrank1,jproj1,jrank2,jproj2)
                 End Do
                End Do
               End Do
              End Do

              If(DBG) Then
               Write(6,'(A,I3)') 'ITO Exchange parameters for pair:',i
               Do jrank1=1,imaxrank(i,1),2
                Do jproj1=-jrank1,jrank1
                 Do jrank2=1,imaxrank(i,2),2
                  Do jproj2=-jrank2,jrank2
                   WRITE(6,'(4I3,2x,2ES21.14)')
     &                          jrank1,jproj1,jrank2,jproj2,
     &                JITOexR(i,jrank1,jproj1,jrank2,jproj2),
     &                JITOexI(i,jrank1,jproj1,jrank2,jproj2)
                  End Do
                 End Do
                End Do
               End Do
              End If
         End Do
         LINENR=LINENR+npair+1
         Go To 100
      End If


*---  process PAIR = LIN1 command --------------------------------------------*
      If (LINE(1:4).eq.'PAIR' .OR. LINE(1:4).eq.'LIN1') Then
        AnisoLines1=.true.

         READ(Input,*,ERR=997) npair
         If(DBG) Write(6,'(A,i6)')'nPair=',nPair

         Do i=1,npair
            Jex(i)=0.0_wp
            i_pair(i,1)=0
            i_pair(i,2)=0

            READ(Input,*,ERR=997) i_pair(i,1), i_pair(i,2), Jex(i)
            If(DBG) Write(6,'(i4,2x,2I4,2x,E18.10)')
     &                         i, i_pair(i,1), i_pair(i,2), Jex(i)

         End Do
         LINENR=LINENR+npair+1
         Go To 100
      End If



*---  process DMEX command --------------------------------------------*
      If (LINE(1:4).eq.'DMEX') Then
         DM_exchange=.true.
         If(DBG) write(6,'(A,L2)') 'DMEX::  DM_exchange=',DM_exchange

         READ(Input,*,ERR=997) npair
         If(DBG) Write(6,'(A,i6)')'nPair=',nPair

         Do i=1,npair
            Do j=1,3
               JDMex(i,j)=0.0_wp
            End Do
            i_pair(i,1)=0
            i_pair(i,2)=0

            ! the convention for 3 exchange interactions is
            ! JDMex(x, y, z)
            READ(Input,*,ERR=997) i_pair(i,1),i_pair(i,2),
     &                            (JDMex(i,j),j=1,3)
         End Do
         LINENR=LINENR+npair+1
         Go To 100
         LINENR=LINENR+1
         Go To 100
      End If



*---  process ZEEM command --------------------------------------------*
      If (LINE(1:4).eq.'ZEEM') Then
         zeeman_energy=.true.
         compute_magnetization=.true.
         LUZEE=0
         Do i=1,3*nDirZee
            check_dir_weight(i)=0.0_wp
         End Do

         READ(Input,*,ERR=997) nDirZee

        Do i=1,nDirZee
!         open the zeeman_energy_xxx.txt file where Zeeman eigenstates will
!         be further written in mangetization() subroutine
          Write(namefile_energy,'(5A)') 'zeeman_energy_',
     &                     CHAR(48+mod( int((i)/100),10)),
     &                     CHAR(48+mod( int((i)/10 ),10)),
     &                     CHAR(48+mod( int( i     ),10)),'.txt'
          If(DBG) Write(6,'(2A)') 'namefile_energy: ', namefile_energy
          LUZee(i)=IsFreeUnit(30+i)
          Call molcas_open(LUZee(i),namefile_energy)

          READ(Input,*,ERR=997) (dir_weight(i,l),l=1,3)

          check_dir_weight(i)=0.0_wp
          check_dir_weight(i)=sqrt( dir_weight(i,1)**2 +
     &                              dir_weight(i,2)**2 +
     &                              dir_weight(i,3)**2 )

          If( (check_dir_weight(i).lt.0.995_wp).OR.
     &        (check_dir_weight(i).gt.1.005_wp) ) Then
            Write(6,'(A)') 'The directions for the magnetic field '//
     &                     'for the computation of the Zeeman '//
     &                     'splitting are wrong.'
            Write(6,'(A)') '( px^2 + py^2 + pz^2 ) must give 1.!'
            Write(6,'(A,I3,2x,A,F9.5)') 'In the present case for '//
     &                                  'direction Nr.', i,
     &                                  ' the dir_weight = px^2 + '//
     &                                  'py^2 + pz^2 = ',
     &                                   check_dir_weight(i)**2
            LINENR=LINENR+2+i
            Go To 997
          End If

        End Do
         LINENR=LINENR+nDirZee+1
         Go To 100
      End If



*---  process MAGN command --------------------------------------------*
c      If (LINE(1:4).eq.'MAGN') Then
c         compute_magnetization=.true.
c         Go To 100
c      End If



*---  process SYMM command --------------------------------------------*
      If (LINE(1:4).eq.'SYMM') Then
         nosym=.false.
         check_symm_presence=.true.
         R_lg=0.0_wp
         R_rot=0.0_wp
         If(DBG) Write(6,'(A,i6)')'SYMM - at init'
         ll=0
         Do i=1,nneq
         If(DBG) Write(6,'(A,i6)')'SYMM:  i=',i

            READ(Input,*,ERR=997) inneq
            If(DBG) Write(6,'(A,i6)')'inneq=',inneq

            Do j=1,Neq(i)
            If(DBG) Write(6,'(A,i6)')'SYMM:  j=',j
               Do m=1,3
                  ll=ll+1
                  READ(Input,*,ERR=997) (R_lg(i,j,m,n),n=1,3)
                  If(DBG) Write(6,'(3E20.12)') (R_lg(i,j,m,n),n=1,3)
               End Do
            End Do

            Do j=1,neq(i)
               detR=0.0_wp
               tmpR=0.0_wp
               Do m=1,3
                  Do n=1,3
                     tmpR(m,n)=R_lg(i,j,m,n)
                  End Do
               End Do

               detR=FindDetR( tmpR(1:3,1:3), 3)
               If(DBG) Write(6,'(A,3E20.12)')'SYMM:  detR=',detR

               If ((abs(detR).lt.0.999).OR.(abs(detR).gt.1.001)) Then
                  Write(6,'(A)') 'The rotation matrices must be '//
     &                           'UNITARY.'
                  Write(6,'(A)') 'and of RIGHT hand system'
                  Write(6,'(A,F11.6)') 'DET = ', detR
                  LINENR=LINENR+ll+i+1
                  Go To 997
               End If
               If(detR.lt.0.0_wp) Then
                  Do m=1,3
                     Do n=1,3
                        R_rot(i,j,m,n)=-R_lg(i,j,m,n)
                     End Do !n
                  End Do !m
               Else If(detR.gt.0.0_wp) Then
                  Do m=1,3
                     Do n=1,3
                        R_rot(i,j,m,n)= R_lg(i,j,m,n)
                     End Do !n
                  End Do !m
               End If
            End Do !neq(i)
         End Do !nneq
         LINENR=LINENR+nneq+ll
         Go To 100
      End If



*---  process EXCH command --------------------------------------------*
      If (LINE(1:4).eq.'EXCH') Then
        decompose_exchange=.true.
        Go To 100
      End If

*---  process EXCH command --------------------------------------------*
c      If (LINE(1:4).eq.'END') Then
c        Go To 100
c      End If



*---  process UBAR command --------------------------------------------*
      If (LINE(1:4).eq.'UBAR') Then
        compute_barrier=.true.
c        READ(Input,*,ERR=997) icase
cc       icase =1  --> magnetic field is applied along the main magnetic
cc                     axis of each Doublet (multiplet)
c        If     ( icase.eq.1 ) Then
c          continue
c        Else If ( icase.eq.2 ) Then
cc       icase =2  --> magnetic field is applied along the main magnetic
cc                     axis of the specIfied Doublet (number) number (NDim)
c          READ(Input,*,ERR=997) NmagMult
c        Else If ( icase.eq.3 ) Then
cc       icase =3  --> a new coordination system is defined by the user,
cc                     and the magnetic field is applied along gZ (third axis)
c          Do i=1,3
c          READ(Input,*,ERR=997) (uBar_Rot(i,j),j=1,3)
c          End Do
c          LINENR=LINENR+3
c        Else
c          Write(6,'(A)') 'Is the UBAR keyword used correctly?'
c          Write(6,'(A)') 'The ICASE parameter is not understood.'
c        End If
        LINENR=LINENR+1
        Go To 100
      End If



C-------------------------------------------
      If (LINE(1:4).eq.'ABCC') Then
      Do_structure_abc = .TRUE.
      READ(Input,*,ERR=997) (cryst(i),i=1,6)
      coord(1)=0.0_wp
      coord(2)=0.0_wp
      coord(3)=0.0_wp
c      READ(Input,*,ERR=997) (coord(i),i=1,3)
        LINENR=LINENR+2
        Go To 100
      End If
c array "cryst" collects the crystallographic data:
c  cryst(1)= a
c  cryst(2)= b
c  cryst(3)= c
c  cryst(4)= alpha
c  cryst(5)= beta
c  cryst(6)= gamma
c  coord(i) =the coordinates of the magnetic center in "abc" axes
c  logical variable 'Do_structure_abc' will make the program compute
c  the magnetic and anisotropy axes in the "abc" coordinate system
C-------------------------------------------




*---  process LONG command --------------------------------------------*
      If (LINE(1:4).eq.'LONG') Then
         KE=.true.

         READ(Input,*,ERR=997) lanth, tpar, upar, KEOPT

         If( (lanth.eq.'GD').OR.(lanth.eq.'gd').OR.
     &       (lanth.eq.'gD').OR.(lanth.eq.'Gd') ) Then
            lant=1
            multLn=8
         Else If( (lanth.eq.'TB').OR.(lanth.eq.'tb').OR.
     &       (lanth.eq.'tB').OR.(lanth.eq.'Tb') ) Then
            lant=2
            multLn=13
         Else If( (lanth.eq.'DY').OR.(lanth.eq.'dy').OR.
     &            (lanth.eq.'dY').OR.(lanth.eq.'Dy') ) Then
            lant=3
            multLn=16
         Else If( (lanth.eq.'HO').OR.(lanth.eq.'ho').OR.
     &            (lanth.eq.'hO').OR.(lanth.eq.'Ho') ) Then
            lant=4
            multLn=17
         Else If( (lanth.eq.'ER').OR.(lanth.eq.'er').OR.
     &            (lanth.eq.'eR').OR.(lanth.eq.'Er') ) Then
            lant=5
            multLn=16
         Else If( (lanth.eq.'TM').OR.(lanth.eq.'tm').OR.
     &            (lanth.eq.'tM').OR.(lanth.eq.'Tm') ) Then
            lant=6
            multLn=13
         Else If( (lanth.eq.'YB').OR.(lanth.eq.'yb').OR.
     &            (lanth.eq.'yB').OR.(lanth.eq.'Yb') ) Then
            lant=7
            multLn=8
         Else
            Write(6,'( A)') 'Error in getting the type of '//
     &                      'the lanthanide!'
            Write(6,'(2A)') 'The program has this info: '//
     &                      'lanth =',lanth
            Write(6,'(26x,A,i2)') 'multLn =',multLn
         End If
         LINENR=LINENR+2
         Go To 100
      End If


! end of reading input keywords
210   Continue
c      CLOSE(Input)
c---------------------------------------------------------------------------




C=====  Perform some PROCESSING of the data =======================================

      If(nosym .eqv. .false.) Then
         If(check_symm_presence .eqv. .false.) Then
         Write(6,'(A)') 'The SYMM keyword is mandatory if the system '
         Write(6,'(A)') 'contains more than one center of the same '//
     &                  'type!'
         Call quit(_RC_INPUT_ERROR_)
         End If !check_symm_presence
      End If !nosym





c preparing the info for computation of molar magnetization
c calculate the total number of directions for the average procedure




c--------  definintion g and D tensors ------------------------------
      If(compute_g_tensors) Then
         nst=0
         Do i=1, nMult
            nst=nst+ndim(i)
            If( nst > exch ) Then
               Write(6,'(A)') 'You have requested the computation of '//
     &                        'properties of more states'
               Write(6,'(A)') 'than the total number of exchange '//
     &                        'states.'
               Write(6,'(A)') 'The program doesn"t know how to compute'
               Write(6,'(A)') 'properties of inexistent states'
               Write(6,'(A)') 'New settings:'
               Write(6,'(A,i6)') 'NMULT = ',i-1

               nmult=i-1
               Go To 14
            End If
         End Do
14       continue
      End If
      If(DBG) Write(6,*) 'READIN:  after proc g and D'
      If(DBG) Call xFlush(6)







c--------  definintion of exchange ------------------------------
      If (npair > 0 ) Then
         ASUM=0
         Do lp=1,nPair
            ASUM = ASUM + i_pair(lp,1) + i_pair(lp,2)
         End Do
         If( Dipol .AND. (ASUM.eq.0) ) Then
            lp=0
            Do i=1,nCenter-1
               Do j=i+1,nCenter
                  If(i>=j) goto 17
                  lp=lp+1
                  i_pair(lp,1)=i
                  i_pair(lp,2)=j
                  If(DBG) Write(6,'(A,i3,A,2I3)') 'lp=',lp,
     &                            ' i_pair(lp,1:2)=',
     &                              i_pair(lp,1),i_pair(lp,2)
  17              Continue
               End Do
            End Do
         End If

         Duplicate_check(1:nPair)=0
         Do i=1,npair
            Duplicate_check(i)=1000*i_pair(i,1)+i_pair(i,2)
            If(DBG) Write(6,*) 'Duplicate_check: ',Duplicate_check(i)

            If ( i_pair(i,1) == i_pair(i,2) ) Then
               Write(6,'(A,i2,a)') 'The center ',i_pair(i,1),
     &                             ' interacts with itself.'
               Write(6,'(A)') 'This is not possible. '//
     &                        'The program has to stop.'
               Call quit(_RC_INPUT_ERROR_)

            Else If( i_pair(i,1) > i_pair(i,2) ) Then
               Write(6,'(A)') 'The convention of this program '//
     &                        'enforces the label of the first '//
     &                        'magnetic center of a given '
               Write(6,'(A)') 'interaction to be smaller than the '//
     &                        'label of the second magnetic center.'
               Write(6,'(A)') 'In order to avoid confusions, please '//
     &                        'respect this convention.'
               Write(6,'(A)') 'Avoid duplicate interactions!'
               Write(6,'(A)') 'The program will stop now.'
               Call quit(_RC_INPUT_ERROR_)
            End If
         End Do
         If(DBG) Call xFlush(6)

         ! check on the duplicate
         Do i=1,npair
            Do j=i+1,npair
               If (j==i) Go To 197
               If (Duplicate_check(i) == Duplicate_check(j) ) Then
                  Write(6,'(A)') 'Some interactions are declared '//
     &                           'twice in the input. Please declare '//
     &                           'all interactions only once!'
                  Write(6,'(A)') 'The program has to stop.'
                  Call quit(_RC_INPUT_ERROR_)
               End If
  197          Continue
            End Do
         End Do


         ! check on the indices of the exchange couplings:
         Do i=1, nPair
            If ( (i_pair(i,1) > nCenter) .OR.
     &           (i_pair(i,2) > nCenter) ) Then
               Write(6,'(A)') 'The numbering of the magnetic '//
     &                        'centers within NPAIR keyword is wrong.'
               Write(6,'(A,i2,a)')
     &                        'For the interaction Nr. = ',i,' you '//
     &                        'numerate individual centers with '//
     &                        'numbers larger than the total number '//
     &                        'of centers in this molecule.'
               Write(6,'(A)') 'NPAIR keyword is wrong.'
               Write(6,'(A,I4)') 'i_pair(i,1) =',i_pair(i,1)
               Write(6,'(A,I4)') 'i_pair(i,2) =',i_pair(i,2)
               Write(6,'(A)') 'The program has to stop.'
               Call quit(_RC_INPUT_ERROR_)
            End If
         End Do


!        check on the size of MxRank1 and MxRank2 wrt nexch(1) and nexch(2)
         If(JITO_exchange) Then
           l=0
           Do i=1,nneq
             Do j=1,neq(i)
               l=l+1
               nind(l,1)=i
               nind(l,2)=j
             End Do
           End Do

           Do lp=1,npair
             lb1=i_pair(lp,1)
             lb2=i_pair(lp,2)
             i1=nind(lb1,1) ! indices of non-equivalent sites
             i2=nind(lb2,1) ! indices of non-equivalent sites
             If(nExch(i1) < (imaxrank(lp,1)+1)) Then
               Write(6,'(100A)') ('#',i=1,100)
               Write(6,'(A)') 'interacting pair = ', lp
               Write(6,'(A)') 'type of site 1 = ', i1
               Write(6,'(A,i2,A,i2)') 'nExch(',i1,') = ',nExch(i1)
               Write(6,'(A,i2,A,i2)') 'Rank2(',lp,',1) = ',
     &                                              imaxrank(lp,1)
               Write(6,'(A)')'nExch < Rank+1 !!!'
               Write(6,'(A)') 'Rank of ITO operators for site 1 is '//
     &                 'larger than the number of defined exchange '//
     &                 'states for this site'
               Write(6,'(A)') 'The program will use only parameters '//
     &                 'which bring non-zero contribution to exchange.'
               Write(6,'(100A)') ('#',i=1,100)
             End If
             If(nExch(i2) < (imaxrank(lp,2)+1)) Then
               Write(6,'(100A)') ('#',i=1,100)
               Write(6,'(A)') 'interacting pair = ', lp
               Write(6,'(A)') 'type of site 2 = ', i2
               Write(6,'(A,i2,A,i2)') 'nExch(',i2,') = ',nExch(i2)
               Write(6,'(A,i2,A,i2)') 'Rank2(',lp,',2) = ',
     &                                              imaxrank(lp,2)
               Write(6,'(A)')'nExch < Rank+1 !!!'
               Write(6,'(A)') 'Rank of ITO operators for site 2 is '//
     &                 'larger than the number of defined exchange '//
     &                 'states for this site'
               Write(6,'(A)') 'The program will use only parameters '//
     &                 'which bring non-zero contribution to exchange.'
               Write(6,'(100A)') ('#',i=1,100)
             End If
           End Do
         End If ! JITO_exchange
       End If ! nPair


      If(DBG) Write(6,*) 'READIN:  before 200 '
      If(DBG) Call xFlush(6)
c--------  definintion of exchange ------------------------------









      Go To 200
C--------------------------------------------
      Write(6,*)' The following input line was not understood:'
      Write(6,'(A)') LINE
      Go To 999

997   continue
      Write(6,*)' READIN: Error reading "poly_aniso.input" '
      Write(6,*)' near line nr.',LINENR+1
      Go To 999
998   continue
      Write(6,*)' READIN: Unexpected End of input file.'
999   continue
      Call quit(_RC_INPUT_ERROR_)
590   continue
      Write(6,*) 'READIN: THE TINT command is incompatible with TEXP'
      Call quit(_RC_INPUT_ERROR_)
591   continue
      Write(6,*) 'READIN: THE HINT command is incompatible with HEXP'
      Call quit(_RC_INPUT_ERROR_)
595   continue
      Write(6,*) 'READIN: THE NCUT, ENCU, and ERAT are mutually'//
     & ' exclusive. You cannot use more than one keyword at the'//
     & ' same time.'
      Call quit(_RC_INPUT_ERROR_)
c ===============   NORMAL EndING  ===============================
200   continue

      If(IPRINT.gt.2) Then
      Write(6,'(5X,A)') 'NO ERROR WAS LOCATED WHILE READING INPUT'
      End If

      Return
      End !Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine RigRot(CoorIn,rM,nAtm)
!***********************************************************************
!                                                                      *
! Object: to compute the rotational constants and the rotational       *
!         spectrum within the rigid-rotor model.                       *
!                                                                      *
!    Reference: P.W. Atkins, in "Molecular Quantum Mechanics",         *
!               Oxford University Press, Oxford/New York,              *
!               ch. 11.2, pp. 289.                                     *
!               Michael Tinkham, in "Group Theory and Quantum          *
!               Mechanics", McGraw-Hill Book Company, New York,        *
!               ch. 7-14, pp. 250.                                     *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Sizes_of_Seward, only: S
use Gateway_Info, only: CoM, PAX, Prin, rMI, TMass
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four, Eight, Half, auTocm, auToHz, uToau
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtm
real(kind=wp), intent(in) :: CoorIn(3,nAtm), rM(nAtm)
#include "print.fh"
integer(kind=iwp) :: i, iAtom, iCar, iEn, ii, iPrint, iRout, j, jCar, k, k1, k2, kappa, kk, kk2, mDim, nEn, nHess, nTri
real(kind=wp) :: A, B, C, keep, rKappa, XI(3)
logical(kind=iwp) :: Linear, RR_Show
character(len=80) :: Label
real(kind=wp), allocatable :: Coor(:,:), En(:), Hess(:), Vec(:)
integer(kind=iwp), external :: iprintlevel

iRout = 117
iPrint = nPrint(iRout)
RR_Show = iPrint >= 6
if (iprintlevel(-1) < 3) RR_Show = .false.

if (RR_Show) then
  write(u6,*)
  call CollapseOutput(1,'   Rigid rotor info:')
  write(u6,'(3X,A)') '   -----------------'
  write(u6,*)
end if

PAx(:,:) = reshape([One,Zero,Zero,Zero,One,Zero,Zero,Zero,One],[3,3])
if (TMass == Zero) then
  call FinishUp()
  return
end if
Linear = .false.
if (iPrint >= 99) then
  call RecPrt(' In RigRot: CoorIn',' ',CoorIn,3,nAtm)
  call RecPrt(' In RigRot: Mass',' ',rM,1,nAtm)
end if
if (RR_Show) then
  write(u6,*)
  write(u6,'(19X,A,F10.5)') ' Total mass (a) :',TMass/uToau
  write(u6,*)
  write(u6,'(19X,A)') ' Center of mass '
  write(u6,'(19X,3A11)') '       X   ','       Y          Z   '
  write(u6,'(19X,3F11.5)') (CoM(i),i=1,3)
  write(u6,*)
end if

! Translate coordinate system to center of mass.

call mma_allocate(Coor,3,nAtm)
do iCar=1,3
  do iAtom=1,nAtm
    Coor(iCar,iAtom) = CoorIn(iCar,iAtom)-CoM(iCar)
  end do
end do

if (RR_Show) then
  write(u6,'(19X,A)') ' Reference system based on center of mass'
  write(u6,'(19X,A)') ' Coordinates and Masses of Atoms, in au and A'
  write(u6,'(19X,A)') '       X          Y          Z        Mass'
  write(u6,'(19X,4F11.5)') ((Coor(j,i),j=1,3),rM(i)/utoau,i=1,nAtm)
  write(u6,*)
end if
if (nAtm == 1) then
  call mma_deallocate(Coor)
  call FinishUp()
  return
end if

! Construct the moment of inertia tensor

ii = 0
do iCar=1,3
  do jCar=1,iCar-1
    ii = ii+1
    rMI(ii) = Zero
    do iAtom=1,nAtm
      rMI(ii) = rMI(ii)-Coor(iCar,iAtom)*Coor(jCar,iAtom)*rM(iAtom)
    end do
  end do
  ii = ii+1
  rMI(ii) = Zero
  do iAtom=1,nAtm
    rMI(ii) = rMI(ii)+rM(iAtom)*(Coor(1,iAtom)**2+Coor(2,iAtom)**2+Coor(3,iAtom)**2-Coor(iCar,iAtom)**2)
  end do
end do
call mma_deallocate(Coor)
if (RR_Show) then
  write(u6,'(19X,A)') ' The Moment of Inertia Tensor / au'
  write(u6,'(19X,14X,3A)') '    X     ','     Y    ','    Z     '
  write(u6,'(19X,A,12X,3(E11.4))') ' X',rMI(1)
  write(u6,'(19X,A,12X,3(E11.4))') ' Y',rMI(2),rMI(3)
  write(u6,'(19X,A,12X,3(E11.4))') ' Z',rMI(4),rMI(5),rMI(6)
  write(u6,*)
end if

! Diagonalize and find principle axis

call mma_Allocate(Hess,6)
Hess(:) = rMI
call Jacob(Hess,Pax,3,3)
Prin(1) = Hess(1)
Prin(2) = Hess(3)
Prin(3) = Hess(6)

! Sort the prinipal axis such that z' is the one with the lowest eigenvalue.

do i=1,2
  do j=i+1,3
    if (Prin(i) < Prin(j)) then
      keep = Prin(i)
      Prin(i) = Prin(j)
      Prin(j) = keep
      call DSwap_(3,PAx(:,i),1,PAx(:,j),1)
    end if
  end do
end do
call mma_deallocate(Hess)
if (RR_Show) then
  write(u6,'(19X,A)') ' The Principal Axes and Moments of Inertia (au)'
  write(u6,'(19X,A,3(E11.4))') ' Eigenvalues :',(Prin(i),i=1,3)
  write(u6,'(19X,14X,3A)') '    X''    ','     Y''   ','    Z''    '
  write(u6,'(19X,A)') ' Eigenvectors:'
  write(u6,'(19X,A,3(E11.4))') ' X            ',Pax(1,:)
  write(u6,'(19X,A,3(E11.4))') ' Y            ',Pax(2,:)
  write(u6,'(19X,A,3(E11.4))') ' Z            ',Pax(3,:)
  write(u6,*)
  !call Put_dArray('PAX',Pax,9)
  write(u6,'(19X,A)') ' The Rotational Constants'
  write(u6,'(19X,A)') '         (cm-1)            (GHz)'
  if (Prin(1) >= 1.0e-3_wp) write(u6,'(19X,F16.3,1X,F16.3)') auTocm*Half/Prin(1),1.0e-9_wp*auToHz*Half/Prin(1)
  if (Prin(2) >= 1.0e-3_wp) write(u6,'(19X,F16.3,1X,F16.3)') auTocm*Half/Prin(2),1.0e-9_wp*auToHz*Half/Prin(2)
  if (Prin(3) >= 1.0e-3_wp) write(u6,'(19X,F16.3,1X,F16.3)') auTocm*Half/Prin(3),1.0e-9_wp*auToHz*Half/Prin(3)
end if
if ((Prin(1) == Zero) .and. (Prin(2) == Zero) .and. (Prin(3) == Zero)) then
  call FinishUp()
  return
end if
if (RR_Show) then
  write(u6,*)
  write(u6,*)
  write(u6,'(19X,A)') ' *******************************************'
  write(u6,'(19X,A)') ' *                                         *'
  write(u6,'(19X,A)') ' * R I G I D - R O T O R   A N A L Y S I S *'
  write(u6,'(19X,A)') ' *                                         *'
  write(u6,'(19X,A)') ' *******************************************'
  write(u6,*)
  write(u6,'(19X,A,I3)') ' j(Max):',S%jMax
  write(u6,*)
end if

! Order the three principal moments of inertia, Ia<=Ib<=Ic

XI(:) = Prin
call Order_Axis(XI,3)

! Asymmetry parameter, Tinkham formula 7-96

B = Half/XI(2)
C = Half/XI(3)
if (XI(1) <= 1.0e-3_wp) then
  Linear = .true.
  rKappa = -One
else
  A = Half/XI(1)
  if (abs(A-C) <= 1.0e-10_wp) then
    rKappa = Zero
  else
    rKappa = (Two*B-A-C)/(A-C)
  end if
end if

! Change order if molecule is oblate, Ia=Ib<=Ic

if ((abs(XI(1)-XI(2)) < 1.0e-6_wp) .and. (abs(XI(1)-XI(3)) > 1.0e-6_wp)) then
  keep = XI(1)
  XI(1) = XI(3)
  XI(3) = keep
end if

! Construct Hessian Matrix
! Iz=XI(1), Ix=XI(2), and Iy=XI(3)

! Set up constants, see Tinkham fomula 7-89a and 7-89b.

if (abs(XI(1)) > 1.0e-3_wp) then
  A = Half/XI(1)
else
  A = Zero
end if
B = (One/XI(2)+One/XI(3))/Four
C = (One/XI(2)-One/XI(3))/Eight
do i=1,80
  Label(i:i) = ' '
end do
! Iz=0 linear rotor
if (abs(A) < 1.0e-3_wp) then
  Label(1:13) = ' Linear Rotor'
! Ix=/=Iy asymmetric top
else if (C > 1.0e-3_wp) then
  Label(1:15) = ' Asymmetric Top'
! Iz=Ix=Iy
else if (abs(A-B) < 1.0e-10_wp) then
  Label(1:14) = ' Spherical Top'
else if (A > B) then
  Label(1:25) = ' Symmetric Top, Prolate'
else
  Label(1:24) = ' Symmetric Top, Oblate'
end if
if (RR_Show) then
  write(u6,'(19X,A,A)') ' Rotor Type:',trim(Label)
  write(u6,'(19X,A,F7.3)') ' Asymmetry parameter:',rKappa
  write(u6,'(19X,A)') ' Prolate = -1'
  write(u6,'(19X,A)') ' Oblate  =  1'
  write(u6,*)
end if

nEn = (S%jMax+1)*(S%jMax+2)*(S%jMax+3)/6
call mma_Allocate(En,nEn)
iEn = 1
nHess = (2*S%jMax+1)*(2*S%jMax+2)/2
call mma_allocate(Hess,nHess)
call mma_Allocate(Vec,(2*S%jMax+1)**2)
do j=0,S%jMax
  mDim = 2*j+1
  nTri = mDim*(mDim+1)/2
  Hess(1:nTri) = Zero
  Vec(1:mDim**2) = Zero
  call dcopy_(mDim,[One],0,Vec,mDim+1)
  if (iPrint >= 99) call RecPrt(' Vec',' ',Vec,mDim,mDim)
  k1 = 1
  do k=-j,j
    kk = k1*(k1+1)/2

    ! Formula 7-89a, (j,k|H|j,k), diagonal term

    Hess(kk) = B*real(j*(j+1),kind=wp)+(A-B)*real(k**2,kind=wp)
    if (Linear) Hess(kk) = B*real(j*(j+1),kind=wp)
    if ((k+2 <= j) .and. (.not. Linear)) then
      k2 = k1+2
      kk2 = k2*(k2-1)/2+k1

      ! Formula 7-89b, (j,k+2|H|j,k), the only off diagonal term.

      Hess(kk2) = C*sqrt(real((j*(j+1)-k*(k+1))*(j*(j+1)-(k+1)*(k+2)),kind=wp))
    end if
    k1 = k1+1
  end do
  if (iPrint >= 99) call TriPrt(' Hessian',' ',Hess,mDim)
  call Jacob(Hess,Vec,mDim,mDim)
  if (iPrint >= 99) call TriPrt(' Hessian',' ',Hess,mDim)
  do i=1,mDim
    En(iEn+I-1) = Hess(i*(i+1)/2)*auTocm
  end do
  call Order_Axis(En(iEn),mDim)
  iEn = iEn+mDim
end do
call mma_deallocate(Vec)
call mma_deallocate(Hess)

! Output

if (RR_Show) then
  write(u6,*)
  write(u6,'(19X,A)') ' Rotational energies / cm-1'
  iEn = 1
  do j=0,S%jMax
    write(u6,*)
    if (Linear) then
      write(u6,'(19X,A,I2,A,F8.3)') ' E(J=',J,') = ',En(iEn)
      iEn = iEn+(2*j+1)
    else
      do kappa=-j,j
        write(u6,'(19X,A,I2,A,I2,A,F12.3)') ' E(J=',J,',kappa=',kappa,') = ',En(iEn)
        iEn = iEn+1
      end do
    end if
  end do
end if
call mma_deallocate(En)

call FinishUp()

return

contains

subroutine FinishUp()

  if (RR_Show) then
    call CollapseOutput(0,'   Rigid rotor info:')
    write(u6,*)
  end if

end subroutine FinishUp

end subroutine RigRot

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION CHO_DSUMELM(VEC,N)
C
C     Purpose: sum elements of double precision vector.
C
      IMPLICIT NONE
      REAL*8  CHO_DSUMELM
      REAL*8  VEC(*), DSUM
      INTEGER I, N

      IF (N .GT. 0) THEN
         DSUM = VEC(1)
         DO I = 2,N
            DSUM = DSUM + VEC(I)
         END DO
      ELSE
         DSUM = 0.0D0
      END IF

      CHO_DSUMELM = DSUM

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine wrtmap (lun,mapd,mapi,rc)
c
c     this routine write required mapd and mapi to opened unformatted file
c     with number lun
c
c     lun   - Logical unit number of file, where mediate will be stored (Input)
c     mapd  - direct map matrix corresponding to given mediate (Input)
c     mapi  - inverse map matrix corresponding to given mediate (Input)
c     rc    - return (error) code (Output)
c
#include "filemgr.fh"
#include "ccsd1.fh"

#include "SysDef.fh"
c
       integer lun,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
       rc=0
c
c1    write mapd
c
       if (iokey.eq.1) then
c      Fortran IO
       write (lun) mapd,mapi
c
       else
c      MOLCAS IO
       call idafile (lun,1,mapd,513*6,daddr(lun))
       call idafile (lun,1,mapi,8*8*8,daddr(lun))
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MltNuc(CoOP,Chrg,Coor,nAtm,rNucMm,ir)
!***********************************************************************
!                                                                      *
! Object: to compute the multipole moments for the nuclei.             *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtm, ir
real(kind=wp), intent(in) :: CoOp(3), Chrg(nAtm), Coor(3,nAtm)
real(kind=wp), intent(out) :: rNucMm(nTri_Elem1(ir))
integer(kind=iwp) :: iAtom, ip, ix, iy, iz
real(kind=wp) :: CCoMx, CCoMy, CCoMz, Temp

#ifdef _DEBUGPRINT_
call RecPrt(' In MltNuc:Coor',' ',Coor,3,nAtm)
call RecPrt(' In MltNuc:Chrg',' ',Chrg,nAtm,1)
call RecPrt(' In MltNuc:CoOp',' ',CoOp,1,3)
#endif

! Compute the nuclear contribution to the multipole moments

ip = 0
do ix=ir,0,-1
  do iy=ir-ix,0,-1
    ip = ip+1
    iz = ir-ix-iy
    temp = Zero
    !write(u6,*) ' ix,iy,iz=',ix,iy,iz
    do iAtom=1,nAtm
      if (ix == 0) then
        CCoMx = One
      else
        CCoMx = (Coor(1,iAtom)-CoOp(1))**ix
      end if
      if (iy == 0) then
        CCoMy = One
      else
        CCoMy = (Coor(2,iAtom)-CoOp(2))**iy
      end if
      if (iz == 0) then
        CCoMz = One
      else
        CCoMz = (Coor(3,iAtom)-CoOp(3))**iz
      end if
      !write(u6,*) CCoMx,CCoMy,CCoMz,temp
      temp = temp+Chrg(iAtom)*CCoMx*CCoMy*CCoMz
    end do
    rNucMm(ip) = temp
  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt(' Nuclear Multipole Moments',' ',rNucMm,ip,1)
#endif

end subroutine MltNuc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        Subroutine Cho_MOtra(CMO,nCMOs,Do_int,ihdf5)
        Implicit None
        Integer nCMOs, ihdf5
        Real*8  CMO(nCMOs)
        Logical Do_int

        Character*6 BName

        Integer iSym
        Integer nSym
        Integer nBas(8), nOrb(8)
        Integer nFro(8), nIsh(8), nAsh(8)
        Integer nSsh(8), nDel(8)

        Logical InitChoEnv

        Call Get_iScalar('nSym',nSym)
        Call Get_iArray('nBas',nBas,nSym)
        Call Get_iArray('nOrb',nOrb,nSym)
        Call Get_iArray('nFro',nFro,nSym)
        Call Get_iArray('nIsh',nIsh,nSym)
        Call Get_iArray('nAsh',nAsh,nSym)
        Call Get_iArray('nDel',nDel,nSym)
        Do iSym=1,nSym
           nSsh(iSym)=nBas(iSym)-nDel(iSym)-nAsh(iSym)
     &               -nIsh(iSym)-nFro(iSym)
        End Do
        BName='_CHMOT'
        InitChoEnv=.true.
        Call Cho_MOTra_(CMO,nCMOs,nSym,nBas,nOrb,
     &                  nFro,nIsh,nAsh,nSsh,nDel,
     &                  BName,Do_Int,ihdf5,InitChoEnv)

        End
************************************************************************
        Subroutine Cho_MOTra_(CMO,nCMOs,nSym,nBas,nOrb,
     &                        nFro,nIsh,nAsh,nSsh,nDel,
     &                        BName,Do_int,ihdf5,Do_ChoInit)
C
C       Note: frozen and deleted orbitals are not included in the
C             transformation.
C
        Implicit Real*8 (a-h,o-z)
        Integer nCMOs, ihdf5
        real*8  CMO(nCMOs)
        Integer nSym
        Integer nBas(nSym), nOrb(nSym)
        Integer nFro(nSym), nIsh(nSym), nAsh(nSym)
        Integer nSsh(nSym), nDel(nSym)
        Character*6 BName
        Logical Do_int
        Logical Do_ChoInit

        Logical timings
        COMMON /CHOTIME /timings
#include "WrkSpc.fh"
**************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
**************************************************

        n=nBas(1)**2
        Do iSym=2,nSym
           n=n+nBas(iSym)**2
        End Do
        If (n.ne.nCMOs) Then
           ! The dimension of CMO is assumed to be nBas**2 in Transp_MOs
           ! with each symmetry block starting at
           !  sym=1: 1
           !  sym=2: 1+nBas(1)**2
           !  sym=3: 1+nBas(1)**2+nBas(2)**2
           ! etc.
           ! This differs from, e.g., subroutine PriMO where each
           ! symmetry block starts at
           !  sym=1: 1
           !  sym=2: 1+nBas(1)*nOrb(1)
           !  sym=3: 1+nBas(1)*nOrb(1)+nBas(2)*nOrb(2)
           ! etc.
           ! This is only a potential problem if orbitals were removed
           ! due to linear dependence (not deleted virtual orbitals)
           Call WarningMessage(2,'Cho_MOTra_: n != nCMOs')
           Write(6,*) 'n,nCMOs=',n,nCMOs
           Call Abend()
        End If
        Call GetMem('CHMOs','Allo','Real',ipCMO,nCMOs)
        Call Transp_MOs(CMO,Work(ipCMO),nSym,nFro,nIsh,nAsh,nSsh,nBas)
c
        timings=.True.
c
        If (Do_int) Then
          Lu_Xint = 80
          Lu_Xint = isfreeunit(Lu_Xint)
          call DaName_mf_wa(Lu_Xint,'DIAGINT')
          lXint=0
          Do jSym=1,nSym
             Do iSymq=1,nSym
                nOrbq=nIsh(iSymq)+nAsh(iSymq)+nSsh(iSymq)
                iSymp=MulD2h(iSymq,jSym)
                If (iSymp.eq.iSymq) Then
                   lXint=lXint+nOrbq*(nOrbq+1)/2
                ElseIf (iSymp.lt.iSymq) Then
                   nOrbp=nIsh(iSymp)+nAsh(iSymp)+nSsh(iSymp)
                   lXint=lXint+nOrbp*nOrbq
                EndIf
             End Do
          End Do
          Call GetMem('DIAGON','Allo','Real',ipXint,lXint)
        EndIf
c
        If (Do_ChoInit) Then
           FracMem=0.0d0 ! in a parallel run set it to a sensible value
           irc=0
           Call Cho_X_Init(irc,FracMem) ! initialize cholesky info
           If (irc.ne.0) Then
              Call WarningMessage(2,
     &                        'Cho_MOTra_: non-zero rc from Cho_X_Init')
              Write(6,*) 'rc=',irc
              Call Abend()
           End If
        End If
        call CHO_TR_drv(irc,nIsh,nAsh,nSsh,ipCMO,BName,
     &                      Do_int,ihdf5,Work(ipXint),lXint)
        If (Do_ChoInit) Then
           Call Cho_X_final(irc)
           If (irc.ne.0) Then
              Call WarningMessage(2,
     &                       'Cho_MOTra_: non-zero rc from Cho_X_Final')
              Write(6,*) 'rc=',irc
              Call Abend()
           End If
        End If
c
        If (Do_int) Then
           Call GADSum(Work(ipXint),lXint)
           kdisk=0
           Call ddafile(Lu_Xint,1,Work(ipXint),lXint,kdisk)
           Call daclos(Lu_Xint)
           Call GetMem('DIAGON','Free','Real',ipXint,lXint)
        EndIf
        Call GetMem('CHMOs','Free','Real',ipCMO,nCMOs)
c
        return
c Avoid unused argument warnings
        If (.False.) Then
           Call Unused_integer_array(nOrb)
           Call Unused_integer_array(nDel)
        End If
        end
************************************************************************
      SUBROUTINE CHO_TR_drv(rc,nIsh,nAsh,nSsh,ipPorb,BName,Do_int,ihdf5,
     &                      Xint,lXint)
**********************************************************************
C
C      a,b,g,d:  AO-index
C      p,q,r,s:  MO-indeces belonging to all (fro and del excluded)
C
**********************************************************************
#ifdef _HDF5_QCM_
      use hdf5_utils
#endif
      Implicit Real*8 (a-h,o-z)

      Integer   rc,nIsh(*),nAsh(*),nSsh(*),lXint, ihdf5
      Real*8    Xint(0:lXint-1)
      Character*6 BName

      Real*8    tread(2),tmotr1(2),tmotr2(2)
      Logical   Debug,timings,DoRead,Do_int
      Integer   nPorb(8),ipOrb(8)
      Integer   ipLpb(8),iSkip(8)
      Integer   LunChVF(8),kOff(8),iOffB(8),nOB(8)

      Character*7  Fnam
      Character*50 CFmt
      Character*10 SECNAM
      Parameter (SECNAM = 'CHO_TR_drv')

      COMMON    /CHOTIME /timings
      Character*3  tv2disk
      COMMON    /CHOTRAW /tv2disk

      parameter (zero = 0.0D0, one = 1.0D0)

#ifdef _HDF5_QCM_
      integer(HID_T)  :: choset_id
      integer(HID_T)  :: space_id
#endif

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )

      integer isfreeunit

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
************************************************************************


#ifdef _DEBUGPRINT_
      Debug=.true.
#else
      Debug=.false.
#endif


#ifdef _HDF5_QCM_
      ! Leon 13.6.2017: Avoid opening a regular file if HDF5 is used
      if (ihdf5/=1) then
#endif
        Do i=1,nSym
          LunChVF(i) = 80
          LunChVF(i) = isfreeunit(LunChVF(i))
          write(Fnam,'(A6,I1)') BName,i
          call DaName_mf_wa(LunChVF(i),Fnam)
        End Do
#ifdef _HDF5_QCM_
      End If
#endif

      DoRead  = .false.
      IREDC = -1  ! unknown reduced set in core

      iSwap = 0  ! Lpb,J are returned by cho_x_getVtra
      kMOs = 1
      nMOs = 1


      CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

      do i=1,2            ! 1 --> CPU   2 --> Wall
         tread(i) = zero   !time read/write vectors
         tmotr1(i) = zero  !time 1st MO half-transf.
         tmotr2(i) = zero  !time 2nd MO half-transf.
      end do

      If (Do_int) Call Fzero(Xint(0),lXint)

c --- Define MO space used
c -----------------------------------
      do i=1,nSym
         nPorb(i) = nIsh(i) + nAsh(i) + nSsh(i)
      end do


C ==================================================================

c --- Various offsets & pointers
c ------------------------------
      ipOrb(1)=ipPorb
      DO ISYM=2,NSYM
        NB=NBAS(ISYM-1)
        NP=NPORB(ISYM-1)
        NP2=NP*NB
        ipOrb(ISYM)=ipOrb(ISYM-1)+NP2 !  MO coeff. symm pointers
      END DO

      iLoc = 3 ! use scratch location in reduced index arrays

C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
c
c
      Mpq=0

      DO jSym=1,nSym

! Init the HDF5 section
#ifdef _HDF5_QCM_
         if(ihdf5 == 1)then
           ! max size of the cholesky vector for now is the
           ! max(nPorb)*(max(nPorb)+1)/2
           ! probably this can be chosen more efficiently,
           ! but would matter only if we use symmetry
           call hdf5_init_wr_cholesky(file_id(1), JSym,
     &       maxval(nPorb(1:nSym))*(maxval(nPorb(1:nSym))+1)/2,
     &       NumCho(JSym), choset_id, space_id)
         end if
#endif
         If (NumCho(jSym).lt.1) GOTO 1000

C --- Set up the skipping flags + some initializations --------
C -------------------------------------------------------------
         Do i=1,nSym
            ipLpb(i) = -6666
            k=Muld2h(i,JSYM)
            iSkip(i) = Min(1,nPorb(i)*nPorb(k)) ! skip Lik vector
            If (i.lt.k) Then
               kOff(i)=Mpq
               nOB(i)=nPorb(i)*nPorb(k)*NumCho(jSym)
               Mpq=Mpq+nPorb(i)*nPorb(k)
            ElseIf (k.eq.i) Then
               kOff(i)=Mpq
               nOB(i)=nPorb(i)*(nPorb(i)+1)/2*NumCho(jSym)
               Mpq=Mpq+nPorb(i)*(nPorb(i)+1)/2
            Else
               nOB(i)=0
            EndIf
            iOffB(i)=0
         End Do
*
         Do i=2,nSym
            iOffB(i)=iOffB(i-1)+nOB(i-1)
         End Do
         Do i=1,nSym
            If (nOB(i).eq.0) Then
               k=Muld2h(i,JSYM)
               iOffB(i)=iOffB(k)
               kOff(i)=kOff(k)
            EndIf
         End Do
C -------------------------------------------------------------


C ****************     MEMORY MANAGEMENT SECTION    *****************
C ------------------------------------------------------------------
C --- compute memory needed to store at least 1 vector of JSYM
C --- and do all the subsequent calculations
C ------------------------------------------------------------------
         mTvec  = 0  ! mem for storing half-transformed vec Laq,J
         mTTvec = 0  ! mem for storing transformed vec Lpq,J

         do l=1,nSym
            k=Muld2h(l,JSYM)
            mTvec = mTvec + nPorb(k)*nBas(l)
            mTTvec = Max(mTTvec,nPorb(k)*nPorb(l))
         end do

         mvec = mTvec + mTTvec

C ------------------------------------------------------------------
C ------------------------------------------------------------------

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

         Do JRED=JRED1,JRED2

            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               call abend()
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.',
     &                         ' rc= ',irc
              call abend()
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec  = Min(LWORK/(nRS+mvec+1),nVrs)

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) 'LWORK= ',LWORK
               WRITE(6,*) 'Min. mem. need= ',nRS+mvec+1
               WRITE(6,*) 'Reading ',nRS,' and then MO-transform.'
               WRITE(6,*) 'In jsym= ',jsym,' and JRED= ',JRED
               rc = 33
               CALL Abend()
               nBatch = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
            Call GetMem('ChoT','Allo','Real',ipChoT,(mvec+1)*nVec)

C --- BATCH over the vectors ----------------------------

            nBatch = (nVrs-1)/nVec + 1

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM) then
                  rc=77
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

               lChoT=JNUM
               Do iSymp=1,nSym

                  iSymb = MulD2h(jSym,iSymp)

                  ipLpb(iSymp) = ipChoT + lChoT
                  lChoT = lChoT + nPorb(iSymp)*nBas(iSymb)*JNUM

               End Do

               ipLpq = ipChoT + lChot

C --------------------------------------------------------------------
C --- First half MO transformation  Lpb,J = sum_a  C(p,a) * Lab,J
C --------------------------------------------------------------------

               CALL CWTIME(TCM1,TWM1)

               CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                           JSYM,iSwap,IREDC,nMOs,kMOs,ipOrb,nPorb,
     &                           ipLpb,iSkip,DoRead)

               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif

               CALL CWTIME(TCM2,TWM2)
               tmotr1(1) = tmotr1(1) + (TCM2 - TCM1)
               tmotr1(2) = tmotr1(2) + (TWM2 - TWM1)

C --------------------------------------------------------------------
C --- 2nd half of MO transformation  Lpq,J = sum_b  Lpb,J * C(q,b)
C --------------------------------------------------------------------

               IF (JSYM.eq.1) THEN   !  Lpq,J in LT-storage

                  Do iSymb=1,nSym

                     NAp = nPorb(iSymb)
                     NApq=NAp*(NAp+1)/2

                     CALL CWTIME(TCM3,TWM3)

                     If (NApq.ne.0) Then

                      Do JVC=1,JNUM

                       ipLJpb = ipLpb(iSymb)
     &                        + nPorb(iSymb)*nBas(iSymb)*(JVC-1)
                       ipLJpq = ipLpq
     &                        + NApq*(JVC-1)

                       CALL DGEMM_Tri('N','T',NAp,NAp,nBas(iSymb),
     &                            One,Work(ipLJpb),NAp,
     &                                Work(ipOrb(iSymb)),NAp,
     &                           Zero,Work(ipLJpq),NAp)

                      End Do

                     EndIf

                     CALL CWTIME(TCM4,TWM4)
                     tmotr2(1) = tmotr2(1) + (TCM4 - TCM3)
                     tmotr2(2) = tmotr2(2) + (TWM4 - TWM3)

                     CALL CWTIME(TCR3,TWR3)

                     If (NApq.ne.0) Then

                        If (tv2disk.eq.'PQK') Then
#ifdef _HDF5_QCM_
                         if (ihdf5/=1) then
#endif
                           Call ddafile(LunChVF(jSym),1,Work(ipLpq),
     &                                                NApq*JNUM,
     &                                                iOffB(iSymb))
#ifdef _HDF5_QCM_
                         else
                           ! this should never happen, this case should be caught in motra.f
                           Write(6,*)' Writing of Cholesky vectors'//
     &                       'in HDF5 format as (pq,k) is not'//
     &                       'supported.'
                           call Abend()
                         end if
#endif
                           If (Do_int) Then
                              Do ipq=0,NApq-1
                                 kt=kOff(iSymb)+ipq
                                 kLpq=ipLpq+ipq
                                Xint(kt)=Xint(kt)+ddot_(JNUM,Work(kLpq),
     &                                             NApq,Work(kLpq),NApq)
                              End Do
                           EndIf
                        Else
                           Do ipq=0,NApq-1
                              call dcopy_(JNUM,Work(ipLpq+ipq),NApq,
     &                                        Work(ipChoT),1)
                              If (Do_int) Then
                                 kt=kOff(iSymb)+ipq
                                 Xint(kt)=Xint(kt)+ddot_(JNUM,
     &                                                  Work(ipChoT),1,
     &                                                  Work(ipChoT),1)
                              EndIf
                              idisk=iOffB(iSymb)+NumCho(jSym)*ipq
#ifdef _HDF5_QCM_
                             ! Leon 13.6.2017: Do not write Cholesky vectors to the regular file
                             ! if the hdf5 file is written. It becomes counterproductive to write
                             ! the same content twice for large basis sets
                             if (ihdf5/=1) then
#endif
                              Call ddafile(LunChVF(jSym),1,Work(ipChoT),
     &                                                   JNUM,
     &                                                   idisk)

#ifdef _HDF5_QCM_
                             ! Write the transformed Cholesky batch to the hdf5 dataset
                             ! The ordering in HDF5 is in column-major order, corresponding to
                             ! the 'Kpq' storage
                             ! This way all the elements needed to compute one integral can be
                             ! read with one read operation.

                             ! TODO: eventually row-major order storage + chunked dataset might
                             ! improve the performance -- but probably it's irrelevant.
                             ! Leon 22.4.2016 -- modified the write_cholesky call below to
                             ! account for multiple reduced sets
                             else
                               call hdf5_write_cholesky(choset_id,
     &                           space_id,ipq,nVec*(iBatch-1)+iVrs-1,
     &                                             JNUM,Work(ipChoT))
                             end if
#endif

                           End Do
                           iOffB(iSymb)=iOffB(iSymb)+JNUM
                        EndIf

                     EndIf

                     CALL CWTIME(TCR4,TWR4)
                     tread(1) = tread(1) + (TCR4 - TCR3)
                     tread(2) = tread(2) + (TWR4 - TWR3)

                  End Do

               ELSE

                  Do iSymb=1,nSym

                     iSymp = MulD2h(JSYM,iSymb)
                     NAp = nPorb(iSymp)
                     NAq = nPorb(iSymb) ! iSymb=iSymq
                     NApq=NAp*NAq

                     CALL CWTIME(TCM3,TWM3)

                     If(NApq.ne.0.and.iSymp.lt.iSymb)Then

                      Do JVC=1,JNUM

                       ipLJpb = ipLpb(iSymp)
     &                        + nPorb(iSymp)*nBas(iSymb)*(JVC-1)
                       ipLJpq = ipLpq
     &                        + nPorb(iSymp)*nPorb(iSymb)*(JVC-1)

                       CALL DGEMM_('N','T',NAp,NAq,nBas(iSymb),
     &                            One,Work(ipLJpb),NAp,
     &                                Work(ipOrb(iSymb)),NAq,
     &                           Zero,Work(ipLJpq),NAp)

                      End Do

                     EndIf

                     CALL CWTIME(TCM4,TWM4)
                     tmotr2(1) = tmotr2(1) + (TCM4 - TCM3)
                     tmotr2(2) = tmotr2(2) + (TWM4 - TWM3)

                     CALL CWTIME(TCR3,TWR3)

                     If (NApq.ne.0) Then

                        If (tv2disk.eq.'PQK') Then
                           Call ddafile(LunChVF(jSym),1,Work(ipLpq),
     &                                                NApq*JNUM,
     &                                                iOffB(iSymp))
                           If (Do_int) Then
                              Do ipq=0,NApq-1
                                 kt=kOff(iSymp)+ipq
                                 kLpq=ipLpq+ipq
                                Xint(kt)=Xint(kt)+ddot_(JNUM,Work(kLpq),
     &                                             NApq,Work(kLpq),NApq)
                              End Do
                           EndIf

                        Else
                           Do ipq=0,NApq-1
                              call dcopy_(JNUM,Work(ipLpq+ipq),NApq,
     &                                        Work(ipChoT),1)
                              If (Do_int) Then
                                 kt=kOff(iSymp)+ipq
                                 Xint(kt)=Xint(kt)+ddot_(JNUM,
     &                                                  Work(ipChoT),1,
     &                                                  Work(ipChoT),1)
                              EndIf
                              idisk=iOffB(iSymp)+NumCho(jSym)*ipq
#ifdef _HDF5_QCM_
                             ! Write the transformed Cholesky batch to the hdf5 dataset
                             ! The ordering in HDF5 is in column-major order, corresponding to
                             ! the 'Kpq' storage
                             ! See above for more explanation
                             if (ihdf5==1) then
                               call hdf5_write_cholesky(choset_id,
     &                           space_id,ipq,nVec*(iBatch-1),JNUM,
     &                                                    Work(ipChoT))
                             end if
#endif

                              Call ddafile(LunChVF(jSym),1,Work(ipChoT),
     &                                                   JNUM,
     &                                                   idisk)
                           End Do
                           iOffB(iSymp)=iOffB(iSymp)+JNUM
                        EndIf

                     EndIf

                     CALL CWTIME(TCR4,TWR4)
                     tread(1) = tread(1) + (TCR4 - TCR3)
                     tread(2) = tread(2) + (TWR4 - TWR3)

                  End Do

               EndIf

C --------------------------------------------------------------------
C --------------------------------------------------------------------

            END DO  ! end batch loop

C --- free memory
            Call GetMem('ChoT','Free','Real',ipChoT,(mvec+1)*nVec)
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

999         CONTINUE

         END DO   ! loop over red sets

#ifdef _HDF5_QCM_
         ! close Cholesky HDF5 stuff
         if (ihdf5==1) then
           call hdf5_close_cholesky(choset_id, space_id)
         else
#endif
           call daclos(LunChVF(jSym))
#ifdef _HDF5_QCM_
         endif
#endif
1000     CONTINUE

      END DO   !loop over JSYM


      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1
*
*---- Write out timing information
      if(timings)then

      CFmt='(6x,A)'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Cholesky-MOTRA timings            CPU       WALL '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

      If (Do_int) Then
         Write(6,'(6x,A28,2f10.2)')'I/O vectors + diag ERIs step     '
     &                           //'         ',tread(1),tread(2)
      Else
         Write(6,'(6x,A28,2f10.2)')'I/O vectors                      '
     &                           //'         ',tread(1),tread(2)
      EndIf
         Write(6,'(6x,A28,2f10.2)')'1st half-transf.                 '
     &                           //'         ',tmotr1(1),tmotr1(2)
         Write(6,'(6x,A28,2f10.2)')'2nd half-transf.                 '
     &                           //'         ',tmotr2(1),tmotr2(2)
         Write(6,*)
         Write(6,'(6x,A28,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif

      rc  = 0

      write(6,*)
      If (tv2disk.eq.'PQK') Then
         tv2disk(1:2)='pq'
         write(6,*)'     Transformed Cholesky vectors stored as L(',
     &                                tv2disk(1:2),',',tv2disk(3:3),')'
      Else
         tv2disk(2:3)='pq'
         write(6,*)'     Transformed Cholesky vectors stored as L(',
     &                                tv2disk(1:1),',',tv2disk(2:3),')'
      EndIf
      write(6,*)


      Return
#ifndef _HDF5_QCM_
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(ihdf5)
#endif
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001-2005, Valera Veryazov                             *
!               2020, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine BasisTbl(Label,BasDir)

! a routine to translate basis set labels

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
character(len=*), intent(inout) :: Label
character(len=*), intent(in) :: BasDir
character(len=256) :: Temp, Line
integer(kind=iwp) :: i, ia, ib, iLast, irecl, istatus, iUnit, jlast
integer(kind=iwp), external :: isFreeUnit, StrnLn
logical(kind=iwp) :: Exists, is_error

!i = index(Label,'.')
!if (i > 0) then
!  i = index(Label(i+1:),'.')
!  !return if we have a complete name
!  if (i /= 0) return
!endif
Temp = BasDir//'/basis.tbl'
call f_Inquire(Temp,Exists)
if (.not. Exists) return
iUnit = isfreeunit(15)
call molcas_Open_ext2(iunit,temp,'sequential','formatted',istatus,.false.,irecl,'unknown',is_error)
!open(unit=iUnit,file=Temp,form='FORMATTED',iostat=istatus)
if (istatus /= 0) return
iLast = StrnLn(Label)

! Strip trailing dots

do while (Label(iLast:iLast) == '.')
  iLast = iLast-1
end do
!write(u6,*) 'Label(1:iLast)=',Label(1:iLast)
do
  read(iUnit,'(a)',iostat=istatus) Line
  if (istatus /= 0) then
    close(iunit)
    return
  end if
  if (Line(1:1) == '#') cycle
  if (Line == ' ') cycle
  call UpCase(Line)

  ! Identify first non-blank segment in Line

  jlast = 0
  do while (Line(jlast+1:jlast+1) /= ' ')
    jLast = jLast+1
  end do
  if (jlast /= ilast) cycle
  !i = index(Line,Label(1:iLast))
  i = index(Line(1:jlast),Label(1:iLast))
  if (i == 1) exit
end do
i = iLast+1
do while (Line(i:i) == ' ')
  i = i+1
end do
ib = i
ia = index(Line(ib:),' ')
if (ia == 0) ia = len(Line)+1
#ifdef _DEBUGPRINT_
write(u6,'(3a)') Label(1:iLast),'translated to ',Line(ib:ib+ia-1)
#endif
Label = Line(ib:ib+ia-1)
close(iUnit)

return

end subroutine BasisTbl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine cidaxpy_cvb(fac,cvec1,cvec2)
      implicit real*8(a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension cvec1(*),cvec2(*)
c  *********************************************************************
c  *                                                                   *
c  *  CIDAXPY := Analogous to the blas routine DAXPY                   *
c  *                                                                   *
c  *********************************************************************

      ivec1=nint(cvec1(1))
      ivec2=nint(cvec2(1))
      iformat=iform_ci(ivec1)
      if(iformat.eq.0)then
        call daxpy_(ndet,fac,work(iaddr_ci(ivec1)),1,
     >              work(iaddr_ci(ivec2)),1)
      else
        write(6,*)' Unsupported format in CIDAXPY :',iformat
        call abend_cvb()
      endif
      call setcnt2_cvb(ivec2,0)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FIJD(INTSYM,INDX,C,DMO,JREFX,AREF)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION INTSYM(*),INDX(*),
     *          C(*),DMO(*),JREFX(*),AREF(*)
*
      JSYM(L)=JSUNP(INTSYM,L)
*
      ICHK=0
      IK=0
      ENPINV=1.0D00/ENP
      DFACR=1.0D00-ENPINV
      IADD10=IAD10(8)
100   CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 100
      IF(LEN.LT.0) RETURN
      DO 10 IN=1,LEN
      IND=ICOP1(IN)
      IF(ICHK.NE.0) THEN
        ICHK=0
        INDI=IND
*        NI=MOD(INDI,2**10)
*        NK=MOD(INDI/2**10,2**10)
        NI=IBITS(INDI, 0,10)
        NK=IBITS(INDI,10,10)
        IK=IROW(NK)+NI
        GO TO 10
      END IF
      IF(IND.EQ.0) THEN
        ICHK=1
        GO TO 10
      END IF
*      IVL=MOD(IND,2**6)
*      IC2=MOD(IND/2**6,2**13)
*      IC1=MOD(IND/2**19,2**13)
      IVL=IBITS(IND, 0, 6)
      IC2=IBITS(IND, 6,13)
      IC1=IBITS(IND,19,13)
      IF(IVL.NE.IVVER)GO TO 13
      DMO(IK)=DMO(IK)+COP(IN)*C(IC1)*C(IC2)*ENPINV
      IF(ICPF.EQ.0)GO TO 10
      IRC1=JREFX(IC1)
      IF(IRC1.EQ.0)GO TO 10
      IRC2=JREFX(IC2)
      IF(IRC2.EQ.0)GO TO 10
      DMO(IK)=DMO(IK)+COP(IN)*AREF(IRC1)*AREF(IRC2)*(1.0D00-ENPINV)
      GO TO 10
13    INDA=IRC(IVL)+IC1
      INDB=IRC(IVL)+IC2
      NA=INDX(INDA)
      NB=INDX(INDB)
      NS1=JSYM(INDA)
      NS1L=MUL(NS1,LSYM)
      INUM=NVIR(NS1L)
      IF(IVL.GE.2)INUM=NVPAIR(NS1L)
      TERM=DDOT_(INUM,C(NA+1),1,C(NB+1),1)
      DMO(IK)=DMO(IK)+COP(IN)*TERM*ENPINV
10    CONTINUE
      GO TO 100
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DELF(FNAM,INUM1,INUM2)

use Definitions, only: iwp

implicit none
character(len=6), intent(in) :: FNAM
integer(kind=iwp), intent(in) :: INUM1, INUM2
integer(kind=iwp) :: I, LU
character(len=8) :: FN
integer(kind=iwp), external :: IsFreeUnit

FN(1:6) = FNAM
do I=inum1,inum2
  write(fn(7:8),'(I2.2)') I
  !write(u6,*) 'File ',FN,' to be deleted'
  LU = IsFreeUnit(8)
  call Molcas_Open(LU,fn)
  close(LU,status='DELETE')
end do

return

end subroutine DELF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Nrmlz(rExp,nPrim,Coeff,nCntrc,iAng)
!***********************************************************************
!                                                                      *
! Object: normalize the contraction coefficients with respect to the   *
!         radial overlap.                                              *
!                                                                      *
! Called from: Input                                                   *
!                                                                      *
! Calling    : RecPrt                                                  *
!              DGEMM_  (ESSL)                                          *
!              DnDot   (ESSL)                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half, OneHalf, TwoP34
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nPrim, nCntrc, iAng
real(kind=wp), intent(in) :: rExp(nPrim)
real(kind=wp), intent(inout) :: Coeff(nPrim,nCntrc)
integer(kind=iwp) :: i, iExp, j, jExp, nScrt1, nScrt2
real(kind=wp) :: Power, Pro_ij, Qtemp, Rtemp, Sum_ij, Temp, vR2, vRR
real(kind=wp), allocatable :: Scrt1(:), Scrt2(:)

if (nPrim*nCntrc == 0) return

nScrt1 = nPrim**2
nScrt2 = nPrim*nCntrc
call mma_allocate(Scrt1,nScrt1)
call mma_allocate(Scrt2,nScrt2)

#ifdef _DEBUGPRINT_
write(u6,*) ' In Nrmlz: iAng=',iAng
call RecPrt(' In Nrmlz: Coefficients',' ',Coeff,nPrim,nCntrc)
call RecPrt(' In Nrmlz: Exponents',' ',rExp,nPrim,1)
#endif

! Normalize the coefficients (only radial normalization)

! Compute overlap for all primitives of this shell.
! This formula includes the normalization constant for each
! primitive as well as the overlap factor of between the primitives.
! Hence, the overlap matrix elements correspond to those of the
! normalized primitive gaussian functions.

do iExp=1,nPrim
  do jExp=1,iExp-1
    Pro_ij = sqrt(rExp(iExp)*rExp(jExp))
    Sum_ij = (rExp(iExp)+rExp(jExp))/Two
    Power = real(iAng,kind=wp)+OneHalf
    Temp = (Pro_ij/Sum_ij)**Power
    Scrt1(nPrim*(iExp-1)+jExp) = Temp
    Scrt1(nPrim*(jExp-1)+iExp) = Temp
  end do
  Scrt1(nPrim*(iExp-1)+iExp) = One
end do
! Contract right side
call DGEMM_('N','N',nPrim,nCntrc,nPrim,One,Scrt1,nPrim,Coeff,nPrim,Zero,Scrt2,nPrim)
#ifdef _DEBUGPRINT_
call RecPrt(' Overlap primitives',' ',Scrt1,nPrim,nPrim)
call RecPrt(' Overlap PrimCon',' ',Scrt2,nPrim,nCntrc)
#endif

! Compute the overlap for each contracted basis function, <i|i>

call DnDot(nCntrc,nPrim,Scrt1,1,1,Scrt2,1,nPrim,Coeff,1,nPrim)
#ifdef _DEBUGPRINT_
call RecPrt(' Overlap Contracted',' ',Scrt1,nCntrc,1)
#endif

! Normalize coefficients, i.e. combine the normalization factor
! of the primitive and the overlap of the unnormalized contracted
! basis function.

do i=1,nCntrc
  if (abs(Scrt1(i)) < 1.0e-12_wp) then
    call WarningMessage(2,'; Error in contraction matrix, zero column; ; Abend in subroutine NRMLZ')
    call Abend()
  end if
end do

Rtemp = Half*real(iAng,kind=wp)+0.75_wp
Qtemp = Two**(iAng+1)*sqrt(Two)*TwoP34
do i=1,nCntrc
  vRR = Scrt1(i)**(-Half)
  do j=1,nPrim
    vR2 = rExp(j)**Rtemp
    Coeff(j,i) = Coeff(j,i)*Qtemp*vRR*vR2
  end do
end do
if ((nPrim == 1) .and. (nCntrc == 1) .and. (rExp(1) == Zero)) then
  Coeff(1,1) = One
end if
#ifdef _DEBUGPRINT_
call Recprt(' In Nrmlz: Normalized coefficients',' ',Coeff,nPrim,nCntrc)
#endif

call mma_deallocate(Scrt2)
call mma_deallocate(Scrt1)

return

end subroutine Nrmlz

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OneBas(Label)
!***********************************************************************
!                                                                      *
!     Change nBas in OneDat                                            *
!                                                                      *
!***********************************************************************

use OneDat, only: nBas, nSym
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp) :: IntBas(8)

if (Label == 'CONT') then
  call Get_iArray('nBas',IntBas,nSym)
else if (Label == 'PRIM') then
  call Get_iArray('nBas_Prim',IntBas,nSym)
else
  write(u6,*) 'OneBas: Illegal Label value!'
  write(u6,*) 'Value: ',Label
  call Abend()
end if
nBas(1:nSym) = IntBas(1:nSym)

return

end subroutine OneBas

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

function iNew(iTest,iIrrep)

use Symmetry_Info, only: iChTbl, nIrrep
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iNew
integer(kind=iwp), intent(in) :: iIrrep, iTest(8)
integer(kind=iwp) :: i, iGo, j

iNew = 0
! Test iTest against all rows thus far.
do i=1,iIrrep
  ! Do a intger inner product.
  iGo = 0
  do j=1,nIrrep
    iGo = iGo+iTest(j)*iChTbl(i-1,j-1)
  end do
  if (iGo /= 0) then
    ! Here if row already defined.
    iNew = i
    return
  end if
end do
iNew = iIrrep+1

return

end function iNew

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function nProp_Int(Do_Index,Idx,nIdx)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nProp_Int
logical(kind=iwp), intent(in) :: Do_Index
integer(kind=iwp), intent(in) :: nIdx
integer(kind=iwp), intent(inout) :: Idx(4,nIdx)
integer(kind=iwp) :: iCent, iComp, iEF, iMltpl, iopt, irc, iSmLbl, iSmLbl_, maxCen, nComp, n_Int(1)
character(len=8) :: Label

!                                                                      *
!***********************************************************************
!                                                                      *
nProp_Int = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Scan the ONEINT file for multipole moment operators

!write(u6,*) ' Starting scan of ONEINT for multipole moments'
do iMltpl=1,99
  nComp = (iMltpl+1)*(iMltpl+2)/2

  write(Label,'(a,i2)') 'MLTPL ',iMltpl
  irc = -1
  iopt = 1
  iComp = 1
  call iRdOne(irc,iopt,Label,iComp,n_Int,iSmLbl)
  if (irc /= 0) exit
  if (Do_Index) then
    do iComp=1,nComp
      nProp_Int = nProp_Int+1
      Idx(1,nProp_Int) = 1
      Idx(2,nProp_Int) = iMltpl
      Idx(3,nProp_Int) = iComp
      Idx(4,nProp_Int) = 0
    end do
  else
    nProp_Int = nProp_Int+nComp
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Scan 'ONEINT' for electric field integrals

!write(u6,*) ' Starting scan of ONEINT for various elec. field integrals'
do iEF=0,2
  nComp = (iEF+1)*(iEF+2)/2

  maxCen = 9999
  do iCent=1,maxCen
    write(Label,'(a,i1,i5)') 'EF',iEF,iCent
    irc = -1
    iopt = 1
    iComp = 1
    call iRdOne(irc,iopt,Label,iComp,n_Int,iSmLbl)
    if (irc /= 0) exit
    if (Do_Index) then
      do iComp=1,nComp
        nProp_Int = nProp_Int+1
        Idx(1,nProp_Int) = 2
        Idx(2,nProp_Int) = iEF
        Idx(3,nProp_Int) = iComp
        Idx(4,nProp_Int) = iCent
      end do
    else
      nProp_Int = nProp_Int+nComp
    end if
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Scan 'ONEINT' for contact term integrals

!write(u6,*) ' Starting scan of ONEINT for various contact term integrals'
nComp = 1

maxCen = 9999
do iCent=1,maxCen
  write(Label,'(a,i5)') 'Cnt',iCent
  irc = -1
  iopt = 1
  iComp = 1
  call iRdOne(irc,iopt,Label,iComp,n_Int,iSmLbl)
  if (irc /= 0) exit
  if (Do_Index) then
    do iComp=1,nComp
      nProp_Int = nProp_Int+1
      Idx(1,nProp_Int) = 3
      Idx(2,nProp_Int) = 1
      Idx(3,nProp_Int) = 1
      Idx(4,nProp_Int) = iCent
    end do
  else
    nProp_Int = nProp_Int+nComp
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Scan 'ONEINT' for magnetic integrals (copied from ONEREL)

nComp = 9
iSmLbl_ = 255
maxCen = 9999
do iCent=1,maxCen
  write(Label,'(A,I3)') 'MAGXP',iCent
  irc = -1
  iopt = 1
  iComp = 1
  call iRdOne(irc,iopt,Label,iComp,n_Int,iSmLbl_)
  if (irc /= 0) exit
  if (Do_Index) then
    do iComp=1,nComp
      nProp_Int = nProp_Int+1
      Idx(1,nProp_Int) = 4
      Idx(2,nProp_Int) = 0
      Idx(3,nProp_Int) = iComp
      Idx(4,nProp_Int) = iCent
    end do
  else
    nProp_Int = nProp_Int+nComp
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
!if (Do_Index) call iVcPrt('Idx',' ',Idx,4*nProp_Int)

return

end function nProp_Int

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LToCore(F,nalpha,ishll,la,iAng,nvecac)
*******************************************************************************
*
* Transformation kernel to atomic orbials in normailized spherical harmonics
*
*******************************************************************************
*    @parameter F  The cartesian components of <A|core>
*    @parameter nAlpha Number of exponents
*    @parameter ishll Shell number for ECP
*    @parameter la angular momenta LS
*    @parameter iAng angular momenta core
*    @parameter Number of derivatives
*
      use Real_Spherical
      use Basis_Info
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Real*8 F(*)

      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nac=nelem(la)*nelem(iang)
      nExpi=Shells(iShll)%nExp
      nBasisi=Shells(iShll)%nBasis
      Call Getmem('TMP1','ALLO','REAL',iptmp,
     &             nExpi*nac*nVecAC*nalpha)
      Call Getmem('TMP2','ALLO','REAL',ipF,
     &             nExpi*nac*nVecAC*nalpha)
*--------------From the lefthandside overlap, form iKaC from ikac by
*              1) i,kac -> k,aci
*
      n = nExpi*nac*nVecAC
      Call DgeTMo(F,nAlpha,
     &            nAlpha, n,
     &            Work(ipTmp),n)
*
*--------------2) aciK =  k,aci * k,K (Contract over core orbital)
*
      Call DGEMM_('T','N',
     &            nac*nVecAC*nAlpha,nBasisi,nExpi,
     &            1.0d0,Work(ipTmp),nExpi,
     &            Shells(iShll)%pCff,nExpi,
     &            0.0d0,Work(ipF),nac*nVecAC*nAlpha)
*
*--------------3) Mult by shiftoperators aci,K -> Bk(K) * aci,K
*
      Do iBk = 1, nBasisi
         Call DYaX(nac*nVecAC*nAlpha,Shells(iShll)%Bk(iBk),
     &              Work((iBk-1)*nac*nVecAC*nAlpha+ipF),1,
     &              Work((iBk-1)*nac*nVecAC*nAlpha+ipTmp),1)
      End Do
*
*--------------4) a,ciK -> ciKa
*
      Call DgeTMo(Work(ipTmp),nElem(la),nElem(la),
     &            nElem(iAng)*nVecAC*nAlpha*nBasisi,
     &            Work(ipF),
     &            nElem(iAng)*nVecAC*nAlpha*nBasisi)
*
*--------------5) iKa,C = c,iKa * c,C
*
      Call DGEMM_('T','N',
     &            nVecAC*nAlpha*nBasisi*nElem(la),
     &            (2*iAng+1),nElem(iAng),
     &            1.0d0,Work(ipF),nElem(iAng),
     &            RSph(ipSph(iAng)),nElem(iAng),
     &            0.0d0,Work(ipTmp),
     &            nVecAC*nAlpha*nBasisi*nElem(la))
*
      Call DgeTMo(Work(ipTmp),nVecAC,nVecAC,
     &            nAlpha*nBasisi*nElem(la)*(2*iAng+1),
     &            F,
     &            nAlpha*nBasisi*nElem(la)*(2*iAng+1))

      Call Getmem('TMP1','FREE','REAL',iptmp,
     &            nExpi*nac*nVecAC*nalpha)

      Call Getmem('TMP2','FREE','REAL',ipF,
     &            nExpi*nac*nVecAC*nalpha)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION NEWCNFTAB(NEL,NORB,MINOP,MAXOP,LSYM,NGAS,
     &                           NGASORB,NGASLIM,IFORM)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "symmul.fh"
      DIMENSION NGASLIM(2,NGAS)
      DIMENSION NGASORB(NSYM,NGAS)

      NEWCNFTAB=-1
CTEST      write(*,*)' Just entered NEWCNFTAB.'
CTEST      write(*,'(1x,a,10i8)')'NEL,NORB,MINOP,MAXOP:',NEL,NORB,MINOP,MAXOP
CTEST      write(*,'(1x,a,10i8)')'NSYM,LSYM,NGAS:',NSYM,LSYM,NGAS
C Note how input parameter LSYM is used: If non-zero, only those configurations
C with symmetry label LSYM are selected. But if LSYM=0, they are all selected.
C We must figure out sizes before allocating the new configuration table.
C Set up a table NCNF1(NSYM,NPOS) with NPOS=((NEL+1)*(NEL+2))/2
      NNCNF1=NSYM*((NEL+1)*(NEL+2))/2
      CALL GETMEM('NCnf1','Allo','Inte',LNCNF1,NNCNF1)
C We need also a table NCNF2, temporarily. Need to know mx nr of active orbitals
C in any GAS subspace:
      MXO=0
       DO IGAS=1,NGAS
        ISUM=0
        DO ISYM=1,NSYM
         ISUM=ISUM+NGASORB(ISYM,IGAS)
        END DO
        MXO=MAX(MXO,ISUM)
      END DO
      NNCNF2=NSYM*((MXO+1)*(MXO+2))/2
      CALL GETMEM('NCnf2','Allo','Inte',LNCNF2,NNCNF2)
      CALL NRCNF1(NEL,NORB,NGAS,NGASLIM,NGASORB,IWORK(LNCNF1),
     &            MXO,IWORK(LNCNF2))
      CALL GETMEM('NCnf2','Free','Inte',LNCNF2,NNCNF2)
C NCNF1(ISYM,IPOS) contains the number of possible configurations for symmetry
C label ISYM, nr of closed shells NCLS, and nr of open shells NOPN. The latter
C are combined as pair index IPOS=1+NOPN+(NOCC*(NOCC+1))/2 with NOCC=NCLS+NOPN

C Header (See below for contents):
      NTAB=10
C NGASORB array:
      NTAB=NTAB+(NSYM+1)*(NGAS+1)
C NGASLIM array:
      NTAB=NTAB+2*NGAS
C Save offset to INFO table for later use:
      KINFO=NTAB+1
C INFO array:
      NTAB=NTAB+3*NSYM*(MAXOP-MINOP+1)
C Save offset to configuration arrays for later use:
      KCNFSTA=NTAB+1
C Configuration arrays:
      DO NOPN=MINOP,MIN(2*NORB-NEL,NEL,MAXOP)
       NCLS=(NEL-NOPN)/2
       IF(NCLS.LT.0) GOTO 19
       IF(2*NCLS+NOPN.NE.NEL) GOTO 19
       NOCC=NCLS+NOPN
       IF(NOCC.GT.NORB) GOTO 19
       DO ISYM=1,NSYM
        NCNF=0
        IF(LSYM.GE.1 .AND. LSYM.LE.NSYM) THEN
          IPOS=1+NOPN+(NOCC*(NOCC+1))/2
          NCNF=IWORK(LNCNF1-1+ISYM+NSYM*(IPOS-1))
        END IF
        LENCNF=NOCC
        IF(IFORM.EQ.2) LENCNF=NORB
        IF(IFORM.EQ.3) LENCNF=(NOCC+3)/4
        IF(IFORM.EQ.4) LENCNF=(NORB+14)/15
        NTAB=NTAB+NCNF*LENCNF
       END DO
  19   CONTINUE
      END DO
C Sizes and offsets are known. Now, we can allocate the table:
      CALL GETMEM('CnfTab','Allo','Inte',LTAB,NTAB)
      NEWCNFTAB=LTAB
C Enter header:
      IWORK(LTAB+ 0)=NTAB
      IWORK(LTAB+ 1)=37
      IWORK(LTAB+ 2)=NEL
      IWORK(LTAB+ 3)=NORB
      IWORK(LTAB+ 4)=MINOP
      IWORK(LTAB+ 5)=MAXOP
      IWORK(LTAB+ 6)=NSYM
      IWORK(LTAB+ 7)=LSYM
      IWORK(LTAB+ 8)=NGAS
      IWORK(LTAB+ 9)=IFORM
C Enter copy of NGASORB array:
      DO IGAS=1,NGAS
       ISUM=0
       DO ISYM=1,NSYM
        L=LTAB+10+ISYM+(NSYM+1)*IGAS
        IWORK(L)=NGASORB(ISYM,IGAS)
        ISUM=ISUM+NGASORB(ISYM,IGAS)
       END DO
       IWORK(LTAB+10+(NSYM+1)*IGAS)=ISUM
      END DO
      DO ISYM=0,NSYM
       ISUM=0
       DO IGAS=1,NGAS
        L=LTAB+10+ISYM+(NSYM+1)*IGAS
        ISUM=ISUM+IWORK(L)
       END DO
       IWORK(LTAB+10+ISYM)=ISUM
      END DO
      L=LTAB+9+(NSYM+1)*(NGAS+1)
C Enter copy of NGASLIM array:
      DO IGAS=1,NGAS
       L=L+1
       IWORK(L)=NGASLIM(1,IGAS)
       L=L+1
       IWORK(L)=NGASLIM(2,IGAS)
      END DO
C Construct and enter INFO table.
      LINFO=LTAB-1+KINFO
C The INFO table has a relative pointer to configuration arrays:
      KCNFEND=KCNFSTA-1
      DO NOPN=MINOP,MAXOP
       NCLS=(NEL-NOPN)/2
       IFPOSS=1
       IF(NCLS.LT.0) IFPOSS=0
       IF(2*NCLS+NOPN.NE.NEL) IFPOSS=0
       IF(NCLS+NOPN.GT.NORB) IFPOSS=0
       IF(IFPOSS.EQ.0) THEN
        DO ISYM=1,NSYM
C No such configuration is possible.
C INFO(1,ISYM,NOPN)=NCNF
         IWORK(LINFO+0+3*(ISYM-1+NSYM*(NOPN-MINOP)))=0
C INFO(2,ISYM,NOPN)=NTAB+1
         IWORK(LINFO+1+3*(ISYM-1+NSYM*(NOPN-MINOP)))=-1
C INFO(3,ISYM,NOPN)=LENCNF
         IWORK(LINFO+2+3*(ISYM-1+NSYM*(NOPN-MINOP)))=0
CTEST      write(*,'(1x,a,2I5)')' Test NOPN,ISYM:',NOPN,ISYM
CTEST      write(*,*)' Impossible configuration.'
CTEST      write(*,*)' Info array:'
CTEST      write(*,'(1x,3I8)')(IWORK(LINFO+I+
CTEST     &                   3*(ISYM-1+NSYM*(NOPN-MINOP))),I=0,2)
        END DO
       ELSE
        NOCC=NCLS+NOPN
        DO ISYM=1,NSYM
         NCNF=0
C If LSYM=0, all symmetry labels will be accepted. Else, only
C those with ISYM=LSYM.
         IF(LSYM.EQ.0 .OR. ISYM.EQ.LSYM) THEN
           IPOS=1+NOPN+(NOCC*(NOCC+1))/2
           NCNF=IWORK(LNCNF1-1+ISYM+NSYM*(IPOS-1))
         END IF
         IF(NCNF.EQ.0) THEN
C INFO(1,ISYM,NOPN)=NCNF
           IWORK(LINFO+0+3*(ISYM-1+NSYM*(NOPN-MINOP)))=0
C INFO(2,ISYM,NOPN)=NTAB+1
           IWORK(LINFO+1+3*(ISYM-1+NSYM*(NOPN-MINOP)))=-1
C INFO(3,ISYM,NOPN)=LENCNF
           IWORK(LINFO+2+3*(ISYM-1+NSYM*(NOPN-MINOP)))=0
         ELSE
           LENCNF=NOCC
           IF(IFORM.EQ.2) LENCNF=NORB
           IF(IFORM.EQ.3) LENCNF=(NOCC+3)/4
           IF(IFORM.EQ.4) LENCNF=(NORB+14)/15
C The relative pointer into this configuration array:
           KCNFSTA=KCNFEND+1
           KCNFEND=KCNFEND+NCNF*LENCNF
C INFO(1,ISYM,NOPN)=NCNF
           IWORK(LINFO+0+3*(ISYM-1+NSYM*(NOPN-MINOP)))=NCNF
C INFO(2,ISYM,NOPN)=NTAB+1
           IWORK(LINFO+1+3*(ISYM-1+NSYM*(NOPN-MINOP)))=KCNFSTA
C INFO(3,ISYM,NOPN)=LENCNF
           IWORK(LINFO+2+3*(ISYM-1+NSYM*(NOPN-MINOP)))=LENCNF
CTEST      write(*,'(1x,a,2I5)')' Test NOPN,ISYM:',NOPN,ISYM
CTEST      write(*,*)' Possible configuration.'
CTEST      write(*,*)' Info array:'
CTEST      write(*,'(1x,3I8)')(IWORK(LINFO+I+
CTEST     &                   3*(ISYM-1+NSYM*(NOPN-MINOP))),I=0,2)
           DO I=1,NCNF*LENCNF
             IWORK(LTAB-1+KCNFSTA-1+I)=0
           END DO
         END IF
        END DO
       END IF
      END DO
C The NCNF1 array is no longer needed.
      CALL GETMEM('NCnf1','Free','Inte',LNCNF1,NNCNF1)

C Finally, only now when we know where to store each (ISYM,NOPN) block of
C configurations, can we compute the actual configuration arrays:
      CALL MKCONF(IWORK(LTAB))

      RETURN
      END
      SUBROUTINE NRCNF1(MAXEL,NORB,NGAS,NGASLIM,
     &                  NGASORB,NCNF1,MXTMP,NCNF2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "symmul.fh"
      DIMENSION NCNF1( NSYM, ((MAXEL+1)*(MAXEL+2))/2 )
      DIMENSION NGASLIM(2,NGAS),NGASORB(NSYM,NGAS)
      DIMENSION NCNF2(NSYM, ((MXTMP+1)*(MXTMP+2))/2 )
C Returns the array NCNF1, which contains the number of
C configurations with the following criteria:
C    Orbital indices range from 1..NORB
C    GAS restrictions described by NGASLIM, NGASORB
C    Total number of electrons is at most MAXEL
C    NCLS closed-shell and NOPN open-shell orbitals
C    Symmetry label LSYM
C for all possible values of NCLS,NOPN and LSYM, stored as
C          NCNF1(LSYM,IPOS)
C with IPOS=(NOCC*(NOCC+1))/2+NOPN+1, NOCC=NCLS+NOPN,
C provided that 0<=NCLS, 0<=NOPN, and NOCC<=MIN(NORB,MAXEL).
C MXTMP=Max nr of orbitals in one GAS partition.
C Prerequisite: The orbital symmetry labels stored in ISM.
C               The GAS restriction arrays
C Method: Induction over GAS partitions.

      MAXOCC=MIN(MAXEL,NORB)
C Initialize:
      DO IPOS=1,((MAXOCC+1)*(MAXOCC+2))/2
       DO ISYM=1,NSYM
        NCNF1(ISYM,IPOS)=0
       END DO
      END DO
      NCNF1(1,1)=1
      CALL GETMEM('OrbSym','Allo','Inte',LISM,NORB)
C Max nr of occupied orbitals so far:
      NOCCMX=0
      DO IGAS=1,NGAS
        MXOCCOLD=NOCCMX
C Nr of orbitals in this partition
        NO=0
        II=0
        DO ISYM=1,NSYM
          NG=NGASORB(ISYM,IGAS)
          NO=NO+NG
          DO I=1,NG
           II=II+1
           IWORK(LISM-1+II)=ISYM
          END DO
        END DO
        NELMN=MAX(0,NGASLIM(1,IGAS))
        NELMX=MIN(2*NO,NGASLIM(2,IGAS))
C Possibilities within this partition:
CTEST      write(*,*)' In GAS partition nr IGAS=',IGAS
CTEST      write(*,*)' Prepare to call NRCNF2.'
CTEST      write(*,'(1x,a,8I5)')' Input data is: NO=',NO
CTEST      write(*,'(1x,a,8I5)')'              NSYM=',NSYM
CTEST      write(*,'(1x,a,8I5)')'               ISM=',
CTEST     &                       (IWORK(LISM-1+I),I=1,NO)
CTEST      write(*,*)' Call NRCNF2.'
        CALL NRCNF2(NO,IWORK(LISM),NCNF2)
CTEST      write(*,*)' Back from NRCNF2.'
CTEST      write(*,*)' The NCNF2 array:'
CTEST      ij=0
CTEST      do i=0,no
CTEST       do j=0,i
CTEST        ij=ij+1
CTEST        write(*,'(1x,2i5,5x,8i5)')i-j,j,(ncnf2(isym,ij),isym=1,nsym)
CTEST       end do
CTEST      end do

CTEST      write(*,*)' GAS partition nr IGAS=',IGAS
CTEST      write(*,*)' Before this partition, NCNF1 array is:'
CTEST      ij=0
CTEST      do i=0,noccmx
CTEST       do j=0,i
CTEST        ij=ij+1
CTEST        write(*,'(1x,2i5,5x,8i5)')i-j,j,(ncnf1(isym,ij),isym=1,nsym)
CTEST       end do
CTEST      end do

C Occupied and open within earlier+new partition:
CTEST        write(*,*)' New NOCCNW up to:',MIN(MAXOCC,MXOCCOLD+NELMX)
        DO NOCCNW=MIN(MAXOCC,MXOCCOLD+NELMX),0,-1
        DO NOPNNW=0,NOCCNW
         NCLSNW=NOCCNW-NOPNNW
         IPOSNW=(NOCCNW*(NOCCNW+1))/2+NOPNNW+1
         DO ISYMNW=1,NSYM
          NEW=0
CTEST        write(*,'(1x,a,3I4)')' NCLSNW,NOPNNW,ISYMNW:',
CTEST     &                                    NCLSNW,NOPNNW,ISYMNW
CTEST        write(*,*)' Add the following contributions:'
CTEST        write(*,*)' Limits on NOCC:',NELMN/2,MIN(NELMX,NO)
C Occupied and open within the GAS partition:
          DO NOCC=NELMN/2,MIN(NELMX,NO)
CTEST        write(*,*)' Limits on NOPN:',MAX(0,2*NOCC-NELMX),
CTEST     &                    MIN(2*NOCC-NELMN,NOCC,NELMX)
          DO NOPN=MAX(0,2*NOCC-NELMX),
     &                    MIN(2*NOCC-NELMN,NOCC,NELMX)
           NCLS=NOCC-NOPN
           IPOS=(NOCC*(NOCC+1))/2+NOPN+1
           DO ISYM=1,NSYM
            NY=NCNF2(ISYM,IPOS)
            IF(NY.EQ.0) GOTO 19
            NCLSOLD=NCLSNW-NCLS
            IF(NCLSOLD.LT.0) GOTO 19
            NOPNOLD=NOPNNW-NOPN
            IF(NOPNOLD.LT.0) GOTO 19
            NOCCOLD=NCLSOLD+NOPNOLD
            IF(NOCCOLD.GT.MXOCCOLD) GOTO 19
            ISYMOLD=MUL(ISYM,ISYMNW)
            IPOSOLD=(NOCCOLD*(NOCCOLD+1))/2+NOPNOLD+1
            NX=NCNF1(ISYMOLD,IPOSOLD)
            IF(NX.EQ.0) GOTO 19
C Test print:
CTEST        write(*,'(1x,a,5I4)')' NCLS,NOPN,ISYM,NCNF1,NCNF2:',
CTEST     &                            NCLS,NOPN,ISYM,NX,NY
C End of test prints
            NEW=NEW+NCNF1(ISYMOLD,IPOSOLD)*NCNF2(ISYM,IPOS)
            NOCCMX=MAX(NOCCNW,NOCCMX)
  19        CONTINUE
           END DO
          END DO
          END DO
          NCNF1(ISYMNW,IPOSNW)=NEW
         END DO
        END DO
        END DO

CTEST      write(*,*)' GAS partition nr IGAS=',IGAS
CTEST      write(*,*)' After this partition, NCNF1 array is:'
CTEST      ij=0
CTEST      do i=0,noccmx
CTEST       do j=0,i
CTEST        ij=ij+1
CTEST        write(*,'(1x,2i5,5x,8i5)')i-j,j,(ncnf1(isym,ij),isym=1,nsym)
CTEST       end do
CTEST      end do

      END DO
      CALL GETMEM('OrbSym','Free','Inte',LISM,NORB)
      RETURN
      END
      SUBROUTINE NRCNF2(NORB,ISM,NCNF2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "symmul.fh"
      DIMENSION NCNF2(NSYM, ((NORB+1)*(NORB+2))/2 )
      DIMENSION ISM(NORB)
C Returns the array NCNF2, which contains the number of
C (sub-)configurations with NCLS closed-shell and NOPN open-shell
C orbitals and having symmetry label LSYM, stored as
C          NCNF2(LSYM,IPOS)
C with IPOS=(NOCC*(NOCC+1))/2+NOPN+1, NOCC=NCLS+NOPN,
C provided that 0<=NCLS, 0<=NOPN, and NOCC<=NORB.
C Prerequisite: The orbital symmetry labels stored in ISM.
C Method: Induction

      DO IPOS=1,((NORB+1)*(NORB+2))/2
       DO ISYM=1,NSYM
        NCNF2(ISYM,IPOS)=0
       END DO
      END DO
      NCNF2(1,1)=1
      DO L=1,NORB
CTEST      write(*,*)' NRCNF2 level L=',L
CTEST      write(*,*)'  ISM(L)=',ISM(L)
        DO NOCC=L,1,-1
          DO NOPN=0,NOCC
            NCLS=NOCC-NOPN
CTEST      write(*,'(1x,a,8i5)')' NCLS,NOPN=',NCLS,NOPN
            IPOS1=(NOCC*(NOCC+1))/2+NOPN+1
            IPOS2=IPOS1-NOCC
            IPOS3=IPOS2-1
CTEST      write(*,'(1x,a,8i5)')' IPOS1,IPOS2,IPOS3:',IPOS1,IPOS2,IPOS3
CTEST      write(*,'(1x,a,8i5)')
CTEST     &         ' From last level:',(NCNF2(I,IPOS1),I=1,NSYM)
CTEST      if(ncls.gt.0) then
CTEST      write(*,'(1x,a,8i5)')
CTEST     &         ' Adding closed  :',(NCNF2(I,IPOS2),I=1,NSYM)
CTEST      end if
CTEST      if(nopn.gt.0) then
CTEST      write(*,'(1x,a,8i5)')
CTEST     &   ' Adding open    :',(NCNF2(MUL(ISM(L),I),IPOS3),I=1,NSYM)
CTEST      write(*,'(1x,a,8i5)')
CTEST     &   ' (Descrambled)  :',(NCNF2(I,IPOS3),I=1,NSYM)
CTEST      end if
            DO ISYM=1,NSYM
              NEW=NCNF2(ISYM,IPOS1)
              IF(NCLS.GT.0) NEW=NEW+NCNF2(ISYM,IPOS2)
              JSYM=MUL(ISM(L),ISYM)
              IF(NOPN.GT.0) NEW=NEW+NCNF2(JSYM,IPOS3)
              NCNF2(ISYM,IPOS1)=NEW
            END DO
CTEST      write(*,'(1x,a,8i5)')
CTEST     &         ' New result     :',(NCNF2(I,IPOS1),I=1,NSYM)
          END DO
        END DO
      END DO
      RETURN
      END
      SUBROUTINE MKCONF(ICNFTAB)
      IMPLICIT NONE

      INTEGER ICNFTAB(*)
      INTEGER NEL,MINOP,MAXOP,LSYM
      INTEGER MXPRT
      PARAMETER (MXPRT=150)
      INTEGER LIMPOP(2,MXPRT),LIMOP(2,MXPRT),LIMCL(2,MXPRT)
      INTEGER IOPDST(MXPRT),ICLDST(MXPRT),IOC(MXPRT),ICNF(MXPRT)
      INTEGER LIM1,LIM2,LIM1SUM,LIM2SUM,IGAS,NOR,IERR
      INTEGER MNOP,MXOP,MNCL,MXCL,NOPN,NCLS
      INTEGER INIT1,INIT2,M,MORE,NOP1,NCL2
      INTEGER ISYM,NORB,ICONF
      INTEGER IFORM,IR,ITYPE,IW,KCNFSTA,KGASLIM
      INTEGER KGASORB,KINFO,KPOS,LCLS,LENCNF,LISM,LOPN,NCNF
      INTEGER NCNFSYM(8),NGAS,NOCC,NTAB
      INTEGER I,J,K,IOFF,IO,IORB,N,NCL,NOP
#include "WrkSpc.fh"
#include "symmul.fh"
C     INTEGER MIN,MAX
      INTRINSIC MIN,MAX
      INTEGER IPOW4(0:15),IPOW256(0:3)
      DATA IPOW4 / 1,4,16,64,256,1024,4096,16384,65536,262144,1048576,
     &             4194304,16777216,67108864,268435456,1073741824 /
      DATA IPOW256 / 1,256,65536,16777216 /

      ITYPE=ICNFTAB(2)
      IF(ITYPE.NE.37) THEN
        WRITE(6,*)'MKCONF error: This is not a configuration table!'
        CALL ABEND()
      END IF
C Unbutton the CNF table.
      NTAB =ICNFTAB(1)
      NEL  =ICNFTAB(3)
      NORB =ICNFTAB(4)
      MINOP=ICNFTAB(5)
      MAXOP=ICNFTAB(6)
      NSYM =ICNFTAB(7)
      LSYM =ICNFTAB(8)
      NGAS =ICNFTAB(9)
      IFORM=ICNFTAB(10)
      KGASORB=11
      KGASLIM=KGASORB+(NSYM+1)*(NGAS+1)
C Check and refine the GAS limits:
      IF(NGAS.LE.0 .OR. NGAS.GT.MXPRT) THEN
         WRITE(6,*)' MKCONF ERROR: Nr of GAS partitions is out of'
         WRITE(6,*)' bounds. NGAS must be .GT.0 and .LT. MXPRT=',MXPRT
         WRITE(6,*)' Input argument NGAS is ',NGAS
         CALL ABEND()
      END IF
      LIM1SUM=0
      LIM2SUM=0
      NORB=0
      DO IGAS=1,NGAS
       NOR=ICNFTAB(KGASORB+(NSYM+1)*IGAS)
       IF(NOR.LT.0) IERR=1
       LIM1=MAX(0,ICNFTAB(KGASLIM+2*(IGAS-1)))
       LIM2=MIN(NEL,ICNFTAB(KGASLIM+1+2*(IGAS-1)),2*NOR)
       LIM1SUM=LIM1SUM+LIM1
       LIM2SUM=LIM2SUM+LIM2
       LIMPOP(1,IGAS)=LIM1
       LIMPOP(2,IGAS)=LIM2
       NORB=NORB+NOR
      END DO
      IERR=0
      DO IGAS=1,NGAS
       LIM1=MAX(LIMPOP(1,IGAS),NEL-(LIM2SUM-LIMPOP(2,IGAS)))
       LIM2=MIN(LIMPOP(2,IGAS),NEL-(LIM1SUM-LIMPOP(1,IGAS)))
       LIMPOP(1,IGAS)=LIM1
       LIMPOP(2,IGAS)=LIM2
       IF(LIM1.GT.LIM2) IERR=1
      END DO
      IF(IERR.GT.0) THEN
         WRITE(6,*)' MKCONF ERROR: The input GAS restrictions are'
         WRITE(6,*)' impossible to meet. No configurations are'
         WRITE(6,*)' generated. The program stops here.'
         WRITE(6,'(1X,A,I2)')' Number of GAS partitions:',NGAS
         WRITE(6,'(1X,A,50I3)')' Partition:',(IGAS,IGAS=1,NGAS)
         WRITE(6,'(1X,A,50I3)')' NGASORB:  ',
     &             (ICNFTAB(KGASORB+(NSYM+1)*IGAS),IGAS=1,NGAS)
         WRITE(6,'(1X,A,50I3)')'NGASLIM(1):',
     &              (ICNFTAB(KGASLIM  +2*(IGAS-1)),IGAS=1,NGAS)
         WRITE(6,'(1X,A,50I3)')'NGASLIM(2):',
     &              (ICNFTAB(KGASLIM+1+2*(IGAS-1)),IGAS=1,NGAS)
         WRITE(6,'(1X,A,I2)')' Number of electrons:',NEL
         CALL ABEND()
      END IF
      IF(NEL.LT.0 .OR. NEL.GT.2*NORB) THEN
         WRITE(6,*)' MKCONF ERROR: Nr of electrons is out of bounds.'
         WRITE(6,*)' NEL must be .GT.0 and .LT. 2*NORB=',2*NORB
         WRITE(6,*)' Input argument NEL is ',NEL
         CALL ABEND()
      END IF
C Array for orbital symmetry:
      CALL GETMEM('OrbSym','Allo','Inte',LISM,NORB)
C Initialize table with orbital symmetry.
      IORB=0
      DO IGAS=1,NGAS
       DO ISYM=1,NSYM
        N=ICNFTAB(KGASORB+ISYM+(NSYM+1)*IGAS)
        DO K=1,N
         IORB=IORB+1
         IWORK(LISM-1+IORB)=ISYM
        END DO
       END DO
      END DO
C INFO table inside ICNFTAB:
      KINFO=KGASLIM+2*NGAS
C Note: Nr of conf, their position and length can now be accessed as:
C      NCNF   =ICNFTAB(KINFO+0+3*(ISYM-1+NSYM*(NOPN-MINOP)))
C      KCNFSTA=ICNFTAB(KINFO+1+3*(ISYM-1+NSYM*(NOPN-MINOP)))
C      LENCNF =ICNFTAB(KINFO+2+3*(ISYM-1+NSYM*(NOPN-MINOP)))
C Make a list of possible number of open shells in each partition:
      DO IGAS=1,NGAS
       NOR=ICNFTAB(KGASORB+(NSYM+1)*IGAS)
       MNOP=1
       MXOP=0
       DO I=LIMPOP(1,IGAS),LIMPOP(2,IGAS)
        MNOP=MIN(MNOP,MOD(I,2))
        MXOP=MAX(MXOP,MIN(I,2*NOR-I))
       END DO
       LIMOP(1,IGAS)=MNOP
       LIMOP(2,IGAS)=MXOP
      END DO
C Counter of configurations:
      ICONF=0
C Loop over the requested range of open shells:
      DO NOPN=MINOP,MAXOP
       NCLS=(NEL-NOPN)/2
       IF(NCLS.LT.0) GOTO 120
       IF(2*NCLS+NOPN.NE.NEL) GOTO 120
C Size of each entry in the configuration table:
       NOCC=NCLS+NOPN
       LENCNF=NOCC
       IF(IFORM.EQ.2) LENCNF=NORB
       IF(IFORM.EQ.3) LENCNF=(NOCC+3)/4
       IF(IFORM.EQ.4) LENCNF=(NORB+14)/15
C Counter of configurations/symmetry for this nr of open shells:
       DO ISYM=1,NSYM
        NCNFSYM(ISYM)=0
       END DO
C Loop over all ways of distributing NOPN open shells among
C the partitions. First make a start distribution:
       INIT1=NGAS
       NOP1=NOPN
  10   CONTINUE
C Create the lexically lowest distribution with NOP1 open
C shells among the INIT1 lowest partitions, and
C increment the next higher partition (if any).
C Let M=Max tot nr of open shells in lower partitions.
       IF(INIT1.LT.NGAS) IOPDST(INIT1+1)=IOPDST(INIT1+1)+1
       M=NOP1
       DO IGAS=INIT1,1,-1
        M=M-LIMOP(1,IGAS)
       END DO
       IF(M.LT.0) GOTO 120
C But actually, we start with zero. So M open shells must be
C distributed in excess of the allowed minimum, among the INIT1
C partitions.
       DO IGAS=1,INIT1
        MORE=MIN(LIMOP(2,IGAS)-LIMOP(1,IGAS),M)
        IOPDST(IGAS)=LIMOP(1,IGAS)+MORE
        M=M-MORE
       END DO
       IF(M.GT.0) GOTO 120
C At this point of the code, all possible distributions of
C open shells will be generated. Use them.
CTEST      write(*,*)' Try this IOPDST distribution:'
CTEST      write(*,'(1x,a,50i3)')
CTEST     &          ' IOPDST(IGAS):',(IOPDST(IGAS),IGAS=1,NGAS)
C First, use it to generate a table of limits for the distribution
C of closed shells:
      DO IGAS=1,NGAS
       NOP=IOPDST(IGAS)
       NOR=ICNFTAB(KGASORB+(NSYM+1)*IGAS)-NOP
       LIM1=MAX(0,(LIMPOP(1,IGAS)-NOP)/2)
       LIM2=MIN(NOR,(LIMPOP(2,IGAS)-NOP)/2)
       IF(LIM1.GT.LIM2) GOTO 110
       MNCL=LIM2
       MXCL=LIM1
       DO I=LIM1,LIM2
        N=2*I+NOP
        IF(N.GE.LIMPOP(1,IGAS) .AND. N.LE.LIMPOP(2,IGAS)) THEN
         MNCL=MIN(MNCL,I)
         MXCL=MAX(MXCL,I)
        END IF
       END DO
       IF(MNCL.GT.MXCL) GOTO 110
       LIMCL(1,IGAS)=MNCL
       LIMCL(2,IGAS)=MXCL
      END DO
CTEST      write(*,'(1x,a,20i3)')
CTEST     &          'LIMCL(1,IGAS):',(LIMCL(1,IGAS),IGAS=1,NGAS)
CTEST      write(*,'(1x,a,50i3)')
CTEST     &          'LIMCL(2,IGAS):',(LIMCL(2,IGAS),IGAS=1,NGAS)

C Loop over all possible ways of distributing NCLS closed shells
C among  the partitions, subject to restrictions.
C In order to create the start distribution:
      INIT2=NGAS
      NCL2=(NEL-NOPN)/2
  20  CONTINUE
C Create the lexically lowest distribution with NCL2 closed shells
C among the INIT2 lowest partitions, and increment the next higher
C partition (if any).
      IF(INIT2.LT.NGAS) ICLDST(INIT2+1)=ICLDST(INIT2+1)+1
      M=NCL2
      DO IGAS=INIT2,1,-1
       M=M-LIMCL(1,IGAS)
      END DO
      IF(M.LT.0) GOTO 110
      DO IGAS=1,INIT2
       MORE=MIN(LIMCL(2,IGAS)-LIMCL(1,IGAS),M)
       ICLDST(IGAS)=LIMCL(1,IGAS)+MORE
       M=M-MORE
      END DO
      IF(M.GT.0) GOTO 110
C Here follows code to use this population distribution.
C Initialize the configuration subarrays of partitions nr
C 1..NGAS, within this population distribution:
CTEST      write(*,*)' New distribution of open/closed shells among'
CTEST      write(*,*)' the GAS spaces is:'
CTEST      write(*,'(1x,a,50i3)')
CTEST     &          ' IOPDST(IGAS):',(IOPDST(IGAS),IGAS=1,NGAS)
CTEST      write(*,'(1x,a,50i3)')
CTEST     &          ' ICLDST(IGAS):',(ICLDST(IGAS),IGAS=1,NGAS)
      IORB=0
      DO IGAS=1,NGAS
       NCL=ICLDST(IGAS)
       DO I=1,NCL
        IORB=IORB+1
        IOC(IORB)=2
       END DO
       NOP=IOPDST(IGAS)
       DO I=1,NOP
        IORB=IORB+1
        IOC(IORB)=1
       END DO
       NOR=ICNFTAB(KGASORB+(NSYM+1)*IGAS)
       DO I=1,NOR-NCL-NOP
        IORB=IORB+1
        IOC(IORB)=0
       END DO
      END DO
  30  CONTINUE
C Here finally we will get all possible configurations, restricted
C by the population arrays. Screening by combined symmetry:
CTEST      write(*,'(1x,a,50I3)')' New config:',(ioc(io),io=1,norb)
CTEST      write(*,*)' Where should it go??'
      ISYM=1
      DO IO=1,NORB
       IF(IOC(IO).EQ.1) ISYM=MUL(IWORK(LISM-1+IO),ISYM)
      END DO
CTEST      write(*,*)' Symmetry ISYM=',ISYM
C Skip if wrong symmetry:
      IF (LSYM.GT.0 .AND. ISYM.NE.LSYM) GOTO 99
CTEST      write(*,*)' Keep it!'
      ICONF=ICONF+1
CTEST      write(*,*)' This is configuration nr ICONF=',ICONF
C Put this configuration into the ICNFTAB table.
C First, determine where it should go:
      N=NCNFSYM(ISYM)
CTEST      write(*,*)' Earlier nr of conf in this symm & nopn:',N
      NCNFSYM(ISYM)=N+1
CTEST      write(*,*)' New value NCNFSYM(ISYM)=',NCNFSYM(ISYM)
      KCNFSTA=ICNFTAB(KINFO+1+3*(ISYM-1+NSYM*(NOPN-MINOP)))
      KPOS=KCNFSTA+N*LENCNF
      IF(KPOS+LENCNF-1.GT.NTAB) THEN
        WRITE(6,*)' MKCONF error: Table overflow.'
        WRITE(6,*)'KCNFSTA:',KCNFSTA
        WRITE(6,*)' LENCNF:',LENCNF
        WRITE(6,*)'   KPOS:',KPOS
        WRITE(6,*)'   NTAB:',NTAB
        CALL ABEND()
      END IF
C Put together configuration array in standard format:
        LCLS=1
        LOPN=NCLS+1
        DO IO=1,NORB
         N=IOC(IO)
         IF(N.EQ.1) THEN
           ICNF(LOPN)=IO
           LOPN=LOPN+1
         ELSE IF(N.EQ.2) THEN
           ICNF(LCLS)=IO
           LCLS=LCLS+1
         END IF
        END DO
C Add this configuration to the configuration table:
CTEST      write(*,*)' Add configuration to conf table.'
        IF(IFORM.EQ.1) THEN
          DO I=1,NOCC
            ICNFTAB(KPOS-1+I)=ICNF(I)
          END DO
        ELSE IF(IFORM.EQ.3) THEN
          DO I=1,NOCC
           IW=(3+I)/4
           IR=(3+I)-4*IW
           IF(IR.EQ.0) THEN
            ICNFTAB(KPOS-1+IW)=ICNF(I)
           ELSE
            ICNFTAB(KPOS-1+IW)=ICNFTAB(KPOS-1+IW)+
     &                   IPOW256(IR)*ICNF(I)
           END IF
          END DO
        ELSE
          IF(IFORM.EQ.2) THEN
            DO I=1,NORB
              ICNFTAB(KPOS-1+I)=IOC(I)
            END DO
          ELSE IF(IFORM.EQ.4) THEN
            DO I=1,NORB
             IW=(14+I)/15
             IR=(14+I)-15*IW
             IF(IR.EQ.0) THEN
              ICNFTAB(KPOS-1+IW)=IOC(I)
             ELSE
              ICNFTAB(KPOS-1+IW)=ICNFTAB(KPOS-1+IW)+
     &                     IPOW4(IR)*IOC(I)

             END IF
            END DO
          END IF
        END IF

  99  CONTINUE
C Get next configuration.
CTEST      write(*,*)' 99 CONTINUE: Get next conf (if any).'
      IOFF=0
      DO IGAS=1,NGAS
       NOR=ICNFTAB(KGASORB+(NSYM+1)*IGAS)
CTEST      write(*,*)'   Is there a new permut in IGAS',IGAS
C Try to find next permutation within this partition:
       DO K=2,NOR
        IF(IOC(IOFF+K-1).GT.IOC(IOFF+K)) THEN
         DO I=1,(K-1)/2
          J=IOC(IOFF+I)
          IOC(IOFF+I)=IOC(IOFF+K-I)
          IOC(IOFF+K-I)=J
         END DO
         DO I=K-1,1,-1
          IF(IOC(IOFF+I).GT.IOC(IOFF+K)) THEN
           J=IOC(IOFF+I)
           IOC(IOFF+I)=IOC(IOFF+K)
           IOC(IOFF+K)=J
CTEST      write(*,*)'   Yes there is! GOTO 30.'
C OK, the next permutation has been obtained.
           GOTO 30
          END IF
         END DO
        END IF
       END DO
CTEST      write(*,*)'   No, there is not. Reset IGAS',IGAS
C Not possible. Reset permutation in this partition, and
C then try the next one:
       N=ICLDST(IGAS)
       M=IOPDST(IGAS)
       DO IO=1,N
        IOC(IOFF+IO)=2
       END DO
       DO IO=N+1,N+M
        IOC(IOFF+IO)=1
       END DO
       DO IO=N+M+1,NOR
        IOC(IOFF+IO)=0
       END DO
       IOFF=IOFF+NOR
      END DO
CTEST      write(*,*)' There is no more, with this distrib.'
C All failed. No more configurations with this distribution of
C closed and open shells.
C Next ICLDST distribution. First find the first increasable index:
      M=0
      NCL2=-1
      DO IGAS=1,NGAS
       INIT2=IGAS-1
       IF(M.GT.0 .AND. ICLDST(IGAS).LT.LIMCL(2,IGAS)) GOTO 20
       M=M+ICLDST(IGAS)-LIMCL(1,IGAS)
       NCL2=NCL2+ICLDST(IGAS)
      END DO
CTEST      write(*,*)' No more ICLDST distribution.'
C No more ICLDST distribution is possible.
 110  CONTINUE
C Next IOPDST distribution. First find the first increasable index:
C That is the first partition with less than LIMOP(2,IGAS) open
C shells, above partitions with nonzero excess number M.
      M=0
      NOP1=-1
      DO IGAS=1,NGAS
       INIT1=IGAS-1
       IF(M.GT.0 .AND. IOPDST(IGAS).LT.LIMOP(2,IGAS)) GOTO 10
       M=M+IOPDST(IGAS)-LIMOP(1,IGAS)
       NOP1=NOP1+IOPDST(IGAS)
      END DO
CTEST      write(*,*)' No more IOPDST distribution.'
CTEST      write(*,*)' There is no more distribution possible.'
CTEST      write(*,*)' Test NCNFSYM(ISYM) vs. INFO:'
CTEST      write(*,'(1x,a,8I5)')'ICNFTAB(KINFO+...):',
CTEST     &  (ICNFTAB(KINFO+3*(ISYM-1+NSYM*(NOPN-MINOP))),ISYM=1,NSYM)
CTEST      write(*,'(1x,a,8I5)')'     NCNFSYM(ISYM):',
CTEST     &                                (NCNFSYM(ISYM),ISYM=1,NSYM)
C Temporary check: Has everything worked perfectly??
      IERR=0
      DO ISYM=1,NSYM
        N=ICNFTAB(KINFO  +3*(ISYM-1+NSYM*(NOPN-MINOP)))
        IF(NCNFSYM(ISYM).NE.N) IERR=1
      END DO
      IF(IERR.NE.0) GOTO 900
C No more IOPDST distribution is possible. Next NOPN value:
 120  CONTINUE
      END DO

      CALL GETMEM('OrbSym','Free','Inte',LISM,NORB)
      RETURN
 900  CONTINUE
      WRITE(6,*)' MKCNF ERROR: Unforeseen calamity.'
      WRITE(6,*)' At end of loop over NOPN, the number of'
      WRITE(6,*)' configurations generated does not match'
      WRITE(6,*)' that which was allocated.'
      WRITE(6,*)' INFO table in ICNFTAB says:'
      WRITE(6,*)
      WRITE(6,*)'  NOPN ISYM       Nr of conf Start point'//
     &             '  Words/config'
      DO NOPN=MINOP,MAXOP
       NCLS=(NEL-NOPN)/2
       NOCC=NCLS+NOPN
       DO ISYM=1,NSYM
        NCNF=ICNFTAB(KINFO+0+3*(ISYM-1+NSYM*(NOPN-MINOP)))
        KCNFSTA=ICNFTAB(KINFO+1+3*(ISYM-1+NSYM*(NOPN-MINOP)))
        LENCNF=ICNFTAB(KINFO+2+3*(ISYM-1+NSYM*(NOPN-MINOP)))
        WRITE(6,'(1X,2I4,5X,3I12)') NOPN,ISYM,NCNF,KCNFSTA,LENCNF
       END DO
      END DO
      CALL ABEND()
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  CIDAXPY := Analogous to the blas routine DAXPY                     *
!*                                                                     *
!***********************************************************************
subroutine cidaxpy_cvb(fac,cvec1,cvec2)

use casvb_global, only: icnt_ci, iform_ci, ndet
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: fac
real(kind=wp), intent(in) :: cvec1(0:ndet)
real(kind=wp), intent(inout) :: cvec2(0:ndet)
integer(kind=iwp) :: iformat, ivec1, ivec2

ivec1 = nint(cvec1(0))
ivec2 = nint(cvec2(0))
iformat = iform_ci(ivec1)
if (iformat == 0) then
  cvec2(1:) = cvec2(1:)+fac*cvec1(1:)
else
  write(u6,*) ' Unsupported format in CIDAXPY :',iformat
  call abend_cvb()
end if
icnt_ci(ivec2) = 0

return

end subroutine cidaxpy_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Gamma_Blocks(iTable,nBlocks,nIrrep)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nBlocks, nIrrep
integer(kind=iwp), intent(out) :: iTable(6,nBlocks)
integer(kind=iwp) :: iBlock, IBOT, idid(8), IND, IRREP, IRREP1, IRREP2, IRREP3, IRREP4, ITMP

iBlock = 0

! Observe the loop ordering straight from GAMSRT in Aces 2.
! THIS LOOP ORDER DOES NOT COMPLY WITH THE MANUAL!

! AAAA

!write(u6,*) 'AAAA'
IND = 0
do IRREP=1,NIRREP
  IND = IND+1
  iBlock = iBlock+1
  iTable(1,iBlock) = 1
  iTable(2:5,iBlock) = IRREP-1
  iTable(6,iBlock) = IND
  !write(u6,*) IND,IRREP-1,IRREP-1,IRREP-1,IRREP-1
end do

! AABB

!write(u6,*) 'AABB'
IND = 0
do IRREP1=2,NIRREP
  do IRREP2=1,IRREP1-1
    IND = IND+1
    iBlock = iBlock+1
    iTable(1,iBlock) = 2
    iTable(2:3,iBlock) = IRREP2-1
    iTable(4:5,iBlock) = IRREP1-1
    iTable(6,iBlock) = IND
    !write(u6,*) IND,IRREP2-1,IRREP2-1,IRREP1-1,IRREP1-1
  end do
end do

! ABAB

!write(u6,*) 'ABAB'
IND = 0
do IRREP=2,NIRREP
  do IRREP1=1,NIRREP
    IRREP2 = ieor(IRREP-1,IRREP1-1)+1
    if (IRREP2 > IRREP1) then
      IND = IND+1
      iBlock = iBlock+1
      iTable(1,iBlock) = 3
      iTable(2:4:2,iBlock) = IRREP1-1
      iTable(3:5:2,iBlock) = IRREP2-1
      iTable(6,iBlock) = IND
      !write(u6,*) IND,IRREP1-1,IRREP2-1,IRREP1-1,IRREP2-1
    end if
  end do
end do

! ABCD

!write(u6,*) 'ABCD'
IND = 0
do IRREP=2,NIRREP
  do IRREP1=1,NIRREP
    IRREP2 = ieor(IRREP-1,IRREP1-1)+1
    if (IRREP2 < IRREP1) cycle
    IBOT = max(IRREP1,IRREP2)+1
    IDID(:) = 0
    do ITMP=IBOT,NIRREP
      IRREP4 = ieor(ITMP-1,IRREP-1)+1
      IRREP3 = min(ITMP,IRREP4)
      IRREP4 = max(ITMP,IRREP4)
      if (max(IDID(IRREP4),IDID(IRREP3)) /= 0) cycle
      IDID(IRREP3) = 1
      IDID(IRREP4) = 1
      IND = IND+1
      iBlock = iBlock+1
      iTable(1,iBlock) = 4
      iTable(2,iBlock) = IRREP3-1
      iTable(3,iBlock) = IRREP4-1
      iTable(4,iBlock) = IRREP1-1
      iTable(5,iBlock) = IRREP2-1
      iTable(6,iBlock) = IND
      !write(u6,*) IND,IRREP3-1,IRREP4-1,IRREP1-1,IRREP2-1
    end do
  end do
end do

end subroutine Gamma_Blocks

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Rsv_Tsk2(id,kls)

use RI_glob, only: iOpt, iRsv, nTask, TskList
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp) :: Rsv_Tsk2
integer(kind=iwp), intent(in) :: id
integer(kind=iwp), intent(out) :: kls
logical(kind=iwp), external :: Rsv_Tsk

if (iOpt == 0) then
  Rsv_Tsk2 = Rsv_Tsk(id,kls)
else if (iOpt == 1) then
  Rsv_Tsk2 = .true.
  if (iRsv > nTask) then
    Rsv_Tsk2 = .false.
  else
    kls = TskList(iRsv)
    iRsv = iRsv+1
    if (kls <= 0) Rsv_Tsk2 = .false.
    if (kls > nTask) Rsv_Tsk2 = .false.
  end if
else
  Rsv_Tsk2 = .false.
  call WarningMessage(2,'Error in Rsv_Tsk2')
  write(u6,*) 'Rsv_Tsk2: illegal iOpt value!'
  call Abend()
end if

return

end function Rsv_Tsk2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,2020,  Roland Lindh                               *
!               1990, IBM                                              *
!               1993, Per Boussard                                     *
!***********************************************************************
!***********************************************************************
!                                                                      *
!    Objective: To read ECP information, excluding the valence basis-  *
!               set. This means that we read (from input stream) the   *
!               effective charge, the model potential terms (M1 and    *
!               M2), projection parameters and projection orbital      *
!               basis-set (exponents and coefficients)                 *
!                                                                      *
! Called from: Input                                                   *
!                                                                      *
! Calling    : RecPrt                                                  *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!                                                                      *
!     Modified: Per Boussard -93.                                      *
!***********************************************************************

subroutine GetECP(lUnit,iShll,nProj,UnNorm)

use Basis_Info, only: dbsc, nCnttp, Shells
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: lUnit
integer(kind=iwp), intent(inout) :: iShll
integer(kind=iwp), intent(out) :: nProj
logical(kind=iwp), intent(in) :: UnNorm
#include "Molcas.fh"
integer(kind=iwp) :: i, iAng, iEE, ierr, iPP, iPrim, iSS, iStrt, jcr, kcr, mPP(2), n_Elec, n_Occ, nCntrc, ncr, nExpi, nM1, nM2, &
                     nPrim
real(kind=wp) :: ccr, zcr
character(len=180) :: Line
real(kind=wp), allocatable :: Scrt1(:), Scrt2(:)
character(len=180), external :: Get_Ln

!                                                                      *
!***********************************************************************
!                                                                      *
! Process Pseudo Potentials

Line = Get_Ln(lUnit)

if (index(Line,'PP') /= 0) then

  dbsc(nCnttp)%iPP = iShll+1

  !write(u6,*) 'Line=',Line
  if (index(Line,'PPSO') /= 0) then
    call Get_i(4,mPP,2)
  else
    call Get_i(4,mPP,1)
    mPP(2) = 0
  end if
  !write(u6,*) 'mPP=',mPP
  dbsc(nCnttp)%nPP = 1+mPP(1)+mPP(2)

  do iPP=0,mPP(1)
    iShll = iShll+1
    !write(u6,*) 'iPP,dbsc(nCnttp)%nPP=',iPP,dbsc(nCnttp)%nPP
    if (iShll > MxShll) then
      call WarningMessage(2,'Abend in GetECP: Increase MxShll')
      call Abend()
    end if

    ! Pick up the number of terms in the shell
    Line = Get_Ln(lUnit)
    !write(u6,*) 'Line=',Line
    call Get_i1(1,kcr)
    !write(u6,*) 'kcr,iShll=',kcr,iShll
    Shells(iShll)%nExp = 3*kcr
    call mma_allocate(Shells(iShll)%Exp,3*kcr,Label='Exp')

    iStrt = 1
    do jcr=1,kcr
      Line = Get_Ln(lUnit)

      call Get_I1(1,ncr)
      !write(u6,*) 'ncr=',ncr
      Shells(iShll)%Exp(iStrt) = real(ncr,kind=wp)
      iStrt = iStrt+1
      call Get_F1(2,zcr)
      !write(u6,*) 'zcr=',zcr
      Shells(iShll)%Exp(iStrt) = zcr
      iStrt = iStrt+1
      call Get_F1(3,ccr)
      !write(u6,*) 'ccr=',ccr
      Shells(iShll)%Exp(iStrt) = ccr
      iStrt = iStrt+1
    end do

  end do
  do iPP=1,mPP(2)
    iShll = iShll+1
    !write(u6,*) 'iPP,dbsc(nCnttp)%nPP=',iPP,dbsc(nCnttp)%nPP
    if (iShll > MxShll) then
      call ErrTra()
      write(u6,*) 'Abend in GetECP: Increase MxShll'
      call Abend()
    end if

    ! Pick up the number of terms in the shell
    Line = Get_Ln(lUnit)
    !write(u6,*) 'Line=',Line
    call Get_i1(1,kcr)
    !write(u6,*) 'kcr,iShll=',kcr,iShll
    Shells(iShll)%nExp = 3*kcr
    call mma_allocate(Shells(iShll)%Exp,3*kcr,Label='Exp')

    iStrt = 1
    do jcr=1,kcr
      Line = Get_Ln(lUnit)

      call Get_I1(1,ncr)
      !write(u6,*) 'ncr=',ncr
      ncr = ncr+1000
      Shells(iShll)%Exp(iStrt) = real(ncr,kind=wp)
      iStrt = iStrt+1
      call Get_F1(2,zcr)
      !write(u6,*) 'zcr=',zcr
      Shells(iShll)%Exp(iStrt) = zcr
      iStrt = iStrt+1
      call Get_F1(3,ccr)
      !write(u6,*) 'ccr=',ccr
      Shells(iShll)%Exp(iStrt) = ccr
      iStrt = iStrt+1
    end do

  end do
  !write(u6,*) 'Done'

  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! M1 section

!write(u6,*) ' Reading M1'
if (index(Line,'M1') == 0) then
  call WarningMessage(2,'ERROR: Keyword M1 expected, offending line : '//Line)
  call Quit_OnUserError()
end if
Line = Get_Ln(lUnit)
call Get_i1(1,nM1)
dbsc(nCnttp)%nM1 = nM1
if (nM1 > 0) then
  call mma_allocate(dbsc(nCnttp)%M1xp,nM1,Label='dbsc:M1xp')
  call mma_allocate(dbsc(nCnttp)%M1cf,nM1,Label='dbsc:M1cf')
  call Read_v(lUnit,dbsc(nCnttp)%M1xp,1,nM1,1,ierr)
  call Read_v(lUnit,dbsc(nCnttp)%M1cf,1,nM1,1,ierr)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! M2 section

!write(u6,*) ' Reading M2'
Line = Get_Ln(lUnit)
if (index(Line,'M2') == 0) then
  call WarningMessage(2,'ERROR: Keyword M2 expected, offending line : '//Line)
  call Quit_OnUserError()
end if
Line = Get_Ln(lUnit)
call Get_i1(1,nM2)
dbsc(nCnttp)%nM2 = nM2
if (nM2 > 0) then
  call mma_allocate(dbsc(nCnttp)%M2xp,nM2,Label='dbsc:M2xp')
  call mma_allocate(dbsc(nCnttp)%M2cf,nM2,Label='dbsc:M2cf')
  call Read_v(lUnit,dbsc(nCnttp)%M2xp,1,nM2,1,ierr)
  call Read_v(lUnit,dbsc(nCnttp)%M2cf,1,nM2,1,ierr)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Read core-repulsion parameter

!write(u6,*) ' Reading Core-repulsion'
Line = Get_Ln(lUnit)
if (index(Line,'COREREP') == 0) then
  call WarningMessage(2,'ERROR: Keyword COREREP expected, offending line : '//Line)
  call Quit_OnUserError()
end if
Line = Get_Ln(lUnit)
call Get_F1(1,dbsc(nCnttp)%CrRep)
!                                                                      *
!***********************************************************************
!                                                                      *
! Now read Projection parameters

!write(u6,*) ' Reading projection operator'
Line = Get_Ln(lUnit)
if (index(Line,'PROJOP') == 0) then
  call WarningMessage(2,'ERROR: Keyword PROJOP expected, offending line : '//Line)
  call Quit_OnUserError()
end if

! Now read projection basis set
! Loop over each shell type (s,p,d,etc....)
! The ECP is assumed to contain s,p,d and f functions,
! Read(Line,*,Err=993) nProj
Line = Get_Ln(lUnit)
call Get_I1(1,nProj)

if (nProj < 0) return
do iAng=0,nProj
  !write(u6,*) ' iAng=',iAng
  n_Elec = 2*(2*iAng+1)
  iShll = iShll+1
  if (iShll > MxShll) then
    call WarningMessage(2,'Abend in GetECP: Increase MxShll')
    call Quit_OnUserError()
  end if
  !read(Line,*,Err=993) nPrim, nCntrc
  Line = Get_Ln(lUnit)
  call Get_I1(1,nPrim)
  call Get_i1(2,nCntrc)

  Shells(iShll)%nExp = nPrim
  Shells(iShll)%nBasis = nCntrc

  ! Check if occupation number is included on the line

  iSS = 1
  call NxtWrd(Line,iSS,iEE)
  iSS = iEE+1
  call NxtWrd(Line,iSS,iEE)
  iSS = iEE+1
  call NxtWrd(Line,iSS,iEE)
  call mma_allocate(Shells(iShll)%Occ,nCntrc,Label='Occ')
  if (iEE > 0) then
    do i=1,nCntrc
      call Get_i1(2+i,n_Occ)
      Shells(iShll)%Occ(i) = real(n_Occ,kind=wp)/real(n_Elec,kind=wp)
      !write(u6,*) 'n_Occ=',n_Occ
    end do
  else
    Shells(iShll)%Occ(:) = One
  end if

  ! Read "orbital energies"

  !write(u6,*) ' Reading Bk'
  call mma_allocate(Shells(iShll)%Bk,nCntrc,Label='Bk')
  Shells(iShll)%nBk = nCntrc
  if (nCntrc > 0) call Read_v(lUnit,Shells(iShll)%Bk,1,nCntrc,1,ierr)
  if (ierr /= 0) then
    call WarningMessage(2,'Abend in GetBS: Error while reading the exponents')
    call Quit_OnUserError()
  end if

  ! Read gaussian EXPonents

  !write(u6,*) ' Reading Exponents'
  call mma_allocate(Shells(iShll)%Exp,nPrim,Label='Exp')
  Shells(iShll)%nExp = nPrim
  if (nPrim > 0) call Read_v(lUnit,Shells(iShll)%Exp,1,nPrim,1,ierr)
  if (ierr /= 0) then
    call WarningMessage(2,'Abend in GetBS: Error while reading the exponents')
    call Quit_OnUserError()
  end if
  !call RecPrt(' Exponents',Shells(iShll)%nExp,nPrim,1)
  call mma_allocate(Shells(iShll)%Cff_c,nPrim,nCntrc,2,Label='Cff_c')
  call mma_allocate(Shells(iShll)%pCff,nPrim,nCntrc,Label='pCff')
  call mma_allocate(Shells(iShll)%Cff_p,nPrim,nPrim,2,Label='Cff_p')
  Shells(iShll)%Cff_p(:,:,:) = Zero  ! dummy assign
  Shells(iShll)%nBasis = nCntrc

  ! Read contraction coefficients
  ! Observe that the matrix will have nPrim rows and nCntrc columns

  !write(u6,*) ' Reading coefficients'
  do iPrim=1,nPrim
    call Read_v(lUnit,Shells(iShll)%Cff_c,iPrim,nPrim*nCntrc,nPrim,ierr)
    if (ierr /= 0) then
      call WarningMessage(2,'Abend in GetBS: Error while reading the coefficients')
      call Quit_OnUserError()
    end if
  end do

  ! Renormalize

  call mma_allocate(Scrt1,nPrim**2)
  call mma_allocate(Scrt2,nPrim*nCntrc)
  call Nrmlx(Shells(iShll)%Exp,nPrim,Shells(iShll)%Cff_c(1,1,1),nCntrc,Scrt1,nPrim**2,Scrt2,nPrim*nCntrc,iAng)
  call mma_deallocate(Scrt1)
  call mma_deallocate(Scrt2)

  ! Duplicate!

  Shells(iShll)%Cff_c(:,:,2) = Shells(iShll)%Cff_c(:,:,1)

  if (.not. UnNorm) then
    nExpi = Shells(iShll)%nExp
    if (nExpi*Shells(iShll)%nBasis >= 1) then
      call Nrmlz(Shells(iShll)%Exp,nExpi,Shells(iShll)%Cff_c(1,1,1),Shells(iShll)%nBasis,iAng)
    end if
  end if
  Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)

end do

return

end subroutine GetECP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1992, Roland Lindh                                *
!               1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine Inputh(Run_MCLR)
!***********************************************************************
!                                                                      *
! Object: input module for the gradient code                           *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             September 1991                                           *
!                                                                      *
!             Modified to complement GetInf, January 1992              *
!***********************************************************************

use McKinley_global, only: lGrd, lHss, nFck, Nona, PreScr, sIrrep
use Index_Functions, only: nTri_Elem
use Basis_Info, only: dbsc, nBas, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: iChTbl, iOper, lBsFnc, lIrrep, nIrrep
use Gateway_global, only: Onenly, Test
use Gateway_Info, only: CutInt
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u5, u6, r8

implicit none
logical(kind=iwp), intent(out) :: Run_MCLR
#include "Molcas.fh"
#include "disp.fh"
#include "print.fh"
integer(kind=iwp) :: i, iCar, iCnt, iCnttp, iCo, iComp, idum, iDummer, iElem, iIrrep, ijSym, iOpt, ipert, iprint, iRC, iRout, &
                     istatus, iSym(3), iTR, j, jIrrep, jTR, k, kIrrep, kTR, ldsp, lTR, Lu_Mck, LuRd, mc, mdc, mDisp, nDisp, nSlct
real(kind=wp) :: alpha, Fact, ovlp
logical(kind=iwp) :: defPert, ltype, Slct !, DoCholesky
character(len=80) :: Key, KWord
character(len=32) :: Label2
character(len=8) :: Label, labelop
integer(kind=iwp), allocatable :: ATDisp(:), Car(:), DEGDisp(:), iTemp(:), TDisp(:)
logical(kind=iwp), allocatable :: lPert(:)
real(kind=wp), allocatable :: AM(:,:), C(:,:), Scr(:,:), Tmp(:,:)
character, parameter :: xyz(0:2) = ['x','y','z']
integer(kind=iwp), external :: iPrmt, NrOpr
real(kind=r8), external :: DDot_
logical(kind=iwp), external :: TstFnc

!call DecideOnCholesky(DoCholesky)
!if (DoCholesky) then
!  write(u6,*)'** Cholesky or RI/DF not yet implemented in McKinley '
!  call abend()
!end if

iRout = 99
nPrint(:) = 5
show = .false.
Onenly = .false.
Test = .false.
TRSymm = .false.
lEq = .false.
Slct = .false.
PreScr = .true.
lGrd = .true.
lHss = .true.
Nona = .false.
Run_MCLR = .true.
CutInt = 1.0e-7_wp
ipert = 2
defPert = .true.
call mma_allocate(lPert,0,label='lPert')
lPert(:) = defPert
sIrrep = .false.
iprint = 0
do i=1,3*MxAtom
  IndxEq(i) = i
end do

! KeyWord directed input

LuRd = u5
call RdNLst(LuRd,'MCKINLEY')
do
  read(u5,'(A72)',iostat=istatus) Key
  if (istatus < 0) call Error(1)
  if (istatus > 0) call Error(2)
  KWord = Key
  call UpCase(KWord)
  if (KWord(1:1) == '*') cycle
  if (KWord == '') cycle
  select case (KWord(1:4))
    !case ('EQUI')
    !  !                                                                *
    !  !***** EQUI ******************************************************
    !  !                                                                *
    !  ! Equivalence option
    !
    !  lEq = .true.
    !  do
    !    read(u5,'(A)',iostat=istatus) KWord
    !    if (istatus > 0) call Error(2)
    !    if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
    !  end do
    !  read(KWord,*) nGroup
    !  do iGroup=1,nGroup
    !    do
    !      read(u5,'(A)',iostat=istatus) KWord
    !      if (istatus > 0) call Error(2)
    !      if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
    !    end do
    !    read(KWord,*) nElem,(iTemp(iElem),iElem=1,nElem)
    !    do iElem=2,nElem
    !      IndxEq(iTemp(iElem)) = iTemp(1)
    !      Direct(iTemp(iElem)) = .false.
    !    end do
    !  end do

    !case ('NOIN')
    !  !                                                                *
    !  !***** NOIN ******************************************************
    !  !                                                                *
    !  ! Disable the utilization of translational and
    !  ! rotational invariance of the energy in the
    !  ! computation of the molecular gradient.
    !
    !  TRSymm = .false.

    case ('SHOW')
      !                                                                *
      !***** SHOW ******************************************************
      !                                                                *
      ! Raise the printlevel to show gradient contributions

      Show = .true.

    case ('CUTO')
      !                                                                *
      !***** CUTO ******************************************************
      !                                                                *
      ! Cutoff for computing primitive gradients

      !do
      !  read(u5,'(A)',iostat=istatus) KWord
      !  if (istatus > 0) call Error(2)
      !  if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      !end do
      !read(KWord,*,iostat=istatus) CutInt
      !if (istatus > 0) call Error(2)
      read(u5,*) Cutint
      CutInt = abs(CutInt)

    case ('VERB')
      !                                                                *
      !***** VERB ******************************************************
      !                                                                *
      ! Verbose output

      nPrint(1) = 6
      nPrint(99) = 6

    case ('NOSC')
      !                                                                *
      !***** NOSC ******************************************************
      !                                                                *
      ! Change default for the prescreening.

      PreScr = .false.

    case ('ONEO')
      !                                                                *
      !***** ONEO ******************************************************
      !                                                                *
      ! Do not compute two electron integrals.

      Onenly = .true.

    case ('SELE')
      !                                                                *
      !***** SELE ******************************************************
      !                                                                *
      ! selection option

      Slct = .true.
      defPert = .false.
      lPert(:) = defPert
      !do
      !  read(u5,'(A)',iostat=istatus) KWord
      !  if (istatus > 0) call Error(2)
      !  if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      !end do
      !read(KWord,*) nSlct
      read(u5,*) nSlct

      call mma_allocate(iTemp,nSlct,label='iTemp')
      read(u5,*) (iTemp(iElem),iElem=1,nSlct)
      do iElem=1,nSlct
        call extend_lPert(iTemp(iElem))
        lPert(iTemp(iElem)) = .true.
      end do
      call mma_deallocate(iTemp)

    case ('REMO')
      !                                                                *
      !***** REMO ******************************************************
      !                                                                *
      Slct = .true.
      read(u5,*) nSlct

      call mma_allocate(iTemp,nSlct,label='iTemp')
      read(u5,*) (iTemp(iElem),iElem=1,nSlct)
      do iElem=1,nSlct
        call extend_lPert(iTemp(iElem))
        lPert(iTemp(iElem)) = .false.
      end do
      call mma_deallocate(iTemp)

    case ('PERT')
      !                                                                *
      !***** PERT ******************************************************
      !                                                                *
      ! Select which part of the Hessian will be computed.

      do
        read(u5,'(A)',iostat=istatus) KWord
        if (istatus > 0) call Error(2)
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      call UpCase(KWord)
      if (KWORD(1:4) == 'HESS') then
        ipert = 2
      else if (KWORD(1:4) == 'GEOM') then
        ipert = 1
      else
        write(u6,*) 'InputH: Illegal perturbation keyword'
        write(u6,'(A,A)') 'KWord=',KWord
        call Abend()
      end if

    case ('TEST')
      !                                                                *
      !***** TEST ******************************************************
      !                                                                *
      ! Process only the input.

      Test = .true.

    case ('EXTR')
      !                                                                *
      !***** EXTR ******************************************************
      !                                                                *
      ! Put the program name and the time stamp onto the extract file

      write(u6,*) 'InputH: EXTRACT option is redundant and is ignored!'

    case ('NONA')
      !                                                                *
      !***** NONA ******************************************************
      !                                                                *
      ! Compute the anti-symmetric overlap gradient only.

      Nona = .true.
      Run_MCLR = .false.

    case ('NOMC')
      !                                                                *
      !***** NOMC ******************************************************
      !                                                                *
      ! Request no automatic run of MCLR

      Run_MCLR = .false.

    case ('END ')
      !                                                                *
      !***** END  ******************************************************
      !                                                                *
      exit

    case default
      write(u6,*) 'InputH: Illegal keyword'
      write(u6,'(A,A)') 'KWord=',KWord
      call Abend()
  end select
end do
!***********************************************************************
!                                                                      *
!                          End of input section.                       *
!                                                                      *
!***********************************************************************

iPrint = nPrint(iRout)

iOpt = 1
if (onenly) iopt = 0
iRC = -1
Lu_Mck = 35
call OpnMck(irc,iOpt,'MCKINT',Lu_Mck)
if (iRC /= 0) then
  write(u6,*) 'InputH: Error opening MCKINT'
  call Abend()
end if
if (ipert == 1) then
  Label2 = 'Geometry'
  LabelOp = 'PERT    '
  irc = -1
  iopt = 0
  call cWrMck(iRC,iOpt,LabelOp,1,Label2,iDummer)
  sIrrep = .true.
else if (ipert == 2) then
  Label2 = 'Hessian'
  LabelOp = 'PERT    '
  call cWrMck(iRC,iOpt,LabelOp,1,Label2,iDummer)
else if (ipert == 3) then
  LabelOp = 'PERT    '
  Label2 = 'Magnetic'
  call cWrMck(iRC,iOpt,LabelOp,1,Label2,iDummer)
  write(u6,*) 'InputH: Illegal perturbation option'
  write(u6,*) 'iPert=',iPert
  call Abend()
else if (ipert == 4) then
  LabelOp = 'PERT    '
  Label2 = 'Relativistic'
  call cWrMck(iRC,iOpt,LabelOp,1,Label2,iDummer)
  write(u6,*) 'InputH: Illegal perturbation option'
  write(u6,*) 'iPert=',iPert
  call Abend()
else
  write(u6,*) 'InputH: Illegal perturbation option'
  write(u6,*) 'iPert=',iPert
  call Abend()
end if

!if (lEq) TRSymm = .false.
!if (Slct) TRSymm = .false.

mDisp = 0
mdc = 0
do iCnttp=1,nCnttp
  do iCnt=1,dbsc(iCnttp)%nCntr
    mdc = mdc+1
    mDisp = mDisp+3*(nIrrep/dc(mdc)%nStab)
  end do
end do

write(u6,*)
write(u6,'(20X,A,E10.3)') ' Threshold for contributions to the gradient or Hessian:',CutInt
write(u6,*)

if (Nona) then
  write(u6,*)
  write(u6,'(20X,A)') ' McKinley only is computing the antisymmetric gradient of the overlap integrals for the NonAdiabatic '// &
                      'Coupling.'
  write(u6,*)
end if

! Generate symmetry adapted cartesian displacements

if (iPrint >= 6) then
  write(u6,*)
  write(u6,'(20X,A)') '********************************************'
  write(u6,'(20X,A)') '* Symmetry Adapted Cartesian Displacements *'
  write(u6,'(20X,A)') '********************************************'
  write(u6,*)
end if
IndDsp(:,:) = 0
InxDsp(:,:) = 0
call mma_allocate(ATDisp,mDisp,Label='ATDisp')
call mma_allocate(DEGDisp,mDisp,Label='DEGDisp')
nDisp = 0
do iIrrep=0,nIrrep-1
  lDisp(iIrrep) = 0
  ltype = .true.
  ! Loop over basis function definitions
  mdc = 0
  mc = 1
  do iCnttp=1,nCnttp
    ! Loop over unique centers associated with this basis set.
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      IndDsp(mdc,iIrrep) = nDisp
      ! Loop over the cartesian components
      do iCar=0,2
        iComp = 2**iCar
        if (TstFnc(dc(mdc)%iCoSet,iIrrep,iComp,dc(mdc)%nStab)) then
          nDisp = nDisp+1
          if (nDisp > mDisp) then
            write(u6,*) 'nDisp > mDisp'
            call Abend()
          end if
          if (iIrrep == 0) InxDsp(mdc,iCar+1) = nDisp
          lDisp(iIrrep) = lDisp(iIrrep)+1
          if (ltype) then
            if (iPrint >= 6) then
              write(u6,*)
              write(u6,'(10X,A,A)') ' Irreducible representation : ',lIrrep(iIrrep)
              write(u6,'(10X,2A)') ' Basis function(s) of irrep: ',lBsFnc(iIrrep)
              write(u6,*)
              write(u6,'(A)') ' Basis Label        Type   Center Phase'
            end if
            ltype = .false.
          end if
          if (iPrint >= 6) &
            write(u6,'(I4,3X,A8,5X,A1,7X,8(I3,4X,I2,4X))') nDisp,dc(mdc)%LblCnt,xyz(iCar), &
                                                           (mc+iCo,iPrmt(NrOpr(dc(mdc)%iCoSet(iCo,0)),iComp)* &
                                                                   iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0))), &
                                                            iCo=0,nIrrep/dc(mdc)%nStab-1)
          write(ChDisp(nDisp),'(A,1X,A1)') dc(mdc)%LblCnt,xyz(iCar)
          ATDisp(ndisp) = icnttp
          DEGDisp(ndisp) = nIrrep/dc(mdc)%nStab
        end if

      end do
      mc = mc+nIrrep/dc(mdc)%nStab
    end do
  end do

end do

if (nDisp /= mDisp) then
  write(u6,*) 'InputH: nDisp /= mDisp'
  write(u6,*) 'nDisp,mDisp=',nDisp,mDisp
  call Abend()
end if
if (sIrrep) then
  ndisp = ldisp(0)
  lDisp(1:nIrrep-1) = 0
end if
call mma_allocate(TDisp,nDisp,Label='TDisp')
TDisp(:) = 30
iOpt = 0
iRC = -1
labelOp = 'ndisp   '
call iWrMck(iRC,iOpt,labelop,1,[ndisp],iDummer)
if (iRC /= 0) then
  write(u6,*) 'InputH: Error writing to MCKINT'
  write(u6,'(A,A)') 'labelOp=',labelOp
  call Abend()
end if
LABEL = 'DEGDISP'
iRc = -1
iOpt = 0
call iWrMck(iRC,iOpt,Label,idum,DEGDISP,idum)
if (iRC /= 0) then
  write(u6,*) 'InputH: Error writing to MCKINT'
  write(u6,'(A,A)') 'LABEL=',LABEL
  call Abend()
end if
call mma_deallocate(DEGDisp)
LABEL = 'NRCTDISP'
iRc = -1
iOpt = 0
call iWrMck(iRC,iOpt,Label,idum,ATDisp,idum)
if (iRC /= 0) then
  write(u6,*) 'InputH: Error writing to MCKINT'
  write(u6,'(A,A)') 'LABEL=',LABEL
  call Abend()
end if
call mma_deallocate(ATDisp)
LABEL = 'TDISP'
iRc = -1
iOpt = 0
call iWrMck(iRC,iOpt,Label,idum,TDisp,idum)
if (iRC /= 0) then
  write(u6,*) 'InputH: Error writing to MCKINT'
  write(u6,'(A,A)') 'LABEL=',LABEL
  call Abend()
end if
call mma_deallocate(TDisp)

! Set up data for the utilization of the translational
! and rotational invariance of the energy.

if (TRSymm) then
  call Abend()
  iSym(1) = 0
  iSym(2) = 0
  iSym(3) = 0
  do i=1,min(nIrrep-1,5)
    j = i
    if (i == 3) j = 4
    do k=1,3
      if (btest(iOper(j),k-1)) iSym(k) = 2**(k-1)
    end do
  end do
  nTR = 0
  ! Translational equations
  do i=1,3
    if (iSym(i) == 0) nTR = nTR+1
  end do
  if (iPrint >= 99) write(u6,*) ' nTR=',nTR
  ! Rotational equations
  do i=1,3
    j = i+1
    if (j > 3) j = j-3
    k = i+2
    if (k > 3) k = k-3
    ijSym = ieor(iSym(j),iSym(k))
    if (ijSym == 0) nTR = nTR+1
  end do
  if (nTR == 0) then
    TRSymm = .false.
  else
    if (iPrint >= 99) write(u6,*) ' nTR=',nTR
    call mma_allocate(AM,nTR,lDisp(0),Label='AM')
    call mma_allocate(Tmp,nTR,nTR,Label='Tmp')
    call mma_allocate(C,4,lDisp(0),Label='C')
    call mma_allocate(Car,lDisp(0),Label='Car')

    AM(:,:) = Zero
    C(:,:) = Zero

    ! Generate temporary information of the symmetrical displacements.

    ldsp = 0
    mdc = 0
    iIrrep = 0
    do iCnttp=1,nCnttp
      do iCnt=1,dbsc(iCnttp)%nCntr
        mdc = mdc+1
        !call RecPrt(' Coordinates',' ',dbsc(iCnttp)%Coor(1,iCnt),1,3)
        Fact = Zero
        iComp = 0
        if (dbsc(iCnttp)%Coor(1,iCnt) /= Zero) iComp = ibset(iComp,0)
        if (dbsc(iCnttp)%Coor(2,iCnt) /= Zero) iComp = ibset(iComp,1)
        if (dbsc(iCnttp)%Coor(3,iCnt) /= Zero) iComp = ibset(iComp,2)
        do jIrrep=0,nIrrep-1
          if (TstFnc(dc(mdc)%iCoSet,jIrrep,iComp,dc(mdc)%nStab)) then
            Fact = Fact+One
          end if
        end do
        do iCar=0,2
          iComp = 2**iCar
          if (TstFnc(dc(mdc)%iCoSet,iIrrep,iComp,dc(mdc)%nStab)) then
            ldsp = ldsp+1
            ! Transfer the coordinates
            C(1:3,ldsp) = dbsc(iCnttp)%Coor(:,iCnt)
            ! Transfer the multiplicity factor
            C(4,ldsp) = Fact
            Car(ldsp) = iCar+1
          end if
        end do
      end do
    end do
    if (iPrint >= 99) then
      call RecPrt(' Information',' ',C,4,lDisp(0))
      write(u6,*) (Car(i),i=1,lDisp(0))
    end if

    ! Set up coefficient for the translational equations

    iTR = 0
    do i=1,3
      if (iSym(i) /= 0) cycle
      iTR = iTR+1
      do ldsp=1,lDisp(0)
        if (Car(ldsp) == i) AM(iTR,ldsp) = C(4,ldsp)
      end do
    end do

    ! Set up coefficient for the rotational invariance

    do i=1,3
      j = i+1
      if (j > 3) j = j-3
      k = i+2
      if (k > 3) k = k-3
      ijSym = ieor(iSym(j),iSym(k))
      if (ijSym /= 0) cycle
      iTR = iTR+1
      do ldsp=1,lDisp(0)
        if (Car(ldsp) == j) then
          Fact = C(4,ldsp)*C(k,ldsp)
        else if (Car(ldsp) == k) then
          Fact = -C(4,ldsp)*C(j,ldsp)
        else
          Fact = Zero
          write(u6,*) 'Inputh: Error'
          call Abend()
        end if
        AM(iTR,ldsp) = Fact
      end do
    end do
    if (iPrint >= 99) call RecPrt(' The A matrix',' ',AM,nTR,lDisp(0))

    ! Now, transfer the coefficient of those gradients which will
    ! not be computed directly.
    ! The matrix to compute the inverse of is determined via
    ! a Gram-Schmidt procedure.

    ! Pick up the other vectors
    do iTR=1,nTR
      !write(u6,*) ' Looking for vector #',iTR
      ovlp = Zero
      kTR = 0
      ! Check all the remaining vectors
      loop1: do ldsp=1,lDisp(0)
        do jTR=1,iTR-1
          if (iTemp(jTR) == ldsp) cycle loop1
        end do
        !write(u6,*) ' Checking vector #', ldsp
        Tmp(:,iTR) = AM(:,ldsp)
        !call RecPrt(' Vector',' ',Tmp(:,iTR),nTR,1)
        ! Gram-Schmidt orthonormalize against accepted vectors
        do lTR=1,iTR-1
          alpha = DDot_(nTR,Tmp(:,iTR),1,Tmp(:,lTR),1)
          !write(u6,*) ' <x|y> =', alpha
          Tmp(:,iTR) = Tmp(:,iTR)-alpha*Tmp(:,lTR)
        end do
        !call RecPrt(' Remainings',' ',Tmp(:,iTR),nTR,1)
        alpha = DDot_(nTR,Tmp(:,iTR),1,Tmp(:,iTR),1)
        !write(u6,*) ' Remaining overlap =', alpha
        ! Check the remaining magnitude of vector after Gram-Schmidt
        if (alpha > ovlp) then
          kTR = ldsp
          ovlp = alpha
        end if
      end do loop1
      if (kTR == 0) then
        write(u6,*) ' No Vector found!'
        call Abend()
      end if
      !write(u6,*) ' Selecting vector #', kTR
      ! Pick up the "best" vector
      Tmp(:,iTR) = AM(:,kTR)
      do lTR=1,iTR-1
        alpha = DDot_(nTR,Tmp(:,iTR),1,Tmp(:,lTR),1)
        Tmp(:,iTR) = Tmp(:,iTR)-alpha*Tmp(:,lTR)
      end do
      alpha = DDot_(nTR,Tmp(:,iTR),1,Tmp(:,iTR),1)
      Tmp(:,iTR) = Tmp(:,iTR)/sqrt(alpha)
      iTemp(iTR) = kTR
    end do
    do iTR=1,nTR
      Tmp(:,iTR) = AM(:,iTemp(iTR))
      AM(:,iTemp(iTR)) = Zero
    end do
    if (iPrint >= 99) then
      call RecPrt(' The A matrix',' ',AM,nTR,lDisp(0))
      call RecPrt(' The T matrix',' ',Tmp,nTR,nTR)
      write(u6,*) (iTemp(iTR),iTR=1,nTR)
    end if

    ! Compute the inverse of the T matrix

    call MatInvert(Tmp,nTR)
    if (IPrint >= 99) call RecPrt(' The T-1 matrix',' ',Tmp,nTR,nTR)
    Tmp(:,:) = -Tmp

    ! Generate the complete matrix

    call mma_allocate(Scr,nTR,lDisp(0),Label='Scr')
    call DGEMM_('N','N',nTR,lDisp(0),nTR,One,Tmp,nTR,AM,nTR,Zero,Scr,nTR)
    if (IPrint >= 99) call RecPrt(' A-1*A',' ',Scr,nTR,lDisp(0))
    call mma_deallocate(AM)
    call mma_allocate(AM,lDisp(0),lDisp(0),Label='AM')
    AM(:,:) = Zero
    do i=1,lDisp(0)
      AM(i,i) = One
    end do
    do iTR=1,nTR
      ldsp = iTemp(iTR)
      AM(ldsp,:) = Scr(iTR,1:lDisp(0))
    end do
    if (iPrint >= 99) call RecPrt('Final A matrix',' ',AM,lDisp(0),lDisp(0))

    call mma_deallocate(Scr)
    call mma_deallocate(Car)
    call mma_deallocate(C)
    call mma_deallocate(Tmp)
    do iTR=1,nTR
      ldsp = iTemp(iTR)
      call extend_lPert(ldsp)
      lPert(ldsp) = .false.
    end do

    write(u6,*)
    write(u6,'(20X,A)') ' Automatic utilization of translational and rotational invariance of the energy is employed.'
    write(u6,*)
    call extend_lPert(lDisp(0))
    do i=1,lDisp(0)
      if (lPert(i)) then
        write(u6,'(25X,A,A)') Chdisp(i),' is independent'
      else
        write(u6,'(25X,A,A)') Chdisp(i),' is dependent'
      end if
    end do
    write(u6,*)
  end if

else
  nTR = 0
  if (iPrint >= 6) then
    write(u6,*)
    write(u6,'(20X,A)') ' No automatic utilization of translational and rotational invariance of the energy is employed.'
    write(u6,*)
  end if
end if

if (Slct) then
  write(u6,*)
  write(u6,'(20X,A)') ' The Selection option is used'
  write(u6,*)
  call extend_lPert(lDisp(0))
  do i=1,lDisp(0)
    if (lPert(i)) then
      write(u6,'(25X,A,A)') Chdisp(i),' is computed'
    else
      write(u6,'(25X,A,A)') Chdisp(i),' is set to zero'
    end if
  end do
  write(u6,*)
end if

call Datimx(KWord)
nFck(0:nIrrep-1) = 0
do iIrrep=0,nIrrep-1
  if (iIrrep /= 0) then
    do jIrrep=0,nIrrep-1
      kIrrep = NrOpr(ieor(ioper(jIrrep),ioper(iIrrep)))
      if (kIrrep < jIrrep) nFck(iIrrep) = nFck(iIrrep)+nBas(jIrrep)*nBas(kIrrep)
    end do
  else
    do jIrrep=0,nIrrep-1
      nFck(0) = nFck(0)+nTri_Elem(nBas(jIrrep))
    end do
  end if
end do

call mma_deallocate(lPert)

return

contains

subroutine Extend_lPert(n)

  integer(kind=iwp), intent(in) :: n
  integer(kind=iwp) :: m
  logical(kind=iwp), allocatable :: Temp(:)

  m = size(lPert)
  if (n > m) then
    call mma_allocate(Temp,n,label='lPert')
    Temp(:m) = lPert
    Temp(m+1:) = defPert
    call mma_deallocate(lPert)
    call move_alloc(Temp,lPert)
  end if

end subroutine Extend_lPert

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  select case (code)
    case (1)
      write(u6,*) 'InputH: end of input file.'
    case (2)
      write(u6,*) 'InputH: error reading input file.'
  end select
  write(u6,'(A,A)') 'Last command=',KWord
  call Abend()

end subroutine Error

end subroutine Inputh

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine FCOOR(LUT,COOR)
!*******************************************************************
!                                                                  *
!      Transforms a symmetry adapted gradient to unsymmetric  form *
!                                                                  *
!       Written by Anders Bernhardsson                             *
!       960427                                                     *
!                                                                  *
!*******************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use Molcas, only: LenIn
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LUT
real(kind=wp), intent(in) :: COOR(3,*)
integer(kind=iwp) :: iCnt, iCnttp, iCo, ii, kop, mdc
real(kind=wp) :: A(3), B(3)
character(len=LenIn) :: Lab

mdc = 0

write(LUT,'(A)') '*BEGIN COORDINATES'
write(LUT,'(A)') '*LABEL COORDINATES CHARGE'
do iCnttp=1,nCnttp
  do iCnt=1,dbsc(iCnttp)%nCntr
    mdc = mdc+1
    A(:) = Coor(:,mdc)
    do iCo=0,nIrrep/dc(mdc)%nStab-1
      kop = dc(mdc)%iCoSet(iCo,0)
      call OA(kOp,A,B)
      ii = nint(dbsc(icnttp)%Charge)
      Lab = dc(mdc)%LblCnt(1:LenIn)
      call setLab(Lab,ico)
      write(LUT,'(1X,A,1X,3F20.10,1X,I3)') Lab,B(1:3),ii
    end do
  end do
end do
write(LUT,'(A)') '*END COORDINATES'

end subroutine FCOOR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine chpcmp2_cvb(itst,iret)

use casvb_global, only: iprm, lstprm, mxprm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: itst
integer(kind=iwp), intent(out) :: iret

iprm = iprm+1
if (iprm > mxprm) then
  write(u6,*) ' Dimensioning error in CHPCMP2!',iprm,mxprm
  call abend_cvb()
end if
iret = lstprm(iprm)
lstprm(iprm) = itst

return

end subroutine chpcmp2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine applyt2_cvb(vec,gjorb,igjorb,
     > i1alf,i1bet,iato,ibto,phato,phbto)
c  Apply T(O) to the vector VEC. O is defined in terms of GJORB.
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension vec(nda,ndb)
      dimension gjorb(norb*norb),igjorb(2,norb*norb)
      dimension i1alf(n1a,norb),i1bet(n1b,norb)
      dimension iato(norb,0:nam1),ibto(norb,0:nbm1)
      dimension phato(norb,nam1),phbto(norb,nbm1)
      save thresh
      data thresh/1.d-10/

      do 1000 ij=1,norb*norb
      iorb=igjorb(2,ij)
      jorb=igjorb(1,ij)
      scale=gjorb(ij)
      if(iorb.ne.jorb.and.abs(scale).gt.thresh)then
c  a) Alpha excitation
        if(absym(2))then
          do 1100 ia=1,n1a
          iaxtmp=i1alf(ia,iorb)
          jax=iato(jorb,iaxtmp)
          if(jax.ne.0)then
            iax=iato(iorb,iaxtmp)
            tcof=scale*phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
            if(jax.gt.iax)then
              call daxpy_(ndb-jax+1,tcof,vec(iax,jax),nda,
     >          vec(jax,jax),nda)
            else
              call daxpy_(iax-jax,tcof,vec(jax,iax),1,vec(jax,jax),nda)
              vec(jax,iax)=vec(jax,iax)+tcof*vec(iax,iax)
              if(ndb-iax.gt.0) call daxpy_(ndb-iax,tcof,
     >          vec(iax,iax+1),nda,vec(jax,iax+1),nda)
            endif
          endif
1100      continue
        else
          do 2100 ia=1,n1a
          iaxtmp=i1alf(ia,iorb)
          jax=iato(jorb,iaxtmp)
          if(jax.ne.0)then
            iax=iato(iorb,iaxtmp)
            tcof=scale*phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
            call daxpy_(ndb,tcof,vec(iax,1),nda,vec(jax,1),nda)
          endif
2100      continue
        endif
c  b) Beta excitation
        if(absym(2))then
          do 3100 ib=1,n1b
          ibxtmp=i1bet(ib,iorb)
          jbx=ibto(jorb,ibxtmp)
          if(jbx.ne.0)then
            ibx=ibto(iorb,ibxtmp)
            tcof=scale*phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            if(jbx.gt.ibx)then
              call daxpy_(ibx-1,tcof,vec(1,ibx),1,vec(1,jbx),1)
              vec(ibx,jbx)=vec(ibx,jbx)+tcof*vec(ibx,ibx)
              if(jbx-ibx.gt.0) call daxpy_(jbx-ibx,tcof,
     >          vec(ibx,ibx+1),nda,vec(ibx+1,jbx),1)
            else
              call daxpy_(jbx,tcof,vec(1,ibx),1,vec(1,jbx),1)
            endif
          endif
3100      continue
        else
          do 4100 ib=1,n1b
          ibxtmp=i1bet(ib,iorb)
          jbx=ibto(jorb,ibxtmp)
          if(jbx.ne.0)then
            ibx=ibto(iorb,ibxtmp)
            tcof=scale*phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            call daxpy_(nda,tcof,vec(1,ibx),1,vec(1,jbx),1)
          endif
4100      continue
        endif
      elseif(iorb.eq.jorb.and.abs(scale-one).gt.thresh)then
c Alpha singly occupied
        if(absym(2))then
          do 5100 ia=1,n1a
          iak=iato(iorb,i1alf(ia,iorb))
          call dscal_(ndb-iak+1,scale,vec(iak,iak),nda)
5100      continue
        else
          do 5200 ia=1,n1a
          iak=iato(iorb,i1alf(ia,iorb))
          call dscal_(ndb,scale,vec(iak,1),nda)
5200      continue
        endif
c Beta singly occupied
        if(absym(2))then
          do 5300 ib=1,n1b
          ibk=ibto(iorb,i1bet(ib,iorb))
          call dscal_(ibk,scale,vec(1,ibk),1)
5300      continue
        else
          do 5400 ib=1,n1b
          ibk=ibto(iorb,i1bet(ib,iorb))
          call dscal_(nda,scale,vec(1,ibk),1)
5400      continue
        endif
      endif
1000  continue
      if(absym(2))then
        do 6000 ia=1,nda
        do 6001 ib=ia+1,ndb
        vec(ib,ia)=vec(ia,ib)
6001    continue
6000    continue
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RasScf_Mcontrol(id_call)

use Fock_util_global, only: ALGO, dmpk, Nscreen
use Cholesky, only: timings
use Para_Info, only: MyRank
use rasscf_global, only: MaxIt, Thre, ThrSX, ThrTE
use Constants, only: Zero
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: id_call
integer(kind=iwp) :: iCount, iCount0, istatus
character(len=512) :: List
character(len=32) :: val

icount = 0

if (id_call == 1) then

  ! Label definitions

  write(List,100) 'RASSCF_started_OK:(-:-):',ALGO,timings,dmpK,nScreen,MaxIt,ThrE,ThrSX,ThrTE

  ! Initialize the control system

  call MolcasControlInit(List)
  return

else

  ! Read the molcas control file
  !1
  call MolcasControl('Cho_ALGO',val)
  if (val(1:4) /= '    ') then
    read(val,*,iostat=istatus) ALGO
    if (istatus /= 0) then
      call Error(istatus)
      return
    end if
    write(u6,*) '--- Warning: Cho_ALGO changed by user to the value ',ALGO
    icount = icount+1
  end if
  !2
  call MolcasControl('Chotime',val)
  if (val(1:4) /= '    ') then
    read(val,*,iostat=istatus) timings
    if (istatus /= 0) then
      call Error(istatus)
      return
    end if
    write(u6,*) '--- Warning: Cholesky timings visualization changed by user to the value ',timings
    icount = icount+1
  end if
  !3
  call MolcasControl('nScreen',val)
  if (val(1:4) /= '    ') then
    read(val,*,iostat=istatus) nScreen
    if (istatus /= 0) then
      call Error(istatus)
      return
    end if
    write(u6,*) '--- Warning: Cholesky LK option nSCREEN changed by user to the value ',nScreen
    icount = icount+1
  end if
  !4
  call MolcasControl('dmpK',val)
  if (val(1:4) /= '    ') then
    read(val,*,iostat=istatus) dmpK
    if (istatus /= 0) then
      call Error(istatus)
      return
    end if
    write(u6,*) '--- Warning: Cholesky LK option DMPK changed by user to the value ',dmpK
    icount = icount+1
  end if
  !5
  call MolcasControl('MaxIter',val)
  if (val(1:4) /= '    ') then
    read(val,*,iostat=istatus) MaxIt
    if (istatus /= 0) then
      call Error(istatus)
      return
    end if
    write(u6,*) '--- Warning: MaxIt changed by user to the value ',MaxIt
    icount = icount+1
  end if
  !6
  call MolcasControl('ThrE',val)
  if (val(1:4) /= '    ') then
    read(val,*,iostat=istatus) ThrE
    if (istatus /= 0) then
      call Error(istatus)
      return
    end if
    write(u6,*) '--- Warning: ThrE changed by user to the value ',ThrE
    icount = icount+1
  end if
  !7
  call MolcasControl('ThrSX',val)
  if (val(1:4) /= '    ') then
    read(val,*,iostat=istatus) ThrSX
    if (istatus /= 0) then
      call Error(istatus)
      return
    end if
    write(u6,*) '--- Warning: ThrSX changed by user to the value ',ThrSX
    icount = icount+1
  end if
  !8
  call MolcasControl('ThrTE',val)
  if (val(1:4) /= '    ') then
    read(val,*,iostat=istatus) ThrTE
    if (istatus /= 0) then
      call Error(istatus)
      return
    end if
    write(u6,*) '--- Warning: ThrTE changed by user to the value ',ThrTE
    icount = icount+1
  end if

end if

icount0 = icount

! Get the true updated counter in parallel runs

call gaIgOP_SCAL(icount,'max')

if (MyRank == 0) then
  if (icount > icount0) then
    write(u6,*) ' Steering will NOT be activated this time because'
    write(u6,*) ' molcas.control file must be changed on node_0 !!'
    call gaIgOP_SCAL(icount,'min')
  end if
end if

if (icount > 0) then

  ! Trick to broadcast the values across nodes

  if (MyRank /= 0) then
    ALGO = 0
    MaxIt = 0
    nScreen = 0
    dmpK = Zero
    ThrE = Zero
    ThrSX = Zero
    ThrTE = Zero
  end if
  call gaIgOP_SCAL(ALGO,'+')
  call gaIgOP_SCAL(nScreen,'+')
  call gaIgOP_SCAL(MaxIt,'+')
  call gadgOP_SCAL(dmpK,'+')
  call gadgOP_SCAL(ThrE,'+')
  call gadgOP_SCAL(ThrSX,'+')
  call gadgOP_SCAL(ThrTE,'+')

  ! Update label values (note that "timings" is updated locally)

  write(List,100) 'RASSCF_modified_by_user:',ALGO,timings,dmpK,nScreen,MaxIt,ThrE,ThrSX,ThrTE

  ! Initialize the control system with the new values

  call MolcasControlInit(List)
  return

end if

return

100 format(A24,',Cho_ALGO=',I2,',Chotime=',L2,',dmpK=',ES11.4,',nScreen=',I4,',MaxIter=',I4,',ThrE=',ES11.4,',ThrSX=',ES11.4, &
           ',ThrTE=',ES11.4)

contains

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  if (code < 0) then
    write(u6,*) 'RasScf_Mcontrol: reached end of file. ( icount= ',icount,' )'
  else if (code > 0) then
    write(u6,*) 'RasScf_Mcontrol: error in data Input. ( icount= ',icount,' )'
  end if

end subroutine Error

end subroutine RasScf_Mcontrol

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine GetWFFock(FOccMO,bk,R,nTri,P2MOt,NG2)
! Partially readapted from rhs_sa

use Index_Functions, only: iTri, nTri_Elem
use ipPage, only: W
use MCLR_Data, only: ipCI, IRLXROOT, LuJob, nConf1, nDens, nNA, XISPSM
use input_mclr, only: iTOC, nCSF, nRoots, ntAsh, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nTri, nG2
real(kind=wp), intent(out) :: FOccMO(nDens), bk(nDens), P2MOt(nG2)
real(kind=wp), intent(in) :: R(nRoots,nRoots)
integer(kind=iwp) :: I, iA, iB, iDij, iDkl, iIJKL, ij1, iRij, iRijkl, iRkl, jA, jB, JDisk, K, kA, kB, kl1, kl2, lA, lB, nConfL, &
                     NCSFs, nG1
real(kind=wp) :: Fact, rdum(1)
real(kind=wp), allocatable :: CIL(:), CIR(:), D5(:), D6(:), DIAO(:), DMatAO(:), FinCI(:), Fock(:), G1q(:), G1qs(:), G1r(:), &
                              G2q(:), G2qs(:), G2r(:), G2rt(:), T(:)

!                                                                      *
!***********************************************************************
!                                                                      *
ng1 = nTri_Elem(ntash)
if (ng2 /= nTri_Elem(ng1)) call Abend()

call mma_allocate(FinCI,nconf1*nroots,Label='FinCI')
call mma_allocate(Fock,nDens,Label='Fock')
call mma_allocate(T,nDens,Label='T')
call mma_allocate(G1q,ng1,Label='G1q')
call mma_allocate(G2q,ng2,Label='G2q')
call mma_allocate(G1r,ntash**2,Label='G1r')
call mma_allocate(G2r,nTri_Elem(ntash**2),Label='G2r')
call mma_allocate(G2rt,nTri_Elem(ntash**2),Label='G2rt')
! Rotate CI vectors back to those for reference states
NCSFs = NCSF(state_sym)
call DGEMM_('n','n',NCSFS,nRoots,nRoots,One,W(ipCI)%A,NCSFs,R,nRoots,Zero,FinCI,nCSFs)
nConfL = max(ncsf(state_sym),nint(xispsm(state_sym,1)))

call mma_allocate(CIL,nConfL)
call mma_allocate(CIR,nConfL)

I = IRlxRoot
call CSF2SD(FinCI(1+(I-1)*NCSFs),CIL,state_sym)
CIR(:) = CIL(:)
call Densi2_mclr(2,G1r,G2rt,CIL,CIR,0,0,0,ntash**2,nTri_Elem(ntash**2))
do iA=1,nnA
  do jA=1,nnA
    do kA=1,nnA
      do la=1,nnA
        ij1 = nnA*(iA-1)+ja
        !ij2 = nna*(ja-1)+ia
        kl1 = nnA*(ka-1)+la
        kl2 = nna*(la-1)+ka
        if ((iA == jA) .or. (kA == la)) then
          G2r(iTri(ij1,kl1)) = G2rt(iTri(ij1,kl1))
        else
          G2r(iTri(ij1,kl1)) = (G2rt(iTri(ij1,kl1))+G2rt(iTri(ij1,kl2)))*Half
        end if
      end do
    end do
  end do
end do
call FockGen(One,G1r,G2r,FOccMO,bk,1)

do iB=1,ntash
  do jB=1,iB
    G1q(iTri(ib,jb)) = G1r(ib+(jb-1)*ntash)
  end do
end do
! D1MOt: CMS-PDFT 1RDM for computing 1-electron gradient
call Put_DArray('D1MOt',G1q,ng1)
do iB=1,ntash
  do jB=1,ntash
    iDij = iTri(ib,jB)
    iRij = jb+(ib-1)*ntash
    do kB=1,ntash
      do lB=1,ntash
        iDkl = iTri(kB,lB)
        iRkl = lb+(kb-1)*ntash
        fact = One
        if ((iDij >= iDkl) .and. (kB == lB)) fact = Half
        if ((iDij < iDkl) .and. (iB == jB)) fact = Half
        iijkl = iTri(iDij,iDkl)
        iRijkl = iTri(iRij,iRkl)
        G2q(iijkl) = Fact*G2r(iRijkl)
      end do
    end do
  end do
end do
call Get_dArray_chk('P2MOt',P2MOt,ng2)
P2MOt(:) = P2MOt(:)+G2q(:)

! Done with the info from CMS final state

! Doing some computation for computing non-active-active 2RDM in
! integral_util/prepp.f
call mma_allocate(D5,nTri)
call mma_allocate(D6,nTri)
! D5: Used in ptrans_sa when isym == jsym (PDFT parts cancel WF
!     parts for intermediate states)
! D6: Used in ptrans_sa when isym /= jsym (sum of inactive parts of
! intermediate-state 1RDMs cancels that of the final state)
call mma_allocate(DMatAO,nTri)
call mma_allocate(DIAO,nTri)
call Get_DArray('MSPDFTD5',DIAO,nTri)
call Get_DArray('MSPDFTD6',D6,nTri)
call GetDMatAO(G1q,DMatAO,ng1,nTri)
D6(:) = D6(:)+DMatAO(:)
D5(:) = DMatAO(:)+Half*DIAO(:)
call Put_DArray('MSPDFTD5',D5,nTri)
call Put_DArray('MSPDFTD6',D6,nTri)
call mma_deallocate(D5)
call mma_deallocate(D6)
call mma_deallocate(DMatAO)
call mma_deallocate(DIAO)
! Beginning of the info for CMS intermediate states

jdisk = itoc(3)
call mma_allocate(G1qs,ng1*nRoots)
call mma_allocate(G2qs,ng2*nRoots)
do K=1,nRoots
  call dDaFile(LUJOB,2,G1q,ng1,jDisk)
  call dDaFile(LUJOB,0,rdum,ng1,jDisk)
  call dDaFile(LUJOB,2,G2q,Ng2,jDisk)
  call dDaFile(LUJOB,0,rdum,Ng2,jDisk)
  G1qs((K-1)*ng1+1:K*ng1) = G1q(:)
  G2qs((K-1)*ng2+1:K*ng2) = G2q(:)
  call mma_allocate(DMatAO,ntri)
  call GetDMatAO(G1q,DMatAO,ng1,nTri)
  call mma_deallocate(DMatAO)
  do iB=1,ntash
    do jB=1,ntash
      G1r(ib+(jb-1)*ntash) = G1q(iTri(ib,jb))
    end do
  end do

  do iB=1,ntash
    do jB=1,ntash
      iDij = iTri(ib,jB)
      iRij = jb+(ib-1)*ntash
      do kB=1,ntash
        do lB=1,ntash
          iDkl = iTri(kB,lB)
          iRkl = lb+(kb-1)*ntash
          fact = One
          if ((iDij >= iDkl) .and. (kB == lB)) fact = Two
          if ((iDij < iDkl) .and. (iB == jB)) fact = Two
          iijkl = iTri(iDij,iDkl)
          iRijkl = iTri(iRij,iRkl)
          G2r(iRijkl) = Fact*G2q(iijkl)
        end do
      end do
    end do
  end do

  call FockGen(One,G1r,G2r,T,Fock,1)
  bk(:) = bk(:)-R(K,I)**2*Fock(:)
  FOccMO(:) = FOccMO(:)-R(K,I)**2*T(:)
  P2MOt(:) = P2MOt(:)-R(K,I)**2*G2q(:)
end do
call Put_DArray('D1INTER',G1qs,ng1*nRoots)
call Put_DArray('P2INTER',G2qs,ng2*nRoots)
call mma_deallocate(G1qs)
call mma_deallocate(G2qs)
call mma_deallocate(Fock)
call mma_deallocate(T)
call mma_deallocate(G1r)
call mma_deallocate(G2r)
call mma_deallocate(G2rt)
call mma_deallocate(G1q)
call mma_deallocate(G2q)
call mma_deallocate(CIL)
call mma_deallocate(CIR)
call mma_deallocate(FinCI)

end subroutine GetWFFock

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Bruno Tenorio                                    *
************************************************************************
*  SUBROUTINE DYSNORM
*  PURPOSE: CALCULATE CORRECTED DYSON NORMS FOR CI EXPANSIONS IN A
*  BIORTH. BASIS
************************************************************************
      SUBROUTINE DYSNORM(CMOA,DYSCMO,NORM)

      use stdalloc, only: mma_allocate, mma_deallocate
      use Constants, only: One, Zero
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NCMO,NBASF,NOSH,NOSHT

      Implicit None

      integer :: isym
      real*8 NORM,NORMSCR
      integer :: nb, nbast, nbast1, nbast2
      real*8, allocatable :: SAO(:),IAO(:),Scr(:),Scr2(:)
      real*8, allocatable :: Dysab(:),Dysab2(:)
      character(len=8) :: Label
      integer :: iOff1, iOff2
      integer :: iOpt,iSyLbl,iRc
      integer :: IC,istca,istcb,ist,ista,istcc,istc,ndys
      REAL*8 DYSCMO(*),CMOA(*)
      integer :: istcmo(8), istao(8), istacc(8)
      Integer no1,nb1,nscr,isy1
      Real*8, EXTERNAL :: DDOT_

C============================================================
      nbast=0
      nbast1=0
      nbast2=0
      do isym=1,nsym
        nb=NBASF(isym)
        nbast=nbast+nb
        nbast1=nbast1+(nb*(nb+1))/2
        nbast2=nbast2+nb**2
      end do

      call mma_allocate(DYSAB,NOSHT)
      CALL DCOPY_(NOSHT,DYSCMO,1,DYSAB,1)

      call mma_allocate(SAO,NBAST1)
      call mma_allocate(IAO,NBAST2)
      IAO=Zero

      iRc=-1
      iOpt=6
      IC=1
      iSyLbl=1
      Label='Mltpl  0'
      Call RdOne(iRc,iOpt,Label,IC,SAO,iSyLbl)
      iOff1 = 0
      iOff2 = 0
      Do iSym = 1,nSym
        nb = nBasf(iSym)
        If ( nb.gt.0 ) then
          call mma_allocate(Scr,nb*nb)
          scr=Zero
          Call Square(SAO(1+iOff1),Scr,1,nb,nb)
          CALL DCOPY_(nb*nb,Scr,1,IAO(iOff2+1),1)
          call mma_deallocate(Scr)
        end if
        iOff1 = iOff1 + (nb*nb+nb)/2
        iOff2 = iOff2 + (nb*nb)
      end do
      call mma_deallocate(SAO)

C============================================================

      IST=1
      ISTA=1
      ISTCC=1
      DO ISY1=1,NSYM
        ISTCMO(ISY1)=IST
        ISTAO(ISY1)=ISTA
        ISTACC(ISY1)=ISTCC
        NO1=NOSH(ISY1)
        IST=IST+NO1*NBASF(ISY1)
        ISTA=ISTA+(NBASF(ISY1)*NBASF(ISY1) )
        ISTCC=ISTCC+NO1*NO1
      END DO

      NSCR=NCMO
      NDYS=1
      DO ISY1=1,NSYM
        ISTCB=ISTCMO(ISY1)
        ISTCA=ISTAO(ISY1)
        ISTC=ISTACC(ISY1)
        NO1=NOSH(ISY1)
        NB1=NBASF(ISY1)
        if (NB1*NO1 == 0) cycle

        call mma_allocate(scr,nscr)
        call mma_allocate(scr2,nscr)
        Scr=Zero
        Scr2=Zero

        CALL DGEMM_('N','N', NB1, NO1, NB1, One,
     &                 IAO(ISTCA),NB1, CMOA(ISTCB), NB1,
     &         Zero, Scr(ISTCB), NB1)

        CALL DGEMM_('T','N', NO1, NO1, NB1, One,
     &                 CMOA(ISTCB),NB1, Scr(ISTCB), NB1,
     &         Zero, Scr2(ISTC), NO1)

! Src2 is the M matrix
! Proceed to compute norm=Dab*(Dab*M)
! Where Dab*M=Dysab2

        call mma_allocate(DYSAB2,NO1)
        DYSAB2=Zero
        CALL DGEMV_('N', NO1, NO1, One, Scr2(ISTC), NO1,
     &              DYSAB(NDYS),1, Zero, DYSAB2, 1)

        normscr= DDOT_(NO1, DYSAB(NDYS), 1, DYSAB2, 1)
        norm=norm+normscr
        call mma_deallocate(DYSAB2)

        NDYS=NDYS+NO1
        Call mma_deallocate(Scr)
        Call mma_deallocate(Scr2)
      END DO

      Call mma_deallocate(IAO)
      call mma_deallocate(DYSAB)

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
****************************************************************************
* GA to/from ScaLAPACK (square block scattered decomposition) interface    *
*                                                                          *
* common variables:                                                        *
*     nnodes        - number of processors                                 *
*     iam           - my processor number                                  *
*     nprow/ npcol  - number of processor rows/cols in virtual proc. grid  *
*     myrow/mycol   - cordinates of my processor in virtual proc. grid     *
*                                                                          *
c***************************************************************************
c* 04/12/96  GVT  Changed the code to adapt to a new version of ScaLAPACK  *
c*           Giuseppe Vitillaro peppe@unipg.it                             *
c* 11/12/14  Slightly modified for the DGA interface                       *
c*           Victor Vysotskiy                                              *
c***************************************************************************
#if defined(SCALAPACK) && defined (_MOLCAS_MPP_)
      subroutine ga_pdsyevx_(g_a, g_b, eval, nb8)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "scalapack_.fh"

      integer g_a               ! matrix A
      integer g_b               ! matrix B
      integer nb8               ! block size
      real*8 eval(*)

      character*1 jobz, range, uplo
c
      integer adra          ! A
      integer adrb          ! B
c
c
      logical oactive           ! true iff this process participates
      integer dimA18, dimA28, typeA
      integer dimB18, dimB28, typeB
      SCALAPACKINT dimA1, dimA2
      SCALAPACKINT dimB1, dimB2
c
      SCALAPACKINT mpA, nqA     ! rows/cols of A held by the processor
      SCALAPACKINT mpB, nqB     ! rows/cols of B held by the processor
c
      integer me
      SCALAPACKINT lda, ldb
      integer elemA,elemB
      SCALAPACKINT numroc

      SCALAPACKINT nb                ! block size
      SCALAPACKINT descA(9), descB(9) !descriptor for scalapack

c
      integer ngaps, adrgaps
      integer iclu, adrclustr
      integer adrfail
      integer liwork, adriwork
      integer lcwork, adrcwork
      SCALAPACKINT lcwork4
      SCALAPACKINT liwork4
c
      SCALAPACKINT nn,mq0, np0
      real*8 vl, vu, abstol, orfac
      SCALAPACKINT il, iu
      SCALAPACKINT m, nz
      SCALAPACKINT n
      SCALAPACKINT info
      integer info8
      SCALAPACKINT zero4,one4,two4,four4
      integer two4n
      parameter(zero4=0,one4=1,two4=2,four4=4)

      real*8 pdlamch
      external pdlamch
      SCALAPACKINT iceil

#include "WrkSpc.fh"

c
c     processor dependent; machine dependent
c
      if(nb8.eq.0) then
         nb=16
      else
         nb=nb8
      endif
c
c***  check environment
c
      me     = ga_nodeid()
c
c***  check GA info for input arrays
c
      call ga_inquire(g_a, typeA, dimA18, dimA28)
      call ga_inquire(g_b, typeB, dimB18, dimB28)

      dima1=dima18
      dima2=dima28
      dimb1=dimb18
      dimb2=dimb28
      n=dima1
      if(nb.lt.1) nb=1
      if(dimA1.ne.dima2) call ga_error(
     $     'ga_pdsyevx: matrix A not square ',0)
      if(dimb1.ne.dimb2) call ga_error(
     $     'ga_pdsyevx: matrix B not square ',0)
      if(dimb1.ne.n) call ga_error(
     $     'ga_pdsyevx: size matrix A and B differ ',0)


c
c
c***  initialize SL interface
c
      call SLinit2_(n)
      oactive=iam.lt.maxproc
      call ga_sync
      if (oactive) then
c
c***  find SBS format parameters
c
c
         mpA = numroc(dimA1, nb, myrow2, zero4, nprow2)
         nqA = numroc(dimA2, nb, mycol2, zero4, npcol2)
c
         mpB = numroc(dimB1, nb, myrow2, zero4, nprow2)
         nqB = numroc(dimB2, nb, mycol2, zero4, npcol2)
c
c
         lda = max(one4,mpA)
         ldb = max(one4,mpB)
c
c
c     let scalapack check for errors
c
c     should check to see if this is a compute node
c     check to see how this works in the new data server model
c
c
         elemA= mpA*nqA
         if(elemA.ne.0)
     $   Call GetMem('A','ALLO','REAL',adrA,elemA)
c
c***  copy g_a to A using the block cyclic scalapack format
c

         call ga_to_SL2_(g_a, dimA1, dimA2, nb, nb,
     $        WORK(adrA), lda)
c
         elemB= mpB*nqB

         if(elemB.ne.0)
     $   Call GetMem('B','ALLO','REAL',adrB,elemB)

c
         ngaps = nprow2*npcol2
         if(ngaps.ne.0)
     $   Call GetMem('GAP','ALLO','REAL',adrgaps,ngaps)
c
         iclu = 2*nprow2*npcol2
         two4n=two4*n
         iclu = max(two4n,iclu)
         if(iclu.ne.0)
     $   Call GetMem('ICLUS','ALLO','INTE',adrclustr,iclu)
         Call GetMem('IFAIL','ALLO','INTE',adrfail,dima18)
      endif
      call ga_sync()
      if(oactive) then
c
c***  fill SCALAPACK matrix descriptors
c
         call descinit(descA, dimA1, dimA2, nb, nb, zero4, zero4,
     $        islctxt2, lda, info)
         info8=info
         if(info8.ne.0) call ga_error(' ga_pdsyevx: descinit A failed ',
     $        -info8)
         call descinit(descB, dimB1, dimB2, nb, nb, zero4, zero4,
     $        islctxt2, ldb, info)
         info8=info
         if(info8.ne.0) call ga_error(' ga_pdsyevx: descinit B failed ',
     $        -info8)
c
         jobz = 'V'
         range = 'A'
         range = 'I'
         uplo = 'L'
         vl = 0.d0
         vu = 0.d0
         il = 0
         iu = 0
         il = 1
         iu = n
         nz = 0
c
c     ability to deal with orthonormality ; let's just
c     have the regular scalapack stuff for the moment
c
         liwork = 6*max(n, nprow2*npcol2+one4, four4)
         liwork=liwork
         if(liwork.ne.0)
     $   Call GetMem('IWORK','ALLO','INTE',adriwork,liwork)
c
         nn = max(n, nb, two4)
         np0 = numroc(nn, nb, zero4, zero4, nprow2)
         mq0 = numroc(nn, nb, zero4, zero4, npcol2)
c
c
         orfac = 1.d-3
c
c
         lcwork = 5*n +MAX(5*NN,(NP0*MQ0 + 2*nb*nb))+
     $          ICEIL( N, NPROW2*NPCOL2)*NN+1
         if(lcwork.ne.0)
     $   Call GetMem('CWORK','ALLO','REAL',adrcwork,lcwork)
c
c
         abstol=pdlamch(islctxt2, 'U')
c
c
         liwork4=liwork
         lcwork4=lcwork
         call pdsyevx(jobz, range, uplo,
     $        n, work(adrA), one4, one4, descA,vl,
     $        vu, il, iu, abstol, m, nz, eval, orfac, work(adrB),
     $        one4, one4, descB, work(adrcwork), lcwork4,
     $        iwork(adriwork), liwork4, iwork(adrfail),
     $        iwork(adrclustr), work(adrgaps), info)
c

         if (nz .ne. n ) then
            if ( info .ne. 0 ) then
               if ( info .gt. 0 ) then
         call ga_error(' ga_pdsyevx: argument is illegal ', info)
               else
         call ga_error(' ga_pdsyevx: eigenvectors failed to converge ',
     $                 info)
               endif
            endif
         endif
c
c
c
c***  copy solution matrix back to g_c
c
         call ga_from_SL2_(g_b, dimA1, dimB2,
     $        nb, nb, work(adrB),
     $        ldb)
c
c
c
c***  deallocate work/SL arrays
c
         if ( lcwork .ne. 0 )
     $   Call GetMem('CWORK','FREE','REAL',adrcwork,lcwork)
         if ( liwork .ne. 0 )
     $   Call GetMem('IWORK','FREE','INTE',adriwork,liwork)
         if ( iclu .ne. 0 )
     $   Call GetMem('ICLUS','FREE','INTE',adrclustr,iclu)
         if ( ngaps.ne.0 )
     $   Call GetMem('GAP','FREE','REAL',adrgaps,ngaps)
         if ( elemB .ne. 0 )
     $   Call GetMem('B','FREE','REAL',adrB,elemB)
         if ( elemA .ne. 0 )
     $   Call GetMem('A','FREE','REAL',adrA,elemA)
         Call GetMem('IFAIL','FREE','INTE',adrfail,dimA18)
      endif
c
      call ga_sync()
      if(maxproc.lt.nnodes.or.dima1.le.nb) then
c     broadcast evals
        Call GA_Brdcst(MT_DBL, eval, dima18, 0)
      endif
      return
      end

      subroutine slinit2_(n)
      implicit none
#include "scalapack_.fh"
#include "global.fh"
      SCALAPACKINT n
c
      SCALAPACKINT zero4
      parameter(zero4=0)
      SCALAPACKINT slgetmxproc_
      external slgetmxproc_
c
      if(init2)return
c
c**** call ga_sync before to enter in BLACS and after
      call ga_sync()
c
      call blacs_pinfo(iam, nnodes)
c
c     determine optimal nprocs for eigensolvers based on matrix size n
c
      maxproc=slgetmxproc_(n,nnodes)
      call FindGrid_(maxproc, nprow2, npcol2)
c
      call blacs_get( zero4, zero4, islctxt2 )
      call blacs_gridinit(islctxt2, 'R', nprow2, npcol2)


c
      if(iam.lt.maxproc) then
         call blacs_gridinfo(iSLctxt2, nprow2, npcol2, myrow2, mycol2)
      else
         nprow2=0
         npcol2=0
         myrow2=0
         mycol2=0
      endif
      init2=.true.
c
      call ga_sync()

c
      end
c
      SCALAPACKINT function slgetmxproc_(n,nnodes)
      implicit none
      SCALAPACKINT nnodes
      SCALAPACKINT n
      SCALAPACKINT i
      real*8 fact
      SCALAPACKINT nmax,twoi
      real*8 nprocs0
      real*8 otto
      parameter(nmax=11,fact=((7108d0*7108d0)/1024d0),otto=8d0)
cnew      parameter(nmax=11,fact=((7108d0*7108d0)/512d0),otto=8d0)
c     lower bound of 8 procs
      nprocs0=max((n*n)/fact,otto)
c
c     try to get powers of two
c
      do i = nmax, 0, -1
         if(nint(nprocs0/(2d0**i)).eq.1) goto 1
      enddo
      i=4
1     twoi=2**i
      slgetmxproc_=min(nnodes,twoi)
      return
      end

      subroutine FindGrid_(nnodes, nprow, npcol)
c
c***  determine nprow, npcol from nnodes
c***  solution is searched in the neighborhood of the square grid
c
      implicit none
      SCALAPACKINT nnodes, nprow, npcol,i
c
c     try to get the 1:4 ratio
c
      npcol = 2*int(sqrt(dble(nnodes)))
      do i = npcol, 1, -1
         if(mod(nnodes,i).eq.0) goto 1
      enddo
1     continue
      npcol = i
      nprow = nnodes/npcol
      if(nprow.gt.npcol) then
         i=npcol
         npcol=nprow
         nprow=i
      endif
      end

      subroutine ga_to_SL2_(g_a, dim1, dim2, nbr, nbc, s_a, lda4)
c
c***  transforms a GA to SL format
c***  reference: Dongarra et al, 'A look at scalable dense lin. alg. libs'
c
c   g_a         - handle for Global Array that is being converted SL format
c   dim1, dim2  - dimensions of Global Array
c   nbr         - number of block rows?
c   nbc         - number of block columns?
c   s_a         - local array holding SL formatted data
c   lda4        - leading dimension of s_a
      implicit none
#include "scalapack_.fh"
#include "global.fh"
      SCALAPACKINT  nbr, nbc, lda4, dim1, dim2
      integer g_a
      real*8  s_a(lda4,*)
      integer row, col, tcol, trow, rbase, cbase
      SCALAPACKINT pcol, prow
      integer lda
      integer r0i,r1i,r0im1,r1im1,rowl,coll
      integer marg1,marg2
      logical putpending

c***  Synchronize at the beginning
c
      lda=lda4
      rbase = 1
      cbase = 1
c
      Trow = nbr * nprow2
      Tcol = nbc * npcol2
      do col  = 1, dim2, nbc
         ! processor column that holds "col"
         pcol = mod(col,Tcol)/nbc
         if(mycol2.eq.pcol) then
            r0im1=-9999
            r1im1=0
            putpending=.false.
            marg1=col+nbc-1
            marg2=dim2
            coll=min(marg1,marg2)

            do row  = 1, dim1, nbr
               ! processor row that holds "row"
               prow = mod(row,Trow)/nbr
               if(myrow2.eq.prow) then
                  if(.not.putpending) then
                     r0im1=row
                     marg1=row+nbr-1
                     marg2=dim1
                     r1im1=min(marg1,marg2)
                  endif
                  r0i=row
                  marg1=row+nbr-1
                  marg2=dim1
                  r1i=min(marg1,marg2)

                  if(r0i.eq.(r1im1+1).and.r1i.ne.dim1) then
                     r1im1=r1i
                     putpending=.true.
                  else
                  rowl=r1i
                  call ga_get(g_a,r0im1,rowl,col,
     $                    coll, s_a(rbase,cbase), lda)
                     putpending=.false.
                     rbase = rbase + rowl - r0im1 +1
                     r0im1=-1
                     r1im1=-1
                  endif
               endif
            enddo
            rbase = 1
            cbase = cbase + nbc
         endif
      enddo

c**** ... and at the end
      end



      subroutine ga_from_SL2_(g_a,dim1,dim2,nbr, nbc, s_a, lda4)
c
c***  transforms a matrix from SL to GA format
c***  reference: Dongarra et al, 'A look at scalable dense lin. alg. libs'
c
      implicit none
#include "scalapack_.fh"
#include "global.fh"
      integer g_a,lda
      SCALAPACKINT  nbr, nbc, lda4, dim1, dim2
      real*8 s_a(lda4,*)
      integer  tcol, trow
      integer rbase, cbase
      SCALAPACKINT pcol, prow
      integer row,col,rowl,coll
      integer r0i,r1i,r0im1,r1im1
      integer marg1,marg2
      logical putpending
c
      lda=lda4
c
c**** Syncronize at the beginning
c
      rbase = 1
      cbase = 1
c
      Trow = nbr * nprow2
      Tcol = nbc * npcol2
c
      do col  = 1, dim2, nbc
         ! processor column that holds "col"
         pcol = mod(col,Tcol)/nbc
         if(mycol2.eq.pcol) then
            r0im1=-9999
            r1im1=0
            putpending=.false.
            marg1=col+nbc-1
            marg2=dim2
            coll=min(marg1,marg2)
            do row  = 1, dim1, nbr
               ! processor row that holds "row"
               prow = mod(row,Trow)/nbr
               if(myrow2.eq.prow) then
                  if(.not.putpending) then
                     r0im1=row
                     marg1=row+nbr-1
                     marg2=dim1
                     r1im1=min(marg1,marg2)
                  endif
                  r0i=row
                  marg1=row+nbr-1
                  marg2=dim1
                  r1i=min(marg1,marg2)

                  if(r0i.eq.(r1im1+1).and.r1i.ne.dim1) then
                     r1im1=r1i
                     putpending=.true.
                  else
                  rowl=r1i
                  call ga_put(g_a,r0im1,rowl,col,
     $                    coll, s_a(rbase,cbase), lda)
                     putpending=.false.
                     rbase = rbase + rowl - r0im1 +1
                     r0im1=-1
                     r1im1=-1
                  endif
               endif
            enddo
            rbase = 1
            cbase = cbase + nbc
         endif
      enddo

c**** ... and at the end
      end
#else
      subroutine dummy_ga_pdsyevx()
      return
      end
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine prefac(Lmax,preroots,clebsch)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lmax
real(kind=wp), intent(out) :: preroots(2,0:Lmax), clebsch(3,2,-Lmax:Lmax,0:Lmax)
integer(kind=iwp) :: L, L2, M, M2
real(kind=wp) :: fact
real(kind=wp), external :: getCG

!bs the roots appearing in front of all
!bs the contributions
!write(u6,*) 'begin of prefac'
do L=0,Lmax
  fact = One/sqrt(real(L+L+1,kind=wp))
  preroots(1,L) = sqrt(real(L,kind=wp))*fact
  preroots(2,L) = sqrt(real(L+1,kind=wp))*fact
end do
!bs there are Clebsch-Gordan-Coefficients
!bs which always appear:
!bs
!bs   -----                       ------
!bs  |                                 |
!bs  |  l +/- 1     1        |      l  |
!bs  |                       |         |
!bs  |                       |         |
!bs  |  m+/-1,0   -1,1,0     |      m  |
!bs  |                       |         |
!bs  |                                 |
!bs   -----                       -----
!bs
!bs
!bs array clebsch (3,2,-Lmax:Lmax,0:Lmax)
!bs first index    1:  m-1
!bs                2:  m
!bs                3:  m+1
!bs second index   1:  l-1
!bs                2:  l+1
!bs third index        m
!bs fourth index       l

!write(u6,*),'start to generate CGs'
do L=0,Lmax
  L2 = 2*L
  do M=-L,L
    !write(u6,*) 'L,M: ',L,M
    M2 = 2*M
    !bs getCG calculates CG-coeffecients. In order to avoid fractions,
    !bs e.g. for spins, arguments are doubled values...
    clebsch(1,1,M,L) = getCG(L2-2,2,L2,M2-2,2,M2)
    clebsch(2,1,M,L) = getCG(L2-2,2,L2,M2,0,M2)
    clebsch(3,1,M,L) = getCG(L2-2,2,L2,M2+2,-2,M2)
    clebsch(1,2,M,L) = getCG(L2+2,2,L2,M2-2,2,M2)
    clebsch(2,2,M,L) = getCG(L2+2,2,L2,M2,0,M2)
    clebsch(3,2,M,L) = getCG(L2+2,2,L2,M2+2,-2,M2)
  end do
end do

return

end subroutine prefac

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_QUALIFY(DIAG,ISHLAB,ISYMAX,MEM,FULL)
C
C     Purpose: qualify diagonal elements for decomposition in
C              current reduced set. ISYMAX is the symmetry block
C              to which the largest diagonal belongs.
C              MEM is the (total!) max. allowed
C              memory for storing the qualified columns.
C              If no more columns can be qualified on exit,
C              FULL=.true. is returned.
C
      use ChoArr, only: iSP2F
      use ChoSwp, only: iQuAB, nnBstRSh, iiBstRSh, IndRed
#include "implicit.fh"
      DIMENSION DIAG(*)
      LOGICAL   FULL
#include "cholesky.fh"

      INTEGER  CHO_IDOT
      EXTERNAL CHO_IDOT

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_QUALIFY')

      LOGICAL LOCDBG
#if defined (_DEBUGPRINT_)
      PARAMETER (LOCDBG = .TRUE.)
#else
      PARAMETER (LOCDBG = .FALSE.)
#endif

C     Copy counter to offset array.
C     -----------------------------

      CALL ICOPY(NSYM,NQUAL,1,IOFFQ,1)

C     Check memory.
C     -------------

      MEM0 = CHO_IDOT(NSYM,NQUAL,1,NNBSTR(1,2),1)
      LEFT = MEM - MEM0
      IF (IALQUA .EQ. 0) THEN
         MINM = NNBSTR(1,2)
         DO ISYM = 1,NSYM
            MINM = MAX(MINM,NNBSTR(ISYM,2))
         END DO
      ELSE
         MINM = NNBSTR(ISYMAX,2)
      END IF
      FULL = LEFT .LT. MINM
      IF (FULL) RETURN

C     Qualify.
C     --------

      IF (IALQUA .EQ. 0) THEN  ! qualify until full (dalton style)
         DO ISYM = 1,NSYM
            CALL CHO_QUALIFY_1(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
         END DO
      ELSE IF (IALQUA .EQ. 1) THEN  ! qualify until full
         CALL CHO_QUALIFY_1(DIAG,ISYMAX,ISHLAB,MEM,MEM0,LEFT)
         DO ISYM = 1,ISYMAX-1
            CALL CHO_QUALIFY_1(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
         END DO
         DO ISYM = ISYMAX+1,NSYM
            CALL CHO_QUALIFY_1(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
         END DO
      ELSE ! qualify until full, then largest
         CALL CHO_QUALIFY_2(DIAG,ISYMAX,ISHLAB,MEM,MEM0,LEFT)
         DO ISYM = 1,ISYMAX-1
            CALL CHO_QUALIFY_2(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
         END DO
         DO ISYM = ISYMAX+1,NSYM
            CALL CHO_QUALIFY_2(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
         END DO
      END IF

C     Set FULL flag:
C     FULL=.true. if a) not enough memory to qualify another column of
C     any symmetry, or b) MAXQUAL reached in any symmetry.
C     ----------------------------------------------------------------

      NEED = CHO_IDOT(NSYM,NQUAL,1,NNBSTR(1,2),1)
      IF (NEED.LT.1 .OR. NEED.GT.MEM) THEN
         CALL CHO_QUIT('Logical error (2) in '//SECNAM,104)
      ELSE
         LEFT = MEM - NEED
         FULL = .FALSE.
         ISYM = 0
         DO WHILE (ISYM.LT.NSYM .AND. .NOT.FULL)
            ISYM = ISYM + 1
            IF (NQUAL(ISYM).LT.IOFFQ(ISYM) .OR. NQUAL(ISYM).LT.0 .OR.
     &          NQUAL(ISYM).GT.MAXQUAL) THEN
               CALL CHO_QUIT('Logical error (3) in '//SECNAM,104)
            ELSE
               FULL = NQUAL(ISYM) .EQ. MAXQUAL
            END IF
            IF (NNBSTR(ISYM,2) .GT. 0) THEN
               FULL = FULL .OR. LEFT.LT.NNBSTR(ISYM,2)
            END IF
         END DO
      END IF

C     Debug: print.
C     -------------

      IF (LOCDBG) THEN
         CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.TRUE.)
         WRITE(LUPRI,*)
         WRITE(LUPRI,*)
         WRITE(LUPRI,*) SECNAM,': qualified diagonals from shell-pair ',
     &                  ISHLA,ISHLB,':'
         WRITE(LUPRI,*) 'Qualification algorithm: ',IALQUA
         WRITE(LUPRI,*) 'Total memory for qualification: ',MEM,
     &                  '  Memory left: ',LEFT
         DO ISYM = 1,NSYM
            NUM = NQUAL(ISYM) - IOFFQ(ISYM)
            WRITE(LUPRI,*)
            WRITE(LUPRI,*) 'Sym.,dimension,#qualified,threshold: ',
     &                     ISYM,NNBSTRSH(ISYM,ISHLAB,2),NUM,DIAMIN(ISYM)
            IF (NNBSTRSH(ISYM,ISHLAB,2) .GT. 0) THEN
               I1 = IIBSTR(ISYM,2) + IIBSTRSH(ISYM,ISHLAB,2) + 1
               I2 = I1 + NNBSTRSH(ISYM,ISHLAB,2) - 1
               WRITE(LUPRI,*) 'Diagonal (current reduced set):'
               WRITE(LUPRI,'(5F15.8)') (DIAG(INDRED(I,2)), I=I1,I2)
               K1 = IOFFQ(ISYM) + 1
               K2 = NQUAL(ISYM)
               WRITE(LUPRI,*) 'Qualified diagonals:'
               WRITE(LUPRI,'(5F15.8)') (DIAG(INDRED(IQUAB(K,ISYM),2)),
     &                                  K = K1,K2)
            END IF
         END DO
         WRITE(LUPRI,*)
         WRITE(LUPRI,*)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Int_Options

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: iTOffs(8**3)
real(kind=wp) :: Disc = Zero, Disc_Mx = Zero, ExFac = Zero, Quad_ijkl = Zero, Thize = Zero
logical(kind=iwp) :: DoFock = .false., DoIntegrals = .true., FckNoClmb = .false., FckNoExch = .false., PreSch = .true., &
                     W2Disc = .false.

public :: Disc, Disc_Mx, DoFock, DoIntegrals, ExFac, FckNoClmb, FckNoExch, Init_Int_Options, iTOffs, PreSch, Quad_ijkl, Thize, &
          W2Disc

contains

subroutine Init_Int_Options()

  ! Default values
  DoFock = .false.
  DoIntegrals = .true.
  FckNoClmb = .false.
  FckNoExch = .false.
  PreSch = .true.
  W2Disc = .false.
  Disc = Zero
  Disc_Mx = Zero
  ExFac = Zero
  Quad_ijkl = Zero
  Thize = Zero

end subroutine Init_Int_Options

end module Int_Options

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function MorsPop(IMORS)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: MorsPop
integer(kind=iwp), intent(in) :: IMORS
integer(kind=iwp) :: I1, I2, I3, J
integer(kind=iwp), parameter :: NUM(0:15) = [0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4]

MorsPop = 0 ! dummy initialize
if (IMORS >= 0) then
  I1 = IMORS/16
  J = IMORS-16*I1
  MorsPop = NUM(J)
  if (I1 == 0) return
  I2 = I1/16
  J = I1-16*I2
  MorsPop = MorsPop+NUM(J)
  if (I2 == 0) return
  I3 = I2/16
  J = I2-16*I3
  MorsPop = MorsPop+NUM(J)
  if (I3 == 0) return
end if
write(u6,*) ' MorsPop: Bad IMORS=',IMORS
call ABEND()

end function MorsPop

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Susi Lehtola                                     *
!               2022, Roland Lindh                                     *
!***********************************************************************

subroutine libxc_interface(xc_func,xc_info,mGrid,nD,F_xc,Coeff)

use xc_f03_lib_m, only: XC_EXCHANGE, xc_f03_func_info_get_family, xc_f03_func_info_get_kind, xc_f03_func_info_t, xc_f03_func_t, &
                        xc_f03_gga_exc, xc_f03_gga_exc_vxc, xc_f03_lda_exc, xc_f03_lda_exc_vxc, xc_f03_mgga_exc, &
                        xc_f03_mgga_exc_vxc, XC_FAMILY_GGA, XC_FAMILY_HYB_GGA, XC_FAMILY_HYB_MGGA, XC_FAMILY_LDA, XC_FAMILY_MGGA
use nq_Grid, only: F_xca, F_xcb, l_casdft, Lapl, Rho, Sigma, Tau, vLapl, vRho, vSigma, vTau
use libxc, only: dfunc_dLapl, dfunc_drho, dfunc_dSigma, dfunc_dTau, func, Only_exc
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, LibxcReal, LibxcSize

implicit none
type(xc_f03_func_t), intent(in) :: xc_func      ! xc functional
type(xc_f03_func_info_t), intent(in) :: xc_info ! xc functional info
integer(kind=iwp), intent(in) :: mGrid, nD
real(kind=wp), intent(inout) :: F_xc(mGrid)
real(kind=wp), intent(in) :: Coeff
integer(kind=iwp) :: iGrid

if ((LibxcSize /= iwp) .or. (LibxcReal /= wp)) then
  write(u6,*) 'Libxc type mismatch!'
  call abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Evaluate energy depending on the family
select case (xc_f03_func_info_get_family(xc_info))
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  case (XC_FAMILY_LDA)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    func(1:mGrid) = Zero ! Initialize memory
    dfunc_drho(:,1:mGrid) = Zero

    if (Only_exc) then
      call xc_f03_lda_exc(xc_func,mGrid,Rho(1,1),func(1))
    else
      call xc_f03_lda_exc_vxc(xc_func,mGrid,Rho(1,1),func(1),dfunc_drho(1,1))
    end if

    ! Libxc evaluates energy density per particle; multiply by
    ! density to get out what we really want
    ! Collect the potential

    if (nD == 1) then
      if (Only_exc) then
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*Rho(1,iGrid)
        end do
      else
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*Rho(1,iGrid)
          vRho(1,iGrid) = vRho(1,iGrid)+Coeff*dfunc_drho(1,iGrid)
        end do
      end if
    else
      if (Only_exc) then
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*(Rho(1,iGrid)+Rho(2,iGrid))
        end do
      else
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*(Rho(1,iGrid)+Rho(2,iGrid))
          vRho(1,iGrid) = vRho(1,iGrid)+Coeff*dfunc_drho(1,iGrid)
          vRho(2,iGrid) = vRho(2,iGrid)+Coeff*dfunc_drho(2,iGrid)
        end do
      end if

      if (l_casdft) then
        select case (xc_f03_func_info_get_kind(xc_info))
          case (XC_EXCHANGE)
            dFunc_dRho(:,1:mGrid) = Rho(:,1:mGrid)
            Rho(2,1:mGrid) = Zero
            func(1:mGrid) = Zero
            call xc_f03_lda_exc(xc_func,mGrid,Rho(1,1),func(1))
            do iGrid=1,mGrid
              F_xca(iGrid) = F_xca(iGrid)+Coeff*func(iGrid)*Rho(1,iGrid)
            end do
            Rho(1,1:mGrid) = Zero
            Rho(2,1:mGrid) = dFunc_dRho(2,1:mGrid)
            func(:) = Zero
            call xc_f03_lda_exc(xc_func,mGrid,Rho(1,1),func(1))
            do iGrid=1,mGrid
              F_xcb(iGrid) = F_xcb(iGrid)+Coeff*func(iGrid)*Rho(2,iGrid)
            end do
            Rho(:,1:mGrid) = dFunc_dRho(:,1:mGrid)
        end select
      end if
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  case (XC_FAMILY_GGA,XC_FAMILY_HYB_GGA)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    func(1:mGrid) = Zero ! Initialize memory
    dfunc_drho(:,1:mGrid) = Zero
    dfunc_dSigma(:,1:mGrid) = Zero

    if (Only_exc) then
      call xc_f03_gga_exc(xc_func,mGrid,Rho(1,1),Sigma(1,1),func(1))
    else
      call xc_f03_gga_exc_vxc(xc_func,mGrid,Rho(1,1),Sigma(1,1),func(1),dfunc_dRho(1,1),dfunc_dSigma(1,1))
    end if

    ! Libxc evaluates energy density per particle; multiply by
    ! density to get out what we really want
    ! Collect the potential

    if (nD == 1) then
      if (Only_exc) then
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*Rho(1,iGrid)
        end do
      else
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*Rho(1,iGrid)
          vRho(1,iGrid) = vRho(1,iGrid)+Coeff*dfunc_drho(1,iGrid)
          vSigma(1,iGrid) = vSigma(1,iGrid)+Coeff*dfunc_dSigma(1,iGrid)
        end do
      end if
    else
      if (Only_exc) then
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*(Rho(1,iGrid)+Rho(2,iGrid))
        end do
      else
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*(Rho(1,iGrid)+Rho(2,iGrid))
          vRho(1,iGrid) = vRho(1,iGrid)+Coeff*dfunc_drho(1,iGrid)
          vRho(2,iGrid) = vRho(2,iGrid)+Coeff*dfunc_drho(2,iGrid)
          vSigma(1,iGrid) = vSigma(1,iGrid)+Coeff*dfunc_dSigma(1,iGrid)
          vSigma(2,iGrid) = vSigma(2,iGrid)+Coeff*dfunc_dSigma(2,iGrid)
          vSigma(3,iGrid) = vSigma(3,iGrid)+Coeff*dfunc_dSigma(3,iGrid)
        end do
      end if

      if (l_casdft) then
        select case (xc_f03_func_info_get_kind(xc_info))
          case (XC_EXCHANGE)
            dFunc_dRho(:,1:mGrid) = Rho(:,1:mGrid)
            Rho(2,1:mGrid) = Zero
            func(1:mGrid) = Zero
            call xc_f03_gga_exc(xc_func,mGrid,Rho(1,1),Sigma(1,1),func(1))
            do iGrid=1,mGrid
              F_xca(iGrid) = F_xca(iGrid)+Coeff*func(iGrid)*Rho(1,iGrid)
            end do
            Rho(1,1:mGrid) = Zero
            Rho(2,1:mGrid) = dFunc_dRho(2,:)
            func(1:mGrid) = Zero
            call xc_f03_gga_exc(xc_func,mGrid,Rho(1,1),Sigma(1,1),func(1))
            do iGrid=1,mGrid
              F_xcb(iGrid) = F_xcb(iGrid)+Coeff*func(iGrid)*Rho(2,iGrid)
            end do
            Rho(:,1:mGrid) = dFunc_dRho(:,1:mGrid)
        end select
      end if
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  case (XC_FAMILY_MGGA,XC_FAMILY_HYB_MGGA)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    func(1:mGrid) = Zero ! Initialize memory
    dfunc_drho(:,1:mGrid) = Zero
    dfunc_dSigma(:,1:mGrid) = Zero
    if (allocated(Tau)) dfunc_dTau(:,1:mGrid) = Zero
    if (allocated(Lapl)) dfunc_dLapl(:,1:mGrid) = Zero

    if (Only_exc) then
      call xc_f03_mgga_exc(xc_func,mGrid,Rho(1,1),Sigma(1,1),Lapl(1,1),Tau(1,1),func(1))
    else
      call xc_f03_mgga_exc_vxc(xc_func,mGrid,Rho(1,1),Sigma(1,1),Lapl(1,1),Tau(1,1),func(1),dfunc_dRho(1,1),dfunc_dSigma(1,1), &
                               dfunc_dLapl(1,1),dfunc_dTau(1,1))
    end if

    ! Libxc evaluates energy density per particle; multiply by
    ! density to get out what we really want
    ! Collect the potential

    if (nD == 1) then
      if (Only_exc) then
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*Rho(1,iGrid)
        end do
      else
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*Rho(1,iGrid)
          vRho(1,iGrid) = vRho(1,iGrid)+Coeff*dfunc_drho(1,iGrid)
          vSigma(1,iGrid) = vSigma(1,iGrid)+Coeff*dfunc_dSigma(1,iGrid)
        end do
        if (allocated(Tau)) then
          do iGrid=1,mGrid
            vTau(1,iGrid) = vTau(1,iGrid)+Coeff*dfunc_dTau(1,iGrid)
          end do
        end if
        if (allocated(Lapl)) then
          do iGrid=1,mGrid
            vLapl(1,iGrid) = vLapl(1,iGrid)+Coeff*dfunc_dLapl(1,iGrid)
          end do
        end if
      end if
    else
      if (Only_exc) then
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*(Rho(1,iGrid)+Rho(2,iGrid))
        end do
      else
        do iGrid=1,mGrid
          F_xc(iGrid) = F_xc(iGrid)+Coeff*func(iGrid)*(Rho(1,iGrid)+Rho(2,iGrid))
          vRho(1,iGrid) = vRho(1,iGrid)+Coeff*dfunc_drho(1,iGrid)
          vRho(2,iGrid) = vRho(2,iGrid)+Coeff*dfunc_drho(2,iGrid)
          vSigma(1,iGrid) = vSigma(1,iGrid)+Coeff*dfunc_dSigma(1,iGrid)
          vSigma(2,iGrid) = vSigma(2,iGrid)+Coeff*dfunc_dSigma(2,iGrid)
          vSigma(3,iGrid) = vSigma(3,iGrid)+Coeff*dfunc_dSigma(3,iGrid)
        end do
        if (allocated(Tau)) then
          do iGrid=1,mGrid
            vTau(1,iGrid) = vTau(1,iGrid)+Coeff*dfunc_dTau(1,iGrid)
            vTau(2,iGrid) = vTau(2,iGrid)+Coeff*dfunc_dTau(2,iGrid)
          end do
        end if
        if (allocated(Lapl)) then
          do iGrid=1,mGrid
            vLapl(1,iGrid) = vLapl(1,iGrid)+Coeff*dfunc_dLapl(1,iGrid)
            vLapl(2,iGrid) = vLapl(2,iGrid)+Coeff*dfunc_dLapl(2,iGrid)
          end do
        end if
      end if

      if (l_casdft) then
        write(u6,*) 'Uncharted territory!'
        call Abend()
        select case (xc_f03_func_info_get_kind(xc_info))
          case (XC_EXCHANGE)
            dFunc_dRho(:,1:mGrid) = Rho(:,1:mGrid)
            Rho(2,1:mGrid) = Zero
            func(1:mGrid) = Zero
            call xc_f03_mgga_exc(xc_func,mGrid,Rho(1,1),Sigma(1,1),Lapl(1,1),Tau(1,1),func(1))
            do iGrid=1,mGrid
              F_xca(iGrid) = F_xca(iGrid)+Coeff*func(iGrid)*Rho(1,iGrid)
            end do
            Rho(1,1:mGrid) = Zero
            Rho(2,1:mGrid) = dFunc_dRho(2,:)
            func(1:mGrid) = Zero
            call xc_f03_mgga_exc(xc_func,mGrid,Rho(1,1),Sigma(1,1),Lapl(1,1),Tau(1,1),func(1))
            do iGrid=1,mGrid
              F_xcb(iGrid) = F_xcb(iGrid)+Coeff*func(iGrid)*Rho(2,iGrid)
            end do
            Rho(:,1:mGrid) = dFunc_dRho(:,1:mGrid)
        end select
      end if
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  case default
    write(u6,*) 'Libxc family not properly identified.'
    call Abend()
    !                                                                  *
    !*******************************************************************
    !                                                                  *
end select
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine libxc_interface

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine appendchr_cvb(c,string,iskip)
      implicit REAL*8 (a-h,o-z)
      character*(*)c,string

      ibegin=len_trim_cvb(c)+1+iskip
      iend=min(len(c),ibegin+len_trim_cvb(string)-1)
      c(ibegin:iend)=string(1:len_trim_cvb(string))
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MSTOW(SGS,CIS,MWS2W,nSym)

use sguga, only: CIStruct, SGStruct
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

#include "intent.fh"

implicit none
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(in) :: CIS
integer(kind=iwp), intent(_OUT_) :: MWS2W(*)
integer(kind=iwp), intent(in) :: nSym
integer(kind=iwp) :: MIDLEV, NIPWLK, NLEV, NMIDV, NVERT, NWALK
integer(kind=iwp), allocatable :: ICS(:)

NLEV = SGS%nLev
NVERT = SGS%nVert
MIDLEV = SGS%MidLev

NMIDV = CIS%nMidV
NIPWLK = CIS%nIpWlk
NWALK = CIS%nWalk
call mma_allocate(ICS,NLEV,Label='ICS')
call MSTOW1(NSYM,NLEV,NVERT,NMIDV,NIPWLK,NWALK,MIDLEV,ICS,CIS%NOW,CIS%IOW,CIS%ICase,SGS%UP,SGS%DOWN,SGS%MAW,MWS2W)
call mma_deallocate(ICS)

end subroutine MSTOW

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine XDR_mkutls(n,TL,TS,Tr,Bk,A,B,R,UL,US,M1,M2,M3,M4)
C
C Evaluate transform matrices in non-orthogonal basis space
C
      implicit none
C Input
      integer n
      Real*8 TL(n,n),TS(n,n),Tr(n,n),Bk(n,n),A(n),B(n),R(n)
C Output
      Real*8 UL(n,n),US(n,n)
C Temp
      integer i,j
      Real*8 M1(n,n),M2(n,n),M3(n,n),M4(n,n)
C
      do i=1,n
        do j=1,n
          M1(j,i) = Tr(j,i) * A(i)
          M2(j,i) = Tr(j,i) * A(i) * R(i)
        end do
      end do
      call dmxma(n,'N','N',M1,TL,M3,1.d0)
      call dmxma(n,'N','N',M2,TS,M4,1.d0)
      do i=1,n
        do j=1,n
          M3(j,i) = M3(j,i) - M4(j,i)
        end do
      end do
      call dmxma(n,'N','N',M3,Bk,UL,1.d0)
C
      do i=1,n
        do j=1,n
          M1(j,i) = Tr(j,i) * B(i)
          M2(j,i) = Tr(j,i) * B(i) / R(i)
        end do
      end do
      call dmxma(n,'N','N',M1,TL,M3,1.d0)
      call dmxma(n,'N','N',M2,TS,M4,1.d0)
      do i=1,n
        do j=1,n
          M3(j,i) = M3(j,i) + M4(j,i)
        end do
      end do
      call dmxma(n,'N','N',M3,Bk,US,1.d0)
C
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine Precibb(ib,is,js,nd,rout,no,Temp1,Scr,Temp2,fockii,fockai,focki,focka,Sgn)
!***********************************************************************
!                                       [2]
! Calculates the diagonal submatrix of E    that couple
!
! kappa           with   kappa                for a
!      kinactive,virtual        kinactive,virtual
!
! single inactive index.
! Used for preconditioner.
!
! See Olsen,Yeager, Joergensen:
!  "Optimization and characterization of an MCSCF state"
!
! Called by prec
!
! ib,is       :       inactive index for the submatrix
! js          :       symmetry of virtual,virtual
! rOut        :       Submatrix
!
!***********************************************************************

use Index_Functions, only: nTri_Elem
use input_mclr, only: nAsh, nIsh, nOrb
use Constants, only: Four, Twelve
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ib, is, js, nd, no
real(kind=wp), intent(inout) :: rout(*)
real(kind=wp), intent(out) :: Temp1(no,no), Temp2(no,no)
real(kind=wp), intent(_OUT_) :: Scr(*)
real(kind=wp), intent(in) :: fockii, fockai, Focki(no,no), Focka(no,no), Sgn
integer(kind=iwp) :: i, ip, jVert, kB
real(kind=wp) :: ra

!                                                                      *
!***********************************************************************
!                                                                      *
jVert = nOrb(js)-nAsh(js)-nIsh(js)
if (jvert == 0) return

ip = nTri_Elem(nd)-nTri_Elem(jVert)+1
ra = Four*Sgn*(Fockii+Fockai)
call COUL(jS,jS,iS,is,IB,iB,Temp2,Scr)
Temp1(:,:) = -Sgn*Four*Temp2(:,:)
call EXCH(js,is,js,is,ib,ib,Temp2,Scr)
Temp1(:,:) = Temp1(:,:)+Sgn*Twelve*Temp2(:,:)
i = ip
do kB=nIsh(jS)+nAsh(jS)+1,nOrb(jS)
  rOut(i) = rout(i)-ra
  rOut(i:i+nOrb(jS)-kB) = rOut(i:i+nOrb(jS)-kB)+Temp1(kB,kB:nOrb(jS))+Sgn*Four*(Focki(kB,kB:nOrb(jS))+Focka(kB,kB:nOrb(jS)))
  i = i+nOrb(jS)-kB+1
end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Precibb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_T_buffer

   USE fmm_global_paras
   USE fmm_stats

   IMPLICIT NONE
   PRIVATE
   ! public procedures
   PUBLIC :: fmm_add_to_T_buffer,   &
             fmm_open_T_buffer,     &
             fmm_close_T_buffer

   ! only one T_buffer can be open at once
   INTEGER(INTK), SAVE :: buffer = -1

   ! diagnostic flag
   CHARACTER(LEN=4), SAVE :: T_buffer_stat

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_add_to_T_buffer(T_pair)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: T_pair
      EXTERNAL fmm_selected_t_buffer
      EXTERNAL fmm_selected_t_contractor

      CALL fmm_selected_t_buffer(fmm_selected_t_contractor,T_pair)

   END SUBROUTINE fmm_add_to_T_buffer

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_close_T_buffer(scheme)

      USE fmm_T_contractors,  ONLY: fmm_lock_T_con
      USE fmm_tree_buffer,    ONLY: fmm_tree_buffer_finish
      USE fmm_multi_T_buffer, ONLY: fmm_free_multi_T_buffer
      USE fmm_scale_T_buffer, ONLY: fmm_free_scale_T_buffer

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      EXTERNAL fmm_selected_t_contractor

      IF (T_buffer_stat /= 'OPEN') CALL fmm_quit ('T_buffer already closed!')

      SELECT CASE (buffer)
         CASE (SKIP_T_BUFFER)
            ! do nothing
         CASE (NULL_T_BUFFER)
            ! do nothing
         CASE (TREE_T_BUFFER)
            CALL fmm_tree_buffer_finish(fmm_selected_t_contractor)
         CASE (MULTI_T_BUFFER)
            CALL fmm_free_multi_T_buffer(fmm_selected_t_contractor)
         CASE (SCALE_T_BUFFER)
            CALL fmm_free_scale_T_buffer(fmm_selected_t_contractor)
         CASE DEFAULT
            CALL fmm_quit ('cannot reconcile list type in fmm_close_T_buffer')
      END SELECT

      T_buffer_stat = 'FREE'
      fmm_lock_T_con = .FALSE.

! Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(scheme%phase)
   END SUBROUTINE fmm_close_T_buffer

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_null_T_buffer(T_contractor,T_pair)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: T_pair
      EXTERNAL T_contractor

      stat_tpack_total = stat_tpack_total + one
      CALL T_contractor(T_pair)

   END SUBROUTINE fmm_null_T_buffer

!-------------------------------------------------------------------------------
! for diagnostic use only

   SUBROUTINE fmm_skip_T_buffer(T_contractor,T_pair)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: T_pair
      EXTERNAL T_contractor

      stat_T_mat_builds = stat_T_mat_builds + 1
      RETURN

! Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL T_contractor(T_pair)
      END IF
   END SUBROUTINE fmm_skip_T_buffer

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_open_T_buffer(scheme)

      USE fmm_T_contractors,  ONLY: fmm_lock_T_con
      USE fmm_tree_buffer,    ONLY: fmm_tree_buffer_init,        &
                                    fmm_tree_buffer_add
      USE fmm_multi_T_buffer, ONLY: fmm_init_multi_T_buffer,     &
                                    fmm_multi_T_buffer_add
      USE fmm_scale_T_buffer, ONLY: fmm_init_scale_T_buffer,     &
                                    fmm_scale_T_buffer_add

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      INTEGER(INTK) :: sort_para
      EXTERNAL fmm_store_t_buffer

      CALL fmm_init_buffer_stats('T')
      IF (T_buffer_stat == 'OPEN') CALL fmm_quit('cannot reopen T_buffer')

      IF (scheme%phase == NEAR_FIELD) THEN
         buffer = scheme%T_con%NF_T_buffer
         sort_para = scheme%T_con%NF_sort_para
      ELSE
         buffer = scheme%T_con%FF_T_buffer
         sort_para = scheme%T_con%FF_sort_para
      END IF

      SELECT CASE (buffer)
         CASE (SKIP_T_BUFFER)
            ! all T-contractions will be skipped by this choice of buffer
            CALL fmm_store_t_buffer(fmm_skip_T_buffer)
         CASE (NULL_T_BUFFER)
            CALL fmm_store_t_buffer(fmm_null_T_buffer)
         CASE (TREE_T_BUFFER)
             ! use tree-based sorting/evaluating module
            CALL fmm_store_t_buffer(fmm_tree_buffer_add)
            CALL fmm_tree_buffer_init(TREE_LENGTH,sort_para)
         CASE (SCALE_T_BUFFER)
             ! use tree-based sorting/evaluating module
            CALL fmm_store_t_buffer(fmm_scale_T_buffer_add)
            CALL fmm_init_scale_T_buffer
         CASE (MULTI_T_BUFFER)
             ! use buffer to drive multiple T matrix simultaneous build
            CALL fmm_store_t_buffer(fmm_multi_T_buffer_add)
            CALL fmm_init_multi_T_buffer(TMATM_DF)
         CASE DEFAULT
            CALL fmm_quit ('cannot reconcile list type in fmm_open_T_buffer')
      END SELECT

      T_buffer_stat = 'OPEN'
      fmm_lock_T_con = .TRUE.

   END SUBROUTINE fmm_open_T_buffer

!-------------------------------------------------------------------------------

END MODULE fmm_T_buffer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Free_iWork
*
*> @brief
*>   Deallocate memory in \c iWork associated with pointer \p ip
*> @author Roland Lindh
*>
*> @details
*> The array associated to pointer/identifier \p ip in \c iWork is deallocated.
*>
*> @param[in,out] ip pointer to memory in \c iWork
************************************************************************
      Subroutine Free_iWork(ip)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
*
      Call GetMem('AiW','Free','Inte',ip,nDum)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine FIND_ACTIVE_BLOCKS(LUIN,LBLK,BLK_A,SEGMNT)
! Find the active (nonvanishing blocks) on LUIN
! Non vanishing block is flagged by a 1.0 (note : real)
! in BLK_A

use lucia_data, only: IDISK
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: LUIN, LBLK
real(kind=wp), intent(_OUT_) :: BLK_A(*), SEGMNT(*)
integer(kind=iwp) :: IAMPACK, IBLK, IDUMMY(1), IMZERO, KBLK, LBL(1), NBLK_A, NO_ZEROING
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: NBLK
#endif

IDISK(LUIN) = 0

IBLK = 0
NBLK_A = 0
! Loop over blocks
do
  IBLK = IBLK+1
  if (LBLK > 0) then
    LBL(1) = LBLK
  else if (LBLK == 0) then
    call IDAFILE(LUIN,2,LBL,1,IDISK(LUIN))
  else if (LBLK < 0) then
    call IDAFILE(LUIN,2,LBL,1,IDISK(LUIN))
    call IDAFILE(LUIN,2,IDUMMY,1,IDISK(LUIN))
  end if
  if (LBL(1) >= 0) then
    if (LBLK >= 0) then
      KBLK = LBL(1)
    else
      KBLK = -1
    end if
    NO_ZEROING = 1
    call FRMDSC2(SEGMNT,LBL(1),KBLK,LUIN,IMZERO,IAMPACK,NO_ZEROING)
    if (IMZERO == 0) then
      NBLK_A = NBLK_A+1
      BLK_A(IBLK) = One
    else
      BLK_A(IBLK) = Zero
    end if
  end if
  if ((LBL(1) < 0) .or. (LBLK > 0)) exit
end do

#ifdef _DEBUGPRINT_
NBLK = IBLK-1
write(u6,*) ' FIND_A.... Number of total and active Blocks',NBLK,NBLK_A
write(u6,*) ' Active blocks'
call WRTMAT(BLK_A,1,NBLK,1,NBLK)
#endif

end subroutine FIND_ACTIVE_BLOCKS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000-2016, Valera Veryazov                             *
!***********************************************************************
!*****************************************************************************
!                                                                            *
! Author:   Valera Veryazov 2000-2016                                        *
!           Theoretical Chemistry                                            *
!           Lund University                                                  *
!           Sweden                                                           *
!                                                                            *
!*****************************************************************************

subroutine systemf(c,rc)

use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: C
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: i, LenC
character(len=1024) :: C2
integer(kind=iwp), external :: StrnLn
interface
  subroutine systemc(c,lc,RCC) bind(C,name='systemc_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    character(kind=c_char) :: c(*)
    integer(kind=MOLCAS_C_INT) :: lc, RCC
  end subroutine systemc
end interface

LenC = StrnLn(C)
if (LenC > 1024-1) then
  write(u6,*) ' Error in systemf.f ! LenC :',LenC
  call abend()
end if

do i=1,lenc
  c2(i:i) = c(i:i)
end do
call systemc(c2,lenc,rc)

return

end subroutine systemf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Find_Dipole_Center(q_A,q_B,Dipole_A,Dipole_B,qn_A,qn_B,
     &                              R_A,R_B,EC_A,EC_B,EC_AB,t,iPlot)
      Implicit Real*8 (A-H,O-Z)
      Dimension EC_A(3),EC_B(3),EC_AB(3)
      Real*8 Multipole_Expansion
      External Multipole_Expansion,Golden2
      Logical Absolute
      Parameter (Absolute = .False.)
      Parameter (E_Threshold = 1.0D-12, R_Threshold = 1.0D-12)
#include "real.fh"
*
      R = R_B - R_A
*
      nSteps = 100
      Delta  = R/(DBLE(nSteps)+1.0D0)
      R_Test = R_A + Delta
      If (iPlot .eq. 1) Then
       write(6, *)'Electronic contributions: q_A, q_B = ',q_a,q_b
         DO i = 1,nSteps
            R_Test = R_A + Delta*DBLE(i)
            E = Multipole_Expansion(q_A,q_B,Dipole_A,Dipole_B,
     &                              R_A,R_B,R_Test,Absolute)
            Write(6,'(1X,A,F6.3,1X,F20.12)') 'R, E = ',R_test,E
            Call xFlush(6)
         End Do
         write(6, *)'Nuclear contributions: q_A, q_B = ',qn_A,qn_B
         DO i = 1,nSteps
            R_Test = R_A + Delta*DBLE(i)
            E = Multipole_Expansion(qn_A,qn_B,Zero,Zero,R_A,R_B,
     &                              R_Test,Absolute)
            Write(6,'(1X,A,F6.3,1X,F20.12)') 'R, E = ',R_test,E
            Call xFlush(6)
         End Do
       write(6, *)'Total contributions: q_A, q_B = ',q_a+qn_a,q_b+qn_b
         DO i = 1,nSteps
            R_Test = R_A + Delta*DBLE(i)
            E = Multipole_Expansion(q_A+qn_A,q_B+qn_B,Dipole_A,Dipole_B,
     &                              R_A,R_B,R_Test,Absolute)
            Write(6,'(1X,A,F6.3,1X,F20.12)') 'R, E = ',R_test,E
            Call xFlush(6)
         End Do
      End If
*
      ax = (R_A+R_B)*.5 + Delta
      bx = (R_A+R_B)*.5 - Delta
* First make an initial bracketing of the minima
      Call mnBrak2(ax,bx,cx,fa,fb,fc,multipole_expansion,q_a,q_b,
     &             dipole_a,dipole_b,r_a,r_b)
* Use Golden to find the minima
      golden = golden2(ax,bx,cx,multipole_expansion,r_threshold,
     &             e_threshold,r_best,q_a,q_b,
     &             dipole_a,dipole_b,r_a,r_b)
      t = (r_best-half*R)/R
      write(6,'(A,3F18.10)')
     &       't_el , r_best, golden = ',t, r_best, golden
      call xflush(6)
*
*
*
      ax = (R_A+R_B)*.5 + Delta
      bx = (R_A+R_B)*.5 - Delta
C      ax = -0.245
C      bx = -0.263
* First make an initial bracketing of the minima
      Call mnBrak2(ax,bx,cx,fa,fb,fc,multipole_expansion,qn_a,qn_b,
     &             zero,zero,r_a,r_b)
* Use Golden to find the minima
      golden = golden2(ax,bx,cx,multipole_expansion,r_threshold,
     &             e_threshold,r_best2,qn_a,qn_b,
     &             zero,zero,r_a,r_b)
      t = (r_best2-half*R)/R
      write(6,'(A,3F18.10)')
     &       't_nuc, r_best, golden = ',t, r_best2, golden
      call xflush(6)
      r_best = (abs(q_a+q_b)*R_best+abs(qn_a+qn_b)*R_best2)
     &               /(abs(q_a+q_b)+abs(qn_a+qn_b))
      t = (r_best-half*R)/R
      write(6,'(A,3F18.10)')
     &       't_fit, r_best, golden = ',t, r_best, golden
      call xflush(6)
*
*
*
C??      ax = (R_A+R_B)*.5 + Delta
C??      bx = (R_A+R_B)*.5 - Delta
C??C      ax = -0.245
C??C      bx = -0.263
C??* First make an initial bracketing of the minima
C??      Call mnBrak2(ax,bx,cx,fa,fb,fc,multipole_expansion,q_a+qn_a,
C??     &             q_b+qn_b,dipole_a,dipole_b,r_a,r_b)
C??* Use Golden to find the minima
C??      golden = golden2(ax,bx,cx,multipole_expansion,r_threshold,
C??     &             e_threshold,r_best,q_a+qn_a,q_b+qn_b,
C??     &             dipole_a,dipole_b,r_a,r_b)
C??      t = (r_best-half*R)/R
C??      write(6,'(A,3F18.10)')
C??     &       't_sum, r_best, golden = ',t, r_best, golden
C??      call xflush(6)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(EC_A)
         Call Unused_real_array(EC_B)
         Call Unused_real_array(EC_AB)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine WrCheck(Label,Arr,n)

use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: Arr(n)
real(kind=wp), external :: DDot_

write(u6,*) Label,DDot_(n,Arr,1,Arr,1),DDot_(n,Arr,1,[One],0),n

end subroutine WrCheck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Roland Lindh                                     *
!               2001, Laura Gagliardi                                  *
!***********************************************************************

subroutine AnMesh(nscheme,pa,rPt,wPt)

use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nscheme(8)
real(kind=wp), intent(in) :: pa(*)
real(kind=wp), intent(_OUT_) :: rPt(3,*), wPt(*)
integer(kind=iwp) :: i, ii, ip, ix, iy, iz, j, j1, jj, n1
real(kind=wp) :: c, pp, qq, rr, ss, tt, uu, vv

!                                                                      *
!***********************************************************************
!                                                                      *

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ******** The Angular Lebedev Grid ********'
write(u6,*)
write(u6,*)
#endif

i = 0
ip = 0

! nscheme(2) -> 6 points

!lg write(u6,*) 'nscheme',(nscheme(i),i=1,8)
if (nscheme(2) > 0) then
  !lg write(u6,*) 'nscheme(2)',nscheme(2)
  ip = ip+1
  do ix=1,3
    do iy=1,-1,-2
      i = i+1
      wPt(i) = pa(ip)
      do j=1,3
        rPt(j,i) = Zero
      end do
      rPt(ix,i) = real(iy,kind=wp)
      !lg write(u6,*) rPt(ix,i),wPt(i)
    end do
  end do
end if

! nscheme(3) -> 8 points

if (nscheme(3) > 0) then   !
  c = One/sqrt(Three)
  ip = ip+1
  do ix=1,-1,-2
    do iy=1,-1,-2
      do iz=1,-1,-2
        i = i+1
        wPt(i) = pa(ip)
        rPt(1,i) = real(ix,kind=wp)*c
        rPt(2,i) = real(iy,kind=wp)*c
        rPt(3,i) = real(iz,kind=wp)*c
      end do
    end do
  end do
end if

! nscheme(4) -> 12 points

if (nscheme(4) > 0) then
  c = One/sqrt(Two)
  ip = ip+1
  do ix=1,-1,-2
    do iy=1,-1,-2
      do iz=1,3
        i = i+1
        wPt(i) = pa(ip)
        rPt(iz,i) = real(ix,kind=wp)*c
        j = mod(iz,3)+1
        rPt(j,i) = real(iy,kind=wp)*c
        j = 6-iz-j
        rPt(j,i) = Zero
      end do
    end do
  end do
end if

! 24a points

n1 = nscheme(5)
do jj=1,n1
  ip = ip+1
  uu = pa(ip)
  vv = sqrt(One-Two*uu*uu)
  ip = ip+1
  do ix=1,-1,-2
    do iy=1,-1,-2
      do iz=1,-1,-2
        do j=1,3
          i = i+1
          wPt(i) = pa(ip)
          do j1=1,3
            rPt(j1,i) = uu
          end do
          rPt(j,i) = vv
          rPt(1,i) = rPt(1,i)*real(ix,kind=wp)
          rPt(2,i) = rPt(2,i)*real(iy,kind=wp)
          rPt(3,i) = rPt(3,i)*real(iz,kind=wp)
        end do
      end do
    end do
  end do
end do

! 24b points

n1 = nscheme(6)
do jj=1,n1
  ip = ip+1
  pp = pa(ip)
  qq = sqrt(One-pp*pp)
  ip = ip+1
  do ix=1,-1,-2
    do iy=1,-1,-2
      do ii=0,1
        do j=1,3
          i = i+1
          wPt(i) = pa(ip)
          j1 = mod(j+ii,3)+1
          rPt(j1,i) = pp*real(ix,kind=wp)
          j1 = mod(j+1-ii,3)+1
          rPt(j1,i) = qq*real(iy,kind=wp)
          rPt(j,i) = Zero
        end do
      end do
    end do
  end do
end do

! 48 points

n1 = nscheme(7)
!lg write(u6,*) 'i, n1 =',i,n1
do jj=1,n1
  ip = ip+1
  rr = pa(ip)
  ip = ip+1
  ss = pa(ip)
  tt = sqrt(One-rr*rr-ss*ss)
  ip = ip+1
  do ix=1,-1,-2
    do iy=1,-1,-2
      do iz=1,-1,-2
        do j=1,3
          do ii=0,1
            i = i+1
            wPt(i) = pa(ip)
            rPt(j,i) = rr*real(ix,kind=wp)
            j1 = mod(j+ii,3)+1
            rPt(j1,i) = ss*real(iy,kind=wp)
            j1 = mod(j+1-ii,3)+1
            rPt(j1,i) = tt*real(iz,kind=wp)
            !lg write (u6,*) rPt(j1,i),wPt(i),j1,i
          end do
          !lg write (u6,*) 'Enddo1',i
        end do
        !lg write (u6,*) 'Enddo2',i
      end do
      !lg write (u6,*) 'Enddo3',i
    end do
    !lg write (u6,*) 'Enddo4',i
  end do
  !lg write (u6,*) 'Enddo5',i
end do
!lg write (u6,*) 'enddo',n1
!                                                                      *
!***********************************************************************
!                                                                      *

!lg write(u6,*) 'End of AnMesh'

return

end subroutine AnMesh

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine Boys(Functional,CMO,Thrs,ThrRot,ThrGrad,
     &                nBas,nOrb2Loc,nFro,nSym,nMxIter,
     &                Maximisation,Converged,Debug,Silent)
C
C     Author: T.B. Pedersen
C
C     Purpose: Boys localisation of occupied orbitals.
C
      Implicit Real*8 (a-h,o-z)
      Real*8   CMO(*)
      Integer nBas(nSym), nOrb2Loc(nSym), nFro(nSym)
      Logical Maximisation, Converged, Debug, Silent
#include "WrkSpc.fh"

      Character*4 SecNam
      Parameter (SecNam = 'Boys')

      Parameter (nComp = 3) ! 3 components of dipole operator
      Integer ipLbl(nComp), ipLbl_MO(nComp)
      Character*8 Label, AlloLbl(nComp), AlloLbl_MO(nComp)

C     Symmetry is NOT allowed!!
C     -------------------------

      If (nSym .ne. 1) Then
         Call SysAbendMsg(SecNam,'Symmetry not implemented!','Sorry!')
      End If

C     Initializations.
C     ----------------

      Functional = -9.9d9

      nBasT     = nBas(1)
      nOrb2LocT = nOrb2Loc(1)
      nFroT     = nFro(1)

      Converged = .False.

C     Read AO dipole moment integrals.
C     --------------------------------

      lLbl = nBasT*nBasT
      Do iComp = 1,nComp
         Write(AlloLbl(iComp),'(A,I2)') 'Dipole',iComp
         Call GetMem(AlloLbl(iComp),'Allo','Real',ipLbl(iComp),lLbl)
      End Do

      lAux = nBasT*(nBasT+1)/2 + 4
      Call GetMem('DipAux','Allo','Real',ipAux,lAux)
      Label = 'Mltpl  1'
      Do iComp = 1,nComp
         irc = -1
         iOpt = 2
         iSym = 1
         Call RdOne(irc,iOpt,Label,iComp,Work(ipAux),iSym)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': RdOne returned ',irc
            Write(6,*) 'Label = ',Label,'   Component = ',iComp
            Call SysAbendMsg(SecNam,'I/O error in RdOne',' ')
         End If
         If (Debug) Then
            Write(6,*)
            Write(6,*) ' Triangular dipole matrix at start'
            Write(6,*) ' ---------------------------------'
            Write(6,*) ' Component: ',iComp
            Call TriPrt(' ',' ',Work(ipAux),nBasT)
         End If
         Call Tri2Rec(Work(ipAux),Work(ipLbl(iComp)),nBasT,Debug)
      End Do
      Call GetMem('DipAux','Free','Real',ipAux,lAux)

C     Allocate MO arrays.
C     -------------------

      lLbl_MO = nOrb2LocT*nOrb2LocT
      Do iComp = 1,nComp
         Write(AlloLbl_MO(iComp),'(A,I2)') 'MO dip',iComp
         Call GetMem(AlloLbl_MO(iComp),'Allo','Real',ipLbl_MO(iComp),
     &                                               lLbl_MO)
      End Do

C     Localise orbitals.
C     ------------------

      kOffC = nBasT*nFroT + 1
      Call Boys_Iter(Functional,CMO(kOffC),Thrs,ThrRot,ThrGrad,
     &               ipLbl,ipLbl_MO,
     &               nBasT,nOrb2LocT,nComp,nMxIter,
     &               Maximisation,Converged,Debug,Silent)

C     De-allocations.
C     ---------------

      Do iComp = nComp,1,-1
         Call GetMem(AlloLbl_MO(iComp),'Free','Real',ipLbl_MO(iComp),
     &                                               lLbl_MO)
      End Do
      Do iComp = nComp,1,-1
         Call GetMem(AlloLbl(iComp),'Free','Real',ipLbl(iComp),lLbl)
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DstInf(iStop,Just_Frequencies)
      use Symmetry_Info, only: nIrrep, iOper
      use Slapaf_Info, only: Cx, Coor, Weights, Energy, MF, qInt, dqInt,
     &                       Dmp_Slapaf, AtomLbl
      use Slapaf_Parameters, only: MaxItr, iOptC, Numerical, Max_Center,
     &                             mTROld, RtRnc, lOld_Implicit, Stop,
     &                             iter
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
#include "Molcas.fh"
#include "print.fh"
#include "SysDef.fh"
#include "angstr.fh"
      Real*8, Allocatable:: Cx_p(:,:), CC(:,:), RV(:,:), xyz(:,:)
*
      LOGICAL do_printcoords, do_fullprintcoords, Just_Frequencies,
     &        Found
      Character(LEN=100) SuperName
      Character(LEN=100), External:: Get_SuperName
      Character(LEN=LENIN), Allocatable:: LblTMP(:)
      Character(LEN=2), Allocatable:: Element(:)

*                                                                      *
************************************************************************
*                                                                      *
      iRout=53
      iPrint=nPrint(iRout)
      do_printcoords=iPrint.ge.5
      do_fullprintcoords=(iPrint.gt.5.OR.iStop.gt.1)
      LOut=6
*                                                                      *
************************************************************************
*                                                                      *
*---  Write information of this iteration to the RLXITR file
*
      Call Dmp_Slapaf(Stop,Just_Frequencies,Energy(1),iter,MaxItr,
     &                mTROld,lOld_Implicit,SIZE(Coor,2))
*
      SuperName=Get_Supername()
      If (SuperName.ne.'numerical_gradient') Then
         Call Put_dArray('qInt',  qInt,SIZE( qInt))
         Call Put_dArray('dqInt',dqInt,SIZE(dqInt))
      End If

      If (Just_Frequencies) Return
*                                                                      *
************************************************************************
*                                                                      *
*---- Geometry information
*
      If (Stop.or.do_printcoords) Then
         Write (LOut,*)
         Call CollapseOutput(1,'Geometry section')
         Write (LOut,*)
         Write (LOut,'(80A)') ('*',i=1,80)
         If (Stop) Then
            Write (LOut,*)
     &        ' Geometrical information of the final structure'
            r_Iter=DBLE(Iter)
            Call Add_Info('GEO_ITER',[r_Iter],1,8)
         Else IF (do_printcoords) THEN
            Write (LOut,*)
     &         ' Geometrical information of the new structure'
         End If
         Write (LOut,'(80A)') ('*',i=1,80)
         Write (LOut,*)
      End If
*
      Call Get_iScalar('Pseudo atoms',nsAtom_p)
      If (nsAtom_p.gt.0) Then
         Call mma_allocate(Cx_p,3,nsAtom_p,Label='Cx_p')
         Call Get_dArray('Pseudo Coordinates',Cx_p,3*nsAtom_p)
      End If
*
      Call mma_Allocate(CC,3,nIrrep*(SIZE(Coor,2)+nsAtom_p),Label='CC')
      nTemp = 0
      Call mma_Allocate(LblTMP,nIrrep*(SIZE(Coor,2)+nsAtom_p),
     &                  Label='LblTMP')
      Do isAtom = 1, SIZE(Coor,2) + nsAtom_p
         If (isAtom.le.SIZE(Coor,2)) Then
            x1 = Coor(1,isAtom)
            y1 = Coor(2,isAtom)
            z1 = Coor(3,isAtom)
         Else
            jsAtom = isAtom - SIZE(Coor,2)
            x1 = Cx_p(1,jsAtom)
            y1 = Cx_p(2,jsAtom)
            z1 = Cx_p(3,jsAtom)
         End If
         Do 6001 iIrrep = 0, nIrrep-1
            x2 = x1
            If (iAnd(1,iOper(iIrrep)).ne.0) x2 = - x2
            y2 = y1
            If (iAnd(2,iOper(iIrrep)).ne.0) y2 = - y2
            z2 = z1
            If (iAnd(4,iOper(iIrrep)).ne.0) z2 = - z2
*
*           Check if it is already in the list
*
            Do iTemp = 1, nTemp
               r = (x2-CC(1,iTemp))**2 +
     &             (y2-CC(2,iTemp))**2 +
     &             (z2-CC(3,iTemp))**2
               If (r.eq.Zero) Go To 6001
            End Do
            nTemp = nTemp + 1
            If (nTemp.gt.nIrrep*(SIZE(Coor,2)+nsAtom_p)) Then
               Call WarningMessage(2,'Error in DstInf')
               Write (6,*) 'nTemp.gt.nIrrep*SIZE(Coor,2)'
               Call Abend()
            End If
            CC(1,nTemp) = x2
            CC(2,nTemp) = y2
            CC(3,nTemp) = z2
            If (isAtom.le.SIZE(Coor,2)) Then
               LblTMP(nTemp)=AtomLbl(isAtom)
            Else
               LblTMP(nTemp)='PC'
            End If
 6001    Continue
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*-----Write out the new cartesian symmetry coordinates.
*
      If (Stop) Then
         Write (LOut,*) ' NOTE: on convergence the final predicted '
     &               //'structure will be printed here.'
         Write (LOut,*) ' This is not identical to the structure'
     &               //' printed in the head of the output.'
         Call OutCoor(
     &    '* Nuclear coordinates of the final structure / Bohr     *',
     &    AtomLbl,SIZE(Coor,2),Coor,3,SIZE(Coor,2),.False.)
         Call OutCoor(
     &    '* Nuclear coordinates of the final structure / Angstrom *',
     &    AtomLbl,SIZE(Coor,2),Coor,3,SIZE(Coor,2),.True.)
      Else If (Do_PrintCoords) Then
         Call OutCoor(
     &    '* Nuclear coordinates for the next iteration / Bohr     *',
     &    AtomLbl,SIZE(Coor,2),Coor,3,SIZE(Coor,2),.False.)
         Call OutCoor(
     &    '* Nuclear coordinates for the next iteration / Angstrom *',
     &    AtomLbl,SIZE(Coor,2),Coor,3,SIZE(Coor,2),.True.)
      End If
*
      If (nsAtom_p.gt.0) Then
         iOff = nTemp - nsAtom_p + 1
         Call OutCoor(
     &'* Pseudo charge coordinates for the next iteration / Bohr     *',
     &    LblTMP(iOff),nsAtom_p,Cx_p,3,nsAtom_p,.False.)
         Call OutCoor(
     &'* Pseudo Charge coordinates for the next iteration / Angstrom *',
     &    LblTMP(iOff),nsAtom_p,Cx_p,3,nsAtom_p,.True.)
         Call mma_deallocate(Cx_p)
      End If
*
      IF (do_printcoords) THEN
         Call Get_iScalar('N ZMAT',N_ZMAT)
         If (N_ZMAT.GT.0) Call OutZMAT(SIZE(Coor,2),Coor,N_ZMAT)
*
         IF (do_fullprintcoords) THEN
           If (nTemp.ge.2)
     &     Call Dstncs(LblTMP,CC,nTemp,angstr,Max_Center,5)
*
           If (nTemp.ge.3)
     &     Call Angles(LblTMP,CC,nTemp,Rtrnc,Max_Center)
*
           If (nTemp.ge.4)
     &     Call Dihedr(LblTMP,CC,nTemp,Rtrnc,Max_Center)
         END IF
      END IF
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(LblTMP)
      Call mma_deallocate(CC)
*                                                                      *
************************************************************************
*                                                                      *
*---  Write the new cartesian symmetry coordinates on GEONEW
*
      Call Put_Coord_New(Cx(1,1,iter+1),SIZE(Coor,2))
*                                                                      *
************************************************************************
*                                                                      *
*     If two runfiles are associated with the calculation update both
*     files.
*
      Call f_Inquire('RUNFILE2',Found)
      If (Found) Then
         Call NameRun('RUNFILE2')
         Call Put_Coord_New(Cx(1,1,iter+1),SIZE(Coor,2))
         Call NameRun('RUNFILE')
      End If
*
*     Update the .Opt.xyz file
*
      If (.Not.Numerical) Then
         Call Get_nAtoms_All(nCoord)
         Call mma_allocate(xyz,3,nCoord,Label='xyz')
         Call mma_allocate(Element,nCoord,Label='Element')
         Call Get_Coord_New_All(xyz,nCoord)
         Call Get_Name_All(Element)
*
         Lu_xyz=IsFreeUnit(11)
         Call MOLCAS_Open(Lu_xyz,'XYZ')
         Write (Lu_xyz,'(I4)') nCoord
         Write(Lu_xyz,*) Energy(1+Iter)
*        Write (Lu_xyz,'(A)') 'Coordinates generated by Slapaf'
         Do i = 1, nCoord
            Write (Lu_xyz,'(A2,3F15.8)') Element(i),
     &            (Angstr*xyz(j,i),j=1,3)
         End Do
         Close (Lu_xyz)
         Call mma_deallocate(Element)
         Call mma_deallocate(xyz)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     If a transition state optimization put the "reaction" vector
*     on the RUNFILE(S)
*
       If (iAnd(iOptC,128).ne.128 .and. Stop ) Then
*
           Call mma_allocate(RV,3,SIZE(Coor,2),Label='RV')
           Call dcopy_(3*SIZE(Coor,2),MF,1,RV,1)
           Do i=1,SIZE(Coor,2)
             xWeight=Weights(i)
             RV(:,i) = RV(:,i)/xWeight
           End Do
           Call OutCoor('* The Cartesian Reaction vector'//
     &                  '                         *',
     &                  AtomLbl,SIZE(Coor,2),RV,3,SIZE(Coor,2),.True.)

           Call f_Inquire('RUNREAC',Found)
           If (Found) Then
              Call NameRun('RUNREAC')
              Call Put_dArray('Reaction Vector',RV,3*SIZE(Coor,2))
           End If
           Call f_Inquire('RUNPROD',Found)
           If (Found) Then
              Call NameRun('RUNPROD')
              Call Put_dArray('Reaction Vector',RV,3*SIZE(Coor,2))
           End If
           Call NameRun('RUNFILE')
           Call Put_dArray('Reaction Vector',RV,3*SIZE(Coor,2))
           Call mma_deallocate(RV)
           iDo_dDipM=0
           Call GF_on_the_fly(iDo_dDipM)
*
       End If
*                                                                      *
************************************************************************
*                                                                      *
      If (Stop.or.do_printcoords)
     &   Call CollapseOutput(0,'Geometry section')
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Read_Bin(iShell_A,iShell_B,iShell_C,iShell_D,G_Toc,
     &                    nQuad,Gamma,nGamma,LuGamma,Bin,lBin)
      Implicit Real*8 (a-h,o-z)
#include "SysDef.fh"
#include "real.fh"
      Real*8 G_Toc(nQuad), Bin(2,lBin), Gamma(nGamma)
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
      Call FZero(Gamma,nGamma)
*
      iShell_AB=iTri(iShell_A,iShell_B)
      iShell_CD=iTri(iShell_C,iShell_D)
      iShell_ABCD=iTri(iShell_AB,iShell_CD)
*
*     Write (*,*) 'Reading Gammas for shell quadruplet ', iShell_ABCD
*
      iDisk=Int(G_Toc(iShell_ABCD))
      iRead=2
99    Call dDaFile(LuGamma,iRead,Bin,2*lBin,iDisk)
      lGamma=Int(Bin(1,lBin))
      iDisk =Int(Bin(2,lBin))
*
      Do iGamma = 1, lGamma
         jGamma=Int(Bin(2,iGamma))
         If (jGamma.gt.nGamma) Then
            Call WarningMessage(2,'Read_Bin: jGamma.gt.nGamma')
            Call Abend()
         End If
         Gamma(jGamma)=Bin(1,iGamma)
*        Write (*,*) Gamma(jGamma), jGamma
      End Do
*
      If (iDisk.ge.0) Go To 99
*
      Return
      End

      Subroutine Read_Bin_Columbus
     &              (iShell_A,iShell_B,iShell_C,iShell_D,G_Toc,
     &                    nQuad,Gamma,nGamma,LuGamma,Bin,lBin)
      Implicit Real*8 (a-h,o-z)
#include "SysDef.fh"
#include "real.fh"
      Real*8 G_Toc(nQuad), Bin(2,lBin), Gamma(nGamma)
      Integer idisk_save
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
      Call FZero(Gamma,nGamma)
*
      iShell_AB=iTri(iShell_A,iShell_B)
      iShell_CD=iTri(iShell_C,iShell_D)
      iShell_ABCD=iTri(iShell_AB,iShell_CD)
*
*     Write (*,*) 'Reading Gammas for shell quadruplet ', iShell_ABCD
*
      iDisk=Int(G_Toc(iShell_ABCD))
*     write(6,'(a,i6,a,i6)') ' Reading gtoc for ',ishell_abcd,'=',iDisk
      iRead=2
* ddafile overwrites idisk
99    idisk_save=idisk
      Call dDaFile(LuGamma,iRead,Bin,2,iDisk)
      lGamma=Int(Bin(1,1))
*98    format(a,'got header1=',i10,i10)
*     Write (*,98) '1st:',lgamma,Int(Bin(2,1))
      If (lGamma.gt.lBin) Then
            Call WarningMessage(2,'Read_Bin_Columbus: lGamma.gt.lbin')
            Call Abend()
      End If
      iDisk=idisk_save
*     write(*,'(a,i6)') ' second read from idisk=',iDisk
      Call dDaFile(LuGamma,iRead,Bin,2*lGamma,iDisk)
      iDisk =Int(Bin(2,1))
*     Write (*,98) '2nd:',Int(Bin(1,1)),Int(Bin(2,1))
*
      Do iGamma = 2, lGamma
         jGamma=Int(Bin(2,iGamma))
         If (jGamma.gt.nGamma) Then
            Call WarningMessage(2,'Read_Bin_Columbus: jGamma.gt.nGamma')
            Call Abend()
         End If
         Gamma(jGamma)=Bin(1,iGamma)
*        Write (*,*) Gamma(jGamma), jGamma
      End Do
*
      If (iDisk.ge.0) Go To 99
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Restart_SurfaceHop

#ifdef _HDF5_
use Tully_variables, only: NSUBSTEPS
use stdalloc, only: mma_allocate, mma_deallocate
use mh5, only: mh5_open_file_r, mh5_fetch_attr, mh5_exists_attr, mh5_exists_dset, mh5_fetch_dset, mh5_close_file
use surfacehop_globals, only: File_H5Res
use Constants, only: auTofs
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, nstates, nconfs, restart_fileid
character(len=256) :: tmp
character(len=128) :: sFile
logical(kind=iwp) :: Exists
real(kind=wp) :: dt
real(kind=wp), allocatable :: ener(:), ciarray(:), real_amatrix(:), imag_amatrix(:), overlap_save(:)
complex(kind=wp), allocatable :: amatrix(:)

write(u6,'(A)') 'Restarting surfacehop from h5 file',file_h5res

! Check the file exists
call f_inquire(sFile,Exists)
if (.not. Exists) then
  call getenvf('MOLCAS_SUBMIT_DIR',tmp)
  if (tmp /= ' ') then
    i = index(tmp,' ')
    if (i > 0) then
      sFile = tmp(1:i-1)//'/'//File_H5Res
      call f_inquire(sFile,Exists)
    end if
  end if
  if (.not. Exists) then
    call WarningMessage(2,'File '//trim(sFile)//' is not found')
    call Quit_OnUserError()
  end if
end if

! Save on the RUNFILE information for DYNAMIX
call restart_dynamix(File_H5Res)

call Get_dScalar('Timestep',DT)
NSUBSTEPS = int(200*DT*auTofs)
restart_fileid = mh5_open_file_r(sFile)
call mh5_fetch_attr(restart_fileid,'NSTATES',nstates)
call mh5_fetch_attr(restart_fileid,'NCONFS',nconfs)

! Save on the RUNFILE information for SURFACEHOP now

! read seed number and save in RunFile
call mh5_fetch_dset(restart_fileid,'SEED',i)
call Put_iScalar('Seed',i)

! read number of hops and save in RunFile
if (mh5_exists_attr(restart_fileid,'NO. OF HOPS')) then
  call mh5_fetch_dset(restart_fileid,'NO. OF HOPS',i)
  call Put_iScalar('Number of Hops',i)
end if

! read max hop for Tully and save in RunFile
if (mh5_exists_dset(restart_fileid,'MAX_HOP_TULLY')) then
  call mh5_fetch_dset(restart_fileid,'MAX_HOP_TULLY',i)
  call Put_iScalar('MaxHopsTully',i)
end if

! read relax root number and save in RunFile
call mh5_fetch_dset(restart_fileid,'RELAX CAS ROOT',i)
call Put_iScalar('Relax CASSCF root',i)

! read the energies of the previous step and save in RunFile
call mma_allocate(ener,nstates)
call mh5_fetch_dset(restart_fileid,'ENERG PREV',ener)
call Put_darray('VenergyP',ener,nstates)
call mma_deallocate(ener)

! read the CI arrays of the previous step and save in RunFile
call mma_allocate(ciarray,nstates*nconfs)
call mh5_fetch_dset(restart_fileid,'CI PREV',ciarray)
call Put_darray('AllCIP',ciarray,nstates*nconfs)
call mma_deallocate(ciarray)

! read the CI arrays of the step before the previous step and save in RunFile
call mma_allocate(ciarray,nstates*nconfs)
call mh5_fetch_dset(restart_fileid,'CI PPREV',ciarray)
call Put_darray('AllCIPP',ciarray,nstates*nconfs)
call mma_deallocate(ciarray)

! read <t-2dt|t-dt> overlap if exists and save in RunFile
if (mh5_exists_dset(restart_fileid,'RASSI_SAVE_OVLP')) then
  call mma_allocate(overlap_save,nstates*nstates)
  call mh5_fetch_dset(restart_fileid,'RASSI_SAVE_OVLP',overlap_save)
  call Put_darray('SH_Ovlp_Save',overlap_save,nstates*nstates)
  call mma_deallocate(overlap_save)
end if

! read the AmatrixV and save in RunFile
call mma_allocate(real_amatrix,nstates*nstates)
call mma_allocate(imag_amatrix,nstates*nstates)
call mma_allocate(amatrix,nstates*nstates)
call mh5_fetch_dset(restart_fileid,'AMATRIXV-R',real_amatrix)
call mh5_fetch_dset(restart_fileid,'AMATRIXV-I',imag_amatrix)
amatrix(:) = cmplx(real_amatrix,imag_amatrix,kind=wp)
call Put_zarray('AmatrixV',amatrix,nstates*nstates)
call mma_deallocate(amatrix)
call mma_deallocate(real_amatrix)
call mma_deallocate(imag_amatrix)

call mh5_close_file(restart_fileid)
#endif

return

end subroutine Restart_SurfaceHop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
*               1993, Per Boussard                                     *
************************************************************************
      SubRoutine M2Grd(
#define _CALLING_
#include "grd_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of M2 integrals used in   *
*         ECP calculations. The operator is a s-type gaussian          *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by ECPMem                 *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
*             Physics, University of Stockholm, Sweden, October '93.   *
************************************************************************
      use Basis_Info
      use Center_Info
      use Her_RW
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "print.fh"
#include "disp.fh"

#include "grd_interface.fh"

*     Local variables
      Real*8 TC(3), C(3)
      Integer iDCRT(0:7), iuvwx(4), lOp(4), JndGrd(3,4)
      Logical ABeq(3), JfGrad(3,4), TstFnc, TF, EQ
*
*-----Statement function for Cartesian index
*
      nElem(k)=(k+1)*(k+2)/2
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*
      iRout = 122
      iPrint = nPrint(iRout)
*
      iIrrep = 0
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      lOp(1) = kOp(1)
      lOp(2) = kOp(2)
      nDAO = nElem(la)*nElem(lb)
*
      nip = 1
      ipA = nip
      nip = nip + nZeta
      ipB = nip
      nip = nip + nZeta
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+2)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+2)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer
      ipQxyz = nip
      nip = nip + nZeta*3*(la+2)*(lb+2)
      ipK = nip
      nip = nip + nZeta
      ipZ = nip
      nip = nip + nZeta
      ipPx= nip
      nip = nip + nZeta
      ipPy= nip
      nip = nip + nZeta
      ipPz= nip
      nip = nip + nZeta
      If (nip-1.gt.nArr*nZeta) Then
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Call ErrTra
         Write (6,*) ' Abend in M2Grd'
         Call Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In M2Grd: A',' ',A,1,3)
         Call RecPrt(' In M2Grd: RB',' ',RB,1,3)
         Call RecPrt(' In M2Grd: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In M2Grd: Kappa',' ',rKappa,nAlpha,nBeta)
         Call RecPrt(' In M2Grd: Zeta',' ',Zeta,nAlpha,nBeta)
         Call RecPrt(' In M2Grd: P',' ',P,nZeta,3)
         Write (6,*) ' In M2Grd: la,lb,nHer=',la,lb,nHer
      End If
*
      iStrt = ipA
      Do 20 iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(iStrt),1)
         iStrt = iStrt + nAlpha
 20   Continue
*
      iStrt = ipB
      Do 21 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(iStrt),nAlpha)
         iStrt = iStrt + 1
 21   Continue
*
*-----Loop over nuclear centers
*
      kdc=0
      Do 100 kCnttp = 1, nCnttp
         If (.Not.dbsc(kCnttp)%ECP) Go To 111
         If (dbsc(kCnttp)%nM2.eq.0) Go To 111
*
         Do 101 kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3)=dbsc(kCnttp)%Coor(1:3,kCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab, dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
            iuvwx(3) = dc(kdc+kCnt)%nStab
            iuvwx(4) = dc(kdc+kCnt)%nStab
*
            Do 102 lDCRT = 0, nDCRT-1
               lOp(3) = NrOpr(iDCRT(lDCRT))
               lOp(4) = lOp(3)
               Call OA(iDCRT(lDCRT),C,TC)
               If (EQ(A,RB).and.EQ(A,TC)) Go To 102
*
               Do 1011 iM2xp = 1, dbsc(kCnttp)%nM2
                  Gamma = dbsc(kCnttp)%M2xp(iM2xp)
                  If (iPrint.ge.99) Write (6,*) ' Gamma=',Gamma
*
                  Call ICopy(6,IndGrd,1,JndGrd,1)
                  Do 10 i = 1, 3
                     Do 11 j = 1, 2
                        JfGrad(i,j) = IfGrad(i,j)
 11                  Continue
 10               Continue
*
*-----------------Derivatives with respect to the operator is computed
*                 via the translational invariance.
*
                  nDisp = IndDsp(kdc+kCnt,iIrrep)
                  Do 220 iCar = 0, 2
                     JfGrad(iCar+1,3) = .False.
                     iCmp = 2**iCar
                     If ( TF(kdc+kCnt,iIrrep,iCmp) .and.
     &                    .Not.dbsc(kCnttp)%pChrg ) Then
                        nDisp = nDisp + 1
                        If (Direct(nDisp)) Then
*--------------------------Reset flags for the basis set centers so that
*                          we will explicitly compute the derivatives
*                          with respect to those centers. Activate flag
*                          for the third center so that its derivative
*                          will be computed by the translational
*                          invariance.
                           JndGrd(iCar+1,1) = Abs(JndGrd(iCar+1,1))
                           JndGrd(iCar+1,2) = Abs(JndGrd(iCar+1,2))
                           JndGrd(iCar+1,3) = -nDisp
                           JfGrad(iCar+1,1) = .True.
                           JfGrad(iCar+1,2) = .True.
                        Else
                           JndGrd(iCar+1,3) = 0
                        End If
                     Else
                        JndGrd(iCar+1,3) = 0
                     End If
 220              Continue
*-----------------No derivatives with respect to the fourth center.
                  Call ICopy(3,[0],0,JndGrd(1,4),1)
                  JfGrad(1,4) = .False.
                  JfGrad(2,4) = .False.
                  JfGrad(3,4) = .False.
                  mGrad = 0
                  Do 231 iCar = 1, 3
                     Do 232 i = 1, 2
                        If (JfGrad(iCar,i)) mGrad = mGrad + 1
 232                 Continue
 231              Continue
                  If (iPrint.ge.99) Write (6,*) ' mGrad=',mGrad
                  If (mGrad.eq.0) Go To 1011
*
*-----------------Modify the original basis.
*
                  Do 1012 iZeta = 1, nZeta
                     PTC2 = (P(iZeta,1)-TC(1))**2
     &                    + (P(iZeta,2)-TC(2))**2
     &                    + (P(iZeta,3)-TC(3))**2
                     Tmp0 = Zeta(iZeta)+Gamma
                     Tmp1 = Exp(-Zeta(iZeta)*Gamma*PTC2/Tmp0)
                     Array(ipK+iZeta-1)    = rKappa(iZeta) * Tmp1
                     Array(ipZ+iZeta-1)    = Tmp0
                     Array(ipPx+iZeta-1)   =
     &                  (Zeta(iZeta)*P(iZeta,1)+Gamma*TC(1))/Tmp0
                     Array(ipPy+iZeta-1)   =
     &                  (Zeta(iZeta)*P(iZeta,2)+Gamma*TC(2))/Tmp0
                     Array(ipPz+iZeta-1)   =
     &                  (Zeta(iZeta)*P(iZeta,3)+Gamma*TC(3))/Tmp0
 1012             Continue
                  If (iPrint.ge.99) Then
                     Write (6,*) ' The modified basis set'
                     Call RecPrt(' In M2Grd: Kappa',' ',
     &                            Array(ipK),nAlpha,nBeta)
                     Call RecPrt(' In M2Grd: Zeta',' ',
     &                            Array(ipZ),nAlpha,nBeta)
                     Call RecPrt(' In M2Grd: P',' ',Array(ipPx),nZeta,3)
                     Call RecPrt(' In M2Grd: TC',' ',TC,1,3)
                  End If
*
*-----------------Compute the cartesian values of the basis functions
*                 angular part
*
                  ABeq(1) = A(1).eq.RB(1) .and. A(1).eq.TC(1)
                  ABeq(2) = A(2).eq.RB(2) .and. A(2).eq.TC(2)
                  ABeq(3) = A(3).eq.RB(3) .and. A(3).eq.TC(3)
                  Call CrtCmp(Array(ipZ),Array(ipPx),nZeta,A,
     &                        Array(ipAxyz),la+1,HerR(iHerR(nHer)),
     &                        nHer,ABeq)
                  Call CrtCmp(Array(ipZ),Array(ipPx),nZeta,RB,
     &                        Array(ipBxyz),lb+1,HerR(iHerR(nHer)),
     &                        nHer,ABeq)
*
*-----------------Compute the contribution from the multipole moment
*                 operator
*
                  ABeq(1) = .False.
                  ABeq(2) = .False.
                  ABeq(3) = .False.
                  Call CrtCmp(Array(ipZ),Array(ipPx),nZeta,Ccoor,
     &                        Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),
     &                        nHer,ABeq)
*
*-----------------Compute the cartesian components for the multipole
*                 moment integrals. The integrals are factorized into
*                 components.
*
                  Call Assmbl(Array(ipQxyz),
     &                        Array(ipAxyz),la+1,
     &                        Array(ipRxyz),nOrdOp,
     &                        Array(ipBxyz),lb+1,
     &                        nZeta,HerW(iHerW(nHer)),nHer)
*
*-----------------Combine the cartesian components to the full one
*                 electron integral gradient.
*
                  Factor = -dbsc(kCnttp)%Charge*dbsc(kCnttp)%M2cf(iM2xp)
     &                   * Fact
                  Call CmbnM2(Array(ipQxyz),nZeta,la,lb,
     &                        Array(ipZ),Array(ipK),Final,
     &                        Array(ipA),Array(ipB),JfGrad,Factor,mVec)
                  If (iPrint.ge.99) Call RecPrt(' Final in M2Grd',' ',
     &                Final,nZeta*nElem(la)*nElem(lb),mVec)
*
*-----------------Distribute the gradient contributions
*
                  Call DistG1X(Final,DAO,nZeta,nDAO,mVec,Grad,nGrad,
     &                         JfGrad,JndGrd,iuvwx,lOp)
*
 1011          Continue
*
 102        Continue
 101     Continue
 111     kdc = kdc + dbsc(kCnttp)%nCntr
*
 100  Continue
*
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_integer_array(lOper)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grow_vvoo_blocked(AA,BB,no,dima,dimb,lasta,lastb,length1,length2,sym)
! this routine does:
!
! grow A(1324)/(vvoo) from the blocked cholesky vectors B(1234)/(vovo)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: no, dima, dimb, lasta, lastb, length1, length2
real(kind=wp), intent(inout) :: AA(length1,length2,no,no)
real(kind=wp), intent(in) :: BB(dima,no,dimb,no)
logical(kind=iwp), intent(in) :: sym
integer(kind=iwp) :: i2, i3, i4

!mp write(u6,'(A,4(i3,x))') 'AA lasta, lastb, dima, dimb ',lasta,lastb,dima,dimb
!mp write(u6,'(A,2(i9,x))') 'chk_a ',lasta+dima,length1
!mp write(u6,'(A,2(i9,x))') 'chk_b ',lastb+dimb,length2

do i4=1,no
  do i3=1,no
    do i2=1,dimb
      AA(lasta+1:lasta+dima,lastb+i2,i3,i4) = BB(:,i3,i2,i4)

      if (sym) AA(lastb+i2,lasta+1:lasta+dima,i4,i3) = BB(:,i3,i2,i4)

    end do
  end do
end do

return

end subroutine grow_vvoo_blocked

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************
!  Cho_X_Bookmark
!
!> @brief
!>   Get number of Cholesky vectors needed to achieve a given integral target accuracy \p Thr
!> @author Thomas Bondo Pedersen, August 2012
!>
!> @details
!> Return number of Cholesky vectors in each symmetry block needed to
!> achieve an integral accuracy of \p Thr (&le; decomposition threshold).
!> The actual integral accuracy in each symmetry block is returned in
!> array \p delta (for 1C-CD, the accuracy is judged by 1-center
!> diagonal elements only!). Note that \p mSym may be smaller than \p nSym
!> (so that one may find a bookmark in irrep 1 only, for example).
!> Available for full CD and 1C-CD, but *not RI*.
!>
!> On exit, return codes signify:
!>
!> - \p irc = ``-1``: bookmarks not available
!> - \p irc =  ``0``: all OK
!> - \p irc =  ``1``: illegal input
!>
!> @param[in]  Thr   Target integral accuracy
!> @param[in]  mSym  Number of irreps
!> @param[out] nVec  Number of Cholesky vectors
!> @param[out] delta Actual integral accuracy
!> @param[out] irc   Return code
!***********************************************************************

subroutine Cho_X_Bookmark(Thr,mSym,nVec,delta,irc)

use Cholesky, only: BkmThr, BkmVec, Cho_Real_Par, nRow_BkmThr, nSym, ThrCom
#ifdef _DEBUGPRINT_
use Cholesky, only: NumCho
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Thr
integer(kind=iwp), intent(in) :: mSym
integer(kind=iwp), intent(out) :: nVec(mSym), irc
real(kind=wp), intent(out) :: delta(mSym)
integer(kind=iwp) :: iRS, iSym, l, n
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: BkmScr(:)
logical(kind=iwp), parameter :: DebugPrint = .false.
character(len=*), parameter :: SecNam = 'Cho_X_Bookmark'

! Set return code.
! ----------------

irc = 0

! Check that bookmarks are available.
! -----------------------------------

if ((.not. allocated(BkmVec)) .or. (.not. allocated(BkmThr))) then
  irc = -1
  return
end if

! Check input.
! ------------

if ((sign(One,Thr) < Zero) .or. (Thr < ThrCom) .or. (mSym < 1) .or. (mSym > nSym)) then
  irc = 1
  return
end if

! Debug print.
! ------------

if (DebugPrint) then
  call Cho_Head(SecNam//': Bookmarks (nVec,delta)','-',80,u6)
  do iSym=1,nSym
    write(u6,'(A,I2,A)') 'Symmetry block',iSym,' Bookmarks (nVec,delta)'
    write(u6,'(5(1X,A,I6,A,ES15.8,A))') ('(',BkmVec(iRS,iSym),',',BkmThr(iRS,iSym),')',iRS=1,nRow_BkmThr)
  end do
end if

! Find largest accuracy below Thr.
! --------------------------------

do iSym=1,mSym
  iRS = 0
  Found = .false.
  do while ((iRS < nRow_BkmThr) .and. (.not. Found))
    iRS = iRS+1
    Found = BkmThr(iRS,iSym) <= Thr
  end do
  if (.not. Found) then
    call Cho_Quit('Bug detected in '//SecNam,104)
  else
    nVec(iSym) = BkmVec(iRS,iSym)
    delta(iSym) = BkmThr(iRS,iSym)
  end if
end do

! Parallel run: take into account the distribution of vectors
! across nodes. Set nVec to the number of vectors needed on this
! node (process).
if (Cho_Real_Par) then
  l = nVec(1)
  do iSym=2,mSym
    l = max(l,nVec(iSym))
  end do
  call mma_Allocate(BkmScr,l,Label='BkmScr')
  do iSym=1,mSym
    call Cho_P_Distrib_Vec(1,nVec(iSym),BkmScr,n)
    nVec(iSym) = n
  end do
  call mma_deallocate(BkmScr)
end if

#ifdef _DEBUGPRINT_
! Self test
do iSym=1,mSym
  if (nVec(iSym) > NumCho(iSym)) call Cho_Quit('Error in '//SecNam,104)
end do
#endif

end subroutine Cho_X_Bookmark

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SGPRWF(iSel,NOCSF,IOCSF,NOW,IOW,CI)
C
C     PURPOSE: PRINT THE WAVEFUNCTION (SPIN COUPLING AND OCCUPATIONS)
C
C     NOTE:    THIS ROUTINE USES THE SPLIT GRAPH GUGA CONVENTION, I.E.,
C              CI BLOCKS ARE MATRICES CI(I,J), WHERE THE  FIRST INDEX
C              REFERS TO THE UPPER PART OF THE WALK.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "rasdim.fh"
#include "rasscf.fh"
#include "general_mul.fh"
#include "input_ras.fh"
#include "output_ras.fh"
#include "gugx.fh"
#include "WrkSpc.fh"
C
      DIMENSION NOCSF(NSYM,NMIDV,NSYM),IOCSF(NSYM,NMIDV,NSYM)
      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)
      DIMENSION CI(NCONF)
      DIMENSION ICS(mxact)
      Integer   iSel(*)
      Character*400 Line
C

      Line(1:16)='      conf/sym  '
      iOff=16
      iSym=nSm(1)
      Do Lev=1,nLev
         If ( nSm(Lev).ne.iSym ) iOff=iOff+1
         Write(Line(iOff+Lev:),'(I1)') nSm(Lev)
         If ( nSm(Lev).ne.iSym ) iSym=nSm(Lev)
      End Do
      iOff=iOff+nLev+3
      Line(iOff:iOff+15)='   Coeff  Weight'
      Write(LF,'(A)') Line(1:iOff+15)
      Line=' '
C
C     RECONSTRUCT THE CASE LIST
C
      NSCR=3*(NLEV+1)
      NICASE=NWALK*NIPWLK
      CALL GETMEM('SCR1','ALLO','INTEG',LSCR,NSCR)
*     CALL GETMEM('CASE','ALLO','INTEG',LICASE,NICASE)
      CALL MKCLIST(NSM,IWORK(LDOWN),IWORK(LNOW),IWORK(LIOW),
     &             IWORK(LICASE),IWORK(LSCR))
      CALL GETMEM('SCR1','FREE','INTEG',LSCR,NSCR)

      IF (KeyPRSD) THEN
        ! scratch for determinant expansion
        CALL GETMEM ('LEX','ALLO','INTEGER',LLEX,NLEV)
      END IF
C
C     ENTER THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
C     WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.
C
      DO MV=1,NMIDV
        DO ISYUP=1,NSYM
          NCI=NOCSF(ISYUP,MV,STSYM)
          IF(NCI.EQ.0) CYCLE
          NUP=NOW(1,ISYUP,MV)
          ISYDWN=MUL(ISYUP,STSYM)
          NDWN=NOW(2,ISYDWN,MV)
          ICONF=IOCSF(ISYUP,MV,STSYM)
          IUW0=LICASE-NIPWLK+IOW(1,ISYUP,MV)
          IDW0=LICASE-NIPWLK+IOW(2,ISYDWN,MV)
          IDWNSV=0
          DO IDWN=1,NDWN
            DO IUP=1,NUP
              ICONF=ICONF+1
              COEF=CI(ICONF)
C -- SKIP OR PRINT IT OUT?
              IF(ABS(COEF).LT.PRWTHR) CYCLE
              IF(IDWNSV.NE.IDWN) THEN
                ICDPOS=IDW0+IDWN*NIPWLK
                ICDWN=IWORK(ICDPOS)
C -- UNPACK LOWER WALK.
                NNN=0
                DO LEV=1,MIDLEV
                  NNN=NNN+1
                  IF(NNN.EQ.16) THEN
                    NNN=1
                    ICDPOS=ICDPOS+1
                    ICDWN=IWORK(ICDPOS)
                  END IF
                  IC1=ICDWN/4
                  ICS(LEV)=ICDWN-4*IC1
                  ICDWN=IC1
                END DO
                IDWNSV=IDWN
              END IF
              ICUPOS=IUW0+NIPWLK*IUP
              ICUP=IWORK(ICUPOS)
C -- UNPACK UPPER WALK:
              NNN=0
              DO LEV=MIDLEV+1,NLEV
                NNN=NNN+1
                IF(NNN.EQ.16) THEN
                  NNN=1
                  ICUPOS=ICUPOS+1
                  ICUP=IWORK(ICUPOS)
                END IF
                IC1=ICUP/4
                ICS(LEV)=ICUP-4*IC1
                ICUP=IC1
              END DO
C -- PRINT IT!
              iSel(iConf) = 1
              Write(Line(1:),'(I8)') iConf
              iOff=10
              iSym=nSm(1)
              Do Lev=1,nLev
                 If ( nSm(Lev).ne.iSym ) iOff=iOff+1
                 If ( ICS(Lev).eq.3 ) then
                    Write(Line(iOff+Lev:),'(A1)') '2'
                 Else If (ICS(Lev).eq.2) then
                    Write(Line(iOff+Lev:),'(A1)') 'd'
                 Else If (ICS(Lev).eq.1) then
                    Write(Line(iOff+Lev:),'(A1)') 'u'
                 Else If (ICS(Lev).eq.0) then
                    Write(Line(iOff+Lev:),'(A1)') '0'
                 End If
                 If ( nSm(Lev).ne.iSym ) iSym=nSm(Lev)
              End Do
              iOff=iOff+nLev+3
              Write(Line(iOff:),'(2F8.5)') COEF,COEF**2
              Write(LF,'(6X,A)') Line(1:iOff+15)
              IF (KeyPRSD) THEN
                ! use maximum spin projection value
                IMS = ISPIN-1
                WRITE(6,*)
                CALL EXPCSF (ICS, NLEV, IMS, IWORK(LLEX))
                WRITE(6,*)
              ENDIF
              Line=' '
            END DO
          END DO
        END DO
      END DO

      IF (KeyPRSD) THEN
        ! free memory for determinant expansion
        CALL GETMEM ('LEX','FREE','INTEGER',LLEX,NLEV)
      END IF

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PPMem(nHer,MemPP,la,lb,lr)
*
      nElem(i) = (i+1)*(i+2)/2
*
      nHer=0
      MemPP=0
      intmax=Max(nElem(la),nElem(lb))
      intmax=intmax**2
      MemPP=MemPP+3*intmax
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lr)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Cnt1El2(Kernel,KrnlMm,Label,
     &                   iDCnt,iDCar,loper,rHrmt,DiffOp,
     &                   Lab_Dsk,iadd,isym,kcar,nordop)
************************************************************************
*                                                                      *
* Object: to compute the one-electron integrals. The method employed at*
*         this point is not necessarily the fastest. However, the total*
*         time for the computation of integrals will depend on the time*
*         spent in computing the two-electron integrals.               *
*         The memory at this point is assumed to be large enough to do *
*         the computation in core.                                     *
*         The data is structured with respect to four indices, two (my *
*         ny or i j) refer to primitives or basis functions and two (a *
*         b) refer to the components of the cartesian or spherical     *
*         harmonic gaussians.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*             Rewritten for gradients needed in hessian calculations   *
*             and general operator treatment                           *
*             May '95 By:                                              *
*             Anders Bernhardsson , Dept. of Theoretical Chemistry,    *
*             University  of Lund, SWEDEN.                             *
************************************************************************
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iOper
      use Sizes_of_Seward, only:S
      Implicit Real*8 (A-H,O-Z)
      External Kernel, KrnlMm
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
c#include "print.fh"
#include "disp.fh"
#include "disp2.fh"
#include "nsd.fh"
#include "setup.fh"
* log trans   integer dcent
      Real*8 A(3), B(3), RB(3),CCoor(3)
      Character Label*8
      Integer nOp(2), ip(8),ipc(0:7),
     &          iDCRR(0:7), iDCRT(0:7), iStabM(0:7), iStabO(0:7),
     &          IndGrd(0:7)
      Logical AeqB,TstFnc,TF,IfGrd(3,2),EQ,DiffOP,DiffCnt,Trans(2)
      Integer iTwoj(0:7)
      Character*8 Lab_dsk
      Data iTwoj/1,2,4,8,16,32,64,128/
*
*     Statement functions
*
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
*-----Compute the number of blocks from each component of the operator
*     and the irreps it will span.
*
*
      Call FZero(CCoor,3)
      Call iCopy(nIrrep,[0],0,IndGrd,1)
      loper=0
      ii=1
      Do i=0,nirrep-1
         ipC(i)=ii
         ii=ii+nBas(i)**2
      End Do
      nnIrrep=nIrrep
      If (sIrrep) nnIrrep=1
      Do iIrrep=0,nnIrrep-1
         jIrrep=nropr(ieor(ioper(iIrrep), ioper(isym)))
         nDisp = IndDsp(iDcnt,iIrrep)
         Do iCar=1,3
            iComp = 2**(iCar-1)
            If ( TF(iDCnt,iIrrep,iComp)) Then
               ndisp=ndisp+1
               If (iDCar.eq.icar) Then
                  loper=loper+2**jIrrep
                  IndGrd(jIrrep) = nDisp
               End If
            End If
         End Do
      End Do
      nIC=0
      If (loper.eq.0) Return
      Call ICopy(nIrrep,[0],0,ip,1)
      Do iIrrep =0,nIrrep-1
         If (iAnd(2**iIrrep,loper).ne.0) Then
            LenInt=nFck(iIrrep)
            nIc=nIC+1
            Call GetMem(Label,'ALLO','REAL',ip(NIC),LenInt)
            call dcopy_(LenInt,[Zero],0,Work(ip(nIC)),1)
         End If
      End Do
      Call SOS(iStabO,nStabO,1)
*
*-----Auxiliary memory allocation.
*
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Basis_Mode('Valence')
      Call Nr_Shells(nSkal)
      Call Setup_iSD()
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Double loop over shells.
*
      Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
         Do jS = 1, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
            B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
*-------Call kernel routine to get memory requirement. Observe, however
*       that kernels which will use the HRR will allocate that
*       memory internally.
*
        maxi=S%maxPrm(iAng)*S%maxprm(jang)
        Call GetMem('Zeta','ALLO','REAL',iZeta,maxi)
        Call GetMem('Zeta','ALLO','REAL',ipZI ,Maxi)
        Call GetMem('Kappa','ALLO','REAL',iKappa,Maxi)
        Call GetMem('PCoor','ALLO','REAL',iPCoor,Maxi*3)
        Call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)
*
*       Memory requirements for contraction and Symmetry
*       adoption of derivatives.
*
        MaxP= Max(S%MaxPrm(iAng),S%MaxPrm(jAng))
        MaxZeta=S%MaxPrm(iAng)*S%MaxPrm(jAng)
        MaxB= Max(S%MaxBas(iAng),S%MaxBas(jAng))
        lFinal = S%MaxPrm(iAng) * S%MaxPrm(jAng) *
     &           nElem(iAng)*nElem(jAng)*nIrrep
*
        MemKrn=Max(MemKer*Maxi,lFinal)
        Call GetMem('Kernel','ALLO','REAL',iKern,MemKrn)
*
*            Save some memory and use Scrt area for
*            transformation
*
*       Allocate memory for the final integrals all in the
*       primitive basis.
*
        Call GetMem('Final','ALLO','REAL',ipFnl,lFinal)
*
*       Scratch area for the transformation to spherical gaussians
*
        nScr1=S%MaxBas(iAng)*S%MaxBas(jAng)*nElem(iAng)*nElem(jAng)*nIC
        Call GetMem('ScrSph','ALLO','REAL',iScrt1,nScr1)
*
*         At this point we can compute Zeta.
*         This is now computed in the ij or ji order.
*
          Call ZXia(Work(iZeta),Work(ipZI),
     &              iPrim,jPrim,Shells(iShll)%Exp,
     &                          Shells(jShll)%Exp)
*
            DiffCnt=(mdci.eq.iDCnt).or.(mdcj.eq.iDCnt)
            If ((.not.DiffCnt).and.(.not.DiffOp)) Goto 131
            AeqB = iS.eq.jS
            Call lCopy(6,[.false.],0,IfGrd,1)
            Call lCopy(2,[.false.],0,trans,1)
            If (mdci.eq.iDCnt) Then
                IfGrd(idCar,1)=.true.
            End If
            If (mdcj.eq.iDCnt) Then
                IfGrd(idCar,2)=.true.
            End If
*
            If (IfGrd(iDCar,1).and.IfGrd(iDCar,2).and.
     &          (.not.DiffOp)) Then
              IfGrd(iDCar,2)=.false.
              Trans(2)=.true.
            End If
            If (Label.eq.'CONNECTI') Trans(2)=.false.
*
*           Allocate memory for SO integrals that will be generated by
*           this batch of AO integrals.
*
            nSO=0
            Do iIrrep=0,nIrrep-1
                If (iAnd(loper,2**iIrrep).ne.0) Then
                 iSmLbl=2**iIrrep
                 nSO=nSO+MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
               End If
            End Do
c           If (iPrint.ge.29) Write (*,*) ' nSO=',nSO
            If (nSO.eq.0) Go To 131
            Call GetMem(' SO ','ALLO','REAL',ipSO,nSO*iBas*jBas)
            call dcopy_(nSO*iBas*jBas,[Zero],0,Work(ipSO),1)
*
*           Find the DCR for A and B
*
            Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &                     dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
*
*           Find the stabilizer for A and B
*
            Call Inter(dc(mdci)%iStab,dc(mdci)%nStab,
     &                 dc(mdcj)%iStab,dc(mdcj)%nStab,
     &                 iStabM,nStabM)
*
            Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
*           Compute normalization factor
*
            iuv = dc(mdci)%nStab*dc(mdcj)%nStab
            Fact = DBLE(iuv*nStabO) / DBLE(nIrrep**2 * LmbdT)
            If (MolWgh.eq.1) Then
               Fact = Fact * DBLE(nIrrep)**2 / DBLE(iuv)
            Else If (MolWgh.eq.2) Then
               Fact = sqrt(DBLE(iuv))*DBLE(nStabO)/DBLE(nIrrep*LmbdT)
            End If
*
*           Loops over symmetry operations acting on the basis.
*
            nOp(1) = NrOpr(0)
            if(jBas.lt.-999999) write(6,*) 'gcc overoptimization',nDCRR
            Do 140 lDCRR = 0, nDCRR-1
             Call OA(iDCRR(lDCRR),B,RB)
             nOp(2) = NrOpr(iDCRR(lDCRR))
             If (Label.ne.'CONNECTI'
     &           .and.EQ(A,RB).and. (.Not.DiffOp)) Go To 140
*
*            Compute kappa and P.
*
             Call Setup1(Shells(iShll)%Exp,iPrim,
     &                   Shells(jShll)%Exp,jPrim,
     &                   A,RB,Work(iKappa),Work(iPCoor),Work(ipZI))
*
*            Compute AO integrals.
*            for easy implementation of NA integrals.
*
             Call Kernel(Shells(iShll)%Exp,iPrim,
     &                   Shells(jShll)%Exp,jPrim,
     &                   Work(iZeta),Work(ipZI),
     &                   Work(iKappa),Work(iPCoor),
     &                   Work(ipFnl),iPrim*jPrim,
     &                   iAng,jAng,A,RB,nOrder,Work(iKern),
     &                   MemKrn,Ccoor,nOrdOp,IfGrd,IndGrd,nop,
     &                   dc(mdci)%nStab,
     &                   dc(mdcj)%nStab,nic,idcar,idcnt,
     &                   iStabM,nStabM,trans,kcar,isym)
*
*
*        Transform from primitive to contracted basis functions.
*        Order of transformation is fixed. It has been shown through
*        testing that the index order ij,ab will give a performance
*        that is up to 20% faster than the ab,ij index order.
*
*
*            Transform i,jabx to jabx,I
             kk=nElem(iAng)*nElem(jAng)*nIC
             Call DGEMM_('T','N',
     &                   jPrim*kk,iBas,iPrim,
     &                   1.0d0,Work(ipFnl),iPrim,
     &                         Shells(iShll)%pCff,iPrim,
     &                   0.0d0,Work(iKern),jPrim*kk)
*
*            Transform j,abxI to abxI,J
*
             Call DGEMM_('T','N',
     &                   kk*iBas,jBas,jPrim,
     &                   1.0d0,Work(iKern),jPrim,
     &                         Shells(jShll)%pCff,jPrim,
     &                   0.0d0,Work(ipFnl),kk*iBas)
*
*            Transform to spherical gaussians if needed.
*
                 kk=nElem(iAng)*nElem(jAng)
*
                 If (Shells(iShll)%Transf.or.Shells(jShll)%Transf) Then
*
*             Result comes back as IJAB or IJAb
*
                   Call CarSph(Work(ipFnl),kk,iBas*jBas*nIC,
     &                    Work(iKern),nScr1,
     &                    RSph(ipSph(iAng)),iAng,
     &                    Shells(iShll)%Transf,
     &                    Shells(iShll)%Prjct,
     &                    RSph(ipSph(jAng)),jAng,
     &                    Shells(jShll)%Transf,
     &                    Shells(jShll)%Prjct,Work(iScrt1),iCmp*jCmp)
*
                  Call DGeTmO(Work(iScrt1),nIC,nIC,
     &                    iBas*jBas*iCmp*jCmp,
     &                    Work(iKern),iBas*jBas*iCmp*jCmp)

*
                Else
*
*             Transpose abx,IJ back to IJ,abx
*
                    Call DGeTmO(Work(ipFnl),kk*nIC,kk*nIC,
     &                   iBas*jBas,Work(iKern),iBas*jBas)
                End If
*
*            At this point accumulate the batch of integrals onto the
*            final symmetry adapted integrals.
*
*               If (iPrint.ge.99) Then
*                 Call RecPrt (' Accumulated SO integrals, so far...',
*    &                               ' ',Work(ipSO),iBas*jBas,nSO)
*               End If
*
*------------Symmetry adapt component by component
*
             iSOBlk = ipSO
             iIC=1
             Do iIrrep = 0, nIrrep-1
                iSmLbl=iAnd(lOper,iTwoj(iIrrep))
                mSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
                If (mSO.eq.0) Then
                   Do jIrrep = 0, nIrrep-1
                      If (iAnd(iSmLbl,iTwoj(jIrrep)).ne.0) iIC = iIC + 1
                   End Do
                Else
                   Call SymAd1(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                         iShell,jShell,iShll,jShll,iAO,jAO,
     &                         Work(iKern),iBas,jBas,nIC,iIC,
     &                         Work(iSOBlk),mSO,nOp)
                   iSOBlk = iSOBlk + mSO*iBas*jBas
                End If
             End Do
*
 140        Continue
*
*           Multiply with factors due to projection operators
*
           If (Fact.ne.One) Call DScal_(nSO*iBas*jBas,Fact,Work(ipSO),1)
*
*           Scatter the SO's on to the non-zero blocks of the
*           lower triangle.
*
             iSOBlk=ipSO
             iIC=0
             Do  iIrrep = 0, nIrrep-1
               If (iAnd(lOper,2**iIrrep).ne.0) Then
                 iSmlbl=2**iIrrep
                 iiC=iiC+1
                 mSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
                 If (nfck(iirrep).ne.0.and.mSO.ne.0)
     &            Call SOSctt(Work(iSOBlk),iBas,jBas,mSO,
     &                    Work(ip(iIC)),nFck(iIrrep),iSmLbl,
     &                    iCmp,jCmp,iShell,jShell,
     &                    iAO,jAO,nIC,Label,2**iIrrep,rHrmt)
                 iSOBlk = iSOBlk + mSO*iBas*jBas
               End If
             End Do
*
            Call GetMem('  SO ','FREE','REAL',ipSO,nSO*iBas*jBas)
 131        Continue
        Call GetMem('Kappa','FREE','REAL',iKappa,Maxi)
        Call GetMem('PCoor','FREE','REAL',iPCoor,Maxi*3)
        Call GetMem('Zeta','FREE','REAL',ipZI ,Maxi)
        Call GetMem('Zeta','FREE','REAL',iZeta,Maxi)
        Call GetMem('ScrSph','Free','REAL',iScrt1,nScr1)
        Call GetMem('Final','FREE','REAL',ipFnl,lFinal)
        Call GetMem('Kernel','FREE','REAL',iKern,MemKrn)
         End Do
      End Do
      Call Free_iSD()
*
*     Compute properties or write integrals to disc and
*     deallocate core.
*
      ipOut = 0
      mDim = 0
      nDens=0
      ipNuc = 0
      ndenssq=0
      Do iI=0,nIrrep-1
         ndenssq=ndenssq+nbas(ii)**2
         nDens=nDens+nBas(iI)*(nBas(iI)+1)/2
      End Do
      nrOp=0

      Call Getmem('Temp','ALLO','REAL',ipscr,ndenssq)
      Do 16 iIrrep = 0, nIrrep-1
         iSmLbl = 2**iIrrep
         If (iAnd(ismLbl,loper).ne.0) Then
            nrOp=nrOp+1
            jdisp=indgrd(iirrep)
            kOper=2**iIrrep
*           Write(*,*) koper,isym,jdisp,iirrep
            If (iadd.ne.0) Then
               irc=-1
               iopt=0
               iipscr=ip_of_iWork_d(work(ipscr))
               call rdmck(irc,iOpt,Lab_dsk,jdisp,iwork(iipscr),koper)
               If (irc.ne.0)
     & Call SysAbendMsg('cnt1el2','error during read in rdmck',' ')
               call daxpy_(nfck(iirrep),one,
     &                    work(ipscr),1,
     &                   work(ip(nrop)),1)
            End If
            irc=-1
            iopt=0
*           Write(*,*) Lab_dsk,jdisp,koper
            call dwrmck(irc,iOpt,Lab_dsk,jdisp,work(ip(nrop)),koper)
            If (irc.ne.0)
     & Call SysAbendMsg('cnt1el2','error during write in dwrmck',' ')
         Call GetMem(Label,'FREE','REAL',ip(nrOp),nFck(iIrrep))
         End If
 16   Continue
*

      Call Getmem('Temp','FREE','REAL',ipscr,2*ii)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine SPLINT(LNPT,NTP,R1,V1,MBEG,MEND,XX,YY)
!** Subroutine to generate (if LNPT >= 0) 4*NTP coefficients CSP(J)
!  of a cubic spline passing through the NTP points (R1(J),V1(J))
!  and to then calculate values of the resulting function YY(I) at the
!  entering abscissae values XX(I) for  I=MBEG to MEND.
!** If LNPT < 0 , generate function values at the given XX(I) using
!  the coefficients CSP(J) obtained and SAVEd on a preceding call.
!** Assumes both R1(J) & XX(I) are monotonic increasing.
!+++++ Calls only subroutines SPLINE and PLYINTRP ++++++++++++++++++++++
!=======================================================================

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LNPT, NTP, MBEG, MEND
real(kind=wp), intent(in) :: R1(NTP), V1(NTP), XX(MEND)
real(kind=wp), intent(out) :: YY(MEND)
integer(kind=iwp) :: I, IER, I1ST, IDER, JK, K, KK, N2, N3, NIPT
real(kind=wp) :: EPS, R2, RI, RRR, TTMP
integer(kind=iwp), parameter :: MAXSP = 6400
real(kind=wp), save :: CSP(MAXSP)

JK = 0
if (4*NTP > MAXSP) then
  write(u6,602) MAXSP,NTP
  !stop
  call ABEND()
end if
EPS = 1.0e-6_wp*(R1(2)-R1(1))
N2 = 2*NTP
N3 = 3*NTP
if (LNPT > 0) then
  ! On first pass for a given data set, generate spline function
  ! coefficients in subroutine SPLINE
  ! Start by using a cubic polynomial at each end of the range to get
  ! the first derivative at each end for use in defining the spline.
  IDER = 1
  NIPT = 4
  I1ST = NTP-3
  call PLYINTRP(R1(I1ST),V1(I1ST),NIPT,R1(NTP),CSP,NIPT,IDER)
  TTMP = CSP(2)
  call PLYINTRP(R1,V1,NIPT,R1(1),CSP,NIPT,IDER)
  CSP(1) = CSP(2)
  CSP(2) = TTMP
  ! Now call routine to actually generate spline coefficients
  call LEVEL_SPLINE(R1,V1,NTP,3,CSP,MAXSP,IER)
  if (IER /= 0) then
    write(u6,604)
    !stop
    call ABEND()
  end if
end if
! Now, use spline to generate function at desired points XX(I)
do I=MBEG,MEND
  RI = XX(I)
  RRR = RI-EPS
  KK = 1
  ! For a monotonic increasing distance array XX(I),  this statement
  ! speeds up the search for which set of cubic coefficients to use.
  if (I > MBEG) then
    if (XX(I) > XX(I-1)) KK = JK
  end if
  do K=KK,NTP
    JK = K
    if (R1(K) >= RRR) exit
  end do
  JK = JK-1
  if (JK < 1) JK = 1
  R2 = RI-R1(JK)
  YY(I) = CSP(JK)+R2*(CSP(NTP+JK)+R2*(CSP(N2+JK)+R2*CSP(N3+JK)))
end do

return

602 format(' *** ERROR in SPLINT ***  Array dimension  MAXSP=',I4,' cannot contain spline coefficients for  NTP=',I4)
604 format(' *** ERROR in generating spline coefficients in SPLINE')

end subroutine SPLINT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Morgane Vacher                                   *
************************************************************************
C
C *********************************************************************
C *                                                                   *
C * Surboutine to project out some nuclear coordinates from the       *
C * forces and do dynamics in reduced dimensionality.                 *
C *                                                                   *
C * 03/04/2020                                                        *
C * Morgane Vacher                                                    *
C *                                                                   *
C *********************************************************************

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8

      SUBROUTINE project_out_for(force,natom)
      IMPLICIT REAL*8 (a-h,o-z)
#include "prgm.fh"
#include "warnings.fh"
#include "Molcas.fh"
      PARAMETER    (ROUTINE='VV_Second')
#include "MD.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "dyn.fh"
#include "constants2.fh"
      INTEGER                                   :: i,j,p
      INTEGER                                   :: natom
      REAL*8, ALLOCATABLE                       :: Mass(:)
      REAL*8, DIMENSION(natom*3), INTENT(INOUT) :: force
      REAL*8, DIMENSION(natom*3)                :: force_m
      REAL*8, ALLOCATABLE                       :: pcoo(:,:),pcoo_m(:,:)
      REAL*8                                    :: pforce
C
      CALL mma_allocate(pcoo,POUT,natom*3)
      CALL mma_allocate(pcoo_m,POUT,natom*3)
      CALL mma_allocate(Mass,natom)

      CALL Get_dArray('Proj_Coord',pcoo,POUT*natom*3)
      CALL GetMassDx(Mass,natom)

C Mass-weight the force vector
      DO i=1, natom
        DO j=1, 3
          force_m(3*(i-1)+j) = force(3*(i-1)+j)/sqrt(Mass(i))
        ENDDO
      ENDDO

      DO p = 1,POUT
C Mass-weight the projection vector
        DO i=1, natom
          DO j=1, 3
            pcoo_m(p,3*(i-1)+j) = pcoo(p,3*(i-1)+j)*sqrt(Mass(i))
          ENDDO
        ENDDO
C normalise it (needed or not?)
        pcoo_m(p,:) = pcoo_m(p,:)/
     &    sqrt(dot_product(pcoo_m(p,:),pcoo_m(p,:)))
C Project out
        pforce = dot_product(pcoo_m(p,:),force_m)
        force_m = force_m - pforce*pcoo_m(p,:)
      ENDDO

C Un-Mass-weight the force vector
      DO i=1, natom
        DO j=1, 3
          force(3*(i-1)+j) = force_m(3*(i-1)+j)*sqrt(Mass(i))
        ENDDO
      ENDDO

      CALL mma_deallocate(pcoo)
      CALL mma_deallocate(pcoo_m)
      CALL mma_deallocate(Mass)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DGETMI (A,ldA,N)
C
C     TRANSPOSE A SQUARE MATRIX (IN-PLACE)
C
      Real*8 A(ldA,*), Temp
C
      If ( N.le.0 ) then
         Write (6,*)
         Write (6,*)
     &   '  *** Error in subroutine DGETMI ***'
         Write (6,*)
     &   '  Invalid dimension of matrix A :'
         Write (6,*)
     &   '  The number of rows/columns, N, must be larger than zero'
         Write (6,*)
      End If
      If ( (ldA.le.0) .or. (ldA.lt.N) ) then
         Write (6,*)
         Write (6,*)
     &   '  *** Error in subroutine DGETMI ***'
         Write (6,*)
     &   '  Invalid leading dimension of matrix A :'
         Write (6,*)
     &   '  ldA must be larger than 0 and larger than N'
         Write (6,*)
      End If
C
      Do i=1,N
         Do j=1,i-1
            Temp=A(j,i)
            A(j,i)=A(i,j)
            A(i,j)=Temp
         End Do
      End Do
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function SelfEn (nChg)
      Use external_centers
      Implicit Real*8 (A-H,O-Z)
*
* Compute the self interaction energy of input point charges
*
#include "espf.fh"
*
      Real*8 SelfEn
*
      iPL = iPL_espf()
      E = Zero
      Do iChg = 2, nChg
         Qi   = XF(4,iChg)
         XMui = XF(5,iChg)
         YMui = XF(6,iChg)
         ZMui = XF(7,iChg)
         Do jChg = 1, iChg-1
            X = XF(1,iChg) - XF(1,jChg)
            Y = XF(2,iChg) - XF(2,jChg)
            Z = XF(3,iChg) - XF(3,jChg)
            Qj   = XF(4,jChg)
            XMuj = XF(5,jChg)
            YMuj = XF(6,jChg)
            ZMuj = XF(7,jChg)
            R2 = X*X+Y*Y+Z*Z
            R = sqrt(R2)
            R3 = R*R2
            R5 = R2*R3
* q_i interacts with q_j and mu_j
            If (Qi.ne.Zero)
     &         E = E + Qi*(Qj/R-XMuj*X/R3-YMuj*Y/R3-ZMuj*Z/R3)
* mu_x_i interacts with q_j and mu_j
            If (XMui.ne.Zero)
     &         E = E + XMui*(-Qj*X/R3+XMuj*(Three*X*X-R2)/R5
     &                       +YMuj*Three*X*Y/R5+ZMuj*Three*X*Z/R5)
* mu_y_i interacts with q_j and mu_j
            If (YMui.ne.Zero)
     &         E = E + YMui*(-Qj*Y/R3+YMuj*(Three*Y*Y-R2)/R5
     &                       +XMuj*Three*X*Y/R5+ZMuj*Three*Y*Z/R5)
* mu_z_i interacts with q_j and mu_j
            If (ZMui.ne.Zero)
     &         E = E + ZMui*(-Qj*Z/R3+ZMuj*(Three*Z*Z-R2)/R5
     &                       +XMuj*Three*X*Z/R5+YMuj*Three*Y*Z/R5)
         End Do
      End Do
      SelfEn = E
      If (nChg.gt.0.and.iPL.ge.2) Write(6,'(A,F16.10)')
     &    ' (For info only) Self Energy of the charges =',SelfEn
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1993,1998, Roland Lindh                           *
************************************************************************
      SubRoutine CmpctR(abcd,na,nb,nijkl,mijkl,Zeta,Kappab,P,
     &                  Ind_Pair,Con,xZeta,xKapp,xP,IndZ,iOff,Jnd,
     &                  xZInv,CutInt,RadMax,cdMax,EtMax,AeqB,xab,
     &                  xabCon,Alpha,xAlpha,Beta,xBeta)
************************************************************************
*                                                                      *
* Object: to find the largest value of the integrals which will be     *
*         generated by an exponent combination. This information will  *
*         be used to prescreen the data.                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             June '91                                                 *
*             Modified for direct SCF, January '93                     *
*                                                                      *
*             Modified for k2 prescreening, June '98                   *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 abcd(mijkl,na,nb,na,nb), Zeta(mijkl), xab(nijkl),
     &       KappAB(mijkl), P(nijkl,3), xZeta(nijkl), xKapp(nijkl),
     &       xP(nijkl,3), xZInv(nijkl), Con(mijkl), xabCon(nijkl),
     &       Alpha(mijkl), xAlpha(nijkl), Beta(mijkl), xBeta(nijkl)
      Integer IndZ(nijkl+1), Ind_Pair(mijkl)
      Logical AeqB
*
      iRout = 245
      iPrint = nPrint(iRout)
      If (iPrint.ge.59) Then
         Write (6,*) ' In CmpctS'
         Write (6,*) AeqB,iOff,Jnd
         Call RecPrt('Zeta',' ',Zeta,mijkl,1)
         Call RecPrt('abcd',' ',abcd,mijkl,(na*nb)**2)
      End If
*
*     Move data
*
      If (AeqB) Then
         Call ICopy(mijkl,Ind_Pair,1,IndZ(iOff+1),  1)
         call dcopy_(mijkl,Zeta,    1,xZeta(iOff+1), 1)
         call dcopy_(mijkl,KappAB,  1,xKapp(iOff+1), 1)
         call dcopy_(mijkl,P(1,1),  1,xP(iOff+1,1),  1)
         call dcopy_(mijkl,P(1,2),  1,xP(iOff+1,2),  1)
         call dcopy_(mijkl,P(1,3),  1,xP(iOff+1,3),  1)
         call dcopy_(mijkl,Alpha,   1,xAlpha(iOff+1),1)
         call dcopy_(mijkl,Beta,    1,xBeta(iOff+1), 1)
         Do ijkl = 1, mijkl
            ijkl_=Ind_Pair(ijkl)
            xZInv(iOff+ijkl)= One/Zeta(ijkl)
            Temp = Zero
            Do ia = 1, na
               Do ib = 1, nb
                  Temp=Max(Temp,Abs(abcd(ijkl,ia,ib,ia,ib)))
               End Do
            End Do
            xab   (ijkl+iOff)= Sqrt(Temp)
            xabCon(ijkl+iOff)= Sqrt(Temp)*Con(ijkl_)
         End Do
         Jnd = Jnd + mijkl
      Else
         Do ijkl = 1, mijkl
            ijkl_=Ind_Pair(ijkl)
*
*-----------Select the largest element (over components)
            Temp = Zero
            Do ia = 1, na
               Do ib = 1, nb
                  Temp=Max(Temp,Abs(abcd(ijkl,ia,ib,ia,ib)))
               End Do
            End Do
            Temp1= Sqrt(Temp)
            Temp2= Sqrt(Temp)* Con(ijkl_)
            If (KappAB(ijkl)*Con(ijkl)*RadMax.ge.CutInt) Then
               Jnd = Jnd + 1
               xZeta(Jnd) =Zeta(ijkl)
               xKapp(Jnd) =KappAB(ijkl)
               xP(Jnd,1)  =P(ijkl,1)
               xP(Jnd,2)  =P(ijkl,2)
               xP(Jnd,3)  =P(ijkl,3)
               xZInv(Jnd) =One/Zeta(ijkl)
               IndZ(Jnd)  =Ind_Pair(ijkl)
               xab   (Jnd)=Temp1
               xabCon(Jnd)=Temp2
               xAlpha(Jnd)=Alpha(ijkl)
               xBeta(Jnd)=Beta(ijkl)
            End If
         End Do
      End If
      IndZ(nijkl+1)=Jnd
*
      If (iPrint.ge.99) Then
         Write (6,*) 'AeqB=',AeqB
         Write (6,*) 'IndZ=',IndZ
         Call RecPrt('xZeta ',' ',xZeta,  1,nijkl)
         Call RecPrt('xKapp ',' ',xKapp,  1,nijkl)
         Call RecPrt('xP(x) ',' ',xP(1,1),1,nijkl)
         Call RecPrt('xP(y) ',' ',xP(1,2),1,nijkl)
         Call RecPrt('xP(z) ',' ',xP(1,3),1,nijkl)
         Call RecPrt('xZInv ',' ',xZInv,  1,nijkl)
         Call RecPrt('xab   ',' ',xab,    1,nijkl)
         Call RecPrt('xabCon',' ',xabCon, 1,nijkl)
         Call RecPrt('xAlpha',' ',Alpha,  1,nijkl)
         Call RecPrt('xBeta ',' ',Beta,   1,nijkl)
      End If
*
*     Call GetMem(' Exit Cmpct','Check','Real',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(cdMax)
         Call Unused_real(EtMax)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Bernd Artur Hess                                 *
************************************************************************
C $Id: relsewc.r,v 1.4 1995/05/08 14:08:53 hess Exp $
C calculate relativistic operators
C   Bernd Artur Hess, hess@uni-bonn.de
C
C
      SUBROUTINE SCFCLI4(idbg,epsilon,S,H,REVTA,
     *SINVA,NA,NB,ISIZEA,ISIZEB,VELIT,
     *AAA,AAB,ISYMA,ISYMB,CMM1,CMM2,
     *EV4,BU2,BU6,EIG4,EW4,P)
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION H(ISIZEA),P(ISIZEA),
     *          EV4(ISIZEA),S(ISIZEA)
      DIMENSION SINVA(NA,NA),
     *          REVTA(NA,NA),
     *          BU2(NA,NB),
     *          AAA(NA),AAB(NB)
      DIMENSION CMM1(NB,NA),CMM2(NA,NB)
      DIMENSION EW4(NA),EIG4(NA,NA),BU6(NA,NA)
C
C
C
      DO I=1,NB
      DO J=1,NA
      CMM1(I,J)=-CMM2(J,I)
      ENDDO
      ENDDO
C
C
C
C     Now we changed sign due to the imaginary character
C
      IJ=0
      DO I=1,NA
      DO J=1,I
      IJ=IJ+1
      EV4(IJ)=0.0D0
      DO L=1,NB
      EV4(IJ)=EV4(IJ)-CMM2(I,L)*CMM1(L,J)
      ENDDO
      ENDDO
      ENDDO
C
C
*     write(*,*)
*     write(*,*) 'Final BSS matrix no Hess part alpha**2 yet'
*     write(*,*) EV4
C
      DO IJ=1,ISIZEA
      EV4(IJ) = 0.5D0*(1.0D0/(VELIT*VELIT))*EV4(IJ)
      ENDDO
C
      CALL AddMar(ISIZEA,EV4,H)
C
C
C
C
culf
      if(idbg.gt.0)CALL PRMAT(IDBG,h,na,nb,'h   oper')
      CALL Sogr(idbg,NA,S,SINVA,P,BU6,EW4)
C
      CALL Diagr(H,NA,EIG4,EW4,SINVA,BU6,EV4)
C
*     if(idbg.gt.0)WRITE (idbg,*) '--- EIGENVALUES OF H MATRIX ---'
*     if(idbg.gt.0)WRITE (idbg,'(4D20.12)') EW4
C
*     write(*,*) 'END OF SCFCLI4 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_real(epsilon)
        CALL Unused_real_array(REVTA)
        CALL Unused_integer(ISIZEB)
        CALL Unused_real_array(AAA)
        CALL Unused_real_array(AAB)
        CALL Unused_integer(ISYMA)
        CALL Unused_integer(ISYMB)
        CALL Unused_real_array(BU2)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine KnEInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: to compute the kinetic energy integrals with the Gauss-      *
*         Hermite quadrature.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Modified to multipole moments November '90               *
************************************************************************
      use Her_RW
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
*
#include "rmat_option.fh"
#include "rmat.fh"
*
#include "print.fh"

#include "int_interface.fh"
*     Local variables
      Logical ABeq(3)
*
      iRout = 150
      iPrint = nPrint(iRout)
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+2)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+2)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp-1)
      ipQxyz = nip
      nip = nip + nZeta*3*(la+2)*(lb+2)*(nOrdOp-1)
      ipTxyz = nip
      nip = nip + nZeta*3*(la+1)*(lb+1)
      ipA = nip
      nip = nip + nZeta
      ipB = nip
      nip = nip + nZeta
*                                                                      *
************************************************************************
*                                                                      *
      If (RMat_type_integrals) Then
         ipRnr=nip
         nip  = nip + nZeta*(la+lb+3)
         ipqC = nip
         nip  = nip + nZeta*(la+lb+1)
         ipDi =nip
         nip  = nip + nZeta*(la+lb+1)
      Else
         ipRnr=-1
         ipqC =-1
         ipDi =-1
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (nip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'KNEInt: nip-1.gt.nArr*nZeta')
         Write (6,*) 'nip=',nip
         Write (6,*) 'nArr,nZeta=',nArr,nZeta
         Call  Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In KnEInt: A',' ',A,1,3)
         Call RecPrt(' In KnEInt: RB',' ',RB,1,3)
         Call RecPrt(' In KnEInt: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In KnEInt: P',' ',P,nZeta,3)
         Write (6,*) ' In KnEInt: la,lb=',la,lb
      End If
*
      If (RMat_type_integrals) Then
*                                                                      *
************************************************************************
*                                                                      *
*     R-matrix calculations: continuum basis functions (A=B=P=0)
*      Compute the contributions of the basis functions and multipole
*      radial part
*
       lsum=la+lb+2
       Call radlc(Zeta,nZeta,lsum,Array(ipRnr))
*
*     Optional for photoionization:
*     R-matrix calculations: continuum basis functions (A=B=P=0)
*      Compute the contributions of the Coulomb operator times qCoul
*      outside the sphere Omega
*
       if(abs(qCoul).gt.Epsq) then
        lsum=la+lb
        icop=1
        Call radlq(Zeta,nzeta,lsum,Array(ipqC),icop)
       endif
*
       if(abs(dipol1).gt.Epsq) then
        lsum=la+lb
        icop=2
        Call radlq(Zeta,nzeta,lsum,Array(ipDi),icop)
       endif
*
*     Combine the radial and angular component to the full one electron
*     integral.
*
       Call CmbnKEr(Array(ipRnr),Array(ipqC),Array(ipDi),
     &              nZeta,la,lb,Zeta,Final,
     &              nComp,Alpha,nAlpha,Beta,nBeta)
*
      Else
*                                                                      *
************************************************************************
*                                                                      *
*
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la+1,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb+1,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the contribution from the multipole moment operator
*
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),
     &            nOrdOp-2,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the cartesian components for the multipole moment
*     integrals. The integrals are factorized into components.
*
       Call Assmbl(Array(ipQxyz),
     &             Array(ipAxyz),la+1,
     &             Array(ipRxyz),nOrdOp-2,
     &             Array(ipBxyz),lb+1,
     &             nZeta,HerW(iHerW(nHer)),nHer)
*
*     Compute the cartesian components for the kinetic energy integrals.
*     The kinetic energy components are linear combinations of overlap
*     components.
*
      ipAOff = ipA
      Do 200 iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
 200  Continue
*
      ipBOff = ipB
      Do 210 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
 210  Continue
*
      Call Kntc(Array(ipTxyz),Array(ipQxyz),la,lb,
     &          Array(ipA),Array(ipB),nZeta)
*
*     Combine the cartesian components to the full one electron
*     integral.
*
      Call CmbnKE(Array(ipQxyz),nZeta,la,lb,nOrdOp-2,Zeta,rKappa,Final,
     &          nComp,Array(ipTxyz))
*
      End If
*
*     Call GetMem(' Exit KnEInt','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iChO)
         Call Unused_integer_array(iStabM)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine defvhlp3(r1,r2,v,dimr1a,dimr1b,dimr1c,dimr2ac,dimva,dimvb,dimvc,adda,addb,addc)
! this routine does
! V(a,b,c)xxx = R1(a,c,b)-R2(b,ac) x=a,b
! for syma/=symb symc==syma
!
! r1      - r1 matrix (I)
! r2      - r2 matrix (I)
! v       - v matrix (O)
! dimr1a  - dimension of a in R1 (I)
! dimr1b  - dimension of b in R1 (I)
! dimr1c  - dimension of c in R1 (I)
! dimr2ac - dimension of ac in R2 (I)
! dimva   - dimension of a in V (I)
! dimvb   - dimension of b in V (I)
! dimvc   - dimension of c in V (I)
! adda    - additional constant to a (I)
! addb    - additional constant to b (I)
! addc    - additional constant to c (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimr1a, dimr1b, dimr1c, dimr2ac, dimva, dimvb, dimvc, adda, addb, addc
real(kind=wp), intent(in) :: r1(dimr1a,dimr1c,dimr1b), r2(dimr1b,dimr2ac)
real(kind=wp), intent(out) :: v(dimva,dimvb,dimvc)
integer(kind=iwp) :: a, acr2, b, br1, c, cr1, cr2

do b=1,dimvb
  br1 = b+addb
  do c=1,dimvc
    cr1 = c+addc
    v(:,b,c) = r1(adda+1:adda+dimva,cr1,br1)
  end do
end do

do c=1,dimvc
  cr2 = c+addc
  do a=1,dimvc
    !acr2 = indab(a+adda,cr2)
    if ((a+adda) >= cr2) then
      acr2 = (a+adda)*(a+adda-1)/2+cr2
    else
      acr2 = cr2*(cr2-1)/2+a+adda
    end if
    v(a,:,c) = v(a,:,c)-r2(addb+1:addb+dimvb,acr2)
  end do
end do

return

end subroutine defvhlp3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Track_State(OVLP)
      IMPLICIT NONE
#include "Molcas.fh"
#include "cntrl.fh"
#include "real.fh"
#include "prgm.fh"
      INTEGER iState,initState,newState
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      INTEGER j
#endif
      REAL*8 MaxOv,ThisOv
      REAL*8 ovlp(nstate,nstate)
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='Track_State')



*     Check that there are 2 JOB files, with the same number of states
      IF (nJob.ne.2) THEN
        Call SysAbendMsg('Track_State',
     &  'The number of JOB files should be 2.','')
      END IF
      IF (nStat(2).ne.nStat(1)) THEN
        Call SysAbendMsg('Track_State',
     &  'The number of states in the JOB files should be the same.','')
      END IF

*     Get the root to track
      CALL Get_iScalar('Relax CASSCF root',initState)

*     Find the root in the first JOB (current states) that has maximum
*     overlap with the tracked root in the second JOB (previous states)
#ifdef _DEBUGPRINT_
      WRITE(6,*)
      WRITE(6,*)'OVERLAP MATRIX FOR THE ORIGINAL STATES:'
      WRITE(6,*)
      DO iState=1,nState
        WRITE(6,'(5(1X,F15.8))')(Ovlp(iState,j),j=1,iState)
      END DO
#endif
      IF (IPGLOB.ge.USUAL) THEN
        WRITE(6,*)
        WRITE(6,*) 'Initial root: ',initState
        WRITE(6,*) 'Overlaps with current states:'
      END IF
      MaxOv=Zero
      newState=0
      DO iState=1,nStat(1)
        ThisOv=Ovlp(iState,initState+nStat(1))
        IF (IPGLOB.ge.USUAL) THEN
          WRITE(6,'(I5,1X,F15.8)') iState,ThisOv
        END IF
        IF (ABS(ThisOv).gt.MaxOv) THEN
          MaxOv=ABS(ThisOv)
          newState=iState
        END IF
      END DO
      IF (IPGLOB.ge.USUAL) THEN
        WRITE(6,*) 'New root: ',newState
      END IF

*     If no state is found, something wrong has happened
      IF (newState.eq.0) THEN
        Call SysAbendMsg('Track_State',
     &  'No overlaps!','')
      END IF

*     Store the new state for geometry optimization
      IF (newState.ne.initState) THEN
        CALL Put_iScalar('Relax CASSCF root',newState)
        CALL Put_iScalar('Relax Original root',newState)
        CALL Put_iScalar('NumGradRoot',newState)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine getmediate (wrk,wrksize,
     & lun,poss0,mapd,mapi,rc)
c
c     this routine read required mediate from opened unformatted file
c     with number lun, and place it statring with the poss0
c     it also reads mapd and mapi of the given mediade, and reconstruct
c     mapd to actual possitions
c
c     lun   - Logical unit number of file, where mediate is stored (Input)
c     poss0 - initial possition in WRK, where mediate will be stored (Input)
c     mapd  - direct map matrix corresponding to given mediate (Output)
c     mapi  - inverse map matrix corresponding to given mediate (Output)
c     rc    - return (error) code (Output)
c
c     N.B.
c     all mediates are storred as follows
c     1 - mapd, mapi
c     2 - one record with complete mediate
c
#include "wrk.fh"
       integer lun,poss0,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer length,rc1
c
       rc=0
c
c1    read mapd
c
      call getmap (lun,poss0,length,mapd,mapi,rc1)
c
c2    read mediate in one block
c
       if (length.eq.0) then
c     RC=1 : there is nothing to read, length of mediate is 0
       rc=1
       return
       end if
c
       call rea (lun,length,wrk(poss0))
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!***********************************************************************

subroutine RSSBCBN_MCLR(IASM,IATP,IBSM,IBTP,JASM,JATP,JBSM,JBTP,IAEL1,IAEL3,IBEL1,IBEL3,JAEL1,JAEL3,JBEL1,JBEL3,NAEL,NBEL,IJAGRP, &
                        IJBGRP,SB,CB,IDOH2,NTSOB,IBTSOB,ITSOB,MAXI,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,C2,NSM,NIA, &
                        NIB,NJA,NJB,IST,CJRES,SIRES,NOPART,TimeDep)
! Contributions to sigma block (iasm iatp, ibsm ibtp) from
! C block (jasm jatp, jbsm, jbtp)
!
! =====
! Input
! =====
! IASM,IATP   : Symmetry and type of alpha strings in sigma
! IBSM,IBTP   : Symmetry and type of beta  strings in sigma
! JASM,JATP   : Symmetry and type of alpha strings in C
! JBSM,JBTP   : Symmetry and type of beta  strings in C
! IAEL1,IAEL3 : Number of elecs in RAS1(RAS3) for alpha strings in sigma
! IBEL1,IBEL3 : Number of elecs in RAS1(RAS3) for  beta strings in sigma
! JAEL1,JAEL3 : Number of elecs in RAS1(RAS3) for alpha strings in C
! JBEL1,JBEL3 : Number of elecs in RAS1(RAS3) for  beta strings in C
! NAEL        : Number of alpha electrons
! NBEL        : Number of  beta electrons
! IJAGRP      : IA and JA belongs to this group of strings
! IJBGRP      : IB and JB belongs to this group of strings
! CB          : Input c block
! IDOH2       : = 0 => no two electron operator
! IDOH2       : = 1 =>    two electron operator
! NTSOB       : Number of orbitals per type and symmetry
! IBTSOB      : base for orbitals of given type and symmetry
! IBORB       : Orbitals of given type and symmetry
! MAXI        : Largest Number of "spectator strings" treated simultaneously
! MAXK        : Largest number of inner resolution strings treated at simult.
! IST, IDOH2  : See RASSG3 input description
!
! ======
! Output
! ======
! SB : fresh sigma block
!
! =======
! Scratch
! =======
! SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the largest
!              number of orbital pairs of given symmetries and types.
! I1, XI1S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! I1, XI1S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! C2         : Must hold largest STT block of sigma or C
! XINT       : Scratch space for integrals.
!
! Jeppe Olsen, Winter of 1991

use Constants, only: One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IASM, IATP, IBSM, IBTP, JASM, JATP, JBSM, JBTP, IAEL1, IAEL3, IBEL1, IBEL3, JAEL1, JAEL3, JBEL1, &
                                 JBEL3, NAEL, NBEL, IJAGRP, IJBGRP, IDOH2, NTSOB(*), IBTSOB(*), ITSOB(*), MAXI, MAXK, NSM, NIA, &
                                 NIB, NJA, NJB, IST, NOPART
real(kind=wp), intent(inout) :: SB(*), CB(*)
real(kind=wp), intent(_OUT_) :: SSCR(*), CSCR(*), XI1S(MAXK,*), XI2S(MAXK,*), XI3S(MAXK,*), XI4S(MAXK,*), XINT(*), C2(*), &
                                CJRES(*), SIRES(*)
integer(kind=iwp), intent(_OUT_) :: I1(MAXK,*), I2(MAXK,*), I3(MAXK,*), I4(MAXK,*)
logical(kind=iwp), intent(in) :: TimeDep
integer(kind=iwp) :: ieaw, IFACTOR, IIITRNS, JJJTRNS
real(kind=wp) :: SGN

! ============================
! Sigma beta beta contribution
! ============================

! Sigma aa(IA,IB) = sum(i > k,j > l)<IB!Eb(ij)Eb(kl)!JB>
!                 * ((ij!kl)-(il!kj)) C(IA,JB)
!                 + sum(ij) <IB!Eb(ij)!JB> H(ij) C(IA,JB)

!write(u6,*) 'I am in rssbcbn'
if ((IATP == JATP) .and. (JASM == IASM)) then

  ! One electron part

  if (IST == 1) then
    SGN = One
  else
    SGN = -One
  end if
  if (NBEL >= 1) &
    call RSBB1E_MCLR(IBSM,IBTP,JBSM,JBTP,IJBGRP,NIA,IBEL1,IBEL3,JBEL1,JBEL3,SB,CB,NTSOB,IBTSOB,ITSOB,MAXI,MAXK,SSCR,CSCR,I1,XI1S, &
                     XINT,NSM,SGN)

  ! Two electron part

  if ((IDOH2 /= 0) .and. (NBEL >= 2)) then
    !write(u6,*) 'Timedep in rssbcbn',TimeDep
    ieaw = 0
    call RSBB2A_MCLR(IBSM,IBTP,JBSM,JBTP,IJBGRP,NIA,IBEL1,IBEL3,JBEL1,JBEL3,SB,CB,NTSOB,IBTSOB,MAXI,MAXK,SSCR,CSCR,I1,XI1S,XINT, &
                     NSM,SGN,NOPART,TimeDep,ieaw)
  end if
end if

!====================================
! Mixed alpha-beta double excitations
!====================================

if ((IDOH2 /= 0) .and. (NAEL >= 1) .and. (NBEL >= 1)) then

  ieaw = 0
  if (ist == 2) ieaw = 1
  call TRNSPS(NJA,NJB,CB,C2)
  CB(1:NJA*NJB) = C2(1:NJA*NJB)
  call TRNSPS(NIA,NIB,SB,C2)
  SB(1:NIA*NIB) = C2(1:NIA*NIB)
  IIITRNS = 1
  if ((IIITRNS == 1) .and. (NIB > NIA) .and. (NJB > NJA)) then
    JJJTRNS = 1
  else
    JJJTRNS = 0
  end if
  if ((JJJTRNS == 1) .and. (IST == 2)) then
    IFACTOR = -1
  else
    IFACTOR = 1
  end if
  if (JJJTRNS == 0) then
    call RSBB2BN_MCLR(IASM,IATP,IBSM,IBTP,NIA,NIB,JASM,JATP,JBSM,JBTP,NJA,NJB,IJAGRP,IJBGRP,IAEL1,IAEL3,JAEL1,JAEL3,IBEL1,IBEL3, &
                      JBEL1,JBEL3,SB,CB,NTSOB,IBTSOB,MAXK,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,NSM,CJRES,SIRES,IFACTOR,ieaw,TimeDep)
  else if (JJJTRNS == 1) then
    call TRNSPS(NIB,NIA,SB,C2)
    SB(1:NIA*NIB) = C2(1:NIA*NIB)
    call TRNSPS(NJB,NJA,CB,C2)
    CB(1:NJA*NJB) = C2(1:NJA*NJB)

    call RSBB2BN_MCLR(IBSM,IBTP,IASM,IATP,NIB,NIA,JBSM,JBTP,JASM,JATP,NJB,NJA,IJBGRP,IJAGRP,IBEL1,IBEL3,JBEL1,JBEL3,IAEL1,IAEL3, &
                      JAEL1,JAEL3,SB,CB,NTSOB,IBTSOB,MAXK,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,NSM,CJRES,SIRES,IFACTOR,ieaw,TimeDep)
    call TRNSPS(NIA,NIB,SB,C2)
    SB(1:NIA*NIB) = C2(1:NIA*NIB)
    call TRNSPS(NJA,NJB,CB,C2)
    CB(1:NJA*NJB) = C2(1:NJA*NJB)
  end if
  ! Restore order!
  call TRNSPS(NJB,NJA,CB,C2)
  CB(1:NJA*NJB) = C2(1:NJA*NJB)
  call TRNSPS(NIB,NIA,SB,C2)
  SB(1:NIA*NIB) = C2(1:NIA*NIB)
end if

! ========================
! Sigma alpha contribution
! ========================

! Transpose for alpha excitations

if ((NAEL >= 1) .and. (IBTP == JBTP) .and. (IBSM == JBSM)) then
  call TRNSPS(NJA,NJB,CB,C2)
  CB(1:NJA*NJB) = C2(1:NJA*NJB)
  call TRNSPS(NIA,NIB,SB,C2)
  SB(1:NIA*NIB) = C2(1:NIA*NIB)

  ! alpha single excitation

  SGN = One
  call RSBB1E_MCLR(IASM,IATP,JASM,JATP,IJAGRP,NIB,IAEL1,IAEL3,JAEL1,JAEL3,SB,CB,NTSOB,IBTSOB,ITSOB,MAXI,MAXK,SSCR,CSCR,I1,XI1S, &
                   XINT,NSM,SGN)

  ! alpha double excitation

  if ((NAEL >= 2) .and. (IDOH2 /= 0)) &
    call RSBB2A_MCLR(IASM,IATP,JASM,JATP,IJAGRP,NIB,IAEL1,IAEL3,JAEL1,JAEL3,SB,CB,NTSOB,IBTSOB,MAXI,MAXK,SSCR,CSCR,I1,XI1S,XINT, &
                     NSM,SGN,NOPART,TimeDep,ieaw)

  ! Restore order!
  call TRNSPS(NIB,NIA,SB,C2)
  SB(1:NIA*NIB) = C2(1:NIA*NIB)
  call TRNSPS(NJB,NJA,CB,C2)
  CB(1:NJA*NJB) = C2(1:NJA*NJB)
end if

return

end subroutine RSSBCBN_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE TPQSET(ICASE,TPQ,IP)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TPQ(*),IOCR(100)
      DIMENSION ICASE(*)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      LOGICAL LWSP
      COMMON /SPIN/ LWSP
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CRL   JO(L)=IAND(ISHFT(QOCC((L+29)/30),-2*((L+29)/30*30-L)),3)
CPAM97      JO(L)=UNPACK(QOCC((L+29)/30), 2*L-(2*L-1)/60*60, 2)
      JO(L)=ICUNP(ICASE,L)
C
      D0=0.0D0
      D1=1.0D0
      D2=2.0D0
C
      IOR=0
      II1=(IREF0-1)*LN
      DO 35 I=1,LN
      JOJ=JO(II1+I)
      IOR=IOR+1
      IOCR(IOR)=JOJ
35    CONTINUE
C
      IINT=IRC(4)
      DO 7 IQ=1,IINT
      TPQ(IQ)=D1
      IF(INCPF.EQ.1)TPQ(IQ)=D2/N
      IF(IQ.EQ.IREF0.OR.IP.EQ.IREF0)TPQ(IQ)=D0
7     CONTINUE
      IF(ISDCI.EQ.1.OR.INCPF.EQ.1.OR.IP.EQ.IREF0)RETURN
C
      II=0
      IJ=0
      DO 15 I=1,LN
      JJ=(IP-1)*LN+I
      IF(JO(JJ).EQ.IOCR(I).OR.JO(JJ).EQ.3)GO TO 15
      IF(LWSP.AND.JO(JJ)*IOCR(I).EQ.2) GO TO 15
      IF(II.NE.0)GO TO 16
      II=I
16    IJ=I
15    CONTINUE
      NI=IOCR(II)
      IF(NI.GT.1)NI=NI-1
      NJ=IOCR(IJ)
      IF(NJ.GT.1)NJ=NJ-1
      DO 20 IQ=1,IINT
      IK=0
      IL=0
      DO 25 I=1,LN
      JJ=(IQ-1)*LN+I
      IF(JO(JJ).EQ.IOCR(I).OR.JO(JJ).EQ.3)GO TO 25
      IF(LWSP.AND.JO(JJ)*IOCR(I).EQ.2) GO TO 25
      IF(IK.NE.0)GO TO 26
      IK=I
26    IL=I
25    CONTINUE
      DIK=D0
      DIL=D0
      DJK=D0
      DJL=D0
      IF(II.EQ.IK)DIK=D1
      IF(II.EQ.IL)DIL=D1
      IF(IJ.EQ.IK)DJK=D1
      IF(IJ.EQ.IL)DJL=D1
      TPQ(IQ)=(DIK+DIL)/(D2*NI)+(DJK+DJL)/(D2*NJ)
      IF(IQ.EQ.IREF0)TPQ(IQ)=D0
20    CONTINUE
      IF(IPRINT.LT.15)RETURN
      IF(IPRINT.GT.5)WRITE(6,11)(TPQ(IQ),IQ=1,IINT)
11    FORMAT(5X,'TPQ',10F5.2)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1994, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine RysEFX(xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,iye,iyf,ixye,ixyf,nzeMin,nzeMax, &
                  nzfMin,nzfMax)
!***********************************************************************
!                                                                      *
!     Object: kernel routine to assemble the integrals from the Ixy    *
!             and Iz integrals.                                        *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             August '90                                               *
!                                                                      *
!             Modified for decreased memory access January '94.        *
!***********************************************************************

use Index_Functions, only: C3_Ind
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nArg, mArg, nRys, neMax, nfMax, meMin, meMax, mfMin, mfMax, ixe, ixf, iye, iyf, ixye, ixyf, &
                                 nzeMin, nzeMax, nzfMin, nzfMax
real(kind=wp), intent(in) :: xyz2D(nRys,mArg,3,0:neMax,0:nfMax), PreFct(mArg)
real(kind=wp), intent(inout) :: EFInt(nArg,meMin:meMax,mfMin:mfMax)
integer(kind=iwp) :: Inde, Indf, iRys, ize, izf

! General code

do izf=nzfMin,nzfMax
  Indf = C3_Ind(ixyf+izf,ixf,izf)-1
  do ize=nzeMin,nzeMax
    Inde = C3_Ind(ixye+ize,ixe,ize)-1
    EFInt(1:mArg,Inde,Indf) = xyz2D(1,:,1,ixe,ixf)*xyz2D(1,:,2,iye,iyf)*xyz2D(1,:,3,ize,izf)
    do iRys=2,nRys
      EFInt(1:mArg,Inde,Indf) = EFInt(1:mArg,Inde,Indf)+xyz2D(iRys,:,1,ixe,ixf)*xyz2D(iRys,:,2,iye,iyf)*xyz2D(iRys,:,3,ize,izf)
    end do
    EFInt(1:mArg,Inde,Indf) = EFInt(1:mArg,Inde,Indf)*PreFct(:)
  end do
end do

return

end subroutine RysEFX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  quaterRotation
*
*> @brief
*>   Performs the rotation of \p U in \p V via the quaternion \p Q
*> @author Y. Carissan
*>
*> @details
*> Performs the rotation of \p U in \p V via the quaternion \p Q.
*>
*> @param[in]  Q Quaternion used for the rotation
*> @param[in]  U Vector to be rotated
*> @param[out] V Vector rotated
************************************************************************
      subroutine quaterRotation(Q,U,V)
      Implicit none
#include "WrkSpc.fh"
#include "debug.fh"
#include "real.fh"
      Real*8 U(3),V(3),Q(0:3)
      Real*8 T(3)
      Real*8 C1,C2,C3
      real*8 ddot_

      Call CheckQuater(Q)
      Call Cross(Q(1),U,T)    ! T=QxU
c
      C1=Two*Q(0)**2-One          ! C1 = 2 * Q(0)^2 - 1
      C2=2*Q(0)                   ! C2 = 2 * Q(0)
      C3=Two*ddot_(3,Q(1),1,U,1)   ! C3 = 2 * Q.U
      V(1) = C1*U(1) - C2*T(1) + C3*Q(1)
      V(2) = C1*U(2) - C2*T(2) + C3*Q(2)
      V(3) = C1*U(3) - C2*T(3) + C3*Q(3)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pseud1(ccr,gout,ltot1,ncr,nkcrl,nkcru,zcr,lit,ljt,ai,aj,xi,yi,zi,xj,yj,zj,xc,yc,zc,kcrs,lproju1,crda,crdb)
! compute type 1 core potential integrals

use ppint_arrays, only: binom, dfac, lmf, lml, lmnv, lmx, lmy, lmz, zlm
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Four, Ten, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ltot1, ncr(*), lit, ljt, kcrs, lproju1, nkcrl(lproju1,*), nkcru(lproju1,*)
real(kind=wp), intent(in) :: ccr(*), zcr(*), ai, aj, xi, yi, zi, xj, yj, zj, xc, yc, zc
real(kind=wp), intent(inout) :: gout(*)
real(kind=wp), intent(out) :: crda(lit,3), crdb(ljt,3)
integer(kind=iwp) :: i, ijt, it, itl, itu, j, jt, jtl, jtu, kcrl, kcru, la1, lam, lamu, lb1, ma1, mb1, n, na1, nb1, nhi
real(kind=wp) :: aa, aaa, aarr1, alpt, arp2, fctr2, rk, rp, rp2, rr, s, taa, xij, xijm, xk, xka, xkb, yij, yijm, yk, yka, ykb, &
                 zij, zijm, zk, zka, zkb
integer(kind=iwp), parameter :: llt_(7,2) = reshape([1,2,5,11,21,36,57,1,4,10,20,35,56,84],shape(llt_))
real(kind=wp), allocatable :: ang(:,:), qsum(:,:), xab(:), yab(:), zab(:)
real(kind=wp), parameter :: tol = 20.0_wp*log(Ten)

call mma_allocate(ang,ltot1,ltot1,label='ang')
call mma_allocate(qsum,ltot1,ltot1,label='qsum')
call mma_allocate(xab,ltot1,label='xab')
call mma_allocate(yab,ltot1,label='yab')
call mma_allocate(zab,ltot1,label='zab')

fctr2 = Four
itl = llt_(lit,1)
itu = llt_(lit,2)
jtl = llt_(ljt,1)
jtu = llt_(ljt,2)
aa = ai+aj
do i=1,3
  crda(1,i) = One
  crdb(1,i) = One
end do
xka = xc-xi
yka = yc-yi
zka = zc-zi
!ca = sqrt(xka*xka+yka*yka+zka*zka)
if (lit /= 1) then
  crda(2,1) = xka
  crda(2,2) = yka
  crda(2,3) = zka
  if (lit /= 2) then
    do i=1,3
      do j=3,lit
        crda(j,i) = crda(2,i)*crda(j-1,i)
      end do
    end do
  end if
end if
xkb = xc-xj
ykb = yc-yj
zkb = zc-zj
!cb = sqrt(xkb*xkb+ykb*ykb+zkb*zkb)
if (ljt /= 1) then
  crdb(2,1) = xkb
  crdb(2,2) = ykb
  crdb(2,3) = zkb
  if (ljt /= 2) then
    do i=1,3
      do j=3,ljt
        crdb(j,i) = crdb(2,i)*crdb(j-1,i)
      end do
    end do
  end if
end if
xij = Half*(xi+xj)
yij = Half*(yi+yj)
zij = Half*(zi+zj)
xijm = Half*(xi-xj)
yijm = Half*(yi-yj)
zijm = Half*(zi-zj)
rr = (xi-xj)**2+(yi-yj)**2+(zi-zj)**2
aaa = (ai-aj)/aa
xk = xij+aaa*xijm-xc
yk = yij+aaa*yijm-yc
zk = zij+aaa*zijm-zc
aarr1 = (ai*aj/aa)*rr
taa = aa+aa

rp2 = xk*xk+yk*yk+zk*zk
if (rp2 == Zero) then
  rp = Zero
  arp2 = Zero
  alpt = Zero
  rk = Zero
  lamu = 1
else
  rp = sqrt(rp2)
  xk = xk/rp
  yk = yk/rp
  zk = zk/rp
  arp2 = aa*rp2
  alpt = aa*arp2
  rk = taa*rp
  lamu = ltot1
end if

! compute radial integrals and sum over potential terms

qsum(:,:) = Zero
kcrl = nkcrl(1,kcrs)
kcru = nkcru(1,kcrs)
call rad1(aa,aarr1,alpt,arp2,ccr,dfac,fctr2,kcrl,kcru,lamu,ltot1,ncr,qsum,rk,tol,zcr)
ijt = 0
do it=itl,itu
  na1 = lmnv(1,it)+1
  la1 = lmnv(2,it)+1
  ma1 = lmnv(3,it)+1
  do jt=jtl,jtu
    ijt = ijt+1
    s = Zero
    nb1 = lmnv(1,jt)+1
    lb1 = lmnv(2,jt)+1
    mb1 = lmnv(3,jt)+1

    ! compute angular integrals

    call facab(binom,na1,nb1,crda(1,1),crdb(1,1),xab)
    call facab(binom,la1,lb1,crda(1,2),crdb(1,2),yab)
    call facab(binom,ma1,mb1,crda(1,3),crdb(1,3),zab)
    call ang1(ang,dfac,na1+nb1-1,la1+lb1-1,ma1+mb1-1,lamu,lmf,lml,lmx,lmy,lmz,ltot1,xab,yab,zab,xk,yk,zk,zlm)

    ! combine angular and radial integrals

    do lam=1,lamu
      nhi = ltot1-mod(ltot1-lam,2)
      do n=lam,nhi,2
        s = s+ang(n,lam)*qsum(n,lam)
      end do
    end do
    gout(ijt) = gout(ijt)+s
  end do
end do

call mma_deallocate(ang)
call mma_deallocate(qsum)
call mma_deallocate(xab)
call mma_deallocate(yab)
call mma_deallocate(zab)

return

end subroutine pseud1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

function GLeSum(K,X,W,Delta)
!======================================================================*
!----------------------------------------------------------------------*
!                                                                      *
!     FUNCTION : Compute the Function in Gauss-Legendre method         *
!             K                                                        *
!     1/X =: SUM W(I)*Func(X(I))                                       *
!            I=1                                                       *
!                                                                      *
!     Author(s): Akio Takatsuka (2007)                                 *
!                                                                      *
!----------------------------------------------------------------------*
!======================================================================*

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: GLeSum
integer(kind=iwp), intent(in) :: K
real(kind=wp), intent(in) :: X(20), W(20), Delta
integer(kind=iwp) :: I
real(kind=wp) :: A, Derv, Dum, Val, Varl

Dum = Zero
do I=1,K
  A = One/(One-X(I))
  Varl = X(I)*A
  Derv = Varl*A
  Val = Derv*exp(-Delta*Varl)
  Dum = Dum+W(I)*Val
end do
GLeSum = Dum

return

end function GLeSum

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Roland Lindh                                           *
!***********************************************************************
!  Get_nAtoms_All
!
!> @author R. Lindh
!>
!> @details
!> Get number of all atoms (not only symmetry unique) from RUNFILE.
!>
!> @param[out] nAtoms_All Number of all atoms in the molecule
!***********************************************************************

subroutine Get_nAtoms_All(nAtoms_All)

use stdalloc, only: mma_allocate, mma_deallocate
use Symmetry_Info, only: iOper, nIrrep, Symmetry_Info_Get
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: nAtoms_All
integer(kind=iwp) :: Active = 0, iAll_Atom, iChAtom, iCoSet(0:7), iGen(3), iUnique_Atom, nAtoms, nCoSet, nGen
real(kind=wp), allocatable :: Coord(:,:)
integer(kind=iwp), external :: iChxyz

call Get_iScalar('Unique atoms',nAtoms)
call mma_allocate(Coord,3,nAtoms,label='Coord')
call Get_dArray('Unique Coordinates',Coord,3*nAtoms)

!write(u6,*) 'Enter Get_nAtoms_All'
!                                                                      *
!***********************************************************************
!                                                                      *
if (Active == 0) then
  call Symmetry_Info_Get()
  Active = 1
end if
!write(u6,*) 'Get_nAtoms_All: nIrrep',nIrrep
!write(u6,*) 'Get_nAtoms_All: iOper',(iOper(i),i=0,nIrrep-1)
!                                                                      *
!***********************************************************************
!                                                                      *
nGen = 0
if (nIrrep == 2) nGen = 1
if (nIrrep == 4) nGen = 2
if (nIrrep == 8) nGen = 3
if (nGen >= 1) iGen(1) = iOper(1)
if (nGen >= 2) iGen(2) = iOper(2)
if (nGen == 3) iGen(3) = iOper(4)
!write(u6,*) 'nGen=',nGen
!write(u6,*) 'iGen=',iGen
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute total number of centers.

iAll_Atom = 0
do iUnique_Atom=1,nAtoms
  !write(u6,*) 'iUnique_Atom=',iUnique_Atom

  iChAtom = iChxyz(Coord(:,iUnique_Atom),iGen,nGen)
  !write(u6,*) 'iChAtom=',iChAtom
  call CoSet(iCoSet,nCoSet,iChAtom)
  !write(u6,*) 'nCoSet=',nCoSet
  !write(u6,*) 'iCoSet=',(iCoSet(i),i=0,nCoset-1)

  iAll_Atom = iAll_Atom+nCoSet

end do

nAtoms_all = iAll_Atom
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Coord)

!write(u6,*) 'nAtoms_All=',nAtoms_All
!write(u6,*) 'Exit Get_nAtoms_All'
return

end subroutine Get_nAtoms_All

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1988, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE PAMTMT(X,T,WORK,NORB)
*
* GENERATE PER AKE'S T MATRIX FROM AN
* ORBITAL ROTATION MATRIX X
*
* T IS OBTAINED AS A STRICTLY LOWER TRIANGULAR
* MATRIX TL AND AN UPPER TRIANGULAR MATRIX TU
*
*         TL = 1 - L
*         TU = U ** -1
*
* WHERE L AND U ARISES FROM A LU DECOMPOSITION OF
* X :
*         X = L * U
* WITH L BEING A LOWER TRIANGULAR MATRIX WITH UNIT ON THE
* DIAGONAL AND U IS AN UPPER TRIANGULAR MATRIX
*
* JEPPE OLSEN OCTOBER 1988
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(NORB,NORB),T(NORB,NORB)
      DIMENSION WORK(*)
* DIMENSION OF WORK : NORB ** 2 + NORB*(NORB+1) / 2
*
      NTEST = 00
      IF(NTEST.GE.2) THEN
        WRITE(6,*) ' Wellcome to PAMTMT '
        WRITE(6,*) ' =================='
        WRITE(6,*)
      END IF
*. Allocate local memory
      KLFREE = 1
C     KLL = KFLREE
      KLL = KLFREE
      KLFREE = KLL + NORB*(NORB+1)/2
      KLU = KLFREE
      KLFREE = KLU + NORB ** 2
*.LU factorize X
      CALL LULU(X,WORK(KLL),WORK(KLU),NORB)
*.Expand U to full matrix
      CALL SETVEC(T,0.0D0,NORB ** 2 )
      DO 10 I = 1,NORB
      DO 11 J = I,NORB
        T(I,J) = WORK(KLU-1+J*(J-1)/2+I)
   11 CONTINUE
   10 CONTINUE
      IF ( NTEST .GE. 100 ) THEN
        WRITE(6,*) ' MATRIX TO BE INVERTED '
        CALL WRTMAT(T,NORB,NORB,NORB,NORB)
      END IF
*.Invert U
      CALL INVMAT(T,WORK(KLU),NORB,NORB,ISING)
      IF ( NTEST .GE. 100 ) THEN
        WRITE(6,*) ' INVERTED MATRIX '
        CALL WRTMAT(T,NORB,NORB,NORB,NORB)
      END IF
*.Subtract L
      DO 20 I = 1, NORB
      DO 21 J = 1,I-1
       T(I,J)= - WORK(KLL-1+I*(I-1)/2+J)
   21 CONTINUE
   20 CONTINUE
*
      IF( NTEST .GE. 2 ) THEN
        WRITE(6,*) ' INPUT X MATRIX '
        CALL WRTMAT(X,NORB,NORB,NORB,NORB)
        WRITE(6,*) ' T MATRIX '
        CALL WRTMAT(T,NORB,NORB,NORB,NORB)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Set_iOff(nSym,nA,nB,jStart,iOff)
      Implicit Real*8(a-h,o-z)
      Integer nSym, jStart, nA(nSym), nB(nSym), iOff(nSym)

      iOff(1)=jStart
      Do i=2,nSym
         iOff(i)=iOff(i-1)+nA(i-1)*nB(i-1)
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine DIN(Dens)

use Index_Functions, only: nTri_Elem
use Basis_Info, only: nBas
use pso_stuff, only: CMO, nDens
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Dens(nDens)
#include "etwas.fh"
integer(kind=iwp) :: iBas, iIrr, ip, ip1, ip2, ipD, nTemp2
real(kind=wp), allocatable :: Temp2(:)

!                                                                      *
!***********************************************************************
!                                                                      *
nTemp2 = 0
do iIrr=0,nIrrep-1
  nTemp2 = max(nTemp2,nBas(iIrr))
end do

call mma_allocate(Temp2,nTemp2**2,Label='Temp2')

ip = 1
ipD = 0
do iIrr=0,nIrrep-1

  if (nBas(iIrr) == 0) cycle

  call DGEMM_('N','T',nBas(iIrr),nBas(iIrr),nIsh(iIrr),One,CMO(ip,1),nBas(iIrr),CMO(ip,1),nBas(iIrr),Zero,Temp2,nBas(iIrr))
  ip1 = 0
  ip2 = ipD
  do iBas=1,nBas(iIrr)
    Dens(ip2+1:ip2+iBas-1) = Four*Temp2(ip1+1:ip1+iBas-1)
    Dens(ip2+iBas) = Two*Temp2(ip1+iBas)
    ip1 = ip1+nBas(iIrr)
    ip2 = ip2+iBas
  end do
  ip = ip+nBas(iIrr)**2
  ipD = ipD+nTri_Elem(nBas(iIrr))

end do

call mma_deallocate(Temp2)

return

end subroutine DIN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RPA_PPInp()
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Input postprocessing.
C
      Implicit None
#include "rpa_config.fh"
#include "rpa_data.fh"
#include "WrkSpc.fh"

      Character*9 SecNam
      Parameter (SecNam='RPA_PPInp')

      ! set RPAModel
      If (dRPA) Then
         If (SOSEX) Then
            RPAModel='SOSX@'//Reference(1:3)
         Else
            RPAModel='dRPA@'//Reference(1:3)
         End If
      Else
         ! this should never happen
         Call RPA_Warn(3,SecNam//': internal error [RPAModel]')
         RPAModel='None@Non'
      End If

      ! freeze orbitals
      Call RPA_Freezer()

      ! print config after input processing
      Call RPA_PrInp()

      End
************************************************************************
      Subroutine RPA_PrInp()
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Print RPA configuration after input processing.
C
      Implicit None
#include "rpa_config.fh"
#include "rpa_data.fh"
#include "WrkSpc.fh"

      Character*9 SecNam
      Parameter (SecNam='RPA_PrInp')
      Integer lPaper
      Parameter (lPaper=132)

      Integer  RPA_iUHF, RPA_LENIN8
      External RPA_iUHF, RPA_LENIN8

      Character*3 lIrrep(8)
      Character*7 spin(2)
      Character*8 Fmt1, Fmt2
      Character*13 orbitals
      Character*120 Line,BlLine,StLine

      Integer iUHF
      Integer lLine
      Integer nLine
      Integer l_orbitals
      Integer i, j, k
      Integer left
      Integer iSym
      Integer LENIN8
      Integer nB
      Integer ip_Name, l_Name
      Integer iCount

      Real*8 Dummy(1)

      Integer p, q
      Real*8 epsi, epsa
      epsi(p,q)=Work(ip_OccEn(q)-1+p)
      epsa(p,q)=Work(ip_VirEn(q)-1+p)

      ! set restricted(1)/unrestricted(2)
      iUHF=RPA_iUHF()

      ! set labels
      If (iUHF.eq.1) Then
         orbitals='orbitals'
         l_orbitals=8
         spin(1)=' '
         spin(2)=' '
      Else If (iUHF.eq.2) Then
         orbitals='spin-orbitals'
         l_orbitals=13
         spin(1)='(alpha)'
         spin(2)='(beta)'
      Else
         Write(6,'(A,I6)') 'iUHF=',iUHF
         Call RPA_Warn(3,SecNam//': iUHF error')
         orbitals=' '
         l_orbitals=1
         spin(1)=' '
         spin(2)=' '
      End If

      ! set irrep names
      Call Get_cArray('Irreps',lIrrep,24)
      Do iSym=1,nSym
         Call RightAd(lIrrep(iSym))
      End Do

      ! init blank line and "star" line
      lLine=len(Line)
      Do i=1,lLine
        BlLine(i:i)=' '
        StLine(i:i)='*'
      End Do
      left=(lPaper-lLine)/2
      Write(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'

      ! print title from input
      If (nTitle.gt.0) Then
         Write(6,*)
         nLine=nTitle+5
         Do i=1,nLine
           Line=BlLine
           If (i.eq.1 .or. i.eq.nLine) Line=StLine
           If (i.eq.3) Line='Title:'
           If (i.ge.4 .and. i.le.nLine-2) Line=Title(i-3)
           Call Center(Line)
           Write(6,Fmt1) '*'//Line//'*'
         End Do
         Write(6,*)
      End If

      ! print coordinates of the molecule
      If (iPrint.ge.2) Then
         Call PrCoor()
      End If

      ! print orbital info
      If (iPrint.ge.2) Then
         Write(6,*)
         Write(6,Fmt2//'A,2(1X,A))') Reference,'reference',orbitals
         j=len(Reference)+11+l_orbitals
         Write(6,Fmt2//'80A1)') ('-',i=1,j)
         If (Reference(2:3).eq.'KS') Then
            Write(6,Fmt2//'A,A)') 'DFT functional: ',DFTFunctional
         End If
         Write(6,*)
         Write(6,Fmt2//'A,T47,8I4)') 'Symmetry species',
     *                               (iSym,iSym=1,nSym)
         Write(6,Fmt2//'A,T47,8(1X,A))') '                ',
     *                               (lIrrep(iSym),iSym=1,nSym)
         Write(6,Fmt2//'A,T47,8I4)') 'Number of basis functions',
     *                               (nBas(iSym),iSym=1,nSym)
         Write(6,Fmt2//'A,T47,8I4)') 'Number of orbitals',
     *                               (nOrb(iSym),iSym=1,nSym)
         Do k=1,iUHF
            Write(6,Fmt2//'A,2(1X,A),T47,8I4)')
     *      'Frozen occupied',orbitals,spin(k),
     *      (nFro(iSym,k),iSym=1,nSym)
         End Do
         Do k=1,iUHF
            Write(6,Fmt2//'A,2(1X,A),T47,8I4)')
     *      'Active occupied',orbitals,spin(k),
     *      (nOcc(iSym,k),iSym=1,nSym)
         End Do
         Do k=1,iUHF
            Write(6,Fmt2//'A,2(1X,A),T47,8I4)')
     *      'Active virtual',orbitals,spin(k),
     *      (nVir(iSym,k),iSym=1,nSym)
         End Do
         Do k=1,iUHF
            Write(6,Fmt2//'A,2(1X,A),T47,8I4)')
     *      'Deleted virtual',orbitals,spin(k),
     *      (nDel(iSym,k),iSym=1,nSym)
         End Do
      End If

      ! print orbital energies
      If (iPrint.ge.2) Then
         iCount=0
         Do k=1,iUHF
            Do iSym=1,nSym
               iCount=iCount+nFro(iSym,k)
            End Do
         End Do
         If (iCount.gt.0) Then
            Write(6,*)
            Write(6,*)
            Write(6,Fmt2//'A,1X,A,T47)')
     *      'Energies of the frozen occupied',orbitals
            Do k=1,iUHF
               i=0
               Do iSym=1,nSym
                  If (nFro(iSym,k).gt.0) then
                     Write(6,*)
                     Write(6,Fmt2//'A,I2,2(1X,A),(T40,5F14.6))')
     *               'symmetry species',iSym,lIrrep(iSym),spin(k),
     *               (epsi(i+j,k),j=1,nFro(iSym,k))
                     i=i+nFro(iSym,k)+nOcc(iSym,k)
                  End If
               End Do
            End Do
         End If
         Write(6,*)
         Write(6,*)
         Write(6,Fmt2//'A,1X,A,T47)')
     *   'Energies of the active occupied',orbitals
         Do k=1,iUHF
            i=0
            Do iSym=1,nSym
               If (nOcc(iSym,k).gt.0) then
                  Write(6,*)
                  Write(6,Fmt2//'A,I2,2(1X,A),(T40,5F14.6))')
     *            'symmetry species',iSym,lIrrep(iSym),spin(k),
     *            (epsi(i+nFro(iSym,k)+j,k),j=1,nOcc(iSym,k))
                  i=i+nFro(iSym,k)+nOcc(iSym,k)
               End If
            End Do
         End Do
         Write(6,*)
         Write(6,*)
         Write(6,Fmt2//'A,1X,A,T47)')
     *   'Energies of the active virtual',orbitals
         Do k=1,iUHF
            i=0
            Do iSym=1,nSym
               If (nVir(iSym,k).gt.0 ) then
                  Write(6,*)
                  Write(6,Fmt2//'A,I2,2(1X,A),(T40,5F14.6))')
     *            'symmetry species',iSym,lIrrep(iSym),spin(k),
     *            (epsa(i+j,k),j=1,nVir(iSym,k))
                  i=i+nVir(iSym,k)+nDel(iSym,k)
               End If
            End Do
         End Do
         iCount=0
         Do k=1,iUHF
            Do iSym=1,nSym
               iCount=iCount+nDel(iSym,k)
            End Do
         End Do
         If (iCount.gt.0) Then
            Write(6,*)
            Write(6,*)
            Write(6,Fmt2//'A,1X,A,T47)')
     *      'Energies of the deleted virtual',orbitals
            Do k=1,iUHF
               i=0
               Do iSym=1,nSym
                  If (nDel(iSym,k).gt.0 ) then
                     Write(6,*)
                     Write(6,Fmt2//'A,I2,2(1X,A),(T40,5F14.6))')
     *               'symmetry species',iSym,lIrrep(iSym),spin(k),
     *               (epsa(i+nVir(iSym,k)+j,k),j=1,nDel(iSym,k))
                     i=i+nVir(iSym,k)+nDel(iSym,k)
                  End If
               End Do
            End Do
         End If
      End If

      ! print orbitals
      If (iPrint.ge.2) Then
         LENIN8=RPA_LENIN8()
         nB=nBas(1)
         Do iSym=2,nSym
            nB=nB+nBas(iSym)
         End Do
         l_Name=LENIN8*nB
         Call GetMem('Name','Allo','Char',ip_Name,l_Name)
         Call Get_cArray('Unique Basis Names',cWork(ip_Name),LENIN8*nB)
         Do k=1,iUHF
            Call PriMO(Reference//' '//orbitals//' '//spin(k),
     *                 .false.,.true.,-9.9d9,9.9d9,
     *                 nSym,nBas,nOrb,cWork(ip_Name),
     *                 Work(ip_EMO(k)),Dummy,Work(ip_CMO(k)),-1)
         End Do
         Call GetMem('Name','Free','Char',ip_Name,l_Name)
      End If

      ! flush output buffer
      Call xFlush(6)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
*               1995,1996, Pavel Neogrady                              *
************************************************************************
       SUBROUTINE REORG(run_triples,IRETURN)
       IMPLICIT REAL*8 (A-H,O-Z)
       Logical run_triples
#include "reorg.fh"
#include "WrkSpc.fh"
       fullprint=0
       If (iPrintLevel(-1).LE.0) fullprint=-1
       Call GetMem('FIRAS','ALLO','REAL',ipFIRAS,mbas*mbas)
       Call GetMem('FI',   'ALLO','REAL',ipFI,mbas*mbas)
       call REORG_(Work(ipFIRAS),Work(ipFI),run_triples,IRETURN)
       Call GetMem('FIRAS','FREE','REAL',ipFIRAS,mbas*mbas)
       Call GetMem('FI',   'FREE','REAL',ipFI,mbas*mbas)
       return
       end
       SUBROUTINE REORG_(FIRAS,FI,run_triples,IRETURN)

*----------------------------------------------------------------------*
*     1994  PER-AAKE MALMQUIST                                         *
*     DEPARTMENT OF THEORETICAL CHEMISTRY                              *
*     UNIVERSITY OF LUND, SWEDEN                                       *
*                                                                      *
* modified by P.N. (Dec. 1995)                                         *
* all allocation memory routines removed by P.N. (8.03.1996)           *
*----------------------------------------------------------------------*

C
C FILES USED:
C     TRAINT    2 electron MO INTEGRALS
C     JOBIPH    THE JOB-INTERFACE FILE AS PRODUCED BY THE RASSCF
C               PROGRAM
C INPUT
C     AT PRESENT:  THE INPUT FILE IS SEARCHED FOR THE STRING
C     '&REORG '. Input is only TITLE
C
C LIMITATIONS
c     Like in CASPT2
C
************************************************************************
       IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"
#include "ccsort.fh"
#include "reorg.fh"
#include "intgrl.fh"
#include "WrkSpc.fh"

       real*8 FIRAS(1:mbas*mbas)
       real*8 EPSRAS(1:mbas)
       real*8 FI(1:mbas*mbas)
       real*8 EPS(1:mbas)
       real*8 ene(mxRoot,mxIter)
c       real*8 Ene(25,50)
c
       INTEGER NOIPSB(106)
       Logical run_triples,run_sort
c
c
C PRINT THE PROGRAM HEADER
       call ccsort_helloPN

c*    READ AND ECHO INPUT DATA, READ JOBIPH, PRINT INPUT DATA,
       CALL RDINPPN(run_triples,run_sort)
       If (fullprint.GE.0) CALL PRINPPN
       CALL CHKINP_CCSORT
c
       if (run_sort) then
c
c*    read FI from JOBIPH
       ntot3=0
       ntot2=0
       do i=1,nsym
       ntot3=ntot3+(norb(i)*(norb(i)+1))/2
       ntot2=ntot2+norb(i)
       end do
c
c*    pick the total energy from the JOBIPH file
c
       iad15=iadr15(6)
       lad15=mxroot*mxiter
       Call dDaFile(JOBIPH,2,Ene,lad15,iad15)
       EScf=0.0d0
       i=1
c
c*    take the last non-zero energy stored
c
       Do While ((Ene(LROOT,i).ne.0.0D0) .and. (i.le.mxIter))
         Escf = Ene(LROOT,i)
         i=i+1
       End Do
       If (fullprint.GE.0) then
          write(6,*)
          write(6,'(6X,A,F16.8)') 'SCF energy:',Escf
          write(6,'(6X,A)')       '-----------'
          write(6,*)
       EndIf
c
c*    get fi from previous RASSCF
c
       iad15=iadr15(10)
       call ddafile(JOBIPH,2,firas(1),ntot3,iad15)
c
c*    get eps from previous RASSCF
c
       iad15=iadr15(11)
       call ddafile(JOBIPH,2,epsras(1),ntot2,iad15)
c
c*    reduce fi,eps and update n's
       call mod1 (nsym,nfro,nish,nash,nssh,ndel,norb,nfror,ndelr,
     &            firas,fi,epsras,eps)
c
c*    def diagonal Fok for closed shell
c
       if (clopkey.eq.2) then
         call mod2 (nsym,nish,nash,nssh,norb,fi,eps)
       end if
c
c*    define noa,nob,nva,nvb
c
       do i=1,nsym
         noa(i)=nish(i)+nash(i)
         nob(i)=nish(i)
         nva(i)=nssh(i)
         nvb(i)=nssh(i)+nash(i)
       end do
c
       if (nsym.lt.8) then
         do i=1+nsym,8
           noa(i)=0
           nob(i)=0
           nva(i)=0
           nvb(i)=0
         end do
       end if
c
       if (fullprint.gt.1) then
         write(6,*)
         write(6,'(6X,A)') 'Diagonal Fock matrix elements and '//
     &                      'orbital energies:'
         write(6,'(6X,A)') '----------------------------------'//
     &                      '-----------------'
         write(6,*)
         write(6,'(6X,A)') '----------------------------------------'
         write(6,'(6X,A)') '   i      F(i,i)           eps(i)       '
         write(6,'(6X,A)') '----------------------------------------'
         ij=0
         do i=1,norb(1)
           do j=1,i
             ij=ij+1
             if (i.eq.j) then
               write(6,'(6X,I4,2F18.10)') i,fi(ij),eps(i)
             end if
           end do
         end do
         write(6,'(6X,A)') '----------------------------------------'
         write(6,*)
       end if
c
c*    prepair adress (stupid)
c
CFUE
CFUE   The unit number of the transformed two electron integrals
CFUE   must be 40, 50, 60, 70, 80 or 90. Any other number will
CFUE   not be compatible with the I/O driver in MOLCAS.
CFUE
       LUINTM=40
cJR       call DANAME (LUINTM,'TRAINT')
       call DANAME_MF (LUINTM,'TRAINT')
       call mkadress (NOIPSB)
c
c*    open TRAINT and call action
c
       Call GetMem('FOKA','ALLO','REAL',ipFOKA,(mbas**2+mbas)/2)
       Call GetMem('FOKB','ALLO','REAL',ipFOKB,(mbas**2+mbas)/2)

       call action (Work(ipFOKA),Work(ipFOKB),fi,eps)
       Call GetMem('FOKA','FREE','REAL',ipFOKA,(mbas**2+mbas)/2)
       Call GetMem('FOKB','FREE','REAL',ipFOKB,(mbas**2+mbas)/2)
c
c      close files
c
       call daclos(luintm)
       call daclos(jobiph)
c
       else
c      case, when SORT was skipped
       write (6,*) ' SORT part was skipped'
       write (6,*) ' Input parameters are from last actual run of SORT'
       end if
c
       ireturn=0
       return
       END
c
c     ---------------------------
c
       subroutine mod1 (nsym,nfro,nish,nash,nssh,ndel,norb,nfror,ndelr,
     & firas,fi,epsras,eps)
c
c     this routine do:
c     1) reduce firas, epsras if nfror>nfro, ndelr>ndel
c     2) redefine nfro,nish,nash,nssh,ndel,norb to proper ones
c
       integer nsym
       integer nfro(1:8)
       integer ndel(1:8)
       integer nish(1:8)
       integer nash(1:8)
       integer nssh(1:8)
       integer norb(1:8)
       integer nfror(1:8)
       integer ndelr(1:8)
       real*8 fi(*)
       real*8 firas(*)
       real*8 eps(*)
       real*8 epsras(*)
c
c     help variables
c
       integer p,q,pqras,pqnew,pras,pnew,isym
       integer ndf,ndd,nup,nlow

c
c1    reduce fi
c
       pqras=0
       pqnew=0
       do 100 isym=1,nsym
c
       ndf=nfror(isym)-nfro(isym)
       ndd=ndelr(isym)-ndel(isym)
       nlow=ndf+1
       nup=norb(isym)-ndd
c
       do 50 p=1,norb(isym)
       do 51 q=1,p
       pqras=pqras+1
c
       if ((p.ge.nlow).and.(p.le.nup)) then
       if ((q.ge.nlow).and.(q.le.nup)) then
       pqnew=pqnew+1
       fi(pqnew)=firas(pqras)
       end if
       end if
c
 51     continue
 50     continue
c
 100    continue
c
c2    reduce eps
c
       pras=0
       pnew=0
       do 200 isym=1,nsym
c
       ndf=nfror(isym)-nfro(isym)
       ndd=ndelr(isym)-ndel(isym)
       nlow=ndf+1
       nup=norb(isym)-ndd
c
       do 150 p=1,norb(isym)
       pras=pras+1
c
       if ((p.ge.nlow).and.(p.le.nup)) then
       pnew=pnew+1
       eps(pnew)=epsras(pras)
       end if
c
 150    continue
c
 200    continue
c
c3    define new nfro,nish,nash,nssh,ndel,norb
c
       do 300 isym=1,nsym
       nash(isym)=nash(isym)
       nish(isym)=nish(isym)-nfror(isym)+nfro(isym)
       nssh(isym)=nssh(isym)-ndelr(isym)+ndel(isym)
       norb(isym)=norb(isym)-nfror(isym)+nfro(isym)-ndelr(isym)
     &           +ndel(isym)
       nfro(isym)=nfror(isym)
 300    continue
c
c
       return
       end
c
c     ---------------------------
c
       subroutine mod2 (nsym,nish,nash,nssh,norb,fi,eps)
c
c     this routine define fi(p,q) = delta(p,q).eps(p)
c     and redefine nish=nish+nash, nash=0
c
c     this is suitable for closed shell case
c
       integer nsym
       integer nish(1:8)
       integer nash(1:8)
       integer nssh(1:8)
       integer norb(1:8)
       real*8 fi(*)
       real*8 eps(*)
c
c     help variables
c
       integer p,q,isym,pq,padd
c
c1    redefine foki
c
       pq=0
       padd=0
       do 200 isym=1,nsym
c
       do 100 p=1,norb(isym)
       do 101 q=1,p
       pq=pq+1
       if (p.eq.q) then
       fi(pq)=eps(padd+p)
       else
       fi(pq)=0.0d0
       end if
 101    continue
 100    continue
c
       padd=padd+norb(isym)
 200    continue
c
c2    redefine n's
c
       do 300 isym=1,nsym
       nish(isym)=nish(isym)+nash(isym)
       nash(isym)=0
 300    continue
c
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(nssh)
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_INT1_1_DBG2_CMP(XINT1,XINT2,NI,NJ,ERRMIN,IMN,JMN,ERRMAX,IMX,JMX,ITST,IERR,THR,PRTERR,LUPRI)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NI, NJ, LUPRI
real(kind=wp), intent(in) :: XINT1(NI,NJ), XINT2(NJ,NI), THR
real(kind=wp), intent(out) :: ERRMIN, ERRMAX
integer(kind=iwp), intent(out) :: IMN, JMN, IMX, JMX
integer(kind=iwp), intent(inout) :: ITST, IERR
logical(kind=iwp), intent(in) :: PRTERR
integer(kind=iwp) :: I, J, JERR
real(kind=wp) :: DIFF

if ((NI < 1) .or. (NJ < 1)) then
  ERRMAX = Zero
  ERRMIN = Zero
  IMN = 0
  JMN = 0
  IMX = 0
  JMX = 0
  return
end if

ERRMAX = XINT1(1,1)-XINT2(1,1)
ERRMIN = XINT1(1,1)-XINT2(1,1)
IMN = 1
JMN = 1
IMX = 1
JMX = 1

JERR = 0
do J=1,NJ
  do I=1,NI
    ITST = ITST+1
    DIFF = XINT1(I,J)-XINT2(J,I)
    if (abs(DIFF) > THR) then
      JERR = JERR+1
      if (PRTERR) write(LUPRI,*) '      Error: ',I,J,DIFF
    end if
    if (DIFF < ERRMIN) then
      ERRMIN = DIFF
      IMN = I
      JMN = J
    end if
    if (DIFF > ERRMAX) then
      ERRMAX = DIFF
      IMX = I
      JMX = J
    end if
  end do
end do
IERR = IERR+JERR

if ((JERR /= 0) .and. (NI == NJ)) then
  JERR = 0
  write(LUPRI,*) '         Checking for identity...'
  do J=1,NJ
    do I=1,NI
      DIFF = XINT1(I,J)-XINT2(I,J)
      if (abs(DIFF) > 1.0e-14_wp) JERR = JERR+1
    end do
  end do
  if (JERR /= 0) then
    write(LUPRI,*) '      ...not identical!!'
  else
    write(LUPRI,*) '      ...identical!!'
  end if
end if

end subroutine CHO_MCA_INT1_1_DBG2_CMP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRANSM(V1,V2,ID1,ID2)
      implicit none
      integer ID1,ID2, I
      REAL*8 V1,V2,ONE
      PARAMETER (ONE=1.D0)
      DIMENSION V1(ID1,ID2),V2(ID2,ID1)
C usual transposition
      IF(ID1.EQ.0.OR.ID2.EQ.0)RETURN
      DO  I=1,ID1
         CALL DCOPY_(ID2,V1(I,1),ID1,V2(1,I),1)
      ENDDO
      RETURN
C
      ENTRY TRANSM_A(V1,V2,ID1,ID2)
C transposition of the matrix + add to the target matrix
      IF(ID1.EQ.0.OR.ID2.EQ.0)RETURN
      DO  I=1,ID1
         CALL DAXPY_(ID2,ONE,V1(I,1),ID1,V2(1,I),1)
      ENDDO
      RETURN
C
      ENTRY TRANSM_D(V1,V2,ID1,ID2)
C transposition with splitting to "double spacing"
      IF(ID1.EQ.0.OR.ID2.EQ.0)RETURN
      DO  I=1,ID1
         CALL DCOPY_(ID2/2,V1(I,1),ID1,V2(1,I),2)
      ENDDO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************

subroutine Chk_vec_UHF(FName,Lu,isUHF)
! routine returns isUHF based on information in INPORB

use InpOrbFmt, only: Magic, mxVer
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: FName
integer(kind=iwp), intent(inout) :: Lu
integer(kind=iwp), intent(out) :: isUHF
integer(kind=iwp) :: istatus, iVer, jVer
character(len=80) :: LINE
logical(kind=iwp) :: Exists
character(len=*), parameter :: Location = 'Chk_vec_UHF'

Line = 'not defined yet'

call OpnFl(FName,Lu,Exists)
if (.not. Exists) then
  write(u6,*) 'RdVec: File ',trim(FName),' not found!'
  call Abend()
end if
rewind(LU)
! Check version!
read(LU,'(A80)',iostat=istatus) Line
if (istatus /= 0) call Error()
iVer = 0
do jVer=1,mxVer
  if (Magic(jVer) == Line(1:len(Magic(jVer)))) iVer = jVer
end do

if (iVer == 0) then
  call SysWarnMsg(Location,'INPORB file in old format',' ')
  call SysPutsEnd()
  isUHF = 0
  close(Lu)
  return
end if
do
  read(LU,'(A80)',iostat=istatus) Line
  if (istatus /= 0) call Error()
  if (Line(1:5) == '#INFO') exit
end do
! Now Do the real job
read(Lu,'(a)',iostat=istatus) Line
if (istatus /= 0) call Error()
read(Lu,*,iostat=istatus) isUHF
if (istatus /= 0) call Error()
close(Lu)

return

contains

subroutine Error()
  call SysWarnFileMsg(Location,FName,'Error during reading INPORB\n',Line)
  call Abend()
end subroutine Error

end subroutine Chk_vec_UHF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               2001, Hans-Joachim Werner                              *
!***********************************************************************

subroutine Drvpot(CCoor,opnuc,ncmp,ptchrg,ngrid,iaddpot)
!***********************************************************************
!                                                                      *
! Object: driver for computation of one-electron property matrices     *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January '91                                              *
!                                                                      *
!     Modified for Properties only by HJW Aug 2001                     *
!     Restricted to POT: Ignacio Fdez. Galvan, March 2019              *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Basis_Info, only: dbsc, nBas, nCnttp
use Center_Info, only: dc
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use Integral_interfaces, only: int_kernel, int_mem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ncmp, ngrid, iaddpot
real(kind=wp), intent(in) :: CCoor(3,ngrid)
real(kind=wp), intent(_OUT_) :: opnuc(*)
real(kind=wp), intent(inout) :: ptchrg(*)
integer(kind=iwp) :: i, iIrrep, jCnt, jCnttp, jxyz, mCnt, nc, nComp, ndc, nDiff, nOrdOp, nSym, ntdg
real(kind=wp) :: rHrmt
logical(kind=iwp) :: Do_ESPF
character(len=8) :: Label
integer(kind=iwp), allocatable :: ip(:), kOper(:), lOper(:)
real(kind=wp), allocatable :: Centr(:,:), Dens(:), Nuc(:)
procedure(int_kernel) :: PotInt
procedure(int_mem) :: NAMem

!                                                                      *
!***********************************************************************
!                                                                      *
nDiff = 0
call IniSewM('mltpl',nDiff)

call Set_Basis_Mode('Valence')
call Setup_iSD()
call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
ntdg = 0
do iIrrep=0,nIrrep-1
  ntdg = ntdg+nTri_Elem(nBas(iIrrep))
end do
call DecideOnESPF(Do_ESPF)

call mma_allocate(Centr,3,S%mCentr)
ndc = 0
nc = 1
do jCnttp=1,nCnttp
  mCnt = dbsc(jCnttp)%nCntr
  if (dbsc(jCnttp)%Aux) mCnt = 0
  do jCnt=1,mCnt
    ndc = ndc+1
    do i=0,nIrrep/dc(ndc)%nStab-1
      call OA(dc(ndc)%iCoSet(i,0),dbsc(jCnttp)%Coor(1:3,jCnt),Centr(1:3,nc))
      nc = nc+1
    end do
    jxyz = jxyz+3
  end do
end do
nc = nc-1

nComp = 1
nOrdOp = 0
call mma_allocate(ip,nComp,label='ip')
call mma_allocate(lOper,nComp,label='lOper')
call mma_allocate(kOper,nComp,label='kOper')
Label = 'Pot '
if ((iaddpot <= 0) .and. (.not. Do_ESPF)) then
  call mma_allocate(Nuc,ngrid,label='Nuc')
  call Pot_nuc(CCoor,Nuc,ngrid)
else
  call mma_allocate(Nuc,ncmp,label='Nuc')
  Nuc(:) = Zero
end if
if (iaddpot < 0) then

  call mma_allocate(Dens,ntdg,Label='Dens')
  if (iaddpot == -1) then
    call Get_D1ao_Var(Dens,ntdg)
  else
    call Get_dArray_chk('D1ao',Dens,ntdg)
  end if
  call Drv1_Pot(Dens,CCoor,ptchrg,ngrid,1,0)
  call mma_deallocate(Dens)

  if (.not. Do_ESPF) then
    ptchrg(1:ngrid) = ptchrg(1:ngrid)+Nuc
    opnuc(1:ngrid) = Nuc
  end if
else
  lOper(1) = 2**nirrep-1
  kOper(1) = 0
  call OneEl(PotInt,NAMem,Label,ip,lOper,ncmp,CCoor,nOrdOp,Nuc,rHrmt,kOper,ptchrg,ngrid,iaddpot)
  if ((iaddpot == 0) .and. (.not. Do_ESPF)) opnuc(1) = Nuc(1)
end if
call mma_deallocate(ip)
call mma_deallocate(lOper)
call mma_deallocate(kOper)
call mma_deallocate(Nuc)

call mma_deallocate(Centr)
call Free_iSD()

return

end subroutine Drvpot

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DERTG3(DOG3,LSYM1,LSYM2,NCONF,NASHT,CI1,CI2,OVL,DTG1,DTG2,NTG3,DTG3,CLAG1,CLAG2)
! Procedure for computing 1-body, 2-body, and 3-body transition
! density elements with active indices only.

! In: Wave functions CI1, with symmetry LSYM1, and CI2, with
!  symmetry LSYM2.
!
! Out: Transition density matrices, denoted here TG1, TG2 and TG3.
! Storage: TG1 and TG2 are simple two- and four-index arrays, and
! includes also such zeroes that are implied by symmetry.
! But TG3 is quite large, and while it is stored with zeroes, it
! is made more compact by the following addressing:

! <Psi1|E_tuvxyz|Psi2> is stored in TG3(ITG3) where
!    ITG3= nTri3_Elem(i-1)) + nTri_Elem(j-1) + k
!     i  = max(tu,vx,yz)
!     j  = mid(tu,vx,yz)
!     k  = min(tu,vx,yz)
! tu stands for the pair index tu= t + NASHT*(u-1), etc., and t is
! the usual active orbital number, when they are enumerated across
! all the symmetries (The ''absolute'' active index).

use Index_Functions, only: nTri_Elem, nTri3_Elem
use Symmetry_Info, only: Mul
use sguga, only: CIS, EXS, L2ACT, SGS
use caspt2_module, only: IASYM, ISCF, MXCI, NACTEL
use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: DOG3
integer(kind=iwp), intent(in) :: LSYM1, LSYM2, NCONF, NASHT, NTG3
real(kind=wp), intent(in) :: CI1(NCONF), CI2(NCONF), OVL
real(kind=wp), intent(inout) :: DTG1(NASHT,NASHT), DTG2(NASHT,NASHT,NASHT,NASHT), DTG3(NTG3), CLAG1(NCONF), CLAG2(NCONF)
integer(kind=iwp) :: ibuf, IL, IM, IP, IP1, IP1END, IP1STA, IP2, IP3, IP3END, IP3STA, IS1, IS2, IS3, ISSG1, ISSG2, ISTAU, IT, ITS, &
                     ITU, IU, IUS, IV, IVS, IVX, IX, IXS, IY, IYS, IYZ, IZ, IZS, JL, JM, JTU, JTUVXYZ, JVX, JYZ, LFROM, LFROMD, &
                     LSGM1, LSGM2, LTAU, LTO, NCI1, nLev, NTAU, NTG3WRK, NTUBUF, NVECS, NYZBUF
real(kind=wp) :: VAL
integer(kind=iwp), allocatable :: P2LEV(:,:)
real(kind=wp), allocatable :: BUF1(:), DTU(:,:), DYZ(:,:), TG3WRK(:)

nLev = SGS%nLev

! Put in zeroes. Recognize special cases:
!OVL = One
if (NASHT == 0) return
if (NACTEL == 0) return
!if (LSYM1 /= LSYM2) OVL = Zero
!TG1(:,:) = Zero
!TG2(:,:,:,:) = Zero
!TG3(1:NTG3) = Zero

if (ISCF /= 0) then
  ! -Special code for the closed-shell or hi-spin cases:
  ! ISCF=1 for closed-shell, =2 for hispin
  write(u6,*) 'Here is the special case'
  write(u6,*) 'not yet'
  call abend()
end if
! Here, for regular CAS or RAS cases.

! Special pair index allows true RAS cases to be handled:
call mma_allocate(P2LEV,2,NASHT**2,Label='P2LEV')
IP = 0
! First, IL < JL pairs.
do IL=1,NLEV-1
  P2LEV(1,IP+1:IP+NLEV-IL) = IL
  P2LEV(2,IP+1:IP+NLEV-IL) = [(JL,JL=IL+1,NLEV)]
  IP = IP+NLEV-IL
end do
! Then, IL = JL pairs.
P2LEV(1,IP+1:IP+NLEV) = [(IL,IL=1,NLEV)]
P2LEV(2,IP+1:IP+NLEV) = [(IL,IL=1,NLEV)]
IP = IP+NLEV
! Last, IL > JL pairs.
do IL=2,NLEV
  P2LEV(1,IP+1:IP+IL-1) = IL
  P2LEV(2,IP+1:IP+IL-1) = [(JL,JL=1,IL-1)]
  IP = IP+IL-1
end do

! First, the 3-particle density matrix:
! <PSI1|E(T,U,V,X,Y,Z)|PSI2>  = <PSI1|E(TU)E(VX)E(YZ)|PSI2>
! -D(Y,X)*(TG2(T,U,V,Z)+D(V,U)*TG1(T,Z))
! -D(V,U)*TG2(T,X,Y,Z) C -D(Y,U)*TG2(V,X,T,Z)
if (DOG3) then
  do IP1=1,NASHT**2
    IT = L2ACT(P2LEV(1,IP1))
    IU = L2ACT(P2LEV(2,IP1))
    ITU = IT+NASHT*(IU-1)
    ITS = IASYM(IT)
    IUS = IASYM(IU)
    IS1 = Mul(Mul(ITS,IUS),LSYM1)
    do IP2=1,IP1
      IV = L2ACT(P2LEV(1,IP2))
      IX = L2ACT(P2LEV(2,IP2))
      IVX = IV+NASHT*(IX-1)
      IVS = IASYM(IV)
      IXS = IASYM(IX)
      IS2 = Mul(Mul(IVS,IXS),IS1)
      do IP3=1,IP2
        IY = L2ACT(P2LEV(1,IP3))
        IZ = L2ACT(P2LEV(2,IP3))
        IYS = IASYM(IY)
        IZS = IASYM(IZ)
        IS3 = Mul(Mul(IYS,IZS),IS2)
        if (IS3 == LSYM2) then
          IYZ = IY+NASHT*(IZ-1)
          if (ITU < IVX) then
            if (ITU >= IYZ) then
              JTU = IVX
              JVX = ITU
              JYZ = IYZ
            else if (IVX < IYZ) then
              JTU = IYZ
              JVX = IVX
              JYZ = ITU
            else
              JTU = IVX
              JVX = IYZ
              JYZ = ITU
            end if
          else
            if (ITU < IYZ) then
              JTU = IYZ
              JVX = ITU
              JYZ = IVX
            else if (IVX >= IYZ) then
              JTU = ITU
              JVX = IVX
              JYZ = IYZ
            else
              JTU = ITU
              JVX = IYZ
              JYZ = IVX
            end if
          end if
          JTUVXYZ = nTri3_Elem(JTU-1)+nTri_Elem(JVX-1)+JYZ
          VAL = DTG3(JTUVXYZ)
          if (IY == IX) then
            DTG2(IT,IU,IV,IZ) = DTG2(IT,IU,IV,IZ)-VAL
            if (IV == IU) DTG1(IT,IZ) = DTG1(IT,IZ)-VAL
          end if
          if (IV == IU) DTG2(IT,IX,IY,IZ) = DTG2(IT,IX,IY,IZ)-VAL
          if (IY == IU) DTG2(IV,IX,IT,IZ) = DTG2(IV,IX,IT,IZ)-VAL
        end if
      end do
    end do
  end do
end if

! Then, the 2-particle density matrix:
! <PSI1|E(T,U,V,X)|PSI2>  = <PSI1|E(TU)E(VX)|PSI2> - D(V,U)*TG2(T,U,V,X)
do IP1=1,NASHT**2
  IT = L2ACT(P2LEV(1,IP1))
  IU = L2ACT(P2LEV(2,IP1))
  do IP2=1,IP1
    IV = L2ACT(P2LEV(1,IP2))
    IX = L2ACT(P2LEV(2,IP2))
    if (IP1 /= IP2) then
      DTG2(IT,IU,IV,IX) = DTG2(IT,IU,IV,IX)+DTG2(IV,IX,IT,IU)
      DTG2(IV,IX,IT,IU) = Zero
    end if
    if (IV == IU) DTG1(IT,IX) = DTG1(IT,IX)-DTG2(IT,IU,IV,IX)
  end do
end do

! If now any matrix element E(t1u1)E(t2u2)..E(tnun) is arranged
! such that the pair indices are non-decreasing, then the matrix
! element can be correctly computed by performing explicit
! excitations within the RAS space.
! But we also need the 'usual' pair index in order to use the
! packed addressing.

NCI1 = CIS%NCSF(LSYM1)
! Overlap:
!if (LSYM1 == LSYM2) OVL = DDOT_(NCI1,CI1,1,CI2,1)
if (LSYM1 == LSYM2) then
  CLAG2(1:NCI1) = CLAG2(1:NCI1)+OVL*CI1(1:NCI1)
  CLAG1(1:NCI1) = CLAG1(1:NCI1)+OVL*CI2(1:NCI1)
end if
!write(u6,*) 'overlap = ',DDOT_(NCI1,CI1,1,CI2,1)
! Allocate as many vectors as possible:
! Wishful thinking:
NVECS = 2*NASHT**2+1
! But what is really available?
call mma_MaxDBLE(NTG3WRK)
NTG3WRK = NTG3WRK-3*MXCI ! for BUF1, DTU, and DYZ, allocated later
NTG3WRK = NTG3WRK/2
NTG3WRK = min(MXCI*NVECS,NTG3WRK)
NVECS = NTG3WRK/MXCI
NTG3WRK = NVECS*MXCI
! Find optimal subdivision of available vectors:
NYZBUF = nint(real(NVECS-1,kind=wp)/real(NASHT,kind=wp),kind=iwp)
NYZBUF = max(1,NYZBUF)
NTUBUF = min(NASHT**2,NVECS-1-NYZBUF)
NYZBUF = NVECS-1-NTUBUF
! Insufficient memory?
if (NTUBUF <= 0) then
  write(u6,*) ' Too little memory left for MKTG3.'
  write(u6,*) ' Need at least 6 vectors of length MXCI=',MXCI
  call ABEND()
end if
if (NTUBUF <= (NASHT**2)/5) then
  write(u6,*) ' WARNING: MKTG3 will be inefficient owing to'
  write(u6,*) ' small memory.'
end if
call mma_allocate(TG3WRK,NTG3WRK,Label='TG3WRK')
call mma_allocate(BUF1,MXCI,Label='BUF1')

call mma_allocate(DTU,MXCI,NTUBUF,Label='DTU')
call mma_allocate(DYZ,MXCI,NYZBUF,Label='DYZ')

! And divide it up:
!! LSGM1: NTUBUF vectors
!! LTAU : 1 vector
!! LSGM2: NYZBUF vectors
LSGM1 = 1
LTAU = LSGM1+NTUBUF*MXCI
LSGM2 = LTAU+MXCI

! Sectioning loops over pair indices IP3 (ket side):
do IP3STA=1,NASHT**2,NYZBUF
  IP3END = min(NASHT**2,IP3STA-1+NYZBUF)
  ! Compute a section of sigma vectors E(YZ)*PSI2 to memory:
  LTO = LSGM2
  do IP3=IP3STA,IP3END
    ! Translate to levels in the SGUGA coupling order:
    IL = P2LEV(1,IP3)
    JL = P2LEV(2,IP3)
    IY = L2ACT(IL)
    IZ = L2ACT(JL)
    IYS = IASYM(IY)
    IZS = IASYM(IZ)
    ISSG2 = Mul(Mul(IYS,IZS),LSYM2)
    TG3WRK(LTO:LTO+MXCI-1) = Zero
    ! LTO is first element of Sigma2 = E(YZ) Psi2
    call SG_Epq_Psi(SGS,CIS,EXS,IL,JL,One,LSYM2,CI2,TG3WRK(LTO))
    !! It is possible to calculate the contribution using
    !! DGEMV, but DAXPY seems to be faster than DGEMV
    if ((ISSG2 == LSYM1) .and. (DTG1(IY,IZ) /= Zero)) CLAG1(1:NCI1) = CLAG1(1:NCI1)+DTG1(IY,IZ)*TG3WRK(LTO:LTO+NCI1-1)
    LTO = LTO+MXCI
  end do

  DYZ(1:MXCI,1:NYZBUF) = Zero
  ! Sectioning loops over pair indices IP1 (bra side):
  do IP1STA=IP3STA,NASHT**2,NTUBUF
    IP1END = min(NASHT**2,IP1STA-1+NTUBUF)
    ! Compute a section of sigma vectors E(UT)*PSI1 to memory:
    LTO = LSGM1
    !! <Psi1|E(TU)
    do IP1=IP1STA,IP1END
      ! Translate to levels:
      JL = P2LEV(1,IP1)
      IL = P2LEV(2,IP1)
      IT = L2ACT(IL)
      IU = L2ACT(JL)
      ITS = IASYM(IT)
      IUS = IASYM(IU)
      ISSG1 = Mul(Mul(ITS,IUS),LSYM1)
      TG3WRK(LTO:LTO+MXCI-1) = Zero
      call SG_Epq_Psi(SGS,CIS,EXS,IL,JL,One,LSYM1,CI1,TG3WRK(LTO))
      if ((ISSG1 == LSYM1) .and. (DTG1(IU,IT) /= Zero) .and. (IP3STA == 1)) &
        CLAG2(1:NCI1) = CLAG2(1:NCI1)+DTG1(IU,IT)*TG3WRK(LTO:LTO+NCI1-1)
      LTO = LTO+MXCI
    end do

    DTU(1:MXCI,1:NTUBUF) = Zero
    ! Now compute as many elements as possible:
    LFROM = LSGM2
    LFROMD = 1
    do IP3=IP3STA,IP3END
      IY = L2ACT(P2LEV(1,IP3))
      IZ = L2ACT(P2LEV(2,IP3))
      ! LFROM will be start element of Sigma2=E(YZ) Psi2
      IYZ = IY+NASHT*(IZ-1)
      IYS = IASYM(IY)
      IZS = IASYM(IZ)
      ISSG2 = Mul(Mul(IYS,IZS),LSYM2)
      IM = P2LEV(1,IP3)
      JM = P2LEV(2,IP3)
      do IP2=IP3,IP1END
        IL = P2LEV(1,IP2)
        JL = P2LEV(2,IP2)
        IV = L2ACT(IL)
        IX = L2ACT(JL)
        IVX = IV+NASHT*(IX-1)
        IVS = IASYM(IV)
        IXS = IASYM(IX)
        ISTAU = Mul(Mul(IVS,IXS),ISSG2)
        NTAU = CIS%NCSF(ISTAU)
        TG3WRK(LTAU:LTAU+MXCI-1) = Zero
        ! LTAU  will be start element of Tau=E(VX) Sigma2=E(VX) E(YZ) Psi2
        !! LTAU = EvxEyz|Psi2>
        call SG_Epq_Psi(SGS,CIS,EXS,IL,JL,One,ISSG2,TG3WRK(LFROM),TG3WRK(LTAU))
        if ((ISTAU == LSYM1) .and. (DTG2(IV,IX,IY,IZ) /= Zero)) then
          !DTG2(IV,IX,IY,IZ) = DDOT_(NTAU,TG3WRK(LTAU),1,CI1,1)
          !! For left derivative: <I|Evx Eyz|Psi2>
          CLAG1(1:NTAU) = CLAG1(1:NTAU)+DTG2(IV,IX,IY,IZ)*TG3WRK(LTAU:LTAU+NTAU-1)
          !! For right derivative: <Psi1|Evx Eyz|I>
          if ((IP2 >= IP1STA) .and. (IP2 <= IP1END)) then
            ibuf = lsgm1+mxci*(ip2-ip1sta)
            DYZ(1:MXCI,LFROMD) = DYZ(1:MXCI,LFROMD)+DTG2(IV,IX,IY,IZ)*TG3WRK(IBUF:IBUF+MXCI-1)
          else
            call SG_Epq_Psi(SGS,CIS,EXS,JL,IL,DTG2(IV,IX,IY,IZ),ISSG2,CI1,DYZ(1,LFROMD))
          end if
          DTG2(IV,IX,IY,IZ) = Zero
        end if
        if (DOG3) then
          BUF1(1:MXCI) = Zero
          do IP1=max(IP2,IP1STA),IP1END
            IT = L2ACT(P2LEV(1,IP1))
            IU = L2ACT(P2LEV(2,IP1))
            ITS = IASYM(IT)
            IUS = IASYM(IU)
            ISSG1 = Mul(Mul(ITS,IUS),LSYM1)
            if (ISSG1 == ISTAU) then
              !L = LSGM1+MXCI*(IP1-IP1STA)
              !VAL = DDOT_(NTAU,TG3WRK(LTAU),1,TG3WRK(L),1)
              ITU = IT+NASHT*(IU-1)
              ! Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
              ! Code to put it in correct place:
              if (ITU < IVX) then
                if (ITU >= IYZ) then
                  JTU = IVX
                  JVX = ITU
                  JYZ = IYZ
                else if (IVX < IYZ) then
                  JTU = IYZ
                  JVX = IVX
                  JYZ = ITU
                else
                  JTU = IVX
                  JVX = IYZ
                  JYZ = ITU
                end if
              else
                if (ITU < IYZ) then
                  JTU = IYZ
                  JVX = ITU
                  JYZ = IVX
                else if (IVX >= IYZ) then
                  JTU = ITU
                  JVX = IVX
                  JYZ = IYZ
                else
                  JTU = ITU
                  JVX = IYZ
                  JYZ = IVX
                end if
              end if
              JTUVXYZ = nTri3_Elem(JTU-1)+nTri_Elem(JVX-1)+JYZ
              if (DTG3(JTUVXYZ) /= Zero) then
                !! For left derivative: <I|Evx Eyz|Psi2> * Dtuvxyz
                !! I don't understand, but this is much faster than
                !! processing all possible vectors at once with DGEMM
                !! (and DGER) after finishing the IP1 loop below
                DTU(1:MXCI,1+IP1-IP1STA) = DTU(1:MXCI,1+IP1-IP1STA)+DTG3(JTUVXYZ)*TG3WRK(LTAU:LTAU+MXCI-1)
                !! For right derivative: <Psi1|Etu|I> * Dtuvxyz
                !! This is also (slightly) faster than DGEMV, apparently
                BUF1(:) = BUF1(:)+DTG3(JTUVXYZ)*TG3WRK(LSGM1+MXCI*(IP1-IP1STA):LSGM1+MXCI*(IP1-IP1STA+1)-1)
              end if
              ! End of symmetry requirement IF-clause:
            end if
            ! End of IP1 loop.
          end do
          !! Second operator for the right derivative:
          !! <Psi1|Etu Evx|I> * Dtuvxyz
          call SG_Epq_Psi(SGS,CIS,EXS,JL,IL,One,ISTAU,BUF1,DYZ(1,LFROMD))
        end if !! End of DOG3 clause
        ! End of IP2 loop.
      end do
      LFROM = LFROM+MXCI
      LFROMD = LFROMD+1
      ! End of IP3 loop.
    end do

    LTO = 1
    !! <I|Etu Evx Eyz|Psi2> * Dtuvxyz
    do IP1=IP1STA,IP1END
      ! Translate to levels:
      IL = P2LEV(1,IP1)
      JL = P2LEV(2,IP1)
      IT = L2ACT(IL)
      IU = L2ACT(JL)
      ITS = IASYM(IT)
      IUS = IASYM(IU)
      ISSG1 = Mul(Mul(ITS,IUS),LSYM1)
      call SG_Epq_Psi(SGS,CIS,EXS,IL,JL,One,LSYM1,DTU(1,LTO),CLAG1)
      LTO = LTO+1
    end do
    ! End of IP1STA sectioning loop
  end do

  LTO = 1
  do IP3=IP3STA,IP3END
    IY = L2ACT(P2LEV(1,IP3))
    IZ = L2ACT(P2LEV(2,IP3))
    ! LFROM will be start element of Sigma2=E(YZ) Psi2
    IYZ = IY+NASHT*(IZ-1)
    IYS = IASYM(IY)
    IZS = IASYM(IZ)
    ISSG2 = Mul(Mul(IYS,IZS),LSYM2)
    IM = P2LEV(1,IP3)
    JM = P2LEV(2,IP3)
    ! LTO is first element of Sigma2 = E(YZ) Psi2
    call SG_Epq_Psi(SGS,CIS,EXS,JM,IM,One,LSYM2,DYZ(1,LTO),CLAG2)
    LTO = LTO+1
  end do
  ! End of IP3STA sectioning loop
end do

call mma_deallocate(TG3WRK)
call mma_deallocate(BUF1)
call mma_deallocate(DTU)
call mma_deallocate(DYZ)
call mma_deallocate(P2LEV)

end subroutine DERTG3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_add(wrk,wrksize,ninda,nindb,nindext,typext,u,v,ssu,ssv,factor,a,ssa,b,ssb,rc)
! this routine does:
! B(indb) = B(indb) + factor * A(inda)
!
! ninda   - # of indices in matrix A (1-4)
! nindb   - # of indices in matrix B (1-4)
! nindext - # of external (frozen, fixed) indices (now:0-2)
! typext  - characterize external indices as follows:
!           0 - no frozen index
!           1 - frozen index p
!           2 - frozen index q
!           3 - frozen index r
!           4 - frozen index s
!           5 - frozen indices p,q
!           6 - frozen indices r,s
! u       - value of first external index (if any, else 0)
! v       - value of second external index (if any, else 0)
! ssu     - symmetry of u (if any, else 1)
! ssv     - symmetry of v (if any, else 1)
! factor  - multiplicative factor (see def)
! a       - A (see docc.txt)
! ssa     - overall spin state of matrix A
! b       - B (see docc.txt)
! ssb     - overall spin state of matrix B
! rc      - return (error) code
!
! Table of present implementations:
!
! nindB  nindxet  typext  typB  =>   Implemented
!
! >4                                   No
!
! 4       0        0    0-4            Yes
! 4       1       1-4   0,4            Yes
! 4       1       1-4   2,3            No
! 4       2        5    0,4            Yes
! 4       2        5    2,3            No
! 4       2       6-n                  No
! 4       3                            No
!
! 3       0       0     0-2            Yes
! 3       1       1-3    0             Yes
! 3       1       1-3   1,2            No
! 3       2                            No
!
! 2       0       0     0,1            Yes
! 2       1       1-2    0             Yes
! 2       1       1-2    1             No
! 2       2                            No
!
! 1                                    No
!
! !N.B. oprav co je oznacene c@!

use CCT3_global, only: dimm, Map_Type, mmul
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, ninda, nindb, nindext, typext, u, v, ssu, ssv, ssa, ssb
real(kind=wp), intent(inout) :: wrk(wrksize)
real(kind=wp), intent(in) :: factor
type(Map_Type), intent(in) :: a, b
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp) :: ia, ib, ibm, nhelp1, nhelp10, nhelp2, nhelp3, nhelp4, nhelp5, nhelp6, nhelp7, nhelp8, nhelp9, p, pq, q, sa1, &
                     sa2, sa3, ssp, ssq, typa, typb
real(kind=wp) :: fact

! general tests

nhelp1 = nindA+nindext

if (nhelp1 /= nindb) then
  ! RC=1  : incompatible (nindA, nindB and nindext, Stup)
  rc = 1
  return
end if

nhelp1 = mmul(ssu,ssv)
nhelp1 = mmul(ssa,nhelp1)
if (nhelp1 /= ssb) then
  ! RC=2  : incompatible (ssa, ssb ,ssu and ssv, Stup)
  rc = 2
  return
end if

typa = a%d(0,6)
typb = b%d(0,6)
fact = factor

if ((nindext > 0) .and. ((typb >= 1) .and. (typb <= 3))) then
  ! RC=3 : nindext>0, typB is 1,2 or 3 (NCI)
  rc = 3
  return
end if

if ((nindext == 2) .and. (typb == 4)) then

  ! def p,q,ssp,ssq,fact(new)

  if (ssu > ssv) then
    ! ssu>ssv
    p = u
    q = v
    ssp = ssu
    ssq = ssv
    fact = factor
  else if (ssu == ssv) then
    ! ssu=ssv
    if (u >= v) then
      p = u
      q = v
      ssp = ssu
      ssq = ssv
      fact = factor
    else
      p = v
      q = u
      ssp = ssv
      ssq = ssu
      fact = -factor
    end if
  else
    ! ssu<ssv
    p = v
    q = u
    ssp = ssv
    ssq = ssu
    fact = -factor
  end if

else
  ! To fix some 'uninitialized' warnings
  p = 0
  q = 0
end if

if (nindb == 4) then

  ! **********  -> B(pqrs) **********

  if (nindext == 0) then

    ! case B(pqrs) <-- A(pqrs) or B(p,q,r,s) <-- A(p,q,r,s)

    ! tests

    if (typa /= typb) then
      ! RC=4 : nindB=4, nindext=0 (TypA incompatible with TypB ,Stup)
      rc = 4
      return
    end if

    do ia=1,a%d(0,5)

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)

      ib = b%i(sa1,sa2,sa3)

      ! def length
      nhelp1 = a%d(ia,2)
      if (nhelp1 == 0) cycle

      ! def posA,posB
      nhelp2 = a%d(ia,1)
      nhelp3 = b%d(ib,1)

      call cct3_add10(wrk(nhelp2),wrk(nhelp3),nhelp1,fact)

    end do

  else if (nindext == 1) then

    if (typext == 1) then

      if (typb == 0) then

        ! case B(p,q,r,s) <-- A(q,r,s)

        ! tests

        if (typa /= 0) then
          ! RC=5 : nindB=4, nindeext=1, typext=1, typB=0 (typA is not 0, Stup)
          rc = 5
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)
          sa3 = a%d(ia,5)

          ib = b%i(ssu,sa1,sa2)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq,dimr,dims
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))
          nhelp7 = dimm(b%d(0,4),b%d(ib,6))

          ! def fictive dimensions
          nhelp8 = nhelp5*nhelp6*nhelp7

          call cct3_add21(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp8,fact)

        end do

      else if (typb == 4) then

        ! case B(pq,rs) <-- A(q,rs)

        ! tests

        if (typa /= 2) then
          ! RC=6  : nindB=4, nindeext=1, typext=1, typB=4 (typA is not 2, Stup)
          rc = 6
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)
          sa3 = a%d(ia,5)

          ib = b%i(ssu,sa1,sa2)
          ibm = b%i(sa1,ssu,sa2)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA
          nhelp2 = a%d(ia,1)

          if (ssu > sa1) then

            ! def dimp,dimq,dimr,dims
            nhelp4 = dimm(b%d(0,1),b%d(ib,3))
            nhelp5 = dimm(b%d(0,2),b%d(ib,4))
            nhelp6 = dimm(b%d(0,3),b%d(ib,5))
            nhelp7 = dimm(b%d(0,4),b%d(ib,6))

            ! def fictive dimensions
            if (sa2 == sa3) then
              nhelp8 = nhelp6*(nhelp6-1)/2
            else
              nhelp8 = nhelp6*nhelp7
            end if

            ! def posB
            nhelp3 = b%d(ib,1)
            ! def fictive dimensions
            nhelp9 = nhelp5*nhelp8
            call cct3_add21(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp9,fact)

          else if (ssu == sa1) then

            ! def dimp,dimq,dimr,dims
            nhelp4 = dimm(b%d(0,1),b%d(ib,3))
            nhelp5 = dimm(b%d(0,2),b%d(ib,4))
            nhelp6 = dimm(b%d(0,3),b%d(ib,5))
            nhelp7 = dimm(b%d(0,4),b%d(ib,6))

            ! def fictive dimensions
            if (sa2 == sa3) then
              nhelp8 = nhelp6*(nhelp6-1)/2
            else
              nhelp8 = nhelp6*nhelp7
            end if

            ! def posB
            nhelp3 = b%d(ib,1)
            ! def fictive dimensions
            nhelp9 = nhelp4*(nhelp4-1)/2
            call cct3_add41(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp9,nhelp8,fact)

          else
            ! ssu<sa1  B(qp,rs) <-- -A_p (q,rs)

            ! def dimp,dimq,dimr,dims
            nhelp4 = dimm(b%d(0,1),b%d(ibm,3))
            nhelp5 = dimm(b%d(0,2),b%d(ibm,4))
            nhelp6 = dimm(b%d(0,3),b%d(ibm,5))
            nhelp7 = dimm(b%d(0,4),b%d(ibm,6))

            ! def fictive dimensions
            if (sa2 == sa3) then
              nhelp8 = nhelp6*(nhelp6-1)/2
            else
              nhelp8 = nhelp6*nhelp7
            end if

            ! def posB-
            nhelp3 = b%d(ibm,1)
            call cct3_add32(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,nhelp8,-fact)

          end if

        end do

      else
        ! RC=7 : nindB=4, nindext=1, typext=1, (typA is not 0 or 4, (NCI))
        rc = 7
        return
      end if

    else if (typext == 2) then

      if (typb == 0) then

        ! case B(p,q,r,s) <-- A(p,r,s)

        ! tests

        if (typa /= 0) then
          ! RC=8 : nindB=4, nindeext=1, typext=2, typB=0 (typA is not 0, Stup)
          rc = 8
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)
          sa3 = a%d(ia,5)

          ib = b%i(sa1,ssu,sa2)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq,dimr,dims
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))
          nhelp7 = dimm(b%d(0,4),b%d(ib,6))

          ! def fictive dimensions
          nhelp8 = nhelp6*nhelp7

          call cct3_add32(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,nhelp8,fact)

        end do

      else if (typb == 4) then

        ! case B(pq,rs) <-- A(p,rs)

        ! tests

        if (typa /= 2) then
          ! RC=9 : nindB=4, nindeext=1, typext=2, typB=4 (typA is not 2, Stup)
          rc = 9
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)
          sa3 = a%d(ia,5)

          ib = b%i(sa1,ssu,sa2)
          ibm = b%i(ssu,sa1,sa2)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA
          nhelp2 = a%d(ia,1)

          if (sa1 > ssu) then

            ! def dimp,dimq,dimr,dims
            nhelp4 = dimm(b%d(0,1),b%d(ib,3))
            nhelp5 = dimm(b%d(0,2),b%d(ib,4))
            nhelp6 = dimm(b%d(0,3),b%d(ib,5))
            nhelp7 = dimm(b%d(0,4),b%d(ib,6))

            ! def fictive dimensions
            if (sa2 == sa3) then
              nhelp8 = nhelp6*(nhelp6-1)/2
            else
              nhelp8 = nhelp6*nhelp7
            end if

            ! def posB
            nhelp3 = b%d(ib,1)
            call cct3_add32(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,nhelp8,fact)

          else if (sa1 == ssu) then

            ! def dimp,dimq,dimr,dims
            nhelp4 = dimm(b%d(0,1),b%d(ib,3))
            nhelp5 = dimm(b%d(0,2),b%d(ib,4))
            nhelp6 = dimm(b%d(0,3),b%d(ib,5))
            nhelp7 = dimm(b%d(0,4),b%d(ib,6))

            ! def fictive dimensions
            if (sa2 == sa3) then
              nhelp8 = nhelp6*(nhelp6-1)/2
            else
              nhelp8 = nhelp6*nhelp7
            end if

            ! def posB
            nhelp3 = b%d(ib,1)
            ! def fictive dimensions
            nhelp9 = nhelp4*(nhelp4-1)/2
            call cct3_add42(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp9,nhelp8,fact)

          else
            ! sa1<ssu  B(qp,rs) <-- -A_q (p,rs)

            ! def dimp,dimq,dimr,dims
            nhelp4 = dimm(b%d(0,1),b%d(ibm,3))
            nhelp5 = dimm(b%d(0,2),b%d(ibm,4))
            nhelp6 = dimm(b%d(0,3),b%d(ibm,5))
            nhelp7 = dimm(b%d(0,4),b%d(ibm,6))

            ! def fictive dimensions
            if (sa2 == sa3) then
              nhelp8 = nhelp6*(nhelp6-1)/2
            else
              nhelp8 = nhelp6*nhelp7
            end if

            ! def posB-
            nhelp3 = b%d(ibm,1)
            ! def fictive index
            nhelp9 = nhelp8*nhelp5
            call cct3_add21(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp9,-fact)

          end if

        end do

      else
        ! RC=10: nindB=4, nindext=1, typext=2, (typA is not 0 or 4, (NCI))
        rc = 10
        return
      end if

    else if (typext == 3) then

      if (typb == 0) then

        ! case B(p,q,r,s) <-- A(p,q,s)

        ! tests

        if (typa /= 0) then
          ! RC=11: nindB=4, nindeext=1, typext=3, typB=0 (typA is not 0, Stup)
          rc = 11
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)
          sa3 = a%d(ia,5)

          ib = b%i(sa1,sa2,ssu)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq,dimr,dims
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))
          nhelp7 = dimm(b%d(0,4),b%d(ib,6))

          ! def fictive dimensions
          nhelp8 = nhelp4*nhelp5

          call cct3_add32(wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp6,nhelp7,fact)

        end do

      else if (typb == 4) then

        ! case B(pq,rs) <-- A(pq,s)
        !@! oprav to tak ako v typext 1 a 2

        ! tests

        if (typa /= 1) then
          ! RC=12: nindB=4, nindeext=1, typext=3, typB=4 (typA is not 1, Stup)
          rc = 12
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)
          sa3 = a%d(ia,5)

          ib = b%i(sa1,sa2,ssu)
          ibm = b%i(sa1,sa2,sa3)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA
          nhelp2 = a%d(ia,1)

          ! def dimp,dimq,dimr,dims
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))
          nhelp7 = dimm(b%d(0,4),b%d(ib,6))

          ! def fictive dimensions
          if (sa1 == sa2) then
            nhelp8 = nhelp4*(nhelp4-1)/2
          else
            nhelp8 = nhelp4*nhelp5
          end if

          if (ssu > sa3) then

            ! def posB
            nhelp3 = b%d(ib,1)
            call cct3_add32(wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp6,nhelp7,fact)

          else if (ssu == sa3) then

            ! def posB
            nhelp3 = b%d(ib,1)
            ! def fictive dimensions
            nhelp9 = nhelp6*(nhelp6-1)/2
            call cct3_add43(wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp9,nhelp6,fact)

          else
            ! ssu<sa3  B(pq,sr) <-- -A_r (pq,s)
            ! def posB-
            nhelp3 = b%d(ibm,1)
            ! def fictive dimension
            nhelp9 = nhelp8*nhelp7
            call cct3_add22(wrk(nhelp2),wrk(nhelp3),u,nhelp9,nhelp6,-fact)

          end if

        end do

      else
        ! RC=13: nindB=4, nindext=1, typext=3, (typA is not 0 or 4, (NCI))
        rc = 13
        return
      end if

    else if (typext == 4) then

      if (typb == 0) then

        ! case B(p,q,r,s) <-- A(p,q,r)

        ! tests

        if (typa /= 0) then
          ! RC=14: nindB=4, nindeext=1, typext=4, typB=0 (typA is not 0, Stup)
          rc = 14
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)
          sa3 = a%d(ia,5)

          ib = b%i(sa1,sa2,sa3)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq,dimr,dims
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))
          nhelp7 = dimm(b%d(0,4),b%d(ib,6))

          ! def fictive dimensions
          nhelp8 = nhelp4*nhelp5*nhelp6

          call cct3_add22(wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp7,fact)

        end do

      else if (typb == 4) then

        ! case B(pq,rs) <-- A(pq,r)
        !@! oprav to tak ako v typext 1 a 2

        ! tests

        if (typa /= 1) then
          ! RC=15: nindB=4, nindeext=1, typext=4, typB=4 (typA is not 1, Stup)
          rc = 15
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)
          sa3 = a%d(ia,5)

          ib = b%i(sa1,sa2,sa3)
          ibm = b%i(sa1,sa2,ssu)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA
          nhelp2 = a%d(ia,1)

          ! def dimp,dimq,dimr,dims
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))
          nhelp7 = dimm(b%d(0,4),b%d(ib,6))

          ! def fictive dimensions
          if (sa1 == sa2) then
            nhelp8 = nhelp4*(nhelp4-1)/2
          else
            nhelp8 = nhelp4*nhelp5
          end if

          if (sa3 > ssu) then

            ! def posB
            nhelp3 = b%d(ib,1)
            ! def fictive dimension
            nhelp9 = nhelp8*nhelp6
            call cct3_add22(wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp7,fact)

          else if (sa3 == ssu) then

            ! def posB
            nhelp3 = b%d(ib,1)
            ! def fictive dimensions
            nhelp9 = nhelp6*(nhelp6-1)/2
            call cct3_add44(wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp9,nhelp6,fact)

          else
            ! sa3<ssu  B(pq,sr) <-- -A_s (pq,r)
            ! def posB-
            nhelp3 = b%d(ibm,1)
            call cct3_add32(wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp7,nhelp6,-fact)

          end if

        end do

      else
        ! RC=16: nindB=4, nindext=1, typext=4, (typA is not 0 or 4, (NCI))
        rc = 16
        return
      end if

    else
      ! RC=17: nindB=4, nindext=1, typext=@  (Stup)
      rc = 17
      return
    end if

  else if (nindext == 2) then

    if (typext == 5) then

      if (typb == 0) then

        ! case B(p,q,r,s) <-- A(r,s)

        ! tests

        if ((typb == 0) .and. (typa /= 0)) then
          ! RC=18: nindB=4, nindext=2, typext=5, typB=0 (typA is not 0, Stup)
          rc = 18
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)

          nhelp1 = mmul(ssu,ssv)
          nhelp1 = mmul(nhelp1,sa1)
          nhelp1 = mmul(nhelp1,ssb)
          if (nhelp1 /= sa2) then
            write(u6,*) ' Add Bpqrs <- Ars incorrect',ssp,ssq,sa1,nhelp1,sa1,sa2
            cycle
          end if

          ib = b%i(ssu,ssv,sa1)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq,dimr,dims
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))
          nhelp7 = dimm(b%d(0,4),b%d(ib,6))

          ! calc joined pq index
          pq = (v-1)*nhelp4+u

          ! calc fictive lengths
          nhelp9 = nhelp6*nhelp7
          nhelp10 = nhelp4*nhelp5

          call cct3_add21(wrk(nhelp2),wrk(nhelp3),pq,nhelp10,nhelp9,fact)

        end do

      else if (typb == 4) then

        ! case B(pq,rs) <-- A(rs)

        ! tests

        if ((typb == 4) .and. (typa /= 1)) then
          ! RC=19: nindB=4, nindext=2, typext=5, typB=4 (typA is not 1, Stup)
          rc = 19
          return
        end if

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)

          nhelp1 = mmul(ssp,ssq)
          nhelp1 = mmul(nhelp1,sa1)
          nhelp1 = mmul(nhelp1,ssb)
          if (nhelp1 /= sa2) then
            write(u6,*) ' Add Bpqrs <- Ars incorrect'
            cycle
          end if

          ib = b%i(ssp,ssq,sa1)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq,dimr,dims
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))
          nhelp7 = dimm(b%d(0,4),b%d(ib,6))

          ! calc joined pq index and fictive length of pq pair
          if (ssp == ssq) then
            pq = (p-1)*(p-2)/2+q
            nhelp10 = nhelp4*(nhelp4-1)/2
          else
            pq = (q-1)*nhelp4+p
            nhelp10 = nhelp4*nhelp5
          end if

          ! calc fictive lengths
          if (sa1 == sa2) then
            nhelp9 = nhelp6*(nhelp6-1)/2
          else
            nhelp9 = nhelp6*nhelp7
          end if

          call cct3_add21(wrk(nhelp2),wrk(nhelp3),pq,nhelp10,nhelp9,fact)

        end do

      else
        ! RC=20: nindB=4, nindext=2, typext=5 (typB is not 0 or 4, NCI)
        rc = 20
        return
      end if

    else if (typext == 6) then

      ! case B(p,q,r,s) <-- A(p,q) and B(pq,rs) <-- A(pq)

      ! RC=21: nindB=4, nindext=2, typext=6, NCI)
      rc = 21
      return

    else
      ! RC=22: nindB=4, nindext=2, (typext is not 5 or 6, NCI)
      rc = 22
      return
    end if

  else
    ! RC=23: nindB=4, nindext>2 (NCI)
    rc = 23
    return
  end if

else if (nindb == 3) then

  ! **********  -> B(pqr) **********

  if (nindext == 0) then

    ! case B(pqr) <-- A(pqr)

    ! tests

    if (typa /= typb) then
      ! RC=24: nindB=3, nindext=0 (TypA incompatible with TypB ,Stup)
      rc = 24
      return
    end if

    do ia=1,a%d(0,5)

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)

      ib = b%i(sa1,sa2,1)

      ! def length
      nhelp1 = a%d(ia,2)
      if (nhelp1 == 0) cycle

      ! def posA,posB
      nhelp2 = a%d(ia,1)
      nhelp3 = b%d(ib,1)

      call cct3_add10(wrk(nhelp2),wrk(nhelp3),nhelp1,fact)

    end do

  else if (nindext == 1) then

    if (typext == 1) then

      ! case B(p,q,r) <-- A(q,r)

      if ((typa == 0) .and. (typb == 0)) then

        ! case B(p,q,r) <-- A(q,r)

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)

          ib = b%i(ssu,sa1,1)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq,dimr
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))

          ! def fictive dimensions
          nhelp7 = nhelp5*nhelp6

          call cct3_add21(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp7,fact)

        end do

      else
        ! RC=25: nindB=3, nindext=1, typext=1 (tybA,B is not 0, NCI)
        rc = 25
        return
      end if

    else if (typext == 2) then

      if ((typa == 0) .and. (typb == 0)) then

        ! case B(p,q,r) <-- A(p,r)

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)

          ib = b%i(sa1,ssu,1)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq,dimr
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))

          call cct3_add32(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp6,nhelp7,fact)

        end do

      else
        ! RC=26: nindB=3, nindext=1, typext=2 (tybA,B is not 0, NCI)
        rc = 26
        return
      end if

    else if (typext == 3) then

      if ((typa == 0) .and. (typb == 0)) then

        ! case B(p,q,r) <-- A(p,q)

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          sa2 = a%d(ia,4)

          ib = b%i(sa1,sa2,1)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq,dimr
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))
          nhelp6 = dimm(b%d(0,3),b%d(ib,5))

          ! def fictive dimensions
          nhelp7 = nhelp4*nhelp5

          call cct3_add21(wrk(nhelp2),wrk(nhelp3),u,nhelp7,nhelp6,fact)

        end do

      else
        ! RC=27: nindB=3, nindext=1, typext=3 (tybA,B is not 0, NCI)
        rc = 27
        return
      end if

    else
      ! RC=28: nindB=3 , typext=@ (Stup)
      rc = 28
      return
    end if

  else
    ! RC=29: nindB=3, nindext>1 (NCI)
    rc = 29
    return
  end if

else if (nindb == 2) then

  ! **********  -> B(pq) **********

  if (nindext == 0) then

    ! case B(p,q) <-- A(p,q)

    do ia=1,a%d(0,5)

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)

      ib = b%i(sa1,1,1)

      ! def length
      nhelp1 = a%d(ia,2)
      if (nhelp1 == 0) cycle

      ! def posA,posB
      nhelp2 = a%d(ia,1)
      nhelp3 = b%d(ib,1)

      call cct3_add10(wrk(nhelp2),wrk(nhelp3),nhelp1,fact)

    end do

  else if (nindext == 1) then

    if (typext == 1) then

      ! case B(p,q) <-- A(q)

      if ((typa == 0) .and. (typb == 0)) then

        do ia=1,a%d(0,5)

          ib = b%i(ssu,1,1)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))

          call cct3_add21(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,fact)

        end do

      else
        ! RC=30: nindB=2, nindext=1, typext=1, (typA,B is not 0, NCI)
        rc = 30
        return
      end if

    else if (typext == 2) then

      ! case B(p,q) <-- A(p)

      if ((typa == 0) .and. (typb == 0)) then

        do ia=1,a%d(0,5)

          sa1 = a%d(ia,3)
          ib = b%i(sa1,1,1)

          ! def length
          nhelp1 = a%d(ia,2)
          if (nhelp1 == 0) cycle

          ! def posA,posB
          nhelp2 = a%d(ia,1)
          nhelp3 = b%d(ib,1)

          ! def dimp,dimq
          nhelp4 = dimm(b%d(0,1),b%d(ib,3))
          nhelp5 = dimm(b%d(0,2),b%d(ib,4))

          call cct3_add22(wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,fact)

        end do

      else
        ! RC=31: nindB=2, nindext=1, typext=2, (typA,B is not 0, NCI)
        rc = 31
        return
      end if

    else
      ! RC=32: nindB=2, nindext=1, typext=@ (Stup)
      rc = 32
      return
    end if

  else
    ! RC=33: nindB=2, ininext>1 (NCI)
    rc = 33
    return
  end if

else
  ! RC=34: nindb less then 2 (NCI/Stup)
  rc = 34
  return
end if

return

end subroutine cct3_add

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2000, Roland Lindh                                *
************************************************************************
      SubRoutine PGet1_Aces(PAO,ijkl,nPAO,iCmp,
     &                      iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,kOp,
     &                      DSO,DSO_Var,DSSO,DSSO_Var,nDSO,
     &                      Gamma,nGamma,iSO2cI,nSOs,
     &                      iSO2Sh,PMax)
************************************************************************
*                                                                      *
*  Object: to assemble the 2nd order density matrix of a SCF wave      *
*          function from the 1st order density.                        *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*          DSO: HF 1st order density                                   *
*          DSO_Var: 1st order density of correlated wf.                *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*                                                                      *
*     Modified to Aces 2 by RL, July 2000, Gainesville, FL, USA        *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use pso_stuff
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
************ columbus interface ****************************************
#include "columbus_gamma.fh"
      parameter (exfac=1d0)
      Real*8 PAO(ijkl,nPAO), DSO(nDSO),  DSO_Var(nDSO),
     &       Gamma(nGamma), DSSO(nDSO), DSSO_Var(nDSO)
      Integer iSO2cI(2,nSOs), iSO2Sh(nSOs)
      Integer iAO(4), kOp(4), iAOst(4), iCmp(4)
      Logical Shijij
*                                                                      *
************************************************************************
*                                                                      *
*     Statement Function
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      iRout = 39
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         iComp = 1
         Call PrMtrx('DSO     ',[iD0Lbl],iComp,1,D0)
         Call PrMtrx('DSO_Var ',[iD0Lbl],iComp,1,DVar)
         Write (6,*) ' nBases..=',iBas,jBas,kBas,lBas
         Write (6,*) 'iSO2Sh=',iSO2Sh
         Write (6,*) 'iSO2cI(1)',(iSO2cI(1,i),i=1,nSOs)
         Write (6,*) 'iSO2cI(2)',(iSO2cI(2,i),i=1,nSOs)
         Call RecPrt('PGet1: Gamma',' ',Gamma,1,nGamma)
      End If
#endif
*
*     Quadruple loop over elements of the basis functions angular
*     description.
*     Observe that we will walk through the memory in PAO in a
*     sequential way.
*
      PMax=Zero
      iPAO=0
      t14 = Quart * exfac
      Do 100 i1 = 1, iCmp(1)
         Do 200 i2 = 1, iCmp(2)
            Do 300 i3 = 1, iCmp(3)
               Do 400 i4 = 1, iCmp(4)
*
*               Unfold the way the eight indices have been reordered.
                iSO = iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
                jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
                kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
                lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
                iPAO = iPAO + 1
                nijkl = 0
                Do 120 lAOl = 0, lBas-1
                   lSOl = lSO + lAOl
                   iShell_D=iSO2Sh(lSOl)
                   Index_D =iSO2cI(1,lSOl)
                   nDim_D  =iSO2cI(2,lSOl)
                   Do 220 kAOk = 0, kBas-1
                      kSOk = kSO + kAOk
                      iShell_C=iSO2Sh(kSOk)
                      Index_C =iSO2cI(1,kSOk)
                      nDim_C  =iSO2cI(2,kSOk)
                      nDim_CD=nDim_C*nDim_D
                      iShell_CD=iTri(iShell_C,iShell_D)
                      If (iShell_C.gt.iShell_D) Then
                         Index_CD=(Index_D-1)*nDim_C + Index_C
                      Else If (iShell_C.eq.iShell_D) Then
                         Index_CD=iTri(Index_C,Index_D)
                      Else
                         Index_CD=(Index_C-1)*nDim_D + Index_D
                      End If
                      Do 320 jAOj = 0, jBas-1
                         jSOj = jSO + jAOj
                         iShell_B=iSO2Sh(jSOj)
                         Index_B =iSO2cI(1,jSOj)
                         nDim_B  =iSO2cI(2,jSOj)
                         Do 420 iAOi = 0, iBas-1
                            iSOi = iSO + iAOi
                            iShell_A=iSO2Sh(iSOi)
                            Index_A =iSO2cI(1,iSOi)
                            nDim_A  =iSO2cI(2,iSOi)
                            nDim_AB=nDim_A*nDim_B
                            iShell_AB=iTri(iShell_A,iShell_B)
                            If (iShell_A.gt.iShell_B) Then
                               Index_AB=(Index_B-1)*nDim_A + Index_A
                            Else If (iShell_A.eq.iShell_B) Then
                               Index_AB=iTri(Index_A,Index_B)
                            Else
                               Index_AB=(Index_A-1)*nDim_B + Index_B
                            End If
                            If (iShell_AB.gt.iShell_CD) Then
                               Index_ABCD=(Index_CD-1)*nDim_AB+Index_AB
                            Else If (iShell_AB.eq.iShell_CD) Then
                               Index_ABCD=iTri(Index_AB,Index_CD)
                            Else
                               Index_ABCD=(Index_AB-1)*nDim_CD+Index_CD
                            End If
                            nijkl = nijkl + 1

************ columbus interface ****************************************
*do not reconstruct the two-particle density from the one-particle
*density or partial two-particle densities but simply read them from
*file
                            if (gamma_mrcisd) goto 95
*
*---------------------------D(ij)*D(kl)
*
                            Indi=Max(iSOi,jSOj)
                            Indj=iSOi+jSOj-Indi
                            Indk=Max(kSOk,lSOl)
                            Indl=kSOk+lSOl-Indk
                            Indij=(Indi-1)*Indi/2+Indj
                            Indkl=(Indk-1)*Indk/2+Indl
                            temp= DSO(Indij)*DSO(Indkl)
     &                          +(DSO_Var(Indij)-DSO(Indij))*DSO(Indkl)
     &                          +DSO(Indij)*(DSO_Var(Indkl)-DSO(Indkl))
*
*--------------------------- -0.25*D(ik)*D(jl)
*
                            Indi=Max(iSOi,kSOk)
                            Indk=iSOi+kSOk-Indi
                            Indj=Max(jSOj,lSOl)
                            Indl=jSOj+lSOl-Indj
                            Indik=(Indi-1)*Indi/2+Indk
                            Indjl=(Indj-1)*Indj/2+Indl
                            temp=temp - t14*(
     &                           DSO(Indik)*DSO(Indjl)
     &                        +(DSO_Var(Indik)-DSO(Indik))*DSO(Indjl)
     &                        +DSO(Indik)*(DSO_Var(Indjl)-DSO(Indjl))
     &                        +DSSO(Indik)*DSSO(Indjl)
     &                        +(DSSO_Var(Indik)-DSSO(Indik))*DSSO(Indjl)
     &                        +DSSO(Indik)*(DSSO_Var(Indjl)-DSSO(Indjl))
     &                                      )
*
*--------------------------- -0.25*D(il)*D(jk)
*
                            Indi=Max(iSOi,lSOl)
                            Indl=iSOi+lSOl-Indi
                            Indj=Max(jSOj,kSOk)
                            Indk=jSOj+kSOk-Indj
                            Indil=(Indi-1)*Indi/2+Indl
                            Indjk=(Indj-1)*Indj/2+Indk
                            temp=temp - t14*(
     &                           DSO(Indil)*DSO(Indjk)
     &                        +(DSO_Var(Indil)-DSO(Indil))*DSO(Indjk)
     &                        +DSO(Indil)*(DSO_Var(Indjk)-DSO(Indjk))
     &                        +DSSO(Indil)*DSSO(Indjk)
     &                        +(DSSO_Var(Indil)-DSSO(Indil))*DSSO(Indjk)
     &                        +DSSO(Indil)*(DSSO_Var(Indjk)-DSSO(Indjk))
     &                                      )
*
                            temp = temp + Four*Gamma(Index_ABCD)
 95                         If(gamma_mrcisd) Then
                               temp = Gamma(Index_ABCD)
                            End If
*
                            PMax=Max(PMax,Abs(temp))
                            PAO(nijkl,iPAO) = temp
*
 420                     Continue
 320                  Continue
 220               Continue
 120            Continue
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
      If (iPAO.ne.nPAO) Then
         Call WarningMessage(2,' Error in PGet1_Aces!')
         Call Abend()
      End If
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' In PGet1:PAO ',' ',PAO,ijkl,nPAO)
         Do 3333 i = 1, ijkl
            Write (6,*) DDot_(nPAO,PAO(i,1),ijkl,
     &                            PAO(i,1),ijkl)
 3333    Continue
      End If
      Call GetMem(' Exit PGet1','CHECK','REAL',iDum,iDum)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Shijij)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Subroutine PLF_RICD(AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iShell,
     &                    iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,kOp,
     &                    TInt,nTInt,mTInt,iTOff,iOffij,iOffkl)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "srt0.fh"
#include "srt1.fh"
#include "WrkSpc.fh"
*
      Real*8 AOint(ijkl,iCmp,jCmp,kCmp,lCmp), TInt(nTInt,mTInt)
      Integer iShell(4), iAO(4), kOp(4), iAOst(4), iSOs(4)
      Logical Shijij
      Common /ibas_ricd/ jbas_, lbas_
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      irout = 109
      iprint = nprint(irout)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      r1=DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,[One],0)
      r2=DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1)
      Write (6,*) ' Sum=',r1
      Write (6,*) ' Dot=',r2
      Call RecPrt(' In PLF_RICD: AOInt',' ',
     &                              AOInt,ijkl,iCmp*jCmp*kCmp*lCmp)
#endif
*
*     quadruple loop over elements of the basis functions angular
*     description. loops are reduced to just produce unique SO integrals
*     observe that we will walk through the memory in AOint in a
*     sequential way.
*
      iAOsti=iAOst(1)
      iAOstj=iAOst(2)
      iAOstk=iAOst(3)
      iAOstl=iAOst(4)
C     Write (6,*) 'iAOsti,iAOstj,iAOstk,iAOstl=',
C    &             iAOsti,iAOstj,iAOstk,iAOstl
      iAOi=iAO(1)
      iAOj=iAO(2)
      iAOk=iAO(3)
      iAOl=iAO(4)
C     Write (6,*) 'iAOs=',iAO
C     Write (6,*) 'kOps=',kOp
C     Write (6,*) 'iTOff,iOffij,iOffkl=',iTOff,iOffij,iOffkl
C     Write (*,*) 'iBas,jBas,kBas,lBas=',iBas,jBas,kBas,lBas
*
*     The writing of the integrals here are shell blocked.
*
      Do i1 = 1, iCmp
         iSOs(1)=iAOtSO(iAOi+i1,kOp(1))+iAOsti
         Do i2 = 1, jCmp
            iSOs(2)=iAOtSO(iAOj+i2,kOp(2))+iAOstj
            Do i3 = 1, kCmp
               iSOs(3)=iAOtSO(iAOk+i3,kOp(3))+iAOstk
               Do i4 = 1, lCmp
                  iSOs(4)=iAOtSO(iAOl+i4,kOp(4))+iAOstl
*
                iSO =iSOs(1)
                jSO =iSOs(2)
                kSO =iSOs(3)
                lSO =iSOs(4)
*
C               Write (6,*)
C               Write (6,*) 'i1,i2,i3,i4,iSOs=',i1,i2,i3,i4,iSOs
C               Write (6,*) 'iBas,jBas,kBas,lBas=',iBas,jBas,kBas,lBas
*
                nijkl = 0
                Do lSOl = lSO, lSO+lBas-1
                   Do kSOk = kSO, kSO+kBas-1
                      If (iAO(3).eq.iAO(4)) Then
                         iSOkl=iTri(kSOk,lSOl) + iOffkl
                      Else
                         iSOkl=(kSOk-1)*lCmp*lBas_+ lSOl + iOffkl
                      End If
                      Do jSOj = jSO, jSO+jBas-1
                         Do iSOi = iSO, iSO+iBas-1
                            nijkl = nijkl + 1
                            AInt=AOint(nijkl,i1,i2,i3,i4)
                            If (iAO(1).eq.iAO(2)) Then
                               iSOij=iTri(iSOi,jSOj) + iOffij
                            Else
                               iSOij=(iSOi-1)*jCmp*jBas_+ jSOj + iOffij
                            End If
*
C                           Write (6,*) 'iSOij,iSOkl,AInt=',
C    &                                   iSOij,iSOkl,AInt
                            ijSOij=Max(iSOij,iSOkl)-iTOff
                            klSOkl=Min(iSOij,iSOkl)
                            TInt(klSOkl,ijSOij)= AInt
*
                         End Do
                      End Do
                   End Do
                End Do
*
               End Do
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Call RecPrt('TInt','(45G8.2)',TInt,nTInt,mTInt)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(iShell)
         Call Unused_logical(Shijij)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GSBBD2A(RHO2,RHO2S,RHO2A,NACOB,ISCSM,ISCTP,ICCSM,ICCTP,IGRP,NROW,NGAS,ISEL,ICEL,SB,CB,MXPNGAS,NOBPTS,IOBPTS,MAXI,MAXK, &
                   SSCR,CSCR,I1,XI1S,X,NSMOB,SCLFAC,IPACK)
! SUBROUTINE GSBBD2A --> 37
!
! Contributions to two-electron density matrix from column excitations
!
! GAS version, '96, Jeppe Olsen
!
! =====
! Input
! =====
! RHO2  : two body density matrix to be updated
! NACOB : Number of active orbitals
! ISCSM,ISCTP : Symmetry and type of sigma columns
! ICCSM,ICCTP : Symmetry and type of C     columns
! IGRP : String group of columns
! NROW : Number of rows in S and C block
! NGAS : Number of active spaces
! ISEL : Number of electrons per AS for S block
! ICEL : Number of electrons per AS for C block
! CB   : Input C block
! MXPNGAS : Max number of AS spaces (program parameter)
! NOBPTS  : Number of orbitals per type and symmetry
! IOBPTS : base for orbitals of given type and symmetry
! IBORB  : Orbitals of given type and symmetry
! NSMOB  : Number of symmetries of orbitals
! MAXI   : Largest Number of "spectator strings" treated simultaneously
! MAXK   : Largest number of inner resolution strings treated at simult.
! IPACK  : Should we pack the density?
!
! ======
! Output
! ======
! RHO2, RHO2S, RHO2A : Updated density block
!
! =======
! Scratch
! =======
!
! SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
!              largest number of orbital pairs of given symmetries and
!              types.
! I1, XI1S,  : For holding creations/annihilations type and symmetry
!
! Jeppe Olsen, Fall of 96

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use Para_Info, only: MyRank, nProcs
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: RHO2(*), RHO2S(*), RHO2A(*)
integer(kind=iwp), intent(in) :: NACOB, ISCSM, ISCTP, ICCSM, ICCTP, IGRP, NROW, NGAS, ISEL(NGAS), ICEL(NGAS), MXPNGAS, &
                                 NOBPTS(MXPNGAS,*), IOBPTS(MXPNGAS,*), MAXI, MAXK, NSMOB
real(kind=wp), intent(in) :: SB(*), CB(*), SCLFAC
real(kind=wp), intent(_OUT_) :: SSCR(*), CSCR(*), XI1S(MAXK,*), X(*)
integer(kind=iwp), intent(_OUT_) :: I1(MAXK,*)
logical(kind=iwp), intent(in) :: IPACK
integer(kind=iwp) :: I, I1IK, I1JL, IBOT, IDXSM, IDXTP, IFIRST, IFRST, II12, IIK, IIKE, IIPART, IJL, IJLE, IKBOFF, IKOBSM, IKOFF, &
                     IKSM, IOFF, ISM, ITOP, ITP(256), ITYP, J, JFRST, JLBOFF, JLOBSM, JLOFF, JLSM, JOFF, JSM, JTP(256), JTYP, K, &
                     K12, KBOT, KEND, KFRST, KOFF, KSM, KTOP, KTP(256), KTYP, L, LDUMMY, LOFF, LSM, LTP(256), LTYP, NDXTP, NI, &
                     NIBTC, NIK, NJ, NJL, NK, NKBTC, NL, NONEW, NPART, NPARTSZ
real(kind=wp) :: FACTOR

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ================='
write(u6,*) ' GSBBD2A in action'
write(u6,*) ' ================='
write(u6,*)
write(u6,*) ' Occupation of active left strings'
call IWRTMA(ISEL,1,NGAS,1,NGAS)
write(u6,*) ' Occupation of active Right strings'
call IWRTMA(ICEL,1,NGAS,1,NGAS)
#endif

IFRST = 1
JFRST = 1

!SVC: determine optimum number of partitions as the lowest multiple of
!     NPROCS that satisfies a block size smaller than MAXI:
NPART = 0
do
  NPART = NPART+NPROCS
  NPARTSZ = max(NROW-1,0)/NPART+1
  if (NPARTSZ <= MAXI) exit
end do

! Type of single excitations that connects the two column strings
call DXTYP_GAS(NDXTP,ITP,JTP,KTP,LTP,NGAS,ISEL,ICEL)
! Symmetry of Double excitation that connects IBSM and JBSM
IDXSM = Mul(ISCSM,ICCSM)
if (IDXSM /= 0) then
# ifdef _DEBUGPRINT_
  write(u6,*) ' ISCSM,ICCSM ',ISCSM,ICCSM
# endif
  do IDXTP=1,NDXTP
    ITYP = ITP(IDXTP)
    JTYP = JTP(IDXTP)
    KTYP = KTP(IDXTP)
    LTYP = LTP(IDXTP)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' ITYP JTYP KTYP LTYP ',ITYP,JTYP,KTYP,LTYP
#   endif
    do IKOBSM=1,NSMOB
      JLOBSM = Mul(IKOBSM,IDXSM)
      if (JLOBSM == 0) cycle
      ! types + symmetries defined => K strings are defined
      KFRST = 1
      ! Loop over of symmetry of i orbitals
      do ISM=1,NSMOB
        KSM = Mul(ISM,IKOBSM)
        NI = NOBPTS(ITYP,ISM)
        NK = NOBPTS(KTYP,KSM)
        if ((NI == 0) .or. (NK == 0)) cycle
        ! Loop over batches of j orbitals
        outer: do JSM=1,NSMOB
          LSM = Mul(JSM,JLOBSM)
          NJ = NOBPTS(JTYP,JSM)
          NL = NOBPTS(LTYP,LSM)
          if ((NJ == 0) .or. (NL == 0)) cycle outer

          IOFF = IOBPTS(ITYP,ISM)
          JOFF = IOBPTS(JTYP,JSM)
          KOFF = IOBPTS(KTYP,KSM)
          LOFF = IOBPTS(LTYP,LSM)

          if ((IOFF < KOFF) .or. (JOFF < LOFF)) cycle outer

          ! ============================================================
          !                  Use N-2 projection method
          ! ============================================================

          IFIRST = 1
          ! Loop over batches of I strings
          X(1:NI*NJ*NK*NL) = Zero
          do IIPART=1+MYRANK,NPART,NPROCS
            IBOT = 1+(IIPART-1)*NPARTSZ
            ITOP = min(IBOT+NPARTSZ-1,NROW)
            NIBTC = ITOP-IBOT+1
            if (NIBTC <= 0) exit
            ! Loop over batches of intermediate strings
            KBOT = 1-MAXK
            KTOP = 0
            do
              KBOT = KBOT+MAXK
              KTOP = KTOP+MAXK

              ! =======================================================
              !
              ! obtain cb(KB,IA,jl) = sum(JB)<KB!a lb a jb !IB>C(IA,JB)
              !
              ! =======================================================

              JLBOFF = 1
              if ((JSM == LSM) .and. (JTYP == LTYP)) then
                NJL = nTri_Elem(NJ)
                JLSM = 1
              else
                NJL = NJ*NL
                JLSM = 0
              end if
              ! Obtain all double excitations from this group of K strings
              II12 = 1
              K12 = 1
              call ADADST_GAS(1,JSM,JTYP,NJ,1,LSM,LTYP,NL,ICCTP,ICCSM,IGRP,KBOT,KTOP,I1,XI1S,MAXK,NKBTC,KEND,JFRST,KFRST,II12,K12, &
                              SCLFAC)

              JFRST = 0
              KFRST = 0

              if (NKBTC == 0) cycle outer
              ! Loop over jl in TS classes
              J = 0
              L = 1

              do IJL=1,NJL
                call NXTIJ(J,L,NJ,NL,JLSM,NONEW)
                I1JL = (L-1)*NJ+J
                ! JAN28
                if (JLSM /= 0) then
                  IJLE = nTri_Elem(J-1)+L
                else
                  IJLE = IJL
                end if
                ! JAN28
                ! CB(IA,KB,jl) = +/-C(IA,a+la+jIA)
                !JLOFF = (JLBOFF-1+IJL-1)*NKBTC*NIBTC+1
                JLOFF = (JLBOFF-1+IJLE-1)*NKBTC*NIBTC+1
                if ((JLSM == 1) .and. (J == L)) then
                  ! a+j a+j gives trivially zero
                  CSCR(JLOFF:JLOFF+NKBTC*NIBTC-1) = Zero
                else
                  call MATCG(CB,CSCR(JLOFF),NROW,NIBTC,IBOT,NKBTC,I1(:,I1JL),XI1S(:,I1JL))
                end if
              end do

              ! =======================================================
              !
              ! obtain sb(KB,IA,ik) = sum(IB)<KB!a kb a ib !IB>S(IA,IB)
              !
              ! =======================================================

              IKBOFF = 1
              if ((ISM == KSM) .and. (ITYP == KTYP)) then
                NIK = nTri_Elem(NI)
                IKSM = 1
              else
                NIK = NI*NK
                IKSM = 0
              end if
              ! Obtain all double excitations from this group of K strings
              II12 = 2
              K12 = 1
              if (IFRST == 1) KFRST = 1
              call ADADST_GAS(1,ISM,ITYP,NI,1,KSM,KTYP,NK,ISCTP,ISCSM,IGRP,KBOT,KTOP,I1,XI1S,MAXK,NKBTC,KEND,IFRST,KFRST,II12,K12, &
                              One)

              IFRST = 0
              KFRST = 0

              if (NKBTC == 0) cycle outer
              ! Loop over jl in TS classes
              I = 0
              K = 1

              do IIK=1,NIK
                call NXTIJ(I,K,NI,NK,IKSM,NONEW)
                I1IK = (K-1)*NI+I
                ! JAN28
                if (IKSM /= 0) then
                  IIKE = nTri_Elem(I-1)+K
                else
                  IIKE = IIK
                end if
                ! JAN28
                ! SB(IA,KB,ik) = +/-S(IA,a+ka+iIA)
                !IKOFF = (IKBOFF-1+IIK-1)*NKBTC*NIBTC+1
                IKOFF = (IKBOFF-1+IIKE-1)*NKBTC*NIBTC+1
                if ((IKSM == 1) .and. (I == K)) then
                  ! a+j a+j gives trivially zero
                  SSCR(IKOFF:IKOFF+NKBTC*NIBTC-1) = Zero
                else
                  call MATCG(SB,SSCR(IKOFF),NROW,NIBTC,IBOT,NKBTC,I1(:,I1IK),XI1S(:,I1IK))
                end if
              end do

              ! ==================================================================
              !
              ! RHO2C(ik,jl)  = RHO2C(ik,jl) - sum(Ia,Kb)SB(Ia,Kb,ik)*CB(Ia,Kb,jl)
              !
              ! ==================================================================

              ! The minus ??
              !
              ! Well, the density matrices are constructed as
              !
              ! <I!a+i a+k aj al!> = -sum(K) <I!a+ia+k!K><J!aj al!K>, and
              ! the latter matrices are the ones we are constructing

              IOFF = IOBPTS(ITYP,ISM)
              JOFF = IOBPTS(JTYP,JSM)
              KOFF = IOBPTS(KTYP,KSM)
              LOFF = IOBPTS(LTYP,LSM)
              LDUMMY = NKBTC*NIBTC
#             ifdef _DEBUGPRINT_
              write(u6,*) ' CSCR matrix'
              call WRTMAT(CSCR,LDUMMY,NJL,LDUMMY,NJL)
              write(u6,*) ' SSCR matrix'
              call WRTMAT(SSCR,LDUMMY,NIK,LDUMMY,NIK)
#             endif

              if (IFIRST == 1) then
                FACTOR = Zero
              else
                FACTOR = One
              end if
              LDUMMY = NKBTC*NIBTC
              !    MATML7(C,A,B,NCROW,NCCOL,NAROW,NACOL,NBROW,NBCOL,FACTORC,FACTORAB,ITRNSP)
              call MATML7(X,SSCR,CSCR,NIK,NJL,LDUMMY,NIK,LDUMMY,NJL,FACTOR,-One,1)
              IFIRST = 0
#             ifdef _DEBUGPRINT_
              write(u6,*) ' Updated X matrix IK,JL,IK,JL',NIK,NJL,NIK,NJL
              call WRTMAT(X,NIK,NJL,NIK,NJL)
#             endif

              if (KEND /= 0) exit
            end do
            ! End of loop over partitionings of resolution strings
          end do
          ! Rho2(ik,jl) has been constructed for ik,jl belonging to
          ! Scatter out to density matrix
          IOFF = IOBPTS(ITYP,ISM)
          JOFF = IOBPTS(JTYP,JSM)
          KOFF = IOBPTS(KTYP,KSM)
          LOFF = IOBPTS(LTYP,LSM)
          !write(u6,*) 'I, J, K, L offsets & IPACK :',IOFF,JOFF,KOFF,LOFF,Ipack
          call ADTOR2(RHO2,RHO2S,RHO2A,X,1,NI,IOFF,NJ,JOFF,NK,KOFF,NL,LOFF,NACOB,IPACK)
          !    ADTOR2(RHO2,RHO2T,ITYPE,NI,IOFF,NJ,JOFF,NK,KOFF,NL,LOFF,NORB)

          !write(u6,*) ' updated density matrix A',' norb = 4 ',norb
          !write(u6,*) ' offset ','IOFF,JOFF,KOFF,LOFF',IOFF,JOFF,KOFF,LOFF
          !call prsym(rho2s,nTri_Elem(NORB))

        end do outer
      end do
    end do
  end do
end if

end subroutine GSBBD2A

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine molden_cvb()
      implicit real*8 (a-h,o-z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "rctfld.fh"

      dimension Dummy(1)

      call daname_cvb(JOBIPH,'JOBIPH')
      idisk=0
      call idafile(JOBIPH,2,iadr15,15,idisk)
      Dummy = 0.0D0
      if(.not.lRf) call interf(0,Dummy,0,1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*      Subroutine ContRASBas(nBas,nStatePrim,iNonH,iNonS,Eigis)
      Subroutine ContRASBas(nBas,nStatePrim,iNonH,iNonS,iEig2)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qm2.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension nBas(MxSym)!,Eigis(MxState,MxState)

*
*--- Hi y'all
*
      Write(6,*)'     ----- Constructing CASSI eigenstates.'

*
*--- Diagonalize overlap matrix.
*
      Call GetMem('EigV1','Allo','Real',iEig1,nStatePrim**2)
      kaunter=0
      Do 1, i=1,nStatePrim
        Do 2, j=1,nStatePrim
          If(i.eq.j) then
            Work(iEig1+kaunter)=ONE
          Else
            Work(iEig1+kaunter)=ZERO
          Endif
          kaunter=kaunter+1
2       Continue
1     Continue
      Call Jacob(Work(iNonS),Work(iEig1),nStatePrim,nStatePrim)
      If(iPrint.ge.15) then
        Call TriPrt('Diagonal RASSCF overlap matrix',' '
     &             ,Work(iNonS),nStatePrim)
      Endif

*
*--- Construct TS^(-1/2) for canonical orthogonalization.
*
      ii=0
      Do 4, i=1,nStatePrim
        ii=ii+i
        x=1.0D00/Sqrt(Max(1.0D-14,Work(iNonS-1+ii)))
        Do 5, k=1,nStatePrim
          ind=k+nStatePrim*(i-1)-1
          Work(iEig1+ind)=x*Work(iEig1+ind)
5       Continue
4     Continue

*
*--- Make reductions if requested.
*
      Call GetMem('RedEigV1','Allo','Real',iEig2,nStatePrim**2)
      iT=0
      If(ContrStateB) then
        Do 61, iS=1,nStatePrim
          kaunt=iS*(iS+1)/2-1
          sss=Work(iNonS+kaunt)
          If(sss.gt.ThrsCont) then
            iT=iT+1
            call dcopy_(nStatePrim,Work(iEig1+nStatePrim*(iS-1)),iONE
     &                ,Work(iEig2+nStatePrim*(iT-1)),iONE)
          Endif
61      Continue
        nStateRed=iT
        Write(6,6199)'  ----- Contraction:',nStatePrim,' ---> '
     &                                     ,nStateRed
6199    Format(A,I3,A,I3)
      Else
        call dcopy_(nStatePrim**2,Work(iEig1),iONE,Work(iEig2),iONE)
        nStateRed=nStatePrim
      Endif

*
*--- Transform H and diagonalize in the original basis.
*
      nTri=nStateRed*(nStateRed+1)/2
      Call GetMem('TEMP','Allo','Real',iTEMP,nStatePrim**2)
      Call GetMem('SqH','Allo','Real',iSqH,nStatePrim**2)
      Call GetMem('RedHSq','Allo','Real',iRedHSq,nStateRed**2)
      Call GetMem('RedHTr','Allo','Real',iRedHTr,nTri)
      Call Square(Work(iNonH),Work(iSqH),iONE,nStatePrim,nStatePrim)
      Call Dgemm_('N','N',nStatePrim,nStateRed,nStatePrim,ONE,Work(iSqH)
     &          ,nStatePrim,Work(iEig2),nStatePrim,ZERO,Work(iTEMP)
     &          ,nStatePrim)
      Call Dgemm_('T','N',nStateRed,nStateRed,nStatePrim,ONE,Work(iEig2)
     &          ,nStatePrim,Work(iTEMP),nStatePrim,ZERO,Work(iRedHSq)
     &          ,nStateRed)
      Call SqToTri_Q(Work(iRedHSq),Work(iRedHTr),nStateRed)
      Call Jacob(Work(iRedHTr),Work(iEig2),nStateRed,nStatePrim)
      Call JacOrd(Work(iRedHTr),Work(iEig2),nStateRed,nStatePrim)

*
*--- At this stage we have eigenvectors to the CASSI states and their
*    eigenenergies, hence time to construct the first H_0 and store the
*    eigenvectors for subsequent transformations.
*
      kaunter=0
      nLvlInd=1
      Do 55, iState=1,nStateRed
        Do 56, jState=1,iState
          kaunter=kaunter+1
          HMatState(kaunter)=ZERO
56      Continue
        HMatState(kaunter)=Work(iRedHTr+kaunter-1)
*---- If requested, introduce level-shift of states.
        If(nLvlShift.ne.0) then
          If(iState.eq.iLvlShift(nLvlInd)) then
            HMatState(kaunter)=HMatState(kaunter)+dLvlShift(nLvlInd)
            nLvlInd=nLvlInd+1
          Endif
        Endif
55    Continue

*
*--- Print.
*
      If(iPrint.ge.10) then
        Call TriPrt('RASSI Hamiltonian',' ',HMatState,nStateRed)
        Write(6,*)
        Call RecPrt('RASSI eigenvectors',' ',Work(iEig2),nStatePrim
     &             ,nStateRed)
      Endif

*
*--- Deallocate.
*
      Call GetMem('EigV1','Free','Real',iEig1,nStatePrim**2)
      Call GetMem('TEMP','Free','Real',iTEMP,nStatePrim**2)
      Call GetMem('SqH','Free','Real',iSqH,nStatePrim**2)
      Call GetMem('RedHSq','Free','Real',iRedHSq,nStateRed**2)
      Call GetMem('RedHTr','Free','Real',iRedHTr,nTri)

*
*--- OBSERVE! CAUTION! ATTENTION! The variable nState is defined.
*
      nState=nStateRed

*
*--- No parasan!
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(nBas)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ijkl_inc(i,j,k,l)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: i, j, k, l

l = l+1
if (((i == k) .and. (l > j)) .or. ((i /= k) .and. (l > k))) then
  l = 1
  k = k+1
  if (k > i) then
    k = 1
    j = j+1
    if (j > i) then
      j = 1
      i = i+1
    end if
  end if
end if

return

end subroutine ijkl_inc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkp1(nEX,lst,rMat,rdiag)

use Index_Functions, only: iTri
use MCLR_Data, only: LuCIV, P1
use input_mclr, only: ERASSCF, lRoots, nConf
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nEX, lst(nex)
real(kind=wp), intent(in) :: rMat(*), rdiag(*)
integer(kind=iwp) :: i, idisk, j, jDisk, k, kk, l
real(kind=wp) :: rtmp
real(kind=wp), allocatable :: Tmp1(:), Tmp2(:)

call mma_allocate(TMP1,nconf,Label='Tmp1')
call mma_allocate(TMP2,nconf,Label='Tmp2')

idisk = 0
do i=1,lroots
  call dDaFile(LuCIV,2,Tmp1,nconf,iDisk)
  jdisk = 0
  do j=1,i
    call dDafile(luciv,2,Tmp2,nconf,jDisk)
    rTmp = Zero
    do k=1,nex
      do l=1,nex
        rtmp = rtmp+Tmp1(lst(k))*Tmp2(lst(l))*rmat(iTri(k,l))
      end do
    end do
    do k=1,nconf
      rtmp = rtmp+Tmp1(k)*Tmp2(k)*rdiag(k)
    end do
    if (i == j) rtmp = rtmp-ERASSCF(1)
    do k=1,nEx
      kk = lst(k)
      rtmp = rtmp-Tmp1(kk)*Tmp2(kk)*(rdiag(kk+1)-ERASSCF(1))
    end do
    P1(iTri(i,j)) = rtmp
  end do
end do

call mma_deallocate(TMP2)
call mma_deallocate(TMP1)

end subroutine mkp1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
      SubRoutine MulPop(CMO,mBB,nD,Ovrlp,mBT,OccNo,mmB)
************************************************************************
*                                                                      *
* This routine is a wrapper for Charge (which prints Mulliken popu-    *
* lation analyzes) since charge needs square CMO matrices.             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund UNiversity, Sweden                                     *
*                                                                      *
************************************************************************
      Implicit None
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
      Integer mBB, nD, mBT, mmB
      Real*8 CMO(mBB,nD), Ovrlp(mBT), OccNo(mmB,nD)
************************************************************************
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Integer iSym
      Logical isOK
      Real*8, Dimension(:), Allocatable:: Aux1, Aux2
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      isOK=.true.
      Do iSym=1,nSym
         isOK=isOK .and. nBas(iSym).eq.nOrb(iSym)
      End Do
      If(isOK) Then
         If(iUHF.eq.0) Then
            Call Charge(nSym,nBas,Name,CMO(1,1),OccNo(1,1),
     &                  Ovrlp,2,.false.,.false.)
         Else
            Call Charge(nSym,nBas,Name,CMO(1,1),OccNo(1,1),
     &                  Ovrlp,0,.false.,.false.)
            Call Charge(nSym,nBas,Name,CMO(1,2),OccNo(1,2),
     &                  Ovrlp,1,.false.,.false.)
         End If
      Else
         Call mma_allocate(Aux1,nBB,Label='Aux1')
         Call mma_allocate(Aux2,nnB,Label='Aux2')
         If(iUHF.eq.0) Then
            Call PadCMO(CMO(1,1),Aux1,nSym,nBas,nOrb)
            Call PadEor(OccNo(1,1),Aux2,nSym,nBas,nOrb)
            Call Charge(nSym,nBas,Name,Aux1,Aux2,
     &                  Ovrlp,2,.false.,.false.)
         Else
            Call PadCMO(CMO(1,1),Aux1,nSym,nBas,nOrb)
            Call PadEor(OccNo(1,1),Aux2,nSym,nBas,nOrb)
            Call Charge(nSym,nBas,Name,Aux1,Aux2,
     &                  Ovrlp,0,.false.,.false.)
            Call PadCMO(CMO(1,2),Aux1,nSym,nBas,nOrb)
            Call PadEor(OccNo(1,2),Aux2,nSym,nBas,nOrb)
            Call Charge(nSym,nBas,Name,Aux1,Aux2,
     &                  Ovrlp,1,.false.,.false.)
         End If
         Call mma_deallocate(Aux1)
         Call mma_deallocate(Aux2)
      End If
*----------------------------------------------------------------------*
* Done                                                                 *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CIO_ReadC_WithLinDep(iAtomPair,C,l_C)
      Implicit None
      Integer iAtomPair
      Integer l_C
      Real*8  C(l_C)
      Call LDF_CIO_ReadC_wLD(iAtomPair,C,l_C)
      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CIO_ReadC_wLD(iAtomPair,C,l_C)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Read LDF fitting coefficients for atom pair iAtomPair.
C              The coefficients are read from memory (buffer) if
C              possible (though the caller need not worry about that).
C              Columns of C corresponding to linearly dependent
C              auxiliary (one-center) functions are included and contain
C              zeros. For reading without linearly dependent columns,
C              use LDF_CIO_ReadC.
C
C     NOTE: this routine may require memory corresponding to at least 1
C           column of the coefficient matrix.
C
      Implicit None
      Integer iAtomPair
      Integer l_C
      Real*8  C(l_C)
#include "WrkSpc.fh"
#include "ldf_cio.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_bas.fh"

      Logical  LDF_isLinDep
      External LDF_isLinDep

      Integer  LDF_nBas_Atom
      Integer  LDF_nBasAux_Pair
      Integer  LDF_nBasAux_Pair_WithLinDep
      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nBas_Atom
      External LDF_nBasAux_Pair
      External LDF_nBasAux_Pair_WithLinDep
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom

      Integer iAddr
      Integer iAtom, jAtom
      Integer l, l_WithLinDep, l_WithoutLinDep
      Integer ii, iS, ipi
      Integer jj, jS, ipj
      Integer ipC
      Integer ip_Scr, l_Scr

      Integer i, j
      Integer nBasSh
      Integer AP_DiskC
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_DiskC(i)=iWork(ip_AP_DiskC-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      If (Lu_LDFC.lt.1) Then
         Call WarningMessage(2,'LDF_CIO_ReadC_wLD: Lu_LDFC<1')
         Call LDF_Quit(1)
      End If

      If (AP_1CLinDep(1,iAtomPair).eq.0) Then
         ! Use LDF_CIO_ReadC if no linear dependence
         Call LDF_CIO_ReadC(iAtomPair,C,l_C)
         Return
      Else If (AP_1CLinDep(1,iAtomPair).lt.0) Then
         ! This would be bug....
         Call WarningMessage(2,
     &         'LDF_CIO_ReadC_wLD: AP_1CLinDep<0 !?!')
         Call LDF_Quit(1)
      Else
         ! lin dep columns are returned as zero vectors
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         l=LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
         l_WithLinDep=l*LDF_nBasAux_Pair_WithLinDep(iAtomPair)
         If (l_WithLinDep.gt.l_C) Then
            Call WarningMessage(2,
     &         'LDF_CIO_ReadC_wLD: insufficient array dimension')
            Call LDF_Quit(1)
         End If
         If (iAtomPair.gt.LastAtomPair) Then ! read from disk
            Call GetMem('GetMax','Max ','Real',ip_Scr,l_Scr)
            l_WithoutLinDep=l*LDF_nBasAux_Pair(iAtomPair)
            If (l_Scr.ge.l_WithoutLinDep) Then ! read full C
               l_Scr=l_WithoutLinDep
               Call GetMem('RdCScr1','Allo','Real',ip_Scr,l_Scr)
               Call LDF_CIO_ReadC(iAtomPair,Work(ip_Scr),l_Scr)
               iAddr=ip_Scr
               ipC=1
               ipi=LDF_lAuxShell_Atom(iAtom)-1
               Do iS=1,LDF_nAuxShell_Atom(iAtom)
                  Do ii=1,nBasSh(iWork(ipi+iS))
                     If (LDF_isLinDep(ii,iS,iAtom,iAtomPair)) Then
                        Call FZero(C(ipC),l)
                     Else
                        Call dCopy_(l,Work(iAddr),1,C(ipC),1)
                        iAddr=iAddr+l
                     End If
                     ipC=ipC+l
                  End Do
               End Do
               If (jAtom.ne.iAtom) Then
                  ipj=LDF_lAuxShell_Atom(jAtom)-1
                  Do jS=1,LDF_nAuxShell_Atom(jAtom)
                     Do jj=1,nBasSh(iWork(ipj+jS))
                        If (LDF_isLinDep(jj,jS,jAtom,iAtomPair)) Then
                           Call FZero(C(ipC),l)
                        Else
                           Call dCopy_(l,Work(iAddr),1,C(ipC),1)
                           iAddr=iAddr+l
                        End If
                        ipC=ipC+l
                     End Do
                  End Do
               End If
               If (AP_2CFunctions(1,iAtomPair).gt.0) Then
                  Call dCopy_(l*AP_2CFunctions(1,iAtomPair),
     &                       Work(iAddr),1,C(ipC),1)
               End If
               Call GetMem('RdCScr1','Free','Real',ip_Scr,l_Scr)
           Else ! read 1 column of C at a time
               If (l_Scr.lt.l) Then
                  Call WarningMessage(2,
     &                 'LDF_CIO_ReadC_wLD: Insufficient memory!')
                  Call LDF_Quit(1)
               End If
               l_Scr=l
               Call GetMem('RdCScr2','Allo','Real',ip_Scr,l_Scr)
               iAddr=AP_DiskC(iAtomPair)
               ipC=1
               ipi=LDF_lAuxShell_Atom(iAtom)-1
               Do iS=1,LDF_nAuxShell_Atom(iAtom)
                  Do ii=1,nBasSh(iWork(ipi+iS))
                     If (LDF_isLinDep(ii,iS,iAtom,iAtomPair)) Then
                        Call FZero(C(ipC),l)
                     Else
                        Call dDAFile(Lu_LDFC,2,Work(ip_Scr),l,iAddr)
                        Call dCopy_(l,Work(ip_Scr),1,C(ipC),1)
                     End If
                     ipC=ipC+l
                  End Do
               End Do
               If (jAtom.ne.iAtom) Then
                  ipj=LDF_lAuxShell_Atom(jAtom)-1
                  Do jS=1,LDF_nAuxShell_Atom(jAtom)
                     Do jj=1,nBasSh(iWork(ipj+jS))
                        If (LDF_isLinDep(jj,jS,jAtom,iAtomPair)) Then
                           Call FZero(C(ipC),l)
                        Else
                           Call dDAFile(Lu_LDFC,2,Work(ip_Scr),l,iAddr)
                           Call dCopy_(l,Work(ip_Scr),1,C(ipC),1)
                        End If
                        ipC=ipC+l
                     End Do
                  End Do
               End If
               If (AP_2CFunctions(1,iAtomPair).gt.0) Then
                  Call dDAFile(Lu_LDFC,2,
     &                         C(ipC),l*AP_2CFunctions(1,iAtomPair),
     &                         iAddr)
               End If
               Call GetMem('RdCScr2','Free','Real',ip_Scr,l_Scr)
           End If
         Else ! copy from buffer
            iAddr=iWork(ip_LDFC_Blocks-1+iAtomPair)
            ipC=1
            ipi=LDF_lAuxShell_Atom(iAtom)-1
            Do iS=1,LDF_nAuxShell_Atom(iAtom)
               Do ii=1,nBasSh(iWork(ipi+iS))
                  If (LDF_isLinDep(ii,iS,iAtom,iAtomPair)) Then
                     Call FZero(C(ipC),l)
                  Else
                     Call dCopy_(l,Work(iAddr),1,C(ipC),1)
                     iAddr=iAddr+l
                  End If
                  ipC=ipC+l
               End Do
            End Do
            If (jAtom.ne.iAtom) Then
               ipj=LDF_lAuxShell_Atom(jAtom)-1
               Do jS=1,LDF_nAuxShell_Atom(jAtom)
                  Do jj=1,nBasSh(iWork(ipj+jS))
                     If (LDF_isLinDep(jj,jS,jAtom,iAtomPair)) Then
                        Call FZero(C(ipC),l)
                     Else
                        Call dCopy_(l,Work(iAddr),1,C(ipC),1)
                        iAddr=iAddr+l
                     End If
                     ipC=ipC+l
                  End Do
               End Do
            End If
            If (AP_2CFunctions(1,iAtomPair).gt.0) Then
               Call dCopy_(l*AP_2CFunctions(1,iAtomPair),
     &                    Work(iAddr),1,C(ipC),1)
            End If
         End If
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MMSort(A,B,ldisp1)
      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "disp_mclr.fh"
      Real*8 A(*),B(*)
      integer ldisp1(nsym)
      logical geomi,geomj
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      ijG=0
      ijD=0
      iii=0
      Call icopy(nsym,[0],0,ldisp1,1)
      Do iSym=1,nsym
       iG=0
       Do idisp=1,ldisp(isym)
        geomi=iand(ntpert(iii+idisp),16).eq.16
        if (geomi) Then
         ldisp1(isym)=ldisp1(isym)+1
         iG=iG+1
         jG=0
         Do jdisp=1,idisp
          geomj=iand(ntpert(jdisp+iii),16).eq.16
          if (geomj) Then
           jG=jG+1
           ijg1=ijG+itri(ig,jg)
           ijd1=ijD+itri(idisp,jdisp)
           B(ijG1)=A(ijD1)
          End If
         End do
        End If
       End do
       ijG=ijG+iG*(iG+1)/2
       ijD=ijD+ldisp(isym)*(ldisp(isym)+1)/2
       iii=iii+ldisp(isym)
      End do
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Temperatures

! Default temperatures for thermochemistry (MCLR, SLAPAF)

use Constants, only: Zero
use Definitions, only: wp

implicit none
private

real(kind=wp), parameter :: DefTemp(7) = [Zero,100.0_wp,273.15_wp,298.15_wp,323.15_wp,373.15_wp,473.15_wp]

public :: DefTemp

end module Temperatures

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Markus P. Fuelscher                              *
!***********************************************************************
! RecPrt
!
!> @brief
!>   Write out a matrix on standard output
!> @author M. P. F&uuml;lscher, Lund, 1992
!>
!> @details
!> The matrix \p A of dimension \p nRow &times; \p nCol is printed
!> in output preceded by the character line \p Title. Format of the numerical
!> output is given by \p FmtIn. If \p FmtIn = ``''`` the utility will decide on format
!> for optimal output.
!>
!> @param[in] Title   Title card
!> @param[in] FmtIn   Format statement
!> @param[in] A       A matrix
!> @param[in] nRow    number of rows of \p A
!> @param[in] nCol    number of columns of \p A
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RecPrt(Title,FmtIn,A,nRow,nCol)

use Spool, only: LuWr
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: Title, FmtIn
integer(kind=iwp), intent(in) :: nRow, nCol
real(kind=wp), intent(in) :: A(nRow,nCol)
integer(kind=iwp), parameter :: lMaxTitle = 60, lPaper = 120
integer(kind=iwp) :: i, iPmax, iPmin, j, lFmt, lItem, lLeft, lLine, lNumbr, lTitle, nCols, nDecim, nDigit
real(kind=wp) :: Amax, Amin, Pmax, Pmin
character(len=lMaxTitle) :: Line
character(len=20) :: FRMT

!----------------------------------------------------------------------*
if (nRow*nCol == 0) return
#ifdef _DEBUGPRINT_
call TrcPrt(Title,FmtIn,A,nRow,nCol)
return
#endif
!----------------------------------------------------------------------*
! print the title                                                      *
!----------------------------------------------------------------------*
lTitle = len_trim(Title)
if (lTitle > 0) then
  Line = ''
  lLeft = 1
  do i=1,lTitle
    if (Title(i:i) /= ' ') then
      lLeft = i-1
      exit
    end if
  end do
  do i=1,lMaxTitle
    if (i+lLeft <= lTitle) Line(i:i) = Title(i+lLeft:i+lLeft)
  end do
  write(LuWr,*)
  write(LuWr,'(2X,A)') Line
  !do i=1,len_trim(Line)
  !  Line(i:i) = '-'
  !end do
  !write(LuWr,'(2X,A)') Line
  write(LuWr,'(2X,A,I5,A,I5)') 'mat. size = ',nRow,'x',nCol
end if
!----------------------------------------------------------------------*
! determine the printing format                                        *
!----------------------------------------------------------------------*
lFmt = len_trim(FmtIn)
if (lFmt /= 0) then
  FRMT = FmtIn
else
  Amax = -huge(Amax)
  Amin = huge(Amin)
  do j=1,nCol
    do i=1,nRow
      Amax = max(Amax,A(i,j))
      Amin = min(Amin,A(i,j))
    end do
  end do
  Pmax = Zero
  if (abs(Amax) > 1.0e-72_wp) Pmax = log10(abs(Amax))
  iPmax = 1+int(Pmax)
  iPmax = max(1,iPmax)
  Pmin = Zero
  if (abs(Amin) > 1.0e-72_wp) Pmin = log10(abs(Amin))
  iPmin = 1+int(Pmin)
  iPmin = max(1,iPmin)
  nDigit = 24
  nDecim = min(16,nDigit-max(iPmin,iPmax))
  nDecim = max(nDecim,1)
  if (Amax < Zero) iPmax = iPmax+1
  if (Amin < Zero) iPmin = iPmin+1
  lNumbr = max(iPmin,iPmax)+nDecim+2
  nCols = 9
  lLine = nCols*lNumbr
  if (lLine > lPaper) then
    if ((lLine <= lPaper+nCols) .and. (nDecim > 1)) then
      nDecim = nDecim-1
      lNumbr = max(iPmin,iPmax)+nDecim
      lItem = max(lNumbr,lPaper/nCols)
    else
      nCols = 5
      lItem = max(lNumbr,lPaper/nCols)
    end if
  else
    lItem = lNumbr
  end if
  write(FRMT,'(A,I4.4,A,I4.4,A,I4.4,A)') '(2X,',nCols,'F',lItem,'.',nDecim,')'
end if
!----------------------------------------------------------------------*
! print the data                                                       *
!----------------------------------------------------------------------*
!write(LuWr,*)
do i=1,nRow
  write(LuWr,FRMT) A(i,1:nCol)
end do
call xFlush(LuWr)

!----------------------------------------------------------------------*
! End procedure                                                        *
!----------------------------------------------------------------------*
return

end subroutine RecPrt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_Decom_A4(Diag,LstQSP,NumSP,iPass)
C
C     Purpose: decompose qualified columns ("parallel" algorithm).
C
      use ChoArr, only: LQ_Tot, LQ
      use ChoVecBuf, only: nVec_in_Buf

      Implicit Real*8 (a-h,o-z)
      Real*8  Diag(*)
      Integer LstQSP(NumSP)
#include "cholesky.fh"
#include "choprint.fh"
#include "stdalloc.fh"

      Character(LEN=12), Parameter:: SecNam = 'Cho_Decom_A4'

      Integer NumCho_Old(8), nQual_Old(8)
      Integer NumV(8), nkVec(8)

      Real*8, Allocatable:: KVScr(:), MQ(:), KVec(:), QDiag(:), xInt(:),
     &                      Wrk1(:)
      Integer, Allocatable:: IDKVec(:), iQScr(:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      SubRoutine Cho_P_GetLQ(QVec,l_QVec,LstQSP,nQSP)
      Integer l_QVec, nQSP
      Real*8, Target::  QVec(l_Qvec)
      Integer LstQSP(nQSP)
      End SubRoutine Cho_P_GetLQ
      End Interface
*                                                                      *
************************************************************************
*                                                                      *

C     Print header.
C     -------------

      LenLin = 0
      If (iPrint .ge. Inf_Progress) Then
         Call Cho_Head(SecNam//
     &                 ': Decomposition of Qualified Diagonals','=',
     &                 80,LUPRI)
         Write(Lupri,'(/,A,I5,A,I4,A)')
     &   'Integral pass number',iPass,' (',NumSP,
     &   ' shell pair distributions calculated)'
         Write(Lupri,'(A,8I8)')
     &   '#Cholesky vec.: ',(NumCho(iSym),iSym=1,nSym)
         Write(Lupri,'(A,8I8)')
     &   '#vec. in buff.: ',(nVec_in_Buf(iSym),iSym=1,nSym)
         Write(Lupri,'(A,8I8)')
     &   '#qualified    : ',(nQual(iSym),iSym=1,nSym)
         Write(Lupri,'(A,8I8)')
     &   'Current  dim. : ',(nnBstr(iSym,2),iSym=1,nSym)
         Write(Lupri,'(A,8I8)')
     &   'Original dim. : ',(nnBstr(iSym,1),iSym=1,nSym)
         Write(Lupri,'(/,A,/,A,A)')
     &   '           #Vectors             Treated Diagonal',
     &   'Sym.     Sym.     Total     Index     Before      After',
     &   '   Conv. Neg.   New Max'
         LenLin = 79
         Write(Lupri,'(80A)') ('-',I=1,LenLin)
         Call Cho_Flush(Lupri)
         Call iCopy(nSym,NumCho,1,NumCho_Old,1)
      Else If (iPrint .ge. Inf_Pass) Then
         Write(Lupri,'(/,A,I4)')
     &   'Number of shell pair distributions calculated:',NumSP
         Write(Lupri,'(A,8I8)')
     &   '#Cholesky vec.: ',(NumCho(iSym),iSym=1,nSym)
         Write(Lupri,'(A,8I8)')
     &   '#vec. in buff.: ',(nVec_in_Buf(iSym),iSym=1,nSym)
         Write(Lupri,'(A,8I8)')
     &   '#qualified    : ',(nQual(iSym),iSym=1,nSym)
         Call Cho_Flush(Lupri)
         Call iCopy(nSym,NumCho,1,NumCho_Old,1)
      End If

C     Allocations.
C     ------------

      Call Cho_P_GetGV(numV,nSym)

      l_KVec = nQual(1)**2
      l_IDKVec = nQual(1)
      l_LQ = nQual(1)*NumV(1)
      Do iSym = 2,nSym
         l_KVec = l_KVec + nQual(iSym)**2
         l_IDKVec = l_IDKVec + nQual(iSym)
         l_LQ = l_LQ + nQual(iSym)*NumV(iSym)
      End Do
      l_LQ = max(l_LQ,1) ! because there might not be any prev. vecs.
      Call mma_allocate(KVec,l_KVec,Label='KVec')
      Call mma_allocate(IDKVec,l_IDKVec,Label='IDKVec')
      Call mma_allocate(QDiag,l_IDKVec,Label='QDiag')

C     Extract elements corresponding to qualified diagonals from
C     previous Cholesky vectors (if any).
C     ----------------------------------------------------------

      Call Cho_Timer(C1,W1)
      Call mma_allocate(LQ_Tot,l_LQ,Label='LQ_Tot')

      iEn = 0
      iSt = 1
      Do iSym = 1,nSym
         If (nQual(iSym)*NumV(iSym)>0) Then
            iEn = iEn + nQual(iSym)*NumV(iSym)
            LQ(iSym)%Array(1:nQual(iSym),1:NumV(iSym)) =>
     &                LQ_Tot(iSt:iEn)
            iSt = iEn + 1
         Else
            LQ(iSym)%Array => Null()
         End If
      End Do

      Call Cho_P_GetLQ(LQ_Tot,l_LQ,LstQSP,NumSP)
      Call Cho_Timer(C2,W2)
      tDecom(1,2) = tDecom(1,2) + C2 - C1
      tDecom(2,2) = tDecom(2,2) + W2 - W1

C     Extract qualified diagonal integral block.
C     ------------------------------------------

      Call Cho_Timer(C1,W1)

      Call mma_allocate(MQ,l_KVec,Label='MQ')
      Call Cho_P_GetMQ(MQ,SIZE(MQ),LstQSP,NumSP)

C     Decompose qualified diagonal block.
C     The qualified diagonals are returned in QDiag.
C     ----------------------------------------------

      Call Cho_Dec_Qual(Diag,LQ_Tot,MQ,KVec,IDKVec,nKVec,QDiag)

C     Deallocate MQ.
C     --------------

      Call mma_deallocate(MQ)

C     Reorder the elements of the K-vectors according to IDK ordering.
C     ----------------------------------------------------------------

      MxQ = nQual(1)
      Do iSym = 2,nSym
         MxQ = max(MxQ,nQual(iSym))
      End Do

      Call mma_allocate(KVScr,MxQ,Label='KVScr')

      kK1 = 0
      kK2 = kK1
      kID = 0
      Do iSym = 1,nSym
         Do iK = 1,nKVec(iSym)
            kK_1 = kK1 + nQual(iSym)*(iK-1) + 1
            Call dCopy_(nQual(iSym),KVec(kK_1),1,KVScr,1)
            kK_2 = kK2 + nKVec(iSym)*(iK-1)
            Do jK = 1,nKVec(iSym)
               lK = IDKVec(kID+jK)
               KVec(kK_2+jK) = KVScr(lK)
            End Do
         End Do
         kK1 = kK1 + nQual(iSym)**2
         kK2 = kK2 + nKVec(iSym)**2
         kID = kID + nQual(iSym)
      End Do

C     Reorder QDiag to IDK ordering.
C     ------------------------------

      kID = 0
      kQD = 0
      Do iSym = 1,nSym
         Call dCopy_(nQual(iSym),QDiag(kQD+1),1,KVScr,1)
         Do iK = 1,nKVec(iSym)
            lK = IDKVec(kID+iK)
            QDiag(kQD+iK) = KVScr(lK)
         End Do
         kQD = kQD + nQual(iSym)
         kID = kID + nQual(iSym)
      End Do

C     Reorder elements of LQ vectors to IDK ordering.
C     -----------------------------------------------

      kID = 0
      Do iSym = 1,nSym
         If (nQual(iSym)<1) Cycle
         Do jVec = 1,NumV(iSym)
            Call dCopy_(nQual(iSym),LQ(iSym)%Array(:,jVec),1,
     &                              KVScr,1)
            Do iK = 1,nKVec(iSym)
               lK = IDKVec(kID+iK)
               LQ(iSym)%Array(iK,jVec) = KVScr(lK)
            End Do
         End Do
         kID = kID + nQual(iSym)
      End Do

      Call mma_deallocate(KVScr)

C     Reset qualification index arrays to IDK ordering.
C     Local as well as global are reordered.
C     -------------------------------------------------

      Call iCopy(nSym,nQual,1,nQual_Old,1)
      Call mma_allocate(iQScr,MxQ,Label='iQScr')

      Call Cho_P_ReoQual(iQScr,IDKVec,nKVec)

      Call mma_deallocate(iQScr)
      Call iCopy(nSym,nKVec,1,nQual,1)

      Call Cho_Timer(C2,W2)
      tDecom(1,4) = tDecom(1,4) + C2 - C1
      tDecom(2,4) = tDecom(2,4) + W2 - W1

C     Compute vectors in each symmetry block.
C     ---------------------------------------

      kV = 1
      kI = 1
      kQD = 1
      Do iSym = 1,nSym

C        Cycle loop if nothing to do in this symmetry.
C        ---------------------------------------------

         If (nQual(iSym) .lt. 1) Go To 100

C        Set vector information.
C        -----------------------

         Call Cho_P_SetVecInf(nQual(iSym),iSym,iPass)

C        Allocate memory for integrals/vectors.
C        --------------------------------------

         l_xInt = max(nnBstR(iSym,2)*nQual(iSym),1)
         Call mma_allocate(xInt,l_xInt,Label='xInt')

         If (nnBstR(iSym,2) .gt. 0) Then

C           Read integral columns from disk, ordered according to IDK.
C           ----------------------------------------------------------

            Call Cho_Timer(C1,W1)
            Call Cho_RdQCol_Indx(xInt,IDKVec(kI),nnBstR(iSym,2),
     &                           nQual(iSym),LuSel(iSym))
            Call Cho_Timer(C2,W2)
            tDecom(1,1) = tDecom(1,1) + C2 - C1
            tDecom(2,1) = tDecom(2,1) + W2 - W1

C           Compute vectors.
C           ----------------

            Call mma_maxDBLE(l_Wrk1)
            Call mma_allocate(Wrk1,l_Wrk1,Label='Wrk1')

            Call Cho_CompVec(Diag,xInt,KVec(kV),QDiag(kQD),
     &                       Wrk1,SIZE(Wrk1),iSym,iPass)

            Call mma_deallocate(Wrk1)

C           Write vectors to disk and update vector counters.
C           -------------------------------------------------

            Call Cho_Timer(C1,W1)
            iVec1 = NumCho(iSym) + 1
            Call Cho_PutVec(xInt,nnBstR(iSym,2),nQual(iSym),
     &                      iVec1,iSym)
            Call Cho_VecBuf_Copy(xInt,nQual(iSym),iSym)
            NumCho(iSym) = NumCho(iSym) + nQual(iSym)
            NumChT = NumChT + nQual(iSym)
            Call Cho_Timer(C2,W2)
            tDecom(1,2) = tDecom(1,2) + C2 - C1
            tDecom(2,2) = tDecom(2,2) + W2 - W1

         End If

C        Transpose vectors on disk (parallel only).
C        ------------------------------------------

         Call Cho_Timer(C1,W1)
         iRed = 2
         Jin = NumV(iSym) + 1
         Jfi = NumV(iSym) + nQual(iSym)
         Call Cho_P_VecTransp(xInt,Jin,Jfi,iSym,iRed,iPass)
         Call Cho_Timer(C2,W2)
         tDecom(1,2) = tDecom(1,2) + C2 - C1
         tDecom(2,2) = tDecom(2,2) + W2 - W1

C        Deallocate memory for integrals/vectors.
C        ----------------------------------------

         Call mma_deallocate(xInt)

C        Empty symmetry blocks jump here.
C        --------------------------------

  100    Continue
         kV = kV + nQual(iSym)**2
         kI = kI + nQual_Old(iSym)
         kQD = kQD + nQual_Old(iSym)

      End Do

C     Deallocations.
C     --------------

      Call mma_deallocate(LQ_Tot)
      Call mma_deallocate(QDiag)
      Call mma_deallocate(IDKVec)
      Call mma_deallocate(KVec)

C     Print.
C     ------

      If (iPrint .ge. Inf_Progress) Then
         Do iSym = 1,nSym
            NumCho_Old(iSym) = NumCho(iSym) - NumCho_Old(iSym)
         End Do
         Write(Lupri,'(80A)') ('-',I=1,LenLin)
         Write(Lupri,'(A,8I8)')
     &   '#vec. gener.  : ',(NumCho_OLD(iSym),iSym=1,nSym)
      Else If (iPrint .ge. Inf_Pass) Then
         Do iSym = 1,nSym
            NumCho_Old(iSym) = NumCho(iSym) - NumCho_Old(iSym)
         End Do
         Write(Lupri,'(A,8I8)')
     &   '#vec. gener.  : ',(NumCho_OLD(iSym),iSym=1,nSym)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine unpckhelp5(a,b,dimp,dimj,dime,jadd,noj,eadd,noe)
! this routine does:
! b(j,e) = a(pj,qe)-a(qe,pj) for symp=symq

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimj, dime, jadd, noj, eadd, noe
real(kind=wp), intent(in) :: a(dimp,dimp)
real(kind=wp), intent(inout) :: b(dimj,dime)
integer(kind=iwp) :: e

do e=1,noe
  b(1:noj,e) = a(jadd+1:jadd+noj,eadd+e)-a(eadd+e,jadd+1:jadd+noj)
end do

return

end subroutine unpckhelp5

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!***********************************************************************

module test_linalg_mod
    use fruit
    use definitions, only: wp
    use linalg_mod, only: mult, operator(.isclose.), Gram_Schmidt, symmetric, &
        sym_diagonalize, canonicalize, norm
    implicit none
    private
    public :: test_mult_N_N, test_mult_T_N, test_mult_N_T, test_mult_T_T, test_diagonalization
    real(wp), parameter :: tolerance = 10._wp**2 * epsilon(1._wp)

contains

    subroutine test_mult_N_N()
        real(wp), target :: A(20, 10), B(10, 20), C(size(A, 1), size(B, 2))
        real(wp) :: expected(size(C, 1), size(C, 2))
        real(wp), pointer :: raw_A(:), raw_B(:), raw_C(:)

        call random_number(A)
        call random_number(B)

        expected = matmul(A, B)

        call mult(A, B, C)
        call assert_true(all(C .isclose. expected))

        raw_A(1 : size(A)) => A(:, :)
        raw_B(1 : size(B)) => B(:, :)
        raw_C(1 : size(C)) => C(:, :)

        call mult(raw_A, shape(A), raw_B, shape(B), raw_C)
        call assert_true(all(C .isclose. expected))
    end subroutine

    subroutine test_mult_T_N()
        real(wp), target :: A(20, 10), B(20, 10), C(size(A, 2), size(B, 2))
        real(wp) :: expected(size(C, 1), size(C, 2))
        real(wp), pointer :: raw_A(:), raw_B(:), raw_C(:)

        call random_number(A)
        call random_number(B)

        expected = matmul(transpose(A), B)

        call mult(A, B, C, transpA=.true.)
        call assert_true(all(C .isclose. expected))

        raw_A(1 : size(A)) => A(:, :)
        raw_B(1 : size(B)) => B(:, :)
        raw_C(1 : size(C)) => C(:, :)

        call mult(raw_A, shape(A), raw_B, shape(B), raw_C, transpA=.true.)
        call assert_true(all(C .isclose. expected))
    end subroutine

    subroutine test_mult_N_T()
        real(wp), target :: A(20, 10), B(20, 10), C(size(A, 1), size(B, 1))
        real(wp) :: expected(size(C, 1), size(C, 2))
        real(wp), pointer :: raw_A(:), raw_B(:), raw_C(:)

        call random_number(A)
        call random_number(B)

        expected = matmul(A, transpose(B))

        call mult(A, B, C, transpB=.true.)
        call assert_true(all(C .isclose. expected))

        raw_A(1 : size(A)) => A(:, :)
        raw_B(1 : size(B)) => B(:, :)
        raw_C(1 : size(C)) => C(:, :)

        call mult(raw_A, shape(A), raw_B, shape(B), raw_C, transpB=.true.)
        call assert_true(all(C .isclose. expected))
    end subroutine

    subroutine test_mult_T_T()
        real(wp), target :: A(20, 10), B(10, 20), C(size(A, 2), size(B, 1))
        real(wp) :: expected(size(C, 1), size(C, 2))
        real(wp), pointer :: raw_A(:), raw_B(:), raw_C(:)

        call random_number(A)
        call random_number(B)

        expected = matmul(transpose(A), transpose(B))

        call mult(A, B, C, transpA=.true., transpB=.true.)
        call assert_true(all(C .isclose. expected))

        raw_A(1 : size(A)) => A(:, :)
        raw_B(1 : size(B)) => B(:, :)
        raw_C(1 : size(C)) => C(:, :)

        call mult(raw_A, shape(A), raw_B, shape(B), raw_C, transpA=.true., transpB=.true.)
        call assert_true(all(C .isclose. expected))
    end subroutine

    subroutine test_diagonalization()
        integer, parameter :: test_size = 10
        ! dimension of the Eigenspaces
        integer, parameter :: dimension_E(4) = [5, 5, 1, 5]
        real(wp) :: lambdas(sum(dimension_E))
        real(wp) :: M(size(lambdas), size(lambdas))
        real(wp) :: V(size(M, 1), size(M, 2))
        real(wp) :: U(size(M, 1), size(M, 2))
        real(wp) :: test_V(size(M, 1), size(M, 2)), tmp(size(M, 2))
        real(wp) :: ref(size(V, 1), size(V, 2))

        integer :: i, j, i_test
        integer :: offset

        ! create_test_matrix
        offset = 1
        do i = 1, size(dimension_E)
            lambdas(offset : offset + dimension_E(i) - 1) = real(i, kind=wp)
            offset = offset + dimension_E(i)
        end do

        M = 0._wp
        do i = 1, size(M, 1)
            M(i, i) = lambdas(i)
        end do

        call get_rand_orthogonal(U)
        M = matmul(matmul(transpose(U), M), U)
        call assert_true(symmetric(M))

        call sym_diagonalize(M, V, lambdas)

        ! test in canonical basis

        call canonicalize(V, lambdas)

        do i_test = 1, test_size
            call create_test_V(V, dimension_E, test_V)
            call canonicalize(test_V, lambdas)

            ! Test that the canonicalized Eigenvectors are indeed Eigenvectors.
            do j = 1, size(lambdas)
                call mult(M, test_V(:, j), tmp)
                call assert_true(all(lambdas(j) * test_V(:, j) .isclose. tmp))
            end do

            ! Test that canonicalized eigenvectors are always the same
            ! even if there are degenerate Eigenspaces.
            call assert_true(all(test_V .isclose. V))
        end do

        ! test with Roland's constraints

        call assert_true(size(V, 1) == size(V, 2))

        ref(:, :) = 0._wp

        do i = 1, size(V, 2)
            ref(i, i) = 1._wp
            ref(mod(i + 1, size(V, 1)), i) = -1._wp
        end do

        call canonicalize(V, lambdas, ref)

        do i_test = 1, test_size
            call create_test_V(V, dimension_E, test_V)
            call canonicalize(test_V, lambdas, ref)

            ! Test that the canonicalized Eigenvectors are indeed Eigenvectors.
            do j = 1, size(lambdas)
                call mult(M, test_V(:, j), tmp)
                call assert_true(all(lambdas(j) * test_V(:, j) .isclose. tmp))
            end do

            ! Test that canonicalized eigenvectors are always the same
            ! even if there are degenerate Eigenspaces.
            call assert_true(all(test_V .isclose. V))
        end do

    end subroutine

!>  @brief
!>    Create random rotations inside degenerate Eigenspaces
!>
!>  @author
!>    Oskar Weser
!>
!>  @param[in] V The eigenvectors. It is assumed, that Eigenvectors from the same Eigenspace
!>          are neighbouring.
!>  @param[in] dimension_E The dimension for each Eigenspace.
!>  @param[out] test_V The eigenvectors where degenerate Eigenspaces are randomly changed.
    subroutine create_test_V(V, dimension_E, test_V)
        real(wp), intent(in) :: V(:, :)
        integer, intent(in) :: dimension_E(:)
        real(wp), intent(out) :: test_V(:, :)

        real(wp), allocatable :: U(:, :)
        integer :: i, j, k, offset

        offset = 1
        test_V = 0._wp
        do i = 1, size(dimension_E)
            allocate(U(dimension_E(i), dimension_E(i)))
            call get_rand_orthogonal(U)

            do j = 1, dimension_E(i)
                do k = 1, dimension_E(i)
                    test_V(:, offset + j - 1) = test_V(:, offset + j - 1) + U(k, j) * V(:, offset + k - 1)
                end do
            end do
            offset = offset + dimension_E(i)
            deallocate(U)
        end do
    end subroutine

    subroutine get_rand_orthogonal(U)
        real(wp), intent(out) :: U(:, :)
        integer :: n_new
        real(wp) :: basis(size(U, 1), size(U, 2))
        logical :: linear_independent

        linear_independent = .false.
        do while (.not. linear_independent)
            call random_number(basis)
            call Gram_Schmidt(basis, size(basis, 2), U, n_new)
            linear_independent = n_new == size(basis, 2)
        end do
    end subroutine
end module test_linalg_mod

program test_linalg
    use fruit
    use test_linalg_mod

    implicit none
    integer :: failed_count, i
    integer, parameter :: seed_size = 50
    integer, parameter :: seed(seed_size) = [(i, i = 1, seed_size)]

    call random_seed(put=seed)
    call init_fruit()
    call inimem()

    call test_linalg_driver()

    call fruit_summary()
    call fruit_finalize()
    call get_failed_count(failed_count)

    if (failed_count /= 0) error stop

contains

    subroutine test_linalg_driver()
        call run_test_case(test_mult_N_N, "test_mult_N_N")
        call run_test_case(test_mult_T_N, "test_mult_T_N")
        call run_test_case(test_mult_N_T, "test_mult_N_T")
        call run_test_case(test_mult_T_T, "test_mult_T_T")
        call run_test_case(test_diagonalization, "test_diagonalization")
    end subroutine
end program test_linalg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PlaceIt(Coord,iQ_Atoms,iCNum)

use qmstat_global, only: Cordst, iPrint, nCent, nPart
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms, iCNum
real(kind=wp), intent(in) :: Coord(3,iQ_Atoms)
integer(kind=iwp) :: i, ind, iTemp, j, k
real(kind=wp) :: Atemp, S, Sbig
logical(kind=iwp) :: Changed
character(len=200) :: Head
integer(kind=iwp), allocatable :: IndexSet(:)
real(kind=wp), allocatable :: AvstPart(:), CordstTemp(:,:)

call mma_allocate(AvstPart,nPart,label='AvstPart')

!For each solvent particle, compute the smallest distance to any QM-atom from the oxygen of water.
do i=1,nPart
  k = (i-1)*nCent+1
  Sbig = 1.0e20_wp
  do j=1,iQ_Atoms
    S = (Coord(1,j)-Cordst(1,k))**2+(Coord(2,j)-Cordst(2,k))**2+(Coord(3,j)-Cordst(3,k))**2
    if (S <= Sbig) then
      Sbig = S
      AvstPart(i) = S
    end if
  end do
end do

call mma_allocate(IndexSet,nPart,label='IndexSet')
do i=1,nPart
  IndexSet(i) = i
end do

do
  ! Order the indices suchwise that smallest distance goes first. The sorting routine is blunt
  ! but at this stage of the execution time is not a problem.
  Changed = .false.
  do i=1,nPart-1
    if (AvstPart(i+1) < AvstPart(i)) then
      Atemp = AvstPart(i)
      AvstPart(i) = AvstPart(i+1)
      AvstPart(i+1) = Atemp
      iTemp = IndexSet(i)
      IndexSet(i) = IndexSet(i+1)
      IndexSet(i+1) = iTemp
      Changed = .true.
    end if
  end do
  if (.not. Changed) exit
end do

call mma_deallocate(AvstPart)

! Put coordinates of solvent suchwise that smallest distances goes first.
call mma_allocate(CordstTemp,3,nPart*nCent,label='CordstTemp')
CordstTemp(:,:) = Cordst(:,1:nPart*nCent)
do i=1,nPart
  k = (i-1)*nCent
  ind = (IndexSet(i)-1)*nCent
  Cordst(:,k+1:k+nCent) = CordstTemp(:,ind+1:ind+nCent)
end do
call mma_deallocate(IndexSet)
call mma_deallocate(CordstTemp)

! Substitute the first coordinate slots with QM-molecule, or since we have
! ordered above, this is equivalent with removing closest solvents and there put QM-mol.
Cordst(:,1:iQ_Atoms) = Coord
! Just dummy-coordinates added to empty slots.
Cordst(1,iQ_Atoms+1:iCnum*nCent) = Coord(1,1)
Cordst(2,iQ_Atoms+1:iCnum*nCent) = Coord(2,1)
Cordst(3,iQ_Atoms+1:iCnum*nCent) = Coord(3,1)

if (iPrint >= 10) then !Optional printing.
  write(Head,*) 'Coordinates of the system after substitution and reordering of solvent molecules.'
  call Cooout(Head,Cordst,nPart,nCent)
end if

return

end subroutine PlaceIt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************

module test_sorting_mod
    use fruit
    use sorting, only: sort, argsort
    use isotopes, only: maxatomnum, ptab
    use definitions, only: wp
    implicit none
    private
    public :: test_sort_ints, test_sort_isotopes, test_sort_reals

contains

    subroutine test_sort_ints
        integer, parameter :: n_test = 10
        integer :: numbers(n_test), idx(n_test)

        numbers = [10, 13, 78, -1, 2, 5, 4, 0, 0, -3]
        idx(:) = argsort(numbers, leq)

        call assert_true(all(numbers(idx( : size(numbers) - 1)) <= numbers(idx(2 :))))
        call assert_equals(idx, [10, 4, 8, 9, 5, 7, 6, 1, 2, 3], n_test)

        call sort(numbers, leq)

        call assert_true(all(numbers( : size(numbers) - 1) <= numbers(2 :)))
        call assert_equals(numbers, [-3, -1, 0, 0, 2, 4, 5, 10, 13, 78], n_test)

        contains

        ! This could also use sorting_funcs::leq_i
        logical pure function leq(i, j)
            integer, intent(in) :: i, j
            leq = i <= j
        end function
    end subroutine

    subroutine test_sort_reals
        integer, parameter :: n_test = 10
        real(kind=wp) :: numbers(n_test)
        integer :: idx(n_test)

        numbers = [0.471_wp, 0.117_wp, -0.357_wp, 0.318_wp, -0.696_wp, -0.426_wp, 0.854_wp, 0.343_wp, 0.697_wp, -0.570_wp]
        idx = argsort(numbers, leq)

        call assert_true(all(numbers(idx( : size(numbers) - 1)) <= numbers(idx(2 :))))
        call assert_equals(idx, [5, 10, 6, 3, 2, 4, 8, 1, 9, 7], n_test)

        contains

        ! This could also use sorting_funcs::leq_r
        logical pure function leq(i, j)
            real(kind=wp), intent(in) :: i, j
            leq = i <= j
        end function
    end subroutine

    subroutine test_sort_isotopes
        integer, allocatable :: idx(:)

        ! not using the ElementList from the isotopes module because
        ! it is protected and proper initialization would require
        ! access to the isotopes_data.txt file
        integer :: i
        type Element
          character(len=2) :: symbol
        end type Element
        type(Element), allocatable :: ElementList(:)

        allocate(ElementList(MaxAtomNum))
        do i=1,MaxAtomNum
          ElementList(i)%symbol = adjustl(PTab(i))
        end do

        allocate(idx(lbound(elementlist, 1) : ubound(elementlist, 1)))

        idx(:) = [(i, i = lbound(idx, 1), ubound(idx, 1))]

        call sort(idx, lex_alphabet_leq)

        print * , elementlist(idx(: 10))%symbol
        call assert_true(all(elementlist(idx(: 10))%symbol &
            == ['Ac', 'Ag', 'Al', 'Am', 'Ar', 'As', 'At', 'Au', 'B ', 'Ba']))

        contains

        logical pure function lex_alphabet_leq(i, j)
            integer, intent(in) :: i, j
            lex_alphabet_leq = elementlist(i)%symbol <= elementlist(j)%symbol
        end function

    end subroutine

end module

program test_sorting
    use fruit
    use test_sorting_mod

    implicit none
    integer :: failed_count, i, seed_size

    call random_seed(size=seed_size)
    call random_seed(put=[(i, i = 1, seed_size)])
    call init_fruit()
    call init_linalg()
    call inimem()

    call test_driver()

    call fruit_summary()
    call fruit_finalize()
    call get_failed_count(failed_count)

    if (failed_count /= 0) error stop

contains

    subroutine test_driver()
        call run_test_case(test_sort_ints, "test_sort_ints")
        call run_test_case(test_sort_reals, "test_sort_reals")
        call run_test_case(test_sort_isotopes, "test_sort_isotopes")
    end subroutine
end program test_sorting

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2007, Markus Reiher                               *
************************************************************************
      subroutine red_dkhstring (dkhorder,xorder,paramtype,dkhscfflg,
     *             ordercounter,opcounter,operleng,oporder,evenodd,
     *             doperators,operators,xordercounter,xopcounter,
     *             xoperleng,xoporder,xevenodd,xdoperators,xoperators,
     *             wordercounter,wopscounter,wopsleng,woporder,eowops,
     *             dwops,wops,termleng,termleng2,termorder,
     *             dtcoeff,dtcoeff2,
     *             sused,snumber,scounter,stimes,wstimes,
     *             sorder,smult,s,scrchar,scrleng,stimestot,
     *             tnumber,tcounter,ttimes,tmult,t,tscrchar,tscrleng,
     *             ttimestot,uused,unumber,utimes,uorder,
     *             umult,u,uscrchar,uscrleng,totmult,dkhzerothrsh,no_u)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 15.01.2007 (M. Reiher, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,xorder
      character*(3) paramtype
      logical dkhscfflg,no_u
c
      integer ordercounter(0:maxorder),opcounter,operleng(maxoperators),
     *        oporder(maxoperators,3),evenodd(maxoperators),
     *        xordercounter(0:maxorder),xopcounter,
     *        xoperleng(maxoperators),xoporder(maxoperators),
     *        xevenodd(maxoperators),wordercounter(maxorder),
     *        wopscounter,wopsleng(maxuops),woporder(maxuops,3),
     *        eowops(maxuops)
      real*8 doperators(maxoperators),
     *                 xdoperators(maxoperators),dwops(maxuops)
#if defined(_MOLCAS_) || defined(MOLPRO)
#include "WrkSpc.fh"
      character operators(*),xoperators(*)
      character*(maxlength) opstring,xopstring
#else
      character*(maxlength) operators(maxoperators),
     *                      xoperators(maxoperators)
#endif
      character*(maxlength) wops(maxuops)
c
      integer sused,snumber,scounter(maxsnumber),stimes(maxsnumber),
     *        wstimes(maxuops,maxsnumber),sorder(maxsnumber,3),
     *        smult(maxsnumber),scrleng(maxsnumber),stimestot
      integer tnumber,tcounter(maxsnumber),ttimes(maxsnumber),
     *        tmult(maxsnumber),tscrleng(maxsnumber),ttimestot

      integer uused,unumber,utimes(maxunumber),uorder(maxunumber,3),
     *        umult(maxunumber),uscrleng(maxunumber)
      character*(3) uscrchar(maxunumber)
      character*(4) s(maxsnumber),t(maxsnumber),u(maxunumber)
      character*(9) scrchar(maxsnumber)
      character*(11) tscrchar(maxsnumber)
c
      integer totmult
      real*8 dkhzerothrsh(0:maxorder)
c
      integer termcounter,termleng(maxoperators),
     *        termleng2(maxoperators),
     *        termorder(maxoperators,3)
      real*8 dtcoeff(maxoperators),dtcoeff2(maxoperators),
     *                 dummycoeff
#if defined(_MOLCAS_) || defined(MOLPRO)
      character*(maxlength) termstr
      integer term,nwop,lwop,intrea
#else
      character*(maxlength) term(maxoperators)
#endif
c
      integer i,j,k,l,wpos,opos,epos,cpos1,cpos2,idum1,idum2,idum3,
     *        idum4,ilow,istart,dummyleng,ctrflg(0:maxorder),
     *        matmulttot1,matmulttot2,matmultterm,opmult(0:maxorder),
     *        xopmult(0:maxorder)
      character*(maxlength) dummychar
#ifdef _MOLCAS_
      Integer IsFreeUnit
#endif
c
      If (dkhscfflg) Then
        Write (stdout,1016)
1016    format (//5X,'|',70('-'),'|',/5X,'|',6X,'STEP 3: Simplify ',
     *          'final Hamiltonian',30X,'|',/5X,'|',
     *          70('-'),'|',/2X)
CMR      Else
CMR        Write (stdout,1017)
CMR1017    format (//5X,'|',70('-'),'|',/5X,'|',6X,'STEP 3: Simplify ',
CMR     *          'final Hamiltonian and property X',15X,'|',/5X,'|',
CMR     *          70('-'),'|',/2X)
      End If
c
      If (dbgflg.ge.1) Then
        Write (dbgunit,1019)
1019    format (/2X,'Step 3: Enter subroutine "red_dkhstring" ',//2X,
     *          'Simplify (if still necessary) terms of the final ',
     *           'Hamiltonian and property X.')
      End If
      Call u_create (uused,unumber,utimes,uorder,umult,u,uscrleng,
     *               uscrchar,no_u)
      do 20 i=0,maxorder
        ctrflg(i)=0
  20  continue
c
#if defined(_MOLCAS_) || defined(MOLPRO)
      lwop=8/intrea()
      nwop=(maxlength-1)/lwop+1
      Call GetMem('term_red','Allo','Inte',term,maxoperators*nwop)
#endif
2456  continue
      do 30 i=0,dkhorder
c
        istart=1
        do 40 l=0,i-1
          istart=istart+ordercounter(l)
  40    continue
c
        do 45 j=istart,istart+ordercounter(i)-1
#if defined(_MOLCAS_) || defined(MOLPRO)
          Call get_dkoperators(j,opstring,operators)
          wpos=index(opstring(1:operleng(j)),'W')
          opos=index(opstring(1:operleng(j)),'O01')
          epos=index(opstring(1:operleng(j)),'E01')
          cpos1=index(opstring(1:operleng(j)),'CO0')
          cpos2=index(opstring(1:operleng(j)),'CE0')
#else
          wpos=index(operators(j)(1:operleng(j)),'W')
          opos=index(operators(j)(1:operleng(j)),'O01')
          epos=index(operators(j)(1:operleng(j)),'E01')
          cpos1=index(operators(j)(1:operleng(j)),'CO0')
          cpos2=index(operators(j)(1:operleng(j)),'CE0')
#endif
c
          If (wpos.gt.0 .or. opos.gt.0 .or. epos.gt.0 .or.
     *        cpos1.gt.0 .or. cpos2.gt.0) Then
            do 50 k=1,maxlength
              dummychar(k:k)=' '
  50        continue
            dummyleng=operleng(j)
            dummycoeff=doperators(j)
c
#if defined(_MOLCAS_) || defined(MOLPRO)
            dummychar=opstring(1:operleng(j))
            Call replace2 (dummyleng,dummycoeff,dummychar,wordercounter,
     *                     wopsleng,dwops,wops,sused,stimes,wstimes,s,
     *                     scrchar,scrleng,ttimes,termcounter,
     *                     termleng,termleng2,
     *                     dtcoeff,dtcoeff2,iwork(term))
#else
            dummychar(1:dummyleng)=operators(j)(1:operleng(j))
            Call replace2 (dummyleng,dummycoeff,dummychar,wordercounter,
     *                     wopsleng,dwops,wops,sused,stimes,wstimes,s,
     *                     scrchar,scrleng,ttimes,termcounter,
     *                     termleng,termleng2,dtcoeff,dtcoeff2,term)
#endif
c
            If (opcounter+termcounter.gt.maxoperators) Then
              Write (stdout,1033) j,opcounter+termcounter
1033          format (/2X,'In SR red_dkhstring: For j = ',I9,':  ',
     *                'opcounter+termcounter = ',I9,' > maxoperators.',
     *                //2X,'Increase maxoperators.',//2X,'STOP.',/)
              Call Abend
            End If
            idum2=0
            do 70 k=1,termcounter
#if defined(_MOLCAS_) || defined(MOLPRO)
              Call get_dkoperators_i(k,termstr,iwork(term))
              Call removeB1 (termleng(k),dtcoeff(k),termstr)
              Call removeB2 (termleng(k),termstr)
              Call insert_ri (termleng(k),termstr)
              Call movebraces (termleng(k),termstr)
              Call finalize (termleng(k),termstr,stimes,ttimes,t)
              Call finalize2 (termleng(k),termstr,uused,utimes,u,
     *                        uscrleng,uscrchar)
              termorder(k,3)=i
              Call calc_orders (dkhscfflg,termleng(k),termorder(k,1),
     *                          termorder(k,2),termorder(k,3),termstr,
     *                          sorder,uorder)
              Call put_dkoperators_i(k,termstr,iwork(term))
#else
              Call removeB1 (termleng(k),dtcoeff(k),term(k))
              Call removeB2 (termleng(k),term(k))
              Call insert_ri (termleng(k),term(k))
              Call movebraces (termleng(k),term(k))
              Call finalize (termleng(k),term(k),stimes,ttimes,t)
              Call finalize2 (termleng(k),term(k),uused,utimes,u,
     *                        uscrleng,uscrchar)
              termorder(k,3)=i
              Call calc_orders (dkhscfflg,termleng(k),termorder(k,1),
     *                          termorder(k,2),termorder(k,3),term(k),
     *                          sorder,uorder)
#endif
              If (dkhscfflg.and. termorder(k,2).gt.xorder) idum2=idum2+1
  70        continue
c
            idum3=termcounter-idum2
            If (idum3.ge.1) Then
              do 90 k=opcounter,j+1,-1
                operleng(k+idum3-1)=operleng(k)
                oporder(k+idum3-1,1)=oporder(k,1)
                oporder(k+idum3-1,2)=oporder(k,2)
                oporder(k+idum3-1,3)=oporder(k,3)
                evenodd(k+idum3-1)=evenodd(k)
                doperators(k+idum3-1)=doperators(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
                Call copy_dkoperators(k,operators,
     *                              k+idum3-1,operators)
#else
              operators(k+idum3-1)=operators(k)
#endif
  90          continue
              idum4=0
              do 100 k=1,termcounter
                If (dynthrsh.eq.0 .and.abs(dtcoeff(k)).ge.dkhzero .and.
     *              (.not.dkhscfflg .or. termorder(k,2).le.xorder)) Then
                  idum4=idum4+1
                  operleng(j+idum4-1)=termleng(k)
                  oporder(j+idum4-1,1)=termorder(k,1)
                  oporder(j+idum4-1,2)=termorder(k,2)
                  oporder(j+idum4-1,3)=termorder(k,3)
                  evenodd(j+idum4-1)=evenodd(j)
                  doperators(j+idum4-1)=dtcoeff(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
                  Call copy_dkoperators_ic(k,iwork(term),j+idum4-1,
     *                                  operators)
#else
              operators(j+idum4-1)=term(k)
#endif
                End If
                If (dynthrsh.eq.1 .and.
     *              abs(dtcoeff(k)).ge.dkhzerothrsh(i) .and.
     *              (.not.dkhscfflg .or. termorder(k,2).le.xorder)) Then
                  idum4=idum4+1
                  operleng(j+idum4-1)=termleng(k)
                  oporder(j+idum4-1,1)=termorder(k,1)
                  oporder(j+idum4-1,2)=termorder(k,2)
                  oporder(j+idum4-1,3)=termorder(k,3)
                  evenodd(j+idum4-1)=evenodd(j)
                  doperators(j+idum4-1)=dtcoeff(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
                  Call copy_dkoperators_ic(k,iwork(term),j+idum4-1,
     *                                  operators)
#else
              operators(j+idum4-1)=term(k)
#endif
                End If
 100          continue
              opcounter=opcounter+idum3-1
              ordercounter(i)=ordercounter(i)+idum3-1
CMR: Is this necessary? Can't one start with reduced loop limits?
              goto 2456
            End If
c
            If (idum3.eq.0) Then
              do 110 k=j,opcounter-1
                operleng(k)=operleng(k+1)
                oporder(k,1)=oporder(k+1,1)
                oporder(k,2)=oporder(k+1,2)
                oporder(k,3)=oporder(k+1,3)
                evenodd(k)=evenodd(k+1)
                doperators(k)=doperators(k+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
CMR Does this work?? Was adapted from above
C               Call copy_dkoperators_ic(k+1,iwork(term),k,operators)
                Call copy_dkoperators(k+1,operators,k,operators)
#else
                operators(k)=operators(k+1)
#endif
 110          continue
              opcounter=opcounter-1
              ordercounter(i)=ordercounter(i)-1
CMR Does this work?? Was adapted from above
              goto 2456
            End If
c
          End If
c
  45    continue
c
        If (ctrflg(i).eq.0) Then
CMR          Write (stdout,1123) i,ordercounter(i)
CMR1123      format (2X,'order ',I2,':  all ',I8,' final terms ',
CMR     *            '(DKH Hamiltonian) successfully simplified.')
        End If
        ctrflg(i)=1
  30  continue
c     Write (stdout,*)
c
#ifndef MOLPRO
#ifdef _MOLCAS_
      dkhunit1=11
      dkhunit1=IsFreeUnit(dkhunit1)
      Call Molcas_Open(dkhunit1,'dkhops.11')
#else
      open (dkhunit1, file='dkhops.11', status='UNKNOWN',
     *        form='FORMATTED')
#endif
#endif
      rewind(dkhunit1)
      Write (dkhunit1,1427) dkhorder,paramtype,xorder,dkhscfflg
1427  format (50('-'),/2X,'dkhorder = ',I2,10X,A3,/2X,'xorder   = ',I2,
     *        /2X,'dkhscfflg = ',L1,/'+++',47('-'))
      ilow=ordercounter(0)+ordercounter(1)+1
      do 300 j=2,dkhorder
        Write (dkhunit1,1001) j,ordercounter(j)
1001    format ('***',/5X,I2,9X,'orders',4X,I6)
        idum1=0
        do 400 k=ilow,ilow+ordercounter(j)-1
          idum1=idum1+1
#if defined(_MOLCAS_) || defined(MOLPRO)
          Call get_dkoperators(k,opstring,operators)
          Write (dkhunit1,1467) idum1,operleng(k),oporder(k,1),
     *                          oporder(k,2),oporder(k,3),
     *                          opstring(1:operleng(k)),doperators(k)
#else
          Write (dkhunit1,1467) idum1,operleng(k),oporder(k,1),
     *                         oporder(k,2),oporder(k,3),
     *                         operators(k)(1:operleng(k)),doperators(k)
#endif
1467      format (I7,1X,I3,4X,I2,1X,I2,1X,I2,1X,A90,4X,F17.14)
 400    continue
        ilow=ilow+ordercounter(j)
 300  continue
#ifdef _MOLCAS_
      close (dkhunit1)
#endif
c
      If (dbgflg.ge.1) Then
        Write (dbgunit,1221) dkhorder,opcounter
1221    format (/2X,'Final low-level DKH Hamiltonian up to dkhorder = ',
     *        I3,':   (opcounter = ',I6,')',/2X,53('-'))
        If (dbgflg.ge.2) Call output3 (dbgunit,opcounter,operleng,
     *                             oporder,evenodd,doperators,operators)
      End If
      If (.not.dkhscfflg) Then
        do 21 i=0,maxorder
          ctrflg(i)=0
  21    continue
c
3456    continue
        do 31 i=0,xorder
c
          istart=1
          do 41 l=0,i-1
            istart=istart+xordercounter(l)
  41      continue
c
          do 245 j=istart,istart+xordercounter(i)-1
#if defined(_MOLCAS_) || defined(MOLPRO)
            Call get_dkoperators(j,xopstring,xoperators)
            wpos=index(xopstring(1:xoperleng(j)),'W')
            opos=index(xopstring(1:xoperleng(j)),'O01')
            epos=index(xopstring(1:xoperleng(j)),'E01')
            cpos1=index(xopstring(1:xoperleng(j)),'CO0')
            cpos2=index(xopstring(1:xoperleng(j)),'CE0')
#else
            wpos=index(xoperators(j)(1:xoperleng(j)),'W')
            opos=index(xoperators(j)(1:xoperleng(j)),'O01')
            epos=index(xoperators(j)(1:xoperleng(j)),'E01')
            cpos1=index(xoperators(j)(1:xoperleng(j)),'CO0')
            cpos2=index(xoperators(j)(1:xoperleng(j)),'CE0')
#endif
c
            If (wpos.gt.0.or.opos.gt.0.or.epos.gt.0.or.cpos1.gt.0
     *            .or.cpos2.gt.0) Then
              do 57 k=1,maxlength
                dummychar(k:k)=' '
  57          continue
              dummyleng=xoperleng(j)
              dummycoeff=xdoperators(j)
c
#if defined(_MOLCAS_) || defined(MOLPRO)
            dummychar=xopstring(1:xoperleng(j))
            Call replace2 (dummyleng,dummycoeff,dummychar,wordercounter,
     *                     wopsleng,dwops,wops,sused,stimes,wstimes,s,
     *                     scrchar,scrleng,ttimes,termcounter,
     *                     termleng,termleng2,
     *                     dtcoeff,dtcoeff2,iwork(term))
#else
              dummychar(1:dummyleng)=xoperators(j)(1:xoperleng(j))
              Call replace2 (dummyleng,dummycoeff,dummychar,
     *                   wordercounter,wopsleng,dwops,wops,sused,stimes,
     *                   wstimes,s,scrchar,scrleng,ttimes,termcounter,
     *                   termleng,termleng2,dtcoeff,dtcoeff2,term)
#endif
c
              If (xopcounter+termcounter.gt.maxoperators) Then
                Write (stdout,2133) j,xopcounter+termcounter
2133            format (/2X,'In SR red_xopstring: For j = ',I9,':  ',
     *                  'xopcounter+termcounter = ',I9,
     *                  ' > maxoperators.',//2X,'Increase maxoperators',
     *                  //2X,'STOP.',/)
                Call Abend
              End If
              idum2=0
              do 71 k=1,termcounter
                If (dynthrsh.eq.0 .and. abs(dtcoeff(k)).lt.dkhzero)
     *                                                     idum2=idum2+1
                If (dynthrsh.eq.1 .and.
     *               abs(dtcoeff(k)).lt.dkhzerothrsh(i))  idum2=idum2+1
c
#if defined(_MOLCAS_) || defined(MOLPRO)
              Call get_dkoperators_i(k,termstr,iwork(term))
              Call removeB1 (termleng(k),dtcoeff(k),termstr)
              Call removeB2 (termleng(k),termstr)
              Call insert_ri (termleng(k),termstr)
              Call movebraces (termleng(k),termstr)
              Call finalize (termleng(k),termstr,stimes,ttimes,t)
              Call finalize2 (termleng(k),termstr,uused,utimes,u,
     *                        uscrleng,uscrchar)
              Call put_dkoperators_i(k,termstr,iwork(term))
#else
                Call removeB1 (termleng(k),dtcoeff(k),term(k))
                Call removeB2 (termleng(k),term(k))
                Call insert_ri (termleng(k),term(k))
                Call movebraces (termleng(k),term(k))
                Call finalize (termleng(k),term(k),stimes,ttimes,t)
                Call finalize2 (termleng(k),term(k),uused,utimes,u,
     *                          uscrleng,uscrchar)
#endif
c
  71          continue
c
              idum3=termcounter-idum2
              If (idum3.ge.1) Then
                do 91 k=xopcounter,j+1,-1
                  xoperleng(k+idum3-1)=xoperleng(k)
                  xoporder(k+idum3-1)=xoporder(k)
                  xevenodd(k+idum3-1)=xevenodd(k)
                  xdoperators(k+idum3-1)=xdoperators(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
                  Call copy_dkoperators(k,xoperators,
     *                                  k+idum3-1,xoperators)
#else
                xoperators(k+idum3-1)=xoperators(k)
#endif
  91            continue
                idum4=0
                do 102 k=1,termcounter
                  If (dynthrsh.eq.0 .and.
     *                                 abs(dtcoeff(k)).ge.dkhzero) Then
                    idum4=idum4+1
                    xoperleng(j+idum4-1)=termleng(k)
                    xoporder(j+idum4-1)=xoporder(j)
                    xevenodd(j+idum4-1)=xevenodd(j)
                    xdoperators(j+idum4-1)=dtcoeff(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
                    Call copy_dkoperators_ic(k,iwork(term),j+idum4-1,
     *                                    xoperators)
#else
                  xoperators(j+idum4-1)=term(k)
#endif
                  End If
                  If (dynthrsh.eq.1 .and.
     *                         abs(dtcoeff(k)).ge.dkhzerothrsh(i)) Then
                    idum4=idum4+1
                    xoperleng(j+idum4-1)=termleng(k)
                    xoporder(j+idum4-1)=xoporder(j)
                    xevenodd(j+idum4-1)=xevenodd(j)
                    xdoperators(j+idum4-1)=dtcoeff(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
                    Call copy_dkoperators_ic(k,iwork(term),j+idum4-1,
     *                                    xoperators)
#else
                  xoperators(j+idum4-1)=term(k)
#endif
                  End If
 102            continue
                xopcounter=xopcounter+idum3-1
                xordercounter(i)=xordercounter(i)+idum3-1
                goto 3456
              End If
c
              If (idum3.eq.0) Then
                do 112 k=j,xopcounter-1
                  xoperleng(k)=xoperleng(k+1)
                  xoporder(k)=xoporder(k+1)
                  xevenodd(k)=xevenodd(k+1)
                  xdoperators(k)=xdoperators(k+1)
                  xoperators(k)=xoperators(k+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
CMR Does this work?? Was adapted from above
                  Call copy_dkoperators(k+1,xoperators,k,xoperators)
#else
                xoperators(k)=xoperators(k+1)
#endif
 112            continue
                xopcounter=xopcounter-1
                xordercounter(i)=xordercounter(i)-1
                goto 3456
              End If
c
            End If
 245      continue
          If (ctrflg(i).eq.0) Then
CMR            Write (stdout,1129) i,xordercounter(i)
CMR1129        format (2X,'order ',I2,':  all ',I8,' final terms ',
CMR     *              '(property X) successfully simplified.')
          End If
          ctrflg(i)=1
  31    continue
c
#ifndef MOLPRO
#ifdef _MOLCAS_
      dkhunit2=12
      dkhunit2=IsFreeUnit(dkhunit2)
      Call Molcas_Open(dkhunit2,'dkhops.12')
#else
      open (dkhunit2, file='dkhops.12', status='UNKNOWN',
#endif
#endif
        rewind(dkhunit2)
        Write (dkhunit2,3427) dkhorder,paramtype,xorder,dkhscfflg
3427    format (50('-'),/2X,'dkhorder = ',I2,10X,A3,/2X,'xorder   = ',
     *          I2,/2X,'dkhscfflg = ',L1,/'+++',47('-'))
        ilow=2
c  Loop 321 runs over all orders
        do 321 j=1,xorder
          Write (dkhunit2,1011) j,xordercounter(j)
1011      format ('***',/5X,I2,7X,'order(V)',2X,I6)
c  Loop 423 processes all terms of one specific order j
          idum1=0
          do 423 k=ilow,ilow+xordercounter(j)-1
            idum1=idum1+1
#if defined(_MOLCAS_) || defined(MOLPRO)
          Call get_dkoperators(k,xopstring,xoperators)
          Write (dkhunit2,1567) idum1,xoperleng(k),xoporder(k),
     *                          xopstring(1:xoperleng(k)),xdoperators(k)
#else
          Write (dkhunit2,1567) idum1,xoperleng(k),xoporder(k),
     *              xoperators(k)(1:xoperleng(k)),xdoperators(k)
#endif
1567        format (I7,1X,I3,5X,I2,5X,A90,4X,F17.14)
 423      continue
          ilow=ilow+xordercounter(j)
 321    continue
#ifdef _MOLCAS_
        close (dkhunit2)
#endif
c
        If (dbgflg.ge.1) Then
          Write (dbgunit,2221) xorder,xopcounter
2221      format (/2X,'Final low-level property X up to xorder = ',I3,
     *                ':   (xopcounter = ',I6,')',/2X,46('-'))
          If (dbgflg.ge.2) Call output3b (dbgunit,xopcounter,xoperleng,
     *                                    xoporder,xevenodd,xdoperators,
     *                                    xoperators)
        End If
c
      End If
c
      snumber=0
      stimestot=0
      do 120 j=1,sused
        If (stimes(j).gt.0) Then
          snumber=snumber+1
          stimestot=stimestot+stimes(j)
        End If
 120  continue
      tnumber=0
      ttimestot=0
      do 121 j=1,sused
        If (ttimes(j).gt.0) Then
          tnumber=tnumber+1
          ttimestot=ttimestot+ttimes(j)
        End If
 121  continue
      do 167 j=0,maxorder
        opmult(j)=0
        xopmult(j)=0
 167  continue
c
      ilow=1
      matmulttot1=0
      matmulttot2=0
      do 180 j=0,dkhorder
        do 200 k=ilow,ilow+ordercounter(j)-1
          matmultterm=0
#if defined(_MOLCAS_) || defined(MOLPRO)
          Call get_dkoperators(k,opstring,operators)
#endif
          do 250 l=1,operleng(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
            If (opstring(l:l).eq.'V'.or.opstring(l:l).eq.'N'.or.
     *          opstring(l:l).eq.'D'.or.opstring(l:l).eq.'Y'.or.
     *          opstring(l:l).eq.'F'.or.opstring(l:l).eq.'G'.or.
     *          opstring(l:l).eq.'Z'.or.opstring(l:l).eq.'Q'.or.
     *          opstring(l:l).eq.'S'.or.opstring(l:l).eq.'T'.or.
     *          opstring(l:l).eq.'U'.or.opstring(l:l).eq.'X'.or.
     *          opstring(l:l).eq.'I'.or.opstring(l:l).eq.'J'.or.
     *          opstring(l:l).eq.'K'.or.opstring(l:l).eq.'L'.or.
     *          opstring(l:l).eq.'M') Then
#else
            If (operators(k)(l:l).eq.'V'.or.operators(k)(l:l).eq.'N'.or.
     *          operators(k)(l:l).eq.'D'.or.operators(k)(l:l).eq.'Y'.or.
     *          operators(k)(l:l).eq.'F'.or.operators(k)(l:l).eq.'G'.or.
     *          operators(k)(l:l).eq.'Z'.or.operators(k)(l:l).eq.'Q'.or.
     *          operators(k)(l:l).eq.'S'.or.operators(k)(l:l).eq.'T'.or.
     *          operators(k)(l:l).eq.'U'.or.operators(k)(l:l).eq.'X'.or.
     *          operators(k)(l:l).eq.'I'.or.operators(k)(l:l).eq.'J'.or.
     *          operators(k)(l:l).eq.'K'.or.operators(k)(l:l).eq.'L'.or.
     *          operators(k)(l:l).eq.'M') Then
#endif
              matmultterm=matmultterm+1
            End If
 250      continue
          If (matmultterm.ge.2) Then
            matmulttot1=matmulttot1+matmultterm-1
            opmult(j)=opmult(j)+matmultterm-1
          End If
 200    continue
        ilow=ilow+ordercounter(j)
 180  continue
c
c
      If (.not.dkhscfflg) Then
        ilow=1
        do 182 j=0,xorder
#if defined(_MOLCAS_) || defined(MOLPRO)
          Call get_dkoperators(k,xopstring,xoperators)
#endif
          do 202 k=ilow,ilow+xordercounter(j)-1
            matmultterm=0
            do 252 l=1,xoperleng(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
            if(xopstring(l:l).eq.'V'.or.xopstring(l:l).eq.'N'.or.
     *         xopstring(l:l).eq.'D'.or.xopstring(l:l).eq.'Y'.or.
     *         xopstring(l:l).eq.'F'.or.xopstring(l:l).eq.'G'.or.
     *         xopstring(l:l).eq.'Z'.or.xopstring(l:l).eq.'Q'.or.
     *         xopstring(l:l).eq.'S'.or.xopstring(l:l).eq.'T'.or.
     *         xopstring(l:l).eq.'U'.or.xopstring(l:l).eq.'X'.or.
     *         xopstring(l:l).eq.'I'.or.xopstring(l:l).eq.'J'.or.
     *         xopstring(l:l).eq.'K'.or.xopstring(l:l).eq.'L'.or.
     *         xopstring(l:l).eq.'M') Then
#else
           if(xoperators(k)(l:l).eq.'V'.or.xoperators(k)(l:l).eq.'N'.or.
     *        xoperators(k)(l:l).eq.'D'.or.xoperators(k)(l:l).eq.'Y'.or.
     *        xoperators(k)(l:l).eq.'F'.or.xoperators(k)(l:l).eq.'G'.or.
     *        xoperators(k)(l:l).eq.'Z'.or.xoperators(k)(l:l).eq.'Q'.or.
     *        xoperators(k)(l:l).eq.'S'.or.xoperators(k)(l:l).eq.'T'.or.
     *        xoperators(k)(l:l).eq.'U'.or.xoperators(k)(l:l).eq.'X'.or.
     *        xoperators(k)(l:l).eq.'I'.or.xoperators(k)(l:l).eq.'J'.or.
     *        xoperators(k)(l:l).eq.'K'.or.xoperators(k)(l:l).eq.'L'.or.
     *        xoperators(k)(l:l).eq.'M') Then
#endif
              matmultterm=matmultterm+1
           End If
 252        continue
            If (matmultterm.ge.2) Then
              matmulttot2=matmulttot2+matmultterm-1
              xopmult(j)=xopmult(j)+matmultterm-1
            End If
 202      continue
          ilow=ilow+xordercounter(j)
 182    continue
      End If
c
      totmult=matmulttot1+matmulttot2
c
      If (dbgflg.ge.1) Then
        If (dkhscfflg) Then
          Write (dbgunit,2274)
2274      format (//2X,'Statistic about high-level substitution ',
     *            'process (Txxx) in step 3:  (only for "operators"!)',
     *            /2X,65('-'))
          Write (dbgunit,2275)
2275      format (/5X,'#',7X,'step1',4X,'-->',3X,'step3',3X,'order',3X,
     *          'no. of subs.',3X,/36X,'(tot)',5X,'(ttimes)'/)
        Else
          Write (dbgunit,2277)
2277      format (//2X,'Statistic about high-level substitution ',
     *            'process (Txxx) in step 3:  (only for "operators"',
     *            ' and "xoperators"!)',/2X,65('-'))
          Write (dbgunit,2278)
2278      format (/5X,'#',7X,'step1',4X,'-->',3X,'step3',3X,'order',1X,
     *            'order',1X,'order',2X,'no. of subs.',3X,/37X,'(V)',3X,
     *            '(X)',2X,'(tot)',3X,'(ttimes)'/)
        End If
        Call output5 (dkhscfflg,dbgunit,sused,ttimes,sorder,t,tscrchar,
     *                ttimestot)
        If (dkhscfflg) Then
          Write (dbgunit,1268)
1268      format (/2X,'No. of matrix multiplications necessary for ',
     *            'evaluation of operators:'/2X,68('-'),//9X,
     *            'order',10X,'opmult',/9X,'(tot)',/)
          do 290 j=0,dkhorder
            Write (dbgunit,1269) j,opmult(j)
1269        format (10X,I2,5X,I10)
 290      continue
          Write (dbgunit,1270) matmulttot1
1270      format (17X,10('-'),/17X,I10)
        Else
          Write (dbgunit,1278)
1278      format (/2X,'No. of matrix multiplications necessary for ',
     *            'evaluation of operators and xoperators:'/2X,83('-'),
     *            //9X,'order',10X,'opmult',13X,'xopmult',/10X,'(V)')
          do 291 j=0,max(dkhorder,xorder)
            Write (dbgunit,1279) j,opmult(j),xopmult(j)
1279        format (10X,I2,5X,I10,10X,I10)
 291      continue
          Write (dbgunit,1280) matmulttot1,matmulttot2,totmult
1280      format (17X,10('-'),10X,10('-'),/17X,I10,5X,'+',4X,I10,
     *            5X,'=',I10)
        End If
        Write (dbgunit,1043) paramtype
1043    format (//2X,'Number of terms of DKH Hamiltonian ',
     *        'and property X after step 3 (red_dkhstring):',2X,A3)
        Call distribution (dbgunit,dkhorder,xorder,dkhscfflg,
     *              ordercounter,opcounter,operleng,oporder,evenodd,
     *              doperators,operators,xordercounter,xopcounter,
     *              xoperleng,xoporder,xevenodd,xdoperators,xoperators)
c
        Write (dbgunit,1327)
1327    format (/2X,'Final operators have been written to the file ',
     *          '"dkhops.11".')
        If (.not.dkhscfflg) Write (dbgunit,1369)
1369    format (2X,'Final xoperators have been written to the file ',
     *          '"dkhops.12".')
c
        Write (dbgunit,1769)
1769    format (/2X,'Subroutine red_dkhstring (step3) has now been ',
     *          'completed.',//2X,145('*'))
      End If
c
CMR      If (dkhscfflg) Then
CMR        Write (stdout,1401) tnumber,ttimestot
CMR1401    format (/2X,'No. of different Sxxx-expressions occurring in',
CMR     *          /4X,'operators suited for substitution by Txxx = ',
CMR     *          'PSxxxP:',7X,I8,/2X,'No. of high-level subs. (Txxx) ',
CMR     *          'used in step3:',15X,I8)
CMR        Write (stdout,1402) opcounter-3,matmulttot1
CMR1402    format (/2X,'No. of low-level matrix-multipl. needed ',
CMR     *        'for the',/4X,'evaluation of all ',I8,
CMR     *        ' terms of "dkhops.11":',10X,I8)
CMR
CMR      Else
CMR        Write (stdout,1403) tnumber,ttimestot
CMR1403    format (/2X,'No. of different Sxxx-expressions occurring in',
CMR     *          /4X,'(x)operators suited for substitution by Txxx = ',
CMR     *          'PSxxxP:',4X,I8,/2X,'No. of high-level subs. (Txxx) ',
CMR     *          'used in step3:',15X,I8)
CMR        Write (stdout,1404) opcounter-2,totmult
CMR1404    format (/2X,'No. of low-level matrix-multipl. needed ',
CMR     *        'for the',/4X,'evaluation of all ',I8,
CMR     *        ' terms of "dkhops.11(12)":',6X,I8)
CMR      End If
c
#if defined(_MOLCAS_) || defined(MOLPRO)
      Call GetMem('term_red','Free','Inte',term,maxoperators*nwop)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(wopscounter)
        Call Unused_integer_array(woporder)
        Call Unused_integer_array(eowops)
        Call Unused_integer_array(scounter)
        Call Unused_integer_array(smult)
        Call Unused_integer_array(tcounter)
        Call Unused_integer_array(tmult)
        Call Unused_integer_array(tscrleng)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine exMap3_231(A,B,d1,d2)
! this routine does:
!
! A (a,bc) -> B(b,c,a)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: d1, d2
real(kind=wp), intent(in) :: A(d1,nTri_Elem(d2))
real(kind=wp), intent(out) :: B(d2,d2,d1)
integer(kind=iwp) :: i2, i23, i3

i23 = 0
do i2=1,d2
  do i3=1,i2
    i23 = i23+1
    B(i2,i3,:) = A(:,i23)
    B(i3,i2,:) = A(:,i23)
  end do
end do

return

end subroutine exMap3_231

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_box_packer

use fmm_global_paras, only: INTK, REALK, scheme_paras, raw_mm_paras, box_mm_paras
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_init_pkd_paras, &
          fmm_shift_and_pack_paras

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_pkd_paras(deepest_level,scheme,raw_paras,pkd_paras)

  use fmm_box_utils, only: fmm_box_centre, fmm_parent_box, fmm_grain

  implicit none
  integer(INTK), intent(in)         :: deepest_level
  type(scheme_paras), intent(in)    :: scheme
  type(raw_mm_paras), intent(inout) :: raw_paras(:)
  type(box_mm_paras), pointer       :: pkd_paras(:)

  type(box_mm_paras) :: tmp_paras(size(raw_paras))
  integer(INTK) :: i, l_up, box(3), foo
  integer(INTK) :: tmp_map(size(raw_paras))
  real(REALK) :: grain

  l_up = deepest_level-1
  grain = fmm_grain(scheme,l_up)
  do i=1,size(raw_paras)
    tmp_paras(i)%box(:) = raw_paras(i)%box(:)
    tmp_paras(i)%cntr(:) = raw_paras(i)%box_cntr(:)
    tmp_paras(i)%bra = raw_paras(i)%bra
    tmp_paras(i)%level = deepest_level
    tmp_paras(i)%id = i
    box(:) = fmm_parent_box(tmp_paras(i)%box(:))
    tmp_paras(i)%cntr_up(:) = fmm_box_centre(box,grain)
    tmp_paras(i)%map_up = 0   ! not defined yet
  end do

  if (associated(pkd_paras)) call fmm_quit('paras should be nullified!')
  if (.false.) then
    ! just build unpacked paras
    foo = size(raw_paras)
    allocate(pkd_paras(foo))
    pkd_paras(:) = tmp_paras(:)
    tmp_map = [(i,i=1,size(raw_paras))]
  else
    ! combine paras in same box and branch (i.e. packed form)
    call pack_boxed_paras(tmp_paras,pkd_paras,tmp_map)
  end if
  ! store map of packing indices (raw:boxed)
  raw_paras(:)%map_up = tmp_map(:)

end subroutine fmm_init_pkd_paras

!-------------------------------------------------------------------------------

subroutine fmm_shift_and_pack_paras(level,scheme,paras_in,paras_out)

  use fmm_box_utils, only: fmm_box_centre, fmm_grain, &
                           fmm_parent_box, fmm_parent_bra

  implicit none
  integer(INTK), intent(in)         :: level
  type(scheme_paras), intent(in)    :: scheme
  type(box_mm_paras), intent(inout) :: paras_in(:)
  type(box_mm_paras), pointer       :: paras_out(:)

  type(box_mm_paras) :: tmp_paras(size(paras_in))
  integer(INTK) :: i, l_up, box(3), foo
  integer(INTK) :: tmp_map(size(paras_in))
  real(REALK) :: grain, grain_up

  ! build tmp array for unpacked paras at next level up
  l_up = level-1
  grain = fmm_grain(scheme,level)
  grain_up = fmm_grain(scheme,l_up)
  do i=1,size(paras_in)
    tmp_paras(i)%box = fmm_parent_box(paras_in(i)%box)
    tmp_paras(i)%cntr(:) = fmm_box_centre(tmp_paras(i)%box,grain)
    tmp_paras(i)%bra = fmm_parent_bra(paras_in(i)%bra)
    tmp_paras(i)%level = level
    tmp_paras(i)%id = i
    box(:) = fmm_parent_box(tmp_paras(i)%box(:))
    tmp_paras(i)%cntr_up(:) = fmm_box_centre(box,grain_up)
    tmp_paras(i)%map_up = 0   ! not defined yet
  end do

  if (.false.) then
    ! just build unpacked paras
    foo = size(paras_in)
    allocate(paras_out(foo))
    paras_out(:) = tmp_paras(:)
    tmp_map = [(i,i=1,size(paras_in))]
  else
    ! combine paras in same box and branch (i.e. packed form)
    call pack_boxed_paras(tmp_paras,paras_out,tmp_map)
  end if
  ! store map of packing indices (raw:boxed)
  paras_in(:)%map_up = tmp_map(:)

end subroutine fmm_shift_and_pack_paras

!-------------------------------------------------------------------------------

subroutine pack_boxed_paras(paras_in,paras_out,map)

  implicit none
  type(box_mm_paras), intent(inout) :: paras_in(:)
  type(box_mm_paras), pointer       :: paras_out(:)
  integer(INTK), intent(out)        :: map(:)

  type(box_mm_paras) :: tmp_paras(size(paras_in))
  integer(INTK) :: i, k

  call fmm_sort_wrt_boxes_and_branches(1_INTK,paras_in)

  map(:) = 0
  tmp_paras(1) = paras_in(1)
  tmp_paras(1)%id = 1
  map(paras_in(1)%id) = 1

  k = 1
  do i=2,size(paras_in)

    if (paras_in(i)%box(3) /= paras_in(i-1)%box(3)) then
      k = k+1
    else if (paras_in(i)%box(2) /= paras_in(i-1)%box(2)) then
      k = k+1
    else if (paras_in(i)%box(1) /= paras_in(i-1)%box(1)) then
      k = k+1
    else if (paras_in(i)%bra /= paras_in(i-1)%bra) then
      k = k+1
    end if

    tmp_paras(k) = paras_in(i)
    tmp_paras(k)%id = k
    map(paras_in(i)%id) = k

  end do

  ! store packed parameters in exactly allocated array
  allocate(paras_out(k))
  paras_out = tmp_paras(1:k)

end subroutine pack_boxed_paras

!-------------------------------------------------------------------------------

recursive subroutine fmm_sort_wrt_boxes_and_branches(xyz,paras)

  use fmm_sort_paras, only: fmm_quicksort_wrt_boxes, &
                            fmm_quicksort_wrt_branches

  implicit none
  integer(INTK), intent(in)         :: xyz
  type(box_mm_paras), intent(inout) :: paras(:)

  integer(INTK) :: i, lo, hi
  real(REALK) :: q1, q2

  if (size(paras) == 1) return

  ! sort only if needed
  q1 = paras(1)%box(xyz)
  do i=2,size(paras)
    q2 = paras(i)%box(xyz)
    if (q2 < q1) then
      call fmm_quicksort_wrt_boxes(paras,xyz)
      exit
    end if
    q1 = q2
  end do

  ! sub-sort next box component
  lo = 1
  do i=2,size(paras)
    q1 = paras(i-1)%box(xyz)
    q2 = paras(i)%box(xyz)
    if (q2 /= q1) then
      hi = i-1
      if (xyz == 3) then
        call fmm_quicksort_wrt_branches(paras(lo:hi))
      else
        call fmm_sort_wrt_boxes_and_branches(xyz+1,paras(lo:hi))
      end if
      lo = i
    end if
  end do

  ! do last batch
  hi = size(paras)
  if (xyz == 3) then
    call fmm_quicksort_wrt_branches(paras(lo:hi))
  else
    call fmm_sort_wrt_boxes_and_branches(xyz+1,paras(lo:hi))
  end if

end subroutine fmm_sort_wrt_boxes_and_branches

!-------------------------------------------------------------------------------

end module fmm_box_packer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine setipermzeta_cvb(ipermzeta,
     >  orbs,symelm,izeta,
     >  orbinv,owrk,owrk2)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension ipermzeta(norb,nzeta)
      dimension orbs(norb,norb)
      dimension symelm(norb*norb,nsyme),izeta(nsyme)
      dimension orbinv(norb,norb),owrk(norb,norb),owrk2(norb,norb)
      save thresh
      data thresh/1.d-8/

      if(nzeta.gt.0)then
        call fmove_cvb(orbs,orbinv,norb*norb)
        call mxinv_cvb(orbinv,norb)
      endif

      izeta1=0
      do 100 isyme=1,nsyme
      if(izeta(isyme).ne.0)then
      izeta1=izeta1+1
c  Determine orbital permutation for sym. operation ISYME :
        call mxatb_cvb(symelm(1,isyme),orbs,norb,norb,norb,owrk2)
        call mxatb_cvb(orbinv,owrk2,norb,norb,norb,owrk)
        do 200 iorb=1,norb
        do 201 jorb=1,norb
        if(abs(abs(owrk(jorb,iorb))-one).lt.thresh)then
          ipermzeta(iorb,izeta1)=nint(owrk(jorb,iorb))*jorb
        elseif(abs(owrk(jorb,iorb)).gt.thresh)then
          write(6,*)' Fatal error! Symmetry operation ',tags(isyme),
     >      ' does not permute the VB orbitals!'
          call mxprint_cvb(owrk,norb,norb,0)
          call abend_cvb()
        endif
201     continue
200     continue
      endif
100   continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkciinfo_cvb()

use casvb_global, only: absym, i1alf, i1bet, iafrm, iato, ibfrm, ibto, n1a, n1b, nalf, nbet, norb, phato, phbto
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, ia, iax, iaxtmp, ib, ibx, ibxtmp, iel, indx, iorb, rc
integer(kind=iwp), allocatable :: iaccm(:), inewocc(:), locc(:), lunocc(:), maxgrph(:), mingrph(:), nk(:), xalf(:,:), xalf2(:,:), &
                                  xbet(:,:), xbet2(:,:)
integer(kind=iwp), external :: indget_cvb

call mma_allocate(xalf,[0,norb],[0,nalf],label='xalf')
call mma_allocate(xbet,[0,norb],[0,nbet],label='xbet')
call mma_allocate(xalf2,[0,norb],[0,nalf-1],label='xalf2')
call mma_allocate(xbet2,[0,norb],[0,nbet-1],label='xbet2')
call mma_allocate(mingrph,[0,norb],label='mingrph')
call mma_allocate(maxgrph,[0,norb],label='maxgrph')
call mma_allocate(nk,[0,norb],label='nk')
call mma_allocate(locc,norb+1,label='locc')
call mma_allocate(lunocc,norb+1,label='lunocc')
call mma_allocate(inewocc,norb,label='inewocc')
call mma_allocate(iaccm,norb,label='iaccm')

iafrm(:,:) = 0
ibfrm(:,:) = 0
iato(:,:) = 0
ibto(:,:) = 0
phato(:,:) = 0
phbto(:,:) = 0
! Alpha loop:
iaccm(:) = 0
do iorb=0,norb
  mingrph(iorb) = max(iorb-norb+nalf,0)
  maxgrph(iorb) = min(iorb,nalf)
end do
call weight_cvb(xalf,mingrph,maxgrph,nalf,norb)
nk(:) = maxgrph(:)
call occupy_cvb(nk,norb,locc,lunocc)
indx = 1
do
  inewocc(:) = 0
  do i=1,nalf
    inewocc(locc(i)) = 1
  end do
  do iel=1,norb
    if (inewocc(iel) == 1) then
      iaccm(iel) = iaccm(iel)+1
      i1alf(iaccm(iel),iel) = indx
    end if
  end do
  ! Indexing arrays:
  do i=1,nalf
    inewocc(locc(i)) = 0
    iafrm(locc(i),indx) = indget_cvb(inewocc,nalf,norb,xalf)
    inewocc(locc(i)) = 1
  end do
  call loind_cvb(norb,nalf,nk,mingrph,maxgrph,locc,lunocc,indx,xalf,rc)
  if (rc == 0) exit
end do
! Beta loop:
iaccm(:) = 0
do iorb=0,norb
  mingrph(iorb) = max(iorb-norb+nbet,0)
  maxgrph(iorb) = min(iorb,nbet)
end do
call weight_cvb(xbet,mingrph,maxgrph,nbet,norb)
nk(:) = maxgrph(:)
call occupy_cvb(nk,norb,locc,lunocc)
indx = 1
do
  inewocc(:) = 0
  do i=1,nbet
    inewocc(locc(i)) = 1
  end do
  do iel=1,norb
    if (inewocc(iel) == 1) then
      iaccm(iel) = iaccm(iel)+1
      i1bet(iaccm(iel),iel) = indx
    end if
  end do
  ! Indexing arrays:
  do i=1,nbet
    inewocc(locc(i)) = 0
    ibfrm(locc(i),indx) = indget_cvb(inewocc,nbet,norb,xbet)
    inewocc(locc(i)) = 1
  end do
  call loind_cvb(norb,nbet,nk,mingrph,maxgrph,locc,lunocc,indx,xbet,rc)
  if (rc == 0) exit
end do

! Altered definitions of I1ALF & I1BET:
do iorb=1,norb
  do ia=1,n1a
    iax = i1alf(ia,iorb)
    iaxtmp = iafrm(iorb,iax)
    i1alf(ia,iorb) = iaxtmp
  end do
end do
if (absym(4)) then
  ! I1ALF & I1BET may share memory:
  if (.not. associated(i1bet,i1alf)) i1bet(:,:) = i1alf(:,:)
else
  do iorb=1,norb
    do ib=1,n1b
      ibx = i1bet(ib,iorb)
      ibxtmp = ibfrm(iorb,ibx)
      i1bet(ib,iorb) = ibxtmp
    end do
  end do
end if
! More indexing arrays:
! Second alpha loop (NALF-1):
do iorb=0,norb
  mingrph(iorb) = max(iorb-norb+nalf-1,0)
  maxgrph(iorb) = min(iorb,nalf-1)
end do
call weight_cvb(xalf2,mingrph,maxgrph,nalf-1,norb)
nk(:) = maxgrph(:)
call occupy_cvb(nk,norb,locc,lunocc)
indx = 1
do
  inewocc(:) = 0
  do i=1,nalf-1
    inewocc(locc(i)) = 1
  end do
  do i=1,norb-nalf+1
    inewocc(lunocc(i)) = 1
    iato(lunocc(i),indx) = indget_cvb(inewocc,nalf,norb,xalf)
    inewocc(lunocc(i)) = 0
    if (mod(nalf+i+1+lunocc(i),2) == 0) then
      phato(lunocc(i),indx) = One
    else
      phato(lunocc(i),indx) = -One
    end if
  end do
  call loind_cvb(norb,nalf-1,nk,mingrph,maxgrph,locc,lunocc,indx,xalf2,rc)
  if (rc == 0) exit
end do

if (nbet > 0) then
  ! Second beta loop (NBET-1):
  do iorb=0,norb
    mingrph(iorb) = max(iorb-norb+nbet-1,0)
    maxgrph(iorb) = min(iorb,nbet-1)
  end do
  call weight_cvb(xbet2,mingrph,maxgrph,nbet-1,norb)
  nk(:) = maxgrph(:)
  call occupy_cvb(nk,norb,locc,lunocc)
  indx = 1
  do
    inewocc(:) = 0
    do i=1,nbet-1
      inewocc(locc(i)) = 1
    end do
    do i=1,norb-nbet+1
      inewocc(lunocc(i)) = 1
      ibto(lunocc(i),indx) = indget_cvb(inewocc,nbet,norb,xbet)
      inewocc(lunocc(i)) = 0
      if (mod(nbet+i+1+lunocc(i),2) == 0) then
        phbto(lunocc(i),indx) = One
      else
        phbto(lunocc(i),indx) = -One
      end if
    end do
    call loind_cvb(norb,nbet-1,nk,mingrph,maxgrph,locc,lunocc,indx,xbet2,rc)
    if (rc == 0) exit
  end do
end if

call mma_deallocate(xalf)
call mma_deallocate(xbet)
call mma_deallocate(xalf2)
call mma_deallocate(xbet2)
call mma_deallocate(mingrph)
call mma_deallocate(maxgrph)
call mma_deallocate(nk)
call mma_deallocate(locc)
call mma_deallocate(lunocc)
call mma_deallocate(inewocc)
call mma_deallocate(iaccm)

return

end subroutine mkciinfo_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE ONECT(H)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      DIMENSION H(*)
      CALL ONECT_INTERNAL(H)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE ONECT_INTERNAL(H)
      USE ISO_C_BINDING
      REAL*8, TARGET :: H(*)
      INTEGER, POINTER :: iH1(:),iH2(:),iH3(:),iH63(:)
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      IF(ICPF.EQ.0.AND.ISDCI.EQ.0.AND.INCPF.EQ.0)GO TO 15
C     CPF AND SDCI
      IF(IDENS.EQ.1)GO TO 10
C     (AI/JK) INTEGRALS
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(63))),iH63,[1])
      CALL AI_CPF(iH2,iH3,H(LW(26)),H(LW(27)),H(LW(62)),
     *H(LW(63)),iH63,H(LW(64)),H(LW(65)),H(LW(66)),H(LW(67)),
     *H(LW(31)),H(LW(32)),1)
      NULLIFY(iH2,iH3,iH63)
10    CALL C_F_POINTER(C_LOC(H(LW(1))),iH1,[1])
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL FIJ(iH1,iH2,iH3,H(LW(26)),H(LW(27)),
     *H(LW(62)),H(LW(64)),H(LW(65)),H(LW(66)),H(LW(67)),
     *H(LW(31)),H(LW(32)))
      NULLIFY(iH1,iH2,iH3)
      GO TO 20
C     MCPF
15    IF(IDENS.EQ.1)GO TO 5
C     (AI/JK) INTEGRALS
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(63))),iH63,[1])
      CALL MAI(iH2,iH3,H(LW(26)),H(LW(27)),H(LW(62)),
     *H(LW(63)),iH63,H(LW(64)),H(LW(65)),H(LW(66)),H(LW(67)),
     *H(LW(28)),H(LW(29)),H(LW(31)),H(LW(32)),IRC(ILIM),1)
      NULLIFY(iH2,iH3,iH63)
5     CALL C_F_POINTER(C_LOC(H(LW(1))),iH1,[1])
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL MFIJ(iH1,iH2,iH3,H(LW(26)),H(LW(27)),
     *H(LW(62)),H(LW(64)),H(LW(65)),H(LW(66)),H(LW(67)),H(LW(28)),
     *H(LW(29)),H(LW(31)),H(LW(32)),IRC(ILIM))
      NULLIFY(iH1,iH2,iH3)
20      Continue
      RETURN
      END SUBROUTINE ONECT_INTERNAL
*
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FOPAB(FIFA,NFIFA,IBRA,IKET,FOPEL)
      use definitions, only: iwp, wp
      use constants, only: Zero, One, Two
      use gugx, only: SGS, L2ACT, EXS, CIS
      use caspt2_global, only: LUCIEX, IDCIEX
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM,NORB,NISH,ISCF,NCONF,STSYM,NASH,
     &                         NAES
      IMPLICIT None

      integer(kind=iwp), intent(in):: NFIFA, IBRA, IKET
      real(kind=wp), intent(in):: FIFA(NFIFA)
      real(kind=wp), intent(out):: FOPEL

* Purely local array, offsets:
      integer(kind=iwp) IOFF(8)
      integer(kind=iwp) :: nLev
      real(kind=wp), allocatable:: BRA(:), KET(:), SGM(:)
      integer(kind=iwp) IOF,ISYM,IFTEST,IJ,I,ID,II,ISCR,IST,ISU,IT,
     &                  ITABS,ITTOT,ITUTOT,IU,IUABS,IUTOT,J,LEVT,LEVU,
     &                  NI
      real(kind=wp) ESUM,OCC,EINACT,FTU,TRC
      real(kind=wp), external:: DDot_

      nLev = SGS%nLev

* Procedure for computing one matrix element of the Fock matrix in the
* basis of the CASSCF states: <BRA|FOP|KET>
* In: The (possibly average) Fock matrix, active indices only, over the
* original CASSCF orbitals and the indices of the two states


* Offset table for accessing FIFA array:
      IOF=0
      DO ISYM=1,NSYM
        IOFF(ISYM)=IOF
        IOF=IOF+(NORB(ISYM)*(NORB(ISYM)+1))/2
      END DO

      IFTEST=0
      IF (IFTEST.GT.0) THEN
        WRITE(6,*)' The FIFA array:'
        DO ISYM=1,NSYM
          IJ=IOFF(ISYM)+1
          DO I=1,NORB(ISYM)
            WRITE(6,'(1x,5F16.8)')(FIFA(IJ+J),J=0,I-1)
            IJ=IJ+I
          END DO
        END DO
      END IF

* Specialized code for Closed-shell or Hi-spin HF:
* Sum up diagonal elements of FIFA times occ. number
* FIXME: This only works for diagonal elements, thus
* in the case of XMS this will not work...
      IF (ISCF.EQ.1 .OR. ISCF.EQ.2) THEN
        ESUM=Zero
        IF (IBRA.EQ.IKET) THEN
          DO ISYM=1,NSYM
            OCC=Two
            DO I=1,NISH(ISYM)
              ESUM=ESUM+OCC*FIFA(IOFF(ISYM)+(I*(I+1))/2)
            END DO
            IF (ISCF.eq.2) OCC=One
            DO J=1,NASH(ISYM)
              I=NISH(ISYM)+J
              ESUM=ESUM+OCC*FIFA(IOFF(ISYM)+(I*(I+1))/2)
            END DO
          END DO
        ELSE
          WRITE(6,*) ' Warning: neglecting the off-diagonal entries'
          WRITE(6,*) ' of H0, XMS will be equal to MS!'
        END IF
        FOPEL=ESUM
        RETURN
      END IF

* General CASSCF or RASSCF case:
* Sum up trace of FIFA over inactive orbitals only:
      TRC=Zero
      DO ISYM=1,NSYM
        DO I=1,NISH(ISYM)
          II=IOFF(ISYM)+(I*(I+1))/2
          TRC=TRC+FIFA(II)
        END DO
      END DO
* Contribution from inactive orbitals:
      EINACT=Two*TRC

      IF (IFTEST.GT.0) THEN
        WRITE(6,*)' Energy contrib from inactive orbitals:',EINACT
      END IF

* Allocate arrays for ket and bra wave functions
      CALL mma_allocate(BRA,NCONF,Label='BRA')
      CALL mma_allocate(KET,NCONF,Label='KET')
* Allocate array for sigma = Fock operator acting on ket:
      CALL mma_allocate(SGM,NCONF,LABEL='SGM')

* Load ket wave function
      ID=IDCIEX
      DO I=1,IKET-1
        CALL DDAFILE(LUCIEX,0,KET,NCONF,ID)
      END DO
      CALL DDAFILE(LUCIEX,2,KET,NCONF,ID)

      IF (IFTEST.GT.0) THEN
        WRITE(6,*)' IKET:',IKET
        WRITE(6,*)' Ket CI array:'
        ISCR=MIN(NCONF,20)
        WRITE(6,'(1x,5F16.8)')(KET(I),I=1,ISCR)
      END IF

* Compute (lowering part of) FIFA operator acting on
* the ket wave function.
      CALL DCOPY_(NCONF,[Zero],0,SGM,1)
      DO LEVU=1,NLEV
        IUABS=L2ACT(LEVU)
        ISU=SGS%ISM(LEVU)
        IU=IUABS-NAES(ISU)
        NI=NISH(ISU)
        IUTOT=NI+IU
        DO LEVT= 1,LEVU
          IF(SGS%ISM(LEVT).NE.ISU) GOTO 10
          ITABS=L2ACT(LEVT)
          IST=ISU
          IT=ITABS-NAES(IST)
          ITTOT=NI+IT
          ITUTOT=(IUTOT*(IUTOT-1))/2+ITTOT
          IF (ITTOT.GT.IUTOT) ITUTOT=(ITTOT*(ITTOT-1))/2+IUTOT
          FTU=FIFA(IOFF(ISU)+ITUTOT)
          IF(ABS(FTU).LT.1.0D-16) GOTO 10
          CALL SIGMA1(SGS,CIS,EXS,
     &                LEVT,LEVU,FTU,STSYM,KET,SGM)
  10      CONTINUE
        END DO
      END DO
* Add contribution from inactive part:
      CALL DAXPY_(NCONF,EINACT,KET,1,SGM,1)

      IF (IFTEST.GT.0) THEN
        WRITE(6,*)' SGM array from (lowering F)|KET>:'
        WRITE(6,'(1x,5F16.8)')(SGM(I),I=1,NCONF)
      END IF

* Load bra wave function
      ID=IDCIEX
      DO I=1,IBRA-1
        CALL DDAFILE(LUCIEX,0,BRA,NCONF,ID)
      END DO
      CALL DDAFILE(LUCIEX,2,BRA,NCONF,ID)

* Put matrix element into FOPEL:
      FOPEL=DDOT_(NCONF,BRA,1,SGM,1)

      IF (IFTEST.GT.0) THEN
        WRITE(6,*)' FOPEL is now:'
        WRITE(6,'(1x,5f16.8)')(FOPEL)
      END IF

* Compute (strictly lowering part of) FIFA operator acting on |BRA>.
* We are computing contributions <KET|Etu|BRA> with t<u, then
* using them as <BRA|Eut|KET>
* Note that I already have BRA in memory
      CALL DCOPY_(NCONF,[Zero],0,SGM,1)
      DO LEVU=2,NLEV
        IUABS=L2ACT(LEVU)
        ISU=SGS%ISM(LEVU)
        IU=IUABS-NAES(ISU)
        NI=NISH(ISU)
        IUTOT=NI+IU
        DO LEVT= 1,LEVU-1
          IF(SGS%ISM(LEVT).NE.ISU) GOTO 20
          ITABS=L2ACT(LEVT)
          IST=ISU
          IT=ITABS-NAES(IST)
          ITTOT=NI+IT
          ITUTOT=(IUTOT*(IUTOT-1))/2+ITTOT
          IF (ITTOT.GT.IUTOT) ITUTOT=(ITTOT*(ITTOT-1))/2+IUTOT
          FTU=FIFA(IOFF(ISU)+ITUTOT)
          IF(ABS(FTU).LT.1.0D-16) GOTO 20
          CALL SIGMA1(SGS,CIS,EXS,
     &                LEVT,LEVU,FTU,STSYM,BRA,SGM)
  20      CONTINUE
        END DO
      END DO

      IF (IFTEST.GT.0) THEN
        WRITE(6,*)' SGM array from (strictly lowering F)|BRA>:'
        WRITE(6,'(1x,5F16.8)')(SGM(I),I=1,NCONF)
      END IF

* Load ket wave function
      ID=IDCIEX
      DO I=1,IKET-1
        CALL DDAFILE(LUCIEX,0,KET,NCONF,ID)
      END DO
      CALL DDAFILE(LUCIEX,2,KET,NCONF,ID)

* Add contribution to matrix element FOPEL
      FOPEL=FOPEL+DDOT_(NCONF,KET,1,SGM,1)

      IF (IFTEST.GT.0) THEN
        WRITE(6,*)' FOPEL is now:'
        WRITE(6,'(1x,5f16.8)')(FOPEL)
      END IF

      CALL mma_deallocate(SGM)
      CALL mma_deallocate(BRA)
      CALL mma_deallocate(KET)

      END SUBROUTINE FOPAB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CPLAB(A,B,L,M,N,IA,IB,C,IC,IER)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: L, M, N, IA, IB, IC
real(kind=wp), intent(in) :: A(IA,M), B(IB,N)
real(kind=wp), intent(inout) :: C(IC,N)
integer(kind=iwp), intent(out) :: IER
integer(kind=iwp) :: I, J, K
real(kind=wp) :: TEMP

if ((IA >= L) .and. (IB >= M) .and. (IC >= L)) then
  IER = 0
  do I=1,L
    do J=1,N
      TEMP = Zero
      do K=1,M
        TEMP = A(I,K)*B(K,J)+TEMP
      end do
      C(I,J) = C(I,J)+TEMP
    end do
  end do
else
  IER = 129
end if

return

end subroutine CPLAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
*  Read_Grad
*
*> @brief Read a vector from the gradients file
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Reads a gradient or coupling vector from the gradients file (GRADS).
*> For a gradient use \p iNAC, \p jNAC = 0. For a coupling vector use
*> \p iRoot = 0.
*>
*> @param[out] Grad  Gradient vector to read
*> @param[in]  nGrad Length of \p Grad
*> @param[in]  iRoot Root number to which the gradient belongs
*> @param[in]  iNAC  First root of a coupling vector
*> @param[in]  jNAC  Second root of a coupling vector
*>
*> @return \p 0 if the vector was not found, \p 1 if the vector was
*>         found, \p -1 if the vector was marked as non-computable
************************************************************************
      Function Read_Grad(Grad,nGrad,iRoot,iNAC,jNAC)
      Implicit None
#include "real.fh"
#include "stdalloc.fh"
      Integer :: Read_Grad,nGrad,iRoot,iNAC,jNAC
      Real*8 :: Grad(nGrad)
      Integer, Dimension(5) :: TOC
      Integer, Dimension(1) :: iDum
      Integer, Dimension(:), Allocatable :: i_grad,i_nac
      Integer :: nRoots,nCoup,LuGrad,iAd,iSt,jSt,idx
      Logical :: Found
      Character(Len=5) :: Filename
*
* If the GRADS file does not exist, there is no gradient
*
      Filename='GRADS'
      Call f_Inquire(Filename,Found)
      If (.Not.Found) Then
        Read_Grad=0
      Else
*
* Read the header
*
        LuGrad=20
        Call DaName(LuGrad,Filename)
        iAd=0
        Call iDaFile(LuGrad,2,TOC,Size(TOC),iAd)
        Call iDaFile(LuGrad,2,iDum,1,iAd)
        nRoots=iDum(1)
        If (Max(iRoot,iNAC,jNAC).gt.nRoots) Then
          Call WarningMessage(2,'Bad number of roots in GRADS file')
          Call Abend()
        End If
        Call iDaFile(LuGrad,2,iDum,1,iAd)
        If (iDum(1).ne.nGrad) Then
          Call WarningMessage(2,'Bad length in GRADS file')
          Call Abend()
        End If
        nCoup=Max(1,nRoots*(nRoots-1)/2)
        Call mma_Allocate(i_grad,nRoots)
        Call mma_Allocate(i_nac,nCoup)
        Call iDaFile(LuGrad,2,i_grad,nRoots,iAd)
        Call iDaFile(LuGrad,2,i_nac,nCoup,iAd)
*
* Read the gradient or NAC vector
*
        If (iRoot.eq.0) Then
          If ((iNAC.ne.0).and.(jNAC.ne.0)) Then
            iSt=Max(iNAC,jNAC)-1
            jSt=Min(iNAC,jNAC)
            idx=iSt*(iSt-1)/2+jSt
            iAd=i_nac(idx)
          Else
            iAd=-1
          End If
        Else
          idx=iRoot
          iAd=i_grad(idx)
        End If
*
        If (iAd.eq.0) Then
          Read_Grad=0
        Else If (iAd.lt.0) Then
          Read_Grad=-1
        Else
          Call dDaFile(LuGrad,2,Grad,nGrad,iAd)
          Read_Grad=1
        End If
*
        Call DaClos(LuGrad)
        Call mma_Deallocate(i_grad)
        Call mma_Deallocate(i_nac)
*
      End If
      If (Read_Grad.le.0) Then
        Call FZero(Grad,nGrad)
      End If
*
      End Function Read_Grad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine setiaprtot_cvb()

use casvb_global, only: iapr, ibpr, ixapr, ixbpr, nda, ndb, npvb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp

implicit none
real(kind=wp) :: dum1(1), dum2(1), dum3
real(kind=wp), allocatable :: tmp(:,:)

call mma_allocate(tmp,nda,ndb,label='tmp')
call dpci2vb_cvb(tmp,dum1,dum2,0,dum3,4)
call setiaprtot2_cvb(tmp,iapr,ixapr,ibpr,ixbpr,npvb,nda,ndb)
call mma_deallocate(tmp)

return

end subroutine setiaprtot_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_Xred(X,dimbe,addbe,dimga,addga)
! check X(be,u,ga,v)
! do X clenu nieje zahrnuty prispevok od Aex, preto picuje

use chcc_global, only: Ac, Gooc, Gvvc, Jc, Kc, no, nv, Q1, Q21, Q22, Q3, T1c, T2c
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dimbe, addbe, dimga, addga
real(kind=wp), intent(in) :: X(dimbe,no,dimga,no)
integer(kind=iwp) :: a, be, bad, ga, i, j, u, v
real(kind=wp) :: s, s1

bad = 0
do v=1,no
  do ga=addga+1,addga+dimga
    do u=1,no
      do be=addbe+1,addbe+dimbe

        s = Zero

        ! X2 (T24)   + Gvv(a,be)   . t2(ga,a,v,u)
        s1 = Zero
        do a=1,nv
          s1 = s1+Gvvc(be,a)*T2c(a,ga,u,v)
        end do
        s = s+Two*s1

        ! X3 (T25)   - Goo(i,u)    . t2(ga,be,v,i)
        s1 = Zero
        do i=1,no
          s1 = s1+Gooc(i,u)*T2c(ga,be,v,i)
        end do
        s = s-Two*s1

        ! T1 cleny
        s1 = Zero

        do a=1,nv
          s1 = s1+Q3(a,ga,be,u)*T1c(a,v)
        end do

        do i=1,no
          s1 = s1-Q1(be,u,i,v)*T1c(ga,i)
        end do

        do i=1,no
          do a=1,nv
            s1 = s1-(Q22(a,ga,i,u)*T1c(be,i))*T1c(a,v)
            s1 = s1-(Q21(a,i,be,u)*T1c(a,v))*T1c(ga,i)
          end do
        end do

        !red s = s+Two*s1

        ! X4 (T22)   + sum(i,j)   [ Ta(be,ga,i,j) . A(i,j,u,v)  ]
        s1 = Zero
        do i=1,no
          do j=1,no
            s1 = s1+Ac(i,j,u,v)*(T2c(be,ga,i,j)+T1c(be,i)*T1c(ga,j))
          end do
        end do
        s = s+s1

        ! X1   <-  Q(be,u,i,a) . (2 t2(ga,a,v,i) - t2(ga,a,i,v))
        ! calc as (2J(be,i,u,a)-K(i,be,u,a)*(2t2(a,ga,i,v)-t2(ga,a,i,v)
        s1 = Zero
        do i=1,no
          do a=1,nv
            s1 = s1+(Two*Jc(be,i,u,a)-Kc(i,be,u,a))*(Two*T2c(a,ga,i,v)-T2c(ga,a,i,v))
          end do
        end do
        s = s+s1

        ! <- V1(be',u,ga',v)
        s1 = Q21(be,u,ga,v)
        s = s+s1

        if (abs(X(be-addbe,u,ga-addga,v)-s) > 1.0e-10_wp) bad = bad+1

      end do
    end do
  end do
end do

write(u6,*) ' Chck X :',bad

return

end subroutine Chck_Xred

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine IFRMDS(IARRAY,NDIM,MBLOCK,IFILE)
! TRANSFER INTEGER ARRAY FROM DISC FILE IFILE
!
! NBLOCK < 0 INDICATES USE OF FASTIO
!
! If nblock == 0 NBLOCK = NDIM

use lucia_data, only: IDISK
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NDIM, MBLOCK, IFILE
integer(kind=iwp), intent(out) :: IARRAY(NDIM)
integer(kind=iwp) :: IBASE, IDUMMY(1), IREST, NBLOCK

NBLOCK = MBLOCK

! DO NOT USE FASTIO
if (NBLOCK <= 0) NBLOCK = NDIM
IREST = NDIM
IBASE = 0
do
  if (IREST > NBLOCK) then
    call IDAFILE(IFILE,2,IARRAY(IBASE+1),NBLOCK,IDISK(IFILE))
    IBASE = IBASE+NBLOCK
    IREST = IREST-NBLOCK
  else
    call IDAFILE(IFILE,2,IARRAY(IBASE+1),IREST,IDISK(IFILE))
    IREST = 0
  end if
  call IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
  if (IREST <= 0) exit
end do

end subroutine IFRMDS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine output3b (unit,xopcounter,xoperleng,xoporder,xevenodd,
     *                     xdoperators,xoperators)
c
c*******************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 12.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer unit,xopcounter,xoperleng(maxoperators),
     *        xoporder(maxoperators),xevenodd(maxoperators)
      REAL*8 xdoperators(maxoperators)
#if defined(_MOLCAS_) || defined(MOLPRO)
      character xoperators(*)
      character*(maxlength) xopstr
#else
      character*(maxlength) xoperators(maxoperators)
#endif
      integer j
c
      write (unit,1012)
1012  format (/6X,'#',2X,'length',90X,'order',2X,'symm.',2X,
     *        'coeff.',/,106X,'(V)',/2X)
      do 10 j=1,xopcounter
#if defined(_MOLCAS_) || defined(MOLPRO)
        call get_dkoperators(j,xopstr,xoperators)
        write (unit,1015) j,xoperleng(j),xopstr(1:xoperleng(j)),
     *                    xoporder(j),xevenodd(j),xdoperators(j)
#else
        write (unit,1015) j,xoperleng(j),xoperators(j)(1:xoperleng(j)),
     *                    xoporder(j),xevenodd(j),xdoperators(j)
#endif
1015    format (I7,2X,I3,2X,A90,2X,I2,5X,I2,3X,F17.14)
  10  continue
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RotateOrb_ER(R,CMO,nBasis,nOrb2Loc,Debug)
! Thomas Bondo Pedersen, November 2005.
!
! Purpose: rotate ER orbitals,
!          CMO -> CMO * U
!          U = R*[R^T*R]^(-1/2)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBasis, nOrb2Loc
real(kind=wp), intent(in) :: R(nOrb2Loc,nOrb2Loc)
real(kind=wp), intent(inout) :: CMO(nBasis,nOrb2Loc)
logical(kind=iwp), intent(in) :: Debug
integer(kind=iwp) :: irc
real(kind=wp) :: ThrU
real(kind=wp), allocatable :: CMOscr(:,:), U(:,:)
character(len=*), parameter :: SecNam = 'RotateOrb_ER'

if ((nOrb2Loc < 1) .or. (nBasis < 1)) return

! Allocate transformation matrix U.
! ---------------------------------

call mma_allocate(U,nOrb2Loc,nOrb2Loc,label='Umat')

! Compute U.
! ----------

call GetU_ER(U,R,nOrb2Loc)

! Debug: check that U is unitary.
! -------------------------------

if (Debug) then
  ThrU = 1.0e-10_wp
  irc = -1
  call Chk_Unitary(irc,U,nOrb2Loc,ThrU)
  if (irc /= 0) then
    call SysAbendMsg(SecNam,'U matrix is not unitary!',' ')
  end if
end if

! Update C.
! ---------

call mma_allocate(CMOscr,nBasis,nOrb2Loc,label='CMOscr')
CMOscr(:,:) = CMO
call DGEMM_('N','N',nBasis,nOrb2Loc,nOrb2Loc,One,CMOscr,nBasis,U,nOrb2Loc,Zero,CMO,nBasis)
call mma_deallocate(CMOscr)

! De-allocate U.
! --------------

call mma_deallocate(U)

end subroutine RotateOrb_ER

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine iRBuf(Array,nArray,Copy)
      Implicit Real*8 (a-h,o-z)
      Logical Copy
#include "SysDef.fh"
      Integer Array(nArray)
*
      Call idRBuf(Array,nArray/RtoI,Copy)
*
      Return
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine idRBuf(Array,nArray,Copy)
      Use Iso_C_Binding
      Integer :: nArray
      Logical :: Copy
      Integer, Target :: Array(nArray)
      Real*8, Pointer :: dArray(:)
      Call C_F_Pointer(C_Loc(Array(1)),dArray,[nArray])
      Call dRBuf(dArray,nArray,Copy)
      Nullify(dArray)
      End Subroutine idRBuf
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine IndSft2(iCmp,iShell,iBas,jBas,kBas,lBas,Shijij,iAO,iAOst,ijkl,SOint,nSOint,iSOSym,nSOs)
!***********************************************************************
!  object: to sift and index the SO integrals.                         *
!                                                                      *
!          the indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          april '90                                                   *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use k2_arrays, only: Sew_Scr
use SOAO_Info, only: iAOtSO, iOffSO
use lw_Info, only: lwInt, lwSqn, lwSyb
use Gateway_Info, only: ThrInt
use Symmetry_Info, only: nIrrep
use sort_data, only: DimSyB, iStBin, lSll, mxSyP, nSkip, Square, TriSyB
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Constants, only: Zero
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iCmp(4), iShell(4), iBas, jBas, kBas, lBas, iAO(4), iAOst(4), ijkl, nSOInt, nSOs, iSOSym(2,nSOs)
logical(kind=iwp), intent(in) :: Shijij
real(kind=wp), intent(in) :: SOint(ijkl,nSOint)
integer(kind=iwp) :: i1, i12, i2, i3, i34, i4, iBin, ij, ipD, ipP1, ipP2, ipP3, ipP4, iqq1, iqq2, iqq3, iqq4, iSO, iSOi, iSq1, &
                     iSq2, iSq3, iSq4, iSqNum, iSyBlk, iSym(0:7), iSym12, iSym34, iSymi, ix, j, j1, j12, j2, j2max, j3, j4, jBin, &
                     jCmpMx, jSO, jSOj, jSqNum, jSyBlk, jSym(0:7), jSymj, k12, k34, kl, kSO, kSOk, kSym(0:7), kSymk, lCmpMx, lSO, &
                     lSOl, lSym(0:7), lSyml, MemSO2, nij, nijkl, nkl, nUt
real(kind=wp) :: A_Int
logical(kind=iwp) :: dupli, qij, qijij, qkl, Shij, Shkl
#ifdef _DEBUGPRINT_
real(kind=wp) :: r1, r2, Tr1 = Zero, Tr2 = Zero
real(kind=wp), external :: DDot_
#endif

k12 = 0
k34 = 0
#ifdef _DEBUGPRINT_
r1 = sum(SOint(:,:))
r2 = DDot_(ijkl*nSOInt,SOInt,1,SOInt,1)
tr1 = tr1+r1
tr2 = tr2+r2
write(u6,*) ' Sum=',r1,tr1
write(u6,*) ' Dot=',r2,tr2
call RecPrt(' in indsft:SOint ',' ',SOint,ijkl,nSOint)
#endif
memSO2 = 0

! allocate space to store integrals together with their
! Symmetry batch and sequence number
! To avoid conflicts in using memory this is done in the
! subroutine PSOAO

nUt = -1

! quadruple loop over elements of the basis functions angular
! description. loops are reduced to just produce unique SO integrals
! observe that we will walk through the memory in AOint in a
! sequential way.

Shij = (iShell(1) == iShell(2))
Shkl = (iShell(3) == iShell(4))
do i1=1,iCmp(1)
  do j=0,nIrrep-1
    ix = 0
    if (iAOtSO(iAO(1)+i1,j) > 0) ix = 2**j
    iSym(j) = ix
  end do
  jCmpMx = iCmp(2)
  if (Shij) jCmpMx = i1
  do i2=1,jCmpMx
    do j=0,nIrrep-1
      ix = 0
      if (iAOtSO(iAO(2)+i2,j) > 0) ix = 2**j
      jSym(j) = ix
    end do
    qij = i1 == i2
    if (iShell(2) > iShell(1)) then
      i12 = iCmp(2)*(i1-1)+i2
    else
      i12 = iCmp(1)*(i2-1)+i1
    end if
    do i3=1,iCmp(3)
      do j=0,nIrrep-1
        ix = 0
        if (iAOtSO(iAO(3)+i3,j) > 0) ix = 2**j
        kSym(j) = ix
      end do
      lCmpMx = iCmp(4)
      if (Shkl) lCmpMx = i3
      do i4=1,lCmpMx
        do j=0,nIrrep-1
          ix = 0
          if (iAOtSO(iAO(4)+i4,j) > 0) ix = 2**j
          lSym(j) = ix
        end do
        qkl = i3 == i4
        if (iShell(4) > iShell(3)) then
          i34 = iCmp(4)*(i3-1)+i4
        else
          i34 = iCmp(3)*(i4-1)+i3
        end if
        if (Shijij .and. (i34 > i12)) cycle
        qijij = (Shijij .and. (i12 == i34))
        !write(u6,*) 'i1,i2,i3,i4=',i1,i2,i3,i4

        ! loop over Irreps which are spanned by the basis function.
        ! again, the loop structure is restricted to ensure unique
        ! integrals.

        do j1=0,nIrrep-1
          if (iSym(j1) == 0) cycle
          j2max = nIrrep-1
          if (Shij .and. qij) j2max = j1
          do j2=0,j2max
            if (jSym(j2) == 0) cycle
            j12 = ieor(j1,j2)
            if (qijij) then
              if (Shij .and. qij) then
                k12 = nTri_Elem(j1)+j2+1
              else if (Shij) then
                k12 = nIrrep*j1+j2+1
              else if (iShell(1) > iShell(2)) then
                k12 = nIrrep*j1+j2+1
              else
                k12 = nIrrep*j2+j1+1
              end if
            end if

            iSymi = max(j1,j2)+1
            jSymj = min(j1,j2)+1

            do j3=0,nIrrep-1
              if (kSym(j3) == 0) cycle
              j4 = ieor(j12,j3)
              if (lSym(j4) == 0) cycle
              if (Shkl .and. qkl .and. (j4 > j3)) cycle
              if (qijij) then
                if (Shkl .and. qkl) then
                  k34 = nTri_Elem(j3)+j4+1
                else if (Shkl) then
                  k34 = nIrrep*j3+j4+1
                else if (iShell(3) > iShell(4)) then
                  k34 = nIrrep*j3+j4+1
                else
                  k34 = nIrrep*j4+j3+1
                end if
                if (k34 > k12) cycle
              end if
              !write(u6,*) 'j1,j2,j3,j4=',j1,j2,j3,j4

              memSO2 = memSO2+1
              if ((nSkip(j1+1)+nSkip(j2+1)+nSkip(j3+1)+nSkip(j4+1)) /= 0) cycle

              ! Compute absolute starting SO index
              iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)+iOffSO(j1)
              jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)+iOffSO(j2)
              kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+iOffSO(j3)
              lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+iOffSO(j4)
              !write(u6,*) 'iSO,jSO,kSO,lSO=',iSO,jSO,kSO,lSO

              kSymk = max(j3,j4)+1
              lSyml = min(j3,j4)+1

              iSym12 = TriSyB(iSymi,jSymj)
              iSym34 = TriSyB(kSymk,lSyml)

              ! Order Irrep index canonical
              if (iSym34 > iSym12) then
                iSyBlk = mxSyP*(iSym34-1)+iSym12
                jSyBlk = mxSyP*(iSym12-1)+iSym34
                nij = DimSyB(kSymk,lSyml)
                nkl = DimSyB(iSymi,jSymj)
                iSq1 = nkl
                iSq2 = 1
                iSq3 = 1
                iSq4 = nij
                iQQ1 = lSll(iSyBlk)/nkl
                iQQ2 = nkl+1
                iQQ3 = nij+1
                iQQ4 = lSll(jSyBlk)/nij
                iPP1 = iQQ1
                iPP2 = 0
                iPP3 = 0
                iPP4 = iQQ4
              else
                iSyBlk = mxSyP*(iSym12-1)+iSym34
                jSyBlk = mxSyP*(iSym34-1)+iSym12
                nij = DimSyB(iSymi,jSymj)
                nkl = DimSyB(kSymk,lSyml)
                iSq1 = 1
                iSq2 = nkl
                iSq3 = nij
                iSq4 = 1
                iQQ1 = nkl+1
                iQQ2 = lSll(iSyBlk)/nkl
                iQQ3 = lSll(jSyBlk)/nij
                iQQ4 = nij+1
                iPP1 = 0
                iPP2 = iQQ2
                iPP3 = iQQ3
                iPP4 = 0
              end if
              !write(u6,*) '<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
              !write(u6,*) 'iSyBlk,jSyBlk=',iSyBlk,jSyBlk
              !write(u6,*) 'iSq1,iSq2,iSq3,iSq4=',iSq1,iSq2,iSq3,iSq4
              !write(u6,*) 'iQQ1,iQQ2,iQQ3,iQQ4=',iQQ1,iQQ2,iQQ3,iQQ4
              !write(u6,*) 'nkl,nij=',nkl,nij

              ! Duplicate integral if permuted integral is
              ! in the same irrep or if all blocks should
              ! be duplicated.
              dupli = (iSyBlk == jSyBlk) .or. Square

              if (.not. dupli) then

                nijkl = 0
                do lSOl=lSO,lSO+lBas-1
                  do kSOk=kSO,kSO+kBas-1
                    kl = iPD(kSOk,lSOl,iSOSym,nSOs)
                    do jSOj=jSO,jSO+jBas-1
                      do iSOi=iSO,iSO+iBas-1
                        nijkl = nijkl+1
                        A_Int = SOint(nijkl,memSO2)
                        if (abs(A_Int) < ThrInt) cycle
                        ij = iPD(iSOi,jSOj,iSOSym,nSOs)
                        !write(u6,*)
                        !write(u6,*) 'iSOi,jSOj,kSOk,lSOl=',iSOi,jSOj,kSOk,lSO
                        !write(u6,*) 'ij,kl=',ij,kl

                        nUt = nUt+1
                        Sew_Scr(lwInt+nUt) = A_Int
                        iBin = (kl-1)/iQQ1+(ij-1)/iQQ2
                        iSqNum = (kl-iBin*iPP1)*iSq1+(ij-iBin*iPP2)*iSq2-nkl
                        Sew_Scr(lwSqN+nUt) = real(iSqNum,kind=wp)
                        Sew_Scr(lwSyB+nUt) = real(iBin+iStBin(iSyBlk),kind=wp)
                        !write(u6,*) 'iSqNum,iBin=',iSqNum,iBin+iStBin(iSyBlk)

                      end do
                    end do
                  end do
                end do

              else

                nijkl = 0
                do lSOl=lSO,lSO+lBas-1
                  do kSOk=kSO,kSO+kBas-1
                    kl = iPD(kSOk,lSOl,iSOSym,nSOs)
                    do jSOj=jSO,jSO+jBas-1
                      do iSOi=iSO,iSO+iBas-1
                        nijkl = nijkl+1
                        A_Int = SOint(nijkl,memSO2)
                        if (abs(A_Int) < ThrInt) cycle
                        ij = iPD(iSOi,jSOj,iSOSym,nSOs)

                        !write(u6,*)
                        !write(u6,*) 'iSOi,jSOj,kSOk,lSOl=',iSOi,jSOj,kSOk,lSO
                        !write(u6,*) 'ij,kl=',ij,kl

                        nUt = nUt+1
                        Sew_Scr(lwInt+nUt) = A_Int
                        iBin = (kl-1)/iQQ1+(ij-1)/iQQ2
                        iSqNum = (kl-iBin*iPP1)*iSq1+(ij-iBin*iPP2)*iSq2-nkl
                        Sew_Scr(lwSqN+nUt) = real(iSqNum,kind=wp)
                        Sew_Scr(lwSyB+nUt) = real(iBin+iStBin(iSyBlk),kind=wp)
                        !write(u6,*) 'iSqNum,iBin=',iSqNum,iBin+iStBin(iSyBlk)

                        nUt = nUt+1
                        Sew_Scr(lwInt+nUt) = A_Int
                        jBin = (kl-1)/iQQ3+(ij-1)/iQQ4
                        jSqNum = (kl-jBin*iPP3)*iSq3+(ij-jBin*iPP4)*iSq4-nij
                        Sew_Scr(lwSqN+nUt) = real(jSqNum,kind=wp)
                        Sew_Scr(lwSyB+nUt) = real(jBin+iStBin(jSyBlk),kind=wp)
                        !write(u6,*) 'jSqNum,jBin=',jSqNum,jBin+iStBin(jSyBlk)

                      end do
                    end do
                  end do
                end do

              end if

            end do
          end do
        end do

      end do
    end do
  end do
end do

! pass the integral to phase 1 of the bin sorting algorithm

call SORT1A(nUt+1,Sew_Scr(lwInt),Sew_Scr(lwSqN),Sew_Scr(lwSyB))
nUt = 0

return

end subroutine IndSft2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine uci()
!***********************************************************************
! Purpose: construct the transformation matrix U_CI from the basis
!          of CSFs to the basis of spin-free states (accounting for
!          spin-degeneracy)
!***********************************************************************
!
!  UTU    : overlap matrix UTU=U_CI**T*U_CI for the spin-free states

use rhodyn_data, only: CI, flag_so, ipglob, ispin, lroots, lrootstot, N, nconf, nconftot, prep_id, prep_uci, runmode, sint, &
                       threshold, U_CI
use rhodyn_utils, only: dashes, mult
use mh5, only: mh5_create_dset_real, mh5_init_attr, mh5_put_dset
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), allocatable :: UTU(:,:)
integer(kind=iwp) :: i, j, k, l, ii, jj, kk, ll, prep_utu

if (ipglob > 2) then
  call dashes()
  write(u6,*) 'Begin of uci'

  write(u6,*) 'Dimensions of transformation matrix accounting for spin-degeneracy'
  call dashes()
  write(u6,sint) 'Number of total CSFs:',nconftot
  write(u6,sint) 'Number of total states (roots):',lrootstot
  call dashes()
end if

U_CI = Zero
ii = 0
jj = 0
kk = 0
if (.not. flag_so) then
  if (ipglob > 2) write(u6,*) 'Construct matrix U_CI'
  do k=1,N
    if (k /= 1) then
      kk = kk+lroots(k-1)
    end if
    do i=1,nconf(k)
      ii = ii+1
      do j=1,lroots(k)
        U_CI(ii,j+kk) = CI(i,j,k)
      end do
    end do
  end do
else
  if (ipglob > 2) write(u6,*) 'Construct matrix U_CI with SO accounting'
  ll = 0
  do l=1,N
    if (l /= 1) then
      ll = ll+lroots(l-1)*ispin(l-1)
      kk = kk+nconf(l-1)*ispin(l-1)
    end if
    do i=1,nconf(l)
      do j=1,lroots(l)
        do k=1,ispin(l)
          ii = kk+(i-1)*ispin(l)+k
          jj = ll+(j-1)*ispin(l)+k
          U_CI(ii,jj) = CI(i,j,l)
        end do
      end do
    end do
  end do
end if

if ((runmode /= 2) .and. (runmode /= 4)) call mh5_put_dset(prep_uci,U_CI)

! Check whether the transformation matrix U_CI is orthonormalized
if (ipglob > 3) then
  call mma_allocate(UTU,lrootstot,lrootstot)
  call mult(U_CI,U_CI,UTU,.true.,.false.)
  call dashes()
  write(u6,*) 'Internal check for CI coefficients'
  do i=1,lrootstot
    do j=1,lrootstot
      if (i /= j) then
        if (abs(UTU(i,j)) >= threshold) then
          write(u6,*) 'ERROR INFO!!! CI coeffs are not orthonormalized',i,j,UTU(i,j)
        end if
      else if (i == j) then
        if (abs(UTU(i,j)-One) >= threshold) then
          write(u6,*) 'ERROR INFO!!! CI coeffs are not orthonormalized',i,j,UTU(i,j)
        end if
      end if
    end do
  end do
  call dashes()
  write(u6,*) 'If there is no error info printout'
  write(u6,*) 'CI coeffs are orthonormalized'

  if ((runmode /= 2) .and. (runmode /= 4)) then
    prep_utu = mh5_create_dset_real(prep_id,'UTU',2,[lrootstot,lrootstot])
    call mh5_init_attr(prep_utu,'description','UTU=U_CI**T*U_CI overlap matrix')
    call mh5_put_dset(prep_utu,UTU)
  end if

  call dashes()
  write(u6,*) 'Overlap of transformation matrix is saved in file'
  call dashes()
  if (allocated(UTU)) call mma_deallocate(UTU)
end if

if (ipglob > 2) write(u6,*) 'End of uci'

end subroutine uci

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_D1sao_Var(D1Sao,nD1Sao)

use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nD1Sao
real(kind=wp), intent(out) :: D1Sao(nD1Sao)
integer(kind=iwp) :: nDens
logical(kind=iwp) :: Found
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ii, iIrrep, nBas(0:7) = -1, nSym = -1
#endif
character(len=*), parameter :: Label = 'D1saoVar'

! Read the variational 1st order density matrix
! density matrix in AO/SO basis
!                                                                      *
!***********************************************************************
!                                                                      *
call qpg_dArray(Label,Found,nDens)
if ((.not. Found) .or. (nDens == 0)) then
  call Get_dArray_chk('D1sao',D1sao,nD1Sao)
else
  call Get_dArray(Label,D1sao,nD1Sao)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
if (nSym < 0) call get_iScalar('nSym',nSym)
if (nBas(0) < 0) call Get_iArray('nBas',nBas,nSym)
write(u6,*) 'variational 1st order spin density matrix'
ii = 1
do iIrrep=0,nSym-1
  if (nBas(iIrrep) > 0) then
    write(u6,*) 'symmetry block',iIrrep
    call TriPrt(' ',' ',D1Sao(ii),nBas(iIrrep))
    ii = ii+nBas(iIrrep)*(nBas(iIrrep)+1)/2
  end if
end do
#endif

return

end subroutine Get_D1sao_Var

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine VDer_PCM(nAt,nTs,nS,AtmC,AtmChg,EF_n,EF_e,
     &     Tessera,iSphe,DerTes,DerPunt,DerRad,DerCentr,VDer)
      Implicit Real*8 (a-h,o-z)
      Dimension AtmC(3,nAt),AtmChg(nAt)
      Dimension EF_n(3,*),EF_e(3,*),VDer(nTs,*)
      Dimension Tessera(4,*),iSphe(*)
      Dimension DerTes(nTs,nAt,3),DerPunt(nTs,nAt,3,3)
      Dimension DerRad(nS,nAt,3),DerCentr(nS,nAt,3,3)
      Integer Lu
cpcm_solvent very temporary! read the potential derivatives from file
      Lu=1
      Lu=IsFreeUnit(Lu)
      Call Molcas_Open(Lu,'DerPot.dat')
*     open(1,file='DerPot.dat',status='old',form='formatted')
      do 1134 iAt = 1, nAt
        do 1135 iCoord = 1, 3
          Index = 3 * (iAt-1) + iCoord
          do 1136 iTs = 1, nTs
            read(1,*)VDer(iTs,Index)
 1136     continue
 1135   continue
 1134 continue
      close(1)
cpcm_solvent end
c     Loop on atoms and coordinates
      Do 100 iAt = 1, nAt
        Do 101 iCoord = 1, 3
          Index = 3 * (iAt-1) + iCoord
*
*---- (Total) derivative of the electronic + nuclear potential
*
          Do 200 iTs = 1, nTs
            L = iSphe(iTs)
c           Derivative of the representative point
            dX = DerPunt(iTs,iAt,iCoord,1)+DerCentr(L,iAt,iCoord,1)
            dY = DerPunt(iTs,iAt,iCoord,2)+DerCentr(L,iAt,iCoord,2)
            dZ = DerPunt(iTs,iAt,iCoord,3)+DerCentr(L,iAt,iCoord,3)
c           Distance tessera - nucleus
            DTessNuc = Sqrt( (Tessera(1,iTs) - AtmC(1,iAt))**2 +
     &                       (Tessera(2,iTs) - AtmC(2,iAt))**2 +
     &                       (Tessera(3,iTs) - AtmC(3,iAt))**2 )
            dCoord = Tessera(iCoord,iTs) - AtmC(iCoord,iAt)
c           Deriv. of the nuclear potential (with fixed repres. point)
            DVNuc = - AtmChg(iAt) * dCoord / DTessNuc**3
c           Electric field (electrons and nuclei) times the derivative of
c           the repres. point
            Fld_e = EF_e(1,iTs)*dX + EF_e(2,iTs)*dY + EF_e(3,iTs)*dZ
            Fld_n = EF_n(1,iTs)*dX + EF_n(2,iTs)*dY + EF_n(3,iTs)*dZ
c           Total deriv. of the potential
            VDer(iTs,Index) = VDer(iTs,Index) - Fld_e + DVNuc + Fld_n
cpcm_solvent
C     In MCLR the electron electric field is not computed, probably because of
C     DoRys set to False in mclr. Setting DoRys to True causes the program
C     to stop because the abdata.ascii file is not found.
          if(iat.eq.1.and.icoord.eq.1.and.its.eq.1)
     &      write(6,'(''In the loop VDer,Fld_e,DVNuc,Fld_n'',4f12.6)')
     &      VDer(1,Index),Fld_e,DVNuc,Fld_n
          if(iat.eq.nat.and.icoord.eq.3.and.its.eq.1)
     &      write(6,'(''In the loop VDer,Fld_e,DVNuc,Fld_n'',4f12.6)')
     &      VDer(1,Index),Fld_e,DVNuc,Fld_n
cpcm_solvent end

  200     Continue
  101   Continue
  100 Continue
cpcm_solvent
      write(6,'(''At the end of DerPot,VDer(1,ind),VDer(nTs,ind)'')')
      Do 102 iAt = 1, nAt
        Do 103 iCoord = 1, 3
          Index = 3 * (iAt-1) + iCoord
          write(6,'(2f12.6)') VDer(1,Index), VDer(nTs,Index)
  103   continue
  102 continue
cpcm_solvent end
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(DerTes)
        Call Unused_real_array(DerRad)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ProjSym2(nAtoms,nCent,Ind,A,iDCRs,B,BqR,dB,dBqR)

use Slapaf_Info, only: jStab, nStab
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nCent, Ind(nCent), iDCRs(nCent)
real(kind=wp), intent(in) :: A(3,nCent), B(3,nCent), dB(3,nCent,3,nCent)
real(kind=wp), intent(out) :: BqR(3,nAtoms), dBqR(3,nAtoms,3,nAtoms)
integer(kind=iwp) :: i, j, jxyz
real(kind=wp) :: ATemp(3)
real(kind=wp), allocatable :: Tx(:,:)

#ifdef _DEBUGPRINT_
call RecPrt('B',' ',B,3,nCent)
call RecPrt('dB',' ',dB,3*nCent,3*nCent)
write(u6,*) iDCRs
#endif

! Set up the T-matrix

! Project away nonsymmetric displacements

call mma_allocate(Tx,3,nCent,Label='Tx')

Tx(:,:) = One
do i=1,nCent
  call NonSym(nStab(Ind(i)),jStab(0,Ind(i)),A(:,i),Tx(:,i))

  ! Rotate vector back to the unique center

  call OA(iDCRs(i),Tx(1:3,i),ATemp)
  Tx(:,i) = ATemp(:)
end do

! The T-matrix is now computed. Now create BqR and dBqR.

! Create BqR

BqR(:,:) = Zero
do i=1,nCent
  BqR(:,Ind(i)) = BqR(:,Ind(i))+Tx(:,i)*B(:,i)
end do
#ifdef _DEBUGPRINT_
call RecPrt('BqR',' ',BqR,1,3*nAtoms)
#endif

! Create dBqR

dBqR(:,:,:,:) = Zero
do j=1,nCent
  do jxyz=1,3

    do i=1,nCent

      dBqR(:,Ind(i),jxyz,Ind(j)) = dBqR(:,Ind(i),jxyz,Ind(j))+Tx(:,i)*dB(:,i,jxyz,j)*Tx(jxyz,j)

    end do

  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('dBqR',' ',dBqR,3*nAtoms,3*nAtoms)
#endif

call mma_deallocate(Tx)

return

end subroutine ProjSym2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Cho_GetMQ(MQ,l_MQ,List_QShp,nQShp)
      use ChoSwp, only: iQuAB, nnBstRSh, iiBstRSh, IndRSh, IndRed
      Implicit Real*8 (a-h,o-z)

      Integer  l_MQ, nQShp
      Real*8   MQ(l_MQ)
      Integer  List_QShp(nQShp)

#include "cholesky.fh"
#include "choprint.fh"
#include "stdalloc.fh"

      Character(LEN=9), Parameter:: SecNam = 'Cho_GetMQ'
      Integer, Parameter:: iOpt = 2

      Integer, External:: Cho_P_LocalSP, Cho_F2SP

      Real*8, Allocatable:: Scr(:)
      Integer, Allocatable:: kOff_Shp(:)

      nTot = nQual(1)
      Do iSym = 2,nSym
         nTot = nTot + nQual(iSym)
      End Do
      If (nTot .lt. 1) Return ! this test makes sense for parallel run

      Call mma_allocate(kOff_Shp,nnShl,Label='kOff_Shp')

      iQoff=0
      Do jSym=1,nSym

         If (nQual(jSym) .lt. 1) goto 10 ! next symmetry

         Lint = 0
         Do iShp=1,nQShp  ! set only the needed offsets
            iL_ShpG = List_QShp(iShp) ! Shell pair
            iL_Shp = Cho_P_LocalSP(iL_ShpG) ! local shell pair
            kOff_Shp(iL_Shp) = Lint
            Lint = Lint + nnBstRSh(jSym,iL_Shp,2)
         End Do

         Call mma_allocate(Scr,Lint,Label='Scr')

C --- Read the integrals
C ----------------------
         Do jQ=1,nQual(jSym)

            iAdr = nnBstr(jSym,2)*(jQ-1)

            Do iShp=1,nQShp

               iL_ShpG = List_QShp(iShp)
               iL_Shp = Cho_P_LocalSP(iL_ShpG) ! local shell pair
               ipS = 1 + kOff_Shp(iL_Shp)
               iShpAdr = iAdr + iiBstRSh(jSym,iL_Shp,2)
               Lread = nnBstRSh(Jsym,iL_Shp,2)
               Call dDaFile(LuSel(JSym),iOpt,Scr(ipS),Lread,iShpAdr)

            End Do

C --- Extract the matrix of qualified integrals
C ---------------------------------------------
            Do iQ=1,nQual(jSym)

               iAB = iQuAB(iQ,jSym)  ! addr curr red set
               isAB = iAB - iiBstR(jSym,2)  ! symm. reduction
               iShABG = IndRsh(IndRed(iAB,2)) ! glob. SP it belongs to
               iShAB = Cho_P_LocalSP(Cho_F2SP(iShABG)) ! local SP
               iabSh = isAB - iiBstRSh(jSym,iShAB,2) ! addr within Shp
               ipfr = kOff_Shp(iShAB) + iabSh
               ipto = iQoff + nQual(jSym)*(jQ-1) + iQ
               MQ(ipto) = Scr(ipfr)

             End Do

         End Do

         iQoff = iQoff + nQual(jSym)**2

         Call mma_deallocate(Scr)

10       Continue

      End Do

      Call mma_deallocate(kOff_Shp)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1999, Roland Lindh                      *
!               1990, IBM                                              *
!***********************************************************************

subroutine Drv_Fck(Label,ip,lOper,nComp,CCoor,nOrdOp,rNuc,rHrmt,iChO,opmol,ipad,opnuc,iopadr,idirect,isyop,PtChrg,nGrid,iAddPot)

use PAM2, only: iPAMcount
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
character(len=8), intent(inout) :: Label
integer(kind=iwp), intent(in) :: nComp, lOper(nComp), nOrdOp, iChO(nComp), ipad, iopadr(*), idirect, isyop, nGrid, iAddPot
integer(kind=iwp), intent(out) :: ip(nComp)
real(kind=wp), intent(in) :: CCoor(3,nComp), rNuc(nComp), rHrmt, opmol(*), opnuc(*), PtChrg(nGrid)
integer(kind=iwp) :: iadr, iComp, iIrrep, iOpt, iRC, iSmLbl, iStabO(0:7), LenInt, LenTot, llOper, nIC, nStabO
real(kind=wp), allocatable :: Int1El(:)
integer(kind=iwp), external :: n2Tri

#include "warnings.h"
#include "macros.fh"
unused_var(CCoor)
unused_var(nOrdOp)
unused_var(iChO)
unused_var(opmol(1))
unused_var(opnuc(1))
unused_var(ipad)
unused_var(iopadr(1))
unused_var(idirect)
unused_var(isyop)
unused_var(PtChrg)
unused_var(iAddPot)

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) ' In OneEl: Label',Label
write(u6,*) ' In OneEl: nComp'
write(u6,'(1X,8I5)') nComp
write(u6,*) ' In OneEl: lOper'
write(u6,'(1X,8I5)') lOper
write(u6,*) ' In OneEl: n2Tri'
do iComp=1,nComp
  ip(iComp) = n2Tri(lOper(iComp))
end do
write(u6,'(1X,8I5)') (ip(iComp),iComp=1,nComp)
call RecPrt(' CCoor',' ',CCoor,3,nComp)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
!-----Compute the number of blocks from each component of the operator
!     and the irreps it will span.

nIC = 0
llOper = 0
do iComp=1,nComp
  llOper = ior(llOper,lOper(iComp))
  do iIrrep=0,nIrrep-1
    if (btest(lOper(iComp),iIrrep)) nIC = nIC+1
  end do
end do
#ifdef _DEBUGPRINT_
write(u6,*) ' nIC =',nIC
#endif
if (nIC == 0) return
call SOS(iStabO,nStabO,llOper)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate memory for symmetry adapted one electron integrals.
! Will just store the unique elements, i.e. low triangular blocks
! and lower triangular elements in the diagonal blocks.

ip(:) = -1
LenTot = 0
do iComp=1,nComp
  LenInt = n2Tri(lOper(iComp))
  LenTot = LenTot+LenInt+4
end do
call mma_allocate(Int1El,LenTot)
Int1El(:) = Zero
ip(1) = 1
iadr = ip(1)
do iComp=1,nComp
  LenInt = n2Tri(lOper(iComp))
  ip(icomp) = iadr
  iadr = iadr+LenInt+4
  ! Copy center of operator to work area.
  call DCopy_(3,Ccoor(1,iComp),1,Int1El(ip(iComp)+LenInt),1)
  ! Copy nuclear contribution to work area.
  Int1El(ip(iComp)+LenInt+3) = rNuc(iComp)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
!---- Compute all SO integrals for all components of the operator.

call Drv_Fck_Inner(ip,Int1El,LenTot,lOper,nComp,rHrmt,iStabO,nStabO,nIC)
!                                                                      *
!***********************************************************************
!                                                                      *
!                    P O S T P R O C E S S I N G                       *
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call PrMtrx(Label,lOper,nComp,ip,Int1El)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
!---- Write integrals to disc.

do iComp=1,nComp
  iSmLbl = lOper(iComp)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !----- Write integrals to disc

  iOpt = 0
  iRC = -1
  if (Label(1:3) == 'PAM') write(Label,'(A5,I3.3)') 'PAM  ',iPAMcount
  !write(u6,*) ' oneel *',Label,'*'

  call WrOne(iRC,iOpt,Label,iComp,Int1El(ip(iComp)),iSmLbl)

  if (Label(1:3) == 'PAM') call WrOne(iRC,iOpt,Label,1,Int1El(ip(iComp)),iSmLbl)
  iPAMcount = iPAMcount+1

  if (iRC /= 0) then
    write(u6,*) ' *** Error in subroutine ONEEL ***'
    write(u6,*) '     Abend in subroutine WrOne'
    call Quit(_RC_IO_ERROR_WRITE_)
  end if
end do  ! iComp
!                                                                      *
!***********************************************************************
!                                                                      *
!---- Deallocate memory for integral

call mma_deallocate(Int1El)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Drv_Fck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine TRMake(TRVec,Coor,nAtoms,nTR,uMtrx,Smmtrc,nDim,dMass,
     &                  CofM)
      Implicit Real*8 (a-h,o-z)
#include "sbs.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
      Real*8 TRVec(6,3*nAtoms), Coor(3,nAtoms),uMtrx(3*nAtoms),
     &       CM(3), dMass(nAtoms)
      Logical SymDsp, Smmtrc(3,nAtoms), TransVar, RotVar, CofM
*
      iRout = 131
      iPrint=nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In TRMake: Coor',' ',Coor,3,nAtoms)
         Write (6,*) ' nDim=',nDim
      End If
*
      call dcopy_(6*3*nAtoms,[Zero],0,TRVec,1)
      TransVar=iAnd(iSBS,2**7).eq. 2**7
      RotVar  =iAnd(iSBS,2**8).eq. 2**8
      nTR = 0
*                                                                      *
************************************************************************
*                                                                      *
*     Translation
*
      If (TransVar) Go To 100
      Do i = 1, 3
         iCmp=2**(i-1)
         If (SymDsp(iCmp)) Then
            nTR = nTR + 1
            call dcopy_(nAtoms,[One],0,TRVec(nTR,i),18)
         End If
      End Do
 100  Continue
*                                                                      *
************************************************************************
*                                                                      *
*-----Rotation around some center
*
*     Loop over axis
*
      If (RotVar) Go To 200
      Do i = 1, 3
         CM(i)=Zero
         rNorm=Zero
         Do iAtom = 1, nAtoms
            j = (iAtom-1)*3+i
            If (CofM) Then
               rNorm=rNorm+uMtrx(j)*dMass(iAtom)
               If (Smmtrc(i,iAtom)) Then
                  CM(i)=CM(i)+uMtrx(j)*Coor(i,iAtom)*dMass(iAtom)
               End If
            Else
               rNorm=rNorm+uMtrx(j)
               If (Smmtrc(i,iAtom)) Then
                  CM(i)=CM(i)+uMtrx(j)*Coor(i,iAtom)
               End If
            End If
         End Do
         CM(i)=CM(i)/rNorm
      End Do
C     Write (6,*) 'TrMake CM=',CM
*
      Do i = 1, 3
         j = i + 1
         If (j.gt.3) j = j - 3
         k = i + 2
         If (k.gt.3) k = k - 3
*--------j and k are the index of the plane perpendicular to the axis
*
*------- Check the rotation has any mirror plane parallel to the axis
*        of the rotation. If not then the rotation will not break the
*        symmetry.
*
         iCmp = 2**(j-1) + 2**(k-1)
         If (SymDsp(iCmp)) Then
            nTR = nTR + 1
            Call DYaX (nAtoms, One,Coor(j,1),3,TRVec(nTR,k),18)
            Call DaXpY_(nAtoms,-One,CM(j)    ,0,TRVec(nTR,k),18)
            Call DYaX (nAtoms,-One,Coor(k,1),3,TRVec(nTR,j),18)
            Call DaXpY_(nAtoms, One,CM(k)    ,0,TRVec(nTR,j),18)
         End If
      End Do
 200  Continue
*                                                                      *
************************************************************************
*                                                                      *
*-----Normalize vectors
*
      Do i = 1, nTR
         rii = Zero
         Do iAtom = 1, 3*nAtoms
            rii = rii + uMtrx(iAtom)*TRVec(i,iatom)**2
         End Do
         If(rii.gt.1.d-15) Then
           Call DScal_(3*nAtoms,One/Sqrt(rii),TRVec(i,1),6)
         Else
           call dcopy_(3*nAtoms,[Zero],0,TRVec(i,1),6)
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.99) Call RecPrt(' In TRMake: TRVec',' ',
     &                           TRVec,6,3*nAtoms)
      Call TROrder(TRVec,nTR,3*nAtoms)
      If (iPrint.ge.99) Call RecPrt(' In TRMake: TRVec',' ',
     &                           TRVec,nTR,3*nAtoms)
      Call TRComp(TRVec,nTR,3*nAtoms,SmmTrc)
*
      If (iPrint.ge.99) Call RecPrt(' In TRMake: TRVec',' ',
     &                           TRVec,nTR,nDim)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      Subroutine TROrder(TRVec,nTR,nX)
      Implicit Real*8 (a-h,o-z)
      Real*8 TRVec(6*nX)
      If (nTR.eq.6) Return
      Do i = 2, nX
         Do iTR = 1, nTR
            iFrom=(i-1)*6 + iTR
            iTo  =(i-1)*nTR + iTR
            TRVec(iTo)=TRVec(iFrom)
         End Do
      End Do
*
      Return
      End
      Subroutine TRComp(TRVec,nTR,nX,Smmtrc)
      Implicit Real*8 (a-h,o-z)
      Real*8 TRVec(nTR,nX)
      Logical Smmtrc(nX)
*
      If (nTR.eq.0) Return
      iDim = 0
      Do iX = 1, nX
         If (Smmtrc(iX)) Then
            iDim = iDim + 1
            If (iDim.ne.iX) call dcopy_(nTR,TRVec(1,iX),1,
     &                                 TRVec(1,iDim),1)
         End If
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Vibrot_globals

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: nRot_Max = 200, nobs = 10, npin = 500, npoint = 5000
integer(kind=iwp) :: J1A, J2A, lambda, ispc, iobs, nop, Vibwvs, iadvib, Vibwvs1, Vibwvs2, n0, nvib1, n02, nvib21, J1B, J2B, &
                     IfPrWf, iscale, iallrot
integer(kind=iwp) :: iadrsp(nRot_Max), iad12(nRot_Max), iad13(nRot_Max), iplot(nobs), npobs(nobs)
real(kind=wp) :: R0o(nobs), R1o(nobs), dRo(nobs), RinO(npin,nobs), Obsin(npin,nobs), EoutO(npoint+4,nobs)
character(len=2) :: Atom1, Atom2
character(len=80) :: Titobs(nobs)

public :: Atom1, Atom2, dRo, EoutO, iad12, iad13, iadrsp, iadvib, iallrot, ifPrWf, iobs, iplot, iscale, ispc, J1A, J1B, J2A, J2B, &
          lambda, n0, n02, nop, npin, npobs, npoint, nRot_Max, nvib1, nvib21, Obsin, R0o, R1o, RinO, Titobs, Vibwvs, Vibwvs1, &
          Vibwvs2

end module Vibrot_globals

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Get_dExcdRa(dExcdRa,ndExcdRa)

use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), allocatable, intent(out) :: dExcdRa(:)
integer(kind=iwp), intent(out) :: ndExcdRa
logical(kind=iwp) :: Found
character(len=*), parameter :: Label = 'dExcdRa'

call qpg_dArray(Label,Found,ndExcdRa)
if ((.not. Found) .or. (ndExcdRa == 0)) call SysAbendmsg('Get_dExcdRa','Did not find:',Label)
call mma_allocate(dExcdRa,ndExcdRa,label='dExcdRa')
call Get_dArray(Label,dExcdRa,ndExcdRa)

return

end subroutine Get_dExcdRa

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine CrSph1(Win,ijkla,
     &                  Scrt,nScrt,
     &                  Coeff3,kCar,kSph,Tr3,Pr3,
     &                  Coeff4,lCar,lSph,Tr4,Pr4,Wout,mcd)
************************************************************************
*                                                                      *
* Object : to transform the two-electron integrals from cartesian      *
*          gaussians to spherical gaussians.                           *
*                                                                      *
*          Observe that most of the time Win and Wout will overlap.    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
      Real*8 Win(ijkla*kCar*lCar), Scrt(nScrt),
     &       Coeff3(kCar,kCar), Coeff4(lCar,lCar),
     &       Wout(mcd*ijkla)
      Logical Tr3, Pr3, Tr4, Pr4
*
      If (Tr3.and.Tr4) Then
*        Call RecPrt(' Right contraction',' ',Coeff4,lCar,lSph)
*        Starting with IJKL,a,cd transforming to D,IJKL,a,c
*        Call xxDGeMul(Coeff4,lCar,'T',
*    &               Win,ijkla*kCar,'T',
*    &               Scrt,lSph,
*    &               lSph,lCar,ijkla*kCar)
         Call TTMul(Coeff4,Win,Scrt,lCar,lSph,ijkla*kCar)
*
*        Call RecPrt(' In CrSph: (a0|cD) ',' ',Scrt,lSph*ijkla,kCar)
*        Call RecPrt(' Left contraction',' ',Coeff3,kCar,kSph)
*        Transform D,IJKL,a,c to CD,IJKL,a
*        Call xxDGeMul(Coeff3,kCar,'T',
*    &               Scrt,lSph*ijkla,'T',
*    &               Wout,kSph,
*    &               kSph,kCar,lSph*ijkla)
         Call TTMul(Coeff3,Scrt,Wout,kCar,kSph,lSph*ijkla)
      Else If (Tr4) Then
*        Call RecPrt(' Right contraction',' ',Coeff4,lCar,lSph)
*        Starting with IJKL,a,cd transforming to D,IJKL,a,c
*        Call xxDGeMul(Coeff4,lCar,'T',
*    &               Win,ijkla*kCar,'T',
*    &               Scrt,lSph,
*    &               lSph,lCar,ijkla*kCar)
         Call TTMul(Coeff4,Win,Scrt,lCar,lSph,ijkla*kCar)
*        Transpose D,IJKL,a,c to cD,IJKL,a
         Call DGeTMO(Scrt,lSph*ijkla,lSph*ijkla,kCar,Wout,kCar)
      Else If (Tr3) Then
*        Transpose IJKL,a,c,d to d,IJKL,a,c
         Call DGeTMO(Win,ijkla*kCar,ijkla*kCar,lCar,Scrt,lCar)
*
*        Call RecPrt(' Left contraction',' ',Coeff3,kCar,kSph)
*        Transform D,IJKL,a,c to CD,IJKL,a
*        Call xxDGeMul(Coeff3,kCar,'T',
*    &               Scrt,lSph*ijkla,'T',
*    &               Wout,kSph,
*    &               kSph,kCar,lSph*ijkla)
         Call TTMul(Coeff3,Scrt,Wout,kCar,kSph,lSph*ijkla)
      Else
*         Transpose IJKL,a,c,d to c,d,IJKL,a
          If (kCar*lCar.ne.1) Then
             call dcopy_(ijkla*kCar*lCar,Win,1,Scrt,1)
             Call DGeTMO(Scrt,ijkla,ijkla,kCar*lCar,Wout,kCar*lCar)
          Else
             call dcopy_(ijkla*kCar*lCar,Win,1,Scrt,1)
             call dcopy_(ijkla*kCar*lCar,Scrt,1,Wout,1)
          End If
      End If
*
*     Call RecPrt(' In CrSph1: (a0|CD)  ',' ',Wout,mcd,ijkla)
*     Call GetMem(' Exit CrSph1','CHECK','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Pr3)
         Call Unused_logical(Pr4)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine bufio_chbuf_cvb(jbuf)
! Change buffer position to JBUF. NB: Does not write current buffer,
! neither is JBUF buffer read.

use casvb_global, only: ibuf, nbuf
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: jbuf
integer(kind=iwp) :: kbuf

! Dummy writes so that we don't exceed end-of-file:
do kbuf=nbuf+1,jbuf-1
  ibuf = kbuf
  call bufio_wrzbuf_cvb()
end do
ibuf = jbuf

return

end subroutine bufio_chbuf_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MXRESCPH(IAB,IOCTPA,IOCTPB,NOCTPA,NOCTPB,NSMST,NSTFSMSPGP,MXPNSMST,NSMOB,MXPTOB,NTPOB,NTSOB,MXPKA,NEL1234,MXCJ,MXCIJA, &
                    MXCIJB,MXCIJAB,MXSXBL,MXADKBLK,IPHGAS,NHLFSPGP,MNHL,IADVICE,MXCJ_ALLSYM,MXADKBLK_AS,MX_NSPII)
! Find largest dimension of matrix C(Ka,Ib,J)
! Find largest dimension of matrix C(ij,Ka,Ib)
! Find largest dimension of matrix C(ij,Ia,Kb)
! Find largest dimension of matrix C(ij,Ka,Kb)
! Find largest dimension of matrix S(P,Ia,I,K) for a single K-string
!
! Particle hole version : hole electrons added, particle elec removed
!
! Largest block of single excitations MXSXBL
!
! Input
! IAB    : allowed combination of alpha and beta supergroups
! IOCPTA : Number of first active alpha supergroup
! IOCPTB : Number of first active beta  supergroup
! NOCTPA : Number of active alpha supergroups
! NOCTPB : Number of active alpha supergroups
!
! Version of Jan 98 : IPHGAS added

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NOCTPA, NOCTPB, IAB(NOCTPA,NOCTPB), IOCTPA, IOCTPB, NSMST, MXPNSMST, NSTFSMSPGP(MXPNSMST,*), &
                                 NSMOB, MXPTOB, NTPOB, NTSOB(MXPTOB,NSMOB), MXPKA, NEL1234(MXPTOB,*), IPHGAS(*), NHLFSPGP(*), &
                                 MNHL, IADVICE
integer(kind=iwp), intent(out) :: MXCJ, MXCIJA, MXCIJB, MXCIJAB, MXSXBL, MXADKBLK, MXCJ_ALLSYM, MXADKBLK_AS, MX_NSPII
integer(kind=iwp) :: IAORC, IATP, IATPABS, IBTP, IBTPABS, IOBTP, ISM, ISMOB, ITOTA, ITOTB, JAORC, JATP, JBTP, JOBTP, JSMOB, K1ATP, &
                     K1BTP, KATP, KBTP, KSM, LBLK, LCJBLK, LCJBLK_ALLSYM, MXA, MXB, MXIA, MXIB, MXIOB, MXISOB, MXJOB, MXJSOB, &
                     MXKA, MXKAB, MXKACTEL, MXKAO, MXKB, MXKBO, MXSOB, NSOB_AS
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IATP_MX, IBTP_MX, IOBTP_MX, KATP_MX

write(u6,*) ' MXRESCPH : MXPKA ',MXPKA
#endif

! matrix C(j,Ka,Ib)

MXKAB = 0
MXCJ = 0
MXCJ_ALLSYM = 0
MXADKBLK = 0
MXADKBLK_AS = 0
MX_NSPII = 0
do IAORC=1,2
  do IATP=1,NOCTPA
    IATPABS = IATP+IOCTPA-1
    do IBTP=1,NOCTPB
      IBTPABS = IBTP+IOCTPB-1

      if (IAB(IATP,IBTP) /= 0) then
#       ifdef _DEBUGPRINT_
        write(u6,*) ' allowed IATP,IBTP',IATP,IBTP
#       endif
        MXB = 0
        ITOTB = 0
        do ISM=1,NSMST
          MXB = max(MXB,NSTFSMSPGP(ISM,IBTPABS))
          ITOTB = ITOTB+NSTFSMSPGP(ISM,IBTPABS)
        end do
#       ifdef _DEBUGPRINT_
        write(u6,*) ' MXB,ITOTB = ',MXB,ITOTB
#       endif
        do IOBTP=1,NTPOB
          ! No K strings obtained from creation in particle space
          if ((IAORC == 2) .and. (IPHGAS(IOBTP) == 1)) cycle
          ! type of K string obtained
          call NEWTYP(IATPABS,IAORC,IOBTP,KATP)
#         ifdef _DEBUGPRINT_
          write(u6,*) ' IOBTP KATP ',IOBTP,KATP
#         endif
          ! addi constraint to avoid calc with long columns and few rows
          ! Works only in connection with active advice routine !
          if (KATP > 0) then
            if ((IAORC == 1) .and. (IADVICE == 1) .and. (NHLFSPGP(IBTPABS)+NHLFSPGP(KATP) < MNHL) .and. &
                (NHLFSPGP(IATPABS) > (NHLFSPGP(IBTPABS)+1))) then
              !write(u6,*) ' N-1 hole space eliminated'
              !write(u6,*) ' IOBTP,IBTPABS,KATP',IOBTP,IBTPABS,KATP
              KATP = 0
            end if
          end if

          if (KATP > 0) then
            !     DIM_SPII(IASPGRP,IBSPGRP,IOBTP,IAB,IAC,NSPII)
            !call DIM_SPII(IATPABS,IBTPABS,IOBTP,1,IAORC,NSPII)
            !MX_NSPII = MAX(MX_NSPII,NSPII)
            MX_NSPII = 0
          end if

          if (KATP > 0) then
            MXKA = max(0,maxval(NSTFSMSPGP(1:NSMST,KATP)))
#           ifdef _DEBUGPRINT_
            write(u6,*) ' MXKA = ',MXKA
#           endif
            MXKAO = MXKA
            if ((MXPKA > 0) .and. (MXKA > MXPKA)) MXKA = MXPKA
            MXSOB = 0
            NSOB_AS = 0
            do ISMOB=1,NSMOB
              MXSOB = max(MXSOB,NTSOB(IOBTP,ISMOB))
              NSOB_AS = NSOB_AS+NTSOB(IOBTP,ISMOB)
            end do
#           ifdef _DEBUGPRINT_
            write(u6,*) ' MXSOB = ',MXSOB
#           endif

            MXADKBLK = max(MXADKBLK,MXSOB*MXKAO)
            MXADKBLK_AS = max(MXADKBLK_AS,NSOB_AS*MXKAO)
            LCJBLK = MXSOB*MXKA*MXB
            LCJBLK_ALLSYM = NSOB_AS*MXKA*ITOTB

            if (LCJBLK > MXCJ) then
              MXCJ = LCJBLK
#             ifdef _DEBUGPRINT_
              IATP_MX = IATP
              IBTP_MX = IBTP
              KATP_MX = KATP
              IOBTP_MX = IOBTP
#             endif
            end if
            MXCJ_ALLSYM = max(MXCJ_ALLSYM,LCJBLK_ALLSYM)
            MXKAB = max(MXKAB,MXKA)

          end if
        end do
      end if
    end do
  end do
end do
! End of anni/crea map

! matrix C(j,Ia,Kb)

do IAORC=1,2
  do IATP=1,NOCTPA
    IATPABS = IATP+IOCTPA-1
    do IBTP=1,NOCTPB
      IBTPABS = IBTP+IOCTPB-1

      if (IAB(IATP,IBTP) /= 0) then
#       ifdef _DEBUGPRINT_
        write(u6,*) ' allowed IATP,IBTP',IATP,IBTP
#       endif
        MXA = 0
        ITOTA = 0
        do ISM=1,NSMST
          MXA = max(MXA,NSTFSMSPGP(ISM,IATPABS))
          ITOTA = ITOTA+NSTFSMSPGP(ISM,IATPABS)
        end do
#       ifdef _DEBUGPRINT_
        write(u6,*) ' MXA = ',MXA
#       endif
        do IOBTP=1,NTPOB
          ! type of K string obtained by removing one elec of type IOPBTP from IATP
          if ((IAORC == 2) .and. (IPHGAS(IOBTP) == 1)) cycle
          call NEWTYP(IBTPABS,IAORC,IOBTP,KBTP)
#         ifdef _DEBUGPRINT_
          write(u6,*) ' IOBTP KBTP ',IOBTP,KBTP
#         endif
          if (KBTP > 0) then
            if ((IAORC == 1) .and. (IADVICE == 1) .and. (NHLFSPGP(IATPABS)+NHLFSPGP(KBTP) < MNHL) .and. &
                (NHLFSPGP(IBTPABS) > NHLFSPGP(IATPABS)+1)) then
              !write(u6,*) ' N-1 hole space eliminated'
              !write(u6,*) ' IOBTP,IATPABS,KBTP',IOBTP,IATPABS,KBTP
              KBTP = 0
            end if
          end if
          if (KBTP > 0) then
            !call DIM_SPII(IATPABS,IBTPABS,IOBTP,2,IAORC,NSPII)
            !MX_NSPII = MAX(MX_NSPII,NSPII)
            MX_NSPII = 0
          end if

          if (KBTP > 0) then
            MXKB = 0
            do KSM=1,NSMST
              MXKB = max(MXKB,NSTFSMSPGP(KSM,KBTP))
            end do
#           ifdef _DEBUGPRINT_
            write(u6,*) ' MXKB = ',MXKB
#           endif
            MXKBO = MXKB
            if ((MXPKA > 0) .and. (MXKB > MXPKA)) MXKB = MXPKA
            MXSOB = 0
            NSOB_AS = 0
            do ISMOB=1,NSMOB
              MXSOB = max(MXSOB,NTSOB(IOBTP,ISMOB))
              NSOB_AS = NSOB_AS+NTSOB(IOBTP,ISMOB)
            end do
#           ifdef _DEBUGPRINT_
            write(u6,*) ' MXSOB = ',MXSOB
#           endif

            MXADKBLK = max(MXADKBLK,MXSOB*MXKBO)
            MXADKBLK_AS = max(MXADKBLK_AS,NSOB_AS*MXKBO)
            !JULY29 LCJBLK = MXSOB*MXKB*MXB
            LCJBLK = MXSOB*MXKB*MXA
            LCJBLK_ALLSYM = NSOB_AS*MXKB*ITOTA
            MXCJ = max(MXCJ,LCJBLK)
            MXCJ_ALLSYM = max(MXCJ_ALLSYM,LCJBLK_ALLSYM)
            MXKAB = max(MXKAB,MXKB)

          end if
        end do
      end if
    end do
  end do
end do
! End of loop over creation/annihilation
#ifdef _DEBUGPRINT_
write(u6,*) 'MXRESCPH : MXADKBLK,MXCJ ',MXADKBLK,MXCJ
write(u6,*) ' MXCJ_ALLSYM = ',MXCJ_ALLSYM
#endif

! matrix C(ij,Ka,Ib)
! both Ka and Ib blocked

MXCIJA = 0
do IATP=1,NOCTPA
  IATPABS = IATP+IOCTPA-1
  do IBTP=1,NOCTPB
    IBTPABS = IBTP+IOCTPB-1

    if (IAB(IATP,IBTP) /= 0) then
      MXIB = 0
      do ISM=1,NSMST
        MXIB = max(MXIB,NSTFSMSPGP(ISM,IBTPABS))
      end do
      if (MXIB > MXPKA) MXIB = MXPKA
#     ifdef _DEBUGPRINT_
      write(u6,*) ' MXIB = ',MXIB
#     endif
      do IAORC=1,2
        do IOBTP=1,NTPOB
          ! type of K string obtained by removing one elec of type IOPBTP from IATP
          call NEWTYP(IATPABS,IAORC,IOBTP,K1ATP)
          ! No N+1 mappings for particle spaces
          if ((IAORC == 2) .and. (IPHGAS(IOBTP) == 1)) K1ATP = 0
#         ifdef _DEBUGPRINT_
          write(u6,*) ' IOBTP K1ATP ',IOBTP,K1ATP
#         endif
          if (K1ATP > 0) then
            MXISOB = 0
            do ISMOB=1,NSMOB
              MXISOB = max(MXISOB,NTSOB(IOBTP,ISMOB))
            end do
#           ifdef _DEBUGPRINT_
            write(u6,*) ' MXISOB = ',MXISOB
#           endif
            do JAORC=1,2
              do JOBTP=1,NTPOB
                ! type of K string obtained by removing one elec of type JOPBTP from K1ATP
                call NEWTYP(K1ATP,JAORC,JOBTP,KATP)
                if ((JAORC == 2) .and. (IPHGAS(JOBTP) == 1)) KATP = 0
                if (KATP > 0) then
                  MXKA = 0
                  do KSM=1,NSMST
                    MXKA = max(MXKA,NSTFSMSPGP(KSM,KATP))
                  end do
#                 ifdef _DEBUGPRINT_
                  write(u6,*) ' MXKA = ',MXKA
#                 endif
                  if ((MXPKA > 0) .and. (MXKA > MXPKA)) MXKA = MXPKA
                  MXJSOB = 0
                  do JSMOB=1,NSMOB
                    MXJSOB = max(MXJSOB,NTSOB(JOBTP,JSMOB))
                  end do
#                 ifdef _DEBUGPRINT_
                  write(u6,*) ' MXJSOB = ',MXJSOB
#                 endif

                  LBLK = MXISOB*MXJSOB*MXKA*MXIB
                  MXCIJA = max(MXCIJA,LBLK)
                end if
              end do
            end do
            ! End of loop over JOBTP, JAORC
          end if
        end do
      end do
      ! End of loop over IOBTP, IAORC
    end if
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'MXRESCPH : MXCIJA ',MXCIJA
#endif

! matrix C(ij,Ia,kb)
! both Ka and Ib blocked

MXCIJB = 0
do IATP=1,NOCTPA
  IATPABS = IATP+IOCTPA-1
  do IBTP=1,NOCTPB
    IBTPABS = IBTP+IOCTPB-1
    if (IAB(IATP,IBTP) /= 0) then
      MXIA = max(0,maxval(NSTFSMSPGP(1:NSMST,IATPABS)))
      if (MXIA > MXPKA) MXIA = MXPKA
#     ifdef _DEBUGPRINT_
      write(u6,*) ' MXIA = ',MXIA
#     endif
      do IAORC=1,2
        do IOBTP=1,NTPOB
          ! type of K string obtained by removing one elec of type IOPBTP from IBTP
          call NEWTYP(IBTPABS,IAORC,IOBTP,K1BTP)
#         ifdef _DEBUGPRINT_
          write(u6,*) ' IOBTP K1BTP ',IOBTP,K1BTP
#         endif
          if ((IAORC == 2) .and. (IPHGAS(IOBTP) == 1)) K1BTP = 0
          if (K1BTP > 0) then
            MXISOB = 0
            do ISMOB=1,NSMOB
              MXISOB = max(MXISOB,NTSOB(IOBTP,ISMOB))
            end do
#           ifdef _DEBUGPRINT_
            write(u6,*) ' MXISOB = ',MXISOB
#           endif
            do JAORC=1,2
              do JOBTP=1,NTPOB
                ! type of K string obtained by removing one elec of type JOPBTP from K1ATP
                call NEWTYP(K1BTP,JAORC,JOBTP,KBTP)
                if ((JAORC == 2) .and. (IPHGAS(JOBTP) == 1)) KBTP = 0
                if (KBTP > 0) then
                  MXKB = 0
                  do KSM=1,NSMST
                    MXKB = max(MXKB,NSTFSMSPGP(KSM,KBTP))
                  end do
#                 ifdef _DEBUGPRINT_
                  write(u6,*) ' MXKB = ',MXKB
#                 endif
                  if ((MXPKA > 0) .and. (MXKB > MXPKA)) MXKB = MXPKA
                  MXJSOB = 0
                  do JSMOB=1,NSMOB
                    MXJSOB = max(MXJSOB,NTSOB(JOBTP,JSMOB))
                  end do
#                 ifdef _DEBUGPRINT_
                  write(u6,*) ' MXJSOB = ',MXJSOB
#                 endif

                  MXCIJB = max(MXCIJB,MXISOB*MXJSOB*MXKB*MXIA)
                end if
              end do
            end do
            ! End of loop over JOBTP,JAORC
          end if
        end do
      end do
      ! End of loop over IOBTP,IAORC
    end if
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'MXRESCPH : MXCIJB ',MXCIJB
#endif

! matrix C(ij,Ka,kb)
! both Ka and Kb blocked

! Modified : Only used if at most two elecs in i and j
!            No batching
!            Used for hardwired few electron code
MXCIJAB = 0
MXKACTEL = 1
do IATP=1,NOCTPA
  IATPABS = IATP+IOCTPA-1
  do IBTP=1,NOCTPB
    IBTPABS = IBTP+IOCTPB-1
    if (IAB(IATP,IBTP) /= 0) then
      do IOBTP=1,NTPOB
        ! type of Ka string obtained by removing one elec of type IOPBTP from IATP
        call NEWTYP(IATPABS,1,IOBTP,KATP)
#       ifdef _DEBUGPRINT_
        write(u6,*) ' IOBTP KATP ',IOBTP,KATP
#       endif
        if (KATP > 0) then
          !   NEL1234(JOBTP,IATPABS)
          if (NEL1234(IOBTP,KATP) > MXKACTEL) KATP = 0
        end if
        if (KATP > 0) then
          MXKA = 0
          do KSM=1,NSMST
            MXKA = max(MXKA,NSTFSMSPGP(KSM,KATP))
          end do
#         ifdef _DEBUGPRINT_
          write(u6,*) ' MXKA = ',MXKA
#         endif
          ! No partitioning
          !if ((MXPKA > 0) .and. (MXKA > MXPKA)) MXKA = MXPKA

          MXISOB = 0
          do ISMOB=1,NSMOB
            MXISOB = max(MXISOB,NTSOB(IOBTP,ISMOB))
          end do
#         ifdef _DEBUGPRINT_
          write(u6,*) ' MXISOB = ',MXISOB
#         endif
          do JOBTP=1,NTPOB
            ! type of K string obtained by removing one elec of type JOPBTP from IBTP
            call NEWTYP(IBTPABS,1,JOBTP,KBTP)
            if (KBTP > 0) then
              if (NEL1234(JOBTP,KBTP) > MXKACTEL) KBTP = 0
            end if
            if (KBTP > 0) then
              MXKB = 0
              do KSM=1,NSMST
                MXKB = max(MXKB,NSTFSMSPGP(KSM,KBTP))
              end do
#             ifdef _DEBUGPRINT_
              write(u6,*) ' MXKB = ',MXKB
#             endif
              ! No partitioning
              !if ((MXPKA > 0) .and. (MXKB > MXPKA)) MXKB = MXPKA
              MXJSOB = 0
              do JSMOB=1,NSMOB
                MXJSOB = max(MXJSOB,NTSOB(JOBTP,JSMOB))
              end do
#             ifdef _DEBUGPRINT_
              write(u6,*) ' MXJSOB = ',MXJSOB
#             endif

              LBLK = MXISOB*MXJSOB*MXKB*MXKA
              MXCIJAB = max(MXCIJAB,LBLK)
            end if
          end do
        end if
      end do
    end if
  end do
end do

! Largest block of single excitations :
! Strings of given type and sym, orbitals of given type and sym

! Largest block of creations : a+i !kstring> where K string is
! obtained as single annihilations
MXSXBL = 0
! For alpha strings :
do IATP=1,NOCTPA
  IATPABS = IATP+IOCTPA-1
  MXIA = max(0,maxval(NSTFSMSPGP(1:NSMST,IATPABS)))
# ifdef _DEBUGPRINT_
  write(u6,*) ' MXIA = ',MXIA
# endif
  ! Orbitals to be removed
  do JOBTP=1,NTPOB
    ! Is this removal allowed ??
    call NEWTYP(IATPABS,1,JOBTP,KATP)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' JOBTP KATP ',JOBTP,KATP
#   endif
    if (KATP > 0) then
      ! Number of possible choices of J orbitals
      MXJOB = max(0,maxval(NTSOB(JOBTP,:)))
      MXJOB = min(MXJOB,NEL1234(JOBTP,IATPABS))
#     ifdef _DEBUGPRINT_
      write(u6,*) ' MXJOB = ',MXJOB
#     endif
      ! Then  : add an electron
      do IOBTP=1,NTPOB
        ! Allowed ?
        call NEWTYP(KATP,2,IOBTP,JATP)
        if (JATP > 0) then
          MXIOB = max(0,maxval(NTSOB(IOBTP,:)))
          MXSXBL = max(MXSXBL,MXIOB*MXJOB*MXIA)
        end if
      end do
    end if
  end do
end do

! For beta  strings :
do IBTP=1,NOCTPB
  IBTPABS = IBTP+IOCTPB-1
  MXIB = max(0,maxval(NSTFSMSPGP(1:NSMST,IBTPABS)))
# ifdef _DEBUGPRINT_
  write(u6,*) ' MXIB = ',MXIB
# endif
  ! Orbitals to be removed
  do JOBTP=1,NTPOB
    ! Is this removal allowed ??
    call NEWTYP(IBTPABS,1,JOBTP,KBTP)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' JOBTP KBTP ',JOBTP,KBTP
#   endif
    if (KBTP > 0) then
      ! Number of possible choices of J orbitals
      MXJOB = max(0,maxval(NTSOB(JOBTP,:)))
      MXJOB = min(MXJOB,NEL1234(JOBTP,IBTP))
#     ifdef _DEBUGPRINT_
      write(u6,*) ' MXJOB = ',MXJOB
#     endif
      ! Then  : add an electron
      do IOBTP=1,NTPOB
        ! Allowed ?
        call NEWTYP(KBTP,2,IOBTP,JBTP)
        if (JATP > 0) then
          MXIOB = max(0,maxval(NTSOB(IOBTP,:)))
          MXSXBL = max(MXSXBL,MXIOB*MXJOB*MXIB)
        end if
      end do
    end if
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'MXRESCPH: MXSXBL : ',MXSXBL
write(u6,*) ' MXRESCPH : MXKAB = ',MXKAB
write(u6,*) ' Info on largest C(Ka,j,Jb) block'
write(u6,*) ' IATP_MX, IBTP_MX, KATP_MX, IOBTP_MX ',IATP_MX,IBTP_MX,KATP_MX,IOBTP_MX
write(u6,*) ' MX_NSPII = ',MX_NSPII
#endif

end subroutine MXRESCPH

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HaveWeConv(iCNum,iCStart,iQ_Atoms,Indma,DT,FFp,xyzMyI,Egun,Energy,NVarv,JaNej,Haveri)

use qmstat_global, only: Cordst, Enelim, iPrint, itMax, nCent, nPart, nPol, Pol, PolLim
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCNum, iCStart, iQ_Atoms, Indma, NVarv
real(kind=wp), intent(inout) :: DT(3,nPol*nPart), Egun
real(kind=wp), intent(in) :: FFp(nPol*nPart,3), Energy
real(kind=wp), intent(out) :: xyzMyI(3)
logical(kind=iwp), intent(out) :: JaNej, Haveri
integer(kind=iwp) :: i, imin, j, k, kmin, l
real(kind=wp) :: Diff, Diffab, dist, distmin, Dtil, Egtest

!----------------------------------------------------------------------*
! With the new and the old induced dipoles, check if we have converged.*
! We also have energy check.                                           *
!----------------------------------------------------------------------*
JaNej = .true.
Haveri = .false.
Diffab = Zero
xyzMyi(:) = Zero
do i=1+(nPol*iCnum),IndMa
  k = i-((i-1)/nPol)*nPol
  do l=1,3
    Dtil = FFp(i,l)*Pol(k)
    Diff = abs(DT(l,i)-Dtil)
    if (Diff > Diffab) Diffab = Diff
    xyzMyi(l) = xyzMyi(l)+Dtil
    ! This is the quantity that has
    ! changed during the iteration and that through FFp
    ! includes the effect of the polarization of the
    ! QM-molecule. It enters the iteration above, unless
    ! we have converged.
    DT(l,i) = Dtil
  end do
end do
Egtest = Egun-Energy
Egun = Energy
if (nVarv >= itMax) then !itMax is from input or default.
  write(u6,*)
  write(u6,*) '  No convergence for the induced dipoles.'
  write(u6,*) '  Difference remaining after ',nVarv,' iterations: ',Diffab
  Haveri = .true.
  iPrint = 10
  do j=icstart,nPart*nCent,nCent
    distmin = 1.0e4_wp
    kmin = 0
    imin = 0
    do i=1,iq_atoms
      do k=0,nCent-1
        dist = sqrt((Cordst(1,i)-Cordst(1,j+k))**2+(Cordst(2,i)-Cordst(2,j+k))**2+(Cordst(3,i)-Cordst(3,j+k))**2)
        if (dist < distmin) then
          distmin = dist
          imin = i
          kmin = k
        end if
      end do
    end do
    write(u6,*) 'solv.',j,'iq_atom',imin,'center',kmin+1,'dist',distmin
  end do
  write(u6,*)
else
  if (abs(egtest) > Enelim) JaNej = .false.
  if (Diffab > PolLim) JaNej = .false.
end if

return

end subroutine HaveWeConv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine OMQMem(nHer,MemOMQ,la,lb,lr)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      Call MltMmP(nOrder,MemP,la,lb+1,lr-1)
!     Not sure what this does. nHer is set on the outside anyway???
      nHer = nOrder
!     not same order (1 not 3) hence lr-2
      Call MltMmP(nOrder,MemN,la,lb,lr-2)
      MemOMQ = Max(MemP,MemN)
      If (lb.gt.0) Then
         Call MltMmP(nOrder,MemM,la,lb-1,lr-1)
!     For L - 1 Component
         MemOMQ = Max(MemOMQ,MemM) + nElem(la)*nElem(lb-1)*6
      End If
!     For dipole term ( L + 0 Component)
      MemOMQ = MemOMQ + nElem(la)*nElem(lb)*3
!     For L + 1 Component
      MemOMQ = MemOMQ + 1 + nElem(la)*nElem(lb+1)*6
      MemOMQ = MemOMQ + nElem(la)*nElem(lb)*9 ! final term
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Pickmo_td(rmo,rmoaa,idsym)

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use MCLR_Data, only: ipMO, nA
use input_mclr, only: nAsh, nBas, nIsh, nSym, ntAsh, TimeDep
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: rmo(*)
real(kind=wp), intent(_OUT_) :: rmoaa(*)
integer(kind=iwp), intent(in) :: idsym
integer(kind=iwp) :: iA, iAA, ijAA, ijkl, ipi, iS, jA, jAA, jS, kA, kAA, klAA, kS, lA, lAA, lS

if (.not. timedep) then
  do iS=1,nSym
    do jS=1,iS
      do kS=1,is
        ls = Mul(Mul(is,js),Mul(ks,idsym))
        if (ls <= ks) then
          do iA=1,nAsh(is)
            iAA = iA+nA(is)
            do jA=1,nAsh(js)
              jAA = jA+nA(js)
              ijAA = iTri(iAA,jAA)
              do kA=1,nAsh(ks)
                kAA = kA+nA(ks)
                do lA=1,nAsh(ls)
                  lAA = lA+nA(ls)
                  klAA = iTri(kAA,lAA)
                  if (ijAA >= klAA) then
                    ijkl = iTri(ijAA,klAA)
                    ipi = ipMO(js,ks,ls)+nIsh(is)+iA-1+nBas(is)*(jA-1)+nBas(is)*nAsh(js)*(kA-1)+nBas(is)*nAsh(js)*nAsh(ks)*(lA-1)
                    !ipi = ipMO(js,ks,ls)+(nBas(is)*(jA-1+nAsh(js)*(kA-1+nAsh(ks)*(lA-1))))+nish(is)+iA-1
                    rmoaa(ijkl) = rmo(ipi)
                  end if
                end do
              end do
            end do
          end do
        end if
      end do
    end do
  end do
else
  do iS=1,nSym
    do jS=1,nsym
      do kS=1,nsym
        ls = Mul(Mul(is,js),Mul(ks,idsym))
        do iA=1,nAsh(is)
          iAA = iA+nA(is)
          do jA=1,nAsh(js)
            jAA = jA+nA(js)
            ijAA = iAA+(jaa-1)*ntash
            do kA=1,nAsh(ks)
              kAA = kA+nA(ks)
              do lA=1,nAsh(ls)
                lAA = lA+nA(ls)
                klAA = kAA+(laa-1)*ntash
                if (ijAA >= klAA) then
                  ijkl = iTri(ijAA,klAA)
                  ipi = ipMO(js,ks,ls)+nIsh(is)+iA-1+nBas(is)*(jA-1)+nBas(is)*nAsh(js)*(kA-1)+nBas(is)*nAsh(js)*nAsh(ks)*(lA-1)
                  !ipi = ipMO(js,ks,ls)+(nBas(is)*(jA-1+nAsh(js)*(kA-1+nAsh(ks)*(lA-1))))+nish(is)+iA-1
                  rmoaa(ijkl) = rmo(ipi)
                end if
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end if

end subroutine Pickmo_td

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               1996, Martin Schuetz                                   *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine TraClc_i(OneHam,Dens,TwoHam,Vxc,nDT,NumDT,iterLw,
     &                    TrDh,TrDP,TrDD,nTr,nD)
************************************************************************
*                                                                      *
* purpose: compute traces                                              *
*                                                                      *
* input:                                                               *
*   Dens    : a few last density matrix differences (nDT,NumDT)        *
*   TwoHam  : a few last two-electron hamiltonians (nDT,NumDT)         *
*   OneHam  : one-electron hamiltonian of length nDT                   *
*   iterLw  : lowest iteration count ...                               *
*             traces are computed from iterLw...iter                   *
*                                                                      *
* output:                                                              *
*   TrDh    : Traces of dD(i)*h of size (nTr)                          *
*   TrDP    : Traces of dD(i)*dP(j) of size (nTr,nTr)                  *
*   TrDD    : Traces of dD(i)*dD(j) of size (nTr,nTr)                  *
*                                                                      *
* called from: Interp, OptClc                                          *
*                                                                      *
* calls to: RWDTG                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Written by:                                                          *
* P.O. Widmark, M.P. Fuelscher and P. Borowski                         *
* University of Lund, Sweden, 1992                                     *
* modified by M. Schuetz, 1996                                         *
* - traces are recomputed for all iterations between iterLw & iter     *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Real*8, Target:: Dens(nDT,nD,NumDT),TwoHam(nDT,nD,NumDT),
     &       Vxc(nDT,nD,NumDT)
      Real*8 OneHam(nDT), TrDh(nTr,nTr,nD),TrDP(nTr,nTr,nD),
     &       TrDD(nTr,nTr,nD)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*---- Define local variables
      Real*8, Dimension(:,:), Allocatable, Target:: Aux1, Aux2, Aux3
      Real*8, Dimension(:,:), Pointer:: pDens, pTwoHam, pVxc
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*define _DEBUGPRINT_
*
      If (iDKeep.lt.0) Return
      iter_d=iter-iter0
      iterLw_d=iterLw-iter0
*
*----------------------------------------------------------------------*
*                                                                      *
* Expand the DFT contribution around the reference density             *
* i.e. the last density.                                               *
*                                                                      *
* Note that for ii larger than 1 that the stored density is the        *
* density difference between the two last iterations.                  *
*                                                                      *
*----------------------------------------------------------------------*
*
*
*     Loop over densities to interpolate over
*
      Do ii = iterLw_d, iter_d
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*        Get the one-particle density_ii
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*        Get pointer to the density
*
         iPosL=MapDns(ii)
*
         If(iPosL.le.0) Then
*
*           If not in memory pick up from disk
*
            If (.Not.Allocated(Aux1))
     &         Call mma_allocate(Aux1,nBT,nD,Label='Aux1')
*
*           Pick up the density matrix and external potential
*
            Call RWDTG(-iPosL,Aux1,nBT*nD,'R','DENS  ',iDisk,MxDDsk)
            pDens => Aux1
         Else
            PDens => Dens(1:nBT,1:nD,iPosL)
         End If
*
         Do iD = 1, nD
*
*           Trace the one-electron density with the one-electron
*           Hamiltonian.
*
            TrDh(ii,ii,iD)=DDot_(nBT,pDens(:,iD),1,OneHam,1)
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
         End Do ! iD
*
         Nullify(pDens)
*
      End Do ! ii
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*
#ifdef _DEBUGPRINT_
      Do iD = 1, nD
         Write(6,'(a)') 'traclc: TrDh'
         Write(6,'(6f16.8)') (TrDh(ii,ii,iD),ii=1,iter_d)
      End Do
#endif
      If (Allocated(Aux1)) Call mma_deallocate(Aux1)
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      Do ii = iterLw_d, iter_d
*
         Do iD = 1, nD
*
*           Trace the two-electron contribution of the Fock matrix with
*           the density. Diagonal terms.
*
            iPosL=MapDns(ii)
            If (iPosL.gt.0) Then
               TrDP(ii,ii,iD)=DDot_(nBT,Dens(1,iD,iPosL),1,
     &                                  TwoHam(1,iD,iPosL),1)
     &                       +DDot_(nBT,Dens(1,iD,iPosL),1,
     &                                  Vxc   (1,iD,iPosL),1)
               TrDD(ii,ii,iD)=DDot_(nBT,Dens(1,iD,iPosL),1,
     &                                  Dens(1,iD,iPosL),1)
            Else
               Write(6,'(a)') 'traclc: should not happen!!!'
               TrDP(ii,ii,iD)=0.0d0
               Call Abend()
            End If
         End Do ! iD
*
         Do i = 1, ii - 1
*
*           Get pointer to density
*
            iPos=MapDns(i)
            If(iPos.le.0) Then
               If (.NOT.Allocated(Aux1)) Then
                  Call mma_allocate(Aux1,nBT,nD,Label='Aux1')
                  Call mma_allocate(Aux2,nBT,nD,Label='Aux2')
                  Call mma_allocate(Aux3,nBT,nD,Label='Aux3')
               End If
               Call RWDTG(-iPos,Aux1,nBT*nD,'R','TWOHAM',iDisk,MxDDsk)
               Call RWDTG(-iPos,Aux2,nBT*nD,'R','dVxcdR',iDisk,MxDDsk)
               Call RWDTG(-iPos,Aux3,nBT*nD,'R','DENS  ',iDisk,MxDDsk)
               pTwoHam => Aux1
               pVxc    => Aux2
               pDens   => Aux3
            Else
               pTwoHam => TwoHam(1:nBT,1:nD,iPos)
               pVxc    => Vxc   (1:nBT,1:nD,iPos)
               pDens   => Dens  (1:nBT,1:nD,iPos)
            End If
*
            Do iD = 1, nD
               TrDP(i,ii,iD) = DDot_(nBT,Dens(1,iD,iPosL),1,
     &                                   pTwoHam(:,iD),1)
               TrDP(ii,i,iD) = TrDP(i,ii,iD)
               TrDP(i,ii,iD) = TrDP(i,ii,iD)
     &                       + DDot_(nBT,Dens(1,iD,iPosL),1,
     &                                   pVxc   (:,iD),1)
               TrDP(ii,i,iD) = TrDP(ii,i,iD)
     &                       + DDot_(nBT,Vxc (1,iD,iPosL),1,
     &                                   pDens(:,iD),1)
               TrDD(i,ii,iD) = DDot_(nBT,Dens(1,iD,iPosl),1,
     &                                   pDens(:,iD),1)
               TrDD(ii,i,iD) = TrDD(i,ii,iD)
*
            End Do ! iD
*
#ifdef _DEBUGPRINT_
            Do iD = 1, nD
               Write(6,*) 'iteration:',ii+iter0
               Write(6,'(a)') 'traclc: TrDh'
               Do iR = 1, ii
                  Write (6,'(6f16.8)')TrDh(iR,iR,iD)
               End Do
               Write(6,'(a)') 'traclc: TrDP'
               Do iR = 1, ii
                  Write (6,'(6f16.8)')(TrDP(iR,iC,iD),iC=1,ii)
               End Do
               Write(6,'(a)') 'traclc: TrDD'
               Do iR = 1, ii
                  Write (6,'(6f16.8)')(TrDD(iR,iC,iD),iC=1,ii)
               End Do
            End Do ! iD
#endif
            Nullify(pTwoHam)
            Nullify(pVxc   )
            Nullify(pDens  )
*
         End Do ! i
*
      End Do ! ii
*
      If (Allocated(Aux1)) Then
         Call mma_deallocate(Aux1)
         Call mma_deallocate(Aux2)
         Call mma_deallocate(Aux3)
      End If
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Yoshio Nishimoto                                 *
!***********************************************************************
!
! Save and restore many quantities that are used in CASPT2 gradient
! calculations using disk at present (hopefully)
! Save with Mode = 1, and restore with Mode = 2
! state-dependent quantities

subroutine SavGradParams(Mode,IDSAVGRD)

use Index_Functions, only: nTri_Elem
use EQSOLV, only: IDBMAT, IDSMAT, IDSTMAT, IDTMAT, IVECX
use fake_GA, only: GA_Arrays
use caspt2_global, only: do_lindep, DREF, IDBoriMat, iTasks_grad, LUGRAD, LUSBT, LUSOLV, LUSTD, NBUF1_GRAD, nTasks_grad, PREF
use caspt2_module, only: E2Tot, EASum, ERef, HZERO, jState, MxCase, nAshT, nASup, nBTri, nCases, nG1, nG2, nG3, nG3Tot, nInDep, &
                         nISup, nState, nSym, RefEne, RFPert
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, myRank
use GA_Wrapper, only: DBL_MB, GA_Destroy, GA_NodeId
use caspt2_global, only: LURHS
use caspt2_module, only: cLab10, iAdr10, IOFFRHS
#endif
use SC_NEVPT2, only: IDBMAT_NEVPT2, SC_amplitude, SC_prop
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: Mode
integer(kind=iwp), intent(inout) :: IDSAVGRD
integer(kind=iwp) :: ICASE, ID, iLUID, IORW, ISYM, NAS, NIN, NIS, NMAX
integer(kind=iwp), allocatable :: IWRK1(:)
integer(kind=byte), allocatable :: idxG3(:,:)
real(kind=wp), allocatable :: WRK1(:)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: I, IDISK, IEND, ISTA, JEND, JSTA, LDM, LDW, lg_S, lg_ST, lg_T, mV1, NBLOCK
logical(kind=iwp) :: bStat
#endif

!! Shift the address due to SavGradParams2
if (IDSAVGRD == 0) then
  IDSAVGRD = NSTATE+3*NSTATE**2
  if (RFpert) IDSAVGRD = IDSAVGRD+NBTRI+1
end if
#ifdef _MOLCAS_MPP_
I = 0
myRank = GA_NODEID()
#endif

!! Decide what to do
if (Mode == 1) then
  IORW = 1 !! Write
else if (Mode == 2) then
  IORW = 2 !! Read
end if

!! Save internal contractions-related quantities
!! 1. Some integers
!! - Number of independent vectors
call IDAFILE(LUGRAD,IORW,NINDEP(1,1),8*MXCASE,IDSAVGRD)
!! - Number of active indices
call IDAFILE(LUGRAD,IORW,NASUP(1,1),8*MXCASE,IDSAVGRD)
!! - Number of inactive + secondary indices
call IDAFILE(LUGRAD,IORW,NISUP(1,1),8*MXCASE,IDSAVGRD)

!! 2. RDMs
!! - NG1, NG2, NG3
call mma_allocate(IWRK1,6,Label='IWRK1')
if (IORW == 1) then
  IWRK1(1) = NG1
  IWRK1(2) = NG2
  IWRK1(3) = NG3
  IWRK1(4) = NG3TOT
  IWRK1(5) = NBUF1_GRAD
  IWRK1(6) = nTasks_grad
  call IDAFILE(LUGRAD,IORW,IWRK1,6,IDSAVGRD)
else if (IORW == 2) then
  call IDAFILE(LUGRAD,IORW,IWRK1,6,IDSAVGRD)
  NG1 = IWRK1(1)
  NG2 = IWRK1(2)
  NG3 = IWRK1(3)
  NG3TOT = IWRK1(4)
  NBUF1_GRAD = IWRK1(5)
  nTasks_grad = IWRK1(6)
  iTasks_grad(:) = 0
end if
call mma_deallocate(IWRK1)
call IDAFILE(LUGRAD,IORW,iTasks_grad,NASHT**2,IDSAVGRD)

NMAX = NG3

do ISYM=1,NSYM
  do ICASE=1,11
    NIN = NINDEP(ISYM,ICASE)
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    NMAX = max(NMAX,nTri_Elem(NAS),NAS*NIN,NIS)
  end do
  do ICASE=12,13
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    NMAX = max(NMAX,NAS*NIS)
  end do
end do

call mma_allocate(WRK1,NMAX,Label='WRK1')

call mma_allocate(idxG3,6,NG3,label='idxG3')
if (IORW == 1) then
  !! NG3 index
  iLUID = 0
  call I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)
  call I1DAFILE(LUGRAD,1,idxG3,6*NG3,IDSAVGRD)

  !! D and F
  call PT2_GET(NG1,' GAMMA1',WRK1)
  call DDAFILE(LUGRAD,IORW,WRK1,NG1,IDSAVGRD)
  call PT2_GET(NG2,' GAMMA2',WRK1)
  call DDAFILE(LUGRAD,IORW,WRK1,NG2,IDSAVGRD)
  call PT2_GET(NG3,' GAMMA3',WRK1)
  call DDAFILE(LUGRAD,IORW,WRK1,NG3,IDSAVGRD)

  if (HZERO /= 'DYALL') then
    call PT2_GET(NG1,' DELTA1',WRK1)
    call DDAFILE(LUGRAD,IORW,WRK1,NG1,IDSAVGRD)
    call PT2_GET(NG2,' DELTA2',WRK1)
    call DDAFILE(LUGRAD,IORW,WRK1,NG2,IDSAVGRD)
    call PT2_GET(NG3,' DELTA3',WRK1)
    call DDAFILE(LUGRAD,IORW,WRK1,NG3,IDSAVGRD)
  end if

  !! EASUM
  WRK1(1) = EASUM
  call DDAFILE(LUGRAD,IORW,WRK1,1,IDSAVGRD)
else if (IORW == 2) then
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    !! Reset, because NG3 can be different
    !! STINI has been skipped
    IADR10(:,1) = -1
    IADR10(:,2) = 0
    CLAB10(:) = '   EMPTY'
    IADR10(1,1) = 0
  end if
# endif
  !! NG3 index
  call I1DAFILE(LUGRAD,2,idxG3,6*NG3,IDSAVGRD)
  iLUID = 0
  call I1DAFILE(LUSOLV,1,idxG3,6*NG3,iLUID)

  !! D and F
  call DDAFILE(LUGRAD,IORW,WRK1,NG1,IDSAVGRD)
  call PT2_PUT(NG1,' GAMMA1',WRK1)
  call DDAFILE(LUGRAD,IORW,WRK1,NG2,IDSAVGRD)
  call PT2_PUT(NG2,' GAMMA2',WRK1)
  call DDAFILE(LUGRAD,IORW,WRK1,NG3,IDSAVGRD)
  call PT2_PUT(NG3,' GAMMA3',WRK1)

  if (HZERO /= 'DYALL') then
    call DDAFILE(LUGRAD,IORW,WRK1,NG1,IDSAVGRD)
    call PT2_PUT(NG1,' DELTA1',WRK1)
    call DDAFILE(LUGRAD,IORW,WRK1,NG2,IDSAVGRD)
    call PT2_PUT(NG2,' DELTA2',WRK1)
    call DDAFILE(LUGRAD,IORW,WRK1,NG3,IDSAVGRD)
    call PT2_PUT(NG3,' DELTA3',WRK1)
  end if

  !! EASUM
  call DDAFILE(LUGRAD,IORW,WRK1,1,IDSAVGRD)
  EASUM = WRK1(1)
  call GETDPREF(DREF,size(DREF),PREF,size(PREF))
  EREF = REFENE(JSTATE)
end if
call mma_deallocate(idxG3)

!! 3. LUSBT matrices
do ISYM=1,NSYM
  do ICASE=1,11
    NIN = NINDEP(ISYM,ICASE)
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (IORW == 1) then
      if (NAS > 0) then
        !! Active overlap
#       ifdef _MOLCAS_MPP_
        if (is_real_par() .and. ((icase == 1) .or. (icase == 4))) then
          call PSBMAT_GETMEM('S',lg_S,NAS)
          call PSBMAT_READ('S',iCase,iSym,lg_S,NAS)
          call GA_Distribution(lg_S,myRank,ISTA,IEND,JSTA,JEND)
          if ((ISTA > 0) .and. (JSTA > 0)) then
            call GA_Access(lg_S,ISTA,IEND,JSTA,JEND,mV1,LDM)
            NBLOCK = LDM*(JEND-JSTA+1)
            call DDAFILE(LUGRAD,1,DBL_MB(mV1),NBLOCK,IDSAVGRD)
            call GA_Release(lg_S,ISTA,IEND,JSTA,JEND)
          end if
          call PSBMAT_FREEMEM(lg_S)
        else
#       endif
          ID = IDSMAT(ISYM,ICASE)
          if (ID >= 0) then
            call DDAFILE(LUSBT,2,WRK1,nTri_Elem(NAS),ID)
            call DDAFILE(LUGRAD,1,WRK1,nTri_Elem(NAS),IDSAVGRD)
          end if
#       ifdef _MOLCAS_MPP_
        end if
#       endif
        if ((NIN > 0) .and. (.not. SC_prop)) then
          !! ST matrix
#         ifdef _MOLCAS_MPP_
          if (is_real_par() .and. ((icase == 1) .or. (icase == 4))) then
            call GA_CREATE_STRIPED('H',NAS,NIN,'STMAT',lg_ST)
            call PSBMAT_READ('M',iCase,iSym,lg_ST,NAS*NIN)
            call GA_Distribution(lg_ST,myRank,ISTA,IEND,JSTA,JEND)
            if ((ISTA > 0) .and. (JSTA > 0)) then
              call GA_Access(lg_ST,ISTA,IEND,JSTA,JEND,mV1,LDM)
              NBLOCK = LDM*(JEND-JSTA+1)
              call DDAFILE(LUGRAD,1,DBL_MB(mV1),NBLOCK,IDSAVGRD)
              call GA_Release(lg_ST,ISTA,IEND,JSTA,JEND)
            end if
            bStat = GA_Destroy(lg_ST)
          else
#         endif
            ID = IDSTMAT(ISYM,ICASE)
            call DDAFILE(LUSBT,2,WRK1,NAS*NIN,ID)
            call DDAFILE(LUGRAD,1,WRK1,NAS*NIN,IDSAVGRD)
#         ifdef _MOLCAS_MPP_
          end if
#         endif
          !! Transformation matrix (eigenvector)
#         ifdef _MOLCAS_MPP_
          if (is_real_par() .and. ((icase == 1) .or. (icase == 4))) then
            call GA_CREATE_STRIPED('H',NAS,NIN,'TMAT',lg_T)
            call PSBMAT_READ('T',iCase,iSym,lg_T,NAS*NIN)
            call GA_Distribution(lg_T,myRank,ISTA,IEND,JSTA,JEND)
            if ((ISTA > 0) .and. (JSTA > 0)) then
              call GA_Access(lg_T,ISTA,IEND,JSTA,JEND,mV1,LDM)
              NBLOCK = LDM*(JEND-JSTA+1)
              call DDAFILE(LUGRAD,1,DBL_MB(mV1),NBLOCK,IDSAVGRD)
              call GA_Release(lg_T,ISTA,IEND,JSTA,JEND)
            end if
            bStat = GA_Destroy(lg_T)
          else
#         endif
            ID = IDTMAT(ISYM,ICASE)
            call DDAFILE(LUSBT,2,WRK1,NAS*NIN,ID)
            call DDAFILE(LUGRAD,1,WRK1,NAS*NIN,IDSAVGRD)
#         ifdef _MOLCAS_MPP_
          end if
#         endif
        end if
      end if
      !! Eigenvalue
      ID = IDBMAT(ISYM,ICASE)
      if (NAS > 0) then
        call DDAFILE(LUSBT,2,WRK1,NAS,ID)
        call DDAFILE(LUGRAD,1,WRK1,NAS,IDSAVGRD)
      end if
      !! IS
      if (SC_amplitude .and. (NIS > 0)) then
        call DDAFILE(LUSBT,2,WRK1,NIS,ID)
        call DDAFILE(LUGRAD,1,WRK1,NIS,IDSAVGRD)
      end if
      if (do_lindep .and. (NAS > 0)) then
        ID = IDBoriMat(ISYM,ICASE)
        call DDAFILE(LUSTD,2,WRK1,nTri_Elem(NAS),ID)
        call DDAFILE(LUGRAD,1,WRK1,nTri_Elem(NAS),IDSAVGRD)
      end if
      !! Original B matrix, needed in SC-NEVPT2 gradient
      if ((HZERO == 'DYALL') .and. SC_amplitude) then
        ID = IDBMAT_NEVPT2(ISYM,ICASE,1)
        call DDAFILE(LUSBT,2,WRK1,nTri_Elem(NAS),ID)
        call DDAFILE(LUGRAD,1,WRK1,nTri_Elem(NAS),IDSAVGRD)
        ID = IDBMAT_NEVPT2(ISYM,ICASE,2)
        call DDAFILE(LUSBT,2,WRK1,NIS,ID)
        call DDAFILE(LUGRAD,1,WRK1,NIS,IDSAVGRD)
      end if
    else if (IORW == 2) then
      if (NAS > 0) then
        !! Active overlap
#       ifdef _MOLCAS_MPP_
        if (is_real_par() .and. ((icase == 1) .or. (icase == 4))) then
          call PSBMAT_GETMEM('S',lg_S,NAS)
          call GA_Distribution(lg_S,myRank,ISTA,IEND,JSTA,JEND)
          if ((ISTA > 0) .and. (JSTA > 0)) then
            call GA_Access(lg_S,ISTA,IEND,JSTA,JEND,mV1,LDM)
            NBLOCK = LDM*(JEND-JSTA+1)
            call DDAFILE(LUGRAD,2,DBL_MB(mV1),NBLOCK,IDSAVGRD)
            call GA_Release(lg_S,ISTA,IEND,JSTA,JEND)
          end if
          call PSBMAT_WRITE('S',iCase,iSym,lg_S,NAS)
          call PSBMAT_FREEMEM(lg_S)
        else
#       endif
          ID = IDSMAT(ISYM,ICASE)
          if (ID >= 0) then
            call DDAFILE(LUGRAD,2,WRK1,nTri_Elem(NAS),IDSAVGRD)
            call DDAFILE(LUSBT,1,WRK1,nTri_Elem(NAS),ID)
          end if
#       ifdef _MOLCAS_MPP_
        end if
#       endif
        if ((NIN > 0) .and. (.not. SC_prop)) then
          !! ST matrix
#         ifdef _MOLCAS_MPP_
          if (is_real_par() .and. ((icase == 1) .or. (icase == 4))) then
            call GA_CREATE_STRIPED('H',NAS,NIN,'STMAT',lg_ST)
            call GA_Distribution(lg_ST,myRank,ISTA,IEND,JSTA,JEND)
            if ((ISTA > 0) .and. (JSTA > 0)) then
              call GA_Access(lg_ST,ISTA,IEND,JSTA,JEND,mV1,LDM)
              NBLOCK = LDM*(JEND-JSTA+1)
              call DDAFILE(LUGRAD,2,DBL_MB(mV1),NBLOCK,IDSAVGRD)
              call GA_Release(lg_ST,ISTA,IEND,JSTA,JEND)
            end if
            call PSBMAT_WRITE('M',iCase,iSym,lg_ST,NAS*NIN)
            bStat = GA_Destroy(lg_ST)
          else
#         endif
            call DDAFILE(LUGRAD,2,WRK1,NAS*NIN,IDSAVGRD)
            ID = IDSTMAT(ISYM,ICASE)
            call DDAFILE(LUSBT,1,WRK1,NAS*NIN,ID)
#         ifdef _MOLCAS_MPP_
          end if
#         endif
          !! Transformation matrix (eigenvector)
#         ifdef _MOLCAS_MPP_
          if (is_real_par() .and. ((icase == 1) .or. (icase == 4))) then
            call GA_CREATE_STRIPED('H',NAS,NIN,'TMAT',lg_T)
            call GA_Distribution(lg_T,myRank,ISTA,IEND,JSTA,JEND)
            if ((ISTA > 0) .and. (JSTA > 0)) then
              call GA_Access(lg_T,ISTA,IEND,JSTA,JEND,mV1,LDM)
              NBLOCK = LDM*(JEND-JSTA+1)
              call DDAFILE(LUGRAD,2,DBL_MB(mV1),NBLOCK,IDSAVGRD)
              call GA_Release(lg_T,ISTA,IEND,JSTA,JEND)
            end if
            call PSBMAT_WRITE('T',iCase,iSym,lg_T,NAS*NIN)
            bStat = GA_Destroy(lg_T)
#           include "macros.fh"
            unused_var(bStat)
          else
#         endif
            call DDAFILE(LUGRAD,2,WRK1,NAS*NIN,IDSAVGRD)
            ID = IDTMAT(ISYM,ICASE)
            call DDAFILE(LUSBT,1,WRK1,NAS*NIN,ID)
#         ifdef _MOLCAS_MPP_
          end if
#         endif
        end if
      end if
      !! Eigenvalue
      ID = IDBMAT(ISYM,ICASE)
      if (NAS > 0) then
        call DDAFILE(LUGRAD,2,WRK1,NAS,IDSAVGRD)
        call DDAFILE(LUSBT,1,WRK1,NAS,ID)
      end if
      !! IS
      if (SC_amplitude .and. (NIS > 0)) then
        call DDAFILE(LUGRAD,2,WRK1,NIS,IDSAVGRD)
        call DDAFILE(LUSBT,1,WRK1,NIS,ID)
      end if
      if (do_lindep .and. (NAS > 0)) then
        call DDAFILE(LUGRAD,2,WRK1,nTri_Elem(NAS),IDSAVGRD)
        ID = IDBoriMat(ISYM,ICASE)
        call DDAFILE(LUSTD,1,WRK1,nTri_Elem(NAS),ID)
      end if
      !! Original B matrix, needed in SC-NEVPT2 gradient
      if ((HZERO == 'DYALL') .and. SC_amplitude) then
        ID = IDBMAT_NEVPT2(ISYM,ICASE,1)
        call DDAFILE(LUGRAD,2,WRK1,nTri_Elem(NAS),IDSAVGRD)
        call DDAFILE(LUSBT,1,WRK1,nTri_Elem(NAS),ID)
        ID = IDBMAT_NEVPT2(ISYM,ICASE,2)
        call DDAFILE(LUGRAD,2,WRK1,NIS,IDSAVGRD)
        call DDAFILE(LUSBT,1,WRK1,NIS,ID)
      end if
    end if
  end do
end do

if (SC_amplitude) then
  do ISYM=1,NSYM
    do ICASE=12,13
      NAS = NASUP(ISYM,ICASE)
      NIS = NISUP(ISYM,ICASE)
      if (IORW == 1) then
        !! Eigenvalue
        ID = IDBMAT(ISYM,ICASE)
        if (NAS > 0) then
          call DDAFILE(LUSBT,2,WRK1,NAS,ID)
          call DDAFILE(LUGRAD,1,WRK1,NAS,IDSAVGRD)
        end if
        !! IS
        if (NIS > 0) then
          call DDAFILE(LUSBT,2,WRK1,NIS,ID)
          call DDAFILE(LUGRAD,1,WRK1,NIS,IDSAVGRD)
        end if
      else if (IORW == 2) then
        !! Eigenvalue
        ID = IDBMAT(ISYM,ICASE)
        if (NAS > 0) then
          call DDAFILE(LUGRAD,2,WRK1,NAS,IDSAVGRD)
          call DDAFILE(LUSBT,1,WRK1,NAS,ID)
        end if
        !! IS
        if (NIS > 0) then
          call DDAFILE(LUGRAD,2,WRK1,NIS,IDSAVGRD)
          call DDAFILE(LUSBT,1,WRK1,NIS,ID)
        end if
      end if
    end do
  end do
end if

!! 4. E2TOT
if (IORW == 1) then
  WRK1(1) = E2TOT
  call DDAFILE(LUGRAD,IORW,WRK1,1,IDSAVGRD)
else if (IORW == 2) then
  call DDAFILE(LUGRAD,IORW,WRK1,1,IDSAVGRD)
  E2TOT = WRK1(1)
end if

call mma_deallocate(WRK1)

!! quasi-canonical active orbital energy
!call DDAFILE(LUGRAD,IORW,EPSA,NASHT,IDSAVGRD)

!! 5. Save T-amplitude (IRHS = LURHS(1) = 51)
!! SC-NEVPT2 does not use IVECX
if ((HZERO /= 'DYALL') .or. (.not. SC_prop)) call SaveReadT1()
!! We at least need to create IVECX for MECI search
if ((HZERO == 'DYALL') .and. SC_prop .and. (IORW == 2)) call RHS_ZERO(IVECX)

contains

subroutine SaveReadT1()

  integer(kind=iwp) :: ICASE_, ISYM_, lg_V1, NVEC

  !! IVECX = T (solution; not quasi-variational, before lambda-eq)
  IVECX = 2

  do ICASE_=1,NCASES
    do ISYM_=1,NSYM
      NIN = NINDEP(ISYM_,ICASE_)
      if (NIN == 0) cycle
      NIS = NISUP(ISYM_,ICASE_)
      NAS = NASUP(ISYM_,ICASE_)
      NVEC = NIN*NIS
      if ((ICASE_ == 12) .or. (ICASE_ == 13)) NVEC = NAS*NIS
      if (NVEC == 0) cycle
      if ((ICASE_ == 12) .or. (ICASE_ == 13)) then
        call RHS_ALLO(NAS,NIS,lg_V1)
        if (IORW == 1) then
#         ifdef _MOLCAS_MPP_
          if (is_real_par()) then
            call GA_Distribution(lg_V1,myRank,ISTA,IEND,JSTA,JEND)
            if ((IEND-ISTA+1 == NAS) .and. (ISTA > 0)) then
              call GA_Access(lg_V1,ISTA,IEND,JSTA,JEND,mV1,LDW)
              NVEC = (IEND-ISTA+1)*(JEND-JSTA+1)
              IDISK = IOFFRHS(ISYM_,ICASE_)
              call DDAFILE(LURHS(IVECX),2,DBL_MB(mV1),NVEC,IDISK)
              call DDAFILE(LUGRAD,IORW,DBL_MB(mV1),NVEC,IDSAVGRD)
              call GA_Release(lg_V1,ISTA,IEND,JSTA,JEND)
            end if
          else
#         endif
            if (NAS*NIS > 0) then
              call RHS_READ_SR(lg_V1,ICASE_,ISYM_,IVECX)
              call DDAFILE(LUGRAD,IORW,GA_Arrays(lg_V1)%A,NAS*NIS,IDSAVGRD)
            end if
#         ifdef _MOLCAS_MPP_
          end if
#         endif
        else if (IORW == 2) then
#         ifdef _MOLCAS_MPP_
          if (is_real_par()) then
            call GA_Distribution(lg_V1,myRank,ISTA,IEND,JSTA,JEND)
            if ((IEND-ISTA+1 == NAS) .and. (ISTA > 0)) then
              call GA_Access(lg_V1,ISTA,IEND,JSTA,JEND,mV1,LDW)
              NVEC = (IEND-ISTA+1)*(JEND-JSTA+1)
              call DDAFILE(LUGRAD,IORW,DBL_MB(mV1),NVEC,IDSAVGRD)
              IDISK = IOFFRHS(ISYM_,ICASE_)
              call DDAFILE(LURHS(IVECX),1,DBL_MB(mV1),NVEC,IDISK)
              call GA_Release(lg_V1,ISTA,IEND,JSTA,JEND)
            end if
          else
#         endif
            if (NAS*NIS > 0) then
              call DDAFILE(LUGRAD,IORW,GA_Arrays(lg_V1)%A,NAS*NIS,IDSAVGRD)
              call RHS_SAVE(NIN,NIS,lg_V1,ICASE_,ISYM_,IVECX)
            end if
#         ifdef _MOLCAS_MPP_
          end if
#         endif
        end if
        call RHS_FREE(lg_V1)
      else
        call RHS_ALLO(NIN,NIS,lg_V1)
        if (IORW == 1) then
#         ifdef _MOLCAS_MPP_
          if (is_real_par()) then
            call GA_Distribution(lg_V1,myRank,ISTA,IEND,JSTA,JEND)
            if ((IEND-ISTA+1 == NIN) .and. (ISTA > 0)) then
              call GA_Access(lg_V1,ISTA,IEND,JSTA,JEND,mV1,LDW)
              NVEC = (IEND-ISTA+1)*(JEND-JSTA+1)
              IDISK = IOFFRHS(ISYM_,ICASE_)
              call DDAFILE(LURHS(IVECX),2,DBL_MB(mV1),NVEC,IDISK)
              call DDAFILE(LUGRAD,IORW,DBL_MB(mV1),NVEC,IDSAVGRD)
              call GA_Release(lg_V1,ISTA,IEND,JSTA,JEND)
            end if
          else
#         endif
            if (NIN*NIS > 0) then
              call RHS_READ_SR(lg_V1,ICASE_,ISYM_,IVECX)
              call DDAFILE(LUGRAD,IORW,GA_Arrays(lg_V1)%A,NIN*NIS,IDSAVGRD)
            end if
#         ifdef _MOLCAS_MPP_
          end if
#         endif
        else if (IORW == 2) then
#         ifdef _MOLCAS_MPP_
          if (is_real_par()) then
            call GA_Distribution(lg_V1,myRank,ISTA,IEND,JSTA,JEND)
            if ((IEND-ISTA+1 == NIN) .and. (ISTA > 0)) then
              call GA_Access(lg_V1,ISTA,IEND,JSTA,JEND,mV1,LDW)
              NVEC = (IEND-ISTA+1)*(JEND-JSTA+1)
              call DDAFILE(LUGRAD,IORW,DBL_MB(mV1),NVEC,IDSAVGRD)
              IDISK = IOFFRHS(ISYM_,ICASE_)
              call DDAFILE(LURHS(IVECX),1,DBL_MB(mV1),NVEC,IDISK)
              call GA_Release(lg_V1,ISTA,IEND,JSTA,JEND)
            end if
          else
#         endif
            if (NIN*NIS > 0) then
              call DDAFILE(LUGRAD,IORW,GA_Arrays(lg_V1)%A,NIN*NIS,IDSAVGRD)
              call RHS_SAVE(NIN,NIS,lg_V1,ICASE_,ISYM_,IVECX)
            end if
#         ifdef _MOLCAS_MPP_
          end if
#         endif
        end if
        call RHS_FREE(lg_V1)
      end if
    end do
  end do

end subroutine SaveReadT1

end subroutine SavGradParams

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Set_Data
      Implicit Real*8 (a-h,o-z)
*
#include "mxdim.fh"
#include "cdtfaux.fh"
#include "files_mbpt2.fh"
*
CStart Molcas
*
*     Aux
*
      Thize=1.0d-6
      SIntTh=1.0d-14
      TfThre=1.0d-14
      nDisc =0
CEnd
*                                                                      *
************************************************************************
*                                                                      *
*     Set up some file names
*
      LUINTA=40
      FNINTA='ORDINT'
      LUHLF1=50
      FNHLF1='LUHLF1'
      LUHLF2=60
      FNHLF2='LUHLF2'
      LUHLF3=70
      FNHLF3='LUHLF3'
      LUINTM=80
      FNINTM='MOLINT'
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Jeppe Olsen                                      *
!***********************************************************************

function ISYMSTR(ISYM,NSTR)
! Symmetry of product of NSTR string symmetries
!
! works currently only for D2H and subgroups
!
! Jeppe Olsen, 1998

use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ISYMSTR
integer(kind=iwp), intent(in) :: NSTR, ISYM(NSTR)
integer(kind=iwp) :: JSTR

ISYMSTR = 1
do JSTR=1,NSTR
  ISYMSTR = Mul(ISYMSTR,ISYM(JSTR))
end do

end function ISYMSTR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,poss0,posst)
c
c     realize mapping without permutation
c     define mapd,mapi
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer poss0,posst
       integer mapda(0:512,1:6),mapdb(0:512,1:6)
       integer mapia(1:8,1:8,1:8),mapib(1:8,1:8,1:8)
c
c     help variables
c
       integer ib,nhelp,i,j,k
c
c     def mapib
c
       do 10 k=1,nsym
       do 11 j=1,nsym
       do 12 i=1,nsym
       mapib(i,j,k)=mapia(i,j,k)
 12     continue
 11     continue
 10     continue
c
c     def initial values
c
       do nhelp=1,6
       mapdb(0,nhelp)=mapda(0,nhelp)
       end do
c
       posst=poss0
       do 100 ib=1,mapda(0,5)
       do nhelp=2,6
       mapdb(ib,nhelp)=mapda(ib,nhelp)
       end do
       mapdb(ib,1)=posst
       posst=posst+mapdb(ib,2)
c
       call map11 (wrk(mapda(ib,1)),wrk(mapdb(ib,1)),mapda(ib,2),1)
c
 100    continue
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine CpOvlp(from,to)

#include "intent.fh"

use Genano_globals, only: MxLqn, nSym, nBas, iSymBk, Center, BasName, symlab
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: from(*)
real(kind=wp), intent(_OUT_) :: to(*)
integer(kind=iwp) :: iBas, iBasX, iBlk, ijBas, ind, indx, iSym, jBas, jBasX, jndx
logical(kind=iwp) :: oki, okj

do iBlk=1,(MxLqn+1)**2
  indx = 0
  ijBas = 0
  iBasX = 0
  do iSym=1,nSym
    do iBas=1,nBas(iSym)
      iBasX = iBasX+1
      oki = BasName(iBasX)(1:len(Center)) == Center
      oki = oki .and. (BasName(iBasX)(len(Center)+1:) == symlab(iBlk))
      if (oki) indx = indx+1
      jndx = 0
      jBasX = iBasX-iBas
      do jBas=1,iBas
        jBasX = jBasX+1
        ijBas = ijBas+1
        okj = BasName(jBasX)(1:len(Center)) == Center
        okj = okj .and. (BasName(jBasX)(len(Center)+1:) == symlab(iBlk))
        if (okj) jndx = jndx+1
        if (oki .and. okj) then
          ind = jndx+indx*(indx-1)/2+iSymBk(iBlk)-1
          to(ind) = from(ijBas)
        end if
      end do
    end do
  end do
end do
!write(u6,*) '*** Overlap matrix in CpOvlp ***'
!iBlk = 0
!do iLqn=0,MxLqn
!  do iShell=-iLqn,iLqn
!    iBlk = iBlk+1
!    if (nPrim(iLqn) > 0) then
!      write(u6,'(a,2i5)') ' Block',iLqn,iShell
!      call Triprt(' ','(6F12.6)',to(iSymBk(iBlk)),nPrim(iLqn))
!    end if
!  end do
!end do

return

end subroutine CpOvlp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine NATORB_CASPT2(DMAT,nDMAT,CMO,nCMO,OCC,nOcc,CNAT,nCNAT)
! Given DMAT, symmetry-blocked array of triangular
! density matrices in MO basis, and symmetry-blocked
! array CMO of MO coefficients, return array of
! natural occupation numbers and MO coefficients of
! natural orbitals.

use Index_Functions, only: nTri_Elem
use caspt2_module, only: NBAS, NDEL, NFRO, NORB, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDMAT, nCMO, nOcc, nCNAT
real(kind=wp), intent(in) :: DMAT(nDMAT), CMO(nCMO)
real(kind=wp), intent(out) :: OCC(nOcc), CNAT(nCNAT)
integer(kind=iwp) :: ICMO, IDMAT, IOCC, ISYM, NB, ND, NF, NO, NTMP
real(kind=wp), allocatable :: TMP(:)

IDMAT = 0
IOCC = 0
ICMO = 0
do ISYM=1,NSYM
  NF = NFRO(ISYM)
  NO = NORB(ISYM)
  ND = NDEL(ISYM)
  NB = NBAS(ISYM)
  !  Frozen orbitals:
  if (NF > 0) then
    OCC(IOCC+1:IOCC+NF) = Two
    IOCC = IOCC+NF
    CNAT(ICMO+1:ICMO+NB*NF) = CMO(ICMO+1:ICMO+NB*NF)
    ICMO = ICMO+NB*NF
  end if
  ! Inactive, active, and secondary orbitals:
  if (NO > 0) then
    NTMP = nTri_Elem(NO)
    call mma_allocate(TMP,NTMP,Label='TMP')
    CNAT(ICMO+1:ICMO+NB*NO) = CMO(ICMO+1:ICMO+NB*NO)
    ! For correct order, change sign.
    TMP(:) = -DMAT(IDMAT+1:IDMAT+NTMP)
    call NIDiag(TMP,CNAT(ICMO+1),NO,NB)
    call JACORD(TMP,CNAT(ICMO+1),NO,NB)
    call VEIG(NO,TMP,OCC(IOCC+1))
    ! Change back to positive sign.
    OCC(IOCC+1:IOCC+NO) = -OCC(IOCC+1:IOCC+NO)
    IDMAT = IDMAT+NTMP
    IOCC = IOCC+NO
    ICMO = ICMO+NB*NO
    call mma_deallocate(TMP)
  end if
  ! Deleted orbitals:
  if (ND > 0) then
    OCC(IOCC+1:IOCC+ND) = Zero
    IOCC = IOCC+ND
    CNAT(ICMO+1:ICMO+NB*ND) = CMO(ICMO+1:ICMO+NB*ND)
    ICMO = ICMO+NB*ND
  end if
end do

end subroutine NATORB_CASPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine IsItValid(Coo,CooRef,ValidOrNot)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"

      Parameter (dTroskel=1d-4)

      Dimension Coo(MxCen,3),CooRef(MxCen,3)

      Logical ValidOrNot

      ValidOrNot=.true.
*-- Lengths.
      Do 101, i=1,4
        Do 102, j=i+1,5
          dL_test=0.0d0
          dL_ref=0.0d0
          Do 103, k=1,3
            dL_test=dL_test+(Coo(i,k)-Coo(j,k))**2
            dL_ref=dL_ref+(CooRef(i,k)-CooRef(j,k))**2
103       Continue
          If(abs(dL_test-dL_ref).gt.dTroskel) then
            ValidOrNot=.false.
            Go To 999
          Endif
102     Continue
101   Continue

999   Continue

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine r2elint(rKappa,rMO1,rmo2,FockI,FockA,nF,
     &                   iDSym,sign,Fact,jspin)
*
************************************************************************
*
*     Constructs the one index transformed Fock-matrixes
*     and (pj|kl).
*     rKappa : the transformation matrix
*     iDSym  : Symmetry of transformation
*     sign   : 1:real -1:complex
*     jspin  : 0:singlet 1:triplet
*
************************************************************************
*
      use Arrays, only: CMO, G1t, FAMO, FIMO
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"
#include "Input.fh"
#include "stdalloc.fh"
      Logical lFI,lFA,lMo
      Parameter ( One = 1.0d0 )
      Real*8 rKappa(nDens2),rMO1(nMba),rmo2(*),FockI(nDens2),
     &       FockA(nDens2)
      Real*8, Allocatable:: T1(:), Tmp2(:), T3(:), T4(:), DIL(:),
     &                      DI(:), DIR(:), FI(:),
     &                      DAL(:), DAR(:), DA(:), FA(:)

*
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
      ndens22=ndens2
      iAM=0
      iBM=0
      Do i=1,nSym
       Do j=1,nSym
        nDens22=Max(nDens22,nBas(i)*nBas(j))
       End do
       iAM=Max(iAM,nAsh(i)+nIsh(i))
       iBM=Max(iBM,nBAs(i))
      End Do
      imem=nDens22

      Call mma_allocate(T1,imem,Label='T1')
      Call mma_allocate(Tmp2,nDens22,Label='Tmp2')
      Call mma_allocate(T3,nDens22,Label='T3')
      Call mma_allocate(T4,nDens22,Label='T4')
      Call mma_allocate(DIL,nDens2,Label='DIL')
      Call mma_allocate(DI,nCMO,Label='DI')
      Call mma_allocate(DIR,nDens2,Label='DIR')
      Call mma_allocate(FI,ndens2,Label='FI')

      FockI(:)=0.0d0
      FockA(:)=0.0d0
      FI(:)   =0.0d0
      DI(:)   =0.0d0
      DIL(:)  =0.0d0
      DIR(:)  =0.0d0
      lFI=.true.
      lFa=.false.
      lMo=.false.
      If (iMethod.eq.2) Then
         Call mma_allocate(DAL,nDens2,Label='DAL')
         Call mma_allocate(DAR,nDens2,Label='DAR')
         Call mma_allocate(DA,nCMO,Label='DA')
         Call mma_allocate(FA,nDens2,Label='FA')
         lFa=.true.
         lMo=.true.
      Else
         Call mma_allocate(DAL,1,Label='DAL')
         Call mma_allocate(DAR,1,Label='DAR')
         Call mma_allocate(DA,1,Label='DA')
         Call mma_allocate(FA,1,Label='FA')
      End If
      FA(:) =0.0d0
      DA(:) =0.0d0
      DAL(:)=0.0d0
      DAR(:)=0.0d0

      Do iS=1,nSym
         Do iB=1,nIsh(iS)
            ip=ipCM(iS)+(ib-1)*nOrb(is)+ib-1
            DI(ip)=2.0d0
         End Do
      End Do
      If (iMethod.eq.2) Then
       Do iS=1,nSym
        Do iB=1,nAsh(iS)
         Do jB=1,nAsh(iS)
          ip=ipCM(iS)+ib+nIsh(is)+(jB+nIsh(is)-1)*nOrb(is)-1
          iA=nA(is)+ib
          jA=nA(is)+jb
          ip2=itri(iA,jA)
          DA(ip)=G1t(ip2)
         End Do
        End Do
       End Do
      End If
*
*     Construct {kappa,(ij|kl)} and the fock matrix contribution
*     from one index tranformation of contracted indexes
*
      FacR=Fact
      Call Read2_2(rmo1,rmo2,
     &         FockI,FockA,
     &         T1,imem,
     &         Tmp2,
     &         T3,T4,
     &         DIR,DIL,
     &         DI,
     &         DAR,DAL,
     &         DA,
     &         rkappa,idsym,Sign,Facr,jSpin,
     &         lFA,lfi,lMo,
     &         CMO)
*
*       call recprt('1 FockI ','',FockI,nDens2,1)
*       call recprt('1 FockA ','',FockA,nDens2,1)
*
*      Calculate contribution from uncontracted indexes.
*
      Do iS=1,nSym
       jS=iEOr(iS-1,iDSym-1)+1
       If (nOrb(iS)*nOrb(jS).ne.0) Then
       If (.not.CASINT)
     & Call DGEMM_('T','N',
     &             nOrb(iS),nOrb(jS),nBas(iS),
     &             1.0d0,CMO(ipCM(iS)),nBas(iS),
     &             FI(ipMat(iS,jS)),nBas(iS),
     &             0.0d0,FockI(ipMat(iS,jS)),nOrb(iS))
       Call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(iS),Sign*Facr,
     &            FIMO(ipCM(iS)),nOrb(is),
     &            rkappa(ipMat(iS,jS)),nOrb(iS),
     &            One,FockI(ipMat(iS,jS)),nOrb(iS))
       Call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(jS),Facr,
     &            rkappa(ipMat(iS,jS)),nOrb(is),
     &            FIMO(ipCM(jS)),nOrb(jS),
     &            One,FockI(ipMat(iS,jS)),nOrb(is))
       If (iMethod.eq.iCASSCF) Then
       If (.not.CASINT)
     &   Call DGEMM_('T','N',
     &               nOrb(iS),nOrb(jS),nBas(iS),
     &               1.0d0,CMO(ipCM(iS)),nBas(iS),
     &               FA(ipMat(iS,jS)),nBas(iS),
     &               0.0d0,FockA(ipMat(iS,jS)),nOrb(iS))
         Call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(iS),Sign*Facr,
     &            FAMO(ipCM(iS)),nOrb(is),
     &            rkappa(ipMat(iS,jS)),nOrb(iS),
     &            One,FockA(ipMat(iS,jS)),nOrb(iS))
         Call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(jS),Facr,
     &            rkappa(ipMat(iS,jS)),nOrb(is),
     &            FAMO(ipCM(jS)),nOrb(jS),
     &            One,FockA(ipMat(iS,jS)),nOrb(is))
       End If
       End If
      End Do

!       call recprt('2 FockI ','',FockI,nDens2,1)
!       call recprt('2 FockA ','',FockA,nDens2,1)

      Call mma_deallocate(DA)
      Call mma_deallocate(DAR)
      Call mma_deallocate(DAL)
      Call mma_deallocate(FA)
      Call mma_deallocate(FI)
      Call mma_deallocate(DIR)
      Call mma_deallocate(DI)
      Call mma_deallocate(DIL)
      Call mma_deallocate(T4)
      Call mma_deallocate(T3)
      Call mma_deallocate(Tmp2)
      Call mma_deallocate(T1)

      Return
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(nF)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine wfnsizes_rassi()
      use rasdef, only: NRS1, NRS1T, NRS2, NRS2T, NRS3, NRS3T
      use rassi_aux, only : nasht_save
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NISHT,NASHT,NOSHT,NSSHT,NBST,
     &                      NAES,NASH,NBASF,NISH,NOSH,NSSH
      implicit none
      integer :: isym
C The structure of the orbital space:
      NISHT=0
      NASHT=0
      NRS1T=0
      NRS2T=0
      NRS3T=0
      NOSHT=0
      NSSHT=0
      NBST=0
      DO ISYM=1,NSYM
        NAES(ISYM)=NASHT
        NISHT=NISHT+NISH(ISYM)
        NASHT=NASHT+NASH(ISYM)
        NRS1T=NRS1T+NRS1(ISYM)
        NRS2T=NRS2T+NRS2(ISYM)
        NRS3T=NRS3T+NRS3(ISYM)
        NOSHT=NOSHT+NOSH(ISYM)
        NSSHT=NSSHT+NSSH(ISYM)
        NBST=NBST+NBASF(ISYM)
      END DO
      nasht_save=nasht
      end subroutine wfnsizes_rassi

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000,2021, Roland Lindh                                *
!               2021, Jie Bao                                          *
!***********************************************************************

subroutine Do_Batch(Kernel,Func,mGrid,list_s,nlist_s,List_Exp,List_Bas,Indx,nIndex,FckInt,nFckDim,nFckInt,mAO,nD,nP2_ontop,Do_MO, &
                    TabMO,TabSO,nMOs,Do_Grad,Grad,nGrad,ndRho_dR,nGrad_Eff,iNQ,EG_OT,nTmpPUVX,PDFTPot1,PDFTFocI,PDFTFocA)
!***********************************************************************
!      Author:Roland Lindh, Department of Chemical Physics, University *
!             of Lund, SWEDEN. November 2000                           *
!***********************************************************************

use iSD_data, only: iSD
use SOAO_Info, only: iAOtSO
use Real_Spherical, only: ipSph, RSph
use Basis_Info, only: dbsc, Shells
use Phase_Info, only: iPhase
use KSDFT_Info, only: do_pdftPot, Funcaa, Funcbb, Funccc
use nq_Grid, only: Angular, D1UnZip, Dens_AO, dRho_dR, F_xc, F_xca, F_xcb, Fact, GradRho, Grid, Grid_AO, iBfn_Index, kAO, &
                   l_CASDFT, Mem, nRho, P2UnZip, Rho, Sigma, TabAO, TabAO_Pack, Weights
use nq_pdft, only: lft, lGGA, MOas, MOax, MOay, MOaz
use nq_MO, only: CMO, D1MO, P2_ontop
use Grid_On_Disk, only: Grid_Status, iDisk_Grid, Lu_Grid, Old_Functional_Type, Regenerate, Use_Old
use nq_Info, only: Dens_a1, Dens_a2, Dens_b1, Dens_b2, Dens_I, Dens_t1, Dens_t2, Functional_Type, GGA_Type, Grad_I, LDA_Type, &
                   meta_GGA_type1, meta_GGA_type2, mRad, NASHT, ndc, nOrbt, nPot1, NQ_Direct, Off, On, Packing, T_Y, Tau_I
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, r8, RtoB

implicit none
external :: Kernel
integer(kind=iwp), intent(in) :: mGrid, nlist_s, list_s(2,nlist_s), List_Exp(nlist_s), List_Bas(2,nlist_s), nIndex, Indx(nIndex), &
                                 nFckDim, nFckInt, mAO, nD, nP2_ontop, nMOs, nGrad, ndRho_dR, nGrad_Eff, iNQ, nTmpPUVX
real(kind=wp), intent(inout) :: Func, FckInt(nFckInt,nFckDim), TabMO(mAO,mGrid,nMOs), Grad(nGrad), EG_OT(nTmpPUVX), &
                                PDFTPot1(nPot1), PDFTFocI(nPot1), PDFTFocA(nPot1)
real(kind=wp), intent(out) :: TabSO(mAO,mGrid,nMOs)
logical(kind=iwp), intent(in) :: Do_MO, Do_Grad
integer(kind=iwp) :: i1, i2, iAdd, iAng, iAO, iBas, iBas_Eff, iBfn, iBfn_e, iBfn_s, iCmp, iCnt, iCnttp, iDrv, iGrid, iList_s, &
                     IndAO1, Indi, ipRadial, iPrim, iPrim_Eff, ipx, ipxyz, ipy, ipz, iR, ish, iShll, iSkal, iSkip, iSO1, jBfn, &
                     jlist_s, kBfn, mData, mdci, mRho, mTabAO, nBfn, nByte, nCMO, nData, nDrv, nForm, nPMO3p, nTerm, nxyz, &
                     TabAO_Size(2)
real(kind=wp) :: A(3), px, py, pz, RA(3), SMax, Thr
logical(kind=iwp) :: l_tanhr
integer(kind=iwp), allocatable :: Tmp_Index(:,:)
real(kind=wp), allocatable :: MOs(:,:), MOx(:,:), MOy(:,:), MOz(:,:), P2_ontop_d(:,:,:), P2MOCube(:,:), P2MOCubex(:,:), &
                              P2MOCubey(:,:), P2MOCubez(:,:), RhoA(:,:), RhoI(:,:), TabAO_Tmp(:)
! MOs,MOx,MOy and MOz are for active MOs.
! MOas is for all MOs.
real(kind=wp), external :: Comp_d, Compute_Rho, Compute_Grad, Compute_Tau
real(kind=r8), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
nCMO = size(CMO)
l_tanhr = .false.

if (l_casdft) then
  call PDFTMemAlloc(mGrid,nOrbt)
  mRho = nP2_ontop
  call mma_allocate(RhoI,mRho,mGrid,Label='RhoI')
  call mma_allocate(RhoA,mRho,mGrid,Label='RhoA')
  RhoI(:,:) = Zero
  RhoA(:,:) = Zero
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Set up an indexation translation between the running index of
! the AOIntegrals and the actual basis function index

nBfn = 0
do iList_s=1,nList_s
  iBas_Eff = List_Bas(1,ilist_s)
  iSkal = list_s(1,ilist_s)
  iCmp = iSD(2,iSkal)
  nBfn = nBfn+iBas_Eff*iCmp
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Evaluate the AOs on the grid points.                                 *
!                                                                      *
!***********************************************************************
!                                                                      *
TabAO(:,:,:) = Zero
TabAO_Size(:) = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute AO's or retrive from disk

if ((NQ_Direct == Off) .and. ((Grid_Status == Use_Old) .and. (.not. Do_Grad) .and. (Functional_Type == Old_Functional_Type))) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Retrieve (and unpack) the AOs from disc

  call iDaFile(Lu_Grid,2,TabAO_Size,2,iDisk_Grid)
  if (TabAO_Size(1) == 0) then
    call Terminate()
    return
  end if
  nBfn = TabAO_Size(1)
  call mma_Allocate(iBfn_Index,6,nBfn,Label='iBfn_Index')
  call iDaFile(Lu_Grid,2,iBfn_Index,size(iBfn_Index),iDisk_Grid)

  nByte = TabAO_Size(2)
  if (Packing == On) then
    mTabAO = (nByte+RtoB-1)/RtoB
  else
    mTabAO = nByte
  end if
  call dDaFile(Lu_Grid,2,TabAO,mTabAO,iDisk_Grid)

  if (Packing == On) then
    nData = size(TabAO)
    call mma_Allocate(TabAO_Tmp,nData,Label='TabAO_Tmp')
    nByte = TabAO_Size(2)
    call UpkR8(0,nData,nByte,TabAO_Pack,TabAO_Tmp)
    TabAO_Pack(:) = TabAO_Tmp(:)
    call mma_deAllocate(TabAO_Tmp)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute the AO's

  call mma_Allocate(iBfn_Index,6,nBfn,Label='iBfn_Index')
  iBfn_Index(:,:) = 0

  ! Generate the values of the AOs on the grid

  Mem(:) = Zero
  ipxyz = 1

! define _ANALYSIS_
# ifdef _ANALYSIS_
  Thr = T_Y
  write(u6,*)
  write(u6,*) ' Sparsity analysis of AO blocks'
  mlist_s = 0
# endif
  !iOff = 1
  iBfn = 0
  iBfn_s = 0
  iBfn_e = 0
  do ilist_s=1,nlist_s
    ish = list_s(1,ilist_s)

    iShll = iSD(0,iSh)
    iAng = iSD(1,iSh)
    iCmp = iSD(2,iSh)
    iBas = iSD(3,iSh)
    iBas_Eff = List_Bas(1,ilist_s)
    iPrim = iSD(5,iSh)
    iPrim_Eff = List_Exp(ilist_s)
    iAO = iSD(7,iSh)
    mdci = iSD(10,iSh)
    iShll = iSD(0,iSh)
    iCnttp = iSD(13,iSh)
    iCnt = iSD(14,iSh)
    A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

    ! Set up the unsifted version of iBfn_Index

    iAdd = iBas-iBas_Eff
    iBfn_s = iBfn+1
    do i1=1,iCmp
      iSO1 = iAOtSO(iAO+i1,0) ! just used when nIrrep=1
      do i2=1,iBas_Eff
        IndAO1 = i2+iAdd
        Indi = iSO1+IndAO1-1

        iBfn = iBfn+1
        iBfn_Index(1,iBfn) = Indi
        iBfn_Index(2,iBfn) = ilist_s
        iBfn_Index(3,iBfn) = i1
        iBfn_Index(4,iBfn) = i2
        iBfn_Index(5,iBfn) = mdci
        iBfn_Index(6,iBfn) = IndAO1
      end do
    end do
    iBfn_e = iBfn

    nDrv = mRad-1
    nForm = 0
    do iDrv=0,nDrv
      nForm = nForm+nTri_Elem1(iDrv)
    end do
    nTerm = 2**nDrv
    nxyz = mGrid*3*(iAng+mRad)
    !nRadial = iBas_Eff*mGrid*mRad
    ipRadial = ipxyz+nxyz

    iR = list_s(2,ilist_s)

    ipx = iPhase(1,iR)
    ipy = iPhase(2,iR)
    ipz = iPhase(3,iR)
    px = real(iPhase(1,iR),kind=wp)
    py = real(iPhase(2,iR),kind=wp)
    pz = real(iPhase(3,iR),kind=wp)
    RA(1) = px*A(1)
    RA(2) = py*A(2)
    RA(3) = pz*A(3)

    ! Evaluate AOs at RA

    call AOEval(iAng,mGrid,Grid,Mem(ipxyz),RA,Shells(iShll)%Transf,RSph(ipSph(iAng)),nTri_Elem1(iAng),iCmp,Angular,nTerm,nForm, &
                T_Y,mRad,iPrim,iPrim_Eff,Shells(iShll)%Exp,Mem(ipRadial),iBas_Eff,Shells(iShll)%pCff(1,iBas-iBas_Eff+1), &
                TabAO(:,:,iBfn_s:),mAO,px,py,pz,ipx,ipy,ipz)
#   ifdef _ANALYSIS_
    ix = iDAMax_(mAO*mGrid*iBas_Eff*iCmp,TabAO_Pack(iOff),1)
    TMax = abs(TabAO_Pack(iOff-1+ix))
    if (TMax < Thr) then
      mlist_s = mlist_s+1
      write(u6,*) ' ilist_s: ',ilist_s
      write(u6,*) ' TMax:    ',TMax
    end if
#   endif

    ! At this time eliminate individual basis functions which have
    ! an insignificant contribution to any of the grid points we
    ! are processing at this stage.

    Thr = T_Y
    iSkip = 0
    kBfn = iBfn_s-1
    do jBfn=iBfn_s,iBfn_e
      call Spectre(SMax)
      if (SMax < Thr) then
        iSkip = iSkip+1
      else
        kBfn = kBfn+1
        if (kBfn /= jBfn) then
          TabAO(:,:,kBfn) = TabAO(:,:,jBfn)
          iBfn_Index(:,kBfn) = iBfn_Index(:,jBfn)
        end if
      end if
    end do
    iBfn = kBfn

    !iOff = iBfn*mAO*mGrid+1

    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! reduced the size of the table to be exactly that of the
  ! number of functions that have non-zero contributions.
  if (iBfn /= nBfn) then
    if (iBfn == 0) then
      TabAO_Size(:) = 0
      call iDaFile(Lu_Grid,1,TabAO_Size,2,iDisk_Grid)
      call Terminate()
      return
    end if
    call mma_allocate(Tmp_Index,6,iBfn,Label='Tmp_Index')
    Tmp_Index(:,1:iBfn) = iBfn_Index(:,1:iBfn)
    call mma_deallocate(iBfn_Index)
    nBfn = iBfn
    call mma_Allocate(iBfn_Index,6,nBfn,Label='iBfn_Index')
    iBfn_Index(:,:) = Tmp_Index(:,:)
    call mma_deallocate(Tmp_Index)
  end if
  TabAO_Size(1) = nBfn

# ifdef _ANALYSIS_
  write(u6,*) ' % AO blocks that can be eliminated: ',100.0_wp*real(mlist_s,kind=wp)/real(nlist_s,kind=wp)
  write(u6,*)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_Allocate(Dens_AO,nBfn,nBfn,nD,Label='Dens_AO')
call mma_Allocate(Grid_AO,kAO,mGrid,nBfn,nD,Label='Grid_AO')
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Evaluate some MOs on the grid                                        *
!                                                                      *
!***********************************************************************
!                                                                      *
if (Do_MO) then

  ! First, symmatry adapt the AOs
  TabSO(:,:,:) = Zero
  jlist_s = 0
  call mk_SOs(TabSO,mAO,mGrid,nMOs,List_s,List_Bas,nList_s,jlist_s)

  ! Second, transform SOs to MOs
  call mk_MOs(TabSO,mAO,mGrid,TabMO,nMOs,CMO,nCMO)
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Compute Rho, Grad Rho, Tau, Laplacian, and the Sigma vectors.
! In case of gradient calculations compute Cartesian derivatives
! of Rho, Grad Rho, Tau, and the Laplacian.

call Mk_Rho(list_s,nlist_s,Fact,ndc,list_bas,Indx,nIndex,Do_Grad)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (l_casdft) then
  Dens_t1 = Dens_t1+Comp_d(Weights,mGrid,Rho,nRho,nD,0)
  Dens_a1 = Dens_a1+Comp_d(Weights,mGrid,Rho,nRho,nD,1)
  Dens_b1 = Dens_b1+Comp_d(Weights,mGrid,Rho,nRho,nD,2)

  nPMO3p = 0
  if (lft .and. lGGA) nPMO3p = mGrid

  call mma_allocate(P2MOCube,NASHT,mGrid)
  call mma_allocate(P2MOCubex,NASHT,nPMO3p)
  call mma_allocate(P2MOCubey,NASHT,nPMO3p)
  call mma_allocate(P2MOCubez,NASHT,nPMO3p)
  call mma_allocate(MOs,NASHT,mGrid)
  call mma_allocate(MOx,NASHT,mGrid)
  call mma_allocate(MOy,NASHT,mGrid)
  call mma_allocate(MOz,NASHT,mGrid)
  call mma_allocate(P2_ontop_d,nP2_ontop,nGrad_Eff,mGrid)

  call CalcP2MOCube(P2MOCube,P2MOCubex,P2MOCubey,P2MOCubez,nPMO3p,MOs,MOx,MOy,MOz,TabMO,P2Unzip,mAO,mGrid,nMOs,Do_Grad)
  P2_ontop(:,:) = Zero

  if (.not. Do_Grad) then !regular MO-based run
    call Do_PI2(D1MO,size(D1MO),TabMO,mAO,mGrid,nMOs,P2_ontop,nP2_ontop,RhoI,RhoA,mRho,P2MOCube,MOs,MOx,MOy,MOz)
  else !AO-based run for gradients
    P2_ontop_d(:,:,:) = Zero
    call Do_Pi2grad(mAO,mGrid,P2_ontop,nP2_ontop,nGrad_Eff,list_s,nlist_s,list_bas,D1MO,size(D1MO),TabMO,P2_ontop_d,RhoI,RhoA, &
                    mRho,nMOs,CMO,nCMO,TabSO,lft,P2MOCube,P2MOCubex,P2MOCubey,P2MOCubez,nPMO3p,MOs,MOx,MOy,MOz)
  end if

  call TranslateDens(P2_OnTop,dRho_dr,P2_OnTop_d,l_tanhr,mGrid,nP2_OnTop,ndRho_dR,nGrad_Eff,Do_Grad)

  call mma_deallocate(P2MOCube)
  call mma_deallocate(P2MOCubex)
  call mma_deallocate(P2MOCubey)
  call mma_deallocate(P2MOCubez)
  call mma_deallocate(MOs)
  call mma_deallocate(MOx)
  call mma_deallocate(MOy)
  call mma_deallocate(MOz)
  call mma_deallocate(P2_ontop_d)

  ! Integrate out the number of electrons
  Dens_t2 = Dens_t2+Comp_d(Weights,mGrid,Rho,nRho,nD,0)
  Dens_a2 = Dens_a2+Comp_d(Weights,mGrid,Rho,nRho,nD,1)
  Dens_b2 = Dens_b2+Comp_d(Weights,mGrid,Rho,nRho,nD,2)

end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (allocated(Sigma)) then
  if (size(Sigma,1) == 1) then
    do iGrid=1,mGrid
      Sigma(1,iGrid) = GradRho(1,iGrid)**2+GradRho(2,iGrid)**2+GradRho(3,iGrid)**2
    end do
  else
    do iGrid=1,mGrid
      Sigma(1,iGrid) = GradRho(1,iGrid)**2+GradRho(2,iGrid)**2+GradRho(3,iGrid)**2
      Sigma(2,iGrid) = GradRho(1,iGrid)*GradRho(4,iGrid)+GradRho(2,iGrid)*GradRho(5,iGrid)+GradRho(3,iGrid)*GradRho(6,iGrid)
      Sigma(3,iGrid) = GradRho(4,iGrid)**2+GradRho(5,iGrid)**2+GradRho(6,iGrid)**2
    end do
  end if
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Integrate out the number of electrons, |grad|, and tau

Dens_I = Dens_I+Compute_Rho(Weights,mGrid,nD)
select case (Functional_type)
  case (LDA_Type)
  case (GGA_type)
    Grad_I = Grad_I+Compute_Grad(Weights,mGrid,nD)
  case (meta_GGA_type1,meta_GGA_type2)
    Grad_I = Grad_I+Compute_Grad(Weights,mGrid,nD)
    Tau_I = Tau_I+Compute_Tau(Weights,mGrid,nD)
end select
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Evaluate the functional on the grid                                  *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! evaluate the energy density, the derivative of the functional with
! respect to rho and grad rho.

call Kernel(mGrid,nD)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Integrate the energy of the functional

Func = Func+DDot_(mGrid,Weights,1,F_xc,1)
if (l_casdft) then
  Funcaa = Funcaa+DDot_(mGrid,Weights,1,F_xca,1)
  Funcbb = Funcbb+DDot_(mGrid,Weights,1,F_xcb,1)
  Funccc = Func-Funcaa-Funcbb
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (Do_Grad) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute the DFT contribution to the gradient                       *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call DFT_Grad(Grad,nGrad,nD,Grid,mGrid,dRho_dR,ndRho_dR,nGrad_Eff,Weights,iNQ)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (l_casdft) then
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! For MC-PDFT optionally compute stuff for the CP-MC-PDFT          *
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    if (do_pdftPot) then
      call mma_allocate(MOs,NASHT,mGrid)
      call TransferMO(MOas,TabMO,mAO,mGrid,nMOs,1)
      if (lft .and. lGGA) then
        call TransferMO(MOax,TabMO,mAO,mGrid,nMOs,2)
        call TransferMO(MOay,TabMO,mAO,mGrid,nMOs,3)
        call TransferMO(MOaz,TabMO,mAO,mGrid,nMOs,4)
      end if
      call TransActMO(MOs,TabMO,mAO,mGrid,nMOs)
      call Calc_Pot1(PDFTPot1,TabMO,mAO,mGrid,nMOs,P2_ontop,nP2_ontop,MOas)
      call Calc_Pot2(EG_OT,mGrid,P2_ontop,nP2_ontop)
      call PDFTFock(PDFTFocI,PDFTFocA,D1Unzip,mGrid,MOs)
      call mma_deallocate(MOs)
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Compute the DFT contribution to the Fock matrix                  *
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    call DFT_Int(list_s,nlist_s,FckInt,nFckInt,nD,Fact,ndc)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! AOs on the grid are (packed and) written to disk.

if ((NQ_Direct == Off) .and. ((Grid_Status == Regenerate) .and. (.not. Do_Grad))) then

  TabAO_Size(1) = nBfn
  if (Packing == On) then

    ! Pack before they are put on disc

    nData = mAO*mGrid*nBfn
    call mma_Allocate(TabAO_Tmp,nData,Label='TabAO_Tmp')
    TabAO_Tmp(1:nData) = TabAO_Pack(1:nData)
    call PkR8(0,nData,nByte,TabAO_Tmp,TabAO_Pack)
    mData = (nByte+RtoB-1)/RtoB
    if (mData > nData) then
      call WarningMessage(2,'mData > nData')
      write(u6,*) 'nData=',nData
      write(u6,*) 'nData=',nData
      call Abend()
    end if
    TabAO_Size(2) = nByte
    call mma_deAllocate(TabAO_Tmp)
  else
    mData = mAO*mGrid*nBfn
    TabAO_Size(2) = mData
  end if

  call iDaFile(Lu_Grid,1,TabAO_Size,2,iDisk_Grid)
  call iDaFile(Lu_Grid,1,iBfn_Index,size(iBfn_Index),iDisk_Grid)
  mTabAO = mData
  call dDaFile(Lu_Grid,1,TabAO,mTabAO,iDisk_Grid)

end if
!                                                                      *
!***********************************************************************
!                                                                      *
call Terminate()

return

contains

subroutine Terminate()

  if (l_casdft) call PDFTMemDeAlloc()

  if (allocated(RhoI)) then
    call mma_deallocate(RhoI)
    call mma_deallocate(RhoA)
  end if
  if (allocated(iBfn_Index)) call mma_deAllocate(iBfn_Index)
  if (allocated(Grid_AO)) call mma_deAllocate(Grid_AO)
  if (allocated(Dens_AO)) call mma_deAllocate(Dens_AO)

end subroutine Terminate

subroutine Spectre(SMax)

  real(kind=wp), intent(out) :: SMax
  integer(kind=iwp) :: iGrid, iAO

  SMax = Zero
  do iGrid=1,mGrid
    do iAO=1,mAO
      SMax = max(SMax,abs(Weights(iGrid)*TabAO(iAO,iGrid,jBfn)))
    end do
  end do
  !if (SMax < Thr) Write(u6,*) SMax,TMax

end subroutine Spectre

end subroutine Do_Batch

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Compress2(ArrayIn,nIn,ArrayOut,nOut,dsym)
*
*************************************************************
*
*     Change from kappa   to vector notation
*                      ip
*
*     where i is occupied and p is general
*
*     used by the preconditioner.
*
*************************************************************
*
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
      Integer dsym
      Real*8  ArrayIn(nIn),ArrayOut(nOut)
*                                                                      *
************************************************************************
*                                                                      *
      indexC=0
      jT=-1
      i1=0
      i2=0
      Fact=1.0d0
      If (dsym.lt.0) Fact=-Fact
      dsym=abs(dsym)
      call dcopy_(nDens,[0.0d0],0,ArrayOut,1)
*
      Do iSym=1,nSym
         jSym = iEOR(iSym-1,dSym-1)+1
*
         Do jBas=1,nB(jSym)
*
            If (jBas.le.nIsh(jsym)) Then
               jT=0
               i1=nIsh(isym)
               j1=nIsh(jsym)
            Else If (jBas.le.nIsh(jsym)+nRs1(jsym)) Then
               jT=1
               i1=nRs1(isym)
               j1=nRs1(jsym)
            Else If (jBas.le.nIsh(jsym)+nRs2(jsym)) Then
               jT=2
               i1=nRs2(isym)
               j1=nRs2(jsym)
            Else If (jBas.le.nIsh(jsym)+nRs3(jsym)) Then
               jT=3
               i1=nRs3(isym)
               j1=nRs3(jsym)
            End If
*
            Do iBas=1,nOrb(iSym)
*
               If (iBas.le.nIsh(isym)) Then
                  iT=0
                  ij=0
                  ji=j1
               Else If (iBas.le.nIsh(isym)+nRs1(isym)) Then
                  iT=1
                  ij=0
                  ji=j1
                  If (it.gt.jt) Then
                     ij=i1
                     ji=0
                  End if
               Else If (iBas.le.nIsh(isym)+nRs2(isym)) Then
                  iT=2
                  ij=0
                  ji=j1
                  If (it.gt.jt) Then
                     ij=i1
                     ji=0
                  End if
               Else If (iBas.le.nIsh(isym)+nRs3(isym)) Then
                  iT=3
                  ij=0
                  ji=j1
                  If (it.gt.jt) Then
                     ij=i1
                     ji=0
                  End if
               Else
                 iT=4
                 ij=i1
                 ji=0
               End If
*                                                                      *
************************************************************************
*                                                                      *
               If (Timedep) Then
                  If (iT.ne.jT) Then
                     indexC = indexc+1
                     Index1 = ipMat(iSym,jSym)
     &                      + (jBas-1)*nOrb(iSym)+iBas-1
                     ArrayOut(Index1)=Fact*ArrayIn(indexC)
                  End If
               Else
                  If (iT.gt.jT) Then
                     indexC = indexc+1
                     Index1 = ipMat(iSym,jSym)
     &                      + (jBas-1)*nOrb(iSym)+iBas-ij-1
                     ArrayOut(IndexC)=ArrayIn(index1)
*                    Index2 = ipMat(jSym,iSym)
*     &                     + (iBas-1)*nOrb(jSym)+jBas-ji-1
*                    If (jBas.le.nB(jsym))
*     &                 ArrayOut(Index2)=Fact*ArrayIn(indexC)
                  End If
               End If
*                                                                      *
************************************************************************
*                                                                      *
            End Do     ! iBas
         End Do       ! jBas
      End Do          ! iSym
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine RHS_ADD(NAS,NIS,lg_W,W)
!SVC: this routine adds to the local part of a global RHS array the
!matching part of a replicate array.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
use Constants, only: One
use Definitions, only: u6
#endif
use fake_GA, only: GA_Arrays
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NAS, NIS, lg_W
real(kind=wp), intent(in) :: W(NAS,NIS)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iHi, iLo, jHi, jLo, LDW, mW, myRank, NW

if (Is_Real_Par()) then
  myRank = GA_NodeID()
  call GA_Distribution(lg_W,myRank,iLo,iHi,jLo,jHi)
  if ((iLo /= 0) .and. (jLo /= 0)) then
    if ((iLo /= 1) .or. (iHi /= NAS)) then
      write(u6,*) 'Not a contiguous vertical stripe'
      call abend()
    end if
    NW = NAS*(jHi-jLo+1)
    call GA_Access(lg_W,iLo,iHi,jLo,jHi,mW,LDW)
    ! can't use array statement because DBL_MB is out of bounds!
    call DAXPY_(NW,One,W(:,jLo:jHi),1,DBL_MB(mW),1)
    call GA_Release_Update(lg_W,iLo,iHi,jLo,jHi)
  end if
else
#endif
  GA_Arrays(lg_W)%A(1:NAS*NIS) = GA_Arrays(lg_W)%A(1:NAS*NIS)+pack(W(:,1:NIS),.true.)
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine RHS_ADD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

subroutine CMSRdMat(Mat,NRow,NCol,FileName,NameLen)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NRow, NCol, NameLen
real(kind=wp), intent(out) :: Mat(NCol,NRow)
character(len=NameLen), intent(in) :: FileName
integer(kind=iwp) :: I, LU
integer(kind=iwp), external :: IsFreeUnit

LU = IsFreeUnit(33)
call Molcas_Open(LU,FileName)
do I=1,NRow
  read(LU,*) Mat(:,I)
end do
close(LU)

end subroutine CMSRdMat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine allocate_vplp_memory()
#include "drt_h.fh"
#include "pl_structure_h.fh"
      allocate(lp_coe(norb_dz+1:norb_inn+1,maxpl))
      allocate(lp_head(maxpl))
      allocate(lp_ltail(maxpl))
      allocate(lp_rtail(maxpl))
      allocate(lp_lwei(maxpl))
      allocate(lp_rwei(maxpl))
      allocate(vplp_w0(maxpl))
      allocate(vplp_w1(maxpl))
      allocate(logic_br(maxpl))
      allocate(lpnew_coe(norb_dz+1:norb_inn+1,maxpl))
      allocate(lpnew_head(maxpl))
      allocate(lpnew_ltail(maxpl))
      allocate(lpnew_rtail(maxpl))
      allocate(lpnew_lwei(maxpl))
      allocate(lpnew_rwei(maxpl))
      allocate(vplpnew_w0(maxpl))
      allocate(vplpnew_w1(maxpl))
      allocate(logic_newbr(maxpl))

      allocate(value_lpext(max_tmpvalue))
      allocate(value_lpext1(max_tmpvalue))
      allocate(value_lpext2(max_tmpvalue))
      allocate(index_lpext(max_tmpvalue))
      allocate(index_lpext1(max_tmpvalue))
      allocate(index_lpext2(max_tmpvalue))

      return
      end

      subroutine deallocate_vplp_memory()
#include "drt_h.fh"
#include "pl_structure_h.fh"

      deallocate(lp_coe)
      deallocate(lp_head)
      deallocate(lp_rtail)
      deallocate(lp_lwei)
      deallocate(lp_rwei)
      deallocate(vplp_w0)
      deallocate(vplp_w1)
      deallocate(logic_br)
      deallocate(lpnew_coe)
      deallocate(lpnew_head)
      deallocate(lpnew_ltail)
      deallocate(lpnew_rtail)
      deallocate(lpnew_lwei)
      deallocate(lpnew_rwei)
      deallocate(vplpnew_w0)
      deallocate(vplpnew_w1)
      deallocate(logic_newbr)

      deallocate(value_lpext)
      deallocate(value_lpext1)
      deallocate(value_lpext2)
      deallocate(index_lpext)
      deallocate(index_lpext1)
      deallocate(index_lpext2)

      return
      end

      subroutine change_vplp_pointer_arrays()
#include "drt_h.fh"
      REAL*8,pointer :: plptmp(:)
      integer, pointer :: iplptmp(:)
#include "pl_structure_h.fh"
      plptmp=>vplp_w0
      vplp_w0=>vplpnew_w0
      vplpnew_w0=>plptmp

      plptmp=>vplp_w1
      vplp_w1=>vplpnew_w1
      vplpnew_w1=>plptmp

      iplptmp=>lp_head
      lp_head=>lpnew_head
      lpnew_head=>iplptmp

      iplptmp=>lp_lwei
      lp_lwei=>lpnew_lwei
      lpnew_lwei=>iplptmp

      iplptmp=>lp_rwei
      lp_rwei=>lpnew_rwei
      lpnew_rwei=>iplptmp

      iplptmp=>lp_ltail
      lp_ltail=>lpnew_ltail
      lpnew_ltail=>iplptmp

      iplptmp=>lp_rtail
      lp_rtail=>lpnew_rtail
      lpnew_rtail=>iplptmp

      end

      subroutine change_coe_pointer_arrays()
#include "drt_h.fh"
      integer, dimension(:,:), pointer :: icoetmp
#include "pl_structure_h.fh"
      icoetmp=>lp_coe
      lp_coe=>lpnew_coe
      lpnew_coe=>icoetmp
      end

      subroutine change_br_pointer_arrays()
#include "drt_h.fh"
      logical, dimension(:), pointer :: logic_brtmp
#include "pl_structure_h.fh"
      logic_brtmp=>logic_br
      logic_br=>logic_newbr
      logic_newbr=>logic_brtmp
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************
Module Arrays

Implicit None
Private
Public :: Hss, FAMO, FIMO, F0SQMO, FAMO_spinp, FAMO_spinm, SFock, G2mp, G2pp, G2mm, Fm, Fp, &
          G1p, G1m, CMO_Inv, CMO, INT1, pINT1, INT2, pInt2, &
          G2t, G2sq, G1t,  &
          KAIN1, KINT2, KINT2A, TI1, TI2

Real*8, Allocatable:: Hss(:)
Real*8, Allocatable:: FAMO(:), FIMO(:), FAMO_spinp(:), FAMO_spinm(:), SFock(:)
Real*8, Allocatable:: Fm(:), Fp(:)
Real*8, Allocatable:: F0SQMO(:)
!     Various one- and two-particle densities
Real*8, Allocatable:: G1t(:)
Real*8, Allocatable:: G1p(:), G1m(:)
Real*8, Allocatable:: G2t(:)
Real*8, Allocatable:: G2sq(:)
Real*8, Allocatable:: G2mp(:), G2pp(:), G2mm(:)
!     MO coefficients
Real*8, Allocatable:: CMO(:)
Real*8, Allocatable:: CMO_Inv(:)

!         INT1        :  1-electron integrals
!         INT2        :  2-electron integrals
!         PINT1       :  Offsets to symmetry blocks
!         PINT2       :  Offsets to symmetry blocks

Real*8,  Target, Allocatable::  INT1(:)
Integer, Allocatable:: pINT1(:)
Real*8,  Allocatable::  INT2(:)
Integer, Allocatable:: pINT2(:)

Real*8, Pointer:: KAIN1(:), KINT2(:), KINT2A(:)
Real*8, Target, Allocatable:: TI1(:), TI2(:)
End Module Arrays

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkgrd_cvb(civb,civb2,grad,dvbdet,np,doorb)

use casvb_global, only: ndet, ndetvb, npr, nprorb, nvb, strucopt, vbdet
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: civb(0:ndet)
real(kind=wp), intent(inout) :: civb2(0:ndet)
real(kind=wp), intent(out) :: grad(npr), dvbdet(ndetvb)
integer(kind=iwp), intent(in) :: np
logical(kind=iwp), intent(in) :: doorb
real(kind=wp), allocatable :: tmp(:)

grad(1:nprorb) = Zero
if (doorb) call onedens_cvb(civb,civb2,grad,.false.,1)
if (strucopt) then
  call ci2vbg_cvb(civb2,dvbdet)
  if (np-nprorb == nvb) then
    call vb2strg_cvb(dvbdet,grad(nprorb+1))
  else if (np-nprorb < nvb) then
    call mma_allocate(tmp,nvb,label='tmp')
    call vb2strg_cvb(dvbdet,tmp)
    vbdet(1:np-nprorb) = tmp(1:np-nprorb)
    call mma_deallocate(tmp)
  else
    write(u6,*) ' Error in mkgrd - np-nprorb > nvb :',np,nprorb,nvb
  end if
end if

return

end subroutine mkgrd_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine UpDens()

use Genano_globals, only: nSym, nBas, kSet, tDsym, pDsym, wSet, Cmo, Occ, Eps, thr, wc0, wc1, BasName
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: IndCmo, IndNme, IndOcc, iOrb, iSym
real(kind=wp) :: e, o, w

pDsym(:) = Zero
IndOcc = 1
IndCmo = 1
IndNme = 1
do iSym=1,nSym
  !write(u6,'(a,i5)') ' iSym:   ',iSym
  do iOrb=1,nBas(iSym)
    !write(u6,'(a,i5)') '   iOrb:   ',iOrb
    !write(u6,'(a,i5)') '   IndOcc: ',IndOcc
    !write(u6,'(a,i5)') '   IndCmo: ',IndCmo
    o = Occ(IndOcc)
    e = Eps(IndOcc)
    w = wc0-wc1*e
    w = max(w,One)
    !write(u6,'(a,2i3,3f12.6)') 'iSym.iOrb,o,e,w',iSym,iOrb,o,e,w
    if (abs(o) > thr) then
      call UpOrb(nBas(iSym),o,w,Cmo(IndCmo),BasName(IndNme))
    end if
    IndCmo = IndCmo+nBas(iSym)
    IndOcc = IndOcc+1
  end do
  IndNme = IndNme+nBas(iSym)
end do
!write(u6,*) '*** Partial density matrix in UpDens ***'
!iBlk = 0
!do iLqn=0,MxLqn
!  do iShell=-iLqn,iLqn
!    iBlk = iBlk+1
!    if (nPrim(iLqn) > 0) then
!      write(u6,'(a,2i5)') ' Block',iLqn,iShell
!      call Triprt(' ','(6f12.6)',pDsym(iSymBk(iBlk)),nPrim(iLqn))
!    end if
!  end do
!end do
tDsym(:) = tDsym(:)+wSet(kSet)*pDsym(:)
!write(u6,*) '*** Total density matrix in UpDens ***'
!iBlk = 0
!do iLqn=0,MxLqn
!  do iShell=-iLqn,iLqn
!    iBlk = iBlk+1
!    if (nPrim(iLqn) > 0) then
!      write(u6,'(a,2i5)') ' Block',iLqn,iShell
!      call Triprt(' ','(6f12.6)',tDsym(iSymBk(iBlk)),nPrim(iLqn))
!    end if
!  end do
!end do

return

end subroutine UpDens

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine DENSCT_CPF(C,S,W,THET,TPQ,ENP,EPP,ICASE_,FC,BUFIN,A,B,FK,DBK,TEMP)

use cpf_global, only: ICASE, INDX, JSY
use Constants, only: One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: C(*), ENP(*), FK(*)
real(kind=wp), intent(_OUT_) :: S(*), W(*), TPQ(*), EPP(*), FC(*), BUFIN(*), A(*), B(*), DBK(*), TEMP(*)
real(kind=wp), intent(in) :: THET(*)
integer(kind=iwp), intent(in) :: ICASE_(*)
real(kind=wp) :: AA

call DENS_CPF(C,FC,ICASE,AA)

! MULTIPLY C BY MP

call NPSET(JSY,INDX,C,TPQ,ENP,TEMP,S,W,EPP,ICASE_)

call ONECT(C,S,W,THET,ENP,EPP,FC,BUFIN,A,B,FK,DBK)
if (AA > One) then
  write(u6,*) 'DENSCT_CPF Error: AA>1.0 (See code.)'
end if
call NATCT(C,FC)

return

end subroutine DENSCT_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHORAS_DRV(nSym,nBas,nOcc,DSQ,DLT,FLT,
     &                      ExFac,LWFSQ,CMO)

      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Integer nBas(8), MinMem(8),rc
      Real*8 FLT(*),CMO(*)
      Real*8 DSQ(*),DLT(*)
      Parameter (MaxDs = 1)
      Logical DoCoulomb(MaxDs),DoExchange(MaxDs)
      Integer Lunit(8)
      Real*8 FactC(MaxDs),FactX(MaxDs),ExFac
      Integer ipDLT(MaxDs),ipDSQ(MaxDs),ipFLT(MaxDs),ipFSQ(MaxDs)
      Integer ipMSQ(MaxDs),ipNocc(MaxDs),nOcc(nSym)
      Integer nnBSF(8,8),n2BSF(8,8)
      Integer ALGO
      Logical REORD,DECO

      Common /CHOUNIT / Lunit
      Common /CHORAS / REORD,DECO,ALGO
*
*
C  **************************************************

      rc=0

      do i=1,8
         Lunit(i)=-1
      end do

      nDen = 1
      DoCoulomb(1)  = .true.
      DoExchange(1) = ExFac.ne.0.0d0
      FactC(1)      = 1.0D0
      FactX(1)      = 0.5D0*ExFac ! ExFac used for hybrid functionals


      ipDLT(1) = ip_of_Work(DLT(1))
      ipDSQ(1) = ip_of_Work(DSQ(1))
      ipFLT(1) = ip_of_Work(FLT(1))
      ipFSQ(1) = LWFSQ

      iUHF=0

      ipNocc(1) = ip_of_iwork(nOcc(1)) ! occup. numbers

       IF (DECO) THEN !use decomposed density
* ==============  Alternative A: Use decomposed density matrix =====
       call getmem('nVec','Allo','Inte',ipnVec,nSym)

       CALL set_nnBSF(nSym,nBas,nnBSF,n2BSF)
       lVdim=0
       do i=1,nSym
          lVdim = lVdim + n2BSF(i,i)
       end do

* Allocate vectors representing decomposed density matrix:
       CALL GETMEM('choMOs','allo','real',ipVec,lVdim)

* ------------------------------------------------------------------
       CALL GETMEM('ddec','allo','real',ipddec,lVdim)
       call dcopy_(lVdim,Work(ipDSQ(1)),1,Work(ipddec),1)
       ipd = ipddec
       ipV = ipVec
       Do i=1,nSym
* Loop over symmetries
          if(nBas(i).gt.0)then
            Ymax=0.0d0
            do ja=1,nBas(i)
               jaa=ipd-1+nBas(i)*(ja-1)+ja
               Ymax=Max(Ymax,Work(jaa))
            end do
            Thr = 1.0d-13*Ymax
* Call for decomposition:
            CALL CD_InCore(Work(ipd),nBas(i),Work(ipV),nBas(i),
     &                     NumV,Thr,rc)
            If (rc.ne.0) GOTO 999
            iwork(ipnVec+i-1) = NumV

            if ( NumV .ne. nOcc(i) ) then
               write(6,*)'Warning! The number of occupied from the dec',
     &'omposition of the density matrix is ',numV,' in symm. ',i
               write(6,*)'Expected value = ',nOcc(i)
               write(6,*)'Max diagonal of the density in symm. ',i,
     &' is equal to ',Ymax
            endif

          else
            iwork(ipnVec+i-1) = 0
          endif
          ipd = ipd + n2BSF(i,i)
          ipV = ipV + n2BSF(i,i)
* End of loop over symmetries
       End Do
       CALL GETMEM('ddec','free','real',ipddec,lVdim)
* ------------------------------------------------------------------


       ipNocc(1) = ipnVec ! occup. numbers

       ipMSQ(1) = ipVec       ! "Cholesky" MOs

* ========End of  Alternative A: Use decomposed density matrix =====
      ENDIF

      Call CHOSCF_MEM(nSym,nBas,iUHF,DoExchange,ipNocc,
     &                ALGO,REORD,MinMem,loff1)

* Here follows a long if nest with six combinations:
* ALGO is 1 ,  REORD is .true. or .false., or
* ALGO is 2,  REORD is .true. or .false., DECO is .true.or .false.
      if (ALGO.eq.1) then
        if (REORD) then
* ALGO.eq.1.and.REORD:
      Call CHO_FOCKTWO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,FactC,
     &                FactX,ipDLT,ipDSQ,ipFLT,ipFSQ,ipNocc,MinMem)
           If (rc.ne.0) GOTO 999

        else
* ALGO.eq.1.and. .not.REORD:
        CALL CHO_FOCKTWO_RED(rc,nBas,nDen,DoCoulomb,DoExchange,
     &           FactC,FactX,ipDLT,ipDSQ,ipFLT,ipFSQ,ipNocc,MinMem)
           If (rc.ne.0) GOTO 999
        end if

      elseif (ALGO.eq.2) then
        if (DECO) then !use decomposed density

          FactX(1) = 0.5D0*ExFac ! vectors are scaled by construction
          if (REORD)then
* ALGO.eq.2.and.DECO.and.REORD:
            Call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,
     &                  lOff1,FactC,FactX,ipDLT,ipDSQ,ipFLT,ipFSQ,
     &                  MinMem,ipMSQ,ipNocc)
            If (rc.ne.0) GOTO 999

          else
* ALGO.eq.2.and.DECO.and. .not.REORD:
            CALL CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,
     &                  lOff1,FactC,FactX,ipDLT,ipDSQ,ipFLT,ipFSQ,
     &                  MinMem,ipMSQ,ipNocc)
            If (rc.ne.0) GOTO 999
          endif


        else
          if (REORD) then
* ALGO.eq.2.and. ..not.DECO.and.REORD:
            ipMSQ(1) = ip_of_work(CMO(1))
            FactX(1) = 1.0D0*ExFac ! because MOs coeff. are not scaled
            Call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,
     &                lOff1,FactC,FactX,ipDLT,ipDSQ,ipFLT,ipFSQ,
     &                MinMem,ipMSQ,ipNocc)
            if (rc.ne.0) GOTO 999
          else
* ALGO.eq.2.and. ..not.DECO.and.REORD:
            ipMSQ(1) = ip_of_work(CMO(1))
            FactX(1) = 1.0D0*ExFac ! because MOs coeff. are not scaled
            CALL CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,
     &                lOff1,FactC,FactX,ipDLT,ipDSQ,ipFLT,ipFSQ,
     &                MinMem,ipMSQ,ipNocc)
            if (rc.ne.0) GOTO 999
          end if
        end if

      else
        rc=99
        write(6,*)'Illegal Input. Specified Cholesky Algorithm= ',ALGO
        CALL QUIT(rc)
      endif

      CALL CHO_SUM(rc,nSym,nBas,iUHF,DoExchange,ipFLT,ipFSQ)

 999    continue
      if (rc.ne.0) then
         write(6,*)'CHORAS_DRV. Non-zero return code. rc= ',rc
         CALL QUIT(rc)
      end if

      IF (DECO) Then
       CALL GETMEM('choMOs','free','real',ipVec,lVdim)
       call getmem('nVec','Free','Inte',ipnVec,nSym)
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkV_A4 (Vp,V,dimb,dima,no,dimij)
c
c       this routine do:
c       Vp(a,b,ij) <- (ai|bj) from V(b,j,a,i)
c
        implicit none
        integer dima,dimb,no,dimij
        real*8 Vp(1:dima,1:dimb,1:dimij)
        real*8 V(1:dimb,1:no,1:dima,1:no)
c
c       help variables
        integer i,j,ij,a,b
c
        ij=0
        do i=1,no
        do j=1,i
          ij=ij+1
          do b=1,dimb
          do a=1,dima
            Vp(a,b,ij)=V(b,j,a,i)
          end do
          end do
        end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fokunpck1(fok,dp,dimfok)
! this routine does Fok = Fok - dp
! fok    - Fok matrix (I/O)
! dp     - Diagonal part vector (I)
! dimfok - dimension for Fok matrix - norb (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimfok
real(kind=wp), intent(inout) :: fok(dimfok,dimfok)
real(kind=wp), intent(in) :: dp(dimfok)
integer(kind=iwp) :: p

!1 subtract dp from Fok
do p=1,dimfok
  fok(p,p) = fok(p,p)-dp(p)
end do

return

end subroutine fokunpck1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************
      SubRoutine ChoMP2g_TraVec(VecAO,VecMO,COrb1,COrb2,Scr,lScr,
     &                         iSyCho,iSyCO,iSyCV,iLoc,
     &                         iMoType1,iMoType2)
C
C     Jonas Bostrom, Feb 2010
C
C     Purpose: compute pq-vector from reduced set AO vector.
C
      use ChoArr, only: iRS2F
      use ChoSwp, only: IndRed
#include "implicit.fh"
      Real*8 VecAO(*), VecMO(*), COrb1(*), COrb2(*)
      Real*8 Scr(lScr)
#include "cholesky.fh"
#include "choorb.fh"
#include "chomp2.fh"
#include "chomp2g.fh"

      Character*13 SecNam
      Parameter (SecNam = 'ChoMP2_TraVec')

      Real*8 Fac(0:1)
      Data Fac /0.5D0,1.0D0/

      MulD2h(i,j)=iEor(i-1,j-1)+1

*     Check what type of Cholesky vector to make (fro-occ, occ-occ.....)
      iVecType = iMoType2 + (iMoType1-1)*nMoType

      If (iLoc.lt.2 .or. iLoc.gt.3) Then
         Write(6,*) SecNam,': illegal iLoc = ',iLoc
         Call ChoMP2_Quit(SecNam,'iLoc out of bounds!',' ')
      End If
      iSyScr = MulD2h(iSyCho,iSyCO)
      If (lScr .lt. nMoAo(iSyScr,iMoType1)) Then
         Write(6,*) SecNam,': insufficient scratch space lScr = ',lScr
         Write(6,*) SecNam,': needed                          = ',
     &              nMoAo(iSyScr,iMoType1)
         Call ChoMP2_Quit(SecNam,'Insufficient scratch space',' ')
      Else
         Call FZero(Scr,nMoAo(iSyScr,iMoType1))
      End If

C     First half-transformation step:
C     Scr(i,alpha) = sum_beta VecAO(alpha,beta)*COrb1(i,beta)
C     ------------------------------------------------------

      If (iSyCho .eq. 1) Then

         Do iAlBe = 1,nnBstR(iSyCho,iLoc)

            jAlBe  = IndRed(iiBstR(iSyCho,iLoc)+iAlBe,iLoc)
            iAlpha = iRS2F(1,jAlBe)
            iBeta  = iRS2F(2,jAlBe)

            iSymAl = 1
            Do iSym = nSym,2,-1
               If (iAlpha .gt. iBas(iSym)) Then
                  iSymAl = iSym
                  Go To 998
               End If
            End Do
  998       iSymBe = iSymAl
            iSymP  = MulD2h(iSymBe,iSyCO)

            jAlpha = iAlpha - iBas(iSymAl)
            jBeta  = iBeta  - iBas(iSymBe)

            AOVal  = Fac(min(abs(iAlpha-iBeta),1))*VecAO(iAlBe)
            kOffAl = iMoAo(iSymP,iSymAl,iMoType1) +  nMo(iSymP,iMoType1)
     &                                       * (jAlpha - 1)
            kOffBe = iMoAo(iSymP,iSymBe,iMoType1) + nMo(iSymP,iMoType1)
     &                                       * (jBeta  - 1)
            Do i = 1,nMo(iSymP,iMoType1)
               Scr(kOffAl+i) = Scr(kOffAl+i) + AOVal*COrb1(kOffBe+i)
               Scr(kOffBe+i) = Scr(kOffBe+i) + AOVal*COrb1(kOffAl+i)
            End Do

         End Do

      Else

         Do iAlBe = 1,nnBstR(iSyCho,iLoc)

            jAlBe  = IndRed(iiBstR(iSyCho,iLoc)+iAlBe,iLoc)
            iAlpha = iRS2F(1,jAlBe)
            iBeta  = iRS2F(2,jAlBe)

            iSymAl = 1
            Do iSym = nSym,2,-1
               If (iAlpha .gt. iBas(iSym)) Then
                  iSymAl = iSym
                  Go To 999
               End If
            End Do
  999       iSymBe = MulD2h(iSymAl,iSyCho)

            jAlpha = iAlpha - iBas(iSymAl)
            jBeta  = iBeta  - iBas(iSymBe)

            AOVal  = VecAO(iAlBe)

            iSymP  = MulD2h(iSymBe,iSyCO)
            kOffAl = iMoAo(iSymP,iSymAl,iMoType1)
     &             + nMo(iSymP,iMoType1)*(jAlpha - 1)
            kOffBe = iMoAo(iSymP,iSymBe,iMoType1)
     &             + nMo(iSymP,iMoType1)*(jBeta  - 1)
            Do i = 1,nMo(iSymP,iMoType1)
               Scr(kOffAl+i) = Scr(kOffAl+i) + AOVal*COrb1(kOffBe+i)
            End Do

            iSymP  = MulD2h(iSymAl,iSyCO)
            kOffAl = iMoAo(iSymP,iSymAl,iMoType1)
     &             + nMo(iSymP,iMoType1)*(jAlpha - 1)
            kOffBe = iMoAo(iSymP,iSymBe,iMoType1)
     &             + nMo(iSymP,iMoType1)*(jBeta  - 1)
            Do i = 1,nMo(iSymP,iMoType1)
               Scr(kOffBe+i) = Scr(kOffBe+i) + AOVal*COrb1(kOffAl+i)
            End Do

         End Do

      End If

C     Second half-transformation step:
C     VecMO(q,p) = sum_alpha COrb2(alpha,q)*Scr(p,alpha)
C     -------------------------------------------------

      Do iSymp = 1,nSym

         iSymq  = MulD2h(iSymp,iSyCho)
         iSymAl = MulD2h(iSymq,iSyCV)

         nTotAl = nBas(iSymAl)
         nTotq  = nMo(iSymq,iMoType2)
         nTotp  = nMo(iSymp,iMoType1)

         If (nTotp.gt.0 .and. nTotq.gt.0 .and. nTotAl.gt.0) Then
            kOff1 = iAoMo(iSymAl,iSymq,iMoType2) + 1
            kOff2 = iMoAo(iSymp,iSymAl,iMoType1) + 1
            kOff3 = iMoMo(iSymq,iSymp,iVecType)   + 1
            Call DGEMM_('T','T',nMo(iSymq,iMoType2),nMo(iSymp,iMoType1),
     &                 nBas(iSymAl),1.0D0,COrb2(kOff1),nTotAl,
     &                 Scr(kOff2),nTotp,0.0D0,VecMO(kOff3),nTotq)
         End If

      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

subroutine GETSTRN_GASSM_SPGP(ISMFGS,ITPFGS,ISTROC,NSTR,NEL,NNSTSGP,IISTSGP)
! Obtain all superstrings containing  strings of given sym and type
!
! (Superstring :contains electrons belonging to all gasspaces
!       string :contains electrons belonging to a given GAS space
!  A super string is thus a product of NGAS strings)
!
! Jeppe Olsen, Summer of 95
!              Optimized version, october 1995
!
! In this subroutine the ordering of strings belonging to a given type
! is defined !!
! Currently we are using the order
! Loop over GAS 1 strings
!  Loop over GAS 2 strings
!   Loop over GAS 3 strings --
!     Loop over gas N strings

use lucia_data, only: MXPNGAS, MXPNSMST, NELFGP, NGAS, OCCSTR
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ISMFGS(*), ITPFGS(*), NEL, NNSTSGP(MXPNSMST,*), IISTSGP(MXPNSMST,*)
integer(kind=iwp), intent(inout) :: ISTROC(NEL,*)
integer(kind=iwp), intent(out) :: NSTR
integer(kind=iwp) :: IBSTFGS(MXPNGAS), IGAS, IGASL, NELB, NELI, NSTA, NSTB, NSTFGS(MXPNGAS), NSTI, NSTRTOT

! Number of strings per GAS space
!write(u6,*) ' entering problem child'
do IGAS=1,NGAS
  NSTFGS(IGAS) = NNSTSGP(ISMFGS(IGAS),IGAS)
  IBSTFGS(IGAS) = IISTSGP(ISMFGS(IGAS),IGAS)
end do

#ifdef _DEBUGPRINT_
write(u6,*) '  GETSTR_GASSM_SPGP speaking'
write(u6,*) '  =========================='
write(u6,*) ' ISMFGS,ITPFGS (input)'
call IWRTMA(ISMFGS,1,NGAS,1,NGAS)
call IWRTMA(ITPFGS,1,NGAS,1,NGAS)
write(u6,*)
write(u6,*) ' NSTFGS, IBSTFGS (intermediate results)'
call IWRTMA(NSTFGS,1,NGAS,1,NGAS)
call IWRTMA(IBSTFGS,1,NGAS,1,NGAS)
#endif
! Last gasspace with a nonvanishing number of electrons
IGASL = 0
do IGAS=1,NGAS
  if (NELFGP(ITPFGS(IGAS)) /= 0) IGASL = IGAS
end do

NSTRTOT = product(NSTFGS(1:NGAS))

if ((IGASL /= 0) .and. (NSTRTOT /= 0)) then
  ! Loop over GAS spaces
  NELB = 0
  do IGAS=1,IGASL
    ! Number of electrons in GAS = 1, IGAS - 1
    if (IGAS > 1) NELB = NELB+NELFGP(ITPFGS(IGAS-1))
    ! Number of electron in IGAS
    NELI = NELFGP(ITPFGS(IGAS))
    if (NELI > 0) then

      ! The order of strings corresponds to a matrix A(I(after),Igas,I(before))
      ! where I(after) loops over strings in IGAS+1 - IGASL and
      ! I(before) loop over strings in 1 - IGAS -1
      NSTA = product(NSTFGS(IGAS+1:IGASL))

      NSTB = product(NSTFGS(1:IGAS-1))

      NSTI = NSTFGS(IGAS)

#     ifdef _DEBUGPRINT_
      write(u6,*) ' NSTI,NSTB,NSTA,NELB,NELI,NEL ',NSTI,NSTB,NSTA,NELB,NELI,NEL
      write(u6,*) ' IBSTFGS(IGAS)',IBSTFGS(IGAS)
#     endif

      call ADD_STR_GROUP(NSTI,IBSTFGS(IGAS),OCCSTR(ITPFGS(IGAS))%A,NSTB,NSTA,ISTROC,NELB+1,NELI,NEL)

      ! Loop over strings in IGAS
    end if
  end do
end if
NSTR = NSTRTOT

#ifdef _DEBUGPRINT_
write(u6,*) ' Info from  GETSTR_GASSM_SPGP'
write(u6,*) ' ============================'
write(u6,*)
write(u6,*) ' Symmetry and type strings :'
write(u6,*)
write(u6,*) '   AS    Sym  Type'
write(u6,*) ' ================='
do IGAS=1,NGAS
  write(u6,'(3I6)') IGAS,ISMFGS(IGAS),ITPFGS(IGAS)
end do
write(u6,*)
write(u6,*) ' Number of strings generated : ',NSTR
write(u6,*) ' Strings generated'
call PRTSTR(ISTROC,NEL,NSTR)
#endif

end subroutine GETSTRN_GASSM_SPGP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      CHARACTER(LEN=8) FUNCTION ORBNAM(ISORB,ORBTAB)
      IMPLICIT NONE
      Integer ISORB, ORBTAB(*)
      CHARACTER(LEN=8) STRING8
      CHARACTER(LEN=2) ORBTYP
      INTEGER IPART,ISMLAB,ISOIND,NPART
      INTEGER KOINFO
      NPART= ORBTAB(6)
      KOINFO=19
      ISMLAB= ORBTAB(KOINFO+ 1+(ISORB-1)*8)
      IPART=  ORBTAB(KOINFO+ 4+(ISORB-1)*8)
      ISOIND= ORBTAB(KOINFO+ 2+(ISORB-1)*8)
      ORBTYP='De'
      IF(IPART.EQ.NPART-1) ORBTYP='Fr'
      IF(IPART.EQ.NPART-2) ORBTYP='Se'
      IF(IPART.EQ.NPART-3) ORBTYP='In'
      IF(IPART.LE.NPART-4) ORBTYP='Ac'
      WRITE(STRING8,'(A2,I1,A1,I3.3,1X)')ORBTYP,ISMLAB,':',ISOIND
      ORBNAM=STRING8

      END FUNCTION ORBNAM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine GetOvlp_Localisation(S,Storage,nBas,nSym)
C
C     Thomas Bondo Pedersen, Dec. 2005.
C
C     Purpose: read the overlap matrix and return in S in lower
C              triangular storage if Storage="Tri" else in full square
C              storage.
C
      Implicit None
      Real*8      S(*)
      Character*3 Storage
      Integer     nSym
      Integer     nBas(nSym)
#include "WrkSpc.fh"

      Character*20 SecNam
      Parameter (SecNam = 'GetOvlp_Localisation')
      Logical Debug
      Parameter (Debug = .False.)

      Character*3 myStorage
      Character*8 Label
      Integer     irc, iOpt, iComp, iSyLbl
      Integer     iSym, l_Scr, ip_Scr, kTri, kSq, l_Tri

      l_Tri = nBas(1)*(nBas(1)+1)/2
      Do iSym = 2,nSym
         l_Tri = l_Tri + nBas(iSym)*(nBas(iSym)+1)/2
      End Do
      l_Scr = l_Tri + 4
      Call GetMem('OvlpScr','Allo','Real',ip_Scr,l_Scr)

      irc    = -1
      iOpt   = 2
      iComp  = 1
      iSyLbl = 1
      Label  = 'Mltpl  0'
      Call RdOne(irc,iOpt,Label,iComp,Work(ip_Scr),iSyLbl)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': RdOne returned ',irc
         Write(6,*) 'Label = ',Label,'  iSyLbl = ',iSyLbl
         Call SysAbendMsg(SecNam,'I/O error in RdOne',' ')
      End If

      myStorage = Storage
      Call UpCase(myStorage)
      If (myStorage .eq. 'TRI') Then
         Call dCopy_(l_Tri,Work(ip_Scr),1,S,1)
      Else
         kTri = ip_Scr
         kSq  = 1
         Do iSym = 1,nSym
            Call Tri2Rec(Work(kTri),S(kSq),nBas(iSym),Debug)
            kTri = kTri + nBas(iSym)*(nBas(iSym)+1)/2
            kSq  = kSq  + nBas(iSym)**2
         End Do
      End If

      Call GetMem('OvlpScr','Free','Real',ip_Scr,l_Scr)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Kamal Sharkas                                    *
!               2019, Thomas J. Duignan                                *
!               2021, Rulin Feng                                       *
!               2026, Dong Q. Le                                       *
!***********************************************************************
!
! Note: The hyperfine code is based on the analogous
! pre-existing G-tensor functionality

module hfcop

#ifdef _HDF5_
use mh5, only: mh5_put_dset
use RASSIWfn, only: wfn_h_hfc_rms
#endif
use Molcas, only: LenIn
use spin_data, only: free_spin_data, get_first_nonzero_GNUC, GNUC_by_nucspin, GNUC_NUCSPIN_by_nucmass, init_spin_data, &
                     NUCSPIN_by_gnuc
use Cntrl, only: AngMom_idx, ASD_idx, Atens_Req, AutoSelect_GFac, DEGEN_ETHR, GNuc, GNuc_set, HypF_rms_Req, HypoIso, LCSTATES, &
                 MLTPLT, NATens_Calc, NAtoms, NCOUP, NMass_set, NPNMR_Calc, NPROP, NSpin_set, NSTATE, NTP, NucMass, NucSpin, &
                 pNMR_req, PSO_idx, TMAXP, TMINP
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Twelve, Half, cZero, auTocm, auToHz, auTokJ, c_in_au, gElectron, kBoltzmann, &
                     proton_mass_in_au
use Definitions, only: iwp, wp, u6

implicit none
private

! RASSI runtime variables
! NSS, ESO

! EPR Calc. :: A tensor, principal and isotropic values
! Atens_fac, prin_vals, signs_resolved

! PNMR Calc :: Shielding tensor, Chemical Shift
! Temp_in_K, pBoltz, Z_HFC_int_oper, Curie_ChemShift, LinRes_ChemShift, LR_tens, C_tens, Z_HFC_over_dE, dE_inv, degen_group,
! n_uniq_ener

! State information and Wigner-Eckart theorem
! MAPST, ETHR_in_cm, CGO_mat, CGx_mat, CGy_mat

! Hamiltonian
! h_FC, h_SD, h_FCSD, h_PSO, h_TOT, USO, h_Zeeman, h_rms_nuc, h_hfc_rms

! Iterators and indices
! iACalc, ipNMR_Calc, degen_start_idx, degen_end_idx, xyz, contrib_lab

! Isotopes and electronic structure
! e_spin, LAtNumb, LAtomLbl, LStability

! Routing variables
! do_calc, do_EPR, do_pNMR

integer(kind=iwp) :: iACalc, ipNMR_Calc, n_uniq_ener, NSS
real(kind=wp) :: Atens_fac, e_spin, ETHR_in_cm
logical(kind=iwp) :: do_calc, do_EPR, do_pNMR
integer(kind=iwp), allocatable :: degen_end_idx(:), degen_group(:), degen_start_idx(:), LAtNumb(:), MAPST(:)
real(kind=wp), allocatable :: C_tens(:,:,:), CGo_mat(:,:), CGx_mat(:,:), CGy_mat(:,:), Curie_ChemShift(:,:,:), dE_inv(:,:), &
                              ESO(:), h_hfc_rms(:,:), h_rms_nuc(:,:), LinRes_ChemShift(:,:,:), LR_tens(:,:,:), pBoltz(:,:), &
                              prin_vals(:,:,:), Temp_in_K(:), Z_HFC_int_oper(:,:,:,:), Z_HFC_over_dE(:,:,:,:)
complex(kind=wp), allocatable :: h_FC(:,:,:), h_FCSD(:,:,:), h_PSO(:,:,:), h_SD(:,:,:), h_TOT(:,:,:), h_Zeeman(:,:,:), USO(:,:)
logical(kind=iwp), allocatable :: signs_resolved(:)
character(len=LenIn), allocatable :: LAtomLbl(:)
character, allocatable :: LStability(:)

! Conversion factors
real(kind=wp), parameter :: alpha2 = One/(c_in_au*c_in_au), au2J = auTokJ*1.0e3_wp, beta_e = One/(Two*c_in_au), &
                            beta_n = beta_e/proton_mass_in_au, con_to_MHz = -gElectron*beta_e*beta_n*auToHz*1.0e-6_wp, &
                            kBoltzman_in_cm = kBoltzmann*auTocm/au2J, to_ppm = 1.0e6_wp*auTocm*alpha2, TwoThird = Two/Three
character(len=*), parameter :: contrib_lab(5) = [character(len=7) :: '[TOTAL]','[FC]', '[SD]','[FCSD]','[PSO]']
character, parameter :: xyz(3) = ['x','y','z']

public :: Hyperfine_Oper

contains

subroutine Hyperfine_Oper(PROP,USOR,USOI,JBNUM)

  real(kind=wp), intent(in) :: PROP(NSTATE,NSTATE,NPROP), USOR(:,:), USOI(:,:)
  integer(kind=iwp), intent(in) :: JBNUM(NSTATE)
  integer(kind=iwp) :: iAtom

  ! Setup reused variables------------------------------
  call setup_hfc_calc(JBNUM,USOR,USOI)
  if (allocated(pNMR_req)) call setup_pNMR_calc(PROP)
  !----------------------------------------------------

  ! do_calc :: calculate Hyperfine hamiltonian
  ! do_EPR  :: calculate A tensor, principal values for EPR spectroscopy
  ! do_pNMR :: calculate paramagnetic NMR chemical shift [Curie and Linear Response]
  ! Calculation begins----------------------------------
  iACalc = 0
  ipNMR_Calc = 0
  do iAtom=1,NAtoms
    call route_calc(iAtom)
    if (do_calc) call calc_h_HFC(iAtom,PROP)
    if (HypF_rms_Req) call update_h_HFC_RMS(iAtom,h_TOT)
  end do

  ! Printing final results------------------------------
  if (HypF_rms_Req) call save_h_rms()
  if (allocated(Atens_Req)) call print_EPR_summary()
  if (allocated(pNMR_req)) call print_pNMR_summary()

  call cleanup_hfcop()

end subroutine Hyperfine_Oper

subroutine setup_hfc_calc(JBNUM,USOR,USOI)

  use wigner_util, only: dclebs

  integer(kind=iwp), intent(in) :: JBNUM(NSTATE)
  real(kind=wp), intent(in) :: USOR(:,:), USOI(:,:)
  integer(kind=iwp) :: ISS, ISTATE, JOB, JSS, MPLET, MSPROJ
  real(kind=wp) :: CGm, CGp, FACT, MPLET1, MPLET2, MSPROJ1, MSPROJ2, S1, S2, SM1, SM2
  integer(kind=iwp), allocatable :: MAPMS(:), MAPSP(:)
  real(kind=wp), allocatable :: rtemp(:)

  ! Form transformation matrix USO with complex numbers
  NSS = size(USOR,1)
  call mma_allocate(USO,NSS,NSS,Label='USO')
  USO(:,:) = cmplx(USOR(:,:),USOI(:,:),kind=wp)

  call mma_allocate(h_FC,3,NSS,NSS,Label='h_FC')
  call mma_allocate(h_SD,3,NSS,NSS,Label='h_SD')
  call mma_allocate(h_FCSD,3,NSS,NSS,Label='h_FCSD')
  call mma_allocate(h_PSO,3,NSS,NSS,Label='h_PSO')
  call mma_allocate(h_TOT,3,NSS,NSS,Label='h_TOT')

  if (HypF_rms_Req) then
    call mma_allocate(h_hfc_rms,NSS,NSS,Label='h_hfc_rms')
    call mma_allocate(h_rms_nuc,NSS,NSS,Label='h_rms_nuc')
    ! IMPORTANT: h_hfc_rms must be initialized to zero, as it is updated via addition within the loop.
    !            h_rms_nuc will be re-assigned later, therefore it does not need to be initialized
    h_hfc_rms(:,:) = Zero
  end if

  if (allocated(Atens_Req)) then
    call mma_allocate(prin_vals,NATens_Calc,5,3,Label='prin_vals')
    call mma_allocate(signs_resolved,NATens_Calc,Label='signs_resolved')
    signs_resolved(:) = .false.
  end if

  ! GET: AtomLbl
  call mma_allocate(LAtomLbl,LenIn*nAtoms,Label='LAtNumb')
  call Get_cArray('Unique Atom Names',LAtomLbl,LenIn*nAtoms)

  ! GET: AtNumb(Z)
  call mma_allocate(rtemp,NAtoms,Label='rtemp_hfcop')
  call mma_allocate(LAtNumb,NAtoms,Label='LAtNumb')
  call Get_dArray('Nuclear charge',rtemp,nAtoms)
  LAtNumb(:) = nint(rtemp(:))
  call mma_deallocate(rtemp)

  ! GET: Energy of SO states (ESO)
  call mma_allocate(ESO,NSS,Label='ESO')
  call get_dArray('ESO_SINGLE',ESO,NSS)

  ! MAP: from spin-free and to spin states:
  call mma_allocate(MAPST,NSS,Label='MAPST')
  call mma_allocate(MAPSP,NSS,Label='MAPSP')
  call mma_allocate(MAPMS,NSS,Label='MAPMS')

  ISS = 0
  do ISTATE=1,NSTATE
    JOB = JBNUM(ISTATE)
    MPLET = MLTPLT(JOB)
    do MSPROJ=-MPLET+1,MPLET-1,2
      ISS = ISS+1
      MAPST(ISS) = ISTATE
      MAPSP(ISS) = MPLET
      MAPMS(ISS) = MSPROJ
    end do
  end do

  ! CALC: Clebsch-Gordan coefficients. Store CGo, CGx, CGy to matrices
  call mma_allocate(CGo_mat,NSS,NSS,Label='CGo')
  call mma_allocate(CGx_mat,NSS,NSS,Label='CGx')
  call mma_allocate(CGy_mat,NSS,NSS,Label='CGy')

  ! Wigner-Eckart theorem
  do ISS=1,NSS

    MPLET1 = MAPSP(ISS)
    MSPROJ1 = MAPMS(ISS)
    S1 = Half*real(MPLET1-1,kind=wp)
    SM1 = Half*real(MSPROJ1,kind=wp)
    do JSS=1,NSS

      MPLET2 = MAPSP(JSS)
      MSPROJ2 = MAPMS(JSS)
      S2 = Half*real(MPLET2-1,kind=wp)
      SM2 = Half*real(MSPROJ2,kind=wp)
      FACT = One/sqrt(real(MPLET1,kind=wp))
      if (MPLET1 == MPLET2-2) FACT = -FACT
      CGM = FACT*DCLEBS(S2,One,S1,SM2,-One,SM1)
      CGo_mat(ISS,JSS) = FACT*DCLEBS(S2,One,S1,SM2,Zero,SM1)
      CGP = FACT*DCLEBS(S2,One,S1,SM2,One,SM1)
      CGx_mat(ISS,JSS) = sqrt(Half)*(CGm-CGp)
      CGy_mat(ISS,JSS) = sqrt(Half)*(CGm+CGp)
    end do
  end do
  ! MAPSP and MAPMS are not needed anymore, but MAPST is required to compute h_HFC
  call mma_deallocate(MAPSP)
  call mma_deallocate(MAPMS)

  ! Process spin data (Nuclear spin + g-Factor)
  if (HypF_rms_Req .or. allocated(Atens_Req)) then
    call proc_spin_data()
    call print_isotope_info()
  end if

  ! GET: Coupled states used to calculate A_tensors and/or pNMR tensors
  ETHR_in_cm = DEGEN_ETHR*auTocm
  if (allocated(Atens_Req) .or. allocated(pNMR_req)) call proc_coupl_states()

end subroutine setup_hfc_calc

subroutine setup_pNMR_calc(PROP)

  real(kind=wp), intent(in) :: PROP(NSTATE,NSTATE,NPROP)
  integer(kind=iwp) :: ISS, iT, JSS, lmb
  real(kind=wp) :: dlt_E, dlt_T, Zstat
  real(kind=wp), parameter :: dltE_cutoff = 1.0e-6_wp, pBoltz_cutoff = 1.0e-100_wp

  call mma_allocate(Curie_ChemShift,NPNMR_Calc,4,NTP,Label='Curie_ChemShift')
  call mma_allocate(LinRes_ChemShift,NPNMR_Calc,4,NTP,Label='LinRes_ChemShift')

  ! Initialize temperature grid
  call mma_allocate(Temp_in_K,NTP,Label='Temp_in_K')
  dlt_T = (TMAXP-TMINP)/(real(NTP-1,kind=wp))
  if (TMINP == Zero) then
    write(u6,*) 'WARNING: TMINP is set to zero. Adjusting TMINP to 0.1K to avoid numerical issues.'
    Temp_in_K(1) = 0.1_wp
  else
    Temp_in_K(1) = TMINP
  end if
  do iT=2,NTP-1
    Temp_in_K(iT) = TMINP+dlt_T*real(iT-1,kind=wp)
  end do
  Temp_in_K(NTP) = TMAXP

  ! Initialize Boltzmann factors
  call mma_allocate(pBoltz,NTP,NSS,Label='p_Boltz')
  do iT=1,NTP
    pBoltz(iT,:) = exp(-ESO(:)/kBoltzman_in_cm/Temp_in_K(iT))
    ! Truncate :: Prevent overflow/underflow when excited states have very high energies
    where(pBoltz(iT,:) < pBoltz_cutoff) pBoltz(iT,:) = Zero
    Zstat = sum(pBoltz(iT,:))
    pBoltz(iT,:) = pBoltz(iT,:)/Zstat
  end do

  ! Calc 1/dE
  call mma_allocate(dE_inv,NSS,NSS,Label='dE_inv')
  dE_inv = Zero
  do ISS=1,NSS
    do JSS=ISS,NSS
      dlt_E = ESO(ISS)-ESO(JSS)
      ! Truncate :: Prevent dividing by small numbers
      if (abs(dlt_E) > dltE_cutoff) dE_inv(ISS,JSS) = -One/dlt_E
    end do
  end do

  call mma_allocate(LR_tens,NTP,3,3,Label='LR_tens')
  call mma_allocate(C_tens,NTP,3,3,Label='C_tens')
  call mma_allocate(Z_HFC_over_dE,3,3,NSS,NSS,Label='Z_HFC_over_dE')
  call mma_allocate(Z_HFC_int_oper,3,3,NSS,NSS,Label='Z_HFC_int_oper')

  ! GROUPING DEGENERATE STATES--------------------------------------
  ! This is only needed for pNMR calculations (to include degenerate excited states).
  ! For EPR (A_tensor), we only take degenerate ground states.
  ! Therefore, it does not appear in setup_hfc_calc subroutine
  call mma_allocate(degen_group,NSS,Label='degen_group')
  n_uniq_ener = size(degen_start_idx)
  do lmb=1,n_uniq_ener
    degen_group(degen_start_idx(lmb):degen_end_idx(lmb)) = lmb
  end do

  call calc_h_Zeeman(PROP)

end subroutine setup_pNMR_calc

subroutine calc_h_HFC(iAtom,PROP)

  integer(kind=iwp), intent(in) :: iAtom
  real(kind=wp), intent(in) :: PROP(NSTATE,NSTATE,NPROP)
  integer(kind=iwp) :: idx(6), ISS, iState, JSS, jState
  real(kind=wp) :: A_tens(3,3)
  real(kind=wp), allocatable :: ASD(:,:,:)

  idx(:) = ASD_idx(iAtom,:)
  call mma_allocate(ASD,6,NSS,NSS,Label='ASD')
  do ISS=1,NSS
    iState = MAPST(ISS)
    do JSS=ISS,NSS
      jState = MAPST(JSS)
      ASD(:,ISS,JSS) = PROP(iState,jState,idx(:))
      ASD(:,JSS,ISS) = ASD(:,ISS,JSS)
    end do
  end do

  if (do_EPR .or. do_pNMR) then
    write(u6,*)
    write(u6,'(3X,A30)') repeat('=',30)
    if (do_EPR .and. do_pNMR) write(u6,'(3X,A24,A6)') 'HFC & pNMR Calc. for :: ',LAtomLbl(iAtom)
    if (do_EPR .and. .not. do_pNMR) write(u6,'(6X,A17,A6)') 'HFC Calc. for :: ',LAtomLbl(iAtom)
    if (.not. do_EPR .and. do_pNMR) write(u6,'(6X,A18,A6)') 'pNMR Calc. for :: ',LAtomLbl(iAtom)
    write(u6,'(3X,A30)') repeat('=',30)
  end if

  ! NOTE: While it is possible to make the code concise by enclosing if(do_EPR) or do_pNMR
  !    for different contributions FC, SD,... it has been made by design that
  !    the code always prints partial output A_tensor or principal values
  !    in case of abnormal termination. Most users need A_tens and prinval more
  !    than hamiltonian.
  !-----------------------------------
  call calc_h_FC(ASD(6,:,:))
  if (do_EPR) then
    call calc_A_tens(A_tens,h_FC)
    call calc_prin_val(iAtom,A_tens,1)
  end if
  if (do_pNMR) call calc_pNMR_Tensor(iAtom,h_FC,1)
  !-----------------------------------
  call calc_h_SD(ASD)
  if (do_EPR) then
    call calc_A_tens(A_tens,h_SD)
    call calc_prin_val(iAtom,A_tens,2)
  end if
  if (do_pNMR) call calc_pNMR_Tensor(iAtom,h_SD,2)
  !-----------------------------------
  h_FCSD(:,:,:) = h_FC(:,:,:)+h_SD(:,:,:)
  if (do_EPR) then
    call calc_A_tens(A_tens,h_FCSD)
    call calc_prin_val(iAtom,A_tens,3)
  end if
  ! Skip do_pNMR for FCSD (just a sum)
  !-----------------------------------
  call calc_h_PSO(iAtom,PROP)
  if (do_EPR) then
    call calc_A_tens(A_tens,h_PSO)
    call calc_prin_val(iAtom,A_tens,4)
  end if
  if (do_pNMR) call calc_pNMR_Tensor(iAtom,h_PSO,3)
  !-----------------------------------
  h_TOT(:,:,:) = h_FCSD(:,:,:)+h_PSO(:,:,:)
  if (do_EPR) then
    call calc_A_tens(A_tens,h_TOT)
    call calc_prin_val(iAtom,A_tens,5)
  end if
  if (do_pNMR) call calc_pNMR_Tensor(iAtom,h_TOT,4)

  call mma_deallocate(ASD)

end subroutine calc_h_HFC

subroutine calc_h_FC(ASD_zz)

  real(kind=wp), intent(in) :: ASD_zz(NSS,NSS)

  h_FC(1,:,:) = cmplx(CGx_mat(:,:)*ASD_zz(:,:),Zero,kind=wp)
  h_FC(2,:,:) = cmplx(Zero,CGy_mat(:,:)*ASD_zz(:,:),kind=wp)
  h_FC(3,:,:) = cmplx(CGo_mat(:,:)*ASD_zz(:,:),Zero,kind=wp)
  h_FC(:,:,:) = TwoThird*h_FC(:,:,:)

  call to_cmpl_SO_states(h_FC)

end subroutine calc_h_FC

subroutine calc_h_SD(ASD)

  real(kind=wp), intent(out) :: ASD(6,NSS,NSS)

  ASD(:,:,:) = -ASD(:,:,:)
  ASD(6,:,:) = -ASD(1,:,:)-ASD(4,:,:)

  h_SD(1,:,:) = cmplx(CGx_mat(:,:)*ASD(1,:,:)+CGo_mat(:,:)*ASD(3,:,:),CGy_mat(:,:)*ASD(2,:,:),kind=wp)
  h_SD(2,:,:) = cmplx(CGx_mat(:,:)*ASD(2,:,:)+CGo_mat(:,:)*ASD(5,:,:),CGy_mat(:,:)*ASD(4,:,:),kind=wp)
  h_SD(3,:,:) = cmplx(CGx_mat(:,:)*ASD(3,:,:)+CGo_mat(:,:)*ASD(6,:,:),CGy_mat(:,:)*ASD(5,:,:),kind=wp)

  call to_cmpl_SO_states(h_SD)

end subroutine calc_h_SD

subroutine proc_nuc_spin(iAtom,icase)

  integer(kind=iwp), intent(in) :: iAtom, icase

  write(u6,'(7X,A18,A6)') 'Process for atom: ',LAtomLbl(iAtom)
  select case (icase)
    case (1)
      write(u6,'(11X,A38)') 'USE: Isotopic mass [SEWARD or GATEWAY]'
      call GNUC_NUCSPIN_by_nucmass(LAtNumb(iAtom),NucMass(iAtom),GNuc(iAtom),NucSpin(iAtom),LStability(iAtom))
    case (2)
      write(u6,'(11X,A31,I0)') 'USE: NMASs [RASSI input]   A = ',NucMass(iAtom)
      call GNUC_NUCSPIN_by_nucmass(LAtNumb(iAtom),NucMass(iAtom),GNuc(iAtom),NucSpin(iAtom),LStability(iAtom))
    case (3)
      write(u6,'(11X,A31,F3.1)') 'USE: NSPIn [RASSI input]   I = ',NucSpin(iAtom)
      call GNUC_by_nucspin(LAtNumb(iAtom),NucMass(iAtom),GNuc(iAtom),NucSpin(iAtom),LStability(iAtom))
    case (4)
      write(u6,'(11X,A37,F12.8)') 'USE: GNUC [RASSI input]   g-factor = ',GNuc(iAtom)
      call NUCSPIN_by_gnuc(LAtNumb(iAtom),NucMass(iAtom),GNuc(iAtom),NucSpin(iAtom),LStability(iAtom))
    case (5)
      write(u6,'(11X,A37)') 'USE: Most abundance non-zero g-factor'
      call get_first_nonzero_GNUC(LAtNumb(iAtom),NucMass(iAtom),GNuc(iAtom),NucSpin(iAtom),LStability(iAtom))
  end select

end subroutine proc_nuc_spin

subroutine proc_spin_data()
  !PURPOSE: To find g-factor and NucSpin for given atoms in EZSpin database.

  ! Case 1: Use SEWARD, GATEWAY mass  --> get g-factor and NucSpin
  ! Case 2: Use Nuclear mass     [NMASs, RASSI] --> get g-factor and NucSpin
  ! Case 3: Use Nuclear spin     [NSPIn, RASSI] --> get g-factor
  ! Case 4: Use Nuclear g-factor [GNUC, RASSI] --> get NucSpin
  ! Case 5: Use Most abundant non-zero g-factor (useful for EPR-HFCC)

  ! Note: NucSpin and mass number (integer) has higher priority [IF-ELSE] than g-factor (the last case).

  integer(kind=iwp) :: iAtom, icase
  logical(kind=iwp) :: use_seward_mass
  real(kind=wp), allocatable :: Weights(:)

  call init_spin_data()

  if (.not. allocated(NucSpin)) then
    call mma_allocate(NucSpin,NAtoms,'NucSpin')
    NucSpin(:) = -100.0_wp
  end if

  if (.not. allocated(GNuc)) then
    call mma_allocate(GNuc,NAtoms,'gNuc')
    GNuc(:) = -100.0_wp
  end if

  call mma_allocate(Weights,NAtoms,Label='Weights_hfcop')
  call Get_dArray('Weights',Weights,NAtoms)
  if (NMass_set) then
    ! CASE 1: RASSI and SEWARD might be inconsistent because of user-input NMASs
    do iAtom=1,nAtoms
      if (NucMass(iAtom) == -100.0_wp) NucMass(iAtom) = nint(Weights(iAtom),kind=iwp)
    end do
  else
    ! CASE 2: RASSI and SEWARD mass numbers is consistent at first.
    !         However, users might define wrong spin for unreal isotope
    !         --> Mass number might be incosistent later --> Warnings instead of termination
    call mma_allocate(NucMass,NAtoms,'NucMass_hfcop')
    NucMass(:) = nint(Weights(:),kind=iwp)
  end if

  ! Stability will be re-assigned after processing spin data
  call mma_allocate(LStability,NAtoms,'Stability')
  LStability(:) = '?'

  ! DEFAULT SETTINGS (if users do NOT specify anything : NMASs, NSPIn or GNUC in RASSI input)
  !------------------
  !       1. HFCOperator --> CASE 1 use SEWARD mass
  !                      REASON: to be consistent with molecular dynamics simulations where mass affects the forces on nuclei.
  !       2. HFCAtoms    --> CASE 5 use most abundant non-zero g-factor
  !                      REASON: Users want to compute EPR parameters without looking up the isotopic information.
  !                              This is convienient because the code also print out the conversion factor.
  use_seward_mass = .false.
  ! Setting DEFAULT case based on user input
  if (HypF_rms_Req) then
    if (.not.(AutoSelect_GFac .or. NMass_set .or. NSpin_set .or. GNuc_set)) use_seward_mass = .true.
  else if (allocated(Atens_Req)) then
    if (.not.(AutoSelect_GFac .or. NMass_set .or. NSpin_set .or. GNuc_set)) AutoSelect_GFac = .true.
  end if

  if (use_seward_mass) icase = 1
  if (NMass_set) icase = 2
  if (NSpin_set) icase = 3
  if (GNuc_set) icase = 4
  if (AutoSelect_GFac) icase = 5

  ! HYPOTHEICAL ISOTOPE-------------------------------------------------------------
  if (.not. allocated(HypoIso)) then
    call mma_allocate(HypoIso,NAtoms,'HypoIso_hfcop')
    HypoIso(:) = .false.
  end if
  write(u6,*)
  if (HypF_rms_Req) then
    do iAtom=1,NAtoms
      if (.not. HypoIso(iAtom)) call proc_nuc_spin(iAtom,icase)
      if (NucMass(iAtom) /= nint(Weights(iAtom))) then
        write(u6,'(11X,A28,I3,A24,I3)') 'Warning: Mass number RASSI= ',NucMass(iAtom),' does NOT match SEWARD= ', &
                                        nint(Weights(iAtom))
        write(u6,*) ''
      end if
    end do
  else
    do iAtom=1,NAtoms
      if (.not. HypoIso(iAtom) .and. Atens_Req(iAtom)) call proc_nuc_spin(iAtom,icase)
      if (NucMass(iAtom) /= nint(Weights(iAtom))) then
        write(u6,'(11X,A28,I3,A24,I3)') 'Warning: Mass number RASSI= ',NucMass(iAtom),' does NOT match SEWARD= ', &
                                        nint(Weights(iAtom))
        write(u6,*) ''
      end if
    end do
  end if

  call mma_deallocate(Weights)

  call free_spin_data()

end subroutine proc_spin_data

subroutine route_calc(iAtom)
  ! PURPOSE: Route the calculation when user requests HFC_RMS, A-tensor, pNMR_tensor togehter or separately for different atoms.
  !          Also, it updates iACalc and iPNMR_Calc
  !------------------------------------------------
  !           |HFCOperator | HFCAToms | NMRAToms  |
  !-----------------------------------|-----------|
  ! do_calc   |     TRUE   |    TRUE  |   TRUE    |
  ! do_EPR    |     ___    |    TRUE  |   ___     |
  ! do_pNMR   |     ___    |    ___   |   TRUE    |
  !------------------------------------------------
  !   --- : to be determined by this subroutine.

  ! Note: iACalc and ipNMR_Calc are global variables controlled by route_calc for long-passing.
  !       Do not use iACalc, ipNMR_Calc for loops.

  integer(kind=iwp), intent(in) :: iAtom

  do_calc = .false.
  do_EPR = .false.
  do_pNMR = .false.

  if (allocated(Atens_Req)) then
    do_EPR = Atens_Req(iAtom)
    if (do_EPR) iACalc = iACalc+1
  end if

  if (allocated(pNMR_req)) then
    do_pNMR = pNMR_req(iAtom)
    if (do_pNMR) ipNMR_Calc = ipNMR_Calc+1
  end if

  if (HypF_rms_Req) then
    do_calc = .true.
  else
    do_calc = do_EPR .or. do_pNMR
  end if

end subroutine route_calc

subroutine print_isotope_info()

  integer(kind=iwp) :: iAtom

  write(u6,*)
  write(u6,*)
  write(u6,'(7X,A21)') 'Isotope specification'
  if (HypF_rms_Req) then
    ! Print full table (Spin G-factor)
    write(u6,'(7X,A45)') repeat('-',45)
    write(u6,'(7X,A45)') 'Atom     A   Spin       g-Factor    Stability'
    write(u6,'(7X,A45)') repeat('-',45)
    do iAtom=1,NAtoms
      write(u6,'(7X,A6,1X,I3,4x,F3.1,3x,F12.8,12X,A1)') LAtomLbl(iAtom),NucMass(iAtom),NucSpin(iAtom),GNuc(iAtom),LStability(iAtom)
    end do
    write(u6,'(7X,A45)') repeat('-',45)

  else
    ! Otherwise, only print g-factor. Spin is not needed for EPR calc.
    write(u6,'(7X,A38)') repeat('-',38)
    write(u6,'(7X,A38)') 'Atom     A       g-Factor    Stability'
    write(u6,'(7X,A38)') repeat('-',38)
    do iAtom=1,NAtoms
      if (Atens_Req(iAtom)) write(u6,'(7X,A6,1X,I3,3x,F12.8,12X,A1)') LAtomLbl(iAtom),NucMass(iAtom),GNuc(iAtom),LStability(iAtom)
    end do
    write(u6,'(7X,A38)') repeat('-',38)
  end if
  write(u6,'(7X,A53)') '[ ] = stable, [*] = radioactive, [?] = no information'
  write(u6,*)

  call mma_deallocate(LStability)
  call mma_deallocate(NucMass)

end subroutine print_isotope_info

subroutine print_pNMR_summary()

  integer(kind=iwp) :: iAtom, iT, iContr

  write(u6,*)
  write(u6,*)
  write(u6,*)
  write(u6,'(3X,A96)') repeat('=',96)
  write(u6,'(36X,A28)') 'Summary pNMR Chemical Shifts'
  write(u6,'(3X,A96)') repeat('=',96)
  write(u6,*)
  write(u6,*)

  ipNMR_Calc = 0
  do iAtom=1,nAtoms

    if (pNMR_req(iAtom)) then
      ipNMR_Calc = ipNMR_Calc+1
      write(u6,*)
      write(u6,'(3X,A10,A6)') '>>> ATOM: ',adjustl(LAtomLbl(iAtom))
      write(u6,*)

      write(u6,'(3X,A66)') repeat('-',66)
      write(u6,'(3X,A10,A6,A20)') '>>> ATOM: ',adjustl(LAtomLbl(iAtom)),'CURIE CHEMICAL SHIFT'
      write(u6,'(3X,A66)') repeat('-',66)
      write(u6,'(3X,A7,2X,A12,5X,A12,2(2X,A12))') 'Temp(K)',' Curie (ppm)','        [FC]','        [SD]','       [PSO]'
      write(u6,'(3X,A7,2X,A12,5X,A12,2(2X,A12))') repeat('-',7),(repeat('-',12),iContr=1,4)
      do iT=1,NTP
        write(u6,'(3X,F7.1,2x,F12.2,5x,F12.2,2(2x,F12.2))') Temp_in_K(iT),Curie_ChemShift(ipNMR_Calc,4,iT), &
                                                            (Curie_ChemShift(ipNMR_Calc,iContr,iT),iContr=1,3)
      end do

      write(u6,'(3X,A66)') repeat('-',66)
      write(u6,'(3X,A10,A6,A30)') '>>> ATOM: ',adjustl(LAtomLbl(iAtom)),'LINEAR RESPONSE CHEMICAL SHIFT'
      write(u6,'(3X,A66)') repeat('-',66)
      write(u6,'(3X,A7,2X,A12,5X,A12,2(2X,A12))') 'Temp(K)','LinRes (ppm)','        [FC]','        [SD]','       [PSO]'
      write(u6,'(3X,A7,2X,A12,5X,A12,2(2X,A12))') repeat('-',7),(repeat('-',12),iContr=1,4)

      do iT=1,NTP
        write(u6,'(3X,F7.1,2x,F12.2,5x,F12.2,2(2x,F12.2))') Temp_in_K(iT),LinRes_ChemShift(ipNMR_Calc,4,iT), &
                                                            (LinRes_ChemShift(ipNMR_Calc,iContr,iT),iContr=1,3)
      end do
    end if
  end do

end subroutine print_pNMR_summary

subroutine print_EPR_summary()

  integer(kind=iwp) :: iAtom, iAxis, iCheckVal, iContr
  real(kind=wp) :: Aiso_tot, conv
  character(len=12) :: string_val
  real(kind=wp), allocatable :: checkfile_vals(:)
  character(len=*), parameter :: undef_res = '-/+/-/+/-', unt = '(MHz)'

  write(u6,*)
  write(u6,*)
  write(u6,*)
  write(u6,'(3X,A96)') repeat('=',96)
  write(u6,'(36X,A28)') 'Summary HFC Principal Values'
  write(u6,'(3X,A96)') repeat('=',96)
  write(u6,*)
  write(u6,*)

  !--> Checkfile
  !        (1) Checkfile should be generated before converting to MHz.
  !            The reason is nuclear gfactor might be updated every year,
  !            which might generate numerical noise in test cases (if spin_data is updated)
  !        (2) Sign determination is experimental. Unsigned principal values are better.
  !        (3) The diagonalization step in A_tensor is sometimes sensitive to compilers and geometry [also symmetry breaking].
  !            Test case should be independent of axis choices.
  !
  ! ----------> checkfile_vals = (ABS(A_xx) + ABS(A_yy) + ABS(A_zz))/3     [note. this not prvl or isotropic vals]
  call mma_allocate(checkfile_vals,NATens_Calc*5,Label='EPR_checkfile')
  iACalc = 0
  iCheckVal = 0
  do iAtom=1,nAtoms
    if (Atens_Req(iAtom)) then
      iACalc = iACalc+1
      do iContr=1,5
        iCheckVal = iCheckVal+1
        checkfile_vals(iCheckVal) = sum(abs(prin_vals(iACalc,iContr,1:3)))/Three
      end do
    end if
  end do
  call Add_Info('EPR_HFCOP_CHKVAL',checkfile_vals,NATens_Calc*5,2)
  call mma_deallocate(checkfile_vals)

  !--> Unit conversion to MHz
  iACalc = 0
  do iAtom=1,nAtoms
    if (Atens_Req(iAtom)) then
      iACalc = iACalc+1
      conv = con_to_MHz*GNuc(iAtom)
      prin_vals(iACalc,:,:) = conv*prin_vals(iACalc,:,:)
      call assign_hfc_prvl_signs()
    end if
  end do

  !--> Print Electronic State information
  write(u6,'(3X,A29,F6.2,2X,A27,I0)') '>>> Electronic Pseudospin :: ',e_spin,'Number of Coupling States: ',NCOUP
  write(u6,*)
  write(u6,*)

  !--> Print summary table of principal values in MHz unit
  iACalc = 0
  do iAtom=1,nAtoms
    if (Atens_Req(iAtom)) then
      iACalc = iACalc+1
      write(u6,*)
      write(u6,'(3X,A10,A6,A19,F12.8)') '>>> ATOM: ',adjustl(LAtomLbl(iAtom)),'Nuclear g-factor = ',GNuc(iAtom)
      if (.not. HypoIso(iAtom)) write(u6,'(19X,A19,2X,F3.1)') 'Nuclear Spin     = ',NucSpin(iAtom)
      write(u6,*)
      write(u6,'(3X,A4,2X,A7,A5,5X,A7,A5,3(2X,A7,A5))') 'Comp',' TOTAL ',unt,'    FC ',unt,'    SD ',unt,'  FCSD ',unt,'   PSO ',unt
      write(u6,'(3X,A4,2X,A12,5X,A12,3(2X,A12))') repeat('-',4),(repeat('-',12),iContr=1,5)

      do iAxis=1,3
        write(u6,'(3X,A2,A1,A1,2x,F12.2,5x,F12.2,3(2x,F12.2))') 'A_',xyz(iAxis),xyz(iAxis),prin_vals(iACalc,5,iAxis), &
                                                                (prin_vals(iACalc,iContr,iAxis),iContr=1,4)
      end do

      !--> Print isotropic values
      if (signs_resolved(iACalc)) then
        Aiso_tot = sum(prin_vals(iACalc,5,:))/Three
        write(u6,'(3X,A4,2X,A12,5X,A12,3(2X,A12))') repeat('-',4),(repeat('-',12),iContr=1,5)
        write(u6,'(3X,A5,1x,F12.2,5x,F12.2,3(2x,F12.2))') 'A_iso',abs(Aiso_tot), &
                                                          (abs(sum(prin_vals(iACalc,iContr,:))/Three),iContr=1,4)
        write(u6,*)
        write(u6,'(3X,A33,F13.3,1X,A5)') '>>>>  Isotropic HFCCs (Total)  = ',abs(Aiso_TOT),unt
        write(u6,*)
      else
        write(u6,'(3X,A5,1x,A12,5x,A12,3(2x,A12))') 'A_iso',undef_res,undef_res,undef_res,undef_res,undef_res
        write(u6,*)
        write(u6,'(17x,A57)') 'NOTE: Signs of principal values cannot be determined.'
      end if
    end if
  end do

  ! FUTURE IMPROVEMENT: Accurate sign determination needs spin density at nucleus. There will be an update for this feature.

  write(u6,*)
  write(u6,*)
  write(u6,*) '   ------------'
  write(u6,*) '     ( Note )'
  write(u6,*) '   ------------'
  write(u6,'(A93)') '       1. All isotropic hyperfine coupling constants (HFCCs) are reported as absolute values.'
  write(u6,'(A88)') '       2. If a different isotope is required, you can convert the reported values to MHz'
  write(u6,'(A65)') '          without restarting by using the provided formula below:'
  write(u6,*)

  write(string_val,'(F12.4)')-gElectron*beta_e*beta_n*1.0e9_wp
  write(u6,'(A52,A7,A4)') '                A(MHz) = A(au) * nuclear-g-factor * ',adjustl(string_val(6:12)),'E-09'
  write(string_val,'(F12.4)') con_to_MHz
  write(u6,'(A60,A7)') '             or A(MHz) = sqrt(eigvval) * nuclear-g-factor * ',adjustl(string_val(6:12))
  write(u6,*)
  write(u6,*)

end subroutine print_EPR_summary

subroutine to_cmpl_SO_states(h)

  complex(kind=wp), intent(out) :: h(3,NSS,NSS)
  integer(kind=iwp) :: u
  complex(kind=wp), allocatable :: tmp_matr(:,:)

  call mma_allocate(tmp_matr,NSS,NSS)
  tmp_matr = cmplx(Zero,Zero,kind=wp)
  do u=1,3
    call zgemm_('n','n',NSS,NSS,NSS,cmplx(1.0_wp,0.0_wp,kind=wp),h(u,:,:),NSS,USO,NSS,cmplx(0.0_wp,0.0_wp,kind=wp),tmp_matr,NSS)
    call zgemm_('c','n',NSS,NSS,NSS,cmplx(1.0_wp,0.0_wp,kind=wp),USO,NSS,tmp_matr,NSS,cmplx(0.0_wp,0.0_wp,kind=wp),h(u,:,:),NSS)
  end do
  call mma_deallocate(tmp_matr)

end subroutine to_cmpl_SO_states

subroutine proc_coupl_states()

  integer(kind=iwp) :: ISS
  real(kind=wp) :: degen, min_energy

  ! PRIORITY of KEYWORDS
  ! NCOU  >  COUPL  > DETH

  ! Note (1): Users might run both HFC and NMR. The results should be consistent, therefore,
  ! both of calculations should couple states by energy threshold. In the otherhand, NCOUP or COUP
  ! keywords give users the freedom to choose states for EPR calculations.

  call get_degen_states(1)

  ! User specifies NCOU without COUP ---> First NCOUP lowest-energy states will be coupled
  if (NCOUP > 0_iwp .and. .not.(allocated(LCSTATES))) then
    call mma_allocate(LCSTATES,NCOUP)
    do ISS=1,NCOUP
      LCSTATES(ISS) = ISS
    end do
  end if

  ! SHIFTING ENERGY by NCOUP/COUP-------------------------------------------
  ! then re-determine the coupled states based on energy threshold.
  if (allocated(LCSTATES)) then
    min_energy = ESO(1)
    do ISS=1,size(LCSTATES)
      ESO(LCSTATES(ISS)) = min_energy
    end do
    call get_degen_states(2)
    ! The assignment NCOUP here is different from lines below in else block.
    ! This line is "after" allocated(LCSTATES) to make consistency.
    ! NCOUP in else block is "before" allocating
    NCOUP = degen_end_idx(1)-degen_start_idx(1)+1_iwp
  else
    ! NO SHIFTING ENERGY----------------------------------------------------
    ! If NCOUP or COUP are not specified, coupling states for the A tensor
    ! are derived from GROUND STATES via get_degen_states(1), controlled by DETH.

    ! Get NCOUP from previous call get_degen_states(1)
    NCOUP = degen_end_idx(1)-degen_start_idx(1)+1_iwp
    call mma_allocate(LCSTATES,NCOUP,'LCStates')
    do ISS=degen_start_idx(1),degen_end_idx(1)
      LCSTATES(ISS) = ISS
    end do
  end if

  if (allocated(Atens_Req)) then
    ! Print states used to calculate A_HFC
    write(u6,*)
    write(u6,*)
    write(u6,'(7X,A25)') ' A TENSOR Coupling States'
    write(u6,'(7X,A25)') '-------------------------'
    write(u6,'(7X,A25)') 'SO-State           ENERGY'
    write(u6,'(7X,A25)') '-------------------------'
    do ISS=1,NCOUP
      write(u6,'(7X,I4,6x,F15.6)') LCSTATES(ISS),ESO(LCSTATES(ISS))
    end do
    write(u6,'(7X,A25)') '-------------------------'
    write(u6,*)
    write(u6,*)

    ! PSEUDOSPIN APPROACH
    !--------------------
    ! Purpose: Calculate Atens_fac used to calculate Atensor
    degen = real(NCOUP,kind=wp)
    e_spin = (degen-One)/Two
    ! REF: 10.1021/acs.jctc.0c01005    [eq. 15]
    ! Plug S = e_spin = (degen-1)/2 into eq. 15, one gets:
    ! Atens_fac = 6/[4*S(S+1)(2S+1)] = 12/(degen^3-degen)
    Atens_fac = Twelve/(degen**3-degen)
  end if

end subroutine proc_coupl_states

subroutine get_degen_states(opt)

  integer(kind=iwp), intent(in) :: opt
  integer(kind=iwp) :: degeneracy, first_state, ISS, last_state, lmb
  real(kind=wp) :: ener,prev_ener

  ! Count number of degenerate groups
  prev_ener = ESO(1)
  n_uniq_ener = 1
  do ISS=2,NSS
    if (abs(ESO(ISS)-prev_ener) >= ETHR_in_cm) then
      n_uniq_ener = n_uniq_ener+1
      prev_ener = ESO(ISS)
    end if
  end do

  ! get_degen_states() can be called multiple times, after shifting energy by NCOU or COUPLedstates.
  if (allocated(degen_start_idx)) call mma_deallocate(degen_start_idx)
  if (allocated(degen_end_idx)) call mma_deallocate(degen_end_idx)

  call mma_allocate(degen_start_idx,n_uniq_ener,Label='beg_idx')
  call mma_allocate(degen_end_idx,n_uniq_ener,Label='end_idx')

  ! Assign begin/end indices for each degenerate group
  degen_start_idx(1) = 1
  lmb = 1
  prev_ener = ESO(1)

  do ISS=2,NSS
    if (abs(ESO(ISS)-prev_ener) > ETHR_in_cm) then
      degen_end_idx(lmb) = ISS-1
      lmb = lmb+1
      degen_start_idx(lmb) = ISS
      prev_ener = ESO(ISS)
    end if
  end do
  degen_end_idx(n_uniq_ener) = NSS

  write(u6,*)
  write(u6,*)
  select case (opt)
    case (1)
      write(u6,'(7x,A34,E9.2,A3)') 'RASSI DEGENERATE SO-STATES within ',DEGEN_ETHR,' au'
    case (2)
      write(u6,'(12x,A35)') '<< SHIFTED by NCOU/COUP keywords >>'
  end select
  write(u6,'(7X,A45)') repeat('-',45)
  write(u6,'(7X,A45)') 'Range [SO-State]  Degen.       Energy (cm^-1)'
  write(u6,'(7X,A45)') repeat('-',45)
  do lmb=1,n_uniq_ener
    first_state = degen_start_idx(lmb)
    last_state = degen_end_idx(lmb)
    degeneracy = last_state-first_state+1_iwp
    ener = ESO(degen_start_idx(lmb))
    write(u6,'(10X,I3,A2,I3,8X,I2,9X,F15.6)') first_state,' - ',last_state,degeneracy,ener
  end do
  write(u6,'(7X,A45)') repeat('-',45)

end subroutine get_degen_states

subroutine calc_A_tens(A_tens,h_HFC)

  real(kind=wp), intent(out) :: A_tens(3,3)
  complex(kind=wp), intent(in) :: h_HFC(3,NSS,NSS)
  integer(kind=iwp) :: u, w
  complex(kind=wp), allocatable :: h_temp(:,:,:)

  ! VARIBLE DESCRIPTION:
  ! u,w    :: are cartesian components {x,y,z}
  ! h_temp :: slice of h_HFC contains only coupling states [degenerate ground states]

  !------> UNOPTIMIZED VERSION (for reference, debug only)
  ! REF: 10.1021/acs.jctc.0c01005    [eq. 14-15]
  ! h_HFC = Atens_fac * sum(<i| h_u |j><j| h_w |i>)
  ! We need two kinds of loop (1) u,w over {x,y,z}
  !                           (2) i,j over {coupled states}
  !
  ! do i=1,degen
  !   do j=1,degen
  !     do u=1,3
  !       do w=1,3
  !         A_tens(u,w)=A_tens(u,w)+real(h_HFC(u,i,j)*h_HFC(w,j,i),kind=wp)
  !       enddo
  !     enddo
  !   enddo
  ! enddo

  call mma_allocate(h_temp,3,NCOUP,NCOUP,Label='h_temp_Atens')
  h_temp(:,1:NCoup,1:NCoup) = h_HFC(:,LCSTATES,LCSTATES)

  !------> VECTORIZED VERSION
  do u=1,3
    do w=1,3
      A_tens(u,w) = sum(real(h_temp(u,:,:)*transpose(h_temp(w,:,:)),kind=wp))
    end do
  end do

  call mma_deallocate(h_temp)
  ! Atens_fac is determined by subroutine get_Atens_coupled_states()
  ! PSEUDOSPIN APPROACH :  REF: 10.1021/acs.jctc.0c01005
  A_tens(:,:) = Atens_fac*A_tens(:,:)

end subroutine calc_A_tens

subroutine assign_hfc_prvl_signs()

  integer(kind=iwp) :: iAxis
  logical(kind=iwp) :: is_determined(3)

  !----------------------------------------------
  ! STEP 1: determine FC  +/- SD  =  +/- FCSD
  is_determined(:) = .false.
  do iAxis=1,3
    call assign_abc_signs(prin_vals(iACalc,1,iAxis),prin_vals(iACalc,2,iAxis),prin_vals(iACalc,3,iAxis),is_determined(iAxis))
  end do

  if (all(is_determined)) then
    !----------------------------------------------
    ! STEP 2: determine FCSD  +/- PSO  =  +/- TOTAL
    is_determined(:) = .false.
    do iAxis=1,3
      call assign_abc_signs(prin_vals(iACalc,3,iAxis),prin_vals(iACalc,4,iAxis),prin_vals(iACalc,5,iAxis),is_determined(iAxis))
    end do
    if (all(is_determined)) signs_resolved(iACalc) = .true.
  end if

  if (.not. signs_resolved(iACalc)) prin_vals(iACalc,:,:) = abs(prin_vals(iACalc,:,:))

end subroutine assign_hfc_prvl_signs

subroutine assign_abc_signs(a,b,c,is_determined)
  ! PURPOSE: Determine signs of this equatiion:
  !           a  +/- |b| = +/- |c|
  ! where sign(a) is fixed (always positive or negative). OUTPUT: sign(b), sign(c)
  ! There are two steps:
  !           STEP 1: Compare  MAX(|a|,|b|) and |c|
  !           STEP 2: Compare with the tolerance [5% of the abs maximum]

  real(kind=wp), intent(in) :: a
  real(kind=wp), intent(out) :: b, c
  logical(kind=iwp), intent(out) :: is_determined
  real(kind=wp) :: abs_a, abs_b, abs_c, max_left_absval
  real(kind=wp), parameter :: tol = 0.05_wp

  ! Tolerance for determining signs
  ! 5% of the maximum absolute value among a, b, c
  abs_a = abs(a)
  abs_b = abs(b)
  abs_c = abs(c)
  max_left_absval = max(abs_a,abs_b)
  is_determined = .false.

  if (abs_c > max_left_absval) then
    ! CASE 1: abs_c increases
    !------------------------
    ! a, b should have the SAME sign --> 2 cases: [+] + [+] = [+]
    !                                          or [-] + [-] = [-]
    if (abs((abs_a+abs_b)/abs_c-One) <= tol) then
      is_determined = .true.
      ! a = [+] --> b = [+]  , c = [+]
      ! a = [-] --> b = [-]  , c = [-]
      if (a < Zero) then
        b = -abs_b
        c = -abs_c
      end if
    end if

  else if (abs_c < max_left_absval) then
    ! CASE 2: abs_c decreases
    !------------------------
    ! a, b should have the DIFFERENT signs --> 2 cases: [+] + [-]
    !                                                or [-] + [+]

    if (abs(abs(abs_a-abs_b)/abs_c-One) <= tol) then
      is_determined = .true.

      ! b needs to have the OPOSITE sign of a. Sign of c depends on a & b
      ! a = [+] --> b = [-]  , c = [+] if |a| > |b| and vice versa
      ! a < [-] --> b = [+]  , c = [-] if |a| > |b| and vice versa

      if (a >= Zero) then
        b = -abs_b
        if (abs_a < abs_b) c = -abs_c
      else if (a < Zero) then
        if (abs_a > abs_b) c = -abs_c
      end if
    end if
  end if

end subroutine assign_abc_signs

subroutine calc_prin_val(iAtom,A_tens,iContr)

  integer(kind=iwp), intent(in) :: iAtom, iContr
  real(kind=wp), intent(in) :: A_tens(3,3)
  integer(kind=iwp) :: iAxis, IERR
  real(kind=wp) :: EVI(3), EVR(3), fnorm_diag, fnorm_off_diag, prvl, tmpmat(3,3), X(3,3)
  real(kind=wp), parameter :: to_au = -gElectron*beta_e*beta_n
  real(kind=wp), external :: dnrm2_

  ! VARIABLE DESCRIPTION:
  !   fnorm_diag:       Frobenius norm of diag(sm_a)
  !   fnorm_off_diag:   Frobenius norm of off-diag(sm_a)
  ! iContr              : Contribution: FC = 1
  !                                     SD = 2
  !                                   FCSD = 3
  !                                    PSO = 4
  !                                  Total = 5
  tmpmat(:,:) = A_tens(:,:)
  X(:,:) = Zero
  EVR(:) = Zero
  EVI(:) = Zero
  call XEIGEN(1,3,3,tmpmat,EVR,EVI,X,IERR)

  ! Calculate diagonal elements norm
  fnorm_diag = sqrt(tmpmat(1,1)**2+tmpmat(2,2)**2+tmpmat(3,3)**2)
  ! Calculate off-diagonal elements norm
  tmpmat(1,1) = Zero
  tmpmat(2,2) = Zero
  tmpmat(3,3) = Zero
  fnorm_off_diag = dnrm2_(9,tmpmat,1)

  if (fnorm_off_diag/fnorm_diag > 0.05_wp) then
    call WarningMessage(1,'Relative Frobenius diag/off-diag norm > 5%')
  end if

  if (any(EVR(:) < Zero)) then
    call WarningMessage(2,'Negative eigenvalues found. Cannot take square root.')
    call AbEnd()
  end if

  ! principal values (sqrt of diagonal elements)
  prin_vals(iACalc,iContr,:) = sqrt(EVR(:))

  ! Print A-tensor, the principal axes and eigenvalues
  write(u6,*) ''
  write(u6,*) ''
  write(u6,'(3X,A96)') repeat('-',96)
  write(u6,'(3X,A10,A6,A22,A7)') '>>> ATOM: ',LAtomLbl(iAtom),'HYPERFINE COUPLING :: ',contrib_lab(iContr)
  write(u6,'(3X,A96)') repeat('-',96)
  write(u6,'(14X,A17,29X,A14,14X,A11)') 'A-tensor (A=aa^T)','principal axes','eigenvalues'
  write(u6,'(12x,3(A1,12x),3x,3(A1,12x))') xyz(1:3),xyz(1:3)
  do iAxis=1,3
    write(u6,'(3X,A1,3(1x,ES12.3),3x,3(1x,ES12.3),2x,ES12.3)') xyz(iAxis),A_tens(iAxis,1:3),X(iAxis,1:3),EVR(iAxis)
  end do

  ! Print absolute principal values without signs
  write(u6,*) ''
  write(u6,'(20X,A31,A7)') 'ABS. PRINCIPAL VALUES [+/-] :: ',contrib_lab(iContr)
  write(u6,'(12X,A52)') repeat('.',52)
  write(u6,'(20X,A12,12X,A4,11X,A5)') 'sqrt(eigval)','(au)','(MHz)'
  write(u6,'(12X,A52)') repeat('.',52)
  do iAxis=1,3
    prvl = prin_vals(iACalc,iContr,iAxis)
    write(u6,'(12X,A2,A1,A1,3X,E13.6,3x,E13.6,3x,E13.6)') 'A_',xyz(iAxis),xyz(iAxis),prvl,prvl*to_au,prvl*con_to_MHz*GNuc(iAtom)
  end do

end subroutine calc_prin_val

subroutine update_h_HFC_RMS(iAtom,h_HFC)

  integer(kind=iwp), intent(in) :: iAtom
  complex(kind=wp), intent(in) :: h_HFC(3,NSS,NSS)
  real(kind=wp) :: fac, I_sq, NSpin_I

  ! VERSION 1: PARTLY VECTORIZED
  ! h_rms_nuc =  abs(h_HFC(1,:,:))**2 + abs(h_HFC(2,:,:))**2 + abs(h_HFC(3,:,:))**2

  ! VERSION 2: LEGACY COMPILERS
  ! h_rms_nuc(:,:) = Zero
  ! do i = 1, 3
  !   h_rms_nuc = h_rms_nuc + real(h_HFC(i,:,:))**2 + aimag(h_HFC(i,:,:))**2
  ! end do

  ! OPTIMIZED VERSION :: FULLY VECTORIZED
  h_rms_nuc(:,:) = sum(abs(h_HFC(:,:,:))**2,dim=1)

  ! Scale with factor || I_sq ||^2
  NSpin_I = NucSpin(iAtom)
  I_sq = NSpin_I*(NSpin_I+One)*(Two*NSpin_I+One)/Three
  fac = I_sq*GNuc(iAtom)**2
  h_rms_nuc(:,:) = fac*h_rms_nuc(:,:)

  ! Update h_RMS for this nuclei
  h_hfc_rms(:,:) = h_hfc_rms(:,:)+h_rms_nuc(:,:)

  if (iAtom == NAtoms) then
    ! Note: con_to_MHz = gElectron*beta_e*beta_n*auToHz*1e-6_wp
    fac = -gElectron*beta_e*beta_n
    h_hfc_rms(:,:) = fac*sqrt(h_hfc_rms(:,:))
  end if
end subroutine update_h_HFC_RMS

subroutine calc_h_PSO(iAtom,PROP)

  integer(kind=iwp), intent(in) :: iAtom
  real(kind=wp), intent(in) :: PROP(NSTATE,NSTATE,NPROP)
  integer(kind=iwp) :: u
  real(kind=wp), allocatable :: Im_h_PSO(:,:,:)

  call mma_allocate(Im_h_PSO,3,NSS,NSS,Label='Im_h_PSO')
  Im_h_PSO(:,:,:) = Zero
  do u=1,3
    call SMMAT(PROP,Im_h_PSO(u,:,:),NSS,PSO_idx(iAtom,u),u)
  end do
  h_PSO(:,:,:) = cmplx(0.0_wp,Im_h_PSO(:,:,:),kind=wp)
  call mma_deallocate(Im_h_PSO)

  call to_cmpl_SO_states(h_PSO)

end subroutine calc_h_PSO

subroutine save_h_rms()

  integer(kind=iwp) :: ISS, istatus, JSTA, LU
  logical(kind=iwp) :: is_error
  integer(kind=iwp), external :: IsFreeUnit

# ifdef _HDF5_
  call mh5_put_dset(wfn_h_hfc_rms,h_hfc_rms)
# endif

  Lu = IsFreeUnit(88)
  istatus = 100
  call molcas_open_ext2(Lu,'h_RMS.txt','SEQUENTIAL','FORMATTED',istatus,.false.,1,'REPLACE',is_error)
  write(Lu,*) 'NSS= ',NSS
  write(Lu,*) '#NROW NCOL REAL'
  do JSTA=1,NSS
    do ISS=1,NSS
      write(Lu,'(I6,1X,I6,A1,ES25.16,A1,ES25.16)') ISS,JSTA,' ',h_hfc_rms(ISS,JSTA)
    end do
  end do
  close(Lu)

end subroutine save_h_rms

subroutine calc_h_Zeeman(PROP)

  real(kind=wp), intent(in) :: PROP(NSTATE,NSTATE,NPROP)
  real(kind=wp), allocatable :: Angmom(:,:,:), Im_h_Zeeman(:,:,:), Re_h_Zeeman(:,:,:)

  call mma_allocate(Re_h_Zeeman,3,NSS,NSS,Label='Re_h_Zeeman')
  call mma_allocate(Im_h_Zeeman,3,NSS,NSS,Label='Im_h_Zeeman')
  call mma_allocate(Angmom,3,NSS,NSS,Label='Angmom')
  call mma_allocate(h_Zeeman,3,NSS,NSS,Label='h_Zeeman')

  h_Zeeman(:,:,:) = cZero
  Re_h_Zeeman(:,:,:) = Zero
  Im_h_Zeeman(:,:,:) = Zero

  Angmom(:,:,:) = Zero

  call SMMAT(PROP,Angmom(1,:,:),NSS,AngMom_idx(1),0)
  call SMMAT(PROP,Angmom(2,:,:),NSS,AngMom_idx(2),0)
  call SMMAT(PROP,Angmom(3,:,:),NSS,AngMom_idx(3),0)

  call SMMAT(PROP,Re_h_Zeeman(1,:,:),NSS,0,1)
  call SMMAT(PROP,Im_h_Zeeman(2,:,:),NSS,0,2)
  call SMMAT(PROP,Re_h_Zeeman(3,:,:),NSS,0,3)

  Re_h_Zeeman(1,:,:) = -gElectron*Re_h_Zeeman(1,:,:)
  Im_h_Zeeman(2,:,:) = -gElectron*Im_h_Zeeman(2,:,:)
  Re_h_Zeeman(3,:,:) = -gElectron*Re_h_Zeeman(3,:,:)
  Im_h_Zeeman(:,:,:) = Im_h_Zeeman(:,:,:)+Angmom(:,:,:)

  h_Zeeman(:,:,:) = cmplx(Re_h_Zeeman(:,:,:),Im_h_Zeeman(:,:,:),kind=wp)
  call to_cmpl_SO_states(h_Zeeman)

  h_Zeeman(:,:,:) = h_Zeeman(:,:,:)/Two

  call mma_deallocate(Re_h_Zeeman)
  call mma_deallocate(Im_h_Zeeman)
  call mma_deallocate(Angmom)
  ! h_Zeeman needs to deallocated at the end [after pNMR calc. finishes]

end subroutine calc_h_Zeeman

subroutine calc_pNMR_Tensor(iAtom,h_HFC,iContr)

  integer(kind=iwp), intent(in) :: iAtom, iContr
  complex(kind=wp), intent(in) :: h_HFC(3,NSS,NSS)

  integer(kind=iwp) :: ISS, iT, lmb, lmb_a, lmb_ap, u, w
  real(kind=wp) :: fac

  ! VARIABLES DESCRIPTION
  ! REF: DOI: 10.1021/acs.jctc.6b00462   [eq. 1]
  ! lmb                 : "lambda" is the group of all degenerate states.
  ! lmb_a & lmb_ap      : states between lmb_a - lmb_ap are degenerate
  ! Z_HFC_int_oper      : <i |h_Zeeman| j> <j |h_HFC| i>
  ! Z_HFC_over_dE       : Z_HFC_int_oper / delta_E(ij)
  ! LR_tens             : Linear Response tensor [first term,  eq 1]
  ! C_tens              : Curie tensor           [second term, eq 1]
  ! iContr              : Contribution: FC = 1
  !                                     SD = 2
  !                                    PSO = 3
  !                                  Total = 4

  ! Calculate temperature-indepedent terms (numerator) in ! REF: DOI: 10.1021/acs.jctc.6b00462 Eq. 1
  do u=1,3
    do w=1,3
      Z_HFC_int_oper(u,w,:,:) = real(h_Zeeman(u,:,:)*conjg(h_HFC(w,:,:)),kind=wp)
      Z_HFC_over_dE(u,w,:,:) = Z_HFC_int_oper(u,w,:,:)*dE_inv(:,:)
    end do
  end do

  ! Linear response, Curie pNMR tensor are temperature-dependent
  LR_tens(:,:,:) = Zero
  C_tens(:,:,:) = Zero
  do iT=1,NTP
    do ISS=1,NSS
      ! lambda (lmb) is a group of degenereate states
      ! All degenerate states have the SAME lambda
      lmb = degen_group(ISS)
      lmb_a = degen_start_idx(lmb)
      lmb_ap = degen_end_idx(lmb)

      ! Vectorized Curie tensor is trivial, loop between lmb_a and lmb_ap [degenerate states]
      C_tens(iT,:,:) = C_tens(iT,:,:)+pBoltz(iT,ISS)*sum(Z_HFC_int_oper(:,:,ISS,lmb_a:lmb_ap),dim=3)

      ! Non-degenerate states will contribute to Linear Response term
      ! Two if-logic has been used to avoid empty array (lmb_a == 1 means 1:lmb_a-1 == 1:0)
      if (lmb_a > 1) LR_tens(iT,:,:) = LR_tens(iT,:,:)+pBoltz(iT,ISS)*sum(Z_HFC_over_dE(:,:,ISS,1:lmb_a-1),dim=3)
      if (lmb_ap < NSS) LR_tens(iT,:,:) = LR_tens(iT,:,:)+pBoltz(iT,ISS)*sum(Z_HFC_over_dE(:,:,ISS,lmb_ap+1:NSS),dim=3)

    end do
    fac = One/(kBoltzman_in_cm*Temp_in_K(iT))
    C_tens(iT,:,:) = fac*C_tens(iT,:,:)
  end do !Temperature

  ! Unit conversion to ppm
  C_tens(:,:,:) = to_ppm*C_tens(:,:,:)
  fac = to_ppm*Two
  LR_tens(:,:,:) = fac*LR_tens(:,:,:)

  ! Calculate chemical shift by average diagonal elements
  ! Store chemical shift to print summary later
  Curie_ChemShift(ipNMR_Calc,iContr,:) = -(C_tens(:,1,1)+C_tens(:,2,2)+C_tens(:,3,3))/Three
  LinRes_ChemShift(ipNMR_Calc,iContr,:) = -(LR_tens(:,1,1)+LR_tens(:,2,2)+LR_tens(:,3,3))/Three

  ! Print output
  write(u6,*) ''
  write(u6,'(3X,A66)') repeat('-',66)
  write(u6,'(3X,A10,A6,A19,A7)') '>>> ATOM: ',LAtomLbl(iAtom),'LINEAR RESPONSE :: ',contrib_lab(iContr)
  write(u6,'(3X,A66)') repeat('-',66)
  write(u6,'(3X,A8,16X,A7,18X,A17)') 'Temp (K)','Tensor','Chem. Shift (ppm)'
  do iT=1,NTP
    call print_pNMR_tens(Temp_in_K(iT),LR_tens(iT,:,:))
  end do
  write(u6,'(3X,A66)') repeat('-',66)
  write(u6,'(3X,A10,A6,A9,A7)') '>>> ATOM: ',LAtomLbl(iAtom),'CURIE :: ',contrib_lab(iContr)
  write(u6,'(3X,A66)') repeat('-',66)
  write(u6,'(3X,A8,16X,A7,18X,A17)') 'Temp (K)','Tensor','Chem. Shift (ppm)'
  do iT=1,NTP
    call print_pNMR_tens(Temp_in_K(iT),C_tens(iT,:,:))
  end do
  write(u6,*) ''
  write(u6,*) ''
  write(u6,*) ''

end subroutine calc_pNMR_Tensor

subroutine print_pNMR_tens(temp,tensor)

  real(kind=wp), intent(in) :: temp, tensor(3,3)
  integer(kind=iwp) :: u
  real(kind=wp) :: shift

  shift = -(tensor(1,1)+tensor(2,2)+tensor(3,3))/Three
  write(u6,'(2X,F6.1,3(2x,ES12.3),4X,F15.3)') temp,tensor(1,1:3),shift
  do u=2,3
    write(u6,'(8X,3(2x,ES12.3))') tensor(u,1:3)
  end do
  write(u6,*)

end subroutine print_pNMR_tens

subroutine cleanup_hfcop()

  call mma_deallocate(MAPST)
  call mma_deallocate(CGx_mat)
  call mma_deallocate(CGy_mat)
  call mma_deallocate(CGo_mat)
  call mma_deallocate(LAtNumb)
  call mma_deallocate(LAtomLbl)
  call mma_deallocate(USO)
  call mma_deallocate(ESO)
  call mma_deallocate(h_FC)
  call mma_deallocate(h_SD)
  call mma_deallocate(h_FCSD)
  call mma_deallocate(h_PSO)
  call mma_deallocate(h_TOT)

  if (HypF_rms_Req) then
    call mma_deallocate(h_hfc_rms)
    call mma_deallocate(h_rms_nuc)
  end if

  if (allocated(pNMR_req)) then
    call mma_deallocate(Curie_ChemShift)
    call mma_deallocate(LinRes_ChemShift)
    call mma_deallocate(pNMR_req)
    call mma_deallocate(pBoltz)
    call mma_deallocate(Temp_in_K)

    call mma_deallocate(Z_HFC_int_oper)
    call mma_deallocate(Z_HFC_over_dE)
    call mma_deallocate(AngMom_idx)
    call mma_deallocate(h_Zeeman)

    call mma_deallocate(dE_inv)
    call mma_deallocate(LR_tens)
    call mma_deallocate(C_tens)
    call mma_deallocate(degen_group)
  end if

  call mma_deallocate(HypoIso,safe='*')

  call mma_deallocate(NucSpin,safe='*')
  call mma_deallocate(GNuc,safe='*')
  call mma_deallocate(LCSTATES,safe='*')

  call mma_deallocate(ASD_idx,safe='*')
  call mma_deallocate(PSO_idx,safe='*')

  call mma_deallocate(degen_start_idx,safe='*')
  call mma_deallocate(degen_end_idx,safe='*')

  if (allocated(Atens_Req)) then
    call mma_deallocate(Atens_Req)
    call mma_deallocate(prin_vals)
    call mma_deallocate(signs_resolved)
  end if

end subroutine cleanup_hfcop

end module hfcop

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Drv_AMFI(Label,lOper,nComp,iAtmNr2,Charge2)

use AMFI_global, only: Lmax
use iSD_data, only: iSD
use Basis_Info, only: dbsc, Gaussian_Type, MolWgh, nBas, nCnttp, Nuclear_Model, Shells
use DKH_Info, only: DKroll
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
character(len=8), intent(in) :: Label
integer(kind=iwp), intent(in) :: nComp, lOper(nComp), iAtmNr2(mxdbsc)
real(kind=wp), intent(in) :: Charge2(mxdbsc)
#include "angtp.fh"
integer(kind=iwp) :: i, iCase, iCenter, iCff_x, iCnt, iCnttp, id_Tsk, iExp_x, iShll, iSkal, jCnt, jCnttp, l, l_max, lDel, &
                     Lu_AMFI, LUPROP, mdci, nBas_x, nCenter, nCenter_node, nCore, nExp_x, nSkal
real(kind=wp) :: charge_x, Coor(3), Eta_Nuc
logical(kind=iwp) :: EQ
integer(kind=iwp), allocatable :: iDel(:)
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
#define _TEST_ .true.
#else
#define _TEST_ .false.
#endif
logical(kind=iwp), parameter :: IfTest = _TEST_
logical(kind=iwp), external :: Rsv_Tsk

#ifdef _DEBUGPRINT_
write(u6,*) ' In OneEl: Label',Label
write(u6,*) ' In OneEl: nComp'
write(u6,'(1X,8I5)') nComp
write(u6,*) ' In OneEl: lOper'
write(u6,'(1X,8I5)') lOper
#endif

Eta_Nuc = Zero

! Generate list of shell information

call Nr_Shells(nSkal)

! Check that there are not several instances of the same center.

nCenter = 0
do iSkal=1,nSkal
  nCenter = max(nCenter,iSD(10,iSkal))
  if (iSD(1,iSkal) > Lmax) then
    write(u6,*) ' Shells higher than '//Angtp(Lmax)//'-functions not allowed in AMFI.'
    call Quit_OnUserError()
  end if
  if ((iSD(1,iSkal) >= 2) .and. (.not. btest(iSD(9,iSkal),0))) then
    write(u6,*) ' Only real spherical harmonics allowed'
    write(u6,*) ' for AMFI.'
    call Quit_OnUserError()
  end if
end do
Coor(:) = Zero
do iCenter=1,nCenter

  ! Identify which dbsc this center belongs.

  iCnttp = 0
  do iSkal=1,nSkal
    if (iSD(10,iSkal) == iCenter) then
      iCnttp = iSD(13,iSkal)
      iCnt = iSD(14,iSkal)
      Coor(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
    end if
  end do

  ! If iCenter is not a center in the current list of shells that
  ! is to be processed then test the next iCenter.

  if (iCnttp == 0) cycle

  do iSkal=1,nSkal
    if ((iSD(13,iSkal) /= iCnttp) .and. (iSD(10,iSkal) /= iCenter)) then
      jCnttp = iSD(13,iSkal)
      jCnt = iSD(14,iSkal)
      if (EQ(Coor,dbsc(jCnttp)%Coor(1,jCnt))) then
        write(u6,*) 'Multiple instances of the same center!'
        write(u6,*) 'This is not allowed with AMFI.'
        call Quit_OnUserError()
      end if
    end if
  end do
end do
if ((MolWgh /= 0) .and. (MolWgh /= 2)) then
  write(u6,*) ' AMFI integrals not implemented for symmetry adaptation a la MOLECULE'
  call Quit_OnUserError()
end if

! Loop over unique center. Observe that multiple shells of the same
! angular momentum is not allowed.

Lu_AMFI = 21
LUPROP = 22
call molcas_open(Lu_AMFI,'AMFI_INP')
call molcas_binaryopen_vanilla(LUPROP,'AMFI_INT')
nCenter_node = 0

call Init_Tsk(id_Tsk,nCenter)
do
  if (.not. Rsv_Tsk(id_Tsk,iCenter)) exit
  !do iCenter=1,nCenter
  nCenter_node = nCenter_node+1

  write(Lu_AMFI,'(A)') ' &AMFI'
  if (IfTest) write(u6,'(A)') ' &AMFI'

  ! Find atom type

  mdci = 0
  outer: do iCnttp=1,nCnttp
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdci = mdci+1
      if (mdci == iCenter) then
        if ((.not. DKroll) .and. (.not. dbsc(iCnttp)%SODK)) write(Lu_AMFI,'(A)') 'Breit-Pauli'
        if (IfTest) then
          if ((.not. DKroll) .and. (.not. dbsc(iCnttp)%SODK)) write(u6,'(A)') 'Breit-Pauli'
        end if
        if (iAtmNr2(iCnttp) >= 1) then
          charge_x = real(iAtmNr2(iCnttp),kind=wp)
        else if ((iAtmNr2(iCnttp) <= 0) .and. (Charge2(iCnttp) == Zero)) then
          charge_x = Zero
        else
          write(u6,*) 'Drv_AMFI: Invalid basis!'
          write(u6,*) 'iAtmNr=',iAtmNr2(iCnttp)
          write(u6,*) 'Charge2=',Charge2(iCnttp)
          call Abend()
        end if
        if (Nuclear_Model == Gaussian_Type) Eta_Nuc = dbsc(iCnttp)%ExpNuc
        exit outer
      end if
    end do
  end do outer

  if (Nuclear_Model == Gaussian_Type) then
    write(Lu_AMFI,'(A)') 'Finite'
    if (IfTest) write(u6,'(A)') 'Finite'
    write(Lu_AMFI,*) Eta_Nuc
    if (IfTest) write(u6,*) Eta_Nuc
  end if

  ! Generate input for each atom

  l_max = -1
  do iSkal=1,nSkal
    if (iSD(10,iSkal) == iCenter) l_Max = max(l_Max,iSD(1,iSkal))
  end do
  if (l_max > LMax) then
    write(u6,*) 'AMFI integrals only implemented up to '//Angtp(Lmax)//'-functions.'
    call Quit_OnUserError()
  end if

  ! Check if there are any core orbitals to be deleted

  nCore = 0
  do l=0,l_max
    do iSkal=1,nSkal
      if ((iSD(10,iSkal) == iCenter) .and. (iSD(1,iSkal) == l)) then

        iCnttp = iSD(13,iSkal)
        if (dbsc(iCnttp)%nSOC /= 0) then
          iShll = dbsc(iCnttp)%iSOC+l
          !jShll = dbsc(iCnttp)%iPrj+l
          !nCore = nCore+Shells(jShll)%nBasis
          nCore = nCore+dbsc(iCnttp)%kDel(l)
        end if
      end if
    end do
  end do
  if (IfTest) write(u6,*) 'nCore: ',nCore

  ! Set up delete array

  if (nCore /= 0) then
    lDel = l_Max+1
    call mma_allocate(iDel,lDel,label='iDel')
    do l=0,l_max
      do iSkal=1,nSkal
        if ((iSD(10,iSkal) == iCenter) .and. (iSD(1,iSkal) == l)) then

          iCnttp = iSD(13,iSkal)
          if (dbsc(iCnttp)%nSOC /= 0) then
            iShll = dbsc(iCnttp)%iSOC+l
            !jShll = dbsc(iCnttp)%iPrj+l
            !iDel(ip_iDel+l) = Shells(jShll)%nBasis
            iDel(1+l) = dbsc(iCnttp)%kDel(l)
          end if
        end if
      end do
    end do
    write(Lu_AMFI,'(A)') 'AIMP'
    write(Lu_AMFI,*) lDel-1,(iDel(i),i=1,lDel)
    if (IfTest) write(u6,'(A)') 'AIMP'
    if (IfTest) write(u6,*) lDel,(iDel(i),i=1,lDel)
    call mma_deallocate(iDel)
  end if

  write(Lu_AMFI,'(A)') '     '
  write(Lu_AMFI,'(3X,F5.1,I4)') charge_x,l_max
  if (IfTest) write(u6,*) charge_x,l_max

  do l=0,l_max
    do iSkal=1,nSkal
      if ((iSD(10,iSkal) == iCenter) .and. (iSD(1,iSkal) == l)) then

        iCnttp = iSD(13,iSkal)
        if (dbsc(iCnttp)%nSOC == 0) then

          ! Use valence basis

          iShll = dbsc(iCnttp)%iVal+l
          iCase = 2

        else

          ! Use special valence basis in case of a ECP where the
          ! normal valence might not be adequate.

          iShll = dbsc(iCnttp)%iSOC+l
          iCase = 1

        end if
        nBas_x = Shells(iShll)%nBasis
        nExp_x = Shells(iShll)%nExp

        if (IfTest) write(u6,*) 'iShll=',iShll
        write(Lu_AMFI,*) nExp_x,nBas_x
        if (IfTest) write(u6,*) nExp_x,nBas_x
        write(Lu_AMFI,*) (Shells(iShll)%Exp(iExp_x),iExp_x=1,nExp_x)
        if (IfTest) write(u6,*) (Shells(iShll)%Exp(iExp_x),iExp_x=1,nExp_x)
        do iExp_x=1,nExp_x
          write(Lu_AMFI,*) (Shells(iShll)%Cff_c(iExp_x,iCff_x,iCase),iCff_x=1,nBas_x)
          if (IfTest) write(u6,*) (Shells(iShll)%Cff_c(iExp_x,iCff_x,iCase),iCff_x=1,nBas_x)
        end do

      end if
    end do
  end do
  write(Lu_AMFI,'(A)') 'End of Input'
  if (IfTest) write(u6,'(A)') 'End of Input'

  ! Now call AMFI

  rewind(Lu_AMFI)
  call AMFI(Lu_AMFI,LUPROP,iCenter)

  rewind(Lu_AMFI)

end do
call Free_Tsk(id_Tsk)
!end do
close(Lu_AMFI)

! Now symmetry adapt.

rewind(LUPROP)

call SymTrafo(LUPROP,lOper,nComp,nBas,nIrrep,Label,MolWgh)

close(LUPROP)

return

end subroutine Drv_AMFI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Name(Element)
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
#include "periodic_table.fh"
      Character*2 Element(*)
      Real*8, Allocatable :: Chrg(:)
*
      Call Get_iScalar('Unique atoms',nAtoms)
      Call mma_Allocate(Chrg,nAtoms)
*
      Call Get_dArray('Nuclear charge',Chrg,nAtoms)
*
      Do i = 1, nAtoms
         iElement_Nr=INT(Chrg(i))
         If (iElement_Nr.ge.0 .and. iElement_Nr.le.Num_Elem) Then
            Element(i)=PTab(iElement_Nr)
         Else
            Element(i)=' X'
         End If
      End Do
      call mma_deallocate(Chrg)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MAGN_NO_MF(EXCH,N,X,Y,Z,H,W,dM,sM,nT,T,sopt,WZ,ZB,S,M,DBG)
! this Subroutine computes the magnetisation for zJ==0.0
!
! definition of the variables:
!   EXCH -- total number of exchange states, Integer, input
!      N -- size of the Zeeman matrix, Integer, input, NM <= EXCH !
!  X,Y,Z -- projections of the magnetic field, specifying the orientation of the applied
!           magnetic field, Real(kind=wp) ::, input;  rule: ( X**2 + Y**2 + Z**2 = 1);
!      H -- strength of the magnetic field in tesla, Real(kind=wp) ::, input;
!      W -- energies of the exchange states; Real(kind=wp) :: array (EXCH);
!     dM -- matrix of the magnetic moment, Complex(kind=wp) :: (3,EXCH,EXCH) array, input;
!     sM -- matrix of the     spin moment, Complex(kind=wp) :: (3,EXCH,EXCH) array, input;
!     nT -- number of temperature points for which magnetisation is computed, input;
!      T -- temperature values(in kelvin) for which magnetisation is computed, input;
!   sopt -- logical parameter. If sopt=.true. Then spin magnetisation is computed.
!                              If sopt=.false. Then spin part is skipped.
!
!     WZ -- Zeeman energies, true values (not shifted to 0), in cm-1, Real(kind=wp) :: (N) array, output;
!     ZB -- statistical Boltzmann distribution, for each temperature, Real(kind=wp) :: (nT) array, output;
!      S -- spin magnetisation, Real(kind=wp) :: (3,nT) array, output;
!      M -- magnetisation, Real(kind=wp) :: (3,nT) array, output;
! m_paranoid --  logical parameter.
!            If m_paranoid = .true.  Then the average spin is computed for each temperature point exactly
!            If m_paranoid = .false. Then  the average spin is computed only for the lowest temperature point
!---------
!  temporary (local) variables:
!    MZ -- matrix of the magnetic moment, Complex(kind=wp) :: (3,EXCH,EXCH) array
!    SZ -- matrix of the     spin moment, Complex(kind=wp) :: (3,EXCH,EXCH) array
!    WM -- array containing the Zeeman eigenstates and, If N<EXCH the exchange eigenstates
!          for the states higher in energy than N, Real(kind=wp) ::, (EXCH) array;
!    ZM -- Zeeman eigenvectors, (N,N) Complex(kind=wp) :: array,
!   i,j -- labels of the states;
!     l -- labels the cartesian component of the momentum (convention: x=1, y=2, z=3)
!    iT -- labels the temperature points;

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: EXCH, N, nT
real(kind=wp), intent(in) :: X, Y, Z, H, W(EXCH), T(nT)
complex(kind=wp), intent(in) :: dM(3,EXCH,EXCH), sM(3,EXCH,EXCH)
logical(kind=iwp), intent(in) :: sopt
real(kind=wp), intent(out) :: WZ(N), ZB(nT), S(3,nT), M(3,nT)
logical(kind=iwp), intent(in) :: DBG
integer(kind=iwp) :: iT, l
real(kind=wp) :: ST(3), zJ
real(kind=wp), allocatable :: RWORK(:), WM(:)
complex(kind=wp), allocatable :: dM_TMP(:,:,:), HZEE(:), MZ(:,:,:), sM_TMP(:,:,:), SZ(:,:,:), TMP(:,:), W_c(:), WORK(:), ZM(:,:)

WZ(:) = Zero
ZB(:) = Zero
S(:,:) = Zero
M(:,:) = Zero

! a few checks, before proceeding:
do iT=1,nT
  if (T(iT) == Zero) return
end do
if (H == Zero) return
if (N > EXCH) return
zJ = Zero ! it must be defined for ZEEM
! initialization:
call mma_allocate(WM,exch,'WM')
call mma_allocate(ZM,exch,exch,'ZM')
call mma_allocate(SZ,3,exch,exch,'SZ')
call mma_allocate(MZ,3,exch,exch,'MZ')

! temporary arrays used in ZEEM_SA:
call mma_allocate(RWORK,3*N-2,'ZEEM_RWORK')
call mma_allocate(HZEE,nTri_Elem(N),'ZEEM_HZEE')
call mma_allocate(WORK,2*N-1,'ZEEM_WORK')
call mma_allocate(W_c,N,'ZEEM_W_c')

! zero everything:
RWORK(:) = Zero
HZEE(:) = cZero
WORK(:) = cZero
W_c(:) = cZero

ST(:) = Zero
WM(:) = Zero
ZM(:,:) = cZero
SZ(:,:,:) = cZero
MZ(:,:,:) = cZero
! start calculations:
if (DBG) then
  write(u6,*) 'Enter ZEEM::'
  write(u6,*) 'Input data:   N = ',N
  write(u6,*) 'Input data:   H = ',H
  write(u6,*) 'Input data:   X = ',X
  write(u6,*) 'Input data:   Y = ',Y
  write(u6,*) 'Input data:   Z = ',Z
  write(u6,*) 'Input data:  zJ = ',zJ
  write(u6,*) 'Input data: W() = ',W(1:N)
  write(u6,*) 'Input data: ST()= ',ST(1:3)
  call prmom('Input data dM:',dM,N)
  call prmom('Input data sM:',sM,N)
end if

! Build and diagonalize the Zeeman Hamiltonian
! most important output are: WM (energies) and ZM (eigenvectors)
if (N == EXCH) then
  call ZEEM_SA(N,H,X,Y,Z,W,dM,sM,ST,zJ,WM,ZM,DBG,RWORK,HZEE,WORK,W_c)
else
  call mma_allocate(dM_TMP,3,N,N,label='dM_TMP')
  call mma_allocate(sM_TMP,3,N,N,label='sM_TMP')
  dM_TMP(:,:,:) = dM(:,1:N,1:N)
  sM_TMP(:,:,:) = sM(:,1:N,1:N)
  call ZEEM_SA(N,H,X,Y,Z,W(1:N),dM_TMP,sM_TMP,ST,zJ,WM(1:N),ZM,DBG,RWORK,HZEE,WORK,W_c)
  call mma_deallocate(dM_TMP)
  call mma_deallocate(sM_TMP)
end if
if (DBG) write(u6,*) 'Exit ZEEM::'

WZ(:) = WM(1:N)
WM(N+1:) = W(N+1:)

! transform the momenta
call UTMU(EXCH,N,ZM,sM,SZ)
call UTMU(EXCH,N,ZM,dM,MZ)

! compute magnetization at different temperatures:

if (N == EXCH) then
  call mma_allocate(TMP,EXCH,EXCH,label='TMP')
  do iT=1,nT
    do l=1,3
      if (sopt) then
        TMP(:,:) = SZ(l,:,:)
        call calcmagn1(EXCH,WM,TMP,T(iT),S(l,iT),ZB(iT))
      end if
      TMP(:,:) = MZ(l,:,:)
      call calcmagn1(EXCH,WM,TMP,T(iT),M(l,iT),ZB(iT))
    end do
  end do
  call mma_deallocate(TMP)
else
  do iT=1,nT
    do l=1,3
      if (sopt) call calcmagn2(EXCH,N,WM,T(iT),H,SZ,X,Y,Z,l,S(l,iT),ZB(iT))
      call calcmagn2(EXCH,N,WM,T(iT),H,MZ,X,Y,Z,l,M(l,iT),ZB(iT))
    end do
  end do !iT
end if

! deallocate temporary arrays:
call mma_deallocate(RWORK)
call mma_deallocate(HZEE)
call mma_deallocate(WORK)
call mma_deallocate(W_c)

call mma_deallocate(WM)
call mma_deallocate(ZM)
call mma_deallocate(SZ)
call mma_deallocate(MZ)

return

end subroutine MAGN_NO_MF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! INPORB formatting parameters
! to add a new version, increase version number and
! add appropriate new Magic string and format descriptors

module InpOrbFmt

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: mxVer = 5, &
                                iVer10 = 1, &
                                iVer11 = 2, &
                                iVer20 = 3, &
                                iVer21 = 4, &
                                iVer22 = 5, &
                                nDivOrb(mxVer) = [4,4,5,5,5], &
                                nDivOcc(mxVer) = [4,4,10,4,5], &
                                nDivOccHR(mxVer) = [0,0,0,10,10], &
                                nDivEne(mxVer) = [4,4,10,10,10], &
                                nDivInd(mxVer) = [4,10,10,10,10], &
                                nSkpInd(mxVer) = [0,1,1,1,1]
character(len=*), parameter :: Magic(mxVer) = ['#INPORB 1.0', &
                                               '#INPORB 1.1', &
                                               '#INPORB 2.0', &
                                               '#INPORB 2.1', &
                                               '#INPORB 2.2' &
                                              ], &
                               FmtOrb(mxVer) = [character(len=40) :: &
                                                '(4E18.12)', &
                                                '(4E18.12)', &
                                                '(5(1X,ES21.14))', &
                                                '(5(1X,ES21.14))', &
                                                '(5(1X,ES21.14))' &
                                               ], &
                               FmtOcc(mxVer) = [character(len=40) :: &
                                                '(4E18.12)', &
                                                '(4E18.12)', &
                                                '(10(1X,F7.4))', &
                                                '(4E18.12)', &
                                                '(5(1X,ES21.14))' &
                                               ], &
                               FmtOccHR(mxVer) = [character(len=40) :: &
                                                  '', &
                                                  '', &
                                                  '', &
                                                  '(10(1X,F7.4))', &
                                                  '(10(1X,F7.4))' &
                                                 ], &
                               FmtEne(mxVer) = [character(len=40) :: &
                                                '(4E18.12)', &
                                                '(4E18.12)', &
                                                '(10(1X,ES11.4))', &
                                                '(10(1X,ES11.4))', &
                                                '(10(1X,ES11.4))' &
                                               ], &
                               FmtInd(mxVer) = [character(len=40) :: &
                                                '(A4)', &
                                                '(2X,A10)', &
                                                '(2X,A10)', &
                                                '(2X,A10)', &
                                                '(2X,A10)' &
                                               ]

public :: FmtEne, FmtInd, FmtOcc, FmtOccHR, FmtOrb, Magic, iVer10, iVer11, iVer20, iVer21, iVer22, mxVer, nDivEne, nDivInd, &
          nDivOcc, nDivOccHR, nDivOrb, nSkpInd

end module InpOrbFmt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_RWord2Byte(Word,Byte,Unt)

use Constants, only: Eight
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: Word
real(kind=wp), intent(out) :: Byte
character(len=2), intent(out) :: Unt

Byte = Word*Eight
Unt = 'b '
if (abs(Byte) > 1.0e3_wp) then
  Byte = Byte/1.024e3_wp
  Unt = 'kb'
  if (abs(Byte) > 1.0e3_wp) then
    Byte = Byte/1.024e3_wp
    Unt = 'Mb'
    if (abs(Byte) > 1.0e3_wp) then
      Byte = Byte/1.024e3_wp
      Unt = 'Gb'
      if (abs(Byte) > 1.0e3_wp) then
        Byte = Byte/1.024e3_wp
        Unt = 'Tb'
      end if
    end if
  end if
end if

end subroutine Cho_RWord2Byte

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mxattb_cvb(a,b,n1,n2,n3,c)
      implicit real*8 (a-h,o-z)
      dimension a(n2,n1),b(n2,n3),c(n1,n3)

      Call DGEMM_('T','N',n1,n3,n2,1.0d0,a,n2,b,n2,0.0d0,c,n1)

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      Subroutine FckDst(TwoHam,nDens,Fij,iBas,jBas,iCmp,jCmp,
     &                  ikop1,ikop2,Irrep,
     &                  Shij,iAO1,iAO2,iAOst1,iAOst2,fact)
      use Symmetry_Info, only: nIrrep, iChTbl, iOper
      use SOAO_Info, only: iAOtSO, nSOInf
      use Basis_Info, only: nBas
      Implicit Real*8 (a-h,o-z)
      integer jirr(0:7)
*
#include "real.fh"
*
      Real*8 Fij(0:iBas-1,0:jBas-1,iCmp,jCmp),TwoHam(nDens)
      Integer iPnt(0:7)
      Logical Shij
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*
      iChO=iOper(Irrep)
      If (iChO.eq.0) Then
*
         iPntij = 0
         Do iIrrep = 0, nIrrep-1
            iPnt(iIrrep) = iPntij
            ipntij = ipntij+nBas(iIrrep)*(nBas(iIrrep)+1)/2
         End Do
*
*-----Distribute contributions from the intermediate skeleton
*     Fock matrix onto the symmetry adapted Fock matrix.
*
         iiR = NrOpr(iEor(ikOp1,ikOp2))
         Do i1 = 1, iCmp
          Do i2 = 1, jCmp
           Do iIrrep = 0, nIrrep-1
            If (Max(iAO1+i1,iAO2+i2)>nSOInf) Then
               Write (6,*) 'Fckdst: Max(iSO.jSO)>nSOInf (1)'
               Call Abend()
            End If
            iSO=iAOtSO(iAO1+i1,iIrrep)+iAOst1
            jSO=iAOtSO(iAO2+i2,iIrrep)+iAOst2
            XR = DBLE(iChTbl(iIrrep,iiR))
*
            If (iSO<0 .or. jSO<0) Cycle
*
            ipntij = iPnt(iIrrep)
            Do jAOj = 0, jBas-1
              Do iAOi = 0, iBas-1
                  Fac = XR
                  If (Shij .and. i1.eq.i2 .and.
     &                iAOi+iAOst1.eq.jAOj+iAOst2) Fac = Two*XR
                  jSOj = jSO + jAOj
                  iSOi = iSO + iAOi
                  ipFij = ipntij + iTri(iSOi,jSOj)
                  TwoHam(ipFij) = TwoHam(ipFij)
     &                          + Fact*Fac*Fij(iAOi,jAOj,i1,i2)
              End Do
            End Do

          End Do   ! iIrrep
         End Do    ! i2
        End Do     ! i1
*
      Else
*
         Do iIrrep=0,nIrrep-1
            jIrr(iIrrep)=
     &      NrOpr(iEOr(iOper(iIrrep),iChO))
         End Do
*
         iPntij = 0
         iPnt(0:nIrrep-1)=-1
         Do iIrrep = 0, nIrrep-1
            jIrrep=jIrr(iIrrep)
            If (iIrrep.gt.jIrrep) Then
               iPnt(iIrrep) = iPntij
               iPntij = iPntij+nBas(jIrrep)*nBas(iIrrep)
             End If
         End Do
*
*-----Distribute contributions from the intermediate skeleton
*     Fock matrix onto the symmetry adapted Fock matrix.
*
         l1=NrOpr(ikop1)
         l2=NrOpr(ikop2)
         Do 100 i1 = 1, iCmp
           Do 200 i2 = 1, jCmp
            Do iIrrep = 0, nIrrep-1
               jIrrep=jIrr(iIrrep)
               If (iIrrep.lt.jIrrep) Cycle
               X1 = DBLE(iChTbl(iIrrep,l1))
               X2 = DBLE(iChTbl(jIrrep,l2))
               X3 = DBLE(iChTbl(jIrrep,l1))
               X4 = DBLE(iChTbl(iIrrep,l2))
               If (Max(iAO1+i1,iAO2+i2)>nSOInf) Then
                  Write (6,*) 'Fckdst: Max(iSO.jSO)>nSOInf (2)'
                  Call Abend()
               End If
               iSOi=iAOtSO(iAO1+i1,iIrrep)+iAOst1
               jSOj=iAOtSO(iAO2+i2,jIrrep)+iAOst2
               jSOi=iAOtSO(iAO2+i2,iIrrep)+iAOst2
               iSOj=iAOtSO(iAO1+i1,jIrrep)+iAOst1
               If (iSOi>-1.and.jSOj>-1) Then
                  iPntij = iPnt(iIrrep)
                  Do jAO = 0, jBas-1
                     Do iAO = 0, iBas-1
                        Fac = X1*X2
                        ipF = iPntij
     &                      + (jSOj+jAO-1)*nBas(iIrrep)
     &                      + iSOi + iAO
                        TwoHam(ipF) = TwoHam(ipF)
     &                              + Fact*Fac*Fij(iAO,jAO,i1,i2)
                     End Do
                  End Do
               End If
               If (jSOi>-1.and.iSOj>-1) Then
                  ipntij = iPnt(iIrrep)
                  Do jAO = 0, jBas-1
                     Do iAO = 0, iBas-1
                        Fac = X3*X4
                        ipF = ipntij
     &                      + nBas(iIrrep)*(iSOj+iAO-1)
     &                      + jSOi + jAO
                        TwoHam(ipF) = TwoHam(ipF)
     &                              + Fact*Fac*Fij(iAO,jAO,i1,i2)
                     End Do
                  End Do
               End If
             End Do
 200       Continue
 100     Continue
*
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE get_pivot_idx_w(Diag,Wg,n,m,lu_A0,lu_A,iD_A,Scr,lScr,
     &                           Thr)
************************************************************************
*
*     Author:  F. Aquilante
*
*       Note:  this routine differs from Get_pivot_idx because here
*              the pivoting/convergence is decided based on weighted
*              diagonals
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Integer n, m, lu_A0, lu_A, iD_A(n), lScr
      Real*8  Diag(*), Wg(*), Scr(lScr)
#include "WrkSpc.fh"
#include "warnings.fh"
*
*
      Acc=Min(1.0D-12,thr*1.0D-2)
      Call GetMem('List','Allo','Inte',list,n)
      Do i=0,n-1
         iWork(list+i)=i+1
      End Do
*
      lmax=lScr-2*n
      If (lmax .lt. n) Then
         Call WarningMessage(2,'Error in Get_Pivot_idx_w')
         write(6,*) ' Get_Pivot_idx_w: too little scratch space!! '
         Call Quit(_RC_CHO_LOG_)
      Endif
*
      nMem_Col = Min(lmax/n,n)
*
      kAddr=0
      is=1+n
      ij = n*nMem_Col
      ks=is+ij
      kScr=lScr-n-ij
*
      m=0
      Do kCol = 1,n
*
         iD_Col=0
         XMax=0.0D0
         Do i=1,n
            If (Abs(Diag(i)*Wg(i)).gt.xMax+Acc) Then
               iD_Col=i
               xMax=Abs(Diag(i))
            End If
         End Do
         If (iD_Col.lt.0 .or. iD_Col.gt.n) Then
           Write(6,*) 'Get_Pivot_idx_w: Index of MaxDiag out of bounds!'
           Write(6,*) 'iD_Col = ',iD_Col
           Call Abend()
         ElseIf (iD_Col.eq.0) Then
           Go To 100
         End If
         iD_A(kCol) = iD_Col ! set the mapping
*
         js=n*(kCol-1)+is ! overlay A and Z
         If (kCol.gt.nMem_Col) js=1
*
         kAddr=n*(iD_Col-1)
         Call dDaFile(lu_A0,2,Scr(js),n,kAddr)
*
         Call CHO_FACTOR(Diag,Scr(js),iD_A,kCol,n,Scr(is),nMem_Col,lu_A,
     &                   Scr(ks),kScr,thr,lindep)
*
         If (lindep.ne.0) Goto 100
*
         iWork(list+iD_Col-1)=0
         m=m+1
*
         iAddr=n*(kCol-1)
         If (kCol.gt.nMem_Col) Call dDaFile(lu_A,1,Scr(1),n,iAddr)
*
      End Do
*
100   Continue
      iAddr=0
      Call dDaFile(lu_A,1,Scr(is),ij,iAddr)
*
      If (m.lt.n) Then
         istart=1
         Do k=m+1,n
            Do i=istart,n
               if (iWork(list+i-1).ne.0) Then
                  iD_A(k)=i
                  istart=i+1
                  goto 200
               endif
            End Do
200         Continue
         End Do
      ElseIf (m.gt.n) Then
         Write(6,*) 'Get_Pivot_idx_w: m > n is not possible!'
         Call Abend()
      EndIf
      Call GetMem('List','Free','Inte',list,n)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2016,2017, Roland Lindh                                *
************************************************************************
      SubRoutine GMFree()
************************************************************************
*                                                                      *
*     purpose: Deallocate work space at the end of calculation to check*
*              possible errors                                         *
*                                                                      *
*     called from: SCF                                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      use SCF_Arrays
      use Orb_Type
      Implicit Real*8 (a-h,o-z)
*
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
#ifdef _FDE_
      ! Thomas Dresselhaus
#include "embpotdata.fh"
#endif
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      nD = iUHF + 1
*
*---- Deallocate memory
      Call mma_deallocate(Darwin)
      Call mma_deallocate(MssVlc)
      Call mma_deallocate(KntE)
      Call mma_deallocate(EDFT)
      Call mma_deallocate(TwoHam)
      Call mma_deallocate(Vxc)
      Call mma_deallocate(Dens)
      Call mma_deallocate(OrbType)
      Call mma_deallocate(EOrb)
      Call mma_deallocate(OccNo)
      Call mma_deallocate(Fock)
      Call mma_deallocate(CMO)
      Call mma_deallocate(TrM)
*
      Call mma_deallocate(Lowdin)
      Call mma_deallocate(Ovrlp)
      Call mma_deallocate(OneHam)
      Call mma_deallocate(HDiag)
#ifdef _FDE_
      If (Allocated(Emb)) Call mma_deallocate(Emb)
#endif
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GETDREF(DREF,NDREF)

use Index_Functions, only: nTri_Elem
use PrintLevel, only: DEBUG
use caspt2_global, only: iPrGlb
use caspt2_module, only: NASHT, NG1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NDREF
real(kind=wp), intent(out) :: DREF(NDREF)
integer(kind=iwp) :: I, IJ
real(kind=wp), allocatable :: G1(:)

! Get active 1-el density matrix GAMMA1 and
! construct DREF in a tringular storage.

! Remember: NDREF=1 if NASHT=0.
DREF(:) = Zero

if (NASHT == 0) return
! Active 1-el density matrix:
call mma_allocate(G1,NG1,Label='G1')
call PT2_GET(NG1,'GAMMA1',G1)
do I=1,NASHT
  IJ = nTri_Elem(I-1)
  DREF(IJ+1:IJ+I) = G1(I:I+NASHT*(I-1):NASHT)
end do
call mma_deallocate(G1)

if (IPRGLB >= DEBUG) write(u6,*) ' GETDREF has constructed DREF.'

end subroutine GETDREF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine contf12 (wrk,wrksize)
c
c     this routine do
c     FI2   f1(a,e) <- -0.5 sum(m) [t1o(a,m) . fok(e,m)]
c
c     N.B. use and destroy: M1,M2
c
        use Para_Info, only: MyRank
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "parallel.fh"
#include "wrk.fh"
c
c     help variables
c
       integer rc,posst,ssc
c
c1    f1(a,e)aa <- sum(m-a) [T1o(a,m)aa . fok(e,m)aa]
c
cpar
      if (myRank.eq.idbaab) then
c
c1.1  map M1(m,e) <- fok(e,m)aa
       call map (wrk,wrksize,
     & 2,2,1,0,0,mapdfk3,mapifk3,1,mapdm1,mapim1,possm10,
     &           posst,rc)
c1.2  mult M2(a,e) = t1o(a,m)aa . M1(m,e)
       call mult (wrk,wrksize,
     & 2,2,2,1,mapdt11,mapit11,1,mapdm1,mapim1,1,mapdm2,
     &            mapim2,ssc,possm20,rc)
c1.3  add f1(a,e)aa <- -0.5 M2(a,e)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,-0.5d0,mapdm2,1,mapdf11,mapif11,1,rc)
c
       end if
c
c
c
c2    f1(a,e)bb <- sum(m-b) [T1o(a,m)bb . fok(e,m)bb]
c
cpar
      if (myRank.eq.idaabb) then
c
c2.1  map M1(m,e) <- fok(e,m)bb
       call map (wrk,wrksize,
     & 2,2,1,0,0,mapdfk4,mapifk4,1,mapdm1,mapim1,possm10,
     &           posst,rc)
c2.2  mult M2(a,e) = t1o(a,m)bb . M1(m,e)
       call mult (wrk,wrksize,
     & 2,2,2,1,mapdt12,mapit12,1,mapdm1,mapim1,1,mapdm2,
     &            mapim2,ssc,possm20,rc)
c2.3  add f1(a,e)bb <- -0.5 M2(a,e)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,-0.5d0,mapdm2,1,mapdf12,mapif12,1,rc)
c
        end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Per Ake Malmqvist                                *
************************************************************************
*****************************************************************
*  PROGRAM RASSI        PER-AAKE MALMQVIST
*  SUBROUTINE MKTDAB    IBM-3090 RELEASE 89 01 31
*  PURPOSE: CALCULATE TRANSITION DENSITY MATRIX FOR CI EXPANSIONS IN
*  BIORTHONORMAL ORBITAL BASES A AND B.
*****************************************************************
      SUBROUTINE MKTDAB(OVER,GAMMA1,TDMAB,iRC)
      use Constants, only: Zero, Two
      use Cntrl, only: LSYM1, LSYM2
      use Symmetry_Info, only: nSym=>nIrrep, MUL
      use rassi_data, only: NASHT,NTDMAB,NASH,NISH,NOSH
      IMPLICIT NONE
      REAL*8 OVER
      REAL*8 GAMMA1(NASHT,NASHT)
      REAL*8 TDMAB(NTDMAB)
      INTEGER iRC

      INTEGER IOFFA(8)
      INTEGER I, IOFFTD, ISY, II, IPOS, ISY12, ISY1, NO1, ISY2, NO2,
     &        NA1, NA2, NI1, NI2, IA, J, JA, JJ
      REAL*8, External:: DDot_
C IOFFA=NR OF ACTIVE ORBITALS IN PREVIOUS SYMMETRY BLOCKS.
      IOFFA(1)=0
      DO I=1,NSYM-1
        IOFFA(I+1)=IOFFA(I)+NASH(I)
      end do
C  INITIALIZE TRANSITION DENSITY MATRIX:
      TDMAB(:)=Zero
C CONTRIBUTION FROM INACTIVE ORBITALS:
      IF (LSYM1.EQ.LSYM2) THEN
         IF (OVER.NE.Zero) THEN
            IOFFTD=0
            DO ISY=1,NSYM
               II=0
               DO I=1,NISH(ISY)
                  II=II+1
                  IPOS=IOFFTD+(II-1)*NOSH(ISY)+II
                  TDMAB(IPOS)=Two*OVER
               end do
               IOFFTD=IOFFTD+NOSH(ISY)**2
            end do
         END IF
      END IF
C THEN ADD CONTRIBUTION FROM ACTIVE SPACE.
      ISY12=MUL(LSYM1,LSYM2)
      IOFFTD=0
      DO ISY1=1,NSYM
         NO1=NOSH(ISY1)
         IF(NO1.EQ.0) cycle
         ISY2=MUL(ISY1,ISY12)
         NO2=NOSH(ISY2)
         IF(NO2.EQ.0) cycle
         NA1=NASH(ISY1)
         if (NA1 /= 0) then
           NA2=NASH(ISY2)
           if (NA2 /= 0) then
             NI1=NISH(ISY1)
             NI2=NISH(ISY2)
             do I=1,NA1
               IA=IOFFA(ISY1)+I
               II=NI1+I
               do J=1,NA2
                 JA=IOFFA(ISY2)+J
                 JJ=NI2+J
                 IPOS=IOFFTD+II+(JJ-1)*NO1
                 TDMAB(IPOS)=GAMMA1(IA,JA)
               end do
             end do
           end if
         end if
      IOFFTD=IOFFTD+NO1*NO2
      end do
*
      iRC=1
      If (DDot_(nTDMAB,TDMAB,1,TDMAB,1).le.Zero) iRC=0

      END SUBROUTINE MKTDAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*  Sl_Grad
*
*> @brief
*>   This subroutine is taken from the Anders program called Diffsph that calculates
*>   the Coulombic interaction between two Slater-type densities
*> @author A. Ohrn
*> @modified_by Jose
*>
*> @details
*> The subroutine (originally called ``Coulomb``) is taken and simplified
*> to QmStat purposes. Molecule A is going to be always the Solvent
*> Molecule and Molecule B the Quantum system. The subroutine is
*> writen for one center in the QM system, so it is called for each
*> center of the QM, and gives the Potential, Field and Field gradient
*> generated by all centers of the classical molecule in this center of the
*> QM molecule but considering the penetration. The original subroutine is for
*> classical molecules with as S (charge) slater distribution and a P
*> (dipole) distribution and it is not ready for Qmstat purposes.
*> Quantum molecule is represented up to \f$ L = 2 \f$. Interaction with
*> Multipole distributed Quadrupoles can be treated using an S
*> distribution in the clasical molecules. However a ``Logical``
*> variable is introduced to avoid the evaluation of this
*> iteraction and perform (in QmStat) less cumbersome calculations
*> using point charges in the classical molecule.
*>
*> This subroutine works with the Molcas order for the quadrupoles
*> \f$ xx=1 \f$, \f$ xy=2 \f$, \f$ xz=3 \f$, \f$ yy=4 \f$, \f$ yz=5 \f$ and \f$ zz=6 \f$
*> So the \p EintSl have to be changed outside the subroutine
*> to be adapted to the QmStat order
*> \f$ xx=1 \f$, \f$ xy=2 \f$, \f$ yy=3 \f$, \f$ xz=4 \f$, \f$ yz=5 \f$ and \f$ zz=6 \f$
*> The subroutine has the parameter \c MxMltp that should be
*> changed if higher multipoles are included.
************************************************************************
      Subroutine Sl_Grad(nCentA,lMaxA,Coord,Dist,DInv
     &                  ,ExpoA,FactorA,SlPA,lMaxB,ExpoB,dNeigh
     &                  ,EintSl,EintSl_Nuc,lAtom)
      Implicit Real*8 (a-h,o-z)

#include "warnings.fh"

      Parameter (MxMltp=2,MxK=(MxMltp*(MxMltp**2+6*MxMltp+11)+6)/6)

      Dimension Coord(3,nCentA),Dist(nCentA),DInv(nCentA)
      Dimension FactorA(4,nCentA),ExpoA(2,nCentA)
      Dimension SlPA(nCentA),ExpoB(MxMltp+1)

      Dimension EintSl(MxK),Colle(3)
      Dimension TMPA((MxMltp+1)*(MxMltp+2)/2)
      Dimension Rotte(3,3),v(3),TR(6,6)

      Logical lDiffA,lDiffB,lTooSmall,lAtom


*-- Some zeros.
      Do ijhr=1,MxK
        EintSl(ijhr)=0.0d0
      End do
      EintSl_Nuc=0.0d0

*
*-- Loop over all centers in molecule A.
*
      Do iCA=1,nCentA
        v(1)=Coord(1,iCA)
        v(2)=Coord(2,iCA)
        v(3)=Coord(3,iCA)
        R=Dist(iCA)
        Rinv=DInv(iCA)

*
*---- Obtain rotation matrix.
*
        Call Revolution(v,Rinv,Rotte)

*--------- Obtain the Matrix used to transform the Quadrupoles
*          This 6x6 matrix is really 6 matrix of 3x3 in diagonal form
*          Each element of each matrix gives the contribution from the
*          old quadrupole to the new quadrupole (new coordinate system)
*          Thus, if xx=1, xy=2, xz=3, yy=4, yz=5 and zz=6
*          QNew(1)=Qold(1)*TD(1,1)+Qold(2)*TD(1,2)+Qold(3)+TD(1,3)+...
*          So, to get field gradient for xx from the sigma interaction
*          (see Anders paper) we have
*          FG(xx)=FGSigma*(TD(6,1)-0.5(TD(1,1)*TD(4,1))) . Remember that
*          the Energy contribution in sigma is calculated using spherical
*          armonics so ESigma=FGSigma(Qnew(6)-0.5(Qnew(1)+Qnew(4)))
*
        Call M2Trans(Rotte,TR)
*
*---- Loop over centres on A. Suck out exponents, factors and
*     point-part. Rotate multipole.
*
        Do iLA=0,lMaxA
          EA=ExpoA(iLA+1,iCA)
          lDiffA=EA.gt.-1.0d0
          nS=iLA*(iLA+1)*(iLA+2)/6
          nT=(iLA+1)*(iLA+2)*(iLA+3)/6
          kaunt=0
          Do kComp=nS+1,nT
            kaunt=kaunt+1
            TMPA(kaunt)=FactorA(kComp,iCA)
          Enddo
*
*------ Rotate and go over to spherical representation.
*
          Sigge=-1.0d0
          Call Rotation_qmstat(iLA,TMPA,Rotte,Sigge)

*
*------- Jose. Only one center in B so not loop over centres on B.
*              Not Suck out Factors since we do not use them here.
*

          Do iLB=0,lMaxB
            EB=ExpoB(iLB+1)
            lDiffB=EB.gt.-1.0d0
*
*-------- There is not rotation of Multipoles in B since we do not use them.
*

*
*---- ELECTRON--ELECTRON.
*
*
*------ Both diffuse.
*
            EAp=0.5d0*EA
            EBp=0.5d0*EB
            If(lDiffA.and.lDiffB) then
              Call TKP(Tau,dKappa,Rho,RhoA,RhoB,EAp,EBp,R
     &                ,dNeigh,lTooSmall)
              Call ABBoth(iLA,iLB,TMPA
     &                   ,Tau,dKappa,Rho,RhoA,RhoB
     &                   ,Rinv,lTooSmall,Colle)
              If(iLB.eq.0) then
                  EintSl(1)=EintSl(1)+Colle(1)
              Else             ! if iLB not 0 then it is 1
                If(iLA.eq.0) then
                  Do ijhr=1,3
                    EintSl(ijhr+1)=EintSl(ijhr+1)
     &                          +Colle(1)*Rotte(3,ijhr)
                  End do
                Else          ! if iLA is not 0 is 1
                  Do ijhr=1,3
                    EintSl(ijhr+1)=EintSl(ijhr+1)
     &              +Colle(1)*Rotte(3,ijhr)+Colle(2)*Rotte(1,ijhr)
     &              +Colle(3)*Rotte(2,ijhr)
                  End do
                Endif
              Endif
*
*------ One diffuse, one not diffuse.
*
            ElseIf(lDiffA.and..not.lDiffB) then
              Call ABOne(iLA,iLB,TMPA
     &                  ,EAp,R,Rinv,Colle,lDiffA)
              If(iLB.eq.0) then
                EintSl(1)=EintSl(1)+Colle(1)
              ElseIf(iLB.eq.1) then
                If(iLA.eq.0) then
                  Do ijhr=1,3
                    EintSl(ijhr+1)=EintSl(ijhr+1)
     &                          +Colle(1)*Rotte(3,ijhr)
                  End do
                Else       ! if iLA not 0 then it is 1
                  Do ijhr=1,3
                    EintSl(ijhr+1)=EintSl(ijhr+1)
     &              +Colle(1)*Rotte(3,ijhr)
     &              +Colle(2)*Rotte(1,ijhr)
     &              +Colle(3)*Rotte(2,ijhr)
                  End do
                Endif
              ElseIf(iLB.eq.2) then
                If(iLA.eq.0) then
                  Do ijhr=1,6            ! Remember Qsigma=z2-0.5(x2+y2)
                    EintSl(ijhr+4)=EintSl(ijhr+4)
     &                   +Colle(1)*(TR(6,ijhr)-0.5d0*(TR(1,ijhr)
     &                   +TR(4,ijhr)))
                  End do
                Else              ! if iLA not 0 then it is 1
                  Do ijhr=1,6            ! Remember Qsigma=z2-0.5(x2+y2)
                                         ! QPi1=sqrt(3)*xz
                                         ! QPi2=sqrt(3)*yz
                    EintSl(ijhr+4)=EintSl(ijhr+4)
     &                +Colle(1)*(TR(6,ijhr)-0.5d0*(TR(1,ijhr)
     &                +TR(4,ijhr)))
     &                +Colle(2)*sqrt(3.0d0)*TR(3,ijhr)
     &                +Colle(3)*sqrt(3.0d0)*TR(5,ijhr)
                  End do
                Endif
              Endif

            ElseIf(.not.lDiffA.and.lDiffB) then
              Call ABOne(iLB,iLA,TMPA
     &                  ,EBp,R,Rinv,Colle,lDiffA)

              If(iLB.eq.0) then
                EintSl(1)=EintSl(1)+Colle(1)
              Else            ! if iLB not 0 then it is 1
                If(iLA.eq.0) then
                  Do ijhr=1,3
                    EintSl(ijhr+1)=EintSl(ijhr+1)
     &                          +Colle(1)*Rotte(3,ijhr)
                  End do
                Else      ! is the same for iLA 1 and 2
                          ! because both have sigma pi1 and pi2
                          ! components regarding to B
                  Do ijhr=1,3
                    EintSl(ijhr+1)=EintSl(ijhr+1)
     &              +Colle(1)*Rotte(3,ijhr)
     &              +Colle(2)*Rotte(1,ijhr)
     &              +Colle(3)*Rotte(2,ijhr)
                  End do
                Endif
              Endif
*
*------ Neither diffuse.
*
            ElseIf(.not.lDiffA.and..not.lDiffB) then
              Call ABNone(iLA,iLB,TMPA,Rinv,Colle)

              If(iLB.eq.0) then
                EintSl(1)=EintSl(1)+Colle(1)
              ElseIf(iLB.eq.1) then
                If(iLA.eq.0) then
                  Do ijhr=1,3
                    EintSl(ijhr+1)=EintSl(ijhr+1)
     &                          +Colle(1)*Rotte(3,ijhr)
                  End do
                Else      ! is the same for iLA 1 or 2
                  Do ijhr=1,3
                    EintSl(ijhr+1)=EintSl(ijhr+1)
     &              +Colle(1)*Rotte(3,ijhr)
     &              +Colle(2)*Rotte(1,ijhr)
     &              +Colle(3)*Rotte(2,ijhr)
                  End do
                Endif
              ElseIf(iLB.eq.2) then
                If(iLA.eq.0) then
                  Do ijhr=1,6            ! Remember Qsigma=z2-0.5(x2+y2)
                    EintSl(ijhr+4)=EintSl(ijhr+4)
     &                   +Colle(1)*(TR(6,ijhr)-0.5d0*(TR(1,ijhr)
     &                   +TR(4,ijhr)))
                  End do
                ElseIf(iLA.eq.1) then
                  Do ijhr=1,6            ! Remember Qsigma=z2-0.5(x2+y2)
                                         ! QPi1=sqrt(3)*xz
                                         ! QPi2=sqrt(3)*yz
                    EintSl(ijhr+4)=EintSl(ijhr+4)
     &                +Colle(1)*(TR(6,ijhr)-0.5d0*(TR(1,ijhr)
     &                +TR(4,ijhr)))
     &                +Colle(2)*sqrt(3.d0)*TR(3,ijhr)
     &                +Colle(3)*sqrt(3.0d0)*TR(5,ijhr)
                  End do

*------------------Jose. This will be for a d-d interaction
C                  ElseIf(iLA.eq.2) then
C                    Do ijhr=1,6         ! Remember Qsigma=z2-0.5(x2+y2)
C                                        ! QPi1=sqrt(3)*xz
C                                        ! QPi2=sqrt(3)*yz
C                                        ! Del1=sqrt(3)*xy
C                                        ! Del2=0.5*sqrt(3)*(x2-y2)
C                      EintSl(ijhr+4)=EintSl(ijhr+4)
C     &                  +Colle(1)*(TR(6,ijhr)-0.5d0*(TR(1,ijhr)
C     &                  +TR(4,ijhr)))+Colle(2)*sqrt(3.d0)*TR(3,ijhr)
C     &                  +Colle(3)*sqrt(3.0d0)*TR(5,ijhr)
C     &                  +Colle(4)*sqrt(3.0d0)*TR(2,ijhr)
C     &                  +Colle(5)*0.5d0*sqrt(3.0d0)*(TR(1,ijhr)
C     &                  -TR(4,ijhr))
C                    End do
*------------------
                Endif
              Endif

            Endif
          Enddo

*
*---- ELECTRON--POINT.
*
*------ Point on centre B.
* Jose. Potential, Field and Field Gradient of Multipole
* distribution in A on B (to obtain nuclear interaction in B)
*
          If(lAtom) then
            If(lDiffA) then
              Call ABOne(iLA,0,TMPA,EAp,R,Rinv,Colle,lDiffA)
              EintSl_Nuc=EintSl_Nuc+Colle(1)
            Else
              Call ABNone(iLA,0,TMPA,Rinv,Colle)
               EintSl_Nuc=EintSl_Nuc+Colle(1)
            Endif
          Endif

*

        Enddo

*---- ELECTRON--POINT.
*
*------ Point on centre A.
* Jose. Potential, Field and Field Gradient of nuclear
* charge in A on the B sites
*
        If(SlPA(iCA).gt.1.0d-8)then
          Do iLB=0,lMaxB
            EB=ExpoB(iLB+1)
            lDiffB=EB.gt.-1.0d0
            EBp=0.5d0*EB

            If(lDiffB) then
              Call ABOne(iLB,0,SlPA(iCA)
     &                  ,EBp,R,Rinv,Colle,.false.)
            Else
              Call ABNone(0,iLB,SlPA(iCA)
     &                     ,Rinv,Colle)
            Endif
            If(iLB.eq.0) then
              EintSl(1)=EintSl(1)+Colle(1)
            ElseIf(iLB.eq.1) then
              Do ijhr=1,3
                EintSl(ijhr+1)=EintSl(ijhr+1)
     &                      +Colle(1)*Rotte(3,ijhr)
              End do
            ElseIf(iLB.eq.2) then
              Do ijhr=1,6               ! Remember Qsigma=z2-0.5(x2+y2)
                EintSl(ijhr+4)=EintSl(ijhr+4)
     &               +Colle(1)*(TR(6,ijhr)-0.5d0*(TR(1,ijhr)
     &               +TR(4,ijhr)))
              End do
            Endif
          End do

*
*---- POINT--POINT.
* Jose. Potential of nuclear charge in A on B
* (to obtain nuclear interaction in B)
          If(lAtom) then
            Call ABNone(0,0,SlPA(iCA),Rinv,Colle)
             EintSl_Nuc=EintSl_Nuc+Colle(1)
          Endif
        Endif

      Enddo

      Return
      End


*
*-- Construct rotation matrix.
*
      Subroutine Revolution(v,Rinv,Rotte)
      Implicit Real*8 (a-h,o-z)

      Dimension v(3),Rotte(3,3)
      Dimension u(3),w(3),t(3)

*
*-- Obtain base-vectors for the plane to which v in the normal vector.
*
      Call PlaneVectors(u,w,v,Rinv)

*
*-- Normalize v.
*
      t(1)=Rinv*v(1)
      t(2)=Rinv*v(2)
      t(3)=Rinv*v(3)

*
*-- Assemble rotation matrix
*
      Rotte(1,1)=u(1)
      Rotte(1,2)=u(2)
      Rotte(1,3)=u(3)
      Rotte(2,1)=w(1)
      Rotte(2,2)=w(2)
      Rotte(2,3)=w(3)
      Rotte(3,1)=t(1)
      Rotte(3,2)=t(2)
      Rotte(3,3)=t(3)

      Return
      End


*
*-- Rotate multipole.
*
      Subroutine Rotation_qmstat(iL,dMul,Rotte,Sigge)
      Implicit Real*8 (a-h,o-z)

      Parameter (MxMltp=2)

      Dimension dMul((MxMltp+1)*(MxMltp+2)/2),Rotte(3,3)
      Dimension dMTrans(6),TD(6,6)

*
*-- Charge, trivial to rotate.
*
      If(iL.eq.0) then
        dMul(1)=dMul(1)
*
*-- Dipole, transforms as a vector. Sigge controls that if the
*   multipole is located not in origin, but at the other end,
*   i.e. molecule A, then any odd occurrence of z should be
*   mirrored. Applies for the quadrupole as well, see below.
*
      ElseIf(iL.eq.1) then
        d1=dMul(1)
        d2=dMul(2)
        d3=dMul(3)
        dMul(1)=Rotte(1,1)*d1+Rotte(1,2)*d2+Rotte(1,3)*d3
        dMul(2)=Rotte(2,1)*d1+Rotte(2,2)*d2+Rotte(2,3)*d3
        dMul(3)=Rotte(3,1)*d1+Rotte(3,2)*d2+Rotte(3,3)*d3
        dMul(1)=dMul(1)
        dMul(2)=dMul(2)
        dMul(3)=Sigge*dMul(3)
*
*-- Quadrupole, transforms as a quadratic form. Also, transform
*   to spherical representation.
*
      ElseIf(iL.eq.2) then
*
*---- Compute the transformation matrix for second-moments.
*
        Call M2Trans(Rotte,TD)
*
*---- Transform. Sigge is explained above.
*
        Do i=1,6
          dMTrans(i)=0.0d0
          Do j=1,6
            dMTrans(i)=dMTrans(i)+TD(i,j)*dMul(j)
          Enddo
        Enddo
        Do i=1,6
          Sig=1.0d0
          If(i.eq.3.or.i.eq.5)Sig=Sigge
          dMul(i)=dMTrans(i)*Sig
        Enddo
*
*---- Go to spherical representation.
*
        Call Spherical(dMul)
      Else
        Write(6,*)'Nope!, Error in sl_grad'
        Call Quit(_RC_IO_ERROR_READ_)
      Endif

      Return
      End


*
*-- Routine for the case where both centres are diffuse. Since these
*   formulas are pretty nasty and apparently with little general
*   structure, each type of interaction is hard-coded.
*
      Subroutine ABBoth(iLA,iLB,dMulA
     &                 ,Tau,dKappa,Rho,RhoA,RhoB
     &                 ,Rinv,lTooSmall,Colle)
      Implicit Real*8 (a-h,o-z)

      Parameter (MxMltp=2)

      Dimension dMulA((MxMltp+1)*(MxMltp+2)/2),Colle(3)

      Logical lTooSmall

*-- To calculate the interaction Sigma is the product of both multipoles
*   in A and in B but since we need potential, field and field gradient
*   for the QM system whe do not multiply for multipoles in B, but we
*   have to take into account to move the result for the original
*   coordinate system in QmStat.
*
      Do i=1,3
        Colle(i)=0.0d0
      End do
*
*-- s-s interaction. There is only sigma-components, hence simple.
*
      If(iLA.eq.0.and.iLB.eq.0) then
        Sigma=dMulA(1)
        If(lTooSmall) then
          Ex=Exp((-2.0d0)*Rho)
          Colle(1)=Sigma*CoulT0_1(Rho,Rinv,Ex)
        Else
          ExA=Exp((-2.0d0)*RhoA)
          ExB=Exp((-2.0d0)*RhoB)
          Colle(1)=Sigma*CoulTN_1(RhoA,RhoB,dKappa,Rinv,ExA,ExB)
        Endif

*
*-- s-p interaction. Only the z-component of the dipole interacts
*   through a sigma-interaction with the s-distribution. Observe
*   that in the case that iLA.gt.iLB, then the formulas by Roothan
*   has to be reversed, i.e. RhoA and RhoB change place and
*   Tau and Kappa changes sign.
*
      ElseIf(iLA.eq.1.and.iLB.eq.0) then
        Sigma=dMulA(3)
        If(lTooSmall) then
          Ex=Exp((-2.0d0)*Rho)
          Colle(1)=Sigma*CoulT0_2(Rho,Rinv,Ex)
        Else
          ExA=Exp((-2.0d0)*RhoA)
          ExB=Exp((-2.0d0)*RhoB)
          Colle(1)=Sigma*CoulTN_2(Rho,-Tau,RhoB,RhoA,-dKappa,Rinv
     &             ,ExB,ExA)
        Endif
      ElseIf(iLA.eq.0.and.iLB.eq.1) then
        Sigma=dMulA(1)
        If(lTooSmall) then
          Ex=Exp((-2.0d0)*Rho)
          Colle(1)=Sigma*CoulT0_2(Rho,Rinv,Ex)
        Else
          ExA=Exp((-2.0d0)*RhoA)
          ExB=Exp((-2.0d0)*RhoB)
          Colle(1)=Sigma*CoulTN_2(Rho,Tau,RhoA,RhoB,dKappa,
     &             Rinv,ExA,ExB)
        Endif

*
*-- p-p interaction. The z-z combination gives a sigma-interaction,
*   and the x-x and y-y combinations give pi-interactions.
*
      ElseIf(iLA.eq.1.and.iLB.eq.1) then
*
*-- The sigma-component.
*
        Sigma=dMulA(3)
        If(lTooSmall) then
          Ex=Exp((-2.0d0)*Rho)
          Colle(1)=Sigma*CoulT0_4(Rho,Rinv,Ex)
        Else
          ExA=Exp((-2.0d0)*RhoA)
          ExB=Exp((-2.0d0)*RhoB)
          Colle(1)=Sigma*CoulTN_4(Rho,Tau,RhoA,RhoB,dKappa
     &             ,Rinv,ExA,ExB)
        Endif
*
*-- The two pi-components.
*
        Pi1=dMulA(1)
        Pi2=dMulA(2)
        If(lTooSmall) then
          Ex=Exp((-2.0d0)*Rho)
          Width=CoulT0_5(Rho,Rinv,Ex)
          Colle(2)=Pi1*Width
          Colle(3)=Pi2*Width
        Else
          ExA=Exp((-2.0d0)*RhoA)
          ExB=Exp((-2.0d0)*RhoB)
          Width=CoulTN_5(Rho,Tau,RhoA,RhoB,dKappa,Rinv,ExA,ExB)
          Colle(2)=Pi1*Width
          Colle(3)=Pi2*Width
        Endif

*
*-- Higher angular momentum interactions.
*
      Else
        Write(6,*)'Too high angular momentum'
        Write(6,*)'at least you start to implement.'
        Call Quit(_RC_IO_ERROR_READ_)
      Endif

      Return
      End

*
*-- One diffuse, the other not diffuse.
*
      Subroutine ABOne(iLdiff,iLpoi,dMul
     &                ,Ep,R,Rinv,Colle,lDiffA)
      Implicit Real*8 (a-h,o-z)

      Parameter (MxMltp=2)

      Dimension dMul((MxMltp+1)*(MxMltp+2)/2),Colle(3)
      Logical lDiffA

*
*-- The omnipresent exponential and distance-exponent product.
*
       er=Ep*R
       Ex=Exp((-2.0d0)*er)
       d3=sqrt(3.0d0)
       Do i=1,3
         Colle(i)=0.0d0
       End do

*
*-- s-s; see ABBoth for comments on sigma and similar below.
*
       If(iLdiff.eq.0.and.iLpoi.eq.0) then
         Sigma=dMul(1)
         DAMP=(1.0d0+er)*Ex
         Colle(1)=Sigma*Rinv*(1.0d0-DAMP)

*
*-- s-p
*
       ElseIf(iLdiff.eq.0.and.iLpoi.eq.1) then
         Sigma=dMul(3)
         If(lDiffA) then
          Sigma=dMul(1)
         End If
         DAMP=(1.0d0+2.0d0*er+2.0d0*er**2)*Ex
         Colle(1)=Sigma*Rinv**2*(1.0d0-DAMP)

*
*-- s-d
*
       ElseIf(iLdiff.eq.0.and.iLpoi.eq.2) then
         Sigma=dMul(3)
         If(lDiffA) then
          Sigma=dMul(1)
         End If
         DAMP=(1.0d0+2.0d0*er+2.0d0*er**2+4.0d0*er**3/3.0d0)*Ex
         Colle(1)=Sigma*Rinv**3*(1.0d0-DAMP)

*
*-- p-s
*
       ElseIf(iLdiff.eq.1.and.iLpoi.eq.0) then
         Sigma=dMul(1)
         If(lDiffA) then
          Sigma=dMul(3)
         End If
         DAMP=(1.0d0+2.0d0*er+2.0d0*er**2+er**3)*Ex
         Colle(1)=Sigma*Rinv**2*(1.0d0-DAMP)

*
*-- p-p
*
       ElseIf(iLdiff.eq.1.and.iLpoi.eq.1) then
         Sigma=dMul(3)
         Pi1=dMul(1)
         Pi2=dMul(2)
         DAMP=(1.0d0+2.0d0*er+2.0d0*er**2+3.0d0*er**3/2.0d0+er**4)*Ex
         Colle(1)=2.0d0*Sigma*Rinv**3*(1.0d0-DAMP)
         DAMP=(1.0d0+2.0d0*er+2.0d0*er**2+er**3)*Ex
         Colle(2)=Pi1*Rinv**3*(1.0d0-DAMP)
         Colle(3)=Pi2*Rinv**3*(1.0d0-DAMP)

*
*-- p-d
*
       ElseIf(iLdiff.eq.1.and.iLpoi.eq.2) then
         Sigma=dMul(3)
         Pi1=dMul(2)
         Pi2=dMul(4)
         If(lDiffA) then
          Pi1=dMul(1)
          Pi2=dMul(2)
         End If
         DAMP=(1.0d0+2.0d0*er+2.0d0*er**2+4.0d0*er**3/3.0d0
     &        +2.0d0*er**4/3.0d0+4.0d0*er**5/9.0d0)*Ex
         Colle(1)=3.0d0*Sigma*Rinv**4*(1.0d0-DAMP)
         DAMP=(1.0d0+2.0d0*er+2.0d0*er**2+4.0d0*er**3/3.0d0
     &        +2.0d0*er**4/3.0d0)*Ex
         Colle(2)=d3*Pi1*Rinv**4*(1.0d0-DAMP)
         Colle(3)=d3*Pi2*Rinv**4*(1.0d0-DAMP)
c        Colle=Colle1+Colle2+Colle3

*
*-- Higher moments.
*
       Else
         Write(6,*)
         Write(6,*)'Too high momentum!'
         Call Quit(_RC_IO_ERROR_READ_)
       Endif

       Return
       End


*
*-- All points. A bunch of special cases, see ABOne and ABBoth for
*   more details.
*
      Subroutine ABNone(iLA,iLB,dMulA
     &                 ,Rinv,Colle)
      Implicit Real*8 (a-h,o-z)

      Parameter (MxMltp=2)

      Dimension dMulA((MxMltp+1)*(MxMltp+2)/2)
      Dimension Colle(3)

      Do i=1,3
        Colle(i)=0.0d0
      End do

      If(iLA.eq.0) then
        If(iLB.eq.0) then
          Sigma=dMulA(1)
          Colle(1)=Sigma*Rinv
        ElseIf(iLB.eq.1) then
          Sigma=dMulA(1)
          Colle(1)=Sigma*Rinv**2
        ElseIf(iLB.eq.2) then
          Sigma=dMulA(1)
          Colle(1)=Sigma*Rinv**3
        Endif
      ElseIf(iLA.eq.1) then
        If(iLB.eq.0) then
          Sigma=dMulA(3)
          Colle(1)=Sigma*Rinv**2
        ElseIf(iLB.eq.1) then
          Sigma=dMulA(3)
          Pi1=dMulA(1)
          Pi2=dMulA(2)
          Colle(1)=2.0d0*Sigma*(Rinv**3)
          Colle(2)=Pi1*(Rinv**3)
          Colle(3)=Pi2*(Rinv**3)
        ElseIf(iLB.eq.2) then
          d3=sqrt(3.0d0)
          Sigma=dMulA(3)
          Pi1=dMulA(1)
          Pi2=dMulA(2)
          Colle(1)=3.0d0*Sigma*(Rinv**4)
          Colle(2)=d3*Pi1*(Rinv**4)
          Colle(3)=d3*Pi2*(Rinv**4)
        Endif

C Jose* This is for Quadrupoles in Classical. We do not use in QmStat.
*--------------------------------------
C      ElseIf(iLA.eq.2) then
C        If(iLB.eq.0) then
C          Sigma=dMulA(3)
C          Colle(1)=Sigma*Rinv**3
C        ElseIf(iLB.eq.1) then
C          d3=sqrt(3.0d0)
C          Sigma=dMulA(3)
C          Pi1=dMulA(2)
C          Pi2=dMulA(4)
C          Colle(1)=3.0d0*Sigma*(Rinv**4)
C          Colle(2)=d3*Pi1*(Rinv**4)
C          Colle(3)=d3*Pi2*(Rinv**4)
C        ElseIf(iLB.eq.2) then
C          Sigma=dMulA(3)
C          Pi1=dMulA(2)
C          Pi2=dMulA(4)
C* Jose. Remember dMulB(1)=sqrt(3)*xy
C* and dMulB(5)=0.5*sqrt(3)*(x2-y2)
C          Del1=dMulA(1)
C          Del2=dMulA(5)
C          Colle(1)=6.0d0*Sigma*(Rinv**5)
C          Colle(2)=4.0d0*Pi1*(Rinv**5)
C          Colle(3)=4.0d0*Pi2*(Rinv**5)
C          Colle(4)=Del1*(Rinv**5)
C          Colle(5)=Del2*(Rinv**5)
C        Endif
*--------------------------------------
      Endif

      Return
      End


*
*-- s-s interaction, with too small exponent difference.
*
      Real*8 Function CoulT0_1(Rho,dSepInv,Expo)
      Implicit Real*8 (a-h,o-z)

      T1=1.0d0
      T2=(11.0d0/8.0d0)*Rho
      T3=(3.0d0/4.0d0)*Rho**2
      T4=(1.0d0/6.0d0)*Rho**3
      CoulT0_1=dSepInv*(1.0d0-(T1+T2+T3+T4)*Expo)

      Return
      End

*
*-- s-s interaction, normal case.
*
      Real*8 Function CoulTN_1(RA,RB,C,dSepInv,ExpA,ExpB)
      Implicit Real*8 (a-h,o-z)

      T1=0.25d0*(2.0d0+C)
      T2=0.25d0*RA
      TA=(1.0d0-C)**2*(T1+T2)*ExpA
      T1=0.25d0*(2.0d0-C)
      T2=0.25d0*RB
      TB=(1.0d0+C)**2*(T1+T2)*ExpB
      CoulTN_1=dSepInv*(1.0d0-TA-TB)

      Return
      End

*
*-- s-p interaction, with too small exponent difference.
*
      Real*8 Function CoulT0_2(Rho,dSepInv,Expo)
      Implicit Real*8 (a-h,o-z)

      T1=1.0d0
      T2=2.0d0*Rho
      T3=2.0d0*Rho**2
      T4=(59.0d0/48.0d0)*Rho**3
      T5=(11.0d0/24.0d0)*Rho**4
      T6=(1.0d0/12.0d0)*Rho**5
      CoulT0_2=dSepInv**2*(1.0d0-(T1+T2+T3+T4+T5+T6)*Expo)

      Return
      End

*
*-- s-p interaction, normal case.
*
      Real*8 Function CoulTN_2(R,T,RA,RB,C,dSepInv,ExpA,ExpB)
      Implicit Real*8 (a-h,o-z)

      T1=(1.0d0/16.0d0)*(5.0d0+3.0d0*C)*(1.0d0+2.0d0*RA)
      T2=0.25d0*RA**2
      TA=(1.0d0-C)**3*(T1+T2)*ExpA
      T1=(1.0d0/16.0d0)*(11.0d0-10.0d0*C+3.0d0*C**2)*(1.0d0+2.0d0*RB)
      T2=0.5d0*(2.0d0-C)*RB**2
      T3=0.25d0*RB**3
      TB=(1.0d0+C)**2*(T1+T2+T3)*ExpB
      CoulTN_2=dSepInv**2*(1.0d0-TA-TB)

      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real(R)
        Call Unused_real(T)
      End If
      End

*
*-- p-p (sigma), with too small exponent difference.
*
      Real*8 Function CoulT0_4(Rho,dSepInv,Expo)
      Implicit Real*8 (a-h,o-z)

      T1=1.0d0
      T2=2.0d0*Rho
      T3=2.0d0*Rho**2
      T4=(263.0d0/192.0d0)*Rho**3
      T5=(71.0d0/96.0d0)*Rho**4
      T6=(77.0d0/240.0d0)*Rho**5
      T7=(1.0d0/10.0d0)*Rho**6
      T8=(1.0d0/60.0d0)*Rho**7
      CoulT0_4=2.0d0*dSepInv**3*(1.0d0-(T1+T2+T3+T4+T5+T6+T7+T8)*Expo)

      Return
      End

*
*-- p-p (sigma), normal case.
*
      Real*8 Function CoulTN_4(R,T,RA,RB,C,dSepInv,ExpA,ExpB)
      Implicit Real*8 (a-h,o-z)

      T1=(1.0d0/16.0d0)*(8.0d0+9.0d0*C+3.0d0*C**2)
     &                 *(1.0d0+2.0d0*RA+2.0d0*RA**2)
      T2=(3.0d0/16.0d0)*(3.0d0+2.0d0*C)*RA**3
      T3=(1.0d0/8.0d0)*RA**4
      TA=(1.0d0-C)**3*(T1+T2+T3)*ExpA
      T1=(1.0d0/16.0d0)*(8.0d0-9.0d0*C+3.0d0*C**2)
     &                 *(1.0d0+2.0d0*RB+2.0d0*RB**2)
      T2=(3.0d0/16.0d0)*(3.0d0-2.0d0*C)*RB**3
      T3=(1.0d0/8.0d0)*RB**4
      TB=(1.0d0+C)**3*(T1+T2+T3)*ExpB
      CoulTN_4=2.0d0*dSepInv**3*(1.0d0-TA-TB)

      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real(R)
        Call Unused_real(T)
      End If
      End

*
*-- p-p (pi), with too small exponent difference.
*
      Real*8 Function CoulT0_5(Rho,dSepInv,Expo)
      Implicit Real*8 (a-h,o-z)

      T1=1.0d0
      T2=2.0d0*Rho
      T3=2.0d0*Rho**2
      T4=(121.0d0/96.0d0)*Rho**3
      T5=(25.0d0/48.0d0)*Rho**4
      T6=(2.0d0/15.0d0)*Rho**5
      T7=(1.0d0/60.0d0)*Rho**6
      CoulT0_5=dSepInv**3*(1.0d0-(T1+T2+T3+T4+T5+T6+T7)*Expo)

      Return
      End

*
*-- p-p (pi), normal case.
*
      Real*8 Function CoulTN_5(R,T,RA,RB,C,dSepInv,ExpA,ExpB)
      Implicit Real*8 (a-h,o-z)

      T1=(1.0d0/16.0d0)*(8.0d0+9.0d0*C+3.0d0*C**2)*(1.0d0+2.0d0*RA)
      T2=(1.0d0/8.0d0)*(5.0d0+3.0d0*C)*RA**2
      T3=(1.0d0/8.0d0)*RA**3
      TA=(1.0d0-C)**3*(T1+T2+T3)*ExpA
      T1=(1.0d0/16.0d0)*(8.0d0-9.0d0*C+3.0d0*C**2)*(1.0d0+2.0d0*RB)
      T2=(1.0d0/8.0d0)*(5.0d0-3.0d0*C)*RB**2
      T3=(1.0d0/8.0d0)*RB**3
      TB=(1.0d0+C)**3*(T1+T2+T3)*ExpB
      CoulTN_5=dSepInv**3*(1.0d0-TA-TB)

      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real(R)
        Call Unused_real(T)
      End If
      End


*
*-- Compute some auxiliary numbers.
*
      Subroutine TKP(Tau,dKappa,Rho,RhoA,RhoB,EA,EB,R
     &              ,dNeigh,lTooSmall)
      Implicit Real*8 (a-h,o-z)


      Logical lTooSmall

      Tau=(EA-EB)/(EA+EB)
      Rho=0.5d0*(EA+EB)*R
      RhoA=(1+Tau)*Rho
      RhoB=(1-Tau)*Rho
      If(abs(Tau).gt.dNeigh) then
        dKappa=0.5d0*(Tau+1.0d0/Tau)
        lTooSmall=.false.
      Else
        lTooSmall=.true.
      Endif

      Return
      End


*
*-- Routine to give base vectors of the plane with v as normal.
*
      Subroutine PlaneVectors(u,w,v,Rinv)
      Implicit Real*8 (a-h,o-z)

      Dimension u(3),w(3),v(3),p(3)

*
*-- Construct an arbitrary normalized vector orthogonal to the v-vector.
*
      const=0.0d0
      Shitx=1.0d0
      Shity=0.0d0
      Shitz=0.0d0
1001  Continue
        p(1)=Shitx+1.0d0*const
        p(2)=Shity+0.5d0*const
        p(3)=Shitz-1.0d0*const
        Scal=p(1)*v(1)+p(2)*v(2)+p(3)*v(3)
        u(1)=p(1)-Scal*Rinv**2*v(1)
        u(2)=p(2)-Scal*Rinv**2*v(2)
        u(3)=p(3)-Scal*Rinv**2*v(3)
        If(abs(u(1)).lt.1d-6.and.
     &     abs(u(2)).lt.1d-6.and.
     &     abs(u(3)).lt.1d-6) then
          const=const+1.0d0
          Go To 1001
        Else
          Go To 1002
        Endif
1002  Continue
      dLu=sqrt(u(1)**2+u(2)**2+u(3)**2)
      u(1)=u(1)/dLu
      u(2)=u(2)/dLu
      u(3)=u(3)/dLu
*
*-- Construct the final pi-vector, which is orthogonal to the v-vector
*   and the recently constructed pi-vector.
*
      w(1)=Rinv*(u(2)*v(3)-u(3)*v(2))
      w(2)=Rinv*(u(3)*v(1)-u(1)*v(3))
      w(3)=Rinv*(u(1)*v(2)-u(2)*v(1))

      Return
      End


*
*-- Routine to generate the transformation for the second moments.
*
      Subroutine M2Trans(Rotte,TD)
      Implicit Real*8 (a-h,o-z)

      Dimension Rotte(3,3),TD(6,6)

*
*-- The transformation of x2.
*
      TD(1,1)=Rotte(1,1)*Rotte(1,1)
      TD(2,1)=Rotte(1,1)*Rotte(2,1)
      TD(3,1)=Rotte(1,1)*Rotte(3,1)
      TD(4,1)=Rotte(2,1)*Rotte(2,1)
      TD(5,1)=Rotte(2,1)*Rotte(3,1)
      TD(6,1)=Rotte(3,1)*Rotte(3,1)
*
*-- The transformation of xy.
*
      TD(1,2)=Rotte(1,1)*Rotte(1,2)+Rotte(1,2)*Rotte(1,1)
      TD(2,2)=Rotte(1,1)*Rotte(2,2)+Rotte(1,2)*Rotte(2,1)
      TD(3,2)=Rotte(1,1)*Rotte(3,2)+Rotte(1,2)*Rotte(3,1)
      TD(4,2)=Rotte(2,1)*Rotte(2,2)+Rotte(2,2)*Rotte(2,1)
      TD(5,2)=Rotte(2,1)*Rotte(3,2)+Rotte(2,2)*Rotte(3,1)
      TD(6,2)=Rotte(3,1)*Rotte(3,2)+Rotte(3,2)*Rotte(3,1)
*
*-- The transformation of xz.
*
      TD(1,3)=Rotte(1,1)*Rotte(1,3)+Rotte(1,3)*Rotte(1,1)
      TD(2,3)=Rotte(1,1)*Rotte(2,3)+Rotte(1,3)*Rotte(2,1)
      TD(3,3)=Rotte(1,1)*Rotte(3,3)+Rotte(1,3)*Rotte(3,1)
      TD(4,3)=Rotte(2,1)*Rotte(2,3)+Rotte(2,3)*Rotte(2,1)
      TD(5,3)=Rotte(2,1)*Rotte(3,3)+Rotte(2,3)*Rotte(3,1)
      TD(6,3)=Rotte(3,1)*Rotte(3,3)+Rotte(3,3)*Rotte(3,1)
*
*-- The transformation of y2.
*
      TD(1,4)=Rotte(1,2)*Rotte(1,2)
      TD(2,4)=Rotte(1,2)*Rotte(2,2)
      TD(3,4)=Rotte(1,2)*Rotte(3,2)
      TD(4,4)=Rotte(2,2)*Rotte(2,2)
      TD(5,4)=Rotte(2,2)*Rotte(3,2)
      TD(6,4)=Rotte(3,2)*Rotte(3,2)
*
*-- The transformation of yz.
*
      TD(1,5)=Rotte(1,2)*Rotte(1,3)+Rotte(1,3)*Rotte(1,2)
      TD(2,5)=Rotte(1,2)*Rotte(2,3)+Rotte(1,3)*Rotte(2,2)
      TD(3,5)=Rotte(1,2)*Rotte(3,3)+Rotte(1,3)*Rotte(3,2)
      TD(4,5)=Rotte(2,2)*Rotte(2,3)+Rotte(2,3)*Rotte(2,2)
      TD(5,5)=Rotte(2,2)*Rotte(3,3)+Rotte(2,3)*Rotte(3,2)
      TD(6,5)=Rotte(3,2)*Rotte(3,3)+Rotte(3,3)*Rotte(3,2)
*
*-- The transformation of z2.
*
      TD(1,6)=Rotte(1,3)*Rotte(1,3)
      TD(2,6)=Rotte(1,3)*Rotte(2,3)
      TD(3,6)=Rotte(1,3)*Rotte(3,3)
      TD(4,6)=Rotte(2,3)*Rotte(2,3)
      TD(5,6)=Rotte(2,3)*Rotte(3,3)
      TD(6,6)=Rotte(3,3)*Rotte(3,3)

      Return
      End

*
*-- Take higher multipole into spherical representation.
*
      Subroutine Spherical(dMul)
      Implicit Real*8 (a-h,o-z)

      Parameter (MxMltp=2)

      Dimension dMul((MxMltp+1)*(MxMltp+2)/2)

      d3=sqrt(3.0d0)
      x2=dMul(1)
      y2=dMul(4)
      z2=dMul(6)
      xy=dMul(2)
      xz=dMul(3)
      yz=dMul(5)
      dMul(1)=d3*xy
      dMul(2)=d3*xz
      dMul(3)=z2-0.5d0*(x2+y2)
      dMul(4)=d3*yz
      dMul(5)=0.5d0*d3*(x2-y2)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReaW4(W,Wa,aSGrp,bSGrp,cSGrp,dSGrp,LunAux)
! this routine does:
! Add W(a",b",c",d") <<- (a",b"|c",d") for any a",b",c",d"
! via reading records W4 (p">=q")>=(r">=s")
!
! Wa is an auxiliary file
!
! Structure of records:
! 1) only records for pSGrp>=qSGrp & rSGrp>=sSGrp & pqSGrp>=rsSGrp
!    exists
! 2) in individual records p">=q",r">=s" are stored
!    however p">=q")>=(r">=a") reduction is not yet used

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimSGrpa, DimSGrpbe
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: Wa(*), W(*)
integer(kind=iwp), intent(in) :: aSGrp, bSGrp, cSGrp, dSGrp, LunAux
integer(kind=iwp) :: abcdLen, abcdPerm, abLen, abPerm, abSGrp, cdLen, cdPerm, cdSGrp, dima, dimb, dimc, dimd, dimp, dimq, dimr, &
                     dims, i, pSGrp, qSGrp, rSGrp, sSGrp
character(len=10) :: LunName

! -------- part I - define basic parameters

!1 Def dima,dimb,dimc,dimc
dima = DimSGrpa(aSGrp)
dimb = DimSGrpbe(bSGrp)
dimc = DimSGrpa(cSGrp)
dimd = DimSGrpbe(dSGrp)

! In steps 2.1 - 2.3 also dimp-dims and pSGrp-sSGrp
!2.1 Def abPerm, abSGrp
if (aSGrp >= bSGrp) then
  abPerm = 0
  abSGrp = nTri_Elem(aSGrp-1)+bSGrp
  pSGrp = aSGrp
  qSGrp = bSGrp
  dimp = dima
  dimq = dimb
else
  abPerm = 1
  abSGrp = nTri_Elem(bSGrp-1)+aSGrp
  pSGrp = bSGrp
  qSGrp = aSGrp
  dimp = dimb
  dimq = dima
end if

!2.2 Def cdPerm, cdSGrp
if (cSGrp >= dSGrp) then
  cdPerm = 0
  cdSGrp = nTri_Elem(cSGrp-1)+dSGrp
  rSGrp = cSGrp
  sSGrp = dSGrp
  dimr = dimc
  dims = dimd
else
  cdPerm = 1
  cdSGrp = nTri_Elem(dSGrp-1)+cSGrp
  rSGrp = dSGrp
  sSGrp = cSGrp
  dimr = dimd
  dims = dimc
end if

!2.3 Def abcdPerm
if (abSGrp >= cdSGrp) then
  abcdPerm = 0
else
  abcdPerm = 1
  i = pSGrp
  pSGrp = rSGrp
  rSGrp = i
  i = qSGrp
  qSGrp = sSGrp
  sSGrp = i
  i = dimp
  dimp = dimr
  dimr = i
  i = dimq
  dimq = dims
  dims = i
end if

!3.1 Def abLen
if (aSGrp == bSGrp) then
  abLen = nTri_Elem(dima)
else
  abLen = dima*dimb
end if

!3.2 Def cdLen
if (cSGrp == dSGrp) then
  cdLen = nTri_Elem(dimc)
else
  cdLen = dimc*dimd
end if

!3.3 Def abcdLen
abcdLen = abLen*cdLen

! -------- part II - read proper integrals (pq|rs) from disc

!4 Def proper LunName
call MkNameV4(pSGrp,qSGrp,rSGrp,sSGrp,'W4',LunName)

!5 Read Wa(pqrs) - velka udalost
!open(unit=LunAux,file=LunName,form='unformatted')
call Molcas_BinaryOpen_Vanilla(LunAux,LunName)
call rea_chcc(LunAux,abcdLen,Wa)
close(LunAux)

! -------- part III - Upgrade W(a",b",c",d") from Wx(pqrs)
! symbolics used: [xy] means xy or yx

if (abcdPerm == 0) then
  ! case ([ab]|[cd])

  if ((abPerm == 0) .and. (cdPerm == 0)) then
    ! subcase (ab|cd)
    call DefW4abcd(W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)

  else if ((abPerm == 0) .and. (cdPerm == 1)) then
    ! subcase (ab|dc)
    call DefW4abdc(W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)

  else if ((abPerm == 1) .and. (cdPerm == 0)) then
    ! subcase (ba|cd)
    call DefW4bacd(W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)

  else
    ! subcase (ba|cd)
    call DefW4badc(W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)

  end if

else
  ! case ([cd]|[ab])

  if ((abPerm == 0) .and. (cdPerm == 0)) then
    ! subcase (cd|ab)
    call DefW4cdab(W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)

  else if ((abPerm == 0) .and. (cdPerm == 1)) then
    ! subcase (cd|ab)
    call DefW4dcab(W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)

  else if ((abPerm == 1) .and. (cdPerm == 0)) then
    ! subcase (cd|ba)
    call DefW4cdba(W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)

  else
    ! subcase (dc|ba)
    call DefW4dcba(W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)

  end if

end if

return

end subroutine ReaW4

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_boundary

   USE fmm_global_paras

   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_opt_near_field

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE verify_planes(grid,planes)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(IN)    :: grid(:)
      TYPE(fmm_planes),   INTENT(INOUT) :: planes

      REAL(REALK), PARAMETER :: THR = 1.0D-15
      INTEGER(INTK) :: i

      DO i = 1, SIZE(grid)
         IF ( ABS(grid(i)%cntr(1) - planes%xmin) > THR .AND.     &
              ABS(grid(i)%cntr(1) - planes%xmax) > THR .AND.     &
              ABS(grid(i)%cntr(2) - planes%ymin) > THR .AND.     &
              ABS(grid(i)%cntr(2) - planes%ymax) > THR .AND.     &
              ABS(grid(i)%cntr(3) - planes%zmin) > THR .AND.     &
              ABS(grid(i)%cntr(3) - planes%zmax) > THR ) THEN
            CALL fmm_quit('boundary planes not // to coordinate axes!')
         END IF
      END DO

   END SUBROUTINE verify_planes

!-------------------------------------------------------------------------------

   SUBROUTINE get_boundary_planes(grid,planes)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(IN)    :: grid(:)
      TYPE(fmm_planes),   INTENT(INOUT) :: planes

      INTEGER(INTK) :: i

      planes%xmin = zero
      planes%xmax = zero
      planes%ymin = zero
      planes%ymax = zero
      planes%zmin = zero
      planes%zmax = zero
      DO i = 1, SIZE(grid)
         planes%xmin = MIN(planes%xmin,grid(i)%cntr(1))
         planes%xmax = MAX(planes%xmax,grid(i)%cntr(1))
         planes%ymin = MIN(planes%ymin,grid(i)%cntr(2))
         planes%ymax = MAX(planes%ymax,grid(i)%cntr(2))
         planes%zmin = MIN(planes%zmin,grid(i)%cntr(3))
         planes%zmax = MAX(planes%zmax,grid(i)%cntr(3))
      END DO

   END SUBROUTINE get_boundary_planes

!-------------------------------------------------------------------------------

   SUBROUTINE get_closest_approach(RHS,planes,gap)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(IN)  :: RHS(:)
      TYPE(fmm_planes),   INTENT(IN)  :: planes
      REAL(REALK),        INTENT(OUT) :: gap

      INTEGER(INTK) :: i

      gap = 1.0d10
      DO i = 1, SIZE(RHS)
         gap = MIN(gap, ABS(RHS(i)%cntr(1) - planes%xmin) )
         gap = MIN(gap, ABS(RHS(i)%cntr(1) - planes%xmax) )
         gap = MIN(gap, ABS(RHS(i)%cntr(2) - planes%ymin) )
         gap = MIN(gap, ABS(RHS(i)%cntr(2) - planes%ymax) )
         gap = MIN(gap, ABS(RHS(i)%cntr(3) - planes%zmin) )
         gap = MIN(gap, ABS(RHS(i)%cntr(3) - planes%zmax) )
      END DO

   END SUBROUTINE get_closest_approach

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_opt_near_field(scheme,LHS,RHS)

      USE fmm_box_utils, ONLY: fmm_deepest_level, fmm_branch, fmm_grain

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(IN)    :: LHS(:)
      TYPE(raw_mm_paras), INTENT(IN)    :: RHS(:)
      TYPE(scheme_paras), INTENT(INOUT) :: scheme

      TYPE(fmm_planes) :: planes
      REAL(REALK)      :: gap, dummy
      REAL(REALK)      :: grain
      INTEGER(INTK)    :: branch

      ! We have only considered branch-free algorithm
      IF (.NOT. scheme%branch_free) RETURN

      CALL get_boundary_planes(LHS,planes)
      CALL verify_planes(LHS,planes)
      CALL get_closest_approach(RHS,planes,gap)
      WRITE(LUPRI,'(A,E15.7)') ' Minimum distance to boundary =', gap

      IF (gap < scheme%extent_min) THEN
         CALL fmm_quit('conflict between branch-free radius and boundary gap!')
      END IF

      grain  = fmm_grain(scheme,fmm_deepest_level(scheme))
      branch = fmm_branch(dummy,one/grain)

      ! we choose this condition to skip the NF conservatively
      IF (gap > (branch+2)*grain) THEN
         WRITE(LUPRI,*) 'There are no near-field interactions!'
         scheme%include_near_field = .FALSE.
      END IF

   END SUBROUTINE fmm_opt_near_field

!-------------------------------------------------------------------------------

END MODULE fmm_boundary

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!***********************************************************************

subroutine CIALL(LSYM,NREF,IOCR,nIOCR,L0,L1,L2,L3,LV)

use guga_global, only: IV0, IWAY, J2, LN, NIORB, NSM
use Symmetry_Info, only: Mul
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LSYM, nIOCR, L0(*), L1(*), L2(*), L3(*), LV
integer(kind=iwp), intent(out) :: NREF
integer(kind=iwp), intent(inout) :: IOCR(nIOCR)
integer(kind=iwp) :: I, IIN, IJJ, IOC(55), KM, KM1, NSJ

IIN = 0
NREF = 0
IJJ = IV0
KM = 1
J2(KM) = IJJ
loop_1: do
  KM = KM+1
  IWAY(KM) = 0
  loop_2: do
    KM1 = KM-1
    if ((L0(J2(KM1)) /= 0) .and. (IWAY(KM) < 1)) then
      J2(KM) = L0(J2(KM1))
      IWAY(KM) = 1
      IOC(KM1) = 0
    else if ((L1(J2(KM1)) /= 0) .and. (IWAY(KM) < 2)) then
      J2(KM) = L1(J2(KM1))
      IWAY(KM) = 2
      IOC(KM1) = 1
    else if ((L2(J2(KM1)) /= 0) .and. (IWAY(KM) < 3)) then
      J2(KM) = L2(J2(KM1))
      IWAY(KM) = 3
      IOC(KM1) = 1
    else if ((L3(J2(KM1)) /= 0) .and. (IWAY(KM) < 4)) then
      J2(KM) = L3(J2(KM1))
      IWAY(KM) = 4
      IOC(KM1) = 2
    else
      KM = KM-1
      if (KM == 1) exit loop_1
      cycle
    end if
    if (KM /= LN+1) exit
    NSJ = 1
    do I=1,LN
      if (I <= LV) then
        if (IOC(I) /= 0) cycle loop_2
      else if (I <= NIORB+LV) then
        if (IOC(I) /= 2) cycle loop_2
      else
        if (IOC(I) == 1) NSJ = Mul(NSJ,NSM(I))
      end if
    end do
    if (NSJ /= LSYM) cycle
    NREF = NREF+1
    do I=1,LN
      if (I <= NIORB+LV) cycle
      IIN = IIN+1
      if (IIN > nIOCR) then
        write(u6,*) 'CIall: IIN > nIOCR'
        write(u6,*) 'IIN=',IIN
        write(u6,*) 'nIOCR=',nIOCR
        call Abend()
      end if
      IOCR(IIN) = IOC(I)
    end do
  end do loop_2
end do loop_1

return

end subroutine CIALL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Ovlp(iWay,C1,C2,Smat)

************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Compute the orbital overlap matrix between the MO sets C1 and C2 *
*                                                                      *
*     calling arguments:                                               *
*     iWay    : integer                                                *
*               =0 : S-matrix for all orbitals                         *
*                    symmetry blocked, triangular                      *
*               =1 : S-matrix for active orbitals only                 *
*                    no symmetry, triangular                           *
*     C1      : real*8                                                 *
*               MO-basis                                               *
*     C2      : real*8                                                 *
*               MO-basis                                               *
*     S       : real*8                                                 *
*               orbital overlap matrix                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1999                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

#include "rasdim.fh"
#include "warnings.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='OVLP    ')
#include "WrkSpc.fh"

      Dimension C1(*),C2(*),Smat(*)

      Character*8 Label

* prologue


      zero = 0.0d0
      Call dCopy_(nAc*nAc,[zero],0,Smat,1)
      Call GetMem('OAO','Allo','Real',lOAO,nTot1)

* read the overlap integrals

      iRc=-1
      iOpt=6
      iComp=1
      iSyLbl=1
      Label='Mltpl  0'
      Call RdOne(iRc,iOpt,Label,iComp,Work(lOAO),iSyLbl)
      If ( iRc.ne.0 ) Goto 900

* compute the S-matrix for all orbitals and select elements

      ipC=1
      ipO=lOAO
      ipSmat=1
      nAcO=0
      Do iSym = 1,nSym
        nBs = nBas(iSym)
        nIs = nFro(iSym)+nIsh(iSym)
        nAs = nAsh(iSym)
        If ( nBs.gt.0 ) then
          Call GetMem('Scr1','Allo','Real',lScr1,nBs*nBs)
          Call GetMem('Scr2','Allo','Real',lScr2,nBs*nBs)
          Call Square(Work(ipO),Work(lScr1),1,nBs,nBs)
          Call DGEMM_('N','N',
     &                nBs,nBs,nBs,
     &                1.0d0,Work(lScr1),nBs,
     &                C1(ipC),nBs,
     &                0.0d0,Work(lScr2),nBs)
          Call DGEMM_('T','N',
     &                nBs,nBs,nBs,
     &                1.0d0,C2(ipC),nBs,
     &                Work(lScr2),nBs,
     &                0.0d0,Work(lScr1),nBs)
          If ( iWay.eq.0 ) then
            ij = lScr1
            Do iOrb = 1,nBs
              Do jOrb = 1,nBs
                If ( jOrb.le.iOrb ) then
                  Smat(ipSmat) = Work(ij)
                  ipSmat = ipSmat+1
                End If
                ij = ij+1
              End Do
            End Do
          Else
            ij = lScr1
            Do iOrb = 1,nBs
              Do jOrb = 1,nBs
*               If ( jOrb.le.iOrb ) then
                  If ( (iOrb.gt.nIs) .and. (iOrb.le.(nIs+nAs)) ) then
                    If ( (jOrb.gt.nIs) .and. (jOrb.le.(nIs+nAs)) ) then
                      iiOrb = iOrb-nIs+nAcO
                      jjOrb = jOrb-nIs+nAcO
                      ipSmat = jjOrb+(iiOrb*iiOrb-iiOrb)/2
                      ipSmat = jjOrb+(iiOrb-1)*nAc
                      Smat(ipSmat) = Work(ij)
                    End If
                  End If
*               End If
                ij = ij+1
              End Do
            End Do
          End If
          Call GetMem('Scr2','Free','Real',lScr2,nBs*nBs)
          Call GetMem('Scr1','Free','Real',lScr1,nBs*nBs)
        End If
        ipC=ipC+nBs*nBs
        ipO=ipO+(nBs*nBs+nBs)/2
        nAcO = nAcO+nAs
      End Do

* epilogue

      Call GetMem('OAO','Free','Real',lOAO,nTot1)

      Return

 900  Write(LF,*)
      Write(LF,*) ' *** Error in subroutine Ovlp ***'
      Write(LF,*) ' premature abort in subroutine RdOne'
      Write(LF,*) ' reading label: ',Label
      Write(LF,*)' RASSCF is trying to orthonormalize orbitals but'
      Write(LF,*)' could not read overlaps from ONEINT. Something'
      Write(LF,*)' is wrong with the file, or possibly with the'
      Write(LF,*)' program. Please check.'
      Write(LF,*)
      Call Quit(_RC_IO_ERROR_READ_)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GS_(T,nInter,nVec,Thr)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nInter, nVec
real(kind=wp), intent(inout) :: T(nInter,nVec)
real(kind=wp), intent(in) :: Thr
integer(kind=iwp) :: i, j
real(kind=wp) :: XX, XY
real(kind=wp), external :: DDot_

do i=1,nVec

  ! Order the vectors according to the diagonal value.

  call GS_Order(T(:,i:),nInter,nVec-i+1)

  ! Normalize the vector

  XX = sqrt(DDot_(nInter,T(:,i),1,T(:,i),1))
  !write(u6,*) 'GS_: i,XX=',i,XX
  if (XX > Thr) then
    T(:,i) = T(:,i)/XX
  else
    T(:,i) = Zero
#   ifdef _DEBUGPRINT_
    call RecPrt('GS_: T',' ',T,nInter,nInter)
#   endif
    cycle
  end if

  ! Orthogonalize against the previous vectors

  ! |Y(new)>=|Y> - <X|Y> * |X>

  do j=1,i-1
    XY = DDot_(nInter,T(:,i),1,T(:,j),1)
    !if (abs(XY) > Thr) then
    !  write(u6,*) 'GS_: j,XY=',j,XY
    T(:,i) = T(:,i)-XY*T(:,j)
    !  XY = DDot_(nInter,T(1,i),1,T(1,j),1)
    !  write(u6,*) 'GS_: j,XY=',j,XY
    !end if
  end do

  ! Renormalize

  XX = sqrt(DDot_(nInter,T(:,i),1,T(:,i),1))
  !write(u6,*) 'GS_: i,XX=',i,XX
  if (XX > Thr) then
    T(:,i) = T(:,i)/XX
  else
    T(:,i) = Zero
  end if
# ifdef _DEBUGPRINT_
  call RecPrt('GS_: T',' ',T,nInter,nInter)
# endif
end do

return

end subroutine GS_

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_B (BB,
     c             dima,dimb,dimbe,dimga,adda,addb,addbe,addga)
c
c        this routine test L2
c
        implicit none
#include "chcc1.fh"
        integer dima,dimb,dimbe,dimga,adda,addb,addbe,addga
         real*8 BB(1:dima,1:dimbe,1:dimb,1:dimga)
c
c        help var
        integer a,b,be,ga,bad,ntot
        real*8 s
c
        bad=0
        ntot=0
c
        do ga=addga+1,addga+dimga
        do b=addb+1,addb+dimb
        do be=addbe+1,addbe+dimbe
        do a=adda+1,adda+dima
c
          s=Bc(a,b,be,ga)
c
           if (abs(BB(a-adda,be-addbe,b-addb,ga-addga)-s)
     &              .gt.1.0d-10) then
            bad=bad+1
            BB(a-adda,be-addbe,b-addb,ga-addga)=s
          end if
          ntot=ntot+1

        end do
        end do
        end do
        end do
c
        write (6,*) ' B test ',bad,ntot
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Per-Olof Widmark                                 *
*               1993,1996,1997, Markus P. Fuelscher                    *
*               1996, Luis Serrano-Andres                              *
*               2012, Victor P. Vysotskiy                              *
************************************************************************
#if defined(_I8_) || defined(_OPENMP)
#define NO_SPLITTING
#endif
      Subroutine DaName_Main(Lu,String,mf,wa)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Open unit Lu for direct access I/O and link the data stream to   *
*     the logical file name Name.                                      *
*                                                                      *
*     calling arguments:                                               *
*     Lu      : integer, input                                         *
*               logical unit number                                    *
*     LuName  : character string, input                                *
*               logical file name                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, IBM Sweden, 1991                                   *
*     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
*     L. Serrano-Andres, University of Lund, Sweden, 1996              *
*----------------------------------------------------------------------*
*                                                                      *
* History:                                                             *
*          V.P. Vysotskiy, University of Lund, Sweden, 2012            *
*                                                                      *
************************************************************************

#ifndef _HAVE_EXTRA_
      Use Prgm
#endif
      Implicit Integer (A-Z)

#include "fio.fh"
#include "switch.fh"
#ifdef _OLD_IO_STAT_
#include "ofio.fh"
#else
#include "pfio.fh"
#endif
#include "blksize.fh"
#include "filesize.fh"
      Character*(*) String
      Logical mf, wa
      Character*8 StdNam
      Character*80 Text

      Character*16 TheName
      Data TheName/'DaName_Main'/

      If ( Trace ) then
        Write (6,*) ' >>> Enter DaName_Main <<<'
        Write (6,*) ' unit :',Lu
        Write (6,*) ' name :',String, mf, wa
      End If

      tmp=Lu
      Lu=isfreeunit(tmp)
*     Check calling arguments
      If ( (Lu.le.0) .or. (Lu.gt.MxFile) )
     * Call SysFileMsg(TheName,'MSG: unit', Lu,String)

*     Check for consistency
      If ( isOpen(Lu).ne.0 )
     * Call SysFileMsg(TheName,'MSG: used', Lu,String)

*     Reformat file name to standard notation
*     (capital letters, no leading blank)
      Call StdFmt(String,StdNam)

*     If no file name has been given link it to the default name
      If ( StdNam.eq.'        ' )
     &   Write(StdNam,'(A,I2.2,A)')'FT',Lu,'F001'

*     Check the storage scheme
#ifndef _GA_
      isFiM(Lu)=0
      isFiM(Lu)=isinmem(StdNam)
#ifdef _DEBUGPRINT_IO_
      if(isFiM(Lu)>0) write(6,*) "The file ",StdNam," will be kept in
     & memory"
#endif
*     Open file
      temp = isFiM(Lu)
#else
      temp=0
#endif
      iRc = AixOpn(temp,StdNam,.true.)
#ifndef _GA_
      if(iRc.eq.eFiMFo) Then
#ifdef _DEBUGPRINT_IO_
         write(6,*) "Failed to open file in memory"
#endif
         isFiM(Lu)=0
         iRc=0
      end if
#endif
      If ( iRc.ne.0 ) then
        iRc = AixErr(Text)
      Call SysFileMsg(TheName,'MSG: open', Lu,Text)
      End If
      isOpen(Lu)  = 1
      FSCB(Lu)    = temp
      LuName(Lu)    = StdNam
#ifndef _OLD_IO_STAT_
      inUse=0
      Do i=1,NProfFiles
         If(LuNameProf(i).eq.StdNam) Then
            inUse=1
         End If
      End Do

      If(inUse.eq.0) Then
        If (NProfFiles+1.le.MxFile) Then
           NProfFiles=NProfFiles+1
           LuNameProf(NProfFiles)=StdNam
        Else
           Write (6,*) 'IO error: NProfFiles+1.gt.MxFile'
           Write (6,*) 'Increase MxFile in src/Include/MxFile.fh!'
           Call Abend()
        End If
      End If
#endif
      Call SetLuMark(Lu)
      Addr(Lu)    = 0
      MPUnit(0,Lu)=Lu
#ifdef _OLD_IO_STAT_
      MxAddr(Lu)  = 0
      Count(1,Lu) = 0
      Count(2,Lu) = 0
      Count(3,Lu) = 0
      Count(4,Lu) = 0
#endif
      Multi_File(Lu)=.False.
      MBL(Lu)=MBl_nwa
      if(wa) MBL(Lu)=MBl_wa
#ifndef NO_SPLITTING
      If(mf) then
        Multi_File(Lu)=.True.
        MaxFileSize = AllocDisk()
        MFMB = Int(Dble(Max_File_Length)/(1024**2))
        If (MaxFileSize.gt.MFMB) Then
            Write (6,*)
            Write (6,*) 'DANAME_MF: Requested MaxFileSize is too large!'
            Write (6,*) ' Requested value of ',MaxFileSize
            MaxFileSize=MFMB
            Write (6,*) ' has been reset to  ',MaxFileSize
        Else If ( MaxFileSize.ne.0 ) then
          If ( Trace ) Write (6,*) ' This is a partitioned data set'
          lName = StrnLn(String)
          If ( (lName.eq.0).or.(lName.eq.8) )
     *   Call SysFileMsg(TheName,'Invalid file name. \n '//
     *   'File names used in '//
     *   'multiple unit files must be less than 8 characters.',
     *                  Lu,String)
          Do i = 1,MaxSplitFile-1
            MPUnit(i,Lu)=-99
          End Do
        End If
      End If
#endif
      If ( Trace ) then
        Write (6,*) ' >>> Exit DaName_Main <<<'
      End If


      Return
      End
      Subroutine SetLuMark(Lu)
#include "fio.fh"
      LuMark(Lu)=0
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine UpdateMostNegative(n,X,Val)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: X(n)
real(kind=wp), intent(in) :: Val
integer(kind=iwp) :: i, j

if (Val >= X(n)) return
i = 0
do while (i < n)
  i = i+1
  if (Val < X(i)) then
    do j=n,i+1,-1
      X(j) = X(j-1)
    end do
    X(i) = Val
    i = n+1 ! break while loop
  end if
end do

end subroutine UpdateMostNegative

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1999, Roland Lindh                      *
*               1990, IBM                                              *
************************************************************************
      Subroutine OneEl_Inner
     &                 (Kernel,KrnlMm,Label,ip,lOper,nComp,CCoor,
     &                  nOrdOp,rHrmt,iChO,
     &                  opmol,opnuc,ipad,iopadr,idirect,isyop,
     &                  iStabO,nStabO,nIC,
     &                  PtChrg,nGrid,iAddPot,Array,LenTot)
************************************************************************
*                                                                      *
* Object: to compute the one-electron integrals. The method employed at*
*         this point is not necessarily the fastest. However, the total*
*         time for the computation of integrals will depend on the time*
*         spent in computing the two-electron integrals.               *
*         The memory at this point is assumed to be large enough to do *
*         the computation in core.                                     *
*         The data is structured with respect to four indices, two (my *
*         ny or i j) refer to primitives or basis functions and two (a *
*         b) refer to the components of the cartesian or spherical     *
*         harmonic gaussians.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*             Modified for Hermite-Gauss quadrature November '90       *
*             Modified for Rys quadrature November '90                 *
*             Modified for multipole moments November '90              *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for general kernel routines January  91         *
*             Modified for nonsymmetrical operators February  91       *
*             Modified for better symmetry treatement October  93      *
*             Modified loop structure April 99                         *
************************************************************************
      use Real_Spherical
      use iSD_data
      use Basis_Info, only: dbsc
      use Sizes_of_Seward, only: S
      Implicit Real*8 (A-H,O-Z)
      External Kernel, KrnlMm, Rsv_Tsk
C     Logical Addpot
#include "real.fh"
#include "rmat_option.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "nsd.fh"
#include "setup.fh"
#include "property_label.fh"
      Real*8 Array(LenTot)
      Real*8, Dimension(:), Allocatable :: Zeta, ZI, Kappa, PCoor,
     &                                     SOInt, FArray, Scrtch,
     &                                     ScrSph, Kern
      Integer, Dimension(:,:), Allocatable :: Ind_ij
      Real*8 CCoor(3,nComp), PtChrg(nGrid)
      dimension opmol(*),opnuc(*),iopadr(nComp,*)
      Character Label*8
      Integer ip(nComp), lOper(nComp), iChO(nComp), iStabO(0:7)
      Logical Do_PGamma, Rsv_Tsk
*
*     Statement functions
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 112
      iPrint = nPrint(iRout)
      RMat_type_integrals=.False.
      Do_PGamma = .True.
*
*-----Auxiliary memory allocation.
*
      Call mma_allocate(Zeta,S%m2Max,label='Zeta')
      Call mma_allocate(ZI,S%m2Max,label='ZI')
      Call mma_allocate(Kappa,S%m2Max,label='Kappa')
      call mma_allocate(PCoor,S%m2Max*3,label='PCoor')
*                                                                      *
************************************************************************
*                                                                      *
      Call Nr_Shells(nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
*-----Double loop over shells. These loops decide the integral type
*
*                                                                      *
************************************************************************
*                                                                      *
*     Create list of non-vanishing pairs
*
      Call mma_allocate(Ind_ij,2,nskal*(nSkal+1)/2,label='Ind_ij')
      nijS = 0
      is = 0
      js = 0
      Do I = 1,nSkal*(nSkal+1)/2
         nijS = nijS + 1
         js = js + 1
         If (jS .gt. iS) Then
            iS = jS
            jS = 1
         End If
         Ind_ij(1,nijS)=iS
         Ind_ij(2,nijS)=jS
      End Do
      Call Init_Tsk(id_Tsk,nijS)
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate scratch for the integral evaluation.
*
      lFinal=1
      lScrt1=1
      lScrt2=1
      MemKrn=1
      Do ijS = 1, nijS
         iS=Ind_ij(1,ijS)
         jS=Ind_ij(2,ijS)
         iPrim=iSD(5,iS)
         jPrim=iSD(5,jS)
         iBas=iSD(3,iS)
         jBas=iSD(3,jS)
         iAng=iSD(1,iS)
         jAng=iSD(1,jS)
*
         mFinal=nIC*iPrim*jPrim*nElem(iAng)*nElem(jAng)
         lFinal=Max(lFinal,mFinal)
*
         If (Label(1:3).eq.'MAG') Cycle
         mScrt1=nIC*Max(iPrim,jBas)*Max(iBas,jPrim)
     &         *nElem(iAng)*nElem(jAng)
         lScrt1=Max(mScrt1,lScrt1)
*
         mScrt2=nIC*iBas*jBas*nElem(iAng)*nElem(jAng)
         lScrt2=Max(mScrt2,lScrt2)
*
         Call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)
*
         If (PLabel.ne.' ') Then
            la0=iAng
            lb0=jAng
            MemAux= 1 + 3*nElem(la0)*nElem(lb0+1)*nIC
            la1=la0
            lb1=lb0+1
            MemBux= 1 + 3*nElem(la1+1)*nElem(lb1)*nIC
            If (la1.ne.0) MemBux=MemBux+3*nElem(la1-1)*nElem(lb1)*nIC
            If (lb0.ne.0) Then
               lb1=lb0-1
               MemAux=MemAux+3*nElem(la0)*nElem(lb0-1)*nIC
               MemCux=1+3*nElem(la1+1)*nElem(lb1)*nIC
               If (la1.ne.0) MemCux=MemCux+3*nElem(la1-1)*nElem(lb1)*nIC
            Else
               MemCux=0
            End If
            MemAux = MemAux + Max(MemBux,MemCux)
            MemKer = MemKer + MemAux
         End If
*
         MemKrn=Max(MemKer*iPrim*jPrim,MemKrn)
      End Do
*
      Call mma_Allocate(FArray,lFinal,label='Final')
      Call mma_allocate(Scrtch,lScrt1,label='Scrtch')
      Call mma_allocate(ScrSph,lScrt2,label='ScrSph')
      Call mma_allocate(Kern,MemKrn,label='Kern')
*                                                                      *
************************************************************************
*                                                                      *
*     big loop over individual tasks, distributed over individual nodes
      ijSh = 0
 10   Continue
*     make reservation of a task on global task list and get task range
*     in return. Function will be false if no more tasks to execute.
      If (.Not.Rsv_Tsk(id_Tsk,ijSh)) Go To 11
      iS = Ind_ij(1,ijSh)
      jS = Ind_ij(2,ijSh)

      iCmp  =iSD(2,iS)
      iBas  =iSD(3,iS)
      iAO   =iSD(7,iS)
      iShell=iSD(11,iS)
      iCnttp=iSD(13,iS)

      jCmp  =iSD(2,jS)
      jBas  =iSD(3,jS)
      jAO   =iSD(7,jS)
      jShell=iSD(11,jS)
      jCnttp=iSD(13,jS)

      nSO=0
      Do iComp = 1, nComp
         iSmLbl=lOper(iComp)
         nSO=nSO+MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
      End Do
      If (iPrint.ge.29) Write (6,*) ' nSO=',nSO
*
*     Do not compute matrix elements in which electronic and
*     muonic basis sets are mixed.
*
      If (nSO.gt.0 .AND.
     &   dbsc(iCnttp)%fMass.eq.dbsc(jCnttp)%fMass
     &   ) Then
         l_SOInt=iBas*jBas*nSO
         Call mma_allocate(SOInt,l_SOInt,label='SOInt')
         SOInt(:)=Zero
         ipSO=1
         Call OneEl_IJ(iS,jS,iPrint,Do_PGamma,
     &                 Zeta,ZI,Kappa,PCoor,
     &                 Kernel,KrnlMm,Label,lOper,nComp,CCoor,
     &                 nOrdOp,iChO,
     &                 iStabO,nStabO,nIC,
     &                 PtChrg,nGrid,iAddPot,SOInt,l_SOInt,
     &                 FArray,lFinal,Scrtch,lScrt1,
     &                 ScrSph,lScrt2,Kern,MemKrn)
         iSOBlk = ipSO
         Do iComp = 1, nComp
            iSmLbl=lOper(iComp)
            If (n2Tri(iSmLbl).ne.0) Then
               mSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            Else
               mSO=0
            End If
*
*           Special trick for integrals over electromagnetic field
*           radiation integrals.
*
            rHrmt_Save=rHrmt

            If (Label(1:5).eq.'EMFR '.or.Label(1:5).eq.'TMOM ') Then
               If (MOD((iComp+5),6).lt.3) Then
                  rHrmt= One
               Else
                  rHrmt=-One
               End If
            End If
*           Write (*,*) 'Label,iComp,rHrmt=',Label,iComp,rHrmt
            If (mSO.ne.0) Then
               Call SOSctt(SOInt(iSOBlk),iBas,jBas,mSO,Array(ip(iComp)),
     &                     n2Tri(iSmLbl),iSmLbl,iCmp,jCmp,iShell,
     &                     jShell,iAO,jAO,nComp,Label,lOper,rHrmt)
               iSOBlk = iSOBlk + mSO*iBas*jBas
            End If
            rHrmt=rHrmt_Save
         End Do
         Call mma_deallocate(SOInt)
      End If
      Goto 10
   11 Continue
      Call Free_Tsk(id_Tsk)
      Do iComp = 1, nComp
         iSmLbl=lOper(iComp)
         Call GADSum(Array(ip(iComp)),n2Tri(iSmLbl))
      End Do
*
      Call mma_deallocate(Kern)
      Call mma_deallocate(ScrSph)
      Call mma_deallocate(Scrtch)
      Call mma_deallocate(FArray)
      Call mma_deallocate(Ind_ij)
      Call mma_deallocate(PCoor)
      Call mma_deallocate(Kappa)
      Call mma_deallocate(ZI)
      Call mma_deallocate(Zeta)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(opmol)
         Call Unused_real_array(opnuc)
         Call Unused_integer(ipad)
         Call Unused_integer_array(iopadr)
         Call Unused_integer(idirect)
         Call Unused_integer(isyop)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Rulin Feng                                       *
!***********************************************************************
!***************************************************
!         Get TDM in AO basis from SO states
!****************************************************
! This routine is modified from sonatorbm to give the
! full transition density matrix (TDM) in atomic orbital
! basis, which is not a nbtri sized matrix as in sonatorbm
! but a full nbst**2 sized matrix.

subroutine MAKETDMAO(CHARTYPE,USOR,USOI,ASS,BSS,NSS,iOpt,ROTMAT,DENSOUT)

use rassi_aux, only: idisk_TDM
use rassi_global_arrays, only: JBNUM
use rassi_data, only: NBASF, NBST, NTDMZZ
use Cntrl, only: IRREP, LSYM1, LSYM2, LuTDM, MLTPLT, NSTATE
use Symmetry_Info, only: MUL, nIrrep
use wigner_util, only: dclebs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
character(len=8), intent(in) :: CHARTYPE
integer(kind=iwp), intent(in) :: ASS, BSS, NSS
real(kind=wp), intent(in) :: USOR(NSS,NSS), USOI(NSS,NSS), ROTMAT(3,3)
integer(kind=iwp), intent(inout) :: iOpt
real(kind=wp), intent(out) :: DENSOUT(6,nbst**2)
integer(kind=iwp) :: I, IDIR, IDISK, IEMPTY, IGO, IJ, IOFF(8), ISF, ISS, ISY1, ISY12, ISY12_MA, ISY2, ITD, ITYPE, J, JOB, JOB1, &
                     JOB2, KSF, KSS, LSF, LSS, MPLET, MPLETK, MPLETL, MSPROJ, MSPROJK, MSPROJL, NB1, NB1_F, NB1_I, NB2, NB2_F, &
                     NB2_I, NBSTS
real(kind=wp) :: CG0, CGM, CGP, CGX, CGY, Dummy(1), FACT, S1, S2, SM1, SM2, TDM, UIL, UIR, URL, URR
integer, allocatable :: MAPST(:), MAPSP(:), MAPMS(:)
real(kind=wp), allocatable :: SDMXYZR(:,:), SDMXYZI(:,:), SDMXYZR2(:,:), SDMXYZI2(:,:), TMPR(:), TMPI(:), SCR(:), TDMZZ(:)

nbsts = nbst**2

! VV: dummy initialization
CGY = -1
CGX = -1
CG0 = -1
! Initialize
DENSOUT(:,:) = Zero
! Get the proper type of the property
select case (CHARTYPE)
  case ('HERMSING')
    ITYPE = 1
  case ('ANTISING')
    ITYPE = 2
  case ('HERMTRIP')
    ITYPE = 3
  case ('ANTITRIP')
    ITYPE = 4
  case default
    write(u6,*) 'RASSI/SONATORB internal error.'
    write(u6,*) 'Erroneous property type:',CHARTYPE
    call ABEND()
    ITYPE = 0
end select

! The following creates an array that is used to
! map a specific spin state to the corresponding
! spin-free state and to its spin
! (see prprop and others)

call mma_allocate(MAPST,NSS,Label='MAPST')
call mma_allocate(MAPSP,NSS,Label='MAPSP')
call mma_allocate(MAPMS,NSS,Label='MAPMS')

ISS = 0
do ISF=1,NSTATE
  JOB = JBNUM(ISF)
  MPLET = MLTPLT(JOB)

  do MSPROJ=-MPLET+1,MPLET-1,2
    ISS = ISS+1
    MAPST(ISS) = ISF
    MAPSP(ISS) = MPLET
    MAPMS(ISS) = MSPROJ
  end do
end do

! Allocate some arrays
! SDMXYZR, etc    DM/TDM for this iteration
! SDMXYZR2, etc   Accumulated DM/TDM
! TMPR,I          Temporary array for U*AU multiplication
! TDMZZ           DM/TDM as read from file
! SCR             Scratch for expansion of TDMZZ
call mma_allocate(SDMXYZR,nbsts,3,Label='SDMXYZR')
call mma_allocate(SDMXYZI,nbsts,3,Label='SDMXYZI')
SDMXYZR(:,:) = Zero
SDMXYZI(:,:) = Zero

call mma_allocate(SDMXYZR2,nbsts,3,Label='SDMXYZR2')
call mma_allocate(SDMXYZI2,nbsts,3,Label='SDMXYZI2')
SDMXYZR2(:,:) = Zero
SDMXYZI2(:,:) = Zero

call mma_allocate(TMPR,nbsts,Label='TMPR')
call mma_allocate(TMPI,nbsts,Label='TMPI')
TMPR(:) = Zero
TMPI(:) = Zero

call mma_allocate(SCR,nbsts,Label='SCR')
! zeroed inside the loop

call mma_allocate(TDMZZ,NTDMZZ,Label='TDMZZ')
TDMZZ(:) = Zero

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! MAIN LOOP OVER KSF/LSF
! WRITTEN AS IN PRPROP
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! CORRESPONDING SPIN-FREE STATES OF THE
! REQUESTED SPIN STATES
!ASF = MAPST(ASS)
!BSF = MAPST(BSS)

do KSS=1,NSS
  KSF = MAPST(KSS)
  MPLETK = MAPSP(KSS)
  MSPROJK = MAPMS(KSS)

  do LSS=1,NSS
    LSF = MAPST(LSS)
    MPLETL = MAPSP(LSS)
    MSPROJL = MAPMS(LSS)

    JOB1 = JBNUM(KSF)
    JOB2 = JBNUM(LSF)
    LSYM1 = IRREP(JOB1)
    LSYM2 = IRREP(JOB2)
    ISY12 = MUL(LSYM1,LSYM2)

    ! SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS
    call mk_IOFF(IOFF,nIrrep,NBASF,ISY12)

    ! These are going to be zero, so head them off at the pass
    if ((ITYPE <= 2) .and. ((MPLETK /= MPLETL) .or. (MSPROJK /= MSPROJL))) cycle

    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
    ! Transition density matrices, TDMZZ, in AO basis.
    ! WDMZZ similar, but WE-reduced 'triplet' densities.
    ! TDMZZ will store either, depending on the type
    TDMZZ(:) = Zero

    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    ! IDTDM: TOC array for transition 1-matrices
    ! TDMZZ is stored on disk from i = 1, NSTATE j=1, i
    ! so swap if needed
    iEmpty = iDisk_TDM(KSF,LSF,2)
    IDISK = iDisk_TDM(KSF,LSF,1)
    iOpt = 2
    if (ITYPE >= 3) then
      iGo = ibset(0,2)
      call dens2file(Dummy,Dummy,TDMZZ,nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,KSF,LSF)
      ! NOTE-the TD matrix as read in has an incorrect sign
      TDMZZ(:) = -TDMZZ(:)
    else
      iGo = ibset(0,0)
      call dens2file(TDMZZ,Dummy,Dummy,nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,KSF,LSF)
    end if

    ! Anti-hermitian properties need a little fixing
    if (((ITYPE == 2) .or. (ITYPE == 4)) .and. (KSF <= LSF)) TDMZZ(:) = -TDMZZ(:)

    ! CALCULATE THE SYMMETRIC AND ANTISYMMETRIC FOLDED TRANS D MATRICES
    ! AND SIMILAR WE-REDUCED SPIN DENSITY MATRICES
    SCR(:) = Zero
    !ccccccccccccc
    ! nbsq and NTDMZZ are the same, but they are the
    ! sizes of the symmetry-adapted matrices
    ! what we need is a NBST**2-sized matrix without symmetry
    ! Thus we expand the final TDM in C1 symmetry
    ! Leave the zero matrix elements as they are
    !cccccccccccccc

    ! Expand into C1
    ITD = 0
    NB1_i = 0
    NB1_f = 0
    do ISY1=1,nIrrep
      NB2_i = 0
      NB2_f = 0
      NB1 = NBASF(ISY1)
      NB1_f = NB1_i+NB1
      do ISY2=1,nIrrep
        ISY12_ma = MUL(ISY1,ISY2)
        NB2 = NBASF(ISY2)
        NB2_f = NB2_i+NB2
        if (ISY12_ma == ISY12) then
          do J=NB2_i+1,NB2_f
            do I=NB1_i+1,NB1_f
              ITD = ITD+1
              TDM = TDMZZ(ITD)
              IJ = I+NBST*(J-1)
              SCR(IJ) = SCR(IJ)+TDM
            end do
          end do
        end if
        NB2_i = NB2_i+NB2
      end do
      NB1_i = NB1_i+NB1
    end do

    ! ie, see how AMFI is processed in soeig
    SDMXYZR(:,:) = Zero
    SDMXYZI(:,:) = Zero

    if (ITYPE >= 3) then
      S1 = Half*real(MPLETK-1,kind=wp)
      SM1 = Half*real(MSPROJK,kind=wp)
      S2 = Half*real(MPLETL-1,kind=wp)
      SM2 = Half*real(MSPROJL,kind=wp)
      FACT = One/sqrt(real(MPLETK,kind=wp))
      if (MPLETK == MPLETL-2) FACT = -FACT

      CGM = FACT*DCLEBS(S2,One,S1,SM2,-One,SM1)
      CG0 = FACT*DCLEBS(S2,One,S1,SM2,Zero,SM1)
      CGP = FACT*DCLEBS(S2,One,S1,SM2,One,SM1)
      CGX = sqrt(Half)*(CGM-CGP)
      CGY = sqrt(Half)*(CGM+CGP)
    end if

    if (((ITYPE == 1) .or. (ITYPE == 2)) .and. (MPLETK == MPLETL) .and. (MSPROJK == MSPROJL)) then
      SDMXYZR(:,3) = SDMXYZR(:,3)+SCR(:)
    else if ((ITYPE == 3) .or. (ITYPE == 4)) then
      if (iOpt == 1) then
        SDMXYZR(:,1) = SDMXYZR(:,1)+(CGX*ROTMAT(1,1)+CGY*ROTMAT(2,1)+CG0*ROTMAT(3,1))*SCR(:)

        SDMXYZR(:,2) = SDMXYZR(:,2)+(CGX*ROTMAT(1,2)+CGY*ROTMAT(2,2)+CG0*ROTMAT(3,2))*SCR(:)

        SDMXYZR(:,3) = SDMXYZR(:,3)+(CGX*ROTMAT(1,3)+CGY*ROTMAT(2,3)+CG0*ROTMAT(3,3))*SCR(:)
      else
        SDMXYZR(:,1) = SDMXYZR(:,1)+CGX*SCR(:)
        SDMXYZI(:,2) = SDMXYZI(:,2)+CGY*SCR(:)
        SDMXYZR(:,3) = SDMXYZR(:,3)+CG0*SCR(:)
      end if
    end if

    !ccccccccccccccccccccccccccccccccccccccccccccccccccccc
    ! SPINORBIT
    !ccccccccccccccccccccccccccccccccccccccccccccccccccccc
    ! Sign of the left-hand imaginary part is handled
    ! when doing DAXPY
    URR = USOR(LSS,BSS)
    UIR = USOI(LSS,BSS)
    URL = USOR(KSS,ASS)
    UIL = USOI(KSS,ASS)

    do IDIR=1,3
      TMPR(:) = Zero
      TMPI(:) = Zero

      ! right side
      TMPR(:) = TMPR(:)+URR*SDMXYZR(:,IDIR)-UIR*SDMXYZI(:,IDIR)
      TMPI(:) = TMPI(:)+UIR*SDMXYZR(:,IDIR)+URR*SDMXYZI(:,IDIR)

      ! left side
      SDMXYZR2(:,IDIR) = SDMXYZR2(:,IDIR)+URL*TMPR(:)+UIL*TMPI(:)
      SDMXYZI2(:,IDIR) = SDMXYZI2(:,IDIR)+URL*TMPI(:)-UIL*TMPR(:)
    end do
    !ccccccccccccccccccccc
    ! END SPINORBIT STUFF
    !ccccccccccccccccccccc

    ! END MAIN LOOP OVER STATES (KSS,LSS)
  end do
end do

! Store this density to DENSOUT
if ((ITYPE == 3) .or. (ITYPE == 4)) then
  DENSOUT(1,:) = SDMXYZR2(:,1)
  DENSOUT(2,:) = SDMXYZR2(:,2)
  DENSOUT(3,:) = SDMXYZR2(:,3)
  DENSOUT(4,:) = SDMXYZI2(:,1)
  DENSOUT(5,:) = SDMXYZI2(:,2)
  DENSOUT(6,:) = SDMXYZI2(:,3)
else
  DENSOUT(1,:) = SDMXYZR2(:,3)
  DENSOUT(2,:) = SDMXYZR2(:,3)
  DENSOUT(3,:) = SDMXYZR2(:,3)
  DENSOUT(4,:) = SDMXYZI2(:,3)
  DENSOUT(5,:) = SDMXYZI2(:,3)
  DENSOUT(6,:) = SDMXYZI2(:,3)
end if

! Free memory
call mma_deallocate(SCR)
call mma_deallocate(TDMZZ)

call mma_deallocate(TMPI)
call mma_deallocate(TMPR)

call mma_deallocate(SDMXYZR)
call mma_deallocate(SDMXYZI)

call mma_deallocate(SDMXYZR2)
call mma_deallocate(SDMXYZI2)

call mma_deallocate(MAPST)
call mma_deallocate(MAPSP)
call mma_deallocate(MAPMS)

end subroutine MAKETDMAO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! ci diagonal elements
subroutine diagonal_loop_wyb()  !  for norb_act<>0

use gugaci_global, only: ipae, iseg_downwei, iw_downwei, iw_sta, jd, jpad, jpad_upwei, jpae, js, jt, jv, mxnode, nci_dim, nci_h0, &
                         ndim, ng_sm, norb_all, nu_ad, nu_ae, vdint, vector1, voint, vpotnuc
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: im, ipae_, iwupwei, jaedownwei, jpad_, lr, lr0, ndimsum

do lr0=2,norb_all
  do lr=1,lr0-1
    vdint(lr,lr0) = voint(lr0,lr)-vdint(lr0,lr)-vdint(lr0,lr)   ! 520
    !write(u6,'(2i4,3f14.8)') lr,lr0,voint(lr0,lr),vdint(lr0,lr),vdint(lr,lr0)
  end do
end do
!write(u6,*) '               ***** start h-diaelm *****'
vector1(1:nci_dim) = vpotnuc
!wl8 = hnil*(hnil-1)*vmd(lr,lr)*Half+hnil*vo(lr,lr)   ! 800

ndimsum = 0
jpae = jv
ipae = 1
jaedownwei = iseg_downwei(ipae)
do jpad_=1,mxnode
  jpad = jpad_ ! jpad is in global module, is this necessary?
  iw_sta(jpad,ipae) = ndimsum
  if (nu_ad(jpad) == 0) cycle
  call seg_drt()
  iwupwei = jpad_upwei(jpad)
  iw_downwei(jpad,ipae) = ndim
  ndimsum = ndimsum+ndim*jaedownwei*iwupwei
  if (ndim == 0) cycle
  call diagonal_act_d()
  call diagonal_act_c()
end do
do im=1,ng_sm
  jpae = jd(im)
  ipae = 1+im
  if (nu_ae(ipae) == 0) cycle
  jaedownwei = iseg_downwei(ipae)
  do jpad_=1,mxnode
    jpad = jpad_ ! jpad is in global module, is this necessary?
    iw_sta(jpad,ipae) = ndimsum
    if (nu_ad(jpad) == 0) cycle
    call seg_drt()
    iwupwei = jpad_upwei(jpad)
    iw_downwei(jpad,ipae) = ndim
    !if (jpad >= 26) write(u6,*)
    ndimsum = ndimsum+ndim*jaedownwei*iwupwei
    if (ndim == 0) cycle
    call diagonal_act_d()
    call diagonal_act_c()
  end do
end do
do im=1,ng_sm
  jpae = jt(im)
  ipae = 9+im
  if (nu_ae(ipae) == 0) cycle
  jaedownwei = iseg_downwei(ipae)
  do jpad_=1,mxnode
    jpad = jpad_ ! jpad is in global module, is this necessary?
    iw_sta(jpad,ipae) = ndimsum
    if (nu_ad(jpad) == 0) cycle
    call seg_drt()
    iwupwei = jpad_upwei(jpad)
    iw_downwei(jpad,ipae) = ndim
    ndimsum = ndimsum+ndim*jaedownwei*iwupwei
    if (ndim == 0) cycle
    call diagonal_act_d()
    call diagonal_act_c()
  end do
end do
do im=1,ng_sm
  jpae = js(im)
  ipae = 17+im
  jaedownwei = iseg_downwei(ipae)
  if (nu_ae(ipae) == 0) cycle
  do jpad_=1,mxnode
    jpad = jpad_ ! jpad is in global module, is this necessary?
    iw_sta(jpad,ipae) = ndimsum
    if (nu_ad(jpad) == 0) cycle
    call seg_drt()
    iwupwei = jpad_upwei(jpad)
    iw_downwei(jpad,ipae) = ndim
    ndimsum = ndimsum+ndim*jaedownwei*iwupwei
    if (ndim == 0) cycle
    call diagonal_act_d()
    call diagonal_act_c()
  end do
end do
call diagonal_dbl()
call diagonal_ext()
outer: do ipae_=1,25
  ipae = ipae_ ! ipae is in global module, is this necessary?
  do jpad_=1,mxnode
    jpad = jpad_ ! jpad is in global module, is this necessary?
    if (iw_sta(jpad,ipae) /= 0) then
      nci_h0 = iw_sta(jpad,ipae)
      exit outer
    end if
  end do
end do outer

!do i=1,nci_dim
!  write(u6,'(i8,f18.8)') i,vector1(i)
!end do
!call abend()

return

end subroutine diagonal_loop_wyb

subroutine diagonal_act_c()

use gugaci_global, only: iy, jb, jeh, jj_sub, jpad, jph, jwh, maxpl, norb_act, norb_dz, norb_inn, th, thh
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: idl, ind1, isq, iwa, je, jeb, jp, jpb, lr, m, me, mh, mp, mpe, mw
real(kind=wp) :: vlop0, vlop1, w, ww
integer(kind=iwp), allocatable :: jee(:), jpe(:), jwe(:)
real(kind=wp), allocatable :: te(:), tee(:)

!write(u6,*) '               ***** start h-diaelm *****'
!write(u6,*) jpad,jpae
!ndr(:) = 0
if (norb_act == 0) then
  mh = 1
  th(1) = One
  thh(1) = One
  call diagonal_link_dae(mh)
  return
end if
mp = 0
! 520
mh = 0
me = 0
jp = jpad
jpb = jb(jp)
do idl=1,4
  if (jj_sub(idl,jp) == 0) cycle
  ind1 = idl
  ! link c"
  call smidc2(isq,w,ww,mw,ind1,jpb)
  mh = mh+1
  jeh(mh) = jj_sub(idl,jp)
  th(mh) = w
  thh(mh) = ww
  jph(mh) = 0
  jwh(mh) = 0
  if (idl /= 1) jwh(mh) = iy(idl,jp)
  ! complete a loop 'v'
  if (ind1 == 1) cycle
  call stml(isq,w,ww,mw,ind1-1,jpb)
  vlop0 = w
  vlop1 = ww
  if ((vlop0 == Zero) .and. (vlop1 == Zero)) cycle
  mpe = jj_sub(idl,jp)
  iwa = iy(idl,jp)
  call diagonal_link_ad(mpe,iwa,vlop0,vlop1)
end do
!***********************************************************************
!write(u6,*) ad(i)
!***********************************************************************
lr = norb_dz+1

call mma_allocate(te,maxpl,label='te')
call mma_allocate(tee,maxpl,label='tee')
call mma_allocate(jpe,maxpl,label='jpe')
call mma_allocate(jee,maxpl,label='jee')
call mma_allocate(jwe,maxpl,label='jwe')
do
  if (lr == norb_inn) then
    if (mh /= 0) call diagonal_link_dae(mh)
    exit
  end if
  lr = lr+1
  me = 0
  do m=1,mh
    je = jeh(m)
    jeb = jb(je)
    !jp = jph(m)
    do idl=1,4
      if (jj_sub(idl,je) == 0) cycle
      ind1 = idl
      !if (lr /= 1) then
      ! link loop
      call smidc2(isq,w,ww,mw,ind1,jeb)
      me = me+1
      jwe(me) = jwh(m)
      if (idl /= 1) jwe(me) = jwe(me)+iy(idl,je)
      jee(me) = jj_sub(idl,je)
      te(me) = th(m)*w
      tee(me) = thh(m)*ww
      jpe(me) = jph(m)
      !end if
      ! complete a loop 'v'
      if (ind1 == 1) cycle
      call stml(isq,w,ww,mw,ind1-1,jeb)
      vlop0 = th(m)*w
      vlop1 = thh(m)*ww
      if ((vlop0 == Zero) .and. (vlop1 == Zero)) cycle
      mp = mp+1
      mpe = jj_sub(idl,je)
      iwa = jwh(m)
      if (idl /= 1) iwa = iwa+iy(idl,je)
      call diagonal_link_ad(mpe,iwa,vlop0,vlop1)
      !*****   520  ****************************************************
    end do
  end do
  !*********************************************************************
  !write(u6,*) ad(i)
  !*********************************************************************
  do m=1,me
    th(m) = te(m)
    te(m) = Zero
    thh(m) = tee(m)
    tee(m) = Zero
    jwh(m) = jwe(m)
    jwe(m) = 0
    jeh(m) = jee(m)
    jee(m) = 0
    jph(m) = jpe(m)
    jpe(m) = 0
  end do
  mh = me
  !if (ndr(lr) < mh) ndr(lr) = mh
end do
!do m=1,mh
!  th(m) = Zero
!  thh(m) = Zero
!  jwh(m) = 0
!  jph(m) = 0
!  jeh(m) = 0
!end do

call mma_deallocate(te)
call mma_deallocate(tee)
call mma_deallocate(jpe)
call mma_deallocate(jee)
call mma_deallocate(jwe)

return

end subroutine diagonal_act_c

subroutine diagonal_act_d()

use gugaci_global, only: iy, jb, jeh, jj_sub, jph, jwh, maxpl, no, norb_dz, norb_inn, th, thh, vdint, voint
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: idl, ind1, isq, iwa, jbl, je, jeb, jp, jp0, jp1, jw, lr, lr0, m, me, mh, mp, mpe, mw
real(kind=wp) :: vlop0, vlop1, w, wt, ww
integer(kind=iwp), allocatable :: jee(:), jpe(:), jwe(:)
real(kind=wp), allocatable :: te(:), tee(:)

!write(u6,*) '               ***** start h-diaelm *****'
!write(u6,*) '   diagonal_act_d:',jpad,ipae
!ndr(:) = 0
do lr=norb_dz+1,norb_inn
  jp0 = no(lr-1)+1
  jp1 = no(lr)
  lr0 = lr
  do jp=jp0,jp1
    if (iy(1,jp) == 0) cycle
    ! 800
    do idl=2,3
      mpe = jj_sub(idl,jp)
      if (mpe == 0) cycle
      wt = voint(lr0,lr0)    ! hnil=1
      jw = iy(idl,jp)
      call prodel(3,wt,jp,mpe,jw)
    end do
    mpe = jj_sub(4,jp)
    if (mpe /= 0) then
      wt = vdint(lr0,lr0)+Two*voint(lr0,lr0)     !idl=4 hnil=2
      jw = iy(4,jp)
      call prodel(3,wt,jp,mpe,jw)
    end if
  end do
end do
call mma_allocate(te,maxpl,label='te')
call mma_allocate(tee,maxpl,label='tee')
call mma_allocate(jpe,maxpl,label='jpe')
call mma_allocate(jee,maxpl,label='jee')
call mma_allocate(jwe,maxpl,label='jwe')
! 520
do lr0=norb_dz+1,norb_inn
  mh = 0
  me = 0
  jp0 = no(lr0-1)+1
  jp1 = no(lr0)
  if (jp0 > jp1) jp0 = jp1
  do jp=jp0,jp1
    if (iy(1,jp) == 0) cycle
    !start '^'
    do idl=1,4
      if (jj_sub(idl,jp) == 0) cycle
      jbl = jb(jp)
      ind1 = idl-1
      if (ind1 == 0) cycle
      call stmh(isq,w,ww,mw,ind1,jbl)
      mh = mh+1
      jeh(mh) = jj_sub(idl,jp)
      th(mh) = w
      thh(mh) = ww
      jph(mh) = jp
      jwh(mh) = 0
      if (idl /= 1) jwh(mh) = iy(idl,jp)
    end do
  end do
  !*********************************************************************
  !write(u6,*) ad(i)
  !*********************************************************************
  lr = lr0
  !if (ndr(lr) < mh) ndr(lr) = mh
  do
    if (lr == norb_inn) then
      call diagonal_link_ae(mh)
      exit
    end if
    lr = lr+1
    me = 0
    mp = 0
    do m=1,mh
      je = jeh(m)
      jeb = jb(je)
      jp = jph(m)
      do idl=1,4
        if (jj_sub(idl,je) == 0) cycle
        ind1 = idl
        if (lr /= 1) then
          ! link loop
          call smidc2(isq,w,ww,mw,ind1,jeb)
          me = me+1
          jwe(me) = jwh(m)
          if (idl /= 1) jwe(me) = jwe(me)+iy(idl,je)
          jee(me) = jj_sub(idl,je)
          te(me) = th(m)*w
          tee(me) = thh(m)*ww
          jpe(me) = jph(m)
        end if
        ! complete a loop 'v'
        if (ind1 == 1) cycle
        call stml(isq,w,ww,mw,ind1-1,jeb)
        vlop0 = th(m)*w
        vlop1 = thh(m)*ww
        if ((vlop0 == Zero) .and. (vlop1 == Zero)) cycle
        mp = mp+1
        mpe = jj_sub(idl,je)
        iwa = jwh(m)
        if (idl /= 1) iwa = iy(idl,je)+iwa
        wt = (vlop0-vlop1)*voint(lr,lr0)-Two*vlop0*vdint(lr,lr0)

        call prodel(3,wt,jp,mpe,iwa)
        !*****   520  **************************************************
      end do
    end do
    !*******************************************************************
    !write(u6,*) ad(i)
    !*******************************************************************
    do m=1,me
      th(m) = te(m)
      te(m) = Zero
      thh(m) = tee(m)
      tee(m) = Zero
      jwh(m) = jwe(m)
      jwe(m) = 0
      jeh(m) = jee(m)
      jee(m) = 0
      jph(m) = jpe(m)
      jpe(m) = 0
    end do
    mh = me
    !if (ndr(lr) < mh) ndr(lr) = mh
  end do
  !do m=1,mh
  !  th(m) = Zero
  !  thh(m) = Zero
  !  jwh(m) = 0
  !  jph(m) = 0
  !  jeh(m) = 0
  !end do
end do

call mma_deallocate(te)
call mma_deallocate(tee)
call mma_deallocate(jpe)
call mma_deallocate(jee)
call mma_deallocate(jwe)

return

end subroutine diagonal_act_d

subroutine diagonal_link_ae(mh)

use gugaci_global, only: ibsm_ext, iesm_ext, ipae, jph, jwh, kk, lsm, ng_sm, nlsm_ext, norb_all, norb_ext, th, thh, v_onevsqtwo, &
                         v_sqthreevsqtwo, v_sqtwo, vdint, voint
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp) :: ima, imae, imb, ip, ityae, iwa, iwe, jp, la, lb, lbend, lbsta, lr0, lra, lrb, ma
real(kind=wp) :: vlop0, vlop1, wg13, wg14, wg38, wg50, wld, wls, wlt, wwg38, wwg50

if (ipae == 1) return   !could not link
ityae = (ipae-1)/8+1
imae = mod(ipae-1,8)
if (imae == 0) then
  ityae = ityae-1
  imae = 8
end if
do ip=1,mh
  iwe = 0
  jp = jph(ip)
  lr0 = kk(jp)
  !write(u6,*) 'ip,jpe,ind0',ip,jpe,ind0
  iwa = jwh(ip)
  vlop0 = th(ip)
  vlop1 = thh(ip)

  !wl5 = (vlop0-vlop1)*vo(lr0,lr)-Two*vlop0*vmd(lr0,lr)
  !wl8 = vlop0*(vo(lr0,lr0)+(vlop0-1)*Half*vmd(lr0,lr0))
  ! two-index,one-loop 520
  ! 0 = <a,j,k,a>:13,14(ss=3),38(tt=2),50(dd=1)
  !link arc_d
  select case (ityae)
    case default ! (1)
      !zz = '  g50  '
      wg50 = vlop0*v_onevsqtwo
      wwg50 = -vlop1*v_sqthreevsqtwo
      do la=1,norb_ext
        ma = lsm(la)
        if (ma /= imae) cycle
        lra = norb_all-la+1
        iwe = iwe+1
        wld = (wg50-wwg50)*voint(lra,lr0)-Two*wg50*vdint(lra,lr0)
        !write(u6,'(a11,2i3,i6,1x,5f10.4)') zz,lr0,la,jwl,vo(lr0,la),vmd(lr0,la),wg50,wwg50,wl
        call prodel(5,wld,jp,iwa,iwe)
      end do

    case (2)
      !zz = '  g38,39  '
      wg38 = -vlop0*v_onevsqtwo
      wwg38 = vlop1
      do ima=1,ng_sm
        imb = Mul(ima,imae)
        if (imb > ima) cycle
        do la=ibsm_ext(ima),iesm_ext(ima)
          lra = norb_all-la+1
          lbsta = ibsm_ext(imb)
          lbend = iesm_ext(imb)
          if (ima == imb) lbend = la-1
          do lb=lbsta,lbend
            lrb = norb_all-lb+1
            iwe = iwe+1
            wlt = (wg38-wwg38)*(voint(lra,lr0)+voint(lrb,lr0))-Two*wg38*(vdint(lra,lr0)+vdint(lrb,lr0))
            !write(u6,*) ' 520 r0,la,lb ',vo(r0,la),vo(r0,lb),vmd(r0,la),vmd(r0,lb)

            call prodel(5,wlt,jp,iwa,iwe)
          end do
        end do
      end do

    case (3)
      !zz = '  g14,15  '
      wg14 = -vlop0*v_onevsqtwo
      do ima=1,ng_sm
        imb = Mul(ima,imae)
        if (imb > ima) cycle
        if (nlsm_ext(ima) == 0) cycle
        if (nlsm_ext(imb) == 0) cycle
        do la=ibsm_ext(ima),iesm_ext(ima)
          lra = norb_all-la+1
          lbsta = ibsm_ext(imb)
          lbend = iesm_ext(imb)
          if (ima == imb) lbend = la-1
          do lb=lbsta,lbend
            lrb = norb_all-lb+1
            iwe = iwe+1
            wls = wg14*(voint(lra,lr0)+voint(lrb,lr0))-Two*wg14*(vdint(lra,lr0)+vdint(lrb,lr0))
            call prodel(5,wls,jp,iwa,iwe)
          end do
        end do
      end do
      if (ipae /= 18) cycle
      !zz = '  g13     '
      wg13 = -vlop0*v_sqtwo
      do la=1,norb_ext
        lra = norb_all-la+1
        iwe = iwe+1
        wls = wg13*(voint(lra,lr0)-Two*vdint(lra,lr0))
        call prodel(5,wls,jp,iwa,iwe)
        !write(u6,*) ' g13 ',vo(lr0,la),vo(lr0,lb),vmd(lr0,la),vmd(lr0,lb)
      end do
  end select

end do
mh = 0

return

end subroutine diagonal_link_ae

subroutine diagonal_link_ad(mpe,iwa,vlop0,vlop1)

use gugaci_global, only: fg, jb_sys, jpad, jud, just, kk, lsm_inn, norb_dz, norb_frz, ns_sm, pd, pdd, ps1, ps2, ps3, ps4, pt, ptt, &
                         v_onevsqtwo, v_sqtwo, vdint, voint
use Symmetry_Info, only: Mul
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mpe, iwa
real(kind=wp), intent(in) :: vlop0, vlop1
integer(kind=iwp) :: imad, imd, imi, imij, imj, ityad, iwd, iws, iwt, lr, lra, lri, lrj, lrjsta
real(kind=wp) :: fqi, vl0, vl1, wld, wls, wlt, wlv

if (norb_dz == 0) return
ityad = 1
if (jpad /= 1) ityad = (jpad-1)/8+2
imad = mod(jpad-1,8)
if (imad == 0) then
  ityad = ityad-1
  imad = 8
end if
lra = kk(mpe)-1
select case (ityad)
  case default ! (1)
    ! v: d&r&l(3)
    fqi = -fg
    vl0 = fqi*v_sqtwo*vlop0
    wlv = Zero
    !do lr=norb_frz+1,norb_dz
    do lr=1,norb_dz
      wlv = wlv-vl0*vdint(lr,lra)
    end do
    call prodel(4,wlv,mpe,0,iwa)

  case (2)
    !jpad = jd(im)
    fqi = -fg
    do lri=norb_frz+1,norb_dz
      imd = Mul(lsm_inn(lri),ns_sm)
      if (imd /= imad) cycle
      iwd = jud(lri)

      ! d: d&r&l(2)
      vl0 = fqi*v_onevsqtwo*vlop0
      vl1 = pd*vlop1
      wld = -Two*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
      ! d: d&r&l(3)+c"(2)
      vl0 = fqi*v_sqtwo*vlop0
      do lr=1,lri-1
        wld = wld+vl0*(voint(lra,lr)-Two*vdint(lra,lr))
      end do
      ! d: d&r&l(3)
      do lr=lri+1,norb_dz
        wld = wld+vl0*(voint(lra,lr)-Two*vdint(lra,lr))
      end do

      call prodel(4,wld,mpe,iwd,iwa)
    end do

  case (3)
    !jpad = jt(im)
    fqi = fg
    iwt = 0
    do lri=norb_frz+1,norb_dz
      imi = Mul(lsm_inn(lri),ns_sm)
      do lrj=lri+1,norb_dz
        imj = lsm_inn(lrj)
        imij = Mul(imi,imj)
        if (imij /= imad) cycle
        iwt = just(lri,lrj)

        ! t: d&r&l(2)
        ! t: d&r&l(2)+c"(2)
        vl0 = fqi*v_onevsqtwo*vlop0
        vl1 = pt*vlop1
        wlt = -Two*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
        wlt = wlt-Two*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
        vl0 = fqi*v_sqtwo*vlop0
        ! t: d&r&l(3)+c"(2)+c"(2)
        do lr=1,lri-1
          wlt = wlt+vl0*vdint(lr,lra)
        end do
        ! t: d&r&l(3)+c"(2)
        do lr=lri+1,lrj-1
          wlt = wlt+vl0*vdint(lr,lra)
        end do
        ! t: d&r&l(3)
        do lr=lrj+1,norb_dz
          wlt = wlt+vl0*vdint(lr,lra)
        end do
        call prodel(4,wlt,mpe,iwt,iwa)
      end do
    end do

  case (4)
    fqi = fg
    iws = 0
    do lri=norb_frz+1,norb_dz
      if (imad == ns_sm) then
        lrj = lri
        iws = just(lri,lri)
        ! s: d&r&l(3)+c"(0)
        ! s: d&r&l(3)
        vl0 = fqi*v_sqtwo*vlop0
        wls = Zero
        do lr=1,norb_dz
          if (lr == lri) cycle
          wls = wls+vl0*(voint(lra,lr)-Two*vdint(lra,lr))
        end do
        call prodel(4,wls,mpe,iws,iwa)
      end if

      imi = Mul(lsm_inn(lri),ns_sm)
      lrjsta = lri+1
      do lrj=lrjsta,norb_dz
        imj = lsm_inn(lrj)
        imij = Mul(imi,imj)
        if (imij /= imad) cycle
        iws = just(lri,lrj)
        ! s1: d&r&l(1)
        vl0 = fqi*v_onevsqtwo*vlop0
        vl1 = ps1*vlop1
        wls = -Two*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
        ! s4: d&r&l(2)+c"(1)
        vl0 = fqi*v_onevsqtwo*vlop0
        vl1 = ps4*vlop1
        wls = wls-Two*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)

        vl0 = fqi*v_sqtwo*vlop0
        ! s: d&r&l(3)+c"(2)+c"(1)
        do lr=1,lri-1
          wls = wls+vl0*vdint(lr,lra)
        end do
        ! s: d&r&l(3)+c"(1)
        do lr=lri+1,lrj-1
          wls = wls+vl0*vdint(lr,lra)
        end do
        ! s: d&r&l(3)
        do lr=lrj+1,norb_dz
          wls = wls+vl0*vdint(lr,lra)
        end do
        call prodel(4,wls,mpe,iws,iwa)
      end do
    end do

    if (jb_sys == 0) return      !any difference when jb_sys=1 and jb_sy
    fqi = fg
    do lri=norb_frz+1,norb_dz
      imi = Mul(lsm_inn(lri),ns_sm)
      do lrj=lri+1,norb_dz
        imj = lsm_inn(lrj)
        imij = Mul(imi,imj)
        if (imij /= imad) cycle
        !iws = iws+1
        iws = just(lrj,lri)
        ! s1: d&r&l(1)-c"(2)
        vl0 = fqi*v_onevsqtwo*vlop0
        vl1 = ps3*vlop1
        wls = -Two*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)

        ! s3: (11)d&r&l(2)
        vl0 = fqi*v_onevsqtwo*vlop0
        vl1 = ps2*vlop1
        wls = wls-Two*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)

        vl0 = fqi*v_sqtwo*vlop0
        ! s: d&r&l(3)+c"(1)+c"(2)
        do lr=1,lri-1
          wls = wls+vl0*vdint(lr,lra)
        end do
        ! s: d&r&l(3)+c"(2)
        do lr=lri+1,lrj-1
          wls = wls+vl0*vdint(lr,lra)
        end do
        ! s: d&r&l(3)
        do lr=lrj+1,norb_dz
          wls = wls+vl0*vdint(lr,lra)
        end do
        call prodel(4,wls,mpe,iws,iwa)
      end do
    end do

  case (5)
    fqi = -fg
    iwd = 0

    do lri=norb_frz+1,norb_dz
      imd = Mul(lsm_inn(lri),ns_sm)
      if (imd /= imad) cycle
      iwd = jud(lri)

      ! dd1: d&r&l(1)
      vl0 = fqi*v_onevsqtwo*vlop0
      vl1 = pdd*vlop1
      !if ((mpe == 43) .and. (iwd == 1.)) then
      !  write(u6,*)
      !  write(u6,*) lri,lra,vl0,vl1,wld,vlop0,vlop1
      !end if

      wld = -Two*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)

      vl0 = fqi*v_sqtwo*vlop0

      ! d: d&r&l(3)+c"(1)
      do lr=1,lri-1
        wld = wld+vl0*vdint(lr,lra)
      end do

      ! d: d&r&l(3)
      do lr=lri+1,norb_dz
        wld = wld+vl0*vdint(lr,lra)
      end do

      call prodel(4,wld,mpe,iwd,iwa)
    end do

  case (6)
    fqi = fg
    iwt = 0
    do lri=norb_frz+1,norb_dz
      imi = Mul(lsm_inn(lri),ns_sm)
      do lrj=lri+1,norb_dz
        imj = lsm_inn(lrj)
        imij = Mul(imi,imj)
        if (imij /= imad) cycle
        iwt = just(lri,lrj)

        ! tt: d&r&l(1)
        ! tt: d&r&l(1)+c"(1)
        vl0 = fqi*v_onevsqtwo*vlop0
        vl1 = ptt*vlop1
        wlt = -Two*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
        wlt = wlt-Two*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
        vl0 = fqi*v_sqtwo*vlop0
        ! t: d&r&l(3)+c"(1)+c"(1)
        do lr=1,lri-1
          wlt = wlt+vl0*vdint(lr,lra)
        end do
        ! t: d&r&l(3)+c"(1)
        do lr=lri+1,lrj-1
          wlt = wlt+vl0*vdint(lr,lra)
        end do
        ! t: d&r&l(3)
        do lr=lrj+1,norb_dz
          wlt = wlt+vl0*vdint(lr,lra)
        end do

        call prodel(4,wlt,mpe,iwt,iwa)
      end do
    end do
end select

return

end subroutine diagonal_link_ad

subroutine diagonal_link_dae(mh)

use gugaci_global, only: fg, jb_sys, jpad, jud, just, jwh, lsm_inn, norb_dz, norb_frz, ns_sm, pd, pdd, ps1, ps2, ps3, ps4, pt, &
                         ptt, th, thh, v_onevsqtwo, v_sqtwo
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mh
integer(kind=iwp) :: imad, imd, imi, imij, imj, ip, ityad, iwa, iwd, iws, iwt, lri, lrj, lrjsta
real(kind=wp) :: fqi, vij0, vij1, vij2, vl0, vlop0, vlop1

ityad = 1
if (jpad /= 1) ityad = (jpad-1)/8+2
imad = mod(jpad-1,8)
if (imad == 0) then
  ityad = ityad-1
  imad = 8
end if
do ip=1,mh
  iwa = jwh(ip)
  vlop0 = th(ip)
  vlop1 = thh(ip)

  select case (ityad)
    case default ! (1)
      !jpad = 1
      if (abs(vlop0) < 1.0e-30_wp) cycle
      fqi = fg
      ! v: d&r&l(3)
      lri = 0
      lrj = 0
      iwd = 0
      vij0 = Zero
      vij1 = Zero
      vij2 = Zero
      vl0 = fqi*v_sqtwo*vlop0
      call diagonal_call_dae(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)

    case (2)
      !jpad = jd(im)
      fqi = -fg
      lrj = 0
      do lri=norb_frz+1,norb_dz
        imd = Mul(lsm_inn(lri),ns_sm)
        if (imd /= imad) cycle
        iwd = jud(lri)

        ! d: d&r&l(2)
        vij0 = fqi*v_onevsqtwo*vlop0
        vij1 = pd*vlop1
        vij2 = Zero
        ! d: d&r&l(3)+c"(2)
        ! d: d&r&l(3)
        vl0 = fqi*v_sqtwo*vlop0

        call diagonal_call_dae(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)

      end do

    case (3)
      !jpad = jt(im)
      fqi = fg
      iwt = 0
      do lri=norb_frz+1,norb_dz
        imi = Mul(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj = lsm_inn(lrj)
          imij = Mul(imi,imj)
          if (imij /= imad) cycle
          iwt = just(lri,lrj)

          ! t: d&r&l(2)
          ! t: d&r&l(2)+c"(2)
          vij0 = fqi*v_onevsqtwo*vlop0
          vij1 = pt*vlop1
          vij2 = vij1
          ! t: d&r&l(3)+c"(2)+c"(2)
          ! t: d&r&l(3)+c"(2)
          ! t: d&r&l(3)
          vl0 = fqi*v_sqtwo*vlop0

          call diagonal_call_dae(lri,lrj,iwt,iwa,vij0,vij1,vij2,vl0)
        end do
      end do

    case (4)
      fqi = fg
      iws = 0
      do lri=norb_frz+1,norb_dz           !cc
        if (imad == ns_sm) then
          lrj = lri
          iws = just(lri,lri)
          vij0 = Zero
          vij1 = Zero
          vij2 = Zero
          ! s: d&r&l(3)+c"(0)
          ! s: d&r&l(3)
          vl0 = fqi*v_sqtwo*vlop0
          call diagonal_call_dae(lri,lrj,iws,iwa,vij0,vij1,vij2,vl0)
        end if
        imi = Mul(lsm_inn(lri),ns_sm)
        lrjsta = lri+1
        do lrj=lrjsta,norb_dz
          imj = lsm_inn(lrj)
          imij = Mul(imi,imj)
          if (imij /= imad) cycle
          iws = just(lri,lrj)
          ! s2: d&r&l(2)
          ! s4: d&r&l(2)+c"(1)
          vij0 = fqi*v_onevsqtwo*vlop0
          vij1 = ps1*vlop1
          vij2 = ps4*vlop1
          ! s: d&r&l(3)+c"(2)+c"(1)
          ! s: d&r&l(3)+c"(1)
          ! s: d&r&l(3)
          vl0 = fqi*v_sqtwo*vlop0
          call diagonal_call_dae(lri,lrj,iws,iwa,vij0,vij1,vij2,vl0)
        end do
      end do
      if (jb_sys == 0) cycle
      fqi = fg
      do lri=norb_frz+1,norb_dz
        imi = Mul(lsm_inn(lri),ns_sm)
        if (imad == ns_sm) lrjsta = lri
        do lrj=lri+1,norb_dz
          imj = lsm_inn(lrj)
          imij = Mul(imi,imj)
          if (imij /= imad) cycle
          iws = just(lrj,lri)
          ! s1: d&r&l(1)
          ! s3: d&r&l(1)+c"(2)
          vij0 = fqi*v_onevsqtwo*vlop0
          vij1 = ps2*vlop1
          vij2 = ps3*vlop1
          ! s: d&r&l(3)+c"(1)+c"(2)
          ! s: d&r&l(3)+c"(2)
          ! s: d&r&l(3)
          vl0 = fqi*v_sqtwo*vlop0
          call diagonal_call_dae(lri,lrj,iws,iwa,vij0,vij1,vij2,vl0)
        end do
      end do

    case (5)
      fqi = -fg
      lrj = 0
      do lri=norb_frz+1,norb_dz
        imd = Mul(lsm_inn(lri),ns_sm)
        if (imd /= imad) cycle
        iwd = jud(lri)

        ! dd1: d&r&l(1)
        vij0 = fqi*v_onevsqtwo*vlop0
        vij1 = pdd*vlop1
        vij2 = Zero
        ! d: d&r&l(3)+c"(1)
        ! d: d&r&l(3)
        vl0 = fqi*v_sqtwo*vlop0

        call diagonal_call_dae(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)

      end do

    case (6)
      fqi = fg               !aa
      iwt = 0
      do lri=norb_frz+1,norb_dz
        imi = Mul(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj = lsm_inn(lrj)
          imij = Mul(imi,imj)
          if (imij /= imad) cycle
          iwt = just(lri,lrj)

          vij0 = fqi*v_onevsqtwo*vlop0
          ! tt: d&r&l(1)
          vij1 = ptt*vlop1
          ! tt: d&r&l(1)+c"(1)
          vij2 = ptt*vlop1
          ! t: d&r&l(3)+c"(1)+c"(1)
          ! t: d&r&l(3)+c"(1)
          ! t: d&r&l(3)
          vl0 = fqi*v_sqtwo*vlop0
          call diagonal_call_dae(lri,lrj,iwt,iwa,vij0,vij1,vij2,vl0)
        end do
      end do
  end select

end do

return

end subroutine diagonal_link_dae

subroutine diagonal_call_dae(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)

use gugaci_global, only: ibsm_ext, iesm_ext, ipae, jpad, ng_sm, norb_all, norb_dz, norb_ext, v_onevsqtwo, v_sqthreevsqtwo, &
                         v_sqtwo, vdint, voint
use Symmetry_Info, only: Mul
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, iwd, iwa
real(kind=wp), intent(in) :: vij0, vij1, vij2, vl0
integer(kind=iwp) :: ima, imae, imb, ityae, iwe, la, lb, lbend, lbsta, lr, lra, lrb
real(kind=wp) :: vd2lalb, vlop0, vlop1, volalb, vovdla, wg13, wg14, wl

if (norb_dz == 0) return
if (ipae == 1) return   !could not link
ityae = (ipae-1)/8+1
imae = mod(ipae-1,8)
if (imae == 0) then
  ityae = ityae-1
  imae = 8
end if
iwe = 0
! 520 = <a,j,k,a>:13,14(ss=3),38(tt=2),50(dd=1)
! link arc_d
select case (ityae)
  case default ! (1)
    !zz = '  g50  '
    do la=ibsm_ext(imae),iesm_ext(imae)
      lra = norb_all-la+1
      iwe = iwe+1
      vlop0 = vl0*v_onevsqtwo
      wl = Zero
      do lr=1,norb_dz
        if (lr == lri) cycle
        if (lr == lrj) cycle
        wl = wl+vlop0*vdint(lr,lra)    !db space drl(33)- ext space -
      end do
      if (lri >= lrj) then
        vlop0 = vij0*v_onevsqtwo
        vlop1 = -vij1*v_sqthreevsqtwo
        wl = wl+(vlop0-vlop1)*voint(lra,lri)-Two*vlop0*vdint(lra,lri)
        vlop1 = -vij2*v_sqthreevsqtwo
        wl = wl+(vlop0-vlop1)*voint(lra,lrj)-Two*vlop0*vdint(lra,lrj)
        !write(u6,'(a11,2i3,i6,1x,5f10.4)') zz,lr0,la,jwl,vo(lr0,la),vmd(lr0,la),wg50,wwg50,wl
      else
        vlop0 = vij0*v_onevsqtwo
        vlop1 = -vij1*v_sqthreevsqtwo  !db space (22)drl(11)- ext space -g
        wl = wl+(vlop0-vlop1)*voint(lra,lrj)-Two*vlop0*vdint(lra,lrj)
        vlop1 = -vij2*v_sqthreevsqtwo  !db space drl(22)c"(11)- ext space
        wl = wl+(vlop0-vlop1)*voint(lra,lri)-Two*vlop0*vdint(lra,lri)
      end if
      call prodel(6,wl,iwd,iwa,iwe)
    end do

  case (2)
    !zz = '  g38,39  '
    do ima=1,ng_sm
      imb = Mul(ima,imae)
      if (imb > ima) cycle
      do la=ibsm_ext(ima),iesm_ext(ima)
        lra = norb_all-la+1
        lbsta = ibsm_ext(imb)
        lbend = iesm_ext(imb)
        if (ima == imb) lbend = la-1
        do lb=lbsta,lbend
          lrb = norb_all-lb+1
          iwe = iwe+1
          volalb = Zero
          vd2lalb = Zero
          do lr=1,norb_dz
            if (lr == lri) cycle
            if (lr == lrj) cycle
            volalb = volalb+(voint(lra,lr)+voint(lrb,lr))
            vd2lalb = vd2lalb-Two*(vdint(lra,lr)+vdint(lrb,lr))
          end do

          vlop0 = -vl0*v_onevsqtwo
          wl = vlop0*(volalb+vd2lalb)
          if (lri >= lrj) then
            vlop0 = -vij0*v_onevsqtwo
            vlop1 = vij1
            wl = wl+(vlop0-vlop1)*(voint(lra,lri)+voint(lrb,lri))-Two*vlop0*(vdint(lra,lri)+vdint(lrb,lri))
            vlop1 = vij2
            wl = wl+(vlop0-vlop1)*(voint(lra,lrj)+voint(lrb,lrj))-Two*vlop0*(vdint(lra,lrj)+vdint(lrb,lrj))
          else
            vlop0 = -vij0*v_onevsqtwo
            vlop1 = vij1
            wl = wl+(vlop0-vlop1)*(voint(lra,lrj)+voint(lrb,lrj))-Two*vlop0*(vdint(lra,lrj)+vdint(lrb,lrj))
            vlop1 = vij2
            wl = wl+(vlop0-vlop1)*(voint(lra,lri)+voint(lrb,lri))-Two*vlop0*(vdint(lra,lri)+vdint(lrb,lri))
          end if
          !write(u6,*) ' 520 r0,la,lb ',vo(r0,la),vo(r0,lb),vmd(r0,la),vmd(r0,lb)

          call prodel(6,wl,iwd,iwa,iwe)
        end do
      end do
    end do

  case (3)
    !zz = '  g14,15  '
    do ima=1,ng_sm
      imb = Mul(ima,imae)
      if (imb > ima) cycle
      do la=ibsm_ext(ima),iesm_ext(ima)
        lra = norb_all-la+1
        lbsta = ibsm_ext(imb)
        lbend = iesm_ext(imb)
        if (ima == imb) lbend = la-1
        do lb=lbsta,lbend
          lrb = norb_all-lb+1
          iwe = iwe+1
          volalb = Zero
          vd2lalb = Zero
          do lr=1,norb_dz
            if (lr == lri) cycle
            if (lr == lrj) cycle
            volalb = volalb+(voint(lra,lr)+voint(lrb,lr))
            vd2lalb = vd2lalb-Two*(vdint(lra,lr)+vdint(lrb,lr))
          end do

          wg14 = -vl0*v_onevsqtwo
          wl = wg14*(volalb+vd2lalb)

          if ((jpad /= 18) .or. (lri /= lrj)) then
            wg14 = -vij0*v_onevsqtwo
            wl = wl+wg14*(voint(lra,lri)+voint(lrb,lri))-Two*wg14*(vdint(lra,lri)+vdint(lrb,lri))
            wl = wl+wg14*(voint(lra,lrj)+voint(lrb,lrj))-Two*wg14*(vdint(lra,lrj)+vdint(lrb,lrj))
            !write(u6,*) ' 520 r0,la,lb ',vo(r0,la),vo(r0,lb),vmd(r0,la),vmd(r0,lb)
          end if
          call prodel(6,wl,iwd,iwa,iwe)
        end do
      end do
    end do

    if (ipae /= 18) return
    !zz = '  g13     '
    do la=1,norb_ext
      lra = norb_all-la+1
      iwe = iwe+1
      vovdla = Zero
      do lr=1,norb_dz
        if (lr == lri) cycle
        if (lr == lrj) cycle
        vovdla = vovdla+vdint(lr,lra)
      end do

      wg13 = -vl0*v_sqtwo
      wl = wg13*vovdla
      wg13 = -vij0*v_sqtwo
      wl = wl+wg13*(vdint(lri,lra)+vdint(lrj,lra))

      call prodel(6,wl,iwd,iwa,iwe)
      !write(u6,*) ' g13 ',vo(lr0,la),vo(lr0,lb),vmd(lr0,la),vmd(lr0,lb)
    end do
end select

return

end subroutine diagonal_call_dae

subroutine diagonal_dbl()

use gugaci_global, only: ipae, iw_downwei, jb_sys, jpad, jud, just, lsm_inn, norb_dz, norb_frz, ns_sm, nu_ae, vdint, voint
use Symmetry_Info, only: Mul
use Constants, only: Zero, Two, Three, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ipae_, iwa, iwad, iwd, iwdownv, iws, iws1, iwt, jpad1, jpas, jpat, jpat1, lr, lr0, lrg, lrm, mr, mr0, mrm
real(kind=wp) :: db, w1, wld, wld0, wls, wls1, wlt, wt0
integer(kind=iwp), external :: iwalk_ad

if (norb_dz == 0) return
wt0 = Zero
do lr=1,norb_dz
  wt0 = wt0+voint(lr,lr)+voint(lr,lr)+vdint(lr,lr)
end do
do ipae_=1,25
  ipae = ipae_ ! ipae is in global module, is this necessary?
  if (nu_ae(ipae) == 0) cycle
  iwdownv = iw_downwei(1,ipae)
  do iwa=0,iwdownv-1
    !zz = ' doub_800_v'
    iwad = iwalk_ad(1,ipae,iwa,0)
    call prodel(1,wt0,0,ipae,iwad)
    !zz = ' doub_800_s'
  end do
end do
!jps = js(1)
do lr0=norb_frz+1,norb_dz
  mr0 = Mul(lsm_inn(lr0),ns_sm)
  iwd = jud(lr0)
  ! d_800
  jpad = 1+mr0
  jpad1 = jpad+24
  wld = wt0-voint(lr0,lr0)-vdint(lr0,lr0)
  wls = wld-voint(lr0,lr0)
  do ipae_=1,25
    ipae = ipae_ ! ipae is in global module, is this necessary?
    if (nu_ae(ipae) == 0) cycle
    iwdownv = iw_downwei(jpad,ipae)
    do iwa=0,iwdownv-1
      iwad = iwalk_ad(jpad,ipae,iwa,iwd)
      call prodel(1,wld,0,ipae,iwad)
    end do
  end do

  if (jb_sys > 0) then
    do ipae_=1,25
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdownv = iw_downwei(jpad1,ipae)
      do iwa=0,iwdownv-1
        iwad = iwalk_ad(jpad1,ipae,iwa,iwd)
        call prodel(1,wld,0,ipae,iwad)
      end do
    end do
  end if
  ! d_800
  jpad = 17+ns_sm
  iwd = just(lr0,lr0)
  do ipae_=1,25
    ipae = ipae_ ! ipae is in global module, is this necessary?
    if (nu_ae(ipae) == 0) cycle
    iwdownv = iw_downwei(jpad,ipae)
    do iwa=0,iwdownv-1
      iwad = iwalk_ad(jpad,ipae,iwa,iwd)
      call prodel(1,wls,0,ipae,iwad)
    end do
  end do

  if (lr0 == norb_dz) cycle
  wld0 = wld

  do lr=lr0+1,norb_dz
    mr = Mul(mr0,lsm_inn(lr))
    jpat = 9+mr
    jpas = 17+mr
    jpat1 = jpat+24
    iws = just(lr0,lr)
    iwt = iws
    wld = wld0-voint(lr,lr)-vdint(lr,lr)
    do ipae_=1,25
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdownv = iw_downwei(jpat,ipae)
      do iwa=0,iwdownv-1
        iwad = iwalk_ad(jpat,ipae,iwa,iwt)
        call prodel(1,wld,0,ipae,iwad)
      end do
      if (jb_sys > 1) then
        iwdownv = iw_downwei(jpat1,ipae)
        do iwa=0,iwdownv-1
          iwad = iwalk_ad(jpat1,ipae,iwa,iwt)     !t1
          call prodel(1,wld,0,ipae,iwad)
        end do
      end if
      iwdownv = iw_downwei(jpas,ipae)
      do iwa=0,iwdownv-1
        iwad = iwalk_ad(jpas,ipae,iwa,iws)
        call prodel(1,wld,0,ipae,iwad)
      end do
      if (jb_sys > 0) then
        iws1 = just(lr,lr0)
        do iwa=0,iwdownv-1
          iwad = iwalk_ad(jpas,ipae,iwa,iws1)
          call prodel(1,wld,0,ipae,iwad)
        end do
      end if
    end do
  end do
end do
!wl8 = 1/2*hnil*(hnil-1)*vmd(lr,lr)+hnil*voint(lr,lr)  !800
!wl5 = (vlop0-vlop1)*vo(lr0,lr)-2*vlop0*vmd(lr0,lr)
!wl5 = vlop0*vmd(lr,lr0)-vlop1*vo(lr0,lr)              !2000.11.26
wt0 = Zero
do lr0=2,norb_dz
  do lr=1,lr0-1
    ! vlop0=-2 vlop1=0
    wt0 = wt0-Two*vdint(lr,lr0)
  end do
end do
jpad = 1
iwd = 0
do ipae_=1,25
  ipae = ipae_ ! ipae is in global module, is this necessary?
  if (nu_ae(ipae) == 0) cycle
  iwdownv = iw_downwei(jpad,ipae)
  do iwa=0,iwdownv-1
    iwad = iwalk_ad(jpad,ipae,iwa,iwd)
    call prodel(1,wt0,0,ipae,iwad)
  end do
end do
do lrm=norb_frz+1,norb_dz
  mrm = Mul(lsm_inn(lrm),ns_sm)
  iws = just(lrm,lrm)
  iwd = jud(lrm)
  jpad = 1+mrm
  jpad1 = jpad+24
  jpas = 17+ns_sm
  ! d_520
  wld = wt0
  do lr=1,lrm-1
    wld = wld+vdint(lr,lrm)
  end do
  do lr0=lrm+1,norb_dz
    wld = wld+vdint(lrm,lr0)
  end do
  wls = wld
  do lr=lrm+1,norb_dz
    wls = wls+vdint(lrm,lr)
  end do
  do lr0=1,lrm-1
    wls = wls+vdint(lr0,lrm)
  end do
  do ipae_=1,25
    ipae = ipae_ ! ipae is in global module, is this necessary?
    if (nu_ae(ipae) == 0) cycle
    iwdownv = iw_downwei(jpad,ipae)
    do iwa=0,iwdownv-1
      iwad = iwalk_ad(jpad,ipae,iwa,iwd)
      call prodel(1,wld,0,ipae,iwad)
    end do
    if (jb_sys > 0) then
      iwdownv = iw_downwei(jpad1,ipae)
      do iwa=0,iwdownv-1
        iwad = iwalk_ad(jpad1,ipae,iwa,iwd)
        call prodel(1,wld,0,ipae,iwad)
      end do
    end if
    ! 520
    iwdownv = iw_downwei(jpas,ipae)
    do iwa=0,iwdownv-1
      iwad = iwalk_ad(jpas,ipae,iwa,iws)
      call prodel(1,wls,0,ipae,iwad)
    end do
  end do
end do
! 520
do lr0=norb_frz+1,norb_dz-1
  mr0 = Mul(lsm_inn(lr0),ns_sm)
  do lr=lr0+1,norb_dz
    mr = Mul(mr0,lsm_inn(lr))
    jpat = 9+mr
    jpas = 17+mr
    jpat1 = jpat+24
    iws = just(lr0,lr)
    iwt = iws
    iws1 = just(lr,lr0)
    if (jb_sys == 0) then
      wls = wt0+Three*(voint(lr,lr0)-vdint(lr,lr0))
      wlt = wt0+voint(lr,lr0)-Three*vdint(lr,lr0)
    end if
    ! 2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2    w1=0
    !   vo(lr0,lr)+  vmd(lr0,lr)  w0=-1/2  w1=-3/2
    ! 2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2    w1=0
    ! - vo(lr0,lr)+  vmd(lr0,lr)  w0=-1/2  w1=1/2
    if (jb_sys > 0) then
      db = jb_sys
      w1 = -(db+3)/(Two*db+2)
      wls = wt0+(OneHalf-w1)*voint(lr,lr0)-Three*vdint(lr,lr0)
      wlt = wt0+voint(lr,lr0)-Three*vdint(lr,lr0)
      w1 = -(db-1)/(Two*db+2)
      wls1 = wt0+(OneHalf-w1)*voint(lr,lr0)-Three*vdint(lr,lr0)
      ! 2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
      ! (-1/2-w1)*vo(lr0,lr)+vmd(lr0,lr)
      ! w0=-1/2    w1=-(db-1)/(2*db+2)
    end if
    !if (jb_sys > 1) then
    !  wlt1 = wt0+voint(lr,lr0)-3*vdint(lr,lr0)
    !end if
    ! 2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
    !  -vo(lr0,lr)+  vmd(lr0,lr)
    do lrg=1,lr0-1
      wls = wls+vdint(lrg,lr0)+vdint(lrg,lr)
      wlt = wlt+vdint(lrg,lr0)+vdint(lrg,lr)
      if (jb_sys > 0) then
        wls1 = wls1+vdint(lrg,lr0)+vdint(lrg,lr)
      end if
      !if (jb_sys > 1) then
      !  wlt1 = wlt1+vdint(lrg,lr0)+vdint(lrg,lr)
      !end if
      ! 2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
      ! - vo(lr0,lr)+2*vmd(lr0,lr)  w0=-1  w1=0
    end do
    do lrg=lr0+1,lr-1
      wls = wls+vdint(lr0,lrg)+vdint(lrg,lr)
      wlt = wlt+vdint(lr0,lrg)+vdint(lrg,lr)
      if (jb_sys > 0) then
        wls1 = wls1+vdint(lr0,lrg)+vdint(lrg,lr)
      end if
      !if (jb_sys > 1) then
      !  wlt1 = wlt1+vdint(lr0,lrg)+vdint(lrg,lr)
      !end if
      ! 2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
      ! - vo(lr0,lr)+2*vmd(lr0,lr)  w0=-1  w1=0
    end do
    do lrg=lr+1,norb_dz
      wls = wls+vdint(lr0,lrg)+vdint(lr,lrg)
      wlt = wlt+vdint(lr0,lrg)+vdint(lr,lrg)
      if (jb_sys > 0) then
        wls1 = wls1+vdint(lr0,lrg)+vdint(lr,lrg)
      end if
      !if (jb_sys > 1) then
      !  wlt1 = wlt1+vdint(lr0,lrg)+vdint(lr,lrg)
      !end if
    end do
    do ipae_=1,25
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdownv = iw_downwei(jpat,ipae)
      do iwa=0,iwdownv-1
        iwad = iwalk_ad(jpat,ipae,iwa,iwt)
        call prodel(1,wlt,0,ipae,iwad)
      end do
      iwdownv = iw_downwei(jpas,ipae)
      do iwa=0,iwdownv-1
        iwad = iwalk_ad(jpas,ipae,iwa,iws)
        call prodel(1,wls,0,ipae,iwad)
      end do
      if (jb_sys > 0) then
        iwdownv = iw_downwei(jpas,ipae)
        do iwa=0,iwdownv-1
          iwad = iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
          call prodel(1,wls1,0,ipae,iwad)
        end do
      end if
      if (jb_sys > 1) then
        iwdownv = iw_downwei(jpat1,ipae)
        do iwa=0,iwdownv-1
          iwad = iwalk_ad(jpat1,ipae,iwa,iwt)     ! t 1-1
          call prodel(1,wlt,0,ipae,iwad)
        end do
      end if
    end do
  end do
end do

! ------------- end of delm --------------------------------------------
return

end subroutine diagonal_dbl

subroutine diagonal_ext()

use gugaci_global, only: ibsm_ext, iesm_ext, ipae, lsm, norb_all, norb_ext, vdint, voint
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: im, ima, imb, ipas, ipat, jw, jweis, jws, jws0, jwt, la, laend, lasta, lb, lra, lrb, lrzz, mr, mra
real(kind=wp) :: wld, wls, wlt

jws0 = 0
do mra=1,8
  ipae = 1+mra
  lasta = ibsm_ext(mra)
  laend = iesm_ext(mra)
  lrzz = laend-lasta+1
  lrzz = lrzz*(lrzz-1)/2
  jws0 = jws0+lrzz
  jw = 0
  do la=lasta,laend
    !jpd = jd(mra)
    jw = jw+1
    ! d(1)_800
    lra = norb_all-la+1
    wld = voint(lra,lra)
    call prodel(2,wld,0,ipae,jw)
  end do
end do

!zz = ' out_800_s'
!jps = js(1)

jweis = jws0
do la=1,norb_ext
  !jpd = jd(mra)
  lra = norb_all-la+1
  jweis = jweis+1
  ! (3)_800
  wls = Two*voint(lra,lra)+vdint(lra,lra)
  call prodel(2,wls,0,18,jweis)
end do
do im=1,8
  jws = 0
  jwt = 0
  ipat = 9+im
  ipas = 17+im
  do la=2,norb_ext
    lra = norb_all-la+1
    ima = lsm(la)
    do lb=1,la-1
      lrb = norb_all-lb+1
      imb = lsm(lb)
      mr = Mul(ima,imb)
      if (mr /= im) cycle
      !jps = js(mr)
      !jpt = jt(mr)
      jws = jws+1
      jwt = jwt+1
      wls = voint(lra,lra)+voint(lrb,lrb)
      wlt = wls
      wls = wls+voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=-3/2
      wlt = wlt-voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=1/2

      call prodel(2,wls,0,ipas,jws)
      call prodel(2,wlt,0,ipat,jwt)
    end do
  end do
end do

! ------------- end of h_delm ------------------------------------------
return

end subroutine diagonal_ext

subroutine prodel(idb,wl,mg1,mg2,mg3)

use gugaci_global, only: log_prod
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3
real(kind=wp), intent(in) :: wl

if (log_prod == 3) then
  call prodel_pt(idb,wl,mg1,mg2,mg3) ! pt1
else
  call prodel_hd(idb,wl,mg1,mg2,mg3)! form_h
end if

return

end subroutine prodel

!  2001.10.2 for norb_act<>0                          mg1,mg2,mg3:
!  idb=1  in dbl_space         ity_up=0-5             jd_type,jd_im,iwd
!  idb=2  in ext_space         ity_down=0-3           je_type,je_im,iwe
!  idb=3  in act_space         ity_up=0-5,itdown=0,3  jp,     mpe,  iwa
!  idb=4  between dbl and act  ity_up=0-5,itdown=0,3  mpe,    iwd,  iwa
!  idb=5  between act and ext  ity_down=0-3           jp,     iwa,  iwe
!  idb=6  between dbl and ext  ity_down=0-3           iwd,    iwa,  iwe
subroutine prodel_hd(idb,wl,mg1,mg2,mg3)

use gugaci_global, only: ihy, ipae, iseg_downwei, iw_downwei, iy, jpad, jpad_upwei, jphy, mxnode, nu_ad, vector1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, isegdownwei, iw, iwa, iwa0, iwad, iwd, iwe, iwupwei, jdbl, jp, jph, jw, jwd, jwnu, jwu, lwnu, mm, mpe
integer(kind=iwp), external :: iwalk_ad

!ndr = 1
select case (idb)
  case default ! (1)
    ! in dbl_space
    ipae = mg2
    iwad = mg3
    isegdownwei = iseg_downwei(ipae)
    do mm=iwad+1,iwad+isegdownwei
      vector1(mm) = vector1(mm)+wl
      !if (mm == ndr) then
      !  write(u6,'(a8,3i6,2f20.14)') ' in dbl _',mg1,mg2,mg3,wl,vector1(mm)
      !end if
    end do

  case (2)
    ! in ext_space
    ipae = mg2
    iwe = mg3
    do jdbl=1,mxnode
      if (nu_ad(jdbl) == 0) cycle
      iw = iw_downwei(jdbl,ipae)
      iwupwei = jpad_upwei(jdbl)
      do iwa=0,iw-1
        do iwd=0,iwupwei-1
          mm = iwalk_ad(jdbl,ipae,iwa,iwd)+iwe
          vector1(mm) = vector1(mm)+wl
          !if(mm == ndr) then
          !  write(nf2,'(a8,3i6,2f20.14)') ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
          !  write(u6,'(a8,3i6,2f20.14)') ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
          !end if
        end do
      end do
    end do

  case (3)
    ! in act_space
    jp = mg1
    mpe = mg2
    jw = mg3
    iwupwei = jpad_upwei(jpad)
    isegdownwei = iseg_downwei(ipae)
    jph = jphy(jp)
    in_ = ihy(jph)
    lwnu = iy(1,mpe)
    do jwu=jph+1,jph+in_
      iwa = jw+ihy(jwu)-1
      do jwd=1,lwnu
        iwa = iwa+1
        do iwd=0,iwupwei-1
          iwad = iwalk_ad(jpad,ipae,iwa,iwd)
          do iwe=1,isegdownwei
            mm = iwe+iwad
            vector1(mm) = vector1(mm)+wl
            !if (mm == ndr) then
            !  write(u6,'(a8,3i6,2f20.14)') ' in act _',mg1,mg2,mg3,wl,vector1(mm)
            !end if
          end do
        end do
      end do
    end do

  case (4)
    ! between dbl and act
    mpe = mg1
    iwd = mg2
    iwa = mg3-1
    isegdownwei = iseg_downwei(ipae)   ! between dbl and act
    jwnu = iy(1,mpe)
    do ii=1,jwnu
      iwa = iwa+1
      iwad = iwalk_ad(jpad,ipae,iwa,iwd)
      do iwe=1,isegdownwei
        mm = iwe+iwad                  ! iwl=iwalk_ad
        vector1(mm) = vector1(mm)+wl
        !if (mm == ndr) then
        !  write(u6,'(a8,3i6,2f20.14)') ' dbl_act ',mg1,mg2,mg3,wl,vector1(mm)
        !end if
      end do
    end do

  case (5)
    ! between act and ext
    jp = mg1
    iwa0 = mg2
    iwe = mg3
    iwupwei = jpad_upwei(jpad)
    jph = jphy(jp)
    in_ = ihy(jph)
    do jwu=jph+1,jph+in_
      iwa = iwa0+ihy(jwu)
      do iwd=0,iwupwei-1
        iwad = iwalk_ad(jpad,ipae,iwa,iwd)
        mm = iwe+iwad
        vector1(mm) = vector1(mm)+wl
        !if (mm == ndr) then
        !  write(nf2,'(a8,3i6,2f20.14)') ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
        !  write(u6,'(a8,3i6,2f20.14)') ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
        !end if
      end do
    end do

  case (6)
    ! between dbl and ext
    iwd = mg1
    iwa = mg2
    iwe = mg3
    iwad = iwalk_ad(jpad,ipae,iwa,iwd)   ! between dbl,act and ext
    mm = iwe+iwad
    vector1(mm) = vector1(mm)+wl
    !if (mm == ndr) then
    !  write(nf2,'(a8,3i6,2f20.14)') ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
    !  write(u6,'(a8,3i6,2f20.14)') ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
    !end if
end select

return

end subroutine prodel_hd

subroutine prodel_pt(idb,wl,mg1,mg2,mg3)

use gugaci_global, only: ihy, ipae, iy, jpad, jpad_upwei, jpae_downwei, jphy, ndim, vector1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, isegdownwei, iw, iwa, iwa0, iwad, iwd, iwe, iwupwei, jp, jph, jw, jwd, jwnu, jwu, lwnu, mm, mpe
integer(kind=iwp), external :: iwalk_ad

!if ((jpad == 18) .and. (ipae == 2)) ndr=ndim_h0+1

!ndr = 32257+ndim_h0
select case (idb)
  case default ! (1)
    ! in dbl_space
    ipae = mg2
    iwad = mg3
    isegdownwei = jpae_downwei(ipae)
    do mm=iwad+1,iwad+isegdownwei
      vector1(mm) = vector1(mm)+wl
      !if (mm == ndr) then
      !  write(nf2,'(a8,3i6,2f20.14)') ' in dbl _',mg1,mg2,mg3,wl,vector1(mm)
      !  write(u6,'(a8,3i6,2f20.14)') ' in dbl _',mg1,mg2,mg3,wl,vector1(mm)
      !end if
    end do

  case (2)
    ! in ext_space
    ipae = mg2
    iwe = mg3
    iw = ndim
    !iw = iseg_dim(jpad,ipae)
    iwupwei = jpad_upwei(jpad)
    do iwa=0,iw-1
      do iwd=0,iwupwei-1
        mm = iwalk_ad(jpad,ipae,iwa,iwd)+iwe
        vector1(mm) = vector1(mm)+wl
        !if (mm == ndr) then
        !  write(nf2,'(a8,3i6,2f20.14)') ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
        !  write(u6,'(a8,3i6,2f20.14)') ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
        !end if
      end do
    end do

  case (3)
    ! in act_space
    jp = mg1
    mpe = mg2
    jw = mg3
    iwupwei = jpad_upwei(jpad)
    isegdownwei = jpae_downwei(ipae)
    jph = jphy(jp)
    in_ = ihy(jph)
    lwnu = iy(1,mpe)
    do jwu=jph+1,jph+in_
      iwa = jw+ihy(jwu)-1
      do jwd=1,lwnu
        iwa = iwa+1
        do iwd=0,iwupwei-1
          iwad = iwalk_ad(jpad,ipae,iwa,iwd)
          do iwe=1,isegdownwei
            mm = iwe+iwad
            vector1(mm) = vector1(mm)+wl
            !if (mm == ndr) then
            !  write(nf2,'(a8,3i6,2f20.14)') ' in act _',mg1,mg2,mg3,wl,vector1(mm)
            !  write(u6,'(a8,3i6,2f20.14)') ' in act _',mg1,mg2,mg3,wl,vector1(mm)
            !end if
          end do
        end do
      end do
    end do

  case (4)
    ! between dbl and act
    mpe = mg1
    iwd = mg2
    iwa = mg3-1
    isegdownwei = jpae_downwei(ipae)       ! between dbl and act
    jwnu = iy(1,mpe)
    do ii=1,jwnu
      iwa = iwa+1
      iwad = iwalk_ad(jpad,ipae,iwa,iwd)
      do iwe=1,isegdownwei
        mm = iwe+iwad                  ! iwl=iwalk_ad
        vector1(mm) = vector1(mm)+wl
        !if (mm == ndr) then
        !  write(nf2,'(a8,3i6,2f20.14)') ' dbl_act ',mg1,mg2,mg3,wl,vector1(mm)
        !  write(u6,'(a8,3i6,2f20.14)') ' dbl_act ',mg1,mg2,mg3,wl,vector1(mm)
        !end if
      end do
    end do

  case (5)
    ! between act and ext
    jp = mg1
    iwa0 = mg2
    iwe = mg3
    iwupwei = jpad_upwei(jpad)
    jph = jphy(jp)
    in_ = ihy(jph)
    do jwu=jph+1,jph+in_
      iwa = iwa0+ihy(jwu)
      do iwd=0,iwupwei-1
        iwad = iwalk_ad(jpad,ipae,iwa,iwd)
        mm = iwe+iwad
        vector1(mm) = vector1(mm)+wl
        !if (mm == ndr) then
        !  write(nf2,'(a8,3i6,2f20.14)') ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
        !  write(u6,'(a8,3i6,2f20.14)') ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
        !end if
      end do
    end do

  case (6)
    ! between dbl and ext
    iwd = mg1
    iwa = mg2
    iwe = mg3
    iwad = iwalk_ad(jpad,ipae,iwa,iwd)       ! between dbl,act and ext
    mm = iwe+iwad
    vector1(mm) = vector1(mm)+wl
    !if (mm == ndr) then
    !  write(nf2,'(a8,3i6,2f20.14)') ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
    !  write(u6,'(a8,3i6,2f20.14)') ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
    !end if
end select

return

end subroutine prodel_pt

subroutine get_jp(ity,nms,jp,id)

use gugaci_global, only: ns_sm
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ity, nms, id
integer(kind=iwp), intent(out) :: jp
integer(kind=iwp) :: ms

ms = nms
if (id == 1) ms = Mul(nms,ns_sm)
select case (ity)
  case default ! (1)
    jp = 1
  case (2)
    jp = 1+ms
  case (3)
    jp = 9+ms
  case (4)
    jp = 17+ms
  case (5)
    jp = 25+ms
  case (6)
    jp = 33+ms
end select

return

end subroutine get_jp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SINANI(KDGN,IFUNCT,NSS,DIPSOm,SPNSFS)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: KDGN, IFUNCT, NSS
complex(kind=wp), intent(in) :: DIPSOm(3,NSS,NSS)
complex(kind=wp), intent(in) :: SPNSFS(3,NSS,NSS)
integer(kind=iwp) :: i, Ico1, Iso1, j, jCo1, Jso2, l
real(kind=wp) :: gtens(3), maxes(3,3)
character :: angm
real(kind=wp), allocatable :: UMATI(:,:), UMATR(:,:)
complex(kind=wp), allocatable :: DIPSOmSA(:,:,:), MATL(:,:), SPNSO(:,:,:), SPNSOSA(:,:,:), TEMP(:,:), Z(:,:)

if (.false.) then
  write(u6,'(/)')
  write(u6,'(A)') repeat('#',120)
  write(u6,'(25X,A)') 'MATRIX ELEMENTS OF THE MAGNETIC MOMENT IN THE BASIS OF SPIN ORBIT STATES'
  write(u6,'(A)') repeat('#',120)

  do l=1,3
    if (l == 1) angm = 'X'
    if (l == 2) angm = 'Y'
    if (l == 3) angm = 'Z'
    write(u6,'(/)')
    write(u6,'(4X,A12,A2)') 'PROJECTION: ',angm
    write(u6,'(/)')
    do Iso1=1,NSS
      write(u6,'(20(2X,2F10.6))') (DIPSOm(l,Iso1,Jso2),Jso2=1,NSS)
    end do
  end do
  write(u6,'(/)')

end if !if (IPGLOB >= 4)

call mma_allocate(DIPSOmSA,3,KDGN,KDGN,Label='DIPSOmSA')

do Iso1=1,KDGN
  do Jso2=1,KDGN
    Ico1 = Iso1+IFUNCT
    Jco1 = Jso2+IFUNCT
    !write(u6,*) 'DIPSOm',DIPSOm(:,Ico1,Jco1)
    DIPSOmSA(:,Iso1,Jso2) = -DIPSOm(:,Ico1,Jco1)
    !S_SOM(:,i,j) = S_SO(:,ic1,ic2)
  end do
end do

if (.false.) then
  write(u6,*)
  write(u6,'(10X,A)') 'MATRIX ELEMENTS OF THE MAGNETIC MOMENT IN THE BASIS OF SPIN-ORBIT FUNCTIONS'
  do l=1,3
    write(u6,'(/)')
    write(u6,'(5X,A6,I3)') 'AXIS= ',l
    write(u6,*)
    do Ico1=1,KDGN
      write(u6,'(16(2F12.8,2x))') (DIPSOmSA(l,Ico1,Jco1),Jco1=1,KDGN)
    end do
  end do

end if

call ATENS_RASSI(DIPSOmSA,KDGN,gtens,maxes,3)
call mma_deallocate(DIPSOmSA)

if (.false.) then

  call mma_allocate(UMATR,NSS,NSS,Label='UMATR')
  call mma_allocate(UMATI,NSS,NSS,Label='UMATI')
  call mma_allocate(SPNSO,3,NSS,NSS,Label='SPNSO')
  call mma_allocate(Z,NSS,NSS,Label='Z')
  call get_dArray('UMATR_SINGLE',UMATR,NSS**2)
  call get_dArray('UMATI_SINGLE',UMATI,NSS**2)
  write(u6,'(/)')
  write(u6,'(5x,a)') 'umatr and umati'
  write(u6,'(/)')
  do i=1,NSS
    write(u6,'(5x,10(2f14.10,2x))') (UMATR(i,j),UMATI(i,j),j=1,NSS)
  end do

  SPNSO(:,:,:) = cZero

  Z(:,:) = cmplx(UMATR(:,:),UMATI(:,:),kind=wp)
  call mma_deallocate(UMATR)
  call mma_deallocate(UMATI)

  call mma_allocate(TEMP,NSS,NSS,Label='TEMP')
  call mma_allocate(MATL,NSS,NSS,Label='MATL')
  do l=1,3
    MATL(:,:) = SPNSFS(L,:,:)

    call ZGEMM('C','N',NSS,NSS,NSS,cOne,Z,NSS,MATL,NSS,cZero,TEMP,NSS)
    call ZGEMM('N','N',NSS,NSS,NSS,cOne,TEMP,NSS,Z,NSS,cZero,MATL,NSS)

    SPNSO(L,:,:) = MATL(:,:)
  end do !l
  call mma_deallocate(TEMP)
  call mma_deallocate(MATL)

  write(u6,'(/)')
  write(u6,'(A)') repeat('#',120)
  write(u6,'(30X,A)') 'MATRIX ELEMENTS OF THE SPIN MOMENT IN THE BASIS OF SPIN ORBIT STATES'
  write(u6,'(A)') repeat('#',120)
  write(u6,'(/)')
  do l=1,3
    if (l == 1) angm = 'X'
    if (l == 2) angm = 'Y'
    if (l == 3) angm = 'Z'
    write(u6,'(/)')
    write(u6,'(4X,A,A)') 'PROJECTION: ',angm
    write(u6,'(/)')
    do Iso1=1,NSS
      write(u6,'(20(2F10.6,2X))') (SPNSO(l,Iso1,Jso2),Jso2=1,NSS)
    end do
  end do

  call mma_deallocate(Z)
  call mma_allocate(SPNSOSA,3,KDGN,KDGN,Label='SPNSOSA')

  do Iso1=1,KDGN
    do Jso2=1,KDGN
      Ico1 = Iso1+IFUNCT
      Jco1 = Jso2+IFUNCT
      SPNSOSA(:,Iso1,Jso2) = SPNSO(:,Ico1,Jco1)
    end do
  end do

  write(u6,*)
  write(u6,'(10X,A)') 'MATRIX ELEMENTS OF THE SPIN MOMENT IN THE BASIS OF SPIN-ORBIT FUNCTIONS'
  do l=1,3
    write(u6,'(/)')
    write(u6,'(5X,A6,I3)') 'AXIS= ',l
    write(u6,*)
    do Ico1=1,KDGN
      write(u6,'(16(2F12.8,2x))') (SPNSOSA(l,Ico1,Jco1),Jco1=1,KDGN)
    end do
  end do
  call mma_deallocate(SPNSOSA)
  call mma_deallocate(SPNSO)

end if

!do l=1,3
!  do Iso1=1,KDGN
!    do Jso2=1,KDGN
!      Ico1 = Iso1+IFUNCT
!      Jco1 = Jso2+IFUNCT
!      write(u6,*) 'DIPSOm',DIPSOm(l,Ico1,Jco1)
!      IPSOm_SA(l,Iso1,Jso2) = -DIPSOm(l,Ico1,Jco1)
!      S_SOM( l,i,j) = S_SO(l,ic1,ic2)
!    end do
!  end do
!end do

end subroutine SINANI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RToSph(F,nBeta,ishll,lb,iAng,nveccb)
*******************************************************************************
*
*   Transform <core|B> from Cartesian components to Sperical harmonics
*
*******************************************************************************
*    @parameter F  The cartesian components of <core|B>(in)
*                  The spherical components of <core|B>(out)
*    @parameter nBeta Number of exponents
*    @parameter ishll Shell number for ECP
*    @parameter lb angular momenta Ket
*    @parameter iAng angular momenta core
*    @parameter Number of derivatives
*******************************************************************************
      use Real_Spherical
      use Basis_Info, only: Shells
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"
      Dimension F(*)

      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2

*******************************************************************************

      ncb=nelem(lb)*nelem(iang)
      nExpi=Shells(iShll)%nExp
      Call Getmem('TMP1','ALLO','REAL',iptmp,
     &             nExpi*ncb*nVecCB*nBeta)
      Call Getmem('TMP2','ALLO','REAL',ipF,
     &             nExpi*ncb*nVecCB*nBeta)


*-------------1) kj,cbx -> cbx,kj
*
      Call DgeTMo(F,
     &            nBeta*nExpi,nBeta*nExpi,
     &            ncb*nVecCB,Work(ipTmp),ncb*nVecCB)
*
*--------------2) bxkj,C = c,bxkj * c,C
*
      Call DGEMM_('T','N',
     &            nElem(lb)*nVecCB*nExpi*nBeta,
     &            (2*iAng+1),nElem(iAng),
     &            1.0d0,Work(ipTmp),nElem(iAng),
     &            RSph(ipSph(iAng)),nElem(iAng),
     &            0.0d0,Work(ipF),nElem(lb)*nVecCB*nExpi*nBeta)
*
*--------------3) bx,kjC -> kjC,bx
*
               Call DgeTMo(Work(ipF),nElem(lb)*nVecCB,
     &            nElem(lb)*nVecCB,
     &            nExpi*nBeta*(2*iAng+1),Work(ipTmp),
     &            nExpi*nBeta*(2*iAng+1))

      call dcopy_(nExpi*
     &           nBeta*(2*iAng+1)*nElem(lb)*nVecCB,
     &           Work(ipTmp),1,F,1)

      Call Getmem('TMP1','FREE','REAL',iptmp,
     &            nExpi*ncb*nVecCB*nBeta)
      Call Getmem('TMP2','FREE','REAL',ipF,
     &            nExpi*ncb*nVecCB*nBeta)
       Return
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RelEne(ErelMV,ErelDC,nSym,nBas,CMO,OCC,D,OP)
************************************************************************
*                                                                      *
*     Purpose: Compute relativistic correction to energy for a given   *
*              set of natural orbitals and occupation numbers          *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
*
      Dimension nBas(*),CMO(*),OCC(*),D(*),OP(*)
*----------------------------------------------------------------------*
*     Compute 1-particle density matrix in AO basis                    *
*----------------------------------------------------------------------*
      ij=0
      iOff1=0
      iOff2=0
      Do 10 iSym=1,nSym
        nBs=nBas(iSym)
        If ( nBs.eq.0 ) Goto 10
        Do 20 iBas=1,nBs
          Do 30 jBas=1,iBas
            ij=ij+1
            D(ij)=0.0D0
            Do 40 iOrb=1,nBs
              iOff3=iOff1+(iOrb-1)*nBs
              D(ij)=D(ij)
     *             +OCC(iOff2+iOrb)*CMO(iBas+iOff3)*CMO(jBas+iOff3)
40          Continue
            If ( iBas.ne.jBas ) D(ij)=2.0d0*D(ij)
30        Continue
20      Continue
        iOff1=iOff1+nBs*nBs
        iOff2=iOff2+nBs
10    Continue
*----------------------------------------------------------------------*
*     Compute energy contributions                                     *
*----------------------------------------------------------------------*
      lOp=0
      Do iSym=1,nSym
         nBs=nBas(iSym)
         lOp=lOp+(nBs**2+nBs)/2
      End Do
      ErelMV=0.0
      iRc=-1
      iOpt=1
      iComp=1
      Call RdOne(iRc,iOpt,'MassVel ',iComp,OP,iSyLbl)
      If ( iRc.eq.0 ) then
        iRc=-1
        iOpt=6
        iComp=1
        Call RdOne(iRc,iOpt,'MassVel ',iComp,OP,iSyLbl)
        ErelMV = DDOT_(lOP,D,1,OP,1)
      End If
      ErelDC=0.0
      iRc=-1
      iOpt=1
      iComp=1
      Call RdOne(iRc,iOpt,'Darwin  ',iComp,OP,iSyLbl)
      If (iRc.eq.0) then
        iRc=-1
        iOpt=6
        iComp=1
        Call RdOne(iRc,iOpt,'Darwin  ',iComp,OP,iSyLbl)
        ErelDC = DDOT_(lOP,D,1,OP,1)
      End If
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine NxtWrd(Line,iF,iE)
************************************************************************
*                                                                      *
* Object:                                                              *
*                                                                      *
* Called from: DefInt                                                  *
*                                                                      *
* Calling    : None                                                    *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             May '91                                                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Character*(*) Line
*
      nChar = Len(Line)
*     Find first non-blank character
 10   Continue
      If (iF.eq.0.or.iF.gt.nChar) Then
         Call WarningMessage(2,'NxtWrd: iF.eq.0.or.iF.gt.nChar')
         Write (6,*) 'nChar=',nChar
         Write (6,*) 'iF,iE=',iF,iE
         Call Abend()
      End If
      If (Line(iF:iF).eq.' ') Then
         iF = iF + 1
         If (iF.ge.nChar) Then
             iF = nChar
            iE=-1
            Return
         End If
         Go To 10
      End If
*     Find the end of the present word
      iE = iF + 1
 20   Continue
      If (Line(iE:iE).ne.' ') Then
         iE = iE + 1
         If (iE.gt.nChar) Then
            iE=nChar
            Return
         End If
         Go To 20
      Else
         iE = iE - 1
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Kurt Pfingst                                           *
************************************************************************
      SubRoutine CmbnKEr(Rnr,qC,Di,nZeta,la,lb,Zeta,Final,nComp,Alpha,
     &                   nAlpha,Beta,nBeta)
************************************************************************
*     Author: Kurt Pfingst                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "nrmf.fh"
#include "rmat.fh"
#include "gam.fh"
      Real*8 Final(nZeta,nComp,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2),
     *       Zeta(nZeta),Rnr(nZeta,0:la+lb+2),qC(nZeta,0:la+lb),
     *       Di(nZeta,-1:la+lb-1),Alpha(nAlpha),Beta(nBeta)
      Character*80 Label
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
      iRout = 134
      iPrint = nPrint(iRout)
*     Call GetMem(' Enter CmbnKE','LIST','REAL',iDum,iDum)
*
      iComp = 1
      Do 10 ixa = 0, la
      Do 11 ixb = 0, lb
         rx1=DBLE(ixb*(ixb-1))
         n=ixa+ixb
         Do 20 iya = 0, la-ixa
            iza = la-ixa-iya
            ipa= Ind(la,ixa,iza)
         Do 21 iyb = 0, lb-ixb
            izb = lb-ixb-iyb
            ipb= Ind(lb,ixb,izb)
            ry1=DBLE(iyb*(iyb-1))
            m=iya+iyb
            rz1=DBLE(izb*(izb-1))
            k=iza+izb
*
*           Combine integrals
*           define various factors
**************************************************************
            ck1=2d0*DBLE(ixb+iyb+izb)+3d0
**************************************************************
**************************************************************
            const1=rx1*gammath(n+m-2,k)*gammaph(m,n-2)
**************************************************************
            const2=ry1*gammath(n+m-2,k)*gammaph(m-2,n)
**************************************************************
            const3=rz1*gammath(n+m,k-2)*gammaph(m,n)
**************************************************************
            CConst1=const1+const2+const3
**************************************************************
**************************************************************
            CConst2=ck1*gammath(n+m,k)*gammaph(m,n)
**************************************************************
            CConst3=gammath(n+m,k)*gammaph(m,n)
**************************************************************
*           Constants for Bloch term b1/b2/b3
            na=ixa+iya+iza
            nb=ixb+iyb+izb
            b1 =0.5D0*(DBLE(nb)+1.d0)*rmatr**(na+nb+1)
            b1a=0.5D0*(DBLE(na)+1.d0)*rmatr**(na+nb+1)
            W=gammath(n+m,k)*gammaph(m,n)
*
            ibeta=1
            ialpha=1
            kc=1
            Do 30 iZeta = 1, nZeta
               ralpha=alpha(ialpha)
               rbeta=beta(ibeta)
               b2 =rbeta*rmatr**(na+nb+3)
               b2a=ralpha*rmatr**(na+nb+3)
               b3=exp(-Zeta(iZeta)*rmatr*rmatr)
               BBLoch=W*b3*((b1-b2)-bParm*(b1-b2)*(b1a-b2a))
               c0=0.5d0
               c1=-rbeta
               c2= 2d0*rbeta*rbeta
               Final(iZeta,iComp,ipa,ipb) =
     &          BBloch
     &           -(c0*CConst1*Rnr(iZeta,n+m+k-2)+
     &           c1*CConst2*Rnr(iZeta,n+m+k)+
     &           c2*CConst3*Rnr(iZeta,n+m+k+2))
               if(iZeta.eq.kc*nalpha) then
                 ibeta=ibeta+1
                 ialpha=0
                 kc=kc+1
               endif
               ialpha=ialpha+1
30          Continue
*
21       Continue
20       Continue
11    Continue
10    Continue
*
************************************************************************
*
      If (iPrint.ge.99) Then
         Write (6,*) ' Result in Cmbnker1'
         Do ia = 1, (la+1)*(la+2)/2
            Do ib = 1, (lb+1)*(lb+2)/2
               Write (Label,'(A,I2,A,I2,A)')
     *               ' Final(',ia,',',ib,')'
               Call RecPrt(Label,' ',Final(1,1,ia,ib),nZeta,nComp)
            End Do
         End Do
      End If
*
************************************************************************
*
*     Add Coulomb contributions for photoionization calculations
*
*
*
      If(abs(qCoul).gt.Epsq) then
      Do 210 ixa = 0, la
      Do 211 ixb = 0, lb
         Do 220 iya = 0, la-ixa
            iza = la-ixa-iya
            ipa= Ind(la,ixa,iza)
         Do 221 iyb = 0, lb-ixb
           izb = lb-ixb-iyb
           ipb= Ind(lb,ixb,izb)
           lrs=ixa+ixb+iya+iyb+iza+izb
           lcost=iza+izb
           lsint=ixa+ixb+iya+iyb
           lsinf=iya+iyb
           lcosf=ixa+ixb
           Fact=gammath(lsint,lcost)*gammaph(lsinf,lcosf)
           Do 230 iZeta = 1, nZeta
            Final(iZeta,iComp,ipa,ipb) = Final(iZeta,iComp,ipa,ipb)+
     *      Fact * qCoul *  qC(iZeta,lrs)
230        Continue
*
221      Continue
220      Continue
211   Continue
210   Continue
      endif
************************************************************************
*
      If (iPrint.ge.99) Then
         Write (6,*) ' Result in Cmbnker2'
         Do ia = 1, (la+1)*(la+2)/2
            Do ib = 1, (lb+1)*(lb+2)/2
               Write (Label,'(A,I2,A,I2,A)')
     *               ' Final(',ia,',',ib,')'
               Call RecPrt(Label,' ',Final(1,1,ia,ib),nZeta,nComp)
            End Do
         End Do
      End If
*
************************************************************************
*
*     Add DIPOL contributions for photoionization calculations
*
*
*
*
      If(abs(Dipol1).gt.Epsq) then
      Do ixa = 0, la
      Do ixb = 0, lb
         Do iya = 0, la-ixa
            iza = la-ixa-iya
            ipa= Ind(la,ixa,iza)
         Do iyb = 0, lb-ixb
           izb = lb-ixb-iyb
           ipb= Ind(lb,ixb,izb)
           lrs=ixa+ixb+iya+iyb+iza+izb
* Beitrag der x-Komponente
           lcost=iza+izb
           lsint=ixa+ixb+iya+iyb+1
           lsinf=iya+iyb
           lcosf=ixa+ixb+1
           Fact1=Dipol(1)*gammath(lsint,lcost)*gammaph(lsinf,lcosf)
* Beitrag der y-Komponente
           lcost=iza+izb
           lsint=ixa+ixb+iya+iyb+1
           lsinf=iya+iyb+1
           lcosf=ixa+ixb
           Fact2=Dipol(2)*gammath(lsint,lcost)*gammaph(lsinf,lcosf)
* Beitrag der z-Komponente
           lcost=iza+izb+1
           lsint=ixa+ixb+iya+iyb
           lsinf=iya+iyb
           lcosf=ixa+ixb
           Fact3=Dipol(3)*gammath(lsint,lcost)*gammaph(lsinf,lcosf)
* Summe
           Fact=Fact1+Fact2+Fact3
            Do iZeta = 1, nZeta
             Final(iZeta,iComp,ipa,ipb) = Final(iZeta,iComp,ipa,ipb)+
     *       Fact *  Di(iZeta,lrs)
            End do
*
           End do
          End do
         End do
       End do
      endif
************************************************************************
*
*     Call GetMem(' Exit CmbnKE','LIST','REAL',iDum,iDum)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Build_Mp2Dens_Old(TriDens,Density,CMO,mSym,nOrbAll,Diagonalize)

#include "intent.fh"

use Data_Structures, only: DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(_OUT_) :: TriDens(*)
type(DSBA_Type), intent(in) :: Density
integer(kind=iwp), intent(in) :: mSym, nOrbAll(8)
real(kind=wp), intent(in) :: CMO(*)
logical(kind=iwp), intent(in) :: Diagonalize
integer(kind=iwp) :: i, idx, ipSymLin(8), ipSymRec(8), ipSymTri(8), iSym, iUHF, j, lRecTot, LuMP2, nOrbAllMax, nOrbAllTot
character(len=30) :: Note
integer(kind=iwp), allocatable :: IndT(:,:)
real(kind=wp), allocatable :: AORecBlock(:), AOTriBlock(:), EigenValBlock(:), EigenValTot(:), EigenVecBlock(:), EigenVecTot(:), &
                              Energies(:), MOTriBlock(:), TmpRecBlock(:)
integer(kind=iwp), external :: IsFreeUnit
#include "corbinf.fh"

nOrbAllTot = nOrbAll(1)
nOrbAllMax = nOrbAll(1)
lRecTot = nOrbAll(1)*nOrbAll(1)
do iSym=2,mSym
  nOrbAllTot = nOrbAllTot+nOrbAll(iSym)
  nOrbAllMax = max(nOrbAllMax,nOrbAll(iSym))
  lRecTot = lRecTot+nOrbAll(iSym)*nOrbAll(iSym)
end do

! A blockmatrix of the size Orb(iSym) X Orb(iSym) is
! allocated and set to zero
call mma_allocate(AORecBlock,nOrbAllMax**2,label='AORecBlock')
call mma_allocate(TmpRecBlock,nOrbAllMax**2,label='TmpRecBlock')
call mma_allocate(AOTriBlock,nOrbAllMax*(nOrbAllMax+1)/2,label='AOTriBlock')
if (Diagonalize) then
  call mma_allocate(MOTriBlock,nOrbAllMax*(nOrbAllMax+1)/2,label='MOTriBlock')
  call mma_allocate(EigenVecBlock,nOrbAllMax**2,label='EigenVecBlock')
  call mma_allocate(EigenValBlock,nOrbAllMax,label='EigenValBlock')
  call mma_allocate(EigenVecTot,lRecTot,label='EigenVectors')
  call mma_allocate(EigenValTot,nOrbAllTot,label='EigenValues')
  call mma_allocate(Energies,nOrbAllTot,label='Energies')
  call mma_allocate(IndT,7,mSym,label='IndT')
  Energies(:) = Zero
end if
AORecBlock(:) = Zero
TmpRecBlock(:) = Zero
AOTriBlock(:) = Zero

! Setup a pointer to a symmetryblock in rect or tri representation.
ipSymRec(1) = 0
ipSymTri(1) = 1
ipSymLin(1) = 0
do iSym=2,8
  ipSymTri(iSym) = ipSymTri(iSym-1)+(nOrbAll(iSym-1))*(nOrbAll(iSym-1)+1)/2
  ipSymRec(iSym) = ipSymRec(iSym-1)+(nOrbAll(iSym-1))**2
  ipSymLin(iSym) = ipSymLin(iSym-1)+(nOrbAll(iSym-1))
end do

do iSym=1,mSym

  if (nOrbAll(iSym) /= 0) then

    ! Set initial values for the eigenvectors to the CMO-matrix.
    ! If we transform the CMO-matrix in the same way as the MO-matrix
    ! needs to be treated to be diagonal we get a transformation from
    ! AO to canonical basis. Also sets the energies to zero since they
    ! have no physical relevance in this basis.
    if (Diagonalize) then
      do i=1,nOrbAll(iSym)**2
        EigenVecBlock(i) = CMO(ipSymRec(iSym)+i)
      end do
    end if
    ! Transform the symmetryblock to AO-density
    call DGEMM_('N','N',nOrbAll(iSym),nOrbAll(iSym),nOrbAll(iSym),One,CMO(ipSymRec(iSym)+1),nOrbAll(iSym),Density%SB(iSym)%A1, &
                nOrbAll(iSym),Zero,TmpRecBlock,nOrbAll(iSym))
    call DGEMM_('N','T',nOrbAll(iSym),nOrbAll(iSym),nOrbAll(iSym),One,TmpRecBlock,nOrbAll(iSym),CMO(ipSymRec(iSym)+1), &
                nOrbAll(iSym),Zero,AORecBlock,nOrbAll(iSym))
    !call RecPrt('AODens:','(20F8.5)',AORecBlock,nOrb(iSym),nOrb(iSym))
    !call RecPrt('MODens:','(20F8.5)',Work(ip_MORecBlock),nOrb(iSym), nOrb(iSym))
    call Fold_Mat(1,nOrbAll(iSym),AORecBlock,AOTriBlock)
    call dcopy_(nOrbAll(iSym)*(nOrbAll(iSym)+1)/2,AOTriBlock,1,TriDens(ipSymTri(iSym)),1)

    if (Diagonalize) then
      ! Make a normal folded matrix

      idx = 1
      do i=1,nOrbAll(iSym)
        do j=1,i
          MOTriBlock(idx) = Density%SB(iSym)%A2(j,i)
          idx = idx+1
        end do
      end do

      call NIDiag(MOTriBlock,EigenVecBlock,nOrbAll(iSym),nOrbAll(iSym))

      do i=1,nOrbAll(iSym)
        EigenValBlock(i) = MOTriBlock(i*(i+1)/2)
      end do

      call JacOrd3(EigenValBlock,EigenVecBlock,nOrbAll(iSym),nOrbAll(iSym))

#     ifdef _DEBUGPRINT_
      write(u6,*) 'The sorted eigenvalues are'
      do i=1,nOrbAll(iSym)
        write(u6,*) EigenValBlock(i)
      end do
      write(u6,*) 'Eigenvectors sorted'
      do i=1,nOrbAll(iSym)**2
        write(u6,*) EigenVecBlock(i)
      end do
#     endif

      call dcopy_(nOrbAll(iSym)**2,EigenVecBlock,1,EigenVecTot(ipSymRec(iSym)+1),1)
      call dcopy_(nOrbAll(iSym),EigenValBlock,1,EigenValTot(ipSymLin(iSym)+1),1)

    end if

  end if
end do

! Put the MP2 natural orbitals we just produced on disk to the file MP2ORB.

if (Diagonalize) then
  LuMP2 = 50
  LuMP2 = IsFreeUnit(LuMP2)
  ! Build the TypeIndex array
  do iSym=1,mSym
    IndT(1,iSym) = nFro(iSym)
    IndT(2,iSym) = nOcc(iSym)
    IndT(3,iSym) = 0
    IndT(4,iSym) = 0
    IndT(5,iSym) = 0
    IndT(6,iSym) = nOrb(iSym)-nFro(iSym)-nOcc(iSym)-nDel(iSym)
    IndT(7,iSym) = nDel(iSym)
  end do
  Note = '*  Natural MP2 orbitals'
  call WrVec('MP2ORB',LuMP2,'COEI',mSym,nOrbAll,nOrbAll,EigenVecTot,EigenValTot,Energies,IndT,Note)
  ! Create a molden-file
  iUHF = 0
  call Molden_Interface(iUHF,'MP2ORB','MD_MP2')

end if

call mma_deallocate(AORecBlock)
call mma_deallocate(TmpRecBlock)
call mma_deallocate(AOTriBlock)
if (Diagonalize) then
  call mma_deallocate(MOTriBlock)
  call mma_deallocate(EigenVecBlock)
  call mma_deallocate(EigenValBlock)
  call mma_deallocate(EigenVecTot)
  call mma_deallocate(EigenValTot)
  call mma_deallocate(Energies)
  call mma_deallocate(IndT)
end if

return

end subroutine Build_Mp2Dens_Old

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Per-Olof Widmark                                 *
!               1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine iRdOne(rc,Option,InLab,Comp,rData,SymLab)
!***********************************************************************
!                                                                      *
!     Purpose: Read data from one-electron integral file               *
!                                                                      *
!     Calling parameters:                                              *
!     rc      : Return code                                            *
!     Option  : Switch to set options                                  *
!     InLab   : Identifier for the data to read                        *
!     Comp    : Composite identifier to select components              *
!     rData   : contains on output the requested data                  *
!     SymLab  : symmetry label of the requested data                   *
!                                                                      *
!     Global data declarations (Include file):                         *
!     Parm    : Table of paramaters                                    *
!     rcParm  : Table of return codes                                  *
!     Switch  : Table of options                                       *
!     Common  : Common block containing ToC                            *
!     Data    : Data definitions                                       *
!                                                                      *
!     Local data declarations:                                         *
!     Label   : character(len=8), used to covert incoming names        *
!     TmpBuf  : I/O buffer                                             *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark and M.P. Fuelscher                                  *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use OneDat, only: AuxOne, LenOp, lTocOne, MxOp, NaN, nBas, nSym, oAddr, oComp, oLabel, oSymLb, pOp, rcOne, sDbg, sNoNuc, sNoOri, &
                  sOpSiz, sRdCur, sRdFst, sRdNxt, TocOne
use Definitions, only: wp, iwp, u6, RtoI, ItoB

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp), intent(in) :: Option
character(len=*), intent(inout) :: InLab
integer(kind=iwp), intent(inout) :: Comp, SymLab
integer(kind=iwp), intent(_OUT_) :: rData(*)
integer(kind=iwp), parameter :: lBuf = 1024
integer(kind=iwp) :: CmpTmp, CurrOp = 1, i, iDisk, idx, ij, iLen, IndAux, IndDta, iOpt, iRC, j, Length, LuOne, nCopy, nSave, TmpCmp
real(kind=wp) :: AuxBuf(4), TmpBuf(lBuf)
character(len=8) :: Label, TmpLab
logical(kind=iwp) :: debug, doclose
integer(kind=iwp), external :: isFreeUnit

!----------------------------------------------------------------------*
! Start procedure:                                                     *
! Pick up the file definitions                                         *
!----------------------------------------------------------------------*
rc = rcOne%good
LuOne = AuxOne%Lu
!----------------------------------------------------------------------*
! Check the file status                                                *
!----------------------------------------------------------------------*
doclose = .false.
if (.not. AuxOne%Opn) then
  !write(u6,*) ' I will open the file for you!'

  ! Well, I'll open and close it for you under the default name

  LuOne = 77
  LuOne = isFreeUnit(LuOne)
  Label = 'ONEINT  '
  !write(u6,*) 'RdOne: opening OneInt'
  iRC = -1
  iOpt = 0
  call OpnOne(iRC,iOpt,Label,LuOne)
  if (iRC /= 0) then
    write(u6,*) 'RdOne: Error opening file'
    call Abend()
  end if
  doclose = .true.
end if
!----------------------------------------------------------------------*
! Truncate the label to 8 characters and convert it to upper case      *
!----------------------------------------------------------------------*
Label = InLab
call UpCase(Label)
TmpLab = Label
iLen = len(TmpLab)/ItoB
!----------------------------------------------------------------------*
! Print debugging information                                          *
!----------------------------------------------------------------------*
debug = .false.
if (btest(option,sDbg)) debug = .true.
if (debug) then
  write(u6,*) '<<< Entering RdOne >>>'
  write(u6,'(a,z8)') ' rc on entry:     ',rc
  write(u6,'(a,a)') ' Label on entry:  ',Label
  write(u6,'(a,z8)') ' Comp on entry:   ',Comp
  write(u6,'(a,z8)') ' SymLab on entry: ',SymLab
  write(u6,'(a,z8)') ' Option on entry: ',Option
end if
!----------------------------------------------------------------------*
! Check reading mode                                                   *
!----------------------------------------------------------------------*
if (btest(option,sRdFst) .and. btest(option,sRdNxt)) then
  call SysWarnMsg('RdOne','Invalid value','sRdFst and sRdNxt')
else if (btest(option,sRdFst) .and. btest(option,sRdCur)) then
  call SysWarnMsg('RdOne','Invalid value','sRdFst and sRdNxt')
else if (btest(option,sRdNxt) .and. btest(option,sRdCur)) then
  call SysWarnMsg('RdOne','Invalid value','sRdNxt and sRdCur')
end if
!----------------------------------------------------------------------*
! Load back TocOne                                                     *
!----------------------------------------------------------------------*
iDisk = 0
call iDaFile(LuOne,2,TocOne,lTocOne,iDisk)
!----------------------------------------------------------------------*
! Read operators from integral records                                 *
!----------------------------------------------------------------------*
if (btest(option,sRdNxt)) then
  CurrOp = CurrOp+1
  if (CurrOp > MxOp) then
    CurrOp = 0
  else if (TocOne(pOp+LenOp*(CurrOp-1)+oLabel) == NaN) then
    CurrOp = 0
  else
    i = CurrOp
    !LabTmp(1) = TocOne(pOp+LenOp*(i-1)+oLabel)
    !#ifndef _I8_
    !LabTmp(2) = TocOne(pOp+LenOp*(i-1)+oLabel+1)
    !#endif
    idx = pOp+LenOp*(i-1)+oLabel
    TmpLab = transfer(TocOne(idx:idx+iLen-1),TmpLab)
    Label = TmpLab
    InLab = Label
    SymLab = TocOne(pOp+LenOp*(i-1)+oSymLb)
    Comp = TocOne(pOp+LenOp*(i-1)+oComp)
  end if
else if (btest(option,sRdFst)) then
  CurrOp = 1
  if (TocOne(pOp+LenOp*(CurrOp-1)+oLabel) == NaN) then
    CurrOp = 0
  else
    i = CurrOp
    !LabTmp(1) = TocOne(pOp+LenOp*(i-1)+oLabel)
    !#ifndef _I8_
    !LabTmp(2) = TocOne(pOp+LenOp*(i-1)+oLabel+1)
    !#endif
    idx = pOp+LenOp*(i-1)+oLabel
    TmpLab = transfer(TocOne(idx:idx+iLen-1),TmpLab)
    Label = TmpLab
    InLab = Label
    SymLab = TocOne(pOp+LenOp*(i-1)+oSymLb)
    Comp = TocOne(pOp+LenOp*(i-1)+oComp)
  end if
else if (btest(option,sRdCur)) then
  if ((CurrOp < 1) .or. (CurrOp > MxOp)) then
    CurrOp = 0
  else if (TocOne(pOp+LenOp*(CurrOp-1)+oLabel) == NaN) then
    CurrOp = 0
  else
    i = CurrOp
    !LabTmp(1) = TocOne(pOp+LenOp*(i-1)+oLabel)
    !#ifndef _I8_
    !LabTmp(2) = TocOne(pOp+LenOp*(i-1)+oLabel+1)
    !#endif
    idx = pOp+LenOp*(i-1)+oLabel
    TmpLab = transfer(TocOne(idx:idx+iLen-1),TmpLab)
    Label = TmpLab
    InLab = Label
    SymLab = TocOne(pOp+LenOp*(i-1)+oSymLb)
    Comp = TocOne(pOp+LenOp*(i-1)+oComp)
  end if
else
  CurrOp = 0
  do i=MxOp,1,-1
    !LabTmp(1) = TocOne(pOp+LenOp*(i-1)+oLabel)
    !#ifndef _I8_
    !LabTmp(2) = TocOne(pOp+LenOp*(i-1)+oLabel+1)
    !#endif
    idx = pOp+LenOp*(i-1)+oLabel
    TmpLab = transfer(TocOne(idx:idx+iLen-1),TmpLab)
    CmpTmp = TocOne(pOp+LenOp*(i-1)+oComp)
    TmpCmp = Comp
    if ((TmpLab == Label) .and. (CmpTmp == TmpCmp)) CurrOp = i
  end do
end if
if (CurrOp == 0) then
  rc = rcOne%RD03
  !write(u6,*) 'RdOne: Information not available'
  !write(u6,*) 'Option=',Option
  !write(u6,*) 'Comp=',Comp
  !write(u6,*) 'SymLab=',SymLab
  !write(u6,*) 'Label=',Label
else
  SymLab = TocOne(pOp+LenOp*(CurrOp-1)+oSymLb)
  Length = 0
  do i=1,nSym
    do j=1,i
      ij = Mul(i,j)-1
      if (btest(SymLab,ij)) then
        if (i == j) then
          Length = Length+nTri_Elem(nBas(i))
        else
          Length = Length+nBas(i)*nBas(j)
        end if
      end if
    end do
  end do
  rData(1) = Length
  if (.not. btest(option,sOpSiz)) then
    IndAux = 0
    IndDta = 0
    iDisk = TocOne(pOp+LenOp*(CurrOp-1)+oAddr)
    do i=0,Length+3,lBuf
      nCopy = max(0,min(lBuf,Length+4-i))
      nSave = max(0,min(lBuf,Length-i))
      call dDaFile(LuOne,2,TmpBuf,nCopy,iDisk)
      call idCopy(nSave,TmpBuf,1,rData(IndDta+1),1)
      IndDta = IndDta+RtoI*nSave
      do j=nSave+1,nCopy
        IndAux = IndAux+1
        !AuxBuf(IndAux) = TmpBuf(nSave+IndAux)
        AuxBuf(IndAux) = TmpBuf(j)
      end do
    end do
    if (.not. btest(option,sNoOri)) call idCopy(3,AuxBuf,1,rData(IndDta+1),1)
    if (.not. btest(option,sNoNuc)) call idCopy(1,AuxBuf(4),1,rData(IndDta+RtoI*3+1),1)
  end if
end if

if (doclose) then
  !write(u6,*) ' I will close the file for you!'
  iRC = -1
  iOpt = 0
  call ClsOne(iRC,iOpt)
  if (iRC /= 0) then
    write(u6,*) 'RdOne: Error closing file'
    call Abend()
  end if
end if

!----------------------------------------------------------------------*
! Terminate procedure                                                  *
!----------------------------------------------------------------------*
return

! This is to allow type punning without an explicit interface
contains

subroutine idCopy(n,Src,n1,Dst,n2)

  integer(kind=iwp), intent(in) :: n, n1, n2
  real(kind=wp), intent(in) :: Src(*)
  integer(kind=iwp), target, intent(_OUT_) :: Dst(*)
  real(kind=wp), pointer :: dDst(:)

  call c_f_pointer(c_loc(Dst),dDst,[n])
  call dCopy_(n,Src,n1,dDst,n2)
  nullify(dDst)

end subroutine idCopy

end subroutine iRdOne

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Steven Vancoillie                                *
************************************************************************
      module second_quantization
!     Implements determinants of k electrons in n (spin)orbitals as combinations
!     (k,n) represented as bitstrings, using 32-bit integers.  Combinations are
!     represented in lexicographic ordering, and their rank can be computed using
!     a binomial table. The 32st bit is used for to indicate sign. all-one-bits
!     are used to indicate annihilation (destroyed state). Excitation operators
!     can be applied to the determinants and return the resulting determinant.

!     Additionally, a wavefunction is represtented by a structure (derived type)
!     consisting of determinant coefficients resulting from the direct product of
!     separate alpha and beta determinants.

!     Steven Vancoillie, November 2013, Lund

      implicit none
      integer, save :: onebits(0:255), ranktbl(0:255,64)

      contains

      recursive integer function gcd(i,j) result (k)
      implicit none
      integer, intent(in) :: i, j
      if (j.eq.0) then
        k = i
      else
        k = gcd(j,mod(i,j))
      end if
      end function gcd

      integer function binom_coef(k,n)
      ! compute binomial coefficient
      ! returns #k-subsets out of n choices
      implicit none
      integer, intent(in) :: k, n
      integer :: i, frac(2), div
      if (k .gt. n) then
        binom_coef = 0
      else
        frac = 1
        do i=1,k
          frac(1) = frac(1) * (n-k+i)
          frac(2) = frac(2) * i
          div = gcd(frac(1),frac(2))
          if (div.gt.1) then
            frac = frac / div
          end if
        end do
        binom_coef = frac(1)/frac(2)
      end if
      end function binom_coef

      integer function lex_init(k,n) result(c)
      ! initialize the first combination
      implicit none
      integer, intent(in) :: k, n
      if (k .gt. n) then
        c = 0
      else
        c = 2**k - 1
      end if
      end function lex_init

      integer function lex_next(c) result(d)
      ! generate the next lexicographic bit combination
      implicit none
      integer, intent(in) :: c
      integer :: t, s
      t = ior(c,c-1)+1
      s = iand(not(t-1),t)-1
      d = ior(t,ishft(s,-(trailz_(c)+1)))
      end function lex_next

      integer function trailz_(c)
      implicit none
      integer, intent(in) :: c
#include "compiler_features.h"
#ifdef TRAILING_ZEROS
      trailz_ = trailz(c)
#else
      ! simple trailing zero computation, only used when the trailz
      ! intrinsic is not supported.
      integer :: t
      t = c
      trailz_ = 0
      if (iand(t,z'FFFF') == 0) then
        t = ishft(t,-16)
        trailz_ = trailz_ + 16
      end if
      if (iand(t,z'FF') == 0) then
        t = ishft(t,-8)
        trailz_ = trailz_ + 8
      end if
      if (iand(t,z'F') == 0) then
        t = ishft(t,-4)
        trailz_ = trailz_ + 4
      end if
      if (iand(t,z'3') == 0) then
        t = ishft(t,-2)
        trailz_ = trailz_ + 2
      end if
      if (iand(t,z'1') == 0) then
        t = ishft(t,-1)
        trailz_ = trailz_ + 1
      end if
      trailz_ = trailz_ + iand(not(t),1)
#endif
      end function trailz_

      subroutine rank_init
      ! initializes a rank table indexed as:
      !      1 2   3    4        8
      !      1 1-8 1-16 1-24 ... 1-56
      !  0
      !  1
      !  ...
      !  255
      ! the row index is a hash table using the
      ! bit representation of a byte section.
      ! the columns refer to the position of
      ! a byte section and the number of possible
      ! preceding one-bits
      integer :: irow, icol, ibyte, ioffset
      integer :: ibit, ipos
      integer :: irank

      do irow = 0, 255
        onebits(irow) = 0
        do ibit = 0, 7
          if (btest(irow,ibit)) then
            onebits(irow) = onebits(irow) + 1
          end if
        end do
      end do

      do irow = 0, 255
        ! compute rank for first byte
        irank = 0
        ipos = 0
        do ibit = 0, 7
          if (btest(irow,ibit)) then
            ipos = ipos + 1
            irank = irank + binom_coef(ipos,ibit)
          end if
        end do
        icol = 1
        ranktbl(irow,icol) = irank
        ! compute rank for subsequent bytes
        ! depending on the number of preceding
        ! one-bits in the previous bytes
        do ibyte = 2, 4
          do ioffset = 0, 8*(ibyte-1)
            icol = icol + 1
            ! compute rank
            irank = 0
            ipos = ioffset
            do ibit = 0, 7
              if (btest(irow,ibit)) then
                ipos = ipos + 1
                irank = irank + binom_coef(ipos,ibit+8*(ibyte-1))
              end if
            end do
            ranktbl(irow,icol) = irank
          end do
        end do
      end do
      end subroutine rank_init

      integer function lexrank(c)
      integer, intent(in) :: c
      integer :: byte(4), ones(4)
      lexrank = 0
      if (c.eq.-1) return
      byte(1) = ibits(c, 0,8)
      byte(2) = ibits(c, 8,8)
      byte(3) = ibits(c,16,8)
      byte(4) = ibits(c,24,6)
      ones(1) = onebits(byte(1))
      ones(2) = onebits(byte(2)) + ones(1)
      ones(3) = onebits(byte(3)) + ones(2)
      lexrank = 1 + ranktbl(byte(1), 1) +
     & ranktbl(byte(2), 2+ones(1)) +
     & ranktbl(byte(3),11+ones(2)) +
     & ranktbl(byte(4),28+ones(3))
      end function lexrank

      integer function fase(c)
      integer, intent(in) :: c
      if (btest(c,31)) then
        fase=-1
      else
        fase=1
      end if
      end function fase

      integer function ex1(p,q,c) result(d)
      implicit none
      integer, intent(in) :: p, q, c
      integer :: t
      d = c
      if (.not.btest(d,q-1)) then
        d = -1
        return
      end if
      d = ibclr(d,q-1)
      if (btest(d,p-1)) then
        d = -1
        return
      end if
      d = ibset(d,p-1)
      if(p.gt.q) then
        t=ibits(d,q,p-q-1)
      else if (p.lt.q) then
        t=ibits(d,p,q-p-1)
      else
        return
      end if
      do while (t.ne.0)
        d = ieor(ishft(iand(t,1),31),d)
        t = ishft(t,-1)
      end do
      end function ex1

      integer function ann(p,c) result(d)
      ! operates on determinant c with (a_p)
      ! and returns the resulting determinant with
      ! the sign in the highest bit (1 = negative)
      integer, intent(in) :: p, c
      integer :: t, b_1111, z_6996
      data b_1111 /b'1111'/
      data z_6996 /z'6996'/
      if (.not.btest(c,p-1)) then
        d = -1
        return
      end if
      d = ibclr(c,p-1)
      t = ibits(d,0,p-1)
      t = ieor(t,ishft(t,-16))
      t = ieor(t,ishft(t,-8))
      t = ieor(t,ishft(t,-4))
      t = iand(t,b_1111)
      t = iand(ishft(z_6996,-t),1)
      d = ieor(ishft(t,31),d)
      end function ann

      integer function cre(p,c) result(d)
      ! operates on determinant c with (a+_p)
      ! and returns the resulting determinant with
      ! the sign in the highest bit (1 = negative)
      integer, intent(in) :: p, c
      integer :: t, b_1111, z_6996
      data b_1111 /b'1111'/
      data z_6996 /z'6996'/
      if (btest(c,p-1)) then
        d = -1
        return
      end if
      d = ibset(c,p-1)
      t = ibits(d,0,p-1)
      t = ieor(t,ishft(t,-16))
      t = ieor(t,ishft(t,-8))
      t = ieor(t,ishft(t,-4))
      t = iand(t,b_1111)
      t = iand(ishft(z_6996,-t),1)
      d = ieor(ishft(t,31),d)
      end function cre

      integer function ann2(p,q,c) result(d)
      ! operates on determinant c with (a_p a_q)
      ! and returns the resulting determinant with
      ! the sign in the highest bit (1 = negative)
      implicit none
      integer, intent(in) :: p, q, c
      integer :: t, b_1111, z_6996
      data b_1111 /b'1111'/
      data z_6996 /z'6996'/
      if (.not.(btest(c,q-1).and.btest(c,p-1))) then
        d = -1
        return
      end if
      d = ibclr(c,q-1)
      d = ibclr(d,p-1)
      if(q.lt.p) then
        t=ibits(d,q,p-q-1)
      else if (p.lt.q) then
        t=ibits(d,p,q-p-1)
        d=ieor(ishft(1,31),d)
      else
        d = -1
        return
      end if
      t = ieor(t,ishft(t,-16))
      t = ieor(t,ishft(t,-8))
      t = ieor(t,ishft(t,-4))
      t = iand(t,b_1111)
      t = iand(ishft(z_6996,-t),1)
      d = ieor(ishft(t,31),d)
      end function ann2

      integer function cre2(p,q,c) result(d)
      ! operates on determinant c with (a+_p a+_q)
      ! and returns the resulting determinant with
      ! the sign in the highest bit (1 = negative)
      implicit none
      integer, intent(in) :: p, q, c
      integer :: t, b_1111, z_6996
      data b_1111 /b'1111'/
      data z_6996 /z'6996'/
      if ((btest(c,q-1).or.btest(c,p-1))) then
        d = -1
        return
      end if
      d = ibset(c,q-1)
      d = ibset(d,p-1)
      if(q.lt.p) then
        t=ibits(d,q,p-q-1)
        d=ieor(ishft(1,31),d)
      else if (p.lt.q) then
        t=ibits(d,p,q-p-1)
      else
        d = -1
        return
      end if
      t = ieor(t,ishft(t,-16))
      t = ieor(t,ishft(t,-8))
      t = ieor(t,ishft(t,-4))
      t = iand(t,b_1111)
      t = iand(ishft(z_6996,-t),1)
      d = ieor(ishft(t,31),d)
      end function cre2

#ifdef __PGI
      ! PGI Fortran compiler version of ibits does not work correctly when
      ! LEN == 0
      integer function ibits(c,pos,len) result(d)
      implicit none
      integer, intent(in) :: c, pos, len
      d = ishft(not(0),-(bit_size(d)-len))
      d = iand(ishft(c,-pos),d)
      return
      end function
#endif

      end module second_quantization

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cre_dyn()
!  MV: Create a dynamix file. If another .dyn.h5 file already
!  exists, it will be overwritten.

#ifdef _HDF5_
use mh5, only: mh5_create_file, mh5_init_attr, mh5_init_dset, mh5_create_dset_real, mh5_create_dset_str, mh5_create_dset_int, &
               mh5_put_dset, mh5_fetch_attr, mh5_close_file, mh5_open_file_r, mh5_exists_attr, mh5_close_dset
use Dynamix_Globals, only: dyn_dt, dyn_etot, dyn_etot0, dyn_fileid, dyn_geom, dyn_mass, dyn_nh, dyn_time, dyn_vel, nh
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: natoms, nsym, nstates, nconfs, dyn_dsetid, surf_dsetid, wfn_fileid, ii
character(len=8) :: method
real(kind=wp), allocatable :: coord(:,:), ener(:), ciarray(:), overlap_save(:)
#include "Molcas.fh"
character(len=LenIn), allocatable :: atomlbl(:)
logical(kind=iwp) :: found
complex(kind=wp), allocatable :: amatrix(:)

! Create a new dynamix file!
dyn_fileid = mh5_create_file('DYN')

! Set module type
call mh5_init_attr(dyn_fileid,'MOLCAS_MODULE','DYNAMIX')

! Copy basic molecular information to the HDF5 file
! Morgane Vacher: Need to be able to modify the geom
! but could not make it work with run2h5
! call run2h5_molinfo(dyn_fileid)

! Symmetry
call mh5_init_attr(dyn_fileid,'NSYM',1)
call get_iScalar('nSym',nsym)
if (nsym > 1) then
  call get_iScalar('LP_nCenter',natoms)
else
  call Get_iScalar('Unique atoms',natoms)
end if

! Number of atoms
call mh5_init_attr(dyn_fileid,'NATOMS_UNIQUE',natoms)

! Nuclear geometry
dyn_geom = mh5_create_dset_real(dyn_fileid,'CENTER_COORDINATES',1,[3*natoms])
call mh5_init_attr(dyn_geom,'DESCRIPTION','Geometry in cartesians coordinates at the current time step')
call mma_allocate(coord,3,natoms)
if (nsym > 1) then
  call get_dArray('LP_Coor',coord,3*natoms)
else
  call Get_dArray('Unique Coordinates',coord,3*natoms)
end if
call mh5_put_dset(dyn_geom,coord)
call mma_deallocate(coord)

! Atom labels
dyn_dsetid = mh5_create_dset_str(dyn_fileid,'CENTER_LABELS',1,[natoms],LENIN)
call mh5_init_attr(dyn_dsetid,'DESCRIPTION','Center labels arranged as a [NATOMS] block')
call mma_allocate(atomlbl,natoms)
if (nsym > 1) then
  call get_cArray('LP_L',atomlbl,LenIn4*natoms)
else
  call Get_cArray('Unique Atom Names',atomlbl,LenIn*natoms)
end if
call mh5_put_dset(dyn_dsetid,atomlbl)
call mma_deallocate(atomlbl)
call mh5_close_dset(dyn_dsetid)

! Current time
dyn_time = mh5_create_dset_real(dyn_fileid,'TIME')
call mh5_init_attr(dyn_time,'DESCRIPTION','Current time of the Molecular Dynamics')

! Time step
dyn_dt = mh5_create_dset_real(dyn_fileid,'TIME_STEP')
call mh5_init_attr(dyn_dt,'DESCRIPTION','Time step of the Molecular Dynamics')

! Total energy at t=0
dyn_etot0 = mh5_create_dset_real(dyn_fileid,'ETOT_0')
call mh5_init_attr(dyn_etot0,'DESCRIPTION','Total energy at t=0')

! Total energy at current time
dyn_etot = mh5_create_dset_real(dyn_fileid,'ETOT')
call mh5_init_attr(dyn_etot,'DESCRIPTION','Total energy at current time')

! Velocities
dyn_vel = mh5_create_dset_real(dyn_fileid,'VELOCITIES',1,[3*natoms])
call mh5_init_attr(dyn_vel,'DESCRIPTION','Velocities in cartesians coordinates at the current time step')

! NoseHoover
dyn_nh = mh5_create_dset_real(dyn_fileid,'NOSEHOOVER',1,[nh])
call mh5_init_attr(dyn_nh,'DESCRIPTION','NoseHoover degrees of freedom')

! MaxHop
! Morgane Vacher: Dataset only created if needed since its existence serves as a flag.
call qpg_iScalar('MaxHops',Found)
if (Found) then
  call get_iScalar('MaxHops',ii)
  call mh5_init_dset(dyn_fileid,'MAX_HOP',ii)
end if

! Isotopes
dyn_mass = mh5_create_dset_real(dyn_fileid,'MASSES',1,[natoms])
call mh5_init_attr(dyn_mass,'DESCRIPTION','Atomic masses, in a.u.')

! The following variables are relevant to the SURFACEHOP module.
! They are not modified by the DYNAMIX module but saved here on the H5 file.
! This way, the informations saved are consistent, ie belong to the same step.

! Seed number
call qpg_iscalar('Seed',Found)
if (Found) then
  surf_dsetid = mh5_create_dset_int(dyn_fileid,'SEED')
  call mh5_init_attr(surf_dsetid,'DESCRIPTION','Seed number')
  call get_iscalar('Seed',ii)
  call mh5_put_dset(surf_dsetid,ii)
  call mh5_close_dset(surf_dsetid)
end if

! Number of hops
call qpg_iscalar('Number of Hops',Found)
if (Found) then
  surf_dsetid = mh5_create_dset_int(dyn_fileid,'NO. OF HOPS')
  call mh5_init_attr(surf_dsetid,'DESCRIPTION','Number of hops')
  call get_iscalar('Number of Hops',ii)
  call mh5_put_dset(surf_dsetid,ii)
  call mh5_close_dset(surf_dsetid)
end if

! Maximum number of hops in Tully
call qpg_iscalar('MaxHopsTully',Found)
if (Found) then
  surf_dsetid = mh5_create_dset_int(dyn_fileid,'MAX_HOP_TULLY')
  call mh5_init_attr(surf_dsetid,'DESCRIPTION','Maximum number of hops in Tully algorithm')
  call get_iscalar('MaxHopsTully',ii)
  call mh5_put_dset(surf_dsetid,ii)
  call mh5_close_dset(surf_dsetid)
end if

call get_carray('Relax Method',method,8)
! This is only read if using the RASSCF program
!   Note that there is no implication all of these will actually work,
!   the point here is simply to skip this block if using e.g. SCF
if ((method(1:3) == 'CAS') .or. (method(1:3) == 'RAS') .or. (method(1:3) == 'GAS') .or. (method(1:4) == 'DMRG')) then

  ! Relax CASSCF root
  call qpg_iscalar('Relax CASSCF root',Found)
  if (Found) then
    surf_dsetid = mh5_create_dset_int(dyn_fileid,'RELAX CAS ROOT')
    call mh5_init_attr(surf_dsetid,'DESCRIPTION','Relax CASSCF root')
    call get_iscalar('Relax CASSCF root',ii)
    call mh5_put_dset(surf_dsetid,ii)
    call mh5_close_dset(surf_dsetid)
  end if

  ! Read number of states and configurations from rasscf.h5 file
  wfn_fileid = mh5_open_file_r('RASWFN')
  if (mh5_exists_attr(wfn_fileid,'NSTATES') .and. mh5_exists_attr(wfn_fileid,'NCONF')) then
    call mh5_fetch_attr(wfn_fileid,'NSTATES',nstates)
    call mh5_fetch_attr(wfn_fileid,'NCONF',nconfs)
    call mh5_init_attr(dyn_fileid,'NSTATES',nstates)
    call mh5_init_attr(dyn_fileid,'NCONFS',nconfs)

    ! Energies at the previous step
    call qpg_darray('VenergyP',Found,nstates)
    if (Found) then
      surf_dsetid = mh5_create_dset_real(dyn_fileid,'ENERG PREV',1,[nstates])
      call mh5_init_attr(surf_dsetid,'DESCRIPTION','Potential energies at the previous time step')
      call mma_allocate(ener,nstates)
      call get_darray('VenergyP',ener,nstates)
      call mh5_put_dset(surf_dsetid,ener)
      call mma_deallocate(ener)
      call mh5_close_dset(surf_dsetid)
    end if

    ! CI coeffs at the previous step
    call qpg_darray('AllCIP',Found,nstates*nconfs)
    if (Found) then
      surf_dsetid = mh5_create_dset_real(dyn_fileid,'CI PREV',1,[nstates*nconfs])
      call mh5_init_attr(surf_dsetid,'DESCRIPTION','CI coeffs at the previous time step')
      call mma_allocate(ciarray,nstates*nconfs)
      call get_darray('AllCIP',ciarray,nstates*nconfs)
      call mh5_put_dset(surf_dsetid,ciarray)
      call mma_deallocate(ciarray)
      call mh5_close_dset(surf_dsetid)
    end if

    ! CI coeffs at the step before the previous step
    call qpg_darray('AllCIPP',Found,nstates*nconfs)
    if (Found) then
      surf_dsetid = mh5_create_dset_real(dyn_fileid,'CI PPREV',1,[nstates*nconfs])
      call mh5_init_attr(surf_dsetid,'DESCRIPTION','CI coeffs at the step before the previous time step')
      call mma_allocate(ciarray,nstates*nconfs)
      call get_darray('AllCIPP',ciarray,nstates*nconfs)
      call mh5_put_dset(surf_dsetid,ciarray)
      call mma_deallocate(ciarray)
      call mh5_close_dset(surf_dsetid)
    end if

    ! A matrix V
    call Qpg_zArray('AmatrixV',Found,nstates*nstates)
    if (Found) then
      call mma_allocate(Amatrix,nstates*nstates)
      call get_zarray('AmatrixV',Amatrix,NSTATES*NSTATES)
      ! HDF5 format does not deal with complex numbers so split manually into
      ! real and imaginary parts and save 2 datasets
      ! Real part
      surf_dsetid = mh5_create_dset_real(dyn_fileid,'AMATRIXV-R',1,[nstates*nstates])
      call mh5_init_attr(surf_dsetid,'DESCRIPTION','real part of AmatrixV')
      call mh5_put_dset(surf_dsetid,real(Amatrix))
      call mh5_close_dset(surf_dsetid)
      ! Imaginary part
      surf_dsetid = mh5_create_dset_real(dyn_fileid,'AMATRIXV-I',1,[nstates*nstates])
      call mh5_init_attr(surf_dsetid,'DESCRIPTION','imaginary part of AmatrixV')
      call mh5_put_dset(surf_dsetid,aimag(Amatrix))
      call mh5_close_dset(surf_dsetid)
      call mma_deallocate(Amatrix)
    end if

    ! <t-2dt|t-dt> RASSI overlap
    call qpg_darray('SH_Ovlp_Save',Found,nstates*nstates)
    if (Found) then
      surf_dsetid = mh5_create_dset_real(dyn_fileid,'RASSI_SAVE_OVLP',1,[nstates*nstates])
      call mh5_init_attr(surf_dsetid,'DESCRIPTION','RASSI overlap between t-2dt and t-dt')
      call mma_allocate(overlap_save,nstates*nstates)
      call get_darray('SH_Ovlp_Save',overlap_save,nstates*nstates)
      call mh5_put_dset(surf_dsetid,overlap_save)
      call mma_deallocate(overlap_save)
      call mh5_close_dset(surf_dsetid)
    end if
  end if

  call mh5_close_file(wfn_fileid)

end if

#endif
end subroutine cre_dyn

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function distance(N,C1,C2)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: distance
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: C1(N), C2(N)
integer(kind=iwp) :: i
real(kind=wp) :: R, X

X = Zero
do i=1,N
  R = C1(i)-C2(i)
  X = X+R*R
end do
distance = sqrt(X)

return

end function distance

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Trnsps_Seward(ijCmp,iCmp,jCmp,iAng,jAng,iShll,jShll,kOp,ijkl,ij,AOInt,Scrtch)
!***********************************************************************
!                                                                      *
!  Object: to transpose the integrals in order to resolve the          *
!          redundancy (faA,fbB)=(fcC,fdD). In this case both sides will*
!          have the same DCR, i.e. (R)=(S). In this case we will only  *
!          need the unique combinations. For the off diagonal comb-    *
!          inations (R=/=S) we will pick up two terms. The terms are   *
!          (faA,fbR(B)|faT(A),fbTS(B)) and                             *
!          (faA,fbS(B)|faT(A),fbTR(B)). Since T and T-1 are the same   *
!          in D2h it is simple to see that after applying T on the     *
!          second integral we will end up with the first one.          *
!                                                                      *
!          However, since we compute the integrals in batches there    *
!          will not be a simple one to one correspondes between the    *
!          integrals in batch one and two. But after transposing the   *
!          pair arguments we will achive that one to one correspondens.*
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             May '90                                                  *
!***********************************************************************

use Index_Functions, only: nTri3_Elem
use Basis_Info, only: Shells
use Real_Spherical, only: iSphCr
use Symmetry_Info, only: iChBas
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ijCmp, iCmp, jCmp, iAng, jAng, iShll, jShll, kOp, ijkl, ij
real(kind=wp), intent(inout) :: AOInt(ijkl,ijCmp,ijCmp)
real(kind=wp), intent(out) :: Scrtch(ijkl,ijCmp,ijCmp)
integer(kind=iwp) :: i1, i12, i2, i3, i34, i4, iChBs, ii, ij1, ij2, jChBs, jj, kChBs, lChBs
real(kind=wp) :: Factor, pa1T, pa2T, pb1T, pb2T
integer(kind=iwp), external :: iPrmt

!call RecPrt(' In Trnsps: AOInt ',' ',AOInt,ijkl,ijCmp*ijCmp)

! Change phase factor. This is only necessary if T=/=E.

if ((kOp /= 0) .and. (ijCmp /= 0)) then
  ii = nTri3_Elem(iAng)
  jj = nTri3_Elem(jAng)
  do i1=1,iCmp
    iChBs = iChBas(ii+i1)
    if (Shells(iShll)%Transf) iChBs = iChBas(iSphCr(ii+i1))
    pa1T = real(iPrmt(kOp,iChBs),kind=wp)
    do i2=1,jCmp
      jChBs = iChBas(jj+i2)
      if (Shells(jShll)%Transf) jChBs = iChBas(iSphCr(jj+i2))
      pb1T = real(iPrmt(kOp,jChBs),kind=wp)
      ij1 = iCmp*(i2-1)+i1

      do i3=1,iCmp
        kChBs = iChBas(ii+i3)
        if (Shells(iShll)%Transf) kChBs = iChBas(iSphCr(ii+i3))
        pa2T = real(iPrmt(kOp,kChBs),kind=wp)
        do i4=1,jCmp
          lChBs = iChBas(jj+i4)
          if (Shells(jShll)%Transf) lChBs = iChBas(iSphCr(jj+i4))
          pb2T = real(iPrmt(kOp,lChBs),kind=wp)
          ij2 = iCmp*(i4-1)+i3
          Factor = pa1T*pb1T*pa2T*pb2T
          if (Factor /= One) AOInt(:,ij1,ij2) = Factor*AOInt(:,ij1,ij2)
        end do
      end do
    end do
  end do
end if

! Transpose ijkl,abcd to klij,cdab

if ((ijCmp == 1) .or. (ij == 1)) then
  call DGeTMI(AOInt,ijCmp*ij,ijCmp*ij)
else
  do i12=1,ijCmp
    do i34=1,ijCmp
      call DGeTMO(AOInt(:,i12,i34),ij,ij,ij,Scrtch(:,i34,i12),ij)
    end do
  end do
  AOInt(:,:,:) = Scrtch(:,:,:)
end if

!call RecPrt(' Exit Trnsps: AOInt ',' ',AOInt,ijkl,ijCmp*ijCmp)

end subroutine Trnsps_Seward

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
*               Valera Veryazov                                        *
************************************************************************
      SubRoutine DrvMO(iRun,INPORB)
************************************************************************
* Adapted from SAGIT to work with OpenMolcas (October 2020)            *
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             Valera Veryazov, Dept. Theoretical Chemistry             *
************************************************************************
      Use Symmetry_Info, Only: nIrrep
      Use Basis_Info, Only: nBas
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "real.fh"
#include "grid.fh"

c      Logical Debug
      Character str*128, Crypt*7
      Character INPORB*(*)
      Character*80 myTitle
      character*128 line
      Real*8 pp(3)
      Integer nTypes(7)
      Logical is_error
      Data Crypt/'fi123sd'/
*
*---- Set size of batches
*
      parameter (nIncPack=18*1024)

      Character cMoBlock(nIncPack*2)

      nInc=nIncPack
*                                                                      *
************************************************************************
*                                                                      *
*...  Prologue
c      Debug=.false.
      isEner=1
      iRout = 2
      ipCutOff=ip_iDummy

      dNorm=0
      ddNorm=0
      if(iRun.eq.1.and.levelprint.ge.3) then
       Write (6,*)
       Write (6,'(A,8I5)') 'Irreps  : ',(i,i=1,nIrrep)
       Write (6,'(A,8I5)') 'Basis   : ',(nBas(i),i=0,nIrrep-1)
       Write (6,'(A,3I5)') 'Grid Net: ',(iGridNpt(i),i=1,3)
       Write (6,*)
      endif
*
*...  Compute the size of the densities
*
      nCMO=0
      nMOs=0
      Do iIrrep = 0, nIrrep - 1
         nCMO  = nCMO + nBas(iIrrep)**2
         nMOs  = nMOs + nBas(iIrrep)
      End Do
*

      if(isUHF.ne.0.and.(isDerivative.ne.0.or.isCurDens.ne.0)) then
        write(6,*) "ERROR - Current density or derivatives not
     &              implemented for UHF!!!"
        call Abend()
      end if
      if(NoOrb.ne.0.and.(isDerivative.ne.0.or.isCurDens.ne.0)) then
        write(6,*) "ERROR - Current density or derivatives not
     &              implemented with the NOORB keyword!!!"
        call Abend()
      end if
      if(isAtom.ne.0.and.(isDerivative.ne.0.or.isCurDens.ne.0)) then
        write(6,*) "ERROR - Current density or derivatives not
     &              implemented with the ATOM keyword!!!"
        call Abend()
      end if

      Call GetMem('CMO','ALLO','REAL',ipCMO,nCMO)

      Call GetMem('Ener','ALLO','REAL',ipE,nMOs)
      Call GetMem('Occu','ALLO','REAL',ipOcc,nMOs)
      Call GetMem('Occ2','ALLO','REAL',ipOoo,nMOs)
      if(isVirt.eq.1) then
        Call GetMem('ddNo','ALLO','REAL',ipdd,nMOs*nMOs)
        Do i=1,nMOs*nMOs
         Work(ipdd+i-1)=Zero
        Enddo
      endif
      Call GetMem('iTyp','ALLO','INTE',ipType,nMOs)
      Call GetMem('Vol','ALLO','REAL',ipVol,nMOs)
      Call GetMem('Sort','ALLO','INTE',ipSort,nMOs)
      Call GetMem('Nzer','ALLO','INTE',ipNZ,nMOs*2)
      Call GetMem('NRef','ALLO','INTE',ipGRef,nMOs)
      Call GetMem('DoIt','ALLO','INTE',ipDoIt,nMOs)
      Call GetMem('Pab','ALLO','REAL',ipPab,nMOs)
        Do i=0, nMOs-1
         iWork(ipGRef+i)=-1
        enddo
*
*  Read information from INPORB file
*
       LuOrb=isFreeUnit(46)


      if(isUHF.eq.0) then

        Call RdVec(INPORB,LuOrb,'COE',nIrrep,NBAS,NBAS,
     &    Work(ipCMO),Work(ipOcc),Work(ipE),iWork(ip_iDummy),
     &    myTitle,0,iErr)


c construct Pab
       if(NoOrb.eq.1) then
c        print *,'nCMO,nMOs', nCMO,nMOs
        Call makePab(Work(ipCMO),Work(ipOcc),Work(ipPab),nMOs,nMOs,
     &  nIrrep, nBas    )
c       print *,'Pab=', (Work(ipPab+i),i=0,nMOs-1)
       endif
        if(iErr.eq.1) then
          do j=0, nMOs-1
          Work(ipE+j)=Zero
          enddo
        endif
      Call RdVec(INPORB,LuOrb,'I',nIrrep,NBAS,NBAS,
     &  Work(ip_Dummy),Work(ip_Dummy),Work(ip_Dummy),iWork(ipType),
     &  myTitle,0,iErr)
        if(iErr.eq.1) then
          do j=0, nMOs-1
          iWork(ipType+j)=0
          enddo
        endif
      else  ! UHF case
c allocate memory for extra arrays.
      Call GetMem('CMO_ab','ALLO','REAL',ipCMO_ab,nCMO)
      Call GetMem('Ener_ab','ALLO','REAL',ipE_ab,nMOs)
      Call GetMem('Occu_ab','ALLO','REAL',ipOcc_ab,nMOs)
      Call GetMem('Sort_ab','ALLO','INTE',ipSort_ab,nMOs)
      Call GetMem('NRef_ab','ALLO','INTE',ipGRef_ab,nMOs)
      Call GetMem('DoIt_ab','ALLO','INTE',ipDoIt_ab,nMOs)

      Call RdVec_(INPORB,LuOrb,'COE',1,nIrrep,NBAS,NBAS,
     &  Work(ipCMO),Work(ipCMO_ab),Work(ipOcc),Work(ipOcc_ab),
     &  Work(ipE),Work(ipE_ab),iWork(ip_iDummy),
     &  myTitle,0,iErr,iWFtype)
c it can be only after SCF, so we do not need TypeIndex info
          do j=0, nMOs-1
          iWork(ipType+j)=0
          enddo

      endif
      do j=1,7
      nTypes(j)=0
      enddo
      do j=0, nMOs-1
      jj=iWork(ipType+j)
      if(jj.gt.0) nTypes(jj)=nTypes(jj)+1
      enddo

      close(LuOrb)
*
*  Calculate net.
*
       if(iRun.eq.1) then
        Write(6,'(A)') '   Input vectors read from INPORB'
        Write(6,'(A,A)') '   Orbital file label: ',
     &                   myTitle(:mylen(myTitle))
       endif
      do j=1,3
       iGridNpt(j)=iGridNpt(j)+1
      enddo

      nCoor=iGridNpt(1)*iGridNpt(2)*iGridNpt(3)
      iiCoord=nCoor
*
*---- if isCutOff is in used - recalculate nCoor
*
       if(isCutOff.eq.1) then
        if(isUserGrid.eq.1) then
            write(6,*) 'Not implemented'
            call Quit_OnUserError()
        endif


       call GetMem('CUTFL','ALLO','INTE',ipCutOff,nCoor)
       ie1=max(iGridNpt(1)-1,1)
       ie2=max(iGridNpt(2)-1,1)
       ie3=max(iGridNpt(3)-1,1)
c       print *,'vv', ie1, ie2, ie3
       iiCoord=0
       iiiCoord=0
       do i1=0,ie1
       do i2=0,ie2
       do i3=0,ie3
         pp(1)=GridOrigin(1)+
     &     GridAxis1(1)*i1/ie1+
     &     GridAxis2(1)*i2/ie2+
     &     GridAxis3(1)*i3/ie3
         pp(2)=GridOrigin(2)+
     &     GridAxis1(2)*i1/ie1+
     &     GridAxis2(2)*i2/ie2+
     &     GridAxis3(2)*i3/ie3
         pp(3)=GridOrigin(3)+
     &     GridAxis1(3)*i1/ie1+
     &     GridAxis2(3)*i2/ie2+
     &     GridAxis3(3)*i3/ie3
c       write(6,'(3f8.4)') pp
         ishow=0
         do ii=1,nAtoms
           iaia=0
           if(abs(Work(ipCoor+ii*3-3)  -pp(1)).lt.CutOff) iaia=iaia+1
           if(abs(Work(ipCoor+ii*3-3+1)-pp(2)).lt.CutOff) iaia=iaia+1
           if(abs(Work(ipCoor+ii*3-3+2)-pp(3)).lt.CutOff) iaia=iaia+1
            if(iaia.eq.3) ishow=1
          enddo
         if(ishow.eq.1) then
            iiCoord=iiCoord+1
            iWork(ipCutOff+iiiCoord)=1
          else
            iWork(ipCutOff+iiiCoord)=0
          endif
          iiiCoord=iiiCoord+1
       enddo
       enddo
       enddo
       write(6,*) nCoor-iiCoord, ' points are eliminated'
c       print *,'old=',nCoor,' New=', iiCoord
c       nCoor=iiCoord
       endif
      if(isTheOne.eq.1) nCoor=int(OneCoor(7)+0.3)
      if(isAtom.eq.1) nCoor=nAtoms
      if(isUserGrid.eq.1) nCoor=nGridPoints
      Write (6,*) ' Number of grid points in file:  ',nCoor
c      call iXML('nPoints',nCoor)
*
************************************************************************
* And now we had to choose orbitals to draw.
*
* Sometime we had to make an automatic guess....
************************************************************************
*
       Call PickOrb(ipNz,ipSort,ipGref,ipSort_ab,
     &  ipGref_ab,ipVol,ipE,ipOcc,ipE_ab,ipOcc_ab,
     &  nShowMOs,nShowMOs_ab,isener,nMOs,myTitle,ipType)
*
*---- Start run over sets of grid points
*
c       if(isBinary.eq.1) then
       nShowMOs=nShowMOs+isDensity+isSphere+isColor
c       else
c       nShowMOs=1
c       endif
      if(isUHF.eq.1) nShowMOs_ab=nShowMOs_ab+isDensity+isSphere+isColor
      nShowMOs2=nShowMOs+nShowMOs_ab
       Write (6,*)
       Write (6,*) ' Total number of MOs               :',nMOs
c       call iXML('nMOs',nMOs)
       Write (6,*) ' Number MOs for grid               :',nShowMOs2
       Write (6,*) ' Batches processed in increments of:',nInc
       Write (6,*)
      iPrintCount=0

        Call GetMem('MOValue','ALLO','REAL',ipMO,nInc*nMOs)
        Call GetMem('DOValue','ALLO','REAL',ipOut,nInc)


      if (imoPack .ne. 0) then
        Call GetMem('PackedBlock','ALLO','INTE',ipPBlock,nInc)
      else
        Call GetMem('PackedBlock','ALLO','INTE',ipPBlock,1)
        iWork(ipPBlock)=0
      endif
*
*.... Allocate memory for the some grid points
*
      Call GetMem('Coor','ALLO','REAL',ipC,nInc*3)
      iSphrDist =ip_Dummy
      iSphrColor=ip_Dummy

      if(isSphere.eq.1) then
      Call GetMem('SpDi','ALLO','REAL',iSphrDist,nInc)
      endif
      if(isColor.eq.1) then
      Call GetMem('SpCo','ALLO','REAL',iSphrColor,nInc)
      endif

*
*   check grids to calculate
*
      Do i=0, nMOs-1
        iWork(ipDoIt+i)=0
        if(isUHF.eq.1) iWork(ipDoIt_ab+i)=0
      enddo
c
      if(NoOrb.eq.1) goto 550
      Do i=1,nShowMOs-isDensity-isSphere-isColor
        iWork(ipDoIt+iWork(ipGRef+i-1)-1)=1
      enddo
      if(isUHF.eq.1) then
      Do i=1,nShowMOs_ab-isDensity-isSphere-isColor
        iWork(ipDoIt_ab+iWork(ipGRef_ab+i-1)-1)=1
      enddo
      endif
      ifpartial=1-isTotal
      if(isTotal.eq.1) then
        Do i=0, nMOs-1
          if(abs(Work(ipOcc+i)).gt.Zero) then
                     iWork(ipDoIt+i)=1
          endif
          if(isUHF.eq.1) then
          if(abs(Work(ipOcc_ab+i)).gt.Zero) then
                     iWork(ipDoIt_ab+i)=1
          endif
          endif
        enddo
      else
        Do i=0, nMOs-1
          if(Work(ipOcc+i).gt.Zero.and.iWork(ipDoIt+i).ne.1) then
                     ifpartial=1
          endif
          if(isUHF.eq.1) then
          if(Work(ipOcc_ab+i).gt.Zero.and.iWork(ipDoIt_ab+i).ne.1) then
                     ifpartial=1
          endif
          endif
        enddo
      endif
550   Continue
*
*   If plotting VB orbitals : count active orbitals and make sure
*   all are included in DOIT :
*
* nothing to do with UHF

c
      iCRSIZE=1
      NBYTES=10
      NINLINE=10
c       Print *, 'prepear  header '

      call PrintHeader(nMOs,nShowMOs,nShowMOs_ab,nCoor,nInc,
     & iiCoord,nTypes,iCRSIZE,NBYTES,NINLINE,nBlocks )

c       Print *, 'HERE header isdone'

      LuVal_=LuVal
      if(isLuscus.eq.1) LuVal_=LID
      Call PrintTitles(LuVal_,nShowMOs,isDensity,nMOs,
     &  iWork(ipGRef), isEner,  Work(ipOcc), iWork(ipType), Crypt,
     &  iWork(ipNZ), Work(ipE), VBocc, ifpartial,isLine,isSphere,
     &  isColor, ISLUSCUS,ncoor,nBlocks,nInc)
      if(isUHF.eq.1) then
      LuVal_ab_=LuVal_ab
      if(isLuscus.eq.1) LuVal_ab_=LID_ab
      Call PrintTitles(LuVal_ab_,nShowMOs_ab,isDensity,nMOs,
     &  iWork(ipGRef_ab), isEner,  Work(ipOcc_ab),
     &  iWork(ipType), Crypt,
     &  iWork(ipNZ), Work(ipE_ab), VBocc, ifpartial,isLine,isSphere,
     &  isColor, ISLUSCUS,ncoor,nBlocks,nInc)
      endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Loop over grid points in batches of nInc
*
      ive3=max(iGridNpt(3)-1,1)
      ive2=max(iGridNpt(2)-1,1)
      ive1=max(iGridNpt(1)-1,1)
       iv3=0
       iv2=0
       iv1=0
c      if(isAtom.eq.1) goto 6000

      iiiCoord=0
      dtot=0.d0
c      if(isCutOff.eq.1) nCoor=iiCoord
cccccccccccccc  main loop starts here  ccccccccccccccccccccccccccccccccc
      iShiftCut=0
      Do iSec = 1, nCoor, nInc
      mCoor=Min(nInc,nCoor-iSec+1)
c      write(status,'(a,i8,a,i8)') ' batch ',iSec,' out of ',nCoor/nInc
c      call StatusLine('grid_it: ',status)
* Generate next portion of points..
      if (isTheOne.eq.0) then
c general case: we have a CUBIC box.
       ipPO=0
667    continue
       iiiCoord=iiiCoord+1
        gv3=1.0d+0*iv3/ive3
        gv2=1.0d+0*iv2/ive2
        gv1=1.0d+0*iv1/ive1

        if(isUserGrid.eq.0) then
          if(isCutOff.eq.0) then
            Work(ipC+ipPO*3)=GridOrigin(1)+
     *        GridAxis1(1)*gv1+GridAxis2(1)*gv2+GridAxis3(1)*gv3
            Work(ipC+ipPO*3+1)=GridOrigin(2)+
     *        GridAxis1(2)*gv1+GridAxis2(2)*gv2+GridAxis3(2)*gv3
            Work(ipC+ipPO*3+2)=GridOrigin(3)+
     *        GridAxis1(3)*gv1+GridAxis2(3)*gv2+GridAxis3(3)*gv3
          else
c using ipCutOff
            Work(ipC+ipPO*3)=40
            Work(ipC+ipPO*3+1)=40
            Work(ipC+ipPO*3+2)=40
             if(iWork(ipCutOff+iiiCoord-1).eq.1) then
              Work(ipC+ipPO*3)=GridOrigin(1)+
     *           GridAxis1(1)*gv1+GridAxis2(1)*gv2+GridAxis3(1)*gv3
              Work(ipC+ipPO*3+1)=GridOrigin(2)+
     *           GridAxis1(2)*gv1+GridAxis2(2)*gv2+GridAxis3(2)*gv3
              Work(ipC+ipPO*3+2)=GridOrigin(3)+
     *           GridAxis1(3)*gv1+GridAxis2(3)*gv2+GridAxis3(3)*gv3
              endif
          endif
        else
          Work(ipC+ipPO*3+1-1)=Work(ipGrid+(iSec+ipPO-1)*3+1-1)
          Work(ipC+ipPO*3+2-1)=Work(ipGrid+(iSec+ipPO-1)*3+2-1)
          Work(ipC+ipPO*3+3-1)=Work(ipGrid+(iSec+ipPO-1)*3+3-1)
c         make a local copy of the weights of the corresponding grid points:
        endif
        iv3=iv3+1
        if (iv3.gt.ive3) then
           iv3=0
           iv2=iv2+1
        endif
        if (iv2.gt.ive2) then
           iv2=0
           iv1=iv1+1
        endif
        ipPO=ipPO+1
c           print *,'ipo',ipP0
            if(ipPO.le.mCoor-1) goto 667
C end of CUBIC box
      else
C coords are given in specific points
* coords for DEBUG mode
       if(isLine.eq.0) then
         do i=0,nCoor-1
           Work(ipC+i*3)=OneCoor(1)+OneCoor(4)*i
           Work(ipC+1+i*3)=OneCoor(2)+OneCoor(5)*i
           Work(ipC+2+i*3)=OneCoor(3)+OneCoor(6)*i
         enddo
       else
c LINE keyword
         do i=0,nCoor-1
            Work(ipC+i*3)=
     &        OneCoor(1)+(OneCoor(4)-OneCoor(1))*i/(nCoor-1)
            Work(ipC+1+i*3)=
     &        OneCoor(2)+(OneCoor(5)-OneCoor(2))*i/(nCoor-1)
            Work(ipC+2+i*3)=
     &        OneCoor(3)+(OneCoor(6)-OneCoor(3))*i/(nCoor-1)
         enddo
       endif
      endif
C end of coordinates.
CVV: FIXME; separate color and sphere
C      if(isSphere.eq.1.and.isColor.eq.1) then
C        Call Sphr_Grid(Work(ipCoor),mCoor,Work(ipC),Work(iSphrDist),
C     &       Work(iSphrColor))
C      endif

        if(NoOrb.eq.1) then
        nDrv=0
        Call MOEval(Work(ipMO),nMOs,mCoor,Work(ipC),Work(ipPab),nMOs,
     &              iWork(ipDoIt),nDrv,1)
        else
           nDrv=0
           Call MOEval(Work(ipMO),nMOs,mCoor,Work(ipC),Work(ipCMO),nCMO,
     &                 iWork(ipDoIt),nDrv,1)
        endif
*
*....... Write out values
*
       nLine=min(nShowMOs,20)
       nSLine=nLine*mCoor
       if(isLine.eq.0) then
         nSLine=1
         nLine=1
        endif
      Call GetMem('Line','ALLO','REAL',ipLine,nSLine)
       if(levelprint.lt.2) iPrintCount=100
CVV BUG Update ipcutOFF

        Call DumpM2Msi(iRun,Luval_,LID,nShowMOs,isDensity,nMOs,
     &    iWork(ipGRef), Work(ipOcc), Work(ipMO),
     &    Work(ipOut), mCoor,
     &    iGauss, nInc, imoPack, iWork(ipPBlock),
     &    cMoBlock,nBytesPackedVal, dnorm, Crypt, VbOcc,
     &    isTheOne,isLine,isBinary, isEner,iWork(ipType),
     &    iWork(ipNZ),Work(ipE),Work(ipLine),nLine,Work(ipC),
     &    iPrintCount,isDebug,isCutOff,iWork(ipCutOff+iShiftCut),
     &    isSphere,Work(iSphrDist),isColor,Work(iSphrColor),
     &    isLuscus,NBYTES,NINLINE)
c
c      if(isXField.eq.1) call dcopy_(mCoor,Work(ipOut),1,Work(ipOutXF),1)
        if(isUHF.eq.1) then
cVV:
          nDrv=0
          Call MOEval(Work(ipMO),nMOs,mCoor,Work(ipC),Work(ipCMO_ab),
     &                nCMO,iWork(ipDoIt_ab),nDrv,1)

*....... Write out values
*
          Call DumpM2Msi(iRun,Luval_ab_,LID_ab,nShowMOs_ab,isDensity,
     &      nMOs,
     &      iWork(ipGRef_ab), Work(ipOcc_ab), Work(ipMO),
     &      Work(ipOut), mCoor,
     &      iGauss, nInc, imoPack, iWork(ipPBlock),
     &      cMoBlock,nBytesPackedVal, dnorm, Crypt, VbOcc,
     &      isTheOne,isLine,isBinary, isEner,iWork(ipType),
     &      iWork(ipNZ),Work(ipE_ab),Work(ipLine),nLine,Work(ipC),
     &      iPrintCount,isDebug,isCutOff,iWork(ipCutOff+iShiftCut),
     &      isSphere,Work(iSphrDist),isColor,Work(iSphrColor),
     &      isLuscus,NBYTES,NINLINE)

        endif ! end if(isUHF.eq.1)


c

       Call GetMem('Line','FREE','REAL',ipLine,nSLine)
        iShiftCut=iShiftCut+mCoor
       if(isVirt.eq.1) then
         do iiMO=1,nMOs
         do jjMO=1,nMOs
         if(Work(ipOcc+iiMO-1).gt.1.1
     &      .and. Work(ipOcc+jjMO-1).lt.0.9) then
c  here if this is a pair Occ-Virt

          do i=1,nMOs
          Work(ipOoo+i-1)=0
          if(i.eq.iiMO) Work(ipOoo+i-1) = Two-Virt
          if(i.eq.jjMO) Work(ipOoo+i-1) = Virt
          enddo

          call outmo(0,2,Work(ipMO),Work(ipOoo),Work(ipOut),
     >               mCoor,nMOs)
          dd=0
          do j=1, mCoor
            dd=dd+Work(ipOut+j-1)
          enddo
c         ddNorm=ddNorm+dd
          call save_ddNorm(dd,iiMO,jjMO,Work(ipdd),nMOs)
         endif
         enddo
         enddo
        endif
       Enddo !iSec
cccccccccccccc  main loop ends here  ccccccccccccccccccccccccccccccccc


      Write (6,*)
* Check norms
*

      if(isAtom.ne.1) then

        det3=GridAxis1(1)*(GridAxis2(2)*GridAxis3(3)-
     -                     GridAxis2(3)*GridAxis3(2))-
     -        GridAxis1(2)*(GridAxis2(1)*GridAxis3(3)-
     -                     GridAxis2(3)*GridAxis3(1))+
     +        GridAxis1(3)*(GridAxis2(1)*GridAxis3(2)-
     -                     GridAxis2(2)*GridAxis3(1))
        det3=det3/( (iGridNpt(1)-1)*(iGridNpt(2)-1)*(iGridNpt(3)-1))
        dNorm=dNorm*det3

c        print *,'dNorm=',dNorm

       if(isVirt.eq.1) then
        call print_ddNorm(nMOs,Work(ipdd),det3)

c       print *,'ddNorm=',ddNorm*det3

       endif

        Call Add_Info('GRIDIT_NORM',[dNorm],1,6)
      endif
*                                                                      *
************************************************************************
*                                                                      *
**      Call DAClos(LuVal)
        IF (ISLUSCUS .EQ. 1) THEN
            LINE=' '
            CALL PRINTLINE(LUVAL_,LINE,1,0)
            LINE=' </DENSITY>'
            CALL PRINTLINE(LUVAL_,LINE,11,0)
            LINE=' <BASIS>'
            CALL PRINTLINE(LUVAL_,LINE,8,0)
            LINE=' </BASIS>'
            CALL PRINTLINE(LUVAL_,LINE,9,0)
            LINE=' <INPORB>'
            CALL PRINTLINE(LUVAL_,LINE,9,0)
          endif


      if(isLine.eq.0) then
      write(str,'(9i8)') nIrrep, (nBas(i),i=0,nIrrep-1)
      Call PrintLine(LuVal_, STR, 72,0)
C      if(isBinary.eq.0) Then
C        write(LuVal_,'(a)') str
C      else
C        write(LuVal_) str
C      endif
c Well, to avoid rewritting of Cerius2 we use old INPORB format
c temporary!
      LuOrb=isFreeUnit(46)
      call molcas_open_ext2(luorb,INPORB,'sequential','formatted',
     & iostat,.false.,irecl,'old',is_error)
c 4001  read(LuOrb,'(a)',err=5000,end=5000) str
c      if(str.ne.'#ORB') goto 4001
5001  read(LuOrb,'(a)',err=5000,end=5000) str
c      if(str(1:1).eq.'#') goto 5001
      iLen=len(str)
      do 5050 i=iLen,1,-1
        if(str(i:i).ne.' ') goto 5060
5050  continue
 5060 CONTINUE
      Call PrintLine(LuVal_, STR, I,0)
C5060  if(isBinary.eq.0) Then
C        write(LuVal_,'(a)') str(1:i)
C      else
C        write(LuVal_) str(1:i)
C      endif
      goto 5001
5000  close(unit=LuOrb)
      endif ! isLine
      close(unit=LuVal)
      if(isUHF.eq.1) close(unit=LuVal_ab)
      if(isTheOne.eq.1) then
        MM=mCoor-1
        if(MM.gt.10) MM=10
        Call Add_Info('GRIDIT_ONE',Work(ipOut),MM,6)
      endif
*                                                                      *
************************************************************************
*                                                                      *
*...  Epilogue, end
*
c6000  continue

      if(isAtom.eq.1)  then
        mCoor=nCoor
        nDrv=0
        Call MOEval(Work(ipMO),nMOs,mCoor,Work(ipCoor),Work(ipCMO),
     &             nCMO,iWork(ipDoIt),nDrv,1)
        call outmo(0,2,Work(ipMO),Work(ipOcc),Work(ipOut),nCoor,nMOs)
        write(6,'(60a1)') ('*',i=1,60)
      if(ifpartial.eq.0) Then
       write(6,'(a5,3a10,a20)') 'Atom','x','y','z','Density'
      else
       write(6,'(a5,3a10,a20)') 'Atom','x','y','z','Density (partial)'
      endif
          do i=0, nAtoms-1
           write(6,'(a5,3f10.3,e20.10)') AtomLbl(i+1),Work(ipCoor+i*3),
     &   Work(ipCoor+i*3+1),Work(ipCoor+i*3+2),Work(ipOut+i)
          enddo
        Call Add_Info('GRIDIT_ATOM',Work(ipOut),nAtoms,6)


       Call GetMem('Coor','FREE','REAL',ipCoor,3*nAtoms)

      endif

      IF (ISLUSCUS .EQ. 1) THEN
        CALL PRTLUSENDGRID(LID)
        if(isUHF.eq.1) CALL PRTLUSENDGRID(LID_ab)
      END IF

      if(isSphere.eq.1) then
      Call GetMem('SpDi','FREE','REAL',iSphrDist,nInc)
      endif
      if(isColor.eq.1) then
      Call GetMem('SpCo','FREE','REAL',iSphrColor,nInc)
      endif
      Call GetMem('Coor','FREE','REAL',ipC,nInc*3)

        Call GetMem('DOValue','FREE','REAL',ipOut,nInc)
        Call GetMem('MOValue','FREE','REAL',ipMO,nInc*nMOs)

      if(isUHF.eq.1) then
        Call GetMem('CMO_ab' ,'FREE','REAL',ipCMO_ab,nCMO)
        Call GetMem('Ener_ab','FREE','REAL',ipE_ab,nMOs)
        Call GetMem('Occu_ab','FREE','REAL',ipOcc_ab,nMOs)
        Call GetMem('Sort_ab','FREE','INTE',ipSort_ab,nMOs)
        Call GetMem('NRef_ab','FREE','INTE',ipGRef_ab,nMOs)
        Call GetMem('DoIt_ab','FREE','INTE',ipDoIt_ab,nMOs)
      endif
      if(isUserGrid.eq.1)
     *  Call GetMem('Grid','FREE','REAL',ipGrid,nGridPoints*3)
      if (imoPack .ne. 0) then
        Call GetMem('PackedBlock','FREE','INTE',ipPBlock,nInc)
      else
        Call GetMem('PackedBlock','FREE','INTE',ipPBlock,1)
      endif

        Call GetMem('Pab' ,'FREE','REAL',ipPab,nMOs)
        Call GetMem('DoIt','FREE','INTE',ipDoIt,nMOs)

        Call GetMem('NRef','FREE','INTE',ipGRef,nMOs)
        Call GetMem('Nzer','FREE','INTE',ipNZ,nMOs*2)
        Call GetMem('Sort','FREE','INTE',ipSort,nMOs)
        Call GetMem('Vol' ,'FREE','REAL',ipVol,nMOs)
        Call GetMem('iTyp','FREE','INTE',ipType,nMOs)
       if(isVirt.eq.1) then
        Call GetMem('ddNo','FREE','REAL',ipdd,nMOs*nMOs)
       endif

        Call GetMem('Occ2','FREE','REAL',ipOoo,nMOs)
        Call GetMem('Occu','FREE','REAL',ipOcc,nMOs)
        Call GetMem('Ener','FREE','REAL',ipE,nMOs)

c      if(isWDW.eq.1) call GetMem('WDW','FREE','REAL',ipWdW,nCenter)
        Call GetMem('CMO','FREE','REAL',ipCMO,nCMO)


      if (isAtom.eq.0.and.isXField.eq.0)
     &  Call GetMem('Coor','FREE','REAL',ipCoor,3*nAtoms)

      if(isCutOff.eq.1)
     &  Call GetMem('CUTFL','FREE','INTE',ipCutOff,nCoor)
*
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine save_ddNorm(ddNorm,ii,jj,Wdd,nMOs)
      Implicit Real*8 (A-H,O-Z)
      Dimension Wdd(nMOs,nMOs)
      Wdd(ii,jj)=Wdd(ii,jj)+ddNorm
      return
      end

      subroutine print_ddNorm(nMOs,Wdd,det3)
      Implicit Real*8 (A-H,O-Z)
      Dimension Wdd(nMOs,nMOs)
        do i=1,nMOs
        write (6,'(20F8.3)') (Wdd(i,j)*det3,j=1,nMOs)
        enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine stat1_cvb()

use casvb_global, only: cpu0, cpu_prev, endvar, ipr, n_2el, n_applyh, n_applyt, n_cihess, n_hess, n_iter, n_orbhess, nmcscf, variat
use Constants, only: Zero
use Definitions, only: wp

implicit none
real(kind=wp), external :: tim_cvb

cpu0 = tim_cvb(Zero)
if (((.not. variat) .or. (nmcscf == 1)) .or. ((ipr(3) >= 1) .and. ((.not. endvar) .or. (ipr(6) >= 2)))) then
  cpu_prev = Zero
  n_applyt = 0
  n_applyh = 0
  n_hess = 0
  n_orbhess = 0
  n_cihess = 0
  n_2el = 0
end if
n_iter = 0

return

end subroutine stat1_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRWF_MRCI(ICSPCK,INTSYM,INDX,C,JREFX)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(*),INDX(*),ICSPCK(*),
     *          INTSYM(*),JREFX(*)
      CHARACTER*12 CSFTYP
      CHARACTER*14 FORM0,FORM1,FORM2,FORM
      CHARACTER*14 FORM00,FORM01,FORM02

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION IOC(32),IORBI(32),ISP(32),ILSYM(32)
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
      DATA FORM00 /'(1X,A,6X,53I2)'/
      DATA FORM01 /'(1X,A,3X,54I2)'/
      DATA FORM02 /'(1X,A,55I2)   '/
      DATA FORM0 /'(1X,A,6X,34I3)'/
      DATA FORM1 /'(1X,A,3X,35I3)'/
      DATA FORM2 /'(1X,A,36I3)   '/
C STATEMENT FUNCTIONS FOR RETRIEVING GUGA CASE NUMBERS AND INTERNAL
C SYMMETRY LABEL:
CPAM97      JO(L)=UNPACK(CSPCK((L+29)/30), 2*L-(2*L-1)/60*60, 2)
      JO(L)=ICUNP(ICSPCK,L)
CPAM96      JSYM(L)=UNPACK(INTSYM((L+9)/10),3*MOD(L-1,10)+1,3)+1
      JSYM(L)=JSUNP(INTSYM,L)
      NA=0
      NB=0
      ILIM=4
      LN2=LN+2
      IF(IFIRST.NE.0)ILIM=2
      SCALE=1.0/SQRT(DDOT_(NCONF,C,1,C,1))
      CALL DSCAL_(NCONF,SCALE,C,1)
      DO 4 J=1,LN
         IORBI(J+2)=IORB(J)
         ILSYM(J+2)=NSM(J)
4     CONTINUE
      JCONF=JSC(1)
      WRITE(6,'(A,F5.3)')'      CI-COEFFICIENTS LARGER THAN ',CTRSH
      CALL XFLUSH(6)
      DO 5 IS=1,NSYM
        IF(NFMO(IS).GT.0) THEN
          WRITE(6,*)' NOTE: THE FOLLOWING ORBITALS WERE FROZEN'
      CALL XFLUSH(6)
          WRITE(6,*)' ALREADY AT THE INTEGRAL TRANSFORMATION STEP'
      CALL XFLUSH(6)
          WRITE(6,*)' AND DO NOT EXPLICITLY APPEAR:'
      CALL XFLUSH(6)
          WRITE(6,'(6X,A,8I4)')'  SYMMETRY:',(I,I=1,NSYM)
      CALL XFLUSH(6)
          WRITE(6,'(6X,A,8I4)')'PRE-FROZEN:',(NFMO(I),I=1,NSYM)
      CALL XFLUSH(6)
          GOTO 6
        END IF
5     CONTINUE
6     CONTINUE
      WRITE(6,*)' ORDER OF SPIN-COUPLING: (PRE-FROZEN, NOT SHOWN)'
      CALL XFLUSH(6)
      WRITE(6,*)'                         (FROZEN, NOT SHOWN)'
      CALL XFLUSH(6)
      WRITE(6,*)'                          VIRTUAL'
      CALL XFLUSH(6)
      WRITE(6,*)'                          ADDED VALENCE'
      CALL XFLUSH(6)
      WRITE(6,*)'                          INACTIVE'
      CALL XFLUSH(6)
      WRITE(6,*)'                          ACTIVE'
      CALL XFLUSH(6)
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,*)' ORBITALS ARE NUMBERED WITHIN EACH SEPARATE SYMMETRY.'
      CALL XFLUSH(6)
      DO 10 I=1,NCONF
        CI=C(I)
        ACI=ABS(C(I))
        IF(I.LE.JCONF) THEN
          JMIN=1
          NREXT=0
          IF(JREFX(I).NE.0) THEN
            CSFTYP='   REFERENCE'
            CLIM=0.0D00
          ELSE
            CSFTYP='     VALENCE'
            CLIM=CTRSH
          END IF
        ELSE IF (I.LE.JSC(2)) THEN
          NREXT=1
          JMIN=1+IRC(1)
          CSFTYP='     DOUBLET'
          CLIM=CTRSH
        ELSE IF (I.LE.JSC(3)) THEN
          NREXT=2
          JMIN=1+IRC(2)
          CSFTYP='     TRIPLET'
          CLIM=CTRSH
        ELSE
          NREXT=2
          JMIN=1+IRC(3)
          CSFTYP='     SINGLET'
          CLIM=CTRSH
        END IF
        IF(ACI.LT.CLIM) GOTO 10
         JJ=I
         IJ=I
         IF(NREXT.GT.0) THEN
           JMAX=IRC(ILIM)
           DO 20 J=JMIN,JMAX
              JJ=J
              IF(INDX(J).LT.IJ)GO TO 20
              JJ=JJ-1
              GOTO 25
20         CONTINUE
25         CONTINUE
         END IF
         NSJ=MUL(JSYM(JJ),LSYM)
         JVIR=IJ-INDX(JJ)
         II1=(JJ-1)*LN
         DO 31 II=1,LN
            II1=II1+1
            ISP(II+2)=JO(II1)
            IOC(II+2)=(1+ISP(II+2))/2
31       CONTINUE
         IF(NREXT.EQ.0) THEN
           FORM=FORM0
           IF(LN2.GT.36) FORM=FORM00
           LN1=3
         ELSE IF (NREXT.EQ.1) THEN
           IO=JVIR+NVIRP(NSJ)+LN
           IORBI(2)=IORB(IO)
           IOC(2)=1
           ISP(2)=1
           ILSYM(2)=NSJ
           FORM=FORM1
           IF(LN2.GT.36) FORM=FORM01
           LN1=2
         ELSE
           IN=0
           DO 46 II=1,NVIRT
              NA=II
              NSI=MUL(NSJ,NSM(LN+II))
              J1=NVIRP(NSI)+1
              J2=NVIRP(NSI)+NVIR(NSI)
              IF(J2.GT.II)J2=II
              IF(J2.LT.J1)GO TO 46
              DO 47 J=J1,J2
                 NB=J
                 IN=IN+1
                 IF(IN.EQ.JVIR)GO TO 48
47            CONTINUE
46         CONTINUE
48         CONTINUE
           IOC(1)=1
           ISP(1)=1
           ILSYM(1)=NSM(LN+NB)
           IO=LN+NB
           IORBI(1)=IORB(IO)
           IF(NA.EQ.NB) THEN
             IORBI(2)=IORBI(1)
             IOC(2)=2
             ISP(2)=3
             ILSYM(2)=NSM(IO)
             CI=CI*SQRT(0.5D00)
             IF(ABS(CI).LT.CTRSH)GO TO 10
             FORM=FORM1
             IF(LN2.GT.36) FORM=FORM01
             LN1=2
           ELSE
             IOC(2)=1
             ISP(2)=2
             IF(CSFTYP.EQ.'     TRIPLET') ISP(2)=1
             IO=LN+NA
             IORBI(2)=IORB(IO)
             ILSYM(2)=NSM(IO)
             FORM=FORM2
             IF(LN2.GT.36) FORM=FORM02
             LN1=1
           END IF
         END IF
         WRITE(6,*)
      CALL XFLUSH(6)
         WRITE(6,105) I,C(I),CSFTYP
      CALL XFLUSH(6)
105   FORMAT(/6X,'CONFIGURATION',I7,3X,'COEFFICIENT',F10.6,A)
         WRITE(6,FORM) 'SYMMETRY     ',(ILSYM(J),J=LN1,LN2)
      CALL XFLUSH(6)
         WRITE(6,FORM) 'ORBITALS     ',(IORBI(J), J=LN1,LN2)
      CALL XFLUSH(6)
         WRITE(6,FORM) 'OCCUPATION   ',(IOC(J),  J=LN1,LN2)
      CALL XFLUSH(6)
         WRITE(6,FORM) 'SPIN-COUPLING',(ISP(J),  J=LN1,LN2)
      CALL XFLUSH(6)
10    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************
subroutine TransActMO(MOs,TabMO,mAO,mGrid,nMOs)
! Purpose:
! Trasnferring active orbitals to the MOs array.
! It records the MO values on each grid point.
! The first and the second elements are the MO values
! of the first and the second active MO at grid point 1.

use nq_Info, only: IOff_Ash, IOff_BasAct, mIrrep, nAsh, NASHT
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mAO, mGrid, nMOs
real(kind=wp), intent(out) :: MOs(NASHT,mGrid)
real(kind=wp), intent(in) :: TabMO(mAO,mGrid,nMOs)
integer(kind=iwp) :: iGrid, iIrrep, IOff1, IOff2

do iGrid=1,mGrid
  do iIrrep=0,mIrrep-1
    IOff1 = IOff_Ash(iIrrep)
    IOff2 = IOff_BasAct(iIrrep)
    MOs(IOff1+1:IOff1+nAsh(iIrrep),iGrid) = TabMO(1,iGrid,IOff2+1:IOff2+nAsh(iIrrep))
  end do
end do

return

end subroutine TransActMO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
!***********************************************************************

module rasdef

! NRSPRT = Nr of RAS partitions
! NRAS(ISYM,IP)=Nr of orbitals with symmetry ISYM in each part.
! NRASEL(IP)=Min nr of accumulated electrons

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: MXRSPRT = 3
integer(kind=iwp) :: NRAS(8,MXRSPRT), NRASEL(MXRSPRT), NRS1(8), NRS1T, NRS2(8), NRS2T, NRS3(8), NRS3T, NRSPRT

public :: NRAS, NRASEL, NRS1, NRS1T, NRS2, NRS2T, NRS3, NRS3T, NRSPRT

end module rasdef

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

subroutine pgek()

use kriging_mod, only: x, y, nPoints, nInter, Index_PGEK, nInter_Eff
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four, Pi
use Definitions, only: wp, iwp

!#define _MI_SORT_
#if (defined(_DEBUGPRINT_) || defined(_MI_SORT_))
use Definitions, only: u6
#endif

implicit none
real(kind=wp), allocatable :: Mean_univariate(:), Variance_univariate(:), Variance_bivariate(:)
real(kind=wp) :: tmp, dx, dy, Fact
integer(kind=iwp) :: i, j, l
! Mutual information array
!real(kind=wp) :: MI(nInter)
real(kind=wp), allocatable :: MI(:)
! universal kernel density estimators.
!real(kind=wp) :: px(nPoints,nInter), py(nPoints), pxy(nPoints,nInter)
real(kind=wp), allocatable :: px(:,:), py(:), pxy(:,:)
! the 2 x 2 covariance matrix (used to compute the transformation variable in the bivariate case)
real(kind=wp) :: Sigma2(2,2), Sigma2_Inverse(2,2), d, h, u_j, K_u_j, Det_Sigma2, Sigma_2, N_norm
#ifdef _MI_SORT_
integer(kind=iwp) :: k
#endif

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'Experimental code to compute the Mutual information between the lth coordinate'
write(u6,*) 'and the energy, denoted MI(l).'
write(u6,*)
write(u6,*) '# of sample points, nPoints=               ',nPoints
write(u6,*) '# of dimensions of the coordinates, nInter=',nInter
call RecPrt('Energies (nPoints): y',' ',y,1,nPoints)
call RecPrt('Coordinates (nInter x nPoints): x',' ',x,nInter,nPoints)
#endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Allocate memory

call mma_allocate(Mean_univariate,nInter+1,label='Mean_univariate')
call mma_allocate(Variance_univariate,nInter+1,label='Variance_univariate')
call mma_allocate(Variance_bivariate,nInter,label='Variance_bivariate')
call mma_allocate(MI,nInter,label='MI')
call mma_allocate(px,nInter,nPoints,label='px')
call mma_allocate(py,nPoints,label='py')
call mma_allocate(pxy,nInter,nPoints,label='pxy')

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Compute the mean for all variables - coordinate components and the energy
! univariate --  x and y
! Compute the variance of the univariate and the bivariate

! univariate means
do i=1,nInter
  Mean_Univariate(i) = Zero
  do j=1,nPoints
    Mean_Univariate(i) = Mean_Univariate(i)+x(i,j)
  end do
end do
Mean_Univariate(nInter+1) = Zero
do j=1,nPoints
  Mean_Univariate(nInter+1) = Mean_Univariate(nInter+1)+y(j)
end do
Mean_Univariate(:) = Mean_Univariate(:)/real(nPoints,kind=wp)

! uni- and bivariate variances
do i=1,nInter
  Variance_Univariate(i) = Zero
  Variance_bivariate(i) = Zero
  do j=1,nPoints
    Variance_Univariate(i) = Variance_Univariate(i)+(x(i,j)-Mean_univariate(i))**2
    Variance_bivariate(i) = Variance_bivariate(i)+(x(i,j)-Mean_univariate(i))*(y(j)-Mean_univariate(nInter+1))
  end do
end do
Variance_Univariate(nInter+1) = Zero
do j=1,nPoints
  Variance_Univariate(nInter+1) = Variance_Univariate(nInter+1)+(y(j)-Mean_univariate(nInter+1))**2
end do
Variance_Univariate(:) = Variance_Univariate(:)/real(nPoints,kind=wp)
Variance_Bivariate(:) = Variance_Bivariate(:)/real(nPoints,kind=wp)

#ifdef _DEBUGPRINT_
call RecPrt('Mean - x,y ',' ',Mean_Univariate(:),nInter+1,1)
call RecPrt('Variance - x^2,y^2 ',' ',Variance_Univariate(:),nInter+1,1)
call RecPrt('Variance - xy ',' ',Variance_Bivariate(:),nInter,1)
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Compute the universal kernel density estimators px, py, and pxy
! also known as Parzen window technique using as a kernel function a normal distribution with
! an exponent of alpha=1/(2 h^2 Sigma^2), in which h is the Gaussian bandwith and Sigma^2 is the
! variance of the random variable under consideration -- Sigma is the standard deviation.

! 1) the univariate cases

! Note that for the bandwidth we are using the equation suggested by Moon, Rajagoplan and Lall
! rather than the one suggested by Liming, Qiu, Gao, Jiang, and Yang. In particular, the latter is
! identical in the uni- and bi-variate case while the former differ.
!
!h = (4/((2*d + 1)*nPoints))**(1/(4+d)) ! the Gaussian bandwidth   d=1,2
!h = (4/((d_h + 2)*nPoints))**(1/(4+d_h)) ! the Gaussian bandwidth   d_h=2

d = One
h = (Four/((Two*d+One)*nPoints))**(One/(Four+d)) ! the Gaussian bandwidth
Fact = One/((Two*Pi)**(d/Two)*h**d)  ! Part of the normalization factor
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'univariate probabilities'
write(u6,*)
write(u6,*) '1/((2pi)^(d/2) h^d)=',Fact
write(u6,*) 'The Gaussian bandwidth, h=',h
#endif

! a) Compute px(l,i)

do l=1,nInter
  Sigma_2 = Variance_Univariate(l)
  !write (u6,*) 'l, Sigma_2=',l, Sigma_2
  !
  ! Take special care of coordinates which might not change due to symmetry
  ! or for some other reason. Then the kernel function effectively is a Dirac delta function.

  if (Sigma_2 < 1.0e-10_wp) then
    px(l,:) = One/real(nPoints,kind=wp)
  else
    N_norm = (Fact/sqrt(Sigma_2))
    do i=1,nPoints
      !write (u6,*) 'i=',i

      tmp = Zero
      do j=1,nPoints
        u_j = (x(l,i)-x(l,j))**2/(h**2*Sigma_2)
        K_u_j = N_norm*exp(-u_j/Two)
        !write (u6,*) 'u_j, K_u_j=',u_j, K_u_j
        tmp = tmp+K_u_j
      end do

      px(l,i) = tmp/real(nPoints,kind=wp)

    end do
  end if
end do

! b) Compute py(i)

Sigma_2 = Variance_Univariate(nInter+1)
N_norm = (Fact/sqrt(Sigma_2))
!write (u6,*) 'Sigma_2=',Sigma_2
do i=1,nPoints
  !write (u6,*) 'i=',i

  tmp = Zero
  do j=1,nPoints
    u_j = (y(i)-y(j))**2/(h**2*Sigma_2)
    K_u_j = N_norm*exp(-u_j/Two)
    !write (u6,*) 'u_j, K_u_j=',u_j, K_u_j
    tmp = tmp+K_u_j
  end do

  py(i) = tmp/real(nPoints,kind=wp)

end do
#ifdef _DEBUGPRINT_
call RecPrt('Probability px(i,l)',' ',px,nInter,nPoints)
call RecPrt('Probability py(l)',' ',py,nPoints,1)
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! 2) the bivariate case, pxy(l,i)

d = Two
h = (Four/((Two*d+One)*nPoints))**(One/(Four+d)) ! the Gaussian bandwidth
Fact = One/((Two*Pi)**(d/Two)*h**d)
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'bivariate probabilities'
write(u6,*)
write(u6,*) 'd=',d
write(u6,*) 'Fact=',Fact
write(u6,*) 'The Gaussian bandwidth, h=',h
#endif

do l=1,nInter
  ! Assemble the 2 x 2 covariance matrix
  Sigma2(1,1) = Variance_univariate(l)  ! p(x_l^2)
  Sigma2(1,2) = Variance_bivariate(l)   ! p(x_ly)
  Sigma2(2,1) = Sigma2(1,2)
  Sigma2(2,2) = Variance_univariate(nInter+1) ! p(y^2)
  Det_Sigma2 = Sigma2(1,1)*Sigma2(2,2)-Sigma2(1,2)*Sigma2(2,1)  ! The determinant of the 2 x 2 sigma matrix
# ifdef _DEBUGPRINT_
  call RecPrt('Sigma2','(2E12.4)',Sigma2,2,2)
  write(u6,'(A,E12.4)') 'Det(Sigma2)=           ',Det_Sigma2
  write(u6,'(A,E12.4)') 'Sqrt(ABS(Det(Sigma2)))=',sqrt(abs(Det_Sigma2))
# endif
  if (Variance_univariate(l) < 1.0e-10_wp .or. abs(Det_Sigma2) < 1.0e-20_wp) then
    pxy(l,:) = One/real(nPoints,kind=wp)
  else
    Sigma2_Inverse(1,1) = Sigma2(2,2)/Det_Sigma2
    Sigma2_Inverse(1,2) = -Sigma2(1,2)/Det_Sigma2
    Sigma2_Inverse(2,1) = -Sigma2(2,1)/Det_Sigma2
    Sigma2_Inverse(2,2) = Sigma2(1,1)/Det_Sigma2
    !call RecPrt('Sigma2_Inverse','(2E10.2)',Sigma2_Inverse,2,2)
    N_norm = (Fact/sqrt(Det_Sigma2))
    do i=1,nPoints

      tmp = Zero
      do j=1,nPoints
        dx = x(l,i)-x(l,j)
        dy = y(i)-y(j)
        u_j = (dx*dx*Sigma2_Inverse(1,1)+dx*dy*Sigma2_Inverse(1,2)+dy*dx*Sigma2_Inverse(2,1)+dy*dy*Sigma2_Inverse(2,2))/h**2
        !write (u6,*)' u_j=',u_j
        K_u_j = N_norm*exp(-u_j/Two)
        !write (u6,*)' K_u_j=',K_u_j
        tmp = tmp+K_u_j
      end do

      pxy(l,i) = tmp/real(nPoints,kind=wp)

    end do
  end if
  !write (u6,*) 'pxy(l,:)=',pxy(l,:)
end do

#ifdef _DEBUGPRINT_
call RecPrt('Probability pxy(l,i)',' ',pxy,nInter,nPoints)
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Assemble the Mutual Information, MI(l), for each variable l, according to equation 23 of
! Chen et al. Note that this is correct only if the sample points to a large extent are
! equidistant -- which they are not.

do l=1,nInter
  tmp = Zero
  if (Variance_univariate(l) > 1.0e-10_wp) then
    do i=1,nPoints
      tmp = tmp+pxy(l,i)*log10(pxy(l,i)/(px(l,i)*py(i)))
    end do
  end if
  MI(l) = tmp
end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifdef _DEBUGPRINT_
write(u6,*) 'Mutual Information'
write(u6,*) '=================='
do i=1,nInter
  write(u6,'(i4,E10.3)') i,MI(i)
end do
#endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

nInter_Eff = 0
do i=1,nInter
# ifdef _MI_SORT_
  k = 0
  tmp = -One
  do j=1,nInter
    if (MI(j) > tmp) then
      k = j
      tmp = MI(j)
    end if
  end do
  if (k == 0) then
    write(u6,*) 'PGEK: k==0'
    call Abend()
  else
    if (MI(k) > 1.0d-10) nInter_Eff = nInter_Eff+1
    MI(k) = -Two
    Index_PGEK(i) = k
  end if
# else
  !if (abs(Variance_bivariate(i)) > 5.0e-15_wp) Then
  if (abs(Variance_bivariate(i)) > 1.0e-14_wp) then
    nInter_eff = nInter_eff+1
    Index_PGEK(nInter_eff) = i
  end if
# endif
end do

! code debugging with full lists and forward and backward order.

!nInter_Eff = nInter
!do i=1, nInter
! Index_PGEK(i) = nInter-i+1
!end do
!nInter_Eff = nInter
!do i=1, nInter
! Index_PGEK(i) = i
!end do
#ifdef _DEBUGPRINT_
write(u6,*) 'nInter_eff=',nInter_eff
write(u6,*) 'Index_PGEK=',(Index_PGEK(i),i=1,nInter_eff)
#endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     Deallocate memory

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

call mma_deallocate(MI)
call mma_deallocate(px)
call mma_deallocate(py)
call mma_deallocate(pxy)
call mma_deallocate(Variance_univariate)
call mma_deallocate(Variance_bivariate)
call mma_deallocate(Mean_univariate)

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(kind=wp) function p_x(xl,l)

  real(kind=wp), intent(in) :: xl
  integer(kind=iwp), intent(in) :: l
  integer(kind=iwp) :: j

  d = One
  h = (Four/((Two*d+One)*nPoints))**(One/(Four+d)) ! the Gaussian bandwidth
  Fact = One/((Two*Pi)**(d/Two)*h**d)  ! Part of the normalization factor

  Sigma_2 = Variance_Univariate(l)

  ! We need a case of explicit zero variance (within machine accuracy) for the cases for symmetry breaking coordinates.

  N_norm = (Fact/sqrt(Sigma_2))
  p_x = Zero
  do j=1,nPoints
    u_j = (xl-x(l,j))**2/(h**2*Sigma_2)
    K_u_j = N_norm*exp(-u_j/Two)
    p_x = p_x+K_u_j
  end do
  p_x = p_x/real(nPoints,kind=wp)

end function p_x

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(kind=wp) function p_y(yl)

  real(kind=wp), intent(in) :: yl
  integer(kind=iwp) :: j

  d = One
  h = (Four/((Two*d+One)*nPoints))**(One/(Four+d)) ! the Gaussian bandwidth
  Fact = One/((Two*Pi)**(d/Two)*h**d)  ! Part of the normalization factor

  Sigma_2 = Variance_Univariate(nPoints+1)
  N_norm = (Fact/sqrt(Sigma_2))
  p_y = Zero
  do j=1,nPoints
    u_j = (yl-y(j))**2/(h**2*Sigma_2)
    K_u_j = N_norm*exp(-u_j/Two)
    p_y = p_y+K_u_j
  end do
  p_y = p_y/real(nPoints,kind=wp)

end function p_y

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

real(kind=wp) function p_xy(xl,yl,l)

  real(kind=wp), intent(in) :: xl, yl
  integer(kind=iwp), intent(in) :: l
  integer(kind=iwp) :: j

  d = Two
  h = (Four/((Two*d+One)*nPoints))**(One/(Four+d)) ! the Gaussian bandwidth
  Fact = One/((Two*Pi)**(d/Two)*h**d)

  ! Assemble the 2 x 2 covariance matrix
  Sigma2(1,1) = Variance_univariate(l)  ! p(x_l^2)
  Sigma2(1,2) = Variance_bivariate(l)   ! p(x_ly)
  Sigma2(2,1) = Sigma2(1,2)
  Sigma2(2,2) = Variance_univariate(nInter+1) ! p(y^2)
  Det_Sigma2 = Sigma2(1,1)*Sigma2(2,2)-Sigma2(1,2)*Sigma2(2,1)  ! The determinant of the 2 x 2 sigma matrix
  Sigma2_Inverse(1,1) = Sigma2(2,2)/Det_Sigma2
  Sigma2_Inverse(1,2) = -Sigma2(1,2)/Det_Sigma2
  Sigma2_Inverse(2,1) = -Sigma2(2,1)/Det_Sigma2
  Sigma2_Inverse(2,2) = Sigma2(1,1)/Det_Sigma2

  N_norm = (Fact/sqrt(Det_Sigma2))
  p_xy = Zero
  do j=1,nPoints
    dx = xl-x(l,j)
    dy = yl-y(j)
    u_j = (dx*dx*Sigma2_Inverse(1,1)+dx*dy*Sigma2_Inverse(1,2)+dy*dx*Sigma2_Inverse(2,1)+dy*dy*Sigma2_Inverse(2,2))/h**2
    K_u_j = N_norm*exp(-u_j/Two)
    p_xy = p_xy+K_u_j
  end do
  p_xy = p_xy/real(nPoints,kind=wp)

end function p_xy

end subroutine pgek

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Nike Dattani                                     *
!***********************************************************************

module level_common

use Definitions, only: wp, iwp

implicit none
private

real(kind=wp) :: ARV, PRV
real(kind=wp), allocatable :: DRDY2(:), RVB(:), SDRDY(:), VBZ(:), YVB(:)
integer(kind=iwp), parameter :: NDIMR = 200001
! Damping function parameters for printout .....
! what are these numbers?
real(kind=wp), parameter :: bDS(-4:0) = [2.50_wp,2.90_wp,3.3_wp,3.69_wp,3.95_wp], &
                            bTT(-1:2) = [2.44_wp,2.78_wp,3.126_wp,3.471_wp], &
                            cDS(-4:0) = [0.468_wp,0.446_wp,0.423_wp,0.40_wp,0.39_wp]

public :: ARV, bDS, bTT, cDS, DRDY2, NDIMR, PRV, RVB, SDRDY, VBZ, YVB

end module level_common

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
*  Create_Grads
*
*> @brief Create an empty gradients file
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Creates an empty gradients file (GRADS), to contain all the computed
*> gradients and couplings for the different roots.
*>
*> Structure of the gradients file:
*>  - 0: \p TOC (5 integers, each a disk address)
*>  - \p TOC(1): \p nRoots
*>  - \p TOC(2): \p nGrad
*>  - \p TOC(3): \p i_grad (\p nRoots integers)
*>  - \p TOC(4): \p i_nac (max(1,\p nRoots * (\p nRoots - 1)/2) integers)
*>  - \p TOC(5): Next free address
*>  - \p i_grad(i): Gradient of state \p i (\p nGrad reals)
*>  - \p i_nac(m): Coupling between states \p i and \p j
*>                 (\p m = \p i * (\p i - 1)/2 + \p j, \p i > \p j) (\p nGrad reals)
*>
*> If \p i_grad(i) or \p i_nac(m) is 0, the vector is not present in the
*> file. If it is negative, the vector is not present and cannot be
*> computed (so it is pointless to ask for it again).
*>
*> @param[in] FN     Filename for the gradients file (prgm-translatable)
*> @param[in] nRoots Number of roots to include in the file
*> @param[in] nGrad  Length of each gradient vector
************************************************************************
      Subroutine Create_Grads(FN,nRoots,nGrad)
      Implicit None
#include "stdalloc.fh"
      Integer :: nRoots,nGrad,Lu,TOC(5),nCoup,iAd
      Character(LEN=*) :: FN
      Integer, Dimension(:), Allocatable:: i_grad, i_nac
*
      nCoup=Max(1,nRoots*(nRoots-1)/2)
      Call mma_Allocate(i_grad,nRoots)
      Call mma_Allocate(i_nac,nCoup)
      Call iCopy(Size(TOC),[0],0,TOC,1)
      Call iCopy(nRoots,[0],0,i_grad,1)
      Call iCopy(nCoup,[0],0,i_nac,1)
*
      Lu=20
      Call DaName(Lu,Trim(FN))
      iAd=0
      Call iDaFile(Lu,1,TOC,SIZE(TOC),iAd)
      TOC(1)=iAd
      Call iDaFile(Lu,1,[nRoots],1,iAd)
      TOC(2)=iAd
      Call iDaFile(Lu,1,[nGrad],1,iAd)
      TOC(3)=iAd
      Call iDaFile(Lu,1,i_grad,nRoots,iAd)
      TOC(4)=iAd
      Call iDaFile(Lu,1,i_nac,nCoup,iAd)
      TOC(5)=iAd
      iAd=0
      Call iDaFile(Lu,1,TOC,Size(TOC),iAd)
      Call DaClos(Lu)
*
      Call mma_Deallocate(i_grad)
      Call mma_Deallocate(i_nac)
*
      End Subroutine Create_Grads

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine OneBas(Label)
************************************************************************
*                                                                      *
*     Change nBas in OneDat.fh                                         *
*                                                                      *
************************************************************************
*
      Implicit Integer (A-Z)
      Integer IntBas(8)
      Character*(*) Label
*
#include "OneDat.fh"
*
      If (Label.eq.'CONT') Then
         Call Get_iArray('nBas',IntBas,nSym)
      Else If (Label.eq.'PRIM') Then
         Call Get_iArray('nBas_Prim',IntBas,nSym)
      Else
         Write (6,*) 'OneBas: Illegal Label value!'
         Write (6,*) 'Value: ',Label
         Call Abend()
      End If
      Call ICopy(nSym,IntBas,1,nBas,1)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Optim(E_Pred,G,H,C,n)
!***********************************************************************
!                                                                      *
!    purpose: Solve a set of non-linear equations to get interpolation *
!             coefficients for damping                                 *
!                                                                      *
!     input:                                                           *
!       G       : linear terms                                         *
!       H       : bilinear terms                                       *
!       n       : size of matrices                                     *
!                                                                      *
!     output:                                                          *
!       C       : interpolation coefficients                           *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! The KISS method is employed here. Do a scan of the energy surface    *
! along lines parallel to the edges. Reduce the steplength gradually.  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark                                                     *
!     University of Lund, Sweden, 2003                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(out) :: E_Pred, C(n)
real(kind=wp), intent(in) :: G(n), H(n,n)
integer(kind=iwp) :: i, Iter, j
real(kind=wp) :: Ci, Cj, Eminus, Eplus, Eref, rSum, Step, Step_m, Step_p
logical(kind=iwp) :: Debug, Debug2, DidChange
real(kind=wp), external :: Optim_E

!----------------------------------------------------------------------*
! Initialize                                                           *
!----------------------------------------------------------------------*
#ifdef _DEBUGPRINT_
Debug = .true.
Debug2 = .true.
#else
Debug = .false.
Debug2 = .false.
#endif
!----------------------------------------------------------------------*
! Make first guess.                                                    *
!----------------------------------------------------------------------*
C(:) = Zero
j = 1
do i=1,n
  if (G(i)+Half*H(i,i) < G(j)+half*H(j,j)) j = i
end do
C(j) = 0.9_wp
do i=1,n
  if (i /= j) C(i) = (One-C(j))/(n-1)
end do
if (Debug) then
  write(u6,'(a)') 'Start C:'
  write(u6,'(6F15.6)') (C(i),i=1,n)
  write(u6,'(a)') 'Start G:'
  write(u6,'(6F26.16)') (G(i),i=1,n)
  call RecPrt('H',' ',H,n,n)
end if
!----------------------------------------------------------------------*
! Compute start energy.                                                *
!----------------------------------------------------------------------*
Eref = sum(C(:)*G(:))
do i=1,n
  Eref = Eref+Half*C(i)*sum(C(:)*H(i,:))
end do
if (Debug) write(u6,'(a,F24.16)') 'Eref = ',Eref
!----------------------------------------------------------------------*
! Do a scan in all pairwise directions                                 *
!----------------------------------------------------------------------*
Iter = 0
DidChange = .true.
Step = 0.1_wp
Eminus = One
Eplus = One

do while ((Iter < 500) .and. DidChange)

  Iter = Iter+1
  DidChange = .false.
  do i=1,n-1
    do j=i+1,n

      Ci = C(i)
      Cj = C(j)
      Step_p = min(Step,One-C(i),C(j))
      C(i) = C(i)+Step_p
      C(j) = C(j)-Step_p

      Eplus = optim_E(C,G,H,n)

      C(i) = Ci
      C(j) = Cj

      Step_m = min(Step,C(i),One-C(j))

      C(i) = C(i)-Step_m
      C(j) = C(j)+Step_m

      EMinus = optim_E(C,G,H,n)

      C(i) = Ci
      C(j) = Cj

      if (Debug2) then
        write(u6,'(a,2I3,3F26.16)') 'i,j,Eref,Eplus,Eminus',i,j,Eref,Eplus,Eminus
        write(u6,'(a,2F26.16)') 'Step_p, Step_m=',Step_p,Step_m
        write(u6,*) 'Eplus < EMinus=',Eplus < EMinus
        write(u6,*) 'Eplus < Eref=',Eplus < Eref
        write(u6,*) 'Eminus < Eref=',Eminus < Eref
      end if
      if (abs(Eplus-EMinus) > 1.0e-12_wp) then
        if (Eplus < Eminus) then
          if (Eplus < Eref) then
            C(i) = C(i)+Step_p
            C(j) = C(j)-Step_p
            Eref = Eplus
            DidChange = .true.
          end if
        else
          if (Eminus < Eref) then
            C(i) = C(i)-Step_m
            C(j) = C(j)+Step_m
            Eref = Eminus
            DidChange = .true.
          end if
        end if
      end if

    end do ! j
  end do ! i

  if (.not. DidChange) then
    if (Step > 0.9e-4_wp) then
      Step = 0.1_wp*Step
      DidChange = .true.
      if (Debug2) write(u6,*) 'Step is',Step
    end if
  end if

  ! Check that the constraint is fulfilled.

  rSum = Zero
  do i=1,n
    if (C(i) < Zero) C(i) = Zero
    if (C(i) > One) C(i) = One
    rSum = rSum+C(i)
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) 'optim: rSum-1',rSum-One
# endif
  C(:) = C(:)/rSum
end do
#ifdef _DEBUGPRINT_
write(u6,*) 'ERef=',ERef
#endif
E_Pred = ERef

end subroutine Optim

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gugadrt_rcas(id,indd)

use gugadrt_global, only: iseg_downwei, iprint, ja, ja_sys, jb, jb_sys, jc_sys, jd, jj, jm, jroute_sys, js, jt, jv, kk, lsm_inn, &
                          max_innorb, max_node, max_ref, mxnode, n_electron, ng_sm, no, norb_dz, norb_inn, ns_sm, nu_ad
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: id, indd
integer(kind=iwp) :: i, idd, ii, im, imd, ims, imt, inb, it, iysum, j, j1, j2, j3, j4, ja0, jb0, jc0, jde, jds, jk, jp, jp0, jpe, &
                     jps, jq1, jq2, jq3, jq4, k0, l, lr, nc, ndj, nel, nm, node
logical(kind=iwp) :: flag
integer(kind=iwp), allocatable :: ind(:,:), itm(:), iwy(:,:), jc(:), locu(:,:), noh(:)

call mma_allocate(ind,8,max_node,label='ind')
call mma_allocate(itm,[0,max_node],label='itm')
call mma_allocate(iwy,[1,4],[0,max_node],label='iwy')
call mma_allocate(jc,max_node,label='jc')
call mma_allocate(locu,8,max_ref,label='locu')
call mma_allocate(noh,max_innorb,label='noh')
write(u6,*) ' '
write(u6,*) 'now generate distinct row tableau'
noh = 0
itm = 0
iwy = 0
ind = 0
locu = 0
jc = 0

nel = n_electron
nm = ns_sm
no(1:norb_dz-1) = 0
j = 0
ja0 = ja_sys
jb0 = jb_sys
jc0 = jc_sys
! v_node
ja(1) = ja0
jb(1) = jb0
jc(1) = jc0
kk(1) = norb_dz
do i=1,8
  ind(i,1) = 0
end do
jm(1) = nm
! d_node
imd = 0
do node=2,9
  imd = imd+1
  if (nu_ad(node) == 0) cycle
  ja(node) = ja(1)
  jb(node) = jb0+1
  jc(node) = jc0-1
  kk(node) = norb_dz
  do i=1,8
    ind(i,node) = 0
  end do
  jm(node) = imd
end do
! t_node
imt = 0
do node=10,17
  imt = imt+1
  if (nu_ad(node) == 0) cycle
  ja(node) = ja(1)
  jb(node) = jb0+2
  jc(node) = jc0-2
  kk(node) = norb_dz
  do i=1,8
    ind(i,node) = 0
  end do
  jm(node) = imt
end do
! s_node
ims = 0
do node=18,25
  ims = ims+1
  if (nu_ad(node) == 0) cycle
  ja(node) = ja(1)+1
  jb(node) = jb0
  jc(node) = jc0-1
  kk(node) = norb_dz
  do i=1,8
    ind(i,node) = 0
  end do
  jm(node) = ims
end do
if (jroute_sys > 1) then
! d'_node
  imd = 0
  do node=26,33
    imd = imd+1
    if (nu_ad(node) == 0) cycle
    ja(node) = ja(1)+1
    jb(node) = jb0-1
    jc(node) = jc0
    kk(node) = norb_dz
    do i=1,8
      ind(i,node) = 0
    end do
    jm(node) = imd
  end do
end if
if (jroute_sys > 2) then
! t'_node
  imt = 0
  do node=34,41
    imt = imt+1
    if (nu_ad(node) == 0) cycle
    ja(node) = ja(1)+2
    jb(node) = jb0-2
    jc(node) = jc0
    kk(node) = norb_dz
    do i=1,8
      ind(i,node) = 0
    end do
    jm(node) = imt
  end do
end if
no(norb_dz) = mxnode

call gugadrt_ref_gfs(nel,ndj,locu,nm)

j = 0
jk = mxnode
do
  j = j+1
  if (j <= mxnode) then
    if (nu_ad(j) == 0) cycle
  end if
  k0 = kk(j)
  if (jc(j) /= 0) then
    jk = jk+1
    ! ***********
    ! *   d=0   *
    ! ***********
    ja(jk) = ja(j)
    jb(jk) = jb(j)
    jc(jk) = jc(j)-1
    jm(jk) = jm(j)
    do i=1,8
      ind(i,jk) = ind(i,j)
    end do
    inb = 0
    if (kk(j) == norb_inn-1) then
      call gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
    end if
    if (inb > 2) then
      jk = jk-1
      jj(1,j) = 0
    else
      flag = .false.
      outer_1: do ii=no(k0)+1,jk-1
        if (ja(jk) /= ja(ii)) cycle
        if (jb(jk) /= jb(ii)) cycle
        if (jc(jk) /= jc(ii)) cycle
        if (jm(jk) /= jm(ii)) cycle
        if (kk(j) /= norb_inn-1) then
          do i=1,8
            if (ind(i,jk) /= ind(i,ii)) cycle outer_1
          end do
        end if
        jk = jk-1
        jj(1,j) = ii
        flag = .true.
        if (flag) exit
      end do outer_1
      if (.not. flag) then
        jj(1,j) = jk
        kk(jk) = kk(j)+1
        if (kk(jk) /= kk(jk-1)) then
          no(k0) = jk-1
        end if
      end if
    end if
  end if
  ! v=0
  if (jb(j) /= 0) then
    jk = jk+1
    ! ***********
    ! *   d=1   *
    ! ***********
    ja(jk) = ja(j)
    jb(jk) = jb(j)-1
    jc(jk) = jc(j)
    jm(jk) = Mul(lsm_inn(kk(j)+1),jm(j))
    do i=1,8
      ind(i,jk) = ind(i,j)
    end do
    ind(lsm_inn(kk(j)+1),jk) = ind(lsm_inn(kk(j)+1),j)+1
    inb = 0
    if (kk(j) == norb_inn-1) then
      call gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
    end if
    if (inb > 2) then
      jk = jk-1
      jj(2,j) = 0
    else
      flag = .false.
      outer_2: do ii=no(k0)+1,jk-1
        if (ja(jk) /= ja(ii)) cycle
        if (jb(jk) /= jb(ii)) cycle
        if (jc(jk) /= jc(ii)) cycle
        if (jm(jk) /= jm(ii)) cycle
        if (kk(j) /= norb_inn-1) then
          do i=1,8
            if (ind(i,jk) /= ind(i,ii)) cycle outer_2
          end do
        end if
        jk = jk-1
        jj(2,j) = ii
        flag = .true.
        if (flag) exit
      end do outer_2
      if (.not. flag) then
        jj(2,j) = jk
        kk(jk) = kk(j)+1
        if (kk(jk) /= kk(jk-1)) then
          no(k0) = jk-1
        end if
      end if
    end if
  end if
  ! v=0
  if (ja(j) > 0) then
    if (jc(j) /= 0) then
      jk = jk+1
      ! *************
      ! *    d=2    *
      ! *************
      ja(jk) = ja(j)-1
      jb(jk) = jb(j)+1
      jc(jk) = jc(j)-1
      !-----------------------------------------------------------------------
      jm(jk) = Mul(lsm_inn(kk(j)+1),jm(j))
      do i=1,8
        ind(i,jk) = ind(i,j)
      end do
      ind(lsm_inn(kk(j)+1),jk) = ind(lsm_inn(kk(j)+1),j)+1
      inb = 0
      if (kk(j) == norb_inn-1) then
        call gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
      end if
      if (inb > 2) then
        jk = jk-1
        jj(3,j) = 0
      else
        flag = .false.
        outer_3: do ii=no(k0)+1,jk-1
          if (ja(jk) /= ja(ii)) cycle
          if (jb(jk) /= jb(ii)) cycle
          if (jc(jk) /= jc(ii)) cycle
          if (jm(jk) /= jm(ii)) cycle
          if (kk(j) /= norb_inn-1) then
            do i=1,8
              if (ind(i,jk) /= ind(i,ii)) cycle outer_3
            end do
          end if
          jk = jk-1
          jj(3,j) = ii
          flag = .true.
          if (flag) exit
        end do outer_3
        if (.not. flag) then
          jj(3,j) = jk
          kk(jk) = kk(j)+1
          if (kk(jk) /= kk(jk-1)) then
            no(k0) = jk-1
          end if
        end if
      end if
    end if
    ! v=0
    ! ************
    ! *    d=3   *
    ! ************
    jk = jk+1
    ja(jk) = ja(j)-1
    jb(jk) = jb(j)
    jc(jk) = jc(j)
    jm(jk) = jm(j)
    do i=1,8
      ind(i,jk) = ind(i,j)
    end do
    ind(lsm_inn(kk(j)+1),jk) = ind(lsm_inn(kk(j)+1),j)+2
    inb = 0
    if (kk(j) == norb_inn-1) then
      call gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
    end if
    if (inb > 2) then
      jk = jk-1
      jj(4,j) = 0
    else
      flag = .false.
      outer_4: do ii=no(k0)+1,jk-1
        if (ja(jk) /= ja(ii)) cycle
        if (jb(jk) /= jb(ii)) cycle
        if (jc(jk) /= jc(ii)) cycle
        if (jm(jk) /= jm(ii)) cycle
        if (kk(j) /= norb_inn-1) then
          do i=1,8
            if (ind(i,jk) /= ind(i,ii)) cycle outer_4
          end do
        end if
        jk = jk-1
        jj(4,j) = ii
        flag = .true.
        if (flag) exit
      end do outer_4
      if (.not. flag) then
        jj(4,j) = jk
        kk(jk) = kk(j)+1
        if (kk(jk) /= kk(jk-1)) then
          no(k0) = jk-1
        end if
      end if
    end if
    ! v=0
    if (jk > max_node) then
      write(u6,*) '    the number of j exceeds max_node',max_node
      call abend()
    end if
  end if
  if (kk(j) > norb_inn-1) exit
end do
!************** external space  *************

id = no(norb_inn)
write(u6,*)
write(u6,*) '    id=no(norb_inn)',id
do idd=no(norb_inn-1)+1,id
  if ((ja(idd) == 0) .and. (jb(idd) == 0) .and. (jm(idd) == 1)) jv = idd
  if ((ja(idd) == 0) .and. (jb(idd) == 1)) then
    if (jm(idd) == 1) jd(1) = idd
    if (jm(idd) == 2) jd(2) = idd
    if (jm(idd) == 3) jd(3) = idd
    if (jm(idd) == 4) jd(4) = idd
    if (jm(idd) == 5) jd(5) = idd
    if (jm(idd) == 6) jd(6) = idd
    if (jm(idd) == 7) jd(7) = idd
    if (jm(idd) == 8) jd(8) = idd
  end if
  if ((ja(idd) == 0) .and. (jb(idd) == 2)) then
    if (jm(idd) == 1) jt(1) = idd
    if (jm(idd) == 2) jt(2) = idd
    if (jm(idd) == 3) jt(3) = idd
    if (jm(idd) == 4) jt(4) = idd
    if (jm(idd) == 5) jt(5) = idd
    if (jm(idd) == 6) jt(6) = idd
    if (jm(idd) == 7) jt(7) = idd
    if (jm(idd) == 8) jt(8) = idd
  end if
  if ((ja(idd) == 1) .and. (jb(idd) == 0)) then
    if (jm(idd) == 1) js(1) = idd
    if (jm(idd) == 2) js(2) = idd
    if (jm(idd) == 3) js(3) = idd
    if (jm(idd) == 4) js(4) = idd
    if (jm(idd) == 5) js(5) = idd
    if (jm(idd) == 6) js(6) = idd
    if (jm(idd) == 7) js(7) = idd
    if (jm(idd) == 8) js(8) = idd
  end if
end do

iwy(1,jv) = 1
do im=1,ng_sm
  if ((jd(im) /= 0) .and. (iseg_downwei(1+im) /= 0)) iwy(1,jd(im)) = 1
  if ((jt(im) /= 0) .and. (iseg_downwei(9+im) /= 0)) iwy(1,jt(im)) = 1
  if ((js(im) /= 0) .and. (iseg_downwei(17+im) /= 0)) iwy(1,js(im)) = 1
end do

do i=1,4
  iwy(i,0) = 0
end do
do l=norb_inn-1,norb_dz,-1
  jps = no(l-1)+1
  jpe = no(l)
  do jde=jps,jpe
    j1 = jj(1,jde)
    j2 = jj(2,jde)
    j3 = jj(3,jde)
    j4 = jj(4,jde)
    iwy(1,jde) = iwy(1,j1)+iwy(1,j2)+iwy(1,j3)+iwy(1,j4)
    if (iwy(1,jde) == 0) then
      if (l == norb_dz) then
        nc = 0
      else
        nc = no(l-2)
      end if
      do jp0=nc+1,no(l-1)
        if (jj(1,jp0) == jde) jj(1,jp0) = 0
        if (jj(2,jp0) == jde) jj(2,jp0) = 0
        if (jj(3,jp0) == jde) jj(3,jp0) = 0
        if (jj(4,jp0) == jde) jj(4,jp0) = 0
      end do
      cycle
    end if
    if ((j2 /= 0) .and. (iwy(1,j2) /= 0)) iwy(2,jde) = iwy(1,j1)
    if ((j3 /= 0) .and. (iwy(1,j3) /= 0)) iwy(3,jde) = iwy(1,j1)+iwy(1,j2)
    if ((j4 /= 0) .and. (iwy(1,j4) /= 0)) iwy(4,jde) = iwy(1,jde)-iwy(1,j4)
    if (jde == 1) cycle
    do jp=jps,jde-1
      if (iwy(1,jp) /= iwy(1,jde)) cycle
      jq1 = jj(1,jp)
      jq2 = jj(2,jp)
      jq3 = jj(3,jp)
      jq4 = jj(4,jp)
      if ((j1 == jq1) .and. (j2 == jq2) .and. (j3 == jq3) .and. (j4 == jq4)) then
        iwy(1,jde) = 0
        do jp0=no(l-2)+1,no(l-1)
          if (jj(1,jp0) == jde) jj(1,jp0) = jp
          if (jj(2,jp0) == jde) jj(2,jp0) = jp
          if (jj(3,jp0) == jde) jj(3,jp0) = jp
          if (jj(4,jp0) == jde) jj(4,jp0) = jp
        end do
        exit
      end if
    end do
  end do
end do
it = mxnode
itm(1) = 1
noh(norb_dz) = mxnode
do lr=norb_dz,norb_inn-1
  do jp=no(lr)+1,no(lr+1)
    itm(jp) = 0
    if (iwy(1,jp) /= 0) then
      it = it+1
      itm(jp) = it
    end if
  end do
  noh(lr+1) = it
end do

do jpe=mxnode+1,id
  jp = itm(jpe)
  if (jp == jpe) cycle
  if (jp == 0) cycle
  l = kk(jpe)
  jds = noh(l-2)+1
  jde = noh(l-1)
  do jp0=jds,jde
    if (jj(1,jp0) == jpe) jj(1,jp0) = jp
    if (jj(2,jp0) == jpe) jj(2,jp0) = jp
    if (jj(3,jp0) == jpe) jj(3,jp0) = jp
    if (jj(4,jp0) == jpe) jj(4,jp0) = jp
  end do
  ja(jp) = ja(jpe)
  jb(jp) = jb(jpe)
  jc(jp) = jc(jpe)
  jm(jp) = jm(jpe)
  kk(jp) = kk(jpe)
  do i=1,4
    iwy(i,jp) = iwy(i,jpe)
    jj(i,jp) = jj(i,jpe)
    ind(i,jp) = ind(i,jpe)
  end do
  do i=5,8
    ind(i,jp) = ind(i,jpe)
  end do
end do

!open(10,file='rcas.out')
no(norb_dz) = 0
no(norb_dz+1) = mxnode

!write(nf10,'(2x,2i10)')norb_dz+1,no(norb_dz+1)
do lr=norb_dz,norb_inn
  no(lr+1) = noh(lr)
  write(u6,'(2x,2i10)') lr+1,no(lr+1)
end do

itm(0) = 0
jv = itm(jv)
do im=1,8
  jd(im) = itm(jd(im))
  jt(im) = itm(jt(im))
  js(im) = itm(js(im))
end do
id = it
if (it /= no(norb_inn+1)) then
  write(u6,*) '   rcas id is wrong!!   no(norb_inn)=',no(norb_inn),it
  call abend()
end if
iysum = 0
do j=1,mxnode
  iysum = iysum+iwy(1,j)
end do
!write(u6,*) '    end of rcas , node=',id,'  dimension=',iysum
write(u6,*)
indd = no(norb_inn)
!iprint=1
if (iprint == 1) then
  write(u6,*) 'guga drt'
  write(u6,506)
end if

do j=1,id
  kk(j) = kk(j)+1
  if (iprint == 1) then
    write(u6,507) j,kk(j),ja(j),jb(j),jm(j),jj(1,j),jj(2,j),jj(3,j),jj(4,j),iwy(2,j),iwy(3,j),iwy(4,j),iwy(1,j),(ind(i,j),i=1,8)
  end if
end do
write(u6,*) 'end of rcas, drt ..........'
write(u6,*)

!open(21,file='fort.drt',form='unformatted')
!write(21) id
!write(21) ja(1:id),jb(1:id),jm(1:id)
!write(21) jj(1:4,0:id)
!write(21) kk(0:id)
!write(21) no(0:norb_inn+1)
!write(21) jv,jd(1:8),jt(1:8),js(1:8)
!close(21)

call writedrt(id)
call mma_deallocate(ind)
call mma_deallocate(itm)
call mma_deallocate(iwy)
call mma_deallocate(jc)
call mma_deallocate(locu)
call mma_deallocate(noh)

506 format('       j    k   a  b jm    j0   j1   j2   j3         y1        y2        y3         x ind')
507 format(3x,2i5,1x,3i3,1x,4i5,1x,4i10,1x,8i2)

end subroutine gugadrt_rcas

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Drvespf(Grad,Temp,nGrad,CCoor)
! Driver to compute the ESPF B*dV contribution to the gradient
! This is a hack of the alaska/drvh1 subroutine with a little
! piece of (extinct) integral_util/drvprop subroutine

use Index_Functions, only: nTri_Elem, nTri_Elem1
use Basis_Info, only: nBas
use Grd_interface, only: grd_kernel, grd_mem
use Symmetry_Info, only: nIrrep
use PrintLevel, only: nPrint
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Temp(nGrad)
real(kind=wp), intent(in) :: CCoor(*)
integer(kind=iwp) :: iIrrep, iPL, nComp, nDens, nOrdOp
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ii
#endif
logical(kind=iwp) :: DiffOp
character(len=80) :: Label
integer(kind=iwp), allocatable :: lOper(:)
real(kind=wp), allocatable :: D_Var(:)
integer(kind=iwp), external :: iPL_espf
procedure(grd_kernel) :: BdVGrd
procedure(grd_mem) :: NAMmG

! Allocate memory for density matrix

nDens = 0
do iIrrep=0,nIrrep-1
  nDens = nDens+nTri_Elem(nBas(iIrrep))
end do

! Read the variational 1st order density matrix
! density matrix in AO/SO basis

call mma_allocate(D_Var,nDens,Label='D_Var')
call Get_D1ao_Var(D_Var,nDens)
#ifdef _DEBUGPRINT_
write(u6,*) 'variational 1st order density matrix'
ii = 1
do iIrrep=0,nIrrep-1
  write(u6,*) 'symmetry block',iIrrep
  call TriPrt(' ',' ',D_Var(ii),nBas(iIrrep))
  ii = ii+nTri_Elem(nBas(iIrrep))
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! nOrdOp: order/rank of the operator
! lOper: lOper of each component of the operator

nPrint(112) = 5
iPL = iPL_espf()
if (iPL >= 3) nPrint(112) = 15
nOrdOp = 0
nComp = nTri_Elem1(nOrdOp)
call mma_allocate(lOper,nComp,Label='lOper')
lOper(:) = 1
!
!***********************************************************************
!                                                                      *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the external field integrals.                        *
!                                                                      *
!***********************************************************************
DiffOp = .true.
Label = ' The ESPF BdV contribution'
call OneEl_g(BdVGrd,NAMmG,Temp,nGrad,DiffOp,CCoor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
Grad(:) = Grad+Temp
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(lOper)
call mma_deallocate(D_Var)

return

end subroutine Drvespf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ExRas(iCStart,nBaseQ,nBaseC,nCnC_C,iQ_Atoms
     &                ,nAtomsCC,Ax,Ay,Az,itristate,SmatRas,SmatPure
     &                ,InCutOff,ipAOSum)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "qm2.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension SmatRas(MxStOT),CorTemp(3)
      Dimension nCnC_C(MxBasC),SmatPure(MxStOT)
      Dimension Inside(MxAt,3)
      Logical Inside,NearBy,InCutOff

*----------------------------------------------------------------------*
* Deduce how much the QM-molecule is translated from its position as   *
* definied in Seward.                                                  *
*----------------------------------------------------------------------*
      Ax=Cordst(1,1)-outxyzRAS(1,1)
      Ay=Cordst(1,2)-outxyzRAS(1,2)
      Az=Cordst(1,3)-outxyzRAS(1,3)

*
*-- Make some initializations.
*
      Cut_ExSq1=Cut_Ex1**2
      Cut_ExSq2=Cut_Ex2**2
      nOrbSize=iOrb(1)*iOrb(2)
      nV2size=iOrb(2)*nBaseC
      nAObaseSize=nBaseQ*nBaseC
      nStorlek=iOrb(1)*nBaseC
      Call GetMem('RotOrb','Allo','Real',iV2,nV2size)
      Call GetMem('Sint','Allo','Real',ipAOint,nAObaseSize)
      Call GetMem('Sintpar','Allo','Real',ipAOintpar,nAObaseSize)
      nHalf=nBaseQ*iOrb(2)
      nGross=nBaseQ*(nBaseQ+1)/2
      Call GetMem('HalfTrans','Allo','Real',iHalfpar,nHalf)
      Call GetMem('HalfPure','Allo','Real',iHalf,nHalf)
      Call GetMem('HalfOrbE','Allo','Real',iHalfE,nHalf)
      Call GetMem('Auxilary','Allo','Real',ipAux,nBaseQ**2)
      Call GetMem('AuxilaryP','Allo','Real',ipAuxp,nBaseQ**2)
      Call GetMem('GammaAO','Allo','Real',ipAOG,nGross)
      Call GetMem('Accumulate','Allo','Real',ipACC,nBaseQ**2)
      Call GetMem('Accumulate','Allo','Real',ipACCp,nBaseQ**2)
      Call GetMem('AccumulateT','Allo','Real',ipACCt,nGross)
      Call GetMem('AccumulateTP','Allo','Real',ipACCtp,nGross)
      Call GetMem('TEMP','Allo','Real',iTEMP,nRedMO*iOrb(2))
      call dcopy_(nBaseQ**2,[ZERO],iZERO,Work(ipACC),iONE)
      call dcopy_(nBaseQ**2,[ZERO],iZERO,Work(ipACCp),iONE)
*Jose****************************************************************
      If(lExtr(8)) then
         Call GetMem('qAOclMOOvl','Allo','Real',iAOMOOvl,nHalf)
         Call GetMem('qAOclMOOvlE','Allo','Real',iAOMOOvlE,nHalf)
         Call GetMem('AuxAOp','Allo','Real',ipAOAUX,nBaseQ**2)
         Call GetMem('AuxAOpTri','Allo','Real',ipAOAUXtri,nGross)
      Endif
*********************************************************************
      InCutOff=.false.
      Do 575, i=1,iTriState
        SmatRas(i)=0
        SmatPure(i)=0
575   Continue
      nInsideCut=0
      If(MoAveRed) then
        nDim1=nRedMO
        nDim2=iOrb(2)
      Else
        nDim1=nBaseQ
        nDim2=iOrb(2)
      Endif
      nDimP=nDim1*nDim2
      nDimT=nDim1*(nDim1+1)/2
*
*-- Start loop over all solvent molecules.
*
      Do 501, N=iCStart-1,nCent*(nPart-1),nCent

*
*-- Initialize
*
        dist_sw=1D20
        r3=1D20
        Do 11, i=1,MxAt
          Inside(i,1)=.false.
          Inside(i,2)=.false.
          Inside(i,3)=.false.
11      Continue
        NearBy=.false.
*-----Loop over atoms.
        Do 511, inwm=1,iQ_Atoms
          Do 512, k=1,3
            CorTemp(k)=(Cordst(N+1,k)-Cordst(inwm,k))**2
512       Continue
          r2=CorTemp(1)+CorTemp(2)+CorTemp(3)
          dist_sw=min(dist_sw,r2)
          DH1=0.0d0 !Distances for the inner cut-off. Also include the
          DH2=0.0d0  !hydrogens.
          Do 513, k=1,3
            DH1=DH1+(Cordst(N+2,k)-Cordst(inwm,k))**2
            DH2=DH2+(Cordst(N+3,k)-Cordst(inwm,k))**2
513       Continue
          r3temp1=min(DH1,DH2)
          r3temp2=min(r3temp1,r2)
          r3=min(r3,r3temp2)
*-----See if these atom-atom pairs inside cut-off.
          If(r2.lt.Cut_ExSq1) then
            Inside(inwm,1)=.true.
            NearBy=.true.
          Endif
          If(DH1.lt.Cut_ExSq1) then
            Inside(inwm,2)=.true.
            NearBy=.true.
          Endif
          If(DH2.lt.Cut_ExSq1) then
            Inside(inwm,3)=.true.
            NearBy=.true.
          Endif
511     Continue
*
*-----Make some cut-off tests.
*
        If(.not.NearBy) Go To 501  !If all distances larger than
                              !cut-off, jump to new solvent.
        If(r3.lt.Cut_ExSq2) then !Inner cut-off. Set flag to true then
          InCutOff=.true.        !huge energy is added later.
        Endif                    !S*S matrix, however!
        nInsideCut=nInsideCut+1

*
*-----Start integrating.
*
        Call AOIntegrate(iCStart,nBaseQ,nBaseC,Ax,Ay,Az,nCnC_C
     &          ,iQ_Atoms,nAtomsCC,ipAOint,ipAOintpar,iV2,N,lmax
     &          ,Inside)

*
*-- Transform overlaps from solvent AO to solvent MO.
*
        Call Dgemm_('N','N',nBaseQ,iOrb(2),nBaseC,ONE
     &      ,Work(ipAOint),nBaseQ,Work(iV2),nBaseC,ZERO
     &      ,Work(iHalf),nBaseQ)
*Jose***************************************************************
        If(lExtr(8)) then
          call dcopy_(nHalf,Work(iHalf),iONE,Work(iAOMOOvl),iONE)
          call dcopy_(nHalf,[ZERO],iZERO,Work(iAOMOOvlE),iONE)
          Do 5731, k=1,iOrb(2)
              ind=nBaseQ*(k-1)
              Call DaxPy_(nBaseQ,c_orbene(k),Work(iAOMOOvl+ind),iONE
     &                  ,Work(iAOMOOvlE+ind),iONE)
5731      Continue
        Endif
********************************************************************
*
*-- If average natural orbital basis used, transform again. We also
*   define Dim1 and Dim2 as dimensions of matrices depending on
*   whether average natural orbitals have been used. This means that
*   some vectors may be larger than necessary, but since no
*   huge demand of memory is required, this should not cause problem.
*
        If(MoAveRed) then
          Call Dgemm_ ('T','N',nRedMO,iOrb(2),nBaseQ,ONE
     &        ,Work(ipAvRed),nBaseQ,Work(iHalf),nBaseQ,ZERO
     &        ,Work(iTEMP),nRedMO)
          call dcopy_(nDim1*nDim2,Work(iTEMP),iONE,Work(iHalf),iONE)
        Endif
*
*-- Hook on the orbital energy.
*
        call dcopy_(nDimP,[ZERO],iZERO,Work(iHalfE),iONE)
        Do 5751, k=1,iOrb(2)
          ind=nDim1*(k-1)
          Call DaxPy_(nDim1,c_orbene(k),Work(iHalf+ind),iONE
     &              ,Work(iHalfE+ind),iONE)
5751    Continue

*
*-- Construct auxilary matrix for the non-electrostatic operator
*   in AO-basis for QM region. Also construct matrix of pure
*   overlaps for the higher order terms.
*
        Call Dgemm_('N','T',nDim1,nDim1,iOrb(2),ONE
     &      ,Work(iHalf),nDim1,Work(iHalfE),nDim1,ZERO
     &      ,Work(ipAUX),nDim1)
        Call Dgemm_('N','T',nDim1,nDim1,iOrb(2),ONE
     &      ,Work(iHalf),nDim1,Work(iHalf),nDim1,ZERO
     &      ,Work(ipAUXp),nDim1)

*
*-- Accumulate.
*
        Call DaxPy_(nDim1**2,ONE,Work(ipAUX),iONE,Work(ipACC),iONE)
        Call DaxPy_(nDim1**2,ONE,Work(ipAUXp),iONE,Work(ipACCp),iONE)

*Jose*********************************
      If(lExtr(8)) then
        Call Dgemm_('N','T',nBaseQ,nBaseQ,iOrb(2),exrep2
     &            ,Work(iAOMOOvl),nBaseQ,Work(iAOMOOvlE),nBaseQ,ZERO
     &            ,Work(ipAOAUX),nBaseQ)
        Call SqToTri_Q(Work(ipAOAUX),Work(ipAOAUXtri),nBaseQ)
        Call DaxPy_(nGross,ONE,Work(ipAOAUXtri),iONE,Work(ipAOSum)
     &            ,iONE)
      Endif
**************************************
*
*-- The end for this solvent molecule.
*
501   Continue
*
*-- Now construct the matrix elements to the non-electrostatic
*   operator in RASSI basis.
*
      kaunter=0
      facx=0
      Do 5703, iS=1,nState
        Do 5704, jS=1,iS
          HighS=0
          kaunter=kaunter+1
*--------Collect the relevant part of the transistion density matrix.
          Call dCopy_(nDimT,Work(iBigT+nDimT*(kaunter-1))
     &              ,iONE,Work(ipAOG),iONE)
*--------Then transform according to theory.
          Call SqToTri_Q(Work(ipACC),Work(ipACCt),nDim1)
          Addition=Ddot_(nDimT,Work(ipAOG),iONE,Work(ipACCt),iONE)
          SmatRas(kaunter)=SmatRas(kaunter)+exrep2*Addition
*--------And include pure S*S for subsequent higher order overlap
*        repulsion.
          Call SqToTri_Q(Work(ipACCp),Work(ipACCtp),nDim1)
          HighS=Ddot_(nDimT,Work(ipAOG),iONE,Work(ipACCtp),iONE)
          SmatPure(kaunter)=SmatPure(kaunter)+HighS
5704    Continue
5703  Continue

*
*-- Deallocations.
*
      Call GetMem('RotOrb','Free','Real',iV2,nV2size)
      Call GetMem('Sint','Free','Real',ipAOint,nAObaseSize)
      Call GetMem('Sintpar','Free','Real',ipAOintpar,nAObaseSize)
      Call GetMem('HalfTrans','Free','Real',iHalfpar,nHalf)
      Call GetMem('HalfPure','Free','Real',iHalf,nHalf)
      Call GetMem('HalfOrbE','Free','Real',iHalfE,nHalf)
      Call GetMem('Auxilary','Free','Real',ipAux,nBaseQ**2)
      Call GetMem('AuxilaryP','Free','Real',ipAuxp,nBaseQ**2)
      Call GetMem('GammaAO','Free','Real',ipAOG,nGross)
      Call GetMem('Accumulate','Free','Real',ipACC,nBaseQ**2)
      Call GetMem('Accumulate','Free','Real',ipACCp,nBaseQ**2)
      Call GetMem('AccumulateT','Free','Real',ipACCt,nGross)
      Call GetMem('AccumulateTP','Free','Real',ipACCtp,nGross)
      Call GetMem('TEMP','Free','Real',iTEMP,nRedMO*iOrb(2))
*Jose****************************************************************
      If(lExtr(8)) then
         Call GetMem('qAOclMOOvl','Free','Real',iAOMOOvl,nHalf)
         Call GetMem('qAOclMOOvlE','Free','Real',iAOMOOvlE,nHalf)
         Call GetMem('AuxAOp','Free','Real',ipAOAUX,nBaseQ**2)
         Call GetMem('AuxAOpTri','Free','Real',ipAOAUXtri,nGross)
      Endif
*********************************************************************

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
************************************************************************
      SUBROUTINE TRACHOSZ
      USE CHOVEC_IO
      IMPLICIT NONE
* ----------------------------------------------------------------
#include "rasdim.fh"
#include "warnings.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "chocaspt2.fh"
#include "choptr.fh"
#include "choglob.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif
      INTEGER IB,IBSTA,IBEND,IBATCH_TOT,NBATCH,NV
      INTEGER ICASE,ISYMA,ISYMB,ISYQ,JSYM,NPB,NPQ
      INTEGER JRED,JRED1,JRED2,JSTART
      INTEGER IDISK,IPNT
      INTEGER MXFTARR,MXHTARR
      INTEGER MXSPC
      INTEGER NVACT,NVACC,NVECS_RED
**********************************************************************
*  Author : P. A. Malmqvist
**********************************************************************


* ======================================================================
* Determine sectioning size to use for the full-transformed MO vectors
* using Francesco's method.
* Cholesky vectors, and half transformed vectors, need space for
* all symmetry blocks with a specified combined symmetry.
* Fully transformed symmetry blocks are handled individually.
      MXHTARR=0
      MXFTARR=0
      DO JSYM=1,NSYM
       NPB=0
       DO ISYMA=1,NSYM
        ISYMB=MUL(ISYMA,JSYM)
        NPB=NPB+MAX(NFRO(iSymA),NISH(iSymA),NASH(iSymA))*NBAS(ISYMB)
        MXFTARR=MAX(MXFTARR,NPSH(ISYMA)*NKSH(ISYMB))
       END DO
       MXHTARR=MAX(MXHTARR,NPB)
      END DO
      MXCHARR=NBAST**2
* MXFTARR,MXHTARR: Largest single full-transformed, half-transformed vector.
* MXCHARR: Largest possible Cholesky vector.

* What is largest possible array that can now be allocated?
      CALL GETMEM('MXSPC','MAX','REAL',IP_DUMMY,MXSPC)
* Subtract 7*MXCHARR (for vector V, etc, see below).
      MXSPC=MXSPC-7*MXCHARR

* Use 80% of this:
      MXSPC=INT(DBLE(MXSPC)*0.8D0)
* Max number of vectors that will fit in memory:
CSVC: added space for 2x the collected chovecs
      MXNVC=MXSPC/(MXCHARR+MXHTARR+MXFTARR+2*nProcs*MXFTARR)
CSVC: MPI workaround: collected chovecs should not exceed 2GB
      IF (MXFTARR.NE.0) THEN
        MXNVC=MIN(MXNVC,2147483647/(8*nProcs*MXFTARR))
      END IF
* Max number of vectors actually used in one batch:
      NJSCT=0
      IBATCH_TOT=0
      DO JSYM=1,NSYM
* Nr of batches in earlier symmetries:
        NBTCHES(JSYM)=IBATCH_TOT
        NBTCH(JSYM)=0
        IF(NUMCHO_PT2(JSYM).LE.0) CYCLE
        ipnt=ip_InfVec+MaxVec_PT2*(1+InfVec_N2_PT2*(jSym-1))
        JRED1=iWork(ipnt)
        JRED2=iWork(ipnt-1+NumCho_PT2(jSym))
* Loop over the reduced sets:
        DO JRED=JRED1,JRED2
          CALL Cho_X_nVecRS(JRED,JSYM,JSTART,NVECS_RED)
* It happens that a reduced set is empty:
          IF(NVECS_RED.eq.0) CYCLE
* Reduced set JRED contains NVECS_RED vectors
* Reduced set JRED must be divided up into NBATCH batches
          NBATCH=1+(NVECS_RED-1)/MXNVC
* Necessary number of vectors in each batch is then:
          NV=1+(NVECS_RED-1)/NBATCH
          NJSCT=MAX(NV,NJSCT)
          NBTCH(JSYM)=NBTCH(JSYM)+NBATCH
        END DO
        ! take maximum number of batches for this symmetry over any
        ! process, such that all procs have the same number of batches
        CALL GAIGOP(NBTCH(JSYM),1,'max')
        IBATCH_TOT=IBATCH_TOT+NBTCH(JSYM)
* Nr of batches in this symmetry:
      END DO
      NBATCH_TOT=IBATCH_TOT

#ifdef _MOLCAS_MPP_
CSVC: take the global sum of the individual maxima
      NJSCT_TOT=NJSCT
      CALL GAIGOP_SCAL(NJSCT_TOT,'+')
#endif

* Allocate space for the Cholesky vectors:
      NCHSPC=NJSCT*MXCHARR
      NHTSPC=NJSCT*MXHTARR
      NFTSPC=NJSCT*MXFTARR
#ifdef _MOLCAS_MPP_
      NFTSPC_TOT=NJSCT_TOT*MXFTARR
#endif

#ifdef _DEBUGPRINT_
      WRITE(6,*)' To be allocated for ...'
      WRITE(6,'(A,1X,I12)')'   Chol. vectors: NCHSPC     =',NCHSPC
      WRITE(6,'(A,1X,I12)')'   half-transf  : NHTSPC     =',NHTSPC
      WRITE(6,'(A,1X,I12)')'   full-transf:   NFTSPC     =',NFTSPC
#ifdef _MOLCAS_MPP_
      WRITE(6,'(A,1X,I12)')'   full-transf:   NFTSPC_TOT =',NFTSPC_TOT
#endif
      WRITE(6,*)' Cholesky vectors per symmetry:'
      WRITE(6,'(1X,8I12)') (NUMCHO_PT2(JSYM),JSYM=1,NSYM)
#endif

* Set up tables with the number of cholesky vectors per batch and disk
* addresses for the beginning of each batch. These arrays are accessible
* through the CHOVEC_IO module.
      ALLOCATE(NVLOC_CHOBATCH(NBATCH_TOT))
      ALLOCATE(IDLOC_CHOGROUP(4,8,8,NBATCH_TOT))
      NVLOC_CHOBATCH=0
      IDLOC_CHOGROUP=0

      IDISK=0
      IBATCH_TOT=0
      DO JSYM=1,NSYM
        IF(NUMCHO_PT2(JSYM).LE.0) CYCLE
        ipnt=ip_InfVec+MaxVec_PT2*(1+InfVec_N2_PT2*(jSym-1))
        JRED1=iWork(ipnt)
        JRED2=iWork(ipnt-1+NumCho_PT2(jSym))
        DO JRED=JRED1,JRED2
          CALL Cho_X_nVecRS(JRED,JSYM,JSTART,NVECS_RED)
* It happens that a reduced set is empty:
          IF(NVECS_RED.eq.0) CYCLE

          NBATCH=1+(NVECS_RED-1)/MXNVC
          NV=1+(NVECS_RED-1)/NBATCH
          NVACC=0
          DO IB=1,NBATCH
            IBATCH_TOT=IBATCH_TOT+1
            ! number of vectors
            NVACT=MIN(NVECS_RED-NVACC,NV)
            NVLOC_CHOBATCH(IBATCH_TOT)=NVACT
            NVACC=NVACC+NVACT
            ! disk address offsets
            DO ISYQ=1,NSYM
              DO ICASE=1,4
                NPQ=NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
                IDLOC_CHOGROUP(ICASE,ISYQ,JSYM,IBATCH_TOT)=IDISK
                CALL DDAFILE(LUDRA,0,WORK(IP_DUMMY),NPQ*NVACT,IDISK)
              END DO
            END DO
          END DO
        END DO
        ! set remaining batches to 0
        NBATCH=IBATCH_TOT-NBTCHES(JSYM)
        DO IB=NBATCH+1,NBTCH(JSYM)
          IBATCH_TOT=IBATCH_TOT+1
          NVLOC_CHOBATCH(IBATCH_TOT)=0
          DO ISYQ=1,NSYM
            DO ICASE=1,4
              IDLOC_CHOGROUP(ICASE,ISYQ,JSYM,IBATCH_TOT)=IDISK
            END DO
          END DO
        END DO
      END DO

* SVC: added workaround to get _all_ the fully transformed cholesky
* vectors onto every process. LUDRA has a counterpart LUDRATOT with
* indexing through the size NVGLB_CHOBATCH and offset IDGLB_CHOGROUP
* available from the CHOVEC_IO module.

      ALLOCATE(NVGLB_CHOBATCH(NBATCH_TOT))
      NVGLB_CHOBATCH(:)=NVLOC_CHOBATCH(:)
#ifdef _MOLCAS_MPP_
      ! for parrallel, sum over processes
      CALL GAIGOP(NVGLB_CHOBATCH,NBATCH_TOT,'+')
#endif

      ! sum over same-symmetry batches
      NVTOT_CHOSYM=0
      DO JSYM=1,NSYM
        IBSTA=NBTCHES(JSYM)+1
        IBEND=NBTCHES(JSYM)+NBTCH(JSYM)
        DO IB=IBSTA,IBEND
          ! total size is sum over global batch sizes
          NVTOT_CHOSYM(JSYM)=NVTOT_CHOSYM(JSYM)+NVGLB_CHOBATCH(IB)
        END DO
      END DO

      ALLOCATE(IDGLB_CHOGROUP(4,8,8,NBATCH_TOT))

      ! compute offsets into all cholesky vectors
      IDISK=0
      IDGLB_CHOGROUP=0
      DO JSYM=1,NSYM
        IBSTA=NBTCHES(JSYM)+1
        IBEND=NBTCHES(JSYM)+NBTCH(JSYM)
        DO IB=IBSTA,IBEND
          NV=NVGLB_CHOBATCH(IB)
          DO ISYQ=1,NSYM
            DO ICASE=1,4
              NPQ=NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
              IDGLB_CHOGROUP(ICASE,ISYQ,JSYM,IB)=IDISK
              CALL DDAFILE(LUDRATOT,0,WORK(IP_DUMMY),NPQ*NV,IDISK)
            END DO
          END DO
        END DO
      END DO

      RETURN
      END

      SUBROUTINE TRACHOSZ_FREE
      USE CHOVEC_IO
      DEALLOCATE(NVLOC_CHOBATCH)
      DEALLOCATE(IDLOC_CHOGROUP)
      DEALLOCATE(NVGLB_CHOBATCH)
      DEALLOCATE(IDGLB_CHOGROUP)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Auxiliary_Shells(iSO,nSO,jOff,iSO2Shl,nSO2Shl,iPair,nPair)

use Index_Functions, only: iTri
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nSO, iSO(2,nSO), jOff, nSO2Shl, iSO2Shl(nSO2Shl), nPair
integer(kind=iwp), intent(_OUT_) :: iPair(nPair)
integer(kind=iwp) :: i, k, kl, kSh, l, lSh

!write(u6,*) 'iSO'
!write(u6,*) '==='
!do i=1,nSO
!  write(u6,*) iSO(1,i),iSO(2,i)
!end do

!write(u6,*) 'iSO2Shl'
!write(u6,*) '======='
!do i=1,nSO2Shl
!  write(u6,*) i,iSO2Shl(i)
!end do
do i=1,nSO
  k = iSO(1,i)+jOff
  l = iSO(2,i)+jOff
  kSh = iSO2Shl(k)
  lSh = iSO2Shl(l)
  !write(u6,*) 'k,kSh=',k,kSh
  !write(u6,*) 'l,lSh=',k,lSh
  kl = iTri(kSh,lSh)
  iPair(kl) = 1
end do
!write(u6,*) 'iPairs'
!write(u6,*) '======'
!do i=1,nPair
!  write(u6,*) iPair(i)
!end do

return

end subroutine Get_Auxiliary_Shells

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  isSymmetric
*
*> @brief
*>   Return ``.True.`` if \p M is symmetric within tolerance \p Tol
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Test if matrix \p M is symmetric. If \f$ \forall i,j \; |M_{ij}-M_{ji}| \le \text{Tol} \f$
*> return ``.True.``
*>
*> @param[in] M   \p n &times; \p n square matrix to test
*> @param[in] n   Dimension of \p M
*> @param[in] Tol Tolerance
*>
*> @return ``.True.`` if \p M is symmetric within tolerance \p Tol
************************************************************************
      Logical Function isSymmetric(M,n,Tol)
      Implicit None
      Integer n
      Real*8  M(n,n)
      Real*8  Tol

      Integer i, j

      isSymmetric=.True.
      Do j=1,n
         Do i=j+1,n
            If (abs(M(i,j)-M(j,i)).gt.Tol) Then
               isSymmetric=.False.
               Return
            End If
         End Do
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Tr_prm_cnt(idbg,nBas_Cont,nBas_Prim)

use Basis_Info, only: dbsc, nBas, nCnttp
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idbg, nBas_Cont(8), nBas_Prim(0:7)
#include "Molcas.fh"
#include "itmax.fh"
#include "rinfo.fh"
integer(kind=iwp) :: i, ia, iBas, iBasL, ic, icnt, iCnttp, iCont, idx, iOff, ip, ipbasL, iPrim, iPrint, iSym, j, k, ka, kbias, la, &
                     nBas_Cont_Tot, ncnt, nSize, nSym, numck, numcl
logical(kind=iwp) :: New_Center, New_l, New_m, Old_Center, Old_l
integer(kind=iwp), allocatable :: icaddr(:), ihelp(:,:), mcaddr(:), numb(:), numc(:)
real(kind=wp), allocatable :: Tr(:)

! contracted basis, atomic basis functions
!
! symmetry info
!
! lant(i): number of atoms in i:th symmetry bf
! expand the coefficient matrix into symmetry basis set
! auxiliary
! icaddr(i): adresses in coeff for a symmetry adapted function

!                                                                      *
! THIS ROUTINE ONLY WORKS WITH SPHERICAL FUNCTIONS. NO CARTESIAN D:S!  *
!***********************************************************************
!                                                                      *
nSym = nIrrep
iPrint = 0
if ((iprint >= 10) .or. (idbg > 0)) then
  write(idbg,*) ' in repmat',nsym
  write(idbg,*) nSym,(nBas(i),i=0,nsym-1)
  write(idbg,*) nSym,(nrBas(i),i=1,nsym)
  write(idbg,*) nSym,(nBas_Prim(i),i=0,nsym-1)
  write(idbg,*) nSym,(nBas_Cont(i),i=1,nsym)
end if

nBas_Cont_Tot = 0
do iSym=1,nSym
  nBas_Cont_Tot = nBas_Cont_Tot+nBas_Cont(iSym)
end do
ncnt = 0
do iCnttp=1,nCnttp
  do icnt=1,dbsc(iCnttp)%nCntr
    ncnt = ncnt+1
  end do
end do
call mma_allocate(icaddr,nBas_Cont_Tot,label='icaddr')
call mma_allocate(mcaddr,nBas_Cont_Tot,label='mcaddr')
call mma_allocate(numb,nBas_Cont_Tot,label='numb')
call mma_allocate(numc,nBas_Cont_Tot,label='numc')
call mma_allocate(ihelp,ncnt,iTabMx,label='ihelp')
!                                                                      *
!***********************************************************************
!                                                                      *
! set up pointer

k = 0
ia = 0  ! center index
ka = 0  ! shell index
do iCnttp=1,nCnttp
  do icnt=1,dbsc(iCnttp)%nCntr
    ia = ia+1
    do la=1,nAngr(ia)+1
      ka = ka+1
      ihelp(ia,la) = k
      k = k+nPrimr(ka)*nBasisr(ka)
    end do
  end do
end do
if ((iPrint >= 10) .or. (idbg > 0)) then
  write(idbg,*) ' Help vector'
  ia = 0
  do iCnttp=1,nCnttp
    do icnt=1,dbsc(iCnttp)%nCntr
      ia = ia+1
      write(idbg,'(10i5)') (ihelp(ia,j),j=1,nAngr(ia)+1)
    end do
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over irreps

k = 0
do iSym=1,nSym
  numck = 1
  numcl = 0
  kbias = 0

  ! Loop over basis functions in irrep

  do iCont=1,nBas_Cont(iSym)
    k = k+1
    if (iCont > 1) then
      New_Center = icent(k) /= icent(k-1)
      New_l = lnang(k) /= lnang(k-1)
      New_m = lmag(k) /= lmag(k-1)
      if (New_m) kbias = kbias-numc(k-1)
      if (New_Center .or. New_l) kbias = 0
    else
      New_Center = .true.
      New_l = .true.
    end if
    kbias = kbias+1
    ka = 0
    ia = 0
    do iCnttp=1,nCnttp
      do iCnt=1,dbsc(iCnttp)%nCntr
        ia = ia+1
        do la=1,nAngr(ia)+1
          ka = ka+1
          Old_Center = icent(k) == ia
          Old_l = lnang(k) == (la-1)
          if (idbg > 0) write(idbg,*) ' at numck',k,ia,icent(k),la-1,lnang(k),ia,New_Center,New_l
          if (Old_Center .and. Old_l) then
            numc(k) = nBasisr(ka)
            numb(k) = nPrimr(ka)
            icaddr(k) = ihelp(ia,la)+(kbias-1)*nPrimr(ka)
            if ((k > 1) .and. (kbias == 1)) numck = numcl+numck
            mcaddr(k) = numck
            numcl = nPrimr(ka)
          end if
        end do  ! la
      end do    ! iCnt
    end do      ! iCnttp
  end do        ! iCont
end do          ! iSym
k = 0
if ((iPrint >= 10) .or. (idbg > 0)) then
  ic = 0
  ip = 0
  do iSym=1,nSym
    write(idbg,*) ' symmetry',iSym
    write(idbg,*) ' numb'
    write(idbg,'(20i4)') (numb(i+ic),i=1,nBas_Cont(iSym))
    write(idbg,*) ' numc'
    write(idbg,'(20i4)') (numc(i+ic),i=1,nBas_Cont(iSym))
    write(idbg,*) ' Pointer to contraction vector'
    write(idbg,'(20i4)') (icaddr(i+ic),i=1,nBas_Cont(iSym))
    write(idbg,*) ' mcaddr'
    write(idbg,'(20i4)') (mcaddr(i+ic),i=1,nBas_Cont(iSym))
    ic = ic+nBas_Cont(iSym)
    ip = ip+nBas_Prim(iSym-1)
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
nSize = 0
do iSym=1,nSym
  nSize = nSize+nBas_Cont(iSym)*nBas_Prim(iSym-1)
end do
call mma_allocate(Tr,nSize,label='Tr')
Tr(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate the transformation matrix.

ibasL = 0
iOff = 0

!---- Loop over irreps

do iSym=1,nSym

  ! loop over contracted

  do iBas=1,nBas_Cont(iSym)
    ibasL = ibasL+1
    ipbasL = mcaddr(ibasL)-1

    ! loop over uncontracted

    do iPrim=1,numb(ibasL)
      ipbasL = ipbasL+1
      idx = iOff+(iBas-1)*nBas_Prim(iSym-1)+ipbasL
      !write(u6,*) iBas,ipbasL
      Tr(idx) = rCof(icaddr(ibasL)+iPrim)

    end do     ! iPrim
  end do
  iOff = iOff+nBas_Cont(iSym)*nBas_Prim(iSym-1)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call Put_dArray('NEMO TPC',Tr,nSize)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Tr)
call mma_deallocate(icaddr)
call mma_deallocate(mcaddr)
call mma_deallocate(numb)
call mma_deallocate(numc)
call mma_deallocate(ihelp)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Tr_prm_cnt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Bingbing Suo                                     *
************************************************************************
      subroutine jl_ne_jr(mp,jl,jr,jwl,jwr,lopu)
#include "drt_h.fh"
#include "pl_structure_h.fh"
!-------------------------------------------------
! on entry:
!     jl  - left DRT node
!     jr  - right DRT node
!     jwl - left weight
!     jwr - right weight
! output
!     mp   - number of partial loop tails
!     lopu(1,i) - left weight of parital loop i
!     lopu(2,i) - right weight of partial loop i
!     lopu(3,i) - loop tail node
!-------------------------------------------------
      dimension lopu(4,loputmp),lopi(4,loputmp),lopj(4,loputmp)
      !lopu(1,*)=jwl lopu(2,*)=jwr,lopu(3,*)=jl,lopu(4,*)=jr
      !write(6,*) "in subroutine jl_ne_jr",jl,jr
      mp=0
      lpi=1
      lopi(1,1)=jwl
      lopi(2,1)=jwr
      lopi(3,1)=jl
      lopi(4,1)=jr
103   lpj=0
      do 114 nlp=1,lpi
        if(lopi(3,nlp).eq.lopi(4,nlp)) then
          mp=mp+1
          lopu(1:4,mp)=lopi(1:4,nlp)
          cycle
        endif
        jlp=lopi(3,nlp)
        jrp=lopi(4,nlp)
        do 115 idlr=1,4
          ml=jjl_sub(idlr,jlp)
          mr=jj_sub(idlr,jrp)
          !write(6,*) "ml,mr",ml,mr
          if(ml.eq.0.or.mr.eq.0) goto 115
          jwlp=lopi(1,nlp)
          jwrp=lopi(2,nlp)
          if(idlr.ne.1)jwlp=jwlp+iyl(idlr,jlp)
          if(idlr.ne.1)jwrp=jwrp+iy(idlr,jrp)
          lpj=lpj+1
          lopj(1,lpj)=jwlp
          lopj(2,lpj)=jwrp
          lopj(3,lpj)=ml
          lopj(4,lpj)=mr
115     continue
114   continue
      if(lpj.eq.0) goto 200
      lpi=lpj
      do i=1,lpj
        lopi(1:4,i)=lopj(1:4,i)
      enddo
      goto 103
200   return
      end

!  idb=1  in dbl_space      ity_up=0-5               0 ,jpad,iwdl,iwdr,
!  idb=2  in act_space      ity_up=0-5,itdown=0,3      jph, jpe,iwal,iwa
!  idb=3  betwin dbl and act   ity_up=0-5,itdown=0,3      jpe,iwdl,iwdr,
c**************************************************************
      subroutine prodab_h0(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
c**************************************************************
c     calculate h matrix elements which were contributed
c     only by whole inner space loops and store them into
c     vector2
c
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lopu(4,loputmp)
c     write(6,*) 'prodab_02 '

      goto(100,200,300),idb
! in dbl_space
c100   jpad=mg2
100   iwdl=mg3
      iwdr=mg4
      ipae=1
      jpad=1
      mntmp=0
      iwdown=iw_downwei(jpad,ipae)
      lwnu=iseg_downwei(ipae)
      do iwa=0,iwdown-1
        iwadl=iwalk_ad(jpad,ipae,iwa,iwdl)
        iwadr=iwalk_ad(jpad,ipae,iwa,iwdr)
        mm=iwadl
        nn=iwadr
        do m=1,lwnu
          mm=mm+1
          nn=nn+1
          if(mm.gt.nn) mntmp=mm*(mm-1)/2+nn
          if(nn.gt.mm) mntmp=nn*(nn-1)/2+mm
          vector2(mntmp)=vector2(mntmp)+wl
!            if(mntmp.eq.2) then
!                write(6,*)'  102',vector2(mntmp),wl
!           endif
        enddo
      enddo
c      enddo
      goto 1000
! in act_space
200   if(jpad.ne.jpadl) return
      jph=mg1
      jpl=mg2
c     iwal=mg3
c     iwar=mg4
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jpy=jphy(jph)
      in=ihy(jpy)

      call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
      do lp=1,mp
        iwl=lopu(1,lp)-1
        iwr=lopu(2,lp)-1
        jpe=lopu(3,lp)
        lwnu=iy(1,jpe)
        do jwu=jpy+1,jpy+in
          iwal=iwl+ihy(jwu)
          iwar=iwr+ihy(jwu)
          do jwd=1,lwnu
            iwal=iwal+1
            iwar=iwar+1
            do iwd=0,iwupwei-1
              iwadl=iwalk_ad(jpadl,ipael,iwal,iwd)
              iwadr=iwalk_ad(jpad,ipae,iwar,iwd)
              do iwe=1,isegdownwei
                mm=iwadl+iwe
                nn=iwadr+iwe
                if(mm.gt.nn) then
                  mntmp=mm*(mm-1)/2+nn
                else
                  mntmp=nn*(nn-1)/2+mm
                endif
                vector2(mntmp)=vector2(mntmp)+wl
                if(mntmp.eq.7) then
                  write(6,*)'  202',vector2(mntmp),wl
                endif
              enddo
            enddo
          enddo
        enddo
      enddo
      goto 1000
! betwin act and dbl
300   jpl =mg1
      iwdl=mg2
      iwdr=mg3
      isegdownwei=iseg_downwei(ipae)

      call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
      do lp=1,mp
        iwal=lopu(1,lp)-1
        iwar=lopu(2,lp)-1
        jpe= lopu(3,lp)
        jwnu=iy(1,jpe)
        do ii=1,jwnu
          iwal=iwal+1
          iwar=iwar+1
          mm=iwalk_ad(jpadl,ipael,iwal,iwdl)
          nn=iwalk_ad(jpad,ipae,iwar,iwdr)
          do iwe=1,isegdownwei
            mm=mm+1                  ! iwl=iwalk_ad
            nn=nn+1                  ! iwl=iwalk_ad
              if(mm.gt.nn) then
                mntmp=mm*(mm-1)/2+nn
              else
                mntmp=nn*(nn-1)/2+mm
              endif
              vector2(mntmp)=vector2(mntmp)+wl
!              if(mntmp.eq.2) then
!                write(6,*)'  302',vector2(mntmp),wl
!           endif
          enddo
        enddo
      enddo
      goto 1000
1000  return
      end

********************************************************************
      subroutine prodab_h(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
c*******************************************************************
c     whole inner space loops - h*c
c     26 feb 2007 - revised by suo bing for multi-root calculation
c
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lopu(4,loputmp)
!     write(6,*) 'prodab_02 ',mcroot,indx(1),iw_downwei(jpad,ipae)
      goto(100,200,300),idb
! in dbl_space
100   jpad=mg2
      iwdl=mg3
      iwdr=mg4
      ipaeend=25
      do ipae=1,ipaeend
        if(nu_ae(ipae).eq.0) cycle
        iwdown=iw_downwei(jpad,ipae)
        if(iwdown.eq.0) cycle
        lwnu=iseg_downwei(ipae)
        do iwa=0,iwdown-1
          iwadl=iwalk_ad(jpad,ipae,iwa,iwdl)
          iwadr=iwalk_ad(jpad,ipae,iwa,iwdr)
          do irot=1,mcroot
            irtidx=indx(irot)
            mm=iwadl+irtidx
            nn=iwadr+irtidx
            do m=1,lwnu
              mm=mm+1
              nn=nn+1
!              if(mm.gt.nci_dim.or.nn.gt.nci_dim) then
!                print*,
!     *            jpad,ipae,iw_downwei(jpad,ipae),iseg_downwei(ipae),
!     *            jpad_upwei(jpad),iw_sta(jpad,ipae),iwadl,iwadr
!              endif
              vector2(mm)=vector2(mm)+vector1(nn)*wl
              vector2(nn)=vector2(nn)+vector1(mm)*wl
            enddo
          enddo
        enddo
      enddo
      goto 1000

! in act_space
200   if(jpad.ne.jpadl) return
      jph=mg1
      jpl=mg2
c     iwal=mg3
c     iwar=mg4
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jpy=jphy(jph)
      in=ihy(jpy)

      call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
      do lp=1,mp
        iwl=lopu(1,lp)-1
        iwr=lopu(2,lp)-1
        jpe=lopu(3,lp)
        lwnu=iy(1,jpe)
        do jwu=jpy+1,jpy+in
          iwal=iwl+ihy(jwu)
          iwar=iwr+ihy(jwu)
          do jwd=1,lwnu
            iwal=iwal+1
            iwar=iwar+1
            do iwd=0,iwupwei-1
              iwadl=iwalk_ad(jpadl,ipael,iwal,iwd)
              iwadr=iwalk_ad(jpad,ipae,iwar,iwd)
              do irot=1,mcroot
                irtidx=indx(irot)
                mm=iwadl+irtidx
                nn=iwadr+irtidx
                do iwe=1,isegdownwei
                  mm=mm+1
                  nn=nn+1
                  vector2(mm)=vector2(mm)+vector1(nn)*wl
                  vector2(nn)=vector2(nn)+vector1(mm)*wl
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
      goto 1000

! betwin act and dbl
300   jpl =mg1
      iwdl=mg2
      iwdr=mg3
      isegdownwei=iseg_downwei(ipae)

      call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)

      do lp=1,mp
        iwal=lopu(1,lp)-1
        iwar=lopu(2,lp)-1
        jpe= lopu(3,lp)
        jwnu=iy(1,jpe)
        do ii=1,jwnu
          iwal=iwal+1
          iwar=iwar+1
          iwadl=iwalk_ad(jpadl,ipael,iwal,iwdl)
          iwadr=iwalk_ad(jpad,ipae,iwar,iwdr)
          do irot=1,mcroot
            irtidx=indx(irot)
            mm=iwadl+irtidx
            nn=iwadr+irtidx
            do iwe=1,isegdownwei
              mm=mm+1                  ! iwl=iwalk_ad
              nn=nn+1                  ! iwl=iwalk_ad
              vector2(mm)=vector2(mm)+vector1(nn)*wl
              vector2(nn)=vector2(nn)+vector1(mm)*wl
            enddo
          enddo
        enddo
      enddo
      goto 1000
1000  return
      end

      subroutine prodab(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
#include "drt_h.fh"

      select case (log_prod)
        case (1)
          call prodab_h(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
        case (2)  ! save H0 CI matrix, use for mrci
          call prodab_h0(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
        case (3)
          call prodab_h0_t(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
        case (4)  ! H0C, use for mrpt2
          call prodab_h0_d(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
        case default ! HC, use for mrci
      end select

      return
      end

      subroutine prodab_h0_d(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lopu(4,loputmp)
!log_prod=2:directly no_formh0
      character*16 loop_type
      loop_type=' prod_h0 '
c       write(*,*) 'prodab_h0 '

      goto(100,200,300),idb
! in dbl_space
100   continue
      iwdl=mg3
      iwdr=mg4
      iwdown=iw_downwei(jpad,ipae)
      lwnu=jpae_downwei(ipae)
      do iwa=0,iwdown-1
        iwadl=iwalk_ad(jpad,ipae,iwa,iwdl)
        iwadr=iwalk_ad(jpad,ipae,iwa,iwdr)
        do irot=1,mcroot
          irtidx=indx(irot)
          mm=iwadl+irtidx
          nn=iwadr+irtidx
          do m=1,lwnu
            mm=mm+1
            nn=nn+1
!            if(mm.gt.nci_dim.or.nn.gt.nci_dim) then
!              print*,
!     *          jpad,ipae,iw_downwei(jpad,ipae),iseg_downwei(ipae),
!     *          jpad_upwei(jpad),iw_sta(jpad,ipae),iwadl,iwadr
!            endif
            vector2(mm)=vector2(mm)+vector1(nn)*wl
            vector2(nn)=vector2(nn)+vector1(mm)*wl
          enddo
        enddo
        !do m=1,lwnu
        !  mm=mm+1
        !  nn=nn+1
        !  vector2(mm)=vector2(mm)+vector1(nn)*wl
        !  vector2(nn)=vector2(nn)+vector1(mm)*wl
        !enddo
      enddo
      goto 1000
! in act_space
200   if(jpad.ne.jpadl) return
      jph=mg1
      jpl=mg2
c     iwal=mg3
c     iwar=mg4
      iwupwei=jpad_upwei(jpad)
      jpaedownwei=jpae_downwei(ipae)
      jpy=jphy(jph)
      in=ihy(jpy)

      call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
      do lp=1,mp
        iwl=lopu(1,lp)-1
        iwr=lopu(2,lp)-1
        jpe=lopu(3,lp)
        lwnu=iy(1,jpe)
        do jwu=jpy+1,jpy+in
          iwal=iwl+ihy(jwu)
          iwar=iwr+ihy(jwu)
          do jwd=1,lwnu
            iwal=iwal+1
            iwar=iwar+1
            do iwd=0,iwupwei-1
              iwadl=iwalk_ad(jpadl,ipael,iwal,iwd)
              iwadr=iwalk_ad(jpad,ipae,iwar,iwd)
              do irot=1,mcroot
                irtidx=indx(irot)
                mm=iwadl+irtidx
                nn=iwadr+irtidx
                do iwe=1, jpaedownwei
                  mm=mm+1
                  nn=nn+1
                  vector2(mm)=vector2(mm)+vector1(nn)*wl
                  vector2(nn)=vector2(nn)+vector1(mm)*wl
                enddo
              enddo
              !do iwe=1,jpaedownwei
              !  mm=iwadl+iwe
              !  nn=iwadr+iwe
              !  vector2(mm)=vector2(mm)+vector1(nn)*wl
              !  vector2(nn)=vector2(nn)+vector1(mm)*wl
              !enddo
            enddo
          enddo
        enddo
      enddo
      goto 1000
! between act and dbl
300   jpl =mg1
      iwdl=mg2
      iwdr=mg3
      jpaedownwei=jpae_downwei(ipae)

      call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
      do lp=1,mp
        iwal=lopu(1,lp)-1
        iwar=lopu(2,lp)-1
        jpe= lopu(3,lp)
        jwnu=iy(1,jpe)
        do ii=1,jwnu
          iwal=iwal+1
          iwar=iwar+1
          iwadl=iwalk_ad(jpadl,ipael,iwal,iwdl)
          iwadr=iwalk_ad(jpad,ipae,iwar,iwdr)
          do irot=1,mcroot
            irtidx=indx(irot)
            mm=iwadl+irtidx
            nn=iwadr+irtidx
            do iwe=1,jpaedownwei
              mm=mm+1                  ! iwl=iwalk_ad
              nn=nn+1                  ! iwl=iwalk_ad
              vector2(mm)=vector2(mm)+vector1(nn)*wl
              vector2(nn)=vector2(nn)+vector1(mm)*wl
            enddo
          enddo
        enddo
      enddo
1000  return
      end

      subroutine prodab_h0_t(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lopu(4,loputmp)
!log_prod=1:truanditional formh0
      character*16 loop_type
      loop_type=' prod_h0 '

c       write(*,*) 'prodab_h0 '

      goto(100,200,300),idb
! in dbl_space
100   continue
      iwdl=mg3
      iwdr=mg4
      iwdown=iw_downwei(jpad,ipae)
      lwnu=jpae_downwei(ipae)
      do iwa=0,iwdown-1
          mm=iwalk_ad(jpad,ipae,iwa,iwdl)
          nn=iwalk_ad(jpad,ipae,iwa,iwdr)
          do m=1,lwnu
            mm=mm+1
            nn=nn+1
            mnh0=mm*(mm-1)/2+nn
            if(nn.gt.mm) mnh0=nn*(nn-1)/2+mm
             vector2(mnh0)=vector2(mnh0)+wl
!            if((mm.eq.1.and.nn.eq.9).or.(mm.eq.9.and.nn.eq.1)) then
!           write(nf2,'(a10,2i5,2f18.8)')' in dbl ',mm,nn,wl,vector2(mnh
!             endif
         enddo
       enddo
      goto 1000
! in act_space
200   if(jpad.ne.jpadl) return
      jph=mg1
      jpl=mg2
c     iwal=mg3
c     iwar=mg4
      iwupwei=jpad_upwei(jpad)
      jpaedownwei=jpae_downwei(ipae)
      jpy=jphy(jph)
      in=ihy(jpy)

       call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
      do lp=1,mp
         iwl=lopu(1,lp)-1
         iwr=lopu(2,lp)-1
         jpe=lopu(3,lp)
        lwnu=iy(1,jpe)
        do jwu=jpy+1,jpy+in
          iwal=iwl+ihy(jwu)
           iwar=iwr+ihy(jwu)
          do jwd=1,lwnu
             iwal=iwal+1
             iwar=iwar+1
             do iwd=0,iwupwei-1
               iwadl=iwalk_ad(jpadl,ipael,iwal,iwd)
               iwadr=iwalk_ad(jpad,ipae,iwar,iwd)
               do iwe=1,jpaedownwei
                 mm=iwadl+iwe
                 nn=iwadr+iwe
                mnh0=mm*(mm-1)/2+nn
                if(nn.gt.mm) mnh0=nn*(nn-1)/2+mm
                 vector2(mnh0)=vector2(mnh0)+wl
!             if((mm.eq.1.and.nn.eq.9).or.(mm.eq.9.and.nn.eq.1)) then
!           write(nf2,'(a10,2i5,2f18.8)')' in act ',mm,nn,wl,vector2(mnh
!          endif
                     enddo
             enddo
           enddo
         enddo
       enddo
      goto 1000
! between act and dbl
300       jpl =mg1
      iwdl=mg2
       iwdr=mg3
      jpaedownwei=jpae_downwei(ipae)

      call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
      do lp=1,mp
         iwal=lopu(1,lp)-1
         iwar=lopu(2,lp)-1
         jpe= lopu(3,lp)
         jwnu=iy(1,jpe)
         do ii=1,jwnu
           iwal=iwal+1
           iwar=iwar+1
           mm=iwalk_ad(jpadl,ipael,iwal,iwdl)
          nn=iwalk_ad(jpad,ipae,iwar,iwdr)
           do iwe=1,jpaedownwei
             mm=mm+1                  ! iwl=iwalk_ad
             nn=nn+1                  ! iwl=iwalk_ad
             mnh0=mm*(mm-1)/2+nn
             if(nn.gt.mm) mnh0=nn*(nn-1)/2+mm
             vector2(mnh0)=vector2(mnh0)+wl
!             if((mm.eq.1.and.nn.eq.9).or.(mm.eq.9.and.nn.eq.1)) then
!       write(nf2,'(a10,2i5,2f18.8)')' act-dbl ',mm,nn,wl,vector2(mnh0)
!                 endif
           enddo
         enddo
      enddo
1000  return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine o5b_cvb( &
#                  define _CALLING_
#                  include "optb_interface.fh"
                  )

use casvb_global, only: hh, maxize, odx, ograd, scalesmall
use Definitions, only: wp, iwp

implicit none
#include "optb_interface.fh"
integer(kind=iwp) :: ipu
real(kind=wp), external :: dnrm2_

#include "macros.fh"
unused_var(grdnrm)

odx(:) = ograd(:)
if (.not. maxize) odx(1:nparm) = -odx(1:nparm)
dxnrm = dnrm2_(nparm,odx,1)
if (.not. close2conv) then
  ipu = 1
else
  ipu = 2
end if
if ((dxnrm > hh) .or. scalesmall(ipu)) then
  odx(1:nparm) = hh/dxnrm*odx(1:nparm)
  dxnrm = hh
end if

return

end subroutine o5b_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Funi_Print
      Implicit Real*8 (A-H,O-Z)
#include "nq_info.fh"
#include "print.fh"
      Logical Check
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      Check(i,j)=iAnd(i,2**(j-1)).ne.0
*                                                                      *
************************************************************************
*                                                                      *
      iRout=666
      iPrint=nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
      Call Get_dScalar('EThr',EThr)
      T_X=Min(T_X,EThr*1.0D-2)
      T_Y=Min(T_Y,EThr*1.0D-2)
      Threshold=Min(Threshold,EThr*1.0D-4)
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.10) Then
      Write (6,*)
      Write (6,'(6X,A)') 'Fast Utility for Numerical Integration'
      Write (6,'(6X,A)') 'Authors: R. Lindh, Y. Carissan, '
     &                 //'M. Wierzbowska and L. Gagliardi.'
      End If
*
      If (iPrint.ge.6) Then
      Write (6,*)
      Write (6,'(6X,A)') 'Numerical integration parameters'
      Write (6,'(6X,A)') '======================================'
      Write (6,'(6X,A,21X,A)') 'Radial quadrature type:    ',Quadrature
*
      If (Quadrature(1:3).eq.'LMG') Then
         Write (6,'(6X,A,E11.4)') 'Radial quadrature accuracy:',
     &                             Threshold
      Else
         Write (6,'(6X,A,18X,I5)')    'Size of radial grid:       ',
     &                             nR
      End If
*
      If (Check(iOpt_Angular,3)) Then
         Write (6,'(6X,A,25X,I4)') 'Lebedev angular grid:',L_Quad
      Else If (Check(iOpt_Angular,1)) Then
         Write (6,'(6X,A,I4)') 'Lobatto angular grid, l_max:',L_Quad
      Else
         Write (6,'(6X,A,I4)')
     &     'Gauss and Gauss-Legendre angular grid, l_max:',L_Quad
      End If
*
      If (Angular_Prunning.eq.On) Then
         Write (6,'(6X,A,1X,ES9.2)')
     &         'Angular grid prunned with the crowding factor:',
     &         Crowding
         Write (6,'(6X,A,1X,ES9.2)')
     &         '                            and fading factor:',
     &         Fade
      End If
      If (Check(iOpt_Angular,2)) Then
         Write (6,'(6X,A)') 'The whole atomic grid is scanned for each'
     &                    //' sub block.'
      End If
*
      Write (6,'(6X,A,2X,ES9.2)')
     &      'Screening threshold for integral computation:',
     &      T_Y
      Write (6,'(6X,A,2X,ES9.2)')
     &      'Screening threshold for density computation: ',
     &      T_X
      If (Quadrature(1:3).ne.'LMG') Then
         Write (6,'(6X,A,20X,ES9.2)') 'Radial quadrature accuracy:',
     &                             Threshold
      End If
*
      Write (6,'(6X,A,17X,I7)') 'Maximum batch size:        ',nGridMax
      If (NQ_Direct.eq.On) Then
         Write (6,'(6X,A)') 'AO values are recomputed each iteration'
      Else
         Write (6,'(6X,A)') 'AO values are stored on disk'
      End If
      Write (6,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Put flag on RUNFILE to indicate that we are doing DFT.
*
*     Call Get_iOption(iOpt)
      Call Get_iScalar('System BitSwitch',iOpt)
      iOpt=iOr(iOpt,2**6)
*     Call Put_iOption(iOpt)
      Call Put_iScalar('System BitSwitch',iOpt)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine strip_blanks_cvb(line,blanks,nblank,blankdelim)
! If BLANKDELIM, a given number of blanks (not leading or trailing)
! will be subsituted by a single blank. Otherwise all blanks are stripped.

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
character(len=*), intent(inout) :: line
integer(kind=iwp), intent(in) :: nblank
character, intent(in) :: blanks(nblank)
logical(kind=iwp), intent(in) :: blankdelim
integer(kind=iwp) :: iblank, ich, ich2, lenline
integer(kind=iwp), allocatable :: lv(:)

lenline = len_trim(line)
do iblank=1,nblank
  if (blanks(iblank) /= ' ') then
    do ich=1,lenline
      if (line(ich:ich) == blanks(iblank)) line(ich:ich) = ' '
    end do
  end if
end do
call mma_allocate(lv,lenline,label='lv')
ich2 = 0
do ich=1,lenline
  if (line(ich:ich) /= ' ') then
    ich2 = ich2+1
    lv(ich2) = ich
  else if (blankdelim .and. (ich >= 2) .and. (line(ich-1:ich-1) /= ' ') .and. (ich2 /= 0)) then
    ! (Final condition eliminates leading blanks:)
    ich2 = ich2+1
    lv(ich2) = ich
  end if
end do
do ich=1,ich2
  line(ich:ich) = line(lv(ich):lv(ich))
end do
lenline = ich2
call mma_deallocate(lv)

return

end subroutine strip_blanks_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_ComputeCoulombIntermediates(Timing,nD,ip_DBlocks,ip_V,CNorm)
! Thomas Bondo Pedersen, October 2010.
!
! Purpose: Compute Coulomb intermediates
!
!      V(J) = sum_uv C(uv,J)*D(uv)
!
!      using LDF fitting coefficients.
!      Frobenius norms of the fitting
!      coefficients are computed as a byproduct, stored as:
!      CNorm(4*(AB-1)+1)
!          =sum_uAvBJ sqrt[C(uAvB,J)**2]       {all J}
!      CNorm(4*(AB-1)+2)
!          =sum_uAvBJA sqrt[C(uAvB,JA)**2]     {J on A}
!      CNorm(4*(AB-1)+3)
!          =sum_uAvBJB sqrt[C(uAvB,JB)**2]     {J on B}
!      CNorm(4*(AB-1)+4)
!          =sum_uAvBJAB sqrt[C(uAvB,JAB)**2]   {J on AB (2CF)}
!
! FOR BLOCKED VERSION: Call LDF_ComputeCoulombIntermediates0

#ifdef _MOLCAS_MPP_
use Para_Info, only: nProcs, Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
#include "ldf_atom_pair_info.fh"
logical(kind=iwp), intent(in) :: Timing
integer(kind=iwp), intent(in) :: nD, ip_DBlocks(nD), ip_V(nD)
real(kind=wp), intent(out) :: CNorm(4*NumberOfAtomPairs)
logical(kind=iwp) :: doNorm
real(kind=wp) :: tC1, tC2, tW1, tW2
integer(kind=iwp) :: TaskListID, iD, l_C, iAtomPair, iAtom, jAtom, nAtom, nuv, M, ipD, ipV, ipC
real(kind=wp), allocatable :: LDFCBlk(:)
logical(kind=iwp), external :: Rsv_Tsk
integer(kind=iwp), external :: LDF_nBas_Atom, LDF_nBasAux_Atom, LDF_nBasAux_Pair_wLD, LDF_nAtom
real(kind=r8), external :: ddot_
#include "WrkSpc.fh"

if (Timing) call CWTIme(tC1,tW1)

! Initialize V arrays
do iD=1,nD
  call LDF_ZeroAuxBasVector(ip_V(iD))
end do

! Allocate array for storing coefficients
l_C = 0
do iAtomPair=1,NumberOfAtomPairs
  iAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+1)
  jAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+2)
  nuv = LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
  M = LDF_nBasAux_Pair_wLD(iAtomPair)
  l_C = max(l_C,nuv*M)
end do
call mma_allocate(LDFCBlk,l_C,label='LDFCBlk')

! compute norm?
doNorm = .true.
#ifdef _MOLCAS_MPP_
! Init norm array
if ((nProcs > 1) .and. Is_Real_Par()) then
  if (doNorm) CNorm(:) = Zero
end if
#endif

! Compute V
nAtom = LDF_nAtom()
call Init_Tsk(TaskListID,NumberOfAtomPairs)
do while (Rsv_Tsk(TaskListID,iAtomPair))
  call LDF_CIO_ReadC_wLD(iAtomPair,LDFCBlk,l_C)
  iAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+1)
  jAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+2)
  nuv = LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
  ipC = 1
  M = LDF_nBasAux_Atom(iAtom)
  if (doNorm) then
    CNorm(4*(iAtomPair-1)+1) = sqrt(dDot_(nuv*LDF_nBasAux_Pair_wLD(iAtomPair),LDFCBlk,1,LDFCBlk,1))
    CNorm(4*(iAtomPair-1)+2) = sqrt(dDot_(nuv*M,LDFCBlk(ipC),1,LDFCBlk(ipC),1))
  end if
  do iD=1,nD
    ipD = iWork(ip_DBlocks(iD)-1+iAtomPair)
    ipV = iWork(ip_V(iD)-1+iAtom)
    call dGeMV_('T',nuv,M,One,LDFCBlk(ipC),nuv,Work(ipD),1,One,Work(ipV),1)
  end do
  if (jAtom /= iAtom) then
    ipC = ipC+nuv*M
    M = LDF_nBasAux_Atom(jAtom)
    if (doNorm) then
      CNorm(4*(iAtomPair-1)+3) = sqrt(dDot_(nuv*M,LDFCBlk(ipC),1,LDFCBlk(ipC),1))
    end if
    do iD=1,nD
      ipD = iWork(ip_DBlocks(iD)-1+iAtomPair)
      ipV = iWork(ip_V(iD)-1+jAtom)
      call dGeMV_('T',nuv,M,One,LDFCBlk(ipC),nuv,Work(ipD),1,One,Work(ipV),1)
    end do
  else
    if (doNorm) then
      CNorm(4*(iAtomPair-1)+3) = CNorm(4*(iAtomPair-1)+2)
    end if
  end if
  if (iWork(ip_AP_2CFunctions-1+2*(iAtomPair-1)+1) > 0) then
    ipC = ipC+nuv*M
    M = iWork(ip_AP_2CFunctions-1+2*(iAtomPair-1)+1)
    if (doNorm) then
      CNorm(4*(iAtomPair-1)+4) = sqrt(dDot_(nuv*M,LDFCBlk(ipC),1,LDFCBlk(ipC),1))
    end if
    do iD=1,nD
      ipD = iWork(ip_DBlocks(iD)-1+iAtomPair)
      ipV = iWork(ip_V(iD)-1+nAtom+iAtomPair)
      call dGeMV_('T',nuv,M,One,LDFCBlk(ipC),nuv,Work(ipD),1,One,Work(ipV),1)
    end do
  else
    if (doNorm) then
      CNorm(4*(iAtomPair-1)+4) = Zero
    end if
  end if
end do
call Free_Tsk(TaskListID)
if (Timing) then
  call CWTIme(tC2,tW2)
  write(u6,'(A,2(1X,F12.2),A)') 'Time spent computing Coulomb (V) intermediates:   ',tC2-tC1,tW2-tW1,' seconds'
end if

! Deallocation
call mma_deallocate(LDFCBlk)

#ifdef _MOLCAS_MPP_
! Get complete V and norm on all nodes
if ((nProcs > 1) .and. Is_Real_Par()) then
  if (Timing) call CWTime(tC1,tW1)
  do iD=1,nD
    call LDF_P_AddAuxBasVector(ip_V(iD))
  end do
  if (doNorm) then
    call GAdGOp(CNorm,4*NumberOfAtomPairs,'+')
  end if
  if (Timing) then
    call CWTime(tC2,tW2)
    write(u6,'(A,2(1X,F12.2),A)') 'Parallel overhead for Coulomb (V) intermediates:  ',tC2-tC1,tW2-tW1,' seconds'
  end if
end if
#endif

end subroutine LDF_ComputeCoulombIntermediates

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_TrcIdl_Report()
!
! Thomas Bondo Pedersen, May 2010.
!
! Report idle status for all processors

use Para_Info, only: nProcs
use Cholesky, only: Cho_Real_Par, Idle, LuPri
#ifdef _DEBUGPRINT_
use Cholesky, only: Trace_Idle
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i, nIdle
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: l_Idle
#endif
integer(kind=iwp), allocatable :: TIloc(:)

#ifdef _DEBUGPRINT_
if ((.not. allocated(Idle)) .or. (.not. Trace_Idle)) then
  write(LuPri,'(A)') 'Cho_TrcIdl_Report should not be called in this run!'
  write(LuPri,*) 'Trace_Idle=',Trace_Idle
  call Cho_Quit('Illegal call to Cho_TrcIdl_Report',103)
end if
#endif

if (Cho_Real_Par) then
# ifdef _DEBUGPRINT_
  l_Idle = 0
  if (allocated(Idle)) l_Idle = size(Idle)
  if (l_Idle < nProcs) then
    write(LuPri,'(A)') 'Error detected in Cho_TrcIdl_Report: l_Idle < nProcs'
    write(LuPri,*) 'Trace_Idle=',Trace_Idle
    call Cho_Quit('Cho_TrcIdle_Report: l_Idle not properly set!',103)
  end if
# endif
  call mma_allocate(TIloc,[0,nProcs-1],Label='TILoc')
  TIloc(:) = Idle(1:nProcs)
  call Cho_GAIGOp(TIloc,nProcs,'+')
  nIdle = 0
  do i=0,nProcs-1
    nIdle = nIdle+min(TIloc(i),1)
  end do
  if (nIdle == 0) then
    write(LuPri,'(A)') 'No idle procs to report'
  else
    write(LuPri,'(I4,A,I4,A,F7.2,A)') nIdle,' of',nProcs,' procs have been idle (', &
                                      1.0e2_wp*real(nIdle,kind=wp)/real(nProcs,kind=wp),' %)'
    write(LuPri,'(A)') 'List of idle procs:'
    do i=0,nProcs-1
      if (TIloc(i) > 0) write(LuPri,'(I4,A,I8,A)') i,' (Idle counter:',TIloc(i),')'
    end do
  end if
  call mma_deallocate(TIloc)
else
  if (Idle(1) == 0) then
    write(LuPri,'(A)') 'No idle procs to report!'
  else
    write(LuPri,'(A,I8,A)') 'Proc 0 has been idle',Idle(1),' times'
  end if
end if
call XFlush(LuPri)

end subroutine Cho_TrcIdl_Report

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SSOTRA(SGS,CIS,EXS,ISYM,LSM,NA,NO,TRA,NCO,CI,TMP)

use sguga, only: CIStruct, EXStruct, SGStruct
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Half
use Definitions, only: wp, iwp

implicit none
type(SGSTruct), intent(in) :: SGS
type(CISTruct), intent(in) :: CIS
type(EXSTruct), intent(inout) :: ExS
integer(kind=iwp), intent(in) :: ISYM, LSM, NA, NO, NCO
real(kind=wp), intent(in) :: TRA(NO,NO)
real(kind=wp), intent(inout) :: CI(NCO)
real(kind=wp), intent(out) :: TMP(NCO)
integer(kind=iwp) :: IK, IKLEV, IL, IP, IPLEV, NI
real(kind=wp) :: CKK, CPK, X
integer(kind=iwp), allocatable :: ILEV(:)

! ILEV(IORB)=GUGA LEVEL CORRESPONDING TO A SPECIFIC ACTIVE ORBITAL
! OF SYMMETRY ISYM.
call mma_allocate(ILEV,NA,Label='ILEV')
NI = NO-NA
IL = 0
do IP=1,NA
  do
    IL = IL+1
    if (SGS%ISM(IL) == ISYM) exit
  end do
  ILEV(IP) = IL
end do
!TEST write(u6,*)' Check prints in SSOTRA.'
!TEST write(u6,*)' ISYM:',ISYM
do IK=1,NA
  IKLEV = ILEV(IK)
  TMP(:) = Zero
  do IP=1,NA
    IPLEV = ILEV(IP)
    CPK = TRA(NI+IP,NI+IK)
    if (IP == IK) CPK = CPK-One
    X = Half*CPK
    !TEST write(u6,*)' IP,IK,X:',IP,IK,X
    if (abs(X) < 1.0e-14_wp) cycle
    call SG_Epq_Psi(SGS,CIS,EXS,IPLEV,IKLEV,X,LSM,CI,TMP)
  end do
  CKK = TRA(NI+IK,NI+IK)
  X = Three-CKK
  CI(:) = CI(:)+X*TMP(:)
  do IP=1,NA
    IPLEV = ILEV(IP)
    CPK = TRA(NI+IP,NI+IK)
    if (IP == IK) CPK = CPK-One
    if (abs(CPK) < 1.0e-14_wp) cycle
    call SG_Epq_Psi(SGS,CIS,EXS,IPLEV,IKLEV,CPK,LSM,TMP,CI)
  end do
end do
call mma_deallocate(ILEV)

end subroutine SSOTRA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Giovanni Ghigo                                         *
************************************************************************
      Subroutine Freq1(nIter,nInter,nRowH,mRowH,Delta,dq,q)
************************************************************************
*                                                                      *
* Object: Displacements for Numerical estimation of single rows and    *
*         columns of Hessian                                           *
*                                                                      *
* Called from: RlxCtl when lRowH=.True.                                *
*                                                                      *
* Author: Giovanni Ghigo, University of Torino, Italy                  *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
      Real*8 q(nInter,nIter+1), dq(nInter,nIter)
      Integer mRowH(10)
*
      iRout = 183
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Write(6,*)' [Freq1] nInter, nIter, Delta =',nInter,nIter,Delta
         Call RecPrt('Initial dq:','(10F9.6)',dq,nInter,nIter)
         Call RecPrt('Initial  q:','(10F9.6)', q,nInter,nIter+1)
      EndIf
*
*-----Compute the new shift
*
      call dcopy_(nInter,[Zero],0,dq(1,nIter),1)
      If (nIter.le.nRowH) then
         kInter = mRowH(nIter)
         dq(kInter,nIter) = Delta
      EndIf
      If (nIter.gt.1) then
         jInter = mRowH(nIter-1)
         dq(jInter,nIter) = -Delta ! Undo previous displacement
      End If
*
*---- Compute the new parameter set.
*
      call dcopy_(nInter,q(1,nIter),1,q(1,nIter+1),1)
      Call DaXpY_(nInter,One,dq(1,nIter),1,q(1,nIter+1),1)
*
      If (iPrint.gt.5) Then
         Write (6,*)
     &           ' Accumulate the gradient for yet one parameter set'
         Write (6,*)
      End If
*
      If (iPrint.ge.98) Then
         Write(6,*)' [Freq1] nInter, nIter, Delta =',nInter,nIter,Delta
         Call RecPrt('Final dq:','(10F9.6)',dq,nInter,nIter)
         Call RecPrt('Final  q:','(10F9.6)', q,nInter,nIter+1)
      EndIf
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RHS_NAC(Fock,SLag,ipS2)

use Index_Functions, only: iTri, nTri_Elem
use ipPage, only: ipin, ipnout, opout, W
use MCLR_Data, only: ipCI, ipMat, n1Dens, n2Dens, nConf1, nDens, NSSA, XISPSM
use CandS, only: ICSM, ISSM
use input_mclr, only: nBas, nConf, nCSF, nRoots, nSym, ntAsh, PT2, State_Sym
use PCM_grad, only: do_RF, DSSAO, DSSMO, PCMSSAO, PCMSSMO, PCM_grad_CLag, PrepPCM2
use ISRotation, only: InvEne, InvSCF
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half, Quart
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Fock(nDens)
real(kind=wp), intent(inout) :: SLag(nRoots,nRoots)
integer(kind=iwp), intent(in) :: ipS2
integer(kind=iwp) :: i, ij, ij2, ijkl, ijkl2, iRC, j, jR, k, kl, kl2, kR, l, LuDens, nConfL, nConfR, ng1, ng2
real(kind=wp) :: factor, vSLag
real(kind=wp), allocatable :: CIL(:), CIR(:), F(:), G1m(:), G1q(:), G1r(:), G2q(:), G2r(:), T(:)

!                                                                      *
!***********************************************************************
!                                                                      *
ng1 = nTri_Elem(ntAsh)
ng2 = nTri_Elem(ng1)
if (.not. InvEne) then
  call mma_allocate(G1q,n1Dens,Label='G1q')
  call mma_allocate(G2q,n2Dens,Label='G2q')
else
  call mma_allocate(G1q,nG1,Label='G1q')
  call mma_allocate(G2q,nG2,Label='G2q')
end if
call mma_allocate(G1m,nG1,Label='G1m')
call mma_allocate(G1r,n1Dens,Label='G1r')
G1r(:) = Zero
call mma_allocate(G2r,n2Dens,Label='G2r')
G2r(:) = Zero

! Calculate one- and two-particle transition matrices
! from the CI vectors of the two NAC states
! (code copied from CIdens_SA, same symmetry)

nConfL = max(nconf1,nint(xispsm(State_sym,1)))
nConfR = max(nconf1,nint(xispsm(State_sym,1)))
call mma_allocate(CIL,nConfL,Label='CIL')
call mma_allocate(CIR,nConfR,Label='CIR')

if (PT2 .or. ((.not. InvEne) .and. InvSCF)) then
  ! Almost the same as the code in rhs_sa, but slightly modified
  !iR = iRLXRoot
  if (.not. PT2) SLag(NSSA(2),NSSA(1)) = SLag(NSSA(2),NSSA(1))+One
  do jR=1,nRoots
    do kR=1,jR
      vSLag = SLag(jR,kR)

      call CSF2SD(W(ipCI)%A(1+(jR-1)*nconf1),CIL,1)
      !call opout(ipCI)
      call CSF2SD(W(ipCI)%A(1+(kR-1)*nconf1),CIR,1)
      !call opout(ipCI)
      !call ipnout(-1)
      !icsm = 1
      !issm = 1

      if (abs(vSLag) > 1.0e-10_wp) then
        call Densi2_mclr(2,G1q,G2q,CIL,CIR,0,0,0,n1Dens,n2Dens)
        G1r(:) = G1r(:)+vSLag*G1q(:)
        G2r(:) = G2r(:)+vSLag*G2q(:)
      end if

      if (kR /= jR) then
        vSLag = SLag(kR,jR)
        if (abs(vSLag) > 1.0e-10_wp) then
          call Densi2_mclr(2,G1q,G2q,CIR,CIL,0,0,0,n1Dens,n2Dens)
          G1r(:) = G1r(:)+vSLag*G1q(:)
          G2r(:) = G2r(:)+vSLag*G2q(:)
        end if
      end if
    end do
  end do
  nConf = ncsf(1) !! nconf is overwritten somewhere in densi2_mclr
else
  call ipIn(ipCI)
  call CSF2SD(W(ipCI)%A(1+(NSSA(2)-1)*nconf1),CIL,State_sym)
  call opout(ipCI)
  call CSF2SD(W(ipCI)%A(1+(NSSA(1)-1)*nconf1),CIR,State_sym)
  call opout(ipCI)
  call ipnout(-1)
  icsm = 1
  issm = 1
  call Densi2_mclr(2,G1r,G2r,CIL,CIR,0,0,0,n1Dens,n2Dens)
end if
call mma_deallocate(CIL)
call mma_deallocate(CIR)

if (do_RF) then
  nconf = ncsf(State_sym)
  ! Update state-specific quantities using rotated G1r
  DSSMO(1:ntAsh,1:ntAsh) = reshape(G1r(1:ntAsh**2),[ntAsh,ntAsh])
  call PrepPCM2(2,DSSMO,DSSAO,PCMSSAO,PCMSSMO)
  call PCM_grad_CLag(2,ipCI,ipS2)
end if

! Symmetrize densities
! For the one-particle density, save the antisymmetric part too

ij = 0
do i=0,ntAsh-1
  do j=0,i-1
    ij = ij+1
    G1q(ij) = (G1r(1+i*ntAsh+j)+G1r(1+j*ntAsh+i))*Half
    ! Note that the order of subtraction depends on how the matrix
    ! will be used when contracting with derivative integrals
    ! This is found to give the correct results:
    G1m(ij) = (G1r(1+j*ntAsh+i)-G1r(1+i*ntAsh+j))*Half
  end do
  ij = ij+1
  G1q(ij) = G1r(1+i*ntAsh+i)
  G1m(ij) = Zero
end do

! The anti-symmetric RDM is contructed somewhere in the CASPT2
! module. It will be read from disk in out_pt2.f.
if (PT2) G1m(:) = Zero

do i=1,ntAsh**2
  j = nTri_Elem(i)
  G2r(j) = Half*G2r(j)
end do
do i=0,ntAsh-1
  do j=0,i-1
    ij = nTri_Elem(i)+j
    do k=0,ntAsh-1
      do l=0,k
        kl = nTri_Elem(k)+l
        if (ij >= kl) then
          factor = Quart
          if (ij == kl) factor = Half
          ijkl = nTri_Elem(ij)+kl
          ij2 = i*ntAsh+j
          kl2 = k*ntAsh+l
          G2q(1+ijkl) = factor*G2r(1+nTri_Elem(ij2)+kl2)
          ij2 = max(j*ntAsh+i,l*ntAsh+k)
          kl2 = min(j*ntAsh+i,l*ntAsh+k)
          G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
          if (k /= l) then
            ij2 = i*ntAsh+j
            kl2 = l*ntAsh+k
            G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
            if (ij /= kl) then
              ij2 = max(j*ntAsh+i,k*ntAsh+l)
              kl2 = min(j*ntAsh+i,k*ntAsh+l)
              G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
            end if
          end if
        end if
      end do
    end do
  end do
  ij = nTri_Elem(i+1)-1
  do k=0,ntAsh-1
    do l=0,k
      kl = nTri_Elem(k)+l
      if (ij >= kl) then
        factor = Half
        if (ij == kl) factor = One
        ijkl = nTri_Elem(ij)+kl
        ij2 = i*ntAsh+i
        kl2 = k*ntAsh+l
        G2q(1+ijkl) = factor*G2r(1+nTri_Elem(ij2)+kl2)
        if (k /= l) then
          kl2 = l*ntAsh+k
          G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
        end if
      end if
    end do
  end do
end do

! Write the symmetric densities in the runfile and
! the antisymmetric one-particle in MCLRDENS

iRC = 0
LuDens = 20
call DaName(LuDens,'MCLRDENS')
call dDaFile(LuDens,1,G1m,ng1,iRC)
call DaClos(LuDens)
call Put_dArray('D1mo',G1q,ng1)
call Put_dArray('P2mo',G2q,ng2)

! Store transition Fock matrix

do i=1,ntAsh
  do j=1,ntAsh
    G1r(ntAsh*(j-1)+i) = G1q(iTri(i,j))
  end do
end do
do i=1,ntAsh
  do j=1,ntAsh
    ij = iTri(i,j)
    ij2 = ntAsh*(i-1)+j
    do k=1,ntAsh
      do l=1,ntAsh
        kl = iTri(k,l)
        kl2 = ntAsh*(k-1)+l
        factor = One
        if ((ij >= kl) .and. (k == l)) factor = Two
        if ((ij < kl) .and. (i == j)) factor = Two
        ijkl = iTri(ij,kl)
        ijkl2 = iTri(ij2,kl2)
        G2r(ijkl2) = factor*G2q(ijkl)
      end do
    end do
  end do
end do

! Note: 1st arg = zero for no inactive density (TDM)
call mma_allocate(T,nDens,Label='T')
call mma_allocate(F,nDens,Label='F')
call FockGen(Zero,G1r,G2r,T,Fock,1)
call TCMO(T,1,-2)
ij = 0
do k=1,nSym
  do i=0,nBas(k)-1
    do j=0,i-1
      ij = ij+1
      F(ij) = T(ipMat(k,k)+nBas(k)*j+i)+T(ipMat(k,k)+nBas(k)*i+j)
    end do
    ij = ij+1
    F(ij) = T(ipMat(k,k)+nBas(k)*i+i)
  end do
end do
call Put_dArray('FockOcc',F,nDens)

call mma_deallocate(T)
call mma_deallocate(F)
call mma_deallocate(G1r)
call mma_deallocate(G2r)
call mma_deallocate(G2q)
call mma_deallocate(G1m)
call mma_deallocate(G1q)

end subroutine RHS_NAC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Funi_Init
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "itmax.fh"
#include "nq_info.fh"
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
* Initialize the defaults values of the parameters.
*
*     Default Grid
      Quadrature='MHL '
      nR=75
      L_Quad=29
      Crowding=3.0D0
      Fade=6.0D0
      MBC=' '
*
      ntotgp=0
*
*     Various idefault thresholds for the integral evaluation.
*
      T_X      =1.0D-18
      T_Y      =1.0D-11
      Threshold=1.0D-25
*
      Angular_Prunning = On
      Grid_Type=Moving_Grid
      Rotational_Invariance= On
      NQ_Direct=On
      nGridMax=128
      Packing=On
C     Packing=Off
*
*     Bit 1: set Lobatto, not set Gauss and Gauss-Legendre
*     Bit 2: set scan the whole atomic grid, not set use subset
*     Bit 3: set Lebedev, override bit 1
      iOpt_Angular=4
*                                                                      *
************************************************************************
*                                                                      *
      Flop=Zero
      Do i = 0, LMax_NQ
         R_Max(i)=Zero
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_sort_T_pairs

! Sorting module with a very simple O(N^2) insertion sort
! algorithm or using the average O(NlogN) Quicksort algorithm
!
! Sort array of interaction T-pairs using Quicksort wrt
!     (a) RHS index
!     (b) T-vector component
!     (c) T-vector modulus (ratio)

use fmm_global_paras, only: INTK, REALK, T_pair_single
implicit none
private
! Public procedures
public :: fmm_quicksort_wrt_RHS, &
          fmm_quicksort_wrt_vector, &
          fmm_quicksort_wrt_ratio

! criteria for switching from Quicksort to Insertion-Sort algorithms
integer(INTK), parameter :: quicksort_CUTOFF = 10

contains

!-------------------------------------------------------------------------------

subroutine insertion_sort_wrt_RHS(arr)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)
  type(T_pair_single) :: tmp
  integer(INTK) :: i, j

  iloop: do i=1,size(arr)
    tmp = arr(i)
    do j=(i-1),1,-1
      if (arr(j)%paras%RHS_id > tmp%paras%RHS_id) then
        arr(j+1) = arr(j)
      else
        arr(j+1) = tmp
        cycle iloop
      end if
    end do
    arr(1) = tmp
  end do iloop

end subroutine insertion_sort_wrt_RHS

!-------------------------------------------------------------------------------

subroutine RHS_swap_elements(arr,i,j)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)
  integer(INTK), intent(in)          :: i, j
  type(T_pair_single) :: tmp

  tmp = arr(i)
  arr(i) = arr(j)
  arr(j) = tmp

end subroutine RHS_swap_elements

!-------------------------------------------------------------------------------
! Subroutine to return the median of first, last, and centre array elements.
! order these and hide the pivot (median) as the second to last array element
! (acts as a sentinel whilst the last is the largest and put in correct place.)

function RHS_median_of_three(arr,left,right)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)
  integer(INTK), intent(in)          :: left, right
  integer(INTK) :: RHS_median_of_three
  integer(INTK) :: cntr

  cntr = (left+right)/2

  if (arr(left)%paras%RHS_id > arr(cntr)%paras%RHS_id) call RHS_swap_elements(arr,left,cntr)
  if (arr(left)%paras%RHS_id > arr(right)%paras%RHS_id) call RHS_swap_elements(arr,left,right)
  if (arr(cntr)%paras%RHS_id > arr(right)%paras%RHS_id) call RHS_swap_elements(arr,cntr,right)

  call RHS_swap_elements(arr,cntr,right-1)
  RHS_median_of_three = arr(right-1)%paras%RHS_id

end function RHS_median_of_three

!-------------------------------------------------------------------------------

recursive subroutine fmm_quicksort_wrt_RHS(arr)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)

  integer(INTK) :: left, right
  integer(INTK) :: i, j, pivot

  left = 1
  right = size(arr)

  if (left+quicksort_CUTOFF > right) then
    ! array too small for Quicksort to be efficient, so don't use it
    call insertion_sort_wrt_RHS(arr)
    return
  end if

  pivot = RHS_median_of_three(arr,left,right)
  ! partition array elements about chosen pivot
  i = left
  j = right-2
  do ! until left, right pointers cross
    ! increment left until large element found
    do while (arr(i)%paras%RHS_id < pivot)
      i = i+1
    end do
    ! increment right until small element found
    do while (arr(j)%paras%RHS_id > pivot)
      j = j-1
    end do
    if (i < j) then
      ! swap items (i,j)
      call RHS_swap_elements(arr,i,j)
      ! now increment (i,j) to avoid infinite loop if both = pivot
      i = i+1
      j = j-1
    else
      exit
    end if
  end do
  ! i is now the position where the pivot should be
  ! swap pivot back to middle of array
  call RHS_swap_elements(arr,i,right-1)

  ! now sort sub-arrays either side of pivot
  call fmm_quicksort_wrt_RHS(arr(left:(i-1)))
  call fmm_quicksort_wrt_RHS(arr((i+1):right))

end subroutine fmm_quicksort_wrt_RHS

!-------------------------------------------------------------------------------
! Insertion sort for sorting of T-pair batch wrt 1 component of T-vector
!-----------------------------------------------------------------------

subroutine insertion_sort_wrt_vector(arr,xyz)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)
  integer(INTK), intent(in)          :: xyz

  type(T_pair_single) :: tmp
  integer(INTK) :: i, j

  iloop: do i=1,size(arr)
    tmp = arr(i)
    do j=(i-1),1,-1
      if (arr(j)%r_ab(xyz) > tmp%r_ab(xyz)) then
        arr(j+1) = arr(j)
      else
        arr(j+1) = tmp
        cycle iloop
      end if
    end do
    arr(1) = tmp
  end do iloop

end subroutine insertion_sort_wrt_vector

!-------------------------------------------------------------------------------
! Quicksort for sorting of T-pair batch wrt 1 component of T-vector
!------------------------------------------------------------------

subroutine vector_swap_elements(arr,i,j)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)
  integer(INTK), intent(in)          :: i, j
  type(T_pair_single) :: tmp

  tmp = arr(i)
  arr(i) = arr(j)
  arr(j) = tmp

end subroutine vector_swap_elements

!-------------------------------------------------------------------------------
! subroutine to return the median of first, last, and centre array elements.
! order these and hide the pivot (median) as the second to last array element
! (acts as a sentinel whilst the last is the largest and put in correct place.)

function vector_median_of_three(arr,left,right,xyz)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)
  integer(INTK), intent(in)          :: left, right
  integer(INTK), intent(in)          :: xyz

  real(REALK) :: vector_median_of_three
  integer(INTK) :: cntr

  cntr = (left+right)/2

  if (arr(left)%r_ab(xyz) > arr(cntr)%r_ab(xyz)) call vector_swap_elements(arr,left,cntr)
  if (arr(left)%r_ab(xyz) > arr(right)%r_ab(xyz)) call vector_swap_elements(arr,left,right)
  if (arr(cntr)%r_ab(xyz) > arr(right)%r_ab(xyz)) call vector_swap_elements(arr,cntr,right)

  call vector_swap_elements(arr,cntr,right-1)
  vector_median_of_three = arr(right-1)%r_ab(xyz)

end function vector_median_of_three

!-------------------------------------------------------------------------------

recursive subroutine fmm_quicksort_wrt_vector(arr,xyz)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)
  integer(INTK), intent(in)          :: xyz

  integer(INTK) :: left, right
  integer(INTK) :: i, j
  real(REALK) :: pivot

  left = 1
  right = size(arr)

  if (left+quicksort_CUTOFF > right) then
    ! array too small for Quicksort to be efficient, so don't use it
    call insertion_sort_wrt_vector(arr,xyz)
    return
  end if

  pivot = vector_median_of_three(arr,left,right,xyz)
  ! partition array elements about chosen pivot
  i = left
  j = right-2
  do ! until left, right pointers cross
    ! increment left until large element found
    do while (arr(i)%r_ab(xyz) < pivot)
      i = i+1
    end do
    ! increment right until small element found
    do while (arr(j)%r_ab(xyz) > pivot)
      j = j-1
    end do
    if (i < j) then
      ! swap items (i,j)
      call vector_swap_elements(arr,i,j)
      ! now increment (i,j) to avoid infinite loop if both = pivot
      i = i+1
      j = j-1
    else
      exit
    end if
  end do
  ! i is now the position where the pivot should be
  ! swap pivot back to middle of array
  call vector_swap_elements(arr,i,right-1)

  ! now sort sub-arrays either side of pivot
  call fmm_quicksort_wrt_vector(arr(left:(i-1)),xyz)
  call fmm_quicksort_wrt_vector(arr((i+1):right),xyz)

end subroutine fmm_quicksort_wrt_vector

!-------------------------------------------------------------------------------
! Insertion sort for sorting of T-pair batch wrt T-vector modulus (ratio)
!------------------------------------------------------------------------

subroutine insertion_sort_wrt_ratio(arr)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)

  type(T_pair_single) :: tmp
  integer(INTK) :: i, j

  iloop: do i=1,size(arr)
    tmp = arr(i)
    do j=(i-1),1,-1
      if (arr(j)%paras%ratio > tmp%paras%ratio) then
        arr(j+1) = arr(j)
      else
        arr(j+1) = tmp
        cycle iloop
      end if
    end do
    arr(1) = tmp
  end do iloop

end subroutine insertion_sort_wrt_ratio

!-------------------------------------------------------------------------------
! Quicksort for sorting of T-pair batch wrt T-vector modulus (ratio)
!-------------------------------------------------------------------

subroutine ratio_swap_elements(arr,i,j)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)
  integer(INTK), intent(in)          :: i, j
  type(T_pair_single) :: tmp

  tmp = arr(i)
  arr(i) = arr(j)
  arr(j) = tmp

end subroutine ratio_swap_elements

!-------------------------------------------------------------------------------
! subroutine to return the median of first, last, and centre array elements.
! order these and hide the pivot (median) as the second to last array element
! (acts as a sentinel whilst the last is the largest and put in correct place.)

function ratio_median_of_three(arr,left,right)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)
  integer(INTK), intent(in)          :: left, right

  real(REALK) :: ratio_median_of_three
  integer(INTK) :: cntr

  cntr = (left+right)/2

  if (arr(left)%paras%ratio > arr(cntr)%paras%ratio) call ratio_swap_elements(arr,left,cntr)
  if (arr(left)%paras%ratio > arr(right)%paras%ratio) call ratio_swap_elements(arr,left,right)
  if (arr(cntr)%paras%ratio > arr(right)%paras%ratio) call ratio_swap_elements(arr,cntr,right)

  call ratio_swap_elements(arr,cntr,right-1)
  ratio_median_of_three = arr(right-1)%paras%ratio

end function ratio_median_of_three

!-------------------------------------------------------------------------------

recursive subroutine fmm_quicksort_wrt_ratio(arr)

  implicit none
  type(T_pair_single), intent(inout) :: arr(:)

  integer(INTK) :: left, right
  integer(INTK) :: i, j
  real(REALK) :: pivot

  left = 1
  right = size(arr)

  if (left+quicksort_CUTOFF > right) then
    ! array too small for Quicksort to be efficient, so don't use it
    call insertion_sort_wrt_ratio(arr)
    return
  end if

  pivot = ratio_median_of_three(arr,left,right)
  ! partition array elements about chosen pivot
  i = left
  j = right-2
  do ! until left, right pointers cross
    ! increment left until large element found
    do while (arr(i)%paras%ratio < pivot)
      i = i+1
    end do
    ! increment right until small element found
    do while (arr(j)%paras%ratio > pivot)
      j = j-1
    end do
    if (i < j) then
      ! swap items (i,j)
      call ratio_swap_elements(arr,i,j)
      ! now increment (i,j) to avoid infinite loop if both = pivot
      i = i+1
      j = j-1
    else
      exit
    end if
  end do
  ! i is now the position where the pivot should be
  ! swap pivot back to middle of array
  call ratio_swap_elements(arr,i,right-1)

  ! now sort sub-arrays either side of pivot
  call fmm_quicksort_wrt_ratio(arr(left:(i-1)))
  call fmm_quicksort_wrt_ratio(arr((i+1):right))

end subroutine fmm_quicksort_wrt_ratio

!-------------------------------------------------------------------------------

end module fmm_sort_T_pairs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Jeppe Olsen                                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine BLKCLS(IBLKS,NBLKS,IBLKCLS,ISPSPCL,NCLS,LCLS,NOCTPA,NOCTPB)
! Class of each block, and dimension of each class
!
! Jeppe Olsen

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NBLKS, IBLKS(8,NBLKS), NOCTPA, NOCTPB, ISPSPCL(NOCTPA,NOCTPB), NCLS
integer(kind=iwp), intent(out) :: IBLKCLS(NBLKS), LCLS(NCLS)
integer(kind=iwp) :: IICLS, JBLK

!write(u6,*) ' ISPSPCL'
!call IWRTMA(ISPSPCL,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
LCLS(:) = 0
do JBLK=1,NBLKS
  IICLS = ISPSPCL(IBLKS(1,JBLK),IBLKS(2,JBLK))
  IBLKCLS(JBLK) = IICLS
  LCLS(IICLS) = LCLS(IICLS)+IBLKS(8,JBLK)
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' BLKCLS Speaking'
write(u6,*) ' ==============='
write(u6,*)
write(u6,*) ' Dimension of each class'
call IWRTMA(LCLS,1,NCLS,1,NCLS)
write(u6,*)
write(u6,*) ' Class of each block :'
call IWRTMA(IBLKCLS,1,NBLKS,1,NBLKS)
#endif

end subroutine BLKCLS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Anders Bernhardsson                              *
*               1994, Roland Lindh                                     *
************************************************************************
      SubRoutine CmbnS2(Rnxyz,nZeta,la,lb,Zeta,rKappa,Final,Alpha,Beta,
     &                  Hess,nHess,DAO,IfHss,IndHss,indgrd,iu,iv,nOp)
************************************************************************
*                                                                      *
* Object: compute the 2nd derivative  of the overlap matrix.           *
*                                                                      *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChTbl
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"

      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6),
     &       Zeta(nZeta), rKappa(nZeta), Beta(nZeta),
     &       Rnxyz(nZeta,3,0:la+2,0:lb+2), Alpha(nZeta),
     &       Hess(nHess),
     &       DAO(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2)
      Logical IfHss(0:1,0:2,0:1,0:2)
      Integer IndHss(0:1,0:2,0:1,0:2,0:nIrrep-1),istb(0:1),
     &          nOp(2), ia(3),
     &          ib(3),indgrd(0:2,0:1,0:nirrep-1)
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
*     Index in the triang. local hessian
*
      I(i1,i2)=i1*(i1-1)/2+i2
*
*EAW 970912     ixyz=idLoc(DAO(1,1,1))
c     iRout = 134
c     iPrint = nPrint(iRout)
      iStb(0)=iu
      iStb(1)=iv
      iQ = 1
*     Call GetMem(' Enter CmbnS2','LIST','REAL',iDum,iDum)
*
      exp32 = -Three/Two
      Do 25 iZeta = 1, nZeta
         rKappa(iZeta) = rKappa(iZeta) * Zeta(iZeta)**exp32
 25   Continue
c     If (iPrint.ge.99) Then
c        Call RecPrt(' In CmbnS2: Zeta  ',' ',Zeta  ,1,nZeta)
c        Call RecPrt(' In CmbnS2: rKappa',' ',rKappa,1,nZeta)
c        Call RecPrt(' In CmbnS2: Alpha ',' ',Alpha ,1,nZeta)
c        Call RecPrt(' In CmbnS2: Beta  ',' ',Beta  ,1,nZeta)
c     End If
      Do 10 iax = 0, la
         ia(1)=iax
         iyaMax=la-ia(1)
      Do 11 ibx = 0, lb
         ib(1)=ibx
         iybMax=lb-ib(1)
         Do 20 iay = 0, iyaMax
            ia(2)=iay
            ia(3) = la-ia(2)-ia(1)
            ipa= Ind(la,ia(1),ia(3))
         Do 21 iby = 0, iybMax
            ib(2)=iby
          ib(3) = lb-ib(2)-ib(1)
          ipb= Ind(lb,ib(1),ib(3))
*
*
*           Combine overlap integrals
*
*           Integrals like dI/dx1dx1
*
          Do 5 iCoor=1,3
            jCoor=Mod(iCoor,3)+1
            kCoor=Mod(jCoor,3)+1
            If (IfHss(0,iCoor-1,0,iCoor-1)) Then
                  Do 30 iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,I(iCoor,iCoor))=rKappa(iZeta)*
     &                   ((Two*Alpha(iZeta))**2 *
     &                   Rnxyz(iZeta,iCoor,ia(iCoor)+2,ib(iCoor))*
     &                   Rnxyz(iZeta,jCoor,ia(jCoor),  ib(jCoor))*
     &                   Rnxyz(iZeta,kCoor,ia(kCoor),  ib(kCoor))-
     &                   Two *  Alpha(iZeta) *
     &                   Rnxyz(iZeta,iCoor,ia(iCoor),ib(iCoor))*
     &                   Rnxyz(iZeta,jCoor,ia(jCoor),ib(jCoor))*
     &                   Rnxyz(iZeta,kCoor,ia(kCoor),ib(kCoor)))
                     If (ia(iCoor).gt.0) Then
                        Final(iZeta,ipa,ipb,I(iCoor,iCoor)) =
     &                      Final(iZeta,ipa,ipb,I(iCoor,iCoor))
     &                      - rKappa(iZeta)*
     &                      (Four *  Alpha(iZeta)* Dble(ia(iCoor)) *
     &                      Rnxyz(iZeta,iCoor,ia(iCoor),ib(iCoor))*
     &                      Rnxyz(iZeta,jCoor,ia(jCoor),ib(jCoor))*
     &                      Rnxyz(iZeta,kCoor,ia(kCoor),ib(kCoor)))
                     End If
                     If (ia(iCoor).gt.1) Then
                        Final(iZeta,ipa,ipb,I(iCoor,iCoor)) =
     &                      Final(iZeta,ipa,ipb,I(iCoor,iCoor))
     &                      + rKappa(iZeta)*
     &                      (Dble(ia(iCoor)*(ia(iCoor)-1))*
     &                      Rnxyz(iZeta,iCoor,ia(iCoor)-2,ib(iCoor))*
     &                      Rnxyz(iZeta,jCoor,ia(jCoor),  ib(jCoor))*
     &                      Rnxyz(iZeta,kCoor,ia(kCoor),  ib(kCoor)))
                     End If
 30               Continue
            End If
 5       Continue
*

*
*           Integrals like dI/dxdz
*
            Do 56 iCoor=2,3
            Do 52 jCoor=1,iCoor-1
                 If (IfHss(0,iCoor-1,0,jCoor-1)) Then
                  Do 51 kCoor=1,3
                    Do 50 iZeta = 1, nZeta
                     If (kCoor.eq.1) Then
                        Final(iZeta,ipa,ipb,
     &                       I(iCoor,jCoor))= rKappa(iZeta)
                     End If
                     If ((kCoor.eq.iCoor).or.(kCoor.eq.jCoor)) Then
                        rIc=Two*Alpha(iZeta)*
     &                      Rnxyz(iZeta,kCoor,ia(kCoor)+1,ib(kCoor))
*
                        If (ia(kCoor).gt.0)
     &                    rIc=rIc-Dble(ia(kCoor))*
     &                       Rnxyz(iZeta,kCoor,ia(kCoor)-1,ib(kCoor))
*
                        Final(iZeta,ipa,ipb,
     &                        I(iCoor,jCoor))=
     &                  Final(iZeta,ipa,ipb,
     &                        I(iCoor,jCoor))*
     &                                       rIc
                     Else
                        Final(iZeta,ipa,ipb,
     &                        I(iCoor,jCoor))=
     &                  Final(iZeta,ipa,ipb,
     &                        I(iCoor,jCoor))*
     &                                Rnxyz(iZeta,kCoor,ia(kCoor),
     &                                ib(kCoor))
                     End If
 50               Continue
 51             Continue
                End If
 52         Continue
 56         Continue
 21      Continue
 20      Continue
 11   Continue
 10   Continue

*
*     Trace the Hessian integrals
*
      nDAO = nZeta * (la+1)*(la+2)/2 * (lb+1)*(lb+2)/2
c     If (iPrint.ge.99) Then
c        Call RecPrt(' S(1)',' ',Final,nDAO,21)
c        Call RecPrt('   D ','(6f12.6)',DAO(1,1,1),nDAO,1)
c     End If
      Do 90 iIrrep=0,nIrrep-1
      Do 100 iCnt=0,1
        Do 105  iCar=1,3
          Do 110 jCnt=0,1
            if (iCnt.eq.jCnt) Then
              iStop=iCar
            Else
              iStop=3
            End If
            Do 115 jCar=1,iStop
            If (IndHss(iCnt,iCar-1,jCnt,jCar-1,iIrrep).ne.0) Then
*
*              Accumulate contribution to the Hessian
*
*
*            Get the characteristics of the diff operator
*
               iCh=iEOr(2**(iCar-1)*iCnt,2**(jCar-1)*jCnt)
*
*             Get the character of the operator in the present irrep
*
               ps=DBLE(iChTbl(iIrrep,nOp(2))**
     &             (iCnt+jCnt))
*
*              Get the transf. character of the diff. operator
*
               ps = ps*DBLE(iPrmt(nOp(2),iCh))
*
*        If the over triangular diff. are needed  multiply by two instead
*        Because of that x2x1 y2y1 z2z1 just appear ones in the (1,2)
*        "subhessian".
*
               if (((iCnt.ne.jCnt).and.(iCar.eq.jCar)).and.
     &               (Abs(indgrd(iCar-1,iCnt,iIrrep)).eq.
     &                Abs(indgrd(jCar-1,jCnt,iIrrep))) ) Then
                         ps=ps*Two
               End If
               iHess = Abs(IndHss(iCnt,iCar-1,jCnt,jCar-1,iIrrep))
               Fact = DBLE(iStb(iCnt)*iStb(jCnt))/DBLE(nIrrep**2)
               Fact = Fact * ps
               if (IndHss(iCnt,iCar-1,jCnt,jCar-1,iIrrep).gt.0) Then
                rtemp=DDot_(nDAO,DAO,1,Final(1,1,1,I(Max(iCar,jCar),
     &                 Min(iCar,jCar))),1)
                Hess(iHess) = Hess(iHess) + Fact*rtemp
               Else
                Fact=Fact*DBLE((-1)**(icnt+jcnt))
                rtemp=DDot_(nDAO,DAO,1,Final(1,1,1,I(Max(iCar,jCar),
     &                 Min(iCar,jCar))),1)
                Hess(iHess) = Hess(iHess) + Fact*rtemp
               End If
            End If
 115       Continue
 110     Continue
 105    Continue
 100  Continue
 90   Continue
*
*     Call GetMem(' Exit CmbnS2','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Beta)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GSTTBL_MCLR(C,CTT,IATP,IASM,IBTP,IBSM,IOCOC,
     &                  NOCTPA,NOCTPB,NSASO,NSBSO,PSSIGN,ICOOSC,IDC,
     &                  PLSIGN,LUC,SCR)
*
* obtain  determinant block (iatp iasm, ibtp ibsm )
* from vector packed in combination format according to IDC
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(*),CTT(*),NSASO(NOCTPA,*),NSBSO(NOCTPB,*)
      DIMENSION IOCOC(NOCTPA,NOCTPB),ICOOSC(NOCTPA,NOCTPB,*)
      DIMENSION SCR(*)
      DIMENSION ISGVST(IBSM)
      DIMENSION IDUM(1)
*
      PSIGN=0.0D0 ! dummy initialize
*
* =================
* Read in from disc
* =================
      IF(LUC.NE.0) THEN
        CALL IFRMDS(IDUM,1,-1,LUC)
        LBL=IDUM(1)
        CALL FRMDSC_MCLR(SCR,LBL,-1,LUC,IMZERO)
        NAST = NSASO(IATP,IASM)
        NBST = NSBSO(IBTP,IBSM)
        IF(LBL.NE.0)
     &  CALL SDCMRF_MCLR(CTT,SCR,2,IATP,IBTP,IASM,IBSM,NAST,NBST,
     &              IDC,PSSIGN,PLSIGN,ISGVST,LDET,LCOMB)
*. ISGVST and PLSIGN missing to make it work for IDC = 3,4
      ELSE
* =================
* Pack out from C
* =================
* Permutation sign
      IF(IDC.EQ.2) THEN
        PSIGN = PSSIGN
      ELSE IF(IDC .EQ. 3 ) THEN
        PSIGN = PLSIGN
      ELSE
         PSIGN=0.0D0
      END IF
      PLSSGN = PLSIGN * PSSIGN
* check for different packing possibilities and unpack
      IF(IASM.GT.IBSM.OR.IDC.EQ.1
     &   .OR.(IDC.EQ.3.AND.IASM.GE.IBSM))THEN
**************
** IASM > IBSM
**************
        IF ( IDC.LT.4 ) THEN
*. Simple copy
          IBASE = ICOOSC(IATP,IBTP,IASM)
          NELMNT = NSASO(IATP,IASM)*NSBSO(IBTP,IBSM)
          CALL DCOPY_(NELMNT,C(IBASE),1,CTT,1)
        ELSE IF( IDC.EQ.4 ) THEN
*. MLMS packed
          IF(IATP.GT.IBTP) THEN
            IBASE = ICOOSC(IATP,IBTP,IASM)
            NELMNT = NSASO(IATP,IASM)*NSBSO(IBTP,IBSM)
            CALL DCOPY_(NELMNT,C(IBASE),1,CTT,1)
          ELSE IF(IATP.EQ.IBTP) THEN
            IBASE = ICOOSC(IATP,IATP,IASM)
            NAST = NSASO(IATP,IASM)
            CALL TRIPK2(CTT,C(IBASE),2,NAST,NAST,PLSIGN*PSSIGN)
          ELSE IF( IATP.LT.IBTP) THEN
            IBASE = ICOOSC(IBTP,IATP,IASM)
            NROW  = NSASO(IBTP,IASM)
            NCOL  = NSBSO(IATP,IBSM)
            CALL TRPMAT(C(IBASE),NROW,NCOL,CTT)
            NELMNT = NROW*NCOL
            CALL DSCAL_(NELMNT,PLSIGN*PSSIGN,CTT,1)
          END IF
        END IF
      ELSE IF( IASM.EQ.IBSM) THEN
**************
** IASM = IBSM
**************
        IF(IATP.GT.IBTP.OR.IDC.EQ.3) THEN
*.. simple copying
          IBASE = ICOOSC(IATP,IBTP,IASM)
          NELMNT = NSASO(IATP,IASM)*NSBSO(IBTP,IBSM)
          CALL DCOPY_(NELMNT,C(IBASE),1,CTT,1)
        ELSE IF( IATP.EQ.IBTP) THEN
*.. expand triangular packed matrix
          IBASE = ICOOSC(IATP,IBTP,IASM)
          NAST = NSASO(IATP,IASM)
          CALL TRIPK2(CTT,C(IBASE),2,NAST,NAST,PSSIGN)
        ELSE IF( IATP .LT. IBTP) THEN
*.. transpose ibtp iasm iatp ibsm block
          IBASE = ICOOSC(IBTP,IATP,IASM)
          NRI = NSASO(IBTP,IASM)
          NCI = NSBSO(IATP,IASM)
          CALL TRPMAT(C(IBASE),NRI,NCI,CTT)
          IF(PSSIGN.EQ.-1.0D0) CALL DSCAL_(NRI*NCI,-1.0d0,CTT,1)
        END IF
      ELSE IF( IASM .LT. IBSM ) THEN
**************
** IASM < IBSM
**************
*.. transpose ibtp ibsm iatp iasm block
        IF(IDC.LT.4) THEN
          IBASE = ICOOSC(IBTP,IATP,IBSM)
          NRI = NSASO(IBTP,IBSM)
          NCI = NSBSO(IATP,IASM)
          IF( IDC.EQ.2) THEN
            CALL TRPMAT(C(IBASE),NRI,NCI,CTT)
          ELSE IF( IDC.EQ.3) THEN
            CALL DCOPY_(NRI*NCI,C(IBASE),1,CTT,1)
          END IF
          IF(PSIGN.EQ.-1.0D0) CALL DSCAL_(NRI*NCI,-1.0D0,CTT,1)
        ELSE IF ( IDC .EQ. 4 ) THEN
          IF(IBTP.GT.IATP) THEN
            IBASE = ICOOSC(IBTP,IATP,IBSM)
            NRI = NSASO(IBTP,IBSM)
            NCI = NSBSO(IATP,IASM)
            CALL TRPMAT(C(IBASE),NRI,NCI,CTT)
            IF(PSSIGN.EQ.-1.0D0) CALL DSCAL_(NRI*NCI,-1.0D0,CTT,1)
          ELSE IF (IBTP.EQ.IATP) THEN
            IBASE = ICOOSC(IBTP,IATP,IBSM)
            NRI   = NSASO(IATP,IBSM)
            NCI   = NSBSO(IATP,IASM)
            CALL TRIPK2(CTT,C(IBASE),2,NRI,NCI,PLSSGN)
            IF(PLSIGN.EQ.-1.0D0) CALL DSCAL_(NRI*NCI,-1.0D0,CTT,1)
          ELSE IF( IBTP.LT.IATP) THEN
            IBASE = ICOOSC(IATP,IBTP,IBSM)
            NELMNT = NSASO(IATP,IBSM)*NSBSO(IBTP,IASM)
            CALL DCOPY_(NELMNT,C(IBASE),1,CTT,1)
            IF(PLSIGN.EQ.-1.0D0) CALL DSCAL_(NELMNT,-1.0D0,CTT,1)
          END IF
        END IF
      END IF
      END IF
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer_array(IOCOC)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mol2vb2_cvb(vecvb,vecmol,isyml,fac,iwr,
     >  indxa,indxb,nstra,nstrb,nsa,nsb)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension vecvb(ndet),vecmol(*)
      dimension indxa(nsa),indxb(nsb)
      dimension nstra(mxirrep),nstrb(mxirrep)

      call indxab_cvb(indxa,indxb,nstra,nstrb,nsa,nsb)

c  Now loop casvb -> molcas
      idet=0
      do 500 isyma=1,mxirrep
      isymb=md2h(isyma,isyml)
      nnsa=nstra(isyma)
      nnsb=nstrb(isymb)
      if(nnsa.le.0 .or. nnsb.le.0)goto 500

      ioffsa=0
      do 510 is=1,isyma-1
      ioffsa=ioffsa+nstra(is)
510   continue
      ioffsb=0
      do 520 is=1,isymb-1
      ioffsb=ioffsb+nstrb(is)
520   continue

      do 600 isb=1,nnsb
      indbet=indxb(isb+ioffsb)
      do 601 isa=1,nnsa
      index=indxa(isa+ioffsa)+(indbet-1)*nda
      idet=idet+1
      if(iwr.eq.0)then
        vecmol(idet)=vecvb(index)
      elseif(iwr.eq.1)then
        vecvb(index)=vecmol(idet)
      elseif(iwr.eq.2)then
        vecvb(index)=vecvb(index)+fac*vecmol(idet)
      endif
601   continue
600   continue
500   continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jonas Bostrom                                          *
************************************************************************
      Subroutine Compute_A_jk_mp2(iSO,jVec,kVec,Ajk,fac_ij,fac_kl,
     &                        nVec,iOpt)
**************************************************************************
*     Author: J Bostrom
*
*     Purpose: Loading A-matrix for mp2 from disk
*
**************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "exterm.fh"
#include "chomp2g_alaska.fh"
#include "WrkSpc.fh"
      Real*8  Ajk,Fac_ij, Fac_kl, dum(1)

      Character*16 SECNAM
      Parameter (SECNAM = 'Compute_A_jk_mp2')

      Ajk = 0.0d0
      If(imp2prpt .eq. 2) Then
         lTot = 1
         iAdrA = nVec*(kVec-1) + jVec
         Call dDaFile(LuAVector(iOpt),2,dum,lTot,iAdrA)
         Ajk_mp2=dum(1)
         Ajk = Ajk + (Ajk_mp2*Fac_kl*Fac_ij)
      End If

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iSO)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  ip_of_iWork
*
*> @brief
*>   Return pointer to be used in \c iWork which corresponds to the first element of array \p A
*> @author R. Lindh
*>
*> @details
*> Function returns pointer such that \p A and \c iWork(ip_of_iWork(A)) refer to
*> the same memory location.
*>
*> @param[in] A first element of integer array
*>
*> @return pointer to \p A in \c iWork
************************************************************************
      Integer Function ip_of_iWork(A)
      Implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Integer A
      Interface
        Function iiLoc(x) bind(C,name='iiloc_')
          use Definitions, only: MOLCAS_C_INT
          integer(MOLCAS_C_INT) :: iiLoc
          integer(MOLCAS_C_INT) :: x
        End Function iiLoc
      End Interface
*
      loc1=(iiLoc(A)-iiLoc(iWork(ip_iDummy)))
      loc2=(iiLoc(iWork(ip_iDummy+1))-iiLoc(iWork(ip_iDummy)))
      ip_of_iWork = ip_iDummy + loc1/loc2
*
      Return
      End
*
      Integer Function ip_of_iWork_d(A)
      Implicit real*8 (a-h,o-z)
      Real*8 A
      ip_of_iWork_d = ip_of_iWork_d_internal(A)
*
*     This is to allow type punning without an explicit interface
      Contains
      Integer Function ip_of_iWork_d_internal(A)
      Use Iso_C_Binding
      Real*8, Target :: A
      Integer, Pointer :: iA
      Call C_F_Pointer(C_Loc(A),iA)
      ip_of_iWork_d_internal = ip_of_iWork(iA)
      Nullify(iA)
      End Function ip_of_iWork_d_internal
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SPSPCLS_GAS(NOCTPA,NOCTPB,IOCA,IOCB,NELFGP,MXPNGAS,NGAS,ISPSPCLS,ICLS,NCLS)
! Obtain mapping a-supergroup X b-supergroup => class
!
! =====
! Input
! =====
!
! NOCTPA : Number of alpha types
! NOCTPB : Number of beta types
!
! IOCA(IGAS,ISTR) occupation of AS IGAS for alpha string type ISTR
! IOCB(IGAS,ISTR) occupation of AS IGAS for beta  string type ISTR
!
! MXPNGAS : Largest allowed number of gas spaces
! NGAS    : Actual number of gas spaces
!
! ======
! Output
! ======
!
! ISPSPCLS(IATP,IBTP) => Class of this block of determinants
!                        =0 indicates unallowed(class less) combination

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NOCTPA, NOCTPB, MXPNGAS, IOCA(MXPNGAS,NOCTPA), IOCB(MXPNGAS,NOCTPB), NELFGP(*), NGAS, NCLS, &
                                 ICLS(NGAS,NCLS)
integer(kind=iwp), intent(out) :: ISPSPCLS(NOCTPA,NOCTPB)
integer(kind=iwp) :: IAMOKAY, IATP, IBTP, IEL, IGAS, IICLS, KCLS

#ifdef _DEBUGPRINT_
write(u6,*) ' ISPSPCLS_GAS entered'
write(u6,*) ' ===================='
write(u6,*)
write(u6,*) ' IOCA and IOCB'
call IWRTMA(IOCA,NGAS,NOCTPA,MXPNGAS,NGAS)
call IWRTMA(IOCB,NGAS,NOCTPB,MXPNGAS,NGAS)
write(u6,*)
write(u6,*) ' ICLS'
call IWRTMA(ICLS,NGAS,NCLS,NGAS,NCLS)
#endif

do IATP=1,NOCTPA
  do IBTP=1,NOCTPB
    IICLS = 0
    do KCLS=1,NCLS
      IAMOKAY = 1
      do IGAS=1,NGAS
        IEL = NELFGP(IOCA(IGAS,IATP))+NELFGP(IOCB(IGAS,IBTP))
        if (IEL /= ICLS(IGAS,KCLS)) IAMOKAY = 0
      end do
      if (IAMOKAY == 1) IICLS = KCLS
    end do
    ISPSPCLS(IATP,IBTP) = IICLS
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' Matrix giving classes for alpha-beta supergroups'
write(u6,*)
call IWRTMA(ISPSPCLS,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
#endif

end subroutine SPSPCLS_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GenCoo(Cart,nAtom,Coor,mAtom,Vctrs,Smmtrc,
     &                  nDim,iAnr,jAnr,iTabAI,Degen)
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Cart(3,nAtom), Coor(3,mAtom), Vctrs(3*mAtom,nDim), r(3),
     &       Degen(3*nAtom)
      Integer iAnr(nAtom), jAnr(mAtom), iTabAI(2,mAtom)
      Logical New, SmmTrc(3,nAtom)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Call RecPrt('GenCoo: Cart',' ',Cart,3,nAtom)
      Call RecPrt('GenCoo: Degen',' ',Degen,3,nAtom)
#endif
*
*-----Loop over list of symmetry unique centers
*
      iSt=1
      iDim = 0
      Do iAtom = 1, nAtom
         Fact = One/Sqrt(Degen((iAtom-1)*3 + 1))
         iEnd=iSt
         jDim=iDim
         call dcopy_(3,Cart(1,iAtom),1,Coor(1,iSt),1)
         iTabAI(1,iEnd) = iAtom
         iTabAI(2,iEnd) = iOper(0)
         jAnr(iEnd)=iAnr(iAtom)
         Do ix = 1, 3
            If (Smmtrc(ix,iAtom)) Then
               jDim=jDim+1
               call dcopy_(3*mAtom,[Zero],0,Vctrs(1,jDim),1)
               Vctrs((iEnd-1)*3+ix,jDim)=Fact
            End If
         End Do
*
*-----Loop over the operators of the point group
*
         iElem=1
         Do ig = 1, nIrrep-1
            r(1)=One
            If (iAnd(iOper(ig),1).ne.0) r(1)=-One
            r(2)=One
            If (iAnd(iOper(ig),2).ne.0) r(2)=-One
            r(3)=One
            If (iAnd(iOper(ig),4).ne.0) r(3)=-One
            x=r(1)*Cart(1,iAtom)
            y=r(2)*Cart(2,iAtom)
            z=r(3)*Cart(3,iAtom)
*
            New=.True.
            Do iGo = iSt, iEnd
               If (New .and. x.eq.Coor(1,iGo)
     &                 .and. y.eq.Coor(2,iGo)
     &                 .and. z.eq.Coor(3,iGo)) New=.False.
            End Do
            If (New) Then
               iElem=iElem+1
               iEnd = iEnd + 1
               Coor(1,iEnd)=x
               Coor(2,iEnd)=y
               Coor(3,iEnd)=z
               iTabAI(1,iEnd) = iAtom
               iTabAI(2,iEnd) = iOper(ig)
               jAnr(iEnd)=iAnr(iAtom)
               jDim=iDim
               Do ix = 1, 3
                  If (Smmtrc(ix,iAtom)) Then
                     jDim=jDim+1
                     Vctrs((iEnd-1)*3+ix,jDim) = r(ix)*Fact
                  End If
               End Do
            End If
         End Do      ! End loop over operators
*
         Do ix = 1, 3
            If (Smmtrc(ix,iAtom)) Then
               iDim=iDim+1
            End If
         End Do
         iSt = iEnd + 1
      End Do         ! End loop over centers
*
#ifdef _DEBUGPRINT_
      Call RecPrt(' In GenCoo: Coor',' ',Coor,3,mAtom)
      Call RecPrt(' In GenCoo: Vctrs',' ',Vctrs,3*mAtom,nDim)
      Write (6,*)
      Write (6,*) ' iTabAI'
      Write (6,*)
      Do iAtom = 1, mAtom
         Write (6,*) iTabAI(1,iAtom),iTabAI(2,iAtom)
      End Do
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 2006  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine DENS2T_RPT2(NLEV,NCONF,MXCI,CI1,CI2,SGM1,SGM2,G1,G2)
! Purpose: Compute the 1- and 2-electron density matrix
! arrays G1 and G2.

use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
use Symmetry_Info, only: Mul
use PrintLevel, only: DEBUG
use sguga, only: CIS, L2ACT, SGS
use caspt2_global, only: iPrGlb
use caspt2_module, only: iSCF, nActEl, nAshT, nG1, nG2, STSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NLEV, NCONF, MXCI
real(kind=wp), intent(in) :: CI1(NCONF), CI2(NCONF)
real(kind=wp), intent(out) :: SGM1(MXCI), SGM2(MXCI), G1(NLEV,NLEV), G2(NLEV,NLEV,NLEV,NLEV)
integer(kind=iwp) :: ID, ISSG1, ISSG2, IST, ISTU, ISU, ISV, ISVX, ISX, IT, ITASK, itu, IU, IV, ivx, IX, LT, LU, LV, LVX, LX, &
                     NSGM1, NSGM2, NTASKS
real(kind=wp) :: GTU, GTUVX
integer(kind=iwp), allocatable :: Task(:,:)
real(kind=wp), external :: DDOT_, DNRM2_

G1(:,:) = Zero
G2(:,:,:,:) = Zero

! For the special cases, there is no actual CI-routines involved:
! Special code for hi-spin case:
if (ISCF == 2) then
  do IT=1,NASHT
    G1(IT,IT) = One
    do IU=1,IT-1
      G2(IT,IT,IU,IU) = One
      G2(IU,IU,IT,IT) = One
      G2(IT,IU,IU,IT) = -One
      G2(IU,IT,IT,IU) = -One
    end do
  end do
  return
end if
! Special code for closed-shell:
if ((ISCF == 1) .and. (NACTEL > 0)) then
  do IT=1,NASHT
    G1(IT,IT) = Two
    G2(IT,IT,IT,IT) = Two
    do IU=1,IT-1
      G2(IT,IT,IU,IU) = Four
      G2(IU,IU,IT,IT) = Four
      G2(IT,IU,IU,IT) = -Two
      G2(IU,IT,IT,IU) = -Two
    end do
  end do
  return
end if

! For the general cases, we use actual CI routine calls, and
! have to take account of orbital order.
! We will use level inices LT,LU... in these calls, but produce
! the density matrices with usual active orbital indices.
! Translation tables L2ACT and LEVEL, in caspt2_module

!-SVC20100311: set up a task table with LT,LU
nTasks = nLev**2

call mma_allocate(Task,nTasks,2,Label='Task')

iTask = 0
do LT=1,nLev
  Task(iTask+1:iTask+nLev,1) = LT
  Task(iTask+1:iTask+nLev,2) = [(LU,LU=1,nLev)]
  iTask = iTask+nLev
end do
if (iTask /= nTasks) write(u6,*) 'ERROR nTasks'

call Init_Tsk(ID,nTasks)

!-SVC20100311: BEGIN SEPARATE TASK EXECUTION
do while (Rsv_Tsk(ID,iTask))

  ! Compute SGM1 = E_UT acting on CI, with T >= U,
  ! i.e., lowering operations. These are allowed in RAS.
  LT = Task(iTask,1)
  IST = SGS%ISM(LT)
  IT = L2ACT(LT)
  LU = Task(iTask,2)
  ISU = SGS%ISM(LU)
  IU = L2ACT(LU)
  ISTU = Mul(IST,ISU)
  ISSG1 = Mul(ISTU,STSYM)
  NSGM1 = CIS%NCSF(ISSG1)
  if (NSGM1 == 0) cycle
  call GETSGM2(LU,LT,STSYM,CI1,NCONF,SGM1,NSGM1)
  if (ISTU == STSYM) then
    GTU = DDOT_(NSGM1,CI2,1,SGM1,1)
    G1(IT,IU) = G1(IT,IU)+GTU
    !G1(IU,IT) = GTU
  end if
  LVX = 0
  do LV=1,NLEV!LT
    ISV = SGS%ISM(LV)
    IV = L2ACT(LV)
    do LX=1,NLEV!LV
      LVX = LVX+1
      ISX = SGS%ISM(LX)
      ISVX = Mul(ISV,ISX)
      !if (ISVX /= ISTU) cycle
      IX = L2ACT(LX)
      ISSG2 = Mul(ISVX,ISSG1)
      NSGM2 = CIS%NCSF(ISSG2)
      if (NSGM2 == 0) cycle
      if (ISSG2 == STSYM) then
        !if (LX == LT) then
        !  ! then actually T=U=V=X.
        !  GTUVX = DDOT_(NSGM,SGM1,1,SGM1,1)
        !else
        call GETSGM2(LX,LV,ISSG1,SGM1,NCONF,SGM2,NSGM2)
        GTUVX = DDOT_(NSGM2,CI2,1,SGM2,1)
        !end if

        !if (LV == LX) then
        !  GTUXV = GTUVX
        !else
        !  if (LVX == LTU) then
        !    GTUXV = DDOT_(NSGM,SGM1,1,SGM1,1)
        !  else
        !    call GETSGM2(LX,LV,STSYM,CI,MXCI,SGM2,NSGM)
        !    GTUXV = DDOT_(NSGM,SGM1,1,SGM2,1)
        !  end if
        !end if
        G2(IT,IU,IV,IX) = G2(IT,IU,IV,IX)+GTUVX
        !G2(IT,IU,IX,IV) = GTUXV
      end if
    end do
  end do

  call GETSGM2(LU,LT,STSYM,CI2,NCONF,SGM1,NSGM1)
  !if (ISTU == 1) then
  if (ISTU == STSYM) then
    GTU = DDOT_(NSGM1,CI1,1,SGM1,1)
    G1(IT,IU) = G1(IT,IU)+GTU
  end if
  LVX = 0
  do LV=1,NLEV
    ISV = SGS%ISM(LV)
    IV = L2ACT(LV)
    do LX=1,NLEV
      LVX = LVX+1
      !if (LVX > LTU) cycle
      ISX = SGS%ISM(LX)
      IX = L2ACT(LX)
      ISVX = Mul(ISV,ISX)
      !if (ISVX /= ISTU) cycle
      ISSG2 = Mul(ISVX,ISSG1)
      NSGM2 = CIS%NCSF(ISSG2)
      if (NSGM2 == 0) cycle
      if (ISSG2 == STSYM) then
        call GETSGM2(LX,LV,ISSG1,SGM1,NCONF,SGM2,NSGM2)
        GTUVX = DDOT_(NSGM2,CI1,1,SGM2,1)
        G2(IT,IU,IV,IX) = G2(IT,IU,IV,IX)+GTUVX
      end if
    end do
  end do

  !SVC: The master node now continues to only handle task scheduling,
  !     needed to achieve better load balancing. So it exits from the task
  !     list.  It has to do it here since each process gets at least one
  !     task.

end do

call Free_Tsk(ID)

call mma_deallocate(Task)

call GAdGOP(G1,NG1,'+')
call GAdGOP(G2,NG2,'+')

!write(u6,*) 'before'
!call sqprt(g2,nlev**2)
do LT=1,NLEV
  IT = L2ACT(LT)
  do LU=1,NLEV
    IU = L2ACT(LU)
    do LV=1,NLEV
      IV = L2ACT(LV)
      G2(IT,IV,IV,IU) = G2(IT,IV,IV,IU)-G1(IT,IU)
    end do
  end do
end do
do it=1,nlev
  do iu=1,nlev
    itu = it+nasht*(iu-1)
    do iv=1,nlev
      do ix=1,nlev
        ivx = iv+nasht*(ix-1)
        if (ivx > itu) g2(iv,ix,it,iu) = g2(it,iu,iv,ix)
      end do
    end do
  end do
end do
!-SVC20100311: serial part: add corrections to G2
!do LT=1,NLEV
!  IT = L2ACT(LT)
!  do LX=1,LT
!    IX = L2ACT(LX)
!    do LU=LX,LT
!      IU = L2ACT(LU)
!      G2(IT,IU,IU,IX) = G2(IT,IU,IU,IX)-G1(IT,IX)
!    end do
!  end do
!end do
!do LT=2,NLEV
!  IT = L2ACT(LT)
!  do LX=2,LT
!    IX = L2ACT(LX)
!    do LU=1,LX-1
!      IU = L2ACT(LU)
!      G2(IT,IU,IU,IX) = G2(IT,IU,IU,IX)-G1(IT,IX)
!    end do
!  end do
!end do
!LTU = 0
!do LT=1,NLEV
!  IT = L2ACT(LT)
!  do LU=1,LT
!    LTU = LTU+1
!    IU = L2ACT(LU)
!    LVX = 0
!    outer: do LV=1,LT
!      IV = L2ACT(LV)
!      do LX=1,LV
!        LVX = LVX+1
!        IX = L2ACT(LX)
!        if (LVX > LTU) exit outer
!        GTUVX = G2(IT,IU,IV,IX)
!        G2(IU,IT,IX,IV) = GTUVX
!        G2(IV,IX,IT,IU) = GTUVX
!        G2(IX,IV,IU,IT) = GTUVX
!        GTUXV = G2(IT,IU,IX,IV)
!        G2(IU,IT,IV,IX) = GTUXV
!        G2(IX,IV,IT,IU) = GTUXV
!        G2(IV,IX,IU,IT) = GTUXV
!      end do
!    end do outer
!  end do
!end do

if (iPrGlb >= DEBUG) then
  write(u6,'("DEBUG> ",A)') 'DENS2_RPT2: norms of the density matrices:'
  write(u6,'("DEBUG> ",A,1X,ES21.14)') 'G1:',DNRM2_(NG1,G1,1)
  write(u6,'("DEBUG> ",A,1X,ES21.14)') 'G2:',DNRM2_(NG2,G2,1)
end if

return

end subroutine DENS2T_RPT2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine GetDmatAO(DMO,DAO,nDMO,nDAO)
! Purpose: calculate the active 1RDM in AO basis given that in MO basis

use Index_Functions, only: iTri
use MCLR_Data, only: CMO, ipMat, nA, nDens
use input_mclr, only: nAsh, nBas, nIsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDMO, nDAO
real(kind=wp), intent(in) :: DMO(nDMO)
real(kind=wp), intent(out) :: DAO(nDAO)
integer(kind=iwp) :: i, iA, iAA, ij, iS, j, jA, jAA, nbas_tot, nLCMO
real(kind=wp), allocatable :: D1(:), NatCMO(:), OCCU(:)

!                                                                      *
!***********************************************************************
!                                                                      *
nLCMO = sum(nbas(1:nSym)**2)
nbas_tot = sum(nbas(1:nSym))

call mma_allocate(D1,nLCMO)
D1(:) = Zero
! First, converting DMO into D1
! similar to computing D_K from G1q, as done in out_pt2.f
!********************************************************
do iS=1,nSym
  do iA=1,nash(is)
    do jA=1,nash(is)
      i = iA+nish(is)
      j = jA+nish(is)
      iAA = iA+na(is)
      jAA = jA+na(is)
      D1(ipmat(is,is)+i-1+(j-1)*nbas(is)) = DMO(iTri(iAA,jAA))
    end do
  end do
end do

!********************************************************
call mma_allocate(OCCU,nbas_tot,Label='OCCU')
call mma_allocate(NatCMO,nDens,Label='NatCMO')

call NatOrb_MCLR(D1,CMO,NatCMO,OCCU)
call dmat_MCLR(NatCMO,OCCU,DAO)
ij = 0
do iS=1,nSym
  do i=1,nbas(is)
    DAO(1:i-1) = Half*DAO(1:i-1)
    ij = ij+i+1
  end do
end do
call mma_deallocate(D1)
call mma_deallocate(OCCU)
call mma_deallocate(NatCMO)

end subroutine GetDmatAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkTau_chcc (T2,T11,T12,dima,dimb,no,f1,f2)
c
c        this routine do:
c        T2(a',b',i,j) = f1 . T2(a',b',i,j) + f2 . T11(a',i) . T12(b',j)
c
c        N.B. Kvajt odflaknute
c
        implicit none
        integer dima,dimb,no
        real*8 f1,f2
        real*8 T2(1:dima,1:dimb,1:no,1:no)
        real*8 T11(1:dima,1:no)
        real*8 T12(1:dimb,1:no)
c
c        help variables
        integer i,j,a,b
        real*8 c
c
c
        do j=1,no
          do i=1,no
            do b=1,dimb
              c=t12(b,j)*f2
              do a=1,dima
                t2(a,b,i,j)=f1*t2(a,b,i,j)+c*t11(a,i)
              end do
            end do
          end do
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GTSPGP(IEL,ISPGP,IWAY)
*
*
* Relation between number of electrons in AS1, AS2 ... and
* supergoup number
*
* IWAY = 1 :
* Get ISPGP : Supergroup of strings
*             with IEL(*)  electrons in each AS
* IWAY = 2 :
* GET IEL(*)  : Number of electrons in each AS for supergroup ISPGP
*
*
* Jeppe Olsen, Another lonely night in Lund
*               GAS version July 1995
*
      IMPLICIT REAL*8 (A-H,O-Z)
*. Generel input
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "strbas.fh"
#include "stinf.fh"
#include "cgas.fh"
#include "gasstr.fh"
*. input(IWAY = 2 ), output (IWAY = 1 )
      INTEGER IEL(*)
*
      IF(IWAY.EQ.1) THEN
*. Occupation => Number
        ISPGP = -1
        DO JSPGP = 1, NTSPGP
          IF(ISPGP.EQ.-1) THEN
            IEQUAL = 1
            DO IGAS = 1, NGAS
              IF(NELFSPGP(IGAS,JSPGP).NE.IEL(IGAS))  IEQUAL= 0
            END DO
            IF(IEQUAL.EQ.1) ISPGP = JSPGP
          END IF
        END DO
      ELSE IF (IWAY .EQ. 2 ) THEN
*. Number => Occupation
        DO IGAS = 1, NGAS
         IEL(IGAS) = NELFSPGP(IGAS,ISPGP)
        END DO
      END IF
*
      NTEST  = 000
      IF(NTEST .GE. 100 ) THEN
        WRITE(6,*) ' Output from GTSPGP '
        WRITE(6,*)
     &   ' IWAY ISPGP IEL ', IWAY,ISPGP,(IEL(IGAS),IGAS = 1, NGAS)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
*               2004,2005, Giovanni Ghigo                              *
************************************************************************
*  Mem_Est
*
*> @brief
*>   The routine makes an estimation of the optimal memory allocation and defines the
*>   maximum number of Cholesky vectors to transform both for the main (\p nVec) and
*>   the inner (\p nFVec) batch procedures
*> @author Giovanni Ghigo
*>
*> @param[in]  iSymL Symmetry of the Cholesky vector
*> @param[out] nVec  Number of Cholesky vectors to transform in the batch procedure
*> @param[out] nFVec Number of Cholesky vectors to transform in the inner batch procedure
************************************************************************
      Subroutine Mem_Est(iSymL,nVec,nFVec)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Torino University, Italy                                   *
*           January-February, July 2005                                *
*----------------------------------------------------------------------*
* Routine for the estimation of the memory usage and the number (nVec) *
* of Cholesky Vectors transformable.                                   *
* The routine also define (calling Def_TCVx) which TCVx create.        *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Character*16 Frmt1,Frmt3

      MulD2h(i,j) = iEor(i-1,j-1)+1

      nVec  = 0 ! Nr. of transformable vectors for batch.
      nFVec = 0 ! Nr. of full vectors for inner transformation batch

*   Memory for Reading (will change when reading reduced set)
      LenCHFV = 0     ! Mem for Full Vectors (p.v. = per vector)
*   Memory for Transformation
      LenTCVx   = 0   ! Mem for TCVx (p.v.)
      LenTmpTra = 0   ! Mem for First-half Transformation
*   Memory for Generation
      MaxInt   = 0    ! Mem for integrals
      MaxSlice = 0    ! Mem for Lx (p.v.)

* --- Memory for Transformation
      Nij = 0  ! A
      Nji = 0  ! A"
      Ntj = 0  ! B
      Nui = 0  ! B"
      Naj = 0  ! C
      Nbi = 0  ! C"
      Ntu = 0  ! D
      Nut = 0  ! D"
      Nau = 0  ! E
      Nbt = 0  ! E"
      Nab = 0  ! F
      Njt = 0  ! G
      Niu = 0  ! G"

      Do iSym=1,nSym
       If(nBas(iSym).GT.0) then
        Do jSym=1,iSym
         If(nBas(jSym).GT.0 .and. MulD2h(iSym,jSym).EQ.iSymL) then

          Len_YAj = 0  ! iSym=jSym: A, B, C
          Len_YAu = 0  ! iSym=jSym: D, E
          Len_YAb = 0  ! iSym=jSym: F
          Len_XAj = 0  ! iSym=/=jSym: A/A", B, C
          Len_XAu = 0  ! iSym=/=jSym: D/D", E
          Len_XAb = 0  ! iSym=/=jSym: F
          Len_XBi = 0  ! iSym=/=jSym: B",C"
          Len_XBt = 0  ! iSym=/=jSym: E"
          Len_ABSq = 0 ! Squared CHFV

          Call Def_TCVx(iSym,jSym)

          If (iSym.EQ.jSym) then

* TCV-A :
           If (TCVXist(1,iSym,jSym)) Then
             Len_YAj = nBas(iSym) * nIsh(jSym)
             Nij = Nij + nIsh(iSym) * nIsh(jSym)
           EndIf
* TCV-B :
           If (TCVXist(2,iSym,jSym)) Then
             Len_YAj = nBas(iSym) * nIsh(jSym)
             Ntj = Ntj + ( nAsh(iSym) * nIsh(jSym) )
* TCV-G :
             Njt = Njt + ( nIsh(jSym) * nAsh(iSym) )
           EndIf
* TCV-C :
           If (TCVXist(3,iSym,jSym)) Then
             Len_YAj = nBas(iSym) * nIsh(jSym)
             Naj = Naj + nSsh(iSym) * nIsh(jSym)
           EndIf
* TCV-D :
           If (TCVXist(4,iSym,jSym)) Then
             Len_YAu = nBas(iSym) * nAsh(jSym)
             Ntu = Ntu + nAsh(iSym) * nAsh(jSym)
           EndIf
* TCV-E :
           If (TCVXist(5,iSym,jSym)) Then
             Len_YAu = nBas(iSym) * nAsh(jSym)
             Nau = Nau + nSsh(iSym) * nAsh(jSym)
           EndIf
* TCV-F :
           If (TCVXist(6,iSym,jSym)) Then
             Len_YAb = nBas(iSym) * nSsh(jSym)
             Nab = Nab + nSsh(iSym) * nssh(jSym)
           EndIf

           LenCHFV = LenCHFV + ( nBas(iSym) * ( nBas(jSym) + 1 ) / 2 )
           Len_ABSq = nBas(iSym) * nBas(jSym)
           LenTmpTra = Max( LenTmpTra ,
     &                      ( Len_ABSq + Len_YAj + Len_YAu + Len_YAb ) )

          else

* TCV-A :
           If (TCVXist(1,iSym,jSym)) Then
             Len_XAj = nBas(iSym) * nIsh(jSym)
             Nij = Nij + ( nIsh(iSym) * nIsh(jSym) )
             Nji = Nji + ( nIsh(jSym) * nIsh(iSym) )
           EndIf
* TCV-B :
           If (TCVXist(2,iSym,jSym)) Then
             Len_XAj = nBas(iSym) * nIsh(jSym)
             Ntj = Ntj + ( nAsh(iSym) * nIsh(jSym) )
* TCV-G :
             Njt = Njt + ( nIsh(jSym) * nAsh(iSym) )
           EndIf
           If (TCVXist(2,jSym,iSym)) Then
             Len_XBi = nBas(jSym) * nIsh(iSym)
             Nui = Nui + ( nAsh(jSym) * nIsh(iSym) )
* TCV-G :
             Niu = Niu + ( nIsh(iSym) * nAsh(jSym) )
           EndIf
* TCV-C :
           If (TCVXist(3,iSym,jSym)) Then
             Len_XAj = nBas(iSym) * nIsh(jSym)
             Naj = Naj + nSsh(iSym) * nIsh(jSym)
           EndIf
           If (TCVXist(3,jSym,iSym)) Then
             Len_XBi = nBas(jSym) * nIsh(iSym)
             Nbi = Nbi + nSsh(jSym) * nIsh(iSym)
           EndIf
* TCV-D :
           If (TCVXist(4,iSym,jSym)) Then
             Len_XAu = nBas(iSym) * nAsh(jSym)
             Ntu = Ntu + ( nAsh(iSym) * nAsh(jSym) )
             Nut = Nut + ( nAsh(jSym) * nAsh(iSym) )
           EndIf
* TCV-E :
           If (TCVXist(5,iSym,jSym)) Then
             Len_XAu = nBas(iSym) * nAsh(jSym)
             Nau = Nau + nSsh(iSym) * nAsh(jSym)
           EndIf
           If (TCVXist(5,jSym,iSym)) Then
             Len_XBt = nBas(jSym) * nAsh(iSym)
             Nbt = Nbt + nSsh(jSym) * nAsh(iSym)
           EndIf
* TCV-F :
           If (TCVXist(6,iSym,jSym)) Then
             Len_XAb = nBas(iSym) * nSsh(jSym)
             Nab = Nab + nSsh(iSym) * nSsh(jSym)
           EndIf

           LenCHFV = LenCHFV + ( nBas(iSym) * nBas(jSym) )
           LenTmpTra = Max ( LenTmpTra ,
     &             ( Len_XAj + Len_XAu + Len_XAb + Len_XBi + Len_XBt ) )

          EndIf

         EndIf
        EndDo ! jSym
       EndIf
      EndDo ! iSym

      LenTCVx = Nij+Nji + Ntj+Nui + Naj+Nbi + Ntu+Nut + Nau+Nbt +
     &                                                     Nab + Niu+Njt

* --- Memory for Generation
      Do iSymI = 1, nSym
       Do iSymJ = 1, iSymI
        Do iSymA = 1, nSym
         Do iSymB = 1, iSymA
          iSymAI = MulD2h(iSymA,iSymI)
          iSymBJ = MulD2h(iSymB,iSymJ)
          Call LenInt(iSymI,iSymJ,iSymA,iSymB,nN_IJ,nN_AB,nN_Ex1,nN_Ex2)
          If (iSymAI.EQ.iSymL.and.iSymBJ.EQ.iSymL. and.
     &                                        nN_IJ*nN_AB.GT.0) then
            MaxInt    = Max(MaxInt, Max(nN_AB, Max(nN_Ex1, 2*nN_Ex2) ) )
            MaxSlice  = Max(MaxSlice, nOrb(iSymA)+nOrb(iSymB) )
          EndIf
         EndDo
        EndDo
       EndDo
      EndDo

      Call GetMem('MaxMem','MAX','REAL',KDUM,MEMX)
      MemFree0 = Max( MEMX - MEMX/10 , 0 )

      MemPerVec2 = LenTCVx + MaxSlice
      MemTmp2 = 2 * MaxInt

      MemMin = LenCHFV + LenTmpTra + LenTCVx + MaxSlice + 2 * MaxInt
      MemFree = MemFree0 - MemMin

      nVec = Min( ( MemFree / MemPerVec2 + 1 ) , NumCho(iSymL) )
      MemFree = MemFree - (nVec-1) * MemPerVec2
      nFVec = Min( ( MemFree / LenCHFV + 1 ) , NumCho(iSymL) )
      MemAlloc = MemMin + (nVec-1) * MemPerVec2 + (nFVec-1) * LenCHFV

      If (.NOT.IfTest.and.nVec.EQ.NumCho(iSymL).and.nFVec.GT.0) Return

      MaxNum = Max(MemFree0,MemAlloc)
      MaxSize = Max(9,Int(Log10(Dble(MaxNum)))+1)
      Write(Frmt1,'(I16)') MaxSize
      Frmt1='(A,1X,I'//Trim(AdjustL(Frmt1))//')'
      Write(Frmt3,'(I16)') MaxSize-5
      Frmt3='(A,1X,I'//Trim(AdjustL(Frmt3))//',A)'

      Write(6,*)
      Write(6,'(20A3)')('---',I=1,20)
      Write(6,05)' MEM for TRANSF/GENER of VECTORS in Sym:',iSymL
      Write(6,*)
      Write(6,Frmt1)' Mem (p.v.) for CHFV            :',LenCHFV
      Write(6,Frmt1)' Tmp Mem for transformation     :',LenTmpTra
      Write(6,Frmt1)' Mem (p.v.) for TCVx            :',LenTCVx
      Write(6,Frmt1)' Max Tmp Mem (p.v.) for generat.:',MaxSlice
      Write(6,Frmt1)' Max Mem for Integrals (twice)  :',2*MaxInt
      Write(6,Frmt1)
      Write(6,Frmt1)' TOTAL AVAILABLE MEMORY         :',MemFree0
      Write(6,Frmt1)' Minimal Memory required        :',MemMin
      Write(6,Frmt1)' Memory Required by generation  :',
     & (nVec-1)*MemPerVec2
      Write(6,Frmt1)' Memory Available for transform.:',MemFree
      Write(6,Frmt1)' Memory Required by transform.  :',
     & (nFVec-1)*LenCHFV
      Write(6,Frmt1)' TOTAL ALLOCATED MEMORY         :',MemAlloc
      Write(6,Frmt1)' Unemployed memory              :',
     & MemFree0-MemAlloc
      Write(6,*)
      Write(6,20)' Max nr. of Transformed vectors  :',nVec
      Write(6,20)' Max nr. of vectors in sub-batch :',nFVec
      Write(6,20)' Total Number of Cholesky vectors:',NumCho(iSymL)
      Write(6,*)
      Write(6,*) 'ESTIMATED MEMORY REQUIREMENTS'
      Write(6,Frmt3)'  Minimum:',2+MemMin / 119000,' MB'
      Write(6,Frmt3)'  Normal :',2+
     & (MemMin+MemPerVec2 * (NumCho(iSymL)-1) ) / 119000,' MB'
      Write(6,Frmt3)'  Maximum:',2+
     & (MemMin+(MemPerVec2+LenCHFV) * (NumCho(iSymL)-1)) / 119000,' MB'
      Write(6,'(20A3)')('---',I=1,20)
      Write(6,*)
      Call XFlush(6)
      If ( nVec.LT.NumCho(iSymL) ) then
        Write(6,*)' Batch procedure used. Increase memory if possible!'
        Write(6,*)
        Write(6,'(20A3)')('---',I=1,20)
        Call XFlush(6)
      EndIf
05    Format(A,1X,I1)
20    Format(A,1X,I6)

      Return
      End
************************************************************************
*  Def_TCVx
*
*> @brief
*>   The routine defines which Transformed Cholesky (TCVx) to generate
*>   setting ``.True.`` the logical matrix \c TCVXist(iType,iSym,jSym)
*> @author Giovanni Ghigo
*>
*> @details
*> - \c iType = ``1``: TCVA
*> - \c iType = ``2``: TCVB
*> - \c iType = ``3``: TCVC
*> - \c iType = ``4``: TCVD
*> - \c iType = ``5``: TCVE
*> - \c iType = ``6``: TCVF
*> - \c iType = ``7``: TCVG
*>
*> @param[in] iSym Symmetry(``i``) of the Cholesky Full Vector
*> @param[in] jSym Symmetry(``j``) of the Cholesky Full Vector
************************************************************************
      Subroutine Def_TCVx(iSym,jSym)
************************************************************************
* Author  :  Giovanni Ghigo                                            *
*            Lund University, Sweden                                   *
* Written :  October 2004                                              *
* Modified:  January 2005                                              *
*----------------------------------------------------------------------*
* Define which Transformed Cholesky Full Vectors (TCVx) to generate.   *
* TCVXist(iType,iSym,jSym) is .True. if the TCVx must be generated.    *
* iType(x):  1=A, 2=B, 3=C, 4=D, 5=E, 6=F, 7=G                         *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "cho_tra.fh"

      If(nIsh(jSym).GT.0) then
        If(nIsh(iSym).GT.0 .and. DoTCVA) then
          TCVXist(1,iSym,jSym)=.True.
          TCVXist(1,jSym,iSym)=.True.  ! Aji = T(Aij) !
        EndIf
        If(nAsh(iSym).GT.0 .and. DoTCVA) then
          TCVXist(2,iSym,jSym)=.True.
          TCVXist(7,jSym,iSym)=.True.
        EndIf
        If(nSsh(iSym).GT.0) then
          TCVXist(3,iSym,jSym)=.True.
        EndIf
      EndIf

      If(nAsh(jSym).GT.0 .and. DoTCVA) then
        If(nIsh(iSym).GT.0 .and. iSym.NE.jSym) then
          TCVXist(2,jSym,iSym)=.True.
          TCVXist(7,iSym,jSym)=.True.
        EndIf
        If(nAsh(iSym).GT.0) then
          TCVXist(4,iSym,jSym)=.True.
          TCVXist(4,jSym,iSym)=.True.  ! Dji = T(Dij) !
        EndIf
        If(nSsh(iSym).GT.0) then
          TCVXist(5,iSym,jSym)=.True.
        EndIf
      EndIf

      If(nSsh(jSym).GT.0 .and. iSym.NE.jSym) then
        If(nIsh(iSym).GT.0) then
          TCVXist(3,jSym,iSym)=.True.
        EndIf
        If(nAsh(iSym).GT.0 .and. DoTCVA) then
          TCVXist(5,jSym,iSym)=.True.
        EndIf
      EndIf

      If(nSsh(jSym).GT.0 .and. nSsh(iSym).GT.0 .and. DoTCVA) then
        TCVXist(6,iSym,jSym)=.True.
      EndIf

      Return
      End

      Subroutine LenInt(iSymI,iSymJ,iSymA,iSymB,nProdIJ,
     &                                          nProdAB,nProdE1,nProdE2)
************************************************************************
* Author  :  Giovanni Ghigo                                            *
*            Lund University, Sweden                                   *
*----------------------------------------------------------------------*
* Return the Length of Coulomb (nProdAB), Exchanges (nProdE1 and       *
* nProdE2) matrices for each i,j and the length (nProdIJ) of the i,j   *
* matrix for each Symmetry Block (iSymI,iSymJ,iSymA,iSymB)             *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "cho_tra.fh"
      nProdIJ=0
      nProdAB=0
      nProdE1=0
      nProdE2=0
      nOccI = nOsh(iSymI)
      nOccJ = nOsh(iSymJ)
      nOrbA = nOrb(iSymA)
      nOrbB = nOrb(iSymB)
      nOrbA2= nOrb(iSymB)
      nOrbB2= nOrb(iSymA)
      nExtA = nSsh(iSymA)
      nExtB = nSsh(iSymB)
      nExtA2= nSsh(iSymB)
      nExtB2= nSsh(iSymA)
      If(iSymI.EQ.iSymJ) then
        nProdIJ=nOccI*(nOccJ+1)/2
      else
        nProdIJ=nOccI*nOccJ
      EndIf
      If(iSymA.EQ.iSymB) then
        nProdAB=nOrbA*(nOrbB+1)/2
      else
        If(iSymA.GT.iSymB) then
          nProdAB=nOrbA*nOrbB
        else
          nProdAB=0
        EndIf
      EndIf
      If(iSymA.GE.iSymB) then
        If(DoTCVA) then
          nProdE1=nOrbA*nOrbB
        else
          nProdE1=nExtA*nExtB
        EndIf
        nProdE2=0
      else
        nProdE1=0
        If(DoTCVA) then
          nProdE2=nOrbA*nOrbB
        else
          nProdE2=nExtA*nExtB
        EndIf
      EndIf
      Return
      End

      Subroutine Def_SubBlockE(iSymA,iSymB)
************************************************************************
* Author  :  Giovanni Ghigo                                            *
*            Lund University, Sweden                                   *
*----------------------------------------------------------------------*
* Define the SubBlocks to calculate in the Exchange matrix.            *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "cho_tra.fh"
      Do i=1,3
        Do j=1,3
          SubBlocks(i,j)=.False.
        EndDo
      EndDo
      If (DoTCVA .and. nIsh(iSymA).GT.0) then
        If (nIsh(iSymB).GT.0) SubBlocks(1,1)=.True.
        If (nAsh(iSymB).GT.0) SubBlocks(1,2)=.True.
        If (nSsh(iSymB).GT.0) SubBlocks(1,3)=.True.
      EndIf
      If (DoTCVA .and. nAsh(iSymA).GT.0) then
        If (nIsh(iSymB).GT.0) SubBlocks(2,1)=.True.
        If (nAsh(iSymB).GT.0) SubBlocks(2,2)=.True.
        If (nSsh(iSymB).GT.0) SubBlocks(2,3)=.True.
      EndIf
      If (DoTCVA .and. nSsh(iSymA).GT.0) then
        If (nIsh(iSymB).GT.0) SubBlocks(3,1)=.True.
        If (nAsh(iSymB).GT.0) SubBlocks(3,2)=.True.
      EndIf
      If ((nSsh(iSymA)*nSsh(iSymB)).GT.0) SubBlocks(3,3)=.True.
      Return
      End

      Subroutine Local_Triang(nRow,A)
C This routine is a modification of the Per-Ake's Triang routine
C found in src/caspt2/triang.f
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension A(nRow**2)
c Convert a square matrix to triangular in-place.
      iFrom=1+nRow
      iTo=2
      Do i=2,nRow
        Call dCopy_(i,A(iFrom),1,A(iTo),1)
        iFrom=iFrom+nRow
        iTo=iTo+i
      EndDo
      Return
      End

      Subroutine PrintSquareMat(nRow,A)
* Prints a square matrix A(nRow,nRow)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension A(nRow**2)
      If (nRow.GT.8) Return
      iCount=0
      Do i=1,nRow
        If(nRow.EQ.1) Write(6,'(1F10.6)') (A(iCount+k),k=1,nRow)
        If(nRow.EQ.2) Write(6,'(2F10.6)') (A(iCount+k),k=1,nRow)
        If(nRow.EQ.3) Write(6,'(3F10.6)') (A(iCount+k),k=1,nRow)
        If(nRow.EQ.4) Write(6,'(4F10.6)') (A(iCount+k),k=1,nRow)
        If(nRow.EQ.5) Write(6,'(5F10.6)') (A(iCount+k),k=1,nRow)
        If(nRow.EQ.6) Write(6,'(6F10.6)') (A(iCount+k),k=1,nRow)
        If(nRow.EQ.7) Write(6,'(7F10.6)') (A(iCount+k),k=1,nRow)
        If(nRow.EQ.8) Write(6,'(8F10.6)') (A(iCount+k),k=1,nRow)
        iCount=iCount+nRow
      EndDo
      Return
      End

      Subroutine PrintDiagMat(nRow,A)
* Prints a diagonal matrix A(nRow,nRow)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension A(nRow*(nRow+1))
      If (nRow.GT.8) Return
      iCount=0
      Do i=1,nRow
        Write(6,'(8F10.6)') (A(iCount+k),k=1,i)
        iCount=iCount+i
      EndDo
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine MDIAGC(JSY,C,S,W,THET,ENP,NII)

use cpf_global, only: IAD25S, ILIM, IRC, LN, LSYM, Lu_25, NSM, NSYS, NVIRT
use guga_util_global, only: COP, nCOP
use Symmetry_Info, only: Mul
use Constants, only: One, Half, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: JSY(*), NII
real(kind=wp), intent(in) :: C(*), THET(NII,NII), ENP(*)
real(kind=wp), intent(inout) :: S(*), W(*)
integer(kind=iwp) :: IADD25, IIC, IND, INDA, IRL, NA, NA1, NA2, NB, NB1, NB2, NSA, NSS
real(kind=wp) :: ENPQ, FACS, FACW
integer(kind=iwp), external :: JSUNP

IADD25 = IAD25S
call dDAFILE(Lu_25,2,COP,nCOP,IADD25)
IIC = 0
IND = 0
IRL = IRC(ILIM)
do INDA=1,IRL
  NSS = MUL(JSUNP(JSY,INDA),LSYM)
  ENPQ = (One-THET(INDA,INDA)*Half)*(ENP(INDA)+ENP(INDA)-One)+THET(INDA,INDA)*Half
  FACS = sqrt(ENP(INDA))*sqrt(ENP(INDA))/ENPQ
  FACW = (FACS*(Two-THET(INDA,INDA))/ENPQ)*ENP(INDA)-FACS
  if (INDA <= IRC(1)) then
    IIC = IIC+1
    IND = IND+1
    S(IND) = S(IND)+FACS*COP(IIC)*C(IND)
    W(IND) = W(IND)+FACW*COP(IIC)*C(IND)
    if (IIC >= nCOP) then
      call dDAFILE(Lu_25,2,COP,nCOP,IADD25)
      IIC = 0
    end if
  else if (INDA <= IRC(2)) then
    NA1 = NSYS(NSS)+1
    NA2 = NSYS(NSS+1)
    do NA=NA1,NA2
      IIC = IIC+1
      IND = IND+1
      S(IND) = S(IND)+FACS*COP(IIC)*C(IND)
      W(IND) = W(IND)+FACW*COP(IIC)*C(IND)
      if (IIC >= nCOP) then
        call dDAFILE(Lu_25,2,COP,nCOP,IADD25)
        IIC = 0
      end if
    end do
  else
    do NA=1,NVIRT
      NSA = MUL(NSS,NSM(LN+NA))
      NB1 = NSYS(NSA)+1
      NB2 = NSYS(NSA+1)
      if (NB2 > NA) NB2 = NA
      do NB=NB1,NB2
        IIC = IIC+1
        IND = IND+1
        S(IND) = S(IND)+FACS*COP(IIC)*C(IND)
        W(IND) = W(IND)+FACW*COP(IIC)*C(IND)
        if (IIC >= nCOP) then
          call dDAFILE(Lu_25,2,COP,nCOP,IADD25)
          IIC = 0
        end if
      end do
    end do
  end if
end do

return

end subroutine MDIAGC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  OrbRot2
*
*> @brief
*>   Rotate orbitals of the solvent
*> @author A. Ohrn
*>
*> @details
*> Given a rotation matrix \f$ R \f$ it is easy to rotate the p-orbitals since
*> they behave just like the three axes. The d-orbitals are more
*> intricate.
*>
*> To obtain a representation
*> of the d-orbital \f$ \mathrm{d}_{xy} \f$ we perform the outer product \f$ \mathrm{d}_x \mathrm{d}_y + \mathrm{d}_y \mathrm{d}_x \f$,
*> which generates a two-dimensional matrix. Now rotate each px and py
*> and perform this multiplication. We obtain a symmetric matrix from
*> whose elements we can compute how the \f$ \mathrm{d}_{xy} \f$ transforms when
*> rotated. The same is done for the other d-orbitals and we can
*> construct a transformation matrix, which we apply to the MO-coeff.
*> Other ways to look at it are available, but the present one can be
*> seen as a generation of table 3 in \cite Iva1996-JPC-100-6342.
*> The present method is efficient
*> with no trigonometric functions and ample use of BLAS_UTIL.
*>
*> @note
*> ::Qfread as well as ::transrot must precede.
*>
*> @param[in] Rot  The rotation matrix
*> @param[in] Cmo  The MO-coefficients
*> @param[in] iQ   The angular type of the \f$ i \f$ -th basis (observe, not the \f$ i \f$ -th basis function, see givemeinfo.f)
*> @param[in] iOrb Number of orbitals
*> @param[in] lMax Number of bases (not basis functions), see qfread.f
*> @param[in] nCnC Number of contracted basis functions of same type as the \f$ i \f$ -th basis. For example 7s4p will have vector ``7,7,7,7,7,7,7,4,4,4,4``.
************************************************************************
      Subroutine OrbRot2(Rot,Cmo,iQ,iOrb,lMax,nCnC)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "warnings.fh"

      Dimension Rot(3,3),Cmo(MxBasC,MxOrb_C),iQ(MxBasC),nCnC(MxBasC)

      Dimension Px(3),Py(3),Pz(3),Resx(3),Resy(3),Resz(3)
      Dimension Dzz(6),Dxy(6),Dxz(6),Dyz(6),Dxmin(6),Dzer(6)
     &,Dkopia(6),Unit(6)

      Dimension PBlock(3,3),DBlock(5,5)

      Logical NewIq

      Data Px/1.0d0,0.0d0,0.0d0/
      Data Py/0.0d0,1.0d0,0.0d0/
      Data Pz/0.0d0,0.0d0,1.0d0/
      Data Dzer/0.0d0,0.0d0,0.0d0,0.0d0,0.0d0,0.0d0/
      Data Unit/-1.0d0,0.0d0,0.0d0,-1.0d0,0.0d0,-1.0d0/

*
*-- Dgemv multiply the matrix Rot on the vector Px. For details about
*   various parameter see the source code for the routine; it is very
*   detailed. Here we get the p-orbitals which also are used to obtain
*   the transformation of the other orbitals.
*
      Call dGeMV_('N',ithree,ithree,ONE,Rot,ithree
     &,Px,ione,ZERO,Resx,ione)
      Call dGeMV_('N',ithree,ithree,ONE,Rot,ithree
     &,Py,ione,ZERO,Resy,ione)
      Call dGeMV_('N',ithree,ithree,ONE,Rot,ithree
     &,Pz,ione,ZERO,Resz,ione)

*
*-- Construct the p-block. Easy since they are linear polynomials in
*   the cartesian R-matrix.
*
      PBlock(1,1)=Resx(1)
      PBlock(2,1)=Resx(2)
      PBlock(3,1)=Resx(3)
      PBlock(1,2)=Resy(1)
      PBlock(2,2)=Resy(2)
      PBlock(3,2)=Resy(3)
      PBlock(1,3)=Resz(1)
      PBlock(2,3)=Resz(2)
      PBlock(3,3)=Resz(3)

*
*-- Generation of quadratic polynomial of R-matrix elements for d_xy.
*
      call dcopy_(isix,Dzer,ione,Dkopia,ione)
      Call Dspr2('L',ithree,ONE,Resx,ione,Resy,ione,Dzer)
      call dcopy_(isix,Dzer,ione,Dxy,ione)
      call dcopy_(isix,Dkopia,ione,Dzer,ione)

*
*-- Generation of quadratic polynomial of R-matrix elements for d_xz.
*
      call dcopy_(isix,Dzer,ione,Dkopia,ione)
      Call Dspr2('L',ithree,ONE,Resx,ione,Resz,ione,Dzer)
      call dcopy_(isix,Dzer,ione,Dxz,ione)
      call dcopy_(isix,Dkopia,ione,Dzer,ione)

*
*-- Generation of quadratic polynomial of R-matrix elements for d_yz.
*
      call dcopy_(isix,Dzer,ione,Dkopia,ione)
      Call Dspr2('L',ithree,ONE,Resy,ione,Resz,ione,Dzer)
      call dcopy_(isix,Dzer,ione,Dyz,ione)
      call dcopy_(isix,Dkopia,ione,Dzer,ione)

*
*-- Generation of quadratic polynomial of R-matrix elements for d_xx-yy.
*
      call dcopy_(isix,Dzer,ione,Dkopia,ione)
      Call Dspr('L',ithree,-1.0d0*ONE,Resy,ione,Dzer)
      call dcopy_(isix,Dzer,ione,Dxmin,ione)
      call dcopy_(isix,Dkopia,ione,Dzer,ione)
      Call Dspr('L',ithree,ONE,Resx,ione,Dxmin)
      call dcopy_(isix,Dkopia,ione,Dzer,ione)

*
*-- Generation of quadratic polynomial of R-matrix elements for d_3zz-1.
*
      call dcopy_(isix,Unit,ione,Dkopia,ione)
      Call Dspr('L',ithree,THREE,Resz,ione,Unit)
      call dcopy_(isix,Unit,ione,Dzz,ione)
      call dcopy_(isix,Dkopia,ione,Unit,ione)

*
*-- Construct the d-block. This requires knowledge of how Molcas
*   handles it d-orbitals, especially its normalization, which is the
*   reason for the constants r1,r2,r3,r4.
*
      r1=1.0d0
      r2=sqrt(dble(3))
      r3=1.0d0
      r4=1.0d0/sqrt(dble(3))
      DBlock(1,1)=r1*Dxy(2) !dxy-->dxy
      DBlock(2,1)=r1*Dxy(5) !dxy-->dyz
      DBlock(3,1)=(r1/r4)*0.5*Dxy(6) !dxy-->d3zz-1
      DBlock(4,1)=r1*Dxy(3) !dxy-->dxz
      DBlock(5,1)=(r1/r3)*(Dxy(1)+0.5*Dxy(6)) !dxy-->dxx-yy
      DBlock(1,2)=r1*Dyz(2) !dyz-->dxy
      DBlock(2,2)=r1*Dyz(5) !dyz-->dyz
      DBlock(3,2)=(r1/r4)*0.5*Dyz(6) !dyz-->d3zz-1
      DBlock(4,2)=r1*Dyz(3) !dyz-->dxz
      DBlock(5,2)=(r1/r3)*(Dyz(1)+0.5*Dyz(6)) !dyz-->dxx-yy
      DBlock(1,3)=r4*Dzz(2) !d3zz-->dxy
      DBlock(2,3)=r4*Dzz(5) !d3zz-->dyz
      DBlock(3,3)=r1*0.5*Dzz(6) !d3zz-->d3zz
      DBlock(4,3)=r4*Dzz(3) !d3zz-->dxz
      DBlock(5,3)=(r1/r2)*(Dzz(1)+0.5*Dzz(6)) !d3zz-->dxx-yy
      DBlock(1,4)=r1*Dxz(2) !dxz-->dxy
      DBlock(2,4)=r1*Dxz(5) !dxz-->dyz
      DBlock(3,4)=(r1/r4)*0.5*Dxz(6) !dxz-->d3zz-1
      DBlock(4,4)=r1*Dxz(3) !dxz-->dxz
      DBlock(5,4)=(r1/r3)*(Dxz(1)+0.5*Dxz(6)) !dxz-->dxx-yy
      DBlock(1,5)=r3*Dxmin(2) !dxx-yy-->dxy
      DBlock(2,5)=r3*Dxmin(5) !dxx-yy-->dyz
      DBlock(3,5)=r2*0.5*Dxmin(6) !dxx-yy-->d3zz
      DBlock(4,5)=r3*Dxmin(3) !dxx-yy-->dxz
      DBlock(5,5)=r1*(Dxmin(1)+0.5*Dxmin(6)) !dxx-yy-->dxx-yy

*
*-- With the proper number of blocks at hand, we make transformation.
*   The brute force way is to construct the entire transformation matrix
*   and make a matrix multiplication. Since so many elements in that
*   matrix are zero, more effecient ways to transform are available.
*   That is what is used below. The formulas follow from considering the
*   transformation matrix multiplied with the CMO-matrix. Multio
*   importante is it to observe how the basis functions in Molcas are
*   ordered!
*
      Do 10, i=1,iOrb
        In=1   !OBSERVE!!! WE ARE ASSUMING THAT THE FIRST BASIS IS OF
               !S-TYPE!!! IF YOU ARE IMPLEMENTING SYMMETRY, THIS
        Do 20, j=2,lMax  !MIGHT NOT BE A VALID ASSUMPTION SO THEN THE
          In=In+1       !NEWIQ-CONSTRUCT BELOW MUST BE ALTERED!!!
          IqSuckOut=iQ(j)
          NewIq=iQ(j).ne.iQ(j-1)
          If(Newiq) then !This if-clause controls the jumping when new
            In=In+(2*iQ(j-1)-2)*nCnC(j-1) !angular basis function
          Endif                           !appears.
          If(IqSuckOut.eq.1) then   !This is s-function
            Go To 20
          ElseIf(IqSuckOut.eq.2) then  !This is p-function
            iSkutt=nCnC(j)
            Ctemp1=PBlock(1,1)*Cmo(In,i)+PBlock(1,2)*Cmo(In+iSkutt,i)
     &           +PBlock(1,3)*Cmo(In+2*iSkutt,i)
            Ctemp2=PBlock(2,1)*Cmo(In,i)+PBlock(2,2)*Cmo(In+iSkutt,i)
     &           +PBlock(2,3)*Cmo(In+2*iSkutt,i)
            Ctemp3=PBlock(3,1)*Cmo(In,i)+PBlock(3,2)*Cmo(In+iSkutt,i)
     &           +PBlock(3,3)*Cmo(In+2*iSkutt,i)
            Cmo(In,i)=Ctemp1
            Cmo(In+iSkutt,i)=Ctemp2
            Cmo(In+2*iSkutt,i)=Ctemp3
          ElseIf(IqSuckOut.eq.3) then  !This is d-function
            iSkutt=nCnC(j)
            Ctemp1=DBlock(1,1)*Cmo(In,i)+DBlock(1,2)*Cmo(In+iSkutt,i)
     &            +DBlock(1,3)*Cmo(In+2*iSkutt,i)
     &            +DBlock(1,4)*Cmo(In+3*iSkutt,i)
     &            +DBlock(1,5)*Cmo(In+4*iSkutt,i)
            Ctemp2=DBlock(2,1)*Cmo(In,i)+DBlock(2,2)*Cmo(In+iSkutt,i)
     &            +DBlock(2,3)*Cmo(In+2*iSkutt,i)
     &            +DBlock(2,4)*Cmo(In+3*iSkutt,i)
     &            +DBlock(2,5)*Cmo(In+4*iSkutt,i)
            Ctemp3=DBlock(3,1)*Cmo(In,i)+DBlock(3,2)*Cmo(In+iSkutt,i)
     &            +DBlock(3,3)*Cmo(In+2*iSkutt,i)
     &            +DBlock(3,4)*Cmo(In+3*iSkutt,i)
     &            +DBlock(3,5)*Cmo(In+4*iSkutt,i)
            Ctemp4=DBlock(4,1)*Cmo(In,i)+DBlock(4,2)*Cmo(In+iSkutt,i)
     &            +DBlock(4,3)*Cmo(In+2*iSkutt,i)
     &            +DBlock(4,4)*Cmo(In+3*iSkutt,i)
     &            +DBlock(4,5)*Cmo(In+4*iSkutt,i)
            Ctemp5=DBlock(5,1)*Cmo(In,i)+DBlock(5,2)*Cmo(In+iSkutt,i)
     &            +DBlock(5,3)*Cmo(In+2*iSkutt,i)
     &            +DBlock(5,4)*Cmo(In+3*iSkutt,i)
     &            +DBlock(5,5)*Cmo(In+4*iSkutt,i)
            Cmo(In,i)=Ctemp1
            Cmo(In+iSkutt,i)=Ctemp2
            Cmo(In+2*iSkutt,i)=Ctemp3
            Cmo(In+3*iSkutt,i)=Ctemp4
            Cmo(In+4*iSkutt,i)=Ctemp5
          Else  !Here we go if non-implemented angular quantum number
                !appears.
            Write(6,*)
            Write(6,*)' ERROR in OrbRot2. I''m not ready for f-orbitals'
            Call Quit(_RC_GENERAL_ERROR_)
          Endif
20      Continue
10    Continue

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE NXTORD(INUM,NELMNT,MINVAL,MAXVAL,NONEW)
*
* An ordered set of numbers INUM(I),I=1,NELMNT is
* given in strictly ascending order. Values of INUM(*) is
* restricted to the interval MINVAL,MAXVAL .
*
* Find next higher number.
*
* NONEW = 1 on return indicates that no additional numbers
* could be obtained.
*
* Jeppe Olsen May 1989
*
      DIMENSION INUM(*)
*
       NTEST = 0
       IF( NTEST .NE. 0 ) THEN
         WRITE(6,*) ' Initial number in NXTORD '
         CALL IWRTMA(INUM,1,NELMNT,1,NELMNT)
       END IF
*
      IPLACE = 0
 1000 CONTINUE
        IPLACE = IPLACE + 1
        IF( IPLACE .LT. NELMNT .AND.
     &      INUM(IPLACE)+1 .LT. INUM(IPLACE+1)
     &  .OR.IPLACE.EQ. NELMNT .AND.
     &      INUM(IPLACE)+1.LE.MAXVAL) THEN
              INUM(IPLACE) = INUM(IPLACE) + 1
              NONEW = 0
              GOTO 1001
        ELSE IF ( IPLACE.LT.NELMNT) THEN
              IF(IPLACE .EQ. 1 ) THEN
                INUM(IPLACE) = MINVAL
              ELSE
                INUM(IPLACE) = INUM(IPLACE-1) + 1
              END IF
        ELSE IF ( IPLACE. EQ. NELMNT ) THEN
              NONEW = 1
              GOTO 1001
        END IF
      GOTO 1000
 1001 CONTINUE
*
      IF( NTEST .NE. 0 ) THEN
        WRITE(6,*) ' New number '
        CALL IWRTMA(INUM,1,NELMNT,1,NELMNT)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine IndSft(iCmp,iShell,iBas,jBas,kBas,lBas,
     &                  Shijij,iAO,iAOst,ijkl,SOInt,nSOInt)
************************************************************************
*  Object: to sift and index the SO integrals.                         *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             April '90                                                *
************************************************************************
      use SOAO_Info, only: iAOtSO, iOffSO
      use LundIO
      use Gateway_Info, only: ThrInt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 SOInt(ijkl,nSOInt)
      Integer iCmp(4), iShell(4), iAO(4), iAOst(4)
      Logical Shijij, Shij, Shkl, Qijij, Qij, Qkl,
     &        iQij, iQkl, Wijij
*     Local Array
      Integer iSym(0:7), jSym(0:7), kSym(0:7), lSym(0:7)
*
      iRout = 39
      iPrint = nPrint(iRout)
      k12=0
      k34=0
      If (iPrint.ge.99)
     &   Call RecPrt(' In IndSft:SOInt ',' ',SOInt,ijkl,nSOInt)
      MemSO2 = 0
*
*     Quadruple loop over elements of the basis functions angular
*     description. Loops are reduced to just produce unique SO integrals
*     Observe that we will walk through the memory in AOInt in a
*     sequential way.
*
      Shij = iShell(1).eq.iShell(2)
      Shkl = iShell(3).eq.iShell(4)
      Do 100 i1 = 1, iCmp(1)
         Do 101 j = 0, nIrrep-1
            ix = 0
            If (iAOtSO(iAO(1)+i1,j)>0) ix = 2**j
            iSym(j) = ix
101      Continue
         jCmpMx = iCmp(2)
         If (Shij) jCmpMx = i1
         Do 200 i2 = 1, jCmpMx
            Do 201 j = 0, nIrrep-1
               ix = 0
               If (iAOtSO(iAO(2)+i2,j)>0) ix = 2**j
               jSym(j) = ix
201         Continue
            Qij = i1.eq.i2
            If (iShell(2).gt.iShell(1)) Then
               i12 = iCmp(2)*(i1-1) + i2
            Else
               i12 = iCmp(1)*(i2-1) + i1
            End If
            Do 300 i3 = 1, iCmp(3)
               Do 301 j = 0, nIrrep-1
                  ix = 0
                  If (iAOtSO(iAO(3)+i3,j)>0) ix = 2**j
                  kSym(j) = ix
301            Continue
               lCmpMx = iCmp(4)
               If (Shkl) lCmpMx = i3
               Do 400 i4 = 1, lCmpMx
                  Do 401 j = 0, nIrrep-1
                     ix = 0
                     If (iAOtSO(iAO(4)+i4,j)>0) ix = 2**j
                     lSym(j) = ix
401               Continue
                  Qkl = i3.eq.i4
                  If (iShell(4).gt.iShell(3)) Then
                     i34 = iCmp(4)*(i3-1) + i4
                  Else
                     i34 = iCmp(3)*(i4-1) + i3
                  End If
                  If (Shijij .and. i34.gt.i12) Go To 400
                  Qijij = Shijij .and. i12.eq.i34
                  iQij = Shij .and. i1.eq.i2
                  iQkl = Shkl .and. i3.eq.i4
*
*      Loop over irreps which are spanned by the basis function.
*      Again, the loop structure is restricted to ensure unique
*      integrals.
*
       Do 110 j1 = 0, nIrrep-1
          If (iSym(j1).eq.0) Go To 110
*
          j2Max = nIrrep-1
          If (Shij .and. Qij) j2Max = j1
          Do 210 j2 = 0, j2Max
             If (jSym(j2).eq.0) Go To 210
             j12 = iEor(j1,j2)
             If (Qijij) Then
                If (Shij .and. Qij) Then
                    k12 = j1*(j1+1)/2 + j2+1
                Else If (Shij) Then
                    k12 = nIrrep*j1 + j2+1
                Else If (iShell(1).gt.iShell(2)) Then
                    k12 = nIrrep*j1 + j2+1
                Else
                    k12 = nIrrep*j2 + j1+1
                End If
             End If
*
             Do 310 j3 = 0, nIrrep-1
                If (kSym(j3).eq.0) Go To 310
                j4 = iEor(j12,j3)
                If (lSym(j4).eq.0) Go To 310
                If (Shkl .and. Qkl .and. j4.gt.j3) Go To 310
                If (Qijij) Then
                   If (Shkl .and. Qkl) Then
                      k34 = j3*(j3+1)/2 + j4+1
                   Else If (Shkl) Then
                      k34 = nIrrep*j3 + j4+1
                   Else If (iShell(3).gt.iShell(4)) Then
                      k34 = nIrrep*j3 + j4+1
                   Else
                      k34 = nIrrep*j4 + j3+1
                   End If
                   If (Qijij .and. k34.gt.k12) Go To 310
                End If
                Wijij = Qijij .and. k12.eq.k34
*               Unfold the way the eight indices have been reordered.
                iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)+iOffSO(j1)
                jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)+iOffSO(j2)
                kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+iOffSO(j3)
                lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+iOffSO(j4)
*
                MemSO2 = MemSO2 + 1
                nkl = 0
                Do 120 lAOl = 0, lBas-1
                   lSOl = lSO + lAOl
                   Do 220 kAOk = 0, kBas-1
                      kSOk = kSO + kAOk
                      nkl = nkl + 1
                      If (iQkl .and. kSOk.lt.lSOl) Go To 220
                      If (kSOk.lt.lSOl) Then
                          kSOkk = lSOl
                          lSOll = kSOk
                      Else
                          kSOkk = kSOk
                          lSOll = lSOl
                      End If
                      nij = 0
                      Do 320 jAOj = 0, jBas-1
                         jSOj = jSO + jAOj
                         Do 420 iAOi = 0, iBas-1
                            nij = nij + 1
                            nijkl = (nkl-1)*iBas*jBas + nij
                            If (Abs(SOInt(nijkl,MemSO2)).gt.ThrInt) Then
                               iSOi = iSO + iAOi
                               If (iSOi.lt.jSOj .and. iQij) Go To 420
                               If (iSOi.lt.jSOj) Then
                                  iSOii = jSOj
                                  jSOjj = iSOi
                               Else
                                  iSOii = iSOi
                                  jSOjj = jSOj
                               End If
                               iSOij = iSOii*(iSOii-1)/2 + jSOjj
                               iSOkl = kSOkk*(kSOkk-1)/2 + lSOll
                               If (iSOij.lt.iSOkl .and. Wijij)
     &                              Go To 420
                               If (iSOij.lt.iSOkl) Then
                                  iiSOii = kSOkk
                                  jjSOjj = lSOll
                                  kkSOkk = iSOii
                                  llSOll = jSOjj
                               Else
                                  iiSOii = iSOii
                                  jjSOjj = jSOjj
                                  kkSOkk = kSOkk
                                  llSOll = lSOll
                               End If
                               Buf%nUt=Buf%nUt + 1
                               Buf%Buf(Buf%nUt) = SOInt(nijkl,MemSO2)
                               Buf%iBuf(Buf%nUt) = llSOll + kkSOkk*2**8
     &                                           +  jjSOjj*2**16
                               Buf%iBuf(Buf%nUt)=iOr( iShft(iiSOii,24),
     &                                            Buf%iBuf(Buf%nUt) )
                               If (Buf%nUt.eq.nBuf-1) Then
                                  Call dDafile(Lu_28,1,Buf%Buf,lBuf,
     &                                         iDisk)
                                  Buf%nUt=0
                               End If
                            End If
 420                     Continue
 320                  Continue
 220               Continue
 120            Continue
*
 310         Continue
 210      Continue
 110   Continue
*
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine lmnvgn_molcas(lmn1u,lmnv)
c     # generate cartesian gaussian exponent array.
c     # lmnv(*,*) = exponents of the cartesian gaussian basis functions.
c     #             s  p  d   f   g   h   i
c     #       lmn = 0  1  2   3   4   5   6
c     #    numxyz = 1, 3, 6, 10, 15  21  28      =((lmn+1)*(lmn+2))/2
      implicit logical (a-z)
      integer lmn, lmn1u, lmnv(3,*), ndx
      Integer ix,iy,iz
c
      ndx=0
      Do lmn = 0,lmn1u-1
         Do ix = lmn, 0 , -1
            Do iy = lmn-ix, 0, -1
               iz = lmn-ix-iy
               ndx=ndx+1
               lmnv(1,ndx)=ix
               lmnv(2,ndx)=iy
               lmnv(3,ndx)=iz
            End Do
         End Do
      End Do
*
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine write_formatted_aniso(nss,nstate,multiplicity,eso,esfs,U,MM,MS,DM,angmom,edmom,amfi,HSO)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nss, nstate, multiplicity(nstate)
real(kind=wp), intent(in) :: eso(nss), esfs(nstate), angmom(3,nstate,nstate), edmom(3,nstate,nstate), amfi(3,nstate,nstate)
complex(kind=wp), intent(in) :: U(nss,nss), MM(3,nss,nss), MS(3,nss,nss), DM(3,nss,nss), HSO(nss,nss)
integer(kind=iwp) :: i, j, l, LuAniso
integer(kind=iwp), external :: IsFreeUnit

LuAniso = IsFreeUnit(81)
call molcas_open(LuAniso,'ANISOINPUT')
write(LuAniso,'(2i10)') nstate,nss
write(LuAniso,'(5ES24.14)') (eso(i),i=1,nss)
write(LuAniso,'(30i4)') (multiplicity(i),i=1,nstate)
do l=1,3
  do i=1,nss
    write(LuAniso,'(5ES24.14)') (MM(l,i,j),j=1,nss)
  end do
end do
do l=1,3
  do i=1,nss
    write(LuAniso,'(5ES24.14)') (MS(l,i,j),j=1,nss)
  end do
end do
! add data at the end, so that we do not break the functionality
! with the present format:
write(LuAniso,'(5ES24.14)') (esfs(i),i=1,nstate)
do i=1,nss
  write(LuAniso,'(5ES24.14)') (U(i,j),j=1,nss)
end do
! angmom
do l=1,3
  do i=1,nstate
    write(LuAniso,'(5ES24.14)') (angmom(l,i,j),j=1,nstate)
  end do
end do

! DMmom
do l=1,3
  do i=1,nss
    write(LuAniso,'(5ES24.14)') (DM(l,i,j),j=1,nss)
  end do
end do

! edmom
do l=1,3
  do i=1,nstate
    write(LuAniso,'(5ES24.14)') (edmom(l,i,j),j=1,nstate)
  end do
end do

! amfi
do l=1,3
  do i=1,nstate
    write(LuAniso,'(5ES24.14)') (amfi(l,i,j),j=1,nstate)
  end do
end do

! HSO matrix
do i=1,nss
  write(LuAniso,'(5ES24.14)') (HSO(i,j),j=1,nss)
end do

close(LuAniso)

return

end subroutine write_formatted_aniso

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FZERO(B,N)
      INTEGER    N
      REAL*8     B(N)

      CALL DCOPY_(N,[0.0D0],0,B,1)

      RETURN
      END

      SUBROUTINE IZERO(B,N)
      INTEGER    N
      INTEGER    B(N)

      CALL ICOPY(N,[0],0,B,1)

      RETURN
      END

      SUBROUTINE DFILL (N,SA,SX,INCX)
      INTEGER    N,INCX
      REAL*8     SX(N),SA

      CALL DCOPY_(N,[SA],0,SX,INCX)

      RETURN
      END

      SUBROUTINE ADDVEC (A,B,C,N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(N),B(N),C(N)

      DO I=1,N
         A(I)=B(I)+C(I)
      END DO

      RETURN
      END

      SUBROUTINE SUBVEC (A,B,C,N)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(N),B(N),C(N)

      DO I=1,N
         A(I)=B(I)-C(I)
      END DO

      RETURN
      END


      SUBROUTINE SCATTER(N,A,IND,B)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*),B(N),IND(N)

      DO I=1,N
         A(IND(I))=B(I)
      END DO

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine expec_cvb(dxp,gradp,heigval,
     >  nnegeig,npr,exp,exp1,exp2)
      implicit real*8 (a-h,o-z)
      dimension dxp(npr),gradp(npr),heigval(npr)
      save zero,half
      data zero/0.d0/,half/0.5d0/

      exp1l=zero
      do 100 i=1,nnegeig
      exp1l=exp1l+dxp(i)*(gradp(i)+half*dxp(i)*heigval(i))
100   continue
      exp2l=zero
      do 200 i=nnegeig+1,npr
      exp2l=exp2l+dxp(i)*(gradp(i)+half*dxp(i)*heigval(i))
200   continue
      exp=exp1l+exp2l
      exp1=exp1l
      exp2=exp2l
      return
      end
      subroutine getdxp_cvb(dxp,gradp,heigval,nnegeig,npr,alfa)
      implicit real*8 (a-h,o-z)
      dimension dxp(npr),gradp(npr),heigval(npr)
      do 300 i=1,nnegeig
      dxp(i)=-gradp(i)/(heigval(i)-alfa)
300   continue
      do 400 i=nnegeig+1,npr
      dxp(i)=-gradp(i)/(heigval(i)+alfa)
400   continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SYG2SGU(IMODE,SGS,CIS,LSYM,ICNFTAB,ISPNTAB,CIOLD,CINEW)
      use definitions, only: iwp, wp, u6
      use constants, only: One
      use rassi_aux, only: ipglob
      use gugx, only: SGStruct, CIStruct, mxlev
      use stdalloc, only: mma_allocate, mma_deallocate
      IMPLICIT NONE
      Integer(kind=iwp), intent(in):: IMODE
      Type (SGStruct), intent(in):: SGS
      Type (CIStruct) , intent(in)::CIS
      Integer(kind=iwp), intent(inout):: LSYM
      INTEGER(kind=iwp), intent(in):: ICNFTAB(*),ISPNTAB(*)
      Real(kind=wp), intent(in):: CIOLD(*)
      Real(kind=wp), intent(out):: CINEW(*)

      Integer(kind=iwp), PARAMETER:: NBUFFER=600,MXCPI=15
      Integer(kind=iwp) KWALK(NBUFFER)
      Real(kind=wp) PHASE(NBUFFER)
      Integer(kind=iwp) ICNUM(NBUFFER)
      Integer(kind=iwp) ICASE(400)
      Integer(kind=iwp) :: IFUP2CS(0:1)=[2,1]
      Integer(kind=iwp), Allocatable:: MWS2W(:), OrbArr(:)

      Integer(kind=iwp) NCONF,NWALK,NSYM,NLEV,NACTEL,NWRD,NWLKLST,NOPEN,
     &                  NODD,NOCC,NHEAD,NCSYMG,NCPL,NCNF,NCLSD,NAPART,
     &                  MXWLK,MIPWLK,MINOP,MAXOP,LEV,KSPNINF,KGSORB,
     &                  KGSLIM,KCPL,KCNFINF,KCNF,IWRD,IWORD,IWLKPOS,
     &                  IREST,IORB,IOCC,IFUP,IFORM,IEL2,IEL1,IEL,
     &                  ICSYMG,ICSPLT,ICPL,ICNF,I
      Real(kind=wp) PHS

C SGS       : Data that define a Split Graph
C qCIS : Data that define a CI array structure
C IMODE=0 transforms a Symmetric Group CI array to SGUGA
C IMODE=1 transforms a Split GUGA CI array to Symm Group
C ...Configuration and Spin Coupling tables, fill this in later.
C CIOLD and CINEW are obvious.

C Dereference CIS and SGS       for some data:
      NCONF =CIS%NCSF(LSYM)
      NWALK =CIS%nWalk
      CALL mma_allocate(MWS2W,NWALK,Label='MWS2W')
      NSYM  =ICNFTAB(7)
      CALL MSTOW(SGS,CIS,MWS2W,NSYM)
C MWS2W is a table which gives the upper or lower walk
C index as function of the MAW sum.

C Inspect the top row of the DRT to find NACTEL and spin:
      NLEV  =SGS%DRT(1,1)
      IF (NLEV.GT.MXLEV) THEN
        WRITE(u6,*) ' SYG2SGU: error: number of levels exceeds MXLEV'
        WRITE(u6,'(1X,2(A,I4))') ' NLEV = ',NLEV,' MXLEV = ',MXLEV
        CALL AbEnd()
      END IF
      NACTEL=SGS%DRT(1,2)

C Now a good bound on MINOP, the minimum number of open
C shells, would be MLTPLC-1. This is the best bound, and it
C does not depend on any assumed Ms.

C A buffer of packed walks is used:
      NWLKLST=0
      IWLKPOS=1
C Nr of integers used to store each total walk:
      MIPWLK=1+(NLEV-1)/MXCPI
C Max nr of Split-Graph CSF''s, stored as walks in the
C buffer KWALK
      MXWLK=NBUFFER/MIPWLK
C Pick up various data from conf and spin tables
C Unbutton Configuration table:

      MINOP =ICNFTAB(5)
      MAXOP =ICNFTAB(6)
      NSYM  =ICNFTAB(7)
      If (LSYM/=ICNFTAB(8))Stop 6776
      LSYM  =ICNFTAB(8)
      NAPART=ICNFTAB(9)
      IFORM =ICNFTAB(10)
*PAM07 Statement to fool intel 10.1 compiler do do the right thing:
      IF(MINOP.GT.MAXOP) WRITE(6,*) MINOP,MAXOP

      NHEAD=10
      KGSORB=NHEAD+1
      KGSLIM =KGSORB+(NSYM+1)*(NAPART+1)
      KCNFINF=KGSLIM+2*NAPART
C Unbutton Spin table:
      KSPNINF=9
      CALL mma_allocate(ORBARR,NACTEL,Label='OrbArr')

C Loop over nr of open shells
C NCSYMG=Nr of Symmetric-Group CSF''s treated so far.
      NCSYMG=0
      DO NOPEN=MINOP,MAXOP
        NCLSD=(NACTEL-NOPEN)/2
        IF(NCLSD.LT.0) cycle
        IF(2*NCLSD+NOPEN.NE.NACTEL) cycle
        NOCC=NCLSD+NOPEN
        IF(NOCC.GT.NLEV) cycle
        NCNF=ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP)))
        KCNF=ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP))+1)
        NWRD=ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP))+2)
        NCPL=ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+1)
        KCPL=ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+3)


* Here follows four if-clauses on the cases of IFORM=1..4.
* The contents in all four cases is almost the same, but it is
* *DELIBERATE* that it has not been rewritten as one single piece of code
* with a few IF statement inside. It seems that some compilers do not
* optimize the code correctly then.
* Also, a number of IF-clauses have been replaced by arithmetic computation
* for the same reason. Pardon the clumsy result...
        IWORD = 0 ! dummy initialize
        IF(IFORM.EQ.1) THEN
************************************************************************
* The IFORM=1 case:
C Long loop over configurations
        DO ICNF=1,NCNF
          DO IEL=1,NOCC
            ORBARR(IEL)=ICNFTAB(KCNF-1+IEL+NWRD*(ICNF-1))
          END DO
C Loop over spin couplings
          DO ICPL=1,NCPL
            DO I=1,NLEV
              ICASE(I)=0
            END DO
            DO I=1,NCLSD
              IORB=ORBARR(I)
              ICASE(IORB)=3
            END DO
            DO I=1,NOPEN
              IORB=ORBARR(NCLSD+I)
              IFUP=ISPNTAB(KCPL-1+I+NOPEN*(ICPL-1))
*              ICASE(IORB)=1
*              IF(IFUP.NE.1) ICASE(IORB)=2
              ICASE(IORB)=IFUP2CS(IFUP)

            END DO
C A phase factor will be induced by the reordering.
            PHS=One
            NODD=0
            DO LEV=1,NLEV
              I=ICASE(LEV)
*              IF(I.EQ.1) NODD=1-NODD
*              IF(I.EQ.2) NODD=1-NODD
              NODD=((2*NODD-1)*I*(I-3))/2+NODD
*              IF(NODD.EQ.1) THEN
*                IF(I.EQ.2) PHS=-PHS
*                IF(I.EQ.3) PHS=-PHS
*              END IF
              PHS=DBLE((3+NODD*I*(I-1)*(2*I-7))/3)*PHS
            END DO
C Pack the walk and add it to the list.
            CALL PKWLK(NLEV,MIPWLK,1,KWALK(IWLKPOS),ICASE)
            IWLKPOS=IWLKPOS+MIPWLK
            NWLKLST=NWLKLST+1
            PHASE(NWLKLST)=PHS
            IF(NWLKLST.EQ.MXWLK) THEN
C Translate the packed walks to a list of CSF ID-numbers
              CALL W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
              IWLKPOS=1
C Loop over this list.
              ICSYMG=NCSYMG
              IF ( IMODE.EQ.0 ) THEN
                DO I=1,NWLKLST
                  PHS=PHASE(I)
                  ICSPLT=ICNUM(I)
                  ICSYMG=NCSYMG+I
                  CINEW(ICSPLT)=CIOLD(ICSYMG)*PHS
                END DO
              ELSE
                DO I=1,NWLKLST
                  PHS=PHASE(I)
                  ICSPLT=ICNUM(I)
                  ICSYMG=NCSYMG+I
                  CINEW(ICSYMG)=CIOLD(ICSPLT)*PHS
                END DO
              END IF
              NCSYMG=ICSYMG
              NWLKLST=0
            END IF

C End of loop over spin couplings
          END DO
C End of loop over configurations
        END DO
        ELSE IF(IFORM.EQ.2) THEN
************************************************************************
* The IFORM=2 case:
C Long loop over configurations
        DO ICNF=1,NCNF
          IEL2=0
          IEL1=NCLSD
          DO IORB=1,NLEV
            IOCC=ICNFTAB(KCNF-1+IORB+NWRD*(ICNF-1))
            IF(IOCC.EQ.1) THEN
              IEL1=IEL1+1
              ORBARR(IEL1)=IORB
            ELSE
              IEL2=IEL2+1
              ORBARR(IEL2)=IORB
            END IF
          END DO
C Loop over spin couplings
          DO ICPL=1,NCPL
            DO I=1,NLEV
              ICASE(I)=0
            END DO
            DO I=1,NCLSD
              IORB=ORBARR(I)
              ICASE(IORB)=3
            END DO
            DO I=1,NOPEN
              IORB=ORBARR(NCLSD+I)
              IFUP=ISPNTAB(KCPL-1+I+NOPEN*(ICPL-1))
*              ICASE(IORB)=1
*              IF(IFUP.NE.1) ICASE(IORB)=2
              ICASE(IORB)=IFUP2CS(IFUP)
            END DO
C A phase factor will be induced by the reordering.
            PHS=One
            NODD=0
            DO LEV=1,NLEV
              I=ICASE(LEV)
*              IF(I.EQ.1) NODD=1-NODD
*              IF(I.EQ.2) NODD=1-NODD
              NODD=((2*NODD-1)*I*(I-3))/2+NODD
*              IF(NODD.EQ.1) THEN
*                IF(I.EQ.2) PHS=-PHS
*                IF(I.EQ.3) PHS=-PHS
*              END IF
              PHS=DBLE((3+NODD*I*(I-1)*(2*I-7))/3)*PHS
            END DO
C Pack the walk and add it to the list.
            CALL PKWLK(NLEV,MIPWLK,1,KWALK(IWLKPOS),ICASE)
            IWLKPOS=IWLKPOS+MIPWLK
            NWLKLST=NWLKLST+1
            PHASE(NWLKLST)=PHS
            IF(NWLKLST.EQ.MXWLK) THEN
C Translate the packed walks to a list of CSF ID-numbers
              CALL W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
              IWLKPOS=1
C Loop over this list.
              ICSYMG=NCSYMG
              IF ( IMODE.EQ.0 ) THEN
                DO I=1,NWLKLST
                  PHS=PHASE(I)
                  ICSPLT=ICNUM(I)
                  ICSYMG=NCSYMG+I
                  CINEW(ICSPLT)=CIOLD(ICSYMG)*PHS
                END DO
              ELSE
                DO I=1,NWLKLST
                  PHS=PHASE(I)
                  ICSPLT=ICNUM(I)
                  ICSYMG=NCSYMG+I
                  CINEW(ICSYMG)=CIOLD(ICSPLT)*PHS
                END DO
              END IF
              NCSYMG=ICSYMG
              NWLKLST=0
            END IF

C End of loop over spin couplings
          END DO
C End of loop over configurations
        END DO
        ELSE IF(IFORM.EQ.3) THEN
************************************************************************
* The IFORM=3 case:
C Long loop over configurations
        DO ICNF=1,NCNF
          DO IEL=1,NOCC
            IWRD=(3+IEL)/4
            IREST=(3+IEL)-4*IWRD
            IF(IREST.EQ.0) THEN
              IWORD=ICNFTAB(KCNF-1+IWRD+NWRD*(ICNF-1))
            END IF
            IORB=MOD(IWORD,256)
            IWORD=IWORD/256
            ORBARR(IEL)=IORB
          END DO
C Loop over spin couplings
          DO ICPL=1,NCPL
            DO I=1,NLEV
              ICASE(I)=0
            END DO
            DO I=1,NCLSD
              IORB=ORBARR(I)
              ICASE(IORB)=3
            END DO
            DO I=1,NOPEN
              IORB=ORBARR(NCLSD+I)
              IFUP=ISPNTAB(KCPL-1+I+NOPEN*(ICPL-1))
*              ICASE(IORB)=1
*              IF(IFUP.NE.1) ICASE(IORB)=2
              ICASE(IORB)=IFUP2CS(IFUP)
            END DO
C A phase factor will be induced by the reordering.
            PHS=One
            NODD=0
            DO LEV=1,NLEV
              I=ICASE(LEV)
*              IF(I.EQ.1) NODD=1-NODD
*              IF(I.EQ.2) NODD=1-NODD
              NODD=((2*NODD-1)*I*(I-3))/2+NODD
*              IF(NODD.EQ.1) THEN
*                IF(I.EQ.2) PHS=-PHS
*                IF(I.EQ.3) PHS=-PHS
*              END IF
              PHS=DBLE((3+NODD*I*(I-1)*(2*I-7))/3)*PHS
            END DO
C Pack the walk and add it to the list.
            CALL PKWLK(NLEV,MIPWLK,1,KWALK(IWLKPOS),ICASE)
            IWLKPOS=IWLKPOS+MIPWLK
            NWLKLST=NWLKLST+1
            PHASE(NWLKLST)=PHS
            IF(NWLKLST.EQ.MXWLK) THEN
C Translate the packed walks to a list of CSF ID-numbers
              CALL W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
              IWLKPOS=1
C Loop over this list.
              ICSYMG=NCSYMG
              IF ( IMODE.EQ.0 ) THEN
                DO I=1,NWLKLST
                  PHS=PHASE(I)
                  ICSPLT=ICNUM(I)
                  ICSYMG=NCSYMG+I
                  CINEW(ICSPLT)=CIOLD(ICSYMG)*PHS
                END DO
              ELSE
                DO I=1,NWLKLST
                  PHS=PHASE(I)
                  ICSPLT=ICNUM(I)
                  ICSYMG=NCSYMG+I
                  CINEW(ICSYMG)=CIOLD(ICSPLT)*PHS
                END DO
              END IF
              NCSYMG=ICSYMG
              NWLKLST=0
            END IF

C End of loop over spin couplings
          END DO
C End of loop over configurations
        END DO
        ELSE IF(IFORM.EQ.4) THEN
************************************************************************
* The IFORM=4 case:
C Long loop over configurations
        DO ICNF=1,NCNF
          IEL2=0
          IEL1=NCLSD
          DO IORB=1,NLEV
            IWRD=(IORB+14)/15
            IREST=IORB+14-15*IWRD
            IF(IREST.EQ.0) THEN
              IWORD=ICNFTAB(KCNF-1+IWRD+NWRD*(ICNF-1))
            END IF
            IOCC=MOD(IWORD,4)
            IWORD=IWORD/4
            IF(IOCC.EQ.1) THEN
              IEL1=IEL1+1
              ORBARR(IEL1)=IORB
            ELSE
              IEL2=IEL2+1
              ORBARR(IEL2)=IORB
            END IF
          END DO
C Loop over spin couplings
          DO ICPL=1,NCPL
            DO I=1,NLEV
              ICASE(I)=0
            END DO
            DO I=1,NCLSD
              IORB=ORBARR(I)
              ICASE(IORB)=3
            END DO
            DO I=1,NOPEN
              IORB=ORBARR(NCLSD+I)
              IFUP=ISPNTAB(KCPL-1+I+NOPEN*(ICPL-1))
*              ICASE(IORB)=1
*              IF(IFUP.NE.1) ICASE(IORB)=2
              ICASE(IORB)=IFUP2CS(IFUP)
            END DO
C A phase factor will be induced by the reordering.
            PHS=One
            NODD=0
            DO LEV=1,NLEV
              I=ICASE(LEV)
*              IF(I.EQ.1) NODD=1-NODD
*              IF(I.EQ.2) NODD=1-NODD
              NODD=((2*NODD-1)*I*(I-3))/2+NODD
*              IF(NODD.EQ.1) THEN
*                IF(I.EQ.2) PHS=-PHS
*                IF(I.EQ.3) PHS=-PHS
*              END IF
              PHS=DBLE((3+NODD*I*(I-1)*(2*I-7))/3)*PHS
            END DO
C Pack the walk and add it to the list.
            CALL PKWLK(NLEV,MIPWLK,1,KWALK(IWLKPOS),ICASE)
            IWLKPOS=IWLKPOS+MIPWLK
            NWLKLST=NWLKLST+1
            PHASE(NWLKLST)=PHS
            IF(NWLKLST.EQ.MXWLK) THEN
C Translate the packed walks to a list of CSF ID-numbers
              CALL W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
              IWLKPOS=1
C Loop over this list.
              ICSYMG=NCSYMG
              IF ( IMODE.EQ.0 ) THEN
                DO I=1,NWLKLST
                  PHS=PHASE(I)
                  ICSPLT=ICNUM(I)
                  ICSYMG=NCSYMG+I
                  CINEW(ICSPLT)=CIOLD(ICSYMG)*PHS
                END DO
              ELSE
                DO I=1,NWLKLST
                  PHS=PHASE(I)
                  ICSPLT=ICNUM(I)
                  ICSYMG=NCSYMG+I
                  CINEW(ICSYMG)=CIOLD(ICSPLT)*PHS
                END DO
              END IF
              NCSYMG=ICSYMG
              NWLKLST=0
            END IF

C End of loop over spin couplings
          END DO
C End of loop over configurations
        END DO
        END IF
************************************************************************

C End of loop over NOPEN
      END DO
C
C As above, processing what remains in the KWALK buffer.
      CALL W2SGORD(SGS,CIS,MWS2W,NWLKLST,KWALK,ICNUM)
      IWLKPOS=1
      IF ( IMODE.EQ.0 ) THEN
        DO I=1,NWLKLST
          PHS=PHASE(I)
          ICSPLT=ICNUM(I)
          ICSYMG=NCSYMG+I
          CINEW(ICSPLT)=CIOLD(ICSYMG)*PHS
        END DO
      ELSE
        DO I=1,NWLKLST
          PHS=PHASE(I)
          ICSPLT=ICNUM(I)
          ICSYMG=NCSYMG+I
          CINEW(ICSYMG)=CIOLD(ICSPLT)*PHS
        END DO
      END IF
      NCSYMG=NCSYMG+NWLKLST
      NWLKLST=0

      IF( IPGLOB.GE.5 ) THEN
        WRITE(6,*)
        WRITE(6,*)' CI vector reordered in SYG2SGU'
        IF(IMODE.EQ.0) THEN
          WRITE(6,*)' OLD CI vector in SYMMETRIC GROUP order'
          WRITE(6,'(10F12.8)') (CIOLD(I),I=1,NCONF)
          WRITE(6,*)' NEW CI vector in SPLIT GRAPH UGA order'
          WRITE(6,'(10F12.8)') (CINEW(I),I=1,NCONF)
        ELSE
          WRITE(6,*)' OLD CI vector in SPLIT GRAPH UGA order'
          WRITE(6,'(10F12.8)') (CIOLD(I),I=1,NCONF)
          WRITE(6,*)' NEW CI vector in SYMMETRIC GROUP order'
          WRITE(6,'(10F12.8)') (CINEW(I),I=1,NCONF)
        END IF
      ENDIF
C
      CALL mma_deallocate(OrbArr)
      CALL mma_deallocate(MWS2W)

      END SUBROUTINE SYG2SGU

      SUBROUTINE PKWLK(N,IPWLK,NWALK,IWALK,ICASE)
      use definitions, only: iwp
      Implicit none
      Integer(kind=iwp), intent(in):: N,IPWLK,NWALK
      Integer(kind=iwp), intent(out):: IWALK(*)
      Integer(kind=iwp), intent(in):: ICASE(N,NWALK)

      Integer(kind=iwp) IPOS,I,LEND,J,LSTA,IWORD,L
C PURPOSE: PACK THE GUGA STEP NUMBERS INTO THE ARRAY IWALK.
C EACH OF THE NWALK WALKS HAS N STEP NUMBERS, 2 BITS EACH,
C AT MOST 15 TO AN INTEGER ELEMENT OF IWALK, EACH NEW WALK
C IS ALIGNED ON INTEGERS.
C NOTE: Can be used for upper, lower, or total walks, so the
C number of integers used for each walk (IPWLK) is given as
C call parameter.
      IPOS=0
      DO I=1,NWALK
        LEND=0
        DO J=1,IPWLK
          LSTA=LEND+1
          LEND=MIN(LSTA+14,N)
          IPOS=IPOS+1
          IWORD=0
          DO L=LEND,LSTA,-1
            IWORD=4*IWORD+ICASE(L,I)
          END DO
          IWALK(IPOS)=IWORD
        END DO
      END DO
      END SUBROUTINE PKWLK

      SUBROUTINE UPKWLK(N,IPWLK,NWALK,IWALK,ICASE)
      use definitions, only: iwp
      Implicit none
      Integer(kind=iwp), intent(in):: N,IPWLK,NWALK
      Integer(kind=iwp), intent(in):: IWALK(*)
      Integer(kind=iwp), intent(out):: ICASE(N,NWALK)

      Integer(kind=iwp) IPOS,I,LEND,J,LSTA,IWORD,L,NEXT
* See companion subroutine PKWLK.
      IPOS=0
      DO I=1,NWALK
        LEND=0
        DO J=1,IPWLK
          LSTA=LEND+1
          LEND=MIN(LSTA+14,N)
          IPOS=IPOS+1
          IWORD=IWALK(IPOS)
          DO L=LSTA,LEND
            NEXT=IWORD/4
            ICASE(L,I)=IWORD-4*NEXT
            IWORD=NEXT
          END DO
        END DO
      END DO
      END SUBROUTINE UPKWLK


      SUBROUTINE W2SGORD(SGS,CIS,MWS2W,
     &                 NLIST,KWALK,ICNUM)
      use definitions, only: iwp
      use gugx, only: SGStruct, CIStruct
      use stdalloc, only: mma_allocate, mma_deallocate
      implicit none
      Type (SGStruct), intent(in):: SGS
      Type (CIStruct), intent(in):: CIS
      Integer(kind=iwp) MWS2W(*), NLIST
      Integer(kind=iwp) KWALK(*),ICNUM(NLIST)

      Integer(kind=iwp), PARAMETER :: MXCPI=15
      Integer(kind=iwp), Allocatable:: ICS(:)
      Integer(kind=iwp) nLev,nVert,MidLev,MVSta,nMidV,NIPWLK,MIPWLK

C Purpose: Given a list of bit-packed total walks,
C translate this into a list of elements of a CI array.
C MXCPI= Max nr of case numbers packed in one integer.
C Dereference SGS:

      nLev   =SGS%nLev
      nVert  =SGS%nVert
      MidLev =SGS%MidLev
      MVSta  =SGS%MVSta
C Dereference CIS:

      nMidV =CIS%nMidV
      NIPWLK=CIS%nIpWlk
C Nr of integers used to store each total walk:
      MIPWLK=1+(NLEV-1)/MXCPI
C Allocate scratch space for case numbers:
      CALL mma_allocate(ICS,NLEV,Label='ICS')
      CALL W2SGORD1(NLEV,NVERT,NMIDV,NIPWLK,SGS%ISM,MIDLEV,
     &            MVSTA,CIS%IOCSF,CIS%NOW,CIS%IOW,
     &            SGS%DOWN,SGS%MAW,ICS,
     &            MWS2W,MIPWLK,NLIST,KWALK,ICNUM)
      CALL mma_deallocate(ICS)
      END SUBROUTINE W2SGORD

      SUBROUTINE W2SGORD1(NLEV,NVERT,NMIDV,NIPWLK,ISM,MIDLEV,
     &                  MVSTA,IOCSF,NOW,IOW,IDOWN,MAW,ICS,
     &                  MWS2W,MIPWLK,NLIST,KWALK,ICNUM)
      use definitions, only: iwp
      use Symmetry_Info, only: nSym=>nIrrep, MUL
      implicit none
      Integer(kind=iwp), intent(in):: NLEV,NVERT,NMIDV,NIPWLK
      Integer(kind=iwp), intent(in):: ISM(NLEV)
      Integer(kind=iwp), intent(in):: MIDLEV,MVSTA
      Integer(kind=iwp), intent(in):: IOCSF(NSYM,NMIDV,NSYM)
      Integer(kind=iwp), intent(in):: NOW(2,NSYM,NMIDV),
     &                                IOW(2,NSYM,NMIDV)
      Integer(kind=iwp), intent(in):: IDOWN(NVERT,0:3),MAW(NVERT,0:3)
      Integer(kind=iwp), intent(out):: ICS(NLEV)
      Integer(kind=iwp), intent(in):: MWS2W(*)
      Integer(kind=iwp), intent(in):: MIPWLK,NLIST
      Integer(kind=iwp), intent(in):: KWALK(MIPWLK,NLIST)
      Integer(kind=iwp), intent(out):: ICNUM(NLIST)

      Integer(kind=iwp) IC,ICONF,IDV,IDW,IOFF,ISYCI,ISYDWN,ISYUP,IUV,
     &                  IUW,LDIM,LEV,MAWSD,MAWSU,MV
C Purpose: For a wave function in Split GUGA storage structure,
C given KWALK(J,I) with J=1..MIPWLK that contains the
C complete Guga walk, as a packed array of case numbers, construct
C ICNUM(I), which is the index of this configuration in the
C Split-Guga scheme.
C Use MAWS to WLK table, MWS2W

      DO ICONF=1,NLIST
C Unpack total walk to ICS()
        CALL UPKWLK(NLEV,MIPWLK,1,KWALK(1,ICONF),ICS)

C Follow upper walk down to MIDLEV:
        MAWSU=0
        IUV=1
        ISYUP=1
        IDV=-1000000000
        DO LEV=NLEV,MIDLEV+1,-1
          IC=ICS(LEV)
          IF(((IC+1)/2).EQ.1)ISYUP=MUL(ISM(LEV),ISYUP)
          IDV=IDOWN(IUV,IC)
          MAWSU=MAWSU+MAW(IUV,IC)
          IUV=IDV
        END DO
C We have found the midvertex number:
        MV=IDV+1-MVSTA
C Follow lower walk down to MIDLEV:
        ISYDWN=1
        MAWSD=0
        DO LEV=MIDLEV,1,-1
          IC=ICS(LEV)
          IF(((IC+1)/2).EQ.1)ISYDWN=MUL(ISM(LEV),ISYDWN)
          IDV=IDOWN(IUV,IC)
          MAWSD=MAWSD+MAW(IUV,IC)
          IUV=IDV
        END DO
        IUW=MWS2W(MAWSU)
        IDW=MWS2W(MAWSD)
C Subtract the offsets:
        IUW=IUW-IOW(1,ISYUP,MV)/NIPWLK
        IDW=IDW-IOW(2,ISYDWN,MV)/NIPWLK
C Split-Guga storage scheme: an element in a set of matrices.
C Offset to the matrix we want is IOCSF(ISYUP,MV,ISYCI).
C Leading dimension=nr of upwalks in this block.
        ISYCI=MUL(ISYUP,ISYDWN)
        IOFF=IOCSF(ISYUP,MV,ISYCI)
        LDIM=NOW(1,ISYUP,MV)
        ICNUM(ICONF)=IOFF+IUW+LDIM*(IDW-1)
      END DO
      END SUBROUTINE W2SGORD1

      SUBROUTINE MSTOW(SGS,CIS,MWS2W,nSym)
      use definitions, only:iwp
      use gugx, only: SGStruct, CIStruct
      use stdalloc, only: mma_allocate, mma_deallocate
      IMPLICIT NONE
      Type (SGStruct), intent(in):: SGS
      Type (CIStruct), intent(in):: CIS
      Integer(kind=iwp), intent(out):: MWS2W(*)
      Integer(kind=iwp), intent(in):: nSym

      Integer(kind=iwp), allocatable:: ICS(:)
      Integer(kind=iwp) NLEV,NVERT,MIDLEV,NMIDV,NIPWLK,NWALK

      NLEV  =SGS%nLev
      NVERT =SGS%nVert
      MIDLEV=SGS%MidLev

      NMIDV =CIS%nMidV
      NIPWLK=CIS%nIpWlk
      NWALK =CIS%nWalk
      CALL mma_allocate(ICS,NLEV,Label='ICS')
      CALL MSTOW1(NSYM,NLEV,NVERT,NMIDV,NIPWLK,NWALK,
     &            MIDLEV,ICS,CIS%NOW,CIS%IOW,
     &            CIS%ICase,SGS%UP,SGS%DOWN,
     &            SGS%MAW,MWS2W)
      CALL mma_deallocate(ICS)
      END SUBROUTINE MSTOW

      SUBROUTINE MSTOW1(NSYM,NLEV,NVERT,NMIDV,NIPWLK,NWALK,
     &                  MIDLEV,ICS,NOW,IOW,IWALK,
     &                  IUP,IDOWN,MAW,MWS2W)
      use definitions, only: iwp
      IMPLICIT  NONE
      Integer(kind=iwp), intent(in):: NSYM,NLEV,NVERT,NMIDV,NIPWLK,
     &                                NWALK,MIDLEV
      Integer(kind=iwp), intent(out):: ICS(NLEV)
      Integer(kind=iwp), intent(in):: NOW(2,NSYM,NMIDV),
     &                                IOW(2,NSYM,NMIDV)
      Integer(kind=iwp), intent(in):: IWALK(NIPWLK*NWALK)
      Integer(kind=iwp), intent(in):: IDOWN(NVERT,0:3),IUP(NVERT,0:3)
      Integer(kind=iwp), intent(in):: MAW(NVERT,0:3)
      Integer(kind=iwp), intent(out):: MWS2W(NWALK)

      Integer(kind=iwp) MV,ISYUP,NUP,IUOFF,IUW,IUWTOT,MS,IUV,LEV,IC,
     &                     ISYDWN,NDWN,IDOFF,IDW,IDWTOT,IDV
C Purpose: From the list of packed up- and downwalks, construct
C the table MWS2W, such that MAW sums can be translated to the
C corresponding walks of the Split-GUGA.

      DO MV=1,NMIDV
        DO ISYUP=1,NSYM
          NUP=NOW(1,ISYUP,MV)
          IF(NUP.EQ.0) cycle
          IUOFF=IOW(1,ISYUP,MV)/NIPWLK
          DO IUW=1,NUP
            IUWTOT=IUOFF+IUW
C Unpack upper walk to ICS()
            CALL UPKWLK(NLEV-MIDLEV,NIPWLK,1,IWALK(1+NIPWLK*(IUWTOT-1)),
     &                  ICS(MIDLEV+1))
            MS=0
            IUV=1
            DO LEV=NLEV,MIDLEV+1,-1
              IC=ICS(LEV)
              MS=MS+MAW(IUV,IC)
              IUV=IDOWN(IUV,IC)
            END DO
            MWS2W(MS)=IUWTOT
          END DO
        END DO
      END DO

      DO MV=1,NMIDV
        DO ISYDWN=1,NSYM
          NDWN=NOW(2,ISYDWN,MV)
          IF(NDWN.EQ.0) cycle
          IDOFF=IOW(2,ISYDWN,MV)/NIPWLK
          DO IDW=1,NDWN
            IDWTOT=IDOFF+IDW
C Unpack lower walk to ICS()
            CALL UPKWLK(MIDLEV,NIPWLK,1,IWALK(1+NIPWLK*(IDWTOT-1)),ICS)
            MS=0
            IDV=NVERT
            DO LEV=1,MIDLEV
              IC=ICS(LEV)
              IUV=IUP(IDV,IC)
              MS=MS+MAW(IUV,IC)
              IDV=IUV
            END DO
            MWS2W(MS)=IDWTOT
          END DO
        END DO
      END DO

      END SUBROUTINE MSTOW1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine hermit_molcas(nn,x,a,eps)
c                  calculates the zeros  x(i)  of the nn-th order
c                hermite polynomial.  the largest zero will be
c                stored in x(1).  also calculates the corresponding
c                coefficients  a(i)  of the nn-th order gauss-hermite
c                quadrature formula of degree 2*nn-1.  the factor of
c                sqrt(pi) has been removed from the a(i).
c  a. h. stroud & d. secrest, gaussian quadrature formulas,
c  prentice-hall, 1966
c
      implicit real*8 (a-h,o-z)
      parameter (sixth = 1.0d0/6.0d0)
      dimension x(*), a(*)
c
      fn = DBLE(nn)
      n1 = nn - 1
      n2 = (nn+1)/2
      cc = 1.0d0
      s  = 0.0d0
      do 15 i=1,n1
        s  = s + 0.5d0
        cc = s*cc
   15 continue
      s  = (2.0d0*fn+1.0d0)**sixth
      do 30 i=1,n2
        if( i.eq.1 ) then
c         # largest zero
          xt = s**3 - 1.85575d0/s
        elseif( i.eq.2 ) then
c         # second zero
          xt = xt - 1.14d0*fn**0.426d0/xt
        elseif( i.eq.3 ) then
c         # third zero
          xt = 1.86d0*xt - 0.86d0*x(1)
        elseif( i.eq.4 ) then
c         # fourth zero
          xt = 1.91d0*xt - 0.91d0*x(2)
        else
c         # all other zeros
          xt = 2.0d0*xt - x(i-2)
        endif
c
        call hroot(xt,nn,dpn,pn1,eps)
        x(i) = xt
        a(i) = cc/dpn/pn1
c       write (6,'(2i4,2d25.17)') nn, i, xt, a(i)
        ni = nn-i+1
        x(ni) = -xt
        a(ni) = a(i)
   30 continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine LEVEL_SPLINE(X,Y,N,IOPT,C,N4,IER)
!** Subroutine for generating cubic spline coefficients
!  C(J), (J=1,N4=4*N) through the N points X(I), Y(I).
!** C(I+M*N), M=0-3  are the coefficients of order  0-3  of cubic
!  polynomial expanded about X(I) so as to describe the interval:
!             -  X(I) to X(I+1)  , if  X(I)  in increasing order
!             -  X(I-1) to X(I)  , if  X(I)  in decreasing order.
!** IOPT indicates boundary conditions used in creating the  spline .
!*  If (IOPT=0)  second derivatives = zero at both ends of range.
!*  If (IOPT=1)  1st derivative at first point X(1) fixed at C(1),
!                and 2nd derivative at X(N) = zero.
!*  If (IOPT=2)  1st derivative at last point X(N) fixed at C(2),
!                and 2nd derivative at X(1) = zero.
!*  If (IOPT=3)  constrain first derivatives at end points to have
!                (read in) values  C(1)  at  X(1)  &  C(2)  at  X(N)
!** IER is the error flag.  IER=0  on return if routine successful.
!-----------------------------------------------------------------------

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, IOPT, N4
real(kind=wp), intent(in) :: X(N), Y(N)
real(kind=wp), intent(out) :: C(N4)
integer(kind=iwp), intent(out) :: IER
integer(kind=iwp) :: I, II, IOH, IOL, J, J1, J2, J3, JMP
real(kind=wp) :: A, DY2, DYA, DYB, H, R, XB, XC, YA, YB
logical(kind=iwp) :: Skip

J1 = 0
II = 0
JMP = 1
if (N <= 1) then
  IER = 1000
  return
end if
! Initialization
XC = X(1)
YB = Y(1)
H = Zero
A = Zero
R = Zero
DYB = Zero

! IOL=0 - given derivative at firstpoint
! IOH=0 - given derivative at last point

IOL = IOPT-1
IOH = IOPT-2
if (IOH == 1) then
  IOL = 0
  IOH = 0
end if
DY2 = C(2)

! Form the system of linear equations
! and eliminate subsequentially

J = 1
do I=1,N
  J2 = N+I
  J3 = J2+N
  A = H*(Two-A)
  DYA = DYB+H*R
  Skip = .false.
  if (I >= N) then

    ! set derivative dy2 at last point

    DYB = DY2
    H = Zero
    if (IOH == 0) then
      Skip = .true.
    else
      DYB = DYA
    end if
  else
    J = J+JMP
    XB = XC
    XC = X(J)
    H = XC-XB

    ! II=0 - increasing abscissae
    ! II=1 - decreasing abscissae

    II = 0
    if (H < 0) II = 1
    if (H == 0) then
      IER = 2000
      return
    end if
    YA = YB
    YB = Y(J)
    DYB = (YB-YA)/H
    if (I <= 1) then
      J1 = II
      if (IOL /= 0) then
        Skip = .true.
      else
        DYA = C(1)
      end if
    end if
  end if
  if (.not. Skip) then
    if (J1 /= II) then
      IER = 2000
      return
    end if
    A = One/(H+H+A)
  end if
  R = A*(DYB-DYA)
  C(J3) = R
  A = H*A
  C(J2) = A
  C(I) = DYB
end do

! back substitution of the system of linear equations
! and computation of the other coefficients

A = One
J1 = J3+N+II-II*N
I = N
do IOL=1,N
  XB = X(J)
  H = XC-XB
  XC = XB
  A = A+H
  YB = R
  R = C(J3)-R*C(J2)
  YA = R+R
  C(J3) = YA+R
  C(J2) = C(I)-H*(YA+YB)
  C(J1) = (YB-R)/A
  C(I) = Y(J)
  A = Zero
  J = J-JMP
  I = I-1
  J2 = J2-1
  J3 = J3-1
  J1 = J3+N+II
end do
IER = 0

return

end subroutine LEVEL_SPLINE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Giovanni Li Manni                                *
*               2017, Aron Cohen                                       *
************************************************************************
      Subroutine S12g(mGrid,Rho,nRho,P2_ontop,
     &                nP2_ontop,iSpin,F_xc,
     &                dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,
     &                T_X)
************************************************************************
*                                                                      *
* Object:     Combination of exchange S12g (or S12h) and PBE           *
*             correlation terms                                        *
*             Reference:  Swart, Marcel                                *
*             Chemical Physics Letters 580 (2013) 166-171              *
*                                                                      *
*      Author: G. Li Manni and A. Cohen, Department of Electronic      *
*              Structure Theory, Max Planck Institute, Stuttgart       *
*              2017                                                    *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"

      Real*8 Rho(nRho,mGrid), dF_dRho(ndF_dRho,mGrid),
     &       P2_ontop(nP2_ontop,mGrid), F_xc(mGrid),
     &       dF_dP2ontop(ndF_dP2ontop,mGrid)
      Integer gh_switch
*                                                                      *
************************************************************************
*                                                                      *
*---- Dirac Exchange
*
C      Coeff=1.079966d0
C
C      Call Diracx(mGrid,Rho,nRho,iSpin,F_xc,
C     &            dF_dRho,ndF_dRho,Coeff,T_X)
*
*---- S12g has its LDA part included!
*
      Coeff=1.0d0

      gh_switch = 1
      Call xS12gh(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &          Coeff,iSpin,F_xc,T_X,gh_switch)
*
*---- PBE Correlation
*
      Coeff=1.0d0
      Call CPBE(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &         Coeff,iSpin,F_xc,T_X)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(P2_ontop)
         Call Unused_real_array(dF_dP2ontop)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine NATORB_CPF(D,CM,CMO,DSYM,CAO,OCC,M)

use cpf_global, only: ICH, IPRINT, IROW, NASH, NBAS, NFRO, NISH, NORB, NVIR
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: D(*), CM(*)
real(kind=wp), intent(_OUT_) :: CMO(*), DSYM(*), CAO(*), OCC(*)
integer(kind=iwp), intent(in) :: M
integer(kind=iwp) :: I, II, IJ, IJ0, ILAS, IP, ISTA, J, JP, kp, M1, NBM, NBP, NFR, NI, NIJ, NJ, NORBM, NORBM2
real(kind=wp) :: TERM

! FORM DENSITY MATRIX BY SYMMETRY
NBM = NBAS(M)
if (NBM == 0) return
if (NORB(M) == 0) return
if (IPRINT >= 15) write(u6,1) M
NBP = 0
M1 = M-1
do I=1,M1
  NBP = NBP+NORB(I)
end do
NFR = NFRO(M)
NORBM = NFR+NISH(M)+NASH(M)+NVIR(M)
if (NORBM == 0) return
NORBM2 = IROW(NORBM+1)
DSYM(1:NORBM2) = Zero
II = 0
do I=1,NFR
  II = II+I
  DSYM(II) = Two
end do
! REST OF DENSITY MATRIX
IJ = 0
do I=1,NORBM
  do J=1,I
    IJ = IJ+1
    NI = ICH(NBP+I)
    if (NI < 0) cycle
    NJ = ICH(NBP+J)
    if (NJ < 0) cycle
    NIJ = IROW(NI)+NJ
    if (NJ > NI) NIJ = IROW(NJ)+NI
    DSYM(IJ) = D(NIJ)
  end do
end do
! DIAGONALIZE
call JACSCF(DSYM,CMO,OCC,NORBM,-1,1.0e-11_wp)
OCC(1:NORBM) = -OCC(1:NORBM)
call ORDER(CMO,OCC,NORBM)
if (IPRINT >= 15) write(u6,30)
ILAS = 0
OCC(1:NORBM) = -OCC(1:NORBM)
do I=1,NORBM
  ISTA = ILAS+1
  ILAS = ILAS+NORBM
  if (IPRINT >= 15) write(u6,40) I,OCC(I),(CMO(J),J=ISTA,ILAS)
end do
! TRANSFORM TO AO-BASIS
if (IPRINT >= 15) write(u6,45)
IJ0 = -NORBM
kp = 1
do I=1,NORBM
  IJ0 = IJ0+NORBM

  do IP=1,NBM
    TERM = Zero
    IJ = IJ0
    JP = IP-NBM
    do J=1,NORBM
      IJ = IJ+1
      JP = JP+NBM
      TERM = TERM+CMO(IJ)*CM(JP)
    end do
    CAO(kp+IP-1) = TERM
  end do

  if (IPRINT >= 15) write(u6,40) I,OCC(I),(CAO(IP),IP=kp,kp+nbm-1)
  kp = kp+NBM
end do

return

1 format(///,5X,'SYMMETRY NUMBER',I3)
30 format(//,5X,'NATURAL ORBITALS IN MO-BASIS',//,7X,'OCCUPATION NUMBER',5X,'COEFFICIENTS')
40 format(/,5X,I4,F10.6,5F10.6,/(19X,5F10.6))
45 format(//,5X,'NATURAL ORBITALS IN AO-BASIS',//,11X,'OCCUPATION NUMBER',5X,'COEFFICIENTS')

end subroutine NATORB_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Markus P. Fuelscher                              *
*               1990, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE REORD
     &           (NLEV,NVERT,MIDLEV,MIDV1,MIDV2,NMIDV,MXUP,MXDWN,
     &            IDRT,IDOWN,IDAW,IUP,IRAW,IUSGN,ILSGN,
     &            NEL,NORB,NCONF,NTYP,
     &            IMODE,IPRINT,
     &            ICONF,ISPIN,NCNFTP,NCSFTP,
     &            CIOLD,CINEW,minop)
C
C     AUTHOR:  M.P. FUELSCHER AND J. OLSEN
C              UNIV. OF LUND, SWEDEN 1990
C
C     PURPOSE: CONSTRUCT THE REINDEXING ARRAY WHICH REORDERS
C              THE CSFS GENERATED BY THE DETERMINANT CODE INTO
C              THE SPLIT GRAPH GUGA ORDER.
C              FOR THAT CONSTRUCT FOR EACH CSF THE CORRESPONDING
C              STEP VECTOR AND PASS IT TO THE FUNCTIONS IPHASE
C              AND ISGNUM WHICH COMPUTES THE THE PHASE FACTOR
C              INVOLVED WHEN GOING FROM THE SYMMETRIC TO THE
C              UNITARY GROUP AND THE SPLIT ORDERING NUMBER.
C              FINALLY, THE VECTORS OF CI COEFFICIENTS ARE
C              REORDERED AND, TWO MODE ARE POSSIBLE:
C              IMODE=0 : FROM SYMMETRIC GROUP TO SPLIT GRAPH UGA ORDER
C              IMODE=1 : FROM SPLIT GRAPH UGA TO SYMMETRIC GROUP ORDER
C
C iPhase and iSgnum are clones from rasscf
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION ICONF(*),ISPIN(*),NCNFTP(*),NCSFTP(*)
      DIMENSION CIOLD(NCONF),CINEW(NCONF)
C
      DIMENSION IDRT(NVERT,5)
      DIMENSION IDOWN(NVERT,0:3),IDAW(NVERT,0:4)
      DIMENSION IUP(NVERT,0:3),IRAW(NVERT,0:4)
      DIMENSION IUSGN(MXUP,NMIDV),ILSGN(MXDWN,NMIDV)
      DIMENSION IWALK(50)
C
C
C     LOOP OVER CONFIGURATIONS TYPES
C
      ICSFJP = 0
      ICNBS0 = 0 ! dummy initialize
      IPBAS  = 0 ! dummy initialize
      DO 1000 ITYP = 1, NTYP
        IOPEN = ITYP + MINOP - 1 ! MINOP IS NOT INITIALIZED TEOEAW
        ICL = (NEL - IOPEN) / 2
C       BASE ADRESS FOR CONFIGURATION OF THIS TYPE
        IF( ITYP .EQ. 1 ) THEN
          ICNBS0 = 1
        ELSE
          ICNBS0 = ICNBS0 + NCNFTP(ITYP-1)*(NEL+IOPEN-1)/2
        END IF
C      BASE ADRESS FOR PROTOTYPE SPIN COUPLINGS
        IF( ITYP .EQ. 1 ) THEN
          IPBAS = 1
        ELSE
          IPBAS = IPBAS + NCSFTP(ITYP-1)*(IOPEN-1)
        END IF
C
C     LOOP OVER NUMBER OF CONFIGURATIONS OF TYPE ITYP AND PROTOTYPE
C     SPIN COUPLINGS
C
        DO 900  IC = 1, NCNFTP(ITYP)
          ICNBS = ICNBS0 + (IC-1)*(IOPEN+ICL)
          DO 800 IICSF = 1,NCSFTP(ITYP)
            ICSFJP = ICSFJP + 1
            ICSBAS = IPBAS + (IICSF-1)*IOPEN
C     COMPUTE STEP VECTOR
            CALL STEPVEC(ICONF(ICNBS),ICONF(ICNBS+ICL),ICL,IOPEN,
     &                   ISPIN(ICSBAS),NORB,IWALK)
C     GET SPLIT GRAPH ORDERING NUMBER
C     FUNCTION ISGNUM2
            ISG=ISGNUM2(NLEV,NVERT,MIDLEV,MIDV1,MIDV2,NMIDV,MXUP,
     &                   MXDWN,IDOWN,IUP,IDAW,IRAW,IUSGN,ILSGN,IWALK)
C     GET PHASE PHASE FACTOR
            IP=IPHASE2(NLEV,NVERT,IDRT,IUP,IWALK)
C     NOW REORDER THIS ELEMENT OF THE CI-VECTOR
            PHASE=DBLE(IP)
            IF ( IMODE.EQ.0 ) THEN
               CINEW(ISG)=CIOLD(ICSFJP)*PHASE
            END IF
            IF ( IMODE.EQ.1 ) THEN
               CINEW(ICSFJP)=CIOLD(ISG)*PHASE
            END IF
800       CONTINUE
900     CONTINUE
1000  CONTINUE
C
      IF( IPRINT.GE.5 ) THEN
        LPRINT=NCONF
        WRITE(6,*)
        WRITE(6,*)' OLD CI-VECTORS IN SUBROUTINE REORD'
        WRITE(6,'(10F12.8)') (CIOLD(I),I=1,LPRINT)
        WRITE(6,*)' NEW CI-VECTORS IN SUBROUTINE REORD'
        WRITE(6,'(10F12.8)') (CINEW(I),I=1,LPRINT)
        WRITE(6,*)
      ENDIF
C
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine WRTVCD(SEGMNT,LU,IREW,LBLK)
! PRINT VECTOR ON FILE LU
!
! LBLK DEFINES STRUCTURE OF FILES :

use lucia_data, only: IDISK
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: SEGMNT(*)
integer(kind=iwp), intent(in) :: LU, IREW, LBLK
integer(kind=iwp) :: IAMPACK, IBLK, IDUMMY(1), IMZERO, KBLK, LBL

if (IREW /= 0) then
  if (LBLK >= 0) then
    IDISK(LU) = 0
  else
    IDISK(LU) = 0
  end if
end if
! LOOP OVER BLOCKS

IBLK = 0
do
  if (LBLK > 0) then
    LBL = LBLK
  else if (LBLK == 0) then
    call IDAFILE(LU,2,IDUMMY,1,IDISK(LU))
    LBL = IDUMMY(1)
  else
    call IDAFILE(LU,2,IDUMMY,1,IDISK(LU))
    LBL = IDUMMY(1)
    call IDAFILE(LU,2,IDUMMY,1,IDISK(LU))
  end if
  IBLK = IBLK+1
  if (LBL >= 0) then
    if (LBLK >= 0) then
      KBLK = LBL
    else
      KBLK = -1
    end if
    call FRMDSC(SEGMNT,LBL,KBLK,LU,IMZERO,IAMPACK)
    if (LBL > 0) then
      write(u6,'(A,I3,A,I6)') ' Number of elements in segment ',IBLK,' IS ',LBL
      call WRTMAT(SEGMNT,1,LBL,1,LBL)
    end if
  end if

  if ((LBL < 0) .or. (LBLK > 0)) exit
end do

end subroutine WRTVCD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine TPQSET(ICASE,TPQ,IP)

use cpf_global, only: INCPF, IPRINT, IRC, IREF0, ISDCI, LN, LWSP, N
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICASE(*), IP
real(kind=wp), intent(_OUT_) :: TPQ(*)
integer(kind=iwp) :: I, II, II1, IINT, IIOR, IJ, IK, IL, IOCR(100), IQ, JJ, JOJ, NI, NJ
real(kind=wp) :: DIK, DIL, DJK, DJL
integer(kind=iwp), external :: ICUNP

IIOR = 0
II1 = (IREF0-1)*LN
do I=1,LN
  JOJ = ICUNP(ICASE,II1+I)
  IIOR = IIOR+1
  IOCR(IIOR) = JOJ
end do

IINT = IRC(4)
do IQ=1,IINT
  TPQ(IQ) = One
  if (INCPF == 1) TPQ(IQ) = Two/N
  if ((IQ == IREF0) .or. (IP == IREF0)) TPQ(IQ) = Zero
end do
if ((ISDCI == 1) .or. (INCPF == 1) .or. (IP == IREF0)) return

II = 0
IJ = 0
do I=1,LN
  JJ = (IP-1)*LN+I
  if ((ICUNP(ICASE,JJ) == IOCR(I)) .or. (ICUNP(ICASE,JJ) == 3)) cycle
  if (LWSP .and. (ICUNP(ICASE,JJ)*IOCR(I) == 2)) cycle
  if (II == 0) II = I
  IJ = I
end do
NI = IOCR(II)
if (NI > 1) NI = NI-1
NJ = IOCR(IJ)
if (NJ > 1) NJ = NJ-1
do IQ=1,IINT
  IK = 0
  IL = 0
  do I=1,LN
    JJ = (IQ-1)*LN+I
    if ((ICUNP(ICASE,JJ) == IOCR(I)) .or. (ICUNP(ICASE,JJ) == 3)) cycle
    if (LWSP .and. (ICUNP(ICASE,JJ)*IOCR(I) == 2)) cycle
    if (IK == 0) IK = I
    IL = I
  end do
  DIK = Zero
  DIL = Zero
  DJK = Zero
  DJL = Zero
  if (II == IK) DIK = One
  if (II == IL) DIL = One
  if (IJ == IK) DJK = One
  if (IJ == IL) DJL = One
  TPQ(IQ) = (DIK+DIL)/(Two*NI)+(DJK+DJL)/(Two*NJ)
  if (IQ == IREF0) TPQ(IQ) = Zero
end do
if (IPRINT > 15) write(u6,11) (TPQ(IQ),IQ=1,IINT)

return

11 format(5X,'TPQ',10F5.2)

end subroutine TPQSET

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Merge_Lists(Mode,nAt)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
character, intent(in) :: Mode
integer(kind=iwp), intent(in) :: nAt
integer(kind=iwp) :: i_1, i_2, i_P, i_R, iOff_1, iOff_2, iOff_3, iOff_Iter, ipCx_1, ipCx_2, ipCx_P, ipCx_R, ipEner_1, ipEner_2, &
                     ipEner_P, ipEner_R, ipGx_1, ipGx_2, ipGx_P, ipGx_R, iter_1, iter_2, iter_3, iter_P, iter_R, n1, n2
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: rList(:,:)
integer(kind=iwp), allocatable :: iList(:,:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Get the sizes of the arrays on the runfile. Same size for both files.

call qpg_iArray('Slapaf Info 1',Found,n1)
call qpg_dArray('Slapaf Info 2',Found,n2)
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over both files and pick up the fields and pick up pointers,
! and interations counts.

call mma_allocate(iList,n1,2,label='iList')
call mma_allocate(rList,n2,2,label='rList')
call NameRun('RUNREAC')
call Get_iArray('Slapaf Info 1',iList(1,1),n1)
call Get_dArray('Slapaf Info 2',rList(1,1),n2)
i_R = 1
iter_R = iList(2,1)
ipEner_R = 1+iList(5,1)
ipCx_R = 1+iList(6,1)
ipGx_R = 1+iList(7,1)
call NameRun('RUNPROD')
call Get_iArray('Slapaf Info 1',iList(1,2),n1)
call Get_dArray('Slapaf Info 2',rList(1,2),n2)
i_P = 2
iter_P = iList(2,2)
ipEner_P = 1+iList(5,2)
ipCx_P = 1+iList(6,2)
ipGx_P = 1+iList(7,2)
!                                                                      *
!***********************************************************************
!                                                                      *
! Translate into generic variables, _1=from, _2=to.

if (Mode == 'R') then
  i_1 = i_P
  iter_1 = iter_P
  ipEner_1 = ipEner_P
  ipCx_1 = ipCx_P
  ipGx_1 = ipGx_P

  i_2 = i_R
  iter_2 = iter_R
  ipEner_2 = ipEner_R
  ipCx_2 = ipCx_R
  ipGx_2 = ipGx_R
else
  i_1 = i_R
  iter_1 = iter_R
  ipEner_1 = ipEner_R
  ipCx_1 = ipCx_R
  ipGx_1 = ipGx_R

  i_2 = i_P
  iter_2 = iter_P
  ipEner_2 = ipEner_P
  ipCx_2 = ipCx_P
  ipGx_2 = ipGx_P
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Start moving stuff around

! Update iteration counter

iter_3 = iter_2+1
iList(2,i_2) = iter_3
iOff_1 = (iter_1-1)*3*nAt
iOff_2 = (iter_2-1)*3*nAt
iOff_3 = (iter_3-1)*3*nAt

! Move the last item(s) in the "to" file up one step.

rList(ipEner_2+iter_3-1,i_2) = rList(ipEner_2+iter_2-1,i_2)
rlist(ipCx_2+iOff_3:ipCx_2+iOff_3+3*nAt-1,i_2) = rList(ipCx_2+iOff_2:ipCx_2+iOff_2+3*nAt-1,i_2)
rlist(ipGx_2+iOff_3:ipGx_2+iOff_3+3*nAt-1,i_2) = rList(ipGx_2+iOff_2:ipGx_2+iOff_2+3*nAt-1,i_2)

! Copy the last item(s) in the "from" file into the
! second last position of the "to" file.

rList(ipEner_2+iter_2-1,i_2) = rList(ipEner_1+iter_1-1,i_1)
rlist(ipCx_2+iOff_2:ipCx_2+iOff_2+3*nAt-1,i_2) = rList(ipCx_1+iOff_1:ipCx_1+iOff_1+3*nAt-1,i_1)
rlist(ipGx_2+iOff_2:ipGx_2+iOff_2+3*nAt-1,i_2) = rList(ipGx_1+iOff_1:ipGx_1+iOff_1+3*nAt-1,i_1)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out the stuff on the appropriate run file.

if (Mode == 'R') then
  call NameRun('RUNREAC')
else
  call NameRun('RUNPROD')
end if

call Put_iArray('Slapaf Info 1',iList(1,i_2),n1)
call Put_dArray('Slapaf Info 2',rList(1,i_2),n2)
call qpg_iScalar('iOff_Iter',Found)
if (Found) then
  call Get_iScalar('iOff_Iter',iOff_Iter)
  call Put_iScalar('iOff_Iter',iOff_Iter+1)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate the memory allocations.

call mma_deallocate(rList)
call mma_deallocate(iList)
!                                                                      *
!***********************************************************************
!                                                                      *
! Open the default run file.

call NameRun('RUNFILE')
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Merge_Lists

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      !> Read information provided on runfile/jobiph files and
      !> initialize pt2wfn file
      subroutine pt2init(refwfnfile)

#ifdef _DMRG_
      use qcmaquis_info
#endif
#ifdef _HDF5_QCM_
      use hdf5_utils
#endif
      use refwfn
      use nevpt2_cfg
      use info_state_energy  ! energies
      use info_orbital_space ! orbital specifications read from JobIph
      use nevpt2wfn
      implicit none

      character(len=*), intent(in) :: refwfnfile

      integer :: istate,ii,j,nDiff,nishprev,nfroprev

      integer, allocatable :: nCore_local(:)
      real*8, allocatable :: readbuf(:,:)
#include "mxdm.fh"
#include "caspt2.fh"

      ! call the Molcas routine to check whether we're using Cholesky
      call DecideOnCholesky(do_cholesky)
      ! read some stuff from RunFile, just as CASPT2 does
      Call Get_iScalar('nSym',nSym)
      ! Symmetry with Cholesky decomposition is not supported yet!
      if ( (nSym.gt.1) .and. do_cholesky) then
        call WarningMessage(1, "Symmetry with Cholesky decomposition"//
     &    " is not supported yet!")
        Call Quit_OnUserError()
      end if
      write (6,*) "Cholesky Decomposition: ",
     &    merge("Enabled ", "Disabled", do_cholesky)

      !> set up AO basis information (needed for post-NEVPT2 information transfer)
      Call Get_iArray('nBas',nBas,nSym)
      nbast=sum(nbas(1:nsym))
      nbsqt=sum(nbas(1:nsym)**2)

      !> TODO: Read more stuff, such as the information about the active
      !> space from the JobIph file, or at least add some consistency checks

      !> open files in analogy to CASPT2
      LUONEM=16
      CALL DANAME_wa(LUONEM,'MOLONE')

      Call refwfn_init(refwfnfile)
      Call refwfn_info
      Call refwfn_data
      Call refwfn_close

      !> fill nevpt2 confuguration variables from caspt2.fh commons
      !> ----------------------------------------------------------

      !> check if nr_states has been requested as 'all'
      if(nr_states == 0)then
        if(allocated(MultGroup%State)) deallocate(MultGroup%State)
        !> nstate from common block in caspt2.fh
        nr_states = nstate
        allocate(MultGroup%State(nr_states))
        do istate = 1, nr_states
          MultGroup%State(istate) = istate
        end do
      end if

      !> spin & number of active electrons
      nspin               = ispin
      nr_active_electrons = nactel

      write (6,'(/a)')   " Wavefunction parameters for NEVPT2"
      write (6,'(a )')   " ----------------------------------"
      write (6,'(a,i4)') " Number of active electrons ....... ",
     & nr_active_electrons
      write (6,'(a,i4)') " Spin ............................. ", nspin

      ! read the info about orbital spaces and initialise
      ! the NEVPT2 inforb array

      ! Read orbital specifications and store them in the inforb_molcas
      ! variable from info_orbital_space


      ! nish, nash and nssh are in caspt2.fh (Common /INPI/ and have been
      ! read by the refwfn module
      call initialize_inforb_molcas(nSym)


      if (maxval(nfro).ne.0) then
      ! Leon: a workaround if frozen orbitals in MCSCF have been detected:
      ! MCSCF frozen orbitals MUST count as active here and then added
      ! to igelo(:) later, otherwise the orbital numbers do not match!
         write (6, *) 'Frozen orbitals in MCSCF detected.'
         inforb_molcas%nish(1:nSym)=nfro(1:nSym)+nish(1:nSym)
      else
         inforb_molcas%nish(1:nSym)=nish(1:nSym)
      end if

      ! Read frozen orbitals from ijkl.h5 files produced by MOTRA
      ! we need this information now to calculate the number of frozen
      ! orbitals correctly

      ! warning! are we sure that nsym here is the same as nsym in hdf5?


      ! is norb from MOTRA the same as nBas or not? or is it nBas-nfro-ndel?
      ! In any case, we're reading the value from MOTRA just to be consistent
#ifdef _HDF5_QCM_
      call hdf5_init()
      call hdf5_open(ijklname, file_id(2)) ! open ijkl.h5
      datadim(1)   = nsym
      allocate(readbuf(nsym,3)); readbuf = -1
      call hdf5_get_data(file_id(2),"norb  ",datadim,readbuf(1,1))
      call hdf5_get_data(file_id(2),"nfro  ",datadim,readbuf(1,2))
      call hdf5_get_data(file_id(2),"ndel  ",datadim,readbuf(1,3))
      inforb_molcas%norb(1:nSym) = nint(readbuf(1:nSym,1))
      inforb_molcas%nfro(1:nSym) = nint(readbuf(1:nSym,2))
      inforb_molcas%ndel(1:nSym) = nint(readbuf(1:nSym,3))
      deallocate(readbuf)

      call hdf5_close(file_id(2)) ! close ijkl.h5
      call hdf5_exit()
#else
      ! Should never be the case!
      call WarningMessage(1,"HDF5 QCMaquis interface not enabled, "//
     &  "cannot continue!")
      call Abend()
#endif
      ! Detect frozen orbitals from reference wavefunction, if there was
      ! no input wrt frozen orbitals


      if (.not.allocated(igelo)) then
        if (nr_frozen_orb.ne.-1) then
        ! Autodetect frozen orbitals:


        ! If nr_frozen_orb is set to -1 in rdinput()
        ! it's to signal that # of frozen orbs has
        ! been forcibly set to 0
        ! no allocated frozen orbitals -> no frozen input
        ! hence try to guess frozen orbitals from reference wavefunction


        ! Correct the # of frozen orbitals just as it is done in CASPT2
          allocate(nCore_local(nSym))
          Call Get_iArray('Non valence orbitals',nCore_local,nSym)
          Do ii = 1, nSym
            If (nCore_local(ii).gt.nFro(ii)) Then
              nDiff=nCore_local(ii)-nFro(ii)
              nDiff=min(nDiff,nISh(ii))
              nFro(ii)=nFro(ii)+nDiff
              nISh(ii)=nISh(ii)-nDiff
            End If
          End Do
          deallocate(nCore_local)

          ! Check if orbitals have been frozen in MOTRA
          if (maxval(inforb_molcas%nfro(1:nSym)).gt.0) then
            do ii = 1, nSym
              nFro(ii) = nFro(ii) - inforb_molcas%nfro(ii)
              if (nFro(ii).lt.0) then
                call WarningMessage(1,"Warning: Additional frozen "//
     &            "orbitals in MOTRA.")
                nFro(ii) = 0
              end if
            end do
          end if

          ! calculate total # of frozen orbitals
          nr_frozen_orb = 0
          do ii = 1, nSym
            nr_frozen_orb = nr_frozen_orb + nFro(ii)
          end do

          allocate(igelo(nr_frozen_orb))
          ! fill igelo by symmetry
          !! TODO: Check here for what has been frozen in MOTRA and subtract it (!!)
          do ii=1, nSym
            nishprev=merge(0,nfro(ii-1)+nish(ii-1),ii.eq.1)
            nfroprev=merge(0,nfro(ii-1),ii.eq.1)
            do j=1,nfro(ii)
              igelo(nfroprev+j)=nishprev+j
            end do
          end do
        else
          ! Reset nr_frozen_orb back to 0, as we have been signalled with
          ! nr_frozen_orb = -1 from rdinput that frozen orbs have been forcibly
          ! reset to zero
          nr_frozen_orb = 0
        end if
        else
          if (maxval(inforb_molcas%nfro(1:nSym)).gt.0) then
            call WarningMessage(2,"Warning: Orbitals have been "//
     &        "frozen in MOTRA and manual freeze specification "//
     &        "has been provided in NEVPT2 input. Make sure "//
     &        "you're not double-counting the frozen orbitals!")
        end if
      end if

      inforb_molcas%nash(1:nSym)=nash(1:nSym)
      inforb_molcas%nssh(1:nSym)=nssh(1:nSym)
      inforb_molcas%nbas(1:nSym)=nbas(1:nSym)
      inforb_molcas%nbast       = nbast
      inforb_molcas%ncmo        = ncmo
      inforb_molcas%nbsqt       = nbsqt

      if (maxval(inforb_molcas%nfro(1:nSym)).gt.0) then
        write (6,'(a,8(18i4))') " Frozen orbitals from MOTRA ....... ",
     &               (inforb_molcas%nfro(ii),ii=1,nSym)
      end if

      write (6,'(a,8(18i4))') " Inactive orbitals ................ ",
     &               (inforb_molcas%nish(ii),ii=1,nSym)
      write (6,'(a,8(18i4))') " Active orbitals .................. ",
     &               (inforb_molcas%nash(ii),ii=1,nSym)
      write (6,'(a,8(18i4))') " Secondary orbitals ............... ",
     &               (inforb_molcas%nssh(ii),ii=1,nSym)

      if (maxval(inforb_molcas%ndel(1:nSym)).gt.0) then
        write (6,'(a,8(18i4))') " Deleted orbitals from MOTRA..... ",
     &               (inforb_molcas%ndel(ii),ii=1,nSym)
      end if

      write (6,'(a/)')   " ----------------------------------"

      call init_energies(nr_states)

      write (6,'(a)') " Energies of zeroth-order DMRG wavefunction(s)"
      write (6,'(a)') " ---------------------------------------------"
      do istate = 1, nr_states
        !> copy reference energies
        e(istate) = refene(MultGroup%State(istate))
        write (6,'(a,i4,a,f18.8)') " State ...",MultGroup%State(istate),
     &         " ... Energy = ",e(istate)
      end do
      write (6,'(a/)')" ---------------------------------------------"

#ifdef _DMRG_
      if(allocated(qcm_group_names))then
        write (6,'(a)') " DMRG wavefunction data will be read from"
        write (6,'(a)') " ----------------------------------------"
        if(.not.allocated(MultGroup%h5_file_name))
     &  allocate(MultGroup%h5_file_name(nr_states))
        MultGroup%h5_file_name = ''
        do istate = 1, nr_states
          MultGroup%h5_file_name(istate) =
     &    trim(qcm_group_names(1)%states(MultGroup%State(istate)))
          !> copy reference wfn file names
          write (6,'(a,i4,a,a)') " State ...",MultGroup%State(istate),
     &           " .......................... ",
     &          trim(qcm_group_names(1)%states(MultGroup%State(istate)))
        end do
        write (6,'(a/)')" ----------------------------------------"
      end if
#endif

      !> Create the PT2 wavefunction file. The reference file should not be active,
      !> as it might be the same file (in which case it is overwritten).
      call nevpt2wfn_init(.true.)
      call nevpt2wfn_data

      end subroutine pt2init

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE AdToR2_MCLR(RHO2,RHO2T,ITYPE,
     &                  NI,IOFF,NJ,JOFF,NK,KOFF,NL,LOFF,NORB)
*
* Add contributions to two electron density matrix RHO2
* output density matrix is in the form Rho2(ij,kl),(ij).ge.(kl)
*
*
* Jeppe Olsen, Fall of 96
*
*
* Itype = 1 => alpha-alpha or beta-beta loop
*              input is in form Rho2t(ik,jl)
* Itype = 2 => alpha-beta loop
*              input is in form Rho2t(ij,kl)
*
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
      DIMENSION RHO2T(*)
*. Input and output
      DIMENSION RHO2(*)
*
      I       = 0     ! dummy initialize
      J       = 0     ! dummy initialize
      K       = 0     ! dummy initialize
      L       = 0     ! dummy initialize
      NII     = 0     ! dummy initialize
      NJJ     = 0     ! dummy initialize
      NKK     = 0     ! dummy initialize
      NLL     = 0     ! dummy initialize
      IIOFF   = 0     ! dummy initialize
      JJOFF   = 0     ! dummy initialize
      KKOFF   = 0     ! dummy initialize
      LLOFF   = 0     ! dummy initialize
      SIGN    = 0.0D0 ! dummy initialize
      IACTIVE = 0     ! dummy initialize
*
      NTEST = 000
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Welcome to ADTOR2 '
        WRITE(6,*) ' ================='
        WRITE(6,*) ' NI NJ NK NL = ', NI,NJ,NK,NL
        WRITE(6,*) ' IOFF JOFF KOFF LOFF =',IOFF,JOFF,KOFF,LOFF
        WRITE(6,*) ' ITYPE = ',ITYPE
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' Initial two body density matrix '
          CALL PRSYM(RHO2,NORB**2)
        END IF
        WRITE(6,*) ' RHO2T : '
*       IF(ITYPE.EQ.1) THEN
*         IF(IOFF.EQ.KOFF) THEN
*           NROW = NI*(NI+1)/2
*         ELSE
*           NROW = NI*NK
*         END IF
*         IF(JOFF.EQ.LOFF) THEN
*           NCOL = NJ*(NJ+1)/2
*         ELSE
*           NCOL = NJ*NL
*         END IF
*       ELSE IF (ITYPE.EQ.2) THEN
*         NROW = NI*NJ
*         NCOL = NK*NL
*       END IF
*       CALL WRTMAT(RHO2T,NROW,NCOL,NROW,NCOL)
      END IF
*
      IF(ITYPE.EQ.1) THEN
*
* =======================================
*     Alpha-alpha or beta-beta term
* =======================================
*
*. Four permutations
      DO IPERM = 1, 4
        IF(IPERM.EQ.1) THEN
          NII = NI
          IIOFF = IOFF
          NJJ = NJ
          JJOFF = JOFF
          NKK = NK
          KKOFF = KOFF
          NLL = NL
          LLOFF = LOFF
          SIGN = 1.0D0
          IACTIVE = 1
        ELSE IF(IPERM.EQ.2) THEN
          IF(IOFF.NE.KOFF) THEN
            NII = NK
            IIOFF = KOFF
            NKK = NI
            KKOFF = IOFF
            NJJ = NJ
            JJOFF = JOFF
            NLL = NL
            LLOFF = LOFF
            IACTIVE = 1
          ELSE
            IACTIVE = 0
          END IF
          SIGN = -1.0D0
        ELSE IF(IPERM.EQ.3) THEN
          IF(JOFF.NE.LOFF) THEN
            NII = NI
            IIOFF = IOFF
            NKK = NK
            KKOFF = KOFF
            NJJ = NL
            JJOFF = LOFF
            NLL = NJ
            LLOFF = JOFF
            SIGN = -1.0D0
            IACTIVE = 1
          ELSE
            IACTIVE = 0
          END IF
        ELSE IF(IPERM.EQ.4) THEN
          IF(IOFF.NE.KOFF.AND.JOFF.NE.LOFF) THEN
            NKK = NI
            KKOFF = IOFF
            NII = NK
            IIOFF = KOFF
            NJJ = NL
            JJOFF = LOFF
            NLL = NJ
            LLOFF = JOFF
            SIGN = 1.0D0
            IACTIVE = 1
          ELSE
            IACTIVE = 0
          END IF
        END IF
*
C       IJOFF = (JJOFF-1)*NORB+IIOFF
C       KLOFF = (LLOFF-1)*NORB+KKOFF
C       IF(IACTIVE.EQ.1.AND.IJOFF.GE.KLOFF) THEN
        IF(IACTIVE.EQ.1) THEN
            DO II = 1, NII
              DO JJ = 1, NJJ
                DO KK = 1, NKK
                  DO LL = 1, NLL
                    IJ = (JJ+JJOFF-2)*NORB + II+IIOFF - 1
                    KL = (LL+LLOFF-2)*NORB + KK+KKOFF - 1
                    IF(IJ.GE.KL) THEN
                      IJKL = IJ*(IJ-1)/2+KL
                      IF(IPERM.EQ.1) THEN
                        I = II
                        K = KK
                        J = JJ
                        L = LL
                      ELSE IF(IPERM.EQ.2) THEN
                        I = KK
                        K = II
                        J = JJ
                        L = LL
                      ELSE IF(IPERM.EQ.3) THEN
                        I = II
                        K = KK
                        J = LL
                        L = JJ
                      ELSE IF(IPERM.EQ.4) THEN
                        I = KK
                        K = II
                        J = LL
                        L = JJ
                      END IF
                      IF(IOFF.NE.KOFF) THEN
                        IKIND = (K-1)*NI+I
                        NIK = NI*NK
                        SIGNIK = 1.0D0
                      ELSE
                        IKIND = MAX(I,K)*(MAX(I,K)-1)/2+MIN(I,K)
                        NIK = NI*(NI+1)/2
                        IF(I.EQ.MAX(I,K)) THEN
                          SIGNIK = 1.0D0
                        ELSE
                          SIGNIK = -1.0D0
                        END IF
                      END IF
                      IF(JOFF.NE.LOFF) THEN
                        JLIND = (L-1)*NJ+J
                        SIGNJL = 1.0D0
                      ELSE
                        JLIND = MAX(J,L)*(MAX(J,L)-1)/2+MIN(J,L)
                        IF(J.EQ.MAX(J,L)) THEN
                          SIGNJL = 1.0D0
                        ELSE
                          SIGNJL = -1.0D0
                        END IF
                      END IF
                      IKJLT = (JLIND-1)*NIK+IKIND
                      RHO2(IJKL) = RHO2(IJKL)
     &                           - SIGN*SIGNJL*SIGNIK*
     &                             RHO2T(IKJLT)
*. The minus : Rho2t comes as <a+i a+k aj al>, but we want
* <a+ia+k al aj>
                    END IF
                  END DO
                END DO
              END DO
            END DO
*. End of active/inactive if
        END IF
*. End of loop over permutations
      END DO
      ELSE IF(ITYPE.EQ.2) THEN
*
* =======================================
*     Alpha-alpha or beta-beta term
* =======================================
*
      DO I = 1, NI
       DO J = 1, NJ
         DO K = 1, NK
           DO L = 1, NL
             IJ = (J+JOFF-2)*NORB + I+IOFF - 1
             KL = (L+LOFF-2)*NORB + K+KOFF - 1
             IF(IJ.EQ.KL) THEN
               FACTOR = 2.0D0
             ELSE
               FACTOR= 1.0D0
             END IF
             IJKL = MAX(IJ,KL)*(MAX(IJ,KL)-1)/2+MIN(IJ,KL)
             IJKLT = (L-1)*NJ*NK*NI+(K-1)*NJ*NI
     &             + (J-1)*NI + I
             RHO2(IJKL) = RHO2(IJKL) + FACTOR*RHO2T(IJKLT)
            END DO
          END DO
        END DO
      END DO
*
      Else If (itype.eq.3) Then
      DO I = 1, NI
       DO J = 1, NJ
         DO K = 1, NK
           DO L = 1, NL
             IJ = (J+JOFF-2)*NORB + I+IOFF - 1
             KL = (L+LOFF-2)*NORB + K+KOFF - 1
*            IJKL = MAX(IJ,KL)*(MAX(IJ,KL)-1)/2+MIN(IJ,KL)
             IJKL=(IJ-1)*NORB**2+KL
             IJKLT = (L-1)*NJ*NK*NI+(K-1)*NJ*NI
     &             + (J-1)*NI + I
             RHO2(IJKL) = RHO2(IJKL) + RHO2T(IJKLT)
            END DO
          END DO
        END DO
      END DO

      END IF
*
*     i=1
*     j=4
*     k=5
*     l=6
*     iA1=itri((i-1)*nOrb+j,(k-1)*nOrb+l)
*     iA2=itri((j-1)*nOrb+i,(k-1)*nOrb+l)
*     iA3=itri((i-1)*nOrb+j,(l-1)*nOrb+k)
*     iA4=itri((j-1)*nOrb+i,(l-1)*nOrb+k)
*     rfel=RHO2(ia1)+RHO2(ia2)+RHO2(ia3)+RHO2(ia4)
*     IF(rfel.NE.0.0D0) THEN
*         Write(*,*) 'STOP'
*     END IF
*     IF(NTEST.GE.1000) THEN
*        WRITE(6,*) ' Updated two-body density matrix '
*        CALL PRSYM(RHO2,NORB**2)
*     END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine transadd(n,a,lda)
      ! Add the transpose to a square matrix, A := A + A^T

      implicit none

      ! dummy arguments
      integer, intent(in) :: n, lda
      real*8, intent(inout) :: a(lda,*)

      ! small buffer block
      integer, parameter :: nblksz = 8

      ! number of blocks, remaining elements
      integer :: nblk, nrem
      integer :: iblk, jblk, ista, jsta, i, j

      nblk = n / nblksz
      nrem = n - nblk * nblksz

      ! loop over diagonal blocks
      do iblk = 1,nblk
        ista = nblksz * (iblk-1) + 1
        ! add transposed upper to lower triangular part
        do i = 1,nblksz
          do j = 1,i
            a(ista+i-1,ista+j-1) = a(ista+i-1,ista+j-1) +
     &       a(ista+j-1,ista+i-1)
          end do
        end do
        ! copy lower to upper part
        do i = 1,nblksz
          do j = 1,i-1
            a(ista+j-1,ista+i-1) = a(ista+i-1,ista+j-1)
          end do
        end do
      end do
      ! the tail block
      ista = nblksz * nblk + 1
      ! add transposed upper to lower triangular part
      do i = 1,nrem
        do j = 1,i
          a(ista+i-1,ista+j-1) = a(ista+i-1,ista+j-1) +
     &     a(ista+j-1,ista+i-1)
        end do
      end do
      ! copy lower to upper part
      do i = 1,nrem
        do j = 1,i-1
          a(ista+j-1,ista+i-1) = a(ista+i-1,ista+j-1)
        end do
      end do

      ! loop over lower triangular blocks
      do iblk = 1,nblk
        ista = nblksz * (iblk-1) + 1
        do jblk = 1,iblk-1
          jsta = nblksz * (jblk-1) + 1
          ! add transposed upper to lower triangular block
          do j = 1,nblksz
            do i = 1,nblksz
              a(ista+i-1,jsta+j-1) = a(ista+i-1,jsta+j-1) +
     &         a(jsta+j-1,ista+i-1)
            end do
          end do
          ! copy transpose of lower to upper triangular block
          do j = 1,nblksz
            do i = 1,nblksz
              a(jsta+i-1,ista+j-1) = a(ista+j-1,jsta+i-1)
            end do
          end do
        end do
      end do
      ! bottom blocks
      ista = nblksz * nblk + 1
      do jblk = 1,iblk-1
        jsta = nblksz * (jblk-1) + 1
        ! add transposed upper to lower triangular block
        do j = 1,nblksz
          do i = 1,nrem
            a(ista+i-1,jsta+j-1) = a(ista+i-1,jsta+j-1) +
     &       a(jsta+j-1,ista+i-1)
          end do
        end do
        ! copy transpose of lower to upper triangular block
        do j = 1,nrem
          do i = 1,nblksz
            a(jsta+i-1,ista+j-1) = a(ista+j-1,jsta+i-1)
          end do
        end do
      end do

      end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_grc32c(a,b,c,mvec,ssa,ssb,pbar,ix)

use CCT3_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
type(Map_Type), intent(in) :: a, b
type(Map_Type), intent(inout) :: c
integer(kind=iwp), intent(out) :: mvec(4096,7), ix
integer(kind=iwp), intent(in) :: ssa, ssb, pbar
integer(kind=iwp) :: ia, ib, ic, nhelp1, nhelp2, nhelp21, nhelp22, nhelp3, nhelp4, nsyma2, ntest1, posct, sa1, sa12, sa2, sa3, &
                     sb1, sb2

!1*

if (pbar == 1) then

  ! structure A(p,qr)*B(qr)=y(p)
  ! implemented in grc32y

else if (pbar == 2) then

  ! structure A(pq,r)*B(r,s)=C(pq,s)

  !1.0 prepare c%d,c%i

  call cct3_grc0(3,a%d(0,6),a%d(0,1),a%d(0,2),b%d(0,2),0,mmul(ssa,ssb),c,posct)

  !1.1 define limitations - p>q,r must be tested - ntest1

  if (a%d(0,6) == 1) then
    ntest1 = 1
  else
    ntest1 = 0
  end if

  !1.2 def symm states and test the limitations

  ix = 0
  do sa1=1,nsym
    if (ntest1 == 1) then
      nsyma2 = sa1
    else
      nsyma2 = nsym
    end if

    do sa2=1,nsyma2
      sa12 = mmul(sa1,sa2)

      sa3 = mmul(ssa,sa12)
      sb1 = sa3

      sb2 = mmul(ssb,sb1)

      !1.3 def mvec,c%d and c%i

      ia = a%i(sa1,sa2,1)
      ib = b%i(sb1,1,1)
      ic = c%i(sa1,sa2,1)

      ! yes/no
      if ((a%d(ia,2) > 0) .and. (b%d(ib,2) > 0)) then
        nhelp1 = 1
      else
        cycle
      end if

      ! rowA
      nhelp21 = dimm(a%d(0,1),sa1)
      nhelp22 = dimm(a%d(0,2),sa2)
      if ((ntest1 == 1) .and. (sa1 == sa2)) then
        nhelp2 = nhelp21*(nhelp21-1)/2
      else
        nhelp2 = nhelp21*nhelp22
      end if

      ! colB
      nhelp3 = dimm(b%d(0,2),sb2)

      ! sum
      nhelp4 = dimm(a%d(0,3),sa3)

      ix = ix+1
      mvec(ix,1) = nhelp1
      mvec(ix,2) = a%d(ia,1)
      mvec(ix,3) = b%d(ib,1)
      mvec(ix,4) = c%d(ic,1)
      mvec(ix,5) = nhelp2
      mvec(ix,6) = nhelp4
      mvec(ix,7) = nhelp3

    end do
  end do

end if

return

end subroutine cct3_grc32c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GETINC_ABS(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                  IXCHNG,IKSM,JLSM,INTLST,IJKLOF,NSMOB,
     &                  ICOUL )
*
* Obtain integrals
* ICOUL = 0 :      XINT(IK,JL) = (IJ!KL) for IXCHNG = 0
*                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
* ICOUL = 1 :      XINT(IJ,KL) = (IJ!KL)
*
* Version for integrals stored in INTLST
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "detdim.fh"
#include "orbinp_mclr.fh"
      Real * 8 Intlst(*)
      Dimension IJKLof(NsmOB,NsmOb,NsmOB)
      DIMENSION XINT(*)
      iOrb=NTSOB(ITP,ISM)
      jOrb=NTSOB(JTP,JSM)
      kOrb=NTSOB(KTP,KSM)
      lOrb=NTSOB(LTP,LSM)
      iOff=IBTSOB(ITP,ISM)
      jOff=IBTSOB(JTP,JSM)
      kOff=IBTSOB(KTP,KSM)
      lOff=IBTSOB(LTP,LSM)
*
*     Collect Coulomb terms
*
      IF(ICOUL.EQ.0) THEN
      iint=1
      Do lBas=lOff,lOff+lOrb-1
        Do jBas=jOff,jOff+jOrb-1
          Do kBas=kOff,kOff+kOrb-1
            Do iBas=iOff,iOff+iOrb-1
              jINT = (lBas-1)*nACOB**3
     &              +(kBas-1)*nACOB**2
     &              +(jBas-1)*nACOB
     &              + iBas
              Xint(iInt) = Intlst(jint)
              iInt=iInt+1
            End Do
          End Do
        End Do
      End Do
*
*     Collect Exchange terms
*
      If ( IXCHNG.ne.0 ) Then
        iint=1
        Do lBas=lOff,lOff+lOrb-1
          Do jBas=joff,jOff+jOrb-1
            Do kBas=kOff,kOff+kOrb-1
              Do iBas=ioff,iOff+iOrb-1
              jINT = (jBas-1)*nACOB**3
     &              +(kBas-1)*nACOB**2
     &              +(lBas-1)*nACOB
     &              + iBas
                XInt(iInt)=XInt(iInt)-Intlst(jint)
                iInt=iInt+1
              End Do
            End Do
          End Do
        End Do
      End If
      ELSE IF(ICOUL.NE.0) THEN
        iint=0
        Do lBas=lOff,lOff+lOrb-1
          Do kBas=kOff,kOff+kOrb-1
           Do jBas=joff,jOff+jOrb-1
            Do iBas=ioff,iOff+iOrb-1
              JINT = (LBAS-1)*nACOB**3
     &              + (KBAS-1)*nACOB**2
     &              + (JBAS-1)*nACOB
     &              +  IBAS
              Xint(iInt) = Intlst(jint)
              iInt=iint+1
            End Do
          End Do
        End Do
      End Do
      END IF
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(IKSM)
        Call Unused_integer(JLSM)
        Call Unused_integer_array(IJKLOF)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Reset_NQ_Grid()

use Grid_On_Disk, only: Final_Grid, iGrid_Set
use nq_Info, only: Crowding, L_Quad, L_Quad_Save, nR, nR_Save, Quadrature, ThrC, Threshold, Threshold_Save
use Definitions, only: u6

implicit none

!                                                                      *
!***********************************************************************
!                                                                      *
! Reset the size and the accuracy of the grid to the requested values.

L_Quad = L_Quad_Save
if (Quadrature(1:3) == 'LMG') then
  Threshold = Threshold_Save
else
  nR = nR_save
end if

Crowding = ThrC

write(u6,*)
write(u6,'(6X,A)') 'Reset the NQ grid!'
write(u6,*)
call Funi_Print()
write(u6,*)
!                                                                      *
!***********************************************************************
!                                                                      *
! Change the Grid set index

iGrid_Set = Final_Grid
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Reset_NQ_Grid

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine RI_XDiag(Diag,nDiag)
C
C     Thomas Bondo Pedersen, Jan. 2007.
C
C     Purpose: compute exact integral diagonal.
C
      Implicit None
      Integer nDiag
      Real*8  Diag(nDiag)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer ip0, ip_Scr, l_Scr
      Integer ip_SewMem, l_SewMem
      Integer ID
      Integer iSAB, iShlA, iShlB
      Integer NumAB
      Integer iSym, i1, i2

      Logical  Rsv_Tsk
      External Rsv_Tsk

      Integer i, j, k
      Integer iSP2F, nBstSh, IndRed, iiBstRSh, nnBstRSh
      iSP2F(i)=iWork(ip_iSP2F-1+i)
      nBstSh(i)=iWork(ip_nBstSh-1+i)
      IndRed(i,j)=iWork(ip_IndRed-1+mmBstRT*(j-1)+i)
      iiBstRSh(i,j,k)=iWork(ip_iiBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      nnBstRSh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)

C     Allocate memory.
C     ----------------

      Call Init_Tsk(ID,nnShl)

      l_Scr = Mx2Sh
      Call GetMem('xDiaScr','Allo','Real',ip_Scr,l_Scr)
      Call GetMem('getMx','Max ','Real',ip_SewMem,l_SewMem)
      Call xSetMem_Ints(l_SewMem)

C     Initialize diagonal array.
C     --------------------------

      Call fZero(Diag,nnBstRT(1))

C     Parallel loop over shell pairs in first red. set.
C     -------------------------------------------------

      ip0 = ip_Scr - 1
      Do While (Rsv_Tsk(ID,iSAB))

C        Get shells.
C        -----------

         Call Cho_InvPck(iSP2F(iSAB),iShlA,iShlB,.True.)

C        Compute (AB|AB).
C        ----------------

         If (iShlA .eq. iShlB) Then
            NumAB = nBstSh(iShlA)*(nBstSh(iShlA)+1)/2
         Else
            NumAB = nBstSh(iShlA)*nBstSh(iShlB)
         End If
         ShA = iShlA
         ShB = iShlB
         Call Cho_MCA_DiagInt(iShlA,iShlB,Work(ip_Scr),NumAB)

C        Extract diagonal elements.
C        --------------------------

         Do iSym = 1,nSym
            i1 = iiBstR(iSym,1) + iiBstRSh(iSym,iSAB,1) + 1
            i2 = i1 + nnBstRSh(iSym,iSAB,1) - 1
            Do i = i1,i2
               Diag(i) = Work(ip0+IndRed(i,1))
            End Do
         End Do

      End Do
      Call Free_Tsk(ID)

C     Sync diagonal.
C     --------------

      Call GAdGOP(Diag,nnBstRT(1),'+')

C     Deallocate memory.
C     ------------------

      Call xRlsMem_Ints
      Call GetMem('xDiaScr','Free','Real',ip_Scr,l_Scr)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine ciweight2_cvb(civec,civbs,civb,citmp,civec5,
     >  orbs,sorbs,orbinv,owrk,gjorb,gjorb2,gjorb3,
     >  vec1,vec2,vec3,
     >  vec4,vec5,
     >  wghtion1,wghtion2,wghtion3,wghtion4,wghtion5,wghtion6,
     >  mingrph,maxgrph,xalf,xbet,iaocc,ibocc,
     >  mingion,maxgion,nkion,xion,locion,lunion,
     >  mingsng,maxgsng,nksng,xsng,locsng,lunsng,
     >  mingasg,maxgasg,nkasg,xasg,locasg,lunasg,
     >  gal1,gal2,indavec,indbvec,
     >  ionmin,ionmax,mxrem,mxsng,mxasg,ncnfcas,mxdetcas)
      implicit real*8 (a-h,o-w,y-z),integer(x)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "formats_cvb.fh"
      character*240 line
      dimension civec(ndet),civbs(ndet),civb(ndet),citmp(ndet),
     >  civec5(ndet)
      dimension orbs(norb,norb),sorbs(norb,norb)
      dimension orbinv(norb,norb),owrk(norb,norb)
      dimension gjorb(*),gjorb2(*),gjorb3(*)

      dimension vec1(ndet),vec2(ndet),vec3(ndet),vec4(ndet),vec5(ndet)
      dimension wghtion1(ionmin:ionmax),wghtion2(ionmin:ionmax)
      dimension wghtion3(ionmin:ionmax),wghtion4(ionmin:ionmax)
      dimension wghtion5(ionmin:ionmax),wghtion6(ionmin:ionmax)
      dimension mingrph(0:norb),maxgrph(0:norb)
      dimension xalf(0:norb,0:nalf),xbet(0:norb,0:nbet)
      dimension iaocc(norb),ibocc(norb)
      dimension mingion(0:norb),maxgion(0:norb),nkion(0:norb)
      dimension xion((norb+1)*(ionmax+1)),locion(norb),lunion(norb)
      dimension mingsng(0:norb),maxgsng(0:norb),nksng(0:norb)
      dimension xsng((mxrem+1)*(mxsng+1)),locsng(norb),lunsng(norb)
      dimension mingasg(0:norb),maxgasg(0:norb),nkasg(0:norb)
      dimension xasg((mxsng+1)*(mxasg+1)),locasg(norb),lunasg(norb)
      dimension gal1(ncnfcas),gal2(ncnfcas)
      dimension indavec(mxdetcas),indbvec(mxdetcas)

      dimension cprint(6)

      call cidot_cvb(civb,civbs,cnrm)
      fac=svb/sqrt(cnrm)

      call cicopy_cvb(civec,citmp)
      call fmove_cvb(orbs,orbinv,norb*norb)
      call mxinv_cvb(orbinv,norb)
      call gaussj_cvb(orbinv,gjorb)
      call applyt_cvb(civec,gjorb)
c  Chirgwin-Coulson weights
      if(mod(iciweights,2).eq.1)then
        call transp_cvb(orbs,owrk,norb,norb)
        call gaussj_cvb(owrk,gjorb2)
        call applyt_cvb(citmp,gjorb2)
        do 200 idet=1,ndet
        vec2(idet)=(vec1(idet)-fac*vec2(idet))*
     >              (vec3(idet)-fac*vec4(idet))
200     continue
        do 300 idet=1,ndet
        vec1(idet)=vec1(idet)*vec3(idet)
300     continue
      endif
      do 400 idet=1,ndet
      vec4(idet)=vec3(idet)-fac*vec4(idet)
400   continue

c  Inverse-overlap weights
      if(.not.mod(iciweights,8).gt.3)goto 4010
      call mxattb_cvb(orbs,orbs,norb,norb,norb,sorbs)
      call fmove_cvb(sorbs,orbinv,norb*norb)
      call mxinv_cvb(orbinv,norb)
      call gaussj_cvb(orbinv,gjorb)
c Alpha weight array:
      do 1100 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nalf,0)
      maxgrph(iorb)=min(iorb,nalf)
1100  continue
      call weight_cvb(xalf,mingrph,maxgrph,nalf,norb)
c Beta weight array:
      do 1200 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nbet,0)
      maxgrph(iorb)=min(iorb,nbet)
1200  continue
      call weight_cvb(xbet,mingrph,maxgrph,nbet,norb)

      nc=0
      do 2000 ion=ionmin,ionmax
      nsing=nel-2*ion
      mrem=norb-ion
      nalfsng=nalf-ion
      nbetsng=nbet-ion
c  Initialise loop for ionic orbitals
      do 2100 iorb=0,norb
      mingion(iorb)=max(iorb-norb+ion,0)
      maxgion(iorb)=min(iorb,ion)
2100  continue
      call weight_cvb(xion,mingion,maxgion,ion,norb)
      call imove_cvb(maxgion,nkion,norb+1)
      call occupy_cvb(nkion,norb,locion,lunion)
c  Initialise loop for singly occupied orbitals
      do 2200 iorb=0,mrem
      mingsng(iorb)=max(iorb-mrem+nsing,0)
      maxgsng(iorb)=min(iorb,nsing)
2200  continue
      call weight_cvb(xsng,mingsng,maxgsng,nsing,mrem)
      call imove_cvb(maxgsng,nksng,mrem+1)
      call occupy_cvb(nksng,mrem,locsng,lunsng)
c  Initialise loop for singly occupied alpha orbitals
      do 2300 iorb=0,nsing
      mingasg(iorb)=max(iorb-nsing+nalfsng,0)
      maxgasg(iorb)=min(iorb,nalfsng)
2300  continue
      call weight_cvb(xasg,mingasg,maxgasg,nalfsng,nsing)
      call imove_cvb(maxgasg,nkasg,nsing+1)
      call occupy_cvb(nkasg,nsing,locasg,lunasg)

c  Loop ionic
      indion=1
3000  continue
c  Loop singly occupied
      indsng=1
3100  continue
      call fzero(vec5,ndet)
      s11=zero
      s22=zero
      s12=zero
c  Loop singly occupied alpha
      indasg=1
3200  continue

      call izero(iaocc,norb)
      call izero(ibocc,norb)
      do 3300 i=1,ion
      iaocc(locion(i))=1
      ibocc(locion(i))=1
3300  continue
      do 3400 ia=1,nalfsng
      iaorb=lunion(locsng(locasg(ia)))
      iaocc(iaorb)=1
3400  continue
      do 3500 ib=1,nbetsng
      iborb=lunion(locsng(lunasg(ib)))
      ibocc(iborb)=1
3500  continue
      inda=indget_cvb(iaocc,nalf,norb,xalf)
      indb=indget_cvb(ibocc,nbet,norb,xbet)
      indavec(indasg)=inda
      indbvec(indasg)=indb

      indab=(indb-1)*nda+inda
      vec5(indab)=vec3(indab)
      s11=s11+vec3(indab)*vec3(indab)
      s22=s22+vec4(indab)*vec4(indab)
      s12=s12+vec3(indab)*vec4(indab)

      call loind_cvb(nsing,nalfsng,nkasg,mingasg,maxgasg,
     >                       locasg,lunasg,indasg,xasg,*3200)

      call applyt_cvb(civec5,gjorb)

      call icomb_cvb(nsing,nalfsng,nindasg)
      sm1=zero
      do 3600 indasg=1,nindasg
      inda=indavec(indasg)
      indb=indbvec(indasg)
      indab=(indb-1)*nda+inda
      sm1=sm1+vec3(indab)*vec5(indab)
3600  continue

      if(abs(sm1).gt.1.d-20)then
        sm1=s11*s11/sm1
      elseif(abs(sm1).le.1.d-20)then
        sm1=zero
      endif

      call fzero(vec5,ndet)
      do 3700 indasg=1,nindasg
      inda=indavec(indasg)
      indb=indbvec(indasg)
      indab=(indb-1)*nda+inda
      vec5(indab)=vec4(indab)
3700  continue

      call applyt_cvb(civec5,gjorb)

      sm2=zero
      do 3800 indasg=1,nindasg
      inda=indavec(indasg)
      indb=indbvec(indasg)
      indab=(indb-1)*nda+inda
      sm2=sm2+vec4(indab)*vec5(indab)
3800  continue

      if(abs(sm2).gt.1.d-20)then
        sm2=s22*s22/sm2
      elseif(abs(sm2).le.1.d-20)then
        sm2=zero
      endif

      nc=nc+1
      gal1(nc)=sm1
      gal2(nc)=sm2

      call loind_cvb(mrem,nsing,nksng,mingsng,maxgsng,
     >                       locsng,lunsng,indsng,xsng,*3100)
      call loind_cvb(norb,ion,nkion,mingion,maxgion,
     >                       locion,lunion,indion,xion,*3000)
2000  continue
      sum1=zero
      sum2=zero
      do 3900 ic=1,ncnfcas
      sum1=sum1+gal1(ic)
      sum2=sum2+gal2(ic)
3900  continue
      fac1=one/sum1
      if(abs(one-svb*svb).lt.1.d-20.and.abs(sum2).lt.1.d-20)then
        fac2=one
      else
        fac2=(one-svb*svb)/sum2
      endif
      do 4000 ic=1,ncnfcas
      gal1(ic)=fac1*gal1(ic)
      gal2(ic)=fac2*gal2(ic)
4000  continue
4010  continue

c  Weights of Lowdin orthonormalized structures
      if(mod(iciweights,4).gt.1)then
        call mxattb_cvb(orbs,orbs,norb,norb,norb,sorbs)
        call mxsqrt_cvb(sorbs,norb,1)
        call gaussj_cvb(sorbs,gjorb3)
        call applyt_cvb(civec,gjorb3)
        call applyt_cvb(civb,gjorb3)
        call cidot_cvb(civb,civb,cnrm)
        fac=svb/sqrt(cnrm)
        do 4100 idet=1,ndet
        vec4(idet)=vec4(idet)*vec4(idet)
        vec3(idet)=vec3(idet)*vec3(idet)
4100    continue
      endif

      write(6,'(/,2a)')' Weights of CASSCF configurations ',
     >                 'in VB basis (c_res=c_cas-Svb*c_vb) :'
      write(6,'(2a)')  ' ---------------------------------',
     >                 '------------------------------------'
      if(mod(iciweights,8).gt.3)then
        write(6,'(a)')' Sum of inverse-overlap weights :'
        write(6,form2AD)' c_cas :',sum1,' expected :',one
        write(6,form2AD)' c_res :',sum2,' expected :',one-svb*svb
        write(6,'(a)')' '
      endif
      lenfld=8+iprec
      ix1=max(0,min(3,2*lenfld-16))
      call cblank_cvb(line,240)
      if(npcf.gt.0.or.npcf.eq.-1)then
        line(1:21)='  Conf. =>  Orbitals '
        ibeg=max(14+3*nel,22)
        ibegt=ibeg
        if(mod(iciweights,2).eq.1)then
          line(ibegt+ix1:ibegt+2*lenfld-1)='Chirgwin-Coulson'
          ibegt=ibegt+2*lenfld
        endif
        if(mod(iciweights,4).gt.1)then
          line(ibegt+ix1:ibegt+2*lenfld-1)='Lowdin'
          ibegt=ibegt+2*lenfld
        endif
        if(mod(iciweights,8).gt.3)then
          line(ibegt+ix1:ibegt+2*lenfld-1)='Inverse'
          ibegt=ibegt+2*lenfld
        endif
        write(6,'(a)')line(1:len_trim_cvb(line))
        call cblank_cvb(line,240)
        if(mod(iciweights,2).eq.1)then
          line(ibeg+ix1:ibeg+lenfld-1)='c_cas'
          ibeg=ibeg+lenfld
          line(ibeg+ix1:ibeg+lenfld-1)='c_res'
          ibeg=ibeg+lenfld
        endif
        if(mod(iciweights,4).gt.1)then
          line(ibeg+ix1:ibeg+lenfld-1)='c_cas'
          ibeg=ibeg+lenfld
          line(ibeg+ix1:ibeg+lenfld-1)='c_res'
          ibeg=ibeg+lenfld
        endif
        if(mod(iciweights,8).gt.3)then
          line(ibeg+ix1:ibeg+lenfld-1)='c_cas'
          ibeg=ibeg+lenfld
          line(ibeg+ix1:ibeg+lenfld-1)='c_res'
          ibeg=ibeg+lenfld
        endif
        write(6,'(a)')line(1:len_trim_cvb(line))
      endif
      call cblank_cvb(line,240)

c Alpha weight array:
      do 5100 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nalf,0)
      maxgrph(iorb)=min(iorb,nalf)
5100  continue
      call weight_cvb(xalf,mingrph,maxgrph,nalf,norb)
c Beta weight array:
      do 5200 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nbet,0)
      maxgrph(iorb)=min(iorb,nbet)
5200  continue
      call weight_cvb(xbet,mingrph,maxgrph,nbet,norb)

      nc=0
      call fzero(wghtion1,ionmax-ionmin+1)
      call fzero(wghtion2,ionmax-ionmin+1)
      call fzero(wghtion3,ionmax-ionmin+1)
      call fzero(wghtion4,ionmax-ionmin+1)
      call fzero(wghtion5,ionmax-ionmin+1)
      call fzero(wghtion6,ionmax-ionmin+1)
      do 6000 ion=ionmin,ionmax
      nsing=nel-2*ion
      mrem=norb-ion
      nalfsng=nalf-ion
      nbetsng=nbet-ion
c  Initialise loop for ionic orbitals
      do 6100 iorb=0,norb
      mingion(iorb)=max(iorb-norb+ion,0)
      maxgion(iorb)=min(iorb,ion)
6100  continue
      call weight_cvb(xion,mingion,maxgion,ion,norb)
      call imove_cvb(maxgion,nkion,norb+1)
      call occupy_cvb(nkion,norb,locion,lunion)
c  Initialise loop for singly occupied orbitals
      do 6200 iorb=0,mrem
      mingsng(iorb)=max(iorb-mrem+nsing,0)
      maxgsng(iorb)=min(iorb,nsing)
6200  continue
      call weight_cvb(xsng,mingsng,maxgsng,nsing,mrem)
      call imove_cvb(maxgsng,nksng,mrem+1)
      call occupy_cvb(nksng,mrem,locsng,lunsng)
c  Initialise loop for singly occupied alpha orbitals
      do 6300 iorb=0,nsing
      mingasg(iorb)=max(iorb-nsing+nalfsng,0)
      maxgasg(iorb)=min(iorb,nalfsng)
6300  continue
      call weight_cvb(xasg,mingasg,maxgasg,nalfsng,nsing)
      call imove_cvb(maxgasg,nkasg,nsing+1)
      call occupy_cvb(nkasg,nsing,locasg,lunasg)

c  Loop ionic
      indion=1
7000  continue
c  Loop singly occupied
      indsng=1
7100  continue
      c1=zero
      c2=zero
      c3=zero
      c4=zero
c  Loop singly occupied alpha
      indasg=1
7200  continue

      call izero(iaocc,norb)
      call izero(ibocc,norb)
      do 7300 i=1,ion
      iaocc(locion(i))=1
      ibocc(locion(i))=1
7300  continue
      do 7400 ia=1,nalfsng
      iaorb=lunion(locsng(locasg(ia)))
      iaocc(iaorb)=1
7400  continue
      do 7500 ib=1,nbetsng
      iborb=lunion(locsng(lunasg(ib)))
      ibocc(iborb)=1
7500  continue
      inda=indget_cvb(iaocc,nalf,norb,xalf)
      indb=indget_cvb(ibocc,nbet,norb,xbet)

      indab=(indb-1)*nda+inda
      c1=c1+vec1(indab)
      c2=c2+vec2(indab)
      c3=c3+vec3(indab)
      c4=c4+vec4(indab)

      call loind_cvb(nsing,nalfsng,nkasg,mingasg,maxgasg,
     >                       locasg,lunasg,indasg,xasg,*7200)
      nc=nc+1
      wghtion1(ion)=wghtion1(ion)+c1
      wghtion2(ion)=wghtion2(ion)+c2
      wghtion3(ion)=wghtion3(ion)+c3
      wghtion4(ion)=wghtion4(ion)+c4
      wghtion5(ion)=wghtion5(ion)+gal1(nc)
      wghtion6(ion)=wghtion6(ion)+gal2(nc)
      if(nc.le.npcf.or.npcf.eq.-1)then
        call int2char_cvb(line,nc,7)
        line(9:10)='=>'
        ilin=11
        do 7600 i=1,ion
        call int2char_cvb(line(ilin:ilin+2),locion(i),3)
        ilin=ilin+3
        call int2char_cvb(line(ilin:ilin+2),locion(i),3)
        ilin=ilin+3
7600    continue
        do 7700 i=1,nsing
        call int2char_cvb(line(ilin:ilin+2),lunion(locsng(i)),3)
        ilin=ilin+3
7700    continue
        ilin=max(ilin,19)
        nprint=0
        if(mod(iciweights,2).eq.1)then
          cprint(nprint+1)=c1
          cprint(nprint+2)=c2
          nprint=nprint+2
        endif
        if(mod(iciweights,4).gt.1)then
          cprint(nprint+1)=c3
          cprint(nprint+2)=c4
          nprint=nprint+2
        endif
        if(mod(iciweights,8).gt.3)then
          cprint(nprint+1)=gal1(nc)
          cprint(nprint+2)=gal2(nc)
          nprint=nprint+2
        endif
        write(6,formAD)line(1:ilin),(cprint(mp),mp=1,nprint)
      endif
      call loind_cvb(mrem,nsing,nksng,mingsng,maxgsng,
     >                       locsng,lunsng,indsng,xsng,*7100)
      call loind_cvb(norb,ion,nkion,mingion,maxgion,
     >                       locion,lunion,indion,xion,*7000)
6000  continue

      call cblank_cvb(line,240)
      line(1:21)=' Accumulated weights:'
      ibeg=22
      if(mod(iciweights,2).eq.1)then
        line(ibeg+ix1:ibeg+2*lenfld-1)='Chirgwin-Coulson'
        ibeg=ibeg+2*lenfld
      endif
      if(mod(iciweights,4).gt.1)then
        line(ibeg+ix1:ibeg+2*lenfld-1)='Lowdin'
        ibeg=ibeg+2*lenfld
      endif
      if(mod(iciweights,8).gt.3)then
        line(ibeg+ix1:ibeg+2*lenfld-1)='Inverse'
        ibeg=ibeg+2*lenfld
      endif
      write(6,'(/,a)')line(1:len_trim_cvb(line))
      call cblank_cvb(line,240)
      ibeg=22
      if(mod(iciweights,2).eq.1)then
        line(ibeg+ix1:ibeg+lenfld-1)='c_cas'
        ibeg=ibeg+lenfld
        line(ibeg+ix1:ibeg+lenfld-1)='c_res'
        ibeg=ibeg+lenfld
      endif
      if(mod(iciweights,4).gt.1)then
        line(ibeg+ix1:ibeg+lenfld-1)='c_cas'
        ibeg=ibeg+lenfld
        line(ibeg+ix1:ibeg+lenfld-1)='c_res'
        ibeg=ibeg+lenfld
      endif
      if(mod(iciweights,8).gt.3)then
        line(ibeg+ix1:ibeg+lenfld-1)='c_cas'
        ibeg=ibeg+lenfld
        line(ibeg+ix1:ibeg+lenfld-1)='c_res'
        ibeg=ibeg+lenfld
      endif
      write(6,'(a)')line(1:len_trim_cvb(line))
      call cblank_cvb(line,240)
      total1=zero
      total2=zero
      total3=zero
      total4=zero
      total5=zero
      total6=zero
      do 8000 ion=ionmin,ionmax
      total1=total1+wghtion1(ion)
      total2=total2+wghtion2(ion)
      total3=total3+wghtion3(ion)
      total4=total4+wghtion4(ion)
      total5=total5+wghtion5(ion)
      total6=total6+wghtion6(ion)
      line(1:19)=' For ionicity    : '
      call int2char_cvb(line(14:16),ion,3)
      nprint=0
      if(mod(iciweights,2).eq.1)then
        cprint(nprint+1)=wghtion1(ion)
        cprint(nprint+2)=wghtion2(ion)
        nprint=nprint+2
      endif
      if(mod(iciweights,4).gt.1)then
        cprint(nprint+1)=wghtion3(ion)
        cprint(nprint+2)=wghtion4(ion)
        nprint=nprint+2
      endif
      if(mod(iciweights,8).gt.3)then
        cprint(nprint+1)=wghtion5(ion)
        cprint(nprint+2)=wghtion6(ion)
        nprint=nprint+2
      endif
      write(6,formAD)line(1:19),(cprint(mp),mp=1,nprint)
8000  continue
      nprint=0
      if(mod(iciweights,2).eq.1)then
        cprint(nprint+1)=total1
        cprint(nprint+2)=total2
        nprint=nprint+2
      endif
      if(mod(iciweights,4).gt.1)then
        cprint(nprint+1)=total3
        cprint(nprint+2)=total4
        nprint=nprint+2
      endif
      if(mod(iciweights,8).gt.3)then
        cprint(nprint+1)=total5
        cprint(nprint+2)=total6
        nprint=nprint+2
      endif
      write(6,formAD)' Total all       : ',(cprint(mp),mp=1,nprint)
      write(6,'(a)')' '
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqk15(f,a,b,reslt,abserr,resabs,resasc)
!***begin prologue  dqk15
!***date written   800101   (yymmdd)
!***revision date  830518   (yymmdd)
!***category no.  h2a1a2
!***keywords  15-point gauss-kronrod rules
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  to compute i = integral of f over (a,b), with error
!                           estimate
!                       j = integral of abs(f) over (a,b)
!***description
!
!           integration rules
!           standard fortran subroutine
!           real*8 version
!
!           parameters
!            on entry
!              f      - real*8
!                       function subprogram defining the integrand
!                       function f(x). the actual name for f needs to be
!                       declared e x t e r n a l in the calling program.
!
!              a      - real*8
!                       lower limit of integration
!
!              b      - real*8
!                       upper limit of integration
!
!            on return
!              reslt  - real*8
!                       approximation to the integral i
!                       result is computed by applying the 15-point
!                       kronrod rule (resk) obtained by optimal addition
!                       of abscissae to the 7-point gauss rule (resg).
!
!              abserr - real*8
!                       estimate of the modulus of the absolute error,
!                       which should not exceed abs(i-reslt)
!
!              resabs - real*8
!                       approximation to the integral j
!
!              resasc - real*8
!                       approximation to the integral of abs(f-i/(b-a))
!                       over (a,b)
!
!***references  (none)
!***routines called  d1mach
!***end prologue  dqk15

use Constants, only: Zero, One, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
interface
  function f(x)
    import :: wp
    real(kind=wp) :: f
    real(kind=wp), intent(in) :: x
  end function f
end interface
real(kind=wp), intent(in) :: a, b
real(kind=wp), intent(out) :: reslt, abserr, resabs, resasc
real(kind=wp) :: absc, centr, dhlgth, epmach, fc, fsum, fval1, fval2, fv1(7), fv2(7), hlgth, resg, resk, reskh, uflow
integer(kind=iwp) :: j, jtw, jtwm1
real(kind=wp), external :: d1mach

! the abscissae and weights are given for the interval (-1,1).
! because of symmetry only the positive abscissae and their
! corresponding weights are given.
!
! xgk    - abscissae of the 15-point kronrod rule
!          xgk(2), xgk(4), ...  abscissae of the 7-point
!          gauss rule
!          xgk(1), xgk(3), ...  abscissae which are optimally
!          added to the 7-point gauss rule
!
! wgk    - weights of the 15-point kronrod rule
!
! wg     - weights of the 7-point gauss rule
!
!
! gauss quadrature weights and kronron quadrature abscissae and weights
! as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
! bell labs, nov. 1981.

real(kind=wp), parameter :: wg(4) = [0.129484966168869693270611432679082_wp, &
                                     0.279705391489276667901467771423780_wp, &
                                     0.381830050505118944950369775488975_wp, &
                                     0.417959183673469387755102040816327_wp]
real(kind=wp), parameter :: xgk(8) = [0.991455371120812639206854697526329_wp, &
                                      0.949107912342758524526189684047851_wp, &
                                      0.864864423359769072789712788640926_wp, &
                                      0.741531185599394439863864773280788_wp, &
                                      0.586087235467691130294144838258730_wp, &
                                      0.405845151377397166906606412076961_wp, &
                                      0.207784955007898467600689403773245_wp, &
                                      0.000000000000000000000000000000000_wp]
real(kind=wp), parameter :: wgk(8) = [0.022935322010529224963732008058970_wp, &
                                      0.063092092629978553290700663189204_wp, &
                                      0.104790010322250183839876322541518_wp, &
                                      0.140653259715525918745189590510238_wp, &
                                      0.169004726639267902826583426598550_wp, &
                                      0.190350578064785409913256402421014_wp, &
                                      0.204432940075298892414161999234649_wp, &
                                      0.209482141084727828012999174891714_wp]

! list of major variables
! -----------------------
!
! centr  - mid point of the interval
! hlgth  - half-length of the interval
! absc   - abscissa
! fval*  - function value
! resg   - result of the 7-point gauss formula
! resk   - result of the 15-point kronrod formula
! reskh  - approximation to the mean value of f over (a,b),
!          i.e. to i/(b-a)
!
! machine dependent constants
! ---------------------------
!
! epmach is the largest relative spacing.
! uflow is the smallest positive magnitude.
!
!***first executable statement  dqk15

epmach = d1mach(4)
uflow = d1mach(1)

centr = Half*(a+b)
hlgth = Half*(b-a)
dhlgth = abs(hlgth)

! compute the 15-point kronrod approximation to
! the integral, and estimate the absolute error.

fc = f(centr)
resg = fc*wg(4)
resk = fc*wgk(8)
resabs = abs(resk)
do j=1,3
  jtw = j*2
  absc = hlgth*xgk(jtw)
  fval1 = f(centr-absc)
  fval2 = f(centr+absc)
  fv1(jtw) = fval1
  fv2(jtw) = fval2
  fsum = fval1+fval2
  resg = resg+wg(j)*fsum
  resk = resk+wgk(jtw)*fsum
  resabs = resabs+wgk(jtw)*(abs(fval1)+abs(fval2))
end do
do j=1,4
  jtwm1 = j*2-1
  absc = hlgth*xgk(jtwm1)
  fval1 = f(centr-absc)
  fval2 = f(centr+absc)
  fv1(jtwm1) = fval1
  fv2(jtwm1) = fval2
  fsum = fval1+fval2
  resk = resk+wgk(jtwm1)*fsum
  resabs = resabs+wgk(jtwm1)*(abs(fval1)+abs(fval2))
end do
reskh = resk*Half
resasc = wgk(8)*abs(fc-reskh)
do j=1,7
  resasc = resasc+wgk(j)*(abs(fv1(j)-reskh)+abs(fv2(j)-reskh))
end do
reslt = resk*hlgth
resabs = resabs*dhlgth
resasc = resasc*dhlgth
abserr = abs((resk-resg)*hlgth)
if ((resasc /= Zero) .and. (abserr /= Zero)) abserr = resasc*min(One,(200.0_wp*abserr/resasc)**OneHalf)
if (resabs > uflow/(50.0_wp*epmach)) abserr = max((epmach*50.0_wp)*resabs,abserr)

return

end subroutine dqk15

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module BasisMode

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: Valence_Mode = 0, Auxiliary_Mode = 1, Fragment_Mode = 2, With_Auxiliary_Mode = 3, &
                                With_Fragment_Mode = 4, All_Mode = 5
integer(kind=iwp) :: Basis_Mode, kCnttp, lCnttp
logical(kind=iwp) :: Atomic

public :: All_Mode, Atomic, Auxiliary_Mode, Basis_Mode, Fragment_Mode, kCnttp, lCnttp, Valence_Mode, With_Auxiliary_Mode, &
          With_Fragment_Mode

end module BasisMode

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine xerror(Label,ix,ier,lvl)
       Character*(*) Label
       Integer ix,ier,lvl
*
       Write (6,*) 'Terminate in xerror!'
       Write (6,'(A)') Label
       Write (6,'(A,I5)') 'ix=',ix
       Write (6,'(A,I5)') 'ier=',ier
       Write (6,'(A,I5)') 'lvl=',lvl
       Call Abend()
*
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkL0(V)
! L0(m,i,j) <- V(m,ij)

use Index_Functions, only: nTri_Elem
use chcc_global, only: L0k, nc, no
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: V(nc,nTri_Elem(no))
integer(kind=iwp) :: i, ij

call mma_allocate(L0k,nc,no,no,label='L0k')

ij = 0
do i=1,no
  L0k(:,i,1:i-1) = V(:,ij+1:ij+i-1)
  L0k(:,1:i,i) = V(:,ij+1:ij+i)
  ij = ij+i
end do

return

end subroutine MkL0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_Energy_Fll(irc,Delete,EMP2,EOcc,EVir,Wrk,lWrk)
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: compute MP2 energy contribution using original
!          Cholesky vectors on disk for the case nBatch=1.

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Cholesky, only: nSym, NumCho
use ChoMP2, only: ChoAlg, DecoMP2, iMatab, iT1am, LiMatij, lUnit_F, nBatch, nMatab, nMP2Vec, nOcc, nT1am, nVir, Wref
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
logical(kind=iwp), intent(in) :: Delete
integer(kind=iwp), intent(in) :: lWrk
real(kind=wp), intent(out) :: EMP2, Wrk(lWrk)
real(kind=wp), intent(in) :: EOcc(*), EVir(*)
integer(kind=iwp) :: i, iAdr, iBat, iClos, ij, iOpt, iSym, iSyma, iSymab, iSymb, iSymi, iSymij, iSymj, iTyp, iVaJi(8), iVec, &
                     iVec0, iVec1, j, kEnd0, kEnd1, kEnd2, kMabij, kXaibj, kOff1, kOff2, kOffi, kOffj, kOffM, kVec, kVecai, kXint, &
                     LiT2am(8), LnT2am, lTot, lWrk0, lWrk1, lWrk2, Nai, nBat, nEnrVec(8), NumV, NumVec, nVaJi, nVec
real(kind=wp) :: Fac
real(kind=wp), parameter :: X(0:1) = [Zero,One]
character(len=*), parameter :: SecNam = 'ChoMP2_Energy_Fll'

if (nBatch /= 1) then
  irc = -1
  return
end if

irc = 0

! Determine if vector files are to be deleted after use.
! ------------------------------------------------------

if (Delete) then
  iClos = 3
else
  iClos = 2
end if

! Set number and type of vectors.
! -------------------------------

if (DecoMP2) then
  iTyp = 2
  nEnrVec(1:nSym) = nMP2Vec(1:nSym)
else
  iTyp = 1
  nEnrVec(1:nSym) = NumCho(1:nSym)
end if

! Set (ai|bj) indices.
! --------------------

call ChoMP2_Energy_GetInd(LnT2am,LiT2am,1,1)

! Allocate memory for integrals.
! ------------------------------

kXaibj = 1
kEnd0 = kXaibj+LnT2am
lWrk0 = lWrk-kEnd0+1
if (lWrk0 < 0) call SysAbendMsg(SecNam,'insufficient memory','[0]')

! Initialize MP2 energy correction.
! ---------------------------------

EMP2 = Zero
Wref = Zero

! Special code for ChoAlg=2:
! compute M(ab,ij) = (ai|bj) with i<=j using level 3 BLAS.
! For ChoAlg=1: use strictly lower triangular storage (=>
! level 2 BLAS).
! --------------------------------------------------------

if (ChoAlg == 2) then ! level 3 BLAS algorithm

  kMabij = kXaibj ! rename pointer
  Wrk(kMabij:kMabij+LnT2am-1) = Zero ! initialize

  ! Loop over Cholesky symmetries.
  ! ------------------------------

  do iSym=1,nSym

    Nai = nT1am(iSym)
    if ((Nai > 0) .and. (nEnrVec(iSym) > 0)) then

      ! Reserve memory for reading a single vector.
      ! -------------------------------------------

      kVecai = kEnd0
      kEnd1 = kVecai+Nai
      lWrk1 = lWrk-kEnd1+1

      if (lWrk1 < Nai) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.1]')

      ! Set up batch over Cholesky vectors.
      ! -----------------------------------

      nVec = min(lWrk1/Nai,nEnrVec(iSym))
      if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.2]') ! should not happen
      nBat = (nEnrVec(iSym)-1)/nVec+1

      ! Open Cholesky vector files.
      ! ---------------------------

      call ChoMP2_OpenF(1,iTyp,iSym)

      ! Start vector batch loop.
      ! ------------------------

      do iBat=1,nBat

        if (iBat == nBat) then
          NumVec = nEnrVec(iSym)-nVec*(nBat-1)
        else
          NumVec = nVec
        end if
        iVec1 = nVec*(iBat-1)+1

        ! Set up index arrays for reordered vectors.
        ! ------------------------------------------

        nVaJi = 0
        do iSymi=1,nSym
          iSyma = Mul(iSymi,iSym)
          iVaJi(iSymi) = nVaJi
          nVaJi = nVaJi+nVir(iSyma)*NumVec*nOcc(iSymi)
        end do

        ! Pointer to reordered vectors: kVec.
        ! -----------------------------------

        kVec = kEnd1
        kEnd2 = kVec+nVaJi
        lWrk2 = lWrk-kEnd2+1
        if (lWrk2 < 0) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.3]') ! should not happen

        ! Read one vector at a time and reorder.
        ! --------------------------------------

        iVec0 = iVec1-1
        do iVec=1,NumVec

          iOpt = 2
          lTot = nT1am(iSym)
          iAdr = nT1am(iSym)*(iVec0+iVec-1)+1
          call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVecai),lTot,iAdr)

          do iSymi=1,nSym
            iSyma = Mul(iSymi,iSym)
            do i=1,nOcc(iSymi)
              kOff1 = kVecai+iT1am(iSyma,iSymi)+nVir(iSyma)*(i-1)
              kOff2 = kVec+iVaJi(iSymi)+nVir(iSyma)*NumVec*(i-1)+nVir(iSyma)*(iVec-1)
              Wrk(kOff2:kOff2+nVir(iSyma)-1) = Wrk(kOff1:kOff1+nVir(iSyma)-1)
            end do
          end do

        end do

        ! Compute M(ab,ij) for i<=j.
        ! First do iSymi=iSymj, then iSymi<iSymj.
        ! ---------------------------------------

        do iSymj=1,nSym

          iSymb = Mul(iSymj,iSym)

          if (nVir(iSymb) > 0) then

            do j=1,nOcc(iSymj)
              do i=1,j

                ij = LiMatij(iSymj,iSymj,1)+iTri(i,j)

                kOffi = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(i-1)
                kOffj = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(j-1)
                kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

                call DGEMM_('N','T',nVir(iSymb),nVir(iSymb),NumVec,ONe,Wrk(kOffi),nVir(iSymb),Wrk(kOffj),nVir(iSymb),One, &
                            Wrk(kOffM),nVir(iSymb))

              end do
            end do

            do iSymi=1,iSymj-1

              iSyma = Mul(iSymi,iSym)
              iSymab = Mul(iSyma,iSymb)
              iSymij = iSymab

              if ((nOcc(iSymi) > 0) .and. (nVir(iSyma) > 0)) then

                do j=1,nOcc(iSymj)
                  do i=1,nOcc(iSymi)

                    ij = LiMatij(iSymi,iSymj,1)+nOcc(iSymi)*(j-1)+i

                    kOffi = kVec+iVaJi(iSymi)+nVir(iSyma)*NumVec*(i-1)
                    kOffj = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(j-1)
                    kOffM = kMabij+LiT2am(iSymij)+nMatab(iSymab)*(ij-1)+iMatab(iSyma,iSymb)

                    call DGEMM_('N','T',nVir(iSyma),nVir(iSymb),NumVec,One,Wrk(kOffi),nVir(iSyma),Wrk(kOffj),nVir(iSymb),One, &
                                Wrk(kOffM),nVir(iSyma))

                  end do
                end do

              end if

            end do
          end if

        end do

      end do

      ! Close (and possibly delete) Cholesky vector files.
      ! --------------------------------------------------

      call ChoMP2_OpenF(iClos,iTyp,iSym)

    end if

  end do ! iSym

else ! level 2 BLAS algorithm

  ! Loop over Cholesky symmetries.
  ! ------------------------------

  do iSym=1,nSym
    if ((nT1am(iSym) > 0) .and. (nEnrVec(iSym) > 0)) then

      ! Set up Cholesky batch.
      ! ----------------------

      NumVec = min(lWrk0/nT1am(iSym),nEnrVec(iSym))
      if (NumVec < 1) call SysAbendMsg(SecNam,'insufficient memory','[2]')
      nBat = (nEnrVec(iSym)-1)/NumVec+1

      ! Open Cholesky vector file.
      ! --------------------------

      call ChoMP2_OpenF(1,iTyp,iSym)

      ! Start batch loop.
      ! -----------------

      do iBat=1,nBat

        if (iBat == nBat) then
          NumV = nEnrVec(iSym)-NumVec*(nBat-1)
        else
          NumV = NumVec
        end if
        iVec1 = NumVec*(iBat-1)+1

        ! Read vectors.
        ! -------------

        kVec = kEnd0

        iOpt = 2
        lTot = nT1am(iSym)*NumV
        iAdr = nT1am(iSym)*(iVec1-1)+1
        call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVec),lTot,iAdr)

        ! Compute contribution.
        ! ---------------------

        Fac = X(min((iBat-1),1))
        kXint = kXaibj+LiT2am(iSym)
        call dGeMM_Tri('N','T',nT1am(iSym),nT1am(iSym),NumV,One,Wrk(kVec),nT1am(iSym),Wrk(kVec),nT1am(iSym),Fac,Wrk(kXint), &
                       nT1am(iSym))

      end do

      ! Close (and possibly delete) Cholesky vector file.
      ! -------------------------------------------------

      call ChoMP2_OpenF(iClos,iTyp,iSym)

    end if
  end do

end if ! ChoAlg

! Compute energy contribution.
! ----------------------------

call ChoMP2_Energy_Contr(EMP2,EOcc,EVir,Wrk(kXaibj),LnT2am,LiT2am,1,1)

! Change sign on energy.
! ----------------------

EMP2 = -EMP2

end subroutine ChoMP2_Energy_Fll

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine CmbnMlt1(Rnxyz,nZeta,la,lb,Zeta,rKappa,rFinal,Alpha,Beta,Grad,nGrad,DAO,IfGrad,IndGrd,iStab,jStab,kOp,nOrdOp,Force)
!***********************************************************************
!                                                                      *
! Object: compute the gradient of the multipole operator matrix.       *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91.                                             *
!***********************************************************************

use Symmetry_Info, only: nIrrep, iChBas
use Index_Functions, only: C_Ind
use Constants, only: Zero, Two, Three
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nGrad, IndGrd(3,2), iStab, jStab, kOp(2), nOrdOp
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la+1,0:lb+1,0:nOrdOp), Zeta(nZeta), Alpha(nZeta), Beta(nZeta), &
                             DAO(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2), Force(*)
real(kind=wp), intent(inout) :: rKappa(nZeta), Grad(nGrad)
real(kind=wp), intent(inout) :: rFinal(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6)
logical(kind=iwp), intent(in) :: IfGrad(3,2)
integer(kind=iwp) :: i1, i2, iCar, iCn, icomp, iGrad, ipa, ipb, iPrint, iRout, ixa, ixb, ixop, iya, iyaMax, iyb, iybMax, iyop, &
                     iza, izb, iZeta, izop, nDAO
real(kind=wp) :: Fact, ff, ps, xa, xb, ya, yb, za, zb
real(kind=wp), parameter :: exp32 = -Three/Two
integer(kind=iwp), external :: iPrmt
real(kind=r8), external :: DDot_
#include "print.fh"

iRout = 134
iPrint = nPrint(iRout)
do iZeta=1,nZeta
  rKappa(iZeta) = rKappa(iZeta)*Zeta(iZeta)**exp32
end do
if (iPrint >= 99) then
  call RecPrt(' In CmbnMlt1: Zeta  ',' ',Zeta,1,nZeta)
  call RecPrt(' In CmbnMlt1: rKappa',' ',rKappa,1,nZeta)
  call RecPrt(' In CmbnMlt1: Alpha ',' ',Alpha,1,nZeta)
  call RecPrt(' In CmbnMlt1: Beta  ',' ',Beta,1,nZeta)
  call RecPrt(' In CmbnMlt1: DAO  ',' ',Dao,nZeta,(la+1)*(la+2)*(lb+1)*(lb+2)/4)
end if
!.... Loop over cartesian components of operator.......
do ixop=0,nOrdOp
  do iyop=0,nOrdOp-ixop
    izop = nOrdOp-ixop-iyop
    icomp = C_Ind(nOrdOp,ixop,izop)
    ff = Force(icomp)
    if (ff == Zero) cycle
    do ixa=0,la
      iyaMax = la-ixa
      do ixb=0,lb
        iybMax = lb-ixb
        do iya=0,iyaMax
          iza = la-ixa-iya
          ipa = C_Ind(la,ixa,iza)
          do iyb=0,iybMax
            izb = lb-ixb-iyb
            ipb = C_Ind(lb,ixb,izb)

            ! Combine overlap integrals

            if (IfGrad(1,1)) then
              if (ixa > 0) then
                xa = real(-ixa,kind=wp)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,1) = rKappa(iZeta)* &
                          (Two*Alpha(iZeta)*Rnxyz(iZeta,1,ixa+1,ixb,ixop)+ &
                                         xa*Rnxyz(iZeta,1,ixa-1,ixb,ixop))* &
                                            Rnxyz(iZeta,2,iya,iyb,iyop)* &
                                            Rnxyz(iZeta,3,iza,izb,izop)
                end do
              else
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,1) = rKappa(iZeta)* &
                           Two*Alpha(iZeta)*Rnxyz(iZeta,1,ixa+1,ixb,ixop)* &
                                            Rnxyz(iZeta,2,iya,iyb,iyop)* &
                                            Rnxyz(iZeta,3,iza,izb,izop)
                end do
              end if
            end if
            if (IfGrad(1,2)) then
              if (ixb > 0) then
                xb = real(-ixb,kind=wp)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,4) = rKappa(iZeta)* &
                           (Two*Beta(iZeta)*Rnxyz(iZeta,1,ixa,ixb+1,ixop)+ &
                                         xb*Rnxyz(iZeta,1,ixa,ixb-1,ixop))* &
                                            Rnxyz(iZeta,2,iya,iyb,iyop)* &
                                            Rnxyz(iZeta,3,iza,izb,izop)
                end do
              else
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,4) = rKappa(iZeta)* &
                            Two*Beta(iZeta)*Rnxyz(iZeta,1,ixa,ixb+1,ixop)* &
                                            Rnxyz(iZeta,2,iya,iyb,iyop)* &
                                            Rnxyz(iZeta,3,iza,izb,izop)
                end do
              end if
            end if
            if (IfGrad(2,1)) then
              if (iya > 0) then
                ya = real(-iya,kind=wp)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,2) = rKappa(iZeta)* &
                                            Rnxyz(iZeta,1,ixa,ixb,ixop)* &
                          (Two*Alpha(iZeta)*Rnxyz(iZeta,2,iya+1,iyb,iyop)+ &
                                         ya*Rnxyz(iZeta,2,iya-1,iyb,iyop))* &
                                            Rnxyz(iZeta,3,iza,izb,izop)
                end do
              else
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,2) = rKappa(iZeta)* &
                                            Rnxyz(iZeta,1,ixa,ixb,ixop)* &
                           Two*Alpha(iZeta)*Rnxyz(iZeta,2,iya+1,iyb,iyop)* &
                                            Rnxyz(iZeta,3,iza,izb,izop)
                end do
              end if
            end if
            if (IfGrad(2,2)) then
              if (iyb > 0) then
                yb = real(-iyb,kind=wp)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,5) = rKappa(iZeta)* &
                                            Rnxyz(iZeta,1,ixa,ixb,ixop)* &
                           (Two*Beta(iZeta)*Rnxyz(iZeta,2,iya,iyb+1,iyop)+ &
                                         yb*Rnxyz(iZeta,2,iya,iyb-1,iyop))* &
                                            Rnxyz(iZeta,3,iza,izb,izop)
                end do
              else
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,5) = rKappa(iZeta)* &
                                            Rnxyz(iZeta,1,ixa,ixb,ixop)* &
                            Two*Beta(iZeta)*Rnxyz(iZeta,2,iya,iyb+1,iyop)* &
                                            Rnxyz(iZeta,3,iza,izb,izop)
                end do
              end if
            end if
            if (IfGrad(3,1)) then
              if (iza > 0) then
                za = real(-iza,kind=wp)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,3) = rKappa(iZeta)* &
                                            Rnxyz(iZeta,1,ixa,ixb,ixop)* &
                                            Rnxyz(iZeta,2,iya,iyb,iyop)* &
                          (Two*Alpha(iZeta)*Rnxyz(iZeta,3,iza+1,izb,izop)+ &
                                         za*Rnxyz(iZeta,3,iza-1,izb,izop))
                end do
              else
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,3) = rKappa(iZeta)* &
                                            Rnxyz(iZeta,1,ixa,ixb,ixop)* &
                                            Rnxyz(iZeta,2,iya,iyb,iyop)* &
                           Two*Alpha(iZeta)*Rnxyz(iZeta,3,iza+1,izb,izop)
                end do
              end if
            end if
            if (IfGrad(3,2)) then
              if (izb > 0) then
                zb = real(-izb,kind=wp)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,6) = rKappa(iZeta)* &
                                            Rnxyz(iZeta,1,ixa,ixb,ixop)* &
                                            Rnxyz(iZeta,2,iya,iyb,iyop)* &
                           (Two*Beta(iZeta)*Rnxyz(iZeta,3,iza,izb+1,izop)+ &
                                         zb*Rnxyz(iZeta,3,iza,izb-1,izop))
                end do
              else
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,6) = rKappa(iZeta)* &
                                            Rnxyz(iZeta,1,ixa,ixb,ixop)* &
                                            Rnxyz(iZeta,2,iya,iyb,iyop)* &
                            Two*Beta(iZeta)*Rnxyz(iZeta,3,iza,izb+1,izop)
                end do
              end if
            end if

          end do
        end do
      end do
    end do

    ! Trace the gradient integrals

    nDAO = nZeta*(la+1)*(la+2)/2*(lb+1)*(lb+2)/2
    if (iPrint >= 99) then
      call RecPrt(' S(1)',' ',rFinal,nDAO,6)
      call RecPrt('   D ',' ',DAO,nDAO,1)
    end if
    do iCn=1,2
      do iCar=1,3
        if (IndGrd(iCar,iCn) /= 0) then
          ! Accumulate contribution to the gradient
          iGrad = abs(IndGrd(iCar,iCn))
          if (iCn == 1) then
            i1 = iCar
            i2 = iCar+3
            ps = real(iPrmt(kOp(1),iChBas(1+iCar)),kind=wp)
            Fact = real(iStab,kind=wp)/real(nIrrep,kind=wp)
          else
            i1 = iCar+3
            i2 = iCar
            ps = real(iPrmt(kOp(2),iChBas(1+iCar)),kind=wp)
            Fact = ps*real(jStab,kind=wp)/real(nIrrep,kind=wp)
          end if
          Fact = Fact*ff
          if (IndGrd(iCar,iCn) < 0) then
            ! Gradient via translational invariance.
            Grad(iGrad) = Grad(iGrad)-Fact*DDot_(nDAO,DAO,1,rFinal(1,1,1,i2),1)
          else
            Grad(iGrad) = Grad(iGrad)+Fact*DDot_(nDAO,DAO,1,rFinal(1,1,1,i1),1)
          end if
        end if
      end do
    end do
  end do
end do

return

end subroutine CmbnMlt1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine David5(nDet,mxItr,nItr,CI_Conv,ThrEne,
     &                 iSel,ExplE,ExplV,HTUTRI,GTUVXTRI)
      use citrans
      use faroald
      Implicit Real*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasrc.fh"
#include "rasscf.fh"
#include "general.fh"
#include "csfbas.fh"
#include "gugx.fh"
#include "davctl.fh"
#include "WrkSpc.fh"
#include "timers.fh"
#include "rasscf_lucia.fh"
#include "output_ras.fh"

* lroots, maxjt in rasscf.fh
      Dimension CI_conv(2,lRoots,MAXJT)
* nsel in general.fh
      Dimension iSel(nSel), ExplE(nSel), ExplV(nSel,nSel)

      PARAMETER (ROUTINE='DAVID5  ')
      Dimension Alpha(mxRoot), Beta(mxRoot)
      Dimension HTUTRI(*), GTUVXTRI(*)
      real*8, allocatable :: sgm(:,:), psi(:,:)
      real*8, allocatable :: htu(:,:), gtuvx(:,:,:,:)
      Dimension Dummy(1)
*-------------------------------------------------------------------
*MGD dec 2017 : When optimizing many states, the lowest ones tend to
*converge much faster than the rest. Changed the code so that the converged states
*are not optimize further, saving potentially a lot of time.

      if (DoFaro) then
        ! fill in the integrals from their triangular storage
        allocate(htu(my_norb,my_norb))
        allocate(gtuvx(my_norb,my_norb,my_norb,my_norb))
        htu=0.0d0
        gtuvx=0.0d0
        itu=0
        ituvx=0
        do it=1,my_norb
          do iu=1,it
            itu=itu+1
*         write(6,'(1x,3I4,F21.14)') it,iu,itu,htutri(itu)
            htu(iu,it) = htutri(itu)
            htu(it,iu) = htutri(itu)
            do iv=1,it
              ixmax=iv
              if (it==iv) ixmax=iu
              do ix=1,ixmax
                ituvx=ituvx+1
*             write(6,'(1x,5I4,F21.14)') it,iu,iv,ix,ituvx,
*    &         gtuvxtri(ituvx)
                GTUVX(IT,IU,IV,IX)=GTUVXTRI(ITUVX)
                GTUVX(IU,IT,IV,IX)=GTUVXTRI(ITUVX)
                GTUVX(IT,IU,IX,IV)=GTUVXTRI(ITUVX)
                GTUVX(IU,IT,IX,IV)=GTUVXTRI(ITUVX)
                GTUVX(IV,IX,IT,IU)=GTUVXTRI(ITUVX)
                GTUVX(IX,IV,IT,IU)=GTUVXTRI(ITUVX)
                GTUVX(IV,IX,IU,IT)=GTUVXTRI(ITUVX)
                GTUVX(IX,IV,IU,IT)=GTUVXTRI(ITUVX)
              end do
            end do
          end do
        end do
        ! Euhm, stuff needed for awkward conversions from a
        ! non-specified SYG to GUGA format befor converting to
        ! determinants. This is because for Lucia, CSFs have been
        ! converted to SYG format somewhere up in cistart.
        CALL GetMem('CIVEC','Allo','Real',IVECSVC, nconf)
        call getmem('kcnf','allo','inte',ivkcnf,nactel)
      end if

      Call Timing(Alfex_1,Swatch,Swatch,Swatch)
      Rc_CI = 0
      IPRLEV=IPRLOC(3)

* allocate space for CI-vectors
      l1 = nKeep
      l2 = l1*l1
      l3 = (l2+l1)/2
C Trying to avoid writing out of bound in CSDTVC :::: JESPER :::: CHEAT
      Call GetMem('Vector1','Allo','Real',iVec1,ndet)
      Call GetMem('Vector2','Allo','Real',iVec2,ndet)
      Call GetMem('Vector3','Allo','Real',iVec3,ndet)
      Call GetMem('Esmall','Allo','Real',iEs,l1)
      Call GetMem('Hsmall','Allo','Real',iHs,l3)
      Call GetMem('Ssmall','Allo','Real',iSs,l3)
      Call GetMem('Csmall','Allo','Real',iCs,l2)
      Call GetMem('Scr1','Allo','Real',iScr1,l2)
      Call GetMem('Scr2','Allo','Real',iScr2,l2)
      Call GetMem('Scr3','Allo','Real',iScr3,lRoots*nSel)
      Call GetMem('Scr4','Allo','Real',iScr4,lRoots*nSel)
      Call GetMem('Scr5','Allo','Real',iScr5,lRoots*nSel)
      CALL GetMem('CTEMP','ALLO','REAL',kctemp,ndet)
      CALL GetMem('SIGTEM','ALLO','REAL',ksigtemp,ndet)
*-------------------------------------------------------------------

* Print convergence thresholds in ITERFILE
      ThrRes = Max(0.2d-6,SQRT(ThrEne))
      Write(IterFile,'(19X,A,F18.10)') '- Threshold for energy   ...:',
     &         ThrEne
      Write(IterFile,'(19X,A,F18.10)') '- Threshold for Residual ...:',
     &         ThrRes
      Write(IterFile,'(20A4)') ('****',i=1,20)
      Write(IterFile,*)
      Write(IterFile,'(1X,A4,4X,A4,4X,A18,4X,A14,4X,A14)')
     &       'Iter','Root','Energy','dE','Residual'
      Write(IterFile,'(72A1)') ('=',i=1,72)
      Call xFlush(IterFile)
*===================================================================
* start long loop over iterations
      nconverged=0
      iskipconv=1
      nnew=0
      nvec=lRoots
      Do iterci=1,mxItr
*-------------------------------------------------------------------
*MGD for stability purposes recompute sigma vec from time to time
         idelta=1
         if ((mod(iterci-1,24).eq.0)) idelta=0
         Do mRoot=lRoots*idelta+1,lRoots+nnew
* New CI vectors (iterci,mroot) are available.
* compute new sigma vectors
            Call Load_CI_vec(mRoot,nConf,Work(iVec1),LuDavid)
            If ( iprlev.ge.DEBUG ) then
               lPrint = Min(nConf,200)
               Write (6,'(1X,A,I2,A,I2)')
     &              'CI vector, iter =',iterci,' mRoot =',mRoot
               Write (6,'(1X,A)')
     &              '(max. 200 elements)'
               Write (6,'(1X,A)')
     &              '-----------------------------'
               Call dVcPrt(' ',' ',Work(iVec1),lPrint)
            End If

            Call Timing(Rolex_1,Swatch,Swatch,Swatch)
            IF (DOFARO) THEN
              ! determinant wavefunctions
              allocate(sgm(ndeta,ndetb))
              allocate(psi(ndeta,ndetb))

              CALL DCOPY_(NCONF, [0.0D0], 0, WORK(IVECSVC), 1)
              CALL REORD2(MY_NORB,NACTEL,1,0,
     &                    IWORK(KICONF(1)),IWORK(KCFTP),
     &                    WORK(IVEC1),WORK(IVECSVC),IWORK(IVKCNF))
              CALL CITRANS_SORT('C',WORK(IVECSVC),WORK(IVEC2))
              PSI = 0.0D0
              CALL CITRANS_CSF2SD(WORK(IVEC2),PSI)
              SGM = 0.0D0
              CALL SIGMA_UPDATE(HTU,GTUVX,SGM,PSI)
              CALL CITRANS_SD2CSF(SGM,WORK(IVEC2))
              CALL CITRANS_SORT('O',WORK(IVEC2),WORK(IVECSVC))
              Call Reord2(my_norb,NACTEL,1,1,
     &                    iWork(KICONF(1)),iWork(KCFTP),
     &                    Work(IVECSVC),Work(IVEC2),iWork(ivkcnf))

              If ( iprlev.ge.DEBUG ) then
                FP=DNRM2_(NCONF,WORK(IVEC2),1)
                WRITE(6,'(1X,A,F21.14)') 'sigma dnrm2_(faroald): ', FP
              End If

              ! free the arrays
              deallocate(sgm,psi)
            Else
C     Convert the CI-vector from CSF to Det. basis
              call dcopy_(nconf, work(ivec1), 1, work(kctemp),1)
              call dcopy_(ndet, [0.0d0], 0, work(ksigtemp), 1)
              CALL csdtvc(work(kctemp), work(ksigtemp), 1, work(kdtoc)
     &           ,iwork(kicts(1)), LSym, 1)
              call dcopy_(ndet, [0.0d0], 0, work(ksigtemp), 1)
              c_pointer = kctemp
C     Calling Lucia to determine the sigma vector
              CALL Lucia_Util('Sigma',iDummy,iDummy,Dummy)
C     Set mark so densi_master knows that the Sigma-vector exists on disk.
              iSigma_on_disk = 1
              CALL CSDTVC(work(iVec2), work(kctemp), 2, work(kdtoc),
     &           iWork(kicts(1)), LSym, 1)

              If ( iprlev.ge.DEBUG ) then
                FP=DNRM2_(NCONF,WORK(IVEC2),1)
                WRITE(6,'(1X,A,F21.14)') 'sigma dnrm2_(lucia):   ', FP
              End If
            End If

C  Add ECORE_HEX (different from zero when particle-hole formalism used)
            ECORE_HEX = GET_ECORE()
            call daxpy_(nconf,ecore_hex,work(iVec1),1,work(iVec2),1)
C Timings on generation of the sigma vector
            Call Timing(Rolex_2,Swatch,Swatch,Swatch)
            Rolex_2 = Rolex_2 - Rolex_1
            Rolex_3 = Rolex_3 + Rolex_2

            If ( iprlev.ge.DEBUG ) then
               lPrint = Min(nConf,200)
               Write (6,*) ' '
               Write (6,'(1X,A,I2,A,I2)')
     &              'sigma vector, iter =',iterci,' mRoot =',mRoot
               Write (6,'(1X,A)')
     &              '(max. 200 elements)'
               Write (6,'(1X,A)')
     &              '--------------------------------'
               Call dVcPrt(' ',' ',Work(iVec2),lPrint)
            End If
            Call Save_Sig_vec(mRoot,nConf,Work(iVec2),LuDavid)
         End Do
* Sigma vectors (iterci,mroot) have been computed, for mroot=1..lroots
*-------------------------------------------------------------------
* compute Hsmall and Ssmall
* These are Hsmall(jtrial,ktrial), where jtrial is (jter,jroot), and
* ktrial is (kter,kroot), and similar Ssmall.
* jtrial=1..mxKeep*lroots correspond to jter=iterci-mxKeep+1..iterci
* (Fewer, at the beginning)

         jtrial = 0
         Do jRoot = 1,nvec
            Call Load_CI_vec(jRoot,nConf,Work(iVec1),LuDavid)
            Call Load_Sig_vec(jRoot,nConf,Work(iVec2),LuDavid)
            Do kRoot = 1,jRoot
               Call Load_CI_vec(kRoot,nConf,Work(iVec3),LuDavid)
               ij = kRoot+(jRoot*jRoot-jRoot)/2
               Sji = dDot_(nConf,Work(iVec1),1,Work(iVec3),1)
               Hji = dDot_(nConf,Work(iVec2),1,Work(iVec3),1)
               Work(iSs+ij-1) = Sji
               Work(iHs+ij-1) = Hji
            End Do
         End Do
         ntrial=nvec
         If ( iprlev.ge.DEBUG ) then
            Call TriPrt('Hsmall',' ',Work(iHs),ntrial)
            Call TriPrt('Ssmall',' ',Work(iSs),ntrial)
         End If
* Hsmall and Ssmall have been computed (ntrial x ntrial, in triangular
* storage.)
*-------------------------------------------------------------------

* solve secular equation HC=SCE.

* PAM2009 nBasVec on input=min(ntrial,nconf)
* nBasVec returned as nr of orthonormal solutions to HC=SCE
         nBasVec=nConf
         Call HCSCE(ntrial,
     &        Work(iHs),Work(iSs),Work(iCs),Work(iEs),nBasVec)
         If ( nBasVec.lt.lRoots ) then
            Write(6,*) 'David: nBasVec less than lRoots'
            Write(6,*) 'nBasvec, lRoots = ',nBasVec, lRoots
            If ( ICIRST.EQ.1 ) Write(6,*) 'CIREstart was used. ',
     & 'Check the number of roots in the previous calculation'
            Call Abend
         Endif
         If ( iprlev.ge.DEBUG ) then
            Call dVcPrt('Eigenvalues of Hsmall',' ',
     &           Work(iEs),ntrial)
            Call RecPrt('Eigenvectors of Hsmall',' ',
     &           Work(iCs),ntrial,ntrial)
         End If
*-------------------------------------------------------------------
* compute the current 'best' CI, sigma and residual vector

* CI vector is Work(iVec1)
* sigma vector is saved in Work(iVec2)
* residual vector is saved in Work(iVec3)
         Do mRoot=1,lRoots
*...      initialize 'best' CI and sigma vector
            Call dCopy_(nConf,[0.0d0],0,Work(iVec1),1)
            Call dCopy_(nConf,[0.0d0],0,Work(iVec2),1)
*...      accumulate contributions
            jtrial = 0
            Do jRoot=1,nvec
               Cik=Work(iCs-1+jRoot+(mRoot-1)*ntrial)
               Call Load_CI_vec(jRoot,nConf,Work(iVec3),LuDavid)
               Call Daxpy_(nConf,Cik,Work(iVec3),1,Work(iVec1),1)
               Call Load_Sig_vec(jRoot,nConf,Work(iVec3),LuDavid)
               Call Daxpy_(nConf,Cik,Work(iVec3),1,Work(iVec2),1)
            End Do
            RR = dDot_(nConf,Work(iVec1),1,Work(iVec1),1)
            scl=1.0d0/sqrt(RR)
            Call DScal_(nConf,scl,Work(iVec1),1)
            Call DScal_(nConf,scl,Work(iVec2),1)
            Call Save_tmp_CI_vec(mRoot,nConf,Work(iVec1),LuDavid)
            Call Save_tmp_Sig_vec(mRoot,nConf,Work(iVec2),LuDavid)
*...      compute residual vector
            E0 = Work(iEs+mRoot-1)
            Call dCopy_(nConf,Work(iVec2),1,Work(iVec3),1)
            call daxpy_(nConf,-E0,Work(iVec1),1,Work(iVec3),1)
*...      save current best energy and residual
            RR = dDot_(nConf,Work(iVec3),1,Work(iVec3),1)
            CI_conv(1,mroot,iterci) = E0
            CI_conv(2,mroot,iterci) = SQRT(RR)
*...  print vectors
            If ( iprlev.ge.DEBUG ) then
               lPrint = Min(nConf,200)
               Write (6,'(1X,A,I2,A,I2)')
     &              'new best CI vector, iter =',iterci,' mRoot =',mRoot
               Write (6,'(1X,A)')
     &              '(max. 200 elements)'
               Write (6,'(1X,A)')
     &              '--------------------------------------'
               Call dVcPrt(' ',' ',Work(iVec1),lPrint)
               Write (6,'(1X,A,I2,A,I2)')
     &           'new best sigma vector, iter =',iterci,' mRoot =',mRoot
               Write (6,'(1X,A)')
     &              '(max. 200 elements)'
               Write (6,'(1X,A)')
     &              '-----------------------------------------'
               Call dVcPrt(' ',' ',Work(iVec2),lPrint)
               Write (6,'(1X,A,I2,A,I2)')
     &           'new residual vector, iter =',iterci,' mRoot =',mRoot
               Write (6,'(1X,A)')
     &              '(max. 200 elements)'
               Write (6,'(1X,A)')
     &              '-----------------------------------------'
               Call dVcPrt(' ',' ',Work(iVec3),lPrint)
            End If
*...      to improve the preconditioner select all elements in the
*...      subspace of the explicit Hamiltonian
            If ( nSel.gt.1 ) then
               iOff = (mRoot-1)*nSel
               Do i = 1,nSel
                  iConf = iSel(i)
                  Work(iScr3+iOff+i-1) = Work(iVec3+iConf-1)
                  Work(iScr4+iOff+i-1) = Work(iVec1+iConf-1)
               End Do
            End If
         End Do
* Current best CI & Sigma vectors have been stored in a temporary place
* for mroot=1..lroots.
* Also, the selected elements of the CI and Sigma vectors have been
* saved at Work(iScr3)(Sigma)  and Work(iScr4)(CI)
*-------------------------------------------------------------------

* check for convergence
         nItr = iterci
         If ( iterci.gt.1 ) then
            dE = CI_conv(1,1,iterci-1) - CI_conv(1,1,iterci)
         Else
            dE = 0.0d0
         End If
         Write(IterFile,'(1X,I4,4X,I4,4X,F18.10,4X,F14.10,4X,F14.10)')
     &          IterCi,1,CI_conv(1,1,iterci),dE,
     &          CI_conv(2,1,iterci)
         Do jRoot = 2,lRoots
            If ( iterci.gt.1 ) then
               dE = CI_conv(1,jroot,iterci-1) - CI_conv(1,jroot,iterci)
            End If
            Write(IterFile,'(9X,I4,4X,F18.10,4X,F14.10,4X,F14.10)')
     &              jRoot,CI_conv(1,jroot,iterci),dE,
     &              CI_conv(2,jroot,iterci)
         End Do
         If (lRoots .gt. 1) Write(IterFile,*)
         Call xFlush(IterFile)
         If ( iprlev.gt.DEBUG ) then
            Write (6,*)
            Write (6,'(1X,120A1)')('*',i=1,120)
            Write (6,'(1X,A,I2)') 'CI iteration ',iterci
            ThrRes = Max(0.2d-6,SQRT(ThrEne))
            Write (6,'(1X,A,2F18.10)') 'ThrEne,ThrRes=',ThrEne,ThrRes
            Do jRoot = 1,lRoots
               If ( iterci.gt.1 ) then
                  dE =CI_conv(1,jroot,iterci-1)-CI_conv(1,jroot,iterci)
               Else
                  dE = 0.0d0
               End If
               Write (6,'(1X,A,I2,A,F18.10,2(A,F14.10))')
     &          ' root ',jRoot,
     &          ' energy =',CI_conv(1,jroot,iterci),
     &          ' dE =',dE,
     &          ' residual =',CI_conv(2,jroot,iterci)
            End Do
            Write (6,'(1X,120A1)')('*',i=1,120)
            Write (6,*)
         End If
         ThrRes = Max(0.2d-6,SQRT(ThrEne))
         iConv = 0
         nconverged=0
*Do not check for convergence of hidden roots
         Do jRoot=1,lRoots-hroots
            If ( iterci.gt.1 ) then
               dE = CI_conv(1,jroot,iterci-1) - CI_conv(1,jroot,iterci)
            Else
               dE = 0.0d0
            End If
            dE = abs(dE)
            R  = CI_conv(2,jroot,iterci)
            If ( (dE.lt.ThrEne) .and. (R.lt.ThrRes) ) Then
               iConv = iConv+1
               If (jRoot.eq.nconverged+1) nconverged=nconverged+1
            EndIf
         End Do
         if (iskipconv.eq.0) nconverged=0
         If ( iConv.ge.lRoots-hroots ) Goto 100
*-------------------------------------------------------------------
* compute correction vectors q1 = r/(E0-H) and q2 = c/(E0-H)

         nleft=lRoots-nconverged
         If ( nSel.gt.1 ) then
            ioff=nconverged*nSel
            Call DGEMM_('T','N',
     &                  nSel,nleft,nSel,
     &                  1.0d0,ExplV,nSel,
     &                  Work(iScr3+ioff),nSel,
     &                  0.0d0,Work(iScr5),nSel)
            Do mRoot=nconverged+1,lRoots
               E0 = Work(iEs+mRoot-1)
               iOff = (mRoot-nconverged-1)*nSel
               Do i = 1,nSel
                  Z = E0-ExplE(i)
                  If ( Abs(Z).lt.0.001d0 ) Z = 0.001d0
                  Work(iScr5+iOff+i-1) = Work(iScr5+iOff+i-1)/Z
               End Do
            End Do
            Call DGEMM_('N','N',
     &                  nSel,nleft,nSel,
     &                  1.0d0,ExplV,nSel,
     &                  Work(iScr5),nSel,
     &                  0.0d0,Work(iScr3),nSel)
            ioff=nconverged*nSel
            Call DGEMM_('T','N',
     &                  nSel,nleft,nSel,
     &                  1.0d0,ExplV,nSel,
     &                  Work(iScr4+ioff),nSel,
     &                  0.0d0,Work(iScr5),nSel)
            Do mRoot=nconverged+1,lRoots
               E0 = Work(iEs+mRoot-1)
               iOff = (mRoot-nconverged-1)*nSel
               Do i = 1,nSel
                  Z = E0-ExplE(i)
                  If ( Abs(Z).lt.0.001d0 ) Z = 0.001d0
                  Work(iScr5+iOff+i-1) = Work(iScr5+iOff+i-1)/Z
               End Do
            End Do
            Call DGEMM_('N','N',
     &                  nSel,nleft,nSel,
     &                  1.0d0,ExplV,nSel,
     &                  Work(iScr5),nSel,
     &                  0.0d0,Work(iScr4),nSel)
         End If
*-------------------------------------------------------------------
         Do mRoot=nconverged+1,lRoots
            E0 = -Work(iEs+mRoot-1)
            Call Load_tmp_Sig_vec(mRoot,nConf,Work(iVec1),
     &                LuDavid)
            Call Load_tmp_CI_vec(mRoot,nConf,Work(iVec2),LuDavid)
            call daxpy_(nConf,E0,Work(iVec2),1,Work(iVec1),1)
            Call Load_H_diag(nConf,Work(iVec3),LuDavid)
            E0 = Work(iEs+mRoot-1)
            Do i = 0,nConf-1
               Z = E0-Work(iVec3+i)
               If ( ABS(Z).lt.1.0d-4 ) Z = 1.0d-4
               Work(iVec3+i) = Work(iVec1+i)/Z
            End Do
            If ( nSel.gt.1 ) then
               iOff = (mRoot-nconverged-1)*nSel
               Do i = 1,nSel
                  iConf = iSel(i)
                  Work(iVec3+iConf-1) = Work(iScr3+iOff+i-1)
               End Do
            End If
            Alpha(mRoot) = dDot_(nConf,Work(iVec3),1,Work(iVec2),1)
            Call Load_H_diag(nConf,Work(iVec3),LuDavid)
            E0 = Work(iEs+mRoot-1)
            Do i = 0,nConf-1
               Z = E0-Work(iVec3+i)
               If ( ABS(Z).lt.1.0d-4 ) Z = 1.0d-4
               Work(iVec3+i) = Work(iVec2+i)/Z
            End Do
            If ( nSel.gt.1 ) then
               iOff = (mRoot-nconverged-1)*nSel
               Do i = 1,nSel
                  iConf = iSel(i)
                  Work(iVec3+iConf-1) = Work(iScr4+iOff+i-1)
               End Do
            End If
            Beta(mRoot) = dDot_(nConf,Work(iVec3),1,Work(iVec2),1)
         End Do
*-------------------------------------------------------------------

* compute correction vectors q3 = (r-E1*q2)/(E0-H)
         If ( nSel.gt.1 ) then
            Do mRoot=nconverged+1,lRoots
               Call Load_tmp_Sig_vec(mRoot,nConf,Work(iVec1),
     &                     LuDavid)
               Call Load_tmp_CI_vec(mRoot,nConf,Work(iVec2),
     &                     LuDavid)
               E0 = -Work(iEs+mRoot-1)
               call daxpy_(nConf,E0,Work(iVec2),1,Work(iVec1),1)
               E1 = -Alpha(mRoot)/Beta(mRoot)
               call daxpy_(nConf,E1,Work(iVec2),1,Work(iVec1),1)
               iOff = (mRoot-nconverged-1)*nSel
               Do i = 1,nSel
                  iConf = iSel(i)
                  Work(iScr3+iOff+i-1) = Work(iVec1+iConf-1)
               End Do
            End Do
            Call DGEMM_('T','N',
     &                  nSel,nleft,nSel,
     &                  1.0d0,ExplV,nSel,
     &                  Work(iScr3),nSel,
     &                  0.0d0,Work(iScr5),nSel)
            Do mRoot=nconverged+1,lRoots
               E0 = Work(iEs+mRoot-1)
               iOff = (mRoot-nconverged-1)*nSel
               Do i = 1,nSel
                  Z = E0-ExplE(i)
                  If ( Abs(Z).lt.0.001d0 ) Z = 0.001d0
                  Work(iScr5+iOff+i-1) = Work(iScr5+iOff+i-1)/Z
               End Do
            End Do
            Call DGEMM_('N','N',
     &                  nSel,nleft,nSel,
     &                  1.0d0,ExplV,nSel,
     &                  Work(iScr5),nSel,
     &                  0.0d0,Work(iScr3),nSel)
         End If
*move the index of CI_vec
         istart=istart+nnew
         istart=mod(istart,nkeep-n_Roots)
*
         nnew=0
         Do mRoot=nconverged+1,lRoots
            Call Load_tmp_Sig_vec(mRoot,nConf,Work(iVec1),
     &                    LuDavid)
            Call Load_tmp_CI_vec(mRoot,nConf,Work(iVec2),LuDavid)
            E0 = -Work(iEs+mRoot-1)
            call daxpy_(nConf,E0,Work(iVec2),1,Work(iVec1),1)
            E1 = -Alpha(mRoot)/Beta(mRoot)
            call daxpy_(nConf,E1,Work(iVec2),1,Work(iVec1),1)
            Call Load_H_diag(nConf,Work(iVec3),LuDavid)
            E0 = Work(iEs+mRoot-1)
            Do i = 0,nConf-1
               Z = E0-Work(iVec3+i)
               If ( ABS(Z).lt.1.0d-4 ) Z = 1.0d-4
               Work(iVec3+i) = Work(iVec1+i)/Z
            End Do
            If ( nSel.gt.1 ) then
               iOff = (mRoot-nconverged-1)*nSel
               Do i = 1,nSel
                  iConf = iSel(i)
                  Work(iVec3+iConf-1) = Work(iScr3+iOff+i-1)
               End Do
            End If
*Orthonormalize wrt previous vectors
            updsiz=dnrm2_(nconf,Work(iVec3),1)
            scl=1.0D0/updsiz
            Call DScal_(nConf,scl,Work(iVec3),1)
            Do jRoot=lRoots+1,min(nvec,nkeep-nconverged)
               Call Load_CI_vec(jRoot,nConf,Work(iVec2),LuDavid)
               ovl = dDot_(nConf,Work(iVec3),1,Work(iVec2),1)
               call daxpy_(nConf,-ovl,Work(iVec2),1,Work(iVec3),1)
            End Do
            updsiz=dnrm2_(nconf,Work(iVec3),1)
            If (updsiz.gt.1.0d-6) then
              scl=1.0D0/updsiz
              Call DScal_(nConf,scl,Work(iVec3),1)
              nnew=nnew+1
              nvec=nvec+1
              nvec=min(nvec,nkeep)
              Call Save_CI_vec(lRoots+mRoot-nconverged,nConf,
     &                         Work(iVec3),LuDavid)
            EndIf
         End Do
*-------------------------------------------------------------------
* move the current best CI and sigma vectors to the first place
* in the list of retained CI vectors
         Do mRoot=1,lRoots
           Call Load_tmp_CI_vec(mRoot,nConf,Work(iVec1),LuDavid)
           Call Save_CI_vec(mRoot,nConf,Work(iVec1),LuDavid)
           Call Load_tmp_Sig_vec(mRoot,nConf,Work(iVec1),LuDavid)
           Call Save_Sig_vec(mRoot,nConf,Work(iVec1),LuDavid)
         End Do

* end of the long loop over iterations
      End Do
*===================================================================

      mxItr = Min(mxCiIt,mxItr+12)
      If (IPRLEV.ge.USUAL) Then
        Write (6,*) '       ',
     &     'No convergence in the CI section: ',
     &     'MAXJT will be increased to ',mxItr
      End If
      Rc_CI = 16
      nItr=nItr-1
* deallocate local temporary vectors
 100  CALL GetMem('CTEMP','Free','REAL',kctemp,ndet)
      CALL GetMem('SIGTEM','Free','REAL',ksigtemp,ndet)
      Call GetMem('Vector1','Free','Real',iVec1,ndet)
      Call GetMem('Vector2','Free','Real',iVec2,ndet)
      Call GetMem('Vector3','Free','Real',iVec3,ndet)
      Call GetMem('Esmall','Free','Real',iEs,l1)
      Call GetMem('Hsmall','Free','Real',iHs,l3)
      Call GetMem('Ssmall','Free','Real',iSs,l3)
      Call GetMem('Csmall','Free','Real',iCs,l2)
      Call GetMem('Scr1','Free','Real',iScr1,l2)
      Call GetMem('Scr2','Free','Real',iScr2,l2)
      Call GetMem('Scr3','Free','Real',iScr3,lRoots*nSel)
      Call GetMem('Scr4','Free','Real',iScr4,lRoots*nSel)
      Call GetMem('Scr5','Free','Real',iScr5,lRoots*nSel)
      If (DoFaro) Then
        CALL GetMem('CIVEC','Free','Real',IVECSVC, nconf)
        call getmem('kcnf','free','inte',ivkcnf,nactel)
      End If

      Call Timing(Alfex_2,Swatch,Swatch,Swatch)
      Alfex_2 = Alfex_2 - Alfex_1
      Alfex_3 = Alfex_3 + Alfex_2

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!  ********************************************************
!  ** Public-domain library routines used by casvb only. **
!  ********************************************************
!  **********************
!  ** EISPACK ROUTINES **
!  **********************

subroutine eltran(nm,n,low,igh,a,intx,z)
! this subroutine is a translation of the algol procedure elmtrans,
! num. math. 16, 181-204(1970) by peters and wilkinson.
! handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
!
! this subroutine accumulates the stabilized elementary
! similarity transformations used in the reduction of a
! real general matrix to upper hessenberg form by  elmhes.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.
!
!    n is the order of the matrix.
!
!    low and igh are integers determined by the balancing
!      subroutine  balanc.  if  balanc  has not been used,
!      set low=1, igh=n.
!
!    a contains the multipliers which were used in the
!      reduction by  elmhes  in its lower triangle
!      below the subdiagonal.
!
!    intx contains information on the rows and columns
!      interchanged in the reduction by  elmhes.
!      only elements low through igh are used.
!
! on output
!
!    z contains the transformation matrix produced in the
!      reduction by  elmhes.
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n, low, igh, intx(igh)
real(kind=wp), intent(in) :: a(nm,igh)
real(kind=wp), intent(out) :: z(nm,n)
integer(kind=iwp) :: i, j, kl, mm, mp, mp1

! .......... initialize z to identity matrix ..........
z(1:n,:) = Zero
do j=1,n
  z(j,j) = One
end do

kl = igh-low-1
! .......... for mp=igh-1 step -1 until low+1 do -- ..........
do mm=1,kl
  mp = igh-mm
  mp1 = mp+1

  z(mp1:igh,mp) = a(mp1:igh,mp-1)

  i = intx(mp)
  if (i == mp) cycle

  z(mp,mp:igh) = z(i,mp:igh)
  z(i,mp) = One
  z(i,mp+1:igh) = Zero

end do

return

end subroutine eltran

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine xerror(Label,ix,ier,lvl)

use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: ix, ier, lvl

write(u6,*) 'Terminate in xerror!'
write(u6,'(a)') Label
write(u6,'(a,i5)') 'ix=',ix
write(u6,'(a,i5)') 'ier=',ier
write(u6,'(a,i5)') 'lvl=',lvl
call Abend()

return

end subroutine xerror

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine rdbis_cvb(ivec,n,ioffset)
c  Buffered integer IO with integer offset
      implicit real*8 (a-h,o-z)
#include "bufio_cvb.fh"
#include "idbl_cvb.fh"
      dimension ivec(n)
      logical debug
      data debug/.false./

      if(n.le.0)return

      ibuf_min=ioffset/lbuf+1
      ibuf_max=(ioffset+n-1)/lbuf+1
      ivec_offs=1
      do 100 jbuf=ibuf_min,ibuf_max
      i_min=max(1,ioffset+1-(jbuf-1)*lbuf)
      i_max=min(lbuf,ioffset+n-(jbuf-1)*lbuf)

      if(ibuf.ne.jbuf)then
c  Following line only needed if reads and writes can be mixed
        call bufio_wrbuf_cvb()
        call bufio_chbuf_cvb(jbuf)
        call bufio_rdbuf_cvb()
      endif
      call imove_cvb(ibuffer(i_min),ivec(ivec_offs),i_max-i_min+1)
      ivec_offs=ivec_offs+i_max-i_min+1
100   continue

      if(debug)then
        write(6,*)' rdbis :',n,ioffset
        write(6,'(40i4)')ivec
      endif
      ioffset=ioffset+n
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2023, Ignacio Fdez. Galvan                             *
************************************************************************

      SUBROUTINE Cho_Amatrix(XMAT,CMO,NCMO,DDTR,NATR)
! Calculation of the "exchange" matrix for the G1,G2,G3 Fock operators
! from Cholesky vectors

      use Symmetry_Info, only: Mul
      USE Index_Functions, ONLY: nTri_Elem
      USE Data_Structures, ONLY: Allocate_DT, Deallocate_DT, DSBA_Type
      USE CHOVEC_IO, ONLY: NVLOC_CHOBATCH
      USE stdalloc, ONLY: mma_allocate, mma_deallocate
      USE Constants, ONLY: Zero, One, Half
      use caspt2_module, only: nSym, nIsh, nAsh, nSsh, nOSqT,
     &                         nOrb, nBtch, nBtches

      IMPLICIT NONE
      INTEGER :: NCMO, NATR
      REAL*8 :: XMAT(NOSQT), CMO(NCMO), DDTR(NATR)
      INTEGER :: I, IB1, IB2, IBGRP, ISYM, J, JSYM, MXBGRP, MXCHOBUF,
     &           MXINT, MXPIQK, NADDBUFF, NBUF, NCHOBUF, NINTS, NLB,
     &           NLK, NV
      INTEGER, ALLOCATABLE :: BGRP(:,:,:), ICA(:), ICI(:), ICV(:),
     &                        IXMAT(:), NBGRP(:), NVEC(:,:)
      REAL*8, ALLOCATABLE :: BRABUF(:), KETBUF(:)
      REAL*8, ALLOCATABLE, TARGET :: INTBUF(:)
      TYPE(DSBA_Type) :: HDSQ
      INTEGER, PARAMETER :: Inac=1, Acti=2, Virt=3

      ! Transform Cholesky vectors, this will have to be redone after
      ! the modified Fock matrix is diagonalized
      CALL TRACHO3(CMO,NCMO)

      ! Square (Dd) to simplify multiplication
      CALL Allocate_DT(HDSQ,NASH,NASH,NSYM,Label='HDSQ')
      I = 1
      DO ISYM=1,NSYM
        CALL Square(DDTR(I),HDSQ%Sb(ISYM)%A1,1,NASH(ISYM),NASH(ISYM))
        I = I+nTri_Elem(NASH(ISYM))
      END DO
      ! To include a 1/2 factor in the final matrix, just scale (Dd)
      HDSQ%A0(:) = Half*HDSQ%A0(:)

      ! Get offsets and sizes
      CALL mma_allocate(IXMAT,NSYM,Label='IXMAT')
      CALL mma_allocate(NBGRP,NSYM,Label='NBGRP')
      MXINT = 0
      MXBGRP = 0
      DO ISYM=1,NSYM
        ! Offsets of symmetry blocks in XMAT
        IF (ISYM == 1) THEN
          IXMAT(ISYM) = 1
        ELSE
          IXMAT(ISYM) = IXMAT(ISYM-1)+NORB(ISYM-1)**2
        END IF
        ! Max size for integral matrix
        DO JSYM=1,NSYM
          I = Mul(ISYM,JSYM)
          NINTS = MAX(NISH(I),NASH(I),NSSH(I))
          MXINT = MAX(MXINT,(NINTS*NASH(JSYM))**2)
        END DO
        MXBGRP = MAX(MXBGRP,NBTCH(ISYM))
      END DO
      CALL mma_allocate(INTBUF,MXINT,Label='INTBUF')
      CALL mma_allocate(BGRP,2,MXBGRP,NSYM,Label='BGRP')
      MXBGRP = 0
      MXCHOBUF = 0
      DO ISYM=1,NSYM
        ! Batch groups per symmetry
        NBGRP(ISYM) = NBTCH(ISYM)
        DO I=1,NBGRP(ISYM)
          BGRP(:,I,ISYM) = NBTCHES(ISYM)+I
        END DO
        ! Max size for Cholesky vectors
        CALL MEMORY_ESTIMATE(ISYM,BGRP(:,:,ISYM),NBGRP(ISYM),NCHOBUF,
     &                       MXPIQK,NADDBUFF)
        MXBGRP = MAX(MXBGRP,NBGRP(ISYM))
        MXCHOBUF = MAX(MXCHOBUF,NCHOBUF)
      END DO
      ! Number of Cholesky vectors per group and symmetry
      CALL mma_allocate(NVEC,MXBGRP,NSYM,Label='NVEC')
      NVEC(:,:) = 0
      DO ISYM=1,NSYM
        DO IBGRP=1,NBGRP(ISYM)
          DO I=BGRP(1,IBGRP,ISYM),BGRP(2,IBGRP,ISYM)
            NVEC(IBGRP,ISYM) = NVEC(IBGRP,ISYM)+NVLOC_CHOBATCH(I)
          END DO
        END DO
      END DO

      CALL mma_allocate(BRABUF,MXCHOBUF,Label='BRABUF')
      CALL mma_allocate(KETBUF,MXCHOBUF,Label='KETBUF')

      ! Now fetch Cholesky vectors and accumulate the A_pq matrix
      CALL mma_allocate(ICI,NSYM,Label='ICI')
      CALL mma_allocate(ICA,NSYM,Label='ICA')
      CALL mma_allocate(ICV,NSYM,Label='ICV')
      DO ISYM=1,NSYM
        ! Index of symmetry blocks in Cholesky vectors,
        ! according to the active orbital symmetry
        J = 0
        ICI(Mul(ISYM,1)) = J
        ICA(1) = 0
        ICV(1) = 0
        DO JSYM=1,NSYM-1
          I = Mul(ISYM,JSYM)
          J = J+NISH(JSYM)*NASH(I)
          ICI(Mul(ISYM,JSYM+1)) = J
          ICA(JSYM+1) = ICA(JSYM)+NASH(JSYM)*NASH(I)
          ICV(JSYM+1) = ICV(JSYM)+NASH(JSYM)*NSSH(I)
        END DO
        DO IBGRP=1,NBGRP(ISYM)
          IB1 = BGRP(1,IBGRP,ISYM)
          IB2 = BGRP(2,IBGRP,ISYM)
          NV = NVEC(IBGRP,ISYM)
          IF (NV == 0) EXIT
          ! Inactive-Inactive
          CALL Get_Cholesky_Vectors(Inac,Acti,ISYM,BRABUF,NBUF,IB1,IB2)
          CALL Accum(Inac,Inac,BRABUF,BRABUF,ICI,ICI)
          ! Inactive-Active
          CALL Get_Cholesky_Vectors(Acti,Acti,ISYM,KETBUF,NBUF,IB1,IB2)
          CALL Accum(Inac,Acti,BRABUF,KETBUF,ICI,ICA)
          ! Active-Active
          CALL Accum(Acti,Acti,KETBUF,KETBUF,ICA,ICA)
          ! Inactive-Virtual
          CALL Get_Cholesky_Vectors(Virt,Acti,ISYM,KETBUF,NBUF,IB1,IB2)
          CALL Accum(Inac,Virt,BRABUF,KETBUF,ICI,ICV)
          ! Virtual-Virtual
          CALL Accum(Virt,Virt,KETBUF,KETBUF,ICV,ICV)
          ! Active-Virtual
          ! We could have saved these Cholesky vectors,
          ! but there's joy in repetition
          CALL Get_Cholesky_Vectors(Acti,Acti,ISYM,BRABUF,NBUF,IB1,IB2)
          CALL Accum(Acti,Virt,BRABUF,KETBUF,ICA,ICV)
        END DO
      END DO

      CALL GADSum(XMAT,NOSQT)

      CALL Deallocate_DT(HDSQ)
      CALL mma_deallocate(IXMAT)
      CALL mma_deallocate(NBGRP)
      CALL mma_deallocate(BGRP)
      CALL mma_deallocate(NVEC)
      CALL mma_deallocate(BRABUF)
      CALL mma_deallocate(KETBUF)
      CALL mma_deallocate(INTBUF)
      CALL mma_deallocate(ICI)
      CALL mma_deallocate(ICA)
      CALL mma_deallocate(ICV)

      RETURN

      CONTAINS

      SUBROUTINE Accum(bBlock,kBlock,bBuf,kBuf,IB,IK)

      INTEGER :: bBlock, kBlock, IB(NSYM), IK(NSYM)
      REAL*8 :: bBuf(*), kBuf(*)
      INTEGER :: B1, BS, BSWCH, bOff(NSYM), I, II, IJ, IJT, J, JA, JJ,
     &           K1, KS, KSWCH, kOff(NSYM), NA, NB(NSYM), NK(NSYM),
     &           PQSYM, TUSYM
      LOGICAL :: diag
      REAL*8, POINTER, CONTIGUOUS :: INT2(:,:)
      REAL*8, EXTERNAL :: dDot_

      ! NB,NK = number of orbitals in bra/ket (not including NA factor)
      ! bOff,kOff = offset or starting orbital in bra/ket
      ! QB,QK = index function for bra/ket
      ! BSWCH,KSWCH = aux switch for generalizing integral access
      !               (1 if inactive, which come before active)
      BSWCH = 0
      SELECT CASE (bBlock)
        CASE (Inac)
          NB(:) = NISH(1:NSYM)
          bOff(:) = 0
          BSWCH = 1
        CASE (Acti)
          NB(:) = NASH(1:NSYM)
          bOff(:) = NISH(1:NSYM)
        CASE (Virt)
          NB(:) = NSSH(1:NSYM)
          bOff(:) = NISH(1:NSYM)+NASH(1:NSYM)
        CASE DEFAULT ! Nothing compares 2 U
          ! (just to keep compilers happy)
          NB(:) = 0
          bOff(:) = 0
          CALL Abend()
      END SELECT
      KSWCH = 0
      SELECT CASE (kBlock)
        CASE (Inac)
          NK(:) = NISH(1:NSYM)
          kOff(:) = 0
          KSWCH = 1
        CASE (Acti)
          NK(:) = NASH(1:NSYM)
          kOff(:) = NISH(1:NSYM)
        CASE (Virt)
          NK(:) = NSSH(1:NSYM)
          kOff(:) = NISH(1:NSYM)+NASH(1:NSYM)
        CASE DEFAULT
          NK(:) = 0
          kOff(:) = 0
          CALL Abend()
      END SELECT
      ! Is this a diagonal block?
      diag = bBlock == kBlock

      ! We want (pt|qu) integrals of symmetry ISYM, with:
      !   t,u of symmetry TUSYM
      !   p,q of symmetry PQSYM
      DO TUSYM=1,NSYM
        PQSYM = Mul(ISYM,TUSYM)
        NA = NASH(TUSYM)
        ! Reconstruct the (bBlock,Active|kBlock,Active) integrals
        NLB = NB(PQSYM)*NA
        NLK = NK(PQSYM)*NA
        CALL dgemm_('N','T',NLB,NLK,NV,One,bBUF(IB(TUSYM)*NV+1),NLB,
     &              kBUF(IK(TUSYM)*NV+1),NLK,Zero,INTBUF,NLB)
        IF (NLB*NLK == 0) CYCLE
        INT2(1:NLB,1:NLK) => INTBUF(1:NLB*NLK)

        ! Accumulate A_pq = sum_tu (pt|qu)*(Dd)_tu
        ! BS,KS = step sizes for traversing active orbitals in INT2
        !         (= 1 if inactive, = NB,NK otherwise)
        BS = (NB(PQSYM)-1)*(1-BSWCH)+1
        KS = (NK(PQSYM)-1)*(1-KSWCH)+1
        ! B1,K1 = for getting the index of the 1st active orbital
        !         (= NA if inactive, = 1 otherwise)
        B1 = (NA-1)*BSWCH+1
        K1 = (NA-1)*KSWCH+1
        DO J=1,NK(PQSYM)
          DO I=1,NB(PQSYM)
            ! Index of this element in XMAT
            IJ = IXMAT(PQSYM)+
     &           (kOff(PQSYM)+J-1)*NORB(PQSYM)+bOff(PQSYM)+I-1
            ! Index of (p1|**) and (**|q1)
            II = (I-1)*B1+1
            JJ = (J-1)*K1+1
            DO JA=1,NA
              XMAT(IJ) = XMAT(IJ)+dDot_(NA,INT2(II:,JJ),BS,
     &                   HDSQ%SB(TUSYM)%A2(:,JA),1)
              JJ = JJ+KS
            END DO
            ! Symmetric element
            IF (diag .AND. (I == J)) EXIT
            IJT = IXMAT(PQSYM)+
     &            (bOff(PQSYM)+I-1)*NORB(PQSYM)+kOff(PQSYM)+J-1
            XMAT(IJT) = XMAT(IJ)
          END DO
        END DO
        NULLIFY(INT2)
      END DO

      END SUBROUTINE Accum

      END SUBROUTINE Cho_Amatrix

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Ignacio Fdez. Galvan                             *
************************************************************************

      Subroutine MnBrak2(ax,bx,cx,fa,fb,fc,f,
     &                 q_a,q_b,dipole_a,dipole_b,r_a,r_b)
      Implicit None
      Real*8 :: ax, bx, cx, fa, fb, fc, vx, fv, coefA, coefB
      Logical :: Def
      Real*8, Parameter :: Ratio = 0.5D0*(Sqrt(5.0D0)+1.0D0)
      Real*8, Parameter :: Thr = 1.0D-20, Lim = 100.0D0
c External function f and its arguments
      Real*8, External :: f
      Real*8 :: q_a,q_b,dipole_a,dipole_b,r_a,r_b
      Logical, Parameter :: Absolute=.True.

#include "real.fh"
      fa = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,ax,Absolute)
      fb = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,bx,Absolute)
      If (fa .lt. fb) Then
        cx = ax
        ax = bx
        bx = cx
        fc = fa
        fa = fb
        fb = fc
      End If
      ! three points such that b is between a and c,
      ! and f(a) > f(b) > f(c), stop when f(c) > f(b)
      cx = bx + Ratio*(bx-ax)
      fc = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,cx,Absolute)
      Do While (fc .le. fb)
        write(6,*) ax,bx,cx
        Def = .True.
        ! try a parabolic fitting
        coefA = (   cx*(fb-fa)+   bx*(fa-fc)+   ax*(fc-fb))
        coefB = (cx**2*(fa-fb)+bx**2*(fc-fa)+ax**2*(fb-fc))
        ! only worth it if the points are not linear and
        ! if the 2nd derivative is positive
        If ((Abs(coefA) .gt. Thr) .and. coefA*(ax-cx) .gt. Zero) Then
          vx = -Half*coefB/coefA
          ! v is between b and c
          If ((cx-vx)*(vx-bx) .gt. Zero) Then
            fv = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,vx,Absolute)
            ! minimum between b and c
            If (fv .lt. fc) Then
              ax = bx
              bx = vx
              fa = fb
              fb = fv
              Return
            ! minimum between a and v
            Else If (fv .gt. fb) Then
              cx = vx
              fc = fv
              Return
            End If
          ! v is beyond c, but within limits
          Else If ((bx+Lim*(cx-bx)-vx)*(vx-cx) .gt. Zero) Then
            fv = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,vx,Absolute)
            ! whatever happens, replace c,v -> b,c
            bx = cx
            cx = vx
            fb = fc
            fc = fv
            ! minimum between b and v
            If (fv .gt. fc) Then
              ax = bx
              fa = fb
              Return
            End If
          ! v is beyond the limit, cutoff to the limit
          Else If ((vx-cx)*(cx-bx) .gt. Zero) Then
            fv = bx + Lim*(cx-bx)
            Def = .False.
          End If
        End If
        ! unless the fit went beyond limits, use default step
        If (Def) Then
          vx = cx + Ratio*(cx-bx)
          fv = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,vx,Absolute)
        End If
        ax = bx
        bx = cx
        cx = vx
        fa = fb
        fb = fc
        fc = fv
      End Do

      End Subroutine MnBrak2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_shell_pairs

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_get_shell_pairs, fmm_free_shell_pairs

   TYPE(fmm_sh_pairs), ALLOCATABLE, TARGET :: sh_pairs(:)

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_shell_pairs(basis,sh_pairs_ptr)

      TYPE(fmm_basis), INTENT(IN) :: basis
      TYPE(fmm_sh_pairs), POINTER :: sh_pairs_ptr(:)
      INTEGER(INTK) :: n_pairs

      IF (ALLOCATED(sh_pairs)) THEN
         sh_pairs_ptr => sh_pairs
      ELSE
         ! make list of non-vanishing shell pairs
         CALL fmm_make_shell_pairs(basis,n_pairs)  ! first get n_pairs
         ALLOCATE(sh_pairs(n_pairs))
         CALL fmm_make_shell_pairs(basis,n_pairs)  ! now store list
         sh_pairs_ptr => sh_pairs
!FIXME add to fmm_stats
write(6,*) 'Number of shell pairs =', SIZE(sh_pairs)
      END IF

   END SUBROUTINE fmm_get_shell_pairs

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_free_shell_pairs

      IF (ALLOCATED(sh_pairs)) DEALLOCATE(sh_pairs)

   END SUBROUTINE fmm_free_shell_pairs

!-------------------------------------------------------------------------------

   FUNCTION fmm_extent(ExpPI)

!      USE fmm_md4_globals, ONLY: fmm_shell_pair_ThrFac, fmm_X0
!      USE fmm_md4_globals, ONLY: fmm_grain_inv, fmm_extent_min
!      USE fmm_box_utils,   ONLY: fmm_branch

      IMPLICIT NONE

      REAL(REALK), INTENT(IN) :: ExpPI

      REAL(REALK), PARAMETER :: root3 = 1.7320508075688772d0
!      REAL(REALK)   :: tmp1, tmp2
      REAL(REALK)   :: fmm_extent
!      INTEGER(INTK) :: bra_min

!      REAL(REALK), PARAMETER :: erfc_inv = 3.4589  ! 1e-6
!      REAL(REALK), PARAMETER :: erfc_inv = 4.0522  ! 1e-8
!      REAL(REALK), PARAMETER :: erfc_inv = 4.5728  ! 1e-10
!      REAL(REALK), PARAMETER :: erfc_inv = 5.6739  ! 1e-15

!      fmm_extent = fmm_X0*ExpPI

      ! Extent based on Classical overlap
!      tmp1 = SQRT(ExpPI)*erfc_inv

!      ! Artificial extent to keep all near-field exact integrals
!      bra_min = fmm_branch(fmm_extent_min,fmm_grain_inv)
!      tmp2 = half*root3*(bra_min+1)/fmm_grain_inv

!      tmp2 = zero
!      fmm_extent = MAX(tmp1,tmp2)

      fmm_extent = SQRT(ExpPI*LOG(1d10))

   END FUNCTION fmm_extent

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_make_shell_pairs(basis,n_pairs)

!      USE fmm_md4_globals, ONLY: fmm_shell_pair_ThrFac

      IMPLICIT NONE

      TYPE(fmm_basis), INTENT(IN)  :: basis
      INTEGER(INTK),   INTENT(OUT) :: n_pairs

!      REAL(REALK), PARAMETER :: ThrFac = fmm_shell_pair_ThrFac
      REAL(REALK), PARAMETER :: ThrFac = 1d-12

      INTEGER(INTK) :: II,JJ, I,J
      INTEGER(INTK) :: IPrim1, JPrim1
      INTEGER(INTK) :: IPrim2, JPrim2, IJPrim, JPTemp2
      REAL(REALK)   :: Acentr(3), Bcentr(3), ABcentr(3), P(3), PM(3), RAB(3)
      REAL(REALK)   :: ExpA, ExpB, ExpP, ExpPI, ExpAR2
      REAL(REALK)   :: R2AB, ExpKAB, tmp_ext, extent

      n_pairs = 0

      Ishel: DO II = 1, basis%nshells

         Acentr(:) = basis%Centr(:,basis%KAtom(II))
         IPrim1 = basis%KStart(II)
         IPrim2 = IPrim1 + basis%KontG(II) - 1

         Jshel: DO JJ = 1, II

            Bcentr(:) = basis%Centr(:,basis%KAtom(JJ))
            JPrim1 = basis%KStart(JJ)
            JPrim2 = JPrim1 + basis%KontG(JJ) - 1

            ABcentr(:) = Half * (Acentr(:) + Bcentr(:))
            RAB(:) = Acentr(:) - Bcentr(:)
            R2AB = DOT_PRODUCT(RAB,RAB)

            extent = zero
            IJPrim = 0
            DO I = IPrim1, IPrim2
               ExpA = basis%Expnt(I)
               ExpAR2 = ExpA * R2AB
               JPTemp2 = JPrim2
               IF (II == JJ) JPTemp2 = I
               DO J = JPrim1, JPTemp2
                  ExpB = basis%Expnt(J)
                  ExpP = ExpA + ExpB
                  ExpPI = One / ExpP
                  ExpKAB = - ExpAR2 * ExpB * ExpPI
                  IF (ExpKAB >= ThrFac) THEN
                     IJPrim = IJPrim +1
                     P(:) = (ExpA * Acentr(:) + ExpB * Bcentr(:)) * ExpPI
                     PM(:) = P(:) - ABcentr(:)
                     tmp_ext = fmm_extent(ExpPI)
                     tmp_ext = tmp_ext + SQRT(DOT_PRODUCT(PM,PM))
                     extent = MAX( extent, tmp_ext )
                  END IF
               END DO
            END DO

            IF (IJPrim > 0) THEN
               n_pairs = n_pairs + 1
               IF (ALLOCATED(sh_pairs)) THEN
                  IF (n_pairs > SIZE(sh_pairs)) CALL fmm_quit('get_sh_pairs')
                  sh_pairs(n_pairs)%I = II
                  sh_pairs(n_pairs)%J = JJ
                  sh_pairs(n_pairs)%extent = extent
                  sh_pairs(n_pairs)%centre(:) = ABcentr(:)
               END IF
            END IF

         END DO Jshel

      END DO Ishel

   END SUBROUTINE fmm_make_shell_pairs

!-------------------------------------------------------------------------------

END MODULE fmm_shell_pairs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine opens the runfile.                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund university, Sweden                                     *
! Written: August 2003                                                 *
!                                                                      *
!***********************************************************************

subroutine OpnRun(iRc,Lu,iOpt)

use RunFile_data, only: Arr2RunHdr, icRd, IDRun, nHdrSz, NulPtr, RunHdr, RunName, VNRun
use Para_Info, only: nProcs
#ifdef _MOLCAS_MPP_
use Para_Info, only: mpp_workshare
#endif
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iRc, Lu
integer(kind=iwp), intent(in) :: iOpt
integer(kind=iwp) :: Arr(nHdrSz), iDisk
logical(kind=iwp) :: ok
character(len=64) :: ErrMsg
integer(kind=iwp), external :: isFreeUnit

!----------------------------------------------------------------------*
! Check that arguments are ok.                                         *
!----------------------------------------------------------------------*
if (iOpt /= 0) then
  write(ErrMsg,*) 'Illegal option flag:',iOpt
  call SysAbendMsg('OpnRun',ErrMsg,' ')
end if
iRc = 0
!----------------------------------------------------------------------*
! Does the runfile exist? If not abort.                                *
!----------------------------------------------------------------------*
call f_inquire(RunName,ok)
if (.not. ok) call SysAbendmsg('gxRdRun','RunFile does not exist',' ')
!----------------------------------------------------------------------*
! Open runfile and check that file is ok.                              *
!----------------------------------------------------------------------*
Lu = isFreeUnit(11)

RunHdr%ID = NulPtr
RunHdr%Ver = NulPtr
call DaName(Lu,RunName)
iDisk = 0
call iDaFile(Lu,icRd,Arr,nHdrSz,iDisk)
call Arr2RunHdr(Arr)
if (RunHdr%ID /= IDrun) then
  call DaClos(Lu)
  call SysFilemsg('gxWrRun','Wrong file type, not a RunFile',Lu,' ')
  call Abend()
end if
if (RunHdr%Ver /= VNrun) then
  call DaClos(Lu)
  call SysFilemsg('gxWrRun','Wrong version of RunFile',Lu,' ')
  call Abend()
end if
ok = RunHdr%nProcs == nProcs
#ifdef _MOLCAS_MPP_
if (.not. mpp_workshare) ok = .true.
#endif
if (.not. ok) then
  write(u6,*) 'Abend: Parallel environment has changed since runfile was created!'
  write(u6,*) 'RunHdr%nProcs/=nProcs'
  write(u6,*) 'RunHrd%nProcs=',RunHdr%nProcs
  write(u6,*) 'nProcs=',nProcs
  call Abend()
end if
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine OpnRun

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine updRotMat(SmallRot,RotMat)

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: SmallRot(3)
real(kind=wp), intent(inout) :: RotMat(3,3)
integer(kind=iwp) :: i, j, k
real(kind=wp) :: rsum, SmallMat(3,3), tmp(3,3)

call mkRotMat(SmallRot,SmallMat)
tmp(:,:) = Zero
do i=1,3
  do j=1,3
    do k=1,3
      tmp(i,j) = tmp(i,j)+RotMat(i,k)*SmallMat(k,j)
    end do
  end do
end do
RotMat(:,:) = tmp(:,:)
! Check for orthonormality:
do i=1,3
  do j=1,3
    if (i == j) then
      rsum = -One
    else
      rsum = Zero
    end if
    do k=1,3
      rsum = rsum+RotMat(i,k)*RotMat(j,k)
    end do
    if (abs(rsum) > 1.0e-10_wp) write(u6,*) ' UPDROTMAT ON check sum error:',rsum
  end do
end do

return

end subroutine updRotMat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2009, Francesco Aquilante                              *
************************************************************************
      SUBROUTINE FWT_Haar(n,m,B,X)
************************************************************************
*
*     Author :  F. Aquilante  (Geneva, March 2009)
*
*
*     Purpose : performs a Fast Wavelet Transform (FWT)
*               of 2^m vectors X_1(n),X_2(n),...,X_2^m(n)
*               using m-th order Haar wavelet.
*
*
*     n : number of components of each vector (input)
*     m : order of Haar wavelet = Log_2 of the number of vectors (input)
*     B(n,2^m-1) : scratch array (input)
*     X(n,2^m) : array of initial/transformed vectors (input/output)
*
************************************************************************
*
*     Mallat's pyramid algorithm (IEEE Trans PAMI, 11, 674-693, 1989) :
*
*        (X_1,X_2,X_3,X_4,...,X_2^m) ---> (A[0],B[0],B[1],...,B[m-1])
*
*        j=m,m-1,...,1
*                       B[j-1] = H[j] * A[j]
*                       A[j-1] = L[j] * A[j]
*
*
*        The matrices H[j] and L[j] have:
*
*        2^(j-1) orthonormal rows, and
*
*        2^j cols pair-orthonormal (merging col k and k+1, the result is
*                 2^(j-1) orthonormal cols each containing 2^j elements)
*
*        and very few nonzero entries.
*
*        High Pass (differencing) filters:
*
*                   [  1 -1                          ]
*                   [        1 -1                    ]
*        H[j] = 1/2 [              ....              ]
*                   [                    ....        ]
*                   [                          1 -1  ]
*
*        Low Pass (averaging) filters:
*
*                   [  1  1                          ]
*                   [        1  1                    ]
*        L[j] = 1/2 [              ....              ]
*                   [                    ....        ]
*                   [                          1  1  ]
*
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Integer n, m
      Real*8  B(n,*), X(n,*)

      Parameter ( hlf=0.5d0 )
*
*
*
      If (m .le. 0) Then

         Write(6,*) ' FWT_Haar: Illegal value of m = ',m
         Call Abend

      ElseIf (n .le. 0) Then

         Write(6,*) ' FWT_Haar: Illegal value of n = ',n
         Call Abend

      ElseIf (n .gt. 50) Then  ! use BLAS

         Call FWT_Haar_(n,m,B,X)

      Else  ! do not use BLAS

         fac=sqrt(hlf)
         nv=2**m
         Do j=m,1,-1  ! A[m]:=X
            nv=nv/2
            kB=nv
            Do k=1,nv
               kA=2*k
               lA=kA-1
               Do i=1,n
                  B(i,kB) = fac*(X(i,lA)-X(i,kA))
                  X(i,k) = fac*(X(i,lA)+X(i,kA))
               End Do
               kB=kB+1
            End Do
         End Do
         Do j=1,2**m-1
            k=j+1  ! A[0] is already in place
            Do i=1,n
               X(i,k)=B(i,j)
            End Do
         End Do

      EndIf
*
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      SUBROUTINE FWT_Haar_(n,m,B,X)
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Integer n, m
      Real*8  B(n,*), X(n,*)

      Parameter ( hlf=0.5d0, one=1.0d0, xone=-1.0d0 )

      fac=sqrt(hlf)
      nv=2**m
      mv=n*nv
      Do j=m,1,-1  ! A[m]:=X
         nv=nv/2
         kB=nv
         call dcopy_(n,X(1,1),1,B(1,kB),1)
         Call daxpy_(n,xone,X(1,2),1,B(1,kB),1)
         call dscal_(n,fac,B(1,kB),1)
         Call daxpy_(n,one,X(1,2),1,X(1,1),1)
         call dscal_(n,fac,X(1,1),1)
         Do k=2,nv
            kB=kB+1
            jB=2*k
            lB=jB-1
            call dcopy_(n,X(1,lB),1,B(1,kB),1)
            Call daxpy_(n,xone,X(1,jB),1,B(1,kB),1)
            call dscal_(n,fac,B(1,kB),1)
            Call daxpy_(n,one,X(1,jB),1,X(1,lB),1)
            call dcopy_(n,X(1,lB),1,X(1,k),1)
            call dscal_(n,fac,X(1,k),1)
         End Do
      End Do
      call dcopy_(mv-n,B(1,1),1,X(1,2),1) ! A[0] is already in place
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       SubRoutine CISigma(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,
     &                    Int2a,nInt2a,ipCI1,ipCI2, Have_2_el)
       use ipPage, only: W
       use Arrays, only: KAIN1, KINT2, KINT2A, pInt1
       Implicit Real*8(a-h,o-z)
*
#include "Pointers.fh"

#include "Input.fh"
#include "stdalloc.fh"
#include "genop.fh"
#include "cands.fh"
#include "detdim.fh"
#include "cstate_mclr.fh"
#include "cicisp_mclr.fh"
       Real*8, Target:: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
       Logical Have_2_el
       integer kic(2),opout
       Real*8, Allocatable:: CIDET(:)
*
*      Interface Anders to Jeppe
*      This interface initiates Jeppes common block
*      and will make it easier to use Anders modifications
*      of the CI routines
*
*      OK first tell Jeppe where the integrals are.
*
       !> yma: notice the nconf1 if DMRG

       If (nconf1.eq.0) return
*
*      One electron integrals
*
       KAIN1=>Int1
*
*      Two electron integrals
*      symmetric in perticle one and two
*
       KINT2=>Int2s
*
*      Two electron integrals
*      anti symmetric in perticle one and two
*
       KINT2A=>Int2a
*
       irefsm=iCSym
*
*      Do we have any twoelectron integrals?
*
       If (Have_2_el) Then
         i12=2
       Else
         i12=1
       End If
*
*      Symmetry of Sigma vector
*
       iSSM=iSSym
       kic(2)=2
       if (issm.eq.State_sym) kic(2)=1
*
*      Symmetry of CI vector
*
       iCSM=iCSym
       kic(1)=2
       if (icsm.eq.State_sym) kic(1)=1
*
*      Symmetry properties of operator
*
       ndet=nint(max(xispsm(iSSym,1),xispsm(iCSym,1)))
       ndet=Max(ndet,ncsf(icsym),ncsf(issym))

       If (ndet.eq.0) Return
       iOP=iEOr(iCSM-1,iSSm-1)+1
       If (iOp.eq.1) Then
         Call iCopy(nSym,ipCM,1,pInt1,1)
       Else
         Do iS=1,nSym
          jS=iEor(iS-1,iOp-1)+1
          pInt1(is)=ipMat(is,jS)
         End Do
       End If
*
*      Triplet/Singlet operator
*
       ist=iispin+1
       square=.false.
*
       If (.not.page) Then

       Call mma_allocate(CIDET,nDet,Label='CIDET')
#ifdef _MS_
       irc=ipin(ipCI1)
       irc=ipin(ipci2)
       Do i=0,nroots-1
          call dcopy_(nCSF(iCSM),W(ipCI1)%Vec(1+i*ncsf(icsm)),1,
     &                        CIDET,1)
          Call SigmaVec(CIDET,
     &               W(ipci2)%Vec(1+i*ncsf(issm)),kic)
       End Do
#else
       call dcopy_(nCSF(iCSM),W(ipCI1)%Vec,1,CIDET,1)

       Call SigmaVec(CIDET,W(ipci2)%Vec,kic)

#endif
       Call mma_deallocate(CIDET)
       Else
        irc=ipnout(ipci2)

        irc=ipin1(ipCI1,ndet)
        irc=ipin(ipci2)
        Call SigmaVec(W(ipCI1)%Vec,W(ipci2)%Vec,kic)
        irc=opout(ipci1)

       End If
*
       Return
#ifdef _WARNING_WORKAROUND_
       If (.False.) Call Unused_integer(irc)
#endif
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2008, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine CD_Decomposer(CD_Col,CD_Vec,MxNumCho,Thr,Span,MxQual,ThrNeg,ThrFail,Diag,Qual,Buf,iPivot,iQual,nDim,lBuf,NumCho,irc)
!
! Thomas Bondo Pedersen, October 2004.
! Modified to compute at most MxNumCho vectors,
!    Thomas Bondo Pedersen, January 2008.
!
! Purpose: Cholesky decompose a matrix.
!          Stop decomposition when either
!          1) max. diag <= Thr
!          2) NumCho = MxNumCho
!
! To use criterion 1) only (standard procedure),
! simply set MxNumCho = nDim.
! To use criterion 2) only,
! simply set Thr=1.0e-20 (i.e. zero)
!
! Note: do *not* call this routine directly;
!       use ChoDec(...) or ChoDec_MxVec instead
!       (see those routines for documentation).
!       This routine contains implicit assumptions
!       that are checked by ChoDec and ChoDec_MxVec!!!
!
! Error codes, irc:
!    0 : all OK
!  301 : too few qualified (probably a bug)
!  302 : insufficient buffer size, lBuf
!  303 : too negative diagonal encountered
!        (matrix non-positive definite!)
!
! CD_Col : external routine for matrix columns
! CD_Vec : external routine for Cholesky vectors

use Cho_interfaces, only: cdcol_kernel, cdvec_kernel
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
procedure(cdcol_kernel) :: CD_Col
procedure(cdvec_kernel) :: CD_Vec
integer(kind=iwp), intent(in) :: MxNumCho, MxQual, nDim, lBuf
real(kind=wp), intent(in) :: Thr, Span, ThrNeg, ThrFail
real(kind=wp), intent(inout) :: Diag(nDim), Qual(nDim,MxQual), Buf(lBuf)
integer(kind=iwp), intent(out) :: iPivot(nDim), iQual(MxQual), irc
integer(kind=iwp), intent(inout) :: NumCho
integer(kind=iwp) :: i, iBatch, iCho, iChoMx, iDump, iOpt, iPass, iVec1, ix, jVec, kOff, kOff1, kOff2, kOffQ, kOffV, lVec, MinBuf, &
                     mPass, MxVec, nBatch, nQual, NumV, nVec
real(kind=wp) :: DiaMin, Dmax, Dx, Factor, xm
logical(kind=iwp) :: Last

irc = 0

iPass = 0
mPass = MxNumCho
do while (iPass < mPass)

  ! Update counter.
  ! ---------------

  iPass = iPass+1

  ! Find max. diagonal.
  ! -------------------

  Dmax = Diag(1)
  do i=2,nDim
    Dmax = max(Dmax,Diag(i))
  end do

  ! Check for convergence.
  ! ----------------------

  if ((Dmax > Thr) .and. (NumCho < MxNumCho)) then

    ! Find largest diagonal elements > DiaMin.
    ! I.e., qualify columns.
    ! ========================================

    nQual = min(MxQual,MxNumCho-NumCho)
    DiaMin = max(Dmax*Span,Thr)
    call CD_DiaMax(Diag,nDim,iPivot,iQual,nQual,DiaMin)

    if (nQual < 1) then ! this would be a bug...
      irc = 301
      return ! exit
    end if

    ! Get qualified columns from external routine.
    ! ============================================

    call CD_Col(Qual,nDim,iQual,nQual,Buf,lBuf)

    ! Subtract previous vectors (if any).
    ! ===================================

    if (NumCho > 0) then

      MinBuf = nDim+nQual
      nVec = min(NumCho,lBuf/MinBuf)
      if (nVec < 1) then  ! insufficient buffer size
        irc = 302
        return ! exit
      else
        nBatch = (NumCho-1)/nVec+1
      end if

      do iBatch=1,nBatch

        if (iBatch == nBatch) then
          NumV = NumCho-nVec*(nBatch-1)
        else
          NumV = nVec
        end if

        iVec1 = nVec*(iBatch-1)+1
        lVec = nDim*NumV

        kOffV = 1
        kOffQ = kOffV+lVec

        iOpt = 2
        call CD_Vec(iVec1,NumV,Buf(kOffV),lBuf-kOffV+1,nDim,iOpt)

        do jVec=1,NumV
          do i=1,nQual
            kOff1 = kOffQ+NumV*(i-1)+jVec-1
            kOff2 = kOffV+nDim*(jVec-1)+iQual(i)-1
            Buf(kOff1) = Buf(kOff2)
          end do
        end do

        call DGEMM_('N','N',nDim,nQual,NumV,-One,Buf(kOffV),nDim,Buf(kOffQ),NumV,One,Qual(:,:),nDim)

      end do

    end if

    ! Decompose.
    ! ==========

    MxVec = min(nQual,lBuf/nDim)
    iDump = 0
    iChoMx = nQual
    iCho = 0
    do while (iCho < iChoMx)

      ! Find max. among qualified.
      ! --------------------------

      Dx = Diag(iQual(1))
      ix = 1
      do i=2,nQual
        if (Diag(iQual(i)) > Dx) then
          Dx = Diag(iQual(i))
          ix = i
        end if
      end do

      Last = (Dx < DiaMin) .or. (Dx <= Thr)
      if (.not. Last) then

        ! Calculate new vector.
        ! ---------------------

        Factor = One/sqrt(Dx)
        do i=1,nDim
          if (Diag(i) == Zero) then
            Qual(i,ix) = Zero
          else
            Qual(i,ix) = Factor*Qual(i,ix)
          end if
        end do

        ! Update diagonal and find new max.
        ! ---------------------------------

        Diag(1) = Diag(1)-Qual(1,ix)*Qual(1,ix)
        xm = Diag(1)
        do i=2,nDim
          Diag(i) = Diag(i)-Qual(i,ix)*Qual(i,ix)
          xm = max(xm,Diag(i))
        end do

        ! Zero treated diagonal and find new DiaMin.
        ! ------------------------------------------

        Diag(iQual(ix)) = Zero
        DiaMin = max(xm*Span,Thr)

        ! Zero negative diagonals (quit if too negative).
        ! -----------------------------------------------

        do i=1,nDim
          if (Diag(i) < ThrNeg) then
            if (Diag(i) < ThrFail) then
              irc = 303
              return ! exit (too negative diagonal)
            else
              Diag(i) = Zero
            end if
          end if
        end do

        ! Subtract this vector from qualified columns.
        ! --------------------------------------------

        do i=1,nQual
          if (Diag(iQual(i)) /= Zero) Qual(:,i) = Qual(:,i)-Qual(iQual(i),ix)*Qual(:,ix)
        end do

        ! Store vector in buffer.
        ! -----------------------

        kOff = nDim*iDump
        Buf(kOff+1:kOff+nDim) = Qual(:,ix)

        ! Update counter.
        ! ---------------

        iDump = iDump+1

      end if

      ! Dump vectors to external routine CD_Vec.
      ! ----------------------------------------

      if (Last .or. (iDump == MxVec)) then
        if (iDump > 0) then
          iVec1 = NumCho+1
          iOpt = 1
          call CD_Vec(iVec1,iDump,Buf,lBuf,nDim,iOpt)
          NumCho = NumCho+iDump
        end if
        if (Last) then
          iCho = iChoMx+1 ! break iCho loop (next pass)
        else
          iDump = 0
          iCho = iCho+1
        end if
      end if

    end do

  else ! converged; break while loop

    iPass = mPass+1

  end if

end do

end subroutine CD_Decomposer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Integral_WrOut_LDF_Diag(
#define _FIXED_FORMAT_
#define _CALLING_
#include "int_wrout_interface.fh"
     &                                  )
*     calls the proper routines IndSft/PLF
*     if IntOrd_jikl==.TRUE. integral order within symblk: jikl
*                      else  integral order within symblk: ijkl
      Implicit Real*8 (a-h,o-z)
*
#include "int_wrout_interface.fh"
*
* call sorting routine
*
      If (mSym==1) Then
        Call PLF_LDF_Diag(TInt,nTInt,
     &           AOInt,ijkl,iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &           iShell,iAO,iAOst,Shijij.and.IJeqKL,
     &           iBas,jBas,kBas,lBas,kOp)
      Else
         Call WarningMessage(2,
     &            'Symmetry not implemented in Integral_WrOut_LDF_Diag')
         Call LDF_Quit(1)
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(MapOrg)
         Call Unused_real_array(SOInt)
         Call Unused_integer(nSOint)
         Call Unused_integer_array(iSOSym)
         Call Unused_integer(nSkal)
         Call Unused_integer_array(itOffs)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine calcrh1(wrk,wrksize,v1,v2)
! this routine calcs V1 = V1-V2
!
! v1 - map type of vector 1 (I)
! v2 - map type of vector 2 (I)
!
! N.B. it is assumed, that V1 and V2 are of the same type

use ccsd_global, only: Map_Type
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: v1, v2
integer(kind=iwp) :: ii, length, pos1, pos2

!1 calc length
ii = v1%d(0,5)
length = v1%d(ii,1)+v1%d(ii,2)-v1%d(1,1)

!2 realize substract
if (length > 0) then
  pos1 = v1%d(1,1)
  pos2 = v2%d(1,1)
  wrk(pos1:pos1+length-1) = wrk(pos1:pos1+length-1)-wrk(pos2:pos2+length-1)
end if

return

end subroutine calcrh1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1984, Per Ake Malmqvist                                *
************************************************************************
C---------------------------------------------------------------
      SUBROUTINE LU2 (NDIMEN,NBLOCK,NSIZE,CXA,CYB,SCR)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CXA(NDIMEN,NDIMEN),CYB(NDIMEN,NDIMEN),SCR(NDIMEN)
      DIMENSION NSIZE(NBLOCK)
C  GIVES A SIMULTANEOUS LU-PARTITIONING OF MATRICES CXA,CYB IN THE
C  SENSE THAT CXA*X = L1*U1 AND CYB*X = L2*U2, WHERE X IS A BLOCK
C  UNITARY MATRIX. X IS NEVER FORMED, BUT AT EACH STEP SUCH A
C  TRANSFORMATION IS APPLIED THAT THE LU PARTITIONING CAN BE
C  APPLIED IN AN OPTIMAL WAY -- THIS IS REFERRED TO AS A
C  UNITARY PSEUDO-PIVOTATION. MATRICES CXA AND CYB ARE DESTROYED,
C  AND WILL CONTAIN THE NONTRIVIAL ELEMENTS OF THE TRIANGULAR
C  MATRICES.
C                                         ( MALMQUIST 84-01-16 )
      NTOT=0
      DO IBLOCK=1,NBLOCK
        NTOT=NTOT+NSIZE(IBLOCK)
      END DO
      IF(NTOT.NE.NDIMEN) WRITE(6,*)' ERROR: NTOT.NE.NDIMEN IN LU2.'
      IEND=0
      DO IBLOCK=1,NBLOCK
        ISTA=IEND+1
        IEND=IEND+NSIZE(IBLOCK)
        DO II=ISTA,IEND
          S1=0.0D00
          S2=0.0D00
          S3=0.0D00
          DO J=II,IEND
            S1=S1+CXA(II,J)**2
            S2=S2+CYB(II,J)**2
            S3=S3+CXA(II,J)*CYB(II,J)
          END DO
          THR=1.0D-06
          IF((S1.LT.THR).OR.(S2.LT.THR)) THEN
            WRITE(6,*)' RASSI CANNOT CONTINUE. THE PROBLEM AT HAND'
            WRITE(6,*)' IS PROBABLY NOT SOLUBLE. THE TWO ORBITAL'
            WRITE(6,*)' SPACES ARE TOO DISSIMILAR.'
            WRITE(6,*)' LU PARTITIONING IS TROUBLESOME. DIAGONAL'
            WRITE(6,*)' ELEMENT NR.',II,' IS TOO SMALL:'
            WRITE(6,*)' IN MATRIX CXA IT IS', SQRT(S1)
            WRITE(6,*)' IN MATRIX CYB IT IS', SQRT(S2)
            WRITE(6,*)' EVEN AFTER OPTIMAL PIVOT-TRANSFORMATION.'
            CALL ABEND()
          END IF
          X1=1.0D00/SQRT(S1)
          X2=1.0D00/SIGN(SQRT(S2),S3)
          DO I=II,IEND
            SCR(I)=X1*CXA(II,I)+X2*CYB(II,I)
          END DO
          S=2.0D0*(1.0D00+X1*X2*S3)
          X=1.0D00/SIGN(SQRT(S),SCR(II))
          DO I=II,IEND
            SCR(I)=X*SCR(I)
          END DO
          X=1.0D00/(1.0D00+SCR(II))
          DO I=1,IEND
            S=0.0D00
            DO J=II,IEND
              S=S+CXA(I,J)*SCR(J)
            END DO
            S2=0.0D00
            DO J=II+1,IEND
              S2=S2+CXA(I,J)*SCR(J)
            END DO
            S2=CXA(I,II)+X*S2
            CXA(I,II)=S
            DO J=II+1,IEND
              CXA(I,J)=CXA(I,J)-S2*SCR(J)
            END DO
          END DO
          DO I=1,IEND
            S=0.0D00
            DO J=II,IEND
              S=S+CYB(I,J)*SCR(J)
            END DO
            S2=0.0D00
            DO J=II+1,IEND
              S2=S2+CYB(I,J)*SCR(J)
            END DO
            S2=CYB(I,II)+X*S2
            CYB(I,II)=S
            DO J=II+1,IEND
            CYB(I,J)=CYB(I,J)-S2*SCR(J)
            END DO
          END DO
          X=1.0D00/CXA(II,II)
          DO I=II+1,IEND
            CXA(I,II)=X*CXA(I,II)
            DO J=II+1,NTOT
              CXA(I,J)=CXA(I,J)-CXA(I,II)*CXA(II,J)
            END DO
          END DO
          X=1.0D00/CYB(II,II)
          DO I=II+1,IEND
            CYB(I,II)=X*CYB(I,II)
            DO J=II+1,NTOT
              CYB(I,J)=CYB(I,J)-CYB(I,II)*CYB(II,J)
            END DO
          END DO
        END DO
      END DO
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Roland Lindh                                     *
************************************************************************
      Subroutine Term_Ints(Verbose,Free_K2)
************************************************************************
*                                                                      *
*     Object: to deallocate memory in association with two-electron    *
*             calculations.                                            *
*                                                                      *
*     Author: Roland Lindh, Chemical Physics, University of Lund,      *
*             Sweden. January '98.                                     *
************************************************************************
      use k2_arrays, only: FT, Mem_DBLE, Mem_INT, Aux, iSOSym
      use Index_arrays
      Implicit Real*8 (A-H,O-Z)
*
#include "setup.fh"
#include "stdalloc.fh"
#include "nsd.fh"
#include "status.fh"
      Logical Verbose, Free_K2
*
      If (ERI_Status.eq.Inactive) Return
      ERI_Status=Inactive
*                                                                      *
************************************************************************
*                                                                      *
*     In case of semi-direct mode the memory is released externally.
*
      Call RlsMem_Ints()
*                                                                      *
************************************************************************
*                                                                      *
      If (Allocated(FT)) Call mma_deallocate(FT)
*
      If (Allocated(Mem_INT)) Then
         Call mma_deallocate(Mem_INT)
         Call mma_deallocate(Mem_DBLE)
         Call mma_deallocate(Aux)
      End If
*
      Call mma_deallocate(iSOSym)
*                                                                      *
************************************************************************
*                                                                      *
      If (Indexation_Status.eq.Active) Then
         Indexation_Status=Inactive
         Call mma_deallocate(nShBF)
         Call mma_deallocate(iShOff)
         Call mma_deallocate(iSh2Sh)
         Call mma_deallocate(iSO2Sh)
         Call mma_deallocate(iCntr)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Free memory for K2 data
*
      If (Free_K2) Call FreeK2()
*                                                                      *
************************************************************************
*                                                                      *
*     Generate statistic of partioning
*
      If (Verbose) Call StatP(1)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GS_Order(T,nInter,nVec)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nInter, nVec
real(kind=wp), intent(inout) :: T(nInter,nVec)
integer(kind=iwp) :: i, iDiag, j
real(kind=wp) :: Diag, DiagMax
real(kind=wp), external :: DDot_

#ifdef _DEBUGPRINT_
call RecPrt('GS_Order: T(orig)','(12F6.2)',T,nInter,nVec)
#endif
do j=1,nVec-1
  DiagMax = DDot_(nInter,T(:,j),1,T(:,j),1)
  iDiag = j
  do i=j+1,nVec
    Diag = DDot_(nInter,T(:,i),1,T(:,i),1)
    if (T(i,i) > DiagMax) then
      DiagMax = Diag
      iDiag = i
    end if
  end do
  if (iDiag /= j) call dswap_(nInter,T(:,iDiag),1,T(:,j),1)
end do
#ifdef _DEBUGPRINT_
call RecPrt('GS_Order: T(ordered)','(12F6.2)',T,nInter,nVec)
#endif

return

end subroutine GS_Order

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine loopcntr2_cvb(icode1,mxalter)
      implicit real*8(a-h,o-z)
#include "inpmod_cvb.fh"
#include "seth_cvb.fh"
#include "loopcntr_cvb.fh"
      logical begbracket

      loopstep=loopstep+1
      if(inputmode.eq.2.and.(icode1.eq.5.or.icode1.eq.6))return
      if(loopstep.gt.mxstep)then
        write(6,*)' Loop structure too complicated -- mxstep :',mxstep
        call abend_cvb()
      endif
      if(inputmode.eq.1)then
        icode(loopstep)=icode1
        ipos(loopstep)=mxalter
      endif
      if(icode(loopstep).eq.1.or.icode(loopstep).eq.3)
     >  joptstep=joptstep+1
      if(inputmode.eq.2)then
        if(joptstep.eq.ioptstep)call setifinish_cvb(icode(loopstep))
        begbracket=
     >    (icode(loopstep).eq.1.and.icode(loopstep+1).eq.2).or.
     >    (icode(loopstep).eq.3.and.icode(loopstep+1).eq.4)
        if(joptstep.ge.ioptstep+1.or.(joptstep.eq.ioptstep.
     >    and..not.begbracket))then
c  Goto end of input :
          icnt=ipos(loopstepmx)
          loopstep=loopstepmx
          joptstep=noptstep
        elseif(joptstep.lt.ioptstep.and.begbracket)then
c  Goto next closing bracket :
          icnt=ipos(loopstep+1)
          loopstep=loopstep+1
        endif
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine rhs_mp2_help2(iSymA,iSymB,iSymI,iSymJ,Int1,Int2,Scr1)

#include "intent.fh"

use MBPT2_Global, only: Density, Mp2Lagr
use Constants, only: One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSymA, iSymB, iSymI, iSymJ
real(kind=wp), intent(_OUT_) :: Int1(*), Int2(*), Scr1(*)
integer(kind=iwp) :: iA, iAA, iAK, iB, iBB, iC, iCC, iCI, iI, iIC, iJ, iK, iKA, nB, nJ
real(kind=wp) :: Fac, xacbi, xaibc, xiajk, xikja
#include "corbinf.fh"

!-----------------------------------------------------------------------
!write(u6,*) 'Starting subroutine with symmetries: '
!write(u6,*) 'I,J,A,B',I,J,iA,iB
!write(u6,*) 'NewSym',NewSym
!write(u6,*) 'IpoDens',IpoDens
!-----------------------------------------------------------------------

! Reads the <..|AB> - integrals for the L3-term

nB = nExt(iSymB)+nDel(iSymB)
do iA=1,nExt(iSymA)+nDel(iSymA)
  iAA = iA+nFro(iSymA)+nOcc(iSymA)
  ! Decide i the AB-matrix is symmetric, if so
  ! only loop over lower triangle
  if (iSymA == iSymB) nB = iA
  do iB=1,nB
    iBB = iB+nFro(iSymB)+nOcc(iSymB)

    call Exch(iSymI,iSymA,iSymJ,iSymB,iA+nOcc(iSymA)+nFro(iSymA),iB+nOcc(iSymB)+nFro(iSymB),Int1,Scr1)
    if (iSymA /= iSymB) then
      call Exch(iSymJ,iSymA,iSymI,iSymB,iA+nOcc(iSymA)+nFro(iSymA),iB+nOcc(iSymB)+nFro(iSymB),Int2,Scr1)
    end if
    !write(u6,*) 'iOrbA',iA,'iOrbB',iB
    !call RecPrt('Int1:','(8F10.6)',Int1,nOrb(iSymA)+nDel(iSymA),nOrb(iSymB)+nDel(iSymA))
    !if (iSymA /= iSymB) then
    !  call RecPrt('Int2:','(8F10.6)',Int2,nOrb(iSymB)+nDel(iSymB),nOrb(iSymA)+nDel(iSymA))
    !end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Lagrangian term 3
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    if ((iSymA == iSymI) .and. (iSymB == iSymJ)) then
      if ((iA == iB) .and. (iSymA == iSymB)) then
        Fac = Half
      else
        Fac = One
      end if
      iIC = (nFro(iSymB)+nOcc(iSymB))*(nOrb(iSymA)+nDel(iSymA))
      iCI = nFro(iSymB)+nOcc(iSymB)
      do iC=1,nExt(iSymB)+nDel(iSymB)
        iCC = iC+nFro(iSymB)+nOcc(iSymB)
        do iI=1,nOcc(iSymA)+nFro(iSymA)
          xaibc = Int1(iIC+iI+(iC-1)*(nOrb(iSymA)+nDel(iSymA)))
          if (iSymA == iSymB) then
            xacbi = Int1(iCI+iC+(iI-1)*(nOrb(iSymB)+nDel(iSymB)))
          else
            xacbi = Int2(iCI+iC+(iI-1)*(nOrb(iSymB)+nDel(iSymB)))
          end if
          Mp2Lagr%SB(iSymA)%A2(iI,iA) = Mp2Lagr%SB(iSymA)%A2(iI,iA)-Fac*Density%SB(iSymB)%A2(iCC,iBB)*(Two*xaibc-xacbi)
          if (iSymA == iSymB) then
            Mp2Lagr%SB(iSymA)%A2(iI,iB) = Mp2Lagr%SB(iSymA)%A2(iI,iB)-Fac*Density%SB(iSymB)%A2(iCC,iAA)*(Two*xacbi-xaibc)
          end if
          !write(u6,*) 'AIBC',iA,iI,iB,iC
          !write(u6,*) 'AIBC2',iB,iI,iA,iC
          !write(u6,*) 'icab',xaibc
          !write(u6,*) 'ibac',xacbi
          !write(u6,*) 'Dens',Density%SB(iSymB)%A2(iCC,iBB)
          !write(u6,*) 'Dens2',Density%SB(iSymB)%A2(iCC,iAA)
          !write(u6,*) 'A',(Two*xaibc-xacbi)
          !write(u6,*) 'A2',(Two*xacbi-xaibc)
          !write(u6,*) 'Bidrag',Density%SB(iSymB)%A2(iCC,iBB)*(Two*xaibc-xacbi)
          !write(u6,*) 'Bidrag2',Density%SB(iSymB)%A2(iCC,iAA)*(Two*xacbi-xaibc)

        end do
      end do

      ! And again we need another loop for the symmetries that isnt written
      ! explicitly. all references to A and B need to change too.

      if (iSymA /= iSymB) then
        iIC = (nFro(iSymA)+nOcc(iSymA))*(nOrb(iSymB)+nDel(iSymB))
        iCI = nFro(iSymA)+nOcc(iSymA)
        do iC=1,nExt(iSymA)+nDel(iSymA)
          iCC = iC+nFro(iSymA)+nOcc(iSymA)
          do iI=1,nFro(iSymB)+nOcc(iSymB)
            xaibc = Int1(iCI+iC+(iI-1)*(nOrb(iSymA)+nDel(iSymA)))
            xacbi = Int2(iIC+iI+(iC-1)*(nOrb(iSymB)+nDel(iSymB)))
            Mp2Lagr%SB(iSymB)%A2(iI,iB) = Mp2Lagr%SB(iSymB)%A2(iI,iB)-Fac*Density%SB(iSymA)%A2(iCC,iAA)*(Two*xaibc-xacbi)
          end do
        end do
      end if
    end if

  end do
end do
! Reads one block of <ij|..> at the time.

nJ = nFro(iSymJ)+nOcc(iSymJ)
do iI=1,nFro(iSymI)+nOcc(iSymI)
  ! Decide if the IJ-block i symmetric and
  ! if so only read a triangle
  if (iSymI == iSymJ) nJ = iI
  !***** Check if the IJ-matrix is symmetric, if so
  !      only loop over lower triangle.
  do iJ=1,nJ
    ! If we are only looping over a triangular matrix
    ! we need to count each offdiagonal element twice.
    ! Copy one AB-block of integrals to the workspace
    call Exch(iSymA,iSymI,iSymB,iSymJ,iI,iJ,Int1,Scr1)
    if (iSymI /= iSymJ) then
      call Exch(iSymB,iSymI,iSymA,iSymJ,iI,iJ,Int2,Scr1)
    end if
    !write(u6,*)
    !write(u6,*) ' *  i,j = ',iI,iJ
    !call RecPrt('Int1:','(8F10.6)',Int1,nOrb(iSymA),nOrb(iSymB))
    !if (iSymI /= iSymJ) then
    !  call RecPrt('Int2:','(8F10.6)',Int2,nOrb(iSymB),nOrb(iSymA))
    !end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Lagrangian term 4
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    if ((iSymI == iSymA) .and. (iSymJ == iSymB)) then
      if ((iI == iJ) .and. (iSymI == iSymJ)) then
        Fac = Half
      else
        Fac = One
      end if

      iKA = (nFro(iSymJ)+nOcc(iSymJ))*(nOrb(iSymI)+nDel(iSymI))
      iAK = nFro(iSymJ)+nOcc(iSymJ)
      do iK=1,nFro(iSymI)+nOcc(iSymI)
        do iA=1,nExt(iSymJ)+nDel(iSymJ)
          xikja = Int1(iKA+iK+(iA-1)*(nOrb(iSymI)+nDel(iSymI)))
          if (iSymI == iSymJ) then
            xiajk = Int1(iAK+iA+(iK-1)*(nOrb(iSymJ)+nDel(iSymJ)))
          else
            xiajk = Int2(iAK+iA+(iK-1)*(nOrb(iSymJ)+nDel(iSymJ)))
          end if
          Mp2Lagr%SB(iSymJ)%A2(iJ,iA) = Mp2Lagr%SB(iSymJ)%A2(iJ,iA)-Fac*Density%SB(iSymI)%A2(iK,iI)*(Two*xikja-xiajk)
          if (iSymI == iSymJ) then
            Mp2Lagr%SB(iSymJ)%A2(iI,iA) = Mp2Lagr%SB(iSymJ)%A2(iI,iA)-Fac*Density%SB(iSymI)%A2(iK,iJ)*(Two*xiajk-xikja)
          end if
          !write(u6,*) 'xikja',xikja
          !write(u6,*) 'xiajk',xiajk
        end do
      end do

      if (iSymI /= iSymJ) then
        iKA = (nFro(iSymI)+nOcc(iSymI))*(nOrb(iSymJ)+nDel(iSymJ))
        iAK = nFro(iSymI)+nOcc(iSymI)
        do iK=1,nFro(iSymJ)+nOcc(iSymJ)
          do iA=1,nExt(iSymI)+nDel(iSymI)
            xikja = Int1(iAK+iA+(iK-1)*(nOrb(iSymI)+nDel(iSymI)))
            xiajk = Int2(iKA+iK+(iA-1)*(nOrb(iSymJ)+nDel(iSymJ)))
            Mp2Lagr%SB(iSymI)%A2(iI,iA) = Mp2Lagr%SB(iSymI)%A2(iI,iA)-Fac*Density%SB(iSymJ)%A2(iK,iJ)*(Two*xikja-xiajk)
          end do
        end do
      end if
    end if
  end do
end do

return

end subroutine rhs_mp2_help2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRORB(CNO,OCC)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION CNO(NCMO),OCC(NBAST)
      CHARACTER*(LENIN8) CLEAN_BNAME
      EXTERNAL CLEAN_BNAME
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,*)'NATURAL ORBITALS IN AO BASIS. IN EACH SYMMETRY,'
      CALL XFLUSH(6)
      WRITE(6,*)'THE ORBITALS PRINTED ARE THOSE UP TO AND INCLUDING'
      CALL XFLUSH(6)
      WRITE(6,*)'THE LAST ORBITAL WITH OCCUPATION NUMBER LARGER'
      CALL XFLUSH(6)
      WRITE(6,'(A,F10.7)')' THAN THRORB = ',THRORB
      CALL XFLUSH(6)
      IEB=0
      IEM=0
      NDIV=10
      DO 100 ISYM=1,NSYM
         NB=NBAS(ISYM)
         IF(NB.EQ.0) GO TO 100
         NPRT=0
         DO 10 I=1,NB
            IF(OCC(IEB+I).GE.THRORB) NPRT=I
10       CONTINUE
         IF(NPRT.EQ.0) GO TO 40
         WRITE(6,'(/28X,''SYMMETRY LABEL'',I3)') ISYM
      CALL XFLUSH(6)
         DO 30 IST=1,NPRT,NDIV
           IEND=MIN(NPRT,IST-1+NDIV)
           WRITE(6,'(/5X,''ORBITAL'',6X,10I8)') (I,I=IST,IEND)
      CALL XFLUSH(6)
           WRITE(6,'( 5X,''OCC.NO.'',8X,10F8.5)')
     *              (OCC(IEB+I),I=IST,IEND)
      CALL XFLUSH(6)
           WRITE(6,*)
      CALL XFLUSH(6)
           DO 20 I=1,NB
              JSMO=IEM+I+NB*(IST-1)
              JEMO=IEM+I+NB*(IEND-1)
              WRITE(6,'(1X,I3,2X,A,10F8.4)')
     *                   I,CLEAN_BNAME(NAME(IEB+I),LENIN),
     *                   (CNO(J),J=JSMO,JEMO,NB)
      CALL XFLUSH(6)
20         CONTINUE
30       CONTINUE
40       CONTINUE
         IEB=IEB+NB
         IEM=IEM+NB*NB
100   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gather_t2_blocked(length1,length2,ngaf,ngal,ngbf,ngbl,t2,t2_tmp,tmp)
! length1 = length of the 1st VO index (=< vblock)
! length2 = length of the 2nd VO index (=< vblock)

use ChT3_global, only: DimGrpaR, LunAux, maxdim, no, T2Name
use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: length1, length2, ngaf, ngal, ngbf, ngbl
real(kind=wp), intent(inout) :: t2(length1*length2*no*no)
real(kind=wp), intent(out) :: t2_tmp(maxdim*maxdim*no*no), tmp(maxdim*maxdim*no*no)
integer(kind=iwp) :: a, a_tmp, b, b_tmp, dima, dimb, lasta, lastb, length
logical(kind=iwp) :: sym

sym = .false.

!mp if (ngaf == ngbf) sym = .true.
if ((ngaf == ngbf) .and. (ngal == ngbl)) sym = .true.

!mp write(u6,*)
!mp write(u6,*) '------ DimGrpaR ------'
!mp write(u6,'(8(i5,2x))') (DimGrpaR(a_tmp),a_tmp=1,NvGrp)
!mp write(u6,*)

do a=ngaf,ngal
  do b=ngbf,min(a,ngbl)

    dima = DimGrpaR(a)
    dimb = DimGrpaR(b)

    if (a == b) then  ! a=b
      length = nTri_Elem(dima)*no*no
      call GetX_t3(tmp,length,LunAux,T2Name(a,b),1,1)
    else ! a>b
      length = dima*dimb*no*no
      call GetX_t3(tmp,length,LunAux,T2Name(a,b),1,1)
    end if

    lasta = 0
    if (a > ngaf) then
      do a_tmp=ngaf,a-1
        lasta = lasta+DimGrpaR(a_tmp)
      end do
    end if

    lastb = 0
    if (b > ngbf) then
      do b_tmp=ngbf,b-1
        lastb = lastb+DimGrpaR(b_tmp)
      end do
    end if

    !mp write(u6,'(A,2(i5,2x),2(i3,x))') 'lasta, lastb, a, b = ',lasta,lastb,a,b

    if (a == b) then ! expand and map
      call expand4_12(tmp,t2_tmp,dima,no,no)
      call grow_t2_blocked(t2,t2_tmp,dima,dimb,no,lasta,lastb,length1,length2,sym)
    else
      call grow_t2_blocked(t2,tmp,dima,dimb,no,lasta,lastb,length1,length2,sym)
    end if

  end do
end do

return

end subroutine gather_t2_blocked

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRWF1(ISGSTRUCT,ICISTRUCT,NLEV,NMIDV,ISM,ICS,
     &                 NOCSF,IOCSF,NOW,IOW,ISYCI,CI,CITHR)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "Struct.fh"
#include "symmul.fh"
      Dimension iSGStruct(nSGSize)
      Dimension iCIStruct(nCISize)
#include "WrkSpc.fh"
      DIMENSION NOCSF(NSYM,NMIDV,NSYM),IOCSF(NSYM,NMIDV,NSYM)
      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)
      DIMENSION CI(*)
      DIMENSION ISM(NLEV), ICS(NLEV)
      LOGICAL SGINFO
      PARAMETER (SGINFO=.TRUE.)
      CHARACTER*80 LINE
      CHARACTER*1 CODE(0:3)
      DATA CODE /'0','u','d','2'/

C -- NOTE: THIS PRWF ROUTINE USES THE CONVENTION THAT CI BLOCKS
C -- ARE MATRICES CI(I,J), WHERE THE   F I R S T   INDEX I REFERS TO
C -- THE   U P P E R   PART OF THE WALK.
C -- THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
C    WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.

      MIDLEV=ISGSTRUCT(8)
      NIPWLK=ICISTRUCT(2)
      LICASE=ICISTRUCT(9)

C Size of occup/spin coupling part of line:
      WRITE(6,*)' Occupation of active orbitals, and spin coupling'
      WRITE(6,*)' of open shells. (u,d: Spin up or down).'
      WRITE(LINE,'(20A4)')('    ',I=1,20)
      K=0
      ISY=0
      DO  LEV=1,NLEV
        IF(ISY.NE.ISM(LEV)) THEN
          ISY=ISM(LEV)
          K=K+1
        END IF
        K=K+1
      END DO
      KOCLAB=10
      KOCSZ=MAX(K,KOCLAB)
      KPAD1=(KOCSZ-KOCLAB)/2
      KPAD2=(KOCSZ-K)/2
      IF(SGINFO) THEN
      WRITE(6,*)' SGUGA info is (Midvert:IsyUp:UpperWalk/LowerWalk)'
      END IF
      LINE(1:7)='  Conf '
      K=7
      IF(SGINFO) THEN
        LINE(8:22)='  SGUGA info   '
        K=22
      END IF
      LINE(K+KPAD1:K+KPAD1+9)='Occupation'
      K=K+KOCSZ
      LINE(K:K+23)='       Coef       Weight'
      WRITE(6,*) LINE
      WRITE(LINE,'(20A4)')('    ',I=1,20)

C -- THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
C    WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.
      DO 40 MV=1,NMIDV
        DO 41 ISYUP=1,NSYM
          NCI=NOCSF(ISYUP,MV,ISYCI)
          IF(NCI.EQ.0) GOTO 41
          NUP=NOW(1,ISYUP,MV)
          ISYDWN=MUL(ISYUP,ISYCI)
          NDWN=NOW(2,ISYDWN,MV)
          ICONF=IOCSF(ISYUP,MV,ISYCI)
          IUW0=LICASE-NIPWLK+IOW(1,ISYUP,MV)
          IDW0=LICASE-NIPWLK+IOW(2,ISYDWN,MV)
          IDWNSV=0
          DO 30 IDWN=1,NDWN
            DO 31 IUP=1,NUP
              ICONF=ICONF+1
              COEF=CI(ICONF)
C -- SKIP OR PRINT IT OUT?
              IF(ABS(COEF).LT.CITHR) GOTO  31
              IF(IDWNSV.NE.IDWN) THEN
                ICDPOS=IDW0+IDWN*NIPWLK
                ICDWN=IWORK(ICDPOS)
C -- UNPACK LOWER WALK.
                NNN=0
                DO 10 LEV=1,MIDLEV
                  NNN=NNN+1
                  IF(NNN.EQ.16) THEN
                    NNN=1
                    ICDPOS=ICDPOS+1
                    ICDWN=IWORK(ICDPOS)
                  END IF
                  IC1=ICDWN/4
                  ICS(LEV)=ICDWN-4*IC1
                  ICDWN=IC1
10              CONTINUE
                IDWNSV=IDWN
              END IF
              ICUPOS=IUW0+NIPWLK*IUP
              ICUP=IWORK(ICUPOS)
C -- UNPACK UPPER WALK:
              NNN=0
              DO 20 LEV=MIDLEV+1,NLEV
                NNN=NNN+1
                IF(NNN.EQ.16) THEN
                  NNN=1
                  ICUPOS=ICUPOS+1
                  ICUP=IWORK(ICUPOS)
                END IF
                IC1=ICUP/4
                ICS(LEV)=ICUP-4*IC1
                ICUP=IC1
20            CONTINUE
C -- PRINT IT!
              WRITE(LINE(1:7),'(I6,1X)') ICONF
              K=7
              IF(SGINFO) THEN
                LINE(K+1:K+1)='('
                WRITE(LINE(K+2:K+3),'(I2)') MV
                LINE(K+4:K+4)=':'
                WRITE(LINE(K+5:K+5),'(I1)') ISYUP
                LINE(K+6:K+6)=':'
                WRITE(LINE(K+7:K+9),'(I3)') IUP
                LINE(K+10:K+10)='/'
                WRITE(LINE(K+11:K+13),'(I3)') IDWN
                LINE(K+14:K+14)=')'
                K=K+14
              END IF
              KNXT=K+KOCSZ
              K=K+KPAD2
              ISY=0
              DO LEV=1,NLEV
                IF(ISY.NE.ISM(LEV)) THEN
                  ISY=ISM(LEV)
                  K=K+1
                  LINE(K:K)=' '
                END IF
                K=K+1
                LINE(K:K)=CODE(ICS(LEV))
              END DO
              K=KNXT
              K=K+1
              LINE(K:K+4)='     '
              K=K+5
              WRITE(LINE(K:K+7),'(F8.5)') COEF
              K=K+8
              LINE(K:K+4)='     '
              K=K+5
              WRITE(LINE(K:K+7),'(F8.5)') COEF**2
              WRITE(6,*)LINE(1:K+7)
31          CONTINUE
30        CONTINUE
41      CONTINUE
40    CONTINUE
      WRITE(6,*)
      WRITE(6,*)('*',I=1,80)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995, Jeppe Olsen                                 *
!***********************************************************************

subroutine GSBBD1_MCLR(RHO1,NACOB,ISCSM,ISCTP,ICCSM,ICCTP,IGRP,NROW,NGAS,ISEL,ICEL,SB,CB,NOBPTS,IOBPTS,MAXI,MAXK,SSCR,CSCR,I1, &
                       XI1S,I2,XI2S,NSM,RHO1S)
! Contributions to one electron density matrix from column excitations
!
! GAS version, August 95, Jeppe Olsen
!
! =====
! Input
! =====
! RHO1        : One body density matrix to be updated
! NACOB       : Number of active orbitals
! ISCSM,ISCTP : Symmetry and type of sigma columns
! ICCSM,ICCTP : Symmetry and type of C     columns
! IGRP        : String group of columns
! NROW        : Number of rows in S and C block
! NGAS        : Number of active spaces
! ISEL        : Number of electrons per AS for S block
! ICEL        : Number of electrons per AS for C block
! CB          : Input C block
! NOBPTS      : Number of orbitals per type and symmetry
! IOBPTS      : base for orbitals of given type and symmetry
! IBORB       : Orbitals of given type and symmetry
! NSM         : Number of symmetries of orbitals
! MAXI        : Largest Number of "spectator strings" treated simultaneously
! MAXK        : Largest number of inner resolution strings treated at simult.
!
! ======
! Output
! ======
! RHO1 : Updated density block
!
! =======
! Scratch
! =======
! SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the largest
!              number of orbital pairs of given symmetries and types.
! I1, XI1S   : MAXK*Max number of orbitals of given type and symmetry
! I2, XI2S   : MAXK*Max number of orbitals of given type and symmetry
!              type and symmetry
! RHO1S      : Space for one electron density
!
! Jeppe Olsen, Winter of 1991
! Updated for GAS, August '95

use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: RHO1(*)
integer(kind=iwp), intent(in) :: NACOB, ISCSM, ISCTP, ICCSM, ICCTP, IGRP, NROW, NGAS, ISEL(NGAS), ICEL(NGAS), NOBPTS(3,*), &
                                 IOBPTS(3,*), MAXI, MAXK, NSM
real(kind=wp), intent(in) :: SB(*), CB(*)
real(kind=wp), intent(_OUT_) :: SSCR(*), CSCR(*), XI1S(*), XI2S(*), RHO1S(*)
integer(kind=iwp), intent(_OUT_) :: I1(*), I2(*)
integer(kind=iwp) :: IBIORB, IBJORB, IBOT, ICGOFF, IIORB, IJSM, IJTP, IPART, ISGOFF, ISM, ITOP, ITP(3*3), ITYP, JJORB, JORB, JSM, &
                     JTP(3*3), JTYP, KBOT, KEND, KTOP, NIBTC, NIORB, NIPART, NJORB, NKBTC, NKI, NSXTP

! Type of single excitations that connects the two column strings
call SXTYP_GAS(NSXTP,ITP,JTP,3,ISEL,ICEL)
! Symmetry of single excitation that connects IBSM and JBSM
IJSM = Mul(ISCSM,ICCSM)
if (IJSM == 0) return
do IJTP=1,NSXTP
  ITYP = ITP(IJTP)
  JTYP = JTP(IJTP)
  do ISM=1,NSM
    ! new i and j so new intermediate strings
    JSM = Mul(ISM,IJSM)
    if (JSM == 0) cycle
    NIORB = NOBPTS(ITYP,ISM)
    NJORB = NOBPTS(JTYP,JSM)
    IBIORB = IOBPTS(ITYP,ISM)
    IBJORB = IOBPTS(JTYP,JSM)
    if ((NIORB == 0) .or. (NJORB == 0)) cycle

    !OLD Loop over partitionings of the row strings
    NIPART = NROW/MAXI
    if (NIPART*MAXI /= NROW) NIPART = NIPART+1
    ! Loop over partitionings of N-1 strings
    KBOT = 1-MAXK
    KTOP = 0
    do
      KBOT = KBOT+MAXK
      KTOP = KTOP+MAXK
      !EAWBEGIN970207
      !     -1 -> MAXK
      !     KTOP -> -1
      !     KTOP=-1
      ! Single excitation information independent of I strings

      ! set up I1(K) =  XI1S(K) a JORB !J STRING >
      call ADST(IBJORB,NJORB,ICCTP,ICCSM,IGRP,KBOT,KTOP,I1,XI1S,MAXK,NKBTC,KEND)
      ! set up I2(K) =  XI1S(K) a JORB !J STRING >
      call ADST(IBIORB,NIORB,ISCTP,ISCSM,IGRP,KBOT,KTOP,I2,XI2S,MAXK,NKBTC,KEND)
      !EAWEND
      ! Appropriate place to start partitioning over I strings
      ! Loop over partitionings of the row strings
      do IPART=1,NIPART
        IBOT = (IPART-1)*MAXI+1
        ITOP = min(IBOT+MAXI-1,NROW)
        NIBTC = ITOP-IBOT+1

        ! Obtain CSCR(I,K,JORB) = SUM(J)<K!A JORB!J>C(I,J)
        ! Gather  C Block
        do JJORB=1,NJORB
          ICGOFF = 1+(JJORB-1)*NKBTC*NIBTC
          call MATCG(CB,CSCR(ICGOFF),NROW,NIBTC,IBOT,NKBTC,I1(1+(JJORB-1)*MAXK),XI1S(1+(JJORB-1)*MAXK))
        end do

        ! Obtain SSCR(I,K,IORB) = SUM(I)<K!A IORB!J>S(I,J)
        do IIORB=1,NIORB
          ! Gather S Block
          ISGOFF = 1+(IIORB-1)*NKBTC*NIBTC
          call MATCG(SB,SSCR(ISGOFF),NROW,NIBTC,IBOT,NKBTC,I2(1+(IIORB-1)*MAXK),XI2S(1+(IIORB-1)*MAXK))
        end do
        NKI = NKBTC*NIBTC
        if (NKI*NIORB*NJORB /= 0) then
          call DGEMM_('T','N',NIORB,NJORB,NKI,One,SSCR,NKI,CSCR,NKI,Zero,RHO1S,NIORB)
        else
          RHO1S(1:NIORB*NJORB) = Zero
        end if
        ! Scatter out to complete matrix
        do JJORB=1,NJORB
          JORB = IBJORB-1+JJORB
          RHO1((JORB-1)*NACOB+IBIORB:(JORB-1)*NACOB+IBIORB+NIORB-1) = RHO1((JORB-1)*NACOB+IBIORB:(JORB-1)*NACOB+IBIORB+NIORB-1)+ &
                                                                      RHO1S((JJORB-1)*NIORB+1:JJORB*NIORB)
        end do

      end do
      ! /\ end of this I partitioning
      ! end of this K partitioning
      if (KEND /= 0) exit
    end do
    ! End of loop over I partitioninigs
  end do
  ! (end of loop over symmetries)
end do

return

end subroutine GSBBD1_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ERChk_Localisation(irc,lnBas,lnOcc,lnFro,lnSym)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: lnSym, lnBas(lnSym), lnOcc(lnSym), lnFro(lnSym)
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: iSym, nTst

irc = 0

if ((lnSym < 1) .or. (lnSym > 8)) then
  irc = 1
  return
end if

if (lnSym /= nSym) then
  irc = 2
  return
end if

do iSym=1,nSym
  if (lnBas(iSym) /= nBas(iSym)) then
    irc = 3
    return
  end if
  nTst = lnOcc(iSym)+lnFro(iSym)
  if (nTst > nBas(iSym)) then
    irc = 4
    return
  end if
end do

end subroutine ERChk_Localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Ovrhss(
#define _CALLING_
#include "hss_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: to compute the gradients of the overlap matrix               *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Anders Bernhardsson 1995                                 *
************************************************************************
      use Her_RW
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
c#include "print.fh"

#include "hss_interface.fh"

*     Local variables
      Logical ABeq(3)
*
c     iRout = 122
c     iPrint = nPrint(iRout)
*     Write (*,*) ' IfHss=',IfHss
*     Write (*,*) ' IndHss=',IndHss
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+3)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+3)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp+1)
      ipRnxyz = nip
      nip = nip + nZeta*3*(la+3)*(lb+3)*(nOrdOp+1)
      ipAlph = nip
      nip = nip + nZeta
      ipBeta = nip
      nip = nip + nZeta
      If (nip-1.gt.nArr) Then
         Write (6,*) 'OvrHss: nip-1.gt.nArr'
         Write (6,*) 'nip,nArr=',nip,nArr
         Call Abend()
      End If
*
c     If (iPrint.ge.49) Then
c        Call RecPrt(' In OvrHss: A',' ',A,1,3)
c        Call RecPrt(' In OvrHss: RB',' ',RB,1,3)
c        Call RecPrt(' In OvrHss: Ccoor',' ',Ccoor,1,3)
c        Call RecPrt(' In OvrHss: P',' ',P,nZeta,3)
c        Write (*,*) ' In OvrHss: la,lb=',la,lb
c     End If
*
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la+2,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb+2,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the contribution from the multipole moment operator
*
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),
     &            nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the cartesian components for the multipole moment
*     integrals. The integrals are factorized into components.
*
       Call Assmbl(Array(ipRnxyz),
     &             Array(ipAxyz),la+2,
     &             Array(ipRxyz),nOrdOp,
     &             Array(ipBxyz),lb+2,
     &             nZeta,HerW(iHerW(nHer)),nHer)
*
*     Combine the cartesian components to the gradient of the one
*     electron integral and contract with the Fock matrix.
*
      ip = ipAlph
      Do 20 iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ip),1)
         ip = ip + nAlpha
 20   Continue
      ip = ipBeta
      Do 21 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ip),nAlpha)
         ip = ip + 1
 21   Continue
*
      Call CmbnS2(Array(ipRnxyz),nZeta,la,lb,Zeta,rKappa,Final,
     &            Array(ipAlph),Array(ipBeta),Hess,nHess,DAO,
     &            IfHss,IndHss,indgrd,dc(mdc)%nStab,dc(ndc)%nStab,nOp)
*
c     Call GetMem(' Exit OvrHss','CHECK','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_logical_array(ifgrd)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iStabM)
         Call Unused_integer(nStabM)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_Drv(iReturn)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: driver for the Cholesky decomposition of two-electron
!          integrals. On entry, the integral program must have been
!          initialized and the relevant index info (#irreps, basis
!          functions, shells, etc.) must have been set up.

use Cholesky, only: Cho_DecAlg
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: iReturn

iReturn = 0
if (Cho_DecAlg == 5) then ! parallel two-step algorithm
  call Cho_Drv_ParTwoStep(iReturn)
else
  call Cho_Drv_Inner(iReturn)
end if

end subroutine Cho_Drv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mkguess2_cvb(orbs,cvb,irdorbs,orbsao)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
#include "mo_cvb.fh"
      dimension orbs(norb,norb),cvb(nvb)
      dimension irdorbs(norb),orbsao(nbas_mo,norb)
      dimension idum(1),dum(1)
      save thresh
      data thresh/1d-10/

      call izero(irdorbs,norb)
c  -- transfer from orbs if applicable --
c  (Newly assigned memory => orbs will be zero)
      do 100 iorb=1,norb
      if(dnrm2_(norb,orbs(1,iorb),1).gt.thresh)then
        irdorbs(iorb)=1
        call fmove_cvb(orbs(1,iorb),orbsao(1,iorb),norb)
      endif
100   continue
c  -- restore from previous optim --
      if(.not.up2date_cvb('RESTGS'))then
        if(up2date_cvb('WRITEGS'))then
          call rdi_cvb(idum,1,recn_tmp04,0)
          ndetvb1=idum(1)
          i1=mstacki_cvb(ndetvb1)
          i2=mstackr_cvb(ndetvb1)
          call mkrestgs_cvb(orbsao,irdorbs,cvb,
     >      w(lw(9)),iw(ll(11)),iw(ll(12)),iw(i1),w(i2))
          call mfreei_cvb(i1)
        endif
        call untouch_cvb('RESTGS')
      endif
c  -- read from file --
      if(.not.up2date_cvb('STRTGS'))then
        call setstrtvb_cvb(strtvb)
        if(tstfile_cvb(strtvb))call mkstrtgs_cvb(orbsao,irdorbs,cvb,
     >    strtvb,kbasiscvb)
        call untouch_cvb('STRTGS')
      endif
c  -- input --
      if(.not.up2date_cvb('INPGS'))then
        i1 = mstacki_cvb(norb)
        call rdioff_cvb(6,recinp,ioffs)
        call rdi_cvb(iw(i1),norb,recinp,ioffs)
        call rdioff_cvb(5,recinp,ioffs)
        do 200 iorb=1,norb
        if(iw(iorb+i1-1).eq.1)then
c MO basis ...
          irdorbs(iorb)=1
          call rdr_cvb(orbsao(1,iorb),norb,recinp,ioffs)
        elseif(iw(iorb+i1-1).eq.2)then
c AO basis ...
          irdorbs(iorb)=2
          call rdr_cvb(orbsao(1,iorb),nbas_mo,recinp,ioffs)
        endif
        ioffs=ioffs+mxaobf
200     continue
        call mfreei_cvb(i1)

        i1 = mstackr_cvb(nvbinp)
        call rdioff_cvb(7,recinp,ioffs)
        call rdrs_cvb(w(i1),nvbinp,recinp,ioffs)
        if(dnrm2_(nvbinp,w(i1),1).gt.thresh)then
          call rdioff_cvb(3,recinp,ioffs)
          call rdis_cvb(idum,1,recinp,ioffs)
          kbasiscvb=idum(1)
          call fmove_cvb(w(i1),w(lv(2)),nvbinp)
        endif
        call mfreer_cvb(i1)

        call untouch_cvb('INPGS')
      endif
c  -- semi-random --
c  Leading diagonal, random but positive orbital overlaps :
      dum=rand_cvb(.777d0)
      c=1d-1
      do 300 iorb=1,norb
      if(irdorbs(iorb).eq.0)then
        irdorbs(iorb)=1
        do 400 ii=1,norb
        orbsao(ii,iorb)=c*rand_cvb(zero)
        if(ii.eq.iorb)orbsao(ii,iorb)=one
400     continue
      else
c  Dummy calls to RAND to get consistent guesses :
        do 500 ii=1,norb
        dum=rand_cvb(zero)
500     continue
      endif
300   continue

c  Collect orbitals and transform AO -> MO :
      norb_ao=0
      do iorb=1,norb
      if(irdorbs(iorb).eq.1)then
        call fmove_cvb(orbsao(1,iorb),orbs(1,iorb),norb)
      elseif(irdorbs(iorb).eq.2)then
        norb_ao=norb_ao+1
        if(norb_ao.ne.iorb)call fmove_cvb(orbsao(1,iorb),
     >    orbsao(1,norb_ao),nbas_mo)
      endif
      enddo
      i1=mstackr_cvb(norb*norb_ao)
      call ao2mo_cvb(orbsao,w(i1),norb_ao)
      iorb_ao=0
      do iorb=1,norb
      if(irdorbs(iorb).eq.2)then
        iorb_ao=iorb_ao+1
        call fmove_cvb(w((iorb_ao-1)*norb+i1),orbs(1,iorb),norb)
      endif
      enddo
      call mfreer_cvb(i1)

      call nize_cvb(orbs,norb,dum,norb,0,0)

      if(abs(detm_cvb(orbs,norb)).lt.1d-8)then
        dum=rand_cvb(.777d0)
        c=1d-1
        do 600 iorb=1,norb
        do 601 ii=1,norb
        orbs(ii,iorb)=orbs(ii,iorb)+c*(one-two*rand_cvb(zero))
601     continue
600     continue
        if(abs(detm_cvb(orbs,norb)).lt.1d-8)then
          if(ip(1).ge.0)
     >      write(6,'(2a)')' Starting orbital guess was near-singular',
     >        ' - using semi-random guess instead.'
          dum=rand_cvb(.777d0)
          c=1d-1
          do 700 iorb=1,norb
          do 701 ii=1,norb
          orbs(ii,iorb)=c*rand_cvb(zero)
          if(ii.eq.iorb)orbs(ii,iorb)=one
701       continue
700       continue
        else
          if(ip(1).ge.0)
     >      write(6,'(2a)')' Starting orbital guess was near-singular',
     >        ' - scrambling orbital coefficients.'
        endif
        call nize_cvb(orbs,norb,dum,norb,0,0)
      endif

      call nize_cvb(orbs,norb,dum,norb,0,0)

c  Perfect-pairing spin function(s) :
      if(dnrm2_(nvb,cvb,1).lt.thresh)then
        kbasiscvb=kbasis
        call ppgs_cvb(cvb)
      endif

      cnrm=dnrm2_(nvb,cvb,1)
      if(cnrm.lt.thresh)then
        write(6,*)' Fatal error - starting structure coefficients ',
     >    'all zero !'
        call abend_cvb()
      endif

      if(kbasiscvb.ne.kbasis)then
        call mktrnspn_cvb()
        call untouch_cvb('TRNSPN')
      endif

      !if(ploc)call rtransf_plc(orbs,cvb)
      if(ploc)call rtransf_plc()

      if(ip(1).ge.2.and..not.endvar)then
        write(6,'(/,a)')' Wavefunction guess :'
        call report_cvb(orbs,norb)
        write(6,'(/,a)')' Structure coefficients :'
        write(6,'(a)')' ------------------------'
        call vecprint_cvb(cvb,nvb)
      endif

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  IniCho_RI
!
!> @brief
!>   Initialize Cholesky environment for RI calculations
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Initialize Cholesky environment for RI calculations.
!>
!> @note
!> Needs a call to ::SetUp_Ints with indexation turned on
!>
!> @param[in] nSkal    The number of shells (excl. aux. basis)
!> @param[in] nVec_Aux Number of aux. basis vectors per irrep
!> @param[in] nIrrep   Number of irreps
!> @param[in] iTOffs   Offset vector
!> @param[in] iShij    Index vector of shell pairs
!> @param[in] nShij    Number of shell pairs
!***********************************************************************

subroutine IniCho_RI(nSkal,nVec_Aux,nIrrep,iTOffs,iShij,nShij)

use Index_Functions, only: iTri
use RICD_Info, only: Thrshld_CD
use Para_Info, only: Is_Real_Par
use ChoArr, only: iSP2F
use ChoSwp, only: InfRed, InfVec
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSkal, nIrrep, nVec_Aux(0:nIrrep-1), iTOffs(3,nIrrep), nShij, iShij(2,nShij)
#include "cholesky.fh"
#include "choprint.fh"
#ifdef _MOLCAS_MPP_
#include "choglob.fh"
#endif
integer(kind=iwp) :: iDummy, ijS, iSym, iVec, LuOut
logical(kind=iwp) :: Alloc_Bkm, SetDefaultsOnly, Skip_PreScreen

! Set defaults for those parameters that can normally be changed
! through user input to the Cholesky decomposition.
! --------------------------------------------------------------

SetDefaultsOnly = .true.
iDummy = -1
LuOut = u6
call Cho_Inp(SetDefaultsOnly,iDummy,LuOut)

! Reset Cholesky Threshold for RI
! -------------------------------
ThrCom = Thrshld_CD

! Reset parallel config.
! ----------------------

CHO_FAKE_PAR = .false.
call Cho_ParConf(CHO_FAKE_PAR)

! Set run mode to "external" (should be irrelevant for RI).
! ---------------------------------------------------------

RUN_MODE = RUN_EXTERNAL

! Silence the Cholesky routines.
! ------------------------------

iPrint = 0

! Set number of shells (excl. aux. basis) in cholesky.fh
! ------------------------------------------------------

nShell = nSkal

! To avoid unnecessary allocations of shell-pair-to-reduced-set
! maps, set decomposition algorithm to 1 ("one-step") and the Seward
! interface to "1" (full shell quadruple storage). Both values are,
! obviously, irrelevant for RI. In parallel runs, use default values
! to avoid warnings being printed in Cho_P_Check.
! ------------------------------------------------------------------

if (Is_Real_Par()) then
  Cho_DecAlg = 4
  IfcSew = 2
else
  Cho_DecAlg = 1
  IfcSew = 1
end if

! Change MaxRed to 1 (all vectors have identical dimension, namely
! full => only 1 reduced set).
! ----------------------------------------------------------------

MaxRed = 1

! Set MaxVec to the largest number of vectors (= number of linearly
! independent auxiliary basis functions). In this way we avoid
! allocating more memory for InfVec than needed.
! -----------------------------------------------------------------

MaxVec = nVec_Aux(0)
do iSym=1,nIrrep-1
  MaxVec = max(MaxVec,nVec_Aux(iSym))
end do

! Other initializations. Most importantly, allocate InfRed and
! InfVec arrays (defined in choswp.f90).
! We skip diagonal prescreening, as it has already been done.
! Instead, allocate and set the mapping from reduced to full shell
! pairs here.
! ----------------------------------------------------------------

nnShl = nShij
call mma_allocate(iSP2F,nnShl,Label='iSP2F')
do ijS=1,nnShl
  iSP2F(ijS) = iTri(iShij(1,ijS),iShij(2,ijS))
end do
Skip_PreScreen = .true.
Alloc_Bkm = .false.
call Cho_Init(Skip_PreScreen,Alloc_Bkm)

! Set number of vectors equal to the number of lin. indep. auxiliary
! basis functions.
! ------------------------------------------------------------------

NumCho(1:nSym) = nVec_Aux(0:nSym-1)
#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  NumCho_g(1:nSym) = NumCho(1:nSym)
  myNumCho(1:nSym) = 0
end if
#endif

! Do allocations that are normally done during or after the
! computation of the diagonal (since the dimension of the 1st
! reduced set is unknown until the screened diagonal is known).
! -------------------------------------------------------------

call IniCho_RI_Xtras(iTOffs,nIrrep,iShij,nShij)

! Set start disk addresses.
! -------------------------

XnPass = 0 ! it should be zeroed in Cho_Inp, but just in case.
call Cho_SetAddr(InfRed,InfVec,MaxRed,MaxVec,size(InfVec,2),nSym)

! Set vector info.
! Parent diagonal is set equal to the vector number, parent pass
! (i.e. reduced set) to 1.
! --------------------------------------------------------------

do iSym=1,nSym
  do iVec=1,NumCho(iSym)
    call Cho_SetVecInf(iVec,iSym,iVec,1,1)
  end do
end do

return

end subroutine IniCho_RI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

subroutine RHSOD_A_NOSYM(IVEC)

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use SUPERINDEX, only: MTREL, MTUV
use CHOVEC_IO, only: ChoVec_read, ChoVec_Size, NVTOT_ChoSym
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB
#else
use fake_GA, only: GA_Arrays
#endif
use caspt2_global, only: FIMO, iPrGlb
use caspt2_module, only: nActEl, nAsh, nIsh, nOrb, nSym, NTUV, nTUVES
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: iAEnd, iASta, iCase, IDX, IIEnd, IISTA, IJ, IOBRA(8,8), IOFFTJ, IOFFVX, IOKET(8,8), ISYJ, iSym, iSYT, iSYV, &
                     iSYX, IT, ITABS, ITJ, ITTOT, ITVX, ITVXTOT, IV, IVABS, iVX, iX, iXABS, lg_W, mW, nAS, nBra, nFIMOES, nIS, &
                     nKet, nV, nW
real(kind=wp) :: ATVXJ, FTJ, TJVX
real(kind=wp), allocatable :: BRA(:), KET(:)
real(kind=wp), external :: DDot_

if (iPrGlb >= DEBUG) write(u6,*) 'RHS on demand: case A'

!***********************************************************************
! Case A:
!   RHS(tvx,j)=(tj,vx)+FIMO(t,j)*kron(v,x)/NACTEL
!***********************************************************************

!***********************************************************************
!SVC: read in all the cholesky vectors (need all symmetries)
!***********************************************************************
call CHOVEC_SIZE(1,NBRA,IOBRA)
call CHOVEC_SIZE(2,NKET,IOKET)

call mma_allocate(BRA,NBRA,LABEL='BRA')
call mma_allocate(KET,NKET,LABEL='KET')

call CHOVEC_READ(1,BRA,NBRA)
call CHOVEC_READ(2,KET,NKET)

ICASE = 1
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
NFIMOES = 0
do ISYM=1,NSYM

  NAS = NTUV(ISYM) !NASUP(ISYM,ICASE)
  NIS = NISH(ISYM) !NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) then
    NFIMOES = NFIMOES+nTri_Elem(NORB(ISYM))
    cycle
  end if

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  do IJ=IISTA,IIEND
    ISYJ = ISYM
    do ITVX=IASTA,IAEND ! these are always all elements
      ITVXTOT = ITVX+NTUVES(ISYM)
      ITABS = MTUV(1,ITVXTOT)
      IVABS = MTUV(2,ITVXTOT)
      IXABS = MTUV(3,ITVXTOT)
      IT = MTREL(1,ITABS)
      ISYT = MTREL(2,ITABS)
      IV = MTREL(1,IVABS)
      ISYV = MTREL(2,IVABS)
      IX = MTREL(1,IXABS)
      ISYX = MTREL(2,IXABS)
      ! compute integrals (tiuv)
      NV = NVTOT_CHOSYM(Mul(ISYT,ISYJ)) ! JSYM=ISYT*ISYI=ISYU*ISYV
      ITJ = IT-1+NASH(ISYT)*(IJ-1)
      IVX = IV-1+NASH(ISYV)*(IX-1)
      IOFFTJ = 1+IOBRA(ISYT,ISYJ)+NV*ITJ
      IOFFVX = 1+IOKET(ISYV,ISYX)+NV*IVX
      TJVX = DDOT_(NV,BRA(IOFFTJ),1,KET(IOFFVX),1)
      ! A(tvx,j) = (tjvx) + FIMO(t,j)*delta(v,x)/NACTEL
      if ((ISYT == ISYJ) .and. (IVABS == IXABS)) then
        ITTOT = IT+NISH(ISYT)
        FTJ = FIMO(NFIMOES+iTri(ITTOT,IJ))
        ATVXJ = TJVX+FTJ/real(max(1,NACTEL),kind=wp)
      else
        ATVXJ = TJVX
      end if
      ! write element A(tvx,j)
      IDX = ITVX+NAS*(IJ-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = ATVXJ
#     else
      GA_Arrays(lg_W)%A(IDX) = ATVXJ
#     endif
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)

  NFIMOES = NFIMOES+nTri_Elem(NORB(ISYM))

end do
!***********************************************************************

call mma_deallocate(BRA)
call mma_deallocate(KET)

end subroutine RHSOD_A_NOSYM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DXTYP(NDXTP,ITYP,JTYP,KTYP,LTYP,LEL1,LEL3,REL1,REL3)
*
* Obtain types of I,J,K,l so
* <L!a+I a+K a L a J!R> is nonvanishing
* only combinations with type(I) .ge. type(K) and type(L).ge.type(J)
* are included
*
      INTEGER REL1,REL3
      INTEGER ITYP(6),JTYP(6),KTYP(6),LTYP(6)
*
*. To get rid of annoying and incorrect compiler warnings
      I1 = 0
      I3 = 0
      IK1 = 0
      IK3 = 0
      IKL1 = 0
      IKL3 = 0
      IKLJ1 = 0
      IKLJ3 = 0
*
      NDXTP = 0
      DO 400 ITP = 1, 3
        IF(ITP.EQ.1) THEN
          I1 = 1
          I3 = 0
        ELSE IF(ITP.EQ.2) THEN
          I1 = 0
          I3 = 0
        ELSE IF(ITP.EQ.3) THEN
          I1 = 0
          I3 = 1
        END IF
        DO 300 KTP = 1, ITP
          IF(KTP.EQ.1) THEN
            IK1 = I1+1
            IK3 = I3
          ELSE IF(KTP.EQ.2) THEN
            IK1 = I1
            IK3 = I3
          ELSE IF(KTP.EQ.3) THEN
            IK1 = I1
            IK3 = I3+1
          END IF
          IF(LEL1-IK1.LT.0) GOTO 300
          IF(LEL3-IK3.LT.0) GOTO 300
          DO 200 LTP = 1,3
            IF(LTP.EQ.1) THEN
              IKL1 = IK1-1
              IKL3 = IK3
            ELSE IF(LTP.EQ.2) THEN
              IKL1 = IK1
              IKL3 = IK3
            ELSE IF(LTP.EQ.3) THEN
              IKL1 = IK1
              IKL3 = IK3-1
            END IF
            DO 100 JTP = 1, 3
              IF(JTP.EQ.1) THEN
                IKLJ1 = IKL1-1
                IKLJ3 = IKL3
              ELSE IF(JTP.EQ.2) THEN
                IKLJ1 = IKL1
                IKLJ3 = IKL3
              ELSE IF(JTP.EQ.3) THEN
                IKLJ1 = IKL1
                IKLJ3 = IKL3-1
              END IF
              IF(IKLJ1+REL1.EQ.LEL1.AND.IKLJ3+REL3.EQ.LEL3) THEN
                NDXTP = NDXTP + 1
                ITYP(NDXTP) = ITP
                KTYP(NDXTP) = KTP
                LTYP(NDXTP) = LTP
                JTYP(NDXTP) = JTP
              END IF
  100       CONTINUE
  200     CONTINUE
  300   CONTINUE
  400 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,'(A,4I4)')
     &  ' Double excitations connecting LEL1,LEL3,LEL1,LEL3 ',
     &    LEL1,LEL3,REL1,REL3
        WRITE(6,*) '  ITYP KTYP LTYP JTYP '
        WRITE(6,*) '  ===================='
        DO 10 IDX = 1,NDXTP
          WRITE(6,'(1H ,5I5)')ITYP(IDX),KTYP(IDX),LTYP(IDX),JTYP(IDX)
   10   CONTINUE
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_VecBuf_Copy(Vec,nVec,iSym)
!
! Purpose: copy as many vectors as fit directly into buffer using
!          current reduced set dimension for symmetry iSym. nVec
!          is the number of vectors in array Vec.
!     NB!  It is important that the vector counter NumCho does NOT
!          include the nVec vectors in array Vec.

use Cholesky, only: CHVBUF, ip_CHVBUF_SYM, l_CHVBUF_SYM, nnBstR, NumCho, nVec_in_Buf
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Vec(*)
integer(kind=iwp), intent(in) :: nVec, iSym
integer(kind=iwp) :: kOff, lCopy, Left, mUsed, nCopy

! Check if there is anything to do at all.
! 1) any buffer allocated?
! 2) any vectors to copy?
! 3) any elements?
! ----------------------------------------

if (l_ChVBuf_Sym(iSym) < 1) return
if (nVec < 1) return
if (nnBstR(iSym,2) < 1) return

! Copy vectors
! 1) if all previous vectors are in the buffer, and
! 2) if there is sufficient free space in the buffer.
! ---------------------------------------------------

if (nVec_in_Buf(iSym) == NumCho(iSym)) then
  mUsed = nnBstR(iSym,2)*nVec_in_Buf(iSym)
  Left = l_ChVBuf_Sym(iSym)-mUsed
  nCopy = min(Left/nnBstR(iSym,2),nVec)
  if (nCopy > 0) then
    lCopy = nnBstR(iSym,2)*nCopy
    kOff = ip_ChVBuf_Sym(iSym)+mUsed-1
    CHVBUF(kOff+1:kOff+lCopy) = Vec(1:lCopy)
    nVec_in_Buf(iSym) = nVec_in_Buf(iSym)+nCopy
  end if
end if

end subroutine Cho_VecBuf_Copy

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine fx_cvb(fx,fast)
c
c  FAST=.TRUE. :     Quick evaluation of f(x) --
c                    no reusable quantities
c  FAST=.FALSE.:     Slower evaluation of f(x) --
c                    but with reusable quantities
c                    (CIVECP/CIVBH & CIVBS)
c
      implicit real*8 (a-h,o-z)
      logical fast
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"

      dxmove=.true.
      iwf1 = lv(1)
      iwf2 = lv(2)
      if(.not.memplenty)then
        call ciwr_cvb(w(lc(2)),61002.2d0)
        call ciwr_cvb(w(lc(3)),61003.2d0)
        call ciwr_cvb(w(lc(4)),61004.2d0)
        call setcnt2_cvb(2,0)
        call setcnt2_cvb(3,0)
        call setcnt2_cvb(4,0)
      endif
      call setcnt2_cvb(6,0)
      call setcnt2_cvb(7,0)
      call setcnt2_cvb(8,0)
      if(icrit.eq.1)then
        call fx_svb1_cvb(fx,fast,w(iwf1),w(iwf2),
     >    w(lc(1)),w(lc(6)),w(lc(7)),w(lc(8)),
     >    w(lw(4)),w(lw(5)),w(lw(6)),w(lw(9)))
      elseif(icrit.eq.2)then
        call fx_evb1_cvb(fx,fast,w(iwf1),w(iwf2),
     >    w(lc(1)),w(lc(6)),w(lc(7)),w(lc(8)),
     >    w(lw(4)),w(lw(5)),w(lw(6)),w(lw(9)))
      endif
      if(.not.memplenty)then
        call ciwr_cvb(w(lc(6)),61006.2d0)
        call ciwr_cvb(w(lc(7)),61007.2d0)
        call ciwr_cvb(w(lc(8)),61008.2d0)
        call cird_cvb(w(lc(2)),61002.2d0)
        call cird_cvb(w(lc(3)),61003.2d0)
        call cird_cvb(w(lc(4)),61004.2d0)
      endif
c  Figure out what we just calculated, and make it up2date :
      if(dxmove)then
        if(icrit.eq.1)then
          call make_cvb('SVB')
        elseif(icrit.eq.2)then
          call make_cvb('EVB')
        endif
      else
        if(icrit.eq.1)then
          call make_cvb('SVBTRY')
        elseif(icrit.eq.2)then
          call make_cvb('EVBTRY')
        endif
      endif
      return
      end
      subroutine fxdx_cvb(fx,fast,dx)
      implicit real*8 (a-h,o-z)
      logical fast
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension dx(*)

      dxmove=.false.
      iwf1 = lw(12)
      iwf2 = lw(13)
      call upd_cvb(dx,w(iwf1),w(iwf2))
      if(.not.memplenty)then
        call ciwr_cvb(w(lc(2)),61002.2d0)
        call ciwr_cvb(w(lc(3)),61003.2d0)
        call ciwr_cvb(w(lc(4)),61004.2d0)
        call setcnt2_cvb(2,0)
        call setcnt2_cvb(3,0)
        call setcnt2_cvb(4,0)
      endif
      call setcnt2_cvb(6,0)
      call setcnt2_cvb(7,0)
      call setcnt2_cvb(8,0)
      if(icrit.eq.1)then
        call fx_svb1_cvb(fx,fast,w(iwf1),w(iwf2),
     >    w(lc(1)),w(lc(6)),w(lc(7)),w(lc(8)),
     >    w(lw(4)),w(lw(5)),w(lw(6)),w(lw(9)))
      elseif(icrit.eq.2)then
        call fx_evb1_cvb(fx,fast,w(iwf1),w(iwf2),
     >    w(lc(1)),w(lc(6)),w(lc(7)),w(lc(8)),
     >    w(lw(4)),w(lw(5)),w(lw(6)),w(lw(9)))
      endif
      if(.not.memplenty)then
        call ciwr_cvb(w(lc(6)),61006.2d0)
        call ciwr_cvb(w(lc(7)),61007.2d0)
        call ciwr_cvb(w(lc(8)),61008.2d0)
        call cird_cvb(w(lc(2)),61002.2d0)
        call cird_cvb(w(lc(3)),61003.2d0)
        call cird_cvb(w(lc(4)),61004.2d0)
      endif
c  Figure out what we just calculated, and make it up2date :
      if(dxmove)then
        if(icrit.eq.1)then
          call make_cvb('SVB')
        elseif(icrit.eq.2)then
          call make_cvb('EVB')
        endif
      else
        if(icrit.eq.1)then
          call make_cvb('SVBTRY')
        elseif(icrit.eq.2)then
          call make_cvb('EVBTRY')
        endif
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Tranca(Cavxyz,Cavsph,lMax,CarSph)
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Dimension Cavxyz((lMax+1)*(lMax+2)*(lMax+3)/6),
     &          Cavsph( (lMax+1)**2 )
      Logical CarSph
*
      iOff1 = 1
      iOff2 = 1
      Do 100 m = 0, lMax
         nElem = (m+1)*(m+2)/2
*        Call RecPrt('Car-->Sph',' ',RSph(ipSph(m)),nElem,nElem)
         If (CarSph) Then
            call dcopy_(2*m+1,[Zero],0,Cavsph(iOff2),1)
*           Call RecPrt('Cartesian',' ',Cavxyz(iOff1),1,nElem)
            Call dGeMV_('T',nElem,2*m+1,
     &                 One,RSph(ipSph(m)),nElem,
     &                     Cavxyz(iOff1),1,
     &                 Zero,CavSph(iOff2),1)
*           Call RecPrt('Spherical',' ',Cavsph(iOff2),1,2*m+1)
         Else
            call dcopy_(nElem,[Zero],0,Cavxyz(iOff1),1)
*           Call RecPrt('Spherical',' ',Cavsph(iOff2),1,2*m+1)
            Call dGeMV_('N',nElem,2*m+1,
     &                 One,RSph(ipSph(m)),nElem,
     &                     Cavsph(iOff2),1,
     &                 Zero,Cavxyz(iOff1),1)
*           Call RecPrt('Cartesian',' ',Cavxyz(iOff1),1,nElem)
         End If
         iOff1 = iOff1 + nElem
         iOff2 = iOff2 + 2*m+1
 100  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Jul 01, 2022, created this file.                *
! ****************************************************************

subroutine GetDiagScr(nScr,Mat,EigVal,nDim)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: nScr
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(inout) :: Mat(nDim**2)
real(kind=wp), intent(out) :: EigVal(nDim)
integer(kind=iwp) :: INFO
real(kind=wp) :: Scr(2)

call DSYEV_('V','U',nDim,Mat,nDim,EigVal,Scr,-1,INFO)
NScr = int(Scr(1))

return

end subroutine GetDiagScr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
      Subroutine SGInit(nSym,nActEl,iSpin,SGS,CIS)
      use stdalloc, only: mma_deallocate
      use gugx, only: SGStruct, CIStruct
      use MkGUGA_mod, only: MKGUGA
      IMPLICIT None
      Integer nSym, nActEl, iSpin
      Type (SGStruct), Target :: SGS
      Type (CIStruct) :: CIS

      SGS%nSym=nSym
      SGS%iSpin=iSpin
      SGS%nActEl=nActEl

      Call MkGuga(SGS,CIS)

! Modified Arc Weights table:
      CALL MKMAW(SGS)

! The DAW, RAW tables are no longer needed:
      CALL mma_deallocate(SGS%RAW)
      CALL mma_deallocate(SGS%DAW)

      end Subroutine SGInit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001-2005, Valera Veryazov                             *
!***********************************************************************

subroutine molcas_open(Lu,FileName)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Lu
character(len=*), intent(in) :: FileName
integer(kind=iwp) :: f_recl, f_iostat
character(len=10) :: f_access, f_form, f_status
logical(kind=iwp) :: is_recl, is_error

f_recl = 1
f_iostat = 100
f_access = 'SEQUENTIAL'
f_form = 'FORMATTED'
f_status = 'UNKNOWN'
is_recl = .false.
is_error = .false.

call molcas_open_ext2(Lu,trim(FileName),f_access,f_form,f_iostat,is_recl,f_recl,f_status,is_error)
if (f_iostat /= 0) then
  write(u6,*)
  write(u6,'(3a)') 'molcas_open: Error opening file "',trim(FileName),'"'
  write(u6,'(a,i9)') '   iostat is',f_iostat
  write(u6,'(a)') '   Aborting'
  write(u6,*)
  call Abend()
end if

return

end subroutine molcas_open

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine INCOOS(IDC,IBLTP,NOOS,NOCTPA,NOCTPB,ISTSM,ISTTA,ISTTB,NSM,IENSM,IENTA,IENTB,IACOOS,MXLNG,IFINI,NBLOCK,INCFST,IOCOC)
! Obtain Number of OOS blocks that can be included
! IN MXLNG word starting from block after ISTSM,ISTTA,ISTTB
! Activated blocks are given in IACOOS
! Last activated block is (IENSM,IENTA,IENTB)
! If all blocks have been accessed IFINI is returned as 1
! Diagonal blocks are expanded
!
! Jeppe Olsen, Winter of 1991

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IDC, IBLTP(*), NOCTPA, NOCTPB, NSM, NOOS(NOCTPA,NOCTPB,NSM), MXLNG, INCFST, IOCOC(NOCTPA,NOCTPB)
integer(kind=iwp), intent(inout) :: ISTSM, ISTTA, ISTTB
integer(kind=iwp), intent(out) :: IENSM, IENTA, IENTB, IACOOS(NOCTPA,NOCTPB,NSM), IFINI, NBLOCK
integer(kind=iwp) :: IA, IB, IPA, IPB, IPSM, ISM, LBLOCK, LENGTH
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ISMST
#endif
logical(kind=iwp) :: Skip

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ================'
write(u6,*) ' INCOOS in action'
write(u6,*) ' ================'
write(u6,*)
write(u6,*) ' NOOS(NOCTPA,NOCTPB,NSM) array (input)'
write(u6,*)
do ISMST=1,NSM
  write(u6,*) ' ISMST = ',ISMST
  call IWRTMA(NOOS(:,:,ISMST),NOCTPA,NOCTPB,NOCTPA,NOCTPB)
end do
#endif

IPA = 0
IPB = 0
IPSM = 0

! Initialize
IACOOS(:,:,:) = 0
ISM = ISTSM
IA = ISTTA
IB = ISTTB
LENGTH = 0
NBLOCK = 0
IENSM = ISTSM
IENTA = ISTTA
IENTB = ISTTB
IFINI = 0
if (INCFST == 1) then
  Skip = .true.
else
  Skip = .false.
end if
do
  if (Skip) then
    Skip = .false.
  else
    ! Next block
    IPA = IA
    IPB = IB
    IPSM = ISM

    if (IB < NOCTPB) then
      IB = IB+1
    else
      IB = 1
      if (IA < NOCTPA) then
        IA = IA+1
      else
        IA = 1
        if (ISM < NSM) then
          ISM = ISM+1
        else
          IFINI = 1
        end if
      end if
    end if
    if (IFINI == 1) exit
  end if
  ! Should this block be included
  if (IDC /= 1) then
    if ((IBLTP(ISM) == 0) .or. ((IBLTP(ISM) == 2) .and. (IA < IB))) cycle
  end if
  if (IOCOC(IA,IB) == 0) cycle
  !write(u6,*) ' INCOOS IDC IBLTP ',IDC,IBLTP(ISM)
  ! can this block be included
  LBLOCK = NOOS(IA,IB,ISM)
  !write(u6,*) ' IA IB ISM LBLOCK ',IA,IB,ISM,LBLOCK
  if (LENGTH+LBLOCK > MXLNG) then
    IA = IPA
    IB = IPB
    ISM = IPSM
    exit
  end if
  NBLOCK = NBLOCK+1
  LENGTH = LENGTH+LBLOCK
  IACOOS(IA,IB,ISM) = 1
  if (NBLOCK == 1) then
    ISTTA = IA
    ISTTB = IB
    ISTSM = ISM
  end if
end do

IENSM = ISM
IENTA = IA
IENTB = IB
if ((IFINI == 0) .and. (NBLOCK == 0)) then
  write(u6,*) ' Not enough scratch space to include a single Block'
  write(u6,*) ' Since I cannot proceed I will stop'
  write(u6,*) ' Insufficient buffer detected in INCOOS'
  write(u6,*) ' Alter RAS space of raise Buffer from ',MXLNG
  call SYSABENDMSG('lucia_util/incoos','Internal error',' ')
end if

#ifdef _DEBUGPRINT_
write(u6,*) 'Output from INCOOS'
write(u6,*) '=================='
write(u6,*) ' Length and number of included blocks ',LENGTH,NBLOCK
do ISM=ISTSM,IENSM
  write(u6,*) ' Active blocks of symmetry ',ISM
  call IWRTMA(IACOOS(1,1,ISM),NOCTPA,NOCTPB,NOCTPA,NOCTPB)
end do
if (IFINI == 1) write(u6,*) ' No new blocks'
#endif

return

end subroutine INCOOS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine chpcmpinit_cvb()
      implicit real*8 (a-h,o-z)
#include "lstprm_cvb.fh"

      do 100 i=1,mxprm
      lstprm(i)=iunset
100   continue
      iprm=0
      return
      entry chpcmp0_cvb()
      iprm=0
      return
      entry chpcmp2_cvb(itst,iret)
      iprm=iprm+1
      if(iprm.gt.mxprm)then
        write(6,*)' Dimensioning error in CHPCMP2!',iprm,mxprm
        call abend_cvb()
      endif
      iret=lstprm(iprm)
      lstprm(iprm)=itst
      return
      end
      function recinpcmp_cvb(ifield)
      implicit real*8 (a-h,o-z)
      logical recinpcmp_cvb
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"

      if(.not.valid_cvb(recinp_old))then
        recinpcmp_cvb=.true.
      else
        call rdioff_cvb(ifield,recinp,ioff1)
        call rdioff_cvb(ifield+1,recinp,ioff2)
        call rdioff_cvb(ifield,recinp_old,joff1)
        call rdioff_cvb(ifield+1,recinp_old,joff2)
        if(ioff2-ioff1.ne.joff2-joff1)then
          recinpcmp_cvb=.true.
        else
          i1=mstackr_cvb(ioff2-ioff1)
          j1=mstackr_cvb(joff2-joff1)
          call rdr_cvb(w(i1),ioff2-ioff1,recinp,ioff1)
          call rdr_cvb(w(j1),joff2-joff1,recinp_old,joff1)
          do 100 i=0,ioff2-ioff1-1
          if(w(i+i1).ne.w(i+j1))then
            recinpcmp_cvb=.true.
            goto 200
          endif
100       continue
          recinpcmp_cvb=.false.
200       call mfreer_cvb(i1)
        endif
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine  Ext_L1 (V1,V2,
     c                      no,dima,dimc,adda,nbs)
c
c       this routine do:
c       V2(i,a',m') <- V1(p,q,m')
c
        implicit none
        integer no,dima,dimc,adda,nbs
        real*8 V1(1:nbs,1:nbs,1:dimc)
        real*8 V2(1:no,1:dima,1:dimc)
c
c       help variables
        integer i,a,m
c
        do m=1,dimc
        do a=1,dima
        do i=1,no
        V2(i,a,m)=V1(i,adda+a,m)
        end do
        end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_Tr_Dab(nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,CMO,nCMO,OrbE,nOrbE,TrD)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nFro(nSym), nIsh(nSym), nAsh(nSym), nSsh(nSym), nDel(nSym), nCMO, nOrbE
real(kind=wp), intent(in) :: CMO(nCMO), OrbE(nOrbE)
real(kind=wp), intent(out) :: TrD(nSym)
integer(kind=iwp) :: iE, ifr, ioff, ip_Y, irc, iSkip, iSym, ito, iV, joff, kEOcc, kEVir, kfr, koff, kto, lnDel(8), lnFro(8), &
                     lnOcc(8), lnOrb(8), lnVir(8), nAct(8), nBB, nOA, nOrb, nVV
real(kind=wp) :: Dummy
real(kind=wp), allocatable :: CMON(:), DMat(:), EOrb(:)

nAct(:) = 0
nVV = sum(nSsh(:)**2)
nOrb = 0
do iSym=1,nSym
  iE = nOrb+nFro(iSym)+nIsh(iSym)
  nAct(iSym) = count(OrbE(iE+1:iE+nAsh(iSym)) < Zero)
  nOrb = nOrb+nBas(iSym)
end do

! setup info
lnOrb(1:nSym) = nBas(:)
lnFro(1:nSym) = nFro(:)
lnOcc(1:nSym) = nIsh(:)+nAct(1:nSym)
lnVir(1:nSym) = nSsh(:)
lnDel(1:nSym) = nDel(:)
nBB = sum(nBas(:)**2)
nOA = sum(lnOcc(1:nSym))

call mma_allocate(Eorb,2*nOrb,Label='EOrb')
kEOcc = 1
kEVir = kEOcc+nOrb
ioff = 0
joff = 0
koff = 0
do iSym=1,nSym
  ifr = 1+ioff+nFro(iSym)
  ito = kEOcc+joff
  EORb(ito:ito+lnOcc(iSym)-1) = OrbE(ifr:ifr+lnOcc(iSym)-1)
  ifr = 1+ioff+nFro(iSym)+nIsh(iSym)+nAsh(iSym)
  ito = kEVir+koff
  EORb(ito:ito+nSsh(iSym)-1) = OrbE(ifr:ifr+nSsh(iSym)-1)
  ioff = ioff+nBas(iSym)
  joff = joff+lnOcc(iSym)
  koff = koff+nSsh(iSym)
end do

call mma_allocate(Dmat,nVV+nOA,Label='DMat')
ip_Y = 1+nVV
DMAT(:) = Zero

call LovCASPT2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,.true.)
call mma_allocate(CMON,nBB,Label='CMON')
CMON(:) = Zero
iOff = 0
do iSym=1,nSym
  kfr = 1+iOff+nBas(iSym)*nFro(iSym)
  kto = 1+iOff+nBas(iSym)*lnFro(iSym)
  CMON(kto:kto+nBas(iSym)*lnOcc(iSym)-1) = CMO(kfr:kfr+nBas(iSym)*lnOcc(iSym)-1)
  kfr = 1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
  kto = kto+nBas(iSym)*lnOcc(iSym)
  CMON(kto:kto+nBas(iSym)*lnVir(iSym)-1) = CMO(kfr:kfr+nBas(iSym)*lnVir(iSym)-1)
  iOff = iOff+nBas(iSym)**2
end do

call Check_Amp(nSym,lnOcc,lnVir,iSkip)
if (iSkip > 0) then
  call ChoMP2_Drv(irc,Dummy,CMON,EOrb(kEOcc),Eorb(kEVir),DMAT(1:nVV),DMAT(ip_Y:))
  if (irc /= 0) then
    write(u6,*) 'MP2 pseudodensity calculation failed !'
    call Abend()
  end if
else
  write(u6,*)
  write(u6,*) 'There are ZERO amplitudes T(ai,bj) with the given '
  write(u6,*) 'combinations of inactive and virtual orbitals !! '
  write(u6,*) 'Check your input and rerun the calculation! Bye!!'
  call Abend()
end if
call mma_deallocate(CMON)

iV = 0
do iSym=1,nSym
  TrD(iSym) = sum(DMat(iV+1:iV+lnVir(iSym)**2:1+lnVir(iSym)))
  iV = iV+lnVir(iSym)**2
end do
call mma_deallocate(Dmat)
call mma_deallocate(Eorb)

end subroutine Compute_Tr_Dab

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine mu_order( dim, MS, MM, gtens, order, HCF2, AMM,
     &                     AMS, Z, iprint)

C This Subroutine receives the moment matrix dipso(3,dim,dim) and Returns the matrix re-builted using only the 1-st order operators.

      Implicit None
      Integer, parameter       :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)      :: dim, order, iprint
      Real(kind=8), intent(out) :: gtens(3)
!     initial magnetic moment
      Complex(kind=8), intent(in)  ::  MM(3,dim,dim)
!     initial spin moment
      Complex(kind=8), intent(in)  ::  MS(3,dim,dim)
!     transformed magnetic moment
      Complex(kind=8), intent(out) :: AMM(3,dim,dim)
!     transformed spin moment
      Complex(kind=8), intent(out) :: AMS(3,dim,dim)
      Complex(kind=8), intent(out) :: Z(dim,dim)
      Complex(kind=8), intent(out) :: HCF2(dim,3,dim,dim)

      ! local variables:
      Integer             :: i,j,l,i1,i2,m,n
      Real(kind=8)       :: maxes(3,3)
      Complex(kind=8)    :: DIP_O(dim,dim), DIP_W(dim,dim),
     &                       B(3,dim,-dim:dim), BNMC(3,dim,0:dim),
     &                       BNMS(3,dim,0:dim), SP_MOW, SP_DIPO(3),
     &                       SP_DIPW(3), O1, O2, m_fact, trace
      External            :: trace
!------------------------------------------------------------
      Z=(0.0_wp,0.0_wp)
      ! get the local pseudospin:
      Call pseudospin( MM, dim, Z, 3,1, iprint)
      ! re-write MM and MS to the new pseudospin basis:
      AMS=(0.0_wp,0.0_wp)
      AMM=(0.0_wp,0.0_wp)
      Do l=1,3
        Do i=1,dim
          Do j=1,dim
            Do i1=1,dim
              Do i2=1,dim
         AMM(l,i,j) = AMM(l,i,j) + MM(l,i1,i2) * conjg(Z(i1,i))*Z(i2,j)
         AMS(l,i,j) = AMS(l,i,j) + MS(l,i1,i2) * conjg(Z(i1,i))*Z(i2,j)
              End Do
            End Do
          End Do
        End Do
      End Do
      If(iprint.gt.2) Then
        Call prMom('MU_ORDER:   AMM(l,i,j):',AMM,dim)
        Call prMom('MU_ORDER:   AMS(l,i,j):',AMS,dim)
      End If
      !project the moment on ITO:
      !obtain the b3m and c3m coefficients:
      B(1:3,1:dim,-dim:dim)=(0.0_wp,0.0_wp)
      Do N=1,dim-1
        Do M=0,N
          DIP_O = (0.0_wp,0.0_wp)
          DIP_W = (0.0_wp,0.0_wp)
          Call Stewens_matrixel(N,M,dim,DIP_O,DIP_W,iprint)
          If(iprint.gt.5) Then
            Write(6,*)
            Write(6,'( 5x,a,i2,a,i3)') 'DIP_O, n = ',N,', m =',m
            Write(6,*)
            Do i=1,dim
              Write(6,'(20(2F10.6,2x))') (DIP_O(i,j), j=1,dim)
            End Do
            Write(6,*)
            Write(6,'( 5x,a,i2,a,i3)')  'DIP_W, n = ',N,', m =',m
            Write(6,*)
            Do i=1,dim
              Write(6,'(20(2F10.6,2x))') (DIP_W(i,j), j=1,dim)
            End Do
          End If

          SP_DIPO = (0.0_wp,0.0_wp)
          SP_DIPW = (0.0_wp,0.0_wp)
          SP_MOW  = (0.0_wp,0.0_wp)
          SP_MOW  = trace(dim,DIP_O,DIP_W)
          Do l=1,3
            SP_DIPO(l)=trace(dim,AMS(l,1:dim,1:dim),DIP_O(1:dim,1:dim))
            SP_DIPW(l)=trace(dim,AMS(l,1:dim,1:dim),DIP_W(1:dim,1:dim))

            B(l,n,-m)=SP_DIPO(l)/SP_MOW
            B(l,n, m)=SP_DIPW(l)/SP_MOW
          End Do ! l
        End Do !m
      End Do !n

      BNMC=(0.0_wp,0.0_wp)
      BNMS=(0.0_wp,0.0_wp)
      Do n=1,dim-1
        Do m=0,N
          Do l=1,3
            If(M.eq.0) Then
              BNMC(l,n,m)=(0.5_wp,0.0_wp)*(B(l,n,m)+B(l,n,-m))
            Else
              m_fact=cmplx((-1)**M,0,wp)
              BNMC(l,n,m)=  B(l,n,m)+m_fact*B(l,n,-m)
              BNMS(l,n,m)=( B(l,n,m)-m_fact*B(l,n,-m) )*(0.0_wp,-1.0_wp)
            End If
          End Do
        End Do
      End Do !n

      If(iprint.gt.2) Then
        Write(6,'(100A)') ('-',i=1,47),'|'
        Write(6,'(A)') '  n  |  m  |   |       B       |'//
     &                                 '       C       |'
        Do N=1,dim-1
          Write(6,'(A)') '-----|-----|---|---------------|'//
     &                                   '---------------|'
           Do M=0,N
             If (M.ne.0) Write(6,'(A)')
     &           '     |-----|---|---------------|---------------|'
             Write(6,'(2(2x,I1,2x,A),1x,A,1x,A,2(F14.9,1x,A))')
     &             N,'|',M,'|','X','|',DBLE(BNMC(1,N,M)),'|',
     &                                 DBLE(BNMS(1,N,M)),'|'
             Write(6,'(2(2x,I1,2x,A),1x,A,1x,A,2(F14.9,1x,A))')
     &             N,'|',M,'|','Y','|',DBLE(BNMC(2,N,M)),'|',
     &                                 DBLE(BNMS(2,N,M)),'|'
             Write(6,'(2(2x,I1,2x,A),1x,A,1x,A,2(F14.9,1x,A))')
     &             N,'|',M,'|','Z','|',DBLE(BNMC(3,N,M)),'|',
     &                                 DBLE(BNMS(3,N,M)),'|'
           End Do
        End Do
        Write(6,'(100A)') ('-',i=1,47),'|'
      End If

      HCF2=(0.0_wp,0.0_wp)
      Do N=1,dim-1
        Do M=0,N
          DIP_O = (0.0_wp,0.0_wp)
          DIP_W = (0.0_wp,0.0_wp)

          Call Stewens_matrixel( N, M, dim, DIP_O, DIP_W, iprint )

          Do l=1,3
            Do i=1,dim
              Do j=1,dim
                If(M.eq.0) Then
                  HCF2(N,l,i,j) = HCF2(N,l,i,j) + BNMC(l,N,M)*DIP_O(i,j)
                Else
                m_fact=(0.0_wp, 0.0_wp)
                    O1=(0.0_wp, 0.0_wp)
                    O2=(0.0_wp, 0.0_wp)

                  m_fact=cmplx((-1)**M,0,wp)
                    O1=(0.5_wp, 0.0_wp)*( m_fact*DIP_W(i,j)+DIP_O(i,j) )
                    O2=(0.0_wp,-0.5_wp)*( m_fact*DIP_W(i,j)-DIP_O(i,j) )

                  HCF2(N,l,i,j) = HCF2(N,l,i,j) + BNMC(l,N,M) * O1
     &                                          + BNMS(l,N,M) * O2
                End If
              End Do
            End Do
          End Do
        End Do
      End Do !n

      If(iprint.gt.2) Then
        Do N=1,dim-1,2
          Write(6,*)
          Write(6,'( 5x,a,I2,a)')  'HCF2(',N,',l,i,j)'
          Do l=1,3
            Write(6,*)
            Write(6,'(a,i3)') 'PROJECTION =' , l
            Do i=1,dim
              Write(6,'(20(2F12.8,2x))') (HCF2(N,l,i,j), j=1,dim)
            End Do
          End Do
          Write(6,*)
        End Do
      End If

      gtens=0.0_wp
      maxes=0.0_wp
      Call ATENS( HCF2(order,:,:,:), dim, gtens, maxes, 1)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Ignacio Fdez. Galvan                             *
************************************************************************
*  Sp_Symmetrize
*
*> @ingroup Sparse
*> @brief Converts a sparse matrix to symmetric format
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Converts a matrix \p A to a matrix \p B, stored in symmetric mode.
*> Only the lower triangle of \p A is stored.
*>
*> @param[in]  n   Size of the matrix
*> @param[in]  A   Input matrix, in sparse format
*> @param[in]  ija Index vector of matrix \p A
*> @param[out] B   Output matrix, in sparse format
*> @param[out] ijb Index vector of matrix \p B
************************************************************************
      SUBROUTINE Sp_Symmetrize(n,A,ija,B,ijb)
      IMPLICIT NONE
      INTEGER n, nijb, ija(*), ijb(*), i, j, k
      REAL*8 A(*), B(*)
#include "real.fh"

      ijb(1)=n+2
      nijb=n+1
      DO i=1,n
        B(i)=A(i)
        DO k=ija(i),ija(i+1)-1
          j=ija(k)
          IF (j.LT.i) THEN
            nijb=nijb+1
            B(nijb)=A(k)
            ijb(nijb)=ija(k)
          END IF
        END DO
        ijb(i+1)=nijb+1
      END DO
      B(n+1)=One

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_RdQCol_Indx(xInt,IDCol,nRow,nCol,Lunit)
C
C     Purpose: read indexed qualified columns from WA file with unit
C              Lunit. (WA=word-addressable)
C
      Implicit None
      Integer nRow, nCol
      Real*8  xInt(nRow,nCol)
      Integer IDCol(nCol)
      Integer Lunit

      Integer iCol, iOpt, iAdr, lTot

      If (nRow.lt.1 .or. nCol.lt.1) Return

      Do iCol = 1,nCol
         iOpt = 2
         lTot = nRow
         iAdr = nRow*(IDCol(iCol)-1)
         Call dDAFile(Lunit,iOpt,xInt(1,iCol),lTot,iAdr)
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _DMRG_

!***********************************************************************
!                                                                      *
!  Purpose:  read (and check) DMRG input in QCMaquis style             *
!                                                                      *
!***********************************************************************
subroutine qcmaquis_rdinp(luinput,switch,nr_lines)

use qcmaquis_interface_cfg, only: dmrg_input, qcmaquis_param
use qcmaquis_interface_utility_routines, only: find_qcmaquis_keyword, lower_to_upper
use rasscf_global, only: DoDelChk, MPSCompressM
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: luinput, switch
integer(kind=iwp), intent(inout) :: nr_lines
integer(kind=iwp) :: i, io, j
logical(kind=iwp) :: compr_flag, donotdelete_flag
character(len=500) :: line, line2

! option for the MPS compression and the do not delete checkpoints flag
compr_flag = .false.
donotdelete_flag = .false.

select case (switch)
  case (1)
    !> find maximum number of input lines
    nr_lines = 0
    do
      line(1:500) = ' '
      read(luinput,*,iostat=io) line
      if (is_iostat_end(io)) exit
      if (io > 0) stop 'problem reading QCMaquis input'
      call lower_to_upper(line(1:5))
      if ((line(1:5) == 'ENDRG') .or. (line(1:5) == 'ENDDM')) exit
      nr_lines = nr_lines+1
    end do
    dmrg_input%nr_qcmaquis_input_lines = nr_lines
    !> read input lines
  case (2)
    if (nr_lines == 0) return
    allocate(dmrg_input%qcmaquis_input(nr_lines))

    DoDelChk = .false.

    dmrg_input%qcmaquis_input = ' '

    do i=1,nr_lines
      read(luinput,*,iostat=io) line
      if (is_iostat_end(io)) exit
      if (io > 0) then
        write(u6,*) 'Problem reading QCMaquis input'
        call Quit_OnUserError()
      end if
      ! Leon: handle a special case where we input the MPS compression
      ! parameter in the RGINPUT block but it does not get passed to
      ! QCMaquis at all

      dmrg_input%qcmaquis_input(i) = trim(line)
      if (.not. compr_flag) then
        line2 = adjustl(trim(line))
        call lower_to_upper(line2(1:5))
        ! process the compression keyword
        ! set the compression flag to true and read the next line.
        if (line2(1:5) == 'COMPR') compr_flag = .true.
      else
        read(line,*,iostat=io) MPSCompressM
        if (io /= 0) then
          write(u6,*) 'Problem reading QCMaquis input'
          call Quit_OnUserError()
        end if
        compr_flag = .false.
      end if

      !! Handle a "do not delete" flag in QCMaquis input, which prevents
      !! deleting old MPS checkpoint files (in case we want a restart)
      if (.not. donotdelete_flag) then
        line2 = adjustl(trim(line))
        call lower_to_upper(line2(1:6))
        ! process the do not delete keyword
        ! set the do not delete flag to true and read the next line.
        if (line2(1:6) == 'DONOTD') donotdelete_flag = .true.
      else
        line2 = adjustl(trim(line))
        call lower_to_upper(line2(1:4))
        if ((line2(1:1) == '1') .or. (line2(1:4) == 'TRUE')) DoDelChk = .true.
        if (io /= 0) then
          write(u6,*) 'Problem reading QCMaquis input'
          call Quit_OnUserError()
        end if
        donotdelete_flag = .false.
      end if

    end do

  case (3)
    !> sanity check input for ALL mandatory keywords
    do j=1,2
      line(1:500) = ' '
      select case (j)
        case (1)
          line = 'NSWEEPS'
        case (2)
          line = 'MAX_BOND_DIMENSION'
        case (3)
          line = 'CONV_THRESH'
      end select
      i = 0
      call find_qcmaquis_keyword(dmrg_input%qcmaquis_input,nr_lines,line,i)
      if (i <= 0) then
        !> check for keyword sweep_bond_dimension which is an alternative
        !conv_thresh is not mandatory
        if (trim(line) == 'CONV_THRESH') cycle
        if (trim(line) == 'MAX_BOND_DIMENSION') then
          line2(1:500) = ' '
          line2 = 'SWEEP_BOND_DIMENSIONS'
          i = 0
          call find_qcmaquis_keyword(dmrg_input%qcmaquis_input,nr_lines,line2,i)
          if (i > 0) cycle
        end if
        call WarningMessage(2,'Error in input preprocessing.')
        write(u6,*) ' qcmaquis_rdinp: mandatory keyword ',trim(line),' missing in QCMaquis DMRG input section'
        nr_lines = -1
        return

      else
        select case (j)
          case (1)
            ! read in nsweeps
            read(dmrg_input%qcmaquis_input(i+1),*) qcmaquis_param%num_sweeps
          case (2)
            ! read in max_bond_dimension
            read(dmrg_input%qcmaquis_input(i+1),*) qcmaquis_param%M
          case (3)
            ! read in conv_thresh
            read(dmrg_input%qcmaquis_input(i+1),*) qcmaquis_param%conv_thresh
        end select
      end if

    end do
  case default
    write(u6,*) ' QCMaquis input reader - you should have never reached this spot...'
    call Quit_OnUserError()
end select

end subroutine qcmaquis_rdinp

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(qcmaquis_rdinp)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GenRadQuad_MHL(R,nR,nR_Eff,Alpha)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "debug.fh"
      Real*8 R(2,nR-1), Alpha
*
*---- Last point at infinity is eliminated
*
      If (Debug) Then
         Write (6,*) 'EM Algorithm (Murray, Handy, Laming)'
         Write (6,*) 'Alpha=',Alpha
         Write (6,*) 'nR=',nR
      End If
      Do iR = 1, nR-1
         x       = DBLE(iR)/DBLE(nR)
         R(1,iR) = Alpha * (x/(One-x))**2
         R(2,iR) = R(1,iR)**2 * Two* Alpha * x / (One-x)**3 / DBLE(nR)
      End Do
      nR_Eff = nR-1
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mult_sro(A,nA,C,nC,B,nB,Fact,Res,Tmp)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nA, nC, nB
real(kind=wp), intent(in) :: A(nA,nC), C(nC,nC), B(nC,nB), Fact
real(kind=wp), intent(inout) :: Res(nA,nB)
real(kind=wp), intent(out) :: Tmp(nA,nC)

call DGEMM_('N','N',nA,nC,nC,One,A,nA,C,nC,Zero,Tmp,nA)
call DGEMM_('N','N',nA,nB,nC,Fact,Tmp,nA,B,nC,One,Res,nA)

return

end subroutine mult_sro

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Jeppe Olsen                                      *
!***********************************************************************

subroutine T_TO_NK_VECS(T,KORB,C,LUCIN,LUCOUT,NSSOA,NSSOB,NBLOCK,IBLOCK,NAEL,NBEL,IASTR,IBSTR,IBLTP,NSMST,ICISTR,NORB,IKAOCC,IKBOCC)
! Multiply Vector in LUCIN with t **NK_op to yield vector on LUCOUT
!
! Both files are initially rewound
!
! Jeppe Olsen, Feb. 1998

use lucia_data, only: IDISK
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: T
integer(kind=iwp), intent(in) :: KORB, LUCIN, LUCOUT, NSMST, NSSOA(NSMST,*), NSSOB(NSMST,*), NBLOCK, IBLOCK(8,NBLOCK), NAEL, NBEL, &
                                 IBLTP(*), ICISTR, NORB
real(kind=wp), intent(_OUT_) :: C(*)
integer(kind=iwp), intent(inout) :: IASTR(NAEL,*), IBSTR(NBEL,*)
integer(kind=iwp), intent(_OUT_) :: IKAOCC(*), IKBOCC(*)
integer(kind=iwp) :: IA, IAMPACK, IASM, IATP, IB, IBSM, IBTP, IDET, IDUM(1), IMZERO, IRESTR, JAEL, JBEL, JBLOCK, JSTR, KABOCC, &
                     KOCC, LDET, MINIA, NASTR1, NBSTR1, NIA, NIB
real(kind=wp) :: T2

IDISK(LUCIN) = 0
IDISK(LUCOUT) = 0

T2 = T**2
do JBLOCK=1,NBLOCK
  IATP = IBLOCK(1,JBLOCK)
  IBTP = IBLOCK(2,JBLOCK)
  IASM = IBLOCK(3,JBLOCK)
  IBSM = IBLOCK(4,JBLOCK)
  !write(u6,*) ' IATP IBTP IASM IBSM ',IATP,IBTP,IASM,IBSM
  ! Obtain alpha strings of sym IASM and type IATP
  IDUM(1) = 0
  call GETSTR_TOTSM_SPGP(1,IATP,IASM,NAEL,NASTR1,IASTR,NORB,0,IDUM,IDUM)
  ! Occupation of orb KORB
  do JSTR=1,NASTR1
    KOCC = 0
    do JAEL=1,NAEL
      if (IASTR(JAEL,JSTR) == KORB) KOCC = 1
    end do
    IKAOCC(JSTR) = KOCC
  end do
  !write(u6,*) ' IKAOCC array'
  !call IWRTMA(IKAOCC,1,NASTR1,1,NASTR1)

  ! Obtain Beta  strings of sym IBSM and type IBTP
  IDUM(1) = 0
  call GETSTR_TOTSM_SPGP(2,IBTP,IBSM,NBEL,NBSTR1,IBSTR,NORB,0,IDUM,IDUM)
  !write(u6,*) ' After GETSTR, NBSTR1=',NBSTR1
  ! Occupation of orb KORB
  do JSTR=1,NBSTR1
    !write(u6,*) ' JSTR = ',JSTR
    KOCC = 0
    do JBEL=1,NBEL
      !write(u6,*) JBEL,IBSTR(JBEL,JSTR)
      if (IBSTR(JBEL,JSTR) == KORB) KOCC = 1
    end do
    IKBOCC(JSTR) = KOCC
  end do
  !write(u6,*) ' IKBOCC array'
  !call IWRTMA(IKBOCC,1,NBSTR1,1,NBSTR1)

  if (IBLTP(IASM) == 2) then
    IRESTR = 1
  else
    IRESTR = 0
  end if
  !write(u6,*) ' IBLTP ',IBLTP(IASM)

  NIA = NSSOA(IASM,IATP)
  NIB = NSSOB(IBSM,IBTP)
  !write(u6,*) ' NIA NIB ',NIA,NIB

  IMZERO = 0
  if (ICISTR >= 2) then
    ! Read in a Type-Type-symmetry block
    call IDAFILE(LUCIN,2,IDUM,1,IDISK(LUCIN))
    LDET = IDUM(1)
    call IDAFILE(LUCIN,2,IDUM,1,IDISK(LUCIN))
    call FRMDSC(C,LDET,-1,LUCIN,IMZERO,IAMPACK)
  end if
  if (IMZERO /= 1) then

    IDET = 0
    do IB=1,NIB
      if ((IRESTR == 1) .and. (IATP == IBTP)) then
        MINIA = IB
      else
        MINIA = 1
      end if
      do IA=MINIA,NIA

        IDET = IDET+1
        !write(u6,*) ' IA IB IDET',IA,IB,IDET
        KABOCC = IKAOCC(IA)+IKBOCC(IB)
        if (KABOCC == 1) then
          C(IDET) = T*C(IDET)
        else if (KABOCC == 2) then
          C(IDET) = T2*C(IDET)
        end if
      end do
      ! End of loop over alpha strings
    end do
    ! End of loop over beta strings

  end if
  ! End of if statement for nonvanishing blocks
  ! Save result on LUCOUT
  IDUM(1) = LDET
  call ITODS(IDUM,1,-1,LUCOUT)
  call TODSC(C,LDET,-1,LUCOUT)
end do
! End of loop over blocks
! This is the end, the end of every file my friend, the end
IDUM(1) = -1
call ITODS(IDUM,1,-1,LUCOUT)

end subroutine T_TO_NK_VECS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
!     Some incomplete documentation
!
!     Vlct  : logical flag to indicate that the velocity integrals will*
!             be computed                                              *
!     lRel  : logical flag to indicate that the 1-electron Darwin and  *
!             mass-velocity integrals should be computed               *
!     UnNorm: logical flag to indicate that the primitive basis        *
!             functions should not be normalized                       *
!     lSchw : logical flag to indicate that the Cauchy-Schwartz        *
!             inequality should be used in the prescreening            *
!     lAMFI : logical flag for Atomic Mean Field Integrals             *
!     GIAO: integrals for first derivative with respect to B           *
!     Do_FckInt: logical flag for FckInt                               *
!     Do_GuessOrb: logical flag for GuessOrb                           *
!     EMFR: Electromagnetic field radiation                            *
!     FNMC: finite nuclear mass correction
Module Logical_Info
Private
Public :: Vlct, lRel, UnNorm, lSchw, lAMFI, NEMO, Do_GuessOrb, Do_FckInt, &
          Align_Only, DoFMM,  lRP, lRP_Post, EMFR, Do_Align, GIAO, lUPONLY, &
          lDOWNONLY, FNMC, lPSOI, &
          Logical_Info_Dmp, Logical_Info_Get

#include "stdalloc.fh"
Integer i
Logical :: Vlct=.True.
Logical :: lRel=.False.
Logical :: UnNorm=.False.
Logical :: lSchw=.True.
Logical :: lAMFI=.False.
Logical :: NEMO=.False.
Logical :: Do_GuessOrb=.True.
Logical :: Do_FckInt=.True.
Logical :: Align_Only=.False.
Logical :: DoFMM=.False.
Logical :: lRP=.False.
Logical :: lRP_Post=.False.
Logical :: Do_Align=.True.
Logical :: EMFR  =.False.
Logical :: GIAO=.False.
Logical :: lUPONLY=.False.
Logical :: lDOWNONLY=.False.
Logical :: FNMC=.False.
Logical :: lPSOI=.False.

Interface
   Subroutine Put_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Put_iArray
   Subroutine Get_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Get_iArray
End Interface

Contains

Subroutine Logical_Info_Dmp()
  Integer, Allocatable:: iDmp(:)
  Integer:: Len=19

  Call mma_allocate(iDmp,Len,Label='iDmp:Logical')

  i = 0
  If (Vlct) i = 1
  iDmp(01)= i
  i = 0
  If (lRel) i = 1
  iDmp(02)= i
  i = 0
  If (UnNorm) i = 1
  iDmp(03)= i
  i = 0
  If (lSchw) i = 1
  iDmp(04)= i
  i = 0
  If (lAMFI) i = 1
  iDmp(05)= i
  i = 0
  If (NEMO) i = 1
  iDmp(06)= i
  i = 0
  If (Do_GuessOrb) i = 1
  iDmp(07)= i
  i = 0
  If (Do_FckInt) i = 1
  iDmp(08)= i
  i = 0
  If (Align_Only) i = 1
  iDmp(09)= i
  i = 0
  If (DoFMM) i = 1
  iDmp(10)= i
  i = 0
  If (lRP) i = 1
  iDmp(11)= i
  i = 0
  If (lRP_Post) i = 1
  iDmp(12)= i
  i = 0
  If (Do_Align) i = 1
  iDmp(13)= i
  i = 0
  If (EMFR) i = 1
  iDmp(14)= i
  i = 0
  If (GIAO) i = 1
  iDmp(15)= i
  i = 0
  If (lUPONLY) i = 1
  iDmp(16)= i
  i = 0
  If (lDOWNONLY) i = 1
  iDmp(17)= i
  i = 0
  If (FNMC) i = 1
  iDmp(18)= i
  i = 0
  If (lPSOI) i = 1
  iDmp(19)= i

  Call Put_iArray('Logical_Info',iDmp,Len)
  Call mma_deallocate(iDmp)
End Subroutine Logical_Info_Dmp

Subroutine Logical_Info_Get()
  Integer, Allocatable:: iDmp(:)
  Integer:: Len=19

  Call mma_allocate(iDmp,Len,Label='iDmp:Logical')
  Call Get_iArray('Logical_Info',iDmp,Len)

  Vlct         = iDmp(01).eq.1
  lRel         = iDmp(02).eq.1
  UnNorm       = iDmp(03).eq.1
  lSchw        = iDmp(04).eq.1
  lAMFI        = iDmp(05).eq.1
  NEMO         = iDmp(06).eq.1
  Do_GuessOrb  = iDmp(07).eq.1
  Do_FckInt    = iDmp(08).eq.1
  Align_Only   = iDmp(09).eq.1
  DoFMM        = iDmp(10).eq.1
  lRP          = iDmp(11).eq.1
  lRP_Post     = iDmp(12).eq.1
  Do_Align     = iDmp(13).eq.1
  EMFR         = iDmp(14).eq.1
  GIAO         = iDmp(15).eq.1
  lUPONLY      = iDmp(16).eq.1
  lDOWNONLY    = iDmp(17).eq.1
  FNMC         = iDmp(18).eq.1
  lPSOI        = iDmp(19).eq.1

  Call mma_deallocate(iDmp)


End Subroutine Logical_Info_Get

End Module Logical_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RBuf_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IST,IADXS)
      Implicit real*8(a-h,o-z)
*     Integer  MEMX,KBUF,BLKSZ,NBLCK,NPASS,DLNGTH

#include "SysDef.fh"
      Dimension W(*)
*      Call GetMem('MaxMem','MAX','REAL',KBUF,MEMX)
*      BLKSZ=(NOTU-1)*IADXS
*      NBLCK=(MEMX)/BLKSZ

      IST=1
*      if(NBLCK.gt.1.and.LBuf.lt.256) Then
*      Call RBufF_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IST,IADXS,MEMX)
*      Else
      Call RBufO_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IST,IADXS)
*      End If
      IST=1
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************

!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*
subroutine MKSEG(SGS,CIS,EXS)
! PURPOSE: CONSTRUCT THE TABLES ISGM AND VSGM.
! ISGM(IVLT,ISGT) REFERS TO A SEGMENT OF THE SEGMENT TYPE
!    ISGT=1,..,26, WHOSE TOP LEFT VERTEX IS IVLT. ISGM GIVES
!    ZERO IF THE SEGMENT IS IMPOSSIBLE IN THE GRAPH DEFINED BY
!    THE PALDUS TABLE DRT. ELSE IT IS THE BOTTOM LEFT VERTEX
!    NUMBER OF THE SEGMENT. THE SEGMENT VALUE IS THEN VSGM.

use gugx, only: CIStruct, EXStruct, SGStruct
use segtab, only: IC1, IC2, ISVC, ITVPT
use stdalloc, only: mma_allocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(inout) :: CIS
type(EXStruct), intent(inout) :: EXS
integer(kind=iwp) :: IA, IAL, IB, IBL, ISGT, ITT, IV, IV1, IV2, IVL, IVLB, IVLT, IVRB, IVRT, LEV, MV, MVLL, MVRR
real(kind=wp) :: V
integer(kind=iwp), parameter :: IATAB = 3, IBTAB = 4
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ICL, ICR, ID
character(len=20) :: TEXT
character(len=*), parameter :: FRML(7) = ['        1.0         ','       -1.0         ','        1/(B+1)     ', &
                                          '       -1/(B+1)     ','  SQRT(   B /(B+1)) ','  SQRT((B+2)/(B+1)) ', &
                                          '  SQRT(B(B+2))/(B+1)']
#endif

call mma_allocate(CIS%IVR,SGS%nVert,2,Label='CIS%IVR')
call mma_allocate(CIS%ISGM,SGS%nVert,26,Label='CIS%ISGM')
call mma_allocate(CIS%VSGM,SGS%nVert,26,Label='CIS%VSGM')
call mma_allocate(EXS%MVL,CIS%nMidV,2,Label='EXS%MVL')
call mma_allocate(EXS%MVR,CIS%nMidV,2,Label='EXS%MVR')

CIS%IVR(:,:) = 0
do LEV=1,SGS%nLev
  IV1 = SGS%LTV(LEV)
  IV2 = SGS%LTV(LEV-1)-1
  do IVL=IV1,IV2
    IAL = SGS%DRT(IVL,IATAB)
    IBL = SGS%DRT(IVL,IBTAB)
    do IV=IVL+1,IV2
      IA = SGS%DRT(IV,IATAB)
      if (IA == IAL) then
        IB = SGS%DRT(IV,IBTAB)
        if (IB == (IBL-1)) CIS%IVR(IVL,1) = IV
      else if (IA == (IAL-1)) then
        IB = SGS%DRT(IV,IBTAB)
        if (IB == (IBL+1)) CIS%IVR(IVL,2) = IV
      end if
    end do
  end do
end do
! CONSTRUCT THE MVL AND MVR TABLES:
do IVL=SGS%MVSta,SGS%MVEnd
  MVLL = IVL-SGS%MVSta+1
  MVRR = 0
  if (CIS%IVR(IVL,1) /= 0) MVRR = CIS%IVR(IVL,1)-SGS%MVSta+1
  EXS%MVR(MVLL,1) = MVRR
  MVRR = 0
  if (CIS%IVR(IVL,2) /= 0) MVRR = CIS%IVR(IVL,2)-SGS%MVSta+1
  EXS%MVR(MVLL,2) = MVRR
  EXS%MVL(MVLL,1) = 0
  EXS%MVL(MVLL,2) = 0
end do
do MV=1,CIS%nMidV
  if (EXS%MVR(MV,1) /= 0) EXS%MVL(EXS%MVR(MV,1),1) = MV
  if (EXS%MVR(MV,2) /= 0) EXS%MVL(EXS%MVR(MV,2),2) = MV
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' MIDVERT PAIR TABLES MVL,MVR IN MKSEG:'
write(u6,*) ' MVL TABLE:'
write(u6,1234) (MV,EXS%MVL(MV,1),EXS%MVL(MV,2),MV=1,CIS%nMidV)
write(u6,*) ' MVR TABLE:'
write(u6,1234) (MV,EXS%MVR(MV,1),EXS%MVR(MV,2),MV=1,CIS%nMidV)
write(u6,*)
write(u6,*) ' VERTEX PAIR TABLE IVR IN MKSEG:'
write(u6,1234) (IVL,CIS%IVR(IVL,1),CIS%IVR(IVL,2),IVL=1,SGS%nVert)
#endif

! INITIALIZE SEGMENT TABLES, AND MARK VERTICES AS UNUSABLE:
do IVLT=1,SGS%nVert
  do ISGT=1,26
    CIS%ISGM(IVLT,ISGT) = 0
    CIS%VSGM(IVLT,ISGT) = Zero
  end do
end do
do IVLT=1,SGS%nVert
  do ISGT=1,26
    ITT = ITVPT(ISGT)
    IVRT = IVLT
    if ((ITT == 1) .or. (ITT == 2)) IVRT = CIS%IVR(IVLT,ITT)
    if (IVRT == 0) cycle
    IVLB = SGS%Down(IVLT,IC1(ISGT))
    if (IVLB == 0) cycle
    IVRB = SGS%Down(IVRT,IC2(ISGT))
    if (IVRB == 0) cycle
    ! SEGMENT IS NOW ACCEPTED AS POSSIBLE.

    CIS%ISGM(IVLT,ISGT) = IVLB
    IB = SGS%DRT(IVLT,IBTAB)
    select case (ISVC(ISGT))
      case (1)
        V = One
      case (2)
        V = -One
      case (3)
        V = One/real(1+IB,kind=wp)
      case (4)
        V = -One/real(1+IB,kind=wp)
      case (5)
        V = sqrt(real(IB,kind=wp)/real(1+IB,kind=wp))
      case (6)
        V = sqrt(real(2+IB,kind=wp)/real(1+IB,kind=wp))
      case (7)
        V = sqrt(real(IB*(2+IB),kind=wp))/real(1+IB,kind=wp)
      case default
        V = Zero ! Dummy assignment
        call Abend()
    end select
    CIS%VSGM(IVLT,ISGT) = V
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' SEGMENT TABLE IN MKSEG.'
write(u6,*) ' VLT SGT ICL ICR VLB       SEGMENT TYPE         FORMULA'
do IV=1,SGS%nVert
  do ISGT=1,26
    ID = CIS%ISGM(IV,ISGT)
    if (ID == 0) cycle
    ICL = IC1(ISGT)
    ICR = IC2(ISGT)
    if (ISGT <= 4) TEXT = '  WALK SECTION.'
    if ((ISGT >= 5) .and. (ISGT <= 8)) TEXT = ' TOP SEGMENT.'
    if ((ISGT >= 9) .and. (ISGT <= 18)) TEXT = ' MID-SEGMENT.'
    if ((ISGT >= 19) .and. (ISGT <= 22)) TEXT = ' BOTTOM SEGMENT.'
    if (ISGT > 22) TEXT = ' DOWN-WALK SECTION.'
    write(u6,2345) IV,ISGT,ICL,ICR,ID,TEXT,FRML(ISVC(ISGT))
  end do
end do
1234 format(3(3(1X,I4),4X))
2345 format(1X,5I4,5X,A20,5X,A20)
# endif

end subroutine MKSEG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997,1998, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE MINMAX_FOR_SYM_DIST(NIGRP,IGRP,MNVAL,MXVAL,NDIST)
*
* A combination of NIGRP groups are given (IGRP)
*. Find MIN and MAX for symmetry in each group
*
* Jeppe Olsen, September 1997
*              April 1998     From  MINMAX_SM_GP
*
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Include blocks
#include "mxpdim.fh"
#include "strbas.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "csm.fh"
#include "WrkSpc.fh"
*. Input
      DIMENSION IGRP(NIGRP)
*.Output
      DIMENSION MNVAL(NIGRP),MXVAL(NIGRP)
*. Local scratch
C-jwk-cleanup      DIMENSION LSMGP(MXPOBS,MXPNGAS)
*
      NTEST = 0000
      IF(NTEST.GE.100) WRITE(6,*) ' >> Entering MINMAX_... <<'
*
      DO JGRP = 1, NIGRP
        MNVAL(JGRP) = MINMAX_SM_GP(1,IGRP(JGRP))
        MXVAL(JGRP) = MINMAX_SM_GP(2,IGRP(JGRP))
      END DO

*. Number of strings per sym and group
C     DO JGRP = 1, NIGRP
C       CALL ICOPVE2(WORK(KNSTSGP(1)),(IGRP(JGRP)-1)*NSMST+1,
C    &               NSMST,LSMGP(1,JGRP))
C     END DO
C     IF(NTEST.GE.1000) THEN
C       WRITE(6,*) ' LSMGP '
C       CALL IWRTMA(LSMGP,NSMST,NIGRP,MXPOBS,NIGRP)
C     END IF
C. Max and min sym in each group
C     DO JGRP = 1, NIGRP
*
C       IMAX = 1
C       DO ISM=1, NSMST
C         IF(LSMGP(ISM,JGRP).GT.0) IMAX = ISM
C       END DO
C       MXVAL(JGRP) = IMAX
*
C       IMIN = NSMST
C       DO ISM = NSMST,1,-1
C        IF(LSMGP(ISM,JGRP).GT.0) IMIN = ISM
C       END DO
C       MNVAL(JGRP) = IMIN
C     END DO
*. Total number of symmetry distributions
      NDIST = 1
      DO JGRP = 1, NIGRP
        NDIST = NDIST*(MXVAL(JGRP)-MNVAL(JGRP)+1)
      END DO
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Group combination : '
        WRITE(6,'(5X,10I3)') (IGRP(JGRP),JGRP=1, NIGRP)
        WRITE(6,*)
        WRITE(6,*) ' Group Minsym Maxsym'
        WRITE(6,*) ' ==================='
        DO JGRP = 1, NIGRP
          WRITE(6,'(3I6)') IGRP(JGRP),MNVAL(JGRP),MXVAL(JGRP)
        END DO
        WRITE(6,*)
        WRITE(6,*) ' Total number of distributions', NDIST
      END IF
*
      IF(NTEST.GE.1000) WRITE(6,*) ' >> Leaving MINMAX_... <<'
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Roland Lindh                                     *
!***********************************************************************

subroutine Output1_Seward(lOPTO)
!***********************************************************************
!                                                                      *
!     Object: to write the output of seward                            *
!                                                                      *
!     Author: Roland Lindh, Dept Chem. Phys., Lund University, Sweden  *
!             September '06                                            *
!***********************************************************************

use Basis_Info, only: dbsc, Gaussian_Type, MolWgh, nCnttp, Nuclear_Model, Point_Charge
use Center_Info, only: dc
use Period, only: Cell_l, ispread
use GeoList, only: Centr, Mass
use MpmC, only: Coor_MPM
use EFP_Module, only: lEFP
#ifdef _EFP_
use EFP_Module, only: nEFP_Fragments
#endif
use External_centers, only: AMP_Center, DMS_Centers, nDMS, nEF, nOrdEF, nWel, nXF, OAM_Center, OMQ_Center, XF
use DKH_Info, only: BSS, DKroll, iCtrLD, iRELAE, iRELMP, LDKroll, nCtrLD, radiLD
use Sizes_of_Seward, only: S
use Gateway_Info, only: CutInt, DoFMM, EMFR, FNMC, GIAO, kVector, lAMFI, lMXTC, lRel, RPQMin, ThrInt, Vlct
use RICD_Info, only: iRI_Type, LDF, Do_RI, Cholesky, Do_acCD_Basis, Skip_High_AC, Cho_OneCenter, LocalDF, Thrshld_CD
use Symmetry_Info, only: nIrrep
use Gateway_global, only: GS_Mode, Onenly, Run_Mode, Prprt, Test
use Constants, only: Zero, One, Two, Ten, Pi, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: lOPTO
#include "Molcas.fh"
#include "rmat.fh"
#include "rctfld.fh"
#include "print.fh"
#include "localdf.fh"
integer(kind=iwp) :: i, iCnttp, iDKH_H_Order, iDKH_X_Order, iParam, iPrint, iRout, iTtl, LuWr, nTtl
real(kind=wp) :: temp
logical(kind=iwp) :: l_aCD_Thr, Found, lNoPair, lPam2, lECP, lPP
character(len=80) :: Title(10)

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 2
iPrint = nPrint(iRout)
LuWr = u6
!                                                                      *
!***********************************************************************
!                                                                      *
lNoPair = .false.
lPam2 = .false.
lECP = .false.
lPP = .false.
do i=1,nCnttp
  lNoPair = lNoPair .or. dbsc(i)%NoPair
  lPam2 = lPam2 .or. dbsc(i)%lPam2
  lECP = lECP .or. dbsc(i)%ECP
  lPP = lPP .or. (dbsc(i)%nPP /= 0)
  lECP = lECP .or. dbsc(i)%ECP
  lPP = lECP .or. dbsc(i)%ECP
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Start of output

if (Test) then
  write(LuWr,*)
  write(LuWr,'(15X,88A)') ('*',i=1,45)
  write(LuWr,'(15X,A)') '* TEST: SEWARD will only process the input! *'
  write(LuWr,'(15X,88A)') ('*',i=1,45)
else

  iDKH_X_Order = iRELAE/10000
  iParam = iRELAE-1000-iDKH_X_Order*10000
  iDKH_H_Order = iParam/10
  iParam = iParam-iDKH_H_Order*10

  write(LuWr,'(15X,A)') 'SEWARD will generate:'
  write(LuWr,'(15X,A,I2)') '   Multipole Moment integrals up to order ',S%nMltpl
  if (.not. Prprt) then
    write(LuWr,'(15X,A)') '   Kinetic Energy integrals'
    if (Nuclear_Model == Gaussian_Type) then
      write(LuWr,'(15X,A)') '   Nuclear Attraction integrals (finite nuclei - Gaussian type)'
    else if (Nuclear_Model == Point_Charge) then
      write(LuWr,'(15X,A)') '   Nuclear Attraction integrals (point charge)'
    else
      write(LuWr,'(15X,A)') '   Nuclear Attraction integrals (finite nuclei -  Modified Gaussian type)'
    end if
    if (lECP) then
      if (lNoPair) then
        select case (IRELMP)
          case (0)
            write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals modified with ECP and No-Pair contributions'
          case (1)
            write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals modified with ECP and No-Pair (DK1) contributions'
          case (2)
            write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals modified with ECP and No-Pair (DK2) contributions'
          case (3)
            write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals modified with ECP and No-Pair (DK3) contributions'
          case (11)
            write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals modified with ECP and RESC contributions'
          case (21)
            write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals modified with ECP and ZORA contributions'
          case (22)
            write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals modified with ECP and ZORA-FP contributions'
          case (23)
            write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals modified with ECP and IORA contributions'
        end select
      else
        write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals modified with ECP contributions'
      end if
    else
      write(LuWr,'(15X,A)') '   One-Electron Hamiltonian integrals'
    end if
    if (FNMC) then
      write(LuWr,'(15X,A)') '   Finite nuclear mass correction added'
    end if
    if (lPAM2) then
      write(LuWr,'(15X,A)') '   Include potentials for DMFT calculation'
    end if
    if (lRel) then
      write(LuWr,'(15X,A)') '   Mass-Velocity integrals'
      write(LuWr,'(15X,A)') '   Darwin One-Electron Contact Term integrals'
    end if
    if (Vlct) write(LuWr,'(15X,A)') '   Velocity integrals'
    if (DKroll) then
      if (iRELAE < 1000) then
        select case (IRELAE)
          case (0)
            write(LuWr,'(15X,A)') '   Relativistic Douglas-Kroll integrals'
          case (1)
            write(LuWr,'(15X,A)') '   Relativistic Douglas-Kroll (DK1) integrals'
          case (2)
            write(LuWr,'(15X,A)') '   Relativistic Douglas-Kroll (DK2) integrals'
          case (3)
            write(LuWr,'(15X,A)') '   Relativistic Douglas-Kroll (DK3) integrals'
          case (4)
            write(LuWr,'(15X,A)') '   full Relativistic Douglas-Kroll (DK3) integrals'
          case (11)
            write(LuWr,'(15X,A)') '   Relativistic RESC integrals'
          case (21)
            write(LuWr,'(15X,A)') '   Relativistic ZORA integrals'
          case (22)
            write(LuWr,'(15X,A)') '   Relativistic ZORA-FP integrals'
          case (23)
            write(LuWr,'(15X,A)') '   Relativistic IORA integrals'
          case (101)
            write(LuWr,'(15X,A)') '   Relativistic X2C integrals'
          case (102)
            write(LuWr,'(15X,A)') '   Relativistic BSS integrals'
          case default
            if (BSS) write(LuWr,'(15X,A)') '   Relativistic Barysz-Sadlej-Snijders integrals'
        end select
      else
        if (LDKroll) then
          write(LuWr,'(17X,A)') ' Relativistic Local-Douglas-Kroll-Hess integrals:'
          if (nCtrLD == 0) then
            if (radiLD == Zero) then
              write(LuWr,'(17X,A)') '   - Atomic approximation'
            else
              write(LuWr,'(17X,A)') '   - Full local approximation'
            end if
          else
            write(LuWr,'(17X,A)') '   - Partial local approximation:'
            write(LuWr,'(17X,A,10(A4))') '     - Centers: ',(dc(iCtrLD(i))%LblCnt,i=1,nCtrLD)
            write(LuWr,'(17X,A,F6.2,A)') '     - Cutoff radius: ',radiLD,' Bohr'
          end if
        else
          write(LuWr,'(17X,A)') ' Relativistic Douglas-Kroll-Hess integrals:'
        end if
        if (iParam == 1) then
          write(LuWr,'(17X,A)') '   - Parametrization         : OPT'
        else if (iParam == 2) then
          write(LuWr,'(17X,A)') '   - Parametrization         : EXP'
        else if (iParam == 3) then
          write(LuWr,'(17X,A)') '   - Parametrization         : SQR'
        else if (iParam == 4) then
          write(LuWr,'(17X,A)') '   - Parametrization         : MCW'
        else if (iParam == 5) then
          write(LuWr,'(17X,A)') '   - Parametrization         : CAY'
        end if
        write(LuWr,'(17X,A,I2)') '   - DKH order of Hamiltonian:',iDKH_H_order
        write(LuWr,'(17X,A,I2)') '   - DKH order of Properties :',iDKH_X_order
        write(LuWr,'(17X,A)') '        - multipole moment operators'
        write(LuWr,'(17X,A)') '        - electric potential operators'
        write(LuWr,'(17X,A)') '        - contact operators'
      end if
    end if
    if (lRF) then
      if (PCM) then
        write(LuWr,'(15X,A)') '   Reaction Field integrals (PCM)'
      else if (lLangevin) then
        write(LuWr,'(15X,A)') '   Reaction Field integrals (Langevin)'
      else
        write(LuWr,'(15X,A)') '   Reaction Field integrals (KirkWood-Onsager)'
      end if
    end if
    if (lPP) write(LuWr,'(15X,A)') '   Pseudo Potential integrals'
  end if
  if (allocated(XF)) write(LuWr,'(15X,A,I6,A)') '   External field from',nXF,' point(s) added to the one-electron Hamiltonian'
  if ((nEF > 0) .and. (nOrdEF >= 0)) write(LuWr,'(15X,A,I6,A)') '   Electric potential for',nEF,' points'
  if ((nEF > 0) .and. (nOrdEF >= 1)) write(LuWr,'(15X,A,I6,A)') '   Electric field integrals for',nEF,' points'
  if ((nEF > 0) .and. (nOrdEF >= 2)) write(LuWr,'(15X,A,I6,A)') '   Electric field gradient integrals for',nEF,' points'
  if ((nEF > 0) .and. (nOrdEF >= 2)) write(LuWr,'(15X,A,I6,A)') '   Contact term integrals for',nEF,' points'
  if (allocated(DMS_Centers)) write(LuWr,'(15X,A,I6,A)') '   Diamagnetic shielding integrals for',nDMS,' points'
  if (allocated(OAM_Center)) write(LuWr,'(15X,A,3(F7.4,1X),A)') '   Orbital angular momentum around (',(OAM_Center(i),i=1,3),')'
  if (allocated(OMQ_Center)) write(LuWr,'(15X,A,3(F7.4,1X),A)') '   Orbital magnetic quadrupole around (',(OMQ_Center(i),i=1,3),')'
  if (Vlct .and. (S%nMltpl >= 2)) write(LuWr,'(15X,A,3(F7.4,1X),A)') '   Velocity quadrupole around (',(Coor_MPM(i,3),i=1,3),')'
  if (allocated(AMP_Center)) write(LuWr,'(15X,A,3(F7.4,1X),A)') &
                             '   Products of Orbital angular momentum operators around (',(AMP_Center(i),i=1,3),')'
  if (nWel /= 0) write(LuWr,'(15X,A,I4,A)') '   Spherical well for',nWel,' exponent(s) added to the one-electron Hamiltonian'
  if (lAMFI) write(LuWr,'(15X,A)') '   Atomic mean-field integrals'
  if (lMXTC) write(LuWr,'(15X,A)') '   Hyperfine Magnetic integrals(MAG) calculated from Gen1Int F90 library'
  if (DoFMM) then
    write(LuWr,'(15X,A)') '   Integral environment set up for FMM option'
    write(LuWr,'(15X,A,F10.5)') '    - RPQMin: ',RPQMin
  end if
  if (lEFP) then
#   ifdef _EFP_
    write(LuWr,'(15X,A)') '   Effective Fragment potentials added       '
    write(LuWr,'(15X,A,I4)') '    - # of fragments: ',nEFP_fragments
#   else
    write(LuWr,'(15X,A)') '   EFP input specified but code not enabled for the option'
    call Abend()
#   endif
  end if
  if (.not. Onenly) then
    if (Cholesky) then
      write(LuWr,'(15X,A)') '   Cholesky decomposed two-electron repulsion integrals'
      if (Cho_OneCenter) then
        write(LuWr,'(17X,A,G10.2)') '  - 1C-CD Threshold: ',Thrshld_CD
      else
        write(LuWr,'(17X,A,G10.2)') '  - CD Threshold: ',Thrshld_CD
      end if
    else if (Do_RI) then
      if (LocalDF) then
        if (LDF_Constraint == -1) then
          write(LuWr,'(15X,A)') '   Local Density Fitting coefficients'
        else
          write(LuWr,'(15X,A)') '   Constrained Local Density Fitting coefficients'
          if (LDF_Constraint == 0) then
            write(LuWr,'(17X,A)') '  - constraint type: charge'
          else
            call WarningMessage(2,'Unknown constraint!')
            write(LuWr,'(A,I10)') 'LDF_Constraint=',LDF_Constraint
            call LDF_Quit(-1)
          end if
        end if
        if (LDF2) then
          write(LuWr,'(17X,A,G10.2)') '  - two-center auxiliary functions included (when needed); target accuracy: ',Thr_Accuracy
        else
          write(LuWr,'(17X,A)') '  - two-center auxiliary functions not included'
        end if
      else if (LDF) then
        write(LuWr,'(15X,A)') '   LDF decomposed two-electron repulsion integrals stored Cholesky style'
        write(LuWr,'(15X,A)') '    Concept demonstration only!'
      else
        write(LuWr,'(15X,A)') '   RI decomposed two-electron repulsion integrals stored Cholesky style'
      end if
      if (iRI_Type == 1) then
        write(LuWr,'(17X,A)') '  - RIJ auxiliary basis'
      else if (iRI_Type == 2) then
        write(LuWr,'(17X,A)') '  - RIJK auxiliary basis'
      else if (iRI_Type == 3) then
        write(LuWr,'(17X,A)') '  - RIC auxiliary basis'
      else if (iRI_Type == 5) then
        write(LuWr,'(17X,A)') '  - External RICD auxiliary basis'
      else
        if (Do_acCD_Basis) then
          write(LuWr,'(17X,A)') '  - acCD auxiliary basis'
        else
          write(LuWr,'(17X,A)') '  - aCD auxiliary basis'
        end if
        write(LuWr,'(17X,A,G10.2)') '  - CD Threshold: ',Thrshld_CD
        l_aCD_Thr = .false.
        do iCnttp=1,nCnttp
          l_aCD_Thr = l_aCD_Thr .or. (dbsc(iCnttp)%aCD_Thr /= One)
        end do
        if (l_aCD_Thr) then
          write(LuWr,'(17X,A)') '     Note that the threshold for individual basis sets might be modified!'
        end if
        if (Skip_High_AC) then
          write(LuWr,'(17X,A)') '  - Skip high angular momentum combinations'
        end if
      end if
    else
      write(LuWr,'(15X,A)') '   Two-Electron Repulsion integrals'
    end if
  end if
  if (RMat_On) then
    write(LuWr,*)
    write(LuWr,'(15X,A)') '   OBSERVE that some integrals are modified to enable variational R-matrix calculations!'
  end if
  if (GIAO) then
    write(LuWr,'(15X,A)') '   GIAO integrals differentiated with respect to B'
    write(LuWr,'(15X,A)') '     dS/dB                                        '
    write(LuWr,'(15X,A)') '     dT/dB                                        '
    write(LuWr,'(15X,A)') '     dV/dB                                        '
  end if

  ! Transition moment integrals for oscillator strengths of
  ! electronic transitions.

  if (EMFR) then
    write(LuWr,'(15X,A)') '   Transition moment integrals'
    write(LuWr,'(15X,A,3(F7.4,1X),A)') '   The wavevector k: (',(kVector(i),i=1,3),')'
    temp = sqrt(KVector(1)**2+KVector(2)**2+kVector(3)**2)
    temp = (Two*Pi)/temp
    write(LuWr,'(15X,A,(F10.4,1X),A)') '   Wavelength:        ',Temp,'a.u.'
    write(LuWr,'(15X,A,(F10.4,1X),A)') '                      ',Temp*Angstrom,'Angstrom'
    write(LuWr,'(15X,A,(F10.4,1X),A)') '                      ',Temp*Angstrom/Ten,'nm'
  end if

end if
!                                                                      *
!***********************************************************************
!                                                                      *
call Qpg_cArray('SewardXTitle',Found,nTtl)
if (Found) then
  nTtl = nTtl/80
  call Get_cArray('SewardXTitle',Title(1),nTtl*80)
  if (iPrint >= 6) then
    write(LuWr,*)
    write(LuWr,'(15X,88A)') ('*',i=1,88)
    write(LuWr,'(15X,88A)') '*',(' ',i=1,86),'*'
    do iTtl=1,nTtl
      write(LuWr,'(15X,A,A,A)') '*   ',Title(iTtl),'   *'
    end do
    write(LuWr,'(15X,88A)') '*',(' ',i=1,86),'*'
    write(LuWr,'(15X,88A)') ('*',i=1,88)
  else
    write(LuWr,*)
    write(LuWr,'(A)') ' Title:'
    do iTtl=1,nTtl
      write(LuWr,'(8X,A)') Title(iTtl)
    end do
    write(LuWr,*)
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
write(LuWr,*)
write(LuWr,'(19X,A,E9.2)') 'Integrals are discarded if absolute value <:',ThrInt
write(LuWr,'(19X,A,E9.2)') 'Integral cutoff threshold is set to       <:',CutInt
!                                                                      *
!***********************************************************************
!                                                                      *
if (Run_Mode == GS_Mode) call Print_Symmetry()
!                                                                      *
!***********************************************************************
!                                                                      *
if (nIrrep > 1) then
  if (MolWgh == 0) then
    write(LuWr,*)
    write(LuWr,'(19X,A)') ' Symmetry adaptation a la DCR.'
    write(LuWr,*)
  end if
  if (MolWgh == 1) then
    write(LuWr,*)
    write(LuWr,'(19X,A)') ' Symmetry adaptation a la MOLECULE.'
    write(LuWr,*)
  end if
  if (MolWgh == 2) then
    write(LuWr,*)
    write(LuWr,'(19X,A)') ' Unitary symmetry adaptation'
    write(LuWr,*)
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Print Cell unit information

if (Cell_l) then
  write(LuWr,'(6X,30(''-''))')
  write(LuWr,'(6X,A)') '* - the centers of the Unit Cell'
  write(LuWr,'(A)') ' '
  write(LuWr,'(A,3I3)') 'Spread of the unit cell:',(ispread(i),i=1,3)
  write(LuWr,'(A)') ' '
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out basis set information

if (Run_Mode == GS_Mode) then
  call Print_Basis(lOPTO)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out coordinates, bond, angles and torsional angles

  if (lOPTO) then
    call Print_Geometry(1)
  else
    call Print_Geometry(0)
  end if
  call Print_Isotopes()
!                                                                      *
!***********************************************************************
!                                                                      *
! Rigid Rotor analysis etc.

  call RigRot(Centr,Mass,S%kCentr)
!                                                                      *
!***********************************************************************
!                                                                      *
  call Print_Basis2()
!                                                                      *
!***********************************************************************
!                                                                      *
  call Print_OpInfo()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Output1_Seward

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Read_h0(nSize,h0,Restart)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSize
real(kind=wp), intent(out) :: h0(nSize)
logical(kind=iwp), intent(in) :: Restart
character(len=8) :: Label
integer(kind=iwp) :: iComp, iOpt0, iOpt1, iRc, iSyLbl, nInts(1)

!                                                                      *
!***********************************************************************
!                                                                      *
iOpt0 = 0
iOpt1 = 1

iComp = 1
iSyLbl = 1
Label = 'OneHam  '
iRc = -1
if (Restart) then
  call Get_dArray('LoProp H0',h0,nSize)
else
  call iRdOne(iRc,iOpt1,Label,iComp,nInts,iSyLbl)
  if (iRc /= 0) then
    write(u6,*) 'Read_h0: Error reading ONEINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if
  if (nInts(1)+4 /= nSize) then
    write(u6,*) 'Local_Polar: nInts+4.ne.nSize',nInts(1)+4,nSize
    call Abend()
  end if
  iRc = -1
  call RdOne(iRc,iOpt0,Label,iComp,h0,iSyLbl)
  call Put_dArray('LoProp H0',h0,nSize)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Read_h0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine defv(wrk,wrksize,deftyp,v,ssv,r,ssr,rc)
! this routine defines v mediate as:
! V_i(abc) = <ab||ic> from integrals, stored in R_i(abc)
! R _i(a,bc)bbb is a matrix, where integrals <ab|ic> are stored
! for b>=c
!
! deftyp - type of definition (see table) (I)
! v      - V (I/O)
! ssv    - overall spin of V (O)
! r      - R (I)
! ssr    - overall spin of R (I)
! rc     - return (error) code (O)
!
! Table of definitions
!
! deftyp         Operation                 Implement.
! 1      V(ab,c)aaa  = R(abc)-R(bac)         Yes
! 2      V(ab,c)bbb  = R(abc)-R(bac)         Yes
! 3      V(a,b,c)abb = R(abc)                Yes
! 4      V(a,b,c)aba = -R(bac)               Yes

use CCT3_global, only: dimm, Map_Type, nvb
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, deftyp, ssr
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(inout) :: v
integer(kind=iwp), intent(out) :: ssv
type(Map_Type), intent(in) :: r
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp) :: ir1, ir2, iv, nhelp1, nhelp10, nhelp2, nhelp3, nhelp4, nhelp5, nhelp6, nhelp7, nhelp8, nhelp9, posr1, posr2, &
                     post, posv, syma, symb, symc

!0.* def v%d,v%i
if (deftyp == 1) then
  ! case V(ab,c)aaa
  call cct3_grc0(3,1,3,3,3,0,ssr,v,post)
else if (deftyp == 2) then
  ! case V(ab,c)bbb
  call cct3_grc0(3,1,4,4,4,0,ssr,v,post)
else if (deftyp == 3) then
  ! case V(a,b,c)abb
  call cct3_grc0(3,0,3,4,4,0,ssr,v,post)
else if (deftyp == 4) then
  ! case V(a,b,c)aba
  call cct3_grc0(3,0,3,4,3,0,ssr,v,post)
else
  ! RC=1 , deftyp out of range (1-4) (Stup)
  rc = 1
  return
end if

!0.* some tests

!0.* define spin
ssv = ssr

if ((deftyp == 1) .or. (deftyp == 2)) then

  !12 case V(ab,c)aaa,bbb

  do iv=1,v%d(0,5)

    !12.* def symmetries
    syma = v%d(iv,3)
    symb = v%d(iv,4)
    symc = v%d(iv,5)

    if (syma == symb) then
      !12.1 syma=symb

      if (symb == symc) then
        !12.1.1 case syma=symb=symc

        !12.1.1.* def positions of V, R1
        posv = v%d(iv,1)
        ir1 = r%i(syma,symb,1)
        posr1 = r%d(ir1,1)

        !12.1.1.* def dimensions
        nhelp1 = nvb(syma)
        nhelp2 = nhelp1*(nhelp1+1)/2
        nhelp4 = dimm(v%d(0,1),syma)
        nhelp3 = nhelp4*(nhelp4-1)/2
        nhelp5 = nvb(syma)-nhelp4

        !12.1.1.* realize definition of V
        call defvhlp1(wrk(posr1),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5)

      else
        !12.1.2 case syma=symb/=symc

        !12.1.2.* def positions of V, R1
        posv = v%d(iv,1)
        if (syma >= symc) then
          ir1 = r%i(syma,symb,1)
        else
          ir1 = r%i(syma,symc,1)
        end if
        posr1 = r%d(ir1,1)

        !12.1.2.* def dimensions
        nhelp1 = nvb(syma)
        nhelp2 = nvb(symc)
        nhelp4 = dimm(v%d(0,1),syma)
        nhelp3 = nhelp4*(nhelp4-1)/2
        nhelp5 = dimm(v%d(0,3),symc)
        nhelp6 = nvb(syma)-nhelp4
        nhelp7 = nvb(symc)-nhelp5

        !12.1.2.* realize definition of V
        if (syma >= symc) then
          call defvhlp21(wrk(posr1),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)
        else
          call defvhlp22(wrk(posr1),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)
        end if

      end if

    else
      !12.2 syma > symb

      if (syma == symc) then
        !12.2.1 case syma>symb , syma=symc

        !12.2.1.* def positions of V, R1, R2
        posv = v%d(iv,1)
        ! R1 is permuted, since (a=c)>b
        ir1 = r%i(syma,symc,1)
        posr1 = r%d(ir1,1)
        ir2 = r%i(symb,syma,1)
        posr2 = r%d(ir2,1)

        !12.2.1.* def dimensions
        nhelp1 = nvb(syma)
        nhelp2 = nvb(symb)
        nhelp3 = nvb(symc)
        nhelp4 = nhelp1*(nhelp1+1)/2
        nhelp5 = dimm(v%d(0,1),syma)
        nhelp6 = dimm(v%d(0,2),symb)
        nhelp7 = dimm(v%d(0,3),symc)
        nhelp8 = nvb(syma)-nhelp5
        nhelp9 = nvb(symb)-nhelp6
        nhelp10 = nvb(symc)-nhelp7

        !12.2.1.* realize definition of V
        call defvhlp3(wrk(posr1),wrk(posr2),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8,nhelp9,nhelp10)

      else if (symb == symc) then
        !12.2.2 case syma>symb , symb=symc

        !12.2.2.* def positions of V, R1, R2
        posv = v%d(iv,1)
        ir1 = r%i(syma,symb,1)
        posr1 = r%d(ir1,1)
        ir2 = r%i(symb,syma,1)
        posr2 = r%d(ir2,1)

        !12.2.2.* def dimensions
        nhelp1 = nvb(syma)
        nhelp3 = nvb(symb)
        nhelp4 = nvb(symc)
        nhelp2 = nhelp3*(nhelp3+1)/2
        nhelp5 = dimm(v%d(0,1),syma)
        nhelp6 = dimm(v%d(0,2),symb)
        nhelp7 = dimm(v%d(0,3),symc)
        nhelp8 = nvb(syma)-nhelp5
        nhelp9 = nvb(symb)-nhelp6
        nhelp10 = nvb(symc)-nhelp7

        !12.2.2.* realize definition of V
        call defvhlp4(wrk(posr1),wrk(posr2),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8,nhelp9,nhelp10)

      else
        !12.2.3 case syma>symb , symc/=syma,symb

        !12.2.3.* def positions of V, R1, R2
        posv = v%d(iv,1)

        if (symb >= symc) then
          ir1 = r%i(syma,symb,1)
        else
          ir1 = r%i(syma,symc,1)
        end if
        posr1 = r%d(ir1,1)

        if (syma >= symc) then
          ir2 = r%i(symb,syma,1)
        else
          ir2 = r%i(symb,symc,1)
        end if
        posr2 = r%d(ir2,1)

        !12.2.3.* def dimensions
        nhelp1 = nvb(syma)
        nhelp2 = nvb(symb)
        nhelp3 = nvb(symc)
        nhelp4 = dimm(v%d(0,1),syma)
        nhelp5 = dimm(v%d(0,2),symb)
        nhelp6 = dimm(v%d(0,3),symc)
        nhelp7 = nvb(syma)-nhelp4
        nhelp8 = nvb(symb)-nhelp5
        nhelp9 = nvb(symc)-nhelp6

        !12.2.3.* realize definition of V
        if ((syma > symc) .and. (symb > symc)) then
          call defvhlp51(wrk(posr1),wrk(posr2),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8,nhelp9)
        else if ((syma > symc) .and. (symb < symc)) then
          call defvhlp52(wrk(posr1),wrk(posr2),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8,nhelp9)
        else if ((syma < symc) .and. (symb > symc)) then
          call defvhlp53(wrk(posr1),wrk(posr2),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8,nhelp9)
        else if ((syma < symc) .and. (symb < symc)) then
          call defvhlp54(wrk(posr1),wrk(posr2),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8,nhelp9)
        end if

      end if

    end if

  end do

else if (deftyp == 3) then

  !3 case V(a,b,c)abb

  do iv=1,v%d(0,5)

    !3.* def symmetries
    syma = v%d(iv,3)
    symb = v%d(iv,4)
    symc = v%d(iv,5)

    if (symb == symc) then
      !3.1 symb=symc

      !3.1.* def positions of V, R1
      posv = v%d(iv,1)
      ir1 = r%i(syma,symb,1)
      posr1 = r%d(ir1,1)

      !3.1.* def dimensions
      nhelp1 = nvb(syma)
      nhelp2 = nvb(symb)
      nhelp3 = nhelp2*(nhelp2+1)/2
      nhelp4 = dimm(v%d(0,1),syma)
      nhelp5 = dimm(v%d(0,2),symb)
      nhelp6 = dimm(v%d(0,3),symc)
      nhelp7 = nvb(syma)-nhelp4

      !3.1.* realize definition of V
      call defvhlp7(wrk(posr1),wrk(posv),nhelp1,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)

    else
      ! case symb/=symc

      !3.1.* def positions of V, R1
      posv = v%d(iv,1)
      if (symb >= symc) then
        ir1 = r%i(syma,symb,1)
      else
        ir1 = r%i(syma,symc,1)
      end if
      posr1 = r%d(ir1,1)

      !3.1.* def dimensions
      nhelp1 = nvb(syma)
      nhelp2 = nvb(symb)
      nhelp3 = nvb(symc)
      nhelp4 = dimm(v%d(0,1),syma)
      nhelp5 = dimm(v%d(0,2),symb)
      nhelp6 = dimm(v%d(0,3),symc)
      nhelp7 = nvb(syma)-nhelp4

      !3.1.* realize definition of V
      if (symb > symc) then
        call defvhlp61(wrk(posr1),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)
      else
        call defvhlp62(wrk(posr1),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)
      end if

    end if

  end do

else if (deftyp == 4) then

  !4 case V(a,b,c)aba

  do iv=1,v%d(0,5)

    !4.* def symmetries
    syma = v%d(iv,3)
    symb = v%d(iv,4)
    symc = v%d(iv,5)

    if (syma == symc) then
      !4.1 syma=symc

      !4.1.* def positions of V, R2
      posv = v%d(iv,1)
      ir2 = r%i(symb,syma,1)
      posr2 = r%d(ir2,1)

      !4.1.* def dimensions
      nhelp1 = nvb(symb)
      nhelp2 = nvb(syma)
      nhelp3 = nhelp2*(nhelp2+1)/2
      nhelp4 = dimm(v%d(0,1),syma)
      nhelp5 = dimm(v%d(0,2),symb)
      nhelp6 = dimm(v%d(0,3),symc)
      nhelp7 = nvb(syma)-nhelp4
      nhelp8 = nvb(symc)-nhelp6

      !4.1.* realize definition of V
      call defvhlp9(wrk(posr2),wrk(posv),nhelp1,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8)

    else
      ! case symb/=symc

      !4.1.* def positions of V, R2
      posv = v%d(iv,1)
      if (syma >= symc) then
        ir2 = r%i(symb,syma,1)
      else
        ir2 = r%i(symb,symc,1)
      end if
      posr2 = r%d(ir2,1)

      !4.1.* def dimensions
      nhelp1 = nvb(symb)
      nhelp2 = nvb(syma)
      nhelp3 = nvb(symc)
      nhelp4 = dimm(v%d(0,1),syma)
      nhelp5 = dimm(v%d(0,2),symb)
      nhelp6 = dimm(v%d(0,3),symc)
      nhelp7 = nvb(syma)-nhelp4
      nhelp8 = nvb(symc)-nhelp6

      !4.1.* realize definition of V
      if (syma > symc) then
        call defvhlp81(wrk(posr2),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8)
      else
        call defvhlp82(wrk(posr2),wrk(posv),nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8)
      end if

    end if

  end do

else
  ! not implemented deftyp

end if

return

end subroutine defv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine getw3 (wrk,wrksize,
     & lunw3xxxx,nxxxx)
c
c     This routine reconstruct W3(m,e,a,j)xxxx from lunw3xxxx file
c     to V1(m,e,a,j) and define corresponding mapdv1 and mapiv1
c     This routine also close lunw3xxxx file
c
c     lunw3xxxx - lun of opened w3xxxx file
c     nxxxx     - xxxx identifier
c     1 - aaaa
c     2 - bbbb
c     3 - aabb
c     4 - abba
c     5 - baab
c     6 - bbaa
c
c     the structure of lunw3xxxx is:
c
c     do syma=1,nsym
c     map of H _a(m,e,j)bbbb (W3(m,e,a,j))
c     skip cycle over a if length of all files is zero
c     do a=1,nvx(syma) [ x is a or b ]
c     if (h1length.gt.0) then
c     write H(m,e,j)
c     end if
c     end do
c     end do
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer lunw3xxxx,nxxxx
c
c     help variables
c
       integer rc,syma,a,h1length,posst,aup,aalfayes,iiv1,v1length
c
c0    def aalfayes
c
       if ((nxxxx.eq.1).or.(nxxxx.eq.5).or.(nxxxx.eq.6)) then
       aalfayes=1
       else
       aalfayes=0
       end if
c
c1.1  def maps of V1(m,e,a,j)
c
       if (nxxxx.eq.1) then
       call grc0 (4,0,1,3,3,1,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.2) then
       call grc0 (4,0,2,4,4,2,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.3) then
       call grc0 (4,0,1,3,4,2,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.4) then
       call grc0 (4,0,1,4,4,1,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.5) then
       call grc0 (4,0,2,3,3,2,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.6) then
       call grc0 (4,0,2,4,3,1,1,possv10,posst,mapdv1,mapiv1)
       end if
c
c1.2  vanish V1
       iiv1=mapdv1(0,5)
       v1length=mapdv1(iiv1,1)+mapdv1(iiv1,2)-possv10
       call mv0zero (v1length,v1length,wrk(possv10))
c
c2    rewind tape lunw3xxxx
       call filemanager (2,lunw3xxxx,rc)
c
c3    loop over symA
c
       do 3000 syma=1,nsym
c
c3.1  get map of H _a(m,e,j) to mapd,i H1
       call getmap (lunw3xxxx,possh10,h1length,mapdh1,mapih1,rc)
c
c3.2  skip cycle over a if length of H1 is 0
       if (h1length.eq.0) goto 3000
c
c3.3  loop over all a in this symmetry
c
       if (aalfayes.eq.1) then
       aup=nva(syma)
       else
       aup=nvb(syma)
       end if
c
       do 2500 a=1,aup
c
       if (h1length.gt.0) then
c
c3.3.1read H1 if any
       call rea (lunw3xxxx,h1length,wrk(possh10))
c
c3.3.2insert H1 into V1 for given a and syma
       call add (wrk,wrksize,
     & 3,4,1,3,a,0,syma,1,1.0d0,mapdh1,syma,mapdv1,mapiv1,1,
     &           rc)
c
       end if
c
 2500   continue
c
 3000   continue
c
c4    close lunw3xxxx file
       call filemanager (3,lunw3xxxx,rc)
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Store_Energies(nEnergies,Energies,iEnergy)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nEnergies, iEnergy
real(kind=wp), intent(in) :: Energies(nEnergies)

call Put_iScalar('Number of roots',nEnergies)
call Put_dArray('Last energies',Energies,nEnergies)
call Put_dScalar('Last energy',Energies(iEnergy))

return

end subroutine Store_Energies

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine XDR_dmatinv(a,n)
C
C Invert a real square matrix
C
      implicit none
#include "WrkSpc.fh"
      Real*8 a(*)
      integer n,ipiv,iTMp,info1,info2
#ifdef _MOLCAS_MPP_
      logical :: isCloneQ
      call check_parallel_data(a,n*n,isCloneQ,"C")
#endif
      call getmem('ipiv','ALLOC','INTE',ipiv,n+4)
      call getmem('tmp ','ALLOC','REAL',iTmp,n+4)
      call dgetrf_(n,n,a(1),n,iWork(ipiv),info1)
      call dgetri_(n  ,a(1),n,iWork(ipiv),Work(iTmp),n,info2)
      call getmem('ipiv','FREE','INTE',ipiv,n+4)
      call getmem('tmp ','FREE','REAL',iTmp,n+4)
#ifdef _MOLCAS_MPP_
      if(isCloneQ)then
         call check_parallel_data(a,n*n,isCloneQ,"S")
      end if
#endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!----------------------------------------------------------------------*
!                                                                      *
!     Define the vocabulary (ComTab) :                                 *
!                                                                      *
!     Command        1st Subcom.  2nd Subcom.  Parameters              *
!     TITL              --           --        Text (10*72 Characters) *
!     FFPT             DIPO         COMP       X=xx,Y=yy,Z=zz          *
!                      EFLD         COMP       X=xx,Y=yy,Z=zz          *
!                                   ORIG       N=i,X=xx,Y=yy,Z=zz      *
!                      QUDR         COMP       XX=xx,YY=yy,ZZ=zz       *
!                                              XY=xy,XZ=xz,YZ=yz,RR=rr *
!                                   ORIG       N=i,X=xx,Y=yy,Z=zz      *
!                      OCTU         COMP       XXX=xxx,XYY=xyy,XZZ=xzz *
!                                              XXY=xxy,YYY=yyy,YZZ=yzz *
!                                              XXZ=xxz,YYZ=yyz,ZZZ=zzz *
!                                              XYZ=xyz                 *
!                                   ORIG       N=i,X=xx,Y=yy,Z=zz      *
!                      EFGR         COMP       XX=xx,YY=yy,ZZ=zz       *
!                                              XY=xy,XZ=xz,YZ=yz,RR=rr *
!                                   ORIG       N=i,X=xx,Y=yy,Z=zz      *
!                      RELA          --        W=ww                    *
!     END               --           --        --                      *
!                                                                      *
!     Define also the command read control tables:                     *
!     ComCtl : Count the number of entries for each hierarchy          *
!              level of the vocabulary                                 *
!     ComStk : flag for each command which has been entered            *
!     ComVal : parameter values read in                                *
!                                                                      *
!----------------------------------------------------------------------*

module FFPT_global

use Definitions, only: wp, iwp

implicit none
private

#include "Molcas.fh"

integer(kind=iwp), parameter :: nCom = 5, MxSub1 = 6, MxSub2 = 2, MxParm = 10
character(len=4) :: ComTab(nCom,0:MxSub1,0:MxSub2,0:MxParm)
integer(kind=iwp) :: ComCtl(nCom,0:MxSub1,0:MxSub2)
logical(kind=iwp) :: ComStk(nCom,0:MxSub1,0:MxSub2,0:MxParm)
real(kind=wp) :: ComVal(nCom,0:MxSub1,0:MxSub2,0:MxParm)

!----------------------------------------------------------------------*
!                                                                      *
!     Allocate space to store general perturbation labels, components  *
!     and weights                                                      *
!     gLblN : general label name                                       *
!     gLblW : general label weight                                     *
!     gLblC : general label component                                  *
!                                                                      *
!----------------------------------------------------------------------*

integer(kind=iwp), parameter :: mxLbl = 20
character(len=8) :: gLblN(mxLbl)
integer(kind=iwp) :: gLblC(mxLbl), mLbl
real(kind=wp) :: gLblW(mxLbl)

!----------------------------------------------------------------------*
!                                                                      *
!     Define the length of the recognition area for:                   *
!     Commands, 1st level - and 2nd level subcommands                  *
!                                                                      *
!----------------------------------------------------------------------*

integer(kind=iwp), parameter :: lCom = 4, lSub = 4, lParm = 3

!----------------------------------------------------------------------*
!                                                                      *
!     Allocate space to store the title                                *
!                                                                      *
!----------------------------------------------------------------------*

integer(kind=iwp), parameter :: MxTitL = 10
character(len=72) :: Title(MxTitL)
integer(kind=iwp) :: mTit

!----------------------------------------------------------------------*
!                                                                      *
!     Allocate space to store the header of the one-electron           *
!     integral file.                                                   *
!                                                                      *
!----------------------------------------------------------------------*

integer(kind=iwp) :: nSym, nBas(MxSym), nAtoms
real(kind=wp), allocatable :: Coor(:,:)
character :: Header(144)

!----------------------------------------------------------------------*
!     An input vector for the SELEctive keyword.                       *
!----------------------------------------------------------------------*

real(kind=wp) :: TranCoo(3)
integer(kind=iwp) :: nSets
logical(kind=iwp) :: LCumulate
integer(kind=iwp), allocatable :: iSelection(:,:)
logical(kind=iwp), allocatable :: Atoms(:), Bonds(:,:)

public :: Atoms, Bonds, ComCtl, ComStk, ComTab, ComVal, Coor, Header, LCumulate, MxLbl, MxTitL, Title, TranCoo, gLblC, gLblN, &
          gLblW, iSelection, mLbl, mTit, nAtoms, nBas, nCom, nSets, nSym, Cleanup

contains

subroutine Cleanup()
  use stdalloc, only: mma_deallocate
  if (allocated(Coor)) call mma_deallocate(Coor)
  if (allocated(iSelection)) call mma_deallocate(iSelection)
  if (allocated(Atoms)) call mma_deallocate(Atoms)
  if (allocated(Bonds)) call mma_deallocate(Bonds)
end subroutine Cleanup

end module FFPT_global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CSDTVC(CSFVEC,DETVEC,IWAY,DTOCMT,ICTSDT,IREFSM,ICOPY)
! PURPOSE: TRANSFORM FROM DETERMINANT TO CSF BASIS AND VICE VERSA
!          IWAY = 1 : CSF TO DETERMINANT TRANSFORMATION
!          IWAY = 2 : DETERMINANT TO CSF TRANSFORMATION

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "ciinfo.fh"
#include "spinfo.fh"
integer(kind=iwp), intent(in) :: IWAY, ICTSDT(*), IREFSM, ICOPY
real(kind=wp), intent(inout) :: CSFVEC(NDTASM(IREFSM)), DETVEC(NDTASM(IREFSM))
real(kind=wp), intent(in) :: DTOCMT(*)
integer(kind=iwp) :: ICNF, ICSF, IDET, IOFFCD, IOFFCS, IOFFDT, ITYP, NCSF, NTEST

! To avoid compiler complaints

IOFFCS = 0
IOFFDT = 0
IOFFCD = 0

NTEST = 00

NDET = NDTASM(IREFSM)
NCSF = NCSASM(IREFSM)
if (NTEST >= 100) then
  write(u6,*) '======================================='
  write(u6,*) '         CSDTVC INFORMATIONS'
  if (IWAY == 1) then
    write(u6,*) '   CSF TO DETERMINANT TRANSFORMATION'
  else
    write(u6,*) '   DETERMINANT TO CSF TRANSFORMATION'
  end if
  write(u6,*) '======================================='
  write(u6,*)
  write(u6,*) '  NDET                  = ',NDET
  write(u6,*) '  NCSF                  = ',NCSF
  write(u6,*)
end if

! CSF ==> DET TRANSFORMATION

if (IWAY == 1) then
  if (NTEST >= 100) then
    write(u6,*) '   INPUT CSF VECTOR:'
    call WRTMAT(CSFVEC,1,NCSF,1,NCSF)
    write(u6,*)
  end if
  DETVEC(:) = Zero
  do ITYP=1,NTYP
    IDET = NDTFTP(ITYP)
    ICSF = NCSFTP(ITYP)
    ICNF = NCNFTP(ITYP,IREFSM)
    if (ITYP == 1) then
      IOFFCS = 1
      IOFFDT = 1
      IOFFCD = 1
    else
      IOFFCS = IOFFCS+NCNFTP(ITYP-1,IREFSM)*NCSFTP(ITYP-1)
      IOFFDT = IOFFDT+NCNFTP(ITYP-1,IREFSM)*NDTFTP(ITYP-1)
      IOFFCD = IOFFCD+NDTFTP(ITYP-1)*NCSFTP(ITYP-1)
    end if
    if ((IDET*ICNF*ICSF) > 0) call MATML4(DETVEC(IOFFDT),DTOCMT(IOFFCD),CSFVEC(IOFFCS),IDET,ICNF,IDET,ICSF,ICSF,ICNF,0)
  end do
  call Sort_Cdet(nDet,ICTSDT,DetVec)
  if (ICOPY /= 0) CSFVEC(:) = DETVEC(:)
  if (NTEST >= 100) then
    write(u6,*) '   OUTPUT DET VECTOR:'
    call WRTMAT(DETVEC,1,NDET,1,NDET)
    write(u6,*)
  end if

else

  ! DET ==> CSF TRANSFORMATION

  if (NTEST >= 100) then
    write(u6,*) '   INPUT DET VECTOR:'
    call WRTMAT(DETVEC,1,NDET,1,NDET)
    write(u6,*)
  end if
  call GATVCS(CSFVEC,DETVEC,ICTSDT,NDET)
  if (NTEST >= 100) then
    write(u6,*) ' ICTSDT reorder array'
    call IWRTMA(ICTSDT,1,100,1,100)
  end if
  DETVEC(:) = CSFVEC(:)
  do ITYP=1,NTYP
    IDET = NDTFTP(ITYP)
    ICSF = NCSFTP(ITYP)
    ICNF = NCNFTP(ITYP,IREFSM)
    if (ITYP == 1) then
      IOFFCS = 1
      IOFFDT = 1
      IOFFCD = 1
    else
      IOFFCS = IOFFCS+NCNFTP(ITYP-1,IREFSM)*NCSFTP(ITYP-1)
      IOFFDT = IOFFDT+NCNFTP(ITYP-1,IREFSM)*NDTFTP(ITYP-1)
      IOFFCD = IOFFCD+NDTFTP(ITYP-1)*NCSFTP(ITYP-1)
    end if
    if ((IDET*ICNF*ICSF) > 0) call MATML4(CSFVEC(IOFFCS),DTOCMT(IOFFCD),DETVEC(IOFFDT),ICSF,ICNF,IDET,ICSF,IDET,ICNF,1)
  end do
  if (ICOPY /= 0) DETVEC(1:NCSF) = CSFVEC(1:NCSF)
  if (NTEST >= 100) then
    write(u6,*) '   OUTPUT CSF VECTOR:'
    call WRTMAT(CSFVEC,1,NCSF,1,NCSF)
    write(u6,*)
  end if
end if

return

end subroutine CSDTVC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2016,2017, Roland Lindh                                *
!***********************************************************************

subroutine R1IntB()
!***********************************************************************
!                                                                      *
!     purpose: Read basis set informations and one-electron integrals  *
!              were not needed so far.                                 *
!                                                                      *
!***********************************************************************

use InfSCF, only: Darwin, KntE, lRel, MssVlc, nBT
use OneDat, only: sNoNuc, sNoOri
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iComp, iOpt, iRC, iSyLbl
character(len=8) :: Label

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Allocate memory for kinetic energy, mass velocity and Darwin integrals

call mma_allocate(KntE,nBT+4,Label='KntE')
call mma_allocate(MssVlc,nBT+4,Label='MssVlc')
call mma_allocate(Darwin,nBT+4,Label='Darwin')

! Read kinetic energy integrals
iRc = -1
iOpt = ibset(ibset(0,sNoOri),sNoNuc)
iComp = 1
iSyLbl = 1
Label = 'Kinetic '
call RdOne(iRc,iOpt,Label,iComp,KntE,iSyLbl)
if (iRc /= 0) then
  write(u6,*) 'R1Intb: Error readin ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if

! Read mass velocity integrals
lRel = .false.
iRc = -1
iOpt = ibset(ibset(0,sNoOri),sNoNuc)
iComp = 1
iSyLbl = 1
Label = 'MassVel '
call RdOne(iRc,iOpt,Label,iComp,MssVlc,iSyLbl)

if (iRc == 0) then
  ! Read Darwin integrals
  iRc = -1
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  iComp = 1
  iSyLbl = 1
  Label = 'Darwin  '
  call RdOne(iRc,iOpt,Label,iComp,Darwin,iSyLbl)
  if (iRc == 0) lRel = .true.
end if

if (.not. lRel) then
  call mma_deallocate(MssVlc)
  call mma_deallocate(Darwin)
  call mma_allocate(MssVlc,0,Label='MssVlc')
  call mma_allocate(Darwin,0,Label='Darwin')
end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*
return

end subroutine R1IntB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine dgeAdd(A,LDA,FORMA,B,LDB,FORMB,C,LDC,M,N)
C
C     MATRIX Addition FOR GENERAL MATRICES
C
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*1 FORMA,FORMB
      REAL*8 A(*), B(*), C(*)

      IF (FORMA.EQ.'N' .AND. FORMB.EQ.'N') THEN
         Do 10 iRow=0,m-1
         Do 11 iCol=0,n-1
            c(iRow+iCol*ldc+1)=a(iRow+iCol*lda+1)+b(iRow+iCol*ldb+1)
   11    Continue
   10    Continue
      ELSE IF (FORMA.EQ.'T' .AND. FORMB.EQ.'N') THEN
         Do 20 iRow=0,m-1
         Do 21 iCol=0,n-1
            c(iRow+iCol*ldc+1)=a(iCol+iRow*lda+1)+b(iRow+iCol*ldb+1)
   21    Continue
   20    Continue
      ELSE IF (FORMA.EQ.'N' .AND. FORMB.EQ.'T') THEN
         Do 30 iRow=0,m-1
         Do 31 iCol=0,n-1
            c(iRow+iCol*ldc+1)=a(iRow+iCol*lda+1)+b(iCol+iRow*ldb+1)
   31    Continue
   30    Continue
      ELSE IF (FORMA.EQ.'T' .AND. FORMB.EQ.'T') THEN
         Do 40 iRow=0,m-1
         Do 41 iCol=0,n-1
            c(iRow+iCol*ldc+1)=a(iCol+iRow*lda+1)+b(iCol+iRow*ldb+1)
   41    Continue
   40    Continue
      ELSE
         Write(6,*) 'Error when calling DGEADD, forma=',
     &     FormA,' formb=',FormB
         Call Abend()
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function ISYMST_MCLR(STRING,NEL)
! Master routine for symmetry of string

use Symmetry_Info, only: Mul
use MCLR_Data, only: ISMFTO
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ISYMST_MCLR
integer(kind=iwp), intent(in) :: NEL, STRING(NEL)
integer(kind=iwp) :: IEL

ISYMST_MCLR = 1
do IEL=1,NEL
  ISYMST_MCLR = Mul(ISYMST_MCLR,ISMFTO(STRING(IEL)))
end do

end function ISYMST_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
************************************************************************
      Subroutine Cnthlf_mck(Coeff1,nCntr1,nPrm1,
     &                      Coeff2,nCntr2,nPrm2,
     &                      nZeta,lZeta,nVec,First,IncVec,A1,A2,A3,
     &                  Indij)
************************************************************************
*                                                                      *
* Object: to do a half transformation. The loop over the two matrix-   *
*         matrix multiplications is segmented such that the end of the *
*         intermediate matrix will not push the start of the same out  *
*         from the cache.                                              *
*                                                                      *
* Author:     Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
c#include "print.fh"
      Real*8 Coeff1(nPrm1,nCntr1), Coeff2(nPrm2,nCntr2),
     &       A1(lZeta,nVec), A2(nPrm2,IncVec*nCntr1),
     &       A3(nVec,nCntr1,nCntr2)
      Integer Indij(nZeta)
      Logical First, Seg1, Seg2
*
*-----Check if the basis set is segmented
*
      Seg1=.False.
      Do iPrm1 = nPrm1, 1, -1
         Do iCntr1 = nCntr1, 1, -1
            If (Coeff1(iPrm1,iCntr1).eq.Zero) Then
               Seg1=.True.
               Go To 10
            End If
         End Do
      End Do
 10   Continue
*
      Seg2=.False.
      Do iPrm2 = nPrm2, 1, -1
         Do iCntr2 = nCntr2, 1, -1
            If (Coeff2(iPrm2,iCntr2).eq.Zero) Then
               Seg2=.True.
               Go To 20
            End If
         End Do
      End Do
 20   Continue
*
*-----Set output matrix to zero
*
      If (First) call dcopy_(nVec*nCntr1*nCntr2,[Zero],0,A3,1)
*
*-----Loop sectioning
*
      Do iiVec = 1, nVec, IncVec
         mVec = Min(IncVec,nVec-iiVec+1)
*--------Set intermediate matrix to zero
         call dcopy_(nPrm2*nCntr1*mVec,[Zero],0,A2,1)
*
         If (Seg1) Then
*
*-----First quarter transformation
*
      i = 0
*
      Do iPrm1 = 1, nPrm1
         Do iCntr1 = 1, nCntr1
*-----------Check for zero due to segmented basis
            If (Abs(Coeff1(iPrm1,iCntr1)).gt.Zero) Then
               Do iPrm2 = 1, nPrm2
                  iZeta = (iPrm2-1)*nPrm1 + iPrm1
                  jZeta = Indij(iZeta)
*-----------------Skip due to screening
                  If (jZeta.gt.0) Then
                     Do iVec = iiVec, iiVec+mVec-1
                        ijVec = mVec*(iCntr1-1) + (iVec-iiVec+1)
                        A2(iPrm2,ijVec) = A2(iPrm2,ijVec) +
     &                    Coeff1(iPrm1,iCntr1)*A1(jZeta,iVec)
                     End Do
                  End If
               End Do
            End If
         End Do
      End Do
*
         Else
*
*-----First quarter transformation
*
      i = 0
      Do iPrm1 = 1, nPrm1
         Do iCntr1 = 1, nCntr1
            Do iPrm2 = 1, nPrm2
               iZeta = (iPrm2-1)*nPrm1 + iPrm1
               jZeta = Indij(iZeta)
*--------------Skip due to screening
               If (jZeta.gt.0) Then
                  Do iVec = iiVec, iiVec+mVec-1
                     ijVec = mVec*(iCntr1-1) + (iVec-iiVec+1)
                     A2(iPrm2,ijVec) = A2(iPrm2,ijVec) +
     &                 Coeff1(iPrm1,iCntr1)*A1(jZeta,iVec)
                  End Do
               End If
            End Do
         End Do
      End Do
*
         End If
*
         If (Seg2) Then
*
*-----Second quarter transformation
*
      Do iPrm2 = 1, nPrm2
         Do iCntr2 = 1, nCntr2
*-----------Check for zero due to segmented basis
            If (Abs(Coeff2(iPrm2,iCntr2)).gt.Zero) Then
               Do iCntr1 = 1, nCntr1
                  Do iVec = iiVec, iiVec+mVec-1
                     ijVec = mVec*(iCntr1-1) + (iVec-iiVec+1)
                     A3(iVec,iCntr1,iCntr2) = A3(iVec,iCntr1,iCntr2) +
     &                 Coeff2(iPrm2,iCntr2)*A2(iPrm2,ijVec)
                  End Do
               End Do
            End If
         End Do
      End Do
*
         Else
*
*-----Second quarter transformation
*
      Do iPrm2 = 1, nPrm2
         Do iCntr2 = 1, nCntr2
            Do iCntr1 = 1, nCntr1
               Do iVec = iiVec, iiVec+mVec-1
                  ijVec = mVec*(iCntr1-1) + (iVec-iiVec+1)
                  A3(iVec,iCntr1,iCntr2) = A3(iVec,iCntr1,iCntr2) +
     &              Coeff2(iPrm2,iCntr2)*A2(iPrm2,ijVec)
               End Do
            End Do
         End Do
      End Do
*
         End If
*
*-----End of loop sectioning
*
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHO_LK_CASSCF(DLT,FLT,MSQ,W_PWXY,FactXI,nFIorb,nAorb,nChM,Ash,DoActive,nScreen,dmpk,dFmat,CMO,ExFac)
!*********************************************************************
!  Author : F. Aquilante
!
!           This routine makes use of the "Local K" scheme for
!                computing the exchange terms in both the Inactive
!                and Active Fock matrix
!
! *************** INACTIVE AO-BASIS FOCK MATRIX **********************
!
!   FI(ab) = 2 * sum_J  Lab,J * V(J)  -  sum_Jk  Lka,J * Lkb,J
!
! ***************   ACTIVE AO-BASIS FOCK MATRIX **********************
!
!   FA(ab) = sum_J  Lab,J * U(J)  -  0.5 * sum_Jw  Lwa,J * Lwb,J
!
! ***************   (WA|XY) integrals     ****************************
!
!   (WA|XY) = sum_J  L(wa,J) * L(xy,J)
!
!*********************************************************************
!
!      V(J) = sum_gd  Lgd,J * DI(gd)     DI=DLT(1)
!      U(J) = sum_gd  Lgd,J * DA(gd)     DA=DLT(2)
!
!      a,b,g,d:  AO-index
!      k:        MO-index   belonging to (Frozen+Inactive)
!      u,w,x,y:  MO-indices belonging to (Active)
!
!*********************************************************************

use ChoArr, only: nBasSh, nDimRS
use ChoSwp, only: IndRed, InfVec, nnBstRSh
use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Fock_util_global, only: Estimate, Update
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, L_Full_Type, Lab_Type, NDSBA_Type, SBA_Type, twxy_Type
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
type(DSBA_Type), intent(in) :: DLT(2), MSQ, Ash(2), CMO
type(DSBA_Type), intent(inout) :: FLT(2)
real(kind=wp), intent(_OUT_) :: W_PWXY(*)
real(kind=wp), intent(in) :: FactXI, dmpk, dFmat, ExFac
integer(kind=iwp), intent(in) :: nFIorb(8), nAorb(8), nChM(8), nScreen
logical(kind=iwp), intent(in) :: DoActive
#include "chotime.fh"
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: i, ia, iab, iag, iaSh, iaSkip, ib, iBatch, ibcount, ibg, ibs, ibSh, ibSkip, iCase, iE, ik, iLoc, iml, Inc, &
                     ioffa, iOffAB, ioffb, iOffShb, irc, ired1, IREDC, iS, ish, iShp, iSwap, ISYM, iSyma, iSymb, iSymv, iTmp, &
                     IVEC2, iVrs, jDen, jK, jK_a, jml, jmlmax, JNUM, JRED, JRED1, JRED2, jrs, jSym, jvc, JVEC, k, kMOs, kOff(8,2), &
                     krs, kscreen, kSym, l, l1, LFMAX, LFULL(2), LKsh, LKshp, LREAD, lSh, lSym, LWORK, MaxB, MaxRedT, &
                     MaxVecPerBatch, mDen, mrs, mSh, mTvec, mTvec1, mTvec2, MUSED, MxB, MxBasSh, myJRED2, n1, n2, nAt, NAv, NAw, &
                     nBatch, nBs, nBsa, nBsb, nDen, nIt, nkOrb, nMOs, nnA(8,8), nnO, nRS, NumCV, numSh, NUMV, NumVT, nVec, nVrs
real(kind=wp) :: Fact, FactC(2), FactX(2), fcorr, LKThr, SKsh, tau(2), TCC1, TCC2, TCINT1, TCINT2, tcoul(2), TCR1, TCR2, TCS1, &
                 TCS2, TCT1, TCT2, TCX1, TCX2, texch(2), thrv(2), tintg(2), tmotr(2), Tmp, tread(2), TOTCPU, TOTCPU1, TOTCPU2, &
                 TOTWALL, TOTWALL1, TOTWALL2, tscrn(2), TWC1, TWC2, TWINT1, TWINT2, TWR1, TWR2, TWS1, TWS2, TWT1, TWT2, TWX1, &
                 TWX2, xFab, xtau(2), xTmp, YMax, YshMax
logical(kind=iwp) :: add, DoScreen, DoTraInt
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: Debug
#endif
type(DSBA_Type) :: KLT(2)
type(SBA_Type) :: Laq(1), Lxy
type(twxy_Type) :: Scr
type(NDSBA_Type) :: DIAH
type(L_Full_Type) :: L_Full
type(Lab_Type) :: Lab
character(len=50) :: CFmt
character :: mode
integer(kind=iwp), allocatable :: Indx(:,:), iShp_rs(:), kOffSh(:,:), nnBfShp(:,:)
real(kind=wp), allocatable :: AbsC(:), Diag(:), Drs(:,:), Faa(:), Fia(:), Frs(:,:), Lrs(:,:), MLk(:,:), SumAClk(:,:), SvShp(:,:), &
                              VJ(:), Ylk(:,:)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: myJRED1, NNBSTMX, ntv0
real(kind=wp), allocatable :: DiagJ(:)
#endif
logical(kind=iwp), parameter :: DoRead = .false.
character(len=*), parameter :: SECNAM = 'CHO_LK_CASSCF'
real(kind=wp), external :: Cho_LK_ScreeningThreshold
real(kind=r8), external :: ddot_
integer(kind=iwp), external :: Cho_LK_MaxVecPerBatch

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
Debug = .false. ! to avoid double printing in CASSCF-debug
#endif

DoTraInt = .false.
IREDC = -1 ! unknown reduced set in core

FactC(:) = [one,one]
FactX(:) = [FactXI*ExFac,-Half*ExFac]

nDen = 2 ! inactive and active density, respectively

if (.not. DoActive) nDen = 1

call CWTIME(TOTCPU1,TOTWALL1) ! start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = zero ! time read/transform vectors
tcoul(:) = zero ! time for computing Coulomb
texch(:) = zero ! time for computing Exchange
tintg(:) = zero ! time for computing (tw|xy) integrals
tmotr(:) = zero ! time for the half-transf of vectors
tscrn(:) = zero ! time for screening overhead

! ==================================================================
call set_nnA(nSym,nAorb,nnA)

! Various offsets
! ----------------
MaxB = nBas(1)
do ISYM=2,NSYM
  MaxB = max(MaxB,nBas(iSym))
end do

!*************************************************

nnO = 0
nIt = 0
do jDen=1,nDen

  kOff(1,jDen) = nnO

  do ISYM=2,NSYM

    nnO = nnO+nFIorb(iSym-1)*(2-jDen)+nChM(iSym-1)*(jDen-1)

    kOff(iSym,jDen) = nnO

  end do

  nnO = nnO+nFIorb(nSym)*(2-jDen)+nChM(nSym)*(jDen-1)

  nIt = nIt+nnO*(2-jDen) ! tot # of (inactive+frozen) orbitals

end do

nAt = nnO-nIt ! tot # of active orb (decomp. Active density)

! Define max number of vectors to be treated in core at once

MaxVecPerBatch = Cho_LK_MaxVecPerBatch()

! Define the basic screening threshold

LKThr = Cho_LK_ScreeningThreshold(dFmat)

! Adjust the damping according to the Abs(Max BLB)
!tbp, may 2013: adjustment moved to Cho_LK_ScreeningThreshold
fcorr = dmpK
!tbp if (dFmat > zero) then
!tbp   if (dFmat < 1.0e3_wp*LKThr) then
!tbp     fcorr = dmpk*1.0e-2_wp
!tbp   end if
!tbp   if (dFmat <= LKThr) fcorr = fcorr*1.0e-2_wp
!tbp end if

tau(1) = (LKThr/max(1,nIt))*fcorr ! Inactive fock matrix screening
tau(2) = (LKThr/max(1,nAt))*fcorr ! Active fock matrix screening

MaxRedT = MaxRed
call GAIGOP_SCAL(MaxRedT,'+')

if (Estimate) then
  do i=1,nDen
    tau(i) = tau(i)/MaxRedT
  end do
end if

xtau(1) = sqrt(tau(1))
xtau(2) = sqrt(tau(2))

! Vector MO transformation screening thresholds
NumVT = NumChT
call GAIGOP_SCAL(NumVT,'+')
thrv(1) = (sqrt(LKThr/(max(1,nIt)*NumVT)))*fcorr
thrv(2) = (sqrt(LKThr/(max(1,nAt)*NumVT)))*fcorr

call mma_allocate(DIAG,NNBSTRT(1),Label='DIAG')

#ifdef _MOLCAS_MPP_
if ((nProcs > 1) .and. Update .and. Is_Real_Par()) then
  NNBSTMX = 0
  do i=1,nSym
    NNBSTMX = max(NNBSTMX,NNBSTR(i,1))
  end do
  call mma_allocate(diagJ,NNBSTMX,Label='diagJ')
  diagJ(:) = Zero
end if
#endif
do jDen=1,nDen
  call Allocate_DT(KLT(jDen),nBas,nBas,nSym,aCase='TRI')
  KLT(jDen)%A0(:) = Zero
end do

! *************** Read the diagonal integrals (stored as 1st red set)
if (Update) call CHO_IODIAG(DIAG,2) ! 2 means "read"

! allocate memory for sqrt(D(a,b)) stored in full (squared) dim
call Allocate_DT(DIAH,nBas,nBas,nSym)
DIAH%A0(:) = Zero

! allocate memory for the abs(C(l)[k])
call mma_allocate(AbsC,MaxB,Label='AbsC')

! allocate memory for the Y(l)[k] vectors
call mma_allocate(Ylk,MaxB,nnO,Label='Ylk')

! allocate memory for the ML[k] lists of largest elements in significant shells
call mma_allocate(MLk,nShell,nnO,Label='MLk')

! allocate memory for the list of  S:= sum_l abs(C(l)[k]) for each shell
call mma_allocate(SumAClk,nShell,nnO,Label='SumAClk')

! allocate memory for the Index arrays
call mma_allocate(Indx,[0,nShell],[1,nnO],Label='Indx')

! allocate memory for kOffSh
call mma_allocate(kOffSh,nShell,nSym,Label='kOffSh')

! allocate memory for nnBfShp
call mma_allocate(nnBfShp,nnShl_tot,nSym,Label='nnBfShp')

! allocate memory for iShp_rs
call mma_allocate(iShp_rs,nnShl_tot,Label='iShp_rs')

! allocate memory for the shell-pair Frobenius norm of the vectors
call mma_allocate(SvShp,nnShl,2,Label='SvShp')

! *** Compute Shell Offsets ( MOs and transformed vectors)

MxBasSh = 0

do iSyma=1,nSym

  LKsh = 0

  do iaSh=1,nShell ! kOffSh(iSh,iSym)

    kOffSh(iaSh,iSyma) = LKsh

    LKsh = LKsh+nBasSh(iSyma,iaSh)

    MxBasSh = max(MxBasSh,nBasSh(iSyma,iaSh))

  end do

end do

! allocate memory for the Diagonal of the Fock matrix
call mma_allocate(Fia,MxBasSh,Label='Fia')
call mma_allocate(Faa,nShell,Label='Faa')
Faa(:) = Zero
Fia(:) = Zero

! *** Determine S:= sum_l C(l)[k]^2  in each shell of C(a,k)
do jDen=1,nDen
  do kSym=1,nSym

    if (jDen == 2) then
      do jK=1,nChM(kSym)
        jK_a = jK+kOff(kSym,jDen)

        do iaSh=1,nShell

          SKsh = zero
          iS = kOffSh(iaSh,kSym)+1
          iE = kOffSh(iaSh,kSym)+nBasSh(kSym,iaSh)
          do ik=iS,iE
            SKsh = SKsh+Ash(2)%SB(kSym)%A2(ik,jK)**2
          end do

          SumAClk(iaSh,jk_a) = SKsh

        end do
      end do

    else
      do jK=1,nFIorb(kSym)
        jK_a = jK+kOff(kSym,jDen)

        do iaSh=1,nShell

          SKsh = zero
          iS = kOffSh(iaSh,kSym)+1
          iE = kOffSh(iaSh,kSym)+nBasSh(kSym,iaSh)
          do ik=iS,iE
            SKsh = SKsh+MSQ%SB(kSym)%A2(ik,jK)**2
          end do

          SumAClk(iaSh,jk_a) = SKsh

        end do
      end do

    end if

  end do
end do

! *** Compute Shell-pair Offsets in the K-matrix

do iSyma=1,nSym

  LKshp = 0

  do iaSh=1,nShell

    do ibSh=1,iaSh

      iShp = iaSh*(iaSh-1)/2+ibSh

      nnBfShp(iShp,iSyma) = LKShp

      LKShp = LKShp+nBasSh(iSyma,iaSh)*nBasSh(iSyma,ibSh)-(1-min((iaSh-ibSh),1))*nBasSh(iSyma,iaSh)*(nBasSh(iSyma,iaSh)-1)/2

    end do

  end do

end do

! *** Mapping shell pairs from the full to the reduced set

call Mk_iShp_rs(iShp_rs,nShell)

! *************** BIG LOOP OVER VECTORS SYMMETRY *******************
do jSym=1,nSym

  NumCV = NumCho(jSym)
  call GAIGOP_SCAL(NumCV,'max')
  if (NumCV < 1) cycle

  JNUM = 1
  call Allocate_DT(L_Full,nShell,iShp_rs,JNUM,JSYM,nSym,Memory=LFULL)

  iCase = 1 ! (wa|xy)
  call Allocate_DT(Scr,nAorb,nBas,JSYM,nSym,iCase)

  ! ****************     MEMORY MANAGEMENT SECTION    *****************
  !---------------------------------------------------------------
  ! compute memory needed to store at least 1 vector of JSYM
  ! and do all the subsequent calculations
  !---------------------------------------------------------------
  mTvec = 0
  mTvec1 = 0
  mTvec2 = 0
  MxB = 0
  do l=1,nSym
    k = Mul(l,JSYM)
    if ((nFIorb(k)+nChM(k)) > 0) MxB = max(MxB,nBas(l))
    mTvec1 = mTvec1+nAorb(k)*nBas(l)
    if (k <= l) mTvec2 = mTvec2+nnA(k,l)
  end do
  mTvec = mTvec1+mTvec2

  LFMAX = max(mTvec,LFULL(1)) ! re-use memory for the active vec
  mTvec = max(MxB,1) ! mem for storing half-transformed vec

  ! ------------------------------------------------------------------
  ! ------------------------------------------------------------------

  iLoc = 3 ! use scratch location in reduced index arrays

  JRED1 = InfVec(1,2,jSym)            ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) ! red set of the last vec
# ifdef _MOLCAS_MPP_
  myJRED1 = JRED1 ! first red set present on this node
  ntv0 = 0
# endif
  myJRED2 = JRED2 ! last red set present on this node

  ! entire red sets range for parallel run
  call GAIGOP_SCAL(JRED1,'min')
  call GAIGOP_SCAL(JRED2,'max')

  kscreen = 1
  DoScreen = .true.

  do JRED=JRED1,JRED2

    call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

    if (nVrs /= 0) then ! otherwise no vectors in that (jred,jsym)

      if (nVrs < 0) then
        write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
        call Abend()
      end if

      call Cho_X_SetRed(irc,iLoc,JRED)
      ! set index arrays at iLoc
      if (irc /= 0) then
        write(u6,*) SECNAM//'cho_X_setred non-zero rc = ',irc
        call Abend()
      end if

      IREDC = JRED

      nRS = nDimRS(JSYM,JRED)

      if (JSYM == 1) then
        call mma_allocate(Drs,nRS,nDen,Label='Drs')
        call mma_allocate(Frs,nRS,nDen,Label='Frs')
        Drs(:,:) = Zero
        Frs(:,:) = Zero
      end if

      call mma_maxDBLE(LWORK)

      nVec = min((LWORK-LFULL(2))/(nRS+mTvec+LFMAX),min(nVrs,MaxVecPerBatch))

      if (nVec < 1) then
        write(u6,*) SECNAM//': Insufficient memory for batch'
        write(u6,*) 'LWORK= ',LWORK
        write(u6,*) 'min. mem. need= ',nRS+mTvec+LFMAX
        write(u6,*) 'jsym= ',jsym
        write(u6,*) ' nRS = ',nRS
        write(u6,*) ' mTvec = ',mTvec
        write(u6,*) ' LFMAX = ',LFMAX
        call Abend()
        nBatch = -9999 ! dummy assignment
      end if

      LREAD = nRS*nVec

      call mma_allocate(Lrs,nRS,nVec,Label='Lrs')

      if (JSYM == 1) then
        ! Transform the densities to reduced set storage
        add = .false.
        call swap_full2rs(irc,iLoc,nRS,nDen,JSYM,DLT,Drs,add)
      end if

      ! BATCH over the vectors ----------------------------

      nBatch = (nVrs-1)/nVec+1

      do iBatch=1,nBatch

        if (iBatch == nBatch) then
          JNUM = nVrs-nVec*(nBatch-1)
        else
          JNUM = nVec
        end if

        JVEC = nVec*(iBatch-1)+iVrs
        IVEC2 = JVEC-1+JNUM

        call CWTIME(TCR1,TWR1)

        call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

        if ((NUMV <= 0) .or. (NUMV /= JNUM)) return

        call CWTIME(TCR2,TWR2)
        tread(1) = tread(1)+(TCR2-TCR1)
        tread(2) = tread(2)+(TWR2-TWR1)

        if (JSYM == 1) then

          call CWTIME(TCC1,TWC1)

          call mma_allocate(VJ,JNUM,Label='VJ')

          Fact = real(min(jVec-iVrs,1),kind=wp)

          do jDen=1,nDen
            ! ************ COULOMB CONTRIBUTIONS  *********************
            !
            !  jDen=1   ---> inactive fock matrix
            !  jDen=2   ---> active fock matrix
            !
            ! Contraction with the density matrix
            ! -----------------------------------
            ! V{#J} =  sum_rs  L(rs,{#J}) * DI(rs)
            !==========================================================

            call DGEMV_('T',nRS,JNUM,ONE,Lrs,nRS,Drs(:,jDen),1,ZERO,VJ,1)

            ! F(rs){#J} <- F(rs){#J} + FactC * sum_J L(rs,{#J})*V{#J}
            !===============================================================

            call DGEMV_('N',nRS,JNUM,FactC(jDen),Lrs,nRS,VJ,1,Fact,Frs(:,jDen),1)

          end do
          call mma_deallocate(VJ)

          call CWTIME(TCC2,TWC2)
          tcoul(1) = tcoul(1)+(TCC2-TCC1)
          tcoul(2) = tcoul(2)+(TWC2-TWC1)

        end if ! Coulomb contribution

        ! *************** EXCHANGE CONTRIBUTIONS  ***********************

        call CWTIME(TCS1,TWS1)
        ! -----------------------------------------------------------------
        ! Estimate the diagonals :   D(a,b) = sum_J (Lab,J)^2

        if (Estimate) then

          call Fzero(Diag(1+iiBstR(jSym,1)),NNBSTR(jSym,1))

          do krs=1,nRS

            mrs = iiBstR(JSYM,iLoc)+krs
            jrs = IndRed(mrs,iLoc) ! address in 1st red set

            do jvc=1,JNUM

              Diag(jrs) = Diag(jrs)+Lrs(krs,jvc)**2

            end do

          end do

        end if

        call CWTIME(TCS2,TWS2)
        tscrn(1) = tscrn(1)+(TCS2-TCS1)
        tscrn(2) = tscrn(2)+(TWS2-TWS1)
        !                                                              *
        !***************************************************************
        !***************************************************************
        !***************************************************************
        !                                                              *
        call Allocate_DT(L_Full,nShell,iShp_rs,JNUM,JSYM,nSym)
        mDen = 1
        call Allocate_DT(Lab,JNUM,nBasSh,nBas,nShell,nSym,mDen)

        call CWTIME(TCX1,TWX1)

        ! Reorder vectors to Full-dimensions
        !
        ! Vectors are returned in the storage LaJ,b with the restriction:
        !
        !    Sym(a) >= Sym(b)
        !
        ! and blocked in shell pairs

        call CHO_getShFull(Lrs,lread,JNUM,JSYM,IREDC,L_Full,SvShp,nnShl,iShp_rs,nnShl_tot)

        call CWTIME(TCX2,TWX2)
        texch(1) = texch(1)+(TCX2-TCX1)
        texch(2) = texch(2)+(TWX2-TWX1)

        if (DoScreen) then

          call CWTIME(TCS1,TWS1)

          ! Compute DH(a,b)=sqrt(D(a,b)) from the updated diagonals.
          !                              Only the symmetry blocks with
          !                              compound symmetry JSYM are computed
          ! ----------------------------------------------------------------
          ired1 = 1 ! location of the 1st red set
          call swap_tosqrt(irc,ired1,NNBSTRT(1),JSYM,DIAH,DIAG)

          call CWTIME(TCS2,TWS2)
          tscrn(1) = tscrn(1)+(TCS2-TCS1)
          tscrn(2) = tscrn(2)+(TWS2-TWS1)

        end if

        do jDen=1,nDen

          do kSym=1,nSym

            lSym = Mul(JSYM,kSym)

            nkOrb = nFIorb(kSym)*(2-jDen)+nChM(kSym)*(jDen-1)

            if (nBas(lsym) == 0) cycle

            do jK=1,nkOrb

              jK_a = jK+kOff(kSym,jDen)

              Lab%A0(1:nBas(lSym)*JNUM) = Zero

              if (DoScreen) then

                call CWTIME(TCS1,TWS1)
                !--------------------------------------------------------------
                ! Setup the screening
                !--------------------------------------------------------------

                if (jDen == 2) then
                  do ik=1,nBas(kSym)
                    AbsC(ik) = abs(Ash(2)%SB(kSym)%A2(ik,jK))
                  end do
                else
                  do ik=1,nBas(kSym)
                    AbsC(ik) = abs(MSQ%SB(kSym)%A2(ik,jK))
                  end do
                end if

                if (lSym >= kSym) then
                  ! ----------------------------------------------------------
                  ! Y(l)[k] = sum_n  DH(l,n) * |C(n)[k]|
                  !===========================================================
                  Mode = 'N'
                  n1 = nBas(lSym)
                  n2 = nBas(kSym)

                else
                  ! ----------------------------------------------------------
                  ! Y(l)[k] = sum_n  DH(n,l) * |C(n)[k]|
                  !===========================================================
                  Mode = 'T'
                  n1 = nBas(kSym)
                  n2 = nBas(lSym)

                end if

                if (n1 > 0) call DGEMV_(Mode,n1,n2,ONE,DIAH%SB(lSym,kSym)%A2,n1,AbsC,1,ZERO,Ylk(1,jK_a),1)

                ! List the shells present in Y(l)[k] by the largest element
                do ish=1,nShell
                  YshMax = zero
                  do ibs=1,nBasSh(lSym,ish)
                    YshMax = max(YshMax,Ylk(koffSh(ish,lSym)+ibs,jK_a))
                  end do
                  MLk(ish,jK_a) = YshMax
                end do

                ! Sort the lists ML[k]
                do ish=1,nShell
                  Indx(ish,jk_a) = ish
                end do

                ! **** Sort the list
                numSh = 0 ! # of significant shells
                jml = 1
                do while (jml <= nShell)

                  YMax = MLk(jml,jK_a)
                  jmlmax = jml

                  do iml=jml+1,nShell ! get the max
                    if (MLk(iml,jK_a) > YMax) then
                      YMax = MLk(iml,jK_a)
                      jmlmax = iml
                    end if
                  end do

                  if (jmlmax /= jml) then ! swap positions
                    xTmp = MLk(jml,jK_a)
                    iTmp = Indx(jml,jk_a)
                    MLk(jml,jK_a) = YMax
                    Indx(jml,jk_a) = Indx(jmlmax,jk_a)
                    MLk(jmlmax,jK_a) = xTmp
                    Indx(jmlmax,jk_a) = iTmp
                  end if

                  ! Exact bounds (quadratic scaling of the MO transformation)

                  !if (MLk(jml,jK_a)*MLk(1,jK_a) >= tau(jDen)) then

                  ! Here we use a non-exact bound for the exchange matrix to achieve
                  ! linear scaling. The positive definiteness of the exchange matrix
                  ! combined with the structure of the density matrix makes this
                  ! bound acceptable and likely to be almost exact for what concerns
                  ! the exchange energy
                  if (MLk(jml,jK_a) >= xtau(jDen)) then
                    numSh = numSh+1
                  else
                    jml = nShell ! exit the loop
                  end if

                  jml = jml+1

                end do

                Indx(0,jk_a) = numsh

                call CWTIME(TCS2,TWS2)
                tscrn(1) = tscrn(1)+(TCS2-TCS1)
                tscrn(2) = tscrn(2)+(TWS2-TWS1)
                !------------------------------------------------------------------
              end if ! Screening setup

              ! Transform vectors for shells in the list ML[k]
              !
              ! Screening based on the Frobenius norm: sqrt(sum_ij  A(i,j)^2)
              !
              !   || La,J[k] ||  <=  || Lab,J || * || Cb[k] ||

              call CWTIME(TCT1,TWT1)

              do iSh=1,Indx(0,jk_a)

                iaSh = Indx(iSh,jk_a)

                Lab%Keep(iaSh,1) = .true.

                ibcount = 0

                do ibSh=1,nShell

                  iOffShb = kOffSh(ibSh,kSym)

                  iShp = iTri(iaSh,ibSh)

                  if (iShp_rs(iShp) <= 0) cycle

                  if ((nnBstRSh(JSym,iShp_rs(iShp),iLoc)*nBasSh(lSym,iaSh)*nBasSh(kSym,ibSh) > 0) .and. &
                      (sqrt(abs(SumAClk(ibSh,jK_a)*SvShp(iShp_rs(iShp),1))) >= thrv(jDen))) then

                    ibcount = ibcount+1

                    if (lSym >= kSym) then

                      l1 = 1
                      if (iaSh < ibSh) l1 = 2

                      ! LaJ,[k] = sum_b  L(aJ,b) * C(b)[k]
                      ! ----------------------------------
                      Mode = 'N'
                      n1 = nBasSh(lSym,iaSh)*JNUM
                      n2 = nBasSh(kSym,ibSh)

                      if (JDen == 2) then
                        call DGEMV_(Mode,n1,n2,One,L_Full%SPB(lSym,iShp_rs(iShp),l1)%A21,n1,Ash(2)%SB(kSym)%A2(1+ioffShb:,jK),1, &
                                    One,Lab%SB(iaSh,lSym,1)%A,1)
                      else
                        call DGEMV_(Mode,n1,n2,One,L_Full%SPB(lSym,iShp_rs(iShp),l1)%A21,n1,MSQ%SB(kSym)%A2(1+ioffShb:,jK),1,One, &
                                    Lab%SB(iaSh,lSym,1)%A,1)
                      end if

                    else ! lSym < kSym

                      l1 = 1
                      if (ibSh < iaSh) l1 = 2

                      ! LJa,[k] = sum_b  L(b,Ja) * C(b)[k]
                      ! ----------------------------------
                      Mode = 'T'
                      n1 = nBasSh(kSym,ibSh)
                      n2 = JNUM*nBasSh(lSym,iaSh)

                      if (JDen == 2) then
                        call DGEMV_(Mode,n1,n2,One,L_Full%SPB(kSym,iShp_rs(iShp),l1)%A12,n1,Ash(2)%SB(kSym)%A2(1+ioffShb:,jK),1, &
                                    One,Lab%SB(iaSh,lSym,1)%A,1)
                      else
                        call DGEMV_(Mode,n1,n2,One,L_Full%SPB(kSym,iShp_rs(iShp),l1)%A12,n1,MSQ%SB(kSym)%A2(1+ioffShb:,jK),1,One, &
                                    Lab%SB(iaSh,lSym,1)%A,1)
                      end if
                    end if

                  end if

                end do

                ! The following re-assignement is used later on to check if the
                ! iaSh vector LaJ[k] can be neglected because identically zero

                if (ibcount == 0) Lab%Keep(iaSh,1) = .false.

              end do

              call CWTIME(TCT2,TWT2)
              tmotr(1) = tmotr(1)+(TCT2-TCT1)
              tmotr(2) = tmotr(2)+(TWT2-TWT1)

              ! Prepare the J-screening

              call CWTIME(TCS1,TWS1)

              do iSh=1,Indx(0,jk_a)

                iaSh = Indx(iSh,jk_a)

                if (.not. Lab%Keep(iaSh,1)) cycle

                if (lSym >= kSym) then

                  ! Faa,[k] = sum_J  (LaJ[k])**2
                  ! -----------------------------
                  Inc = nBasSh(lSym,iaSh)
                  n1 = 1

                else ! lSym < kSym

                  ! Faa,[k] = sum_J  (LJa[k])**2
                  !------------------------------
                  Inc = 1
                  n1 = JNUM

                end if

                Tmp = Zero
                do ia=1,nBasSh(lSym,iaSh)
                  Fia(ia) = DDot_(JNUM,Lab%SB(iaSh,lSym,1)%A(1+n1*(ia-1):),Inc,Lab%SB(iaSh,lSym,1)%A(1+n1*(ia-1):),Inc)
                  Tmp = max(abs(Fia(ia)),Tmp)
                end do

                Faa(iaSh) = Tmp

              end do

              call CWTIME(TCS2,TWS2)
              tscrn(1) = tscrn(1)+(TCS2-TCS1)
              tscrn(2) = tscrn(2)+(TWS2-TWS1)

              !--------------------------------------------------------
              ! Compute exchange matrix for the interacting shell pairs
              !--------------------------------------------------------
              call CWTIME(TCX1,TWX1)

              do lSh=1,Indx(0,jk_a)

                iaSh = Indx(lSh,jk_a)

                iaSkip = merge(1,0,Lab%Keep(iaSh,1))

                mSh = 1

                do while (mSh <= Indx(0,jk_a))

                  ibSh = Indx(mSh,jk_a)

                  ibSkip = merge(1,0,Lab%Keep(ibSh,1))

                  iShp = iTri(iaSh,ibSh)

                  iOffShb = kOffSh(ibSh,lSym)

                  iOffAB = nnBfShp(iShp,lSym)

                  xFab = sqrt(abs(Faa(iaSh)*Faa(ibSh)))

                  if (MLk(mSh,jK_a)*MLk(lSh,jK_a) < tau(jDen)) then

                    mSh = Indx(0,jk_a) !skip rest

                  else if ((iaSh == ibSh) .and. (xFab >= tau(jDen)/MaxRedT) .and. (iaSkip == 1)) then

                    if (lSym >= kSym) then

                      ! F(a,b)[k] = F(a,b)[k] + FactX * sum_J  L(a,J)[k] * L(b,J)[k]
                      ! --------------------------------------------------------------
                      nBs = nBasSh(lSym,iaSh)

                      call DGEMM_Tri('N','T',nBasSh(lSym,iaSh),nBasSh(lSym,ibSh),JNUM,FActX(jDen),Lab%SB(iaSh,lSym,1)%A,nBs, &
                                     Lab%SB(iaSh,lSym,1)%A,nBs,ONE,KLT(jDen)%SB(lSym)%A1(iOffAB+1:),nBs)

                    else ! lSym < kSym

                      ! F(a,b)[k] = F(a,b)[k] + FactX * sum_J  L(J,a)[k] * L(J,b)[k]
                      ! --------------------------------------------------------------

                      nBs = nBasSh(lSym,iaSh)

                      call DGEMM_Tri('T','N',nBasSh(lSym,iaSh),nBasSh(lSym,ibSh),JNUM,FActX(jDen),Lab%SB(iaSh,lSym,1)%A,JNUM, &
                                     Lab%SB(iaSh,lSym,1)%A,JNUM,ONE,KLT(jDen)%SB(lSym)%A1(iOffAB+1:),nBs)

                    end if

                  else if ((iaSh > ibSh) .and. (xFab >= tau(jDen)/MaxRedT) .and. (iaSkip*ibSkip == 1)) then

                    if (lSym >= kSym) then
                      ! F(a,b)[k] = F(a,b)[k] + FactX * sum_J  L(a,J)[k] * L(b,J)[k]
                      ! --------------------------------------------------------------
                      nBsa = nBasSh(lSym,iaSh)
                      nBsb = nBasSh(lSym,ibSh)

                      call DGEMM_('N','T',nBasSh(lSym,iaSh),nBasSh(lSym,ibSh),JNUM,FActX(jDen),Lab%SB(iaSh,lSym,1)%A,nBsa, &
                                  Lab%SB(ibSh,lSym,1)%A,nBsb,ONE,KLT(jDen)%SB(lSym)%A1(iOffAB+1:),nBsa)

                    else  ! lSym < kSym

                      ! F(a,b)[k] = F(a,b)[k] + FactX * sum_J  L(J,a)[k] * L(J,b)[k]
                      ! --------------------------------------------------------------

                      nBs = nBasSh(lSym,iaSh)

                      call DGEMM_('T','N',nBasSh(lSym,iaSh),nBasSh(lSym,ibSh),JNUM,FActX(jDen),Lab%SB(iaSh,lSym,1)%A,JNUM, &
                                  Lab%SB(ibSh,lSym,1)%A,JNUM,ONE,KLT(jDen)%SB(lSym)%A1(iOffAB+1:),nBs)

                    end if

                  end if

                  mSh = mSh+1 ! update shell counter

                end do

              end do

              call CWTIME(TCX2,TWX2)
              texch(1) = texch(1)+(TCX2-TCX1)
              texch(2) = texch(2)+(TWX2-TWX1)

            end do ! loop over k MOs

          end do ! loop over MOs symmetry

        end do ! loop over densities

        call Deallocate_DT(Lab)
        call Deallocate_DT(L_Full)
        !                                                              *
        !***************************************************************
        !***************************************************************
        !***************************************************************
        !                                                              *
        DoScreen = .false. ! avoid redo screening inside batch loop

        ! ************  END EXCHANGE CONTRIBUTION  ****************

        ! Diagonals updating. It only makes sense if Nscreen > 0

        if (Update .and. (Nscreen > 0)) then

          call CWTIME(TCS1,TWS1)
          ! -----------------------------------------------------------------
          ! update the diagonals :   D(a,b) = D(a,b) - sum_J (Lab,J)^2
          !
          ! subtraction is done in the 1st reduced set
#         ifdef _MOLCAS_MPP_
          if ((nProcs > 1) .and. Is_Real_Par()) then

            do krs=1,nRS

              mrs = iiBstR(JSYM,iLoc)+krs
              jrs = IndRed(mrs,iLoc)-iiBstR(JSYM,1)

              do jvc=1,JNUM

                DiagJ(jrs) = DiagJ(jrs)+Lrs(krs,jvc)**2
              end do

            end do

          else
#         endif

            do krs=1,nRS

              mrs = iiBstR(JSYM,iLoc)+krs
              jrs = IndRed(mrs,iLoc) ! address in 1st red set

              do jvc=1,JNUM

                Diag(jrs) = Diag(jrs)-Lrs(krs,jvc)**2
              end do

            end do

#         ifdef _MOLCAS_MPP_
          end if
#         endif

          call CWTIME(TCS2,TWS2)
          tscrn(1) = tscrn(1)+(TCS2-TCS1)
          tscrn(2) = tscrn(2)+(TWS2-TWS1)

        end if

        ! Lvw,J , strictly LT storage
        iSwap = 5
        call Allocate_DT(Lxy,nAorb,nAorb,nVec,JSYM,nSym,iSwap)
        iSwap = 0 ! Lvb,J are returned
        call Allocate_DT(Laq(1),nAorb,nBas,nVec,JSYM,nSym,iSwap)
        ! ----------------------------------------------------------------
        ! First half Active transformation  Lvb,J = sum_a  C(v,a) * Lab,J
        ! ----------------------------------------------------------------

        call CWTIME(TCINT1,TWINT1)

        ! Set up the skipping flags
        ! The memory used before for the full-dimension AO-vectors
        !     is now re-used to store half and full transformed
        !     vectors in the active space
        !----------------------------------------------------------

        kMOs = 1
        nMOs = 1 ! Active MOs (1st set)

        call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,Ash,Laq(1),DoRead)

        if (irc /= 0) return

        ! ----------------------------------------------------------------
        ! Active-Active transformation  Lvw,J = sum_b  Lvb,J * C(w,b)
        ! ----------------------------------------------------------------
        if (JSYM == 1) then

          do iSymb=1,nSym

            NAv = nAorb(iSymb)

            if (NAv > 0) then

              do JVC=1,JNUM

                call DGEMM_Tri('N','T',NAv,NAv,NBAS(iSymb),One,Laq(1)%SB(iSymb)%A3(:,:,JVC),NAv,Ash(1)%SB(iSymb)%A2,NAv,Zero, &
                               Lxy%SB(iSymb)%A2(:,JVC),NAv)

              end do

            end if

          end do

        else

          ! ----------------------------------------------------------------
          ! Active-Active transformation  Lvw,J = sum_b  Lvb,J * C(w,b)
          ! ----------------------------------------------------------------
          do iSymb=1,nSym

            iSymv = Mul(JSYM,iSymb)
            NAv = nAorb(iSymv)
            NAw = nAorb(iSymb) ! iSymb=iSymw

            if ((NAv*NAw /= 0) .and. (iSymv < iSymb)) then

              do JVC=1,JNUM

                call DGEMM_('N','T',NAv,NAw,NBAS(iSymb),One,Laq(1)%SB(iSymv)%A3(:,:,JVC),NAv,Ash(1)%SB(iSymb)%A2,NAw,Zero, &
                            Lxy%SB(iSymv)%A2(:,JVC),NAv)

              end do

            end if

          end do

        end if

        ! *************** EVALUATION OF THE (WA|XY) INTEGRALS ***********

        DoTraInt = (JRED == myJRED2) .and. (iBatch == nBatch)

        call CHO_eval_waxy(irc,Scr,Laq(1),Lxy,W_PWXY,nAorb,JSYM,JNUM,DoTraInt,CMO)

        call CWTIME(TCINT2,TWINT2)
        tintg(1) = tintg(1)+(TCINT2-TCINT1)
        tintg(2) = tintg(2)+(TWINT2-TWINT1)

        if (irc /= 0) return

        call Deallocate_DT(Lxy)
        call Deallocate_DT(Laq(1))

        ! --------------------------------------------------------------------
        ! --------------------------------------------------------------------

      end do ! end batch loop

      if (JSYM == 1) then
        ! backtransform fock matrix to full storage
        add = .true.
        call swap_rs2full(irc,iLoc,nRS,nDen,JSYM,FLT,Frs,add)
      end if

      ! free memory
      call mma_deallocate(Lrs)

      if (JSYM == 1) then
        call mma_deallocate(Frs)
        call mma_deallocate(Drs)
      end if

    end if

    ! Screening control section
    DoScreen = kscreen == Nscreen

    if (.not. DoScreen) then
      kscreen = kscreen+1
    else
      kscreen = 1
    end if

#   ifdef _MOLCAS_MPP_
    if ((nProcs > 1) .and. Update .and. DoScreen .and. Is_Real_Par()) then
      call GaDsum(DiagJ,nnBSTR(JSYM,1))
      call Daxpy_(nnBSTR(JSYM,1),-One,DiagJ,1,Diag(1+iiBstR(JSYM,1)),1)
      call Fzero(DiagJ,nnBSTR(JSYM,1))
    end if
    ! Need to activate the screening to setup the contributing shell
    ! indices the first time the loop is entered .OR. whenever other nodes
    ! have performed screening in the meanwhile
    if ((nProcs > 1) .and. (.not. DoScreen) .and. (nVrs == 0) .and. Is_Real_Par()) then
      ntv0 = ntv0+1
      DoScreen = ((JRED < myJRED1) .or. (ntv0 >= Nscreen))
      if (DoScreen) ntv0 = 0
    end if
#   endif

  end do ! loop over red sets

  call Deallocate_DT(Scr)

end do ! loop over JSYM

! Accumulate Coulomb and Exchange contributions
do jDen=1,nDen

  do iSym=1,nSym

    do iaSh=1,nShell

      ioffa = kOffSh(iaSh,iSym)

      ! ibSh < iaSh
      ! -----------
      do ibSh=1,iaSh-1

        iShp = iaSh*(iaSh-1)/2+ibSh

        iOffAB = nnBfShp(iShp,iSym)

        ioffb = kOffSh(ibSh,iSym)

        do ib=1,nBasSh(iSym,ibSh)

          do ia=1,nBasSh(iSym,iaSh)

            iab = nBasSh(iSym,iaSh)*(ib-1)+ia

            iag = ioffa+ia
            ibg = ioffb+ib

            FLT(jDen)%SB(iSym)%A1(iTri(iag,ibg)) = FLT(jDen)%SB(iSym)%A1(iTri(iag,ibg))+KLT(jDen)%SB(iSym)%A1(iOffAB+iab)

          end do

        end do

      end do

      ! ibSh = iaSh
      ! -----------
      iShp = iaSh*(iaSh+1)/2

      iOffAB = nnBfShp(iShp,iSym)

      do ib=1,nBasSh(iSym,iaSh)

        do ia=ib,nBasSh(iSym,iaSh)

          iab = ia*(ia-1)/2+ib

          iag = ioffa+ia
          ibg = ioffa+ib

          FLT(jDen)%SB(iSym)%A1(iTri(iag,ibg)) = FLT(jDen)%SB(iSym)%A1(iTri(iag,ibg))+KLT(jDen)%SB(iSym)%A1(iOffAB+iab)

        end do

      end do

    end do

  end do

end do

call mma_deallocate(Faa)
call mma_deallocate(Fia)
call mma_deallocate(SvShp)
call mma_deallocate(iShp_rs)
call mma_deallocate(nnBfShp)
call mma_deallocate(kOffSh)
call mma_deallocate(Indx)
call mma_deallocate(SumAClk)
call mma_deallocate(MLk)
call mma_deallocate(Ylk)
call mma_deallocate(AbsC)
call Deallocate_DT(DIAH)
do jDen=1,nDen
  call Deallocate_DT(KLT(jDen))
end do
#ifdef _MOLCAS_MPP_
if ((nProcs > 1) .and. Update .and. Is_Real_Par()) call mma_deallocate(DiagJ)
#endif
call mma_deallocate(Diag)

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky RASSCF timing from '//SECNAM
  write(u6,CFmt) '----------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Fock matrix construction        CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ VECTORS                              ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COULOMB                                   ',tcoul(1),tcoul(2)
  write(u6,'(2x,A26,2f10.2)') 'SCREENING OVERHEAD                        ',tscrn(1),tscrn(2)
  write(u6,'(2x,A26,2f10.2)') 'MO HALF-TRANSFORM VECTORS                 ',tmotr(1),tmotr(2)
  write(u6,'(2x,A26,2f10.2)') 'EXCHANGE                                  ',texch(1),texch(2)
  write(u6,'(2x,A26,2f10.2)') '(PU|VX) INTEGRALS                         ',tintg(1),tintg(2)
  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

! Print the Fock-matrix
#ifdef _DEBUGPRINT_
if (Debug) then ! to avoid double printing in CASSCF-debug

  write(u6,'(6X,A)') 'TEST PRINT FROM '//SECNAM
  write(u6,'(6X,A)')
  write(u6,'(6X,A)') '***** INACTIVE FOCK MATRIX ***** '
  do ISYM=1,NSYM
    if (NBAS(ISYM) > 0) then
      write(u6,'(6X,A)')
      write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
      call TRIPRT('','',FLT(1)%SB(ISYM)%A1,NBAS(ISYM))
    end if
  end do
  if (DoActive) then
    write(u6,'(6X,A)')
    write(u6,'(6X,A)') '***** ACTIVE FOCK MATRIX ***** '
    do ISYM=1,NSYM
      if (NBAS(ISYM) > 0) then
        write(u6,'(6X,A)')
        write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
        call TRIPRT('','',FLT(2)%SB(ISYM)%A2,NBAS(ISYM))
      end if
    end do
  end if

end if
#endif

return

end subroutine CHO_LK_CASSCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Magic_Bonds(Coor,nAtoms,iTabBonds,nBondMax,nBonds,iTabAtoms,nMax)

use Slapaf_Info, only: Covalent_Bond, Magic_Bond, vdW_Bond
use Constants, only: deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nBondMax, nMax
real(kind=wp), intent(in) :: Coor(3,nAtoms)
integer(kind=iwp), intent(inout) :: iTabBonds(3,nBondMax), nBonds, iTabAtoms(2,0:nMax,nAtoms)
integer(kind=iwp) :: iAtom, iBond, iBondType, iCase, jAtom, jBond, jBondType, kAtom, kBond, kNeighbor, nNeighbor_i, nNeighbor_j, &
                     nNeighbor_k
real(kind=wp) :: CosFi, CosFi_limit, Fi_limit, rij, rkj, xij, xkj, yij, ykj, zij, zkj

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *

Fi_limit = 165.0_wp*deg2rad
CosFi_limit = cos(Fi_limit)
do iBond=1,nBonds
  iBondType = iTabBonds(3,iBond)
  if (iBondType == vdW_Bond) cycle
  if (iBondType > Magic_Bond) cycle

  do iCase=1,2

    if (iCase == 1) then
      iAtom = iTabBonds(1,iBond)
      jAtom = iTabBonds(2,iBond)
    else
      iAtom = iTabBonds(2,iBond)
      jAtom = iTabBonds(1,iBond)
    end if

    xij = Coor(1,iAtom)-Coor(1,jAtom)
    yij = Coor(2,iAtom)-Coor(2,jAtom)
    zij = Coor(3,iAtom)-Coor(3,jAtom)
    rij = sqrt(xij**2+yij**2+zij**2)

    nNeighbor_j = iTabAtoms(1,0,jAtom)
    neighbor: do kNeighbor=1,nNeighbor_j
      kAtom = iTabAtoms(1,kNeighbor,jAtom)
      jBond = iTabAtoms(2,kNeighbor,jAtom)
      if (jBond >= iBond) cycle neighbor
      jBondType = iTabBonds(3,jBond)
      if (jBondType == vdW_Bond) cycle neighbor
      if (jBondType > Magic_Bond) cycle neighbor

      ! If this is close to a linear system we will form
      ! a magic bond between iAtom and kAtom

      xkj = Coor(1,kAtom)-Coor(1,jAtom)
      ykj = Coor(2,kAtom)-Coor(2,jAtom)
      zkj = Coor(3,kAtom)-Coor(3,jAtom)
      rkj = sqrt(xkj**2+ykj**2+zkj**2)

      CosFi = (xij*xkj+yij*ykj+zij*zkj)/(rij*rkj)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'iAtom,jAtom,kAtom=',iAtom,jAtom,kAtom
      write(u6,*) 'CosFi,CosFi_limit=',CosFi,CosFi_limit
#     endif

      ! Observe that this limit should be coordinated with
      ! the limit for excluding torsions in torsion_list!

      if (CosFi <= CosFi_Limit) then

#       ifdef _DEBUGPRINT_
        write(u6,*) 'Forming a "magic" bond'
        write(u6,*) 'iAtom,kAtom=',iAtom,kAtom
#       endif
        ! Double check that this bond is not included already.
        ! If that is the case just update the bond type if it
        ! is not classified already as a covalent bond.

        do kBond=1,nBonds
          if (((iTabBonds(1,kBond) == iAtom) .and. (iTabBonds(2,kBond) == kAtom)) .or. &
              ((iTabBonds(1,kBond) == kAtom) .and. (iTabBonds(2,kBond) == iAtom)) .and. (iTabBonds(3,kBond) /= Covalent_Bond)) then
            iTabBonds(3,kBond) = jAtom+Magic_Bond
            cycle neighbor
          end if
        end do

        if (nBonds+1 > nBondMax) then
          call WarningMessage(2,'Error in Magic_Bonds')
          write(u6,*) 'Magic_Bonds: nBonds > nBondMax'
          write(u6,*) 'iTabBonds:'
          do kBond=1,nBonds
            write(u6,*)
            write(u6,*) 'kBond=',kBond
            write(u6,*)
            write(u6,*) 'Atoms=',iTabBonds(1,kBond),iTabBonds(2,kBond)
            write(u6,*) 'Bondtype:',iTabBonds(3,kBond)
          end do
          call Abend()
        end if
        nBonds = nBonds+1
        iTabBonds(1,nBonds) = max(iAtom,kAtom)
        iTabBonds(2,nBonds) = min(iAtom,kAtom)
        iTabBonds(3,nBonds) = jAtom+Magic_Bond

        nNeighbor_i = iTabAtoms(1,0,iAtom)+1
        if (nNeighbor_i > nMax) then
          call WarningMessage(2,'Error in Magic_Bonds')
          write(u6,*) 'Magic_Bonds: nNeighbor_i > nMax'
          write(u6,*) 'iAtom=',iAtom
          write(u6,*) 'nNeighbor_i=',nNeighbor_i
          write(u6,*) 'nMax=',nMax
          call Abend()
        end if
        iTabAtoms(1,0,iAtom) = nNeighbor_i
        iTabAtoms(1,nNeighbor_i,iAtom) = kAtom
        iTabAtoms(2,nNeighbor_i,iAtom) = nBonds

        nNeighbor_k = iTabAtoms(1,0,kAtom)+1
        if (nNeighbor_k > nMax) then
          call WarningMessage(2,'Error in Magic_Bonds')
          write(u6,*) 'Magic_Bonds: nNeighbor_k > nMax'
          write(u6,*) 'kAtom=',kAtom
          write(u6,*) 'nNeighbor_k=',nNeighbor_k
          write(u6,*) 'nMax=',nMax
          call Abend()
        end if
        iTabAtoms(1,0,kAtom) = nNeighbor_k
        iTabAtoms(1,nNeighbor_k,kAtom) = iAtom
        iTabAtoms(2,nNeighbor_k,kAtom) = nBonds
      end if

    end do neighbor  ! kNeighbor

  end do     ! iCase

end do       ! iBond

return

end subroutine Magic_Bonds

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Fix_Coeff(nPrim,nCntrc,Coeff_c,Coeff_p,
     &                     Mode)
      Implicit Real*8 (a-h,o-z)
      Real*8 Coeff_c(nPrim,nCntrc), Coeff_p(nPrim,nPrim)
      Character Mode*1
*
*     Put in the normalization constant for the product
*     basis function.
*
      If (Mode.eq.'F') Then
         Do iC = 1, nCntrc
            Do iP = 1, nPrim
               Coeff_c(iP,iC) = Coeff_c(iP,iC)/Coeff_p(iP,iP)
            End Do
         End Do
      Else
         Do iC = 1, nCntrc
            Do iP = 1, nPrim
               Coeff_c(iP,iC) = Coeff_c(iP,iC)*Coeff_p(iP,iP)
            End Do
         End Do
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DNDOT(N,M,S,INCS,ISW,X,INCXI,INCXO,Y,INCYI,INCYO)
! COMPUTE DOT PRODUCT N TIMES

#include "intent.fh"

use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: N, M, INCS, ISW, INCXI, INCXO, INCYI, INCYO
real(kind=wp), intent(_OUT_) :: S(1+(N-1)*INCS)
real(kind=wp), intent(in) :: X((1+(M-1)*INCXI)*(1+(N-1)*INCXO)), Y((1+(M-1)*INCYI)*(1+(N-1)*INCYO))
integer(kind=iwp) :: I
real(kind=r8), external :: DDOT_

if (ISW == 1) then
  do I=1,N
    S(1+(I-1)*INCS) = DDOT_(M,X(1+(I-1)*INCXO),INCXI,Y(1+(I-1)*INCYO),INCYI)
  end do
else if (ISW == 2) then
  do I=1,N
    S(1+(I-1)*INCS) = -DDOT_(M,X(1+(I-1)*INCXO),INCXI,Y(1+(I-1)*INCYO),INCYI)
  end do
else if (ISW == 3) then
  do I=1,N
    S(1+(I-1)*INCS) = S(1+(I-1)*INCS)+DDOT_(M,X(1+(I-1)*INCXO),INCXI,Y(1+(I-1)*INCYO),INCYI)
  end do
else if (ISW == 4) then
  do I=1,N
    S(1+(I-1)*INCS) = S(1+(I-1)*INCS)-DDOT_(M,X(1+(I-1)*INCXO),INCXI,Y(1+(I-1)*INCYO),INCYI)
  end do
else
  call SysAbendMsg('dndot','ISW IS OUT OF RANGE IN DNDOT',' ')
end if

return

end subroutine DNDOT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019,2020, Roland Lindh                                *
*               2020, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine Update_kriging(
     &                     iter,MaxItr,NmIter,iInt,nFix,nInter,qInt,
     &                     Shift,
     &                     Grad,iOptC,Beta,Beta_Disp,Lbl,GNrm,
     &                     Energy,UpMeth,ed,Line_Search,Step_Trunc,
     &                     nLambda,iRow_c,nsAtom,AtomLbl,
     &                     mxdc,jStab,nStab,BMx,Smmtrc,nDimBC,
     &                     rLambda,Cx,Gx,GrdMax,StpMax,GrdLbl,StpLbl,
     &                     iNeg,nLbl,Labels,nLabels,FindTS,TSC,nRowH,
     &                     nWndw,Mode,MF,
     &                     iOptH,HUpMet,kIter,GNrm_Threshold,IRC,
     &                     dMass,HrmFrq_Show,CnstWght,Curvilinear,
     &                     Degen,ThrEne,ThrGrd)
************************************************************************
*                                                                      *
*     Object: to update coordinates                                    *
*                                                                      *
*    (see update_sl)                                                   *
************************************************************************
      Use kriging_mod, only: Max_Microiterations,
     &                       Thr_microiterations
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
      Real*8 qInt(nInter,MaxItr), Shift(nInter,MaxItr),
     &       Grad(nInter,MaxItr), GNrm(MaxItr), Energy(MaxItr),
     &       BMx(3*nsAtom,3*nsAtom), rLambda(nLambda,MaxItr),
     &       dMass(nsAtom), Degen(3*nsAtom), dEner,
     &       Cx(3*nsAtom,Iter+1), Gx(3*nsAtom,Iter), MF(3*nsAtom)
      Integer jStab(0:7,nsAtom), nStab(nsAtom),
     &        iNeg(2)
      Logical Line_Search, Smmtrc(3*nsAtom),
     &        FindTS, TSC, HrmFrq_Show, Curvilinear,
     &        First_MicroIteration
      Character Lbl(nLbl)*8, GrdLbl*8, StpLbl*8, Step_Trunc,
     &          Labels(nLabels)*8, AtomLbl(nsAtom)*(LENIN), UpMeth*6,
     &          HUpMet*6
      Character GrdLbl_Save*8
      Real*8 Dummy(1)
      Real*8, Allocatable:: Hessian(:,:), Temp(:,:)
*                                                                      *
************************************************************************
*                                                                      *
*     Different hardwired kriging options
*
*#define _DEBUGPRINT_
*#define _OVERSHOOT_
*                                                                      *
************************************************************************
*                                                                      *
      Logical Kriging_Hessian, Not_Converged, Force_RS
#ifdef _OVERSHOOT_
      Real*8, Allocatable:: Step_k(:,:)
#endif
*
      iRout=153
      iPrint=nPrint(iRout)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('Update_K: qInt',' ',qInt,nInter,Iter)
      Call RecPrt('Update_K: Shift',' ',Shift,nInter,Iter-1)
      Call RecPrt('Update_K: GNrm',' ',GNrm,Iter,1)
#endif
*
      Kriging_Hessian =.TRUE.
      Force_RS=.FALSE.
      iOpt_RS=1   ! Activate restricted variance.
      iterAI=iter
      dEner=Thr_microiterations
      nRaw=Min(iter,nWndw/2)
*     nRaw=1 ! Force HMF Hessian
      iFirst = iter - nRaw + 1
      iterK=0
      dqdq=Zero
      qBeta=Beta
      qBeta_Disp=Beta_Disp
      GrdMax_Save=GrdMax
      GrdLbl_Save=GrdLbl
#ifdef _DEBUGPRINT_
      Call RecPrt('qInt(0)',  ' ',qInt(1,iFirst),nInter,nRaw)
      Call RecPrt('Energy(0)',' ',Energy(iFirst),1,nRaw)
      Call RecPrt('Grad(0)',  ' ',Grad(1,iFirst),nInter,nRaw)
      Call RecPrt('Shift',  ' ',Shift(1,iFirst),nInter,nRaw)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Pick up the HMF Hessian
*
      Call mma_Allocate(Hessian,nInter,nInter,Label='Hessian')
      Call Mk_Hss_Q()
      Call Get_dArray('Hss_Q',Hessian,nInter**2)
*     Call RecPrt('HMF Hessian',' ',Hessian,nInter,nInter)
*                                                                      *
************************************************************************
*                                                                      *
*     Select the data points to pass to the GEK routine. Remember to
*     change the sign of the gradients.
*                                                                      *
************************************************************************
*                                                                      *
*     Note that we could have some kind of sorting here if we like!
*
************************************************************************
*                                                                      *
*     Pass the sample points to the GEK procedure and deallocate the
*     memory -- to be reused for another purpose later.
*
      Call DScal_(nInter*nRaw,-One,Grad(1,iFirst),1)
      Call Setup_Kriging(nRaw,nInter,qInt(1,iFirst),
     &                               Grad(1,iFirst),
     &                               Energy(iFirst),Hessian)
      Call DScal_(nInter*nRaw,-One,Grad(1,iFirst),1)
*                                                                      *
************************************************************************
*                                                                      *
*     Save initial gradient
*     This is for the case the gradient is already converged, we want
*     the microiterations to still reduce the gradient
*
      FAbs_ini=Sqrt(DDot_(nInter,Grad(1,iter),1,
     &                           Grad(1,iter),1)/DBLE(nInter))
      GrdMx_ini=Zero
      Do iInter = 1, nInter
         GrdMx_ini=Max(GrdMx_ini,Abs(Grad(iInter,iterAI)))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Find the fraction value to be used to define the restricted
*     variance threshold.
*
*
      Beta_Disp_Min=1.0D-10
*     Let the accepted variance be set as a fraction of the
*     largest component in the gradient.
      tmp=0.0D0
      Do i = 1, 3*nsAtom
         tmp = Max(tmp,Abs(Gx(i,iter)))
      End Do
*
*     Temporary code until we have figured out this for constrained
*     optimizations.
*
      Beta_Disp_=Max(Beta_Disp_Min,tmp*Beta_Disp)
      Beta_=Min(1.0D3*GNrm(iter),Beta)
*
#ifdef _RS_RFO_
*     Switch over to RS-RFO once the gradient is low.
*
      tmp=99.0D0
      Do j = 1, iter
         tmp0=0.0D0
         Do i = 1, 3*nsAtom
            tmp0 = Max(tmp0,Abs(Gx(i,j)))
         End Do
         tmp=Min(tmp,tmp0)
      End Do

      If (tmp.lt.4.0D-4) Then
         iOpt_RS=0
         Beta_=0.03D0
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Start the Kriging loop.
*
      Not_Converged = .True.
      Step_Trunc='N'  ! not defined
      do while (Not_Converged)
*                                                                      *
************************************************************************
*                                                                      *
         kIter_=iterAI
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*) 'Do iterAI: ',iterAI
#endif
*
*        Compute the Kriging Hessian
*
         If (Kriging_Hessian) Then
            Call Hessian_Kriging_Layer(qInt(1,iterAI),Hessian,nInter)
            Call Put_dArray('Hss_Q',Hessian,nInter**2)
         End If
*                                                                      *
************************************************************************
*                                                                      *
*        Compute the updated structure.
*
         First_MicroIteration=iterAI.eq.iter
         nWndw_=nWndw/2 + (iterAI-iter)
         Call Update_sl_(iterAI,iInt,nFix,nInter,qInt,Shift,Grad,iOptC,
     &                   Beta_,Beta_Disp_,Lbl,GNrm,Energy,
     &                   UpMeth,ed,Line_Search,Step_Trunc,nLambda,
     &                   iRow_c,nsAtom,AtomLbl,mxdc,jStab,
     &                   nStab,BMx,Smmtrc,nDimBC,rLambda,Cx,
     &                   GrdMax,StpMax,GrdLbl,StpLbl,iNeg,nLbl,
     &                   Labels,nLabels,FindTS,TSC,nRowH,nWndw_,Mode,
     &                   MF,iOptH,HUpMet,kIter_,GNrm_Threshold,IRC,
     &                   dMass,HrmFrq_Show,CnstWght,Curvilinear,Degen,
     &                   Kriging_Hessian,qBeta,iOpt_RS,
     &                   First_MicroIteration,iter,qBeta_Disp)
#ifdef _DEBUGPRINT_
         Write (6,*) 'Update_kriging: Step_Trunc',Step_Trunc
         Call RecPrt('New Coord',' ',qInt,nInter,iterAI+1)
         Call RecPrt('Grad',' ',Grad,nInter,iterAI)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        In case of a constrained optimization GrdMax and GNrm has been
*        updated to reflect the contribution from the constraint.
*        GrdMax, however, is a scalar and we need to save it such that
*        it has the correct value on exit. That is, the value of itera-
*        tion iter.
*
         If (iterAI.eq.iter) Then
            GrdMax_Save=GrdMax
            GrdLbl_Save=GrdLbl
         End If
*                                                                      *
************************************************************************
*                                                                      *
*        During the micro iterations we need to set GNrm to some
*        reasonable value. Normally it is set by the force routine or
*        the con_opt routine.
*
         If (nLambda.eq.0 .and. iterAI.gt.iter) Then
            GNrm(iterAI)=Sqrt(DDot_(nInter,Grad(1,iterAI),1,
     &                                    Grad(1,iterAI),1))
         End If
*                                                                      *
************************************************************************
*                                                                      *
*        Compute the step length from the last ab initio point
*        to the most recent kriging point.
*
         dqdq=Zero
         Do iInter=1,nInter
            dqdq=(qInt(iInter,iterAI+1)
     &           -qInt(iInter,iFirst+nRaw-1))**2
         End Do
         If (iterK.eq.0.and.Step_trunc.eq.'*') dqdq=qBeta**2
*                                                                      *
************************************************************************
*                                                                      *
*        Transform the new internal coordinates to Cartesians
*
         Call NewCar_Kriging(iterAI,iRow,nsAtom,nDimBC,nInter,BMx,dMass,
     &                       Lbl,Shift,qInt,Grad,AtomLbl,
     &                       Cx,.True.,iter)
*
*        Compute the energy and gradient according to the
*        surrogate model for the new coordinates.
*
         Call Energy_Kriging_layer(qInt(1,iterAI+1),Energy(iterAI+1),
     &                             nInter)
         Call Dispersion_Kriging_Layer(qInt(1,iterAI+1),E_Disp,nInter)
         Call Gradient_Kriging_layer(qInt(1,iterAI+1),
     &                               Grad(1,iterAI+1),nInter)
         Call DScal_(nInter,-One,Grad(1,iterAI+1),1)
*                                                                      *
************************************************************************
*                                                                      *
         iterK  = iterK  + 1
         iterAI = iterAI + 1
         dEner = Energy(iterAI) - Energy(iterAI-1)
#ifdef _DEBUGPRINT_
         Call RecPrt('qInt(x):',' ',qInt,nInter,iterAI)
         Call RecPrt('Ener(x):',' ',Energy,1,iterAI)
         Call RecPrt('Grad(x):',' ',Grad,nInter,iterAI)
         Write (6,*) 'UpMeth=',UpMeth
#endif
*
*        Change label of updating method
*
         UpMeth='RVO   '
         Write (UpMeth(4:6),'(I3)') iterK
*                                                                      *
************************************************************************
*                                                                      *
*        Check on convergence criteria.
*
         If (ThrEne.gt.Zero) Then
*           Convergence on energy criteria.
            Not_Converged = Abs(dEner).ge.ThrEne
            Not_Converged = Not_Converged .and. dqdq.lt.qBeta**2
         Else
*           Use standard convergence criteria
            FAbs=GNrm(iterAI-1)/SQRT(DBLE(nInter-nLambda))
            RMS =Sqrt(DDot_(nInter,Shift(1,iterAI-1),1,
     &                             Shift(1,iterAI-1),1)/DBLE(nInter))
            RMSMx=Zero
            Do iInter = 1, nInter
               RMSMx=Max(RMSMx,Abs(Shift(iInter,iterAI-1)))
            End Do
            GrdMx=GrdMax
#ifdef _DEBUGPRINT_
            Write (6,*)
            Write (6,*) 'iter=',iterAI-1
            Write (6,*) 'FAbs=',FAbs
            Write (6,*) 'GrdMax=',GrdMax
            Write (6,*) 'RMS=',RMS
            Write (6,*) 'GrdMx=',GrdMx
            Write (6,*) 'RMSMx=',RMSMx
            Write (6,*) FAbs.gt.Min(ThrGrd,FAbs_ini)
            Write (6,*) GrdMx.gt.Min(ThrGrd*OneHalf,GrdMx_ini)
            Write (6,*) RMS.gt.ThrGrd*Four
            Write (6,*) RMSMx.gt.ThrGrd*Six
#endif
            Not_Converged = FAbs.gt.Min(ThrGrd,FAbs_ini)
            Not_Converged = Not_Converged .or.
     &                      GrdMx.gt.Min(ThrGrd*OneHalf,GrdMx_ini)
            Not_Converged = Not_Converged .or.
     &                      RMS.gt.ThrGrd*Four
            Not_Converged = Not_Converged .or.
     &                      RMSMx.gt.ThrGrd*Six
         End If
*        Check total displacement from initial structure
         If (Force_RS) Then
            Call mma_allocate(Temp,3*nsAtom,1)
            Temp(:,1)=Cx(:,iterAI)-Cx(:,iter)
            RMS =Sqrt(DDot_(3*nsAtom,Temp,1,Temp,1)/DBLE(3*nsAtom))
            If (RMS.gt.(Three*Beta_)) Step_trunc='*'
            Call mma_deAllocate(Temp)
         End If
         Not_Converged = Not_Converged .and.
     &                   iterK.lt.Max_Microiterations
#ifdef _DEBUGPRINT_
         Write (6,*) 'Not_Converged=',Not_Converged
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        If the step restriction is invoked or Hessian has been
*        corrected for wrong curvature, terminate anyhow.
*
         If (Step_trunc.ne.' ') Not_Converged=.False.
*
*        If RS rather than RV do not micro iterate
*
         If (iOpt_RS.eq.0) Not_Converged=.False.
*        Not_Converged=.False. ! Force single iteration scheme.
#ifdef _DEBUGPRINT_
         Write (6,*) 'Not_Converged=',Not_Converged
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     End of the micro iteration loop
*
      End Do  ! Do While (Not_Converged)
#ifdef _OVERSHOOT_
*                                                                      *
************************************************************************
*                                                                      *
*     Attempt overshooting
*
      Call mma_allocate(Step_k,nInter,2)
      i=iFirst+nRaw-1
      Call dCopy_(nInter,qInt(1,iterAI),1,Step_k(1,2),1)
      Call dAXpY_(nInter,-One,qInt(1,i),1,Step_k(1,2),1)
*     Call RecPrt('q(i+1)-q(f)','',Step_k(1,2),nInter,1)
      If (i.gt.1) Then
         Call dCopy_(nInter,qInt(1,i),1,Step_k(1,1),1)
         Call dAXpY_(nInter,-One,qInt(1,i-1),1,Step_k(1,1),1)
*        Call RecPrt('q(f)-q(f-1)','',Step_k(1,1),nInter,1)
         dsds=dDot_(nInter,Step_k(1,1),1,Step_k(1,2),1)
         dsds=dsds/Sqrt(ddot_(nInter,Step_k(1,1),1,Step_k(1,1),1))
         dsds=dsds/Sqrt(ddot_(nInter,Step_k(1,2),1,Step_k(1,2),1))
         Write(6,*) 'dsds = ',dsds
      Else
         dsds=Zero
      End If
      dsds_min=0.9D0
      If ((dsds.gt.dsds_min).And.(Step_Trunc.eq.' ')) Then
        Do Max_OS=9,0,-1
         OS_Factor=Max_OS*((dsds-dsds_min)/(One-dsds_min))**4
         Call dCopy_(nInter,qInt(1,i),1,qInt(1,iterAI),1)
         Call dAXpY_(nInter,One+OS_Factor,Step_k(1,2),1,
     &                                    qInt(1,iterAI),1)
         Call Energy_Kriging_Layer(qInt(1,iterAI),OS_Energy,nInter)
         Call Dispersion_Kriging_Layer(qInt(1,iterAI),OS_Disp,nInter)
         Write(6,*) 'Max_OS=',Max_OS
         Write(6,*) OS_Disp,E_Disp,Beta_Disp_
         If ((OS_Disp.gt.E_Disp).And.(OS_Disp.lt.Beta_Disp_)) Then
            Call dAXpY_(nInter,OS_Factor,Step_k(1,2),1,
     &                                   Shift(1,iterAI-1),1)
            Call NewCar_Kriging(iterAI-1,iRow,nsAtom,nDimBC,nInter,BMx,
     &                          dMass,Lbl,Shift,qInt,Grad,AtomLbl,
     &                          Cx,.True.,iter)
            Energy(iterAI)=OS_Energy
            If (Max_OS.gt.0) Then
               If (UpMeth(4:4).ne.' ') UpMeth(5:6)='**'
               UpMeth(4:4)='+'
            End If
            Exit
         End If
        End Do
      End If
      Call mma_deallocate(Step_k)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Save the optimized kriging coordinates as the coordinates
*     for the next macro iteration.
*
      qInt(:,iter+1)=qInt(:,iterAI)
      Cx(:,iter+1)=Cx(:,iterAI)
*
*     Update the shift vector
*
      Shift(:,iter)=qInt(:,iter+1)-qInt(:,iter)
*
*     Update the predicted energy change
*
      ed = Energy(iterAI)-Energy(iter)
*
      Call MxLbls(GrdMax,StpMax,GrdLbl,StpLbl,nInter,
     &            Grad(1,iter),Shift(1,iter),Lbl)
*
*     Stick in the correct value for GrdMax, which might contain a
*     contribution due to constraints.
*
      GrdMax=GrdMax_Save
      GrdLbl=GrdLbl_Save
#ifdef _DEBUGPRINT_
      Call RecPrt('qInt(3):',' ',qInt,nInter,iter+1)
      Call RecPrt('Shift:',' ',Shift,nInter,iter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Deallocating memory used by Kriging
*
      Call mma_deallocate(Hessian)
      Call Close_Kriging()
*                                                                      *
************************************************************************
*                                                                      *
*-----Write out the shift in internal coordinate basis.
*
      If (iPrint.ge.99) Then
         Call RecPrt(
     &      'Shifts in internal coordinate basis / au or rad',
     &      ' ',Shift,nInter,Iter)
         Call RecPrt(
     &      'qInt in internal coordinate basis / au or rad',
     &      ' ',qInt,nInter,Iter+1)
      End If
*
*---- Remove unneeded fields from the runfile
      Dummy(1)=-Zero
      Call Put_dArray('BMxOld',Dummy(1),0)
      Call Put_dArray('TROld',Dummy(1),0)
*
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(kIter)
      If (.False.) Call Unused_integer(NmIter)
#endif
      End Subroutine Update_Kriging

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contw1(wrk,wrksize,lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,lunt2o3)
! this routine calcs contributions to W1 i.e. W11,W12,W13
! and contribution from W1 to T2 i.e. T24
!
! Mediate : WI(m,n,i,j)
! Spin states : WI(mn,ij)aaaa, WI(mn,ij)bbbb, WI(m,n,i,j)abab
! Contributions:
!
!     WI1
!I.1  WI(mn,ij)aaaa   <= <mn||ij>aaaa
!J.1  WI(mn,ij)bbbb   <= <mn||ij>bbbb
!K.1  WI(m,n,i,j)abab <= <mn||ij>abab
!
!     WI2
!I.2  Q(mn,i,j)aaaa  <= sum(e-a) [ <ie||mn>aaaa . T1o(e,j)aa ]
!     WI(mn,ij)aaaa   <- Q(mn,i,j)aaaa - Q(mn,j,i)aaaa  i>j
!J.2  Q(mn,i,j)bbbb  <= sum(e-b) [ <ie||mn>bbbb . T1o(e,j)bb ]
!     WI(mn,ij)bbbb   <- Q(mn,i,j)bbbb - Q(mn,j,i)bbbb  i>j
!K.2  WI(m,n,i,j)abab <- - sum(e-a) [ <je||mn>baab . T1o(e,i)aa ]
!     <- sum(e-b) [ <ie||mn>abab . T1o(e,j)bb ]
!
!     WI3
!I.3  WI(mn,ij)aaaa   <- sum(e>f-aa) [ <ef||mn>aaaa . Tau(ef,ij)aaaa ]
!J.3  WI(mn,ij)bbbb   <- sum(e>f-bb) [ <ef||mn>bbbb . Tau(ef,ij)bbbb ]
!K.3  WI(m,n,i,j)abab <- sum(e,f-ab) [ <ef||mn>abab . Tau(e,f,i,j)abab ]
!
!     T24
!I.4  T2n(ab,ij)aaaa   <- sum(m>n-aa) [ Tau(ab,mn)aaaa . W1(mn,ij)aaaa ]
!J.4  T2n(ab,ij)bbbb   <- sum(m>n-bb) [ Tau(ab,mn)bbbb . W1(mn,ij)bbbb ]
!K.4  T2n(a,b,i,j)abab <- sum(m,n-ab) [ Tau(a,b,m,n)abab . W1(m,n,i,j)abab ]
!
! N.B. use and destroy : V1,V2,V3,V4
! N.B. number of read  : 6

use ccsd_global, only: idfin, t11, t12, t21, t22, t23, v1, v2, v3, v4, w01, w02, w03, w11, w12, w13, w14
use Para_Info, only: MyRank
use Constants, only: One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp), intent(_IN_) :: lunabij1, lunabij2, lunabij3, lunt2o1, lunt2o2, lunt2o3
integer(kind=iwp) :: post, rc, ssc

!par
if (myRank == idfin) then

  !I case W1(mn,ij)aaaa

  !I.1.1 map V1(mn,ij) <= <mn||ij>aaaa
  call map(wrk,wrksize,4,1,2,3,4,w01,1,v1,post,rc)

  !I.2.1 map V2(mn,i,e) <= <ie||mn>aaaa
  call map(wrk,wrksize,4,3,4,1,2,w11,1,v2,post,rc)

  !I.2.2 mult V3(mn,i,j) <= V2(mn,i,e) . T1o(e,j)aa
  call ccmult(wrk,wrksize,4,2,4,1,v2,1,t11,1,v3,ssc,rc)

  !I.2.3 pack V2(mn,ij) <= V3(mn,i,j)
  call fack(wrk,wrksize,4,4,v3,1,v2,rc)

  !I.2.4 add V1(mn,ij) <- V2(mn,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v2,1,v1,1,rc)

  !I.3.1 read V2(ef,ij) <= T2o(ef,ij)aaaa
  call filemanager(2,lunt2o1,rc)
  call getmediate(wrk,wrksize,lunt2o1,v2,rc)

  !I.3.2 make Tau V2(ef,ij) from V2(ef,ij)
  call mktau(wrk,wrksize,v2,t11,t12,One,rc)

  !I.3.3 read V3(ef,mn) <= <ef||mn>aaaa
  call filemanager(2,lunabij1,rc)
  call getmediate(wrk,wrksize,lunabij1,v3,rc)

  !I.3.4 map V4(mn,ef) <= V3(ef,mn)
  call map(wrk,wrksize,4,3,4,1,2,v3,1,v4,post,rc)

  !I.3.5 mult V3(mn,ij) = V4(mn,ef) . V2(ef,ij)
  call ccmult(wrk,wrksize,4,4,4,2,v4,1,v2,1,v3,ssc,rc)

  !I.3.6 add V1(mn,ij) <- V3(mn,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,v1,1,rc)

  !I.4.0 Tau(ab,mn) are in V2(ab,mn) from I.3.2
  !      W1(mn,ij)  are in V1(mn,ij)

  !I.4.1 V3(ab,ij) = V2(ab,mn) . V1(mn,ij)
  call ccmult(wrk,wrksize,4,4,4,2,v2,1,v1,1,v3,ssc,rc)

  !I.4.2 add t2n(ab,ij)aaaa <- V3(ab,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,t21,1,rc)

  !J case W1(mn,ij)bbbb

  !J.1.1 map V1(mn,ij) <= <mn||ij>bbbb
  call map(wrk,wrksize,4,1,2,3,4,w02,1,v1,post,rc)

  !J.2.1 map V2(mn,i,e) <= <ie||mn>bbbb
  call map(wrk,wrksize,4,3,4,1,2,w12,1,v2,post,rc)

  !J.2.2 mult V3(mn,i,j) <= V2(mn,i,e) . T1o(e,j)bb
  call ccmult(wrk,wrksize,4,2,4,1,v2,1,t12,1,v3,ssc,rc)

  !J.2.3 pack V2(mn,ij) <= V3(mn,i,j)
  call fack(wrk,wrksize,4,4,v3,1,v2,rc)

  !J.2.4 add V1(mn,ij) <- V2(mn,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v2,1,v1,1,rc)

  !J.3.1 read V2(ef,ij) <= T2o(ef,ij)bbbb
  call filemanager(2,lunt2o2,rc)
  call getmediate(wrk,wrksize,lunt2o2,v2,rc)

  !J.3.2 make Tau V2(ef,ij) from V2(ef,ij)
  call mktau(wrk,wrksize,v2,t11,t12,One,rc)

  !J.3.3 read V3(ef,mn) <= <ef||mn>bbbb
  call filemanager(2,lunabij2,rc)
  call getmediate(wrk,wrksize,lunabij2,v3,rc)

  !J.3.4 map V4(mn,ef) <= V3(ef,mn)
  call map(wrk,wrksize,4,3,4,1,2,v3,1,v4,post,rc)

  !J.3.5 mult V3(mn,ij) = V4(mn,ef) . V2(ef,ij)
  call ccmult(wrk,wrksize,4,4,4,2,v4,1,v2,1,v3,ssc,rc)

  !J.3.6 add V1(mn,ij) <- V3(mn,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,v1,1,rc)

  !J.4.0 Tau(ab,mn) are in V2(ab,mn) from J.3.2
  !      W1(mn,ij)  are in V1(mn,ij)

  !J.4.1 mult V3(ab,ij) = V2(ab,mn) . V1(mn,ij)
  call ccmult(wrk,wrksize,4,4,4,2,v2,1,v1,1,v3,ssc,rc)

  !J.4.2 add t2n(ab,ij)bbbb <- V3(ab,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,t22,1,rc)

  !K case W1(mn,ij)abab

  !K.1.1 map V1(m,n,i,j) <= <mn||ij>abab
  call map(wrk,wrksize,4,1,2,3,4,w03,1,v1,post,rc)

  !K.2.1 map V2(m,n,j,e) <= <je||mn>baab
  call map(wrk,wrksize,4,3,4,1,2,w14,1,v2,post,rc)

  !K.2.2 mult V3(m,n,j,i) <= V2(m,n,j,e) . T1o(e,i)aa
  call ccmult(wrk,wrksize,4,2,4,1,v2,1,t11,1,v3,ssc,rc)

  !K.2.3 map V2(m,n,i,j) <= V3(m,n,j,i)
  call map(wrk,wrksize,4,1,2,4,3,v3,1,v2,post,rc)

  !K.2.4 add V1(m,n,i,j) <- - V2(m,n,i,j)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,-One,v2,1,v1,1,rc)

  !K.2.5 map V2(m,n,i,e) <= <ie||mn>abab
  call map(wrk,wrksize,4,3,4,1,2,w13,1,v2,post,rc)

  !K.2.6 mult V3(m,n,i,j) <= V2(m,n,i,e) . T1o(e,j)bb
  call ccmult(wrk,wrksize,4,2,4,1,v2,1,t12,1,v3,ssc,rc)

  !K.2.7 add V1(m,n,i,j) <- V3(m,n,i,j)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,v1,1,rc)

  !K.3.1 read V2(e,f,i,j) <= T2o(e,f,i,j)abab
  call filemanager(2,lunt2o3,rc)
  call getmediate(wrk,wrksize,lunt2o3,v2,rc)

  !K.3.2 make Tau V2(e,f,i,j) from V2(e,f,i,j)
  call mktau(wrk,wrksize,v2,t11,t12,One,rc)

  !K.3.3 read V3(e,f,m,n) <= <ef||mn>abab
  call filemanager(2,lunabij3,rc)
  call getmediate(wrk,wrksize,lunabij3,v3,rc)

  !K.3.4 map V4(m,n,e,f) <= V3(e,f,m,n)
  call map(wrk,wrksize,4,3,4,1,2,v3,1,v4,post,rc)

  !K.3.5 mult V3(m,n,i,j) = V4(m,n,e,f) . V2(e,f,i,j)
  call ccmult(wrk,wrksize,4,4,4,2,v4,1,v2,1,v3,ssc,rc)

  !K.3.6 add V1(m,n,i,j) <- V3(m,n,i,j)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,v1,1,rc)

  !K.4.0 Tau(a,b,m,n) are in V2(ab,mn) from K.3.2
  !      W1(m,n,i,j)  are in V1(m,n,i,j)

  !K.4.1 mult V3(a,b,i,j) = V2(a,b,m,n) . V1(m,n,i,j)
  call ccmult(wrk,wrksize,4,4,4,2,v2,1,v1,1,v3,ssc,rc)

  !K.4.2 add t2n(a,b,i,j)abab <- V3(a,b,i,j)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,t23,1,rc)

end if

return

end subroutine contw1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine OneEl_g_pcm(Kernel,KrnlMm,Grad,nGrad,DiffOp,CCoor,FD,nFD,lOper,nComp,nOrdOp,Label)
!***********************************************************************
!                                                                      *
! Object: to compute gradients of the one electron integrals.          *
!         The memory at this point is assumed to be large enough to do *
!         the computation in core.                                     *
!         The data is structured with respect to four indices, two (my *
!         ny or i j) refer to primitives or basis functions and two (a *
!         b) refer to the components of the cartesian or spherical     *
!         harmonic gaussians.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!             Modified for Hermite-Gauss quadrature November '90       *
!             Modified for Rys quadrature November '90                 *
!             Modified for multipole moments November '90              *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for general kernel routines January '91         *
!             Modified for nonsymmetrical operators February '91       *
!             Modified for gradients October '91                       *
!***********************************************************************

use Real_Spherical, only: ipSph, RSph
use iSD_data, only: iSD
use Basis_Info, only: dbsc, MolWgh, Shells
use Center_Info, only: dc
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
external :: Kernel, KrnlMm
integer(kind=iwp), intent(in) :: nGrad, nFD, nComp, lOper(nComp), nOrdOp
real(kind=wp), intent(out) :: Grad(nGrad)
logical(kind=iwp), intent(in) :: DiffOp
real(kind=wp), intent(in) :: CCoor(3), FD(nFD)
character(len=80), intent(in) :: Label
integer(kind=iwp) :: i, iAng, iAO, iBas, iCar, iCmp, iCnt, iCnttp, iComp, iDCRR(0:7), iDCRT(0:7), ijS, IndGrd(3,2), iPrim, iPrint, &
                     iRout, iS, iShell, iShll, iSmLbl, iStabM(0:7), iStabO(0:7), iuv, jAng, jAO, jBas, jCmp, jCnt, jCnttp, jPrim, &
                     jS, jShell, jShll, kk, lDCRR, lFinal, llOper, LmbdR, LmbdT, mdci, mdcj, MemKer, MemKrn, nDCRR, nDCRT, niAng, &
                     njAng, nOp(2), nOrder, nScr1, nScr2, nSkal, nSO, nStabM, nStabO, nTasks
real(kind=wp) :: A(3), B(3), FactNd, RB(3)
logical(kind=iwp) :: AeqB, EQ, IfGrad(3,3)
real(kind=wp), allocatable :: DAO(:), DSO(:), DSOp(:), Fnl(:), Kappa(:), Kern(:), PCoor(:), Scrt1(:), Scrt2(:), Zeta(:), ZI(:)
character(len=3), parameter :: ChOper(0:7) = ['E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz']
integer(kind=iwp), external :: MemSO1, n2Tri, NrOpr
#include "angtp.fh"
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"

iRout = 112
iPrint = nPrint(iRout)
Grad(:) = Zero

! Auxiliary memory allocation.

call mma_allocate(Zeta,S%m2Max,label='Zeta')
call mma_allocate(ZI,S%m2Max,label='ZI')
call mma_allocate(Kappa,S%m2Max,label='Kappa')
call mma_allocate(PCoor,3*S%m2Max,label='PCoor')
!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Basis_Mode('Valence')
call Nr_Shells(nSkal)
call Setup_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
! Double loop over shells. These loops decide the integral type

nTasks = nSkal*(nSkal+1)/2
iS = 0
jS = 0
do ijS=1,nTasks
  jS = jS+1
  if (jS > iS) then
    iS = jS
    jS = 1
  end if

  !do iS=1,nSkal
  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  mdci = iSD(10,iS)
  iShell = iSD(11,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
  niAng = nTri_Elem1(iAng)

  !do jS=1,iS
  jShll = iSD(0,jS)
  jAng = iSD(1,jS)
  jCmp = iSD(2,jS)
  jBas = iSD(3,jS)
  jPrim = iSD(5,jS)
  jAO = iSD(7,jS)
  mdcj = iSD(10,jS)
  jShell = iSD(11,jS)
  jCnttp = iSD(13,jS)
  jCnt = iSD(14,jS)
  B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
  njAng = nTri_Elem1(jAng)

  iSmLbl = 1
  nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
  if (nSO == 0) cycle

  ! Find the DCR for A and B

  call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
  if ((.not. DiffOp) .and. (nDCRR == 1) .and. EQ(A,B)) cycle
  if (iPrint >= 49) write(u6,'(10A)') ' {R}=(',(ChOper(iDCRR(i)),i=0,nDCRR-1),')'

  if (iPrint >= 19) write(u6,'(A,A,A,A,A)') ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'

  ! Call kernel routine to get memory requirement.

  call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)
  MemKrn = MemKer*S%m2Max
  call mma_allocate(Kern,MemKrn,label='Kernel')

  ! Allocate memory for the final integrals, all in the primitive basis.

  lFinal = 6*S%MaxPrm(iAng)*S%MaxPrm(jAng)*niAng*njAng*nComp
  call mma_allocate(Fnl,lFinal,label='Final')

  ! Scratch area for contraction step

  nScr1 = S%MaxPrm(iAng)*S%MaxPrm(jAng)*niAng*njAng
  call mma_allocate(Scrt1,nScr1,label='Scrtch')

  ! Scratch area for the transformation to spherical gaussians

  nScr2 = S%MaxPrm(iAng)*S%MaxPrm(jAng)*niAng*njAng
  call mma_allocate(Scrt2,nScr2,label='ScrSph')

  call mma_allocate(DAO,iPrim*jPrim*niAng*njAng,label='DAO')

  ! At this point we can compute Zeta.

  call ZXia(Zeta,ZI,iPrim,jPrim,Shells(iShll)%Exp,Shells(jShll)%Exp)

  do iCar=0,2
    IndGrd(iCar+1,1) = iSD(iCar+16,iS)
    IfGrad(iCar+1,1) = iSD(iCar+16,iS) /= 0
  end do

  AeqB = iS == jS

  do iCar=0,2
    IndGrd(iCar+1,2) = iSD(iCar+16,jS)
    IfGrad(iCar+1,2) = iSD(iCar+16,jS) /= 0
  end do

  ! Find the stabilizer for A and B

  call Inter(dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iStabM,nStabM)

  ! Allocate memory for the elements of the Fock or 1st order
  ! denisty matrix which are associated with the current shell
  ! pair.

  call mma_allocate(DSOp,nSO*iPrim*jPrim,label='DSOpr')
  call mma_allocate(DSO,nSO*iPrim*jPrim,label='DSO')

  ! Gather the elements from 1st order density / Fock matrix.

  call SOGthr(DSO,iBas,jBas,nSO,FD,n2Tri(iSmLbl),iSmLbl,iCmp,jCmp,iShell,jShell,AeqB,iAO,jAO)

  ! Project the Fock/1st order density matrix in AO
  ! basis on to the primitive basis.

  if (iPrint >= 99) then
    call RecPrt(' Left side contraction',' ',Shells(iShll)%pCff,iPrim,iBas)
    call RecPrt(' Right side contraction',' ',Shells(jShll)%pCff,jPrim,jBas)
  end if

  ! Transform IJ,AB to J,ABi
  call DGEMM_('T','T',jBas*nSO,iPrim,iBas,One,DSO,iBas,Shells(iShll)%pCff,iPrim,Zero,DSOp,jBas*nSO)
  ! Transform J,ABi to AB,ij
  call DGEMM_('T','T',nSO*iPrim,jPrim,jBas,One,DSOp,jBas,Shells(jShll)%pCff,jPrim,Zero,DSO,nSO*iPrim)
  ! Transpose to ij,AB
  call DGeTmO(DSO,nSO,nSO,iPrim*jPrim,DSOp,iPrim*jPrim)
  call mma_deallocate(DSO)

  if (iPrint >= 99) call RecPrt(' Decontracted 1st order density/Fock matrix',' ',DSOp,iPrim*jPrim,nSO)

  ! Loops over symmetry operations.

  nOp(1) = NrOpr(0)
  ! VV: gcc bug: one has to use this if!
  if (nDCRR >= 1) then
    do lDCRR=0,nDCRR-1
      call OA(iDCRR(lDCRR),B,RB)
      nOp(2) = NrOpr(iDCRR(lDCRR))
      if (EQ(A,RB) .and. (.not. DiffOp)) cycle
      if (.not. DiffOp) then
        ! Use the translational invariance to reduce the set of
        ! gradients to compute
        do iCar=1,3
          if (IfGrad(iCar,1) .and. IfGrad(iCar,2)) then
            IfGrad(iCar,2) = .false.
            IndGrd(iCar,2) = -IndGrd(iCar,2)
          end if
        end do
      end if

      if (iPrint >= 49) then
        write(u6,'(10A)') ' {M}=(',(ChOper(iStabM(i)),i=0,nStabM-1),')'
      end if

      llOper = lOper(1)
      do iComp=2,nComp
        llOper = ior(llOper,lOper(iComp))
      end do
      call SOS(iStabO,nStabO,llOper)
      call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

      ! Compute normalization factor due the DCR symmetrization
      ! of the two basis functions and the operator.

      iuv = dc(mdci)%nStab*dc(mdcj)%nStab
      FactNd = real(iuv*nStabO,kind=wp)/real(nIrrep**2*LmbdT,kind=wp)
      if (MolWgh == 1) then
        FactNd = FactNd*real(nIrrep**2,kind=wp)/real(iuv,kind=wp)
      else if (MolWgh == 2) then
        FactNd = sqrt(real(iuv,kind=wp))*real(nStabO,kind=wp)/real(nIrrep*LmbdT,kind=wp)
      end if

      if (iPrint >= 49) then
        write(u6,'(A,/,2(3F6.2,2X))') ' *** Centers A, RB ***',(A(i),i=1,3),(RB(i),i=1,3)
      end if

      ! Desymmetrize the matrix with which we will
      ! contracte the trace.

      call DesymD(iSmLbl,iAng,jAng,iCmp,jCmp,iShell,jShell,iShll,jShll,iAO,jAO,DAO,iPrim,jPrim,DSOp,nSO,nOp,FactNd)

      ! Project the spherical harmonic space onto the
      ! cartesian space.

      kk = niAng*njAng
      if (Shells(iShll)%Transf .or. Shells(jShll)%Transf) then

        ! ---ij,AB --> AB,ij
        call DGeTmO(DAO,iPrim*jPrim,iPrim*jPrim,iCmp*jCmp,Scrt1,iCmp*jCmp)
        ! ---AB,ij --> ij,ab
        call SphCar(Scrt1,iCmp*jCmp,iPrim*jPrim,Scrt2,nScr2,RSph(ipSph(iAng)),iAng,Shells(iShll)%Transf,Shells(iShll)%Prjct, &
                    RSph(ipSph(jAng)),jAng,Shells(jShll)%Transf,Shells(jShll)%Prjct,DAO,kk)
      end if
      if (iPrint >= 99) call RecPrt(' Decontracted FD in the cartesian space',' ',DAO,iPrim*jPrim,kk)

      ! Compute kappa and P.

      call Setup1(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,A,RB,Kappa,PCoor,ZI)

      ! Compute gradients of the primitive integrals and
      ! trace the result.

      call Kernel(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,Zeta,ZI,Kappa,Pcoor,Fnl,iPrim*jPrim,iAng,jAng,A,RB,nOrder,Kern, &
                  MemKer,Ccoor,nOrdOp,Grad,nGrad,IfGrad,IndGrd,DAO,mdci,mdcj,nOp,nComp,iStabM,nStabM)
      if (iPrint >= 49) call PrGrad_pcm(' In Oneel',Grad,nGrad,ChDisp,5)

    end do
  end if
  call mma_deallocate(Kern)
  call mma_deallocate(Fnl)
  call mma_deallocate(Scrt1)
  call mma_deallocate(Scrt2)
  call mma_deallocate(DAO)
  call mma_deallocate(DSOp)
  !end do
  !end do
end do

call Free_iSD()
call mma_deallocate(Zeta)
call mma_deallocate(ZI)
call mma_deallocate(Kappa)
call mma_deallocate(PCoor)

if (iPrint >= 15) call PrGrad_pcm(Label,Grad,nGrad,ChDisp,5)

return

end subroutine OneEl_g_pcm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per Ake Malmqvist                                *
*               1992, Roland Lindh                                     *
************************************************************************
       Subroutine SetHer(nDiff)
************************************************************************
*                                                                      *
* Object: to setup the roots and weights of the Hermite polynomials    *
*         for the evaluation of one electron integrals.                *
*                                                                      *
*    Authors: Per-Ake Malmqvist and Roland Lindh,                      *
*             March 1992.                                              *
************************************************************************
      use Her_RW
      use Sizes_of_Seward, only: S
      Implicit Real*8 (A-H,O-Z)
#include "stdalloc.fh"
#include "real.fh"
#include "status.fh"
      Real*8, Dimension(:), Allocatable :: Beta, BInv, Herm
*
      If (nPrp.gt.nPrpMx) Then
         Write (6,*) 'nPrp, nPrpMx=',nPrp, nPrpMx
         Call WarningMessage(2,'SetHer: nPrp too large!')
         Call Abend()
      End If
*
*
*     1) Hermite-Gauss
*     2) Rys-Gauss (asymtotic formula)
*
      n_1111 = (2*S%iAngMx+nPrp+2+nDiff)/2
      n_2222 = 4*S%iAngMx+2+nDiff
*
      If (Allocated(HerR) .and. Max(n_1111,n_2222).le.MaxHer) Then
         Return
      Else If (Allocated(HerR)) Then
         Call Free_HerRW()
      End If
      MaxHer = Max(n_1111,n_2222)
      Call mma_allocate(iHerR,MaxHer,label='iHerR')
      Call mma_allocate(iHerW,MaxHer,label='iHerW')
*
*     Set up square of roots and weights for Hermite polynomials
*
      nMem = (MaxHer*MaxHer+MaxHer)/2
      Call mma_Allocate(HerR,nMem,label='HerR')
      iHerR(1)=1
      Call dCopy_(nMem,[0.0d0],0,HerR,1)
      Call mma_allocate(HerW,nMem,label='HerW')
      iHerW(1)=1
      Call dCopy_(nMem,[0.0d0],0,HerW,1)
      Call mma_allocate(Beta,MaxHer,label='Beta')
      Call dCopy_(MaxHer,[0.0d0],0,Beta,1)
      Call mma_allocate(BInv,MaxHer,label='BInv')
      Call dCopy_(MaxHer,[0.0d0],0,BInv,1)
      Call mma_allocate(Herm,MaxHer+1,label='Herm')
      Call dCopy_(MaxHer+1,[0.0d0],0,Herm,1)
      DO 10 K=1,MaxHer
        b_1111 = HALF*DBLE(K)
        B=SQRT(b_1111)
        Beta(K)=B
        BInv(K)=1.0d0/B
  10  CONTINUE
      HerR(iHerR(1))=0.0d0
      HerR(iHerR(1)+2)=SQRT(HALF)
      HerR(iHerR(1)+1)=-HerR(iHerR(1)+2)
      HerW(iHerW(1))=SQRT(PI)
      HerW(iHerW(1)+1)=HerW(iHerW(1))*HALF
      HerW(iHerW(1)+2)=HerW(iHerW(1)+1)
      Herm(1)=1.0d0/SQRT( HerW(iHerW(1)) )
      Do 11 iHer = 2, MaxHer
        i_1111 = (iHer*iHer-iHer)/2
        iHerR(iHer) = iHerR(1) + i_1111
        iHerW(iHer) = iHerW(1) + i_1111
 11   Continue
*
      Alpha = BInv(1)
      DO 2000 IDEG=3,MaxHer
        i_0000 = (IDEG*IDEG-IDEG)/2
        IR=iHerR(1)-1+i_0000
        IW=iHerW(1)-1+i_0000
        IDH=IDEG/2
        i_1111 = IR+IDH+1
        i_3333 = i_1111-IDEG
        w_3333 = HerR(i_3333)
        i_2222 = i_3333+1
        w_2222 = HerR(i_2222)
        X=(w_2222-w_3333)/2.0d0
        HerR(i_1111)=0.0d0
        DO 20 IROOT=2,IDEG,2
          j_0000 = IROOT/2
          j_1111 = IR+j_0000
          j_2222 = IR-IDEG+1+j_0000
          j_3333 = IR+IDEG+1-j_0000
          R =  HerR(j_2222)-X
          HerR(j_1111) = R
          HerR(j_3333) = -R
  20    CONTINUE
        DO 1000 IROOT=1,IDH
          j_0000 = IR+IROOT
          Z = HerR(j_0000)
          CORR = 0.0d0
          Do j = 1,ideg
            If ( j.ne.iroot ) then
              c_0000 = Z-HerR(IR+J)
              CORR=CORR+(1.0d0/c_0000)
            End If
          End Do
  99      CONTINUE
          Herm(2)=Z*Herm(1)*Alpha
          DO 110 K=1,IDEG-1
            w_1111 = Herm(K+1)
            w_3333 = Herm(K)
            w_4444 = Beta(K)
            w_5555 = BInv(K+1)
            w_2222 = (Z*w_1111-w_4444*w_3333)*w_5555
            Herm(K+2) = w_2222
 110      CONTINUE
          HDER=2.0d0*Beta(IDEG)*Herm(IDEG)
          DELTA=-Herm(IDEG+1)/(HDER-CORR*Herm(IDEG+1))
          Z=Z+DELTA
          IF(ABS(DELTA).GT.1.0d-8) then
             if(abs(DELTA).gt.1.0d8) then
                Call WarningMessage(1,'Warning: large value in sether')
c               write(6,*) delta
              endif
              goto 99
             endif
          HerR(IR+IROOT)=Z
          HerR(IR+IDEG+1-IROOT)=-Z
 1000   CONTINUE
        DO 3010 IROOT=1,IDH+1
          j_0000 = IR+IROOT
          Z = HerR(j_0000)
          Herm(2)=Z*Herm(1)*Alpha
          SUM=Herm(1)**2
          SUM=SUM+Herm(2)**2
          DO 3020 K=1,IDEG-2
            w_1111 = Herm(K+1)
            w_3333 = Herm(K)
            w_4444 = Beta(K)
            w_5555 = BInv(K+1)
            w_2222 = (Z*w_1111-w_4444*w_3333)*w_5555
            Herm(K+2) = w_2222
            SUM=SUM+w_2222*w_2222
 3020     CONTINUE
          W = 1.0d0/SUM
          HerW(IW+IROOT) = W
          HerW(IW+IDEG+1-IROOT) = W
 3010   CONTINUE
 2000 CONTINUE
      Call mma_deallocate(Beta)
      Call mma_deallocate(BInv)
      Call mma_deallocate(Herm)
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call TriPrt(' Hermite roots',' ',HerR(iHerR(1)),MaxHer)
      Call TriPrt(' Hermite weights',' ',HerW(iHerW(1)),MaxHer)
      Write (6,*) ' MaxHer=',MaxHer,nPrp,S%iAngMx
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Gerardo Raggi                                    *
************************************************************************
      module kriging_mod

      implicit none
!
!     Define and initiate Kriging parameters.
!
      Logical :: Kriging = .False.
      Integer :: nspAI = 1
      Logical :: anMd = .True.
      Real*8  :: pAI = 2
      Real*8  :: lb(3) = [20.0D0, 20.0D0, 1.0D0]
      Integer :: Max_MicroIterations = 50
      Real*8  :: Thr_MicroIterations = 1.0D-8
      Logical :: blAI = .False.
      Logical :: mblAI = .False.
      Logical :: blaAI = .True.
      Real*8  :: blavAI=10.0D0
      Logical :: set_l=.False.
      Logical :: ordinary=.False.
      Real*8  :: blvAI
*
!     Memory for coordinates, value and gradients of the
!     sample points.
!
      real*8, allocatable, protected :: x(:,:), y(:), dy(:)
!
!     Inter_save: the dimension of the coordinate vector
!     nPoints_v: the total number of sample points for which the value is
!                used
!     nPoinst_g: the total number of sample points for which the
!                gradients are used
!
!     We will assume that nPoints_v >= nPoints_g
!
      integer, protected :: nInter = 0 , nPoints = 0, nD=0

      real*8, allocatable ::
     &        rl(:,:), dl(:), full_Rinv(:,:),
     &        full_R(:,:), x0(:), Kv(:),
     &        cv(:,:,:), cvg(:,:,:),cvh(:,:,:,:),
     &        Rones(:), l(:),
     &        gpred(:), hpred(:,:), ll(:),
     &        cvMatFder(:), cvMatSder(:), cvMatTder(:)
      real*8 :: pred, sigma, var
      real*8 :: sb, variance, detR, lh, sbO, sbmev
      real*8, parameter :: h = 1e-5, eps = 1e-13, eps2 = 1e-10
! eps avoid to become singular in 1st der & eps2 in 2nd der
      integer :: prev_ns, m_t, counttimes

      contains

      Subroutine Setup_Kriging(nPoints_In,nD_In,nInter_In,x_,dy_,y_)
#include "stdalloc.fh"
      integer :: nPoints_In, nD_In, nInter_In, i, j
      real*8 ::  x_(nInter_In,nPoints_In)
      real*8 ::         y_(nPoints_In)
      real*8 :: dy_(nInter_In,nPoints_In)

      nInter = nInter_In
      nD           = nD_In
      nPoints      = nPoints_In

      Call mma_Allocate(x,nInter,nPoints,Label="x")
      Call mma_Allocate(y,nPoints,Label="y")
      Call mma_Allocate(dy,nInter*(nPoints-nD),Label="dy")

!x is the n-dimensional internal coordinates
      x(:,:) = x_(:,:)
      ! write(6,*) 'x',x
!y is the energy
      y(:) = y_(:)
      ! write(6,*) 'y',y
!dy it's a vector of Grad-y (eq. (5)  ref. gradients of
! the energy with respect to the internal coordinates
!
!     Note the storage as subblocks of the same component of the
!     gradient, each subblock running over all nPoints_g which
!     contributes with gradient values.
!
!     At this point we also skip those gradients which we will not use in
!     the kriging.
!
      do i=1,nInter
        do j=1,nPoints-nD
          dy(j + (i-1)*(nPoints-nD)) = dy_(i,j+nD)
        enddo
      enddo

      return
      end subroutine Setup_kriging

      end module kriging_mod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1998, Roland Lindh                      *
!               1990, IBM                                              *
!***********************************************************************

subroutine Drv2El(Integral_WrOut,ThrAO)
!***********************************************************************
!                                                                      *
!  Object: driver for two-electron integrals.                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Modified for k2 loop. August '91                         *
!             Modified to minimize overhead for calculations with      *
!             small basis sets and large molecules. Sept. '93          *
!             Modified driver. Jan. '98                                *
!***********************************************************************

use iSD_data, only: iSD
use Basis_Info, only: dbsc
use Gateway_Info, only: CutInt
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Eight
use Definitions, only: wp, iwp

implicit none
external :: Integral_WrOut
real(kind=wp), intent(in) :: ThrAO
real(kind=wp) :: A_int, Disc, Dix_Mx, ExFac(1), P_Eff, PP_Count, PP_Eff, PP_Eff_delta, S_Eff, ST_Eff, T_Eff, TCpu1, TCpu2, Thize, &
                 TMax_all, TskCount, TskHi, TskLw, TWall1, Twall2
integer(kind=iwp) :: iCnttp, ijS, iOpt, iS, iTOffs(8,8,8), jCnttp, jS, kCnttp, klS, kS, lCnttp, lS, nij, Nr_Dens, nSkal
logical(kind=iwp) :: Verbose, Indexation, FreeK2, W2Disc, PreSch, DoIntegrals, DoFock, DoGrad, FckNoClmb(1), FckNoExch(1), &
                     Triangular
character(len=72) :: SLine
real(kind=wp), allocatable :: Dens(:), Fock(:), TInt(:), TMax(:,:)
integer(kind=iwp), parameter :: nTInt = 1, mDens = 1
integer(kind=iwp), allocatable :: Pair_Index(:,:)
logical(kind=iwp), external :: Rsv_GTList

!                                                                      *
!***********************************************************************
!                                                                      *
SLine = 'Computing 2-electron integrals'
call StatusLine(' Seward:',SLine)
!                                                                      *
!***********************************************************************
!                                                                      *
ExFac = One
Nr_Dens = 1
DoIntegrals = .true.
DoFock = .false.
DoGrad = .false.
FckNoClmb = .false.
FckNoExch = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Basis_Mode('Valence')
call Setup_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize for 2-electron integral evaluation. Do not generate
! tables for indexation.

Indexation = .false.
call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
!                                                                      *
!***********************************************************************
!                                                                      *
Thize = Zero               ! Not used for conventional integrals
PreSch = .true.            ! Not used for conventional integrals

Disc = Zero
Dix_Mx = Zero
TskHi = Zero
TskLw = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute entities for prescreening at shell level

call mma_allocate(TMax,nSkal,nSkal)
call Shell_MxSchwz(nSkal,TMax)
TMax_all = Zero
do iS=1,nSkal
  do jS=1,iS
    TMax_all = max(TMax_all,TMax(iS,jS))
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Create list of non-vanishing pairs

call mma_allocate(Pair_Index,2,nSkal*(nSkal+1)/2)
nij = 0
do iS=1,nSkal
  do jS=1,iS
    if (TMax_All*TMax(iS,jS) >= CutInt) then
      nij = nij+1
      Pair_Index(1,nij) = iS
      Pair_Index(2,nij) = jS
    end if
  end do
end do
P_Eff = real(nij,kind=wp)
!                                                                      *
!***********************************************************************
!                                                                      *
Triangular = .true.
call Init_TList(Triangular,P_Eff)
call Init_PPList()
call Init_GTList()
iOpt = 0

PP_Eff = P_Eff**2
PP_Eff_delta = 0.1_wp*PP_Eff
PP_Count = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TCpu1,TWall1)

! big loop over individual tasks distributed over individual nodes

do
  ! make reservations of a tesk in global task list and get task range
  ! in return. Function will be false if no more tasks to execute.
  if (.not. Rsv_GTlist(TskLw,TskHi,iOpt,W2Disc)) exit
  W2Disc = .false.

  ! Now do a quadruple loop over shells

  ijS = int((One+sqrt(Eight*TskLw-Three))/Two)
  iS = Pair_Index(1,ijS)
  jS = Pair_Index(2,ijS)
  klS = int(TskLw-real(ijS,kind=wp)*(real(ijS,kind=wp)-One)/Two)
  kS = Pair_Index(1,klS)
  lS = Pair_Index(2,klS)
  TskCount = TskLw

  do while (TskCount-TskHi <= 1.0e-10_wp)

    ! Logic to avoid computing integrals in a mixed muonic and
    ! electronic basis.

    iCnttp = iSD(13,iS)
    jCnttp = iSD(13,jS)
    if (dbsc(iCnttp)%fMass == dbsc(jCnttp)%fMass) then
      kCnttp = iSD(13,kS)
      lCnttp = iSD(13,lS)
      if (dbsc(kCnttp)%fMass == dbsc(lCnttp)%fMass) then

        S_Eff = real(ijS,kind=wp)
        T_Eff = real(klS,kind=wp)
        ST_Eff = S_Eff*(S_Eff-One)/Two+T_Eff
        if (ST_Eff >= PP_Count) then
          write(SLine,'(A,F5.2,A)') 'Computing 2-electron integrals,',ST_Eff/PP_Eff*100.0_wp,'% done so far.'
          call StatusLine(' Seward:',SLine)
          PP_Count = PP_Count+PP_Eff_delta
        end if

        A_int = TMax(iS,jS)*TMax(kS,lS)
        if (A_Int >= CutInt) then
          ! from Dens are dummy arguments
          call mma_allocate(TInt,nTInt,label='TInt')
          call mma_allocate(Dens,mDens,label='Dens')
          call mma_allocate(Fock,mDens,label='Fock')
          call Eval_Ints_New_Inner(iS,jS,kS,lS,TInt,nTInt,iTOffs,Integral_WrOut,Dens,Fock,mDens,ExFac,Nr_Dens,FckNoClmb,FckNoExch, &
                                   Thize,W2Disc,PreSch,Dix_Mx,Disc,TskCount,DoIntegrals,DoFock)
          call mma_deallocate(TInt)
          call mma_deallocate(Dens)
          call mma_deallocate(Fock)
        end if
      end if
    end if
    TskCount = TskCount+One
    if (TskCount-TskHi > 1.0e-10_wp) exit
    klS = klS+1
    if (klS > ijS) then
      ijS = ijS+1
      klS = 1
    end if
    iS = Pair_Index(1,ijS)
    jS = Pair_Index(2,ijS)
    kS = Pair_Index(1,klS)
    lS = Pair_Index(2,klS)
  end do

  ! Use a time slot to save the number of tasks and shell
  ! quadrupltes process by an individual node
  call SavStat(1,One,'+')
  call SavStat(2,TskHi-TskLw+One,'+')
end do
! End of big task loop
call CWTime(TCpu2,TWall2)
call SavTim(1,TCpu2-TCpu1,TWall2-TWall1)
!                                                                      *
!***********************************************************************
!                                                                      *
!                         E P I L O G U E                              *
!                                                                      *
!***********************************************************************
!                                                                      *
call Free_GTList()
call Free_PPList()
call Free_TList()

call mma_deallocate(Pair_Index)
call mma_deallocate(TMax)
!                                                                      *
!***********************************************************************
!                                                                      *
! Terminate integral environment.

Verbose = .false.
FreeK2 = .true.
call Term_Ints(Verbose,FreeK2)
call Free_iSD()

return

end subroutine Drv2El

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Util1(Alpha,Beta,nZeta,rFinal,la,lb,Slaplb,Slamlb,Slalbp,Slalbm)
!***********************************************************************
!                                                                      *
! Object: to assemble the electric field integrals from                *
!         derivative integrals of the electric potential.              *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             February '91                                             *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb
real(kind=wp), intent(in) :: Alpha(nZeta), Beta(nZeta), Slaplb(nZeta,nTri_Elem1(la+1),nTri_Elem1(lb)), &
                             Slamlb(nZeta,nTri_Elem1(la-1),nTri_Elem1(lb)), Slalbp(nZeta,nTri_Elem1(la),nTri_Elem1(lb+1)), &
                             Slalbm(nZeta,nTri_Elem1(la),nTri_Elem1(lb-1))
real(kind=wp), intent(out) :: rFinal(nZeta,3,nTri_Elem1(la),nTri_Elem1(lb))
#include "print.fh"
integer(kind=iwp) :: ib, iElem, ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyb, iza, izb, jElem
character(len=80) :: Label

iRout = 203
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  write(u6,*) ' In Util1 la,lb=',la,lb
  call RecPrt('Alpha',' ',Alpha,nZeta,1)
  call RecPrt('Beta',' ',Beta,nZeta,1)
  do ib=1,nTri_Elem1(lb)
    write(Label,'(A,I2,A)') ' Slaplb(la,',ib,')'
    call RecPrt(Label,' ',Slaplb(:,:,ib),nZeta,nTri_Elem1(la+1))
  end do
  if (la > 0) then
    do ib=1,nTri_Elem1(lb)
      write(Label,'(A,I2,A)') ' Slamlb(la,',ib,')'
      call RecPrt(Label,' ',Slamlb(:,:,ib),nZeta,nTri_Elem1(la-1))
    end do
  end if
  do ib=1,nTri_Elem1(lb+1)
    write(Label,'(A,I2,A)') ' Slalbp(la,',ib,')'
    call RecPrt(Label,' ',Slalbp(:,:,ib),nZeta,nTri_Elem1(la))
  end do
  if (lb > 0) then
    do ib=1,nTri_Elem1(lb-1)
      write(Label,'(A,I2,A)') ' Slalbm(la,',ib,')'
      call RecPrt(Label,' ',Slalbm(:,:,ib),nZeta,nTri_Elem1(la))
    end do
  end if
end if

do ixa=la,0,-1
  do iya=la-ixa,0,-1
    iza = la-ixa-iya
    ipa = C_Ind(la,ixa,iza)

    do ixb=lb,0,-1
      do iyb=lb-ixb,0,-1
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        if ((ixa /= 0) .and. (ixb /= 0)) then
          rFinal(:,1,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa+1,iza),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb))- &
                                real(ixa,kind=wp)*Slamlb(:,C_Ind(la-1,ixa-1,iza),ipb)- &
                                real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb))
        else if (ixa /= 0) then
          rFinal(:,1,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa+1,iza),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb))- &
                                real(ixa,kind=wp)*Slamlb(:,C_Ind(la-1,ixa-1,iza),ipb)
        else if (ixb /= 0) then
          rFinal(:,1,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa+1,iza),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb))- &
                                real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb))
        else
          rFinal(:,1,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa+1,iza),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb))
        end if

        if ((iya /= 0) .and. (iyb /= 0)) then
          rFinal(:,2,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa,iza),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb))- &
                                real(iya,kind=wp)*Slamlb(:,C_Ind(la-1,ixa,iza),ipb)- &
                                real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb))
        else if (iya /= 0) then
          rFinal(:,2,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa,iza),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb))- &
                                real(iya,kind=wp)*Slamlb(:,C_Ind(la-1,ixa,iza),ipb)
        else if (iyb /= 0) then
          rFinal(:,2,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa,iza),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb))- &
                                real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb))
        else
          rFinal(:,2,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa,iza),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb))
        end if

        if ((iza /= 0) .and. (izb /= 0)) then
          rFinal(:,3,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa,iza+1),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1))- &
                                real(iza,kind=wp)*Slamlb(:,C_Ind(la-1,ixa,iza-1),ipb)- &
                                real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1))
        else if (iza /= 0) then
          rFinal(:,3,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa,iza+1),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1))- &
                                real(iza,kind=wp)*Slamlb(:,C_Ind(la-1,ixa,iza-1),ipb)
        else if (izb /= 0) then
          rFinal(:,3,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa,iza+1),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1))- &
                                real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1))
        else
          rFinal(:,3,ipa,ipb) = Two*Alpha*Slaplb(:,C_Ind(la+1,ixa,iza+1),ipb)+Two*Beta*Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1))
        end if

      end do
    end do

  end do
end do

if (iPrint >= 49) then
  write(u6,*) ' In Util1 la,lb=',la,lb
  do iElem=1,nTri_Elem1(la)
    do jElem=1,nTri_Elem1(lb)
      write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,') '
      call RecPrt(Label,' ',rFinal(:,:,iElem,jElem),nZeta,3)
    end do
  end do
end if

return

end subroutine Util1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Per-Olof Widmark                                 *
*               1993,1996,1997, Markus P. Fuelscher                    *
*               1996, Luis Serrano-Andres                              *
*               2002, Roland Lindh                                     *
*               2012, Victor P. Vysotskiy                              *
************************************************************************
      Subroutine FastIO(String)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Manage all I/O operations within the MOLCAS programs.            *
*                                                                      *
*     calling arguments:                                               *
*     String  : Character string                                       *
*               Command liner. Known commands are                      *
*               TRACE  : enable/disable trace output                   *
*               QUERY  : enable/disable updating of the calling tree   *
*               STATUS : print I/O statistics                          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, IBM Sweden, 1991                                   *
*     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
*     L. Serrano-Andres, University of Lund, Sweden, 1996              *
*                                                                      *
*     Modified to MB, by RL June, 2002, in Tokyo, Japan.               *
*     New I/O Stat, V.P. Vysotskiy, University of Lund, Sweden, 2012   *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

#include "fio.fh"
#ifdef _OLD_IO_STAT_
#include "ofio.fh"
#else
#include "pfio.fh"
#endif
#include "blksize.fh"
#include "SysDef.fh"

      Character*(*) String

      Real*8 tot_Rec_in,tot_Rec_out,file_size
      Real*8 tot_MB_in,tot_MB_out
#ifdef _OLD_IO_STAT_
      Real*8 Rec_in,Rec_out,MB_in,MB_out
#else
      Real*8  tot_Time_out,tot_Time_in,rwr,rrd
#endif
      Character*100 Fmt
      lString=len(String)
      if(lString.ge.8) then
*     Enable/disable tracing output
      If ( String(1:8).eq.'TRACE=ON' ) Trace=.true.
      If ( String(1:9).eq.'TRACE=OFF' ) Trace=.false.

*     Enable/disable updating of the calling tree
*     (This option may become very expensive in production runs!)
      If ( String(1:8).eq.'QUERY=ON' ) Query=.true.
      If ( String(1:9).eq.'QUERY=OFF' ) Query=.false.
      endif
*     Print I/O statistics
      If ( String(1:6).eq.'STATUS'.and.iPrintLevel(-1).ge.3) then
#ifdef _OLD_IO_STAT_

         Call CollapseOutput(1,'I/O statistics')
         Write (6,'(3X,A)')    '--------------'
         Write (6,'(1X,A)')
         Write (6,'(1X,A)') ' Unit  Name          Xtent      pages     '
     &                    //' MBytes     pages      MBytes'
         Write (6,'(1X,A)') '                    (MBytes)     in       '
     &                    //'   in        out        out  '
         Write (6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - - -'
     &                    //' - - - - - - - - - - - - - -'
         tot_Rec_in  = 0.0d0
         tot_Rec_out = 0.0d0
         tot_MB_in   = 0.0d0
         tot_MB_out  = 0.0d0
         Do i = 1,MxFile
           If ( FSCB(i).ne.0 ) then
             Rec_in  = Count(1,i)/1024.0d0
             Rec_out = Count(3,i)/1024.0d0
             MB_in   = Count(2,i)/1024.0d0
             MB_out  = Count(4,i)/1024.0d0
             tot_Rec_in  = tot_Rec_in  + Rec_in
             tot_Rec_out = tot_Rec_out + Rec_out
             tot_MB_in   = tot_MB_in   + MB_in
             tot_MB_out  = tot_MB_out  + MB_out
*            min_Block_length was undefined long ago...
             file_size   = (DBLE(MxAddr(i))*DBLE(min_Block_length))
     &                   / (1024.0d0)**2
             Write(6,'(2X,I2,3X,A8,1X,5F11.2)')
     &         i,LuName(i),file_size,
     &         Rec_in, MB_in, Rec_out, MB_out
           End If
         End Do
         Write (6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - - -'
     &                    //' - - - - - - - - - - - - - -'
         Write(6,'(1X,A,20X,4F11.2)') ' Total',
     &                              tot_Rec_in,tot_MB_in,
     &                              tot_Rec_out,tot_MB_out
         Write (6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - - -'
     &                    //' - - - - - - - - - - - - - -'
         Call CollapseOutput(0,'I/O statistics')
#else
        tot_Rec_in  = 0.0d0
        tot_Rec_out = 0.0d0
        tot_MB_in   = 0.0d0
        tot_MB_out  = 0.0d0
        tot_Time_in = 0.0d0
        tot_Time_out= 0.0d0
        file_size   = 0.0d0
        Call CollapseOutput(1,'I/O STATISTICS')

CPart I: general I/O information
        Write (6,*) ''
        Write (6,'(1X,A)')' I. General I/O information'
        Write (6,'(1X,A)')' - - - - - - - - - - - - - - - - - - - - - -'
     &                  //' - - - - - - - - - - - - - - - - - - - - -'
        Write (6,'(1X,A)')' Unit  Name          Flsize      Write/Read '
     &                  //'           MBytes           Write/Read'
        Write (6,'(1X,A)')'                     (MBytes)       Calls   '
     &                  //'           In/Out           Time, sec.'
        Write (6,'(1X,A)')' - - - - - - - - - - - - - - - - - - - - - -'
     &                  //' - - - - - - - - - - - - - - - - - - - - -'

        Do i = 1, NProfFiles

           tot_Rec_in  =tot_Rec_in  + PRofData(1,i)
           tot_Rec_out =tot_Rec_out + PRofData(4,i)
           tot_MB_in   =tot_MB_in   + PRofData(2,i)
           tot_MB_out  =tot_MB_out  + PRofData(5,i)
           tot_Time_in =tot_Time_in + PRofData(3,i)
           tot_Time_out=tot_Time_out+ PRofData(6,i)
           file_size   =file_size   + FlsSize(i)

           Fmt='(2X,I2,2X,A8,3X,F11.2,A2,I8,A1,I8,A2,F9.1,A1,F9.1,'//
     &         'A2,I8,A1,I8)'
           Write(6,Fmt)
     &     i,LuNameProf(i),FlsSize(i)/1024.d0/1024.d0,' .',
     &     INT(PRofData(1,i)),'/',INT(PRofData(4,i)),' .',
     &     PRofData(2,i)/1024**2,'/',PRofData(5,i)/1024**2,
     &     ' .', INT(PRofData(3,i)),'/',INT(PRofData(6,i))
        End Do
        Write (6,'(1X,A)')' - - - - - - - - - - - - - - - - - - - - - -'
     &                  //' - - - - - - - - - - - - - - - - - - - - -'

        Fmt='(2X,A10,5X,F11.2,A2,I8,A1,I8,A2,F9.1,A1,F9.1,A2,I8,A1,I8)'
        Write(6,Fmt)
     &  '*  TOTAL ',file_size/1024.d0/1024.d0,' .',
     &  INT(tot_Rec_in),'/',INT(tot_Rec_out),' .',
     &  tot_MB_in/1024**2,'/',tot_MB_out/1024**2,
     &  ' .', INT(tot_Time_in),'/',INT(tot_Time_out)
        Write (6,'(1X,A)')' - - - - - - - - - - - - - - - - - - - - - -'
     &                  //' - - - - - - - - - - - - - - - - - - - - -'

CPart II: a little bit more about I/O Access Patterns
C Percentage of write/read activity that was random writes/reads.
        Write (6,*) ''
        Write (6,'(1X,A)')' II. I/O Access Patterns'
        Write (6,'(1X,A)')' - - - - - - - - - - - - - - - - - - - -'
        Write (6,'(1X,A)')' Unit  Name               % of random'
        Write (6,'(1X,A)')'                        Write/Read calls'
        Write (6,'(1X,A)')' - - - - - - - - - - - - - - - - - - - -'
        Do i = 1, NProfFiles

           If(PRofData(1,i).gt.0) Then
             rwr=100*PRofData(7,i)/PRofData(1,i)
           Else
             rwr=0.d0
           End If

           If(PRofData(4,i).gt.0) Then
             rrd=100*PRofData(8,i)/PRofData(4,i)
           Else
             rrd=0.d0
           End If

           Write(6,'(2X,I2,2X,A8,7X,F9.1,A1,F6.1)')
     &     i,LuNameProf(i), rwr,'/', rrd

        End Do
        Write (6,'(1X,A)')' - - - - - - - - - - - - - - - - - - - -'
        Call CollapseOutput(0,'I/O STATISTICS')
#endif
      End If

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Legacy code that is not used by current LAPACK but could be "needed"
! by other libraries. Define here just as dummy procedures
!
! If you modify this, the files f[1-5].fh should be updated too, use delayed.py

module LEGACY_MOD

use Definitions, only: BLASInt, BLASR8

implicit none
private

public :: dgetf2, dpotf2

contains

subroutine dgetf2(m,n,a,lda,ipiv,info)
  implicit none
  integer(kind=BLASInt) :: info, lda, m, n
  integer(kind=BLASInt) :: ipiv(*)
  real(kind=BLASR8) :: a(lda,*)
end subroutine dgetf2

subroutine dpotf2(uplo,n,a,lda,info)
  implicit none
  character :: uplo
  integer(kind=BLASInt) :: info, lda, n
  real(kind=BLASR8) :: a(lda,*)
end subroutine dpotf2

end module LEGACY_MOD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine prepare_decay()
! energy and time should fullfill relation delta_E*delta_t=h
! construct the decay in SOC states basis sets

use rhodyn_data, only: basis, CSF2SO, decay, flag_decay, flag_dyson, ion_diss, ipglob, ispin, N, N_L3, nconf, Nstate, Nval, SO_CI, &
                       tau_L2, tau_L3, tmp, U_CI_compl
use rhodyn_utils, only: mult, dashes
use Constants, only: Zero, cZero, pi
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i, j, k, ii
logical(kind=iwp), parameter :: ion_blocks(5) = [.true.,.false.,.true.,.false.,.true.]

if (ipglob > 3) write(u6,*) 'Begin of prepare_decay'

decay(:,:) = cZero
! Auger decay
if (flag_decay) then
  do i=Nval+1,Nval+N_L3
    decay(i,i) = -tau_L3/2/pi
  end do
  do i=Nval+N_L3+1,Nstate
    decay(i,i) = -tau_L2/2/pi
  end do
  if (basis == 'CSF') then
    call mult(CSF2SO,decay,tmp)
    call mult(tmp,CSF2SO,decay,.false.,.true.)
  else if (basis == 'SF') then
    call mult(SO_CI,decay,tmp)
    call mult(tmp,SO_CI,decay,.false.,.true.)
  end if
end if

! ionization
if (flag_dyson .and. (ion_diss /= Zero)) then
  ii = 1
  do k=1,N
    do i=ii,(ii+nconf(k)*ispin(k)-1)
      if (ion_blocks(k)) decay(i,i) = decay(i,i)-ion_diss
    end do
    ii = ii+nconf(k)*ispin(k)
  end do
  if (basis == 'CSF') then
    call mult(U_CI_compl,decay,tmp)
    call mult(tmp,U_CI_compl,decay,.false.,.true.)
  else if (basis == 'SO') then
    call mult(SO_CI,decay,tmp,.true.,.false.)
    call mult(tmp,SO_CI,decay)
  end if
end if

!!!!!!!!!!
if (ipglob > 4) then
  call dashes()
  write(u6,*) 'Decay matrix'
  do i=1,Nstate
    write(u6,*) (decay(i,j),j=1,Nstate)
  end do
  call dashes()
end if
!!!!!!!!!!

if (ipglob > 3) write(u6,*) 'End of prepare_decay'

end subroutine prepare_decay

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Hidden(mTtAtm,ipCoor,ipAN,nHidden,rHidden,nMDstep)
      Implicit Real*8 (a-h,o-z)
*
*  Add to the Grand atom list some hidden atoms, coming e.g.
*  from the MM part of a QM/MM system
*
#include "Molcas.fh"
#include "angstr.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "periodic_table.fh"
      Logical Do_ESPF,Exist,Exist2
      Character*180 Line
      Character*180 Get_Ln
      External Get_Ln
      Dimension XYZ(3)
      Character*2 Symbol
*
      iPL = iPrintLevel(-1)
*     iPL=99
*
*#define _DEBUGPRINT_
*
#ifdef _DEBUGPRINT_
      iPL = 4
#endif
      nMDstep = 0
      iHidden = 0
      Do_ESPF = .False.
*
*  Is there a ESPF/QMMM file ?
*
      Call DecideOnESPF(Do_ESPF)
      If (Do_ESPF) Then
*
*        Try MM atoms from Tinker QM/MM interface file
*
         Call F_Inquire('QMMM',Exist)
         If (Exist) Then
            ITkQMMM=IsFreeUnit(25)
            Call Molcas_Open(ITkQMMM,'QMMM')
            Line = ' '
            Do While (Index(Line,'TheEnd ') .eq. 0)
               Line=Get_Ln(ITkQMMM)
*
*  Read the maximum number of MM atoms + some temporary arrays allocation
*
               If (Index(Line,'NMM').ne.0) Then
                  Call Get_I1(2,nHidden)
                  If (iPL.gt.3) Write(6,'(A,I5,A)')'Found ',nHidden,
     &                                    ' hidden atoms.'
                  If(nHidden.gt.0) Then
                     Call Allocate_Work(ip_h_xyz,3*nHidden)
                     Call Allocate_iWork(ip_h_AN,nHidden)
                     Do iHidden = 0, nHidden-1
                        Line=Get_Ln(ITkQMMM)
                        If (Index(Line,'MMCoord').eq.0) Then
                           Write(6,*) 'Error in hidden.',
     &                      ' Last line does not start with MMCoord:'
                           Write(6,*) Line
                           Call Quit_onUserError()
                        End If
                        Call Get_I1(2,iAtNum)
                        iWork(ip_h_AN+iHidden) = -iAtNum
                        Call Get_F(3,XYZ,3)
                        Work(ip_h_xyz+3*iHidden  ) = XYZ(1)/Angstr
                        Work(ip_h_xyz+3*iHidden+1) = XYZ(2)/Angstr
                        Work(ip_h_xyz+3*iHidden+2) = XYZ(3)/Angstr
                     End Do
                  End If
               Else If (Index(Line,'MD ').ne.0) Then
                  Call Get_I1(2,nMDstep)
               End If
            End Do
            Close (ITkQMMM)
         End If
*
*        Try outer MM atoms stored on runfile
*
         If (.Not.Exist) Then
            Call Qpg_dArray('MMO Coords',Exist2,nHidden)
         Else
            Exist2 = .False.
         End If
         If (Exist2) Then
            nHidden=nHidden/3
            Call Allocate_Work(ip_h_xyz,3*nHidden)
            Call Allocate_iWork(ip_h_AN,nHidden)
            Call GetMem('LabMMO','ALLO','CHAR',ipLabMMO,LENIN*nHidden)
            Call Get_dArray('MMO Coords',Work(ip_h_xyz),nHidden*3)
            Call Get_cArray('MMO Labels',cWork(ipLabMMO),LENIN*nHidden)
            Do iHidden = 0, nHidden-1
               Symbol(1:1) = cWork(ipLabMMO+iHidden*LENIN)
               Symbol(2:2) = cWork(ipLabMMO+iHidden*LENIN+1)
               If (Symbol(2:2).Eq.'_') Symbol = ' '//Symbol(1:1)
               Do i = 0, Num_Elem
                  If (Ptab(i) == Symbol) Then
                     Work(ip_h_AN+iHidden) = -i
                     Exit
                  End If
               End Do
            End Do
            Call GetMem('LabMMO','FREE','CHAR',ipLabMMO,
     &                  LENIN*nHidden)
         End If
      End If
      If (iPL.gt.3) Call RecPrt('Hidden coord:',' ',Work(ip_h_xyz),3,
     &                          nHidden)
*
*  Select the hidden atoms to be kept.
*
      nKept = 0
      If (nHidden .gt. 0) Call Select_hidden(mTtAtm,nHidden,
     &                Work(ipCoor),Work(ip_h_xyz),iWork(ip_h_AN),
     &                nKept,rHidden,iPL)
*
*  Copy all the arrays needed by box and nlm
*
      If (nKept .gt. 0) Then
         If (iPL .gt. 3) Then
            Write(6,'(A8,I5,A)') 'Hidden: ',nKept,' atoms are kept.'
            If (nMDstep.gt.0) Write(6,'(8X,I5,A)') nMDstep,' mean Hess'
         End If
         mTot = mTtAtm + nKept
         Call Allocate_Work(ipCoor_h,3*mTot)
         Call Allocate_iWork(ipAN_h,mTot)
*
         Call dCopy_(3*mTtAtm,Work(ipCoor),1,Work(ipCoor_h),1)
         Call iCopy(mTtAtm,iWork(ipAN),1,iWork(ipAN_h),1)
*
*  Copy the kept hidden atom coordinates, atom numbers and masses
*
         iKept = 0
         Do iHidden = 0, (nHidden-1)
            If (iWork(ip_h_AN+iHidden) .gt. 0) Then
               Call dCopy_(3,Work(ip_h_xyz+3*iHidden),1,
     &                      Work(ipCoor_h+3*(mTtAtm+iKept)),1)
               iAN = iWork(ip_h_AN+iHidden)
               iWork(ipAN_h+mTtAtm+iKept) = iAN
               iKept = iKept + 1
            End If
         End Do
         If (iKept .ne. nKept) Then
            Write(6,'(A)') ' Hidden: wrong number of kept hidden atoms.'
            Call Quit_OnUserError()
         End If
         Call Free_Work(ip_h_xyz)
         Call Free_iWork(ip_h_AN)
         Call GetMem('Coor','Free','Real',ipCoor,3*mTtAtm)
         Call GetMem('AN','Free','Inte',ipAN,mTtAtm)
*
*  The end
*
         ipCoor  = ipCoor_h
         ipAN    = ipAN_h
*
         If (iPL .gt. 3) Then
            Call RecPrt('Hidden: Coor',' ',Work(ipCoor),3,mTot)
         End If
      End If
      nHidden = nKept
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      real*8 function  fradf(x)
************************************************************************
*                                                                      *
* Object: to compute the angular contribution to the multipole integral*
*         between continuum basis functions within an R-matrix sphere  *
*         (theta integration)                                          *
*                                                                      *
************************************************************************
      Implicit real*8 (a-h,o-z)
#include "nrmf.fh"
*
      fradf=x**(l+2)*exp(-expsum*x*x)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************
!**************************************
!** Low-level input parsing routines **
!**************************************

subroutine rdstring_cvb(string,ierr)
! Check if field is applicable:

use casvb_global, only: ifield, nfield
use Definitions, only: wp, iwp

implicit none
character(len=8), intent(inout) :: string
integer(kind=iwp), intent(out) :: ierr
integer(kind=iwp) :: idi
real(kind=wp) :: rdr

ierr = 0
if (nfield == -1) ierr = 1
if (ifield > nfield) ierr = 2
if (ierr /= 0) then
  string = '        '
else
  !call gtstring_cvb(string,ifield)
  call gtany_cvb(string,idi,rdr,1,ifield,ierr)
end if

return

end subroutine rdstring_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       SubRoutine FockGen(d_0,rDens1,rdens2,Fock,FockOut,idSym)
************************************************************************
*                                                                      *
*   Constructs active Fock matrix and Q matrix                         *
*                                                                      *
*   Input: rkappa: Rotation matrix                                     *
*          idsym : symmetry of perturbation                            *
*                                                                      *
*                                                                      *
*   Output:MO     : MO integrals                                       *
*          Fock   : Fock matrix (one index transformed integrals)      *
*          MOtilde: MO (one index transformed integrals)               *
*                                                                      *
************************************************************************

      Implicit Real*8(a-h,o-z)
#include "Pointers.fh"
#include "standard_iounits.fh"
#include "Input.fh"
#include "WrkSpc.fh"
#include "real.fh"
#include "sa.fh"
#include "dmrginfo_mclr.fh"
      Real*8 Fock(nDens2),FockOut(*), rDens2(*),rDens1(nna,nna)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      call dcopy_(nDens2,[Zero],0,Fock,1)
*
      n1=0
      Do iS = 1, nSym
        n1=Max(n1,nBas(iS))
      End Do
      n2=n1**2

      if(doDMRG)then  ! yma
        call dmrg_spc_change_mclr(RGras2(1:8),nash)
      end if

      If (newCho) Go to 15
      Call GetMem('ip_MO','Allo','Real',ip_MO,n2)
      Call GetMem('ipScr','Allo','Real',ipScr,n2)
*
      Do ipS=1,nSym
         Do kS=1,nSym
            Do iS=1,nSym
               jS=iEor(iEor(ipS-1,kS-1),iS-1)+1
*                                                                      *
************************************************************************
*                                                                      *
*              Coulomb term: F  =2(pk|ji)d
*                             kp          ij
*                                                                      *
************************************************************************
*                                                                      *
               If (iEOr(ipS-1,kS-1)+1.eq.iDsym .and.
     &             nBas(ipS)*nIsh(kS).gt.0           ) Then
                  Do iA=1,nAsh(iS)
                     iAA=iA+nIsh(iS)
                     Do jA=1,nAsh(jS)
                        jAA=jA+nIsh(jS)
*
                        Call Coul(ipS,kS,iS,jS,iAA,jAA,
     &                            Work(ip_MO),Work(ipScr))
*
                        rD=rDens1(iA+nA(iS),jA+nA(jS))*Two
                        Call DaXpY_(nBas(ipS)*nIsh(kS),rd,
     &                             Work(ip_MO),1,Fock(ipMat(ipS,Ks)),1)
*
                     End Do
                  End Do
               End If
*                                                                      *
************************************************************************
*                                                                      *
*              Exchange term: F = -(pk|ji)d
*                              pl          kj
*                                                                      *
************************************************************************
*                                                                      *
               If (iEOr(ipS-1,iS-1)+1.eq.iDsym .and.
     &             nBas(ipS).gt.0                   ) Then
                  Do iA = 1, nIsh(iS)
                     ipF=ipMat(ipS,iS)+nBas(ipS)*(iA-1)
                     Do jA=1,nAsh(jS)
                        jAA=jA+nIsh(jS)
*
                        Call Coul(ipS,kS,iS,jS,iA,jAA,
     &                            Work(ip_MO),Work(ipScr))
*
                        ipM=ip_MO+nIsh(kS)*nBas(ipS)
                        Do kA=1,nAsh(kS)
*
                           rd=rDens1(kA+nA(kS),jA+nA(jS))
                           Call DaXpY_(nBas(ipS),-rd,
     &                                Work(ipM),1,Fock(ipF),1)
                           ipM = ipM + nBas(ipS)
                        End Do
*
                     End Do
                  End Do
               End If
*                                                                      *
************************************************************************
*                                                                      *
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call CreQADD(Fock,rdens2,idsym,Work(ip_MO),Work(ipScr),n2)
      Call Free_Work(ipScr)
      Call Free_Work(ip_MO)
*
************************************************************************
*       new Cholesky code                                              *
************************************************************************
 15   Continue
      if (newCho) Then
        nVB=0
        nG2=0
        Do iSym=1,nSym
          nVB = nVB + nAsh(iSym)*nOrb(iSym)
          nAG2=0
          Do jSym=1,nSym
            kSym=iEOr(jsym-1,isym-1)+1
            nAG2=nAg2+nAsh(jSym)*nAsh(kSym)
          End Do
          nG2=nG2+nAG2**2
        End Do

*
**      Unfold 2-DM
*
        Call GetMem('G2x','ALLO','REAL',ipG2x,nG2)
        ipGx=ipG2x
        Do ijS=1,nSym
          Do iS=1,nSym
            jS=iEOR(is-1,ijS-1)+1
            Do kS=1,nSym
              lS=iEOR(kS-1,ijS-1)+1
              Do kAsh=1,nAsh(ks)
                Do lAsh=1,nAsh(ls)
c                 ikl=itri(lAsh+nA(lS),kAsh+nA(kS))
                  ikl=nna*(lAsh+nA(lS)-1)+kAsh+nA(kS)
                  Do iAsh=1,nAsh(is)
                    Do jAsh=1,nAsh(js)
c                     iij =itri(iAsh+nA(is),jAsh+nA(jS))
                      iij=nna*(jAsh+nA(jS)-1)+iAsh+nA(iS)
                      Work(ipGx)=rdens2(itri(iij,ikl))
                      ipGx=ipGx+1
                    End Do
                  End Do
                End Do
              End Do
            End Do
          End Do
        End Do
*
**      Get active CMO
*
        Call GetMem('Cva','Allo','Real',ipAsh,nVB)
        ioff=0
        ioff1=0
        Do iS=1,nSym
          ioff2 = ioff + nOrb(iS)*nIsh(iS)
          Do iB=1,nAsh(iS)
            ioff3=ioff2+nOrb(iS)*(iB-1)
            call dcopy_(nOrb(iS),Work(ipCMO+ioff3),1,
     &                Work(ipAsh+ioff1+iB-1),nAsh(iS))
          End Do
          ioff=ioff+(nIsh(iS)+nAsh(iS))*nOrb(iS)
          ioff1=ioff1+nAsh(iS)*nOrb(iS)
        End Do

*
        Call GetMem('Scr','Allo','Real',ipScr1,n2*2)
        call dcopy_(n2*2,[Zero],0,Work(ipScr1),1)
        ipScr2=ipScr1+n2
        ipDA=ip_of_work(rdens1(1,1))
        ipFock=ip_of_work(Fock(1))
*
        Call cho_fock_mclr(ipDA,ipG2x,ipScr1,ipScr2,ipFock,
     &                    [ipAsh],ipCMO,nIsh,nAsh,LuAChoVec)
*
        Call GetMem('Scr','Free','Real',ipScr1,n2*2)
        Call GetMem('Cva','Free','Real',ipAsh,nVB)
        Call GetMem('G2x','Free','REAL',ipG2x,nG2)
      EndIf
*
************************************************************************
*       Common part                                                    *
************************************************************************
*
      Do iS=1,nSym
         If (nBas(iS).gt.0) Then
            jS=iEOr(is-1,iDSym-1)+1
            Do iA=1,nAsh(is)
               Do jA=1,nAsh(js)
                  rd=rDens1(iA+nA(iS),jA+nA(js))
                  ip1=nBas(iS)*(nIsh(is)+iA-1)+ipCM(is)-1
                  ip2=nBas(iS)*(nIsh(js)+jA-1) +ipmat(is,js)
                 Call DaXpY_(nBas(iS),Rd,Work(ipFIMO+ip1),1,Fock(ip2),1)
               End Do
            End Do
         End If
      End Do

*
      If (iDsym.eq.1) Then
         Do iS=1,nSym
            If (nBas(iS)*nIsh(iS).gt.0)
     &         Call DaXpY_(nBas(iS)*nIsh(is),Two*d_0,
     &                    Work(ipFIMO+ipMat(is,is)-1),1,
     &                    Fock(ipMat(is,is)),1)
         End Do
      End If
*
      Do iS=1,nSym
         jS=iEOR(iS-1,idSym-1)+1
         If (nBas(is)*nBas(jS).ne.0)
     &      Call DGeSub(Fock(ipMat(iS,jS)),nBas(iS),'N',
     &                  Fock(ipMat(jS,iS)),nBas(jS),'T',
     &                  FockOut(ipMat(iS,jS)),nBas(iS),
     &                  nBas(iS),nBas(jS))
      End Do

*
*
      Call DScal_(nDens2,Two,FockOut,1)
      If (idSym.eq.1) Call AddGrad2(FockOut,idSym,d_0)

      if(doDMRG)then ! yma
        call dmrg_spc_change_mclr(LRras2(1:8),nash)
      end if
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Ben Swerts                                             *
!***********************************************************************

subroutine FragPGrd( &
#                   define _CALLING_
#                   include "grd_interface.fh"
                   )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of FAIEMP Projection      *
!         operator integrals.                                          *
!                                                                      *
!     Author: Ben Swerts                                               *
!                                                                      *
!     based on PrjGrd                                                  *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW
use Real_Spherical, only: ipSph, RSph
use iSD_data, only: iSD
use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Symmetry_Info, only: iOper
use Index_Functions, only: iTri, nTri_Elem1
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6, r8

implicit none
#include "grd_interface.fh"
#include "print.fh"
real(kind=wp) :: C(3), TC(3), B(3), TB(3), Fact
integer(kind=iwp) :: i, ia, iAng, ib, iBas, iCar, iCent, iCnt, iCnttp, iCurCenter, iCurCnttp, iCurMdc, iDCRT(0:7), iGamma, iLoc, &
                     ip, ipA, ipAxyz, ipB, ipBxyz, ipCxyz, ipF1, ipF1a, ipF2, ipF2a, ipIJ, ipK1, ipK2, ipP1, ipP2, ipQ1, iPrim, &
                     iPrint, ipRxyz, ipTmp, ipZ1, ipZ2, ipZI1, ipZI2, iRout, iS, iSbasis, iSEnd, iShll, iSize, iSlocal, iSstart, &
                     iStemp, iStrt, iuvwx(4), iVec, jAng, jBas, jCnt, jCnttp, JndGrd(3,4), jPrim, jS, jSbasis, jShll, jSize, &
                     jSlocal, ld, lDCRT, LmbdT, lOp(4), maxDensSize, mdci, mGrad, mVec, mVecAC, mVecCB, n_Her, nac, ncb, nDAO, &
                     nDCRT, nSkal, nVecAC, nVecCB
logical(kind=iwp) :: JfGrad(3,4), ABeq(3), EQ, EnergyWeight
character(len=80) :: Label
real(kind=r8), external :: DNrm2_
#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(nHer)

iRout = 202
iPrint = nPrint(iRout)

if (iPrint >= 49) then
  call RecPrt(' In FragPGrd: Grad',' ',Grad,1,nGrad)
  call RecPrt(' In FragPGrd: A',' ',A,1,3)
  call RecPrt(' In FragPGrd: RB',' ',RB,1,3)
  call RecPrt(' In FragPGrd: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In FragPGrd: P',' ',P,nZeta,3)
  call RecPrt(' In FragPGrd: Alpha',' ',Alpha,nAlpha,1)
  call RecPrt(' In FragPGrd: Beta',' ',Beta,nBeta,1)
  write(u6,*) ' In FragPGrd: la,lb=',' ',la,lb
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Setup the fragment shells

call Set_Basis_Mode('Fragments')
call SetUp_iSD()
call Nr_Shells(nSkal)
if (iPrint >= 99) then
  write(u6,*) 'looping over ',nSkal,' shells'
  write(u6,*) 'Shells()%Frag = ',(Shells(i)%Frag,i=1,10)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Reserve space for the largest possible fragment energy weighted
! density matrix
maxDensSize = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%nFragType > 0) maxDensSize = max(maxDensSize,dbsc(iCnttp)%nFragDens*(dbsc(iCnttp)%nFragDens+1)/2)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over all shells belonging to the fragments
nDAO = nTri_Elem1(la)*nTri_Elem1(lb)
iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
lOp(1) = iOper(kOp(1))
lOp(2) = iOper(kOp(2))

iCurMdc = 0         ! The mdc value of the current fragment placeholder
iCurCnttp = 0       ! The Cnttp of the fragment placeholder
iCurCenter = 999999 ! The index of the fragment in the fragment placeholder list of centers
iSstart = 0         ! The index into the full shells list for the first shell of a fragment
iSbasis = 0         ! The basis function index relative to the start of the fragment
iSEnd = -1          ! Dummy initialize
do iS=1,nSkal
  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  mdci = iSD(10,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  C(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

  iSize = nTri_Elem1(iAng)
  if (Shells(iShll)%Transf .and. Shells(iShll)%Prjct) iSize = 2*iAng+1
  if (abs(dbsc(iCnttp)%nFragCoor) /= iCurMdc) then
    ! update fragment related quantities
    iCurMdc = abs(dbsc(iCnttp)%nFragCoor)
    iSstart = iS
    iSend = nSkal
    do iStemp=iSstart+1,nSkal
      if (abs(dbsc(iSD(13,iStemp))%nFragCoor) /= iCurMdc) then
        iSend = iStemp-1
        exit
      end if
    end do
    iSbasis = 1
    iCurCenter = iCurCenter+1
    if (iCurCenter > dbsc(iCurCnttp)%nCntr) then
      iCurCenter = 1
      do jCnttp=iCurCnttp+1,nCnttp
        if (dbsc(jCnttp)%nFragType > 0) then
          iCurCnttp = jCnttp
          exit
        end if
      end do
      ! update the energy weighted density matrix of the current fragment
      EnergyWeight = .true.
      call MakeDens(dbsc(iCurCnttp)%nFragDens,dbsc(iCurCnttp)%nFragEner,dbsc(iCurCnttp)%FragCoef,dbsc(iCurCnttp)%FragEner, &
                    EnergyWeight,Array)
      if (iPrint >= 49) call TriPrt('Energy weighted fragment dens',' ',Array,dbsc(iCurCnttp)%nFragDens)
      ! include the minus sign of -2eta_i
      call DScal_(dbsc(iCurCnttp)%nFragDens*(dbsc(iCurCnttp)%nFragDens+1)/2,-One,Array,1)
      if (maxDensSize < dbsc(iCurCnttp)%nFragDens*(dbsc(iCurCnttp)%nFragDens+1)/2) stop 'maxIJSize'
    end if
  end if
  !write(u6,*) '  iShll,iAng,mdci,iCnttp,iCurMdc,iCurCnttp',iShll,iAng,mdci,iCnttp,iCurMdc,iCurCnttp
  !write(u6,*) '  iPrim,iBas =',iPrim,iBas

  ! extra derivative stuff
  iuvwx(3) = dc(mdci)%nStab
  iuvwx(4) = dc(mdci)%nStab
  JndGrd(:,1:2) = IndGrd
  JfGrad(:,1:2) = IfGrad

  JfGrad(:,3:4) = .false.
  ! always equivalent of pChrg's
  JndGrd(:,3:4) = 0
  mGrad = 0
  do iCar=1,3
    do i=1,2
      if (JfGrad(iCar,i)) mGrad = mGrad+1
    end do
  end do
  if (iPrint >= 99) write(u6,*) ' mGrad=',mGrad
  if (mGrad == 0) cycle
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Loop over all other shells belonging to the same fragment
  jSbasis = 1
  do jS=iSstart,iSend
    jShll = iSD(0,jS)
    jAng = iSD(1,jS)
    jBas = iSD(3,jS)
    jPrim = iSD(5,jS)
    jCnttp = iSD(13,jS)
    jCnt = iSD(14,jS)
    jSize = nTri_Elem1(jAng)
    if (Shells(jShll)%Transf .and. Shells(jShll)%Prjct) jSize = 2*jAng+1
    B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
    !write(u6,*) '    jShll,jAng,jCnttp =',jShll,jAng,jCnttp
    !write(u6,*) '    jPrim,jBas =',jPrim,jBas
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Create a rectangular matrix sized (iBas*nTri_Elem1(iAng),jBas*nTri_Elem1(jAng))
    ! from the energy weighted density matrix (desymmetrized)
    ! contains values from iSbasis to iSbasis + iBas*nTri_Elem1(iAng) - 1
    !             and from jSbasis to jSbasis + jBas*nTri_Elem1(jAng) - 1
    ipIJ = 1+maxDensSize
    !write(u6,*) '    extracting values from',iSbasis,' to',iSbasis+iBas*iSize-1,', and from',jSbasis,' to',jSbasis+jBas*jSize-1
    do iSlocal=iSbasis,iSbasis+iBas*iSize-1
      do jSlocal=jSbasis,jSbasis+jBas*jSize-1
        iLoc = ipIJ+(jSlocal-jSbasis)*iBas*iSize+iSlocal-iSbasis
        Array(iLoc) = Array(iTri(iSlocal,jSlocal))
        if (iSlocal /= jSlocal) Array(iLoc) = Array(iLoc)/Two
        !write(u6,*) 'Filling (',iSlocal-iSbasis+1,',',jSlocal-jSbasis+1,') from (',iSlocal,',',jSlocal,')'
      end do
    end do
    if (iPrint >= 99) call RecPrt('W(KC,LD)',' ',Array(ipIJ),iBas*iSize,jBas*jSize)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! DCR stuff (iS and jS have always the same symmetry character)

    call DCR(LmbdT,iStabM,nStabM,dc(mdci)%iStab,dc(mdci)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Loop over symmetry operations acting on the basis.

    do lDCRT=0,nDCRT-1
      lOp(3) = iDCRT(lDCRT)
      lOp(4) = lOp(3)
      call OA(iDCRT(lDCRT),C,TC)
      call OA(iDCRT(lDCRT),B,TB)
      if (EQ(A,RB) .and. EQ(A,TC)) cycle
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Calculate the overlap integral < alpha | is > and its derivative
      !
      !*** Storage

      ip = ipIJ+maxDensSize
      ipF1 = ip
      nac = nTri_Elem1(la)*nTri_Elem1(iAng)*4
      ip = ip+nAlpha*nac*iPrim
      ipP1 = ip
      ip = ip+3*nAlpha*iPrim
      ipZ1 = ip
      ip = ip+nAlpha*iPrim
      ipK1 = ip
      ip = ip+nAlpha*iPrim
      ipZI1 = ip
      ip = ip+nAlpha*iPrim
      if (ip-1 > nArr*nZeta) then
        write(u6,*) '  ip-1 > nArr*nZeta(1) in FragPGrd'
        call Abend()
      end if

      !*** Effective center and exponent

      call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,iPrim,Alpha,Shells(iShll)%Exp)
      call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,iPrim,A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))

      !*** Overlap and derivative

      n_Her = ((la+1)+iAng+2)/2
      ipAxyz = ip
      ip = ip+nAlpha*iPrim*3*n_Her*(la+2)
      ipCxyz = ip
      ip = ip+nAlpha*iPrim*3*n_Her*(iAng+1)
      ipRxyz = ip
      ip = ip+nAlpha*iPrim*3*n_Her*(nOrdOp+1)
      ipQ1 = ip
      ip = ip+nAlpha*iPrim*3*(la+2)*(iAng+1)*(nOrdOp+1)
      ipA = ip
      ip = ip+nAlpha*iPrim
      if (ip-1 > nArr*nZeta) then
        write(u6,*) '  ip-1 > nArr*nZeta(1b) in FragPGrd'
        call Abend()
      end if
      ABeq(1) = A(1) == TC(1)
      ABeq(2) = A(2) == TC(2)
      ABeq(3) = A(3) == TC(3)
      call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*iPrim,A,Array(ipAxyz),la+1,HerR(iHerR(n_Her)),n_Her,ABeq)
      call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*iPrim,TC,Array(ipCxyz),iAng,HerR(iHerR(n_Her)),n_Her,ABeq)
      ABeq(1) = .false.
      ABeq(2) = .false.
      ABeq(3) = .false.
      call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*iPrim,Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(n_Her)),n_Her,ABeq)
      if (iPrint >= 49) then
        write(u6,*) ' Array(ipAxyz)=',DNrm2_(nAlpha*iPrim*3*n_Her*(la+2),Array(ipAxyz),1)
        write(u6,*) ' Array(ipCxyz)=',DNrm2_(nAlpha*iPrim*3*n_Her*(iAng+1),Array(ipCxyz),1)
        write(u6,*) ' Array(ipRxyz)=',DNrm2_(nAlpha*iPrim*3*n_Her*(nOrdOp+1),Array(ipRxyz),1)
      end if
      call Assmbl(Array(ipQ1),Array(ipAxyz),la+1,Array(ipRxyz),nOrdOp,Array(ipCxyz),iAng,nAlpha*iPrim,HerW(iHerW(n_Her)),n_Her)
      iStrt = ipA
      do iGamma=1,iPrim
        call dcopy_(nAlpha,Alpha,1,Array(iStrt),1)
        iStrt = iStrt+nAlpha
      end do
      if (iPrint >= 49) write(u6,*) ' Array(ipA)=',DNrm2_(nAlpha*iPrim,Array(ipA),1)
      call rKappa_Zeta(Array(ipK1),Array(ipZ1),iPrim*nAlpha)
      ld = 1
      call CmbnAC(Array(ipQ1),nAlpha*iPrim,la,iAng,Array(ipK1),Array(ipF1),Array(ipA),JfGrad(1,1),ld,nVecAC)
      if (iPrint >= 49) then
        write(u6,*) ' Array(ipQ1)=',DNrm2_(nAlpha*iPrim*3*(la+2)*(iAng+1)*(nOrdOp+1),Array(ipQ1),1)
        write(u6,*) ' Array(ipA)=',DNrm2_(nAlpha*iPrim,Array(ipA),1)
      end if
      ip = ip-nAlpha*iPrim*(6+3*n_Her*(la+2)+3*n_Her*(iAng+1)+3*n_Her*(nOrdOp+1)+3*(la+2)*(iAng+1)*(nOrdOp+1)+1)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Calculate the overlap integral < js | beta > and its derivative
      !
      !*** Storage

      ipF2 = ip
      ncb = nTri_Elem1(jAng)*nTri_Elem1(lb)*4
      ip = ip+jPrim*nBeta*ncb
      ipP2 = ip
      ip = ip+3*jPrim*nBeta
      ipZ2 = ip
      ip = ip+jPrim*nBeta
      ipK2 = ip
      ip = ip+jPrim*nBeta
      ipZI2 = ip
      ip = ip+jPrim*nBeta
      if (ip-1 > nArr*nZeta) then
        write(u6,*) '  ip-1 > nArr*nZeta(2) in FragPGrd'
        call Abend()
      end if

      !*** Effective center and exponent

      call ZXia(Array(ipZ2),Array(ipZI2),jPrim,nBeta,Shells(jShll)%Exp,Beta)
      call SetUp1(Shells(jShll)%Exp,jPrim,Beta,nBeta,TB,RB,Array(ipK2),Array(ipP2),Array(ipZI2))

      !*** Overlap and derivative

      n_Her = (jAng+(lb+1)+2)/2
      ipCxyz = ip
      ip = ip+nBeta*jPrim*3*n_Her*(jAng+1)
      ipBxyz = ip
      ip = ip+nBeta*jPrim*3*n_Her*(lb+2)
      ipRxyz = ip
      ip = ip+nBeta*jPrim*3*n_Her*(nOrdOp+1)
      ipQ1 = ip
      ip = ip+nBeta*jPrim*3*(jAng+1)*(lb+2)*(nOrdOp+1)
      ipB = ip
      ip = ip+nBeta*jPrim
      if (ip-1 > nArr*nZeta) then
        write(u6,*) '  ip-1 > nArr*nZeta(2b) in FragPGrd'
        call Abend()
      end if
      ABeq(1) = TB(1) == RB(1)
      ABeq(2) = TB(2) == RB(2)
      ABeq(3) = TB(3) == RB(3)
      call CrtCmp(Array(ipZ2),Array(ipP2),jPrim*nBeta,TB,Array(ipCxyz),jAng,HerR(iHerR(n_Her)),n_Her,ABeq)
      call CrtCmp(Array(ipZ2),Array(ipP2),jPrim*nBeta,RB,Array(ipBxyz),lb+1,HerR(iHerR(n_Her)),n_Her,ABeq)
      ABeq(1) = .false.
      ABeq(2) = .false.
      ABeq(3) = .false.
      call CrtCmp(Array(ipZ2),Array(ipP2),jPrim*nBeta,Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(n_Her)),n_Her,ABeq)
      if (iPrint >= 49) then
        write(u6,*) ' Array(ipCxyz)=',DNrm2_(nBeta*jPrim*3*n_Her*(jAng+1),Array(ipCxyz),1)
        write(u6,*) ' Array(ipBxyz)=',DNrm2_(nBeta*jPrim*3*n_Her*(lb+2),Array(ipBxyz),1)
        write(u6,*) ' Array(ipRxyz)=',DNrm2_(nBeta*jPrim*3*n_Her*(nOrdOp+1),Array(ipRxyz),1)
      end if
      call Assmbl(Array(ipQ1),Array(ipCxyz),jAng,Array(ipRxyz),nOrdOp,Array(ipBxyz),lb+1,jPrim*nBeta,HerW(iHerW(n_Her)),n_Her)
      iStrt = ipB
      do iGamma=1,jPrim
        call dcopy_(nBeta,Beta,1,Array(iStrt),jPrim)
        iStrt = iStrt+1
      end do
      if (iPrint >= 49) write(u6,*) ' Array(ipB)=',DNrm2_(jPrim*nBeta,Array(ipB),1)
      call rKappa_Zeta(Array(ipK2),Array(ipZ2),jPrim*nBeta)
      ld = 1
      call CmbnCB(Array(ipQ1),jPrim*nBeta,jAng,lb,Array(ipK2),Array(ipF2),Array(ipB),JfGrad(1,2),ld,nVecCB)
      if (iPrint >= 49) then
        write(u6,*) ' Array(ipQ1)=',DNrm2_(jPrim*nBeta*3*(la+2)*(jAng+1)*(nOrdOp+1),Array(ipQ1),1)
        write(u6,*) ' Array(ipB)=',DNrm2_(JPrim*nBeta,Array(ipB),1)
      end if
      ip = ip-nBeta*jPrim*(6+3*n_Her*(lb+2)+3*n_Her*(jAng+1)+3*n_Her*(nOrdOp+1)+3*(lb+2)*(jAng+1)*(nOrdOp+1)+1)
      nac = nTri_Elem1(la)*nTri_Elem1(iAng)*nVecAC
      ncb = nTri_Elem1(jAng)*nTri_Elem1(lb)*nVecCB
      ipTmp = ip
      ip = ip+max(nAlpha*max(iPrim,jBas)*nac,nBeta*ncb*jBas)
      if (ip-1 > nArr*nZeta) then
        write(u6,*) '  ip-1 > nArr*nZeta(3) in FragPGrd'
        call Abend()
      end if
      nac = nTri_Elem1(la)*nTri_Elem1(iAng)
      ncb = nTri_Elem1(jAng)*nTri_Elem1(lb)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Assemble the calculated quantities and contract
      !
      ! Calculate Contraction over components of the fragment
      ! orbitals of type <A|iS>coef<jS|B> where we now have in
      ! Array(ipF1) the cartesian components of <A|iS>, and
      ! similarily, in Array(ipF2), we have stored the cartesian
      ! components of <jS|B>. Observe that the fragment orbitals are
      ! orthonomal atomic orbitals. Hence, the transformation
      ! to the spherical harmonics has to be for normalized
      ! spherical harmonics.
      !
      ! nAlpha = i               nTri_Elem1(la) = a
      ! nBeta  = j               nTri_Elem1(lb) = b
      ! iPrim = k (iBas = K)     nTri_Elem1(iAng) = c (iSize = C)
      ! jPrim = l (jBas = L)     nTri_Elem1(jAng) = d (jSize = D)
      !
      !---From the lefthandside overlap, form iKaC from ikac by
      !   1) i,kac -> k,aci

      call DgeTMo(Array(ipF1),nAlpha,nAlpha,iPrim*nac*nVecAC,Array(ipTmp),iPrim*nac*nVecAC)

      !---2) aciK =  k,aci * k,K (Contract over core orbital)

      call DGEMM_('T','N',nac*nVecAC*nAlpha,iBas,iPrim,One,Array(ipTmp),iPrim,Shells(iShll)%pCff,iPrim,Zero,Array(ipF1), &
                  nac*nVecAC*nAlpha)

      !---3) a,ciK -> ciKa

      call DgeTMo(Array(ipF1),nTri_Elem1(la),nTri_Elem1(la),nTri_Elem1(iAng)*nVecAC*nAlpha*iBas,Array(ipTmp), &
                  nTri_Elem1(iAng)*nVecAC*nAlpha*iBas)

      !---4) iKa,C = c,iKa * c,C

      if (Shells(iShll)%Transf .and. Shells(iShll)%Prjct) then
        call DGEMM_('T','N',nVecAC*nAlpha*iBas*nTri_Elem1(la),iSize,nTri_Elem1(iAng),One,Array(ipTmp),nTri_Elem1(iAng), &
                    RSph(ipSph(iAng)),nTri_Elem1(iAng),Zero,Array(ipF1),nVecAC*nAlpha*iBas*nTri_Elem1(la))
      else
        call DgeTMo(Array(ipTmp),nTri_Elem1(iAng),nTri_Elem1(iAng),nVecAC*iBas*nTri_Elem1(la)*nAlpha,Array(ipF1), &
                    nVecAC*iBas*nTri_Elem1(la)*nAlpha)
      end if
      ! what does this do and is it needed? (from PrjGrd)
      call DgeTMo(Array(ipF1),nVecAC,nVecAC,nAlpha*iBas*nTri_Elem1(la)*iSize,Array(ipTmp),nAlpha*iBas*nTri_Elem1(la)*iSize)
      call dcopy_(nVecAC*nAlpha*iBas*nTri_Elem1(la)*iSize,Array(ipTmp),1,Array(ipF1),1)

      !---And (almost) the same thing for the righthand side, form
      !   LjDb from ljdb
      !   1) jdb,L = l,jdb * l,L

      call DGEMM_('T','N',nBeta*ncb*nVecCB,jBas,jPrim,One,Array(ipF2),jPrim,Shells(jShll)%pCff,jPrim,Zero,Array(ipTmp), &
                  nBeta*ncb*nVecCB)

      !---2)  j,dbL -> dbL,j

      call DgeTMo(Array(ipTmp),nBeta,nBeta,ncb*nVecCB*jBas,Array(ipF2),ncb*nVecCB*jBas)

      !---3) bLj,D = d,bLj * d,D

      if (Shells(jShll)%Transf .and. Shells(jShll)%Prjct) then
        call DGEMM_('T','N',nTri_Elem1(lb)*nVecCB*jBas*nBeta,jSize,nTri_Elem1(jAng),One,Array(ipF2),nTri_Elem1(jAng), &
                    RSph(ipSph(jAng)),nTri_Elem1(jAng),Zero,Array(ipTmp),nTri_Elem1(lb)*nVecCB*jBas*nBeta)
      else
        call DgeTMo(Array(ipF2),nTri_Elem1(jAng),nTri_Elem1(jAng),nVecCB*jBas*nTri_Elem1(lb)*nBeta,Array(ipTmp), &
                    nVecCB*jBas*nTri_Elem1(lb)*nBeta)
      end if

      !---4) b,LjD -> LjD,b

      call DgeTMo(Array(ipTmp),nTri_Elem1(lb)*nVecCB,nTri_Elem1(lb)*nVecCB,jBas*nBeta*jSize,Array(ipF2),jBas*nBeta*jSize)

      !---Next Contract (iKaC)*W(KLCD)*(LjDb) producing ijab

      rFinal(:,:,:,1,:) = Zero

      if (iPrint >= 99) then
        call RecPrt('ipF1 (nVecAC x X)',' ',Array(ipF1),nVecAC,iBas*nAlpha*iSize)
        call RecPrt('ipF2 (nVecCB x Y)',' ',Array(ipF2),nVecCB,jBas*nBeta*jSize)
      end if

      mVec = 0
      mVecAC = 1
      mVecCB = 1
      do iCar=1,3
        do iCent=1,2
          !write(u6,*) 'iCar, iCent = ',iCar,iCent
          if (JfGrad(iCar,iCent)) then
            mVec = mVec+1
            if (iCent == 1) then
              mVecAC = mVecAC+1
              ipF1a = ipF1+(mVecAC-1)*nAlpha*jBas*nTri_Elem1(la)*iSize
              ipF2a = ipF2
            else
              ipF1a = ipF1
              mVecCB = mVecCB+1
              ipF2a = ipF2+(mVecCB-1)*jBas*nBeta*jSize*nTri_Elem1(lb)
            end if
            if (iPrint >= 99) then
              write(u6,*) 'mVecAC, mVecCB = ',mVecAC,mVecCB
              call RecPrt('ipF1a (nAlpha*aAng x iBas*iSize)',' ',Array(ipF1a),nAlpha*nTri_Elem1(la),iBas*iSize)
              call RecPrt('ipF2a (nBeta*bAng x jBas*jSize)',' ',Array(ipF2a),nBeta*nTri_Elem1(lb),jBas*jSize)
            end if

            call FragPCont(Array(ipF1a),nAlpha,iBas,nTri_Elem1(la),iSize,Array(ipF2a),jBas,nBeta,jSize,nTri_Elem1(lb),Array(ipIJ), &
                           rFinal(:,:,:,1,mVec),Fact*Half)
          end if
        end do !iCent
      end do !iCar

      if (iPrint >= 49) then
        do iVec=1,mVec
          write(u6,*) iVec,sqrt(DNrm2_(nZeta*nTri_Elem1(la)*nTri_Elem1(lb),rFinal(:,:,:,1,iVec),1))
        end do
      end if
      if (iPrint >= 99) then
        write(u6,*) ' Result in FragPGrd'
        do ia=1,nTri_Elem1(la)
          do ib=1,nTri_Elem1(lb)
            do iVec=1,mVec
              write(Label,'(A,I2,A,I2,A,I2,A)') ' rFinal(',ia,',',ib,',',iVec,')'
              call RecPrt(Label,' ',rFinal(:,ia,ib,1,iVec),nAlpha,nBeta)
            end do
          end do
        end do
      end if

      !---Distribute contributions to the gradient

      call Distg1X(rFinal,DAO,nZeta,nDAO,mVec,Grad,nGrad,JfGrad,JndGrd,iuvwx,lOp)

    end do !lDCRT
    jSbasis = jSbasis+jBas*jSize
  end do !jS
  iSbasis = iSbasis+iBas*iSize
end do !iS

! Revert to the valence shells

call Free_iSD()

return

end subroutine FragPGrd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function LHR(i,iAtom,j,jAtom)
! LHR function: convert full Hessian indices in lower triangular index

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: LHR
integer(kind=iwp), intent(in) :: i, iAtom, j, jAtom
integer(kind=iwp) :: ivv, ivv1, ivv2

ivv1 = (iAtom-1)*3+i
ivv2 = (jAtom-1)*3+j
ivv = max(ivv1,ivv2)
LHR = ivv*(ivv-3)/2+ivv1+ivv2

return

end function LHR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Localize_LoProp(Ttot,Ttot_Inv,nBas,SMatrix,iCenter,
     &                           iType)
*                                                                      *
************************************************************************
*                                                                      *
* H2 molecule with 2s basis functions on each H: A and B are the two
* centers
* Original S matrix  (nz=non zero; 10-8 should be zero but it is not for
* numerical imprecision
*       1     10-8  nz   nz
* S0=   10-8  1     nz   nz
*       nz    nz    1    10-8
*       nz    nz    10-8 1
*
* Step 1. LO S0 in order to generate S1 (orthogonalization of all the
* blocks for the same center
*       1     0     nz   nz
* S1=   0     1     nz   nz
*       nz    nz    1    0
*       nz    nz    0    1
*
* Step 2. LO S1 -> S2 (orthogonalization of the OAOB and VAVB blocks
*       1     0     0    nz
* S2=   0     1     nz   0
*       0     nz    1    0
*       nz    0     0    1
*
* Step 3. GS S2 -> S3 (orthogonalization of the VBOA and VAOB blocks
*       1     0     0    0
* S3=   0     1     0    0
*       0     0     1    0
*       0     0     0    1
*                                                                      *
************************************************************************
*                                                                      *
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Ttot(nBas,nBas), Ttot_Inv(nBas,nBas), SMatrix(nBas,nBas)
      Integer iCenter(nBas), iType(nBas)
      Integer IndType(7), Occ, Vir
      Parameter(Occ=1,Vir=0)
      Character OrbName*128, Note*80, Filename*6
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate temporary memory
*
      Call Allocate_Work(ip_T1,nBas**2)
      Call Allocate_Work(ip_T2,nBas**2)
      Call Allocate_Work(ip_T3,nBas**2)
      Call Allocate_Work(ip_T4,nBas**2)
      Call Allocate_Work(ip_tmp,nBas**2)
      Call Allocate_Work(ip_S,nBas**2)
      Call Allocate_Work(ip_Save,nBas**2)
*
*     Save S because GS will destroy it!
*
      call dcopy_(nBas**2,SMatrix,1,Work(ip_S),1)
*                                                                      *
************************************************************************
*                                                                      *
*     Step 1. GS S0 ->S1
*
      call dcopy_(nBas**2,[Zero],0,Work(ip_T1),1)
      call dcopy_(nBas,[One],0,Work(ip_T1),nBas+1)
*
      Call Step1(iCenter,Work(ip_S),nBas,Work(ip_T1),iType,
     &           SMatrix,Work(ip_tmp))
*                                                                      *
************************************************************************
*                                                                      *
*     Step 2. LO S1 ->S2
*
      call dcopy_(nBas**2,Work(ip_S),1,Work(ip_Save),1)
      call dcopy_(nBas**2,[Zero],0,Work(ip_T2),1)
      call dcopy_(nBas,[One],0,Work(ip_T2),nBas+1)
*
      Call Step2(iCenter,Work(ip_S),nBas,Work(ip_T2),iType,
     &           Work(ip_Save),Work(ip_tmp))
*                                                                      *
************************************************************************
*                                                                      *
*     Now set up things for the GS orthogonalization
*
*
*     Step 3. GS S2 ->S3
*
      Call Step3(iCenter,Work(ip_S), nBas,Work(ip_T3),iType)

*                                                                      *
************************************************************************
*                                                                      *
*     Now do a final Lowdin to remove virtual-virtual
*
*
*     Step 4. LO S3 ->S4
*
      Call Step4(Work(ip_S),nBas,Work(ip_T4),iType)

*                                                                      *
************************************************************************
*                                                                      *
*     Now I have LO orthog twice and GS orthog
*     The corresponding transformation matrices are T1 T2 and TGS
*     Now I generate the total transformation matrix TTOT=T1*T2*TGS
*
*        ...now T is T1*T2*T3*T4
*
      Call Ttotal(Work(ip_T1),Work(ip_T2),Work(ip_T3), Work(ip_T4),
     &            Ttot,Ttot_Inv,nBas)
*                                                                      *
************************************************************************
*                                                                      *
*      Check that all this works by applaying TTot to original overlap
*      matrix and you should get unit matrix
*
C     Call RecPrt('Old S',' ',SMatrix,nBas,nBas)
C     Call xxDGeMul(SMatrix,nBas,'N',
C    &            Ttot,nBas,'N',
C    &            Work(ip_tmp),nBas,
C    &            nBas,nBas,nBas)
C     Call xxDGeMul(Ttot,nBas,'T',
C    &            Work(ip_tmp),nBas,'N',
C    &            SMatrix,nBas,
C    &            nBas,nBas,nBas)
C     Call RecPrt('New S',' ',SMatrix,nBas,nBas)
*                                                                      *
************************************************************************
*                                                                      *
*     Dealloctate memory
*
      Call Free_Work(ip_Save)
      Call Free_Work(ip_S)
      Call Free_Work(ip_tmp)
      Call Free_Work(ip_T4)
      Call Free_Work(ip_T3)
      Call Free_Work(ip_T2)
      Call Free_Work(ip_T1)
*                                                                      *
************************************************************************
*                                                                      *
*     Write out the transformation matrix as molecular orbitals.
*
      nOcc=0
      Do iBas = 1, nBas
         If (iType(iBas).eq.Occ) nOcc = nOcc + 1
      End Do
*
      IndType(1)=0
      IndType(2)=nOcc
      IndType(3)=0
      IndType(4)=0
      IndType(5)=0
      IndType(6)=nBas-nOcc
      IndType(7)=0
*
      Call Allocate_Work(ipE,nBas)
      Call FZero(Work(ipE),nBas)
      OrbName='LPRORB'
      LuOut=20
      iUHF=0
      nSym=1
      Note='LoProp localized orbitals'
      Call WrVec_(OrbName,LuOut,'COEI',iUHF,nSym,[nBas],[nBas],
     &            TTot,[0.0d0],
     &            Work(ipE),[0.0d0],
     &            Work(ipE),[0.0d0],IndType,Note,0)
      Call Free_Work(ipE)
*                                                                      *
************************************************************************
*                                                                      *
*     Not implemented for symmetry!
*
      Filename='MD_LPR'
      Call Get_iScalar('nSym',nSym)
      If (nSym.eq.1) Call Molden_Interface(iUHF,OrbName,Filename)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_X_GenVec(irc,Diag)

use Cholesky, only: iQuAB, pTemp, iQuAB_here, LuPri, MaxQual, Mode_Screen, nnZTot, nSym, NumCho
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(_OUT_) :: Diag(*)
integer(kind=iwp) :: iSym, MaxQual_SAVE
character(len=*), parameter :: SecNam = 'Cho_X_GenVec'

! Set return code.
! ----------------

irc = 0

! Re-allocate the iQuAB index array, save old allocation.
! This is used to trick the integral extraction from Seward so as to
! reduce the number of re-calculations of shell pairs.
! ------------------------------------------------------------------

pTemp => iQuAB
MaxQual_SAVE = MaxQual

MaxQual = NumCho(1)
do iSym=2,nSym
  MaxQual = max(MaxQual,NumCho(iSym))
end do

call mma_allocate(iQuAB_here,MaxQual,nSym,Label='iQuAB_here')
iQuAB => iQuAB_here

! Read initial diagonal.
! ----------------------

call Cho_IODiag(Diag,2)

! Reinitialize the number of zeroed negative diagonals.
! Turn on damped screening for second step.
! -----------------------------------------------------

nNZTot = 0
MODE_SCREEN = 1

! Generate vectors.
! -----------------

call Cho_GnVc_Drv(irc,Diag)
if (irc /= 0) write(Lupri,*) SecNam,': Cho_GnVc_Drv returned ',irc

! De-allocations.
! Restore original iQuAB array.
! -----------------------------

call mma_deallocate(iQuAB_here)
iQuAB => pTemp
MaxQual = MaxQual_SAVE

end subroutine Cho_X_GenVec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_T_buffer

use fmm_global_paras, only: INTK, T_pair_single, scheme_paras, SKIP_T_BUFFER, NULL_T_BUFFER, TREE_T_BUFFER, MULTI_T_BUFFER, &
                            SCALE_T_BUFFER, NEAR_FIELD, TMATM_DF, TREE_LENGTH, One
use fmm_stats, only: stat_T_mat_builds, stat_tpack_total, fmm_init_buffer_stats
use fmm_utils, only: fmm_quit

implicit none
private
! public procedures
public :: fmm_add_to_T_buffer, &
          fmm_open_T_buffer, &
          fmm_close_T_buffer

! only one T_buffer can be open at once
integer(INTK), save :: buffer = -1

! diagnostic flag
character(len=4), save :: T_buffer_stat

contains

!-------------------------------------------------------------------------------

subroutine fmm_add_to_T_buffer(T_pair)

  implicit none
  type(T_pair_single), intent(in) :: T_pair
  external :: fmm_selected_t_buffer
  external :: fmm_selected_t_contractor

  call fmm_selected_t_buffer(fmm_selected_t_contractor,T_pair)

end subroutine fmm_add_to_T_buffer

!-------------------------------------------------------------------------------

subroutine fmm_close_T_buffer()

  use fmm_T_contractors, only: fmm_lock_T_con
  use fmm_tree_buffer, only: fmm_tree_buffer_finish
  use fmm_multi_T_buffer, only: fmm_free_multi_T_buffer
  use fmm_scale_T_buffer, only: fmm_free_scale_T_buffer

  implicit none
  external :: fmm_selected_t_contractor

  if (T_buffer_stat /= 'OPEN') call fmm_quit('T_buffer already closed!')

  select case (buffer)
    case (SKIP_T_BUFFER)
      ! do nothing
    case (NULL_T_BUFFER)
      ! do nothing
    case (TREE_T_BUFFER)
      call fmm_tree_buffer_finish(fmm_selected_t_contractor)
    case (MULTI_T_BUFFER)
      call fmm_free_multi_T_buffer(fmm_selected_t_contractor)
    case (SCALE_T_BUFFER)
      call fmm_free_scale_T_buffer(fmm_selected_t_contractor)
    case default
      call fmm_quit('cannot reconcile list type in fmm_close_T_buffer')
  end select

  T_buffer_stat = 'FREE'
  fmm_lock_T_con = .false.

end subroutine fmm_close_T_buffer

!-------------------------------------------------------------------------------

subroutine fmm_null_T_buffer(T_contractor,T_pair)

  implicit none
  type(T_pair_single), intent(in) :: T_pair
  external                        :: T_contractor

  stat_tpack_total = stat_tpack_total+one
  call T_contractor(T_pair)

end subroutine fmm_null_T_buffer

!-------------------------------------------------------------------------------
! for diagnostic use only

subroutine fmm_skip_T_buffer(T_contractor,T_pair)

# include "macros.fh"

  implicit none
  type(T_pair_single), intent(in) :: T_pair
  external                        :: T_contractor

  unused_proc(T_contractor(T_pair))

  stat_T_mat_builds = stat_T_mat_builds+1
  return

end subroutine fmm_skip_T_buffer

!-------------------------------------------------------------------------------

subroutine fmm_open_T_buffer(scheme)

  use fmm_T_contractors, only: fmm_lock_T_con
  use fmm_tree_buffer, only: fmm_tree_buffer_init, &
                             fmm_tree_buffer_add
  use fmm_multi_T_buffer, only: fmm_init_multi_T_buffer, &
                                fmm_multi_T_buffer_add
  use fmm_scale_T_buffer, only: fmm_init_scale_T_buffer, &
                                fmm_scale_T_buffer_add

  implicit none
  type(scheme_paras), intent(in) :: scheme
  integer(INTK) :: sort_para
  external :: fmm_store_t_buffer

  call fmm_init_buffer_stats('T')
  if (T_buffer_stat == 'OPEN') call fmm_quit('cannot reopen T_buffer')

  if (scheme%phase == NEAR_FIELD) then
    buffer = scheme%T_con%NF_T_buffer
    sort_para = scheme%T_con%NF_sort_para
  else
    buffer = scheme%T_con%FF_T_buffer
    sort_para = scheme%T_con%FF_sort_para
  end if

  select case (buffer)
    case (SKIP_T_BUFFER)
      ! all T-contractions will be skipped by this choice of buffer
      call fmm_store_t_buffer(fmm_skip_T_buffer)
    case (NULL_T_BUFFER)
      call fmm_store_t_buffer(fmm_null_T_buffer)
    case (TREE_T_BUFFER)
      ! use tree-based sorting/evaluating module
      call fmm_store_t_buffer(fmm_tree_buffer_add)
      call fmm_tree_buffer_init(TREE_LENGTH,sort_para)
    case (SCALE_T_BUFFER)
      ! use tree-based sorting/evaluating module
      call fmm_store_t_buffer(fmm_scale_T_buffer_add)
      call fmm_init_scale_T_buffer()
    case (MULTI_T_BUFFER)
      ! use buffer to drive multiple T matrix simultaneous build
      call fmm_store_t_buffer(fmm_multi_T_buffer_add)
      call fmm_init_multi_T_buffer(TMATM_DF)
    case default
      call fmm_quit('cannot reconcile list type in fmm_open_T_buffer')
  end select

  T_buffer_stat = 'OPEN'
  fmm_lock_T_con = .true.

end subroutine fmm_open_T_buffer

!-------------------------------------------------------------------------------

end module fmm_T_buffer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine SOS(iStabO,nStabO,lOper)
!***********************************************************************
!                                                                      *
! Object: to generate the stabilizer S for the operator O.             *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             February '91                                             *
!***********************************************************************

use Symmetry_Info, only: iChTbl, iOper, nIrrep
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iStabO(8), nStabO
integer(kind=iwp), intent(in) :: lOper
integer(kind=iwp) :: iIrrep, iS

#ifdef _DEBUGPRINT_
write(u6,*) ' In SOS'
write(u6,*) ' lOper=',lOper
do iS=0,nIrrep-1
  write(u6,'(8I5)') (iChTbl(iIrrep,iS),iIrrep=0,nIrrep-1)
end do
#endif
if ((lOper < 0) .or. (lOper > 255)) then
  call WarningMessage(2,'SOS: Symmetry label is corrupted.')
  write(u6,*) 'lOper=',lOper
  call Abend()
end if
nStabO = 0
outer: do iS=0,nIrrep-1
  inner: do iIrrep=0,nIrrep-1
    if (.not. btest(lOper,iIrrep)) cycle inner
    if (iChTbl(iIrrep,iS) /= 1) cycle outer
  end do inner
  nStabO = nStabO+1
  iStabO(nStabO) = iOper(iS)
end do outer

end subroutine SOS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Annihil_rho(Dmat,nBas)

#include "intent.fh"

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(_OUT_) :: Dmat(*)
integer(kind=iwp), intent(in) :: nBas
#include "Molcas.fh"
integer(kind=iwp) :: i, iAt, iAt_B, ijj, j, jj, Length, nAA, nAt_B, nAtoms, nBas_A, nBas_B
real(kind=wp) :: ZA, ZB
integer(kind=iwp), allocatable :: nBas_per_Atom(:), nBas_Start(:)
real(kind=wp), allocatable :: Charge_B(:)
character(len=LenIn8), allocatable :: UBName(:)

!                                                                      *
!***********************************************************************
!                                                                      *
call Get_iScalar('Unique atoms',nAtoms)

if (nAtoms < 1) then
  write(u6,'(A,I9)') 'nUniqAt =',nAtoms
  call Abend()
end if

call mma_allocate(nBas_per_Atom,nAtoms,Label='nBpA')
call mma_allocate(nBas_Start,nAtoms,Label='nB_Start')

call mma_allocate(UBName,nBas,Label='UBName')
call Get_cArray('Unique Basis Names',UBName,(LENIN8)*nBas)

call BasFun_Atom(nBas_per_Atom,nBas_Start,UBName,nBas,nAtoms,.false.)
call mma_deallocate(UBName)

call mma_allocate(Charge_B,nAtoms,Label='Charge_B')
call Get_dArray('Nuclear charge',Charge_B,nAtoms)

ZA = Zero
iAt = 1
do while ((iAt <= nAtoms) .and. (ZA == Zero))
  ZA = Charge_B(iAt)
  iAt = iAt+1
end do
iAt_B = iAt-1  ! start of atoms of subsystem B
call mma_deallocate(Charge_B)

if (iAt_B == 1) then ! subsystem B comes first
  ZB = One
  nAt_B = 1
  do while ((nAt_B <= nAtoms) .and. (ZB > Zero))
    ZB = Charge_B(nAt_B)
    nAt_B = nAt_B+1
  end do
  nAt_B = nAt_B-1  ! end of atoms of subsystem B
  nBas_B = nBas_Start(nAt_B)-1
  do j=nBas_B,nBas-1
    jj = j*(j+1)/2
    do i=1,j
      ijj = i+jj
      Dmat(ijj) = Zero
    end do
  end do
else
  nBas_A = nBas_Start(iAt_B)-1
  nAA = nBas_A*(nBas_A+1)/2
  DMat(1:nAA) = Zero
  do j=nBas_A,nBas-1
    jj = j*(j+1)/2
    do i=1,nBas_A
      ijj = i+jj
      Dmat(ijj) = Zero
    end do
  end do
end if

call mma_deallocate(nBas_Start)
call mma_deallocate(nBas_per_Atom)

! Annihilated density written to runfile for use in Coulomb gradients

Length = nBas*(nBas+1)/2
call Put_D1ao_Var(Dmat,Length)

return

end subroutine Annihil_rho

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkbiks_cvb()

use casvb_global, only: aikcof, bikcof, ikcoff, ipr, kbasiscvb, nel
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i2s1, ibeg, iend, ifns, nalf1, ndet, nel1, ntmp
logical(kind=iwp) :: share
character(len=*), parameter :: basis(7) = ['Kotani    ','Serber    ','Rumer     ','Rumer (LT)','projected ','Determ    ', &
                                           'Determ    ']
integer(kind=iwp), external :: ifns_cvb

aikcof(0) = real(kbasiscvb,kind=wp)
bikcof(0) = real(kbasiscvb,kind=wp)
if (kbasiscvb == 6) return

if (ipr(1) >= 1) write(6,6100) trim(basis(kbasiscvb))

share = associated(bikcof,aikcof)
do nel1=0,nel
  do nalf1=0,nel
    do i2s1=0,nel
      ibeg = ikcoff(nel1,nalf1,i2s1)+1
      if (ibeg /= 0) then
        ntmp = (nel1+i2s1)/2
        ifns = ifns_cvb(nel1,ntmp,kbasiscvb)
        call icomb_cvb(nel1,nalf1,ndet)
        iend = ibeg+ndet*ifns-1
        call bikset_cvb(aikcof(ibeg:iend),bikcof(ibeg:iend),nel1,nalf1,i2s1,ndet,ifns,kbasiscvb,share,ipr(1))
      end if
    end do
  end do
end do

return
6100 format(/,' Generate ',a,' spin functions.')

end subroutine mkbiks_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine CheckDomain(irc,iDomain,nAtom,nOcc)
C
C     Thomas Bondo Pedersen, January 2006.
C
C     Purpose: check domain definition.
C
      Implicit Real*8 (a-h,o-z)
      Integer iDomain(0:nAtom,nOcc)

      irc = 0
      Do i = 1,nOcc
         If (iDomain(0,i).lt.1 .or. iDomain(0,i).gt.nAtom) Then
            Write(6,*) 'Dimension of domain ',i,': ',iDomain(0,i)
            irc = irc + 1
         Else
            Do iAt = 1,iDomain(0,i)
               iAtom = iDomain(iAt,i)
               If (iAtom.lt.1 .or. iAtom.gt.nAtom) Then
                  Write(6,*) 'Atom ',iAt,' of domain ',i,': ',iAtom
                  irc = irc + 1
               End If
            End Do
         End If
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETINT(DIAG,DIASH,ISYSH,LSTQSP,NPOTSH,ICOUNT)
C
C     Purpose: get qualified integral columns for Cholesky decomposition.
C
C     DIASH(ij): max. diagonal in shell pair i,j
C     NPOTSH   : the number of shell pairs that can be qualified.
C
      use ChoArr, only: iSP2F, IntMap
#include "implicit.fh"
      DIMENSION DIAG(*), DIASH(*)
      INTEGER   ISYSH(*)
      INTEGER   LSTQSP(NPOTSH)
#include "cholesky.fh"
#include "choprint.fh"
#include "stdalloc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_GETINT')

      PARAMETER (ZERO = 0.0D0)

      LOGICAL DODECO, FULL, SYNC, LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

      INTEGER MEMQ(1)

      INTEGER  CHO_ISUMELM
      EXTERNAL CHO_ISUMELM

C-tbp: some debugging...
c     IF (LOCDBG) THEN
c        DO LEVEL = 1,3
c           CALL CHO_MCA_INT_1_DBG(DIAG,LEVEL)
c        END DO
c        call cho_quit(SECNAM//' end of test',100)
c     END IF

C     Initializations.
C     ----------------

      CALL IZERO(NQUAL,NSYM)
      ICOUNT = 0
      IF (MXSHPR .GT. 0) THEN
         MCOUNT = MIN(NPOTSH,MXSHPR)
      ELSE
         MCOUNT = NPOTSH
      END IF
      DODECO = .FALSE.

      MXDIM = NNBSTR(1,2)
      DO ISYM = 2,NSYM
         MXDIM = MAX(MXDIM,NNBSTR(ISYM,2))
      END DO
      Call mma_maxDBLE(LMAX)
      XMMQ = DBLE(N1_QUAL)*DBLE(LMAX)/DBLE(N2_QUAL)
      MEMQ(1) = INT(XMMQ)
      CALL CHO_GAIGOP(MEMQ,1,'min')
      IF (MEMQ(1) .LT. MXDIM) THEN
         WRITE(LUPRI,*) SECNAM,': memory split error!'
         WRITE(LUPRI,*) 'Memory for storing qualified columns: ',MEMQ(1)
         WRITE(LUPRI,*) 'Minimal memory needed to store one column: ',
     &                  MXDIM
         WRITE(LUPRI,*) 'Total memory available: ',LMAX
         WRITE(LUPRI,*) 'Memory split is ',N1_QUAL,'/',N2_QUAL,
     &                  ' for qualified columns.'
         WRITE(LUPRI,*) 'Change memory split in input file...'
         CALL CHO_QUIT('Memory split error in '//SECNAM,101)
      END IF

C     Shell pair qualification loop.
C     ------------------------------

      DO WHILE ((.NOT.DODECO) .AND. (ICOUNT.LT.MCOUNT))

C        Update shell pair counter.
C        --------------------------

         ICOUNT = ICOUNT + 1

C        Get shell pair corresponding to largest diagonal.
C        -------------------------------------------------

         CALL CHO_P_GETMAXSHL(DIASH,SMAX,ISHLAB)
         CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.TRUE.)
         ISYMAB = ISYSH(ISHLAB)

         IF ((SMAX.EQ.ZERO) .OR. (ABS(SMAX).LT.DIAMIN(ISYMAB))) THEN

C           Diagonal too small to be qualified for decomposition.
C           -----------------------------------------------------

            IF (ICOUNT .EQ. 1) THEN
               WRITE(LUPRI,*) SECNAM,': no integrals calculated; ',
     &                        'unable to proceed to decomposition!'
               WRITE(LUPRI,*) 'Max. abs. diagonal for shell pair ',
     &                        ISHLA,', ',ISHLB,': ',ABS(SMAX)
               WRITE(LUPRI,*) 'Max. abs. diagonal allowed: ',
     &                        DIAMIN(ISYMAB),' (sym. ',ISYMAB,')'
               CALL CHO_QUIT('Severe error in '//SECNAM,104)
            ELSE
               ICOUNT = ICOUNT - 1
               NSEL   = CHO_ISUMELM(NQUAL,NSYM)
               DODECO = NSEL .GT. 0
            END IF

         ELSE

C           Qualify diagonals within this shell pair.
C           -----------------------------------------

            SYNC = .FALSE.
            FULL = .FALSE.
            CALL CHO_P_QUALIFY(DIAG,SYNC,ISHLAB,ISYMAB,MEMQ(1),FULL)

C           Calculate integral columns; get qualified ones stored in
C           current reduced set; write these to disk on temporary
C           file(s).
C           --------------------------------------------------------

            NSEL   = CHO_ISUMELM(NQUAL,NSYM)
            NCOLAB = NSEL - CHO_ISUMELM(IOFFQ,NSYM)

            IF (NCOLAB .GT. 0) THEN

               INTMAP(ISHLAB) = INTMAP(ISHLAB) + 1
               IF (IPRINT .GE. INF_IN2) THEN
                  WRITE(LUPRI,'(/,A,I5,1X,I5,A,I9,A)')
     &            'Calculating shell pair (**|',ISHLA,ISHLB,
     &            '):',NCOLAB,' columns have been qualified'
                  WRITE(LUPRI,'(80A)') ('=',i=1,77)
                  WRITE(LUPRI,'(A,I12)')
     &            'Number of calculations so far for this shell pair: ',
     &            INTMAP(ISHLAB)
               END IF

               LSTQSP(ICOUNT) = ISHLAB
               CALL CHO_MCA_CALCINT(ISHLAB)

C              Enough integral columns for proceeding to decomposition?
C              --------------------------------------------------------

               DODECO = FULL .OR. NSEL.GE.MINQUAL

            ELSE IF (NCOLAB .EQ. 0) THEN

               IF (NSEL .LT. 1) THEN
                  WRITE(LUPRI,*) SECNAM,': logical error: ',
     &                                  'unable to qualify diagonals'
                  WRITE(LUPRI,*) SECNAM,': NCOLAB = ',NCOLAB
                  WRITE(LUPRI,*) SECNAM,': NSEL   = ',NSEL
                  CALL CHO_QUIT('[0] Logical error in '//SECNAM,104)
               ELSE
                  ICOUNT = ICOUNT - 1
                  DODECO = .TRUE.
               END IF

            ELSE

               WRITE(LUPRI,*) SECNAM,': logical error: ',
     &                               'unable to qualify diagonals'
               WRITE(LUPRI,*) SECNAM,': NCOLAB = ',NCOLAB
               WRITE(LUPRI,*) SECNAM,': NSEL   = ',NSEL
               CALL CHO_QUIT('[1] Logical error in '//SECNAM,104)

            END IF

         END IF

      END DO

C     Test loop exit (we may have calculated all possible integrals, yet
C     NSEL < MINQUAL or allowed memory may have been used).
C     ------------------------------------------------------------------

      IF (.NOT. DODECO) THEN
         NSEL = CHO_ISUMELM(NQUAL,NSYM)
         IF (NSEL .LT. 1) THEN
            WRITE(LUPRI,*) SECNAM,': logical error: ',
     &                            'unable to qualify diagonals'
            WRITE(LUPRI,*) SECNAM,': Flag DODECO is ',DODECO
            WRITE(LUPRI,*) SECNAM,': NSEL    = ',NSEL
            WRITE(LUPRI,*) SECNAM,': ICOUNT  = ',ICOUNT
            WRITE(LUPRI,*) SECNAM,': MCOUNT  = ',MCOUNT
            WRITE(LUPRI,*) SECNAM,': NPOTSH  = ',NPOTSH
            WRITE(LUPRI,*) SECNAM,': MINQUAL = ',MINQUAL
            CALL CHO_QUIT('[2] Logical error in '//SECNAM,103)
         ELSE
            DODECO = .TRUE.
         END IF
      END IF

C     Set indices for local qualified (parallel runs).
C     ------------------------------------------------

      CALL CHO_P_SETLQ()

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Size_SO_block_g(iSD4,nSD,nSO,No_batch)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nSD, iSD4(0:nSD,4)
integer(kind=iwp), intent(out) :: nSO
logical(kind=iwp), intent(out) :: No_batch
integer(kind=iwp), external :: MemSO2_P

nSO = MemSO2_P(iSD4(2,1),iSD4(2,2),iSD4(2,3),iSD4(2,4),iSD4(7,1),iSD4(7,2),iSD4(7,3),iSD4(7,4))
No_batch = nSO == 0

return

end subroutine Size_SO_block_g

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine axexbsol_cvb( &
#                       define _CALLING_
#                       include "ddsol_interface.fh"
                       )
! Solve linear equation in Davidson subspace.

use casvb_global, only: cnrm, corenrg, ifollow, ipdd, nroot, safety, signtol
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "ddsol_interface.fh"
integer(kind=iwp) :: i, ioptc, nnegeig, nposeig
real(kind=wp) :: alfastart, eigmn, eigmx, gnrm, ovr_dx_grad, safety_use
real(kind=wp), allocatable :: dxp(:), eigval(:), eigvec(:,:), gradp(:), w2(:)
real(kind=wp), external :: ddot_, dnrm2_

#include "macros.fh"
unused_var(nfrdim)

call mma_allocate(eigval,itdav,label='eigval')
call mma_allocate(eigvec,itdav,itdav,label='eigvec')
eigvec(:,:) = ap(1:itdav,1:itdav)

if (ipdd >= 3) then
  write(u6,*) ' AP matrix :'
  do i=1,itdav
    eigval(i) = eigvec(i,i)
    eigvec(i,i) = eigvec(i,i)+corenrg
  end do
  call mxprintd_cvb(eigvec,itdav,itdav,0)
  do i=1,itdav
    eigvec(i,i) = eigval(i)
  end do
  write(u6,*) ' RHSP vector :'
  call mxprint_cvb(rhsp,1,itdav,0)
end if

call mxdiag_cvb(eigvec,eigval,itdav)

if (ipdd >= 2) then
  write(u6,'(a)') ' Eigenvalues :'
  eigval(1:itdav) = eigval(1:itdav)+corenrg
  call vecprint_cvb(eigval,itdav)
  eigval(1:itdav) = eigval(1:itdav)-corenrg
end if

call mma_allocate(gradp,itdav,label='gradp')
call mxatb_cvb(rhsp,eigvec,1,itdav,itdav,gradp)
if (ifollow == 1) then
  nposeig = nroot-1
  nnegeig = itdav-nposeig
else if (ifollow == 2) then
  nnegeig = nroot-1
  nposeig = itdav-nnegeig
else
  write(u6,*) ' Error in IFOLLOW with direct Fletcher!',ifollow
  call abend_cvb()
  nnegeig = 0
  nposeig = 0
end if

call mma_allocate(dxp,itdav,label='dxp')
eigmx = -One
eigmn = One
if (nnegeig > 0) eigmx = eigval(nnegeig)
if (nposeig > 0) eigmn = eigval(nnegeig+1)
safety_use = safety
do
  if ((eigmx < -signtol) .and. (eigmn > signtol)) then
    alfastart = Zero
  else
    alfastart = max(eigmx,-eigmn,Zero)+safety_use
  end if
  call getdxp_cvb(dxp,gradp,eigval,nnegeig,itdav,alfastart)
  cnrm = dnrm2_(itdav,dxp,1)
  if (alfastart == Zero) exit
  gnrm = dnrm2_(itdav,gradp,1)
  if ((cnrm <= 1.0e-15_wp) .or. (gnrm <= 1.0e-15_wp) .or. (safety_use == 1.0e-4_wp)) exit
  ovr_dx_grad = ddot_(itdav,dxp,1,gradp,1)/(cnrm*gnrm)
  if (ovr_dx_grad >= 0.3_wp) exit
  safety_use = 1.0e-4_wp
end do

call mma_allocate(w2,itdav,label='w2')
ioptc = 0
call makedx_cvb(solp,itdav,ioptc,eigvec,eigval,dxp,gradp,w2,.false.,nposeig,.false.,.false.,nnegeig,.false.,alfastart,eig)
call mma_deallocate(eigval)
call mma_deallocate(eigvec)
call mma_deallocate(gradp)
call mma_deallocate(dxp)
call mma_deallocate(w2)

eig_res = eig
solp_res(:) = solp(:)
if (ipdd >= 2) then
  write(u6,'(a,f15.8)') ' Eigenvalue :',eig
  write(u6,'(a)') ' Solution vector :'
  call vecprint_cvb(solp,itdav)
end if

return

end subroutine axexbsol_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DAVCRE(C,HC,HH,CC,E,HD,SC,Q,QQ,S,SXSEL,NROOT,ITMAX,NDIM,ITERSX,NSXS)
! RASSCF program: version IBM-3090: SX section
!
! Using the Davidson method, in the multiple root version suggested
! by B.LIU. This routine finds the NROOT lowest eigenvalues and
! eigenvectors of a secular problem of dimension NDIM.
! This is a vectorized version adapted to run optimally on IBM 3090
! It is completely CPU bound (except maybe for the construction of
! the sigma vector). Multiple calls to this subroutine may therefore
! be necessary for cases where more iterations are needed than
! is allowed by the core space requirements to store all C and
! sigma vectors.
!
! Externals: HMAT (set up the Davidson H-matrix HH)
!            COVLP (calculate the overlap between two CI vectors)
!            Jacob (full diagonalization routine)
!            DGEMM and other ESSL routines for matrix operations
! Parameters: C  SuperCI-vectors
!             HC SuperCI Sigma vectors
!             HH Davidson's H-matrix
!             CC      "     eigenvectors
!             E       "     eigenvalues
!             HD diagonal elements of SuperCI
!             Q  the Davidson update vectors
!             QQ the norm of all Q-vectors
!             SC scratch area
!
! ********** IBM-3090 Release 88 09 08 *****

use Index_Functions, only: nTri_Elem
use fciqmc, only: DoNECI
use wadr, only: DIA, PA, SXN
use PrintLevel, only: DEBUG, INSANE
use output_ras, only: IPRLOC, RC_SX
use RASDim, only: MxSXIt
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NROOT, NDIM, NSXS
integer(kind=iwp), intent(inout) :: ITMAX
real(kind=wp), intent(out) :: C((NROOT+NSXS)*NROOT*(ITMAX+1)), CC((ITMAX*NROOT)**2), E((ITMAX*NROOT)), SC((NROOT+NSXS)), &
                              Q((NROOT+NSXS)*(NROOT+1)), QQ(NROOT), S(ITMAX*NROOT**2)
real(kind=wp), intent(inout) :: HC((NROOT+NSXS)*NROOT*ITMAX), HH((ITMAX*NROOT)*(ITMAX*NROOT+1))
real(kind=wp), intent(in) :: HD(NROOT+NSXS)
character(len=*), intent(in) :: SXSEL
integer(kind=iwp), intent(out) :: ITERSX
integer(kind=iwp) :: i, iConvA, iConvL, iConvQ, ii, ij, iPass, iPrLev, iSel, iST, iSTC, iSTQ, j, ji, jST, k, kDimH, Length, nCR, &
                     nDimH, nDimH2, nST, nTotDC, nTrial
real(kind=wp) :: ASQ, Ei, ENO, Ovl, QNorm, SWAP, XMX, XNorm, XX
character(len=4) :: IOUTW, IOUTX
real(kind=wp), allocatable :: C1(:), C2(:), X(:)
real(kind=wp), parameter :: THRA = 1.0e-13_wp, THRLD1 = 1.0e-8_wp, THRLD2 = 5.0e-14_wp, THRQ = 1.0e-7_wp, THRZ = 1.0e-6_wp
real(kind=wp), external :: DDot_
#include "warnings.h"

! Local print level (if any)
IPRLEV = IPRLOC(1)
if (IPRLEV >= DEBUG) then
  write(u6,*) ' Entering DAVCRE'
  write(u6,*) 'Super-CI diagonalization. Max iterations: ',ITMAX
end if

! Set values at loop head and starting guess of the vectors C

Rc_SX = 0
NTRIAL = NROOT
NCR = NROOT*NDIM
C(1:NCR) = Zero
II = 0
do I=1,NROOT
  C(II+I) = One
  II = II+NDIM
end do

! memory allocation for COVLP

call mma_allocate(C1,NSXS,Label='C1')
call mma_allocate(C2,NSXS,Label='C2')
call mma_allocate(X,NSXS,Label='X')

! Begin Davidson iterations
! Start by setting up the Davidson HH-matrix
! The dimension of this matrix, NDIMH, is updated in HMAT

NDIMH = 0

!*************************************************************
!               Head of Super-CI iteration loop:
!*************************************************************
do ITERSX=1,ITMAX
  call HMAT(C,HC,HH,HD,NDIM,NDIMH,NTRIAL)
  KDIMH = nTri_Elem(NDIMH)

  ! Echo the HH-matrix before diagonalizing it.

  HH(KDIMH+1:2*KDIMH) = HH(1:KDIMH)

  if (IPRLEV >= DEBUG) then
    write(u6,*) ' Davidson H-matrix in iteration ',ITERSX
    write(u6,*) ' Davidson H-matrix triangular of size =  ',NDIMH
    write(u6,'(1x,8F14.6)') (HH(I),I=1,KDIMH)
  end if
  E(1) = HH(1)
  CC(1) = One
  if (NDIMH > 1) then

    ! set eigenvector array to identity before JACO call

    NDIMH2 = NDIMH**2
    CC(1:NDIMH2) = Zero
    II = -NDIMH
    do I=1,NDIMH
      II = II+NDIMH+1
      CC(II) = One
    end do

    call Jacob(HH(KDIMH+1),CC,NDIMH,NDIMH)
    if (SXSEL == 'LOWEST') then
      ! Root selection here assumes picking the lowest root(s).
      call JACORD(HH(KDIMH+1),CC,NDIMH,NDIMH)
      II = 0
      do I=1,NROOT
        II = II+I
        E(I) = HH(II+KDIMH)
      end do
    else
      ! Root selection by maximum overlap.
      ISEL = 1
      XMX = abs(CC(1))
      do I=2,NDIMH
        XX = abs(CC(1+NDIMH*(I-1)))
        if (XX > XMX) then
          ISEL = I
          XMX = XX
        end if
      end do
      if (ISEL /= I) then
        do I=1,NDIMH
          SWAP = CC(I+NDIMH*(ISEL-1))
          CC(I+NDIMH*(ISEL-1)) = CC(I)
          CC(I) = -SWAP
        end do
        SWAP = HH(KDIMH+nTri_Elem(ISEL))
        HH(KDIMH+nTri_Elem(ISEL)) = HH(KDIMH+1)
        HH(KDIMH+1) = SWAP
      end if
    end if

    if (IPRLEV >= DEBUG) then
      write(u6,*) ' Eigenvalues:'
      write(u6,'(1X,8F14.6)') (E(I),I=1,NROOT)
      write(u6,*) ' Eigenvectors:'
      NST = 0
      do I=1,NROOT
        write(u6,'(1X,10F11.6)') (CC(J+NST),J=1,NDIMH)
        NST = NST+NDIMH
      end do
    end if
  end if

  ! Now perform the Davidson update
  ! First form for each root I, a vector Q(I), where
  ! Q(I,K)=sum(J,M) CC(I,J,M)*(HC(M,J,K)-E(I)*C(M,J,K))
  ! here J runs over iterations and M over the number of trial
  ! vectors in each iterations E(I) is the current estimate of the
  ! energy of the I:th root, C(M,J) is the M:th trial vector used in
  ! the J:th iteration, HC being the corresponding sigma vector. CC
  ! is the matrix of eigenvectors of the Davidson Hamiltonian.

  ! STEP 1: form the matrix CCE=-CC*E (CCE in array SC)
  JI = 0
  do I=1,NROOT
    EI = E(I)
    do J=1,NDIMH
      JI = JI+1
      S(JI) = -CC(JI)*EI
    end do
  end do

  ! Step 2: form the matrix Q=HC*CC
  call DGEMM_('N','N',NDIM,NROOT,NDIMH,One,HC,NDIM,CC,NDIMH,Zero,Q(NDIM+1),NDIM)
  ! Step 3: add the contribution C*CCE
  call DGEMM_('N','N',NDIM,NROOT,NDIMH,One,C,NDIM,S,NDIMH,One,Q(NDIM+1),NDIM)

  ! Note that the NDIM first positions in Q are untouched so far
  ! the vector will be moved later
  if (IPRLEV >= INSANE) then
    write(u6,*) ' The residual vectors Q of size:',NDIM
    write(u6,'(1x,8F14.10)') (Q(NDIM+I),I=1,NDIM)
  end if

  ! Check the norms of the Q-vectors for convergence, and obtain
  ! bounds to the eigenvalues. E(I) is an upper bound to the I:th
  ! eigenvalue, from McDonald's theorem, while E(I)-NORM(Q(I))
  ! is a lower bound to the eigenvalue. This is the Weinstein lower
  ! bound formula in a multiple root form.

  ICONVQ = 0
  IST = 1+NDIM
  do I=1,NROOT
    call COVLP(Q(IST),Q(IST),DIA,PA,SXN,C1,C2,X,QQ(I))
    IST = IST+NDIM
  end do

  do I=1,NROOT
    QNORM = sqrt(QQ(I))
    if (QNORM < THRQ) ICONVQ = ICONVQ+1
    EI = E(I)
    ENO = EI-QNORM
    if (IPRLEV >= DEBUG) then
      if (NROOT > 1) then
        if (I > 1) then
          write(u6,'(20X,F16.8,A,I2,A,F16.8)') ENO,' <  SX energy ',I,'  < ',EI
        else
          write(u6,'(1X,I2,A,4X,F16.8,A,I2,A,F16.8)') ITERSX,' SX iteration ',ENO,' <  SX energy ',I,'  < ',EI
        end if
      else
        write(u6,'(1X,I2,A,4X,F16.8,A,I2,A,F16.8)') ITERSX,' SX iteration ',ENO,' <  SX energy ',I,'  < ',EI
      end if
      write(u6,*) '  Norm of Q:',QNORM
    end if
    IST = IST+NDIM
  end do
  !PAM00 End of replacement.

  ! Reset ICONVQ unless all roots are converged

  if (ICONVQ < NROOT) ICONVQ = 0

  ! Check the expansion vectors for convergence. This is done
  ! by computing the sum of the squares of CC(I,J), for each
  ! root I, and for the J trial vectors of the current iteration

  NST = NDIMH-NTRIAL+1
  ICONVA = 0
  do I=1,NROOT
    ASQ = DDOT_(NTRIAL,CC(NST),1,CC(NST),1)
    if (ASQ < THRA) ICONVA = ICONVA+1
    NST = NST+NDIMH
  end do

  ! Reset ICONVA unless all roots are converged.

  if (ICONVA < NROOT) ICONVA = 0

  ! Branch out of iteration loop if convergence has been
  ! achieved on either the energy or the Davidson expansion vectors.

  if ((ICONVQ /= 0) .or. (ICONVA /= 0)) then
    IOUTW = 'y   '
    if (NROOT > 1) IOUTW = 'ies '
    IOUTX = '    '
    if (NROOT > 1) IOUTX = 's   '
    if (IPRLEV >= DEBUG) then
      if (ICONVQ /= 0) write(u6,*) ' Convergence on CI energ'//IOUTW
      if (ICONVA /= 0) write(u6,*) ' Convergence on Davidson expansion vector'//IOUTX
    end if
    exit
  end if

  ! Calculate the D-vectors as D(I,K)=Q(I,K)/(E(I)-HD(K,K))

  IST = 1
  do I=1,NROOT
    EI = E(I)
    do K=1,NDIM
      SC(K) = EI-HD(K)
      if (abs(SC(K)) < THRZ) SC(K) = One
    end do
    Q(IST:IST+NDIM-1) = Q(IST+NDIM:IST+2*NDIM-1)/SC(1:NDIM)
    IST = IST+NDIM
  end do
  ! Remove any unwanted components. These are signalled by
  ! huge elements of SX hamiltonian diagonal (set in SXHAM).
  do I=1,NDIM
    if (HD(I) > 1.0e20_wp) then
      do J=1,NROOT
        Q(I+NDIM*(J-1)) = Zero
      end do
    end if
  end do
  if (IPRLEV >= INSANE) then
    write(u6,*) ' The correction vectors D(stored in Q):'
    write(u6,'(1x,8F14.10)') (Q(I),I=1,NDIM)
  end if

  ! Q now contains the Davidson correction vectors. These will now
  ! be orthogonalized to all old vectors and then to each other.
  !PAM01 The ON is done in two passes. A vector smaller than THRLD
  ! after the first ON pass is considered to contribute nothing worthwhile
  ! to the Davidson procedure, and is discarded. Else, it is normalized.
  ! If it is not still normalized to within an accuracy THRLD after the
  ! second pass, then again it is discarded: it means that the rescaling
  ! after pass 1, together with numerical noise amplification in
  ! COVLP, is beginning to be noticable. The latter will of course happen
  ! when some orbital rotation(s) are almost redundant.

  IPASS = 0
  ICONVL = 0
  NTOTDC = NROOT

  do

    ! First form the overlap matrix
    IJ = 0
    ISTQ = 1
    do I=1,NTOTDC
      ISTC = 1
      do J=1,NDIMH
        IJ = IJ+1
        call COVLP(Q(ISTQ),C(ISTC),DIA,PA,SXN,C1,C2,X,OVL)
        S(IJ) = -OVL
        ISTC = ISTC+NDIM
      end do
      ISTQ = ISTQ+NDIM
    end do
    call DGEMM_('N','N',NDIM,NTOTDC,NDIMH,One,C,NDIM,S,NDIMH,One,Q,NDIM)

    ! The Q-vectors are now orthogonal to all C-vectors.
    if (IPRLEV >= INSANE) then
      write(u6,*) '  D vector orthogonal to all C vectors:'
      write(u6,'(1x,8F14.10)') (Q(I),I=1,NDIM)
    end if
    ! Now orthogonalize them to one another, rejecting those which
    ! appear with too small a norm

    IST = 1
    NTRIAL = 0

    ! Long loop over NTOTDC vectors:
    do I=1,NTOTDC
      if ((I /= 1) .and. (NTRIAL /= 0)) then

        ! Orthogonalize this vector to the preceding Q's of this iteration

        JST = 1
        do J=1,NTRIAL
          call COVLP(Q(IST),Q(JST),DIA,PA,SXN,C1,C2,X,OVL)
          S(J) = -OVL
          JST = JST+NDIM
        end do
        !call DGEMX(NDIM,NTRIAL,One,Q,NDIM,S,1,Q(IST),1)
        call DGEMV_('N',NDIM,NTRIAL,One,Q,NDIM,S,1,One,Q(IST),1)
        if (IPRLEV >= INSANE) then
          write(u6,*) '  Q vector orthogonal to preceding Q vectors:'
          write(u6,'(1x,8F14.10)') (Q(k),k=1,NDIM)
        end if
      end if

      ! Normalize this vector and move to trial set if norm large enough

      call COVLP(Q(IST),Q(IST),DIA,PA,SXN,C1,C2,X,XNORM)
      ! Due to large noise amplification in COVLP, the squared-norm
      ! can actually come out as a negative number.
      ! Acceptable, only if it is very close to zero. Else, quit.
      if (XNORM < -1.0e-9_wp) then
        write(u6,*)
        write(u6,*) '      *** Error in subroutine DAVCRE ***'
        write(u6,*) ' The squared norm of a trial vector has been'
        write(u6,*) ' computed to be negative:'
        write(u6,*) '      XNORM=',XNORM
        write(u6,*) ' This is possible only for some severe malfunction'
        write(u6,*) ' of the rasscf program. Please issue a bug report.'
        write(u6,*)
        if (.not. DoNECI) then
          call Quit(_RC_GENERAL_ERROR_)
        else
          write(u6,*) ' non positive-semi definite matrix occurred.'
          write(u6,*) ' Calculation will continue. '
          write(u6,*) ' Divergent results might occur'
          write(u6,*) ' Tests for possible solution on the way...'
        end if
      end if
      XNORM = sqrt(max(Zero,XNORM))
      if (IPRLEV >= INSANE) write(u6,'(1X,A,I3,A,I3,A,ES16.8)') 'Pass ',IPASS,' New orthogonal vector ',I,' has norm ',XNORM

      !PAM01 Two different treatments, depending on if this is first or
      ! second orthonormalization pass:
      if (IPASS == 0) then
        ! First pass:
        if ((ITERSX == 1) .or. (XNORM > THRLD1)) then
          ISTQ = NTRIAL*NDIM+1
          NTRIAL = NTRIAL+1
          XNORM = One/(XNORM+1.0e-24_wp)
          !PAM01 Note that ISTQ can be (and is!) the same as IST:
          Q(ISTQ:ISTQ+NDIM-1) = XNORM*Q(IST:IST+NDIM-1)
        end if
      else
        ! Second pass: Demand accurate normalization, else we know that
        ! poor independence, maybe with strong rounding-error amplification
        ! in COVLP, has began to erode the orthonormalization of the
        ! basis vectors, hence the integrity of the Davidson procedure.
        if ((ITERSX == 1) .or. (abs(XNORM-One) < THRLD2)) then
          ISTQ = NTRIAL*NDIM+1
          NTRIAL = NTRIAL+1
          XNORM = One/(XNORM+1.0e-24_wp)
          !PAM01 Note that ISTQ can be (and is!) the same as IST:
          Q(ISTQ:ISTQ+NDIM-1) = XNORM*Q(IST:IST+NDIM-1)
        end if
      end if
      IST = IST+NDIM

    ! End over long loop over NTOTDC vectors I=1..NTOTDC
    end do

    ! NTRIAL new orthogonal vectors have now been formed. if NTRIAL
    ! equals zero there are no new linearly independent trial vectors
    ! and we branch out. If NTRIAL does not equal zero make a second
    ! orthonormalization pass

    if (NTRIAL == 0) ICONVL = 1
    NTOTDC = NTRIAL
    IPASS = IPASS+1
    if ((IPASS == 2) .or. (NTOTDC == 0)) exit
  end do
  if (IPRLEV >= INSANE) then
    write(u6,*) ' The correction vectors, after ON:'
    write(u6,'(1x,8F14.10)') (Q(I),I=1,NDIM*NTRIAL)
  end if

  ! Check if the set of vectors has become linearly dependent

  if (ICONVL == 1) then
    if (IPRLEV >= DEBUG) write(u6,*) ' Trial vector set has become linearly dependent'
    exit
  end if

  ! Move the new orthogonal vectors to C

  NST = 1+NDIMH*NDIM
  LENGTH = NTRIAL*NDIM
  C(NST:NST+LENGTH-1) = Q(1:LENGTH)

  if (IPRLEV >= DEBUG) write(u6,'(1X,A,I2,A)') ' Adding ',NTRIAL,' new vectors.'
  if (IPRLEV >= INSANE) then
    IST = NDIMH*NDIM
    do I=1,NTRIAL
      write(u6,'(1X,A,I2,A)') ' New vector ',I,' is:'
      write(u6,'(1X,10F11.6)') (C(IST+K),K=1,NDIM)
      IST = IST+NDIM
    end do
  end if
end do

if (ITERSX > ITMAX) then
  ! At this point, the calculation has neither converged, nor
  ! produced linearly dependent trial vectors.

  if (IPRLEV >= DEBUG) then
    if (ITMAX < MXSXIT) then
      write(u6,*) ' Super-CI not converged. Max SX iter increased.'
    else
      write(u6,*) ' Super-CI not converged.'
    end if
  end if
  ITMAX = min(ITMAX+2,MXSXIT)
  Rc_SX = 16
end if

! Compute CI vectors for all roots
!
! CI NEW (K) = sum(J,M)CC(I,J M)*C M J (K)
!
! Here J runs over the iterations, and M over the
! number of trial vectors used in each iteration J

call DGEMM_('N','N',NDIM,NROOT,NDIMH,One,C,NDIM,CC,NDIMH,Zero,Q,NDIM)
if (IPRLEV >= INSANE) then
  write(u6,*) ' Unnormalized final CI vectors (in Q):'
  write(u6,'(1x,8F14.10)') (Q(I),I=1,NDIM)
end if

! Normalize the final CI vectors

IST = 1
do I=1,NROOT
  call COVLP(Q(IST),Q(IST),DIA,PA,SXN,C1,C2,X,XNORM)
  XNORM = One/XNORM
  C(IST:IST+NDIM-1) = XNORM*Q(IST:IST+NDIM-1)
  IST = IST+NDIM
end do

! Print vector if desired

if (IPRLEV >= INSANE) then
  IST = 0
  do I=1,NROOT
    write(u6,*) ' SX-CI vector for root ',I
    write(u6,'(1X,8F8.4)') (C(IST+K),K=1,NDIM)
    IST = IST+NDIM
  end do
end if

! End of diagonalization
! Free memory for COVLP

call mma_deallocate(C1)
call mma_deallocate(C2)
call mma_deallocate(X)

end subroutine DAVCRE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine GetU_ER(U,R,n)
C
C     Thomas Bondo Pedersen, November 2005.
C
C     Purpose: compute U = R*[R^T*R]^(-1/2).
C
C     (used by ER orbital localisation - hence the _ER)
C
      Implicit None
      Integer n
      Real*8 U(n,n), R(n,n)
#include "WrkSpc.fh"

      Integer nn,n2
      Integer ipRTR, lRTR
      Integer ipSqrt, lSqrt, ipISqrt, lISqrt
      Integer ipScr, lScr
      Integer iTask

      If (n .lt. 1) Return

C     Allocations.
C     ------------

      nn = n*(n+1)/2
      n2 = n**2

      lRTR = n2
      lSqrt = n2
      lISqrt = n2
      lScr = 2*n2 + nn
      Call GetMem('RTR','Allo','Real',ipRTR,lRTR)
      Call GetMem('Sqrt','Allo','Real',ipSqrt,lSqrt)
      Call GetMem('ISqrt','Allo','Real',ipISqrt,lISqrt)
      Call GetMem('Scr','Allo','Real',ipScr,lScr)

C     Compute R^T*R.
C     --------------

      Call DGEMM_('T','N',n,n,n,1.0d0,R,n,R,n,0.0d0,Work(ipRTR),n)

C     Compute inverse square root of R^T*R.
C     -------------------------------------

      iTask = 2 ! compute sqrt as well as inverse sqrt
      Call SqrtMt(Work(ipRTR),n,iTask,Work(ipSqrt),Work(ipISqrt),
     &            Work(ipScr))

C     Compute U.
C     ----------

      Call DGEMM_('N','N',n,n,n,1.0d0,R,n,Work(ipISqrt),n,0.0d0,U,n)

C     De-allocations.
C     ---------------

      Call GetMem('Scr','Free','Real',ipScr,lScr)
      Call GetMem('ISqrt','Free','Real',ipISqrt,lISqrt)
      Call GetMem('Sqrt','Free','Real',ipSqrt,lSqrt)
      Call GetMem('RTR','Free','Real',ipRTR,lRTR)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PPInt( &
#                define _CALLING_
#                include "int_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: to compute pseudo potential integrals.                       *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
integer(kind=iwp), parameter :: lproju = 9, imax = 100, kcrs = 1
integer(kind=iwp) :: iA, iAB, iAlpha, iB, iBeta, iCntr, iCnttp, iDCRT(0:7), iExp, intmax, iOff, iOff2, ipA, ipScr, iSh, iStrt, &
                     iZeta, kdc, kSh, kShEnd, kShStr, lcr(kcrs), lDCRT, LmbdT, nArray, ncr(imax), ncrr, nDCRT, &
                     nkcrl(lproju+1,kcrs), nkcru(lproju+1,kcrs), nOp, npot, nPP_S
real(kind=wp) :: C(3), ccr(imax), Fact, TC(3), zcr(imax)
integer(kind=iwp), external :: NrOpr
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif

#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(P)
unused_var(nHer)
unused_var(Ccoor)
unused_var(nOrdOp)
unused_var(PtChrg)
unused_var(nGrid)
unused_var(iAddPot)

!                                                                      *
!***********************************************************************
!                                                                      *
call dcopy_(nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nIC,[Zero],0,rFinal,1)
!                                                                      *
!***********************************************************************
!                                                                      *
nArray = 0
ipScr = 1
intmax = max(nTri_Elem1(la),nTri_Elem1(lb))
intmax = intmax**2
nArray = nArray+intmax
ipA = ipScr+2*intmax
nArray = nArray+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)
if (nArray > nZeta*nArr) then
  write(u6,*) 'nArray > nZeta*nArr'
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
kdc = 0
do iCnttp=1,nCnttp
  if (iCnttp > 1) kdc = kdc+dbsc(iCnttp-1)%nCntr

  if (dbsc(iCnttp)%nPP == 0) cycle
  !AOM< Get the "true" (non SO) shells
  nPP_S = 0
  do kSh=dbsc(iCnttp)%iPP,dbsc(iCnttp)%iPP+dbsc(iCnttp)%nPP-1
    ! Skip if a cardholder shell
    if (Shells(kSh)%nExp <= 0) cycle
    ncrr = int(Shells(kSh)%Exp(1))
    if (ncrr <= 500) nPP_S = nPP_S+1
  end do
  if (nPP_S == 0) cycle
  !AOM>

  npot = 0
  kShStr = dbsc(iCnttp)%iPP
  kShEnd = kShStr+nPP_S-1
  if (nPP_S-1 > lproju) then
    write(u6,*) 'dbsc(iCnttp)%nPP-1 > lproju'
    write(u6,*) 'dbsc(iCnttp)%nPP   =',nPP_S
    write(u6,*) 'lproju             =',lproju
    call Abend()
  end if
  lcr(kcrs) = nPP_S-1
  iSh = 0
  iOff = 1
  do kSh=kShStr,kShEnd
    iSh = iSh+1
    nkcrl(iSh,kcrs) = iOff
    nkcru(iSh,kcrs) = iOff+Shells(kSh)%nExp/3-1
    iOff = iOff+Shells(kSh)%nExp/3
    if (nPot > imax) then
      write(u6,*) ' Pseudo: nPot > imax'
      write(u6,*) '         nPot=',nPot
      write(u6,*) '         imax=',imax
      call Abend()
    end if
    iStrt = 1
    do iExp=1,Shells(kSh)%nExp/3
      npot = npot+1
      ncr(npot) = int(Shells(kSh)%Exp(iStrt))
      zcr(npot) = Shells(kSh)%Exp(iStrt+1)
      ccr(npot) = Shells(kSh)%Exp(iStrt+2)
      iStrt = iStrt+3
    end do
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) 'ncr',(ncr(i),i=1,npot)
  write(u6,*) 'zcr',(zcr(i),i=1,npot)
  write(u6,*) 'ccr',(ccr(i),i=1,npot)
  write(u6,*) 'nkcrl',(nkcrl(i,1),i=1,iSh)
  write(u6,*) 'nkcru',(nkcru(i,1),i=1,iSh)
# endif

  do iCntr=1,dbsc(iCnttp)%nCntr
    C(1:3) = dbsc(iCnttp)%Coor(1:3,iCntr)

    ! Find the DCR for M and S

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+iCntr)%iStab,dc(kdc+iCntr)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    do lDCRT=0,nDCRT-1
      call OA(iDCRT(lDCRT),C,TC)
      !                                                                *
      !*****************************************************************
      !                                                                *
      iZeta = 0
      do iBeta=1,nBeta
        do iAlpha=1,nAlpha
          iZeta = iZeta+1
          call FZero(Array(ipScr),intmax)
          call Pseudo(Alpha(iAlpha),A(1),A(2),A(3),la+1,Beta(iBeta),RB(1),RB(2),RB(3),lb+1,Array(ipScr),intmax,max(la+1,lb+1),ccr, &
                      zcr,nkcrl,nkcru,lcr,ncr,TC(1),TC(2),TC(3),npot)

          do iB=1,nTri_Elem1(lb)
            do iA=1,nTri_Elem1(la)
              iAB = (iB-1)*nTri_Elem1(la)+iA
              iOff2 = (iB-1)*nTri_Elem1(la)*nZeta+(iA-1)*nZeta+iZeta+ipA-1
              Array(iOff2) = Array(iAB+ipScr-1)
            end do ! iA
          end do   ! iB

        end do     ! iAlpha
      end do       ! iBeta
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Symmetry Adapt

      nOp = NrOpr(iDCRT(lDCRT))
      call SymAdO(Array(ipA),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,Fact)
    end do ! lDCRT
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end do   ! iCntr
end do     ! iCnttp
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine PPInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine psym2_cvb(civec1,civec2,isymalf,isymbet,iasyind,ibsyind,osym,ips)

use Symmetry_Info, only: Mul
use casvb_global, only: isympr, mxirrep, nda, ndb, nirrep
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: civec1(nda,ndb), osym(mxirrep)
real(kind=wp), intent(in) :: civec2(nda,ndb)
integer(kind=iwp), intent(in) :: isymalf(nda), isymbet(ndb), iasyind(0:mxirrep), ibsyind(0:mxirrep), ips
integer(kind=iwp) :: ida, idb, inda, irp, jrpa, jrpb

if (ips == 1) then
  do irp=1,nirrep
    if (isympr(irp) == 1) cycle
    do jrpa=1,nirrep
      jrpb = Mul(irp,jrpa)
      do ida=iasyind(jrpa-1)+1,iasyind(jrpa)
        inda = isymalf(ida)
        do idb=ibsyind(jrpb-1)+1,ibsyind(jrpb)
          civec1(inda,isymbet(idb)) = Zero
        end do
      end do
    end do
  end do
else if (ips == 2) then
  do irp=1,nirrep
    osym(irp) = Zero
    do jrpa=1,nirrep
      jrpb = Mul(irp,jrpa)
      do ida=iasyind(jrpa-1)+1,iasyind(jrpa)
        inda = isymalf(ida)
        do idb=ibsyind(jrpb-1)+1,ibsyind(jrpb)
          osym(irp) = osym(irp)+civec1(inda,isymbet(idb))*civec2(inda,isymbet(idb))
        end do
      end do
    end do
  end do
end if

return

end subroutine psym2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine opt2_cvb(orbs,cvb)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "formats_cvb.fh"
#include "malloc_cvb.fh"
      dimension orbs(norb,norb),cvb(nvb)

c The following initialization is to appease a compiler
      fx=zero
      ioptc=0
      iter=0

      if(imethod.eq.11)then
c  Method = None :
        goto 10
      endif
      if(imethod.eq.4)then
        if(icrit.eq.1)then
          call svbd_cvb(orbs,cvb,fx,ioptc,iter)
        elseif(icrit.eq.2)then
          call evbd_cvb(orbs,cvb,fx,ioptc,iter)
        endif
        goto 10
      elseif(imethod.eq.6)then
        call evb2cas_cvb(orbs,cvb,fx,ioptc,iter)
        goto 10
      endif

      fx=zero

      call optize_cvb(fx,ioptc,iter,
     >  imethod,isaddle,mxiter,icrit.eq.1,corenrg,ip(3),ip(4)-2,ip(4)-2,
     >  strucopt)

      if(ioptc.eq.-1.and.mxiter.gt.0)then
        if(ip(3).ge.0)write(6,'(a,i4)')
     >    ' Maximum number of iterations reached:',mxiter
        if(ip(3).ge.0)
     >  write(6,'(a)')' Calculation NOT converged!!!'
      endif
10    continue
      if(icrit.eq.1)then
        svb=fx
      else
        evb=fx
      endif
      if(ip(5).ge.0)then
        if(imethod.ne.11)then
          if(icrit.eq.1)write(6,formE)' Final Svb :',svb
          if(icrit.eq.2)write(6,formE)' Final Evb :',evb
        endif
        if(ip(3).le.1.and.ioptc.ne.-1)
     >    write(6,'(a,i4)')' Number of iterations used:',iter
      endif
      if(ip(5).ge.2)then
        call report_cvb(orbs,norb)
        write(6,'(/,a)')' Structure coefficients :'
        write(6,'(a)')' ------------------------'
        call vecprint_cvb(cvb,nvb)
      endif
      convinone=((ioptc.eq.0.and.iter.le.1).or.endvar)
      ioptc_new=ioptc
      n_iter=n_iter+iter
      if(ioptc.eq.1)ioptc_new=mxiter
      if(ioptc.eq.0)ioptc_new=iter
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine MIJKL(JSY,INDX,C,S,FIJKL,BUFIN,W,THET,ENP,EPP,NII)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use cpf_global, only: IRC, IREF0, IROW, ITER, JSC, KBUFF1, LASTAD, LN, LSYM, Lu_CIGuga, Lu_TiABCI, NCONF, NNS, NVIR
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, RtoI

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JSY(*), INDX(*), NII
real(kind=wp), intent(in) :: C(*), THET(NII,NII), ENP(*)
real(kind=wp), intent(inout) :: S(*), W(*), EPP(*)
real(kind=wp), intent(_OUT_) :: FIJKL(*), BUFIN(*)
integer(kind=iwp) :: IADD10, IADR, IC1, IC2, ICHK, ILEN, IND, INDA, INDB, INDI, INUM, IP, IVL, JP, KKBUF0, KKBUF1, KKBUF2, KP, &
                     LENGTH, LP, NA, NB, NIJ, NIJKL, NKL, NS1, NS1L
real(kind=wp) :: COPI, ENPQ, FACS, FACW, FACWA, FACWB, FINI
integer(kind=iwp), external :: JSUNP

call MIJKL_INTERNAL(BUFIN)

! This is to allow type punning without an explicit interface
contains

subroutine MIJKL_INTERNAL(BUFIN)

  real(kind=wp), target, intent(_OUT_) :: BUFIN(*)
  integer(kind=iwp), pointer :: IBUFIN(:)
  integer(kind=iwp) :: IIN

  call c_f_pointer(c_loc(BUFIN),iBUFIN,[1])

  FINI = Zero ! dummy initialize
  NCONF = JSC(4)
  ICHK = 0
  NIJ = IROW(LN+1)
  NIJKL = NIJ*(NIJ+1)/2
  FIJKL(1:NIJKL) = Zero
  KKBUF0 = (RTOI*(KBUFF1+2)-2)/(RTOI+1)
  KKBUF1 = RTOI*KKBUF0+KKBUF0+1
  KKBUF2 = KKBUF1+1
  IADR = LASTAD(1)
  do
    call iDAFILE(Lu_TiABCI,2,IBUFIN,KKBUF2,IADR)
    LENGTH = IBUFIN(KKBUF1)
    IADR = IBUFIN(KKBUF2)
    if (LENGTH /= 0) call SCATTER(LENGTH,FIJKL,IBUFIN(RTOI*KKBUF0+1:RTOI*KKBUF0+LENGTH),BUFIN)
    if (IADR == -1) exit
  end do
  IADD10 = IAD10(5)
  do
    call dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
    call iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
    ILEN = ICOP1(nCOP+1)
    if (ILEN == 0) cycle
    if (ILEN < 0) exit
    do IIN=1,ILEN
      IND = ICOP1(IIN)
      if (ICHK == 0) then
        if (IND /= 0) then
          if (abs(FINI) < 1.0e-6_wp) cycle
          IVL = ibits(IND,0,6)
          IC2 = ibits(IND,6,13)
          IC1 = ibits(IND,19,13)
          COPI = COP(IIN)*FINI
          if (IVL == 0) then
            if (IC1 == IREF0) then
              COPI = COPI/sqrt(ENP(IC2))
              S(IC2) = S(IC2)+COPI
              if (ITER /= 1) EPP(IC2) = EPP(IC2)+COPI*C(IC2)
            else if (IC2 == IREF0) then
              COPI = COPI/sqrt(ENP(IC1))
              S(IC1) = S(IC1)+COPI
              if (ITER /= 1) EPP(IC1) = EPP(IC1)+COPI*C(IC1)
            else
              ENPQ = (One-THET(IC1,IC2)*Half)*(ENP(IC1)+ENP(IC2)-One)+THET(IC1,IC2)*Half
              FACS = sqrt(ENP(IC1))*sqrt(ENP(IC2))/ENPQ
              FACW = FACS*(Two-THET(IC1,IC2))/ENPQ
              FACWA = FACW*ENP(IC1)-FACS
              FACWB = FACW*ENP(IC2)-FACS
              S(IC1) = S(IC1)+FACS*COPI*C(IC2)
              S(IC2) = S(IC2)+FACS*COPI*C(IC1)
              W(IC1) = W(IC1)+FACWA*COPI*C(IC2)
              W(IC2) = W(IC2)+FACWB*COPI*C(IC1)
            end if
          else
            INDA = IRC(IVL)+IC1
            INDB = IRC(IVL)+IC2
            ENPQ = (One-THET(INDA,INDB)*Half)*(ENP(INDA)+ENP(INDB)-One)+THET(INDA,INDB)*Half
            FACS = sqrt(ENP(INDA))*sqrt(ENP(INDB))/ENPQ
            FACW = FACS*(Two-THET(INDA,INDB))/ENPQ
            FACWA = FACW*ENP(INDA)-FACS
            FACWB = FACW*ENP(INDB)-FACS
            NA = INDX(INDA)
            NB = INDX(INDB)
            NS1 = JSUNP(JSY,INDA)
            NS1L = MUL(NS1,LSYM)
            INUM = NVIR(NS1L)
            if (IVL >= 2) INUM = NNS(NS1L)
            S(NA+1:NA+INUM) = S(NA+1:NA+INUM)+COPI*FACS*C(NB+1:NB+INUM)
            S(NB+1:NB+INUM) = S(NB+1:NB+INUM)+COPI*FACS*C(NA+1:NA+INUM)
            W(NA+1:NA+INUM) = W(NA+1:NA+INUM)+COPI*FACWA*C(NB+1:NB+INUM)
            W(NB+1:NB+INUM) = W(NB+1:NB+INUM)+COPI*FACWB*C(NA+1:NA+INUM)
          end if
        else
          ICHK = 1
        end if
      else
        ICHK = 0
        INDI = IND
        IP = ibits(INDI,0,8)
        JP = ibits(INDI,8,8)
        KP = ibits(INDI,16,8)
        LP = ibits(INDI,24,8)
        NIJ = IROW(IP)+JP
        NKL = IROW(KP)+LP
        IND = NIJ*(NIJ-1)/2+NKL
        FINI = FIJKL(IND)
      end if
    end do
  end do

  nullify(IBUFIN)

  return

end subroutine MIJKL_INTERNAL

end subroutine MIJKL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************
subroutine CalcOrbOff()

use nq_Info, only: iOff_Ash, iOff_Bas, iOff_BasAct, mBas, mIrrep, mOrb, NASH, NASHT, nFro, nIsh, nOrbt, nPot1, OffBas, OffBas2, &
                   OffBasFro, OffOrb, OffOrb2, OffOrbTri
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iIrrep, jOffA_, jOffB_, nTri

NASHT = 0
jOffA_ = 0
jOffB_ = 0
nPot1 = 0
nTri = 0
nOrbt = 0
do iIrrep=0,mIrrep-1
  mOrb(iIrrep) = mBas(iIrrep)-nFro(iIrrep)
  nPot1 = nPot1+mOrb(iIrrep)**2
  nOrbt = nOrbt+mOrb(iIrrep)
  NASHT = NASHT+NASH(iIrrep)
  iOff_Ash(iIrrep) = jOffA_
  iOff_Bas(iIrrep) = jOffB_
  OffBasFro(iIrrep) = jOffB_+nFro(iIrrep)
  iOff_BasAct(iIrrep) = jOffB_+nIsh(iIrrep)+nFro(iIrrep)
  OffOrbTri(iIrrep) = nTri
  nTri = nTri+mOrb(iIrrep)*(mOrb(iIrrep)+1)/2
  jOffA_ = jOffA_+nAsh(iIrrep)
  jOffB_ = jOffB_+mBas(iIrrep)
end do

OffOrb(0) = 0
OffBas(0) = 1
OffBas2(0) = 1
OffOrb2(0) = 0
do IIrrep=1,mIrrep-1
  OffBas(iIrrep) = OffBas(iIrrep-1)+mBas(iIrrep-1)
  OffOrb(iIrrep) = OffOrb(iIrrep-1)+mOrb(iIrrep-1)
  OffBas2(iIrrep) = OffBas2(iIrrep-1)+mBas(iIrrep-1)**2
  OffOrb2(iIrrep) = OffOrb2(iIrrep-1)+mOrb(iIrrep-1)**2
end do

return

end subroutine CalcOrbOff

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE MATML7(       C,       A,       B,   NCROW,   NCCOL,
     &                     NAROW,   NACOL,   NBROW,   NBCOL, FACTORC,
     &                  FACTORAB, ITRNSP )
C
C MULTIPLY A AND B TO GIVE C
C
C     C =  FACTORC*C + FACTORAB* A * B             FOR ITRNSP = 0
C
C     C =  FACTORC*C + FACTORAB* A(T) * B FOR ITRNSP = 1
C
C     C =  FACTORC*C + FACTORAB* A * B(T) FOR ITRNSP = 2
C
C     C =  FACTORC*C + FACTORAB* A(T) * B(T) FOR ITRNSP = 3
*
* Warning ITRNSP = 3 should only be used for small matrices,
* as this path involves notunit strides in inner loops.
* As Lasse points out, it is better to calculate C(T) = BA
* and then transpose C
*
C... JEPPE OLSEN,
*
* ITRNSP = 3 added, march 2003
C
*. Notice : If the summation index has dimension zero nothing
*           is performed
      IMPLICIT REAL*8           (A-H,O-Z)
      DIMENSION A(NAROW,NACOL),B(NBROW,NBCOL)
      DIMENSION C(NCROW,NCCOL)

      IF(NAROW.eq.0.or.NACOL.eq.0.or.NBROW.eq.0.or.
     &   NBCOL.eq.0.or.NCROW.eq.0.or.NCCOL .EQ. 0) THEN
        IZERO = 1
      ELSE
        IZERO = 0
      END IF
*
      IF(IZERO.EQ.1.AND.NCROW*NCCOL.NE.0) THEN
        IF(FACTORC.NE.0.0D0) THEN
         CALL SCALVE(C,FACTORC,NCROW*NCCOL)
        ELSE
         ZERO = 0.0D0
         CALL SETVEC(C,ZERO,NCROW*NCCOL)
        END IF
      END IF
*
      IF (IZERO.EQ.0 ) THEN
*. DGEMM from CONVEX/ESSL  lib
        LDA = MAX(1,NAROW)
        LDB = MAX(1,NBROW)
*
        LDC = MAX(1,NCROW)
        IF(ITRNSP.EQ.0) THEN
        CALL DGEMM_(      'N',      'N',    NAROW,    NBCOL,    NACOL,
     &               FACTORAB,        A,      LDA,        B,      LDB,
     &                FACTORC,        C,      LDC)
        ELSE IF (ITRNSP.EQ.1) THEN
        CALL DGEMM_(      'T',      'N',    NACOL,    NBCOL,    NAROW,
     &               FACTORAB,        A,      LDA,        B,      LDB,
     &                FACTORC,        C,      LDC)
        ELSE IF(ITRNSP.EQ.2) THEN
        CALL DGEMM_(      'N',      'T',    NAROW,    NBROW,    NACOL,
     &               FACTORAB,        A,      LDA,        B,      LDB,
     &                FACTORC,        C,      LDC)
        END IF

c here if iZERO == 1
      ELSE
* Use Jeppes version ( it should be working )
        IF( ITRNSP .EQ. 0 ) THEN
* ======
* C=A*B
* ======
*
C         CALL SCALVE(C,FACTORC,NCROW*NCCOL)
          DO J =1, NCCOL
*. Initialize with FACTORC*C(I,J) + FACTORAB*A(I,1)*B(1,J)
            IF(NBROW.GE.1) THEN
              B1J = FACTORAB*B(1,J)
              DO I = 1, NCROW
                C(I,J) = FACTORC*C(I,J) + B1J*A(I,1)
              END DO
            END IF
*. and the major part
            DO K =2, NBROW
              BKJ = FACTORAB*B(K,J)
              DO I = 1, NCROW
                C(I,J) = C(I,J) + BKJ*A(I,K)
              END DO
            END DO
          END DO
*
        END IF
        IF ( ITRNSP .EQ. 1 ) THEN
*
* =========
* C=A(T)*B
* =========
*
          DO J = 1, NCCOL
            DO I = 1, NCROW
              T = 0.0D0
              DO K = 1, NBROW
                T = T  + A(K,I)*B(K,J)
              END DO
              C(I,J) = FACTORC*C(I,J) + FACTORAB*T
            END DO
          END DO
        END IF
C
        IF ( ITRNSP .EQ. 2 ) THEN
C ===========
C. C = A*B(T)
C ===========
          DO J = 1,NCCOL
*. Initialization
            IF(NBCOL.GE.1) THEN
              BJ1 = FACTORAB*B(J,1)
              DO I = 1, NCROW
                C(I,J) = FACTORC*C(I,J) + BJ1*A(I,1)
              END DO
            END IF
*. And the rest
            DO K = 2,NBCOL
              BJK = FACTORAB*B(J,K)
              DO I = 1, NCROW
                C(I,J) = C(I,J) + BJK*A(I,K)
              END DO
            END DO
          END DO
        END IF
      END IF
*
c end of iZero ==1

      IF(ITRNSP.EQ.3) THEN
C ================
C. C = A(T)*B(T)
C ================
* C(I,J) = FACTORC*C(I,J) + FACTORAB*sum(K) A(K,I)*B(J,K)
        CALL SCALVE(C,FACTORC,NCROW*NCCOL)
        DO I = 1, NCROW
          DO K = 1, NAROW
            AKI = FACTORAB*A(K,I)
            DO J = 1,NBROW
              C(I,J) = C(I,J) + AKI*B(J,K)
            END DO
          END DO
        END DO
      END IF
C
c      IF ( NTEST .NE. 0 ) THEN
c      WRITE(6,*)
c      WRITE(6,*) ' C MATRIX FROM MATML7 '
c      WRITE(6,*)
c      CALL WRTMAT(C,NCROW,NCCOL,NCROW,NCCOL)
c      END IF
C
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine INT3(I,J,K,L,IT1,IT2,II,IID,JJ,JJD,JTYP,ITAI,L0,L1,L2,L3)
! K < I < J < L

use guga_global, only: COUP, IJ, IVF0, IWAY, IX, J1, J2, JM, JM1
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: I, J, K, L, IT1, IT2, II, IID, JJ, JJD, JTYP, L0(*), L1(*), L2(*), L3(*)
integer(kind=iwp), intent(_OUT_) :: ITAI(*)
integer(kind=iwp) :: ISTOP, ITAIL, ITURN, ITYP, KM, LJ, LJM, LJS
logical(kind=iwp) :: first1, first2, first3, skip

ITYP = 0
LJS = IJ(L+1)+1
LJM = IJ(L)
do LJ=LJS,LJM
  ITAIL = IX(IT2+LJ)
  if (IT1 /= IT2) call TAIL(L,LJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
  IWAY(L) = 1
  skip = .false.
  loop_1: do
    if (skip) then
      skip = .false.
    else
      KM = L
      J2(KM+1) = LJ
      J1(KM+1) = LJ
      call LOOP1(KM,ISTOP,IT1,IT2)
      if (ISTOP == 1) exit loop_1
    end if
    KM = KM-1
    IWAY(KM) = 1
    first1 = KM == J
    loop_2: do
      if (first1) then
        first1 = .false.
        ITURN = 0
        IWAY(J) = 1
        loop_3: do
          KM = J
          JM(KM) = IVF0+1
          JM1(KM) = IVF0+1
          if (ITURN == 0) then
            call LOOP10(KM,ISTOP,IT1,IT2)
          else if (ITURN == 1) then
            call LOOP11(KM,ISTOP,IT1,IT2)
          end if
          if (ISTOP /= 0) then
            if (ITURN /= 1) then
              ITURN = 1
              IWAY(J) = 1
              cycle loop_3
            else
              KM = KM+1
              if (KM == L) cycle loop_1
              cycle loop_2
            end if
          end if
          KM = KM-1
          IWAY(KM) = 1
          first2 = KM == I
          loop_4: do
            if (first2) then
              first2 = .false.
              IWAY(I) = 1
              loop_5: do
                KM = I
                if (ITURN == 0) then
                  call LOOP15(KM,ISTOP,IT1,IT2)
                else if (ITURN == 1) then
                  call LOOP19(KM,ISTOP,IT1,IT2)
                end if
                if (ISTOP /= 0) then
                  KM = KM+1
                  if (KM == J) cycle loop_3
                  cycle loop_4
                end if
                loop_6: do
                  KM = KM-1
                  first3 = .false.
                  if (KM == 0) then
                    call COMP1(LJ,ITYP,L,IT2,II,IID,JJ,JJD,JTYP,ITAI)
                    KM = 1
                    if (KM == I) cycle loop_5
                  else
                    IWAY(KM) = 1
                    if (KM == K) first3 = .true.
                  end if
                  do
                    if (first3) then
                      IWAY(K) = 1
                      do
                        KM = K
                        call LOOP3(KM,ISTOP,IT1,IT2)
                        if (ISTOP == 1) exit
                        if (abs(COUP(K)) < 1.0e-6_wp) cycle
                        call COMP(K,LJ,ITYP,K,IT1,IT2)
                      end do
                      first3 = .false.
                    else
                      call LOOP5(KM,ISTOP,IT1,IT2)
                      if (ISTOP == 0) cycle loop_6
                    end if
                    KM = KM+1
                    if (KM == I) cycle loop_5
                  end do
                  if (.true.) exit loop_6
                end do loop_6
                if (.true.) exit loop_5
              end do loop_5
            else
              JM(KM) = IVF0+1
              JM1(KM) = IVF0+1
              if (ITURN == 0) then
                call LOOP17(KM,ISTOP,IT1,IT2)
              else if (ITURN == 1) then
                call LOOP21(KM,ISTOP,IT1,IT2)
              end if
              if (ISTOP == 0) then
                KM = KM-1
                IWAY(KM) = 1
                if (KM == I) first2 = .true.
              else
                KM = KM+1
                if (KM == J) cycle loop_3
              end if
            end if
          end do loop_4
          if (.true.) exit loop_3
        end do loop_3
        exit loop_2
      else
        call LOOP5(KM,ISTOP,IT1,IT2)
        if (ISTOP == 0) then
          skip = .true.
          cycle loop_1
        end if
        KM = KM+1
        if (KM == L) cycle loop_1
      end if
    end do loop_2
    if (.true.) exit loop_1
  end do loop_1
end do

return

end subroutine INT3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2007, Markus Reiher                               *
************************************************************************
      subroutine subs_dkhstring (dkhorder,xorder,dkhscfflg,ordercounter,
     *          opcounter,operleng,oporder,evenodd,doperators,operators,
     *          xordercounter,xopcounter,xoperleng,xoporder,xevenodd,
     *          xdoperators,xoperators,wordercounter,wopscounter,
     *          wopsleng,woporder,eowops,dwops,wops,sused,snumber,
     *          scounter,stimes,wstimes,sorder,smult,s,scrchar,scrleng,
     *          stimestot,tnumber,tcounter,ttimes,tmult,t,
     *          tscrchar,tscrleng,ttimestot,no_s)
c
c************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 15.01.2007 (M. Reiher, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,xorder
      logical dkhscfflg,no_s
c
      integer ordercounter(0:maxorder),opcounter,operleng(maxoperators),
     *        oporder(maxoperators,3),evenodd(maxoperators),
     *        xordercounter(0:maxorder),xopcounter,
     *        xoperleng(maxoperators),xoporder(maxoperators),
     *        xevenodd(maxoperators)
      REAL*8 doperators(maxoperators),
     *                 xdoperators(maxoperators)
#if defined(_MOLCAS_) || defined(MOLPRO)
      character*(maxlength) opstring,xopstring
      character operators(*),xoperators(*)
#else
      character*(maxlength) operators(maxoperators),
     *                      xoperators(maxoperators)
#endif
c
      integer wordercounter(maxorder),wopscounter,wopsleng(maxuops),
     *        woporder(maxuops,3),eowops(maxuops)
      REAL*8 dwops(maxuops)
      character*(maxlength) wops(maxuops)
c
      integer sused,snumber,scounter(maxsnumber),stimes(maxsnumber),
     *        wstimes(maxuops,maxsnumber),sorder(maxsnumber,3),
     *        smult(maxsnumber),scrleng(maxsnumber),stimestot
      integer tnumber,tcounter(maxsnumber),ttimes(maxsnumber),
     *        tmult(maxsnumber),tscrleng(maxsnumber),ttimestot
      character*(4) s(maxsnumber),t(maxsnumber)
      character*(9) scrchar(maxsnumber)
      character*(11) tscrchar(maxsnumber)
c
C     integer j,k,l,pos,hits,idum1,idum2,dummyleng,istart
      integer j,k,  pos,hits,idum1,idum2,dummyleng,istart
C     logical again
      character*(maxlength) dummychar
c
CMR      write (stdout,1017)
CMR1017  format (//5X,'|',70('-'),'|',/5X,'|',6X,'STEP 2: Substitution ',
CMR     *        'of even-order high-level expressions',7X,'|',/5X,'|',
CMR     *        70('-'),'|')
c
      if (dbgflg.ge.1) then
        write (dbgunit,1019)
1019    format (/2X,'Step 2: Enter subroutine "subs_dkhstring" ',//2X,
     *          'Start high-level substitution of suitable expressions',
     *          ' occurring in the',/4X,'DKH Hamiltonian (operators),',
     *          ' the property X (xoperators), and the W-operators ',
     *          '(wops).')
      endif
c
      call s_create (dkhscfflg,sused,snumber,scounter,stimes,wstimes,
     *               sorder,smult,s,scrleng,scrchar,stimestot,
     *               wopscounter,no_s)
c
      call t_create (sused,scrleng,scrchar,tnumber,tcounter,ttimes,
     *               tmult,t,tscrleng,tscrchar,ttimestot)
c
      dummyleng=0
      do 20 j=1,maxlength
        dummychar(j:j)=' '
  20  continue
      do 30 k=1,wopscounter
        dummyleng=wopsleng(k)-3
        dummychar(1:dummyleng)=wops(k)(3:wopsleng(k)-1)
        if (index(dummychar(1:dummyleng),'E00').ne.0) then
          write (stdout,1061) k
1061      format (/2X,'ERROR1 in SR "subs_dkhstring": In term no. ',I6,
     *            ' of wops occurs expression "E00".',//2X,
     *            'All "E00" should have been removed at this stage.',
     *            //2X,'STOP.',/)
          CALL Abend
        endif
        hits=0
        pos=1
  50    continue
        if (pos.lt.dummyleng) then
          idum1=index(dummychar(pos:dummyleng),'E01')
          idum2=index(dummychar(pos:dummyleng),'CE0')
          if ((idum2.lt.idum1.and.idum2.gt.0).or.idum1.eq.0) idum1=idum2
          if (idum1.ne.0) then
            hits=hits+1
            pos=pos+idum1+1
            goto 50
          endif
        endif
        if (hits.gt.1)  then
          write (stdout,1073) k
1073      format (/2X,'ERROR2 in SR "subs_dkhstring": In term no. ',I6,
     *            ' of wops occur expressions "E01" or "CE0" more than',
     *            ' once.',//2X,'This is not possible at this stage.',
     *            //2X,'STOP.',/)
          CALL Abend
        endif
        idum1=1
        call substitute_term (idum1,k,hits,dummyleng,dummychar,sused,
     *                        stimes,wstimes,s,scrleng,scrchar)
        wopsleng(k)=dummyleng+3
        wops(k)(3:wopsleng(k)-1)=dummychar(1:dummyleng)
        wops(k)(wopsleng(k):wopsleng(k))=']'
  30  continue
c
      if (dbgflg.ge.1)  then
        write (dbgunit,1233)
1233    format (/2X,'Form of stored W-operators (wops) after ',
     *          'substitution by Sxxx-expressions:',/2X,73('-'))
        call output2 (dbgunit,wopscounter,wopsleng,woporder,eowops,
     *                dwops,wops)
      endif
c
c
      if (dkhscfflg) istart=4
      if (.not.dkhscfflg) istart=3
c
      do 100 k=istart,opcounter
#if defined(_MOLCAS_) || defined(MOLPRO)
        call get_dkoperators(k,opstring,operators)
        if (index(opstring(1:operleng(k)),'E00').ne.0) then
#else
        if (index(operators(k)(1:operleng(k)),'E00').ne.0) then
#endif
          write (stdout,1621) k
1621      format (/2X,'ERROR3 in SR "subs_dkhstring": In term no. ',I6,
     *            ' occurs expression "E00".',//2X,'All "E00" should ',
     *            'have been removed at this stage.',//2X,'STOP.',/)
          CALL Abend
        endif
        hits=0
        pos=1
 122    continue
        if (pos.lt.operleng(k)) then
#if defined(_MOLCAS_) || defined(MOLPRO)
          idum1=index(opstring(pos:operleng(k)),'E01')
          idum2=index(opstring(pos:operleng(k)),'CE0')
#else
          idum1=index(operators(k)(pos:operleng(k)),'E01')
          idum2=index(operators(k)(pos:operleng(k)),'CE0')
#endif
          if ((idum2.lt.idum1.and.idum2.gt.0).or.idum1.eq.0) idum1=idum2
          if (idum1.ne.0) then
            hits=hits+1
            pos=pos+idum1+1
            goto 122
          endif
        endif
        if (hits.gt.1)  then
          write (stdout,1625) k
1625      format (/2X,'ERROR4 in SR "subs_dkhstring": In term no. ',I6,
     *            ' of operators occurs expression "E01" or "CE0" more',
     *            ' than once.',//2X,'This is not possible at this ',
     *            'stage.',//2X,'STOP.',/)
          CALL Abend
        endif
        idum1=2
#if defined(_MOLCAS_) || defined(MOLPRO)
        call substitute_term (idum1,k,hits,operleng(k),opstring,
     *                        sused,stimes,wstimes,s,scrleng,scrchar)
        call Put_dkoperators(k,opstring,operators)
#else
        call substitute_term (idum1,k,hits,operleng(k),operators(k),
     *                        sused,stimes,wstimes,s,scrleng,scrchar)
#endif

 100  continue
c
      if (dbgflg.ge.1) then
        write (dbgunit,1701)
1701    format (/2X,'Substitution of even-order high-level terms of ',
     *          'DKH Hamiltonian successful (SR "substitute_term").')
        if (dbgflg.ge.2) then
          write (dbgunit,1721) dkhorder
1721      format (/2X,'Final high-level DKH Hamiltonian up to dkhorder',
     *            ' = ',I2,':',/2X,53('-'))
          call output3 (dbgunit,opcounter,operleng,oporder,evenodd,
     *                  doperators,operators)
        endif
      endif
c
c
      if (.not.dkhscfflg) then
c
        do 200 k=2,xopcounter
          hits=0
          pos=1
 222      continue
          if (pos.lt.xoperleng(k)) then
#if defined(_MOLCAS_) || defined(MOLPRO)
          call get_dkoperators(k,xopstring,xoperators)
          idum1=index(xopstring(pos:xoperleng(k)),'CE0')
#else
          idum1=index(xoperators(k)(pos:xoperleng(k)),'CE0')
#endif
            if (idum1.ne.0) then
              hits=hits+1
              pos=pos+idum1+1
              goto 222
            endif
          endif
          if (hits.gt.1)  then
            write (stdout,1725) k
1725        format (/2X,'ERROR: In term no. ',I6,' of xoperators ',
     *              'occurs expression "CE0" more than once.',//2X,
     *              'This is not possible at this stage.',//2X,
     *              'STOP.',/)
            CALL Abend
          endif
          idum1=2
#if defined(_MOLCAS_) || defined(MOLPRO)
          call substitute_term (idum1,k,hits,xoperleng(k),xopstring,
     *                          sused,stimes,wstimes,s,scrleng,scrchar)
          call Put_dkoperators(k,xopstring,xoperators)
#else
          call substitute_term (idum1,k,hits,xoperleng(k),xoperators(k),
     *                          sused,stimes,wstimes,s,scrleng,scrchar)
#endif
c
 200    continue
c
        if (dbgflg.ge.1) then
          write (dbgunit,1801)
1801      format (/2X,'Substitution of even-order high-level terms of ',
     *            'property X successful (SR "substitute_term").')
          if (dbgflg.ge.2) then
            write (dbgunit,1821) xorder
1821        format (/2X,'Final high-level property X up to xorder',
     *              ' = ',I2,':',/2X,48('-'))
            call output3b (dbgunit,xopcounter,xoperleng,xoporder,
     *                     xevenodd,xdoperators,xoperators)
          endif
        endif
c
      endif
c
      do 120 j=1,sused
        if (stimes(j).gt.0) then
          snumber=snumber+1
          stimestot=stimestot+stimes(j)
        endif
 120  continue
c
      if (dbgflg.ge.1) then
        if (dkhscfflg) then
          write (dbgunit,1871)
1871      format (//2X,'Statistic about high-level substitution ',
     *            'process (Sxxx) in step 2:   (only for "operators"!)',
     *          /2X,65('-'),//5X,'Note:  * All values refer ',
     *          'to high-level situation of step2 and',/14X,'will ',
     *          'change (increase) dramatically in further steps.',/12X,
     *          '* All values depend strongly on dkhorder and xorder.',
     *          /12X,'* All other patterns did not occur.',/12X)
          write (dbgunit,1872)
1872      format (//5X,'#',6X,'step1',3X,'-->',3X,'step2',3X,'order',3X,
     *            'no. of subs.',3X,/34X,'(tot)',5X,'(stimes)',/)
        else
          write (dbgunit,1873)
1873      format (//2X,'Statistic about high-level substitution ',
     *            'process (Sxxx) in step 2:   (only for "operators"',
     *            ' and "xoperators"!)',
     *          /2X,65('-'),//5X,'Note:  * All values refer ',
     *          'to high-level situation of step2 and',/14X,'will ',
     *          'change (increase) dramatically in further steps.',/12X,
     *          '* All values depend strongly on dkhorder and xorder.',
     *          /12X,'* All other patterns did not occur.',/12X)
          write (dbgunit,1874)
1874      format (//5X,'#',6X,'step1',3X,'-->',3X,'step2',3X,'order',
     *            1X,'order',1X,'order',2X,'no. of subs.',3X,/35X,'(V)',
     *            3X,'(X)',2X,'(tot)',3X,'(stimes)',/)
        endif
        call output4 (dkhscfflg,dbgunit,sused,stimes,sorder,s,scrchar,
     *                stimestot)
c
        write (dbgunit,1769)
1769    format (/2X,'Subroutine subs_dkhstring (step2) has now been ',
     *          'completed.',//2X,145('*'))
      endif
CMR      if (dkhscfflg) then
CMR        write (stdout,1902) snumber,stimestot
CMR1902    format (/2X,'No. of diff. Sxxx-patterns suited for ',
CMR     *          'operator subst.:',11X,I3,/2X,'No. of high-level ',
CMR     *          'subst. (Sxxx) for operators:',14X,I8,
CMR     *           //2X,'Note: Also substitutions (Sxxx) in wops ',
CMR     *           'have been executed,',/8X,'but they have not been ',
CMR     *           'considered (stimes) for the statistic.')
CMR      else
CMR        write (stdout,1903) snumber,stimestot
CMR1903    format (/2X,'No. of diff. Sxxx-patterns suited for ',
CMR     *          '(x)operator subst.:',8X,I3,/2X,'No. of high-level ',
CMR     *          'subst. (Sxxx) for (x)operators:',11X,I8,
CMR     *           //2X,'Note: Also substitutions (Sxxx) in wops ',
CMR     *           'have been executed,',/8X,'but they have not been ',
CMR     *           'considered (stimes) for the statistic.')
CMR      endif
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer_array(ordercounter)
        call Unused_integer_array(xordercounter)
        call Unused_integer_array(wordercounter)
      end if
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Gen_iSD4(iS, jS, kS, lS,iSD,nSD,iSD4)
      Implicit Real*8 (a-h,o-z)
      Integer iSD(0:nSD,1024), iSD4(0:nSD,4), jQuad(4)
*
      jQuad(1)=iS
      jQuad(2)=jS
      jQuad(3)=kS
      jQuad(4)=lS
      Do i = 1, 4
         iSkal=jQuad(i)
         Do j = 0, nSD
            iSD4(j,i)=iSD(j,iSkal)
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3sglh122 (w,dima,dimab,dimc,s3,d3,ns)
c
c     this routine add following contribution to W
c     for syma=symb > symc
c
c     W(ab,c) <-  + S3 _i(c) . D3 _jk(ab)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b) index (I)
c     dimab   - dimension of ab index (I)
c     dimc   - dimension of c index (I)
c     s3     - S3 matrix (I)
c     d3     - D3 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimab,dimc,ns
       real*8 w(1:dimab,1:dimc)
       real*8 s3(1:dimc)
       real*8 d3(1:dimab)
c
c     help variables
c
       integer c,ab
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       do 120 c=1,dimc
       s=s3(c)
       do 121 ab=1,dimab
       w(ab,c)=w(ab,c)+d3(ab)*s
 121    continue
 120    continue
c
       else
c     phase -1
c
       do 220 c=1,dimc
       s=s3(c)
       do 221 ab=1,dimab
       w(ab,c)=w(ab,c)-d3(ab)*s
 221    continue
 220    continue
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dima)
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine autoSegmentation(Nprocs,maxspace,Jal1,Jal2,NvGrp,NvSGrp,NchBlk,wrksize,maxdim)
! Issues:
!
! 1) o2v4: n'(n'+1)/2 + n' "poltaskov"
! 2) odhadnut overhead? on-the-fly vs precalculate?

use chcc_global, only: maxGrp, maxSGrp, printkey
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Nprocs, maxspace, NchBlk
integer(kind=iwp), intent(out) :: Jal1, Jal2, NvGrp, NvSGrp, wrksize, maxdim
real(kind=wp) :: eff
real(kind=wp), parameter :: eff_thrs = 80.0_wp
logical(kind=iwp), parameter :: requireEfficiency = .true.

write(u6,*)
write(u6,*) '==============================='
write(u6,*) 'Autogenerating segmentation'
write(u6,'(A,i8)') ' Nprocs: ',Nprocs
write(u6,*)

! reset small segmentation
NvSGrp = 1

! get rough estimated of N', e.g. Nprocs == nntasks
NvGrp = int(sqrt(Two*Nprocs))
if (printkey >= 2) write(u6,'(A,i4)') ' 1st Np estimate: ',NvGrp

! if no such Np, get the smallest Np for which nntasks > Nprocs
if ((NvGrp*NvGrp/2) < Nprocs) then
  NvGrp = NvGrp+1
  if (printkey >= 2) write(u6,'(A,i4)') ' Corrected 1st Np estimate: ',NvGrp
end if

! make correction for efficiency, if required
if (requireEfficiency) then
  call findNextEffSeg(NvGrp,eff,Nprocs,eff_thrs,maxGrp,printkey)
  if (printkey >= 2) write(u6,'(A,i4,A,f6.2)') ' (maybe) further correction for efficiency: ',NvGrp,', efficiency: ',eff*100
end if

write(u6,*)

! does the segmentation fit into memory (start with Npp = 1)?
call checkMem(NvGrp,NvSGrp,NchBlk,Jal1,Jal2,wrksize,maxdim)

do while (wrksize > maxspace)

  if (printkey >= 10) write(u6,'(A,i13)') ' Not enough memory. Max: ',maxspace,', Current: ',wrksize

  ! increase small segmentation, if possible

  if ((NvSGrp < 8) .and. ((NvGrp*(NvSGrp+1)) <= maxSGrp)) then
    NvSGrp = NvSGrp+1
    if (printkey >= 10) write(u6,'(A,i4)') ' Npp increased: ',NvSGrp

  else
    ! if not, increase large segmentation and reset small

    ! reset small segmentation in any case
    NvSGrp = 1

    ! increment large segmentation
    NvGrp = NvGrp+1
    if (printkey >= 10) write(u6,'(A,i4)') ' Np increased: ',NvGrp

    ! make correction for efficiency, if required
    if (requireEfficiency) then
      call findNextEffSeg(NvGrp,eff,Nprocs,eff_thrs,maxGrp,printkey)
      if (printkey >= 10) write(u6,'(A,i4)') ' Np increased (corrected for efficiency): ',NvGrp
    end if

    ! check new large segmentation

    if (NvGrp > maxGrp) then
      write(u6,*)
      write(u6,*) ' No suitable segmentation found, quitting'
      call abend()
    end if

  end if ! increase small or large

  ! print final results and
  ! recompute memory requirements
  if (printkey >= 10) write(u6,'(2(A,i4))') ' Current Np: ',NvGrp,', Npp: ',NvSgrp

  call checkMem(NvGrp,NvSGrp,NchBlk,Jal1,Jal2,wrksize,maxdim)

end do ! we fit to memory

write(u6,*)
write(u6,'(A,2(i4),i8)') ' Final segmentation (Large/Small/Cholesky): ',NvGrp,NvSGrp,NchBlk
write(u6,*) '==============================='
write(u6,*)

return

end subroutine autoSegmentation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Real*8 function distance(N,C1,C2)
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)       :: N
      Real(kind=8), intent(in) :: C1(N), C2(N)
      ! local variables
      Integer       :: i
      Real(kind=8) :: X, R
      distance=0.0_wp
      X=0.0_wp
      Do i=1,N
        R=0.0_wp
        R=C1(i)-C2(i)
        X=X+R*R
      End Do
      distance=sqrt(X)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SOCtl_Seward(Mamn,nMamn)

use Basis_Info, only: dbsc, iCnttp_Dummy, nBas, nBas_Aux, nBas_Frag, nCnttp, MolWgh, Shells
use Center_Info, only: dc
use Symmetry_Info, only: iChBas, iChTbl, iOper, iSkip, lBsFnc, lIrrep, nIrrep
use SOAO_Info, only: iAOtSO, iSOInf, iOffSO, nSOInf, SOAO_Info_Init
use real_spherical, only: iSphCr, LblCBs, LblSBs
use Gateway_global, only: Primitive_Pass
use Sizes_of_Seward, only: S
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nMamn
character(len=LenIn8), intent(out) :: Mamn(nMamn)
#include "itmax.fh"
#include "rinfo.fh"
#include "print.fh"
integer(kind=iwp) :: i, iAng, iAO, iAtoms, iBas, iBas_Aux, iBas_Frag, iChBs, iChxyz, iCnt, iCntrc, iCnttp, iCo, iComp, iCounter, &
                     iIrrep, imc, iPrint, iR, iRout, iSh, iShell, iSO, iSO_, iSO_Aux, iSO_Frag, iSO_Tot, isymunit, itest1, itest2, &
                     ixxx, iyy, j, jAO, jCnttp, jComp, jCounter, jIrrep, jOffSO(0:7), jSO, jxxx, k, kComp, kculf, kIrrep, lComp, &
                     lculf, llab, lMax, mc, mdc, mlab, nBasisi, nCore, nExpi, nFCore(0:7), Nr
real(kind=wp) :: FacN, fact
logical(kind=iwp) :: IsBasisAE, IsBasisANO, IsBasisUNK, kECP, lFAIEMP, lSkip, output, TstFnc, bType(0:7)
character(len=LenIn8) :: ChTmp
character(len=8) :: ChTemp
character(len=60) :: Frmt
!SVC: the basis ids are tuples (c,n,l,m) with c the center index,
!     n the shell index, l the angmom value, and m the angmom component.
!     the angmom components of p are mapped (x,y,z) -> (1,-1,0)
!     examples: 3d1+ on atom 1: (1,3,2,1); 2py on atom 5: (5,2,1,-1)
!IFG: for Cartesian shells, l -> -l, m -> T(ly+lz)-(lx+ly), where T(n)=n*(n+1)/2
integer(kind=iwp), allocatable :: basis_ids(:,:), desym_basis_ids(:,:), fermion_type(:), iCI(:), IndC(:), Index1(:), Index2(:), &
                                  iOT(:), jCI(:), List(:), List_AE(:), LPA(:), LPMM(:), LVAL(:), MVAL(:), nCore_Sh(:)
real(kind=wp), allocatable :: LPC(:,:), LPQ(:), SM(:,:)
character(len=LenIn4), allocatable :: LP_Names(:)
integer(kind=iwp), parameter :: Occ = 1, Vir = 0
character(len=*), parameter :: ChOper(0:7) = ['E  ', &
                                              'x  ', &
                                              'y  ', &
                                              'xy ', &
                                              'z  ', &
                                              'xz ', &
                                              'yz ', &
                                              'xyz']
integer(kind=iwp), external :: Index_Center, Index_Nosym, iPrmt, isfreeunit, NrOpr
logical(kind=iwp), external :: Get_BasisType
character(len=LenIn8), external :: Clean_BName

!                                                                      *
!***********************************************************************
!                                                                      *
IsBasisAE = .false.
IsBasisANO = .false.
IsBasisUNK = .false.
iRout = 2
iPrint = nPrint(iRout)
!vv LP_NAMES was used later without initialization.
call mma_allocate(LP_Names,MxAtom,label='LP_Names')
LP_NAMES(:)(1:LenIn) = 'crap'
LP_NAMES(:)(LenIn1:) = 'crap'
lFAIEMP = .false.
do i=1,nCnttp
  lFAIEMP = lFAIEMP .or. dbsc(i)%Frag
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute iBas, iBas_Aux, and iBas_Frag used for double checking
! in SOCtl.
! Compute cdMax, EtMax, and S%nShlls.

call Misc_Seward(iBas,iBas_Aux,iBas_Frag)
call SOAO_Info_Init(iBas+iBas_Frag+iBas_Aux,nIrrep)
!                                                                      *
!***********************************************************************
!                                                                      *
! initialize LVAL and MVAL
! (note: this is wrong for Cartesian shells)

call mma_allocate(LVAL,(iTabMx+1)**2,label='LVAL')
call mma_allocate(MVAL,(iTabMx+1)**2,label='MVAL')
k = 0
do i=0,iTabMx
  do j=-i,i
    k = k+1
    lval(k) = i
    mval(k) = j
  end do
end do
!write(u6,*) ' lval',k,(iTabMx+1)**2
! correct mval order for p-functions
mval(2) = 1
mval(3) = -1
mval(4) = 0
iCent(:) = -99
lnAng(:) = -99
!write(u6,'(20i4)') (lval(i),i=1,k)
!write(u6,*) ' lval',k
!write(u6,'(20i4)') (mval(i),i=1,k)

call mma_allocate(nCore_Sh,[0,iTabMx],label='nCore_Sh')
call mma_allocate(List,[0,iTabMx],label='List')
call mma_allocate(List_AE,[0,iTabMx],label='List_AE')
List(:) = 0
List_AE(:) = 0

isymunit = isfreeunit(58)
call molcas_open(isymunit,'SYMINFO')
rewind isymunit
write(isymunit,'(A)') 'Symmetry information from seward'
write(isymunit,'(A)') '#of funct, unique centre, L, M , # of sym.ad.functions , Phases'
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of symmetry adapted or petite list basis functions
!                                                                      *
!***********************************************************************
!                                                                      *
iSO = 0
iSO_Aux = iBas+iBas_Frag
iSO_Frag = iBas
iSO_Tot = 0
S%n2Tot = 0
S%nDim = 0
iAO = 0
lSkip = .false.

nFCore(:) = 0

call mma_Allocate(iCI,iBas,label='iCI')        ! Stuff for LoProp
call mma_Allocate(jCI,iBas,label='jCI')        ! Stuff for LocalDKH/X2C/BSS
call mma_Allocate(iOT,iBas,label='iOT')        ! Stuff for LoProp
call mma_Allocate(LPC,3,S%mCentr,label='LPC')  ! Stuff (not just) for LoProp
call mma_Allocate(LPQ,S%mCentr,label='LPQ')    ! Stuff (not just) for LoProp
call mma_Allocate(LPMM,S%mCentr,label='LPMM')  ! Stuff (not just) for LoProp
call mma_Allocate(LPA,S%mCentr,label='LPA')
call mma_allocate(basis_ids,4,maxbfn+maxbfn_aux)
call mma_allocate(desym_basis_ids,4,maxbfn+maxbfn_aux)
call mma_allocate(fermion_type,maxbfn+maxbfn_aux)

IsBasisAE = Get_BasisType('AE_')
IsBasisANO = Get_BasisType('ANO')
IsBasisUNK = Get_BasisType('UNK')
if (Show .and. (iPrint >= 6)) then
  write(u6,*)
  call CollapseOutput(1,'   SO/AO info:')
  write(u6,'(3X,A)') '   -----------'
end if
if (nIrrep /= 1) then

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Symmetry case.

  if (Show .and. (iPrint >= 6)) then
    write(u6,*)
    write(u6,'(19x,a)') ' **************************************************'
    write(u6,'(19x,a)') ' ******** Symmetry adapted Basis Functions ********'
    write(u6,'(19x,a)') ' **************************************************'
    write(u6,*)
  end if

  call mma_allocate(Index1,5*iBas,label='Index1')
  call mma_allocate(Index2,5*iBas,label='Index2')
  Index1(:) = 0
  Index2(:) = 0
  iCounter = 0
  jCounter = 0
  call mma_Allocate(SM,iBas,iBas,label='SM')
  call FZero(SM,iBas**2)
  call mma_Allocate(IndC,2*S%mCentr)
  iAtoms = 0

  ! Loop over irreducible representations and symmetry operations,
  ! respectively, for SO and Petite list, respectively.

  do iIrrep=0,7
    jOffSO(iIrrep) = 0
  end do
  kIrrep = 0
  do iIrrep=0,nIrrep-1
    iOffSO(iIrrep) = iSO_Tot
    jOffSO(iIrrep) = iSO
    iAO = 0
    jSO = 0
    nBas(iIrrep) = 0
    nBas_Aux(iIrrep) = 0
    nBas_Frag(iIrrep) = 0
    bType(iIrrep) = .true.

    ! Loop over distinct shell types

    mc = 1
    iShell = 0
    if (iSkip(iIrrep) /= 0) then
      write(u6,*)
      write(u6,*) ' All basis functions of Irrep',iIrrep+1,' are removed!'
      write(u6,*)
      lSkip = .true.
    else
      iCnttp = 0
      do jCnttp=1,nCnttp

        ! Make sure that we process the dummy shell last

        if ((jCnttp == iCnttp_Dummy) .and. (jCnttp /= nCnttp)) then
          iCnttp = iCnttp+2
        else if ((jCnttp == nCnttp) .and. (iCnttp == jCnttp)) then
          iCnttp = iCnttp_Dummy
        else
          iCnttp = iCnttp+1
        end if

        output = show .and. (iPrint >= 6)
        if (dbsc(iCnttp)%Aux) output = output .and. (iPrint >= 10) .and. (iCnttp /= iCnttp_Dummy)
        if (dbsc(iCnttp)%Frag) output = output .and. (iPrint >= 10)
        kECP = dbsc(iCnttp)%ECP
        lMax = dbsc(iCnttp)%nVal-1

        call OrbType(dbsc(iCnttp)%AtmNr,List_AE,31)
        if (kECP) then

          ! ECP case

          call ECP_Shells(dbsc(iCnttp)%AtmNr,list)

          ! No core to freeze!

          nCore_Sh(0:lMax) = 0
        else

          ! Non-ECP case

          ! Pick up the number of occupied orbitals in each shell type.

          List(:) = List_AE

          ! Pick up which orbitals should be frozen as default.

          if (dbsc(iCnttp)%Charge /= Zero) then
            call Freeze_Default(dbsc(iCnttp)%AtmNr,nCore_Sh,lMax)
          else

            ! If there charge is zero we presume that these are
            ! ghost orbitals or something else. In any case
            ! we do not freeze any orbitals!

            call Freeze_Default(0,nCore_Sh,lMax)
          end if
        end if

        ! Loop over distinct centers

        do iCnt=1,dbsc(iCnttp)%nCntr
          mdc = iCnt+dbsc(iCnttp)%mdci

          ! Loop over shells associated with this center
          ! Start with s type shells

          kComp = 0
          kculf = 0
          iSh = dbsc(iCnttp)%iVal-1
          if (dbsc(iCnttp)%nVal < 1) then
            do iCo=0,nIrrep/dc(mdc)%nStab-1
              iyy = Index_Center(mdc,iCo,IndC,iAtoms,S%mCentr)
              iR = NrOpr(dc(mdc)%iCoSet(iCo,0))

              LPC(1:3,iyy) = dbsc(iCnttp)%Coor(1:3,iCnt)
              if (btest(iOper(iR),0)) LPC(1,iyy) = -LPC(1,iyy)
              if (btest(iOper(iR),1)) LPC(2,iyy) = -LPC(2,iyy)
              if (btest(iOper(iR),2)) LPC(3,iyy) = -LPC(3,iyy)
              LPQ(iyy) = dbsc(iCnttp)%Charge
              LPA(iyy) = dbsc(iCnttp)%AtmNr
              LPMM(iyy) = dbsc(iCnttp)%IsMM
              LP_Names(iyy) = dc(mdc)%LblCnt(1:LenIn)//':'//ChOper(iOper(iR))
            end do
          end if
          do iAng=0,dbsc(iCnttp)%nVal-1
            nCore = nCore_Sh(iAng)
            iSh = iSh+1
            iShell = iShell+1
            nExpi = Shells(iSh)%nExp
            nBasisi = Shells(iSh)%nBasis
            if (Shells(iSh)%Prjct) then
              jComp = 2*iAng+1
            else
              jComp = (iAng+1)*(iAng+2)/2
            end if
            if ((nExpi /= 0) .and. (nBasisi /= 0)) then

              do iComp=1,jComp
                iAO = iAO+1
                if (iAO > MxAO) then
                  call ErrTra()
                  write(u6,*) ' Increase MxAO'
                  call Abend()
                end if
                lComp = kComp+iComp
                lculf = kculf+icomp
                ! Get character of basis function
                iChBs = iChBas(lComp)
                if (Shells(iSh)%Transf) iChBs = iChBas(iSphCr(lComp))

                ! Skip if function not a basis of irreps.

                if (.not. TstFnc(dc(mdc)%iCoSet,iIrrep,iChBs,dc(mdc)%nStab)) cycle
                if (.not. (Shells(iSh)%Frag .or. dbsc(iCnttp)%Aux)) nFCore(iIrrep) = nFCore(iIrrep)+nCore
                if (output .and. bType(iIrrep)) then
                  write(u6,*)
                  write(u6,'(10X,A,A)') ' Irreducible representation : ',lIrrep(iIrrep)
                  write(u6,'(10X,2A)') ' Basis function(s) of irrep: ',lBsFnc(iIrrep)
                  write(u6,*)
                  write(u6,'(A)') ' Basis Label        Type   Center Phase'
                  bType(iIrrep) = .false.
                end if

                if (S%MaxBas(iAng) > 0) iAOtSO(iAO,iIrrep) = jSO+1
                S%m2Max = max(S%m2Max,nExpi**2)
                do iCntrc=1,nBasisi
                  iSO_Tot = iSO_Tot+1
                  if (Shells(iSh)%Aux) then
                    iSO_Aux = iSO_Aux+1
                    iSO_ = iSO_Aux
                    nBas_Aux(iIrrep) = nBas_Aux(iIrrep)+1
                  else if (Shells(iSh)%Frag) then
                    iSO_Frag = iSO_Frag+1
                    iSO_ = iSO_Frag
                    nBas_Frag(iIrrep) = nBas_Frag(iIrrep)+1
                  else
                    iSO = iSO+1
                    iSO_ = iSO
                    nBas(iIrrep) = nBas(iIrrep)+1
                  end if
                  if (iSO_ > nMamn) then
                    write(u6,*) ' iSO_ > nMamn'
                    write(u6,*) 'nMamn=',nMamn
                    call Abend()
                  end if
                  jSO = jSO+1

                  ChTemp = LblCBs(lComp)
                  if (Shells(iSh)%Transf) ChTemp = LblSbs(lComp)

                  call Name_to_lm(ChTemp,llab,mlab)

                  ! Introduce a somewhat better labelling. Thnx LG!

                  if (IsBasisAE) then
                    if (IsBasisANO) then
                      write(ChTemp(1:2),'(I2.2)') iAng+iCntrc
                    else
                      if (nExpi == nBasisi) then
                        write(ChTemp(1:1),'(A1)') '*'
                        if (llab >= 0) write(ChTemp(2:2),'(A1)') '0'
                      else if (iCntrc <= list(iAng)) then
                        write(ChTemp(1:2),'(I2.2)') iAng+iCntrc
                      else
                        write(ChTemp(1:1),'(A1)') '*'
                        if (llab >= 0) write(ChTemp(2:2),'(A1)') '0'
                      end if
                    end if
                  else if (.not. IsBasisUNK) then
                    if (nExpi == nBasisi) then
                      write(ChTemp(1:1),'(A1)') '*'
                      if (llab >= 0) write(ChTemp(2:2),'(A1)') '0'
                    else if (iCntrc <= list(iAng)) then
                      write(ChTemp(1:2),'(I2.2)') iAng+iCntrc+(List_AE(iAng)-List(iAng))
                    else
                      write(ChTemp(1:1),'(A1)') '*'
                      if (llab >= 0) write(ChTemp(2:2),'(A1)') '0'
                    end if

                  end if
                  ChTmp = Clean_BName(ChTemp,0)

                  if (output) write(u6,'(I5,3X,A8,4X,A8,8(I3,4X,I2,4X))') iSO_,dc(mdc)%LblCnt,ChTmp, &
                    (mc+iCo,iPrmt(NrOpr(dc(mdc)%iCoSet(iCo,0)),iChbs)*iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0))), &
                     iCo=0,nIrrep/dc(mdc)%nStab-1)

                  if (iSO_ > nSOInf) then
                    write(u6,*) 'iSO_ > nSOInf'
                    call Abend()
                  end if
                  iSOInf(1,iSO_) = iCnttp
                  iSOInf(2,iSO_) = iCnt
                  iSOInf(3,iSO_) = iAng

                  if (Shells(iSh)%Aux .or. Shells(iSh)%Frag) cycle

                  if (.not. Primitive_Pass) then
                    write(isymunit,'(13(I4,4X))') iSO_,mdc,LVAL(lculf),MVAL(lculf),nIrrep/dc(mdc)%nStab, &
                      (iPrmt(NrOpr(dc(mdc)%iCoSet(iCo,0)),iChbs)*iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0))), &
                       iCo=0,nIrrep/dc(mdc)%nStab-1)
                  end if
                  !                                                    *
                  !*****************************************************
                  !                                                    *
                  ! Stuff (not just) for LoProp

                  do iCo=0,nIrrep/dc(mdc)%nStab-1
                    ixxx = Index_NoSym(iCntrc,iComp,iAng,mdc,iCo,Index1,iCounter,iBas)
                    jxxx = Index_NoSym(iCntrc,iComp,iAng,mdc,iirrep,Index2,jCounter,iBas)
                    fact = real(iPrmt(NrOpr(dc(mdc)%iCoSet(iCo,0)),iChbs)*iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0))),kind=wp)

                    FacN = One/real(nIrrep/dc(mdc)%nStab,kind=wp)
                    if (MolWgh == 1) then
                      FacN = One
                    else if (MolWgh == 2) then
                      FacN = sqrt(FacN)
                    end if
                    SM(ixxx,iSO) = Fact*FacN
                    iyy = Index_Center(mdc,iCo,IndC,iAtoms,S%mCentr)

                    iCI(ixxx) = iyy
                    jCI(jxxx) = icnt

                    if (iCntrc <= List(iAng)) then
                      iOT(ixxx) = Occ
                    else
                      iOT(ixxx) = Vir
                    end if

                    iR = NrOpr(dc(mdc)%iCoSet(iCo,0))
                    LPC(1:3,iyy) = dbsc(iCnttp)%Coor(1:3,iCnt)
                    if (btest(iOper(iR),0)) LPC(1,iyy) = -LPC(1,iyy)
                    if (btest(iOper(iR),1)) LPC(2,iyy) = -LPC(2,iyy)
                    if (btest(iOper(iR),2)) LPC(3,iyy) = -LPC(3,iyy)

                    LPQ(iyy) = dbsc(iCnttp)%Charge
                    LPMM(iyy) = dbsc(iCnttp)%IsMM
                    LPA(iyy) = dbsc(iCnttp)%AtmNr

                    LP_Names(iyy) = dc(mdc)%LblCnt(1:LenIn)//':'//ChOper(iOper(iR))
                    desym_basis_ids(1,ixxx) = iyy
                    desym_basis_ids(2,ixxx) = iCntrc
                    desym_basis_ids(3,ixxx) = llab
                    desym_basis_ids(4,ixxx) = mlab
                  end do
                  !                                                    *
                  !*****************************************************
                  !                                                    *
                  Mamn(iSO) = dc(mdc)%LblCnt(1:LenIn)//ChTemp(1:8)
                  basis_ids(1,iSO) = mdc
                  basis_ids(2,iSO) = iCntrc
                  basis_ids(3,iSO) = llab
                  basis_ids(4,iSO) = mlab
                  fermion_type(iSO) = 0
                  if (dbsc(iCnttp)%fMass /= One) fermion_type(iSO) = 1
                  if (.not. Primitive_Pass) then
                    kIrrep = kIrrep+1
                    icent(kIrrep) = mdc
                    lnang(kIrrep) = lval(lculf)
                    lmag(kIrrep) = mval(lculf)
                    lant(kIrrep) = nIrrep/dc(mdc)%nStab
                  end if
                end do

              end do
            end if
            kComp = kComp+(iAng+1)*(iAng+2)/2
            kculf = kculf+2*iAng+1
          end do ! iAng
          mc = mc+nIrrep/dc(mdc)%nStab
        end do ! iCnt

      end do ! jCnttp
    end if
    !ulf
    nrSym = nIrrep
    nrBas(iIrrep+1) = nBas(iIrrep)
    !write(u6,*) ' nBas(iIrrep)', iIrrep, nBas(iIrrep)
    S%nDim = S%nDim+nBas(iIrrep)
    S%n2Tot = S%n2Tot+nBas(iIrrep)**2
  end do ! iIrrep
  !if (lSkip) S%nDim = iBas
  if ((iBas /= iSO) .and. (iBas_Aux /= iSO_Aux-iSO) .and. (.not. lSkip)) then
    write(u6,*) 'iBas=',iBas
    write(u6,*) 'iBas_Aux=',iBas_Aux
    write(u6,*) 'iSO=',iSO
    write(u6,*) 'iSO_Aux=',iSO_Aux-iSO
    write(u6,*) 'iSO_Tot=',iSO_Tot
    call ErrTra()
    call Abend()
  end if
  ! redefine iOffSO array in case of Fragment AIEMP
  if (lFAIEMP) then
    do iIrrep=0,nIrrep-1
      iOffSO(iIrrep) = jOffSO(iIrrep)
    end do
  end if
# ifdef _DEBUGPRINT_
  call RecPrt('Symmetrization Matrix','(20F5.2)',SM,iBas,iBas)
# endif
  call Put_dArray('SM',SM,iBas**2)

  !SVC: basis IDs of both symmetric and non-symmetric case
  if (.not. Primitive_Pass) then
    call Put_iArray('Fermion IDs',fermion_type,iSO)
    call Put_iArray('Basis IDs',basis_ids,4*iSO)
    call Put_iArray('Desym Basis IDs',desym_basis_ids,4*iBas)
  end if

  call mma_deallocate(IndC)
  call mma_deallocate(SM)
  call mma_deallocate(Index1)
  call mma_deallocate(Index2)

else

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! No symmetry case.

  if (Show .and. (iPrint >= 6)) then
    write(u6,*)
    write(u6,'(19x,a)') ' **************************************************'
    write(u6,'(19x,a)') ' ********** Petite list Basis Functions ***********'
    write(u6,'(19x,a)') ' **************************************************'
    write(u6,*)
  end if

  kIrrep = 0
  do iIrrep=0,nIrrep-1
    iOffSO(iIrrep) = iSO_Tot
    iAO = 0
    jSO = 0
    nBas(iIrrep) = 0
    nBas_Aux(iIrrep) = 0
    nBas_Frag(iIrrep) = 0
    bType(iIrrep) = .true.

    ! Loop over distinct shell types

    mc = 1
    iShell = 0
    iCnttp = 0
    do jCnttp=1,nCnttp

      ! Make sure that we process the dummy shell last

      if ((jCnttp == iCnttp_Dummy) .and. (jCnttp /= nCnttp)) then
        iCnttp = iCnttp+2
      else if ((jCnttp == nCnttp) .and. (iCnttp == jCnttp)) then
        iCnttp = iCnttp_Dummy
      else
        iCnttp = iCnttp+1
      end if

      output = show .and. (iPrint >= 6)
      if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag) output = output .and. (iPrint >= 10) .and. (iCnttp /= iCnttp_Dummy)
      kECP = dbsc(iCnttp)%ECP
      lMax = dbsc(iCnttp)%nVal-1
      call OrbType(dbsc(iCnttp)%AtmNr,List_AE,31)
      if (kECP) then
        call ECP_Shells(dbsc(iCnttp)%AtmNr,list)
        nCore_Sh(0:lmax) = 0
      else
        List(:) = List_AE
        if (dbsc(iCnttp)%Charge /= Zero) then
          call Freeze_Default(dbsc(iCnttp)%AtmNr,nCore_Sh,lMax)
        else
          call Freeze_Default(0,nCore_Sh,lMax)
        end if
      end if

      ! Loop over distinct centers

      do iCnt=1,dbsc(iCnttp)%nCntr
        mdc = iCnt+dbsc(iCnttp)%mdci

        ! Loop over shells associated with this center
        ! Start with s type shells

        kComp = 0
        kculf = 0
        iSh = dbsc(iCnttp)%iVal-1
        if (dbsc(iCnttp)%nVal < 1) then
          LPC(1:3,mdc) = dbsc(iCnttp)%Coor(1:3,iCnt)
          LPQ(mdc) = dbsc(iCnttp)%Charge
          LPMM(mdc) = dbsc(iCnttp)%IsMM
          LPA(mdc) = dbsc(iCnttp)%AtmNr
          LP_Names(mdc) = dc(mdc)%LblCnt(1:LenIn)//'    '
        end if
        do iAng=0,dbsc(iCnttp)%nVal-1
          nCore = nCore_Sh(iAng)
          iSh = iSh+1
          iShell = iShell+1
          nExpi = Shells(iSh)%nExp
          nBasisi = Shells(iSh)%nBasis
          if ((nExpi /= 0) .and. (nBasisi /= 0)) then
            if (Shells(iSh)%Prjct) then
              jComp = 2*iAng+1
            else
              jComp = (iAng+1)*(iAng+2)/2
            end if
            do iComp=1,jComp
              iAO = iAO+1
              if (iAO > MxAO) then
                call ErrTra()
                write(u6,*) ' Increase MxAO'
                call Abend()
              end if
              lComp = kComp+iComp
              lculf = kculf+iComp

              ! Skip if symmetry operator is not in the coset of this center.

              do imc=0,(nIrrep/dc(mdc)%nStab)-1
                if (dc(mdc)%iCoSet(imc,0) /= iOper(iIrrep)) cycle
                if (output .and. bType(iIrrep)) then
                  write(u6,*)
                  write(u6,'(10X,2A)') ' Basis functions generated by ',ChOper(iIrrep)
                  write(u6,*)
                  write(u6,'(A)') ' Basis Label        Type   Center'
                  bType(iIrrep) = .false.
                end if

                if (S%MaxBas(iAng) > 0) iAOtSO(iAO,iIrrep) = jSO+1
                S%m2Max = max(S%m2Max,nExpi**2)
                if (.not. (Shells(iSh)%Frag .or. dbsc(iCnttp)%Aux)) nFCore(0) = nFCore(0)+nCore

                ! Loop over contracted basis functions

                do iCntrc=1,nBasisi
                  iSO_Tot = iSO_Tot+1
                  if (Shells(iSh)%Aux) then
                    iSO_Aux = iSO_Aux+1
                    iSO_ = iSO_Aux
                    nBas_Aux(iIrrep) = nBas_Aux(iIrrep)+1
                  else if (Shells(iSh)%Frag) then
                    iSO_Frag = iSO_Frag+1
                    iSO_ = iSO_Frag
                    nBas_Frag(iIrrep) = nBas_Frag(iIrrep)+1
                  else
                    iSO = iSO+1
                    iSO_ = iSO
                    nBas(iIrrep) = nBas(iIrrep)+1
                  end if
                  if (iSO_ > nMamn) then
                    write(u6,*) ' iSO_ > nMamn'
                    write(u6,*) 'nMamn=',nMamn
                    call Abend()
                  end if
                  jSO = jSO+1

                  ChTemp = LblCBs(lComp)
                  if (Shells(iSh)%Transf) ChTemp = LblSbs(lComp)

                  call Name_to_lm(ChTemp,llab,mlab)

                  ! Introduce a somewhat better labelling. Thnx LG!

                  if (IsBasisAE) then
                    if (IsBasisANO) then
                      write(ChTemp(1:2),'(I2.2)') iAng+iCntrc
                    else
                      if (nExpi == nBasisi) then
                        write(ChTemp(1:1),'(A1)') '*'
                        if (llab >= 0) write(ChTemp(2:2),'(A1)') '0'
                      else if (iCntrc <= list(iAng)) then
                        write(ChTemp(1:2),'(I2.2)') iAng+iCntrc
                      else
                        write(ChTemp(1:1),'(A1)') '*'
                        if (llab >= 0) write(ChTemp(2:2),'(A1)') '0'
                      end if
                    end if
                  else if (.not. IsBasisUNK) then
                    if (nExpi == nBasisi) then
                      write(ChTemp(1:1),'(A1)') '*'
                      if (llab >= 0) write(ChTemp(2:2),'(A1)') '0'
                    else if (iCntrc <= list(iAng)) then
                      write(ChTemp(1:2),'(I2.2)') iAng+iCntrc+(List_AE(iAng)-List(iAng))
                    else
                      write(ChTemp(1:1),'(A1)') '*'
                      if (llab >= 0) write(ChTemp(2:2),'(A1)') '0'
                    end if
                  end if
                  ChTmp = Clean_BName(ChTemp,0)

                  if (output) write(u6,'(I5,2X,A8,5X,A8,I3)') iSO_,dc(mdc)%LblCnt,ChTmp,mc+imc

                  if (iSO_ > nSOInf) then
                    write(u6,*) 'iSO_ > nSOInf'
                    call Abend()
                  end if
                  iSOInf(1,iSO_) = iCnttp
                  iSOInf(2,iSO_) = iCnt
                  iSOInf(3,iSO_) = iAng

                  if (Shells(iSh)%Aux .or. Shells(iSh)%Frag) cycle
                  write(isymunit,'(13(I4,4X))') iSO,mdc,LVAL(lculf),MVAL(lculf),nIrrep/dc(mdc)%nStab, &
                    (iPrmt(NrOpr(dc(mdc)%iCoSet(iCo,0)),iChbs)*iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0))), &
                     iCo=0,nIrrep/dc(mdc)%nStab-1)
                  !                                                    *
                  !*****************************************************
                  !                                                    *
                  ! Stuff (not just) for LoProp

                  iCI(iSO) = mdc
                  jCI(iSO) = mdc
                  if (iCntrc <= List(iAng)) then
                    iOT(iSO) = Occ
                  else
                    iOT(iSO) = Vir
                  end if
                  LPC(1:3,mdc) = dbsc(iCnttp)%Coor(1:3,iCnt)
                  LPQ(mdc) = dbsc(iCnttp)%Charge
                  LPMM(mdc) = dbsc(iCnttp)%IsMM
                  LPA(mdc) = dbsc(iCnttp)%AtmNr
                  LP_Names(mdc) = dc(mdc)%LblCnt(1:LenIn)//'    '
                  !                                                    *
                  !*****************************************************
                  !                                                    *
                  Mamn(iSO) = dc(mdc)%LblCnt(1:LenIn)//ChTemp(1:8)
                  basis_ids(1,iSO) = mdc
                  basis_ids(2,iSO) = iCntrc
                  basis_ids(3,iSO) = llab
                  basis_ids(4,iSO) = mlab
                  fermion_type(iSO) = 0
                  if (dbsc(iCnttp)%fMass /= One) fermion_type(iSO) = 1
                  if (.not. Primitive_Pass) then
                    kIrrep = kIrrep+1
                    icent(kIrrep) = mdc
                    lnang(kIrrep) = lval(lculf)
                    lmag(kIrrep) = mval(lculf)
                    lant(kIrrep) = nIrrep/dc(mdc)%nStab
                  end if
                end do
              end do
            end do
          end if
          kComp = kComp+(iAng+1)*(iAng+2)/2
          kculf = kculf+2*iAng+1
        end do
        mc = mc+nIrrep/dc(mdc)%nStab
      end do

    end do
    nrSym = nIrrep
    nrBas(iIrrep+1) = nBas(iIrrep)
    S%nDim = S%nDim+nBas(iIrrep)
    S%n2Tot = S%n2Tot+nBas(iIrrep)**2
  end do

  !SVC: basis IDs of non-symmetric case
  if (.not. Primitive_Pass) then
    call Put_iArray('Fermion IDs',fermion_type,iBas)
    call Put_iArray('Basis IDs',basis_ids,4*iBas)
  end if

  do jAO=1,iAO
    do jIrrep=0,nIrrep-1
      iAOtSO(jAO,jIrrep) = iAOtSO(jAO,jIrrep)+iOffSO(jIrrep)
    end do
  end do

  ! Fix index list such that redundant operators will have the
  ! same AO index.

  mc = 1
  iShell = 0
  iAO = 0
  do iCnttp=1,nCnttp
    kECP = dbsc(iCnttp)%ECP

    ! Loop over distinct centers

    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = iCnt+dbsc(iCnttp)%mdci
      iChxyz = dc(mdc)%iChCnt

      ! Loop over shells associated with this center
      ! Start with s type shells

      iSh = dbsc(iCnttp)%iVal-1
      do iAng=0,dbsc(iCnttp)%nVal-1
        iSh = iSh+1
        iShell = iShell+1
        nExpi = Shells(iSh)%nExp
        nBasisi = Shells(iSh)%nBasis
        if ((nExpi /= 0) .and. (nBasisi /= 0)) then
          if (Shells(iSh)%Prjct) then
            jComp = 2*iAng+1
          else
            jComp = (iAng+1)*(iAng+2)/2
          end if
          do iComp=1,jComp
            iAO = iAO+1
            if (iAO > MxAO) then
              call ErrTra()
              write(u6,*) ' Increase MxAO'
              call Abend()
            end if
            if (S%MaxBas(iAng) > 0) then

              do imc=0,(nIrrep/dc(mdc)%nStab)-1
                itest1 = iand(dc(mdc)%iCoSet(imc,0),iChxyz)
                Nr = NrOpr(dc(mdc)%iCoSet(imc,0))
                do jIrrep=0,nIrrep-1
                  itest2 = iand(iOper(jIrrep),iChxyz)
                  if (itest1 == itest2) iAOtSO(iAO,jIrrep) = iAOtSO(iAO,Nr)
                end do
              end do
            end if
          end do
        end if
      end do
      mc = mc+nIrrep/dc(mdc)%nStab
    end do

  end do

end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (Show) then
  if (iPrint >= 6) then ! std print has been moved to seward.f

    ! Print out basis set information

    Frmt = '(6X,A,T30,8I4)'
    write(u6,*)
    write(u6,'(6X,A)') 'Basis set specifications :'
    write(u6,'(6X,A,T30,8(1X,A))') 'Symmetry species',(lIrrep(i),i=0,nIrrep-1)
    write(u6,Frmt) 'Basis functions',(nBas(i),i=0,nIrrep-1)

  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Write info (not just) for LoProp

if (.not. Primitive_Pass) then
  call Put_cArray('LP_L',LP_Names(1),(LenIn4)*S%mCentr)
  call Put_iArray('LP_A',LPA,S%mCentr)
  call Put_dArray('LP_Q',LPQ,S%mCentr)
  call Put_dArray('LP_Coor',LPC,3*S%mCentr)
  call Put_iScalar('LP_nCenter',S%mCentr)
  call Put_iArray('IsMM Atoms',LPMM,S%mCentr)
  call Put_iArray('Center Index',iCI,iBas)
  call Put_iArray('Orbital Type',iOT,iBas)
  call Put_iArray('Non valence orbitals',nFCore,nIrrep)
else
  call Put_iArray('Ctr Index Prim',jCI,iBas)

end if
call mma_deallocate(LP_Names)
call mma_deallocate(fermion_type)
call mma_deallocate(desym_basis_ids)
call mma_deallocate(basis_ids)
call mma_deallocate(LPA)
call mma_deallocate(LPMM)
call mma_deallocate(LPQ)
call mma_deallocate(LPC)
call mma_deallocate(iCI)
call mma_deallocate(jCI)
call mma_deallocate(iOT)
call mma_deallocate(List)
call mma_deallocate(List_AE)
call mma_deallocate(LVAL)
call mma_deallocate(MVAL)
call mma_deallocate(nCore_Sh)

if (Show .and. (iPrint >= 6)) then
  call CollapseOutput(0,'   SO/AO info:')
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) ' *** iAOtSO ***'
do jAO=1,iAO
  write(u6,*) (iAOtSO(jAO,jIrrep),jIrrep=0,nIrrep-1)
end do
#endif

write(isymunit,'(A3)') 'END'
close(isymunit)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine SOCtl_Seward

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DerBet(IOpt,IC,NSFE,L0,L1,L2,DP,DA,Vert,Centr,Sphere,IntSph,ISphe)

use PCM_Arrays, only: MxVert
use Constants, only: Zero, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IOpt, IC, NSFE, L0, L1, L2, IntSph(MxVert), ISphe
real(kind=wp), intent(in) :: DP(MxVert,3), Vert(3,MxVert), Centr(3,MxVert), Sphere(4,*)
real(kind=wp), intent(out) :: DA
integer(kind=iwp) :: IDX, JJ, NS1, NS2, NS3
real(kind=wp) :: BETA, COSBETA, DBETA, DIST2, dnxxt0, dnxxt1, DT0(3), DT1(3), DV1(3), DV2(3), DV3(3), DV4(3), FACT, P1(3), P2(3), &
                 P3(3), PROD, SENBETA, T0(3), T1(3), T12(3), V1(3), V2(3), V3(3), V4(3)

! Trova la derivata dell'angolo esterno del vertice L1 della tessera
! ITS, formato dai lati L0-L1 e L1-L2,
!
! IOpt = 0 : rispetto alla coordinata IC (ex derbeta)
! IOpt = 1 : rispetto al raggio (ex derbeta1)
!
! della sfera NSFE, conoscendo la derivata della posizione del vertice P1.

NS1 = ISPHE
NS2 = INTSPH(L0)
NS3 = INTSPH(L1)

! Trova i vettori posizione dei vertici L0, L1 rispetto al centro
! dell'arco L0, e dei vertici L1, L2 rispetto al centro dell'arco L1
V1(:) = VERT(:,L0)-CENTR(:,L0)
V2(:) = VERT(:,L1)-CENTR(:,L0)
V3(:) = VERT(:,L1)-CENTR(:,L1)
V4(:) = VERT(:,L2)-CENTR(:,L1)
! Trova la derivata dei vettori posizione
DV1(:) = DP(L0,:)
DV2(:) = DP(L1,:)
DV3(:) = DP(L1,:)
DV4(:) = DP(L2,:)

! Corregge la derivata dei vettori posizione se il lato considerato
! appartiene alla sfera che si muove (distinguendo se ITS appartiene
! o no alla sfera che si muove)
IDX = 0
if ((NS1 == NSFE) .neqv. (NS2 == NSFE)) IDX = 1
if (IDX == 1) then
  T12(:) = Sphere(1:3,NS2)-Sphere(1:3,NS1)
  DIST2 = T12(1)*T12(1)+T12(2)*T12(2)+T12(3)*T12(3)
  if (IOpt == 0) then
    DV1(:) = DV1(:)+(Sphere(4,NS1)**2-Sphere(4,NS2)**2)*T12(IC)*T12(:)/(DIST2*DIST2)
    DV2(:) = DV2(:)+(Sphere(4,NS1)**2-Sphere(4,NS2)**2)*T12(IC)*T12(:)/(DIST2*DIST2)
    FACT = (Sphere(4,NS1)**2-Sphere(4,NS2)**2+DIST2)/(Two*DIST2)
    DV1(IC) = DV1(IC)-FACT
    DV2(IC) = DV2(IC)-FACT
  else if (IOpt == 1) then
    DV1(:) = DV1(:)+Sphere(4,NS2)*T12(:)/DIST2
    DV2(:) = DV2(:)+Sphere(4,NS2)*T12(:)/DIST2
  else
    write(u6,'(a)') 'Illegal IOpt in DerBet.'
    call Abend()
  end if
end if

IDX = 0
if ((NS1 == NSFE) .and. (NS3 /= NSFE)) IDX = 1
if ((NS1 /= NSFE) .and. (NS3 == NSFE)) IDX = 1
if (IDX == 1) then
  T12(:) = Sphere(1:3,NS3)-Sphere(1:3,NS1)
  DIST2 = T12(1)*T12(1)+T12(2)*T12(2)+T12(3)*T12(3)
  if (IOpt == 0) then
    DV3(:) = DV3(:)+(Sphere(4,NS1)**2-Sphere(4,NS3)**2)*T12(IC)*T12(:)/(DIST2*DIST2)
    DV4(:) = DV4(:)+(Sphere(4,NS1)**2-Sphere(4,NS3)**2)*T12(IC)*T12(:)/(DIST2*DIST2)
    FACT = (Sphere(4,NS1)**2-Sphere(4,NS3)**2+DIST2)/(Two*DIST2)
    DV3(IC) = DV3(IC)-FACT
    DV4(IC) = DV4(IC)-FACT
  else if (IOpt == 1) then
    DV3(:) = DV3(:)+Sphere(4,NS3)*T12(:)/DIST2
    DV4(:) = DV4(:)+Sphere(4,NS3)*T12(:)/DIST2
  else
    write(u6,'(a)') 'Illegal IOpt in DerBet.'
    call Abend()
  end if
end if

! Trova il vettore tangente al lato L0-L1: T0 = V2 x (V2 x V1)
call crprod(V2,V1,P2)
call crprod(V2,P2,T0)
dnxxt0 = sqrt(T0(1)*T0(1)+T0(2)*T0(2)+T0(3)*T0(3))
! Trova il vettore tangente al lato L1-L2: T1 = V3 x (V3 x V4)
call crprod(V3,V4,P2)
call crprod(V3,P2,T1)
dnxxt1 = sqrt(T1(1)*T1(1)+T1(2)*T1(2)+T1(3)*T1(3))

! Trova l'angolo Beta(L1)
PROD = T0(1)*T1(1)+T0(2)*T1(2)+T0(3)*T1(3)
BETA = PI-acos(PROD/(dnxxt0*dnxxt1))
COSBETA = cos(BETA)
SENBETA = sin(BETA)

! Trova la derivata della tangente T0 :
! DT0 = DV2 x (V2 x V1) + V2 x (DV2 x V1) + V2 x (V2 x DV1)

call crprod(V2,V1,P2)
call crprod(DV2,P2,DT0)

call crprod(DV2,V1,P2)
call crprod(V2,P2,P3)
DT0(:) = DT0(:)+P3(:)

call crprod(V2,DV1,P2)
call crprod(V2,P2,P3)
DT0(:) = DT0(:)+P3(:)

! Trova la derivata della tangente T1 :
! DT1 = DV3 x (V3 x V4) + V3 x (DV3 x V4) + V3 x (V3 x DV4)

call crprod(V3,V4,P2)
call crprod(DV3,P2,DT1)

call crprod(DV3,V4,P2)
call crprod(V3,P2,P3)
DT1(:) = DT1(:)+P3(:)

call crprod(V3,DV4,P2)
call crprod(V3,P2,P3)
DT1(:) = DT1(:)+P3(:)

! Infine calcola la derivata dell'angolo Beta(L1)
P1(:) = T1(:)+COSBETA*dnxxt1*T0(:)/dnxxt0
P2(:) = T0(:)+COSBETA*dnxxt0*T1(:)/dnxxt1
DBETA = Zero
do JJ=1,3
  DBETA = DBETA+(P1(JJ)*DT0(JJ)+P2(JJ)*DT1(JJ))
end do
DBETA = DBETA/(SENBETA*dnxxt0*dnxxt1)
DA = Sphere(4,NS1)*Sphere(4,NS1)*DBETA

return

end subroutine DerBet

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Load_tmp_CI_vec(iRoot,nConf,CI_vec,LuDavid)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Load a temporary CI vector                                       *
!     further use by the Davidson diagonalization scheme               *
!                                                                      *
!     calling arguments:                                               *
!     iRoot   : integer                                                *
!               root number                                            *
!     nConf   : integer                                                *
!               length of the vector H_diag                            *
!     CI_vec  : array of real                                          *
!               CI vector                                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use timers, only: TimePage
use davctl_mod, only: disk_address, in_core, llab, memory_vectors, mixed_mode_1, mixed_mode_2, n_Roots, on_disk, save_mode
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iRoot, nConf, LuDavid
real(kind=wp), intent(out) :: CI_vec(nConf)
integer(kind=iwp) :: iDisk, tmp_CI_vec_RecNo
real(kind=wp) :: dum1, dum2, dum3, Time(2)
character(len=llab) :: KeyWord
integer(kind=iwp), external :: RecNo

call Timing(Time(1),dum1,dum2,dum3)

! check input arguments
if (nConf < 0) then
  write(u6,*) 'Load_tmp_CI_vec: nConf less than'
  write(u6,*) 'nConf = ',nConf
  call Abend()
end if
if (iRoot < 0) then
  write(u6,*) 'Load_tmp_CI_vec: iRoot less than 0'
  write(u6,*) 'iRoot = ',iRoot
  call Abend()
end if
if (iRoot > n_Roots) then
  write(u6,*) 'Load_tmp_CI_vec: iRoot greater than nRoots'
  write(u6,*) 'iRoot, nRoots = ',iRoot,n_Roots
  call Abend()
end if

! the diagonalization can be run in core:
! copy the CI vector to new memory location
if (save_mode == in_core) then
  tmp_CI_vec_RecNo = RecNo(4,iRoot)
  CI_vec(:) = memory_vectors(:,tmp_CI_vec_RecNo)
end if

! the diagonalization must be run out of core:
! load the CI vector from disk
if (save_mode == on_disk) then
  tmp_CI_vec_RecNo = RecNo(4,iRoot)
  iDisk = disk_address(tmp_CI_vec_RecNo)
  call DDaFile(LuDavid,2,CI_vec,nConf,iDisk)
end if

! the diagonalization may be run in mixed mode:
! use the write through cache mechanism to load and save
! the CI vector
if ((save_mode == mixed_mode_1) .or. (save_mode == mixed_mode_2)) then
  write(KeyWord,'(A,I4.4)') 'tmp_CI_vec',iRoot
  call page_in(KeyWord,nConf,CI_vec,LuDavid)
end if

call Timing(Time(2),dum1,dum2,dum3)
TimePage = TimePage+Time(2)-Time(1)

return

end subroutine Load_tmp_CI_vec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifdef _IN_MODULE_

subroutine klvaa_oovo(x,g,vblock,N,nug,LU,last,ias)
!mp !subroutine klvaa_oovo(G,ix,it,ig,iscr,vblock,N,nug,LU,last,ias)
!mpn subroutine klvaa_oovo(ix,it,ig,iscr,vblock,N,nug,LU,last,ias)
!
! creates L(alpha>alpha,alpha-alpha)
! DA files LMATICH(ISP)ICH(ISP)
! max G at this place
!
! parallelization (seems to be) irrelevant at the moment
! implemented integer offsets, PV, 14 may 2004.

use ChT3_global, only: DimGrpaR, maxdim, nblock, nc, NNOAB, NNUAB, no, NOAB, NUAB, printkey
use Index_Functions, only: iTri, nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), allocatable, intent(_OUT_) :: x(:)
real(kind=wp), allocatable, intent(inout) :: g(:)
integer(kind=iwp), intent(in) :: vblock, N, nug, LU
integer(kind=iwp), intent(out) :: last, ias
integer(kind=iwp) :: A, A1, A2, a_tmp, AADT, ADIM, B1, b1_tmp, B2, b2_chk, i, i_blk, iasblock, IJS, IS2, isp, j, j_blk, j_tmp, k, &
                     KADT, KI, length, length1, length2, MAXDIM2, NGA, ngaa, ngaf, ngal, NGB, ngbf, ngbl, nind_ngaf, nind_ngal, &
                     nind_ngbf, nind_ngbl, nno, NSTEP, R, RAD
real(kind=wp), allocatable :: l1(:), l2(:), t2_exp(:), t2_tmp(:), tmp(:), tmp2(:), x2(:)

!mp write(u6,*) 'Entering klvaa_oovo'

ISP = 1
iasblock = NNOAB(ISP)*vblock*N/nblock
if ((iasblock*nblock) < (NNOAB(ISP)*vblock*N)) iasblock = iasblock+1
nno = nTri_Elem(noab(isp))
!!call w_alloc(ix,nnoab(ISP)*vblock*n,'IX klvaao')
!!call w_alloc(ig,noab(isp)*nuab(isp)*nnoab(isp),'IG klvaao')
!!call w_alloc(iscr,nuab(isp)*nuab(isp)*nnoab(isp),'ISCR klvaao')
!FN = 'OOVOI'//ICH(ISP)
!!call GET3DM(FN,G(ig),NUAB(ISP)*NOAB(ISP),NNOAB(ISP),0)

!call EXPA1_UHF(G(IT),nnoab(isp),NUAB(ISP),-1,G(ISCR))
! expa done here. remains in it address
!mpn IJS = IT
!mpn do i=2,noab(isp)
!mpn   do j=1,i-1
!mpn     KADT = IT+(i-1)*noab(isp)*nnuab(3)+(j-1)*nnuab(3)
!mpn     !!call dcopy_(NNUAB(3),G(KADT),1,G(IJS),1)
!mpncmp  !call vneg_cht3(G(KADT),1,G(IJS),1,NNUAB(3))
!mpn     Work(IJS:IJS+NNUAB(3)-1) = -Work(KADT:KADT+NNUAB(3)-1)
!mpncmp  !call TRANSM_A(G(KADT),G(IJS),NUAB(ISP),NUAB(ISP))
!mpn     call TRANSM_A(Work(KADT),Work(IJS),NUAB(ISP),NUAB(ISP))
!mpn     IJS = IJS+NNUAB(3)
!mpn   end do ! j
!mpn end do ! i

IAS = 1
ngaa = 0
!mpn
do A1=1,NUAB(ISP),vblock
  ! not needed  call zeroma(g(ix),1,nnoab(isp)*vblock*n)
  adim = min(vblock,nuab(isp)-A1+1)
  A2 = A1+adim-1
  !mpn
  ngaa = ngaa+1

  !mp write(u6,*)
  !mp write(u6,*) '================================='
  !mp write(u6,*) ' nga ',ngaa
  !mp write(u6,*) '================================='
  !mp write(u6,*)

  !mp write(u6,'(A,2(i5,2x))') 'b1,b2 = ',a1,a2

  call block_interf(1,1,a1,a2,ngaf,ngal,nind_ngaf,nind_ngal,ngbf,ngbl,nind_ngbf,nind_ngbl)

  !mp write(u6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',ngbf,ngbl,nind_ngbf,nind_ngbl

  ! - read amplitudes T2(nv,vblock,j<i)

  ! - calculate memory requirements

  length1 = nuab(isp)

  length2 = 0
  do i_blk=ngbf,ngbl
    length2 = length2+DimGrpaR(i_blk)
  end do

  !mp write(u6,*) 'length1, NUAB   = ',length1,NUAB(1)
  !mp write(u6,*) 'length2, vblock = ',length2,vblock

  length = length1*length2*nTri_Elem(no-1)
  !mp write(u6,*) 'length for blocked T2 amplitudes = ',length

  ! - setup memory

  !mp write(u6,*) 'allocating t2_exp = ',length
  call mma_allocate(t2_exp,length,label='t2_length')

  ! - read pertinent files and store them in the new blocked structure

  call mma_allocate(t2_tmp,maxdim*maxdim*no*no,label='t2_tmp')
  call mma_allocate(tmp2,maxdim*maxdim*no*no,label='tmp2')

  call gather_t2anti_blocked(length1,length2,ngbf,ngbl,t2_exp,t2_tmp,tmp2)

  call mma_deallocate(tmp2)
  call mma_deallocate(t2_tmp)

  !mpn
  ! copies oovo
  ! oovo (k>l,ai)
  K = 0
  do I=2,NOAB(ISP)
    do J=1,I-1
      K = K+1
      !!do K = 1,NNOAB(ISP)
      IJS = (K-1)*adim*N
      !!KADT = (a1-1)*noab(isp)+(K-1)*noab(isp)*nuab(isp)+1
      do a=A1,A2
        KADT = (J-1)*nno*nuab(isp)+(A-1)*nno
        do r=1,noab(isp)
          ! <ra|ij>
          !mp G(IJS+r) = G(KADT+iTri(r,i))
          x(IJS+r) = g(KADT+iTri(r,i))
        end do
        KADT = (I-1)*nno*nuab(isp)+(A-1)*nno
        do r=1,noab(isp)
          ! -<ra|ji>
          !mp G(IJS+r) = G(IJS+r)-G(KADT+iTri(r,j))
          x(IJS+r) = x(IJS+r)-g(KADT+iTri(r,j))
        end do
        !!call dcopy_(noab(isp),G(KADT),1,G(IJS),1)
        IJS = IJS+N
        !!KADT = KADT+noab(isp)
      end do
      ! now the T2
      !mpn
      !!KADT = ISCR+(K-1)*NUAB(ISP)*NUAB(ISP)+(A1-1)*NUAB(ISP)
      !mp KADT = IT+(K-1)*NUAB(ISP)*NUAB(ISP)+(A1-1)*NUAB(ISP)
      IJS = 1+NOAB(ISP)+(K-1)*adim*N

      a_tmp = a1-nind_ngbf
      !mp write(u6,*) 'K, a1, a_tmp',k,a1,a_tmp

      KADT = 1+(K-1)*NUAB(ISP)*length2+(a_tmp-1)*NUAB(ISP)

      do a=A1,A2
        !mp call dcopy_(NUAB(isp),G(KADT),1,G(IJS),1)
        x(IJS:IJS+NUAB(isp)-1) = t2_exp(KADT:KADT+NUAB(isp)-1)
        !mp write(u6,*) (t2_exp(KADT+a_tmp),a_tmp=0,NUAB(isp)-1)
        !!write(u6,'(A,2I3,11D10.4)')'OT',K,a,(G(r),r=IJS-noab(isp),IJS+nuab(isp)-1)

        KADT = KADT+NUAB(ISP)
        IJS = IJS+N
      end do     !A
    end do       !J
  end do         !I
  !!enddo          !K
  !!write(u6,'(A,2I5,4x,5D15.10)') 'block-m:a1,IAS,ddot',a1,ias,ddot_(N*adim*nnoab(ISP),G(IX),1,G(IX),1),(G(I),I=IX,IX+3)
  !mp call multi_wridir(G(IX),n*adim*nnoab(isp),LU,IAS,last)
  !mp
  !mpn do jjj=1,n*adim*nnoab(isp)
  !mpn   if (abs(x(jjj)) > 1.0e5_wp) then
  !mpn     write(u6,*) 'fucko 2'
  !mpn     write(u6,*) jjj,x(jjj)
  !mpn     stop
  !mpn   end if
  !mpn end do
  !mp
  call multi_wridir(x,N*adim*nnoab(isp),LU,IAS,last)
  IAS = IAS+iasblock

  !mp
  call mma_deallocate(t2_exp)
  !mp
end do     ! A1
  !mp write(u6,*) 'cast 1 ok'
  !mpn

IS2 = 3-ISP
! lmat
!mp ! Mozes odjbt ix, iscr, ig
!mp write(u6,*) 'test 2 na iscr ',vblock*noab(1)*noab(1)
!mp write(u6,*) 'test 2 na ig ',noab(1)*nuab(1)*nno
!mp write(u6,*) 'test 2 na ix ',noab(1)*noab(1)*vblock*n
!mp write(u6,*) 'nno (2) = ',nno
!call GetMem('c2_iscr','Free','Real',iscr,vblock*noab(1)*noab(1))
call mma_deallocate(g)
call mma_deallocate(x)
!mp write(u6,*) 'n (2) = ',n
!mp call w_memchk('IX klvaa ')
!mp call w_free(g(ix),0,'klvaaix')
!mp call w_alloc(ix,nnoab(isp)*vblock*vblock,'Ix klvaa-v')
!mp
call mma_allocate(x2,nnoab(isp)*vblock*vblock,label='klv_oo_ix')
!mp
! starts <aa||oo> integrals
!FN = 'VVOOI'//ich(3)
!!FN = 'VVOOI'//ich(isp)
!mp !call GET3DM(FN,G(it),NNUAB(3),NNOAB(3),0)
!mp
!mp !call w_alloc(il1,nc*no*maxdim,'IL1 klvaa-v')
!mpn call mma_allocate(l1,nc*no*maxdim,label='klv_oo_il1')
!mp !call w_alloc(itmp,max(nc*no*maxdim,maxdim*maxdim*no*no),'IL2 klvaa-v')
!mpn call mma_allocate(tmp,max(nc*no*maxdim,maxdim*maxdim*no*no),label='klv_oo_itmp')
!mp !call w_alloc(il2,max(nc*no*maxdim,maxdim*maxdim*no*no),'IL2 klvaa-v')
!mpn call mma_allocate(l2,max(nc*no*maxdim,maxdim*maxdim*no*no),label='klv_oo_il2')

!mp !call gen_vvoo(G(it),G(il1),G(itmp),G(il2))
!mpn call gen_vvoo(Work(it),l1,tmp,l2)

!mp !open(unit=36,file='vvoo_moje')
!mp !do i=0,NNUAB(3)*NNOAB(3)-1
!mp !  if (abs(G(it+i)) < 1.0e-7_wp) G(it+i) = Zero
!mp !  write(36,*) i,G(it+i)
!mp !end do
!mp !close (36)

!mp !call w_free(G(il1),0,'IL1 klvaa-v')
!mpn call mma_deallocate(l2)
!mpn call mma_deallocate(tmp)
!mpn call mma_deallocate(l1)

!mp write(u6,*) ddot_(nnoab(3)*nnuab(3),G(it),1,G(it),1)

!mp
!!call dscal_(NNUAB(3)*NNOAB(3),-One,G(it),1)
!!call dscal_(NNUAB(isp)*NNOAB(ISP),-One,G(it),1)

! number of blocks written in a single multiwrite

iasblock = vblock*vblock*nnoab(isp)/nblock
if (iasblock*nblock < vblock*vblock*nnoab(isp)) iasblock = iasblock+1
!!write(u6,*) 'create_aa vvoo   iasblock',iasblock

!!FN = 'VMAT'//ich(isp)//ich(isp)
!!call multi_opendir(FN,LU)
! currently using 3-dim (big field) - will be replaced after changing
! stepiv and the rest
do nga=1,nug
  A1 = (nga-1)*vblock+1
  adim = min(vblock,nuab(isp)-A1+1)
  A2 = A1+adim-1
  do ngb=1,nga
    if (nga == ngb) then
      maxdim2 = nTri_Elem(adim-1)
    else
      maxdim2 = adim*vblock
    end if
    B1 = (ngb-1)*vblock+1
    !mpn
    !mp write(u6,*)
    !mp write(u6,*) '================================='
    !mp write(u6,*) ' nga, ngb',nga,ngb
    !mp write(u6,*) '================================='
    !mp write(u6,*)

    !mpn
    ! - check the largest b2

    !mp b2_chk = b1-1+min(vblock,a2-b1)
    !mpn b2_chk = b1-1+vblock
    b2_chk = b1+min(vblock,nuab(isp)-b1+1)-1

    ! - find out which T2 blocked files will be needed for particular nga, ngb

    !mp write(u6,'(A,4(i5,2x))') 'a1,a2,b1,b2_chk = ',a1,a2,b1,b2_chk

    call block_interf(a1,a2,b1,b2_chk,ngaf,ngal,nind_ngaf,nind_ngal,ngbf,ngbl,nind_ngbf,nind_ngbl)

    !mp write(u6,'(A,4(i5,2x))') 'ngaf, ngal, nind_ngaf, nind_ngal',ngaf,ngal,nind_ngaf,nind_ngal
    !mp write(u6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',ngbf,ngbl,nind_ngbf,nind_ngbl

    ! - read amplitudes from T2_ngaf_ngbf ...  T2_ngaf_ngbl, nga>=ngb
    !                           ....               ....
    !                        T2ngal_ngbf  ...  T2_ngal_ngbl, nga>=ngb

    ! - calculate memory requirements (consider squared T2(a',a'))

    length1 = 0
    do i_blk=ngaf,ngal
      length1 = length1+DimGrpaR(i_blk)
    end do

    length2 = 0
    do j_blk=ngbf,ngbl
      length2 = length2+DimGrpaR(j_blk)
    end do

    !mp write(u6,*) 'length1, vblock = ',length1,vblock
    !mp write(u6,*) 'length2, vblock = ',length2,vblock

    length = length1*length2*no*no
    !mp write(u6,*) 'length for blocked VVOO integrals = ',length

    ! - setup memory

    !mp write(u6,*) 'allocating t2_exp = ',length
    call mma_allocate(t2_exp,length,label='t2_exp')

    ! - read pertinent files and generate block of vvoo integrals

    call mma_allocate(l1,nc*no*maxdim,label='vvooil1')
    call mma_allocate(tmp,max(nc*no*maxdim,maxdim*maxdim*no*no),label='vvooitmp')
    call mma_allocate(l2,max(nc*no*maxdim,maxdim*maxdim*no*no),label='vvooil2')
    !mp
    call gen_vvoo_blocked(t2_exp,l1,tmp,l2,length1,length2,ngaf,ngal,ngbf,ngbl)
    !mp
    call mma_deallocate(l2)
    call mma_deallocate(tmp)
    call mma_deallocate(l1)
    !mpn
    do a=a1,a2
      B2 = B1-1+min(vblock,A-B1)
      NSTEP = B2-B1+1
      if (nstep /= 0) then
        if (nga == ngb) then
          IJS = nTri_Elem(a-a1-1)+1
        else
          IJS = (a-a1)*vblock+1
        end if
        R = 0
        do I=2,NOAB(ISP)
          do J=1,I-1
            !!R = R+1
            !!do R=1,NNOAB(ISP)
            !!  KADT = (R-1)*NNUAB(ISP)
            !mpn R = (J-1)*noab(isp)+I
            !mpn KADT = (R-1)*NNUAB(3)
            !mpn KADT = KADT+(a-1)*NUAB(ISP)+B1+IT-1

            a_tmp = a-nind_ngaf
            b1_tmp = b1-nind_ngbf

            !mp write(u6,'(A,5(i4,x))') 'a,b1,I,J,nstep ',a,b1,I,J,nstep
            !mp write(u6,'(A,5(i4,x))') 'a_tmp,b1_tmp   ',a_tmp,b1_tmp
            do j_tmp=0,nstep-1

              KADT = (i-1)*noab(isp)*length1*length2+(j-1)*length1*length2+(b1_tmp+j_tmp-1)*length1+a_tmp

              x2(IJS+j_tmp) = t2_exp(KADT)

            end do

            ! address and block for the A1-A2x B1-B2
            !!KADT = KADT+nTri_Elem(a-2)+B1+IT-1
            ! VO >>> G(IX)
            !mpn x2(IJS:IJS+NSTEP-1) = t2_exp(KADT:KADT+NSTEP-1)
            !mpn R = (I-1)*noab(isp)+J
            !mpn KADT = (R-1)*NNUAB(3)
            !mpn KADT = KADT+(a-1)*NUAB(ISP)+B1+IT-1
            do j_tmp=0,nstep-1

              KADT = (j-1)*noab(isp)*length1*length2+(i-1)*length1*length2+(b1_tmp+j_tmp-1)*length1+a_tmp

              x2(IJS+j_tmp) = x2(IJS+j_tmp)-t2_exp(KADT)

            end do
            !mpn
            !mpn x2(IJS:IJS+NSTEP-1) = x2(IJS:IJS+NSTEP-1)-t2_exp(KADT:KADT+NSTEP-1)
            !!write(u6,'(A,2I3,8D15.8)')'T',nTri_Elem(I-2)+j,a,(G(r),r=IJS,IJS+NSTEP-1)
            IJS = IJS+maxdim2
          end do       ! RI
        end do         ! RJ
      end if
    end do             ! a1
    !!write(u6,'(A,4I5,4x,5D15.10)') 'block-m: a1,b1,IAS,ddot',a1,b1,ias,maxdim2,ddot_(nnoab(isp)*maxdim2,G(IX),1,G(IX),1), &
    !!                               (G(I),I=IX,IX+3)
    if (maxdim2 == 0) then
      maxdim2 = 1
    end if
    !mp call multi_wridir(G(IX),nnoab(isp)*maxdim2,LU,IAS,last)
    !mp
    !mpn do jjj=1,nnoab(isp)*maxdim2
    !mpn   if (abs(x2(jjj)) > 1.0e5_wp) then
    !mpn     write(u6,*) 'fucko 3'
    !mpn     write(u6,*) jjj,x2(jjj)
    !mpn     stop
    !mpn   end if
    !mpn end do
    !mp
    call multi_wridir(x2,nnoab(isp)*maxdim2,LU,IAS,last)
    ias = ias+iasblock

    !mp write(u6,*) 'deallocating t2_exp = ',length
    call mma_deallocate(t2_exp)

  end do    ! ngb
end do      ! nga
!mp write(u6,*) 'cast 2 ok'
!mp call w_memchk('all klvaa ')
!mp call w_free(g(ix),0,'klvaa ')
!mp
call mma_deallocate(x2)
!mp
!!call w_free(g(it),0,'klvaa ')
!mp call w_alloc(ix,nnoab(3)*vblock*vblock,'ix-vvoo')
!mp
call mma_allocate(x2,nnoab(3)*vblock*vblock,label='klv_oo_ix')
!mp
!!call w_alloc(ig,nnoab(3)*nnuab(3),'ig-vvoo')
!mpn ig = it
! from now on as for uhf
iasblock = nnoab(3)*vblock*vblock/nblock
if (iasblock*nblock < nnoab(3)*vblock**2) iasblock = iasblock+1
!!FN = 'VVOOI'//ICH(3)
!!CALL GET3DM(FN,G(IG),NNUAB(3),NNOAB(3),0)
! (c>d|AK)

!mpn
nga = 0
!mpn
do A1=1,NUAB(ISP),vblock
  A2 = A1+min(vblock,nuab(isp)-A1+1)-1
  adim = A2-A1+1
  !mpn
  nga = nga+1
  ngb = 0
  !mpn
  do B1=1,NUAB(IS2),vblock
    !mpn
    ngb = ngb+1
    !mpn
    NSTEP = min(vblock,nuab(is2)-B1+1)
    !mpn
    !mpn
    !mp write(u6,*)
    !mp write(u6,*) '================================='
    !mp write(u6,*) ' nga, ngb',nga,ngb
    !mp write(u6,*) '================================='
    !mp write(u6,*)

    ! - check the largest b2

    !mp b2_chk = b1-1+min(vblock,nuab(is2)-B1+1)
    !mpn b2_chk = b1-1+vblock
    b2_chk = b1+min(vblock,nuab(is2)-B1+1)-1

    ! - find out which T2 blocked files will be needed for particular nga, ngb

    !mp write(u6,'(A,4(i5,2x))') 'a1,a2,b1,b2_chk = ',a1,a2,b1,b2_chk

    if (nga < ngb) then
      !mp write(u6,*) 'switching nga, ngb',ngb,nga

      call block_interf(b1,b2_chk,a1,a2,ngaf,ngal,nind_ngaf,nind_ngal,ngbf,ngbl,nind_ngbf,nind_ngbl)

    else

      call block_interf(a1,a2,b1,b2_chk,ngaf,ngal,nind_ngaf,nind_ngal,ngbf,ngbl,nind_ngbf,nind_ngbl)

    end if

    !mp write(u6,'(A,4(i5,2x))') 'ngaf, ngal, nind_ngaf, nind_ngal',ngaf,ngal,nind_ngaf,nind_ngal
    !mp write(u6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',ngbf,ngbl,nind_ngbf,nind_ngbl

    ! - read amplitudes from T2_ngaf_ngbf ...  T2_ngaf_ngbl, nga>=ngb
    !                           ....               ....
    !                        T2ngal_ngbf  ...  T2_ngal_ngbl, nga>=ngb

    ! - calculate memory requirements (consider squared T2(a',a'))

    length1 = 0
    do i_blk=ngaf,ngal
      length1 = length1+DimGrpaR(i_blk)
    end do

    length2 = 0
    do j_blk=ngbf,ngbl
      length2 = length2+DimGrpaR(j_blk)
    end do

    !mp write(u6,*) 'length1, vblock = ',length1,vblock
    !mp write(u6,*) 'length2, vblock = ',length2,vblock

    length = length1*length2*no*no
    !mp write(u6,*) 'length for blocked VVOO integrals = ',length

    ! - setup memory

    !mp write(u6,*) 'allocating t2_exp = ',length
    call mma_allocate(t2_exp,length,label='t2_exp')

    ! - read pertinent files and generate block of vvoo integrals

    call mma_allocate(l1,nc*no*maxdim,label='vvooil1')
    call mma_allocate(tmp,max(nc*no*maxdim,maxdim*maxdim*no*no),label='tmp')
    call mma_allocate(l2,max(nc*no*maxdim,maxdim*maxdim*no*no),label='vvooil2')
    !mp
    call gen_vvoo_blocked(t2_exp,l1,tmp,l2,length1,length2,ngaf,ngal,ngbf,ngbl)
    !mp
    call mma_deallocate(l2)
    call mma_deallocate(tmp)
    call mma_deallocate(l1)
    !mpn
    !!bdim = NSTEP
    ! mv T2(B,A,I,K) >> G(ix)
    KI = 0
    do K=1,noab(isp)
      KADT = (K-1)*NNUAB(3)*(NOAB(2)*(2-ISP)+ISP-1)
      do I=1,NOAB(IS2)
        KI = KI+1
        !mpn IADT = (I-1)*NNUAB(3)*(NOAB(2)*(2-IS2)+IS2-1)
        !mpn BADT = (2-ISP)*B1+(ISP-1)*(B1-1)*NUAB(2)
        do A=A1,A2
          !mpn
          if (nga < ngb) then
            a_tmp = a-nind_ngbf
            b1_tmp = b1-nind_ngaf
          else
            a_tmp = a-nind_ngaf
            b1_tmp = b1-nind_ngbf
          end if
          !mpn
          !mpn AADT = IADT+KADT+BADT+A*(ISP-1)+(2-ISP)*(A-1)*NUAB(2)+IG-1
          ! T2 <A,B,J,K> for isp=1 T2 <B,A,K,J> for isp=2

          RAD = (KI-1)*adim*nstep+(A-A1)*nstep+1
          !mpn ISTEP = (ISP-1)*NUAB(2)+2-ISP
          !mpn
          if (nga >= ngb) then ! nga> ngb

            !mp write(u6,'(A,4(i5,2x),3x,i5)') '(I)  a_tmp,b1_tmp,k,i  nstep = ',a_tmp,b1_tmp,k,i,nstep
            ! T2(B1,A,I,K) =? T2(A,B1,K,I)
            do j_tmp=0,NSTEP-1  ! istep je 1 ak dobre tusim

              AADT = (I-1)*length1*length2*NOAB(2)+(K-1)*length1*length2+(b1_tmp-1+j_tmp)*length1+a_tmp

              x2(RAD+j_tmp) = t2_exp(AADT)

            end do

          else ! nga < ngb

            !mp write(u6,'(A,4(i5,2x),3x,i5)') '(II) b1_tmp,a_tmp,k,i   nstep = ',b1_tmp,a_tmp,i,k,nstep
            ! T2(B1,A,I,K)
            do j_tmp=0,NSTEP-1  ! istep je 1 ak dobre tusim

              AADT = (k-1)*length1*length2*NOAB(2)+(i-1)*length1*length2+(a_tmp-1)*length1+b1_tmp+j_tmp

              x2(RAD+j_tmp) = t2_exp(AADT)

            end do
          end if
          !mpn
          !mpn x2(RAD:RAD+NSTEP-1) = t2_exp(AADT:AADT+NSTEP-1)

        end do    ! A
      end do      ! I
    end do        ! K
    !!write(u6,'(A,3I5,4x,5D15.10)') 'block-v: a1,b1,IAS,ddot',a1/vblock+1,b1/vblock+1,ias, &
    !!                               ddot_(NNOAB(3)*adim*nstep,G(IX),1,G(IX),1),(G(I),I=IX,IX+3)
    !mp call multi_wridir(G(IX),NNOAB(3)*adim*nstep,LU,IAS,last)
    !mp
    !mpn do jjj=1,NNOAB(3)*adim*nstep
    !mpn   if (abs(x2(jjj)) > 1.0e5_wp) then
    !mpn     write(u6,*) 'fucko 1'
    !mpn     write(u6,*) jjj,x2(jjj)
    !mpn     stop
    !mpn   end if
    !mpn end do
    !mp
    call multi_wridir(x2,NNOAB(3)*adim*nstep,LU,IAS,last)
    ias = ias+iasblock
    !mpn
    call mma_deallocate(t2_exp)
    !mpn
  end do    ! B1
end do      ! A1
!mp write(u6,*) 'cast 3 ok'
!!close(LU)   in calling routine
!write(u6,*) FN,isp,IAS
!!dupblk(ndup) = last   in calling routine
!mp call w_memchk('all klvaa ')
!!call w_free(g(ix),0,'IT klvaa ')   in calling routine
!mp
call mma_deallocate(x2)
!mp
!mpn
if (printkey > 1) write(u6,*) 'VVOO integrals regenerated from MOLCAS'

!mpn
call xflush(u6)
!!stop

return

end subroutine klvaa_oovo

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine input_process(nneq,neq,neqv,nmax,nCenter,nexch,nDir,nDirZee,nDirTot,nH,nT,exch,nBlock,nTempMagn,iopt,nMult,nDim,nPair, &
                         i_pair,nP,AngPoints,lant,multLn,KEOPT,encut_definition,nK,mG,ncut,nsfs,nss,nLoc,MxRank1,MxRank2,imaxrank, &
                         iPrint,nsymm,ngrid,R_LG,gtens_input,dirX,dirY,dirZ,dir_weight,zJ,cryst,coord,hmin,hmax,TempMagn,thrs, &
                         Hexp,Mexp,tmin,tmax,chit_exp,Texp,Xfield,Jex,JAex,JAex9,JDMex,tpar,upar,MagnCoords,encut_rate,eso, &
                         JITOexR,JITOexI,Title,itype,namefile_aniso,Do_structure_abc,old_aniso_format,compute_barrier,fitCHI,fitM, &
                         hinput,tinput,compute_magnetization,compute_Mdir_vector,zeeman_energy,m_paranoid,m_accurate,smagn, &
                         compute_g_tensors,compute_torque,compute_susceptibility,Lines,AnisoLines3,AnisoLines9,Dipol,check_title, &
                         KE,DM_exchange,JITO_exchange)
!  nneq      : number of non-equivalent sites
!  neq(nneq) : number of equivalent sites of each type
!  neqv      : = MAXVAL(neq(:))
! definition of the exchange:
!  exch      : total number of exchange states
!  nPair     : number of metal pairs (number of interactions)
!  i_pair    : index of the metal site in a given interacting pair
!  imaxrank  : index of the ITO ranks for each pair
!  Jex       : Lines exchange    ( 1 parameter / interacting pair)
!  JAex      : Anisotropic Lines ( 3 parameter / interacting pair)
!  JAex9     : Anisotropic Lines full ( 9 parameters / interacting pair)
!  JDMex     : Dzyaloshinsky-Morya exchange
!  MxRank1, MxRank2, Lines, AnisoLines3, AnisoLines9, Dipol, DM_exchange, JITO_exchange, old_aniso_format, JITOexR, JITOexI
! options used in connection with KE
!  lant, KEOPT, multLn, KE, tpar, upar
! options used in connection with Dipol-Dipol interaction
!  MagnCoords
! definition of data for susceptibility
!  nT, tinput, compute_susceptibility, tmin, tmax, chit_exp, Texp
! options related to XT_MoverH
!  Xfield, nH, nTempMagn, iopt, TempMagn, Hexp, Mexp, thrs, hmin, hmax, hinput, compute_magnetization, compute_Mdir_vector, &
!  zeeman_energy, m_paranoid, m_accurate, smagn
! options used to set up nM and EM
!  encut_definition
!  nK, mG     : encut_definition=1;
!  ncut       : encut_definition=2;
!  encut_rate : encut_definition=3;
! definition of g and D tensors
!  nMult, nDim, compute_g_tensors
! magnetization torque
!  nP, AngPoints, compute_torque
! Zeeman energy and M vector
!  nDir, nDirZee, dirX, dirY, dirZ, dir_weight
! definition of mean field parameter
!  zJ
! definition of the crystal axes:
!  Do_structure_abc
!  cryst : a, b, c, alpha, beta, gamma
! Cartesian coordinates of the main metal site, or center
!  coord
! definitions for blocking barrier
!  nBlock, compute_barrier
! options for automatic fitting of parameters:
!  fitCHI : not used so far
!  fitM   : not used so far
!  check_title, Title

use Lebedev_quadrature, only: order_table
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nneq, neq(nneq), neqv, nmax, nCenter, nexch(nneq), nDir, nDirZee, nH, nT, exch, nTempMagn, iopt, &
                                 nMult, nDim(nMult), nPair, i_pair(nPair,2), nP, AngPoints, lant, multLn, KEOPT, encut_definition, &
                                 nK, mG, ncut, nss(nneq), nsfs(nneq), nLoc, MxRank1, MxRank2, imaxrank(nPair,2), iPrint, nsymm
integer(kind=iwp), intent(inout) :: nDirTot, nBlock, ngrid
real(kind=wp), intent(in) :: R_LG(nneq,neqv,3,3), gtens_input(3,nneq), dirX(nDir), dirY(nDir), dirZ(nDir), dir_weight(nDirZee,3), &
                             zJ, cryst(6), coord(3), hmin, hmax, thrs, Hexp(nH), Mexp(nH,nTempMagn), tmin, tmax, chit_exp(nT), &
                             Texp(nT), Xfield, Jex(nPair), JAex(nPair,3), JAex9(nPair,3,3), JDMex(nPair,3), tpar, upar, &
                             MagnCoords(nneq,3), encut_rate, eso(nneq,nLoc), &
                             JITOexR(nPair,MxRank1,-MxRank1:MxRank1,MxRank2,-MxRank2:MxRank2), &
                             JITOexI(nPair,MxRank1,-MxRank1:MxRank1,MxRank2,-MxRank2:MxRank2)
real(kind=wp), intent(inout) :: TempMagn(nTempMagn)
character(len=180), intent(in) :: Title, namefile_aniso(nneq)
character, intent(in) :: itype(nneq)
logical(kind=iwp), intent(in) :: Do_structure_abc, old_aniso_format, fitCHI, fitM, hinput, tinput, compute_magnetization, &
                                 compute_Mdir_vector, zeeman_energy, m_accurate, smagn, compute_g_tensors, compute_torque, Lines, &
                                 AnisoLines3, AnisoLines9, Dipol, check_title, KE, DM_exchange, JITO_exchange
logical(kind=iwp), intent(inout) :: compute_barrier, m_paranoid, compute_susceptibility
integer(kind=iwp) :: i, icount_B_sites, iH, iproj1, iproj2, irank1, irank2, iT, j, jEnd, k, l, m, n
logical(kind=iwp) :: ab_initio_all, nosym
character(len=180) fmtline
integer(kind=iwp), parameter :: ngrid_map(32) = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,17,20,23,26,29,32,35,38,41,44,47,50,53,56,59, &
                                                 62,65]

!-----------------------------------------------------------------------
! print the data from this Subroutine:
if (check_title) write(u6,'(A,A72)') 'TITL :         = ',Title
! ======================================================================
! INFORMATION about individual magnetic sites
! ======================================================================
write(u6,'(A,  I5)') 'PRLV :         = ',iPrint
write(u6,'(A)') 'Information about individual magnetic sites:'
write(u6,'(A)')
write(u6,'(A,  I5)') 'NNEQ :         = ',nneq
write(u6,'(A,  I5)') 'NEQV :         = ',neqv
write(u6,'(A,50I5)') 'NEQ() :        = ',(neq(i),i=1,nneq)
write(u6,'(A,  I5)') 'nCenter :      = ',nCenter

write(u6,'(A,50I5  )') 'NEXCH():       = ',(nexch(i),i=1,nneq)
write(u6,'(A,50I5  )') 'NMAX:          = ',nmax
write(u6,'(A,50I5  )') 'NSTATE():      = ',(nsfs(i),i=1,nneq)
write(u6,'(A,50I5  )') 'NSS():         = ',(nss(i),i=1,nneq)

do i=1,nneq
  if (itype(i) == 'A') then
    write(u6,'(i3,1x,A15,1x,3i5,A)') i,namefile_aniso(i),nsfs(i),nss(i),nexch(i),' -- computed ab initio'
    write(u6,'(A,i2,A )') 'ESO(',i,' ):'
    write(u6,'(10F10.3)') (ESO(i,j),j=1,nss(i))
  else
    write(u6,'(i3,A15,1x,3i5,A)') i,' - - - - - - - ',nsfs(i),nss(i),nexch(i),' -- generated as isotropic'
  end if
end do

nosym = .true.
icount_B_sites = 0
ab_initio_all = .true.
do i=1,nneq
  if (neq(i) > 1) nosym = .false.
  if (itype(i) == 'B') then
    icount_B_sites = icount_B_sites+1
    ab_initio_all = .false.
  end if
end do
#ifdef _DEBUGPRINT_
write(u6,'(A,i3)') 'input_process:  icount_B_sites=',icount_B_sites
#endif

if (.not. nosym) then
  write(u6,'(A,A)') 'SYMM :         = ',' rotation matrices for equivalent magnetic centers:'
  do i=1,nneq
    write(u6,'(8x,A,i3)') 'center type:',i
    do j=1,neq(i)
      do m=1,3
        write(u6,'(20x,3F11.6)') (R_lg(i,j,m,n),n=1,3)
      end do
    end do
  end do
else
  write(u6,'(A,A )') 'SYMM :         = ',' rotation matrices are "Identity Matrices" for all magnetic centers'
end if

if (ab_initio_all) then
  write(u6,'(17x,A,I2,A)') 'all centers have been computed ab initio and ',nneq,' file(s) of "aniso_i.input" type exist.'
else
  write(u6,'(17x,I2,A,I2,A)') nneq-icount_B_sites,' center(s) have been computed ab initio and',nneq-icount_B_sites, &
                              ' file(s) of "aniso_i.input" type exist.'
  write(u6,'(17x,I2,A,15F7.3)') icount_B_sites,' center(s) have been defined empirical: no ZFS and g_tens = '
  write(u6,'(17x,A,99F10.5)') 'gX = ',(gtens_input(1,i),i=1,nneq)
  write(u6,'(17x,A,99F10.5)') 'gY = ',(gtens_input(2,i),i=1,nneq)
  write(u6,'(17x,A,99F10.5)') 'gZ = ',(gtens_input(3,i),i=1,nneq)
end if

if (old_aniso_format) write(u6,'(A,A)') 'OLDA :         = ',' Input data files are given in OLD format'

! ======================================================================
! INFORMATION about exchange
! ======================================================================
write(u6,'(A)') 'Information about exchange and magnetic couplings'
if (Lines) then
  write(u6,'(A,  I3  )') 'PAIR or LIN1 : = ',npair
  do i=1,npair
    write(u6,'(17x,2I3,2x, F9.5)') i_pair(i,1),i_pair(i,2),Jex(i)
  end do
end if

if (AnisoLines3) then
  write(u6,'(A,  I3  )') 'LIN3 :         = ',npair
  do i=1,npair
    write(u6,'(17x,2I3,2x,3F9.5)') i_pair(i,1),i_pair(i,2),(JAex(i,j),j=1,3)
  end do
end if

if (AnisoLines9) then
  write(u6,'(A,  I3  )') 'LIN9 :         = ',npair
  do i=1,npair
    write(u6,'(17x,2I3,2x,9F9.5)') i_pair(i,1),i_pair(i,2),(JAex9(i,1,j),j=1,3),(JAex9(i,2,j),j=1,3),(JAex9(i,3,j),j=1,3)
  end do
end if

if (DM_exchange) then
  write(u6,'(A,  I3  )') 'DMEX :         = ',npair
  do i=1,npair
    write(u6,'(17x,2I3,2x,3F9.5)') i_pair(i,1),i_pair(i,2),(JDMex(i,j),j=1,3)
  end do
end if

if (Dipol) then
  write(u6,'(A,A )') 'DIPO :         = ',' dipolar coupling for the above exchange pairs is included'
  write(u6,'(A,A )') 'COOR :         = ',' symmetrized cartesian coordinates for each non-equivalent magnetic centers '
  do i=1,nneq
    write(u6,'(17x,i3,3F11.6)') i,(MagnCoords(i,l),l=1,3)
  end do
else
  write(u6,'(A,A )') 'DIPO :         = ',' dipolar coupling for the above exchange pairs is NOT included.'
end if

if (KE) then
  write(u6,'(A,A )') 'LONG :         = ','kinetic exchange coupling is requested:'
  write(u6,'(A,2F14.7)') 't     = ',tpar
  write(u6,'(A,2F14.7)') 'U     = ',upar
  write(u6,'(A,i2    )') 'lant  = ',lant
  write(u6,'(A,i2    )') 'multLn= ',multLn
  write(u6,'(A,i2    )') 'keopt = ',KEOPT
end if

if (JITO_exchange) then
  write(u6,'(A,A )') 'ITOJ :         = ',' Full anisotopic ITO exchange for the above exchange pairs is included (in cm-1)'
  do i=1,npair
    write(u6,'(17x,2I3)') i_pair(i,1),i_pair(i,2)
    do irank1=1,imaxrank(i,1),2
      do iproj1=-irank1,irank1
        do irank2=1,imaxrank(i,2),2
          do iproj2=-irank2,irank2
            write(u6,'(23x,4I3,2x,2ES23.14)') irank1,iproj1,irank2,iproj2,JITOexR(i,irank1,iproj1,irank2,iproj2), &
                                              JITOexI(i,irank1,iproj1,irank2,iproj2)
          end do
        end do
      end do
    end do
  end do
end if
!-----------------------------------------------------------------------
! print Exchange Hamiltonian
! print Exchange Eigenstates
! print decomposition of exchange
!...
! ======================================================================
! Print out of the UBAR:
if (compute_barrier) then
  if (compute_g_tensors) then
    Nblock = 0
    do i=1,nmult
      Nblock = Nblock+ndim(i)
    end do
  else
    write(u6,'(A)') 'UBAR keyword needs to know the sizes of'
    write(u6,'(A)') 'the manifolds forming the barrier'
    write(u6,'(A)') 'Was the MLTP keyword defined?'
    write(u6,'(A)') 'The program will continue, but UBAR is deactivated'
    compute_barrier = .false.
  end if

  if (Nblock > exch) then
    write(u6,'(A)') 'It seems that you have asked for properties of inexistent states.'
    write(u6,'(A)') 'Nblock > Nexch!'
    write(u6,'(A,I5)') 'Nblock = ',nBlock
    write(u6,'(A,I5)') 'Nexch  = ',exch
    write(u6,'(A   )') 'Reset   NBLOCK=EXCH and continue'
    nBlock = exch
  end if
end if

! ======================================================================
! Print out of the g and D tensors:

if (compute_g_tensors .and. (nMult > 0)) then
  write(u6,'(A)') 'Information about g and D tensors:'
  write(u6,'(A,I3)') 'MLTP :         = ',NMULT
  if (nMult <= 20) then
    write(u6,'(A,20I3)') '               = ',(NDIM(i),i=1,NMULT)
  else
    write(u6,'(A,20I3)') '               = ',(NDIM(i),i=1,20)
    do j=21,NMULT,20
      jEnd = min(NMULT,J+19)
      write(u6,'(A,20I3)') '                 ',(NDIM(i),i=j,jEnd)
    end do
  end if
else
  write(u6,'(A)') 'Computation of pseudospin Hamiltonians was not requested'
end if

if (compute_g_tensors .and. (nMult == 0)) then
  write(u6,'(A,i3)') 'nMult =',nMult
  write(u6,'(A   )') 'Computation of pseudospin Hamiltonians is deactivated.'
end if
! ======================================================================

if (Do_structure_abc .and. ((nMult > 0) .or. compute_susceptibility)) then
  write(u6,'(2A)') 'ABCC :         = ','the main axes for the computed tensors are written also'
  write(u6,'(A)') 'in the crystallographic "abc" axes'
  write(u6,'(10x,A,F9.4)') 'a       = ',cryst(1)
  write(u6,'(10x,A,F9.4)') 'b       = ',cryst(2)
  write(u6,'(10x,A,F9.4)') 'c       = ',cryst(3)
  write(u6,'(10x,A,F9.4)') 'alpha   = ',cryst(4)
  write(u6,'(10x,A,F9.4)') 'beta    = ',cryst(5)
  write(u6,'(10x,A,F9.4)') 'gamma   = ',cryst(6)
  write(u6,'(10x,a,3F9.4)') 'coords: = ',(coord(i),i=1,3)
end if

! ======================================================================
! Print out of the SUSCEPTIBILITY
compute_susceptibility = .true.
if (compute_susceptibility) then
  !-----------------------------------------!
  write(u6,'(A)') 'Magnetic susceptibility will be computedin the limit of zero applied magnetic field.'
  !-----------------------------------------!
  write(u6,'(A,A )') 'CHIT :         = ',' molar magnetic susceptibility is computed using'
  !-----------------------------------------!
  if (IOPT == 1) then
    write(u6,'(18x,A)') 'newly-derived formula for total XT and M'
  else if (IOPT == 2) then
    write(u6,'(18x,A)') 'additive formula employed for total XT and M'
  else if (IOPT == 3) then
    write(u6,'(18x,A)') 'old formula employed for total XT and M'
  else
    write(u6,'(18x,A)') 'IOPT parameter out of range.'
    return
  end if
  !-----------------------------------------!
  if (TINPUT) then
    write(u6,'(A)') 'TEXP :         = the experimental temperature interval is provided:'
    do iT=1,nT
      write(u6,'(5X,i4,F11.5,F14.7)') iT,Texp(iT),chit_exp(iT)
    end do
  else
    write(u6,'(A, I4)') 'TINT :      nT = ',nT
    write(u6,'(A,F7.3)') '          Tmin = ',Tmin
    write(u6,'(A,F7.3)') '          Tmax = ',Tmax
  end if
  !-----------------------------------------!
  if (xField /= Zero) then
    write(u6,'(A)') 'Magnetic susceptibility will be computed also by using:'
    write(u6,'(A)') ' X= dM/dH formula and'
    write(u6,'(A)') ' X=  M/H formula (commonly used by experimentalists)'
    write(u6,'(A,F9.5,A)') 'FIELD :          ',Xfield,' Telsa'
  end if
  !-----------------------------------------!
else
  write(u6,'(A)') 'Computation of magnetic susceptibility was not requested.'
end if

! ======================================================================
! Print out of the TORQUE
if (compute_torque) then
  write(u6,'(A)') 'TORQ :         = ',' magnetic torque is computed'
  write(u6,'(A,I4)') 'AngPoints = ',AngPoints
  write(u6,'(A,i4)') 'nP        = ',nP
else
  write(u6,'(A)') 'Computation of magnetic torque was not requested.'
end if

! ======================================================================

! ======================================================================
! Print out of the MAGNETIZATION
ngrid = ngrid_map(ngrid)
if (compute_magnetization) then
  write(u6,'(2A )') 'MAGN :         = ',' molar magnetization is computed'
  !-----------------------------------------!
  if (nH > 0) then
    if (HINPUT) then
      write(u6,'(A)') 'HEXP :         = the experimental field interval is provided:'
      write(fmtline,'(A,i3,A)') '(5x,i4,F11.5,',nTempMagn,'F14.7)'
      do iH=1,nH
        write(u6,fmtline) iH,Hexp(iH),(Mexp(iH,iT),iT=1,nTempMagn)
      end do
    else
      write(u6,'(A, I4)') 'HINT :      nH = ',nH
      write(u6,'(A,F7.3)') '          Hmin = ',Hmin
      write(u6,'(A,F7.3)') '          Hmax = ',Hmax
    end if
  end if
  !-----------------------------------------!
  if (encut_definition == 1) then
    write(u6,'(A, I4)') 'NCUT :         = ',ncut
  else if (encut_definition == 2) then
    write(u6,'(A,2I4)') 'ECUT :         = ',nk,mg
  else if (encut_definition == 3) then
    write(u6,'(A,F7.3)') 'ERAT :         = ',encut_rate
  end if
  !-----------------------------------------!
  write(u6,'(A, I4   )') 'TMAG :         = ',nTempMagn
  ! check for negative T
  do i=1,nTempMagn
    if (TempMagn(i) <= Zero) TempMagn(i) = Two
  end do

  !-----------------------------------------!
  if (nTempMagn <= 10) then
    write(u6,'(6x,A,10F7.3)') 'TempMagn = ',(TempMagn(i),i=1,nTempMagn)
  else
    do i=1,nTempMagn,10
      j = min(nTempMagn,i+9)
      write(u6,'(17x,10F7.3)') (TempMagn(k),k=i,j)
    end do
  end if
  !-----------------------------------------!
  if (zeeman_energy) then
    write(u6,'(2A,I3,A)') 'ZEEM :         = ',' Zeeman splitting for the following ',nDirZee
    write(u6,'(17x,A  )') 'direction(s) of the magnetic field is given in the "zeeman_energy_xxx.output" file(s)'
    do i=1,nDirZee
      write(u6,'(17x,3F11.6)') (dir_weight(i,l),l=1,3)
    end do
  end if
  !-----------------------------------------!
  if (compute_Mdir_vector) then
    write(u6,'(2A,I2,a)') 'MVEC :         = ','Magnetization vector(s) for the following ',nDir, &
                          ' direction(s) of the applied magnetic'
    write(u6,'(17x,A)') 'field will be computed;'
    do i=1,nDir
      write(u6,'(17x,A,I2,A,3F10.6)') 'Dir :',i,' : ',DirX(i),DirY(i),DirZ(i)
    end do
  end if

  if (nH > 0) then
    !-----------------------------------------!
    write(u6,'(A, I4)') 'MAVE :   nsymm = ',nsymm
    write(u6,'(A, I4)') '         ngrid = ',ngrid
    write(u6,'(A, I4)') '       nPoints = ',order_table(nsymm,ngrid)
    !-----------------------------------------!
    nDirTot = nDir+nDirZee+order_table(nsymm,ngrid)
    write(u6,'(A,I4,A)') 'Magnetization will be computed in',nDirTot,' directions.'
    write(u6,'(A,I6,A)') 'There will be ',nDirTot*nH,' calculations in total.'

    !-----------------------------------------------------------|
    if (m_accurate) then
      write(u6,'(2A   )') 'MACC :         = ','Contribution to magnetization from local excited states'
      write(u6,'(17x,A)') 'is computed exactly.'
    else
      write(u6,'(17x,A)') 'is accounted by formula:  M_excited = X_excited * H'
    end if
    !-----------------------------------------------------------|

    !-----------------------------------------------------------|
    if ((exch < 256) .and. (zJ /= Zero)) m_paranoid = .true.

    if (m_paranoid .and. (zJ /= Zero)) then
      write(u6,'(2A)') 'MPAR :         = ','Average spin < S > of the environment is computed'
      write(u6,'(2A)') '                 ','for each temperature point (more accurate)'
    else
      write(u6,'(2A)') 'MPAR :         = ','Average spin < S > of the environment is computed'
      write(u6,'(2A)') '                 ','for the highest temperature point only and used for all computed temperature points.'
    end if
    !-----------------------------------------------------------|

    !-----------------------------------------------------------|
    if (smagn) then
      write(u6,'(2A)') 'SMAG :         = ','Spin-only magnetisation is computed'
    else
      write(u6,'(A)') 'Computation of spin magnetization was not requested.'
    end if
    !-----------------------------------------------------------|

    write(u6,'(A,ES14.6)') 'THRS = ',thrs
  end if
else
  write(u6,'(A)') 'Computation of molar magnetization was not requested.'
end if
! End Print out of the MAGNETIZATION
! ======================================================================
if (compute_susceptibility .or. compute_torque .or. compute_magnetization) then
  if (zJ /= Zero) then
    write(u6,'(A)') 'Mean field intermolecular interaction parameter'
    write(u6,'(A,F12.7)') 'ZJPR :         = ',zJ
  end if
end if
! ======================================================================
if ((fitCHI .or. fitM) .and. (tinput .or. hinput)) &
  write(u6,'(A)') 'Automatic fitting of exchange parameters is yet in the development'
! ======================================================================

return

end subroutine input_process

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine dmxma(n,transa,transb,a,b,c,alpha)
C
C Square real matrices multiplication
C
      implicit none
      integer n
      Real*8 a(*),b(*),c(*),alpha
      character*1 transa,transb
      call dgemm_(transa,transb,n,n,n,alpha,a(1),n,b(1),n,0.d0,c(1),n)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 2006  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKRPTORB(FIFA,NFIFA,TORB,NTORB,CMO,NCMO)
! Transform to orbitals that diagonalize the diagonal blocks of FIFA.
! Affected data sets are CMO, C EPS, EPSI, EPSA, and EPSE. Also, the
! CI arrays are transformed on file LUCIEX.
! Note: FIFA is unchanged  and is not valid for the new orbitals.
! It will be recomputed later.
! The transformation matrices are returned in TORB.

use Index_Functions, only: nTri_Elem
use fciqmc_interface, only: DoFCIQMC, NonDiagonal
use caspt2_global, only: IDCIEX, IDTCEX, LUCIEX
use caspt2_module, only: EPS, EPSA, EPSE, EPSI, iSCF, nBas, nConf, nDel, nFro, nIsh, nOMx, nOrb, nRas1, nRas2, nRas3, nSsh, &
                         nState, nSym, STSym
#if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_)
use caspt2_module, only: DoCumulant
#endif
#if defined (_ENABLE_BLOCK_DMRG_) || defined (_DMRG_)
use caspt2_module, only: jState, nAshT
use Constants, only: Zero
#endif
#if defined(_DMRG_)
use, intrinsic :: iso_c_binding, only: c_bool, c_int
use qcmaquis_interface, only: qcmaquis_interface_rotate_rdms
use caspt2_module, only: DMRG
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NFIFA, NTORB, NCMO
real(kind=wp), intent(in) :: FIFA(NFIFA)
real(kind=wp), intent(out) :: TORB(NTORB)
real(kind=wp), intent(inout) :: CMO(NCMO)
integer(kind=iwp) :: I, ICMOEND, ICMOSTA, IDR, IDW, IEPS, IEPSA, IEPSE, IEPSI, II, IOEND, IOSTA, IST, ISYM, ITOEND, ITOSTA, NB, &
                     NCMOSCT, NFES, NFOCK, NO, NSCT
real(kind=wp), allocatable :: CI(:), CMO2(:), FOCK(:)
#if defined(_ENABLE_BLOCK_DMRG_) || defined(_DMRG_)
integer(kind=iwp) :: NXMAT
real(kind=wp), allocatable :: XMAT(:)
#endif

! Allocate space for temporary square Fock matrix in each symmetry:
! NBMX=Max number of basis functions in any symmetry, in common in caspt2_module
NFOCK = NOMX**2
call mma_allocate(FOCK,NFOCK,LABEL='FOCK')
! Allocate space for new CMO coefficients:
call mma_allocate(CMO2,NCMO,LABEL='CMO2')

! In the loop over symmetries, NFES is the nr of Fock matrix
! elements processed in earlier symmetries.
NFES = 0
IEPS = 0
IEPSI = 0
IEPSA = 0
IEPSE = 0
! The transformation matrices for each symmetry
! will be collected into TORB and returned. This is
! necessary for later backtransformation to original
! MO basis.
! ITOSTA,ITOEND: Section of TORB for each subspace.
ITOEND = 0
! ICMOSTA,ICMOEND: Section of CMO for each subspace.
ICMOEND = 0
do ISYM=1,NSYM
  NO = NORB(ISYM)
  NB = NBAS(ISYM)
  ! Put Fock matrix in square format in FOCK
  if (NO > 0) call SQUARE(FIFA(NFES+1),FOCK,NO,1,NO)
  ! the zero-ing out of the off-diagonal blocks happens here
  ! diafck is not structured like rasscf/fckpt2
  ! Number of orbitals processed so far in this symmetry:
  IOEND = 0
  ! Frozen orbitals: Just copy frozen CMO coefficients.
  NSCT = NFRO(ISYM)
  if (NSCT > 0) then
    NCMOSCT = NBAS(ISYM)*NSCT
    ICMOSTA = ICMOEND+1
    ICMOEND = ICMOEND+NCMOSCT
    CMO2(ICMOSTA:ICMOEND) = CMO(ICMOSTA:ICMOEND)
  end if
  ! Inactive block: Section length NSCT=NISH(ISYM)
  NSCT = NISH(ISYM)
  if (NSCT > 0) then
    IOSTA = IOEND+1
    IOEND = IOEND+NSCT
    NCMOSCT = NBAS(ISYM)*NSCT
    ICMOSTA = ICMOEND+1
    ICMOEND = ICMOEND+NCMOSCT
    ITOSTA = ITOEND+1
    ITOEND = ITOEND+NSCT**2
    call DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),NB,CMO(ICMOSTA),CMO2(ICMOSTA))
    do I=1,NSCT
      II = IOSTA-1+I
      IEPS = IEPS+1
      EPS(IEPS) = FOCK(II+NO*(II-1))
      IEPSI = IEPSI+1
      EPSI(IEPSI) = EPS(IEPS)
    end do
  end if
  ! RAS1 block: Section length NSCT=NRAS1(ISYM)
  NSCT = NRAS1(ISYM)
  if (NSCT > 0) then
    IOSTA = IOEND+1
    IOEND = IOEND+NSCT
    NCMOSCT = NBAS(ISYM)*NSCT
    ICMOSTA = ICMOEND+1
    ICMOEND = ICMOEND+NCMOSCT
    ITOSTA = ITOEND+1
    ITOEND = ITOEND+NSCT**2
    call DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),NB,CMO(ICMOSTA),CMO2(ICMOSTA))
    do I=1,NSCT
      II = IOSTA-1+I
      IEPS = IEPS+1
      EPS(IEPS) = FOCK(II+NO*(II-1))
      IEPSA = IEPSA+1
      EPSA(IEPSA) = EPS(IEPS)
    end do
  end if
  ! RAS2 block: Section length NSCT=NRAS2(ISYM)
  NSCT = NRAS2(ISYM)
  if (NSCT > 0) then
    IOSTA = IOEND+1
    IOEND = IOEND+NSCT
    NCMOSCT = NBAS(ISYM)*NSCT
    ICMOSTA = ICMOEND+1
    ICMOEND = ICMOEND+NCMOSCT
    ITOSTA = ITOEND+1
    ITOEND = ITOEND+NSCT**2
    call DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),NB,CMO(ICMOSTA),CMO2(ICMOSTA))
    do I=1,NSCT
      II = IOSTA-1+I
      IEPS = IEPS+1
      EPS(IEPS) = FOCK(II+NO*(II-1))
      IEPSA = IEPSA+1
      EPSA(IEPSA) = EPS(IEPS)
    end do
  end if
  ! RAS3 block: Section length NSCT=NRAS3(ISYM)
  NSCT = NRAS3(ISYM)
  if (NSCT > 0) then
    IOSTA = IOEND+1
    IOEND = IOEND+NSCT
    NCMOSCT = NBAS(ISYM)*NSCT
    ICMOSTA = ICMOEND+1
    ICMOEND = ICMOEND+NCMOSCT
    ITOSTA = ITOEND+1
    ITOEND = ITOEND+NSCT**2
    call DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),NB,CMO(ICMOSTA),CMO2(ICMOSTA))
    do I=1,NSCT
      II = IOSTA-1+I
      IEPS = IEPS+1
      EPS(IEPS) = FOCK(II+NO*(II-1))
      IEPSA = IEPSA+1
      EPSA(IEPSA) = EPS(IEPS)
    end do
  end if
  ! Secondary (virtual) block: Section length NSCT=NSSH(ISYM)
  NSCT = NSSH(ISYM)
  if (NSCT > 0) then
    IOSTA = IOEND+1
    IOEND = IOEND+NSCT
    NCMOSCT = NBAS(ISYM)*NSCT
    ICMOSTA = ICMOEND+1
    ICMOEND = ICMOEND+NCMOSCT
    ITOSTA = ITOEND+1
    ITOEND = ITOEND+NSCT**2
    call DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),NB,CMO(ICMOSTA),CMO2(ICMOSTA))
    do I=1,NSCT
      II = IOSTA-1+I
      IEPS = IEPS+1
      EPS(IEPS) = FOCK(II+NO*(II-1))
      IEPSE = IEPSE+1
      EPSE(IEPSE) = EPS(IEPS)
    end do
  end if
  ! Deleted orbitals: Just copy deleted CMO coefficients.
  NSCT = NDEL(ISYM)
  if (NSCT > 0) then
    NCMOSCT = NBAS(ISYM)*NSCT
    ICMOSTA = ICMOEND+1
    ICMOEND = ICMOEND+NCMOSCT
    CMO2(ICMOSTA:ICMOEND) = CMO(ICMOSTA:ICMOEND)
  end if

  NFES = NFES+nTri_Elem(NO)

end do

! Actually, we will not use the old CMO array any more, so just
! overwrite it with the new ones and get rid of the allocated array.
CMO(:) = CMO2(:)
call mma_deallocate(CMO2)

! We will not use the Fock matrix either. It was just used temporarily
! for each turn of the symmetry loop. Skip it.
call mma_deallocate(FOCK)

! Finally, loop again over symmetries, transforming the CI:

if (ISCF == 0) then
# ifdef _DMRG_
  if (DMRG) then
    NXMAT = NASHT**2
    call mma_allocate(XMAT,NXMAT,LABEL='XMAT')
    XMAT(:) = Zero
    call MKXMAT(TORB,XMAT)

    call qcmaquis_interface_rotate_rdms(int(JSTATE-1,kind=c_int),int(JSTATE-1,kind=c_int),0_c_int,XMAT,.false._c_bool)
    do I=1,NSTATE
      if (JSTATE /= I) then
        write(u6,*) 'QCMaquis> Rotating tRDMs',JSTATE-1,I-1
        call qcmaquis_interface_rotate_rdms(int(JSTATE-1,kind=c_int),int(I-1,kind=c_int),0_c_int,XMAT,.false._c_bool)
      end if
    end do
    call mma_deallocate(XMAT)
  end if
# endif

  if (DoFCIQMC) then
    if (NonDiagonal) then
      write(u6,*) 'Transforming CASPT2 intermediates to pseudo-canonical orbitals.'
    else
      write(u6,*) 'FCIQMC-CASPT2 assumes pseudo-canonical orbitals.'
    end if
  else
#   if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_)
    if (.not. DoCumulant) then
#   endif
      call mma_allocate(CI,NCONF,Label='CI')
      do IST=1,NSTATE
        IDR = IDCIEX(IST)
        call DDAFILE(LUCIEX,2,CI,NCONF,IDR)

        call mkTraCI(nTORB,TORB,STSYM,nConf,CI)

        IDW = IDTCEX(IST)
        call DDAFILE(LUCIEX,1,CI,NCONF,IDW)
      end do
      call mma_deallocate(CI)
#   ifdef _ENABLE_BLOCK_DMRG_
    else
      ! Transforming 2,3-RDMs from Block DMRG (1-RDM is computed from 2-RDM)
      ! NN.14 : For the time, Block's dump files of RDMs are directly loaded,
      !         but those should be stored in JobIph file eventually.
      NXMAT = NASHT**2
      ! Workspace for transformation matrix
      call mma_allocate(XMAT,NXMAT,LABEL='XMAT')
      XMAT(:) = Zero
      call MKXMAT(TORB,XMAT)

      call block_tran2pdm(NASHT,XMAT,JSTATE,JSTATE)
      call block_tran3pdm(NASHT,XMAT,JSTATE,JSTATE)

      call mma_deallocate(XMAT)
    end if
#   elif _ENABLE_CHEMPS2_DMRG_
  else
    write(u6,*) 'CHEMPS2> MKRPTORB assumes PSEUDOCANONICAL orbitals!'
  end if
# endif
end if
end if

end subroutine MKRPTORB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c -------------------------------------------------------------------
c The following subroutine calculates a batch of 2-electron
c density matrix elements in SO basis.
c Need to know:
c   nish(),nash(),nbas()
c   cmo()
c   npam(indpos,isym)= Nr of SO indices at index position 1..4,
c       with symmetry label isym=0..7.
c   ipam()= A consecutive list of SO indices.
c   DSO()=Density matrix in SO basis, symmetry blocked.
c   G1()=Active MO 1-el density matrix.
c   G2()=d:o,   MO 2-el density matrix.
c Also:
c   ncmo=Size of cmo array (for dimensioning only)
c   nDSO=Similar, DSO matrix
c   mxpam=Similar, ipam array
c   mxSO=Largest batch of SO indices in one single symmetry
c Returns:
c   PSOPam()=a four-index array containing the selected matrix
c         elements.
c -------------------------------------------------------------------
      subroutine ptrans(cmo,npam,ipam,nxpam,DSO,PSOPam,nPSOPam,
     &                  G1,nG1,G2,nG2,Cred,nC,Scr1,nS1,Scr2,nS2)
      Implicit Real*8 (a-h,o-z)
      Integer npam(4,0:*)
      Real*8 ipam(nxpam)
      Real*8 DSO(nDSO), PSOPam(nPSOPam), G1(nG1), G2(nG2),
     &       Cred(nC), Scr1(nS1), Scr2(nS2), Cmo(ncmo)
#include "real.fh"
#include "print.fh"
#include "etwas.fh"
c Triangular addressing without symmetry:
      i3adr(i,j)=( (max(i,j)) *( (max(i,j)) -1) )/2+min(i,j)
*
      iRout = 251
      iPrint = nPrint(iRout)
*     Call GetMem('List1','List','Real',iDum,iDum)
      If (iPrint.ge.99) Then
         Write (6,*) ' iPam',iPam
         Write (6,*) ' nPam',(nPam(1,i),i=0,mIrrep-1)
         Write (6,*) ' nPam',(nPam(2,i),i=0,mIrrep-1)
         Write (6,*) ' nPam',(nPam(3,i),i=0,mIrrep-1)
         Write (6,*) ' nPam',(nPam(4,i),i=0,mIrrep-1)
      End If
      t14 = Quart
c Offsets into the ipam array:
      nnpam1=0
      nnpam2=0
      nnpam3=0
      nnpam4=0
      do 10 isym=0,mirrep-1
        nnpam1=nnpam1+npam(1,isym)
        nnpam2=nnpam2+npam(2,isym)
        nnpam3=nnpam3+npam(3,isym)
        nnpam4=nnpam4+npam(4,isym)
  10  continue
      nPSOP=nnpam1*nnpam2*nnpam3*nnpam4
      call dcopy_(nPSOP,[Zero],0,PSOPam,1)
      iopam1=0
      iopam2=nnpam1
      iopam3=iopam2+nnpam2
      iopam4=iopam3+nnpam3
c Loop over all possible symmetry combinations.
      lend=0
      ixend=0
      iocmol=0
      ioDs=0
      do 1040 lsym=0,mirrep-1
        nl=npam(4,lsym)
        lsta=lend+1
        lend=lend+nl
        nx=nash(lsym)
        ixsta=ixend+1
        ixend=ixend+nx
        iocmox=iocmol+nish(lsym)*mbas(lsym)
      kend=0
      ivend=0
      iocmok=0
      ioDr=0
      do 1030 ksym=0,mirrep-1
        klsym=ieor(ksym,lsym)
        nk=npam(3,ksym)
        ksta=kend+1
        kend=kend+nk
        nkl=nk*nl
        nv=nash(ksym)
        ivsta=ivend+1
        ivend=ivend+nv
        nxv=nx*nv
        iocmov=iocmok+nish(ksym)*mbas(ksym)
      jend=0
      iuend=0
      iocmoj=0
      ioDq=0
      do 1020 jsym=0,mirrep-1
        jksym=ieor(jsym,ksym)
        nj=npam(2,jsym)
        jsta=jend+1
        jend=jend+nj
        njkl=nj*nkl
        nu=nash(jsym)
        iusta=iuend+1
        iuend=iuend+nu
        nxvu=nxv*nu
        iocmou=iocmoj+nish(jsym)*mbas(jsym)
      iend=0
      itend=0
      iocmoi=0
      do 1010 isym=0,mirrep-1
        ni=npam(1,isym)
        ista=iend+1
        iend=iend+ni
        nijkl=ni*njkl
        nt=nash(isym)
        itsta=itend+1
        itend=itend+nt
        nxvut=nxvu*nt
        iocmot=iocmoi+nish(isym)*mbas(isym)
c Break loop if not acceptable symmetry combination.
        ijsym=ieor(isym,jsym)
        if(klsym.ne.ijsym) goto 1005
c Break loop if no such symmetry block:
        if(nijkl.eq.0) goto 1005
        ilsym=jksym
        If (iPrint.ge.99) Write (6,*) ' i,j,k,lsym=',iSym,jSym,kSym,lSym
c Bypass transformation if no active orbitals:
        if(nxvut.eq.0) goto 300
c Pick up matrix elements and put in a full symmetry block:
        ind=0
        do 140 ix=ixsta,ixend
         do 130 iv=ivsta,ivend
          ivx=i3adr(iv,ix)
          do 120 iu=iusta,iuend
           do 110 it=itsta,itend
            itu=i3adr(it,iu)
            ituvx=i3adr(itu,ivx)
            ind=ind+1
            scr1(ind)=G2(ituvx)
            if(isym.eq.jsym) then
              fact=1.0d00
              if(itu.ge.ivx .and. iv.eq.ix) fact=2.0d00
              if(itu.lt.ivx .and. it.eq.iu) fact=2.0d00
              scr1(ind)=fact*scr1(ind)
chjw multiplying the G1 product with coulfac gives wrong result
              scr1(ind)=scr1(ind)-G1(itu)*G1(ivx)
            end if
            if(isym.eq.lsym) then
              itx=i3adr(it,ix)
              ivu=i3adr(iv,iu)
chjw t14 includes exfac, why not coulfac above? What are these terms?
              scr1(ind)=scr1(ind)+t14*G1(itx)*G1(ivu)
            end if
            if(isym.eq.ksym) then
              itv=i3adr(it,iv)
              ixu=i3adr(ix,iu)
              scr1(ind)=scr1(ind)+t14*G1(itv)*G1(ixu)
            end if
 110     continue
 120    continue
 130   continue
 140  continue
      If (iPrint.ge.99) Call RecPrt('G2-G1G1(MO)',' ',
     &                              Scr1,
     &                              nash(iSym)*nash(jSym),
     &                              nash(kSym)*nash(lsym))
c
c Transform:
c  scr2(l,tuv)= sum cmo(sl,x)*scr1(tuv,x)
      ncopy=nash(lsym)
      nskip1=mbas(lsym)
      ioff2=0
      nskip2=npam(4,lsym)
      ntuv=nash(isym)*nash(jsym)*nash(ksym)
      do 210 l=lsta,lend
        ioff1=iocmox+INT(ipam(iopam4+l))
        ioff2=ioff2+1
        call dcopy_(ncopy,CMO(ioff1),nskip1,Cred(ioff2),nskip2)
 210  continue
      call DGEMM_('N','T',
     &            nskip2,ntuv,ncopy,
     &            1.0d0,Cred,nskip2,
     &            Scr1,ntuv,
     &            0.0d0,Scr2,nskip2)
c Transform:
c  scr3(k,ltu)= sum cmo(rk,v)*scr2(ltu,v)
      ncopy=nash(ksym)
      nskip1=mbas(ksym)
      ioff2=0
      nskip2=npam(3,ksym)
      nltu=nash(isym)*nash(jsym)*npam(4,lsym)
      do 220 k=ksta,kend
        ioff1=iocmov+INT(ipam(iopam3+k))
        ioff2=ioff2+1
        call dcopy_(ncopy,CMO(ioff1),nskip1,Cred(ioff2),nskip2)
 220  continue
      call DGEMM_('N','T',
     &            nskip2,nltu,ncopy,
     &            1.0d0,Cred,nskip2,
     &            Scr2,nltu,
     &            0.0d0,Scr1,nskip2)
c Transform:
c  scr4(j,klt)= sum cmo(qj,u)*scr3(klt,u)
      ncopy=nash(jsym)
      nskip1=mbas(jsym)
      ioff2=0
      nskip2=npam(2,jsym)
      nklt=nash(isym)*npam(3,ksym)*npam(4,lsym)
      do 230 j=jsta,jend
        ioff1=iocmou+INT(ipam(iopam2+j))
        ioff2=ioff2+1
        call dcopy_(ncopy,CMO(ioff1),nskip1,Cred(ioff2),nskip2)
 230  continue
      call DGEMM_('N','T',
     &            nskip2,nklt,ncopy,
     &            1.0d0,Cred,nskip2,
     &            Scr1,nklt,
     &            0.0d0,Scr2,nskip2)
c Transform:
c  scr5(i,jkl)= sum cmo(pi,t)*scr4(jkl,t)
      ncopy=nash(isym)
      nskip1=mbas(isym)
      ioff2=0
      nskip2=npam(1,isym)
      njkl=npam(2,jsym)*npam(3,ksym)*npam(4,lsym)
      do 240 i=ista,iend
        ioff1=iocmot+INT(ipam(iopam1+i))
        ioff2=ioff2+1
        call dcopy_(ncopy,CMO(ioff1),nskip1,Cred(ioff2),nskip2)
 240  continue
      call DGEMM_('N','T',
     &            nskip2,njkl,ncopy,
     &            1.0d0,Cred,nskip2,
     &            Scr2,njkl,
     &            0.0d0,Scr1,nskip2)
      If (iPrint.ge.99) Call RecPrt('G2-G1G1(SO)',' ',
     &                              Scr1,
     &                              nPam(1,iSym)*nPam(2,jSym),
     &                              nPam(3,kSym)*nPam(4,lSym))
c
c Put results into correct positions in PSOPam:
      do 280 l=lsta,lend
       loff=nnpam3*(l-1)
       lof1=nPam(3,ksym)*(l-lsta)
       do 270 k=ksta,kend
        kloff=nnpam2*(k-1+loff)
        klof1=nPam(2,jsym)*(k-ksta+lof1)
        do 260 j=jsta,jend
         jkloff=nnpam1*(j-1+kloff)
         jklof1=nPam(1,isym)*(j-jsta+klof1)
         do 250 i=ista,iend
          ipso=i+jkloff
          iscr=1+i-ista+jklof1
          PSOPam(ipso)=Scr1(iscr)
 250     continue
 260    continue
 270   continue
 280  continue
c Add contributions from 1-el density matrix:
 300  continue
      do 340 l=lsta,lend
       is=INT(ipam(iopam4+l))
       loff=nnpam3*(l-1)
       do 330 k=ksta,kend
        ir=INT(ipam(iopam3+k))
        irs=i3adr(ir,is)
        kloff=nnpam2*(k-1+loff)
        do 320 j=jsta,jend
         iq=INT(ipam(iopam2+j))
         jkloff=nnpam1*(j-1+kloff)
         do 310 i=ista,iend
          ip=INT(ipam(iopam1+i))
          ipq=i3adr(ip,iq)
          ipso=i+jkloff
          if(isym.eq.lsym) then
           ips=i3adr(ip,is)
           irq=i3adr(ir,iq)
           PSOPam(ipso)=PSOPam(ipso)-t14*DSO(ioDs+ips)*DSO(ioDr+irq)
          end if
          if(isym.eq.ksym) then
           ipr=i3adr(ip,ir)
           isq=i3adr(is,iq)
           PSOPam(ipso)=PSOPam(ipso)-t14*DSO(ioDr+ipr)*DSO(ioDs+isq)
          end if
          if(isym.eq.jsym) then
           PSOPam(ipso)=PSOPam(ipso)+DSO(ioDq+ipq)*DSO(ioDs+irs)*coulfac
          end if
 310     continue
 320    continue
 330   continue
 340  continue
c End of loop over symmetry labels.
 1005     continue
          nbi=mbas(isym)
          iocmoi=iocmoi+nbi**2
 1010    continue
         nbj=mbas(jsym)
         iocmoj=iocmoj+nbj**2
         ioDq=ioDq+(nbj*(nbj+1))/2
 1020   continue
        nbk=mbas(ksym)
        iocmok=iocmok+nbk**2
        ioDr=ioDr+(nbk*(nbk+1))/2
 1030  continue
       nbl=mbas(lsym)
       iocmol=iocmol+nbl**2
       ioDs=ioDs+(nbl*(nbl+1))/2
 1040 continue
      If (iPrint.ge.89) Call RecPrt('PSOPam',' ',PSOPam,
     &                     nnPam1*nnPam2,nnPam3*nnPam4)
*
*     Call GetMem('Exit PTrans','Check','Real',iDum,iDum)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine orthcon_cvb(ipairs,ipair,igroups,ngroup,iorthlst,
     >  mxortl,mxpair)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      parameter (nstrin=7,ncmp=4,mxgroup=40)
      character*8 string(nstrin)
      character*3 glabel(mxgroup)
      dimension ipairs(2,mxpair),ipair(mxorb,mxorb)
      dimension igroups(mxorb,mxgroup),ngroup(mxgroup)
      dimension iorthlst(mxortl)
      save string
      data string/'GROUP   ','ORTH    ','PAIRS   ','STRONG  ',
     >            'FULL    ','END     ','ENDORTHC'/

      call izero(ipair,mxorb*mxorb)
      ngrp=0
2000  call fstring_cvb(string,nstrin,istr,ncmp,2)
      if(istr.eq.1)then
c 'GROUP'
      ngrp=ngrp+1
      if(ngrp.gt.mxgroup)then
        write(6,*)' Too many GROUP keywords in input!',mxgroup
        call abend_cvb()
      endif
      glabel(ngrp)=' '
      call string_cvb(glabel(ngrp),1,nread,1)
      if(glabel(ngrp)(1:1).lt.'A'.or.glabel(ngrp)(1:1).gt.'Z')then
        write(6,*)' Group label must begin with a character A-Z: ',
     >    glabel(ngrp)
        call abend_cvb()
      endif
      call int_cvb(igroups(1,ngrp),mxorb,ngroup(ngrp),0)
      if(ngroup(ngrp).eq.-1)then
        write(6,*)' Too many elements for group ',glabel(ngrp)
        call abend_cvb()
      endif
      do 100 i=1,ngroup(ngrp)
      if(igroups(i,ngrp).lt.1.or.igroups(i,ngrp).gt.mxorb)then
        write(6,*)' Illegal orbital number in group ',glabel(ngrp),
     >    ' :',igroups(i,ngrp)
        call abend_cvb()
      endif
100   continue
      do 150 i=1,ngrp-1
      if(glabel(ngrp).eq.glabel(i))then
        write(6,*)' Repeated label in GROUP keywords : ',glabel(ngrp)
        call abend_cvb()
      endif
150   continue
      elseif(istr.eq.2)then
c 'ORTH'
      nsp=0
175   continue
      call int_cvb(iorthlst(1+nsp),mxortl-nsp,nread,0)
      nsp=nsp+nread
      if(mxortl-nsp.gt.0)then
        call fstring_cvb(glabel,ngrp,igrp,3,0)
        if(igrp.gt.0)then
          nsp=nsp+1
          iorthlst(nsp)=-igrp
          if(mxortl-nsp.gt.0)goto 175
        endif
      endif
      do 500 isp=1,nsp
      do 501 jsp=isp+1,nsp
      ior=iorthlst(isp)
      jor=iorthlst(jsp)
      if(ior.gt.0.and.jor.gt.0)then
        ipair(ior,jor)=1
      elseif(ior.gt.0.and.jor.lt.0)then
        jor2=-jor
        do 600 jo=1,ngroup(jor2)
        ipair(ior,igroups(jo,jor2))=1
600     continue
      elseif(ior.lt.0.and.jor.gt.0)then
        ior2=-ior
        do 700 io=1,ngroup(ior2)
        ipair(jor,igroups(io,ior2))=1
700     continue
      elseif(ior.lt.0.and.jor.lt.0)then
        ior2=-ior
        jor2=-jor
        do 800 io=1,ngroup(ior2)
        do 801 jo=1,ngroup(jor2)
        ipair(igroups(io,ior2),igroups(jo,jor2))=1
801     continue
800     continue
      endif
501   continue
500   continue
      elseif(istr.eq.3)then
c 'PAIRS'
      nsp=0
975   continue
      call int_cvb(ipairs(1+nsp,1),2*mxpair-nsp,nread,0)
      nsp=nsp+nread
      if(2*mxpair-nsp.gt.0)then
        call fstring_cvb(glabel,ngrp,igrp,3,0)
        if(igrp.gt.0)then
          nsp=nsp+1
          ipairs(nsp,1)=-igrp
          if(mxortl-nsp.gt.0)goto 975
        endif
      endif
      if(mod(nsp,2).eq.1)then
        write(6,*)' Odd number of orthogonalization numbers in PAIRS!'
        call abend_cvb()
      endif
      npairs=nsp/2
      do 1300 ipar=1,npairs
      ior=ipairs(1,ipar)
      jor=ipairs(2,ipar)
      if(ior.gt.0.and.jor.gt.0)then
        ipair(ior,jor)=1
      elseif(ior.gt.0.and.jor.lt.0)then
        jor2=-jor
        do 1400 jo=1,ngroup(jor2)
        ipair(ior,igroups(jo,jor2))=1
1400    continue
      elseif(ior.lt.0.and.jor.gt.0)then
        ior2=-ior
        do 1500 io=1,ngroup(ior2)
        ipair(jor,igroups(io,ior2))=1
1500    continue
      elseif(ior.lt.0.and.jor.lt.0)then
        ior2=-ior
        jor2=-jor
        do 1600 io=1,ngroup(ior2)
        do 1601 jo=1,ngroup(jor2)
        ipair(igroups(io,ior2),igroups(jo,jor2))=1
1601    continue
1600    continue
      endif
1300  continue
      elseif(istr.eq.4)then
c 'STRONG'
      do 1700 i=1,mxorb
      do 1701 j=i+1,mxorb
      if(.not.(mod(i,2).eq.1.and.j.eq.i+1))ipair(i,j)=1
1701  continue
1700  continue
      elseif(istr.eq.5)then
c 'FULL'
      do 1800 i=1,mxorb
      do 1801 j=i+1,mxorb
      ipair(i,j)=1
1801  continue
1800  continue
      endif
c 'END' , 'ENDORTHC' or unrecognized keyword -- end of ORTHCON input :
      if(.not.(istr.eq.6.or.istr.eq.7.or.istr.eq.0))goto 2000
      call izero(ipairs,2*mxpair)
      nort=0
      do 1900 i=1,mxorb
      do 1901 j=i+1,mxorb
      if(ipair(i,j).eq.1.or.ipair(j,i).eq.1)then
        nort=nort+1
        ipairs(1,nort)=i
        ipairs(2,nort)=j
      endif
1901  continue
1900  continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine stz(wrk,wrksize,a)
! this routine vanishes A
! A = 0
!
! a - A m(I/O)
!
! N.B. this routine should be done using matrix operations

use CCT3_global, only: Map_Type
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
type(Map_Type), intent(in) :: a
integer(kind=iwp) :: nhelp1, nhelp2, nhelp3

!1 def the length of the mediate
nhelp1 = a%d(0,5)
nhelp3 = a%d(nhelp1,1)+a%d(nhelp1,2)-a%d(1,1)

!2 def initial position
nhelp2 = a%d(1,1)

!3 refactoring
wrk(nhelp2:nhelp2+nhelp3-1) = Zero

return

end subroutine stz

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Calculation of transition matrix elements over vibrational
! wave functions of a given series of observables by a Simpson
! quadrature. The vibrational wave functions have been computed
! in vibrot and stored on units Vibwvs1 = 12 (potential 1) and
! Vibwvs2 = 13 (potential 2) for each rotational quantum number.
! The observables are read as input for a sequence of r-values
! and fitted to an analytical form in subroutine Pot.
! Integration is performed on a logarithmic scale (u=ln(r))
! between Umin and Umax with a grid size del corresponding to
! ndim integration steps. ndim has to be odd.
! Lifetimes are computed for the upper state (potential 2)
! no degeneracy factor is included in these values.
! Oscillator strengths are computed for all vibrational levels.
!
! ********** MOLCAS Release 91 05 01 **********
subroutine Vibtrm(ndim,Umin,Umax,Teas,R,PotR,Title)

use Vibrot_globals, only: iad12, iad13, iallrot, J1A, J1B, J2A, J2B, nvib1, nvib21, Vibwvs1, Vibwvs2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Four, c_in_au, auTofs, auTocm
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndim
real(kind=wp), intent(in) :: Umin, Umax, Teas, R(ndim), PotR(ndim)
character(len=80), intent(in) :: Title
integer(kind=iwp) :: i, iadr1, iadr2, ipot, iPrint, ist1, ist2, iwr, J1, J2, Jad1, Jad2, JEndA, JEndB, ndim1, ne, ne1, ne2, nemax, &
                     ne2max, nv, nv1, nv11, nv12, nv12s, nv2, nv22
real(kind=wp) :: ChkSum, del, Obsr, Smax, Afact
integer(kind=iwp), allocatable :: nv1w(:), nv2w(:)
real(kind=wp), allocatable :: Vib(:,:), X(:), E(:,:), Tau(:), Taui(:,:), Osc(:,:), Obs(:), S(:), Sw(:)
character(len=80) :: TmpLine

ChkSum = Zero

!PAM97 write(u6,1001) Title,Teas
write(u6,*)
call CollapseOutput(1,'Matrix elements of observable: '//Title)
write(u6,'(a,es15.8)') ' Asymptotic energy difference (au):',Teas
iPrint = 2

! check dimensions
ne1 = nvib1+1
ne2 = nvib21+1
ndim1 = ndim+1
nemax = max(ne1,ne2)
ne2max = max(ne1*ne2,ne1*(ne1+1)/2,ne2*(ne2+1)/2)

! Allocate memory
call mma_allocate(Vib,ndim1,ne1+ne2,label='Vib')
call mma_allocate(X,ndim,label='X')
call mma_allocate(E,2,nemax,label='E')
call mma_allocate(Tau,ne2,label='Tau')
call mma_allocate(Taui,ne1,ne2,label='Taui')
call mma_allocate(Osc,ne1,ne2,label='Osc')
call mma_allocate(OBs,ne1*ne2,label='Obs')
call mma_allocate(S,ne1*(ne1+1)+ne2*(ne2+1),label='S')
call mma_allocate(Sw,ne2max,label='Sw')
call mma_allocate(nv1w,ne2max,label='nv1w')
call mma_allocate(nv2w,ne2max,label='nv2w')

! Set up grid size
del = (Umax-Umin)/(ndim-1)

! Loop over rotational quantum numbers
JEndA = J1A
JEndB = J1B
if (iallrot == 1) then
  JEndA = J2A
  JEndB = J2B
end if
do J1=J1A,JEndA
  Jad1 = J1-J1A+1
  do J2=J1B,JEndB
    Jad2 = J2-J1B+1
    write(u6,*)
    write(TmpLine,1002) J1,J2
    call CollapseOutput(1,TmpLine)
    write(u6,1003)

    ! Read vibrational functions for this pair of J-values.
    do ipot=1,2
      if (ipot == 1) then
        ne = ne1
        iadr1 = iad12(Jad1)
        do nv=1,ne1
          call DDafile(Vibwvs1,2,Vib(:,nv),ndim1,iadr1)
          E(1,nv) = Vib(ndim,nv)
        end do
      else
        ne = ne2
        iadr2 = iad13(Jad2)
        do nv=1,ne2
          call DDafile(Vibwvs2,2,Vib(:,ne1+nv),ndim1,iadr2)
          E(2,nv) = Vib(ndim,ne1+nv)+Teas
        end do
      end if

      ! compute overlap matrix S
      nv12 = (ipot-1)*(ne1**2+ne1)/2
      do nv1=1,ne
        ist1 = nv1+(ipot-1)*ne1
        do nv2=1,nv1
          ist2 = nv2+(ipot-1)*ne1
          nv12 = nv12+1
          ! Set up scalar product and integrate
          do i=1,ndim
            X(i) = Vib(i,ist1)*Vib(i,ist2)*R(i)**2
          end do
          call Simpsn(X,del,ndim,S(nv12))
        end do
      end do

      ! check overlap matrix for non-orthogonality
      nv12 = (ipot-1)*(ne1**2+ne1)/2
      Smax = Zero
      do nv1=1,ne
        do nv2=1,nv1
          nv12 = nv12+1
          if (nv1 == nv2) cycle
          if (abs(S(nv12)) > abs(Smax)) Smax = S(nv12)
        end do
      end do
      if (abs(Smax) > 1.0e-4_wp) write(u6,1200) ipot,Smax

      ! Print overlap matrix
      if (iPrint >= 1) then
        write(u6,*)
        write(u6,'(1x,A,I3)') 'Overlap matrix for vibrational wave functions for potential number',ipot
        iwr = 0
        nv12 = (ipot-1)*(ne1**2+ne1)/2
        do nv1=1,ne
          do nv2=1,nv1
            iwr = iwr+1
            nv12 = nv12+1
            nv1w(iwr) = nv1-1
            nv2w(iwr) = nv2-1
            Sw(iwr) = S(nv12)
          end do
        end do
        write(u6,'(6(3X,2I3,F12.6))') (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
      end if
    end do

    ! Compute overlap matrix between pot1 and pot2 functions
    nv11 = 0
    nv12s = (ne1**2+ne1+ne2**2+ne2)/2
    nv12 = nv12s
    do nv1=1,ne1
      nv11 = nv11+nv1
      nv22 = (ne1**2+ne1)/2
      do nv2=1,ne2
        nv12 = nv12+1
        nv22 = nv22+nv2
        ! Set up scalar product and integrate
        do i=1,ndim
          X(i) = Vib(i,nv1)*Vib(i,nv2+ne1)*R(i)**2
        end do
        call Simpsn(X,del,ndim,S(nv12))
        S(nv12) = S(nv12)/sqrt(S(nv11)*S(nv22))
        ChkSum = ChkSum+S(nv12)
      end do
    end do

    ! print overlap matrix
    write(u6,1310)
    nv12 = nv12s-ne2
    do nv1=1,ne1
      nv12 = nv12+ne2
      write(u6,'(6(3X,2I3,F12.6))') (nv1-1,i-1,S(i+nv12),i=1,ne2)
    end do
    ! compute transition moment
    ! Afact = 4*pi*e^2*E_h^2 / 3*eps_0*m_e*c^3*h^2
    ! numerically: 4/(3*c^3) (in a.u. of time ^ -1) (converted to 1/ns)
    Afact = Four/(Three*c_in_au**3)/auToFs*1.0e6_wp
    nv11 = 0
    nv12 = 0
    do nv1=1,ne1
      nv11 = nv11+nv1
      nv22 = (ne1**2+ne1)/2
      do nv2=1,ne2
        nv12 = nv12+1
        nv22 = nv22+nv2
        ! Set up scalar product and integrate
        do i=1,ndim
          X(i) = Vib(i,nv1)*Vib(i,nv2+ne1)*PotR(i)*R(i)**2
        end do
        call Simpsn(X,del,ndim,Obsr)
        Obs(nv12) = Obsr/sqrt(S(nv11)*S(nv22))

        ! Taui is the contribution to the inverse lifetime from
        ! vibrational states nv1 (lower) and nv2 (upper)
        Taui(nv1,nv2) = Afact*(E(2,nv2)-E(1,nv1))**3*Obs(nv12)**2
        ! computed oscillator strengths
        Osc(nv1,nv2) = Two*(E(2,nv2)-E(1,nv1))*Obs(nv12)**2/Three

        !ChkSum = ChkSum + Taui(nv1,nv2)
      end do
    end do

    ! write matrix elements
    write(u6,*)
    write(u6,'(1x,A)') 'Transition moments over vibrational wave functions (atomic units)'
    iwr = 0
    do nv1=1,ne1
      do nv2=1,ne2
        iwr = iwr+1
        nv1w(iwr) = nv1-1
        nv2w(iwr) = nv2-1
        Sw(iwr) = Obs(iwr)
      end do
    end do
    write(u6,'(6(2X,I3,1X,I3,1X,F11.6))') (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
    write(u6,*)
    write(u6,'(1x,A)') 'Energy differences for vibrational wave functions (atomic units)'
    iwr = 0
    do nv1=1,ne1
      do nv2=1,ne2
        iwr = iwr+1
        nv1w(iwr) = nv1-1
        nv2w(iwr) = nv2-1
        Sw(iwr) = E(2,nv2)-E(1,nv1)
      end do
    end do
    write(u6,'(6(2X,I3,1X,I3,1X,F11.6))') (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
    write(u6,'(1x,A)') 'Energy differences for vibrational wave functions (cm-1)'
    iwr = 0
    do nv1=1,ne1
      do nv2=1,ne2
        iwr = iwr+1
        nv1w(iwr) = nv1-1
        nv2w(iwr) = nv2-1
        Sw(iwr) = (E(2,nv2)-E(1,nv1))*auTocm
      end do
    end do
    write(u6,'(6(2X,I3,1X,I3,1X,F11.1))') (nv1w(i),nv2w(i),Sw(i),i=1,iwr)

    ! Print oscillator strengths
    write(u6,'(1x,A)') 'Oscillator strengths for vibrational wave functions'
    iwr = 0
    do nv1=1,ne1
      do nv2=1,ne2
        iwr = iwr+1
        nv1w(iwr) = nv1-1
        nv2w(iwr) = nv2-1
        Sw(iwr) = Osc(nv1,nv2)
      end do
    end do
    write(u6,'(6(2X,I3,1X,I3,1X,E12.5))') (nv1w(i),nv2w(i),Sw(i),i=1,iwr)

    ! Print lifetime
    write(u6,*)
    write(u6,'(1x,A,/,A)') 'Contributions to inverse lifetimes (ns-1)','No degeneracy factor is included in these values.'
    iwr = 0
    do nv1=1,ne1
      do nv2=1,ne2
        iwr = iwr+1
        nv1w(iwr) = nv1-1
        nv2w(iwr) = nv2-1
        Sw(iwr) = Taui(nv1,nv2)
      end do
    end do
    write(u6,'(6(2X,I3,1X,I3,1X,E12.5))') (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
    ! Compute lifetimes for upper state
    write(u6,1600)
    do nv2=1,ne2
      Tau(nv2) = Zero
      do nv1=1,ne1
        Tau(nv2) = Tau(nv2)+Taui(nv1,nv2)
      end do
      Tau(nv2) = One/Tau(nv2)
      !ChkSum = ChkSum + Tau(nv2)
      write(u6,1700) nv2-1,Tau(nv2)
    end do
    call CollapseOutput(0,TmpLine)

  ! End of loop over rotational quantum number
  end do
end do
call CollapseOutput(0,'Matrix elements of observable: '//Title)

! Deallocate memory
call mma_deallocate(Vib)
call mma_deallocate(X)
call mma_deallocate(E)
call mma_deallocate(Tau)
call mma_deallocate(Taui)
call mma_deallocate(Osc)
call mma_deallocate(Obs)
call mma_deallocate(S)
call mma_deallocate(Sw)
call mma_deallocate(nv1w)
call mma_deallocate(nv2w)

!PAM97 New code begins:
!do J1=J1A,J2A
!  do J2=J1B,J2B
!    ! Read vibrational function for pot-1, with rot q.n.=J1:
!    iadr1 = iad12(J1-J1A+1)
!    do nv=0,nvib1
!      call Dafile(Vibwvs1,2,Vibbuf,RtoI*ndim,iadr1)
!      call dcopy_(ndim,Vibbuf,1,Vib1(1,nv),1)
!      ERoVib1(nv,J1) = Vibbuf(ndim+1)
!    end do
!    ! Normalize vibrational function:
!    do nv=0,nvib1
!      do i=1,ndim
!        Vibbuf(i) = Vib1(i,nv)**2*R(i)**2
!      end do
!      call Simpsn(Vibbuf,del,ndim,ovlp)
!      xnrm = One/sqrt(ovlp)
!      do i=1,ndim
!        Vib1(i,nv) = xnrm*Vib1(i,nv)
!      end do
!    end do
!    ! Check orthonormality:
!    ovlmax = Zero
!    do nv1=1,nvib1
!      do nv2=0,nv1-1
!        do i=1,ndim
!          Vibbuf(i) = Vib1(i,nv1)*Vib1(i,nv2)*R(i)**2
!        end do
!        call Simpsn(Vibbuf,del,ndim,ovlp)
!        ovlmax = max(ovlp,ovlmax)
!      end do
!    end do
!    if (ovlmax >= 1.0e-4_wp) then
!      write(u6,*) ' Warning from VIBTRM: Vibrational wave functions for potential 1'
!      write(u6,*) ' are not orthonormal. Max overlap:',ovlmax
!    end if
!    ! Read vibrational function for pot-2, with rot q.n.=J2:
!    iadr2 = iad13(J2-J1B+1)
!    do nv=0,nvib21
!      call Dafile(Vibwvs2,2,Vibbuf,RtoI*ndim,iadr2)
!      call dcopy_(ndim,Vibbuf,1,Vib2(1,nv),1)
!      ERoVib2(nv,J2) = Vibbuf(ndim+1)
!    end do
!    ! Normalize vibrational function:
!    do nv=0,nvib21
!      do i=1,ndim
!        Vibbuf(i) = Vib2(i,nv)**2*R(i)**2
!      end do
!      call Simpsn(Vibbuf,del,ndim,ovlp)
!      xnrm = One/sqrt(ovlp)
!      do i=1,ndim
!        Vib2(i,nv) = xnrm*Vib2(i,nv)
!      end do
!    end do
!    ! Check orthonormality:
!    ovlmax = Zero
!    do nv1=1,nvib21
!      do nv2=0,nv1-1
!        do i=1,ndim
!          Vibbuf(i) = Vib2(i,nv1)*Vib2(i,nv2)*R(i)**2
!        end do
!        call Simpsn(Vibbuf,del,ndim,ovlp)
!        ovlmax = max(ovlp,ovlmax)
!      end do
!    end do
!    if (ovlmax >= 1.0e-4_wp) then
!      write(u6,*) ' Warning from VIBTRM: Vibrational wave functions for potential 2'
!      write(u6,*) ' are not orthonormal. Max overlap:',ovlmax
!    end if
!    ! Compute Franck-Condon overlaps and transition moment integrals:
!    do nv1=0,nvib1
!      do nv2=0,nvib21
!        if (J1 == J2) then
!          do i=1,ndim
!            Vibbuf(i) = Vib1(i,nv1)*Vib2(i,nv2)*R(i)**2
!          end do
!          call Simpsn(Vibbuf,del,ndim,FC(nv1,nv2,J1))
!        end if
!        if (abs(nv1-nv2) <= NSel) then
!          do i=1,ndim
!            X(i) = PotR(i)*Vibbuf(i)
!          end do
!          call Simpsn(X,del,ndim,Obs(nv1,nv2,J1,J2))
!        else
!          TD(nv1,nv2,J1,J2) = Zero
!        end if
!        EDiff = ERoVib2(nv2,J2)-ERoVib1(nv1,J1)+TeDiff
!        TauPrt(nv1,nv2,J1,J2) = Afact*EDiff**3*TD(nv1,nv2,J1,J2)**2
!      end do
!    end do
!  end do
!end do
!PAM97 New code ends

call Add_Info('VIBROT_VIBTRM',[ChkSum],1,6)

return

!PAM97
!1001 format(1h1,1x,'Matrix elements of observables'/1x,e80//1x,'Asymtotic energy difference (au):',e14.6)
1002 format('Rotational quantum number for potential 1: ',i3,', for potential 2: ',i3)
1003 format(1x,80('-'))
1200 format(/1x,'*****Warning: non-orthogonality between vibrational',1x,'wave functions for potential',i2 &
            /13x,'largest overlap matrix element is',f14.6)
1310 format(/1x,'Overlap matrix for pot-1 and pot-2 functions')
1600 format(/1x,'Lifetimes (in nano seconds)'/3x,'v',7x,'tau')
1700 format(1x,i3,f10.2)

end subroutine Vibtrm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRTSTR(ISTR,NEL,NSTR)
*
* Print NSTR strings each containing NEL electrons
*
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION ISTR(NEL,NSTR)
*
      DO JSTR = 1, NSTR
        WRITE(6,'(1H0,A,I6,A,4X,10(2X,I4),/,(1H ,19X,10(2X,I4)))' )
     &   ' String ',JSTR,' : ',(ISTR(IEL,JSTR),IEL=1,NEL)
      END DO
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GTJK_MCLR(RJ,RK)
      use Arrays, only: Int2
C
C     PURPOSE: GET ALL INTEGRALS COULOMB AND EXCHANGE INTEGRALS
C              WITH THE CHARGE DISTRIBUTION JK
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "detdim.fh"
#include "Pointers.fh"
#include "orbinp_mclr.fh"
      DIMENSION RJ(NACOB,NACOB),RK(NACOB,nACOB)

      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
C
C     FORM THE COULOMB (RJ) AND EXCHANGE (RK) INTEGRAL MATRICES FROM
C     THE TWO-ELECTRON INTEGRAL LIST
C
      DO NT=1,NACOB
         DO  NU=1,NT
            NTUK=itri(itri(nt,nt),itri(nu,nu))
            RJ(NT,NU)=INT2(NTUK)
            RJ(NU,NT)=INT2(NTUK)

            NTUJ=itri(itri(nt,nu),itri(nu,nt))
            RK(NT,NU)=INT2(NTUJ)
            RK(NU,NT)=INT2(NTUJ)
         End Do
      End Do
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine mkangLmin(Lmax,l1,l2,l3,l4,m1,m2,m3,m4,
     *angintSO,angintOO,
     *Lfirst,Llast,Lblocks,
     *ncont1,ncont2,ncont3,
     *ncont4,
     *caseaSO,caseb1SO,caseb2SO,casecSO,
     *caseaOO,caseb1OO,caseb2OO,casecOO,
     *preroots,clebsch,dummy,bonn,breit,
     *sameorb)
      implicit real*8 (a-h,o-z)
cbs   subroutine for combining radial intgrls with angular
cbs   factors for the block with l1,l2,l3,l4,m1,m2,m3m,m4
cbs   this routine mkangLmin = make angular factors for the L- -part
cbs   includes both, spin-same and spin-other-orbit parts.
      real*8 LMdepang
      dimension
     *angintSO(ncont1,ncont2,ncont3,ncont4),
     *angintOO(ncont1,ncont2,ncont3,ncont4),
     *Lfirst(*),Llast(*),Lblocks(*),
cbs   all the arrays with the radial intgrls for
cbs   this combination of l-values
     *caseaSO(ncont1*ncont2*ncont3*ncont4,*),
c    ! (2,0)   intgrls with alpha1*alpha3
     *caseb1SO(ncont1*ncont2*ncont3*ncont4,*),
c    ! (0,0)   intgrls with alpha1
     *caseb2SO(ncont1*ncont2*ncont3*ncont4,*),
c    ! (0,0)   intgrls with alpha3
     *casecSO(ncont1*ncont2*ncont3*ncont4,*),
c    ! (-2,0)  intgrls with factor 1
     *caseaOO(ncont1*ncont2*ncont3*ncont4,*),
c    ! (2,0)   intgrls with alpha1*alpha3
     *caseb1OO(ncont1*ncont2*ncont3*ncont4,*),
c    ! (0,0)   intgrls with alpha1
     *caseb2OO(ncont1*ncont2*ncont3*ncont4,*),
c    ! (0,0)   intgrls with alpha3
     *casecOO(ncont1*ncont2*ncont3*ncont4,*),
c    ! (-2,0)  intgrls with factor 1
     *preroots(2,0:Lmax),
c    ! some prefactors: sqrt( (l(+1))/(2l+1))
     *clebsch(3,2,-Lmax:Lmax,0:Lmax)
c    ! some clebsch gordans, that appear regulary
      dimension dummy(0:*)
      logical bonn,breiT,sameorb
      root2=sqrt(2.0d0)
      root2inv=1d0/root2
c     write(6,*) 'begin mkangL- ',
c    *l1,l2,l3,l4,m1,m2,m3,m4
cbs
      ncontall=ncont1*ncont2*ncont3*ncont4
cbs   cheater introduced to correct signs, because they were different from HERMIT
      if (mod(l1+l2+l3+l4,4).eq.2) then
      cheater=1d0
      else
      cheater=-1d0
      endiF
cbs   cleaning up
      if (bonn.or.breit.or.sameorb) then
      call dzero(angintSO,ncontall)
      else
      call dzero(angintSO,ncontall)
      call dzero(angintOO,ncontall)
      endif
cbs  starting with the same-orbit-contributions
cbs  first term: ###########################################################################
      factor=-root2inv*preroots(2,l1)*preroots(2,l3)*
     *clebsch(3,2,m1,l1)*
     *clebsch(2,2,m3,l3)
      if (factor.ne.0d0) then
      do I=0,Lmax+Lmax+1
      dummy(I)=0d0
      enddo
cbs   get the L,M dependent coefficients
      if (Lblocks(1).gt.0) then
      M=m2-m4
      Lrun=1
      do L=Lfirst(1),Llast(1),2
      dummy(L)=LMdepang(L,M,l1+1,l2,l3+1,l4,m1+1,m2,m3,m4,cheater)
      if (dummy(L).ne.0d0) then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,
     *   4.0D0*factor*dummy(L),caseaOO(1,Lrun),1,angintOO,1)
      endif
      Endif
      Lrun=Lrun+1
      enddo
      endif
      endif
cbs   second term: ###########################################################################
      factor=-root2inv*preroots(1,l1)*preroots(2,l3)*
     *clebsch(3,1,m1,l1)*
     *clebsch(2,2,m3,l3)
      if (factor.ne.0d0) then
      do I=0,Lmax+Lmax+1
      dummy(I)=0d0
      enddo
      Klast=0
      Kfirst=Lmax+Lmax+1 ! just to be sure ..
cbs   get the L,M dependent coefficients
      if (Lblocks(1).gt.0) then
      M=m2-m4
      Kfirst=Lfirst(1)
      Klast=Llast(1)
      Lrun=1
      do L=Lfirst(1),Llast(1),2
      dummy(L)=LMdepang(L,M,l1-1,l2,l3+1,l4,m1+1,m2,m3,m4,cheater)
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,
     *   4.0D0*factor*dummy(L),caseaOO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(3).gt.0) then
      M=m2-m4
              if (Lfirst(3).lt.Kfirst) then
              do L=Lfirst(3),Kfirst,2
        dummy(L)=LMdepang(L,M,l1-1,l2,l3+1,l4,m1+1,m2,m3,m4,cheater)
              enddo
              Kfirst=Lfirst(3)
              endif
              if (Llast(3).gt.Klast) then
              do L=Klast,Llast(3),2
        dummy(L)=LMdepang(L,M,l1-1,l2,l3+1,l4,m1+1,m2,m3,m4,cheater)
              enddo
              Klast=Llast(3)
              endif
      Lrun=1
      do L=Lfirst(3),Llast(3),2
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,-DBLE(2+4*l1)*factor*dummy(L),
     *   caseb2SO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,-DBLE(2+4*l1)*factor*dummy(L),
     *   caseb2SO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,-DBLE(2+4*l1)*
     *   factor*dummy(L),caseb2OO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      endif
cbs   third term: ###########################################################################
      factor=-root2inv*preroots(2,l1)*preroots(1,l3)*
     *clebsch(3,2,m1,l1)*
     *clebsch(2,1,m3,l3)
      if (factor.ne.0d0) then
      do I=0,Lmax+Lmax+1
      dummy(I)=0d0
      enddo
      Klast=0
      Kfirst=Lmax+Lmax+1 ! just to be sure ..
cbs   get the L,M dependent coefficients
      if (Lblocks(1).gt.0) then
      M=m2-m4
      Kfirst=Lfirst(1)
      Klast=Llast(1)
      Lrun=1
      do L=Lfirst(1),Llast(1),2
      dummy(L)=LMdepang(L,M,l1+1,l2,l3-1,l4,m1+1,m2,m3,m4,cheater)
      if (dummy(L).ne.0d0) then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,
     *   4.0D0*factor*dummy(L),caseaOO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(2).gt.0) then
      M=m2-m4
              if (Lfirst(2).lt.Kfirst) then
              do L=Lfirst(2),Kfirst,2
              dummy(L)=LMdepang(L,M,l1+1,l2,l3-1,l4,m1+1,m2,
     *                 m3,m4,Cheater)
              enddo
              Kfirst=Lfirst(2)
              endif
              if (Llast(2).gt.Klast) then
              do L=Klast,Llast(2),2
        dummy(L)=LMdepang(L,M,l1+1,l2,l3-1,l4,m1+1,m2,m3,m4,cheater)
              enddo
              Klast=Llast(2)
              endif
      Lrun=1
      do L=Lfirst(2),Llast(2),2
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,-DBLE(2+4*l3)*factor*dummy(L),
     *   caseb1SO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,-DBLE(2+4*l3)*factor*dummy(L),
     *   caseb1SO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,-DBLE(2+4*l3)*
     *   factor*dummy(L),caseb1OO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      endif
cbs   fourth term: ###########################################################################
      factor=-root2inv*preroots(1,l1)*preroots(1,l3)*
     *clebsch(3,1,m1,l1)*
     *clebsch(2,1,m3,l3)
      if (factor.ne.0d0) then
      do I=0,Lmax+Lmax+1
      dummy(I)=0d0
      enddo
      Klast=0
      Kfirst=Lmax+Lmax+1 ! just to be sure ..
cbs   get the L,M dependent coefficients
      if (Lblocks(1).gt.0) then
      M=m2-m4
      Kfirst=Lfirst(1)
      Klast=Llast(1)
      Lrun=1
      do L=Lfirst(1),Llast(1),2
      dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3,m4,cheater)
      if (dummy(L).ne.0d0) then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,
     *   4.0D0*factor*dummy(L),caseaOO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(2).gt.0) then
      M=m2-m4
              if (Lfirst(2).lt.Kfirst) then
              do L=Lfirst(2),Kfirst,2
        dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3,m4,cheater)
              enddo
              Kfirst=Lfirst(2)
              endif
              if (Llast(2).gt.Klast) then
              do L=Klast,Llast(2),2
        dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3,m4,cheater)
              enddo
              Klast=Llast(2)
              endif
      Lrun=1
      do L=Lfirst(2),Llast(2),2
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,-DBLE(2+4*l3)*factor*dummy(L),
     *   caseb1SO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,-DBLE(2+4*l3)*factor*dummy(L),
     *   caseb1SO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,-DBLE(2+4*l3)*
     *   factor*dummy(L),caseb1OO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(3).gt.0) then
      M=m2-m4
              if (Lfirst(3).lt.Kfirst) then
              do L=Lfirst(3),Kfirst,2
        dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3,m4,cheater)
              enddo
              Kfirst=Lfirst(3)
              endif
              if (Llast(3).gt.Klast) then
              do L=Klast,Llast(3),2
        dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3,m4,cheater)
              enddo
              Klast=Llast(3)
              endif
      Lrun=1
      do L=Lfirst(3),Llast(3),2
      if (dummy(L).ne.0d0) then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,-DBLE(2+4*l1)*factor*dummy(L),
     *   caseb2SO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,-DBLE(2+4*l1)*factor*dummy(L),
     *   caseb2SO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,-DBLE(2+4*l1)*
     *   factor*dummy(L),caseb2OO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(4).gt.0) then
      M=m2-m4
              if (Lfirst(4).lt.Kfirst) then
              do L=Lfirst(4),Kfirst,2
        dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3,m4,cheater)
              enddo
              Kfirst=Lfirst(4)
              endif
              if (Llast(4).gt.Klast) then
              do L=Klast,Llast(4),2
        dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1+1,m2,m3,m4,cheater)
              enddo
              Klast=Llast(4)
              endif
      Lrun=1
      do L=Lfirst(4),Llast(4),2
      if (dummy(L).ne.0d0) then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,DBLE(4*l1*l3+2*l1+2*l3+1)*factor*dummy(L),
     *   casecSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,DBLE(4*l1*l3+2*l1+2*l3+1)*factor*dummy(L),
     *   casecSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,
     *   DBLE(4*l1*l3+2*l1+2*l3+1)*factor*dummy(L),
     *   casecOO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      endif
cbs  fifth term: ###########################################################################
      factor=-root2inv*preroots(2,l1)*preroots(2,l3)*
     *clebsch(2,2,m1,l1)*
     *clebsch(1,2,m3,l3)
      if (factor.ne.0d0) then
      do I=0,Lmax+Lmax+1
      dummy(I)=0d0
      enddo
cbs   get the L,M dependent coefficients
      if (Lblocks(1).gt.0) then
      M=m2-m4
      Lrun=1
      do L=Lfirst(1),Llast(1),2
      dummy(L)=LMdepang(L,M,l1+1,l2,l3+1,l4,m1,m2,m3-1,m4,cheater)
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,
     *   4.0D0*factor*dummy(L),caseaOO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      endif
cbs   sixth  term: ###########################################################################
      factor=-root2inv*preroots(1,l1)*preroots(2,l3)*
     *clebsch(2,1,m1,l1)*
     *clebsch(1,2,m3,l3)
      if (factor.ne.0d0) then
      do I=0,Lmax+Lmax+1
      dummy(I)=0d0
      enddo
      Klast=0
      Kfirst=Lmax+Lmax+1 ! just to be sure ..
cbs   get the L,M dependent coefficients
      if (Lblocks(1).gt.0) then
      M=m2-m4
      Kfirst=Lfirst(1)
      Klast=Llast(1)
      Lrun=1
      do L=Lfirst(1),Llast(1),2
      dummy(L)=LMdepang(L,M,l1-1,l2,l3+1,l4,m1,m2,m3-1,m4,cheater)
      if (dummy(L).ne.0d0) then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,4.0D0*
     *   factor*dummy(L),caseaOO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(3).gt.0) then
      M=m2-m4
              if (Lfirst(3).lt.Kfirst) then
              do L=Lfirst(3),Kfirst,2
         dummy(L)=LMdepang(L,M,l1-1,l2,l3+1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Kfirst=Lfirst(3)
              endif
              if (Llast(3).gt.Klast) then
              do L=Klast,Llast(3),2
         dummy(L)=LMdepang(L,M,l1-1,l2,l3+1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Klast=Llast(3)
              endif
      Lrun=1
      do L=Lfirst(3),Llast(3),2
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,-DBLE(2+4*l1)*factor*dummy(L),
     *   caseb2SO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,-DBLE(2+4*l1)*factor*dummy(L),
     *   caseb2SO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,-DBLE(2+4*l1)*
     *   factor*dummy(L),caseb2OO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      endif
cbs   seventh term: ###########################################################################
      factor=-root2inv*preroots(2,l1)*preroots(1,l3)*
     *clebsch(2,2,m1,l1)*
     *clebsch(1,1,m3,l3)
      if (factor.ne.0d0) then
      do I=0,Lmax+Lmax+1
      dummy(I)=0d0
      enddo
      Klast=0
      Kfirst=Lmax+Lmax+1 ! just to be sure ..
cbs   get the L,M dependent coefficients
      if (Lblocks(1).gt.0) then
      M=m2-m4
      Kfirst=Lfirst(1)
      Klast=Llast(1)
      Lrun=1
      do L=Lfirst(1),Llast(1),2
      dummy(L)=LMdepang(L,M,l1+1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,
     *   4.0D0*factor*dummy(L),caseaOO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(2).gt.0) then
      M=m2-m4
              if (Lfirst(2).lt.Kfirst) then
              do L=Lfirst(2),Kfirst,2
         dummy(L)=LMdepang(L,M,l1+1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Kfirst=Lfirst(2)
              endif
              if (Llast(2).gt.Klast) then
              do L=Klast,Llast(2),2
         dummy(L)=LMdepang(L,M,l1+1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Klast=Llast(2)
              endif
      Lrun=1
      do L=Lfirst(2),Llast(2),2
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,-DBLE(2+4*l3)*factor*dummy(L),
     *   caseb1SO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,-DBLE(2+4*l3)*factor*dummy(L),
     *   caseb1SO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,-DBLE(2+4*l3)*
     *   factor*dummy(L),caseb1OO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      endif
cbs   eigth term: ###########################################################################
      factor=-root2inv*preroots(1,l1)*preroots(1,l3)*
     *clebsch(2,1,m1,l1)*
     *clebsch(1,1,m3,l3)
      if (factor.ne.0d0) then
      do I=0,Lmax+Lmax+1
      dummy(I)=0d0
      enddo
      Klast=0
      Kfirst=Lmax+Lmax+1 ! just to be sure ..
cbs   get the L,M dependent coefficients
      if (Lblocks(1).gt.0) then
      M=m2-m4
      Kfirst=Lfirst(1)
      Klast=Llast(1)
      Lrun=1
      do L=Lfirst(1),Llast(1),2
      dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,4.0D0*factor*dummy(L),
     *   caseaSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,4.0D0*
     *   factor*dummy(L),caseaOO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(2).gt.0) then
      M=m2-m4
              if (Lfirst(2).lt.Kfirst) then
              do L=Lfirst(2),Kfirst,2
         dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Kfirst=Lfirst(2)
              endif
              if (Llast(2).gt.Klast) then
              do L=Klast,Llast(2),2
         dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Klast=Llast(2)
              endif
      Lrun=1
      do L=Lfirst(2),Llast(2),2
      if (dummy(L).ne.0d0) then
      if (bonn.or.breit.or.sameorb) then
        call daxpy_(ncontall,-DBLE(2+4*l3)*factor*dummy(L),
     *  caseb1SO(1,Lrun),1,angintSO,1)
      else
        call daxpy_(ncontall,-DBLE(2+4*l3)*factor*dummy(L),
     *  caseb1SO(1,Lrun),1,angintSO,1)
        call daxpy_(ncontall,-DBLE(2+4*l3)*
     *factor*dummy(L),caseb1OO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(3).gt.0) then
      M=m2-m4
              if (Lfirst(3).lt.Kfirst) then
              do L=Lfirst(3),Kfirst,2
         dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Kfirst=Lfirst(3)
              endif
              if (Llast(3).gt.Klast) then
              do L=Klast,Llast(3),2
         dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Klast=Llast(3)
              endif
      Lrun=1
      do L=Lfirst(3),Llast(3),2
      if (dummy(L).ne.0d0)  then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,-DBLE(2+4*l1)*factor*dummy(L),
     *   caseb2SO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,-DBLE(2+4*l1)*factor*dummy(L),
     *   caseb2SO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,-DBLE(2+4*l1)*
     *   factor*dummy(L),caseb2OO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      if (Lblocks(4).gt.0) then
      M=m2-m4
              if (Lfirst(4).lt.Kfirst) then
              do L=Lfirst(4),Kfirst,2
         dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Kfirst=Lfirst(4)
              endif
              if (Llast(4).gt.Klast) then
              do L=Klast,Llast(4),2
         dummy(L)=LMdepang(L,M,l1-1,l2,l3-1,l4,m1,m2,m3-1,m4,cheater)
              enddo
              Klast=Llast(4)
              endif
      Lrun=1
      do L=Lfirst(4),Llast(4),2
      if (dummy(L).ne.0d0) then
      if (bonn.or.breit.or.sameorb) then
         call daxpy_(ncontall,DBLE(4*l1*l3+2*l1+2*l3+1)*
     *   factor*dummy(L),
     *   casecSO(1,Lrun),1,angintSO,1)
      else
         call daxpy_(ncontall,DBLE(4*l1*l3+2*l1+2*l3+1)*
     *   factor*dummy(L),
     *   casecSO(1,Lrun),1,angintSO,1)
         call daxpy_(ncontall,
     *   DBLE(4*l1*l3+2*l1+2*l3+1)*factor*dummy(L),
     *   casecOO(1,Lrun),1,angintOO,1)
      endif
      endif
      Lrun=Lrun+1
      enddo
      endif
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Index_Center(iCnt,iR,cIndex,iAtoms,nAtoms)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: Index_Center
integer(kind=iwp), intent(in) :: iCnt, iR, nAtoms
integer(kind=iwp), intent(inout) :: cIndex(2,nAtoms), iAtoms
integer(kind=iwp) :: i

outer: do
  Index_Center = 0
  do i=1,iAtoms
    if ((cIndex(1,i) == iCnt) .and. (cIndex(2,i) == iR)) then
      Index_Center = i
      exit outer
    end if
  end do

  iAtoms = iAtoms+1
  cIndex(1,iAtoms) = iCnt
  cIndex(2,iAtoms) = iR
end do outer

return

end function Index_Center

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3sglh131(w,dima,dimbc,s1,d1,ns)
! this routine adds following contribution to W
! for syma=symb > symc
!
! W(a,bc) <-  + S1 _i(a) . D1 _jk(bc)
!
! w     - W matrix (I/O)
! dima  - dimension of a (b) index (I)
! dimbc - dimension of bc index (I)
! s1    - S1 matrix (I)
! d1    - D1 matrix (I)
! ns    - signum of the contribution (+-1) (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimbc, ns
real(kind=wp), intent(inout) :: w(dima,dimbc)
real(kind=wp), intent(in) :: s1(dima), d1(dimbc)
integer(kind=iwp) :: bc

if (ns == 1) then
  ! phase +1

  do bc=1,dimbc
    w(:,bc) = w(:,bc)+s1(:)*d1(bc)
  end do

else
  ! phase -1

  do bc=1,dimbc
    w(:,bc) = w(:,bc)-s1(:)*d1(bc)
  end do

end if

return

end subroutine t3sglh131

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine occupy_cvb(nk,nel,locc,lunocc)
      dimension nk(0:nel),locc(*),lunocc(*)

      iocc=0
      iunocc=0
      do 2100 iel=1,nel
      if(nk(iel)-nk(iel-1) .eq. 1)then
        iocc=iocc+1
        locc(iocc)=iel
      elseif(nk(iel)-nk(iel-1) .eq. 0)then
        iunocc=iunocc+1
        lunocc(iunocc)=iel
      else
        write(6,*)' Error in graphical indexing routine!'
        call abend_cvb()
      endif
2100  continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETRED(DIAG,IIBSTRSH,NNBSTRSH,INDRED,
     &                      MSYM,LMMBSTRT,MMSHL)
C
C     Purpose: set next reduced set. A copy of the previous set
C              is stored in location 3.
C
#include "implicit.fh"
      DIMENSION DIAG(*)
      INTEGER   INDRED(LMMBSTRT,3)
      INTEGER   IIBSTRSH(MSYM,MMSHL,3), NNBSTRSH(MSYM,MMSHL,3)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_SETRED')

      ISP2F(I)=IWORK(ip_iSP2F-1+I)
      IATOMSHL(I)=IWORK(ip_IATOMSHL-1+I)

C     Debug print.
C     ------------

      IF (CHO_TRCNEG) THEN
         WRITE(LUPRI,*)
         WRITE(LUPRI,*) SECNAM,
     &                  ': tracing of negative diagonals activated.'
         WRITE(LUPRI,*) SECNAM,': flag SCDIAG     is ',SCDIAG
         WRITE(LUPRI,*) SECNAM,': flag CHO_USEABS is ',CHO_USEABS
         IF (SCDIAG) THEN
            WRITE(LUPRI,*) SECNAM,': MODE_SCREEN     is ',MODE_SCREEN
         END IF
         WRITE(LUPRI,*) SECNAM,': checking for negative diagonals in ',
     &                  'first reduced set:'
         NNEG = 0
         DO ISYM = 1,NSYM
            JAB1 = IIBSTR(ISYM,1) + 1
            JAB2 = JAB1 + NNBSTR(ISYM,1) - 1
            INEG = 0
            DO JAB = JAB1,JAB2
               IF (DIAG(JAB) .LT. 0.0D0) THEN
                  INEG = INEG + 1
               END IF
            END DO
            NNEG = NNEG + INEG
            WRITE(LUPRI,*) SECNAM,': #negative in symmetry ',ISYM,
     &                     ': ',INEG
         END DO
         WRITE(LUPRI,*) SECNAM,': total #negative: ',NNEG
      END IF

C     Copy index arrays from location 2 to location 3.
C     ------------------------------------------------

      CALL CHO_RSCOPY(IIBSTRSH,NNBSTRSH,INDRED,2,3,MSYM,MMSHL,LMMBSTRT,
     &                3)

C     Re-initialize index arrays at location 2.
C     -----------------------------------------

      CALL CHO_IZERO(INDRED(1,2),LMMBSTRT)
      CALL CHO_IZERO(IIBSTRSH(1,1,2),MSYM*MMSHL)
      CALL CHO_IZERO(NNBSTRSH(1,1,2),MSYM*MMSHL)
      CALL CHO_IZERO(IIBSTR(1,2),MSYM)
      CALL CHO_IZERO(NNBSTR(1,2),MSYM)
      NNBSTRT(2) = 0

C     Set new reduced set: mapping and SP counter.
C     --------------------------------------------

      IF (SCDIAG) THEN  ! do screening

         IF (MODE_SCREEN .EQ. 1) THEN ! both conv. and unconv. included

            IF (CHO_USEABS) THEN ! neg. diag. might be included

               KAB = 0
               DO ISYM = 1,NSYM
                  IF (NNBSTR(ISYM,3) .GT. 0) THEN

                     JAB1 = IIBSTR(ISYM,3) + 1
                     JAB2 = JAB1 + NNBSTR(ISYM,3) - 1

                     IAB = INDRED(JAB1,3)
                     XM  = ABS(DIAG(IAB))
                     DO JAB = JAB1+1,JAB2
                        IAB = INDRED(JAB,3)
                        XM  = MAX(XM,ABS(DIAG(IAB)))
                     END DO

                     IF (XM .GT. THRCOM) THEN  ! only if not converged
                        DO ISHLAB = 1,NNSHL
                           JAB1 = IIBSTR(ISYM,3)
     &                          + IIBSTRSH(ISYM,ISHLAB,3) + 1
                           JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,3) - 1
                           DO JAB = JAB1,JAB2
                              IAB = INDRED(JAB,3)
                              TST = SQRT(ABS(DIAG(IAB))*XM)*DAMP(2)
                              IF (TST .GT. THRCOM) THEN
                                 KAB = KAB + 1
                                 INDRED(KAB,2) = IAB
                                 NNBSTRSH(ISYM,ISHLAB,2) =
     &                                       NNBSTRSH(ISYM,ISHLAB,2) + 1
                              END IF
                           END DO
                        END DO
                     END IF

                  END IF
               END DO

            ELSE ! neg. diag. excluded

               KAB = 0
               DO ISYM = 1,NSYM
                  IF (NNBSTR(ISYM,3) .GT. 0) THEN

                     JAB1 = IIBSTR(ISYM,3) + 1
                     JAB2 = JAB1 + NNBSTR(ISYM,3) - 1

                     IAB = INDRED(JAB1,3)
                     XM  = ABS(DIAG(IAB))
                     DO JAB = JAB1+1,JAB2
                        IAB = INDRED(JAB,3)
                        XM  = MAX(XM,ABS(DIAG(IAB)))
                     END DO

                     IF (XM .GT. THRCOM) THEN  ! only if not converged
                        DO ISHLAB = 1,NNSHL
                           JAB1 = IIBSTR(ISYM,3)
     &                          + IIBSTRSH(ISYM,ISHLAB,3) + 1
                           JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,3) - 1
                           DO JAB = JAB1,JAB2
                              IAB = INDRED(JAB,3)
                              IF (DIAG(IAB) .GT. 0.0D0) THEN ! neg=>conv
                                 TST = SQRT(DIAG(IAB)*XM)*DAMP(2)
                                 IF (TST .GT. THRCOM) THEN
                                    KAB = KAB + 1
                                    INDRED(KAB,2) = IAB
                                    NNBSTRSH(ISYM,ISHLAB,2) =
     &                                       NNBSTRSH(ISYM,ISHLAB,2) + 1
                                 END IF
                              END IF
                           END DO
                        END DO
                     END IF

                  END IF
               END DO

            END IF

         ELSE IF (MODE_SCREEN .EQ. 2) THEN ! only unconv. included

            IF (CHO_USEABS) THEN ! neg. diag. might be included

               KAB = 0
               DO ISYM = 1,NSYM
                  IF (NNBSTR(ISYM,3) .GT. 0) THEN

                     DO ISHLAB = 1,NNSHL
                        JAB1 = IIBSTR(ISYM,3)
     &                       + IIBSTRSH(ISYM,ISHLAB,3) + 1
                        JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,3) - 1
                        DO JAB = JAB1,JAB2
                           IAB = INDRED(JAB,3)
                           IF (ABS(DIAG(IAB)) .GT. THRCOM) THEN
                              KAB = KAB + 1
                              INDRED(KAB,2) = IAB
                              NNBSTRSH(ISYM,ISHLAB,2) =
     &                                       NNBSTRSH(ISYM,ISHLAB,2) + 1
                           END IF
                        END DO
                     END DO

                  END IF
               END DO

            ELSE ! neg. diag. excluded

               KAB = 0
               DO ISYM = 1,NSYM
                  IF (NNBSTR(ISYM,3) .GT. 0) THEN

                     DO ISHLAB = 1,NNSHL
                        JAB1 = IIBSTR(ISYM,3)
     &                       + IIBSTRSH(ISYM,ISHLAB,3) + 1
                        JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,3) - 1
                        DO JAB = JAB1,JAB2
                           IAB = INDRED(JAB,3)
                           IF (DIAG(IAB) .GT. THRCOM) THEN
                              KAB = KAB + 1
                              INDRED(KAB,2) = IAB
                              NNBSTRSH(ISYM,ISHLAB,2) =
     &                                       NNBSTRSH(ISYM,ISHLAB,2) + 1
                           END IF
                        END DO
                     END DO

                  END IF
               END DO

            END IF

         ELSE IF (MODE_SCREEN .EQ. 3) THEN ! only 1-center unconv. incl.

            IF (CHO_USEABS) THEN ! neg. diag. might be included

               KAB = 0
               DO ISYM = 1,NSYM
                  IF (NNBSTR(ISYM,3) .GT. 0) THEN

                     DO ISHLAB = 1,NNSHL
                        CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,
     &                                  .TRUE.)
                        IF (IATOMSHL(ISHLA) .EQ. IATOMSHL(ISHLB)) THEN
                           JAB1 = IIBSTR(ISYM,3)
     &                          + IIBSTRSH(ISYM,ISHLAB,3) + 1
                           JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,3) - 1
                           DO JAB = JAB1,JAB2
                              IAB = INDRED(JAB,3)
                              IF (ABS(DIAG(IAB)) .GT. THRCOM) THEN
                                 KAB = KAB + 1
                                 INDRED(KAB,2) = IAB
                                 NNBSTRSH(ISYM,ISHLAB,2) =
     &                                       NNBSTRSH(ISYM,ISHLAB,2) + 1
                              END IF
                           END DO
                        END IF
                     END DO

                  END IF
               END DO

            ELSE ! neg. diag. excluded

               KAB = 0
               DO ISYM = 1,NSYM
                  IF (NNBSTR(ISYM,3) .GT. 0) THEN

                     DO ISHLAB = 1,NNSHL
                        CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,
     &                                  .TRUE.)
                        IF (IATOMSHL(ISHLA) .EQ. IATOMSHL(ISHLB)) THEN
                           JAB1 = IIBSTR(ISYM,3)
     &                          + IIBSTRSH(ISYM,ISHLAB,3) + 1
                           JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,3) - 1
                           DO JAB = JAB1,JAB2
                              IAB = INDRED(JAB,3)
                              IF (DIAG(IAB) .GT. THRCOM) THEN
                                 KAB = KAB + 1
                                 INDRED(KAB,2) = IAB
                                 NNBSTRSH(ISYM,ISHLAB,2) =
     &                                       NNBSTRSH(ISYM,ISHLAB,2) + 1
                              END IF
                           END DO
                        END IF
                     END DO

                  END IF
               END DO

            END IF

         ELSE ! MODE_SCREEN out of bounds

            WRITE(LUPRI,*) SECNAM,': MODE_SCREEN = ',MODE_SCREEN
            CALL CHO_QUIT('MODE_SCREEN out of bounds in '//SECNAM,103)

         END IF

      ELSE ! no screening; remove zero diagonals and check convergence

         IF (CHO_USEABS) THEN ! neg diag might be incl.

            KAB = 0
            DO ISYM = 1,NSYM
               IF (NNBSTR(ISYM,3) .GT. 0) THEN

                  JAB1 = IIBSTR(ISYM,3) + 1
                  JAB2 = JAB1 + NNBSTR(ISYM,3) - 1

                  IAB = INDRED(JAB1,3)
                  XM  = ABS(DIAG(IAB))
                  DO JAB = JAB1+1,JAB2
                     IAB = INDRED(JAB,3)
                     XM  = MAX(XM,ABS(DIAG(IAB)))
                  END DO

                  IF (XM .GT. THRCOM) THEN  ! only if not converged
                     DO ISHLAB = 1,NNSHL
                        JAB1 = IIBSTR(ISYM,3)
     &                       + IIBSTRSH(ISYM,ISHLAB,3) + 1
                        JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,3) - 1
                        DO JAB = JAB1,JAB2
                           IAB = INDRED(JAB,3)
                           IF (ABS(DIAG(IAB)) .GT. 0.0D0) THEN
                              KAB = KAB + 1
                              INDRED(KAB,2) = IAB
                              NNBSTRSH(ISYM,ISHLAB,2) =
     &                                       NNBSTRSH(ISYM,ISHLAB,2) + 1
                           END IF
                        END DO
                     END DO
                  END IF

               END IF
            END DO

         ELSE ! neg diag excl.

            KAB = 0
            DO ISYM = 1,NSYM
               IF (NNBSTR(ISYM,3) .GT. 0) THEN

                  JAB1 = IIBSTR(ISYM,3) + 1
                  JAB2 = JAB1 + NNBSTR(ISYM,3) - 1

                  IAB = INDRED(JAB1,3)
                  XM  = ABS(DIAG(IAB))
                  DO JAB = JAB1+1,JAB2
                     IAB = INDRED(JAB,3)
                     XM  = MAX(XM,ABS(DIAG(IAB)))
                  END DO

                  IF (XM .GT. THRCOM) THEN  ! only if not converged
                     DO ISHLAB = 1,NNSHL
                        JAB1 = IIBSTR(ISYM,3)
     &                       + IIBSTRSH(ISYM,ISHLAB,3) + 1
                        JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,3) - 1
                        DO JAB = JAB1,JAB2
                           IAB = INDRED(JAB,3)
                           IF (DIAG(IAB) .GT. 0.0D0) THEN
                              KAB = KAB + 1
                              INDRED(KAB,2) = IAB
                              NNBSTRSH(ISYM,ISHLAB,2) =
     &                                       NNBSTRSH(ISYM,ISHLAB,2) + 1
                           END IF
                        END DO
                     END DO
                  END IF

               END IF
            END DO

         END IF

      END IF

C     Set remaining index arrays.
C     ---------------------------

      CALL CHO_SETREDIND(IIBSTRSH,NNBSTRSH,MSYM,MMSHL,2)

C     Debug print.
C     ------------

      IF (CHO_TRCNEG) THEN
         WRITE(LUPRI,*) SECNAM,': checking for negative diagonals ',
     &                  'in next reduced set:'
         NNEG = 0
         DO ISYM = 1,NSYM
            JAB1 = IIBSTR(ISYM,2) + 1
            JAB2 = JAB1 + NNBSTR(ISYM,2) - 1
            INEG = 0
            DO JAB = JAB1,JAB2
               IAB = INDRED(JAB,2)
               IF (DIAG(IAB) .LT. 0.0D0) THEN
                  INEG = INEG + 1
               END IF
            END DO
            NNEG = NNEG + INEG
            WRITE(LUPRI,*) SECNAM,': #negative in symmetry ',ISYM,
     &                     ': ',INEG
         END DO
         WRITE(LUPRI,*) SECNAM,': total #negative: ',NNEG
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SubRoutine Wavelet_Transform(irc,ipCMO,nSym,nBas,nFro,nOrb2Loc,
     &                                 inv,Silent,xNrm)
C
C     Author: F. Aquilante
C
C     Purpose: wavelet transform of the MO basis (inv=0)
C              "       backtransform (inv=1)
C
      Implicit Real*8 (a-h,o-z)
      Integer irc, ipCMO, nSym, nBas(nSym), nFro(nSym), nOrb2Loc(nSym)
      Integer inv
      Logical Silent
      Real*8  xNrm

#include "WrkSpc.fh"

      Character*17 SecNam
      Parameter (SecNam = 'Wavelet_Transform')

      Integer  Log2
      External Log2

      real*8 ddot_
      external ddot_
*
*
      irc = 0
      xNrm = 0.0d0
      If (.not.Silent) Then
         If (inv.eq.0) Write(6,'(/,1X,A)')'Wavelet transform of the MOs'
         If (inv.eq.1) Write(6,'(/,1X,A)')'Inverse wavelet transform'//
     &                                    ' of the MOs'
         Write(6,'(1X,A,8(1X,I6))')
     &   'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
         Write(6,'(1X,A,8(1X,I6))')
     &   'Orbitals to transform:',(nOrb2Loc(iSym),iSym=1,nSym)
      End If

      If (inv.eq.1) go to 1000 ! Inverse wavelet transform

      njOrb = Log2(nOrb2Loc(1))
      l_Scr = nBas(1)*(2**njOrb-1)
      Do iSym = 2,nSym
         njOrb = Log2(nOrb2Loc(iSym))
         l_Scr = max(l_Scr,nBas(iSym)*(2**njOrb-1))
      End Do
      Call GetMem('Scratch','Allo','Real',ipScr,l_Scr)
      kOffC = ipCMO
      Do iSym = 1,nSym
         If (nOrb2Loc(iSym) .gt. 0) Then
            kOff1 = kOffC + nBas(iSym)*nFro(iSym)
            kOff2 = kOff1
            njOrb = Log2(nOrb2Loc(iSym))
            Do While (njOrb .ge. 1)
              Call FWT_Haar(nBas(iSym),njOrb,Work(ipScr),Work(kOff2))
              njOrb = 2**njOrb
              kOff2 = kOff2 + nBas(iSym)*njOrb
              njOrb = Log2(nOrb2Loc(iSym)-njOrb)
            End Do
            xNrm = xNrm + dDot_(nBas(iSym)*nOrb2Loc(iSym),Work(kOff1),1,
     &                                                   Work(kOff1),1)
            If (irc .ne. 0) Then
               irc  = 1
               xNrm = -9.9d9
               Return
            End If
         End If
         kOffC = kOffC + nBas(iSym)**2
      End Do
      xNrm = sqrt(xNrm)
      Call GetMem('Scratch','Free','Real',ipScr,l_Scr)
      Return
*
1000  Continue
      njOrb = Log2(nOrb2Loc(1))
      l_Scr = nBas(1)*2**njOrb
      Do iSym = 2,nSym
         njOrb = Log2(nOrb2Loc(iSym))
         l_Scr = max(l_Scr,nBas(iSym)*2**njOrb)
      End Do
      Call GetMem('Scratch','Allo','Real',iScr,l_Scr)
      kOffC = ipCMO
      Do iSym = 1,nSym
         If (nOrb2Loc(iSym) .gt. 0) Then
            kOff1 = kOffC + nBas(iSym)*nFro(iSym)
            kOff2 = kOff1
            njOrb = Log2(nOrb2Loc(iSym))
            Do While (njOrb .ge. 1)
              Call Inv_FWT_Haar(nBas(iSym),njOrb,Work(iScr),Work(kOff2))
              njOrb = 2**njOrb
              kOff2 = kOff2 + nBas(iSym)*njOrb
              njOrb = Log2(nOrb2Loc(iSym)-njOrb)
            End Do
            xNrm = xNrm + dDot_(nBas(iSym)*nOrb2Loc(iSym),Work(kOff1),1,
     &                                                   Work(kOff1),1)
            If (irc .ne. 0) Then
               irc  = 1
               xNrm = -9.9d9
               Return
            End If
         End If
         kOffC = kOffC + nBas(iSym)**2
      End Do
      xNrm = sqrt(xNrm)
      Call GetMem('Scratch','Free','Real',iScr,l_Scr)
*
      End
*                                                                      *
************************************************************************
*                                                                      *
      Integer Function Log2(n)

      Implicit none
      Integer n, m

      m=n
      Log2=0
      Do while (m .gt. 1)
         m=m/2
         Log2=Log2+1
      End Do

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine symgen_cvb(nalf1,nbet1,nda1,ndb1,
     >  isymalf,isymbet,iasyind,ibsyind,
     >  ialfsym,ibetsym,irpdet,irpalf,irpbet,
     >  mingrph,maxgrph,nk,locc,lunocc,xalf,xbet,icount)
      implicit real*8 (a-h,o-w,y-z),integer(x)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension isymalf(nda1),isymbet(ndb1)
      dimension iasyind(0:mxirrep),ibsyind(0:mxirrep)
      dimension ialfsym(nda1),ibetsym(ndb1)
      dimension irpdet(mxirrep),irpalf(mxirrep),irpbet(mxirrep)
      dimension mingrph(0:norb),maxgrph(0:norb)
      dimension nk(0:norb),locc(norb+1),lunocc(norb+1)
      dimension xalf(0:norb,0:nalf1),xbet(0:norb,0:nbet1)
      dimension icount(mxirrep)

c Alpha loop:
      call izero(irpalf,mxirrep)
      do 100 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nalf1,0)
      maxgrph(iorb)=min(iorb,nalf1)
100   continue
      call weight_cvb(xalf,mingrph,maxgrph,nalf1,norb)
      call imove_cvb(maxgrph,nk,norb+1)
      call occupy_cvb(nk,norb,locc,lunocc)
      index=1
200   continue
      irp=1
      do 250 ia=1,nalf1
      irp=md2h(irp,ityp(locc(ia)))
250   continue
      irpalf(irp)=irpalf(irp)+1
      ialfsym(index)=irp
      call loind_cvb(norb,nalf1,nk,mingrph,maxgrph,
     >                       locc,lunocc,index,xalf,*200)
      iasyind(0)=0
      do 260 irp=1,mxirrep
      iasyind(irp)=iasyind(irp-1)+irpalf(irp)
260   continue
      call izero(icount,mxirrep)
      do 275 ida=1,nda1
      irrep=ialfsym(ida)
      icount(irrep)=icount(irrep)+1
      isymalf(icount(irrep)+iasyind(irrep-1))=ida
275   continue

c Beta loop:
      call izero(irpbet,mxirrep)
      do 300 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nbet1,0)
      maxgrph(iorb)=min(iorb,nbet1)
300   continue
      call weight_cvb(xbet,mingrph,maxgrph,nbet1,norb)
      call imove_cvb(maxgrph,nk,norb+1)
      call occupy_cvb(nk,norb,locc,lunocc)
      index=1
400   continue
      irp=1
      do 450 ib=1,nbet1
      irp=md2h(irp,ityp(locc(ib)))
450   continue
      irpbet(irp)=irpbet(irp)+1
      ibetsym(index)=irp
      call loind_cvb(norb,nbet1,nk,mingrph,maxgrph,
     >                       locc,lunocc,index,xbet,*400)
      ibsyind(0)=0
      do 460 irp=1,mxirrep
      ibsyind(irp)=ibsyind(irp-1)+irpbet(irp)
460   continue
      call izero(icount,mxirrep)
      do 475 idb=1,ndb1
      irrep=ibetsym(idb)
      icount(irrep)=icount(irrep)+1
      isymbet(icount(irrep)+ibsyind(irrep-1))=idb
475   continue

      do 500 irp=1,mxirrep
      irpdet(irp)=0
      do 501 jrp=1,mxirrep
      irpdet(irp)=irpdet(irp)+irpalf(jrp)*irpbet(md2h(irp,jrp))
501   continue
500   continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Make_Fluctuating_Charges(nAtoms,iANr,nij,nPert,rMP,
     &                                    nElem,EC,Alpha)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Real*8 rMP(nij,0:nElem-1,0:nPert-1), EC(3,nij)
      Integer iANr(nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
*     For the A-matrix
*
      Call Allocate_Work(ip_AInv,nAtoms**2)
      Call Allocate_Work(ip_A,nAtoms**2)
*
      Call Build_AMatrix(nAtoms,iANr,Work(ip_A),Work(ip_AInv),EC,nij,
     &     Alpha)
*
      Call Free_Work(ip_A)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the fluctuating charges
*
      Call Allocate_Work(ip_lambda,nAtoms)
      Call Allocate_Work(ip_dq    ,nAtoms)
*
      Call Fluctuating(Work(ip_AInv),nAtoms,Work(ip_lambda),Work(ip_dq),
     &                 nij,nPert,iANr,rMP,nElem,EC,Alpha)
*
      Call Free_Work(ip_lambda)
      Call Free_Work(ip_dq)
      Call Free_Work(ip_AInv)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GenBMp(irc,X,n,m,Lunit,nStp,StpSiz,Color)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: n, m, Lunit, nStp
real(kind=wp), intent(in) :: X(n,m), StpSiz
character, intent(in) :: Color
integer(kind=iwp) :: i, iBin, iUpLim, j, nBin, nBin_Def, nCh
real(kind=wp) :: absX, Step, Step_Def
character :: Color_Def, myColor
integer(kind=iwp), allocatable :: BMp(:)
real(kind=wp), allocatable :: Bin(:)
character(len=*), parameter :: SecNam = 'GenBMp'
integer(kind=iwp), external :: iRnge

! Defaults and limits.
! --------------------

nBin_Def = 5
Step_Def = 1.0e-2_wp
Color_Def = 'R'
iUpLim = 999999

! Check input.
! ------------

irc = 0
if ((n < 1) .or. (m < 1)) then
  return
end if
if ((n > iUpLim) .or. (m > iUpLim)) then
  irc = 1
  return
end if
if (Lunit < 1) then
  irc = 2
  return
end if

if ((nStp < 2) .or. (nStp > 256)) then
  nBin = nBin_Def
else
  nBin = nStp
end if
if (StpSiz <= Zero) then
  Step = Step_Def
else
  Step = StpSiz
end if
myColor = Color
call UpCase(myColor)
if ((myColor /= 'R') .and. (myColor /= 'G') .and. (myColor /= 'B')) then
  myColor = Color_Def
end if

! Set up bins.
! ------------

nCh = 255/(nBin-1)

call mma_allocate(Bin,nBin,label='Bins')
call mma_allocate(BMp,nBin,label='iBMp')

Bin(1) = One
do iBin=2,nBin-1
  Bin(iBin) = Bin(iBin-1)*Step
end do
Bin(nBin) = -One

BMp(nBin) = 255
do iBin=nBin-1,1,-1
  BMp(iBin) = BMp(iBin+1)-nCh
end do

! Generate bitmap file.
! Note the special loop structure.
! --------------------------------

write(Lunit,'(2(1X,I6))') m,n ! #col,#row
if (myColor == 'R') then ! red
  do i=n,1,-1
    do j=1,m
      absX = abs(X(i,j))
      iBin = iRnge(absX,Bin,nBin)
      if (BMp(iBin) == 255) then
        write(Lunit,'(4(1X,I3))') 255,255,255,0
      else
        write(Lunit,'(4(1X,I3))') BMp(iBin),0,0,0
      end if
    end do
  end do
else if (myColor == 'G') then ! green
  do i=n,1,-1
    do j=1,m
      absX = abs(X(i,j))
      iBin = iRnge(absX,Bin,nBin)
      if (BMp(iBin) == 0) then
        write(Lunit,'(4(1X,I3))') 255,255,255,0
      else
        write(Lunit,'(4(1X,I3))') 0,BMp(iBin),0,0
      end if
    end do
  end do
else if (myColor == 'B') then ! blue
  do i=n,1,-1
    do j=1,m
      absX = abs(X(i,j))
      iBin = iRnge(absX,Bin,nBin)
      if (BMp(iBin) == 0) then
        write(Lunit,'(4(1X,I3))') 255,255,255,0
      else
        write(Lunit,'(4(1X,I3))') 0,0,BMp(iBin),0
      end if
    end do
  end do
else
  call SysAbendMsg(SecNam,'Logical error!','(Should never happen)')
end if

! De-allocations.
! ---------------

call mma_deallocate(Bin)
call mma_deallocate(BMp)

end subroutine GenBMp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Lebedev_Grid(L_Max)
************************************************************************
*                                                                      *
*     Computes datas useful for the angular quadrature.                *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "nq_info.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Parameter (nSet=11)
      Integer Lebedev_order(nSet)
      Data Lebedev_order/5,7,11,17,23,29,35,41,47,53,59/
*                                                                      *
************************************************************************
*                                                                      *
*     Use the GGL grids to minimize the number of grid points.
*
      If (L_Max.lt.3) Go To 99
      Call Do_GGL(3,nPoints,ipR)
      nAngularGrids=nAngularGrids+1
      Info_Ang(1,nAngularGrids)=3
      Info_Ang(2,nAngularGrids)=nPoints
      Info_Ang(3,nAngularGrids)=ipR
*                                                                      *
************************************************************************
*                                                                      *
*---- Generate angular grid a la Lebedev
*
      Do iSet = 1, nSet
         If (Lebedev_order(iSet).le.L_Max) Then
            nAngularGrids=nAngularGrids+1
            L_Eff=Lebedev_order(iSet)
*
            Call Do_Lebedev(L_Eff,nPoints,ipR)
*
            Info_Ang(1,nAngularGrids)=L_Eff
            Info_Ang(2,nAngularGrids)=nPoints
            Info_Ang(3,nAngularGrids)=ipR
         Else
*
            Go To 99
*
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
 99   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Yoshio Nishimoto                                 *
!***********************************************************************

module PCM_alaska

use pso_stuff, only: nDens
use rctfld_module, only: nTS, PCM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none

! PM_SQ_ind: ASCs polarized by the relaxed density matrix (after Z-vector)
!  PCM_SQ_ind(1,:) :: nuclear-induced charges
!  PCM_SQ_ind(2,:) :: electron-induced charges
! PCMO: CMO obtained in RASSCF (PCM + CMO)
! DSA_AO: density matrix that polarizes the ASCs during SCF (in AO)
! def_solv = 1: state-specific
! def_solv = 3: state-averaged
real(kind=wp), allocatable :: DSA_AO(:), PCM_SQ_ind(:,:), PCMO(:)
integer(kind=iwp) :: def_solv = 0
logical(kind=iwp) :: lSA = .false.

contains

!-----------------------------------------------------------------------

subroutine PCM_alaska_lSA()

  integer(kind=iwp) :: iGo
  character(len=8) Method

  call Get_cArray('Relax Method',Method,8)
  lSA = .false.
  if ((Method == 'CASSCFSA') .or. (Method == 'DMRGSCFS') .or. (Method == 'GASSCFSA') .or. (Method == 'RASSCFSA') .or. &
      (Method == 'CASPT2')) then
    call Get_iScalar('SA ready',iGo)
    if (iGO == 1) lSA = .true.
  end if

  if (.not. PCM) return
  if (.not. lSA) return

  call PCM_alaska_init()

end subroutine PCM_alaska_lSA

!-----------------------------------------------------------------------

subroutine PCM_alaska_init()

  use Sizes_of_Seward, only: S

  integer(kind=iwp) :: iPCMRoot, mCMO

  if (def_solv == 0) then
    call Get_iScalar('RF CASSCF root',iPCMRoot)
    select case (iPCMRoot)
      case (1:)
        def_solv = 1
      case (0)
        def_solv = 3
      case (-1)
        def_solv = 4
      case (-2)
        def_solv = 5
      case (-3)
        def_solv = 6
    end select

    if ((def_solv /= 1) .and. (def_solv /= 3)) then
      write(u6,*) ' RFROOT in &RASSCF must be non-negative for SA-MCSCF/PCM gradients'
      call abend()
    end if
  end if

  call mma_allocate(PCM_SQ_ind,2,nTS,Label='PCM_SQ_ind')
  PCM_SQ_ind(:,:) = Zero

  mCMO = S%n2Tot
  call mma_allocate(PCMO,mCMO,Label='CMO')
  call Get_dArray_chk('Last orbitals',PCMO,mCMO)

end subroutine PCM_alaska_init

!-----------------------------------------------------------------------

subroutine PCM_alaska_final()

  if (.not. PCM) return
  if (.not. lSA) return

  call mma_deallocate(PCM_SQ_ind)
  call mma_deallocate(PCMO)
  call mma_deallocate(DSA_AO)

end subroutine PCM_alaska_final

!-----------------------------------------------------------------------

subroutine PCM_alaska_prep()

  use Basis_Info, only: nBas
  use etwas, only: nAsh
  use PCM_arrays, only: PCM_SQ
  use pso_stuff, only: nDens
  use Symmetry_Info, only: nIrrep
  use Index_Functions, only: nTri_Elem

  integer(kind=iwp) :: iCharge, iIrrep, nAct
  logical(kind=iwp) :: Dff, First, NonEq
  real(kind=wp) :: RepNuc, Tot_Charge, Tot_El_Charge, Tot_Nuc_Charge
  real(kind=wp), allocatable :: Dtmp(:), h1(:), TwoHam(:)

  call Set_Basis_Mode('Valence')
  call Setup_iSD()
  call Get_iArray('nAsh',nAsh,nIrrep)

  ! First, construct the density matrix that polarizes the ASCs during SCF (in AO)

  nAct = 0
  nDens = 0
  do iIrrep=0,nIrrep-1
    nAct = nAct+nAsh(iIrrep)
    nDens = nDens+nTri_Elem(nBas(iIrrep))
  end do

  call mma_allocate(DSA_AO,nDens,Label='DSA_AO')
  call mma_allocate(Dtmp,nDens,Label='Dtmp') ! ntBtri length

  ! Read the density matrix that polarized the ASCs during SCF
  ! constructed in mclr/inpone.F90
  DSA_AO(:) = Zero
  call Get_dArray_chk('D1ao_PCM',DSA_AO,nDens)

  ! Second, obtain ASCs induced by the effective density (after Z-vector)
  ! The induced charges are put in PCM_SQ_ind

  call Get_D1ao_Var(Dtmp,nDens) ! Read from D1aoVar
  call mma_allocate(h1,nDens,Label='h1')
  call mma_allocate(TwoHam,nDens,Label='TwoHam')
  RepNuc = Zero
  First = .true.
  Dff = .false.
  NonEq = .false.
  h1(:) = Zero
  TwoHam(:) = Zero
  call DrvPCM(h1,TwoHam,Dtmp,RepNuc,nDens,First,Dff,NonEq)
  call Get_dArray('PCM Charges',PCM_SQ_ind,2*nTs)

  ! Third, obtain ASCs induced by the ASC-polarizing density
  ! In the conventional implementation, the ASCs are stored in PCM_SQ.
  ! However, the ASCs have been overwritten during MCLR so the correct ASCs are newly computed here.

  h1(:) = Zero
  TwoHam(:) = Zero
  call DrvPCM(h1,TwoHam,DSA_AO,RepNuc,nDens,First,Dff,NonEq)
  call Get_dArray('PCM Charges',PCM_SQ,2*nTs)

  call Free_iSD()

  ! tentative patch for MECI calculations with MS-type CASPT2
  ! "Reaction Field" has been overwritten in MCLR, but the correct reaction field is needed
  ! for computing H0 in MS-type calculations for other roots, so recompute it here.
  ! Note that ALASKA should not be called for PTED solvation.
  h1(:) = Zero
  TwoHam(:) = Zero

  call Get_dScalar('Total Nuclear Charge',Tot_Nuc_Charge)
  call Get_dScalar('Total Charge',Tot_El_Charge)
  Tot_Charge = Tot_Nuc_Charge+Tot_El_Charge
  iCharge = int(Tot_Charge,kind=iwp)
  call DrvRF(h1,TwoHam,DSA_AO,RepNuc,nDens,First,Dff,NonEq,iCharge)

  call mma_deallocate(Dtmp)
  call mma_deallocate(h1)
  call mma_deallocate(TwoHam)

end subroutine PCM_alaska_prep

end module PCM_alaska

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************

function IBINOM(N,M)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: IBINOM
integer(kind=iwp), intent(in) :: N, M
integer(kind=iwp) :: I, INIT = 0, IPOS, J, K, MM, NOMTAB(225) = 0
real(kind=wp) :: X

IBINOM = 0
if (N < 0) return
MM = M
if (2*MM > N) MM = N-M
if (MM < 0) return
IBINOM = 1
if (MM == 0) return
IBINOM = N
if (MM == 1) return
if (INIT == 0) then
  IPOS = 0
  do I=4,32
    X = real(I,kind=wp)
    do J=2,I/2
      IPOS = IPOS+1
      X = X*real(I+1-J,kind=wp)/real(J,kind=wp)
      NOMTAB(IPOS) = nint(X)
    end do
  end do
  !PAM write(u6,'(1x,5I9)') NOMTAB
  INIT = 1
end if
if (N <= 32) then
  IBINOM = NOMTAB(((N-3)**2)/4+MM-1)
else
  X = real(IBINOM,kind=wp)
  do K=2,MM
    X = X*real(N+1-K,kind=wp)/real(K,kind=wp)
  end do
  IBINOM = nint(X)
  if (X /= real(IBINOM,kind=wp)) then
    write(u6,*) ' IBINOM: Unable to compute N over M'
    write(u6,*) ' N=',N
    write(u6,*) ' M=',M
    call SYSABENDMSG('lucia_util/ibinom','Internal error','')
  end if
end if

end function IBINOM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine output7 (unit,dkhscfflg,sused,tcounter,ttimes,sorder,
     *                    tmult,t,tscrchar,ttimestot,tmulttot)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 19.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer unit,sused,tcounter(maxsnumber),ttimes(maxsnumber),
     *        sorder(maxsnumber,3),tmult(maxsnumber),ttimestot,tmulttot
      character*(4) t(maxsnumber)
      character*(11) tscrchar(maxsnumber)
      integer j,idum
c
      write (unit,1071)
1071  format (//2X,'Statistic about evaluation of Txxx-expressions in ',
     *        'step 5:',/2X,57('-'),//5X,'Note: All values refer to',
     *        ' low-level situation of step5.')
c
      if (dkhscfflg) then
        write (unit,1072)
1072    format (//5X,'#',7X,'step1',4X,'-->',3X,'step5',3X,'order',3X,
     *          'no. of subs.',3X,'no. of terms',3X,'no. of mat.mult.',
     *          /36X,'(tot)',5X,'(ttimes)',5X,'(tcounter)',6X,'(tmult)',
     *          10X,/)
      else
       write (unit,1073)
1073    format (//5X,'#',6X,'step1',3X,'-->',3X,'step5',4X,'order',1X,
     *        'order',1X,'order',3X,'no. of subs.',3X,'no. of terms',3X,
     *        'no. of mat.mult.',/36X,'(V)',3X,'(X)',2X,'(tot)',5X,
     *        '(ttimes)',7X,'(tcounter)',7X,'(tmult)',/)
      endif
c
      idum=0
      do 25 j=1,sused
        if (ttimes(j).gt.0) then
          idum=idum+1
          if (dkhscfflg) then
            write (dbgunit,1081) idum,tscrchar(j),t(j),sorder(j,3),
     *                         ttimes(j),tcounter(j),tmult(j)
1081        format (3X,I3,5X,A11,6X,A4,5X,I2,4X,I8,8X,I6,8X,I8)
          else
            write (dbgunit,1082) idum,tscrchar(j),t(j),sorder(j,1),
     *                           sorder(j,2),sorder(j,3),ttimes(j),
     *                           tcounter(j),tmult(j)
1082        format (3X,I3,5X,A11,4X,A4,6X,I2,4X,I2,4X,I2,6X,I8,6X,I8,7X,
     *              I9)
          endif
        endif
  25  continue
c
      if (dkhscfflg) then
        write (unit,1091) ttimestot,tmulttot
1091    format (43X,8('-'),21X,9('-'),/43X,I8,21X,I9,/2X)
      else
        write (unit,1092) ttimestot,tmulttot
1092    format (56X,8('-'),21X,9('-'),/56X,I8,21X,I9,/2X)
      endif
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE RSBB2A_LUCIA(  ISCSM,  ISCTP,  ICCSM,  ICCTP,   IGRP,
     &                           NROW,  NSCOL,   NGAS,   ISOC,   ICOC,
     &                             SB,     CB,  ADSXA,  STSTDX,
     &                         SXDXSX,NOBPTS,
     &                           MAXI,   MAXK,   SSCR,   CSCR,     I1,
*
     &                           XI1S,          XINT,  NSMOB,
     &                          NSMST,    NSMDX,
     &                           MXSXST, MXSXBL,   IMOC, SCLFAC,
     &                         NTESTG, IPHGAS)
*
*
* SUBROUTINE RSBB2A_LUCIA --> 46
*
*
* two electron excitations on column strings
*
* =====
* Input
* =====
*
* ISCSM,ISCTP : Symmetry and type of sigma columns
* ICCSM,ICCTP : Symmetry and type of C     columns
* IGRP : String group of columns
* NROW : Number of rows in S and C block
* NSCOL : Number of columns in S block
* ISEL1(3) : Number of electrons in RAS1(3) for S block
* ICEL1(3) : Number of electrons in RAS1(3) for C block
* CB   : Input C block
* ADASX : sym of a+, a => sym of a+a
* ADSXA : sym of a+, a+a => sym of a
* DXSTST : Sym of sx,!st> => sym of sx !st>
* STSTDX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
* SXDXSX : Symmetry of SX1,SX1*SX2 => symmetry of SX2
* NTSOB  : Number of orbitals per type and symmetry
* IBTSOB : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* NSMOB,NSMST,NSMSX,NSMDX : Number of symmetries of orbitals, strings,
*                           single excitations, double excitations
* MAXI   : Largest number of 'spectator strings' treated simultaneously
* MAXK   : Largest number of inner resolution strings treated at simult.
*
* ======
* Output
* ======
*
* SB : updated sigma block
*
* =======
* Scratch
* =======
*
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* I2, XI2S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* XINT : Space for two electron integrals
*
* Jeppe Olsen, Winter of 1991
*
      USE Para_Info, ONLY: MyRank, nProcs
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
*. General input
      INTEGER ADSXA(MXPOBS,2*MXPOBS)
      INTEGER STSTDX(NSMST,NSMST)
      INTEGER SXDXSX(2*MXPOBS,4*MXPOBS)
      INTEGER NOBPTS(MXPNGAS,*)
      INTEGER IPHGAS(NGAS)
*
*.Input
      DIMENSION CB(*)
      INTEGER ISOC(NGAS),ICOC(NGAS)
*.Output
      DIMENSION SB(*)
*.Scatch
      DIMENSION SSCR(*),CSCR(*),XINT(*)
      DIMENSION I1(MAXK,*),XI1S(MAXK,*)
c      DIMENSION RIKSX(MXSXBL,4),RKJSX(MXSXBL,4)
*.Local arrays
      DIMENSION ITP(256),JTP(256),KTP(256),LTP(256)
C-jwk-cleanup      INTEGER I4_DIM(4),I4_SM(4)
      DIMENSION I4_TP(4),I4_REO(4),ISCR(4)
      INTEGER I4_AC(4)
*
      INTEGER IKBT(3,8),IKSMBT(2,8),JLBT(3,8),JLSMBT(2,8)
*     DIMENSION SCR(MXPTSOB*MXPTSOB*MXPTSOB*MXPTSOB)
*

#include "oper.fh"
*
C-jwk-cleanup      DIMENSION IACAR(2),ITPAR(2)
      Call Allocate_Work(ipSCR,MXPTSOB**4)
      NTESTL = 000
      NTEST = MAX(NTESTG,NTESTL)
      IF(NTEST.GE.1000) THEN
        WRITE(6,*) ' ================'
        WRITE(6,*) ' RSBB2A speaking '
        WRITE(6,*) ' ================'
        WRITE(6,*) ' MXSXST MXSXBL = ', MXSXST,MXSXBL
        WRITE(6,*) ' RSBB2A : IMOC ', IMOC
        WRITE(6,*) ' ISOC and ICOC : '
        CALL IWRTMA(ISOC,1,NGAS,1,NGAS)
        CALL IWRTMA(ICOC,1,NGAS,1,NGAS)
*
*
      END IF
      IFRST = 1
      JFRST = 1
*
*.Types of DX that connects the two strings
*
      IDXSM = STSTDX(ISCSM,ICCSM)
      IF(IDXSM.EQ.0)  GOTO 2001
*. Connecting double excitations
      CALL DXTYP2_GAS(   NDXTYP,      ITP,      JTP,      KTP,      LTP,
     &                     NGAS,     ISOC,     ICOC,   IPHGAS)
      DO 2000 IDXTYP = 1, NDXTYP
        ITYP = ITP(IDXTYP)
        JTYP = JTP(IDXTYP)
        KTYP = KTP(IDXTYP)
        LTYP = LTP(IDXTYP)
*. Is this combination of types allowed
c         IJKL_ACT = 1
c         IF(IJKL_ACT.EQ.0) GOTO 2000
*
C?      write(6,*) ' test inserted in RSBB2AN'
C?      NPTOT = 0
C?      IF(ITYP.EQ.3) NPTOT = NPTOT + 1
C?      IF(JTYP.EQ.3) NPTOT = NPTOT + 1
C?      IF(KTYP.EQ.3) NPTOT = NPTOT + 1
C?      IF(LTYP.EQ.3) NPTOT = NPTOT + 1
C?      IF(NPTOT.EQ.3) GOTO 2000
*
        ITYP_ORIG = ITYP
        JTYP_ORIG = JTYP
        KTYP_ORIG = KTYP
        LTYP_ORIG = LTYP
*
        IF(NTEST.GE.100) THEN
          WRITE(6,*) ' ITYP_ORIG, JTYP_ORIG, KTYP_ORIG, LTYP_ORIG',
     &                 ITYP_ORIG, JTYP_ORIG, KTYP_ORIG, LTYP_ORIG
        END IF
        NIJKL1 = 0
        IF(ITYP.EQ.1) NIJKL1 = NIJKL1+1
        IF(JTYP.EQ.1) NIJKL1 = NIJKL1+1
        IF(KTYP.EQ.1) NIJKL1 = NIJKL1+1
        IF(LTYP.EQ.1) NIJKL1 = NIJKL1+1
*. Optimal ordering of operators
        I4_AC(1) = 2
        I4_AC(2) = 2
        I4_AC(3) = 1
        I4_AC(4) = 1
        I4_TP(1) = ITYP
        I4_TP(2) = KTYP
        I4_TP(3) = LTYP
        I4_TP(4) = JTYP
c        IF(IUSE_PH.EQ.1) THEN
c          NOP = 4
c          CALL ALG_ROUTERX(ISOC,JSOC,NOP,I4_TP,I4_AC,I4_REO,SIGN4)
c        ELSE
          DO IJKL = 1, 4
            I4_REO(IJKL) = IJKL
          END DO
c        END IF
*. Type of operators : TP and AC
        DO IJKL = 1, 4
C         ISCR( I4_REO(IJKL) ) = I4_TP(IJKL)
          ISCR(IJKL) = I4_TP( I4_REO(IJKL) )
        END DO
        DO IJKL = 1, 4
          I4_TP(IJKL) = ISCR(IJKL)
        END DO
        ITYP = I4_TP(1)
        KTYP = I4_TP(2)
        LTYP = I4_TP(3)
        JTYP = I4_TP(4)
        DO IJKL = 1, 4
          ISCR(IJKL) = I4_AC( I4_REO(IJKL) )
        END DO
        DO IJKL = 1, 4
          I4_AC(IJKL) = ISCR(IJKL)
        END DO
        IF(NTEST.GE.100) THEN
          WRITE(6,*) ' I4_AC, IT_TP  defined '
          WRITE(6,*) ' I4_AC, I4_TP '
          CALL IWRTMA(I4_AC,1,4,1,4)
          CALL IWRTMA(I4_TP,1,4,1,4)
        END IF
*
CSVC: determine optimum number of partions as the lowest multiple of
C     NPROCS that satisfies a block size smaller than MAXI:
        NPART=0
        DO
          NPART=NPART+NPROCS
          NPARTSZ=MAX(NROW-1,0)/NPART+1
          IF (NPARTSZ.LE.MAXI) EXIT
        END DO
*
*      ==================================
        IF(I4_AC(1).EQ.I4_AC(2) ) THEN
*      ==================================
*
*. a+ a+ a a or a a a+ a+
*. Largest possible number of orbital pairs
          MI = 0
          MJ = 0
          MK = 0
          ML = 0
          DO IOBSM = 1, NSMST
            MI = MAX(MI,NOBPTS(ITYP,IOBSM))
            MJ = MAX(MJ,NOBPTS(JTYP,IOBSM))
            MK = MAX(MK,NOBPTS(KTYP,IOBSM))
            ML = MAX(ML,NOBPTS(LTYP,IOBSM))
          END DO
          MXPAIR = MAX(MI*MK,MJ*ML)
*. Largest posssible
*. Symmetry of allowed Double excitation,loop over excitations
          DO 1950 IKOBSM = 1, NSMOB
            JLOBSM = SXDXSX(IKOBSM,IDXSM)
            IF(NTEST.GE.100) WRITE(6,*) ' IKOBSM,JLOBSM', IKOBSM,JLOBSM
            IF(JLOBSM.EQ.0) GOTO 1950
*. types + symmetries defined => K strings are defined
            KFRST = 1
*
*. Number of batchs of symmetry pairs IK
*
            LENGTH = 0
            NIKBT = 0
            NBLK = 0
            NBLKT = 0
            DO ISM = 1, NSMOB
              KSM = ADSXA(ISM,IKOBSM)
              NI = NOBPTS(ITYP,ISM)
              NK = NOBPTS(KTYP,KSM)
              IF(NTEST.GE.100) write(6,*) ' NI, NK' , NI,NK
*
              IF(ISM.EQ.KSM.AND.ITYP.EQ.KTYP) THEN
                NIK = NI*(NI+1)/2
              ELSE IF(ITYP.GT.KTYP.OR.(ITYP.EQ.KTYP.AND.ISM.GT.KSM))THEN
                NIK = NI*NK
              ELSE
                NIK = 0
              END IF
              IF(NIK.NE.0) THEN
                NBLKT = NBLKT + 1
                IF(LENGTH+NIK .GT. MXPAIR) THEN
*. The present batch is complete
                  NIKBT = NIKBT+1
                  IKBT(1,NIKBT) = NBLKT - NBLK
                  IKBT(2,NIKBT) = NBLK
                  IKBT(3,NIKBT) = LENGTH
                  LENGTH = 0
                  NBLK = 0
                END IF
                NBLK = NBLK + 1
                LENGTH = LENGTH + NIK
                IKSMBT(1,NBLKT) = ISM
                IKSMBT(2,NBLKT) = KSM
              END IF
            END DO
*. The last batch
            IF(NBLK.NE.0) THEN
              NIKBT = NIKBT+1
              IKBT(1,NIKBT) = NBLKT - NBLK + 1
              IKBT(2,NIKBT) = NBLK
              IKBT(3,NIKBT) = LENGTH
            END IF

*.
            IF(NTEST.GE.2000) THEN
              WRITE(6,*) ' ITYP, KTYP, IKOBSM,  NIKBT = ',
     &                     ITYP, KTYP, IKOBSM,  NIKBT
              WRITE(6,*) ' IKBT : Offset, number, length '
              DO JIKBT = 1, NIKBT
                WRITE(6,'(3i3)') (IKBT(II,JIKBT), II = 1, 3)
              END DO
              WRITE(6,*) ' IKSMBT '
              CALL IWRTMA(IKSMBT,2,NBLKT,2,8)
            END IF
*
*. Number of batchs of symmetry pairs JL
*
            LENGTH = 0
            NJLBT = 0
            NBLK = 0
            NBLKT = 0
            DO JSM = 1, NSMOB
              LSM = ADSXA(JSM,JLOBSM)
              NJ = NOBPTS(JTYP,JSM)
              NL = NOBPTS(LTYP,LSM)
*
              IF(JSM.EQ.LSM.AND.JTYP.EQ.LTYP) THEN
                NJL = NJ*(NJ+1)/2
              ELSE IF(JTYP.GT.LTYP.OR.(JTYP.EQ.LTYP.AND.JSM.GT.LSM))THEN
                NJL = NJ*NL
              ELSE
                NJL = 0
              END IF
              IF(NJL.NE.0) THEN
                NBLKT = NBLKT + 1
                IF(LENGTH+NJL .GT. MXPAIR) THEN
*. The present batch is complete
                  NJLBT = NJLBT+1
                  JLBT(1,NJLBT) = NBLKT - NBLK
                  JLBT(2,NJLBT) = NBLK
                  JLBT(3,NJLBT) = LENGTH
                  LENGTH = 0
                  NBLK = 0
                END IF
                NBLK = NBLK + 1
                LENGTH = LENGTH + NJL
                JLSMBT(1,NBLKT) = JSM
                JLSMBT(2,NBLKT) = LSM
              END IF
            END DO
*. The last batch
            IF(NBLK.NE.0) THEN
              NJLBT = NJLBT+1
              JLBT(1,NJLBT) = NBLKT - NBLK + 1
              JLBT(2,NJLBT) = NBLK
              JLBT(3,NJLBT) = LENGTH
            END IF
*.
            IF(NTEST.GE.2000) THEN
              WRITE(6,*) ' JTYP, LTYP, JLOBSM,  NJLBT = ',
     &                     JTYP, LTYP, JLOBSM,  NJLBT
              WRITE(6,*) ' JLBT : Offset, number, length '
              DO JJLBT = 1, NJLBT
                WRITE(6,'(3i3)') (JLBT(II,JJLBT), II = 1, 3)
              END DO
              WRITE(6,*) ' JLSMBT '
              CALL IWRTMA(JLSMBT,2,NBLKT,2,8)
            END IF
*
*. Loop over batches of IK strings
            DO 1940 IKBTC = 1, NIKBT
              IF(NTEST.GE.1000) WRITE(6,*) ' IKBTC = ', IKBTC
*. Loop over batches of JL strings
              DO 1930 JLBTC = 1, NJLBT
                IFIRST = 1
*. Loop over batches of I strings
                DO 1801 IIPART = 1+MYRANK, NPART, NPROCS
                  IBOT = 1+(IIPART-1)*NPARTSZ
                  ITOP = MIN(IBOT+NPARTSZ-1,NROW)
                  NIBTC = ITOP-IBOT+1
                  IF (NIBTC.LE.0) EXIT
*.Loop over batches of intermediate strings
                  KBOT = 1- MAXK
                  KTOP = 0
 1800             CONTINUE
                    KBOT = KBOT + MAXK
                    KTOP = KTOP + MAXK
*
                    IONE = 1
                    JLBOFF = 1
                    NJLT = JLBT(3,JLBTC)
                    DO JLPAIR = 1, JLBT(2,JLBTC)
                      JSM = JLSMBT(1,JLBT(1,JLBTC)-1+JLPAIR)
                      LSM = JLSMBT(2,JLBT(1,JLBTC)-1+JLPAIR)
                      NJ = NOBPTS(JTYP,JSM)
                      NL = NOBPTS(LTYP,LSM)
                      IF(JSM.EQ.LSM.AND.JTYP.EQ.LTYP) THEN
                        NJL = NJ*(NJ+1)/2
                        JLSM = 1
                      ELSE
                        NJL = NJ * NL
                        JLSM = 0
                      END IF

*
*. obtain cb(KB,IA,jl) = sum(JB)<KB!a lb a jb !IB>C(IA,JB)
*
*. Obtain all double excitations from this group of K strings
                      II12 = 1
                      K12 = 1
                      IONE = 1
C?       write(6,*) ' Before ADAADAST '
*. Creation / annihilation maps , conjugated of above
                      IF(I4_AC(4).EQ.1) THEN
                        JAC = 2
                      ELSE
                        JAC = 1
                      END IF
                      IF(I4_AC(3).EQ.1) THEN
                        LAC = 2
                      ELSE
                        LAC = 1
                      END IF
                      CALL ADAADAST_GAS( IONE,  JSM, JTYP,   NJ,  JAC,
     &                                   IONE,  LSM, LTYP,   NL,  LAC,
     &                                  ICCTP,ICCSM, IGRP, KBOT, KTOP,
     &                                     I1, XI1S, MAXK,NKBTC, KEND,
     &                                  JFRST,KFRST, II12,  K12,SCLFAC)
*
                      JFRST = 0
                      KFRST = 0
*
                      IF(NKBTC.EQ.0) GOTO 1930
*. Loop over jl in TS classes
                      J = 0
                      L = 1
*
                      DO  IJL = 1, NJL
                        CALL NXTIJ(     J,     L,    NJ,    NL,  JLSM,
     &                              NONEW)
                        I1JL = (L-1)*NJ+J
*.CB(IA,KB,jl) = +/-C(IA,a+la+jIA)
                        JLOFF = (JLBOFF-1+IJL-1)*NKBTC*NIBTC+1
                        IF(JLSM.EQ.1.AND.J.EQ.L) THEN
*. a+j a+j gives trivially zero
                          ZERO = 0.0D0
                          CALL SETVEC(CSCR(JLOFF),ZERO,NKBTC*NIBTC)
                        ELSE
                          CALL MATCG(    CB,CSCR(JLOFF),NROW,NIBTC,IBOT,
     &                                NKBTC,I1(1,I1JL),XI1S(1,I1JL))
                        END IF
                      END DO
*
                      JLBOFF = JLBOFF + NJL
                    END DO
*
*. ( End of loop over jlpair in batch )
*==============================================
*. SSCR(I,K,ik) = CSR(I,K,jl)*((ij!kl)-(il!jk))
*===============================================
*.Obtain two electron integrals xint(ik,jl) = (ij!kl)-(il!kj)
                    IF(IFIRST.EQ.1) THEN
                      IXCHNG = 1
* Obtain integrals in ik batch
                      NIKT = IKBT(3,IKBTC)
                      NJLT = JLBT(3,JLBTC)
                      JLOFF = 1
                      DO JLPAIR = 1, JLBT(2,JLBTC)
                      IKOFF = 1
                      DO IKPAIR = 1, IKBT(2,IKBTC)
*
                        ISM = IKSMBT(1,IKBT(1,IKBTC)-1+IKPAIR)
                        KSM = IKSMBT(2,IKBT(1,IKBTC)-1+IKPAIR)
                        JSM = JLSMBT(1,JLBT(1,JLBTC)-1+JLPAIR)
                        LSM = JLSMBT(2,JLBT(1,JLBTC)-1+JLPAIR)
*
                        IF(ISM.EQ.KSM.AND.ITYP.EQ.KTYP) THEN
                          IKSM = 1
                          NIK =
     &                    NOBPTS(ITYP,ISM)*(NOBPTS(ITYP,ISM)+1)/2
                        ELSE
                          IKSM = 0
                          NIK =
     &                    NOBPTS(ITYP,ISM)*NOBPTS(KTYP,KSM)
                        END IF
*
                        IF(JSM.EQ.LSM.AND.JTYP.EQ.LTYP) THEN
                          JLSM = 1
                          NJL =
     &                    NOBPTS(JTYP,JSM)*(NOBPTS(JTYP,JSM)+1)/2
                        ELSE
                          JLSM = 0
                          NJL =
     &                    NOBPTS(JTYP,JSM)*NOBPTS(LTYP,LSM)
                        END IF
* ================================================================
*. Required form of integrals : Coulomb - Exchange of just Coulomb
* ================================================================
                        ICOUL = 0
*. Use coulomb - exchange
                        IXCHNG = 1
*. fetch integrals
*. Full conjugation symmetry, do do not worry
*                       CALL GETINT(   SCR,  ITYP,   ISM,  JTYP,   JSM,
                        CALL GETINT(Work(ipSCR),
     &                                       ITYP,   ISM,  JTYP,   JSM,
     &                                KTYP,   KSM,  LTYP,   LSM,IXCHNG,
     &                                IKSM,  JLSM, ICOUL)
*                       ^ End if similarity transformed Hamiltonian is
*                         used
                        DO JL = 1, NJL
*                         CALL COPVEC(SCR((JL-1)*NIK+1),
                          CALL COPVEC(Work((JL-1)*NIK+ipSCR),
     &                         XINT((JLOFF-1+JL-1)*NIKT+IKOFF),NIK)
                        END DO
                        IKOFF = IKOFF + NIK
                      END DO
                      JLOFF = JLOFF + NJL
                      END DO
                    END IF
*                   ^ End if integrals should be fetched
                    IFIRST = 0
*.and now ,to the work
                    LIKB = NIBTC*NKBTC
                    IF(NTEST.GE.3000) THEN
                     WRITE(6,*) ' Integral block '
                     CALL WRTMAT(XINT,NIKT,NJLT,NIKT,NJLT)
                    END IF
                    IF(NTEST.GE.3000) THEN
                      WRITE(6,*) ' CSCR matrix '
                      CALL WRTMAT(CSCR,LIKB,NJLT,LIKB,NJLT)
                    END IF
*
C?                  MXACIJO = MXACIJ
c                    MXACIJ = MAX(MXACIJ,LIKB*NJLT,LIKB*NIKT)
C?                  IF(MXACIJ.GT.MXACIJO) THEN
C?                    write(6,*) ' New max MXACIJ = ', MXACIJ
C?                    write(6,*) ' ISCTP,ICCTP', ISCTP,ICCTP
C?                    WRITE(6,*) ' ITYP,JTYP,KTYP,LTYP',
C?   &                             ITYP,JTYP,KTYP,LTYP
C?                    WRITE(6,*)'NIJT, NJLT, NIBTC NKBTC',
C?   &                           NIJT, NJLT,NIBTC,NKBTC
C?                  END IF
*
                    FACTORC = 0.0D0
                    FACTORAB = 1.0D0
                    CALL MATML7(   SSCR,   CSCR,   XINT,   LIKB,   NIKT,
     &                             LIKB,   NJLT,   NIKT,   NJLT,FACTORC,
     &                          FACTORAB,     2)
                    IF(NTEST.GE.3000) THEN
                      WRITE(6,*) ' SSCR matrix '
                      CALL WRTMAT(SSCR,LIKB,NIKT,LIKB,NIKT)
                    END IF
* ============================
* Loop over ik and scatter out
* ============================
*. Generate double excitations from K strings
*. I strings connected with K strings in batch <I!a+i a+k!K)
                    II12 = 2
*
                    IONE = 1
                    IKBOFF = 1
                    DO IKPAIR = 1, IKBT(2,IKBTC)
                      ISM = IKSMBT(1,IKBT(1,IKBTC)-1+IKPAIR)
                      KSM = IKSMBT(2,IKBT(1,IKBTC)-1+IKPAIR)
                      NI = NOBPTS(ITYP,ISM)
                      NK = NOBPTS(KTYP,KSM)
                      IF(ISM.EQ.KSM.AND.ITYP.EQ.KTYP) THEN
                        NIK = NI*(NI+1)/2
                        IKSM = 1
                      ELSE
                        NIK = NI * NK
                        IKSM = 0
                      END IF
                      IF(IFRST.EQ.1) KFRST = 1
                      ONE = 1.0D0
*
                      IAC = I4_AC(1)
                      KAC = I4_AC(2)
*
                      CALL ADAADAST_GAS( IONE,  ISM, ITYP,   NI,  IAC,
     &                                   IONE,  KSM, KTYP,   NK,  KAC,
     &                                  ISCTP,ISCSM, IGRP, KBOT, KTOP,
     &                                     I1, XI1S, MAXK,NKBTC, KEND,
     &                                  IFRST,
*
     &                                  KFRST,
     &                                   II12,
     &                                    K12,
     &                                  ONE         )
*
                      IFRST = 0
                      KFRST = 0
*
                      I = 0
                      K = 1
                      DO IK = 1, NIK
                        CALL NXTIJ(     I,     K,    NI,    NK,  IKSM,
     &                              NONEW)
                        IKOFF = (K-1)*NI + I
                        ISBOFF = 1+(IKBOFF-1+IK-1)*NIBTC*NKBTC
                        IF(IKSM.EQ.1.AND.I.EQ.k) THEN
* a+ i a+i gives trivially zero
                        ELSE
                         CALL MATCAS(SSCR(ISBOFF),SB,NIBTC,NROW,IBOT,
     &                                NKBTC,I1(1,IKOFF),XI1S(1,IKOFF))
                        END IF
                      END DO
                      IKBOFF = IKBOFF + NIK
*
                    END DO
*                   ^ End of loop over IKPAIRS in batch
*
                  IF(KEND.EQ.0) GOTO 1800
*.                ^ End of loop over partitionings of resolution strings
 1801           CONTINUE
*               ^ End of loop over partionings of I strings
 1930         CONTINUE
*             ^ End of loop over batches of JL
 1940       CONTINUE
*           ^ End of loop over batches of IK
 1950     CONTINUE
*         ^ End of loop over IKOBSM
*
*      ==============================================
        ELSE IF(.NOT.( I4_AC(1).EQ. I4_AC(2)) ) THEN
*      ==============================================
*
*
* Three types of operators :
* a+ a  a+ a
* a+ a  a  a+
* a  a+ a+ a
*
* The first end up with
* -a+ i ak a+l aj X2(ik,jl)
*
* Number two and three end up with
* -a i a k a l aj XC(ik,jl)  ( In coulomb form)
*
          JLSM = 0
          IKSM = 0
*. Symmetry of allowed Double excitation,loop over excitations
          DO 2950 IKOBSM = 1, NSMOB
            JLOBSM = SXDXSX(IKOBSM,IDXSM)
            IF(JLOBSM.EQ.0) GOTO 2950
*. types + symmetries defined => K strings are defined
            KFRST = 1
            DO ISM = 1, NSMOB
              KSM = ADSXA(ISM,IKOBSM)
              DO JSM = 1, NSMOB
                LSM = ADSXA(JSM,JLOBSM)
                IF(NTEST.GE.2000) WRITE(6,*) ' ISM KSM LSM JSM',
     &          ISM,KSM,LSM,JSM
                ISCR(I4_REO(1)) = ISM
                ISCR(I4_REO(2)) = KSM
                ISCR(I4_REO(3)) = LSM
                ISCR(I4_REO(4)) = JSM
*
                ISM_ORIG = ISCR(1)
                KSM_ORIG = ISCR(2)
                LSM_ORIG = ISCR(3)
                JSM_ORIG = ISCR(4)
*
C           DO ISM_ORIG = 1, NSMOB
C             KSM_ORIG = ADSXA(ISM_ORIG,IKOBSM)
C             DO JSM_ORIG = 1, NSMOB
C               LSM_ORIG = ADSXA(JSM_ORIG,JLOBSM)
*
C               ISCR(1) = ISM_ORIG
C               ISCR(2) = KSM_ORIG
C               ISCR(3) = LSM_ORIG
C               ISCR(4) = JSM_ORIG
*
C               ISM = ISCR(I4_REO(1))
C               KSM = ISCR(I4_REO(2))
C               LSM = ISCR(I4_REO(3))
C               JSM = ISCR(I4_REO(4))
*
                NI = NOBPTS(ITYP,ISM)
                NJ = NOBPTS(JTYP,JSM)
                NK = NOBPTS(KTYP,KSM)
                NL = NOBPTS(LTYP,LSM)
                NIK = NI*NK
                NJL = NJ*NL
                IF(NIK.EQ.0.OR.NJL.EQ.0) GOTO 2803
*
                ITPSM_ORIG = (ITYP_ORIG-1)*NSMOB + ISM_ORIG
                JTPSM_ORIG = (JTYP_ORIG-1)*NSMOB + JSM_ORIG
                KTPSM_ORIG = (KTYP_ORIG-1)*NSMOB + KSM_ORIG
                LTPSM_ORIG = (LTYP_ORIG-1)*NSMOB + LSM_ORIG
*
                IF(ITPSM_ORIG.GE.KTPSM_ORIG.AND.
     &             JTPSM_ORIG.GE.LTPSM_ORIG) THEN
*
                IFIRST = 1
*. Loop over batches of I strings
                DO 2801 IIPART = 1+MYRANK, NPART, NPROCS
                  IBOT = 1+(IIPART-1)*NPARTSZ
                  ITOP = MIN(IBOT+NPARTSZ-1,NROW)
                  NIBTC = ITOP-IBOT+1
                  IF (NIBTC.LE.0) EXIT
*.Loop over batches of intermediate strings
                  KBOT = 1- MAXK
                  KTOP = 0
 2800             CONTINUE
                    KBOT = KBOT + MAXK
                    KTOP = KTOP + MAXK
*
*. obtain cb(KB,IA,jl) = sum(JB)<KB!a lb a jb !IB>C(IA,JB)
*
*. Obtain all double excitations from this group of K strings
                    II12 = 1
                    K12 = 1
                    IONE = 1
*. Creation / annihilation maps , conjugated of above
                    IF(I4_AC(4).EQ.1) THEN
                      JAC = 2
                    ELSE
                      JAC = 1
                    END IF
                    IF(I4_AC(3).EQ.1) THEN
                      LAC = 2
                    ELSE
                      LAC = 1
                    END IF
C                   KFRST = 1
                    CALL ADAADAST_GAS( IONE,  JSM, JTYP,   NJ,  JAC,
     &                                 IONE,  LSM, LTYP,   NL,  LAC,
     &                                ICCTP,ICCSM, IGRP, KBOT, KTOP,
     &                                   I1, XI1S, MAXK,NKBTC, KEND,
     &                                JFRST,KFRST, II12,  K12,SCLFAC)
*
                    JFRST = 0
                    KFRST = 0
*
                    IF(NKBTC.EQ.0) GOTO 2801
*. Loop over jl in TS classes and gather
                    J = 0
                    L = 1
                    DO  IJL = 1, NJL
                      CALL NXTIJ(     J,     L,    NJ,    NL,  JLSM,
     &                            NONEW)
                      I1JL = (L-1)*NJ+J
*.CB(IA,KB,jl) = +/-C(IA,a+la+jIA)
                      JLOFF = (IJL-1)*NKBTC*NIBTC+1
                      CALL MATCG(    CB,CSCR(JLOFF),NROW,NIBTC,IBOT,
     &                            NKBTC,I1(1,I1JL),XI1S(1,I1JL))
                    END DO
*
*==============================================
*. SSCR(I,K,ik) = CSR(I,K,jl)*((ij!kl)-(il!jk))
*===============================================
*.Obtain two electron integrals as xint(ik,jl) = (ij!kl)-(il!kj)
                    IKSM = 0
                    JLSM = 0
                    IF(IFIRST.EQ.1) THEN
                      IF(I4_AC(1).EQ.I4_AC(3)) THEN
* a+ a a+ a
                        ICOUL = 2
                      ELSE
* a+ a a a+ or a+ a a a+
                        ICOUL = 1
                      END IF
*. Use coulomb - exchange or just coulomb integrals ?
                      IF(ITPSM_ORIG.EQ.KTPSM_ORIG
     &                .AND.JTPSM_ORIG.EQ.LTPSM_ORIG)THEN
*. No use of exchange
                        IXCHNG = 0
                        FACX = -0.5D0
                      ELSE IF(ITPSM_ORIG.NE.KTPSM_ORIG
     &                .OR.JTPSM_ORIG.NE.LTPSM_ORIG) THEN
*. Exchange used, combines two terms
                        IXCHNG = 1
                        FACX = -0.5D0
                      END IF
                      IF(ITPSM_ORIG.NE.KTPSM_ORIG
     &                .AND.JTPSM_ORIG.NE.LTPSM_ORIG)THEN
*. Exchange used, combines four terms
                        IXCHNG = 1
                        FACX = -1.0D0
                      END IF
           IF( NTEST.GE.1000) WRITE(6,*)
     &   ' ITPSM_ORIG,KTPSM_ORIG,JTPSM_ORIG,LTPSM_ORIG,FACX',
     &     ITPSM_ORIG,KTPSM_ORIG,JTPSM_ORIG,LTPSM_ORIG,FACX
*. fetch integrals
* we want the operator in the form a+i ak a+l aj ((ij!lk)-(ik!lj))
                      IF(ICOUL.EQ.2) THEN
*. Obtain X2(ik,lj) = (ij!lk)
                      CALL GETINT(  XINT,  ITYP,   ISM,  JTYP,   JSM,
     &                              LTYP,   LSM,  KTYP,   KSM,IXCHNG,
     &                              IKSM,  JLSM, ICOUL)
                      ELSE IF (ICOUL.EQ.1) THEN
                        CALL GETINT(  XINT,  ITYP,   ISM,  KTYP,   KSM,
     &                                JTYP,   JSM,  LTYP,   LSM,IXCHNG,
     &                                IKSM,  JLSM, ICOUL)
                      END IF
*
                    END IF
*                   ^ End if integrals should be fetched
                    IFIRST = 0
*.and now ,to the work
                    LIKB = NIBTC*NKBTC
                    IF(NTEST.GE.3000) THEN
                     WRITE(6,*) ' Integral block '
                     CALL WRTMAT(XINT,NIK,NJL,NIK,NJL)
                    END IF
                    IF(NTEST.GE.3000) THEN
                      WRITE(6,*) ' CSCR matrix '
                      CALL WRTMAT(CSCR,LIKB,NJL,LIKB,NJL)
                    END IF
*
C?                  MXACIJO = MXACIJ
c                    MXACIJ = MAX(MXACIJ,LIKB*NJL,LIKB*NIK)
C?                  IF(MXACIJ.GT.MXACIJO) THEN
C?                    write(6,*) ' New max MXACIJ = ', MXACIJ
C?                    write(6,*) ' ISCTP,ICCTP', ISCTP,ICCTP
C?                    WRITE(6,*) ' ITYP,JTYP,KTYP,LTYP',
C?   &                             ITYP,JTYP,KTYP,LTYP
C?                    WRITE(6,*)'NIJ NJL NIBTC NKBTC',
C?   &                           NIJ,NJL,NIBTC,NKBTC
C?                  END IF
*
                    FACTORC = 0.0D0
                    FACTORAB = FACX
                    CALL MATML7(   SSCR,   CSCR,   XINT,   LIKB,    NIK,
     &                             LIKB,    NJL,    NIK,    NJL,FACTORC,
     &                          FACTORAB,     2)
                    IF(NTEST.GE.3000) THEN
                      WRITE(6,*) ' SSCR matrix '
                      CALL WRTMAT(SSCR,LIKB,NIK,LIKB,NIK)
                    END IF
* ============================
* Loop over ik and scatter out
* ============================
*. Generate double excitations from K strings
*. I strings connected with K strings in batch <I!a+i a+k!K)
                    II12 = 2
*
                    IONE = 1
                    IF(IFRST.EQ.1) KFRST = 1
                    ONE = 1.0D0
*
                    IAC = I4_AC(1)
                    KAC = I4_AC(2)
*
C                   KFRST = 1
                    CALL ADAADAST_GAS( IONE,  ISM, ITYP,   NI,  IAC,
     &                                 IONE,  KSM, KTYP,   NK,  KAC,
     &                                ISCTP,ISCSM, IGRP, KBOT, KTOP,
     &                                   I1, XI1S, MAXK,NKBTC, KEND,
     &                                IFRST,
*
     &                                KFRST,
     &                                 II12,
     &                                  K12,
     &                                ONE          )
*
                    IFRST = 0
                    KFRST = 0
*
                    I = 0
                    K = 1
                    DO IK = 1, NIK
                      CALL NXTIJ(     I,     K,    NI,    NK,  IKSM,
     &                            NONEW)
                      IKOFF = (K-1)*NI + I
                      ISBOFF = 1+(IK-1)*NIBTC*NKBTC
                      CALL MATCAS(SSCR(ISBOFF),SB,NIBTC, NROW, IBOT,
     &                             NKBTC,I1(1,IKOFF),XI1S(1,IKOFF))
                    END DO
C                   write(6,*) ' first element of updated SB', SB(1)
*
                  IF(KEND.EQ.0) GOTO 2800
*. End of loop over partitionings of resolution strings
 2801           CONTINUE
*               ^ End of loop over batches of I strings
              END IF
*             ^ End of if I. ge. K, J.ge. L
 2803         CONTINUE
              END DO
*             ^ End of loop over KSM
            END DO
*           ^ End of loop over ISM
 2950     CONTINUE
        END IF
*       ^ End of a+ a+ a a/a a a+ a+ versus a+ a a+ a switch

 2000 CONTINUE
*
 2001 CONTINUE
*
C?      WRITE(6,*) ' Memcheck at end of RSBB2A '
C?      CALL MEMCHK
C?      WRITE(6,*) ' Memcheck passed '
*
      Call Free_Work(ipSCR)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NSCOL)
        CALL Unused_integer(NSMDX)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RdTraOne
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     read the header of the transformed one-electron integral file    *
*                                                                      *
************************************************************************

#include "Molcas.fh"
#include "motra.fh"
#include "SysDef.fh"

      Integer iDisk,LuTraOne
      Integer TocTraOne(64)
      Character*(LENIN8) BsLbl(MxOrb)

      LuTraOne = 3

      Call DaName(LuTraOne,'TRAONE')

culf
      iDisk=0

      Call WR_MOTRA_Info(LuTraOne,2,iDisk,
     &                   TocTraOne,64,
     &                   EcorX,
     &                   nSymX,
     &                   nBasX,nOrbX,nFroX,nDelX,8,
     &                   BsLbl,LENIN8*MxOrb)

      Call Daclos(LuTraOne)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Jeppe Olsen                                      *
*               1989, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE WRTMAT(A,NROW,NCOL,NMROW,NMCOL)
C
C     AUTHOR: J. OLSEN, UNIV. OF LUND, SWEDEN, APRIL 1987
C     MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
C                    M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
C
C     PRINT REAL VALUED MATRIX
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NMROW,NMCOL)
C
      DO 100 I=1,NROW
         Write(6,1010) I,(A(I,J),J=1,NCOL)
100   CONTINUE
1010  FORMAT(1H0,I3,2X,4(E15.8),/,(1H ,5X,4(E15.8)))
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine import_cho(numcho_pt2,infvec_n2_pt2,maxvec_pt2)
      implicit none
#include "cholesky.fh"
      integer numcho_pt2(8), infvec_n2_pt2, maxvec_pt2
      integer i
      do i=1,nsym
        numcho_pt2(i)=numcho(i)
      end do
      do i=nsym+1,8
        numcho_pt2(i)=0
      end do
      maxvec_pt2=maxvec
      infvec_N2_pt2=infvec_N2
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine bspset2_cvb(ikcoff,nel,kbasis,need)
      implicit real*8 (a-h,o-z)
#include "frag_cvb.fh"
      dimension ikcoff(0:nel,0:nel,0:nel)

      do 100 ifrag=1,nfrag
      do 101 ion=mnion_fr(ifrag),mxion_fr(ifrag)
      nelsing=nel_fr(ifrag)-2*ion
      if(nelsing.lt.0)goto 101
      do 200 iMs=1,nMs_fr(ifrag)
      nalfsing=nalf_fr(iMs,ifrag)-ion
      if(nalfsing.lt.0)goto 200
      do 300 iS=1,nS_fr(ifrag)
      if(i2s_fr(iS,ifrag).le.nelsing.and.
     >  i2s_fr(iS,ifrag).ge.2*nalfsing-nelsing)
     >  ikcoff(nelsing,nalfsing,i2S_fr(iS,ifrag))=1
300   continue
200   continue
101   continue
100   continue
      need=0
      do 400 nel1=0,nel
      do 401 nalf1=0,nel
      do 402 i2s1=0,nel
      if(ikcoff(nel1,nalf1,i2s1).eq.1)then
        ikcoff(nel1,nalf1,i2s1)=need
        nalf1_spin=(nel1+i2s1)/2
        need=need+ifns_cvb(nel1,nalf1_spin,kbasis)*ndet_cvb(nel1,nalf1)
      endif
402   continue
401   continue
400   continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Conj_Grad(Done,lVector,Prec,X,XTemp,R,RTemp,
     &                     P,PTemp,Z,ZTemp,AP,Tolerance,res)
*
************************************************************************
*
*   Purpose: Takes one step in a PCG algorithm. The preconditioner has
*            to be diagonal at the moment.
*
*   Algorithm: (Ref: Kolla upp referensen)
*
*   Initial values:         suggestions to make it work:
*   x1 = x1                 x1 = 0
*   r1 = b-A*x_1            r1 = b
*   p1 = p1                 p1 = r1
*   z1 = (A_pre)^-1 * r1    z1 = (diag(A))^-1 * r1
*
*
*   CG-iterations
*   alfa  = (r_k * z_k) / (p_k * [A * p_k])
*   x_k+1 = x_k + alfa * p_k
*   r_k+1 =  r_k - alfa * [A * p_k]
*   beta  = (r_k+1 * z_k+1) / (r_k * z_k)
*   p_k+1 =  z_k+1 + Beta * p_k
*
*   Apart from a check for convergence, that is all of it.
*
************************************************************************
*
*  Parameters:
*
*  Done:        A logical parameter that decides if there is
*               convergence
*
*
*  ipX:         A pointer to the workspace with a value for x_k which
*               will be overwritten with x_k+1.
*
*  ipXtemp:     A pointer to a temporary scratch vector which will be
*               used to replace X. If its defined outside the routine
*               a lot of allocating and deallocating is avoided.
*
*  ipR:         A pointer to the workspace with a value for r_k which
*               will be overwritten with r_k+1.
*
*  ipXtemp:     A pointer to a temporary scratch vector which will be
*               used to replace R.
*
*  ipP:         A pointer to the workspace with a value for p_k which
*               will be overwritten with p_k+1.
*
*  ipPtemp:     A pointer to a temporary scratch vector which will be
*               used to replace P.
*
*  lVector:     The vectorial dimension of the problem. A is
*               assumed to be a square matrix.
*
*  ipPrec:      A diagonal preconditioner.
*
*  ipAP:        A pointer to a vector containing the product of A and P.
*               The reason for not specifying A is that the dimension may
*               be too big to keep in the workspace.
*
*  Res:         Returns the norm of the residual. Can be useful for the
*               user to make a judgement call if the procedure does not
*               converge below the tolerance.
*
****************************************************************************
*

      Implicit Real*8 (a-h,o-z)
*
      Logical Done
      Real*8  Z(1:lVector), ZTemp(1:lVector),AP(1:lVector)
      Real*8  Prec(1:lVector),X(1:lVector),XTemp(1:lVector)
      Real*8  R(1:lVector), RTemp(1:lVector),P(1:lVector)
      Real*8  PTemp(1:lVector)

*     Copy the vectors into the temporary ones. ipXTemp, ipRTemp etc. will
*     then contain x_k, r_k etc.
      call dcopy_(lVector,X(1),1,XTemp(1),1)
      call dcopy_(lVector,R(1),1,RTemp(1),1)
      call dcopy_(lVector,P(1),1,PTemp(1),1)
      call dcopy_(lVector,Z(1),1,ZTemp(1),1)
*
*     Now we calculate Alfa = (r_k * z_k) / (p_k * [A * p_k])
      Alfa = ddot_(lVector,RTemp(1),1,ZTemp(1),1)/
     &       ddot_(lVector,PTemp(1),1,AP(1),1)
*
*     Now we calculate x_k+1 = x_k + alfa * p_k
*
      call daxpy_(lVector,Alfa,PTemp(1),1,X(1),1)
*
*     Now we calculate r_k+1 = r_k - alfa * [A * p_k]
      call daxpy_(lVector,-Alfa,AP(1),1,R(1),1)
*
*     At this point we can both see if we are done and
      Res = sqrt(ddot_(lVector,R(1),1,R(1),1))
      if(Res.lt.Tolerance) then
         Done = .true.
         goto 100
      End If
*
*     Now we calculate z_k+1 =
      Do i = 1, lVector
         Z(i) = R(i)*Prec(i)
      EndDo
*
*     Now we calculate beta = (r_k+1 * z_k+1) / (r_k * z_k)
      Beta = ddot_(lVector,R(1),1,Z(1),1)/
     &       ddot_(lVector,RTemp(1),1,ZTemp(1),1)
*
*     Now we calculate P_k+1
      call dcopy_(lVector,Z(1),1,P(1),1)
      call daxpy_(lVector,Beta,PTemp(1),1,P(1),1)
*

 100  Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE VECSMDP(    VEC1,    VEC2,    FAC1,    FAC2,     LU1,
     &                        LU2,     LU3,    IREW,    LBLK)
C
C DISC VERSION OF VECSUM :
C
C      ADD BLOCKED VECTORS ON FILES LU1 AND LU2
C      AND STORE ON LU3
*
* Packed version, May 1996
C
C LBLK DEFINES STRUCTURE OF FILE
C
      IMPLICIT REAL*8(A-H,O-Z)
#include "io_util.fh"
      DIMENSION VEC1(*),VEC2(*)
      DIMENSION IDUMMY(1)
C
      IF(IREW .NE. 0 ) THEN
        IDISK(LU1)=0
        IDISK(LU2)=0
        IDISK(LU3)=0
      END IF
C
C LOOP OVER BLOCKS OF VECTOR
C
 1000 CONTINUE
C
        IF( LBLK .GT. 0 ) THEN
          NBL1 = LBLK
          NBL2 = LBLK
        ELSE IF(LBLK .EQ. 0 ) THEN
          CALL IDAFILE(LU1,2,IDUMMY,1,IDISK(LU1))
          NBL1=IDUMMY(1)
          CALL IDAFILE(LU2,2,IDUMMY,1,IDISK(LU2))
          NBL2=IDUMMY(1)
          CALL IDAFILE(LU3,1,[NBL1],1,IDISK(LU3))
        ELSE IF (LBLK .LT. 0 ) THEN
          CALL IDAFILE(LU1,2,IDUMMY,1,IDISK(LU1))
          NBL1=IDUMMY(1)
          CALL IDAFILE(LU1,2,IDUMMY,1,IDISK(LU1))
          CALL IDAFILE(LU2,2,IDUMMY,1,IDISK(LU2))
          NBL2=IDUMMY(1)
          CALL IDAFILE(LU2,2,IDUMMY,1,IDISK(LU2))
          CALL IDAFILE(LU3,1,[NBL1],1,IDISK(LU3))
          CALL IDAFILE(LU3,1,[-1],1,IDISK(LU3))
        END IF
        IF( NBL1 .NE. NBL2 ) THEN
        WRITE(6,'(A,2I5)') 'DIFFERENT BLOCKSIZES IN VECSMD ',
     &  NBL1,NBL2
*       STOP ' INCOMPATIBLE BLOCKSIZES IN VECSMF '
        CALL SYSABENDMSG('lucia_util/vecsmf','Different block sizes',
     &                   ' ')
      END IF
C
      IF(NBL1 .GE. 0 ) THEN
          IF(LBLK .GE.0 ) THEN
            KBLK = NBL1
          ELSE
            KBLK = -1
          END IF
        NO_ZEROING = 1
        CALL FRMDSC2(     VEC1,     NBL1,     KBLK,      LU1,  IMZERO1,
     &                 IAMPACK,NO_ZEROING)
        CALL FRMDSC2(     VEC2,     NBL1,     KBLK,      LU2,  IMZERO2,
     &                 IAMPACK,NO_ZEROING)
        IF( NBL1 .GT. 0 ) THEN
          IF(IMZERO1.EQ.1.AND.IMZERO2.EQ.1) THEN
*. Simple zero record
            CALL ZERORC(NBL1,LU3,IAMPACK)
          ELSE
*. Nonvanishing record
            ZERO = 0.0D0
            IF(IMZERO1.EQ.1) THEN
              CALL VECSUM(    VEC1,    VEC1,    VEC2,    ZERO,    FAC2,
     &                        NBL1)
            ELSE IF(IMZERO2.EQ.1) THEN
              CALL VECSUM(    VEC1,    VEC1,    VEC2,    FAC1,    ZERO,
     &                        NBL1)
            ELSE
              CALL VECSUM(    VEC1,    VEC1,    VEC2,    FAC1,    FAC2,
     &                        NBL1)
            END IF
            CALL TODSCP(VEC1,NBL1,KBLK,LU3)
          END IF
        ELSE IF (NBL1.EQ.0) THEN
          CALL TODSCP(VEC1,NBL1,KBLK,LU3)
        END IF
      END IF
C
      IF(NBL1.GE. 0 .AND. LBLK .LE. 0) GOTO 1000
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADADST_GAS(IOB,IOBSM,IOBTP,NIOB,JOB,JOBSM,JOBTP,NJOB,ISPGP,ISM,ITP,KMIN,KMAX,I1,XI1S,LI1,NK,IEND,IFRST,KFRST,I12,K12, &
                      SCLFAC)
! Obtain mappings
! a+IORB a+ JORB !KSTR> = +/-!ISTR>
! In the form
! I1(KSTR) =  ISTR if a+IORB a+ JORB !KSTR> = +/-!ISTR>, ISTR is in
! ISPGP,ISM,IGRP.
! (numbering relative to TS start)
! Only excitations IOB >= JOB are included
! The orbitals are in GROUP-SYM IOBTP,IOBSM, JOBTP,JOBSM respectively,
! and IOB (JOB) is the first orbital to be used, and the number of orbitals
! to be checked is NIOB (NJOB).
!
! Only orbital pairs IOB > JOB are included
!
! The output is given in I1(KSTR,I,J) = I1 ((KSTR,(J-1)*NIOB + I)
!
! Above +/- is stored in XI1S
! Number of K strings checked is returned in NK
! Only Kstrings with relative numbers from KMIN to KMAX are included
!
! If IEND /= 0 last string has been checked
!
! Jeppe Olsen, August of 95

use Symmetry_Info, only: Mul
use lucia_data, only: IBSPGPFTP, IOBPTS, NELFSPGP, NELFTP, NELIS, NGAS, NOBPT, NOCOB, NSTRKS, OCSTR, REO, Z, ZSCR
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IOB, IOBSM, IOBTP, NIOB, JOB, JOBSM, JOBTP, NJOB, ISPGP, ISM, ITP, KMIN, KMAX, LI1, IFRST, KFRST, &
                                 I12, K12
integer(kind=iwp), intent(out) :: I1(LI1,NIOB*NJOB), NK, IEND
real(kind=wp), intent(out) :: XI1S(LI1,NIOB*NJOB)
real(kind=wp), intent(in) :: SCLFAC
integer(kind=iwp) :: IDUM_ARR(1), IIOB, ISPGPABS, JJOB, K1SM, K1SPGPABS, KSM, KSPGPABS, NELI, NELK, NSTRI, NSTRK

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ====================='
write(u6,*) ' ADADST_GAS in service'
write(u6,*) ' ====================='
write(u6,*)
write(u6,*) ' IOB,IOBSM,IOBTP ',IOB,IOBSM,IOBTP
write(u6,*) ' JOB,JOBSM,JOBTP ',JOB,JOBSM,JOBTP
#endif

!if (SCLFAC /= One) then
!  write(u6,*) 'Problemo, ADADST'
!  write(u6,*) ' SCLFAC = ',SCLFAC
!end if

! Internal affairs

if ((I12 > size(Z,2)) .or. (K12 > size(OCSTR,2))) then
  write(u6,*) ' ADST_GAS : Illegal value of K12 = ',K12
  write(u6,*) ' ADST_GAS : Illegal value of I12 = ',I12
  !stop ' ADST_GAS : Illegal value of I12'
  call SYSABENDMSG('lucia_util/adst_gas','Internal error','')
  return
end if

! Supergroup and symmetry of K strings

ISPGPABS = IBSPGPFTP(ITP)-1+ISPGP
call NEWTYP(ISPGPABS,1,IOBTP,K1SPGPABS)
call NEWTYP(K1SPGPABS,1,JOBTP,KSPGPABS)
K1SM = Mul(IOBSM,ISM)
KSM = Mul(JOBSM,K1SM)
#ifdef _DEBUGPRINT_
write(u6,*) ' K1SM,K1SPGPABS,KSM,KSPGPABS : ',K1SM,K1SPGPABS,KSM,KSPGPABS
#endif
! In ADADS1_GAS we need : Occupation of KSTRINGS
!                         lexical => Actual order for I strings
! Generate if required

if (IFRST /= 0) then
  ! Generate information about I strings
  ! Arc weights for ISPGP
  call WEIGHT_SPGP(Z(:,I12),NGAS,NELFSPGP(1,ISPGPABS),NOBPT,ZSCR)
  NELI = NELFTP(ITP)
  NELIS(I12) = NELI
  ! Reorder array for I strings
  call GETSTR_TOTSM_SPGP(ITP,ISPGP,ISM,NELI,NSTRI,OCSTR(:,K12),NOCOB,1,Z(:,I12),REO(:,I12))
end if
NELK = NELIS(I12)-2
if (KFRST /= 0) then
  ! Generate occupation of K STRINGS
  call GETSTR_TOTSM_SPGP(1,KSPGPABS,KSM,NELK,NSTRK,OCSTR(:,K12),NOCOB,0,IDUM_ARR,IDUM_ARR)
  NSTRKS(K12) = NSTRK
end if

NSTRK = NSTRKS(K12)

IIOB = IOBPTS(IOBTP,IOBSM)+IOB-1
JJOB = IOBPTS(JOBTP,JOBSM)+JOB-1
call ADADS1_GAS(NK,I1,XI1S,LI1,IIOB,NIOB,JJOB,NJOB,OCSTR(:,K12),NELK,NSTRK,REO(:,I12),Z(:,I12),NOCOB,KMAX,KMIN,IEND,SCLFAC)

end subroutine ADADST_GAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DIAG_R2(MATRIX,N,INFO,W,Z)
! THIS ROUTINE PERFORMS THE DIAGONALIZATION OF A Real SQUARE
! MATRIX WITH THE DIMENSION NBTOT. THE EIGENVALUES OF THE DIAGONALIZATION
! ARE DIRECTED INTO W1 AND THE Real EIGENVECTORS ARE WRITTEN TO Z1.

use Index_Functions, only: iTri, nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: MATRIX(N,N)
integer(kind=iwp), intent(out) :: INFO
real(kind=wp), intent(out) :: W(N), Z(N,N)
integer(kind=iwp) :: I, J
real(kind=wp), allocatable :: AP(:), WORK(:)

! initializations
INFO = 0
if (N < 1) return

W(:) = Zero
Z(:,:) = Zero

call mma_allocate(AP,nTri_Elem(N),'AP')
call mma_allocate(WORK,3*N,'WORK')
WORK(:) = Zero

do j=1,N
  do i=1,j
    AP(iTri(i,j)) = MATRIX(i,j)
  end do
end do
! diagonalize:
call DSPEV_('V','U',N,AP,W,Z,N,WORK,INFO)

call mma_deallocate(AP)
call mma_deallocate(WORK)

return

end subroutine DIAG_R2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DTRANS(NROWS,NCOLS,A,LDA,B,LDB)
! Copy-transpose matrix A to B using blocks to optimize cache
! usage or extended BLAS functionality if present.
! B := transpose(A)
!
! double precision version

#include "intent.fh"

#ifdef _MKL_
use Constants, only: One
#endif
use Definitions, only: wp, iwp, u6

implicit none
! arguments
integer(kind=iwp), intent(in) :: NROWS, NCOLS, LDA, LDB
real(kind=wp), intent(in) :: A(LDA,*)
real(kind=wp), intent(_OUT_) :: B(LDB,*)
! local variables
#ifndef _MKL_
integer(kind=iwp) :: I, IB, J, JB, LCOLS, LROWS, MAXCOL, MAXROW, NBLKSZ
#endif

if ((NROWS <= 0) .or. (NCOLS <= 0)) then
  write(u6,'(1X,A)') 'DTRANS: Error: invalid dimension(s)'
  write(u6,'(1X,2(A,I9))') 'NROWS = ',NROWS,'NCOLS = ',NCOLS
  call AbEnd
else if ((NROWS > LDA) .or. (NCOLS > LDB)) then
  write(u6,'(1X,A)') 'DTRANS: Error: dimension(s) out-of-bounds'
  write(u6,'(1X,2(A,I9))') 'NROWS = ',NROWS,'NCOLS = ',NCOLS
  write(u6,'(1X,2(A,I9))') 'LDA   = ',LDA,'LDB   = ',LDB
  call AbEnd
end if

#ifdef _MKL_
call mkl_domatcopy('C','T',NROWS,NCOLS,One,A,LDA,B,LDB)
#else
NBLKSZ = 8
LROWS = mod(NROWS,NBLKSZ)
LCOLS = mod(NCOLS,NBLKSZ)
MAXROW = NROWS-LROWS
MAXCOL = NCOLS-LCOLS
if ((MAXROW > 0) .and. (MAXCOL > 0)) then
  do IB=1,MAXROW,NBLKSZ
    do JB=1,MAXCOL,NBLKSZ
      do I=IB,IB+NBLKSZ-1
        do J=JB,JB+NBLKSZ-1
          B(J,I) = A(I,J)
        end do
      end do
    end do
  end do
end if
! remainder of the blocks
if ((MAXROW > 0) .and. (LCOLS > 0)) then
  do IB=1,MAXROW,NBLKSZ
    do I=IB,IB+NBLKSZ-1
      do J=MAXCOL+1,MAXCOL+LCOLS
        B(J,I) = A(I,J)
      end do
    end do
  end do
end if
if ((MAXCOL > 0) .and. (LROWS > 0)) then
  do JB=1,MAXCOL,NBLKSZ
    do I=MAXROW+1,MAXROW+LROWS
      do J=JB,JB+NBLKSZ-1
        B(J,I) = A(I,J)
      end do
    end do
  end do
end if
! remainder block
if ((LROWS > 0) .and. (LCOLS > 0)) then
  do I=MAXROW+1,MAXROW+LROWS
    do J=MAXCOL+1,MAXCOL+LCOLS
      B(J,I) = A(I,J)
    end do
  end do
end if
#endif

end subroutine DTRANS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Pavel Neogrady                                   *
************************************************************************
c
c       this package contains:
c       sumoerab
c         multstack
c         grc0stack
c         extstack
c           extstackhlp1
c
c     -----------------------------
c
      subroutine sumoverab (wrk,wrksize,
     & lunt2o1, lunt2o2, lunt2o3,nabstack,possabstack,
     & niter)
c
c     this routine realize sumation over ab
c     and calculate following contributions:
c
c     T25
c     T2n(ab,ij)aaaa   <- sum(e>f-aa) [ <ab||ef>aaaa . Tau(ef,ij)aaaa ]
c     T2n(ab,ij)bbbb   <- sum(e>f-bb) [ <ab||ef>bbbb . Tau(ef,ij)bbbb ]
c     T2n(a,b,i,j)abab <- sum(e,f-ab) [ <ab||ef>abab . Tau(ef,ij)abab ]
c
c     T28
c      Q(ab,k,l)aaaa   <= sum(e-a)    [ <ab||ke>aaaa . T1o(e,l)aa ]
c     T2n(ab,ij)aaaa   <- Q(ab,i,j)aaaa - Q(ab,j,i)aaaa
c      Q(ab,k,l)bbbb   <= sum(e-b)    [ <ab||ke>bbbb . T1o(e,l)bb ]
c     T2n(ab,ij)bbbb   <- Q(ab,i,j)bbbb - Q(ab,j,i)bbbb
c     T2n(a,b,i,j)abab <- - sum(e-a)  [ <ab||je>abba . T1o(e,i)aa ]
c        <- + sum(e-b)  [ <ab||ie>abab . T1o(e,j)bb ]
c
c     General Status:

c     1) Tau ampitudes are stored and properly mapped in V1-V3
c     V1(ij,ef)   = Tau(ef,ij)aaaa
c     V2(ij,ef)   = Tau(ef,ij)bbbb
c     V3(i,j,e,f) = Tau(e,f,i,j)abab
c
c     2) Integrals are stored in file nab
c
c     syma=1,nsym
c       symb=1,syma
c       ! one record mapdn,mapin - in all cases
c         a=1,nvb(syma)
c         if (syma.eq.symb) then
c         limb=a
c         else
c         limb=nvb(symb)
c         end if
c           b=1,limb
c             ! one record N _a_b(p,q) - if any
c           end b
c         end a
c       end sumb
c     end syma
c
c     N.B. nab musi byt dakde deklarovane (daky common)
c
c     N.B. II. in paralell.fh there are:
c     nprocab - number of nodeschoosed for 'sumoverab' part
c     idab    - array of id's of these nodes
c
        implicit none
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
#include "paralell.fh"
      INTEGER lunt2o1,lunt2o2,lunt2o3
      integer nabstack,possabstack
      integer niter
c
c     help variables
c
      INTEGER key,aeqb,yes
      INTEGER a,b,syma,symb,ssh3,ssn,ssh1
      INTEGER nlenght,posst,rc
      INTEGER lunab,nsa,nsb,limb
      integer nab,nadd
      integer idtot(1:maxproc)
c
      integer iab,nabnow,left,bstart,bstop,todo,possab,bb
      integer nhelp
c
      todo=0
      possab=possabstack
c
c
c     I.paralell
c
c     I.par.1  - escape, if this node is not reserved for sumoverab
      yes=0
      do a=1,nprocab
        if (idab(a).eq.myRank) then
c       if ((idab(a).eq.myRank).and.(ideffab(a).gt.0.0d0)) then
        yes=a
        end if
      end do
c
      if (yes.eq.0) then
      return
      end if
c
c      I.par.2 - cal overal number of ab records
      nab=0
      DO  syma=1,nsym
        DO  symb=1,syma
        IF (syma.eq.symb) THEN
        nab=nab+(nvb(syma)*(nvb(syma)+1))/2
        ELSE
        nab=nab+nvb(syma)*nvb(symb)
        END IF
      end do
      end do
c
c       I.par.3 - distribute and calc add parameter
      call sumabdistt (nab,idtot)
        nab=idtot(yes)
c        escape, if there is nothing to do on this node
        if (nab.eq.0) return
        nadd=0
        do b=1,yes-1
        nadd=nadd+idtot(b)
        end do
c
c      I.1  open nab file
c
      lunab=10
      CALL filemanager (4, lunab, rc)
c
c      I.2  prepair
c     V1(ij,ef)   = Tau(ef,ij)aaaa
c     V2(ij,ef)   = Tau(ef,ij)bbbb
c     V3(i,j,e,f) = Tau(e,f,i,j)abab
c
      CALL filemanager (2, lunt2o1, rc)
      CALL getmediate (wrk,wrksize,
     &lunt2o1, possv40, mapdv4, mapiv4, rc)
      CALL mktau (wrk,wrksize,
     &mapdv4, mapiv4, mapdt11, mapit11, mapdt12, mapit12,
     11.0d0, rc)
      CALL map (wrk,wrksize,
     &4, 3, 4, 1, 2, mapdv4, mapiv4, 1, mapdv1, mapiv1,
     1possv10, posst, rc)
c
      CALL filemanager (2, lunt2o2, rc)
      CALL getmediate (wrk,wrksize,
     &lunt2o2, possv40, mapdv4, mapiv4, rc)
      CALL mktau (wrk,wrksize,
     &mapdv4, mapiv4, mapdt11, mapit11, mapdt12, mapit12,
     11.0d0, rc)
      CALL map (wrk,wrksize,
     &4, 3, 4, 1, 2, mapdv4, mapiv4, 1, mapdv2, mapiv2,
     1possv20, posst, rc)
c
      CALL filemanager (2, lunt2o3, rc)
      CALL getmediate (wrk,wrksize,
     &lunt2o3, possv40, mapdv4, mapiv4, rc)
      CALL mktau (wrk,wrksize,
     &mapdv4, mapiv4, mapdt11, mapit11, mapdt12, mapit12,
     11.0d0, rc)
      CALL map (wrk,wrksize,
     &4, 3, 4, 1, 2, mapdv4, mapiv4, 1, mapdv3, mapiv3,
     1possv30, posst, rc)
c
c      II   sum over ab
      DO 20 syma=1,nsym
        DO 21 symb=1,syma
        if (fullprint.ge.2) then
        write (6,*) ' SymA, SymB ',syma,symb
        end if
c
c      II.1   read mapdn,mapin
        CALL getmap (lunab, possn0, nlenght, mapdn, mapin, rc)
c
c      II.3     skip sum over a,b if N is empty
        IF (nlenght.eq.0) GO TO 21
c
c      II.4   skip sum over a,b if # of ab is zero
        IF ((nvb(syma)*nvb(symb)).eq.0) GO TO 21
c
c      II.5   def symmetry of N
        ssn=mmul(syma,symb)
c
c      II.5.1   def mapd and mapi for R1 _a,_b(j,e)aaaa = <ab||je>  (pos
        CALL grc0 (2, 0, 1, 3, 0, 0, ssn, possm10, posst, mapdr1,
     1   mapir1)
c      II.5.2   def mapd and mapi for R2 _a,_b(j,e)bbbb = <ab||je>  (pos
        CALL grc0 (2, 0, 2, 4, 0, 0, ssn, possm20, posst, mapdr2,
     1   mapir2)
c      II.5.3   def mapd and mapi for R3 _a,_b(j,e)abba = <ab||je>  (pos
        CALL grc0 (2, 0, 2, 3, 0, 0, ssn, possm30, posst, mapdr3,
     1   mapir3)
c      II.5.4   def mapd and mapi for R4 _b,_a(j,e)abba = <ba||je>  (pos
        CALL grc0 (2, 0, 2, 3, 0, 0, ssn, possm40, posst, mapdr4,
     1   mapir4)
c      II.5.5   def mapd and mapi for R5 _a,_b(j,e)abab = <ab||je>  (pos
        CALL grc0 (2, 0, 1, 4, 0, 0, ssn, possh10, posst, mapdr5,
     1   mapir5)
c      II.5.6   def mapd and mapi for R6 _b,_a(j,e)abab = <ba||je>  (pos
        CALL grc0 (2, 0, 1, 4, 0, 0, ssn, possh20, posst, mapdr6,
     1   mapir6)
c
c      II.6.1   def mapd and mapi for M1 _a,_b(ef)aaaa = <ab||ef>
        CALL grc0 (2, 1, 3, 3, 0, 0, ssn, possm10, posst, mapdm1,
     1   mapim1)
c      II.6.2   def mapd and mapi for M2 _a,_b(ef)bbbb = <ab||ef>
        CALL grc0 (2, 1, 4, 4, 0, 0, ssn, possm20, posst, mapdm2,
     1   mapim2)
c      II.6.3   def mapd and mapi for M3 _a,_b(e,f)abab = <ab||ef>
        CALL grc0 (2, 0, 3, 4, 0, 0, ssn, possm30, posst, mapdm3,
     1   mapim3)
c      II.6.4   def mapd and mapi for M4 _b,_a(e,f)abab = <ba||fe>
        CALL grc0 (2, 0, 3, 4, 0, 0, ssn, possm40, posst, mapdm4,
     1   mapim4)
c
c      II.7   def # of S orbitals in syma and symb
        nsa=nvb(syma)-nva(syma)
        nsb=nvb(symb)-nva(symb)
c
        DO 10 a=1,nvb(syma)
c
        if (fullprint.ge.3) then
        write (6,*) ' A', a
        end if
c
c      II.7     def limitations for b
          IF (syma.eq.symb) THEN
            limb=a
          ELSE
            limb=nvb(symb)
          END IF
c
c@@
cpar    for nodes, selected for sumab process:
c       1) only blank read (instead of _a_b(e,f) form lunab file for records,
c       pre-standing to the portion, that is going to be done on this node
c       2) prepair setup (def bstart,limb), if needed
c
        if (nadd.ge.limb) then
c       all cycle over b need to be skipped
          do b=1,limb
c           blank read and nothing more
            call reajalovy (lunab, nlenght, wrk(possn0))
            nadd=nadd-1
          end do
c       no setup needed
          goto 10
c
        else if (nadd.gt.0) then
c       setup first
          bstart=nadd
          if (nab.lt.(limb-bstart)) then
            limb=bstart+nab
          end if
c       part of the cycle over b need to be skipped
          do b=1,nadd
c           blank read and nothing more
            call reajalovy (lunab, nlenght, wrk(possn0))
          end do
          nadd=0
c
        else
c       nabadd musi byt 0, inak nieje dobre
c       no part of the cycle over b need to be skipped
c       only setup
          bstart=0
          if (nab.lt.limb) then
            limb=nab
          end if
        end if
c
c
c*      define conditions for reading to stack
c       bstart - lower limit of b-sumation
c       bstop  - upper limit of b-sumation
c       nabnow - actual size af stack (if=1, no stacking)
c
c*.1    initialization
cStare  bstart=0
c
c*.1    set unstacking conditions
4       bstart=bstart+1
        bstop=bstart
        nabnow=1
c
c*.2    without stacking if: 1)a=b; 2)a or b \in S; 3) nabnow.le.3
c       (N.B. it was found inconvenient to execute stacking if
c             size of stack is less then 4,or even more)
c
c       ad 1)
        if ((bstart.eq.a).and.(syma.eq.symb)) goto 6
c       ad 2)
        if ((bstart.le.nsb).or.(a.le.nsa)) goto 6
c       ad 3)
        left=limb-bstart+1
        if (syma.eq.symb) left=left-1
        if (left.le.3) goto 6
c
c*.3    set stacking conditions for real stacking
        if (left.le.nabstack) then
          nabnow=left
        else
          nabnow=nabstack
        end if
        bstop=bstart+nabnow-1
        todo=1
        possab=possabstack
c
c*.     reading to N or to stack
6       if (nabnow.eq.1) then
          CALL rea (lunab, nlenght, wrk(possn0))
        else
          do iab=1,nabnow
          CALL rea (lunab, nlenght, wrk(possabstack+(iab-1)*nlenght))
          if ((possabstack+iab*nlenght).ge.possm10) then
          end if
          end do
c         qq=wrk(possabstack)
        end if
c
c
          do 8 b=bstart,bstop
c
c      III.3       read N
cStare    CALL rea (lunab, nlenght, wrk(possn0))
c
c      III.4       def aeqb
          IF ((syma.eq.symb).and.(a.eq.b)) THEN
            aeqb=1
          ELSE
            aeqb=0
          END IF
c
c      III.5       def key
          IF ((a.gt.nsa).and.(b.gt.nsb)) THEN
            key=4
          ELSE IF ((a.gt.nsa).and.(b.le.nsb)) THEN
            key=2
          ELSE IF ((a.le.nsa).and.(b.gt.nsb)) THEN
            key=3
          ELSE
            key=1
          END IF
c
c      def yes for T25.1
          IF (syma.eq.symb) THEN
            IF (a.eq.b) THEN
              yes=0
            ELSE IF (key.eq.4) THEN
              yes=1
            ELSE
              yes=0
            END IF
          ELSE
            IF (key.eq.4) THEN
              yes=1
            ELSE
              yes=0
            END IF
          END IF
c
c
c           T25
c           T2n(ab,ij)aaaa   <- sum(e>f-aa) [ <ab||ef>aaaa . Tau(ef,ij)aaaa ]
c           T2n(ab,ij)bbbb   <- sum(e>f-bb) [ <ab||ef>bbbb . Tau(ef,ij)bbbb ]
c           T2n(a,b,i,j)abab <- sum(e,f-ab) [ <ab||ef>abab . Tau(ef,ij)abab ]
c
        if (nabnow.eq.1) then
c       AB stacking is not active
c
c      III.6       get
c           -> M1 _a,_b(ef)aaaa  = <ab||ef>
c           -> M2 _a,_b(ef)bbbb  = <ab||ef>
c           -> M3 _a,_b(e,f)abab = <ab||ef>
c           -> M4 _b,_a(e,f)abab = <ba||fe>
c           free: H1-H4 (V4 reserved for stacking)
          CALL unpackab1 (wrk,wrksize,
     &     mapdn, mapin, mapdm1, mapim1, mapdm2, mapim2,
     1     mapdm3, mapim3, mapdm4, mapim4, ssn, key, aeqb)
c
c
          IF (yes.eq.1) THEN
c      T25.1.1      H1 (ij) = V1(ij,ef) . M1 (ef)
            CALL mult (wrk,wrksize,
     &       4, 2, 2, 2, mapdv1, mapiv1, 1, mapdm1, mapim1,
     1       ssn, mapdh1, mapih1,ssh1,possh10, rc)
c      T25.1.2      T2n(ab,ij)aaaa <- 1.0d0 . H1(ij)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a-nsa, b-nsb, syma, symb, 1.0d0,
     1       mapdh1, ssn, mapdt21, mapit21, 1, rc)
          END IF
c
          IF (aeqb.eq.0) THEN
c      T25.2.1      H1 (ij) = V2(ij,ef) . M2 (ef)
            CALL mult (wrk,wrksize,
     &       4, 2, 2, 2, mapdv2, mapiv2, 1, mapdm2, mapim2,
     1       ssn, mapdh1, mapih1,ssh1,possh10, rc)
c      T25.2.2      T2n(ab,ij)bbbb <- 1.0d0 . H1(ij)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a, b, syma, symb, 1.0d0, mapdh1, ssn,
     1       mapdt22, mapit22, 1, rc)
          END IF
c
          IF ((key.eq.2).or.(key.eq.4)) THEN
c      T25.3.1      H1 (i,j) = V3(i,j,e,f) . M3 (e,f)
            CALL mult (wrk,wrksize,
     &       4, 2, 2, 2, mapdv3, mapiv3, 1, mapdm3, mapim3,
     1       ssn, mapdh1, mapih1,ssh1,possh10, rc)
c      T25.3.2      T2n(a,b,i,j)abab <- 1.0d0 . H1(i,j)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a-nsa, b, syma, symb, 1.0d0, mapdh1,
     1       ssn, mapdt23, mapit23, 1, rc)
          END IF
c
          IF (((key.eq.3).or.(key.eq.4)).and.(aeqb.eq.0)) THEN
c      T25.3.3      H1 (i,j) = V3(i,j,e,f) . M4 (e,f)
            CALL mult (wrk,wrksize,
     &       4, 2, 2, 2, mapdv3, mapiv3, 1, mapdm4, mapim4,
     1       ssn, mapdh1, mapih1,ssh1,possh10, rc)
c
c      T25.3.4      T2n(a,b,i,j)abab <- 1.0d0 . H1(i,j)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, b-nsb, a, symb, syma, 1.0d0, mapdh1,
     1       ssn, mapdt23, mapit23, 1, rc)
          END IF
c
c
        else
c       AB stacking is active
c
          if (todo.eq.1) then
c         once it need to be done
          todo=0
c
c      III.6       get
c           -> M1 _a,_b(ef)aaaa  = <ab||ef>
c           -> M2 _a,_b(ef)bbbb  = <ab||ef>
c           -> M3 _a,_b(e,f)abab = <ab||ef>
c           -> M4 _b,_a(e,f)abab = <ba||fe>
c           free: H1-H4 (V4 reserved for stacking)
c
c
c       def mapd and mapi for V4 _a,(ef,Bp)
       call grc0stack (nabnow,1,3,3,3,0,ssn,possv40,posst,mapdv4,mapiv4)
c           -> V4 _a,_b(ef)aaaa  = <ab||ef>
       call unpackab3 (wrk,wrksize,
     &      mapdn,mapin,mapdv4,mapiv4,ssn,nabnow,possabstack,nlenght,1)
c
c      T25.1.1      H2 (ij,Bp) = V1(ij,ef) . V4 (ef,Bp)
        call multstack (wrk,wrksize,
     &                  mapdv1,mapdv4,mapdh2,mapiv1,mapiv4,mapih2,
     &                  1,ssn,possh20,nabnow)

c       def mapd and mapi for H1 _a,_b(ij)aa
        call grc0 (2,1,1,1,0,0,ssn,possh10,posst,mapdh1,mapih1)
        do bb=bstart,bstop
c      T25.1.2      ext H1(ij) <- H2(ij,_Bb) (only data transfer)
        call extstack (wrk,wrksize,
     &                 mapdh1,mapdh2,(bb-bstart+1),nabnow)
c      T25.1.3      T2n(ab,ij)aaaa <- 1.0d0 . H1(ij)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a-nsa, bb-nsb, syma, symb, 1.0d0,
     1       mapdh1, ssn, mapdt21, mapit21, 1, rc)
        end do
c
c
c
c       def mapd and mapi for V4 _a,(ef,Bp)
       call grc0stack (nabnow,1,4,4,4,0,ssn,possv40,posst,mapdv4,mapiv4)
c           -> V4 _a,_b(ef)bbbb  = <ab||ef>
       call unpackab3 (wrk,wrksize,
     &      mapdn,mapin,mapdv4,mapiv4,ssn,nabnow,possabstack,nlenght,2)
c
c      T25.2.1      H2 (ij,Bp) = V2(ij,ef) . V4 (ef,Bp)
        call multstack (wrk,wrksize,
     &                  mapdv2,mapdv4,mapdh2,mapiv2,mapiv4,mapih2,
     &                  1,ssn,possh20,nabnow)
c
c       def mapd and mapi for H1 _a,_b(ij)bb
        call grc0 (2,1,2,2,0,0,ssn,possh10,posst,mapdh1,mapih1)
        do bb=bstart,bstop
c      T25.2.2      ext H1(ij) <- H2(ij,Bb)
        call extstack (wrk,wrksize,
     &                 mapdh1,mapdh2,(bb-bstart+1),nabnow)
c      T25.2.3      T2n(ab,ij)bbbb <- 1.0d0 . H1(ij)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a, bb, syma, symb, 1.0d0, mapdh1, ssn,
     1       mapdt22, mapit22, 1, rc)
        end do
c
c
c
c       def mapd and mapi for V4 _a,(ef,Bp)
       call grc0stack (nabnow,0,3,4,4,0,ssn,possv40,posst,mapdv4,mapiv4)
c           -> V4 _a,_b(e,f)abab = <ab||ef>
       call unpackab3 (wrk,wrksize,
     &      mapdn,mapin,mapdv4,mapiv4,ssn,nabnow,possabstack,nlenght,3)
c
c      T25.3.1      H2 (i,j,Bp) = V3(i,j,e,f) . V4 (e,f,Bp)
        call multstack (wrk,wrksize,
     &                  mapdv3,mapdv4,mapdh2,mapiv3,mapiv4,mapih2,
     &                  1,ssn,possh20,nabnow)
c
c       def mapd and mapi for H1 _a,_b(ij)ab
        call grc0 (2,0,1,2,0,0,ssn,possh10,posst,mapdh1,mapih1)
        do bb=bstart,bstop
c      T25.3.2      ext H1(i,j) <- H2(ij,Bb)
        call extstack (wrk,wrksize,
     &                 mapdh1,mapdh2,(bb-bstart+1),nabnow)
c      T25.3.3      T2n(a,b,i,j)abab <- 1.0d0 . H1(i,j)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a-nsa, bb, syma, symb, 1.0d0, mapdh1,
     1       ssn, mapdt23, mapit23, 1, rc)
        end do
c
c
c
c       def mapd and mapi for V4 _a,(ef,Bp)
       call grc0stack (nabnow,0,3,4,3,0,ssn,possv40,posst,mapdv4,mapiv4)
c           -> V4 _b,_a(e,f)abab = <ba||fe>
       call unpackab3 (wrk,wrksize,
     &      mapdn,mapin,mapdv4,mapiv4,ssn,nabnow,possabstack,nlenght,4)
c
c      T25.3.4      H2 (i,j,Bp) = V3(i,j,e,f) . V4 (e,f,Bp)
        call multstack (wrk,wrksize,
     &                  mapdv3,mapdv4,mapdh2,mapiv3,mapiv4,mapih2,
     &                  1,ssn,possh20,nabnow)
c
c       def mapd and mapi for H1 _a,_b(ij)ab
        call grc0 (2,0,1,2,0,0,ssn,possh10,posst,mapdh1,mapih1)
        do bb=bstart,bstop
c      T25.3.5      ext H1(i,j) <- H2(i,j,Bb)
        call extstack (wrk,wrksize,
     &                 mapdh1,mapdh2,(bb-bstart+1),nabnow)
c      T25.3.6      T2n(a,b,i,j)abab <- 1.0d0 . H1(i,j)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, bb-nsb, a, symb, syma, 1.0d0, mapdh1,
     1       ssn, mapdt23, mapit23, 1, rc)
        end do
c
          end if
        end if
c
c     T28
c      Q(ab,k,l)aaaa   <= sum(e-a)    [ <ab||ke>aaaa . T1o(e,l)aa ]
c     T2n(ab,ij)aaaa   <- Q(ab,i,j)aaaa - Q(ab,j,i)aaaa
c      Q(ab,k,l)bbbb   <= sum(e-b)    [ <ab||ke>bbbb . T1o(e,l)bb ]
c     T2n(ab,ij)bbbb   <- Q(ab,i,j)bbbb - Q(ab,j,i)bbbb
c     T2n(a,b,i,j)abab <- - sum(e-a)  [ <ab||je>abba . T1o(e,i)aa ]
c        <- + sum(e-b)  [ <ab||ie>abab . T1o(e,j)bb ]
c
c
c       put appropriate data from AB_stack to N mediate, if needed
        if (nabnow.gt.1) then
c       transfer data
          do nhelp=0,nlenght-1
          wrk(possn0+nhelp)=wrk(possab+nhelp)
          end do
c       upgrade address
          possab=possab+nlenght
        end if
c
c
c      III.7       get
c           -> M1 _a,_b(j,e)aaaa = <ab||je> (map is R1)
c           -> M2 _a,_b(j,e)bbbb = <ab||je> (map is R2)
c           -> M3 _a,_b(j,e)abba = <ab||je> (map is R3)
c           -> M4 _b,_a(j,e)abba = <ba||je> (map is R4)
c           -> H1 _a,_b(j,e)abab = <ab||je> (map is R5)
c           -> H2 _b,_a(j,e)abab = <ba||je> (map is R6)
c           free: H3,H4 (V4 reserved for stacking)
c
       CALL unpackab2 (wrk,wrksize,
     & mapdn,mapin,mapdr1,mapir1,mapdr2,mapir2,mapdr3,mapir3,
     & mapdr4,mapir4,mapdr5,mapir5,mapdr6,mapir6,ssn,key,aeqb)
c
c
c     T28
c      Q(ab,k,l)aaaa   <= sum(e-a)    [ <ab||ke>aaaa . T1o(e,l)aa ]
c     T2n(ab,ij)aaaa   <- Q(ab,i,j)aaaa - Q(ab,j,i)aaaa
c      Q(ab,k,l)bbbb   <= sum(e-b)    [ <ab||ke>bbbb . T1o(e,l)bb ]
c     T2n(ab,ij)bbbb   <- Q(ab,i,j)bbbb - Q(ab,j,i)bbbb
c     T2n(a,b,i,j)abab <- - sum(e-a)  [ <ab||je>abba . T1o(e,i)aa ]
c        <- + sum(e-b)  [ <ab||ie>abab . T1o(e,j)bb ]
c
c
c      def yes for T28.1
          IF (syma.eq.symb) THEN
            IF (a.eq.b) THEN
              yes=0
            ELSE IF (key.eq.4) THEN
              yes=1
            ELSE
              yes=0
            END IF
          ELSE
            IF (key.eq.4) THEN
              yes=1
            ELSE
              yes=0
            END IF
          END IF
c
c
          IF (yes.eq.1) THEN
c      T28.1.1      H3(k,l) = M1(k,e) . T1o(e,l)aa
            CALL mult (wrk,wrksize,
     &       2, 2, 2, 1, mapdr1, mapir1, ssn, mapdt11,
     1       mapit11, 1, mapdh3, mapih3,ssh3,possh30, rc)
c      T28.1.2      H4(kl)  = H3(k,l)-H3(l,k)
            CALL fack (wrk,wrksize,
     &       2, 1, mapdh3, ssh3, mapih3, mapdh4, mapih4,
     1       possh40, rc)
c      T28.1.3      T2n(ab,ij)aaaa <- 1.0d0 H4(ij)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a-nsa, b-nsb, syma, symb, 1.0d0,
     1       mapdh4, ssn, mapdt21, mapit21, 1, rc)
          END IF
c
          IF (aeqb.eq.0) THEN
c      T28.2.1      H3(k,l) = M2(k,e) . T1o(e,l)bb
            CALL mult (wrk,wrksize,
     &       2, 2, 2, 1, mapdr2, mapir2, ssn, mapdt12,
     1       mapit12, 1, mapdh3, mapih3,ssh3,possh30, rc)
c      T28.2.2      H4(kl)  = H3(k,l)-H3(l,k)
            CALL fack (wrk,wrksize,
     &       2, 1, mapdh3, ssh3, mapih3, mapdh4, mapih4,
     1       possh40, rc)
c      T28.2.3      T2n(ab,ij)bbbb <- 1.0d0 H4(ij)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a, b, syma, symb, 1.0d0, mapdh4, ssn,
     1       mapdt22, mapit22, 1, rc)
          END IF
c
          IF ((key.eq.2).or.(key.eq.4)) THEN
c      T28.3.1      H3(j,i)  = M3(j,e) . T1o(e,i)aa
            CALL mult (wrk,wrksize,
     &       2, 2, 2, 1, mapdr3, mapir3, ssn, mapdt11,
     1       mapit11, 1, mapdh3, mapih3,ssh3,possh30, rc)
c      T28.3.2      H4(i,j)  = H3(j,i)
            CALL map (wrk,wrksize,
     &       2, 2, 1, 0, 0, mapdh3, mapih3, ssn, mapdh4,
     1       mapih4, possh40, posst, rc)
c      T28.3.3      T2n(a,b,i,j)abab <- -1.0d0 H4(i,j)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a-nsa, b, syma, symb, -1.0d0, mapdh4,
     1       ssn, mapdt23, mapit23, 1, rc)
          END IF
c
          IF (((key.eq.3).or.(key.eq.4)).and.(aeqb.eq.0)) THEN
c      T28.3.4      H3(j,i)  = M4(j,e) . T1o(e,i)aa
            CALL mult (wrk,wrksize,
     &       2, 2, 2, 1, mapdr4, mapir4, ssn, mapdt11,
     1       mapit11, 1, mapdh3, mapih3,ssh3,possh30, rc)
c      T28.3.5      H4(i,j)  = H3(j,i)
            CALL map (wrk,wrksize,
     &       2, 2, 1, 0, 0, mapdh3, mapih3, ssn, mapdh4,
     1       mapih4, possh40, posst, rc)
c      T28.3.6      T2n(a,b,i,j)abab <- -1.0d0 H4(i,j)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, b-nsb, a, symb, syma, -1.0d0, mapdh4,
     1       ssn, mapdt23, mapit23, 1, rc)
          END IF
c
          IF ((key.eq.2).or.(key.eq.4)) THEN
c      T28.3.7      H3(i,j)  = H1(i,e) . T1o(e,j)bb
            CALL mult (wrk,wrksize,
     &       2, 2, 2, 1, mapdr5, mapir5, ssn, mapdt12,
     1       mapit12, 1, mapdh3, mapih3,ssh3,possh30, rc)
c      T28.3.8      T2n(a,b,i,j)abab <- 1.0d0 H3(i,j)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, a-nsa, b, syma, symb, 1.0d0, mapdh3,
     1       ssn, mapdt23, mapit23, 1, rc)
          END IF
c
          IF (((key.eq.3).or.(key.eq.4)).and.(aeqb.eq.0)) THEN
c      T28.3.9      H3(j,i)  = H2(i,e) . T1o(e,j)bb
            CALL mult (wrk,wrksize,
     &       2, 2, 2, 1, mapdr6, mapir6, ssn, mapdt12,
     1       mapit12, 1, mapdh3, mapih3,ssh3,possh30, rc)
c      T28.3.10     T2n(a,b,i,j)abab <- 1.0d0 H3(i,j)
            CALL add (wrk,wrksize,
     &       2, 4, 2, 5, b-nsb, a, symb, syma, 1.0d0, mapdh3,
     1       ssn, mapdt23, mapit23, 1, rc)
          END IF
c
c
  8     CONTINUE
c
cpar
        nab=nab-(bstop-bstart+1)
        if (nab.eq.0) then
        goto 30
        end if
c
        if (bstop.lt.limb) then
          bstart=bstop
          goto 4
        end if
 10     CONTINUE
c
 21   CONTINUE
 20   CONTINUE
c
c      IV   close lunab
30    CALL filemanager (3, lunab, rc)
c
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(niter)
      END
c
c     -----------------------------
c
       subroutine multstack (wrk,wrksize,
     &                       mapda,mapdb,mapdc,mapia,mapib,mapic,
     &                       ssa,ssb,possc0,bsize)
c
c        This is a special routine for multiplying of the:
c        C(ij,Bp) = A(ij,cd) . B(cd,Bp)
c        where Bp is a limited (partial) sumation over
c        b index (#b - bsize), namely those, hich are stacked
c
c        This routine is used only in stacking in sumoverab
c        process and is a modification of grc42y routine.
c        Type of index Bp is registered as for standard b, but
c        all lengths of blocks are calculated with
c        bsize, instead of dimm(typb,symb) and the symmetry
c       of b is ignored, B and C are treated as 2index
c
c        P.N. 17.02.06
c
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer possc0,bsize
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4
       integer nhelp21,nhelp22,nhelp41,nhelp42
       integer ntest1,ntest2
       integer sa1,sa2,sa3,sa4,sb1,sb2,sa34,sa134
CLD    integer sa1,sa2,sa3,sa4,sb1,sb2,sb3,sa12,sa34,sa134,sb12
CLD    integer nsyma2
       integer ia,ib,ix,iy
CLD    integer ia,ib,ic,ix,iy
       integer possct
c
c1*
c
c     sctructure A(pq,rs)*B(rs,t)=C(pq,t)
c     sctructure A(pq,rs)*B(rs)=YC(pq)
c
c1.1  define limitations -  p>q,r,s must be tested - ntest1
c     p,q,r>s must be tested - ntest2
c
       if ((mapda(0,6).eq.1).or.(mapda(0,6).eq.4)) then
       ntest1=1
       else
       ntest1=0
       end if
c
       if ((mapda(0,6).eq.3).or.(mapda(0,6).eq.4)) then
       ntest2=1
       else
       ntest2=0
       end if
c
c1.0  prepare mapdc,mapic
c
       call grc0stack (bsize,ntest1,mapda(0,1),mapda(0,2),mapdb(0,3),
     &                 0,mmul(ssa,ssb),possc0,possct,mapdc,mapic)

c
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sb1=1,nsym
       sa3=sb1
c
       sb2=mmul(ssb,sb1)
       sa4=sb2
       sa34=mmul(sa3,sa4)
       if ((ntest2.eq.1).and.(sb1.lt.sb2)) then
c     Meggie out
       goto 100
       end if
c
       do 50 sa1=1,nsym
       sa134=mmul(sa1,sa34)
c
       sa2=mmul(ssa,sa134)
       if ((ntest1.eq.1).and.(sa1.lt.sa2)) then
c     Meggie out
       goto 50
       end if
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,sa3)
       ib=mapib(sb1,1,1)
       iy=mapic(sa1,1,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 50
       end if
c
c     rowA
       nhelp21=dimm(mapda(0,1),sa1)
       nhelp22=dimm(mapda(0,2),sa2)
       if ((ntest1.eq.1).and.(sa1.eq.sa2)) then
       nhelp2=nhelp21*(nhelp21-1)/2
       else
       nhelp2=nhelp21*nhelp22
       end if
c
c     sum
       nhelp41=dimm(mapda(0,3),sa3)
       nhelp42=dimm(mapda(0,4),sa4)
       if ((ntest2.eq.1).and.(sa3.eq.sa4)) then
       nhelp4=nhelp41*(nhelp41-1)/2
       else
       nhelp4=nhelp41*nhelp42
       end if
c
c     colBp
       nhelp3=bsize
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(iy,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=nhelp3
c
       ix=ix+1
c
 50     continue
 100    continue
       ix=ix-1
c
c
c*        multiplying
c
        call multc0 (wrk,wrksize,
     &               mvec,ix,mapdc,1)
c
       return
       end
c
c     -----------------------------
c
       subroutine grc0stack (bsize,typ,typp,typq,typr,typs,stot,
     & poss0,posst,mapd,mapi)
c
c             This routine defines mapd and mapi for specific
c        3 index intermediat A(pq,Bp), needed when stacking
c        (About Bp, see notes in multstack)
c        This routine is a modification of grc0 routine
c
c        P.N. 17.02.06
c     !N.B. (this routine cannot run with +OP2)
c
       integer bsize,typ,typp,typq,typr,typs,stot,poss0,posst
c
#include "ccsd1.fh"
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer sp,sq
CLD    integer sp,sq,sr,ss,spq,spqr
CLD    integer nsymq,nsymr
       integer poss,i,nhelp1,nhelp2,nhelp3
CLD    integer poss,i,nhelp1,nhelp2,nhelp3,nhelp4

c     To get rid of compiler warning
      poss=0
      i=0
c
c     vanishing mapi files
c
       do nhelp1=1,nsym
       do nhelp2=1,nsym
       do nhelp3=1,nsym
       mapi(nhelp3,nhelp2,nhelp1)=0
       end do
       end do
       end do
c
c     matrix A(p,q) or specifilally A(i,j,Bp)
c
       i=1
       poss=poss0
c
       do 100 sp=1,nsym
c
       sq=mmul(stot,sp)
       if ((typ.eq.1).and.(sp.lt.sq)) then
c     Meggie out
       goto 100
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
c
c     def mapi
       mapi(sp,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=bsize*nhelp1*(nhelp1-1)/2
       else
       mapd(i,2)=bsize*nhelp1*nhelp2
       end if
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 100    continue
c
c
       posst=poss
c
c     definition of other coll
c
       mapd(0,1)=typp
       mapd(0,2)=typq
       mapd(0,3)=typr
       mapd(0,4)=typs
       mapd(0,5)=i-1
       mapd(0,6)=typ
c
       return
       end
c
c     -----------------------------
c
        subroutine extstack (wrk,wrksize,
     &                 mapda,mapdb,b,dimb)
c
c       This routine do:
c       A(ij) <- B(ij,_b) for given b
c
c       A special routine used only in sumoverab for stacking
c       case.
c
c       Yet it is assumed,that blocks in A and B are in the same
c       order. To je pomerne odflaknuty predpoklad, a moze to
c       byt bugous
c
#include "wrk.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer b,dimb
c
c     help variables
c
       integer ii,dimij,possa,possb
c
c
        do ii=1,mapda(0,5)
          dimij=mapda(ii,2)
          possa=mapda(ii,1)
          possb=mapdb(ii,1)
          call extstackhlp1 (wrk(possa),wrk(possb),dimij,dimb,b)
        end do
c
        return
        end
c
c       -----------
c
        subroutine extstackhlp1 (a,b,dimij,dimb,bb)
        integer dimij,dimb,bb,ij
        real*8 a(1:dimij),b(1:dimij,1:dimb)
        do ij=1,dimij
        a(ij)=b(ij,bb)
        end do
        return
        end
c
c     -----------------------------
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine genprexyz14(icheckz,interxyz)

use AMFI_global, only: Lmax
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: icheckz(0:Lmax,0:Lmax,0:Lmax,0:Lmax), interxyz(16,0:Lmax,0:Lmax,0:Lmax,0:Lmax)
integer(kind=iwp) :: M1, M2, M3, M4
integer(kind=iwp), external :: mcheckz

!bs ####################################################################
!bs   some quick decision for interaction
!bs ####################################################################
do M4=0,Lmax
  do M3=0,Lmax
    do M2=0,Lmax
      do M1=0,Lmax
        icheckz(m1,m2,m3,m4) = mcheckz(m1,m2,m3,m4)
      end do
    end do
  end do
end do
!bs ####################################################################
!bs   there are at most 16 possible combinations of signs (2**4)
!bs ####################################################################
interxyz(:,:,:,:,:) = 0

return

end subroutine genprexyz14

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Per-Olof Widmark                                 *
*               1993,1996,1997, Markus P. Fuelscher                    *
*               1996, Luis Serrano-Andres                              *
*               2012, Victor P. Vysotskiy                              *
************************************************************************
      Subroutine DaClos(Lu)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Close unit Lu                                                    *
*                                                                      *
*     calling arguments:                                               *
*     Lu      : integer, input                                         *
*               logical unit number                                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, IBM Sweden, 1991                                   *
*     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
*     L. Serrano-Andres, University of Lund, Sweden, 1996              *
*     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

#include "fio.fh"
#ifndef _OLD_IO_STAT_
#include "pfio.fh"
#endif

      Character*80 Text
      Character*16 TheName

      Data TheName/'DaClos'/


      If ( Trace ) then
        Write (6,*) ' >>> Enter DaClos <<<'
        Write (6,*) ' unit :',Lu
        Write (6,*) ' name :',LuName(Lu)
      End If
#ifndef _OLD_IO_STAT_
      LuP=0
      Do i=1,NProfFiles
         If(LuNameProf(i).eq.LuName(Lu)) Then
            LuP=i
         End If
      End Do
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      If(isFiM(Lu).eq.0) then
#endif
         FlsSize(LuP)=AixFsz(FSCB(Lu))
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      Else
         FlsSize(LuP)=FimFsz(FSCB(Lu))
      End If
#endif
#endif

      If ( (Lu.le.0) .or. (Lu.gt.MxFile) )
     * Call SysFileMsg(TheName,'MSG: unit', Lu,' ')
      If ( isOpen(Lu).eq.0 )
     * Call SysFileMsg(TheName,'MSG: notopened', Lu,' ')
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      If(isFiM(Lu).eq.0) then
#endif
       iRc = AixCls(FSCB(Lu))
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      Else
        iRc=FimCls(FSCB(Lu))
        isFiM(Lu)=0
      End If
#endif
      If ( iRc.ne.0 ) then
        iRc = AixErr(Text)
      Call SysFileMsg(TheName,'MSG: close', Lu,Text)
      End If
      isOpen(Lu) = 0
      MBL(Lu)=0
      If ( Multi_File(Lu) ) then
        If ( MaxFileSize.ne.0 ) then
          If ( Trace ) Write (6,*) ' This is a partitioned data set'
          Do i = 1,MaxSplitFile-1
             Lu_=MPUnit(i,Lu)
             If (Lu_.ge.1) Then
                irc=0
                If ( isOpen(Lu_).ne.0 ) iRc = AixCls(FSCB(Lu_))
                If ( iRc.ne.0 ) then
                   iRc = AixErr(Text)
                   Call SysFileMsg(TheName,'MSG: close', Lu_,Text)
                End If
                isOpen(Lu_) = 0
                MPUnit(i,Lu)=-99
                Multi_File(Lu_)=.False.
                MBL(Lu_)=0
             End If
          End Do
        End If
        MPUnit(0,Lu)=0
        Multi_File(Lu)=.False.
      End If

      If ( Trace ) then
        Write (6,*) ' >>> Exit DaClos <<<'
      End If


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

function rMassx(nAtom,nIso)
!***********************************************************************
!                                                                      *
! Object: to return the mass of the nucleus as a function of the       *
!         atomic number, nAtom. The mass is that one of the most       *
!         abundant isotope. In the case there is not stable isotope    *
!         we select the one with the longest lifetime.                 *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Isotopes, only: Isotope, MaxAtomNum
use Constants, only: Zero, uToau
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: rMassx
integer(kind=iwp), intent(in) :: nAtom, nIso
integer(kind=iwp) :: isnx

if (nAtom > MaxAtomNum) then
  !write(u6,*) ' Weight for this atom is not listed!'
  !write(u6,*) ' Mass set to 2.6 times atom number'
  rMassx = 2.6_wp*real(nAtom,kind=wp)*uToau
else if (nAtom == 0) then
  !write(u6,*) ' Weight for this atom is meaningless!'
  !write(u6,*) ' Mass set to 0.0'
  rMassx = Zero
else if (nAtom < 0) then
  rMassx = 1.0e99_wp*uToau
else
  isnx = nIso
  call Isotope(isnx,nAtom,rMassx)
end if

return

end function rMassx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RRINT(K,ALFA,A,BETA,R0,GRINT,lmax)
      Implicit Real*8(A-H,O-Z)
#include "real.fh"
#include "welcom.fh"
      Real*8 grint(0:lmax,lmax),rri(0:kmax+2)
*
      M=K+1
      EXPA=-A*A*ALFA-BETA*R0*R0
      AEXP=(ALFA+BETA)
      BEXP1 = -Two*(BETA*R0+A*ALFA)/AEXP
      BEXP2 = -Two*(BETA*R0-A*ALFA)/AEXP
      If (A.eq.Zero) Then
         Test =Zero
      Else
         If (R0.eq.Zero) Then
            Test=One
         Else
            TEST=A*ALFA
         End If
      End If
CFUE  IF(TEST.LT..02D+00)GO TO 900
      IF(TEST.LT..005D+00)GO TO 900
C     Write (*,*) ' Large A'
C.....K=0 ONE CONTRIBUTION SS-INTEGRAL
      Do 40 i=0,k
         rri(i)=qrint(i+1,aexp,bexp1,expa)*DBLE((-1)**i)
     &          -qrint(i+1,aexp,bexp2,expa)
 40   Continue
C     Call RecPrt(' In RRInt: rri',' ',rri,k+1,1)
      AL=One/(Two*ALFA*A)
      Do 41 i=0,k
         mmax=i/2
         Do 42 m=1,mmax+1
c.....calculate integral ri(i,m)
            fiintm=fiint(m-1,0)
            grint(i,m)=Zero
            Do 43 n=1,m
               Bi=binom(m-1,n-1)*DBLE((-1)**(n+1))
               ind=i-(m-n)*2
               Do 44 kk=0,ind
                  ggg=fac(ind)/fac(ind-kk)*al**(kk+1)
                  grint(i,m)=grint(i,m)+bi*ggg*rri(i-kk)*fiintm
 44            Continue
43          Continue
42       Continue
41    Continue
      go to 100
900   Continue
C     Write (*,*) ' SERIES EXPANSION FOR SMALL A'
c
C.....SERIES EXPANSION FOR SMALL A
c
C.... K=0 FIRST
      l = (k+1)/2
      EXP1=-(ALFA*A*A+BETA*R0*R0)
      BEXP=-Two*BETA*R0/(ALFA+BETA)
      Do 45 i=0,l+2
         rri(i)=qrint(2*(i+1),AExp,BExp,Exp1)
 45   Continue
C     Call RecPrt(' rri',' ',rri,l+3,1)
      pi4=pi*Four
      AA  = Two *(A*Alfa)
      AA2 = Two *(A*Alfa)**2
      AA3 = Four*(A*Alfa)**3
      AA4 = Two *(A*Alfa)**4
      AA5 = Four*(A*Alfa)**5
      GRINT(0,1) = pi4*(               rri(0)
     &           +      AA2/Three    * rri(1)
     &           +      AA4/15.0D+00 * rri(2)  )
      IF(K.EQ.0)  go to 100
      Do 20 ll=1,l
         Do kk = 1, ll+1
*
            tmp1= fiint(kk-1,0)/fiint(0,0)
            tmp2= -Two*DBLE(kk-1)
            tmp = Zero
            Do mm = 0, kk-1
               tmp3 = tmp1*binom(kk-1,mm)*(-One)**mm
               tmp4 = tmp2 + DBLE(mm)*Two + One
               tmp = tmp + tmp3 * (
     &              + One /(      DBLE(2*ll  )+tmp4)      * rri(ll)
     &              + AA2/(       DBLE(2*ll+2)+tmp4)      * rri(ll+1)
     &              + AA4/(Three*(DBLE(2*ll+4)+tmp4))     * rri(ll+2))
            End Do
            Grint(ll*2,  kk) = pi4 * tmp
*
            if (kk.eq.1) cycle
            tmp1= fiint(kk-2,0)/fiint(0,0)
            tmp=Zero
            Do mm = 1, kk-1
               tmp3 = tmp1*binom(kk-2,mm-1)*(-One)**(mm+1)
               tmp4 = tmp2 + DBLE(mm)*Two + One
               tmp = tmp - tmp3 * (
     &              + AA /       (DBLE(2*ll)  +tmp4)      * rri(ll)
     &              + AA3/(Three*(DBLE(2*ll+2)+tmp4))     * rri(ll+1)
     &              + AA5/(15.0D0*(DBLE(2*ll+4)+tmp4))    * rri(ll+2))
            End Do
            Grint(ll*2-1,kk-1) = pi4 * tmp
            Grint(ll*2-1,kk) = Zero
*
         End Do
 20   Continue
 100  Continue
*
*     Call RecPrt(' In RRint:grint',' ',grint,1+lmax,lmax)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mxsqrt_cvb(a,n,ipow)
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension a(n,n)

      i1 = mstackr_cvb(n)
      i2 = mstackr_cvb(n*n)
      i3 = mstackr_cvb(n)
      i4 = mstackr_cvb(n)
      i5 = mstackr_cvb(n*n)
      ifail=0
      call casvb_rs(n,n,a,w(i1),1,w(i2),w(i3),w(i4),ifail)
      if(ifail.ne.0)then
        write(6,*)' Fatal error in diagonalization (MXSQRT) :',ifail
        call abend_cvb()
      endif
      call fzero(a,n*n)
      do 100 i=1,n
      a(i,i)=sqrt(w(i+i1-1))**ipow
100   continue
      call mxatb_cvb(w(i2),a,n,n,n,w(i5))
      call fzero(a,n*n)
      do 200 k=1,n
      do 201 j=1,n
      do 202 i=1,n
      a(i,j)=a(i,j)+w(i+(k-1)*n+i5-1)*w(j+(k-1)*n+i2-1)
202   continue
201   continue
200   continue
      call mfreer_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine DIADNS(ISYM,ICASE,VEC1,nVec1,VEC2,nVec2,DPT2,nDPT2,LIST,mList)
! Compute diagonal-block contribs to a trans density matrix.
! Vector blocks are in spectral resolution basis (ON).
! Each square matrix block of density matrix elements is
! computed and stored in full, even if VEC1=VEC2.
! Present implementation does not compute active-active
! contributions. This should be added in a separate routine,
! since it requires transformation to standard (Non-ON) basis.

use Symmetry_Info, only: Mul
use caspt2_global, only: do_grad
use EQSOLV, only: LLIST, NLIST
use Sigma_data, only: IFTEST, INCX1, INCX2, INCX3, INCY1, INCY2, LEN1, NLST1, VAL1
use caspt2_module, only: NAGEB, NAGTB, NASH, NASUP, NIGEJ, NIGTJ, NIMX, NINDEP, NISH, NISUP, NORB, NORB, NSMX, NSSH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ISYM, ICASE, nVEC1, nVec2, nDPT2, mList, LIST(mList)
real(kind=wp), intent(in) :: VEC1(nVec1), VEC2(nVec2)
real(kind=wp), intent(inout) :: DPT2(nDPT2)
integer(kind=iwp) :: IA, IB, ICD, ICEM, ICEP, ICGM, ICGP, IDAB, IDII, IDIJ, IDTU, II, III, IJ, IJS, INCA, IOFCD(8,8), IOFDAB(8), &
                     IOFDIJ(8), IS, ISYMA, ISYMC, ISYMCA, ISYMI, ISYMK, ISYMKI, IV, IV1, IV11, IV2, IV22, IY, IY1, IY2, IYOFF, JS, &
                     LLST1, MU, NA, NAKI, NAS, NC, NCA, NCAY, NI, NICA, NIN, NIS, NK, NKI, NKIY, NO, NOA, NOI, NS, NVEC, NX
real(kind=wp) :: OVL, rSUM
real(kind=wp), allocatable :: X1(:), X2(:)
real(kind=wp), parameter :: SQR2 = sqrt(Two)
real(kind=wp), external :: DDOT_

NIN = NINDEP(ISYM,ICASE)
if (NIN == 0) return
NIS = NISUP(ISYM,ICASE)
if (NIS == 0) return
NAS = NASUP(ISYM,ICASE)
NVEC = NIN*NIS

IFTEST = 0
! Set up various offset arrays:
IDIJ = 0
do IS=1,NSYM
  NI = NISH(IS)
  NA = NASH(IS)
  NO = NORB(IS)
  IDTU = IDIJ+NO*NI+NI
  IDAB = IDTU+NO*NA+NA
  IOFDIJ(IS) = IDIJ
  IOFDAB(IS) = IDAB
  IDIJ = IDIJ+NO*NO
end do
do IS=1,NSYM
  ICD = 0
  ICEP = 0
  ICEM = 0
  ICGP = 0
  ICGM = 0
  do JS=1,NSYM
    IJS = Mul(IS,JS)
    IOFCD(IS,JS) = ICD
    ICD = ICD+NSSH(JS)*NISH(IJS)
    ICEP = ICEP+NSSH(JS)*NIGEJ(IJS)
    ICEM = ICEM+NSSH(JS)*NIGTJ(IJS)
    ICGP = ICGP+NISH(JS)*NAGEB(IJS)
    ICGM = ICGM+NISH(JS)*NAGTB(IJS)
  end do
end do

! Core contribution:
if (.not. do_grad) then
  OVL = DDOT_(NVEC,VEC1,1,VEC2,1)
  do IS=1,NSYM
    NI = NISH(IS)
    NO = NORB(IS)
    IDII = IOFDIJ(IS)+1
    do III=1,NI
      DPT2(IDII) = DPT2(IDII)+Two*OVL
      IDII = IDII+NO+1
    end do
  end do
end if

LLST1 = 0 ! dummy initialize
NLST1 = 0 ! dummy initialize

select case (ICASE)
  ! -----------------------------------------------
  case (1)
    ! Case A
    NI = NISH(ISYM)
    NO = NORB(ISYM)
    do II=1,NI
      IV2 = 1+NIN*(II-1)
      do IJ=1,NI
        IDIJ = IOFDIJ(ISYM)+II+NO*(IJ-1)
        IV1 = 1+NIN*(IJ-1)
        DPT2(IDIJ) = DPT2(IDIJ)-DDOT_(NIN,VEC1(IV1),1,VEC2(IV2),1)
      end do
    end do
    ! -----------------------------------------------
  case (2,3)
    ! Case BP
    ! Case BM
    ! Unfold VEC1 and VEC2 into X1(MU,K,I), X2(MU,K,I):
    NX = NIN*NIMX**2
    call mma_allocate(X1,NX,LABEL='X1')
    call mma_allocate(X2,NX,LABEL='X2')
    do ISYMK=1,NSYM
      ISYMI = Mul(ISYMK,ISYM)
      NK = NISH(ISYMK)
      NI = NISH(ISYMI)
      NKI = NK*NI
      if (NKI == 0) cycle
      X1(1:NIN*NKI) = Zero
      X2(1:NIN*NKI) = Zero
      if (ICASE == 2) then
        LLST1 = LLIST(ISYMK,ISYM,14)
        NLST1 = NLIST(ISYMK,ISYM,14)
        VAL1(1) = One
        VAL1(2) = SQR2
      else if (ICASE == 3) then
        LLST1 = LLIST(ISYMK,ISYM,15)
        NLST1 = NLIST(ISYMK,ISYM,15)
        VAL1(1) = One
        VAL1(2) = -One
      end if
      if (NLST1 == 0) cycle
      INCX1 = 1
      INCX2 = NIN
      INCX3 = NIN*NK
      INCY1 = 1
      INCY2 = NIN
      LEN1 = NIN
      call MLTUNF(LIST(LLST1),NLST1,X1,nX,VEC1,nVec1)
      call MLTUNF(LIST(LLST1),NLST1,X2,nX,VEC2,nVec2)
      ! D(I,J) := Add contraction -X2(MU,K,I)*X1(MU,K,J):
      IDIJ = 1+IOFDIJ(ISYMI)
      NO = NORB(ISYMI)
      call DGEMM_('T','N',NI,NI,NIN*NK,-One,X2,NIN*NK,X1,NIN*NK,One,DPT2(IDIJ),NO)
    end do
    call mma_deallocate(X1)
    call mma_deallocate(X2)
    ! -----------------------------------------------
  case (4)
    ! Case C
    NS = NSSH(ISYM)
    NO = NORB(ISYM)
    do IA=1,NS
      IV1 = 1+NIN*(IA-1)
      do IB=1,NS
        IDAB = IOFDAB(ISYM)+IA+NO*(IB-1)
        IV2 = 1+NIN*(IB-1)
        DPT2(IDAB) = DPT2(IDAB)+DDOT_(NIN,VEC1(IV1),1,VEC2(IV2),1)
      end do
    end do
    ! -----------------------------------------------
  case (5)
    ! Case D
    do ISYMA=1,NSYM
      NS = NSSH(ISYMA)
      NOA = NORB(ISYMA)
      ISYMI = Mul(ISYMA,ISYM)
      NI = NISH(ISYMI)
      NOI = NORB(ISYMI)
      IV = 1+NIN*IOFCD(ISYM,ISYMA)
      INCA = NIN*NI
      if (NI == 0) cycle
      do II=1,NI
        IV2 = IV+NIN*(II-1)
        do IJ=1,NI
          IDIJ = IOFDIJ(ISYMI)+II+NOI*(IJ-1)
          rSUM = DPT2(IDIJ)
          IV1 = IV+NIN*(IJ-1)
          do IA=1,NS
            IV11 = IV1+INCA*(IA-1)
            IV22 = IV2+INCA*(IA-1)
            rSUM = rSUM-DDOT_(NIN,VEC1(IV11),1,VEC2(IV22),1)
          end do
          DPT2(IDIJ) = rSUM
        end do
      end do
      do IA=1,NS
        IV1 = IV+INCA*(IA-1)
        do IB=1,NS
          IDAB = IOFDAB(ISYMA)+IA+NOA*(IB-1)
          IV2 = IV+INCA*(IB-1)
          DPT2(IDAB) = DPT2(IDAB)+DDOT_(INCA,VEC1(IV1),1,VEC2(IV2),1)
        end do
      end do
    end do
    ! -----------------------------------------------
  case (6,7)
    ! Case EP
    ! Case EM
    NX = NIN*NSMX*NIMX**2
    call mma_allocate(X1,NX,LABEL='X1')
    call mma_allocate(X2,NX,LABEL='X2')
    IYOFF = 0
    do ISYMA=1,NSYM
      ISYMKI = Mul(ISYMA,ISYM)
      NA = NSSH(ISYMA)
      NOA = NORB(ISYMA)
      if (ICASE == 6) NKIY = NIGEJ(ISYMKI)
      if (ICASE == 7) NKIY = NIGTJ(ISYMKI)
      IY = 1+IYOFF
      ! First, contributions to DIJ.
      ! Unfold VEC1 and VEC2 into X1(MU,A;K,I), X2(MU,A;K,I):
      do ISYMK=1,NSYM
        ISYMI = Mul(ISYMK,ISYMKI)
        NK = NISH(ISYMK)
        NI = NISH(ISYMI)
        NAKI = NA*NK*NI
        if (NAKI == 0) cycle
        X1(1:NIN*NAKI) = Zero
        X2(1:NIN*NAKI) = Zero
        if (ICASE == 6) then
          LLST1 = LLIST(ISYMK,ISYMKI,14)
          NLST1 = NLIST(ISYMK,ISYMKI,14)
          VAL1(1) = One
          VAL1(2) = SQR2
        else if (ICASE == 7) then
          LLST1 = LLIST(ISYMK,ISYMKI,15)
          NLST1 = NLIST(ISYMK,ISYMKI,15)
          VAL1(1) = One
          VAL1(2) = -One
        end if
        if (NLST1 == 0) cycle
        INCX1 = 1
        INCX2 = NIN*NA
        INCX3 = NIN*NA*NK
        INCY1 = 1
        INCY2 = NIN*NA
        LEN1 = NIN*NA
        call MLTUNF(LIST(LLST1),NLST1,X1,nX,VEC1(IY),nVEC1-IY+1)
        call MLTUNF(LIST(LLST1),NLST1,X2,nX,VEC2(IY),nVEC2-IY+1)
        ! D(I,J) := Add contraction -X2(MU,A,K,I)*X1(MU,A,K,J):
        IDIJ = 1+IOFDIJ(ISYMI)
        NOI = NORB(ISYMI)
        call DGEMM_('T','N',NI,NI,NIN*NA*NK,-One,X2,NIN*NA*NK,X1,NIN*NA*NK,One,DPT2(IDIJ),NOI)
      end do
      ! Second, contributions to DAB.
      if (NKIY == 0) cycle
      do IA=1,NA
        do IB=1,NA
          IDAB = IOFDAB(ISYMA)+IA+NOA*(IB-1)
          rSUM = DPT2(IDAB)
          do MU=1,NIN
            IY1 = IYOFF+MU+NIN*(IA-1)
            IY2 = IYOFF+MU+NIN*(IB-1)
            rSUM = rSUM+DDOT_(NKIY,VEC1(IY1),INCY2,VEC2(IY2),INCY2)
          end do
          DPT2(IDAB) = rSUM
        end do
      end do
      IYOFF = IYOFF+NIN*NA*NKIY
    end do
    call mma_deallocate(X1)
    call mma_deallocate(X2)
    ! -----------------------------------------------
  case (8,9)
    ! Case FP
    ! Case FM
    ! Unfold VEC1 and VEC2 into X1(MU,C,A), X2(MU,C,B):
    NX = NIN*NSMX**2
    call mma_allocate(X1,NX,LABEL='X1')
    call mma_allocate(X2,NX,LABEL='X2')
    do ISYMC=1,NSYM
      ISYMA = Mul(ISYMC,ISYM)
      NC = NSSH(ISYMC)
      NA = NSSH(ISYMA)
      NCA = NC*NA
      if (NCA == 0) cycle
      X1(1:NIN*NCA) = Zero
      X2(1:NIN*NCA) = Zero
      if (ICASE == 8) then
        LLST1 = LLIST(ISYMC,ISYM,16)
        NLST1 = NLIST(ISYMC,ISYM,16)
        VAL1(1) = One
        VAL1(2) = SQR2
      else if (ICASE == 9) then
        LLST1 = LLIST(ISYMC,ISYM,17)
        NLST1 = NLIST(ISYMC,ISYM,17)
        VAL1(1) = One
        VAL1(2) = -One
      end if
      if (NLST1 == 0) cycle
      INCX1 = 1
      INCX2 = NIN
      INCX3 = NIN*NC
      INCY1 = 1
      INCY2 = NIN
      LEN1 = NIN
      call MLTUNF(LIST(LLST1),NLST1,X1,nX,VEC1,nVec1)
      call MLTUNF(LIST(LLST1),NLST1,X2,nX,VEC2,nVec2)
      ! D(A,B) := Add contraction  X1(MU,C,A)*X2(MU,C,B):
      IDAB = 1+IOFDAB(ISYMA)
      NOA = NORB(ISYMA)
      call DGEMM_('T','N',NA,NA,NIN*NC,+One,X1,NIN*NC,X2,NIN*NC,One,DPT2(IDAB),NOA)
    end do
    call mma_deallocate(X1)
    call mma_deallocate(X2)
    ! -----------------------------------------------
  case (10,11)
    ! Case GP
    ! Case GM
    NX = NIN*NIMX*NSMX**2
    call mma_allocate(X1,NX,LABEL='X1')
    call mma_allocate(X2,NX,LABEL='X2')
    IYOFF = 0
    do ISYMI=1,NSYM
      ISYMCA = Mul(ISYMI,ISYM)
      NI = NISH(ISYMI)
      NOI = NORB(ISYMI)
      if (ICASE == 10) NCAY = NAGEB(ISYMCA)
      if (ICASE == 11) NCAY = NAGTB(ISYMCA)
      IY = 1+IYOFF
      ! First, contributions to DAB.
      ! Unfold VEC1 and VEC2 into X1(MU,I;C,A), X2(MU,I;C,A):
      do ISYMC=1,NSYM
        ISYMA = Mul(ISYMC,ISYMCA)
        NC = NSSH(ISYMC)
        NA = NSSH(ISYMA)
        NICA = NI*NC*NA
        if (NICA == 0) cycle
        X1(1:NIN*NICA) = Zero
        X2(1:NIN*NICA) = Zero
        if (ICASE == 10) then
          LLST1 = LLIST(ISYMC,ISYMCA,16)
          NLST1 = NLIST(ISYMC,ISYMCA,16)
          VAL1(1) = One
          VAL1(2) = SQR2
        else if (ICASE == 11) then
          LLST1 = LLIST(ISYMC,ISYMCA,17)
          NLST1 = NLIST(ISYMC,ISYMCA,17)
          VAL1(1) = One
          VAL1(2) = -One
        end if
        if (NLST1 == 0) cycle
        INCX1 = 1
        INCX2 = NIN*NI
        INCX3 = NIN*NI*NC
        INCY1 = 1
        INCY2 = NIN*NI
        LEN1 = NIN*NI
        call MLTUNF(LIST(LLST1),NLST1,X1,nX,VEC1(IY),nVec1-IY+1)
        call MLTUNF(LIST(LLST1),NLST1,X2,nX,VEC2(IY),nVec2-IY+1)
        ! D(A,B) := Add contraction +X1(MU,I,C,A)*X2(MU,I,C,B):
        IDAB = 1+IOFDAB(ISYMA)
        NOA = NORB(ISYMA)
        call DGEMM_('T','N',NA,NA,NIN*NI*NC,+One,X1,NIN*NI*NC,X2,NIN*NI*NC,One,DPT2(IDAB),NOA)
      end do
      ! Second, contributions to DIJ.
      if (NCAY == 0) cycle
      do II=1,NI
        do IJ=1,NI
          IDIJ = IOFDIJ(ISYMI)+II+NOI*(IJ-1)
          rSUM = DPT2(IDIJ)
          do MU=1,NIN
            IY1 = IYOFF+MU+NIN*(IJ-1)
            IY2 = IYOFF+MU+NIN*(II-1)
            rSUM = rSUM-DDOT_(NCAY,VEC1(IY1),INCY2,VEC2(IY2),INCY2)
          end do
          DPT2(IDIJ) = rSUM
        end do
      end do
      IYOFF = IYOFF+NIN*NI*NCAY
    end do
    call mma_deallocate(X1)
    call mma_deallocate(X2)
    ! -----------------------------------------------
  case (12,13)
    ! Case HP
    ! Case HM
    ! Unfold VEC1 and VEC2 into X1(MU,K,I), X2(MU,K,I):
    NX = NAS*NIMX**2
    call mma_allocate(X1,NX,LABEL='X1')
    call mma_allocate(X2,NX,LABEL='X2')
    do ISYMK=1,NSYM
      ISYMI = Mul(ISYMK,ISYM)
      NK = NISH(ISYMK)
      NI = NISH(ISYMI)
      NKI = NK*NI
      if (NKI == 0) cycle
      X1(1:NAS*NKI) = Zero
      X2(1:NAS*NKI) = Zero
      if (ICASE == 12) then
        LLST1 = LLIST(ISYMK,ISYM,14)
        NLST1 = NLIST(ISYMK,ISYM,14)
        VAL1(1) = One
        VAL1(2) = SQR2
      else if (ICASE == 13) then
        LLST1 = LLIST(ISYMK,ISYM,15)
        NLST1 = NLIST(ISYMK,ISYM,15)
        VAL1(1) = One
        VAL1(2) = -One
      end if
      if (NLST1 == 0) cycle
      INCX1 = 1
      INCX2 = NAS
      INCX3 = NAS*NK
      INCY1 = 1
      INCY2 = NAS
      LEN1 = NAS
      call MLTUNF(LIST(LLST1),NLST1,X1,nX,VEC1,nVec1)
      call MLTUNF(LIST(LLST1),NLST1,X2,nX,VEC2,nVec2)
      ! D(I,J) := Add contraction -X2(MU,K,I)*X1(MU,K,J):
      IDIJ = 1+IOFDIJ(ISYMI)
      NOI = NORB(ISYMI)
      call DGEMM_('T','N',NI,NI,NAS*NK,-One,X2,NAS*NK,X1,NAS*NK,One,DPT2(IDIJ),NOI)
    end do
    call mma_deallocate(X1)
    call mma_deallocate(X2)
    ! Unfold VEC1 and VEC2 into X1(A,C,IJ), X2(A,C,IJ):
    NX = NIS*NSMX**2
    call mma_allocate(X1,NX,LABEL='X1')
    call mma_allocate(X2,NX,LABEL='X2')
    do ISYMC=1,NSYM
      ISYMA = Mul(ISYMC,ISYM)
      NC = NSSH(ISYMC)
      NA = NSSH(ISYMA)
      NCA = NC*NA
      if (NCA == 0) cycle
      X1(1:NIS*NCA) = Zero
      X2(1:NIS*NCA) = Zero
      if (ICASE == 12) then
        LLST1 = LLIST(ISYMA,ISYM,16)
        NLST1 = NLIST(ISYMA,ISYM,16)
        VAL1(1) = One
        VAL1(2) = SQR2
      else if (ICASE == 13) then
        LLST1 = LLIST(ISYMA,ISYM,17)
        NLST1 = NLIST(ISYMA,ISYM,17)
        VAL1(1) = One
        VAL1(2) = -One
      end if
      if (NLST1 == 0) cycle
      INCX1 = NCA
      INCX2 = 1
      INCX3 = NA
      INCY1 = NAS
      INCY2 = 1
      LEN1 = NIS
      call MLTUNF(LIST(LLST1),NLST1,X1,nX,VEC1,nVec1)
      call MLTUNF(LIST(LLST1),NLST1,X2,nX,VEC2,nVec2)
      ! D(A,B) := Add contraction  X1(A,C,IJ)*X2(B,C,IJ):
      IDAB = 1+IOFDAB(ISYMA)
      NOA = NORB(ISYMA)
      call DGEMM_('N','T',NA,NA,NIS*NC,+One,X1,NA,X2,NA,One,DPT2(IDAB),NOA)
    end do
    call mma_deallocate(X1)
    call mma_deallocate(X2)
  case default
    call ABEND()
end select

contains

subroutine MLTUNF(LST,nLST,X,nX,Y,nY)
  ! Given a list with entries LST(4,ITEM), ITEM=1,NLST,
  ! with entries called L1,L2,L3,L4 for given ITEM, and
  ! an array of the form Y(p,q), compute the matrix
  !    X(p,L1,L2) := Add V*Y(p,L3), p=1..LEN1
  ! where V=VAL1(L4), looped over ITEM=1,NLST.
  ! Note: Arrays are addressed by strides given in common.

  integer(kind=iwp), intent(in) :: nLST, LST(4,nLST), nX, nY
  real(kind=wp), intent(inout) :: X(nX)
  real(kind=wp), intent(in) :: Y(nY)
  integer(kind=iwp) :: ILST, IX, IY, L1, L2, L3, L4
  real(kind=wp) :: V

  do ILST=1,NLST
    L1 = LST(1,ILST)
    L2 = LST(2,ILST)
    L3 = LST(3,ILST)
    L4 = LST(4,ILST)
    V = VAL1(L4)
    IX = 1+INCX2*(L1-1)+INCX3*(L2-1)
    IY = 1+INCY2*(L3-1)
    call DAXPY_(LEN1,V,Y(IY),INCY1,X(IX),INCX1)
  end do

end subroutine MLTUNF

end subroutine DIADNS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Martin Schuetz                                   *
!***********************************************************************

subroutine ChkOrt(iD,OffMx)
!***********************************************************************
!                                                                      *
!     purpose: Check orthogonality of CMOs                             *
!                                                                      *
!     output:                                                          *
!       OffMx   : maximal off diagonal element                         *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: CMO, MaxBas, nBas, nOrb, nSym, Ovrlp
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iD
real(kind=wp), intent(out) :: OffMx
integer(kind=iwp) :: i, iCMO, iDgNo1, ij, iOff, iOffMx, iSym, j, jOffMx, nBs, nOr
real(kind=wp) :: DgNo1
logical(kind=iwp) :: termin
real(kind=wp), allocatable :: Aux(:), OvlS(:)
real(kind=wp), parameter :: OrtThr = 1.0e-9_wp

call mma_allocate(OvlS,MaxBas**2,Label='OvlS')
call mma_allocate(Aux,MaxBas**2,Label='Aux')

ij = 1
iCMO = 1
termin = .false.
do iSym=1,nSym
  OffMx = Zero
  DgNo1 = Zero
  nBs = nBas(iSym)
  nOr = nOrb(iSym)
  if (nOr > 0) then
    call Square(Ovrlp(ij),OvlS,1,nBs,nBs)
    call DGEMM_('N','N',nBs,nOr,nBs, &
                One,OvlS,nBs, &
                CMO(iCMO,iD),nBs, &
                Zero,Aux,nBs)
    call DGEMM_('T','N',nOr,nOr,nBs, &
                One,CMO(iCMO,iD),nBs, &
                Aux,nBs, &
                Zero,OvlS,nOr)
    ! get largest non zero off diag element
    do i=1,nOr
      do j=1,i-1
        iOff = (j-1)*nOr+i
        OffMx = max(OffMx,abs(OvlS(iOff)))
      end do
    end do
    ! get diag element most different from one
    do i=1,nOr
      iOff = (i-1)*nOr+i
      DgNo1 = max(DgNo1,abs(OvlS(iOff)-One))
    end do
    ! check, if orthogonality violated
    if ((OffMx > OrtThr) .or. (DgNo1 > OrtThr)) then
      ! Ooooops...
      !write(u6,*) 'WARNING: reorthonormalizing MOs...',OffMx,DgNo1

      ! try to re-orthonormalize...
      call Orthox(OvlS,CMO(iCMO,iD),nOr,nBs)

      ! and test again...
      OffMx = Zero
      DgNo1 = Zero
      call Square(Ovrlp(ij),OvlS,1,nBs,nBs)
      call DGEMM_('N','N',nBs,nOr,nBs, &
                  One,OvlS,nBs, &
                  CMO(iCMO,iD),nBs, &
                  Zero,Aux,nBs)
      call DGEMM_('T','N',nOr,nOr,nBs, &
                  One,CMO(iCMO,iD),nBs, &
                  Aux,nBs, &
                  Zero,OvlS,nOr)
      ! get largest non zero off diag element
      do i=1,nOr
        do j=1,i-1
          iOff = (j-1)*nOr+i
          OffMx = max(OffMx,abs(OvlS(iOff)))
        end do
      end do
      ! get diag element most different from one
      do i=1,nOr
        iOff = (i-1)*nOr+i
        DgNo1 = max(DgNo1,abs(OvlS(iOff)-One))
      end do
      ! check, if orthogonality violated
      if ((OffMx > OrtThr) .or. (DgNo1 > OrtThr)) then
        termin = .true.
        if (OffMx > OrtThr) then
          ! off diag element too large. Now we have time, since
          ! program will terminate anyway -> Go through matrix
          ! again, this time we want element indices...
          outer: do i=1,nOr
            do j=1,i-1
              iOff = (j-1)*nOr+i
              if (abs(OvlS(iOff)) >= OffMx) then
                ! found
                iOffMx = i
                jOffMx = j
                OffMx = OvlS(iOff)
                ! exit loop
                exit outer
              end if
            end do
          end do outer
          !call WarningMessage(0,'Orthogonality violated')
          write(u6,*) ' iSym =',iSym
          write(u6,*) ' largest off diag element:',' [',iOffMx,',',jOffMx,']',' = ',OffMx
        end if
        if (DgNo1 > OrtThr) then
          ! diag element too different from One
          do i=1,nOr
            iOff = (i-1)*nOr+i
            if (abs(OvlS(iOff)-One) >= DgNo1) then
              ! found
              iDgNo1 = i
              DgNo1 = OvlS(iOff)
              ! exit loop
              exit
            end if
          end do
          !call WarningMessage(0,'Orthogonality violated')
          write(u6,*)
          write(u6,*) ' ***** Orthogonality violated *****'
          write(u6,*) ' iSym =',iSym
          write(u6,*) ' diag element most different from 1.0:',' [',iDgNo1,',',iDgNo1,']',' = ',DgNo1
        end if
      end if
    end if
  end if
  ij = ij+nTri_Elem(nBs)
  iCMO = iCMO+nBs*nOr
end do

call mma_deallocate(Aux)
call mma_deallocate(OvlS)
if (termin) then
  call WarningMessage(0,'Orthogonality cannot be recovered\n Basis set problem???')
  call Abend()
end if

return

end subroutine ChkOrt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Kntc(Txyz,Sxyz,na,nb,Alpha,Beta,nZeta)
************************************************************************
*                                                                      *
* Object: to assemble the cartesian components of the kinetic energy   *
*         integral from the cartesian components of the overlap        *
*         integral.                                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Txyz(nZeta,3,0:na,0:nb), Sxyz(nZeta,3,0:na+1,0:nb+1),
     &       Alpha(nZeta), Beta(nZeta)
      Character*80 Label
*
      iRout = 115
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In Kntc: Alpha',' ',Alpha,nZeta,1)
         Call RecPrt(' In Kntc: Beta ',' ',Beta ,nZeta,1)
         Do 1 ia = 0, na+1
            Do 2 ib = 0, nb+1
               Write (Label,'(A,I2,A,I2,A)')
     &               ' In Kntc: Sxyz(',ia,',',ib,')'
               Call RecPrt(Label,' ',Sxyz(1,1,ia,ib),nZeta,3)
 2          Continue
 1       Continue
      End If
      Do 10 ia = 0, na
         Do 20 ib = 0, nb
            If (ia.eq.0 .and. ib.eq.0) Then
               Do 31 iCar = 1, 3
                  Do 41 iZeta = 1, nZeta
                     Txyz(iZeta,iCar,ia,ib) =
     &                   Two * Alpha(iZeta) * Beta(iZeta) *
     &                                       Sxyz(iZeta,iCar,ia+1,ib+1)
 41               Continue
 31            Continue
            Else If (ia.eq.0) Then
               Do 32 iCar = 1, 3
                  Do 42 iZeta = 1, nZeta
                     Txyz(iZeta,iCar,ia,ib) =
     &                   Two * Alpha(iZeta) * Beta(iZeta) *
     &                                       Sxyz(iZeta,iCar,ia+1,ib+1)
     &           - Alpha(iZeta) * DBLE(ib) * Sxyz(iZeta,iCar,ia+1,ib-1)
 42               Continue
 32            Continue
            Else If (ib.eq.0) Then
               Do 33 iCar = 1, 3
                  Do 43 iZeta = 1, nZeta
                     Txyz(iZeta,iCar,ia,ib) =
     &                   Two * Alpha(iZeta) * Beta(iZeta) *
     &                                       Sxyz(iZeta,iCar,ia+1,ib+1)
     &           - Beta(iZeta)  * DBLE(ia) * Sxyz(iZeta,iCar,ia-1,ib+1)
 43               Continue
 33            Continue
            Else
               Do 30 iCar = 1, 3
                  Do 40 iZeta = 1, nZeta
                     Txyz(iZeta,iCar,ia,ib) =
     &                Half * DBLE(ia * ib) * Sxyz(iZeta,iCar,ia-1,ib-1)
     &           - Beta(iZeta)  * DBLE(ia) * Sxyz(iZeta,iCar,ia-1,ib+1)
     &           - Alpha(iZeta) * DBLE(ib) * Sxyz(iZeta,iCar,ia+1,ib-1)
     &                 + Two * Alpha(iZeta) * Beta(iZeta) *
     &                                       Sxyz(iZeta,iCar,ia+1,ib+1)
 40               Continue
 30            Continue
            End If
            If (iPrint.ge.99) Then
               Write (Label,'(A,I2,A,I2,A)') ' In Kntc: Txyz(',ia,',',
     &                ib,')'
               Call RecPrt(Label,' ',Txyz(1,1,ia,ib),nZeta,3)
            End If
 20      Continue
 10   Continue
*
*     Call GetMem(' Exit Kntc  ','CHECK','REAL',iDum,iDum)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Fill_rInfo1()
      use Basis_Info
#include "Molcas.fh"
#include "rinfo.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Generate stuff for rinfo.fh
*
      krExp=0
      krCof=0
      krBas=0
      krCnt=0

*     Loop over basis sets
      Do iCnttp = 1, nCnttp
*        Loop over distinct centers
         Do icnt = 1, dbsc(iCnttp)%nCntr
            krCnt=krCnt+1
            nAngr(krCnt)=dbsc(iCnttp)%nVal-1
*
*           Start with s type shells
            jSh = dbsc(iCnttp)%iVal
            Do iAng = 0, dbsc(iCnttp)%nVal-1
*
               krBas=krBas+1
               If (krBas.gt.MxAO) Then
                  Call WarningMessage(2,'Too many shells')
                  Write(6,*) 'MORE THAN ',MxAO,' SHELLS'
                  Write(6,*) 'Increase MxAO in info.fh and',
     &                      ' recompile the code!'
                  Call Abend()
               End If
               nExpj=Shells(jSh)%nExp
               nPrimr(krBas)=nExpj
               nBasisr(krBas)=Shells(jSh)%nBasis_C
*
               If (krExp+nExpj.gt.MxPrim) then
                  Call WarningMessage(2,'Too many primitives')
                  write(6,*) 'MORE THAN ',MxPrim,' PRIMITIVES'
                  write(6,*) 'Increase MxPrim in rinfo.fh and',
     &                       'recompile the code!'
                  Call Abend()
               End If
               Do  kExp=1,nExpj
                  krExp=krExp+1
                  rExp(krExp)=Shells(jSh)%Exp(kExp)
               End Do
*
*
*              Pointer to the untouched contraction matrix as after
*              input.
*
               If (krCof+nExpj*Shells(jSh)%nBasis.gt.MxrCof) Then
                  Call WarningMessage(2,
     &                     'Too many contraction coefficients')
                  Write(6,*) 'MORE THAN ',MxrCof,
     &                      ' CONTRACTION COEFFICIENTS'
                  Write(6,*) 'Increase MxrCof in rinfo.fh and',
     &                       'recompile the code!'
                  Call Abend()
               End If
               Do kCof=1,Shells(jSh)%nBasis_C
                  Do  kExp=1,nExpj
                        krCof=krCof+1
                        rCof(krCof)=Shells(jSh)%Cff_c(kExp,kCof,2)
                  End Do
               End Do
*
               jSh = jSh + 1
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine expand3 (a,b,dimp,dimqr,dimq)
c
c     expand a(p,qr) -> b(p,q,r)
c     assumption: q>r, a(p,q,r)=-a(p,r,q)
c     RISC version
c
       integer dimp,dimq,dimqr
c       real*8 a(1:dimp,1:dimqr+1)
       real*8 a(1:dimp,1:dimq**2)
       real*8 b(1:dimp,1:dimq,1:dimq)
c
c     help variables
c
       integer p,q,r,qr
       real*8 scalar
c
       if (dimq.gt.1) then
c
       qr=0
       do 100 q=2,dimq
       do 101 r=1,q-1
       qr=qr+1
c
       do p=1,dimp
       scalar=a(p,qr)
       b(p,q,r)=scalar
       b(p,r,q)=-scalar
       end do
 101    continue
 100    continue
c
       end if
c
       do q=1,dimq
       do p=1,dimp
       b(p,q,q)=0.0d0
       end do
       end do
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dimqr)
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Ignacio Fdez. Galvan                             *
************************************************************************

      Real*8 Function Golden(ax,bx,cx,f,tol_x,tol_f,xmin,
     &                 rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,
     &                 lMax,nElem,nAtoms,nPert,Scratch_New,Scratch_Org,
     &                 iPrint_Errors)
      Implicit None
      Real*8 :: ax, bx, cx, tol_x, tol_f, xmin
      Real*8, Parameter :: Ratio = 0.5D0*(3.0D0-Sqrt(5.0D0))
      Real*8, Parameter :: RM = 1.0D0-Ratio
      Real*8 :: x1, x2, x3, x4, f2, f3
c External function f and its arguments
      Real*8, External :: f
      Integer :: nij,lMax,nElem
      Real*8 :: rMP(nij,0:nElem),xrMP(nij,nElem),xxrMP(nij,nElem),
     &          xnrMP(nij,nElem),EC(3,nij),AC(3,nij),R_ij(3),C_o_C(3),
     &          Scratch_New(nij*(2+lMax+1)),Scratch_Org(nij*(2+lMax+1))
      Integer :: ij,l,nAtoms,nPert,iPrint_Errors

      x1 = ax
      x4 = cx
      If (Abs(cx-bx) .gt. Abs(bx-ax)) Then
        x2 = bx
        x3 = RM*bx + Ratio*cx
      Else
        x2 = RM*bx + Ratio*ax
        x3 = bx
      End If
      f2 = f(x2,
     &       rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,lMax,nElem,
     &       nAtoms,nPert,Scratch_New,Scratch_Org,iPrint_Errors)
      f3 = f(x3,
     &       rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,lMax,nElem,
     &       nAtoms,nPert,Scratch_New,Scratch_Org,iPrint_Errors)
      Do While ((Abs(x4-x1) .gt. tol_x*(Abs(x1)+Abs(x2))) .and.
     &          (Abs(f3-f2) .gt. tol_f*(Abs(f2)+Abs(f3))))
        If (f2 .lt. f3) Then
          x4 = x3
          x3 = x2
          f3 = f2
          x2 = RM*x3 + Ratio*x1
          f2 = f(x2,
     &       rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,lMax,nElem,
     &       nAtoms,nPert,Scratch_New,Scratch_Org,iPrint_Errors)
        Else
          x1 = x2
          x2 = x3
          f2 = f3
          x3 = RM*x2 + Ratio*x4
          f3 = f(x3,
     &       rMP,xrMP,xxrMP,xnrMP,EC,AC,R_ij,C_o_C,ij,l,nij,lMax,nElem,
     &       nAtoms,nPert,Scratch_New,Scratch_Org,iPrint_Errors)
        End If
      End Do
      If (f2 .lt. f3) Then
        xmin = x2
        Golden = f2
      Else
        xmin = x3
        Golden = f3
      End If

      End Function Golden

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine wrcivec_cvb(detvec,fn,reord)

use jobiph_j, only: iadr15_j, iroot_j, ispin_j, lsym_j, nactel_j, nconf_j, nroots_j
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: detvec(*)
character(len=*), intent(in) :: fn
logical(kind=iwp), intent(in) :: reord
integer(kind=iwp) :: i, iDisk, iwr, j, k, lujob, ncix(8), ndet_j
real(kind=wp) :: rdum(1)
real(kind=wp), allocatable :: CI(:), CI2(:)
logical(kind=iwp) :: debug = .false.

iwr = 1

call getnci_cvb(ncix,nactel_j,ispin_j-1,lsym_j)
ndet_j = ncix(1)

lujob = 15
call daname_cvb(lujob,fn)
! Allocate at least NDET words for each vector, since this is required by csdtvc:
!call mma_allocate(CI,nConf_j*nroots_j,label='OCIvec')
call mma_allocate(CI,nConf_j*nroots_j+ndet_j-nConf_j,label='OCIvec')
if (iwr == 0) then
  do i=1,nroots_j
    j = iroot_j(i)
    iDisk = iadr15_j(4)
    do k=1,j-1
      call dDaFile(LuJob,0,rdum,nConf_j,iDisk)
    end do
    call dDaFile(LuJob,2,CI(1+(i-1)*nConf_j),nConf_j,iDisk)
  end do

  if (reord) then
    call mma_allocate(CI2,nConf_j,label='CI2')
    call reord2_cvb(CI,CI2,1)
    CI(1:nConf_j) = CI2(:)
    call mma_deallocate(CI2)
  end if

  call csf2det_cvb(CI,detvec,lsym_j,1)
else if (iwr == 1) then
  call csf2det_cvb(CI,detvec,lsym_j,2)

  if (reord) then
    call mma_allocate(CI2,nConf_j,label='CI2')
    call reord2_cvb(CI,CI2,0)
    CI(1:nConf_j) = CI2(:)
    call mma_deallocate(CI2)
  end if

  do i=1,nroots_j
    j = iroot_j(i)
    iDisk = iadr15_j(4)
    do k=1,j-1
      call dDaFile(LuJob,0,rdum,nConf_j,iDisk)
    end do
    call dDaFile(LuJob,1,CI(1+(i-1)*nConf_j),nConf_j,iDisk)
  end do
end if
if (debug) then
  do i=0,nroots_j-1
    write(u6,'(a,i3,a)') ' (CSF) CI vector ',i+1,' :'
    write(u6,'(a)') ' ---------------------'
    call mxprint_cvb(CI(1+nconf_j*i),1,nconf_j,0)
  end do
end if
call mma_deallocate(CI)
call daclos_cvb(lujob)

return

end subroutine wrcivec_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MRCI(IRETURN)
!***********************************************************************
!  MULTI REFERENCE SDCI AND AVERAGE CPF PROGRAM.                       *
!***********************************************************************
! UNITS USED IN THE PROGRAM
! UNIT u5, INPUT
! UNIT u6, OUTPUT
! UNIT  2=LUPROP, (DA,ONEINT) FOR PROPERTY CALCULATIONS
! UNIT 10=LUSYMB, (DA,CIGUGA) SYMBOLIC FORMULAS
! UNIT 50=LUTRA, (DA,TRAINT) TRANSFORMED MO 2-EL INTEGRALS
! UNIT 60, (DA) SORTED AIBJ, ABIJ AND AIJK INTEGRALS
! UNIT 70, (DA) SORTED IJKL AND ABCI INTEGRALS
! UNIT 80, (DA) SORTED ABCD INTEGRALS
! UNIT 17=LUONE, (DA,TRAONE) ONE ELECTRON INTEGRALS
! UNIT 18=LUVEC, (Formatted, sequential!) MRCI ORBITALS OUT
! UNIT 23=LUEIG, (DA) WORKSPACE FOR MALMQUIST DIAGONALIZATION.
! UNIT 25, (DA) FOCK MATRIX AND DIAGONAL CSF MATRIX ELEMENTS
! UNIT 27, (DA) SCRATCH IN IIJJ. ALSO, REFERENCE CI VECTOR.
! UNIT 28=LUREST, (DA,MRCIVECT) CI VECTOR
!***********************************************************************

use mrci_global, only: Lu_25, Lu_27, Lu_60, Lu_70, Lu_80, LUEIG, LUONE, LUREST, LUSYMB, LUTRA, LUVEC, MEMTOT
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: IRETURN

call mma_maxdble(MemTot)

! Open files

LUVEC = 18

LUSYMB = 10
call DANAME(LUSYMB,'CIGUGA')
LUTRA = 50
call DANAME_MF(LUTRA,'TRAINT')
LUONE = 17
call DANAME(LUONE,'TRAONE')
LUREST = 28
call DANAME(LUREST,'MRCIVECT')
! Temporaries:
Lu_60 = 60
call DANAME_MF(Lu_60,'TIABIJ')
Lu_70 = 70
call DANAME_MF(Lu_70,'TIABCI')
Lu_80 = 80
call DANAME_MF(Lu_80,'TIABCD')
LUEIG = 23
call DANAME(LUEIG,'FT23F001')
Lu_25 = 25
call DANAME(Lu_25,'FT25F001')
Lu_27 = 27
call DANAME(Lu_27,'FT27F001')

! main body

call SDCI_MRCI()

! Epilogue, end
!                                                                      *
!***********************************************************************
!                                                                      *
! Close open dafiles.

call DACLOS(LUSYMB)
call DACLOS(LUTRA)
call DACLOS(LUONE)
call DACLOS(LUREST)
call DACLOS(Lu_60)
call DACLOS(Lu_70)
call DACLOS(Lu_80)
call DACLOS(LUEIG)
call DACLOS(Lu_25)
call DACLOS(Lu_27)
!                                                                      *
!***********************************************************************
!                                                                      *
call FastIO('STATUS')
IRETURN = 0

return

end subroutine MRCI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine Free_RctFld(iXPolType)
       use PCM_arrays
       use Langevin_arrays
       Implicit Real*8 (a-h,o-z)
#include "rctfld.fh"
#include "status.fh"
#include "stdalloc.fh"
*
       If (RctFld_Status.eq.InActive) Return
       Call mma_deallocate(MM)
       If (lLangevin .or. (iXPolType.gt.0)) Then
          If(iXPolType.eq.2) Then
             nPolComp = 6
          Else
             nPolComp = 1
          EndIf
          Call mma_deallocate(Field)
          Call mma_deallocate(dField)
          Call mma_deallocate(Dip)
          Call mma_deallocate(PolEf)
          Call mma_deallocate(DipEf)
          Call mma_deallocate(Grid)
*
          Call mma_deallocate(davxyz)
          Call mma_deallocate(cavxyz)
          Call mma_deallocate(ravxyz)
       End If
       If (PCM) Then
          Call mma_deallocate(NewSph)
          Call mma_deallocate(IntSph)
          Call mma_deallocate(NVert)
          Call mma_deallocate(PCMiSph)
          Call mma_deallocate(PCM_N)
          Call mma_deallocate(PCMDM)
          Call mma_deallocate(SSph)
          Call mma_deallocate(Centr)
          Call mma_deallocate(Vert)
          Call mma_deallocate(PCMTess)
          Call mma_deallocate(PCMSph)
*
*---- Free the space for geometric derivatives
*
          If (DoDeriv) Then
             Call mma_deallocate(dTes)
             Call mma_deallocate(dPnt)
             Call mma_deallocate(dRad)
             Call mma_deallocate(dCntr)
             Call mma_deallocate(PCM_SQ)
          End If
*
       End If
       RctFld_Status=InActive
*
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Yoshio Nishimoto                                 *
!***********************************************************************
!
! This module is used when we need to consider rotations between
! internal states, which are usually state-averaged RASSCF states. The
! standard SA-RASSCF (CASSCF) is invariant with respect to rotations
! within internal states, but not for the following example:
!   1. unequally weighted SA-RASSCF
!   2. SA-RASSCF/PCM (unless state-averaging and density that polarizes
!      ASCs are the same (def_solv = 3))
!   3. CASPT2/RASPT2
! In some cases, the Lagrangian multipliers relevant to the rotations
! can be obtained without iteration. For instance, for 3, if the
! reference SA-CASSCF is invariant, the multipliers can be immediately
! obtained. Or, for 2, if the density that polarizes ASCs are equally
! state-averaged, the same applies. For other cases, they should be
! obtained iteratively.
!
! (InvSCF, InvEne) = (.true., .true.)
!   -> conventional SA-CASSCF/RASSCF and SA-CASSCF/PCM (with def_solv = 3)
!      There is no need to consider the internal state rotations
! (InvSCF, InvEne) = (.true., .false.)
!   -> CASPT2 (w/o PCM), SA-CASSCF/PCM (with def_solv = 4)
!      Internal state rotations are non-iteratively evaluated by rotating
!      the 1e and 2e density matrix in rhs_sa and rhs_nac through the
!      SLag matrix.
! (InvSCF, InvEne) = (.false., .false.)
!   -> anything based on SA-CASSCF/PCM (with def_solv /= 3,4)
!      Some internal rotations may be evaluated non-iteratively as in
!      (InvSCF, InvEne) = (.true., .false.). This comes from the
!      rotation in MS-CASPT2 and should not be considered as rotation
!      parameters to be optimized, since it is not iteratively
!      determined during energy.
!      The other internal rotations come from the overlap between the
!      original CI and CI derivative. This is optimized during Z-vector.
! (InvSCF, InvEne) = (.false., .true.)
!   -> unequally (including dynamically) weighted SA-MCSCF w/o PCM
!      The initial residue of the internal rotation is zero, though.

module ISRotation

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none

! Whether the "target" energy, specified by RLXROOT, is invariant or
! non-invariant wrt internal state rotations. The conventional
! SA-MCSCF is invariant, so InvEne = .true. For the above cases, the
! energy is non-invariant, so InvEne = .false. (for instance, CASPT2
! or SA-MCSCF with PCM etc.). This flag only controls the evaluation
! of the initial internal rotation parameter.
logical(kind=iwp) :: InvEne = .true.
! Whether the reference "state-averaged" SCF energy is invariant or
! not with respect to rotations between internal states. If they are
! invariant (InvSCF = .true.), the rotation parameters can be
! non-iteratively determined. If non-invariant (InvSCF = .false.),
! they have to be iteratively determined during the Z-vector
! procedure. The rotation parameters for InvSCF = .true. can be
! iteratively determined as well; this will end up with the same
! result with InvSCF = .false. See the above note for details.
logical(kind=iwp) :: InvSCF = .true.
! Whether we consider the off-diagonal block (O-S and C-S) couplings.
! Purely development purpose
logical(kind=iwp) :: IntRotOff = .true.
! unequal state-average?
logical(kind=iwp) :: unequal_SA = .false.
! InvSol is true only if the ASCs are polarized by the state-averaged
! density matrix. If .not.InvSCF, InvSol is always false, but the
! converse may not be true.
logical(kind=iwp) :: InvSol = .true.
! Whether state rotations are scaled with the weight factor.
! This option should not affect the computed results but I'm not sure.
! Purely development purpose
logical(kind=iwp) :: ScalWeight = .false.

type ISR_param
  real(kind=wp), allocatable :: Ap(:,:)   ! results of A*p
  real(kind=wp), allocatable :: p(:,:)    ! trial vector during CG
  real(kind=wp), allocatable :: Rvec(:,:) ! initial residue (RHS)
  real(kind=wp), allocatable :: prec(:,:) ! preconditioned something
  real(kind=wp), allocatable :: Xvec(:,:) ! solution
  real(kind=wp), allocatable :: Pvec(:,:) ! P vector (for CGS)
  real(kind=wp), allocatable :: Qvec(:,:) ! Q vector (for CGS)
  real(kind=wp), allocatable :: Uvec(:,:) ! U vector (for CGS)
  real(kind=wp), allocatable :: R0(:,:)   ! initial residue (for CGS)
end type ISR_param

type(ISR_param) :: ISR

logical(kind=iwp), pointer :: do_RF

contains

!-----------------------------------------------------------------------

subroutine ISR_init(iPL,do_RF_,def_solv)

  !use DWSol, only: DWSCF
  use cgs_mod, only: CGS
  use input_mclr, only: nRoots, PT2, weight

  integer(kind=iwp), intent(in) :: iPL, def_solv
  logical(kind=iwp), intent(in), target :: do_RF_
  integer(kind=iwp) :: iR

  !! Check whether we need to consider internal state rotations
  !! iteratively or non-interatively
  InvEne = .true.
  unequal_SA = .false.

  if (.not. InvSCF) InvEne = .false.
  if (PT2 .and. (nRoots > 0)) InvEne = .false.
  if (do_RF_ .and. (def_solv /= 3)) InvEne = .false.
  do iR=2,nRoots
    if (weight(1) /= weight(iR)) then
      unequal_SA = .true.
      InvSCF = .false.
      if (do_RF_ .and. (def_solv == 3)) InvEne = .false.
    end if
  end do

  do_RF => do_RF_

  !! If InvEnv = .false., we need internal state rotations
  !! Rvec may be allocated for all cases
  call mma_allocate(ISR%Rvec,nRoots,nRoots,Label='ISR%Rvec')
  ISR%Rvec(:,:) = Zero
  if (.not. InvSCF) then
    call mma_allocate(ISR%Ap,nRoots,nRoots,Label='ISR%Ap')
    call mma_allocate(ISR%p,nRoots,nRoots,Label='ISR%p')
    call mma_allocate(ISR%prec,nRoots,nRoots,Label='ISR%prec')
    call mma_allocate(ISR%Xvec,nRoots,nRoots,Label='ISR%Xvec')

    ISR%Ap(:,:) = Zero
    ISR%p(:,:) = Zero
    ISR%prec(:,:) = Zero
    ISR%Xvec(:,:) = Zero
  end if

  !! The rest is for CGS
  !! actually, if InvSCF = .false., it is usually better to use CGS
  CGS = CGS .or. do_RF ! .or. DWSCF%do_DW
  if (CGS) then

    call mma_allocate(ISR%Pvec,nRoots,nRoots,Label='ISR%Pvec')
    call mma_allocate(ISR%Qvec,nRoots,nRoots,Label='ISR%Qvec')
    call mma_allocate(ISR%Uvec,nRoots,nRoots,Label='ISR%Uvec')
    call mma_allocate(ISR%R0,nRoots,nRoots,Label='ISR%R0')

    ISR%Pvec(:,:) = Zero
    ISR%Qvec(:,:) = Zero
    ISR%Uvec(:,:) = Zero
    ISR%R0(:,:) = Zero
  end if

  if (iPL >= 2) then
    if (.not. InvEne) write(u6,'(1X,A)') 'Target energy is non-invariant with respect to internal state rotations'
    if (.not. InvSCF) write(u6,'(1X,A)') 'Internal rotations are iteratively determined'
    if (.not. InvSol) write(u6,'(1X,A)') 'Solvent ESP is non-invariant with respect to internal state rotations'
    if (CGS) write(u6,'(1X,A)') 'Preconditioned conjugate gradient squared (CGS) method is used'
    if (.not. InvEne .or. (.not. InvSCF) .or. (.not. InvSol) .or. CGS) write(u6,*)
  end if

end subroutine ISR_init

!-----------------------------------------------------------------------

subroutine ISR_final()

  use cgs_mod, only: CGS

  call mma_deallocate(ISR%Rvec)

  !! Not quite safe for unequally weighted SA-RASSCF...
  if (.not. InvSCF) then
    call mma_deallocate(ISR%Ap)
    !call mma_deallocate(ISR%p) ! deallocated in ISR_final2
    call mma_deallocate(ISR%prec)
    call mma_deallocate(ISR%Xvec)
  end if

  if (CGS) then
    call mma_deallocate(ISR%Pvec)
    call mma_deallocate(ISR%Qvec)
    call mma_deallocate(ISR%Uvec)
    call mma_deallocate(ISR%R0)
  end if

end subroutine ISR_final

!-----------------------------------------------------------------------

subroutine ISR_final2()

  if (.not. InvSCF) call mma_deallocate(ISR%p)

end subroutine ISR_final2

!-----------------------------------------------------------------------

subroutine ISR_RHS(CI,CIDER)

  use input_mclr, only: ERASSCF, ncsf, nRoots, State_Sym

  real(kind=wp), intent(in) :: CI(ncsf(State_Sym),nRoots), CIDER(ncsf(State_Sym),nRoots)
  integer(kind=iwp) :: i, j
  real(kind=wp) :: scal
  real(kind=wp), external :: ddot_

  ! Construct the RHS (with minus) of state rotation

  do i=1,nRoots
    do j=1,i-1
      scal = DDot_(ncsf(State_Sym),CI(:,i),1,CIDER(:,j),1)-DDot_(ncsf(State_Sym),CI(:,j),1,CIDER(:,i),1)
      if (InvSCF) then
        ! non-iterative internal state rotations, if invariant
        ISR%Rvec(i,j) = ISR%Rvec(i,j)+scal/(ERASSCF(j)-ERASSCF(i))
      else
        ! initial residue (for iterative solution)
        ISR%Rvec(i,j) = ISR%Rvec(i,j)+scal
      end if
    end do
  end do

  !write(6,*) 'initial state rotation'
  !call sqprt(isr%rvec,nroots)

end subroutine ISR_RHS

!-----------------------------------------------------------------------

subroutine ISR_projection(CI,CIDER)

  use input_mclr, only: ncsf, nRoots, State_Sym

  real(kind=wp), intent(in) :: CI(ncsf(State_Sym),nRoots)
  real(kind=wp), intent(inout) :: CIDER(ncsf(State_Sym),nRoots)
  integer(kind=iwp) :: i, j
  real(kind=wp) :: scal
  real(kind=wp), external :: ddot_

  ! Project out the internal rotation contribution

  do i=1,nRoots
    do j=1,nRoots
      scal = DDot_(ncsf(State_Sym),CI(:,i),1,CIDER(:,j),1)
      CIDER(:,j) = CIDER(:,j)-Scal*CI(:,i)
    end do
  end do

end subroutine ISR_projection

!-----------------------------------------------------------------------

subroutine ISR_TimesE2(MODE,CI,CIDER)

  use input_mclr, only: ERASSCF, ncsf, nRoots, State_Sym, Weight
  !use DWSol, only: DWSCF, DWSol_Der

  integer(kind=iwp), intent(in) :: MODE
  real(kind=wp), intent(in) :: CI(ncsf(State_Sym),nRoots)
  real(kind=wp), intent(inout) :: CIDER(ncsf(State_Sym),nRoots)
  integer(kind=iwp) :: i, j
  real(kind=wp) :: fact, scal
  !real(kind=wp), allocatable :: DERHII(:), DEROMG(:)
  real(kind=wp), external :: ddot_

# include "macros.fh"
  unused_var(mode)

  ! Compute the C-S and S-S blocks of the Ap operation

  !! if do_RF and unequal_SA are true, this subroutine is called twice, so the S-S block has to be halved
  fact = One
  if (do_RF .and. unequal_SA) fact = Half

  if (.not. InvSCF) then
    do i=1,nRoots
      do j=1,i-1
        scal = Zero
        if (IntRotOff) then
          !! Note that CIDER has been multiplied by Weight or W_SOLV
          scal = DDot_(ncsf(State_Sym),CI(:,i),1,CIDER(:,j),1)-DDot_(ncsf(State_Sym),CI(:,j),1,CIDER(:,i),1)
        end if
        if (ScalWeight .and. (abs(Weight(i)-Weight(j)) > 1.0e-9_wp)) then
          ISR%Ap(i,j) = ISR%Ap(i,j)+scal+(ERASSCF(i)-ERASSCF(j))*ISR%p(i,j)*Two*fact*(Weight(i)-Weight(j))
        else
          ISR%Ap(i,j) = ISR%Ap(i,j)+scal+(ERASSCF(i)-ERASSCF(j))*ISR%p(i,j)*Two*fact
        end if
      end do
      !! The diagonal contribution is for dynamically weighted methods
      ISR%Ap(i,i) = ISR%Ap(i,i)+ISR%p(i,i)*fact
    end do
  end if

  !! Derivative of H for DW-MCSCF is evaluated with CI derivatives
  !! DW solvation is evaluated in DWder_MCLR
  !if ((mode == 1) .and. DWSCF%do_DW) then
  !  call mma_allocate(DEROMG,nRoots,Label='DEROMG')
  !  DEROMG = Zero
  !  if (IntRotOff) then
  !    do i=1,nRoots
  !      ! CIDER has been scaled with the weight in cisigma_sa
  !      if (weight(i) >= 1.0e-8_wp) then
  !        DEROMG(i) = DDot_(ncsf(State_Sym),CI(:,i),1,CIDER(:,i),1)/weight(i)
  !      else
  !        DEROMG(i) = Zero !! under consideration
  !      end if
  !    end do
  !  end if
  !
  !  call mma_allocate(DERHII,nRoots,Label='DERHII')
  !  DERHII(:) = Zero
  !  call DWSol_Der(mode,DEROMG,DERHII,ERASSCF,weight)
  !
  !  do i=1,nRoots
  !    !! not sure why 1/4
  !    !! One reason is CIDER has been scaled by two, and the other is ?
  !    ISR%Ap(i,i) = ISR%Ap(i,i)+DERHII(i)*Quart
  !  end do
  !  call mma_deallocate(DERHII)
  !  call mma_deallocate(DEROMG)
  !end if

end subroutine ISR_TimesE2

!-----------------------------------------------------------------------

subroutine DMInvISR(ISRotIn,ISRotOut)

  use input_mclr, only: ERASSCF, nRoots, Weight

  real(kind=wp), intent(in) :: ISRotIn(nRoots,nRoots)
  real(kind=wp), intent(inout) :: ISRotOut(nRoots,nRoots)
  integer(kind=iwp) :: i, j
  logical(kind=iwp) :: Edeg, Wdeg

  ! diagonal preconditioning for the internal state rotation Hessian

  do i=1,nRoots
    do j=1,i-1
      Edeg = .false.
      if (abs(ERASSCF(i)-ERASSCF(j)) < 1.0e-9_wp) Edeg = .true.
      Wdeg = .false.
      if (ScalWeight .and. (abs(Weight(i)-Weight(j)) < 1.0e-9_wp)) Wdeg = .true.
      ! How to avoid the zero divsion for degenerated states?
      if (Edeg .and. Wdeg) then
        ISRotOut(i,j) = Half*ISRotIn(i,j)
      else if (Wdeg .or. (.not. ScalWeight)) then
        ISRotOut(i,j) = Half*ISRotIn(i,j)/(ERASSCF(i)-ERASSCF(j))
      else if (Edeg .and. ScalWeight) then
        ISRotOut(i,j) = Half*ISRotIn(i,j)/(Weight(i)-Weight(j))
      else
        ISRotOut(i,j) = Half*ISRotIn(i,j)/((ERASSCF(i)-ERASSCF(j))*(Weight(i)-Weight(j)))
      end if
    end do
    ISRotOut(i,i) = ISRotIn(i,i)
  end do

end subroutine DMInvISR

end module ISRotation

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

Module Interfaces_SCF

Implicit None
Private
Public :: dOne_SCF, MinDns, OccDef, PMat_SCF, TraClc_i, vOO2OV

Interface

  SubRoutine dOne_SCF(nSym,nBas,nOrb,nFro,CMO,nCMO,Occ,Dlt,alpha_density)
    Integer :: nSym,nCMO,nBas(nSym),nOrb(nSym),nFro(nSym)
    Real*8, Target:: CMO(nCMO), Occ(*), Dlt(*)
    Logical :: alpha_density
  End SubRoutine dOne_SCF

  SubRoutine MinDns(Dens,mBT,NumD,XCff,ltXCff,nD)
    Integer :: mBT,NumD,ltXCff,nD
    Real*8 :: XCff(ltXCff,nD)
    Real*8, Target :: Dens(mBT,nD,NumD)
  End SubRoutine MinDns

  SubRoutine OccDef(Occ,mmB,nD,CMO,mBB)
    Integer :: mmB,nD,mBB
    Real*8 :: Occ(mmB,nD)
    Real*8, Target :: CMO(mBB,nD)
  End SubRoutine OccDef

  SubRoutine PMat_SCF(Dens,OneHam,TwoHam,nDT,NumDT,nXCf,FstItr,XCf,nD,E_DFT,nE_DFT,Vxc,Fock)
    Integer :: nDT,NumDT,nXCf,nD,nE_DFT
    Real*8, Target :: Dens(nDT,nD,NumDT)
    Real*8 :: OneHam(nDT),XCf(nXCf,nD),E_DFT(nE_DFT),Vxc(nDT,nD,NumDT),Fock(nDT,nD)
    Real*8, Target :: TwoHam(nDT,nD,NumDT)
    Logical :: FstItr
  End SubRoutine PMat_SCF

  SubRoutine TraClc_i(OneHam,Dens,TwoHam,Vxc,nDT,NumDT,iterLw,TrDh,TrDP,TrDD,nTr,nD)
    Integer :: nDT,NumDT,iterLw,nTr,nD
    Real*8 :: OneHam(nDT),TrDh(nTr,nTr,nD),TrDP(nTr,nTr,nD),TrDD(nTr,nTr,nD)
    Real*8, Target :: Dens(nDT,nD,NumDT),TwoHam(nDT,nD,NumDT),Vxc(nDT,nD,NumDT)
  End SubRoutine TraClc_i

  SubRoutine vOO2OV(v1,n1,v2,n2,nD)
    Integer :: n1,n2,nD
    Real*8, Target :: v1(n1,nd),v2(n2,nD)
  End SubRoutine vOO2OV

End Interface

End Module Interfaces_SCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine individual_ranks(nDIMCF,BC,BS,Hinit,LJ,iprint)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDIMCF, iprint
real(kind=wp), intent(in) :: BC(nDIMcf,0:nDIMcf), BS(nDIMcf,0:nDIMcf)
complex(kind=wp), intent(in) :: Hinit(nDIMcf,nDIMcf)
character, intent(in) :: LJ
integer(kind=iwp) :: i, ik, ikmax, info, ip, iq, ir, j, jEnd, k, m, n, nfields
real(kind=wp) :: Tnrm, TnrmKQ, wt
complex(kind=wp) :: redME
character(len=16) :: field(8)
character(len=6) :: iprog
integer(kind=iwp), allocatable :: projKQ(:), rankKQ(:)
real(kind=wp), allocatable :: ListKQ(:), Rnrm(:), RnrmKQ(:,:), Snrm(:), Winit(:), Wk(:,:), Ws(:,:), Wtmp(:)
complex(kind=wp), allocatable :: HCF(:,:,:), HCFS(:,:,:), HKQ(:,:), O(:,:), Tmp(:,:), W(:,:), Ztmp(:,:)
real(kind=wp), external :: dznrm2_

!-----------------------------------------------------------------------
call mma_allocate(Rnrm,nDIMCF,label='Rnrm')
call mma_allocate(Snrm,nDIMCF,label='Snrm')
call mma_allocate(Wk,nDIMCF,nDIMCF,label='Wk')
call mma_allocate(Ws,nDIMCF,nDIMCF,label='Ws')
call mma_allocate(Wtmp,nDIMCF,label='Wtmp')
call mma_allocate(Winit,nDIMCF,label='Winit')
call mma_allocate(RnrmKQ,[1,nDIMcf],[-nDIMcf,nDIMcf],label='RnrmKQ')
call mma_allocate(ListKQ,nDIMCF*(2*nDIMCF+1),label='ListKQ')
call mma_allocate(rankKQ,nDIMCF*(2*nDIMCF+1),label='rankKQ')
call mma_allocate(projKQ,nDIMCF*(2*nDIMCF+1),label='projKQ')

call mma_allocate(O,nDIMCF,nDIMCF,label='O')
call mma_allocate(W,nDIMCF,nDIMCF,label='W')
call mma_allocate(HKQ,nDIMCF,nDIMCF,label='HKQ')
call mma_allocate(HCF,nDIMCF,nDIMCF,nDIMCF,label='HCF')
call mma_allocate(HCFS,nDIMCF,nDIMCF,nDIMCF,label='HCFS')
call mma_allocate(Tmp,nDIMCF,nDIMCF,label='Tmp')
call mma_allocate(Ztmp,nDIMCF,nDIMCF,label='Ztmp')

Rnrm(:) = Zero
Snrm(:) = Zero
Tnrm = Zero

HCF(:,:,:) = cZero
HCFS(:,:,:) = cZero
!-----------------------------------------------------------------------
! re-construct the  initial CF matrix:
do N=2,nDIMcf-1,2
  do M=0,N
    call Liviu_ESO(nDIMcf,N,M,O,W,redME)
    if (M == 0) then
      HCF(N,:,:) = HCF(N,:,:)+BC(N,0)*O(:,:)
    else
      HCF(N,:,:) = HCF(N,:,:)+BC(N,M)*O(:,:)+BS(N,M)*W(:,:)
    end if
  end do
end do

do k=2,nDIMCF-1,2
  do ik=2,k
    ! add the ranks as follows:
    ! O2= O2
    ! O4= O2+O4
    ! O6= O2+O4+O6
    ! O8= O2+O4+O6+O8
    ! etc...
    ! compute the cumulative CF matrix
    HCFS(k,:,:) = HCFS(k,:,:)+HCF(ik,:,:)
  end do
end do

do N=2,nDIMCF-1,2
  Tmp(:,:) = HCF(N,:,:)
  Rnrm(N) = dznrm2_(nDIMcf*nDIMcf,Tmp,1)
  Tnrm = Tnrm+Rnrm(N)
  do i=2,N,2
    Snrm(N) = Snrm(N)+Rnrm(i)
  end do
end do
! compute the CF spinting of individual weight operators:
do k=2,nDIMcf-1,2
  Tmp(:,:) = HCF(k,:,:)
  call DIAG_C2(Tmp,nDIMcf,info,Wtmp,Ztmp)
  Wk(k,:) = Wtmp(:)
  Tmp(:,:) = HCFS(k,:,:)
  call DIAG_C2(Tmp,nDIMcf,info,Wtmp,Ztmp)
  Ws(k,:) = Wtmp(:)
end do
! set the initial energies as to the sum of all contributions:
call DIAG_C2(Hinit,nDIMcf,info,Winit,Ztmp)
call mma_deallocate(Wtmp)
call mma_deallocate(Tmp)

!-----------------------------------------------------------------------
! individual parameter contribution:
TnrmKQ = Zero
RnrmKQ(:,:) = Zero
ListKQ(:) = Zero
projKQ(:) = 0
rankKQ(:) = 0
ik = 0
do N=2,nDIMcf-1,2
  do M=-N,N
    ik = ik+1
    ! generate ITO operators:
    call Liviu_ITO(nDIMcf,N,abs(M),O,W,redME)
    ! generate HCF for each parameter rank and projection:
    if (M < 0) then
      HKQ(:,:) = BS(N,abs(M))*W(:,:)
    else if (M >= 0) then
      HKQ(:,:) = BC(N,abs(M))*O(:,:)
    end if
    ! find the rank value of each NM operator
    ! for further estimate the effect of the corresponding CF parameter
    RnrmKQ(N,M) = dznrm2_(nDIMcf*nDIMcf,HKQ,1)
    TnrmKQ = TnrmKQ+RnrmKQ(N,M)

    ! indexing lists
    ListKQ(ik) = RnrmKQ(N,M)
    rankKQ(ik) = N
    projKQ(ik) = M
  end do
end do
ikmax = ik
! make an ordered list of CF parameters
! following their descending effect:
call sort_KQ(ikmax,ListKQ,rankKQ,projKQ,2)
!--------- below we just print the data --------------------------------
if (LJ == 'L') then
  iprog = 'RASSCF'
else
  iprog = ' RASSI'
end if

if (iprint >= 4) then
  write(u6,'(A,F20.12)') 'Tnrm=',Tnrm
  do k=1,nDIMCF-1
    write(u6,'(2(A,i2,A,F20.12,2x))') 'Rnrm(',k,')=',Rnrm(k),'Snrm(',k,')=',Snrm(k)
  end do
end if

! print the cumulative and individual rank weight:
write(u6,'(/)')
write(u6,'(A)') 'CUMULATIVE WEIGHT OF INDIVIDUAL-RANK OPERATORS ON THE CRYSTAL FIELD SPLITTING:'
if ((nDIMCF-1) >= 2) write(u6,'(2x,A,F10.6,A)') 'O2 :------------------------------------------: ',(Snrm(2)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 4) write(u6,'(2x,A,F10.6,A)') 'O2 + O4 :-------------------------------------: ',(Snrm(4)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 6) write(u6,'(2x,A,F10.6,A)') 'O2 + O4 + O6 :--------------------------------: ',(Snrm(6)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 8) write(u6,'(2x,A,F10.6,A)') 'O2 + O4 + O6 + O8 :---------------------------: ',(Snrm(8)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 10) write(u6,'(2x,A,F10.6,A)') 'O2 + O4 + O6 + O8 + O10 :---------------------: ',(Snrm(10)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 12) write(u6,'(2x,A,F10.6,A)') 'O2 + O4 + O6 + O8 + O10 + O12 :---------------: ',(Snrm(12)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 14) write(u6,'(2x,A,F10.6,A)') 'O2 + O4 + O6 + O8 + O10 + O12 + O14 :---------: ',(Snrm(14)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 16) write(u6,'(2x,A,F10.6,A)') 'O2 + O4 + O6 + O8 + O10 + O12 + O14 + O16 :---: ',(Snrm(16)/Tnrm)*100.0_wp,' %.'

!-----------------------------------------------------------------------
write(u6,*)
write(u6,'(A)') 'ENERGY SPLITTING INDUCED BY CUMMULATIVE INDIVIDUAL-RANK OPERATORS (in cm-1).'
field(1) = '      O2       |'
field(2) = '     O2+O4     |'
field(3) = '   O2+O4+O6    |'
field(4) = '  O2+O4+O6+O8  |'
field(5) = ' O2+O4+...+O10 |'
field(6) = ' O2+O4+...+O12 |'
field(7) = ' O2+O4+...+O14 |'
field(8) = ' O2+O4+...+O16 |'
nfields = (nDIMCF-1)/2
do J=1,nfields,4
  jEnd = min(nfields,J+3)
  write(u6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)

  if (mod(nDIMcf,2) == 1) then
    write(u6,'(3A,I2,3x,A,5x,A,4x,A,10(5x,A,6x,A))') '  ',LJ,' =',(nDIMcf-1)/2,'|',iprog,'|',('ONLY','|',i=j,jEnd)
  else
    write(u6,'(3A,I3,A,5x,A,4x,A,10(5x,A,6x,A))') ' ',LJ,' =',nDIMcf-1,'/2 |',iprog,'|',('ONLY','|',i=j,jEnd)
  end if

  write(u6,'(10x,10A)') '|     INITIAL   |',(field(i),i=j,jEnd)
  write(u6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)
  do i=1,nDIMcf
    write(u6,'(1x,A,1x,i2,2x,a,12(f14.8,1x,a))') 'w.f.',i,'|',(Winit(i)-Winit(1)),'|',((Ws(k,i)-Ws(k,1)),'|',k=2*j,2*jEnd,2)
  end do
  write(u6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)
end do ! j

write(u6,'(/)')
write(u6,'(A)') 'WEIGHT OF INDIVIDUAL-RANK OPERATORS ON THE CRYSTAL FIELD SPLITTING:'
if ((nDIMCF-1) >= 2) write(u6,'(2x,A,F10.6,A)') 'O2  :-----------------------------------------: ',(Rnrm(2)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 4) write(u6,'(2x,A,F10.6,A)') 'O4  :-----------------------------------------: ',(Rnrm(4)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 6) write(u6,'(2x,A,F10.6,A)') 'O6  :-----------------------------------------: ',(Rnrm(6)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 8) write(u6,'(2x,A,F10.6,A)') 'O8  :-----------------------------------------: ',(Rnrm(8)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 10) write(u6,'(2x,A,F10.6,A)') 'O10 :-----------------------------------------: ',(Rnrm(10)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 12) write(u6,'(2x,A,F10.6,A)') 'O12 :-----------------------------------------: ',(Rnrm(12)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 14) write(u6,'(2x,A,F10.6,A)') 'O14 :-----------------------------------------: ',(Rnrm(14)/Tnrm)*100.0_wp,' %.'
if ((nDIMCF-1) >= 16) write(u6,'(2x,A,F10.6,A)') 'O16 :-----------------------------------------: ',(Rnrm(16)/Tnrm)*100.0_wp,' %.'

!-----------------------------------------------------------------------
write(u6,'(/)')
write(u6,'(A)') 'ENERGY SPLITTING INDUCED BY INDIVIDUAL-RANK OPERATORS (in cm-1).'
field(1) = '      O2       |'
field(2) = '      O4       |'
field(3) = '      O6       |'
field(4) = '      O8       |'
field(5) = '      O10      |'
field(6) = '      O12      |'
field(7) = '      O14      |'
field(8) = '      O16      |'
nfields = (nDIMCF-1)/2

do J=1,nfields,4
  jEnd = min(nfields,J+3)
  write(u6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)

  if (mod(nDIMcf,2) == 1) then
    write(u6,'(3A, I2,3x,A,5x,A,4x,A,10(5x,A,6x,A))') '  ',LJ,' =',(nDIMcf-1)/2,'|',iprog,'|',('ONLY','|',i=j,jEnd)
  else
    write(u6,'(3A,I3,a,5x,A,4x,A,10(5x,A,6x,A))') ' ',LJ,' =',nDIMcf-1,'/2 |',iprog,'|',('ONLY','|',i=j,jEnd)
  end if

  write(u6,'(10x,10A)') '|     INITIAL   |',(field(i),i=j,jEnd)
  write(u6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)
  do i=1,nDIMcf
    write(u6,'(1x,A,1x,i2,2x,a,12(f14.8,1x,a))') 'w.f.',i,'|',(Winit(i)-Winit(1)),'|',((Wk(k,i)-Wk(k,1)),'|',k=2*j,2*jEnd,2)
  end do
  write(u6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)
end do ! j

!-----------------------------------------------------------------------
write(u6,'(/)')
write(u6,'(A)') 'WEIGHT OF INDIVIDUAL CRYSTAL FIELD PARAMETERS ON THE CRYSTAL FIELD SPLITTING: (in descending order):'
write(u6,'(A)') 'CFP are given in ITO used in J. Chem. Phys. 137, 064112 (2012).'

write(u6,'(2A)') repeat('-',55),'|'
write(u6,'(A)') '  k |  q  |         B(k,q)        |    Weight (in %)   |'
write(u6,'(A)') '----|-----|-----------------------|--------------------|'
do ik=1,ikmax
  ip = projKQ(ik)
  iq = abs(projKQ(ik))
  ir = rankKQ(ik)
  wt = 100.0_wp*ListKQ(ik)/TnrmKQ

  if (projKQ(ik) >= 0) then
    write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),(ES22.14,1x,A),F19.14,1x,A)') ir,'|',ip,'|',BC(ir,iq),'|',wt,'|'
  else
    write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),(ES22.14,1x,A),F19.14,1x,A)') ir,'|',ip,'|',BS(ir,iq),'|',wt,'|'
  end if
end do
write(u6,'(A)') '----|-----|-----------------------|--------------------|'

!-----------------------------------------------------------------------
call mma_deallocate(Rnrm)
call mma_deallocate(Snrm)
call mma_deallocate(Wk)
call mma_deallocate(Ws)
call mma_deallocate(Winit)

call mma_deallocate(O)
call mma_deallocate(W)
call mma_deallocate(HKQ)
call mma_deallocate(HCF)
call mma_deallocate(HCFS)
call mma_deallocate(Ztmp)
call mma_deallocate(RnrmKQ)
call mma_deallocate(ListKQ)
call mma_deallocate(rankKQ)
call mma_deallocate(projKQ)

return

end subroutine individual_ranks

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine Localise_Iterative(irc,Model,Functional)
C
C     Author: T.B. Pedersen
C
C     Purpose: Iterative localisation of orbitals.
C              Models implemented:
C                Pipek-Mezey         [MODEL='PIPE']
C                Boys                [MODEL='BOYS']
C                Edmiston-Ruedenberg [MODEL='EDMI']
C
      Implicit Real*8 (a-h,o-z)
      Character*4 Model
#include "Molcas.fh"
#include "inflocal.fh"
#include "WrkSpc.fh"
#include "debug.fh"

      Character*18 SecNam
      Parameter (SecNam = 'Localise_Iterative')

      Character*4  myModel
      Character*80 Txt
      Logical Converged

      irc = 0
      Functional = -9.9d9
      Converged  = .False.

C     Generate Cholesky start guess, if requested.
C     --------------------------------------------

      If (ChoStart) Then
         Thrs_Save = Thrs
         Thrs = 1.0d-12
         Call Localise_Noniterative(irc,'Chol',xNrm)
         If (irc .ne. 0) Then
            Write(Txt,'(A,I4)') 'Return code:',irc
            Call SysAbendMsg(SecNam,'Localise_Noniterative failed!',Txt)
         End If
         Thrs = Thrs_Save
      End If

C     Localise.
C     ---------

      myModel = Model
      Call UpCase(myModel)
      If (myModel .eq. 'PIPE') Then
*        If (.not.Silent) Then
            Write(6,'(//,1X,A)') 'Pipek-Mezey localisation'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Convergence threshold:',Thrs,' (functional)'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Convergence threshold:',ThrGrad,' (gradient)'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Screening threshold  :',ThrRot,' (orbital rotations)'
            Write(6,'(1X,A,8(1X,I6))')
     &      'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
            Write(6,'(1X,A,8(1X,I6))')
     &      'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
*        End If
         Call PipekMezey(Functional,Work(ipCMO),Thrs,ThrRot,ThrGrad,
     &                   Name,
     &                   nBas,nOrb2Loc,nFro,
     &                   nSym,nAtoms,nMxIter,
     &                   Maximisation,Converged,Debug,Silent)
      Else If (myModel .eq. 'BOYS') Then
*        If (.not.Silent) Then
            Write(6,'(/,1X,A)') 'Boys localisation'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Convergence threshold:',Thrs,' (functional)'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Convergence threshold:',ThrGrad,' (gradient)'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Screening threshold  :',ThrRot,' (orbital rotations)'
            Write(6,'(1X,A,8(1X,I6))')
     &      'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
            Write(6,'(1X,A,8(1X,I6))')
     &      'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
*        End If
         Call Boys(Functional,Work(ipCMO),Thrs,ThrRot,ThrGrad,
     &             nBas,nOrb2Loc,nFro,
     &             nSym,nMxIter,
     &             Maximisation,Converged,Debug,Silent)
      Else If (myModel .eq. 'EDMI') Then
*        If (.not.Silent) Then
            Write(6,'(/,1X,A)') 'Edmiston-Ruedenberg localisation'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Convergence threshold:',Thrs,' (functional)'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Convergence threshold:',ThrGrad,' (gradient)'
c           Write(6,'(1X,A,1X,D12.4,A)')
c    &      'Screening threshold  :',ThrRot,' (orbital rotations)'
            Write(6,'(1X,A,8(1X,I6))')
     &      'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
            Write(6,'(1X,A,8(1X,I6))')
     &      'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
*        End If
         Call EdmistonRuedenberg(Functional,Work(ipCMO),Thrs,ThrRot,
     &                           ThrGrad,
     &                           nBas,nOrb2Loc,nFro,
     &                           nSym,nMxIter,
     &                           Maximisation,Converged,Debug,Silent)
      Else
         Write(Txt,'(A,A4)') 'Model = ',Model
         Call SysAbendMsg(SecNam,'Unknown model',Txt)
      End If

      If (.not.Converged) Then
         irc = 1
         Return
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Roland Lindh                                     *
************************************************************************
      Module External_Centers
      Implicit None
      Private
#include "stdalloc.fh"
      Public :: nEF, EF_Centers,
     &          OAM_Center, OMQ_Center, nDMS, DMS_Centers, Dxyz,
     &          nWel, Wel_Info, AMP_Center, nRP, RP_Centers,
     &          nData_XF, nXF, nXMolnr, XF, XEle, XMolnr,
     &          nOrdEF, nOrd_XF, iXPolType,
     &          External_Centers_Dmp,
     &          External_Centers_Free,
     &          External_Centers_Get
      Integer :: nEF=0, nOrdEF=-1
      Real*8, Allocatable:: EF_Centers(:,:)
      Real*8, Allocatable:: OAM_Center(:)
      Real*8, Allocatable:: OMQ_Center(:)
      Integer :: nDMS=0
      Real*8, Allocatable:: DMS_Centers(:,:)
      Real*8 :: Dxyz(3)=[0.0D0, 0.0D0, 0.0D0]
      Integer :: nWel=0
      Real*8, Allocatable:: Wel_Info(:,:)
      Real*8, Allocatable:: AMP_Center(:)
      Integer :: nRP=0
      Real*8, Target, Allocatable:: RP_Centers(:,:,:)
      Integer :: nData_XF=0, nXF=0, nXMolnr=0, nOrd_XF=1, iXPolType=0
      Real*8, Allocatable:: XF(:,:)
      Integer, Allocatable:: XEle(:), XMolnr(:,:)
*                                                                      *
************************************************************************
*                                                                      *
      Contains
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine External_Centers_Dmp()
#include "angtp.fh"
      Real*8, Allocatable:: RP_Temp(:,:,:)
      Integer, Allocatable:: iDmp(:)
      Real*8, Allocatable:: DMS_Ext(:,:)
      If (Allocated(EF_Centers)) Then
         Call Put_dArray('EF_Centers',EF_Centers,3*nEF)
      End If
      If (Allocated(OAM_Center)) Then
         Call Put_dArray('OAM_Center',OAM_Center,3)
      End If
      If (Allocated(OMQ_Center)) Then
         Call Put_dArray('OMQ_Center',OMQ_Center,3)
      End If
      If (Allocated(DMS_Centers)) Then
         Call mma_allocate(DMS_Ext,3,nDMS+1,Label='DMS_Ext')
         DMS_ext(1:3,1:nDMS)=DMS_Centers(1:3,1:nDMS)
         DMS_ext(1:3,nDMS+1)=Dxyz(1:3)
         Call Put_dArray('DMS_Centers',DMS_Ext,3*(nDMS+1))
         Call mma_deallocate(DMS_Ext)
      End If
      If (Allocated(Wel_Info)) Then
         Call Put_dArray('Wel_Info',Wel_Info,3*nWel)
      End If
      If (Allocated(AMP_Center)) Then
         Call Put_dArray('AMP_Center',AMP_Center,3)
      End If
      If (Allocated(RP_Centers)) Then
         Call mma_allocate(RP_Temp,3,nRP/3,2)
         RP_Temp(:,:,1)=RP_Centers(:,1:nRP/3,1)
         RP_Temp(:,:,2)=RP_Centers(:,1:nRP/3,2)
         Call Put_dArray('RP_Centers',RP_Temp,nRP*2)
         Call mma_deallocate(RP_Temp)
      End If
      If (Allocated(XF)) Then
         Call Put_dArray('XF',XF,nData_XF*nXF)
      End If
      If (Allocated(XMolnr)) Then
         Call Put_iArray('XMolnr',XMolnr,nXMolnr*nXF)
      End If
      If (Allocated(XEle)) Then
         Call Put_iArray('XEle',XEle,nXF)
      End If
      Call mma_Allocate(iDmp,3,Label='iDmp')
      iDmp(1)=nOrdEF
      iDmp(2)=nOrd_XF
      iDmp(3)=iXPolType
      Call Put_iArray('Misc',iDmp,3)
      Call mma_deallocate(iDmp)
      Return
      End Subroutine External_Centers_Dmp
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine External_Centers_Free()
      If (Allocated(EF_Centers)) Then
         Call mma_deallocate(EF_Centers)
         nEF=0
      End If
      If (Allocated(OAM_Center)) Call mma_deallocate(OAM_Center)
      If (Allocated(OMQ_Center)) Call mma_deallocate(OMQ_Center)
      If (Allocated(DMS_Centers)) Then
         Call mma_deallocate(DMS_Centers)
         nDMS=0
      End If
      If (Allocated(Wel_Info)) Then
         Call mma_deallocate(Wel_Info)
         nWel=0
      End If
      If (Allocated(AMP_Center)) Call mma_deallocate(AMP_Center)
      If (Allocated(RP_Centers)) Then
         Call mma_deallocate(RP_Centers)
         nRP=0
      End If
      If (Allocated(XF)) Then
         Call mma_deallocate(XF)
         Call mma_deallocate(XMolnr)
         Call mma_deallocate(XEle)
         nData_XF=0
         nXF=0
         nXMolnr=0
         nOrdEF=-1
         nOrd_XF=1
         iXPolType=0
      End If
      Return
      End Subroutine External_Centers_Free
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine External_Centers_Get()
      Integer, Allocatable:: iDmp(:)
      Real*8, Allocatable:: DMS_Ext(:,:)
      Logical Found
      Integer Len2
      Call qpg_dArray('EF_Centers',Found,Len2)
      If (Found) Then
         nEF=Len2/3
         If (Allocated(EF_Centers)) Then
            If (SIZE(EF_Centers,2).ne.nEF) Then
               Write (6,*) 'SIZE(EF_Centers,2).ne.nEF'
               Call Abend()
            End If
         Else
            Call mma_allocate(EF_Centers,3,nEF,Label='EF_Centers')
         End If
         Call Get_dArray('EF_Centers',EF_Centers,3*nEF)
      End If
*
      Call qpg_dArray('OAM_Center',Found,Len2)
      If (Found) Then
         If (.Not.Allocated(OAM_Center)) Then
            Call mma_allocate(OAM_Center,3,Label='OAM_Center')
         End If
         Call Get_dArray('OAM_Center',OAM_Center,3)
      End If
*
      Call qpg_dArray('OMQ_Center',Found,Len2)
      If (Found) Then
         If (.Not.Allocated(OMQ_Center)) Then
            Call mma_allocate(OMQ_Center,3,Label='OMQ_Center')
         End If
         Call Get_dArray('OMQ_Center',OMQ_Center,3)
      End If
*
      Call qpg_dArray('DMS_Centers',Found,Len2)
      If (Found) Then
         nDMS=Len2/3-1
         If (Allocated(DMS_Centers)) Then
            If (SIZE(DMS_Centers,2).ne.nDMS) Then
               Write (6,*) 'SIZE(DMS_Centers,2).ne.nDMS'
               Call Abend()
            End If
         Else
            Call mma_allocate(DMS_Centers,3,nDMS,Label='DMS_Centers')
         End If
         call mma_allocate(DMS_Ext,3,nDMS+1,Label='DMS_Ext')
         Call Get_dArray('DMS_Centers',DMS_Ext,3*(nDMS+1))
         DMS_Centers(1:3,1:nDMS)= DMS_Ext(1:3,1:nDMS)
         Dxyz(1:3) =              DMS_Centers(1:3,nDMS+1)
         call mma_deallocate(DMS_Ext)
      End If
*
      Call qpg_dArray('Wel_Info',Found,Len2)
      If (Found) Then
         nWel=Len2/3
         If (Allocated(Wel_Info)) Then
            If (SIZE(Wel_Info,2).ne.nWel) Then
               Write (6,*) 'SIZE(Wel_Info,2).ne.nWel'
               Call Abend()
            End If
         Else
            Call mma_allocate(Wel_Info,3,nWel,Label='Wel_Info')
         End If
         Call Get_dArray('Wel_Info',Wel_Info,3*nWel)
      End If
*
      Call qpg_dArray('AMP_Center',Found,Len2)
      If (Found) Then
         If (.Not.Allocated(AMP_Center)) Then
            Call mma_allocate(AMP_Center,3,Label='AMP_Center')
         End If
         Call Get_dArray('AMP_Center',AMP_Center,3)
      End If
*
      Call qpg_dArray('RP_Centers',Found,Len2)
      If (Found) Then
         nRP=Len2/2
         If (Allocated(RP_Centers)) Then
            If (SIZE(RP_Centers,2).ne.nRP/3) Then
               Write (6,*) 'SIZE(RP_Centers,2).ne.nRP/3'
               Call Abend()
            End If
         Else
            Call mma_allocate(RP_Centers,3,nRP/3,2,Label='RP_Centers')
         End If
         Call Get_dArray('RP_Centers',RP_Centers,2*nRP)
      End If
*
      Call qpg_iArray('XEle',Found,Len2)
      If (Found) Then
         nXF=Len2
         If (.Not.Allocated(XEle)) Then
            Call mma_allocate(XEle,nXF,Label='XEle')
         End If
         Call Get_iArray('XEle',XEle,nXF)
*
         Call qpg_dArray('XMolnr',Found,Len2)
         nXMolnr=Len2/nXF
         If (.Not.Allocated(XMolnr)) Then
            Call mma_allocate(XMolnr,nXMolnr,nXF,Label='XMolnr')
         End If
         Call Get_iArray('XMolnr',XMolnr,nXMolnr*nXF)
*
         Call qpg_dArray('XF',Found,Len2)
         nData_XF=Len2/nXF
         If (.Not.Allocated(XF)) Then
            Call mma_allocate(XF,nData_XF,nXF,Label='XF')
         End If
         Call Get_dArray('XF',XF,nData_XF*nXF)
      End If
      Call mma_Allocate(iDmp,3,Label='iDmp')
      Call Get_iArray('Misc',iDmp,3)
      nOrdEF    = iDmp(1)
      nOrd_XF   = iDmp(2)
      iXPolType = iDmp(3)
      Call mma_deallocate(iDmp)
      End Subroutine External_Centers_Get
*                                                                      *
************************************************************************
*                                                                      *
      End Module External_Centers

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2007, Roland Lindh                                *
!***********************************************************************

subroutine PGet2_CD2(iCmp,iBas,jBas,kBas,lBas,iAO,iAOst,nijkl,PSO,nPSO,CoulFac,PMax,V_k,mV_k)
!***********************************************************************
!  Object: to assemble the 2nd order density matrix of a SCF wave      *
!          function from the 1st order density matrix.                 *
!                                                                      *
!          The indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             January '92.                                             *
!                                                                      *
!             Modified for Cholesky 1-center gradients May 2007 by     *
!             R. Lindh                                                 *
!***********************************************************************

use Index_Functions, only: iTri
use Basis_Info, only: nBas
use SOAO_Info, only: iAOtSO
use Symmetry_Info, only: Mul, nIrrep
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCmp(4), iBas, jBas, kBas, lBas, iAO(4), iAOst(4), nijkl, nPSO, mV_k
real(kind=wp), intent(out) :: PSO(nijkl,nPSO), PMax
real(kind=wp), intent(in) :: CoulFac, V_K(mV_K)
integer(kind=iwp) :: i1, i2, i3, i4, iAOi, Indij, Indkl, iPntij, iPntkl, is, iSO, iSOi, iSym(0:7), j, j1, j12, j123, j2, j3, j4, &
                     jAOj, js, jSO, jSOj, jSym(0:7), kAOk, ks, kSO, kSOk, kSym(0:7), lAOl, lOper, ls, lSO, lSOl, lSym(0:7), &
                     MemSO2, mijkl, niSym, njSym, nkSym, nlSym
real(kind=wp) :: Fac, temp
integer(kind=iwp), external :: iPntSO

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('V_K',' ',V_K,1,mV_K)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
lOper = 1
PMax = Zero

! Quadruple loop over elements of the basis functions angular description.
! Observe that we will walk through the memory in AOInt in a sequential way.

!Fac = Quart
Fac = One
MemSO2 = 0
do i1=1,iCmp(1)
  niSym = 0
  do j=0,nIrrep-1
    if (iAOtSO(iAO(1)+i1,j) > 0) then
      iSym(niSym) = j
      niSym = niSym+1
    end if
  end do
  do i2=1,iCmp(2)
    njSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) then
        jSym(njSym) = j
        njSym = njSym+1
      end if
    end do
    do i3=1,iCmp(3)
      nkSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(3)+i3,j) > 0) then
          kSym(nkSym) = j
          nkSym = nkSym+1
        end if
      end do
      do i4=1,iCmp(4)
        nlSym = 0
        do j=0,nIrrep-1
          if (iAOtSO(iAO(4)+i4,j) > 0) then
            lSym(nlSym) = j
            nlSym = nlSym+1
          end if
        end do

        ! Loop over irreps which are spanned by the basis function.

        do is=0,niSym-1
          j1 = iSym(is)

          do js=0,njSym-1
            j2 = jSym(js)
            j12 = Mul(j1+1,j2+1)-1

            do ks=0,nkSym-1
              j3 = kSym(ks)
              j123 = Mul(j12+1,j3+1)-1
              do ls=0,nlSym-1
                j4 = lSym(ls)
                if (j123 /= j4) cycle

                MemSO2 = MemSO2+1

                ! Unfold the way the eight indicies have been reordered.
                iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)
                jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
                kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)
                lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)

                if ((j1 /= j2) .and. (j1 /= j3) .and. (j1 /= j4)) then
                  ! all irreps are different and the 2nd order density
                  ! matrix will be identical to zero for a SCF type wave
                  ! function.
                  PSO(:,MemSO2) = Zero
                  exit
                end if

                mijkl = 0
                do lAOl=0,lBas-1
                  lSOl = lSO+lAOl
                  do kAOk=0,kBas-1
                    kSOk = kSO+kAOk
                    do jAOj=0,jBas-1
                      jSOj = jSO+jAOj
                      do iAOi=0,iBas-1
                        iSOi = iSO+iAOi
                        mijkl = mijkl+1

                        ! Contribution V_k(ij)*V_k(kl) to P(ijkl)
                        if (j1 == j2) then
                          ! j3 == j4 also
                          iPntij = iPntSO(j1,j2,lOper,nbas)
                          iPntkl = iPntSO(j3,j4,lOper,nbas)
                          Indij = iPntij+iTri(iSOi,jSOj)
                          Indkl = iPntkl+iTri(kSOk,lSOl)
                          temp = V_k(Indij)*V_k(Indkl)*CoulFac
                        else
                          temp = Zero
                        end if

                        ! Contribution -1/4*D(ik)*D(jl) to P(ijkl)
                        !if (j1 == 3) then
                        !  ! j2 == 4 also
                        !end if

                        ! Contribution -1/4*D(il)*D(jk) to P(ijkl)
                        !if (j1 == 4) then
                        !  ! j2 == 3 also
                        !end if

                        PMax = max(PMax,abs(Temp))
                        PSO(mijkl,MemSO2) = Fac*temp

                      end do
                    end do
                  end do
                end do

              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do
if (nPSO /= MemSO2) then
  write(u6,*) ' PGet2_CD2: nPSO /= MemSO2'
  write(u6,*) nPSO,MemSO2
  call Abend()
end if

#ifdef _DEBUGPRINT_
call RecPrt(' In PGet2_CD2:PSO ',' ',PSO,nijkl,nPSO)
#endif

return

end subroutine PGet2_CD2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jeppe Olsen                                            *
************************************************************************
      SUBROUTINE BLKCLS(   IBLKS,   NBLKS, IBLKCLS, ISPSPCL,    NCLS,
     &                      LCLS,  NOCTPA,  NOCTPB)
*
* Class of each block, and dimension of each class
*
* Jeppe Olsen
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      INTEGER IBLKS(8,NBLKS)
      INTEGER ISPSPCL(NOCTPA,NOCTPB)
*. Output
      INTEGER IBLKCLS(NBLKS),LCLS(NCLS)
*
C?    WRITE(6,*) ' ISPSPCL'
C?    CALL IWRTMA(ISPSPCL,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
      IZERO = 0
      CALL ISETVC(LCLS,IZERO,NCLS)
      DO JBLK = 1, NBLKS
        IICLS = ISPSPCL(IBLKS(1,JBLK),IBLKS(2,JBLK))
        IBLKCLS(JBLK) = IICLS
        LCLS(IICLS) = LCLS(IICLS) + IBLKS(8,JBLK)
      END DO
*
      NTEST = 000
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' BLKCLS Speaking '
        WRITE(6,*) ' ==============='
        WRITE(6,*)
        WRITE(6,*) ' Dimension of each class '
        CALL IWRTMA(LCLS,1,NCLS,1,NCLS)
        WRITE(6,*)
        WRITE(6,*) ' Class of each block : '
        CALL IWRTMA(IBLKCLS,1,NBLKS,1,NBLKS)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  GAUSSJ    := Define sequence of simple updates from orb transf.    *
!*                                                                     *
!***********************************************************************
subroutine gaussj_cvb(orbs,gjorb)

use casvb_global, only: gjorb_type, norb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: orbs(norb,norb)
type(gjorb_type), intent(_OUT_) :: gjorb
integer(kind=iwp) :: i
integer(kind=iwp), allocatable :: lrow(:)
real(kind=wp), allocatable :: a(:,:)

call mma_allocate(a,norb,norb,label='a')
call mma_allocate(lrow,norb,label='lrow')
a(:,:) = orbs(:,:)
call gaussj2_cvb(a,lrow,gjorb%i1,gjorb%i2,gjorb%r,norb)
lrow(:) = gjorb%i1(:)
do i=1,norb
  gjorb%i1(lrow(i)) = i
end do
call mma_deallocate(a)
call mma_deallocate(lrow)

return

end subroutine gaussj_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE TS_SYM_PNT2(   IGRP,  NIGRP, MAXVAL, MINVAL,   ISYM,
     &                          IPNT,   LPNT)
*
* Construct pointers to start of symmetrydistributions
* for supergroup of strings with given symmetry
*
* The start of symmetry block ISYM1 ISYM2 ISYM3 .... ISYMN
* is given as
*     1
*     +  (ISM1-MINVAL(1))
*     +  (ISM2-MINVAL(2))*(MAXVAL(1)-MINVAL(1)+1)
*     +  (ISM3-MINVAL(3))*(MAXVAL(1)-MINVAL(1)+1)*(MAXVAL(2)-MINVAL(2)+1)
*     +
*     +
*     +
*     +  (ISM L-1-MINVAL(L-1))*Prod(i=1,L-2)(MAXVAL(i)-MINVAL(i)+1)
*
* Where L is the last group of strings with nonvanishing occupation
*
* Jeppe Olsen, September 1997
*
* Version 2 : Uses IGRP and NIGRP to define supergroup
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
!      COMMON/BIGGY/WORK(MXPWRD)
#include "orbinp.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "strbas.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "csm.fh"
*. Specific Input
      INTEGER IGRP(NIGRP)
*. Local scratch
      INTEGER ISMFGS(MXPNGAS),ITPFGS(MXPNGAS)
C-jwk-cleanup      INTEGER NELFGS(MXPNGAS)
      INTEGER NNSTSGP(MXPNSMST,MXPNGAS)
*. Output
      INTEGER MINVAL(*),MAXVAL(*),IPNT(*)
*
      NTEST = 00
*. Info on groups of strings in supergroup
      NGASL = 1
      DO IGAS = 1, NIGRP
       ITPFGS(IGAS) = IGRP(IGAS)
       IF(NELFGP(IGRP(IGAS)).GT.0) NGASL = IGAS
*. Number of strings per symmetry in each gasspace
C       CALL ICOPVE2(WORK(KNSTSGP(1)),(ITPFGS(IGAS)-1)*NSMST+1,NSMST,
C    &               NNSTSGP(1,IGAS))
        CALL ICOPVE(NSTFSMGP(1,IGRP(IGAS)),NNSTSGP(1,IGAS),NSMST)
      END DO
*
C     NGASL = NIGRP
*
C     DO IGAS = 1, NIGRP
C       DO ISMST = 1, NSMST
C         IF(NNSTSGP(ISMST,IGAS).GT.0) MAXVAL(IGAS) = ISMST
C       END DO
C       DO ISMST = NSMST,1,-1
C         IF(NNSTSGP(ISMST,IGAS).GT.0) MINVAL(IGAS) = ISMST
C       END DO
C     END DO
      DO IGAS = 1, NIGRP
        MINVAL(IGAS) = MINMAX_SM_GP(1,IGRP(IGAS))
        MAXVAL(IGAS) = MINMAX_SM_GP(2,IGRP(IGAS))
      END DO
*
      IF(NTEST.GE.1000) THEN
        write(6,*) 'NIGRP:', NIGRP
        WRITE(6,*)  ' MINVAL and MAXVAL '
        CALL IWRTMA(MINVAL,1,NIGRP,1,NIGRP)
        CALL IWRTMA(MAXVAL,1,NIGRP,1,NIGRP)
      END IF

*. Total number of symmetry blocks that will be generated
      NBLKS = 1
      DO IGAS = 1, NGASL-1
       NBLKS = NBLKS*(MAXVAL(IGAS)-MINVAL(IGAS)+1)
      END DO
      IF(NBLKS.GT.LPNT) THEN
        WRITE(6,*) ' Problem in TS_SYM_PNT'
        WRITE(6,*) ' Dimension of IPNT too small'
        WRITE(6,*) ' Actual and required length',NBLKS,LPNT
        WRITE(6,*)
        WRITE(6,*) ' I will Stop and wait for instructions'
*        STOP' TS_SYM_PNT too small'
        CALL SYSABENDMSG('lucia_util/ts_sym_pnt',
     &                    'Internal error',' ')
      END IF
*. Loop over symmetry blocks in standard order
      IFIRST = 1
      ISTRBS = 1
      NSTRINT = 0
 2000 CONTINUE
        IF(IFIRST .EQ. 1 ) THEN
          DO IGAS = 1, NGASL - 1
            ISMFGS(IGAS) = MINVAL(IGAS)
          END DO
        ELSE
*. Next distribution of symmetries in NGAS -1
         CALL NXTNUM3(ISMFGS,NGASL-1,MINVAL,MAXVAL,NONEW)
         IF(NONEW.NE.0) GOTO 2001
        END IF
        IFIRST = 0
*. Symmetry of NGASL -1 spaces given, symmetry of full space
C       ISTSMM1 = 1
C       DO IGAS = 1, NGASL -1
C         CALL  SYMCOM(3,1,ISTSMM1,ISMFGS(IGAS),JSTSMM1)
C         ISTSMM1 = JSTSMM1
C       END DO
        ISTSMM1 = ISYMSTR(ISMFGS,NGASL-1)
*.  sym of SPACE NGASL
        CALL SYMCOM(2,1,ISTSMM1,ISMGSN,ISYM)
        ISMFGS(NGASL) = ISMGSN
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' next symmetry of NGASL spaces '
          CALL IWRTMA(ISMFGS,1,NGASL,1,NGASL)
        END IF
*. Number of strings with this symmetry combination
        NSTRII = 1
        DO IGAS = 1, NGASL
          NSTRII = NSTRII*NNSTSGP(ISMFGS(IGAS),IGAS)
        END DO
*. Offset for this symmetry distribution in IOFFI
        IOFF = 1
        MULT = 1
        DO IGAS = 1, NGASL-1
          IOFF = IOFF + (ISMFGS(IGAS)-MINVAL(IGAS))*MULT
          MULT = MULT * (MAXVAL(IGAS)-MINVAL(IGAS)+1)
        END DO
*
        IPNT(IOFF) = NSTRINT + 1
        NSTRINT = NSTRINT + NSTRII
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' IOFF, IPNT(IOFF) NSTRII ',
     &                 IOFF, IPNT(IOFF),NSTRII
        END IF
*
      IF(NGASL-1.GT.0) GOTO 2000
 2001 CONTINUE
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' Output from TS_SYM_PNT'
        WRITE(6,*) ' Required total symmetry',ISYM
        WRITE(6,*) ' Number of symmetry blocks ', NBLKS
        WRITE(6,*)
        WRITE(6,*) ' Offset array  for symmetry blocks'
        CALL IWRTMA(IPNT,1,NBLKS,1,NBLKS)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Jeppe Olsen                                      *
!***********************************************************************

subroutine CNFSTR(ICONF,ITYP,IASTR,IBSTR,NORB,NAEL,NBEL,IDET,IPRODT,ISCR,SGN,IPREXH)
! An orbital configuration ICONF is given
! Obtain the corresponding alpha strings, IASTR
!        the corresponding beta  strings, IBSTR
!        the corresponding sign  array  , SGN
!
! Jeppe Olsen, Summer of '89

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NORB, ICONF(NORB), ITYP, NAEL, NBEL, IDET, IPRODT(*)
integer(kind=iwp), intent(inout) :: IPREXH
integer(kind=iwp), intent(out) :: IASTR(NAEL,IDET), IBSTR(NBEL,IDET), ISCR(NAEL+NBEL,0:IDET)
real(kind=wp), intent(out) :: SGN(IDET)
integer(kind=iwp) :: ICLOS, IOCC, IOPEN, IP, ISGN, JDET, JTYP, NEL, NTEST
#include "spinfo.fh"
#include "ciinfo.fh"

NEL = NAEL+NBEL
IOPEN = ITYP-1+MINOP
ICLOS = (NEL-IOPEN)/2
IOCC = IOPEN+ICLOS

! Spin orbital occupations of determinants of configuration

! Pointer for determinants of prototype ITYP
IP = 1
do JTYP=1,ITYP-1
  IP = IP+NDTFTP(JTYP)*(JTYP-1+MINOP)
end do
call CNDET(ICONF,IPRODT(IP),IDET,NEL,NORB,IOPEN,ICLOS,ISCR(:,1:),IPREXH)

! Separate determinants into strings and determine sign change

do JDET=1,IDET
  call DETSTR2(ISCR(:,JDET),IASTR(:,JDET),IBSTR(:,JDET),NEL,NAEL,NBEL,ISGN,ISCR(:,0),IPREXH)
  SGN(JDET) = real(ISGN,kind=wp)
end do

NTEST = 0
if (NTEST >= 1) then
  write(u6,*) ' Output from CNFSTR'
  write(u6,*) ' =================='
  write(u6,*) ' Input configuration'
  call IWRTMA(ICONF,1,IOCC,1,IOCC)
  write(u6,*) ' Corresponding alpha and beta strings'
  call IWRTMA(IASTR,NAEL,IDET,NAEL,IDET)
  call IWRTMA(IBSTR,NBEL,IDET,NBEL,IDET)
  write(u6,*) ' SIGN ARRAY'
  call WRTMAT(SGN,1,IDET,1,IDET)
end if

return

end subroutine CNFSTR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine newjkqpar(n1,n2,H,J,B,S)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, cZero, cOne, Onei
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: n1, n2
complex(kind=wp), intent(in) :: H(n1,n1,n2,n2)
complex(kind=wp), intent(out) :: J(n1-1,-(n1-1):n1-1,n2-1,-(n2-1):n2-1), B(n1-1,-(n1-1):n1-1,n2-1,-(n2-1):n2-1), &
                                 S(n1-1,-(n1-1):n1-1,n2-1,-(n2-1):n2-1)
integer(kind=iwp) :: k1, k2, m1, m12, m2, q1, q2
real(kind=wp) :: C01, C02, cr1, cr2, F1, F2, knm(12,0:12), r1, r2
complex(kind=wp) :: c1, c12, c2, cc1, cc2, cf1, cf2
complex(kind=wp), allocatable :: O1(:,:), O2(:,:), W1(:,:), W2(:,:)
complex(kind=wp), external :: trace_exch2
#ifdef _DEBUGPRINT_
complex(kind=wp), allocatable :: HAM(:,:,:,:)
real(kind=wp), external :: dznrm2_
#endif

!-------------------------------------------
if ((n1 < 1) .or. (n2 < 1)) return
!-------------------------------------------
call mma_allocate(O1,n1,n1,'operator O1')
call mma_allocate(W1,n1,n1,'operator W1')
call mma_allocate(O2,n2,n2,'operator O2')
call mma_allocate(W2,n2,n2,'operator W2')
call set_knm(knm)
!-------------------------------------------
J(:,:,:,:) = cZero
B(:,:,:,:) = cZero
S(:,:,:,:) = cZero
do k1=1,n1-1
  do q1=0,k1
    do k2=1,n2-1
      do q2=0,k2

        m1 = (-1)**q1
        m2 = (-1)**q2
        m12 = (-1)**(q1+q2)
        c1 = m1*cOne
        c2 = m2*cOne
        c12 = m12*cOne

        ! generate the operators for site 1 and 2:
        call ITO(n1,k1,q1,C01,O1,W1)
        call ITO(n2,k2,q2,C02,O2,W2)

        ! compute the scaling factors for various Operators
        call coeff_redus_sub(n1,k1,cr1)
        call coeff_redus_sub(n2,k2,cr2)
        cc1 = One/(cr1*C01)*cOne
        cc2 = One/(cr2*C02)*cOne
        r1 = C01*C01*real(2*k1+1,kind=wp)/real(n1,kind=wp)
        r2 = C02*C02*real(2*k2+1,kind=wp)/real(n2,kind=wp)
        cf1 = c1*(r1*cOne)
        cf2 = c2*(r2*cOne)

        ! find the parameters:
        ! in the Naoya's operators
        J(k1,-q1,k2,-q2) = cf1*cf2*trace_exch2(n1,n2,H,O1,O2)
        J(k1,-q1,k2,q2) = cf1*cf2*trace_exch2(n1,n2,H,O1,W2)
        J(k1,q1,k2,-q2) = cf1*cf2*trace_exch2(n1,n2,H,W1,O2)
        J(k1,q1,k2,q2) = cf1*cf2*trace_exch2(n1,n2,H,W1,W2)

        ! in the Liviu operators
        B(k1,-q1,k2,-q2) = J(k1,-q1,k2,-q2)*cc1*cc2
        B(k1,-q1,k2,q2) = J(k1,-q1,k2,q2)*cc1*cc2
        B(k1,q1,k2,-q2) = J(k1,q1,k2,-q2)*cc1*cc2
        B(k1,q1,k2,q2) = J(k1,q1,k2,q2)*cc1*cc2

        ! generate real parameters for Extended Stevens Operators formalism:
        if ((q1 > 0) .and. (q2 > 0)) then
          ! BB = (Jmm + (-1)^q2 Jmp + (-1)^q1 Jpm + (-1)^(q1 + q2) Jpp);
          S(k1,q1,k2,q2) = B(k1,-q1,k2,-q2)+c2*B(k1,-q1,k2,q2)+c1*B(k1,q1,k2,-q2)+c12*B(k1,q1,k2,q2)
          ! BC = (Jmm - (-1)^q2 Jmp + (-1)^q1 Jpm - (-1)^(q1 + q2) Jpp) (-I);
          S(k1,q1,k2,-q2) = -Onei*(B(k1,-q1,k2,-q2)-c2*B(k1,-q1,k2,q2)+c1*B(k1,q1,k2,-q2)-c12*B(k1,q1,k2,q2))
          ! CB = (Jpp + (-1)^q2 Jpm - (-1)^q1 Jmp - (-1)^(q1 + q2) Jmm) (-I);
          S(k1,-q1,k2,q2) = -Onei*(B(k1,-q1,k2,-q2)+c2*B(k1,-q1,k2,q2)-c1*B(k1,q1,k2,-q2)-c12*B(k1,q1,k2,q2))
          ! CC = (-Jpp + (-1)^q2 Jpm + (-1)^q1 Jmp - (-1)^(q1 + q2) Jmm);
          S(k1,-q1,k2,-q2) = -B(k1,-q1,k2,-q2)+c2*B(k1,-q1,k2,q2)+c1*B(k1,q1,k2,-q2)-c12*B(k1,q1,k2,q2)
        else if ((q1 == 0) .and. (q2 > 0)) then
          S(k1,q1,k2,q2) = (B(k1,q1,k2,-q2)+c2*B(k1,q1,k2,q2))
          S(k1,q1,k2,-q2) = -Onei*(B(k1,q1,k2,-q2)-c2*B(k1,q1,k2,q2))
        else if ((q1 > 0) .and. (q2 == 0)) then
          S(k1,q1,k2,q2) = (B(k1,-q1,k2,q2)+c1*B(k1,q1,k2,q2))
          S(k1,-q1,k2,q2) = -Onei*(B(k1,-q1,k2,q2)-c1*B(k1,q1,k2,q2))
        else if ((q1 == 0) .and. (q2 == 0)) then
          S(k1,q1,k2,q2) = B(k1,q1,k2,q2)
        end if

      end do
    end do
  end do
end do

! scale the Stevens parameters to match the ESO operators:
do k1=1,n1-1
  do q1=-k1,k1
    do k2=1,n2-1
      do q2=-k2,k2
        F1 = Zero
        F2 = Zero
        if (k1 <= 12) F1 = knm(k1,abs(q1))
        if (k2 <= 12) F2 = knm(k2,abs(q2))
        S(k1,q1,k2,q2) = S(k1,q1,k2,q2)*(F1*F2*cOne)
      end do
    end do
  end do
end do

! in case verification is needed:
#ifdef _DEBUGPRINT_
call mma_allocate(HAM,n1,n1,n2,n2,'recovered HAM_S')
write(u6,'(A)') 'Extracted exchange parameters: J(k1,q1,k2,q2):'
write(u6,'(A)') 'using Naoya ITO:'
do k1=1,n1-1
  do q1=-k1,k1
    do k2=1,n2-1
      do q2=-k2,k2
        !if (abs(S(k1,q1,k2,q2)) > 1.0e-20_wp) then
        write(u6,'(4(A,i2),A,2ES22.13)') 'J(',k1,',',q1,',',k2,',',q2,') = ',J(k1,q1,k2,q2)
        !end if
      end do
    end do
  end do
end do
call recover_exch_HAM_from_Naoya_ITO(n1,n2,J,HAM)
write(u6,'(A,ES20.10)') 'recover from Naoya Jkqkq parameters'
write(u6,'(A,ES24.14)') 'JKQP: total difference between HAM-H=',dznrm2_(n1*n1*n2*n2,HAM-H,1)

write(u6,'(A)') 'Extracted exchange parameters: B(k1,q1,k2,q2):'
write(u6,'(A)') 'using Liviu ITO:'
do k1=1,n1-1
  do q1=-k1,k1
    do k2=1,n2-1
      do q2=-k2,k2
        !if (abs(S(k1,q1,k2,q2)) > 1.0e-20_wp) then
        write(u6,'(4(A,i2),A,2ES22.13)') 'B(',k1,',',q1,',',k2,',',q2,') = ',B(k1,q1,k2,q2)
        !end if
      end do
    end do
  end do
end do
call recover_exch_HAM_from_Liviu_ITO(n1,n2,B,HAM)
write(u6,'(A,ES20.10)') 'recover from Liviu Bkqkq parameters'
write(u6,'(A,ES24.14)') 'JKQP: total difference between HAM-H=',dznrm2_(n1*n1*n2*n2,HAM-H,1)

write(u6,'(A)') 'Extracted exchange parameters: S(k1,q1,k2,q2):'
write(u6,'(A)') 'using Stevens ESO:'
do k1=1,n1-1
  do q1=-k1,k1
    do k2=1,n2-1
      do q2=-k2,k2
        !if (abs(S(k1,q1,k2,q2)) > 1.0e-20_wp) then
        write(u6,'(4(A,i2),A,2ES22.13)') 'S(',k1,',',q1,',',k2,',',q2,') = ',S(k1,q1,k2,q2)
        !end if
      end do
    end do
  end do
end do
call recover_exch_HAM_from_Stevens_ESO(n1,n2,S,HAM)
write(u6,'(A,ES20.10)') 'recover from Stevens Skqkq parameters'
write(u6,'(A,ES24.14)') 'JKQP: total difference between HAM-H=',dznrm2_(n1*n1*n2*n2,HAM-H,1)
call mma_deallocate(HAM)
#endif

!=======================================================================
call mma_deallocate(O1)
call mma_deallocate(O2)
call mma_deallocate(W1)
call mma_deallocate(W2)

return

end subroutine newjkqpar

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DefParo3v3Hlp1 (i,j,Schem,Nomen)
c
c       help routine to DefParo2v4, producing names of Disc files
c       ex: Schem='XY', i=1, j=3  ->  Nomen='XY0103'
c        N.B. suspendovana rutina
c
        implicit none
        integer i,j
        character*2 Schem
        character*6 Nomen
c
c       help variables
        character*1 Chr(1:6)
        character*2 digit(1:64)
        character*2 ichr,jchr
        character*2 baza
        character*6 meno
c
        equivalence (Chr(1),meno)
        equivalence (Chr(1),baza)
        equivalence (Chr(3),ichr)
        equivalence (Chr(5),jchr)
c
c
c        quite a porno this piece
        digit(1)='01'
        digit(2)='02'
        digit(3)='03'
        digit(4)='04'
        digit(5)='05'
        digit(6)='06'
        digit(7)='07'
        digit(8)='08'
        digit(9)='09'
        digit(10)='10'
        digit(11)='11'
        digit(12)='12'
        digit(13)='13'
        digit(14)='14'
        digit(15)='15'
        digit(16)='16'
        digit(17)='17'
        digit(18)='18'
        digit(19)='19'
        digit(20)='20'
        digit(21)='21'
        digit(22)='22'
        digit(23)='23'
        digit(24)='24'
        digit(25)='25'
        digit(26)='26'
        digit(27)='27'
        digit(28)='28'
        digit(29)='29'
        digit(30)='30'
        digit(31)='31'
        digit(32)='32'
        digit(33)='33'
        digit(34)='34'
        digit(35)='35'
        digit(36)='36'
        digit(37)='37'
        digit(38)='38'
        digit(39)='39'
        digit(40)='40'
        digit(41)='41'
        digit(42)='42'
        digit(43)='43'
        digit(44)='44'
        digit(45)='45'
        digit(46)='46'
        digit(47)='47'
        digit(48)='48'
        digit(49)='49'
        digit(50)='50'
        digit(51)='51'
        digit(52)='52'
        digit(53)='53'
        digit(54)='54'
        digit(55)='55'
        digit(56)='56'
        digit(57)='57'
        digit(58)='58'
        digit(59)='59'
        digit(60)='60'
        digit(61)='61'
        digit(62)='62'
        digit(63)='63'
        digit(64)='64'
c
c
        baza=Schem
        ichr=digit(i)
        jchr=digit(j)
        Nomen=meno
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_T_pair_mould

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_init_T_pair_mould,           &
             fmm_close_T_pair_mould

   INTEGER(INTK), SAVE :: LHS_LMAX, RHS_LMAX
    ! flag to test initialisation
   CHARACTER(LEN=11), SAVE :: fmm_init_mould

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_close_T_pair_mould

      IMPLICIT NONE
      IF (fmm_init_mould /= 'initialised') STOP 'mm_T_pair_mould init'
      fmm_init_mould = ' '
      LHS_LMAX = 0
      RHS_LMAX = 0

   END SUBROUTINE fmm_close_T_pair_mould

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_set_T_pair_basics(LHS,RHS,id,weight,T_pair)

      IMPLICIT NONE
      TYPE(gen_mm_paras),  INTENT(IN)  :: LHS, RHS
      TYPE(LHS_RHS_type),  INTENT(IN)  :: id
      INTEGER(INTK),       INTENT(IN)  :: weight
      TYPE(T_pair_single), INTENT(OUT) :: T_pair

      T_pair%N_or_T = 'N' ! not used for T contractions, so null
      ! init. normalisation scalar for other options
      T_pair%paras%ratio = one
      ! here, T_pair%r_ab is the unnormalised vector

      ! weighting to account for double-counting in T-pair generation
      T_pair%paras%weight = weight

      T_pair%LMAX = MAX(T_pair%paras%LHS_LMAX,T_pair%paras%RHS_LMAX)
      T_pair%lm_max = (1+T_pair%LMAX)**2

! Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_integer_array(LHS%raw_paras%id)
         CALL Unused_integer_array(RHS%raw_paras%id)
         CALL Unused_integer(id%LHS)
      END IF
   END SUBROUTINE fmm_set_T_pair_basics

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_set_RR_paras(LHS,RHS,id,T_pair)

      IMPLICIT NONE
      TYPE(gen_mm_paras),  INTENT(IN)  :: LHS, RHS
      TYPE(LHS_RHS_type),  INTENT(IN)  :: id
      TYPE(T_pair_single), INTENT(OUT) :: T_pair

      ! interaction vector for building T-matrix
      T_pair%r_ab = RHS%raw_paras(id%RHS)%cntr - LHS%raw_paras(id%LHS)%cntr
      ! indices to map back to actual moments in separate array
      T_pair%paras%LHS_id = LHS%raw_paras(id%LHS)%id
      T_pair%paras%RHS_id = RHS%raw_paras(id%RHS)%id
      ! check that paras:moments mapping was built
      IF (T_pair%paras%LHS_id == 0) CALL fmm_quit('LHS paras:moments mapping')
      IF (T_pair%paras%RHS_id == 0) CALL fmm_quit('RHS paras:moments mapping')

   END SUBROUTINE fmm_set_RR_paras

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_set_BB_paras(LHS,RHS,id,T_pair)

      IMPLICIT NONE
      TYPE(gen_mm_paras),  INTENT(IN)  :: LHS, RHS
      TYPE(LHS_RHS_type),  INTENT(IN)  :: id
      TYPE(T_pair_single), INTENT(OUT) :: T_pair

      ! interaction vector for building T-matrix
      T_pair%r_ab = RHS%box_paras(id%RHS)%cntr - LHS%box_paras(id%LHS)%cntr
      ! indices to map back to actual moments in separate array
      T_pair%paras%LHS_id = LHS%box_paras(id%LHS)%id
      T_pair%paras%RHS_id = RHS%box_paras(id%RHS)%id
      ! check that paras:moments mapping was built
      IF (T_pair%paras%LHS_id == 0) CALL fmm_quit('LHS paras:moments mapping')
      IF (T_pair%paras%RHS_id == 0) CALL fmm_quit('RHS paras:moments mapping')

   END SUBROUTINE fmm_set_BB_paras

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_set_LHS_LMAX(X,Y,T_pair)

      IMPLICIT NONE
      TYPE(gen_mm_paras),  INTENT(IN)  :: X        ! dummy variables
      TYPE(LHS_RHS_type),  INTENT(IN)  :: Y        ! dummy variables
      TYPE(T_pair_single), INTENT(OUT) :: T_pair

      T_pair%paras%LHS_LMAX = LHS_LMAX

! Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_integer_array(X%raw_paras%id)
         CALL Unused_integer(Y%LHS)
      END IF
   END SUBROUTINE fmm_set_LHS_LMAX

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_set_RHS_LMAX(X,Y,T_pair)

      IMPLICIT NONE
      TYPE(gen_mm_paras),  INTENT(IN)  :: X        ! dummy variables
      TYPE(LHS_RHS_type),  INTENT(IN)  :: Y        ! dummy variables
      TYPE(T_pair_single), INTENT(OUT) :: T_pair

      T_pair%paras%RHS_LMAX = RHS_LMAX

! Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_integer_array(X%raw_paras%id)
         CALL Unused_integer(Y%LHS)
      END IF
   END SUBROUTINE fmm_set_RHS_LMAX

!-------------------------------------------------------------------------------
! This routine directs the saving of functions in fmm_proc_selector.c
! relevant to the formation of a T-pair entity.
! There are 4 parts to the making of a T-pair once raw data has been
! suppplied from the classical interaction search algorithm.
! These are all called consecutively from the C-code via
! fmm_stored_t_pair_mould.
! The 4 functions saved are selected here and depend on whether
! pure boxed moments, or unboxed moments, are being contracted.

   SUBROUTINE fmm_init_T_pair_mould(scheme,pair_type)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      INTEGER(INTK),      INTENT(IN) :: pair_type
      EXTERNAL fmm_store_t_pair_mould1   ! raw/box dependent variables
      EXTERNAL fmm_store_t_pair_mould2   ! set LMAX (LHS)
      EXTERNAL fmm_store_t_pair_mould3   ! set LMAX (RHS)
      EXTERNAL fmm_store_t_pair_mould4   ! common to all T-pair builds

      CALL fmm_store_t_pair_mould2(fmm_set_LHS_LMAX)
      CALL fmm_store_t_pair_mould3(fmm_set_RHS_LMAX)
      CALL fmm_store_t_pair_mould4(fmm_set_T_pair_basics)
      SELECT CASE (pair_type)
      CASE (LHS_raw_RHS_raw)
         LHS_LMAX = scheme%raw_LMAX
         RHS_LMAX = scheme%raw_LMAX
         CALL fmm_store_t_pair_mould1(fmm_set_RR_paras)
      CASE (LHS_box_RHS_box)
         LHS_LMAX = scheme%trans_LMAX
         RHS_LMAX = scheme%trans_LMAX
         CALL fmm_store_t_pair_mould1(fmm_set_BB_paras)
      CASE DEFAULT
         CALL fmm_quit ('cannot recognise T_pair type!')
      END SELECT

      fmm_init_mould = 'initialised'

   END SUBROUTINE fmm_init_T_pair_mould

!-------------------------------------------------------------------------------

END MODULE fmm_T_pair_mould

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Integral_RICD( &
#                        define _CALLING_
#                        include "int_wrout_interface.fh"
                        )

use Definitions, only: wp, iwp, u6

implicit none
#include "int_wrout_interface.fh"

#include "macros.fh"
unused_var(iShell)
unused_var(MapOrg)
unused_var(Shijij)
unused_var(IJeqKL)
unused_var(SOInt(1))
unused_var(nSOint)
unused_var(iSOSym)
unused_var(nSkal)

if (mSym == 1) then
  ! note that iTOffs is being abused for something else
  call PLF_RICD(AOInt,ijkl,iCmp(1),iCmp(2),iCmp(3),iCmp(4),iAO,iAOst,iBas,jBas,kBas,lBas,kOp,TInt,iTOffs(0,0,1),iTOffs(0,0,2), &
                iTOffs(0,0,0),iTOffs(0,0,3),iTOffs(0,0,4))
else
  write(u6,*) 'Integral_RICD: fatal error!'
  call Abend()
end if

return

end subroutine Integral_RICD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  CNFPRT   := Print configurations.                                *
c  *                                                                   *
c  *********************************************************************
      subroutine cnfprt_cvb(iconfs,nconf1,nel1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "malloc_cvb.fh"
      dimension iconfs(noe,nconf1)

      i1 = mstacki_cvb(noe)
c  Main loop over configurations :
      do 100 iconf=1,nconf1
c  Prepare iw(i1) for print
      ioffs=i1-1
      do 200 iorb=1,norb
      if(iconfs(iorb,iconf).eq.2)then
        iw(1+ioffs)=iorb
        iw(2+ioffs)=iorb
        ioffs=ioffs+2
      endif
200   continue
      do 300 iorb=1,norb
      if(iconfs(iorb,iconf).eq.1)then
        iw(1+ioffs)=iorb
        ioffs=ioffs+1
      endif
300   continue
      write(6,'(i8,a,20i3)')iconf,'   =>  ',(iw(ii+i1-1),ii=1,nel1)
100   continue
      call mfreei_cvb(i1)
      return
      end
      function nvb_cvb(kbasis_loc)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"

      ndetvb=0
      ndetvb2=0
      nvbr=0
      do 100 ifrag=1,nfrag
      if(kbasis_loc.ne.6)then
        nvb_fr(ifrag)=nvbr_fr(ifrag)
      else
        if(absym(1))then
          nvb_fr(ifrag)=ndetvb2_fr(ifrag)
        else
          nvb_fr(ifrag)=ndetvb_fr(ifrag)
        endif
      endif
      ndetvb=ndetvb+ndetvb_fr(ifrag)
      ndetvb2=ndetvb2+ndetvb2_fr(ifrag)
      nvbr=nvbr+nvbr_fr(ifrag)
100   continue

      if(kbasis_loc.ne.6)then
        nvb_loc=nvbr
      else
        if(absym(1))then
          nvb_loc=ndetvb2
        else
          nvb_loc=ndetvb
        endif
      endif
      nvb_cvb=nvb_loc
      return
      end
      function ifns_cvb(nel1,nalf1,kbasis1)
      implicit real*8 (a-h,o-z)

      nbet1=nel1-nalf1
      if(nbet1.gt.nalf1)then
        nsw=nalf1
        nalf1=nbet1
        nbet1=nsw
      endif
      if(kbasis1.ne.6)then
        call icomb_cvb(nel1,nbet1,iretval1)
        call icomb_cvb(nel1,nbet1-1,iretval2)
        ifn=iretval1-iretval2
      else
        call icomb_cvb(nel1,nalf1,ifn)
        if(nalf1.eq.nbet1)ifn=(ifn+1)/2
      endif
      ifns_cvb=ifn
      return
      end
      function ndet_cvb(nel1,nalf1)
      implicit real*8 (a-h,o-z)

      call icomb_cvb(nel1,nalf1,nd)
      ndet_cvb=nd
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NonSym(nStab,jStab,A,Tx)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nStab, jStab(0:nStab-1)
real(kind=wp), intent(in) :: A(3)
real(kind=wp), intent(inout) :: Tx(3)
integer(kind=iwp) :: iStab

do iStab=0,nStab-1
  if ((A(1) /= Zero) .and. btest(jStab(iStab),0)) cycle
  if ((A(2) /= Zero) .and. btest(jStab(iStab),1)) cycle
  if ((A(3) /= Zero) .and. btest(jStab(iStab),2)) cycle
  if (btest(jStab(iStab),0)) Tx(1) = Zero
  if (btest(jStab(iStab),1)) Tx(2) = Zero
  if (btest(jStab(iStab),2)) Tx(3) = Zero
end do

return

end subroutine NonSym

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CASPT2_Res(VECROT,nVECROT)

use caspt2_global, only: imag_shift, iVecL, jStLag, real_shift, sigma_p_epsilon
use caspt2_module, only: HZERO, IFMSCOUP, NSTATE
use EQSOLV, only: IRHS, IVECC, IVECC2, IVECR, IVECW, IVECX
use SC_NEVPT2, only: SC_prop, SC_NEVPT2_res
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nVECROT
real(kind=wp), intent(in) :: VECROT(nVECROT)
integer(kind=iwp) :: ICONV, iRHSbk, iStLag, iVecRbk, iVecXbk
real(kind=wp) :: SAV, SAVI, savreg, Scal
integer(kind=iwp), parameter :: iVecG = 8

!! Some subroutines (e.g., PSCAVEC) use NINDEP, so they cannot be
!! directly used for SC-NEVPT2. It should be easier to write from scratch
if (SC_prop) then
  call SC_NEVPT2_res(VECROT)
  return
end if

if ((HZERO == 'DYALL') .and. (real_shift == Zero) .and. (imag_shift == Zero) .and. (sigma_p_epsilon == Zero)) then
  !! The correlation energy of the target state for the plane NEVPT2 is stationary
  !! Note that IVECL for SC-NEVPT2 is in an MO (contravariant) basis
  call RHS_ZERO(iVecL)
else
  !! 1) Calculate the derivative of the CASPT2 energy with respect
  !!    to the amplitude.
  !! 2) In the standard CASPT2, solve the CASPT2 equation. In the
  !!    diagonal CASPT2, compute the lambda directly.
  !!
  !! L_S = U_{TS}*H_{TU}*U_{US}
  !!     + U_{SS}*(H_{SS} + <\Psi_S|H0-E0|\Psi_S>)*U_{SS}
  !!     + <lambda|H|\Psi0> + <lambda|H0-E0+Eshift|\Psi_S>

  !write(u6,*) 'in CASPT2_res'
  call PSCAVEC(One,IRHS,iVecL)

  !! Construct the partial derivative of the target state
  !! The derivative is constructed in iVecL
  !! The shift parameters are set to zero, because the actual energy
  !! is computed without them. The reference state has to be
  !! multiplied by two, from the above equation for L_S.
  !! For MS-CASPT2, the rotation is mutiplied later.
  SAV = real_shift
  SAVI = imag_shift
  savreg = sigma_p_epsilon
  real_shift = Zero
  imag_shift = Zero
  sigma_p_epsilon = Zero
  call SIGMA_CASPT2(Two,Two,IVECX,iVecL)
  real_shift = SAV
  imag_shift = SAVI
  sigma_p_epsilon = savreg
end if

!! Add the partial derivative contribution for MS-CASPT2
!! (off-diagonal elements). The derivative is taken with IVECW
!! and put in IVECC.
!write(u6,*) 'Ifmscoup = ',ifmscoup,nstate
if (IFMSCOUP) then
  call RHS_ZERO(IVECC)
  call PSCAVEC(VECROT(jStLag),iVecL,iVecL)
  do iStLag=1,nState
    Scal = VECROT(iStLag)
    if (iStLag == jStLag) Scal = Zero
    if (abs(VECROT(iStLag)) <= 1.0e-12_wp) cycle
    call MS_Res(1,iStLag,jStLag,Scal)
  end do
  !! Transform to SR representatin (IRHS).
  call PTRTOSR(0,IVECC,IRHS)
  !! Add to iVecL
  call PLCVEC(One,One,IRHS,iVecL)
end if

!! Finally, solve the lambda equation.
!! The following is just a copy-and-paste of eqctl2 and pcg,
!! but some unnecessary lines (comuptation of energy etc.) are
!! omitted.
!! The lambda equation is solved with the shift parameters,
!! as is the case for the T-amplitude.

iVecXbk = iVecX
iVecRbk = iVecR
iRHSbk = iRHS
iVecX = iVecR
iRHS = iVecL !! = 7
iVecR = iVecG !! = 8

call PCG_RES(ICONV)
if (ICONV /= 0) then
  write(u6,*) 'Lambda equation did not converge...'
  write(u6,*) 'Continue anyway?'
end if

iVecX = iVecXbk
iVecR = iVecRbk
iRHS = iRHSbk

!! For implicit derivative of S
if (IFMSCOUP) then
  call PTRTOSR(1,IVECW,IRHS)
  call RHS_ZERO(IVECC)
  do iStLag=1,nState
    Scal = VECROT(iStLag)*Half
    if (iStLag == jStLag) Scal = Scal*Two
    if (abs(VECROT(iStLag)) <= 1.0e-12_wp) cycle
    call MS_Res(1,iStLag,jStLag,Scal)
  end do
  call PTRTOSR(0,IVECC,iVecL)
end if

!! Restore contravariant and covariant representations of the
!! non-variational T-amplitude
call PTRTOC(0,IVECX,IVECC)
call PTRTOC(1,IVECX,IVECC2)

return

end subroutine CASPT2_Res

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine vecprint_cvb(a,n)
c Prints vector A
      implicit real*8 (a-h,o-z)
#include "print_cvb.fh"
#include "formats_cvb.fh"
      parameter (mxbuf=8)
      dimension a(n)

      nbuf=min((iwidth-4)/(iprec+4),mxbuf)
      if(nbuf.eq.7)nbuf=6
      iform=0
      do 100 ibegin=1,n,nbuf
      iend=min(ibegin+nbuf-1,n)
      if(iform.eq.0)then
        write(6,formMXP5)(a(i),i=ibegin,iend)
      else
        write(6,formMXP6)(a(i),i=ibegin,iend)
      endif
100   continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_fokunpck3(fok,fai,dimfok,dimfa,dimfi)
! this routine distributes (Fok - dp) to Fai
! fok    - Fok matrix (I)
! fai    - Fai matrix (O)
! dimfok - dimension for Fok matrix - norb (I)
! dimfa  - dimension of virtuals - nv (I)
! dimfi  - dimension of occupied - no (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimfok, dimfa, dimfi
real(kind=wp), intent(in) :: fok(dimfok,dimfok)
real(kind=wp), intent(out) :: fai(dimfa,dimfi)

!1 distribute Fok to Fai
fai(:,:) = fok(dimfi+1:dimfi+dimfa,1:dimfi)

return

end subroutine cct3_fokunpck3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine fstring_cvb(strings,nstring,istring,ncmp,ifc)
      implicit real*8 (a-h,o-z)
#include "inpmod_cvb.fh"
      character*(*) strings(nstring)
      character*8 string
      logical debug
      data debug/.false./

      if(inputmode.eq.2)then
        call gethfs_cvb(istring)
        if(debug)then
          write(6,*)' fstring :',istring
          if(istring.ne.0)write(6,*)' fstring :',strings(istring)
        endif
        return
      endif
      call popfield_cvb(ifc)
      call rdstring_cvb(string,ierr)
      do 100 istring=1,nstring
      if(string(1:ncmp).eq.strings(istring)(1:ncmp))then
c  For keywords starting by END we check more letters. This
c  implementation is a bit ungainly, but simpler to code :
        if(string(1:3).eq.'END')then
          if(string(4:ncmp+3).ne.strings(istring)(4:ncmp+3))goto 100
        endif
        goto 200
      endif
100   continue
      istring=0
      call pushfield_cvb()
200   continue
      if(inputmode.eq.1)then
        call sethfs_cvb(istring)
      endif
      if(debug)then
        write(6,*)' fstring :',istring
        if(istring.ne.0)write(6,*)' fstring :',strings(istring)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE JACOB(ARRAY,VECS,NDIM,LENVEC)
*     SUBROUTINE JACOBI(ARRAY,VECS,NDIM,LENVEC)
      Implicit Real*8 (A-H,O-Z)
*
      Dimension ARRAY(*)
      Dimension VECS(LENVEC,*)
*
      PARAMETER (EPS=1.0D-16)
      PARAMETER (EPS2=1.0D-30)
      LOGICAL IFTEST
      IfTest=.false.
#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif

      IF(NDIM.LE.1) RETURN
C A shift is applied. Use a representative diagonal value:
      NDTRI=(NDIM*(NDIM+1))/2
      SHIFT=0.5D0*(ARRAY(1)+ARRAY(NDTRI))
      SHIFT=DBLE(NINT(SHIFT))
      II=0
      DO I=1,NDIM
        II=II+I
        ARRAY(II)=ARRAY(II)-SHIFT
      END DO

* Sanity test:
      CALL CHK4NAN(NDIM*(NDIM+1)/2,Array,Ierr)
      IF (IERR .NE. 0) Then
        CALL ABEND()
      END IF

      IF (IFTEST) THEN
        WRITE(6,*)' JACOBI test prints:'
        WRITE(6,*)' NSWEEP = Nr of sweeps'
        WRITE(6,*)' NR     = Rotations this sweep'
        WRITE(6,*)' NROT   = Nr of 2-rotations (Accum)'
        WRITE(6,*)' VNSUM  = von Neumann''s sum'
        WRITE(6,*)' SBDMAX = Largest subdiag element in this sweep.'
        WRITE(6,*)
     &    '   NSWEEP   NR     NROT       VNSUM               SBDMAX'

        SBDMAX=0.0D0
        VNSUM=0.0D0
        DO I=2,NDIM
           II=(I*(I-1))/2
           DO J=1,I-1
              ARIJ=ARRAY(II+J)
              VNSUM=VNSUM+ARIJ**2
              SBDMAX=MAX(SBDMAX,ABS(ARIJ))
           END DO
        END DO
        WRITE(6,'(A,2G20.12)') ' Initial values:        ',VNSUM,SBDMAX
      END IF

C NSWEEP counts number of sweeps over subdiagonal elements.
      NSWEEP=0
C NROT counts total number of 2x2 rotations
      NROT=0

C Head of loop over sweeps
  10  CONTINUE
      NSWEEP=NSWEEP+1
C NR: Nr of 2x2 rotations in this sweep
      NR=0

      SUBDAC=0d0
      NSUBD=0
      DO I=2,NDIM
         II=(I*(I-1))/2
         DO J=1,I-1
CTEST      DO IMJ=1,NDIM-1
CTEST         DO I=IMJ+1,NDIM
CTEST            II=(I*(I-1))/2
CTEST            J=I-IMJ
            JJ=(J*(J-1))/2
            ARIJ=ARRAY(II+J)
            AAIJ=ABS(ARIJ)
            ARII=ARRAY(II+I)
            ARJJ=ARRAY(JJ+J)
            DIFF=ARII-ARJJ
            SGN=1.0D0
            IF(DIFF.LT.0.0D0) THEN
               DIFF=-DIFF
               SGN=-SGN
            END IF
            SUBDAC=SUBDAC+AAIJ
            NSUBD=NSUBD+1
C Decide if we should rotate: SUBDAC is accumulated sum of abs of subdiag
C values. Therefore, we are certain that they are distributed around the
C value SUBDAC/NSUBD. Skip rotations that are too small compared to average:
            IF(DBLE(NSUBD)*AAIJ.LE.0.5*SUBDAC) GOTO 100
C Or, if the resulting rotation would be insignificant compared to DIFF:
            IF(AAIJ.LE.EPS*DIFF) GOTO 100
C Or, if the resulting rotation would be insignificant in absolute size:
            IF(AAIJ.LE.EPS2) GOTO 100
C Determine size of 2x2 rotation:
            NR=NR+1
            DUM=DIFF+SQRT(DIFF**2+4.0D0*AAIJ**2)
            TN=2.0D0*SGN*ARIJ/DUM
            CS=1.0D0/SQRT(1.0D0+TN**2)
            SN=CS*TN
C TN,CS,SN=TAN,COS AND SIN OF ROTATION ANGLE.
C  The following partially unrolled loops are written by Markus Fuelscher
            kmin=1
            kmax=j-1
            kleft=Mod(kmax-kmin+1,4)
            If ( kleft.eq.1 ) then
               Aii1=ARRAY(ii+1)
               Ajj1=ARRAY(jj+1)
               ARRAY(ii+1)=SN*Ajj1+CS*Aii1
               ARRAY(jj+1)=CS*Ajj1-SN*Aii1
            Else If ( kleft.eq.2 ) then
               Ajj1=ARRAY(jj+1)
               Ajj2=ARRAY(jj+2)
               Aii1=ARRAY(ii+1)
               Aii2=ARRAY(ii+2)
               ARRAY(ii+1)=SN*Ajj1+CS*Aii1
               ARRAY(ii+2)=SN*Ajj2+CS*Aii2
               ARRAY(jj+1)=CS*Ajj1-SN*Aii1
               ARRAY(jj+2)=CS*Ajj2-SN*Aii2
            Else If ( kleft.eq.3 ) then
               Ajj1=ARRAY(jj+1)
               Ajj2=ARRAY(jj+2)
               Ajj3=ARRAY(jj+3)
               Aii1=ARRAY(ii+1)
               Aii2=ARRAY(ii+2)
               Aii3=ARRAY(ii+3)
               ARRAY(ii+1)=SN*Ajj1+CS*Aii1
               ARRAY(ii+2)=SN*Ajj2+CS*Aii2
               ARRAY(ii+3)=SN*Ajj3+CS*Aii3
               ARRAY(jj+1)=CS*Ajj1-SN*Aii1
               ARRAY(jj+2)=CS*Ajj2-SN*Aii2
               ARRAY(jj+3)=CS*Ajj3-SN*Aii3
            End If
            kmin=kmin+kleft
            Do k=kmin,kmax,4
               Ajj0=ARRAY(jj+k+0)
               Ajj1=ARRAY(jj+k+1)
               Ajj2=ARRAY(jj+k+2)
               Ajj3=ARRAY(jj+k+3)
               Aii0=ARRAY(ii+k+0)
               Aii1=ARRAY(ii+k+1)
               Aii2=ARRAY(ii+k+2)
               Aii3=ARRAY(ii+k+3)
               ARRAY(ii+k+0)=SN*Ajj0+CS*Aii0
               ARRAY(ii+k+1)=SN*Ajj1+CS*Aii1
               ARRAY(ii+k+2)=SN*Ajj2+CS*Aii2
               ARRAY(ii+k+3)=SN*Ajj3+CS*Aii3
               ARRAY(jj+k+0)=CS*Ajj0-SN*Aii0
               ARRAY(jj+k+1)=CS*Ajj1-SN*Aii1
               ARRAY(jj+k+2)=CS*Ajj2-SN*Aii2
               ARRAY(jj+k+3)=CS*Ajj3-SN*Aii3
            End Do
            kmin=j+1
            kmax=i-1
            kleft=Mod(kmax-kmin+1,4)
            kk=jj+j
            If ( kleft.eq.1 ) then
               k0=kk
               Ak0j=ARRAY(k0+j)
               Aii0=ARRAY(ii+kmin+0)
               ARRAY(ii+kmin+0)=SN*Ak0j+CS*Aii0
               ARRAY(kk+j)=CS*Ak0j-SN*Aii0
               kk=k0+kmin
            Else If ( kleft.eq.2 ) then
               k0=kk
               k1=k0+kmin
               Ak0j=ARRAY(k0+j)
               Ak1j=ARRAY(k1+j)
               Aii0=ARRAY(ii+kmin+0)
               Aii1=ARRAY(ii+kmin+1)
               ARRAY(k0+j)=CS*Ak0j-SN*Aii0
               ARRAY(k1+j)=CS*Ak1j-SN*Aii1
               ARRAY(ii+kmin+0)=SN*Ak0j+CS*Aii0
               ARRAY(ii+kmin+1)=SN*Ak1j+CS*Aii1
               kk=k1+kmin+1
            Else If ( kleft.eq.3 ) then
               k0=kk
               k1=k0+kmin
               k2=k1+kmin+1
               Ak0j=ARRAY(k0+j)
               Ak1j=ARRAY(k1+j)
               Ak2j=ARRAY(k2+j)
               Aii0=ARRAY(ii+kmin+0)
               Aii1=ARRAY(ii+kmin+1)
               Aii2=ARRAY(ii+kmin+2)
               ARRAY(k0+j)=CS*Ak0j-SN*Aii0
               ARRAY(k1+j)=CS*Ak1j-SN*Aii1
               ARRAY(k2+j)=CS*Ak2j-SN*Aii2
               ARRAY(ii+kmin+0)=SN*Ak0j+CS*Aii0
               ARRAY(ii+kmin+1)=SN*Ak1j+CS*Aii1
               ARRAY(ii+kmin+2)=SN*Ak2j+CS*Aii2
               kk=k2+kmin+2
            End If
            kmin=kmin+kleft
            Do k=kmin,kmax,4
               k0=kk
               k1=k0+k
               k2=k1+k+1
               k3=k2+k+2
               Ak0j=ARRAY(k0+j)
               Ak1j=ARRAY(k1+j)
               Ak2j=ARRAY(k2+j)
               Ak3j=ARRAY(k3+j)
               Aii0=ARRAY(ii+k+0)
               Aii1=ARRAY(ii+k+1)
               Aii2=ARRAY(ii+k+2)
               Aii3=ARRAY(ii+k+3)
               ARRAY(k0+j)=CS*Ak0j-SN*Aii0
               ARRAY(k1+j)=CS*Ak1j-SN*Aii1
               ARRAY(k2+j)=CS*Ak2j-SN*Aii2
               ARRAY(k3+j)=CS*Ak3j-SN*Aii3
               ARRAY(ii+k+0)=SN*Ak0j+CS*Aii0
               ARRAY(ii+k+1)=SN*Ak1j+CS*Aii1
               ARRAY(ii+k+2)=SN*Ak2j+CS*Aii2
               ARRAY(ii+k+3)=SN*Ak3j+CS*Aii3
               kk=k3+k+3
            End Do
            kmin=i+1
            kmax=NDIM
            kleft=Mod(kmax-kmin+1,4)
            kk=ii+i
            If ( kleft.eq.1 ) then
               k0=kk
               Ak0j=ARRAY(k0+j)
               Ak0i=ARRAY(k0+i)
               ARRAY(k0+j)=CS*Ak0j-SN*Ak0i
               ARRAY(k0+i)=SN*Ak0j+CS*Ak0i
               kk=k0+kmin
            Else If ( kleft.eq.2 ) then
               k0=kk
               k1=k0+kmin
               Ak0j=ARRAY(k0+j)
               Ak0i=ARRAY(k0+i)
               Ak1j=ARRAY(k1+j)
               Ak1i=ARRAY(k1+i)
               ARRAY(k0+j)=CS*Ak0j-SN*Ak0i
               ARRAY(k0+i)=SN*Ak0j+CS*Ak0i
               ARRAY(k1+j)=CS*Ak1j-SN*Ak1i
               ARRAY(k1+i)=SN*Ak1j+CS*Ak1i
               kk=k1+kmin+1
            Else If ( kleft.eq.3 ) then
               k0=kk
               k1=k0+kmin
               k2=k1+kmin+1
               Ak0j=ARRAY(k0+j)
               Ak0i=ARRAY(k0+i)
               Ak1j=ARRAY(k1+j)
               Ak1i=ARRAY(k1+i)
               Ak2j=ARRAY(k2+j)
               Ak2i=ARRAY(k2+i)
               ARRAY(k0+j)=CS*Ak0j-SN*Ak0i
               ARRAY(k0+i)=SN*Ak0j+CS*Ak0i
               ARRAY(k1+j)=CS*Ak1j-SN*Ak1i
               ARRAY(k1+i)=SN*Ak1j+CS*Ak1i
               ARRAY(k2+j)=CS*Ak2j-SN*Ak2i
               ARRAY(k2+i)=SN*Ak2j+CS*Ak2i
               kk=k2+kmin+2
            End If
            kmin=kmin+kleft
            Do k=kmin,kmax,4
               k0=kk
               k1=k0+k
               k2=k1+k+1
               k3=k2+k+2
               Ak0j=ARRAY(k0+j)
               Ak0i=ARRAY(k0+i)
               Ak1j=ARRAY(k1+j)
               Ak1i=ARRAY(k1+i)
               Ak2j=ARRAY(k2+j)
               Ak2i=ARRAY(k2+i)
               Ak3j=ARRAY(k3+j)
               Ak3i=ARRAY(k3+i)
               ARRAY(k0+j)=CS*Ak0j-SN*Ak0i
               ARRAY(k0+i)=SN*Ak0j+CS*Ak0i
               ARRAY(k1+j)=CS*Ak1j-SN*Ak1i
               ARRAY(k1+i)=SN*Ak1j+CS*Ak1i
               ARRAY(k2+j)=CS*Ak2j-SN*Ak2i
               ARRAY(k2+i)=SN*Ak2j+CS*Ak2i
               ARRAY(k3+j)=CS*Ak3j-SN*Ak3i
               ARRAY(k3+i)=SN*Ak3j+CS*Ak3i
               kk=k3+k+3
            End Do
C Update the diagonal elements of A
            Temp=2.0D0*CS*SN*ARIJ
            CS2=CS**2
            SN2=SN**2
            ARRAY(jj+j)=SN2*ARII+CS2*ARJJ-Temp
            ARRAY(ii+j)=0.0D0
            ARRAY(ii+i)=CS2*ARII+SN2*ARJJ+Temp
C Update rows/columns of the eigenvectors VECS
            kmin=1
            kmax=LENVEC
            kleft=Mod(kmax-kmin+1,4)
            If ( kleft.eq.1 ) then
               C1j=VECS(1,j)
               C1i=VECS(1,i)
               VECS(1,i)=SN*C1j+CS*C1i
               VECS(1,j)=CS*C1j-SN*C1i
            Else If ( kleft.eq.2 ) then
               C1j=VECS(1,j)
               C2j=VECS(2,j)
               C1i=VECS(1,i)
               C2i=VECS(2,i)
               VECS(1,i)=SN*C1j+CS*C1i
               VECS(2,i)=SN*C2j+CS*C2i
               VECS(1,j)=CS*C1j-SN*C1i
               VECS(2,j)=CS*C2j-SN*C2i
            Else If ( kleft.eq.3 ) then
               C1j=VECS(1,j)
               C2j=VECS(2,j)
               C3j=VECS(3,j)
               C1i=VECS(1,i)
               C2i=VECS(2,i)
               C3i=VECS(3,i)
               VECS(1,i)=SN*C1j+CS*C1i
               VECS(2,i)=SN*C2j+CS*C2i
               VECS(3,i)=SN*C3j+CS*C3i
               VECS(1,j)=CS*C1j-SN*C1i
               VECS(2,j)=CS*C2j-SN*C2i
               VECS(3,j)=CS*C3j-SN*C3i
            End If
            kmin=kmin+kleft
            Do k=kmin,kmax,4
               C0j=VECS(k+0,j)
               C1j=VECS(k+1,j)
               C2j=VECS(k+2,j)
               C3j=VECS(k+3,j)
               C0i=VECS(k+0,i)
               C1i=VECS(k+1,i)
               C2i=VECS(k+2,i)
               C3i=VECS(k+3,i)
               VECS(k+0,i)=SN*C0j+CS*C0i
               VECS(k+1,i)=SN*C1j+CS*C1i
               VECS(k+2,i)=SN*C2j+CS*C2i
               VECS(k+3,i)=SN*C3j+CS*C3i
               VECS(k+0,j)=CS*C0j-SN*C0i
               VECS(k+1,j)=CS*C1j-SN*C1i
               VECS(k+2,j)=CS*C2j-SN*C2i
               VECS(k+3,j)=CS*C3j-SN*C3i
            End Do
C  End of code by Markus Fuelscher

 100        CONTINUE
         END DO
      END DO
      NROT=NROT+NR

      IF (IFTEST) THEN
        SBDMAX=0.0D0
        VNSUM=0.0D0
        DO I=2,NDIM
           II=(I*(I-1))/2
           DO J=1,I-1
              ARIJ=ARRAY(II+J)
              VNSUM=VNSUM+ARIJ**2
              SBDMAX=MAX(SBDMAX,ABS(ARIJ))
           END DO
        END DO
        WRITE(6,'(3I8,2G20.12)') NSWEEP,NR,NROT,VNSUM,SBDMAX
      END IF

C CHECK IF CONVERGED:
      IF(NR.GT.0) GOTO 10

C The shifted diagonal values are restored:
      II=0
      DO I=1,NDIM
        II=II+I
        ARRAY(II)=ARRAY(II)+SHIFT
      END DO
      RETURN
c      STOP
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine dWdR(R,ilist_p,Weights,list_p,nlist_p,
     &                dW_dR,nGrad_Eff,iTab,dW_Temp,dPB,nGrid)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "itmax.fh"
#include "nq_info.fh"
#include "debug.fh"
      Real*8 R(3,nGrid), Weights(nGrid), dW_dR(nGrad_Eff,nGrid),
     &       dW_Temp(3,nlist_p), dPB(3,nlist_p,nlist_p), sxyz(3),
     &       dOdxs(3), Osxyz(3)
      Integer list_p(nlist_p), iTab(4,nGrad_Eff)
*                                                                      *
************************************************************************
*                                                                      *
#include "nq_structure.fh"
      declare_ip_coor
      declare_ip_dodx
      p(x)=(x*0.5D0)*(3.0D0-x**2)
*                                                                      *
************************************************************************
*                                                                      *
      P_i = Zero ! dummy initialize
*
*     iNQ is the index of the current atomic grid to which these grid
*     points belong.
*
      iNQ=list_p(ilist_p)
      iA=ilist_p
      O11=Work(ip_O)
      O12=Work(ip_O+1)
      O13=Work(ip_O+2)
      O21=Work(ip_O+3)
      O22=Work(ip_O+4)
      O23=Work(ip_O+5)
      O31=Work(ip_O+6)
      O32=Work(ip_O+7)
      O33=Work(ip_O+8)
*                                                                      *
************************************************************************
*                                                                      *
      Do iGrid = 1, nGrid
         Call FZero(dW_dR(1,iGrid),nGrad_Eff)
*                                                                      *
************************************************************************
*                                                                      *
*------- The current grid point is associated with center A and the
*        "atomic" displacement vector relative to center A is computed.
*
         Osxyz(1) = R(1,iGrid)-Work(ip_Coor(iNQ)  )
         Osxyz(2) = R(2,iGrid)-Work(ip_Coor(iNQ)+1)
         Osxyz(3) = R(3,iGrid)-Work(ip_Coor(iNQ)+2)
*
         sxyz(1)=O11*Osxyz(1)+O12*Osxyz(2)+O13*Osxyz(3)
         sxyz(2)=O21*Osxyz(1)+O22*Osxyz(2)+O23*Osxyz(3)
         sxyz(3)=O31*Osxyz(1)+O32*Osxyz(2)+O33*Osxyz(3)
*
         Z=Zero
         Call FZero(dPB,3*nlist_p**2)
*
*        Compute all P_B and corresponding derivatives.
*
C        P_A=Zero
         P_A=One ! Dummy set
         Do iiB = 1, nlist_p
            If (iiB.eq.1) Then
               iB = iA
            Else If (iiB.eq.iA) Then
               iB = 1
            Else
               iB = iiB
            End If
*
            kNQ=list_p(iB)
            kx=ip_Coor(kNQ)
            r_Bx=R(1,iGrid)-Work(kx  )
            r_By=R(2,iGrid)-Work(kx+1)
            r_Bz=R(3,iGrid)-Work(kx+2)
            r_B=sqrt(r_Bx**2+r_By**2+r_Bz**2)
*
*           loop over C=/=B for all s(mu_BC), see Eq. B3
*
            P_B=One
            Do iC = 1, nlist_p
*
               If (iC.ne.iB) Then
                  lNQ=list_p(iC)
                  lx=ip_Coor(lNQ)
                  r_Cx=R(1,iGrid)-Work(lx  )
                  r_Cy=R(2,iGrid)-Work(lx+1)
                  r_Cz=R(3,iGrid)-Work(lx+2)
                  r_C=sqrt(r_Cx**2+r_Cy**2+r_Cz**2)
                  R_BCx=Work(kx  )-Work(lx  )
                  R_BCy=Work(kx+1)-Work(lx+1)
                  R_BCz=Work(kx+2)-Work(lx+2)
                  R_BC=sqrt(R_BCx**2+R_BCy**2+R_BCz**2)
*
*                 Eq. B6
*
                  rMU_BC=(r_B-r_C)/R_BC
                  If (rMU_BC.le.0.5D0) Then
                     p1=p(rMU_BC)
                     p2=p(p1)
                     p3=p(p2)
*
*                 Eq. B4
*
                     s_MU_BC=Half*(One-p3)
*
                     P_B=P_B*s_MU_BC
                     If (P_B.le.1.0D-20) Go To 99
                     tMU_BC=-27D0*(One-p2**2)
     &                           *(One-p1**2)
     &                           *(One-rMU_BC**2)
     &                     /(16d0*Max(s_MU_BC,1.0D-99))
                  Else
                     xdiff0=rMU_BC-1.0D0
                     xdiff1=(-1.5D0-0.5D0*xdiff0)*xdiff0**2
                     xdiff2=(-1.5D0-0.5D0*xdiff1)*xdiff1**2
                     p3=    ( 1.5D0+0.5D0*xdiff2)*xdiff2**2
                     s_MU_BC=Half*p3
*
                     P_B=P_B*s_MU_BC
                     If (P_B.le.1.0D-20) Go To 99
                     tMU_BC= 27D0*(2.0D0+xdiff2)*xdiff2
     &                           *(2.0D0+xdiff1)*xdiff1
     &                           *(2.0D0+xdiff0)*xdiff0
     &                     /(16d0*Max(s_MU_BC,1.0D-99))
                  End If
*
*---------------- Differentiate mu_BC with respect to the center, D.
*
                  Do iD = 1, nlist_p
C                    jNQ=list_p(iD)
*
                     If (iD.eq.iB) Then
*
*                       d mu_BC(r_A) / dB, Eq. B10
*
                        If (r_B.eq.Zero) Then
                           dmu_BC_dBx =
     &                                - (r_B-r_C)*R_BCx/R_BC**3
                           dmu_BC_dBy =
     &                                - (r_B-r_C)*R_BCy/R_BC**3
                           dmu_BC_dBz =
     &                                - (r_B-r_C)*R_BCz/R_BC**3
                        Else
                           dmu_BC_dBx =  -r_Bx/(r_B*R_BC)
     &                                - (r_B-r_C)*R_BCx/R_BC**3
                           dmu_BC_dBy =  -r_By/(r_B*R_BC)
     &                                - (r_B-r_C)*R_BCy/R_BC**3
                           dmu_BC_dBz =  -r_Bz/(r_B*R_BC)
     &                                - (r_B-r_C)*R_BCz/R_BC**3
                        End If
*
                        dPB(1,iB,iB)=dPB(1,iB,iB) + tMU_BC*dmu_BC_dBx
                        dPB(2,iB,iB)=dPB(2,iB,iB) + tMU_BC*dmu_BC_dBy
                        dPB(3,iB,iB)=dPB(3,iB,iB) + tMU_BC*dmu_BC_dBz
*
                     Else If (iD.eq.iC) Then
*
*                       d mu_BC(r_A) / dC, Eq, B10
*
                        If (r_C.eq.Zero) Then
                           dmu_BC_dCx =
     &                                + (r_B-r_C)*R_BCx/R_BC**3
                           dmu_BC_dCy =
     &                                + (r_B-r_C)*R_BCy/R_BC**3
                           dmu_BC_dCz =
     &                                + (r_B-r_C)*R_BCz/R_BC**3
                        Else
                           dmu_BC_dCx =  r_Cx/(r_C*R_BC)
     &                                + (r_B-r_C)*R_BCx/R_BC**3
                           dmu_BC_dCy =  r_Cy/(r_C*R_BC)
     &                                + (r_B-r_C)*R_BCy/R_BC**3
                           dmu_BC_dCz =  r_Cz/(r_C*R_BC)
     &                                + (r_B-r_C)*R_BCz/R_BC**3
                        End If
                        dPB(1,iC,iB)=dPB(1,iC,iB) + tMU_BC*dmu_BC_dCx
                        dPB(2,iC,iB)=dPB(2,iC,iB) + tMU_BC*dmu_BC_dCy
                        dPB(3,iC,iB)=dPB(3,iC,iB) + tMU_BC*dmu_BC_dCz
*
                     End If
*
*                    d mu_BC(r_A) / dr_A
*
                     If (r_B.eq.Zero) Then
                        dmu_BC_dAx = (         - r_Cx/r_C)/R_BC
                        dmu_BC_dAy = (         - r_Cy/r_C)/R_BC
                        dmu_BC_dAz = (         - r_Cz/r_C)/R_BC
                     Else If (r_C.eq.Zero) Then
                        dmu_BC_dAx = (r_Bx/r_B           )/R_BC
                        dmu_BC_dAy = (r_By/r_B           )/R_BC
                        dmu_BC_dAz = (r_Bz/r_B           )/R_BC
                     Else
                        dmu_BC_dAx = (r_Bx/r_B - r_Cx/r_C)/R_BC
                        dmu_BC_dAy = (r_By/r_B - r_Cy/r_C)/R_BC
                        dmu_BC_dAz = (r_Bz/r_B - r_Cz/r_C)/R_BC
                     End If
*
                     If (iD.eq.iA) Then
*
*                       The direct term
*
                        dPB(1,iA,iB)=dPB(1,iA,iB) + tMU_BC*dmu_BC_dAx
                        dPB(2,iA,iB)=dPB(2,iA,iB) + tMU_BC*dmu_BC_dAy
                        dPB(3,iA,iB)=dPB(3,iA,iB) + tMU_BC*dmu_BC_dAz
*
                     End If
*
                     jNQ=list_p(iD)
                     Do iCar = 1, 3
C                       Call xxDGeMul(Work(ip_dOdx(jNQ,iCar)),3,'N',
C    &                              sxyz,3,'N',
C    &                              dOdxs,3,
C    &                              3,3,1)
                        dOdx_11=Work(ip_dOdx(jNQ,iCar))
                        dOdx_21=Work(ip_dOdx(jNQ,iCar)+1)
                        dOdx_31=Work(ip_dOdx(jNQ,iCar)+2)
                        dOdx_12=Work(ip_dOdx(jNQ,iCar)+3)
                        dOdx_22=Work(ip_dOdx(jNQ,iCar)+4)
                        dOdx_32=Work(ip_dOdx(jNQ,iCar)+5)
                        dOdx_13=Work(ip_dOdx(jNQ,iCar)+6)
                        dOdx_23=Work(ip_dOdx(jNQ,iCar)+7)
                        dOdx_33=Work(ip_dOdx(jNQ,iCar)+8)
                        dOdxs(1)=dOdx_11*sxyz(1)
     &                          +dOdx_12*sxyz(2)
     &                          +dOdx_13*sxyz(3)
                        dOdxs(2)=dOdx_21*sxyz(1)
     &                          +dOdx_22*sxyz(2)
     &                          +dOdx_23*sxyz(3)
                        dOdxs(3)=dOdx_31*sxyz(1)
     &                          +dOdx_32*sxyz(2)
     &                          +dOdx_33*sxyz(3)
                        temp = tMU_BC*(dmu_BC_dAx*dOdxs(1)
     &                                +dmu_BC_dAy*dOdxs(2)
     &                                +dmu_BC_dAz*dOdxs(3))
*
                        dPB(iCar,iD,iB) = dPB(iCar,iD,iB) - temp
                     End Do
*
                  End Do  ! iD
*
               End If
            End Do        ! iC
*
 99         Continue
*
*           Multiply derivatives with P_B as in Eq. B8
*
            Do iD = 1, nlist_p
               dPB(1,iD,iB)=P_B*dPB(1,iD,iB)
               dPB(2,iD,iB)=P_B*dPB(2,iD,iB)
               dPB(3,iD,iB)=P_B*dPB(3,iD,iB)
            End Do
*
            If (iB.eq.iA) P_A=P_B
            If (P_A.le.1.0D-20) Go To 98
*
*           Denominator Eq. B2
            Z = Z + P_B
         End Do           ! iB
*
         If (P_A.eq.Zero) Then
            Fact=Zero
         Else
            Fact = Weights(iGrid)*Z/P_A
         End If
*                                                                      *
************************************************************************
*                                                                      *
*------- Assemble the gradient
*
         Do iB = 1, nlist_p
*
            dZ_dBx=Zero
            dZ_dBy=Zero
            dZ_dBz=Zero
            Do iC = 1, nlist_p
               dZ_dBx=dZ_dBx+dPB(1,iB,iC)
               dZ_dBy=dZ_dBy+dPB(2,iB,iC)
               dZ_dBz=dZ_dBz+dPB(3,iB,iC)
            End Do
*
*           Eq. B7
*
            dW_Temp(1,iB) = dPB(1,iB,iA)/Z - (P_A*dZ_dBx)/Z**2
            dW_Temp(2,iB) = dPB(2,iB,iA)/Z - (P_A*dZ_dBy)/Z**2
            dW_Temp(3,iB) = dPB(3,iB,iA)/Z - (P_A*dZ_dBz)/Z**2
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*        Pick up the relevant gradients
*
         Do iGrad = 1, nGrad_Eff
            iCar=iTab(1,iGrad)
            kNQ =iTab(3,iGrad)
            Fact0=Fact
            Do iB = 1, nlist_p
               lNQ=list_p(iB)
               If (kNQ.eq.lNQ) dW_dR(iGrad,iGrid)=Fact0*dW_Temp(iCar,iB)
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
 98      Continue
      End Do ! iGrid
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine UnNrmlz(Exp,nPrim,Coeff,nCntrc,iang)
      Implicit Real*8 (A-H,O-Z)
      Real*8 Exp(nPrim), Coeff(nPrim,nCntrc)
#include "real.fh"
*
      Do  i = 1, nCntrc
         Do  j = 1, nPrim
            Coeff(j,i) = Coeff(j,i) /( TwoP34 *
     &                (Four*Exp(j))**((Two*DBLE(iAng)+Three)/Four))
         End Do
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SubRoutine ChoMP2_RHSlagr_2(EOcc,EVir,EFro,EDel,Xaibj,
     &                          LnPQRSprod,LiPQRSprod,iBatch,jBatch,
     &                          nOccLeftI,nOccLeftJ,
     &                          nOrbLeftI,nOrbLeftJ,
     &                          nFroLeftI,nFroLeftJ)
*     This will calculate the righthandside of the mp2lagrangian.
#include "implicit.fh"
      Real*8 EOcc(*), EVir(*),EFro(*),EDel(*), Xaibj(LnPQRSprod)
      Integer LiPQRSprod(8)
      Integer nOccLeftI(8),nOccLeftJ(8)
      Integer nOrbLeftI(8), nOrbLeftJ(8)
      Integer nFroLeftI(8),nFroLeftJ(8)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"
*
      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
      iDensVir(i,j,k) = ip_Density(k) +
     &                         nFro(k) + nOcc(k) +  j-1 +
     &                        (nOrb(k) + nDel(k))*
     &                        (i + nFro(k) + nOcc(k) -1)
      iDensOcc(i,j,k) = ip_Density(k)
     &                          + j-1 + (nOrb(k)+nDel(k))
     &                                      * (i-1)
      iMp2Lagr(i,j,k) = ip_Mp2Lagr(k) +
     &                          j-1 + (nOcc(k)+nFro(k))*(i-1)
      iDiaA(i,j,k) = ip_DiaA(k) + j-1 + (nOcc(k)+nFro(k))*(i-1)
      iFirstS(i,j)=iWork(ip_FirstS-1+nSym*(j-1)+i)
      LnBatOrb(i,j)=iWork(ip_LnBatOrb-1+nSym*(j-1)+i)
      LiPQprod(i,j,k)=iWork(ip_LiPQprod-1+
     &                        nSym*nSym*(k-1)+nSym*(j-1)+i)
      LnPQprod(i,j)=iWork(ip_LnPQprod-1+nSym*(j-1)+i)
*
      Do iSymIP = 1, nSym
         iSymAQ = iSymIP
         Do iSymI = 1,nSym
            iSymP = MulD2h(iSymI,iSymIP)
            LiOrb = Min(LnBatOrb(iSymI,iBatch),
     &                  nOccLeftI(iSymI))
            Do Li = 1, LiOrb
               If(nFroLeftI(iSymI) .gt. 0) Then
                  iI = Li
               Else
                  iI = iFirstS(iSymI,iBatch) + Li - 1
               End If
               Lii = LiPQprod(iSymI,iSymI,iBatch)
     &             + (nFro(iSymI) + nOcc(iSymI)
     &             +  nVir(iSymI) + nDel(iSymI))
     &             * (Li - 1)
     &             +  iI

*
               Do iSymA = 1, nSym
                  iSymAI = MulD2h(iSymI,iSymA)
                  iSymQ = MulD2h(iSymA,iSymAQ)
                  iSymIQ = MulD2h(iSymI,iSymQ)
                  iSymAP = iSymIQ
                  LaOrb = LnBatOrb(iSymA,jBatch)
     &                  - nOccLeftJ(iSymA)
                  Do La = 1, LaOrb
                     If(nOccLeftJ(iSymA).gt.0) Then
                        iA = La
                     Else
                        iA = iFirstS(iSymA,jBatch) - nFro(iSymA)
     &                     - nOcc(iSymA) + La-1
                     End If
*     Calculating the diagonal of A: 3(ia|ia) - (ii|aa)
*     (Only needed once for each iA hence iP = 1)
*
                     If((iSymI .eq. iSymA).and.(iSymIP.eq.1)) Then
                        Lii = LiPQprod(iSymI,iSymI,iBatch)
     &                       + (nFro(iSymI) + nOcc(iSymI)
     &                       +  nVir(iSymI) + nDel(iSymI))
     &                       * (Li - 1)
     &                       +  iI
                        Laa = LiPQprod(iSymA,iSymA,jBatch)
     &                       + (nFro(iSymA) + nOcc(iSymA)
     &                       +  nVir(iSymA) + nDel(iSymA))
     &                       * (La + nOccLeftJ(iSymA) - 1)
     &                       +  iA + nFro(iSymA) + nOcc(iSymA)
                        Lai = LiPQprod(iSymA,iSymI,iBatch)
     &                       + (nFro(iSymA) + nOcc(iSymA)
     &                       +  nVir(iSymA) + nDel(iSymA))
     &                       * (Li-1)
     &                       +  iA + nFro(iSymA) + nOcc(iSymA)
                        Lia = LiPQprod(iSymI,iSymA,jBatch)
     &                       + (nFro(iSymA) + nOcc(iSymA)
     &                       +  nVir(iSymA) + nDel(iSymA))
     &                       * (La + nOccLeftJ(iSymA) - 1)
     &                       +  iI
                        If(iBatch.eq.jBatch) Then
                           ip_iiaa = LiPQRSprod(iSymAI)
     &                             + iTri(Laa,Lii)
                           ip_aiai = LiPQRSprod(iSymAI)
     &                             + iTri(Lia,Lai)
                        Else
                           ip_iiaa = LiPQRSprod(iSymAI)
     &                             + LnPQprod(iSymAI,iBatch)
     &                             * (Laa-1) + Lii
                           ip_aiai = LiPQRSprod(iSymAI)
     &                             + LnPQprod(iSymAI,iBatch)
     &                             * (Lia-1) + Lai
                        End If
                        DiagInt = 3.0d0 * Xaibj(ip_aiai)
     &                                  - Xaibj(ip_iiaa)
                        If(iI .le. nFro(iSymI)) Then
                           E_Occ = EFro(iFro(iSymI) + iI)
                        Else
                           E_Occ = EOcc(iOcc(iSymI)
     &                           + iI - nFro(iSymI))
                        End If
                        If(iA .gt. nVir(iSymA)) Then
                           E_Vir = EDel(iDel(iSymA)
     &                           + iA - nVir(iSymA))
                        Else
                           E_Vir = EVir(iVir(iSymA) + iA)
                        End If

                        DiagEn = E_Vir - E_Occ
                        Work(iDiaA(iA,iI,iSymI)) =
     &                       Work(iDiaA(iA,iI,iSymI))
     &                       + 1.0D0/(DiagInt + DiagEn)
*-----------------------------------------------------------------------
*                              Write(6,*) 'IA', iI, iA
*                              Write(6,*) 'Symm', iSymI, iSymA
*                              Write(6,*) 'iiaa', Xaibj(ip_iiaa)
*                              Write(6,*) 'iaia', Xaibj(ip_aiai)
*                              Write(6,*) 'DiagInt', DiagInt
*                              Write(6,*) 'DiagEn', DiagEn
*-----------------------------------------------------------------------
                     End If
                     Do iP = 1, nOrb(iSymP) + nDel(iSymP)
                        Lip = LiPQprod(iSymP,iSymI,iBatch)
     &                       + (nFro(iSymP) + nOcc(iSymP)
     &                       +  nVir(iSymP) + nDel(iSymP))
     &                       * (Li - 1)
     &                       +  iP
                        Lap = LiPQProd(iSymP,iSymA,jBatch)
     &                       + (nFro(iSymP) + nOcc(iSymP)
     &                       +  nVir(iSymP) + nDel(iSymP))
     &                       * (La+nOccLeftJ(iSymA)-1)
     &                       +  iP
                        If((iP .le. nFro(iSymP) + nOcc(iSymP)) .and.
     &                      (iSymI .eq. iSymP)) Then
                           Do iK = 1, nFro(iSymQ) + nOcc(iSymQ)
                              iJ = iP
                              Lak = LiPQProd(iSymQ,iSymA,jBatch)
     &                            + (nFro(iSymQ) + nOcc(iSymQ)
     &                            +  nVir(iSymQ) + nDel(iSymQ))
     &                            * (La+nOccLeftJ(iSymA)-1)
     &                            +  iK
                              Lik = LiPQProd(iSymQ,iSymI,iBatch)
     &                             + (nFro(iSymQ) + nOcc(iSymQ)
     &                             +  nVir(iSymQ) + nDel(iSymQ))
     &                             * (Li-1)
     &                             +  iK
*
                              If(iBatch.eq.jBatch) Then
                                 ip_ijak = LiPQRSprod(iSymIP)
     &                                + iTri(Lip,Lak)
                                 ip_ikaj = LiPQRSprod(iSymIQ)
     &                             + iTri(Lik,Lap)
                              Else
                                 ip_ijak = LiPQRSprod(iSymIP)
     &                                + LnPQprod(iSymIP,iBatch)
     &                                * (Lak-1) + Lip
                                 ip_ikaj = LiPQRSprod(iSymIQ)
     &                                + LnPQprod(iSymIQ,iBatch)
     &                                * (Lap-1) + Lik
                              End If
                              A = 2.0d0 * Xaibj(ip_ijak)
     &                          - 1.0d0 * Xaibj(ip_ikaj)
                              Work(iMp2Lagr(iA,iK,iSymQ)) =
     &                             Work(iMp2Lagr(iA,iK,iSymQ))
     &                             + Work(iDensOcc(iJ,iI,iSymI))
     &                             * A
*--------------------- Debug Comments -----------------------
*                              If(iP .le. nFro(iSymP) + nOcc(iSymP)) Then
*                                 Write(6,*) 'AIJK',iA,iI,iJ,iK
*                                 Write(6,*) 'aijk', Xaibj(ip_ijak)
*                                 Write(6,*) 'akji', Xaibj(ip_ikaj)
*                                 Write(6,*) 'A',A
*                                 Write(6,*) 'Density',Work(iDensOcc(iJ,
*     &                                                     iI,iSymI))
*                              End If
*------------------------------------------------------------
                           End Do
                        Else If((iP .gt. nFro(iSymP) + nOcc(iSymP)).and.
     &                          (iSymA .eq. iSymQ)) Then
                           Do iB = 1, nVir(iSymQ) + nDel(iSymQ)
                              iC = iP - nFro(iSymP) - nOcc(iSymP)
                              Lab = LiPQProd(iSymQ,iSymA,jBatch)
     &                            + (nFro(iSymQ) + nOcc(iSymQ)
     &                            +  nVir(iSymQ) + nDel(iSymQ))
     &                            * (La+nOccLeftJ(iSymA)-1)
     &                            +  iB + nFro(iSymQ) + nOcc(iSymQ)
                              Lib = LiPQProd(iSymQ,iSymI,iBatch)
     &                             + (nFro(iSymQ) + nOcc(iSymQ)
     &                             +  nVir(iSymQ) + nDel(iSymQ))
     &                             * (Li-1)
     &                             + iB + nFro(iSymQ) + nOcc(iSymQ)
                              If(iBatch.eq.jBatch) Then
                                 ip_icab = LiPQRSprod(iSymIP)
     &                                + iTri(Lip,Lab)
                                 ip_ibac = LiPQRSprod(iSymIQ)
     &                             + iTri(Lib,Lap)
                              Else
                                 ip_icab = LiPQRSprod(iSymIP)
     &                                + LnPQprod(iSymIP,iBatch)
     &                                * (Lab-1) + Lip
                                 ip_ibac = LiPQRSprod(iSymIQ)
     &                                + LnPQprod(iSymIQ,iBatch)
     &                                * (Lap-1) + Lib
                              End If
                              A = 2.0d0 * Xaibj(ip_icab)
     &                          - 1.0d0 * Xaibj(ip_ibac)
                              Work(iMp2Lagr(iC,iI,iSymI)) =
     &                             Work(iMp2Lagr(iC,iI,iSymI))
     &                             + Work(iDensVir(iB,iA,iSymA))
     &                             * A
*----------- Debug Comments ------------------------------------------
*                        Write(6,*) 'AIBC',iA,iI,iB,iC
*                        Write(6,*) 'Symm',iSymA,iSymI,iSymQ,iSymP
*                        Write(6,*) 'icab', Xaibj(ip_icab)
*                        Write(6,*) 'ibac', Xaibj(ip_ibac)
*                        Write(6,*) 'adress',iMp2Lagr(iC,iI,iSymI)-
*     &                             ip_Mp2Lagr(1)
*                        Write(6,*) 'DensAdress',iDensVir(iB,iA,iSymA)-
*     &                                          ip_Density(1)
*                        Write(6,*) 'Dens',Work(iDensVir(iB,iA,iSymA))
*                        Write(6,*) 'A',A
*                        Write(6,*) 'Bidrag',
*     &                             A*Work(iDensVir(iB,iA,iSymA))
*----------------------------------------------------------------------
                           End Do
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(nOrbLeftI)
         Call Unused_integer_array(nOrbLeftJ)
         Call Unused_integer_array(nFroLeftJ)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine VEIG(N,A,V)
! THE DIAGONAL ELEMENTS OF THE LOWER TRIANGULAR MATRIX, A, STORED
! IN UPPER PACKED STORAGE MODE ARE COPIED TO THE FIELD V.

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: A(nTri_Elem(N))
real(kind=wp), intent(out) :: V(N)
integer(kind=iwp) :: I

do I=1,N
  V(I) = A(nTri_Elem(I))
end do

return

end subroutine VEIG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE INIT_RASSI

      use rasscf_data, only: doDMRG

      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='INIT')
#include "Molcas.fh"
#include "cntrl.fh"
#include "symmul.fh"
#include "Files.fh"
#include "stdalloc.fh"
#include "WrkSpc.fh"
#include "rassi.fh"
#include "hfc_logical.fh"
      Character*256 STRING
      Logical FoundTwoEls,DoCholesky


* Initialise doDMRG if compiled without QCMaquis
#ifndef _DMRG_
      DoDMRG = .false.
#endif

C SET UP SYMMETRY MULTIPLICATION TABLE:
      MUL(1,1)=1
      M=1
      DO  N=1,3
        DO  I=1,M
          DO J=1,M
            MUL(I+M,J)=M+MUL(I,J)
            MUL(I,J+M)=MUL(I+M,J)
            MUL(I+M,J+M)=MUL(I,J)
          END DO
        END DO
        M=2*M
      END DO

C UNIT NUMBERS AND NAMES
      LUONE=2
      FNONE='ONEINT'
      LUORD=30
      FNORD='ORDINT'
      LUCOM=33
      FNCOM='COMFILE'
      LUIPH=15
      LUSCR=20
      FNSCR='SCRATCH'
      LUEXC=22
      FNEXC='ANNI'
      LUEXT=21
      FNEXT='EXTRACT'
      LUMCK=33
      LuToM=26
      FnToM='TOFILE'
      LuEig=27
      FnEig='EIGV'
      DO  I=1,MXJOB
        JBNAME(I)='UNDEFINE'
      END DO
      DO  I=1,MXJOB
        WRITE(MINAME(I),'(''MCK'',I3.3)') I
      END DO
      IF(IPGLOB.GT.VERBOSE) THEN
        WRITE(6,*)' Unit numbers and names:'
        WRITE(6,'(1x,I8,5x,A8)')LUONE,FNONE
        WRITE(6,'(1x,I8,5x,A8)')LUORD,FNORD
        WRITE(6,'(1x,I8,5x,A8)')LUSCR,FNSCR
        WRITE(6,'(1x,I8,5x,A8)')LUEXC,FNEXC
      END IF

      IF(IPGLOB.GT.VERBOSE) WRITE(6,*)' OPENING ',FNSCR
      CALL DANAME(LUSCR,FNSCR)
      IF(IPGLOB.GT.VERBOSE) WRITE(6,*)' OPENING ',FNEXC
      CALL DANAME(LUEXC,FNEXC)


C NR OF JOBIPHS AND STATES:
      NJOB=0
      NSTATE=0
      IF(IPGLOB.GT.VERBOSE) THEN
       WRITE(6,*)' INITIAL DEFAULT VALUES:'
       WRITE(6,'(1X,A,I4)')'  NJOB:',NJOB
       WRITE(6,'(1X,A,I4)')'NSTATE:',NSTATE
      END IF
C
C NR OF OPERATORS FOR WHICH MATRIX ELEMENTS ARE TO BE CALCULATED:
      NPROP=0

C OPERATORS FOR WHICH MATRIX ELEMENTS OVER SPIN-ORBIT EIGENSTATES
C ARE TO BE COMPUTED.
      NSOPR=0

C DEFAULT THRESHOLD FOR PRINTING CI COEFFICIENTS:
      CITHR=0.05d0

C DEFAULT THRESHOLD FOR PRINTING TRANSITION DIPOLE VECTORS
      TDIPMIN=1.0D-4

C DEFAULT THRESHOLD AND MAX NUMBER OF SO-HAMILTONIAN
C MATRIX ELEMENTS TO PRINT:
      NSOTHR_PRT=0
      SOTHR_PRT=-1.0D0

C SET LABELS TO UNDEFINED
      DO IPROP = 1, MXPROP
         PNAME(IPROP) ='UNDEF.  '
         PTYPE(IPROP) ='UNDEF.  '
         SOPRNM(IPROP)='UNDEF.  '
         SOPRTP(IPROP)='UNDEF.  '
      END DO

C DEFAULT FLAGS:
      PRSXY=.FALSE.
      PRDIPVEC=.FALSE.
      PRORB=.FALSE.
      PRTRA=.FALSE.
      PRCI=.FALSE.
      IFHAM=.FALSE.
      IFEJOB=.FALSE.
      IFSHFT=.FALSE.
      IFHDIA=.FALSE.
      IFHEXT=.FALSE.
      IFHEFF=.FALSE.
      IFHCOM=.FALSE.
      HAVE_HEFF=.FALSE.
      HAVE_DIAG=.FALSE.
      IFSO=.FALSE.
      IFNTO=.FALSE.
      NATO=.FALSE.
      BINA=.FALSE.
      NONA=.FALSE.
      IFTRD1=.FALSE.
      IFTRD2=.FALSE.
      RFPERT=.FALSE.
      ToFile=.false.
      PRXVR=.FALSE.
      PRXVE=.FALSE.
      PRXVS=.FALSE.
      PRMER=.FALSE.
      PRMEE=.FALSE.
      PRMES=.FALSE.
      IFGCAL=.FALSE.
      EPRTHR=0.0D0
      IFXCAL=.FALSE.
      IFMCAL=.FALSE.
      HOP=.FALSE.
      TRACK=.FALSE.
      ONLY_OVERLAPS=.FALSE.
* Intesities
      DIPR=.FALSE.
      OSTHR_DIPR = 0.0D0
      QIPR=.FALSE.
      OSTHR_QIPR = 0.0D0
      QIALL=.FALSE.
      DYSO=.FALSE.
      DYSEXPORT=.FALSE.
* Exact operator
      Do_TMOM=.FALSE.
      PRRAW=.FALSE.
      PRWEIGHT=.FALSE.
      TOLERANCE=0.1D0
      REDUCELOOP=.FALSE.
      LOOPDIVIDE=0
      TMGr_thrs=-1.0d0
      Do_SK  =.FALSE.
      Do_Pol  =.FALSE.
      L_Eff=5
C CD - velocity and mixed gauge
      DOCD = .FALSE.
      RSTHR = 0.0D0
      RSPR=.FALSE.
C Force that TDMs are not stored in the AO basis.
      Force_NON_AO_TDM=.False.
      CALL GETENVF('MOLCAS_FORCE_NON_AO_TDM',STRING)
      If (STRING.eq.'ON') Force_NON_AO_TDM=.True.
cnf
      IfDCpl = .False.
cnf

C tjd- BMII: Print out spin-orbit properties to files
      LPRPR=.FALSE.
      LHAMI=.FALSE.
c Feng: test control
      MAG_X2C=.FALSE.

C K. Sharkas  BEG
      IFATCALSA=.FALSE.
      IFGTCALSA=.FALSE.
      IFGTSHSA=.FALSE.
C K. Sharkas  END

c BP - Hyperfine tensor and SONATORB initialization
c RF - SO-NTO initialization
      IFACAL=.FALSE.
      IFACALFC=.TRUE.
      IFACALSD=.TRUE.

      NOSO=.FALSE.
      SONATNSTATE=0
      SODIAGNSTATE=0

      SONTOSTATES=0

      IFCURD=.FALSE.
      IFARGU=.FALSE.


* Nr of states for which natural orbitals will be computed:
      NRNATO=0
* Nr of state pairs for computing bi-natural orbitals:
      NBINA=0

* Check if two-electron integrals are available:
      Call f_Inquire('ORDINT',FoundTwoEls)
      Call DecideOnCholesky(DoCholesky)
      If (FoundTwoEls .or. DoCholesky) IFHAM=.True.

      IF(IPGLOB.GE.DEBUG) THEN
        WRITE(6,*)'Initial default flags are:'
        WRITE(6,*)'     PRSXY :',PRSXY
        WRITE(6,*)'     PRORB :',PRORB
        WRITE(6,*)'     PRTRA :',PRTRA
        WRITE(6,*)'     PRCI  :',PRCI
        WRITE(6,*)'     IFHAM :',IFHAM
        WRITE(6,*)'     IFHEXT:',IFHEXT
        WRITE(6,*)'     IFHEFF:',IFHEFF
        WRITE(6,*)'     IFEJOB:',IFEJOB
        WRITE(6,*)'     IFSHFT:',IFSHFT
        WRITE(6,*)'     IFHDIA:',IFHDIA
        WRITE(6,*)'     IFHCOM:',IFHCOM
        WRITE(6,*)'     IFSO  :',IFSO
        WRITE(6,*)'     NATO  :',NATO
        WRITE(6,*)'     IFTRD1:',IFTRD1
        WRITE(6,*)'     IFTRD2:',IFTRD2
        WRITE(6,*)'     RFPERT:',RFPERT
        WRITE(6,*)'     TOFILE:',ToFile
        WRITE(6,*)'     PRXVR :',PRXVR
        WRITE(6,*)'     PRXVE :',PRXVE
        WRITE(6,*)'     PRXVS :',PRXVS
        WRITE(6,*)'     PRMER :',PRMER
        WRITE(6,*)'     PRMEE :',PRMEE
        WRITE(6,*)'     PRMES :',PRMES
        WRITE(6,*)'     IFGCAL:',IFGCAL
        WRITE(6,*)'     IFXCAL:',IFXCAL
        WRITE(6,*)'     IFMCAL:',IFMCAL
        WRITE(6,*)'     HOP:',HOP
        WRITE(6,*)'     TRACK:',TRACK
        WRITE(6,*)'     ONLY_OVERLAPS:',ONLY_OVERLAPS
        WRITE(6,*)'     IfDCpl:',IfDCpl
        WRITE(6,*)'     IFCURD:',IFCURD
        WRITE(6,*)'     Do_TMOM:',Do_TMOM
        WRITE(6,*)'     Do_SK:',Do_SK
        WRITE(6,*)'     L_Eff:',L_Eff
        WRITE(6,*)'     CD:',DOCD
        WRITE(6,*)'     Force_NON_AO_TDM:',Force_NON_AO_TDM
      END IF

C DEFAULT WAVE FUNCTION TYPE:
      WFTYPE='GENERAL '
      IF(IPGLOB.GT.VERBOSE) WRITE(6,*)' ***** INIT ENDS **********'

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine creqadd_sp(q,G2,idsym,Temp,Scr,n2)
! Constructs the Q matrix

use Symmetry_Info, only: Mul
use MCLR_Data, only: ipMat, nA, nDens, nNA
use input_mclr, only: nAsh, nIsh, nOrb, nSym
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Q(nDens)
real(kind=wp), intent(in) :: G2(nna,nna,nna,nna)
integer(kind=iwp), intent(in) :: idSym, n2
real(kind=wp), intent(out) :: Temp(n2), Scr(n2)
integer(kind=iwp) :: iAA, iAsh, ijS, ipM, ipQ, ipS, iS, jAA, jAsh, jS, kAA, kAsh, kS, lAA, lAsh, lS
real(kind=wp) :: RD

!                                                                      *
!***********************************************************************
!                                                                      *
! Q = (pj|kl)d
!  pi         ijkl

do iS=1,nSym
  ipS = Mul(is,idsym)
  if (norb(ips) /= 0) then
    do jS=1,nsym
      ijS = Mul(is,js)
      do kS=1,nSym
        ls = Mul(ijs,Mul(ks,idsym))

        do kAsh=1,nAsh(ks)
          kAA = kAsh+nIsh(ks)
          do lAsh=1,nAsh(ls)
            lAA = lAsh+nIsh(ls)

            call Coul(ipS,jS,kS,lS,kAA,lAA,Temp,Scr)

            do iAsh=1,nAsh(is)
              iAA = iAsh+nIsh(is)
              ipQ = ipMat(ips,is)+(iAA-1)*nOrb(ips)
              do jAsh=1,nAsh(js)
                jAA = jAsh+nIsh(js)
                ipM = (jAA-1)*nOrb(ipS)+1

                rd = G2(iAsh+na(is),jAsh+na(js),kAsh+na(ks),lash+na(ls))
                Q(ipQ:ipQ+nOrb(ipS)-1) = Q(ipQ:ipQ+nOrb(ipS)-1)+rd*Temp(ipM:ipM+nOrb(ipS)-1)
              end do
            end do
          end do
        end do

      end do
    end do
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine creqadd_sp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1992, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

#ifdef _OLD_CODE_

subroutine NTMul(A,B,C,nRowA,nColA,nRowB)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nRowA, nColA, nRowB
real(kind=wp), intent(in) :: A(nRowA,nColA), B(nRowB,nColA)
real(kind=wp), intent(out) :: C(nRowA,nRowB)
integer(kind=iwp) :: i, Indj, j, jj, k, mCache, nCache, njVec

nCache = (64/8)*1024
mCache = (nCache*3)/4-nRowA*nColA
Incj = mCache/(nRowA+nColA)

! Sectioning of long index

do jj=1,nRowB,Incj
  njVec = min(Incj,nRowB-jj+1)

  do i=1,nRowA
    ! Set target to zero
    C(i,jj:jj+njVec-1) = Zero
    do k=1,nColA
      if (A(i,k) /= Zero) C(i,jj:jj+njVec-1) = C(i,jj:jj+njVec-1)+A(i,k)*B(jj:jj+njVec-1,k)
    end do
  end do

end do    ! End of sectioning

return

end subroutine NTMul

#else

subroutine ntmul(a,b,r,ncol,nlink,nrow)

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCol, nLink, nRow
real(kind=wp), intent(in) :: a(ncol,*), b(nrow,*)
real(kind=wp), intent(out) :: r(ncol,nrow)
integer(kind=iwp), parameter :: mxind = 2000
integer(kind=iwp) :: i, ind(mxind), j, k, nnot, nr1
real(kind=wp) :: S(16)

do i=1,ncol

  nnot = 0
  do k=1,min(nlink,mxind)
    if (a(i,k) /= Zero) then
      nnot = nnot+1
      ind(nnot) = k
    end if
  end do

  do j=1,nrow-15,16
    s(:) = Zero
    do k=1,nnot
      s(:) = s(:)+a(i,ind(k))*b(j:j+15,ind(k))
    end do
    r(i,j:j+15) = s(:)
  end do

  nr1 = mod(nrow,16)
  if (nr1 == 0) cycle
  j = nrow-nr1+1

  if (nr1 >= 8) then
    s(1:8) = Zero
    do k=1,nnot
      s(1:8) = s(1:8)+a(i,ind(k))*b(j:j+7,ind(k))
    end do
    r(i,j:j+7) = s(1:8)
    nr1 = nr1-8
    j = j+8
  end if

  if (nr1 >= 4) then
    s(1:4) = Zero
    do k=1,nnot
      s(1:4) = s(1:4)+a(i,ind(k))*b(j:j+3,ind(k))
    end do
    r(i,j:j+3) = s(1:4)
    nr1 = nr1-4
    j = j+4
  end if

  if (nr1 == 3) then
    s(1:3) = Zero
    do k=1,nnot
      s(1:3) = s(1:3)+a(i,ind(k))*b(j:j+2,ind(k))
    end do
    r(i,j:j+2) = s(1:3)
  else if (nr1 == 2) then
    s(1:2) = Zero
    do k=1,nnot
      s(1:2) = s(1:2)+a(i,ind(k))*b(j:j+1,ind(k))
    end do
    r(i,j:j+1) = s(1:2)
  else if (nr1 == 1) then
    s(1) = Zero
    do k=1,nnot
      s(1) = s(1)+a(i,ind(k))*b(j,ind(k))
    end do
    r(i,j) = s(1)
  else if (nr1 > 3) then
    call WarningMessage(2,'nr1 > 3')
    call Abend()
  end if
end do

if (mxind >= nlink) return
call WarningMessage(2,'MxInd < nLink')
write(u6,*) 'mxind,nlink=',mxind,nlink
call Abend()

return

end subroutine ntmul

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine h1_espf (h1,RepNuc,nh1,First,Do_DFT)
      use Basis_Info, only: nBas
      Implicit Real*8 (A-H,O-Z)
*
* Driver for computing the ESPF one-electron modification
* of the core hamiltonian
*
#include "espf.fh"
*
#include "print.fh"
      Character*180 Line,Get_Ln
      External Get_Ln
      Character*10 ESPFKey
      Real*8 h1(nh1)
      Logical StandAlone,First,Do_DFT
      Logical DynExtPot,Exist,DoTinker,DoGromacs,lMorok,UpdateVMM
      Logical DoDirect
*
      iPL = iPrintLevel(-1)
*
      RealDummy = Zero
*
* Recover some ESPF data
*
      StandAlone = .False.
      DoTinker = .False.
      DoGromacs = .False.
      lMorok = .False.
      DoDirect = .False.
      ipOldMltp = ip_Dummy
      Call F_Inquire('ESPF.DATA',Exist)
      If (Exist) Then
         IPotFl = IsFreeUnit(1)
         Call Molcas_Open(IPotFl,'ESPF.DATA')
10       Line = Get_Ln(IPotFl)
         ESPFKey = Line(1:10)
         If (ESPFKey.eq.'MLTORD    ') Then
            Call Get_I1(2,MltOrd)
            ibla = 0
            Do ii = 0, MltOrd
               ibla = ibla + (ii+2)*(ii+1)/2
            End Do
            MltOrd = ibla
         Else If (ESPFKey.eq.'IRMAX     ') Then
            Call Get_I1(2,iRMax)
         Else If (ESPFKey.eq.'DELTAR    ') Then
            Call Get_F1(2,DeltaR)
         Else If (ESPFKey.eq.'GRIDTYPE  ') Then
            Call Get_I1(2,iGrdTyp)
         Else If (ESPFKey.eq.'TINKER    ') Then
            DoTinker = .True.
         Else If (ESPFKey.eq.'GROMACS   ') Then
            DoGromacs = .True.
         Else If (ESPFKey.eq.'LA_MOROK  ') Then
            lMorok = .True.
         Else If (ESPFKey.eq.'DIRECT    ') Then
            DoDirect = .True.
         Else If (ESPFKey.eq.'MULTIPOLE ') Then
            Call Get_I1(2,nMult)
            Call Allocate_Work(ipOldMltp,nMult)
            Do iMlt = 1, nMult, MltOrd
               Line = Get_Ln(IPotFl)
               Call Get_I1(1,iAt)
               Call Get_F(2,Work(ipOldMltp+iMlt-1),MltOrd)
            End Do
         Else If (ESPFKey.eq.'ENDOFESPF ') Then
            Goto 11
         EndIf
         Goto 10
11       Close (IPotFl)
      Else
         Write(6,*) 'No ESPF.DATA file. Abort'
         Call Quit_OnUserError()
      End If
*
* Is this a fully coupled QM/MM calculation?
*
      DynExtPot = .False.
      iMode = 0
      If (DoTinker) Then
         ITkQMMM = IsFreeUnit(30)
         Call Molcas_Open (ITkQMMM,'QMMM')
         Line = ' '
         Do While (Index(Line,'TheEnd ') .eq. 0)
            Line=Get_Ln(ITkQMMM)
            If (Index(Line,'FullCoupling').ne.0) Then
               DynExtPot = .True.
               iMode = Max(iMode,1)
            Else If (Index(Line,'MMPolar').ne.0) Then
               DynExtPot = .True.
               iMode = Max(iMode,2)
            End If
         End Do
         Close (ITkQMMM)
      End If
      If(.not. DynExtPot) Then
        If (ipOldMltp .ne. ip_Dummy) Call Free_Work(ipOldMltp)
        iReturn=0
        Return
      End If
*
      ipIsMM = ip_iDummy
      Call espf_init(natom,nAtQM,ipCord,ipIsMM,ipExt)
      nMult = MltOrd * nAtQM
*
* Compute the grid around the molecule
*
      nGrdPt = 0
      ipGrid = ip_Dummy
      ipDGrd = ip_Dummy
      Call StatusLine(' espf:',' Making the grid')
      If (iGrdTyp.eq.1) Then
         Call MkGrid(natom,ipCord,ipGrid,nGrdPt,iRMax,DeltaR,.False.,
     &      ipIsMM,-iGrdTyp,ipDGrd,nAtQM)
         Call GetMem('ESPF_Grid','Allo','Real',ipGrid,3*nGrdPt)
         Call MkGrid(natom,ipCord,ipGrid,nGrdPt,iRMax,DeltaR,.False.,
     &     ipIsMM,iGrdTyp,ipDGrd,nAtQM)
      Else
         Call MkGrid(natom,ipCord,ipGrid,nGrdPt,iRMax,DeltaR,.False.,
     &      ipIsMM,iGrdTyp,ipDGrd,nAtQM)
      End If
*
* Compute the cartesian tensor T, TtT^-1, [TtT^-1]Tt
* and B=ExtPot[TtT^-1]Tt
* Tt means the transpose of T
*
* Warning, at this point ExtPot is not filled (only TTT is needed)
*
      iSize1 = nMult * nGrdPt
      iSize2 = nMult * nMult
      iSize3 = nMult * Max(nMult,nGrdPt)
      Call GetMem('CartTensor','Allo','Real',ipT,iSize1)
      Call GetMem('TT','Allo','Real',ipTT,iSize2)
      Call GetMem('TTT','Allo','Real',ipTTT,iSize3)
      Call GetMem('ExtPot*TTT','Allo','Real',ipB,nGrdPt)
      Call InitB(nMult,natom,nAtQM,nGrdPt,ipCord,ipGrid,ipT,ipTT,ipTTT,
     &           ipExt,ipB,ipIsMM)
*
* Read the old MM electrostatic potential (and derivatives) from PotFile
*
      IPotFl=IsFreeUnit(IPotFl)
      Call Molcas_Open(IPotFl,'ESPF.EXTPOT')
      Line = Get_Ln(IPotFl)
      Call Get_I1(1,nChg)
      If (nChg .ne. 0) Then
         Write(6,*) 'ESPF: nChg ne 0 in h1_espf'
         Call Abend()
      End If
      Do iAt = 1, natom
         Line = Get_Ln(IPotFl)
         Call Get_I1(1,jAt)
         Call Get_F(2,Work(ipExt+(jAt-1)*MxExtPotComp),MxExtPotComp)
      End Do
      Close(IPotFl)
*
* Compute the quantum atomic multipoles
*
      Call GetMem('ESPFMltp','Allo','Real',ipMltp,nMult)
      Call espf_mltp(natom,MltOrd,nMult,nGrdPt,ipTTT,ipMltp,ipGrid,
     &               ipIsMM,ipExt,iPL-1)
*
* Run Tinker
*
      UpdateVMM = .False.
      If (ipOldMltp .ne. ip_Dummy) Then
         sum1 = Zero
         sum2 = Zero
         sum3 = Zero
         sum4 = Zero
         Do iMlt = 1, nMult, MltOrd
            sum1 = Abs(Work(ipMltp+iMlt-1)-Work(ipOldMltp+iMlt-1))
            UpdateVMM = UpdateVMM .or. (sum1 .gt. 0.001d0)
            If (MltOrd .eq. 4) Then
            sum2 = sum2+(Work(ipMltp+iMlt  )-Work(ipOldMltp+iMlt  ))**2
            sum3 = sum3+(Work(ipMltp+iMlt+1)-Work(ipOldMltp+iMlt+1))**2
            sum4 = sum4+(Work(ipMltp+iMlt+2)-Work(ipOldMltp+iMlt+2))**2
            End If
         End Do
         rms1 = sqrt(sum1/nMult)
         rms2 = sqrt(sum2/nMult)
         rms3 = sqrt(sum3/nMult)
         rms4 = sqrt(sum4/nMult)
         If (MltOrd .eq. 4) Then
            UpdateVMM = UpdateVMM .or. (rms2 .gt. -0.01d0)
            UpdateVMM = UpdateVMM .or. (rms3 .gt. -0.01d0)
            UpdateVMM = UpdateVMM .or. (rms4 .gt. -0.01d0)
         End If
         Call Free_Work(ipOldMltp)
      Else
         UpdateVMM = .True.
      End If
      iQMchg = 1
      If (First .and. Do_DFT) UpdateVMM = .True.
      If (UpdateVMM) Call RunTinker(natom,ipCord,ipMltp,ipIsMM,MltOrd,
     &                    DynExtPot,iQMchg,natMM,StandAlone,DoDirect)
*
* Read the MM electrostatic potential (and derivatives) from PotFile
*
      IPotFl=IsFreeUnit(IPotFl)
      Call Molcas_Open(IPotFl,'ESPF.EXTPOT')
      Line = Get_Ln(IPotFl)
      Call Get_I1(1,nChg)
      If (nChg .ne. 0) Then
         Write(6,*) 'ESPF: nChg ne 0 in h1_espf'
         Call Abend()
      End If
      Do iAt = 1, natom
         Line = Get_Ln(IPotFl)
         Call Get_I1(1,jAt)
         Call Get_F(2,Work(ipExt+(jAt-1)*MxExtPotComp),MxExtPotComp)
      End Do
      Close(IPotFl)
*
* Recompute the B matrix
*
      Call InitB(nMult,natom,nAtQM,nGrdPt,ipCord,ipGrid,ipT,ipTT,ipTTT,
     &           ipExt,ipB,ipIsMM)
*
* Compute the modification of the core hamiltonian
*
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      Call StatusLine(' espf:',' Computing energy components')
      Call espf_energy(nBas(0),natom,nGrdPt,ipExt,ipGrid,ipB,h1,nh1,
     &                 RepNuc,RealDummy,DoTinker,DoGromacs,DynExtPot)
*
* Save the modified h1 matrix
*
      Call Put_Temp('h1    XX',h1,nh1)
      Call Put_Temp('PotNucXX',[RepNuc],1)
      If (.not.DynExtPot) Then
         Call Put_Temp('h1_raw  ',h1,nh1)
         Call Put_Temp('PotNuc00',[RepNuc],1)
      End If
*
* Save data in the ESPF.DATA file
*
      Call espf_write(MltOrd,iRMax,DeltaR,iGrdTyp,nGrdPt,DoTinker,
     &                DoGromacs,lMorok,ipMltp,nMult,ipIsMM,natom,
     &                .False.,.False.,DoDirect)
*
* The end
*
      Call GetMem('ExtPot*TTT','Free','Real',ipB,nGrdPt)
      Call GetMem('ExtPot','Free','Real',ipExt,natom*MxExtPotComp)
      Call GetMem('TTT','Free','Real',ipTTT,iSize3)
      Call GetMem('TT','Free','Real',ipTT,iSize2)
      Call GetMem('CartTensor','Free','Real',ipT,iSize1)
      Call GetMem('ESPFMltp','Free','Real',ipMltp,nMult)
      Call GetMem('ESPF_Grid','Free','Real',ipGrid,3*nGrdPt)
      Call GetMem('IsMM for atoms','Free','Inte',ipIsMM,natom)
      Call GetMem('AtomCoord','Free','Real',ipCord,3*natom)
*
      iReturn=0
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine grad_cvb(grad)

use casvb_global, only: civb2, civb3, civb4, civb6, civb7, civb8, dvbdet, dxmove, grad1, grad2, gradx, icrit, memplenty, ovraa, &
                        ovraa_try, ovrab, ovrab_try, vec1, ww, ww_try
use Definitions, only: wp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: grad(*)

call touch_cvb('OOHESS')
if (dxmove .and. memplenty) then
  call cicopy_cvb(civb6,civb2)
  call cicopy_cvb(civb7,civb3)
  call cicopy_cvb(civb8,civb4)
else if (dxmove) then
  call cird_cvb(civb2,61006.2_wp)
  call cird_cvb(civb3,61007.2_wp)
  call cird_cvb(civb4,61008.2_wp)
end if
ovraa = ovraa_try
ovrab = ovrab_try
ww = ww_try
if (icrit == 1) then
  call gr_svb1_cvb(civb2,civb3,civb4,dvbdet,grad,grad1,grad2,gradx,vec1)
else if (icrit == 2) then
  call gr_evb1_cvb(civb2,civb3,civb4,dvbdet,grad,grad1,grad2,gradx,vec1)
end if

return

end subroutine grad_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1995, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE NEWTYP(INSPGP,IACOP,ITPOP,OUTSPGP)
*
* an input  supergroup is given.
* apply an string of elementary operators to this supergroup and
* obtain supergroup mumber of new string
*
* Jeppe Olsen, October 1993
* GAS-version : July 95
*
* ------
* Input
* ------
*
* INSPGP  : input super group ( given occupation in each AS )
* IACOP = 1 : operator is an annihilation operator
*       = 2 : operator is a  creation   operator
* ITPOP : orbitals space of operator
*
* Output
* ------
* OUTSPGP  : supergroup of resulting string
*
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "cgas.fh"
#include "strbas.fh"
#include "WrkSpc.fh"
*. Input
      INTEGER INSPGP,IACOP,ITPOP
*. output
      INTEGER OUTSPGP
*
      IF(IACOP.EQ.1) THEN
        OUTSPGP = IWORK(KSPGPAN+ITPOP-1+NGAS*(INSPGP-1))
      ELSE
        OUTSPGP = IWORK(KSPGPCR+ITPOP-1+NGAS*(INSPGP-1))
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
!#define _OBSOLETE_
subroutine RFNuc(CoOP,rNucMm,ir)
!***********************************************************************
!                                                                      *
! Object: to compute the multipole moments for the nuclei.             *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _OBSOLETE_
use Phase_Info, only: iPhase
use External_Centers, only: nOrd_XF, XF
#endif
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ir
real(kind=wp), intent(in) :: CoOp(3)
real(kind=wp), intent(out) :: rNucMm(nTri_Elem1(ir))
integer(kind=iwp) :: i, iCnt, iCnttp, iq, ix, iy, iz, mdc, ndc
real(kind=wp) :: A(3), CCoMx, CCoMy, CComZ, RA(3), temp, ZA
#ifdef _OBSOLETE_
integer(kind=iwp) :: iStb(0:7), jCoSet(0:7,0:7)
real(kind=wp) :: DAx, DAy, DAz, QRAxx, QRAxy, QRAxz, QRAyy, QRAyz, QRAzz, Qxx, Qxy, Qxz, Qyy, Qyz, Qzz, rRMy(3)
#endif
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ip
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt(' In RFNuc:CoOp',' ',CoOp,1,3)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the nuclear contribution to the multipole moments

! Contributions due to the charges of nuclear charges

iq = 0
do ix=ir,0,-1
  do iy=ir-ix,0,-1
    iq = iq+1
    iz = ir-ix-iy
    temp = Zero
    !write(u6,*) ' ix,iy,iz=',ix,iy,iz

    ndc = 0
    do iCnttp=1,nCnttp
      if (iCnttp > 1) ndc = ndc+dbsc(iCnttp-1)%nCntr
      ZA = dbsc(iCnttp)%Charge
      if (ZA == Zero) cycle
#     ifdef _DEBUGPRINT_
      write(u6,*) ' Charge=',ZA
      call RecPrt(' Centers',' ',dbsc(iCnttp)%Coor,3,dbsc(iCnttp)%nCntr)
#     endif
      do iCnt=1,dbsc(iCnttp)%nCntr
        A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
        mdc = ndc+iCnt
        do i=0,nIrrep/dc(mdc)%nStab-1
          call OA(dc(mdc)%iCoSet(i,0),A,RA)
          !call RecPrt(' RA',' ',RA,1,3)
          !call RecPrt(' CoOp',' ',CoOp,1,3)

          if (ix == 0) then
            CCoMx = One
          else
            CCoMx = (RA(1)-CoOp(1))**ix
          end if
          if (iy == 0) then
            CCoMy = One
          else
            CCoMy = (RA(2)-CoOp(2))**iy
          end if
          if (iz == 0) then
            CCoMz = One
          else
            CCoMz = (RA(3)-CoOp(3))**iz
          end if
          !write(u6,*) CCoMx, CCoMy, CCoMz, temp
          temp = temp+ZA*CCoMx*CCoMy*CCoMz
        end do
      end do
    end do
    rNucMm(iq) = temp
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _OBSOLETE_
! The remainder of this subroutine is obsolete and
! is kept only for testing reasons. It is replaced by
! the subroutine XFMoment which is more general.

if (allocated(XF) .and. (nOrd_XF >= 0) then

  ! Contributions due to the charges and dipoles of the
  ! static external electric field.

  !write(u6,*) ' Adding contributions from esef!'

  iq = 0
  do ix=ir,0,-1
    do iy=ir-ix,0,-1
      iq = iq+1
      iz = ir-ix-iy
      temp = Zero
      !write(u6,*) ' ix,iy,iz=',ix,iy,iz

      do iFd=1,nXF
        DAx = Zero
        DAy = Zero
        DAz = Zero
        Qxx = Zero
        Qxy = Zero
        Qxz = Zero
        Qyy = Zero
        Qyz = Zero
        Qzz = Zero
        if (nOrd_XF == 0) then
          ZA = XF(4,iFd)
        else if (nOrd_XF == 1) then
          ZA = XF(4,iFd)
          DAx = XF(5,iFd)
          DAy = XF(6,iFd)
          DAz = XF(7,iFd)
        else if (nOrd_XF == 2) then
          ZA = XF(4,iFd)
          DAx = XF(5,iFd)
          DAy = XF(6,iFd)
          DAz = XF(7,iFd)
          Qxx = XF(8,iFd)
          Qxy = XF(9,iFd)
          Qxz = XF(10,iFd)
          Qyy = XF(11,iFd)
          Qyz = XF(12,iFd)
          Qzz = XF(13,iFd)
        else
          call WarningMessage(2,'RFNuc: Option not implemented yet!')
          call Abend()
        end if
#       ifdef _DEBUGPRINT_
        write(u6,*) ' Charge=',ZA
        write(u6,*) ' ixyz=',ixyz
        call RecPrt(' Centers',' ',XF(1,iXF),3,1)
#       endif

        A(1:3) = XF(1:3,iXF)

        ! Generate Stabilazor of C

        iChxyz = iChAtm(A)
        iDum = 0
        call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)

        !write(u6,*) ' nStb=',nStb
        do i=0,nIrrep/nStb-1
          call OA(jCoSet(i,0),A,RA)
          rRMy(1) = DAx*real(iPhase(1,jCoSet(i,0)),kind=wp)
          rRMy(2) = DAy*real(iPhase(2,jCoSet(i,0)),kind=wp)
          rRMy(3) = DAz*real(iPhase(3,jCoSet(i,0)),kind=wp)
          QRAxx = QAxx
          QRAyy = QAyy
          QRAzz = QAzz
          QRAxy = real(iPhase(1,jCoSet(i,0))*iPhase(2,jCoSet(i,0)),kind=wp)*QAxy
          QRAxz = real(iPhase(1,jCoSet(i,0))*iPhase(3,jCoSet(i,0)),kind=wp)*QAxz
          QRAyz = real(iPhase(2,jCoSet(i,0))*iPhase(3,jCoSet(i,0)),kind=wp)*QAyz

          if (ix == 0) then
            CCoMx = One
          else
            CCoMx = (RA(1)-CoOp(1))**ix
          end if
          if (iy == 0) then
            CCoMy = One
          else
            CCoMy = (RA(2)-CoOp(2))**iy
          end if
          if (iz == 0) then
            CCoMz = One
          else
            CCoMz = (RA(3)-CoOp(3))**iz
          end if

          !write(u6,*) CCoMx, CCoMy, CCoMz, temp

          ! The charge contribution

          temp = temp+ZA*CCoMx*CCoMy*CCoMz

          ! Dipole contributions

          if (ix >= 1) temp = temp+real(ix,kind=wp)*rRmy(1)*CCoMy*CCoMz*(RA(1)-CoOp(1))**(ix-1)
          if (iy >= 1) temp = temp+real(iy,kind=wp)*rRmy(2)*CCoMx*CCoMz*(RA(2)-CoOp(2))**(iy-1)
          if (iz >= 1) temp = temp+real(iz,kind=wp)*rRmy(3)*CCoMx*CCoMy*(RA(3)-CoOp(3))**(iz-1)

        end do
      end do
      !write(u6,*) ' Temp=',temp
      rNucMm(iq) = rNucMm(iq)+temp

    end do
  end do

end if
#endif
#ifdef _DEBUGPRINT_
call RecPrt(' Nuclear Multipole Moments',' ',rNucMm,ip,1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine RFNuc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************
Module Slapaf_Info
implicit none
Private
Public:: Cx, Gx, Gx0, NAC, Q_nuclear, dMass, Coor, Grd, ANr, Weights, Shift, GNrm, Lambda, &
         Energy, Energy0, DipM, MF, qInt, dqInt, nSup, Atom, RefGeo, BMx, Degen, jStab, nStab, iCoSet, &
         BM, dBM, iBM, idBM, nqBM, R12, GradRef, KtB, AtomLbl, Smmtrc, Lbl, mRowH, RootMap, &
         Free_Slapaf, Get_Slapaf, Dmp_Slapaf
!
! Arrays always allocated
!
Real*8, Allocatable:: Cx(:,:,:)     ! list of Cartesian coordinates
Real*8, Allocatable:: Gx(:,:,:)     ! list of Cartesian Gradients, State 1
Real*8, Allocatable:: Gx0(:,:,:)    ! list of Cartesian Gradients, State 2 for optimization of conical intersections
Real*8, Allocatable:: Q_nuclear(:)  ! list nuclear charges
Real*8, Allocatable:: dmass(:)      ! list atomic mass in units of (C=12)
Real*8, Allocatable:: Coor(:,:)     ! Cartesian coordinates of the last iteraction
Real*8, Allocatable:: Grd(:,:)      ! gradient of the last iteraction in Cartesian coordinates
Real*8, Allocatable:: Weights(:)    ! list of weights of ALL centers, however, the symmetry unique are first.
Real*8, Allocatable:: Shift(:,:)    ! list of displacements in Cartesian coordinates
Real*8, Allocatable:: GNrm(:)       ! list of the gradient norm for each iteration
Real*8, Allocatable:: Energy(:)     ! list of the energies of each iteration, State 1
Real*8, Allocatable:: Energy0(:)    ! list of the energies of each iteration, State 2 for optimization of conical intersections
Real*8, Allocatable:: MF(:,:)       ! list of Cartesian mode following vectors for each iteration
Real*8, Allocatable:: DipM(:,:)     ! list of dipole moments for each iteration
Real*8, Allocatable:: qInt(:,:)     ! internal coordinates for each iteration
Real*8, Allocatable:: dqInt(:,:)    ! derivatives of internal coordinates for each iteration
Real*8, Allocatable, Target:: RefGeo(:,:)   ! Reference geometry in Cartesian coordinates
Real*8, Allocatable, Target:: R12(:,:)      ! Reference geometry in R-P calculation (not used right now)
Real*8, Allocatable, Target:: GradRef(:,:)  ! Reference gradient
Real*8, Allocatable, Target:: Bmx(:,:)      ! the B matrix
Real*8, Allocatable:: Degen(:,:)    ! list of degeneracy numbers of the unique atoms (three identical entries)
Integer, Allocatable:: jStab(:,:), iCoset(:,:), nStab(:) ! stabilizer and cosets information for the indivudual centers
#include "LenIn.fh"
Character(LEN=LENIN), Allocatable:: AtomLbl(:) ! atomic labels
Logical, Allocatable:: Smmtrc(:,:)    ! Array with logical symmetry information on if a Cartesian is symmetric or not.
Character(LEN=8), Allocatable:: Lbl(:) ! Labels for internl coordinates and constraints

! Arrays for automatic internal coordinates
Real*8, Allocatable:: BM(:)         ! ...
Real*8, Allocatable:: dBM(:)        ! ...
Integer, Allocatable:: iBM(:)       ! ...
Integer, Allocatable:: idBM(:)      ! ...
Integer, Allocatable:: nqBM(:)      ! ...

Integer, Allocatable:: ANr(:)       ! list of atomic numbers
!
! Arrays optionally allocated
!
Real*8, Allocatable:: NAC(:,:)      ! list of Cartesian non-adiabatic coupling vector
Real*8, Allocatable:: Lambda(:,:)   ! list of the Lagrange multipiers
Integer, Allocatable:: mRowH(:)     ! rows of the Hessian to be explicitly computed
Integer, Allocatable:: RootMap(:)   ! Array to map the roots between iterations
!
! Utility arrays with explicit deallocation, i.e. not via Free_Slapaf()
!
Integer, Allocatable:: Atom(:)      ! Temporary arrays for the super symmetry case
Integer, Allocatable:: NSup(:)      ! Temporary arrays for the super symmetry case
Real*8, Allocatable::  KtB(:,:)     ! KtB array for the BMtrx family of subroutines

Logical:: Initiated=.False.
Integer nsAtom
Contains
  Subroutine Free_Slapaf()
#include "stdalloc.fh"
  If (Allocated(Energy)) Call mma_deallocate(Energy)
  If (Allocated(Energy0)) Call mma_deallocate(Energy0)
  If (Allocated(DipM)) Call mma_deallocate(DipM)
  If (Allocated(GNrm)) Call mma_deallocate(GNrm)
  If (Allocated(Cx)) Call mma_deallocate(Cx)
  If (Allocated(Gx)) Call mma_deallocate(Gx)
  If (Allocated(Gx0)) Call mma_deallocate(Gx0)
  If (Allocated(MF)) Call mma_deallocate(MF)
  If (Allocated(Lambda)) Call mma_deallocate(Lambda)
  If (Allocated(Degen)) Call mma_deallocate(Degen)
  If (Allocated(jStab)) Call mma_deallocate(jStab)
  If (Allocated(iCoSet)) Call mma_deallocate(iCoSet)
  If (Allocated(nStab)) Call mma_deallocate(nStab)
  If (Allocated(AtomLbl)) Call mma_deallocate(AtomLbl)
  If (Allocated(Smmtrc)) Call mma_deallocate(Smmtrc)
  If (Allocated(Lbl)) Call mma_deallocate(Lbl)

  If (Allocated(Q_nuclear)) Call mma_deallocate(Q_nuclear)
  If (Allocated(dMass)) Call mma_deallocate(dMass)
  If (Allocated(Coor)) Call mma_deallocate(Coor)
  If (Allocated(Grd)) Call mma_deallocate(Grd)
  If (Allocated(ANr)) Call mma_deallocate(ANr)
  If (Allocated(Weights)) Call mma_deallocate(Weights)
  If (Allocated(Shift)) Call mma_deallocate(Shift)
  If (Allocated(BMx)) Call mma_deallocate(BMx)

  If (Allocated(BM)) Call mma_deallocate(BM)
  If (Allocated(dBM)) Call mma_deallocate(dBM)
  If (Allocated(iBM)) Call mma_deallocate(iBM)
  If (Allocated(idBM)) Call mma_deallocate(idBM)
  If (Allocated(nqBM)) Call mma_deallocate(nqBM)

  If (Allocated(RefGeo)) Call mma_deallocate(RefGeo)
  If (Allocated(R12)) Call mma_deallocate(R12)
  If (Allocated(R12)) Call mma_deallocate(GradRef)

  If (Allocated(NAC)) Call mma_deallocate(NAC)
  If (Allocated(qInt)) Call mma_deallocate(qInt)
  If (Allocated(dqInt)) Call mma_deallocate(dqInt)
  If (Allocated(mRowH)) Call mma_deallocate(mRowH)
  If (Allocated(RootMap)) Call mma_deallocate(RootMap)
  End Subroutine Free_Slapaf



  Subroutine Get_Slapaf(iter,MaxItr,mTROld,lOld_Implicit, nsAtom_In,mLambda)
  Integer iter, MaxItr, mTROld, nsAtom_In, mLambda
  Logical lOld_Implicit
#include "real.fh"
#include "stdalloc.fh"
  Logical Exist
  Integer itmp, iOff, Lngth
  Integer, Allocatable:: Information(:)
  Real*8, Allocatable:: Relax(:)
  Character(LEN=100) SuperName
  Character(LEN=100), External:: Get_SuperName

  Initiated=.True.

  nsAtom=nsAtom_In

  Call mma_allocate(Information,7,Label='Information')

  Call qpg_iArray('Slapaf Info 1',Exist,itmp)
  If (Exist) Call Get_iArray('Slapaf Info 1',Information,7)

  If (.Not.Exist.or.(Exist.and.Information(1).eq.-99)) Then
!    Write (6,*) 'Reinitiate Slapaf fields on runfile'
     Information(:)=0
     Information(3)=-99
     Call Put_iArray('Slapaf Info 1',Information,7)
  End If

  iter  =Information(2)+1
  If (iter.ge.MaxItr+1) Then
     Write (6,*) 'Increase MaxItr in slapaf_info.f90'
     Call WarningMessage(2,'iter.ge.MaxItr+1')
     Call Abend()
  End If
  mTROld=Information(3)
  lOld_Implicit= Information(4).eq.1

  Call mma_deallocate(Information)

  If (.NOT.Allocated(Energy)) Then

  Call mma_allocate(Energy,          MaxItr+1,Label='Energy')
  Energy(:) = Zero
  Call mma_allocate(Energy0,         MaxItr+1,Label='Energy0')
  Energy0(:) = Zero
  Call mma_allocate(DipM,   3,       MaxItr+1,Label='DipM')
  DipM(:,:) = Zero
  Call mma_allocate(GNrm,            MaxItr+1,Label='GNrm')
  GNrm(:) = Zero
  Call mma_allocate(Cx,     3,nsAtom,MaxItr+1,Label='Cx')
  Cx(:,:,:) = Zero
  Call mma_allocate(Gx,     3,nsAtom,MaxItr+1,Label='Gx')
  Gx(:,:,:) = Zero
  Call mma_allocate(Gx0,    3,nsAtom,MaxItr+1,Label='Gx0')
  Gx0(:,:,:) = Zero
  Call mma_allocate(MF,     3,nsAtom,         Label='MF')
  MF(:,:) = Zero
  If (mLambda>0) Then
     Call mma_allocate(Lambda,mLambda,MaxItr+1,Label='Lambda')
     Lambda(:,:)=Zero
  End If

  End If

  If (iter==1) Return

  SuperName=Get_Supername()
  If (SuperName.ne.'numerical_gradient') Then

     Lngth=SIZE(Energy)+SIZE(Energy0)+SIZE(DipM)+SIZE(GNrm)+SIZE(Cx)+SIZE(Gx)  &
          +SIZE(Gx0)+SIZE(MF)+SIZE(Lambda)
     Call mma_allocate(Relax,Lngth,Label='Relax')
     Call Get_dArray('Slapaf Info 2',Relax,Lngth)

     iOff=1
     Call DCopy_(SIZE(Energy ),Relax(iOff),1,Energy ,1)
     iOff=iOff+SIZE(Energy)
     Call DCopy_(SIZE(Energy0),Relax(iOff),1,Energy0,1)
     iOff=iOff+SIZE(Energy0)
     Call DCopy_(SIZE(DipM   ),Relax(iOff),1,DipM   ,1)
     iOff=iOff+SIZE(DipM   )
     Call DCopy_(SIZE(GNrm   ),Relax(iOff),1,GNrm   ,1)
     iOff=iOff+SIZE(GNrm   )
     Call DCopy_(SIZE(Cx     ),Relax(iOff),1,Cx     ,1)
     iOff=iOff+SIZE(Cx     )
     Call DCopy_(SIZE(Gx     ),Relax(iOff),1,Gx     ,1)
     iOff=iOff+SIZE(Gx     )
     Call DCopy_(SIZE(Gx0    ),Relax(iOff),1,Gx0    ,1)
     iOff=iOff+SIZE(Gx0    )
     Call DCopy_(SIZE(MF     ),Relax(iOff),1,MF     ,1)
     iOff=iOff+SIZE(MF     )
     If (Allocated(Lambda)) Then
        Call DCopy_(SIZE(Lambda ),Relax(iOff),1,Lambda ,1)
        iOff=iOff+SIZE(Lambda )
     End If
     Call mma_deallocate(Relax)
   Else
     iter=1
   End If

  End Subroutine Get_Slapaf



  Subroutine Dmp_Slapaf(Stop,Just_Frequencies,Energy_In,Iter,MaxItr,mTROld, &
                        lOld_Implicit,nsAtom)
  Logical Stop, Just_Frequencies, lOld_Implicit
  Real*8 Energy_In
  Integer Iter, MaxItr, mTROld, nsAtom
#include "stdalloc.fh"
  Integer, Allocatable:: Information(:)
  Real*8, Allocatable:: Relax(:)
  Real*8, Allocatable:: GxFix(:,:)
  Integer iOff_Iter, nSlap, iOff, Lngth
  Logical Found
  Character(LEN=100) SuperName
  Character(LEN=100), External:: Get_SuperName

  If (.NOT.Initiated) Then
     Write (6,*) 'Dmp_Slapaf: Slapaf not initiated!'
     Call Abend()
  Else
     Initiated=.False.
  End If

!---  Write information of this iteration to the RLXITR file
  Call mma_allocate(Information,7,Label='Information')
  If (Stop) Then
     Information(1)=-99     ! Deactivate the record
     iOff_Iter=0
     Call Put_iScalar('iOff_Iter',iOff_Iter)
!
!    Restore the runfile data as if the computation was analytic
!    (note the gradient sign must be changed back)
!
     If (Just_Frequencies) Then
        Call Put_dScalar('Last Energy',Energy_In)
        Call mma_allocate(GxFix,3,nsAtom,Label='GxFix')
        call dcopy_(3*nsAtom,Gx,1,GxFix,1)
        GxFix(:,:) = - GxFix(:,:)
        Call Put_Grad(GxFix,3*nsAtom)
        Call mma_deallocate(GxFix)
        Call Put_dArray('Unique Coordinates',Cx,3*nsAtom)
        Call Put_Coord_New(Cx,nsAtom)
     End If
  Else
     Call qpg_iArray('Slapaf Info 1',Found,nSlap)
     If (Found) Then
        Call Get_iArray('Slapaf Info 1',Information,7)
        If (Information(1).ne.-99) Information(1)=MaxItr
     Else
        Information(1)=MaxItr
     End If
  End If

  SuperName=Get_Supername()
  If (SuperName.ne.'numerical_gradient') Then
     Information(2)=Iter
     Information(3)=mTROld ! # symm. transl /rot.
     If (lOld_Implicit) Then
        Information(4)=1
     Else
        Information(4)=0
     End If
     Information(5)=0
     Information(6)=SIZE(Energy)+SIZE(Energy0)+SIZE(DipM)+SIZE(GNrm)
     Information(7)=SIZE(Energy)+SIZE(Energy0)+SIZE(DipM)+SIZE(GNrm)+SIZE(Cx)
     Call Put_iArray('Slapaf Info 1',Information,7)

     Lngth=SIZE(Energy)+SIZE(Energy0)+SIZE(DipM)+SIZE(GNrm)+SIZE(Cx)+SIZE(Gx)  &
          +SIZE(Gx0)+SIZE(MF)+SIZE(Lambda)
     Call mma_allocate(Relax,Lngth,Label='Relax')
     iOff = 1
     Call DCopy_(SIZE(Energy ),Energy ,1,Relax(iOff),1)
     iOff = iOff + SIZE(Energy )
     Call DCopy_(SIZE(Energy0),Energy0,1,Relax(iOff),1)
     iOff = iOff + SIZE(Energy0)
     Call DCopy_(SIZE(DipM   ),DipM   ,1,Relax(iOff),1)
     iOff = iOff + SIZE(DipM   )
     Call DCopy_(SIZE(GNrm   ),GNrm   ,1,Relax(iOff),1)
     iOff = iOff + SIZE(GNrm   )
     Call DCopy_(SIZE(Cx     ),Cx     ,1,Relax(iOff),1)
     iOff = iOff + SIZE(Cx     )
     Call DCopy_(SIZE(Gx     ),Gx     ,1,Relax(iOff),1)
     iOff = iOff + SIZE(Gx     )
     Call DCopy_(SIZE(Gx0    ),Gx0    ,1,Relax(iOff),1)
     iOff = iOff + SIZE(Gx0    )
     Call DCopy_(SIZE(MF     ),MF     ,1,Relax(iOff),1)
     iOff = iOff + SIZE(MF     )
     If (Allocated(Lambda)) Then
        Call DCopy_(SIZE(Lambda ),Lambda ,1,Relax(iOff),1)
        iOff = iOff + SIZE(Lambda )
     End If
     Call Put_dArray('Slapaf Info 2',Relax,Lngth)
     Call mma_deallocate(Relax)
  End If
  Call mma_deallocate(Information)

  End Subroutine Dmp_Slapaf
End Module Slapaf_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine magnetization( nss, nM, nTempMagn, nDirTot, nDir,
     &                          nDirZee, nH, iPrint, LUZee, mem,
     &                          compute_Mdir_vector, zeeman_energy,
     &                          hinput, m_paranoid, smagn, doplot,
     &                          TempMagn, eso, dirX, dirY, dirZ,
     &                          dir_weight, hexp, magn_exp, zJ, hmin,
     &                          hmax, EM, thrs,
     &                          dipm, sm, dbg )
************************************************************************
*                                                                      *
*     MAGNETIZATION control section                                    *
*                                                                      *
*     calling arguments:                                               *
*     NSS     : number of spin-orbit states (total)                    *
*               scalar integer                                         *
*     NM      : size of the Zeeman Hamiltonian matrix                  *
*               scalar integer                                         *
*     EM      : cut-off energy (energy of the last s-o state which is  *
*               included in the Zeeman matrix                          *
*               scalar real*8                                          *
*     EM      : cut-off energy (energy of the last s-o state which is  *
*               included in the Zeeman matrix                          *
*               scalar real*8                                          *
*     IFINAL  : integer                                                *
*               termination flag                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     Liviu Ungur                                                      *
*     University of Leuven, Belgium, 2008-2017                         *
*                                                                      *
*----------------------------------------------------------------------*
*     Hystory:                                                         *
*     Liviu Ungur, 2008-2017 various modifications                     *
************************************************************************

      Implicit None
      Integer, Parameter            :: wp=kind(0.d0)
#include "mgrid.fh"
#include "stdalloc.fh"
!----------------------------------------------------------------
      ! input data (30)
      Integer, intent(in)          :: nDir
      Integer, intent(in)          :: nDirZee
      Integer, intent(in)          :: nDirTot
      Integer, intent(in)          :: nss
      Integer, intent(in)          :: nM
      Integer, intent(in)          :: nH
      Integer, intent(in)          :: iprint
      Integer, intent(in)          :: nTempMagn
      Integer, intent(in)          :: mem
      Integer, intent(in)          :: LUZee(nDirZee)

      Logical, intent(in)          :: compute_Mdir_vector
      Logical, intent(in)          :: zeeman_energy
      Logical, intent(in)          :: DoPlot
      Logical, intent(in)          :: hinput
      Logical, intent(in)          :: smagn
      Logical, intent(in)          :: m_paranoid
      Logical, intent(in)          :: dbg

      Real(kind=8), intent(in)    :: dirX(nDir), dirY(nDir), dirZ(nDir)
      Real(kind=8), intent(in)    :: dir_weight(nDirZee,3)
      Real(kind=8), intent(in)    :: hmin, hmax
      Real(kind=8), intent(in)    :: zj, thrs
      Real(kind=8), intent(in)    :: eso(nss)
      Real(kind=8), intent(in)    :: EM
      Real(kind=8), intent(in)    :: TempMagn(nTempMagn)
      Real(kind=8), intent(in)    :: hexp(nH)
      Real(kind=8), intent(in)    :: magn_exp(nH,nTempMagn)

      Complex(kind=8), intent(in) ::   sm(3,nss,nss)
      Complex(kind=8), intent(in) :: dipm(3,nss,nss)
!----------------------------------------------------------------
!     local variables
      Integer       :: nP,iTEnd,iT,IM,I,L,J,IC,IDIR,IH,iTemp
      Real(kind=8) :: DLTH, mv, sv, dev
      Character(len=99):: STLNE1, STLNE2

      Real(kind=8), allocatable :: WM(:)         ! WM(nm)
      Real(kind=8), allocatable :: MT(:,:,:)     ! MT(3,nH,nTempMagn)
      Real(kind=8), allocatable :: ST(:,:,:)     ! ST(3,nH,nTempMagn)
      ! magnetization and spin vectors
      Real(kind=8), allocatable :: MVEC(:,:,:,:)
!                                   MVEC(nDirTot,nH,nTempMagn,3)
      Real(kind=8), allocatable :: SVEC(:,:,:,:)
!                                   SVEC(nDirTot,nH,nTempMagn,3)
      Real(kind=8), allocatable :: H(:)          ! H(nH)
      ! average powder M and S:
      Real(kind=8), allocatable :: MAV(:,:) ! MAV(nH,nTempMagn)
      Real(kind=8), allocatable :: SAV(:,:) ! SAV(nH,nTempMagn)

      Real(kind=8), allocatable :: ZT(:,:)  ! ZT(nH,nTempMagn)
      Real(kind=8), allocatable :: STDEV(:) ! STDEV(nTempMagn)
      Real(kind=8), allocatable :: dHX(:)   ! dHX(nDirTot)
      Real(kind=8), allocatable :: dHY(:)   ! dHY(nDirTot)
      Real(kind=8), allocatable :: dHZ(:)   ! dHZ(nDirTot)
      Real(kind=8), allocatable :: dHW(:)   ! dHW(nDirTot)

      Integer          :: mem_local, RtoB

      External      :: dev

!-----------------------------------------------------------------------
! Allocate necessary memory
      mem_local=0
      RtoB=8

      ! Zeeman exchange energy spectrum
      Call mma_allocate(WM,nM,'W')
      Call dcopy_(nM,[0.0_wp],0,WM,1)
      mem_local=mem_local+nM*RtoB

      Call mma_allocate(MT,3,nH,nTempMagn,'MT')
      Call dcopy_(3*nH*nTempMagn,[0.0_wp],0,MT,1)
      mem_local=mem_local+3*nH*nTempMagn*RtoB

      Call mma_allocate(ST,3,nH,nTempMagn,'ST')
      Call dcopy_(3*nH*nTempMagn,[0.0_wp],0,ST,1)
      mem_local=mem_local+3*nH*nTempMagn*RtoB

      Call mma_allocate(MAV,nH,nTempMagn,'MAV')
      Call dcopy_(nH*nTempMagn,[0.0_wp],0,MAV,1)
      mem_local=mem_local+nH*nTempMagn*RtoB

      Call mma_allocate(SAV,nH,nTempMagn,'SAV')
      Call dcopy_(nH*nTempMagn,[0.0_wp],0,SAV,1)
      mem_local=mem_local+nH*nTempMagn*RtoB

      Call mma_allocate(ZT,nH,nTempMagn,'ZT')
      Call dcopy_(nH*nTempMagn,[0.0_wp],0,ZT,1)
      mem_local=mem_local+nH*nTempMagn*RtoB

      Call mma_allocate(MVEC,nDirTot,nH,nTempMagn,3,'MVEC')
      Call mma_allocate(SVEC,nDirTot,nH,nTempMagn,3,'SVEC')
      Call dcopy_(3*nDirTot*nH*nTempMagn,[0.0_wp],0,MVEC,1)
      Call dcopy_(3*nDirTot*nH*nTempMagn,[0.0_wp],0,SVEC,1)
      mem_local=mem_local+6*nDirTot*nH*nTempMagn*RtoB

      Call mma_allocate(H,nH,'H')
      Call dcopy_(nH,[0.0_wp],0,H,1)
      mem_local=mem_local+nH*RtoB

      Call mma_allocate(STDEV,nTempMagn,'H')
      Call dcopy_(nTempMagn,[0.0_wp],0,STDEV,1)
      mem_local=mem_local+nTempMagn*RtoB

      Call mma_allocate(dHX,nDirTot,'dHX')
      Call mma_allocate(dHY,nDirTot,'dHY')
      Call mma_allocate(dHZ,nDirTot,'dHZ')
      Call mma_allocate(dHW,nDirTot,'dHW')
      Call dcopy_(nDirTot,[0.0_wp],0,dHX,1)
      Call dcopy_(nDirTot,[0.0_wp],0,dHY,1)
      Call dcopy_(nDirTot,[0.0_wp],0,dHZ,1)
      Call dcopy_(nDirTot,[0.0_wp],0,dHW,1)
      mem_local=mem_local+4*nDirTot*RtoB
      If(dbg) Write(6,*) 'MAGNETIZATION:  memory allocated (local):'
      If(dbg) Write(6,*) 'mem_local=', mem_local
      If(dbg) Write(6,*) 'MAGNETIZATION:  memory allocated (total):'
      If(dbg) Write(6,*) 'mem_total=', mem+mem_local
!-----------------------------------------------------------------------
      Write(6,*)
      Write(6,'(100A)') (('%'),J=1,96)
      Write(6,'(40X,A)') 'CALCULATION OF THE MOLAR MAGNETIZATION'
      Write(6,'(100A)') (('%'),J=1,96)
      Write(6,*)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      If(DBG.or.iprint>3) Then
        Write(6,'(A, I5)')  'nH                  = ',nH
        Write(6,'(A, I5)')  'nM                  = ',nM
        Write(6,'(A, I5)')  'nsymm               = ',nsymm
        Write(6,'(A, I5)')  'ngrid               = ',ngrid
        Write(6,'(A, I5)')  'nDir                = ',nDir
        Write(6,'(A, I5)')  'nDirZee             = ',nDirZee
        Write(6,'(A, I5)')  'nDirTot             = ',nDirTot
        Write(6,'(A, F9.5)')'HMIN                = ',hmin
        Write(6,'(A, F9.5)')'HMAX                = ',hmax
        Write(6,'(A, F9.5)')'zJ                  = ',zJ
        Write(6,*)          'compute_Mdir_vector = ',compute_Mdir_vector
        Write(6,*)          'hinput              = ',hinput
        Write(6,*)          'zeeman_energy       = ',zeeman_energy
        Write(6,*)          'hinput              = ',hinput
        Write(6,*)          'smagn               = ',smagn
        Write(6,'(A)') 'dir_weight'
        Do i=1,nDirZee
          Write(6,'(3F10.6)') (dir_weight(i,j),j=1,3)
        End Do
        Write(6,'(A)') 'nDir'
        Do i=1,nDir
          Write(6,'(3F10.6)') dirX(i),dirY(i),dirZ(i)
        End Do
        Write(6,'(30(F6.3,a))')
     &                       (TempMagn(iTemp),' K.;',iTemp=1,nTempMagn)
        If (zeeman_energy) Then
          Write(6,'(A)') 'dir_weight'
          Do i=1,nDirZee
            Write(6,'(3F10.6)') (dir_weight(i,j),j=1,3)
          End Do
        End If
      End If

      nP=get_nP(nsymm,ngrid)


      Call hdir( nDir,nDirZee, dirX,dirY,dirZ,dir_weight,
     &           nP,nsymm,ngrid,nDirTot,dHX,dHY,dHZ,dHW)


      Write(6,'(2X,A,i3,A)') 'Molar magnetization will be '//
     &                       'calculated in ',NH,
     &                       ' points, equally distributed in '//
     &                       'magnetic field range'
      Write(6,'(2X,F4.1,1x,a,1X,F4.1,a,10(F6.3,a))') HMIN,'--',HMAX,
     &                       ' T., at the following temperatures:'
      Do i=1,nTempMagn,10
        j=MIN(nTempMagn,i+9)
        Write(6,'(10(F8.4,A))') (TempMagn(l),' K.;',l=i,j)
      End Do
      Write(6,'(2X,A,I4,A)') 'Powder molar magnetization will be '//
     &                       'averaged on ',nP,' directions of the '//
     &                       'applied magnetic field.'
      Write(6,'(2x,10A)') ('--------', i=1,10)
      If(nsymm.eq.1) Then
        Write(6,'(23x,A)') 'Lebedev-Laikov grid on a hemisphere:'
        Write(6,'(38x,A)') 'z >= 0;'
      Else If(nsymm.eq.2) Then
        Write(6,'(23x,A)') 'Lebedev-Laikov grid on a 4th-of-a-sphere:'
        Write(6,'(34x,A)') 'x >= 0; z >= 0;'
      Else If(nsymm.eq.3) Then
        Write(6,'(23x,A)') 'Lebedev-Laikov grid on a 8th-of-a-sphere:'
        Write(6,'(30x,A)') 'x >= 0; y >= 0; z >= 0;'
      End If
      Write(6,'(2x,10A)') ('--------', i=1,10)
      Write(6,'(2x,A,12x,A,2(18x,A),16x,A)') 'Nr.','x','y','z',
     &                                         'weight'
      Do i=1,nP
        Write(6,'(i4,2x,4(F18.12,1x))')
     &                      i,dHX(i+nDir+nDirZee),dHY(i+nDir+nDirZee),
     &                        dHZ(i+nDir+nDirZee),dHW(i+nDir+nDirZee)
      End Do

      If( nDir>0 ) Then
        Write(6,'(2x,10A)') ('--------', i=1,10)
        Write(6,'(23x,A)') ' Magnetization vector will be computed'
        Write(6,'(2x,10A)') ('--------', i=1,10)
        Write(6,'(2x,A,12x,A,2(18x,A))') 'Nr.','x','y','z'
        Do i=1,nDir
          Write(6,'(i4,2x,4(F18.12,1x))') i, dHX(i), dHY(i), dHZ(i)
        End Do
      End If

      If (zeeman_energy) Then
        Write(6,'(2x,10A)') ('--------', i=1,10)
        Write(6,'(23x,A)') 'Zeeman Energy Splitting will be computed'
        Write(6,'(2x,10A)') ('--------', i=1,10)
        Write(6,'(2x,A,12x,A,2(18x,A))') 'Nr.','x','y','z'
        Do i=1,nDirZee
           j=i+nDir
          Write(6,'(i4,2x,4(F18.12,1x))') j, dHX(j), dHY(j), dHZ(j)
        End Do
      End If

      Write(6,'(2x,10A)') ('--------', i=1,10)
      Write(6,'(2X,A)') 'The cut-off energy for the exact '//
     &                  'diagonalization of the Zeeman Hamiltonian is:'
      Write(6,'(2x,a,F15.9,A)') 'E = ',EM ,' cm(-1).'
      If(NM.lt.10) Then
        Write(6,'(2X,A,i2,a)') 'The exact diagonalization of the '//
     &                         'Zeeman Hamiltonian included ',NM,
     &                         ' exchange states.'
      Else If( (NM.ge.10) .AND. (NM.lt.100) ) Then
        Write(6,'(2X,A,i3,a)') 'The exact diagonalization of the '//
     &                         'Zeeman Hamiltonian included ',NM,
     &                         ' exchange states.'
      Else If( (NM.ge.100) .AND. (NM.lt.1000) ) Then
        Write(6,'(2X,A,i4,a)') 'The exact diagonalization of the '//
     &                         'Zeeman Hamiltonian included ',NM,
     &                         ' exchange states.'
      Else If( (NM.ge.1000) .AND. (NM.lt.10000) ) Then
        Write(6,'(2X,A,i5,a)') 'The exact diagonalization of the '//
     &                         'Zeeman Hamiltonian included ',NM,
     &                         ' exchange states.'
      End If
      If(compute_Mdir_vector) Then
        Write(6,'(2x,A,i2,a)') 'The magnetization vector for ',nDir,
     &                         ' directions of the applied '//
     &                         'magnetic field will be calculated.'
      Else
        Write(6,'(2X,A)') 'The magnetization vector was not calculated.'
      End If
      If(zeeman_energy) Then
        Write(6,'(2x,A,i2,a)') 'The Zeeman splitting for ',nDirZee,
     &                         ' directions of the applied '//
     &                         'magnetic field will be calculated.'
        Write(6,'(2x,a     )') 'The Zeeman energies for each '//
     &                         'direction of the applied magnetic '//
     &                         'field are written in files '//
     &                         '"zeeman_energy_xxx.txt".'
      Else
        Write(6,'(2X,A)') 'Computation of the Zeeman splitting was '//
     &                    'not requested.'
      End If
!      smagn=.false.
!      m_paranoid=.true.
!      THRS=1.d-10 !threshold for convergence of average spin, in case (zJ .ne. 0)
C /// opening the loop over the field points
      Do iH=1,nH
c /// ---------------------------------------------------------------
        If (HINPUT) Then
           H(iH)=HEXP(iH)
           If(H(iH).eq.0.0_wp) Then
             H(iH)=0.0001_wp
           End If
        Else
          DLTH=(HMAX-HMIN)/DBLE(NH-1)
          If (iH.eq.1) Then
            H(IH)=HMIN+0.0001_wp
          Else
            H(IH)=HMIN+DLTH*DBLE(IH-1)
          End If
          If(H(iH).eq.0.0_wp) Then
            H(iH)=0.0001_wp
          End If
        End If

         !    If(DBG)
         If(DBG) Write(6,'(A,i0,A,F10.5,A,L2,A,L2)')
     &          'MAGNETIZATION::  H(',iH,') = ', H(iH),
     &          'smagn=',smagn,' m_paranoid=',m_paranoid

c ///  opening the loop over dIfferent directions of the magnetic field
        Do iM=1,NDIRTOT
          MT(1:3,iH,1:nTempMagn)=0.0_wp
          ST(1:3,iH,1:nTempMagn)=0.0_wp
          Call dcopy_(nM,[0.0_wp],0,WM,1)
c         Entry into monitor: Status line
          WRITE(STLNE1,'(A)') 'SINGLE_ANISO:  powder magnetization:'
          WRITE(STLNE2,'(A,I4,A,I4,A,I4,A,I4)')
     &    ' Field: ',IH,' from ',nH,' at direction ',IM,' from ',NDIRTOT
          Call StatusLine( trim(STLNE1), trim(STLNE2) )
c  actual calculation of the MT and ST, ZT
          Call MAGN( NSS, NM, dHX(iM),dHY(iM),dHZ(iM),H(iH),
     &               ESO, zJ, THRS,
     &               DIPM,
     &                 SM,
     &               nTempMagn,TempMagn,smagn,
     &               WM,
     &               ZT(iH,1:nTempMagn),
     &               ST(1:3,iH,1:nTempMagn),
     &               MT(1:3,iH,1:nTempMagn), m_paranoid, DBG )
          If (DBG .and. (iH.eq.nH) .and. (iM.eq.23)) Then
            Write(6,'(A,3ES16.8)') 'iM:',dHX(iM),dHY(iM),dHZ(iM)
            Write(6,'(2(A,3ES16.8,1x),A,ES16.8)')
     &                                'MT:',(MT(l,iH,1),l=1,3),
     &                                'ST:',(ST(l,iH,1),l=1,3),
     &                             'ZSTAT:',ZT(iH,1)
            Write(6,'(A,3ES16.8)') 'WM:',(WM(l),l=1,nM)
          End If
C  ---------------------------------------------------------------------
          If (zeeman_energy) Then
             If((iH.eq.1).and.(iM.eq.nDir+1))
     &         Write(6,'(A)') 'Energies of the Zeeman Hamiltonian '//
     &                        'for the following directions of the '//
     &                        'applied field:'
             If ( (iH.eq.1).and.(iM.gt.nDir) .and.
     &                          (iM.le.(nDir+nDirZee)) ) Then
               Write(6,'(A,I3,A,3F10.6,3x,5A)')
     &                 'direction Nr.',iM-nDir, ' : ',
     &                  dHX(iM), dHY(iM), dHZ(iM),
     &                 'written in file "zeeman_energy_',
     &                  CHAR(48+mod(int((iM-nDir)/100),10)),
     &                  CHAR(48+mod(int((iM-nDir)/10 ),10)),
     &                  CHAR(48+mod(    (iM-nDir)     ,10)),
     &                  '.txt".'

               Write(LUZee(iM-nDir),'(A,3F24.15)')
     &                  '# direction of the applied magnetic field:',
     &                  dHX(iM), dHY(iM), dHZ(iM)
               Write(LUZee(iM-nDir),'(A,6x,A,1000(I4,6x) )') '# H(T)',
     &                  ' State =>',(i,i=1,nm)
             End If

             If ( (iM.gt.nDir) .and. (iM.le.(nDir+nDirZee)) ) Then
               Write(LUZee(iM-nDir),'(F8.4,1000F10.3)')
     &                               H(IH),(WM(I),I=1,NM)
             End If
          End If !zeeman_energy
C  ---------------------------------------------------------------------
!         computing the AVERAGE MOMENTS calculated at different temperatures
!         (TempMagn(i))
          Do iT=1,nTempMagn
            Do ic=1,3
              MVEC(iM,iH,iT,ic)=MT(ic,iH,iT)
              SVEC(iM,iH,iT,ic)=ST(ic,iH,iT)
            End Do  ! ic

            If(iM.gt.nDir+nDirZee) Then
c              MAV(iH,iTemp) = MAV(iH,iTemp)+MT(1,iH,iT)*dHX(iM)*dHW(iM)
c     &                                     +MT(2,iH,iT)*dHY(iM)*dHW(iM)
c     &                                     +MT(3,iH,iT)*dHZ(iM)*dHW(iM)
c
c              SAV(iH,iTemp) = SAV(iH,iTemp)+ST(1,iH,iT)*dHX(iM)*dHW(iM)
c     &                                     +ST(2,iH,iT)*dHY(iM)*dHW(iM)
c     &                                     +ST(3,iH,iT)*dHZ(iM)*dHW(iM)
              ! accumulate contributions:
              Call daxpy_(1,dHX(iM)*dHW(iM),MT(1,iH,iT),1,MAV(iH,iT),1)
              Call daxpy_(1,dHY(iM)*dHW(iM),MT(2,iH,iT),1,MAV(iH,iT),1)
              Call daxpy_(1,dHZ(iM)*dHW(iM),MT(3,iH,iT),1,MAV(iH,iT),1)
              Call daxpy_(1,dHX(iM)*dHW(iM),ST(1,iH,iT),1,SAV(iH,iT),1)
              Call daxpy_(1,dHY(iM)*dHW(iM),ST(2,iH,iT),1,SAV(iH,iT),1)
              Call daxpy_(1,dHZ(iM)*dHW(iM),ST(3,iH,iT),1,SAV(iH,iT),1)
            End If
            If (iprint > 2) Then
               If((iM==1).AND.(iH==1))
     &            Write(6,'(2x,A,1x,A,4x,A,7x,A,7x,A)')
     &                  'iH','iM','iT',
     &                  'moment(iM,iT)',
     &                  'spin(iM,iT)'
                  Write(6,'(3i4,3(F21.15,1x))')
     &                   iH,iM,iT,
     &                (  MT(1,iH,iT)*dHX(iM)
     &                 + MT(2,iH,iT)*dHY(iM)
     &                 + MT(3,iH,iT)*dHZ(iM) ),

     &                (  ST(1,iH,iT)*dHX(iM)
     &                 + ST(2,iH,iT)*dHY(iM)
     &                 + ST(3,iH,iT)*dHZ(iM) )
            End If
          End Do !iT
C  ---------------------------------------------------------------------
c ///  closing the loop over directions of magnetic field
        End Do   !  iM
c /// -------------------------------------------------------------------
c ///  closing the loop over the points of magnetic field:
      End Do ! IH
c /// -------------------------------------------------------------------
c Close Zeeman files, if opened
      If (Zeeman_Energy) Then
        Do i=1,nDirZee
          Close( LUZee(i) )
        End Do
      End If

c /// -------------------------------------------------------------------
      If(nDir .gt. 0) Then

      If (smagn) Then
        Do iT=1,nTempMagn
          Write(6,*)
          Do iDir=1,nDir
            Write(6,*)
            Write(6,'(A,A,1x,A)') '--------|',
     &                            '------------------------------'//
     &                            '------------------------------|',
     &                            '|------------------------------'//
     &                            '------------------------------|'
            Write(6,'(A,i3,26x,A,1x,A,60x,A)')
     &                   'Direction of the applied magnetic field:',
     &                    iDir,'|','|','|'
            Write(6,'(A,F18.14,44x,A,1x,A,60x,A)')
     &                   'proj X=',dHX(iDIR),'|','|','|'
            Write(6,'(A,F18.14,44x,A,1x,A,60x,A)')
     &                   'proj Y=',dHY(iDir),'|','|','|'
            Write(6,'(A,F18.14,44x,A,1x,A,60x,A)')
     &                   'proj Z=',dHZ(iDir),'|','|','|'
            Write(6,'(A,F7.4,A,41x,A,1x,A,60x,A)')
     &                   'Temperature = ',TempMagn(iT),
     &                   ' Kelvin','|','|','|'
            Write(6,'(A,A,1x,A)') '--------|',
     &                            '------------------------------'//
     &                            '------------------------------|',
     &                            '|------------------------------'//
     &                            '------------------------------|'
            Write(6,'(2x,A,12x,2A,1x,A,10x,2A)') 'Field |',
     &                   'Magnetization Vector            |',
     &                   '   Total Magn. |','|',
     &                   'Spin Magnetization Vector         |',
     &                   '   Total Magn. |'
            Write(6,'(5A,1x,5A)') '--------|',
     &                   '--- proj X ---|','--- proj Y ---|',
     &                   '--- proj Z ---|','- in this dir.-|',
     &                   '|--- proj X ---|','--- proj Y ---|',
     &                   '--- proj Z ---|','- in this dir.-|'
            Do iH=1,nH
              mv=0.0_wp
              sv=0.0_wp
              mv = MVEC(iDir,iH,iT,1)*dHX(iDir)
     &           + MVEC(iDir,iH,iT,2)*dHY(iDir)
     &           + MVEC(iDir,iH,iT,3)*dHZ(iDir)
              sv = SVEC(iDir,iH,iT,1)*dHX(iDir)
     &           + SVEC(iDir,iH,iT,2)*dHY(iDir)
     &           + SVEC(iDir,iH,iT,3)*dHZ(iDir)

              Write(6,'(F7.3,1x,A, 3(E13.6,1x,A),E14.7,1x,A,1x,A, '//
     &                            '3(E13.6,1x,A),E14.7,1x,A)')
     &                   H(iH),'|', MVEC(iDir,iH,iT,1),' ',
     &                              MVEC(iDir,iH,iT,2),' ',
     &                              MVEC(iDir,iH,iT,3),'|', mv,'|','|',
     &                              SVEC(iDir,iH,iT,1),' ',
     &                              SVEC(iDir,iH,iT,2),' ',
     &                              SVEC(iDir,iH,iT,3),'|', sv,'|'
            End Do
            Write(6,'(A,A,1x,A)') '--------|',
     &                            '------------------------------'//
     &                            '------------------------------|',
     &                            '|------------------------------'//
     &                            '------------------------------|'
          End Do !iDir
        End Do !iT

      Else
      ! smagn == .false.

        Do iT=1,nTempMagn
          Write(6,*)
          Do iDir=1,nDir
            Write(6,*)
            Write(6,'(2A)') '--------|',
     &                      '------------------------------'//
     &                      '------------------------------|'
            Write(6,'(A,i3,26x,A)')
     &                      'Direction of the applied magnetic field:',
     &                       iDir,'|'
            Write(6,'(A,F18.14,44x,A)') 'proj X=',dHX(iDIR),'|'
            Write(6,'(A,F18.14,44x,A)') 'proj Y=',dHY(iDir),'|'
            Write(6,'(A,F18.14,44x,A)') 'proj Z=',dHZ(iDir),'|'
            Write(6,'(A,F7.4,A,41x,A)') 'Temperature = ',TempMagn(iT),
     &                                  ' Kelvin','|'
            Write(6,'(2A)') '--------|',
     &                      '------------------------------'//
     &                      '------------------------------|'
            Write(6,'(2x,A,12x,2A)') 'Field |',
     &                      'Magnetization Vector            |',
     &                      '   Total Magn. |'
            Write(6,'(5A)') '--------|',
     &                      '--- proj X ---|','--- proj Y ---|',
     &                      '--- proj Z ---|','- in this dir.-|'
            Do iH=1,nH
              mv=0.0_wp
              mv = MVEC(iDir,iH,iT,1)*dHX(iDir)
     &           + MVEC(iDir,iH,iT,2)*dHY(iDir)
     &           + MVEC(iDir,iH,iT,3)*dHZ(iDir)
              Write(6,'(F7.3,1x,A,3(E13.6,1x,A),E14.7,1x,A)') H(iH),'|',
     &                MVEC(iDir,iH,iT,1),' ',
     &                MVEC(iDir,iH,iT,2),' ',
     &                MVEC(iDir,iH,iT,3),'|', mv,'|'
            End Do
            Write(6,'(2A)') '--------|',
     &                      '------------------------------'//
     &                      '------------------------------|'
          End Do !iDir
        End Do !iT
        End If !(smagn)
      End If !(nDir>0)
c /// -------------------------------------------------------------------
c     COMPUTING THE STANDARD DEVIATION OF THE MAGNETIZATION
      If(HINPUT) Then
        Do iT=1,nTempMagn
          STDEV(iT) = 0.0_wp
          STDEV(iT) = dev(nH,MAV(:,iT),magn_exp(:,iT))
        End Do
      End If
c /// -------------------------------------------------------------------

      Write(6,*)
      Write(6,'(25X,A)') 'HIGH-FIELD POWDER MAGNETIZATION'
      Write(6,'(30X,A)') '(Units: Bohr magneton)'
      Write(6,*)
      Do iT=1,nTempMagn,5
        iTEnd=min(nTempMagn,iT+4)

        Write(6,'(A,11A)') '-----------|',
     &                    ('---------------|',i=iT,iTEnd+1)
        Write(6,'(A,10(F10.3,A))') '   H(T)    |STATISTICAL SUM|',
     &                    (TempMagn(i),' K.  |',i=iT,iTEnd)
        Write(6,'(A,11A)') '-----------|',
     &                    ('---------------|',i=iT,iTEnd+1)

        Do iH=1,nH
          Write(6,'(F10.6,1X,A,F14.7,1x,A,11(f14.10,1x,A))')
     &          H(iH),'|',ZT(iH,1),'|', (MAV(iH,i),'|',i=iT,iTEnd)
        End Do

        Write(6,'(A,11A)') '-----------|',
     &                    ('---------------|',i=iT,iTEnd+1)
        If(HINPUT) Then
          Write(6,'(A,15x,11(f14.10,1x,A) )')
     &                       'ST.DEV.M   |',
     &                      ( STDEV(i),'|',i=1,nTempMagn)
          Write(6,'(A,11A)') '-----------|',
     &                      ('---------------|',i=iT,iTEnd+1)
        End If
      End Do


      If(smagn) Then
         Write(6,*)
         Write(6,'(15X,A)') 'HIGH-FIELD POWDER SPIN MAGNETIZATION'
         Write(6,'(20X,A)') '(Units: Bohr magneton)'
         Write(6,*)
         Do iT=1,nTempMagn,5
           iTEnd=min(nTempMagn,iT+4)
           Write(6,'(A,11A)') '---------|',('---------------|',i=iT,
     &                                                        iTEnd+1)
           Write(6,'(A,11(F10.3,A))') '   H(T)  |STATISTICAL SUM|',
     &                               (TempMagn(i),' K.  |',i=iT,iTEnd)
           Write(6,'(A,11A)') '---------|',('---------------|',i=iT,
     &                                                        iTEnd+1)
           Do iH=1,nH
            Write(6,'(F10.6,1X,A,F14.7,1x,A,11(f14.10,1x,A))')
     &              H(iH),'|',ZT(iH,1),'|', (SAV(iH,i),'|',i=iT,iTEnd)
           End Do
           Write(6,'(A,11A)') '---------|',('---------------|',i=iT,
     &                                                        iTEnd+1)
         End Do
      End If!smagn


      If(DoPlot) Then
        IF ( hinput ) THEN
           Call plot_MH_with_Exp( nH, H, nTempMagn, TempMagn, MAV,
     &                            magn_exp, zJ )
        ELSE
           Call plot_MH_no_Exp( nH, H, nTempMagn, TempMagn, MAV, zJ )
        END IF
!        IF ( zeeman_energy ) THEN
!           Call plot_zeeman( nH, nM, nDirZee, H, LuZee )
!        END IF
      End If


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      Call Add_Info('MAGN_AVERAGED',MAV(1:nH,1:nTempMagn),
     &               nH*nTempMagn,5)
      If(compute_Mdir_vector) Then
        Call Add_Info('MAGN_VECT_X(2)     ',MVEC(1, 2,1,1),1,4)
        Call Add_Info('MAGN_VECT_X(nH/2)  ',
     &                     MVEC(1,(NH-1)/2,1,1),1,4)
        Call Add_Info('MAGN_VECT_X(nH)    ',MVEC(1,NH,1,1),1,4)
        Call Add_Info('MAGN_VECT_Y(2)     ',MVEC(1, 2,1,2),1,4)
        Call Add_Info('MAGN_VECT_Y(nH/2)  ',
     &                     MVEC(1,(NH-1)/2,1,2),1,4)
        Call Add_Info('MAGN_VECT_Y(nH)    ',MVEC(1,NH,1,2),1,4)
        Call Add_Info('MAGN_VECT_Z(2)     ',MVEC(1, 2,1,3),1,4)
        Call Add_Info('MAGN_VECT_Z(nH/2)  ',
     &                     MVEC(1,(NH-1)/2,1,3),1,4)
        Call Add_Info('MAGN_VECT_Z(nH)    ',MVEC(1,NH,1,3),1,4)
      End If


!-----------------------------------------------------------------------
! Deallocate necessary memory
      Call mma_deallocate(WM)
      Call mma_deallocate(MT)
      Call mma_deallocate(ST)
      Call mma_deallocate(MAV)
      Call mma_deallocate(SAV)
      Call mma_deallocate(ZT)
      Call mma_deallocate(MVEC)
      Call mma_deallocate(SVEC)
      Call mma_deallocate(H)
      Call mma_deallocate(STDEV)
      Call mma_deallocate(dHX)
      Call mma_deallocate(dHY)
      Call mma_deallocate(dHZ)
      Call mma_deallocate(dHW)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine GetQaaFock(FOccMO,P2MOt,GDMat,zX,nP2)

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: nDens, nNA
use input_mclr, only: nRoots, ntAsh, ntBas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nP2
real(kind=wp), intent(inout) :: FOccMO(nDens), P2MOt(nP2)
real(kind=wp), intent(in) :: GDMat(nTri_Elem(nRoots),nnA,nnA), zX(nTri_Elem(nRoots-1))
integer(kind=iwp) :: IKK, IKL, IKL2, ILL, K, L, nG1, nG1r, nG2, nG2r, NPUVX
logical(kind=iwp) :: debug2
integer(kind=iwp), allocatable :: IndPUVX(:,:,:,:), IndTUVX(:,:,:,:)
real(kind=wp), allocatable :: Fock(:), G1r(:), G2q(:), G2r(:), PQaa(:), PUVX(:), T(:)

!                                                                      *
!***********************************************************************
!                                                                      *
ng1 = nTri_Elem(ntash)
ng2 = nTri_Elem(ng1)

nG1r = ntash**2
nG2r = nTri_Elem(nG1r)
call mma_allocate(Fock,nDens)
call mma_allocate(T,nDens)
call mma_allocate(G1r,nG1r)
call mma_allocate(G2r,nG2r)
call mma_allocate(G2q,ng2)
call mma_allocate(PQaa,ng2)
Debug2 = .false.
PQaa(1:nP2) = Zero
G1r(:) = Zero
G2r(:) = Zero

!*****************

if (Debug2) then
  call Get_PUVXLen(NPUVX)
  call mma_allocate(PUVX,NPUVX)
  call mma_allocate(IndTUVX,ntAsh,ntAsh,ntAsh,ntAsh)
  call mma_allocate(IndPUVX,ntBas,ntAsh,ntAsh,ntAsh)
  call Get_Two_Ind(IndPUVX,IndTUVX)
end if

do K=1,nRoots
  IKK = nTri_Elem(K)
  do L=1,K-1
    ILL = nTri_Elem(L)
    IKL = iTri(K,L)
    IKL2 = nTri_Elem(K-2)+L
    call QaaP2MO(G2q,ng2,GDMat,IKL,IKK,ILL)
    if (Debug2) call QaaVerif(G2q,ng2,PUVX,NPUVX,IndTUVX)
    call G2qtoG2r(G2r,G2q,nG2,nG2r)
    PQaa(:) = PQaa(:)+zX(IKL2)*G2q(:)
  end do
end do

P2MOt(1:nG2) = P2MOt(1:nG2)+PQaa(:)
call Put_dArray('P2MOt',P2MOt,nG2)

call G2qtoG2r(G2r,PQaa,nG2,nG2r)
call FockGen(Zero,G1r,G2r,T,Fock,1)
FOccMO(:) = FOccMO(:)+T(:)
if (Debug2) then
  call mma_deallocate(PUVX)
  call mma_deallocate(IndTUVX)
  call mma_deallocate(IndPUVX)
end if
call mma_deallocate(Fock)
call mma_deallocate(T)
call mma_deallocate(G1r)
call mma_deallocate(G2r)
call mma_deallocate(G2q)
call mma_deallocate(PQaa)

end subroutine GetQaaFock

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Knemem_mck( &
#                     define _CALLING_
#                     include "mem_interface.fh"
                     )

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"

#include "macros.fh"
unused_var(lr)

nHer = ((la+1)+(lb+1)+2+1)/2
Mem = 3*nHer*(la+3)+3*nHer*(lb+3)+3*nHer+3*(la+3)*(lb+3)+3*(la+2)*(lb+2)+1+1+nTri_Elem1(la)*nTri_Elem1(lb)*3

return

end subroutine Knemem_mck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ddV(Cart,mTtAtm,Hess,iANr,iTabBonds,iTabAtoms,nBonds,nMax,nHidden)

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: VarR, VarT
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: mTtAtm, nHidden, iANr(mTtAtm+nHidden), nBonds, iTabBonds(3,nBonds), nMax, &
                                 iTabAtoms(2,0:nMax,mTtAtm+nHidden)
real(kind=wp), intent(in) :: Cart(3,mTtAtm+nHidden)
real(kind=wp), intent(out) :: Hess(nTri_Elem(3*mTtAtm))
integer(kind=iwp) :: nTot
logical(kind=iwp) :: VRSave, VTSave
real(kind=wp), allocatable :: HBig(:)

! Temporary big hessian
!                                                                      *
!***********************************************************************
!                                                                      *
if (nHidden > 0) then
  nTot = mTtAtm+nHidden
  call mma_allocate(HBig,nTri_Elem(3*nTot),Label='HBig')

  ! Temporary turn on the translational/rotational invariance

  VRSave = VarR
  VTSave = VarT
  VarR = .false.
  VarT = .false.
  call ddV_(Cart,nTot,HBig,iANr,iTabBonds,iTabAtoms,nBonds,nMax,nHidden)
  VarR = VRSave
  VarT = VTSave
  Hess(:) = HBig(1:nTri_Elem(3*mTtAtm))
# ifdef _DEBUGPRINT_
  write(u6,*) 'DDV: Improved Hessian'
  call RecPrt('Coord (with hidden atoms):',' ',Cart,3,nTot)
  call TriPrt('Hessian (hidden atoms):',' ',HBig,3*nTot)
  call TriPrt('Hessian (normal):',' ',Hess,3*mTtAtm)
# endif
  call mma_deallocate(HBig)
else
  call ddV_(Cart,mTtAtm,Hess,iANr,iTabBonds,iTabAtoms,nBonds,nMax,nHidden)
end if

end subroutine ddV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ConInt(xyz,nCent,dE,Bf,lWrite_,lWarn,Label,dBf,ldB,
     &                  lIter)
      Implicit Real*8  (a-h,o-z)
#include "info_slapaf.fh"
#include "real.fh"
#include "nadc.fh"
#include "WrkSpc.fh"
#include "constants.fh"
      Real*8   Bf(3,nCent), xyz(3,nCent), dBf(3*nCent,3*nCent)
      Logical lWrite_, ldB, lWarn
      Character*8 Label
*
*
      E1 = Work(ipEner +lIter-1)
      E0 = Work(ipEner0+lIter-1)
*
c     iOpt=1 -> Linear
c     iOpt=2 -> Quadratic
c     iOpt=3 -> Absolute value
      If (NADC) Then
         If (ApproxNADC) Then
            iOpt=2
         Else
            iOpt=3
         End If
      Else
         iOpt=1
      End If
*
*     Observe that the program is storing the forces rather than the
*     gradients!
*
*     For a true conical intersection the storage is done a bit
*     differently (see init2.f). Here the average energy is stored
*     in E1 and the energy difference in E0. Ditto for the gradients.
*
      dE=Zero
      If (iOpt.eq.1) Then
C------- Linear ------------------
         If (NADC) Then
            dE=E0
         Else
            dE=E1-E0
         End If
      Else If (iOpt.eq.2) Then
C------- Quadratic ---------------
         If (NADC) Then
            dE=E0**2
         Else
            dE=(E1-E0)**2
         End If
      Else If (iOpt.eq.3) Then
C------- Absolute value ----------
         If (NADC) Then
            dE=Abs(E0)
         Else
            dE=Abs(E1-E0)
         End IF
      End If
      If (lWrite_) Then
         If (NADC) Then
            Write (6,'(2A,F18.8,A,F18.8,A)')
     &                    Label,' : Energy difference = ',
     &                    E0, ' hartree, ',
     &                    E0*CONV_AU_TO_KJ_PER_MOLE_,
     &                    ' kJ/mol'
            Write (6,'( A,F18.8,A)') '           Average energy    = ',
     &                               E1   , ' hartree'
         Else
            Write (6,'(2A,F18.8,A,F18.8,A)')
     &                    Label,' : Energy difference = ',
     &                    E1-E0, ' hartree, ',
     &                    (E1-E0)*CONV_AU_TO_KJ_PER_MOLE_,
     &                    ' kJ/mol'
            Write (6,'( A,F18.8,A)') '           E(i)              = ',
     &                               E1   , ' hartree'
            Write (6,'( A,F18.8,A)') '           E(j)              = ',
     &                               E0   , ' hartree'
         End If
      End If
*
*---- Compute the WDC B-matrix
*
      iOff = 0
      ipGrad1=(lIter-1)*3*nsAtom + ipGx
      ipGrad0=(lIter-1)*3*nsAtom + ipGx0
C     Call RecPrt('Grad1',' ',Work(ipGrad1),3,nCent)
C     Call RecPrt('Grad0',' ',Work(ipGrad0),3,nCent)
      Do iCent = 1, nCent
         Fact=DBLE(iDeg(xyz(1,iCent)))
C        Write (6,*) 'Fact=',Fact
         Do iCar = 1, 3
            Bf(iCar,iCent)=Zero
            If (iOpt.eq.1) Then
C------------- Linear ------------------
               If (NADC) Then
                  Bf(iCar,iCent)=-Work(ipGrad0+iOff)
               Else
                  Bf(iCar,iCent)=-(Work(ipGrad1+iOff)
     &                            -Work(ipGrad0+iOff))
               End If
            Else If (iOpt.eq.2) Then
C------------- Quadratic ---------------
*
*              When the energy difference becomes small, the true derivative vanishes.
*              In such case use simply a scaled-down energy difference gradient
*
               If (NADC) Then
                  If (Abs(E0).gt.1.0D-5) Then
                     Bf(iCar,iCent)=-Two*E0
     &                             *Work(ipGrad0+iOff)
                  Else
                     Bf(iCar,iCent)=-Two*1.0D-5
     &                             *Work(ipGrad0+iOff)
                  End If
               Else
                  If (Abs(E1-E0).gt.1.0D-5) Then
                     Bf(iCar,iCent)=-Two*(E1-E0)
     &                             *(Work(ipGrad1+iOff)
     &                              -Work(ipGrad0+iOff))
                  Else
                     Bf(iCar,iCent)=-Two*1.0D-5
     &                             *(Work(ipGrad1+iOff)
     &                              -Work(ipGrad0+iOff))
                  End If
               End If
            Else If (iOpt.eq.3) Then
C------------- Absolute value ----------
               If (NADC) Then
                  Bf(iCar,iCent)=-Sign(One,E0)*(Work(ipGrad0+iOff))
               Else
                  Bf(iCar,iCent)=-Sign(One,E1-E0)
     &                          *(Work(ipGrad1+iOff)
     &                           -Work(ipGrad0+iOff))
               End If
            End If
*
            Bf(iCar,iCent)=Fact*Bf(iCar,iCent)
            iOff = iOff+1
         End Do
      End Do
*     Call RecPrt('Bf',' ',Bf,3,nCent)
      If (lWrite_.and.iOpt.eq.1) Then
         XX=Sqrt(DDot_(3*nCent,Bf,1,Bf,1))
         If (XX.le.1.0D-3) Then
            Write (6,*)
            Write (6,*)
     &            '    Warning: PESs might be parallel!'
            Write (6,*)
         End If
      End If
*
*---- Compute the cartesian derivative of the B-Matrix.
*
      If (ldB) Then
         nGrad=3*nCent
         If (iOpt.eq.1) Then
C---------- Linear ------------------
            Call FZero(dBf,(3*nCent)**2)
         Else If (iOpt.eq.2) Then
C---------- Quadratic ---------------
            Call FZero(dBf,(3*nCent)**2)
            Do ix = 0, nGrad-1
               Do iy = 0, nGrad-1
                  If (NADC) Then
                     dBf(1+ix,1+iy)=-Two*
     &                               Work(ipGrad0+ix)
     &                             * Work(ipGrad0+iy)
                  Else
                     dBf(1+ix,1+iy)=-Two*
     &                              (Work(ipGrad1+ix)-
     &                               Work(ipGrad0+ix))
     &                             *(Work(ipGrad1+iy)-
     &                               Work(ipGrad0+iy))
                  End If
               End Do
            End Do
         Else If (iOpt.eq.3) Then
C------------- Absolute value ----------
            Call FZero(dBf,(3*nCent)**2)
*
         End If
*        Call RecPrt('dBf','(9F9.1)',dBf,3*nCent,3*nCent)
*
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(lWarn)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 01, 2022, created this file.               *
! ****************************************************************

Module CMS
logical CMSNotConverged
Logical CMSGiveOpt
Real*8  CMSThres
Real*8,DIMENSION(:),Allocatable:: RGD
INTEGER iCMSOpt
Logical PosHess,BigQaaGrad,NeedMoreStep
INTEGER nPosHess,nCMSScale
Real*8  LargestQaaGrad
CHARACTER*128 cmsguessfile
End Module CMS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine MKBNEV()

use Index_Functions, only: nTri_Elem
use caspt2_global, only: iPrGlb, LUSBT, LUSOLV
use caspt2_module, only: NASHT_ => NASHT, NASUP, NG1, NG2, NG3, NINDEP, NSYM
use PrintLevel, only: debug, verbose
use EQSOLV, only: IDBMAT, IDSMAT
use sguga, only: SGS
use SC_NEVPT2, only: Do_SC, ECORR_SC, IDBMAT_NEVPT2, OVLAPS_SC
use NEVPT2_mod, only: NASHT
#ifdef _MOLCAS_MPP_
use NEVPT2_E4, only: MAXBUF
use caspt2_module, only: MXCI
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, byte

implicit none
integer(kind=iwp) :: ICASE, IDISK, iLUID, ISYM, NLEV, NTRI
real(kind=wp) :: cpe, cptf0, cptf10, cput, DUM(1), tioe, tiotf0, tiotf10, wallt
integer(kind=byte), allocatable :: idxG3(:,:)
real(kind=wp), allocatable :: G1(:,:), G2(:,:,:,:), G3(:), Gact(:,:,:,:), Hact(:,:), Hbar(:,:), Htilde(:,:), WRK(:)

if (IPRGLB >= VERBOSE) then
  write(u6,*)
  write(u6,*) ' Construct B matrices'
end if

! It seems G2 is not a standard normal-ordered RDM.
! G2(standard)(a,b,c,d) = G2(MOLCAS)(a,c,b,d)
! That is, in MOLCAS, G2(a,b,c,d) = <0|a+ c+ d b|0> = D(ac,bd)
! G3(standard)(tuvxyz) = G3(MOLCAS)(txu,yvz)
! G3(t,u,v,x,y,z) = <0|t+ v+ y+ z x u|0> -> G3(standard)(tvyuxz)

nAshT = nAshT_ ! define the number of the active orbitals used in NEVPT2_MOD
#ifdef _MOLCAS_MPP_
MAXBUF = 2000000000/(MXCI*8)
#endif

if (nAshT /= 0) then
  call mma_allocate(Hact,nAshT,nAshT,Label='Hact')
  call mma_allocate(Gact,nAshT,nAshT,nAshT,nAshT,Label='Gact')
  call mma_allocate(Hbar,nAshT,nAshT,Label='Hbar')
  call mma_allocate(Htilde,nAshT,nAshT,Label='Htilde')
  ! Construct the active part of the integrals
  call nevint(nAshT,Hact,Gact,Hbar,Htilde)

  !check_eigen = .true.
  !if (check_eigen) call check_eigenfunction(nAshT,Hact,Gact)

  call mma_allocate(G1,nAshT,nAshT,Label='G1')
  call mma_allocate(G2,nAshT,nAshT,nAshT,nAshT,Label='G2')
  call mma_allocate(G3,NG3,Label='G3')
  call mma_allocate(idxG3,6,NG3,label='idxG3')
  call PT2_GET(NG1,' GAMMA1',G1)
  call PT2_GET(NG2,' GAMMA2',G2)
  call PT2_GET(NG3,' GAMMA3',G3)
  iLUID = 0
  call I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)

  if (IPRGLB >= DEBUG) then
    write(u6,'("DEBUG> ",A)') 'case SYM B-MATRIX NORM'
    write(u6,'("DEBUG> ",A)') '==== === ============='
  end if

  if (IPRGLB >= verbose) call TIMING(CPTF0,CPE,TIOTF0,TIOE)
  call MKBNEVG(nAshT,Hact,Gact,G1,G2)
  call MKBNEVE(nAshT,Hact,Gact,G1,G2)

  call MKBNEVF(nAshT,NG3,Hbar,Gact,G2,G3,idxG3)
  call MKBNEVB(nAshT,NG3,Hbar,Gact,G1,G2,G3,idxG3)

  call MKBNEVD(nAshT,NG3,Hbar,Gact,G1,G2,G3,idxG3)
  call GASync()

  if (IPRGLB >= verbose) then
    call TIMING(CPTF10,CPE,TIOTF10,TIOE)
    CPUT = CPTF10-CPTF0
    WALLT = TIOTF10-TIOTF0
    write(u6,'(a,2f10.3)') ' MKBNEV1 : CPU/WALL TIME=',cput,wallt
    call TIMING(CPTF0,CPE,TIOTF0,TIOE)
  end if

  ! I did not come up with a good parallel strategy for the A and C subspaces

  call MKBNEVAC_E3(nAshT,NG3,Hact,Htilde,Gact,G1,G2,G3,idxG3)
  call GASync()

  if (IPRGLB >= verbose) then
    call TIMING(CPTF10,CPE,TIOTF10,TIOE)
    CPUT = CPTF10-CPTF0
    WALLT = TIOTF10-TIOTF0
    write(u6,'(a,2f10.3)') ' MKBNEV2 : CPU/WALL TIME=',cput,wallt
    call TIMING(CPTF0,CPE,TIOTF0,TIOE)
  end if

  call mma_deallocate(Hact)
  call mma_deallocate(Hbar)
  call mma_deallocate(Htilde)
  call mma_deallocate(G1)
  call mma_deallocate(G2)
  call mma_deallocate(G3)
  call mma_deallocate(idxG3)

  nLev = SGS%nLev
  call MKBNEVAC_E4(nAshT,NLEV,Gact)

  if (IPRGLB >= verbose) then
    call TIMING(CPTF10,CPE,TIOTF10,TIOE)
    CPUT = CPTF10-CPTF0
    WALLT = TIOTF10-TIOTF0
    write(u6,'(a,2f10.3)') ' MKBNEV3 : CPU/WALL TIME=',cput,wallt
  end if

  call mma_deallocate(Gact)
end if

! For completeness, even case H has formally S and B
! matrices. This costs nothing, and saves conditional
! looping, etc in the rest  of the routines.
DUM(1) = Zero
do ISYM=1,NSYM
  do ICASE=12,13
    if (NINDEP(ISYM,ICASE) > 0) then
      IDISK = IDSMAT(ISYM,ICASE)
      call DDAFILE(LUSBT,1,DUM,1,IDISK)
      IDISK = IDBMAT(ISYM,ICASE)
      call DDAFILE(LUSBT,1,DUM,1,IDISK)
    end if
  end do
end do

! Copy the original B matrix
if (Do_SC) then
  ECORR_SC(:,:) = Zero
  OVLAPS_SC(:,:) = Zero
  do iSym=1,nSym
    do iCase=1,11
      if ((iCase == 1) .or. (iCase == 4)) cycle ! done in MKBNEVA_E3 and E4
      if (NINDEP(iSym,iCase) > 0) then
        NTRI = nTri_Elem(NASUP(iSym,iCase))
        call mma_allocate(WRK,NTRI,Label='WRK')
        idisk = IDBMAT(iSym,iCase)
        call DDAFILE(LUSBT,2,WRK,NTRI,IDISK)
        idisk = IDBMAT_NEVPT2(iSym,iCase,1)
        call DDAFILE(LUSBT,1,WRK,NTRI,IDISK)
        call mma_deallocate(WRK)
      end if
    end do
  end do
end if

end subroutine MKBNEV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function RPA_iUHF()

use RPA_globals, only: Reference
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: RPA_iUHF
integer(kind=iwp) :: iUHF

if (Reference(1:1) == 'R') then
  iUHF = 1
else if (Reference(1:1) == 'U') then
  iUHF = 2
else
  write(u6,'(A,A)') 'Reference=',Reference
  call RPA_Warn(3,'Unable to determine iUHF in RPA')
  iUHF = -1
end if
RPA_iUHF = iUHF

end function RPA_iUHF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
      Subroutine Mk_RI_Shells(LuRd)
************************************************************************
*                                                                      *
*    Objective: To expand the data for the auxiliary functions         *
*                                                                      *
* Called from: RdCtl                                                   *
*                                                                      *
* Calling    : GetBS                                                   *
*                                                                      *
*     Author: Roland Lindh                                             *
*                                                                      *
************************************************************************
      use Basis_Info
      use Sizes_of_Seward, only: S
      use RICD_Info, only: iRI_Type
      use Logical_Info, only: UnNorm
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "stdalloc.fh"
#include "WrkSpc.fh"
#include "real.fh"
#include "print.fh"
      Logical Hit, IfTest
      Character*13 DefNm
      Character*80 Ref(2), BSLbl, BSLB*180
      Character*80 atom,type,author,basis,CGTO, Aux
      Character*80 atomb
      Character *256 Basis_lib, Fname
      Character*180, Allocatable :: STDINP(:) !CGGn
      Character*180 Line, Get_Ln
      External Get_Ln
      Integer StrnLn
      External StrnLn
      Logical Quit_On_Error
      common /getlnQOE/ Quit_On_Error
      Character*180 Get_Ln_Quit

      Integer BasisTypes(4)
      Data DefNm/'basis_library'/
*                                                                      *
************************************************************************
*                                                                      *
      Interface
#include "getbs_interface.fh"
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 2
      iPrint = nPrint(iRout)
*
*     Temporary setup of symmetry information
*
      Call mma_allocate(STDINP,mxAtom*2,label='STDINP')
      IfTest=.False.
*     IfTest=.True.
*
*     Add the auxiliary basis set
*
      BasisTypes(1)=0
      BasisTypes(2)=0
      BasisTypes(3)=0
      BasisTypes(4)=0
      iShll = S%Mx_Shll - 1
      lSTDINP=0
      mCnttp=nCnttp
*
*     Branch to special loop for reading external RICD basis sets
*     since these have a different infrastructure.
*
      If (iRI_Type.eq.5) Go To 1000

      Do iCnttp = 1, mCnttp
         If (dbsc(iCnttp)%Frag.or.dbsc(iCnttp)%nVal.eq.0) cycle
         mdc = dbsc(iCnttp)%mdci
         nCnttp=nCnttp+1
*
         If (nCnttp.gt.Mxdbsc) Then
            Call WarningMessage(2,'Error in Mk_RI_Shells')
            Write (6,*) 'Mk_RI_Shells: Increase Mxdbsc'
            Call Abend()
         End If
*
*        Resolve the name of the valence basis and find the name of
*        the appropriate auxiliary basis set.
*
         dbsc(nCnttp)%Bsl=dbsc(iCnttp)%Bsl_old
*
         Hit=.True.
         Call Decode(dbsc(nCnttp)%Bsl,atom,1,Hit)
         Hit=.True.
         Call Decode(dbsc(nCnttp)%Bsl,type,2,Hit)
         Hit=.True.
         Call Decode(dbsc(nCnttp)%Bsl,author,3,Hit)
         Hit=.True.
         Call Decode(dbsc(nCnttp)%Bsl,basis,4,Hit)
         Hit=.True.
         Call Decode(dbsc(nCnttp)%Bsl,CGTO,5,Hit)
         Hit=.False.
         Call Decode(dbsc(nCnttp)%Bsl,Aux,6,Hit)
         If (.Not.Hit) Aux = ' '
*
         n=Index(Atom,' ')-1
         dbsc(nCnttp)%Bsl(1:n+1)=atom(1:n)//'.'
         nn = n + 1
*
         n=Index(Type,' ')-1
         dbsc(nCnttp)%Bsl(nn+1:nn+n+5)=Type(1:n)//'.....'
*
*        Modify basis set library correctly
*
         Indx=Index(dbsc(nCnttp)%Bsl,' ')
         BSLbl=' '
         BSLbl(1:Indx-1)=dbsc(nCnttp)%Bsl(1:Indx-1)
         Call WhichMolcas(Basis_lib)
         If (Basis_lib(1:1).ne.' ') Then
            ib=index(Basis_lib,' ')-1
            If(ib.lt.1)
     &       Call SysAbendMsg('rdCtl','Too long PATH to MOLCAS',' ')
            If (iRI_Type.eq.1) Then
               Fname=Basis_lib(1:ib)//'/basis_library/j_Basis'
            Else If (iRI_Type.eq.2) Then
               Fname=Basis_lib(1:ib)//'/basis_library/jk_Basis'
            Else If (iRI_Type.eq.3) Then
               Fname=Basis_lib(1:ib)//'/basis_library/c_Basis'
            Else
               Call WarningMessage(2,'Error in Mk_RI_Shells')
               Write (6,*) 'Wrong iRI_Type!'
               Write (6,*) 'iRI_Type=',iRI_Type
               Call Abend()
            End If
         Else
            If (iRI_Type.eq.1) Then
               Fname=DefNm//'/j_Basis'
            Else If (iRI_Type.eq.2) Then
               Fname=DefNm//'/jk_Basis'
            Else If (iRI_Type.eq.3) Then
               Fname=DefNm//'/c_Basis'
            Else
               Call WarningMessage(2,'Error in Mk_RI_Shells')
               Write (6,*) 'Wrong iRI_Type!'
               Write (6,*) 'iRI_Type=',iRI_Type
               Call Abend()
            End If
         End If
*
         If (Show.and.iPrint.ge.6) Then
            Write (6,*)
            Write (6,*)
            Write(6,'(1X,A,I5,A,A)')
     &              'Basis Set ',nCnttp,' Label: ', BSLbl(1:Indx-1)
            Write(6,'(1X,A,A)') 'Basis set is read from library:',
     &                          Fname(1:index(Fname,' '))
         End if
*
         jShll = iShll
         dbsc(nCnttp)%Bsl_old=dbsc(nCnttp)%Bsl
         Call GetBS(Fname,dbsc(nCnttp)%Bsl,iShll,Ref,UnNorm,
     &              LuRd,BasisTypes,STDINP,lSTDINP,.False.,.true.,' ')
*
         dbsc(nCnttp)%Aux=.True.
         dbsc(nCnttp)%Charge=Zero
*
         If (Show.and.iPrint.ge.6 .and.
     &      Ref(1).ne.'' .and. Ref(2).ne.'') Then
            Write (6,'(1x,a)')  'Basis Set Reference(s):'
            If (Ref(1).ne.'') Write (6,'(5x,a)') Ref(1)
            If (Ref(2).ne.'') Write (6,'(5x,a)') Ref(2)
            Write (6,*)
            Write (6,*)
         End If
         dbsc(nCnttp)%ECP=(dbsc(nCnttp)%nPrj
     &                   + dbsc(nCnttp)%nSRO
     &                   + dbsc(nCnttp)%nSOC
     &                   + dbsc(nCnttp)%nPP
     &                   + dbsc(nCnttp)%nM1
     &                   + dbsc(nCnttp)%nM2) .NE. 0
*
         lAng=Max(dbsc(nCnttp)%nVal,
     &            dbsc(nCnttp)%nSRO,
     &            dbsc(nCnttp)%nPrj)-1
         S%iAngMx=Max(S%iAngMx,lAng)
*        No transformation needed for s and p shells
         Shells(jShll+1)%Transf=.False.
         Shells(jShll+1)%Prjct =.False.
         Shells(jShll+2)%Transf=.False.
         Shells(jShll+2)%Prjct =.False.
         dbsc(nCnttp)%pChrg=dbsc(iCnttp)%pChrg
         dbsc(nCnttp)%Fixed=dbsc(iCnttp)%Fixed
         dbsc(nCnttp)%Parent_iCnttp=iCnttp
         dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal
     &                        + dbsc(nCnttp)%nPrj
     &                        + dbsc(nCnttp)%nSRO
     &                        + dbsc(nCnttp)%nSOC
     &                        + dbsc(nCnttp)%nPP

         Do iSh = jShll+1, iShll
            Shells(iSh)%nBasis=Shells(iSh)%nBasis_c
            Call mma_deallocate(Shells(iShll)%pCff)
            Call mma_allocate(Shells(iShll)%pCff,
     &                        Shells(iSh)%nExp,Shells(iSh)%nBasis,
     &                        Label='pCff')
            Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
            Shells(iSh)%Aux=.True.
         End Do
*
         nCnt = dbsc(iCnttp)%nCntr
         dbsc(nCnttp)%nCntr=nCnt
         dbsc(nCnttp)%mdci =mdc
*        Create a pointer to the actual coordinates of the parent dbsc
         dbsc(nCnttp)%Coor=>dbsc(iCnttp)%Coor(1:3,1:nCnt)
*
         S%Mx_Shll=iShll+1
         Max_Shells=S%Mx_Shll
         S%Mx_mdc=mdc
*
      End Do
      Go To 1100
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Specially designed loop to read a RICD auxiliary basis set from
*     an external library.
*
 1000 Continue
*
      Lu_lib=17
      Lu_lib=IsFreeUnit(Lu_lib)
      call molcas_open(Lu_lib,'RICDLIB')
*
      Do iCnttp = 1, mCnttp
         If (dbsc(iCnttp)%Frag.or.dbsc(iCnttp)%nVal.eq.0) cycle
         mdc = dbsc(iCnttp)%mdci
*
         Hit=.True.
         Call Decode(dbsc(iCnttp)%Bsl_old,atom,1,Hit)
         Type=' '
         Author=' '
         basis=' '
         CGTO=' '
         Aux=' '
         If (IfTest) Then
            Write (6,*) 'Bsl_Old=',dbsc(iCnttp)%Bsl_old
            Write (6,*) 'Atom=',Atom
         End If
*
         Indx=Index(dbsc(iCnttp)%Bsl_old,' ')
         BSLbl=' '
         BSLbl(1:Indx-1)=dbsc(iCnttp)%Bsl_old(1:Indx-1)
*
*        Find the basis set
*
         ReWind(Lu_lib)
*
*        Loop over the basis set library to find the correct label
*
         If (IfTest) Write (6,*) ' Locate basis set label in library'
   10    BSLB = Get_Ln_Quit(Lu_lib,0)
         If (Quit_On_Error) Then
            iLast3=StrnLn(BsLbl)
            Call WarningMessage(2,
     &          'The requested basis set label: '//
     &          BsLbl(:iLast3)//';'//
     &          'was not found in basis library: '//'RICDLIB')
            Call Abend()
         End If
*
         Call UpCase(BSLB)
         If (BSLB(1:1).ne.'/') Go To 10
         If (IfTest) Write(6,*) 'BSLB=',BSLB
         n=Index(BSLB,' ')
         Do i=n,80
            BSLB(i:i)='.'
         End Do
         Hit=.True.
         Call Decode(BSLB(2:80),atomb,1,Hit)
         If (atomb.ne.atom) Go To 10
         If (IfTest) Write(6,*) 'atomb=',atomb
*
*        Now we should have found the correct basis set label!
*
         nSet=-1

         Do While (nSet.ne.0)
            Line=Get_Ln(Lu_lib)
            If (IfTest) Then
               Write(6,*) 'nSet=',nSet
               Write(6,*) 'Line=',Line
            End If
            Call Get_I1(2,lAng)
            If (nSet.eq.-1) Call Get_I1(3,nSet)
            If (IfTest) Write(6,*) 'lAng,nSet=',lAng,nSet
*
            Line=Get_Ln(Lu_lib)
            Line=Get_Ln(Lu_lib)
*
            nCnttp=nCnttp+1
            If (nCnttp.gt.Mxdbsc) Then
               Call WarningMessage(2,'Error in Mk_RI_Shells')
               Write (6,*) 'Mk_RI_Shells: Increase Mxdbsc'
               Call Abend()
            End If
            If (Show.and.iPrint.ge.6) Then
               Write (6,*)
               Write (6,*)
               Write(6,'(1X,A,I5,A,A)')
     &                 'Basis Set ',nCnttp,' Label: ', BSLb
               Write(6,'(1X,A)') 'Basis set is read from the workdir.'
            End if
*
            dbsc(nCnttp)%Bsl=BSLB(2:80)
            dbsc(nCnttp)%Bsl_old=dbsc(nCnttp)%Bsl
*
*           Loop over the angular shells
*
            jShll = iShll
            Do iAng = 0, lAng
               iShll=iShll+1
               Line=Get_Ln(Lu_lib)
               Call Get_I1(1,nPrim)
               Call Get_I1(2,nCntrc)
               Call Get_I1(3,iSph)
               If (IfTest) Then
                  Write (6,*) 'iAng=',iAng
                  Write (6,*) 'nPrim=',nPrim
                  Write (6,*) 'nCntrc=',nCntrc
                  Write (6,*) 'iSph=',iSph
               End If
*
*              Read Gaussian exponents
*
               Call mma_Allocate(Shells(iShll)%Exp,nPrim,Label='ExpRI')
               Shells(iShll)%nExp=nPrim
               Shells(iShll)%nBasis_C = nCntrc
               iEnd = iStrt - 1
               If (nPrim.gt.0) then
                  If (IfTest) Write(6,*) ' Read gaussian exponents'
                  Call Read_v(Lu_lib,Shells(iShll)%Exp,1,nPrim,1,Ierr)
                  If (Ierr.ne.0) Then
                     Call WarningMessage(2,
     &                     'GetBS: Error while reading the exponents')
                     Call Quit_OnUserError()
                  End If
                  If (IfTest) Write(6,*) ' Done with exponents'
               If (iPrint.ge.99.or.IfTest)
     &           Call RecPrt(' Exponents',' ',Shells(iShll)%Exp,nPrim,1)
               End If
               iStrt = iEnd + 1
*
*              Read contraction coefficients. Storage of coefficients
*              for both contracted and uncontracted case.
*
               Call mma_allocate(Shells(iShll)%Cff_c,nPrim,nCntrc,2,
     &                           Label='Cff_c')
               Call mma_allocate(Shells(iShll)%pCff,nPrim,nCntrc,
     &                           Label='pCff')
               Shells(iShll)%nBasis=nCntrc
               Call mma_allocate(Shells(iShll)%Cff_p,nPrim,nPrim,2,
     &                           Label='Cff_p')
               iEnds= iEnd
               iEnds= iEnds
               iEndc = iStrt - 1
               iEnd  = iStrt - 1
*              Read contraction coefficients
*              Observe that the matrix will have nPrim rows and
*              nCntrc columns
               If (IfTest) Write (6,*) ' Read coefficients'
*
*              Read in coeffs. in GC format, as the standard case
*
               If (IfTest) Write (6,*) ' Standard case'
               If (nPrim*nCntrc.gt.0) Then
                  Shells(iShll)%Cff_c(:,:,:)=Zero
*
*              Note that we now change the order!!!
               Read (Lu_lib,*) ((Shells(iShll)%Cff_c(i,j,2),
     &                           j=1,nCntrc),i=1,nPrim)
               If (Ierr.ne.0) Then
                  Call WarningMessage(2,
     &                   'GetBS: Error reading coeffs in GC format')
                  Call Quit_OnUserError()
               End If
               If (IfTest)
     &            Call RecPrt(' Coeffs',' ',Shells(iShll)%Cff_c(1,1,2),
     &                        nPrim,nCntrc)
               Shells(iShll)%Cff_c(:,:,1) = Shells(iShll)%Cff_c(:,:,2)
               If (IfTest)
     &            Call RecPrt(' Coeffs',' ',Shells(iShll)%Cff_c(1,1,1),
     &                        nPrim,nCntrc)
*
*              Put in unit matrix of uncontracted set
*
               Shells(iShll)%Cff_p(:,:,1)=Zero
               Do i=1,nPrim
                  Shells(iShll)%Cff_p(i,i,1)=One
               End Do
*
               Shells(iShll)%Cff_p(:,:,2)=Shells(iShll)%Cff_p(:,:,1)
               Call Nrmlz(Shells(iShll)%Exp,nPrim,
     &                    Shells(iShll)%Cff_p(1,1,1),nPrim ,iAng)

               Shells(iShll)%Cff_c(:,:,2)=Shells(iShll)%Cff_c(:,:,1)
               Call Fix_Coeff(nPrim,nCntrc,Shells(iShll)%Cff_c(1,1,2),
     &                                     Shells(iShll)%Cff_p(1,1,1),
     &                                     'F')
               Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
               End If
*
               iEnd =iEnds
               If (iSph.eq.0) Then
                  Shells(iShll)%Transf=.False.
                  Shells(iShll)%Prjct =.False.
               Else If (iSph.eq.1) Then
                  Shells(iShll)%Transf=.False.
                  Shells(iShll)%Prjct =.True.
               Else If (iSph.eq.2) Then
                  Shells(iShll)%Transf=.True.
                  Shells(iShll)%Prjct =.False.
               Else
                  Shells(iShll)%Transf=.True.
                  Shells(iShll)%Prjct =.True.
               End If

               Shells(iShll)%nBasis=Shells(iShll)%nBasis_C
               Shells(iShll)%Aux=.True.
*
            End Do ! iAng
*
            dbsc(nCnttp)%Aux=.True.
            S%iAngMx=Max(S%iAngMx,lAng)
*
            dbsc(nCnttp)%iVal = jShll + 1
            dbsc(nCnttp)%nVal = lAng+1
            dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal
*
            nCnt = dbsc(iCnttp)%nCntr
            dbsc(nCnttp)%nCntr=nCnt
            dbsc(nCnttp)%mdci =mdc
            dbsc(nCnttp)%Parent_iCnttp=iCnttp
*           Create a pointer to the actual coordinates.
            dbsc(nCnttp)%Coor=>dbsc(iCnttp)%Coor(1:3,1:nCnt)
*
            S%Mx_Shll=iShll+1
            Max_Shells=S%Mx_Shll
            S%Mx_mdc=mdc
*
            nSet=nSet-1
            If (nSet.ne.0) Line=Get_Ln(Lu_lib)
         End Do ! Do While (nSet.ne.0)
*
      End Do ! iCnttp
*
      Close(Lu_lib)
*                                                                      *
************************************************************************
*                                                                      *
*     Add the final DUMMY SHELL!
*
 1100 Continue
      Call Mk_Dummy_Shell()
      Call mma_deallocate(STDINP)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003,2020, Roland Lindh                                *
!               2020, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Con_Opt(r,drdq,T,dEdq,rLambda,q,dq,dy,dx,hql,du,x,dEdx,W,GNrm,nWndw,Hess,nInter,nIter,iOptH,jPrint,Energy,nLambda,Err, &
                   EMx,RHS,A,nA,cBeta,fCart,Beta_Disp_Seed,nFix,iP,Step_Trunc,Lbl,d2rdq2,nsAtom,iOpt_RS,Thr_RS,iter_, &
                   First_Microiteration)
!***********************************************************************
!                                                                      *
!     Object: to perform an constrained optimization. The constraints  *
!             are optimized directly as a linear problem in the        *
!             subspace defined by the gradients of the constraints.    *
!             The minimization is performed in the complemental        *
!             subspace with the ordinary routines.                     *
!                                                                      *
!             L(q,l) = E(q) - l^T r(q)                                 *
!                                                                      *
!             Ref:                                                     *
!             "A Reduced-Restricted-Quasi-Newton-Raphson Method for    *
!              Locating and Optimizing Energy Crossing Points Between  *
!              Two Potential Energy Surfaces",                         *
!             J. M. Anglada and J. M. Bofill,                          *
!             J. Comput. Chem., 18, 992-1003 (1997)                    *
!                                                                      *
!             For more details consult:                                *
!             "New General Tools for Constrained Geometry Optimization"*
!             L. De Vico, M. Olivucci, and R. Lindh,                   *
!             JCTC, 1:1029-1037, 2005                                  *
!             doi:10.1021/ct500949                                     *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chemical Physics,                 *
!             University of Lund, SWEDEN                               *
!             July 2003                                                *
!***********************************************************************

use kriging_mod, only: Max_MicroIterations, nSet
use Slapaf_Info, only: CnstWght, E_Delta, GrdMax, iOptC, IRC, MF, NADC, StpLbl, StpMax
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Five, Ten, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nWndw, nInter, nIter, iOptH, jPrint, nA, nFix, nsAtom, iOpt_RS, iter_
integer(kind=iwp), intent(inout) :: nLambda
real(kind=wp), intent(inout) :: r(nLambda,nIter), drdq(nInter,nLambda,nIter), dEdq(nInter,nIter), rLambda(nLambda,nIter+1), &
                                q(nInter,nIter+1), dq(nInter,nIter), Energy(nIter), cBeta, Thr_RS
real(kind=wp), intent(out) :: T(nInter,nInter), dy(nLambda), dx(nInter-nLambda,nIter), hql(nInter,nIter), du(nInter), &
                              x(nInter-nLambda,nIter+1), dEdx(nInter-nLambda,nIter), W(nInter-nLambda,nInter-nLambda), GNrm, &
                              Err(nInter,nIter+1), EMx((nIter+1)**2), RHS(nIter+1), A(nA)
real(kind=wp), intent(in) :: Hess(nInter,nInter), fCart, Beta_Disp_Seed, d2rdq2(nInter,nInter,nLambda)
integer(kind=iwp), intent(out) :: iP(nInter)
character, intent(out) :: Step_Trunc
character(len=8), intent(inout) :: Lbl(nInter+nLambda)
logical(kind=iwp), intent(in) :: First_MicroIteration
integer(kind=iwp) :: i, iCount, iCount_Max, iInter, iIter, iLambda, iMEP, iOff_Iter, iOptC_Temp, ipTb, ipTti, iSt, j, jLambda, &
                     nTrans
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iNeg
#endif
real(kind=wp) :: Beta, Beta_Disp, Beta_Disp_Save = Zero, Det, disp(nSet), disp_long, Disp_Save = Zero, disp_short, Dummy, dxdx, &
                 dxdx_last, dydy, dydy_last, dydymax, Fact, Fact_long, Fact_short, gBeta, gg, gg_last, RG, RR_, Sf, StpMax_Save, &
                 tBeta, Thr, tmp, xBeta, yBeta
logical(kind=iwp) :: Found, IRC_setup, Recompute_disp, RVO
character(len=8) :: StpLbl_Save
character :: Step_Trunc_
real(kind=wp), allocatable :: dq_xy(:), Hessian(:,:,:), RR(:,:), RRInv(:,:), RRR(:,:), RT(:,:), RTInv(:,:), Tdy(:), Tmp1(:), &
                              Tmp2(:,:), Tr(:), Trans(:), WTr(:)
character(len=8), allocatable :: LblSave(:)
real(kind=wp), parameter :: Beta_Disp_Min = 1.0e-10_wp
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) '****************************************************'
write(u6,*) '**** Con_Opt: Input data ***************************'
write(u6,*) '****************************************************'
write(u6,*)
write(u6,*) 'iOpt_RS=',iOpt_RS
write(u6,*) 'cBeta=',cBeta
write(u6,*) 'Beta_Disp_Seed=',Beta_Disp_Seed
write(u6,*)
write(u6,*) 'First_Microiteration=',First_Microiteration
write(u6,*)
call RecPrt('Con_Opt: Energy',' ',Energy,nIter,1)
call RecPrt('Con_Opt: q',' ',q,nInter,nIter)
call RecPrt('Con_Opt: dEdq',' ',dEdq,nInter,nIter)
if (nIter > 1) call RecPrt('Con_Opt: dq',' ',dq,nInter,nIter-1)
call RecPrt('Con_Opt: Hess(in)',' ',Hess,nInter,nInter)
call RecPrt('Con_Opt: r',' ',r,nLambda,nIter)
do iIter=1,nIter
  write(u6,*) ' iIter=',iIter
  call RecPrt('Con_Opt: drdq(orig)',' ',drdq(:,:,iIter),nInter,nLambda)
end do
do iLambda=1,nLambda
  write(u6,*) 'iLambda=',iLambda
  call RecPrt('Con_Opt: d2rdq2(iLambda)',' ',d2rdq2(:,:,iLambda),nInter,nInter)
end do
write(u6,*) '****************************************************'
write(u6,*) ' End of input arrays'
write(u6,*) '****************************************************'
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
RVO = iOpt_RS /= 0

ipTb = 1
ipTti = ipTb+nLambda

yBeta = One
gBeta = One
xBeta = One
Beta = fCart*cBeta
dydy_last = Beta
gg_last = Beta
dxdx_last = Beta
Sf = sqrt(Two)
dxdx = Zero
dydy = Zero
Thr = 1.0e-6_wp
call Get_iScalar('iOff_Iter',iOff_Iter)
call mma_allocate(dq_xy,nInter,Label='dq_xy')
call mma_allocate(Hessian,nInter,nInter,nSet,Label='Hessian')
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
iSt = max(iOff_Iter+1,nIter-nWndw+1)

#ifdef _DEBUGPRINT_
write(u6,*) '****************************************************'
write(u6,*) ' Compute the lambda values'
write(u6,*) '****************************************************'
#endif
do iIter=iSt,nIter
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) '>>>>>> iIter=',iIter
  write(u6,*)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute the lambda values (Eqn. 17)
  !
  ! dEdq=drdq l ; from  h(q_0,l)=dEdq - drdq l = 0
  !
  ! drdq^T dEdq= (drdq^T drdq) l
  !
  ! l =  (drdq^T drdq)^{-1} drdq^T dEdq

  call mma_allocate(RRR,nLambda,nInter,Label='RRR')
  call mma_allocate(RRInv,nLambda,nLambda,Label='RRInv')
  call mma_allocate(RR,nLambda,nLambda,Label='RR')

  ! drdq^T drdq

  call DGEMM_('T','N',nLambda,nLambda,nInter,One,drdq(:,:,iIter),nInter,drdq(:,:,iIter),nInter,Zero,RR,nLambda)

  ! (drdq^T drdq)^{-1}

  call MInv(RR,RRInv,Det,nLambda)
  call mma_deallocate(RR)

  ! (drdq^T drdq)^{-1} drdq^T

  call DGEMM_('N','T',nLambda,nInter,nLambda,One,RRInv,nLambda,drdq(:,:,iIter),nInter,Zero,RRR,nLambda)
  call mma_deallocate(RRInv)

  ! l = (T_b^T drdq)^{-1} drdq^T dEdq

  ! Note the sign conflict due to dEdq stored as a force.

  call DGEMM_('N','N',nLambda,1,nInter,-One,RRR,nLambda,dEdq(:,iIter),nInter,Zero,rLambda(:,iIter),nLambda) ! Sign conflict
  call mma_deallocate(RRR)
# ifdef _DEBUGPRINT_
  call RecPrt('rLambda(iIter)',' ',rLambda(:,iIter),nLambda,1)
# endif
end do
#ifdef _DEBUGPRINT_
write(u6,*) '****************************************************'
write(u6,*) ' End of computing the lambda values'
write(u6,*) '****************************************************'
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) '****************************************************'
write(u6,*) ' Check that grads of constraint are not null vectors'
write(u6,*) '****************************************************'
#endif
!do iIter = iOff_Iter+1,nIter
do iIter=iSt,nIter
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) '>>>>>> iIter,nIter=',iIter,nIter
  write(u6,*)
# endif
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! If we have that the derivative of the constraint is a null
  ! vector replace it with an arbitrary vector which is orthogonal
  ! to the gradient.
  !
  ! In case of the first macro iteration of an IRC search replace
  ! it with the reaction vector.

# ifdef _DEBUGPRINT_
  write(u6,*) '****************************************************'
  write(u6,*) ' Check that grads of constraint are not null vectors'
  write(u6,*) '****************************************************'
# endif
  do iLambda=1,nLambda
    RR_ = sqrt(DDot_(nInter,drdq(:,iLambda,iIter),1,drdq(:,iLambda,iIter),1))
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iLambda=',iLambda
    call RecPrt('drdq',' ',drdq(:,iLambda,iIter),1,nInter)
#   endif

    ! Make sure that we don't mess up gradients which are zero vectors.

    if (RR_ < 1.0e-12_wp) then
      xBeta = xBeta*Half

      if (abs(IRC) /= 0) then
        iMEP = 0
        call Qpg_iScalar('nMEP',Found)
        if (Found) call Get_iScalar('nMEP',iMEP)
        IRC_Setup = (iIter == 1) .and. (iMEP == 0)
      else
        IRC_Setup = .false.
      end if

      if (iIter == nIter) then

        write(u6,*) 'Warning: constraint ',iLambda,' has a null vector, I''ll fix it!'

        if (IRC_Setup .and. (IRC == 1)) then
          write(u6,*) ' IRC forward direction.'
        else if (IRC_Setup .and. (IRC == -1)) then
          write(u6,*) ' IRC backward direction.'
        end if
      end if
      r(iLambda,iIter) = Zero

      if (IRC_SetUp) call ReacQ(MF,3*nsAtom,dEdq(:,iIter),nInter)

      ! Try to use the transverse direction if the gradient is too small

      RR_ = sqrt(DDot_(nInter,dEdq(:,iIter),1,dEdq(:,iIter),1))
      if (RR_ < 1.0e-12_wp) then
        call qpg_dArray('Transverse',Found,nTrans)
        if (Found .and. (nTrans == 3*nsAtom)) then
          call mma_Allocate(Trans,3*nsAtom,Label='Trans')
          call Get_dArray('Transverse',Trans,nTrans)
          call ReacQ(Trans,3*nsAtom,dEdq(:,iIter),nInter)
          RR_ = sqrt(DDot_(nInter,dEdq(:,iIter),1,dEdq(:,iIter),1))
          dEdq(:,iIter) = dEdq(:,iIter)/RR_
          call mma_deallocate(Trans)
        end if
      else
        dEdq(:,iIter) = dEdq(:,iIter)/RR_
      end if

      do iInter=1,nInter
        if (abs(dEdq(iInter,iIter)) <= 1.0e-6_wp) then
          drdq(iInter,iLambda,iIter) = Zero
        else
          drdq(iInter,iLambda,iIter) = sign(One,dEdq(iInter,iIter))
        end if
      end do
#     ifdef _DEBUGPRINT_
      call RecPrt('Con_Opt: drdq',' ',drdq,nInter,nLambda*nIter)
#     endif

      ! Orthogonalize against the gradient and all other constraints

      RG = DDot_(nInter,drdq(:,iLambda,iIter),1,dEdq(:,iIter),1)
      drdq(:,iLambda,iIter) = drdq(:,iLambda,iIter)-RG*dEdq(:,iIter)
      RR_ = sqrt(DDot_(nInter,drdq(:,iLambda,iIter),1,drdq(:,iLambda,iIter),1))
      do jLambda=1,nLambda
        if (jLambda /= iLambda) then
          RG = DDot_(nInter,drdq(:,iLambda,iIter),1,drdq(:,jLambda,iIter),1)
          drdq(:,iLambda,iIter) = drdq(:,iLambda,iIter)-RG*drdq(:,jLambda,iIter)
          RR_ = sqrt(DDot_(nInter,drdq(:,iLambda,iIter),1,drdq(:,iLambda,iIter),1))
          drdq(:,iLambda,iIter) = drdq(:,iLambda,iIter)/RR_
        end if
      end do

#     ifdef _DEBUGPRINT_
      call RecPrt('Con_Opt; drdq(2)',' ',drdq,nInter,nLambda*nIter)
#     endif
    end if
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) '****************************************************'
  write(u6,*) ' End Check'
  write(u6,*) '****************************************************'
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! NOTE: for historical reasons the code stores the force rather than *
  !       the gradient. Hence, be careful of the sign whenever the     *
  !       terms dEdq, hql show up.                                     *
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Set up the T-matrix which separates the space into the
  ! subspace in which the constraint is accomplished and
  ! the complemental subspace.
  !
  ! [T_b,T_{ti}]
  !
  ! With the properties
  !
  ! drdq^T T_b =/= 0 (but not = 1, see note below)
  !
  ! drdq^T T_{ti} = T_b^T T_{ti} = 0
  !
  ! T_{ti}^T T_{ti} = 1

  call GS(drdq(:,:,iIter),nLambda,T,nInter,.false.,.false.)
# ifdef _DEBUGPRINT_
  call RecPrt('Con_Opt: T-Matrix',' ',T,nInter,nInter)
  call RecPrt('Con_Opt: T_b',' ',T(:,ipTB),nInter,nLambda)
  call RecPrt('Con_Opt: T_ti',' ',T(:,ipTti),nInter,nInter-nLambda)
# endif
  !                                                                    *
  ! Note that the paper by Anglada and Bofill has some errors on the   *
  ! properties of T. Especially with respect to the properties of T_b. *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute delta y  (Eqn. 11) -- in case of full relaxation --
  !
  ! r(q)+drdq^T dq=0
  !
  ! dq = [T_b, T_{ti}] (dy,dx)^T
  !
  ! r(q) = - drdq^T T_b dy - drdq^T T_{ti} dx
  !
  ! r(q) = - drdq^T T_b dy
  !
  ! dy = - (drdq^T T_b)^{-1} r(q)

  call mma_Allocate(RTInv,nLambda,nLambda,Label='RTInv')
  call mma_Allocate(RT,nLambda,nLambda,Label='RT   ')

  ! drdq^T T_b

  call DGEMM_('T','N',nLambda,nLambda,nInter,One,drdq(:,:,iIter),nInter,T(:,ipTb),nInter,Zero,RT,nLambda)
# ifdef _DEBUGPRINT_
  call RecPrt('Con_Opt: RT = drdq^T T_b',' ',RT,nLambda,nLambda)
# endif

  call MInv(RT,RTInv,Det,nLambda)
  call mma_deallocate(RT)
# ifdef _DEBUGPRINT_
  call RecPrt('Con_Opt: RTInv = (drdq^T T_b)^{-1}',' ',RTInv,nLambda,nLambda)
  call RecPrt('Con_Opt: r(:,iIter)',' ',r(:,iIter),nLambda,1)
# endif

  ! dy = - (drdq^T T_b)^{-1} r(q)

  call DGEMM_('N','N',nLambda,1,nLambda,-One,RTInv,nLambda,r(:,iIter),nLambda,Zero,dy,nLambda)
  call mma_deallocate(RTInv)
# ifdef _DEBUGPRINT_
  call RecPrt('Con_Opt: dy(full) = - (drdq^T T_b)^{-1} r(q)',' ',dy,nLambda,1)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Add contributions from constraints according to the last
  ! iterations. See Eqn. 7,
  !
  ! The Hessian of the Lagrangian expressed in the full space.
  !
  ! W^0 = H^0 - Sum(i) l_{0,i} d2rdq2(q_0)

  if (.not. RVO) then
    Hessian(:,:,1) = Hess(:,:)
    if (iIter == nIter) then
      do iLambda=1,nLambda
        Hessian(:,:,1) = Hessian(:,:,1)-rLambda(iLambda,iIter)*d2rdq2(:,:,iLambda)
      end do
    end if
  else
    call Hessian_Kriging_Layer(q(:,iIter),Hessian,nInter)
    if ((nSet > 2) .and. NADC) Hessian(:,:,1) = Half*(Hessian(:,:,1)+Hessian(:,:,2))
    do iLambda=1,nLambda
      Hessian(:,:,1) = Hessian(:,:,1)-rLambda(iLambda,iIter)*d2rdq2(:,:,iLambda)
    end do
  end if
# ifdef _DEBUGPRINT_
  call RecPrt('W^0 = H^0 - Sum(i) l_{0,i} d2rdq2(q_0)',' ',Hessian(:,:,1),nInter,nInter)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Transform various vectors and matrices to the nInter-nLambda
  ! subspace. See Eqn. 10 and text following.
  !
  ! Compute x, the coordinates of the reduced space.

  if (nInter-nLambda > 0) then

    ! q = T_b y + T_{ti} x = T [y,x]^T
    !
    ! x = T_{ti}^T q, since T_{ti}^T T_b = 0

    call DGEMM_('T','N',nInter-nLambda,1,nInter,One,T(:,ipTti),nInter,q(:,iIter),nInter,Zero,x(:,iIter),nInter-nLambda)

    ! Compute dx
    !
    ! dx = T_{ti}^T dq

    call DGEMM_('T','N',nInter-nLambda,1,nInter,One,T(:,ipTti),nInter,dq(:,iIter),nInter,Zero,dx(:,iIter),nInter-nLambda)

    ! Compute step restriction based on information from the
    ! minimization in the x subspace. This restriction is based
    ! on the step length in the x subspace.

    if (iIter /= nIter) then
#     ifdef _DEBUGPRINT_
      write(u6,*) 'dx = T_{ti}^T dq'
      call RecPrt('dx(:,iIter)',' ',dq(:,iIter),nInter,1)
#     endif

      ! Compute dq step in the x subspace
      !
      ! du = [0,dx]^T
      !
      ! dq = T [0,dx]^T

      du(:) = Zero
      du(nLambda+1:) = dx(1:nInter-nLambda,iIter)
      call Backtrans_T(du,dq_xy)
      dxdx = sqrt(DDot_(nInter,dq_xy,1,dq_xy,1))

#     ifdef _DEBUGPRINT_
      write(u6,*) 'dxdx=',dxdx
      write(u6,*) 'dxdx_last=',dxdx_last
#     endif

      if ((dxdx < 0.75_wp*dxdx_last) .and. (dxdx < Beta-Thr)) then
        ! Increase trust radius
        xBeta = min(One,xBeta*Sf)
      else if ((dxdx > 1.25_wp*dxdx_last) .or. (dxdx >= Beta+Thr)) then
        ! Reduce trust radius
        xBeta = max(One/Five,xBeta/Sf)
      end if
      dxdx_last = dxdx
#     ifdef _DEBUGPRINT_
      write(u6,*) 'xBeta=',xBeta
#     endif
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Compute the reduced gradient, observe again that we store
    ! the forces rather than the gradients.
    !
    ! See text after Eqn. 13.
    !
    ! dEdx = T_{ti}^T (dEdq + W_{ex} T_b dy)

    call mma_allocate(Tmp1,nInter,Label='Tmp1')
    call mma_allocate(Tmp2,nInter,nLambda,Label='Tmp2')

#   ifdef _DEBUGPRINT_
    call RecPrt('Con_Opt: dEdq',' ',dEdq(:,iIter),1,nInter)
    call RecPrt('Con_Opt: W',' ',Hessian(:,:,1),nInter,nInter)
    call RecPrt('Con_Opt: T',' ',T,nInter,nInter)
    call RecPrt('Con_Opt: dy',' ',dy,1,nLambda)
#   endif

    ! W_{ex} T_b

    call DGEMM_('N','N',nInter,nLambda,nInter,One,Hessian,nInter,T(:,ipTb),nInter,Zero,Tmp2,nInter)
#   ifdef _DEBUGPRINT_
    call RecPrt('W_{ex} T_b',' ',Tmp2,nInter,nLambda)
#   endif

    ! dEdq + W_{ex} T_b dy
    !
    ! Since we are computing the force we have the conflicting sign below.

    Tmp1(:) = dEdq(:,iIter)
    call DGEMM_('N','N',nInter,1,nLambda,-One,Tmp2,nInter,dy,nLambda,One,Tmp1,nInter) ! Sign conflict
    call mma_deallocate(Tmp2)
#   ifdef _DEBUGPRINT_
    call RecPrt('dEdq + W_{ex} T_b dy',' ',Tmp1,1,nInter)
#   endif

    ! dEdx = T_{ti}^T (dEdq + W_{ex} T_b dy)

    call DGEMM_('T','N',nInter-nLambda,1,nInter,One,T(:,ipTti),nInter,Tmp1,nInter,Zero,dEdx(:,iIter),nInter-nLambda)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iIter=',iIter
    call RecPrt('dEdx(:,iIter)',' ',dEdx(:,iIter),1,nInter-nLambda)
#   endif
    call mma_deallocate(Tmp1)

    ! Only now do we have the constrained gradient so we can
    ! reduce the step size (see update_kriging)

    if (RVO .and. First_Microiteration .and. (iIter == nIter)) then
      GNrm = sqrt(DDot_(nInter-nLambda,dEdx(:,nIter),1,dEdx(:,nIter),1))
      cBeta = min(1.0e3_wp*GNrm,cBeta)
      Beta = fCart*cBeta
    end if

    ! Compute step restriction based on information from the
    ! minimization in the x subspace. This restriction is based
    ! on the gradient in the x subspace.

    gg = sqrt(DDot_(nInter-nLambda,dEdx(:,iIter),1,dEdx(:,iIter),1))
    if ((gg < 0.75_wp*gg_last) .and. (gg < Beta-Thr)) then
      ! Increase trust radius
      gBeta = min(One,gBeta*Sf)
      !gBeta = gBeta*Sf
    else if ((gg > 1.25_wp*gg_last) .or. (gg >= Beta+Thr)) then
      ! Reduce trust radius
      gBeta = max(One/Five,gBeta/Sf)
    end if
    gg_last = gg
#   ifdef _DEBUGPRINT_
    write(u6,*) 'gg=',gg
    write(u6,*) 'gBeta=',gBeta
#   endif

  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Add contributions to the Lagrangian energy change

  if (iIter == nIter) then

    ! Term due to constraint

    call mma_allocate(Tmp1,nLambda,Label='Tmp1')
    call mma_allocate(Tdy,nInter,Label='Tdy')

    ! T_b dy

    call DGEMM_('N','N',nInter,1,nLambda,One,T(:,ipTb),nInter,dy,nLambda,Zero,Tdy,nInter)

    ! drdq^T dq = drdq^T T_b dy

    call DGEMM_('T','N',nLambda,1,nInter,One,drdq(:,:,iIter),nInter,Tdy,nInter,Zero,Tmp1,nLambda)
    call mma_deallocate(Tdy)

    ! r + drdq^T dq

    Tmp1(1:nLambda) = Tmp1(1:nLambda)+r(1:nLambda,iIter)

    ! l^T (r + drdq^T dq)

    E_Delta = E_Delta-DDot_(nLambda,rLambda(:,iIter),1,Tmp1,1)
    call mma_deallocate(Tmp1)

    ! Term due to coupling

    call mma_allocate(Tr,nInter,Label='Tr')

    ! T_b dy

    call DGEMM_('N','N',nInter,1,nLambda,One,T(:,ipTb),nInter,dy,nLambda,Zero,Tr,nInter)

    ! dEdq^T T_b dy
    !
    ! Note the sign conflict.

    E_Delta = E_Delta-DDot_(nInter,Tr,1,dEdq,1)

    call mma_allocate(WTr,nInter,Label='WTr')

    ! W T_b dy

    call DGEMM_('N','N',nInter,1,nInter,One,Hessian,nInter,Tr,nInter,Zero,WTr,nInter)

    ! dy^T T_b^T W T_b dy

    E_Delta = E_Delta+Half*DDot_(nInter,Tr,1,WTr,1)
    call mma_deallocate(WTr)
    call mma_deallocate(Tr)
  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Restrict actual step, dy
  !
  ! Step in direction which fulfills the restriction is given priority.
  ! This step is only reduced if it is larger than half the overall step
  ! restriction.

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Restricting the dy step.'
  write(u6,*) 'Start: dy(:)=',dy(:)
  write(u6,*)
# endif
  if (.not. RVO) then

    ! Compute dq step in the y subspace
    !
    ! dq_y = T [dy, 0]^T

    du(:) = Zero
    du(1:nLambda) = dy(:)
    call Backtrans_T(du,dq_xy)
    dydy = sqrt(DDot_(nInter,dq_xy,1,dq_xy,1))

    ! Reduce y step size if larger than some maximum size
    ! (the x step or half the total max step times a factor)

    dydymax = CnstWght*max(dxdx,Half*Beta)
    if (dydy > dydymax) then
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Reduce dydy!',dydy,' -> ',dydymax
      write(u6,*) 'Scaling Factor=',(dydymax/dydy)
#     endif
      dy(:) = (dydymax/dydy)*dy(:)
      dydy = dydymax
      Step_Trunc = '*'
    else
#     ifdef _DEBUGPRINT_
      write(u6,*) 'No reduce dydy!',dydy,' < ',dydymax
#     endif
      Step_Trunc = ' '
    end if

    ! The step reduction in the space which we minimize is such
    ! that while the fulfillment of the constraint is not
    ! improving from step to step we reduce the step length in
    ! the subspace in which we do the minimization.

    if ((dydy < 0.75_wp*dydy_last) .or. (dydy < 1.0e-2_wp)) then
      ! Recent step in the space for the restriction is smaller
      ! than the previous, or the recent step is smaller than
      ! some threshold. Then increase step length for x, however
      ! not more than the overall step restriction.
      yBeta = min(Two,yBeta*Sf)
    else if ((dydy > 1.25_wp*dydy_last) .and. (dydy >= 1.0e-5_wp)) then
      ! Otherwise decrease step direction.
      yBeta = max(One/Ten,yBeta/Sf)
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Here in the case of kriging and restricted-variance
    ! optimization.
    !
    ! We only need this for the last point.

    Fact = One
#   ifdef _DEBUGPRINT_
    if (iIter /= nIter) write(u6,*) 'Skip'
#   endif
    if (iIter == nIter) then

      ! Pick up the largest element of the gradient of the constraints.
      tmp = Zero
      do i=1,nLambda
        do j=1,nInter
          tmp = max(tmp,abs(drdq(j,i,iIter)))
        end do
      end do
      tmp = min(tmp,0.3_wp) ! Some constraints can have huge gradients. So be a bit careful.
      ! Allowed dispersion in the y subspace
      Beta_Disp = max(Beta_Disp_Min,tmp*CnstWght/(CnstWght+One)*Beta_Disp_Seed)
      if (.not. First_MicroIteration) Beta_Disp = min(Disp_Save+Beta_Disp,Beta_Disp_Save)

#     ifdef _DEBUGPRINT_
      write(u6,*) 'Step_trunc=',Step_trunc
      write(u6,*) 'CnstWght=',CnstWght
      write(u6,*) 'Beta=',Beta
      write(u6,*) 'tmp=',tmp
      write(u6,*) 'Beta_Disp=',Beta_Disp
#     endif

      dydy = DDot_(nLambda,dy,1,dy,1)
      if (Disp_Save/Beta_Disp > 0.99_wp) then
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Skip'
#       endif
        dy(:) = Zero
      else if (dydy >= 1.0e-12_wp) then
        ! Restrict dy step during micro iterations
        Fact = max(sqrt(dydy)/(CnstWght/(CnstWght+One)*Beta),One)

        iCount = 1
        iCount_Max = 100
        if (Step_Trunc == 'N') Step_Trunc = ' '
        do
          du(1:nLambda) = (One/Fact)*dy(:)
          du(nLambda+1:nInter) = Zero
          call Backtrans_T(du,dq_xy)
          q(:,iIter+1) = q(:,iIter)+dq_xy(:)

          call Dispersion_Kriging_Layer(q(:,iIter+1),disp,nInter)

          if (iCount == 1) then
            Fact_long = Fact
            disp_long = disp(1)
            Fact_short = Zero
            disp_short = disp_long+One
          end if
#         ifdef _DEBUGPRINT_
          write(u6,*) 'disp,Fact,iCount=',disp(1),Fact,iCount
#         endif
          if ((disp(1) <= Beta_Disp) .and. (iCount == 1)) exit
          if (abs(Beta_Disp-disp(1)) < Thr_RS) exit
          iCount = iCount+1
          if (iCount > iCount_Max) then
            write(u6,*) 'iCount > iCount_Max'
            call Abend()
          end if
          call Find_RFO_Root(Fact_long,disp_long,Fact_short,disp_short,Fact,disp(1),Beta_Disp)
          Step_Trunc = '*'
        end do
      end if
    end if
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Final scaling Factor:',(One/Fact)
#   endif
    dy(:) = (One/Fact)*dy(:)
#   ifdef _FindTS_

    ! If a FindTS optimization hold back a bit. The purpose of
    ! the constrained optimization phase is actually not to
    ! find the constrained structure.

    if (btest(iOptC,12)) then
      dydy = sqrt(DDot_(nLambda,dy,1,dy,1))
      Thrdy = 0.075_wp
      if (dydy > Thrdy) then
        dy(:) = (Thrdy/dydy)*dy(:)
        Step_Trunc = '*'
      end if
    end if
#   endif
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Step_trunc=',Step_trunc
    write(u6,*) 'Final: dy(:)=',dy(:)
#   endif
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !      Twist for MEP optimizations.

  if ((iIter == iOff_iter+1) .and. (dydy < 1.0e-4_wp) .and. (iIter /= 1)) xBeta = xBeta*Half
  dydy_last = dydy

# ifdef _DEBUGPRINT_
  call RecPrt('Con_Opt: dy(actual)',' ',dy,nLambda,1)
# endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
end do ! Do iIter = iSt, nIter
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('Con_Opt: dEdx',' ',dEdx,nInter-nLambda,nIter)
call RecPrt('Con_Opt: Lambda',' ',rLambda,nLambda,nIter)
call RecPrt('Con_Opt: x',' ',x,nInter-nLambda,nIter)
call RecPrt('Con_Opt: dx',' ',dx,nInter-nLambda,nIter-1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the h vectors.   (Eqn. 16)
!
! h(q,l) = dEdq - drdq l_0^T
!
! Note the sign conflict due to storage of the force rather than the
! gradient.
#ifdef _DEBUGPRINT_
call RecPrt('Con_Opt: dEdq',' ',dEdq,nInter,nIter)
write(u6,*) 'iOff_iter=',iOff_iter
#endif
hql(:,:) = dEdq(:,:)
do iIter=iOff_iter+1,nIter
  do iLambda=1,nLambda
    hql(:,iIter) = hql(:,iIter)+rLambda(iLambda,nIter)*drdq(:,iLambda,iIter) ! Sign conflict
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('Con_Opt: h(q,l) = dEdq - drdq l_0^T',' ',hql,nInter,nIter)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the value of the Lagrangian
!
! L = E + l r(q)

do iIter=iOff_iter+1,nIter
  do iLambda=1,nLambda
    Energy(iIter) = Energy(iIter)+rLambda(iLambda,iIter)*r(iLambda,iIter)
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('Con_Opt: Lagrangian, L = E + l r(q)',' ',Energy,nIter,1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Update the Hessian in the m subspace
! There should be no negative eigenvalue, if so change the sign.

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*)
write(u6,*) ' *** Updating the reduced Hessian ***'
write(u6,*)
#endif

if (btest(iOptC,12)) then

  ! If FINDTS option force minimization option during the Hessian update.

  iOptC_Temp = 128
else
  iOptC_Temp = iOptC
end if

#ifdef _DEBUGPRINT_
call RecPrt('Con_Opt: Hessian before the update',' ',Hessian(:,:,1),nInter,nInter)
write(u6,*) 'iOptH=',iOptH
#endif
if (Step_Trunc == 'N') Step_Trunc = ' '
Dummy = Zero
call Update_H(nWndw,Hessian,nInter,nIter,iOptC_Temp,dq,hql,iOptH,jPrint,Dummy,nsAtom,.false.,.false.)

#ifdef _DEBUGPRINT_
call RecPrt('Con_Opt: W(updated)',' ',Hessian(:,:,1),nInter,nInter)
write(u6,*) 'Step_Trunc=',Step_trunc
call DiagMtrx(Hessian(:,:,1),nInter,iNeg)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the reduced Hessian
!
! See text after Eqn. 13.
!
! T_{ti}^T W T_{ti}

if (nInter-nLambda > 0) then

  call mma_allocate(Tmp2,nInter-nLambda,nInter,Label='Tmp2')
  call DGEMM_('T','N',nInter-nLambda,nInter,nInter,One,T(:,ipTti),nInter,Hessian,nInter,Zero,Tmp2,nInter-nLambda)
  call DGEMM_('N','N',nInter-nLambda,nInter-nLambda,nInter,One,Tmp2,nInter-nLambda,T(:,ipTti),nInter,Zero,W,nInter-nLambda)
  call mma_deallocate(Tmp2)
# ifdef _DEBUGPRINT_
  call RecPrt('Con_Opt: the reduced Hessian, T_{ti}^T W T_{ti}',' ',W,nInter-nLambda,nInter-nLambda)
  call DiagMtrx(W,nInter-nLambda,iNeg)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Update dx
  !
  ! Set threshold depending on if restriction is w.r.t. step-size
  ! or variance.

  if (.not. RVO) then
    Beta_Disp = One ! Dummy assign
  else

    ! Note that we use the dEdx data for the last point on the real PES.

#   ifdef _DEBUGPRINT_
    write(u6,*) 'Beta_Disp=',Beta_Disp
#   endif
    tmp = Zero
    do i=1,nInter-nLambda
      tmp = max(tmp,abs(dEdx(i,iter_)))
    end do
    ! Add the allowed dispersion in the x subspace.
    if (First_MicroIteration) Beta_Disp_Save = max(Beta_Disp+tmp*Beta_Disp_Seed,Beta_Disp_Min)
    Beta_Disp = Beta_Disp_Save
#   ifdef _DEBUGPRINT_
    write(u6,*) 'tmp,Beta_Disp=',tmp,Beta_Disp
#   endif
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute updated geometry in internal coordinates

  fact = One
  tBeta = max(Beta*yBeta*min(xBeta,gBeta),Beta/Ten)
  Thr_RS = 1.0e-7_wp
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Compute dx'
  write(u6,*)
  write(u6,*) 'Step_Trunc(0)=',Step_Trunc
  write(u6,*) 'Beta=',Beta
  write(u6,*) 'yBeta=',yBeta
  write(u6,*) 'xBeta=',xBeta
  write(u6,*) 'gBeta=',gBeta
  write(u6,*) 'tBeta=',tBeta
# endif
  do
    Step_Trunc_ = Step_Trunc
    call Newq(x,nInter-nLambda,nIter,dx,W,dEdx,Err,EMx,RHS,A,nA,tBeta,nFix,iP,Energy,Step_Trunc_,Thr_RS)
    if (Step_Trunc == 'N') Step_Trunc = ' '

    if (.not. RVO) then
      if (Step_Trunc_ == 'N') Step_Trunc_ = ' '
      Step_Trunc = Step_Trunc_
      exit
    end if

    if (Step_Trunc//Step_Trunc_ == ' *') Step_Trunc = '.'

    du(1:nLambda) = dy(:)
    du(nLambda+1:nInter) = dx(:,nIter)
    call Backtrans_T(du,dq_xy)
    q(:,nIter+1) = q(:,nIter)+dq_xy(:)

    call Dispersion_Kriging_Layer(q(:,nIter+1),disp,nInter)
    Disp_Save = disp(1)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'disp=',disp(1)
#   endif
    fact = Half*fact
    tBeta = Half*tBeta
    if (One-disp(1)/Beta_Disp > 1.0e-3_wp) exit
    if ((fact < 1.0e-5_wp) .or. (disp(1) < Beta_Disp)) exit
    Step_Trunc = '*'
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) 'Step_Trunc(n)=',Step_Trunc
# endif
  GNrm = sqrt(DDot_(nInter-nLambda,dEdx(:,nIter),1,dEdx(:,nIter),1))

else
  ! Negative norm should serve as sign that there is no gradient
  GNrm = -One
end if

#ifdef _DEBUGPRINT_
write(u6,*) 'Step_Trunc=',Step_trunc
call RecPrt('Con_Opt: dx(actual)',' ',dx,nInter-nLambda,nIter)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Back transform dy and dx to dq.
!
! See Eqn. 10.

#ifdef _DEBUGPRINT_

! dy only, constraint

du(:) = Zero
du(1:nLambda) = dy(:)
call Backtrans_T(du,dq_xy)
dydy = sqrt(DDot_(nInter,dq_xy,1,dq_xy,1))
call RecPrt('dq(dy)',' ',dq_xy,nInter,1)
write(u6,*) '<R(q_0)|dy>=',DDot_(nInter,dRdq(:,1,nIter),1,dq_xy,1)

! dx only, constrained minimization

du(:) = Zero
du(nLambda+1:nInter) = dx(:,nIter)
call Backtrans_T(du,dq_xy)
dxdx = sqrt(DDot_(nInter,dq_xy,1,dq_xy,1))
call RecPrt('dq(dx)',' ',dq_xy,nInter,1)
write(u6,*) '<R(q_0)|dx>=',DDot_(nInter,dRdq(:,1,nIter),1,dq_xy,1)
#endif

! dy+dx, full step
!
! dq = T [dy, dx]

du(:) = Zero
du(1:nLambda) = dy(1:nLambda)
du(nLambda+1:nInter) = dx(:,nIter)
#ifdef _DEBUGPRINT_
call RecPrt('du',' ',du,1,nInter)
#endif

! For kriging, in the last 10 micro iterations, give up trying to
! optimize and just focus on fulfilling the constraints.

Recompute_disp = .false.
if ((Max_MicroIterations >= 50) .and. (nIter-iter_+1 > Max_Microiterations-10)) then
  dydy = sqrt(DDot_(nLambda,dy,1,dy,1))
  if (dydy > 1.0e-12_wp) du(nLambda+1:nInter) = Zero
  Recompute_disp = .true.
end if
call Backtrans_T(du,dq(:,nIter))
#ifdef _DEBUGPRINT_
call RecPrt('dq(dx+dy)',' ',dq(:,nIter),1,nInter)
#endif

! Compute q for the next iteration

q(:,nIter+1) = q(:,nIter)+dq(:,nIter)
if (Recompute_disp) then
  call Dispersion_Kriging_Layer(q(:,nIter+1),Disp,nInter)
  Disp_Save = Disp(1)
end if

#ifdef _DEBUGPRINT_
call RecPrt('Con_Opt: q',' ',q,nInter,nIter+1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! StpMax from q

call MxLbls(nInter,hql(:,nIter),dq(:,nIter),Lbl)

! GrdMax for dEdx

if (nInter-nLambda > 0) then

  StpMax_Save = StpMax
  StpLbl_Save = StpLbl
  call mma_allocate(LblSave,size(Lbl),Label='LblSave')
  LblSave(:) = Lbl
  GrdMax = Zero
  do i=1,nInter-nLambda
    write(Lbl(i),'(A,I3.3)') 'dEdx',i
  end do
  call MxLbls(nInter-nLambda,dEdx(:,nIter),dx(:,nIter),LblSave)
  call mma_deallocate(LblSave)
  StpMax = StpMax_Save
  StpLbl = StpLbl_Save

end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(dq_xy)
call mma_deallocate(Hessian)

return

contains

subroutine Backtrans_T(du,dq)
  real(kind=wp), intent(in) :: du(nInter)
  real(kind=wp), intent(out) :: dq(nInter)
  call DGEMM_('N','N',nInter,1,nInter,One,T,nInter,du,nInter,Zero,dq,nInter)
end subroutine Backtrans_T

end subroutine Con_Opt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module GetInt_mod

use Definitions, only: wp, iwp

implicit none
private

! Variables for computing integrals from Cholesky vectors.
integer(kind=iwp) :: I, ID_IP, LuCVec(2), mNeed, nBas(8), nPQ, nRS, NumCho(8), NumV, nVec, pq1
real(kind=wp), allocatable :: Vec2(:,:)
integer(kind=iwp), allocatable :: Basis_IDs(:,:), hash_table(:), lists(:,:)

public :: Basis_IDs, hash_table, I, ID_IP, lists, LuCVec, mNeed, nBas, nPQ, nRS, NumCho, NumV, nVec, pq1, Vec2

end module GetInt_mod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine faroald_free()
! The finalization subroutine lives outside of the
! faroald module so that it can be called separately.

use faroald, only: ex1_a, ex1_b, mma_deallocate

implicit none

if (allocated(ex1_a)) call mma_deallocate(ex1_a)
if (allocated(ex1_b)) call mma_deallocate(ex1_b)

end subroutine faroald_free

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine CalcAddpp (aSGrp,addapp)
c
c        this routine calc addapp
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
        integer aSGrp,addapp
c
c        help var
        integer i
c
          addapp=0
        if (aSGrp.gt.1) then
          do i=1,aSGrp-1
            addapp=addapp+DimSGrpa(i)
          end do
        end if
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_V(VV)
! check V

use chcc_global, only: no, nv, Q22, T1c
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: VV(nv,no,no,no)
integer(kind=iwp) :: b, bad, be, j, u, v
real(kind=wp) :: s

bad = 0

do j=1,no
  do u=1,no
    do v=1,no
      do be=1,nv

        s = Zero
        do b=1,nv
          s = s+Q22(be,b,u,j)*T1c(b,v)
        end do

        if (abs(VV(be,v,u,j)-s) > 1.0e-10_wp) then
          VV(be,v,u,j) = s
          bad = bad+1
        end if

      end do
    end do
  end do
end do

write(u6,*) ' V  Chck :',bad

return

end subroutine Chck_V

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        Subroutine fileorb(filein,fileout)
        Character*(*) filein
        Character*(*) fileout
        Character*256 tmp
        Logical Exist
        if(index(filein,'/').ne.0) then
           fileout=filein
           goto 100
        endif
        tmp=' '
        call getenvf('MOLCAS_SUBMIT_DIR',tmp)
        if(tmp.ne.' ') then
         fileout=tmp(1:mylen(tmp))//'/'//filein
c         print *,'vv',fileout
         call f_inquire(fileout,Exist)
         if(Exist) goto 100
        endif
         fileout=filein
         call f_inquire(fileout,Exist)
         if(.not.Exist)        then
          tmp='file '//fileout(1:mylen(fileout))//' not found'
          Call WarningMessage(2,tmp)
          Call Quit_OnUserError()
         endif
100      continue
c         write(6,*) 'INPORB file=',fileout
c         call fcopy(fileout(1:mylen(fileout)),'INPORB')
         return
         end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHOSCF_MEM(nSym,nBas,iUHF,DoExchange,ipNocc,
     &                      ALGO,REORD,MinMem,lOff1)

*****************************************************************
*  Author : F. Aquilante
*
*  Purpose:
*            Returns an array MinMem that contains the minimum
*            amount of memory required for each Cholesky
*            vector for the building of the frozen AO-Fock matrix
*
*            The first vector is stored in a larger memory block
*            in some cases in order to re-use the allocated memory
*            for computing the exchange intermediate.
*            The value of LOFF1 specifies the amount of memory
*            reserved for the 1st vector
*
*            Note that this is a specialized code and can be used
*                 only in connection with the truth table defined
*                 in the calling routine
******************************************************************

      Implicit Real*8 (a-h,o-z)
      Integer nSym,nBas(nSym),MinMem(nSym),iUHF,ALGO
      Integer Moccmx(nSym),Mabmx(nSym),MxBas(nSym)
      Logical REORD,xToDo,DoExchange(*)
      Integer ipNocc(*)

#include "WrkSpc.fh"
#include "choptr.fh"

**************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
**************************************************
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
**************************************************



      If (iUHF .eq. 0) Then
         nDen = 1
         xToDo=DoExChange(1)
      Else
         nDen = 3
         xToDo=DoExChange(2)
      End If

C============================
      lOff1=0
      Do i=1,nDen
         Do j=1,nSym
            lOff1=Max(lOff1,iWork(ipNocc(i)+j-1))
         End Do
      End Do

      do j=1,nSym
         Moccmx(j)=0
         do i=1,nDen
            Moccmx(j)=Max(Moccmx(j),iWork(ipNocc(i)+j-1))
         end do
      end do

C Max dimension of a read symmetry block
        Nmax=0
        Do iSym=1,nSym
           if(NBAS(iSym).gt.Nmax .and. Moccmx(isym).ne.0 )then
           Nmax = NBAS(iSym)
           iSymMax= iSym
           endif
        End Do

        lOff1 = Nmax*lOff1

C============================
      Do jSym=1,nSym

C Total length of a vector
       Mabmx(jSym)=0
       MxBas(jSym)=0
       Nab=0
       NSab=0
       Do ksym=1,nSym
          iSymp=MulD2h(ksym,jSym)
          If (iSymp.gt.ksym .and. (Moccmx(iSymp).ne.0 .or.
     &                             Moccmx(ksym).ne.0) )  Then
             Nab = Nab + nBas(ksym)*nBas(iSymp)
             Mabmx(jSym)= Max(Mabmx(jSym),Max(nBas(ksym)*Moccmx(iSymp),
     &                        nBas(iSymp)*Moccmx(ksym)))
             MxBas(jSym)= Max(MxBas(jSym),nBas(ksym)*nBas(iSymp))
          Else
               If (iSymp.eq.ksym) Then ! all are needed for the Coulomb
                  Nab = Nab + nBas(ksym)*(nBas(ksym)+1)/2
                  NSab= NSab + nBas(ksym)**2
               End If
          End If
       End Do

C ====================================================================
C === The following memory management is bound to the truth table  ===
C === assigned in the calling routine
C=====================================================================

        IF(.not.xToDo) THEN

         MinMem(jSym) = Nab + 1  ! to store 1 vector of L(rJ),s + V(J)
         if(.not.REORD) then
           MinMem(jSym)=Nab+nDimRS(jSym,1)
c           ! L + read 1 vect reduced set1
         end if

        ELSE ! Memory for "off-diagonal" exchange only (jSym.ne.1)

             if (REORD) then
               MinMem(jSym) = 2*Nab ! 1 vector of L(rJ),s + W(rJ),s
             else
                if(ALGO.eq.2)then
                  MinMem(jSym) = Nab + Max(nDimRS(jSym,1),Mabmx(jSym))
                else
                  MinMem(jSym) = Nab + Max(nDimRS(jSym,1),MxBas(jSym))
                endif
             endif

        END IF

C-----
        IF(xToDo.and.jSym.eq.1) THEN  ! jSym=1 is a special case

           If(nSym.eq.1) then

               if (ALGO.eq.2) then
                   if (lOff1.gt.Nab) then
                      MinMem(jSym) = lOff1 + NSab
                   else
                      MinMem(jSym) = Nab + NSab
                      lOff1 = Nab
                   endif
               else

                   MinMem(jSym) = 2*NSab
                   lOff1 = NSab

               endif

           Else  ! nSym > 1   jSym=1

               if (ALGO.eq.2) then
                   if (lOff1.gt.nBas(1)*(nBas(1)+1)/2) then
                      MinMem(jSym) = Nab - nBas(1)*(nBas(1)+1)/2
     &                             + lOff1 + Nmax**2
                   else
                      MinMem(jSym) = Nab + Nmax**2
                      lOff1 = nBas(1)*(nBas(1)+1)/2
                   endif
               else

                   MinMem(jSym) = 2*(Nmax**2)
     &                          + (Nab-nBas(1)*(nBas(1)+1)/2)
                   lOff1 = Nmax**2

               endif

           EndIf

        ENDIF   ! JSYM=1  special case

C ====================================================================

      End Do  ! loop over jSym

      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ds_ardlr_act_c1(lin)
!=======================================================================
! ds(7-1) ar(23)-drl(30)-
!=======================================================================

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, w0_ds
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmd, lrd, lri, mpl, ni
real(kind=wp) :: w0ds1
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  do lrd=norb_frz+1,lri-1
    lmd = lsm_inn(lrd)
    if (lmd /= jml) cycle
    iwdr = just(lri,lri)
    iwdl = jud(lrd)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    w0ds1 = w0_ds(1)
    ni = mod(norb_dz-lrd,2)
    if (ni == 0) w0ds1 = -w0ds1
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ds1
      vplp_w1(mpl) = Zero
    end do
    call ar_drl_ext_al_new(lin,lrd,lri)
  end do
end do

return

end subroutine ds_ardlr_act_c1

subroutine ds_arblbr_act_c1(lin)
!=======================================================================
! ds(7-3) ar(23)-bl(32)-br(31)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_ds, w1_ds
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmd, lmi, lmij, lmj, lrd, lri, lrj, mpl, ni
real(kind=wp) :: w0ds, w1ds
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmr) cycle
    ! ds(7-3) ar(23)-bl(32)-br(31)-
    do lrd=norb_frz+1,lri-1
      lmd = lsm_inn(lrd)
      if (lmd /= jml) cycle
      ijk = lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
      intpos = intind_ijka(ijk)
      w0ds = w0_ds(3)
      w1ds = w1_ds(3)
      ni = mod(norb_dz-lrj+lri-lrd,2)
      if (ni == 0) w0ds = -w0ds
      if (ni == 0) w1ds = -w1ds

      iwdr = just(lri,lrj)
      iwdl = jud(lrd)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ds
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ds
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    end do
  end do
end do

return

end subroutine ds_arblbr_act_c1

subroutine dt_arblbr_act_c1(lin)
!=======================================================================
! dt(14) ar(23)-bl(32)-br(32)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_dt, w1_dt
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmd, lmi, lmij, lmj, lrd, lri, lrj, mpl, ni
real(kind=wp) :: w0dt, w1dt
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmr) cycle
    ! dt(14) ar(23)-bl(32)-br(32)-
    do lrd=norb_frz+1,lri-1
      lmd = lsm_inn(lrd)
      if (lmd /= jml) cycle
      ijk = lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
      intpos = intind_ijka(ijk)
      w0dt = w0_dt
      w1dt = w1_dt
      ni = mod(norb_dz-lrj+lri-lrd,2)
      if (ni == 0) w0dt = -w0dt
      if (ni == 0) w1dt = -w1dt

      iwdr = just(lri,lrj)
      iwdl = jud(lrd)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0dt
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1dt
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    end do
  end do
end do

return

end subroutine dt_arblbr_act_c1

subroutine dv_ar_act_blbr(lin,jk)
!=======================================================================
! dv(23-1) ar(23)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dv
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lri, mpl, ni
real(kind=wp) :: w0dv1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jml) cycle
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)

  w0dv1 = w0_dv(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0dv1 = -w0dv1
  iwdl = jud(lri)
  iwdr = 0
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0dv1
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0dv1
  end do
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  call ar_bl_br_ext_al_new(lin,intpos,isma,1)
end do

return

end subroutine dv_ar_act_blbr

!subroutine dv_ar_act_brbr(lin,lrai,lraj)
!!=======================================================================
!! dv(23-1) ar(23)-
!!=======================================================================
!
!use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
!                         lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dv
!use Symmetry_Info, only: Mul
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: lin, lrai, lraj
!integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lri, mpl, ni
!real(kind=wp) :: w0dv1
!integer(kind=iwp), external :: iwalk_ad
!
!isma = Mul(iml,imr)
!do lri=norb_frz+1,norb_dz
!  lmi = lsm_inn(lri)
!  if (lmi /= jml) cycle
!  ijk = lri-norb_frz+ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)
!  intpos = intind_ijka(ijk)
!
!  w0dv1 = w0_dv(1)
!  ni = mod(norb_dz-lri,2)
!  if (ni == 1) w0dv1 = -w0dv1
!  iwdl = jud(lri)
!  iwdr = 0
!  do mpl=1,mtype
!    vplp_w0(mpl) = vplpnew_w0(mpl)*w0dv1
!    vplp_w1(mpl) = vplpnew_w1(mpl)*w0dv1
!  end do
!  do mpl=1,mhlp
!    iwal = lpnew_lwei(mpl)
!    iwar = lpnew_rwei(mpl)
!    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!  end do
!  call ar_br_br_ext_ar_new(lin,intpos,isma)
!end do
!
!return
!
!end subroutine dv_ar_act_brbr

subroutine dv_ar_act_dlr(lin,lra)
!=======================================================================
! dv(23-1) ar(23)-
!=======================================================================

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dv
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lri, mpl, ni
real(kind=wp) :: w0dv1
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jml) cycle

  w0dv1 = w0_dv(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0dv1 = -w0dv1
  iwdl = jud(lri)
  iwdr = 0
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0dv1
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0dv1
  end do
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  call ar_drl_ext_al_new(lin,lri,lra)
end do

return

end subroutine dv_ar_act_dlr

subroutine tt_arbl_act_bl(lin,lra)
!=======================================================================
! tt(11-1) (22)ar(23)-bl(32)-
! tt(11-1) ar(23)-c'(22)-bl(32)-
! tt(11-1) ar(23)-bl(32)-c"(22)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, jml, jmr, lsm_inn, ngw2, ngw3, norb_dz, norb_frz
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, jmlr, lmi, lmij, lmj, lri, lrj, nk

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    call tt1_ext(lri,lrj,nk,1)
    call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
    call tt1_ext(lri,lrj,nk,-1)
    call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
  end do
end do

return

end subroutine tt_arbl_act_bl

subroutine tt_drl_act_bl(lin,lra)
! tt(11-2) (22)drl(22)-
! tt(11-2) drl(22)-c"(22)-
! tt(11-3) (22)(22)drl(33)-
! tt(11-3) (22)drl(33)-c"(22)-
! tt(11-3) drl(33)-c"(22)-c"(22)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_tt, w1_tt
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_tt(2)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_tt(2)
    end do
    ! tt(11-2) (22)drl(22)-
    ! tt(11-2) drl(22)-c"(22)-
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call drl_bl_ext_ar_new(lin,lri,lra)
    call drl_bl_ext_ar_new(lin,lrj,lra)
    ! tt(11-3) drl(33)-c"(22)-c"(22)-
    ! tt(11-3) (22)drl(33)-c"(22)-
    ! tt(11-3) (22)(22)drl(33)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_tt(3)
      vplp_w1(mpl) = Zero
    end do
    if (lra > norb_dz) then
      call drl_bl_sum_ar_new(lin,lri,lrj,lra)
    else
      do lrk=1,norb_dz
        if (lrk == lri) cycle
        if (lrk == lrj) cycle
        call drl_bl_ext_ar_new(lin,lrk,lra)
      end do
    end if
    !do lrk=1,norb_dz
    !  if (lrk == lri) cycle
    !  if (lrk == lrj) cycle
    !  call drl_bl_ext_ar_new(lin,lrk,lra)
    !end do
  end do
end do

return

end subroutine tt_drl_act_bl

subroutine tt_arbl_act_br(lin,lra)
!=======================================================================
! tt(11-1) (22)ar(23)-bl(32)-
! tt(11-1) ar(23)-c'(22)-bl(32)-
! tt(11-1) ar(23)-bl(32)-c"(22)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, jml, jmr, lsm_inn, ngw2, ngw3, norb_dz, norb_frz
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, jmlr, lmi, lmij, lmj, lri, lrj, nk

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    call tt1_ext(lri,lrj,nk,1)
    call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
    call tt1_ext(lri,lrj,nk,-1)
    call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
  end do
end do

return

end subroutine tt_arbl_act_br

subroutine tt_drl_act_br(lin,lra)
! tt(11-2) (22)drl(22)-
! tt(11-2) drl(22)-c"(22)-
! tt(11-3) (22)(22)drl(33)-
! tt(11-3) (22)drl(33)-c"(22)-
! tt(11-3) drl(33)-c"(22)-c"(22)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_tt, w1_tt
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_tt(2)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_tt(2)
    end do
    ! tt(11-2) (22)drl(22)-
    ! tt(11-2) drl(22)-c"(22)-
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call drl_br_ext_al_new(lin,lri,lra)
    call drl_br_ext_al_new(lin,lrj,lra)
    ! tt(11-3) drl(33)-c"(22)-c"(22)-
    ! tt(11-3) (22)drl(33)-c"(22)-
    ! tt(11-3) (22)(22)drl(33)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_tt(3)
      vplp_w1(mpl) = Zero
    end do
    if (lra > norb_dz) then
      call drl_br_sum_al_new(lin,lri,lrj,lra)
    else
      do lrk=1,norb_dz
        if (lrk == lri) cycle
        if (lrk == lrj) cycle
        call drl_br_ext_al_new(lin,lrk,lra)
      end do
    end if
    !do lrk=1,norb_dz
    !  if (lrk == lri) cycle
    !  if (lrk == lrj) cycle
    !  call drl_br_ext_al_new(lin,lrk,lra)
    !end do
  end do
end do

return

end subroutine tt_drl_act_br

subroutine st_drl_act_bl(lin,lra)
! st(2-5) (22)drl(12)-
! st(2-6) drl(22)-c"(12)-
! st(2-7) drl(12)-c"(22)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    !-------------------------------------------------------------------
    ! st(2-5) (22)drl(12)-
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_st(5)
    end do
    call drl_bl_ext_ar_new(lin,lrj,lra)
    ! st(2-6) drl(22)-c"(12)-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_st(6)
    end do
    call drl_bl_ext_ar_new(lin,lri,lra)
  end do
end do

return

end subroutine st_drl_act_bl

subroutine st_arbl_act_bl(lin,lra)

use gugaci_global, only: iml, imr, intind_ijka, ngw2, ngw3, norb_dz, norb_frz
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, lri, lrj, nk

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz-1
  do lrj=lri+1,norb_dz
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    call st1_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
    call st2_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
    call st4_ext(lri,lrj,nk,1)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
    call st4_ext(lri,lrj,nk,-1)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
  end do
end do

return

end subroutine st_arbl_act_bl

subroutine st_drl_act_br(lin,lra)
! st(2-5) (22)drl(12)-
! st(2-6) drl(22)-c"(12)-
! st(2-7) drl(12)-c"(22)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    !-------------------------------------------------------------------
    ! st(2-5) (22)drl(12)-
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_st(5)
    end do
    call drl_br_ext_al_new(lin,lrj,lra)
    ! st(2-6) drl(22)-c"(12)-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_st(6)
    end do
    call drl_br_ext_al_new(lin,lri,lra)
  end do
end do

return

end subroutine st_drl_act_br

subroutine st_arbl_act_br(lin,lra)

use gugaci_global, only: iml, imr, intind_ijka, ngw2, ngw3, norb_dz, norb_frz
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, lri, lrj, nk

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz-1
  do lrj=lri+1,norb_dz
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    call st1_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    call st2_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
    call st4_ext(lri,lrj,nk,1)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
    call st4_ext(lri,lrj,nk,-1)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
  end do
end do

return

end subroutine st_arbl_act_br

subroutine ss_arbl_act_br(lin,lra)
!=======================================================================
! ss(1-3)  ar(13)-bl(20)-
! ss(1-6)  (11)-ar(23)-bl(32)-
! ss(1-7)  ar(13)-c'(21)-bl(32)-
! ss(1-8)  ar(13)-c'(22)-bl(31)-
! ss(1-9)  ar(23)-c'(11)-bl(32)-
! ss(1-11) ar(13)-bl(31)-c"(22)-
! ss(1-12) ar(13)-bl(32)-c"(21)-
! ss(1-13) ar(23)-bl(31)-c"(12)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ngw2, ngw3, norb_dz, norb_frz
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, lri, lrj, nk

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  do lrj=lri+1,norb_dz
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    !-------------------------------------------------------------------
    call ss2_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    call ss4_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    call ss5_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
    call ss10_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
    call ss14_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
    !-------------------------------------------------------------------
  end do
end do

return

end subroutine ss_arbl_act_br

subroutine ss_drl_act_br(lin,lra)

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (jml == 1) then
    ! ss(1-20) drl(33)-c"(00)-
    iwdl = just(lri,lri)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(20)
      vplp_w1(mpl) = Zero
    end do
    if (lri > norb_dz) then
      call drl_br_sum_al_new(lin,lri,0,lri)
    else
      do lrk=1,norb_dz
        if (lrk == lri) cycle
        call drl_br_ext_al_new(lin,lrk,lra)
      end do
    end if
  end if
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    ! ss(1-15) (22)-drl(11)-
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(15)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(15)
    end do
    call drl_br_ext_al_new(lin,lrj,lra)
    ! ss(1-17) drl(22)-c"(11)-
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(17)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(17)
    end do
    call drl_br_ext_al_new(lin,lri,lra)
    ! ss(1-20) drl(33)-c"(22)-c"(11)-
    ! ss(1-20) (22)drl(33)-c"(11)-
    ! ss(1-20) (22)(11)drl(33)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(20)
      vplp_w1(mpl) = Zero
    end do
    if (lra > norb_dz) then
      call drl_br_sum_al_new(lin,lri,lrj,lra)
    else
      do lrk=1,norb_dz
        if (lrk == lri) cycle
        if (lrk == lrj) cycle
        call drl_br_ext_al_new(lin,lrk,lra)
      end do
    end if
  end do
end do

return

end subroutine ss_drl_act_br

subroutine ts_arbl_act_br(lin,lra)
!=======================================================================
! ts(3) a&r-b^l-  act -b&l ............................................

use gugaci_global, only: iml, imr, intind_ijka, ngw2, ngw3, norb_dz, norb_frz
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, lri, lrj, nk

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  do lrj=lri+1,norb_dz
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    call ts1_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    call ts2_ext(lri,lrj,nk,1)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
    call ts2_ext(lri,lrj,nk,-1)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
    call ts4_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_br_ext_al_new(lin,intpos,isma,nk)
  end do
end do

return

end subroutine ts_arbl_act_br

subroutine ts_arbl_act_bl(lin,lra)
!=======================================================================
! ts(3) a&r-b^l-  act -b&l ............................................

use gugaci_global, only: iml, imr, intind_ijka, ngw2, ngw3, norb_dz, norb_frz
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, lri, lrj, nk

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  do lrj=lri+1,norb_dz
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    call ts1_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
    call ts2_ext(lri,lrj,nk,1)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
    call ts2_ext(lri,lrj,nk,-1)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
    call ts4_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
  end do
end do

return

end subroutine ts_arbl_act_bl

subroutine ss_drl_act_bl(lin,lra)
!=======================================================================
! ss(1)    act -bl-
! ss(1-16) (11)-drl(22)-
! ss(1-17) drl(22)-c"(11)-
! ss(1-18) drl(11)-c"(22)-
! ss(1-19) drl(12)-c"(21)-
! ss(1-20) drl(33)-c"(11)-c"(22)-
! ss(1-20) (11)drl(33)-c"(22)-
! ss(1-20) (11)(22)drl(33)-
!=======================================================================

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (jml == 1) then
    ! ss(1-20) drl(33)-c"(00)-
    iwdl = just(lri,lri)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(20)
      vplp_w1(mpl) = Zero
    end do
    if (lra > norb_dz) then
      call drl_bl_sum_ar_new(lin,lri,0,lra)
    else
      do lrk=1,norb_dz
        if (lrk == lri) cycle
        call drl_bl_ext_ar_new(lin,lrk,lra)
      end do
    end if
    !do lrk=1,norb_dz
    !  if (lrk == lri) cycle
    !  call drl_bl_ext_ar_new(lin,lrk,lra)
    !end do
  end if
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    ! ss(1-15) (22)-drl(11)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(15)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(15)
    end do
    call drl_bl_ext_ar_new(lin,lrj,lra)
    ! ss(1-17) drl(22)-c"(11)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(17)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(17)
    end do
    call drl_bl_ext_ar_new(lin,lri,lra)
    ! ss(1-20) drl(33)-c"(22)-c"(11)-
    ! ss(1-20) (22)drl(33)-c"(11)-
    ! ss(1-20) (22)(11)-drl(33)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(20)
      vplp_w1(mpl) = Zero
    end do
    if (lra > norb_dz) then
      call drl_bl_sum_ar_new(lin,lri,lrj,lra)
    else
      do lrk=1,norb_dz
        if (lrk == lri) cycle
        if (lrk == lrj) cycle
        call drl_bl_ext_ar_new(lin,lrk,lra)
      end do
    end if
    !do lrk=1,norb_dz
    !  if (lrk == lri) cycle
    !  if (lrk == lrj) cycle
    !  call drl_bl_ext_ar_new(lin,lrk,lra)
    !end do
  end do
end do

return

end subroutine ss_drl_act_bl

subroutine ss_arbl_act_bl(lin,lra)
!=======================================================================
! ss(1)    act -bl-
! ss(1-3)  ar(13)-bl(20)-
! ss(1-6)  (11)-ar(23)-bl(32)-
! ss(1-7)  ar(13)-c'(21)-bl(32)-
! ss(1-8)  ar(13)-c'(22)-bl(31)-
! ss(1-9)  ar(23)-c'(11)-bl(32)-
! ss(1-11) ar(13)-bl(31)-c"(22)-
! ss(1-12) ar(13)-bl(32)-c"(21)-
! ss(1-13) ar(23)-bl(31)-c"(12)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ngw2, ngw3, norb_dz, norb_frz
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, lri, lrj, nk

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  do lrj=lri+1,norb_dz
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    call ss2_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
    call ss4_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
    call ss5_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
    call ss10_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
    call ss14_ext(lri,lrj,nk)
    if (nk /= 0) call ar_bl_bl_ext_ar_new(lin,intpos,isma,nk)
  end do
end do

return

end subroutine ss_arbl_act_bl

subroutine sd_ar_act_bl(lin,lra)
! sd(6-1) a&r(02)-
! sd(6-2) (22)a&(13)-
! sd(6-3) a&r(13)c'(22)-
! sd(6-4) a&r(23)c'(12)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd4
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd1 = w0_sd(1)
  w0sd2 = w0_sd(2)
  w0sd4 = w0_sd(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd4 = -w0sd4
  end if
  if ((jml == 1) .and. (lmi == jmr)) then
    ! sd(6-1) a&r(02)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
    end do
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end if
  ! sd(6-2) (22)a&(13)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
  end do
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end do
  ! sd(6-4) a&r(23)-c'(12)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd4
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end do
end do

return

end subroutine sd_ar_act_bl

subroutine sd_ar_act_blbl(lin,jk)
! sd(6-1) a&r(02)-
! sd(6-2) (22)a&(13)-
! sd(6-3) a&r(13)c'(22)-
! sd(6-4) a&r(23)c'(12)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd4
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  w0sd1 = w0_sd(1)
  w0sd2 = w0_sd(2)
  w0sd4 = w0_sd(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd4 = -w0sd4
  end if
  ! sd(6-1) a&r(02)-
  if ((jml == 1) .and. (lmi == jmr)) then
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
  end if
  !---------------------------------------------------------------------
  ! sd(6-2) c(22)a&(13)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
  end do
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
  end do
  !---------------------------------------------------------------------
  ! sd(6-4) a&r(23)c'(12)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd4
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
  end do
end do

return

end subroutine sd_ar_act_blbl

subroutine sd_ar_act_brbr(lin,jk)
! sd(6-1) a&r(02)-
! sd(6-2) (22)a&(13)-
! sd(6-3) a&r(13)c'(22)-
! sd(6-4) a&r(23)c'(12)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd4
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  w0sd1 = w0_sd(1)
  w0sd2 = w0_sd(2)
  w0sd4 = w0_sd(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd4 = -w0sd4
  end if
  ! sd(6-1) a&r(02)-
  if ((jml == 1) .and. (lmi == jmr)) then
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_br_ext_ar_new(lin,intpos,isma)
  end if
  !---------------------------------------------------------------------
  ! sd(6-2) c(22)a&(13)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
  end do
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_br_ext_ar_new(lin,intpos,isma)
  end do
  !---------------------------------------------------------------------
  ! sd(6-4) a&r(23)c'(12)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd4
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_br_ext_ar_new(lin,intpos,isma)
  end do
end do

return

end subroutine sd_ar_act_brbr

subroutine sd_ar_act_blbr(lin,jk)
! sd(6-1) a&r(02)-
! sd(6-2) (22)a&(13)-
! sd(6-3) a&r(13)c'(22)-
! sd(6-4) a&r(23)c'(12)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd4
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  w0sd1 = w0_sd(1)
  w0sd2 = w0_sd(2)
  w0sd4 = w0_sd(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd4 = -w0sd4
  end if
  ! sd(6-1) a&r(02)-
  if ((jml == 1) .and. (lmi == jmr)) then
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end if
  !---------------------------------------------------------------------
  ! sd(6-2) c(22)a&(13)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
  end do
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end do
  !---------------------------------------------------------------------
  ! sd(6-4) a&r(23)c'(12)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd4
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end do
end do

return

end subroutine sd_ar_act_blbr

subroutine sd_ar_act_dlr(lin,lra)
! sd(6-1) a&r(02)-
! sd(6-2) (22)a&(13)-
! sd(6-3) a&r(13)c'(22)-
! sd(6-4) a&r(23)c'(12)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd4
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd1 = w0_sd(1)
  w0sd2 = w0_sd(2)
  w0sd4 = w0_sd(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd4 = -w0sd4
  end if
  ! sd(6-1) a&r(02)-
  if ((jml == 1) .and. (lmi == jmr)) then
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end if
  !---------------------------------------------------------------------
  ! sd(6-2) c(22)a&(13)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
  end do
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end do
  !---------------------------------------------------------------------
  ! sd(6-4) a&r(23)c'(12)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd4
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end do
end do

return

end subroutine sd_ar_act_dlr

subroutine td_ar_act_bl(lin,lra)
! td(13-1) (22)a(23)
! td(13-1) a(23)c'(22)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_td
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_td(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1
  !---------------------------------------------------------------------
  ! td(13-1) (22)a(23)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end do
  !---------------------------------------------------------------------
  ! td(13-1) a(23)c'(22)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end do
end do

return

end subroutine td_ar_act_bl

subroutine td_ar_act_brbr(lin,jk)
! td(13-1) (22)a(23)
! td(13-1) a(23)c'(22)

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_td
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_td(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  !---------------------------------------------------------------------
  ! td(13-1) (22)a(23)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_br_ext_ar_new(lin,intpos,isma)
  end do
  !---------------------------------------------------------------------
  ! td(13-1) a(23)c'(22)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_br_ext_ar_new(lin,intpos,isma)
  end do
end do

return

end subroutine td_ar_act_brbr

subroutine td_ar_act_blbl(lin,jk)
! td(13-1) (22)a(23)
! td(13-1) a(23)c'(22)

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_td
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_td(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  !---------------------------------------------------------------------
  ! td(13-1) (22)a(23)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
  end do
  !---------------------------------------------------------------------
  ! td(13-1) a(23)c'(22)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
  end do
end do

return

end subroutine td_ar_act_blbl

subroutine td_ar_act_blbr(lin,jk)
! td(13-1) (22)a(23)
! td(13-1) a(23)c'(22)

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_td
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_td(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  !---------------------------------------------------------------------
  ! td(13-1) (22)a(23)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end do
  !---------------------------------------------------------------------
  ! td(13-1) a(23)c'(22)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end do
end do

return

end subroutine td_ar_act_blbr

subroutine td_ar_act_dlr(lin,lra)
! td(13-1) (22)a(23)
! td(13-1) a(23)c'(22)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_td
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_td(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1
  !---------------------------------------------------------------------
  ! td(13-1) (22)a(23)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end do
  !---------------------------------------------------------------------
  ! td(13-1) a(23)c'(22)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end do
end do

return

end subroutine td_ar_act_dlr

subroutine dd_drl_act_bl(lin,lra)
! dd(19-2) drl(22)-
! dd(19-3) drl(33)-c"(22)-
! dd(19-3) (22)drl(33)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dd, w1_dd
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lml, lrk, lrl, mpl
real(kind=wp) :: w0, w1
integer(kind=iwp), external :: iwalk_ad

do lrl=norb_frz+1,norb_dz
  lml = lsm_inn(lrl)
  if (lml /= jml) cycle
  !---------------------------------------------------------------------
  iwdl = jud(lrl)
  iwdr = iwdl
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  w0 = w0_dd(2)
  w1 = w1_dd(2)
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1
  end do
  call drl_bl_ext_ar_new(lin,lrl,lra)

  w0 = w0_dd(3)
  w1 = Zero
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1
  end do
  if (lra > norb_dz) then
    call drl_bl_sum_ar_new(lin,lrl,0,lra)
  else
    do lrk=1,norb_dz
      if (lrk == lrl) cycle
      call drl_bl_ext_ar_new(lin,lrk,lra)
    end do
  end if
  !do lrk=1,norb_dz
  !  if (lrk == lrl) cycle
  !  call drl_bl_ext_ar_new(lin,lrk,lra)
  !end do
end do

return

end subroutine dd_drl_act_bl

subroutine dd_drl_act_br(lin,lra)
! dd(19-2) drl(22)-
! dd(19-3) drl(33)-c"(22)-
! dd(19-3) (22)drl(33)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dd, w1_dd
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lml, lrk, lrl, mpl
real(kind=wp) :: w0, w1
integer(kind=iwp), external :: iwalk_ad

do lrl=norb_frz+1,norb_dz
  lml = lsm_inn(lrl)
  if (lml /= jml) cycle
  !---------------------------------------------------------------------
  iwdl = jud(lrl)
  iwdr = iwdl
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  w0 = w0_dd(2)
  w1 = w1_dd(2)
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1
  end do
  call drl_br_ext_al_new(lin,lrl,lra)

  w0 = w0_dd(3)
  w1 = Zero
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1
  end do
  do lrk=1,norb_dz
    if (lrk == lrl) cycle
    call drl_br_ext_al_new(lin,lrk,lra)
  end do
end do

return

end subroutine dd_drl_act_br

subroutine dd_arbl_act_bl(lin,lra)
! dd(19-1) a&r(23)-b&l(32)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dd, &
                         w1_dd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lml, lmr, lrl, lrr, mpl, ni
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lrl=norb_frz+1,norb_dz-1
  lml = lsm_inn(lrl)
  if (lml /= jml) cycle
  do lrr=lrl+1,norb_dz
    lmr = lsm_inn(lrr)
    if (lmr /= jmr) cycle
    ijk = lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    w0dd1 = w0_dd(1)
    w1dd1 = w1_dd(1)
    ni = mod(lrr-lrl,2)
    if (ni == 0) w0dd1 = -w0_dd(1)
    if (ni == 0) w1dd1 = -w1_dd(1)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
    end do

    iwdl = jud(lrl)
    iwdr = jud(lrr)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
    !-------------------------------------------------------------------
  end do
end do

return

end subroutine dd_arbl_act_bl

subroutine dd_arbl_act_br(lin,lra)
! dd(19-1) a&r(23)-b&l(32)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dd, w1_dd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lml, lmr, lrl, lrr, mpl, ni
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lrl=norb_frz+1,norb_dz-1
  lml = lsm_inn(lrl)
  if (lml /= jml) cycle
  do lrr=lrl+1,norb_dz
    lmr = lsm_inn(lrr)
    if (lmr /= jmr) cycle
    ijk = lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    w0dd1 = w0_dd(1)
    w1dd1 = w1_dd(1)
    ni = mod(lrr-lrl,2)
    if (ni == 0) w0dd1 = -w0_dd(1)
    if (ni == 0) w1dd1 = -w1_dd(1)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
    end do

    iwdl = jud(lrl)
    iwdr = jud(lrr)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    !-------------------------------------------------------------------
  end do
end do

return

end subroutine dd_arbl_act_br

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine TwoEl_mck(Coor,nRys,Hess,nHess,IfGrd,IndGrd,IfHss,IndHss,IfG,PSO,nijkl,nPSO,Work2,nWork2,Work3,nWork3,Work4,nWork4,Aux, &
                     nAux,WorkX,nWorkX,Fin,nfin,Temp,nTemp,nTwo2,nFt,TwoHam,Buffer,nBuffer,lgrad,ldot,n8,ltri,Dan,Din,moip,naco, &
                     rMOIN,nMOIN,iSD4)
!***********************************************************************
!                                                                      *
!     Input:                                                           *
!     PSO                                                              *
!     Work2                                                            *
!     Work3                                                            *
!     Work4                                                            *
!     AUX                                                              *
!     Fin    : Area for cntrctd int in sph hmn                         *
!     Temp   : Working place for F gen and n8                          *
!     TwoHam : Final results fock matrix and MO's                      *
!                                                                      *
!     Object:      To construct the first order derivatives of the AO- *
!     integrals and add them up to the MO derivatives and              *
!     the Fock matrix derivatives and contract the second              *
!     order derivatives of the AO's with the second order              *
!     density matrix.                                                  *
!                                                                      *
!     Authors: Roland Lindh, IBM Almaden Research Center, San Jose, CA *
!     March '90                                                        *
!     Anders Bernhardsson Theoretical Chemistry 95                     *
!***********************************************************************
!                                                                      *
!     When we are calculating the second order derivatives we need     *
!     the derivatives of the two electron integrals in three ways:     *
!                                                                      *
!     (2)                                                              *
!     1)  To calculate the static term H                               *
!     -                                                                *
!     2)  To calculate the non-zero part of <0|[E  ,H]|0>              *
!     pq                                                               *
!                                                                      *
!                                                                      *
!     3)  To calculate the derivatives of the MO orbitals with all     *
!     four indexes in the active space.                                *
!                                                                      *
!     In this implementation all contributions are calculated at       *
!     the same time.                                                   *
!                                                                      *
!     (2)                                                              *
!     The H    is calculated by contracting the second order           *
!     derivatives on the flight with the second order density matrix   *
!                                                                      *
!     (1)  (1)       (1)                                               *
!     the    F  - F    and MO     are calculated by first contracting  *
!     pq   qp                                                          *
!                                                                      *
!     the primitives and transform the integrals to  spherical         *
!     harmonics and then construct the Fock matrix as a direct SCF     *
!     The Fock matrixes is transformed to MO base and then added up to *
!     total Fock matrix                                                *
!                                                                      *
!***********************************************************************

use McKinley_global, only: CPUStat, nIntegrals, nScreen, nTrans, nTwoDens, PreScr
use iSD_data, only: nSD
use Index_Functions, only: iTri, nTri_Elem1
use k2_structure, only: Indk2, k2_type, k2Data
use k2_arrays, only: BraKet, DeDe, DeDe2
use Real_Spherical, only: ipSph, RSph
use Basis_Info, only: Shells
use Phase_Info, only: iPhase
use Gateway_Info, only: CutInt
use Symmetry_Info, only: nIrrep
use Rys_interfaces, only: cff2d_kernel, modu2_kernel, tval1_kernel
use Dens_stuff, only: ipDDij, ipDDij2, ipDDik, ipDDik2, ipDDil, ipDDil2, ipDDjk, ipDDjk2, ipDDjl, ipDDjl2, ipDDkl, ipDDkl2, &
                      mDCRij, mDCRik, mDCRil, mDCRjk, mDCRjl, mDCRkl, mDij, mDik, mDil, mDjk, mDjl, mDkl
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nRys, nHess, IndGrd(3,4,0:7), IndHss(4,3,4,3,0:7), nijkl, nPSO, nWork2, nWork3, nWork4, nAux, &
                                 nWorkX, nfin, nTemp, nTwo2, nFt, nBuffer, moip(0:7), naco, nMOIN, iSD4(0:nSD,4)
real(kind=wp), intent(in) :: Coor(3,4), PSO(nijkl,nPSO), Dan(*), Din(*)
real(kind=wp), intent(inout) :: Hess(nHess), WorkX(nWorkX), TwoHam(nTwo2), Buffer(nBuffer), rMOIN(nMOIN)
logical(kind=iwp), intent(in) :: IfGrd(3,4), IfHss(4,3,4,3), lgrad, ldot, n8, ltri
logical(kind=iwp), intent(out) :: IfG(4)
real(kind=wp), intent(out) :: Work2(nWork2), Work3(nWork3), Work4(nWork4), Aux(nAux), Fin(nfin), Temp(nTemp)
integer(kind=iwp) :: iAngV(4), iAO(4), iAOst(4), iBasi, iCar, iCmp(4), iCmpa, iCNT, iDCRR(0:7), iDCRS(0:7), iDCRT(0:7), iDCRTS, &
                     iEta, iIrr, ijS, ik2, IncEta, IncZet, Indx(3,4), ip, ip2, ipFT, ipS1, ipS2, ipTemp, iS, iShell(4), iShll(4), &
                     iShlla, iuvwx(4), ix2, iy2, iz2, iZeta, jBasj, jCmpb, jk2, JndGrd(3,4,0:7), JndHss(4,3,4,3,0:7), jPrInc, jS, &
                     jShllb, kBask, kCmpc, klS, kS, kShllc, la, lb, lBasl, lc, lCmpd, ld, lDCR1, lDCR2, lDCRR, lDCRS, lDCRT, lEta, &
                     lPrInc, lS, lShlld, lZeta, mab, mcd, mEta, mZeta, n, nabcd, nAlpha, nBeta, nDCR1, nDCR2, nDCRR, nDCRS, nDCRT, &
                     nDelta, nEta, nEta_Tot, nGamma, nGr, niag, nOp(4), nS1, nS2, nTe, nw3, nw3_2, nZeta, nZeta_Tot
real(kind=wp) :: CoorAC(3,2), CoorM(3,4), dum1, dum2, dum3, Fact, Time
logical(kind=iwp) :: ABeqCD, AeqB, AeqC, CeqD, first, JfGrd(3,4), JfHss(4,3,4,3), l_og, ldot2, Tr(4), Shijij
procedure(cff2d_kernel) :: Cff2D
procedure(modu2_kernel) :: ModU2
procedure(tval1_kernel) :: TERI1
type(k2_type), pointer :: k2data1(:), k2data2(:)
real(kind=wp), pointer :: Coeff1(:,:), Coeff2(:,:), Coeff3(:,:), Coeff4(:,:), Dij1(:,:), Dij2(:,:), Dik1(:,:), Dik2(:,:), &
                          Dil1(:,:), Dil2(:,:), Djk1(:,:), Djk2(:,:), Djl1(:,:), Djl2(:,:), Dkl1(:,:), Dkl2(:,:)
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ

!                                                                      *
!***********************************************************************
!                                                                      *
! PROLOGUE
!                                                                      *
!***********************************************************************
!                                                                      *
jPrInc = iSD4(6,2)
lPrInc = iSD4(6,4)

iAO(:) = iSD4(7,:)
iCmp(:) = iSD4(2,:)
iShll(:) = iSD4(0,:)
iShell(:) = iSD4(11,:)
iAngV(:) = iSD4(1,:)
iAOst(:) = iSD4(8,:)

nAlpha = iSD4(5,1)
nBeta = iSD4(5,2)
nGamma = iSD4(5,3)
nDelta = iSD4(5,4)

iBasi = iSD4(19,1)
jBasj = iSD4(19,2)
kBask = iSD4(19,3)
lBasl = iSD4(19,4)

nZeta = iSD4(5,1)*iSD4(5,2)
nEta = iSD4(5,3)*iSD4(5,4)

Shijij = ((iSD4(11,1) == iSD4(11,3)) .and. (iSD4(11,2) == iSD4(11,4)))

nGr = 0
ldot2 = ldot
la = iAngV(1)
lb = iAngV(2)
lc = iAngV(3)
ld = iAngV(4)
iCmpa = iCmp(1)
jCmpb = iCmp(2)
kCmpc = iCmp(3)
lCmpd = iCmp(4)
iShlla = iShll(1)
jShllb = iShll(2)
kShllc = iShll(3)
lShlld = iShll(4)
IncZet = nAlpha*jPrInc
IncEta = nGamma*lPrInc
nabcd = iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)
mab = nTri_Elem1(la)*nTri_Elem1(lb)
mcd = nTri_Elem1(lc)*nTri_Elem1(ld)

! Scratch space for Fock Matrix construction

ip = 1
ipS1 = ip
nS1 = nijkl*nabcd
ip = ip+nS1
ipS2 = ip
nS2 = max(nS1,nijkl+max(iBasi*lBasl,jBasj*lBasl,iBasi*kBask,jBasj*kBask))
ip = ip+nS2
ipFT = ip
ip = ip+nFT
ipTemp = ip
nTe = nijkl*nabcd
ip = ip+nTe
if (ip-1 > nTemp) then
  write(u6,*) 'TwoEl_McK: ip-1 > nTemp'
  write(u6,*) 'ip,nTemp=',ip,nTemp
  call Abend()
end if
#ifdef _WARNING_WORKAROUND_
! Avoid some warnings about unset output arguments
Temp(nTemp) = One
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Pick up pointers to k2 entities.

iS = iShell(1)
jS = iShell(2)
kS = iShell(3)
lS = iShell(4)
ijS = iTri(iS,jS)
klS = iTri(kS,lS)
nDCR1 = IndK2(2,ijS)
ik2 = IndK2(3,ijS)
nDCR2 = IndK2(2,klS)
jk2 = IndK2(3,klS)
k2data1(1:nDCR1) => k2Data(1:nDCR1,ik2)
k2data2(1:nDCR2) => k2Data(1:nDCR2,jk2)

Coeff1(1:nAlpha,1:iBasi) => Shells(iShll(1))%pCff(:,iAOst(1)+1:)
Coeff2(1:nBeta,1:jBasj) => Shells(iShll(2))%pCff(:,iAOst(2)+1:)
Coeff3(1:nGamma,1:kBask) => Shells(iShll(3))%pCff(:,iAOst(3)+1:)
Coeff4(1:nDelta,1:lBasl) => Shells(iShll(4))%pCff(:,iAOst(4)+1:)

if (lbound(DeDe,1) >= 1) then
  Dij1(1:mDij,1:mDCRij) => DeDe(ipDDij:ipDDij+mDij*mDCRij-1)
  Dkl1(1:mDkl,1:mDCRkl) => DeDe(ipDDkl:ipDDkl+mDkl*mDCRkl-1)
  Dik1(1:mDik,1:mDCRik) => DeDe(ipDDik:ipDDik+mDik*mDCRik-1)
  Dil1(1:mDil,1:mDCRil) => DeDe(ipDDil:ipDDil+mDil*mDCRil-1)
  Djk1(1:mDjk,1:mDCRjk) => DeDe(ipDDjk:ipDDjk+mDjk*mDCRjk-1)
  Djl1(1:mDjl,1:mDCRjl) => DeDe(ipDDjl:ipDDjl+mDjl*mDCRjl-1)
else
  ! dummy associations
  Dij1(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Dkl1(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Dik1(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Dil1(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Djk1(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Djl1(1:1,1:1) => DeDe(lbound(DeDe,1):)
end if

if (lbound(DeDe2,1) >= 1) then
  Dij2(1:mDij,1:mDCRij) => DeDe2(ipDDij2:ipDDij2+mDij*mDCRij-1)
  Dkl2(1:mDkl,1:mDCRkl) => DeDe2(ipDDkl2:ipDDkl2+mDkl*mDCRkl-1)
  Dik2(1:mDik,1:mDCRik) => DeDe2(ipDDik2:ipDDik2+mDik*mDCRik-1)
  Dil2(1:mDil,1:mDCRil) => DeDe2(ipDDil2:ipDDil2+mDil*mDCRil-1)
  Djk2(1:mDjk,1:mDCRjk) => DeDe2(ipDDjk2:ipDDjk2+mDjk*mDCRjk-1)
  Djl2(1:mDjl,1:mDCRjl) => DeDe2(ipDDjl2:ipDDjl2+mDjl*mDCRjl-1)
else
  ! dummy associations
  Dij2(1:1,1:1) => DeDe2(lbound(DeDe2,1):)
  Dkl2(1:1,1:1) => DeDe2(lbound(DeDe2,1):)
  Dik2(1:1,1:1) => DeDe2(lbound(DeDe2,1):)
  Dil2(1:1,1:1) => DeDe2(lbound(DeDe2,1):)
  Djk2(1:1,1:1) => DeDe2(lbound(DeDe2,1):)
  Djl2(1:1,1:1) => DeDe2(lbound(DeDe2,1):)
end if

!                                                                      *
!***********************************************************************
!                                                                      *
!           - - - - - - END PROLOGUE - - - - - -
!                                                                      *
!***********************************************************************
!                                                                      *
call mk_DCRs_and_Stabilizers(Fact,iuvwx,nDCRR,nDCRS,nDCRT,iDCRR,iDCRS,iDCRT,nSD,iSD4)
!                                                                      *
!***********************************************************************
!                                                                      *
! - - - - Loop over first set
!                                                                      *
!***********************************************************************
!                                                                      *
nOp(1) = NrOpr(0)
CoorM(:,1) = Coor(:,1)
do lDCRR=0,nDCRR-1
  nOp(2) = NrOpr(iDCRR(lDCRR))
  call OA(iDCRR(lDCRR),Coor(1:3,2),CoorM(1:3,2))
  AeqB = EQ(CoorM(1,1),CoorM(1,2))
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! - - - - Loop over second set
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do lDCRS=0,nDCRS-1
    Coorm(:,3) = Coor(:,3)
    call OA(iDCRS(lDCRS),Coor(1:3,4),CoorM(1:3,4))
    CeqD = EQ(Coor(1,3),CoorM(1,4))
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! - - - - Loop over third set
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    do lDCRT=nDCRT-1,0,-1

      nOp(3) = NrOpr(iDCRT(lDCRT))
      nOp(4) = NrOpr(ieor(iDCRT(lDCRT),iDCRS(lDCRS)))

      iDCRTS = ieor(iDCRT(lDCRT),iDCRS(lDCRS))
      call OA(iDCRTS,Coor(1:3,4),CoorM(1:3,4))
      call OA(iDCRT(lDCRT),Coor(1:3,3),CoorM(1:3,3))

      AeqC = EQ(CoorM(1,1),CoorM(1,3))
      ABeqCD = AeqB .and. CeqD .and. AeqC
      ! No contribution to geometric derivatives from one-center integrals
      if (ABeqCD) cycle

      ! Find the proper centers to start of with the angular
      ! momentum on. If la == lb there will exist an
      ! ambiguity to which center that angular momentum should
      ! be accumulated on. In that case we will use A and C of
      ! the order as defined by the basis functions types.

      if (iAngV(1) >= iAngV(2)) then
        CoorAC(:,1) = CoorM(:,1)
      else
        CoorAC(:,1) = CoorM(:,2)
      end if
      if (iAngV(3) >= iAngV(4)) then
        CoorAC(:,2) = CoorM(:,3)
      else
        CoorAC(:,2) = CoorM(:,4)
      end if

      ! Calculate the desymmetrized two-electron density matrix in cartesian AO base.

      call Timing(dum1,Time,dum2,dum3)
      if (ldot2) call TwoDns(iAngV,iCmp,shijij,ishll,ishell,iAO,nOp,iBasi,jBasj,kBask,lBasl,Aux,nAux,Work2,nWork2,Work3,nWork3, &
                             Work4,nWork4,PSO,nPSO,Fact)

      call Timing(dum1,Time,dum2,dum3)
      CpuStat(nTwoDens) = CpuStat(nTwoDens)+Time
      !----------------------------------------------------------------*
      !
      ! Fix the control matrices for derivatives and try to use
      ! translation invariance as efficiently as possible.
      !
      !----------------------------------------------------------------*
      JfHss(:,:,:,:) = IfHss
      JfGrd(:,:) = IfGrd
      ifg(:) = .true.
      Tr(:) = .false.
      JndHss(:,:,:,:,0:nIrrep-1) = IndHss(:,:,:,:,0:nIrrep-1)
      JndGrd(:,:,0:nIrrep-1) = IndGrd(:,:,0:nIrrep-1)

      ! Delete one center that should be calculated with translation invariance

      call Translation(ifg,jfgrd,jfhss,tr,jndgrd,jndhss,coorm,nirrep,indgrd,indhss)

      if (.not. ldot) then
        JfHss(:,:,:,:) = .false.
        JndHss(:,:,:,:,:) = 0
      end if

      !----------------------------------------------------------------*
      !
      ! Loops to partition the primitives
      !
      !----------------------------------------------------------------*
      lDCR1 = NrOpr(iDCRR(lDCRR))+1
      lDCR2 = NrOpr(iDCRS(lDCRS))+1
      ix2 = iPhase(1,iDCRT(lDCRT))
      iy2 = iPhase(2,iDCRT(lDCRT))
      iz2 = iPhase(3,iDCRT(lDCRT))

      nZeta_Tot = k2Data1(lDCR1)%IndZ(nZeta+1)
      nEta_Tot = k2Data2(lDCR2)%IndZ(nEta+1)

      first = .true.
      nGr = 0
      do iZeta=1,nZeta_Tot,IncZet
        mZeta = min(IncZet,nZeta_Tot-iZeta+1)
        ! Check that subblock of contraction matrix has non-zero elements.
        if (all(Coeff2(:,:) == Zero)) cycle
        do iEta=1,nEta_Tot,IncEta
          mEta = min(IncEta,nEta_Tot-iEta+1)
          ! Check that subblock of contraction matrix has non-zero elements.
          if (all(Coeff4(:,:) == Zero)) cycle
          !------------------------------------------------------------*
          !     PRE PRESCREENING                                       *
          !------------------------------------------------------------*

          lZeta = mZeta
          lEta = mEta

          ! Decontract the 2nd order density matrix

          ! Work4->Work2  Work3:scratch
          call Timing(dum1,Time,dum2,dum3)
          if (ldot2) call Tcrtnc_h(Coeff1,nAlpha,iBasi,Coeff2,nBeta,jBasj,Coeff3,nGamma,kBask,Coeff4,nDelta,lBasl, &
                                   Work4,mab*mcd,Work3,nWork3/2,Work2, &
                                   k2Data1(lDCR1)%IndZ(iZeta:iZeta+mZeta-1),mZeta, &
                                   k2Data2(lDCR2)%IndZ(iEta:iEta+mEta-1),mEta)
          call Timing(dum1,Time,dum2,dum3)
          CPUStat(nTwoDens) = CPUStat(nTwoDens)+Time

          ! Transfer k2 data and prescreen

          ! Work2:PAO-> Work2
          ! Work3 Scratch
          call Timing(dum1,Time,dum2,dum3)
          call Screen_mck(iZeta-1,iEta-1,Work2,Work3,mab*mcd,nZeta,nEta,mZeta,mEta,lZeta,lEta, &
                          k2Data1(lDCR1),k2Data2(lDCR2), &
                          BraKet%Zeta,BraKet%ZInv,BraKet%P,BraKet%xA,BraKet%xB,BraKet%KappaAB, &
                          BraKet%Eta,BraKet%EInv,BraKet%Q,BraKet%xG,BraKet%xD,BraKet%KappaCD, &
                          BraKet%xpre,1,1,1,ix2,iy2,iz2,CutInt,PreScr,Braket%IndZet,Braket%IndEta,ldot2)
          call Timing(dum1,Time,dum2,dum3)
          CPUStat(nScreen) = CPUStat(nScreen)+Time

          if (lZeta*lEta == 0) cycle

          ! Compute integral derivative and accumulate
          ! contribution to the molecular gradient.

          ! Work2:PAO
          ! Work3:Work area  The PO integrals are stored in the begining of Work3

          call Timing(dum1,Time,dum2,dum3)

          call Rysg2(iAngV,nRys,lZeta*lEta,BraKet%xA,BraKet%xB,BraKet%xG,BraKet%xD,BraKet%Zeta,BraKet%ZInv,lZeta,BraKet%Eta, &
                     BraKet%EInv,lEta,BraKet%P,nZeta,BraKet%Q,nEta,CoorM,CoorM,CoorAC,Work3,nWork3,TERI1,ModU2,Cff2D,Work2, &
                     mab*mcd,Hess,nHess,JfGrd,JndGrd,JfHss,JndHss,nOp,iuvwx,IfG,nGr,Indx,lgrad,ldot,Tr)
          call Timing(dum1,Time,dum2,dum3)
          CPUStat(nIntegrals) = CPUStat(nIntegrals)+Time

          ! Work3 AO
          ! Work3_3  Scratch
          ! ->    Work3_2
          !------------------------------------------------------------*
          !
          ! Transform integrals to AO base
          !
          !------------------------------------------------------------*
          ip2 = nGr*mab*mcd*lZeta*lEta+1
          call Timing(dum1,Time,dum2,dum3)
          call Cntrct_mck(First,Coeff1,nAlpha,iBasi,Coeff2,nBeta,jBasj,Coeff3,nGamma,kBask,Coeff4,nDelta,lBasl,Work3,nGr*mab*mcd, &
                          Work3(ip2),nwork3-ip2,BraKet%xpre,WorkX,nWorkX,lZeta*lEta,BraKet%IndZet,nZeta,lZeta,BraKet%IndEta,nEta, &
                          lEta)
        end do
      end do

      ! Mark which derivatives should be calculated with translation invariance.

      if (nGr == 0) cycle
      do iCNT=1,4
        if (Tr(iCnt)) then
          do iCar=1,3
            l_og = .false.
            do iIrr=0,nIrrep-1
              l_og = l_og .or. (indgrd(iCar,iCnt,iIrr) /= 0)
            end do
            if (l_og) Indx(iCar,iCnt) = -1
          end do
        end if
      end do

      if (Fact /= One) then
        n = nGr*mab*mcd*nijkl
        WorkX(1:n) = Fact*WorkX(1:n)
      end if

      !----------------------------------------------------------------*
      !
      !     Transpose abcd,g,IJKL -> bcd,g,IJKL,A Work3 -> Work3_2
      !
      !----------------------------------------------------------------*

      niag = nijkl*nTri_Elem1(lb)*mcd*nGr
      call CrSph_mck(WorkX,niag,nTri_Elem1(la),RSph(ipSph(la)),la,Shells(iShlla)%Transf,Shells(iShlla)%Prjct,Work3,iCmpa)
      nw3 = niag*iCmpa
      ip2 = 1+nw3

      !----------------------------------------------------------------*
      !
      !     Transpose   bcd,g,IJKL,A -> cd,g,IJKL,AB Work3_2->Work3
      !
      !----------------------------------------------------------------*

      niag = nijkl*mcd*nGr*iCmpa
      nw3_2 = niag*jCmpb
      if (nw3+nw3_2 > nWork3) then
        write(u6,*) '1: nw3+nw3_2 > nWork3'
        call Abend()
      end if
      call CrSph_mck(Work3,niag,nTri_Elem1(lb),RSph(ipSph(lb)),lb,Shells(jShllb)%Transf,Shells(jShllb)%Prjct,Work3(ip2),jCmpb)

      !----------------------------------------------------------------*
      !
      !     Transpose  cd,g,IJKL,AB -> d,g,IJKL,ABC  Work3->Work3_2
      !
      !----------------------------------------------------------------*

      niag = nijkl*nGr*nTri_Elem1(ld)*iCmpa*jCmpb
      call CrSph_mck(Work3(ip2),niag,nTri_Elem1(lc),RSph(ipSph(lc)),lc,Shells(kShllc)%Transf,Shells(kShllc)%Prjct,Work3,kCmpc)
      if (niag*kCmpc > nw3) then
        write(u6,*) 'niag*kCmpc > nw3'
        call Abend()
      end if
      nw3 = niag*kCmpc
      ip2 = nw3+1

      !----------------------------------------------------------------*
      !
      !     Transpose   d,g,IJKL,ABC -> g,IJKL,ABCD Work3_2->Work3
      !
      !----------------------------------------------------------------*

      niag = nijkl*nGr*iCmpa*jCmpb*kCmpc
      nw3_2 = niag*lCmpd
      if (nw3+nw3_2 > nWork3) then
        write(u6,*) '2: nw3+nw3_2 > nWork3'
        call Abend()
      end if
      call CrSph_mck(Work3,niag,nTri_Elem1(ld),RSph(ipSph(ld)),ld,Shells(lShlld)%Transf,Shells(lShlld)%Prjct,Work3(ip2),lCmpd)

      !----------------------------------------------------------------*
      !
      !     Transpose g,IJKL,ABCD -> IJKL,ABCD,g Work3->Buffer
      !
      !----------------------------------------------------------------*

      niag = nijkl*iCmpa*jCmpb*kCmpc*lCmpd
      call DGetMO(Work3(ip2),nGr,nGr,niag,Fin,niag)

      ! DEBUG  (calculates gradient from transformed integrals)

      call Timing(dum1,Time,dum2,dum3)
      CPUStat(nTrans) = CPUStat(nTrans)+Time

      !----------------------------------------------------------------*
      !
      !     Send the integrals to clrbuffer for construction of
      !
      !----------------------------------------------------------------*

      call ClrBuf(idcrr(ldcrr),idcrs(ldcrs),idcrt(ldcrt),nGr,Shijij,iAngV,iCmp,iShll,iShell,iShell,iBasi,jBasj,kBask,lBasl,Dij1, &
                  Dij2,mDij,mDCRij,Dkl1,Dkl2,mDkl,mDCRkl,Dik1,Dik2,mDik,mDCRik,Dil1,Dil2,mDil,mDCRil,Djk1,Djk2,mDjk,mDCRjk,Djl1, &
                  Djl2,mDjl,mDCRjl,fin,nfin,Temp(ipFT),nFT,Temp(ipS1),nS1,Temp(ipS2),nS2,Temp(ipTemp),nTe,TwoHam,nTwo2,JndGrd, &
                  Indx,iao,iaost,iuvwx,n8,ltri,moip,nAcO,rMoin,nmoin,ntemp,Buffer,nOp,Din,Dan)

    end do

  end do

end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Twoel_Mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE REFCI(HREF,AREF,EREF,ICSPCK,CISEL,PLEN)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION HREF((NREF*(NREF+1))/2),AREF(NREF,NREF),EREF(NREF)
      DIMENSION PLEN(NREF),CISEL(NREF,NSEL),ICSPCK(NCSPCK)
      CHARACTER*2 STR
      CHARACTER*48 FORM1,FORM2,FORM3,FORM4
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CPAM97      JCASE(L)=UNPACK(CSPCK((L+29)/30), 2*L-(2*L-1)/60*60, 2)
      JCASE(L)=ICUNP(ICSPCK,L)
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,*)('-',I=1,60)
      CALL XFLUSH(6)
      WRITE(6,*)'   REFERENCE CI CALCULATION.'
      CALL XFLUSH(6)
      WRITE(6,*)('-',I=1,60)
      CALL XFLUSH(6)
      IF(NSEL.EQ.0) THEN
        WRITE(6,*)' ROOT SELECTION BY ENERGY ORDERING.'
      CALL XFLUSH(6)
        IF(NRROOT.EQ.1) THEN
          WRITE(6,'(A,I8)')'  ONE SINGLE ROOT, NUMBER.....: ',IROOT(1)
      CALL XFLUSH(6)
        ELSE
          WRITE(6,*)' THE FOLLOWING ROOTS WILL BE SELECTED:'
      CALL XFLUSH(6)
          WRITE(6,'(12(A,I2))') ' ROOTS NR ',IROOT(1),
     *                           (',',IROOT(I),I=2,NRROOT-1),
     *                          ', AND ',IROOT(NRROOT)
      CALL XFLUSH(6)
        END IF
      ELSE
        WRITE(6,*)' ROOT SELECTION BY PROJECTION: THE EIGENVECTORS OF'
      CALL XFLUSH(6)
        WRITE(6,*)' THE REFERENCE CI ARE ORDERED BY DECREASING SIZE OF'
      CALL XFLUSH(6)
        WRITE(6,*)' THEIR PROJECTIONS ONTO A SELECTION SPACE.'
      CALL XFLUSH(6)
        IF(NRROOT.EQ.1) THEN
          WRITE(6,*)' SELECT THE EIGENVECTOR WITH LARGEST PROJECTION.'
      CALL XFLUSH(6)
        ELSE
          WRITE(6,'(A,I2,A)')' SELECT THE ',NRROOT,
     *              ' EIGENVECTORS WITH LARGEST PROJECTION.'
      CALL XFLUSH(6)
        END IF
        WRITE(6,*)' THE SELECTION SPACE IS SPANNED BY THE FOLLOWING',
     *            ' VECTORS (NONZERO COMPONENTS ONLY):'
      CALL XFLUSH(6)
        JJ=0
        DO 1234 I=1,NSEL
          WRITE(6,'(A,I2)') ' VECTOR NR. ',I
      CALL XFLUSH(6)
          NC=NCOMP(I)
          WRITE(6,'(5X,I2,5X,A20,F12.8)')
     *          (J,SSEL(JJ+J),CSEL(JJ+J),J=1,NC)
      CALL XFLUSH(6)
          JJ=JJ+NC
1234  CONTINUE
      END IF
      WRITE(6,*)
      CALL XFLUSH(6)
      CALL JACSCF(HREF,AREF,EREF,NREF,-1,1.0D-11)
      CALL ORDER(AREF,EREF,NREF)
      CALL CI_SELECT_MRCI(NREF,AREF,PLEN,NSEL,CISEL,NRROOT,IROOT)
      IF(NSEL.GT.0) THEN
          WRITE(6,*)' THE FOLLOWING ROOTS WERE SELECTED:'
      CALL XFLUSH(6)
          WRITE(6,'(12(A,I2))') ' ROOTS NR ',IROOT(1),
     *                           (',',IROOT(I),I=2,NRROOT-1),
     *                          ', AND ',IROOT(NRROOT)
      CALL XFLUSH(6)
      END IF
      WRITE(STR,'(I2)') LN
      CALL XFLUSH(6)
      FORM1='(2X,'//STR//'X,A,I7,2(8X,I7))'
      FORM2='(2X,'//STR//'X,A,3F15.8)'
      FORM3='('' CSF NR'',I5,'' CASE '','//STR//'I1,3(F13.6,2X))'
      FORM4='(''       '',I5,''      '','//STR//'I1,3(F13.6,2X))'
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,*)'        LOWEST REFERENCE CI ROOTS:'
      CALL XFLUSH(6)
      NPRT=MIN(NREF,IROOT(NRROOT)+2)
      DO 100 K1=1,NPRT,3
        K2=MIN(NPRT,K1+2)
        WRITE(6,FORM1)'            ROOT',(K,K=K1,K2)
      CALL XFLUSH(6)
        IF(NSEL.GT.0) WRITE(6,FORM2)'SELECTION WEIGHT',(PLEN(K),K=K1,K2)
        WRITE(6,FORM2)'          ENERGY',(EREF(K),K=K1,K2)
      CALL XFLUSH(6)
        DO  50 IREF=1,NREF
          IC=IREFX(IREF)
          IOFF=LN*(IC-1)
          IF(IREF.EQ.1) THEN
          WRITE(6,FORM3)IC,(JCASE(IOFF+J),J=1,LN),(AREF(IREF,K),K=K1,K2)
      CALL XFLUSH(6)
          ELSE
          WRITE(6,FORM4)IC,(JCASE(IOFF+J),J=1,LN),(AREF(IREF,K),K=K1,K2)
      CALL XFLUSH(6)
          END IF
50      CONTINUE
        WRITE(6,*)
      CALL XFLUSH(6)
100   CONTINUE
      WRITE(6,*)
      CALL XFLUSH(6)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine compl_cvb(a,nvec,n)
! Creates orthogonal complement.
! On entry : A is square (NxN) and contains NVEC vectors.
! On exit  : A is a full matrix, NVEC first vectors are untouched,
! remaining orthonormal vectors span the orthogonal complement.

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nvec, n
real(kind=wp), intent(inout) :: a(n,n)
integer(kind=iwp) :: i, ierr, imx, j
real(kind=wp) :: cmx, dum(1)
real(kind=wp), allocatable :: awrk(:,:), bwrk(:,:), cwrk(:), dwrk(:,:)
real(kind=wp), external :: ddot_

call mma_allocate(awrk,n,nvec,label='awrk')
call mma_allocate(dwrk,n,n,label='dwrk')
awrk(:,:) = a(:,1:nvec)
call unitmat(dwrk,n)
call schmidt_cvb(awrk,nvec,dum,n,0)
call schmidtd_cvb(awrk,nvec,dwrk,n,dum,n,0)
call mma_deallocate(awrk)
! Sort N vectors in order of decreasing norms
call mma_allocate(bwrk,n,n,label='bwrk')
call mma_allocate(cwrk,n,label='cwrk')
do i=1,n
  cwrk(i) = ddot_(n,dwrk(:,i),1,dwrk(:,i),1)
end do
do j=1,n
  cmx = cwrk(1)
  imx = 1
  do i=2,n
    if (cwrk(i) > cmx) then
      cmx = cwrk(i)
      imx = i
    end if
  end do
  cwrk(imx) = -real(j,kind=wp)
  bwrk(:,j) = dwrk(:,imx)
end do
call mma_deallocate(dwrk)
call schmidt_cvb(bwrk,n,dum,n,0)
! Extract N-NVEC remaining vectors with largest norms
do i=1,n
  cwrk(i) = ddot_(n,bwrk(:,i),1,bwrk(:,i),1)
end do
do j=1,n-nvec
  cmx = cwrk(1)
  imx = 1
  do i=2,n
    if (cwrk(i) > cmx) then
      cmx = cwrk(i)
      imx = i
    end if
  end do
  cwrk(imx) = -real(j,kind=wp)
  a(:,nvec+j) = bwrk(:,imx)
end do
ierr = 0
call nize_cvb(a(:,nvec+1:),n-nvec,dum,n,0,ierr)
call mma_deallocate(bwrk)
call mma_deallocate(cwrk)

return

end subroutine compl_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
*  This function return 0 if module is running outside structure
*                       1 if module is running inside structure
*
      Function IsStructure ()
      character*256 Value
      Character*100 Get_SuperName
      External Get_SuperName
      Value=' '
      call getenvf('MOLCAS_STRUCTURE',Value)
      IsStructure=0
      if (Value.eq.'1')  IsStructure=1
      if (Get_SuperName().eq.'last_energy') IsStructure=1
      Return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
************************************************************************
      SUBROUTINE TRACHO3(CMO)
      USE CHOVEC_IO
      IMPLICIT NONE
* ----------------------------------------------------------------
#include "rasdim.fh"
#include "warnings.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "chocaspt2.fh"
#include "choptr.fh"
#include "choglob.fh"
#include "WrkSpc.fh"
#include "output.fh"
**********************************************************************
*  Author : P. A. Malmqvist
**********************************************************************
      REAL*8 CMO(NBSQT)

      INTEGER NCES(8),ip_HTVec(8)
      Integer, External :: Cho_IRange
      INTEGER ISTART(8),NUSE(8)
      INTEGER IC,ICASE,IRC,ILOC
      INTEGER JSTART,JEND
      INTEGER JRED,JRED1,JRED2,JREDC,JNUM,JV1,JV2
      INTEGER IASTA,IAEND,IISTA,IIEND
      INTEGER NA,NASZ,NI,NISZ,NBUFFY,NPQ
      INTEGER IB,IBATCH,IBATCH_TOT,IBSTA,IBEND,NBATCH
      INTEGER IP_LFT,IP_LHT
      INTEGER ISYM,JSYM,ISYMA,ISYMB,ISYP,ISYQ
      INTEGER N,N1,N2
      INTEGER ip_buffy,ip_chspc,ip_ftspc,ip_htspc,ipnt
      INTEGER NUMV,NV,NVECS_RED,NVTOT,NHTOFF,MUSED

      REAL*8, EXTERNAL :: DDOT_

**********************************************************************
* ======================================================================
* This section deals with density matrices and CMO''s
* Offsets into CMO arrays:
      IC=0
      DO ISYM=1,NSYM
       NCES(ISYM)=IC
       IC=IC+NBAS(ISYM)**2
      END DO

* ======================================================================
      CALL GETMEM('CHSPC','ALLO','REAL',IP_CHSPC,NCHSPC)
      CALL GETMEM('HTSPC','ALLO','REAL',IP_HTSPC,NHTSPC)
      CALL GETMEM('FTSPC','ALLO','REAL',IP_FTSPC,NFTSPC)
* ======================================================================

      !IBATCH_TOT=0
* Loop over JSYM
      DO JSYM=1,NSYM
      IBATCH_TOT=NBTCHES(JSYM)

      IF(NUMCHO_PT2(JSYM).EQ.0) GOTO 1000

      ipnt=ip_InfVec+MaxVec_PT2*(1+InfVec_N2_PT2*(jSym-1))
      JRED1=iWork(ipnt)
      JRED2=iWork(ipnt-1+NumCho_PT2(jSym))

* Loop over JRED
      DO JRED=JRED1,JRED2

      CALL Cho_X_nVecRS(JRED,JSYM,JSTART,NVECS_RED)
      IF(NVECS_RED.EQ.0) GOTO 999

      ILOC=3
      CALL CHO_X_SETRED(IRC,ILOC,JRED)
* For a reduced set, the structure is known, including
* the mapping between reduced index and basis set pairs.
* The reduced set is divided into suitable batches.
* First vector is JSTART. Nr of vectors in r.s. is NVECS_RED.
      JEND=JSTART+NVECS_RED-1

* Determine batch length for this reduced set.
* Make sure to use the same formula as in the creation of disk
* address tables, etc, above:
      NBATCH=1+(NVECS_RED-1)/MXNVC

* Loop over IBATCH
      JV1=JSTART
      DO IBATCH=1,NBATCH
      IBATCH_TOT=IBATCH_TOT+1

      JNUM=NVLOC_CHOBATCH(IBATCH_TOT)
      JV2=JV1+JNUM-1

      JREDC=JRED
* Read a batch of reduced vectors
      CALL CHO_VECRD(WORK(IP_CHSPC),NCHSPC,JV1,JV2,JSYM,
     &                        NUMV,JREDC,MUSED)
      IF(NUMV.ne.JNUM) THEN
        write(6,*)' Rats! CHO_VECRD was called, assuming it to'
        write(6,*)' read JNUM vectors. Instead it returned NUMV'
        write(6,*)' vectors: JNUM, NUMV=',JNUM,NUMV
        write(6,*)' Back to the drawing board?'
        CALL QUIT(_RC_INTERNAL_ERROR_)
      END IF
      IF(JREDC.NE.JRED) THEN
        write(6,*)' Rats! It was assumed that the Cholesky vectors'
        write(6,*)' in HALFTRNSF all belonged to a given reduced'
        write(6,*)' set, but they don''t!'
        write(6,*)' JRED, JREDC:',JRED,JREDC
        write(6,*)' Back to the drawing board?'
        write(6,*)' Let the program continue and see what happens.'
      END IF

* Frozen half-transformation:
      NHTOFF=0
      DO ISYMA=1,NSYM
       ISYMB=MUL(ISYMA,JSYM)
       IP_HTVEC(ISYMA)=IP_HTSPC+NHTOFF
       ISTART(ISYMA)=1
       NUSE(ISYMA)=NFRO(ISYMA)
       NHTOFF=NHTOFF+NUSE(ISYMA)*NBAS(ISYMB)*JNUM
      END DO
      CALL HALFTRNSF(IRC,WORK(IP_CHSPC),NCHSPC,1,JV1,JNUM,JNUM,
     &     JSYM,JREDC,CMO,ISTART,NUSE,IP_HTVEC)

* Inactive half-transformation:
* Vectors of type HALF(K,J,B) = Sum(CHO(AB,J)*CMO(A,K) where
* A,B are basis functions of symmetry ISYMA, ISYMB,
* K is inactive of symmetry ISYMA, J is vector number in 1..NUMV
* numbered within the present batch.
* Symmetry block ISYMA,ISYMB is found at WORK(IP_HTVEC(ISYMA)
      NHTOFF=0
      DO ISYMA=1,NSYM
       ISYMB=MUL(ISYMA,JSYM)
       IP_HTVEC(ISYMA)=IP_HTSPC+NHTOFF
       ISTART(ISYMA)=NFRO(ISYMA)+1
       NUSE(ISYMA)=NISH(ISYMA)
       NHTOFF=NHTOFF+NUSE(ISYMA)*NBAS(ISYMB)*JNUM
      END DO
      CALL HALFTRNSF(IRC,WORK(IP_CHSPC),NCHSPC,1,JV1,JNUM,JNUM,
     &     JSYM,JREDC,CMO,ISTART,NUSE,IP_HTVEC)

* Loop over ISYQ
      DO ISYQ=1,NSYM
       ISYP=MUL(ISYQ,JSYM)

       N=NBAS(ISYP)
* ---------------------------------------------------
       N1=NASH(ISYP)
       N2=NISH(ISYQ)
       IC=1+NCES(ISYP) +(NFRO(ISYP)+NISH(ISYP))*N
       IP_LHT=IP_HTVEC(ISYQ)
       IP_LFT=IP_FTSPC
*   Compute fully transformed TK
       IF(N1*N2.GT.0) THEN
        CALL FULLTRNSF(N1,N2,N,CMO(IC),JNUM,WORK(IP_LHT),WORK(IP_LFT))
        CALL CHOVEC_SAVE(WORK(IP_LFT),1,ISYQ,JSYM,IBATCH_TOT)
       END IF
* ---------------------------------------------------
       N1=NSSH(ISYP)
       N2=NISH(ISYQ)
       IC=1+NCES(ISYP) +(NFRO(ISYP)+NISH(ISYP)+NASH(ISYP))*N
       IP_LHT=IP_HTVEC(ISYQ)
       IP_LFT=IP_FTSPC
*   Compute fully transformed AK
       IF(N1*N2.GT.0) THEN

C     CALL FULLTRNSF(N1,N2,N,CMO(IC),JNUM,WORK(IP_LHT),WORK(IP_LFT))

C =SVC= modified for using boxed ordering of pairs, note that the boxed
C routine is less efficient than the original one (loop over J values)
        NA=N1
        NI=N2
C Allocate memory for small buffer used in FULLTRNSF_BOXED
        NBUFFY=NA*NI
        CALL GETMEM('BUFFY','ALLO','REAL',IP_BUFFY,NBUFFY)
C Loop over boxes
        DO IASTA=1,NA,nSecBX
         IAEND=MIN(IASTA-1+nSecBX,NA)
         NASZ=1+IAEND-IASTA
         DO IISTA=1,NI,nInaBX
          IIEND=MIN(IISTA-1+nInaBX,NI)
          NISZ=1+IIEND-IISTA
C =SVC= note that WITHIN this box, the index of the outer box A (P in
C the FULLTRNSF subroutine, i.e. the secondary orbital index) is the
C fast-running index, as LFT([A],[I],J) = CMO(P,[A])^T * LHT([I],J,P)^T
C with P=1,NB.  So if used in e.g. ADDRHS as BRA(c,l,J), making an inner
C loop over secondary orbital index c is more efficient.
          CALL FULLTRNSF_BOXED (IASTA,IISTA,NASZ,NISZ,NA,NI,
     &                          N,CMO(IC+N*(IASTA-1)),JNUM,
     &                          WORK(IP_LHT),WORK(IP_LFT),
     &                          WORK(IP_BUFFY))
         ENDDO
        ENDDO
        CALL GETMEM('BUFFY','FREE','REAL',IP_BUFFY,NBUFFY)
        CALL CHOVEC_SAVE(WORK(IP_LFT),4,ISYQ,JSYM,IBATCH_TOT)
       END IF
* End loop ISYQ
      END DO
* ---------------------------------------------------

* Active scaled natural orbitals half-transformation:
* Vectors of type HALF(W,J,B) = Sum(CHO(AB,J)*CMO(A,W) where
* A,B are basis functions of symmetry ISYMA, ISYMB,
* W is active of symmetry ISYMA, J is vector number in 1..NUMV
* numbered within the present batch.
* Symmetry block ISYMA,ISYMB is found at WORK(IP_HTVEC(ISYMA)
      NHTOFF=0
      DO ISYMA=1,NSYM
       ISYMB=MUL(ISYMA,JSYM)
       IP_HTVEC(ISYMA)=IP_HTSPC+NHTOFF
       ISTART(ISYMA)=NFRO(ISYMA)+NISH(ISYMA)+1
       NUSE(ISYMA)=NASH(ISYMA)
       NHTOFF=NHTOFF+NUSE(ISYMA)*NBAS(ISYMB)*JNUM
      END DO
* ---------------------------------------------------
* Active half-transformation:
      CALL HALFTRNSF(IRC,WORK(IP_CHSPC),NCHSPC,1,JV1,JNUM,JNUM,
     &    JSYM,JREDC,CMO,ISTART,NUSE,IP_HTVEC)


      DO ISYQ=1,NSYM
       ISYP=MUL(ISYQ,JSYM)

       N=NBAS(ISYP)
* ---------------------------------------------------
* Loop over ISYQ
       N1=NASH(ISYP)
       N2=NASH(ISYQ)
       IC=1+NCES(ISYP) +(NFRO(ISYP)+NISH(ISYP))*N
       IP_LHT=IP_HTVEC(ISYQ)
       IP_LFT=IP_FTSPC
* Compute fully transformed TV
       IF(N1*N2.GT.0) THEN
        CALL FULLTRNSF(N1,N2,N,CMO(IC),JNUM,WORK(IP_LHT),WORK(IP_LFT))
        CALL CHOVEC_SAVE(WORK(IP_LFT),2,ISYQ,JSYM,IBATCH_TOT)
       END IF
* ---------------------------------------------------
       N1=NSSH(ISYP)
       N2=NASH(ISYQ)
       IC=1+NCES(ISYP) +(NFRO(ISYP)+NISH(ISYP)+NASH(ISYP))*N
       IP_LHT=IP_HTVEC(ISYQ)
       IP_LFT=IP_FTSPC
*   Compute fully transformed AV
       IF(N1*N2.GT.0) THEN
        CALL FULLTRNSF(N1,N2,N,CMO(IC),JNUM,WORK(IP_LHT),WORK(IP_LFT))
        CALL CHOVEC_SAVE(WORK(IP_LFT),3,ISYQ,JSYM,IBATCH_TOT)
       END IF
* ---------------------------------------------------
* End loop ISYQ
      END DO

* 800  CONTINUE
* End loop IBATCH
       JV1=JV1+JNUM
      END DO

* End loop JRED
  999 CONTINUE
      END DO

* End loop JSYM
 1000 CONTINUE
      END DO

      ! if using the RHS on-demand, we need all cholesky vectors on each
      ! process, collect them here
      IF (RHSDIRECT) THEN
        IP_LFT=IP_FTSPC
        DO JSYM=1,NSYM
          NVTOT=NVTOT_CHOSYM(JSYM)
          IBSTA=NBTCHES(JSYM)+1
          IBEND=NBTCHES(JSYM)+NBTCH(JSYM)
          DO IB=IBSTA,IBEND
            NV=NVLOC_CHOBATCH(IB)
            DO ISYQ=1,NSYM
              DO ICASE=1,4
                NPQ=NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
                IF (NPQ.EQ.0) CYCLE
                CALL CHOVEC_LOAD(WORK(IP_LFT),ICASE,ISYQ,JSYM,IB)
                CALL CHOVEC_COLL(WORK(IP_LFT),ICASE,ISYQ,JSYM,IB)
              END DO
            END DO
          END DO
        END DO
      END IF

      CALL GETMEM('CHSPC','FREE','REAL',IP_CHSPC,NCHSPC)
      CALL GETMEM('HTSPC','FREE','REAL',IP_HTSPC,NHTSPC)
      CALL GETMEM('FTSPC','FREE','REAL',IP_FTSPC,NFTSPC)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Felipe Zapata                                    *
!***********************************************************************

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! The Nose-Hoover chain of thermostat is based on the following paper
! Journal of Physical Chemistry B, 2001, 105, 7598
! The implemetation required first initialized the thermostat, then
! before calling the first part of velocity verlet the NHC is call,
! then the positions and velocities are updated using the verlet_first
! and after that the verlet_second is called and after this step
! the NHC subroutine is call. The order must not be changed
!
! Felipe Zapata, November 1, 2012
!
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine NhcThermo(vel)

#ifdef _HDF5_
use mh5, only: mh5_put_dset
use Dynamix_Globals, only: dyn_nh
#endif
use Dynamix_Globals, only: DT, TEMP, nh, iQ1, iQ2, iX1, iX2, iVx1, iVx2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: kBoltzmann, auTokJ, Zero, Two, Three, Half, Quart
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: vel(*)
integer(kind=iwp) :: i, j, natom
real(kind=wp) :: Ekin, DT2, DT4, DT8, G1, G2, NHC(nh), Q1, Q2, sc, Vx1, Vx2, X1, X2
real(kind=wp), allocatable :: Mass(:)
real(kind=wp), parameter :: kb = kBoltzmann/(auTokJ*1.0e3_wp)

!nh stands for the number of variables in the thermostat
! NHC = Q1,Q2,X1,X2,VX1,VX2,Scale
!
! The parameter kb is the Boltzmann constant in E_h/K

! READ PARAMETERS FROM RUNFILE

call Get_nAtoms_Full(natom)

call mma_allocate(Mass,natom)

! Read Thermostat Variables
call Get_NHC(NHC,nh)

Q1 = NHC(iQ1)
Q2 = NHC(iQ2)
X1 = NHC(iX1)
X2 = NHC(iX2)
Vx1 = NHC(iVx1)
Vx2 = NHC(iVx2)

! Initialize the Mass variable
call GetMassDx(Mass,natom)

Ekin = Zero

do i=1,natom
  do j=1,3
    Ekin = Ekin+Half*Mass(i)*(vel(3*(i-1)+j)**2)
  end do
end do

DT2 = DT*Half
DT4 = DT*Quart
DT8 = DT*0.125_wp

G2 = (Q1*Vx1*Vx1-TEMP*kb)/Q2
Vx2 = Vx2+G2*DT4
Vx1 = Vx1*exp(-Vx2*DT8)
G1 = (Two*Ekin-Three*natom*TEMP*kb)/Q1
Vx1 = Vx1+G1*DT4
Vx1 = Vx1*exp(-Vx2*DT8)
sc = exp(-Vx1*DT2)

vel(1:3*natom) = vel(1:3*natom)*sc
Ekin = Ekin*sc*sc

X1 = X1+Vx1*DT2
X2 = X2+Vx2*DT2
Vx1 = Vx1*exp(-Vx2*DT8)
G1 = (Two*Ekin-Three*natom*TEMP*kb)/Q1
Vx1 = Vx1+G1*DT4
Vx1 = Vx1*exp(-Vx2*DT8)
G2 = (Q1*(Vx1**2)-TEMP*kb)/Q2
Vx2 = Vx2+G2*DT4

NHC(iX1) = X1
NHC(iX2) = X2
NHC(iVx1) = Vx1
NHC(iVx2) = Vx2

call Put_NHC(NHC,nh)
#ifdef _HDF5_
call mh5_put_dset(dyn_nh,NHC)
#endif

call mma_deallocate(Mass)

return

end subroutine NhcThermo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine InitDB(nMult,natom,nAtQM,nGrdPt,ipCord,ipGrid,ipT,ipTT,
     &           ipTTT,ipExt,ipDB,ipIsMM,iRMax,DeltaR,iGrdTyp,ipDGrd)
      Implicit Real*8 (A-H,O-Z)
*
*     Compute DB = d(ExtPot[TtT^-1]Tt)/dq
*
#include "espf.fh"
*
      nOrd = nMult/nAtQM
      nMnAt = nMult*nAtQM*3
      nGdnAt = nGrdPt*nAtQM*3
*
*     Various derivatives
*
      Call GetMem('DTTT','Allo','Real',ipDTTT,nMult*nGrdPt*nAtQM*3)
      Call GetMem('DT','Allo','Real',ipDT,nGrdPt*nMult*3*nAtQM)
      Call GetMem('DTT','Allo','Real',ipDTT,nMult*nMult*nAtQM*3)
      Call GetMem('DTTTT','Allo','Real',ipDTTTT,nMult*nMult*nAtQM*3)

      Call CalcDT(nMult,nGrdPt,natom,nAtQM,ipIsMM,iGrdTyp,Work(ipCord),
     &            Work(ipGrid),Work(ipDGrd),Work(ipT),Work(ipTT),
     &            Work(ipDT),Work(ipDTT),Work(ipDTTTT),Work(ipDTTT))

      Call GetMem('DTTTT','Free','Real',ipDTTTT,nMult*nMult*nAtQM*3)
      Call GetMem('DTT','Free','Real',ipDTT,nMult*nMult*nAtQM*3)
      Call GetMem('DT','Free','Real',ipDT,nGrdPt*nMult*3*nAtQM)
*
*     Finally dB = dTTT * V_ext + TTT * dV_ext
*
      Call CalcDB(nMult,nGrdPt,natom,nAtQM,ipIsMM,Work(ipTTT),
     &            Work(ipDTTT),Work(ipExt),Work(ipDB))
      Call GetMem('DTTT','Free','Real',ipDTTT,nMult*nGrdPt*nAtQM*3)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(iRMax)
        Call Unused_real(DeltaR)
      End If
      End
*
      Subroutine CalcDB(nMult,nGrdPt,natom,nAtQM,ipIsMM,TTT,DTTT,ExtPot,
     &                  DB)
      Implicit Real*8 (A-H,O-Z)
*
*     dB = dTTT * V_ext + TTT * dV_ext
*
#include "espf.fh"
*
      Dimension TTT(nGrdPt,nMult),DTTT(nMult,nGrdPt,3,nAtQM),
     &          ExtPot(10,natom),DB(nGrdPt,3,nAtQM)
*
      iPL = iPL_espf()
*
      If (iPL.ge.4) Call RecPrt('TTT in calcdb',' ',TTT,nMult,nGrdPt)
      nOrd = nMult/nAtQM
      Do iPnt = 1, nGrdPt
         iQM = 0
         Do iAt = 1, natom
            If (iWork(ipIsMM+iAt-1) .ne. 0) Goto 1
            iQM = iQM + 1
            DB(iPnt,1,iQM)= TTT(iPnt,nOrd*(iQM-1)+1)*ExtPot(2,iAt)
            DB(iPnt,2,iQM)= TTT(iPnt,nOrd*(iQM-1)+1)*ExtPot(3,iAt)
            DB(iPnt,3,iQM)= TTT(iPnt,nOrd*(iQM-1)+1)*ExtPot(4,iAt)
            If (nOrd.eq.4) Then
               DB(iPnt,1,iQM)= DB(iPnt,1,iQM)
     &                       + TTT(iPnt,nOrd*(iQM-1)+2)*ExtPot( 5,iAt)
     &                       + TTT(iPnt,nOrd*(iQM-1)+3)*ExtPot( 8,iAt)
     &                       + TTT(iPnt,nOrd*(iQM-1)+4)*ExtPot( 9,iAt)
               DB(iPnt,2,iQM)= DB(iPnt,2,iQM)
     &                       + TTT(iPnt,nOrd*(iQM-1)+2)*ExtPot( 8,iAt)
     &                       + TTT(iPnt,nOrd*(iQM-1)+3)*ExtPot( 6,iAt)
     &                       + TTT(iPnt,nOrd*(iQM-1)+4)*ExtPot(10,iAt)
               DB(iPnt,3,iQM)= DB(iPnt,3,iQM)
     &                       + TTT(iPnt,nOrd*(iQM-1)+2)*ExtPot( 9,iAt)
     &                       + TTT(iPnt,nOrd*(iQM-1)+3)*ExtPot(10,iAt)
     &                       + TTT(iPnt,nOrd*(iQM-1)+4)*ExtPot( 7,iAt)
            End If
            jQM = 0
            Do jAt = 1, natom
               If (iWork(ipIsMM+jAt-1) .ne. 0) Goto 2
               jQM = jQM + 1
               Do iOrd = 1, nOrd
                  iMlt = nOrd*(jQM-1) + iOrd
                  DB(iPnt,1,iQM)= DB(iPnt,1,iQM)
     &                          + DTTT(iMlt,iPnt,1,iQM)*ExtPot(iOrd,jAt)
                  DB(iPnt,2,iQM)= DB(iPnt,2,iQM)
     &                          + DTTT(iMlt,iPnt,2,iQM)*ExtPot(iOrd,jAt)
                  DB(iPnt,3,iQM)= DB(iPnt,3,iQM)
     &                          + DTTT(iMlt,iPnt,3,iQM)*ExtPot(iOrd,jAt)
               End Do
2              Continue
            End Do
1           Continue
         End Do
      End Do
*
*     Some printing for debug
*
      If (iPL.ge.4) Then
         Do iQM = 1, nAtQM
            Write(6,*) 'dB/dq_i for i = ',iQM
            Do jPnt = 1, nGrdPt
               Write(6,1234) jPnt,(DB(jPnt,iXYZ,iQM),iXYZ=1,3)
 1234       Format(I6,3D13.6)
            End Do
         End Do
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkNameV4(i,j,k,l,Schem,Nomen)
! help routine to ReaW4, producing name of V4file
! ex: Schem='XY', i=1, j=3, k=5, l=07 ->  Nomen='XY01030507'

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: i, j, k, l
character(len=2), intent(in) :: Schem
character(len=10), intent(out) :: Nomen

write(Nomen,'(a2,4(i2.2))') Schem,i,j,k,l

return

end subroutine MkNameV4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkL0 (V)
c
c        L0(m,i,j) <- V(m,ij)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:nc,1:no*(no+1)/2)
c
c        help var
        integer i,j,ij,m
c
        ij=0
        do i=1,no
        do j=1,i
        ij=ij+1
          do m=1,nc
             L0k(m,i,j)=V(m,ij)
             L0k(m,j,i)=V(m,ij)
          end do
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

* Legacy code that is not used by current LAPACK but could be "needed"
* by other libraries. Define here just as dummy procedures
*
* If you modify this, the files f[1-5].fh should be updated too, use delayed.py

      module LEGACY_MOD

      contains

      subroutine dgetf2( m, n, a, lda, ipiv, info )
        implicit none
        integer :: info, lda, m, n
        integer :: ipiv( * )
        real*8 :: a( lda, * )
      end subroutine dgetf2

      subroutine dpotf2( uplo, n, a, lda, info )
        implicit none
        character :: uplo
        integer :: info, lda, n
        real*8 :: a( lda, * )
      end subroutine dpotf2

      end module LEGACY_MOD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
! THERMOstat = 0  nothing (default)
!              1  microcanonical ensemble (Andersen Thermostat)
!              2  canonical ensemble (Nose-Hoover Chain of Thermostats)
! VELOcities = 0  zero start velocities (default)
!              1  reads in the velocities (Bohr/a.u.) from 'velocity.xyz'
!              2  reads in the mass-weighted velocities (Bohr/a.u.) from 'velocity.xyz'
!              3  Maxwell-Boltzmann distribution at temperature T (Bohr/a.u.)
! POUT = x Number of nuclear coordinates to project out from the dynamics
!          and therefore of files 'out.00x.xyz' to read
! PIN = x Number of nuclear coordinates to keep in for the dynamics
!          and therefore of files 'in.00x.xyz' to read
!
! DT      - Time step
! Etot0   - Reference total energy for microcanonical ensemble
! Restart - Restart time of the molecular dynamics simulation
! iPrint  - (global) print level

module Dynamix_Globals

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: THERMO, VELO, POUT, PIN, iPrint
real(kind=wp) :: DT, RESTART, TEMP
logical(kind=iwp) :: lH5Restart
integer(kind=iwp), parameter :: SILENT = 0, TERSE = 1, USUAL = 2, VERBOSE = 3, DEBUG = 4, INSANE = 5
integer(kind=iwp), parameter :: nh = 6, iQ1 = 1, iQ2 = 2, iX1 = 3, iX2 = 4, iVx1 = 5, iVx2 = 6
integer(kind=iwp), parameter :: VelVer = 1, VV_First = 2, VV_Second = 3, Gromacs = 4

public :: DT, lH5Restart, iPrint, PIN, POUT, THERMO, TEMP, RESTART, VELO
public :: SILENT, TERSE, USUAL, VERBOSE, DEBUG, INSANE
public :: nh, iQ1, iQ2, iX1, iX2, iVx1, iVx2
public :: VelVer, VV_First, VV_Second, Gromacs

#ifdef _HDF5_
integer(kind=iwp) :: dyn_fileid, dyn_time, dyn_dt, dyn_etot, dyn_etot0, dyn_vel, dyn_nh, dyn_mass, dyn_geom
character(len=180) :: File_H5Res
public :: dyn_fileid, dyn_time, dyn_dt, dyn_etot, dyn_etot0, dyn_vel, dyn_nh, dyn_mass, dyn_geom, File_H5Res
#endif

end module Dynamix_Globals

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine SetUp_SCF()
!***********************************************************************
!                                                                      *
!     purpose: Set up needed parameters                                *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: DSCF, kOV, MaxBas, MaxBOF, MaxBOO, MaxBXO, MaxOrb, MaxORF, MaxORO, mOV, nBas, nBB, nBO, nBT, nD, nFro, nnB, &
                  nnFr, nnO, nnOc, nOCC, nOFS, nOO, nOrb, nOV, nSym
use Molcas, only: MxBas, MxSym
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iSym, maxnOcc(MxSym), minnOcc(MxSym)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Set up global parameters used later
nnOc = 0
nnFr = 0
nnB = 0
nnO = 0
nBT = 0
nBO = 0
nBB = 0
nOO = 0
nOV = 0
mOV = 0
kOV(:) = 0
nOFS = 0
MaxBas = 0
MaxOrb = 0
MaxOrF = 0
MaxOrO = 0
MaxBxO = 0
MaxBOF = 0
MaxBOO = 0
if (nD == 1) then
  maxnOcc(1:nSym) = nOcc(1:nSym,1)
  minnOcc(1:nSym) = nOcc(1:nSym,1)
else
  maxnOcc(1:nSym) = max(nOcc(1:nSym,1),nOcc(1:nSym,2))
  minnOcc(1:nSym) = min(nOcc(1:nSym,1),nOcc(1:nSym,2))
end if
do iSym=1,nSym
  if (nBas(iSym) > MxBas) then
    write(u6,*) 'SetUp: nBas(iSym) > MxBas'
    write(u6,*) 'nBas(iSym),MxBas=',nBas(iSym),MxBas
    call Abend()
  end if
  if (nOrb(iSym) > nBas(iSym)) then
    write(u6,*) 'SetUp: nOrb(iSym) > nBas(iSym)'
    write(u6,*) 'nOrb(iSym),nBas(iSym)=',nOrb(iSym),nBas(iSym)
    call Abend()
  end if
  if (maxnOcc(iSym) > nOrb(iSym)) then
    write(u6,*) 'iSym=',iSym
    write(u6,*) 'SetUp: nOcc(iSym) > nOrb(iSym)'
    write(u6,*) 'nOcc(iSym),nOrb(iSym)=',maxnOcc(iSym),nOrb(iSym)
    call Abend()
  end if
  if (nFro(iSym) > minnOcc(iSym)) then
    write(u6,*) 'SetUp: nFro(iSym) > nOcc(iSym)'
    write(u6,*) 'nFro(iSym),nOcc(iSym)=',nFro(iSym),minnOcc(iSym)
    call Abend()
  end if
  nnOc = nnOc+nOcc(iSym,1)
  if (nD == 2) nnOc = nnOc+nOcc(iSym,2)
  nnFr = nnFr+nFro(iSym)
  nnB = nnB+nBas(iSym)
  nnO = nnO+nOrb(iSym)
  nBT = nBT+nTri_Elem(nBas(iSym))
  nBO = nBO+nBas(iSym)*nOrb(iSym)
  nBB = nBB+nBas(iSym)**2
  nOO = nOO+nOrb(iSym)*nOrb(iSym)
  kOV(:) = kOV(:)+(nOcc(iSym,:)-nFro(iSym))*(nOrb(iSym)-nOcc(iSym,:))
  nOV = nOV+(maxnOcc(iSym)-nFro(iSym))*(nOrb(iSym)-minnOcc(iSym))
  nOFS = nOFS+(nOrb(iSym)-nFro(iSym))**2
  MaxBas = max(MaxBas,nBas(iSym))
  MaxOrb = max(MaxOrb,nOrb(iSym))
  MaxOrF = max(MaxOrF,nOrb(iSym)-nFro(iSym))
  MaxOrO = max(MaxOrO,nOrb(iSym)-minnOcc(iSym))
  MaxBxO = max(MaxBxO,nBas(iSym)*nOrb(iSym))
  MaxBOF = max(MaxBOF,nBas(iSym)*(nOrb(iSym)-nFro(iSym)))
  MaxBOO = max(MaxBOO,nBas(iSym)*(nOrb(iSym)-minnOcc(iSym)))
end do
mOV = kOV(1)+kOV(2)

if ((nnB > 2*MxBas) .and. (.not. DSCF)) then
  write(u6,*) 'SetUp: nnB > 2*MxBas .and. .not.DSCF'
  write(u6,*) 'nnB,MxBas=',nnB,MxBas
  call Abend()
else if ((nnB > 4*MxBas) .and. DSCF) then
  write(u6,*) 'SetUp: nnB > 4*MxBas .and. DSCF'
  write(u6,*) 'nnB,MxBas=',nnB,MxBas
  call Abend()
end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine SetUp_SCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_boundary

use fmm_global_paras, only: INTK, REALK, LUPRI, raw_mm_paras, fmm_planes, scheme_paras, Zero, One
use fmm_utils, only: fmm_quit

implicit none
private
! Public procedures
public :: fmm_opt_near_field

contains

!-------------------------------------------------------------------------------

subroutine verify_planes(grid,planes)

  implicit none
  type(raw_mm_paras), intent(in)  :: grid(:)
  type(fmm_planes), intent(inout) :: planes

  real(REALK), parameter :: THR = 1.0e-15_REALK
  integer(INTK) :: i

  do i=1,size(grid)
    if (abs(grid(i)%cntr(1)-planes%xmin) > THR .and. &
        abs(grid(i)%cntr(1)-planes%xmax) > THR .and. &
        abs(grid(i)%cntr(2)-planes%ymin) > THR .and. &
        abs(grid(i)%cntr(2)-planes%ymax) > THR .and. &
        abs(grid(i)%cntr(3)-planes%zmin) > THR .and. &
        abs(grid(i)%cntr(3)-planes%zmax) > THR) then
      call fmm_quit('boundary planes not // to coordinate axes!')
    end if
  end do

end subroutine verify_planes

!-------------------------------------------------------------------------------

subroutine get_boundary_planes(grid,planes)

  implicit none
  type(raw_mm_paras), intent(in)  :: grid(:)
  type(fmm_planes), intent(inout) :: planes

  integer(INTK) :: i

  planes%xmin = zero
  planes%xmax = zero
  planes%ymin = zero
  planes%ymax = zero
  planes%zmin = zero
  planes%zmax = zero
  do i=1,size(grid)
    planes%xmin = min(planes%xmin,grid(i)%cntr(1))
    planes%xmax = max(planes%xmax,grid(i)%cntr(1))
    planes%ymin = min(planes%ymin,grid(i)%cntr(2))
    planes%ymax = max(planes%ymax,grid(i)%cntr(2))
    planes%zmin = min(planes%zmin,grid(i)%cntr(3))
    planes%zmax = max(planes%zmax,grid(i)%cntr(3))
  end do

end subroutine get_boundary_planes

!-------------------------------------------------------------------------------

subroutine get_closest_approach(RHS,planes,gap)

  implicit none
  type(raw_mm_paras), intent(in) :: RHS(:)
  type(fmm_planes), intent(in)   :: planes
  real(REALK), intent(out)       :: gap

  integer(INTK) :: i

  gap = 1.0e10_REALK
  do i=1,size(RHS)
    gap = min(gap,abs(RHS(i)%cntr(1)-planes%xmin))
    gap = min(gap,abs(RHS(i)%cntr(1)-planes%xmax))
    gap = min(gap,abs(RHS(i)%cntr(2)-planes%ymin))
    gap = min(gap,abs(RHS(i)%cntr(2)-planes%ymax))
    gap = min(gap,abs(RHS(i)%cntr(3)-planes%zmin))
    gap = min(gap,abs(RHS(i)%cntr(3)-planes%zmax))
  end do

end subroutine get_closest_approach

!-------------------------------------------------------------------------------

subroutine fmm_opt_near_field(scheme,LHS,RHS)

  use fmm_box_utils, only: fmm_deepest_level, fmm_branch, fmm_grain

  implicit none
  type(raw_mm_paras), intent(in)    :: LHS(:)
  type(raw_mm_paras), intent(in)    :: RHS(:)
  type(scheme_paras), intent(inout) :: scheme

  type(fmm_planes) :: planes
  real(REALK) :: gap, dummy
  real(REALK) :: grain
  integer(INTK) :: branch

  ! We have only considered branch-free algorithm
  if (.not. scheme%branch_free) return

  call get_boundary_planes(LHS,planes)
  call verify_planes(LHS,planes)
  call get_closest_approach(RHS,planes,gap)
  write(LUPRI,'(a,es15.7)') ' Minimum distance to boundary =',gap

  if (gap < scheme%extent_min) then
    call fmm_quit('conflict between branch-free radius and boundary gap!')
  end if

  grain = fmm_grain(scheme,fmm_deepest_level(scheme))
  branch = fmm_branch(dummy,one/grain)

  ! we choose this condition to skip the NF conservatively
  if (gap > (branch+2)*grain) then
    write(LUPRI,*) 'There are no near-field interactions!'
    scheme%include_near_field = .false.
  end if

end subroutine fmm_opt_near_field

!-------------------------------------------------------------------------------

end module fmm_boundary

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine rtrace(N,A,B)
      ! removes the trace of a Real array
      Implicit None
      Integer, parameter         :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)        :: N ! size of the array
      Real(kind=8), intent(in)  :: A(N) ! input
      Real(kind=8), intent(out) :: B(N) ! output
      ! local variables
      Integer       :: i
      Real(kind=8) :: AS
      AS=0.0_wp
      Call dcopy_(N,[0.0_wp],0, B,1)
      !compute the equal-weighted average
      Do i=1,N
        AS=AS+A(i)/dble(N)
      End Do
      !translate each of the elements
      Do i=1,N
        B(i)=A(i)-AS
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FULLTRNSF(NP,NW,NB,CMOBLK,NJ,BUF_HT,BUF_FT)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NP, NW, NB, NJ
real(kind=wp), intent(in) :: CMOBLK(NB,NP), BUF_HT(NW*NJ,NB)
real(kind=wp), intent(out) :: BUF_FT(NP,NW*NJ)

! In: Vectors of type HALF(W,J,B) = Sum(CHO(AB,J)*CMO(A,W),A=1,NBAS)

! Compute fully transformed Cholesky vector buffer:
!  FULL(P,W,J)=Sum(CMO(B,P)*HALF(W,J,B),B=1,NB)
!do J=1,NJ
!  call DGEMM_('T','T',NP,NW,NB,One,CMOBLK,NB,BUF_HT(1,J,1),NW*NJ,Zero,BUF_FT(1,1,J),NP)
!end do
call DGEMM_('T','T',NP,NW*NJ,NB,One,CMOBLK,NB,BUF_HT,NW*NJ,Zero,BUF_FT,NP)

end subroutine FULLTRNSF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mxprint_cvb(a,nrow,ncol,itype)
c Prints matrix A, stored according to ITYPE
      implicit real*8 (a-h,o-z)
#include "print_cvb.fh"
#include "formats_cvb.fh"
      parameter (mxbuf=8)
      dimension buffer(mxbuf),ibuf(mxbuf),a(*)

      nbuf=min((iwidth-4)/(iprec+4),mxbuf)
      if(nbuf.eq.7)nbuf=6
      iform=0
      jin=1
100   jend=jin+nbuf-1
      if(ncol.le.nbuf) jend=ncol
      if(jend.gt.ncol+nbuf-1) return
      jend=min(ncol,jend)
      k=0
      do 200 j=jin,jend
      k=k+1
      ibuf(k)=j
200   continue
      if(iform.eq.0)then
        write(6,formMXP1)(ibuf(i),i=1,jend-jin+1)
      else
        write(6,formMXP2)(ibuf(i),i=1,jend-jin+1)
      endif
      do 300 i=1,nrow
      k=0
      do 400 j=jin,jend
      k=k+1
      if(itype.eq.0)then
        ind=(j-1)*nrow+i
      elseif(itype.eq.1)then
        if(i.ge.j)then
          ind=i*(i-1)/2+j
        else
          ind=j*(j-1)/2+i
        endif
      else
        ind=(i-1)*ncol+j
      endif
      buffer(k)=a(ind)
400   continue
      if(iform.eq.0)then
        write(6,formMXP3)i,(buffer(ii),ii=1,jend-jin+1)
      else
        write(6,formMXP4)i,(buffer(ii),ii=1,jend-jin+1)
      endif
300   continue
      jin=jend+1
      if(ncol.gt.nbuf)goto 100
      return
      end
      subroutine mxprintd_cvb(a,nrow,ncol,itype)
      implicit real*8 (a-h,o-z)
#include "print_cvb.fh"
#include "formats_cvb.fh"
      parameter (mxbuf=8)
      dimension buffer(mxbuf),ibuf(mxbuf),a(*)
      nbuf=min((iwidth-4)/(iprec+8),mxbuf)
      if(nbuf.eq.7)nbuf=6
      iform=1
      jin=1
100   jend=jin+nbuf-1
      if(ncol.le.nbuf) jend=ncol
      if(jend.gt.ncol+nbuf-1) return
      jend=min(ncol,jend)
      k=0
      do 200 j=jin,jend
      k=k+1
      ibuf(k)=j
200   continue
      if(iform.eq.0)then
        write(6,formMXP1)(ibuf(i),i=1,jend-jin+1)
      else
        write(6,formMXP2)(ibuf(i),i=1,jend-jin+1)
      endif
      do 300 i=1,nrow
      k=0
      do 400 j=jin,jend
      k=k+1
      if(itype.eq.0)then
        ind=(j-1)*nrow+i
      elseif(itype.eq.1)then
        if(i.ge.j)then
          ind=i*(i-1)/2+j
        else
          ind=j*(j-1)/2+i
        endif
      else
        ind=(i-1)*ncol+j
      endif
      buffer(k)=a(ind)
400   continue
      if(iform.eq.0)then
        write(6,formMXP3)i,(buffer(ii),ii=1,jend-jin+1)
      else
        write(6,formMXP4)i,(buffer(ii),ii=1,jend-jin+1)
      endif
300   continue
      jin=jend+1
      if(ncol.gt.nbuf)goto 100
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine POT(Rin,Ein,Rout,Eout,nout,ifit,Emin,Req,R0,R1,dR,npin,Title,iplot,Redm,sc,Nr)

use Vibrot_globals, only: iscale, nop
use Constants, only: Zero, One, Ten
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: Rin(*), Ein(*), Rout(*), Eout(*), Redm
real(kind=wp), intent(inout) :: R0, R1, dR
integer(kind=iwp), intent(in) :: nout, ifit, npin, iplot, Nr
real(kind=wp), intent(out) :: Emin, Req, sc
character(len=8) :: FILENAME
real(kind=wp) :: Eeq, Ree, Ue, Re, Eminx, Escale, alpha, Einf, Einfp
integer(kind=iwp) :: Vibplt, iPrint, next, nplot, i, imin
character(len=80) :: Title
character(len=*), parameter :: tp(3) = [character(len=12) :: 'Max point','Saddle point','Min point']
integer(kind=iwp), parameter :: lext = 100, ipldim = 1000
real(kind=wp) :: Rext(lext), Eext(lext), Eextp(lext), Rplot(ipldim), Eplot(ipldim), Eplotp(ipldim)
integer(kind=iwp) :: iext(lext)
integer(kind=iwp), external :: IsFreeUnit

FILENAME = 'VIBPLT0 '
if ((Nr >= 1) .and. (Nr <= 9)) then
  write(FILENAME(7:7),'(I1)') Nr
else if ((Nr >= 10) .and. (Nr <= 99)) then
  write(FILENAME(7:8),'(I2)') Nr
end if
write(u6,*) 'Generating plot file:',FILENAME
Vibplt = IsFreeUnit(10)
call Molcas_Open(Vibplt,FILENAME)

iPrint = 1

select case (ifit)
  case (1)
    Ue = 0.4_wp
    if ((Ue < 0.1_wp) .or. (Ue > 0.9_wp)) then
      write(u6,*) 'POT Error: Ue should be in 0.1..0.9'
      write(u6,*) '           Ue  =',Ue
      call Quit_OnUserError()
    end if

    ! Find Re value

    Re = Rin(1)
    Eminx = Ein(1)
    do i=2,npin
      if (Ein(i) <= Eminx) then
        Re = Rin(i)
        Eminx = Ein(i)
      end if
    end do

    ! Scale input potential if requested such that
    ! the binding energy is 0.1 au (BOR 0601).

    sc = One
    Escale = Ein(npin)
    if (iscale /= 0) sc = abs(0.1_wp/(Eminx-Escale))
    do i=1,npin
      Ein(i) = Escale+sc*(Ein(i)-Escale)
    end do
    Redm = Redm/sc
    write(u6,1001) sc

    if ((Re < 1.0_wp) .or. (Re > 20.0_wp)) then
      write(u6,*) 'POT Error: Re should be in 1.0..20.0'
      write(u6,*) '           Re  =',Re
      call Quit_OnUserError()
    end if
    alpha = log(Ue)/Re
    do i=1,npin
      Rin(i) = exp(alpha*Rin(i))
    end do

    do i=1,nout
      Rout(i) = exp(alpha*Rout(i))
    end do
    Rout(nout+1) = Zero
    call Sort_Pot(Rin,Ein,npin)
    next = lext
    call Spline(Rin,Ein,npin,Rout,Eout,nout+1,Rext,Eext,iext,next,1)
    do i=1,npin
      Rin(i) = log(Rin(i))/alpha
    end do
    call Sort_Pot(Rin,Ein,npin)
    do i=1,nout
      Rout(i) = log(Rout(i))/alpha
    end do
    do i=1,next
      Rext(i) = log(Rext(i))/alpha
    end do
    if (iPrint >= 1) then
      do i=1,next
        Eextp(i) = Escale+(Eext(i)-Escale)/sc
      end do
      if (next >= 1) then
        write(u6,2002)
        write(u6,2003) (tp(iext(i)),Rext(i),Eextp(i),i=1,next)
      end if
    end if
    if (iplot >= 1) then
      nplot = 1+int((R1-R0)/dR)
      if ((nplot > ipldim) .or. (nplot <= 0)) then
        write(u6,*) 'POT Error: Variable NPLOT should be in 1..IPLDIM'
        write(u6,*) '          IPLDIM=',IPLDIM
        write(u6,*) '          NPLOT =',NPLOT
        call Quit_OnUserError()
      end if
      do i=1,nop
        Rin(i) = exp(alpha*Rin(i))
      end do
      call Sort_Pot(Rin,Ein,nop)
      if (iplot == 1) then
        do i=1,nplot
          Rplot(i) = (i-1)*dR+R0
        end do
      else
        do i=1,nplot
          Rplot(i) = Ten**((i-1)*dR+R0)
        end do
      end if
      do i=1,nplot
        Rplot(i) = exp(alpha*Rplot(i))
      end do
      next = lext
      call Spline(Rin,Ein,npin,Rplot,Eplot,nplot,Rext,Eext,iext,next,1)
      do i=1,nplot
        Rplot(i) = log(Rplot(i))/alpha
      end do
      if (iplot == 3) then
        do i=1,nplot
          Rplot(i) = log10(Rplot(i))
        end do
      end if
      do i=1,nplot
        Eplotp(i) = Escale+(Eplot(i)-Escale)/sc
      end do
      write(Vibplt,3000) Title
      write(Vibplt,3002) nplot
      write(Vibplt,3001) (Rplot(i),Eplotp(i),i=1,nplot)
    end if
    if (next <= 0) then
      write(u6,*) 'POT Error: Variable NEXT should be larger than 0'
      write(u6,*) '          NEXT =',NEXT
      call Quit_OnUserError()
    end if
    Eeq = huge(Eeq)
    imin = 0
    do i=1,next
      if (Eeq > Eext(i)) then
        imin = i
        Eeq = Eext(i)
      end if
    end do
    Emin = Eeq
    Ree = Rext(imin)
    if (iplot > 0) Ree = log(Ree)/alpha
    Req = Ree
    if (iext(imin) /= 3) then
      write(u6,*) 'POT Error: IEXT(IMIN) should be = 3'
      write(u6,*) '    IEXT(IMIN) =',IEXT(IMIN)
      call Quit_OnUserError()
    end if
    Einf = Eout(nout+1)
    do i=1,nout
      Eout(i) = Eout(i)-Einf
    end do
    Emin = Emin-Einf
    Einfp = Escale+(Einf-Escale)/sc
    write(u6,1002) Einfp

    close(Vibplt)

  ! Here for fitting of observable input
  case (2)
    call Sort_Pot(Rin,Ein,npin)
    next = lext
    call Spline(Rin,Ein,npin,Rout,Eout,nout,Rext,Eext,iext,next,1)
    if (iplot >= 1) then
      nplot = 1+int((R1-R0)/dR)
      if ((nplot > ipldim) .or. (nplot <= 0)) then
        write(u6,*) 'POT Error: Variable NPLOT should be in 1..IPLDIM'
        write(u6,*) '          IPLDIM=',IPLDIM
        write(u6,*) '          NPLOT =',NPLOT
        call Quit_OnUserError()
      end if
      if (iplot == 1) then
        do i=1,nplot
          Rplot(i) = (i-1)*dR+R0
        end do
      else
        do i=1,nplot
          Rplot(i) = Ten**((i-1)*dR+R0)
        end do
      end if
      call Spline(Rin,Ein,npin,Rplot,Eplot,nplot,Rext,Eext,iext,next,1)
      if (iplot == 3) then
        do i=1,nplot
          Rplot(i) = log10(Rplot(i))
        end do
      end if
      write(Vibplt,3000) Title
      write(Vibplt,3002) nplot
      write(Vibplt,3001) (Rplot(i),Eplot(i),i=1,nplot)
    end if
    sc = One
    Req = Zero
    Emin = Zero

    close(Vibplt)

  case default
    write(u6,*) 'POT Error: IFIT variable must be 1 or 2.'
    write(u6,*) '           IFIT=',IFIT
    call Quit_OnUserError()
end select

return

1001 format(/1x,'Scaling parameter for potential:',f12.6)
1002 format(1x,'Extrapolated value at infinity',f13.6)
2002 format(/1x,'extremum points'/24x,'R(au)',9x,'Value')
2003 format(1x,a,2f14.6)
3000 format(a80)
3001 format(1x,f15.8,f20.8)
3002 format(i4)

end subroutine POT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE NXTNUM3(INUM,NELMNT,MINVAL,MAXVAL,NONEW)
*
* An set of numbers INUM(I),I=1,NELMNT is
* given. Find next compund number.
* Digit I must be in the range MINVAL(I),MAXVAL(I).
*
*
* NONEW = 1 on return indicates that no additional numbers
* could be obtained.
*
* Jeppe Olsen Oct 1994
*
*. Input
      DIMENSION MINVAL(*),MAXVAL(*)
*. Input and output
      DIMENSION INUM(*)
*
       NTEST = 0
       IF( NTEST .NE. 0 ) THEN
         WRITE(6,*) ' Initial number in NXTNUM '
         CALL IWRTMA(INUM,1,NELMNT,1,NELMNT)
       END IF
*
      IF(NELMNT.EQ.0) THEN
        NONEW = 1
        GOTO 1001
      END IF
*
      IPLACE = 0
 1000 CONTINUE
        IPLACE = IPLACE + 1
        IF(INUM(IPLACE).LT.MAXVAL(IPLACE)) THEN
          INUM(IPLACE) = INUM(IPLACE) + 1
          NONEW = 0
          GOTO 1001
        ELSE IF ( IPLACE.LT.NELMNT) THEN
          DO JPLACE = 1, IPLACE
            INUM(JPLACE) = MINVAL(JPLACE)
          END DO
        ELSE IF ( IPLACE. EQ. NELMNT ) THEN
          NONEW = 1
          GOTO 1001
        END IF
      GOTO 1000
 1001 CONTINUE
*
      IF( NTEST .NE. 0 ) THEN
        WRITE(6,*) ' New number '
        CALL IWRTMA(INUM,1,NELMNT,1,NELMNT)
      END IF
*
      RETURN
      END
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_PRTTIM(SECTION,TCPU2,TCPU1,TWALL2,TWALL1,IOPT)
!
! Purpose: print timing for a section.

use Cholesky, only: LuPri
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: SECTION
real(kind=wp), intent(in) :: TCPU1, TCPU2, TWALL1, TWALL2
integer(kind=iwp), intent(in) :: IOPT
integer(kind=iwp) :: IHRC, IHRW, IMNC, IMNW, LENSEC
real(kind=wp) :: SECC, SECW, TCPUT, TWALLT
character(len=80) :: STRING

TCPUT = TCPU2-TCPU1
TWALLT = TWALL2-TWALL1
call CHO_CNVTIM(TCPUT,IHRC,IMNC,SECC)
call CHO_CNVTIM(TWALLT,IHRW,IMNW,SECW)

if (IOPT == 0) then
  LENSEC = len(SECTION)
  write(LUPRI,'(/,A,A,A)') '***** ',SECTION(1:LENSEC),' completed *****'
  write(LUPRI,'(A,I8,A,I2,A,F6.2,A)') 'Total CPU  time:',IHRC,' hours ',IMNC,' minutes ',SECC,' seconds'
  write(LUPRI,'(A,I8,A,I2,A,F6.2,A,/)') 'Total wall time:',IHRW,' hours ',IMNW,' minutes ',SECW,' seconds'
else if (IOPT == 1) then
  LENSEC = len(SECTION)
  write(LUPRI,'(///,A,A,A)') '***** ',SECTION(1:LENSEC),' completed *****'
  write(LUPRI,'(A,I8,A,I2,A,F6.2,A)') 'Total CPU  time:',IHRC,' hours ',IMNC,' minutes ',SECC,' seconds'
  write(LUPRI,'(A,I8,A,I2,A,F6.2,A,//)') 'Total wall time:',IHRW,' hours ',IMNW,' minutes ',SECW,' seconds'
else if (IOPT == 2) then
  LENSEC = min(len(SECTION),70)
  write(STRING,'(A10,A)') 'Timing of ',SECTION(1:LENSEC)
  LENSEC = LENSEC+10
  call CHO_HEAD(STRING(1:LENSEC),'=',80,LUPRI)
  write(LUPRI,'(/,A,I8,A,I2,A,F6.2,A)') 'Total CPU  time:',IHRC,' hours ',IMNC,' minutes ',SECC,' seconds'
  write(LUPRI,'(A,I8,A,I2,A,F6.2,A)') 'Total wall time:',IHRW,' hours ',IMNW,' minutes ',SECW,' seconds'
else
  write(LUPRI,'(/,A,I8,A,I2,A,F6.2,A)') 'Total CPU  time:',IHRC,' hours ',IMNC,' minutes ',SECC,' seconds'
  write(LUPRI,'(A,I8,A,I2,A,F6.2,A)') 'Total wall time:',IHRW,' hours ',IMNW,' minutes ',SECW,' seconds'
end if

call XFLUSH(LUPRI)

end subroutine CHO_PRTTIM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MLSM(IML,IPARI,ISM,TYPE,IWAY)
*
* Transfer between ML,IPARI notation and compound notation ISM
*
* IWAY = 1 : IML,IPARI => Compound
* IWAY = 2 : IML,IPARI <= Compound
*
* TYPE : 'SX','OB','ST','DX','CI'
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
      CHARACTER*2 TYPE
*./NONAB/
* FIXME: This common block is never initialized or referenced elsewhere
* In the absence of further information, I'm setting the values to 0
*      COMMON /NONAB/ MNMLOB,NMLOB,
*     &               MNMLST,NMLST,
*     &               MNMLSX,NMLSX,
*     &               MNMLCI,NMLCI,
*     &               MNMLDX,NMLDX
       PARAMETER (MNMLOB=0,NMLOB=0,
     &            MNMLST=0,NMLST=0,
     &            MNMLSX=0,NMLSX=0,
     &            MNMLCI=0,NMLCI=0,
     &            MNMLDX=0,NMLDX=0)
*./CSM/
C     COMMON/CSM/NSMSX,NSMDX,NSMST,NSMCI,ITSSX,ITSDX
#include "csm.fh"
*
*.(Tired of warnings from 3090 Compiler so )
* (
      NML = 0
      MNML= 0
*             )
      IF(TYPE.EQ.'OB') THEN
        NML = NMLOB
        MNML = MNMLOB
      ELSE IF(TYPE.EQ.'SX') THEN
        NML = NMLSX
        MNML = MNMLSX
      ELSE IF(TYPE.EQ.'DX') THEN
        NML = NMLDX
        MNML = MNMLDX
      ELSE IF(TYPE.EQ.'ST') THEN
        NML = NMLST
        MNML = MNMLST
      ELSE IF(TYPE.EQ.'CI') THEN
        NML = NMLCI
        MNML = MNMLCI
      END IF
*
      IF(IWAY.EQ.1) THEN
C        ISM = (IPARI-1)*NML + MNML - 1
         ISM = (IPARI-1)*NML + IML - MNML + 1
      ELSE IF(IWAY.EQ.2) THEN
        IF(ISM.GT.NML) THEN
          IPARI = 2
          IML = ISM - NML + MNML - 1
        ELSE
          IPARI = 1
          IML = ISM       + MNML - 1
        END IF
      ELSE
        WRITE(6,*) ' Error in MLSM , IWAY = ' ,IWAY
        WRITE(6,*) ' MLSM stop !!! '
*        STOP 20
        CALL SYSABENDMSG('lucia_util/mlsm','Internal error',' ')
      END IF
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,'(A,A)') ' MLSM speaking ,type= ',TYPE
        WRITE(6,'(A,3I4)') ' IML IPARI ISM ',IML,IPARI,ISM
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_PTS_WrRst(irc,NVT,l_NVT)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: Write restart files (parallel two-step algorithm).
C
      Implicit None
      Integer irc
      Integer l_NVT
      Integer NVT(l_NVT)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer N2
      Parameter (N2=InfVec_N2)

#if defined (_DEBUGPRINT_)
      Character*13 SecNam
      Parameter (SecNam='Cho_PTS_WrRst')
      Integer ip_IDV, l_IDV
      Integer myNumCho(8)
#endif

      Integer iSym
      Integer ip_InfVcT
      Integer iV, kOff, iAdr

      Integer i, j, k
      Integer InfVct
      InfVcT(i,j,k)=iWork(ip_InfVcT-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)

      ! Init return code
      irc=0

#if defined (_DEBUGPRINT_)
      ! check that NumCho agrees with distribution
      If (l_NVT.lt.nSym) Then
         irc=-1
         Return
      End If
      Do iSym=1,nSym
         l_IDV=NVT(iSym)
         Call GetMem('IDV','Allo','Inte',ip_IDV,l_IDV)
         myNumCho(iSym)=0
         Call Cho_P_Distrib_Vec(1,NVT(iSym),iWork(ip_IDV),
     &                          myNumCho(iSym))
         Call GetMem('IDV','Free','Inte',ip_IDV,l_IDV)
         If (NumCho(iSym) .ne. myNumCho(iSym)) Then
            Write(LuPri,*)
     &      SecNam,': NumCho discrepancy in sym. ',iSym
            Write(LuPri,*)
     &      '  NumCho=',NumCho(iSym)
            Write(LuPri,*)
     &      'myNumCho=',myNumCho(iSym)
            Write(LuPri,*)
     &      '     NVT=',NVT(iSym)
            irc=1
         End If
      End Do
      Call iCopy(nSym,NumCho,1,myNumCho,1)
      Call Cho_GAIGOp(myNumCho,nSym,'+')
      Do iSym=1,nSym
         If (myNumCho(iSym).ne.NVT(iSym)) Then
            Write(LuPri,*)
     &      SecNam,': NumCho discrepancy in sym. ',iSym
            Write(LuPri,*)
     &      'Sum of NumCho across nodes=',myNumCho(iSym)
            Write(LuPri,*)
     &      '                       NVT=',NVT(iSym)
            irc=2
         End If
      End Do
      If (irc.ne.0) Return
#endif

      ! Erase existing files from first step
      ! (Keep map and vector files, though)
      If (LuRst.lt.1) Then
         LuRst=7
         Call DAName_MF_WA(LuRst,'CHORST')
      End If
      Call DAEras(LuRst)
      LuRst=0
      If (LuRed.lt.1) Then
         LuRed=7
         Call DAName_MF_WA(LuRst,'CHRED')
      End If
      Call DAEras(LuRed)
      LuRed=0
      If (LuMap.gt.0) Then
         Call DAClos(LuMap)
         LuMap=0
      End If
      Do iSym=1,nSym
         If (LuCho(iSym).gt.0) Then
            Call DAClos(LuCho(iSym))
            LuCho(iSym)=0
         End If
      End Do

      ! Re-open files
      Call Cho_OpenVR(1,2)

      ! Set InfRed corresponding to only one reduced set
      ! (All vectors are now stored in 1st reduced set)
      iWork(ip_InfRed)=0
      ! Set InfVec data (only disk addresses need updating)
      Call Cho_X_GetIP_InfVec(ip_InfVcT)
      kOff=ip_InfVec-1
      Do iSym=1,nSym
         ! InfVec(iV,1,iSym): parent diagonal in rs1 of vector iV of
         ! symmetry iSym
         Do iV=1,NVT(iSym)
            iWork(kOff+iV)=InfVcT(iV,1,iSym)
         End Do
         Do iV=NVT(iSym)+1,MaxVec
            iWork(kOff+iV)=0
         End Do
         kOff=kOff+MaxVec
         ! InfVec(iV,2,iSym): reduced set of vector iV of
         ! symmetry iSym (always rs1 in this implementation)
         Do iV=1,NVT(iSym)
            iWork(kOff+iV)=1
         End Do
         Do iV=NVT(iSym)+1,MaxVec
            iWork(kOff+iV)=0
         End Do
         kOff=kOff+MaxVec
         ! InfVec(iV,3,iSym): disk address of vector iV of
         ! symmetry iSym (always rs1 in this implementation)
         ! Note: this information is for the vectors on this
         ! node ONLY!!
         iAdr=0
         Do iV=1,NumCho(iSym)
            iWork(kOff+iV)=iAdr
            iAdr=iAdr+nnBstR(iSym,1)
         End Do
         Do iV=NumCho(iSym)+1,MaxVec
            iWork(kOff+iV)=-1
         End Do
         kOff=kOff+MaxVec
         ! InfVec(iV,4,iSym): WA disk address of vector iV of
         ! symmetry iSym (redundant? Oh yes, but used for statistics...)
         iAdr=0
         Do iV=1,NVT(iSym)
            iWork(kOff+iV)=iAdr
            iAdr=iAdr+nnBstR(iSym,1)
         End Do
         Do iV=NVT(iSym)+1,MaxVec
            iWork(kOff+iV)=-1
         End Do
         kOff=kOff+MaxVec
         ! InfVec(iV,5,iSym): is defined automatically by Cho_X_Init
         ! No need to set it here - use a dummy value
         Do iV=1,MaxVec
            iWork(kOff+iV)=-1
         End Do
         kOff=kOff+MaxVec
      End Do

      ! Make sure that all vector info is written
      Call iSwap(nSym,NVT,1,NumCho,1)

      ! Write restart file
      Call Cho_WrRstC(1)

      ! Write reduced set
      Call Cho_PutRed(1,1)

      ! Swap back
      Call iSwap(nSym,NVT,1,NumCho,1)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function OVLMP(NP,ZP,NQ,ZQ)
!     <NP,ZP|NQ,ZQ>
! Note that both NP and NQ should be either even or odd, but not mixed.

use AMatrix, only: DFAC
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: OVLMP
integer(kind=iwp), intent(in) :: NP, NQ
real(kind=wp), intent(in) :: ZP, ZQ
integer(kind=iwp) :: IT11, IT22, IT33
real(kind=wp) :: RT1, ZAV

IT11 = 2*NP
IT22 = 2*NQ
RT1 = sqrt(ZP**(IT11+1)*ZQ**(IT22+1))/(DFAC(IT11)*DFAC(IT22))
RT1 = sqrt(RT1)
IT33 = NP+NQ
ZAV = Half*(ZP+ZQ)
OVLMP = RT1*DFAC(IT33)/sqrt(ZAV**(IT33+1))

return

end function OVLMP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Interfaces_SCF

! Dummy modules to get correct order of compilation
use InfSCF, only:
use LnkLst, only:

implicit none
private

public :: dOne_SCF, MinDns, OccDef, OptClc_X, TraClc_i, vOO2OV_inner, yHx

contains

! Subroutines that need an explicit interface (target or allocatable arguments)
#define _IN_MODULE_
#include "done_scf.F90"
#include "mindns.F90"
#include "occdef.F90"
#include "optclc_x.F90"
#include "traclc_i.F90"
#include "voo2ov_inner.F90"
#include "yhx.F90"

end module Interfaces_SCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine Drvh1_mck(Nona)
!***********************************************************************
!                                                                      *
! Object: driver for computation of gradients of one-electron matrices.*
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January '91                                              *
!             Modified by Anders Bernhardsson for Gradients            *
!             May 95                                                   *
!***********************************************************************

use mck_interface, only: grd_mck_kernel, mck_mem
use Index_Functions, only: nTri_Elem
use Basis_Info, only: dbsc, nBas, nCnttp
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: Nona
#include "print.fh"
integer(kind=iwp) :: i, iCnt, iCnttp, idCar, idcnt, iIrrep, loper, nDens, nFock
character(len=8) :: Label
logical(kind=iwp) :: lECP
real(kind=wp), allocatable :: D0(:), Fock(:)
procedure(grd_mck_kernel) :: KneGrd_mck, m1grd_mck, nagrd_mck, nonatwo, OvrGrd_mck, prjgrd_mck, srogrd_mck
procedure(mck_mem) :: KneMem_mck, m1mm1, na2mem, namem_mck, OvrMem_mck, prjmm1, sromm1

if (show) then
  nFock = 0
  nDens = 0
  do iIrrep=0,nIrrep-1
    nFock = nFock+nTri_Elem(nBas(iIrrep))
    nDens = nDens+nTri_Elem(nBas(iIrrep))
  end do

  ! Read the variational 1st order density matrix
  ! density matrix in AO/SO basis
  call mma_allocate(D0,nDens,Label='D0')
  call Get_D1ao_Var(D0,nDens)
  ! Read the generalized Fock matrix
  ! Fock matrix in AO/SO basis
  call mma_allocate(Fock,nFock,Label='Fock')
  call Get_Fock_Occ(Fock,nFock)
else
  nFock = 1
  nDens = 1
  call mma_allocate(Fock,nFock,Label='Fock')
  call mma_allocate(D0,nDens,Label='D0')
  Fock(1) = Zero
  D0(1) = Zero
end if
if (Nona) then
  !*********************************************************************
  !0a)                                                                 *
  !     Antisymmetric gradient of Overlap matrix                       *
  !                                                                    *
  !*********************************************************************
  Label = 'OVRGRDA'
  idcnt = 0
  do iCnttp=1,nCnttp
    do iCnt=1,dbsc(iCnttp)%nCntr
      idcnt = idcnt+1
      do idCar=1,3
        call Cnt1El(OvrGrd_mck,OvrMem_mck,Label,idcnt,idcar,loper,-One,.false.,Fock,'OVRGRDA ',0)
      end do
    end do
  end do
  !*********************************************************************
  !0b)                                                                 *
  !     Non-adiabatic second derivative integrals                      *
  !                                                                    *
  !*********************************************************************
  Label = 'NONA2'
  idcnt = 0
  do iCnttp=1,nCnttp
    do iCnt=1,dbsc(iCnttp)%nCntr
      idcnt = idcnt+1
      do idCar=1,3
        call Cnt1El(NONATWO,NA2Mem,Label,idcnt,idcar,loper,One,.false.,Fock,'NONA2   ',0)
      end do
    end do
  end do

end if

!***********************************************************************
!1)                                                                    *
!     Gradient of Overlap matrix                                       *
!                                                                      *
!***********************************************************************
Label = 'OVRGRD'
idcnt = 0
do iCnttp=1,nCnttp
  do iCnt=1,dbsc(iCnttp)%nCntr
    idcnt = idcnt+1
    do idCar=1,3
      call Cnt1El(OvrGrd_mck,OvrMem_mck,Label,idcnt,idcar,loper,One,.false.,Fock,'OVRGRD  ',0)
    end do
  end do
end do
!
!***********************************************************************
!2)                                                                    *
!     Gradient of Kinetic operator                                     *
!                                                                      *
!***********************************************************************
Label = 'KNEGRD'
idcnt = 0
do iCnttp=1,nCnttp
  do iCnt=1,dbsc(iCnttp)%nCntr
    idcnt = idcnt+1
    do idCar=1,3
      call Cnt1El(KneGrd_mck,KneMem_mck,Label,idcnt,idcar,loper,One,.false.,D0,'ONEGRD  ',0)
    end do
  end do
end do
!
!***********************************************************************
!3)                                                                    *
!     Gradient of Nuclear attraction Operator                          *
!                                                                      *
!***********************************************************************
Label = 'NAGRD'
idcnt = 0
do iCnttp=1,nCnttp
  do iCnt=1,dbsc(iCnttp)%nCntr
    idcnt = idcnt+1
    do idCar=1,3
      call Cnt1El(NaGrd_mck,NaMem_mck,Label,idcnt,idcar,loper,One,.true.,D0,'ONEGRD  ',1)
    end do
  end do
end do
!
!
!***********************************************************************
!3)                                                                    *
!     Gradient of Nuclear attraction Operator  ECP-part                *
!                                                                      *
!***********************************************************************
lECP = .false.
do i=1,nCnttp
  lECP = lECP .or. dbsc(i)%ECP
end do
if (lecp) then
  idcnt = 0
  do iCnttp=1,nCnttp
    do iCnt=1,dbsc(iCnttp)%nCntr
      idcnt = idcnt+1
      do idCar=1,3
        Label = 'PRJGRD'
        call Cnt1El(Prjgrd_mck,PrjMm1,Label,idcnt,idcar,loper,One,.true.,D0,'ONEGRD  ',1)
        Label = 'M1GRD'
        call Cnt1El(m1grd_mck,m1Mm1,Label,idcnt,idcar,loper,One,.true.,D0,'ONEGRD  ',1)
        Label = 'SROGRD'
        call Cnt1El(Srogrd_mck,sroMm1,Label,idcnt,idcar,loper,One,.true.,D0,'ONEGRD  ',1)
      end do
    end do
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(D0)
call mma_deallocate(Fock)
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Drvh1_mck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine check_Fthaw(iRC)

use OFembed, only: ThrFThaw
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: iRC
#include "warnings.h"
integer(kind=iwp) :: i, iSeed, iter, iter0, Lu
real(kind=wp) :: DEneA, DEneB, E1, E3, EneA, EneB
logical(kind=iwp) :: ok
character(len=16) :: NamRfil
real(kind=wp), allocatable :: Ene(:,:)
integer(kind=iwp), external :: IsFreeUnit

if (ThrFThaw <= Zero) return

call f_inquire('AUXRFIL',ok)
if (.not. ok) return

call Get_NameRun(NamRfil)
call NameRun('AUXRFIL')
call Get_dScalar('Last energy',EneB)
call NameRun(NamRfil)
call Get_dScalar('Last energy',EneA)

iSeed = 7
Lu = IsFreeUnit(iSeed)
call f_inquire('FRETHAW',ok)
if (.not. ok) then
  call molcas_open(Lu,'FRETHAW')
  !open(Lu,file='FRETHAW')
  write(Lu,'(I4,2F18.10)') 1,EneA,EneB
  close(Lu,status='keep')
else
  call molcas_open(Lu,'FRETHAW')
  !open(Lu,file='FRETHAW',status='old')

  read(Lu,'(I4,2F18.10)') iter0,E1,E3
  if (iter0 == 1000) then
    write(u6,*) ' Error! check_Fthaw: maxIter reached! '
    call Abend()
  end if
  call mma_allocate(Ene,iter0,4,label='Ene')
  Ene(1,1) = E1
  Ene(1,3) = E3
  do i=2,iter0
    read(Lu,'(I4,4F18.10)') iter,Ene(i,1),Ene(i,2),Ene(i,3),Ene(i,4)
  end do

  iter = iter0+1
  DEneA = EneA-Ene(iter0,1)
  DEneB = EneB-Ene(iter0,3)

  rewind Lu
  write(Lu,'(I4,2F18.10)') iter,Ene(1,1),Ene(1,3)
  do i=2,iter0
    write(Lu,'(I4,4F18.10)') iter,Ene(i,1),Ene(i,2),Ene(i,3),Ene(i,4)
  end do
  write(Lu,'(I4,4F18.10)') iter,EneA,DEneA,EneB,DEneB

  write(u6,*)
  write(u6,*) '*******************************************************************************'
  write(u6,*) '*************** Energy Statistics for Freeze-n-Thaw ***************************'
  write(u6,*) '*******************************************************************************'
  write(u6,*) '         Energy_A       Delta(Energy_A)      Energy_B       Delta(Energy_B)'
  write(u6,'(I3,1X,F18.10,18X,F18.10)') 1,Ene(1,1),Ene(1,3)
  do i=2,iter0
    write(u6,'(I3,1X,4F18.10)') i,Ene(i,1),Ene(i,2),Ene(i,3),Ene(i,4)
  end do
  write(u6,'(I3,1X,4F18.10)') iter,EneA,DEneA,EneB,DEneB
  write(u6,*) '*******************************************************************************'

  if ((abs(DEneA) < ThrFThaw) .and. (abs(DEneB) < ThrFThaw)) then
    write(u6,'(A,E9.2,A)') ' Convergence reached ! (Thr = ',ThrFThaw,')'
    write(u6,*)
    iRC = _RC_ALL_IS_WELL_
    close(Lu,status='delete')
  else
    write(u6,'(A,E9.2,A)') ' Convergence NOT reached yet ! (Thr = ',ThrFThaw,')'
    write(u6,*)
    close(Lu,status='keep')
  end if
  call mma_deallocate(Ene)
end if

return

end subroutine check_Fthaw

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_TrcIdl_Init()
C
C     Thomas Bondo Pedersen, May 2010.
C
C     Allocate and init array for tracing idle processors
C
      Implicit None
#include "choptr2.fh"
#include "cho_para_info.fh"
#include "WrkSpc.fh"

      Integer i

      If (Cho_Real_Par) Then
         l_Idle=nProcs
      Else
         l_Idle=1
      End If
      Call GetMem('TrcIdl','Allo','Inte',ip_Idle,l_Idle)

      Do i=0,l_Idle-1
         iWork(ip_Idle+i)=0
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine writegs_cvb()

use casvb_global, only: cvb, cvbdet, iapr, ixapr, nalf, nbet, nda, ndetvb, norb, orbs, recn_tmp04
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ia, ib, idetvb, ioffs, ixa
integer(kind=iwp), allocatable :: iabind(:)

call mma_allocate(iabind,ndetvb,label='iabind')

call str2vbc_cvb(cvb,cvbdet)
ioffs = 0
call wris_cvb([ndetvb],1,recn_tmp04,ioffs)
call wris_cvb([norb],1,recn_tmp04,ioffs)
call wris_cvb([nalf],1,recn_tmp04,ioffs)
call wris_cvb([nbet],1,recn_tmp04,ioffs)
call wrrs_cvb(orbs,norb*norb,recn_tmp04,ioffs)
idetvb = 0
do ia=1,nda
  do ixa=ixapr(ia),ixapr(ia+1)-1
    idetvb = idetvb+1
    ib = iapr(ixa)
    iabind(idetvb) = ia+(ib-1)*nda
  end do
end do
call wris_cvb(iabind,ndetvb,recn_tmp04,ioffs)
call wrrs_cvb(cvbdet,ndetvb,recn_tmp04,ioffs)
call make_cvb('WRITEGS')

call mma_deallocate(iabind)

return

end subroutine writegs_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA_Setup()

! Thomas Bondo Pedersen (CTCC,UiO), July 2013.
!
! Set up RPA calculation:
!    - process input
!    - read reference orbitals

implicit none
character(len=*), parameter :: SecNam = 'RPA_Setup'

! Define data in common blocks (dummy values).
call RPA_SetInc()

! Get and check integral representation from Runfile.
call RPA_SetIntegralRepresentation()
call RPA_CheckIntegralRepresentation()

! Pick up data from Runfile.
call RPA_RdRun()

! Process input.
call RPA_RdInp()

! Read orbitals and orbital energies.
call RPA_RdOrb()

! Postprocessing and print
call RPA_PPInp()

! Add info for testing
call RPA_Setup_Add_Info()

end subroutine RPA_Setup

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GASDIAT(DIAG,LUDIA,ECORE,ICISTR,I12,IBLTP,NBLOCK,IBLKFO)
! CI diagonal in SD basis for state with symmetry ISM in internal
! space ISPC
!
! GAS version, Winter of 95
!
! Driven by table of TTS blocks, May97

use lucia_data, only: I_AM_OUT, IDISK, IREOST, MXNSTR, N_ELIMINATED_BATCHES, NACOB, NELEC, NIRREP, NOCTYP, NSTSO, NTOOB, PSSIGN
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use lucia_data, only: IBSPGPFTP
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: DIAG(*)
integer(kind=iwp), intent(in) :: LUDIA, ICISTR, I12, IBLTP(*), NBLOCK, IBLKFO(8,NBLOCK)
real(kind=wp), intent(in) :: ECORE
integer(kind=iwp) :: IATP, IBTP, MAXA, NAEL, NBEL, NOCTPA
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IOCTPA, IOCTPB, NOCTPB
#endif
integer(kind=iwp), allocatable :: LASTR(:), LBSTR(:)
real(kind=wp), allocatable :: LH1D(:), LJ(:), LK(:), LRJKA(:), LXB(:)
integer(kind=iwp), external :: IMNMX

! Specifications of internal space

IATP = 1
IBTP = 2
NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)
NOCTPA = NOCTYP(IATP)

#ifdef _DEBUGPRINT_
NOCTPB = NOCTYP(IBTP)
! Offsets for alpha and beta supergroups
IOCTPA = IBSPGPFTP(IATP)
IOCTPB = IBSPGPFTP(IBTP)
write(u6,*) ' ==============='
write(u6,*) ' GASDIA speaking'
write(u6,*) ' ==============='
write(u6,*) ' IATP IBTP NAEL NBEL ',IATP,IBTP,NAEL,NBEL
write(u6,*) ' NOCTPA NOCTPB  : ',NOCTPA,NOCTPB
write(u6,*) ' IOCTPA IOCTPB  : ',IOCTPA,IOCTPB
#endif

! Local memory

call mma_allocate(LJ,NTOOB**2,Label='LJ')
call mma_allocate(LK,NTOOB**2,Label='LK')
call mma_allocate(LXB,NACOB,Label='LXB')
call mma_allocate(LH1D,NACOB,Label='LH1D')
! Space for blocks of strings
call mma_allocate(LASTR,MXNSTR*NAEL,Label='LASTR')
call mma_allocate(LBSTR,MXNSTR*NBEL,Label='LBSTR')
MAXA = IMNMX(NSTSO(IATP)%A,NIRREP*NOCTPA,2)
call mma_allocate(LRJKA,MAXA,Label='LRJKA')

! Diagonal of one-body integrals and coulomb and exchange integrals

call GT1DIA(LH1D)
call GTJK(LJ,LK,NTOOB,IREOST)
if (LUDIA > 0) IDISK(LUDIA) = 0
call GASDIAS(NAEL,LASTR,NBEL,LBSTR,NACOB,DIAG,NIRREP,LH1D,LXB,LJ,LK,NSTSO(IATP)%A,NSTSO(IBTP)%A,LUDIA,ECORE,PSSIGN,NTOOB,ICISTR, &
             LRJKA,I12,IBLTP,NBLOCK,IBLKFO,I_AM_OUT,N_ELIMINATED_BATCHES)
! Flush local memory
call mma_deallocate(LJ)
call mma_deallocate(LK)
call mma_deallocate(LXB)
call mma_deallocate(LH1D)
call mma_deallocate(LASTR)
call mma_deallocate(LBSTR)
call mma_deallocate(LRJKA)

end subroutine GASDIAT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine SymAd1(lOper,iAng,jAng,iCmp,jCmp,iShell,jShell,
     &                  iShll,jShll,iAO,jAO,
     &                  AOInt,iBas,jBas,nIC,iIC,
     &                  SOInt,nSOInt,nOp)
************************************************************************
*                                                                      *
* Object: to transform the one-electon matrix elements from AO basis   *
*         to SO basis.                                                 *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January '91                                              *
************************************************************************
      use Basis_Info
      use Symmetry_Info, only: nIrrep, iChTbl, iOper, iChBas
      use SOAO_Info, only: iAOtSO
      use Real_Spherical, only: iSphCr
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 AOInt(iBas*jBas,iCmp,jCmp,nIC), SOInt(iBas*jBas,nSOInt)
      Integer nOp(2)
      Real*8 Prmt(0:7)
      Integer iTwoj(0:7), jIC(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
      Data Prmt/1.d0,-1.d0,-1.d0,1.d0,-1.d0,1.d0,1.d0,-1.d0/
*
*     Statement functions
*
      xPrmt(i,j) = Prmt(iAnd(i,j))
*
      iRout = 133
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Write (6,*) ' lOper=',lOper
         Write (6,*) ' nSOInt=',nSOInt
         Call RecPrt(' In SymAd1: AOInt',' ',AOInt,iBas*jBas,
     &                iCmp*jCmp*nIC)
         Call RecPrt(' In SymAd1: SOInt',' ',SOInt,iBas*jBas,nSOInt)
         Write (6,*) ' iIC=',iIC
      End If
      Do 10 iIrrep = 0, nIrrep-1
         jIC(iIrrep) = -999999999
         If (iAnd(lOper,iTwoj(iIrrep)).eq.0) Cycle
         jIC(iIrrep) = iIC
         iIC = iIC + 1
 10   Continue
*
      ii = iAng*(iAng+1)*(iAng+2)/6
      jj = jAng*(jAng+1)*(jAng+2)/6
*
      lSO = 0
      Do 100 j1 = 0, nIrrep-1
         xa= DBLE(iChTbl(j1,nOp(1)))
         Do 200 i1 = 1, iCmp
            If (iAOtSO(iAO+i1,j1)<0) Cycle
            iChBs = iChBas(ii+i1)
            If (Shells(iShll)%Transf) iChBs = iChBas(iSphCr(ii+i1))
            pae = xPrmt(iOper(nOp(1)),iChBs)
*
            Do 300 j2 = 0, nIrrep-1
               j12 = iEor(j1,j2)
*
               If (iAnd(lOper,iTwoj(j12)).eq.0) Cycle
               kIC = jIC(j12)
               xb = DBLE(iChTbl(j2,nOp(2)))
               jMx = jCmp
               If (iShell.eq.jShell .and. j1.eq.j2) jMx = i1
*
               Do 400 i2 = 1, jMx
                  If (iAOtSO(jAO+i2,j2)<0) Cycle
                  lSO = lSO + 1
                  jChBs = iChBas(jj+i2)
                  If (Shells(jShll)%Transf)
     &               jChBs = iChBas(iSphCr(jj+i2))
                  pbr = xPrmt(iOper(nOp(2)),jChBs)
                  Call DaXpY_(iBas*jBas,xa*pae*xb*pbr,
     &                       AOInt(1,i1,i2,kIC),1,
     &                       SOInt(1,lSO),1)
 400           Continue
*
 300        Continue
*
 200     Continue
 100  Continue
      If (lSO.ne.nSOInt) Then
         Call WarningMessage(2,'Error in SymAd1, lSO.ne.nSOInt')
         Call Abend()
      End If
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In SymAd1: SOInt',' ',SOInt,iBas*jBas,nSOInt)
      End If
      If (iPrint.ge.59) Call GetMem(' Exit SymAd1','CHECK','REAL',
     &                              iDum,iDum)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE get_diag(diag, ndet)
*
* Copies CI diagonal from Lucia enviroment to RASSCF envirmonet
*
      implicit real*8 (a-h,o-z)
#include "io_util.fh"
      dimension diag(*)
#include "clunit.fh"
      dimension idummy(1)
*
      ndet = 0
      IDISK(LUDIA)=0
 100  CONTINUE
      CALL IDAFILE(LUDIA,2,IDUMMY,1,IDISK(LUDIA))
      IDET=IDUMMY(1)
      CALL IDAFILE(LUDIA,2,IDUMMY,1,IDISK(LUDIA))
      IF (idet.eq.-1) GOTO 200
      CALL frmdsc(diag(ndet+1), idet, -1, ludia,
     &     imzero, i_am_packed)
      ndet = ndet + idet
      GOTO 100
*
 200  CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function D_Bond(Ind,iOp_,nStab,jStab,mxdc,nSym)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Integer jStab(0:7,mxdc), nStab(mxdc), Ind(2), iOp_(2)
      Real*8 D_Bond
*                                                                      *
************************************************************************
*                                                                      *
*---- B O N D  (iAtom,jAtom)
*
*---- Compute the stabilizer of P(A) & R(B), this is done in two ways.
*
*     P(A)-R(B) = A-PR(B)
*
*     A=/=B, the stabilizer is formed as the intersection of
*            the stabilizers of A and B.
*
*     A=B, the stabilizer is formed as union of U and R(U)
*
      D_Bond=Zero
*
      iAtom=Ind(1)
      jAtom=Ind(2)
      iOp_E=iOp_(1)
      iOp_R=iOp_(2)
*
      nU_A=nStab(iAtom)
      iU_A=iU(jStab(0,iAtom),nU_A)
      nU_B=nStab(jAtom)
      iU_B=iU(jStab(0,jAtom),nU_B)
*
      If (iAtom.eq.jAtom) Then
         iOp_ER=iEor(iOp_E,iOp_R)
         iU_AB=iOr(iU_A,iUR(iOp_ER,iU_A))
      Else
         iU_AB=iAnd(iU_A,iU_B)
      End If
      nU_AB=nU(iU_AB)
*
*-----Now evaluate the degeneracy of the bond.
*
      iDeg=nSym/nU_AB
      D_Bond=DBLE(iDeg)
*
*     Write (*,*) ' D_Bond=',D_Bond
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Steven Vancoillie                                *
!***********************************************************************

module second_quantization
! Implements determinants of k electrons in n (spin)orbitals as combinations
! (k,n) represented as bitstrings, using 32-bit integers.  Combinations are
! represented in lexicographic ordering, and their rank can be computed using
! a binomial table. The 32nd bit is used for to indicate sign. all-one-bits
! are used to indicate annihilation (destroyed state). Excitation operators
! can be applied to the determinants and return the resulting determinant.
!
! Additionally, a wavefunction is represtented by a structure (derived type)
! consisting of determinant coefficients resulting from the direct product of
! separate alpha and beta determinants.
!
! Steven Vancoillie, November 2013, Lund

use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: onebits(0:255), ranktbl(0:255,64)
integer(kind=iwp), parameter :: b_1111 = int(b'1111',kind=iwp), z_6996 = int(z'6996',kind=iwp)

public :: ann, ann2, binom_coef, cre, cre2, ex1, fase, lex_init, lex_next, lexrank, rank_init

contains

#include "compiler_features.h"

#ifndef TRAILING_ZEROS
#define trailz trailz_
function trailz_(c) result(d)
! simple trailing zero computation, only used when the trailz intrinsic is not supported.

  integer(kind=iwp) :: d
  integer(kind=iwp), intent(in) :: c
  integer(kind=iwp) :: t

  d = 0
  do t=0,bit_size(c)-1
    if (btest(c,t)) exit
    d = d+1
  end do

end function trailz_
#endif

#ifndef IBITS_LEN_ZERO
#define ibits ibits_
function ibits_(c,pos,len) result(d)
! Workaround for ibits not working with zero length

  integer(kind=iwp) :: d
  integer(kind=iwp), intent(in) :: c, pos, len

  d = ishft(not(0),-(bit_size(d)-len))
  d = iand(ishft(c,-pos),d)

end function ibits_
#endif

recursive function gcd(i,j) result(k)

  integer(kind=iwp) :: k
  integer(kind=iwp), intent(in) :: i, j

  if (j == 0) then
    k = i
  else
    k = gcd(j,mod(i,j))
  end if

end function gcd

function binom_coef(k,n)
! compute binomial coefficient
! returns #k-subsets out of n choices

  integer(kind=iwp) :: binom_coef
  integer(kind=iwp), intent(in) :: k, n
  integer(kind=iwp) :: i, frac(2), div

  if (k > n) then
    binom_coef = 0
  else
    frac = 1
    do i=1,k
      frac(1) = frac(1)*(n-k+i)
      frac(2) = frac(2)*i
      div = gcd(frac(1),frac(2))
      if (div > 1) then
        frac = frac/div
      end if
    end do
    binom_coef = frac(1)/frac(2)
  end if

end function binom_coef

function lex_init(k,n) result(c)
! initialize the first combination

  integer(kind=iwp) :: c
  integer(kind=iwp), intent(in) :: k, n

  if (k > n) then
    c = 0
  else
    c = 2**k-1
  end if

end function lex_init

function lex_next(c) result(d)
! generate the next lexicographic bit combination

  integer(kind=iwp) :: d
  integer(kind=iwp), intent(in) :: c
  integer(kind=iwp) :: t, s

  t = ior(c,c-1)+1
  s = iand(not(t-1),t)-1
  d = ior(t,ishft(s,-(trailz(c)+1)))

end function lex_next

subroutine rank_init()
! initializes a rank table indexed as:
!      1 2   3    4        8
!      1 1-8 1-16 1-24 ... 1-56
!  0
!  1
!  ...
!  255
! the row index is a hash table using the
! bit representation of a byte section.
! the columns refer to the position of
! a byte section and the number of possible
! preceding one-bits

  integer(kind=iwp) :: irow, icol, ibyte, ioffset, ibit, ipos, irank

  do irow=0,255
    onebits(irow) = 0
    do ibit=0,7
      if (btest(irow,ibit)) then
        onebits(irow) = onebits(irow)+1
      end if
    end do
  end do

  do irow=0,255
    ! compute rank for first byte
    irank = 0
    ipos = 0
    do ibit=0,7
      if (btest(irow,ibit)) then
        ipos = ipos+1
        irank = irank+binom_coef(ipos,ibit)
      end if
    end do
    icol = 1
    ranktbl(irow,icol) = irank
    ! compute rank for subsequent bytes
    ! depending on the number of preceding
    ! one-bits in the previous bytes
    do ibyte=2,4
      do ioffset=0,8*(ibyte-1)
        icol = icol+1
        ! compute rank
        irank = 0
        ipos = ioffset
        do ibit=0,7
          if (btest(irow,ibit)) then
            ipos = ipos+1
            irank = irank+binom_coef(ipos,ibit+8*(ibyte-1))
          end if
        end do
        ranktbl(irow,icol) = irank
      end do
    end do
  end do

end subroutine rank_init

function lexrank(c)

  integer(kind=iwp) :: lexrank
  integer(kind=iwp), intent(in) :: c
  integer(kind=iwp) :: byte(4), ones(4)

  lexrank = 0
  if (c == -1) return
  byte(1) = ibits(c,0,8)
  byte(2) = ibits(c,8,8)
  byte(3) = ibits(c,16,8)
  byte(4) = ibits(c,24,6)
  ones(1) = onebits(byte(1))
  ones(2) = onebits(byte(2))+ones(1)
  ones(3) = onebits(byte(3))+ones(2)
  lexrank = 1+ranktbl(byte(1),1)+ranktbl(byte(2),2+ones(1))+ranktbl(byte(3),11+ones(2))+ranktbl(byte(4),28+ones(3))

end function lexrank

function fase(c)

  integer(kind=iwp) :: fase
  integer(kind=iwp), intent(in) :: c

  if (btest(c,31)) then
    fase = -1
  else
    fase = 1
  end if

end function fase

function ex1(p,q,c) result(d)

  integer(kind=iwp) :: d
  integer(kind=iwp), intent(in) :: p, q, c
  integer(kind=iwp) :: t

  d = c
  if (.not. btest(d,q-1)) then
    d = -1
    return
  end if
  d = ibclr(d,q-1)
  if (btest(d,p-1)) then
    d = -1
    return
  end if
  d = ibset(d,p-1)
  if (p > q) then
    t = ibits(d,q,p-q-1)
  else if (p < q) then
    t = ibits(d,p,q-p-1)
  else
    return
  end if
  do while (t /= 0)
    d = ieor(ishft(iand(t,1),31),d)
    t = ishft(t,-1)
  end do

end function ex1

function ann(p,c) result(d)
! operates on determinant c with (a_p)
! and returns the resulting determinant with
! the sign in the highest bit (1 = negative)

  integer(kind=iwp) :: d
  integer(kind=iwp), intent(in) :: p, c
  integer(kind=iwp) :: t

  if (.not. btest(c,p-1)) then
    d = -1
    return
  end if
  d = ibclr(c,p-1)
  t = ibits(d,0,p-1)
  t = ieor(t,ishft(t,-16))
  t = ieor(t,ishft(t,-8))
  t = ieor(t,ishft(t,-4))
  t = iand(t,b_1111)
  t = iand(ishft(z_6996,-t),1)
  d = ieor(ishft(t,31),d)

end function ann

function cre(p,c) result(d)
! operates on determinant c with (a+_p)
! and returns the resulting determinant with
! the sign in the highest bit (1 = negative)

  integer(kind=iwp) :: d
  integer(kind=iwp), intent(in) :: p, c
  integer(kind=iwp) :: t

  if (btest(c,p-1)) then
    d = -1
    return
  end if
  d = ibset(c,p-1)
  t = ibits(d,0,p-1)
  t = ieor(t,ishft(t,-16))
  t = ieor(t,ishft(t,-8))
  t = ieor(t,ishft(t,-4))
  t = iand(t,b_1111)
  t = iand(ishft(z_6996,-t),1)
  d = ieor(ishft(t,31),d)

end function cre

function ann2(p,q,c) result(d)
! operates on determinant c with (a_p a_q)
! and returns the resulting determinant with
! the sign in the highest bit (1 = negative)

  integer(kind=iwp) :: d
  integer(kind=iwp), intent(in) :: p, q, c
  integer(kind=iwp) :: t

  if (.not. (btest(c,q-1) .and. btest(c,p-1))) then
    d = -1
    return
  end if
  d = ibclr(c,q-1)
  d = ibclr(d,p-1)
  if (q < p) then
    t = ibits(d,q,p-q-1)
  else if (p < q) then
    t = ibits(d,p,q-p-1)
    d = ieor(ishft(1,31),d)
  else
    d = -1
    return
  end if
  t = ieor(t,ishft(t,-16))
  t = ieor(t,ishft(t,-8))
  t = ieor(t,ishft(t,-4))
  t = iand(t,b_1111)
  t = iand(ishft(z_6996,-t),1)
  d = ieor(ishft(t,31),d)

end function ann2

function cre2(p,q,c) result(d)
! operates on determinant c with (a+_p a+_q)
! and returns the resulting determinant with
! the sign in the highest bit (1 = negative)

  integer(kind=iwp) :: d
  integer(kind=iwp), intent(in) :: p, q, c
  integer(kind=iwp) :: t

  if ((btest(c,q-1) .or. btest(c,p-1))) then
    d = -1
    return
  end if
  d = ibset(c,q-1)
  d = ibset(d,p-1)
  if (q < p) then
    t = ibits(d,q,p-q-1)
    d = ieor(ishft(1,31),d)
  else if (p < q) then
    t = ibits(d,p,q-p-1)
  else
    d = -1
    return
  end if
  t = ieor(t,ishft(t,-16))
  t = ieor(t,ishft(t,-8))
  t = ieor(t,ishft(t,-4))
  t = iand(t,b_1111)
  t = iand(ishft(z_6996,-t),1)
  d = ieor(ishft(t,31),d)

end function cre2

end module second_quantization

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      Integer Function Cho_F2SP(iSP)
C
C     Thomas Bondo Pedersen, March 2006.
C
C     Purpose: return reduced shell pair index for full shell pair index
C              iSP. If not found, 0 is returned.
C              Note: nnShl_SP is used to avoid problems in parallel runs
C              when swapping nnShl and nnShl_G. If properly set,
C              nnShl_SP = nnShl_G.
C
      Implicit None
      Integer iSP
#include "chosp.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer iSP2F, i, jSP

      iSP2F(i)=iWork(ip_iSP2F-1+i)

      Cho_F2SP = 0
      Do jSP = 1,nnShl_SP
         If (iSP2F(jSP) .eq. iSP) Then
            Cho_F2SP = jSP
            Return
         End If
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contf24(wrk,wrksize,lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,lunt2o3)
! this routine does:
! 5)  FII4  f2(m,i) <- sum(n,e>f) [ <ef||mn> . Tap(in,ef)]
!
! N.B. use and destroy : V1,V2,V3,V4,M1
! N.B. # of get v2o2 : 6
! N.B. possible fusion with f14 graph

use ccsd_global, only: f21, f22, idaabb, idbaab, m1, t11, t12, v1, v2, v3, v4
use Para_Info, only: MyRank
use Constants, only: One, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp), intent(_IN_) :: lunabij1, lunabij2, lunabij3, lunt2o1, lunt2o2, lunt2o3
integer(kind=iwp) :: post, rc, ssc

!1 f2(m,i)aa <- sum(n,e>f-aaa) [ <ef||mn>aaaa . Tap(ef,in)aaaa ]

!par
if (myRank == idbaab) then

  !1.1 read V1(af,mn) <= T2o(ef,in)aaaa
  call filemanager(2,lunt2o1,rc)
  call getmediate(wrk,wrksize,lunt2o1,v1,rc)

  !1.2 make Tap V1(ef,in) from V1(ef,in)
  call mktau(wrk,wrksize,v1,t11,t12,Half,rc)

  !1.3 expand V2(ef,i,n) <= V1(ef,in)
  call expand(wrk,wrksize,4,6,v1,1,v2,rc)

  !1.4 map V4(ef,n,i) <= V2(ef,i,n)
  call map(wrk,wrksize,4,1,2,4,3,v2,1,v4,post,rc)

  !1.5 read V1(ef,mn) <= <ef||mn>aaaa
  call filemanager(2,lunabij1,rc)
  call getmediate(wrk,wrksize,lunabij1,v1,rc)

  !1.6 expand V3(ef,m,n) <= V1(ef,mn)
  call expand(wrk,wrksize,4,6,v1,1,v3,rc)

  !1.7 map V1(m,ef,n) <= V3(ef,m,n)
  call map(wrk,wrksize,4,2,3,1,4,v3,1,v1,post,rc)

  !1.8 mult M1(m,i) <= V1(m,ef,n) . V4(ef,n,i)
  call ccmult(wrk,wrksize,4,4,2,3,v1,1,v4,1,m1,ssc,rc)

  !1.9 add f2(m,i)aa <- M1(m,i)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,One,m1,1,f21,1,rc)

end if

!2 f2(m,i)bb <- sum(n,e>f-bbb) [ <ef||mn>bbbb . Tap(ef,in)bbbb ]

!par
if (myRank == idaabb) then

  !2.1 read V1(af,mn) <= T2o(ef,in)bbbb
  call filemanager(2,lunt2o2,rc)
  call getmediate(wrk,wrksize,lunt2o2,v1,rc)

  !2.2 make Tap V1(ef,in) from V1(ef,in)
  call mktau(wrk,wrksize,v1,t11,t12,Half,rc)

  !2.3 expand V2(ef,i,n) <= V1(ef,in)
  call expand(wrk,wrksize,4,6,v1,1,v2,rc)

  !2.4 map V4(ef,n,i) <= V2(ef,i,n)
  call map(wrk,wrksize,4,1,2,4,3,v2,1,v4,post,rc)

  !2.5 read V1(ef,mn) <= <ef||mn>bbbb
  call filemanager(2,lunabij2,rc)
  call getmediate(wrk,wrksize,lunabij2,v1,rc)

  !2.6 expand V3(ef,m,n) <= V1(ef,mn)
  call expand(wrk,wrksize,4,6,v1,1,v3,rc)

  !2.7 map V1(m,ef,n) <= V3(ef,m,n)
  call map(wrk,wrksize,4,2,3,1,4,v3,1,v1,post,rc)

  !2.8 mult M1(m,i) <= V1(m,ef,n) . V4(ef,n,i)
  call ccmult(wrk,wrksize,4,4,2,3,v1,1,v4,1,m1,ssc,rc)

  !2.9 add f2(m,i)bb <- M1(m,i)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,One,m1,1,f22,1,rc)

end if

!3* f2(m,i)aa <- sum(nef-bab) [ <ef||mn>abab . Tap(e,f,i,n)abab ]
!4* f2(m,i)bb <- sum(nef-aab) [ <ef||nm>abab . Tap(e,f,n,i)abab ]

!par
if ((myRank == idbaab) .or. (myRank == idaabb)) then

  !34.1 read V1(e,f,k,l) <= T2o(e,f,k,l)abab
  call filemanager(2,lunt2o3,rc)
  call getmediate(wrk,wrksize,lunt2o3,v1,rc)

  !34.2 read V2(e,f,k,l) <= <ef||kl>abab
  call filemanager(2,lunabij3,rc)
  call getmediate(wrk,wrksize,lunabij3,v2,rc)

  !34.3 make Tap V1(e,f,k,l) from V1(e,f,k,l)
  call mktau(wrk,wrksize,v1,t11,t12,Half,rc)
end if

!par
if (myRank == idbaab) then

  !3.1 map V3(m,e,f,n) <= V2(e,f,m,n)
  call map(wrk,wrksize,4,2,3,1,4,v2,1,v3,post,rc)

  !3.2 map V4(e,f,n,i) <= V1(e,f,i,n)
  call map(wrk,wrksize,4,1,2,4,3,v1,1,v4,post,rc)

  !3.3 mult M1(m,i) <= V3(m,e,f,n) . V4(e,f,n,i)
  call ccmult(wrk,wrksize,4,4,2,3,v3,1,v4,1,m1,ssc,rc)

  !3.4 add f2(m,i)aa <- M1(m,i)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,One,m1,1,f21,1,rc)

end if

!par
if (myRank == idaabb) then

  !4.1 map V3(m,e,f,n) <= V2(e,f,n,m)
  call map(wrk,wrksize,4,2,3,4,1,v2,1,v3,post,rc)

  !4.3 mult M1(m,i) <= V3(m,e,f,n) . V1(e,f,n,i)
  call ccmult(wrk,wrksize,4,4,2,3,v3,1,v1,1,m1,ssc,rc)

  !4.4 add f2(m,i)bb <- M1(m,i)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,One,m1,1,f22,1,rc)

end if

return

end subroutine contf24

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995,1999,2003, Michael A. Saunders                    *
************************************************************************

************************************************************************
* This file from MINRES:                                               *
*   http://web.stanford.edu/group/SOL/software/minres/                 *
*                                                                      *
* The software for MINRES (f77 version) is provided by SOL, Stanford   *
* University under the terms of the OSI Common Public License (CPL):   *
* http://www.opensource.org/licenses/cpl1.0.php                        *
************************************************************************
      subroutine MINRES( n, b, r1, r2, v, w, w1, w2, x, y,
     $                   Aprod, Msolve, checkA, precon, shift,
     $                   nout , itnlim, rtol,
     $                   istop, itn, Anorm, Acond, rnorm, ynorm )

      implicit           none
      external           Aprod, Msolve
      integer            n, nout, itnlim, istop, itn
      logical            checkA, precon
      REAL*8   shift, rtol, Anorm, Acond, rnorm, ynorm,
     $                   b(n), r1(n), r2(n),
     $                   v(n), w(n), w1(n), w2(n), x(n), y(n)
!     ------------------------------------------------------------------
!
!     MINRES  is designed to solve the system of linear equations
!
!                Ax = b
!
!     or the least-squares problem
!
!         min || Ax - b ||_2,
!
!     where A is an n by n symmetric matrix and b is a given vector.
!     The matrix A may be indefinite and/or singular.
!
!     1. If A is known to be positive definite, the Conjugate Gradient
!        Method might be preferred, since it requires the same number
!        of iterations as MINRES but less work per iteration.
!
!     2. If A is indefinite but Ax = b is known to have a solution
!        (e.g. if A is nonsingular), SYMMLQ might be preferred,
!        since it requires the same number of iterations as MINRES
!        but slightly less work per iteration.
!
!     The matrix A is intended to be large and sparse.  It is accessed
!     by means of a subroutine call of the form
!     SYMMLQ development:
!
!                call Aprod ( n, x, y )
!
!     which must return the product y = Ax for any given vector x.
!
!
!     More generally, MINRES is designed to solve the system
!
!                (A - shift*I) x = b
!     or
!         min || (A - shift*I) x - b ||_2,
!
!     where  shift  is a specified scalar value.  Again, the matrix
!     (A - shift*I) may be indefinite and/or singular.
!     The work per iteration is very slightly less if  shift = 0.
!
!     Note: If  shift  is an approximate eigenvalue of  A
!     and  b  is an approximate eigenvector,  x  might prove to be
!     a better approximate eigenvector, as in the methods of
!     inverse iteration and/or Rayleigh-quotient iteration.
!     However, we're not yet sure on that -- it may be better
!     to use SYMMLQ.
!
!     A further option is that of preconditioning, which may reduce
!     the number of iterations required.  If M = C C' is a positive
!     definite matrix that is known to approximate  (A - shift*I)
!     in some sense, and if systems of the form  My = x  can be
!     solved efficiently, the parameters precon and Msolve may be
!     used (see below).  When  precon = .true., MINRES will
!     implicitly solve the system of equations
!
!             P (A - shift*I) P' xbar  =  P b,
!
!     i.e.                  Abar xbar  =  bbar
!     where                         P  =  C**(-1),
!                                Abar  =  P (A - shift*I) P',
!                                bbar  =  P b,
!
!     and return the solution       x  =  P' xbar.
!     The associated residual is rbar  =  bbar - Abar xbar
!                                      =  P (b - (A - shift*I)x)
!                                      =  P r.
!
!     In the discussion below, eps refers to the machine precision.
!     eps is computed by MINRES.  A typical value is eps = 2.22d-16
!     for IEEE double-precision arithmetic.
!
!     Parameters
!     ----------
!
!     n       input      The dimension of the matrix A.
!
!     b(n)    input      The rhs vector b.
!
!     r1(n)   workspace
!     r2(n)   workspace
!     v(n)    workspace
!     w(n)    workspace
!     w1(n)   workspace
!     w2(n)   workspace
!
!     x(n)    output     Returns the computed solution  x.
!
!     y(n)    workspace
!
!     Aprod   external   A subroutine defining the matrix A.
!                        For a given vector x, the statement
!
!                              call Aprod ( n, x, y )
!
!                        must return the product y = Ax
!                        without altering the vector x.
!
!     Msolve  external   An optional subroutine defining a
!                        preconditioning matrix M, which should
!                        approximate (A - shift*I) in some sense.
!                        M must be positive definite.
!                        For a given vector x, the statement
!
!                              call Msolve( n, x, y )
!
!                        must solve the linear system My = x
!                        without altering the vector x.
!
!                        In general, M should be chosen so that Abar has
!                        clustered eigenvalues.  For example,
!                        if A is positive definite, Abar would ideally
!                        be close to a multiple of I.
!                        If A or A - shift*I is indefinite, Abar might
!                        be close to a multiple of diag( I  -I ).
!
!                        NOTE.  The program calling MINRES must declare
!                        Aprod and Msolve to be external.
!
!     checkA  input      If checkA = .true., an extra call of Aprod will
!                        be used to check if A is symmetric.  Also,
!                        if precon = .true., an extra call of Msolve
!                        will be used to check if M is symmetric.
!
!     precon  input      If precon = .true., preconditioning will
!                        be invoked.  Otherwise, subroutine Msolve
!                        will not be referenced; in this case the
!                        actual parameter corresponding to Msolve may
!                        be the same as that corresponding to Aprod.
!
!     shift   input      Should be zero if the system Ax = b is to be
!                        solved.  Otherwise, it could be an
!                        approximation to an eigenvalue of A, such as
!                        the Rayleigh quotient b'Ab / (b'b)
!                        corresponding to the vector b.
!                        If b is sufficiently like an eigenvector
!                        corresponding to an eigenvalue near shift,
!                        then the computed x may have very large
!                        components.  When normalized, x may be
!                        closer to an eigenvector than b.
!
!     nout    input      A file number.
!                        If nout .gt. 0, a summary of the iterations
!                        will be printed on unit nout.
!
!     itnlim  input      An upper limit on the number of iterations.
!
!     rtol    input      A user-specified tolerance.  MINRES terminates
!                        if it appears that norm(rbar) is smaller than
!                              rtol * norm(Abar) * norm(xbar),
!                        where rbar is the transformed residual vector,
!                              rbar = bbar - Abar xbar.
!
!                        If shift = 0 and precon = .false., MINRES
!                        terminates if norm(b - A*x) is smaller than
!                              rtol * norm(A) * norm(x).
!
!     istop   output     An integer giving the reason for termination...
!
!              -1        beta2 = 0 in the Lanczos iteration; i.e. the
!                        second Lanczos vector is zero.  This means the
!                        rhs is very special.
!                        If there is no preconditioner, b is an
!                        eigenvector of A.
!                        Otherwise (if precon is true), let My = b.
!                        If shift is zero, y is a solution of the
!                        generalized eigenvalue problem Ay = lambda My,
!                        with lambda = alpha1 from the Lanczos vectors.
!
!                        In general, (A - shift*I)x = b
!                        has the solution         x = (1/alpha1) y
!                        where My = b.
!
!               0        b = 0, so the exact solution is x = 0.
!                        No iterations were performed.
!
!               1        Norm(rbar) appears to be less than
!                        the value  rtol * norm(Abar) * norm(xbar).
!                        The solution in  x  should be acceptable.
!
!               2        Norm(rbar) appears to be less than
!                        the value  eps * norm(Abar) * norm(xbar).
!                        This means that the residual is as small as
!                        seems reasonable on this machine.
!
!               3        Norm(Abar) * norm(xbar) exceeds norm(b)/eps,
!                        which should indicate that x has essentially
!                        converged to an eigenvector of A
!                        corresponding to the eigenvalue shift.
!
!               4        Acond (see below) has exceeded 0.1/eps, so
!                        the matrix Abar must be very ill-conditioned.
!                        x may not contain an acceptable solution.
!
!               5        The iteration limit was reached before any of
!                        the previous criteria were satisfied.
!
!               6        The matrix defined by Aprod does not appear
!                        to be symmetric.
!                        For certain vectors y = Av and r = Ay, the
!                        products y'y and r'v differ significantly.
!
!               7        The matrix defined by Msolve does not appear
!                        to be symmetric.
!                        For vectors satisfying My = v and Mr = y, the
!                        products y'y and r'v differ significantly.
!
!               8        An inner product of the form  x' M**(-1) x
!                        was not positive, so the preconditioning matrix
!                        M does not appear to be positive definite.
!
!                        If istop .ge. 5, the final x may not be an
!                        acceptable solution.
!
!     itn     output     The number of iterations performed.
!
!     Anorm   output     An estimate of the norm of the matrix operator
!                        Abar = P (A - shift*I) P',   where P = C**(-1).
!
!     Acond   output     An estimate of the condition of Abar above.
!                        This will usually be a substantial
!                        under-estimate of the true condition.
!
!     rnorm   output     An estimate of the norm of the final
!                        transformed residual vector,
!                           P (b  -  (A - shift*I) x).
!
!     ynorm   output     An estimate of the norm of xbar.
!                        This is sqrt( x'Mx ).  If precon is false,
!                        ynorm is an estimate of norm(x).
!     ------------------------------------------------------------------
!
!
!     MINRES is an implementation of the algorithm described in
!     the following reference:
!
!     C. C. Paige and M. A. Saunders (1975),
!     Solution of sparse indefinite systems of linear equations,
!     SIAM J. Numer. Anal. 12(4), pp. 617-629.
!     ------------------------------------------------------------------
!
!
!     MINRES development:
!            1972: First version, similar to original SYMMLQ.
!                  Later lost @#%*!
!        Oct 1995: Tried to reconstruct MINRES from
!                  1995 version of SYMMLQ.
!     30 May 1999: Need to make it more like LSQR.
!                  In middle of major overhaul.
!     19 Jul 2003: Next attempt to reconstruct MINRES.
!                  Seems to need two vectors more than SYMMLQ.  (w1, w2)
!                  Lanczos is now at the top of the loop,
!                  so the operator Aprod is called in just one place
!                  (not counting the initial check for symmetry).
!     22 Jul 2003: Success at last.  Preconditioning also works.
!                  minres.f added to http://www.stanford.edu/group/SOL/.
!
!     FUTURE WORK: A stopping rule is needed for singular systems.
!                  We need to estimate ||Ar|| as in LSQR.  This will be
!                  joint work with Sou Cheng Choi, SCCM, Stanford.
!                  Note that ||Ar|| small => r is a null vector for A.
!
!
!     Michael A. Saunders           na.msaunders@na-net.ornl.gov
!     Department of MS&E            saunders@stanford.edu
!     Stanford University
!     Stanford, CA 94305-4026       (650) 723-1875
!     ------------------------------------------------------------------
!
!
!     Subroutines and functions
!
!     USER       Aprod , Msolve
!     BLAS1      daxpy , dcopy , ddot  , dnrm2  } These are all in
!     Utilities  daxpy2, dload2, dscal2         } the file minresblas.f

!     Functions

      real*8, external :: ddot_

!     Local variables

      REAL*8   alfa  , beta  , beta1 , cs    ,
     $                   dbar  , delta , denom , diag  ,
     $                   eps   , epsa  , epsln , epsr  , epsx  ,
     $                   gamma , gbar  , gmax  , gmin  ,
     $                   oldb  , oldeps, qrnorm, phi   , phibar,
     $                   rhs1  , rhs2  , s     , sn    , t     ,
     $                   tnorm2, ynorm2, z
      integer            i
      logical            debug, prnt

      REAL*8   zero, one, two, ten
      parameter        ( zero = 0.0d+0,  one =  1.0d+0,
     $                   two  = 2.0d+0,  ten = 10.0d+0 )

      character*16       enter, exit
      character*52       msg(-1:8)

      data               enter /' Enter MINRES.  '/,
     $                   exit  /' Exit  MINRES.  '/

      data               msg
     $ / 'beta2 = 0.  If M = I, b and x are eigenvectors of A',
     $   'beta1 = 0.  The exact solution is  x = 0',
     $   'Requested accuracy achieved, as determined by rtol',
     $   'Reasonable accuracy achieved, given eps',
     $   'x has converged to an eigenvector',
     $   'Acond has exceeded 0.1/eps',
     $   'The iteration limit was reached',
     $   'Aprod  does not define a symmetric matrix',
     $   'Msolve does not define a symmetric matrix',
     $   'Msolve does not define a pos-def preconditioner' /
!     ------------------------------------------------------------------

      debug = .false.
      gmax= 99999999
      gmin=-99999999

!     ------------------------------------------------------------------
!     Compute eps, the machine precision.  The call to daxpy is
!     intended to fool compilers that use extra-length registers.
!     31 May 1999: Hardwire eps so the debugger can step thru easily.
!     ------------------------------------------------------------------
      eps    = 2.22d-16    ! Set eps = zero here if you want it computed

      if (eps .le. zero) then
         eps    = two**(-12)
   10       eps    = eps / two
            x(1)   = eps
            y(1)   = one
            call daxpy_( 1, one, x, 1, y, 1 )
            if (y(1) .gt. one) go to 10
         eps    = eps * two
      end if

!     ------------------------------------------------------------------
!     Print heading and initialize.
!     ------------------------------------------------------------------
      if (nout .gt. 0) then
         write(nout, 1000) enter, n, checkA, precon,
     $                     itnlim, rtol, shift
      end if
      istop  = 0
      itn    = 0
      Anorm  = zero
      Acond  = zero
      rnorm  = zero
      ynorm  = zero
      call dload2( n, zero, x )

!     ------------------------------------------------------------------
!     Set up y and v for the first Lanczos vector v1.
!     y  =  beta1 P' v1,  where  P = C**(-1).
!     v is really P' v1.
!     ------------------------------------------------------------------
      call dcopy_( n, b, 1, y , 1 )         ! y  = b
      call dcopy_( n, b, 1, r1, 1 )         ! r1 = b
      if ( precon ) call Msolve( n, b, y )
      beta1  = ddot_( n, b, 1, y, 1 )

      if (beta1 .lt. zero) then    ! M must be indefinite.
         istop = 8
         go to 900
      end if

      if (beta1 .eq. zero) then    ! b = 0 exactly.  Stop with x = 0.
         istop = 0
         go to 900
      end if

      beta1  = sqrt( beta1 )       ! Normalize y to get v1 later.

!     ------------------------------------------------------------------
!     See if Msolve is symmetric.
!     ------------------------------------------------------------------
      if (checkA  .and.  precon) then
         call Msolve( n, y, r2 )
         s      = ddot_( n, y, 1, y, 1 )
         t      = ddot_( n,r1, 1,r2, 1 )
         z      = abs( s - t )
         epsa   = (s + eps) * eps**0.33333d+0
         if (z .gt. epsa) then
            istop = 7
            go to 900
         end if
      end if

!     ------------------------------------------------------------------
!     See if Aprod  is symmetric.
!     ------------------------------------------------------------------
      if (checkA) then
         call Aprod ( n, y, w )
         call Aprod ( n, w, r2 )
         s      = ddot_( n, w, 1, w, 1 )
         t      = ddot_( n, y, 1,r2, 1 )
         z      = abs( s - t )
         epsa   = (s + eps) * eps**0.33333d+0
         if (z .gt. epsa) then
            istop = 6
            go to 900
         end if
      end if

!     ------------------------------------------------------------------
!     Initialize other quantities.
!     ------------------------------------------------------------------
      oldb   = zero
      beta   = beta1
      dbar   = zero
      epsln  = zero
      qrnorm = beta1
      phibar = beta1
      rhs1   = beta1
      rhs2   = zero
      tnorm2 = zero
      ynorm2 = zero
      cs     = - one
      sn     = zero
      call dload2( n, zero, w  )        ! w  = 0
      call dload2( n, zero, w2 )        ! w2 = 0
      call dcopy_( n, r1, 1, r2, 1 )    ! r2 = r1

      if (debug) then
         write(6,*) ' '
         write(6,*) 'b    ', b
         write(6,*) 'beta ', beta
         write(6,*) ' '
      end if

!     ------------------------------------------------------------------
!     Main iteration loop.
!     ------------------------------------------------------------------
  100 itn    = itn   +  1               ! k = itn = 1 first time through
      if (istop .ne. 0) go to 900

      !-----------------------------------------------------------------
      ! Obtain quantities for the next Lanczos vector vk+1, k = 1, 2,...
      ! The general iteration is similar to the case k = 1 with v0 = 0:
      !
      !   p1      = Operator * v1  -  beta1 * v0,
      !   alpha1  = v1'p1,  '
      !   q2      = p2  -  alpha1 * v1,
      !   beta2^2 = q2'q2,  '
      !   v2      = (1/beta2) q2.
      !
      ! Again, y = betak P vk,  where  P = C**(-1).
      ! .... more description needed.
      !-----------------------------------------------------------------
      s      = one / beta            ! Normalize previous vector (in y).
      call dscal2( n, s, y, v )      ! v = vk if P = I

      call Aprod ( n, v, y )
      call daxpy_( n, (- shift), v, 1, y, 1 )
      if (itn .ge. 2) then
         call daxpy_( n, (- beta/oldb), r1, 1, y, 1 )
      end if

      alfa   = ddot_( n, v, 1, y, 1 )     ! alphak

      call daxpy_( n, (- alfa/beta), r2, 1, y, 1 )
      call dcopy_( n, r2, 1, r1, 1 )
      call dcopy_( n,  y, 1, r2, 1 )
      if ( precon ) call Msolve( n, r2, y )

      oldb   = beta                        ! oldb = betak
      beta   = ddot_( n, r2, 1, y, 1 )    ! beta = betak+1^2
      if (beta .lt. zero) then
         istop = 6
         go to 900
      end if

      beta   = sqrt( beta )                ! beta = betak+1
      tnorm2 = tnorm2 + alfa**2 + oldb**2 + beta**2

      if (itn .eq. 1) then                 ! Initialize a few things.
         if (beta/beta1 .le. ten*eps) then ! beta2 = 0 or ~ 0.
            istop = -1                     ! Terminate later.
         end if
        !tnorm2 = alfa**2
         gmax   = abs( alfa )              ! alpha1
         gmin   = gmax                     ! alpha1
      end if

      ! Apply previous rotation Qk-1 to get
      !   [deltak epslnk+1] = [cs  sn][dbark    0   ]
      !   [gbar k dbar k+1]   [sn -cs][alfak betak+1].

      oldeps = epsln
      delta  = cs * dbar  +  sn * alfa ! delta1 = 0         deltak
      gbar   = sn * dbar  -  cs * alfa ! gbar 1 = alfa1     gbar k
      epsln  =               sn * beta ! epsln2 = 0         epslnk+1
      dbar   =            -  cs * beta ! dbar 2 = beta2     dbar k+1

      ! Compute the next plane rotation Qk

      gamma  = sqrt( gbar**2 + beta**2 )   ! gammak
      cs     = gbar / gamma                ! ck
      sn     = beta / gamma                ! sk
      phi    = cs * phibar                 ! phik
      phibar = sn * phibar                 ! phibark+1

      if (debug) then
         write(6,*) ' '
         write(6,*) 'v    ', v
         write(6,*) 'alfa ', alfa
         write(6,*) 'beta ', beta
         write(6,*) 'gamma', gamma
         write(6,*) 'delta', delta
         write(6,*) 'gbar ', gbar
         write(6,*) 'epsln', epsln
         write(6,*) 'dbar ', dbar
         write(6,*) 'phi  ', phi
         write(6,*) 'phiba', phibar
         write(6,*) ' '
      end if

      ! Update  x.

      denom = one/gamma

      do i = 1, n
         w1(i) = w2(i)
         w2(i) = w(i)
         w(i)  = ( v(i) - oldeps*w1(i) - delta*w2(i) ) * denom
         x(i)  =   x(i) +   phi * w(i)
      end do

      ! Go round again.

      gmax   = max( gmax, gamma )
      gmin   = min( gmin, gamma )
      z      = rhs1 / gamma
      ynorm2 = z**2  +  ynorm2
      rhs1   = rhs2  -  delta * z
      rhs2   =       -  epsln * z

      ! Estimate various norms and test for convergence.

      Anorm  = sqrt( tnorm2 )
      ynorm  = sqrt( ynorm2 )
      epsa   = Anorm * eps
      epsx   = Anorm * ynorm * eps
      epsr   = Anorm * ynorm * rtol
      diag   = gbar
      if (diag .eq. zero) diag = epsa

      qrnorm = phibar
      rnorm  = qrnorm

      ! Estimate  cond(A).
      ! In this version we look at the diagonals of  R  in the
      ! factorization of the lower Hessenberg matrix,  Q * H = R,
      ! where H is the tridiagonal matrix from Lanczos with one
      ! extra row, beta(k+1) e_k^T.

      Acond  = gmax / gmin

      ! See if any of the stopping criteria are satisfied.
      ! In rare cases, istop is already -1 from above (Abar = const*I).

      if (istop .eq. 0) then
         if (itn    .ge. itnlim    ) istop = 5
         if (Acond  .ge. 0.1d+0/eps) istop = 4
         if (epsx   .ge. beta1     ) istop = 3
         if (qrnorm .le. epsx      ) istop = 2
         if (qrnorm .le. epsr      ) istop = 1
      end if


      ! See if it is time to print something.

      if (nout .gt. 0) then
         prnt   = .false.
         if (n      .le. 40         ) prnt = .true.
         if (itn    .le. 10         ) prnt = .true.
         if (itn    .ge. itnlim - 10) prnt = .true.
         if (mod(itn,10)  .eq.     0) prnt = .true.
         if (qrnorm .le.  ten * epsx) prnt = .true.
         if (qrnorm .le.  ten * epsr) prnt = .true.
         if (Acond  .ge. 1.0d-2/eps ) prnt = .true.
         if (istop  .ne.  0         ) prnt = .true.

         if ( prnt ) then
            if (    itn     .eq. 1) write(nout, 1200)
            write(nout, 1300) itn, x(1), qrnorm, Anorm, Acond
            if (mod(itn,10) .eq. 0) write(nout, 1500)
         end if
      end if

      go to 100
!     ------------------------------------------------------------------
!     End of main iteration loop.
!     ------------------------------------------------------------------

      ! Display final status.

  900 if (nout  .gt. 0) then
         write(nout, 2000) exit, istop, itn,
     $                     exit, Anorm, Acond,
     $                     exit, rnorm, ynorm
         write(nout, 3000) exit, msg(istop)
      end if

      return


 1000 format(// 1p,    a, 5x, 'Solution of symmetric   Ax = b'
     $       / ' n      =', i7, 5x, 'checkA =', l4, 12x,
     $          'precon =', l4
     $       / ' itnlim =', i7, 5x, 'rtol   =', e11.2, 5x,
     $          'shift  =', e23.14)
 1200 format(// 5x, 'itn', 8x, 'x(1)', 10x,
     $         'norm(r)', 3x, 'norm(A)', 3X, 'cond(A)')
 1300 format(1p, i8, e19.10, 3e10.2)
 1500 format(1x)
 2000 format(/ 1p, a, 5x, 'istop =', i3,   14x, 'itn   =', i8
     $       /     a, 5x, 'Anorm =', e12.4, 5x, 'Acond =', e12.4
     $       /     a, 5x, 'rnorm =', e12.4, 5x, 'ynorm =', e12.4)
 3000 format(      a, 5x, a )

      end ! subroutine MINRES

*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine dload2( n, const, x )

      implicit           none
      integer            n
      REAL*8   const, x(n)

*     ------------------------------------------------------------------
*     dload2 loads all elements of x with const.
*     ------------------------------------------------------------------

      integer            i

      do i = 1, n
         x(i) = const
      end do

      end ! subroutine dload2

*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine dscal2( n, a, x, y )

      implicit           none
      integer            n
      REAL*8   a, x(n), y(n)

*     ------------------------------------------------------------------
*     dscal2 sets y = a*x.
*     ------------------------------------------------------------------

      integer            i

      do i = 1, n
         y(i) = a*x(i)
      end do

      end ! subroutine dscal2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine PutCMSFockOcc(FOccMO,nTri)

use MCLR_Data, only: ipMat, nDens
use input_mclr, only: nBas, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: FOccMO(nDens)
integer(kind=iwp), intent(in) :: nTri
integer(kind=iwp) :: iB, ijb, iS, jB
real(kind=wp), allocatable :: F(:), T(:)

call mma_allocate(F,nDens)
call mma_allocate(T,nDens)

F(:) = Zero
call Get_dArray_chk('FockOcc',F,nTri)
! WF Part
T(:) = FOccMO(:)
call TCMO(T,1,-2)
ijb = 0
do iS=1,nSym
  do ib=1,nbas(is)
    do jb=1,ib-1
      ijb = ijb+1
      F(ijb) = F(ijb)+T(ipmat(is,is)+nbas(is)*(jb-1)+ib-1)+T(ipmat(is,is)+nbas(is)*(ib-1)+jb-1)
    end do
    ijb = ijb+1
    F(ijb) = F(ijb)+T(ipmat(is,is)+nbas(is)*(ib-1)+ib-1)
  end do
end do
call Put_dArray('FockOcc',F,nDens)
call mma_deallocate(F)
call mma_deallocate(T)

end subroutine PutCMSFockOcc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine removeB1 (length,coeff,operator)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 12.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************

      implicit none
#include "dkhparameters.fh"

      integer length
      REAL*8 coeff
      character*(maxlength) operator

      integer k,l,m,dumleng,idum

      do 10 k=length,2,-1
        if (operator(k:k).eq.'B') then
          if (operator(k-1:k-1).eq.'B') then
            operator(k:k)=' '
            operator(k-1:k-1)=' '
          else if (operator(k-1:k-1).eq.'P') then
            coeff=-coeff
            operator(k-1:k-1)='B'
            operator(k:k)='P'
          else
            operator(k:k)=operator(k-1:k-1)
            operator(k-1:k-1)='B'
          endif
        endif
  10  continue

      dumleng=length
      idum=0
      do 20 l=1,dumleng
        idum=idum+1
        if (operator(idum:idum).eq.' ' .and. idum.le.length) then
          do 30 m=idum+1,length
            operator(m-1:m-1)=operator(m:m)
  30      continue
          if (operator(idum:idum).eq.' ') idum=idum-1
          operator(length:length)=' '
          length=length-1
        endif
  20  continue

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module DKH_Info

use Constants, only: Zero, One, c_in_au
use Definitions, only: wp, iwp

implicit none
private

! IRELMP = 0  .... NOPAIR (DK2)
!        = 1  .... NOPAIR (DK1)
!        = 2  .... NOPAIR (DK2)
!        = 3  .... NOPAIR (DK3)
!        = 4  .... full NOPAIR (DK3)
!        = 11 .... RESC
!        = 21 .... ZORA
!        = 22 .... ZORA-FP
!        = 23 .... IORA
!
! IRELAE = 0  .... DKH
!        = 1  .... DK1
!        = 2  .... DK2
!        = 3  .... DK3
!        = 4  .... DK3full
!        = 11 .... RESC
!        = 21 .... ZORA
!        = 22 .... ZORA(FP)
!        = 23 .... IORA
!        = 101.... X2C
!        = 102.... BSS
!
! NB: The IRELAE flag has been extended to account for
!     arbitrary-order DKH with different parametrizations!
!     IMPORTANT: new arbitrary-order DKH routines are only
!                called for IRELAE values LARGER than 1000.

integer(kind=iwp) :: nCtrLD = 0, iCtrLD(10) = [0,0,0,0,0,0,0,0,0,0], iRelae = -1, iRelmp = -1
real(kind=wp) :: radiLD = Zero, cLightAU = c_in_au
logical(kind=iwp) :: DKroll = .false., LDKroll = .false., BSS = .false.

public :: nCtrLD, iCtrLD, radiLD, DKroll, LDKroll, BSS, iRelae, iRelmp, cLightAU, DKH_Info_Get, DKH_Info_Dmp

contains

subroutine DKH_Info_Dmp()
  use stdalloc, only: mma_allocate, mma_deallocate
  real(kind=wp), allocatable :: rDmp(:)
  integer(kind=iwp) :: i
  integer(kind=iwp), parameter :: Length = 17

  call mma_allocate(rDmp,Length,Label='rDmp:DKH')
  rDmp(1) = real(nCtrLD,kind=wp)
  do i=1,10
    rDmp(i+1) = iCtrLD(i)
  end do
  rDmp(12) = radiLD
  rDmp(13) = merge(One,Zero,DKroll)
  rDmp(14) = merge(One,Zero,LDKroll)
  rDmp(15) = merge(One,Zero,BSS)
  rDmp(16) = cLightAU
  rDmp(17) = real(iRelae,kind=wp)
  call Put_dArray('DKH_Info',rDmp,Length)
  call mma_deallocate(rDmp)
end subroutine DKH_Info_Dmp

subroutine DKH_Info_Get()
  use stdalloc, only: mma_allocate, mma_deallocate
  real(kind=wp), allocatable :: rDmp(:)
  integer(kind=iwp) :: i
  integer(kind=iwp), parameter :: Length = 17

  call mma_allocate(rDmp,Length,Label='rDmp:DKH')
  call Get_dArray('DKH_Info',rDmp,Length)

  nCtrLD = nint(rDmp(1))
  do i=1,10
    iCtrLD(i) = nint(rDmp(i+1))
  end do
  radiLD = rDmp(12)
  DKroll = nint(rDmp(13)) == 1
  LDKroll = nint(rDmp(14)) == 1
  BSS = nint(rDmp(15)) == 1
  cLightAU = rDmp(16)
  iRelae = nint(rDmp(17))

  call mma_deallocate(rDmp)
end subroutine DKH_Info_Get

end module DKH_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Bjorn O. Roos                                    *
*               1989, Per Ake Malmqvist                                *
*               1991,1993,1996, Markus P. Fuelscher                    *
************************************************************************
      Subroutine SXCtl(CMO,OCC,D,P,PA,FI,FA,D1A,THMAX,IFINAL)
********************************************************************
*                                                                  *
* super-CI control section                                         *
*                                                                  *
* calling arguments:                                               *
* CMO     : array of real*8                                        *
*           MO-coefficients                                        *
* OCC     : array of real*8                                        *
*           orbital occupation numbers                             *
* D       : array of real*8                                        *
*           averaged one-body density matrix                       *
* P       : array of real*8                                        *
*           averaged two-body density matrix                       *
* PA      : array of real*8                                        *
*           averaged antisymmetric two-body density matrix         *
* FI      : array of real*8                                        *
*           inactive Fock matrix                                   *
* FA      : array of real*8                                        *
*           active Fock matrix                                     *
* D1A     : array of real*8                                        *
*           active one-body density matrix in AO basis             *
* IFINAL  : integer                                                *
*           termination flag                                       *
*                                                                  *
*------------------------------------------------------------------*
*                                                                  *
* written by:                                                      *
* B.O. Roos and P.Aa. Malmqvist                                    *
* University of Lund, Sweden, 1989                                 *
*                                                                  *
*------------------------------------------------------------------*
*                                                                  *
* history:                                                         *
* - updated for MOLCAS version 2                                   *
*   M.P. Fuelscher, University of Lund, Sweden, 1991               *
* - updated for MOLCAS version 3                                   *
*   M.P. Fuelscher, University of Lund, Sweden, 1993               *
* - updated for integral direct and reaction field calculations    *
*   M.P. Fuelscher, University of Lund, Sweden, 1996               *
*                                                                  *
********************************************************************

#ifdef _DMRG_
      use qcmaquis_interface_cfg
#endif
      use fciqmc, only : DoNECI
#ifdef _HDF5_
      use mh5, only: mh5_put_dset
      use raswfn, only: wfn_mocoef, wfn_occnum
#endif
      use stdalloc, only: mma_allocate, mma_deallocate
      use Fock_util_global, only: ALGO, DoCholesky
      use Lucia_Interface, only: Lucia_Util
      use wadr, only: DIA, SXN, BM, F1, F2, SXG, SXH, NLX
      use input_ras, only: KeyHEUR
      use rasscf_global, only: ExFac, KSDFT, DoBlockDMRG, DoDMRG, ECAS,
     &                         ESX, iCIOnly, iPT2, ITER, ITERSX, ITMAX,
     &                         l_casdft, NAC, nDimSX, nFint, NO2M,
     &                         nQune, NROOT, NSXS, NTOT4, QNSTEP,
     &                         QNUPDT, SXSEL, TMIN, VIA, ISTORP,
     &                         IADR15, EMY
      use PrintLevel, only: DEBUG
      use output_ras, only: LF,IPRLOC
      use general_data, only: NSYM,NACTEL,JOBIPH,LUINTM,LUQUNE,NASH,
     &                        NBAS,NDEL,NFRO,NISH,NORB,NRS1,NRS2,NRS3,
     &                        NSSH,NTOT,NTOT1,NTOT2


      Implicit None

      Real*8 CMO(*),OCC(*),D(*),P(*),PA(*),FI(*),FA(*),D1A(*)
      Real*8 THMAX
      INTEGER IFINAL

      Character(LEN=16), Parameter :: ROUTINE='SXCTL   '
* PAM 2008 IndType, VecTyp added, see below at call to WrVec
      Integer IndType(56)
      Character(LEN=80) VecTyp
      Integer, Save ::nCall
      Logical TraOnly
      Real*8 P2act(1),CIDUMMY(1)
      Real*8, Allocatable:: SXHD(:)
      Real*8, Allocatable, Target:: SMAT(:)
      Real*8, Allocatable:: PUVX(:), DA(:), STRP(:), P2reo(:), P2Raw(:),
     &                      Fck(:), QMat(:), EDum(:), CMON(:), FTR(:),
     &                      Vec(:), WO(:), SQ(:), CMOX(:), SXDF(:),
     &                      SXDD(:), CSX(:), Sigma(:), HH(:), CC(:),
     &                      ENER_X(:), SC(:), QQ(:), OVL(:), VT(:),
     &                      VL(:), XQN(:), SCR(:), V1(:), V2(:),
     &                      XMAT(:), X2(:)
      Real*8 :: Dummy(1), CASDFT_En, CPES, CPTS, P2reo_size, TIOES,
     &          TIOS, XSXMAX
      Real*8, External :: DDot_
      Integer :: i, iBas, IC, iDisk, IndT, iOff, iOrb, iPrLev, iRC,
     &           iRef, iShift, iSym, iWay, j, kMax, LCSXI, LuvvVec,
     &           MIAAE, MNO, NA, NAEAE, NAOAE, NB, NCR, NCR1, NE, NI,
     &           NIA, NIAIA, NLCC, NLHH, NLOVL, NLQ, NLX1, NLX2, NO,
     &           nP2Act, NQ, NAE
      Integer, External:: IsFreeUnit

C PAM01 The SXCI part has been slightly modified by P-AA M Jan 15, 2001:
C Changes affect several of the subroutines of this part.
C The program should now behave more gracefully when there are (almost)
C redundant orbital rotation modes.
C For individual 2x2 rotations that are to be excluded, the SX hamiltonian
C diagonal, used in the preconditioning step in DAVCRE, is set to a huge
C value. Corresponding elements of trial vectors and sigma vectors are
C zeroed.
C To take care of 'hidden' redundant linear combinations, a small extra
C term, proportional to the square norm of the orbital rotations, is
C added to the optimization problem: this means in practice that a small
C extra term is added in the SIGVEC routine.
C Also, an extra term is added to the overlap calculation. The
C proportionality factor in SIGVEC should be small, but larger than the
C one used in the COVLP routine.
C Presently I try the following values:
C Huge elements in diagonal values: 1.0D32
C (Tested against 1.0D20 in IF-statements)
C Extra term in overlaps (COVLP, SXHAM): 1.0D-14
C Extra term in SIGVEC:                  1.0D-12


C Local print level (if any)
      IPRLEV=IPRLOC(4)
c      write(6,*) 'Entering SXCTL!'
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF

C --- Check for Cholesky ---------------

c      Call DecideOnCholesky(DoCholesky)
C --------------------------------------

* compute constants needed for addressing
      NLX1=0
      NLX2=0
      NQ=0
      NSXS=0
      NIAIA=0
      NAEAE=0
      NAOAE=0
      MNO=0
      MIAAE=0
      NLX=0
      DO 10 ISYM=1,NSYM
       NB=NBAS(ISYM)
       NA=NASH(ISYM)
       NI=NISH(ISYM)
       NE=NSSH(ISYM)
       NO=NORB(ISYM)
       NIA=NI+NA
       NAE=NA+NE
       NSXS=NSXS+NIA*NAE
       NIAIA=NIAIA+NIA**2
       NAEAE=NAEAE+NAE**2
       NAOAE=NAOAE+NA*NAE
       NLX1=MAX(NLX1,NO**2)
       NLX2=MAX(NLX2,NB*NO)
       NQ=MAX(NQ,NA*NO)
       MNO=MAX(MNO,NO)
       MIAAE=MAX(MIAAE,NIA*NAE)
       NLX=MAX(NLX,NIA*NA,NIA*NAE)
10    CONTINUE
      IF(NQ.LT.NIAIA) NQ=NIAIA
      NROOT=1
      NDIMSX=NROOT+NSXS
************************************************************************
* load back two-electron integrals (pu|vx)
************************************************************************
      If (.not.DoCholesky .or. ALGO.eq.1) Then
        If ( nFint.gt.0) then
          iDisk = 0
          Call mma_allocate(PUVX,nFint,Label='PUVX')
          Call DDaFile(LUINTM,2,PUVX,nFint,iDisk)
        Else
          Call mma_allocate(PUVX,1,Label='PUVX')
        EndIf
      End If
      IF(IPRLEV.ge.DEBUG) THEN
       write(6,*) 'PUVX integrals in SXCTL'
       call wrtmat(PUVX,1,nFInt,1,nFInt)
      END IF
*********************************************************************************
* update and transform the Fock matrices FI and FA in MO basis ----> Fmat routine
*********************************************************************************
      If (.not.DoCholesky .or. ALGO.eq.1) Then
         Call Fmat(CMO,PUVX,D,D1A,FI,FA)

      ElseIf (ALGO.eq.2) Then

*     Inactive-active contribution to ECAS
         Call mma_allocate(DA,nTot1,Label='DA')
         Call Fold(nSym,nBas,D1A,DA) !get the packed DA
         VIA=dDot_(nTot1,FI,1,DA,1)
         ECAS=EMY+VIA
         If ( IPRLEV.ge.DEBUG ) then
           Write(LF,'(A,ES20.10)') ' Total core energy:            ',EMY
           Write(LF,'(A,ES20.10)') ' inactive-active interaction:  ',VIA
           Write(LF,'(A,ES20.10)') ' CAS energy (core+interaction):',
     &                             ECAS
         End If
         Call mma_deallocate(DA)

         TraOnly=.true.
         Call CHO_CAS_DRV(irc,CMO,D,FI,D1A,FA,Dummy,TraOnly)

         if (irc.ne.0) then
         Write(LF,*)'SXCTL: Cho_cas_drv non-zero return code! rc= ',irc
         call abend()
         endif

      Else

         Write(LF,*)'SXCTL: Illegal Cholesky parameter ALGO= ',ALGO
         call abend()

      EndIf
************************************************************************
* reorder the two-body density matrix P
************************************************************************
      IF(.not.l_casdft) then
* ISTORP(NSYM+1) represents the size of the 2-body density matrix,d(vwxy), with vwxy all active.
* the size is computed as NAP*NAQ*NRS (sum over all symmetries). If Sym_R = Sym_S then triangular
* form over NRS... with R.ge.S, rectanguar otherwise.
       IF(ISTORP(NSYM+1).GT.0) THEN
         CALL mma_allocate(STRP,ISTORP(NSYM+1),Label='STRP')

         CALL PMAT_RASSCF(P,STRP)

         If (ExFac.ne.1.0D0 .and.KSDFT(1:3).ne.'SCF') Then
            CALL mma_allocate(P2reo,ISTORP(NSYM+1),Label='P2reo')
            Call Get_Temp('nP2Act  ',P2Act,1)
            nP2Act=Int(P2Act(1))
            CALL mma_allocate(P2RAW,nP2Act,Label='P2Raw')
            Call Get_Temp('P2_RAW  ',P2RAW,nP2Act)
            CALL PMAT_RASSCF(P2RAW,P2reo)
            Call mma_deallocate(P2Raw)
            P2reo_size=DBLE(ISTORP(NSYM+1))
            Call Put_Temp('nP2reo  ',[P2reo_size],1)
            Call Put_Temp('P2_reo  ',P2reo,ISTORP(NSYM+1))
            Call mma_deallocate(P2reo)
         End If
       ELSE
         CALL mma_allocate(STRP,1,Label='STRP')
       END IF
      ELSE ! GLM-CASDFT
* ISTORP(NSYM+1) here represents the size of the Dvw*Dxy array (product of one-body
* density matrix,d(vwxy), with vwxy all active. The size is computed as NAP*NAQ*NRS
* (sum over all symmetries). If Sym_R = Sym_S then triangular form over NRS...
* with R.ge.S, rectanguar otherwise. Basically we will use same simmetry as for dvwxy.
       IF(ISTORP(NSYM+1).GT.0) THEN
c         Write(LF,*)
c         Write(LF,*) ' ---------------------'
         CALL mma_allocate(STRP,ISTORP(NSYM+1),Label='STRP')
         CALL DmatDmat(D,STRP)
       ELSE
         CALL mma_allocate(STRP,1,Label='STRP')
       END IF
      end if
************************************************************************
* Compute the MCSCF generalized Fock matrix and Brillouin matrix elements
************************************************************************
      Call mma_allocate(FCK,NTOT4,Label='FCK')
      CALL mma_allocate(BM,NSXS,Label='BM')
      CALL mma_allocate(QMat,NQ,Label='QMat') ! q-matrix(1symmblock)
      CALL FOCK(FCK,BM,FI,FA,D,STRP,QMat,PUVX,IFINAL,CMO)
c Now FA = FI + FA. Original FA has been overwritten in FOCK routine.
      IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,*)
        Write(LF,*)'FI+FA in MO-basis in sxctl (overwritten on FA)'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FA(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
      END IF
      Call mma_deallocate(FCK)
      Call mma_deallocate(QMat)
      call mma_deallocate(STRP,safe='*')
      Call mma_deallocate(PUVX,safe='*')

* PAM 2008: Orbital files should be updated each iteration
* for easy access in case of catastrophic failure.
      IF ( IFINAL.NE.1 ) THEN
       iShift=0
       DO ISYM=1,NSYM
         IndT=0
         IndType(1+iShift)= NFRO(ISYM)
         IndT=IndT+NFRO(ISYM)
         IndType(2+iShift)= NISH(ISYM)
         IndT=IndT+NISH(ISYM)
         IndType(3+iShift)= NRS1(ISYM)
         IndT=IndT+NRS1(ISYM)
         IndType(4+iShift)= NRS2(ISYM)
         IndT=IndT+NRS2(ISYM)
         IndType(5+iShift)= NRS3(ISYM)
         IndT=IndT+NRS3(ISYM)
         IndType(7+iShift)= NDEL(ISYM)
         IndT=IndT+NDEL(ISYM)
         IndType(6+iShift)= NBAS(ISYM)-IndT
         iShift=iShift+7
        EndDo
* Note: This is not the final orbitals, and the orbital energies and
* active occupation numbers may be meaningless.
* There is an array with occupation numbers, so use it, even if
* possibly irrelevant. But put zeroes as orbital energies:
        Call mma_allocate(EDUM,NTOT,Label='EDUM')
        EDUM(:)=0.0D0

        Write(VecTyp,'(A)')
        VecTyp='* RASSCF average (pseudo-natural) orbitals (Not final)'
        LuvvVec=50
        LuvvVec=isfreeunit(LuvvVec)
        Call WrVec('RASORB',LuvvVec,'COE',NSYM,NBAS,NBAS,
     &           CMO, OCC, EDUM, INDTYPE,VECTYP)
        Call WrVec('RASORB',LuvvVec,'AI',NSYM,NBAS,NBAS,
     &           CMO, OCC, EDUM, INDTYPE,VECTYP)
        Call mma_deallocate(EDUM)

#ifdef _HDF5_
        call mh5_put_dset(wfn_mocoef,CMO)
        call mh5_put_dset(wfn_occnum,OCC)
#endif
      END IF

      IF ( IFINAL.EQ.1 ) THEN
C If ifinal=1 , this is the last call to SXCTL for calculating
C the MCSCF Fock matrix for occupied orbitals, and new orbitals).
C First generate final orbitals:
C Diagonalize inactive and secondary part of FP = FI + FA.
C         diagonal blocks of the active density matrix
C for RAS1, RAS2, and RAS3. All this is done in NEWORB.
C Finally generate orbitals and Fock matrices for CAS-PT2 runs.
C in FCKPT2

C Memory allocation and call to NEWORB and FCKPT2
C CMON: New molecular orbitals (NTOT2)
C FTR:  Temporary area for part of the Fock matrix FP (NTOT1)
C VEC:  EIGENVECTORS OF FTR (NO2M)
C SQ and WO: scratch areas

        CALL mma_allocate(CMON,NTOT2,Label='CMON')
        CALL mma_allocate(FTR,NTOT1,Label='FTR')
        CALL mma_allocate(VEC,NTOT2,Label='VEC')
        CALL mma_allocate(WO,NTOT2,Label='WO')
        CALL mma_allocate(SQ,NTOT2,Label='SQ')
        CALL mma_allocate(CMOX,NTOT2,Label='CMOX')
        If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' CMO in SXCTL for IFINAL=1'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         ioff=0
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          if(iBas.ne.0) then
            write(6,*) 'Sym =', iSym
            do i= 1,iBas
              write(6,*) (CMO(ioff+iBas*(i-1)+j),j=1,iBas)
            end do
            iOff = iOff + (iBas*iBas)
          end if
         End Do
        End If

        If ( iCIonly.eq.1 ) then
          IDISK=IADR15(2)
          CALL DDAFILE(JOBIPH,1,CMO,NTOT2,IDISK)
          CALL DDAFILE(JOBIPH,1,OCC,NTOT,IDISK)
#ifdef _HDF5_
          call mh5_put_dset(wfn_mocoef,CMO)
          call mh5_put_dset(wfn_occnum,OCC)
#endif
        Else
!          this part (TRACI) need to be changed to "TRAMPS", not yet ! Yingjin
           CALL NEWORB_RASSCF(CMO,CMON,FA,FTR,VEC,WO,SQ,CMOX,D,OCC)
* compute orbital overlap matrix
c           IF (NACTEL.GT.0) THEN
* NN.14 Skip this when DMRG-CASSCF due to CI-vector dependency
           !IF(.NOT.(DoDMRG.or.doBlockDMRG).AND.NACTEL.GT.0) THEN
           IF(NACTEL.GT.0)THEN
             CALL mma_allocate(SMAT,NAC*NAC,Label='SMAT')
             IWAY = 1
             CALL OVLP(IWAY,CMO,CMON,SMAT)

             if(dodmrg)then
#ifdef _DMRG_
#ifdef BLUBB
               call mpsrot(mat,nac,nrs2,nsym)
#endif
#endif
             else if(doBlockDMRG .or. DoNECI)then
             else !CI
               iDisk=IADR15(4)
               CALL LUCIA_UTIL('TRACI',
     &                         iDisk=iDisk,
     &                         Lu=JOBIPH,
     &                         Array=SMAT(:))
             end if
             Call mma_deallocate(SMAT)
           ELSE
             CIDUMMY=1.0D0
             IDISK=IADR15(4)
             CALL DDAFILE(JOBIPH,1,CIDUMMY,1,IDISK)
           END IF
        End If

        ! IPT2 = 1 for OUTO, CANOnical option...
        IF(IPT2.NE.0)
     &  CALL FCKPT2(CMO,CMON,FI,FA,FTR,VEC,WO,SQ,CMOX)

        Call mma_deallocate(CMOX)
        Call mma_deallocate(SQ)
        Call mma_deallocate(WO)
        Call mma_deallocate(VEC)
        Call mma_deallocate(FTR)
        Call mma_deallocate(CMON)

        CALL TIMING(CPTS,CPES,TIOS,TIOES)

        GOTO 9990
      ENDIF

C Memory allocation and calling sequence for SXHAM
C SXN: Normalization constants for super-CI vector
C F1 and F2: parts of the Fock matrix FP
C DIA: Occupied part of the density matrix (squared)
C SXG: The G matrix(used in sigvec)
C SXH: The H matrix( "    "   "   )
C SXHD: The diagonal of the super-CI Hamiltonian
C LDF: The matrix D*FP
C LDDIA: Diagonal of the density matrix (all elements one symmetry)

      CALL mma_allocate(SXN,NSXS,Label='SXN')
      CALL mma_allocate(F1,NIAIA,Label='F1')
      CALL mma_allocate(F2,NAEAE,Label='F2')
      CALL mma_allocate(DIA,NIAIA,Label='DIA')
      CALL mma_allocate(SXG,NIAIA,Label='SXG')
      CALL mma_allocate(SXH,NAOAE,Label='SXH')
      CALL mma_allocate(SXHD,NDIMSX,Label='SXHD')
      CALL mma_allocate(SXDF,NQ,Label='SXDF')
      CALL mma_allocate(SXDD,MNO,Label='SXDD')

c         CALL TRIPRT(' Dmat in MO in SXCTL bf call to SXHAM ',' ',D,NAC)
c         CALL TRIPRT(' Pmat in MO in SXCTL bf call to SXHAM ',
c     &              ' ',P,NACPAR)
c         CALL TRIPRT(' PAmat in MO in SXCTL bf call to SXHAM',
c     &              ' ',PA,NACPAR)
      CALL SXHAM(D,P,PA,FA,SXN,F1,F2,DIA,SXG,SXH,SXHD,SXDF,SXDD)

      Call mma_deallocate(SXDD)
      Call mma_deallocate(SXDF)

C PAM01 Removal of certain rotations from the BLB elements.
C Some additional rotations (besides those listed in IZROT) may
C need to be suppressed. These are rotations that are (very nearly)
C redundant -- they hardly affect the wave function at all.
C All suppressed rotations can be identified because the corresponding
C diagonal elements have been set to a huge number in SXHAM.
C Use this criterion to set some BLB elements exactly =0:
      DO I=1,NSXS
       IF(SXHD(NROOT+I).GT.1.0D20) BM(I)=0.0D0
      END DO

C MEMORY ALLOCATION AND CALLING SEQUENCE FOR SX DIAGONALIZATION

C CSX: The super-CI vectors
C SIGMA: The sigma vectors
C HH:  The Davidson H matrix
C CC:   "     "     egenvectors
C ENER: "     "     energies
C SC:   Scratch area
C QMat:    Davidson update vectors
C QQ:   Norm of update vectors
C OVL:  Overlap matrix

      NCR=NDIMSX*NROOT*ITMAX
      KMAX=ITMAX*NROOT
      NCR1=NDIMSX*NROOT*(ITMAX+1)
      CALL mma_allocate(CSX,NCR1,Label='CSX')
      CALL mma_allocate(SIGMA,NCR,Label='SIGMA')
      NLHH=KMAX**2+KMAX
      NLCC=KMAX**2
      NLQ=NDIMSX*(NROOT+1)
      NLOVL=ITMAX*NROOT**2
      CALL mma_allocate(HH,NLHH,Label='HH')
      CALL mma_allocate(CC,NLCC,Label='CC')
      CALL mma_allocate(ENER_X,KMAX,Label='ENER_X')
      CALL mma_allocate(SC,NDIMSX,Label='SC')
      Call mma_allocate(QMat,NLQ,Label='QMat')
      CALL mma_allocate(QQ,NROOT,Label='QQ')
      CALL mma_allocate(OVL,NLOVL,Label='OVL')

      CALL DAVCRE(CSX,SIGMA,HH,CC,ENER_X,SXHD,SC,
     &            QMat,QQ,OVL,SXSEL,
     &            NROOT,ITMAX,NDIMSX,ITERSX,NSXS)

      ESX=ENER_X(1)
      Call mma_deallocate(SIGMA)
      Call mma_deallocate(HH)
      Call mma_deallocate(CC)
      Call mma_deallocate(ENER_X)
      Call mma_deallocate(SC)
      Call mma_deallocate(QMat)
      Call mma_deallocate(QQ)
      Call mma_deallocate(OVL)
      Call mma_deallocate(F1)
      Call mma_deallocate(F2)
      Call mma_deallocate(SXG)
      Call mma_deallocate(SXH)
      Call mma_deallocate(SXHD)

C Renormalize the SX-coefficients

      IREF=1
      LCSXI=1+NDIMSX*(IREF-1)
      IC=NROOT+LCSXI-1
      XSXMAX=0.0D0
      DO 54 I=1,NSXS
       CSX(IC+I)=SXN(I)*CSX(IC+I)/CSX(LCSXI)
       XSXMAX=MAX(XSXMAX,abs(CSX(IC+I)))
54    CONTINUE
      IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,*) 'SXCTL after DAVCRE, Renormalized SX coeffs:'
        Write(LF,'(1X,8F14.6)')(CSX(IC+I),I=1,NSXS)
      END IF

* Step size control has been built into qune now.
*C Step length control, just for safety.
*      DO I=1,NSXS
*        VAL=CSX(IC+I)
*        CSX(IC+I)=VAL/(1.0D0+1.7D0*ABS(VAL))
*      END DO

C Intercept XSX and BM, to use (perhaps) Quasi-Newton or Line Search

*      IF(ITER.EQ.1) NCALL=0
      IF(ITER.LE.4) NCALL=0
      IF(KeyHEUR.AND.ITER.GT.10.AND.MOD(ITER,10).LT.4) NCALL=0
      if(doDMRG) then
        IF(ITER.LE.2) NCALL=0  ! YM: change 4 -> 2, for saving time
      end if
      IF(XSXMAX.GT.0.5D0) NCALL=0
      IF(NQUNE.NE.0.AND.XSXMAX.LT.0.5D0) THEN
        CALL mma_allocate(VT,NSXS,Label='VT')
        CALL mma_allocate(VL,NSXS,Label='VL')
        CALL mma_allocate(XQN,NSXS,Label='XQN')
        CALL mma_allocate(SCR,NSXS,Label='SCR')
        CALL mma_allocate(V1,NSXS,Label='V1')
        CALL mma_allocate(V2,NSXS,Label='V2')
        CASDFT_En=0.0d0
        If(KSDFT.ne.'SCF'.and.KSDFT(1:3).ne.'PAM')
     &      Call Get_dScalar('CASDFT energy',CASDFT_En)
        CASDFT_En=ECAS+CASDFT_En
        CALL QUNE(NCALL,CASDFT_En,BM,CSX(NROOT+LCSXI),
     &            VL,VT,XQN,SCR,
     &            V1,V2,NSXS,LUQUNE,
     &            TMIN,QNSTEP,QNUPDT,KSDFT)

        Call mma_deallocate(VT)
        Call mma_deallocate(VL)
        Call mma_deallocate(XQN)
        Call mma_deallocate(SCR)
        Call mma_deallocate(V1)
        Call mma_deallocate(V2)
      ENDIF

C Rotation of orbitals with exp(x) where x is obtained from
C the super-CI coefficients, with a Quasi Newton update (NQUNE=1)


C CMO:  before - old MO's           after - new MO's
C CMON: intermediate storage for new MO's (moved to CMO in ORTHO)
C X2:  work area, also in ORTHO (AO overlap matrix)
C Scr: WORK AREA

      CALL mma_allocate(CMON,NTOT2,Label='CMON')
      CALL mma_allocate(XMAT,NO2M,Label='XMAT')
      CALL mma_allocate(X2,NTOT1,Label='X2')
      CALL mma_allocate(Scr,NO2M,Label='SCR')

      CALL ROTORB(CMO,CMON,CSX(LCSXI),XMAT,X2,SCR,THMAX,FA)

      IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,*)
        Write(LF,*)'FI+FA in SXCTL after Unitary transform in ROTORB'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FA(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
      END IF
      Call mma_deallocate(CMON)
      Call mma_deallocate(XMAT)
      Call mma_deallocate(X2)
      Call mma_deallocate(SCR)
      Call mma_deallocate(SXN)
      Call mma_deallocate(DIA)
      Call mma_deallocate(CSX)

      IDISK=IADR15(2)
      CALL DDAFILE(JOBIPH,1,CMO,NTOT2,IDISK)
      CALL DDAFILE(JOBIPH,1,OCC,NTOT,IDISK)
#ifdef _HDF5_
      call mh5_put_dset(wfn_mocoef,CMO)
      call mh5_put_dset(wfn_occnum,OCC)
#endif
      CALL TIMING(CPTS,CPES,TIOS,TIOES)

9990  CONTINUE
      Call mma_deallocate(BM)

      END Subroutine SXCtl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

module Slapaf_Info

use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Half
use Definitions, only: wp, iwp

implicit none
private

! Baker      Convergence a la Baker
! Beta       The threshold for restricted step optimization.
! Beta_Disp  The threshold for restricted variance optimization.
!
!     Hessian update
! 0   iOptH=0000001 ( 1) Meyer (disabled)
! 1   iOptH=0000010 ( 2) BP (disabled)
! 2   iOptH=0000100 ( 4) BFGS
! 3   iOptH=0001000 ( 8) None
! 4   iOptH=0010000 (16) MPS, for TS search
! 5   iOptH=0100000 (32) EU, for TS search
! 6   iOptH=1000000 (64) TS-BFGS, for TS search
!
! Optimization method. DO NOT EVER GO BEYOND BIT 30!!!
!
!     iOptC=00000000000000  (  0) No optimization
!  0  iOptC=00000000000001  (  1) Quasi Newton-Raphson
!  1  iOptC=00000000000010  (  2) c1-DIIS
!  2  iOptC=00000000000100  (  4) c2-DIIS
!  3  iOptC=00000000001000  (  8) RS-RFO
!  4  iOptC=0000000001....  ( 16) DIIS, <dx|dx>
!  5  iOptC=0000000010....  ( 32) DIIS, <dx|g>
!  6  iOptC=0000000100....  ( 64) DIIS, <g|g>
!  7  iOptC=0000001.......  (128) Minimum, if not set TS search
!  8  iOptC=0000010.......  (256) Optimization with constraint
!  9  iOptC=00001.........  (512) set: RS-I-RFO, unset: RS-P-RFO
! 10  iOptC=0001.......... (1024) HMF augmented with weak interactions
! 11  iOptC=0010.......... (2048) augmented HMF used for selection of internal coordinates
! 12  iOptC=01............ (4096) set if FindTS
! 13  iOptC=10............ (8192) set if FindTS and in TS regime

! Arrays always allocated
!
! Cx                   list of Cartesian coordinates
! Gx                   list of Cartesian Gradients, State 1
! Gx0                  list of Cartesian Gradients, State 2 for optimization of conical intersections
! NAC                  list of Cartesian non-adiabatic coupling vectors
! Q_nuclear            list nuclear charges
! dmass                list atomic mass in units of (C=12)
! Coor                 Cartesian coordinates of the last iteration
! Grd                  gradient of the last iteraction in Cartesian coordinates
! Weights              list of weights of ALL centers, however, the symmetry unique are first.
! Shift                list of displacements in Cartesian coordinates
! GNrm                 list of the gradient norm for each iteration
! Energy               list of the energies of each iteration, State 1
! Energy0              list of the energies of each iteration, State 2 for optimization of conical intersections
! MF                   list of Cartesian mode following vectors for each iteration
! DipM                 list of dipole moments for each iteration
! qInt                 internal coordinates for each iteration
! dqInt                derivatives of internal coordinates for each iteration
! dqInt_Aux            derivatives of internal coordinates for each iteration, of sets > 1
! RefGeo               Reference geometry in Cartesian coordinates
! R12                  Reference geometry in R-P calculation (not used right now)
! GradRef              Reference gradient
! Bmx                  the B matrix
! BMx_kriging          the updated B matrix during the Kriging procedure
! Degen                list of degeneracy numbers of the unique atoms (three identical entries)
! Stab, iCoset, nStab  stabilizer and cosets information for the indivudual centers
! AtomLbl              atomic labels
! Smmtrc               Array with logical symmetry information on if a Cartesian is symmetric or not.
! Lbl                  Labels for internal coordinates and constraints
!Arrays for automatic internal coordinates
! BM                   ...
! dBM                  ...
! iBM                  ...
! idBM                 ...
! nqBM                 ...
! ANr                  list of atomic numbers
!
! Arrays optionally allocated
!
! Lambda               list of the Lagrange multipiers
! mRowH                rows of the Hessian to be explicitly computed
! RootMap              Array to map the roots between iterations
!
! Utility arrays with explicit deallocation, i.e. not via Free_Slapaf()
!
! Atom                  Temporary arrays for the super symmetry case
! NSup                  Temporary arrays for the super symmetry case
! KtB                   KtB array for the BMtrx family of subroutines

integer(kind=iwp), parameter :: MaxItr = 2000
integer(kind=iwp) :: iInt = 0, iNeg(2) = 0, iOptC = int(b'111011001000'), iOptH = int(b'100'), IRC = 0, iRef = 0, iRow = 0, &
                     iRow_c = 0, iState(2) = 0, iter = 0, Max_Center = 15, mB_Tot = 0, mdB_Tot = 0, MEPNum = 0, Mode = -1, &
                     mq = 0, mTROld = 0, mTtAtm = 0, MxItr = 0, nBVec = 0, nDimBC = 0, nFix = 0, nLambda = 0, nMEP = MaxItr, &
                     NmIter = 0, nsRot = 0, nUserPT = 0, nWndw = 5
real(kind=wp) :: Beta = 0.3_wp, Beta_Disp = 0.3_wp, CnstWght = One, Delta = 1.0e-2_wp, dMEPStep = 0.1_wp, E_Delta = Zero, &
                 GNrm_Threshold = 0.2_wp, GrdMax = Zero, StpMax = Zero, rFuzz = Half, rHidden = Zero, RtRnc = Three, &
                 ThrCons = Zero, ThrMEP = Zero, ThrEne = Zero, ThrGrd = Zero, UserP = Zero, UserT(64) = Zero
logical(kind=iwp) :: Analytic_Hessian = .false., ApproxNADC = .false., Baker = .false., BSet = .false., CallLast = .true., &
                     Cubic = .false., Curvilinear = .true., ddV_Schlegel = .false., EDiffZero = .false., eMEPTest = .true., &
                     Fallback = .true., FindTS = .false., Force_dB = .false., HrmFrq_Show = .false., HSet = .false., &
                     HWRS = .true., Initiated = .false., isFalcon = .false., lCtoF = .false., lDoubleIso = .false., &
                     Line_Search = .true., lNmHss = .false., lOld = .false., lOld_Implicit = .false., lRP = .false., &
                     lSoft = .false., lTherm = .false., MEP = .false., MEPCons = .false., NADC = .false., Numerical = .false., &
                     PrQ = .false., Redundant = .false., Request_Alaska = .false., Request_RASSI = .false., rMEP = .false., &
                     SlStop = .false., Track = .false., TSConstraints = .false., TwoRunFiles = .false., User_Def = .false., &
                     WeightedConstraints = .false.
character(len=10) :: MEP_TYPE = 'SPHERE'
character(len=8) :: GrdLbl = '', StpLbl = ''
character(len=6) :: HUpMet = ' None ', UpMeth = '  RF  '
character(len=2) :: MEP_Algo = 'GS'
character :: Header(144) = ''
integer(kind=iwp), allocatable :: ANr(:), Atom(:), iBM(:), idBM(:), iCoset(:,:), jStab(:,:), mRowH(:), nqBM(:), nStab(:), NSup(:), &
                                  RootMap(:)
real(kind=wp), allocatable :: BM(:), BMx_kriging(:,:), Coor(:,:), Cx(:,:,:), dBM(:), Degen(:,:), DipM(:,:), dmass(:), dqInt(:,:), &
                              dqInt_Aux(:,:,:), Energy(:), Energy0(:), GNrm(:), Grd(:,:), Gx(:,:,:), Gx0(:,:,:), KtB(:,:), &
                              Lambda(:,:), MF(:,:), NAC(:,:,:), Q_nuclear(:), qInt(:,:), Shift(:,:), Weights(:)
real(kind=wp), allocatable, target :: Bmx(:,:), GradRef(:,:), R12(:,:), RefGeo(:,:)
logical(kind=iwp), allocatable :: Smmtrc(:,:)
character(len=LenIn), allocatable :: AtomLbl(:)
character(len=8), allocatable :: Lbl(:)

integer(kind=iwp), parameter :: Covalent_Bond = 0, &
                                vdW_Bond = 1, &
                                Fragments_Bond = 2, &
                                Magic_Bond = 3
character(len=*), parameter :: BondType(0:3) = ['Covalent_Bond ', &
                                                'vdW_Bond      ', &
                                                'Fragments_Bond', &
                                                'Magic_Bond    ']

public :: Analytic_Hessian, ANr, ApproxNADC, Atom, AtomLbl, Baker, Beta, Beta_Disp, BM, Bmx, BMx_kriging, BondType, BSet, &
          CallLast, CnstWght, Coor, Covalent_Bond, Cubic, Curvilinear, Cx, dBM, ddV_Schlegel, Degen, Delta, DipM, dmass, dMEPStep, &
          Dmp_Slapaf, dqInt, dqInt_Aux, E_Delta, EDiffZero, eMEPTest, Energy, Energy0, Fallback, FindTS, Force_dB, Fragments_Bond, &
          Free_Slapaf, Get_Slapaf, GNrm, GNrm_Threshold, GradRef, Grd, GrdLbl, GrdMax, Gx, Gx0, Header, HrmFrq_Show, HSet, HUpMet, &
          HWRS, iBM, iCoset, idBM, iInt, iNeg, iOptC, iOptH, IRC, iRef, iRow, iRow_c, isFalcon, iState, iter, jStab, KtB, Lambda, &
          Lbl, lCtoF, lDoubleIso, Line_Search, lNmHss, lOld, lOld_Implicit, lRP, lSoft, lTherm, Magic_Bond, Max_Center, MaxItr, &
          mB_Tot, mdB_Tot, MEP, MEP_Algo, MEP_TYPE, MEPCons, MEPNum, MF, Mode, mq, mRowH, mTROld, mTtAtm, MxItr, NAC, NADC, nBVec, &
          nDimBC, nFix, nLambda, nMEP, NmIter, nqBM, nsRot, nStab, NSup, Numerical, nUserPT, nWndw, PrQ, Q_nuclear, qInt, R12, &
          Redundant, RefGeo, Request_Alaska, Request_RASSI, rFuzz, rHidden, rMEP, RootMap, RtRnc, Shift, SlStop, Smmtrc, StpLbl, &
          StpMax, ThrCons, ThrEne, ThrGrd, ThrMEP, Track, TSConstraints, TwoRunFiles, UpMeth, User_Def, UserP, UserT, vdW_Bond, &
          WeightedConstraints, Weights

contains

subroutine Free_Slapaf()

  call mma_deallocate(Energy,safe='*')
  call mma_deallocate(Energy0,safe='*')
  call mma_deallocate(DipM,safe='*')
  call mma_deallocate(GNrm,safe='*')
  call mma_deallocate(Cx,safe='*')
  call mma_deallocate(Gx,safe='*')
  call mma_deallocate(Gx0,safe='*')
  call mma_deallocate(NAC,safe='*')
  call mma_deallocate(MF,safe='*')
  call mma_deallocate(Lambda,safe='*')
  call mma_deallocate(Degen,safe='*')
  call mma_deallocate(jStab,safe='*')
  call mma_deallocate(iCoSet,safe='*')
  call mma_deallocate(nStab,safe='*')
  call mma_deallocate(AtomLbl,safe='*')
  call mma_deallocate(Smmtrc,safe='*')
  call mma_deallocate(Lbl,safe='*')

  call mma_deallocate(Q_nuclear,safe='*')
  call mma_deallocate(dMass,safe='*')
  call mma_deallocate(Coor,safe='*')
  call mma_deallocate(Grd,safe='*')
  call mma_deallocate(ANr,safe='*')
  call mma_deallocate(Weights,safe='*')
  call mma_deallocate(Shift,safe='*')
  call mma_deallocate(BMx,safe='*')
  call mma_deallocate(BMx_kriging,safe='*')

  call mma_deallocate(BM,safe='*')
  call mma_deallocate(dBM,safe='*')
  call mma_deallocate(iBM,safe='*')
  call mma_deallocate(idBM,safe='*')
  call mma_deallocate(nqBM,safe='*')

  call mma_deallocate(RefGeo,safe='*')
  call mma_deallocate(R12,safe='*')
  call mma_deallocate(GradRef,safe='*')

  call mma_deallocate(qInt,safe='*')
  call mma_deallocate(dqInt,safe='*')
  call mma_deallocate(dqInt_Aux,safe='*')
  call mma_deallocate(mRowH,safe='*')
  call mma_deallocate(RootMap,safe='*')

end subroutine Free_Slapaf

subroutine Get_Slapaf(iter,MaxItr,mTROld,lOld_Implicit,nsAtom,mLambda)

  use UnixInfo, only: SuperName
  use Constants, only: Zero
  use Definitions, only: u6

  integer(kind=iwp), intent(out) :: iter, mTROld
  integer(kind=iwp), intent(in) :: MaxItr, nsAtom, mLambda
  logical(kind=iwp), intent(out) :: lOld_Implicit
  integer(kind=iwp) :: iLn, iOff, itmp, Lngth
  logical(kind=iwp) :: Exists
  integer(kind=iwp), allocatable :: Information(:)
  real(kind=wp), allocatable :: Relax(:)

  Initiated = .true.

  call mma_allocate(Information,7,Label='Information')

  call qpg_iArray('Slapaf Info 1',Exists,itmp)
  if (Exists) call Get_iArray('Slapaf Info 1',Information,7)

  if ((.not. Exists) .or. (Information(1) == -99)) then
    !write(u6,*) 'Reinitiate Slapaf fields on runfile'
    Information(:) = 0
    Information(3) = -99
    call Put_iArray('Slapaf Info 1',Information,7)
  end if

  iter = Information(2)+1
  if (iter > MaxItr) then
    write(u6,*) 'Increase MaxItr in slapaf_info.f90'
    call WarningMessage(2,'iter >= MaxItr+1')
    call Abend()
  end if
  mTROld = Information(3)
  lOld_Implicit = Information(4) == 1

  call mma_deallocate(Information)

  if (.not. allocated(Energy)) then

    call mma_allocate(Energy,MaxItr+1,Label='Energy')
    Energy(:) = Zero
    call mma_allocate(Energy0,MaxItr+1,Label='Energy0')
    Energy0(:) = Zero
    call mma_allocate(DipM,3,MaxItr+1,Label='DipM')
    DipM(:,:) = Zero
    call mma_allocate(GNrm,MaxItr+1,Label='GNrm')
    GNrm(:) = Zero
    call mma_allocate(Cx,3,nsAtom,MaxItr+1,Label='Cx')
    Cx(:,:,:) = Zero
    call mma_allocate(Gx,3,nsAtom,MaxItr+1,Label='Gx')
    Gx(:,:,:) = Zero
    call mma_allocate(Gx0,3,nsAtom,MaxItr+1,Label='Gx0')
    Gx0(:,:,:) = Zero
    call mma_allocate(NAC,3,nsAtom,MaxItr+1,Label='NAC')
    NAC(:,:,:) = Zero
    call mma_allocate(MF,3,nsAtom,Label='MF')
    MF(:,:) = Zero
    if (mLambda > 0) then
      call mma_allocate(Lambda,mLambda,MaxItr+1,Label='Lambda')
      Lambda(:,:) = Zero
    end if

  end if

  if (iter == 1) return

  if (SuperName /= 'numerical_gradient') then

    Lngth = size(Energy)+size(Energy0)+size(DipM)+size(GNrm)+size(Cx)+size(Gx)+size(Gx0)+size(NAC)+size(MF)
    if (allocated(Lambda)) Lngth = Lngth+size(Lambda)
    call mma_allocate(Relax,Lngth,Label='Relax')
    call Get_dArray('Slapaf Info 2',Relax,Lngth)

    iOff = 1
    iLn = size(Energy)
    Energy(:) = Relax(iOff:iOff+iLn-1)
    iOff = iOff+iLn
    iLn = size(Energy0)
    Energy0(:) = Relax(iOff:iOff+iLn-1)
    iOff = iOff+iLn
    iLn = size(DipM)
    DipM(:,:) = reshape(Relax(iOff:iOff+iLn-1),shape(DipM))
    iOff = iOff+iLn
    iLn = size(GNrm)
    GNrm(:) = Relax(iOff:iOff+iLn-1)
    iOff = iOff+iLn
    iLn = size(Cx)
    Cx(:,:,:) = reshape(Relax(iOff:iOff+iLn-1),shape(Cx))
    iOff = iOff+iLn
    iLn = size(Gx)
    Gx(:,:,:) = reshape(Relax(iOff:iOff+iLn-1),shape(Gx))
    iOff = iOff+iLn
    iLn = size(Gx0)
    Gx0(:,:,:) = reshape(Relax(iOff:iOff+iLn-1),shape(Gx0))
    iOff = iOff+iLn
    iLn = size(NAC)
    NAC(:,:,:) = reshape(Relax(iOff:iOff+iLn-1),shape(NAC))
    iOff = iOff+iLn
    iLn = size(MF)
    MF(:,:) = reshape(Relax(iOff:iOff+iLn-1),shape(MF))
    iOff = iOff+iLn
    if (allocated(Lambda)) then
      iLn = size(Lambda)
      Lambda(:,:) = reshape(Relax(iOff:iOff+iLn-1),shape(Lambda))
      iOff = iOff+iLn
    end if
    call mma_deallocate(Relax)
  else
    iter = 1
  end if

end subroutine Get_Slapaf

subroutine Dmp_Slapaf(lStop,Just_Frequencies,Energy_In,Iter,MaxItr,mTROld,lOld_Implicit,nsAtom)

  use UnixInfo, only: SuperName
  use Definitions, only: u6

  logical(kind=iwp), intent(in) :: lStop, Just_Frequencies, lOld_Implicit
  real(kind=wp), intent(in) :: Energy_In
  integer(kind=iwp), intent(in) :: Iter, MaxItr, mTROld, nsAtom
  integer(kind=iwp) :: iLn, iOff, iOff_Iter, Lngth, nSlap
  logical(kind=iwp) :: Found
  integer(kind=iwp), allocatable :: Information(:)
  real(kind=wp), allocatable :: GxFix(:,:), Relax(:)

  if (.not. Initiated) then
    write(u6,*) 'Dmp_Slapaf: Slapaf not initiated!'
    call Abend()
  else
    Initiated = .false.
  end if

  ! Write information of this iteration to the RLXITR file
  call mma_allocate(Information,7,Label='Information')
  if (lStop) then
    Information(1) = -99     ! Deactivate the record
    iOff_Iter = 0
    call Put_iScalar('iOff_Iter',iOff_Iter)

    ! Restore the runfile data as if the computation was analytic
    ! (note the gradient sign must be changed back)

    if (Just_Frequencies) then
      call Put_dScalar('Last Energy',Energy_In)
      call mma_allocate(GxFix,3,nsAtom,Label='GxFix')
      GxFix(:,:) = -Gx(:,:,1)
      call Put_dArray('GRAD',GxFix,3*nsAtom)
      call mma_deallocate(GxFix)
      call Put_dArray('Unique Coordinates',Cx,3*nsAtom)
      call Put_Coord_New(Cx,nsAtom)
    end if
  else
    call qpg_iArray('Slapaf Info 1',Found,nSlap)
    if (Found) then
      call Get_iArray('Slapaf Info 1',Information,7)
      if (Information(1) /= -99) Information(1) = MaxItr
    else
      Information(1) = MaxItr
    end if
  end if

  if (SuperName /= 'numerical_gradient') then
    Information(2) = Iter
    Information(3) = mTROld ! # symm. transl /rot.
    Information(4) = merge(1,0,lOld_Implicit)
    Information(5) = 0
    Information(6) = size(Energy)+size(Energy0)+size(DipM)+size(GNrm)
    Information(7) = size(Energy)+size(Energy0)+size(DipM)+size(GNrm)+size(Cx)
    call Put_iArray('Slapaf Info 1',Information,7)

    Lngth = size(Energy)+size(Energy0)+size(DipM)+size(GNrm)+size(Cx)+size(Gx)+size(Gx0)+size(NAC)+size(MF)
    if (allocated(Lambda)) Lngth = Lngth+size(Lambda)
    call mma_allocate(Relax,Lngth,Label='Relax')
    iOff = 1
    iLn = size(Energy)
    Relax(iOff:iOff+iLn-1) = pack(Energy,.true.)
    iOff = iOff+iLn
    iLn = size(Energy0)
    Relax(iOff:iOff+iLn-1) = pack(Energy0,.true.)
    iOff = iOff+iLn
    iLn = size(DipM)
    Relax(iOff:iOff+iLn-1) = pack(DipM,.true.)
    iOff = iOff+iLn
    iLn = size(GNrm)
    Relax(iOff:iOff+iLn-1) = pack(GNrm,.true.)
    iOff = iOff+iLn
    iLn = size(Cx)
    Relax(iOff:iOff+iLn-1) = pack(Cx,.true.)
    iOff = iOff+iLn
    iLn = size(Gx)
    Relax(iOff:iOff+iLn-1) = pack(Gx,.true.)
    iOff = iOff+iLn
    iLn = size(Gx0)
    Relax(iOff:iOff+iLn-1) = pack(Gx0,.true.)
    iOff = iOff+iLn
    iLn = size(NAC)
    Relax(iOff:iOff+iLn-1) = pack(NAC,.true.)
    iOff = iOff+iLn
    iLn = size(MF)
    Relax(iOff:iOff+iLn-1) = pack(MF,.true.)
    iOff = iOff+iLn
    if (allocated(Lambda)) then
      iLn = size(Lambda)
      Relax(iOff:iOff+iLn-1) = pack(Lambda,.true.)
      iOff = iOff+iLn
    end if
    call Put_dArray('Slapaf Info 2',Relax,Lngth)
    call mma_deallocate(Relax)
  end if
  call mma_deallocate(Information)

end subroutine Dmp_Slapaf

end module Slapaf_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
* This routine prints the trailer part to the postscript figure of     *
* occupation numbers.                                                  *
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine FigCls(lu)
      Write(lu,'(a)') '%---'
      Write(lu,'(a)') 'grestore'
      Write(lu,'(a)') 'showpage'
      Write(lu,'(a)') '%.AutoFeed'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine diiswa1(wrk,wrksize,diispoint)
! this routine does:
! a) upgrade diispoint
! b) write new amplitudes T21,T22,T23,T13,T14 into proper position
!
! diispoint - array of lun's where N-1, N-2 .. amplitudes are stored (I/O)

use ccsd_global, only: cycext, t13, t14, t21, t22, t23
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(_IN_) :: wrk(wrksize)
integer(kind=iwp), intent(inout) :: diispoint(4)
integer(kind=iwp) :: lun1, p, rc

!1 upgrade diispoint

lun1 = diispoint(cycext)

do p=cycext-1,1,-1
  diispoint(p+1) = diispoint(p)
end do

diispoint(1) = lun1

!2 save amplitudes

!2.1 rewind lun1 file
lun1 = diispoint(1)
call filemanager(2,lun1,rc)

!2.2 write T21
call wrtmediate(wrk,wrksize,lun1,t21,rc)

!2.3 write T22
call wrtmediate(wrk,wrksize,lun1,t22,rc)

!2.4 write T23
call wrtmediate(wrk,wrksize,lun1,t23,rc)

!2.5 write T13
call wrtmediate(wrk,wrksize,lun1,t13,rc)

!2.6 write T14
call wrtmediate(wrk,wrksize,lun1,t14,rc)

!2.1 rewind lun1 file
call filemanager(2,lun1,rc)

return

end subroutine diiswa1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine vec(threshold,u,j,k,iErr)

use ZMatConv_Mod, only: Coords
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: threshold
real(kind=wp), intent(out) :: u(3)
integer(kind=iwp), intent(in) :: j, k
integer(kind=iwp), intent(out) :: iErr
integer(kind=iwp) :: i
real(kind=wp) :: r(3), r2

iErr = 0
r2 = Zero

do i=1,3
  r(i) = Coords(i,j)-Coords(i,k)
  r2 = r2+r(i)*r(i)
end do
r2 = sqrt(r2)
if (r2 < threshold) then
  iErr = 1
  return
end if
do i=1,3
  u(i) = r(i)/r2
end do

return

end subroutine vec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine PtDiff(I_Dim,Coeff,T,A)
!-----------------------------------------------------------------------
! Function : Calculate derivative
!            j = odd  ; A(I,J) = EXP(-X*Coeff(J+1))
!            j = even ; A(I,J) = -X*Coeff(J-1)*EXP(-X*Coeff(J))
!-----------------------------------------------------------------------

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: I_Dim
real(kind=wp), intent(in) :: Coeff(40), T(40)
real(kind=wp), intent(out) :: A(40,40)
integer(kind=iwp) :: I, J
real(kind=wp) :: X

do I=1,I_Dim
  do J=1,I_Dim
    X = T(I_Dim+1-I)
    if (mod(J,2) == 1) then
      A(I,J) = exp(-X*Coeff(J+1))
    else
      A(I,J) = -X*Coeff(J-1)*exp(-X*Coeff(J))
    end if
  end do
end do

return

end subroutine PtDiff

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Bjorn O. Roos                                    *
************************************************************************
*--------------------------------------------*
* 1987  B. O. ROOS                           *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND, SWEDEN                 *
*--------------------------------------------*
      Subroutine tr2NsA2(CMO,X1,nX1,X2,nX2,
     &                   pqrU,npqrU, pqTU,npqTU)
C
C SECOND ORDER TWO-ELECTRON TRANSFORMATION ROUTINE
C
C THIS ROUTINE IS CALLED FOR EACH SYMMETRY BLOCK OF INTEGRALS
C (ISP,ISQ,ISR,ISS) WITH ISP.GE.ISQ AND ISR.GE.ISS.
C P,Q,R,S are SO indices.
C A,B are MO indices, counting only non-frozen and non-deleted.
C T,U are occupied MO indices, only non-frozen and non-deleted.
C INTEGRALS (AB/TU) ARE ALWAYS GENERATED
C EXCHANGE INTEGRALS (AT/BU) ARE GENERATED AS FOLLOWS:
C (AT/BU) IF ISP.GE.ISR
C (AT/UB) IF ISP.GT.ISS AND ISP.NE.ISQ
C (TA/BU) IF ISQ.GT.ISR AND ISP.NE.ISQ
C (TA/UB) IF ISQ.GE.ISS AND ISP.NE.ISQ
C
*     This and tr2NsB routines transform non-squared AO integrals. The
*     transformed MO integrals are stored as the same as Tr2Sq
*     subroutine does.
*
      Implicit real*8(a-h,o-z)
CPAM98      COMMON/INTTRA/ISP,ISQ,ISR,ISS,NBP,NBQ,NBR,NBS,NBPQ,NBRS,IRRST,
CPAM98     &              NOCP,NOCQ,NOCR,NOCS,NPQ,LADX,LRUPQ,LURPQ,LTUPQ,
CPAM98     &              NOP,NOQ,NOR,NOS,LMOP,LMOQ,LMOR,LMOS,LMOP2,LMOQ2,
CPAM98     &              LMOR2,LMOS2,IAD13,ITP,ITQ,ITR,ITS
#include "rasdim.fh"
#include "caspt2.fh"
#include "trafo.fh"
#include "intgrl.fh"
#include "SysDef.fh"
      DIMENSION CMO(NCMO)
      Dimension X1(nX1),X2(nX2)
      Dimension PQTU(nPQTU),PQRU(nPQRU)

      NSYMP=NSYM*(NSYM+1)/2
      NOTU=NOCR*NOCS
      IF(ISR.EQ.ISS) NOTU=(NOCR**2+NOCR)/2
      NOUS=NOCR*NBS
      NORU=NBR*NOCS
      icc  =NOP*NOQ*NOCR*NOCS
      icxc1=NOP*NOCQ*NOR*NOCS
      icxc3=NOP*NOCQ*NOCR*NOS
      icxc5=NOCP*NOQ*NOR*NOCS
      icxc7=NOCP*NOQ*NOCR*NOS
c
c Check for in core or out of core transformation
c
C     2. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|RU) ON UNIT LUHLF2
      IPQMX2=NBPQ
      IF(NBPQ*NORU.GT.LRUPQ) THEN
       IPQMX2=LRUPQ/NORU
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|RU)',IPQMX2
       IAD2S=0
       CALL dDAFILE(LUHLF2,0,PQRU,IPQMX2,IAD2S)
      ENDIF
      IAD2=0
      IOUT2=0
C     3. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|TU) ON UNIT LUHLF3
      IPQMX3=NBPQ
      IF(NBPQ*NOTU.GT.LTUPQ) THEN
       IPQMX3=LTUPQ/NOTU
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|TU)',IPQMX3
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,PQTU,IPQMX3,IAD3S)
      ENDIF
      IAD3=0
      IOUT3=0
c
c====================================================
c Second half transformation
c====================================================
c-------------------------------------------
c Second half transformation (AB,TU) coulomb
c  Always calculated.
c-------------------------------------------
c Loop over t,u pair,
      If(icc.ne.0) then
       ISPQRS=((ISR**2-ISR)/2+ISS-1)*NSYMP+(ISP**2-ISP)/2+ISQ
       IAD2M(1,ISPQRS)=IAD13
       IPQTU=0
       ITU=0
       Do NT=1,NOCR
        Num=NOCS
        If(ISR.eq.ISS)Num=NT
        Do NU=1,Num
         IPQTU=1+NBPQ*ITU
         ITU=ITU+1
c Read sorted integral from disk
         IF(IPQMX3.LT.NBPQ) THEN
          Call RBuf_tra2(LUHLF3,PQTU,NBPQ,IPQMX3,NOTU,ITU,IPQTU,IAD3S)
         ENDIF
         If(ISP.eq.ISQ) then
c  Square if necessary
          CALL SQUARE(PQTU(IPQTU),X2,1,NBP,NBP)
c  (pq,TU) -> (Aq,TU)
          CALL DGEMM_('N','N',
     &                NBQ,NOP,NBP,
     &                1.0d0,X2,NBQ,
     &                CMO(LMOP),NBP,
     &                0.0d0,X1,NBQ)
c  (Aq,TU) -> (AB,TU)
          CALL MXMT(X1,       NBQ,1,
     &              CMO(LMOQ),1,NBQ,
     &              X2,
     &              NOP,NBQ)
          IX2=(NOP+NOP**2)/2
         Else
c  (pq,TU) -> (Aq,TU)
          CALL DGEMM_('N','N',
     &                NBQ,NOP,NBP,
     &                1.0d0,PQTU(IPQTU),NBQ,
     &                CMO(LMOP),NBP,
     &                0.0d0,X1,NBQ)
c  (Aq,TU) -> (AB,TU)
          CALL DGEMM_('T','N',
     &                NOQ,NOP,NBQ,
     &                1.0d0,CMO(LMOQ),NBQ,
     &                X1,NBQ,
     &                0.0d0,X2,NOQ)
          IX2=NOP*NOQ
         Endif
c  Store (AB,TU) of this t,u pair
         Call GADSum(X2,IX2)
         Call dDAFILE(LUINTM,1,X2,IX2,IAD13)
        Enddo
       Enddo
c End of loop over t,u pair
      Endif
c-----------------------------------------------------------------------
c Second half transformation Case 1 (AT,BU)
c  Always calculated. Both type 1 and 2. Case 2 (BU,AT) can be abandoned
c  since always ISP.gt.ISR(equality can be removed by symmetry)
c-----------------------------------------------------------------------
c Loop over r,u pair
      NOTU=NOCQ*NOCS
      IF(ISQ.EQ.ISS) NOTU=(NOCQ**2+NOCQ)/2
      If(icxc1.ne.0)then
       LAR=LTUPQ/NOTU
       LR=LAR/NOP
       IF(LR.GT.NBR) LR=NBR
       LAR=NOP*LR
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,PQTU,LAR,IAD3S)
       IAD3=0
       IR=0
       Do NR=1,NBR
        IR=IR+1
        Do NU=1,NOCS
c Square if necessary
         IRU=NBR*(NU-1)+NR
         IPQST=1+NBPQ*(IRU-1)
         IF(IPQMX2.LT.NBPQ) THEN
          Call RBuf_tra2(LUHLF2,PQRU,NBPQ,IPQMX2,NORU,IRU,IPQST,IAD2S)
         ENDIF
         If(ISP.eq.ISQ)then
          Call Square(PQRU(IPQST),X2,1,NBP,NBP)
         Else
          call dcopy_(NBPQ,PQRU(IPQST),1,X2,1)
         Endif
c  If(ISQ.eq.ISS)then triangular
         If(ISQ.eq.ISS)then
c  (pq,rU) -> (pT,rU)
          CALL DGEMM_('T','N',
     &                NBP,NOCQ-NU+1,NBQ,
     &                1.0d0,X2,NBQ,
     &                CMO(LMOQ2+NBQ*(NU-1)),NBQ,
     &                0.0d0,X1,NBP)
c  (pT,rU) -> (AT,rU)
          CALL DGEMM_('T','N',
     &                NOCQ-NU+1,NOP,NBP,
     &                1.0d0,X1,NBP,
     &                CMO(LMOP2),NBP,
     &                0.0d0,X2,NOCQ-NU+1)
         Else
c  (pq,rU) -> (pT,rU)
          CALL DGEMM_('T','N',
     &                NBP,NOCQ,NBQ,
     &                1.0d0,X2,NBQ,
     &                CMO(LMOQ2),NBQ,
     &                0.0d0,X1,NBP)
c  (pT,rU) -> (AT,rU)
          CALL DGEMM_('T','N',
     &                NOCQ,NOP,NBP,
     &                1.0d0,X1,NBP,
     &                CMO(LMOP),NBP,
     &                0.0d0,X2,NOCQ)
         Endif
c  Store buffer
         IF(IR.GT.LR) THEN
          IR=1
cvv          DO I=1,NOTU
cvv           CALL dDAFILE(LUHLF3,1,PQTU(1+LAR*(I-1)),LAR,IAD3)
cvv          End do
         CALL dDAFILE(LUHLF3,1,PQTU,LAR*NOTU,IAD3)
         ENDIF
c  Sort
         NAT=0
         DO NA=1,NOP
          NTM=1
          IF(ISQ.EQ.ISS) NTM=NU
          DO NT=NTM,NOCQ
           ITU=NOCS*(NT-1)+NU-1
           IF(ISQ.LT.ISS) ITU=NOCQ*(NU-1)+NT-1
           IF(ISQ.EQ.ISS) ITU=(NT**2-NT)/2+NU-1
           NAT=NAT+1
           PQTU(LAR*ITU+NOP*(IR-1)+NA)=X2(NAT)
c          if(isp.eq.7.and.isq.eq.1.and.isr.eq.6)
c    &     write(6,'(d13.6)')pqtu(1)
          Enddo
         Enddo
c End of loop over r,u pair
        Enddo
       Enddo
c Store last buffer
       IF(LR.LT.NBR) THEN
cvv        DO I=1,NOTU
cvv         CALL dDAFILE(LUHLF3,1,PQTU(1+LAR*(I-1)),LAR,IAD3)
cvv        Enddo
       CALL dDAFILE(LUHLF3,1,PQTU,LAR*NOTU,IAD3)
       ENDIF
c Transform fourth index
       IF(ISQ.GE.ISS) THEN
c Exchange type 1
        ISPQRS=((ISQ**2-ISQ)/2+ISS-1)*NSYMP+(ISP**2-ISP)/2+ISR
        IAD2M(2,ISPQRS)=IAD13
        NTMAX=NOCQ
        NUMAX=NOCS
       ELSE
c Exchange type 2
        ISPQRS=((ISS**2-ISS)/2+ISQ-1)*NSYMP+(ISP**2-ISP)/2+ISR
        IAD2M(3,ISPQRS)=IAD13
        NTMAX=NOCS
        NUMAX=NOCQ
       ENDIF
c Loop over t,u pair, If(ISQ.eq.ISS) loop should be triangle
       IST=1-NOP*NBR
       KKTU=0
       DO NT=1,NTMAX
        NUM=NUMAX
        IF(ISQ.EQ.ISS) NUM=NT
        DO NU=1,NUM
         IST=IST+NOP*NBR
         KKTU=KKTU+1
         IF(LR.LT.NBR)THEN
          Call RBuf_tra2(LUHLF3,PQTU,NBR*NOP,LAR,NOTU,KKTU,IST,IAD3S)
         ENDIF
c  (AT,rU) -> (AT,BU)
         CALL DGEMM_('T','T',
     &               NOR,NOP,NBR,
     &               1.0d0,CMO(LMOR2),NBR,
     &               PQTU(IST),NOP,
     &               0.0d0,X2,NOR)
C
C       WRITE THESE BLOCK OF INTEGRALS ON LUINTM
C
         Call GADSum(X2,NOP*NOR)
         Call dDAFILE(LUINTM,1,X2,NOP*NOR,IAD13)
        Enddo
       Enddo
c End of loop over t,u pair
      Endif
c-----------------------------------------------------------------------
c Case 5 (TA,BU) and 6 (UB,AT)
c  Calculated if ISP.ne.ISQ.or.(ISQ.lt.ISR.and.ISP.eq.ISR)
c  If ISQ.ge.ISR then Case 5, which alwats gives type 1 integrals
c  If ISQ.lt.ISR.and.ISP.ne.ISR
c                then Case 6, which alwats gives type 2 integrals
c-----------------------------------------------------------------------
      NOTU=NOCP*NOCS
c ISP.eq.ISR in Case 6 should be skipped.
      If(ISQ.lt.ISR.and.ISP.eq.ISR)goto 100
      If(ISP.ne.ISQ.and.icxc5.NE.0)then
       LAR=LTUPQ/NOTU
       LR=LAR/NOQ
       IF(LR.GT.NBR) LR=NBR
       LAR=NOQ*LR
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,PQTU,LAR,IAD3S)
       IAD3=0
       IRU=0
       IR=0
c Loop over r,u pair
       Do NR=1,NBR
        IR=IR+1
        Do NU=1,NOCS
c  Square is unnecessary
         IRU=NBR*(NU-1)+NR
         IPQST=1+NBPQ*(IRU-1)
         IF(IPQMX2.LT.NBPQ) THEN
          Call RBuf_tra2(LUHLF2,PQRU,NBPQ,IPQMX2,NORU,IRU,IPQST,IAD2S)
         ENDIF
c  Always ISP.gt.ISS i.e. s(T).gt.s(U)
c  (pq,rU) -> (Tq,rU)
         CALL DGEMM_('N','N',
     &               NBQ,NOCP,NBP,
     &               1.0d0,PQRU(IPQST),NBQ,
     &               CMO(LMOP2),NBP,
     &               0.0d0,X1,NBQ)
c  (Tq,rU) -> (TA,rU)
         CALL DGEMM_('T','N',
     &               NOCP,NOQ,NBQ,
     &               1.0d0,X1,NBQ,
     &               CMO(LMOQ2),NBQ,
     &               0.0d0,X2,NOCP)
c Store buffer
         IF(IR.GT.LR) THEN
          IR=1
cvv          DO I=1,NOTU
cvv           CALL dDAFILE(LUHLF3,1,PQTU(1+LAR*(I-1)),LAR,IAD3)
cvv          Enddo
         CALL dDAFILE(LUHLF3,1,PQTU,LAR*NOTU,IAD3)
         ENDIF
c Sorting
         NAT=0
         DO NA=1,NOQ
          DO NT=1,NOCP
           ITU=NOCS*(NT-1)+NU-1
           NAT=NAT+1
           PQTU(LAR*ITU+NOQ*(IR-1)+NA)=X2(NAT)
          Enddo
         Enddo
c End of loop over r,u pair
        Enddo
       Enddo
c Store last buffer
       IF(LR.LT.NBR) THEN
cvv        DO I=1,NOTU
cvv         CALL dDAFILE(LUHLF3,1,PQTU(1+LAR*(I-1)),LAR,IAD3)
cvv        Enddo
       CALL dDAFILE(LUHLF3,1,PQTU,LAR*NOTU,IAD3)
       ENDIF
       If(ISQ.ge.ISR)then
c   Store(Only type1)
        ISPQRS=((ISP**2-ISP)/2+ISS-1)*NSYMP+(ISQ**2-ISQ)/2+ISR
        IAD2M(2,ISPQRS)=IAD13
       Elseif(ISP.ne.ISR.and.ISR.gt.ISQ) then
c   Store(Only type2)
        ISPQRS=((ISP**2-ISP)/2+ISS-1)*NSYMP+(ISR**2-ISR)/2+ISQ
        IAD2M(3,ISPQRS)=IAD13
       Endif
c Loop over t,u pair
       IST=1-NOQ*NBR
       KKTU=0
       Do NT=1,NOCP
        Do NU=1,NOCS
         IST=IST+NOQ*NBR
         KKTU=KKTU+1
         IF(LR.LT.NBR)THEN
          Call RBuf_tra2(LUHLF3,PQTU,NBR*NOQ,LAR,NOTU,KKTU,IST,IAD3S)
         ENDIF
c  (TA,rU) -> (TA,BU)
         If(ISQ.ge.ISR)then
          CALL DGEMM_('T','T',
     &                NOR,NOQ,NBR,
     &                1.0d0,CMO(LMOR),NBR,
     &                PQTU(IST),NOQ,
     &                0.0d0,X2,NOR)
         Else if(ISP.ne.ISR.and.ISR.gt.ISQ) then
          CALL DGEMM_('N','N',
     &                NOQ,NOR,NBR,
     &                1.0d0,PQTU(IST),NOQ,
     &                CMO(LMOR),NBR,
     &                0.0d0,X2,NOQ)
         Endif
C
C       WRITE THESE BLOCK OF INTEGRALS ON LUINTM
C
         CALL GADSum(X2,NOQ*NOR)
         Call dDAFILE(LUINTM,1,X2,NOQ*NOR,IAD13)
        Enddo
       Enddo
c End of loop over t,u pair
      Endif
  100 Continue

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DefW4cdba (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (cd|ba)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:cdLen,1:abLen)
c
c        help variables
        integer a,b,c,d,ba,cd
c
        if (cSGrp.eq.dSGrp) then
c        case (c=d|b,a)
          ba=0
          do a=1,dima
          do b=1,dimb
          ba=ba+1
            do c=2,dimc
            cd=c*(c-1)/2
            do d=1,c-1
            cd=cd+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(cd,ba)
              W(a,b,d,c)=W(a,b,d,c)+Wx(cd,ba)
            end do
            end do
            do c=1,dimc
            cd=c*(c+1)/2
              W(a,b,c,c)=W(a,b,c,c)+Wx(cd,ba)
            end do
          end do
          end do
c
        else
c        case (c,d|b,a)
          ba=0
          do a=1,dima
          do b=1,dimb
          ba=ba+1
            cd=0
            do d=1,dimd
            do c=1,dimc
            cd=cd+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(cd,ba)
            end do
            end do
          end do
          end do
c
        end if
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(aSGrp)
        call Unused_integer(bSGrp)
      end if
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine correlating_orbitals
************************************************************************
*
* Alter the correlating orbital space by various freeze-delete schemes.
*
************************************************************************
      use inputdata
      implicit none
#include "stdalloc.fh"
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"

      Real*8, Allocatable :: CMO(:), DPQ(:)
      Integer IDISK
      Integer ntri, NDPQ
      Real*8 Dummy(1)
      Integer I, iRC, iSkp, iSym

* memory to store MOs
      NCMO=NBSQT
      CALL MMA_ALLOCATE(CMO,NCMO)

* Read the MOs from the LUONEM file
      IDISK=IAD1M(1)
      CALL DDAFILE(LUONEM,2,CMO,NCMO,IDISK)

* AFreeze CASPT2 calculation, available only with
* Cholesky or RI type integral representation.
      If(Input % AFreeze) then
        If (.not.IfChol) Then
          Call WarningMessage(2,'AFreeze needs Cholesky/RI.')
          Call Quit_OnUserError
        End If
        Write(6,'(A)') ' Additional orbitals will be frozen or deleted'
        Write(6,'(A,18A4)') ' Selected atoms:  ',
     &    (Input%namfro(i),i=1,Input%lnfro)
        Write(6,'(A,8I4)')
     &  ' Frozen orbitals before selection:    ',(nfro(i),i=1,nsym)
        Write(6,'(A,8I4)')
     &  ' Inactive orbitals before selection:  ',(nish(i),i=1,nsym)
        Write(6,'(A,8I4)')
     &  ' Secondary orbitals before selection: ',(nssh(i),i=1,nsym)
        Write(6,'(A,8I4)')
     &  ' Deleted orbitals before selection:   ',(ndel(i),i=1,nsym)
        ntri=0
        Do isym=1,nsym
          ntri=ntri+(nbas(isym)+nbas(isym)**2)/2
        Enddo
        NDPQ=ntri
        CALL MMA_ALLOCATE(DPQ,NDPQ)
        Call AFreez(NSYM,NBAS,NFRO,NISH,NASH,NSSH,NDEL,NAME,
     &    INPUT%NAMFRO,INPUT%LNFRO,DPQ,
     &    Input%THRFR,Input%THRDE,IFQCAN,CMO,NCMO)
        CALL MMA_DEALLOCATE(DPQ)
        Write(6,'(A,8I4)')
     &  ' Frozen orbitals after selection     ',(nfro(i),i=1,nsym)
        Write(6,'(A,8I4)')
     &  ' Inactive orbitals after selection   ',(nish(i),i=1,nsym)
        Write(6,'(A,8I4)')
     &  ' Secondary orbitals after selection: ',(nssh(i),i=1,nsym)
        Write(6,'(A,8I4)')
     &  ' Deleted orbitals after selection:   ',(ndel(i),i=1,nsym)
      Endif

* LOV CASPT2 calculation, available only with
* Cholesky or RI type integral representation.
      If (Input % LovCASPT2) then
        If (.not.IfChol) Then
          Call WarningMessage(2,'LOV-CASPT2 needs Cholesky/RI.')
          Call Quit_OnUserError
        End If
        IF (IFQCAN.EQ.0) Then
          Call WarningMessage(2,'LOV-CASPT2 needs Canonical Orbitals.')
          Call Quit_OnUserError
        EndIf
        If (Input%thr_atm.lt.0.0d0 .or. Input%thr_atm.ge.1.0d0) Then
          write(6,*)' Threshold out of range! Must be in [0,1[ '
          Call Quit_OnUserError
        End If

        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A)') ' Start LovCASPT2 section '
        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A,8I4)')
        Write(6,'(A,8I4)')
     &  ' Frozen orbitals before selection:   ',(nFro(i),i=1,nSym)
        Write(6,'(A,8I4)')
     &  ' Inactive orbitals before selection: ',(nIsh(i),i=1,nSym)
        Write(6,'(A,8I4)')
     &  ' Secondary orbitals before selection:',(nSsh(i),i=1,nSym)
        Write(6,'(A,8I4)')
     &  ' Deleted orbitals before selection:  ',(nDel(i),i=1,nSym)

        EMP2=0.0d0
        Call Lov_CASPT2(irc,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &    NAME,nUniqAt,Input%thr_atm,IFQCAN,
     &    Input%DoMP2,Input%DoEnv,Input%VIRA,EMP2,CMO,NCMO)

        If (irc.ne.0) Then
          write(6,*) 'LovCASPT2 returned rc= ',irc
          Call abend()
        EndIf
        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A)') ' End LovCASPT2 section '
        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A,8I4)')
        iSkp=0
        Do iSym=1,nSym
          iSkp=Max(iSkp,nAsh(iSym))
        End Do
        If (iSkp.lt.1) Call xquit(0)
        Write(6,'(A,8I4)') ' Going to perform CASPT2 calculation '//
     &                      'on the active region only.'
        Write(6,'(A,8I4)')
      Endif

* Frozen Natural Orbital CASPT2 calculation, available only with
* Cholesky or RI type integral representation.
      If (Input % FnoCASPT2) then
        If (.not.IfChol) Then
          Call WarningMessage(2,'FNO-CASPT2 needs Cholesky/RI.')
          Call Quit_OnUserError
        End If
        If (Input%vFrac.le.0.0d0 .or. Input%vFrac.gt.1.0d0) Then
          Call WarningMessage(2,'FNO-CASPT2 fraction out of range.')
          Write(6,*)' Requested fraction of virtual space must be'
          Write(6,*)' between 0.0 and 1.0.'
          Call Quit_OnUserError
        End If

        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A)') ' Start FNO-CASPT2 section '
        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A,8I4)')
        Write(6,'(A,I3,A)') ' NOs specified: ',
     &        int(Input%vfrac*1.0D2),'% of the total virtual space'
        Write(6,'(A,8I4)')
     &  ' Secondary orbitals before selection:',(nSsh(i),i=1,nSym)
        Write(6,'(A,8I4)')
     &  ' Deleted orbitals before selection:  ',(nDel(i),i=1,nSym)

        EMP2=0.0d0
        Call FNO_CASPT2(irc,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &           Input%vfrac,IFQCAN,Input%DoMP2,EMP2,CMO,NCMO)

        If (irc.ne.0) Then
          write(6,*) 'FNO_CASPT2 returned rc= ',irc
          Call abend()
        EndIf
        Write(6,'(A,8I4)')
        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A)') ' End FNO-CASPT2 section '
        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A,8I4)')
        Write(6,'(A,8I4)')
      Endif

      If (Input % GhostDelete) then
        If (Input%ThrGD.lt.0.0d0 .or. Input%ThrGD.ge.1.0d0) Then
          Write(6,*)' GHOST threshold out of range! Must be in [0,1[ '
          Call Quit_OnUserError
        End If

        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A)') ' GHOST virtual space removal'
        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A,8I4)')
        Write(6,'(A,8I4)')
     &  ' Secondary orbitals before selection:',(nSsh(i),i=1,nSym)
        Write(6,'(A,8I4)')
     &  ' Deleted orbitals before selection:  ',(nDel(i),i=1,nSym)

        Call Delete_Ghosts(irc,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &          NAME,nUniqAt,Input%ThrGD,.True.,CMO,Dummy)

        If (irc.ne.0) Then
          write(6,*) 'Delete_GHOSTS returned rc= ',irc
          Call abend()
        EndIf
        Write(6,'(A,8I4)')
        Write(6,'(A)')
     &  '-------------------------------------------------------'
        Write(6,'(A,8I4)')
        Write(6,'(A,8I4)')
      Endif

* Store the MOs on the LUONEM file
      IDISK=IAD1M(1)
      CALL DDAFILE(LUONEM,1,CMO,NCMO,IDISK)

      CALL MMA_DEALLOCATE(CMO)

* we need to force recanonicalization of the orbitals later
      IFQCAN=0

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine testconv2_cvb(close2conv,converged,wrongstat,
     >  act,zz,step,grad,npr,eigmn,eigmx,eigmna,nposeig,nnegeig)
      implicit real*8 (a-h,o-z)
#include "formats_cvb.fh"
      logical close2conv,converged,wrongstat,close_old
      logical dfx_is_small,step_is_small,grad_is_small
      logical correct_index,zz_ok
#include "tols_cvb.fh"
#include "print_cvb.fh"
      dimension step(npr),grad(npr)

      close_old=close2conv

      step_nrm=dnrm2_(npr,step,1)
      step_rms=step_nrm/sqrt(DBLE(npr))
      call findamx_cvb(step,npr,step_amx,idum)

      grad_nrm=dnrm2_(npr,grad,1)
      grad_rms=grad_nrm/sqrt(DBLE(npr))
      call findamx_cvb(grad,npr,grad_amx,idum)

      if(ip(3).ge.2)then
        if(nnegeig.gt.0.and.nposeig.gt.0)then
          write(6,*)' Maximum eigenvalue : ',eigmx,' of first ',
     >      nnegeig,' values.'
          write(6,*)' Minimum eigenvalue : ',eigmn,' of last  ',
     >      nposeig,' values.'
        elseif(nnegeig.gt.0)then
          write(6,*)' Maximum eigenvalue : ',eigmx
        else
          write(6,*)' Minimum eigenvalue : ',eigmn
        endif
      endif

c  Local region / final convergence reached if :
c  a) Change in F(X) small
c  b) Step is small
c  c) Gradient is small
c  d) Hessian has correct index
c  e) ACT/EXP ratio is within acceptable interval

      if(eigmna.gt.singul(1))then
        mm=1
      else
        mm=2
      endif
      dfx_is_small=(act.lt.dfx(mm))
      step_is_small=(step_nrm.lt.dx(2,mm).and.
     >  step_rms.lt.dx(3,mm).and.step_amx.lt.dx(1,mm))
      grad_is_small=(grad_nrm.lt.grd(2,mm).and.
     >  grad_rms.lt.grd(3,mm).and.grad_amx.lt.grd(1,mm))
      correct_index=eigmx.lt.sign(mm).and.eigmn.gt.-sign(mm)
      zz_ok=(zz.gt.zzmin(mm).and.zz.lt.zzmax(mm))

      close2conv=(dfx_is_small.and.step_is_small.and.grad_is_small
     >  .and.correct_index.and.zz_ok)

      if(eigmna.gt.singul(2))then
        mm=3
      else
        mm=4
      endif
      dfx_is_small=(act.lt.dfx(mm))
      step_is_small=(step_nrm.lt.dx(2,mm).and.
     >  step_rms.lt.dx(3,mm).and.step_amx.lt.dx(1,mm))
      grad_is_small=(grad_nrm.lt.grd(2,mm).and.
     >  grad_rms.lt.grd(3,mm).and.grad_amx.lt.grd(1,mm))
      correct_index=eigmx.lt.sign(mm).and.eigmn.gt.-sign(mm)
      zz_ok=(zz.gt.zzmin(mm).and.zz.lt.zzmax(mm))

      if(ip(3).ge.2)then
        write(6,'(/,a)')' Test of convergence :'
        write(6,'(a)')' ---------------------'
        call cvprt_cvb(' 1) Change in F(x) :',dfx_is_small)
        call cvprt_cvb(' 2) Step length    :',step_is_small)
        call cvprt_cvb(' 3) Grad norm      :',grad_is_small)
        call cvprt_cvb(' 4) Hessian index  :',correct_index)
        call cvprt_cvb(' 5) Act/Exp ratio  :',zz_ok)
        write(6,*)' '
        call cvprt2_cvb(' F(x) change   :',act,dfx(mm),1)
        call cvprt2_cvb(' Norm of step  :',step_nrm,dx(2,mm),1)
        call cvprt2_cvb(' RMS of step   :',step_rms,dx(3,mm),1)
        call cvprt2_cvb(' AMAX of step  :',step_amx,dx(1,mm),1)
        call cvprt2_cvb(' Norm of grad  :',grad_nrm,grd(2,mm),1)
        call cvprt2_cvb(' RMS of grad   :',grad_rms,grd(3,mm),1)
        call cvprt2_cvb(' AMAX of grad  :',grad_amx,grd(1,mm),1)
        call cvprt2_cvb(' Max. eigval   :',eigmx,sign(mm),1)
        call cvprt2_cvb(' Min. eigval   :',eigmn,-sign(mm),2)
        call cvprt2_cvb(' Act/Exp ratio :',zz,zzmin(mm),2)
        call cvprt2_cvb(' Act/Exp ratio :',zz,zzmax(mm),1)
        write(6,*)' '
      endif

      converged=(dfx_is_small.and.step_is_small.and.grad_is_small
     >  .and.correct_index.and.zz_ok)
      converged=(converged.and.close2conv)

      if(eigmna.gt.singul(3))then
        mm=5
      else
        mm=6
      endif
      dfx_is_small=(act.lt.dfx(mm))
      step_is_small=(step_nrm.lt.dx(2,mm).and.
     >  step_rms.lt.dx(3,mm).and.step_amx.lt.dx(1,mm))
      grad_is_small=(grad_nrm.lt.grd(2,mm).and.
     >  grad_rms.lt.grd(3,mm).and.grad_amx.lt.grd(1,mm))
      correct_index=eigmx.lt.sign(mm).and.eigmn.gt.-sign(mm)
      zz_ok=(zz.gt.zzmin(mm).and.zz.lt.zzmax(mm))

c  Wrong stationary point if otherwise converged, but Hessian
c  hasn't got correct index:
      wrongstat=(dfx_is_small.and.step_is_small.and.grad_is_small
     >  .and.(.not.correct_index).and.zz_ok)

      if(ip(3).ge.1.and.close2conv.and..not.(converged.or.close_old))
     >  write(6,'(a)')' Optimization entering local region.'
      if(converged.and.ip(3).ge.0)then
        write(6,formAD)
     >    ' Converged ... maximum update to coefficient:',step_amx
        if(eigmna.le.singul(2))then
          write(6,'(a)')' Warning - singular hessian!'
          write(6,formAD)' Smallest Hessian eigenvalue :',eigmna
        endif
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Eigen_Molcas(N,X,D,E)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Compute eigenvalues and eigenvectors of a symmetric real matrix  *
*     by the method of Householder (QR algorithm)                      *
*                                                                      *
*     reference:                                                       *
*     R.S. Martin, C. Reinsch and J.H. Wilkinson                       *
*     Num. Mat. Vol 11, p 181.-195 (1968)                              *
*                                                                      *
*     calling arguments:                                               *
*     N       : Type integer, input.                                   *
*               Dimensions of the matrix X and vectors D and E         *
*     X       : Type real*8 real, input/output                         *
*               on input it is the matrix to diagonalized              *
*               on output it contains the eigenvectors                 *
*     D       : Type real*8 real, output.                              *
*               vector of eigenvalues                                  *
*     E       : Type real*8 real, input/output.                        *
*               Scratch area of length N                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher, University of Lund, Sweden, 2000                 *
*     (the subrotine is based on a old implementation written          *
*      by the comp. center in Munich)                                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension X(N,N),D(N),E(N)

      Parameter ( eps  = 3.0D-17 )
      Parameter ( tol  = 1.0D-22 )
      Parameter ( One  = 1.0D+00 )
      Parameter ( Zero = 0.0D+00 )

      If ( N.eq.1 ) then
        D(1) = X(1,1)
        X(1,1) = One
        Return
      End If
C
C     HOUSEHOLDER REDUCTION
C
      Do ii = 2,N
        i = N+2-ii
        l = i-2
        H = Zero
        G = X(i,i-1)
        If ( l.gt.0 ) then
          Do k = 1,l
            H = H+X(i,k)*X(i,k)
          End Do
          S = H+G*G
          If ( S.lt.Tol ) H = Zero
          If ( H.gt.Zero ) then
            l = l+1
            F = G
            G = sqrt(S)
            If ( G.gt.Zero ) G = -G
            H = S-F*G
            X(i,i-1) = F-G
            F = Zero
            Do j = 1,l
              X(j,i) = X(i,j)/H
              sum = Zero
              Do k = 1,j
                sum = sum+X(j,k)*X(i,k)
              End Do
              Do k = j+1,l
                sum = sum+X(k,j)*X(i,k)
              End Do
              E(j) = sum/H
              F = F+sum*X(j,i)
            End Do
            F = F/(H+H)
            Do j = 1,l
              E(j) = E(j)-F*X(i,j)
            End Do
            Do j = 1,l
              F = X(i,j)
              scal = E(j)
              Do k = 1,j
                X(j,k) = X(j,k)-F*E(k)-X(i,k)*scal
              End Do
            End Do
          End If
        End If
        D(i) = H
        E(i-1) = G
      End Do
C
C     ACCUMULATION OF TRANSFORMATION MATRICES
C
      D(1) = X(1,1)
      X(1,1) = One
      Do i = 2,N
        l = i-1
        If ( D(i).gt.0.0D0 ) then
          Do j = 1,l
            S = Zero
            Do k = 1,l
              S = S+X(i,k)*X(k,j)
            End Do
            Do k = 1,l
              X(k,j) = X(k,j)-S*X(k,i)
            End Do
          End Do
        End If
        D(i) = X(i,i)
        X(i,i) = One
        Do j = 1,l
          X(i,j) = Zero
          X(j,i) = Zero
        End Do
      End Do
C
C     DIAGONAlIZATION OF THE TRIDIAGONAL MATRIX
C
      B = Zero
      F = Zero
      E(N) = Zero
      Do l = 1,N
        H = eps*(abs(D(l))+abs(E(l)))
        If ( H.GT.B ) B = H
        Do j = l,N
          If ( abs(E(j)).lE.B ) then
            If ( j.eq.l ) Goto 100
          End If
        End Do
        j = N
        Do while ( abs(E(l)).GT.B )
          P = (D(l+1)-D(l))*0.5D0/E(l)
          R = sqrt(P*P+One)
          If ( P.ge.Zero ) then
            P = P+R
          Else
            P = P-R
          End If
          H = D(l)-E(l)/P
          Do i = l,N
            D(i) = D(i)-H
          End Do
          F = F+H
          P = D(j)
          C = One
          S = Zero
          Do ii = l,j-1
            i = l+j-1-ii
            G = C*E(i)
            H = C*P
            If ( abs(P).lT.abs(E(i)) ) then
              C = P/E(i)
              R = sqrt(C*C+One)
              E(i+1) = S*E(i)*R
              S = One/R
              C = C/R
            Else
              C = E(i)/P
              R = sqrt(C*C+One)
              E(i+1) = S*P*R
              S = C/R
              C = One/R
            End If
            P = C*D(i)-S*G
            D(i+1) = H+S*(C*G+S*D(i))
            Do k = 1,N
              H = X(k,i+1)
              X(k,i+1) = X(k,i)*S+H*C
              X(k,i) = X(k,i)*C-H*S
            End Do
          End Do
          E(l) = S*P
          D(l) = C*P
        End Do
100     Continue
        D(l) = D(l)+F
      End Do
C
C     ORDERING OF EIGENVALUES
C
      Do i = 1,N-1
        Do j = i+1,N
          If ( D(j).lt.D(i) ) then
            tmp = D(j)
            D(j) = D(i)
            D(i) = tmp
            Do k = 1,N
              tmp = X(k,j)
              X(k,j) = X(k,i)
              X(k,i) = tmp
            End Do
          End If
        End Do
      End Do
C
C     FIXING OF SIGN
C
      Do i = 1,N
        k = 1
        tmp = abs(X(k,i))
        Do j = 2,N
          If ( tmp.le.abs(X(j,i)) ) then
            tmp = abs(X(j,i))
            k = j
          End If
        End Do
        If ( X(k,i).lt.Zero ) then
          Do j = 1,N
            X(j,i) = -X(j,i)
          End Do
        End If
      End Do

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ZMatConv(LuWr,iAtom,iErr)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension u1(3),u2(3),u3(3),u4(3),vj(3),vp(3)
#include "g_zmatconv.fh"

      iErr = 0

      torad = 3.1415926536d0 / 180.0d0
      dCBiAtom = COS(torad*Zmat(iAtom,2))
      dSBiAtom = SIN(torad*Zmat(iAtom,2))
      dCTiAtom = COS(torad*Zmat(iAtom,3))
      dSTiAtom = SIN(torad*Zmat(iAtom,3))
      If (ABS(dCBiAtom).LT.1.0d-10) dCBiAtom = 0.0d0
      If (ABS(dSBiAtom).LT.1.0d-10) dSBiAtom = 0.0d0
      If (ABS(dCTiAtom).LT.1.0d-10) dCTiAtom = 0.0d0
      If (ABS(dSTiAtom).LT.1.0d-10) dSTiAtom = 0.0d0

      Call vec(1.0d-06,u1,iZmat(iAtom,2),iZmat(iAtom,3),iErr)
! Vet. u1(NB-NT)
      If (iErr.NE.0) GoTo 9990 ! Vettore u1 nullo
      Call vec(1.0d-06,u2,iZmat(iAtom,1),iZmat(iAtom,2),iErr)
! Vet. u2(NA,NB)
      If (iErr.NE.0) GoTo 9990 ! Vettore u2 nullo
      arg = 1.0d0 - ( u1(1)*u2(1) + u1(2)*u2(2) + u1(3)*u2(3) )**2
      If (arg.LT.0.0d0) GoTo 9990 ! u1 e u2 allineati
      r = sqrt(arg) ! (u1.u2)^0.5
      If (r .LT. 1.0d-6) GoTo 9990 ! r piccolo

      Call crprod(u1,u2,vp) ! Vettore piano perpendicolare u1 x u2
      Do i=1,3
        u3(i) = vp(i)/r
      EndDo
      Call crprod(u3,u2,u4)
      Do i=1,3
        vj(i) = Zmat(iAtom,1)*(-u2(i)*dCBiAtom+u4(i)*dSBiAtom*dCTiAtom
     &                                       +u3(i)*dSBiAtom*dSTiAtom)
        Coords(iAtom,i) = Coords(iZmat(iAtom,1),i) + vj(i)
      EndDo

      GoTo 9999

9990  iErr=1
      Write(LuWr,*) ' [Z-Mat_Conv] Incipient floating point error ',
     &'detected for atom ',iAtom

9999  Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine vbgendet_cvb(
     >  iapr,ixapr,ibpr,ixbpr,
     >  iconfs,idetvb,
     >  nconf,nconfion,
     >  nda,ndb,ndetvb,nel,
     >  noe,nalf,nbet,norb)
      implicit real*8 (a-h,o-z)
      dimension iapr(ndetvb),ixapr(nda+1),ibpr(ndetvb),ixbpr(ndb+1)
      dimension iconfs(noe,nconf),idetvb(ndetvb)
      dimension nconfion(0:nel)
#include "WrkSpc.fh"

      k1= mstacki_cvb(ndetvb)
      k2= mstacki_cvb(ndetvb)
      k3= mstacki_cvb(ndetvb)
      k4= mstacki_cvb(ndetvb)
      call vbgendet2_cvb(
     >  iapr,ixapr,ibpr,ixbpr,
     >  iconfs,idetvb,
     >  nconf,nconfion,
     >  nda,ndb,ndetvb,nel,
     >  noe,nalf,nbet,norb,
     >  iwork(k1),iwork(k2),iwork(k3),iwork(k4))
      call mfreei_cvb(k1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine mo_transp(cmo,cmo_t,no,nv,ndel,nbas)
c
c CMO(p,alpha) <- CMO_t(alpha,p+del),  p=o+v
c
        integer no,nv,nbas,ndel
        integer i,j
        real*8 cmo(1:(no+nv),1:nbas)
        real*8 cmo_t(1:nbas,1:(no+nv+ndel))
c
        do i=1,nbas
        do j=1,(no+nv)
c
        cmo(j,i)=cmo_t(i,j)
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018, Jesper Norell                                    *
************************************************************************

*****************************************************************
*  SUBROUTINE MKDYSZZ
*  PURPOSE: CALCULATE DYSON ORBITAL COEFFICIENTS FOR CI EXPANSIONS IN
*  BASIS FUNCTION BASE BASE Z,
*  IN ANALOGUE TO MKTDZZ FOR TRANSITION DENSITY MATRIX.
*****************************************************************

      SUBROUTINE MKDYSZZ(CMOA,DYSAB,DYSZZ)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 DYSAB(*),DYSZZ(*)
      DIMENSION CMOA(NCMO)
      INTEGER IBIO,IZZ,SYMOFF,BIOOFF
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "symmul.fh"
#include "rassi.fh"

C *** Re-express the DO coefficients in biorth basis DYSAB
C *** into atomic basis DYSZZ with help of CMOA that contains
C *** biorth orbitals in ZZ basis

      SYMOFF=0
      DO ISY1=1,NSYM
        NO1=NOSH(ISY1)
        NB1=NBASF(ISY1)
        DO IBIO=1,NO1
         DO IZZ=1,NB1
          BIOOFF=(IBIO-1)*NB1
          COEFF=DYSAB(IBIO)*CMOA(SYMOFF+BIOOFF+IZZ)
          DYSZZ(IZZ)=DYSZZ(IZZ)+COEFF
         END DO
        END DO
        SYMOFF=SYMOFF+NO1
      END DO

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION CHO_TABIND(TABLE,LKEY,NTABLE,EOINP,LEOINP,NEOINP,
     &                            WORD)
C
C     Purpose: table lookup.
C              First, try to find WORD in TABLE. If success, return ID,
C              else, check if WORD is a special string
C              in EOINP (if any supplied). If success, return NTABLE+1,
C              else, return -1.
C
      IMPLICIT NONE
      INTEGER LKEY, NTABLE, LEOINP, NEOINP
      CHARACTER*(*) TABLE(NTABLE)  ! <-- character*(lkey)
      CHARACTER*(*) EOINP(NEOINP)  ! <-- character*(leoinp)
      CHARACTER*(*) WORD           ! <-- character*(lkey)

      INTEGER IJUMP, LCMP

C     Find entry.
C     -----------

      IF (LKEY.GT.0 .AND. NTABLE.GT.0) THEN
         IJUMP = 1
         DO WHILE (IJUMP.LE.NTABLE .AND. TABLE(IJUMP).NE.WORD)
            IJUMP = IJUMP + 1
         END DO
         IF (IJUMP .GT. NTABLE) THEN
            IF (LEOINP.GT.0 .AND. NEOINP.GT.0) THEN
               LCMP  = MIN(LEOINP,LKEY)
               IJUMP = 1
               DO WHILE (IJUMP.LE.NEOINP .AND.
     &                   EOINP(IJUMP)(1:LCMP).NE.WORD(1:LCMP))
                  IJUMP = IJUMP + 1
               END DO
               IF (IJUMP .GT. NEOINP) THEN
                  CHO_TABIND = -1
               ELSE
                  CHO_TABIND = NTABLE + 1
               END IF
            ELSE
               CHO_TABIND = -1
            END IF
         ELSE
            CHO_TABIND = IJUMP
         END IF
      ELSE
         CHO_TABIND = -1
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine KnEInt_GIAO( &
#                      define _CALLING_
#                      include "int_interface.fh"
                      )
!***********************************************************************
!                                                                      *
! Object: to compute the kinetic energy integrals with the Gauss-      *
!         Hermite quadrature.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!             Modified to multipole moments November '90               *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW
use Index_Functions, only: nTri_Elem1
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: iBeta, iComp, iDCRT(0:7), ipA, ipAOff, ipAxyz, ipB, ipBOff, ipBxyz, ipFnl, ipQxyz, iPrint, ipRxyz, ipTxyz, &
                     ipWxyz, iRout, iStabO(0:7), lDCRT, llOper, LmbdT, nB, nDCRT, nip, nOp, nStabO
real(kind=wp) :: TC(3)
logical(kind=iwp) :: ABeq(3)
integer(kind=iwp), external :: NrOpr

#include "macros.fh"
unused_var(ZInv)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 150
iPrint = nPrint(iRout)
ABeq(:) = A == RB

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+2)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+2)
ipRxyz = nip
nip = nip+nZeta*3*nHer*(nOrdOp+2)
ipQxyz = nip
nip = nip+nZeta*3*(la+2)*(lb+2)*(nOrdOp+2)
ipTxyz = nip
nip = nip+nZeta*3*(la+1)*(lb+1)*(nOrdOp+2)
ipWxyz = nip
nip = nip+nZeta*3*(la+1)*(lb+1)*2
ipA = nip
nip = nip+nZeta
ipB = nip
nip = nip+nZeta
ipFnl = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp
!                                                                      *
!***********************************************************************
!                                                                      *
if (nip-1 > nArr*nZeta) then
  call WarningMessage(2,'KNEInt: nip-1 > nArr*nZeta')
  write(u6,*) 'nip=',nip
  write(u6,*) 'nArr,nZeta=',nArr,nZeta
  call Abend()
end if

if (iPrint >= 49) then
  call RecPrt(' In KnEInt: A',' ',A,1,3)
  call RecPrt(' In KnEInt: RB',' ',RB,1,3)
  call RecPrt(' In KnEInt: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In KnEInt: P',' ',P,nZeta,3)
  write(u6,*) ' In KnEInt: la,lb=',la,lb
end if
!                                                                      *
!***********************************************************************
!                                                                      *
llOper = lOper(1)
do iComp=2,nComp
  llOper = ior(llOper,lOper(iComp))
end do
!                                                                      *
!***********************************************************************
!                                                                      *

! Compute the cartesian values of the basis functions angular part

call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),la+1,HerR(iHerR(nHer)),nHer,ABeq)
call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),lb+1,HerR(iHerR(nHer)),nHer,ABeq)

call SOS(iStabO,nStabO,llOper)
call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

do lDCRT=0,nDCRT-1
  call OA(iDCRT(lDCRT),CCoor,TC)

  ! Compute the contribution from the multipole moment operator

  ABeq(:) = .false.
  call CrtCmp(Zeta,P,nZeta,TC,Array(ipRxyz),nOrdOp+1,HerR(iHerR(nHer)),nHer,ABeq)

  ! Compute the cartesian components for the multipole moment
  ! integrals. The integrals are factorized into components.

  call Assmbl(Array(ipQxyz),Array(ipAxyz),la+1,Array(ipRxyz),nOrdOp+1,Array(ipBxyz),lb+1,nZeta,HerW(iHerW(nHer)),nHer)

  ! Compute the cartesian components for the kinetic energy
  ! integrals. The kinetic energy components are linear
  ! combinations of overlap components.

  ipAOff = ipA-1
  do iBeta=1,nBeta
    Array(ipAOff+1:ipAOff+nAlpha) = Alpha
    ipAOff = ipAOff+nAlpha
  end do

  ipBOff = ipB-1
  do iBeta=1,nBeta
    Array(ipBOff+1:ipBOff+nAlpha) = Beta(iBeta)
    ipBOff = ipBOff+nAlpha
  end do

  call Kntc_GIAO(Array(ipTxyz),Array(ipQxyz),Array(ipWxyz),la,lb,Array(ipA),Array(ipB),nZeta)

  ! Combine the cartesian components to the full one electron integral.

  nB = 3
  call CmbnKE_GIAO(Array(ipQxyz),nZeta,la,lb,nOrdOp,Zeta,rKappa,Array(ipFnl),nComp/nB,nB,Array(ipTxyz),Array(ipWxyz),A,RB,TC)

  ! Accumulate contributions

  nOp = NrOpr(iDCRT(lDCRT))
  call SymAdO(Array(ipFnl),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,One)

end do

return

end subroutine KnEInt_GIAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Msum( N, Mex,Zex, ML,ZL, MR,ZR, iopt, M, Z )
c   computes the total M, provided all input values are provided
c   according to the desired partition scheme  (iopt = 1 or 2 )
c   all M vectors must be given in the general coordinate system
c
c definition of the variables:
c     N  -- total number of magnetic sites, Integer, input
c    Mex -- magnetisation vector arising from the exchange states only, Real(kind=8) ::, (3) array, input
c    Zex -- statistical sum according to Boltzmann distribution law of the exchange states, Real(kind=8) ::, input
c    ML  -- magnetisation vector arising from LOCAL states (all), Real(kind=8) ::, (N,3) array, input
c    ZL  -- statistical sum according to Boltzmann distribution law arising from LOCAL states (all), Real(kind=8) ::, (N) array, input
c    MR  -- magnetisation vector arising from LOCAL states (exchange only), Real(kind=8) ::, (N,3) array, input
c    ZR  -- statistical sum according to Boltzmann distribution law arising from LOCAL states (exchange only), Real(kind=8) ::, (N) array, input
c   iopt -- option allowing to choose the desired formula, (Integer, input):
c           iopt=1  =>  formula for weak exchange limit ( new derivation)
c           iopt=2  =>  formula for strong exchange limit ( simple sumation of moments),size consistent;
c           iopt=3  =>  formula for strong exchange limit ( not to be used...)
c    M   -- total magnwtisation, Real(kind=8) ::, (3) array, output
c    Z   -- total statistical sum according to Boltzmann distribution, Real(kind=8) ::, output
c---------
c  temporary (local) variables:
c
      Implicit None
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer       :: N, iopt
      Real(kind=8) :: Mex(3), Zex
      Real(kind=8) :: ML(N,3), ZL(N)
      Real(kind=8) :: MR(N,3), ZR(N)
      Real(kind=8) :: M(3), Z
c local variables
      Integer       :: i, ic
      Real(kind=8) :: ZLT, ZRT, MLT(3), MRT(3)
      Logical       :: DBG
      DBG=.false.
      ZLT=1.0_wp
      ZRT=1.0_wp
      Z=0.0_wp
      MLT(:)=0.0_wp
      MRT(:)=0.0_wp
      M(:)=0.0_wp

      If( iopt .eq. 1 ) Then
c compute the total ZT
c my formula (simple):
        Do i=1,N
          ZLT=ZLT*ZL(i)
          ZRT=ZRT*ZR(i)
        End Do
        Z=Zex+ZLT-ZRT
        Do ic=1,3
          Do i=1,N
            MLT(ic) = MLT(ic) + ML(i,ic)
            MRT(ic) = MRT(ic) + MR(i,ic)
          End Do
          M(ic) = Mex(ic) + MLT(ic) - MRT(ic)
        End Do
        If (DBG) Then
          Write(6,'(A,3F10.6)') 'Contribution from exchange states',
     &                           (Mex(ic),ic=1,3)
          Write(6,'(A,3F10.6)') 'Contribution from excited states ',
     &                           (MLT(ic) - MRT(ic),ic=1,3)
        End If

      Else If( iopt .eq. 2 ) Then
c "thesis formula:"
        Do i=1,N
          ZLT=ZLT*ZL(i)
          ZRT=ZRT*ZR(i)
        End Do
        Z = Zex+ZLT-ZRT
        Do ic=1,3
          Do i=1,N
            MLT(ic) = MLT(ic) + ML(i,ic)*ZLT
            MRT(ic) = MRT(ic) + MR(i,ic)*ZRT
          End Do
          M(ic) = (Mex(ic)*Zex + MLT(ic) - MRT(ic))/Z
        End Do

      Else

        Write(6,'(A)') 'chi_sum: IOPT parameter out of range'
        Write(6,'(A,i8)') 'IOPT = ', IOPT
        Return

      End If

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DYAX(N,ALPHA,X,INCX,Y,INCY)
! MULTIPLY A VECTOR, X, BY A SCALAR AND STORE THE RESULT IN THE VECTOR Y.

#include "intent.fh"

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, INCX, INCY
real(kind=wp), intent(in) :: ALPHA, X(1+(N-1)*INCX)
real(kind=wp), intent(_OUT_) :: Y(1+(N-1)*INCY)
integer(kind=iwp) :: I

do I=1,N
  Y(1+(I-1)*INCY) = ALPHA*X(1+(I-1)*INCX)
end do

return

end subroutine DYAX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  PAOLoc
*
*> @brief
*>   Compute projected atomic orbitals (PAOs)
*> @author Thomas Bondo Pedersen
*>
*> @details
*> A set of linearly independent nonorthonormal
*> Projected Atomic Orbitals (PAOs) are computed by projecting
*> the AOs onto the virtual space. Subsequently, the linear
*> dependence may be removed through Cholesky decomposition of a
*> density-type matrix constructed from the linearly dependent
*> PAOs according to \f$ D_{a,b} = \sum_c \mathit{PAO}_{a,c} \mathit{PAO}_{b,c} \f$. Finally,
*> orthonormal linearly independent PAOs may be obtained by
*> multiplying with the inverse square root of the PAO overlap
*> matrix.
*>
*> The Mode input string controls which set is returned in array
*> PAO:
*>
*> - \p Mode = ``'RAW'``: return linearly dependent nonorthonormal PAOs. In this case, array PAO
*>                        should be dimensioned as \p nBas &timens \p nBas (in symmetry blocks).
*> - \p Mode = ``'CHO'``: return linearly independent nonorthonormal PAOs obtained by Cholesky
*>                        decomposition of the density-type matrix. In this case, array PAO should
*>                        be dimensioned as \p nBas &times; \p nVir (in symmetry blocks).
*> - \p Mode = ``'ORT'``: return linearly independent orthonormal PAOs. In this case, array PAO
*>                        should be dimensioned as \p nBas &times; \p nVir (in symmetry blocks).
*>
*> If Mode is anything else, \p Mode = ``'ORT'`` is assumed.
*> Note that if \p nOcc+nVir < \p nBas the remaining \p nBas-nOcc-nVir
*> orbitals are considered part of the orthogonal complement of
*> the virtual space (and are projected out of the AOs when
*> obtaining the raw PAOs). Thus, one may obtain PAOs for any
*> subset of orbitals by specifying \p nOcc and \p nVir arrays
*> appropriately.
*>
*> @note
*> Needs the AO overlap matrix on disk.
*>
*> @param[out] irc  return code
*> @param[in]  CMO  MO coefficients
*> @param[out] PAO  PAOs
*> @param[in]  Thr  Cholesky decomposition threshold
*> @param[in]  nBas Number of basis functions/irrep
*> @param[in]  nOrb Number of orbitals/irrep
*> @param[in]  nOcc Number of occupied orbs/irrep
*> @param[in]  nVir Number of virtual orbs/irrep
*> @param[in]  nSym Number of irreps
*> @param[in]  Mode Mode of calculation
************************************************************************
      SubRoutine PAOLoc(irc,CMO,PAO,Thr,nBas,nOrb,nOcc,nVir,nSym,Mode)
      Implicit Real*8 (a-h,o-z)
      Real*8  CMO(*), PAO(*)
      Integer nBas(nSym), nOrb(nSym), nOcc(nSym), nVir(nSym)
      Character*(*) Mode
#include "WrkSpc.fh"

      Character*6 SecNam
      Parameter (SecNam = 'PAOLoc')

      Character*3 myMode, DefMode
      Parameter (DefMode = 'ORT')
      Integer DefLevel
      Real*8  DefThr
      Parameter (DefThr = 1.0d-12)

      Logical TestOrth, Normalize

#if defined (_DEBUGPRINT_)
      TestOrth = .True.
#else
      TestOrth = .False.
#endif

C     Set return code.
C     ----------------

      irc = 0

C     Set DefLevel from DefMode.
C     --------------------------

      If (DefMode .eq. 'RAW') Then
         DefLevel = 1
      Else If (DefMode .eq. 'CHO') Then
         DefLevel = 2
      Else If (DefMode .eq. 'ORT') Then
         DefLevel = 3
      Else
         Call SysAbendMsg(SecNam,'DefMode not recognized!',
     &                    'Note: this is a programming error...')
         DefLevel = -999999
      End If

C     Interpret Mode input.
C     ---------------------

      lMode = len(Mode)
      If (lMode .lt. 3) Then
         Level = DefLevel
      Else
         myMode = Mode(1:3)
         Call UpCase(myMode)
         If (myMode .eq. 'RAW') Then
            Level = 1
         Else If (myMode .eq. 'CHO') Then
            Level = 2
         Else If (myMode .eq. 'ORT') Then
            Level = 3
         Else
            Level = DefLevel
         End If
      End If

C     Make a dummy allocation to enable de-allocation by flushing.
C     ------------------------------------------------------------

      l_Dum = 1
      Call GetMem('PAOL_Dummy','Allo','Real',ip_Dum,l_Dum)

C     Compute raw projected AOs.
C     --------------------------

      l_R = nBas(1)**2
      Do iSym = 2,nSym
         l_R = l_R + nBas(iSym)**2
      End Do
      Call GetMem('PAOL_R','Allo','Real',ip_R,l_R)

      Normalize = .True.
      Call GetRawPAOs(Work(ip_R),CMO,nBas,nOrb,nOcc,nVir,nSym,Normalize)

      If (Level .eq. 1) Then
         Call dCopy_(l_R,Work(ip_R),1,PAO,1)
         Go To 1 ! return after de-allocation
      End If

C     Use Cholesky decomposition to compute a linearly independent set
C     of nonorthonormal PAOs.
C     ----------------------------------------------------------------

      l_D = nBas(1)**2
      Do iSym = 2,nSym
         l_D = max(l_D,nBas(iSym)**2)
      End Do
      Call GetMem('PAOL_D','Allo','Real',ip_D,l_D)

      If (Thr .le. 0.0d0) Then
         ThrLoc = DefThr
      Else
         ThrLoc = Thr
      End If

      kOffR = ip_R
      kOffP = 1
      Do iSym = 1,nSym
         If (nVir(iSym) .gt. 0) Then
            Call GetDens_Localisation(Work(ip_D),Work(kOffR),
     &                                nBas(iSym),nBas(iSym))
            Call ChoLoc(irc,Work(ip_D),PAO(kOffP),ThrLoc,xNrm,
     &                  nBas(iSym),nVir(iSym))
            If (irc .ne. 0) Go To 1 ! return after de-allocation
         End If
         kOffR = kOffR + nBas(iSym)**2
         kOffP = kOffP + nBas(iSym)*nVir(iSym)
      End Do

      If (Level .eq. 2) Then
         Go To 1 ! return after de-allocation
      End If

C     Orthonormalize the PAOs.
C     ------------------------

      kOffP = 1
      kOffR = ip_R
      Do iSym = 1,nSym
         kOff1 = kOffR + nBas(iSym)*nOcc(iSym)
         Call dCopy_(nBas(iSym)*nVir(iSym),PAO(kOffP),1,Work(kOff1),1)
         kOffP = kOffP + nBas(iSym)*nVir(iSym)
         kOffR = kOffR + nBas(iSym)**2
      End Do
      nOrthPs = 2 ! orthonormalization passes to ensure num. accuracy
      Call OrthoPAO_Localisation(Work(ip_R),nBas,nOcc,nVir,nSym,nOrthPs,
     &                           TestOrth)
      kOffP = 1
      kOffR = ip_R
      Do iSym = 1,nSym
         kOff1 = kOffR + nBas(iSym)*nOcc(iSym)
         Call dCopy_(nBas(iSym)*nVir(iSym),Work(kOff1),1,PAO(kOffP),1)
         kOffP = kOffP + nBas(iSym)*nVir(iSym)
         kOffR = kOffR + nBas(iSym)**2
      End Do

      If (Level .eq. 3) Then
         Go To 1 ! return after de-allocation
      End If

C     De-allocation by flushing.
C     --------------------------

    1 Call GetMem('PAOL_Dummy','Flus','Real',ip_Dum,l_Dum)
      Call GetMem('PAOL_Dummy','Free','Real',ip_Dum,l_Dum)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  CNFINI   := Set NVBR, NDETVB, NDETVB2, MNION, MXION,               *
!*              NCONFION, and IFSC.                                    *
!*                                                                     *
!***********************************************************************
subroutine cnfini_cvb(iconfs,nconf1,nel1,nS,i2s,nMs,nalf1,nvbr1,ndetvb1,ndetvb21,mnion1,mxion1,nconfion,ifsc1)

use casvb_global, only: noe, norb
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nconf1, iconfs(noe,nconf1), nel1, nS, i2s(nS), nMs, nalf1(nMs)
integer(kind=iwp), intent(out) :: nvbr1, ndetvb1, ndetvb21, mnion1, mxion1, ifsc1
integer(kind=iwp), intent(_OUT_) :: nconfion(0:*)
integer(kind=iwp) :: i, iconf, iMs, ion, iorb, iretval, iretval1, iretval2, iS

! Main loop over configurations:
mnion1 = nel1/2
mxion1 = 0
nconfion(0:nel1/2) = 0
ndetvb1 = 0
ndetvb21 = 0
nvbr1 = 0
do iconf=1,nconf1
  ion = 0
  do iorb=1,norb
    if (iconfs(iorb,iconf) == 2) ion = ion+1
  end do
  if (ion < mnion1) mnion1 = ion
  if (ion > mxion1) mxion1 = ion
  nconfion(ion) = nconfion(ion)+1
  do iS=1,nS
    call icomb_cvb(nel1-2*ion,(nel1-i2s(iS))/2-ion,iretval1)
    call icomb_cvb(nel1-2*ion,(nel1-i2s(iS))/2-ion-1,iretval2)
    nvbr1 = nvbr1+iretval1-iretval2
  end do
  do iMs=1,nMs
    call icomb_cvb(nel1-2*ion,nalf1(iMs)-ion,iretval)
    ndetvb1 = ndetvb1+iretval
    ndetvb21 = ndetvb21+(iretval+1)/2
  end do
end do
if ((norb == nel1) .and. (nconf1 == 1)) then
  ifsc1 = 1
  do i=1,nel1
    if (iconfs(i,nconf1) /= 1) then
      ifsc1 = 0
      exit
    end if
  end do
else
  ifsc1 = 0
end if

return

end subroutine cnfini_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Giovanni Ghigo                                   *
!***********************************************************************

#include "compiler_features.h"
#ifdef _HAVE_EXTRA_

subroutine ZMatrixConverter_GW(LuRd,LuWr,LuOut,nAskAtoms,iErr)
!***********************************************************************
! Author: Giovanni Ghigo                                               *
!         Torino (Italy)  October-November 2006                        *
!                                                                      *
! This is an adaptation of Subroutine ZMatrixConverter for GateWay     *
!***********************************************************************

use ZMatConv_Mod, only: BasReq, Coords, iZmat, NAT, Symbols, Zmat
use isotopes, only: MaxAtomNum
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, deg2rad
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LuRd, LuWr, LuOut, nAskAtoms
integer(kind=iwp), intent(out) :: iErr
integer(kind=iwp) :: i, iAtom, j, k, nAtoms, nBasis, nXAtoms
real(kind=wp) :: r

nAtoms = 0
nBasis = 0
iErr = 0

call mma_allocate(BasReq,MaxAtomNum,label='BasReq')
call mma_allocate(NAT,nAskAtoms,label='NAT')
call mma_allocate(Symbols,nAskAtoms,label='Symbols')
call mma_allocate(iZmat,3,nAskAtoms,label='iZmat')
call mma_allocate(Zmat,3,nAskAtoms,label='Zmat')
BasReq(:) = .false.
NAT(:) = 0
Symbols(:) = ''
iZmat(:,:) = 0
Zmat(:,:) = Zero

! Reading input
call ZMatReader(LuRd,LuWr,nAtoms,nXAtoms,nBasis,nAskAtoms,iErr)
if (iErr /= 0) then
  write(LuWr,*) ' ERROR: Wrong input in Z-Matrix definition !'
  return
end if
write(LuOut,*) nAtoms
write(LuOut,'(A)') 'Angstrom'

! Some checks
if (nAtoms == 0) then
  iErr = 1
  write(LuWr,*) 'ERROR: No atom coordinates specified !'
  return
end if

call Put_iScalar('N ZMAT',nAtoms+nXAtoms)
call Put_cArray('Symbol ZMAT',Symbols(1),(nAtoms+nXAtoms)*len(Symbols))
call Put_iArray('Index ZMAT',iZmat,(nAtoms+nXAtoms)*3)
call Put_iArray('NAT ZMAT',NAT,nAtoms+nXAtoms)

call mma_allocate(Coords,3,nAtoms+nXAtoms,label='Coords')
Coords(:,:) = Zero

! Calculate coordinates
! Atom #1
if (nAtoms+nXAtoms > 1) then
  ! Atom #2
  Coords(3,2) = Zmat(1,2)  ! Z(2)=R
end if
if (nAtoms+nXAtoms > 2) then
  ! Atom #3
  if (iZmat(1,3) == 1) then
    Coords(1,3) = Zmat(1,3)*sin(Zmat(2,3)*deg2rad) ! X(2)=R sin(A)
    Coords(3,3) = Zmat(1,3)*cos(Zmat(2,3)*deg2rad) ! Z(3)=R cos(A)
  else
    Coords(1,3) = Zmat(1,3)*sin(Zmat(2,3)*deg2rad)
    Coords(3,3) = Coords(3,2)-Zmat(1,3)*cos(Zmat(2,3)*deg2rad)
  end if
end if
if (nAtoms+nXAtoms > 3) then
  ! Atom #4 ->
  do iAtom=4,nAtoms+nXAtoms
    call ZMatConv(LuWr,iAtom,iErr)
  end do
  if (iErr /= 0) return
end if

! Check for superposed atoms
do i=1,nAtoms+nXAtoms
  if (NAT(i) > 0) then
    do j=i+1,nAtoms+nXAtoms
      if (NAT(j) > 0) then
        r = Zero
        do k=1,3
          r = r+(Coords(k,i)-Coords(k,j))**2
        end do
        if (r < 1.0e-4_wp) then
          iErr = 1
          write(LuWr,*) ' ERROR: Superimposed atoms: ',i,j,'  r=',sqrt(r)
          return
        end if
      end if
    end do
  end if
end do

! Writing

do i=1,nAtoms+nXAtoms
  if (NAT(i) > 0) write(LuOut,999) Symbols(i),(Coords(k,i),k=1,3)
end do

call mma_deallocate(BasReq)
call mma_deallocate(NAT)
call mma_deallocate(Symbols)
call mma_deallocate(iZmat)
call mma_deallocate(Zmat)
call mma_deallocate(Coords)

return

999 format(A5,1X,3(F12.6))

end subroutine ZMatrixConverter_GW

#elif !defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(ZMatrixConverter_GW)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine EXTRROW(INMAT,IROW,NROW,NCOL,IOUTVEC)
! Extract row IROW from integer matrix INMAT
!
! Jeppe Olsen, Winter 1996

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NROW, NCOL, INMAT(NROW,NCOL), IROW
integer(kind=iwp), intent(out) :: IOUTVEC(NCOL)

IOUTVEC(:) = INMAT(IROW,:)

#ifdef _DEBUGPRINT_
write(u6,*) ' Output vector from EXTRROW'
write(u6,*) ' Extracted ROW ',IROW
call IWRTMA(IOUTVEC,1,NCOL,1,NCOL)
#endif

end subroutine EXTRROW

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine asc2ab_cvb(detvec,nvec,nel,nalf)
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension detvec(*)


      call icomb_cvb(nel,nalf,ndet)
      nbet=nel-nalf
      i1 = mstacki_cvb(nel+1)
      i2 = mstacki_cvb(nel+1)
      i3 = mstacki_cvb(nel+1)
      i4 = mstacki_cvb((nel+1)*(nalf+1))
      i5 = mstacki_cvb(nel)
      call asc2ab2_cvb(detvec,nvec,nel,nalf,
     >  nbet,ndet,
     >  iw(i1),iw(i2),iw(i3),iw(i4),iw(i5))
      call mfreei_cvb(i1)
      return
      end
      subroutine ab2asc_cvb(detvec,nvec,nel,nalf)
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension detvec(*)


      call icomb_cvb(nel,nalf,ndet)
      nbet=nel-nalf
      i1 = mstacki_cvb(nel+1)
      i2 = mstacki_cvb(nel+1)
      i3 = mstacki_cvb(nel+1)
      i4 = mstacki_cvb((nel+1)*(nalf+1))
      i5 = mstacki_cvb(nel)
      call asc2ab2_cvb(detvec,nvec,nel,nalf,
     >  nbet,ndet,
     >  iw(i1),iw(i2),iw(i3),iw(i4),iw(i5))
      call mfreei_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ass3b(D1,D2,D3,PAO,tmp1_,tmp2_,tmp3_,nt,nrys)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nt, nrys
real(kind=wp), intent(in) :: D1(nrys,nt), D2(nrys,nt), D3(nrys,nt), PAO(nt)
real(kind=wp), intent(inout) :: tmp1_, tmp2_, tmp3_
integer(kind=iwp) :: iRys, iT
real(kind=wp) :: tmp1, tmp2, tmp3

tmp1 = Zero
tmp2 = Zero
tmp3 = Zero

select case (nRys)

  case (1)
    do iT=1,nt
      tmp1 = tmp1+PAO(iT)*D1(1,iT)
      tmp2 = tmp2+PAO(iT)*D2(1,iT)
      tmp3 = tmp3+PAO(iT)*D3(1,iT)
    end do

  case (2)
    do iT=1,nt
      tmp1 = tmp1+(D1(1,iT)+D1(2,iT))*PAO(iT)
      tmp2 = tmp2+(D2(1,iT)+D2(2,iT))*PAO(iT)
      tmp3 = tmp3+(D3(1,iT)+D3(2,iT))*PAO(iT)
    end do

  case (3)
    do iT=1,nt
      tmp1 = tmp1+(D1(1,iT)+D1(2,iT)+D1(3,iT))*PAO(iT)
      tmp2 = tmp2+(D2(1,iT)+D2(2,iT)+D2(3,iT))*PAO(iT)
      tmp3 = tmp3+(D3(1,iT)+D3(2,iT)+D3(3,iT))*PAO(iT)
    end do

  case (4)
    do iT=1,nt
      tmp1 = tmp1+(D1(1,iT)+D1(2,iT)+D1(3,iT)+D1(4,iT))*PAO(iT)
      tmp2 = tmp2+(D2(1,iT)+D2(2,iT)+D2(3,iT)+D2(4,iT))*PAO(iT)
      tmp3 = tmp3+(D3(1,iT)+D3(2,iT)+D3(3,iT)+D3(4,iT))*PAO(iT)
    end do

  case (5)
    do iT=1,nt
      tmp1 = tmp1+(D1(1,iT)+D1(2,iT)+D1(3,iT)+D1(4,iT)+D1(5,iT))*PAO(iT)
      tmp2 = tmp2+(D2(1,iT)+D2(2,iT)+D2(3,iT)+D2(4,iT)+D2(5,iT))*PAO(iT)
      tmp3 = tmp3+(D3(1,iT)+D3(2,iT)+D3(3,iT)+D3(4,iT)+D3(5,iT))*PAO(iT)
    end do

  case (6)
    do iT=1,nt
      tmp1 = tmp1+(D1(1,iT)+D1(2,iT)+D1(3,iT)+D1(4,iT)+D1(5,iT)+D1(6,iT))*PAO(iT)
      tmp2 = tmp2+(D2(1,iT)+D2(2,iT)+D2(3,iT)+D2(4,iT)+D2(5,iT)+D2(6,iT))*PAO(iT)
      tmp3 = tmp3+(D3(1,iT)+D3(2,iT)+D3(3,iT)+D3(4,iT)+D3(5,iT)+D3(6,iT))*PAO(iT)
    end do

  case (7)
    do iT=1,nt
      tmp1 = tmp1+(D1(1,iT)+D1(2,iT)+D1(3,iT)+D1(4,iT)+D1(5,iT)+D1(6,iT)+D1(7,iT))*PAO(iT)
      tmp2 = tmp2+(D2(1,iT)+D2(2,iT)+D2(3,iT)+D2(4,iT)+D2(5,iT)+D2(6,iT)+D2(7,iT))*PAO(iT)
      tmp3 = tmp3+(D3(1,iT)+D3(2,iT)+D3(3,iT)+D3(4,iT)+D3(5,iT)+D3(6,iT)+D3(7,iT))*PAO(iT)
    end do

  case (8)
    do iT=1,nt
      tmp1 = tmp1+(D1(1,iT)+D1(2,iT)+D1(3,iT)+D1(4,iT)+D1(5,iT)+D1(6,iT)+D1(7,iT)+D1(8,iT))*PAO(iT)
      tmp2 = tmp2+(D2(1,iT)+D2(2,iT)+D2(3,iT)+D2(4,iT)+D2(5,iT)+D2(6,iT)+D2(7,iT)+D2(8,iT))*PAO(iT)
      tmp3 = tmp3+(D3(1,iT)+D3(2,iT)+D3(3,iT)+D3(4,iT)+D3(5,iT)+D3(6,iT)+D3(7,iT)+D3(8,iT))*PAO(iT)
    end do

  case (9)
    do iT=1,nt
      tmp1 = tmp1+(D1(1,iT)+D1(2,iT)+D1(3,iT)+D1(4,iT)+D1(5,iT)+D1(6,iT)+D1(7,iT)+D1(8,iT)+D1(9,iT))*PAO(iT)
      tmp2 = tmp2+(D2(1,iT)+D2(2,iT)+D2(3,iT)+D2(4,iT)+D2(5,iT)+D2(6,iT)+D2(7,iT)+D2(8,iT)+D2(9,iT))*PAO(iT)
      tmp3 = tmp3+(D3(1,iT)+D3(2,iT)+D3(3,iT)+D3(4,iT)+D3(5,iT)+D3(6,iT)+D3(7,iT)+D3(8,iT)+D3(9,iT))*PAO(iT)
    end do

  case default
    do iT=1,nt
      do iRys=1,nRys
        tmp1 = tmp1+PAO(iT)*D1(iRys,iT)
        tmp2 = tmp2+PAO(iT)*D2(iRys,iT)
        tmp3 = tmp3+PAO(iT)*D3(iRys,iT)
      end do
    end do

end select

tmp1_ = tmp1_+tmp1
tmp2_ = tmp2_+tmp2
tmp3_ = tmp3_+tmp3

end subroutine ass3b

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Hss_q()

use Slapaf_Info, only: Analytic_Hessian, Curvilinear, Degen, dqInt, iRef, lOld, nDimBC, Smmtrc
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i, iAtom, ix, ixyz, nAtom, nQQ
real(kind=wp) :: rDum(1)
real(kind=wp), allocatable :: Hss_X(:), Degen2(:), Hss_Q_(:), KtB(:)

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
if (lOld) return

nQQ = size(dqInt,1)
nAtom = size(Degen,2)
!                                                                      *
!***********************************************************************
!                                                                      *
! Back-transform from cartesian to internals
!
! dQ/dx d^2E/dQ^2 dQ/dx + d^2Q/dx^2 dE/dQ = d^2E/dx^2

! Pickup d^2E/dx^2

call mma_allocate(Hss_x,nDimBC**2,Label='Hss_X')
call Get_dArray('Hss_X',Hss_x,nDimBC**2)
call mma_allocate(KtB,nDimBC*nQQ,Label='KtB')
call Get_dArray('KtB',KtB,nDimBC*nQQ)
#ifdef _DEBUGPRINT_
call RecPrt('Hss_x',' ',Hss_X,nDimBC,nDimBC)
#endif

call mma_allocate(Degen2,nDimBC,Label='Degen2')
i = 0
do ix=1,3*nAtom
  iAtom = (ix+2)/3
  ixyz = ix-(iAtom-1)*3
  if (Smmtrc(ixyz,iAtom)) then
    i = i+1
    Degen2(i) = Degen(ixyz,iAtom)
  end if
end do
#ifdef _DEBUGPRINT_
call RecPrt('Degen2',' ',Degen2,nDimBC,1)
#endif

if (Analytic_Hessian .and. Curvilinear) then

  ! Form u^(1/2) (Sum(i) d^2Q_i/dx^2 * dE/dQ_i) u^(1/2)
  !
  ! and form d^2E/dx^2 - d^2Q/dx^2 dE/dQ

  call dBuu(Degen2,nQQ,nDimBC,dqInt(:,iRef),Hss_X,.false.)
# ifdef _DEBUGPRINT_
  call RecPrt('H(X)-BtgQ',' ',Hss_X,nDimBC,nDimBC)
# endif
end if

call mma_allocate(Hss_Q_,nQQ**2,Label='Hss_Q_')
call Hess_Tra(Hss_X,nDimBC,Degen2,KtB,nQQ,Hss_Q_)

call Put_dArray('Hss_Q',Hss_Q_,nQQ**2)
call Put_dArray('Hss_upd',rDum,0)
#ifdef _DEBUGPRINT_
call RecPrt('Hss_Q: Hessian',' ',Hss_Q_,nQQ,nQQ)
#endif
call mma_deallocate(Hss_Q_)
call mma_deallocate(KtB)
call mma_deallocate(Degen2)
call mma_deallocate(Hss_X)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Hss_q

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1997, Roland Lindh                                *
************************************************************************
      SubRoutine DefInt2(BVct,dBVct,nBvct,BMtrx,mInt,nAtom,
     &                   nLines,Value,rInt,rInt0,Lbl,
     &                   lWrite,rMult,dBMtrx,Value0,lIter,iFlip)
************************************************************************
*                                                                      *
* Object: to generate the B matrix for the constraints                 *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             May '91                                                  *
*                                                                      *
*             Modified to constraints, June '97 by R. Lindh            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "Molcas.fh"
      Real*8 BVct(3*nAtom,nBVct), dBVct(3*nAtom,3*nAtom,nBVct),
     &       Value(nBVct), BMtrx(3*nAtom,mInt), rInt(mInt), rInt0(mInt),
     &       rMult(nBVct,nBVct),
     &       dBMtrx(3*nAtom,3*nAtom,mInt), Value0(nBVct), MaxErr
      Character Line*120, Type*6, Format*8,
     &          Temp*120, Lbl(mInt)*8, filnam*16
      Logical lWrite, Start, rInt0_on_file,rInt0_in_memory, InSlapaf
      Integer, Parameter:: Flip=1, NoFlip=0
      Integer, External:: StrnLn
      Integer iFlip(nBVct)
      Character(LEN=100), External:: Get_SuperName
      Integer, Allocatable:: Ind(:), tpc(:)
      Real*8, Allocatable:: Hess(:), Mass(:), Grad(:), xyz(:), r0(:)
      Character(LEN=8), Allocatable:: Labels(:)
#include "angstr.fh"

      Call mma_allocate(Labels,nBVct,Label='Labels')
      Lu=6
*
*     Initiate some stuff for automatic setting of
*     the constraints to be those that the structure
*     actually has initially.
*
      rInt0_on_file=.FALSE.
      InSlapaf = (Get_SuperName().eq.'slapaf')
      If (InSlapaf) Call qpg_dArray('rInt0',rInt0_on_file,nrInt0)
      If (.not.rInt0_on_File) nrInt0 = mInt
      rInt0_in_memory=.FALSE.
*
      iRout = 30
      iPrint = nPrint(iRout)
      Start=lIter.eq.1
      Call ICopy(nBVct,[Flip],0,iFlip,1)
*
      nTemp=Len(Temp)
      Write (Format,'(A,I3.3,A)') '(F',nTemp,'.0)'
*
      Lu_UDC=91
      filnam='UDC'
      Call molcas_open(Lu_UDC,filnam)
c      Open(Lu_UDC,File=filnam,Form='FORMATTED',Status='OLD')
      Rewind (Lu_UDC)
*
      call dcopy_(nBVct**2,[Zero],0,rMult,1)
      If (iPrint.ge.99) lWrite = .True.
      If (iPrint.ge.99 .or. lWrite) Then
          Write (Lu,*)
          Call CollapseOutput(1,'Constraints section')
          Write (Lu,'(34X,A)') 'CONSTRAINTS'
         Write (Lu,*)
         Write (Lu,'(80A)') ('*',i=1,80)
         Do iLines = 1, nLines
            Read(Lu_UDC,'(A)') Line
            Write (Lu,'(A)') Line(:StrnLn(Line))
         End Do
         Write (Lu,'(80A)') ('*',i=1,80)
         Write (Lu,*)
         Write (Lu,*)
         Write (Lu,*) '*********************************************'//
     &                '****************'
         Write (Lu,*) '* Values of the primitive constraints        '//
     &                '               *'
         Write (Lu,*) '*********************************************'//
     &                '****************'
         Rewind (Lu_UDC)
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Step 1. Set up the b vectors from which we will define the
*             constraints.
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      iBVct = 0
      Call mma_allocate(tpc ,nBVct,Label='tpc')
      Do 10 iLines = 1, nLines
         Read(Lu_UDC,'(A)') Line
         Temp = Line
         Call UpCase(Temp)
         If (Temp(1:4).Eq.'VALU') Go To 100
         iBVct = iBVct + 1
*
*        Move the label of the internal coordinate
*
         neq = Index(Line,'=')
         If (neq.Eq.0) Then
            Call WarningMessage(2,'Error in DefInt2')
            Write (Lu,'(A)') ' Syntax error in line:'
            Write (Lu,'(A)') Line
            Call Quit_OnUserError()
         Else
            iFrst = 1
            Call NxtWrd(Line,iFrst,iEnd)
            jEnd = iEnd
            If (Line(iEnd:iEnd).eq.'=') jEnd = jEnd - 1
            If (jEnd-iFrst+1.gt.8) Then
               Call WarningMessage(2,'Error in DefInt2')
               Write (Lu,'(A,A)') Line(iFrst:jEnd),
     &               ' has more than 8 character, syntax error!'
               Call Quit_OnUserError()
            End If
            Call ChkLbl(Line(iFrst:jEnd),Labels,iBVct-1)
            Labels(iBVct) = Line(iFrst:jEnd)
         End If
*
*--------Construct the corresponding transformation vector
*
         mCntr = 0
         iType = 0
         If (Index(Temp,'CART').Ne.0) Then
            nCntr=1
            nGo = Index(Temp,'CART')
            Call NxtWrd(Temp,nGo,nGo2)
            nGo = nGo2+1
            Call NxtWrd(Temp,nGo,nGo2)
            If (Temp(nGo:nGo2).Eq.'X') Then
               nGo = nGo2+1
               Call NxtWrd(Temp,nGo,nGo2)
               Type='X     '
               iType=1
            Else If (Temp(nGo:nGo2).Eq.'Y') Then
               nGo = nGo2+1
               Call NxtWrd(Temp,nGo,nGo2)
               Type='Y     '
               iType=2
            Else If (Temp(nGo:nGo2).Eq.'Z') Then
               nGo = nGo2+1
               Call NxtWrd(Temp,nGo,nGo2)
               Type='Z     '
               iType=3
            Else
              nGo=-1
              Call WarningMessage(2,'Error in DefInt2')
              Write (Lu,*) 'DefInt2: wrong cartesian type'
              Write (Lu,'(A,A)') 'Temp=',Temp
              Call Quit_OnUserError()
            End If
         Else If (Index(Temp,'BOND').Ne.0) Then
            nCntr=2
            nGo = Index(Temp,'BOND')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type='STRTCH'
            iType=4
         Else If (Index(Temp,'LANGLE(2)').Ne.0) Then
            nCntr=3
            nGo = Index(Temp,'LANGLE(2)')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='LBEND2'
            iType=5
         Else If (Index(Temp,'LANGLE(1)').Ne.0) Then
            nCntr=3
            nGo = Index(Temp,'LANGLE(1)')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='LBEND1'
            iType=6
         Else If (Index(Temp,'ANGL').Ne.0) Then
            nCntr=3
            nGo = Index(Temp,'ANGL')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='BEND  '
            iType=7
         Else If (Index(Temp,'DIHE').Ne.0) Then
            nCntr=4
            nGo = Index(Temp,'DIHE')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='TRSN  '
* AOM!! Remove flip for Torsions!!!
            iFlip(iBVct)=NoFlip
            iType=8
         Else If (Index(Temp,'OUTO').Ne.0) Then
            nCntr=4
            nGo = Index(Temp,'OUTO')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='OUTOFP'
            iFlip(iBVct)=NoFlip
            iType=9
         Else If (Index(Temp,'EDIF').Ne.0) Then
            nCntr=nAtom
            nGo = Index(Temp,'EDIF')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='EDIFF '
            iFlip(iBVct)=NoFlip
            iType=10
         Else If (Index(Temp,'SPHE').Ne.0) Then
            nCntr=nAtom
            nGo = Index(Temp,'SPHE')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='SPHERE'
            iType=11
         Else If (Index(Temp,'NAC ').Ne.0) Then
            nCntr=nAtom
            nGo = Index(Temp,'NAC ')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='NAC   '
            iType=12
         Else If (Index(Temp,'TRAN').Ne.0) Then
            nCntr=nAtom
            nGo = Index(Temp,'TRAN')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='TRANSV'
            iFlip(iBVct)=NoFlip
            iType=13
         Else If (Index(Temp,'DISS').Ne.0) Then
            i1 = Index(Line,'(')
            i2 = Index(Line,'+')
            i3 = Index(Line,')')
            If (i1.ge.i2 .or. i2.ge.i3) Then
               Call WarningMessage(2,'Error in DefInt2')
               Write (6,*)
               Write (6,*) '********** ERROR ************'
               Write (6,*)' Line contains syntax error !'
               Write (6,'(A)') Line
               Write (6,*) i1,i2,i3
               Write (6,*) '*****************************'
               Call Quit_OnUserError()
            End If
            nGo = i3+1
            Temp = Line(i1+1:i2-1)
            Read (Temp,Format) Tmp
            nCntr=NInt(Tmp)
            Temp=Line(i2+1:i3-1)
            Read (Temp,Format) Tmp
            mCntr=NInt(Tmp)
            Type ='DISSOC'
            iType=14
         Else
            nGo=-1
            Call WarningMessage(2,'Error in DefInt2')
            Write (Lu,*)' Line contains syntax error!'
            Write (Lu,'(A)') Line
            Call Quit_OnUserError()
         End If
         tpc(iBVct)=iType
*
         msAtom=nCntr+mCntr
         Call mma_allocate(xyz ,3*msAtom,Label='xyz')
         Call mma_allocate(Grad,3*msAtom,Label='Grad')
         Call mma_allocate(Ind ,2*msAtom,Label='Ind')
         Call mma_allocate(Mass,msAtom,Label='Mass')
         Call mma_allocate(Hess,(3*msAtom)**2,Label='Hess')
*
         Call Cllct2(Line(nGo:nTemp),BVct(1,iBVct),dBVct(1,1,iBVct),
     &               Value(iBVct),nAtom,nCntr,mCntr,xyz,Grad,
     &               Ind,Type,Mass,Labels(iBVct),lWrite,
     &               rMult(iBVct,iBVct),Hess,lIter)
*
         If (Type.eq.'TRSN  ' .and.
     &       Abs(Value(iBVct)).lt.Pi*Half) iFlip(iBVct)=NoFlip
*
         Call mma_deallocate(Hess)
         Call mma_deallocate(Mass)
         Call mma_deallocate(Ind)
         Call mma_deallocate(Grad)
         Call mma_deallocate(xyz)
*
 10   Continue
      Call WarningMessage(2,'Error in DefInt2')
      Write (Lu,*) 'DefInt2: No internal coordinates are defined!'
      Call Quit_OnUserError()
*
 100  Continue

*
*---- Process primitive value to correct for flips
*
      If (.Not.Start) Then
         Do iBVct = 1, nBVct
*
*---------- Test if we have a flip in the sign of the value
*
            If (Value(iBVct)*Value0(iBVct).lt.Zero .and.
     &          iFlip(iBVct).eq.Flip) Then
C              Write (Lu,*) 'Flip Sign for ',Labels(iBVct)
               Value(iBVct)=-Value(iBVct)
            End If
         End Do
      End If
      call dcopy_(nBVct,Value,1,Value0,1)
*

      If (iPrint.ge.59) Call RecPrt(' The B-vectors',' ',
     &                              BVct,3*nAtom,nBVct)
      If (iPrint.ge.19) Then
         Call RecPrt(
     &        ' Value of primitive internal coordinates / au or rad',
     &                             ' ',Value,nBVct,1)
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Step 2. Define constraints as linear combinations of
*             the previously defined primitive internal coordinates.
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      iBMtrx = 0
      jLines=iLines
 201  Continue
         jLines=jLines+1
         If (jLines.gt.nLines) Go To 200
*
         Read (Lu_UDC,'(A)') Line
         Temp = Line
         Call UpCase(Temp)
*
         iBMtrx = iBMtrx + 1
         rInt(iBMtrx) = Zero
         Write(Lbl(iBMtrx),'(A,I3.3)') 'Cns',iBMtrx
*
*------- Find the label of the first primitive
*
         iFrst = 1
         Call NxtWrd(Line,iFrst,iEnd)
         jEnd = iEnd
         If (Line(iEnd:iEnd).eq.'=') jEnd=iEnd-1
*
         nPlus = Index(Line,' + ')
         nMinus= Index(Line,' - ')
*                                                                      *
************************************************************************
*                                                                      *
         If (nPlus.Eq.0.and.nMinus.Eq.0.and.Index(Line,'&').eq.0) Then
*                                                                      *
************************************************************************
*                                                                      *
*           a single vector (this will only extend over one line)
*
            If (Index(Line,'&').ne.0) Then
               Call WarningMessage(2,'Error in DefInt2')
               Write (Lu,*) 'Single vector lines should not extend'
               Write (Lu,*) 'over more than one line!'
               Write (Lu,'(A)') Line
               Call Quit_OnUserError()
            End If
            iBVct = 0
            Do jBVct = 1, nBVct
               If (Line(iFrst:jEnd).eq.Labels(jBVct))
     &            iBVct=jBVct
            End Do
            If (iBVct.eq.0) Then
               Call WarningMessage(2,'Error in DefInt2')
               Write (Lu,*) ' A single vector'
               Write (Lu,*) ' Undefined internal coordinate'
               Write (Lu,'(A,A)') Line
               Write (Lu,'(A,A)') Line(iFrst:jEnd)
               Call ErrTra
               Call Quit_OnUserError()
            End If
*
            call dcopy_(3*nAtom,BVct(1,iBVct),1,BMtrx(1,iBMtrx),1)
            call dcopy_((3*nAtom)**2,dBVct(1,1,iBVct),1,
     &                              dBMtrx(1,1,iBMtrx),1)
            rInt(iBMtrx) = Value(iBVct)
*
            iFrst=iEnd+1
            Call NxtWrd(Line,iFrst,iEnd)
            If (Line(iEnd:iEnd).eq.'=') Then
               iFrst=iEnd+1
               Call NxtWrd(Line,iFrst,iEnd)
            End If
            Temp=Line(iFrst:iEnd)
*
            If (Index(Temp,'FIX').ne.0) Then
*
*              Pick up values from the runfile. Written there on
*              the first iteration.
*
               If (.Not.rInt0_in_memory) Then
                  rInt0_in_memory=.TRUE.
                  Call mma_allocate(r0,nrInt0,Label='r0')
                  If (rInt0_on_file) Then
                     Call Get_dArray('rInt0',r0,nrInt0)
                  Else
                    r0(:)=Zero
                  End If
               End If
*
               If (rInt0_on_file) Then
                  rInt0(iBMtrx)=r0(iBMtrx)
               Else
                  r0(iBmtrx)   =rInt(iBMtrx)
                  rInt0(iBMtrx)=rInt(iBMtrx)
               End If
*
            Else
*
*              Read value from input file.
*
               Read (Temp,Format) rInt0(iBMtrx)
               Temp = Line
               Call UpCase(Temp)
               If (Index(Temp,'ANGSTROM').ne.0) rInt0(iBMtrx) =
     &                                       rInt0(iBMtrx)/angstr
               If (Index(Temp,'DEGREE').ne.0) rInt0(iBMtrx) =
     &                                     rInt0(iBMtrx)*Pi/1.800D+02
            End If
*
* AOM: trying to correct torsion...
            If (tpc(iBVct).eq.8) Then
              n0 = Int((rInt(iBMtrx)-rInt0(iBMtrx))/(Two*Pi))
              If (Abs(rInt(IBMtrx)-rInt0(iBMtrx)-Dble(n0)*Two*Pi) .gt.
     &           Abs(rInt(IBMtrx)-rInt0(iBMtrx)-Dble(n0+1)*Two*Pi)) Then
                n0=n0+1
              Else If (Abs(rInt(IBMtrx)-rInt0(iBMtrx)-Dble(n0)*Two*Pi)
     &                 .gt.
     &           Abs(rInt(IBMtrx)-rInt0(iBMtrx)-Dble(n0-1)*Two*Pi)) Then
                n0=n0-1
              Endif
              rInt(iBMtrx)=rInt(iBMtrx)-Dble(n0)*Two*Pi
            Endif
*                                                                      *
************************************************************************
*                                                                      *
         Else
*                                                                      *
************************************************************************
*                                                                      *
*
*-----------A linear combination of vectors
*
            call dcopy_(3*nAtom,[Zero],0,BMtrx(1,iBMtrx),1)
            call dcopy_((3*nAtom)**2,[Zero],0,dBMtrx(1,1,iBMtrx),1)
            iFrst = 1
            Sgn=One
*
*-----------Process the rest of the line and possible extension lines
*
 22         Continue
*
*            ***********************************************************
*            *                                                         *
*------------> Get the factor
               Call NxtWrd(Line,iFrst,iEnd)
               Temp=Line(iFrst:iEnd)
               Read (Temp,Format) Fact
               Fact = Fact * Sgn
               iFrst = iEnd + 1
*------------> Get the label
               Call NxtWrd(Line,iFrst,iEnd)
               If (Line(iEnd:iEnd).eq.'=') iEnd=iEnd-1
               iBVct = 0
               Do jBVct = 1, nBVct
                  If (Line(iFrst:iEnd).eq.Labels(jBVct))
     &               iBVct=jBVct
               End Do
               If (iBVct.eq.0) Then
                  Call WarningMessage(2,'Error in DefInt2')
                  Write (Lu,*) ' Linear combinations of vectors'
                  Write (Lu,*) ' Undefined internal coordinate'
                  Write (Lu,'(A,A)') Line
                  Write (Lu,'(A,A)') Line(iFrst:iEnd)
                  Call Quit_OnUserError()
               End If
*
               Call DaXpY_(3*nAtom,Fact,BVct(1,iBvct),1,
     &                                 BMtrx(1,iBMtrx),1)
               Call DaXpY_((3*nAtom)**2,Fact,dBVct(1,1,iBvct),1,
     &                                      dBMtrx(1,1,iBMtrx),1)
               rInt(iBMtrx) = rInt(iBMtrx)+ Fact * Value(iBVct)
*            *                                                         *
*            ***********************************************************
*
               iFrst = iEnd + 1
 25            Continue
               Temp=Line(iFrst:nTemp)
               nEq   = Index(Temp,'=')
               nPlus = Index(Temp,'+')
               nMinus= Index(Temp,'-')
*
            If (nEq.ne.0 .and.
     &          (nEq.lt.nMinus.eqv.nMinus.gt.0) .and.
     &          (nEq.lt.nPlus .eqv.nPlus .gt.0)) Then
               If (Index(Line,'&').ne.0) Then
                  Call WarningMessage(2,'Error in DefInt2')
                  Write (Lu,*) 'This line should not be extended'
                  Write (Lu,'(A)') Line
                  Call Quit_OnUserError()
               End If
               iFrst = iFrst + nEq + 1
               Call NxtWrd(Line,iFrst,iEnd)
               Temp=Line(iFrst:iEnd)
*
               If (Index(Temp,'FIX').ne.0) Then
*
*                 Pick up values from the runfile. Written there on
*                 the first iteration.
*
                  If (.Not.rInt0_in_memory) Then
                     rInt0_in_memory=.TRUE.
                     Call mma_allocate(r0,nrInt0,Label='r0')
                     If (rInt0_on_file) Then
                        Call Get_dArray('rInt0',r0,nrInt0)
                     Else
                        r0(:)=Zero
                     End If
                  End If
*
                  If (rInt0_on_file) Then
                     rInt0(iBMtrx)=r0(iBMtrx)
                  Else
                     r0(iBmtrx)=rInt(iBMtrx)
                  End If
*
               Else
*
*                 Read value from input file.
*
                  Read (Temp,Format) rInt0(iBMtrx)
                  Temp = Line
                  Call UpCase(Temp)
                  If (Index(Temp,'ANGSTROM').ne.0) rInt0(iBMtrx) =
     &                                          rInt0(iBMtrx)/angstr
                  If (Index(Temp,'DEGREE').ne.0) rInt0(iBMtrx) =
     &                                        rInt0(iBMtrx)*Pi/1.800D+02
               End If
               Go To 24
            End If
*
            If (nPlus.ne.0.and.(nPlus.lt.nMinus.eqv.nMinus.gt.0)) Then
               Sgn=One
               iFrst = iFrst + nPlus
               Go To 22
            End If
*
            If (nMinus.ne.0.and.(nMinus.lt.nPlus.eqv.nPlus.gt.0)) Then
               Sgn=-One
               iFrst = iFrst + nMinus
               Go To 22
            End If
*
*---------- Here if all statements processed of this line
*
            If (Index(Line,'&').ne.0) Then
               jLines=jLines+1
               If (jLines.gt.nLines) Then
                  Call WarningMessage(2,'Error in DefInt2')
                  Write(Lu,*)'DefInt2: jLines.gt.nLines'
                  Call Quit_OnUserError()
               End If
               Read (Lu_UDC,'(A)') Line
               iFrst = 1
               Call NxtWrd(Line,iFrst,iEnd)
               If (Line(iFrst:iEnd).eq.'+') Then
                  iFrst = iEnd + 1
                  Sgn=One
                  Go To 22
               Else If (Line(iFrst:iEnd).eq.'-') Then
                  iFrst = iEnd + 1
                  Sgn=-One
                  Go To 22
               Else If (Line(iFrst:iEnd).eq.'=') Then
                  iFrst = 1
                  Go To 25
               Else
                  Call WarningMessage(2,'Error in DefInt2')
                  Write (Lu,*) ' Syntax Error: first character in '
     &                      //' extension line is not + or -'
                  Write (Lu,'(A)') Line
                  Write (Lu,'(3A)') '-->',Line(iFrst:iEnd),'<--'
                  Call Quit_OnUserError()
               End If
            End If
*
*---------- At the end of this line
*
 24         Continue
*                                                                      *
************************************************************************
*                                                                      *
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Go To 201
*
 200  Continue
      If (iPrint.ge.99) Then
         Call RecPrt(' The B-matrix',' ',BMtrx,3*nAtom,mInt)
         Do iInt = 1, mInt
            Call RecPrt(' The dB-matrix',' ',dBMtrx(1,1,iInt),3*nAtom,
     &                                                        3*nAtom)
         End Do
      End If
      Close(Lu_UDC)
      Call mma_deallocate(tpc)
      If (rint0_in_memory) Then
         If (InSlapaf) Call Put_dArray('rInt0',r0,mInt)
         Call mma_deallocate(r0)
      End If
*
*     Compute the maximum error in the constraints
*
      MaxErr = Zero
      Do iInt = 1, mInt
         MaxErr = Max(MaxErr, Abs(rInt(iInt)-rInt0(iInt)))
      End Do
      Call Put_dScalar('Max error',MaxErr)
*
      If (iPrint.ge.99 .or. lWrite) Then
         Write (Lu,*)
         Write (Lu,*)
         Write (Lu,*) '*******************************************'
         Write (Lu,*) '* Values of the constraints   / au or rad *'
         Write (Lu,*) '*******************************************'
         Write (Lu,*) '  Label        C         C0'
         Write (Lu,'(1X,A,2X,F10.6,F10.6)')
     &         (Lbl(iInt),rInt(iInt),rInt0(iInt),iInt=1,mInt)
         Write (Lu,*)
         Call CollapseOutput(0,'Constraints section')
         Write (Lu,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Labels)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Roland Lindh                                     *
************************************************************************
      Subroutine SetUp_Kriging(nRaw,nInter,qInt,Grad,Energy,
     &                         Hessian_HMF)
      Use kriging_mod, only: blavAI, set_l, layer_U
      Implicit None
#include "stdalloc.fh"
#include "real.fh"
      Integer nRaw, nInter,i,iInter,jInter,ij
      Real*8 qInt(nInter,nRaw), Grad(nInter,nRaw), Energy(nRaw),
     &       Hessian_HMF(nInter,nInter)
      Real*8 Value_l
      Real*8, Allocatable:: Array_l(:), HTri(:), Hessian(:,:),
     &                      qInt_s(:,:), Grad_s(:,:)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(layer_U,nInter,nInter,Label='layer_U')
*
      layer_U(:,:)=Zero
      Do i=1,nInter
         layer_U(i,i)=One
      End Do
*
      Call mma_allocate(Hessian,nInter,nInter,Label='Hessian')
      Call mma_allocate(HTri,nInter*(nInter+1)/2,Label='HTri')
*
      Do iInter = 1, nInter
         Do jInter = 1, iInter
            ij = iInter*(iInter-1)/2 + jInter
            HTri(ij)=Hessian_HMF(iInter,jInter)
         End Do
      End Do
*     Call TriPrt('HTri(raw)',' ',HTri,nInter)
      Call NIDiag_new(HTri,layer_U,nInter,nInter)
*     layer_U(:,:)=Zero
*     Do i=1,nInter
*        layer_U(i,i)=One
*     End Do
*     Call TriPrt('HTri',' ',HTri,nInter)
      Hessian(:,:) = Zero
      Do i=1,nInter
         Hessian(i,i)=HTri(i*(i+1)/2)
      End Do
*
      Call mma_deallocate(HTri)
*                                                                      *
************************************************************************
*                                                                      *
*     Select between setting all ls to a single value or go in
*     multiple l-value mode in which the l-value is set such that
*     the kriging hessian reproduce the diagonal value of the HMF
*     Hessian of the current structure.
*
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('Setup_kriging: Energy',' ',Energy,1,nRaw)
      Call RecPrt('Setup_kriging: qInt',' ',qInt,nInter,nRaw)
      Call RecPrt('Setup_kriging: Grad',' ',Grad,nInter,nRaw)
#endif
      Call mma_Allocate(Array_l,nInter,Label='Array_l')
      If (Set_l) Then
         Call Get_dScalar('Value_l',Value_l)
         Array_l(:)=Value_l
      Else
         Call Set_l_Array(Array_l,nInter,blavAI,Hessian)
      End If
      Call mma_deallocate(Hessian)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_Allocate(qInt_s,nInter,nRaw,Label="qInt_s")
      Call mma_Allocate(Grad_s,nInter,nRaw,Label="Grad_s")
*
*     Transform to the basis which diagonalizes the HMF Hessian.
*
      Call Trans_K(qInt,qInt_s,nInter,nRaw)
      Call Trans_K(Grad,Grad_s,nInter,nRaw)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Call RecPrt('Setup_kriging: qInt_s',' ',qInt_s,nInter,nRaw)
      Call RecPrt('Setup_kriging: Grad_s',' ',Grad_s,nInter,nRaw)
#endif
      Call Start_Kriging(nRaw,nInter,qInt_s,Grad_s,Energy)
*
      Call mma_deAllocate(qInt_s)
      Call mma_deAllocate(Grad_s)
*                                                                      *
************************************************************************
*                                                                      *
*     Pass the l-values to the GEK routine. This will initiate the
*     computation of the covariance matrix, and solve related GEK
*     equations.
*
      Call Set_l_Kriging(Array_l,nInter)
      Call mma_deAllocate(Array_l)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End Subroutine Setup_Kriging

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Roland Lindh                                     *
!***********************************************************************

subroutine Set_binom()
!***********************************************************************
!                                                                      *
!     Object: to set up a table of binomial coefficients.              *
!                                                                      *
!     Author: Roland Lindh                                             *
!             Dept of Chem. Phys.                                      *
!             Univ. of Lund, Sweden                                    *
!             February 1999                                            *
!***********************************************************************

use define_af, only: Binom, iTabMx
use Constants, only: Zero, One
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, n

binom(:,:) = Zero
binom(0,0) = One

! Do recurrence according to Pascal's triangle!

do n=1,2*iTabMx
  do i=0,n
    binom(n,i) = binom(n-1,i-1)+binom(n-1,i)
  end do
end do

end subroutine Set_binom

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine span0_cvb(nvecmx1,n)

use casvb_global, only: nvecmx, nvtot, span
use stdalloc, only: mma_allocate, mma_maxDBLE
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nvecmx1, n
integer(kind=iwp) :: mavailr
integer(kind=iwp), parameter :: nmult = 5

call mma_maxDBLE(mavailr)
nvecmx = min(nmult*nvecmx1,mavailr/n)
if (nvecmx <= 0) then
  write(u6,*) ' Not enough vectors in SPAN0_CVB!',nvecmx
  write(u6,*) ' Remaining memory :',mavailr
  write(u6,*) ' Max number of vectors :',nvecmx1
  call abend_cvb()
end if
call mma_allocate(span,n,nvecmx,label='span')
nvtot = 0

return

end subroutine span0_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine addintab(wrk,wrksize,syma,symb,abmap)
! this routine adds contributions to open INTAB1 file,
! comming from ab syma,symb

use ccsort_global, only: lunab, lunda1, mapd3, mapi3, mbas, NORB, NSYM, nvb, pos30, reclen
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, syma, symb, abmap(mbas,mbas,8)
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
integer(kind=iwp) :: a, b, bup, ii, irec0, length, pos, pos3, rc, symab, symp, symq

! def symab
symab = mul(syma,symb)

! make mapd3,mapi3 for <_a_b|pq>

! set mapi3=0 (partly)

mapi3(1:nsym,1:nsym,1:nsym) = 0

! def 0-th row

mapd3(0,1) = 5
mapd3(0,2) = 5
mapd3(0,3) = 0
mapd3(0,4) = 0
mapd3(0,5) = nsym
mapd3(0,6) = 0

! def other rows

pos = pos30
do ii=1,nsym

  symp = ii
  symq = mul(symab,symp)
  length = norb(symp)*norb(symq)
  mapd3(ii,1) = pos
  mapd3(ii,2) = length
  mapd3(ii,3) = symp
  mapd3(ii,4) = symq
  mapd3(ii,5) = 1
  mapd3(ii,6) = 1
  mapi3(symp,1,1) = ii
  pos = pos+length

end do

! write mapd,mapi to INTAB
call dawrtmap(lunab,mapd3,mapi3,rc)

!T if there are no _a_b,pq integrals in this symab, skip summation over ab

if ((mapd3(nsym,1)+mapd3(nsym,2)) == pos30) return

! loop over a,b

do a=1,nvb(syma)

  if (syma == symb) then
    bup = a
  else
    bup = nvb(symb)
  end if

  do b=1,bup

    ! loop over symp

    do symp=1,nsym

      ! def irec0 for this a,b,symp in TEMPDA1
      irec0 = abmap(a,b,symp)

      ! def corresponding position and length in #3
      ii = mapi3(symp,1,1)
      pos3 = mapd3(ii,1)
      length = mapd3(ii,2)

      ! read this block to #3
      if (length > 0) call daread(lunda1,irec0,wrk(pos3),length,reclen)

    end do

    ! since there must be some integrals, write them to TEMPAB

    call deflength(mapd3,length)
    call dawri(lunab,length,wrk(pos30))

  end do
end do

return

end subroutine addintab

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE ISO_C_UTILITIES
   USE ISO_C_BINDING ! Intrinsic module

   CHARACTER(KIND=C_CHAR), DIMENSION(1), SAVE, TARGET, PRIVATE :: dummy_string="?"

CONTAINS

   FUNCTION C_F_STRING(CPTR) RESULT(FPTR)
      ! Convert a null-terminated C string into a Fortran character array pointer
      TYPE(C_PTR), INTENT(IN) :: CPTR ! The C address
      CHARACTER(KIND=C_CHAR), DIMENSION(:), POINTER :: FPTR

      INTERFACE ! strlen is a standard C function from <string.h>
         ! int strlen(char *string)
         FUNCTION strlen(string) RESULT(len) BIND(C,NAME="strlen")
            USE ISO_C_BINDING
            TYPE(C_PTR), VALUE :: string ! A C pointer
            INTEGER(KIND=C_INT) :: len
         END FUNCTION
      END INTERFACE

      IF (C_ASSOCIATED(CPTR)) THEN
         CALL C_F_POINTER(FPTR=FPTR, CPTR=CPTR, SHAPE=[strlen(CPTR)])
      ELSE
         ! To avoid segfaults, associate FPTR with a dummy target:
         FPTR=>dummy_string
      END IF

   END FUNCTION

END MODULE

MODULE DLFCN
   USE ISO_C_BINDING
   USE ISO_C_UTILITIES
   IMPLICIT NONE
   PRIVATE

   PUBLIC :: DLOpen, DLSym, DLClose, DLError, DLAddr ! DL API

   ! Valid modes for mode in DLOpen:
   INTEGER, PARAMETER, PUBLIC :: RTLD_LAZY=1, RTLD_NOW=2, RTLD_GLOBAL=256, RTLD_LOCAL=0
      ! Obtained from the output of the previously listed C program

   ! Struct for DLAddr
   TYPE, BIND(C), PUBLIC :: DL_info
      TYPE(C_PTR) :: dli_fname
      TYPE(C_FUNPTR) :: dli_fbase
      TYPE(C_PTR) :: dli_sname
      TYPE(C_FUNPTR) :: dli_saddr
   END TYPE DL_info

   INTERFACE ! All we need is interfaces for the prototypes in <dlfcn.h>
      FUNCTION DLOpen(file,mode) RESULT(handle) BIND(C,NAME="dlopen")
         ! void *dlopen(const char *file, int mode);
         USE ISO_C_BINDING
         CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: file
            ! C strings should be declared as character arrays
         INTEGER(C_INT), VALUE :: mode
         TYPE(C_PTR) :: handle
      END FUNCTION
      FUNCTION DLSym(handle,name) RESULT(funptr) BIND(C,NAME="dlsym")
         ! void *dlsym(void *handle, const char *name);
         USE ISO_C_BINDING
         TYPE(C_PTR), VALUE :: handle
         CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: name
         TYPE(C_FUNPTR) :: funptr ! A function pointer
      END FUNCTION
      FUNCTION DLClose(handle) RESULT(status) BIND(C,NAME="dlclose")
         ! int dlclose(void *handle);
         USE ISO_C_BINDING
         TYPE(C_PTR), VALUE :: handle
         INTEGER(C_INT) :: status
      END FUNCTION
      FUNCTION DLError() RESULT(error) BIND(C,NAME="dlerror")
         ! char *dlerror(void);
         USE ISO_C_BINDING
         TYPE(C_PTR) :: error
      END FUNCTION
      ! dladdr is a Glibc extension, not POSIX
      FUNCTION DLAddr(funptr,info) RESULT(output) BIND(C,NAME="dladdr")
         ! int dladdr(void *addr, Dl_info *info)
         USE ISO_C_BINDING
         TYPE(C_FUNPTR), VALUE :: funptr ! A function pointer
         TYPE(C_PTR), VALUE :: info
         INTEGER(C_INT) :: output
      END FUNCTION
   END INTERFACE

END MODULE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!               2020,2021, Roland Lindh                                *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Cho_CGM_InfVec(InfVcT,NVT,n)

use Definitions, only: iwp

implicit none
integer(kind=iwp), pointer, intent(out) :: InfVcT(:,:,:)
integer(kind=iwp), intent(in) :: n
integer(kind=iwp), intent(out) :: NVT(n)

call Cho_X_GetIP_InfVec(InfVcT)
call Cho_X_GetTotV(NVT,n)

end subroutine Cho_CGM_InfVec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine init_motra
#include "motra_global.fh"
#include "files_motra.fh"
*----------------------------------------------------------------------*
*     Define  file names and unit numbers.                             *
*----------------------------------------------------------------------*
      FnInpOrb='INPORB'
      FnJobIph='JOBIPH'
      FnOneAO='ONEINT'
      FnTwoAO='ORDINT'
      FnOneMO='TRAONE'
      FnTwoMO='TRAINT'
      FnHalf='TEMP1'
      FnExt='EXTRACT'
      FnCom='COMFILE'
      Debug=0
      iPrint=0
      iOneOnly=0
      iVecTyp=2
      iAutoCut=0
      iRFpert=0
      LuInpOrb=10
      LuJobIph=15
      LuOneAO=20
      LuTwoAO=40
      LuOneMO=30
      LuTwoMO=50
      LuHalf=60
      LuExt=18
      LuCom=22
*----------------------------------------------------------------------*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DfH_Hvv1 (Hvv,Fvv,nv,dimbe,addbe)
c
c        this routine do:
c        Hvv(a,be') <- Fvv(a,be)
c
        implicit none
        integer dimbe,nv,addbe
        real*8 Hvv(1:nv,1:dimbe)
        real*8 Fvv(1:nv,1:nv)
c
c        help variables
        integer a,be,bev
c
        do be=1,dimbe
          bev=be+addbe
          do a=1,nv
            Hvv(a,be)=Fvv(a,bev)
          end do
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine extract_cvb(c,t,nvec1,nextract,mode,thr,s,nbf,metr)
c  MODE: 0,1 => determine NEXTRACT based on THR
c        1,3 => transform also T matrix
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension c(nbf,nvec1),t(nbf,nvec1),s(*)

      nvec=nvec1
      i1 = mstackr_cvb(nvec)
      i2 = mstackr_cvb(nbf*nvec)
      i3 = mstackr_cvb(nvec*nvec)
      i4 = mstackr_cvb(nbf*nvec)
      call svd_cvb(c,w(i1),w(i2),w(i3),nbf,nvec)

      if(mode.lt.2)then
c  Determine NEXTRACT :
        do 100 i=nvec,1,-1
        if(w(i+i1-1).le.thr)goto 200
100     continue
200     nextract=nvec-i
      endif
      call fmove_cvb(w(1+(nvec-nextract)*nbf+i2-1),c,nbf*nextract)
      if(mod(mode,2).eq.1)then
c  Apply same transformation to T :
        call mxatb_cvb(t,w(i3),nbf,nvec,nvec,w(i4))
        do 300 i=1,nvec
        call dscal_(nbf,1.d0/w(i+i1-1),w((i-1)*nbf+i4),1)
300     continue
        call fmove_cvb(w(1+(nvec-nextract)*nbf+i4-1),t,nbf*nextract)
        call schmidtt_cvb(c,nextract,t,nbf,s,nbf,metr)
      endif
      call mfreer_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Pavel Neogrady                                   *
!***********************************************************************

subroutine extstack(wrk,wrksize,a,b,bb,dimb)
! This routine does:
! A(ij) <- B(ij,_bb) for given bb
!
! A special routine used only in sumoverab for stacking case.
!
! Yet it is assumed that blocks in A and B are in the same order.
! To je pomerne odflaknuty predpoklad, a moze to byt bugous

use ccsd_global, only: Map_Type
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, bb, dimb
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: a, b
integer(kind=iwp) :: dimij, ii, posa, posb

do ii=1,a%d(0,5)
  dimij = a%d(ii,2)
  posa = a%d(ii,1)
  posb = b%d(ii,1)
  call extstackhlp1(wrk(posa),wrk(posb),dimij,dimb,bb)
end do

return

end subroutine extstack

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 11, 2022, created this file.               *
!*****************************************************************

! Subroutine relating to generalized 1-e density matrix (GD) called
! in CMSNewton
!     GD^KL_tu = sum_{MN}{U^KM * U^LN * GD^MN_tu}
subroutine RotGD(GD,R,nGD,lRoots,NAC2)

use CMS, only: RGD
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nGD, lRoots, NAC2
real(kind=wp), intent(inout) :: GD(nGD)
real(kind=wp), intent(in) :: R(lRoots**2)
integer(kind=iwp) :: iLoc, iNAC2, lRoots2

lRoots2 = lRoots**2

!write(u6,*) 'rotation matrix in RotGD'
!call RecPrt(' ',' ',R,lRoots,lRoots)

!write(u6,*) 'GD matrix after rotation'
!call RecPrt(' ',' ',GD,lRoots2,NAC2)

do iNAC2=1,NAC2
  iLoc = (iNAC2-1)*lRoots2+1
  call DGEMM_('T','N',lRoots,lRoots,lRoots,One,R,lRoots,GD(iLoc),lRoots,Zero,RGD,lRoots)
  call DGEMM_('N','N',lRoots,lRoots,lRoots,One,RGD,lRoots,R,lRoots,Zero,GD(iLoc),lRoots)
end do

!write(u6,*) 'GD matrix after rotation'
!call RecPrt(' ',' ',GD,lRoots2,NAC2)

return

end subroutine RotGD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Par Soderhjelm                                   *
!***********************************************************************

subroutine XFMoment(lMax,Cavxyz,Tmom,nCavxyz_,Org)
!***********************************************************************
!                                                                      *
!     Object:  Calculate total moment of XF multipoles, add to Cavxyz  *
!                                                                      *
!     Authors: P. Soderhjelm                                           *
!              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
!                                                                      *
!              November 2004                                           *
!***********************************************************************

use Index_Functions, only: nTri3_Elem1
use External_Centers, only: nOrd_XF, nXF, XF
use Phase_Info, only: iPhase
use Symmetry_Info, only: nIrrep
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lmax, nCavxyz_
real(kind=wp), intent(inout) :: Cavxyz(nCavxyz_)
real(kind=wp), intent(out) :: Tmom(nCavxyz_), Org(3)
integer(kind=iwp) :: i, iChAtm, iChxyz, iDum, iStb(0:7), j, jCoSet(0:7,0:7), nInp, nStb
real(kind=wp) :: A(3), Tco(3)

if (nOrd_XF < 0) return
if (nOrd_XF > lMax) then
  call WarningMessage(2,'nOrd_XF > lMax')
  call Abend()
end if
nInp = nTri3_Elem1(nOrd_XF)
Org(:) = Zero
do i=1,nXF

  ! Generate Stabilizer of C

  ! IFG: "A" was undefined, is this the right point?
  A(1:3) = XF(1:3,i)
  iChxyz = iChAtm(A)
  iDum = 0
  call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)
  do j=0,nIrrep/nStb-1
    Tmom(:) = Zero
    Tmom(1:nInp) = XF(4:3+nInp,i)
    TCo(1:3) = XF(1:3,i)
    Tco(1) = Tco(1)*real(iPhase(1,jCoSet(j,0)),kind=wp)
    Tco(2) = Tco(2)*real(iPhase(2,jCoSet(j,0)),kind=wp)
    Tco(3) = Tco(3)*real(iPhase(3,jCoSet(j,0)),kind=wp)
    if (nOrd_XF > 0) then
      Tmom(2) = Tmom(2)*real(iPhase(1,jCoSet(j,0)),kind=wp)   !Dx
      Tmom(3) = Tmom(3)*real(iPhase(2,jCoSet(j,0)),kind=wp)   !Dy
      Tmom(4) = Tmom(4)*real(iPhase(3,jCoSet(j,0)),kind=wp)   !Dz
      if (nOrd_XF > 1) then
        Tmom(6) = Tmom(6)*real(iPhase(1,jCoSet(j,0))*iPhase(2,jCoSet(j,0)),kind=wp) !Qxy
        Tmom(7) = Tmom(7)*real(iPhase(1,jCoSet(j,0))*iPhase(3,jCoSet(j,0)),kind=wp) !Qxz
        Tmom(9) = Tmom(9)*real(iPhase(2,jCoSet(j,0))*iPhase(3,jCoSet(j,0)),kind=wp) !Qyz
      end if
    end if
    call ReExpand(Tmom,1,nCavxyz_,Tco,Org,1,lMax)
    Cavxyz(:) = Cavxyz(:)+Tmom(:)
  end do
end do

end subroutine XFMoment

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine free2all_cvb(vecfrom,vecto,nvec)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension vecfrom(nfr,nvec),vecto(npr,nvec)

      do 100 ivec=1,nvec
      if(.not.orbfr_is_unit)then
        call mxatb_cvb(w(ls(14)),vecfrom(1,ivec),
     >    nprorb,nfrorb,1,vecto(1,ivec))
      else
        if(nprorb.gt.0) call fmove_cvb(vecfrom(1,ivec),
     >    vecto(1,ivec),nprorb)
      endif
      if(nprvb.gt.0) call fmove_cvb(vecfrom(nfrorb+1,ivec),
     >  vecto(nprorb+1,ivec),nprvb)
100   continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1992,1995, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine RFGrd(
#define _CALLING_
#include "grd_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: to compute the multipole moments integrals with the          *
*         Gauss-Hermite quadrature.                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Modified to multipole moments November '90               *
*                                                                      *
*             Roland Lindh, Dept. of Theoratical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified to reaction field calculations July '92         *
*             Modified to gradient calculations May '95                *
************************************************************************
      use Her_RW
      use PCM_arrays, only: MM
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "rctfld.fh"

#include "grd_interface.fh"

*     Local variables
      Logical ABeq(3)
*
      iRout = 122
      iPrint = nPrint(iRout)
*     iPrint = 99
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+2)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+2)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp+1)
      ipRnxyz = nip
      nip = nip + nZeta*3*(la+2)*(lb+2)*(nOrdOp+1)
      ipTemp1 = nip
      nip = nip + nZeta
      ipTemp2 = nip
      nip = nip + nZeta
      ipTemp3 = nip
      nip = nip + 3*nZeta*nHer
      ipAlph = nip
      nip = nip + nZeta
      ipBeta = nip
      nip = nip + nZeta
      If (nip-1.gt.nArr*nZeta) Then
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Call ErrTra
         Write (6,*) ' Abend in RFGrd'
         Call Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In RFGrd: A',' ',A,1,3)
         Call RecPrt(' In RFGrd: RB',' ',RB,1,3)
         Call RecPrt(' In RFGrd: CCoor',' ',CCoor,1,3)
         Call RecPrt(' In RFGrd: P',' ',P,nZeta,3)
         Write (6,*) ' In RFGrd: la,lb=',la,lb
         Write (6,*) ' In RFGrd: nHer=',nHer
      End If
*
*     Compute the cartesian values of the basis functions angular part
*
      Do 10 iZeta = 1, nZeta
         Array(ipTemp1-1+iZeta) = Zeta(iZeta)**(-Half)
 10   Continue
*
      Call vCrtCmp(Array(ipTemp1),P,nZeta,A,Array(ipAxyz),
     &               la+1,HerR(iHerR(nHer)),nHer,ABeq)
      Call vCrtCmp(Array(ipTemp1),P,nZeta,RB,Array(ipBxyz),
     &               lb+1,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the contribution from the multipole moment operator
*
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call vCrtCmp(Array(ipTemp1),P,nZeta,Ccoor,Array(ipRxyz),
     &            nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the cartesian components for the multipole moment
*     integrals. The integrals are factorized into components.
*
       Call vAssmbl(Array(ipRnxyz),
     &              Array(ipAxyz),la+1,
     &              Array(ipRxyz),nOrdOp,
     &              Array(ipBxyz),lb+1,
     &              nZeta,HerW(iHerW(nHer)),nHer,Array(ipTemp3))
*
*     Combine the cartesian components to the full one electron
*     integral.
*
      ip = ipAlph
      Do iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ip),1)
         ip = ip + nAlpha
      End Do
      ip = ipBeta
      Do iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ip),nAlpha)
         ip = ip + 1
      End Do
      nCav=(nOrdOp+1)*(nOrdOp+2)*(nOrdOp+3)/6
      Call CmbnRF1(Array(ipRnxyz),nZeta,la,lb,nOrdOp,Zeta,rKappa,Final,
     &             nComp,Array(ipTemp1),Array(ipTemp2),
     &             Array(ipAlph),Array(ipBeta),Grad,nGrad,DAO,
     &             IfGrad,IndGrd,dc(mdc)%nStab,dc(ndc)%nStab,
     &             kOp,MM(1,2))
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iStabM)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine saamphlp3
     & (t1aa,t1bb,t2abab,noa,nob,nva,nvb,noas,nvbs,key)
c
c     this routine rearrange amplitudes to be spin adapted
c     for T1 amplitudes for given si(=sa)
c
c     t1aa - T1aa amplitudes for given si (=sa) (I/O)
c     t1bb - T1bb amplitudes for given si (=sa) (I/O)
c     t2abab - T2(arsi)abab amplitudes sa=si (sr=ss=irrep of S) (I/O)
c     noa  - number of alpha occupied in symi (I)
c     nob  - number of beta occupied in symi (I)
c     nva  - number of alpha virtuals in symi (I)
c     nvb  - number of beta virtuals in symi (I)
c     noas - number of alpha occupied in symmetry, where S orbitals is (I)
c     nvbs - number of beta virtuals in symmetry, where S orbitals is (I)
c     key  - 0 - no adaptation (I)
c     1 - T2 DDVV adaptation
c     2 - T2 DDVV + T1 DV adaptation
c     3 - full T1 and T2 adaptation (only for doublets)
c     4 - full T2 without SDVS (only for doublets)
c
       integer noa,nob,nva,nvb,nvbs,noas
cT1
       real*8 t1aa(1:nva,1:noa)
       real*8 t1bb(1:nvb,1:nob)
cT2
       real*8 t2abab(1:nva,1:nvbs,1:noas,1:nob)
c
       integer key
c
c     help variables
c
       integer nd,nv,ns
       integer i,a
       real*8 t1,t2
c
       if (key.eq.0) return
c
       nd=nob
       ns=noa-nob
       nv=nva
c
c     T1 adaption
c
c     ta=t1oaa(i,a)     DV
c     tb=t1obb(i,a)     DV
c     tc=t2o2b(p,i,a,p) SDVS
c
c     direct :
c     t1= (ta+tb)/2
c     t2= (-ta+tb+2tc)/6
c
c     reverse :
c     ta= t1-t2
c     tb= t1+t2
c     tc= 2t2
c
       if (key.eq.3) then
c
       do 10 i=1,nd
       do 11 a=1,nv
c
       t1=(t1aa(a,i)+t1bb(a+ns,i))/2.0d0
       t2=(t1bb(a+ns,i)-t1aa(a,i)+2.0d0*t2abab(a,1,noas,i))/6.0d0
c
       t1aa(a,i)=t1-t2
       t1bb(a+ns,i)=t1+t2
       t2abab(a,1,noas,i)=2.0d0*t2
c
 11     continue
 10     continue
c
       else if (key.eq.2) then
c
       do 40 i=1,nd
       do 41 a=1,nv
c
       t1=(t1aa(a,i)+t1bb(a+ns,i))/2.0d0
c
       t1aa(a,i)=t1
       t1bb(a+ns,i)=t1
c
 41     continue
 40     continue
c
c     else if (key.eq.1) then
c     no adaption in T1 turn on
       end if
c
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Localize_LoProp_Drv(Ttot,Ttot_Inv,nBas,iCenter,iType,nBas1,nBas2,nSym,nBasMax,P,Restart)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nBas1, iCenter(nBas1), iType(nBas1), nBas2, nBasMax
real(kind=wp), intent(out) :: Ttot(nBas1,nBas1), Ttot_Inv(nBas1,nBas1)
real(kind=wp), intent(in) :: P(*)
logical(kind=iwp), intent(in) :: Restart
integer(kind=iwp) :: idum(1), iOffs, iOfft, iOpt0, iOpt1, iRc, iSyLbl, iSym, nElem, nInts, nInts_tot, nScr
character(len=8) :: Label
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: irestart(:)
real(kind=wp), allocatable :: all_ints(:), S(:), Scr(:), SSym(:), Tmp(:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Get the overlap matrix

iOpt1 = 1
iOpt0 = 0
Label = 'Mltpl  0'
iRc = -1
iSyLbl = 1
if (Restart) then
  call Qpg_iArray('LoProp nInts',Found,nElem)
  call mma_allocate(irestart,nElem,label='irestart')
  call Get_iArray('LoProp nInts',irestart,nElem)
  nInts = irestart(1)-4
  call mma_allocate(SSym,nInts+4,label='Tmp')
  call Qpg_dArray('LoProp Integrals',Found,nInts_tot)
  if (.not. Found) then
    write(u6,*) 'LoProp Integrals not available on the RunFile.'
    call Abend()
  end if
  call mma_allocate(all_ints,nInts_Tot,label='all_ints')
  call Get_dArray('LoProp Integrals',all_ints,nInts_tot)
  SSym(1:nInts+4) = all_ints(1:nInts+4)
  call Get_iArray('LoProp iSyLbl',irestart,nElem)
  iSyLbl = irestart(1)
  call mma_deallocate(all_ints)
  call mma_deallocate(irestart)
else
  call iRdOne(iRc,iOpt1,Label,1,idum,iSyLbl)
  if (iRc /= 0) then
    write(u6,*) 'Polar: error reading length of mu!'
    write(u6,*) 'Mu=',0
    call Abend()
  end if
  nInts = idum(1)
  call mma_allocate(SSym,nInts+4,label='Tmp')
  call RdOne(iRc,iOpt0,Label,1,SSym,iSyLbl)
  if (iRc /= 0) then
    write(u6,*) 'Polar: error reading mu!'
    write(u6,*) 'Mu=',0
    call Abend()
  end if
end if
#ifdef _DEBUGPRINT_
call RecPrt('SSym',' ',SSym,1,nInts)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(Tmp,nBas2,label='SMatrix')

iOfft = 1
iOffs = 1
do iSym=1,nSym
  if (nBas(iSym) == 0) cycle

  ! Now I square the overlap matrix because it has been stored as a
  ! lower triangle

  call Square(SSym(iOfft),Tmp(iOffs),1,nBas(iSym),nBas(iSym))

  iOfft = iOfft+nBas(iSym)*(nBas(iSym)+1)/2
  iOffs = iOffs+nBas(iSym)**2
end do
call mma_deallocate(SSym)

if (nSym == 1) then
  call move_alloc(Tmp,S)
else

  ! Desymmetrize

  call mma_allocate(S,nBas1**2)
  nScr = nBasMax*nBas1
  call mma_allocate(Scr,nScr,label='Scr')
  S(:) = Zero
  call Desymmetrize(Tmp,nBas2,Scr,nScr,S,nBas,nBas1,P,nSym,iSyLbl)
  call mma_deallocate(Scr)
  call mma_deallocate(Tmp)

end if
#ifdef _DEBUGPRINT_
call RecPrt('Overlap matrix',' ',S,nBas1,nBas1)
#endif

! Localize

call Localize_LoProp(Ttot,Ttot_Inv,nBas1,S,iCenter,iType)
#ifdef _DEBUGPRINT_
call RecPrt('Ttot',' ',Ttot,nBas1,nBas1)
call RecPrt('Ttot_Inv',' ',Ttot_Inv,nBas1,nBas1)
call xSpot('Exit Localize_LoProp_Drv')
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(S)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Localize_LoProp_Drv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module UnixInfo

use Definitions, only: wp, iwp

implicit none
private

real(kind=wp) :: Heuer(4) = -huge(Heuer)
integer(kind=iwp), protected :: hour, isdst, mday, mins, mon, pid, ppid, sec, wday, yday, year
character(len=256), protected :: HomeDir, MolcasDir, ProgName, RealName, Shell, SuperName, UserName
character(len=*), parameter :: Month(12) = ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'], &
                               Weekday(7) = ['Mon','Tue','Wed','Thu','Fri','Sat','Sun']

public :: Heuer, HomeDir, hour, init_UnixInfo, isdst, mday, mins, MolcasDir, mon, Month, pid, ppid, ProgName, RealName, sec, &
          Shell, SuperName, UserName, wday, Weekday, yday, year

contains

subroutine init_UnixInfo(SuperModuleName,ModuleName)

  character(len=*), intent(in) :: SuperModuleName, ModuleName
  integer(kind=iwp) :: Ich, Islash, LenProgName
  integer(kind=iwp), external :: StrnLn
  logical(kind=iwp) :: IfTest = .false.
  interface
    subroutine UnixInfoC(pid,ppid,sec,min_,hour,mday,mon,year,wday,yday,isdst,username,realname,homedir,shell,molcasdir) &
               bind(C,name='unixinfoc_')
      use, intrinsic :: iso_c_binding, only: c_char
      use Definitions, only: MOLCAS_C_INT
      integer(kind=MOLCAS_C_INT) :: pid, ppid, sec, min_, hour, mday, mon, year, wday, yday, isdst
      character(kind=c_char) :: username(*), realname(*), homedir(*), shell(*), molcasdir(*)
    end subroutine UnixInfoC
  end interface

# ifdef _DEBUGPRINT_
  IfTest = .true.
# endif

  ProgName = ModuleName
  SuperName = SuperModuleName
  UserName = ' '
  RealName = ' '
  HomeDir = ' '
  Shell = ' '
  MolcasDir = ' '
# ifndef _DEMO_
  call UnixInfoC(pid,ppid,sec,mins,hour,mday,mon,year,wday,yday,isdst,UserName,RealName,HomeDir,Shell,MolcasDir)
# endif

  ! Clear ProgName of directory part:
  LenProgName = StrnLn(ProgName)
  Islash = 0
  do Ich=LenProgName,1,-1
    if (ProgName(Ich:Ich) == '/') then
      Islash = Ich
      exit
    end if
  end do
  do Ich=1,LenProgName
    if (Ich <= LenProgName-Islash) then
      ProgName(Ich:Ich) = ProgName(Ich+Islash:Ich+Islash)
    else
      ProgName(Ich:Ich) = ' '
    end if
  end do

  mon = mon+1
  year = year+1900
  if (wday == 0) wday = 7
  yday = yday+1
  if (IfTest) call PrtUnixInfo()

  return

end subroutine init_UnixInfo

subroutine PrtUnixInfo()

  use Definitions, only: u6

  character(len=35) :: prt

  prt = adjustr(ProgName(1:35))
  write(u6,'(2A)')       ' Program name      :',prt
  write(u6,'(A,I35)')    ' Process ID        :',pid
  write(u6,'(A,I35)')    ' Parent process ID :',ppid
  write(u6,'(A,I35)')    ' Seconds           :',sec
  write(u6,'(A,I35)')    ' Minutes           :',mins
  write(u6,'(A,I35)')    ' Hours             :',hour
  write(u6,'(A,I35)')    ' Day of month      :',mday
  write(u6,'(A,I29,3A)') ' Month             :',mon,' (',Month(mon),')'
  write(u6,'(A,I35)')    ' Year              :',year
  write(u6,'(A,I29,3A)') ' Day of week       :',wday,' (',Weekday(wday),')'
  write(u6,'(A,I35)')    ' Day of year       :',yday
  write(u6,'(A,I35)')    ' Daylight saving ? :',isdst

  return

  end subroutine PrtUnixInfo

end module UnixInfo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_shell_pairs

use fmm_global_paras, only: INTK, REALK, LUPRI, fmm_sh_pairs, fmm_basis, Zero, One, Half
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_get_shell_pairs, fmm_free_shell_pairs

type(fmm_sh_pairs), allocatable, target :: sh_pairs(:)

contains

!-------------------------------------------------------------------------------

subroutine fmm_get_shell_pairs(basis,sh_pairs_ptr)

  type(fmm_basis), intent(in) :: basis
  type(fmm_sh_pairs), pointer :: sh_pairs_ptr(:)
  integer(INTK) :: n_pairs

  if (allocated(sh_pairs)) then
    sh_pairs_ptr => sh_pairs
  else
    ! make list of non-vanishing shell pairs
    call fmm_make_shell_pairs(basis,n_pairs)  ! first get n_pairs
    allocate(sh_pairs(n_pairs))
    call fmm_make_shell_pairs(basis,n_pairs)  ! now store list
    sh_pairs_ptr => sh_pairs
    !FIXME add to fmm_stats
    write(LUPRI,*) 'Number of shell pairs =',size(sh_pairs)
  end if

end subroutine fmm_get_shell_pairs

!-------------------------------------------------------------------------------

subroutine fmm_free_shell_pairs()

  implicit none

  if (allocated(sh_pairs)) deallocate(sh_pairs)

end subroutine fmm_free_shell_pairs

!-------------------------------------------------------------------------------

function fmm_extent(ExpPI)

  !use fmm_md4_globals, only: fmm_shell_pair_ThrFac, fmm_X0
  !use fmm_md4_globals, only: fmm_grain_inv, fmm_extent_min
  !use fmm_box_utils, only: fmm_branch

  implicit none

  real(REALK), intent(in) :: ExpPI

  real(REALK), parameter :: root3 = sqrt(3.0_REALK)
  !real(REALK)   :: tmp1, tmp2
  real(REALK) :: fmm_extent
  !integer(INTK) :: bra_min

  !real(REALK), parameter :: erfc_inv = 3.4589_REALK  ! 1e-6
  !real(REALK), parameter :: erfc_inv = 4.0522_REALK  ! 1e-8
  !real(REALK), parameter :: erfc_inv = 4.5728_REALK  ! 1e-10
  !real(REALK), parameter :: erfc_inv = 5.6739_REALK  ! 1e-15

  !fmm_extent = fmm_X0*ExpPI

  ! Extent based on Classical overlap
  !tmp1 = sqrt(ExpPI)*erfc_inv

  ! Artificial extent to keep all near-field exact integrals
  !bra_min = fmm_branch(fmm_extent_min,fmm_grain_inv)
  !tmp2 = half*root3*(bra_min+1)/fmm_grain_inv

  !tmp2 = zero
  !fmm_extent = max(tmp1,tmp2)

  fmm_extent = sqrt(ExpPI*log(1.0e10_REALK))

end function fmm_extent

!-------------------------------------------------------------------------------

subroutine fmm_make_shell_pairs(basis,n_pairs)

  !use fmm_md4_globals, only: fmm_shell_pair_ThrFac

  implicit none

  type(fmm_basis), intent(in) :: basis
  integer(INTK), intent(out)  :: n_pairs

  !real(REALK), parameter :: ThrFac = fmm_shell_pair_ThrFac
  real(REALK), parameter :: ThrFac = 1.0e-12_REALK

  integer(INTK) :: II, JJ, I, J
  integer(INTK) :: IPrim1, JPrim1
  integer(INTK) :: IPrim2, JPrim2, IJPrim, JPTemp2
  real(REALK) :: Acentr(3), Bcentr(3), ABcentr(3), P(3), PM(3), RAB(3)
  real(REALK) :: ExpA, ExpB, ExpP, ExpPI, ExpAR2
  real(REALK) :: R2AB, ExpKAB, tmp_ext, extent

  n_pairs = 0

  Ishel: do II=1,basis%nshells

    Acentr(:) = basis%Centr(:,basis%KAtom(II))
    IPrim1 = basis%KStart(II)
    IPrim2 = IPrim1+basis%KontG(II)-1

    Jshel: do JJ=1,II

      Bcentr(:) = basis%Centr(:,basis%KAtom(JJ))
      JPrim1 = basis%KStart(JJ)
      JPrim2 = JPrim1+basis%KontG(JJ)-1

      ABcentr(:) = Half*(Acentr(:)+Bcentr(:))
      RAB(:) = Acentr(:)-Bcentr(:)
      R2AB = dot_product(RAB,RAB)

      extent = zero
      IJPrim = 0
      do I=IPrim1,IPrim2
        ExpA = basis%Expnt(I)
        ExpAR2 = ExpA*R2AB
        JPTemp2 = JPrim2
        if (II == JJ) JPTemp2 = I
        do J=JPrim1,JPTemp2
          ExpB = basis%Expnt(J)
          ExpP = ExpA+ExpB
          ExpPI = One/ExpP
          ExpKAB = -ExpAR2*ExpB*ExpPI
          if (ExpKAB >= ThrFac) then
            IJPrim = IJPrim+1
            P(:) = (ExpA*Acentr(:)+ExpB*Bcentr(:))*ExpPI
            PM(:) = P(:)-ABcentr(:)
            tmp_ext = fmm_extent(ExpPI)
            tmp_ext = tmp_ext+sqrt(dot_product(PM,PM))
            extent = max(extent,tmp_ext)
          end if
        end do
      end do

      if (IJPrim > 0) then
        n_pairs = n_pairs+1
        if (allocated(sh_pairs)) then
          if (n_pairs > size(sh_pairs)) call fmm_quit('get_sh_pairs')
          sh_pairs(n_pairs)%I = II
          sh_pairs(n_pairs)%J = JJ
          sh_pairs(n_pairs)%extent = extent
          sh_pairs(n_pairs)%centre(:) = ABcentr(:)
        end if
      end if

    end do Jshel

  end do Ishel

end subroutine fmm_make_shell_pairs

!-------------------------------------------------------------------------------

end module fmm_shell_pairs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine initired
      implicit real*8 (a-h,o-z)
cbs   initialize all information for ireducible representations
cbs   later on, it might be useful to have a switch for
cbs    changing to other orders of IREDs like e.g. in TURBOMOLE
c
c
c   HOW2ADD another symmetry:
c
c   1. add it in readbas.f to be accepted. Add the number of IRs
c
c   2. copy one of the symmetry-blocks in this subroutine and
c      edit the multiplication-table for the group
c
c   3. assign the right IRs to L_X, L_Y and L_Z
c
c   that is  all. Good luck!!!
c
#include "para.fh"
#include "ired.fh"
      character*3 symmetry
      symmetry='D2H'  ! MOLCAS-Version
      if (symmetry.eq.'D2H') then
      mult(2,1)=2
      mult(3,1)=3
      mult(4,1)=4
      mult(5,1)=5
      mult(6,1)=6
      mult(7,1)=7
      mult(8,1)=8
c
      mult(3,2)=4
      mult(4,2)=3
      mult(5,2)=6
      mult(6,2)=5
      mult(7,2)=8
      mult(8,2)=7
c
      mult(4,3)=2
      mult(5,3)=7
      mult(6,3)=8
      mult(7,3)=5
      mult(8,3)=6
c
      mult(5,4)=8
      mult(6,4)=7
      mult(7,4)=6
      mult(8,4)=5
c
      mult(6,5)=2
      mult(7,5)=3
      mult(8,5)=4
c
      mult(7,6)=4
      mult(8,6)=3
c
      mult(8,7)=2
c
C
      do ired=1,8
      mult(ired,ired)=1
      enddo
      do irun=2,8
      do jrun=1,irun-1
      mult(jrun,irun)=mult(irun,jrun)
      enddo
      enddo
CBS   write(6,*)
CBS   write(6,*)
CBS  *'multiplicitation table (atkins,child and phillips)'
CBS   write(6,*)
CBS   do ired=1,8
CBS   write(6,'(8I5)') (mult(jred,ired),jred=1,8)
CBS   write(6,*)
CBS   enddo

c
      IRLX=4
      IRLY=3
      IRLZ=2
cbs   assume same order of ireds as Atkins Child and Phillips use..
cbs   would lead to an order with 1 to 1, 2 to 2 ...
cbs   however, this is the molecule/ seward order.
      iredorder(1)=1
      iredorder(2)=4
      iredorder(3)=6
      iredorder(4)=7
      iredorder(5)=8
      iredorder(6)=5
      iredorder(7)=3
      iredorder(8)=2
      do ired=1,8
      iredorderinv(iredorder(ired))=ired
      enddo
      ipow2ired(0,0,0)=iredorder(1)
      ipow2ired(1,1,0)=iredorder(2)
      ipow2ired(1,0,1)=iredorder(3)
      ipow2ired(0,1,1)=iredorder(4)
      ipow2ired(1,1,1)=iredorder(5)
      ipow2ired(0,0,1)=iredorder(6)
      ipow2ired(0,1,0)=iredorder(7)
      ipow2ired(1,0,0)=iredorder(8)
c     write(6,*) 'interacting IRs '
      do ired=1,8
      IRwithLX(ired)=
     *iredorder(mult(IRLX,iredorderinv(ired)))
      IRwithLY(ired)=
     *iredorder(mult(IRLY,iredorderinv(ired)))
      IRwithLZ(ired)=
     *iredorder(mult(IRLZ,iredorderinv(ired)))
c     write(6,*) IRwithLX(ired),IRwithLY(ired),
c    *IRwithLZ(ired)
      enddo
      elseif(symmetry.eq.'C2V') then
cbs   1. A1 2. A2 3. B1 4. B2
      mult(2,1)=2
      mult(3,1)=3
      mult(4,1)=4
c
      mult(3,2)=4
      mult(4,2)=3
c
      mult(4,3)=2
C
      do ired=1,4
      mult(ired,ired)=1
      enddo
      do irun=2,4
      do jrun=1,irun-1
      mult(jrun,irun)=mult(irun,jrun)
      enddo
      enddo
      write(6,*)
      write(6,*)
     *'multiplicitation table '
      write(6,*)
      do ired=1,4
      write(6,'(4I5)') (mult(jred,ired),jred=1,4)
      write(6,*)
      enddo

c
      IRLX=4
      IRLY=3
      IRLZ=2
cbs   this is the molecule/ seward order.
      iredorder(1)=1
      iredorder(2)=4
      iredorder(3)=2
      iredorder(4)=3
      do ired=1,4
      iredorderinv(iredorder(ired))=ired
      enddo
      ipow2ired(0,0,0)=iredorder(1)
      ipow2ired(1,1,0)=iredorder(2)
      ipow2ired(1,0,1)=iredorder(3)
      ipow2ired(0,1,1)=iredorder(4)
      ipow2ired(1,1,1)=iredorder(2)
      ipow2ired(0,0,1)=iredorder(1)
      ipow2ired(0,1,0)=iredorder(4)
      ipow2ired(1,0,0)=iredorder(3)
c     write(6,*) 'interacting IRs '
      do ired=1,4
      IRwithLX(ired)=
     *iredorder(mult(IRLX,iredorderinv(ired)))
      IRwithLY(ired)=
     *iredorder(mult(IRLY,iredorderinv(ired)))
      IRwithLZ(ired)=
     *iredorder(mult(IRLZ,iredorderinv(ired)))
c     write(6,*) IRwithLX(ired),IRwithLY(ired),
c    *IRwithLZ(ired)
      enddo
      elseif(symmetry.eq.'D2 ') then
cbs   1. A1 2. B1 3. B2 4. B3
      mult(2,1)=2
      mult(3,1)=3
      mult(4,1)=4
c
      mult(3,2)=4
      mult(4,2)=3
      mult(4,3)=2
C
      do ired=1,4
      mult(ired,ired)=1
      enddo
      do irun=2,4
      do jrun=1,irun-1
      mult(jrun,irun)=mult(irun,jrun)
      enddo
      enddo
      write(6,*)
      write(6,*)
     *'multiplicitation table '
      write(6,*)
      do ired=1,4
      write(6,'(4I5)') (mult(jred,ired),jred=1,4)
      write(6,*)
      enddo

c
      IRLX=4
      IRLY=3
      IRLZ=2
      iredorder(1)=1
      iredorder(2)=2
      iredorder(3)=3
      iredorder(4)=4
      do ired=1,4
      iredorderinv(iredorder(ired))=ired
      enddo
      ipow2ired(0,0,0)=iredorder(1)
      ipow2ired(1,1,0)=iredorder(2)
      ipow2ired(1,0,1)=iredorder(3)
      ipow2ired(0,1,1)=iredorder(4)
      ipow2ired(1,1,1)=iredorder(1)
      ipow2ired(0,0,1)=iredorder(2)
      ipow2ired(0,1,0)=iredorder(3)
      ipow2ired(1,0,0)=iredorder(4)
c     write(6,*) 'interacting IRs '
      do ired=1,4
      IRwithLX(ired)=
     *iredorder(mult(IRLX,iredorderinv(ired)))
      IRwithLY(ired)=
     *iredorder(mult(IRLY,iredorderinv(ired)))
      IRwithLZ(ired)=
     *iredorder(mult(IRLZ,iredorderinv(ired)))
c     write(6,*) IRwithLX(ired),IRwithLY(ired),
c    *IRwithLZ(ired)
      enddo
      elseif(symmetry.eq.'C2H') then
cbs   assume 1.Ag 2.Au 3.Bg 4.Bu
      mult(2,1)=2
      mult(3,1)=3
      mult(4,1)=4
c
      mult(3,2)=4
      mult(4,2)=3
c
      mult(4,3)=2
C
      do ired=1,4
      mult(ired,ired)=1
      enddo
      do irun=2,4
      do jrun=1,irun-1
      mult(jrun,irun)=mult(irun,jrun)
      enddo
      enddo
      write(6,*)
      write(6,*)
     *'multiplicitation table '
      write(6,*)
      do ired=1,4
      write(6,'(4I5)') (mult(jred,ired),jred=1,4)
      write(6,*)
      enddo

c
      IRLX=3
      IRLY=3
      IRLZ=1
      iredorder(1)=1
      iredorder(2)=2
      iredorder(3)=3
      iredorder(4)=4
      do ired=1,4
      iredorderinv(iredorder(ired))=ired
      enddo
      ipow2ired(0,0,0)=iredorder(1)
      ipow2ired(1,1,0)=iredorder(1)
      ipow2ired(1,0,1)=iredorder(3)
      ipow2ired(0,1,1)=iredorder(3)
      ipow2ired(1,1,1)=iredorder(2)
      ipow2ired(0,0,1)=iredorder(2)
      ipow2ired(0,1,0)=iredorder(4)
      ipow2ired(1,0,0)=iredorder(4)
c     write(6,*) 'interacting IRs '
      do ired=1,4
      IRwithLX(ired)=
     *iredorder(mult(IRLX,iredorderinv(ired)))
      IRwithLY(ired)=
     *iredorder(mult(IRLY,iredorderinv(ired)))
      IRwithLZ(ired)=
     *iredorder(mult(IRLZ,iredorderinv(ired)))
c     write(6,*) IRwithLX(ired),IRwithLY(ired),
c    *IRwithLZ(ired)
      enddo
      elseif(symmetry.eq.'CS ') then
      write(6,*) 'CS in initired '
cbs   assume 1.A' 2.A'
      mult(2,1)=2
C
      do ired=1,2
      mult(ired,ired)=1
      enddo
      do irun=2,2
      do jrun=1,irun-1
      mult(jrun,irun)=mult(irun,jrun)
      enddo
      enddo
      write(6,*)
      write(6,*)
     *'multiplicitation table '
      write(6,*)
      do ired=1,2
      write(6,'(2I5)') (mult(jred,ired),jred=1,2)
      write(6,*)
      enddo

c
      IRLX=2
      IRLY=2
      IRLZ=1
      iredorder(1)=1
      iredorder(2)=2
      do ired=1,2
      iredorderinv(iredorder(ired))=ired
      enddo
      ipow2ired(0,0,0)=iredorder(1)
      ipow2ired(1,1,0)=iredorder(1)
      ipow2ired(1,0,1)=iredorder(2)
      ipow2ired(0,1,1)=iredorder(2)
      ipow2ired(1,1,1)=iredorder(2)
      ipow2ired(0,0,1)=iredorder(2)
      ipow2ired(0,1,0)=iredorder(1)
      ipow2ired(1,0,0)=iredorder(1)
c     write(6,*) 'interacting IRs '
      do ired=1,2
      IRwithLX(ired)=
     *iredorder(mult(IRLX,iredorderinv(ired)))
      IRwithLY(ired)=
     *iredorder(mult(IRLY,iredorderinv(ired)))
      IRwithLZ(ired)=
     *iredorder(mult(IRLZ,iredorderinv(ired)))
c     write(6,*) IRwithLX(ired),IRwithLY(ired),
c    *IRwithLZ(ired)
      enddo
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function E2(FockI,rMo,loper,idisp)

use Index_Functions, only: iTri
use MCLR_Data, only: G1t, G2t, ipCM, nA, nCMO, nNA
use input_mclr, only: nAsh, nIsh, nOrb, nSym, ntPert
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: E2
real(kind=wp), intent(in) :: FockI(nCMO), rMO(*)
integer(kind=iwp), intent(in) :: lOper, iDisp
integer(kind=iwp) :: i, iA, iAA, iAB, ij, ijkl, ipF, iS, j, jA, jAA, jAB, jS, k, l
logical(kind=iwp) :: Go

!                                                                      *
!***********************************************************************
!                                                                      *
E2 = Zero
if (loper == 0) then
  Go = (iDisp < 0)
  if (.not. Go) Go = btest(ntpert(idisp),2)
  if (Go) then
    do i=1,nna
      do j=1,nna
        ij = iTri(i,j)
        do k=1,nna
          do l=1,nna
            ijkl = iTri(ij,iTri(k,l))
            E2 = E2+Half*G2t(ijkl)*rmo(ijkl)
          end do
        end do
      end do
    end do
  end if
  do is=1,nSym
    do iA=1,nAsh(is)
      iAA = nA(iS)+ia
      iAB = ia+nIsh(iS)
      js = is
      do jA=1,nAsh(js)
        jAA = ja+nA(js)
        jAB = jA+nIsh(js)
        ipF = (iab-1)*norb(is)+jab+ipCM(is)-1
        E2 = E2+Focki(ipf)*G1t(iTri(iaa,jaa))
      end do
    end do
  end do
end if

!                                                                      *
!***********************************************************************
!                                                                      *

end function E2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine BasisReader(LuWr,nBase,
     &      iglobal,nxbas,xb_label,xb_bas,iErr)
      Implicit Integer (i-n)
      Implicit Real*8 (a-h,o-z)
      Character*48 Line, Blank
      Character*2  SimbA
#include "g_zmatconv.fh"
      Logical Found
        character *(*) xb_label(*)
        character *(*) xb_bas(*)
      character *48 TMP
      iErr = 0
      Blank = ' '
      nBase = 0
      icount=1

10    CONTINUE
C Read(iZMUnit,'(A)',Err=9904,End=9999) Line
      if(iglobal.eq.0) then
        Line=trim(xb_label(icount))//'.'//trim(xb_bas(icount))
      else
              Line='FF.'//trim(xb_bas(icount))
        nxbas=1
      endif
c      print *,'>>',Line
      Found = .False.
      SimbA = Line(1:2)
      If (SimbA(2:2).EQ.'.') SimbA(2:2)=' '
      Do i = 1, Num_Elem
        If ((SimbA(1:1).le.'z').and.(SimbA(1:1).ge.'a'))
     &       SimbA(1:1)=char(ichar(SimbA(1:1))-32)
        If ((SimbA(2:2).le.'Z').and.(SimbA(2:2).ge.'A'))
     &       SimbA(2:2)=char(ichar(SimbA(2:2))+32)

      If (SimbA.EQ.AdjustL(PTab(i)).and.iglobal.eq.0) then
          Base(i) = Line
          BasAva(i) = .True.
          Found = .True.
          nBase = nBase + 1
      EndIf
      If (iglobal.eq.1) then
          Base(i) = Line
          Base(i)(1:2) = AdjustL(PTab(i))
          if(Base(i)(2:2).eq.' ') then
            TMP=Base(i)(3:)
            Base(i)(2:)=TMP(1:47)
          endif
          BasAva(i) = .True.
          Found = .True.
          nBase = nBase + 1
      EndIf

      EndDo
      If (.NOT.Found) then
        iErr = 1
        Write(LuWr,*) ' [BasisReader]: Wrong symbol in line'
        Write(LuWr,*) '                ',Line
        GoTo 9999
      EndIf
      icount=icount+1
      if(icount.le.nxbas) GoTo 10


c9904  iErr = 1
c      Write(LuWr,*) ' [BasisReader]: Unable to read z-matrix !'
c      GoTo 9999
9999  continue
      Return
      End


      Subroutine BasisConsistency(LuWr,iErr)
      Implicit Integer (i-n)
      Implicit Real*8 (a-h,o-z)
#include "g_zmatconv.fh"

      iErr = 0
      Do i = 1, 100
        If (BasReq(i) .AND. .NOT.BasAva(i)) GoTo 9900
      EndDo
      Return

9900  iErr = 1
      Write(LuWr,*) ' [BasisConsistency]: Atom NA=',i,' requires BS'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gen1overR3(Lhigh,oneoverR3)
!bs generates the radial integrals  for the one electron spin orbit integrals
!bs taken the 1/r**3 formula from the documentation and included additional
!bs factors for normalization

use AMFI_global, only: df, exponents, MxprimL, nprimit, Lmax
use Constants, only: Two, Quart, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lhigh
real(kind=wp), intent(out) :: oneoverR3(MxprimL*(MxprimL+1)/2,Lmax)
integer(kind=iwp) :: icount, iprim1, iprim2, L
real(kind=wp) :: alpha1, alpha2

do L=1,Lhigh
  icount = 0
  do iprim2=1,nprimit(L)
    alpha2 = exponents(iprim2,L)
    do iprim1=1,iprim2
      alpha1 = exponents(iprim1,L)
      icount = icount+1
      oneoverR3(icount,L) = sqrt(Two/Pi)*(df(L+L-2)*real(2**(L+3),kind=wp)*(alpha1*alpha2)**(Quart*real(L+L+3,kind=wp)))/ &
                            ((alpha1+alpha2)**L*df(L+L+1))
    end do
  end do
end do

return

end subroutine gen1overR3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
Module ipPage
Integer, Parameter:: Max_CI_Vectors=40
Integer, Parameter:: On_Disk=0, In_Memory=1, Null_Vector=2
Integer, Parameter:: dWrite=0, Write=1, Read=2

!         ip_Mem : memory pointer
!         n  : Length of CI-vector
!         ida: disk address

Integer::      n(0:Max_CI_Vectors)
Integer::    ida(0:Max_CI_Vectors)
Integer:: Status(0:Max_CI_Vectors)

Integer:: n_CI_Vectors=0
Integer:: iDisk_Addr_End=0
Integer:: Lu_ip=-99
Logical:: DiskBased=.False.

Type Vector
  Real*8, Allocatable:: Vec(:)
End Type Vector

Type (Vector) :: W(0:Max_CI_Vectors)
End Module ipPage

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine INVMAT(A,B,NDIM,ISING)
! FIND INVERSE OF MATRIX A
! INPUT :
!        A : MATRIX TO BE INVERTED
!        B : SCRATCH ARRAY
!        NDIM : PHYSICAL DIMENSION OF MATRICES
!
! OUTPUT : A : INVERSE MATRIX (ORIGINAL MATRIX THUS DESTROYED)
! (WARNINGS ARE ISSUED IN CASE OF CONVERGENCE PROBLEMS)
!
! ISING = 0 => No convergence problems
!       = 1 => Convergence problems

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NDIM
real(kind=wp), intent(inout) :: A(NDIM,NDIM)
real(kind=wp), intent(out) :: B(NDIM,NDIM)
integer(kind=iwp), intent(out) :: ISING
integer(kind=iwp) :: ITEST
real(kind=wp) :: DETERM, EPSIL

ITEST = 0
if (NDIM == 1) then
  if (A(1,1) /= Zero) then
    A(1,1) = One/A(1,1)
  else
    ITEST = 1
  end if
else
  DETERM = Zero
  EPSIL = Zero
  call BNDINV(A,B,NDIM,DETERM,EPSIL,ITEST)
end if

if (ITEST /= 0) then
  write(u6,'(A,I3)') ' INVERSION PROBLEM NUMBER..',ITEST
  ISING = 1
else
  ISING = 0
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' INVERTED MATRIX'
call WRTMAT(A,NDIM,NDIM,NDIM,NDIM)
#endif

end subroutine INVMAT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine CmbnS1_mck(Rnxyz,nZeta,la,lb,Zeta,rKappa,
     &                  Final,Alpha,Beta,IfGrad,nOp)
************************************************************************
*                                                                      *
* Object: compute the gradient of the overlap matrix.                  *
*                                                                      *
*     Author: Roland Lindh,                                            *
*             Dept. of Theoretical Chemistry,                          *
*             University of Lund, SWEDEN                               *
*             October '91.                                             *
*             Anders Bernhardsson                                      *
*             Dept. of Theoretical Chemistry,                          *
*             University of Lund, SWEDEN                               *
*              95.                                                     *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
c#include "print.fh"
#include "real.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,1),
     &       Zeta(nZeta), rKappa(nZeta), Beta(nZeta),
     &       Rnxyz(nZeta,3,0:la+1,0:lb+1), Alpha(nZeta)
      Logical IfGrad(3,2)
      Integer  nOp(2)
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
c     iRout = 134
c     iPrint = nPrint(iRout)
*     Call GetMem(' Enter CmbnS1_mck','LIST','REAL',iDum,iDum)
*
*     ii = la*(la+1)*(la+2)/6
*     jj = lb*(lb+1)*(lb+2)/6
      iQ = 1
      exp32 = -Three/Two
      Do 25 iZeta = 1, nZeta
         rKappa(iZeta) = rKappa(iZeta) * Zeta(iZeta)**exp32
 25   Continue
c     If (iPrint.ge.99) Then
c     iQ = 1
c        Call RecPrt(' In CmbnS1_mck: Zeta  ',' ',Zeta  ,1,nZeta)
c        Call RecPrt(' In CmbnS1_mck: rKappa',' ',rKappa,1,nZeta)
c        Call RecPrt(' In CmbnS1_mck: Alpha ',' ',Alpha ,1,nZeta)
c        Call RecPrt(' In CmbnS1_mck: Beta  ',' ',Beta  ,1,nZeta)
c     End If
      Do 10 ixa = 0, la
         iyaMax=la-ixa
      Do 11 ixb = 0, lb
         iybMax=lb-ixb
         Do 20 iya = 0, iyaMax
            iza = la-ixa-iya
            ipa= Ind(la,ixa,iza)
         Do 21 iyb = 0, iybMax
            izb = lb-ixb-iyb
            ipb= Ind(lb,ixb,izb)
*
*           Combine overlap integrals
*
            tTwo = Two
*           write (*,*) ' papb=', papb
            If (IfGrad(1,1)) Then
               If (ixa.gt.0) Then
                  xa = Dble(-ixa)
                  Do 30 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &    (tTwo*Alpha(iZeta)*Rnxyz(iZeta,1,ixa+1,ixb) +
     &                    xa*Rnxyz(iZeta,1,ixa-1,ixb))*
     &                       Rnxyz(iZeta,2,iya,iyb)*
     &                       Rnxyz(iZeta,3,iza,izb)
 30               Continue
               Else
                  Do 31 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &     tTwo*Alpha(iZeta)*Rnxyz(iZeta,1,ixa+1,ixb)*
     &                       Rnxyz(iZeta,2,iya,iyb)*
     &                       Rnxyz(iZeta,3,iza,izb)
 31               Continue
               End If
            End If
            If (IfGrad(1,2)) Then
               If (ixb.gt.0) Then
                  xb = Dble(-ixb)
                  Do 35 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &     (tTwo*Beta(iZeta)*Rnxyz(iZeta,1,ixa,ixb+1) +
     &                    xb*Rnxyz(iZeta,1,ixa,ixb-1))*
     &                       Rnxyz(iZeta,2,iya,iyb)*
     &                       Rnxyz(iZeta,3,iza,izb)
 35               Continue
               Else
                  Do 36 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &      tTwo*Beta(iZeta)*Rnxyz(iZeta,1,ixa,ixb+1)*
     &                       Rnxyz(iZeta,2,iya,iyb)*
     &                       Rnxyz(iZeta,3,iza,izb)
 36               Continue
               End If
            End If
            If (IfGrad(2,1)) Then
               If (iya.gt.0) Then
                  ya = Dble(-iya)
                  Do 40 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &                       Rnxyz(iZeta,1,ixa,ixb)*
     &    (tTwo*Alpha(iZeta)*Rnxyz(iZeta,2,iya+1,iyb) +
     &                    ya*Rnxyz(iZeta,2,iya-1,iyb))*
     &                       Rnxyz(iZeta,3,iza,izb)
 40               Continue
               Else
                  Do 41 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &                       Rnxyz(iZeta,1,ixa,ixb)*
     &     tTwo*Alpha(iZeta)*Rnxyz(iZeta,2,iya+1,iyb)*
     &                       Rnxyz(iZeta,3,iza,izb)
 41               Continue
               End If
            End If
            If (IfGrad(2,2)) Then
               If (iyb.gt.0) Then
                  yb = Dble(-iyb)
                  Do 45 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &                       Rnxyz(iZeta,1,ixa,ixb)*
     &     (tTwo*Beta(iZeta)*Rnxyz(iZeta,2,iya,iyb+1) +
     &                    yb*Rnxyz(iZeta,2,iya,iyb-1))*
     &                       Rnxyz(iZeta,3,iza,izb)
 45               Continue
               Else
                  Do 46 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &                       Rnxyz(iZeta,1,ixa,ixb)*
     &      tTwo*Beta(iZeta)*Rnxyz(iZeta,2,iya,iyb+1)*
     &                       Rnxyz(iZeta,3,iza,izb)
 46               Continue
               End If
            End If
            If (IfGrad(3,1)) Then
               If (iza.gt.0) Then
                  za = Dble(-iza)
                  Do 50 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &                       Rnxyz(iZeta,1,ixa,ixb)*
     &                       Rnxyz(iZeta,2,iya,iyb)*
     &    (tTwo*Alpha(iZeta)*Rnxyz(iZeta,3,iza+1,izb) +
     &                    za*Rnxyz(iZeta,3,iza-1,izb))
 50               Continue
               Else
                  Do 51 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &                       Rnxyz(iZeta,1,ixa,ixb)*
     &                       Rnxyz(iZeta,2,iya,iyb)*
     &     tTwo*Alpha(iZeta)*Rnxyz(iZeta,3,iza+1,izb)
 51               Continue
               End If
            End If
            If (IfGrad(3,2)) Then
               If (izb.gt.0) Then
                  zb = Dble(-izb)
                  Do 55 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &                       Rnxyz(iZeta,1,ixa,ixb)*
     &                       Rnxyz(iZeta,2,iya,iyb)*
     &     (tTwo*Beta(iZeta)*Rnxyz(iZeta,3,iza,izb+1) +
     &                    zb*Rnxyz(iZeta,3,iza,izb-1))
 55               Continue
               Else
                  Do 56 iZeta = 1, nZeta
*                    Final(iZeta,ipa,ipb,1) = papb * rKappa(iZeta)*
                     Final(iZeta,ipa,ipb,1) = rKappa(iZeta)*
     &                       Rnxyz(iZeta,1,ixa,ixb)*
     &                       Rnxyz(iZeta,2,iya,iyb)*
     &      tTwo*Beta(iZeta)*Rnxyz(iZeta,3,iza,izb+1)
 56               Continue
               End If
            End If
*
 21      Continue
 20      Continue
 11   Continue
 10   Continue
*
*     Call GetMem(' Exit CmbnS1_mck','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(nOp)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_Alaska_RdInp(LuSpool)
***********************************************************
*
*     Purpose: Read and process input for Cholesky section
*              in alaska.
*
***********************************************************

      Implicit Real*8 (A-H,O-Z)
#include "exterm.fh"
      Character*180 KWord, Key, Get_Ln
      External Get_Ln
      character*16 SECNAM
      parameter (SECNAM = 'CHO_ALASKA_INPUT')
      Real*8 dmpK
      Integer nScreen
      Logical timings
      COMMON  /CHOTIME /timings
*
*     Set defaults
*
      dmpK = 1.0d0
      dmpK_default = dmpK
      nScreen = 10
*
      iPrint=5

*     Process the input
 1000 continue
      Key=Get_Ln(LuSpool)
      Kword=Key
      Call UpCase(Kword)
      If(KWord(1:1).eq.'*')    Go To 1000
      If(KWord(1:4).eq.'')  Go To 1000
      If(KWord(1:4).eq.'DMPK') Go To 100
      If(KWord(1:4).eq.'SCRN') Go To 110
      If(KWord(1:4).eq.'TIMI') Go To 120
      If(KWord(1:4).eq.'ENDC') Go To 998
      If(KWord(1:4).eq.'END ') Go To 998
      If(KWord(1:4).eq.'ENDO') Go To 998
*                                                             *
**** DMPK *****************************************************
*                                                             *
 100  Continue
      Read(LuSpool,*, err=210, end=200) dmpK
      If(dmpK .lt. 0.0d0) Then
         Write(6,*) 'OBS! Specified DMPK value is negative.'
         Write(6,*) 'Restoring Default!'
         dmpK = dmpK_default
      End If
      Go To 1000
*                                                             *
**** SCRN *****************************************************
*                                                             *
 110  Continue
      Read(LuSpool,*, err=210, end=200) nScreen
      Go To 1000
*                                                             *
**** TIMI *****************************************************
*                                                             *
 120  Continue
      Timings=.True.
      Go To 1000
*                                                             *
*** ENDChoinput ***********************************************
*                                                             *
 998  Continue
      Return
*                                                             *
***************************************************************
*                                                             *
      Call ErrTra
 200  Write(6,*) SECNAM, 'Premature end of input file.'
      Call Quit_onUserError()
      Call ErrTra
 210  Write(6,*) SECNAM, 'Error while reading input file.'
      Call Quit_onUserError()
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994-1996, Martin Schuetz                              *
!***********************************************************************
!***********************************************************************
! This Module comprises 8 subroutines and 5 functions, which are all   *
! used to store, recall and administrate vectors from e.g. subsequent  *
! iterations, which can be assigned to an ordered keylist, e.g. to a   *
! list of iteration numbers.                                           *
! The internal data structure used to control the vectors is a linked  *
! list of nodes, each containing a pointer to the memory or disk       *
! location of the vector, together with some other information.        *
! The head of the list is a special node called CNOD which contains    *
! the following info:                                                  *
!     CNOD:    addr(CNOD)   -> error code, if 0: op performed OK       *
!              addr(CNOD)+1 -> ptr to first NODE in list (iroot)       *
!              addr(CNOD)+2 -> actual length of list (lislen)          *
!              addr(CNOD)+3 -> # of vectors wished to keep in memory   *
!                              (incore)                                *
!              addr(CNOD)+4 -> unused yet                              *
!              addr(CNOD)+5 -> unused yet                              *
! One NODE of the linked list itself contains six integers and is      *
! organized as follows:                                                *
!     NODE:    addr(NODE)   -> ptr to next node                        *
!              addr(NODE)+1 -> ptr to stored vector                    *
!              addr(NODE)+2 -> next free position, if on disk          *
!                              unused otherwise                        *
!              addr(NODE)+3 -> length of vector                        *
!              addr(NODE)+4 -> iteration number                        *
!              addr(NODE)+5 -> 1, if in core; 0, if on disk            *
! The 11 subroutines and functions operating on the linked lists have  *
! the following purposes:                                              *
! IniLst(LList,incore)                                                 *
!  -> initialize list                                                  *
! PutVec(vec,lvec,iterat,opcode,LList)                                 *
!  -> store vector on list, ev. move the tailnode vector on disk       *
! GetVec(iterat,LList,inode,vec,lvec)                                  *
!  -> fetch vector from list, which corresponds to iterat              *
! GetNod(iterat,LList,inode)                                           *
!  -> does not read out vector, just returns address of node in inode  *
! InfNod(inode,iterat,ipnext,ipvec,lvec)                               *
!  -> returns info of node indicated by inode                          *
! Logical InCore_f(inode)                                              *
!  -> returns true, if corresponding vector is incore, false otherwise *
! Integer iVPtr(vptr1,nvtr1,inode)                                     *
!  -> uses InfNod or GetVec to read out vector of inode, depending     *
!     if InCore or not. If the result is ivptr1, the vector was read   *
!     from disk. ivptr1 has to be allocated before (same vector length *
!     as stored in inode).                                             *
! Integer LstPtr(iterat,LList)                                         *
!  -> uses GetNod and InfNod to get the pointer to the vector, which   *
!     corresponds to iterat. The pointer is the return value of the    *
!     function. If the vector is not InCore, the function terminates   *
!     with an Error message. This function is used only in cases,      *
!     where the vector for sure is stored in core (e.g. last entries   *
!     in LList).                                                       *
! Logical LLErr(LList)                                                 *
!  -> checks, if ErrCode was set in previous LL Operation              *
! Integer LLLen(LList)                                                 *
!  -> returns the actual length of the LL                              *
! KilLst(LList)                                                        *
!  -> kill list and free all memory                                    *
! DmpLst(LList,LUnit,lDskPt)                                           *
!  -> flush list and dump it on corresponding DA listfile              *
!     lDskPt: DA pointer where listnodes begin (on output)             *
! RclLst(LList,LUnit,lDskPt,NoAllo)                                    *
!  -> recall and restore list from corresponding DA listfile           *
!     lDskPt: DA pointer where listnodes begin  (on input)             *
!     NoAllo: amount of memory not to allocate...                      *
!----------------------------------------------------------------------*
!     written by:                                                      *
!     M. Schuetz                                                       *
!     University of Lund, Sweden, 1994/96                              *
!***********************************************************************
!----------------------------------------------------------------------*
!     Define linked lists for storage of vectors of subsequent iters   *
!----------------------------------------------------------------------*
!     LLGrad - linked list of gradients                                *
!     LLlGrd - linked list of local gradients                          *
!     LLdGrd - linked list of gradient diffs                           *
!     LLDelt - linked list of Delta vectors                            *
!     LLy    - linked list of y-vectors                                *
!     LLx    - linked list of x orbital rotation parameter vectors     *
!              (only for QNR/DIIS combination)                         *
!----------------------------------------------------------------------*

!#define _DEBUGPRINT_
module LnkLst

use InfSCF, only: MxIter
use Data_Structures, only: Alloc1DArray_Type
use stdalloc, only: mma_maxDBLE
use Definitions, only: wp, iwp, u6

implicit none
private

integer(kind=iwp), parameter :: MAXnodes = (MxIter+1)*6, NodSiz = 6

integer(kind=iwp) :: LLDelt, LLdGrd, LLGrad, LLlGrd, lLList = 0, LLx, LLy, nLList(MAXnodes,0:NodSiz-1)
logical(kind=iwp) :: Init_LLs = .false.
type(Alloc1DArray_Type) :: SCF_V(Maxnodes)

public :: DmpLst, GetNod, GetVec, IniLst, Init_LLs, iVPtr, KilLst, LLDelt, LLdGrd, LLGrad, LLLen, LLlGrd, lLList, LLx, LLy, &
          LstPtr, nLList, NodSiz, PutVec, RclLst, SCF_V, StlLst

contains

subroutine IniLst(iLList,incore)

  integer(kind=iwp), intent(out) :: iLList
  integer(kind=iwp), intent(in) :: incore

  ! allocate list header CNOD
  lLList = lLList+1
  iLList = lLList
  nLList(iLList,0) = 0
  nLList(iLList,1) = 0
  nLList(iLList,2) = 0
  nLList(iLList,3) = incore

# ifdef _DEBUGPRINT_
  write(u6,*) 'IniLst'
  call StlLst(iLList)
# endif

  return

end subroutine IniLst

subroutine PutVec(vec,lvec,iterat,opcode,iLList)
  ! NoAllo is the amount of memory (in DWords) one wants to keep
  ! for other purposes.
  ! opcode is a 4 character string:
  ! 'NOOP' -no operation, if same iterat is found on head node
  ! 'OVWR' -overwrite vector, if same iterat is found in any node
  !         If lvec is different from lvec stored on node, old
  !         vector is not overwritten and iWork(LList) is set to
  !         ErrCode 1

  use stdalloc, only: mma_allocate

  integer(kind=iwp), intent(in) :: lvec, iterat, iLList
  real(kind=wp), intent(in) :: vec(lvec)
  character(len=4), intent(in) :: opcode
  integer(kind=iwp) :: iPtr2, iroot, lislen, MaxMem

# ifdef _DEBUGPRINT_
  write(u6,*) 'PutVec',iterat
  call StlLst(iLList)
# endif

  ! clear ErrCode
  nLList(iLList,0) = 0
  ! read listhead
  iroot = nLList(iLList,1)
  lislen = nLList(iLList,2)

  select case (opcode)

    case ('NOOP')

      if (iroot > 0) then
        if (nLList(iroot,4) == iterat) return
      endif

    case ('OVWR')
      do while ((iroot > 0))
        if (nLList(iroot,3) /= lvec) then
          ! Set error code: inconsistency in vector lengths
          nLList(iLList,0) = 1
        else if (nLList(iroot,4) == iterat) then
          SCF_V(iroot)%A(1:lVec) = vec(:)
          return
        end if
        iroot = nLList(iroot,0)
      end do

    case default

      ! opcode unknown
      write(u6,*) 'PutVec: opcode unknown'
      write(u6,'(A,A)') 'opcode=',opcode
      call Abend()

  end select

  iroot = nLList(iLList,1)
  ! check if there is still enough memory to store vec
  call mma_maxDBLE(MaxMem)
  ! let's allocate some memory
  ! allocate new node
  lLList = lLList+1
  iPtr2 = lLList
  if (iPtr2 > Maxnodes) then
    write(u6,*) 'PutVec: iPtr2 > Maxnodes'
    call Abend()
  end if
  if (allocated(SCF_V(iPtr2)%A)) then
    write(u6,*) 'Node already allocated'
    write(u6,*) 'iPtr2=',iPtr2
    call Abend()
  end if
  call mma_allocate(SCF_V(iPtr2)%A,lVec,Label='LVec')
  nLList(iPtr2,0) = iroot
  nLList(iPtr2,1) = iPtr2
  nLList(iPtr2,2) = 0
  nLList(iPtr2,3) = lvec
  nLList(iPtr2,4) = iterat
  nLList(iPtr2,5) = 1

  SCF_V(iPtr2)%A(:) = Vec(:)
  iroot = iPtr2
  lislen = lislen+1
  nLList(iLList,1) = iroot
  nLList(iLList,2) = lislen

  return

end subroutine PutVec

subroutine GetVec(iterat,iLList,inode,vec,lvec)
  ! searches linked list for node corresponding to iterat, starting
  ! from iroot=iWork(LList+1).
  ! inode points to the node found after searching.
  ! the vector stored at inode then is copied to vec, but only
  ! if lvec is equal to the vector length stored in inode. Otherwise
  ! the entry is considered as inconsistent.
  ! inode is set to zero, if no entry was found, or to its negative
  ! address, if an inconsistent entry was found.
  ! if LList<0, then -LList is interpreted as a direct node address,
  ! and not the address of the listhead (faster access).

  integer(kind=iwp), intent(in) :: iterat, iLList, lvec
  integer(kind=iwp), intent(out) :: inode
  real(kind=wp), intent(out) :: vec(lvec)

  inode = nLList(iLList,1)
  if (inode <= 0) then
    write(u6,*) 'GetVec: iNode<=0'
    call Abend()
  end if

  do while ((nLList(inode,4) /= iterat) .and. (nLList(inode,0) /= 0))
    inode = nLList(inode,0)
  end do

  if (nLList(inode,4) == iterat) then
    ! we've found matching entry, so check if consistent
    if (nLList(inode,3) == lvec) then
      ! everything's alright, we made it, let's copy to vec
      vec(:) = SCF_V(iNode)%A(1:lVec)
    else
      ! inconsistency
      write(u6,*) ' Found inconsistency.'
      !inode = -inode
      inode = 0
    end if
  else
    inode = 0
  end if

end subroutine GetVec

subroutine GetNod(iterat,iLList,inode)
  ! searches linked list for node corresponding to iterat, starting
  ! from iroot. inode points to the node found after searching.
  ! inode is set to zero and iWork(LList)=0 is set to ErrCode 1,
  ! if no correspondance was found.

  integer(kind=iwp), intent(in) :: iterat, iLList
  integer(kind=iwp), intent(out) :: inode

# ifdef _DEBUGPRINT_
  write(u6,*) 'GetNod',iterat
  call StlLst(iLList)
# endif

  ! clear ErrCode
  nLList(iLList,0) = 0
  ! set inode to iroot
  inode = nLList(iLList,1)
  if (inode <= 0) then
    write(u6,*) 'GetNod: iNode<=0'
    write(u6,*) 'iLList=',iLList
    call Abend()
  end if

  do while ((nLList(inode,4) /= iterat) .and. (nLList(inode,0) /= 0))
    inode = nLList(inode,0)
  end do
  if (nLList(inode,4) == iterat) then
    ! we've found matching entry
  else
    write(u6,*) 'GetNod: Warning!'
    inode = 0
    nLList(iLList,0) = 1
  end if

end subroutine GetNod

subroutine InfNod(inode,iterat,ipnext,ipvec,lvec)
  ! returns info of node indicated by inode. iterat,ipnext,ipvec,lvec
  ! are overwritten with the corresponding info on the node

  integer(kind=iwp), intent(in) :: inode
  integer(kind=iwp), intent(out) :: iterat, ipnext, ipvec, lvec

  iterat = nLList(inode,4)
  ipnext = nLList(inode,0)
  ipvec = nLList(inode,1)
  lvec = nLList(inode,3)

  return

end subroutine InfNod

function InCore_f(inode)
  ! returns true, if corresponding vector is incore, false otherwise

  logical(kind=iwp) :: InCore_f
  integer(kind=iwp), intent(in) :: inode

  if (nLList(inode,5) == 1) then
    InCore_f = .true.
  else
    InCore_f = .false.
  end if

  return

end function InCore_f

function LLErr(iLList)
  ! checks, if ErrCode was set in previous LL Operation

  logical(kind=iwp) :: LLErr
  integer(kind=iwp), intent(in) :: iLList

  if (nLList(iLList,0) == 0) then
    LLErr = .false.
  else
    LLErr = .true.
  end if

  return

end function LLErr

function LLLen(iLList)
  ! returns the actual length of the LL

  integer(kind=iwp) :: LLLen
  integer(kind=iwp), intent(in) :: iLList

  LLLen = nLList(iLList,2)

  return

end function LLLen

subroutine iVPtr(vptr1,nvptr1,inode)
  ! uses InfNod or GetVec to read out vector of inode, depending
  ! if InCore or not. If the result is ivptr1, the vector was read
  ! from disk. ivptr1 has to be allocated before (same vector length
  ! as stored in inode). The return value points to the memory
  ! location of the read vector. If the function fails (in GetVec),
  ! the inode value of GetVec is returned.
  !
  ! 2017-03-15:Converted to return the array in vptr1.

  integer(kind=iwp), intent(in) :: nvptr1, inode
  real(kind=wp), intent(out) :: vptr1(nvptr1)
  integer(kind=iwp) :: idum1, idum2, idum3, ivptr2

  if (InCore_f(inode)) then
    call InfNod(inode,idum1,idum2,ivptr2,idum3)
    vPtr1(:) = SCF_V(inode)%A(1:nvptr1)
  else
    call GetVec(nLList(inode,4),inode,idum1,vptr1,nLList(inode,3))
  end if

  return

end subroutine iVPtr

function LstPtr(iterat,iLList)
  ! uses GetNod and InfNod to obtain the pointer to the vector, which
  ! corresponds to iterat. The pointer is the return value of the
  ! function. If the vector is not InCore, the function terminates
  ! with an Error message. This function is used only in cases,
  ! where the vector for sure is stored in core (e.g. last entries
  ! in LList).

  integer(kind=iwp) :: LstPtr
  integer(kind=iwp), intent(in) :: iterat, iLList
  integer(kind=iwp) :: idum1, idum2, idum3, inode, ivptr

  LstPtr = -999999
  call GetNod(iterat,iLList,inode)
  if (inode == 0) then
    ! Hmmm, no entry found in LList, that's strange
    write(u6,*) 'LstPtr: inode <= 0'
    write(u6,*) 'inode=',inode
    call Abend()
  else if (InCore_f(inode)) then
    call InfNod(inode,idum1,idum2,ivptr,idum3)
    LstPtr = ivptr
  else
    ! Hmmm, no incore hit for this entry, that's strange
    write(u6,*) 'LstPtr: no incore hit for this entry'
    write(u6,*) 'inode=',inode
    call Abend()
  end if

end function LstPtr

subroutine KilLst(iLList)
  ! Free all memory of linked list LList

  use stdalloc, only: mma_deallocate

  integer(kind=iwp), intent(in) :: iLList
  integer(kind=iwp) :: iFlag, iroot

# ifdef _DEBUGPRINT_
  write(u6,*) 'KilLst'
  call StlLst(iLList)
# endif

  iroot = nLList(iLList,1)
  do while (iroot /= 0)
    iFlag = nLList(iroot,5)

    if (iFlag == 1) call mma_deallocate(SCF_V(iroot)%A)
    iroot = nLList(iroot,0)
  end do

end subroutine KilLst

subroutine DmpLst(iLList,LUnit,lDskPt)

  use stdalloc, only: mma_deallocate

  integer(kind=iwp), intent(in) :: iLList, LUnit
  integer(kind=iwp), intent(out) :: lDskPt
  integer(kind=iwp) :: iDskPt, iPtr1, iPtr2, iRoot, Length

  ! clear ErrCode
  nLList(iLList,0) = 0
  ! read listhead
  iroot = nLList(iLList,1)

  if (iroot <= 0) then
    ! linked list has zero length, that's strange
    ! save in any case listhead...
    lDskPt = 0
    iDskPt = lDskPt
    call iDaFile(LUnit,1,nLList(iLList,0),NodSiz,iDskPt)
    return
  end if

  do while (nLList(iroot,5) == 1)
    iPtr1 = iroot
    iPtr2 = iPtr1
    ! go either to last element or list or to last element in core
    ! and flush vector
    do while ((nLList(iPtr1,0) /= 0) .and. (nLList(iPtr1,5) == 1))
      iPtr2 = iPtr1
      iPtr1 = nLList(iPtr1,0)
    end do
    if (nLList(iPtr1,5) == 1) then
      ! nothing written on disk yet
      iDskPt = 0
      iPtr2 = iPtr1
      iPtr1 = nLList(iPtr1,1)
    else
      iDskPt = nLList(iPtr1,2)
      iPtr1 = nLList(iPtr2,1)
    end if
    ! now set up node again and write vec to disk
    nLList(iPtr2,1) = iDskPt
    nLList(iPtr2,5) = 0
    Length = nLList(iPtr2,3)

    call dDaFile(LUnit,1,SCF_V(iPtr2)%A,Length,iDskPt)
    call mma_deallocate(SCF_V(iPtr2)%A)
  end do
  lDskPt = iDskPt
  ! now all vectors are flushed... so dump linked list...
  call iDaFile(LUnit,1,nLList(iLList,0),NodSiz,iDskPt)

  do while (iroot /= 0)
    iPtr1 = iroot
    iroot = nLList(iroot,0)
    call iDaFile(LUnit,1,nLList(iPtr1,0),NodSiz,iDskPt)
  end do

end subroutine DmpLst

subroutine RclLst(iLList,LUnit,lDskPt,NoAllo)

  use stdalloc, only: mma_allocate

  integer(kind=iwp), intent(out) :: iLList
  integer(kind=iwp), intent(in) :: LUnit, NoAllo
  integer(kind=iwp), intent(inout) :: lDskPt
  integer(kind=iwp) :: incore, iPtr1, iPtr2, iRoot, lislen, lVec, MaxMem

  ! load listhead...
  lLList = lLList+1
  iLList = lLList

  call iDaFile(LUnit,2,nLList(iLList,0),NodSiz,lDskPt)
  iroot = nLList(iLList,1)

  if (iroot <= 0) then
    write(u6,*) 'RclLst: linked list has zero length, that''s strange!'
    ! linked list has zero length, that's strange
    !call Quit(20)
    return
  end if

  ! restore linked list...
  lislen = 1
  lLList = lLList+1
  iPtr1 = lLList

  nLList(iLList,1) = iPtr1
  call iDaFile(LUnit,2,nLList(iPtr1,0),NodSiz,lDskPt)

  iroot = iPtr1
  iPtr2 = iroot
  do while (nLList(iPtr2,0) /= 0)
    lislen = lislen+1
    lLList = lLList+1
    iPtr1 = lLList
    nLList(iPtr2,0) = iPtr1

    call iDaFile(LUnit,2,nLList(iPtr1,0),NodSiz,lDskPt)
    iPtr2 = iPtr1
  end do
  if (nLList(iLList,2) /= lislen) then
    write(u6,*) 'RclLst:LList length mismatch:',nLList(iLList,2),lislen
    call Abend()
  end if
  write(u6,*) 'Let''s restore...'
  ! now we have restored the list, let's fetch some vectors
  incore = nLList(iLList,3)
  call mma_maxDBLE(MaxMem)
  lvec = nLList(iroot,3)
  iPtr2 = iroot
  do while ((incore > 0) .and. (MaxMem-NoAllo >= lvec) .and. (iPtr2 > 0))
    lDskPt = nLList(iPtr2,1)

    if (iPtr2 > Maxnodes) then
      write(u6,*) 'iPtr2 > Maxnodes, restoring'
      call Abend()
    end if
    if (allocated(SCF_V(iPtr2)%A)) then
      write(u6,*) 'Node already allocated while restoring'
      write(u6,*) 'iPtr2=',iPtr2
      call Abend()
    end if
    call mma_Allocate(SCF_V(iPtr2)%A,lvec,Label='LVec')
    call dDaFile(LUnit,2,SCF_V(iPtr2)%A,lvec,lDskPt)
    nLList(iPtr2,1) = iPtr2
    nLList(iPtr2,2) = 0
    nLList(iPtr2,5) = 1
    iPtr2 = nLList(iPtr2,0)
    incore = incore-1

    call mma_maxDBLE(MaxMem)
  end do
  if (iPtr2 > 0) nLList(iLList,3) = nLList(iLList,3)-incore

end subroutine RclLst

subroutine StlLst(LLink)

  integer(kind=iwp), intent(in) :: LLink
  integer(kind=iwp) :: iRoot

  write(u6,*)
  write(u6,*) '*********** Status of Linked List *************'
  write(u6,*)
  write(u6,*) ' LLink:',LLink
  write(u6,*)
  write(u6,*) ' CNOD data'
  write(u6,*) 'Error code:                       ',nLList(LLink,0)
  write(u6,*) 'Pointer to first NODE in the list:',nLList(LLink,1)
  write(u6,*) 'Actual length of list:            ',nLList(LLink,2)
  write(u6,*) '# of vectors in core:             ',nLList(LLink,3)
  write(u6,*)
  iRoot = nLList(LLink,1)
  do while (iRoot /= 0)
    write(u6,*) ' NODE data'
    write(u6,*) 'NODE @:                         ',iRoot
    write(u6,*) 'Pointer to next NODE:           ',nLList(iRoot,0)
    write(u6,*) 'Pointer to stored vector:       ',nLList(iRoot,1)
    if (nLList(iRoot,5) >= 1) then
      write(u6,*) 'Vector status:                  in Core'
    else
      write(u6,*) 'Vector status:                  on Disk'
    end if
    write(u6,*) 'Next free position:             ',nLList(iRoot,2)
    write(u6,*) 'Length of vector:               ',nLList(iRoot,3)
    write(u6,*) 'Iteration number:               ',nLList(iRoot,4)
    write(u6,*)
    iRoot = nLList(iRoot,0)
  end do
  write(u6,*) '************ End of Status Report *************'
  write(u6,*)

end subroutine StlLst

end module LnkLst

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2007, Roland Lindh                                *
************************************************************************
      SubRoutine PGet0(iCmp,iBas,jBas,kBas,lBas,
     &                 Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                 n1,n2,n3,n4,MemPSO,Mem2,nMem2,
     &                 iShell_A,iShell_B,iShell_C,iShell_D,nQuad,PMax)
************************************************************************
*                                                                      *
* Object: to act as a shell towards the manipulations of generating or *
*         accessing the 2nd order density matrix.                      *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January '92.                                             *
*                                                                      *
*             Modified for RI Feb. 2007                                *
************************************************************************
      use aces_stuff
      use pso_stuff
      use Index_arrays, only: iSO2Sh
      use Sizes_of_Seward, only: S
      use RICD_Info, only: Do_RI
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Basis_Mode_Parameters.fh"
#include "Basis_Mode.fh"
#include "print.fh"
#include "real.fh"
#include "setup.fh"
#include "etwas.fh"
#include "columbus_gamma.fh"
      Real*8 PSO(ijkl,nPSO), Mem2(nMem2)
      Integer iAO(4), iCmp(4), kOp(4), iAOst(4)
      Logical Shijij
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      iRout = 248
      iPrint = nPrint(iRout)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*
!      write(*,*)"Print out in integral_util/pget0 starting"
!      Call RecPrt('DSO in PGet0',' ',D0,ndens,5)  ! ====== yma ======

      PMax=One
      nSA=1
*                                                                      *
************************************************************************
*                                                                      *
*       RASSCF wavefunction
*
        If (lPSO) Then
*                                                                      *
************************************************************************
*                                                                      *
*
         ipPam=1
         ipiPam = ipPam + MemPSO
         ipMap = ipiPam + n1+n2+n3+n4
         ipC = ipMap + 4*S%nDim
         ipS1 = ipC + nCred
         ipS2 = ipS1 + 2*nScr1
*
         If (lSA) nSA=4
*
         If (nIrrep.eq.1) Then
            kOp(1) = 0
            kOp(2) = 0
            kOp(3) = 0
            kOp(4) = 0
            If (Case_2C) Then
               If (Do_RI) Then
                  Call PGet1_RI2(PSO,ijkl,nPSO,iCmp,
     &                           iAO,iAOst,Shijij,
     &                           iBas,jBas,kBas,lBas,kOp,
     &                           ExFac,CoulFac,PMax,
     &                           V_K,U_K,nV_K,
     &                           Z_p_k,nSA)
!                  write(*,*)"PGet1_RI2 ===========" yma
               Else
*Not modified yet
                  Call Abend()
               End If
            Else If (Case_3C) Then
               If (Do_RI) Then
                  Call PGet1_RI3(PSO,ijkl,nPSO,iCmp,
     &                           iAO,iAOst,Shijij,
     &                           iBas,jBas,kBas,lBas,kOp,D0,
     &                           DS,DVar,nDens,
     &                           ExFac,CoulFac,PMax,
     &                           V_K,U_K,nV_K,
     &                           Z_p_k,nnP(0),nSA,nAsh)
               Else
*Not modified yet
                  Call Abend()
               End If
            Else
               Call PGet3(PSO,ijkl,nPSO,iCmp,
     &                    iAO,iAOst,Shijij,
     &                    iBas,jBas,kBas,lBas,kOp,D0,nDens,
     &                    Mem2(ipPam),n1,n2,n3,n4,
     &                    Mem2(ipiPam),Mem2(ipMap),S%nDim,
     &                    Mem2(ipC),nCred,Mem2(ipS1),nScr1,
     &                    Mem2(ipS2),nScr2,PMax)
!yma                  write(*,*)"PGet3 ==========="
            End If
         Else
            If (Case_2C) Then
               If (Do_RI) Then
                  Call PGet2_RI2(iCmp,
     &                           iBas,jBas,kBas,lBas,
     &                           Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                           ExFac,CoulFac,
     &                           PMax,V_K,nV_K,
     &                           Z_p_k,nSA,nZ_p_k)
!yma                  write(*,*)"PGet2_RI2 ==========="
               Else
*Not modified yet
                  Call Abend()
               EndIf
            Else If (Case_3C) Then
               If (Do_RI) Then
                  Call PGet2_RI3(iCmp,
     &                           iBas,jBas,kBas,lBas,
     &                           Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                           D0,DS,nDens,ExFac,
     &                           CoulFac,PMax,V_K,nV_K,
     &                           Z_p_k,nSA,nAsh)

               Else
*Not modified yet
                  Call Abend()
               EndIf
            Else
            do i=1,ijkl  !yma for testing
              do j=1,nPSO
                PSO(i,j)=0.0d0
              end do
            end do



!      write(*,*)"Print out in integral_util/pget0 before"
!      Call RecPrt('DSO in PGet0',' ',D0,ndens,5)  ! ====== yma ======

               Call PGet4(iCmp,iBas,jBas,kBas,lBas,
     &                    Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                    D0,nDens,
     &                    Mem2(ipPam),n1,n2,n3,n4,
     &                    Mem2(ipiPam),Mem2(ipMap),S%nDim,
     &                    Mem2(ipC),nCred,Mem2(ipS1),nScr1,
     &                    Mem2(ipS2),nScr2,PMax)
!yma                  write(*,*)"PGet4 ============"
            End If
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
*        SCF and DFT wavefunction
*
         If (Gamma_On .and. nGamma.gt.nMem2) Then
            Write (6,*) 'pGet0: nGamma.lt.nMem2'
            Call abend()
         End If
*
         iComp = 1
         If (nIrrep.eq.1) Then
            kOp(1) = 0
            kOp(2) = 0
            kOp(3) = 0
            kOp(4) = 0
            If (Gamma_On) Then
               If (Do_RI) Call Abend()
               If (gamma_mrcisd) Then
               Call Read_Bin_Columbus
     &                (iShell_A,iShell_B,iShell_C,iShell_D,
     &                       G_Toc,nQuad,
     &                       Mem2,nGamma,
     &                       LuGamma,Bin,lBin)
               Else
               Call Read_Bin(iShell_A,iShell_B,iShell_C,iShell_D,
     &                       G_Toc,nQuad,
     &                       Mem2,nGamma,
     &                       LuGamma,Bin,lBin)
               Endif
               Call PGet1_Aces(PSO,ijkl,nPSO,iCmp,
     &                         iAO,iAOst,Shijij,
     &                         iBas,jBas,kBas,lBas,kOp,D0,
     &                         DVar,DS,DSVar,
     &                         nDens,Mem2,nGamma,
     &                         SO2cI,nSOs,iSO2Sh,PMax)
            Else
               If (Case_2C) Then
                  If (Do_RI) Then
                     Call PGet1_RI2(PSO,ijkl,nPSO,iCmp,
     &                              iAO,iAOst,Shijij,
     &                              iBas,jBas,kBas,lBas,kOp,
     &                              ExFac,CoulFac,PMax,
     &                              V_K,U_K,nV_K,
     &                              Z_p_k, nSA)
                  Else
                     Call PGet1_CD2(PSO,ijkl,nPSO,iCmp,
     &                              iAO,iAOst,Shijij,
     &                              iBas,jBas,kBas,lBas,kOp,
     &                              ExFac,CoulFac,PMax,
     &                              V_K,U_K,nV_K,
     &                              Z_p_k,nnP(0))
                  End If
               Else If (Case_3C) Then
                  If (Do_RI) Then
                     Call PGet1_RI3(PSO,ijkl,nPSO,iCmp,
     &                              iAO,iAOst,Shijij,
     &                              iBas,jBas,kBas,lBas,kOp,D0,
     &                              DS,DVar,nDens,
     &                              ExFac,CoulFac,PMax,
     &                              V_K,U_K,nV_K,
     &                              Z_p_k,nnP(0),nSA,nAsh)
                  Else
                     Call PGet1_CD3(PSO,ijkl,nPSO,iCmp,
     &                              iAO,iAOst,Shijij,
     &                              iBas,jBas,kBas,lBas,kOp,D0,
     &                              DS,DVar,nDens,
     &                              ExFac,CoulFac,PMax,
     &                              V_K,U_K,nV_K)
                  End If
               Else
                  Call PGet1(PSO,ijkl,nPSO,iCmp,
     &                       iAO,iAOst,Shijij,
     &                       iBas,jBas,kBas,lBas,kOp,D0,
     &                       DS,nDens,ExFac,CoulFac,PMax)
               End If
            End If
         Else
            If (Gamma_On) Then
               If (Do_RI) Call Abend()
               If (gamma_mrcisd) Then
               Call Read_Bin_Columbus
     &                (iShell_A,iShell_B,iShell_C,iShell_D,
     &                       G_Toc,nQuad,
     &                       Mem2,nGamma,
     &                       LuGamma,Bin,lBin)
               else
               Call Read_Bin(iShell_A,iShell_B,iShell_C,iShell_D,
     &                       G_Toc,nQuad,
     &                       Mem2,nGamma,
     &                       LuGamma,Bin,lBin)
               endif
               Call PGet2_Aces(iCmp,
     &                         iBas,jBas,kBas,lBas,
     &                         Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                         D0,DVar,DS,
     &                         DSVar,nDens,Mem2,nGamma,
     &                         SO2cI,nSOs,iSO2Sh,PMax)
            Else
               If (Case_2C) Then
                  If (Do_RI) Then

                     Call PGet2_RI2(iCmp,
     &                              iBas,jBas,kBas,lBas,
     &                              Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                              ExFac,CoulFac,
     &                              PMax,V_K,nV_K,
     &                              Z_p_k, nSA,nZ_p_k)
                  Else
                     Call PGet2_CD2(iCmp,
     &                              iBas,jBas,kBas,lBas,
     &                              Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                              ExFac,CoulFac,
     &                              PMax,V_K,nV_K)
                  End If
               Else If (Case_3C) Then
                  If (Do_RI) Then
                     Call PGet2_RI3(iCmp,
     &                              iBas,jBas,kBas,lBas,
     &                              Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                              D0,DS,nDens,ExFac,
     &                              CoulFac,PMax,V_K,nV_K,
     &                              Z_p_k,nSA,nAsh)
                  Else
                     Call PGet2_CD3(iCmp,
     &                              iBas,jBas,kBas,lBas,
     &                              Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                              D0,DS,nDens,ExFac,
     &                              CoulFac,PMax,V_K,nV_K)
                  End If
*
               Else
                  Call PGet2(iCmp,
     &                       iBas,jBas,kBas,lBas,
     &                       Shijij, iAO, iAOst, ijkl, PSO, nPSO,
     &                       D0,DS,nDens,ExFac,CoulFac,
     &                       PMax)
               End If
            End If
         End If
*                                                                      *
************************************************************************
*                                                                      *
      End If
*
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Call RecPrt('PSO in PGet0',' ',
     &                               PSO,ijkl,nPSO)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine unpackab3 (wrk,wrksize,
     & mapdn,mapin,mapdr1,mapir1,ssn,nabnow,possab0,lentotab,key)
c
c     mapdn - direct map matrix corresponding to N (Input)
c     mapin - direct map matrix corresponding to N (Input)
c     mapdr1- inverse map matrix corresponding to R1 (Input)
c     mapir1- inverse map matrix corresponding to R1 (Input)
c     ssn   - overall symmtry state of N (Input)
c     nabnow- #of b indexes stored in stack (dimension of stack)
c     possab0 - real possition of AB_stack (I)
c     lentotab- lenrgth of one record in stack (per one b ind) (I)
c     key   - key, specifying which integrals need to be defined (I)
c       this routine unpack: N _a_b (p,q) = <ab|pq>              key
c       N _a_b (p,q) a>=b-bb  -> R1 _a,_b(ef)aaaa = <ab||ef>      1
c                             -> R1 _a,_b(ef)bbbb = <ab||ef>      2
c                             -> R1 _a,_b(e,f)abab = <ab||ef>     3
c                             -> R1 _b,_a(e,f)abab = <ba||fe>     4
c
c     !N.B. mylim, ze pri II.3;II.4;III.3;III.4 maju byt possn +--+ a nie ++++
c     ako su terazky
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer mapdn(0:512,1:6)
       integer mapin(1:8,1:8,1:8)
       integer mapdr1(0:512,1:6)
       integer mapir1(1:8,1:8,1:8)
c
       integer ssn,key,nabnow,possab0,lentotab
c
c     help variables
c
       integer symp,symq,dimp,dimq,dime,dimf,dimef,lengthn
       integer ir1,possr1,bb
       integer possn,in,inp,inm,possnp,possnm
c
c
       do 2000 bb=1,nabnow
c
c
       do 1000 symp=1,nsym
       symq=mmul(ssn,symp)
c
       in=mapin(symp,1,1)
       lengthn=mapdn(in,2)
c
       if (lengthn.eq.0) goto 1000
c
       if (symp.eq.symq) then
c     symp=symq
c
cold   possn=mapdn(in,1)
       possn=possab0+(mapdn(in,1)-mapdn(1,1))+(bb-1)*lentotab
       dimp=dimm(5,symp)
c
cI.1  def R1 - _a_b(ef)aaaa
c
       if (key.eq.1) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dimef=(dimm(3,symp)*(dimm(3,symp)-1))/2
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp8 (wrk(possn),wrk(possr1),dimp,dimef,noa(symp),
     &                  nva(symp),bb,nabnow)
       end if
       end if
c
cI.2  def R1 - _a_b(ef)bbbb
c
       if (key.eq.2) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dimef=(dimm(4,symp)*(dimm(4,symp)-1))/2
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp8 (wrk(possn),wrk(possr1),dimp,dimef,nob(symp),
     &                  nvb(symp),bb,nabnow)
       end if
       end if
c
cI.3  def R1 - _a_b(e,f)abab
c
       if (key.eq.3) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp10(wrk(possn),wrk(possr1),dimp,dimp,dime,
     & dimf,noa(symp),nva(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
cI.4  def R1 - _b_a(e,f)abab
c
       if (key.eq.4) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp11(wrk(possn),wrk(possr1),dimp,dimp,dime,
     & dimf,noa(symp),nva(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
       else if (symp.gt.symq) then
c     symp > symq
c
       inp=mapin(symp,1,1)
       inm=mapin(symq,1,1)
cold   possnp=mapdn(inp,1)
       possnp=possab0+(mapdn(inp,1)-mapdn(1,1))+(bb-1)*lentotab
cold   possnm=mapdn(inm,1)
       possnm=possab0+(mapdn(inm,1)-mapdn(1,1))+(bb-1)*lentotab
       dimp=dimm(5,symp)
       dimq=dimm(5,symq)
c
cII.1 def R1 - _a_b(ef)aaaa
c
       if (key.eq.1) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(3,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp9 (wrk(possnp),wrk(possnm),wrk(possr1),dimp,dimq,
     &                  dime,dimf,
     & noa(symp),nva(symp),noa(symq),nva(symq),bb,nabnow)
       end if
       end if
c
cII.2 def R1 - _a_b(ef)bbbb
c
       if (key.eq.2) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(4,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp9 (wrk(possnp),wrk(possnm),wrk(possr1),dimp,dimq,
     &                  dime,dimf,
     & nob(symp),nvb(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
cII.3 def R1 - _a_b(e,f)abab
c
       if (key.eq.3) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp10(wrk(possnp),wrk(possr1),dimp,dimq,dime,dimf,
     & noa(symp),nva(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
cII.4 def R4 - _b_a(e,f)abab
c
       if (key.eq.4) then
       ir1=mapir1(symq,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symq)
       dimf=dimm(4,symp)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp11(wrk(possnp),wrk(possr1),dimp,dimq,dime,dimf,
     & noa(symq),nva(symq),nob(symp),nvb(symp),bb,nabnow)
       end if
       end if
c
       else
c     symp < symq
c%

       inp=mapin(symp,1,1)
       inm=mapin(symq,1,1)
cold   possnp=mapdn(inp,1)
cold   possnm=mapdn(inm,1)
       possnp=possab0+(mapdn(inp,1)-mapdn(1,1))+(bb-1)*lentotab
       possnm=possab0+(mapdn(inm,1)-mapdn(1,1))+(bb-1)*lentotab
       dimp=dimm(5,symp)
       dimq=dimm(5,symq)
c
cIII.1def R1 - _a_b(ef)aaaa -no operation
cIII.2def R1 - _a_b(ef)bbbb -no operation
c
cIII.3def R1 - _a_b(e,f)abab
c
       if (key.eq.3) then
       ir1=mapir1(symp,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symp)
       dimf=dimm(4,symq)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp10(wrk(possnp),wrk(possr1),dimp,dimq,dime,dimf,
     & noa(symp),nva(symp),nob(symq),nvb(symq),bb,nabnow)
       end if
       end if
c
cIII.4def R3 - _b_a(e,f)abab
c
       if (key.eq.4) then
       ir1=mapir1(symq,1,1)
       possr1=mapdr1(ir1,1)
       dime=dimm(3,symq)
       dimf=dimm(4,symp)
       if (mapdr1(ir1,2).gt.0) then
       call unpckhelp11(wrk(possnp),wrk(possr1),dimp,dimq,dime,dimf,
     & noa(symq),nva(symq),nob(symp),nvb(symp),bb,nabnow)
       end if
       end if
c
c%
       end if
c
 1000   continue
 2000   continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MSSTRN_LUCIA(INSTRN,UTSTRN,NOPEN,IPRCSF)
C
C A STRING IS GIVEN IN FORM A SEQUENCE OF ZEROES
C AND ONE ' S
C
C REINTERPRET THIS AS :
C
C 1 : THE INPUT STRING IS A DETERMINANT AND THE
C     1'S INDICATE ALPHA ELECTRONS AND THE
C     0'S INDICATE BETA ELECTRONS .
C     UTSTRN IS THE MS-VALUES ATE EACH VERTEX
C
C 2 : THE INPUT STRING IS A CSF GIVEN IN A
C     BRANCHING DIAGRAM, WHERE
C     1'S INDICATE UPWARDS SPIN COUPLEING
C     WHILE THE 0'S INDICATES DOWNWARDS SPIN COUPLING ,
C     REEXPRESS THIS AS S VALUES OF ALL COUPLINGS
C
C THE TWO PROCEDURES ARE IDENTICAL .

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION INSTRN(NOPEN),UTSTRN(NOPEN)
C
      UTSTRN(1) = DBLE(INSTRN(1)) - 0.5D0
      DO 10 IOPEN = 2, NOPEN
        UTSTRN(IOPEN) = UTSTRN(IOPEN-1) +DBLE(INSTRN(IOPEN))-0.5D0
   10 CONTINUE
C
      NTEST = 0
      NTEST = MAX(NTEST,IPRCSF)
      IF(NTEST.GE.10) THEN
         WRITE(6,*) ' ... Output from MSSTRN '
         WRITE(6,*) ' INSTRN AND UTSTRN'
         CALL IWRTMA(INSTRN,1,NOPEN,1,NOPEN)
         CALL WRTMAT(UTSTRN,1,NOPEN,1,NOPEN)
       END IF
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               1993, Per-Olof Widmark                                 *
!***********************************************************************

subroutine RdOrd_(rc,iOpt,iSym,jSym,kSym,lSym,Buf,lBuf,nMat)
!***********************************************************************
!                                                                      *
!    Purpose: Read a buffer of ordered integrals of length lBuf        *
!             The subroutine returns the number of submatrices         *
!             it has picked up.                                        *
!                                                                      *
!    Calling parameters:                                               *
!    iSym   : irred. representation of first symmetry label            *
!    jSym   : irred. representation of second symmetry label           *
!    kSym   : irred. representation of third symmetry label            *
!    lSym   : irred. representation of fourth symmetry label           *
!    Buf    : containts on output the integrals                        *
!    lBuf   : length of the integral buffer                            *
!    nMat   : number of submatrices read in                            *
!    iOpt   : option code (iOpt=1:start reading at first integral)     *
!                         (iOpt=2:continue reading)                    *
!    rc     : return code                                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher and P.O. Widmark                                 *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use TwoDat, only: AuxTwo, isBas, isOrd, isPkPa, isSkip, isSym, nBatch, RAMD, rcTwo, TocTwo
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: rc, nMat
integer(kind=iwp), intent(in) :: iOpt, iSym, jSym, kSym, lSym, lBuf
real(kind=wp), intent(_OUT_) :: Buf(*)
integer(kind=iwp) :: iB, iBatch, ijB, ijS, iSkip, iSyBlk, jB, jSkip, kB, klB, klS, kSkip, lB, Leftpq, lSkip, nInts, nPairs, nSym
logical(kind=iwp) :: Square

!----------------------------------------------------------------------*
! Start the procedure                                                  *
!----------------------------------------------------------------------*
rc = rcTwo%good
!----------------------------------------------------------------------*
! Check the file status                                                *
!----------------------------------------------------------------------*
if (.not. AuxTwo%Opn) then
  rc = rcTwo%RD08
  write(u6,*) 'RdOrd: ORDINT not opened yet!'
  call Abend()
end if
!----------------------------------------------------------------------*
! Check if the packing table has been loaded                           *
!----------------------------------------------------------------------*
if ((TocTwo(isPkPa) < 0) .or. (TocTwo(isPkPa) > 1)) then
  rc = rcTwo%RD09
  write(u6,*) 'RdOrd: the packing flags are spoiled'
  call Abend()
end if
!----------------------------------------------------------------------*
! Check the symmetry labels                                            *
!----------------------------------------------------------------------*
Square = TocTwo(isOrd) == 1
if (Mul(iSym,jSym) /= Mul(kSym,lSym)) then
  rc = rcTwo%RD01
  write(u6,*) 'RdOrd: Wrong symmetry labels, direct product is not total symmetric'
  call Abend()
end if
if ((iSym < jSym) .or. (kSym < lSym)) then
  rc = rcTwo%RD02
  write(u6,*) 'RdOrd: invalid order of symmetry labels'
  call Abend()
end if
ijS = jSym+nTri_Elem(iSym-1)
klS = lSym+nTri_Elem(kSym-1)
if ((ijS < klS) .and. (.not. Square)) then
  rc = rcTwo%RD03
  write(u6,*) 'RdOrd: invalid combination of symmetry labels'
  call Abend()
end if
nSym = TocTwo(isSym)
nPairs = nTri_Elem(nSym)
iSyBlk = (ijS-1)*nPairs+klS
iBatch = nBatch(iSyBlk)
!----------------------------------------------------------------------*
! Check the skipping flags                                             *
!----------------------------------------------------------------------*
iSkip = TocTwo(isSkip+iSym-1)
jSkip = TocTwo(isSkip+jSym-1)
kSkip = TocTwo(isSkip+kSym-1)
lSkip = TocTwo(isSkip+lSym-1)
if ((iSkip+jSkip+kSkip+lSkip) /= 0) then
  rc = rcTwo%RD07
  write(u6,*) 'RdOrd: Requested symmetry block has not been computed'
  call Abend()
end if
!----------------------------------------------------------------------*
! Check options                                                        *
!----------------------------------------------------------------------*
if ((iOpt /= 1) .and. (iOpt /= 2)) then
  rc = rcTwo%RD06
  write(u6,*) 'RdOrd: Invalid option'
  write(u6,*) 'iOpt=',iOpt
  call Abend()
end if
!----------------------------------------------------------------------*
! Check the buffer size                                                *
!----------------------------------------------------------------------*
if (lBuf <= 0) then
  rc = rcTwo%RD04
  write(u6,*) 'RdOrd: invalid buffer size'
  write(u6,*) 'lbuf=',lBuf
  call Abend()
end if
!----------------------------------------------------------------------*
! Compute matrix dimensions                                            *
!----------------------------------------------------------------------*
iB = TocTwo(isBas+iSym-1)
jB = TocTwo(isBas+jSym-1)
kB = TocTwo(isBas+kSym-1)
lB = TocTwo(isBas+lSym-1)
if (iSym == jSym) then
  ijB = nTri_Elem(iB)
else
  ijB = iB*jB
end if
if (kSym == lSym) then
  klB = nTri_Elem(kB)
else
  klB = kB*lB
end if
!----------------------------------------------------------------------*
! Compute submatrix dimensions                                         *
!----------------------------------------------------------------------*
if (lBuf <= 0) then
  rc = rcTwo%RD04
  write(u6,*) 'RdOrd: invalid buffer size'
  write(u6,*) 'lbuf=',lBuf
  call Abend()
end if
if (klB <= 0) then
  nMat = 0
  return
else
  nMat = (lBuf-1)/klB
end if
if (nMat > ijB) nMat = ijB
if (nMat == 0) then
  rc = rcTwo%RD05
  write(u6,*) 'RdOrd: too small buffer'
  write(u6,*) 'Buffer size is lBuf  =',lBuf
  write(u6,*) 'Size of submatrix klB=',klB
  write(u6,*) 'Call parameters to rdord are:'
  write(u6,*) 'iOpt=',iOpt
  write(u6,*) 'iSym=',iSym
  write(u6,*) 'jSym=',jSym
  write(u6,*) 'kSym=',kSym
  write(u6,*) 'lSym=',lSym
  write(u6,*) 'lBuf=',lBuf
  write(u6,*) 'nMat=',nMat
  write(u6,*) 'Symmetry block iSyBlk=',iSyBlk
  write(u6,*) 'Batch nr       iBatch=',iBatch
  write(u6,*) 'iB=TocTwo(isBas+iSym-1), etc:'
  write(u6,*) 'iB=',iB
  write(u6,*) 'jB=',jB
  write(u6,*) 'kB=',kB
  write(u6,*) 'lB=',lB
  call Abend()
end if
!----------------------------------------------------------------------*
! Check that the number of submatrices do not run beyond               *
! the last integral of a symmetry allowed batch                        *
!----------------------------------------------------------------------*
Leftpq = AuxTwo%Npq
if (iOpt == 1) then
  Leftpq = ijB
else
  nMat = min(Leftpq,nMat)
end if
Leftpq = Leftpq-nMat
AuxTwo%Npq = Leftpq
nInts = nMat*klB
!----------------------------------------------------------------------*
! Transfer integrals                                                   *
!----------------------------------------------------------------------*
if (RAMD%act) then
  call ORDIN2(iOpt,Buf,nInts,iBatch)
else
  call ORDIN1(iOpt,Buf,nInts,iBatch)
end if

!----------------------------------------------------------------------*
! exit                                                                 *
!----------------------------------------------------------------------*
return

end subroutine RdOrd_

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
*               2010, Grigory A. Shamov                                *
************************************************************************
      Subroutine XRGE2(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                   Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object: To compute the exchange part of RGE2, by                     *
*  Ruzsinszky, Csonka, Scuseria, JCTC 2009, 5, 763-769                 *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author:Per Ake Malmqvist, Department of Theoretical Chemistry,  *
*             University of Lund, SWEDEN. June 2006                    *
*             Grigory A Shamov, U of Manitoba, spring 2010             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),
     &       F_xc(mGrid)

* IDORD=Order of derivatives to request from XPBE:
      idord=1


      if (ispin.eq.1) then
* ispin=1 means spin zero.
* T_X: Screening threshold of total density.
        Ta=0.5D0*T_X
        do iGrid=1,mgrid
         rhoa=max(1.0D-24,Rho(ipR,iGrid))
         if(rhoa.lt.Ta) goto 110
         grdrhoa_x=Rho(ipdRx,iGrid)
         grdrhoa_y=Rho(ipdRy,iGrid)
         grdrhoa_z=Rho(ipdRz,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2

         call testRGE2_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*(2.0D0*Fa)
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*dFdrhoa
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*dFdgammaaa
* Note: For xpbe, dFdgammaab is zero.
 110     continue
        end do
      else
* ispin .ne. 1, use both alpha and beta components.
        do iGrid=1,mgrid
         rhoa=max(1.0D-24,Rho(ipRa,iGrid))
         rhob=max(1.0D-24,Rho(ipRb,iGrid))
         rho_tot=rhoa+rhob
         if(rho_tot.lt.T_X) goto 210
         grdrhoa_x=Rho(ipdRxa,iGrid)
         grdrhoa_y=Rho(ipdRya,iGrid)
         grdrhoa_z=Rho(ipdRza,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         call testRGE2_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)

         grdrhob_x=Rho(ipdRxb,iGrid)
         grdrhob_y=Rho(ipdRyb,iGrid)
         grdrhob_z=Rho(ipdRzb,iGrid)
         sigmabb=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
         call testRGE2_(idord,rhob,sigmabb,Fb,dFdrhob,dFdgammabb,
     &          d2Fdrb2,d2Fdrbdgbb,d2Fdgbb2)

         F_xc(iGrid)=F_xc(iGrid)+Coeff*(Fa+Fb)
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+Coeff*dFdrhoa
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+Coeff*dFdrhob
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
* Note: For xpbe, dFdgammaab is zero.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*dFdgammaaa
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*dFdgammabb
 210     continue
        end do
      end if

      Return
      End

C Cmu to be modified to 10/81 to make it PBEsol
C      Data Ckp, Cmu / 0.804D0, 0.12345679012346D0/


      Subroutine testXPBE_(idord,rho_s,sigma_s,
     &                        f,dFdr,dFdg,d2Fdr2,d2Fdrdg,d2Fdg2)
************************************************************************
*                                                                      *
* Object: To compute the PBE exchange functional from MOLPRO manual    *
*         using Maxima derivatives and optimization/fortran generator  *
*  Ref: PBE,"Generalized gradient approximation made simple,"          *
*      Phys. Rev. Lett. 77 (1996) 3865-3868.                           *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author: Grigory Shamov, U of Manitoba, Feb-March 2010           *
************************************************************************
      Implicit None
      Integer idord
      real*8 rho_s,sigma_s, rho, gamma, k, mu, Tpi, Cx, one
      real*8 f,dFdr,dFdg,d2Fdr2,d2Fdrdg,d2Fdg2
      parameter(Tpi=3.141592653589793d0,
     &  Cx=0.9305257363491d0, one=1.0d0 )

      Data k, mu / 0.804D0, 0.2195149727645171D0/
C      Data CkF / 3.0936677262801359310D0/
C      Data CeX /-0.73855876638202240588D0/
      real*8 T1,T2,T3,T4,T5,T6 ,T7, T8
C
      rho=max(1.0D-24,rho_s)
      gamma=max(1.0D-24,sigma_s)


      T1=rho**(4.d+0/3.d+0)
      T2=one/k
      T3=1.6455307846020562d-2*T2*mu*gamma/rho**(8.d+0/3.d+0)+1.d+0
      T4=-1.d+0*k/T3+k+1.d+0
      T5=one/rho**(7.d+0/3.d+0)
      T6=one/T3**2
      T7=mu**2
      T8=one/T3**3

      F = -9.305257363491001d-1*T1*T4

      dFdr = 4.083223320071
     4   841d-2*mu*T5*gamma*T6-1.2407009817988002d+0*rho**(1.d+0/3.d+0)*
     5   T4

      dFdg = -1.5312087450269407d-2*mu*T6/T1

      d2Fdr2 = -4.135669939
     6   329333d-1*T4/rho**(2.d+0/3.d+0)-4.0832233200718443d-2*mu*gamma*
     7   T6/rho**(1.d+1/3.d+0)+3.583503825911055d-3*T2*T7*gamma**2*T8/rh
     8   o**6

      d2Fdrdg = 2.0416116600359208d-2*mu*T5*T6-1.343813934716646
     9   d-3*T2*T7*gamma*T8/rho**5

      d2Fdg2 = 5.03930225518742d-4*T2*T7*T8
     =   /rho**4

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(idord)
      End

      Subroutine testRGE2_(idord,rho_s,sigma_s,
     &                        f,dFdr,dFdg,d2Fdr2,d2Fdrdg,d2Fdg2)
************************************************************************
*                                                                      *
* Object: To compute the RGE exchange functional. Procedure: the PBE   *
*  exchange functional from MOLPRO manual with Fx changed to RGE, the  *
*  mu parameter changed to be as of PBEsol. Code was made              *
*         using Maxima derivatives and optimization/fortran generator  *
*                                                                      *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author: Grigory Shamov, U of Manitoba, Feb-March 2010           *
************************************************************************

      Implicit None
      Integer idord
      real*8 rho_s,sigma_s, rho, gamma, k, mu, Tpi, Cx, one
      real*8 f,dFdr,dFdg,d2Fdr2,d2Fdrdg,d2Fdg2
      parameter(Tpi=3.141592653589793d0,
     &  Cx=0.9305257363491d0, one=1.0d0 )

C Cmu to be modified to 10/81 to make it PBEsol
      Data k, mu / 0.804D0, 0.12345679012346D0/

C      Data k, mu / 0.804D0, 0.2195149727645171D0/
C      Data CkF / 3.0936677262801359310D0/
C      Data CeX /-0.73855876638202240588D0/
      real*8 T1, T2, T3, T4, T5, T6
      real*8 T7, T8, T9, T10, T11
      real*8 T12, T13, T14, T15, T16
C
      rho=max(1.0D-24,rho_s)
      gamma=max(1.0D-24,sigma_s)

      T1= rho**(4.d+0/3.d+0)
      T2=one/k
      T3=one/rho**(8.d+0/3.d+0)
      T4=one/k**2
      T5=  mu**2
      T6=one/rho**(1.6d+1/3.d+0)
      T7=gamma**2
      T8=2.707771563073058
     3   7d-4*T4*T5*T6*T7+1.6455307846020562d-2*T2*mu*T3*gamma+1.d+0
      T9=  -1.d+0*k/T8+k+1.d+0
      T10=one/rho**(1.1000000000000001d+1/3.d+0)
      T11=one/rho**(1.9d+1/3.d+0)
      T12=-1.4441448336389645d-3*T4*T5*T11*T7
     6   -4.388082092272149d-2*T2*mu*T10*gamma
      T13=one/T8**2
      T14=rho**(1.d+0/3.d+0)
      T15=5.415543126146117d-4*T4*T5*T6*gamma+1.64553078460
     8   20562d-2*T2*mu*T3
      T16=one/T8**3

      F = -9.305257363491001d-1*T1*T9

      dFdr = -1.2407009817988002d+0*T14*T9-9.305257363491001d-1*k*T1*
     =   T12*T13
      dFdg = -9.305257363491001d-1*k*T1*T15*T13

      d2Fdr2 = -4.1
     ;   35669939329333d-1*T9/rho**(2.d+0/3.d+0)-2.4814019635975995d+0*k
     <   *T14*T12*T13-9.305257363491001d-1*k*T1*(9.146250613046776d-3*T4
     =   *T5*T7/rho**(2.2000000000000003d+1/3.d+0)+1.6089634338331216d-1
     >   *T2*mu*gamma/rho**(1.3999999999999999d+1/3.d+0))*T13+1.86105147
     ?   26982003d+0*k*T1*T12**2*T16

      d2Fdrdg = -1.2407009817988002d+0*k*
     @   T14*T15*T13-9.305257363491001d-1*k*T1*(-2.888289667277929d-3*T4
     1   *T5*T11*gamma-4.388082092272149d-2*T2*mu*T10)*T13+1.86105147269
     2   82003d+0*k*T1*T15*T12*T16

      d2Fdg2 = 1.8610514726982003d+0*k*T1*T
     3   15**2*T16-5.03930225518742d-4*T2*T5*T13/rho**4

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(idord)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine InsReqo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c                   mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
c
c       this routine do:
c        Inspect W3 and W4 files requirements of o2v4 procedure
c        on this node. It checks which of the W3 and W4 files
c        are used on this node
c
        use Para_Info, only: MyRank
        implicit none
#include "chcc1.fh"
#include "parcc.fh"
#include "o2v4.fh"
c
        integer NaGrp,NbeGrp,NaSGrp,NbeSgrp
        integer mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
c
c        help variables
c
        integer aGrp,bGrp,gaGrp,beGrp,aSGrp,bSGrp,gaSGrp,beSGrp
        integer dima,dimb,adda,addb
        integer dimbe,dimga,addbe,addga,addbepp,addgapp
        integer bSGrpUp,gaSGrpUp
        integer LenW3,LenW4
        integer i,j,NSGrp
c
c
c*        Initial Set InqW3,InqW4 = F
        NSGrp=NaGrp*NaSGrp
        do i=1,(NSGrp*(NSGrp+1))/2
          do j=1,NSGrp
          InqW3(i,j)=.False.
          end do
          do j=1,(NSGrp*(NSGrp+1))/2
          InqW4(i,j)=.False.
          end do
        end do
        LenW3=0
        LenW4=0
c
c
c*      cycle over all groups of (a>=b)
        adda=0
        do aGrp=1,naGrp
        dima=DimGrpa(aGrp)
c
c##        test, if on this node atleast one combination with this
c        aGrp is scheduled. Skip if no
        i=0
        do j=1,NaGrp
          i=i+ABID(myRank,aGrp,j)
        end do
        if (i.eq.0) goto 12
c
c
        addb=0
        do bGrp=1,aGrp
        dimb=DimGrpa(bGrp)
c
c##     test, if this a'b' combination is planed to be run on this node
        if (ABID(myRank,aGrp,bGrp).eq.0) goto 11
c
c
cx        cycle over all groups of (be>=ga)
          addbe=0
          do beGrp=1,nbeGrp
          dimbe=DimGrpbe(beGrp)
          addga=0
          do gaGrp=1,beGrp
          dimga=DimGrpbe(gaGrp)
c
c
cxx         cycle over all subgroups of (be>=ga)'
            addbepp=addbe
            do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)
c
            if (beGrp.eq.gaGrp) then
              gaSGrpUp=beSGrp
            else
              gaSGrpUp=GrpbeUp(gaGrp)
            end if
c
            addgapp=addga
            do gaSGrp=GrpbeLow(gaGrp),gaSGrpUp
c
c
cxxx          cycle over all subgroups of (a>=b)'
              do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
              if (aGrp.eq.bGrp) then
                bSGrpUp=aSGrp
              else
                bSGrpUp=GrpaUp(bGrp)
              end if
              do bSGrp=GrpaLow(bGrp),bSGrpUp
c
c
c*              clasical reading or generating of (VV|VV) integrals
c
cxxxx                term W1(a",be",b",ga") <- -(b"ga"|a"i) . T1(i,be")
cxxxx1          Get Ww(b",ga",a",i) (Wx used as Aux)
                call InsReaW3 (bSGrp,gaSGrp,aSGrp,LenW3)
c
cxxxx           Upgrade W1(a",be",b",ga") <<- (a",be"|b",ga")
                call InsReaW4 (aSGrp,beSGrp,bSGrp,gaSGrp,LenW4)
c
c
                if (aSGrp.ne.bSGrp) then
cxxxx                  term W2(b",be",a",ga") <- -(a"ga"|b"i) . T1(i,ga")
cxxxx1            Get Ww(a",ga",b",i) (Wx used as Aux)
                  call InsReaW3 (aSGrp,gaSGrp,bSGrp,LenW3)
c
cxxxx                  term W2(b",be",a",ga") <<- -(b"be"|a"i) . T1(i,ga")
cxxxx1            Get Ww(b",be",a",i) (Wx used as Aux)
                  call InsReaW3 (bSGrp,beSGrp,aSGrp,LenW3)
c
cxxxx             Add W2(b",be",a",ga") <<- (b",be"Ia",ga")
c                  Upgrade:W2, destroy:Ww
                  call InsReaW4 (bSGrp,beSGrp,aSGrp,gaSGrp,LenW4)
                end if
c
c
c
cxxx          end cycle over all subgroups of (a>=b)'
              end do
              end do
c
cxx         end cycle over all subgroups of (be>=ga)'
            addgapp=addgapp+DimSGrpbe(gaSGrp)
            end do
            addbepp=addbepp+DimSGrpbe(beSGrp)
            end do
c
cx        end cycle over all groups of (be>=ga)
          addga=addga+dimga
          end do
          addbe=addbe+dimbe
          end do
c
c*      end cycle over all groups of (a>=b)
11        addb=addb+dimb
        end do
12        adda=adda+dima
        end do
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(NbeSgrp)
        call Unused_integer(mdGrpa)
        call Unused_integer(mdGrpbe)
        call Unused_integer(mdSGrpa)
        call Unused_integer(mdSGrpbe)
      end if
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETINT(DIAG,DIASH,ISYSH,LSTQSP,NPOTSH,ICOUNT)
!
! Purpose: get qualified integral columns for Cholesky decomposition.
!
! DIASH(ij): max. diagonal in shell pair i,j
! NPOTSH   : the number of shell pairs that can be qualified.

use Cholesky, only: DiaMin, INF_IN2, IntMap, iOffq, IPRINT, iSP2F, LuPri, MinQual, MXSHPR, N1_Qual, N2_Qual, NCOLAB, nnBstR, &
                    nQual, nSym
use stdalloc, only: mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*)
real(kind=wp), intent(inout) :: DIASH(*)
integer(kind=iwp), intent(in) :: ISYSH(*), NPOTSH
integer(kind=iwp), intent(out) :: LSTQSP(NPOTSH), ICOUNT
integer(kind=iwp) :: ISHLA, ISHLAB, ISHLB, ISYM, ISYMAB, LMAX, MCOUNT, MEMQ(1), MXDIM, NSEL
real(kind=wp) :: SMAX, XMMQ
logical(kind=iwp) :: DODECO, FULL, SYNC
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_GETINT'

!-tbp: some debugging...
!if (LOCDBG) then
!  do LEVEL=1,3
!    call CHO_MCA_INT_1_DBG(DIAG,LEVEL)
!  end do
!  call cho_quit(SECNAM//' end of test',100)
!end if

! Initializations.
! ----------------

NQUAL(1:NSYM) = 0
ICOUNT = 0
if (MXSHPR > 0) then
  MCOUNT = min(NPOTSH,MXSHPR)
else
  MCOUNT = NPOTSH
end if
DODECO = .false.

MXDIM = NNBSTR(1,2)
do ISYM=2,NSYM
  MXDIM = max(MXDIM,NNBSTR(ISYM,2))
end do
call mma_maxDBLE(LMAX)
XMMQ = real(N1_QUAL,kind=wp)*real(LMAX,kind=wp)/real(N2_QUAL,kind=wp)
MEMQ(1) = int(XMMQ)
call CHO_GAIGOP(MEMQ,1,'min')
if (MEMQ(1) < MXDIM) then
  write(LUPRI,*) SECNAM,': memory split error!'
  write(LUPRI,*) 'Memory for storing qualified columns: ',MEMQ(1)
  write(LUPRI,*) 'Minimal memory needed to store one column: ',MXDIM
  write(LUPRI,*) 'Total memory available: ',LMAX
  write(LUPRI,*) 'Memory split is ',N1_QUAL,'/',N2_QUAL,' for qualified columns.'
  write(LUPRI,*) 'Change memory split in input file...'
  call CHO_QUIT('Memory split error in '//SECNAM,101)
end if

! Shell pair qualification loop.
! ------------------------------

do while ((.not. DODECO) .and. (ICOUNT < MCOUNT))

  ! Update shell pair counter.
  ! --------------------------

  ICOUNT = ICOUNT+1

  ! Get shell pair corresponding to largest diagonal.
  ! -------------------------------------------------

  call CHO_P_GETMAXSHL(DIASH,SMAX,ISHLAB)
  call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)
  ISYMAB = ISYSH(ISHLAB)

  if ((SMAX == Zero) .or. (abs(SMAX) < DIAMIN(ISYMAB))) then

    ! Diagonal too small to be qualified for decomposition.
    ! -----------------------------------------------------

    if (ICOUNT == 1) then
      write(LUPRI,*) SECNAM,': no integrals calculated; unable to proceed to decomposition!'
      write(LUPRI,*) 'Max. abs. diagonal for shell pair ',ISHLA,', ',ISHLB,': ',abs(SMAX)
      write(LUPRI,*) 'Max. abs. diagonal allowed: ',DIAMIN(ISYMAB),' (sym. ',ISYMAB,')'
      call CHO_QUIT('Severe error in '//SECNAM,104)
    else
      ICOUNT = ICOUNT-1
      NSEL = sum(NQUAL(1:NSYM))
      DODECO = NSEL > 0
    end if

  else

    ! Qualify diagonals within this shell pair.
    ! -----------------------------------------

    SYNC = .false.
    FULL = .false.
    call CHO_P_QUALIFY(DIAG,SYNC,ISHLAB,ISYMAB,MEMQ(1),FULL)

    ! Calculate integral columns; get qualified ones stored in
    ! current reduced set; write these to disk on temporary file(s).
    ! --------------------------------------------------------------

    NSEL = sum(NQUAL(1:NSYM))
    NCOLAB = NSEL-sum(IOFFQ(1:NSYM))

    if (NCOLAB > 0) then

      INTMAP(ISHLAB) = INTMAP(ISHLAB)+1
      if (IPRINT >= INF_IN2) then
        write(LUPRI,'(/,A,I5,1X,I5,A,I9,A)') 'Calculating shell pair (**|',ISHLA,ISHLB,'):',NCOLAB,' columns have been qualified'
        write(LUPRI,'(A)') repeat('=',77)
        write(LUPRI,'(A,I12)') 'Number of calculations so far for this shell pair: ',INTMAP(ISHLAB)
      end if

      LSTQSP(ICOUNT) = ISHLAB
      call CHO_MCA_CALCINT(ISHLAB)

      ! Enough integral columns for proceeding to decomposition?
      ! --------------------------------------------------------

      DODECO = FULL .or. (NSEL >= MINQUAL)

    else if (NCOLAB == 0) then

      if (NSEL < 1) then
        write(LUPRI,*) SECNAM,': logical error: unable to qualify diagonals'
        write(LUPRI,*) SECNAM,': NCOLAB = ',NCOLAB
        write(LUPRI,*) SECNAM,': NSEL   = ',NSEL
        call CHO_QUIT('[0] Logical error in '//SECNAM,104)
      else
        ICOUNT = ICOUNT-1
        DODECO = .true.
      end if

    else

      write(LUPRI,*) SECNAM,': logical error: unable to qualify diagonals'
      write(LUPRI,*) SECNAM,': NCOLAB = ',NCOLAB
      write(LUPRI,*) SECNAM,': NSEL   = ',NSEL
      call CHO_QUIT('[1] Logical error in '//SECNAM,104)

    end if

  end if

end do

! Test loop exit (we may have calculated all possible integrals, yet
! NSEL < MINQUAL or allowed memory may have been used).
! ------------------------------------------------------------------

if (.not. DODECO) then
  NSEL = sum(NQUAL(1:NSYM))
  if (NSEL < 1) then
    write(LUPRI,*) SECNAM,': logical error: unable to qualify diagonals'
    write(LUPRI,*) SECNAM,': Flag DODECO is ',DODECO
    write(LUPRI,*) SECNAM,': NSEL    = ',NSEL
    write(LUPRI,*) SECNAM,': ICOUNT  = ',ICOUNT
    write(LUPRI,*) SECNAM,': MCOUNT  = ',MCOUNT
    write(LUPRI,*) SECNAM,': NPOTSH  = ',NPOTSH
    write(LUPRI,*) SECNAM,': MINQUAL = ',MINQUAL
    call CHO_QUIT('[2] Logical error in '//SECNAM,103)
  else
    DODECO = .true.
  end if
end if

! Set indices for local qualified (parallel runs).
! ------------------------------------------------

call CHO_P_SETLQ()

end subroutine CHO_GETINT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function VExch(ZP,NP,ZQ,NQ,LA,nProj,iCoShll)
!***********************************************************************
!                                                                      *
!     VExch calculates the atomic integral                             *
!     <zp,np,la | Sum(core) Kc |zq,nq,la>                              *
!                                                                      *
!***********************************************************************

use Basis_Info, only: Shells
use AMatrix, only: DFAC, KOSUU, NYU, RCA
use Constants, only: Zero, One, Two, Half, Pi
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: VExch
real(kind=wp), intent(in) :: ZP, ZQ
integer(kind=iwp), intent(in) :: NP, NQ, LA, nProj, iCoShll
integer(kind=iwp) :: ICORB, iCoSh, INU, ISIM, IT1, IT2, IT3, IT4, K, KOMAX, L, L1, L2, LMT, nExpon, NR, NS, NU, NUT
real(kind=wp) :: CR, CS, DL2, FOcc, OrbPS, RCAT, RTT1, RTT2, RTT3, RTT4, RTT5, RTT6, RTT7, SUMA, VPQ, VR, VS, ZR, ZS
real(kind=wp), parameter :: SQRT2PI = sqrt(Two/Pi)

if (nProj > 4) then
  write(u6,*) 'VExch: nProj',nProj
  write(u6,*) 'Abend: Implementation ready only up to g-core.'
  write(u6,*) '       Update common block /CONST/.'
  call Abend()
end if
if ((NP > 5) .or. (NQ > 5)) then
  write(u6,*) 'VExch: NP,NQ',NP,NQ
  write(u6,*) 'Abend: Implementation ready only up to g-valence.'
  write(u6,*) '       Update common block /CONST/.'
  call Abend()
end if

!PIPPI = (Half/PI)**0.75_wp
L1 = LA
VPQ = VF(2*NP,ZP)*VF(2*NQ,ZQ)
!PSMT = Zero
!ls start adding
Vexch = Zero
!ls end adding
! loop over angular momentum
do ISIM=1,nProj+1
  iCoSh = iCoShll+ISIM-1
  !EDUM = Half*real(ISIM,kind=wp)+Quart
  NR = ISIM
  NS = ISIM
  L2 = ISIM
  DL2 = real(2*(L2-1)+1,kind=wp)
  LMT = ((L1-1)*L1)/2+L2
  if (L1 < L2) LMT = ((L2-1)*L2)/2+L1
  KOMAX = KOSUU(LMT)
  ! loop over core orbitals of a given angular momentum
  do ICORB=1,Shells(iCoSh)%nBasis
    OrbPS = Zero
    do INU=1,KOMAX
      NUT = NYU(INU,LMT)
      NU = NUT
      RCAT = RCA(INU,LMT)*DL2
      !      BEGIN KSM.
      ! COMPUTATION OF K SUPER MATRIX OVER CGTO
      ! NU IS UPPER INDEX NYU IN ROOTHAAN'S NOTATION

      IT1 = NP+NR-NU-1
      IT2 = NQ+NS+NU
      IT3 = NQ+NS-NU-1
      IT4 = NP+NR+NU
      SUMA = Zero
      nExpon = Shells(iCoSh)%nExp
      do K=1,nExpon
        ZR = Shells(iCoSh)%Exp(K)
        CR = Shells(iCoSh)%Cff_c(K,ICORB,2)
        !LS coeff of unnormalized non-diagonal cartesian GTF
        ! to be used in ecpaimp       CR = CR/(PIPPI*(Four*ZR)**EDUM)
        VR = VF(2*NR,ZR)
        RTT1 = Half*(ZP+ZR)
        do L=1,nExpon
          ZS = Shells(iCoSh)%Exp(L)
          CS = Shells(iCoSh)%Cff_c(L,ICORB,2)
          ! to be used in ecpaimp          CS = CS/(PIPPI*(Four*ZS)**EDUM)
          VS = VF(2*NS,ZS)
          RTT2 = Half*(ZQ+ZS)
          RTT3 = RTT1/RTT2
          RTT4 = One/RTT3
          call AUXC((IT1+1)/2,IT2,RTT3,RTT5)
          call AUXC((IT3+1)/2,IT4,RTT4,RTT6)
          RTT7 = VF(IT1,RTT1)*VF(IT2,RTT2)*RTT5+VF(IT3,RTT2)*VF(IT4,RTT1)*RTT6
          SUMA = SUMA+RTT7*CR*CS/sqrt(VPQ*VR*VS)
        end do
      end do
      !      END KSM.
      !ls PSMT = PSMT+RCAT*SQRT2PI*SUMA
      !ls start adding
      OrbPS = OrbPS+RCAT*SQRT2PI*SUMA
      !ls end adding
    end do
    !ls start adding
    FOcc = Shells(iCoSh)%Occ(iCOrb)
    Vexch = Vexch+Two*OrbPS*FOcc
    !ls start adding
  end do ! end of loop over core orbitals of a given angular momentum
end do ! end of loop over angular momentum
!ls VEXCH = Two*PSMT

return

contains

function VF(N,X)

  real(kind=wp) :: VF
  integer(kind=iwp), intent(in) :: N
  real(kind=wp), intent(in) :: X

  VF = DFAC(N)/sqrt(X)**(N+1)

end function VF

end function VExch

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine Start2(FName,LuOrb,CMO,mBB,nD,Ovrlp,mBT,EOrb,OccNo,mmB)
!***********************************************************************
!                                                                      *
!     purpose: Get starting orbitals INPORB                            *
!                                                                      *
!     called from: SOrb                                                *
!                                                                      *
!     calls to: Ortho                                                  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

#ifdef _MSYM_
use, intrinsic :: iso_c_binding, only: c_ptr
#endif
#ifdef _HDF5_
use mh5, only: mh5_exists_dset
#endif
use InfSCF, only: Aufb, FileOrb_id, isHDF5, mSymON, nBas, nBO, nBT, nDel, nnB, nOcc, nOrb, nSym, OnlyProp, VTitle
use SCFFiles, only: LuOut
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: FName
integer(kind=iwp), intent(in) :: LuOrb, mBB, nD, mBT, mmB
real(kind=wp), intent(out) :: CMO(mBB,nD), EOrb(mmB,nD), OccNo(mmB,nD)
real(kind=wp), intent(in) :: Ovrlp(mBT)
integer(kind=iwp) :: iBas, iD, iDum(7,8), iDummy(1), iErr, indx, iOff, isUHF, iSym, iWFtype, Lu_, nTmp(8)
real(kind=wp) :: Dummy(1)
character(len=6) :: OrbName
integer(kind=iwp), allocatable :: IndT(:,:)
#ifdef _MSYM_
type(c_ptr) :: msym_ctx
#endif

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Read vectors (vectors MUST !!!!! be written in symmetry blocks
! of dimension nBas(i)*nBas(i))

call mma_allocate(IndT,nnB,nD,Label='IndT')

Lu_ = LuOrb
if (nD == 1) then
  if (isHDF5) then
    call RdVec_HDF5(fileorb_id,'COEI',nSym,nBas,CMO,OccNo,EOrb,IndT)
  else
    call RdVec_(FName,Lu_,'COEI',nD-1,nSym,nBas,nOrb,CMO,Dummy,OccNo,Dummy,EOrb(:,1),Dummy,IndT(1,1),VTitle,1,iErr,iWFtype)
  end if
  call VecSort(nSym,nBas,nBas,CMO,OccNo,IndT(:,1),0,iDummy,iErr)
  indx = 1
  do iSym=1,nSym
    nTmp(iSym) = 0
    do iBas=1,nBas(iSym)
      if (IndT(indx,1) == 7) nTmp(iSym) = nTmp(iSym)+1
      indx = indx+1
    end do
    if (nOrb(iSym) > nBas(iSym)-nTmp(iSym)) then
      nOrb(iSym) = nBas(iSym)-nTmp(iSym)
      nDel(iSym) = nTmp(iSym)
    end if
  end do
  call TrimCMO(CMO(:,1),nSym,nBas,nOrb)
  call TrimEor(EOrb(:,1),nSym,nBas,nOrb)

  call Setup_SCF()
  if ((.not. Aufb) .and. (.not. OnlyProp)) then
    iOff = 0
    do iSym=1,nSym
      OccNo(iOff+1:iOff+nOcc(iSym,1),1) = Two
      OccNo(iOff+nOcc(iSym,1)+1:iOff+nOrb(iSym),1) = Zero
      iOff = iOff+nOrb(iSym)
    end do
  end if
else
  if (isHDF5) then
    isUHF = 0
#   ifdef _HDF5_
    if (mh5_exists_dset(fileorb_id,'MO_ALPHA_VECTORS')) isUHF = 1
#   endif
  else
    call Chk_Vec_UHF(FNAME,Lu_,isUHF)
  end if
  if (isUHF == 1) then
    if (isHDF5) then
      call RdVec_HDF5(fileorb_id,'COEIA',nSym,nBas,CMO(:,1),OccNo(:,1),EOrb(:,1),IndT(:,1))
      call RdVec_HDF5(fileorb_id,'COEIB',nSym,nBas,CMO(:,2),OccNo(:,2),EOrb(:,2),IndT(:,2))
    else
      call RdVec_(FName,Lu_,'COEI',nD-1,nSym,nBas,nOrb,CMO(:,1),CMO(:,2),OccNo(:,1),OccNo(:,2),EOrb(:,1),EOrb(:,2),IndT(:,1), &
                  VTitle,1,iErr,iWFtype)
      IndT(:,2) = IndT(:,1)
    end if
    call VecSort(nSym,nBas,nBas,CMO(:,1),OccNo(:,1),IndT(:,1),0,iDummy,iErr)
    call VecSort(nSym,nBas,nBas,CMO(:,2),OccNo(:,2),IndT(:,2),0,iDummy,iErr)
    indx = 1
    do iSym=1,nSym
      nTmp(iSym) = 0
      do iBas=1,nBas(iSym)
        if (IndT(indx,1) == 7) nTmp(iSym) = nTmp(iSym)+1
        indx = indx+1
      end do
      if (nOrb(iSym) > nBas(iSym)-nTmp(iSym)) then
        nOrb(iSym) = nBas(iSym)-nTmp(iSym)
        nDel(iSym) = nTmp(iSym)
      end if
    end do
    call TrimCMO(CMO(:,1),nSym,nBas,nOrb)
    call TrimCMO(CMO(:,2),nSym,nBas,nOrb)
    call TrimEor(EOrb(:,1),nSym,nBas,nOrb)
    call TrimEor(EOrb(:,2),nSym,nBas,nOrb)
    call Setup_SCF()
  else
    if (isHDF5) then
      call RdVec_HDF5(fileorb_id,'COEI',nSym,nBas,CMO,OccNo,EOrb,IndT)
    else
      call RdVec_(FName,Lu_,'COEI',0,nSym,nBas,nOrb,CMO,Dummy,OccNo,Dummy,EOrb(:,1),Dummy,IndT(:,1),VTitle,1,iErr,iWFtype)
    end if
    call VecSort(nSym,nBas,nBas,CMO,OccNo,IndT(:,1),0,iDummy,iErr)
    indx = 1
    do iSym=1,nSym
      nTmp(iSym) = 0
      do iBas=1,nBas(iSym)
        if (IndT(indx,1) == 7) nTmp(iSym) = nTmp(iSym)+1
        indx = indx+1
      end do
      if (nOrb(iSym) > nBas(iSym)-nTmp(iSym)) then
        nOrb(iSym) = nBas(iSym)-nTmp(iSym)
        nDel(iSym) = nTmp(iSym)
      end if
    end do
    call TrimCMO(CMO(:,1),nSym,nBas,nOrb)
    call TrimEor(EOrb(:,1),nSym,nBas,nOrb)
    call Setup_SCF()
    CMO(1:nBO,2) = CMO(1:nBO,1)
    EOrb(1:nnB,2) = EOrb(1:nnB,1)
    OccNo(1:nnB,1) = Half*OccNo(1:nnB,1)
    OccNo(1:nnB,2) = OccNo(1:nnB,1)
  end if
  if (.not. Aufb) then
    iOff = 0
    do iSym=1,nSym
      OccNo(iOff+1:iOff+nOcc(iSym,1),1) = One
      OccNo(iOff+nOcc(iSym,1)+1:iOff+nOrb(iSym),1) = Zero
      iOff = iOff+nOrb(iSym)
    end do
    iOff = 0
    do iSym=1,nSym
      OccNo(iOff+1:iOff+nOcc(iSym,2),2) = One
      OccNo(iOff+nOcc(iSym,2)+1:iOff+nOrb(iSym),2) = Zero
      iOff = iOff+nOrb(iSym)
    end do
  end if
end if
call mma_deallocate(IndT,safe='*')

if (MSYMON) then
# ifdef _MSYM_
  write(u6,*) 'Symmetrizing start orbitals'
  call fmsym_create_context(msym_ctx)
  call fmsym_set_elements(msym_ctx)
  call fmsym_find_symmetry(msym_ctx)
  do iD=1,nD
    call fmsym_symmetrize_orbitals(msym_ctx,CMO(:,iD))
  end do
# else
  write(u6,*) 'No msym support, skipping symmetrization of start orbitals...'
# endif
end if

do iD=1,nD
  call Ortho(CMO(:,iD),nBO,Ovrlp,nBT)
end do

#ifdef _MSYM_
if (MSYMON) call fmsym_release_context(msym_ctx)
#endif

! Dump orbitals

if (nD == 1) then
  OrbName = 'SCFORB'
  call WrVec_(OrbName,LuOut,'COE',nD-1,nSym,nBas,nBas,CMO,Dummy,OccNo,Dummy,EOrb(:,1),Dummy,iDum,VTitle,iWFtype)
else
  OrbName = 'UHFORB'
  call WrVec_(OrbName,LuOut,'COE',nD-1,nSym,nBas,nBas,CMO(:,1),CMO(:,2),OccNo(:,1),OccNo(:,2),EOrb(:,1),EOrb(:,2),iDum,VTitle, &
              iWFtype)
end if

return

end subroutine Start2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CLagSym(nAshT,DG1,DG2,DF1,DF2,mode)

use Constants, only: Half, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAshT, mode
real(kind=wp), intent(inout) :: DG1(nAshT,nAshT), DG2(nAshT,nAshT,nAshT,nAshT), DF1(nAshT,nAshT), DF2(nAshT,nAshT,nAshT,nAshT)
integer(kind=iwp) :: iI, iJ, iK, iL
real(kind=wp) :: Val

!return
!if (mode == 0) then
do iI=1,nAshT
  do iJ=1,iI-1
    Val = (DG1(iI,iJ)+DG1(iJ,iI))*Half
    DG1(iI,iJ) = Val
    DG1(iJ,iI) = Val
    Val = (DF1(iI,iJ)+DF1(iJ,iI))*Half
    DF1(iI,iJ) = Val
    DF1(iJ,iI) = Val
  end do
end do
!end if

select case (mode)
  case (0)
    !! Follow G2 symmetry
    do iI=1,nAshT
      do iJ=1,nAshT
        do iK=1,nAshT
          do iL=1,nAshT
            Val = (DG2(iI,iJ,iK,iL)+DG2(iJ,iI,iL,iK)+DG2(iK,iL,iI,iJ)+DG2(iL,iK,iJ,iI))*Quart
            DG2(iI,iJ,iK,iL) = Val
            DG2(iJ,iI,iL,iK) = Val
            DG2(iK,iL,iI,iJ) = Val
            DG2(iL,iK,iJ,iI) = Val
            Val = (DF2(iI,iJ,iK,iL)+DF2(iJ,iI,iL,iK)+DF2(iK,iL,iI,iJ)+DF2(iL,iK,iJ,iI))*Quart
            DF2(iI,iJ,iK,iL) = Val
            DF2(iJ,iI,iL,iK) = Val
            DF2(iK,iL,iI,iJ) = Val
            DF2(iL,iK,iJ,iI) = Val
          end do
        end do
      end do
    end do
  case (1)
    !! Follow EtuEyz symmetry
    !do iI=1,nAshT
    !  do iJ=1,nAshT
    !    do iK=1,nAshT
    !      do iL=1,nAshT
    !        Val = (DG2(iI,iJ,iK,iL)+DG2(iL,iK,iJ,iI))*Quart
    !        if ((ii /= il) .and. (ij /= ik)) then
    !          DG2(iI,iJ,iK,iL) = Two*Val
    !          DG2(iL,iK,iJ,iI) = Zero
    !        else
    !          DG2(iI,iJ,iK,iL) = Val
    !          DG2(iL,iK,iJ,iI) = Val
    !        end if
    !        Val = (DF2(iI,iJ,iK,iL)+DF2(iL,iK,iJ,iI))*Quart
    !        if ((ii /= il) .and. (ij /= ik)) then
    !          DF2(iI,iJ,iK,iL) = Two*Val
    !         DF2(iL,iK,iJ,iI) = Zero
    !        else
    !          DF2(iI,iJ,iK,iL) = Val
    !          DF2(iL,iK,iJ,iI) = Val
    !        end if
    !      end do
    !    end do
    !  end do
    !end do
  case (2)
end select

return

end subroutine CLagSym

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Roland Lindh                                     *
!***********************************************************************

subroutine DrvNQ(Kernel,FckInt,nFckDim,Funct,Density,nFckInt,nD,Do_Grad,Grad,nGrad,Do_MO,Do_TwoEl,DFTFOCK,IsFT)
!***********************************************************************
!                                                                      *
!     Predriver for numerical integration utility.                     *
!                                                                      *
!     Author: Roland Lindh,                                            *
!             Dept of Chemical Physics,                                *
!             University of Lund, Sweden                               *
!             December 2001                                            *
!***********************************************************************

use Symmetry_Info, only: nIrrep
use nq_Grid, only: Angular, Coor, F_xc, F_xca, F_xcb, Fact, GradRho, Grid, IndGrd, iTab, kAO, l_CASDFT, Lapl, List_G, Mem, &
                   nGridMax, nR_Eff, nRho, Pax, R2_trial, Rho, Sigma, Tau, Temp, vLapl, vRho, vSigma, vTau, Weights
use nq_pdft, only: lft, lGGA
use nq_MO, only: nMOs, CMO, D1MO, P2MO, P2_ontop
use nq_Structure, only: Close_NQ_Data
use nq_Info, only: Functional_type, GGA_type, LDA_type, LMax_NQ, mBas, meta_GGA_type1, meta_GGA_type2, mIrrep, nAsh, nAtoms, nFro, &
                   number_of_subblocks, Other_type
use Grid_On_Disk, only: Final_Grid, G_S, Grid_Status, GridInfo, iDisk_Grid, iDisk_Set, iGrid_Set, Intermediate, Lu_Grid, &
                        LuGridFile, Old_Functional_Type, Regenerate, Use_Old
use libxc, only: dfunc_dLapl, dfunc_drho, dfunc_dsigma, dfunc_dTau, func
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
external :: Kernel
integer(kind=iwp), intent(in) :: nFckDim, nFckInt, nD, nGrad
real(kind=wp), intent(inout) :: FckInt(nFckInt,nFckDim), Funct, Grad(nGrad)
real(kind=wp), intent(in) :: Density(nFckInt,nD)
logical(kind=iwp), intent(in) :: Do_Grad, Do_TwoEl, IsFT
logical(kind=iwp), intent(inout) :: Do_MO
character(len=4), intent(in) :: DFTFOCK
#include "status.fh"
integer(kind=iwp) :: i, iDum(1), iIrrep, ijIrrep, ijkIrrep, iOrb, iStack, jAsh, jIrrep, kAsh, kIrrep, kl_Orb_pairs, lAsh, mAO, &
                     mdRho_dr, mGrad, nBas(8), nCMO, nD1MO, nDel(8), nGradRho, nLapl, nNQ, nP2, nP2_ontop, nSigma, nTau, NQNAC, &
                     NQNACPAR, NQNACPR2, nShell, nTmpPUVX
real(kind=wp) :: PThr
logical(kind=iwp) :: PMode
integer(kind=iwp), allocatable :: List_Bas(:,:), List_Exp(:), List_P(:), List_s(:,:), Maps2p(:,:)
real(kind=wp), allocatable :: R_Min(:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
lft = IsFT
if (Do_TwoEl) Do_MO = .true.
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate enough memory for Maps2p

call Set_Basis_Mode('Valence')
call Nr_Shells(nShell)
call mma_allocate(Maps2p,nShell,nIrrep,Label='Maps2p')
call mma_allocate(R_Min,LMax_NQ+1,Label='R_Min')

NQ_Status = Inactive
call Setup_NQ(Maps2p,nShell,nIrrep,nNQ,Do_Grad,Do_MO,PThr,PMode,R_Min,LMax_NQ)

call mma_deallocate(R_Min)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate memory sufficiently large to store all grid points
! and associated weights.

call mma_Allocate(Grid,3,nGridMax,Label='Grid')
call mma_Allocate(Weights,nGridMax,Label='Weights')
!                                                                      *
!***********************************************************************
!                                                                      *
! CASDFT stuff:
!
! Note, l_CASDFT=.True. implies that both Do_MO and Do_Twoel are true.

nTmpPUVX = 1

NQNAC = 0
if (l_casdft) call Get_iArray('nAsh',nAsh,mIrrep)
if ((DFTFOCK /= 'SCF ') .or. l_CASDFT) then
  do iIrrep=0,mIrrep-1
    NQNAC = NQNAC+nAsh(iIrrep)
  end do
end if
NQNACPAR = (NQNAC**2+NQNAC)/2
NQNACPR2 = (NQNACPAR**2+NQNACPAR)/2

LuGridFile = 31
LuGridFile = IsFreeUnit(LuGridFile)
call Molcas_Open(LuGridFile,'GRIDFILE')

#ifdef _DEBUGPRINT_
write(u6,*) 'l_casdft value at drvnq:',l_casdft
if (l_casdft) write(u6,*) 'MCPDFT with functional:',KSDFA
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     Definition of resources needed for the functionals.              *
!                                                                      *
!     mAO: the number of derivatives needed of an basis function.      *
!          Depending of the functional type and if gradients will be   *
!          computed. Numbers will be 1, 4, 10, 20, 35, etc.            *
!     nRho:the number of parameters of the functional. Note that this  *
!          is different for the same functional depending on if it is  *
!          a closed or open-shell case.                                *
!     mdRho_dR: number of derivatives of the parameters with respect   *
!          to the nuclear coordinates. The true number is of course    *
!          three (x,y,z) times this.                                   *
!     nF_drho: the number of derivatives of the functional wrt the     *
!          parameters. Note that grad rho is not a direct parameter    *
!          but that we use gamma.                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
select case (Functional_type)

  case (LDA_type)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! We need the AOs, for gradients we need the derivatives too.

    mAO = 1
    kAO = mAO
    if (Do_Grad) mAO = 4

    ! We need rho.
    ! For gradients we need derivatives of rho wrt the coordinates

    nRho = nD
    mdRho_dr = 0
    if (Do_Grad) mdRho_dr = nD
    nSigma = 0
    nGradRho = 0
    nLapl = 0
    nTau = 0

    ! We need derivatives of the functional with respect to
    ! rho(alpha). In case of open-shell calculations we also
    ! need rho(beta).

    nP2_ontop = 1
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  case (GGA_type)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! We need the AOs and their derivatives, for  gradients we need
    ! the second derivatives too.

    mAO = 4
    kAO = mAO
    if (Do_Grad) mAO = 10

    ! We need rho and grad rho
    ! For gradients we need the derrivatives wrt the coordinates

    nRho = nD
    nSigma = nD*(nD+1)/2
    nGradRho = nD*3
    nLapl = 0
    nTau = 0
    mdRho_dR = 0
    if (Do_Grad) mdRho_dR = 4*nD

    ! We need derivatives of the functional with respect to
    ! rho(alpha), gamma(alpha,alpha) and gamma(alpha,beta).
    ! In case of open-shell calculations we also
    ! need rho(beta) and gamma(beta,beta).

    nP2_ontop = 4
    lGGA = .true.
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  case (meta_GGA_type1)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! We need the AOs and their derivatives, for  gradients we need
    ! the second derivatives too.

    mAO = 4
    kAO = mAO
    if (Do_Grad) mAO = 10

    ! We need rho, grad rho and tau.
    ! For gradients we need the derrivatives wrt the coordinates

    nRho = nD
    nSigma = nD*(nD+1)/2
    nGradRho = nD*3
    !nLapl = 0
    nLapl = nD
    nTau = nD
    mdRho_dR = 0
    if (Do_Grad) mdRho_dR = 5*nD

    ! We need derivatives of the functional with respect to
    ! rho(alpha), gamma(alpha,alpha), gamma(alpha,beta) and
    ! tau(alpha). In case of open-shell calculations we also
    ! need rho(beta), gamma(beta,beta) and tau(beta).

    nP2_ontop = 4
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  case (meta_GGA_type2)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! We need the AOs and their 1st and 2nd derivatives, for
    ! gradients we need the 3rd order derivatives too.

    mAO = 10
    kAO = mAO
    if (Do_Grad) mAO = 20

    ! We need rho, grad rho, tau, and the Laplacian
    ! For gradients we need the derrivatives wrt the coordinates

    nRho = nD
    nSigma = nD*(nD+1)/2
    nGradRho = nD*3
    nLapl = nD
    nTau = nD
    mdRho_dR = 0
    if (Do_Grad) mdRho_dR = 6*nD

    ! We need derivatives of the functional with respect to
    ! rho(alpha), gamma(alpha,alpha), gamma(alpha,beta),
    ! tau(alpha) and laplacian(alpha). In case of open-shell
    ! calculations we also need rho(beta), gamma(beta,beta),
    ! tau(beta) and laplacian(beta).

    nP2_ontop = 4
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  case default
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    Functional_type = Other_type
    call WarningMessage(2,'DrvNQ: Invalid Functional_type!')
    call Abend()
    nRho = 0
    nSigma = 0
    nGradRho = 0
    nLapl = 0
    nTau = 0
    !                                                                  *
    !*******************************************************************
    !                                                                  *
end select
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(Rho,nRho,nGridMax,Label='Rho')
call mma_allocate(vRho,nRho,nGridMax,Label='vRho')
call mma_allocate(dfunc_drho,nRho,nGridMax,Label='dfunc_drho')
if (nSigma /= 0) then
  call mma_Allocate(Sigma,nSigma,nGridMax,Label='Sigma')
  call mma_Allocate(vSigma,nSigma,nGridMax,Label='vSigma')
  call mma_Allocate(dfunc_dSigma,nSigma,nGridMax,Label='dfunc_dSigma')
end if
if (nGradRho /= 0) then
  call mma_Allocate(GradRho,nGradRho,nGridMax,Label='GradRho')
end if
if (nTau /= 0) then
  call mma_allocate(Tau,nTau,nGridMax,Label='Tau')
  call mma_allocate(vTau,nTau,nGridMax,Label='vTau')
  call mma_allocate(dfunc_dTau,nTau,nGridMax,Label='dfunc_dTau')
  Tau(:,:) = Zero
end if
if (nLapl /= 0) then
  call mma_allocate(Lapl,nLapl,nGridMax,Label='Lapl')
  call mma_allocate(vLapl,nLapl,nGridMax,Label='vLapl')
  call mma_allocate(dfunc_dLapl,nLapl,nGridMax,Label='dfunc_dLapl')
  Lapl(:,:) = Zero
end if

call mma_allocate(F_xc,nGridMax,Label='F_xc')
call mma_allocate(func,nGridMax,Label='func')
if (l_casdft) then
  call mma_allocate(F_xca,nGridMax,Label='F_xca')
  call mma_allocate(F_xcb,nGridMax,Label='F_xcb')
end if

call mma_allocate(List_S,2,nIrrep*nShell,Label='List_S')
call mma_allocate(List_Exp,nIrrep*nShell,Label='List_Exp')
call mma_allocate(List_Bas,2,nIrrep*nShell,Label='List_Bas')
call mma_allocate(List_P,nNQ,Label='List_P')
call mma_allocate(R2_trial,nNQ,Label='R2_trial')

if (Do_MO) then
  if (NQNAC /= 0) then
    nD1MO = NQNACPAR
    call mma_allocate(D1MO,nD1MO,Label='D1MO')
    call Get_D1MO(D1MO,nD1MO)
    nP2 = NQNACPR2
    call mma_Allocate(P2MO,nP2,Label='P2MO')
    call Get_P2mo(P2MO,nP2)
  end if
  call Get_iArray('nBas',nBas,mIrrep)
  call Get_iArray('nDel',nDel,mIrrep)
  nCMO = 0
  do i=1,mIrrep
    nCMO = nCMO+nBas(i)*(nBas(i)-nDel(i))
  end do
  call mma_allocate(CMO,nCMO,Label='CMO')
  call Get_CMO(CMO,nCMO)
  call Get_iArray('nAsh',nAsh,mIrrep)
  nMOs = 0
  do iIrrep=0,mIrrep-1
    nMOs = nMOs+mBas(iIrrep)
  end do
end if

! Prepare memory for two-electron integrals:
! nPUVX

if (Do_TwoEl) then
  if (.not. Do_MO) then
    call WarningMessage(2,' Can''t produce 2 el dft integrals without MO')
    call Abend()
  end if

  iStack = 0
  do iIrrep=0,mIrrep-1
    iOrb = mBas(iIrrep)-nFro(iIrrep)
    do jIrrep=0,mIrrep-1
      jAsh = nAsh(jIrrep)
      ijIrrep = ieor(iIrrep,jIrrep)
      do kIrrep=0,mIrrep-1
        kAsh = nAsh(kIrrep)
        ijkIrrep = ieor(ijIrrep,kIrrep)
        if (ijkIrrep <= kIrrep) then
          lAsh = nAsh(ijkIrrep)
          kl_Orb_pairs = kAsh*lAsh
          if (kIrrep == ijkIrrep) kl_Orb_pairs = (kAsh*kAsh+kAsh)/2
          iStack = iStack+iOrb*jAsh*kl_Orb_pairs
        end if
      end do
    end do
  end do
  nTmpPUVX = iStack

end if

if (Do_Grad) then
  call mma_allocate(List_g,3,nShell*nIrrep,Label='List_G')
  mGrad = 3*nAtoms
  call mma_allocate(IndGrd,mGrad,Label='IndGrd')
  call mma_allocate(iTab,4,mGrad,Label='iTab')
  call mma_allocate(Temp,mGrad,Label='Temp')
end if

if (.not. Do_Grad) FckInt(:,:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'l_casdft value at drvnq:',l_casdft
if (l_casdft) write(u6,*) 'MCPDFT with functional:',KSDFA
#endif

if (l_casdft) then
  call mma_allocate(P2_ontop,nP2_ontop,nGridMax,Label='P2_ontop')
  P2_ontop(:,:) = Zero
end if

call DrvNQ_Inner(Kernel,Funct,Maps2p,nIrrep,List_S,List_Exp,List_bas,nShell,List_P,nNQ,FckInt,nFckDim,Density,nFckInt,nD,nGridMax, &
                 nP2_ontop,Do_Mo,nTmpPUVX,Do_Grad,Grad,nGrad,mAO,mdRho_dR)
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate the memory

call mma_deallocate(Pax)
if (Do_Grad) then
  call mma_deallocate(Temp)
  call mma_deallocate(iTab)
  call mma_deallocate(IndGrd)
  call mma_deallocate(List_G)
end if
call mma_deallocate(R2_trial)
call mma_deallocate(List_P)
call mma_deallocate(List_Bas)
call mma_deallocate(List_Exp)
call mma_deallocate(List_S)
! Do_TwoEl
if (allocated(D1MO)) call mma_deallocate(D1MO)
if (allocated(P2MO)) call mma_deallocate(P2MO)
if (allocated(CMO)) call mma_deallocate(CMO)
if (l_casdft) then
  call mma_deallocate(F_xcb)
  call mma_deallocate(F_xca)
end if
call mma_deallocate(func)
call mma_deallocate(F_xc)
!
if (allocated(Lapl)) then
  call mma_deallocate(dfunc_dLapl)
  call mma_deallocate(vLapl)
  call mma_deallocate(Lapl)
end if
if (allocated(Tau)) then
  call mma_deallocate(dfunc_dTau)
  call mma_deallocate(vTau)
  call mma_deallocate(Tau)
end if
if (allocated(GradRho)) call mma_deallocate(GradRho)
if (allocated(Sigma)) then
  call mma_deallocate(dfunc_dSigma)
  call mma_deallocate(vSigma)
  call mma_deallocate(Sigma)
end if
call mma_deallocate(dfunc_dRho)
call mma_deallocate(vRho)
call mma_deallocate(Rho)

call mma_deallocate(Weights)
call mma_deallocate(Grid)

#ifdef _DEBUGPRINT_
write(u6,*) 'l_casdft value at drvnq:',l_casdft
if (l_casdft) write(u6,*) 'MCPDFT with functional:',KSDFA
#endif
if (allocated(P2_ontop)) call mma_deallocate(P2_ontop)

call mma_deallocate(nR_Eff)
call mma_deallocate(Coor)

call Close_NQ_Data()
call mma_deallocate(Mem)
call mma_deallocate(Angular)
call mma_deallocate(Fact)
call mma_deallocate(Maps2p)
NQ_Status = Inactive
!                                                                      *
!***********************************************************************
!                                                                      *
! Write the status flag and TOC.

if ((iGrid_Set == Intermediate) .and. (Grid_Status == Regenerate)) iDisk_Set(Final_Grid) = iDisk_Grid
if (Do_Grad) then
  G_S(iGrid_Set) = Regenerate
else
  G_S(iGrid_Set) = Use_Old
end if

iDisk_Grid = 0
call iDaFile(Lu_Grid,1,G_S,2,iDisk_Grid)
call iDaFile(Lu_Grid,1,iDisk_Set,2,iDisk_Grid)
iDum(1) = Old_Functional_Type
call iDaFile(Lu_Grid,1,iDum,1,iDisk_Grid)
iDisk_Grid = iDisk_Set(iGrid_Set)
call iDaFile(Lu_Grid,1,GridInfo,2*number_of_subblocks,iDisk_Grid)

call DaClos(Lu_Grid)

call mma_deallocate(GridInfo)
!                                                                      *
!***********************************************************************
!                                                                      *
call IniPkR8(PThr,PMode)

call xFlush(LuGridFile)
close(LuGridFile)

return

end subroutine DrvNQ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CleanDiagonal(iAtomPair)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: zero negative diagonals for atom pair iAtomPair.
C              If any diagonal is too negative, execution is stopped!
C
      Implicit None
      Integer iAtomPair
#include "localdf.fh"
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_AtomPair_DiagDim
      External LDF_AtomPair_DiagDim

      Integer ip_D, nuv, uv
#if defined (_DEBUGPRINT_)
      Integer nClean
#endif

#if defined (_DEBUGPRINT_)
      Write(6,'(A,A,I9)')
     & 'LDF_CleanDiagonal: zeroing negative diagonals for ',
     & 'atom pair',iAtomPair
      Call xFlush(6)
      nClean=0
#endif

      nuv=LDF_AtomPair_DiagDim(iAtomPair)
      ip_D=iWork(ip_AP_Diag-1+iAtomPair)-1
      Do uv=1,nuv
         If (Work(ip_D+uv).lt.0.0d0) Then
            If (Work(ip_D+uv).lt.TooNegative) Then
               Call WarningMessage(2,
     &                      'LDF_CleanDiagonal: too negative diagonal!')
               Write(6,'(A,I9)') 'Atom Pair:',iAtomPair
               Write(6,'(A,I9,1X,1P,D15.6)')
     &         'Diagonal element (no. and value):',uv,Work(ip_D+uv)
               Write(6,'(A,1P,D15.6,A)')
     &         '(Too negative diagonals are those <',TooNegative,')'
               Call LDF_Quit(1)
            End If
            Work(ip_D+uv)=0.0d0
#if defined (_DEBUGPRINT_)
            nClean=nClean+1
#endif
         End If
      End Do

#if defined (_DEBUGPRINT_)
      Write(6,'(A,I9,A)')
     & '   - zeroed ',nClean,' diagonals.'
      Call xFlush(6)
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Jeppe Olsen                                      *
!               2011, Giovanni Li Manni                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADDDIA_TERMS(NAEL,IASTR,NBEL,IBSTR,NORB,CVEC,SVEC,NSMST,H,XB,RJ,RK,NSSOA,NSSOB,ECORE,NTOOB,RJKAA,IASPGP,IASM,IBSPGP, &
                        IBSM,FACTOR)
! Update Sigma vector with diagonal terms for a given block
!     SVEC(IASPGP,IBSPGP) = SVEC(IASPGP,IBSPGP)
!                         + FACTOR*DIAG(IASPGP,IBSPGP)CVEC(IASPGP,IBSPGP)
! ========================
! General symmetry version
! ========================
!
! Jeppe Olsen and Giovanni Li Manni, September 2011
!
! I12 = 1 => only one-body part
!     = 2 =>      one+two-body part

use Constants, only: Zero, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NAEL, NBEL, NORB, NSMST, NSSOA(NSMST,*), NSSOB(NSMST,*), NTOOB, IASPGP, IASM, IBSPGP, IBSM
integer(kind=iwp), intent(inout) :: IASTR(NAEL,*), IBSTR(NBEL,*)
real(kind=wp), intent(in) :: CVEC(*), H(NORB), RJ(NTOOB,NTOOB), ECORE, FACTOR
real(kind=wp), intent(inout) :: SVEC(*), RK(NTOOB,NTOOB)
real(kind=wp), intent(out) :: XB(NORB)
real(kind=wp), intent(_OUT_) :: RJKAA(*)
integer(kind=iwp) :: I12, IA, IAEL, IB, IBEL, IDET, IDUM(1), IEL, JEL, NASTR1, NBSTR1, NIA, NIB
real(kind=wp) :: EAA, EB, HB, RJBB, X

IDUM(1) = 0
I12 = 2
!if (LUIN > 0) rewind(LUIN)
!if (LUOUT > 0) rewind(LUOUT)

#ifdef _DEBUGPRINT_
write(u6,*) ' ======================'
write(u6,*) ' ADDDIA_TERMS in action'
write(u6,*) ' ======================'
write(u6,*)
write(u6,*) ' IASM, IASPGP, IBSM, IBSPGP = ',IASM,IASPGP,IBSM,IBSPGP

write(u6,*) ' Diagonal one electron integrals'
call WRTMAT(H,1,NORB,1,NORB)
if (I12 == 2) then
  write(u6,*) ' Coulomb and exchange integrals'
  call WRTMAT(RJ,NORB,NORB,NTOOB,NTOOB)
  write(u6,*)
  call WRTMAT(RK,NORB,NORB,NTOOB,NTOOB)
end if
write(u6,*) ' FACTOR = ',FACTOR
#endif

!*3 Diagonal elements according to Handys formulae
!   (corrected for error)
!
!   DIAG(IDET) = HII*(NIA+NIB)
!              + 0.5 * ( J(I,J)-K(I,J) ) * N(I,A)*N(J,A)
!              + 0.5 * ( J(I,J)-K(I,J) ) * N(I,B)*N(J,B)
!              +         J(I,J) * N(I,A)*N(J,B)
! N(X) are occupation numbers

! K goes to J - K
if (I12 == 2) RK(:,:) = RJ(:,:)-RK(:,:)

! Construct array RJKAA(*) =   SUM(I) H(I)*N(I) +
!                          0.5*SUM(I,J) (J(I,J) - K(I,J))*N(I)*N(J)
!
! Obtain alpha strings of sym IASM and type IASPGP
call GETSTR_TOTSM_SPGP(1,IASPGP,IASM,NAEL,NASTR1,IASTR,NORB,0,IDUM,IDUM)

NIA = NSSOA(IASM,IASPGP)

#ifdef _DEBUGPRINT_
write(u6,*) ' After GETSTR for A strings'
write(u6,*) ' alpha strings obtained'
call IWRTMA(IASTR,NAEL,NIA,NAEL,NIA)
#endif

do IA=1,NIA
  EAA = Zero
  do IEL=1,NAEL
    IAEL = IASTR(IEL,IA)
    EAA = EAA+H(IAEL)
    if (I12 == 2) then
      do JEL=1,NAEL
        EAA = EAA+Half*RK(IASTR(JEL,IA),IAEL)
      end do
    end if
  end do
  RJKAA(IA) = EAA
end do
! Obtain alpha strings of sym IBSM and type IBTP
call GETSTR_TOTSM_SPGP(2,IBSPGP,IBSM,NBEL,NBSTR1,IBSTR,NORB,0,IDUM,IDUM)
NIB = NSSOB(IBSM,IBSPGP)
IDET = 0
do IB=1,NIB
  ! Terms depending only on IB
  HB = Zero
  RJBB = Zero
  XB(:) = Zero

  do IEL=1,NBEL
    IBEL = IBSTR(IEL,IB)
    HB = HB+H(IBEL)

    if (I12 == 2) then
      do JEL=1,NBEL
        RJBB = RJBB+RK(IBSTR(JEL,IB),IBEL)
      end do

      XB(:) = XB(:)+RJ(1:NORB,IBEL)
    end if
  end do

  EB = HB+Half*RJBB+ECORE
  do IA=1,NSSOA(IASM,IASPGP)
    IDET = IDET+1
    X = EB+RJKAA(IA)
    do IEL=1,NAEL
      X = X+XB(IASTR(IEL,IA))
    end do
    SVEC(IDET) = SVEC(IDET)+CVEC(IDET)*(X+FACTOR)
  end do ! IA
end do ! IB

#ifdef _DEBUGPRINT_
write(u6,*) ' Input and output vectord, ADDDIA_TERMS'
call WRTMAT(CVEC,1,IDET,1,IDET)
call WRTMAT(SVEC,1,IDET,1,IDET)
#endif

end subroutine ADDDIA_TERMS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function JSUNP(INTSYM,L)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: JSUNP
integer(kind=iwp), intent(in) :: INTSYM(*), L
integer(kind=iwp) :: I, J

! L = (I-1)*10 + J+1  [ J = 0-9 ]
I = (L+9)/10
J = mod(L-1,10)
JSUNP = 1+ibits(INTSYM(I),27-3*J,3)

return

end function JSUNP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine getmoblk_cvb(cmoblk,ic2)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "mo_cvb.fh"
#include "io_cvb.fh"
#include "idbl_cvb.fh"
      dimension cmoblk(nbasisq_mo)
      dimension iadr15(15)

      call mkfn_cvb(strtmo,ibf)
      lujob=15
      call daname_cvb(lujob,filename(ibf))
      iad=0
      Call iDaFile(lujob,2,iadr15,15,iad)
      iad=iadr15(2)
      Call dDaFile(lujob,2,cmoblk,nbasisq_mo,iad)
      call daclos_cvb(lujob)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(ic2)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine reainput()
! this routine does:
! 1) read INPDAT file, produced by REORG with mul,nsym,noa,nob,nva,nvb,norb,eps
! 2) read input file for CCSD to read (parameters transported through cmm common)
! title   - jobtitle
!   1-ntit rows with 72 characters
!   no default
! ntit    - number of rows in jobtitle
!   ntit is limited to 10 !!! NOT ANY MORE !!! ntit is limited to 1
!   default (1)
! maxiter - maximum number of iterations
!   default (10)
! typt3   - type of T3 cpntribution
!   0 - CCSD
!   1 - CCSD+T(CCSD)
!   2 - CCSD(T)
!   default (0)
! typden  - type of denominator (division of fok)
!   0 - diagonal elements
!   1 - average of faa and fbb
!   2 - orbital energies
!   default (0)
! firstext- first iteration wnere extrapolation is used
!   (default-no) less than cycext is not possible
! cycext  - cycle of extrapolation
!   (default-no) limited to 2-4
! ccnonv  - energy convergence criterion
!   (default=1.0e-6)
! keysa   - Spin adaptation key
!   0 - no adaptation
!   1 - T2 DDVV adaptation
!   2 - T2 DDVV + T1 DV adaptation
!   3 - full T1 and T2 adaptation (only for doublets)
!   4 - full T2 adaptation without SDVS (only for doublets)
!   (default=0)
! keyrst  - restart key
!   0 - no saving restart informations (amplitudes)
!   1 - save amplitudes
!   2 - start from previous informations
!   (default=1)
! filerst - name for restart informations file
!   (default=RSTART)
! mchntyp - type of machine in matrix multiplication
!   1 - C=A*B is faster or comparable with C=AT*B
!   2 - C=AT*B is faster
! (default=1)
! slim    - limitation for usieng C=AT*B
!   no default (suitable=2.0)
! shifhto - shift for occupied
!   (default=0.0)
! shifhtv - shift for virtuals
!   (default=0.0)
! maxspace - maximal allowed work space
!   (default=0 - unlimited)
! fullprint - level of printing contrlo key
!   (default=0)
! noop  - no operation key
!   (default=no)
! iokey - I/O control key
!   1 - Fortran I/O system
!   2 - MOLCAS DA IO system
!   (default=2)
! mhkey - Matrix handling control key
!   1 - ESSL routines
!   2 - Fortran I/O system
! noccsd - key to supress CCSD run
!   (default=no)c     (default=1)
! .....  - can be added

use ccsd_global, only: ccconv, cycext, dimm, eps, Escf, filerst, firstext, fullprint, iokey, ispin, keyrst, keysa, lsym, maxiter, &
                       maxorb, maxspace, mchntyp, mhkey, mmul, nactel, noa, nob, noccsd, noop, norb, nshf, nsym, ntit, nva, nvb, &
                       slim, shifto, shiftv, title, typden, typt3, yesext
use spool, only: SpoolInp, Close_LuSpool
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: f_iostat, f_recl, LuSpool, nhelp
character(len=80) :: LINE
logical(kind=iwp) :: is_error

!1 read INPDAT

call molcas_open_ext2(1,'INPDAT','sequential','unformatted',f_iostat,.false.,f_recl,'unknown',is_error)
!open(unit=1,file='INPDAT',form='unformatted')
read(1) nactel,ispin,nsym,lsym,mmul,noa,nob,nva,nvb,norb,eps,Escf
close(1)

!2 def dimm

dimm(1,1:nsym) = noa(1:nsym)
dimm(2,1:nsym) = nob(1:nsym)
dimm(3,1:nsym) = nva(1:nsym)
dimm(4,1:nsym) = nvb(1:nsym)
dimm(5,1:nsym) = norb(1:nsym)

!3 define nshf

do nhelp=1,maxorb
  nshf(nhelp) = (nhelp-1)*(nhelp-2)/2
end do

!4 define defaults

maxiter = 30
typt3 = 0
ntit = 1
typden = 0
yesext = 0
firstext = 0
cycext = 0
ccconv = 1.0e-7_wp
keysa = 0
keyrst = 1
filerst = 'RSTART'
mchntyp = 1
slim = One
shifto = Zero
shiftv = Zero
maxspace = 0
!GG fullprint = 0
noop = 0
iokey = 1
mhkey = 1
noccsd = 0

!5 read input file

LuSpool = 17
call SpoolInp(LuSpool)
rewind(LuSpool)
do
  read(LuSpool,'(A80)') LINE
  call UPCASE(LINE)
  if (index(LINE,'&CCSDT') /= 0) exit
end do
TITLE = ' '
do
  read(LuSpool,'(A80)') LINE
  if (LINE(1:1) == '*') cycle
  call UPCASE(LINE)

  if (LINE(1:4) == 'TITL') then
    read(LuSpool,'(A72)') TITLE
  else if (LINE(1:4) == 'ITER') then
    read(LuSpool,*) maxiter
  else if (LINE(1:4) == 'DENO') then
    read(LuSpool,*) typden
    if ((typden < 0) .or. (typden > 2)) then
      typden = 2
      if (fullprint >= 0) then
        write(u6,*) ' Warning!!!, Invalid type of denominators'
        write(u6,*) ' parameter typden changed to 2'
      end if
    end if
  else if (LINE(1:4) == 'EXTR') then
    yesext = 1
    read(LuSpool,*) firstext,cycext
    if ((cycext < 2) .or. (cycext > 4)) then
      cycext = 4
      if (fullprint >= 0) then
        write(u6,*) ' Warning!!!, Size of DIIS procedure out of range'
        write(u6,*) ' parameter cycext changed to 4'
      end if
    end if
    if (firstext < cycext) then
      firstext = cycext
      if (fullprint >= 0) then
        write(u6,*) ' Warning!!!, First DIIS iteration is smaller then DIIS size'
        write(u6,*) ' parameter firstext was changed to:',firstext
      end if
    end if
  else if (LINE(1:4) == 'ACCU') then
    read(LuSpool,*) ccconv
  else if (LINE(1:4) == 'ADAP') then
    read(LuSpool,*) keysa
    if ((keysa > 4) .or. (keysa < 0)) then
      keysa = 0
      if (fullprint >= 0) then
        write(u6,*) ' Warning!!!, Adaptation key out of range'
        write(u6,*) ' parameter keysa changed to 0'
      end if
    end if
    if ((keysa /= 0) .and. (typden == 0)) then
      typden = 2
      if (fullprint >= 0) then
        write(u6,*) ' Warning!!!, typden is incompatible with SA'
        write(u6,*) ' type of denominators changed to 2 - Orb. energies'
      end if
    end if
  else if (LINE(1:4) == 'REST') then
    read(LuSpool,*) keyrst
    if ((keyrst < 0) .or. (keyrst > 2)) then
      keyrst = 1
      if (fullprint >= 0) then
        write(u6,*) ' Warning!!!, Restart key out of range'
        write(u6,*) ' parameter keyrst changed to 1'
      end if
    end if
    read(LuSpool,*) filerst
  else if (LINE(1:4) == 'MACH') then
    read(LuSpool,*) mchntyp,slim
    if ((mchntyp < 1) .or. (mchntyp > 2)) then
      mchntyp = 1
      if (fullprint >= 0) then
        write(u6,*) ' Warning!!!, Machinetype out of range'
        write(u6,*) ' parameter mchtyp changed to 1'
      end if
    end if
  else if (LINE(1:4) == 'SHIF') then
    read(LuSpool,*) shifto,shiftv
  else if (LINE(1:4) == 'PRIN') then
    read(LuSpool,*) fullprint
    if ((fullprint < 0) .or. (fullprint > 3)) then
      fullprint = 0
      write(u6,*) ' Warning!!!, Printing key out of range'
      write(u6,*) ' parameter fullprint changed to 0'
    end if
  else if (LINE(1:4) == 'NOOP') then
    noop = 1
  else if (LINE(1:4) == 'IOKE') then
    read(LuSpool,*) iokey
    if ((iokey < 0) .or. (iokey > 2)) then
      iokey = 2
      if (fullprint >= 0) then
        write(u6,*) ' Warning!!!, I/O key out of range'
        write(u6,*) ' parameter iokey changed to 2'
      end if
    end if
  else if (LINE(1:4) == 'MHKE') then
    read(LuSpool,*) mhkey
    if ((mhkey < 0) .or. (mhkey > 2)) then
      mhkey = 1
      if (fullprint >= 0) then
        write(u6,*) ' Warning!!!, Matrix handling key out of range'
        write(u6,*) ' parameter mhkey changed to 1'
      end if
    end if
  else if (LINE(1:4) == 'NOSD') then
    noccsd = 1
  else if (LINE(1:4) == 'END ') then
    exit
  end if
end do

call Close_LuSpool(LuSpool)

return

end subroutine reainput

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine vbgenabdet_cvb(idetavb,idetbvb,iconfs,nconf,nconfion,ndetvb,nel,noe,nalf,nbet,norb)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nconf, noe, iconfs(noe,nconf), nel, nconfion(0:nel), ndetvb, nalf, nbet, norb
integer(kind=iwp), intent(out) :: idetavb(ndetvb), idetbvb(ndetvb)
integer(kind=iwp) :: i, iaind, iaocc, ibind, ibocc, iconf, incr, incrdet, indx, ioff_nconf, ion, iorb, nalfsing, nbetsing, &
                     nelsing, nstring
integer(kind=iwp), allocatable :: astr(:,:), bstr(:,:), iaccm(:), inewocc(:), maxgrph(:), mingrph(:), xalf(:,:), xbet(:,:)
logical(kind=iwp), parameter :: debug = .false.
integer(kind=iwp), external :: indget_cvb

call mma_allocate(xalf,[0,norb],[0,nalf],label='xalf')
call mma_allocate(xbet,[0,norb],[0,nbet],label='xbet')
call mma_allocate(mingrph,[0,norb],label='mingrph')
call mma_allocate(maxgrph,[0,norb],label='maxgrph')

! Set xalf and xbet for indget:
do iorb=0,norb
  mingrph(iorb) = max(iorb-norb+nalf,0)
  maxgrph(iorb) = min(iorb,nalf)
end do
call weight_cvb(xalf,mingrph,maxgrph,nalf,norb)
do iorb=0,norb
  mingrph(iorb) = max(iorb-norb+nbet,0)
  maxgrph(iorb) = min(iorb,nbet)
end do
call weight_cvb(xbet,mingrph,maxgrph,nbet,norb)

call mma_deallocate(mingrph)
call mma_deallocate(maxgrph)
call mma_allocate(inewocc,norb,label='inewocc')
call mma_allocate(iaccm,norb,label='iaccm')

! Transformation matrix VB structures  <->  determinants
incrdet = 0
ioff_nconf = 0
do ion=0,nel/2
  nelsing = nel-2*ion
  nalfsing = nalf-ion
  nbetsing = nbet-ion
  ! Skip if configurations are incompatible with Ms:
  if ((nalfsing >= 0) .and. (nbetsing >= 0) .and. (nelsing >= 0)) then

    ! Generate alpha/beta strings for singly occupied electrons:
    call icomb_cvb(nelsing,nalfsing,nstring)
    call mma_allocate(astr,nalfsing,nstring,label='astr')
    call mma_allocate(bstr,nbetsing,nstring,label='bstr')
    call stringen_cvb(nelsing,nalfsing,astr,bstr)
    if (debug) then
      write(u6,*) ' ionicity=',ion,' nconf=',nconfion(ion)
      write(u6,*) ' check alpha strings :'
      do i=1,nstring
        write(u6,*) i,' => ',astr(:,i)
      end do
      write(u6,*) ' check beta strings :'
      do i=1,nstring
        write(u6,*) i,' => ',bstr(:,i)
      end do
    end if

    do iconf=ioff_nconf+1,ioff_nconf+nconfion(ion)
      inewocc(:) = iconfs(1:norb,iconf)
      incr = 0
      do iorb=1,norb
        if (inewocc(iorb) == 1) then
          incr = incr+1
          iaccm(incr) = iorb
        end if
        inewocc(iorb) = max(0,inewocc(iorb)-1)
      end do

      ! Spin string loop:
      do indx=1,nstring

        ! Alpha index in full string space ...
        do i=1,nalfsing
          iaocc = iaccm(astr(i,indx))
          inewocc(iaocc) = inewocc(iaocc)+1
        end do
        iaind = indget_cvb(inewocc,nalf,norb,xalf)
        do i=1,nalfsing
          iaocc = iaccm(astr(i,indx))
          inewocc(iaocc) = inewocc(iaocc)-1
        end do

        ! Beta index in full string space ...
        do i=1,nbetsing
          ibocc = iaccm(bstr(i,indx))
          inewocc(ibocc) = inewocc(ibocc)+1
        end do
        ibind = indget_cvb(inewocc,nbet,norb,xbet)
        do i=1,nbetsing
          ibocc = iaccm(bstr(i,indx))
          inewocc(ibocc) = inewocc(ibocc)-1
        end do

        incrdet = incrdet+1
        idetavb(incrdet) = iaind
        idetbvb(incrdet) = ibind
      end do
    end do
    call mma_deallocate(astr)
    call mma_deallocate(bstr)
  end if
  ioff_nconf = ioff_nconf+nconfion(ion)
end do
if (debug) then
  write(u6,*) ' idetavb='
  write(u6,'(10i6)') idetavb
  write(u6,*) ' idetbvb='
  write(u6,'(10i6)') idetbvb
end if

call mma_deallocate(xalf)
call mma_deallocate(xbet)
call mma_deallocate(inewocc)
call mma_deallocate(iaccm)

return

end subroutine vbgenabdet_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!***********************************************************************
! Integer Function RsvTsk(igaTsk,iTskLs,nTsk,iStart)                   *
!  -> reserve a task for my node and mark it on the global task list   *
!     as reserved.                                                     *
!     igaTsk:   global array handle to global task list                *
!     iTskLs:   my private task list (my favourite sequence of tasks)  *
!     nTsk:     # of tasks                                             *
!     iStart:   starting value of index of private task list           *
!***********************************************************************

function RsvTsk(igaTsk,iTskLs,nTsk,mTsk,iStart,iS,iE)

#ifdef _MOLCAS_MPP_
#ifdef _GA_
use GA_Wrapper, only: GA_Read_Inc
#else
use stdalloc, only: mma_allocate, mma_deallocate
#endif
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: RsvTsk
integer(kind=iwp), intent(in) :: igaTsk, nTsk, mTsk
integer(kind=iwp), intent(inout) :: iTskLs(nTsk,2), iStart, iS, iE
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iCnt, iTsk
logical(kind=iwp) :: Reserved
#ifndef _GA_
integer(kind=iwp), allocatable :: TSKR(:)
#endif

if (iStart > mTsk) then
  iTsk = 0
  iCnt = nTsk
else
# ifndef _GA_
  call mma_allocate(TSKR,mTsk,Label='TSKR')
  call ga_readb_inc(igaTsk,mTsk,iTskLs(iStart,1),TSKR)
# endif
  do iCnt=iStart,mTsk
    iTsk = iTskLs(iCnt,1)
    ! try to reserve iTsk on global task list...
#   ifdef _GA_
    Reserved = ga_read_inc(igaTsk,iTsk,1,1) /= 0
#   else
    Reserved = TSKR(1+iCnt-iStart) /= 0
#   endif
    if (Reserved) then
      iE = iE-1
      iTskLs(iE,2) = iTsk
    else
      iS = iS+1
      iTskLs(iS,2) = iTsk
      exit
    end if
  end do
  if (iCnt > mTsk) iTsk = 0
# ifndef _GA_
  call mma_deallocate(TSKR)
# endif
end if
RsvTsk = iTsk
iStart = iCnt

#else

#include "macros.fh"
unused_var(igaTsk)
unused_var(iTskLs)
unused_var(mTsk)
unused_var(iS)
unused_var(iE)

RsvTsk = 0
iStart = nTsk

#endif

end function RsvTsk

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Giovanni Li Manni                                *
************************************************************************
      SUBROUTINE NEXT_SYM_DISTR_NEW(NSMST,NGRP,KGRP,NGAS,
     &                              ISYM,ISYM_TOT,IFIRST,
     &                              NONEW,ISMDFGP,NACTSYM,ISMSCR)
*
* Giovanni Li Manni. Geneva, February 2012
*
* Obtain next distribution of symmetries with given total
* Symmetry.
*
* Loop over first NGAS-1 spaces are performed, and the symmetry
* of the last space is then fixed by the required total sym
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      INTEGER ISMDFGP(NSMST,NGRP),NACTSYM(NGRP),ISMSCR(NGRP)
      INTEGER KGRP(NGAS)
*. Input and output
      DIMENSION ISYM(NGAS)
*
      NTEST = 00
*
      IF(NTEST.ge.100) then
        write(6,*) '***************************'
        write(6,*) 'INPUT IN NEXT_SYM_DISTR_NEW'
        write(6,*) '***************************'
        write(6,*) 'NGRP :', NGRP
        write(6,*) 'KGRP :'
        write(6,'(40I3)') (KGRP(i),i=1,NGAS)
        write(6,*) 'NACTSYM(NGRP) :'
        write(6,'(40I2)') (NACTSYM(i),i = 1,NGRP)
        write(6,*) 'ISMDFGP(ISYM,NGRP) :'
        do Ism = 1, NSMST
          write(6,'(40I2)') (ISMDFGP(ism,i),i = 1, NGRP)
        end do
        write(6,*) 'IFIRST', IFIRST
      End IF
*
      IF(IFIRST.EQ.1) THEN
        DO IGAS = 1, NGAS
          ISMSCR(IGAS) = 1
          ISYM(IGAS) = ISMDFGP(1,KGRP(IGAS))
        END DO
        NONEW = 0
      END IF
*
      IF(NTEST.ge.100) then
        write(6,*) 'Symmetry distribution :'
        write(6,'(40I2)') (ISYM(IGAS),IGAS=1,NGAS)
      End IF
*
1001  CONTINUE
      IF(IFIRST.EQ.0) then
        CALL NXTDIST(NSMST,NGRP,NGAS,KGRP,ISMDFGP,ISMSCR,NACTSYM,NONEW)
        Do IGAS = 1, NGAS
          ISYM(IGAS) = ISMDFGP(ISMSCR(IGAS),KGRP(IGAS))
        End Do
      END if
      IFIRST = 0
      IF(NONEW.EQ.0) THEN
        JSYM = ISYMSTR(ISYM,NGAS)
        IF(JSYM.ne.ISYM_TOT)GOTO 1001
      END IF
*
      IF(NTEST.GE.100) THEN
        IF(NONEW.EQ.1) THEN
         WRITE(6,*) ' No new symmetry distributions '
        ELSE
         WRITE(6,*) ' Next symmetry distribution '
         CALL IWRTMA(ISYM,1,NGAS,1,NGAS)
        END IF
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine binte(k,alfa,beta,r0,a,ggrin,nz)

use welcom, only: binom, fiint, kmax
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: k, nz
real(kind=wp), intent(in) :: alfa(nz), beta, r0, a(nz)
real(kind=wp), intent(out) :: ggrin(nz,0:k,k/2+1,k/4+1)
integer(kind=iwp) :: i, ind, iz, j, j2, k2, l
real(kind=wp) :: tal
real(kind=wp), allocatable :: grint(:,:)

#ifdef _DEBUGPRINT_
call RecPrt(' In Binte: Alfa',' ',alfa,nz,1)
call RecPrt(' In Binte: A   ',' ',a,nz,1)
#endif
ggrin(:,:,:,:) = Zero
call mma_allocate(grint,[0,kmax],[1,kmax],label='grint')
do iz=1,nz
  grint(:,:) = Zero
  call rrint(k,alfa(iz),a(iz),beta,r0,grint,kmax)
  do i=0,k
    do j=0,i,2
      j2 = j/2+1
      ggrin(iz,i,j2,1) = Zero
      do l=j,i-1
        ggrin(iz,i,j2,1) = ggrin(iz,i,j2,1)+grint(l,j2)*a(iz)**(i-l)*binom(i-j,l-j)
      end do
      ggrin(iz,i,j2,1) = ggrin(iz,i,j2,1)+grint(l,j2)*binom(i-j,l-j)
      ind = 1
      do k2=2,j2-1,2
        tal = fiint((j-k2)/2,k2/2)/fiint(j/2,0)
        ind = ind+1
        ggrin(iz,i,j2,ind) = ggrin(iz,i,j2,1)*tal
      end do
    end do
  end do
end do
call mma_deallocate(grint)

#ifdef _DEBUGPRINT_
call RecPrt(' In Binte: Ggrin',' ',Ggrin,nz,(k+1)*(k/2+1)*(k/4+1))
#endif

return

end subroutine binte

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MLTUNF(LST,X,Y)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(*),Y(*)
      DIMENSION LST(4,NLST1)
#include "sigma.fh"

C Given a list with entries LST(4,ITEM), ITEM=1,NLST1,
C with entries called L1,L2,L3,L4 for given ITEM, and
C an array of the form Y(p,q), compute the matrix
C    X(p,L1,L2) := Add V*Y(p,L3), p=1..LEN1
C where V=VAL1(L4), looped over ITEM=1,NLST1.
C Note: Arrays are addressed by strides given in common.
*     write(*,*)' In MLTUNF. List:'
*     write(*,'(1x,4i5)') ((LST(I,J),I=1,4),J=1,NLST1)
*     write(*,'(1x,a,3i5)')'INCX:',INCX1,INCX2,INCX3
*     write(*,'(1x,a,3i5)')'INCY:',INCY1,INCY2
*     write(*,'(1x,a,3i5)')'LEN1:',LEN1
      DO ILST=1,NLST1
        L1=LST(1,ILST)
        L2=LST(2,ILST)
        L3=LST(3,ILST)
        L4=LST(4,ILST)
        V=VAL1(L4)
        IX=1+INCX2*(L1-1)+INCX3*(L2-1)
        IY=1+INCY2*(L3-1)
        CALL DAXPY_(LEN1,V,Y(IY),INCY1,X(IX),INCX1)
      END DO
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PCOLLVEC(IVEC,iTYPE)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"


***************************************************************
      DO ICASE=1,NCASES
       DO ISYM=1,NSYM
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 100
        IF (ITYPE.EQ.0) THEN
          NAS=NINDEP(ISYM,ICASE)
        ELSE
          NAS=NASUP(ISYM,ICASE)
        END IF
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NW.EQ.0) GOTO 100
        CALL DRA2SOLV (NAS,NIS,iCASE,iSYM,iVEC)
 100    CONTINUE
       END DO
      END DO


      RETURN
      END

#if 0
      SUBROUTINE PDISTVEC(IVEC,iTYPE)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"


***************************************************************
      DO ICASE=1,NCASES
       DO ISYM=1,NSYM
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 100
        IF (ITYPE.EQ.0) THEN
          NAS=NINDEP(ISYM,ICASE)
        ELSE
          NAS=NASUP(ISYM,ICASE)
        END IF
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NW.EQ.0) GOTO 100
        CALL SOLV2DRA (NAS,NIS,iCASE,iSYM,iVEC)
 100    CONTINUE
       END DO
      END DO


      RETURN
      END
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GS(drdq,nLambda,T,nInter,Swap,RD)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 drdq(nInter,nLambda),T(nInter,nInter)
      Logical Swap,RD
      Real*8, Allocatable:: Temp(:,:)
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
*
*     Be careful here so that noise is not converted to a basis!
*
      Thr=1.0D-12
#ifdef _DEBUGPRINT_
      Call RecPrt('GS: dRdQ',' ',drdq,nInter,nLambda)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Initial check to see if the dRdQ vectors are independent.
*
      Call mma_Allocate(Temp,nInter,nLambda,Label='Temp')
      Temp(:,:)=drdq(:,:)
      Call GS_(drdq,nInter,nLambda,Thr)
      jLambda=0
      Do i = 1, nLambda
         XX=Sqrt(DDot_(nInter,drdq(1,i),1,drdq(1,i),1))
C        Write (6,*) 'i,XX=',i,XX
         If (XX.gt.Thr) Then
            jLambda=jLambda+1
*           RD = remove degeneracies
            If (RD) Then
               If (jLambda.ne.i) Then
                  Call dCopy_(nInter,drdq(1,i),1,drdq(1,jLambda),1)
               End If
            End If
         End If
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('GS: dRdQ(orth)',' ',drdq,nInter,nLambda)
#endif
      If ((.not.RD).and.(jLambda.ne.nLambda)) Then
         Write (6,*) ' Constraints are linear dependent!'
         Call abend()
      End If
      nLambda=jLambda
*                                                                      *
************************************************************************
*                                                                      *
*     Project away the space which is spanned by the constraints.
*
      Call FZero(T,nInter**2)
*
      call dcopy_(nInter,[One],0,T,1+nInter)
#ifdef _DEBUGPRINT_
      Call RecPrt('T(orig)',' ',T,nInter,nInter)
#endif
*
*     Form 1 - P
*
      Do iLambda = 1, nLambda
         Do iInter = 1, nInter
            Do jInter = 1, nInter
               T(iInter,jInter) = T(iInter,jInter)
     &                          - drdq(iInter,iLambda)
     &                          * drdq(jInter,iLambda)
            End Do
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('1-P',' ',T,nInter,nInter)
#endif
*
*     Orthonormalize
*
      Call GS_(T,nInter,nInter,Thr)
*
*     Set the trailing vectors to null vectors.
*     We might have noise here.
*
      If (nLambda.ne.0) Then
         iStart = nInter-nLambda + 1
         Call FZero(T(1,iStart),nInter*nLambda)
      End If
#ifdef _DEBUGPRINT_
      Call RecPrt('1-P(GS)',' ',T,nInter,nInter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Restore dRdQ
*
      If (.not.RD) Then
         call dcopy_(nInter*nLambda,Temp,1,drdq,1)
      End If
      Call mma_deallocate(Temp)
*                                                                      *
************************************************************************
*                                                                      *
*     Reorder, place the null vectors at the start.
*
      j=nInter
      Do i = nInter, 1, -1
         XX=DDot_(nInter,T(1,i),1,T(1,i),1)
         If (XX.gt.Zero.and.i.ne.j) Then
            call dcopy_(nInter,T(1,i),1,T(1,j),1)
            j = j - 1
         Else If (XX.gt.Zero) Then
            j = j - 1
         End If
      End Do
*
*     Put drdq at the start
*
      call dcopy_(nInter*nLambda,drdq,1,T,1)
#ifdef _DEBUGPRINT_
      Call RecPrt('T(ReOrdered)',' ',T,nInter,nInter)
#endif
*
*     Call GS_(T,nInter,nInter,Thr)
      If (Swap) call dswap_(nInter,T(1,1),1,T(1,3),1)
*
      Return
      End
      Subroutine GS_(T,nInter,nVec,Thr)
      Implicit Real*8 (a-h,o-z)
      Real*8 T(nInter,nVec)
#include "real.fh"
*
*
      Do i = 1, nVec
*
*        Order the vectors according to the diagonal value.
*
         Call GS_Order(T(1,i),nInter,nVec-i+1)
*
*        Normalize the vector
*
         XX=Sqrt(DDot_(nInter,T(1,i),1,T(1,i),1))
C        Write (6,*) 'GS_: i,XX=',i,XX
         If (XX.gt.Thr) Then
            Call DScal_(nInter,One/XX,T(1,i),1)
         Else
            Call FZero(T(1,i),nInter)
            Go To 100
         End If
*
*        Orthogonalize against the previous vectors
*
*        |Y(new)>=|Y> - <X|Y> * |X>
*
         Do j = 1, i-1
            XY=DDot_(nInter,T(1,i),1,T(1,j),1)
C           If (Abs(XY).gt.Thr) Then
C              Write (6,*) 'GS_: j,XY=',j,XY
               Call DaXpY_(nInter,-XY,T(1,j),1,T(1,i),1)
C              XY=DDot_(nInter,T(1,i),1,T(1,j),1)
C              Write (6,*) 'GS_: j,XY=',j,XY
C           End If
         End Do
*
*        Renormalize
*
         XX=Sqrt(DDot_(nInter,T(1,i),1,T(1,i),1))
C        Write (6,*) 'GS_: i,XX=',i,XX
         If (XX.gt.Thr) Then
            Call DScal_(nInter,One/XX,T(1,i),1)
         Else
            Call FZero(T(1,i),nInter)
         End If
 100     Continue
#ifdef _DEBUGPRINT_
         Call RecPrt('GS_: T',' ',T,nInter,nInter)
#endif
      End Do
*
      Return
      End
      Subroutine GS_Order(T,nInter,nVec)
      Implicit Real*8 (a-h,o-z)
      Real*8 T(nInter,nVec)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('GS_Order: T(orig)','(12F6.2)',T,nInter,nVec)
#endif
      Do j = 1, nVec-1
         DiagMax=DDot_(nInter,T(1,j),1,T(1,j),1)
         iDiag=j
         Do i = j+1, nVec
            Diag=DDot_(nInter,T(1,i),1,T(1,i),1)
            If (T(i,i).gt.DiagMax) Then
               DiagMax=Diag
               iDiag=i
            End If
         End Do
         If (iDiag.ne.j) call dswap_(nInter,T(1,iDiag),1,T(1,j),1)
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('GS_Order: T(ordered)','(12F6.2)',T,nInter,nVec)
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992, Roland Lindh                                *
*               1990, IBM                                              *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine k2Loop_mck(Coor,
     &                      iAnga,iCmpa,
     &                      iDCRR,nDCRR,Data, ijCmp,
     &                      Alpha,nAlpha,Beta,nBeta,
     &                      Coeff1,iBasn,Coeff2,jBasn,
     &                      nMemab,Con,
     &                      Wk002,m002,Wk003,m003,Wk004,m004,
     &                      iStb,jStb,
     &                      ipTmp1,ipTmp2,ipTmp3,
     &                      ipKnew,ipLnew,ipPnew,ipQnew)
************************************************************************
*                                                                      *
* Object: to compute zeta, kappa, and P.                               *
*         This is done for all unique pairs of centers                 *
*         generated from the symmetry unique centers A and B.          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             June '91, modified to compute zeta, P, kappa and inte-   *
*             grals for Schwartz inequality in a k2 loop.              *
*             January '92 modified to gradient calculations.           *
*             April '92, modified to use the Cauchy-Schwarz inequality *
*              to estimate the integral derivatives.                   *
*                                                                      *
*             May   '95  modified (simplified) for hessian calculation *
*             By Anders Bernhardsson                                   *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "ndarray.fh"
#include "real.fh"
#include "disp.fh"
#include "disp2.fh"
      Real*8 Coor(3,2), CoorM(3,4), Alpha(nAlpha), Beta(nBeta),
     &       Data(nAlpha*nBeta*nDArray+nDScalar,nDCRR),
     &       Coeff1(nAlpha,iBasn), Coeff2(nBeta,jBasn),
     &       Wk002(m002),Wk003(m003),Wk004(m004), Con(nAlpha*nBeta)
      Integer iDCRR(0:7), iAnga(4), iCmpa(4), mStb(2)
*
      Call k2Loop_mck_internal(Data)
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Con)
         Call Unused_real_array(Wk004)
         Call Unused_integer(ipTmp1)
         Call Unused_integer(ipTmp2)
         Call Unused_integer(ipTmp3)
         Call Unused_integer(ipKnew)
         Call Unused_integer(ipLnew)
         Call Unused_integer(ipPnew)
         Call Unused_integer(ipQnew)
      End If
*
*     This is to allow type punning without an explicit interface
      Contains
      SubRoutine k2Loop_mck_internal(Data)
      Use Iso_C_Binding
      Real*8, Target :: Data(nAlpha*nBeta*nDArray+nDScalar,nDCRR)
      Integer, Pointer :: iData(:)
      nZeta = nAlpha*nBeta
      mStb(1) = iStb
      mStb(2) = jStb
*
      CoorM(1,1) = Coor(1,1)
      CoorM(2,1) = Coor(2,1)
      CoorM(3,1) = Coor(3,1)
*
      Do 100 lDCRR = 0, nDCRR-1
*
         Call OA(iDCRR(lDCRR),Coor(1:3,2),CoorM(1:3,2))
         call dcopy_(6,CoorM(1,1),1,CoorM(1,3),1)
*
*--------Compute Zeta, P and kappa.
*
         Call C_F_Pointer(C_Loc(Data(ip_IndZ(1,nZeta),lDCRR+1)),
     &                    iData,[nAlpha*nBeta+1])
         Call DoZeta(Alpha,nAlpha,Beta,nBeta,
     &               CoorM(1,1),CoorM(1,2),
     &               Data(ip_PCoor(1,nZeta),lDCRR+1),
     &               Data(ip_Z    (1,nZeta),lDCRR+1),
     &               Data(ip_Kappa(1,nZeta),lDCRR+1),
     &               Data(ip_ZInv (1,nZeta),lDCRR+1),
     &               Data(ip_Alpha(1,nZeta,1),lDCRR+1),
     &               Data(ip_Beta (1,nZeta,2),lDCRR+1),
     &               iData)
         Nullify(iData)
*
         Call SchInt_mck(CoorM,iAnga,iCmpa,nAlpha,nBeta,nMemab,
     &                   Data(ip_Z(1,nZeta),lDCRR+1),
     &                   Data(ip_ZInv(1,nZeta),lDCRR+1),
     &                   Data(ip_Kappa(1,nZeta),lDCRR+1),
     &                   Data(ip_PCoor(1,nZeta),lDCRR+1),
     &                   nZeta,Wk002,m002,Wk003,m003)
*
         Call PckInt_mck(Wk002,nZeta,ijCmp,
     &                   Data(ip_ab(1,nZeta),lDCRR+1),
     &                   Data(ip_Z(1,nZeta),lDCRR+1))
*                                                                      *
************************************************************************
*                                                                      *
*        Estimate the largest contracted integral.
*
         Call C_F_Pointer(C_Loc(Data(ip_IndZ(1,nZeta),lDCRR+1)),
     &                    iData,[nAlpha*nBeta+1])
         Data(ip_EstI(nZeta),lDCRR+1) =
     &                      EstI(Data(ip_Z(1,nZeta),lDCRR+1),
     &                           Data(ip_Kappa(1,nZeta),lDCRR+1),
     &                           nAlpha,nBeta,
     &                           Coeff1,iBasn,Coeff2,jBasn,
     &                           Data(ip_ab   (1,nZeta),lDCRR+1),
     &                           iCmpa(1)*iCmpa(2),
     &                           Wk002,m002,
     &                           iData)
*                                                                      *
************************************************************************
*                                                                      *
*------- Find the largest integral estimate (AO Basis).
*
         Tst  = -One
         Do  iZeta = 0, nZeta-1
             Tst=Max(Data(ip_Z(iZeta+1,nZeta),lDCRR+1),Tst)
         End Do
         Data(ip_ZetaM(nZeta),lDCRR+1) = tst
*
         Tst  = -One
         ZtMax=Zero
         abMax=Zero
         Do  iZeta = 1, nZeta
            tmp =          Data(ip_ab(iZeta,nZeta),lDCRR+1)
            If (Tst.lt.tmp) Then
               Tst = tmp
               ZtMax = Data(ip_Z (iZeta,nZeta),lDCRR+1)
               abMax = Data(ip_ab(iZeta,nZeta),lDCRR+1)
            End If
         End Do
         Data(ip_ZtMax(nZeta),lDCRR+1) = ZtMax
         Data(ip_abMax(nZeta),lDCRR+1) = abMax
 100  Continue
*
      Return
      End SubRoutine k2Loop_mck_internal
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Upd_FA(PUVX,F,D,ExFac)
!***********************************************************************
!                                                                      *
!     compute FIA, FAA, and FAS from the integral set (pu!vx)          *
!                                                                      *
!     calling arguments:                                               *
!     PUVX    : input, array of real                                   *
!               ERIs with indices (pu!vx)                              *
!               (three active, one general)                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use general_data, only: NASH, NISH, NORB, NSYM
use Molcas, only: MxSym
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: PUVX(*), D(*), ExFac
real(kind=wp), intent(inout) :: F(*)
integer(kind=iwp) :: IASH, icase, IDOFF, IFOFF, IISH, IJSYM, IORB, IP, IPU, IPUVX, IPV, IPX, ISTACK, ISYM, IU, IUV, IUX, IV, IVX, &
                     IX, JASH, JDOFF, JFOFF, JISH, JORB, JSYM, KASH, KDOFF, KL_ORB_PAIRS, KLSYM, KSYM, LASH, LSYM, &
                     off_Dmat(mxSym), off_Fmat(mxSym), off_PUVX(mxSym)
real(kind=wp) :: DUV, DUX, DVX, TEMP

! generate offsets

iStack = 0
do iSym=1,nSym
  off_Dmat(iSym) = iStack
  iStack = iStack+nTri_Elem(nAsh(iSym))
end do

iStack = 0
do iSym=1,nSym
  off_Fmat(iSym) = iStack
  iStack = iStack+nTri_Elem(nOrb(iSym))
end do

iStack = 0
do iSym=1,nSym
  off_PUVX(iSym) = iStack
  iOrb = nOrb(iSym)
  do jSym=1,nSym
    jAsh = nAsh(jSym)
    ijSym = Mul(iSym,jSym)
    do kSym=1,nSym
      kAsh = nAsh(kSym)
      do lSym=1,kSym
        lAsh = nAsh(lSym)
        klSym = Mul(kSym,lSym)
        if (ijSym == klSym) then
          kl_Orb_pairs = kAsh*lAsh
          if (kSym == lSym) kl_Orb_pairs = nTri_Elem(kAsh)
          iStack = iStack+iOrb*jAsh*kl_Orb_pairs
        end if
      end do
    end do
  end do
end do

! clear the subbocks FIA, FAA and FSA

do iSym=1,nSym
  iOrb = nOrb(iSym)
  iAsh = nAsh(iSym)
  iIsh = nIsh(iSym)
  iFoff = off_Fmat(iSym)
  do iU=iIsh+1,iIsh+iAsh
    do iP=1,iU
      F(iFoff+iTri(iU,iP)) = Zero
    end do
  end do
  do iU=iIsh+iAsh+1,iOrb
    do iP=iIsh+1,iIsh+iAsh
      F(iFoff+iTri(iP,iU)) = Zero
    end do
  end do
end do

! generate the subblocks FIA, FAA and FSA

do iSym=1,nSym
  iOrb = nOrb(iSym)
  iAsh = nAsh(iSym)
  iIsh = nIsh(iSym)
  iPUVX = off_PUVX(iSym)
  do jSym=1,iSym
    jOrb = nOrb(jSym)
    jAsh = nAsh(jSym)
    jIsh = nIsh(jSym)
    ijSym = Mul(iSym,jSym)
    do kSym=1,nSym
      kAsh = nAsh(kSym)
      do lSym=1,kSym
        lAsh = nAsh(lSym)
        klSym = Mul(kSym,lSym)

        ! find cases
        icase = 4
        if (iSym == jSym) icase = icase-2
        if (iSym == kSym) icase = icase-1

        if ((ijSym == klSym) .and. (iAsh*jAsh*kAsh*lAsh /= 0)) then

          select case (icase)

            case (1)
              ! symmetry case (II!II)
              iFoff = off_Fmat(iSym)
              iDoff = off_Dmat(iSym)
              do iV=1,kAsh
                do iX=1,iV
                  iVX = iTri(iV,iX)
                  DVX = Two*D(iDoff+iVX)
                  if (iX == iV) DVX = D(iDoff+iVX)
                  do iU=1,jAsh
                    iUV = iTri(iU,iV)
                    DUV = ExFac*Half*D(iDoff+iUV)
                    iUX = iTri(iU,iX)
                    DUX = ExFac*Half*D(iDoff+iUX)
                    if (iX == iV) then
                      DUV = ExFac*Half*DUV
                      DUX = ExFac*Half*DUX
                    end if
                    iPUVX = off_PUVX(iSym)
                    ! inactive/active block
                    do iP=1,iIsh
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPU = iTri(iIsh+iU,iP)
                      F(iFoff+iPU) = F(iFoff+iPU)+DVX*Temp
                      iPV = iTri(iIsh+iV,iP)
                      F(iFoff+iPV) = F(iFoff+iPV)-DUX*Temp
                      iPX = iTri(iIsh+iX,iP)
                      F(iFoff+iPX) = F(iFoff+iPX)-DUV*Temp
                    end do
                    ! active/active block and iP<=(iIsh+iU)
                    do iP=iIsh+1,iIsh+iU
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPU = iTri(iIsh+iU,iP)
                      F(iFoff+iPU) = F(iFoff+iPU)+DVX*Temp
                      iPV = iTri(iIsh+iV,iP)
                      F(iFoff+iPV) = F(iFoff+iPV)-ExFac*Half*DUX*Temp
                      if (iP == (iIsh+iV)) F(iFoff+iPV) = F(iFoff+iPV)-ExFac*Half*DUX*Temp
                      iPX = iTri(iIsh+iX,iP)
                      F(iFoff+iPX) = F(iFoff+iPX)-ExFac*Half*DUV*Temp
                      if (iP == (iIsh+iX)) F(iFoff+iPX) = F(iFoff+iPX)-ExFac*Half*DUV*Temp
                    end do
                    ! active/active block and iP>(iIsh+iU)
                    do iP=iIsh+iU+1,iIsh+iAsh
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPV = iTri(iIsh+iV,iP)
                      F(iFoff+iPV) = F(iFoff+iPV)-ExFac*Half*DUX*Temp
                      if (iP == (iIsh+iV)) F(iFoff+iPV) = F(iFoff+iPV)-ExFac*Half*DUX*Temp
                      iPX = iTri(iIsh+iX,iP)
                      F(iFoff+iPX) = F(iFoff+iPX)-ExFac*Half*DUV*Temp
                      if (iP == (iIsh+iX)) F(iFoff+iPX) = F(iFoff+iPX)-ExFac*Half*DUV*Temp
                    end do
                    ! active/secondary block
                    do iP=iIsh+iAsh+1,iOrb
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPU = iTri(iIsh+iU,iP)
                      F(iFoff+iPU) = F(iFoff+iPU)+DVX*Temp
                      iPV = iTri(iIsh+iV,iP)
                      F(iFoff+iPV) = F(iFoff+iPV)-DUX*Temp
                      iPX = iTri(iIsh+iX,iP)
                      F(iFoff+iPX) = F(iFoff+iPX)-DUV*Temp
                    end do
                    off_PUVX(iSym) = off_PUVX(iSym)+iOrb
                  end do
                end do
              end do

            case (2)
              ! symmetry case (II!KK)
              iFoff = off_Fmat(iSym)
              kDoff = off_Dmat(kSym)
              do iV=1,kAsh
                do iX=1,iV
                  iVX = iTri(iV,iX)
                  DVX = Two*D(kDoff+iVX)
                  if (iX == iV) DVX = D(kDoff+iVX)
                  do iU=1,jAsh
                    iPUVX = off_PUVX(iSym)
                    ! inactive/active block
                    do iP=1,iIsh
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPU = iTri(iIsh+iU,iP)
                      F(iFoff+iPU) = F(iFoff+iPU)+DVX*Temp
                    end do
                    ! active/active block and iP<=(iIsh+iU)
                    do iP=iIsh+1,iIsh+iU
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPU = iTri(iIsh+iU,iP)
                      F(iFoff+iPU) = F(iFoff+iPU)+DVX*Temp
                    end do
                    iPUVX = iPUVX+iAsh-iU
                    ! active/secondary block
                    do iP=iIsh+iAsh+1,iOrb
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPU = iTri(iIsh+iU,iP)
                      F(iFoff+iPU) = F(iFoff+iPU)+DVX*Temp
                    end do
                    off_PUVX(iSym) = off_PUVX(iSym)+iOrb
                  end do
                end do
              end do

            case (3)
              ! symmetry case (IJ!IJ)
              iFoff = off_Fmat(iSym)
              jFoff = off_Fmat(jSym)
              iDoff = off_Dmat(iSym)
              jDoff = off_Dmat(jSym)
              do iV=1,kAsh
                do iX=1,lAsh
                  do iU=1,jAsh
                    iUX = iTri(iU,iX)
                    DUX = ExFac*Half*D(jDoff+iUX)
                    iPUVX = off_PUVX(iSym)
                    ! inactive/active block
                    do iP=1,iIsh
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPV = iTri(iIsh+iV,iP)
                      F(iFoff+iPV) = F(iFoff+iPV)-DUX*Temp
                    end do
                    ! active/active block and iP<=(iIsh+iV)
                    do iP=iIsh+1,iIsh+iV
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPV = iTri(iIsh+iV,iP)
                      F(iFoff+iPV) = F(iFoff+iPV)-DUX*Temp
                    end do
                    iPUVX = iPUVX+iAsh-iV
                    ! active/secondary block
                    do iP=iIsh+iAsh+1,iOrb
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPV = iTri(iIsh+iV,iP)
                      F(iFoff+iPV) = F(iFoff+iPV)-DUX*Temp
                    end do
                    off_PUVX(iSym) = off_PUVX(iSym)+iOrb
                  end do
                  do iU=1,iAsh
                    iUV = iTri(iU,iV)
                    DUV = ExFac*Half*D(iDoff+iUV)
                    iPUVX = off_PUVX(jSym)
                    ! inactive/active block
                    do iP=1,jIsh
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPX = iTri(jIsh+iX,iP)
                      F(jFoff+iPX) = F(jFoff+iPX)-DUV*Temp
                    end do
                    ! active/active block and iP<=(jIsh+iX)
                    do iP=jIsh+1,jIsh+iX
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPX = iTri(jIsh+iX,iP)
                      F(jFoff+iPX) = F(jFoff+iPX)-DUV*Temp
                    end do
                    iPUVX = iPUVX+jAsh-iX
                    ! active/secondary block
                    do iP=jIsh+jAsh+1,jOrb
                      iPUVX = iPUVX+1
                      Temp = PUVX(iPUVX)
                      iPX = iTri(jIsh+iX,iP)
                      F(jFoff+iPX) = F(jFoff+iPX)-DUV*Temp
                    end do
                    off_PUVX(jSym) = off_PUVX(jSym)+jOrb
                  end do
                end do
              end do

            case (4)
              ! symmetry case (IJ!KL)
              off_PUVX(iSym) = off_PUVX(iSym)+iOrb*jAsh*kAsh*lAsh
              off_PUVX(jSym) = off_PUVX(jSym)+iAsh*jOrb*kAsh*lAsh

          end select
        end if

      end do
    end do
  end do
end do

end subroutine Upd_FA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE REO_PTDET(NOPEN,NALPHA,IZ_PTDET,IREO_PTDET,ILIST_PTDET,
     &                     NLIST_PTDET, ISCR)
*
* A list(ILIST_PTDET) of prototype determinants with NOPEN unpaired electrons and
* NALPHA alpha electrons is given.
*
* Obtain 1 : Z matrix for this set of prototype dets
*        2 : Reorder array going from lexical order to
*            the order specified by the prototype dets
*            given in ILIST_PTDET. The reordering goes
*            from lexical order to actual order.
*            Prototype determinants not included in
*            ILIST_PTDET are given zero address
*
*. Jeppe Olsen, December 2001
*
#include "implicit.fh"
*. Input
      INTEGER ILIST_PTDET(NOPEN,*)
*. Output
      INTEGER IZ_PTDET(NOPEN,NALPHA), IREO_PTDET(*)
*. Local scratch : Min length : 2*NOPEN + (NALPHA+1)*(NOPEN+1)
      INTEGER ISCR(*)
      INTEGER NOPEN_ARR(1),NALPHA_ARR(1),IDUM(1)
      NTEST = 00
*
* 1 : Set up lexical order array for prototype determinants
*     (alpha considered as occupied electron)
      KLMIN = 1
      KLMAX = KLMIN + NOPEN
      KLW   = KLMAX + NOPEN
      NOPEN_ARR(1) =NOPEN
      NALPHA_ARR(1)=NALPHA
      CALL MXMNOC_SPGP(ISCR(KLMIN),ISCR(KLMAX), 1,NOPEN_ARR,NALPHA_ARR,
     &                      NTEST)
      NOPEN =NOPEN_ARR(1)
      NALPHA=NALPHA_ARR(1)
*
*. Arc weights
*
      CALL GRAPW( ISCR(KLW),  IZ_PTDET,ISCR(KLMIN),ISCR(KLMAX),   NOPEN,
     &               NALPHA,     NTEST)
      NOPEN_ARR(1)=NOPEN
      NALPHA_ARR(1)=NALPHA
*
*. Reorder array
*
*. Total number of prototype determinants
      NTOT_PTDET = 0
      IF (NALPHA .GE. 0 .AND. NALPHA .LE. NOPEN) THEN
         NTOT_PTDET = IBION_LUCIA(NOPEN,NALPHA)
      ELSE
         NTOT_PTDET = 0
      ENDIF
      IZERO = 0
      CALL ISETVC(IREO_PTDET,IZERO,NTOT_PTDET)
*
      DO JPTDT = 1, NLIST_PTDET
C?     WRITE(6,*) ' JPTDT = ', JPTDT
*. Lexical address of prototype determiant JPTDT
       IF(NALPHA.EQ.0) THEN
         ILEX=1
       ELSE
         ILEX = IZNUM_PTDT(ILIST_PTDET(1,JPTDT),NOPEN,NALPHA,IZ_PTDET,
     &                   IDUM,0)
       END IF
       IREO_PTDET(ILEX) = JPTDT
      END DO
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Reorder array for prototype determinants '
        CALL IWRTMA(IREO_PTDET,1,NTOT_PTDET,1,NTOT_PTDET)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE INTDIM(IPRNT)
*
* Number of integrals and storage mode
*
      IMPLICIT REAL*8(A-H,O-Z)
*
* =====
*.Input
* =====
*
#include "mxpdim.fh"
#include "lucinp.fh"
#include "orbinp.fh"
#include "csm.fh"
#include "crun.fh"
*.CSMPRD
#include "csmprd.fh"
*
* =======
*. Output
* =======
*
#include "cintfo.fh"
*.1 : Number of one-electron integrals
      NINT1 =  NSXFSM(NSMOB,MXPOBS,NTOOBS,NTOOBS,ITSSX,ADSXA,1,IPRNT)
*.2 : Number of two-electron integrals
        IF(PNTGRP.EQ.1) THEN
*. Full eightfold symmetry can be used
          I12S = 1
          I34S = 1
          I1234S = 1
c        ELSE
*. Only symmetry between 12 and 34
c          I12S = 0
c          I34S = 0
c          I1234S = 1
        END IF
        NINT2 = NDXFSM(NSMOB,NSMSX,MXPOBS,NTOOBS,NTOOBS,NTOOBS,
     &                  NTOOBS,ITSDX,ADSXA,SXDXSX,I12S,I34S,I1234S,
     &                  IPRNT )
*. Number of integrals without complex conjugation symmetry
*. ( used for T1 transformed Hamiltonian)
       I12 = 0
       I34 = 0
       I1234 = 1
       NINT2_NO_CCSYM = NDXFSM(NSMOB,NSMSX,MXPOBS,NTOOBS,NTOOBS,NTOOBS,
     &                  NTOOBS,ITSDX,ADSXA,SXDXSX,I12,I34,I1234,
     &                  IPRNT )
c       IF(ISIMTRH.EQ.1) THEN
c         WRITE(6,*)
c     &   ' Number of two-electron integrals in exp(-T1)Hexp(T1) ',
c     &     NINT2_NO_CCSYM
c       END IF
*. Number of symmetry blocks of one- and two-electron integrals
      NBINT1 = NSMOB
      NBINT2 = NSMOB ** 3
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ComputeFuncER(ERFun,CMO,nBas,nOcc,nFro,nSym,Timing)
! Thomas Bondo Pedersen, November 2005.
!
! Purpose: compute Edmiston-Ruedenberg functional.
!
! =====================================================
!    WORKS *ONLY* WITH CHOLESKY DECOMPOSED INTEGRALS
! =====================================================

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: ERFun
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOcc(nSym), nFro(nSym)
logical(kind=iwp), intent(in) :: Timing
integer(kind=iwp) :: i, irc, iSym, kOff, lERFun, nFroT, nOccT(8)
real(kind=wp) :: FracMem
character(len=80) :: Txt
real(kind=wp), allocatable :: ERFunVec(:)
character(len=*), parameter :: SecNam = 'ComputeFuncER'

! Initializations.
! ----------------

irc = 0

FracMem = Zero ! no buffer allocated
call Cho_X_Init(irc,FracMem)
if (irc /= 0) then
  write(Txt,'(A,I4)') 'Cho_X_Init returned',irc
  call SysAbendMsg(SecNam,'Cholesky initialization failure!',Txt)
end if

! Check dimensions.
! -----------------

call ERChk_Localisation(irc,nBas,nOcc,nFro,nSym)
if (irc /= 0) then
  write(Txt,'(A,I4)') 'ERChk_Localisation returned',irc
  call SysAbendMsg(SecNam,'Cholesky initialization mismatch!',Txt)
end if

! Compute ER functional.
! ----------------------

nOccT(1) = nOcc(1)+nFro(1)
do iSym=2,nSym
  nOccT(iSym) = nOcc(iSym)+nFro(iSym)
end do

lERFun = nOccT(1)
nFroT = nFro(1)
do iSym=2,nSym
  lERFun = lERFun+nOccT(iSym)
  nFroT = nFroT+nFro(iSym)
end do

call mma_allocate(ERFunVec,lERFun,label='ERFun')
ERFun = Zero
call EvalERFun(ERFun,ERFunVec,CMO,nOccT,nSym,Timing)
if (nFroT > 0) then
  kOff = 0
  do iSym=1,nSym
    do i=1,nFro(iSym)
      ERFun = ERFun-ERFunVec(kOff+i)
    end do
    kOff = kOff+nOccT(iSym)
  end do
end if
call mma_deallocate(ERFunVec)

! Finalizations.
! --------------

call Cho_X_Final(irc)
if (irc /= 0) then
  write(Txt,'(A,I4)') 'Cho_X_Final returned',irc
  call SysAbendMsg(SecNam,'Cholesky finalization failure!',Txt)
end if

end subroutine ComputeFuncER

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_GAdGOp(X,n,Op)

use Cholesky, only: Cho_Real_Par
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: X(n)
character(len=*), intent(in) :: Op
integer(kind=iwp) :: iv, kv

if (Cho_Real_Par) then
  iv = 0
  do while (iv < n)
    kv = min(n-iv,32000000)
    call GAdGOp(X(iv+1),kv,Op)
    iv = iv+kv
  end do
end if

end subroutine Cho_GAdGOp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Jose Manuel Hermida Ramon                        *
************************************************************************
      Subroutine OneOverR_Sl(iFil,Ax,Ay,Az,BoMaH,BoMaO,EEDisp,iCNum
     &                  ,Eint,iQ_Atoms,outxyz,Eint_Nuc)
      Implicit Real*8 (a-h,o-z)
*----------------------------------------------------------------------*
*     Jose. Modification of the OneOverR subroutine to include the     *
*     electrostatic penetration of the charge density in the           *
*     electrostatic operator of the Hamiltonian. 2011-05-30            *
*----------------------------------------------------------------------*

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "WrkSpc.fh"

      Parameter (MxK=(MxMltp*(MxMltp**2+6*MxMltp+11)+6)/6)

      Dimension iFil(MxQCen,10)
      Dimension Eint(MxQCen,10),BoMaH(MxAt),BoMaO(MxAt),outxyz(MxQCen,3)
      Dimension Eint_Nuc(MxAt),EintSl(MxK)
      Dimension CTemp(3,MxCen),DTemp(MxCen),DInvTemp(MxCen)
      Logical   lAtom

      EEdisp=0.0d0
*----------------------------------------------------------------------*
* Compute some distances and inverted distances etc. The potential,    *
* the field and etc. and when we already have the numbers, we also do  *
* the dispersion interaction.                                          *
*----------------------------------------------------------------------*
      iCi=(iQ_Atoms*(iQ_Atoms+1))/2
      Do 601, k=1,iCi
        lAtom=.false.
        If(k.le.iQ_atoms) lAtom=.true.
        Gx=outxyz(k,1)+Ax
        Gy=outxyz(k,2)+Ay
        Gz=outxyz(k,3)+Az
        Do 602, j=iCnum+1,nPart
          i=1+(j-1)*nCent
          ip=1+(j-1)*nPol
          Rabx1=Cordst(i,1)-Gx  !Below follows a lot of
          Raby1=Cordst(i,2)-Gy  !distances to and fro.
          Rabz1=Cordst(i,3)-Gz
          Rabx2=Cordst(i+1,1)-Gx
          Raby2=Cordst(i+1,2)-Gy
          Rabz2=Cordst(i+1,3)-Gz
          Rabx3=Cordst(i+2,1)-Gx
          Raby3=Cordst(i+2,2)-Gy
          Rabz3=Cordst(i+2,3)-Gz
          Rabx4=Cordst(i+3,1)-Gx
          Raby4=Cordst(i+3,2)-Gy
          Rabz4=Cordst(i+3,3)-Gz
          Rabx5=Cordst(i+4,1)-Gx
          Raby5=Cordst(i+4,2)-Gy
          Rabz5=Cordst(i+4,3)-Gz
          R21=Rabx1**2+Raby1**2+Rabz1**2
          R22=Rabx2**2+Raby2**2+Rabz2**2
          R23=Rabx3**2+Raby3**2+Rabz3**2
          R24=Rabx4**2+Raby4**2+Rabz4**2
          R25=Rabx5**2+Raby5**2+Rabz5**2
          Rg1=Sqrt(r21)
          Rg2=Sqrt(r22)
          Rg3=Sqrt(r23)
          Rg4=Sqrt(r24)
          Rg5=Sqrt(r25)
          S1i=1/Rg1
          S2i=1/Rg2
          S3i=1/Rg3
          S4i=1/Rg4
          S5i=1/Rg5
          S1e=S1i
          S2e=S2i
          S3e=S3i
          S4e=S4i
          S5e=S5i
          Rab13i=S1e/R21
          Rab23i=S2e/R22
          Rab33i=S3e/R23
          Rab43i=S4e/R24
          Rab53i=S5e/R25
*----------------------------------------------------------------------*
* The dispersion interaction between QM-atoms and solvent is computed, *
* with or without damping. The initial if-clause sees to that only     *
* atom-centers are included, while bonds and virtual centers are       *
* ignored.                                                             *
*----------------------------------------------------------------------*
          If(lAtom) then
            Call DispEnergy(EEDisp,BoMah,BoMaO,rg1,rg2,rg3
     &                     ,Rab13i,Rab23i,Rab33i,k)

          Endif
          Ux1=RabX1*s1i
          Uy1=RabY1*s1i
          Uz1=RabZ1*s1i
          Ux2=RabX2*s2i
          Uy2=RabY2*s2i
          Uz2=RabZ2*s2i
          Ux3=RabX3*s3i
          Uy3=RabY3*s3i
          Uz3=RabZ3*s3i
          Ux4=RabX4*s4i
          Uy4=RabY4*s4i
          Uz4=RabZ4*s4i
          Ux5=RabX5*s5i
          Uy5=RabY5*s5i
          Uz5=RabZ5*s5i
          Rg1=Sqrt(r21)
          Rg2=Sqrt(r22)
          Rg3=Sqrt(r23)
          Rg4=Sqrt(r24)
          Rg5=Sqrt(r25)
          S1i=1/Rg1
          S2i=1/Rg2
          S3i=1/Rg3
          S4i=1/Rg4
          S5i=1/Rg5
*----------------------------------------------------------------------*
* Now we wrap up the electrostatics.                                   *
*----------------------------------------------------------------------*
* Jose. First we check if distance with at least one of the centers of *
* the clasical molecule is inside the Cut-off                          *
*----------------------------------------------------------------------*
          distMin=min(rg1,rg2)
          distMin=min(distMin,rg3)
          distMin=min(distMin,rg4)
          distMin=min(distMin,rg5)
          If(distMin.le.Cut_Elc) then
            CTemp(1,1)=Rabx1
            CTemp(2,1)=Raby1
            CTemp(3,1)=Rabz1
            CTemp(1,2)=Rabx2
            CTemp(2,2)=Raby2
            CTemp(3,2)=Rabz2
            CTemp(1,3)=Rabx3
            CTemp(2,3)=Raby3
            CTemp(3,3)=Rabz3
            CTemp(1,4)=Rabx4
            CTemp(2,4)=Raby4
            CTemp(3,4)=Rabz4
            CTemp(1,5)=Rabx5
            CTemp(2,5)=Raby5
            CTemp(3,5)=Rabz5
            DTemp(1)=Rg1
            DTemp(2)=Rg2
            DTemp(3)=Rg3
            DTemp(4)=Rg4
            DTemp(5)=Rg5
            DInvTemp(1)=S1i
            DInvTemp(2)=S2i
            DInvTemp(3)=S3i
            DInvTemp(4)=S4i
            DInvTemp(5)=S5i
            If(lQuad) then
              nMltTemp=nMlt-1 ! this is done because for Sl_Grad
                              ! charge is L=0, dipole is L=1 and
                              ! quadrupole is L=2. In QmStat they
                              ! are 1, 2 and 3, respectively.

              Call Sl_Grad(nSlSiteC,lMltSlC,CTemp,DTemp,DInvTemp
     &               ,SlExpC,SlFactC,SlPC,nMltTemp,SlExpQ(1,k),DifSlExp
     &               ,EintSl,EintSl_Nuc,lAtom)

*-----------------------------------------------------------------------*
* Change in the order of field gradients beacuse subroutine Sl_Grad
* have the same order than Molcas xx=5, xy=6, xz=7, yy=8, yz=9 and zz=10
* and we need the QmStat order: xx=5, xy=6, yy=7, xz=8, yz=9 and zz=10
*-----------------------------------------------------------------------*
              EintSlTemp=EintSl(7)
              EintSl(7)=EintSl(8)
              EintSl(8)=EintSlTemp

              Do jhr=1,10
                Eint(k,jhr)=Eint(k,jhr)-EintSl(jhr) !Check bellow why
                                               ! it is a subtraction
                                               ! and not a sum
              End do
              If(lAtom) then
                Eint_Nuc(k)=Eint_Nuc(k)-EintSl_Nuc
              End if
              go to 3466
            Else
              nMltTemp=nMlt-1 ! this is done because for Sl_Grad
                              ! charge is L=0, dipole is L=1 and
                              ! quadrupole is L=2. In QmStat they
                              ! are 1, 2 and 3, respectively.

              ijhr=min(nMltTemp,1)
              Call Sl_Grad(nSlSiteC,lMltSlC,CTemp,DTemp,DInvTemp
     &                 ,SlExpC,SlFactC,SlPC,ijhr,SlExpQ(1,k),DifSlExp
     &                 ,EintSl,EintSl_Nuc,lAtom)

              Do jhr=1,4
                Eint(k,jhr)=Eint(k,jhr)-EintSl(jhr) ! Check bellow why
                                               ! it is a subtraction
                                               ! and not a sum
              End do
              If(lAtom) then
                Eint_Nuc(k)=Eint_Nuc(k)-EintSl_Nuc
              End if
              go to 3456
            Endif
          Endif
*----------------------------------------------------------------------*
* The Eint(k,1) term will below turn into the interaction between
* charges on water and the MME-charges on the QM-molecule.
* Plus the interaction between the charge densities in Water and the
* charge densities in QM-Molecule when the Penetration is evaluated
*----------------------------------------------------------------------*
          Eint(k,1)=-Qsta(1)*S2e-Qsta(2)*S3e-Qsta(3)*S4e
     &             -Qsta(4)*S5e+Eint(k,1)
          If(lAtom) then
            Eint_Nuc(k)=-Qsta(1)*S2e-Qsta(2)*S3e-Qsta(3)*S4e
     &             -Qsta(4)*S5e+Eint_Nuc(k)
          Endif

         !These three terms will below turn into the interaction
         !between water charges and the MME-dipoles on the QM-mol.
         !Change sign of charge, change sign of vector and then we
         !should also change sign since when a dipole interacts with
         !a field we have a minus sign, but this minus sign we have
         !omitted in hel; therefore this calculation gives the right
         !number eventually.
          Eint(k,2)=-Qsta(1)*RabX2*Rab23i-Qsta(2)*RabX3*Rab33i
     &-Qsta(3)*RabX4*Rab43i-Qsta(4)*RabX5*Rab53i+Eint(k,2)
          Eint(k,3)=-Qsta(1)*RabY2*Rab23i-Qsta(2)*RabY3*Rab33i
     &-Qsta(3)*RabY4*Rab43i-Qsta(4)*RabY5*Rab53i+Eint(k,3)
          Eint(k,4)=-Qsta(1)*RabZ2*Rab23i-Qsta(2)*RabZ3*Rab33i
     &-Qsta(3)*RabZ4*Rab43i-Qsta(4)*RabZ5*Rab53i+Eint(k,4)
          !And here it is the MME-quadrupoles that are prepared.
          !Change sign of charges, change sign two times of the
          !vector (in effect, zero times then) and then in the
          !energy expression for the interaction between the field
          !vector from a charge and a quarupole there is a plus
          !sign, so a minus is the right sign below.

3456      Continue

          Eint(k,5)=Eint(k,5)-Qsta(1)*Ux2**2*Rab23i-Qsta(2)*Ux3**2
     &*Rab33i-Qsta(3)*Ux4**2*Rab43i-Qsta(4)*Ux5**2*Rab53i
          Eint(k,7)=Eint(k,7)-Qsta(1)*Uy2**2*Rab23i-Qsta(2)*Uy3**2
     &*Rab33i-Qsta(3)*Uy4**2*Rab43i-Qsta(4)*Uy5**2*Rab53i
          Eint(k,10)=Eint(k,10)-Qsta(1)*Uz2**2*Rab23i-Qsta(2)*Uz3**2
     &*Rab33i-Qsta(3)*Uz4**2*Rab43i-Qsta(4)*Uz5**2*Rab53i
          Eint(k,6)=Eint(k,6)-Qsta(1)*Ux2*Uy2*Rab23i-Qsta(2)*Ux3
     &*Uy3*Rab33i-Qsta(3)*Ux4*Rab43i*Uy4-Qsta(4)*Ux5*Rab53i*Uy5
          Eint(k,8)=Eint(k,8)-Qsta(1)*Ux2*Uz2*Rab23i-Qsta(2)*Ux3
     &*Uz3*Rab33i-Qsta(3)*Ux4*Rab43i*Uz4-Qsta(4)*Ux5*Rab53i*Uz5
          Eint(k,9)=Eint(k,9)-Qsta(1)*Uz2*Uy2*Rab23i-Qsta(2)*Uz3
     &*Uy3*Rab33i-Qsta(3)*Uz4*Rab43i*Uy4-Qsta(4)*Uz5*Rab53i*Uy5

3466      Continue

*----------------------------------------------------------------------*
* And now a whole lot of grad(1/r) and higher...                       *
*----------------------------------------------------------------------*
      !Unipoles.
          Work(iFil(k,1)-1+ip)=Rabx1*Rab13i
          Work(iFil(k,1)-1+ip+1)=Rabx2*Rab23i
          Work(iFil(k,1)-1+ip+2)=Rabx3*Rab33i
          Work(iFil(k,1)-1+nPart*nPol+ip)=Raby1*Rab13i
          Work(iFil(k,1)-1+nPart*nPol+ip+1)=Raby2*Rab23i
          Work(iFil(k,1)-1+nPart*nPol+ip+2)=Raby3*Rab33i
          Work(iFil(k,1)-1+2*nPart*nPol+ip)=Rabz1*Rab13i
          Work(iFil(k,1)-1+2*nPart*nPol+ip+1)=Rabz2*Rab23i
          Work(iFil(k,1)-1+2*nPart*nPol+ip+2)=Rabz3*Rab33i
      !Dipole -- x-component.
          Work(iFil(k,2)-1+ip)=-(1-3*Ux1**2)*Rab13i
          Work(iFil(k,2)-1+ip+1)=-(1-3*Ux2**2)*Rab23i
          Work(iFil(k,2)-1+ip+2)=-(1-3*Ux3**2)*Rab33i
          Work(iFil(k,2)-1+nPart*nPol+ip)=Uy1*Ux1*Rab13i*3
          Work(iFil(k,2)-1+nPart*nPol+ip+1)=Uy2*Ux2*Rab23i*3
          Work(iFil(k,2)-1+nPart*nPol+ip+2)=Uy3*Ux3*Rab33i*3
          Work(iFil(k,2)-1+2*nPart*nPol+ip)=Uz1*Ux1*Rab13i*3
          Work(iFil(k,2)-1+2*nPart*nPol+ip+1)=Uz2*Ux2*Rab23i*3
          Work(iFil(k,2)-1+2*nPart*nPol+ip+2)=Uz3*Ux3*Rab33i*3
      !Dipole -- y-component.
          Work(iFil(k,3)-1+ip)=Uy1*Ux1*Rab13i*3
          Work(iFil(k,3)-1+ip+1)=Uy2*Ux2*Rab23i*3
          Work(iFil(k,3)-1+ip+2)=Uy3*Ux3*Rab33i*3
          Work(iFil(k,3)-1+nPart*nPol+ip)=-(1-3*Uy1**2)*Rab13i
          Work(iFil(k,3)-1+nPart*nPol+ip+1)=-(1-3*Uy2**2)*Rab23i
          Work(iFil(k,3)-1+nPart*nPol+ip+2)=-(1-3*Uy3**2)*Rab33i
          Work(iFil(k,3)-1+2*nPart*nPol+ip)=Uz1*Uy1*Rab13i*3
          Work(iFil(k,3)-1+2*nPart*nPol+ip+1)=Uz2*Uy2*Rab23i*3
          Work(iFil(k,3)-1+2*nPart*nPol+ip+2)=Uz3*Uy3*Rab33i*3
      !Dipole -- z-component.
          Work(iFil(k,4)-1+ip)=Uz1*Ux1*Rab13i*3
          Work(iFil(k,4)-1+ip+1)=Uz2*Ux2*Rab23i*3
          Work(iFil(k,4)-1+ip+2)=Uz3*Ux3*Rab33i*3
          Work(iFil(k,4)-1+nPart*nPol+ip)=Uz1*Uy1*Rab13i*3
          Work(iFil(k,4)-1+nPart*nPol+ip+1)=Uz2*Uy2*Rab23i*3
          Work(iFil(k,4)-1+nPart*nPol+ip+2)=Uz3*Uy3*Rab33i*3
          Work(iFil(k,4)-1+2*nPart*nPol+ip)=-(1-3*Uz1**2)*Rab13i
          Work(iFil(k,4)-1+2*nPart*nPol+ip+1)=-(1-3*Uz2**2)*Rab23i
          Work(iFil(k,4)-1+2*nPart*nPol+ip+2)=-(1-3*Uz3**2)*Rab33i
      !Quadrupole -- xx-component.
          Work(iFil(k,5)-1+ip)=(5*Ux1*(Ux1*Ux1-.4))*Rab13i*S1e
          Work(iFil(k,5)-1+ip+1)=(5*Ux2*(Ux2*Ux2-.4))*Rab23i*S2e
          Work(iFil(k,5)-1+ip+2)=(5*Ux3*(Ux3*Ux3-.4))*Rab33i*S3e
          Work(iFil(k,5)-1+nPart*nPol+ip)=5*Uy1*Ux1*Ux1*Rab13i*S1e
          Work(iFil(k,5)-1+nPart*nPol+ip+1)=5*Uy2*Ux2*Ux2*Rab23i*S2e
          Work(iFil(k,5)-1+nPart*nPol+ip+2)=5*Uy3*Ux3*Ux3*Rab33i*S3e
          Work(iFil(k,5)-1+2*nPart*nPol+ip)=5*Uz1*Ux1*Ux1*Rab13i*S1e
          Work(iFil(k,5)-1+2*nPart*nPol+ip+1)=5*Uz2*Ux2*Ux2*Rab23i*S2e
          Work(iFil(k,5)-1+2*nPart*nPol+ip+2)=5*Uz3*Ux3*Ux3*Rab33i*S3e
      !Quadrupole -- yy-component.
          Work(iFil(k,7)-1+ip)=5*Uy1*Uy1*Ux1*Rab13i*S1e
          Work(iFil(k,7)-1+ip+1)=5*Uy2*Uy2*Ux2*Rab23i*S2e
          Work(iFil(k,7)-1+ip+2)=5*Uy3*Uy3*Ux3*Rab33i*S3e
          Work(iFil(k,7)-1+nPart*nPol+ip)=(5*Uy1*(Uy1*Uy1-.4))
     &                                   *Rab13i*S1e
          Work(iFil(k,7)-1+nPart*nPol+ip+1)=(5*Uy2*(Uy2*Uy2-.4))
     &                                   *Rab23i*S2e
          Work(iFil(k,7)-1+nPart*nPol+ip+2)=(5*Uy3*(Uy3*Uy3-.4))
     &                                   *Rab33i*S3e
          Work(iFil(k,7)-1+2*nPart*nPol+ip)=5*Uz1*Uy1*Uy1*Rab13i*S1e
          Work(iFil(k,7)-1+2*nPart*nPol+ip+1)=5*Uz2*Uy2*Uy2*Rab23i*S2e
          Work(iFil(k,7)-1+2*nPart*nPol+ip+2)=5*Uz3*Uy3*Uy3*Rab33i*S3e
      !Quadrupole -- zz-component.
          Work(iFil(k,10)-1+ip)=5*Uz1*Uz1*Ux1*Rab13i*S1e
          Work(iFil(k,10)-1+ip+1)=5*Uz2*Uz2*Ux2*Rab23i*S2e
          Work(iFil(k,10)-1+ip+2)=5*Uz3*Uz3*Ux3*Rab33i*S3e
          Work(iFil(k,10)-1+nPart*nPol+ip)=5*Uz1*Uz1*Uy1*Rab13i*S1e
          Work(iFil(k,10)-1+nPart*nPol+ip+1)=5*Uz2*Uz2*Uy2*Rab23i*S2e
          Work(iFil(k,10)-1+nPart*nPol+ip+2)=5*Uz3*Uz3*Uy3*Rab33i*S3e
          Work(iFil(k,10)-1+2*nPart*nPol+ip)=(5*Uz1*(Uz1*Uz1-.4))
     &                                      *Rab13i*S1e
          Work(iFil(k,10)-1+2*nPart*nPol+ip+1)=(5*Uz2*(Uz2*Uz2-.4))
     &                                      *Rab23i*S2e
          Work(iFil(k,10)-1+2*nPart*nPol+ip+2)=(5*Uz3*(Uz3*Uz3-.4))
     &                                      *Rab33i*S3e
      !Quadrupole -- xy-component.
          Work(iFil(k,6)-1+ip)=(5*Uy1*(Ux1*Ux1-.2))*Rab13i*S1e
          Work(iFil(k,6)-1+ip+1)=(5*Uy2*(Ux2*Ux2-.2))*Rab23i*S2e
          Work(iFil(k,6)-1+ip+2)=(5*Uy3*(Ux3*Ux3-.2))*Rab33i*S3e
          Work(iFil(k,6)-1+nPart*nPol+ip)=(5*Ux1*(Uy1*Uy1-.2))
     &                                   *Rab13i*S1e
          Work(iFil(k,6)-1+nPart*nPol+ip+1)=(5*Ux2*(Uy2*Uy2-.2))
     &                                   *Rab23i*S2e
          Work(iFil(k,6)-1+nPart*nPol+ip+2)=(5*Ux3*(Uy3*Uy3-.2))
     &                                   *Rab33i*S3e
          Work(iFil(k,6)-1+2*nPart*nPol+ip)=5*Uz1*Uy1*Ux1*Rab13i*S1e
          Work(iFil(k,6)-1+2*nPart*nPol+ip+1)=5*Uz2*Uy2*Ux2*Rab23i*S2e
          Work(iFil(k,6)-1+2*nPart*nPol+ip+2)=5*Uz3*Uy3*Ux3*Rab33i*S3e
      !Quadrupole -- xz-component.
          Work(iFil(k,8)-1+ip)=(5*Uz1*(Ux1*Ux1-.2))*Rab13i*S1e
          Work(iFil(k,8)-1+ip+1)=(5*Uz2*(Ux2*Ux2-.2))*Rab23i*S2e
          Work(iFil(k,8)-1+ip+2)=(5*Uz3*(Ux3*Ux3-.2))*Rab33i*S3e
          Work(iFil(k,8)-1+nPart*nPol+ip)=5*Uz1*Uy1*Ux1*Rab13i*S1e
          Work(iFil(k,8)-1+nPart*nPol+ip+1)=5*Uz2*Uy2*Ux2*Rab23i*S2e
          Work(iFil(k,8)-1+nPart*nPol+ip+2)=5*Uz3*Uy3*Ux3*Rab33i*S3e
          Work(iFil(k,8)-1+2*nPart*nPol+ip)=(5*Ux1*(Uz1*Uz1-.2))
     &                                     *Rab13i*S1e
          Work(iFil(k,8)-1+2*nPart*nPol+ip+1)=(5*Ux2*(Uz2*Uz2-.2))
     &                                     *Rab23i*S2e
          Work(iFil(k,8)-1+2*nPart*nPol+ip+2)=(5*Ux3*(Uz3*Uz3-.2))
     &                                     *Rab33i*S3e
      !Quadrupole -- yz-component.
          Work(iFil(k,9)-1+ip)=5*Uz1*Uy1*Ux1*Rab13i*S1e
          Work(iFil(k,9)-1+ip+1)=5*Uz2*Uy2*Ux2*Rab23i*S2e
          Work(iFil(k,9)-1+ip+2)=5*Uz3*Uy3*Ux3*Rab33i*S3e
          Work(iFil(k,9)-1+nPart*nPol+ip)=(5*Uz1*(Uy1*Uy1-.2))
     &                                   *Rab13i*S1e
          Work(iFil(k,9)-1+nPart*nPol+ip+1)=(5*Uz2*(Uy2*Uy2-.2))
     &                                   *Rab23i*S2e
          Work(iFil(k,9)-1+nPart*nPol+ip+2)=(5*Uz3*(Uy3*Uy3-.2))
     &                                   *Rab33i*S3e
          Work(iFil(k,9)-1+2*nPart*nPol+ip)=(5*Uy1*(Uz1*Uz1-.2))
     &                                   *Rab13i*S1e
          Work(iFil(k,9)-1+2*nPart*nPol+ip+1)=(5*Uy2*(Uz2*Uz2-.2))
     &                                   *Rab23i*S2e
          Work(iFil(k,9)-1+2*nPart*nPol+ip+2)=(5*Uy3*(Uz3*Uz3-.2))
     &                                   *Rab33i*S3e
*----------------------------------------------------------------------*
* If damping of the field is requested, then do it.                    *
*----------------------------------------------------------------------*
          If(FieldDamp) then
            Do 620, ijhr=1,10
              Do 621, jjhr=0,2
                Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip)=
     &          Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip)
     &          *(1-exp(CAFieldG*rg1))**CFexp
                Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip+1)=
     &          Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip+1)
     &          *(1-exp(CBFieldG*rg2))**CFexp
                Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip+2)=
     &          Work(iFil(k,ijhr)-1+jjhr*nPart*nPol+ip+2)
     &          *(1-exp(CBFieldG*rg3))**CFexp
621           Continue
620         Continue
          Endif
602     Continue
601   Continue

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine SolveforRHS(Fock,CICSF,AXkzx,AXPzx,bk,bP)

use MCLR_Data, only: nConf1, nDens
use input_mclr, only: nRoots
use Definitions, only: wp

implicit none
real(kind=wp), intent(out) :: Fock(nDens), CICSF(nConf1*nRoots)
real(kind=wp), intent(in) :: AXkzx(nDens), AXPzx(nConf1*nRoots), bk(nDens), bP(nConf1*nRoots)

! Orbital Rotation Part
Fock(:) = Axkzx(:)+bk(:)

! State-CSF Rotation Part
CICSF(:) = AXPzx(:)-bP(:)

end subroutine SolveforRHS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Density_Matrix_mpprop(D,nBas,nSym)

#include "intent.fh"

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym)
real(kind=wp), intent(_OUT_) :: D(*)
integer(kind=iwp) :: nDens

if (nSym == 1) then
  nDens = nBas(1)*(nBas(1)+1)/2
  call Get_D1ao(D,nDens)
# ifdef _DEBUGPRINT_
  call RecPrt('D',' ',D,1,nDens)
# endif
else
  write(u6,*) 'MpProp cannot handle symmetry'
  call Abend()
end if

return

end subroutine Get_Density_Matrix_mpprop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*  SetMem
*
*> @brief
*>   Initialize and change status for memory control (common / MOLCAS_GetMem / MemCtl)
*>
*> @details
*> String is a string of any size and is not case sensitive.
*> The string contains keyword and the status of keyword in a form:
*> ``KEYWORD=STATUS``. The ``STATUS`` of the keyword can be ``ON`` or ``OFF``.
*> The ::SetMem subroutine can recognize only keywords:
*>
*> - ``TRACE``:  traces memory.
*> - ``SYSOUT``: unit of file which will be used as output for all kind of prints connected with the memory control.
*> - ``CLEAR``:  sets memory block for extra checking for memory allocation.
*>               A  ``_GARBLE_`` preprocessor option can be defined during compilation process to add an additional checking.
*> - ``QUERY``:  prints status of the Molcas_query.
*> - ``CHECK``:  check the internal state of the MA.
*>
*> @param[in] String ``TRACE=ON`` / ``TRACE=OFF`` / ``SYSOUT=ON`` / ``SYSOUT=OFF`` / ``CLEAR=ON`` / ``CLEAR=OFF`` / ``QUERY=ON`` / ``QUERY=OFF`` / ``CHECK=ON`` / ``CHECK=OFF``
************************************************************************
      Subroutine SetMem (String)
*

#include "SysCtl.fh"
#include "mama.fh"
*
*
      Character*(*) String
      Character*20  Token
*----------------------------------------------------------------------*
*     Initialize the Common / MemCtl / the first time it is referenced *
*----------------------------------------------------------------------*
      If ( MemCtl(ipStat).ne.ON ) then
         Call IniMem
      End if
*----------------------------------------------------------------------*
*     read default parameters from Common / MemCtl /                   *
*----------------------------------------------------------------------*
      iW=MemCtl(ipSysOut)
      If ( MemCtl(ipTrace).eq.ON ) then
         Write(iW,*) ' <<< Entering SetMem >>>'
      End If
*----------------------------------------------------------------------*
*     extract the first token and convert it into standard format      *
*----------------------------------------------------------------------*
      Call StdFmt(String,Token)
      If ( Token.eq.' ' ) Return
*----------------------------------------------------------------------*
*     replace default values                                           *
*----------------------------------------------------------------------*
      lToken=LEN(Token)
      If ( Token(1:6).eq.'TRACE=') then
         If ( Token(7:8).eq.'ON' ) then
            MemCtl(ipTrace) = ON
            Return
         Else If ( Token(7:9).eq.'OFF' ) then
            MemCtl(ipTrace) = OFF
            Return
         End If
      Else if ( Token(1:7).eq.'SYSOUT=' ) then
         Read(Token(8:lToken),*) MemCtl(ipSysOut)
         Return
      Else if ( Token(1:6).eq.'CLEAR=') then
         If ( Token(7:8).eq.'ON' ) then
            MemCtl(ipClear) = ON
            Return
         Else If ( Token(7:9).eq.'OFF' ) then
            MemCtl(ipClear) = OFF
            Return
         End If
      Else if ( Token(1:6).eq.'QUERY=') then
         If ( Token(7:8).eq.'ON' ) then
            MemCtl(ipQuery) = ON
            Return
         Else If ( Token(7:9).eq.'OFF' ) then
            MemCtl(ipQuery) = OFF
            Return
         End If
      Else if ( Token(1:6).eq.'CHECK=') then
         If ( Token(7:8).eq.'ON' ) then
            MemCtl(ipCheck) = ON
            Return
         Else If ( Token(7:9).eq.'OFF' ) then
            MemCtl(ipCheck) = OFF
            Return
         End If
      Else
         Write (6,*) 'SetMem: illegal option'
         Write (6,'(2A)') 'Option:',Token
         Call Abend()
      End if
*----------------------------------------------------------------------*
*     exit                                                             *
*----------------------------------------------------------------------*
      If ( MemCtl(ipTrace).eq.ON ) then
         Write(iW,*) ' <<< Exiting SetMem >>>'
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RBufF_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IADXS,MEMX)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: LUHLFX, LL, LBuf, NOTU, KKTU, IADXS, MEMX
real(kind=wp), intent(_OUT_) :: W(*)
integer(kind=iwp) :: BLKSZ, BPASS, I, IADX, IST, J, NBLCK, NPASS, NRST
real(kind=wp), allocatable :: BUF(:,:)

BLKSZ = (NOTU-1)*IADXS+LBuf
NBLCK = MEMX/BLKSZ

call mma_allocate(BUF,BLKSZ,NBLCK,LABEL='BUF')

BPASS = (LL+LBuf-1)/Lbuf
NPASS = (BPASS+NBLCK-1)/NBLCK

!write(u6,*) 'LL=',LL
!write(u6,*) 'LBUF=',LBUF
!write(u6,*) 'MEMX=',MEMX
!write(u6,*) 'BLKSZ=',BLKSZ
!write(u6,*) 'NBLCK=',NBLCK
!write(u6,*) 'BPASS=',BPASS
!write(u6,*) 'NPASS=',NPASS

IADX = (KKTU-1)*IADXS
IST = 1

do I=1,NPASS-1
  call dDAFILE(LUHLFX,2,BUF,size(BUF),IADX)

  do J=1,NBLCK
    call dcopy_(LBuf,BUF(:,J),1,W(IST),1)
    IST = IST+LBuf
  end do

  BPASS = BPASS-NBLCK
end do

NRST = (BPASS-1)*BLKSZ+mod(LL,LBuf)
call dDAFILE(LUHLFX,2,BUF,NRST,IADX)

do J=1,BPASS-1
  call dcopy_(LBuf,BUF(:,J),1,W(IST),1)
  IST = IST+LBuf
end do

NRST = mod(LL,LBuf)

call dcopy_(NRST,BUF(:,BPASS),1,W(IST),1)

call mma_deallocate(BUF)

return

end subroutine RBufF_tra2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Function rMass(nAtom)
************************************************************************
*                                                                      *
* Object: to return the mass of the nucleus as a function of the       *
*         atomic number, nAtom. The mass is that one of the most       *
*         abundant isotope. In the case there is not stable isotope    *
*         we select the one with the longest lifetime.                 *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      Use Isotopes
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "constants2.fh"
      Real*8 rMass
*
      rMass=rMassx(nAtom,0)
      Return
      End
*
      Function rMassx(nAtom,nIso)
      Use Isotopes
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "constants2.fh"
      Real*8 rMassx
      Integer nIso
*
      rMassx=Zero
      If (nAtom.gt.MaxAtomNum) Then
*        Write (6,*) ' Weight for this atom is not listed!'
*        Write (6,*) ' Mass set to 2.6 times atom number'
         rMassx = 2.6D0 * DBLE(nAtom) * uToau
      Else If (nAtom.eq.0) Then
*        Write (6,*) ' Weight for this atom is meaningless!'
*        Write (6,*) ' Mass set to 0.0'
      Else If (nAtom.lt.0) Then
         rMassx = 1.0D99 * uToau
      Else
         isnx=nIso
         Call Isotope(isnx,nAtom,rMassx)
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!***********************************************************************

subroutine SCARMT(MATIN,NROWIN,NCOLIN,MATUT,NROWUT,NCOLUT,ISCA,SSCA)
! Scatter-add  rows of MATIN to transposed matrix MATUT
!
!  MATUT(J,ISCA(I)) = MATUT(J,ISCA(I)) + SSCA(I)*MATIN(I,J)
!  (if INDEX(I) /= 0)
!
! Jeppe Olsen, Getting LUCIA in shape, Feb1994

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NROWIN, NCOLIN, NROWUT, NCOLUT, ISCA(NROWIN)
real(kind=wp), intent(in) :: MATIN(NROWIN,NCOLIN), SSCA(NROWIN)
real(kind=wp), intent(inout) :: MATUT(NCOLUT,NROWUT)
integer(kind=iwp) :: I, ICINBL, ICINEN, ICINOF, LBLK, NBLK

! (MATUT transposed!)

! To get rid of annoying and incorrect compiler warnings
ICINOF = 0

!LBLK = 100
LBLK = 40
NBLK = NCOLIN/LBLK
if (LBLK*NBLK < NCOLIN) NBLK = NBLK+1
do ICINBL=1,NBLK
  if (ICINBL == 1) then
    ICINOF = 1
  else
    ICINOF = ICINOF+LBLK
  end if
  ICINEN = min(ICINOF+LBLK-1,NCOLIN)
  do I=1,NROWIN
    if (ISCA(I) /= 0) then
      MATUT(ICINOF:ICINEN,ISCA(I)) = MATUT(ICINOF:ICINEN,ISCA(I))+SSCA(I)*MATIN(I,ICINOF:ICINEN)
    end if
  end do
end do

return

end subroutine SCARMT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRDTMP(DPT2,NDPT2)

use Para_Info, only: King
use EQSOLV, only: iVecc
use caspt2_module, only: nAES, nAsh, nAshT, nIsh, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDPT2
real(kind=wp), intent(inout) :: DPT2(NDPT2)
integer(kind=iwp) :: idpt, iofdpt, isym, it, itabs, itq, iu, iuabs, iuq, na, ndtemp, ni, no
real(kind=wp), allocatable :: DTemp(:,:)

if (nasht == 0) return

ndtemp = nasht**2
call mma_allocate(dtemp,nAshT,nAshT,Label='DTemp')
DTemp(:,:) = Zero
!SVC: trdact is still serial and expects to work on the LUSOLV file,
! which is only on the master node. As long as the MKWW subroutines are
! not functioning in parallel, this part should be done only on the
! master node:
if (KING()) call trdact(IVECC,IVECC,dtemp)

call GADGOP(DTEMP,NDTEMP,'+')

iofdpt = 0
do isym=1,nsym
  ni = nish(isym)
  na = nash(isym)
  no = norb(isym)
  do it=1,na
    itq = ni+it
    itabs = naes(isym)+it
    do iu=1,na
      iuq = ni+iu
      iuabs = naes(isym)+iu
      idpt = iofdpt+itq+no*(iuq-1)
      DPT2(idpt) = DPT2(idpt)+dtemp(itabs,iuabs)
    end do
  end do
  iofdpt = iofdpt+no**2
end do
call mma_deallocate(dtemp)

end subroutine TRDTMP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_d2Mdx2(ZA,nAtoms,iAtom,iCar,dTdRAi,jAtom,jCar,d2Mdx2)

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, iAtom, iCar, jAtom, jCar
real(kind=wp), intent(in) :: ZA(nAtoms), dTdRAi
real(kind=wp), intent(out) :: d2Mdx2(3,3)
integer(kind=iwp) :: kAtom
real(kind=wp) :: tmpi, tmpj, ZB

!                                                                      *
!***********************************************************************
!                                                                      *
d2Mdx2(:,:) = Zero
do kAtom=1,nAtoms
  ZB = ZA(kAtom)
  if (kAtom == iAtom) then
    tmpi = One-dTdRAi
  else
    tmpi = -dTdRAi
  end if
  if (kAtom == jAtom) then
    tmpj = One-dTdRAi
  else
    tmpj = -dTdRAi
  end if

  select case (iCar)
    case (1)
      select case (jCar)
        case (1)
          d2Mdx2(2,2) = d2Mdx2(2,2)+Two*ZB*tmpi*tmpj
          d2Mdx2(3,3) = d2Mdx2(3,3)+Two*ZB*tmpi*tmpj
        case (2)
          d2Mdx2(1,2) = d2Mdx2(1,2)-ZB*tmpi*tmpj
          d2Mdx2(2,1) = d2Mdx2(2,1)-ZB*tmpj*tmpi
        case (3)
          d2Mdx2(1,3) = d2Mdx2(1,3)-ZB*tmpi*tmpj
          d2Mdx2(3,1) = d2Mdx2(3,1)-ZB*tmpj*tmpi
      end select
    case (2)
      select case (jCar)
        case (1)
          d2Mdx2(1,2) = d2Mdx2(1,2)-ZB*tmpj*tmpi
          d2Mdx2(2,1) = d2Mdx2(2,1)-ZB*tmpi*tmpj
        case (2)
          d2Mdx2(1,1) = d2Mdx2(1,1)+Two*ZB*tmpi*tmpj
          d2Mdx2(3,3) = d2Mdx2(3,3)+Two*ZB*tmpi*tmpj
        case (3)
          d2Mdx2(2,3) = d2Mdx2(2,3)-ZB*tmpi*tmpj
          d2Mdx2(3,2) = d2Mdx2(3,2)-ZB*tmpj*tmpi
      end select
    case (3)
      select case (jCar)
        case (1)
          d2Mdx2(1,3) = d2Mdx2(1,3)-ZB*tmpj*tmpi
          d2Mdx2(3,1) = d2Mdx2(3,1)-ZB*tmpi*tmpj
        case (2)
          d2Mdx2(2,3) = d2Mdx2(2,3)-ZB*tmpj*tmpi
          d2Mdx2(3,2) = d2Mdx2(3,2)-ZB*tmpi*tmpj
        case (3)
          d2Mdx2(1,1) = d2Mdx2(1,1)+Two*ZB*tmpi*tmpj
          d2Mdx2(2,2) = d2Mdx2(2,2)+Two*ZB*tmpi*tmpj
      end select
  end select
end do
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Compute_d2Mdx2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine KE_Covalent(N,lant,t,u,OPT, HCOV )
c this function computes the covalent CF Hamiltonian ofr a given Lanthanide
      Implicit None
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer N,OPT,lant
      Real(kind=8) ::  t,u
      Real(kind=8) ::  WCG ! Clebsh_Gordan Coefficeints
      Complex(kind=8) ::  HCOV(N,N)
c local variables
      Integer i,j,JLn,ms1,ns1
      Real(kind=8) ::  HCOV1(N,N)
      Real(kind=8) ::  test1
      external WCG
#include "stdalloc.fh"
#include "jcoeff.fh"

      HCOV1=0.0_wp
      HCOV=(0.0_wp,0.0_wp)
      JLn=N-1

      Do i=1,N
      ms1=-(N-1)+2*(i-1)
         Do j=1,N
         ns1=-(N-1)+2*(j-1)

      If(OPT.eq.1) Then !FULL calculation

            Do iLS=1,4
               Do iJ=1,17
                  Do iK=0,6,2
                     Do ika=-4,4,4
      test1=0.0_wp
      test1=WCG(JLn, JLn, 2*iK, 0,  JLn, JLn )
      If(test1.eq.0.0_wp) Go To 107
      HCOV1(i,j)=HCOV1(i,j)
     &                    + t*t/(u+dE(lant,iLS,iJ))
     &                    * Jx(lant,iLS,iJ, iK,ika,0,0)
     &                    * WCG(JLn, ns1, 2*iK, 2*ika, JLn, ms1 )
     &                    / WCG(JLn, JLn, 2*iK,     0, JLn, JLn )
 107  continue
                     End Do
                  End Do
               End Do
            End Do

      Else If(OPT.eq.2) Then ! 1/U approximation

            Do iLS=1,4
               Do iJ=1,17
                  Do iK=0,6,2
                     Do ika=-4,4,4
      test1=0.0_wp
      test1=WCG(JLn, JLn, 2*iK, 0,  JLn, JLn )
      If(test1.eq.0.0_wp) Go To 108
      HCOV1(i,j)=HCOV1(i,j) + t*t/u
     &                    * Jx(lant,iLS,iJ, iK,ika,0,0)
     &                    * WCG(JLn, ns1, 2*iK, 2*ika, JLn, ms1 )
     &                    / WCG(JLn, JLn, 2*iK,     0, JLn, JLn )
 108  continue
                     End Do
                  End Do
               End Do
            End Do
      End If
      ! kind=8, complex double precision
      HCOV(i,j)=cmplx(HCOV1(i,j),0.0_wp, wp)
      End Do !j
      End Do !i

      Call mma_deallocate(Jx)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989,2003, Jeppe Olsen                                 *
!***********************************************************************

subroutine DIHDJ_MOLCAS(IASTR,IBSTR,NIDET,JASTR,JBSTR,NJDET,NAEL,NBEL,IWORK,NORB,ONEBOD,HAMIL,ISYM,NINOB,ECORE,ICOMBI,PSIGN, &
                        IPRINT,TUVX,ExFac,IREOTS)
! A SET OF DETERMINANTS IA DEFINED BY ALPHA AND BETA STRINGS
! IASTR,IBSTR AND ANOTHER SET OF DETERMINATS DEFINED BY STRINGS
! JASTR AND JBSTR ARE GIVEN. OBTAIN CORRESPONDING HAMILTONIAN MATRIX
!
! IF ICOMBI /= 0 COMBINATIONS ARE USED FOR ALPHA AND BETA STRING
! THAT DIFFERS :
!   1/SQRT(2) * ( |I1A I2B| + PSIGN * |I2A I1B| )
!
! IF ISYM == 0 FULL HAMILTONIAN IS CONSTRUCTED
! IF ISYM /= 0 LOWER HALF OF HAMILTONIAN IS CONSTRUCTED
!
! JEPPE OLSEN JANUARY 1989
!             IREOTS added for new Molcas compatibility, August 2003

use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NAEL, NBEL, NIDET, NJDET, JASTR(NAEL,NJDET), JBSTR(NBEL,NJDET), NORB, ISYM, NINOB, ICOMBI, &
                                 IPRINT, IREOTS(NORB)
integer(kind=iwp), intent(inout) :: IASTR(NAEL,NIDET), IBSTR(NBEL,NIDET)
integer(kind=iwp), intent(out) :: IWORK(4*NORB+NIDET)
real(kind=wp), intent(in) :: ONEBOD(NORB,NORB), ECORE, PSIGN, TUVX(*), ExFac
real(kind=wp), intent(_OUT_) :: HAMIL(*)
integer(kind=iwp) :: I1, I1_REO, I2, I2_REO, IA, IA_REO, IAB, IAEL, IAEQIB, IB, IB_REO, IBEL, IDET, IDIFF, IEL, IEL1, iii, ILOOP, &
                     IORB, IORB_REO, IPERM, J1, J1_REO, J2, J2_REO, JA, JA_REO, JAB, JAEL, JAEQJB, JB, JB_REO, JBEL, JDET, JDIFF, &
                     JEL, JEL1, jjj, JORB, JORB_REO, JPERM, KLFREE, KLIAB, KLIAE, KLIBE, KLJAE, KLJBE, LHAMIL, MINI, NACM, NADIF, &
                     NBCM, NBDIF, NDIF0, NDIF1, NDIF2, NIABEL, NJABEL, NLOOP, NTERMS, NTEST
real(kind=wp) :: CONST, SGN, SIGNA, SIGNB, XVAL
real(kind=wp), external :: GETH2A

NTEST = 0
! Initialization
KLIAB = 0
IAEQIB = 0
JAEQJB = 0
CONST = Zero
IEL1 = 0
JEL1 = 0
IPERM = 0
JPERM = 0
SGN = Zero
SIGNA = Zero
SIGNB = Zero
XVAL = Zero
IA = 0
IB = 0
JA = 0
JB = 0
I1 = 0
I2 = 0
J1 = 0
J2 = 0
! SCRATCH SPACE

! 1 : EXPANSION OF ALPHA AND BETA STRINGS OF TYPE I

KLFREE = 1
KLIAE = KLFREE
KLFREE = KLIAE+NORB
KLIBE = KLFREE
KLFREE = KLIBE+NORB

KLJAE = KLFREE
KLFREE = KLJAE+NORB
KLJBE = KLFREE
KLFREE = KLJBE+NORB
if (ICOMBI /= 0) then
  KLIAB = KLFREE
  KLFREE = KLFREE+NIDET
end if

if (ICOMBI /= 0) then
  ! SET UP ARRAY COMPARING ALPHA AND BETA STRINGS IN IDET LIST
  do IDET=1,NIDET
    IAEQIB = 1
    do IEL=1,NAEL
      if (IASTR(IEL,IDET) /= IBSTR(IEL,IDET)) IAEQIB = 0
    end do
    IWORK(KLIAB-1+IDET) = IAEQIB
  end do
end if

if (ISYM == 0) then
  LHAMIL = NIDET*NJDET
else
  LHAMIL = NIDET*(NIDET+1)/2
end if
HAMIL(1:LHAMIL) = Zero

NTERMS = 0
NDIF0 = 0
NDIF1 = 0
NDIF2 = 0
! LOOP OVER J DETERMINANTS

do JDET=1,NJDET

  ! EXPAND JDET
  call ICOPY(NORB,[0],0,IWORK(KLJAE),1)
  call ICOPY(NORB,[0],0,IWORK(KLJBE),1)

  if (ICOMBI /= 0) then
    JAEQJB = 1
    do IEL=1,NAEL
      if (JASTR(IEL,JDET) /= JBSTR(IEL,JDET)) JAEQJB = 0
    end do
  end if

  do IAEL=1,NAEL
    IWORK(KLJAE-1+JASTR(IAEL,JDET)) = 1
  end do

  do IBEL=1,NBEL
    IWORK(KLJBE-1+JBSTR(IBEL,JDET)) = 1
  end do

  if (NTEST >= 10) then
    write(u6,*) ' LOOP 1000 JDET =  ',JDET
    write(u6,*) ' JASTR AND JBSTR'
    call IWRTMA(JASTR(1,JDET),1,NAEL,1,NAEL)
    call IWRTMA(JBSTR(1,JDET),1,NBEL,1,NBEL)
    write(u6,*) ' EXPANDED ALPHA AND BETA STRING'
    call IWRTMA(IWORK(KLJAE),1,NORB,1,NORB)
    call IWRTMA(IWORK(KLJBE),1,NORB,1,NORB)
  end if

  if (ISYM == 0) then
    MINI = 1
  else
    MINI = JDET
  end if
  do IDET=MINI,NIDET
    if (ICOMBI == 0) then
      NLOOP = 1
    else
      IAEQIB = IWORK(KLIAB-1+IDET)
      if (IAEQIB+JAEQJB == 0) then
        NLOOP = 2
      else
        NLOOP = 1
      end if
    end if

    do ILOOP=1,NLOOP
      NTERMS = NTERMS+1

      ! COMPARE DETERMINANTS

      ! SWAP IA AND IB FOR SECOND PART OF COMBINATIONS
      if (ILOOP == 2) then
        do iii=1,NAEL
          jjj = IASTR(iii,IDET)
          IASTR(iii,IDET) = IBSTR(iii,IDET)
          IBSTR(iii,IDET) = jjj
        end do
      end if

      NACM = 0
      do IAEL=1,NAEL
        NACM = NACM+IWORK(KLJAE-1+IASTR(IAEL,IDET))
      end do

      NBCM = 0
      do IBEL=1,NBEL
        NBCM = NBCM+IWORK(KLJBE-1+IBSTR(IBEL,IDET))
      end do

      NADIF = NAEL-NACM
      NBDIF = NBEL-NBCM
      if (NTEST >= 10) then
        write(u6,*) '  LOOP 900 IDET ',IDET
        write(u6,*) ' COMPARISON, NADIF, NBDIF ',NADIF,NBDIF
      end if

      if (NADIF+NBDIF > 2) cycle

      ! FACTOR FOR COMBINATIONS
      if (ICOMBI == 0) then
        CONST = One
      else
        if ((JAEQJB+IAEQIB) == 2) then
          CONST = One
        else if ((JAEQJB+IAEQIB) == 1) then
          CONST = One/sqrt(Two)*(One+PSIGN)
        else if ((JAEQJB+IAEQIB) == 0) then
          if (ILOOP == 1) then
            CONST = One
          else
            CONST = PSIGN
          end if
        end if
      end if

      ! FIND DIFFERING ORBITALS AND SIGN FOR PERMUTATION

      ! EXPAND IDET
      call ICOPY(NORB,[0],0,IWORK(KLIAE),1)
      call ICOPY(NORB,[0],0,IWORK(KLIBE),1)

      do IAEL=1,NAEL
        IWORK(KLIAE-1+IASTR(IAEL,IDET)) = 1
      end do

      do IBEL=1,NBEL
        IWORK(KLIBE-1+IBSTR(IBEL,IDET)) = 1
      end do

      if (NADIF == 1) then
        do IAEL=1,NAEL
          if (IWORK(KLJAE-1+IASTR(IAEL,IDET)) == 0) then
            IA = IASTR(IAEL,IDET)
            IEL1 = IAEL
            exit
          end if
        end do

        do JAEL=1,NAEL
          if (IWORK(KLIAE-1+JASTR(JAEL,JDET)) == 0) then
            JA = JASTR(JAEL,JDET)
            JEL1 = JAEL
            exit
          end if
        end do
        SIGNA = real((-1)**(JEL1+IEL1),kind=wp)
      end if
      if (NBDIF == 1) then
        do IBEL=1,NBEL
          if (IWORK(KLJBE-1+IBSTR(IBEL,IDET)) == 0) then
            IB = IBSTR(IBEL,IDET)
            IEL1 = IBEL
            exit
          end if
        end do

        do JBEL=1,NBEL
          if (IWORK(KLIBE-1+JBSTR(JBEL,JDET)) == 0) then
            JB = JBSTR(JBEL,JDET)
            JEL1 = JBEL
            exit
          end if
        end do
        SIGNB = real((-1)**(JEL1+IEL1),kind=wp)
      end if
      if (NADIF == 2) then
        IDIFF = 0
        do IAEL=1,NAEL
          if (IWORK(KLJAE-1+IASTR(IAEL,IDET)) == 0) then
            if (IDIFF == 0) then
              IDIFF = 1
              I1 = IASTR(IAEL,IDET)
              IPERM = IAEL
            else
              I2 = IASTR(IAEL,IDET)
              IPERM = IAEL+IPERM
              exit
            end if
          end if
        end do

        JDIFF = 0
        do JAEL=1,NAEL
          if (IWORK(KLIAE-1+JASTR(JAEL,JDET)) == 0) then
            if (JDIFF == 0) then
              JDIFF = 1
              J1 = JASTR(JAEL,JDET)
              JPERM = JAEL
            else
              J2 = JASTR(JAEL,JDET)
              JPERM = JAEL+JPERM
              exit
            end if
          end if
        end do
        SGN = real((-1)**(IPERM+JPERM),kind=wp)
      end if

      if (NBDIF == 2) then
        IDIFF = 0
        do IBEL=1,NBEL
          if (IWORK(KLJBE-1+IBSTR(IBEL,IDET)) == 0) then
            if (IDIFF == 0) then
              IDIFF = 1
              I1 = IBSTR(IBEL,IDET)
              IPERM = IBEL
            else
              I2 = IBSTR(IBEL,IDET)
              IPERM = IBEL+IPERM
              exit
            end if
          end if
        end do

        JDIFF = 0
        do JBEL=1,NBEL
          if (IWORK(KLIBE-1+JBSTR(JBEL,JDET)) == 0) then
            if (JDIFF == 0) then
              JDIFF = 1
              J1 = JBSTR(JBEL,JDET)
              JPERM = JBEL
            else
              J2 = JBSTR(JBEL,JDET)
              JPERM = JBEL+JPERM
              exit
            end if
          end if
        end do
        SGN = real((-1)**(IPERM+JPERM),kind=wp)
      end if

      ! OBTAIN VALUE OF HAMILTONIAN ELEMENT

      if ((NADIF == 2) .or. (NBDIF == 2)) then
        NDIF2 = NDIF2+1
        ! SGN * (I1 J1 | I2 J2 ) - ( I1 J2 | I2 J1 )
        I1 = I1+NINOB
        I2 = I2+NINOB
        J1 = J1+NINOB
        J2 = J2+NINOB
        ! Well, there is no reordering in integrals any more. so
        I1_REO = IREOTS(I1)
        J1_REO = IREOTS(J1)
        I2_REO = IREOTS(I2)
        J2_REO = IREOTS(J2)
        XVAL = SGN*(GETH2A(I1_REO,J1_REO,I2_REO,J2_REO,TUVX)-GETH2A(I1_REO,J2_REO,I2_REO,J1_REO,TUVX))
      else if ((NADIF == 1) .and. (NBDIF == 1)) then
        NDIF2 = NDIF2+1
        ! SGN * (IA JA | IB JB )
        IA = IA+NINOB
        IB = IB+NINOB
        JA = JA+NINOB
        JB = JB+NINOB

        IA_REO = IREOTS(IA)
        IB_REO = IREOTS(IB)
        JA_REO = IREOTS(JA)
        JB_REO = IREOTS(JB)
        XVAL = SIGNA*SIGNB*GETH2A(IA_REO,JA_REO,IB_REO,JB_REO,TUVX)
      else if (((NADIF == 1) .and. (NBDIF == 0)) .or. ((NADIF == 0) .and. (NBDIF == 1))) then
        NDIF1 = NDIF1+1
        ! SGN * (  H(I1 J1 ) +
        !  (SUM OVER ORBITALS OF BOTH      SPIN TYPES  ( I1 J1 | JORB JORB )
        ! -(SUM OVER ORBITALS OF DIFFERING SPIN TYPE   ( I1 JORB | JORB J1 ) )
        if (NADIF == 1) then
          I1 = IA+NINOB
          J1 = JA+NINOB
          SGN = SIGNA
        else
          I1 = IB+NINOB
          J1 = JB+NINOB
          SGN = SIGNB
        end if

        I1_REO = IREOTS(I1)
        J1_REO = IREOTS(J1)
        XVAL = ONEBOD(IREOTS(I1-NINOB),IREOTS(J1-NINOB))
        do JAEL=1,NAEL
          JORB = JASTR(JAEL,JDET)+NINOB
          JORB_REO = IREOTS(JORB)
          XVAL = XVAL+GETH2A(I1_REO,J1_REO,JORB_REO,JORB_REO,TUVX)
        end do
        do JBEL=1,NBEL
          JORB = JBSTR(JBEL,JDET)+NINOB
          JORB_REO = IREOTS(JORB)
          XVAL = XVAL+GETH2A(I1_REO,J1_REO,JORB_REO,JORB_REO,TUVX)
        end do
        if (NADIF == 1) then
          do JAEL=1,NAEL
            JORB = JASTR(JAEL,JDET)+NINOB
            JORB_REO = IREOTS(JORB)
            XVAL = XVAL-GETH2A(I1_REO,JORB_REO,JORB_REO,J1_REO,TUVX)
          end do
        else
          do JBEL=1,NBEL
            JORB = JBSTR(JBEL,JDET)+NINOB
            JORB_REO = IREOTS(JORB)
            XVAL = XVAL-GETH2A(I1_REO,JORB_REO,JORB_REO,J1_REO,TUVX)
          end do
        end if
        XVAL = XVAL*SGN
      else if ((NADIF == 0) .and. (NBDIF == 0)) then
        NDIF0 = NDIF0+1
        ! SUM(I,J OF JDET) H(I,J) + (I I | J J ) - (I J | J I )

        XVAL = ECORE
        do IAB=1,2
          if (IAB == 1) then
            NIABEL = NAEL
          else
            NIABEL = NBEL
          end if
          do JAB=1,2
            if (JAB == 1) then
              NJABEL = NAEL
            else
              NJABEL = NBEL
            end if
            do IEL=1,NIABEL
              if (IAB == 1) then
                IORB = IASTR(IEL,IDET)
              else
                IORB = IBSTR(IEL,IDET)
              end if
              IORB_REO = IREOTS(IORB)
              if (IAB == JAB) XVAL = XVAL+ONEBOD(IORB_REO,IORB_REO)
              IORB = IORB+NINOB
              do JEL=1,NJABEL
                if (JAB == 1) then
                  JORB = IASTR(JEL,IDET)+NINOB
                else
                  JORB = IBSTR(JEL,IDET)+NINOB
                end if
                JORB_REO = IREOTS(JORB)
                XVAL = XVAL+Half*GETH2A(IORB_REO,IORB_REO,JORB_REO,JORB_REO,TUVX)
                if (IAB == JAB) XVAL = XVAL-ExFac*Half*GETH2A(IORB_REO,JORB_REO,JORB_REO,IORB_REO,TUVX)
              end do
            end do
          end do
        end do
      end if

      if (ISYM == 0) then
        HAMIL((JDET-1)*NIDET+IDET) = HAMIL((JDET-1)*NIDET+IDET)+CONST*XVAL
      else
        HAMIL((IDET-1)*IDET/2+JDET) = HAMIL((IDET-1)*IDET/2+JDET)+CONST*XVAL
      end if
      ! RESTORE ORDER
      if (ILOOP == 2) then
        do iii=1,NAEL
          jjj = IASTR(iii,IDET)
          IASTR(iii,IDET) = IBSTR(iii,IDET)
          IBSTR(iii,IDET) = jjj
        end do
      end if
    end do
  end do
end do

if (IPRINT >= 2) then
  write(u6,*) '  HAMILTONIAN MATRIX'
  if (ISYM == 0) then
    call WRTMAT(HAMIL,NIDET,NJDET,NIDET,NJDET)
  else
    call PRSYM(HAMIL,NIDET)
  end if
end if

return

end subroutine DIHDJ_MOLCAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA_Frz(nFre,Prnt,nSym,EOcc,nFro,nOcc,nFro1)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nFre, nSym, nFro(nSym), nOcc(nSym)
logical(kind=iwp), intent(in) :: Prnt
real(kind=wp), intent(in) :: EOcc(*)
integer(kind=iwp), intent(out) :: nFro1(nSym)
integer(kind=iwp) :: l_Point, l_E, iCount, NumFre, iFre, i, iSym
real(kind=wp) :: xMin
integer(kind=iwp), allocatable :: Point(:), Pivot(:), iOcc(:)
real(kind=wp), allocatable :: E(:)
character(len=*), parameter :: SecNam = 'RPA_Frz'
integer(kind=iwp), external :: Cho_iRange

if ((nSym < 1) .or. (nSym > 8)) then
  write(u6,'(A,I6)') 'nSym=',nSym
  call RPA_Warn(3,SecNam//': illegal nSym')
else if (nSym == 1) then
  nFro1(1) = max(nFre,0)
  return
else
  nFro1(:) = 0
end if
if (nFre < 1) return

l_Point = nFre
l_E = nOcc(1)
do iSym=2,nSym
  l_E = l_E+nOcc(iSym)
end do
if (nFre > l_E) then
  call RPA_Warn(4,SecNam//': too many orbitals to freeze')
end if
call mma_allocate(Point,l_Point,label='ScrPnt')
call mma_allocate(iOcc,l_Point,label='iOcc')
call mma_allocate(E,l_Point,label='ScrOccE')
call mma_allocate(Pivot,l_Point,label='Pivot')

iCount = 0
do iSym=1,nSym
  iOcc(iSym) = iCount
  iCount = iCount+nOcc(iSym)
end do

iCount = 1
do iSym=1,nSym
  call dCopy_(nOcc(iSym),EOcc(iCount+nFro(iSym)),1,E(iOcc(iSym)+1),1)
  iCount = iCount+nFro(iSym)+nOcc(iSym)
end do

xMin = -1.0e15_wp
NumFre = nFre
E(:) = -E(:)
call CD_DiaMax(E,l_E,Pivot,Point,NumFre,xMin)
if (NumFre /= nFre) then
  write(u6,'(2(A,I12))') 'NumFre=',NumFre,'  nFre=',nFre
  call RPA_Warn(3,SecNam//': NumFre != nFre')
end if

do iFre=1,nFre
  iSym = Cho_iRange(Point(iFre),iOcc,nSym,.false.)
  nFro1(iSym) = nFro1(iSym)+1
end do

if (Prnt) then
  write(u6,'(/,3X,A,A,A)') 'Output from ',SecNam,':'
  write(u6,'(A,I5,A)') 'The',nFre,' lowest occupied orbitals have been frozen.'
  write(u6,'(A)') 'List of frozen occupied orbitals:'
  do iFre=1,nFre
    iCount = Point(iFre)
    iSym = Cho_iRange(iCount,iOcc,nSym,.false.)
    i = iCount-iOcc(iSym)
    write(u6,'(1X,A,I5,A,I1,A,F15.8)') 'Occupied orbital',i,' of symmetry ',iSym,' and energy ',-E(iCount)
  end do
  call xFlush(u6)
end if

call mma_deallocate(Point)
call mma_deallocate(iOcc)
call mma_deallocate(E)
call mma_deallocate(Pivot)

end subroutine RPA_Frz

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Marcus Johansson                                 *
************************************************************************
      Subroutine fmsym(iReturn)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "WrkSpc.fh"
      Call fmsym_create_context(ctx)
      Call fmsym_set_elements(ctx)
      Call fmsym_find_symmetry(ctx)
      Call fmsym_symmetrize_molecule(ctx)
      Call fmsym_generate_orbital_subspaces(ctx)
      Call fmsym_symmetrize_orb_file(ctx,'INPORB')
      Call fmsym_release_context(ctx)
      iReturn = 0
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MK_TWDM(mSym,TDMZZ,WDMZZ,nTDMZZ,SCR,nSCR,iOFF,NBASF,
     &                   ISY12)
      use definitions, only: iwp, wp
      use constants, only: Zero
      use Symmetry_Info, only: MUL
      IMPLICIT NONE
      INTEGER(KIND=IWP), INTENT(IN):: mSYM, nTDMZZ,nSCR,ISY12
      REAL(KIND=WP), INTENT(IN):: TDMZZ(NTDMZZ),WDMZZ(NTDMZZ)
      REAL(KIND=WP), INTENT(OUT):: SCR(nSCR,4)
      INTEGER(KIND=IWP), INTENT(IN):: IOFF(mSYM), NBASF(mSym)

      INTEGER(KIND=IWP) IOF,ITD,ISY,NB,J,I,IJ,ISY1,NB1,ISY2,NB2
      REAL(KIND=WP) TDM,WDM
C CALCULATE THE SYMMETRIC AND ANTISYMMETRIC FOLDED TRANS D MATRICES
C AND SIMILAR WE-REDUCED SPIN DENSITY MATRICES

C SPECIAL CASE: DIAGONAL SYMMETRY BLOCKS.
      SCR(:,:)=Zero
      IF(ISY12.EQ.1) THEN
        IOF=0
        ITD=0
        DO ISY=1,mSym
          NB=NBASF(ISY)
          IF(NB.EQ.0) CYCLE
          DO J=1,NB
            DO I=1,NB
              ITD=ITD+1
              TDM=TDMZZ(ITD)
              WDM=WDMZZ(ITD)
              IF(I.GE.J) THEN
                IJ=IOF+(I*(I-1))/2+J
                IF(I.GT.J) THEN
                  SCR(IJ,2)=SCR(IJ,2)+TDM
                  SCR(IJ,4)=SCR(IJ,4)+WDM
                END IF
              ELSE
                IJ=IOF+(J*(J-1))/2+I
                SCR(IJ,2)=SCR(IJ,2)-TDM
                SCR(IJ,4)=SCR(IJ,4)-WDM
              END IF
              SCR(IJ,1)=SCR(IJ,1)+TDM
              SCR(IJ,3)=SCR(IJ,3)+WDM
            END DO
          END DO
          IOF=IOF+(NB*(NB+1))/2
        END DO
      ELSE
C GENERAL CASE, NON-DIAGONAL SYMMETRY BLOCKS
C THEN LOOP OVER ELEMENTS OF TDMZZ
        ITD=0
        DO ISY1=1,mSym
          NB1=NBASF(ISY1)
          IF(NB1.EQ.0) CYCLE
          ISY2=MUL(ISY1,ISY12)
          NB2=NBASF(ISY2)
          IF(NB2.EQ.0) CYCLE
          IF(ISY1.GT.ISY2) THEN
            DO J=1,NB2
              DO I=1,NB1
                ITD=ITD+1
                TDM=TDMZZ(ITD)
                WDM=WDMZZ(ITD)
                IJ=IOFF(ISY1)+I+NB1*(J-1)
                SCR(IJ,1)=SCR(IJ,1)+TDM
                SCR(IJ,2)=SCR(IJ,2)+TDM
                SCR(IJ,3)=SCR(IJ,3)+WDM
                SCR(IJ,4)=SCR(IJ,4)+WDM
              END DO
            END DO
          ELSE
            DO J=1,NB2
              DO I=1,NB1
                ITD=ITD+1
                TDM=TDMZZ(ITD)
                WDM=WDMZZ(ITD)
                IJ=IOFF(ISY2)+J+NB2*(I-1)
                SCR(IJ,1)=SCR(IJ,1)+TDM
                SCR(IJ,2)=SCR(IJ,2)-TDM
                SCR(IJ,3)=SCR(IJ,3)+WDM
                SCR(IJ,4)=SCR(IJ,4)-WDM
              END DO
            END DO
          END IF
        END DO
      END IF
*
      END SUBROUTINE MK_TWDM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines:
c     diis
c     calcr
c     calcrh1
c     diiswa1
c     diisra
c     diisof
c     diiscf
c     diisrf
c     diish1
c     diish2
c     diish3
c
c     gauss
c
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
       subroutine diis (wrk,wrksize,
     & diispointt,diispointr,key)
c
c     1) increment key
c     2) if key >=firstext do:
c     Tn = DIIS (previous cycext)
c     Tn=(T21,T22,T23,T13,T14)
c     if key < firstext
c     Tn=Tn(prev)
c
c     diispointt - pointer of T stack (I)
c     diispointr - pointer of R stack (I)
c     key        - manipulation key (I/O)
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer diispointt(1:4)
       integer diispointr(1:4)
       integer key
c
c     help variables
c
       real*8 rdiis1(1:4,1:4)
       real*8 cdiis(1:4)
       integer rc,lun1,nhelp
culf
      do i=1,4
         cdiis(i)=0.0
         do j=1,4
            rdiis1(i,j)=0.0
         enddo
      enddo
c1    increment key
       key=key+1
c
       if (key.lt.firstext) then
c
c     get Tn from last possition
c
c     get lun number
       lun1=diispointt(1)
c     rewind lun1
       call filemanager (2,lun1,rc)
c     T2aaaa
       call getmediate (wrk,wrksize,
     & lun1,posst210,mapdt21,mapit21,rc)
c     T2bbbb
       call getmediate (wrk,wrksize,
     & lun1,posst220,mapdt22,mapit22,rc)
c     T2abab
       call getmediate (wrk,wrksize,
     & lun1,posst230,mapdt23,mapit23,rc)
c     T1aa
       call getmediate (wrk,wrksize,
     & lun1,posst130,mapdt13,mapit13,rc)
c     T1bb
       call getmediate (wrk,wrksize,
     & lun1,posst140,mapdt14,mapit14,rc)
c     rewind lun1
       call filemanager (2,lun1,rc)
c
       return
       end if
c
c2.1  make overlap matrix
c
c2.1.1rewind R-files
       call diisrf (diispointr,cycext)
c
c2.1.2.1  read R-T21
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.2.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 4,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,1)
c
c
c2.1.3.1  read R-T22
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.3.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 4,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,0)
c
c
c2.1.4.1  read R-T23
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.4.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 4,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,0)
c
c
c2.1.5.1  read R-T13
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.5.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 2,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,0)
c
c
c2.1.6.1  read R-T14
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.6.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 2,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,0)
c
c
c2.2.1calc DIIS coeficients
c
       call diish2 (rdiis1,cycext,cdiis,rc)
c2.2.2write DIIS coeficients
       if (fullprint.gt.1) then
       write(6,'(6X,A,4(F9.5,2X))') 'DIIS coeficients    :',
     & (cdiis(nhelp),nhelp=1,cycext)
       end if
c
c
c2.3  make new vector
c
c2.3.1rewind T-files
       call diisrf (diispointt,cycext)
c
c2.3.2.1  read T21
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.2.2  make new T21
       call diish3 (wrk,wrksize,
     & mapdt21,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
c2.3.3.1  read T22
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.3.2  make new T22
       call diish3 (wrk,wrksize,
     & mapdt22,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
c2.3.4.1  read T23
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.4.2  make new T23
       call diish3 (wrk,wrksize,
     & mapdt23,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
c2.3.5.1  read T13
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.5.2  make new T13
       call diish3 (wrk,wrksize,
     & mapdt13,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
c2.3.6.1  read T14
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.6.2  make new T14
       call diish3 (wrk,wrksize,
     & mapdt14,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
       return
       end
c
c     ------------------------------
c
       subroutine calcr (wrk,wrksize,
     & lune)
c
c     this routine calc difference vector Tn = Tn-E
c     Tn=(T12,T22,T23,T13,T14)
c
c     lune - lun of file, where E is stored (I)
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
       integer lune
c
c     help variables
c
       integer rc
c
c1    rewind lune
       call filemanager (2,lune,rc)
c
c     T2aaaa
       call getmediate (wrk,wrksize,
     & lune,possv10,mapdv1,mapiv1,rc)
       call calcrh1 (wrk,wrksize,
     & mapdt21,mapdv1)
c     T2bbbb
       call getmediate (wrk,wrksize,
     & lune,possv10,mapdv1,mapiv1,rc)
       call calcrh1 (wrk,wrksize,
     & mapdt22,mapdv1)
c     T2abab
       call getmediate (wrk,wrksize,
     & lune,possv10,mapdv1,mapiv1,rc)
       call calcrh1 (wrk,wrksize,
     & mapdt23,mapdv1)
c     T1aa
       call getmediate (wrk,wrksize,
     & lune,possv10,mapdv1,mapiv1,rc)
       call calcrh1 (wrk,wrksize,
     & mapdt13,mapdv1)
c     T1bb
       call getmediate (wrk,wrksize,
     & lune,possv10,mapdv1,mapiv1,rc)
       call calcrh1 (wrk,wrksize,
     & mapdt14,mapdv1)
c
       return
       end
c
c     --------------
c
       subroutine calcrh1 (wrk,wrksize,
     & mapd1,mapd2)
c
c     this routine calc V1 = V1-V2
c
c     mapd1 - direct map of vecotr 1 (I)
c     mapd2 - direct map of vecotr 2 (I)
c
c     N.B. it is assumed, that V1 and V2 are of the same type
c
#include "wrk.fh"
c
       integer mapd1(0:512,1:6)
       integer mapd2(0:512,1:6)
c
c     help variables
c
       integer poss1,poss2,lenght,ii
c
c1    calc lenght
       ii=mapd1(0,5)
       lenght=mapd1(ii,1)+mapd1(ii,2)-mapd1(1,1)
c
c2    realize substract
       if (lenght.gt.0) then
       poss1=mapd1(1,1)
       poss2=mapd2(1,1)
       do 10 ii=0,lenght-1
       wrk(poss1+ii)=wrk(poss1+ii)-wrk(poss2+ii)
 10     continue
       end if
c
       return
       end
c
c     ------------------------------
c
       subroutine diiswa1 (wrk,wrksize,
     & diispoint)
c
c     this routine
c     a) upgrade diispoint
c     b) write write new amplitudes T21,T22,T23,T13,T14 into
c     proper possition
c
c     diispoint - array of lun's where N-1, N-2 .. amplitudes
c     are stored (I/O)
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer diispoint(1:4)
c
c     help variables
c
       integer lun1,rc,p
c
c
c1    upgrade diispoint
c
       lun1=diispoint(cycext)
c
       do 10 p=cycext-1,1,-1
       diispoint(p+1)=diispoint(p)
 10     continue
c
       diispoint(1)=lun1
c
c
c2    save aplitudes
c
c2.1  rewind lun1 file
       lun1=diispoint(1)
       call filemanager (2,lun1,rc)
c
c2.2  write T21
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt21,mapit21,rc)
c
c2.3  write T22
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt22,mapit22,rc)
c
c2.4  write T23
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt23,mapit23,rc)
c
c2.5  write T13
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt13,mapit13,rc)
c
c2.6  write T14
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt14,mapit14,rc)
c
c2.1  rewind lun1 file
       call filemanager (2,lun1,rc)
c
       return
       end
c
c     ------------------------------
c
       subroutine diisra (wrk,wrksize,
     & diispoint,num,
     & mapd1,mapi1,poss10,mapd2,mapi2,poss20,
     & mapd3,mapi3,poss30,mapd4,mapi4,poss40)
c
c     this routine read num vectors of amplitudes
c     form prepaired diispoint(1) - diispoint(num) files
c
c     diispoint - stack of lun numbers (I)
c     num       - number of vertors to be read (1-4) (I)
c     mapd1     - direct matrix of vector 1 (I)
c     mapi1     - inverse matrix of vector 1 (I)
c     poss10    - initial possition of vector 1 (I)
c     mapd2     - direct matrix of vector 2 (I)
c     mapi2     - inverse matrix of vector 2 (I)
c     poss20    - initial possition of vector 2 (I)
c     mapd3     - direct matrix of vector 3 (I)
c     mapi3     - inverse matrix of vector 3 (I)
c     poss30    - initial possition of vector 3 (I)
c     mapd4     - direct matrix of vector 4 (I)
c     mapi4     - inverse matrix of vector 4 (I)
c     poss40    - initial possition of vector 4 (I)
c     if there is less tahn 4 vecrors required
c     use any map's and poss's
c
#include "wrk.fh"
c
       integer diispoint(1:4)
       integer num
c
       integer mapd1(0:512,1:6)
       integer mapd2(0:512,1:6)
       integer mapd3(0:512,1:6)
       integer mapd4(0:512,1:6)
       integer mapi1(1:8,1:8,1:8)
       integer mapi2(1:8,1:8,1:8)
       integer mapi3(1:8,1:8,1:8)
       integer mapi4(1:8,1:8,1:8)
       integer poss10,poss20,poss30,poss40
c
c     help variables
c
       integer lun,rc
c
c
       if (num.eq.1) then
       lun=diispoint(1)
       call getmediate (wrk,wrksize,
     & lun,poss10,mapd1,mapi1,rc)
       else if (num.eq.2) then
       lun=diispoint(1)
       call getmediate (wrk,wrksize,
     & lun,poss10,mapd1,mapi1,rc)
       lun=diispoint(2)
       call getmediate (wrk,wrksize,
     & lun,poss20,mapd2,mapi2,rc)
       else if (num.eq.3) then
       lun=diispoint(1)
       call getmediate (wrk,wrksize,
     & lun,poss10,mapd1,mapi1,rc)
       lun=diispoint(2)
       call getmediate (wrk,wrksize,
     & lun,poss20,mapd2,mapi2,rc)
       lun=diispoint(3)
       call getmediate (wrk,wrksize,
     & lun,poss30,mapd3,mapi3,rc)
       else if (num.eq.4) then
       lun=diispoint(1)
       call getmediate (wrk,wrksize,
     & lun,poss10,mapd1,mapi1,rc)
       lun=diispoint(2)
       call getmediate (wrk,wrksize,
     & lun,poss20,mapd2,mapi2,rc)
       lun=diispoint(3)
       call getmediate (wrk,wrksize,
     & lun,poss30,mapd3,mapi3,rc)
       lun=diispoint(4)
       call getmediate (wrk,wrksize,
     & lun,poss40,mapd4,mapi4,rc)
       end if
c
       return
       end
c
c     ------------------------------
c
       subroutine diisof (diispoint,ndiis)
c
c     this routine open 1-ndiis Temp files for DIIS procedure
c     and store lun's in stack (diispoint)
c
c     diispoint - stack of lun numbers (I)
c     ndiis     - size of diis procedure (I)
c
       integer ndiis
       integer diispoint(1:4)
c
c     help variables
c
       integer lun,rc
c
c
       if (ndiis.gt.0) then
       call filemanager (1,lun,rc)
       diispoint(1)=lun
       end if
c
       if (ndiis.gt.1) then
       call filemanager (1,lun,rc)
       diispoint(2)=lun
       end if
c
       if (ndiis.gt.2) then
       call filemanager (1,lun,rc)
       diispoint(3)=lun
       end if
c
       if (ndiis.gt.3) then
       call filemanager (1,lun,rc)
       diispoint(4)=lun
       end if
c
       return
       end
c
c     ------------------------------
c
       subroutine diisrf (diispoint,ndiis)
c
c     this routine rewind 1-ndiis Temp files for DIIS procedure
c     lun's are stored in stack (diispoint)
c
c     diispoint - stack of lun numbers (I)
c     ndiis     - size of diis procedure (I)
c
       integer ndiis
       integer diispoint(1:4)
c
c     help variables
c
       integer lun,rc
c
c
       if (ndiis.gt.0) then
       lun=diispoint(1)
       call filemanager (2,lun,rc)
       end if
c
       if (ndiis.gt.1) then
       lun=diispoint(2)
       call filemanager (2,lun,rc)
       end if
c
       if (ndiis.gt.2) then
       lun=diispoint(3)
       call filemanager (2,lun,rc)
       end if
c
       if (ndiis.gt.3) then
       lun=diispoint(4)
       call filemanager (2,lun,rc)
       end if
c
       return
       end
c
c     ------------------------------
c
       subroutine diiscf (diispoint,ndiis)
c
c     this routine close 1-ndiis Temp files for DIIS procedure
c     lun's are stored in stack (diispoint)
c
c     diispoint - stack of lun numbers (I)
c     ndiis     - size of diis procedure (I)
c
       integer ndiis
       integer diispoint(1:4)
c
c     help variables
c
       integer lun,rc
c
c
       if (ndiis.gt.0) then
       lun=diispoint(1)
       call filemanager (3,lun,rc)
       end if
c
       if (ndiis.gt.1) then
       lun=diispoint(2)
       call filemanager (3,lun,rc)
       end if
c
       if (ndiis.gt.2) then
       lun=diispoint(3)
       call filemanager (3,lun,rc)
       end if
c
       if (ndiis.gt.3) then
       lun=diispoint(4)
       call filemanager (3,lun,rc)
       end if
c
c
       return
       end
c
c     ------------------------------
c
       subroutine diish1 (wrk,wrksize,
     & nind,rdiis1,mapd1,mapd2,mapd3,mapd4,
     & mapi1,mapi2,mapi3,mapi4,ndiis,szkey)
c
c     this routine upgrade rdiis1(p,q) maptix
c     rdiis1(p,q) = szkey*rdiis1(p,q) + (xp|xq)
c
c     nind   - number of indexes in vectors (i)
c     rdiis1 - overlap matrix of 1-5 vectors (O)
c     mapd1  - direct map of vector 1 (i)
c     mapd2  - direct map of vector 2 (i)
c     mapd3  - direct map of vector 3 (i)
c     mapd4  - direct map of vector 4 (i)
c     mapi1  - inverse map of vector 1 (i)
c     mapi2  - inverse map of vector 2 (i)
c     mapi3  - inverse map of vector 3 (i)
c     mapi4  - inverse map of vector 4 (i)
c     if tere is less than 5 vectors, use any map
c     ndiis  - dimension of DIIS (2-4) (I)
c     szkey  - 0 - no vanishing rdiis1 at the beggining
c     1 - vanishing rdiis1 at the beggining
c
#include "wrk.fh"
#include "ccsd1.fh"
c
       real*8 rdiis1(1:4,1:4)
       integer mapd1(0:512,1:6)
       integer mapd2(0:512,1:6)
       integer mapd3(0:512,1:6)
       integer mapd4(0:512,1:6)
       integer mapi1(1:8,1:8,1:8)
       integer mapi2(1:8,1:8,1:8)
       integer mapi3(1:8,1:8,1:8)
       integer mapi4(1:8,1:8,1:8)
c
       integer nind,ndiis,szkey
c
c     help variables
c
       integer nhelp
       real*8 scalar
       integer rc,num
c
c
       num=ndiis+1
c
       if (szkey.eq.1) then
       nhelp=4*4
       call mv0zero(nhelp,nhelp,rdiis1)
       end if
c
       if (num.gt.0) then
c     calc X11
       call multdot (wrk,wrksize,
     & nind,mapd1,mapi1,1,mapd1,mapi1,1,scalar,rc)
       rdiis1(1,1)=rdiis1(1,1)+scalar
       end if
c
       if (num.gt.1) then
c     X21
       call multdot (wrk,wrksize,
     & nind,mapd2,mapi2,1,mapd1,mapi1,1,scalar,rc)
       rdiis1(2,1)=rdiis1(2,1)+scalar
       rdiis1(1,2)=rdiis1(1,2)+scalar
c     X22
       call multdot (wrk,wrksize,
     & nind,mapd2,mapi2,1,mapd2,mapi2,1,scalar,rc)
       rdiis1(2,2)=rdiis1(2,2)+scalar
       end if
c
       if (num.gt.2) then
c     X31
       call multdot (wrk,wrksize,
     & nind,mapd3,mapi3,1,mapd1,mapi1,1,scalar,rc)
       rdiis1(3,1)=rdiis1(3,1)+scalar
       rdiis1(1,3)=rdiis1(1,3)+scalar
c     X32
       call multdot (wrk,wrksize,
     & nind,mapd3,mapi3,1,mapd2,mapi2,1,scalar,rc)
       rdiis1(3,2)=rdiis1(3,2)+scalar
       rdiis1(2,3)=rdiis1(2,3)+scalar
c     X33
       call multdot (wrk,wrksize,
     & nind,mapd3,mapi3,1,mapd3,mapi3,1,scalar,rc)
       rdiis1(3,3)=rdiis1(3,3)+scalar
       end if
c
       if (num.gt.3) then
c     X41
       call multdot (wrk,wrksize,
     & nind,mapd4,mapi4,1,mapd1,mapi1,1,scalar,rc)
       rdiis1(4,1)=rdiis1(4,1)+scalar
       rdiis1(1,4)=rdiis1(1,4)+scalar
c     X42
       call multdot (wrk,wrksize,
     & nind,mapd4,mapi4,1,mapd2,mapi2,1,scalar,rc)
       rdiis1(4,2)=rdiis1(4,2)+scalar
       rdiis1(2,4)=rdiis1(2,4)+scalar
c     X43
       call multdot (wrk,wrksize,
     & nind,mapd4,mapi4,1,mapd3,mapi3,1,scalar,rc)
       rdiis1(4,3)=rdiis1(4,3)+scalar
       rdiis1(3,4)=rdiis1(3,4)+scalar
c     X44
       call multdot (wrk,wrksize,
     & nind,mapd4,mapi4,1,mapd4,mapi4,1,scalar,rc)
       rdiis1(4,4)=rdiis1(4,4)+scalar
       end if
c
       return
       end
c
c     ----------------------
c
       subroutine diish2 (rdiis1,ndiis,cdiis,rc)
c
c     this rouine calculate diis coeficients by solving
c
c     B-1   c  =  0
c     -1 0   l    -1
c
c     and consequent normalization of coeficients
c
c
c     r1diis  - matrix of amp. overlap of ndiid+1 iterations (I)
c     ndiis   - size of diis (2-4) (I)
c     cdiis   - final diis coeficients (O)
c     rc      - return (error) code (O)
c     0 - OK
c     1 - singular DIIS matrix
c
c
       real*8 rdiis1(1:4,1:4)
       real*8 cdiis (1:4)
       integer ndiis,rc
c
c     help variables
c
       integer p,q
       real*8 scalar
       real*8 rdiis2(1:5,1:5)
       real*8 bb(1:5)
       real*8 ci(1:5)
c
c1    vanish rdiis2 file
       call mv0zero (25,25,rdiis2)
c
c2.1  make rdiis2 matrix
c
       do 10 p=1,ndiis
       do 11 q=1,ndiis
       rdiis2(p,q)=rdiis1(p,q)
 11     continue
 10     continue
c
       do 12 p=1,ndiis
       rdiis2(p,ndiis+1)=-1.0d0
       rdiis2(ndiis+1,p)=-1.0d0
       bb(p)=0.0d0
 12     continue
c
       bb(ndiis+1)=-1.0d0
c
c2.2  modify rdiis2 matrix
c
c     scale matrix
       scalar=sqrt(rdiis2(1,1)*rdiis2(ndiis,ndiis))
       do 13 q=1,ndiis
       do 14 p=1,ndiis
       rdiis2(p,q)=rdiis2(p,q)/scalar
 14     continue
 13     continue
c
c     add penalty function
       scalar=0.01d0*rdiis2(ndiis,ndiis)
c     rdiis2(ndiis,ndiis)=rdiis2(ndiis,ndiis)+scalar
c     bb(ndiis)=scalar
c
c
c3    solve SLE
c
c3.1  vanish ci
       do 20 p=1,ndiis+1
       ci(p)=0.0d0
 20     continue
c
c3.2  get cdiis
       call gauss (ndiis+1,5,rdiis2,ci,bb)
c
c4    final modification of cdiis coeficients
c
CFUE   if (rc.eq.1) then
c     matrix R2 was singular, no extrapolation
CFUE   write(6,*) ' SINGULAR DIIS MATRIX, NO EXTRAPOLATION'
CFUE   cdiis(1)=1.0d0
CFUE   do p=2,ndiis
CFUE   cdiis(p)=0.0d0
CFUE   end do
c
CFUE   else
c     DIIS procedure was succesfull, renormalize coef.
c
       scalar=0.0d0
       do 40 p=1,ndiis
       scalar=scalar+ci(p)
 40     continue
c
       do 50 p=1,ndiis
       cdiis(p)=ci(p)/scalar
 50     continue
c
       scalar=0.0d0
       do 60 p=1,ndiis
       scalar=scalar+cdiis(p)
 60     continue
c
CFUE   end if
c
CFUE   write(6,*) cdiis(1),cdiis(2),cdiis(3),cdiis(4),scalar
c51     format (5(i2,d12.7))
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(rc)
       end
c
c     -------------------------------------
c
       subroutine diish3 (wrk,wrksize,
     & mapd0,mapd1,mapd2,mapd3,mapd4,cdiis,ndiis)
c
c     this routine produce new vector
c     v(0) = sum(i) [cdiis(i) . V(i)]
c
c     mapd0  - direct map of V0 vector (I)
c     mapd1  - direct map of V1 vector (I)
c     mapd2  - direct map of V2 vector (I)
c     mapd3  - direct map of V3 vector (I)
c     mapd4  - direct map of V4 vector (I)
c     cdiis  - vector of diis coeficients (I)
c     ndiis  - size of diis (2-4) (I)
c
#include "wrk.fh"
c
       integer mapd0(0:512,1:6)
       integer mapd1(0:512,1:6)
       integer mapd2(0:512,1:6)
       integer mapd3(0:512,1:6)
       integer mapd4(0:512,1:6)
       real*8 cdiis(1:4)
       integer ndiis
c
c     help variables
c
       integer poss0,poss1,poss2,poss3,poss4,nhelp,lenght
c
c
       if (ndiis.eq.2) then
c     2 dimensional DIIS
c
       poss0=mapd0(1,1)
       poss1=mapd1(1,1)
       poss2=mapd2(1,1)
c
       nhelp=mapd1(0,5)
       lenght=mapd1(nhelp,1)+mapd1(nhelp,2)-mapd1(1,1)
c
       if (lenght.gt.0) then
       do 20 nhelp=0,lenght-1
       wrk(poss0+nhelp)=cdiis(1)*wrk(poss1+nhelp)
     & +cdiis(2)*wrk(poss2+nhelp)
 20     continue
       end if
c
       else if (ndiis.eq.3) then
c     3 dimensional DIIS
c
       poss0=mapd0(1,1)
       poss1=mapd1(1,1)
       poss2=mapd2(1,1)
       poss3=mapd3(1,1)
c
       nhelp=mapd1(0,5)
       lenght=mapd1(nhelp,1)+mapd1(nhelp,2)-mapd1(1,1)
c
       if (lenght.gt.0) then
       do 30 nhelp=0,lenght-1
       wrk(poss0+nhelp)=cdiis(1)*wrk(poss1+nhelp)
     & +cdiis(2)*wrk(poss2+nhelp)
     & +cdiis(3)*wrk(poss3+nhelp)
 30     continue
       end if
c
       else if (ndiis.eq.4) then
c     4 dimensional DIIS
c
       poss0=mapd0(1,1)
       poss1=mapd1(1,1)
       poss2=mapd2(1,1)
       poss3=mapd3(1,1)
       poss4=mapd4(1,1)
c
       nhelp=mapd1(0,5)
       lenght=mapd1(nhelp,1)+mapd1(nhelp,2)-mapd1(1,1)
c
       if (lenght.gt.0) then
       do 40 nhelp=0,lenght-1
       wrk(poss0+nhelp)=cdiis(1)*wrk(poss1+nhelp)
     & +cdiis(2)*wrk(poss2+nhelp)
     & +cdiis(3)*wrk(poss3+nhelp)
     & +cdiis(4)*wrk(poss4+nhelp)
 40     continue
       end if
c
       end if
c
       return
       end
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Diff_ThrsMul(ipMP,ThrsMul,ThrsMul_Clever,nAt,nij,lMax)
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"

      dMMax=0.0d0
      kauntA=0
      Do iAtom=1,nAt
        Do jAtom=1,iAtom
          kaunt=0
          Do l=0,1
            kComp=(l+1)*(l+2)/2
            Do k=1,kComp
              dM=Work(ipMP+nij*kaunt+kauntA)
              If(abs(dM).gt.dMMax)dMMax=abs(dM)
              kaunt=kaunt+1
            Enddo
          Enddo
          kauntA=kauntA+1
        Enddo
      Enddo

      ThrsMul_Clever=dMMax*ThrsMul

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lMax)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Chunk(LenVec,NumVec_,iChoVec,iSym,iVec_Global)

use RI_glob, only: Chunk
#ifdef _MOLCAS_MPP_
use RI_glob, only: iMap, ip_Chunk
use ChoSwp, only: InfVec
use Para_Info, only: MyRank, Is_Real_Par
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LenVec, NumVec_, iSym, iVec_Global
integer(kind=iwp), intent(inout) :: iChoVec
#ifdef _MOLCAS_MPP_
#include "mafdecls.fh"
integer(kind=iwp) :: Indx, iVec, J_e, J_s, ld, MuNu_e, MuNu_s, nJ
#endif

#ifndef _MOLCAS_MPP_
#include "macros.fh"
unused_var(iVec_Global)
#endif

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  call GA_Sync()
  call Cho_RI_SwapVecUnit(iSym)

  ! Get the subrange and check that we are within range.

  J_s = iMap(1+MyRank)
  if (J_s <= NumVec_) then
    J_e = iMap(1+MyRank+1)-1
    J_e = min(J_e,NumVec_)
    nJ = J_e-J_s+1
    if (nJ > 0) then
      MuNu_s = 1
      MuNu_e = LenVec
      call GA_Access(ip_Chunk,MuNu_s,MuNu_e,J_s,J_e,Indx,ld)
      !call RecPrt('Dbl_Mb(Indx)',' ',Dbl_Mb(Indx),LenVec,nJ)
      call Cho_PutVec(DBL_MB(Indx),LenVec,nJ,iChoVec+1,iSym)
      ! Set mapping from local to global vector index
      do iVec=1,nJ
        InfVec(iChoVec+iVec,5,iSym) = iVec_Global+J_s-2+iVec
      end do
      call GA_Release(ip_Chunk,MuNu_s,MuNu_e,J_s,J_e)
      iChoVec = iChoVec+nJ
    end if
  end if
  call Cho_RI_SwapVecUnit(iSym)
else
#endif
  call Cho_PutVec(Chunk,LenVec,NumVec_,iChoVec+1,iSym)
  iChoVec = iChoVec+NumVec_
#ifdef _MOLCAS_MPP_
end if
#endif

return

end subroutine Get_Chunk

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

module ipPage

use Data_Structures, only: Alloc1DArray_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
private

! n   : Length of CI-vector
! ida : disk address

integer(kind=iwp), parameter :: Max_CI_Vectors = 40, &
                                On_Disk = 0, In_Memory = 1, Null_Vector = 2, &
                                dWrite = 0, oWrite = 1, oRead = 2

integer(kind=iwp) :: ida(0:Max_CI_Vectors), iDisk_Addr_End = 0, Lu_ip, n(0:Max_CI_Vectors), n_CI_Vectors = 0, &
                     vStatus(0:Max_CI_Vectors)
logical(kind=iwp) :: DiskBased = .false.
type(Alloc1DArray_Type) :: W(0:Max_CI_Vectors)

public :: ipclose, ipget, ipin, ipin1, ipnout, ipopen, ipout, opout, W

contains

!=======================================================================
! Initiate the whole lot.
subroutine ipopen(page)

  logical(kind=iwp), intent(in) :: page
  integer(kind=iwp), external :: IsFreeUnit

  ! Ask how much memory is available

  if (Page) then

    ! Initiate for disk based storage.

    if (.not. DiskBased) then
      Lu_ip = IsFreeUnit(21)
      call Daname(Lu_ip,'TEMPCIV')
      DiskBased = .true.
    end if

    ! n  : Length of CI-vector
    ! ida: disk address

    n(0:Max_CI_Vectors) = 0
    ida(0:Max_CI_Vectors) = -1
    vStatus(0:Max_CI_Vectors) = Null_Vector

    ! iDisk_Addr_End: next free disk address
    ! n_CI_Vectors : number of CI-vectors

    iDisk_Addr_End = 0
    n_CI_Vectors = 0

  else

    call ipTerm()

  end if

end subroutine ipopen

!=======================================================================
! Object: release all vectors above and including the vector indexed ia.
subroutine ipclose(ia)

  integer(kind=iwp), intent(in) :: ia
  integer(kind=iwp) :: ii
  real(kind=wp) :: rdum(1)

  if (ia > Max_CI_Vectors) then
    write(u6,*) 'ipclose: ia > Max_CI_Vectors'
    write(u6,*) 'ia,Max_CI_Vectors=',ia,Max_CI_Vectors
    call Abend()
  end if

  ! Update iDisk_Addr_End

  iDisk_Addr_End = 0
  if (ia < 0) then

    n_CI_Vectors = 0
    call ipTerm()

  else

    n_CI_Vectors = ia-1
    if (DiskBased) then
      do ii=1,ia-1
        if (vStatus(ii) /= Null_Vector) call dDafile(Lu_ip,dWrite,rdum(1),n(ii),iDisk_Addr_End)
      end do
    end if

  end if

  ! Release memory and flag as a null vector

  do ii=max(ia,0),Max_CI_Vectors
    if (vStatus(ii) == In_Memory) then
      call mma_deallocate(W(ii)%A)
      ida(ii) = -1
      n(ii) = 0
      vStatus(ii) = Null_Vector
    end if
  end do

end subroutine ipclose

!=======================================================================
! Termination
subroutine ipterm()

  if (DiskBased) then
    call DaClos(Lu_ip)
    DiskBased = .false.
  end if

end subroutine ipterm

!=======================================================================
! Get the index of a vector with the length nn.
! Memory or disk space is allocated.
function ipget(nn)

  integer(kind=iwp) :: ipget
  integer(kind=iwp), intent(in) :: nn
  character(len=4) :: Label

  ! Take the next memory slot.

  n_CI_Vectors = n_CI_Vectors+1
  ipget = n_CI_Vectors

  if (n_CI_Vectors > Max_CI_Vectors) then
    write(u6,*) 'Number of CI vectors higher than Max_CI_Vectors'
    write(u6,*) 'Max_CI_Vectors=',Max_CI_Vectors
    call Abend()
  end if

  ida(ipget) = iDisk_Addr_End
  n(ipget) = nn

  ! Allocate memory for vector if of non-zero  length

  if (nn > 0) then
    write(Label,'(I3.3)') n_CI_Vectors
    call mma_allocate(W(ipget)%A,nn,Label='ipget'//Label)
    vStatus(ipget) = In_Memory
    W(ipget)%A(:) = Zero
  else
    !vStatus(ipget) = Null_Vector

    ! The calling code doesn't have the logic to handle the
    ! case that W(i)%A is not allocated. Hence, we have
    ! to make a dummy allocation to make sure that the compiler
    ! doesn't puke.
    n(ipget) = 1
    write(Label,'(I3.3)') n_CI_Vectors
    call mma_allocate(W(ipget)%A,1,Label='ipget'//Label)
    vStatus(ipget) = In_Memory
    W(ipget)%A(:) = Zero
  end if

  ! If DiskBased mode put vector on disc and release memory

  if (DiskBased) then
    if (vStatus(ipget) /= Null_Vector) then
      call dDafile(Lu_ip,oWrite,W(ipget)%A,nn,iDisk_Addr_End)
      vStatus(ipget) = On_Disk
      call mma_deallocate(W(ipget)%A)
    end if
  end if

end function ipget

! Object: retrieve vector ii with a length of nn and
!         make it available in memory as W(ii)%A
subroutine ipin1(ii,nn)

  integer(kind=iwp), intent(in) :: ii, nn
  integer(kind=iwp) :: idisk, nnn
  real(kind=wp), allocatable :: Tmp(:)

  if (ii > Max_CI_Vectors) then
    write(u6,*) 'ipin1: ii > Max_CI_Vectors'
    write(u6,*) 'ii,Max_CI_Vectors=',ii,Max_CI_Vectors
    call Abend()
  end if

  if (vStatus(ii) == In_Memory) then

    ! ii is in memory

    ! If the size of the vector is larger than was originally set
    ! resize the reservation and copy the content

    if (nn > n(ii)) then
      call mma_allocate(Tmp,nn,Label='Tmp')
      Tmp(:) = Zero
      Tmp(1:n(ii)) = W(ii)%A(:)
      call mma_deallocate(W(ii)%A)
      call mma_allocate(W(ii)%A,nn,Label='ipin1')
      W(ii)%A(:) = Tmp(:)
      call mma_deallocate(Tmp)
      n(ii) = nn
    end if

  else if (vStatus(ii) == On_Disk) then

    ! ii is on disk

    call mma_allocate(W(ii)%A,max(n(ii),nn),Label='ipin1')
    W(ii)%A(:) = Zero

    nnn = min(n(ii),nn)

    ! pick up from disk

    idisk = ida(ii)
    call dDafile(Lu_ip,oRead,W(ii)%A,nnn,idisk)
    vStatus(ii) = In_Memory

  else if (vStatus(ii) /= Null_Vector) then

    write(u6,*)
    write(u6,*) 'ipIn1: illegal vStatus(ii)'
    write(u6,*) 'ii=',ii
    write(u6,*)
    call Abend()

  end if

end subroutine ipin1

! Object: retrieve vector ii with a length of n(ii) and
!         make it available in memory as W(ii)%A
subroutine ipin(ii)

  integer(kind=iwp), intent(in) :: ii
  integer(kind=iwp) :: nn

  nn = n(ii)
  call ipin1(ii,nn)

end subroutine ipin

! ipout will page out vector ii to disk and free the memory area
subroutine ipout(ii)

  integer(kind=iwp), intent(in) :: ii
  integer(kind=iwp) :: idisk, nn

  if (DiskBased) then

    if ((vStatus(ii) == In_Memory) .and. (ii > 0)) then
      idisk = ida(ii)
      nn = n(ii)
      call dDafile(Lu_ip,oWrite,W(ii)%A,nn,idisk)
      vStatus(ii) = On_Disk
      call mma_deallocate(W(ii)%A)
    end if

  end if

end subroutine ipout

!=======================================================================
! Object: write all vectors in memory on disk but vector iii
subroutine ipnout(iii)

  integer(kind=iwp), intent(in) :: iii
  integer(kind=iwp) :: idisk, ii, nn

  if (iii > Max_CI_Vectors) then
    write(u6,*) 'ipout: iii > Max_CI_Vectors'
    write(u6,*) 'iii,Max_CI_Vectors=',iii,Max_CI_Vectors
    call Abend()
  end if

  if (DiskBased) then

    do ii=1,Max_CI_Vectors

      if ((vStatus(ii) == In_Memory) .and. (ii /= iii)) then
        idisk = ida(ii)
        nn = n(ii)
        call dDafile(Lu_ip,oWrite,W(ii)%A,nn,idisk)
        vStatus(ii) = On_Disk
        call mma_deallocate(W(ii)%A)
      end if

    end do

  end if

end subroutine ipnout

!=======================================================================
! opout will release the memory area of vector ii without updating the disk
subroutine opout(ii)

  integer(kind=iwp), intent(in) :: ii

  if (ii > Max_CI_Vectors) then
    write(u6,*) 'opout: ii > Max_CI_Vectors'
    write(u6,*) 'ii,Max_CI_Vectors=',ii,Max_CI_Vectors
    call Abend()
  end if

  if (DiskBased) then

    if ((vStatus(ii) == In_Memory) .and. (ii > 0)) then
      vStatus(ii) = On_Disk
      call mma_deallocate(W(ii)%A)
    end if

  end if

end subroutine opout

end module ipPage

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine WR_MOTRA_Info(Lu,iOpt,iDisk,TCONEMO,nTCONEMO,ECOR,NSYM,NBAS,NORB,NFRO,NDEL,MxSym,BSLBL,nBSLBL)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lu, iOpt, nTCONEMO, MxSym, nBSLBL
integer(kind=iwp), intent(inout) :: iDisk, TCONEMO(nTCONEMO), NSYM, nBas(MxSym), nOrb(MxSym), nFro(MxSym), nDel(MxSym)
real(kind=wp), intent(inout) :: ECOR
character, intent(inout) :: BSLBL(nBSLBL)
integer(kind=iwp) :: idum(1)
real(kind=wp) :: dum(1)

call iDafile(Lu,iOpt,TCONEMO,nTCONEMO,iDisk)
dum(1) = ECor
call dDafile(Lu,iOpt,dum,1,iDisk)
ECor = dum(1)
idum(1) = nSym
call iDafile(Lu,iOpt,idum,1,iDisk)
nSym = idum(1)
call iDafile(Lu,iOpt,nBas,MxSym,iDisk)
call iDafile(Lu,iOpt,nOrb,MxSym,iDisk)
call iDafile(Lu,iOpt,nFro,MxSym,iDisk)
call iDafile(Lu,iOpt,nDel,MxSym,iDisk)
call cDafile(Lu,iOpt,BSLBL,nBSLBL,iDisk)

return

end subroutine WR_MOTRA_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1992,1995, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine RFGrd( &
#                define _CALLING_
#                include "grd_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: to compute the multipole moments integrals with the          *
!         Gauss-Hermite quadrature.                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!             Modified to multipole moments November '90               *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified to reaction field calculations July '92         *
!             Modified to gradient calculations May '95                *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW
use PCM_arrays, only: MM
use Center_Info, only: dc
use Index_Functions, only: nTri_Elem1
use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: iAlpha, iBeta, ip, ipAlph, ipAxyz, ipBeta, ipBxyz, iPrint, ipRnxyz, ipRxyz, ipTemp1, ipTemp2, ipTemp3, iRout, &
                     iZeta, nip
logical(kind=iwp) :: ABeq(3)
#include "print.fh"

#include "macros.fh"
unused_var(ZInv)
unused_var(iStabM)
unused_var(nStabM)

iRout = 122
iPrint = nPrint(iRout)
!iPrint = 99
ABeq(:) = A == RB

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+2)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+2)
ipRxyz = nip
nip = nip+nZeta*3*nHer*(nOrdOp+1)
ipRnxyz = nip
nip = nip+nZeta*3*(la+2)*(lb+2)*(nOrdOp+1)
ipTemp1 = nip
nip = nip+nZeta
ipTemp2 = nip
nip = nip+nZeta
ipTemp3 = nip
nip = nip+3*nZeta*nHer
ipAlph = nip
nip = nip+nZeta
ipBeta = nip
nip = nip+nZeta
if (nip-1 > nArr*nZeta) then
  write(u6,*) ' nArr is Wrong! ',nip-1,' > ',nArr*nZeta
  call ErrTra()
  write(u6,*) ' Abend in RFGrd'
  call Abend()
end if

if (iPrint >= 49) then
  call RecPrt(' In RFGrd: A',' ',A,1,3)
  call RecPrt(' In RFGrd: RB',' ',RB,1,3)
  call RecPrt(' In RFGrd: CCoor',' ',CCoor,1,3)
  call RecPrt(' In RFGrd: P',' ',P,nZeta,3)
  write(u6,*) ' In RFGrd: la,lb=',la,lb
  write(u6,*) ' In RFGrd: nHer=',nHer
end if

! Compute the cartesian values of the basis functions angular part

do iZeta=1,nZeta
  Array(ipTemp1-1+iZeta) = Zeta(iZeta)**(-Half)
end do

call vCrtCmp(Array(ipTemp1),P,nZeta,A,Array(ipAxyz),la+1,HerR(iHerR(nHer)),nHer,ABeq)
call vCrtCmp(Array(ipTemp1),P,nZeta,RB,Array(ipBxyz),lb+1,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the contribution from the multipole moment operator

ABeq(:) = .false.
call vCrtCmp(Array(ipTemp1),P,nZeta,Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the cartesian components for the multipole moment
! integrals. The integrals are factorized into components.

call vAssmbl(Array(ipRnxyz),Array(ipAxyz),la+1,Array(ipRxyz),nOrdOp,Array(ipBxyz),lb+1,nZeta,HerW(iHerW(nHer)),nHer,Array(ipTemp3))

! Combine the cartesian components to the full one electron integral.

ip = ipAlph
do iBeta=1,nBeta
  call dcopy_(nAlpha,Alpha,1,Array(ip),1)
  ip = ip+nAlpha
end do
ip = ipBeta
do iAlpha=1,nAlpha
  call dcopy_(nBeta,Beta,1,Array(ip),nAlpha)
  ip = ip+1
end do
call CmbnRF1(Array(ipRnxyz),nZeta,la,lb,nOrdOp,Zeta,rKappa,rFinal,nComp,Array(ipTemp1),Array(ipTemp2),Array(ipAlph),Array(ipBeta), &
             Grad,nGrad,DAO,IfGrad,IndGrd,dc(mdc)%nStab,dc(ndc)%nStab,kOp,MM(1,2))

return

end subroutine RFGrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Giovanni Li Manni                                      *
************************************************************************
      Subroutine Readinp_expbas()
c
c     Author: G. Li Manni (University of Geneva)
c
      Implicit Real*8(a-h,o-z)
#include "info_expbas.fh"
      Character*180  Line, Blank, key, Get_Ln
      External Get_Ln
c
c Initial values
c
      DoExpbas = .true.
      DoDesy   = .false.
      EB_FileOrb  = ' '
c
      LuSpool=18
      LuSpool=isFreeUnit(LuSpool)
      Call SpoolInp(LuSpool)

      Rewind(LuSpool)
      Call RdNLst(LuSpool,'EXPBAS')
      Blank=' '

  999 Continue
*      Read(LuSpool,'(A)',End=9940) Line
      key =Get_Ln(LuSpool)
      Call LeftAd(key)
      Line = key
      If (Line(1:1).eq.'*' ) Goto 999
      If (Line.eq.Blank ) Goto 999
      Call UpCase(Line)
      If (Line(1:4).eq.'NOEX') Goto 1000
      If (Line(1:4).eq.'DESY') Goto 2000
      If (Line(1:4).eq.'FILE') Goto 3000
      If (Line(1:4).eq.'END ') Go To 99999
      Write (6,*) 'Unidentified key word  : '
      Call FindErrorLine
      Call Quit_OnUserError()

*========= NOEX =============
 1000 Continue
      DoExpbas = .false.
      Go To 999

*========= DESY =============
 2000 Continue
      DoDesy   = .true.
      Go To 999

*========= FILE =============
 3000 Continue
      Line=Get_Ln(LuSpool)
      Call FileOrb(Line,EB_FileOrb)
      Go To 999

c
c END of Input
c

c9940  Continue
      WRITE(6,*)' READIN: Premature end of file when reading selected'
      CALL ABEND()

99999 Continue

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RDINT2_MP2(IPRX)
! SECOND ORDER TWO-ELECTRON TRANFORMATION PROGRAM. TEST SECTION
!
! THIS SUBROUTINE READS AND CHECKS THE RESULT OF THE SECOND ORDER
! TWO-ELECTRON TRANSFORMATION PROGRAM TRA2. IT CAN BE CALLED BY
! TR2CTL IMMEDIATELY AFTER THE CALL TO TRA2

use MBPT2_Global, only: LuIntM, nBas
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IPRX
integer(kind=iwp) :: IAD131, IAD132, IAD13C, IADC, IADX1, IADX2, ISPQRS, LENGTH, LREC, LRECX, NSP, NSPQ, NSPQR, NSQ, NSR, NSS, NT, &
                     NU, NUM
real(kind=wp), allocatable :: Tmp(:)
#include "corbinf.fh"
#include "trafo.fh"

! READ ADDRESS RECORD ON UNIT LUINTM

IAD13 = 0
call iDAFILE(LUINTM,2,IADOUT,3888,IAD13)

! LOOP OVER QUADRUPLES OF SYMMETRIES (NSP,NSP,NSR,NSS)

ISPQRS = 0
do NSP=1,NSYM
  NBP = NBAS(NSP)
  NOP = NORB(NSP)
  NOCP = NOCC(NSP)
  do NSQ=1,NSP
    NBQ = NBAS(NSQ)
    NOQ = NORB(NSQ)
    NOCQ = NOCC(NSQ)
    NSPQ = Mul(NSP,NSQ)
    do NSR=1,NSYM
      NBR = NBAS(NSR)
      NOR = NORB(NSR)
      NOCR = NOCC(NSR)
      NSPQR = Mul(NSPQ,NSR)
      ISR = NSR
      do NSS=1,NSR
        NBS = NBAS(NSS)
        ISPQRS = ISPQRS+1
        if (NSPQR /= NSS) cycle
        NOS = NORB(NSS)
        NOCS = NOCC(NSS)
        if (NOCP*NOCQ*NOCR*NOCS == 0) cycle

        ! FIND ADDRESSES FOR THIS SYMMETRY BLOCK

        IADC = IADOUT(3*ISPQRS-2)
        IADX1 = IADOUT(3*ISPQRS-1)
        IADX2 = IADOUT(3*ISPQRS)
        write(u6,1000) NSP,NSQ,NSR,NSS
        if (IADC == 0) then
          write(u6,1100)
        else
          write(u6,1200) IADC
          IAD13C = IADC
        end if
        if (IADX1 == 0) then
          write(u6,1110)
        else
          write(u6,1210) IADX1
          IAD131 = IADX1
        end if
        if (IADX2 == 0) then
          write(u6,1120)
        else
          write(u6,1220) IADX2
          IAD132 = IADX2
        end if
        LREC = NOR*NOS
        if (NSR == NSS) LREC = (NOR**2+NOR)/2
        LRECX = NOR*NOS
        do NT=1,NOCP
          NUM = NOCQ
          if (NSP == NSQ) NUM = NT
          do NU=1,NUM
            if (IADC /= 0) then
              call mma_allocate(Tmp,LREC,label='Tmp')
              call dDAFILE(LUINTM,2,Tmp,LREC,IAD13C)
              if (IPRX /= 0) LENGTH = LREC
              if (IPRX == 0) LENGTH = min(LREC,10)
              write(u6,1300) NT,NU,Tmp(1:LENGTH)
              call mma_deallocate(Tmp)
            end if

            ! THE LOOP ABOVE OVER T AND U RECOVERS ONE BLOCK OF INTEGRALS (AB|TU
            ! FOR EACH PAIR T,U. TO PROCESS ONE BLOCK FOR ALL A AND B THE
            ! FOLLOWING LOOP STRUCTURE IS USED:
            !   IAB = 0
            !   do NA=1,NOR
            !     NBM = NOS
            !     if (NSR == NSS) NBM = NA
            !     do NB=1,NBM
            !       IAB = IAB+1
            !     end do
            !   end do
            ! WORK(IAB) NOW CONTAINS THE INTEGRAL (AB|TU)
            if (IADX1 /= 0) then
              call mma_allocate(Tmp,LRECX,label='Tmp')
              call dDAFILE(LUINTM,2,Tmp,LRECX,IAD131)
              if (IPRX /= 0) LENGTH = LRECX
              if (IPRX == 0) LENGTH = min(LRECX,10)
              write(u6,1310) NT,NU,Tmp(1:LENGTH)
              call mma_deallocate(Tmp)
            end if
            ! THE EXCHANGE INTEGRALS OF TYPE 1 ,(AT|BU) ARE PROCESSED AS THE
            ! COULOMB INTEGRALS. IF NST.NE.NSU THERE ARE ALSO EXCHANGE
            ! INTEGRALS OF TYPE 2, (AU|BT). THE ORDERING IS STILL T,U AND A,B
            ! BUT T IS NOW THE FOURTH INDEX AND U THE SECOND
            ! EXCHANGE INTEGRALS ARE ALWAYS QUADRATIC IN A,B
            if (IADX2 /= 0) then
              call mma_allocate(Tmp,LRECX,label='Tmp')
              call dDAFILE(LUINTM,2,Tmp,LRECX,IAD132)
              if (IPRX /= 0) LENGTH = LRECX
              if (IPRX == 0) LENGTH = min(LRECX,10)
              write(u6,1320) NT,NU,Tmp(1:LENGTH)
              call mma_deallocate(Tmp)
            end if
          end do
        end do

        ! ALL INTEGRALS FOR SYMMETRY BLOCK NSP,NSQ,NSR,NSS ARE READ

      end do
    end do
  end do
end do

return

1000 format(/1x,'SYMMETRY BLOCK',4i4)
1100 format(1x,'NO COULOMB INTEGRALS FOR THIS SYMMETRY BLOCK?')
1110 format(1x,'NO EXCHAN1 INTEGRALS FOR THIS SYMMETRY BLOCK?')
1120 format(1x,'NO EXCHAN2 INTEGRALS FOR THIS SYMMETRY BLOCK?')
1200 format(1x,'ADDRESS FOR COULOMB INTEGRALS',i8)
1210 format(1x,'ADDRESS FOR EXCHAN1 INTEGRALS',i8)
1220 format(1x,'ADDRESS FOR EXCHAN2 INTEGRALS',i8)
1300 format(/1x,'COULOMB INTEGRALS FOR TU PAIR',2i3/(1x,10f10.6))
1310 format(/1x,'EXCHAN1 INTEGRALS FOR TU PAIR',2i3/(1x,10f10.6))
1320 format(/1x,'EXCHAN2 INTEGRALS FOR TU PAIR',2i3/(1x,10f10.6))

end subroutine RDINT2_MP2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE mkVERTAB(NACTEL,M2SPIN,LSYM,NPART,NGASORB,NGASLIM,
     &                   ISSTAB,NFSB0,NRDETS0,NFSB,NRDETS)
      use stdalloc, only: mma_allocate, mma_deallocate
      use rassi_global_arrays, only: FSBARR
      use cntrl, only: MORSBITS
      use Symmetry_Info, only: nSym=>nIrrep, MUL
      IMPLICIT NONE
      INTEGER ISSTAB(*)
      INTEGER NASPRT,NACTEL,M2SPIN,LSYM
      INTEGER NPART
      INTEGER NGASORB(0:NSYM,0:NPART)
      INTEGER NGASLIM(2,NPART)
      INTEGER NFSB,NFSB0,NRDETS,NRDETS0
      INTEGER NVERT,IVER1,IVER2
      INTEGER IPOS,ISPART,NPC1,M2C1,ISC1
      INTEGER ISST,KPOP,KMS2,KSYM
      INTEGER MX1,MN1,MX2,MN2,IPART,NOREM,MINEL,MAXEL
      INTEGER ISPEND,NGO,NSP,ISPSTA,MNL,MXL,MNR,MXR,NO
      INTEGER NPC2,M2C2,ISC2
      INTEGER NSSTP,KSSTP,KPOPMAX,KMS2MAX,NPOP,MS2,NSSTPTR
      INTEGER N,IEND,ISTA,IADDR,ISAVE,NEXT
      INTEGER MS2MIN,MS2MAX,MSFACT,NVIDX,IVIDX,IVERT
      INTEGER LEVUP,LEVDWN,IADDR1,IADDR2,NARC
      INTEGER NARCVRT,NVERTAB,NDWNTAB,NARCLEV
      INTEGER NFSBARR,IVUP,LOWEST,ISW,NSW
      INTEGER KPOPLIM
      INTEGER IARC,IA,ISUM,KEEP
      INTEGER NSBS
      INTEGER NSDBLK
      INTEGER LIMARR(2,0:50)
      INTEGER ITRY(50)
      INTEGER, Allocatable::  SSTPTR(:), SSTARR(:), VIDX(:)
      INTEGER, Allocatable::  VERTAB(:), DWNTAB(:), LTDA(:)
      INTEGER, Allocatable::  WEIGHT(:), SWITCH(:)

*----------------------------------------------------------------
* Unbutton the substring table:
      NSYM  =ISSTAB(4)
      NASPRT=ISSTAB(5)
      NSSTP =ISSTAB(7)
      KSSTP =15

CTEST      write(*,*)' Test print in VERTAB.'
CTEST      write(*,*)' NSYM  :',NSYM
CTEST      write(*,*)' NASPRT:',NASPRT
CTEST      write(*,*)' NSSTP :',NSSTP
CTEST      write(*,*)' Substrings:'
CTEST      do isst=1,nsstp
CTEST       NSBS   = ISSTAB(KSSTP+0+5*(ISST-1))
CTEST       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
CTEST       KSYM   = ISSTAB(KSSTP+2+5*(ISST-1))
CTEST       MS2    = ISSTAB(KSSTP+3+5*(ISST-1))
CTEST       ISPART = ISSTAB(KSSTP+4+5*(ISST-1))
CTEST       write(*,'(1x,6i8)')isst,nsbs,npop,ksym,ms2,ispart
CTEST      end do
* Now the properties of the substring types can be picked up
* as
*       NSBS   = ISSTAB(KSSTP+0+5*(ISST-1))
*       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
*       ISYM   = ISSTAB(KSSTP+2+5*(ISST-1))
*       MS2    = ISSTAB(KSSTP+3+5*(ISST-1))
*       ISPART = ISSTAB(KSSTP+4+5*(ISST-1))
*---------------------------------------------------------------
* Determine KPOPMAX = Max population of any subpartition
* Determine KMS2MAX = Max spin proj in any subpartition
      KPOPMAX=0
      KMS2MAX=0
      DO ISST=1,NSSTP
       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
       MS2    = ISSTAB(KSSTP+3+5*(ISST-1))
       KPOPMAX=MAX(NPOP,KPOPMAX)
       KMS2MAX=MAX(MS2,KMS2MAX)
      END DO
CTEST      write(*,'(1x,a,8i8)')'KPOPMAX:',KPOPMAX
CTEST      write(*,'(1x,a,8i8)')'KMS2MAX:',KMS2MAX
*----------------------------------------------------------------
* Using the GAS restrictions, set up an array with min and max nr of
* electrons (cumulative) up to and including subpartition ISPART:
      MX1=0
      MN1=0
      MX2=NACTEL
      MN2=NACTEL
      DO IPART=1,NPART
       NOREM=NGASORB(0,IPART)
       MINEL=MAX(0,NGASLIM(1,IPART))
       MAXEL=MIN(NOREM,NGASLIM(2,IPART))
       MX2=MX2-MINEL
       MN2=MN2-MAXEL
      END DO
      ISPEND=0

      LIMARR(1,0)=0
      LIMARR(2,0)=0
      DO IPART=1,NPART
       NGO  =NGASORB(0,IPART)
       MINEL=MAX(0,NGASLIM(1,IPART))
       MAXEL=MIN(NGO,NGASLIM(2,IPART))
       NSP=(NGO+MORSBITS-1)/MORSBITS
       ISPSTA=ISPEND+1
       ISPEND=ISPEND+NSP
       MNL=MAX(MN1,MN2)
       MXL=MIN(MX1,MX2)
       MN1=MN1+MINEL
       MX1=MX1+MAXEL
       MN2=MN2+MAXEL
       MX2=MX2+MINEL
       MNR=MAX(MN1,MN2)
       MXR=MIN(MX1,MX2)
       NOREM=NGO
       DO ISPART=ISPSTA,ISPEND
        NO=MIN(NOREM,MORSBITS)
        NOREM=NOREM-NO
        LIMARR(1,ISPART)=MAX(MNL,MNR-NOREM)
        LIMARR(2,ISPART)=MIN(MXL+NGO-NOREM,MXR)
       END DO
      END DO
CTEST      write(*,*)' The LIMARR array:'
CTEST      write(*,'(1x,8i5)')(limarr(1,ispart),ispart=0,nasprt)
CTEST      write(*,'(1x,8i5)')(limarr(2,ispart),ispart=0,nasprt)

*----------------------------------------------------------------
* First, set up an array containing substring types.
* It would be nice to be able to quickly loop through just those
* substrings that have a limited population, and belong to a
* specific subpartition. To achieve this, we need a temporary
* array with index limits (0:KPOPMAX+1,1:NASPRT), and one with
* index limits (1:NSSTP).
      NSSTPTR=(KPOPMAX+2)*NASPRT
      CALL mma_allocate(SSTPTR,NSSTPTR,Label='SSTPTR')
      DO ISPART=1,NASPRT
        DO KPOP=1,KPOPMAX+2
          SSTPTR(KPOP+(KPOPMAX+2)*(ISPART-1))=0
        END DO
      END DO
      CALL mma_allocate(SSTARR,NSSTP,Label='SSTARR')
      DO ISST=1,NSSTP
       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
       ISPART = ISSTAB(KSSTP+4+5*(ISST-1))
       N=1+SSTPTR(1+NPOP+(KPOPMAX+2)*(ISPART-1))
       SSTPTR(1+NPOP+(KPOPMAX+2)*(ISPART-1))=N
      END DO
      IEND=0
      DO ISPART=1,NASPRT
        DO KPOP=0,KPOPMAX
          N=SSTPTR(1+KPOP+(KPOPMAX+2)*(ISPART-1))
          ISTA=IEND+1
          IEND=IEND+N
          SSTPTR(1+KPOP+(KPOPMAX+2)*(ISPART-1))=ISTA
        END DO
        SSTPTR(1+KPOPMAX+1+(KPOPMAX+2)*(ISPART-1))=IEND+1
      END DO
      DO ISST=1,NSSTP
       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
       ISPART = ISSTAB(KSSTP+4+5*(ISST-1))
       IADDR=SSTPTR(1+NPOP+(KPOPMAX+2)*(ISPART-1))
       SSTPTR(1+NPOP+(KPOPMAX+2)*(ISPART-1))=IADDR+1
       SSTARR(IADDR)=ISST
      END DO
      ISAVE=1
      DO ISPART=1,NASPRT
        DO KPOP=0,KPOPMAX
          NEXT=SSTPTR(1+KPOP+(KPOPMAX+2)*(ISPART-1))
          SSTPTR(1+KPOP+(KPOPMAX+2)*(ISPART-1))=ISAVE
          ISAVE=NEXT
        END DO
      END DO
CTESTC test print
CTEST      IADDR1=sstptr(1+(kpopmax+2)*(1-1))
CTEST      IADDR2=sstptr(1+kpopmax+1+(kpopmax+2)*(nasprt-1))
CTEST      write(*,'(1x,a,8i8)')'iaddr1,iaddr2:',iaddr1,iaddr2
CTEST      do IADDR=IADDR1,IADDR2-1
CTEST        isst=sstarr(IADDR)
CTEST        kpop=ISSTAB(KSSTP+1+5*(ISST-1))
CTEST        ksym=ISSTAB(KSSTP+2+5*(ISST-1))
CTEST        kms2=ISSTAB(KSSTP+3+5*(ISST-1))
CTEST      write(*,'(1x,a,8i8)')'iaddr,isst,kpop,ksym,kms2:',
CTEST     &                      iaddr,isst,kpop,ksym,kms2
CTEST      end do
CTESTC End of test print

*----------------------------------------------------------------
* Here follows the construction of a graph, to be used for
* producing the FSB table.
* Use a single unique compound index for the vertices
* This way, we can use a temporary counter array to
* identify vertices.
* Subpartition is in 1..NASPRT, so we need levels 0..NASPRT
* Cumulative population is in 0..NACTEL
* Intermediate spin projection is in MS2MIN..MS2MAX:
      MS2MIN=(M2SPIN-KMS2MAX*NASPRT)/2
      MS2MAX=(M2SPIN+KMS2MAX*NASPRT)/2
* and it runs in steps of two units.
      MSFACT=1+(MS2MAX-MS2MIN)/2
* Intermediate symmetry label is in 1..NSYM
* All in all, the index
*  IND=ISCUM+NSYM*(
*    (M2CUM-MS2MIN)/2 + MSFACT*(NPCUM + (NACTEL+1)*ISPART))
* should do the trick.
* Run through the generation procedure twice. First time, we will
* determine the sizes of the vertex and downchain tables, and
* allocate them. Second time, we will fill in the values in these
* tables, and then the temporary counter table can be deallocated.
*----------------------------------
* Allocate temporary counter array:
      NVIDX=NSYM*MSFACT*(NACTEL+1)*(NASPRT+1)
      CALL mma_allocate(VIDX,NVIDX,Label='VIDX')
      DO IVIDX=1,NVIDX
       VIDX(IVIDX)=0
      END DO
*----------------------------------
* Initialize top vertex:
      IPOS=LSYM+NSYM*((M2SPIN-MS2MIN)/2+MSFACT*(
     &              NACTEL+(NACTEL+1)*NASPRT))
      VIDX(IPOS)=1
      IVERT=1
*----------------------------------
* Recursively, find all other reachable vertices:
* Upper and lower level:
      DO LEVUP=NASPRT,1,-1
        LEVDWN=LEVUP-1
* A wasteful loop to pick out vertices on the upper level:
        DO NPC1=LIMARR(1,LEVUP),LIMARR(2,LEVUP)
         DO M2C1=-NPC1,NPC1,2
          IF(M2C1.LT.MS2MIN) GOTO 130
          IF(M2C1.GT.MS2MAX) GOTO 130
          DO ISC1=1,NSYM
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           IVER1=VIDX(+IPOS)
           IF(IVER1.EQ.0) GOTO 120
* This is a valid upper vertex on the upper level.
* Loop over valid arcs:
           KPOPLIM=MIN(NPC1,KPOPMAX)
           IADDR1=SSTPTR(1+(KPOPMAX+2)*(LEVUP-1))
           IADDR2=SSTPTR(1+KPOPLIM+1+(KPOPMAX+2)*(LEVUP-1))
           DO IADDR=IADDR1,IADDR2-1
             ISST=SSTARR(IADDR)
             KPOP=ISSTAB(KSSTP+1+5*(ISST-1))
             KSYM=ISSTAB(KSSTP+2+5*(ISST-1))
             KMS2=ISSTAB(KSSTP+3+5*(ISST-1))
* Just temporary sanity test:
             ISPART=ISSTAB(KSSTP+4+5*(ISST-1))
             IF(ISPART.NE.LEVUP) THEN
               WRITE(6,*)' THIS IS INSANE!'
               CALL ABEND()
             END IF
             NPC2=NPC1-KPOP
             IF(NPC2.LT.LIMARR(1,LEVDWN)) GOTO 110
             IF(NPC2.GT.LIMARR(2,LEVDWN)) GOTO 110
             M2C2=M2C1-KMS2
             IF(M2C2.LT.MS2MIN) GOTO 110
             IF(M2C2.GT.MS2MAX) GOTO 110
             ISC2=MUL(KSYM,ISC1)
             IF(ABS(M2C2).GT.NPC2) GOTO 110
             IF(NPC2.EQ.0 .AND. ISC2.NE.1) GOTO 110
* Inspect the lower vertex: Is it a new one?
             IPOS=ISC2+NSYM*((M2C2-MS2MIN)/2+MSFACT*(
     &              NPC2+(NACTEL+1)*LEVDWN))
             IVER2=VIDX(+IPOS)
             IF(IVER2.GT.0) GOTO 110
* This is a new vertex. Register its number
             IVERT=IVERT+1
             IVER2=IVERT
             VIDX(+IPOS)=IVER2
 110         CONTINUE
           END DO
* Finished looping over possible arcs.
 120      CONTINUE
         END DO
 130     CONTINUE
        END DO
       END DO
* Finished looping over possible upper vertices.
      END DO
* Finished loop over upper level, LEVUP.
*----------------------------------
* Now the index array holds a positive integer IV if the combination
* of properties is such that this vertex could be reached from above.
* We now need to keep just those that can also be reached from below.
* This is accomplished by a similar loop, now in the other direction:
*----------------------------------
      NARC=0
* Upper and lower level:
      DO LEVUP=1,NASPRT
        LEVDWN=LEVUP-1
* A wasteful loop to pick out vertices on the upper level:
        DO NPC1=LIMARR(1,LEVUP),LIMARR(2,LEVUP)
         DO M2C1=-NPC1,NPC1,2
          IF(M2C1.LT.MS2MIN) GOTO 230
          IF(M2C1.GT.MS2MAX) GOTO 230
          DO ISC1=1,NSYM
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           IVER1=VIDX(+IPOS)
           IF(IVER1.EQ.0) GOTO 220
* This is a valid upper vertex on the upper level.
* Is it reachable from below?
          NARCVRT=0
* Loop over valid arcs:
           KPOPLIM=MIN(NPC1,KPOPMAX)
           IADDR1=SSTPTR(1+(KPOPMAX+2)*(LEVUP-1))
           IADDR2=SSTPTR(1+KPOPLIM+1+(KPOPMAX+2)*(LEVUP-1))
           DO IADDR=IADDR1,IADDR2-1
             ISST=SSTARR(IADDR)
             KPOP=ISSTAB(KSSTP+1+5*(ISST-1))
             KSYM=ISSTAB(KSSTP+2+5*(ISST-1))
             KMS2=ISSTAB(KSSTP+3+5*(ISST-1))
* Just temporary sanity test:
             ISPART=ISSTAB(KSSTP+4+5*(ISST-1))
             IF(ISPART.NE.LEVUP) THEN
               WRITE(6,*)' THIS IS INSANE!'
               CALL ABEND()
             END IF
             NPC2=NPC1-KPOP
             IF(LEVDWN.EQ.0.AND.NPC2.GT.0) GOTO 210
             M2C2=M2C1-KMS2
             IF(M2C2.LT.MS2MIN) GOTO 210
             IF(M2C2.GT.MS2MAX) GOTO 210
             ISC2=MUL(KSYM,ISC1)
             IF(ABS(M2C2).GT.NPC2) GOTO 210
             IF(NPC2.EQ.0 .AND. ISC2.NE.1) GOTO 210
* Inspect the lower vertex: Is it reachable?
             IPOS=ISC2+NSYM*((M2C2-MS2MIN)/2+MSFACT*(
     &              NPC2+(NACTEL+1)*LEVDWN))
             IVER2=VIDX(+IPOS)
             IF(IVER2.GT.0) NARCVRT=NARCVRT+1
 210         CONTINUE
           END DO
* Finished looping over possible arcs.
* Remove this vertex if it was unreachable.
          IF(NARCVRT.EQ.0) THEN
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           VIDX(+IPOS)=0
          END IF
          NARC=NARC+NARCVRT
 220      CONTINUE
         END DO
 230     CONTINUE
        END DO
       END DO
* Finished looping over possible upper vertices.
      END DO
* Finished loop over upper level, LEVUP.
*----------------------------------
* Renumber the vertices:
      NVERT=0
* Upper and lower level:
      DO LEVUP=NASPRT,0,-1
* A wasteful loop to pick out vertices on the upper level:
        DO NPC1=LIMARR(1,LEVUP),LIMARR(2,LEVUP)
         DO M2C1=-NPC1,NPC1,2
          IF(M2C1.LT.MS2MIN) GOTO 330
          IF(M2C1.GT.MS2MAX) GOTO 330
          DO ISC1=1,NSYM
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           IVER1=VIDX(+IPOS)
           IF(IVER1.EQ.0) GOTO 320
           NVERT=NVERT+1
           VIDX(+IPOS)=NVERT
 320       CONTINUE
          END DO
 330      CONTINUE
         END DO
        END DO
       END DO
*----------------------------------
* Now allocate the vertex and downchain tables, and loop again:
      NVERTAB=6*NVERT
      CALL mma_allocate(VERTAB,NVERTAB,Label='VERTAB')
      NDWNTAB=3*NARC
      CALL mma_allocate(DWNTAB,NDWNTAB,Label='DWNTAB')
      IARC =0
CTEST      write(*,'(1x,a,8i8)')'Nr of vertices NVERT=',NVERT
CTEST      write(*,'(1x,a,8i8)')'Nr of arcs     NARC =',NARC
* --------------------------------------------------------------
C Allocate LTDA(1:2,1:NASPRT), Level-to-Downarc array:
      CALL mma_allocate(LTDA,2*(NASPRT+1),Label='LTDA')
*----------------------------------
* Upper and lower level:
      DO LEVUP=NASPRT,1,-1
        LEVDWN=LEVUP-1
* Level-to-Downarc array:
        LTDA(1+2*LEVUP)=IARC+1
        LTDA(1+2*LEVUP+1)=0
* Initialize counter of arcs from this upper level:
        NARCLEV=0
* A wasteful loop to pick out vertices on the upper level:
        DO NPC1=LIMARR(1,LEVUP),LIMARR(2,LEVUP)
         DO M2C1=-NPC1,NPC1,2
          IF(M2C1.LT.MS2MIN) GOTO 430
          IF(M2C1.GT.MS2MAX) GOTO 430
          DO ISC1=1,NSYM
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           IVER1=VIDX(+IPOS)
           IF(IVER1.EQ.0) GOTO 420
* This is a valid upper vertex on the upper level.
           VERTAB(+1+6*(IVER1-1))=LEVUP
           VERTAB(+2+6*(IVER1-1))=NPC1
           VERTAB(+3+6*(IVER1-1))=M2C1
           VERTAB(+4+6*(IVER1-1))=ISC1
           VERTAB(+5+6*(IVER1-1))=IARC+1
           VERTAB(+6+6*(IVER1-1))=0
* Initialize counter of arcs from this upper vertex:
           NARCVRT=0
* Loop over valid arcs:
           KPOPLIM=MIN(NPC1,KPOPMAX)
           IADDR1=SSTPTR(1+(KPOPMAX+2)*(LEVUP-1))
           IADDR2=SSTPTR(1+KPOPLIM+1+(KPOPMAX+2)*(LEVUP-1))
           DO IADDR=IADDR1,IADDR2-1
             ISST=SSTARR(IADDR)
             KPOP=ISSTAB(KSSTP+1+5*(ISST-1))
             KSYM=ISSTAB(KSSTP+2+5*(ISST-1))
             KMS2=ISSTAB(KSSTP+3+5*(ISST-1))
* Just temporary sanity test:
             ISPART=ISSTAB(KSSTP+4+5*(ISST-1))
             IF(ISPART.NE.LEVUP) THEN
               WRITE(6,*)' THIS IS INSANE!'
               CALL ABEND()
             END IF
             NPC2=NPC1-KPOP
             IF(LEVDWN.EQ.0.AND.NPC2.GT.0) GOTO 410
             M2C2=M2C1-KMS2
             IF(M2C2.LT.MS2MIN) GOTO 410
             IF(M2C2.GT.MS2MAX) GOTO 410
             ISC2=MUL(KSYM,ISC1)
             IF(ABS(M2C2).GT.NPC2) GOTO 410
             IF(NPC2.EQ.0 .AND. ISC2.NE.1) GOTO 410
* Is it a valid arc? See if a lower vertex exists.
             IPOS=ISC2+NSYM*((M2C2-MS2MIN)/2+MSFACT*(
     &              NPC2+(NACTEL+1)*LEVDWN))
             IVER2=VIDX(+IPOS)
             IF(IVER2.EQ.0) GOTO 410
* A valid arc has been found. The upper vertex IVER1 is
* joined to the lower vertex IVER2 by an arc associated
* with the substring type ISST.
             NARCVRT=NARCVRT+1
             NARCLEV=NARCLEV+1
             IARC=IARC+1
             DWNTAB(+1+3*(IARC-1))=ISST
             DWNTAB(+2+3*(IARC-1))=IVER1
             DWNTAB(+3+3*(IARC-1))=IVER2
 410         CONTINUE
           END DO
* Finished looping over possible arcs.
          VERTAB(+6+6*(IVER1-1))=NARCVRT
 420      CONTINUE
         END DO
 430     CONTINUE
        END DO
       END DO
* Finished looping over vertices on this level.
       LTDA(1+2*LEVUP+1)=NARCLEV
      END DO
* Finished loop over upper level, LEVUP.
      VERTAB(+1+6*(NVERT-1))=0
      VERTAB(+2+6*(NVERT-1))=0
      VERTAB(+3+6*(NVERT-1))=0
      VERTAB(+4+6*(NVERT-1))=1
      VERTAB(+5+6*(NVERT-1))=IARC
      VERTAB(+6+6*(NVERT-1))=0
      LTDA(1)=IARC
      LTDA(1+1)=0
*---------------------------------------------------------
* The graph is finished. we do no longer need these arrays:
      CALL mma_deallocate(SSTPTR)
      CALL mma_deallocate(SSTARR)
      CALL mma_deallocate(VIDX)
*---------------------------------------------------------
* A graph has been constructed. We may construct a weight array:
      CALL mma_allocate(WEIGHT,NVERT,Label='WEIGHT')
      DO IVERT=1,NVERT-1
       WEIGHT(+IVERT)=0
      END DO
      WEIGHT(+NVERT)=1
      DO LEVUP=1,NASPRT
        LEVDWN=LEVUP-1
* Loop over arcs leading down from upper level:
        NARCLEV=LTDA(1+2*LEVUP+1)
        DO IA=1,NARCLEV
          IARC=LTDA(1+2*LEVUP)-1+IA
          ISST =DWNTAB(+1+3*(IARC-1))
          IVER1=DWNTAB(+2+3*(IARC-1))
          IVER2=DWNTAB(+3+3*(IARC-1))
          ISUM=WEIGHT(+IVER1)+WEIGHT(+IVER2)
          WEIGHT(+IVER1)=ISUM
        END DO
      END DO
C No more use for Level-to-Downarc array:
      CALL mma_deallocate(LTDA)
*---------------------------------------------------------
* Now, for any vertex iv, WEIGHT(+iv) is the total number of
* downwalks that can reach vertex nr nvert (The bottom vertex).
* Traverse the graph. Use a swich array. The graph is traversed
* from the top. At each vertex, one of the available arcs downwards
* is selected. Which arc to select is given by ISWITCH(LEVUP), where
* LEVUP is the level of the upper vertex.
      CALL mma_allocate(SWITCH,NASPRT,Label='SWITCH')
* Initial values: Lowest walk
      DO LEVUP=1,NASPRT
        SWITCH(+LEVUP)=1
      END DO
* The total number of walks in the graph:
      NFSB0=WEIGHT(1)
      NFSBARR=(NASPRT+2)*NFSB0
      CALL mma_allocate(FSBARR,NFSBARR,Label='FSBARR')
      NRDETS0=0
      NFSB=0
      NRDETS=0
CTEST      write(*,*)' A list of all generated FS blocks:'
 500  CONTINUE
* Construct this walk. While constructing it, also find out if
* it has a successor.
      IVUP=1
      LOWEST=NASPRT+1
      DO LEVUP=NASPRT,1,-1
       ISW=SWITCH(+LEVUP)
* Select arc nr isw from those available to vertex ivup.
       IARC=VERTAB(+5+6*(IVUP-1))-1+ISW
* Could it be incremented?
       NSW=VERTAB(+6+6*(IVUP-1))
CTEST      write(*,'(1x,a,8i8)')'IVUP,ISW,NSW:',IVUP,ISW,NSW
       IF(NSW.GT.ISW) LOWEST=LEVUP
* Consult the downarc table:
       ISST =DWNTAB(+1+3*(IARC-1))
       IVER1=DWNTAB(+2+3*(IARC-1))
       IVER2=DWNTAB(+3+3*(IARC-1))
CTEST      write(*,'(1x,a,8i8)')'ISST,IVER1,IVER2:',ISST,IVER1,IVER2
       IF(IVER1.NE.IVUP) THEN
         WRITE(6,*)' OOOOPS! THIS SHOULD NOT HAPPEN.'
         CALL ABEND()
       END IF
       ITRY(LEVUP)=ISST
       IVUP=IVER2
      END DO
* Check GAS restrictions:
      NSDBLK=1
      ISPEND=0
      KEEP=1
      DO IPART=1,NPART
       NGO  =NGASORB(0,IPART)
       NSP=(NGO+MORSBITS-1)/MORSBITS
       ISPSTA=ISPEND+1
       ISPEND=ISPEND+NSP
       NOREM=NGO
       ISUM=0
       DO ISPART=ISPSTA,ISPEND
        ISST=ITRY(ISPART)
        NSBS   = ISSTAB(KSSTP+0+5*(ISST-1))
        NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
        ISUM=ISUM+NPOP
        NSDBLK=NSDBLK*NSBS
       END DO
       IF(ISUM.LT.NGASLIM(1,IPART)) KEEP=0
       IF(ISUM.GT.NGASLIM(2,IPART)) KEEP=0
      END DO
      NRDETS0=NRDETS0+NSDBLK
      IF(KEEP.EQ.1) THEN
        NFSB=NFSB+1
        DO ISPART=1,NASPRT
         FSBARR(ISPART+(NASPRT+2)*(NFSB-1))=ITRY(ISPART)
        END DO
        FSBARR(1+NASPRT+(NASPRT+2)*(NFSB-1))=NSDBLK
        FSBARR(1+NASPRT+1+(NASPRT+2)*(NFSB-1))=NRDETS+1
        NRDETS=NRDETS+NSDBLK

* Next walk: Lowest increasable switch value is at level lowest.
      END IF
      IF(LOWEST.GT.NASPRT) GOTO 600
      DO LEVUP=1,LOWEST-1
       SWITCH(+LEVUP)=1
      END DO
      SWITCH(+LOWEST)=1+SWITCH(+LOWEST)
      GOTO 500

 600  CONTINUE
      CALL mma_deallocate(SWITCH)
      CALL mma_deallocate(VERTAB)
      CALL mma_deallocate(DWNTAB)
      CALL mma_deallocate(WEIGHT)
* Here we are. No more FS blocks can be constructed.
CTEST      write(*,*)' Total nr of Slater determinants, NRDETS=',NRDETS
CTEST      write(*,*)' Returning from VERTAB.'

      END SUBROUTINE mkVERTAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine o12sa3_cvb(vec,cvb,
     >  orbs,gjorb,gjorb2,gjorb3,
     >  civec,civecp,civb,cvbdet,vec_all,
     >  nvb,nprorb,nparm1,strucopt)
      implicit real*8 (a-h,o-z)
      logical strucopt
#include "opt_cvb.fh"
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

      dimension vec(nparm1)
      dimension cvb(nvb),civec(*),civecp(*),civb(*),cvbdet(*)
      dimension vec_all(nparm1)
      dimension orbs(*),gjorb(*),gjorb2(*),gjorb3(*)

      call makegjorbs_cvb(orbs,gjorb,gjorb2,gjorb3)

      call str2vbc_cvb(cvb,cvbdet)
      call vb2cic_cvb(cvbdet,civb)

      call makecivecp_cvb(civec,civecp,orbs)
      call ci2vbg_cvb(civecp,cvbdet)
      call vb2strg_cvb(cvbdet,vec_all(nprorb+1))
      call fzero(vec_all,nprorb)
      call onedens_cvb(civb,civecp,vec_all,.false.,0)
c  If no optimization of structure coefficients we are doing
c  "Augmented" calc:
      if(strucopt)then
        ic1=1
      else
        ic1=2
      endif
      call all2free_cvb(vec_all,vec(ic1),1)
      if(.not.strucopt)vec(1)=ddot_(nvb,cvb,1,vec_all(nprorb+1),1)
      call ddrhs_cvb(vec,nparm1,0)

      call str2vbc_cvb(cvb,cvbdet)
      call vb2cic_cvb(cvbdet,civb)

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Setup1(ExpA,nPrim,ExpB,mPrim,A,B,rKappa,Pcoor,ZInv)
************************************************************************
*                                                                      *
*     Object : to compute some data which is needed for the one-       *
*              electron integrals.                                     *
*                                                                      *
* Called from: OneEl                                                   *
*                                                                      *
* Calling    : RecPrt                                                  *
*              GetMem                                                  *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 ExpA(nPrim), ExpB(mPrim), rKappa(nPrim,mPrim),
     &       Pcoor(nPrim,mPrim,3),  ZInv(nPrim,mPrim), A(3), B(3)
*
      iRout = 114
      iPrint = nPrint(iRout)
      ab  = (A(1)-B(1))**2 + (A(2)-B(2))**2 + (A(3)-B(3))**2
      If (ab.ne.Zero) Then
      Do 10 iPrim = 1, nPrim
         Do 20 jPrim = 1, mPrim
            rKappa(iPrim,jPrim) = Exp(- ExpA(iPrim) * ExpB(jPrim) * ab *
     &                            ZInv(iPrim,jPrim))
            Pcoor(iPrim,jPrim,1)=(ExpA(iPrim)*A(1)+ExpB(jPrim)*B(1)) *
     &                            ZInv(iPrim,jPrim)
            Pcoor(iPrim,jPrim,2)=(ExpA(iPrim)*A(2)+ExpB(jPrim)*B(2)) *
     &                            ZInv(iPrim,jPrim)
            Pcoor(iPrim,jPrim,3)=(ExpA(iPrim)*A(3)+ExpB(jPrim)*B(3)) *
     &                            ZInv(iPrim,jPrim)
 20      Continue
 10   Continue
      Else
        call dcopy_(nPrim*mPrim,[One],0,rKappa,1)
        call dcopy_(nPrim*mPrim,A(1),0,Pcoor(1,1,1),1)
        call dcopy_(nPrim*mPrim,A(2),0,Pcoor(1,1,2),1)
        call dcopy_(nPrim*mPrim,A(3),0,Pcoor(1,1,3),1)
      End If
      If (iPrint.ge.99) Then
         Call RecPrt(' *** Kappa ***',' ',rKappa, nPrim, mPrim)
         Call RecPrt(' ***   Px  ***',' ',Pcoor(1,1,1),nPrim,mPrim)
         Call RecPrt(' ***   Py  ***',' ',Pcoor(1,1,2),nPrim,mPrim)
         Call RecPrt(' ***   Pz  ***',' ',Pcoor(1,1,3),nPrim,mPrim)
      End If
*     Call GetMem('SetUp1','CHECK','REAL',iDum,iDum)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine HCSCE(N,H,S,C,E,M)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Solve the secular equations HC=SCE. This routine is part of the  *
*     Davidson diagonalization procedure used to find the lowest roots *
*     of the CI-Hamiltonian. Because of that it is crucial to use      *
*     Schmidt orthogonalization such that the latest vector (in chro-  *
*     nological order) remains unchanged and the previous are ortho-   *
*     gonalized relative to it. It is also important that the input    *
*     data remain unchanged.                                           *
*                                                                      *
*     calling arguments:                                               *
*     N       : Type integer, input.                                   *
*               Dimensions of the secular equations.                   *
*     H       : Type double precision real, input.                     *
*               Hamiltonian in matrix representation.                  *
*     S       : Type double precision real, input.                     *
*               Overlap matrix.                                        *
*     C       : Type double precision real, output.                    *
*               Matrix containing the eigenvectors.                    *
*     E       : Type double precision real, output.                    *
*               Vector containing the eigenvalues.                     *
*     M       : Type integer, output.                                  *
*               This is the number of linearly independent basis       *
*               vectors that span space the metric given by the        *
*               overlap matrix.                                        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher, University of Lund, Sweden, 1993                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8(A-H,O-Z)

      Dimension H(N*(N+1)/2),S(N*(N+1)/2),C(N,N),E(N)
      dimension WGronk(2)

#include "WrkSpc.fh"
#include "timers.fh"

*      Character*12 method

      Call Timing(Longines_1,Swatch,Swatch,Swatch)

* PAM 2009: On input, M=max possible orthonormal solutions to HC=SCE
* Save it.
      MMAX=M

*     allocate temporary work space
      Call GetMem('Temp1','Allo','Real',lw1,N*N)
      Call GetMem('Temp2','Allo','Real',lw2,N*N)
      Call GetMem('Temp3','Allo','Real',lw3,N*N)
      Call GetMem('Temp4','Allo','Real',lw4,N)

*     make local copies of H and S
      Call Square(S,Work(lw1),1,N,N)
      Call Square(H,Work(lw2),1,N,N)

*     Schmidt orthogonalization
      call dcopy_(N*N,[0.0d0],0,C,1)
      call dcopy_(N,[1.0d0],0,C,N+1)

*      write(6,*)' HCSCE calling Schmidt.'
*      Call Schmidt(N,Work(lw1),C,Work(lw4),M)
*      write(6,*)' HCSCE back from Schmidt. M=',M
* PAM 2009: It seems that no provision is made for the case that
* the returned M, = nr of ON vectors produced, is smaller than N?!
* Also, the whole thing looks very inefficient. But I just make
* some provisional changes now (090216).
*      write(6,*)' HCSCE check eigenvalues. N=',N
*      Call eigv(N,Work(lw1))
*      write(6,*)' HCSCE calling NewGS.'
      Call NewGS(N,Work(lw1),C,Work(lw4),M)
*      write(6,*)' HCSCE back from NewGS. M=',M
* Possibly in very difficult cases, NewGS produced too many vectors:
       M=MIN(M,MMAX)

*     transform H to an orthogonal basis
* PAM 2009: Rewritten, use only M orthogonal vectors
      Call DGEMM_('N','N',
     &            N,M,N,
     &            1.0d0,Work(lw2),N,
     &            C,N,
     &            0.0d0,Work(lw3),N)
      Call DGEMM_('T','N',
     &            M,M,N,
     &            1.0d0,C,N,
     &            Work(lw3),N,
     &            0.0d0,Work(lw2),M)

* PAM 2009: Replace by DSYEV call.
*      method='Householder'
*      method='Jacobi'

*     diagonalize and extract eigenvalues
*      If ( method.eq.'Jacobi' ) then
*        Do i=1,N
*           Do j=1,i
*              Work(j+i*(i-1)/2+lw2-1)=Work(j+(i-1)*N+lw2-1)
*           End Do
*        End Do
*        Call Jacob(Work(lw2),C,N,N)
*        Call JacOrd(Work(lw2),C,N,N)
*        Do i=1,N
*           E(i)=Work(i*(i+1)/2+lw2-1)
*        End Do
*      End If
*      If ( method.eq.'Householder' ) then
*        Call Eigen_Molcas(N,Work(lw2),E,Work(lw4))
*        Call DGEMM_('N','N',
*     &              N,N,N,
*     &              1.0d0,C,N,
*     &              Work(lw2),N,
*     &              0.0d0,Work(lw3),N)
*        call dcopy_(N*N,Work(lw3),1,C,1)
*      End If
* PAM 2009 Equivalent, DSYEV, note now use just M, not all N:
      INFO=0
      call dsyev_('V','L',M,Work(lw2),M,E,WGRONK,-1,INFO )
      NSCRATCH=INT(WGRONK(1))
      CALL GETMEM('SCRATCH','ALLO','REAL',LSCRATCH,NSCRATCH)
      call dsyev_('V','L',M,WORK(lw2),M,E,WORK(LSCRATCH),
     &            NSCRATCH,INFO)
      CALL GETMEM('SCRATCH','FREE','REAL',LSCRATCH,NSCRATCH)
      Call DGEMM_('N','N',
     &              N,M,M,
     &              1.0d0,C,N,
     &              Work(lw2),M,
     &              0.0d0,Work(lw3),N)
      call dcopy_(N*M,Work(lw3),1,C,1)

*     deallocate temporary work space
      Call GetMem('Temp4','Free','Real',lw4,N)
      Call GetMem('Temp3','Free','Real',lw3,N*N)
      Call GetMem('Temp2','Free','Real',lw2,N*N)
      Call GetMem('Temp1','Free','Real',lw1,N*N)

      Call Timing(Longines_2,Swatch,Swatch,Swatch)
      Longines_2 = Longines_2 - Longines_1
      Longines_3 = Longines_3 + Longines_2

      Return
      End

      Subroutine NewGS(N,S,C,Temp,M)
      Implicit Real*8(A-H,O-Z)
      Dimension S(N,N),C(N,N),Temp(N)
* PAM 2009, New Gram-Schmidt 090216
#include "warnings.fh"

      M=0
      do i=1,N
       X=S(i,i)
       If(X.lt.1.0D-6) Goto 90
       Y=1.0D0/sqrt(X)
       call dcopy_(N,[0.0D0],0,C(1,M+1),1)
       C(i,M+1)=Y
       call dcopy_(N,S(1,i),1,Temp,1)
       Call DSCAL_(N,Y,Temp,1)

       Loop=0
  10   Continue
       Loop=Loop+1
       Do k=1,M
        ovl=DDOT_(N,Temp,1,C(1,k),1)
        call daxpy_(N,-ovl,C(1,k),1,C(1,M+1),1)
       End Do
       Call dGeMV_('N',N,N,1.0D0,S,N,C(1,M+1),1,0.0D0,Temp,1)
       xn2=DDOT_(N,Temp,1,C(1,M+1),1)

       If(xn2.lt.1.0D-6) Goto 90

       Y=1.0D0/sqrt(xn2)
       Call DSCAL_(N,Y,C(1,M+1),1)
       Call dGeMV_('N',N,N,1.0D0,S,N,C(1,M+1),1,0.0D0,Temp,1)
       If(Loop.eq.1 .and. Y.gt.100.0D0) Goto 10
*MGD issues with many states : to be very safe, test the result
       isfail=0
       Do  k=1,M
        ovl=DDOT_(N,Temp,1,C(1,k),1)
        if (abs(ovl).gt.1.0d-4) isfail=1
       End Do
       If (isfail.eq.0) M=M+1

  90   Continue
      End do
      Return
      End
      Subroutine Schmidt(N,S,C,Temp,M)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Schmidt orthogonalization such that the latest vector (in chro-  *
*     nological order) remains unchanged and the previous are ortho-   *
*     gonalized relative to it.                                        *
*                                                                      *
*     calling arguments:                                               *
*     N       : Type integer, input.                                   *
*               Dimensions of the overlap matrix.                      *
*     S       : Type double precision real, input.                     *
*               Overlap matrix.                                        *
*     C       : Type double precision real, output.                    *
*               Matrix containing the transformation vectors.          *
*     Temp    : Type double precision real, input/output.              *
*               Scratch area.                                          *
*     M       : Type integer, output.                                  *
*               This is the number of linearly independent basis       *
*               vectors that span space the metric given by the        *
*               overlap matrix.                                        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher, University of Lund, Sweden, 1993                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8(A-H,O-Z)

      Dimension S(N,N),C(N,N),Temp(N)

      Logical forward,backward

      forward  = .true.
      backward = .not.forward

      M=0
      Do i=1,N
         Do j=1,N
            C(j,i)=0.0d0
         End Do
         C(i,i)=1.0d0/Sqrt(S(i,i))
      End Do

*     forward orthonormalization
*     (vectors 1 remains unchanged)
      If ( forward ) then
        Do i=1,N
           Alpha=C(i,i)
           Do j=1,N
              Temp(j)=S(j,i)*Alpha
           End Do
           Do j=1,i-1
              Sum=0.0d0
               Do k=1,i
                 Sum=Sum+C(k,j)*Temp(k)
              End Do
              Do k=1,i
                 C(k,i)=C(k,i)-Sum*C(k,j)
              End Do
           End Do
           Sum=0.0d0
           Do k=1,i
              Sum=Sum+C(k,i)*Temp(k)
           End Do
           If ( Sum.gt.1.0d-9 ) then
              M=M+1
              Alpha=1.0d0/Sqrt(Sum)
              Do k=1,i
                 C(k,i)=C(k,i)*Alpha
              End Do
           Else
              Do k=1,i
                 C(k,i)=0.0d0
              End Do
           End If
        End Do
      End If

*     backward orthonormalization
*     (vectors N remains unchanged)
      If ( backward ) then
        Do i=N,1,-1
           Alpha=C(i,i)
           Do j=1,N
              Temp(j)=S(j,i)*Alpha
           End Do
           Do j=N,i+1,-1
              Sum=0.0d0
              Do k=j,N
                 Sum=Sum+C(k,j)*Temp(k)
              End Do
              Do k=j,N
                 C(k,i)=C(k,i)-Sum*C(k,j)
              End Do
           End Do
           Sum=0.0d0
           Do k=i,N
              Sum=Sum+C(k,i)*Temp(k)
           End Do
           If ( Sum.gt.1.0d-9 ) then
              M=M+1
              Alpha=1.0d0/Sqrt(Sum)
              Do k=i,N
                 C(k,i)=C(k,i)*Alpha
              End Do
           Else
              Do k=i,N
                 C(k,i)=0.0d0
              End Do
           End If
        End Do
      End If

      Return
      End
*      subroutine eigv(N,S)
*      implicit real*8 (a-h,o-z)
*      dimension S(N,N)
*      dimension WGronk(2)

*
*      CALL GETMEM('LSCP','ALLO','REAL',LSCP,N**2)
*      CALL DCOPY_(N**2,S,1,WORK(LSCP),1)
*      CALL GETMEM('LEIG','ALLO','REAL',LEIG,N)
*      INFO=0
*      call dsyev_('V','L',N,WORK(LSCP),N,WORK(LEIG),WGRONK,-1,INFO )
*      NSCRATCH=INT(WGRONK(1))
*      CALL GETMEM('SCRATCH','ALLO','REAL',LSCRATCH,NSCRATCH)
*      call dsyev_('V','L',N,WORK(LSCP),N,WORK(LEIG),WORK(LSCRATCH),
*     &            NSCRATCH,INFO)
*      CALL GETMEM('SCRATCH','FREE','REAL',LSCRATCH,NSCRATCH)
*      write(6,*)' Largest eigenvalues of S matrix:'
*      write(6,'(5g16.8)')(Work(leig+i),i=MAX(0,N-10),N-1)
*      CALL GETMEM('LEIG','FREE','REAL',LEIG,N)
*      CALL GETMEM('LSCP','FREE','REAL',LSCP,N**2)
*
*      return
*      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,2020, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      Module Real_Spherical
      Private
#include "stdalloc.fh"
      Public :: ipSph, RSph, Sphere, Sphere_Free,
     &          Condon_Shortley_phase_factor, lmax_internal,
     &          Sphere_Dmp, iSphCr, LblCBs, LblSBs
      Integer, Allocatable:: iSphCr(:)
      Integer, Dimension(:), Allocatable :: ipSph
      Integer :: lmax_internal=-1
      Real*8, Dimension(:), Allocatable :: RSph
      Logical :: Condon_Shortley_phase_factor=.False.
      Character(LEN=8), Allocatable :: LblCBs(:), LblSBs(:)
*
************************************************************************
*
      Contains
*
************************************************************************
*
      SubRoutine Sphere_Free()
      If (Allocated(RSph)) Call mma_deallocate(RSph)
      If (Allocated(ipSph)) Call mma_deallocate(ipSph)
      If (Allocated(iSphCr)) Call mma_deallocate(iSphCr)
      If (Allocated(LblCBs)) Call mma_deallocate(LblCBs)
      If (Allocated(LblSBs)) Call mma_deallocate(LblSBs)
      lmax_internal=-1
      End SubRoutine Sphere_Free
*
************************************************************************
*
      SubRoutine Sphere(lMax)
************************************************************************
*                                                                      *
* Object: create the transformation matrices from cartesian gaussians  *
*         to spherical gaussians. By having these matricies being      *
*         defined dynamical we ensure that any extension of the        *
*         program to higher angular momentum is simply done by chang-  *
*         ing iTabMx to the appropiate value.                          *
*         In addition, this will also allow us to have any order of    *
*         vectors in the matrix, i.e. we can have our own format or    *
*         any other odd order (MOLECULE).                              *
*                                                                      *
* Called from: Input                                                   *
*                                                                      *
* Calling    : Real_Sphere                                             *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March 1990                                               *
************************************************************************
*               Credits.                                               *
*               2020, R. Lindh; P. R. Taylor; L. Birnoschi; A. Dzubak; *
*                     M. Navarrete; C. Gonzalez-Espinoza; G. Raggi;    *
*                     N. F. Chilton at OpenMolcas2020                  *
************************************************************************
      Implicit real*8 (a-h,o-z)
*     find iTabMx, limiting the highest ang mom, in itmax.fh
#include "itmax.fh"
#include "real.fh"
      Logical CSPF
*     check if required ang mom is greater than hard-coded limit
      If (lMax.gt.iTabMx) Then
         Call WarningMessage(2,' Sphere: Increase iTabMx!')
         Call Abend()
      End If
*
      If (lmax.lt.0) Then
         Write (6,*) 'Sphere: lmax<0'
         Call Abend()
      End If
      If (lmax.gt.lmax_internal) Then
         Call Sphere_Free()
         lmax_internal=lMax
      Else
         Return
      End If
      Call Get_lScalar('CSPF',CSPF)
      Condon_Shortley_phase_factor=CSPF
*
      nSphCr=(lmax+1)*(lmax+2)*(lmax+3)/6
      Call mma_allocate(iSphCr,nSphCr,Label='iSphCr')
      iSphCr(:)=0

*     Write (*,*) 'C&S',Condon_Shortley_phase_factor
*
*     Make the labels
*     Gives info on basis function angular momenta
*     n, l, ml or assigns it as a diffuse/polarising function with '*'
*
      MxFnc=(lMax+1)*(lMax+2)*(lMax+3)/6
      Call mma_allocate(LblCBs,MxFnc,Label='LblCBs')
      Call mma_allocate(LblSBs,MxFnc,Label='LblSBs')
*
      Call Make_Labels(LblCbs,LblSbs,MxFnc,lMax)
*
*     Allocate memory for transformation matrices
*     Here, ipSph are the pointers to memory locations in RSph, for the
*     transformation matrices of given ang mom
      nSphr = 0
      Do iAng = 0, lMax
         nSphr = nSphr + (iAng*(iAng+1)/2 + iAng + 1)**2
      End Do
      Call mma_allocate(RSph,nSphr,label='RSph')
      Call mma_allocate(ipSph,[0,lMax],label='ipSph')
      ipSph(0)=1
      Do 2 iAng = 0, lMax-1
         ipSph(iAng+1) = ipSph(iAng) + (iAng*(iAng+1)/2 + iAng + 1)**2
 2    Continue

*     Here the transformation matrices from cartesian to spherical are
*     made
      Call Real_Sphere(ipSph,lMax,RSph,nSphr)
*
*     Set up the symmetry properties of the spherical gaussians
      iii = 0
      jjj = 0
      Do 50 n = 0, lMax
         nElem = (n+1)*(n+2)/2
         ii = 0
         Do 55 m = n, 0, -2
            Do 60 l = -m, m
               iii = iii + 1
               Do 65 iElem = 1, nElem
                  If (RSph(iElem-1+ii+ipSph(n)).ne.Zero) Go To 66
65             Continue
66             iSphCr(iii) = iElem + jjj
               ii = ii + nElem
60          Continue
55       Continue
        jjj = jjj + nElem
50    Continue
*
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) ' Spherical Harmonic expansions '
      Write (6,*)
      iLbl=1
      Do n = 0, lMax
         nElem = (n+1)*(n+2)/2
         ii  = 0
         Write (6,*)
         Write (6,'(8X,31(2X,I1,I1,I1))') ((i,j,n-i-j,
     &         j=n-i,0,-1),i=n,0,-1)
         Write (6,*)
         Do m = n, 0, -2
            Do l = -m, m
               Write (6,'(1X,A6,1X,31F5.2)')
     &            LblSbs(iLbl),(RSph(i+ii+ipSph(n)),i=0,nElem-1)
               ii = ii + nElem
               iLbl = iLbl + 1
            End Do
            Write (6,*)
         End Do
         Write (6,*)
      End Do
#endif
*
      Return
      End Subroutine Sphere
      Subroutine Real_Sphere(ipSph,lMax,RSph,nSphr)
      Implicit Real*8 (a-h,o-z)
      Real*8 RSph(nSphr)
      Integer ipSph(0:lMax)
*
      i00 = ipSph(0)
      i10 = ipSph(0)
      Do i = 0, lMax
         i2  = ipSph(i)
         nElem = (i+1)*(i+2)/2
         i20= i2 + i*nElem
*        First generate the coefficients for Y(i,0) -- always real
         Call Recurse(RSph(i00),RSph(i10),RSph(i20),i)
*        Use ladder operators to generate Y(i,m)
         Call Ladder(RSph(i2),i)
*
*        Now do the contaminant, by simply multiply with r**2
*
         j = i-2
         If (j.ge.0) Then
            iCont = i2 + (2*i+1)*nElem
            iOff=ipSph(j)
            mElem = (j+1)*(j+2)/2
            Do l = j, 0, -2
               Call Contaminant(RSph(iCont),i,RSph(iOff),j,l)
               iCont = iCont + (2*l+1)*nElem
               iOff  = iOff  + (2*l+1)*mElem
            End Do
         End If
*
         i00=i10
         i10=i20
      End Do
*
*.... Normalize
*
      Do i = 0, lMax
         Call NrmSph(RSph(ipSph(i)),i)
      End Do
*
      Return
      End Subroutine Real_Sphere
      Subroutine Recurse(P0,P1,P2,n2)
************************************************************************
*                                                                      *
*     The Legendre polynomial is identical to Y(l,0).                  *
*     Note that it is real and that there is no Condon-Shortley phase  *
*     factor to consider.                                              *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 P0((n2-1)*n2/2), P1(n2*(n2+1)/2),P2((n2+1)*(n2+2)/2)
*     Define statement function:
      iad(ix,iy,iz)=(iz+iy)*(iz+iy+1)/2 +iz + 1
*
      P2(:)=Zero
*
*---- Use recurrence relation for Legendre polynomials
*
*     (n+1) P_{n+1} = (2n+1) z P_n - n r^2 P_{n-1}
*
      If (n2.eq.0) then
*
         P2(1)=One
*
      Else
*
*        P_{n+1} = (2n+1)/(n+1) z P_n
*
         Fact_1=DBLE(2*n2-1)/DBLE(n2)
         n1=n2-1
         Do ix = n1, 0, -1
           Do iy = n1-ix, 0, -1
             iz = n1-ix-iy
             P2(iad(ix,iy,iz+1)) = P2(iad(ix,iy,iz+1))
     &            + Fact_1*P1(iad(ix,iy,iz))
           End Do
         End Do
*
*        P_{n+1} = - n/(n+1) (x^2+y^2+z^2) P_{n-1}
*
         Fact_2=DBLE(n2-1)/DBLE(n2)
         n0=n1-1
         Do ix = n0, 0, -1
            Do iy = n0-ix, 0, -1
               iz = n0-ix-iy
               P2(iad(ix+2,iy,iz)) = P2(iad(ix+2,iy,iz))
     &                             - Fact_2*P0(iad(ix,iy,iz))
               P2(iad(ix,iy+2,iz)) = P2(iad(ix,iy+2,iz))
     &                             - Fact_2*P0(iad(ix,iy,iz))
               P2(iad(ix,iy,iz+2)) = P2(iad(ix,iy,iz+2))
     &                             - Fact_2*P0(iad(ix,iy,iz))
            End Do
         End Do
*
      End if

      Return
      End Subroutine Recurse
      Subroutine Ladder(P0,n)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 P0((n+1)*(n+2)/2,-n:n)
*     Define statement function:
      iad(ix,iy,iz)=(iz+iy)*(iz+iy+1)/2 +iz + 1
*
*     Generate Y(l,m) from Y(l,m-1), starting the process from Y(l,0)
*
      Do m = 0, n-1
         m_p=  m+1
         m_m=-(m+1)
         P0(:,m_p)=Zero
         P0(:,m_m)=Zero
         Fact=One/(Two*Sqrt(DBLE(n*(n+1)-m*(m-1))))
*
*        The spherical harmonic is a two component (real,imaginary)
*        function.
*
*....... Y(n, m) =(-1)**  m  x (S(+,m), S(-,m)) and
*        Y(n,-m) =(-1)**(-m) x (S(+,m),-S(-,m))
*
*        with S(-,0)=0
*
*        The ladder operator is subdivided in a similar way
*
*        L(+)=(Lr,Li),  L(-)=(Lr,-Li)
*
*        Hence
*
*        L(+) Y(n,m)= C x Y(n,m+1)
*
*        or
*
*        C(S(+,m+1),S(-,m+1))=(Lr S(+,m)-Li S(-,m),Li S(+,m)+Lr S(-,m))
*
         Do ix = n, 0, -1
            Do iy = n-ix, 0, -1
               iz = n-ix-iy
*
*............. Generating the real part
*
               If (iz.ge.1)
     &         P0(iad(ix+1,iy,iz-1),m_p)= P0(iad(ix+1,iy,iz-1),m_p)
     &                            + Fact*DBLE(iz)*P0(iad(ix,iy,iz),m)
               If (ix.ge.1)
     &         P0(iad(ix-1,iy,iz+1),m_p)= P0(iad(ix-1,iy,iz+1),m_p)
     &                            - Fact*DBLE(ix)*P0(iad(ix,iy,iz),m)
               If (m.ne.0) Then
                  If (iz.ge.1)
     &            P0(iad(ix,iy+1,iz-1),m_p)= P0(iad(ix,iy+1,iz-1),m_p)
     &                            - Fact*DBLE(iz)*P0(iad(ix,iy,iz),-m)
                  If (iy.ge.1)
     &            P0(iad(ix,iy-1,iz+1),m_p)= P0(iad(ix,iy-1,iz+1),m_p)
     &                            + Fact*DBLE(iy)*P0(iad(ix,iy,iz),-m)
               End If
*
*............. Generating the imaginary part
*
               If (iz.ge.1)
     &         P0(iad(ix,iy+1,iz-1),m_m)= P0(iad(ix,iy+1,iz-1),m_m)
     &                            + Fact*DBLE(iz)*P0(iad(ix,iy,iz),m)
               If (iy.ge.1)
     &         P0(iad(ix,iy-1,iz+1),m_m)= P0(iad(ix,iy-1,iz+1),m_m)
     &                            - Fact*DBLE(iy)*P0(iad(ix,iy,iz),m)
               If (m.ne.0) Then
                  If (iz.ge.1)
     &            P0(iad(ix+1,iy,iz-1),m_m)= P0(iad(ix+1,iy,iz-1),m_m)
     &                            + Fact*DBLE(iz)*P0(iad(ix,iy,iz),-m)
                  If (ix.ge.1)
     &            P0(iad(ix-1,iy,iz+1),m_m)= P0(iad(ix-1,iy,iz+1),m_m)
     &                            - Fact*DBLE(ix)*P0(iad(ix,iy,iz),-m)
               End If
*
            End Do
         End Do
*
*        Up to this point we have been operating on the Legendre and
*        associated Legendre polynomials. Let us now put in the
*        Condon-Shortley phase factor
*
         If (Condon_Shortley_phase_factor .and.
     &       MOD(m+1,2).ne.0) Then
*           Write (6,*) 'C&S phase factor included.'
            P0(:,m_p)=-P0(:,m_p)
            P0(:,m_m)=-P0(:,m_m)
         End If
*
      End Do ! m
*
      Return
      End Subroutine Ladder
      Subroutine Contaminant(P0,i,Px,j,l)
*     This subroutine generates the lower ang mom contaminants for the
*     given ang mom
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 P0((i+1)*(i+2)/2,-l:l), Px((j+1)*(j+2)/2,-l:l)
*     Declare statement function
      iad(ix,iy,iz)=(iz+iy)*(iz+iy+1)/2 +iz + 1
*
*     Px = (x^2+y^2+z^2) x P0
*
      Do m = -l, l
         P0(:,m)=Zero
         Do ix = j, 0, -1
            Do iy = j-ix, 0, -1
               iz = j-ix-iy
               P0(iad(ix+2,iy,iz),m)=P0(iad(ix+2,iy,iz),m)
     &                              +Px(iad(ix,iy,iz),m)
               P0(iad(ix,iy+2,iz),m)=P0(iad(ix,iy+2,iz),m)
     &                              +Px(iad(ix,iy,iz),m)
               P0(iad(ix,iy,iz+2),m)=P0(iad(ix,iy,iz+2),m)
     &                              +Px(iad(ix,iy,iz),m)
            End Do
         End Do
      End Do
*
      Return
      End Subroutine Contaminant
      Subroutine NrmSph(P,n)
      Implicit Real*8 (a-h,o-z)
      Real*8 P((n+1)*(n+2)/2,(n+1)*(n+2)/2)
#include "real.fh"
*
      iad(ix,iy,iz)=(iy+iz)*(iy+iz+1)/2+iz+1
*
      Do m = 1, (n+1)*(n+2)/2
         rMax=Zero
         Do k = 1, (n+1)*(n+2)/2
            If (Abs(P(k,m)).gt.rMax) rMax=Abs(P(k,m))
         End Do
         Do k = 1, (n+1)*(n+2)/2
            If (Abs(P(k,m)).lt.1.0D-12*rMax) P(k,m)=Zero
         End Do
         tmp=Zero
         Do ijx = 2*n, 0, -2
            Do ijy = 2*n-ijx, 0, -2
               ijz=2*n-ijx-ijy
               DF=DblFac(ijx-1)*DblFac(ijy-1)*DblFac(ijz-1)
               temp=Zero
               Do ix = Min(n,ijx), Max(0,ijx-n), -1
                  jx=ijx-ix
                  Do iy = Min(n-ix,ijy), Max(0,ijy-n+jx), -1
                     jy=  ijy-iy
                     iz=n-ix-iy
                     jz=n-jx-jy
                     temp=temp+P(iad(ix,iy,iz),m)*P(iad(jx,jy,jz),m)
                  End Do
               End Do
               tmp=tmp+DF*temp
            End Do
         End Do
         Call DScal_((n+1)*(n+2)/2,One/Sqrt(tmp),P(1,m),1)
      End Do
      Return
      End Subroutine NrmSph
*
************************************************************************
*
      End Module Real_Spherical

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
*               2005, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine GenerateP(Ovlp,cMO,Name,nBasis,nOrb2Loc,nAtoms,
     &                     nBas_per_Atom,nBas_Start,PA,Debug)
c
c     Author: Yannick Carissan.
c
c     Modifications:
c        - October 6, 2005 (Thomas Bondo Pedersen):
c          Reduce operation count and use BLAS.
c
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
#include "Molcas.fh"
      Real*8, Allocatable:: SBar(:,:)
      Integer nBas_per_Atom(*),nBas_Start(*)
      Real*8 cMO(nBasis,*),Ovlp(nBasis,nBasis)
      Real*8 PA(nOrb2Loc,nOrb2Loc,nAtoms)
      Logical Debug
      Character*(LENIN8) Name(*)

      Call mma_Allocate(SBar,nBasis,nOrb2Loc,Label='SBar')
      Call GenerateP_1(Ovlp,cMO,Sbar,Name,nBasis,nOrb2Loc,
     &                 nAtoms,nBas_per_Atom,nBas_Start,PA,Debug)
      Call mma_deallocate(SBar)

      End
      Subroutine GenerateP_1(Ovlp,cMO,Sbar,Name,nBasis,nOrb2Loc,nAtoms,
     &                       nBas_per_Atom,nBas_Start,PA,Debug)
c
c     Author: Yannick Carissan.
c
c     Modifications:
c        - October 6, 2005 (Thomas Bondo Pedersen):
c          Reduce operation count and use BLAS.
c
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "real.fh"
#include "Molcas.fh"
      Integer nBas_per_Atom(*),nBas_Start(*)
      Real*8 cMO(nBasis,*),Ovlp(nBasis,nBasis)
      Real*8 Sbar(nBasis,nOrb2Loc)
      Real*8 PA(nOrb2Loc,nOrb2Loc,nAtoms)
      Logical Debug
      Character*(LENIN8) Name(*),PALbl
c
c---- Compute Sbar(mu,s) = sum_{nu} Ovlp(mu,nu) * cMO(nu,s)
c
      Call DGEMM_('N','N',nBasis,nOrb2Loc,nBasis,
     &           One,Ovlp,nBasis,cMO,nBasis,
     &           Zero,Sbar,nBasis)
c
      Do iAt=1,nAtoms
c
c------ Compute MA(s,t) = sum_{mu_in_A} cMO(mu,s) * Sbar(mu,t)
c
        Call DGEMM_('T','N',
     &             nOrb2Loc,nOrb2Loc,nBas_per_Atom(iAt),
     &             One,cMO(nBas_Start(iAt),1),nBasis,
     &                 Sbar(nBas_Start(iAt),1),nBasis,
     &             Zero,PA(1,1,iAt),nOrb2Loc)
c
c------ Compute <s|PA|t> by symmetrization of MA.
c
        Do iMO_s=1,nOrb2Loc
          Do iMO_t=iMO_s+1,nOrb2Loc
            PAst = PA(iMO_s,iMO_t,iAt)
            PAts = PA(iMO_t,iMO_s,iAt)
            PA(iMO_s,iMO_t,iAt) = Half*(PAst+PAts)
            PA(iMO_t,iMO_s,iAt) = PA(iMO_s,iMO_t,iAt)
          End Do !iMO_t
        End Do !iMO_s
c
      End Do !iAt
c
      If (Debug) Then
        Write(6,*) 'In GenerateP'
        Write(6,*) '------------'
        Do iAt=1,nAtoms
          PALbl='PA__'//Name(nBas_Start(iAt))(1:LENIN)
          Call RecPrt(PALbl,' ',PA(1,1,iAt),nOrb2Loc,nOrb2Loc)
        End Do
      End If
c
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Naoki Nakatani                                   *
!***********************************************************************

subroutine MKXMAT(TORB,XMAT)
! Make full transformation matrix for active space
! from that stored for each symmetry in IAD1M(4)
! Written by N. Nakatani, Oct. 2014

use Definitions, only: wp, iwp

implicit none
#include "rasdim.fh"
#include "caspt2.fh"
real(kind=wp), intent(in) :: TORB(NTORB)
real(kind=wp), intent(out) :: XMAT(NASHT,NASHT)
integer(kind=iwp) :: I, IR1, IR2, IR3, ISTART, ISYM, ITO, ITOEND, ITOSTA, J, JR1, JR2, JR3, NA, NI, NR1, NR2, NR3, NS

if (NASHT > 0) then
  ITOEND = 0
  do ISYM=1,NSYM
    NI = NISH(ISYM)
    NA = NASH(ISYM)
    NR1 = NRAS1(ISYM)
    NR2 = NRAS2(ISYM)
    NR3 = NRAS3(ISYM)
    NS = NSSH(ISYM)
    ITOSTA = ITOEND+1
    ITOEND = ITOEND+NI**2+NR1**2+NR2**2+NR3**2+NS**2

    ! Normally, NRAS2 should only be non-zero, but NRAS1 and NRAS3 should be zero
    ! for DMRG-CASSCF calculation
    ITO = ITOSTA+NI**2
    !ITO = ITOSTA+NI**2-1
    if (NA > 0) then
      ! RAS1
      if (NR1 > 0) then
        ISTART = NAES(ISYM)
        do JR1=1,NR1
          J = ISTART+JR1
          do IR1=1,NR1
            I = ISTART+IR1
            XMAT(I,J) = TORB(ITO)
            ITO = ITO+1
          end do
        end do
      end if
      ! RAS2
      if (NR2 > 0) then
        ISTART = NAES(ISYM)+NR1
        do JR2=1,NR2
          J = ISTART+JR2
          do IR2=1,NR2
            I = ISTART+IR2
            XMAT(I,J) = TORB(ITO)
            ITO = ITO+1
          end do
        end do
      end if
      ! RAS3
      if (NR3 > 0) then
        ISTART = NAES(ISYM)+NR1+NR2
        do JR3=1,NR3
          J = ISTART+JR3
          do IR3=1,NR3
            I = ISTART+IR3
            XMAT(I,J) = TORB(ITO)
            ITO = ITO+1
          end do
        end do
      end if
    end if
  end do
end if

return

end subroutine MKXMAT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it ana/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               1995,1996, Martin Schuetz                              *
*               2003, Valera Veryazov                                  *
*               2016,2017, Roland Lindh                                *
************************************************************************
      SubRoutine WfCtl_SCF(iTerm,Meth,FstItr,SIntTh)
      use SCF_Arrays
      Implicit Real*8 (a-h,o-z)
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
      Logical FstItr
      Character Meth*(*)
*
      nD = iUHF + 1
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate memory for some arrays
*
      nTr=MxIter
      Call mma_allocate(TrDh,nTR**2,nD,Label='TrDh')
      Call mma_allocate(TrDP,nTR**2,nD,Label='TrDP')
      Call mma_allocate(TrDD,nTR**2,nD,Label='TrDD')
      nCI = MxOptm + 1
      Call mma_allocate(CInter,nCI,nD,Label='CInter')
*                                                                      *
************************************************************************
*                                                                      *
      Call WfCtl_SCF_(iTerm,Meth,FstItr,SIntTh,OneHam,TwoHam,Dens,
     &                Ovrlp,Fock,TrDh,TrDP,TrDD,CMO,CInter,EOrb,OccNo,
     &                HDiag,Vxc,TrM,nBT,nDens,nD,nTr,nBB,nCI,nnB,nOV)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(CInter)
      Call mma_deallocate(TrDD)
      Call mma_deallocate(TrDP)
      Call mma_deallocate(TrDh)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      SubRoutine WfCtl_SCF_(iTerm,Meth,FstItr,SIntTh,
     &                      OneHam,TwoHam,Dens,Ovrlp,Fock,
     &                      TrDh,TrDP,TrDD,CMO,CInter,EOrb,OccNo,HDiag,
     &                      Vxc,TrM,mBT,mDens,nD,nTr,mBB,nCI,mmB,mOV)
************************************************************************
*                                                                      *
*     purpose: Optimize SCF wavefunction.                              *
*                                                                      *
*     called from: SCF                                                 *
*                                                                      *
*     calls to: PrBeg,Aufbau,DMat,PMat,EneClc,SOIniH,UpdFck,           *
*               TraFck,DIIS_x,DIIS_i,NewOrb,MODens,PrIte               *
*               uses SubRoutines and Functions from Module cycbuf.f    *
*               -cyclic buffer implementation                          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*     QNR/DIIS, M. Schuetz, 1995                                       *
*     NDDO start orbitals, M. Schuetz, 1996                            *
*     University of Lund, Sweden, 1992,95,96                           *
*     UHF, V.Veryazov, 2003                                            *
*     Cleanup, R. Lindh, 2016                                          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      External Seconds
      Real*8 Seconds
      Real*8 OneHam(mBT), TwoHam(mBT,nD,mDens), Dens(mBT,nD,mDens),
     &       Ovrlp(mBT), Fock(mBT,nD), TrDD(nTr*nTr,nD),
     &       TrDh(nTr*nTr,nD), TrDP(nTr*nTr,nD), CMO(mBB,nD),
     &       CInter(nCI,nD), Vxc(mBT,nD,mDens), TrM(mBB,nD),
     &       EOrb(mmB,nD), OccNo(mmB,nD), HDiag(nOV,nD)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "file.fh"
#include "llists.fh"
#include "twoswi.fh"
#include "ldfscf.fh"
#include "warnings.fh"
      Real*8, Dimension(:),   Allocatable:: D1Sao
      Real*8, Dimension(:,:), Allocatable:: Grd1, Disp, Xnp1

*---  Tolerance for negative two-electron energy
      Real*8 E2VTolerance
      Parameter (E2VTolerance=-1.0d-8)

*---  Define local variables
      Logical QNR1st,FstItr
      Character Meth*(*)
      Character*72 Note
      Logical AufBau_Done, Diis_Save, Reset, Reset_Thresh, AllowFlip
      Logical ScramNeworb
      Integer iAufOK, Ind(MxOptm)
      Character*128 OrbName
#ifdef _MSYM_
      Real*8 msym_ctx
#endif
#include "interfaces_scf.fh"
      Dimension Dummy(1),iDummy(7,8)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Call CWTime(TCpu1,TWall1)
*---  Put empty spin density on the runfile.
      Call mma_allocate(D1Sao,nBT,Label='D1Sao')
      Call FZero(D1Sao,nBT)
      Call Put_D1Sao(D1Sao,nBT)
      Call mma_deallocate(D1Sao)
*
      iTerm=0
      iDMin = - 1
*---  Choose between normal and minimized differences
      MinDMx = 0
      If(MiniDn) MinDMx = Max(0,nIter(nIterP)-1)
*
      QNR1st=.TRUE.
*
*     Optimization options
*
*     iOpt=0: DIIS interpolation on density or/and Fock matrices
*     iOpt=1: DIIS extrapolation on gradients w.r.t orbital rot.
*     iOpt=2: DIIS extrapolation on the anti-symmetrix X matrix.
*     iOpt=3: RS-RFO in the space of the anti-symmetric X matrix.
*
      iOpt=0
*
*     START INITIALIZATION
*
*---
*---  Initialize Cholesky information if requested
*
      If (DoCholesky) Then
         If (DoLDF) Then ! Local DF
            Call LDF_X_Init(.True.,0,LDFracMem,irc)
            If (irc.ne.0) Then
               Call WarningMessage(2,
     &                    'WfCtl: non-zero return code from LDF_X_Init')
               Call LDF_Quit(1)
            End If
            Call LDF_SetIntegralPrescreeningInfo()
            Call Free_iSD()
         Else ! Cholesky or RI/DF
            Call Cho_X_init(irc,ChFracMem)
            If (irc.ne.0) Then
               Call WarningMessage(2,
     &                              'WfCtl. Non-zero rc in Cho_X_init.')
               Call Abend
            End If
         End If
      End If
*                                                                      *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*                                                                      *
      iterSt=iter0
      iterso=0        ! number of second order steps.
      kOptim=1
      Iter_no_Diis=2
*                                                                      *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*                                                                      *
*     END INITIALIZATION
*                                                                      *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*                                                                      *
      DiisTh=Max(DiisTh,QNRTh)
*
*     If DIIS is turned off make threhold for activation impossible
*
      If (.NOT. DIIS) Then
         DiisTh=Zero
         Iter_no_Diis=1000000
      End If
*
*     If no damping to preceed the DIIS make threshold being fullfiled
*     at once.
*
      If (.NOT. Damping) Then
         DiisTh=DiisTh*1.0D99
         Iter_no_Diis=0
      End If
*
*---  turn temporarily off DIIS & QNR/DIIS, if Aufbau is active...
*
      DiisTh_save=DiisTh
      Diis_Save=Diis
      If(Aufb) Then
         DiisTh=Zero
         Diis=.False.
      End If
*
*---  Print header to iterations
*
      If(KSDFT.eq.'SCF'.or.One_Grid) Call PrBeg(Meth)
      Temsav=RTemp
      AufBau_Done=.False.
*                                                                      *
*======================================================================*
*======================================================================*
*                                                                      *
*---  If direct SCF modify thresholds temporarily
*
      Reset=.False.
      Reset_Thresh=.False.
      EThr_New=EThr*100.0D0
*
*--- pow: temporary disabling of threshold switching
*
      If((DSCF.or.KSDFT.ne.'SCF').and.nIter(nIterP).gt.10) Then
*
         If(DSCF.and.KSDFT.eq.'SCF'.and.Two_Thresholds) Then
            Reset=.True.
            Reset_Thresh=.True.
            Call Reduce_Thresholds(EThr_New,SIntTh)
         End If
*
         If(KSDFT.ne.'SCF'.and..Not.One_Grid) Then
            Reset=.True.
            Call Modify_NQ_Grid()
            Call PrBeg(Meth)
         End If
*
      End If
*
*======================================================================*
*======================================================================*
*                                                                      *
*                     I  t  e  r  a  t  i  o  n  s                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* nIterP=0: NDDO                                                       *
* nIterP=1: SCF                                                        *
*                                                                      *
*======================================================================*
*
*     Set some paramters to starting defaults.
*
      AllowFlip=.true.
      iAufOK=0
      IterX=0
      If(Scrmbl) IterX=-2
      Iter_DIIS=0
      EDiff=0.0D0
      DMOMax=0.0D0
      FMOMax=0.0D0
      DltNrm=0.0D0
      DMOold=Zero
      FMOold=Zero
      nEconv = 0
      nDconv = 0
      nFconv = 0

      If(MSYMON) Then
#ifdef _MSYM_
         Write(6,*) 'Symmetrizing orbitals during SCF calculation'
         Call fmsym_create_context(msym_ctx)
         Call fmsym_set_elements(msym_ctx)
         Call fmsym_find_symmetry(msym_ctx)
#else
         Write(6,*) 'No msym support, skipping symmetrization '
     $           //'of SCF orbitals...'
#endif
      End If
*                                                                      *
*======================================================================*
*                                                                      *
*     Start of iteration loop
*                                                                      *
*======================================================================*
*                                                                      *
      Do 100 iter = iterSt+1, iterSt+nIter(nIterP)
         IterX=IterX+1
         WarnCfg=.false.
*
         If(.not.Aufb.and.iter.gt.MaxFlip) AllowFlip=.false.

         TCP1=seconds()

         iDMin = iDMin + 1
         If(iDMin.gt.MinDMx) iDMin = MinDMx

#ifdef _MSYM_
         If (MSYMON) Then
            Do iD = 1, nD
               Call fmsym_symmetrize_orbitals(msym_ctx,CMO(1,iD))
               Call ChkOrt(CMO(1,iD),nBO,Ovrlp,nBT,Whatever)
               Call Ortho(CMO(1,iD),nBO,Ovrlp,nBT)
               Call ChkOrt(CMO(1,iD),nBO,Ovrlp,nBT,Whatever)
            End Do
         End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        Do Aufbau procedure, if active...
*
         If (Aufb) Call Aufbau(EOrb,mmB,nAufb,OccNo,mmb,iAufOK,nD)
*                                                                      *
************************************************************************
*                                                                      *
*        Save the variational energy of the previous step
*
         EnVold=EneV
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*        Optimization section
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*        Test if this is a DIIS extrapolation iteration, alternatively
*        the the iteration is a DIIS interpolation iteration. The former
*        is activated if the DMOMax is lower than the threshold
*        after a specific number of iteration, or if the condition
*        has already been achived.
*
*        2017-02-03: add energy criterion to make sure that the DIIS
*                    gets some decent to work with.
*
         If ((DMOMax.lt.DiisTh .AND. IterX.gt.Iter_no_Diis
     &             .AND. ABS(EDiff).lt.1.0D-1)) Then
*
*           Reset kOptim such that the extraploation scheme is not
*           corrupted by iterations with too high energies. Those can
*           not be used in the scheme.
*
            If (iOpt.eq.0) kOptim=2
            iOpt=1
            Iter_DIIS = Iter_DIIS + 1
         End If
*
*        Test if the DIIS scheme will be operating in an orbital
*        rotation mode or linear combination of density matrices. This
*        option is avaliable only in the extrapolation mode of DIIS.
*
*        2017-02-03: Make sure that the density based DIIS is in
*                    action for at least 2 iterations such that
*                    when the orbital rotation DIIS is turned on
*                    we are firmly in the NR region.
*
         If (iOpt.ge.2 .OR.
     &      (iOpt.eq.1 .AND. DMOMax.lt.QNRTh .AND.  Iter_DIIS.ge.2))
     &      Then
            If (RSRFO) Then
               iOpt=3
               kOptim=2
            Else
               iOpt=2
            End If
            If (QNR1st) Then
               kOptim=2
*
*---           compute initial inverse Hessian H (diag)
*
               Call SOIniH(EOrb,nnO,HDiag,nOV,nD)
*
            End If
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*        Move over to DIIS optimization. Here we compute the optimal
*        coefficients CInter.
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
         If ( iOpt.eq.0 ) Then
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*           Interpolation DIIS
*
            Call SCF_Energy(FstItr,E1V,E2V,EneV)
*
*           Compute traces: TrDh, TrDP and TrDD.
*
            Call TraClc_i(OneHam,Dens,TwoHam,Vxc,nBT,nDens,iter,
     &                    TrDh,TrDP,TrDD,MxIter,nD)
*
            If (kOptim.eq.1) Then
*
*              If we only have one density, then nothing much to intra-
*              polate over.
*
               AccCon = 'None     '
*
            Else
*
*              DIIS interpolation optimization: EDIIS, ADIIS, LDIIS
*
               iOpt_DIIS=1 ! EDIIS option
*              iOpt_DIIS=2 ! ADIIS option (untested option)
*              iOpt_DIIS=3 ! LDIIS option (not implemented option)
*
               Call DIIS_i(CInter,nCI,TrDh,TrDP,TrDD,MxIter,nD,
     &                     iOpt_DIIS,Ind)
*
*----          Compute optimal density, dft potentials, and TwoHam
*
               Call OptClc(Dens,TwoHam,Vxc,nBT,nDens,CInter,nCI,nD,Ind)
*
            End If
*
*---        Update Fock Matrix from OneHam and extrapolated TwoHam & Vxc
*
            Call UpdFck(OneHam,TwoHam,Vxc,nBT,nDens,Fock,nIter(nIterP),
     &                  nD)
*---        Diagonalize Fock matrix and obtain new orbitals
*
            ScramNeworb=Scrmbl.and.iter.eq.1
            Call NewOrb_SCF(Fock,nBT,CMO,nBO,FMOMax,EOrb,nnO,Ovrlp,nFO,
     &                  AllowFlip,ScramNeworb,nD)
*
*---        Transform density matrix to MO basis
*
            Call MODens(Dens,Ovrlp,nBT,nDens,CMO,nBB,nD)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
         Else If ( iOpt.eq.1 ) Then
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*           Extrapolation DIIS
*
*           The section of the code operates on the derivatives of
*           the energy w.r.t the elements of the anti-symmetric X
*           matrix.
*
*           The optimal density matrix is found with the DIIS and
*           canonical CMOs are generated by the diagonalization of the
*           Fock matrix.
*
            Call SCF_Energy(FstItr,E1V,E2V,EneV)
*
            Call TraClc_x(kOptim,iOpt.eq.2,FrstDs,.FALSE.,CInter,nCI,nD,
     &                    nOV,Lux,iter,memRsv,LLx)
*
            Call DIIS_x(nD,CInter,nCI,iOpt.eq.2,HDiag,mOV,Ind)
*
*----       Compute optimal density, dft potentials, and TwoHam
*
            Call OptClc(Dens,TwoHam,Vxc,nBT,nDens,CInter,nCI,nD,Ind)
*
*---        Update Fock Matrix from OneHam and extrapolated TwoHam & Vxc
*
            Call UpdFck(OneHam,TwoHam,Vxc,nBT,nDens,Fock,nIter(nIterP),
     &                  nD)
*---        Diagonalize Fock matrix and obtain new orbitals
*
            ScramNeworb=Scrmbl.and.iter.eq.1
            Call NewOrb_SCF(Fock,nBT,CMO,nBO,FMOMax,EOrb,nnO,Ovrlp,nFO,
     &                  AllowFlip,ScramNeworb,nD)
*
*---        Transform density matrix to MO basis
*
            Call MODens(Dens,Ovrlp,nBT,nDens,CMO,nBB,nD)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
         Else If ( iOpt.eq.2 ) Then
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*           Extrapolation DIIS & QNR
*
*           In this section we operate directly on the anti-symmetric X
*           matrix.
*
*           Initially the energy is determined through a line seach,
*           followed by the Fock matrix etc. In this respect, this
*           approach is doing in this iteration what was already done
*           by the two other approaches in the end of the previous
*           iteration.
*
*           Note also, that since we work directly with the X matrix we
*           also rotate the orbitals with this matrix (note the call to
*           RotMOs right before the call to SCF_Energy in the line
*           search routine, linser). Thus, the orbitals here are not
*           canonical and would require at the termination of the
*           optimization that these are computed.
*
*           Initiate if the first QNR step
*
            Call SCF_Energy(FstItr,E1V,E2V,EneV)
*
            Call TraClc_x(kOptim,iOpt.eq.2,FrstDs,QNR1st,CInter,nCI,
     &                    nD,nOV,Lux,iter,memRsv,LLx)
*
            Call dGrd()
*
*---        Update the Fock Matrix from actual OneHam, Vxc & TwoHam
*           AO basis
*
            Call UpdFck(OneHam,TwoHam,Vxc,nBT,nDens,Fock,
     &                  nIter(nIterP),nD)
*
*---        and transform the Fock matrix into the new MO space,
*
            Call TraFck(Fock,nBT,CMO,nBO,.FALSE.,FMOMax,
     &                  EOrb,nnO,Ovrlp,nD)
*
*---        update QNR iteration counter
*
            iterso=iterso+1
*
            Call DIIS_x(nD,CInter,nCI,iOpt.eq.2,HDiag,mOV,Ind)
*
*----       Compute extrapolated g(n) and X(n)
*
            Call mma_allocate(Grd1,nOV,nD,Label='Grd1')
            Call mma_allocate(Xnp1,nOV,nD,Label='Xnp1')
*
            Call OptClc_QNR(CInter,nCI,nD,Grd1,Xnp1,nOV,Ind,MxOptm,
     &                      kOptim)

            Call mma_allocate(Disp,nOV,nD,Label='Disp')
*
*-------    compute new displacement vector delta
*           dX(n) = -H(-1)*grd'(n), grd'(n): extrapolated gradient
*
            Call SOrUpV(MemRsv,Grd1,HDiag,nOV*nD,Disp,'DISP','BFGS')
*
*           from this, compute new orb rot parameter X(n+1)
*
*           X(n+1) = X(n) -H(-1)grd'(X(n))
*
            Call Daxpy_(nOV*nD,-One,Disp,1,Xnp1,1)
            Call PutVec(Xnp1,nOV*nD,Lux,iter+1,MemRsv,'NOOP',LLx)
*
*           get address of actual X(n) in corresponding LList
*
            jpXn=LstPtr(Lux,iter,LLx)
*
*           and compute actual displacement dX(n)=X(n+1)-X(n)
*
            Call DZAXPY(nOV*nD,-One,Work(jpXn),1,Xnp1,1,Disp,1)
*
*           store dX(n) vector from Disp to LList
*
            Call PutVec(Disp,nOV*nD,LuDel,iter,MemRsv,'NOOP',LLDelt)
*
*           compute Norm of dX(n)
*
            DltNrm=DBLE(nD)*DNORM2(nOV*nD,Disp,1)

*           Generate the CMOs, rotate MOs accordingly to new point
*
            Call RotMOs(Disp,nOV,CMO,nBO,nD,Ovrlp,mBT)
*
*           and release memory...
            Call mma_deallocate(Xnp1)
            Call mma_deallocate(Disp)
            Call mma_deallocate(Grd1)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
         Else If ( iOpt.eq.3 ) Then
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*           Quasi-2nd order scheme (rational function optimization)
*           with  restricted.step.
*
*           In this section we operate directly on the anti-symmetric X
*           matrix.
*
*           Initially the energy is determined through a line seach,
*           followed by the Fock matrix etc. In this respect, this
*           approach is doing in this iteration what was already done
*           by the two other approaches in the end of the previous
*           iteration.
*
*           Note also, that since we work directly with the X matrix we
*           also rotate the orbitals with this matrix (note the call to
*           RotMOs right before the call to SCF_Energy in the line
*           search routine, linser). Thus, the orbitals here are not
*           canonical and would require at the termination of the
*           optimization that these are computed.
*
*           Initiate if the first QNR step
*
            Call SCF_Energy(FstItr,E1V,E2V,EneV)
*
            Call TraClc_x(kOptim,iOpt.ge.2,FrstDs,QNR1st,CInter,nCI,
     &                    nD,nOV,Lux,iter,memRsv,LLx)
*
            Call dGrd()
*
*---        Update the Fock Matrix from actual OneHam, Vxc & TwoHam
*           AO basis
*
            Call UpdFck(OneHam,TwoHam,Vxc,nBT,nDens,Fock,
     &                  nIter(nIterP),nD)
*
*---        and transform the Fock matrix into the new MO space,
*
            Call TraFck(Fock,nBT,CMO,nBO,.FALSE.,FMOMax,
     &                  EOrb,nnO,Ovrlp,nD)
*
*---        update QNR iteration counter
*
            iterso=iterso+1
*
*           Allocate memory for the current gradient and
*           displacement vector.
*
            Call mma_allocate(Grd1,nOV,nD,Label='Grd1')
            Call mma_allocate(Disp,nOV,nD,Label='Disp')
*
*           get last gradient grad(n) from LList
*
            Call GetVec(LuGrd,iter,LLGrad,inode,Grd1,nOV*nD)
#ifdef _DEBUGPRINT_
            Call RecPrt('Wfctl: g(n)',' ',Grd1,1,nOV*nD)
#endif
*
*           Call restricted-step rational function optimization procedure
*           to compute dX(n)=Xn+1 - Xn
*
            StepMax=0.3D0
            Call rs_rfo_scf(HDiag,Grd1,nOV*nD,Disp,AccCon(1:6),dqdq,
     &                      dqHdq,StepMax,AccCon(9:9),MemRsv)
*
*           store dX(n) vector from Disp to LList
*
            Call PutVec(Disp,nOV*nD,LuDel,iter,MemRsv,'NOOP',LLDelt)
#ifdef _DEBUGPRINT_
            Write (6,*) 'LuDel,LLDelt:',LuDel,LLDelt
            Call RecPrt('Wfctl: dX(n)',' ',Disp,1,nOV*nD)
#endif
*
*           compute Norm of delta(n)
*
            DltNrm=DBLE(nD)*dqdq
*
*           Generate the CMOs, rotate MOs accordingly to new point
*
            Call RotMOs(Disp,nOV,CMO,nBO,nD,Ovrlp,mBT)
*
*           and release memory...
            Call mma_deallocate(Disp)
            Call mma_deallocate(Grd1)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
         Else
            Write (6,*) 'WfCtl_SCF: Illegal option'
            Call Abend()
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*----    Update DIIS interpolation depth kOptim
*
         If (iOpt.ne.3) Then
            If (idKeep.eq.0) Then
               kOptim = 1
            Else If (idKeep.eq.1) Then
               kOptim = 2
            Else
               kOptim = kOptim + 1
            End If
            If (kOptim.gt.MxOptm) kOptim = MxOptm
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*        End optimization section
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*---     Save the new orbitals in case the SCF program aborts

         iTrM = 1
         iCMO = 1
         Do iSym = 1, nSym
            nBs = nBas(iSym)
            nOr = nOrb(iSym)
            lth = nBs*nOr
            Do iD = 1, nD
               Call DCopy_(lth,CMO(iCMO,iD),1,TrM(iTrM,iD),1)
               Call FZero(TrM(iTrm+nBs*nOr,iD),nBs*(nBs-nOr))
            End Do
            iTrM = iTrM + nBs*nBs
            iCMO = iCMO + nBs*nOr
         End Do
*
         If(iUHF.eq.0) Then
            OrbName='SCFORB'
            Note='*  intermediate SCF orbitals'
            If(KSDFT.eq.'SCF') Then
               iWFtype=2
            Else
               iWFtype=3
            End If

            Call WrVec_(OrbName,LuOut,'CO',iUHF,nSym,nBas,nBas,
     &                  TrM(1,1), Dummy,OccNo(1,1), Dummy,
     &                  Dummy,Dummy, iDummy,Note,2)
            Call Put_darray('SCF orbitals',TrM(1,1),nBB)
            Call Put_darray('OrbE',Eorb(1,1),nnB)
            If(.not.Aufb) Then
               Call Put_iarray('SCF nOcc',nOcc(1,1),nSym)
            End If
         Else
            OrbName='UHFORB'
            Note='*  intermediate UHF orbitals'
            If(KSDFT.eq.'SCF') Then
               iWFtype=4
            Else
               iWFtype=5
            End If
            Call WrVec_(OrbName,LuOut,'CO',iUHF,nSym,nBas,nBas,
     &                  TrM(1,1), TrM(1,2),OccNo(1,1),OccNo(1,2),
     &                  Dummy,Dummy, iDummy,Note,3)
            Call Put_darray('SCF orbitals',   TrM(1,1),nBB)
            Call Put_darray('SCF orbitals_ab',TrM(1,2),nBB)
            Call Put_darray('OrbE',   Eorb(1,1),nnB)
            Call Put_darray('OrbE_ab',Eorb(1,2),nnB)
            If(.not.Aufb) Then
               Call Put_iarray('SCF nOcc',   nOcc(1,1),nSym)
               Call Put_iarray('SCF nOcc_ab',nOcc(1,2),nSym)
            End If
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*        Update some parameters to be used in subsequent iterations
*
         If(iter.eq.1) Then
            EDiff  = Zero
            DMOold = DMOmax
            FMOold = FMOmax
            nEconv = 0
            nDconv = 0
            nFconv = 0
         Else
            EDiff = EneV-EnVold
            If(Abs(Ediff).le.10.0d0*Ethr) Then
               nEconv=nEconv+1
            Else
               nEconv=0
            End If
            If(Abs(DMOmax-DMOold).le.1.0d-6) Then
               nDconv=nDconv+1
            Else
               nDconv=0
            End If
            If(Abs(FMOmax-FMOold).le.1.0d-6) Then
               nFconv=nFconv+1
            Else
               nFconv=0
            End If
            If(nEconv.gt.9 .and. nDconv.gt.9 .and. nFconv.gt.9) Then
               Emconv=.true.
               WarnSlow=.true.
            End If
*           Write(6,'(a,3i5)') 'nEconv, nDconv, nFconv:',
*    &                          nEconv,nDconv,nFconv
            DMOold = DMOmax
            FMOold = FMOmax
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*                                                                      *
*======================================================================*
*                                                                      *
*                         A U F B A U  section                         *
*                                                                      *
*======================================================================*
*                                                                      *
         If (Aufb.and..Not.Teee) Then
*
            If(iter.ne.1 .and. Abs(EDiff).lt.0.002D0 .and.
     &         .Not.AufBau_Done) Then
               Aufbau_Done=.True.
               Diis=Diis_Save
               DiisTh=DiisTh_save
            End If
*
         Else If (Aufb.and.Teee) Then
*
* If one iteration has been performed with the end temperature and we
* have a stable aufbau Slater determinant, terminate.
* The temperature is scaled down each iteration until it reaches the end
* temperature
*
* !!! continue here
            If(Abs(RTemp-TStop).le.1.0d-3
     &         .and. iAufOK.eq.1
     &         .and. Abs(Ediff).lt.1.0d-2 ) Then
               Aufbau_Done=.True.
               Diis=Diis_Save
               DiisTh=DiisTh_save
            End If
            RTemp=TemFac*RTemp
*           RTemp=Max(TStop,RTemp)
            TSTop=Min(TStop,RTemp)
         End If
*                                                                      *
*======================================================================*
*======================================================================*
*                                                                      *
*------- Print out necessary things
*
         TCP2=seconds()
         CpuItr = TCP2 - TCP1
         Call PrIte(iOpt.ge.2,CMO,mBB,nD,Ovrlp,mBT,OccNo,mmB)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- Perform another iteration if necessary
*
*        Convergence criteria are
*
*        Either,
*
*        1) it is not the first iteration
*        2) the absolute energy change is smaller than EThr
*        3) the absolute Fock matrix change is smaller than FThr
*        4) the absolute density matrix change is smaller than DThr,
*           and
*        5) step is NOT a Quasi NR step
*
*        or
*
*        1) step is a Quasi NR step, and
*        2) DltNrm.le.DltNth
*
*        or
*
*        EmConv is true.
*
         If (iter.ne.1             .AND.
     &       (Abs(EDiff).le.EThr)  .AND.
     &       (Abs(FMOMax).le.FThr) .AND.
     &       (((Abs(DMOMax).le.DThr).AND.(iOpt.lt.2))
     &       .OR.
     &       ((DltNrm.le.DltNTh).AND.iOpt.ge.2))
     &       .OR.EmConv
     &      ) Then
*
            If(Aufb) Then
               WarnPocc=.true.
               EmConv=.False.
            End If
*
*           If calculation with two different sets of parameters rest
*           the convergence parameters to default values. This is
*           possibly used for direct SCF and DFT.
*           See "99 Continue" below.
*
            If (Reset) Go To 99
*
*           Here if we converged!
*
            If (jPrint.ge.2) Then
               If (EmConv) Then
                  Write (6,*)
                  Write (6,'(6X,A)')
     &                  'No convergence, optimization aborted'
               Else
                  Write (6,*)
                  Write (6,'(6X,A,I3,A)')' Convergence after',
     &                      iter, ' Macro Iterations'
               End If
            End If
*
*           Branch out of the iterative loop! Done!!!
*
            GoTo 101
*                                                                      *
************************************************************************
*                                                                      *
         Else If(Aufb.and.AufBau_Done) Then
*                                                                      *
************************************************************************
*                                                                      *
*           Here if Aufbau stage is finished and the calculation will
*           continue normally.
*
            Aufb=.FALSE.
            If (jPrint.ge.2) Then
               Write(6,*)
               Write(6,'(6X,A)') ' Fermi aufbau procedure completed!'
            End If
            IterX=-2
            If(iUHF.eq.0) Then
               iOffOcc=0
               Do iSym = 1, nSym
                  Do iBas = 1, nOrb(iSym)
                     iOffOcc=iOffOcc+1
                     If(iBas.le.nOcc(iSym,1)) Then
                        OccNo(iOffOcc,1)=2.0d0
                     Else
                        OccNo(iOffOcc,1)=0.0d0
                     End If
                  End Do
               End Do
               If (jPrint.ge.2) Then
                Write (6,'(6X,A,8I5)') 'nOcc=',
     &                (nOcc(iSym,1),iSym=1,nSym)
                Write (6,*)
               End If
            Else
               iOffOcc=0
               Do iSym = 1, nSym
                  Do iBas = 1, nOrb(iSym)
                     iOffOcc=iOffOcc+1
                     If(iBas.le.nOcc(iSym,1)) Then
                        OccNo(iOffOcc,1)=1.0d0
                     Else
                        OccNo(iOffOcc,1)=0.0d0
                     End If
                     If(iBas.le.nOcc(iSym,2)) Then
                        OccNo(iOffOcc,2)=1.0d0
                     Else
                        OccNo(iOffOcc,2)=0.0d0
                     End If
                  End Do
               End Do
               If (jPrint.ge.2) Then
                  Write (6,'(6X,A,8I5)')
     *              'nOcc(alpha)=',(nOcc(iSym,1),iSym=1,nSym)
                  Write (6,'(6X,A,8I5)')
     *              'nOcc(beta) =',(nOcc(iSym,2),iSym=1,nSym)
                  Write (6,*)
               End If

            End If
*
*---------- Now when nOcc is known compute standard sizes of arrays.
*
            Call Setup
*
         End If
*
*----------------------------------------------------------------------*
         Call Scf_Mcontrol(iter)
*----------------------------------------------------------------------*
*
*------- Check that two-electron energy is positive.
*        The LDF integrals may not be positive definite, leading to
*        negative eigenvalues of the ERI matrix - i.e. attractive forces
*        between the electrons! When that occurs the SCF iterations
*        still might find a valid SCF solution, but it will obviously be
*        unphysical and we might as well just stop here.
*
         If (Neg2_Action.ne.'CONT') Then
            If (E2V.lt.E2VTolerance) Then
               Call WarningMessage(2,
     &                        'WfCtl_SCF: negative two-electron energy')
               Write(6,'(A,1P,D25.10)') 'Two-electron energy E2V=',E2V
               Call xFlush(6)
               If (Neg2_Action.eq.'STOP') Call Abend()
            End If
         End If
*----------------------------------------------------------------------*
         Go To 100  ! Skip the reset section.
*                                                                      *
************************************************************************
*                                                                      *
*------- Reset thresholds for direct SCF procedure
*
  99     Continue
         Reset=.False.
         EmConv=.False.
*
*---------------
         If(iOpt.eq.2) Then
            iOpt = 1        ! True if step is QNR
            QNR1st=.TRUE.
         End If
         iterso=0
         If(Reset_Thresh) Call Reset_Thresholds
         If(KSDFT.ne.'SCF') Then
            If (.Not.One_Grid) Then
               iterX=0
               Call Reset_NQ_grid()
*              Call PrBeg(Meth)
            End If
            If ( iOpt.eq.0 ) kOptim=1
         End If
*
*                                                                      *
*======================================================================*
*                                                                      *
*     End of iteration loop
*
 100  Continue ! iter
*                                                                      *
*======================================================================*
*                                                                      *
#ifdef _MSYM_
      If (MSYMON) Then
         Call fmsym_release_context(msym_ctx)
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Here if we didn't converge or if this was a forced one iteration
*     calculation.
*
      iter=iter-1
      If(nIter(nIterP).gt.1) Then
         If (jPrint.ge.1) Then
            Write(6,*)
            Write(6,'(6X,A,I3,A)')
     &              ' No convergence after',iter,' Iterations'
         End If
         iTerm = _RC_NOT_CONVERGED_
      Else
         If (jPrint.ge.2) Then
            Write(6,*)
            Write(6,'(6X,A)') ' Single iteration finished!'
         End If
      End If
*
      If (jPrint.ge.2) Then
         Write(6,*)
      End If
*
      If(Reset) Then
         If(DSCF.and.KSDFT.eq.'SCF') Call Reset_Thresholds
         If(KSDFT.ne.'SCF'.and..Not.One_Grid) then
           Call Reset_NQ_grid()
         endif
      End If
*
***********************************************************
*                      S   T   O   P                      *
***********************************************************
*
  101 Continue
      If (jPrint.ge.2) Then
         Call CollapseOutput(0,'Convergence information')
         Write(6,*)
      End If
*---  Compute total spin (if UHF)
      If(iUHF.eq.0) Then
         s2uhf=0.0d0
      Else
         Call s2calc(CMO(1,1),CMO(1,2),Ovrlp,
     &               nOcc(1,1),nOcc(1,2),nBas,nOrb, nSym,
     &               s2uhf)
      End If
*---
      Call Add_Info('SCF_ITER',[DBLE(Iter)],1,8)
c     Call Scf_XML(0)
*
      Call KiLLs
*
*     If the orbitals are generated with orbital rotations in
*     RotMOs we need to generate the canonical orbitals.
*
      If (iOpt.ge.2) Then
*
*---    Generate canonical orbitals
*
         Call TraFck(Fock,nBT,CMO,nBO,.TRUE.,FMOMax,EOrb,nnO,
     &               Ovrlp,nD)
*
*        Transform density matrix to MO basis
*
         Call MODens(Dens,Ovrlp,nBT,nDens,CMO,nBB,nD)
*
      End If
*
*---- Compute correct orbital energies
*
      Call MkEorb(Fock,nBT,CMO,nBB,EOrb,nnB,nSym,nBas,nOrb,nD)
*
*     Put orbital coefficients and energies on the runfile.
*
      Call Put_darray('SCF orbitals',   CMO(1,1),nBB)
      Call Put_darray('OrbE',   Eorb(1,1),nnB)
      If (nD.eq.2) Then
         Call Put_darray('SCF orbitals_ab',   CMO(1,2),nBB)
         Call Put_darray('OrbE_ab',   Eorb(1,2),nnB)
      End If
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*---  Finalize Cholesky information if initialized
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      If (DoCholesky) Then
         If (DoLDF) Then
            Call LDF_UnsetIntegralPrescreeningInfo()
            Call LDF_X_Final(.True.,irc)
            If (irc.ne.0) Then
               Call WarningMessage(2,
     &                   'WfCtl: non-zero return code from LDF_X_Final')
               Call LDF_Quit(1)
            End If
         Else
            Call Cho_X_Final(irc)
            If (irc.ne.0) Then
               Call WarningMessage(2,
     &                             'WfCtl. Non-zero rc in Cho_X_Final.')
               Call Abend
            End If
         End If
      End If
*                                                                      *
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*                                                                      *
      Call CWTime(TCpu2,TWall2)
      Call SavTim(3,TCpu2-TCpu1,TWall2-TWall1)
      TimFld( 2) = TimFld( 2) + (TCpu2 - TCpu1)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Anders Bernhardsson                              *
!               1994, Roland Lindh                                     *
!***********************************************************************

subroutine CmbnS2a(Rnxyz,nZeta,la,lb,rKappa,rFinal,Alpha,IfHss,ld)
!***********************************************************************
!                                                                      *
! Object: compute the 2nd derivative of the overlap matrix.            *
!                                                                      *
!***********************************************************************

use Index_Functions, only: C_Ind, iTri, nTri_Elem1
use Constants, only: Two, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, ld
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la+ld,0:lb), rKappa(nZeta), Alpha(nZeta)
real(kind=wp), intent(inout) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),6)
logical(kind=iwp), intent(in) :: IfHss(4,3,4,3)
integer(kind=iwp) :: ia(3), iax, iay, ib(3), ibx, iby, iCoor, ii, ij, ipa, ipb, iyaMax, iybMax, jCoor, kCoor

do iax=0,la
  ia(1) = iax
  iyaMax = la-ia(1)
  do ibx=0,lb
    ib(1) = ibx
    iybMax = lb-ib(1)
    do iay=0,iyaMax
      ia(2) = iay
      ia(3) = la-ia(2)-ia(1)
      ipa = C_Ind(la,ia(1),ia(3))
      do iby=0,iybMax
        ib(2) = iby
        ib(3) = lb-ib(2)-ib(1)
        ipb = C_Ind(lb,ib(1),ib(3))

        ! Combine overlap integrals

        ! Integrals like dI/dx1dx1

        do iCoor=1,3
          jCoor = mod(iCoor,3)+1
          kCoor = mod(jCoor,3)+1
          if (IfHss(1,iCoor,1,iCoor)) then
            ii = iTri(iCoor,iCoor)
            rFinal(:,ipa,ipb,ii) = rKappa(:)*((Two*Alpha(:))**2*Rnxyz(:,iCoor,ia(iCoor)+2,ib(iCoor))* &
                                                                Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))- &
                                              Two*Alpha(:)*Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                           Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                           Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
            if (ia(iCoor) > 0) rFinal(:,ipa,ipb,ii) = rFinal(:,ipa,ipb,ii)-rKappa(:)*Four*Alpha(:)*real(ia(iCoor),kind=wp)* &
                                                      Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                      Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                      Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ia(iCoor) > 1) rFinal(:,ipa,ipb,ii) = rFinal(:,ipa,ipb,ii)+rKappa(:)*real(ia(iCoor)*(ia(iCoor)-1),kind=wp)* &
                                                      Rnxyz(:,iCoor,ia(iCoor)-2,ib(iCoor))* &
                                                      Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                      Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
          end if
        end do

        ! Integrals like dI/dxdz

        do iCoor=2,3
          do jCoor=1,iCoor-1
            if (IfHss(1,iCoor,1,jCoor)) then
              ij = iTri(iCoor,jCoor)
              rFinal(:,ipa,ipb,ij) = rKappa
              do kCoor=1,3
                if ((kCoor == iCoor) .or. (kCoor == jCoor)) then
                  if (ia(kCoor) > 0) then
                    rFinal(:,ipa,ipb,ij) = rFinal(:,ipa,ipb,ij)*(Two*Alpha(:)*Rnxyz(:,kCoor,ia(kCoor)+1,ib(kCoor))- &
                                                                 real(ia(kCoor),kind=wp)*Rnxyz(:,kCoor,ia(kCoor)-1,ib(kCoor)))
                  else
                    rFinal(:,ipa,ipb,ij) = rFinal(:,ipa,ipb,ij)*Two*Alpha(:)*Rnxyz(:,kCoor,ia(kCoor)+1,ib(kCoor))
                  end if
                else
                  rFinal(:,ipa,ipb,ij) = rFinal(:,ipa,ipb,ij)*Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
                end if
              end do
            end if
          end do
        end do
      end do
    end do
  end do
end do

return

end subroutine CmbnS2a

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_OpenVR(iOpt)
!
! Purpose: open (iOpt=1) or close (iOpt=2) local and global storage
!          files.

use Para_Info, only: Is_Real_Par, nProcs
use Cholesky, only: Cho_AdrVec, Cho_Fake_Par, Cho_Real_Par, LuCho, LuCho_G, LuPri, LuRed_G, LuRst_G, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iOpt
integer(kind=iwp) :: ID, iSym
character(len=6) :: FNRst, FNVec(8)
character(len=5) :: FNRed
character(len=*), parameter :: SecNam = 'Cho_P_OpenVR'

! Local files.
! ------------

if (Cho_Real_Par) then
  ID = 1
else
  ID = 2
end if
call Cho_OpenVR(iOpt,ID)

! Global files for restart info and reduced set indices.
! ------------------------------------------------------

if (Cho_Real_Par) then
  if (iOpt == 1) then
    LuRed_G = 7
    FNRed = 'CHRED'
    call DAName_MF_WA(LuRed_G,FNRed)
    LuRst_G = 7
    FNRst = 'CHORST'
    call DAName_MF_WA(LuRst_G,FNRst)
    do iSym=1,nSym
      LuCho_G(iSym) = 7
      write(FNVec(iSym),'(A5,I1)') 'CHVEC',iSym
      call DaName_MF_WA(LuCho_G(iSym),FNVec(iSym))
    end do
  else if (iOpt == 2) then
    if (LuRed_G > 0) then
      call DAClos(LuRed_G)
      LuRed_G = 0
    end if
    if (LuRst_G > 0) then
      call DAClos(LuRst_G)
      LuRst_G = 0
    end if
    do iSym=1,nSym
      if (LuCho_G(iSym) > 0) then
        call DaClos(LuCho_G(iSym))
        LuCho_G(iSym) = 0
      end if
    end do
  else
    write(Lupri,*) SecNam,': iOpt out of bounds: ',iOpt
    call Cho_Quit('Error in '//SecNam,104)
  end if
else
  if (CHO_FAKE_PAR .and. (nProcs > 1) .and. Is_Real_Par()) then
    if (iOpt == 1) then
      if (CHO_ADRVEC == 1) then
        do iSym=1,nSym
          LuCho_G(iSym) = 7
          write(FNVec(iSym),'(A5,I1)') 'CHVCL',iSym
          call DaName_MF_WA(LuCho_G(iSym),FNVec(iSym))
        end do
      else if (CHO_ADRVEC == 2) then
        do iSym=1,nSym
          LuCho_G(iSym) = 7
          write(FNVec(iSym),'(A5,I1)') 'CHVCL',iSym
          call DaName_MF(LuCho_G(iSym),FNVec(iSym))
        end do
      else
        call Cho_Quit('CHO_ADRVEC out of bounds in '//SecNam,102)
        LuCho_G(1:nSym) = 0
      end if
      ! Swap units so that
      !    LuCho_G points to 'CHVEC'
      !    LuCho   points to 'CHVCL'
      call iSwap(nSym,LuCho,1,LuCho_G,1)
    else if (iOpt == 2) then
      do iSym=1,nSym
        if (LuCho_G(iSym) > 0) then
          call DaClos(LuCho_G(iSym))
          LuCho_G(iSym) = 0
        end if
      end do
    else
      write(Lupri,*) SecNam,': iOpt out of bounds: ',iOpt
      call Cho_Quit('Error in '//SecNam,104)
    end if
  end if
end if

end subroutine Cho_P_OpenVR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine change3_cvb()

use casvb_global, only: kbasis, kbasiscvb
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: kmost
logical(kind=iwp) :: changed
logical(kind=iwp), external :: chpcmp_cvb ! ... Change of dimensioning variables ...

changed = .false.
! Spin functions coefficients (BIKCOF) + inverse (AIKCOF)
!  Get KBASISCVB if we don't know it already (eqv. to GETGUESS later):
!  Need to reserve enough space for both KBASIS and KBASISCVB
!  --> figure out which one needs most:
if (((kbasis > 2) .and. (kbasis /= 6)) .or. ((kbasiscvb > 2) .and. (kbasiscvb /= 6))) then
  kmost = 3
else if ((kbasis <= 2) .or. (kbasiscvb <= 2)) then
  kmost = 1
else
  kmost = 6
end if
if (chpcmp_cvb(kmost)) changed = .true.
if (changed) call touch_cvb('MEM3')

return

end subroutine change3_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Tessera(IPRINT,Nesf,NS,NV,XE,YE,ZE,RE,IntSph,PTS,CCC,PP,AREA)

use PCM_Arrays, only: MxVert
use Constants, only: Zero, Two, Eleven
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IPRINT, Nesf, NS
integer(kind=iwp), intent(inout) :: NV
real(kind=wp), intent(in) :: XE(*), YE(*), ZE(*), RE(*)
integer(kind=iwp), intent(out) :: IntSph(MxVert)
real(kind=wp), intent(inout) :: PTS(3,MxVert)
real(kind=wp), intent(out) :: CCC(3,MxVert), PP(3), AREA
integer(kind=iwp) :: I, ICOP, ICUT, IND(MxVert), INTSCR(MxVert), II, IV1, IV2, L, LTYP(MxVert), N, NSFE1
real(kind=wp) :: CCCP(3,MxVert), DE2, DELR, DELR2, DIST, DNORM, P1(3), P2(3), P3(3), P4(3), POINT(3), POINTL(3,MxVert), &
                 PSCR(3,MxVert), RC, RC2
real(kind=wp), parameter :: Small = 1.0e-12_wp, TOL = -1.0e-10_wp

! Coord. del centro che sottende l'arco tra i vertici
! n e n+1 (per i primi tre vertici e' sicuramente il centro della
! sfera) e sfera alla cui intersezione con NS appartiene l'arco (se
! appartiene alla sfera originaria INTSPH(N)=NS)

AREA = Zero
CCC(1,1:3) = XE(NS)
CCC(2,1:3) = YE(NS)
CCC(3,1:3) = ZE(NS)
! INTSPH viene riferito alla tessera MxTs, e in seguito riceve il
! numero corretto.
INTSPH(1:3) = NS
! Loop sulle altre sfere
do NSFE1=1,NESF
  if (NSFE1 == NS) cycle
  ! Memorizza i vertici e i centri che sottendono gli archi
  INTSCR(1:NV) = INTSPH(1:NV)
  PSCR(:,1:NV) = PTS(:,1:NV)
  CCCP(:,1:NV) = CCC(:,1:NV)
  ICOP = 0
  IND(:) = 0
  LTYP(:) = 0
  ! Loop sui vertici della tessera considerata
  do I=1,NV
    DELR2 = (PTS(1,I)-XE(NSFE1))**2+(PTS(2,I)-YE(NSFE1))**2+(PTS(3,I)-ZE(NSFE1))**2
    DELR = sqrt(DELR2)
    if (DELR < (RE(NSFE1)-Small)) then
      IND(I) = 1
      ICOP = ICOP+1
    end if
  end do
  ! Se la tessera e' completamente coperta, la trascura
  if (ICOP == NV) return
  ! Controlla e classifica i lati della tessera: LTYP = 0 (coperto),
  ! 1 (tagliato con il II vertice coperto), 2 (tagliato con il I
  ! vertice coperto), 3 (bitagliato), 4 (libero)
  ! Loop sui lati
  do L=1,NV
    IV1 = L
    IV2 = L+1
    if (L == NV) IV2 = 1
    if ((IND(IV1) == 1) .and. (IND(IV2) == 1)) then
      LTYP(L) = 0
    else if ((IND(IV1) == 0) .and. (IND(IV2) == 1)) then
      LTYP(L) = 1
    else if ((IND(IV1) == 1) .and. (IND(IV2) == 0)) then
      LTYP(L) = 2
    else if ((IND(IV1) == 0) .and. (IND(IV2) == 0)) then
      LTYP(L) = 4
      RC2 = (CCC(1,L)-PTS(1,L))**2+(CCC(2,L)-PTS(2,L))**2+(CCC(3,L)-PTS(3,L))**2
      RC = sqrt(RC2)
      ! Su ogni lato si definiscono 11 punti equispaziati, che vengono
      ! controllati
      do II=1,11
        POINT(:) = PTS(:,IV1)+II*(PTS(:,IV2)-PTS(:,IV1))/Eleven
        POINT(:) = POINT(:)-CCC(:,L)
        DNORM = sqrt(POINT(1)**2+POINT(2)**2+POINT(3)**2)
        POINT(:) = POINT(:)*RC/DNORM+CCC(:,L)
        DIST = sqrt((POINT(1)-XE(NSFE1))**2+(POINT(2)-YE(NSFE1))**2+(POINT(3)-ZE(NSFE1))**2)
        if ((DIST-RE(NSFE1)) < TOL) then
          !if (DIST < RE(NSFE1)) then
          LTYP(L) = 3
          POINTL(:,L) = POINT(:)
          exit
        end if
      end do
    end if
  end do
  ! Se la tessera e' spezzata in due o piu' tronconi, la trascura
  ICUT = 0
  do L=1,NV
    if ((LTYP(L) == 1) .or. (LTYP(L) == 2)) ICUT = ICUT+1
    if (LTYP(L) == 3) ICUT = ICUT+2
  end do
  ICUT = ICUT/2
  if (ICUT > 1) return
  ! Creazione dei nuovi vertici e lati della tessera
  ! Loop sui lati
  N = 1
  do L=1,NV
    ! Se il lato L e' coperto:
    if (LTYP(L) == 0) cycle
    IV1 = L
    IV2 = L+1
    if (L == NV) IV2 = 1
    !*******************************************************************
    ! Se il lato L e' tagliato (con il I vertice scoperto):
    if (LTYP(L) == 1) then
      PTS(:,N) = PSCR(:,IV1)
      CCC(:,N) = CCCP(:,IV1)
      INTSPH(N) = INTSCR(IV1)
      N = N+1
      ! Trova l'intersezione tra i due vertici del lato L
      !
      ! P1 = coord. del primo vertice
      ! P2 = coord. del secondo vertice
      ! P3 = coord. del centro dell'arco sotteso
      ! P4 = coord. dell'intersezione

      P1(:) = PSCR(:,IV1)
      P2(:) = PSCR(:,IV2)
      P3(:) = CCCP(:,IV1)

      call INTER_PCM(XE(NSFE1),YE(NSFE1),ZE(NSFE1),RE(NSFE1),P1,P2,P3,P4,0,IPRINT)
      ! Aggiorna i vertici della tessera e il centro dell'arco
      PTS(:,N) = P4(:)

      ! Il nuovo arco sara' sotteso tra questo e il prossimo punto
      ! di intersezione: il centro che lo sottende
      ! sara' il centro del cerchio di intersezione tra la sfera NS
      ! e la sfera NSFE1.

      DE2 = (XE(NSFE1)-XE(NS))**2+(YE(NSFE1)-YE(NS))**2+(ZE(NSFE1)-ZE(NS))**2
      CCC(1,N) = XE(NS)+(XE(NSFE1)-XE(NS))*(RE(NS)**2-RE(NSFE1)**2+DE2)/(Two*DE2)
      CCC(2,N) = YE(NS)+(YE(NSFE1)-YE(NS))*(RE(NS)**2-RE(NSFE1)**2+DE2)/(Two*DE2)
      CCC(3,N) = ZE(NS)+(ZE(NSFE1)-ZE(NS))*(RE(NS)**2-RE(NSFE1)**2+DE2)/(Two*DE2)
      INTSPH(N) = NSFE1
      N = N+1
    end if
    !*******************************************************************
    ! Se il lato L e' tagliato (con il II vertice scoperto):
    if (LTYP(L) == 2) then
      ! Trova l'intersezione tra i due vertici del lato L
      !
      ! P1 = coord. del primo vertice
      ! P2 = coord. del secondo vertice
      ! P3 = coord. del centro dell'arco sotteso
      ! P4 = coord. dell'intersezione

      P1(:) = PSCR(:,IV1)
      P2(:) = PSCR(:,IV2)
      P3(:) = CCCP(:,IV1)

      call INTER_PCM(XE(NSFE1),YE(NSFE1),ZE(NSFE1),RE(NSFE1),P1,P2,P3,P4,1,IPRINT)
      ! Aggiorna i vertici della tessera e il centro dell'arco
      PTS(:,N) = P4(:)
      CCC(:,N) = CCCP(:,IV1)
      INTSPH(N) = INTSCR(IV1)
      N = N+1
    end if
    !*******************************************************************
    ! Se il lato e' intersecato due volte:
    if (LTYP(L) == 3) then
      PTS(:,N) = PSCR(:,IV1)
      CCC(:,N) = CCCP(:,IV1)
      INTSPH(N) = INTSCR(IV1)
      N = N+1
      ! Trova l'intersezione tra il primo vertice e un punto intermedio
      ! coperto
      !
      ! P1 = coord. del primo vertice
      ! P2 = coord. del secondo vertice
      ! P3 = coord. del centro dell'arco sotteso
      ! P4 = coord. dell'intersezione

      P1(:) = PSCR(:,IV1)
      P2(:) = POINTL(:,L)
      P3(:) = CCCP(:,IV1)
      call INTER_PCM(XE(NSFE1),YE(NSFE1),ZE(NSFE1),RE(NSFE1),P1,P2,P3,P4,0,IPRINT)
      ! Aggiorna i vertici della tessera e il centro dell'arco
      PTS(:,N) = P4(:)

      ! Il nuovo arco sara' sotteso tra questo e il prossimo punto
      ! di intersezione: il centro che lo sottende
      ! sara' il centro del cerchio di intersezione tra la sfera NS
      ! e la sfera NSFE1.

      DE2 = (XE(NSFE1)-XE(NS))**2+(YE(NSFE1)-YE(NS))**2+(ZE(NSFE1)-ZE(NS))**2
      CCC(1,N) = XE(NS)+(XE(NSFE1)-XE(NS))*(RE(NS)**2-RE(NSFE1)**2+DE2)/(Two*DE2)
      CCC(2,N) = YE(NS)+(YE(NSFE1)-YE(NS))*(RE(NS)**2-RE(NSFE1)**2+DE2)/(Two*DE2)
      CCC(3,N) = ZE(NS)+(ZE(NSFE1)-ZE(NS))*(RE(NS)**2-RE(NSFE1)**2+DE2)/(Two*DE2)
      INTSPH(N) = NSFE1
      N = N+1

      ! Trova l'intersezione tra un punto intermedio coperto e il
      ! secondo vertice
      !
      ! P1 = coord. del primo vertice
      ! P2 = coord. del secondo vertice
      ! P3 = coord. del centro dell'arco sotteso
      ! P4 = coord. dell'intersezione

      P1(:) = POINTL(:,L)
      P2(:) = PSCR(:,IV2)
      P3(:) = CCCP(:,IV1)

      call INTER_PCM(XE(NSFE1),YE(NSFE1),ZE(NSFE1),RE(NSFE1),P1,P2,P3,P4,1,IPRINT)
      ! Aggiorna il vertice e il centro dell'arco
      PTS(:,N) = P4(:)
      CCC(:,N) = CCCP(:,IV1)
      INTSPH(N) = INTSCR(IV1)
      N = N+1
    end if

    !*******************************************************************
    ! Se il lato e' scoperto:
    if (LTYP(L) == 4) then
      PTS(:,N) = PSCR(:,IV1)
      CCC(:,N) = CCCP(:,IV1)
      INTSPH(N) = INTSCR(IV1)
      N = N+1
    end if
    ! Controlla che il numero di vertici creati non sia eccessivo
    if (N > 11) then
      write(u6,'(/,a)') ' TESSERA: too many vertices in a tessera'
      call Abend()
    end if
  end do

  NV = N-1
end do

! Se la tessera non e' stata scartata, a questo punto ne troviamo
! l'area e il punto rappresentativo

call GAUBON(XE,YE,ZE,RE,IntSph,NV,NS,PTS,CCC,PP,AREA,IPRINT)

return

end subroutine Tessera

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Per Ake Malmqvist                                *
************************************************************************
      SubRoutine AMPr(Beta,nZeta,Rslt,la,lb,Tabpp,Tabp,Tab0,
     &                Tabm,Tabmm)
************************************************************************
*                                                                      *
* Object: Compute matrix elements of hermitized products of angular    *
*         moment operators, using elementary overlaps, dipole, and     *
*         quadrupole integrals.                                        *
*                                                                      *
*     Author: Per-Ake Malmqvist, Dept. of Theoretical Chemistry,       *
*             University of Lund, SWEDEN                               *
*             November '96                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8  Rslt  (nZeta,((la+1)*(la+2))/2,((lb+1)*(lb+2))/2,6),
     &        Tabpp (nZeta,((la+1)*(la+2))/2,((lb+3)*(lb+4))/2,6),
     &        Tabp  (nZeta,((la+1)*(la+2))/2,((lb+2)*(lb+3))/2,3),
     &        Tab0  (nZeta,((la+1)*(la+2))/2,((lb+1)*(lb+2))/2,6),
     &        Tabm  (nZeta,((la+1)*(la+2))/2,( lb   *(lb+1))/2,3),
     &        Tabmm (nZeta,((la+1)*(la+2))/2,((lb-1)* lb   )/2,6),
     &        Beta(nZeta)
      Character*80 Label
      data kx, ky, kz  / 1, 2, 3 /
      data kxx,kxy,kxz,kyy,kyz,kzz / 1,2,3,4,5,6 /
      data kyx,kzx,kzy/ 2,3,5 /
*
*     Statement function for cartesian index
      Ind(j,k)=((j+k)*(j+k+1))/2+k+1
      nElem(ix) = (ix+1)*(ix+2)/2
*
      iRout = 221
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
          Write (6,*) ' In AMPr la,lb=',la,lb
          Call RecPrt('Beta',' ',Beta,nZeta,1)
          Do ia = 1, nElem(la)
             Do ib = 1, nElem(lb+2)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tabpp(',ia,',',ib,'xx)'
                Call RecPrt(Label,' ',Tabpp(1,ia,ib,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tabpp(',ia,',',ib,'xy)'
                Call RecPrt(Label,' ',Tabpp(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tabpp(',ia,',',ib,'xz)'
                Call RecPrt(Label,' ',Tabpp(1,ia,ib,3),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tabpp(',ia,',',ib,'yy)'
                Call RecPrt(Label,' ',Tabpp(1,ia,ib,4),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tabpp(',ia,',',ib,'yz)'
                Call RecPrt(Label,' ',Tabpp(1,ia,ib,5),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tabpp(',ia,',',ib,'zz)'
                Call RecPrt(Label,' ',Tabpp(1,ia,ib,6),nZeta,1)
             End Do
          End Do
          Do ia = 1, nElem(la)
             Do ib = 1, nElem(lb+1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tabp(',ia,',',ib,'x)'
                Call RecPrt(Label,' ',Tabp(1,ia,ib,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tabp(',ia,',',ib,'y)'
                Call RecPrt(Label,' ',Tabp(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tabp(',ia,',',ib,'z)'
                Call RecPrt(Label,' ',Tabp(1,ia,ib,3),nZeta,1)
             End Do
          End Do
          Do ia = 1, nElem(la)
             Do ib = 1, nElem(lb)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tab0',ia,',',ib,'xx)'
                Call RecPrt(Label,' ',Tab0(1,ia,ib,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tab0',ia,',',ib,'xy)'
                Call RecPrt(Label,' ',Tab0(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tab0',ia,',',ib,'xz)'
                Call RecPrt(Label,' ',Tab0(1,ia,ib,3),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tab0',ia,',',ib,'yy)'
                Call RecPrt(Label,' ',Tab0(1,ia,ib,4),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tab0',ia,',',ib,'yz)'
                Call RecPrt(Label,' ',Tab0(1,ia,ib,5),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Tab0',ia,',',ib,'zz)'
                Call RecPrt(Label,' ',Tab0(1,ia,ib,6),nZeta,1)
             End Do
          End Do
          If (lb.gt.0) Then
             Do ia = 1, nElem(la)
                Do ib = 1, nElem(lb-1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Tabm(',ia,',',ib,'x)'
                   Call RecPrt(Label,' ',Tabm(1,ia,ib,1),nZeta,1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Tabm(',ia,',',ib,'y)'
                   Call RecPrt(Label,' ',Tabm(1,ia,ib,2),nZeta,1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Tabm(',ia,',',ib,'z)'
                   Call RecPrt(Label,' ',Tabm(1,ia,ib,3),nZeta,1)
                End Do
             End Do
          End If
          If (lb.gt.1) Then
             Do ia = 1, nElem(la)
                Do ib = 1, nElem(lb-2)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Tabmm(',ia,',',ib,'xx)'
                   Call RecPrt(Label,' ',Tabmm(1,ia,ib,1),nZeta,1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Tabmm(',ia,',',ib,'xy)'
                   Call RecPrt(Label,' ',Tabmm(1,ia,ib,2),nZeta,1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Tabmm(',ia,',',ib,'xz)'
                   Call RecPrt(Label,' ',Tabmm(1,ia,ib,3),nZeta,1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Tabmm(',ia,',',ib,'yy)'
                   Call RecPrt(Label,' ',Tabmm(1,ia,ib,4),nZeta,1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Tabmm(',ia,',',ib,'yz)'
                   Call RecPrt(Label,' ',Tabmm(1,ia,ib,5),nZeta,1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Tabmm(',ia,',',ib,'zz)'
                   Call RecPrt(Label,' ',Tabmm(1,ia,ib,6),nZeta,1)
                End Do
             End Do
          End If
      End If
*
      Do 100 ixa = la, 0, -1
         Do 101 iya = la-ixa, 0, -1
            iza = la-ixa-iya
            ipa = Ind(iya,iza)
*
      Do 200 ixb = lb, 0, -1
         Do 201 iyb = lb-ixb, 0, -1
            izb = lb-ixb-iyb
            ipb = Ind(iyb,izb)
            ix=ixb
            iy=iyb
            iz=izb
*
            Do 300 iZeta = 1, nZeta
               B=Beta(iZeta)
               B2=B**2
               Bx2=Dble(2*ix)*B
               By2=Dble(2*iy)*B
               Bz2=Dble(2*iz)*B
C First compute Lx**2, Ly**2, and Lz**2:
C------------------
               Term1=    2d0*Bz2*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kyy)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy  ,iz+2),kyy)
     &                     +2d0*B*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kyy)
               Term2=   -2d0*By2*Tab0 (iZeta,ipa,Ind(iy-1,iz+1),kyz)
     &                  -2d0*Bz2*Tab0 (iZeta,ipa,Ind(iy+1,iz-1),kyz)
     &                    +8d0*B2*Tabpp(iZeta,ipa,Ind(iy+1,iz+1),kyz)
               Term3=    2d0*By2*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kzz)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy+2,iz  ),kzz)
     &                     +2d0*B*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kzz)
               Term4=      -2d0*B*Tabp (iZeta,ipa,Ind(iy+1,iz  ),ky )
     &                     -2d0*B*Tabp (iZeta,ipa,Ind(iy  ,iz+1),kz )
               if(lb.ge.1) then
               Term4=Term4 +Dble(iy)*Tabm (iZeta,ipa,Ind(iy-1,iz  ),ky )
     &                     +Dble(iz)*Tabm (iZeta,ipa,Ind(iy  ,iz-1),kz )
               if(lb.ge.2) then
               Term1=Term1
     &              -Dble(iz*(iz-1))*Tabmm(iZeta,ipa,Ind(iy  ,iz-2),kyy)
               Term2=Term2
     &              +Dble(2*iy*iz)*Tabmm(iZeta,ipa,Ind(iy-1,iz-1),kyz)
               Term3=Term3
     &              -Dble(iy*(iy-1))*Tabmm(iZeta,ipa,Ind(iy-2,iz  ),kzz)
               end if
               end if
               Rslt(iZeta,ipa,ipb,kxx) = Term1+Term2+Term3+Term4
C------------------
               Term1=    2d0*Bx2*Tab0 (iZeta,ipa,Ind(iy,iz  ),kzz)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy,iz  ),kzz)
     &                     +2d0*B*Tab0 (iZeta,ipa,Ind(iy,iz  ),kzz)
               Term2=   -2d0*Bz2*Tab0 (iZeta,ipa,Ind(iy,iz-1),kzx)
     &                  -2d0*Bx2*Tab0 (iZeta,ipa,Ind(iy,iz+1),kzx)
     &                    +8d0*B2*Tabpp(iZeta,ipa,Ind(iy,iz+1),kzx)
               Term3=    2d0*Bz2*Tab0 (iZeta,ipa,Ind(iy,iz  ),kxx)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy,iz+2),kxx)
     &                     +2d0*B*Tab0 (iZeta,ipa,Ind(iy,iz  ),kxx)
               Term4=      -2d0*B*Tabp (iZeta,ipa,Ind(iy,iz+1),kz )
     &                     -2d0*B*Tabp (iZeta,ipa,Ind(iy,iz  ),kx )
               if(lb.ge.1) then
               Term4=Term4  +Dble(iz)*Tabm (iZeta,ipa,Ind(iy,iz-1),kz )
     &                      +Dble(ix)*Tabm (iZeta,ipa,Ind(iy,iz  ),kx )
               if(lb.ge.2) then
               Term1=
     &           Term1-Dble(ix*(ix-1))*Tabmm(iZeta,ipa,Ind(iy,iz  ),kzz)
               Term2=
     &           Term2+  Dble(2*iz*ix)*Tabmm(iZeta,ipa,Ind(iy,iz-1),kzx)
               Term3=
     &           Term3-Dble(iz*(iz-1))*Tabmm(iZeta,ipa,Ind(iy,iz-2),kxx)
               end if
               end if
               Rslt(iZeta,ipa,ipb,kyy) = Term1+Term2+Term3+Term4
C------------------
               Term1=    2d0*By2*Tab0 (iZeta,ipa,Ind(iy  ,iz),kxx)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy+2,iz),kxx)
     &                     +2d0*B*Tab0 (iZeta,ipa,Ind(iy  ,iz),kxx)
               Term2=   -2d0*Bx2*Tab0 (iZeta,ipa,Ind(iy+1,iz),kxy)
     &                  -2d0*By2*Tab0 (iZeta,ipa,Ind(iy-1,iz),kxy)
     &                    +8d0*B2*Tabpp(iZeta,ipa,Ind(iy+1,iz),kxy)
               Term3=    2d0*Bx2*Tab0 (iZeta,ipa,Ind(iy  ,iz),kyy)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy  ,iz),kyy)
     &                     +2d0*B*Tab0 (iZeta,ipa,Ind(iy  ,iz),kyy)
               Term4=      -2d0*B*Tabp (iZeta,ipa,Ind(iy  ,iz),kx )
     &                     -2d0*B*Tabp (iZeta,ipa,Ind(iy+1,iz),ky )
               if(lb.ge.1) then
               Term4=Term4+  Dble(ix)*Tabm (iZeta,ipa,Ind(iy  ,iz),kx )
     &                      +Dble(iy)*Tabm (iZeta,ipa,Ind(iy-1,iz),ky )
               if(lb.ge.2) then
               Term1=
     &           Term1-Dble(iy*(iy-1))*Tabmm(iZeta,ipa,Ind(iy-2,iz),kxx)
               Term2=
     &           Term2+  Dble(2*ix*iy)*Tabmm(iZeta,ipa,Ind(iy-1,iz),kxy)
               Term3=
     &           Term3-Dble(ix*(ix-1))*Tabmm(iZeta,ipa,Ind(iy  ,iz),kyy)
               end if
               end if
               Rslt(iZeta,ipa,ipb,kzz) = Term1+Term2+Term3+Term4
C------------------
C Compute (Lx*Ly+Ly*Lx)/2, etc cyclical.
C With Term5, (Lx*Ly) obtains. With Term6, (Ly*Lx).
C We want the hermitian average.
C------------------ (Lx,Ly)
               Term1=       Bx2*Tab0 (iZeta,ipa,Ind(iy  ,iz+1),kyz)
     &                     +Bz2*Tab0 (iZeta,ipa,Ind(iy  ,iz-1),kyz)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy  ,iz+1),kyz)
               Term2=    -2d0*Bz2*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kxy)
     &                    +4d0*B2*Tabpp(iZeta,ipa,Ind(iy  ,iz+2),kxy)
     &                     -2d0*B*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kxy)
               Term3=      -Bx2*Tab0 (iZeta,ipa,Ind(iy+1,iz  ),kzz)
     &                     -By2*Tab0 (iZeta,ipa,Ind(iy-1,iz  ),kzz)
     &                    +4d0*B2*Tabpp(iZeta,ipa,Ind(iy+1,iz  ),kzz)
               Term4=       By2*Tab0 (iZeta,ipa,Ind(iy-1,iz+1),kxz)
     &                     +Bz2*Tab0 (iZeta,ipa,Ind(iy+1,iz-1),kxz)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy+1,iz+1),kxz)
               Term5=      +2d0*B*Tabp (iZeta,ipa,Ind(iy  ,iz  ),ky )
               Term6=      +2d0*B*Tabp (iZeta,ipa,Ind(iy+1,iz  ),kx )
               if(lb.ge.1) then
               Term5=Term5-Dble(ix)*Tabm (iZeta,ipa,Ind(iy  ,iz  ),ky )
               Term6=Term6-Dble(iy)*Tabm (iZeta,ipa,Ind(iy-1,iz  ),kx )
               if(lb.ge.2) then
               Term1=Term1
     &              -Dble(ix*iz)*Tabmm(iZeta,ipa,Ind(iy  ,iz-1),kyz)
               Term2=Term2
     &              +Dble(iz*(iz-1))*Tabmm(iZeta,ipa,Ind(iy  ,iz-2),kxy)
               Term3=Term3
     &              +Dble(ix*iy)*Tabmm(iZeta,ipa,Ind(iy-1,iz  ),kzz)
               Term4=Term4
     &              -Dble(iy*iz)*Tabmm(iZeta,ipa,Ind(iy-1,iz-1),kxz)
               end if
               end if
               Rslt(iZeta,ipa,ipb,kxy) = Term1+Term2+Term3+Term4
     &                     +0.5D0*(Term5+Term6)
C------------------ (Ly,Lz)
               Term1=       By2*Tab0 (iZeta,ipa,Ind(iy-1,iz  ),kzx)
     &                     +Bx2*Tab0 (iZeta,ipa,Ind(iy+1,iz  ),kzx)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy+1,iz  ),kzx)
               Term2=    -2d0*Bx2*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kyz)
     &                    +4d0*B2*Tabpp(iZeta,ipa,Ind(iy  ,iz  ),kyz)
     &                     -2d0*B*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kyz)
               Term3=      -By2*Tab0 (iZeta,ipa,Ind(iy-1,iz+1),kxx)
     &                     -Bz2*Tab0 (iZeta,ipa,Ind(iy+1,iz-1),kxx)
     &                    +4d0*B2*Tabpp(iZeta,ipa,Ind(iy+1,iz+1),kxx)
               Term4=       Bz2*Tab0 (iZeta,ipa,Ind(iy  ,iz-1),kyx)
     &                     +Bx2*Tab0 (iZeta,ipa,Ind(iy  ,iz+1),kyx)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy  ,iz+1),kyx)
               Term5=      +2d0*B*Tabp (iZeta,ipa,Ind(iy+1,iz  ),kz )
               Term6=      +2d0*B*Tabp (iZeta,ipa,Ind(iy  ,iz+1),ky )
               if(lb.ge.1) then
               Term5=Term5-Dble(iy)*Tabm (iZeta,ipa,Ind(iy-1,iz  ),kz )
               Term6=Term6-Dble(iz)*Tabm (iZeta,ipa,Ind(iy  ,iz-1),ky )
               if(lb.ge.2) then
               Term1=
     &          Term1 -Dble(iy*ix)*Tabmm(iZeta,ipa,Ind(iy-1,iz  ),kzx)
               Term2=Term2
     &              +Dble(ix*(ix-1))*Tabmm(iZeta,ipa,Ind(iy  ,iz  ),kyz)
               Term3=
     &          Term3 +Dble(iy*iz)*Tabmm(iZeta,ipa,Ind(iy-1,iz-1),kxx)
               Term4=
     &          Term4 -Dble(iz*ix)*Tabmm(iZeta,ipa,Ind(iy  ,iz-1),kyx)
               end if
               end if
               Rslt(iZeta,ipa,ipb,kyz) = Term1+Term2+Term3+Term4
     &                     +0.5D0*(Term5+Term6)
C------------------ (Lx,Lz)
               Term1=       Bz2*Tab0 (iZeta,ipa,Ind(iy+1,iz-1),kxy)
     &                     +By2*Tab0 (iZeta,ipa,Ind(iy-1,iz+1),kxy)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy+1,iz+1),kxy)
               Term2=    -2d0*By2*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kzx)
     &                    +4d0*B2*Tabpp(iZeta,ipa,Ind(iy+2,iz  ),kzx)
     &                     -2d0*B*Tab0 (iZeta,ipa,Ind(iy  ,iz  ),kzx)
               Term3=      -Bz2*Tab0 (iZeta,ipa,Ind(iy  ,iz-1),kyy)
     &                     -Bx2*Tab0 (iZeta,ipa,Ind(iy  ,iz+1),kyy)
     &                    +4d0*B2*Tabpp(iZeta,ipa,Ind(iy  ,iz+1),kyy)
               Term4=       Bx2*Tab0 (iZeta,ipa,Ind(iy+1,iz  ),kzy)
     &                     +By2*Tab0 (iZeta,ipa,Ind(iy-1,iz  ),kzy)
     &                    -4d0*B2*Tabpp(iZeta,ipa,Ind(iy+1,iz  ),kzy)
               Term5=      +2d0*B*Tabp (iZeta,ipa,Ind(iy  ,iz+1),kx )
               Term6=      +2d0*B*Tabp (iZeta,ipa,Ind(iy  ,iz  ),kz )
               if(lb.ge.1) then
               Term5=Term5 -Dble(iz)*Tabm (iZeta,ipa,Ind(iy  ,iz-1),kx )
               Term6=Term6 -Dble(ix)*Tabm (iZeta,ipa,Ind(iy  ,iz  ),kz )
               if(lb.ge.2) then
               Term1=Term1
     &              -Dble(iz*iy)*Tabmm(iZeta,ipa,Ind(iy-1,iz-1),kxy)
               Term2=Term2
     &              +Dble(iy*(iy-1))*Tabmm(iZeta,ipa,Ind(iy-2,iz  ),kzx)
               Term3=Term3
     &              +Dble(iz*ix)*Tabmm(iZeta,ipa,Ind(iy  ,iz-1),kyy)
               Term4=Term4
     &              -Dble(ix*iy)*Tabmm(iZeta,ipa,Ind(iy-1,iz  ),kzy)
               end if
               end if
               Rslt(iZeta,ipa,ipb,kxz) = Term1+Term2+Term3+Term4
     &                     +0.5D0*(Term5+Term6)

 300       Continue
*
 201     Continue
 200  Continue
*
 101     Continue
 100  Continue
*
      If (iPrint.ge.49) Then
          Write (6,*) ' In AMPr la,lb=',la,lb
          Do iElem = 1, nElem(la)
             Do jElem = 1, nElem(lb)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Rslt (',iElem,',',jElem,',xx) '
                Call RecPrt(Label,' ',Rslt(1,iElem,jElem,kxx),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Rslt (',iElem,',',jElem,',xy) '
                Call RecPrt(Label,' ',Rslt(1,iElem,jElem,kxy),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Rslt (',iElem,',',jElem,',xz) '
                Call RecPrt(Label,' ',Rslt(1,iElem,jElem,kxz),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Rslt (',iElem,',',jElem,',yy) '
                Call RecPrt(Label,' ',Rslt(1,iElem,jElem,kyy),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Rslt (',iElem,',',jElem,',yz) '
                Call RecPrt(Label,' ',Rslt(1,iElem,jElem,kyz),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Rslt (',iElem,',',jElem,',zz) '
                Call RecPrt(Label,' ',Rslt(1,iElem,jElem,kzz),nZeta,1)
             End Do
          End Do
          Write (6,*) ' Leaving AMPr.'
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine RotGDMat(R,GD)

use Index_Functions, only: iTri, nTri_Elem
use rasscf_global, only: lRoots, NAC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: R(lRoots,lRoots)
real(kind=wp), intent(inout) :: GD(nTri_Elem(lRoots),NAC,NAC)
integer(kind=iwp) :: I, iIJ, iKL, ip, iq, J, K, L, p, q
real(kind=wp), allocatable :: GD2(:,:,:)

call mma_allocate(GD2,nTri_Elem(lRoots),NAC,NAC,Label='GD2')

do p=1,nac
  do q=1,nac
    do I=1,lRoots
      do J=1,I
        iIJ = iTri(I,J)
        GD2(iIJ,p,q) = Zero
        do K=1,lRoots
          do L=1,lRoots
            if (K > L) then
              ip = p
              iq = q
            else
              ip = q
              iq = p
            end if
            iKL = iTri(K,L)
            GD2(iIJ,p,q) = GD2(iIJ,p,q)+GD(iKL,ip,iq)*R(I,K)*R(J,L)
          end do
        end do
      end do
    end do
  end do
end do

do I=1,lRoots
  do J=1,I
    iIJ = iTri(I,J)
    GD(iIJ,:,:) = GD2(iIJ,:,:)
  end do
end do

call mma_deallocate(GD2)

end subroutine RotGDMat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CRYSTALFIELD_1(nDIMcf,nlanth,MM,ESOJ,GRAD,iprint)
! This soubrutine calculates the crystal field parameters on the basis
! of the given fron RASSI - J multiplet.
! In a second step, the first largest 27 parameters will be used to
! recalculate the S-O energies, eigenfunctions, g- and D- tensors.

!  Employed parameters:

!  IPRINT = the print level of the calculation

!  IReturn = the error value.
!        0 = no error, happy landing

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDIMcf, nlanth, iprint
complex(kind=wp), intent(in) :: MM(3,nDIMcf,nDIMcf)
real(kind=wp), intent(in) :: ESOJ(nDIMcf)
logical(kind=iwp), intent(in) :: GRAD
integer(kind=iwp) :: i, info, j, k, LuCF, q
real(kind=wp), allocatable :: BNC(:,:), BNS(:,:), Bstev(:,:), Eloc(:), Winit(:)
complex(kind=wp), allocatable :: Akq(:,:), HCF(:,:), Z(:,:), Zinit(:,:)
integer(kind=iwp), external :: IsFreeUnit

call mma_allocate(Winit,nDIMcf,'Winit')
call mma_allocate(Eloc,nDIMcf,'Eloc')
call mma_allocate(Zinit,nDIMcf,nDIMcf,'Zinit')
call mma_allocate(Z,nDIMcf,nDIMcf,'Z')
call mma_allocate(HCF,nDIMcf,nDIMcf,'HCF')
call mma_allocate(BNC,[1,nDIMcf],[0,nDIMcf],label='BNC')
call mma_allocate(BNS,[1,nDIMcf],[0,nDIMcf],label='BNS')
call mma_allocate(Bstev,[1,nDIMcf],[-nDIMcf,nDIMcf],label='Bstev')
call mma_allocate(Akq,[1,nDIMcf-1],[-(nDIMcf-1),nDIMcf-1],label='Akq')

! find the J-pseudospin:
!iDir = 3
call pseudospin(MM,nDIMcf,Z,3,1,iprint)
call rtrace(nDIMcf,ESOJ,ELOC)
! re-write the CF matrix in J-pseudospin basis:
! energy units = cm-1
HCF(:,:) = cZero
do j=1,nDIMcf
  do k=1,nDIMcf
    HCF(:,j) = HCF(:,j)+ELOC(k)*conjg(Z(k,:))*Z(k,j)
  end do
end do
! diagonalize the initial CF matrix:
call DIAG_C2(HCF,nDIMcf,INFO,Winit,Zinit)
call print_ZFS('Ab Initio Calculated Crystal-Field Splitting Matrix written in the basis of Pseudospin Eigenfunctions',HCF,nDIMCF)

if (IPRINT > 2) then
  write(u6,*)
  write(u6,'(5X,A)') 'MAIN VALUES OF THE INITIAL CRYSTAL-FIELD HAMILTONIAN:'
  write(u6,*)
  if (mod(nDIMcf,2) == 1) then
    do I=1,nDIMcf
      write(u6,'(3X,A,I3,A,F25.16)') '|',(nDIMcf-1)/2+(1-I),'> = ',Winit(I)-Winit(1)
    end do
  else
    do I=1,nDIMcf
      write(u6,'(3X,A,I3,A,F25.16)') '|',(nDIMcf-1)-2*(I-1),'/2 > = ',Winit(i)-Winit(1)
    end do
  end if
  write(u6,*)

  write(u6,'(5X,A)') 'EIGENVECTORS OF THE INITIAL CRYSTAL-FIELD HAMILTONIAN:'
  write(u6,*)
  call print_ZFS_naoya('J',Zinit,nDIMcf)
  ! End the checking of the main values of the initial crystal-field
end if

! calculating the coeficients of the crystal filed operators Bnm
!  Akq=(2k+1)/(2J+1) * 1/|< J || O || J >|^2 * Trace{HCF*O(k,-q)}
call NEWCF(HCF,nDIMcf,Akq,BNC,BNS,Bstev)
!#ifdef _DEBUGPRINT_
!call recover_CF(nDIMCF,HCF,Akq,BNC,BNS,Bstev)
!#endif

call print_CFP_alpha(nlanth,nDIMCF,BNC,BNS)
if (iprint >= 4) then
  call print_CFP_LCLU(nDIMCF,BNC,BNS,.true.)
  call print_CFP_stev(nDIMCF,Bstev,.true.)
  call print_CFP_naoya(nDIMcf,Akq,.true.)
else
  call print_CFP_LCLU(nDIMCF,BNC,BNS,.false.)
  call print_CFP_stev(nDIMCF,Bstev,.false.)
  call print_CFP_naoya(nDIMcf,Akq,.false.)
end if

!-----------------------------------------------------------------------
write(u6,'(/)')
if (mod(nDIMcf,2) == 1) then
  write(u6,'(A,I0)') 'DECOMPOSITION OF THE RASSI WAVE FUNCTIONS CORRESPONDING TO THE LOWEST ATOMIC MULTIPLET J =',(nDIMcf-1)/2
  write(u6,'(A,I0)') 'IN WAVE FUNCTIONS WITH DEFINITE PROJECTION OF THE TOTAL MOMENT ON THE QUANTIZATION AXIS'
else ! mod(nDIMcf,2) == 0
  write(u6,'(A,I0,A)') 'DECOMPOSITION OF THE RASSI WAVE FUNCTIONS CORRESPONDING TO THE LOWEST ATOMIC MULTIPLET J = ',(nDIMcf-1),'/2'
  write(u6,'(A,I0)') 'IN WAVE FUNCTIONS WITH DEFINITE PROJECTION OF THE TOTAL MOMENT ON THE QUANTIZATION AXIS'
end if

call print_ZFS_naoya('J',Zinit,nDIMcf)
call individual_ranks(nDIMCF,BNC,BNS,HCF,'J',iprint)
!-----------------------------------------------------------------------
! saving some information for tests:
call Add_Info('CRYS_BNMC_20',BNC(2,0),1,4)
call Add_Info('CRYS_BNMC_40',BNC(4,0),1,4)
call Add_Info('CRYS_BNMC_60',BNC(6,0),1,4)
!-----------------------------------------------------------------------
! for the interface related to CF gradient calculation:
if (GRAD) then
  LuCF = IsFreeUnit(81)
  call molcas_open(LuCF,'CFMAT')
  do k=2,nDIMcf-1,2
    do q=0,k
      write(LuCF,'(I3,I3,1x,2ES25.15)') k,q,BNC(k,q),BNS(k,q)
    end do
  end do
  close(LuCF)
end if
!-----------------------------------------------------------------------
call mma_deallocate(Winit)
call mma_deallocate(Eloc)
call mma_deallocate(Zinit)
call mma_deallocate(Z)
call mma_deallocate(HCF)
call mma_deallocate(BNC)
call mma_deallocate(BNS)
call mma_deallocate(Bstev)
call mma_deallocate(Akq)

return

end subroutine CRYSTALFIELD_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  obeysCauchySchwarz
*
*> @brief
*>   Return ``.True.`` if \p M obeys the Cauchy--Schwarz inequality within tolerance \p Tol
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Test if matrix \p M obeys the Cauchy--Schwarz inequality.
*> If \f$ \exists i \gt j \; |M_{ij}^2 - M_{ii}M_{jj}| \gt \text{Tol} \f$
*> return ``.False.``.
*>
*> @param[in] M   \p n &times; \p n square matrix to test
*> @param[in] n   Dimension of \p M
*> @param[in] Tol Tolerance
*>
*> @return ``.True.`` if \p M obeys the Cauchy--Schwarz inequality within tolerance \p Tol
************************************************************************
      Logical Function obeysCauchySchwarz(M,n,Tol)
      Implicit None
      Integer n
      Real*8  M(n,n)
      Real*8  Tol

      Integer i, j

      obeysCauchySchwarz=.True.
      Do j=1,n
         Do i=j+1,n
            If (M(i,j)**2 .gt. M(i,i)*M(j,j) .and.
     &          abs(M(i,j)**2-M(i,i)*M(j,j)).gt.Tol) Then
               obeysCauchySchwarz=.False.
               Return
            End If
         End Do
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_PrintAuxBasVector(VectorName,ip_V)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Print aux bas vector.
C
      Implicit None
      Character*(*) VectorName
      Integer ip_V
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nAtom, LDF_nBasAux_Atom
      External LDF_nAtom, LDF_nBasAux_Atom

      real*8 ddot_
      external ddot_

      Integer l_max
      Parameter (l_max=80)
      Character*(l_max) myName

      Integer l
      Integer nAtom
      Integer iAtomPair
      Integer iAtom
      Integer M
      Integer ip

      Real*8 tnorm, bnorm

      Integer i, j
      Integer AP_2CFunctions
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      l=min(len(VectorName),l_max)
      If (l.gt.0) Then
         Write(myName,'(A)') VectorName(1:l)
      Else
         Write(myName,'(A)') '<unknown> '
      End If

      nAtom=LDF_nAtom()
      tnorm=0.0d0
      Do iAtom=1,nAtom
         M=LDF_nBasAux_Atom(iAtom)
         ip=iWork(ip_V-1+iAtom)
         bnorm=dDot_(M,Work(ip),1,Work(ip),1)
         tnorm=tnorm+bnorm
         Write(6,'(/,A,A,I9)')
     &   myName(1:l),' aux bas block for atom ',iAtom
         Write(6,'(A,I9,A,1P,D15.6)')
     &   'Dimension:',M,'    Norm:',sqrt(bnorm)
         Call Cho_Output(Work(ip),1,1,1,M,1,M,1,6)
      End Do
      Do iAtomPair=1,NumberOfAtomPairs
         M=AP_2CFunctions(1,iAtomPair)
         If (M.gt.0) Then
            ip=iWork(ip_V-1+nAtom+iAtomPair)
            bnorm=dDot_(M,Work(ip),1,Work(ip),1)
            tnorm=tnorm+bnorm
            Write(6,'(/,A,A,I9)')
     &      myName(1:l),' aux bas block for atom pair',iAtomPair
            Write(6,'(A,I9,A,1P,D15.6)')
     &      'Dimension:',M,'    Norm:',sqrt(bnorm)
            Call Cho_Output(Work(ip),1,1,1,M,1,M,1,6)
         End If
      End Do
      Write(6,'(/,A,A,1P,D15.6)')
     & myName(1:l),' total norm:',sqrt(tnorm)
      Call xFlush(6)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Setup_O()
      use nq_Grid, only: Pax
      use stdalloc, only: mma_allocate
      Call mma_allocate(Pax,3,3,Label='Pax')
      Pax(:,:)=0.0D0
      Call DCOPY_(3,[1.0D0],0,Pax,4)
      Return
      End
*
      Subroutine Free_O()
      use nq_Grid, only: Pax
      use stdalloc, only: mma_deallocate
      Call mma_deallocate(Pax)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Compute3IndexIntegrals_1(AB,C,tau,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: compute 3-index integrals of the form (u_A v_B|K_C)
C              where |u_A v_B) are AO products on atom pair AB and K_C
C              are one-center auxiliary functions on atom C. Note that
C              *all* auxiliary functions on C are included (including
C              linearly dependent ones).
C
C     tau is the prescreening threshold. Note that the integral
C     prescreening arrays must have been set up before calling this
C     routine.
C
      Implicit None
      Integer AB
      Integer C
      Real*8  tau
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_mem.fh"
#include "localdf_bas.fh"
#include "localdf_int3.fh"
#include "ldf_integral_prescreening_info.fh"

      Character*28 SecNam
      Parameter (SecNam='LDF_Compute3IndexIntegrals_1')

      External Int_LDF_3Indx_1

      Integer  LDF_nBas_Atom, LDF_nBasAux_Atom
      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nBas_Atom, LDF_nBasAux_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
#if defined (_DEBUGPRINT_)
      Integer  LDF_nAtom
      External LDF_nAtom
#endif

      Real*8 tau2

      Integer ip_iOffRow, l_iOffRow
      Integer ip_iOffCol, l_iOffCol
      Integer A, B
      Integer nu, nv
      Integer M
      Integer l_xInt
      Integer nShellA, nShellB, nAuxShellC
      Integer ipA, ipB, ipC
      Integer n, ip0
      Integer iS, jS, kS, lS
      Integer iShell, jShell, kShell, lShell
      Integer K, ijK, jiK
      Integer ip_SewWrk, l_SewWrk

      Integer i, j
      Integer nBasSh
      Integer iOffCol
      Integer iOffRow
      Integer AP_Atoms
      Real*8  Imax
      Real*8  Gmax
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iOffCol(i)=iWork(ip_iOffCol-1+i)
      iOffRow(i,j)=iWork(ip_iOffRow-1+nShellA*(j-1)+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      Imax(i,j)=Work(iWork(ip_IDiag+2*(AB-1)+1)-1+nShellA*(j-1)+i)
      Gmax(i)=Work(iWork(ip_GDiag_1C+2*(C-1)+1)-1+i)

#if defined (_USE_APD_INTEGRALS_)
      If (.True.) Then
         Call WarningMessage(0,SecNam//': Using APD integrals!')
         Call LDF_APD3IndexIntegrals_1(AB,C,l_xInt_,xInt)
         Return
      End If
#endif

#if defined (_DEBUGPRINT_)
      If (AB.lt.1 .or. AB.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,SecNam//': AB out of bounds!')
         Call LDF_Quit(1)
      End If
      M=LDF_nShell_Atom(AP_Atoms(1,AB))*LDF_nShell_Atom(AP_Atoms(2,AB))
      If (iWork(ip_IDiag+2*(AB-1)).ne.M) Then
         Call WarningMessage(2,SecNam//': IDiag not properly set!')
         Call LDF_Quit(1)
      End If
      If (C.lt.1 .or. C.gt.LDF_nAtom()) Then
         Call WarningMessage(2,SecNam//': C out of bounds!')
         Call LDF_Quit(1)
      End If
      M=LDF_nAuxShell_Atom(C)
      If (iWork(ip_GDiag_1C+2*(C-1)).ne.M) Then
         Call WarningMessage(2,SecNam//': GDiag_1C not properly set!')
         Call LDF_Quit(1)
      End If
#endif

      ! Square screening threshold
      tau2=tau**2

      ! Get atoms of atom pair AB
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)

      ! Get number of basis functions on atoms A and B
      nu=LDF_nBas_Atom(A)
      nv=LDF_nBas_Atom(B)

      ! Get number of auxiliary functions on C
      M=LDF_nBasAux_Atom(C)

      ! Check integral array dimension
      nRow=nu*nv
      l_xInt=nRow*M
      If (l_xInt.gt.l_xInt_) Then
         Call WarningMessage(2,
     &                SecNam//': insufficient integral array dimension')
         Call LDF_Quit(1)
      End If

      ! Get number of shells on each atom A,B
      nShellA=LDF_nShell_Atom(A)
      nShellB=LDF_nShell_Atom(B)

      ! Get pointers to lists of shells on A,B
      ipA=LDF_lShell_Atom(A)-1
      ipB=LDF_lShell_Atom(B)-1

      ! Allocate row offset array
      l_iOffRow=nShellA*nShellB
      Call GetMem('3IiOffR','Allo','Inte',ip_iOffRow,l_iOffRow)

      ! Set row offset array
      n=0
      Do jS=1,nShellB
         jShell=iWork(ipB+jS)
         ip0=ip_iOffRow-1+nShellA*(jS-1)
         Do iS=1,nShellA
            iWork(ip0+iS)=n
            iShell=iWork(ipA+iS)
            n=n+nBasSh(iShell)*nBasSh(jShell)
         End Do
      End Do
#if defined (_DEBUGPRINT_)
      If (n.ne.nRow) Then
         Call WarningMessage(2,SecNam//': row dimension problem!')
         Call LDF_Quit(1)
      End If
#endif

      ! Get number of auxiliary shells on C
      nAuxShellC=LDF_nAuxShell_Atom(C)

      ! Get pointer to auxiliary shells on C
      ipC=LDF_lAuxShell_Atom(C)-1

      ! Allocate columns offset array
      l_iOffCol=nAuxShellC
      Call GetMem('3IiOffC','Allo','Inte',ip_iOffCol,l_iOffCol)

      ! Set column offset array
      n=0
      ip0=ip_iOffCol-1
      Do kS=1,nAuxShellC
         iWork(ip0+kS)=n
         kShell=iWork(ipC+kS)
         n=n+nBasSh(kShell)
      End Do
#if defined (_DEBUGPRINT_)
      If (n.ne.M) Then
         Call WarningMessage(2,SecNam//': column dimension problem!')
         Call LDF_Quit(1)
      End If
#endif

      ! Allocate memory for Seward
      Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
      l_SewWrk = min(l_SewWrk,MaxLDFSew)
      Call xSetMem_Ints(l_SewWrk)

      ! Compute integrals
      Call FZero(xInt,l_xInt)
      kShell=nShell_Valence+nShell_Auxiliary+1
      SHC=kShell
      If (A.eq.B) Then
         ! compute (u_A v_B|K_C) for u_A >= v_B (shell blocks)
         Do lS=1,nAuxShellC
            lShell=iWork(ipC+lS)
            SHD=lShell
            iCol0=iOffCol(lS)
            Do jS=1,nShellB
               jShell=iWork(ipB+jS)
               SHB=jShell
               Do iS=jS,nShellA
                  If (Imax(iS,jS)*Gmax(lS).ge.tau2) Then
                     iShell=iWork(ipA+iS)
                     SHA=iShell
                     iRow0=iOffRow(iS,jS)
                     Call Eval_IJKL(iShell,jShell,kShell,lShell,
     &                              xInt,l_xInt,Int_LDF_3Indx_1)
                  End If
               End Do
            End Do
         End Do
         ! Now copy to get lower triangle u_A < v_B (shell blocks)
         Do K=0,M-1
            ip0=nRow*K
            Do jS=2,nShellB
               jShell=iWork(ipB+jS)
               Do iS=1,jS-1
                  iShell=iWork(ipA+iS)
                  Do j=1,nBasSh(jShell)
                     Do i=1,nBasSh(iShell)
                        ijK=ip0+iOffRow(iS,jS)+nBasSh(iShell)*(j-1)+i
                        jiK=ip0+iOffRow(jS,iS)+nBasSh(jShell)*(i-1)+j
                        xInt(ijK)=xInt(jiK)
                     End Do
                  End Do
               End Do
            End Do
         End Do
      Else If (A.gt.B) Then
         ! compute (u_A v_B|K_C)
         Do lS=1,nAuxShellC
            lShell=iWork(ipC+lS)
            SHD=lShell
            iCol0=iOffCol(lS)
            Do jS=1,nShellB
               jShell=iWork(ipB+jS)
               SHB=jShell
               Do iS=1,nShellA
                  If (Imax(iS,jS)*Gmax(lS).ge.tau2) Then
                     iShell=iWork(ipA+iS)
                     SHA=iShell
                     iRow0=iOffRow(iS,jS)
                     Call Eval_IJKL(iShell,jShell,kShell,lShell,
     &                              xInt,l_xInt,Int_LDF_3Indx_1)
                  End If
               End Do
            End Do
         End Do
      Else
         Call WarningMessage(2,SecNam//': A<B')
         Call LDF_Quit(1)
      End If

      ! Deallocate
      Call xRlsMem_Ints()
      Call GetMem('3IiOffC','Free','Inte',ip_iOffCol,l_iOffCol)
      Call GetMem('3IiOffR','Free','Inte',ip_iOffRow,l_iOffRow)

      nRow=0
      iRow0=0
      iCol0=0
      SHA=0
      SHB=0
      SHC=0
      SHD=0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Compute3IndexIntegrals_2(AB,CD,tau,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: compute 3-index integrals of the form (u_A v_B|K_CD)
C              where |u_A v_B) are AO products on atom pair AB and K_CD
C              are two-center auxiliary functions on atom pair CD.
C
C     tau is the prescreening threshold. Note that the integral
C     prescreening arrays must have been set up before calling this
C     routine.
C
      Implicit None
      Integer AB
      Integer CD
      Real*8  tau
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_int.fh"
#include "localdf_mem.fh"
#include "localdf_bas.fh"
#include "ldf_integral_prescreening_info.fh"

      Character*28 SecNam
      Parameter (SecNam='LDF_Compute3IndexIntegrals_2')

      Integer  LDF_nBasAux_Pair
      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom

      Real*8 tau2

      Integer M
      Integer A, B
      Integer l_xInt
      Integer nShellA, nShellB
      Integer n
      Integer ipA, ipB
      Integer iS, jS, klS
      Integer iShell, jShell, kShell, lShell
      Integer ip0, ij0, ji0, ij, ji
      Integer K
      Integer ip_SewWrk, l_SewWrk

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_2CFunctions
      Integer i2CList
      Real*8  Gmax
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      i2CList(i,j)=iWork(ip_2CList-1+l_2CList_1*(j-1)+i)
      Gmax(i)=Work(iWork(ip_GDiag_2C+2*(CD-1)+1)-1+i)

#if defined (_USE_APD_INTEGRALS_)
      If (.True.) Then
         Call WarningMessage(0,SecNam//': Using APD integrals!')
         Call LDF_APD3IndexIntegrals_2(AB,CD,l_xInt_,xInt)
         Return
      End If
#endif

#if defined (_DEBUGPRINT_)
      If (AB.lt.1 .or. AB.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,SecNam//': AB out of bounds!')
         Call LDF_Quit(1)
      End If
      If (CD.lt.1 .or. CD.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,SecNam//': CD out of bounds!')
         Call LDF_Quit(1)
      End If
      If (iWork(ip_GDiag_2C+2*(CD-1)).lt.1) Then
         Call WarningMessage(2,SecNam//': GDiag_2C not properly set!')
         Call LDF_Quit(1)
      End If
#endif

      ! Get number of two-center auxiliary functions on CD
      M=AP_2CFunctions(1,CD)

      ! Return if nothing to do
      If (M.lt.1) Return

      ! Square prescreening threshold
      tau2=tau**2

      ! Get atoms of atom pair AB
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)

      ! Get row dimension
      nRow_uvJ=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      If (nRow_uvJ.lt.1) Return

      ! Check integral array dimension
      l_xInt=nRow_uvJ*M
      If (l_xInt.gt.l_xInt_) Then
         Call WarningMessage(2,
     &                SecNam//': insufficient integral array dimension')
         Call LDF_Quit(1)
      End If

      ! Set column index array including one-center functions.
      ! Then shift indices to exclude one-center functions.
      Call LDF_SetIndxG(CD)
      Call LDF_ColMod(LDF_nBasAux_Pair(CD)-M)

      ! Get number of shells on A and B
      nShellA=LDF_nShell_Atom(A)
      nShellB=LDF_nShell_Atom(B)

      ! Allocate row offset array
      l_iOff=nShellA*nShellB
      Call GetMem('3I2iOff','Allo','Inte',ip_iOff,l_iOff)

      ! Get pointers to shell lists
      ipA=LDF_lShell_Atom(A)-1
      ipB=LDF_lShell_Atom(B)-1

      ! Set row offset array
      n=0
      Do jS=1,nShellB
         jShell=iWork(ipB+jS)
         ip0=ip_iOff-1+nShellA*(jS-1)
         Do iS=1,nShellA
            iWork(ip0+iS)=n
            iShell=iWork(ipA+iS)
            n=n+nBasSh(iShell)*nBasSh(jShell)
         End Do
      End Do
#if defined (_DEBUGPRINT_)
      If (n.ne.nRow_uvJ) Then
         Call WarningMessage(2,SecNam//': row dimension problem!')
         Call LDF_Quit(1)
      End If
#endif

      ! Allocate memory for Seward
      Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
      l_SewWrk = min(l_SewWrk,MaxLDFSew)
      Call xSetMem_Ints(l_SewWrk)

      ! Compute integrals
      Call FZero(xInt,l_xInt)
      Do klS=1,l_2CList_2
         kShell=i2CList(1,klS)
         lShell=i2CList(2,klS)
         SPAB=i2CList(3,klS)
         Call LDF_CI_uvJ_PS(AB,kShell,lShell,Gmax(klS),tau2,l_xInt,xInt)
      End Do

      ! Free Seward memory
      Call xRlsMem_Ints()

      ! Postprocessing for A=B:
      ! Only lower (block) triangle computed => transpose to get upper
      If (A.eq.B) Then
         Do K=0,M-1
            ip0=nRow_uvJ*K
            Do jS=2,nShellB
               jShell=iWork(ipB+jS)
               Do iS=1,jS-1
                  iShell=iWork(ipA+iS)
                  ij0=ip0+iWork(ip_iOff-1+nShellA*(jS-1)+iS)
                  ji0=ip0+iWork(ip_iOff-1+nShellB*(iS-1)+jS)
                  Do j=1,nBasSh(jShell)
                     Do i=1,nBasSh(iShell)
                        ij=ij0+nBasSh(iShell)*(j-1)+i
                        ji=ji0+nBasSh(jShell)*(i-1)+j
                        xInt(ij)=xInt(ji)
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End If

      ! Deallocate row offset array
      Call GetMem('3I2iOff','Free','Inte',ip_iOff,l_iOff)
      ip_iOff=0
      l_iOff=0
      nRow_uvJ=0
      iOffuv=0

      ! Unset indices
      Call LDF_UnsetIndxG()
      SHA=0
      SHB=0
      SHC=0
      SHD=0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_ColMod(M)
      Implicit None
      Integer M
#include "WrkSpc.fh"
#include "localdf_int.fh"

      Integer i, j, ip0, ij0, ij

      ip0=ip_IndxG2-1
      Do j=1,l_IndxG2_2
         ij0=ip0+l_IndxG2_1*(j-1)
         Do i=1,l_IndxG2_1
            ij=ij0+i
            iWork(ij)=max(iWork(ij)-M,0)
         End Do
      End Do

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CI_uvJ_PS(iAtomPair,iShell,jShell,Gmax,tau2,
     &                         l_xInt,xInt)
C
C     Thomas Bondo Pedersen, November 2010.
C     - modified version of LDF_CI_uvJ
C
C     Compute integrals (uv|J) where J is an auxiliary function in
C     shell pair iShell,jShell [iShell=dummy-shell if 1-center].
C
      Implicit None
      Integer iAtomPair
      Integer iShell, jShell
      Real*8  Gmax, tau2
      Integer l_xInt
      Real*8  xInt(l_xInt)
#include "WrkSpc.fh"
#include "localdf_int.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_integral_prescreening_info.fh"

      Character*13 SecNam
      Parameter (SecNam='LDF_CI_uvJ_PS')

      External Int_LDF_uvJ

      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom

      Integer kAtom, lAtom
      Integer nShell_kAtom, nShell_lAtom
      Integer kS, lS
      Integer kShell, lShell
      Integer ipk, ipl
#if defined (_DEBUGPRINT_)
      Integer M
#endif

      Integer i, j
      Integer AP_Atoms
      Real*8  Imax
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      Imax(i,j)=Work(iWork(ip_IDiag+2*(iAtomPair-1)+1)-1
     &                             +nShell_kAtom*(j-1)+i)

#if defined (_DEBUGPRINT_)
      If (iAtomPair.lt.1 .or. iAtomPair.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,SecNam//': iAtomPair out of bounds!')
         Call LDF_Quit(1)
      End If
      M=LDF_nShell_Atom(AP_Atoms(1,iAtomPair))
     & *LDF_nShell_Atom(AP_Atoms(2,iAtomPair))
      If (iWork(ip_IDiag+2*(iAtomPair-1)).ne.M) Then
         Call WarningMessage(2,SecNam//': IDiag not properly set!')
         Call LDF_Quit(1)
      End If
#endif

      kAtom=AP_Atoms(1,iAtomPair)
      lAtom=AP_Atoms(2,iAtomPair)
      nShell_kAtom=LDF_nShell_Atom(kAtom)
      nShell_lAtom=LDF_nShell_Atom(lAtom)
      ipk=LDF_lShell_Atom(kAtom)-1
      ipl=LDF_lShell_Atom(lAtom)-1

      SHA=iShell
      SHB=jShell

      If (kAtom.eq.lAtom) Then
         ! NOTE: only lower (block) triangular part is computed!!!
         Do lS=1,nShell_lAtom
            lShell=iWork(ipl+lS)
            SHD=lShell
            Do kS=lS,nShell_kAtom
               If (Imax(kS,lS)*Gmax.ge.tau2) Then
                  kShell=iWork(ipk+kS)
                  SHC=kShell
                  ! iOffuv = row offset
                  iOffuv=iWork(ip_iOff-1+nShell_kAtom*(lS-1)+kS)
                  Call Eval_IJKL(iShell,jShell,kShell,lShell,xInt,
     &                           l_xInt,Int_LDF_uvJ)
               End If
            End Do
         End Do
      Else If (kAtom.gt.lAtom) Then
         Do lS=1,nShell_lAtom
            lShell=iWork(ipl+lS)
            SHD=lShell
            Do kS=1,nShell_kAtom
               If (Imax(kS,lS)*Gmax.ge.tau2) Then
                  kShell=iWork(ipk+kS)
                  SHC=kShell
                  ! iOffuv = row offset
                  iOffuv=iWork(ip_iOff-1+nShell_kAtom*(lS-1)+kS)
                  Call Eval_IJKL(iShell,jShell,kShell,lShell,xInt,
     &                           l_xInt,Int_LDF_uvJ)
               End If
            End Do
         End Do
      Else
         Call WarningMessage(2,SecNam//': kAtom<lAtom')
         Call LDF_Quit(1)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DerChg(nAt,nAt3,nTs,nS,Eps,IAtm,AtmC,AtmChg,
     &  DM,DerMat,Tessera,Q,Qtot,QDer,
     $  DerTes,DerPunt,DerCentr,DerRad,Der1,Der2,VDer,Sphere,ISphe)
      Implicit Real*8(A-H,O-Z)
      Integer IAtm(nAt)
      Dimension AtmC(3,nAt),AtmChg(nAt)
      Dimension Q(2,*),ISphe(*),QTot(*),QDer(3,nAt,*),Der1(*),Der2(*)
      Dimension Tessera(4,*),Sphere(4,*),VDer(nTs,*)
      Dimension DM(nTs,*),DerMat(nTs,*)
      Dimension DerTes(nTs,NAt,3),DerPunt(nTs,NAt,3,3)
      Dimension DerRad(nS,NAt,3),DerCentr(nS,NAt,3,3)
      Data Zero,One,Two,Four/0.0d0,1.0d0,2.0d0,4.0d0/,XX/0.0d0/,JJ/0/
*
      PI  = Four*ATan(One)
      FPI = Four*PI
      Diag = - 1.0694d0 * Sqrt(FPI) / Two
      Sc_Cond = (Eps - One) / Eps
*
*---- Total charges
*
      Do iTs = 1, nTs
        Qtot(iTs) = Q(1,iTs) + Q(2,iTs)
      endDo
*
*---- Compute the derivative of PCM matrix
*
c     Loop on atoms and coordinates
      Do 100 iAt = 1, nAt
        Do 101 iCoord = 1, 3
          Index = 3 * (iAt-1) + iCoord
c         Conductor-like case
          Call DMat_CPCM(iAt,iCoord,Eps,nTs,nS,nAt,Diag,Tessera,
     &                   DerMat,DerTes,DerPunt,DerCentr,iSphe)

*
*---- First product: DerDM * Qtot
*
          Call PrMatVec(.False.,.False.,DerMat,-One,nTs,nTs,Qtot,Der1)
cpcm_solvent
c      if(iat.eq.5.and.icoord.eq.1) then
c       write(6,'(''In DerChg first contribution for 5, 1'')')
c       do its = 1, nts
c        write(6,'(i4,f20.12)') its,der1(its)
c       enddo
c      endif
cpcm_solvent end
*
*---- Total deriv. of the potential summed up the quantity alread
*---- computed (DerDM*Qtot)
*
          Do 200 iTs = 1, nTs
            Der1(iTs) = Der1(iTs) + Sc_Cond * VDer(iTs,Index)
  200     Continue
*
*---- Last product: - DM^-1 * (V^x + DM^x*q)
*
cpcm_solvent
c      if(iat.eq.5.and.icoord.eq.1) then
c       write(6,'(''In DerChg second contribution for 5, 1'')')
c       do its = 1, nts
c        write(6,'(i4,f20.12)') its,der1(its)
c       enddo
c      endif
cpcm_solvent end
          Call PrMatVec(.False.,.False.,DM,-1.d0,nTs,nTs,Der1,Der2)
          Call FillQDer(nAt,nTs,iAt,iCoord,Der2,QDer)
  101   Continue
  100 Continue
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(nAt3)
        Call Unused_integer_array(IAtm)
        Call Unused_real_array(AtmC)
        Call Unused_real_array(AtmChg)
        Call Unused_real_array(DerRad)
        Call Unused_real_array(Sphere)
      End If
      End
c----------------------------------------------------------------------
      Subroutine DMat_CPCM(iAt,iC,Eps,nTs,nS,nAt,fact,Tessera,
     &           DerMat,DerTes,DerPunt,DerCentr,iSphe)
      Implicit Real*8 (A-H,O-Z)
      Dimension ISphe(*),Tessera(4,*),DerMat(nTs,*)
      Dimension DerTes(nTs,NAt,3),DerPunt(nTs,NAt,3,3)
      Dimension DerCentr(nS,NAt,3,3)
      Data One/1.0d0/,Two/2.0d0/,Four/4.0d0/
C
C     Compute the derivative of the CPCM matrix wrt atom iat, coord. ic
C
C     Loop on tesserae
      Do 10 ITs = 1, NTs
        L = ISPHE(ITs)
        Do 11 JTS = 1, NTs
          LJ = ISPHE(JTS)
C         Diagonal elements
          If(ITs.eq.JTS) then
            DerMat(ITs,ITs) = fact * DERTES(ITs,iAt,IC) /
     &      ( Tessera(4,ITs) * Sqrt(Tessera(4,ITs)) )
          Else
C           Off diagonal elements
            XIJ = Tessera(1,ITs) - Tessera(1,JTS)
            YIJ = Tessera(2,ITs) - Tessera(2,JTS)
            ZIJ = Tessera(3,ITs) - Tessera(3,JTS)
            DIJ = Sqrt( XIJ*XIJ + YIJ*YIJ + ZIJ*ZIJ )
            DXIJ=DERPUNT(ITs,iAt,IC,1)+DERCENTR(L,iAt,IC,1)
     &          -DERPUNT(JTS,iAt,IC,1)-DERCENTR(LJ,iAt,IC,1)
            DYIJ=DERPUNT(ITs,iAt,IC,2)+DERCENTR(L,iAt,IC,2)
     &          -DERPUNT(JTS,iAt,IC,2)-DERCENTR(LJ,iAt,IC,2)
            DZIJ=DERPUNT(ITs,iAt,IC,3)+DERCENTR(L,iAt,IC,3)
     &          -DERPUNT(JTS,iAt,IC,3)-DERCENTR(LJ,iAt,IC,3)
            PROD = (XIJ*DXIJ + YIJ*DYIJ + ZIJ*DZIJ) / DIJ**3
            DerMat(ITs,JTS) = - PROD
          EndIf
   11   Continue
   10 Continue
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(Eps)
      End
*------------------------------------------------------------------------
      Subroutine PrMatVec(Dag,DoSym,Mat,f,n,m,Vec,Res)
      Implicit Real*8 (A-H,O-Z)
      Real*8 Mat(n,*),Vec(*),Res(*)
      Logical Dag,DoSym
      Data Zero,Two /0.0d0,2.0d0/
*
*---- Do the matrix vector product: f*Mat(n,m)*Vec(m,1)=Res(n,1)
*---- possibly transposed (if Dag): f*Vec(1,m)*Mat(m,n)=Res(1,n)
*---- If DoSym symmetrize the matrix elements
*
      Do 100 i = 1, n
        Res(i) = Zero
        Do 101 j = 1, m
          If(DoSym) then
            ElM = (Mat(i,j) + Mat(j,i)) / Two
          Else
            If(Dag) ElM = Mat(j,i)
            If(.not.Dag) Elm = Mat(i,j)
          EndIF
          Res(i) = Res(i) + f * ElM * Vec(j)
  101   Continue
  100 Continue
      Return
      End
*------------------------------------------------------------------------
      Subroutine FillQDer(nAt,nTs,iAt,iC,Der,QDer)
      Implicit Real*8 (A-H,O-Z)
      Dimension Der(*),QDer(3,nAt,*)
      Do 100 iTs = 1, nTs
        QDer(iC,iAt,iTs) = Der(iTs)
  100 Continue
      Return
      End
*------------------------------------------------------------------------
      subroutine testq(nAt,nTs,VDer,q,qtot)
      Implicit Real*8 (A-H,O-Z)
      Dimension VDer(nTs,*),Q(2,*),QTot(*)
      Integer Lu
      Lu=1
      Call Molcas_open(Lu,'DerPt.dat')
*     open(1,file='DerPot.dat',status='old',form='formatted')
      do 1132 iAt = 1, nAt
        do 1133 iCoord = 1, 3
          Index = 3 * (iAt-1) + iCoord
          do 1134 iTs = 1, nTs
            read(1,*)VDer(iTs,Index)
 1134     continue
 1133   continue
 1132 continue
      close(1)
      do 1135 iAt = 1, nAt
        do 1136 iCoord = 1, 3
          Index = 3 * (iAt-1) + iCoord
          sum = 0.d0
          do its = 1, nts
            qtot(its) = q(1,its) + q(2,its)
            sum = sum + qtot(its) * VDer(its,index)
          enddo
          write(6,'(''Charges times VDer'',i4,f20.12)') index,sum
 1136   continue
 1135 continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Eigen_Molcas(N,X,D,E)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Compute eigenvalues and eigenvectors of a symmetric real matrix  *
!     by the method of Householder (QR algorithm)                      *
!                                                                      *
!     reference:                                                       *
!     R.S. Martin, C. Reinsch and J.H. Wilkinson                       *
!     Num. Mat. Vol 11, p 181.-195 (1968)                              *
!                                                                      *
!     calling arguments:                                               *
!     N       : Type integer, input.                                   *
!               Dimensions of the matrix X and vectors D and E         *
!     X       : Type real*8 real, input/output                         *
!               on input it is the matrix to diagonalized              *
!               on output it contains the eigenvectors                 *
!     D       : Type real*8 real, output.                              *
!               vector of eigenvalues                                  *
!     E       : Type real*8 real, input/output.                        *
!               Scratch area of length N                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher, University of Lund, Sweden, 2000                 *
!     (the subrotine is based on a old implementation written          *
!      by the comp. center in Munich)                                  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(inout) :: X(N,N), E(N)
real(kind=wp), intent(out) :: D(N)
integer(kind=iwp) :: i, ii, j, k, l
real(kind=wp) :: B, C, dsum, F, G, H, P, R, S, scal, tmp
real(kind=wp), parameter :: eps = 3.0e-17_wp, tol = 1.0e-22_wp

if (N == 1) then
  D(1) = X(1,1)
  X(1,1) = One
  return
end if

! HOUSEHOLDER REDUCTION

do ii=2,N
  i = N+2-ii
  l = i-2
  H = Zero
  G = X(i,i-1)
  if (l > 0) then
    do k=1,l
      H = H+X(i,k)*X(i,k)
    end do
    S = H+G*G
    if (S < Tol) H = Zero
    if (H > Zero) then
      l = l+1
      F = G
      G = sqrt(S)
      if (G > Zero) G = -G
      H = S-F*G
      X(i,i-1) = F-G
      F = Zero
      do j=1,l
        X(j,i) = X(i,j)/H
        dsum = Zero
        do k=1,j
          dsum = dsum+X(j,k)*X(i,k)
        end do
        do k=j+1,l
          dsum = dsum+X(k,j)*X(i,k)
        end do
        E(j) = dsum/H
        F = F+dsum*X(j,i)
      end do
      F = F/(H+H)
      do j=1,l
        E(j) = E(j)-F*X(i,j)
      end do
      do j=1,l
        F = X(i,j)
        scal = E(j)
        do k=1,j
          X(j,k) = X(j,k)-F*E(k)-X(i,k)*scal
        end do
      end do
    end if
  end if
  D(i) = H
  E(i-1) = G
end do

! ACCUMULATION OF TRANSFORMATION MATRICES

D(1) = X(1,1)
X(1,1) = One
do i=2,N
  l = i-1
  if (D(i) > Zero) then
    do j=1,l
      S = Zero
      do k=1,l
        S = S+X(i,k)*X(k,j)
      end do
      do k=1,l
        X(k,j) = X(k,j)-S*X(k,i)
      end do
    end do
  end if
  D(i) = X(i,i)
  X(i,i) = One
  do j=1,l
    X(i,j) = Zero
    X(j,i) = Zero
  end do
end do

! DIAGONALIZATION OF THE TRIDIAGONAL MATRIX

B = Zero
F = Zero
E(N) = Zero
outer: do l=1,N
  H = eps*(abs(D(l))+abs(E(l)))
  if (H > B) B = H
  do j=l,N
    if (abs(E(j)) <= B) then
      if (j == l) then
        D(l) = D(l)+F
        cycle outer
      end if
    end if
  end do
  j = N
  do while (abs(E(l)) > B)
    P = (D(l+1)-D(l))*Half/E(l)
    R = sqrt(P*P+One)
    if (P >= Zero) then
      P = P+R
    else
      P = P-R
    end if
    H = D(l)-E(l)/P
    do i=l,N
      D(i) = D(i)-H
    end do
    F = F+H
    P = D(j)
    C = One
    S = Zero
    do ii=l,j-1
      i = l+j-1-ii
      G = C*E(i)
      H = C*P
      if (abs(P) < abs(E(i))) then
        C = P/E(i)
        R = sqrt(C*C+One)
        E(i+1) = S*E(i)*R
        S = One/R
        C = C/R
      else
        C = E(i)/P
        R = sqrt(C*C+One)
        E(i+1) = S*P*R
        S = C/R
        C = One/R
      end if
      P = C*D(i)-S*G
      D(i+1) = H+S*(C*G+S*D(i))
      do k=1,N
        H = X(k,i+1)
        X(k,i+1) = X(k,i)*S+H*C
        X(k,i) = X(k,i)*C-H*S
      end do
    end do
    E(l) = S*P
    D(l) = C*P
  end do
  D(l) = D(l)+F
end do outer

! ORDERING OF EIGENVALUES

do i=1,N-1
  do j=i+1,N
    if (D(j) < D(i)) then
      tmp = D(j)
      D(j) = D(i)
      D(i) = tmp
      do k=1,N
        tmp = X(k,j)
        X(k,j) = X(k,i)
        X(k,i) = tmp
      end do
    end if
  end do
end do

! FIXING OF SIGN

do i=1,N
  k = 1
  tmp = abs(X(k,i))
  do j=2,N
    if (tmp <= abs(X(j,i))) then
      tmp = abs(X(j,i))
      k = j
    end if
  end do
  if (X(k,i) < Zero) then
    do j=1,N
      X(j,i) = -X(j,i)
    end do
  end if
end do

return

end subroutine Eigen_Molcas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine bufio_init_cvb(file_id1)
      implicit real*8 (a-h,o-z)
      logical tstfile_cvb
      external tstfile_cvb
#include "bufio_cvb.fh"
#include "idbl_cvb.fh"
      dimension dnbuf(1)

      file_id=file_id1
      ibuf=0
      if(.not.tstfile_cvb(file_id))then
        nbuf=0
        dnbuf=DBLE(nbuf)
        call wrlow_cvb(dnbuf,1,file_id,0)
      else
        call rdlow_cvb(dnbuf,1,file_id,0)
        nbuf=nint(dnbuf(1))
      endif
      nword=lbuf/idbl
      call izero(izbuffer,lbuf)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Real*8 Function E2_td(FockI,rMo,loper,idisp)
*
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "WrkSpc.fh"

*
      Real*8 FockI(nCMO),rMO(*)
      Logical Go
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      E22=0.0d0
      If (loper.eq.0) Then
         Go = idisp.lt.0
         If (.Not.Go) Go = iAnd(ntpert(idisp),2**2).eq.4
         If (Go) Then
            Do i=1,nna
               Do j=1,nna
                  ij2=i+(j-1)*nna
                  ij=itri(i,j)
                  Do k=1,nna
                     Do l=1,nna
                        ijkl=itri(ij,itri(k,l))
                        kl2=k+(l-1)*nna
                        ijkl2=ij2+(kl2-1)*nna**2
                        E22=E22+0.5d0*work(ipg2sq+ijkl2-1)*rmo(ijkl)
                     End Do
                  End Do
               End Do
            End Do
         End If
         Do is=1,nSym
            Do iA=1,Nash(is)
               iAA=nA(is)+ia
               iAB=ia+nish(is)
               js=is
               Do jA=1,nAsh(js)
                  jAA=ja+nA(js)
                  jAB=jA+nIsh(js)
                  ipF=(iab-1)*nbas(is)+jab+ipCM(is)-1
                  E22=E22+Focki(ipf)*Work(ipg1+itri(iaa,jaa)-1)
               End Do
            End Do
         End Do
      End If
*
      e2_td=e22
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Bernd Artur Hess                                 *
!               1999, Roland Lindh                                     *
!***********************************************************************

subroutine pXpInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the comutation of pXp integrals           *
!                                                                      *
!     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
!             Chemie, University of Bonn, Germany, April 1993          *
!             R. Lindh, modified to molcas 4.1 form, Oct 1999          *
!***********************************************************************

use Symmetry_Info, only: iChBas, nIrrep
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: iBeta, iComp, iDum, ipar, ipar_p1, ipar_p2, ipar_p3, ipArr, ipB, ipOff, iPrint, ipS1, ipS2, iRout, iSym_p1, &
                     iSym_p2, iSym_p3, iSym_pX, iSym_pXp, iTemp, jTemp1, jTemp2, jTemp3, kComp, kIC, kOrdOp, mArr, nip
integer(kind=iwp), allocatable :: kChO(:,:), kOper(:,:)
integer(kind=iwp), external :: IrrFnc

#include "macros.fh"
unused_var(nHer)

iRout = 220
iPrint = nPrint(iRout)

rFinal(:,:,:,:) = Zero
Array(:) = Zero
nip = 1
ipB = nip
nip = nip+nZeta
ipS1 = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb+1)*3*nIC
if (lb > 0) then
  ipS2 = nip
  nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb-1)*3*nIC
else
  ipS2 = ipS1
end if
ipArr = nip
mArr = nArr-(nip-1)/nZeta
if (mArr < 0) then
  call WarningMessage(2,'pXpInt: mArr<0!')
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! nIC: the number of blocks of the symmetry adapted operator pXp
! nComp: number of components of the operator pXp
!
! pXp = d/dx X d/dx + d/dy X d/dy + d/dz X d/dz

kIC = nIC*3
kComp = nComp*3
kOrdOp = nOrdOp-1
call mma_allocate(kChO,3,nComp,label='kChO')
call mma_allocate(kOper,3,nComp,label='kOper')
!write(u6,*)
!write(u6,*) 'pXpInt:**********'

iSym_p1 = IrrFnc(1)
iSym_p2 = IrrFnc(2)
iSym_p3 = IrrFnc(4)
!write(u6,*) 'iSym_p=',iSym_p1,iSym_p2,iSym_p3
ipar_p1 = iChBas(2)
ipar_p2 = iChBas(3)
ipar_p3 = iChBas(4)
!write(u6,*) 'ipar_p=',ipar_p1,ipar_p2,ipar_p3
do iComp=1,nComp
  iTemp = lOper(iComp)
  ipar = iChO(iComp)

  jTemp1 = 0
  jTemp2 = 0
  jTemp3 = 0
  do iSym_pXp=0,nIrrep-1
    if (btest(iTemp,iSym_pXp)) then
      iSym_pX = ieor(iSym_pXp,iSym_p1)
      !write(u6,*) 'iSym_pXp,iSym_pX=',iSym_pXp,iSym_pX
      jTemp1 = ibset(jTemp1,iSym_pX)
      iSym_pX = ieor(iSym_pXp,iSym_p2)
      !write(u6,*) 'iSym_pXp,iSym_pX=',iSym_pXp,iSym_pX
      jTemp2 = ibset(jTemp2,iSym_pX)
      iSym_pX = ieor(iSym_pXp,iSym_p3)
      !write(u6,*) 'iSym_pXp,iSym_pX=',iSym_pXp,iSym_pX
      jTemp3 = ibset(jTemp3,iSym_pX)
    end if
  end do
  kOper(1,iComp) = jTemp1
  kOper(2,iComp) = jTemp2
  kOper(3,iComp) = jTemp3

  kChO(1,iComp) = ieor(ipar,ipar_p1)
  kChO(2,iComp) = ieor(ipar,ipar_p2)
  kChO(3,iComp) = ieor(ipar,ipar_p3)

end do
!                                                                      *
!***********************************************************************
!                                                                      *
call pXint(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS1),nZeta,kIC,kComp,la,lb+1,A,RB,iDum,Array(ipArr),mArr,CCoor, &
           kOrdOp,kOper,kChO,iStabM,nStabM,PtChrg,nGrid,iAddPot)
!                                                                      *
!***********************************************************************
!                                                                      *
if (lb > 0) then
  call pXint(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS2),nZeta,kIC,kComp,la,lb-1,A,RB,iDum,Array(ipArr),mArr,CCoor, &
             kOrdOp,kOper,kChO,iStabM,nStabM,PtChrg,nGrid,iAddPot)
end if
call mma_deallocate(kChO)
call mma_deallocate(kOper)
!                                                                      *
!***********************************************************************
!                                                                      *
ipOff = ipB-1
do iBeta=1,nBeta
  Array(ipOff+1:ipOff+nAlpha) = Beta(iBeta)
  ipOff = ipOff+nAlpha
end do

if (iPrint >= 99) then
  call RecPrt(' In pXpint: Beta (expanded)','(5D20.13)',Array(ipB),nZeta,1)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Combine pX integrals to generate the pXp integrals.
!
! Note that the pX integrals have 3*nComp components.

call Ass_pXp(Array(ipB),nZeta,rFinal,la,lb,Array(ipS1),Array(ipS2),nComp)
!                                                                      *
!***********************************************************************
!                                                                      *
if (iPrint >= 49) call RecPrt('pXpInt: rFinal',' ',rFinal(:,:,:,1),nZeta,nTri_Elem1(la)*nTri_Elem1(lb))

return

end subroutine pXpInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, IBM                                              *
************************************************************************
      Integer Function NrOpr(iOp)
************************************************************************
*                                                                      *
* Object: to return the order index of a symmetry operator.            *
*                                                                      *
************************************************************************
      Use Symmetry_Info, only: nIrrep, iOper
      NrOpr=-1
      Do iIrrep = 0, nIrrep - 1
         If (iOp.eq.iOper(iIrrep)) NrOpr=iIrrep
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE COMP1(LJ,ITYP,L,IT2,II,IID,JJ,JJD,JTYP,ITAI)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
      DIMENSION ITAI(*)
#include "real_guga.fh"
#include "integ.fh"
#include "files_guga.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
      COMMON/D/JNDX(500 000)
*
      JO(L)=ICUNP(ICASE,L)
*
      FAC=D1
      ITAIL=IX(IT2+LJ)
      DO 90 IN=1,ITAIL
      IC1=ICOUP(1)+IN
      JND1=JNDX(II+IC1)
      IF(JND1.EQ.0)GO TO 90
      IN2=ITAI(IN)
      IF(IN2.EQ.0)GO TO 90
      IC2=ICOUP1(1)+IN2
      IF(ITYP.NE.1)GO TO 91
      KK1=(JND1-1)*LN+L
      JOJ=JO(KK1)
      IF(JOJ.GT.1)JOJ=JOJ-1
      FAC=JOJ
      IF(JOJ.EQ.0)GO TO 90
91    IC1=JND1-IID
      JND2=JNDX(JJ+IC2)
      IF(JND2.EQ.0)GO TO 90
      IC2=JND2-JJD
      IOUT=IOUT+1
      KTYP=JTYP
      IF(JTYP.LE.3)GO TO 92
      ICT=IC1
      IC1=IC2
      IC2=ICT
      KTYP=JTYP-3
92    CONTINUE
*      IND=KTYP+2**6*IC2
      IND=IOR(KTYP,ISHFT(IC2,6))
*      ICOP1(IOUT)=IND+2**19*IC1
      ICOP1(IOUT)=IOR(IND,ISHFT(IC1,19))
      COP(IOUT)=FAC*COUP(1)
      IF(IOUT.LT.NBUF)GO TO 90
      ICOP1(nCOP+1)=NBUF
      IF(.FALSE.) THEN
         WRITE(6,*) 'WRITING BUFFER IN COMP1'
         WRITE(6,*) '======================='
         WRITE(6,'(A,I6)') 'ICOP1(nCOP+1) ',ICOP1(nCOP+1)
         WRITE(6,'(A,I6)') 'IADD10     ',IADD10
      END IF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
90    CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_SetAddr()
C
C     Purpose: set initial disk adresses for local as well as global
C              reduced sets.
C
      use ChoSwp, only: InfRed, InfRed_G
      use ChoSwp, only: InfVec, InfVec_G
      Implicit None
#include "cholesky.fh"
#include "cho_para_info.fh"
#include "choglob.fh"

      Character*13 SecNam
      Parameter (SecNam = 'Cho_P_SetAddr')

      Integer irc

      If (Cho_Real_Par) Then

C        The variable XnPass must be zero: restart is not possible.
C        ----------------------------------------------------------

         If (XnPass .ne. 0) Then
            Call Cho_Quit('XnPass>0 error in '//SecNam,104)
         End If

C        Global.
C        -------

         Call Cho_P_SetAddr_2(InfRed_G,InfVec_G,
     &                        MaxRed,MaxVec,SIZE(InfVec,2),nSym,irc)
         If (irc .ne. 0) Then
            Write(Lupri,*) SecNam,': Cho_P_SetAddr_2 returned ',irc
            Call Cho_Quit('Error in '//SecNam,104)
         End If

      End If

C     Local.
C     ------

      Call Cho_SetAddr(InfRed,InfVec,
     &                 MaxRed,MaxVec,SIZE(InfVec,2),nSym)

      End
************************************************************************
************************************************************************
************************************************************************
      SubRoutine Cho_P_SetAddr_2(InfRed,InfVec,MaxRed,MaxVec,N2,nSym,
     &                           irc)
      Implicit None
      Integer MaxRed, MaxVec, N2, nSym, irc
      Integer InfRed(MaxRed), InfVec(MaxVec,N2,nSym)

      Integer iSym

      irc = 0

      If (MaxRed .gt. 0) Then
         InfRed(1) = 0
      Else
         irc = 1
         Return
      End If

      If (MaxVec.gt.0 .and. N2.ge.4) Then
         Do iSym = 1,nSym
            InfVec(1,3,iSym) = 0
            InfVec(1,4,iSym) = 0
         End Do
      Else
         irc = 2
         Return
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine grc42C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,pbar,possc0,ix)
c
#include "ccsd1.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer pbar,possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4
       integer nhelp21,nhelp22,nhelp23
       integer ntest1,ntest2
       integer sa1,sa2,sa3,sa4,sb1,sb2,sa12,sa123
       integer nsyma2,nsyma3
       integer ia,ib,ic,ix
       integer possct
c
c1*
c
       if (pbar.eq.1) then
c
c     not possible
c
       else if (pbar.eq.2) then
c
c     sctructure A(pq,rs)*B(rs)=C(pq)
c     implemented in grc42y
c
       else if (pbar.eq.3) then
c
c     sctructure A(pqr,s)*B(s,t)=C(pqr,t)
c
c1.1  define limitations -  p>q,r,s must be tested - ntest1
c     p,q>r,s must be tested - ntest2
c
c1.0  prepare mapdc,mapic
c
       call grc0 (4,mapda(0,6),mapda(0,1),mapda(0,2),mapda(0,3),mapdb(0,
     &            2),mmul(ssa,ssb),
     & possc0,possct,mapdc,mapic)
c
       if (mapda(0,6).eq.1) then
       ntest1=1
       else
       ntest1=0
       end if
c
       if (mapda(0,6).eq.2) then
       ntest2=1
       else
       ntest2=0
       end if
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sa1=1,nsym
       if (ntest1.eq.1) then
       nsyma2=sa1
       else
       nsyma2=nsym
       end if
c
       do 101 sa2=1,nsyma2
       sa12=mmul(sa1,sa2)
       if (ntest2.eq.1) then
       nsyma3=sa2
       else
       nsyma3=nsym
       end if
c
       do 102 sa3=1,nsyma3
       sa123=mmul(sa12,sa3)
c
       sa4=mmul(ssa,sa123)
       sb1=sa4
c
       sb2=mmul(ssb,sb1)
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,sa3)
       ib=mapib(sb1,1,1)
       ic=mapic(sa1,sa2,sa3)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 102
       end if
c
c     rowA
       nhelp21=dimm(mapda(0,1),sa1)
       nhelp22=dimm(mapda(0,2),sa2)
       nhelp23=dimm(mapda(0,3),sa3)
       if ((ntest1.eq.1).and.(sa1.eq.sa2)) then
       nhelp2=nhelp21*(nhelp21-1)*nhelp23/2
       else if ((ntest2.eq.1).and.(sa2.eq.sa3)) then
       nhelp2=nhelp21*nhelp22*(nhelp22-1)/2
       else
       nhelp2=nhelp21*nhelp22*nhelp23
       end if
c
c     colB
       nhelp3=dimm(mapdb(0,2),sb2)
c
c     sum
       nhelp4=dimm(mapda(0,4),sa4)
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(ic,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=nhelp3
c
       ix=ix+1
c
 102    continue
 101    continue
 100    continue
c
c
       end if
       ix=ix-1
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_Energy_Prt(Caller,Job,iBatch)
!
! Thomas Bondo Pedersen, March 2005.
!
! Purpose: print progress reports for the MP2 energy evaluation.

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: Caller
integer(kind=iwp), intent(in) :: Job, iBatch
real(kind=wp) :: CME_Time(2,2) = Zero, CPU, Ratio, Wall
character(len=*), parameter :: SecNam = 'ChoMP2_Energy_Prt', ThisNam = 'Energy_Prt'

if (Job == 0) then

  CME_Time(:,:) = Zero

  write(u6,'(/,4X,A,/,4X,A)') 'Evaluation of MP2 energy correction','==================================='
  write(u6,'(4X,A,A)') 'Evaluator: ',Caller

  write(u6,'(/,4X,A,/,4X,A,/,4X,A)') 'Batch      CPU       Wall    Ratio',' No.     seconds    seconds', &
                                     '----------------------------------'

  call xFlush(u6)

else if (Job == 1) then

  call CWTime(CME_Time(1,1),CME_Time(2,1))

  call xFlush(u6)

else if (Job == 2) then

  call CWTime(CME_Time(1,2),CME_Time(2,2))
  CPU = CME_Time(1,2)-CME_Time(1,1)
  Wall = CME_Time(2,2)-CME_Time(2,1)
  if (abs(Wall) < 1.0e-8_wp) then
    if (abs(CPU) < 1.0e-8_wp) then
      Ratio = One
    else
      Ratio = 1.0e15_wp
    end if
  else
    Ratio = CPU/Wall
  end if
  write(u6,'(I9,2(1X,F10.2),1X,F6.3)') iBatch,CPU,Wall,Ratio

  call xFlush(u6)

else if (Job == 3) then

  write(u6,'(4X,A)') '----------------------------------'

  call xFlush(u6)

else

  call SysAbendMsg(SecNam,'Input parameter "Job" is out of range',' ')

end if

end subroutine ChoMP2_Energy_Prt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1994, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine RysEF4(xyz2D,nArg,mArg,nRys,neMin,neMax,nfMin,
     &                  nfMax,EFInt,meMin,meMax,mfMin,mfMax,
     &                  PreFct,ixe,ixf,ixye,ixyf,
     &                  nzeMin,nzeMax,nzfMin,nzfMax)
************************************************************************
*                                                                      *
* Object: kernel routine to assemble the integrals from the Ixy        *
*         and Iz integrals.                                            *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             August '90                                               *
*                                                                      *
*             Modified for decreased memory access January '94.        *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 xyz2D(nRys,mArg,3,0:neMax,0:nfMax),
     &       PreFct(mArg), EFInt(nArg,meMin:meMax,mfMin:mfMax)
*
*     Statement function to compute canonical index
*
      iCan(ixyz,ix,iz) = ixyz*(ixyz+1)*(ixyz+2)/6 +
     &   (ixyz-ix)*(ixyz-ix+1)/2 + iz
*
      iRout = 17
      iPrint = nPrint(iRout)
*
      iyf=ixyf-ixf
      iye=ixye-ixe
      izf=nzfMax
      ize=nzeMax
      Indf=iCan(ixyf+izf,ixf,izf)
      Inde=iCan(ixye+ize,ixe,ize)
      If (nRys.eq.1) Then
         Do iArg = 1, mArg
            EFInt(iArg,Inde,Indf) = PreFct(iArg) *
     &                         xyz2D(1,iArg,1,ixe,ixf) *
     &                         xyz2D(1,iArg,2,iye,iyf) *
     &                         xyz2D(1,iArg,3,ize,izf)
         End Do
       Else If (nRys.eq.2) Then
         Do iArg = 1, mArg
            EFInt(iArg,Inde,Indf) = PreFct(iArg) * (
     &                         xyz2D(1,iArg,1,ixe,ixf) *
     &                         xyz2D(1,iArg,2,iye,iyf) *
     &                         xyz2D(1,iArg,3,ize,izf)
     &                       + xyz2D(2,iArg,1,ixe,ixf) *
     &                         xyz2D(2,iArg,2,iye,iyf) *
     &                         xyz2D(2,iArg,3,ize,izf))
         End Do
       Else If (nRys.eq.3) Then
         Do iArg = 1, mArg
            EFInt(iArg,Inde,Indf) = PreFct(iArg) * (
     &                         xyz2D(1,iArg,1,ixe,ixf) *
     &                         xyz2D(1,iArg,2,iye,iyf) *
     &                         xyz2D(1,iArg,3,ize,izf)
     &                       + xyz2D(2,iArg,1,ixe,ixf) *
     &                         xyz2D(2,iArg,2,iye,iyf) *
     &                         xyz2D(2,iArg,3,ize,izf)
     &                       + xyz2D(3,iArg,1,ixe,ixf) *
     &                         xyz2D(3,iArg,2,iye,iyf) *
     &                         xyz2D(3,iArg,3,ize,izf))
         End Do
      Else If (nRys.eq.4) Then
         Do iArg = 1, mArg
            EFInt(iArg,Inde,Indf) = PreFct(iArg) * (
     &                         xyz2D(1,iArg,1,ixe,ixf) *
     &                         xyz2D(1,iArg,2,iye,iyf) *
     &                         xyz2D(1,iArg,3,ize,izf)
     &                       + xyz2D(2,iArg,1,ixe,ixf) *
     &                         xyz2D(2,iArg,2,iye,iyf) *
     &                         xyz2D(2,iArg,3,ize,izf)
     &                       + xyz2D(3,iArg,1,ixe,ixf) *
     &                         xyz2D(3,iArg,2,iye,iyf) *
     &                         xyz2D(3,iArg,3,ize,izf)
     &                       + xyz2D(4,iArg,1,ixe,ixf) *
     &                         xyz2D(4,iArg,2,iye,iyf) *
     &                         xyz2D(4,iArg,3,ize,izf))
         End Do
      Else If (nRys.eq.5) Then
         Do iArg = 1, mArg
            EFInt(iArg,Inde,Indf) = PreFct(iArg) * (
     &                         xyz2D(1,iArg,1,ixe,ixf) *
     &                         xyz2D(1,iArg,2,iye,iyf) *
     &                         xyz2D(1,iArg,3,ize,izf)
     &                       + xyz2D(2,iArg,1,ixe,ixf) *
     &                         xyz2D(2,iArg,2,iye,iyf) *
     &                         xyz2D(2,iArg,3,ize,izf)
     &                       + xyz2D(3,iArg,1,ixe,ixf) *
     &                         xyz2D(3,iArg,2,iye,iyf) *
     &                         xyz2D(3,iArg,3,ize,izf)
     &                       + xyz2D(4,iArg,1,ixe,ixf) *
     &                         xyz2D(4,iArg,2,iye,iyf) *
     &                         xyz2D(4,iArg,3,ize,izf)
     &                       + xyz2D(5,iArg,1,ixe,ixf) *
     &                         xyz2D(5,iArg,2,iye,iyf) *
     &                         xyz2D(5,iArg,3,ize,izf))
         End Do
      Else
*
*--------------General code
*
         Do iArg = 1, mArg
            EFInt(iArg,Inde,Indf) =
     &                         xyz2D(1,iArg,1,ixe,ixf) *
     &                         xyz2D(1,iArg,2,iye,iyf) *
     &                         xyz2D(1,iArg,3,ize,izf)
               Do iRys = 2, nRys
               EFInt(iArg,Inde,Indf) = EFInt(iArg,Inde,Indf) +
     &                            xyz2D(iRys,iArg,1,ixe,ixf) *
     &                            xyz2D(iRys,iArg,2,iye,iyf) *
     &                            xyz2D(iRys,iArg,3,ize,izf)
               End Do
               EFInt(iArg,Inde,Indf) = EFInt(iArg,Inde,Indf) *
     &           PreFct(iArg)
         End Do
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(neMin)
         Call Unused_integer(nfMin)
         Call Unused_integer(nzeMin)
         Call Unused_integer(nzfMin)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
************************************************************************
      SubRoutine OpnFl(Name,Lu,Exist)
************************************************************************
*                                                                      *
* Object:                                                              *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    : f_Inquire                                               *
*              isFreeUnit                                              *
*              Open                                                    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Chemical Physics,                 *
*             University of Lund, SWEDEN                               *
*             February 2000                                            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Character*(*) name
      Logical Exist
*
*---- Find an unused unit number
*
      lu_=lu
      lu=isFreeUnit(lu_)
      Exist = .False.
*
*---- Check that file exists
*
c      Open(unit=Lu,file=name,status='UNKNOWN',form='FORMATTED')
      Call F_Inquire(Name,Exist)
      Call Molcas_Open(Lu,Name)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine axexbsol2_cvb(ap,rhsp,itdav,maxdav,nfrdim1,
     >  solp,solp_res,eig,eig_res,
     >  eigval,eigvec,dxp,gradp,w2)
c  Solve linear equation in Davidson subspace.
      implicit real*8 (a-h,o-z)
#include "direct_cvb.fh"
#include "locopt1_cvb.fh"
#include "tune_cvb.fh"
      dimension ap(maxdav,maxdav),rhsp(maxdav)
      dimension solp(maxdav),solp_res(maxdav)
      dimension eigval(itdav),eigvec(itdav,itdav)
      dimension dxp(itdav),gradp(itdav),w2(itdav)
      save zero,one
      data zero/0d0/,one/1d0/

      do 100 it=1,itdav
      call fmove_cvb(ap(1,it),eigvec(1,it),itdav)
100   continue

      if(ip.ge.3)then
        write(6,*)' AP matrix :'
        do i=1,itdav
        eigval(i)=eigvec(i,i)
        eigvec(i,i)=eigvec(i,i)+corenrg
        enddo
        call mxprintd_cvb(eigvec,itdav,itdav,0)
        do i=1,itdav
        eigvec(i,i)=eigval(i)
        enddo
        write(6,*)' RHSP vector :'
        call mxprint_cvb(rhsp,1,itdav,0)
      endif

      call mxdiag_cvb(eigvec,eigval,itdav)

      if(ip.ge.2)then
        write(6,'(a)')' Eigenvalues :'
        do i=1,itdav
        eigval(i)=eigval(i)+corenrg
        enddo
        call vecprint_cvb(eigval,itdav)
        do i=1,itdav
        eigval(i)=eigval(i)-corenrg
        enddo
      endif

      call mxatb_cvb(rhsp,eigvec,1,itdav,itdav,gradp)
      if(ifollow.eq.1)then
        nposeig=nroot-1
        nnegeig=itdav-nposeig
      elseif(ifollow.eq.2)then
        nnegeig=nroot-1
        nposeig=itdav-nnegeig
      else
        write(6,*)' Error in IFOLLOW with direct Fletcher!',ifollow
        call abend_cvb()
        nnegeig=0
        nposeig=0
      endif

      eigmx=-one
      eigmn=one
      if(nnegeig.gt.0)eigmx=eigval(nnegeig)
      if(nposeig.gt.0)eigmn=eigval(nnegeig+1)
      safety_use=safety
200   continue
      if(eigmx.lt.-signtol.and.eigmn.gt.signtol)then
        alfastart=zero
      else
        alfastart=max(eigmx,-eigmn,zero)+safety_use
      endif
      call getdxp_cvb(dxp,gradp,eigval,nnegeig,itdav,alfastart)
      cnrm=dnrm2_(itdav,dxp,1)
      if(alfastart.ne.zero)then
        gnrm=dnrm2_(itdav,gradp,1)
        if(cnrm.gt.1d-15.and.gnrm.gt.1d-15.and.safety_use.ne.1d-4)then
          ovr_dx_grad=ddot_(itdav,dxp,1,gradp,1)/(cnrm*gnrm)
          if(ovr_dx_grad.lt..3d0)then
            safety_use=1d-4
            goto 200
          endif
        endif
      endif

      call makedx_cvb(solp,itdav,0,
     >  eigvec,eigval,dxp,gradp,w2,
     >  .false.,.false.,nposeig,.false.,
     >  .false.,nnegeig,.false.,alfastart,eig)

      eig_res=eig
      call fmove_cvb(solp,solp_res,itdav)
      if(ip.ge.2)then
        write(6,'(a,f15.8)')' Eigenvalue :',eig
        write(6,'(a)')' Solution vector :'
        call vecprint_cvb(solp,itdav)
      endif
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(nfrdim1)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine  Mk_T1t (T1,H,dimbepp,no,nv,addbepp)
c
c        this routine do:
c        H(i,be") <- T1o(be,i)
c
        implicit none
        integer dimbepp,no,nv,addbepp
        real*8 T1(1:nv,1:no)
        real*8 H(1:no,1:dimbepp)
c
c        help variables
        integer i,bepp
c
        do i=1,no
        do bepp=1,dimbepp
          H(i,bepp)=T1(addbepp+bepp,i)
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2000, Roland Lindh                                *
************************************************************************
      SubRoutine InpRct(LuSpool)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*                                                                      *
*             Modified for Langevin polarizabilities, March 2000 (RL)  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "rctfld.fh"
#include "covradt_data.fh"
      Character*180 KWord, Key, Get_Ln
      External Get_Ln
*
      iRout=1
      iPrint=nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*---- Initiate data for dielectric medium
*
      Eps=One
      EpsInf=One
      Eps_User=-One
      EpsInf_User=Zero
      rds=Zero
      lMax=-1
      lRF = .False.
      lRFCav = .False.
      RF_Basis=.False.
*                                                                      *
************************************************************************
*                                                                      *
*---- Initiate data for PCM
*
      PCM=.False.
      i_sph_inp = 0
*     Default PCM parameters
      Call PCMDef(ISlPar,RSlPar,iPrint)
*                                                                      *
************************************************************************
*                                                                      *
*---- Setting up default values for parameters used in Langevin
*     polarizabilities
*
*     latato: Gitter type (1 or 4)
      latato = 1
      Cordsi(1,latato) = Half
      Cordsi(2,latato) = Half
      Cordsi(3,latato) = Half
*
*     polsi: site polarizability
      polsi = Zero
*
*     dipsi: site dipole moment
      dipsi = Zero
*
*     radlat: maximum extension of the lattic
      radlat = Zero
*
*     scala,scalb,scalc: lengths of the cell dimensions
      scala = Zero ! should be set by input
      scalb = Zero
      scalc = Zero
*
*     scaaa: overall scaling
      scaaa = One

*     rotation of grid
      rotAlpha = Zero
      rotBeta  = Zero
      rotGamma = Zero

*     rsca: scaling of radii
      rsca = One

*     Controls wheather a sparse grid should be used outside
*     a distance distSparce from ALL atoms and XF points
*     nSparse = scala(sparse) / scala(normal)
      LSparse = .False.
      nSparse = 1
      distSparse = Zero

*     Minimum distance for handling dipole-dipole interactions
      dipCutoff = Zero

*     Damping of dipole-dipole interactions
      lDamping = .True.

*     Use a dipole-dipole cutoff of Amber type, i.e. same exclusions
*     as for the static field
      lAmberPol = .False.

*     Controls scaling of contributions from negative entries in
*     the exclusion list, typically 1-4 interactions
      scal14 = One

*     Controls wheather an average of different grids is done
      LGridAverage = .False.

*
*     diedel: controlls deletion of gitter polarizabilities
      diedel = 0.01D0
*
*     tK: Boltzman factor
      tK = 0.001
*
*     clim: convergence threshold for solver
      clim = 1.0D-15
*
*     afac: controlls equation solver (valid values 0.3-0.97)
      afac = Half

*     iterDamp: controls update of dipoles in equation solver
*     newDip = oldDip*iterDamp + estimatedDip*(1-iterDamp)
      dampIter=0.4D0
      lDiprestart=.False.
*
*     nexpo: exponent of the potential with which the QM system kills
*            the gitter polatizabilities
      nexpo = 12
*
*     prefac: scaling of the polarization energies
      prefac = One
*
      lLangevin = .False.
*                                                                      *
************************************************************************
*                                                                      *
      iPrint=5
*                                                                      *
************************************************************************
*                                                                      *
*-----Process the input
*
 998  Read (LuSpool,'(A72)',END=977,ERR=988) Key
      KWord = Key
      Call UpCase(KWord)
      If (KWord(1:1).eq.'*')    Go To 998
      If (KWord.eq.'')       Go To 998
      If (KWord(1:4).eq.'REAC') Go To 900
      If (KWord(1:4).eq.'PRIN') Go To 910
      If (KWord(1:4).eq.'LANG') Go To 911
      If (KWord(1:4).eq.'GITT') Go To 912
      If (KWord(1:4).eq.'POLA') Go To 913
      If (KWord(1:4).eq.'DIPO') Go To 914
      If (KWord(1:4).eq.'OSCA') Go To 915
      If (KWord(1:4).eq.'DIED') Go To 916
      If (KWord(1:4).eq.'MXLX') Go To 917
      If (KWord(1:4).eq.'AFAC') Go To 918
      If (KWord(1:4).eq.'RFBA') Go To 919
      If (KWord(1:4).eq.'PCM-') Go To 920
      If (KWord(1:4).eq.'SOLV') Go To 921
      If (KWord(1:4).eq.'DIEL') Go To 922
      If (KWord(1:4).eq.'COND') Go To 923
      If (KWord(1:4).eq.'AARE') Go To 925
      If (KWord(1:4).eq.'R-MI') Go To 926
      If (KWord(1:4).eq.'PAUL') Go To 927
      If (KWord(1:4).eq.'SPHE') Go To 928
      If (KWord(1:4).eq.'TEMP') Go To 929
      If (KWord(1:4).eq.'RSCA') Go To 930
      If (KWord(1:4).eq.'ROTA') Go To 931
      If (KWord(1:4).eq.'SPAR') Go To 932
      If (KWord(1:4).eq.'IDAM') Go To 933
      If (KWord(1:4).eq.'AVER') Go To 934
      If (KWord(1:4).eq.'CONV') Go To 935
      If (KWord(1:4).eq.'SKIP') Go To 936
      If (KWord(1:4).eq.'NODA') Go To 937
      If (KWord(1:4).eq.'LRAD') Go To 938
      If (KWord(1:4).eq.'AMBE') Go To 939
      If (KWord(1:4).eq.'SC14') Go To 940
      If (KWord(1:4).eq.'DRES') Go To 941
      If (KWord(1:4).eq.'END ') Go To 997
      iChrct=Len(KWord)
      Last=iCLast(KWord,iChrct)
      Write (6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
      Call WarningMessage(2,'InpRct: Error in keyword.')
      Call Quit_OnUserError()
*                                                                      *
****** REAC ************************************************************
*                                                                      *
*-----Read reaction field parameters
*
 900  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,Eps)
      Call Get_F1(2,rds)
      Call Get_I1(3,lmax)
      If (nToken(KWord).gt.3) Call Get_F1(4,EpsInf)
*
      lRF = .True.
      lRFCav = .True.
      iRc=-1
      iOpt=0
      Write(KWord,'(A,F10.5,A,F10.5,A,I4)')
     & 'eps=',Eps,' radius=',rds,' higest moment=',lMax
      Go To 998
*                                                                      *
****** PRIN ************************************************************
*                                                                      *
*-----Print level
*
 910  KWord=Get_Ln(LuSpool)
      Call Get_I1(1,n)
      Do i = 1, n
         KWord=Get_Ln(LuSpool)
         Call Get_I1(1,jRout)
         Call Get_I1(2,iPrint)
         nPrint(jRout)=iPrint
      End Do
      Go To 998
*                                                                      *
****** LANG ************************************************************
*                                                                      *
 911  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,scala)
      Call Get_F1(2,scalb)
      Call Get_F1(3,scalc)
      lLangevin = .True.
      lRF = .True.
      Go To 998
*                                                                      *
****** GITT ************************************************************
*                                                                      *
 912  KWord=Get_Ln(LuSpool)
      Call Get_I1(1,latato)
      Do i = 1, latato
         KWord=Get_Ln(LuSpool)
         Call Get_F(1,Cordsi(1,i),3)
      End Do
      Go To 998
*                                                                      *
****** POLA ************************************************************
*                                                                      *
 913  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,polsi)
      Go To 998
*                                                                      *
****** DIPO ************************************************************
*                                                                      *
 914  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,dipsi)
      Go To 998
*                                                                      *
****** OSCA ************************************************************
*                                                                      *
 915  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,scaaa)
      Go To 998
*                                                                      *
****** DIED ************************************************************
*                                                                      *
 916  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,diedel)
      Go To 998
*                                                                      *
****** MXLX ************************************************************
*                                                                      *
 917  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,radlat)
      Go To 998
*                                                                      *
****** AFAC ************************************************************
*                                                                      *
 918  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,afac)
      If (afac.ge.One) Then
         Call WarningMessage(2,'InpRct: afac invalid value!;'//
     &               '        afac >= 1.0 !')
         Call Quit_OnUserError()
      End If
      Go To 998
*                                                                      *
****** RFBA ************************************************************
*                                                                      *
C% 919  RF_Basis=.True.
C%      Go To 998
 919  Go To 998
*                                                                      *
****** PCM- ************************************************************
*                                                                      *
 920  PCM=.True.
      lRF = .True.
      lLangevin = .False.
      Go To 998
*                                                                      *
****** SOLV ************************************************************
*                                                                      *
 921  Solvent=Trim(Get_Ln(LuSpool))
      ISlPar(15) = NumSolv(Solvent)
      Go To 998
*                                                                      *
****** DIEL ************************************************************
*                                                                      *
*
*
 922  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,Eps_User)
      If (nToken(KWord).gt.1) Call Get_F1(2,EpsInf_User)
      Go To 998
*                                                                      *
****** COND ************************************************************
*                                                                      *
 923  Conductor=.True.
      ISlPar(16) = 2
      Go To 998
*                                                                      *
****** AARE ************************************************************
*                                                                      *
 925  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,aArea)
      RSlPar(7) = aArea
      Go To 998
*                                                                      *
****** RMIN ************************************************************
*                                                                      *
 926  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,r_min_Sphere)
      RSlPar(3) = r_min_Sphere
      Go To 998
*                                                                      *
****** PAUL ************************************************************
*                                                                      *
 927  ITypRad = 2
      ISlPar(9) = ITypRad
      Go To 998
*                                                                      *
****** SPHE ************************************************************
*                                                                      *
 928  KWord=Get_Ln(LuSpool)
      Call Get_I1(1,I_Sph)
      Call Get_F1(2,Radius)
      ITypRad = 3
      ISlPar(9) = ITypRad
      i_sph_inp = i_sph_inp + 1
      NOrdInp(i_sph_inp) = I_Sph
      RadInp(i_sph_inp) = Radius
      ISlPar(14) = i_sph_inp
      Go To 998
*                                                                      *
****** TEMP ************************************************************
*                                                                      *
*     Temperature for Langevin model
 929  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,Temp)
      tK=3.1668D-6*Temp
      Go To 998
*                                                                      *
****** RSCA ************************************************************
*                                                                      *
*     Simultaneous scaling of all radii
 930  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,rsca)
      Go To 998

*                                                                      *
****** ROTA ************************************************************
*                                                                      *
*     Rotation of the grid with Euler angles alpha, beta, gamma (degrees)
 931  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,rotAlpha)
      Call Get_F1(2,rotBeta)
      Call Get_F1(3,rotGamma)

      rotAlpha=rotAlpha/180.0D0*3.1415926535897932D0
      rotBeta=rotBeta/180.0D0*3.1415926535897932D0
      rotGamma=rotGamma/180.0D0*3.1415926535897932D0
      Go To 998

*                                                                      *
****** SPAR ************************************************************
*                                                                      *
*     Use sparse grid outside a distance distSparse from all atoms
 932  KWord=Get_Ln(LuSpool)
      LSparse = .True.
      Call Get_I1(1,nSparse)
      Call Get_F1(2,distSparse)
      Go To 998

*                                                                      *
****** IDAM ************************************************************
*                                                                      *
*     change dampIter

 933  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,dampIter)
      Go To 998

*                                                                      *
****** AVER ************************************************************
*                                                                      *
*     requests average among a number of random grids in the Langevin
*     routine. Note: Average is taken for each SCF iteration and only
*     the last grid is used for updating the density
*     nGridSeed is RNG seed, 0=no seed, -1=system timer

 934  KWord=Get_Ln(LuSpool)
      LGridAverage=.True.
      Call Get_I1(1,nGridAverage)
      Call Get_I1(2,nGridSeed)
      Go To 998

*                                                                      *
****** CONV ************************************************************
*                                                                      *
*     Change convergence threshold

 935  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,clim)
      Go To 998

*                                                                      *
****** SKIP ************************************************************
*                                                                      *
*     Set minimal distance for dipole-dipole interactions

 936  KWord=Get_Ln(LuSpool)
      Call Get_F1(1,dipCutoff)
      Go To 998
*                                                                      *
****** NODA ************************************************************
*                                                                      *
*     Turn off damping of dipole-dipole interactions

 937  lDamping=.False.
      Go To 998

*                                                                      *
****** LRAD ************************************************************
*                                                                      *
*     Input non-standard Langevin radii

 938  Continue
      Kword=Get_Ln(LuSpool)
      Call UpCase(KWord)
      If (KWord(1:1).eq.'*')    Go To 938
      If (KWord.eq.'')       Go To 938
      If (KWord(1:3).eq.'END')  Go To 998
      Read(KWord,*,err=988) ii,val
      CovRadT_(ii)=val
c      write(6,*)'COVR',ii,val
      Go To 938
*                                                                      *
****** AMBE ************************************************************
*                                                                      *
*     Use dipole-dipole cutoff of AMBER type

 939  Continue
      lAmberPol=.True.
      Go To 998
*                                                                      *
****** SC14 ************************************************************
*                                                                      *
*     Scaling of negative entries in exclusion list

 940  Continue
      KWord=Get_Ln(LuSpool)
      Call Get_F1(1,scal14)

      Go To 998

*                                                                      *
****** DRES ************************************************************
*                                                                      *
*     Restart dipoles from scratch in each QM iteration
*     This sometimes gives better convergence.

 941  Continue
      lDiprestart=.True.
      Go To 998

*                                                                      *
****** END  ************************************************************
*                                                                      *
*-----End of input
*
 997  Continue
*                                                                      *
************************************************************************
*                                                                      *
      If (lLangevin) Then
*
         polsi=polsi*scaaa**Three
         scala=scala*scaaa
         scalb=scalb*scaaa
         scalc=scalc*scaaa
         dipsi=dipsi*scaaa**(Three/Two)
*
*        Analyze the lattice
*
         gatom=Anal_Gitt(cordsi,latato)
*
*        Scale the grid.
*
         Do i=1,latato
            cordsi(1,i)=cordsi(1,i)*scala
            cordsi(2,i)=cordsi(2,i)*scalb
            cordsi(3,i)=cordsi(3,i)*scalc
         End Do
*
         If (lRFCav) Then
            If (radlat.eq.Zero) radlat=rds-One/Ten
            If (radlat.gt.rds) Then
               Call WarningMessage(2,'InpRct: radlat.gt.rds')
               Call Abend()
            End If
         Else
            Call WarningMessage(1,
     &           'Running Langevin without reaction field')
         EndIf
*
         tK=One/tK
         poltot=gatom*(polsi+dipsi**2*tK/Three)
         tal=poltot*Four*Pi/(Three*scala*scalb*scalc)
         epscm=(One+Two*tal)/(One-tal)
         If (Eps.lt.One) Eps=epscm
*
         tk5=Half*tk
         r2=radlat**2
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
*                                                                      *
************************************************************************
*                                                                      *
*-----Error handling
*
 977  Call WarningMessage(2,'InpRct: Premature end of input file.')
      Call Quit_OnUserError()
 988  Call WarningMessage(2,'InpRct: Error while reading input file.')
      Call Quit_OnUserError()
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003, Valera Veryazov                                  *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PMat_SCF(FstItr,XCf,nXCF,nD)
!***********************************************************************
!                                                                      *
!     purpose: Compute two-electron part of the Fock matrix            *
!                                                                      *
!     output:                                                          *
!       TwoHam  : two-electron part of the Fock matrix constructed by  *
!                 contraction of proper density matrix difference with *
!                 two-electron integrals i) in conventional way ii) in *
!                 direct way                                           *
!                                                                      *
!***********************************************************************

use OFembed, only: Do_OFemb
use InfSCF, only: Algo, DDnOff, Dens, dfkMat, DoFMM, DSCF, EDFT, exFac, FMOMax, FockAO, iDisk, iDummy_Run, ipsLst, Iter, Klockan, &
                  KSDFT, MapDns, MaxBas, MiniDn, MxConstr, nBas, nBB, nBT, nCore, nDens, nDIsc, nIter, nIterP, nOcc, NoExchange, &
                  nSkip, nSym, OneHam, pMTime, PotNuc, PreSch, RFPert, Thize, TimFld, tNorm, Tot_Charge, TwoHam, Vxc
use RICD_Info, only: Do_DCCD
use Int_Options, only: Exfac_Int => ExFac, FckNoClmb, PreSch_Int => PreSch, Thize_Int => Thize
use rctfld_module, only: lRF
use Integral_interfaces, only: Drv2El_dscf
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(inout) :: FstItr
integer(kind=iwp), intent(in) :: nXCf, nD
real(kind=wp), intent(in) :: XCf(nXCf,nD)
integer(kind=iwp) :: Algo_Save, iCharge, iD, iDumm, iM, iMat, iSpin, nT
real(kind=wp) :: Backup_ExFac, CPU1, CPU2, Dummy(1), ERFSelf, TCF2, TCF2_1, Tim1, Tim2, Tim3, Tmp, TWF2, TWF2_1, XCPM, XCPM1, &
                 XCPM2, XWPM, XwPM1, XwPM2
logical(kind=iwp) :: Do_DFT, Do_ESPF, First = .true., Found, ltmp1, ltmp2, NonEq
real(kind=wp), allocatable :: D(:), DnsS(:,:), RFfld(:), Saved(:,:), tVxc(:,:)
real(kind=wp), allocatable, target :: Aux(:,:), Temp(:,:)
real(kind=wp), pointer :: pTwoHam(:,:)
real(kind=wp), external :: DDot_
logical(kind=iwp), external :: EFP_On

if (PmTime) call CWTime(xCPM1,xWPM1)
call Timing(Cpu1,Tim1,Tim2,Tim3)
#ifdef _DEBUGPRINT_
call NrmClc(TwoHam(1,1,iPsLst),nBT*nD,'PMat: Enter','T in iPsLst')
call NrmClc(TwoHam(1,1,nDens),nBT*nD,'PMat: Enter','T in nDens')
call NrmClc(Vxc(1,1,iPsLst),nBT*nD,'PMat: Enter','V in iPsLst')
call NrmClc(Vxc(1,1,nDens),nBT*nD,'PMat: Enter','V in nDens')
#endif

! Copy the (abs.) value of the Max Offdiag Fmat to a Common Block
! Used in the LK Cholesky algorithm
dFKmat = abs(FMOmax)

! Add contribution due to external potential

TwoHam(:,:,iPsLst) = Zero
iSpin = 1
if (nD == 2) iSpin = 2
call Put_iScalar('Multiplicity',iSpin)
!                                                                      *
!***********************************************************************
!                                                                      *
call DecideOnESPF(Do_ESPF)
if (Do_ESPF .or. lRF .or. (KSDFT /= 'SCF') .or. Do_OFemb .or. EFP_On()) then

  ! Observe that this call always has to be prior to the calls
  ! to Drv2El_dScf and/or FTwoa. This since DrvXV will redefine
  ! ExFac!!!!!

  ! Note, the linear (Oneham) and bilinear (TwoHam) contributions
  ! can be computed with partial densities, as supplied with the
  ! arguments to the routine. For the DFT contributions, however,
  ! not being linear or bilinears, the total density is read from
  ! the runfile (as put there by dmat).

  iCharge = int(Tot_Charge)
  NonEq = .false.
  Do_DFT = .true.
  iDumm = 1
  ltmp1 = iter == 1
  ltmp2 = iter /= 1
  if (nD == 1) then
    call DrvXV(OneHam,TwoHam(:,1,iPsLst),Dens(:,1,iPsLst),PotNuc,nBT,ltmp1,ltmp2,NonEq,lRF,KSDFT,ExFac,iCharge,iSpin,'SCF ',Do_DFT)
  else
    call mma_allocate(D,nBT,Label='D')
    D(:) = Dens(:,1,iPsLst)+Dens(:,2,iPsLst)
    call DrvXV(OneHam,TwoHam(:,1,iPsLst),D,PotNuc,nBT,ltmp1,ltmp2,NonEq,lRF,KSDFT,ExFac,iCharge,iSpin,'SCF ',Do_DFT)
    call mma_deallocate(D)
    TwoHam(:,2,iPsLst) = TwoHam(:,1,iPsLst)
    if ((MxConstr > 0) .and. (klockan == 1)) then
      call SetUp_iSD()
      call Get_Enondyn_dft(nBT,Dummy,iDumm,'SCF ')
      call Free_iSD()
      klockan = 24
    end if
  end if

  ! Pick up the integrated energy contribution of the external
  ! potential to the total energy.

  call Peek_dScalar('KSDFT energy',EDFT(iter))

  ! Pick up the contribution to the Fock matrix due to the
  ! external field. Note that for some external field the
  ! potential is neither linear nor bi-linear.

  if (KSDFT /= 'SCF') then
    call Get_dArray_chk('dExcdRa',Vxc(:,:,iPsLst),nBT*nD)
  else
    Vxc(:,:,iPsLst) = Zero
  end if

  if (Do_OFemb) then
    call NameRun('AUXRFIL') ! switch the RUNFILE name
    call mma_allocate(tVxc,nBT,nD,Label='tVxc')
    call Get_dArray_chk('dExcdRa',tVxc,nBT*nD)
    Vxc(:,:,iPsLst) = Vxc(:,:,iPsLst)+tVxc(:,:)
    call mma_deallocate(tVxc)
    call NameRun('#Pop')    ! switch back RUNFILE name
  end if
# ifdef _DEBUGPRINT_
  call NrmClc(Vxc(:,:,iPsLst),nBT*nD,'PMat','Optimal V ')
# endif

else if (RFpert .and. First) then

  if (nD == 2) then
    write(u6,*) ' UHF+RF: Not implemented'
    call Abend()
  end if
  call mma_allocate(RFfld,nBT,Label='RFfld')
  call f_Inquire('RUNOLD',Found)
  if (Found) call NameRun('RUNOLD')
  call Get_dScalar('RF Self Energy',ERFself)
  call Get_dArray('Reaction field',RFfld,nBT)
  if (Found) call NameRun('#Pop')
  PotNuc = PotNuc+ERFself
  OneHam(:) = OneHam(:)+RFfld(:)
  do iD=1,nD
    FockAO(:,iD) = OneHam(:)
  end do
  call mma_deallocate(RFfld)

else

  Vxc(:,:,iPsLst) = Zero

end if
!                                                                      *
!***********************************************************************
!                                                                      *
First = .false.

! Compute the two-electron contribution to the Fock matrix

Backup_ExFac = ExFac
if (NoExchange) ExFac = Zero

nT = 1+(nD-1)*2

call mma_allocate(Temp,nBT,nT,Label='Temp')
Temp(:,:) = Zero

if (PmTime) call CWTime(tCF2,tWF2)

if (DSCF .and. (.not. Do_DCCD)) then

  call Drv2El_dscf_Front_End(Temp)

else   ! RICD/Cholesky option

  ! Allocate memory for squared density matrix
  call mma_allocate(DnsS,nBB,nD,Label='DnsS')

  ! Expand the 1-density matrix
  do iD=1,nD
    call Unfold(Dens(1,iD,iPsLst),nBT,DnsS(1,iD),nBB,nSym,nBas)
  end do

  call FockTwo_Drv_scf(nSym,nBas,nBas,nSkip,Dens(:,:,iPsLst),DnsS,Temp,nBT,ExFac,nBB,MaxBas,nD,nOcc,size(nOcc,1),iDummy_run)

  if (Do_DCCD) then
    call mma_Allocate(Saved,size(Temp,1),size(Temp,2),Label='Saved')

    Saved(:,:) = Zero
    call Drv2El_dscf_Front_End(Saved)
    Temp(:,:) = Temp(:,:)+Saved(:,:)

    Algo_save = Algo
    Algo = 0
    Saved(:,:) = Zero
    call FockTwo_Drv_scf(nSym,nBas,nBas,nSkip,Dens(:,:,iPsLst),DnsS,Saved,nBT,ExFac,nBB,MaxBas,nD,nOcc,size(nOcc,1),iDummy_run)
    Temp(:,:) = Temp(:,:)-Saved(:,:)
    Algo = Algo_save
    call mma_deAllocate(Saved)
  end if

  ! Deallocate memory for squared density matrix
  call mma_deallocate(DnsS)

end if

if (PmTime) then
  call CWTime(tCF2_1,tWF2_1)
  tCF2 = tCF2_1-tCF2
  tWF2 = tWF2_1-tWF2
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Add on FMM contributions to Fock matrix, only works for HF

if (DoFMM) call FMMFck(Dens(1,1,iPsLst),Temp(1,1),nDens)
!                                                                      *
!***********************************************************************
!                                                                      *
TwoHam(:,:,iPsLst) = TwoHam(:,:,iPsLst)+Temp(:,1:nD)
#ifdef _DEBUGPRINT_
call NrmClc(Temp,nBT*nD,'PMat_SCF','Temp')
call NrmClc(TwoHam(:,:,iPsLst),nBT*nD,'PMat_SCF','T in iPsLst')
#endif
call mma_deallocate(Temp)

!                                                                      *
!***********************************************************************
!                                                                      *
! Now compute the total two-electron contribution

! Generate the two-electron contribution corresponding to the total
! density.

if (MiniDn .and. (max(0,nIter(nIterP)-1) > 0)) then

  ! Minimized density option
  !
  ! D(k+1) = Sum_i_k C_i D_i + delta(k+1)
  !
  ! G(D(k+1)) = G(delta(k+1)) + Sum_i_k C_i G(D_i)

  call mma_allocate(Aux,nBT,nD,Label='Aux')
  do iMat=1,iter-1

    tmp = sum(abs(XCf(iMat,:)))
    if (tmp == Zero) cycle

    iM = MapDns(iMat)
    if (iM < 0) then
      call RWDTG(-iM,Aux,nBT*nD,'R','TWOHAM',iDisk,size(iDisk,1))
      pTwoHam => Aux
    else
      pTwoHam => TwoHam(:,:,iM)
    end if

    do iD=1,nD
      if (Xcf(iMat,iD) == Zero) cycle
      TwoHam(:,iD,iPsLst) = TwoHam(:,iD,iPsLst)+Xcf(iMat,iD)*pTwoHam(:,iD)
    end do

    nullify(pTwoHam)

  end do
  call mma_deallocate(Aux)

else if (.not. DDnOFF) then

  ! Normal density difference
  !
  ! G(D(k+1)) = G(D(k)) + G(D(k+1)-D(k))

  TwoHam(:,:,iPsLst) = TwoHam(:,:,iPsLst)+TwoHam(:,:,nDens)

end if

! Restore the total density in position iPsLst

Dens(:,:,iPsLst) = Dens(:,:,nDens)
TwoHam(:,:,nDens) = TwoHam(:,:,iPsLst)
Vxc(:,:,nDens) = Vxc(:,:,iPsLst)

! Restore ExFac (if it was changed)
if (NoExchange) ExFac = Backup_ExFac
!                                                                      *
!***********************************************************************
!                                                                      *
TNorm = DDot_(nBT*nD,TwoHam(1,1,iPsLst),1,TwoHam(1,1,iPsLst),1)/real(nD,kind=wp)

#ifdef _DEBUGPRINT_
call NrmClc(Dens(1,1,iPsLst),nBT*nD,'PMat  ','D iPsLst  ')
call NrmClc(Dens(1,1,nDens),nBT*nD,'PMat  ','D nDens   ')
call NrmClc(TwoHam(1,1,iPsLst),nBT*nD,'PMat  ','T iPsLst  ')
call NrmClc(TwoHam(1,1,nDens),nBT*nD,'PMat  ','T nDens   ')
call NrmClc(Vxc(1,1,iPsLst),nBT*nD,'PMat  ','V iPsLst  ')
call NrmClc(Vxc(1,1,nDens),nBT*nD,'PMat  ','V nDens   ')

#endif
call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(5) = TimFld(5)+(Cpu2-Cpu1)
if (PmTime) then
  call CWTime(xCPM2,xWPM2)
  xCPM = xCPM2-xCPM1
  xWPM = xWPM2-xWPM1
  write(u6,'(1X,A,F15.2,A,F15.2,A,/,1X,A,F15.2,A,F15.2,A)') '>>> PMat_SCF: CPU  time:',xCPM,' seconds  (2-el contributions: ', &
                                                            tCF2,' seconds) <<<','>>> PMat_SCF: Wall time:',xWPM, &
                                                            ' seconds  (2-el contributions: ',tWF2,' seconds) <<<'
  call xFlush(u6)
end if

contains

subroutine Drv2El_dscf_Front_End(Tmp)

  real(kind=wp) :: Tmp(:,:)

  ! while the Drv2El_dscf can't handle UHF in a trivial way this interface has
  ! to be used.

  ExFac_Int = ExFac
  Thize_Int = Thize
  PreSch_Int = PreSch
  FckNoClmb = .false.
  if (size(Tmp,2) == 1) then
    call Drv2El_dscf(Dens(:,1,iPsLst),Tmp(:,1),nBT,0,FstItr)
  else

    ! Compute the Coulomb potential for the total density and
    ! exchange of alpha and beta, respectively. Add together
    ! to get the correct contributions to the alpha and beta
    ! Fock matrices.

    ! Set exchange factor to zero and compute only Coulomb
    ! for the total electron density.

    Tmp(:,2) = Dens(:,1,iPsLst)+Dens(:,2,iPsLst)

    ExFac_Int = Zero
    call Drv2El_dscf(Tmp(:,2),Tmp(:,3),nBT,max(nDisc*1024,nCore),FstItr)

    ! alpha exchange
    FckNoClmb = .true.
    Tmp(:,2) = Zero
    ExFac_Int = ExFac
    call Drv2El_dscf(Dens(:,1,iPsLst),Tmp(:,1),nBT,max(nDisc*1024,nCore),FstItr)
    Tmp(:,1) = Two*Tmp(:,1)

    ! beta exchange
    ExFac_Int = ExFac
    call Drv2El_dscf(Dens(:,2,iPsLst),Tmp(:,2),nBT,max(nDisc*1024,nCore),FstItr)
    Tmp(:,2) = Two*Tmp(:,2)

    ! Add together J and K contributions to form the correct
    ! alpha and beta Fock matrices.

    Tmp(:,1) = Tmp(:,1)+Tmp(:,3)
    Tmp(:,2) = Tmp(:,2)+Tmp(:,3)
  end if

end subroutine Drv2El_dscf_Front_End

end subroutine PMat_SCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine PMLTSCA(KOD,IMLTOP,LST1,LST2,X,NXI,NXA,F,NFI,NFA,lg_Y,NAS2,NIS2)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
#endif
use Sigma_data, only: NLST1, NLST2
use fake_GA, only: GA_Arrays
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: KOD, IMLTOP, LST1(4,NLST1), LST2(4,NLST2), NXI, NXA, NFI, NFA, lg_Y, NAS2, NIS2
real(kind=wp), intent(inout) :: X(NXI,NXA), F(NFI,NFA)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iYHi, iYLo, jYHi, jYLo, LDY, mY, myRank

! SVC: Determine the index ranges of the local chunks of lg_Y.
! The boundaries and leading dimension are stored in a common block for
! access inside the lower-level routines.
! For now, only case H is handled as a distributed array, which is
! always the Y array.
if (Is_Real_Par()) then
  call GA_Sync()
  myRank = GA_NodeID()
  !call GA_Distribution(lg_X,myRank,iXLo,iXHi,jXLo,jXHi)
  !if ((iXLo /= 0) .and. (jXLo /= 0)) call GA_Access(lg_X,iXLo,iXHi,jXLo,jXHi,mX,LDX)
  call GA_Distribution(lg_Y,myRank,iYLo,iYHi,jYLo,jYHi)
  if ((iYLo /= 0) .and. (jYLo /= 0)) then
    call GA_Access(lg_Y,iYLo,iYHi,jYLo,jYHi,mY,LDY)
    if ((KOD == 23) .or. (KOD == 24)) then
      call MLTSCA_DH(IMLTOP,LST1,LST2,X,NXI,NXA,F,NFI,NFA,DBL_MB(mY),NAS2,jYLo,jYHi)
    else
      write(u6,*) 'PMLTSCA: not supposed to be here'
      call AbEnd()
    end if
    call GA_Release_Update(lg_Y,iYLo,iYHi,jYLo,jYHi)
  end if
  call GA_Sync()
else
#endif
  if ((KOD == 23) .or. (KOD == 24)) then
    call MLTSCA_DH(IMLTOP,LST1,LST2,X,NXI,NXA,F,NFI,NFA,GA_Arrays(lg_Y)%A,NAS2,1,NIS2)
  else
    write(u6,*) 'PMLTSCA: not supposed to be here'
    call AbEnd()
  end if
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine PMLTSCA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DONEI(DLT,DSQ,CMO)

#include "intent.fh"

use motra_global, only: Debug, iPrint, nBas, nFro, nSym
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(_OUT_) :: DLT(*), DSQ(*)
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp) :: IB, IJ, ISTLT, ISTSQ, ISYM, JB, NB, NF

ISTSQ = 0
ISTLT = 0
do ISYM=1,NSYM
  NF = NFRO(ISYM)
  NB = NBAS(ISYM)
  if (NB*NF > 0) call DGEMM_('N','T',NB,NB,NF,One,CMO(ISTSQ+1),NB,CMO(ISTSQ+1),NB,Zero,DSQ(ISTSQ+1),NB)
  call DSCAL_(NB*NB,Two,DSQ(ISTSQ+1),1)
  IJ = ISTLT
  do IB=1,NB
    do JB=1,IB
      IJ = IJ+1
      DLT(IJ) = Two*DSQ(ISTSQ+JB+(IB-1)*NB)
    end do
    DLT(IJ) = Half*DLT(IJ)
  end do
  ISTSQ = ISTSQ+NB*NB
  ISTLT = ISTLT+NB*(NB+1)/2
end do

if ((IPRINT >= 5) .or. (DEBUG /= 0)) then
  write(u6,'(6X,A)') 'Frozen one-body density matrix in AO basis'
  ISTLT = 1
  do ISYM=1,NSYM
    NB = NBAS(ISYM)
    if (NB > 0) then
      write(u6,'(6X,A,I2)') 'symmetry species:',ISYM
      call TRIPRT(' ',' ',DLT(ISTLT),NB)
      ISTLT = ISTLT+NB*(NB+1)/2
    end if
  end do
end if

return

end subroutine DONEI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  XHole
*
*> @brief
*>   Prepare the kernel for the exchange-hole dipole
*> @author A. Ohrn
*>
*> @details
*> At this moment only for RHF. Collect number of occupied orbitals. Then
*> construct the kernel. Since orbital pair dipoles are triangular, the
*> matrix is unfolded by a factor two for non-diagonal elements. For
*> small values of the density, the exchange hole dipole grid value is
*> set to zero; this is okey since it will only be roughly of size 100,
*> which becomes as good as zero when later multiplied by the density.
*> See \cite Bec2005-JCP-122-154104 for details.
*>
*> @param[in]  nRho      Should equal one, since no derivatives
*> @param[in]  mGrid     Number of grid-points
*> @param[in]  Rho       The density in the grid-points
*> @param[in]  Grid      The coordinates of the grid-points
*> @param[in]  mAO       Should equal one, since no derivatives
*> @param[in]  nMOs      Total number of molecular orbitals
*> @param[in]  TabMO     The orbitals in the grid-points
*> @param[in]  ndF_dRho  Should equal one
*> @param[in]  nD        Should equal one
*> @param[out] dF_dRho   The value of the kernel. This is used as input later to compute the actual matrix elements,
*>                       but we do so by fooling the program to believe that it is the derivate of the functional
*>                       with respect to density
*> @param[in]  Weights   Quadrature weights
*> @param[in]  ip_OrbDip Dipole moments computed by LoProp routine
*> @param[out] Func      The expectation value of the kernel
************************************************************************
#ifdef _NOT_USED_OR_TESTED_
      Subroutine XHole(nRho,mGrid,Rho,Grid,mAO,nMOs,TabMO,ndF_dRho,nD,
     &                 dF_dRho,Weights,ip_OrbDip,Func)
      Implicit Real*8 (a-h,o-z)

#include "real.fh"
#include "nq_index.fh"
#include "WrkSpc.fh"

      Real*8 Rho(nRho,mGrid),Grid(3,mGrid),Weights(mGrid)
      Real*8 TabMO(mAO,mGrid,nMOs)
      Real*8 dF_dRho(ndF_dRho,mGrid)
      Real*8 dx(3)
      Integer nOcc(1),ip_OrbDip(3)

*
*-- Some crazy consistency tests.
*
      If(nRho.ne.1.or.nD.ne.1.or.mAO.ne.1) then
        Call WarningMessage(2,
     &            'How did you manage this! nRho, nD or mAO is not '
     &          //'equal to one in Do_XHole!')
        Call Abend()
      Endif

*
*-- Some numbers.
*
      Call Get_iArray('nIsh',nOcc,1)
      nOccMO=nOcc(1)

*
*-- Now evaluate dx**2. Put it in dF_dRho for later processing.
*
      Do iGrid=1,mGrid
        If(Rho(1,iGrid).gt.1d-14) then
          Do k=1,3
            kaunter=0
            SumOrb=Zero
            Do iMO=1,nOccMO
              Do jMO=1,iMO
                kaunter=kaunter+1
                dUnfoldToSq=One
                If(iMO.ne.jMO) dUnfoldToSq=Two
                dMOPr=dUnfoldToSq*TabMO(1,iGrid,iMO)*TabMO(1,iGrid,jMO)
                SumOrb=SumOrb+Two*Work(ip_OrbDip(k)+kaunter-1)*dMOPr
              Enddo
            Enddo
            dx(k)=(One/(Rho(1,iGrid)))*SumOrb-Grid(k,iGrid)
          Enddo
        Else
          Do k=1,3
            dx(k)=Zero
          Enddo
        Endif
        dSquare=dx(1)**2+dx(2)**2+dx(3)**2
        dF_dRho(ipR,iGrid)=dSquare
        Func=Func+Weights(iGrid)*dSquare*Rho(1,iGrid)
      Enddo

      Return
      End
#else
      Subroutine XHole()
      End
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Andrew M. Sand                                   *
*                                                                      *
************************************************************************
      SubRoutine WfCtl_pdft(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,
     &                    iRHSDisp,converged,iPL)
************************************************************************
*                                                                      *
*                                                                      *
*     called from: MCLR                                                *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
************************************************************************
      use Exp, Only: Exp_Close
      use ipPage, only: W
      use PDFT_Util, only: Do_Hybrid, WF_Ratio,PDFT_Ratio
      Implicit Real*8 (a-h,o-z)
*
#include "stdalloc.fh"

#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "dmrginfo_mclr.fh"

      Logical CI
#include "crun_mclr.fh"
      Character*8   Fmt2
      Integer iKapDisp(nDisp),isigDisp(nDisp)
      Integer iRHSDisp(nDisp)
      Integer iCIDisp(nDisp),iCIsigDisp(nDisp)
      Integer opOut
*      Integer nacpar,nacpr2
      Logical lPrint,converged(8)
      Real*8 rchc(mxroot)
      Real*8 rDum(1)

      External IsFreeUnit
      Real*8, Allocatable:: FOSq(:), FOTr(:)
      Real*8, Allocatable:: Kappa(:), dKappa(:), Sigma(:),
     &                      Temp4(:), Sc1(:), Sc2(:), Fancy(:),
     &                      FMO1t(:), FMO1(:), FMO2t(:),
     &                      FT99(:), Temp5(:)
      Real*8, Allocatable:: lmroots(:), lmroots_new(:), Kap_New(:),
     &                      Kap_New_Temp(:)
      Real*8, Allocatable:: WFOrb(:),P2WF(:),P2PDFT(:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
       SubRoutine CISigma_sa(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,
     &                       Int2a,nInt2a,ipCI1,ipCI2, Have_2_el)
       Integer iispin, iCsym, iSSym
       Integer nInt1, nInt2s, nInt2a
       Real*8, Target:: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
       Integer ipCI1, ipCI2
       Logical Have_2_el
       End SubRoutine CISigma_sa
      End Interface
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
      Call StatusLine(' MCLR:',
     &                ' Computing Lagrangian multipliers for MC-PDFT')
*

      lPaper=132
      lLine =120
      left=(lPaper-lLine)/2
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
*----------------------------------------------------------------------*

      iDis=0

      fail=.false.
      Converged(:)=.true.
*MGD I think this is nice when printed...
      lprint=.true.
      debug=.false.
      reco=-One
      Lu_50=50
      If (SAVE) CALL DANAME(Lu_50,'RESIDUALS')
      If (SAVE) Then
         Write (6,*) 'WfCtl_SA: SAVE option not implemented'
         Call Abend()
      End If
      If (iAnd(kprint,2).eq.2) lprint=.true.
      isym=1
      nconf1=ncsf(State_Sym)

      CI=.false.
      If (iMethod.eq.2.and.nconf1.gt.0) CI=.true.

*          Initiate CSF <-> SD
           Call InCSFSD(iEor(iSym-1,State_Sym-1)+1,
     &                  State_sym,.false.)
*
*
*          Calculate length of the density, Fock and Kappa matrix etc
*          notice that this matrices are not necessarily symmetric.
*          Store pointers.
*
*          Input:
*                 iSym: Symmetry of perturbation
*
*          Output: Commonblocks (Pointers.fh)
*
      nConf3=nint(Max(xispsm(State_SYM,1),xispsm(State_SYM,1)))

      Call Setup_MCLR(iSym)

*
*     Determine if we should page CI vectors
*                                [2]
*     Calculate the diagonal of E    and store in core/disc
*
      Call mma_allocate(Fancy,nRoots**3,Label='Fancy')
!____________________
!AMS - what to do here?
! What should rCHC be?  is it computed with E(mcscf) or E(pdft)?

!____________________
      Call CIDia_SA(State_Sym,rCHC,Fancy)
      irc=ipOut(ipdia)


*     Allocate disk/memory space
*
*
*     This areas should be addressed through ipIn
*     ipOut will page them out to disk and free the memory area
*     if page mode is used
*
*     opOut will release the memory area without update the disk
*
      ipS1 =ipGet(nconf3*nroots)
      ipS2 =ipGet(nconf3*nroots)
      ipST =ipGet(nconf3*nroots)
      ipCIT=ipGet(nconf1*nroots)
      ipCID=ipGet(nconf1*nroots)

*

      npre2=npre(isym)
      ipPre2=ipGet(npre2)

      irc=ipIn(ipPre2)
      Call Prec(W(ipPre2)%Vec,isym)
      irc=ipOut(ippre2)

*
*     OK START WORKING
*
*     idisp=1
      jspin=0
*
*     Allocate areas for scratch and state variables
*
      Call mma_allocate(Kappa,nDens2+6,Label='Kappa')
      Call mma_allocate(dKappa,nDens2+6,Label='dKappa')
      Call mma_allocate(Sigma,nDens2+6,Label='Sigma')
      Call mma_allocate(Temp4,nDens2+6,Label='Temp4')
      Call mma_allocate(Sc1,nDens2+6,Label='Sc1')
      Call mma_allocate(Sc2,nDens2+6,Label='Sc2')

*
      !I think the lagrange multiplers are independent of the
      !displacement, no?
      nDisp = 1
      do iDisp=1,nDisp
      Kappa(1:nDens2)=Zero
      dKappa(1:nDens2)=Zero
      Sigma(1:nDens2)=Zero
*
*-----------------------------------------------------------------------------
*
*     Calculate RHS for the perturbation
*
*-----------------------------------------------------------------------------
*
*     (T1,T2,T3,T4,T5,T6,T7,Kappa1,CI1)
*
      If (debug) Then
         If (isNAC) Then
            Write(6,*)'States: ',NACstates(1),NACstates(2)
         Else
            Write(6,*)'State: ',irlxroot
         EndIf
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
!AMS - I Think I can skip all of this RHS stuff - I'll read it in
!below.
!      If (isNAC) Then
!        Call RHS_NAC(Temp4)
!      Else
!        Call RHS_SA(Temp4)
!        goto 538
!      End If
*
!AMS _____________________________________________________
!Read in the Fock operator for the calculation of the CI part of the RHS
!ipF1 and ipF2.
      LUTMP=87
      Call Molcas_Open(LUTMP,'TmpFock')
      nTri = 0
      nOrbAct = 0
      do ksym=1,nsym
        nTri = nTri + nBas(ksym)*(nBas(ksym)+1)/2
        nOrbAct = nOrbAct + nAsh(ksym)
      end do
      nacpar = nOrbAct*(nOrbAct+1)/2
      Call mma_allocate(FMO1t,nTri,Label='FMO1t')
      Call mma_allocate(FMO1,nDens2,Label='FMO1')
      nacpar=(nnA+1)*nnA/2
      nacpr2=(nacpar+1)*nacpar/2
      Call mma_allocate(FMO2t,nacpr2,Label='FMO2t')
      do i=1,nTri
        read(LUTMP,*) FMO1t(i)
      end do

      ioff = 0
      do iS=1,nSym
        jS=iS
        If (nBas(is)*nBas(jS).ne.0) then
          if(iS.eq.jS) then
            do i=1,nBas(iS)
              do j=1,i
               ioff = ioff+1
               ji= ipMat(is,js)-1 +(i-1)*nbas(iS)+j
               FMO1(ji) = FMO1t(ioff)
               if (i.ne.j) then
                  ij= ipMat(is,js)-1 +(j-1)*nbas(iS)+i
                  FMO1(ij) = FMO1t(ioff)
               end if
              end do
            end do
          else
            do i=1,nBas(iS)
              do j=1,nBas(jS)
              ioff = ioff+1
              ji= ipMat(is,js)-1 +(i-1)*nbas(iSym)+j
              FMO1(ji) = FMO1t(ioff)
              end do
            end do
          end if
        End if
      end do



      do i=1,nacpr2
        read(LUTMP,*) FMO2t(i)
      end do
      Close(LUTMP)

      Call CISigma_sa(0,State_sym,State_sym,FMO1,nDens2,FMO2t,
     &                SIZE(FMO2t),rdum,1,ipci,ipST,.True.)
      Call mma_deallocate(FMO2t)

      troot = (irlxroot - 1)
      irc=ipin(ipST)
      irc=ipin(ipCI)
      Do i=0,nroots-1
        if (i.eq.troot) then
          Call Dscal_(nconf1,(1/weight(i+1)),W(ipST)%Vec(1+i*nconf1),1)
          rE=ddot_(nconf1,W(ipST)%Vec(1+i*nconf1),1,
     &                    W(ipCI)%Vec(1+i*nconf1),1)
          Call Daxpy_(nconf1,-rE,W(ipCI)%Vec(1+i*nconf1),1,
     &                           W(ipST)%Vec(1+i*nconf1),1)

        else
        call dcopy_(nConf1,[Zero],0,W(ipst)%Vec(1+i*nconf1),1)
        end if
      Enddo

      Call DSCAL_(nconf1*nroots,-2.0d0,W(ipST)%Vec,1)

      IF(Do_Hybrid) THEN
*scaling the CI resp. for PDFT part in HMC-PDFT
       CALL DScal_(nconf1*nroots,PDFT_Ratio,W(ipST)%Vec,1)
      END IF

      if (debug) then
      write(6,*) 'RHS CI part:'
      do iS=1,nconf1*nroots
        write(6,*) W(ipST)%Vec(iS)
      end do
      end if

      Call mma_deallocate(FMO1t)
      Call mma_deallocate(FMO1)

!Get the fock matrix needed for the determination of the orbital part of
!the RHS.

      Call mma_allocate(FT99,nDens2,Label='FT99')
      Call mma_allocate(Temp5,nDens2+6,Label='Temp5')
      FT99(:)=Zero
      Temp5(:)=Zero
      Call get_dArray('Fock_PDFT',FT99,nDens2)
      Do iS=1,nSym
         jS=iEOR(iS-1,0)+1
         If (nBas(is)*nBas(jS).ne.0) then
           Call DGeSub(FT99(ipMat(iS,jS)),nBas(iS),'N',
     &                 FT99(ipMat(jS,iS)),nBas(jS),'T',
     &                 Temp5(ipMat(iS,jS)),nBas(iS),
     &                 nBas(iS),nBas(jS))
         End If
      End Do
      Call dcopy_(nDens2+6,Temp5,1,Temp4,1)
      Call DSCAL_(ndens2+6,-Two,Temp4,1)

      Call mma_deallocate(FT99)
      Call mma_deallocate(Temp5)
      IF(Do_Hybrid) THEN
*scaling the orb resp. for PDFT part in HMC-PDFT
       Call DSCAL_(ndens2,PDFT_Ratio,Temp4,1)
*calculating the orb resp. for WF part in HMC-PDFT
       CALL mma_allocate(WForb,nDens2+6,Label='WForb')
*saving Fock matrix for PDFT part in HMC-PDFT
       Call mma_allocate(FOTr,nTri  ,Label='FOTr')
       Call Get_Fock_Occ(FOTr,nTri)
*      note that the Fock matrix will be overwritten with the wf one
*      ini rhs_sa
       CALL rhs_sa(WForb)
       CALL dAXpY_(nDens2,WF_Ratio,WForb,1,Temp4,1)
       call mma_deallocate(WForb)
      END IF

      if (debug) then
      write(6,*) 'RHS orb part:'
      do iS=1,nDens2
        write(6,*) Temp4(iS)
      end do
      end if


!Also, along with this RHS stuff, the Fock_occ array already stored on
!the runfile needs to be replaced - switch triangular storage to square
!storage:
!
      IF(Do_Hybrid) THEN
       ng1=(ntash+1)*ntash/2
       ng2=(ng1+1)*ng1/2
       Call mma_allocate(FOSq,nDens2,Label='FOSq')
       CALL Get_Fock_Occ(FOsq,nDens2)

*scaling fock for wf part
       CALL DScal_(nTri,WF_Ratio,FOsq,1)

*adding fock for pdft part
       call daxpy_(ntri,pdft_ratio,fotr,1,fosq,1)

       CALL mma_allocate(P2PDFT,nG2 ,Label='P2PDFT')
       CALL mma_allocate(P2WF  ,nG2 ,Label='P2WF')

       CALL Get_P2MOt(P2PDFT,nG2)
*scaling P2 for pdft part'
       CALL DScal_(nG2,PDFT_Ratio,P2PDFT,1)

       CALL Get_P2MO(P2WF,nG2)
*adding P2 for wf part'
       call daxpy_(ng2,wf_ratio,P2WF,1,P2PDFT,1)

       CALL Put_P2MOt(P2PDFT,nG2)

       Call Put_Fock_Occ(FOSq,ndens2)

       Call mma_deallocate(FOSq)
       Call mma_deallocate(FOTr)
       Call mma_deallocate(P2PDFT)
       Call mma_deallocate(P2WF)

      ELSE
       Call mma_allocate(FOSq,nDens2,Label='FOSq')
       Call mma_allocate(FOTr,nTri  ,Label='FOTr')
       FOSq(:)=Zero
       Call Get_Fock_Occ(FOTr,nTri)
       Call dcopy_(nTri,FOtr,1,FOSq,1)
       Call Put_Fock_Occ(FOSq,ndens2)

       Call mma_deallocate(FOSq)
       Call mma_deallocate(FOTr)
      END IF


!This seems to calculate the RHS, at least for the orbital part.
!Now, my sigma_0 should be given by
!(RHS) - A*Kappa, where Kappa is my initial guess at the solution, x_0.
!So, should I be running a "TimesE2"-like subroutine here, to do the
!A*Kappa multiplication, before we go on to multiply things by the
!preconditioner inverse?
!___________________________________________________________

      irc=opOut(ipci)
*
      If (lprint) Write(6,*)
     &      '       Iteration       Delta       Res(kappa)  Res(CI)'
     &    //'     DeltaK      DeltaC'
      iLen=nDensC
      iRHSDisp(iDisp)=iDis
      do iS=1,nDens2
      end do
      Call Compress(Temp4,Sigma,iSym)
      r1=ddot_(nDensc,Sigma,1,Sigma,1)
      If(debug)Write(6,*) 'Hi how about r1',r1
      Call dDaFile(LuTemp,1,Sigma,iLen,iDis)

      irc=ipIn(ipCIT)
      call dcopy_(nConf1*nroots,[Zero],0,W(ipCIT)%Vec,1)
      irc=ipIn(ipCID)
      call dcopy_(nConf1*nroots,[Zero],0,W(ipCID)%Vec,1)
      irc=ipOut(ipCIT)
      Call DSCAL_(nDensC,-One,Sigma,1)
*
*
*
*
      deltaC=Zero
!AMS _________________________________________________________
!I need to read in the CI portion of the RHS here.
      If (CI) Then
         irc=ipIn(ipS2)
         Call DMinvCI_sa(ipST,W(ipS2)%Vec,rdum(1),isym,Fancy)
      End If
      irc=ipin(ipST)
      irc=ipin(ipCId)
      Call dcopy_(nconf1*nroots,W(ipST)%Vec,1,W(ipCId)%Vec,1)
********************
*TRS
       Call mma_allocate(lmroots,nroots,Label='lmroots')
       Call mma_allocate(lmroots_new,nroots,Label='lmroots_new')
       Call mma_allocate(kap_new,ndensc,Label='kap_new')
       Call mma_allocate(kap_new_temp,ndens,Label='kap_new_temp')
*
      Kap_New(:)=Zero
      Kap_New_Temp(:)=Zero
*
      irc=ipin(ipCI)
      Call DgeMV_('T', nconf1, nroots, One, W(ipCI)%Vec,
     &            nconf1,W(ipCId)%Vec(1+(irlxroot-1)*nconf1),
     &            1,Zero,lmroots,1)
*SA-SA rotations w/in SA space in eigen state basis
      if(debug) Call recprt('lmroots',' ',lmroots,1,nroots)
*SA-SA rotations w/in SA space in CSF basis
        call dgemv_('N', nconf1, nroots, One, W(ipCI)%Vec,
     &              nconf1, lmroots,1,Zero,
     &              W(ipCId)%Vec(1+(irlxroot-1)*nconf1),1)
*SA-SA rotations w/in SA space for new lagrange multipliers
       do i=1, nroots
          if (i.eq.irlxroot) then
             lmroots_new(i)=Zero
          else
             diff=(ERASSCF(i)-ERASSCF(irlxroot))
             if(debug) write(6,*) 'diff',diff
             wscale = (One/(Two*diff))*(One/weight(i))
             if(debug) write(6,*)'wscale',wscale
             if(debug) write(6,*) 'weight', weight(i)
             lmroots_new(i)= wscale*lmroots(i)
          end if
       end do
*
      if(debug) Call recprt('lmroots_new',' ',lmroots_new,1,nroots)
*SA-SA rotations w/in SA space for new lagrange multipliers in csf basis
        call dgemv_('N', nconf1, nroots, One, W(ipCI)%Vec,
     &              nconf1, lmroots_new,1,Zero,
     &              W(ipcid)%Vec(1+(irlxroot-1)*nconf1),1)
*
*First iter of PCG
          Call TimesE2_(kap_new,ipCId,1,reco,jspin,ipS2,
     &                  kap_new_temp,ipS1)
*
        Call DgeMV_('T', nconf1, nroots, One, W(ipCI)%Vec,
     &              nconf1,W(ipST)%Vec(1+(irlxroot-1)*nconf1),
     &              1,Zero,lmroots,1)
*
       if (debug) then
          write(6,*) 'lmroots_ipst this should be 1lmroots'
          Call recprt('lmroots',' ',lmroots,1,nroots)
       end if
*
        irc=ipin(ipS1)
        Call DgeMV_('T', nconf1, nroots, One, W(ipCI)%Vec,
     &              nconf1,W(ipS1)%Vec(1+(irlxroot-1)*nconf1),
     &              1,Zero,lmroots,1)
*
       if (debug) then
          write(6,*) 'lmroots_ips1 this should be -lmroots'
          Call recprt('lmroots',' ',lmroots,1,nroots)
       end if
* Initializing some of the elements of the PCG
* Modifying the response
       irc=ipIn(ipS1)
       irc=ipIn(ipST)
       Call DaXpY_(nConf1*nroots,-One,W(ipS1)%Vec,1,W(ipST)%Vec,1)
*
*Kap part put into  sigma
       Call DaxPy_(nDensC,-One,kap_new_temp,1,Sigma,1)
       irc=ipIn(ipCId)
       irc=ipIn(ipCIT)
       Call DaXpY_(nConf1*nroots,1.0d0,W(ipCId)%Vec,1,W(ipCIT)%Vec,1)
*
       Call dcopy_(nconf1*nroots,W(ipST)%Vec,1,W(ipCId)%Vec,1)
*
       irc=opOut(ipci)
       irc=opOut(ipdia)
*
       irc=ipIn(ipPre2)
       Call DMInvKap(W(ipPre2)%Vec,Sigma,nDens2+6,
     &                 dKappa,nDens2+6,Sc1,nDens2+6,iSym,iter)
         irc=opOut(ippre2)
         r2=ddot_(ndensc,dKappa,1,dKappa,1)
         If (r2.gt.r1) Write(6,*) 'Warning ',
     &    ' perturbation number ',idisp,' might diverge'
*
*
       Call mma_deallocate(kap_new)
       Call mma_deallocate(kap_new_temp)
       Call mma_deallocate(lmroots_new)
*TRS
**********************
       irc=ipin(ipCI)
       irc=ipin(ipST)
       Call DgeMV_('T', nconf1, nroots, One, W(ipci)%Vec,
     &             nconf1,W(ipST)%Vec(1+(irlxroot-1)*nconf1),
     &             1,Zero,lmroots,1)
*
      if(debug) then
         write(6,*) 'lmroots_ipst this should be zero'
         Call recprt('lmroots',' ',lmroots,1,nroots)
       end if
       Call mma_deallocate(lmroots)
*
*
      If (CI) Then
        irc=ipin(ipCId)
        deltaC=ddot_(nConf1*nroots,W(ipST)%Vec,1,W(ipCId)%Vec,1)
        irc=ipout(ipcid)
      Else
        deltaC=0.0d0
      End If
!AMS_______________________________________________

      irc=ipOut(ipcid)
      deltaK=ddot_(nDensC,dKappa,1,Sigma,1)
      delta=deltac+deltaK
*         write(6,*)'deltac and deltak', deltac,deltak
      delta0=delta
      iter=1
      If (delta.eq.Zero) Goto 300
* Naming System:
* Kappa: accumulates Lagrange multiplier orbital parts (dKappa * ralpha)
* dKappa: orbital input of Hessian matrix-vector;
* Temp4: orbital output of Hessian matrix-vector
* Sigma: accumulates error vector orbital part
* ipCIT: accumulates Lagrange multiplier CI parts (ipCId * ralpha)
* ipCId: CI input of Hessian matrix-vector;
* ipS1: CI output of Hessian matrix-vector
* ipST: accumulates error vector CI part


*-----------------------------------------------------------------------------
*
200   Continue
*
         Call TimesE2_(dKappa,ipCId,1,reco,jspin,ipS2,Temp4,ipS1)
*
*-----------------------------------------------------------------------------
*
*                   delta
*        rAlpha=------------
*               dKappa:dSigma
*
*-----------------------------------------------------------------------------
*
         rAlphaK=Zero
         rAlphaK=ddot_(nDensC,Temp4,1,dKappa,1)
         rAlphaC=Zero
         irc=ipIn(ipS1)
         irc=ipIn(ipCId)
         rAlphaC=ddot_(nConf1*nroots,W(ipS1)%Vec,1,W(ipCId)%Vec,1)
*
         rAlpha=delta/(rAlphaK+rAlphaC)
*
*-------------------------------------------------------------------*
*
*        Kappa=Kappa+rAlpha*dKappa
         Call DaxPy_(nDensC,ralpha,dKappa,1,Kappa,1)
*        Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa
         Call DaxPy_(nDensC,-ralpha,Temp4,1,Sigma,1)
         resk=sqrt(ddot_(nDensC,Sigma,1,Sigma,1))
*
         resci=Zero
         irc=ipIn(ipCIT)
         Call DaXpY_(nConf1*nroots,ralpha,W(ipCId)%Vec,1,W(ipCIT)%Vec,1)
         irc=ipOut(ipCIT)
*        ipST =ipST -rAlpha*ipS1         ipST=RHS-A*ipCIT
         irc=ipIn(ipS1)
         irc=ipIn(ipST)
         Call DaXpY_(nConf1*nroots,-ralpha,W(ipS1)%Vec,1,W(ipST)%Vec,1)
         irc=opOut(ipS1)
         resci=sqrt(ddot_(nconf1*nroots,W(ipST)%Vec,1,W(ipST)%Vec,1))
*
*-------------------------------------------------------------------*
*
*        Precondition......
*           -1
*        S=M  Sigma
*
         irc=opOut(ipcid)

         irc=ipIn(ipS2)
         Call DMinvCI_SA(ipST,W(ipS2)%Vec,rdum(1),isym,Fancy)

         irc=opOut(ipci)
         irc=opOut(ipdia)
*
         irc=ipIn(ipPre2)
         Call DMInvKap(W(ipPre2)%Vec,Sigma,nDens2+6,
     &                 Sc2,nDens2+6,Sc1,nDens2+6,iSym,iter)
         irc=opOut(ippre2)
*
*
*
*-------------------------------------------------------------------*
*             s:Sigma (k+1)     s:Sigma (k+1)
*        Beta=-------        =  -------------
*              delta  (k)        s:Sigma (k)
*
*        delta=s:sigma
*
*        dKappa=s+Beta*dKappa
*
         irc=ipIn(ipST)
         irc=ipIn(ipS2)
         deltaC=ddot_(nConf1*nroots,W(ipST)%Vec,1,W(ipS2)%Vec,1)
*
*
         irc=ipOut(ipST)
*
         deltaK=ddot_(nDensC,Sigma,1,Sc2,1)
         If (.not.CI) Then
            rBeta=deltaK/delta
            delta=deltaK
            Call DScal_(nDensC,rBeta,dKappa,1)
            Call DaXpY_(nDensC,One,Sc2,1,dKappa,1)
         Else
            rbeta=(deltac+deltaK)/delta
            delta=deltac+deltaK

            irc=ipIn(ipCID)
            Call DScal_(nConf1*nroots,rBeta,W(ipCID)%Vec,1)
            Call DScal_(nDensC,rBeta,dKappa,1)
            irc=ipIn(ipS2)
            Call DaXpY_(nConf1*nroots,One,W(ipS2)%Vec,1,W(ipCID)%Vec,1)
            Call DaXpY_(nDensC,One,Sc2,1,dKappa,1)
            irc=opOut(ipS2)
            irc=ipOut(ipCID)
         End If

*    ######  #    #  #####        #####    ####    ####
*    #       ##   #  #    #       #    #  #    #  #    #
*    #####   # #  #  #    #       #    #  #       #
*    #       #  # #  #    #       #####   #       #  ###
*    #       #   ##  #    #       #       #    #  #    #
*    ######  #    #  #####        #        ####    ####
*
*-------------------------------------------------------------------*
*
*
         res=Zero ! dummy initialize
         If (iBreak.eq.1) Then
            If (abs(delta).lt.abs(Epsilon**2*delta0)) Goto 300
         Else If (iBreak.eq.2) Then
            res=sqrt(resk**2+resci**2)
            if (doDMRG) res=sqrt(resk**2)
            If (res.lt.abs(epsilon)) Goto 300
         Else
            If (abs(delta).lt.abs(Epsilon**2*delta0).and.
     &          res.lt.abs(epsilon))  Goto 300
         End If
         If (iter.ge.niter) goto 210
         If (lprint)
     &   Write(6,Fmt2//'I7,7X,F12.7,F12.7,F12.7,F12.7,F12.7)')
     &          iter,delta/delta0,resk,resci,deltac,deltak
         iter=iter+1
*
         Goto 200
*
************************************************************************
*
 210     Continue
         Write(6,Fmt2//'A,I4,A)')
     &         'No convergence for perturbation no: ',
     &          idisp,'. Increase Iter.'
         converged(isym)=.false.
         fail=.true.
         Goto 310
 300  Continue
      If (iPL.ge.2) Then
        Write(6,Fmt2//'I7,7X,F12.7,F12.7,F12.7,F12.7,F12.7)')
     &          iter,delta/delta0,resk,resci,deltac,deltak
          Write(6,Fmt2//'A,I4,A,I4,A)')
     &          'Perturbation no: ',idisp,' converged in ',
     &          iter-1,' steps.'
      End If
      irc=ipnout(-1)
*
 310  Continue
      If (iPL.ge.2) Write(6,*)
      if (debug) then
       write(6,*) 'outputs'
       write(6,*) 'kappa'
       do i=1,ndens2
         write(6,*) Kappa(i)
       end do
       irc=ipin(ipCIT)
*      Call dcopy_(nconf1*nroots,0.0d0,0,W(ipCIT)%Vec,1)
       write(6,*) 'cit'
       do i=1,nconf1*nroots
         write(6,*) W(ipCIT)%Vec(i)
       end do
      end if
*
      iLen=ndensC
*
      iKapDisp(iDisp)=iDis
      Call dDaFile(LuTemp,1,Kappa,iLen,iDis)
      iSigDisp(iDisp)=iDis
      Call dDaFile(LuTemp,1,Sigma,iLen,iDis)
      ilen=nconf1*nroots
      iCIDisp(iDisp)=iDis
*
      irc=ipin(ipCIT)
      Call dDaFile(LuTemp,1,W(ipCIT)%Vec,iLen,iDis)
*
**MGD This last call seems unused, so I comment it
*
*      Call TimesE2(Kappa,ipCIT,1,reco,jspin,ipS2,Temp4,ipS2)
      iCISigDisp(iDisp)=iDis
      irc=ipin(ipST)
      Call dDaFile(LuTemp,1,W(ipST)%Vec,iLen,iDis)
      end do
*
      Call mma_deallocate(Sc2)
      Call mma_deallocate(Sc1)
      Call mma_deallocate(Temp4)
      Call mma_deallocate(Sigma)
      Call mma_deallocate(dKappa)
      Call mma_deallocate(Kappa)
      Call mma_deallocate(Fancy)
*
*     Free all memory and remove from disk all data
*     related to this symmetry
*
      irc=ipclose(ipdia)
      If (.not.CI) irc=ipclose(ipPre2)
*
      Call Exp_Close()
*
      If (debug) Then
      Write(6,*)  '****************************************'//
     &            '****************************************'
      Write(6,*)
      End If
      if(doDMRG)then  ! yma
        call dmrg_spc_change_mclr(RGras2(1:8),nash)
        call dmrg_spc_change_mclr(RGras2(1:8),nrs2)
      end if
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

      Subroutine TimesE2_(Kap,ipCId,isym,reco,jspin,ipS2,KapOut,ipCiOut)
*
      use ipPage, only: W
      Implicit Real*8(a-h,o-z)
#include "stdalloc.fh"
#include "Pointers.fh"
#include "dmrginfo_mclr.fh"
#include "real.fh"
#include "Input.fh"
      Integer opOut
      Real*8 Kap(*),KapOut(*)
      Real*8 rdum(1)
      Real*8, Allocatable:: RMOAA(:), Sc1(:), Sc2(:), Sc3(:),
     &                      Temp4(:), Temp3(:)
*
      Call mma_allocate(RMOAA,n2dens,Label='RMOAA')
      Call mma_allocate(Sc1,ndens2,Label='Sc1')
      Call mma_allocate(Sc2,ndens2,Label='Sc2')
      Call mma_allocate(Sc3,ndens2,Label='Sc3')
      Call mma_allocate(Temp3,ndens2,Label='Temp3')
      Call mma_allocate(Temp4,ndens2,Label='Temp4')
*
      if(doDMRG)then ! yma
        call dmrg_spc_change_mclr(RGras2(1:8),nash)
        call dmrg_spc_change_mclr(RGras2(1:8),nrs2)
      end if

      Call Uncompress(Kap,Sc1,isym)
      Call RInt_generic(SC1,rmoaa,rdum,Sc2,Temp3,Temp4,Sc3,
     &                 isym,reco,jspin)

      Call Kap_CI(Temp4,nDens2,rmoaa,n2Dens,ipCIOUT)
      Call Ci_Ci(ipcid,ipS2)
      Call CI_KAP(ipCid,Sc1,Sc3,isym)

      Call DZaXpY(nDens,One,Sc2,1,Sc3,1,Sc1,1)
*
      Call Compress(Sc1,KapOut,isym)   ! ds
*     Call RecPrt('Ex',' ',KapOut,ndensC,1)
*
      irc=ipin(ipS2)
      irc=ipin(ipCIOUT)
      Call DaXpY_(nConf1*nroots,One,W(ipS2)%Vec,1,W(ipCIOUT)%Vec,1)
      irc=opOut(ipCId)

*
      Call mma_deallocate(Temp4)
      Call mma_deallocate(Temp3)
      Call mma_deallocate(Sc3)
      Call mma_deallocate(Sc2)
      Call mma_deallocate(Sc1)
      Call mma_deallocate(RMOAA)

      if(doDMRG)then  ! yma
        call dmrg_spc_change_mclr(LRras2(1:8),nash)
      end if
*
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Drvespf(Grad,Temp,nGrad,CCoor)
*
*     Driver to compute the ESPF B*dV contribution to the gradient
*     This is a hack of the alaska/drvh1 subroutine with a little
*     piece of (extinct) integral_util/drvprop subroutine
*
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "espf.fh"
*
      External BdVGrd
      External NAMmG
#include "print.fh"
#include "disp.fh"
#include "nsd.fh"
#include "setup.fh"
#include "wldata.fh"
#include "stdalloc.fh"
      Character Label*80
      Real*8 Grad(nGrad), Temp(nGrad)
      Real*8 Ccoor(*)
*     Logical DiffOp, DoRys
      Logical DiffOp
      Real*8, Allocatable:: D_Var(:)
      Integer, Allocatable:: lOper(:)
*
*-----Statement function
*
      nElem(i) = (i+1)*(i+2)/2
*
*...  Prologue
      iPrint = 1
*
*---- Allocate memory for density matrix
*
      nDens = 0
      Do iIrrep = 0, nIrrep - 1
         nDens = nDens + nBas(iIrrep)*(nBas(iIrrep)+1)/2
      End Do
*
*...  Read the variational 1st order density matrix
*...  density matrix in AO/SO basis
*
      Call mma_allocate(D_Var,nDens,Label='D_Var')
      Call Get_D1ao_Var(D_Var,nDens)
      If (iPrint.ge.99) then
         Write(6,*) 'variational 1st order density matrix'
         ii=1
         Do iIrrep = 0, nIrrep - 1
            Write(6,*) 'symmetry block',iIrrep
            Call TriPrt(' ',' ',D_Var(ii),nBas(iIrrep))
            ii = ii + nBas(iIrrep)*(nBas(iIrrep)+1)/2
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     nOrdOp: order/rank of the operator
*     lOper: lOper of each component of the operator
*
      nPrint(112) = 5
      iPL = iPL_espf()
      If (iPL.ge.3) nPrint(112) = 15
      nOrdOp=0
      nComp = nElem(nOrdOp)
      Call mma_allocate(lOper,nComp,Label='lOper')
      lOper(:)=1
*
************************************************************************
*                                                                      *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the external field integrals.                        *
*                                                                      *
************************************************************************
      DiffOp = .True.
      Label = ' The ESPF BdV contribution'
      Call OneEl_g(BdVGrd,NAMmG,Temp,nGrad,DiffOp,CCoor,
     &             D_Var,nDens,lOper,nComp,nOrdOp,Label)
      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(lOper)
      Call mma_deallocate(D_Var)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cp_SpcInt()

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i, iq, LuTmp1, LuTmp2, nq, nQQ
logical(kind=iwp) :: Exists
character(len=16) :: filnam
character(len=14) :: qLbl
real(kind=wp), allocatable :: rK(:)

!write(u6,*) ' Copy files'

! Copy file SPCINX to SPCIN1

filnam = 'SPCINX'
call f_Inquire(filnam,Exists)
if (Exists) then
  LuTmp1 = 11
  LuTmp2 = 12
  call molcas_binaryopen_vanilla(luTmp1,filnam)
  !open(luTmp1,File=filnam,Form='unformatted',Status='unknown')
  filnam = 'SPCIN1'
  call molcas_binaryopen_vanilla(luTmp2,filnam)
  !open(luTmp2,File=filnam,Form='unformatted',Status='unknown')
  rewind(LuTmp1)
  rewind(LuTmp2)

  read(LuTmp1) nq,nQQ
  write(LuTmp2) nq,nQQ
  call mma_allocate(rK,nQQ,Label='rK')
  do iq=1,nq
    read(LuTmp1) qLbl,(rK(i),i=1,nQQ)
    write(LuTmp2) qLbl,(rK(i),i=1,nQQ)
  end do
  call mma_deallocate(rK)

  close(LuTmp1)
  close(LuTmp2)
end if

return

end subroutine cp_SpcInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &                  jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &                  jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &                  Fail)
************************************************************************
*                                                                      *
* Object: to change the length of the primitive and basis functions    *
*         vectors of center D and B, and center  D, B, C, and A,       *
*         respectively.                                                *
*                                                                      *
* Called from: PSOAOx                                                  *
*                                                                      *
* Calling    : None                                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
c#include "print.fh"
*
      Logical QiBas, QjBas, QkBas, QlBas, QjPrim, QlPrim, Fail
*
c     iRout = 11
c     iPrint = nPrint(iRout)
      Fail = .False.
      If (QlPrim) Then
         If (lPrInc.eq.1) Then
            QlPrim=.False.
            QjPrim=.True.
            Go To 100
         End If
         Do 10 i = 2, lPrim
            If ((lPrim+1)/i.lt.lPrInc) Then
               lPrInc=Max(1,(lPrim+1)/i)
               Return
            End If
 10      Continue
      End If
 100  Continue
      If (QjPrim) Then
         lPrInc = lPrim
         If (jPrInc.eq.1) Then
            QjPrim=.False.
            QlBas =.True.
            Go To 200
         End If
         Do 20 i = 2, jPrim
            If ((jPrim+1)/i.lt.jPrInc) Then
               jPrInc=Max(1,(jPrim+1)/i)
               Return
            End If
 20      Continue
      End If
 200  Continue
      lPrInc = lPrim
      jPrInc = jPrim
      If (QlBas) Then
         If (lBsInc.eq.1) Then
            QlBas =.False.
            QjBas =.True.
            Go To 300
         End If
         Do 30 i = 2, lBas
            If ((lBas+1)/i.lt.lBsInc) Then
               lBsInc=Max(1,(lBas+1)/i)
               QlPrim=.True.
               Return
            End If
 30      Continue
      End If
 300  Continue
      If (QjBas) Then
         lBsInc = lBas
         If (jBsInc.eq.1) Then
            QjBas =.False.
            QkBas =.True.
            Go To 400
         End If
         Do 40 i = 2, jBas
            If ((jBas+1)/i.lt.jBsInc) Then
               jBsInc=Max((jBas+1)/i,1)
               QlPrim=.True.
               Return
            End If
 40      Continue
      End If
 400  Continue
      If (QkBas) Then
         lBsInc = lBas
         jBsInc = jBas
         If (kBsInc.eq.1) Then
            QkBas =.False.
            QiBas =.True.
            Go To 500
         End If
         Do 50 i = 2, kBas
            If ((kBas+1)/i.lt.kBsInc) Then
               kBsInc=Max((kBas+1)/i,1)
               QlPrim=.True.
               Return
            End If
 50      Continue
      End If
 500  Continue
      If (QiBas) Then
         lBsInc = lBas
         jBsInc = jBas
         kBsInc = kBas
         If (iBsInc.eq.1) Then
            Fail = .True.
            Return
         End If
         Do 60 i = 2, iBas
            If ((iBas+1)/i.lt.iBsInc) Then
               iBsInc=Max(1,(iBas+1)/i)
               QlPrim=.True.
               Return
            End If
 60      Continue
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(MaxReq)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE Z_BLKFO(    ISPC,     ISM,    IATP,    IBTP,  KPCLBT,
     &                    KPCLEBT, KPCI1BT,  KPCIBT, KPCBLTP,  NBATCH,
     &                     NBLOCK)
*
* Construct information about batch and block structure of CI space
* defined by ISPC,ISM,IATP,IBTP.
*
* Output is given in the form of pointers to vectors in WORK
* where the info is stored :
*
* KPCLBT : Length of each Batch ( in blocks)
* KPCLEBT : Length of each Batch ( in elements)
* KPCI1BT : Length of each block
* KPCIBT  : Info on each block
* KPCBLTP : BLock type for each symmetry
*
* NBATCH : Number of batches
* NBLOCK : Number of blocks
*
* Jeppe Olsen, Feb. 98
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "cicisp.fh"
#include "stinf.fh"
#include "cstate.fh"
#include "csm.fh"
#include "strbas.fh"
#include "crun.fh"
* Some dummy initializations
      KSVST = 1 ! jwk-cleanup
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' =================== '
        WRITE(6,*) ' Output from Z_BLKFO '
        WRITE(6,*) ' =================== '
        WRITE(6,*)
        WRITE(6,*) ' ISM, ISPC = ', ISM,ISPC
      END IF
*
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*. Pointers to output arrays
      NTTS = MXNTTS
      CALL GETMEM('CLBT  ','ALLO','INTE',KPCLBT ,MXNTTS)
      CALL GETMEM('CLEBT ','ALLO','INTE',KPCLEBT,MXNTTS)
      CALL GETMEM('CI1BT ','ALLO','INTE',KPCI1BT,MXNTTS)
      CALL GETMEM('CIBT  ','ALLO','INTE',KPCIBT ,8*MXNTTS)
      CALL GETMEM('CBLTP ','ALLO','INTE',KPCBLTP,NSMST)
*.    ^ These should be preserved after exit so put mark for flushing here
      IDUM = 0
*. Info needed for generation of block info
      CALL GETMEM('CIOIO ','ALLO','INTE',KLCIOIO,NOCTPA*NOCTPB)
      CALL IAIBCM(ISPC,IWORK(KLCIOIO))
      CALL ZBLTP(ISMOST(1,ISM),NSMST,IDC,IWORK(KPCBLTP),IWORK(KSVST))
*. Allowed length of each batch
c      IF(ISIMSYM.EQ.0) THEN
        LBLOCK = MXSOOB
c      ELSE
c        LBLOCK = MXSOOB_AS
c      END IF
*
      LBLOCK = MAX(LBLOCK,LCSBLK)
* JESPER : Should reduce I/O
      IF (ENVIRO(1:6).EQ.'RASSCF') THEN
         LBLOCK = MAX(INT(XISPSM(IREFSM,1)),MXSOOB)
         IF(PSSIGN.NE.0.0D0) LBLOCK = INT(2.0D0*XISPSM(IREFSM,1))
      ENDIF
*
      IF(NTEST.GE.10) THEN
        WRITE(6,*) ' LBLOCK = ', LBLOCK
      END IF
*
*. Batches  of C vector
      CALL PART_CIV2(      IDC,
     &               IWORK(KPCBLTP),
     &               IWORK(KNSTSO(IATP)),
     &               IWORK(KNSTSO(IBTP)),NOCTPA,NOCTPB, NSMST,LBLOCK,
     &               IWORK(KLCIOIO),
*
     &               ISMOST(1,ISM),
     &                  NBATCH,
     &               IWORK(KPCLBT),
     &               IWORK(KPCLEBT),IWORK(KPCI1BT),
     &               IWORK(KPCIBT),0,ISIMSYM)
*. Number of BLOCKS
      NBLOCK = IFRMR(IWORK(KPCI1BT),1,NBATCH)
     &       + IFRMR(IWORK(KPCLBT),1,NBATCH) - 1
      IF(NTEST.GE.1) THEN
         WRITE(6,*) ' Number of batches', NBATCH
         WRITE(6,*) ' Number of blocks ', NBLOCK
      END IF
*. Length of each block
      CALL EXTRROW(IWORK(KPCIBT),8,8,NBLOCK,IWORK(KPCI1BT))
*
      CALL GETMEM('CIOIO ','FREE','INTE',KLCIOIO,NOCTPA*NOCTPB)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 22, 2021, created this file.               *
! ****************************************************************
subroutine PDFTMemAlloc(mGrid,nOrbt)

use nq_pdft, only: d2RdRho2, d2RdRhodPi, d2ZdR2, dEdPi, dEdPiMO, dEdPix, dEdPiy, dEdPiz, dEdRho, dEdRhox, dEdRhoy, dEdRhoz, &
                   dF_dRhoamb, dF_dRhoapb, dF_dRhoxamb, dF_dRhoxapb, dF_dRhoyamb, dF_dRhoyapb, dF_dRhozamb, dF_dRhozapb, dRdPi, &
                   dRdRho, dRhodX, dRhodY, dRhodZ, dZdR, dZdRho, GdEdPiMO, GradPidFdRho, GradRdFdRho, GradRhodFdRho, MOas, MOax, &
                   MOay, MOaz, OneMz, OnePz, Pass1, Pass2, Pass3, RatioA, RhoAB, ZetaA
use KSDFT_Info, only: do_pdftpot
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: mGrid, nOrbt

call mma_allocate(RatioA,mGrid)
call mma_allocate(OnePz,mGrid)
call mma_allocate(OneMz,mGrid)
call mma_allocate(RhoAB,mGrid)
call mma_allocate(ZetaA,mGrid)
call mma_allocate(dZdR,mGrid)
call mma_allocate(Pass1,mGrid)
call mma_allocate(Pass2,mGrid)

! for ft-functional
call mma_allocate(Pass3,mGrid)

if (do_pdftPot) then
  call mma_allocate(dRdRho,mGrid)
  call mma_allocate(dRhodX,mGrid)
  call mma_allocate(dRhodY,mGrid)
  call mma_allocate(dRhodZ,mGrid)
  call mma_allocate(dF_dRhoapb,mGrid)
  call mma_allocate(dF_dRhoamb,mGrid)
  call mma_allocate(dF_dRhoxapb,mGrid)
  call mma_allocate(dF_dRhoyapb,mGrid)
  call mma_allocate(dF_dRhozapb,mGrid)
  call mma_allocate(dF_dRhoxamb,mGrid)
  call mma_allocate(dF_dRhoyamb,mGrid)
  call mma_allocate(dF_dRhozamb,mGrid)
  call mma_allocate(dEdRho,mGrid)
  call mma_allocate(dZdRho,mGrid)
  call mma_allocate(dEdRhox,mGrid)
  call mma_allocate(dEdRhoy,mGrid)
  call mma_allocate(dEdRhoz,mGrid)
  call mma_allocate(dEdPi,mGrid)
  call mma_allocate(GradRhodFdRho,mGrid)
  call mma_allocate(d2ZdR2,mGrid)
  call mma_allocate(d2RdRho2,mGrid)
  call mma_allocate(d2RdRhodPi,mGrid)
  call mma_allocate(MOas,mGrid,nOrbt)

  ! for ft-functional
  call mma_allocate(dRdPi,mGrid)
  call mma_allocate(GradRdFdRho,mGrid)
  call mma_allocate(GradPidFdRho,mGrid)
  call mma_allocate(dEdPix,mGrid)
  call mma_allocate(dEdPiy,mGrid)
  call mma_allocate(dEdPiz,mGrid)
  call mma_allocate(dEdPiMO,mGrid,nOrbt)
  call mma_allocate(GdEdPiMO,mGrid,nOrbt)
  call mma_allocate(MOax,mGrid,nOrbt)
  call mma_allocate(MOay,mGrid,nOrbt)
  call mma_allocate(MOaz,mGrid,nOrbt)
end if

end subroutine PDFTMemAlloc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkguess_cvb()

use casvb_global, only: cvb, cvbdet, endvar, iapr, ipr, ixapr, kbasis, kbasiscvb, mxaobf, nbas_mo, norb, nvb, nvbinp, orbs, &
                        recinp, strtvb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: idum(1), ierr, ii, ioffs, iorb, iorb_ao, norb_ao
real(kind=wp) :: c, cnrm, dum(1)
integer(kind=iwp), allocatable :: irdorbs(:), itmp(:)
real(kind=wp), allocatable :: orbsao(:,:), tmp(:), tmp2(:,:)
real(kind=wp), parameter :: thresh = 1.0e-10_wp
real(kind=wp), external :: detm_cvb, dnrm2_, rand_cvb
logical(kind=iwp), external :: tstfile_cvb, & ! ... Files/Hamiltonian available ...
                               up2date_cvb    ! ... Make: up to date? ...

call mma_allocate(orbsao,nbas_mo,norb,label='orbsao')
call mma_allocate(irdorbs,norb,label='irdorbs')
irdorbs(:) = 0
! -- transfer from orbs if applicable -
! (Newly assigned memory => orbs will be zero)
do iorb=1,norb
  if (dnrm2_(norb,orbs(:,iorb),1) > thresh) then
    irdorbs(iorb) = 1
    orbsao(1:norb,iorb) = orbs(:,iorb)
  end if
end do
! -- restore from previous optim --
if (.not. up2date_cvb('RESTGS')) then
  if (up2date_cvb('WRITEGS')) call mkrestgs_cvb(orbsao,irdorbs,cvb,cvbdet,iapr,ixapr)
  call untouch_cvb('RESTGS')
end if
! -- read from file --
if (.not. up2date_cvb('STRTGS')) then
  call setstrtvb_cvb(strtvb)
  if (tstfile_cvb(strtvb)) call mkstrtgs_cvb(orbsao,irdorbs,cvb,strtvb)
  call untouch_cvb('STRTGS')
end if
! -- input --
if (.not. up2date_cvb('INPGS')) then
  call mma_allocate(itmp,norb,label='itmp')
  call rdioff_cvb(6,recinp,ioffs)
  call rdi_cvb(itmp,norb,recinp,ioffs)
  call rdioff_cvb(5,recinp,ioffs)
  do iorb=1,norb
    if (itmp(iorb) == 1) then
      ! MO basis ...
      irdorbs(iorb) = 1
      call rdlow_cvb(orbsao(1,iorb),norb,recinp,ioffs)
    else if (itmp(iorb) == 2) then
      ! AO basis ...
      irdorbs(iorb) = 2
      call rdlow_cvb(orbsao(1,iorb),nbas_mo,recinp,ioffs)
    end if
    ioffs = ioffs+mxaobf
  end do
  call mma_deallocate(itmp)

  call mma_allocate(tmp,nvbinp,label='tmp')
  call rdioff_cvb(7,recinp,ioffs)
  call rdrs_cvb(tmp,nvbinp,recinp,ioffs)
  if (dnrm2_(nvbinp,tmp,1) > thresh) then
    call rdioff_cvb(3,recinp,ioffs)
    call rdis_cvb(idum,1,recinp,ioffs)
    kbasiscvb = idum(1)
    cvb(1:nvbinp) = tmp(:)
  end if
  call mma_deallocate(tmp)

  call untouch_cvb('INPGS')
end if
! -- semi-random --
! Leading diagonal, random but positive orbital overlaps:
dum = rand_cvb(0.777_wp)
c = 0.1_wp
do iorb=1,norb
  if (irdorbs(iorb) == 0) then
    irdorbs(iorb) = 1
    do ii=1,norb
      orbsao(ii,iorb) = c*rand_cvb(Zero)
      if (ii == iorb) orbsao(ii,iorb) = One
    end do
  else
    ! Dummy calls to RAND to get consistent guesses:
    do ii=1,norb
      dum = rand_cvb(Zero)
    end do
  end if
end do

! Collect orbitals and transform AO -> MO:
norb_ao = 0
do iorb=1,norb
  if (irdorbs(iorb) == 1) then
    orbs(:,iorb) = orbsao(1:norb,iorb)
  else if (irdorbs(iorb) == 2) then
    norb_ao = norb_ao+1
    if (norb_ao /= iorb) orbsao(:,norb_ao) = orbsao(:,iorb)
  end if
end do
call mma_allocate(tmp2,norb,norb_ao,label='tmp2')
call ao2mo_cvb(orbsao,tmp2,norb_ao)
iorb_ao = 0
do iorb=1,norb
  if (irdorbs(iorb) == 2) then
    iorb_ao = iorb_ao+1
    orbs(:,iorb) = tmp2(:,iorb_ao)
  end if
end do
call mma_deallocate(tmp2)
call mma_deallocate(orbsao)
call mma_deallocate(irdorbs)

ierr = 0
call nize_cvb(orbs,norb,dum,norb,0,ierr)

if (abs(detm_cvb(orbs,norb)) < 1.0e-8_wp) then
  dum = rand_cvb(0.777_wp)
  c = 0.1_wp
  do iorb=1,norb
    do ii=1,norb
      orbs(ii,iorb) = orbs(ii,iorb)+c*(One-Two*rand_cvb(Zero))
    end do
  end do
  if (abs(detm_cvb(orbs,norb)) < 1.0e-8_wp) then
    if (ipr(1) >= 0) write(u6,'(a)') ' Starting orbital guess was near-singular - using semi-random guess instead.'
    dum = rand_cvb(0.777_wp)
    c = 0.1_wp
    do iorb=1,norb
      do ii=1,norb
        orbs(ii,iorb) = c*rand_cvb(Zero)
        if (ii == iorb) orbs(ii,iorb) = One
      end do
    end do
  else
    if (ipr(1) >= 0) write(u6,'(a)') ' Starting orbital guess was near-singular - scrambling orbital coefficients.'
  end if
  ierr = 0
  call nize_cvb(orbs,norb,dum,norb,0,ierr)
end if

ierr = 0
call nize_cvb(orbs,norb,dum,norb,0,ierr)

! Perfect-pairing spin function(s):
if (dnrm2_(nvb,cvb,1) < thresh) then
  kbasiscvb = kbasis
  call ppgs_cvb(cvb)
end if

cnrm = dnrm2_(nvb,cvb,1)
if (cnrm < thresh) then
  write(u6,*) ' Fatal error - starting structure coefficients all zero !'
  call abend_cvb()
end if

if (kbasiscvb /= kbasis) then
  call mktrnspn_cvb()
  call untouch_cvb('TRNSPN')
end if

!if (ploc) call rtransf_plc(orbs,cvb)

if ((ipr(1) >= 2) .and. (.not. endvar)) then
  write(u6,'(/,a)') ' Wavefunction guess :'
  call report_cvb(orbs,norb)
  write(u6,'(/,a)') ' Structure coefficients :'
  write(u6,'(a)') ' ------------------------'
  call vecprint_cvb(cvb,nvb)
end if

return

end subroutine mkguess_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine lattXPol(Grid,nGrid,nGrid_Eff,PolEff,DipEff,XF,nXF,nOrd_XF,nPolComp)

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nGrid, nXF, nOrd_XF, nPolComp
integer(kind=iwp), intent(inout) :: nGrid_Eff
real(kind=wp), intent(inout) :: Grid(3,nGrid), PolEff(nPolComp,nGrid), DipEff(nGrid)
real(kind=wp), intent(in) :: XF(*)
integer(kind=iwp) :: Inc, iOrdOp, iXF

! Calculate number of entries per XFIELD point
Inc = 3
do iOrdOp=0,nOrd_XF
  Inc = Inc+nTri_Elem1(iOrdOp)
end do
Inc = Inc+6  !iXpolType always > 0

! Insert XFIELD polarisabilities into Grid
do iXF=1,nXF
  nGrid_Eff = nGrid_Eff+1
  PolEff(:,nGrid_Eff) = XF(iXF*Inc-6+1:iXF*Inc-6+nPolComp)
  DipEff(nGrid_Eff) = Zero
  Grid(:,nGrid_Eff) = XF((iXF-1)*Inc+1:(iXF-1)*Inc+3)
end do

return

end subroutine lattXPol

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine SROMem( &
#                 define _CALLING_
#                 include "mem_interface.fh"
                 )
!***********************************************************************
!  Object: to compute the number of real*8 the kernel routine will     *
!          need for the computation of a matrix element between two    *
!          cartesian Gaussian functions with the total angular momentum*
!          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
!          lr is the order of the operator (this is only used when the *
!          integrals are computed with the Hermite-Gauss quadrature).  *
!                                                                      *
!  Called from: OneEl                                                  *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp, Shells
use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: iAng, iCnttp, ip, iShll, memMlt, nac, ncb, nExpi, nH

nHer = 0
Mem = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%ECP) then
    do iAng=0,dbsc(iCnttp)%nSRO-1
      iShll = dbsc(iCnttp)%iSRO+iAng
      nExpi = Shells(iShll)%nExp
      if (nExpi == 0) cycle

      ip = 0
      ip = ip+nExpi**2
      nac = nTri_Elem1(la)*nTri_Elem1(iAng)
      ip = ip+nExpi*nac
      ip = ip+3*nExpi
      ip = ip+nExpi
      ip = ip+nExpi
      ip = ip+nExpi

      call MltMmP(nH,MemMlt,la,iAng,lr)
      nHer = max(nH,nHer)
      Mem = max(Mem,ip+nExpi*MemMlt)
      ip = ip-6*nExpi

      ncb = nTri_Elem1(iAng)*nTri_Elem1(lb)
      ip = ip+nExpi*ncb
      ip = ip+3*nExpi
      ip = ip+nExpi
      ip = ip+nExpi
      ip = ip+nExpi

      call MltMmP(nH,MemMlt,iAng,lb,lr)
      nHer = max(nH,nHer)
      Mem = max(Mem,ip+nExpi*MemMlt)
      ip = ip-6*nExpi

      ip = ip+max(nExpi*nac,ncb*nExpi)
      Mem = max(Mem,ip)

    end do
  end if
end do

return

end subroutine SROMem

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine OSPIR(NOSPIR,IOSPIR,MXPIRR,MXPOBS)
! Number and symmetries of orbitals corresponding to a given shell
!
! =====
! Input
! =====
!
! PNTGRP  : type of pointgroup
!       = 1 => D2h or a subgroup of D2H
!       = 2 => C inf v
!       = 3 => D inf h
!       = 4 => O 3
! MXPIRR : Largest allowed number of shell irreps
! MXPOBS : Largest allowed number of orbital symmetries
!
! ======
! Output
! ======
!
! NOSPIR : Number of orbital symmetries per irrep
! IOSPIR : Orbital symmetries corresponding to a given irrep
!
! Jeppe Olsen, Winter of 1991

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use lucia_data, only: NIRREP
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: MXPIRR, MXPOBS
integer(kind=iwp), intent(out) :: NOSPIR(MXPIRR), IOSPIR(MXPOBS,MXPIRR)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IRREP
#endif

!if (PNTGRP == 1) then
!=====
! D2h
!=====
NOSPIR(1:8) = 1
IOSPIR(1,1:8) = [1,2,3,4,5,6,7,8]
!else
!  write(u6,*) ' Sorry  PNTGRP out of range, PNTGRP = ',PNTGRP
!  write(u6,*) ' OSPIR fatally wounded'
!  !stop 5
!  call SYSABENDMSG('lucia_util/ospir','Internal error','')
!end if

#ifdef _DEBUGPRINT_
write(u6,*) ' OSPIR speaking'
write(u6,*) ' ================'
write(u6,*) ' Number of orbitals per irrep'
call IWRTMA(NOSPIR,1,NIRREP,1,NIRREP)
write(u6,*) ' Orbital symmetries per irrep'
do IRREP=1,NIRREP
  call IWRTMA(IOSPIR(:,IRREP),1,NOSPIR(IRREP),1,NOSPIR(IRREP))
end do
#endif

end subroutine OSPIR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine W_Partitioning(R,ilist_p,Fact,Weights,list_p,nlist_p,
     &                          dW_dR,nGrad_Eff,iTab,Do_Grad,dW_Temp,
     &                          dPB)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "itmax.fh"
#include "nq_info.fh"
#include "debug.fh"
      Real*8 R(3), Weights, dW_dR(nGrad_Eff), dW_Temp(3,nlist_p),
     &       dPB(3,nlist_p,nlist_p), sxyz(3)
*
      Integer list_p(nlist_p), iTab(4,nGrad_Eff)
      Logical Do_Grad
*                                                                      *
************************************************************************
*                                                                      *
#include "nq_structure.fh"
      declare_ip_coor
      p(x)=(x/Two)*(Three-x**2)
*                                                                      *
************************************************************************
*                                                                      *
ct    R(1)=Zero
ct    R(2)=Zero
ct    R(3)=Zero
ct    Fact=One
      P_i = Zero ! dummy initialize
*
*     iNQ is the index of the current atomic grid to which these grid
*     points belong.
*
      iNQ=list_p(ilist_p)
*                                                                      *
************************************************************************
*                                                                      *
      If (.Not.(Do_Grad.and.Grid_Type.eq.Moving_Grid)) Then
*                                                                      *
************************************************************************
*                                                                      *
*----    Becke's partitioning
*
         Sum_P_k=Zero
*        P_k=Zero
         Do klist_p = 1, nlist_p
            kNQ=list_p(klist_p)
            kx=ip_Coor(kNQ)
            ky=kx+1
            kz=ky+1
            r_k=sqrt((R(1)-Work(kx))**2
     &               +(R(2)-Work(ky))**2
     &               +(R(3)-Work(kz))**2)
            P_k=One
            Do llist_p = 1, nlist_p
               lNQ=list_p(llist_p)
               lx=ip_Coor(lNQ)
               ly=lx+1
               lz=ly+1
               If (kNQ.ne.lNQ) Then
                  r_l=sqrt((R(1)-Work(lx))**2
     &                     +(R(2)-Work(ly))**2
     &                     +(R(3)-Work(lz))**2)
                  R_kl=sqrt((Work(kx)-Work(lx))**2
     &                      +(Work(ky)-Work(ly))**2
     &                      +(Work(kz)-Work(lz))**2)
                  rMU_kl=(r_k-r_l)/R_kl
c                 p1=p(rMU_kl)
c                 p2=p(p1)
c                 p3=p(p2)
                  p3=p(p(p(rMU_kl)))
                  s=Half*(One-p3)
                  P_k=P_k*s
               End If
            End Do
            If (kNQ.eq.iNQ) P_i=P_k
            Sum_P_k = Sum_P_k + P_k
         End Do
         Weights=Fact*P_i/Sum_P_k
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
         Call FZero(dW_Temp,3*nlist_p)
*
*------- The current grid point is associated with center A and the
*        "atomic" displacement vector relative to center A is computed.
*
         iA=ilist_p
         sxyz(1) = R(1)-Work(ip_Coor(iNQ)  )
         sxyz(2) = R(2)-Work(ip_Coor(iNQ)+1)
         sxyz(3) = R(3)-Work(ip_Coor(iNQ)+2)
*
         Z=Zero
         Call FZero(dPB,3*nlist_p**2)
*
*        Compute all P_B and corresponding derivatives.
*
         P_A=Zero
         Do iB = 1, nlist_p
            kNQ=list_p(iB)
            kx=ip_Coor(kNQ)
            r_Bx=R(1)-Work(kx  )
            r_By=R(2)-Work(kx+1)
            r_Bz=R(3)-Work(kx+2)
            r_B=sqrt(r_Bx**2+r_By**2+r_Bz**2)
*
*           loop over C=/=B for all s(mu_BC), see Eq. B3
*
            P_B=One
            Do iC = 1, nlist_p
*
               If (iC.ne.iB) Then
                  lNQ=list_p(iC)
                  lx=ip_Coor(lNQ)
*
                  r_Cx=R(1)-Work(lx  )
                  r_Cy=R(2)-Work(lx+1)
                  r_Cz=R(3)-Work(lx+2)
                  r_C=sqrt(r_Cx**2+r_Cy**2+r_Cz**2)
                  R_BCx=Work(kx  )-Work(lx  )
                  R_BCy=Work(kx+1)-Work(lx+1)
                  R_BCz=Work(kx+2)-Work(lx+2)
                  R_BC=sqrt(R_BCx**2+R_BCy**2+R_BCz**2)
*
*                 Eq. B6
*
                  rMU_BC=(r_B-r_C)/R_BC
*
*                 Eqs. B5
*
                  p1=p(rMU_BC)
                  p2=p(p1)
                  p3=p(p2)
*
*                 Eq. B4
*
                  s_MU_BC=Half*(One-p3)
                  If (s_MU_BC.eq.Zero) s_MU_BC=1.0D-99
*
*                 Eq. B10
*
                  P_B=P_B*s_MU_BC
                  tMU_BC=-27D0*(One-p2**2)*(One-p1**2)*(One-rMU_BC**2)
     &                  /(16d0*s_MU_BC)
*
*---------------- Differentiate mu_BC with respect to the center, D.
*
                  Do iD = 1, nlist_p
*
                     If (iD.eq.iB) Then
*
*                       d mu_BC(r_A) / dB, Eq. B10
*
                        dmu_BC_dBx =  -r_Bx/(r_B*R_BC)
     &                             - (r_B-r_C)*R_BCx/R_BC**3
                        dmu_BC_dBy =  -r_By/(r_B*R_BC)
     &                             - (r_B-r_C)*R_BCy/R_BC**3
                        dmu_BC_dBz =  -r_Bz/(r_B*R_BC)
     &                             - (r_B-r_C)*R_BCz/R_BC**3
*
                        dPB(1,iD,iB)=dPB(1,iD,iB) + tMU_BC*dmu_BC_dBx
                        dPB(2,iD,iB)=dPB(2,iD,iB) + tMU_BC*dmu_BC_dBy
                        dPB(3,iD,iB)=dPB(3,iD,iB) + tMU_BC*dmu_BC_dBz
*
                     Else If (iD.eq.iC) Then
*
*                       d mu_BC(r_A) / dC, Eq, B10
*
                        dmu_BC_dCx =  r_Cx/(r_C*R_BC)
     &                             + (r_B-r_C)*R_BCx/R_BC**3
                        dmu_BC_dCy =  r_Cy/(r_C*R_BC)
     &                             + (r_B-r_C)*R_BCy/R_BC**3
                        dmu_BC_dCz =  r_Cz/(r_C*R_BC)
     &                             + (r_B-r_C)*R_BCz/R_BC**3
                        dPB(1,iD,iB)=dPB(1,iD,iB) + tMU_BC*dmu_BC_dCx
                        dPB(2,iD,iB)=dPB(2,iD,iB) + tMU_BC*dmu_BC_dCy
                        dPB(3,iD,iB)=dPB(3,iD,iB) + tMU_BC*dmu_BC_dCz
*
                     End If
*
*                    d mu_BC(r_A) / dr_A
*
                     dmu_BC_dAx = (r_Bx/r_B - r_Cx/r_C)/R_BC
                     dmu_BC_dAy = (r_By/r_B - r_Cy/r_C)/R_BC
                     dmu_BC_dAz = (r_Bz/r_B - r_Cz/r_C)/R_BC
*
                     If (iD.eq.iA) Then
*
*                       The direct term
*
                        dPB(1,iD,iB)=dPB(1,iD,iB) + tMU_BC*dmu_BC_dAx
                        dPB(2,iD,iB)=dPB(2,iD,iB) + tMU_BC*dmu_BC_dAy
                        dPB(3,iD,iB)=dPB(3,iD,iB) + tMU_BC*dmu_BC_dAz
                     End If
*
                  End Do  ! iD
*
               End If
            End Do        ! iC
*
*           Multiply derivatives with P_B as in Eq. B8
            Do iD = 1, nlist_p
               dPB(1,iD,iB)=P_B*dPB(1,iD,iB)
               dPB(2,iD,iB)=P_B*dPB(2,iD,iB)
               dPB(3,iD,iB)=P_B*dPB(3,iD,iB)
            End Do
*
            If (iB.eq.iA) P_A=P_B
*
*           Denominator Eq. B2
            Z = Z + P_B
         End Do           ! iB
*
*        Eq. B2
*
         Weights=Fact*P_A/Z
*                                                                      *
************************************************************************
*                                                                      *
*------- Assemble the gradient
*
         If (Debug) Call RecPrt('dPB',' ',dPB,3*nlist_p,nlist_p)
         Do iB = 1, nlist_p
*
            dZ_dBx=Zero
            dZ_dBy=Zero
            dZ_dBz=Zero
            Do iC = 1, nlist_p
               dZ_dBx=dZ_dBx+dPB(1,iB,iC)
               dZ_dBy=dZ_dBy+dPB(2,iB,iC)
               dZ_dBz=dZ_dBz+dPB(3,iB,iC)
            End Do
*
*           Eq. B7
*
            dW_Temp(1,iB) = dPB(1,iB,iA)/Z - (P_A*dZ_dBx)/Z**2
            dW_Temp(2,iB) = dPB(2,iB,iA)/Z - (P_A*dZ_dBy)/Z**2
            dW_Temp(3,iB) = dPB(3,iB,iA)/Z - (P_A*dZ_dBz)/Z**2
         End Do
         If (Debug) Call RecPrt('dW_Temp',' ',dW_Temp,3,nlist_p)
*                                                                      *
************************************************************************
*                                                                      *
*        Pick up the relevant gradients
*
         Call FZero(dW_dR,nGrad_Eff)
         Do iGrad = 1, nGrad_Eff
            iCar=iTab(1,iGrad)
            kNQ =iTab(3,iGrad)
            Fact0=Fact*DBLE(Abs(iTab(4,iGrad)))
            Do iB = 1, nlist_p
               lNQ=list_p(iB)
               If (kNQ.eq.lNQ) dW_dR(iGrad)=Fact0*dW_Temp(iCar,iB)
            End Do
         End Do
         If (Debug) Call RecPrt('dW_dR',' ',dW_dR,1,nGrad_Eff)
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GETSTEPVECTOR(NOW,IOW,MV,IDWN,IUP,ICS)

use Definitions, only: iwp

implicit none
#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
#include "gugx.fh"
#include "WrkSpc.fh"
integer(kind=iwp), intent(in) :: NOW(2,NSYM,NMIDV), IOW(2,NSYM,NMIDV)
integer(kind=iwp), intent(inout) :: MV, IDWN, IUP
integer(kind=iwp), intent(out) :: ICS(NLEV)
integer(kind=iwp) :: IC1, ICDPOS, ICDWN, ICUP, ICUPOS, IDW0, IUW0, LEV, NDWN, NNN

! RECONSTRUCT THE CASE LIST

NICASE = NWALK*NIPWLK
!NSCR = 3*(NLEV+1)
!call mma_allocate(SCR,NSCR,label='SCR1')
!call mma_allocate(ICASE,NICASE,label='CASE')
!call MKCLIST(NSM,IWORK(LDOWN),IWORK(LNOW),IWORK(LIOW),ICASE,LSCR)
!call mma_deallocate(SCR)

! ENTER THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
! WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.
!
!do MV=1,NMIDV
!  do ISYUP=1,NSYM
NUP = NOW(1,1,MV)
NDWN = NOW(2,1,MV)
IUW0 = LICASE-NIPWLK+IOW(1,1,MV)
IDW0 = LICASE-NIPWLK+IOW(2,1,MV)
!    IDWNSV = 0
!    do IDWN=1,NDWN
!      do IUP=1,NUP
! determine the stepvector
!        if (IDWNSV /= IDWN) then
ICDPOS = IDW0+IDWN*NIPWLK
ICDWN = IWORK(ICDPOS)
! unpack lower walk
NNN = 0
do LEV=1,MIDLEV
  NNN = NNN+1
  if (NNN == 16) then
    NNN = 1
    ICDPOS = ICDPOS+1
    ICDWN = IWORK(ICDPOS)
  end if
  IC1 = ICDWN/4
  ICS(LEV) = ICDWN-4*IC1
  ICDWN = IC1
end do
!          IDWNSV = IDWN
!        end if
ICUPOS = IUW0+NIPWLK*IUP
ICUP = IWORK(ICUPOS)
! unpack upper walk
NNN = 0
do LEV=MIDLEV+1,NLEV
  NNN = NNN+1
  if (NNN == 16) then
    NNN = 1
    ICUPOS = ICUPOS+1
    ICUP = IWORK(ICUPOS)
  end if
  IC1 = ICUP/4
  ICS(LEV) = ICUP-4*IC1
  ICUP = IC1
end do
!      end do
!    end do
!  end do
!end do

! compute the next set of indices
if (IUP == NUP) then
  if (IDWN == NDWN) then
    if (MV == NMIDV) then
      MV = 0
    else
      MV = MV+1
    end if
    IDWN = 1
  else
    IDWN = IDWN+1
  end if
  IUP = 1
else
  IUP = IUP+1
end if

!call mma_deallocate(ICASE)
return

end subroutine GETSTEPVECTOR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Roland Lindh                                     *
!***********************************************************************
  subroutine dens2file(array1,array2,array3,adim,lu,adr,iEmpty,iOpt,iGo, &
                       iState,jState)
  use rassi_aux, Only : AO_Mode, Job_Index, nasht_save, CMO1, CMO2,      &
                        DMAB, mTRA, Job1_Old, Job2_Old
  implicit none
! External DDot_
! Real*8 DDot_
#include "stdalloc.fh"
  integer, intent(in) :: adim, lu, iEmpty, iOpt, iGo, iState, jState
  integer, intent(inout) :: adr
  real*8 , intent(inout) :: array1(adim),array2(adim),array3(adim)
  Integer JOB1, JOB2, bdim, IRC, J1, J2
  Real*8, Allocatable:: TRA1(:), TRA2(:)

!**********************************************************************
!   This is the generalized disk interface for TDMs.
!   Some of the parameters and variables are explained here.
!
!   AO_Mode: true if TDMs are in the AO basis, otherwise the TDMs are
!            stored in the basis of the active orbitals only (no sym).
!   iEmpty: the three lowest bits are set if the TDMAB, TSDMAB, and
!           WDMAB, are stored on disk, respectively. That is, for
!           example, if iEmpty=5 the code will write only the first
!           and the last matrix. On read of the second matrix the
!           routine will generate a zero matrix.
!   iOpt: values are 1, or 2, for write and read, respectively.
!   iGo: the three lowest bits are set to tell which matrices are
!        requested. For example, iGo=2, means that only spin-densities
!        are requested.
!
!**********************************************************************
    bdim=adim
    If (.NOT.AO_Mode .AND. iOpt.eq.2) bdim=nasht_save**2+1
    If (bdim.gt.adim) Then
       Write (6,*) 'Dens2file: bdim.gt.adim'
       Call Abend()
    End If

!   Write (*,*) 'iState,jState=',iState,jState
    If (IAND(iGo,1).ne.0) Then
       If (IAND(iEmpty,1).ne.0) Then
!         If (iOpt.eq.1) Write (6,*) 'array1=',DDot_(bdim-1,Array1,1,Array1,1), Array1(bdim)
          call ddafile(lu,iOpt,array1,bdim,adr)
       Else
          If (iOpt.eq.2) array1(:)=0.0D0
       End If
    Else
       If (IAND(iEmpty,1).ne.0) Then
          call ddafile(lu,0,array1,bdim,adr)
       End If
    End If
    If (IAND(iGo,2).ne.0) Then
       If (IAND(iEmpty,2).ne.0) Then
!         If (iOpt.eq.1) Write (6,*) 'array2=',DDot_(bdim-1,Array2,1,Array2,1), Array2(bdim)
          call ddafile(lu,iOpt,array2,bdim,adr)
       Else
          If (iOpt.eq.2) array2(:)=0.0D0
       End If
    Else
       If (IAND(iEmpty,2).ne.0) Then
          call ddafile(lu,0,array2,bdim,adr)
       End If
    End If
    If (IAND(iGo,4).ne.0) Then
       If (IAND(iEmpty,4).ne.0) Then
!         If (iOpt.eq.1) Write (6,*) 'array3=',DDot_(bdim-1,Array3,1,Array3,1), Array3(bdim)
          call ddafile(lu,iOpt,array3,bdim,adr)
       Else
          If (iOpt.eq.2) array3(:)=0.0D0
       End If
    End If
!
    If (.Not.AO_Mode.AND.iOpt.eq.2) Then
!
!      Expand the TDMs to AO basis.
!
       JOB1=JOB_Index(iState)
       JOB2=JOB_Index(jState)
       J1=Max(JOB1,JOB2)
       J2=Min(JOB1,JOB2)
       If (J1.ne.JOB1_Old.or.J2.ne.JOB2_Old) Then
          CALL RDCMO_RASSI(J1,CMO1)
          CALL RDCMO_RASSI(J2,CMO2)
          JOB1_OLD=J1
          JOB2_OLD=J2
          Call mma_Allocate(TRA1,mTra,Label='TRA1')
          Call mma_Allocate(TRA2,mTra,Label='TRA2')
          CALL FINDT(CMO1,CMO2,TRA1,TRA2)
          Call mma_deallocate(TRA2)
          Call mma_deallocate(TRA1)
       End If

!
       If (IAND(iGo,1).ne.0.AND.iAND(iEmpty,1).ne.0) Then
!         Write (*,*) 'array1=',DDot_(nasht_save**2,Array1,1,Array1,1),Array1(bdim)
          CALL MKTDAB(array1(bdim),array1,DMAB,iRC)
          CALL MKTDZZ(CMO1,CMO2,DMAB,array1,iRC)
       End If
!
       If (IAND(iGo,2).ne.0.AND.iAND(iEmpty,2).ne.0) Then
!         Write (*,*) 'array2=',DDot_(nasht_save**2,Array2,1,Array2,1),Array2(bdim)
          CALL MKTDAB(array2(bdim),array2,DMAB,iRC)
          CALL MKTDZZ(CMO1,CMO2,DMAB,array2,iRC)
       End If
!
       If (IAND(iGo,4).ne.0.AND.iAND(iEmpty,4).ne.0) Then
!         Write (*,*) 'array3=',DDot_(nasht_save**2,Array3,1,Array3,1),Array3(bdim)
          CALL MKTDAB(array3(bdim),array3,DMAB,iRC)
          CALL MKTDZZ(CMO1,CMO2,DMAB,array3,iRC)
       End If
!
    End If
!
  end subroutine dens2file

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine o3v3jk(wrk,wrksize,NvGrp,maxdim,LunAux)
! This routine does:
!
! --- Part I - generation of Q and K intermediates
!
! Q(be,u,i,a) = 2 J(be,u,i,a)   - K(be,u,i,a)
! Q(be,u,i,a) <-
!        Q1     + [ 2(u,be|a,i) - (u,i|a,be) ]
!        Q2     - [ 2(u,j |a,i) - (u,i|a,j ) ] . t(be,j)
!        Q4     + [ 2(a,i |b,j) - (a,j|b,i ) ] . D(be,b,j,u)
!
! K(be,u,i,a) <-
!        K1     + [  (u,i |a,be)             ]
!        K2     - [  (u,i |a,j )             ] . t(be,j)
!        K4     - [  (b,i |a,j )             ] . T(be,b,j,u)
!
! Hoo(i,u)  <<-
! Hoo1        +  Foo(i,u)
! Hoo2        +  sum(a,b,j) [2 (ai|bj) - (aj|bi)] Ta(a,b,u,j)
!  implemented as:
! Hoo2        +  sum(a,b,j) [2 (bi|aj) - (bj|ai)] Ta(a,b,j,u)
!
! Hvv(a,be) <<-
! Hvv1        +  Fvv(a,be)
! Hvv2        +  sum(b,i,j) [2 (ai|bj) - (aj|bi)] Ta(be,b,i,j)
!
! Hvo(a,i)  <<-
! Hvo1        +  Fvo(a,i)
! Hvo2        +  sum(be,j)   [2 (be,j|ai) - (be,i|aj)] T1(be,j)
!
! Aex(ij,u,v) <-
! Aex1  + sum(a,b)  [  (ai|bj) . Ta(a,b,u,v)
!
! A(ij,u,v) <-
! A1    +   <-      [  (iu,jv)           ]
! A2    + sum(a)    [  (aj|iu) . t1(a,v) ]
! A3    + sum(a)    [  (ai|jv) . t1(a,u) ]
! A4    +           [   Aex(ij,u,v)      ]
!
!  T1(be,u) <<-
!  T161 + sum(a,i)   [ (2(ai|be,u) . t(a,i) ]
!  T18  - sum(a,i,j) [ (2(ai|ju)   - (aj|iu)  ) . Ta(a,be,i,j) ]
!
!  T18 is implemented in the form:
!  T18  - sum(a,i,j) [ (2(ai|ju)   - (aj|iu)  ) . Ta(be,a,j,i) ]
!
! where:
! D(a,b,i,j) =  t(a,b,j,i) - T(a,b,i,j)
! T(a,b,i,j) =  t(a,b,i,j)/2 + t(a,i) . t(b,j)
! Ta(a,b,i,j)=  t(a,b,i,j)   + t(a,i) . t(b,j)
!
!1 intermediates Q and K will be temporarily stored in files
!  QFil, KFil as follows
!  do aGrp
!    do beGrp
!      Q(K) (be',u,i,a')
!    end do
!  end do
!
!2 Structure of files, where selected group of (pq|rs) are
!  stored (V'O|OO) - I1 ; (V'O|V'O) - I2 ; (V'V'|OO) - I3
!
!  (A'I|JK)  I1inxx xx - Group of A'
!
!  (A'I|B'J) I2xxyy xx - Group of A'
!                   yy - Group of B'
!
!  (A'B'|IJ) I3xxyy xx - Group of A'
!                   yy - Group of B'
!
!3 Structure of Cholesky vector files
!
!  L1(m,I ,A')  L1vcxx xx - Group of A'
!
!  L2(m,A',B')  L2xxyy xx - Group of A'
!                      yy - Group of B'
!
!4 Structure of Amplitude file
!  t2(A',B',IJ)  T2xxyy xx - Group of A'
!                       yy - Group of B'

use Index_Functions, only: nTri_Elem
use chcc_global, only: BeAID, DimGrpv, I0Name, I1Name, I2Name, I3Name, intkey, no, nv, PosA, PosAex, PosFoo, PosFree, PosFvo, &
                       PosFvv, PosHoo, PosHvo, PosHvv, PosT1n, PosT1o, printkey, T2Name, TCpu, TCpu_l, Tmp1Name, TWall, TWall_l, &
                       TWall0
use Para_Info, only: MyRank
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, NvGrp, maxdim, LunAux
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: adda, addb, addbe, aGrp, beGrp, bGrp, dim_1, dim_2, dima, dimb, dimbe, PosH1, PosH2, PosH3, PosH4, PosH5, &
                     PosK, PosQ, PosT, PosV1, PosV2, PosV3, PosV4
character(len=6) :: LunName

! --- introduction part ---

!x Distribute memory
!  @@ yet distribution is the same for all three o3v3 drivers,
!  v buducnosti nosnost usposobit vsetky 3 vlastne

PosT = PosFree
call DistMemo3v3jk(maxdim,PosV1,PosV2,PosV3,PosV4,PosH1,PosH2,PosH3,PosH4,PosH5,PosK,PosQ,PosT)
if (printkey >= 10) write(u6,*) ' Last Value :',PosT,wrksize
if (PosT > wrksize) then
  !mp write(u6,*) ' Nieje dobre, Dr. Ch.  Kokotopuloss',
  write(u6,*) ' Not Enough memory in o3v3jk step! Increase large and/or small segmentation ', &
              real(PosT,kind=wp)/real(wrksize,kind=wp)
  call abend()
end if

!if (generkey == 1) then
!  !vytvorenie suboru T2       vektorov (docasne)
!  call UrobT2(wrk(PosV1),NbeGrp2,NbGrp2,LunAux)
!  write(u6,*) 'T2Vc    done'
!end if

!## Vanish Hoo,Hvo,Hvv, T1n, A, Aex (because of paralelization)
dim_1 = no*no
wrk(PosHoo:PosHoo+dim_1-1) = Zero
dim_1 = no*nv
wrk(PosHvo:PosHvo+dim_1-1) = Zero
dim_1 = nv*nv
wrk(PosHvv:PosHvv+dim_1-1) = Zero
dim_1 = no*nv
wrk(PosT1n:PosT1n+dim_1-1) = Zero
dim_1 = no*no*nTri_Elem(no)
wrk(PosA:PosA+dim_1-1) = Zero
if (intkey == 0) wrk(PosAex:PosAex+dim_1-1) = Zero

! cycle over be'

addbe = 0

do beGrp=1,NvGrp
  dimbe = DimGrpv(beGrp)

  !## test, if something for this beGrp is planed to be run on this node
  dim_1 = sum(BeAID(myRank,beGrp,1:NvGrp))
  !dim_1 = dim_1+BetaID(myRank,beGrp)
  if (dim_1 /= 0) then
    if (printkey > 1) write(u6,*) ' o3v3 JK - ID,beGrp',myRank,beGrp ! toto som si nie isty ...
    !mp
    call CWTime(TCpu,TWall)
    if (printkey > 1) then
      write(u6,*)
      write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
      write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
      write(u6,*)
      write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
      write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
      write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
      write(u6,*)
    end if
    TCpu_l = TCpu
    TWall_l = TWall
    !mp

    !T1G vanish H4(be',u)
    dim_1 = dimbe*no
    wrk(PosH4:PosH4+dim_1-1) = Zero

    !G Extract H1(be',J) <- T1(be,j)
    call ExtT1(wrk(PosH1),wrk(PosT1o),dimbe,addbe)

    ! cycle over a'

    adda = 0

    do aGrp=1,NvGrp
      dima = DimGrpv(aGrp)

      ! Test, if this Be' A' combination is to be run on this node
      if (BeAID(myRank,beGrp,aGrp) /= 0) then
        if (printkey >= 10) write(u6,*) ' o3v3 JK - ID,be,a',myRank,beGrp,aGrp

        !G Extract H2(a',J) <- T1(a,j)
        call ExtT1(wrk(PosH2),wrk(PosT1o),dima,adda)

        !G vanish Q(K)(be',u,i,a')

        dim_1 = no*no*dimbe*dima
        wrk(PosQ:PosQ+dim_1-1) = Zero
        wrk(PosK:PosK+dim_1-1) = Zero

        !QK2.1.1 read V2(a',o_a,JK) <- I2 (a',o_a|JK)
        LunName = I1name(aGrp)
        dim_1 = nTri_Elem(no)*no*dima
        call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
        !QK2.1.2 Expand V1(a',o_a,J,K) <- V2(a',o_a,JK)
        dim_1 = nTri_Elem(no)
        call Exp2(wrk(PosV2),wrk(PosV1),dima,no,dim_1,no)

        !QK2.2 map  V4(j,u,i,a') <- V1(a',j,u,i)
        call Map4_4123(wrk(PosV1),wrk(PosV4),dima,no,no,no)

        if (aGrp == beGrp) then
          ! term A23 only for a'=be'

          !A23.1 Calc V1(I,JK,L) <- V2(T)(a',I,JK) . H2(a',L)
          dim_1 = no*no*nTri_Elem(no)
          wrk(PosV1:PosV1+dim_1-1) = Zero
          dim_1 = no*nTri_Elem(no)
          call mc0c1at3b(dima,dim_1,dima,no,dim_1,no,dim_1,dima,no,wrk(PosV2),wrk(PosH2),wrk(PosV1))

          !A23.2f Add A(ij,u,v) <<- V1(j,iu,v) + V1(i,jv,u)
          dim_1 = nTri_Elem(no)
          call AdV_A23(wrk(PosV1),wrk(PosA),dim_1,no)

        end if

        !QK1.1.1 read V2(bea',ui) = (be',a'|IJ)
        if (beGrp > aGrp) then
          LunName = I3name(beGrp,aGrp)
          dim_1 = nTri_Elem(no)*dima*dimbe
        else if (beGrp == aGrp) then
          LunName = I3name(beGrp,aGrp)
          dim_1 = nTri_Elem(no)*nTri_Elem(dima)
        else
          LunName = I3name(aGrp,beGrp)
          dim_1 = nTri_Elem(no)*dima*dimbe
        end if
        call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

        !QK1.1.2 Expand V1(be',a',u,i) <- V2(bea',ui)
        if (beGrp > aGrp) then
          dim_1 = nTri_Elem(no)
          call Exp2(wrk(PosV2),wrk(PosV1),dimbe,dima,dim_1,no)
        else if (beGrp == aGrp) then
          dim_1 = nTri_Elem(dima)
          dim_2 = nTri_Elem(no)
          call Exp4(wrk(PosV2),wrk(PosV1),dim_1,dima,dim_2,no)
        else
          dim_1 = nTri_Elem(no)
          call Exp2i(wrk(PosV2),wrk(PosV1),dima,dimbe,dim_1,no)
        end if

        !QK1.2 map V2(be'u,i,a') <- V1(be',a',u,i)
        call Map4_1423(wrk(PosV1),wrk(PosV2),dimbe,dima,no,no)

        !Q1.3 Q(be',u,i,a) <-  - V2(be',u,i,a')
        dim_1 = no*no*dimbe*dima
        wrk(PosQ:PosQ+dim_1-1) = wrk(PosQ:PosQ+dim_1-1)-wrk(PosV2:PosV2+dim_1-1)

        !K1.3f K(be',u,i,a) <-  V2(be',u,i,a')
        dim_1 = no*no*dimbe*dima
        wrk(PosK:PosK+dim_1-1) = wrk(PosK:PosK+dim_1-1)+wrk(PosV2:PosV2+dim_1-1)

        !Q1.4 read V1(be',o_be,a',o_a) = (be'I|a'J)
        LunName = I2name(beGrp,aGrp)
        dim_1 = no*no*dima*dimbe
        call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

        !Q1.5 Map V2(be',u,i,a') <- V1(be',u,a',i)
        call Map4_1243(wrk(PosV1),wrk(PosV2),dimbe,no,dima,no)

        !Q1.6f Q(be',u,i,a) <-  2 V2(be',u,i,a')
        dim_1 = no*no*dimbe*dima
        wrk(PosQ:PosQ+dim_1-1) = wrk(PosQ:PosQ+dim_1-1)+Two*wrk(PosV2:PosV2+dim_1-1)

        !T161.1 V2(be',u) <- V1(be',u,a',i) . H2(a',i)
        dim_1 = dimbe*no
        dim_2 = dima*no
        wrk(PosV2:PosV2+dim_1-1) = Zero
        call mv0v1a3u(dim_1,dim_2,dim_2,dim_1,dim_1,dim_2,1,1,wrk(PosV1),wrk(PosH2),wrk(PosV2))

        !T161.2f Add H4(be',u) <<- 2 V2(be',u)
        dim_1 = dimbe*no
        wrk(PosH4:PosH4+dim_1-1) = wrk(PosH4:PosH4+dim_1-1)+Two*wrk(PosV2:PosV2+dim_1-1)

        !Hvo2.1 Make V2(a',i,be',j) <- [2 V1(be',j|a'i) - V1(be',i|a'j)]
        call MkV_Hvo2(wrk(PosV1),wrk(PosV2),dimbe,dima,no)

        !Hvo2.2 V3(a',i) <- V2(a',i,be',j) . H1(be',j)
        wrk(PosV3:PosV3+dima*no-1) = Zero
        call mv0v1a3u(dima*no,dimbe*no,dimbe*no,dima*no,dima*no,dimbe*no,1,1,wrk(PosV2),wrk(PosH1),wrk(PosV3))

        !Hvo2.3f Add Hvo(a,i) <<- V3(a',i) (da sa spravit aj vlastna rutina)
        call AdT_T17(wrk(PosHvo),wrk(PosV3),nv,dima,no,adda,One)

        !K2.3 map  V2(j,u,i,a') = -V4(j,u,i,a')
        dim_1 = no*no*no*dima
        call MkV_K22(wrk(PosV2),wrk(PosV4),dim_1)

        !Q2.3 make V1(j,u,i,a') = -2V4(i,u,j,a')+V4(j,u,i,a') uz prepermutovanuo
        call MkV_Q22(wrk(PosV4),wrk(PosV1),dima)

        !Q2.4f Q(be',u,i,a') <-  H1(be',j).V1(j,u,i,a')
        call mc0c1a3b(dimbe,no,no,no*no*dima,dimbe,no*no*dima,dimbe,no,no*no*dima,wrk(PosH1),wrk(PosV1),wrk(PosQ))

        !K2.4f K(be',u,i,a') <- H1(be',j).V2(j,u,i,a')
        call mc0c1a3b(dimbe,no,no,no*no*dima,dimbe,no*no*dima,dimbe,no,no*no*dima,wrk(PosH1),wrk(PosV2),wrk(PosK))

        !Hvv2.1 vanish H3(be',a')
        dim_1 = dimbe*dima
        wrk(PosH3:PosH3+dim_1-1) = Zero

        ! cycle over b'

        addb = 0

        do bGrp=1,NvGrp
          dimb = DimGrpv(bGrp)

          !G Extract H5(b',i) <- T1(b,i)
          call ExtT1(wrk(PosH5),wrk(PosT1o),dimb,addb)

          !QK4.1.12 read V1(be'b',o_be,o_b) <- t2(be',b',I,J)
          LunName = T2name(beGrp,bGrp)
          if (bGrp == beGrp) then
            dim_1 = nTri_Elem(dimbe)*no*no
            call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
            !QK4.1.2 Expand V1(be',b',p,q) <- V2(be'b',p,q)
            dim_1 = nTri_Elem(dimb)
            call ExpT2(wrk(PosV2),wrk(PosV1),dimbe,dim_1,no)
          else
            dim_1 = dimbe*dimb*no*no
            call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
          end if

          !T18 - sum(a,i,j) [ (2(ai|ju)   - (aj|iu)  ) . Ta(be,a,j,i) ]
          if (aGrp == bGrp) then
            ! term T18 only in the case a'=b'
            ! preserve: V1(be',a',I,J) = T2(be',a',I,J)
            !           V4(J,K,L,a') = (a',J|K,L)
            ! destroy : V2,V3

            !T18.1 Make V2(a',j,i,u) <- - [2(ai|ju)-(aj|iu)] from V4
            call MkV_T18(wrk(PosV2),wrk(PosV4),dima,no)

            !T18.2 Set V3(be',a',j,i) <- V1(be',a',j,i)
            dim_1 = dimbe*dima*no*no
            wrk(PosV3:PosV3+dim_1-1) = wrk(PosV1:PosV1+dim_1-1)

            !T18.3 Make Tau in V3
            call MkTau_chcc(wrk(PosV3),wrk(PosH1),wrk(PosH2),dimbe,dima,no,One,One)

            !T18.4f Calc H4(be',u) <<- V3(be',a',j,i) . V2(a',j,i,u)
            dim_1 = no*no*dima
            call mc0c1a3b(dimbe,dim_1,dim_1,no,dimbe,no,dimbe,dim_1,no,wrk(PosV3),wrk(PosV2),wrk(PosH4))

          end if

          !QK4.2 read V2(b',o_b,a',o_a) = (b'I|a'J)
          LunName = I2Name(bGrp,aGrp)
          dim_1 = dimb*dima*no*no
          call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

          if (aGrp == beGrp) then
            ! term A4 only for a'=be' ,If Tau is needed instead
            ! of T, A4 term can be joined with Hoo2 subpart

            !Aex1.1 Extract V3(a',b',ij) <- (ai|bj) from V2(b',J,a',I)
            dim_1 = nTri_Elem(no)
            call MkV_A4(wrk(PosV3),wrk(PosV2),dimb,dima,no,dim_1)

            !Aex1.2 Make Tau in V1 (@@@ toto sa menilo oproti T1=0 - OK)
            call MkTau_chcc(wrk(PosV1),wrk(PosH2),wrk(PosH5),dima,dimb,no,One,One)

            if (intkey == 0) then
              ! cholesky generation of integrals
              !Aex1.3f Aex(ij,u,v) <<- V3(T)(a',b',ij) . V1(a',b',u,v)
              dim_1 = nTri_Elem(no)
              call mc0c1at3b(dimb*dima,dim_1,dimb*dima,no*no,dim_1,no*no,dim_1,dima*dimb,no*no,wrk(PosV3),wrk(PosV1),wrk(PosAex))
            else
              ! W4 and W3 integrals from disc
              !Aex(A4).3f A(ij,u,v) <<- V3(T)(a',b',ij) . V1(a',b',u,v)
              dim_1 = nTri_Elem(no)
              call mc0c1at3b(dimb*dima,dim_1,dimb*dima,no*no,dim_1,no*no,dim_1,dima*dimb,no*no,wrk(PosV3),wrk(PosV1),wrk(PosA))
            end if

            !Aex1.4ff nesuspended: V pripade Tau rekonstruovat naspat T2 vo V1
            call MkTau_chcc(wrk(PosV1),wrk(PosH2),wrk(PosH5),dima,dimb,no,One,-One)

          end if

          !Hvv2.2 make Tau(be',b',o_be,o_b) in V1
          call MkTau_chcc(wrk(PosV1),wrk(PosH1),wrk(PosH5),dimbe,dimb,no,One,One)

          !Hvv2.3 Make V3(b',i,j,a') <-2(a'i|b'j)-(a'j|b'i) from V2(b'J|a'I)
          call MkV_Hvv2(wrk(PosV3),wrk(PosV2),dima,dimb,no)

          !Hvv2.4 Calc H3(be',a') <<- V1(be',b',i,j) . V3(b',i,j,a')
          dim_1 = dimb*no*no
          call mc0c1a3b(dimbe,dim_1,dim_1,dima,dimbe,dima,dimbe,dim_1,dima,wrk(PosV1),wrk(PosV3),wrk(PosH3))

          if (aGrp == beGrp) then
            ! terms Hoo2 only for a'=be'
            ! @ musim tu sachovat, lebo nemam dalsie V a tak
            !   je tu jeden lacny perm navyse Hoo2.4 :-(, ak bude
            !   vytvorene nove V5, tak  to treba prerobit @

            !Hoo2.1 Map V3(a',b',j,u) <- V1(a',b',u,j)
            call Map3_132(wrk(PosV1),wrk(PosV3),dima*dimb,no,no)

            !Hoo2.2 Make V1(i,a',b',j) <- 2 V2(b'j|a'i) - V2(b'i|a'j)
            call MkV_Hoo2(wrk(PosV1),wrk(PosV2),dima,dimb,no)

            !Hoo2.3f Hoo(i,u) <<- + V1(i,a',b',j) . V3(a',b',j,u)
            dim_1 = dima*dimb*no
            call mc0c1a3b(no,dim_1,dim_1,no,no,no,no,dim_1,no,wrk(PosV1),wrk(PosV3),wrk(PosHoo))
            !Hoo2.4post Map V1(a',b',u,j) <- V3(a',b',j,u)
            call Map3_132(wrk(PosV3),wrk(PosV1),dima*dimb,no,no)

          end if

          !QK4.3 make T(be',b',o_be,o_b) in V1 (in V1 is Tau from Hvv2.2)
          call MkTau_chcc(wrk(PosV1),wrk(PosH1),wrk(PosH5),dimbe,dimb,no,Half,Half)

          !QK4.4 map V3(be',o_b,b',o_be) <-V1(be',b',o_be,o_b)(now T in V3)
          call Map4_1342(wrk(PosV1),wrk(PosV3),dimbe,dimb,no,no)

          !QK4.5 map V1(b',o_a,o_b,a') <- V2(b',o_b,a',o_a) (now I2 in V1)
          call Map4_1342(wrk(PosV2),wrk(PosV1),dimb,no,dima,no)

          !K4.6f K(be',u,i,a') <<- - V3(be',u_b,b',j_be) . V1(b',j_a,i_b,a')
          call mc0c2a3b(dimbe*no,dimb*no,dimb*no,dima*no,dimbe*no,dima*no,dimbe*no,dimb*no,dima*no,wrk(PosV3),wrk(PosV1),wrk(PosK))

          !Q4.6 Make D: V2(be',u_b,b',j_be) (now D in V2)
          !Q4.6c from T - V3(be',u_b,b',j_be) and T1 - H1(be',j),H2(b',u)
          ! velice specialna procedurka, ale da sa urobit fok :-)))
          call MkD_Q46(wrk(PosV2),wrk(PosV3),wrk(PosH1),wrk(PosH5),dimbe,dimb,no)

          !Q4.7 Make V3(b',o_a,o_b,a') = 2(a',i |b',j) - (a',j|b',i )
          !Q4.7c from V1(b',o_a,o_b,a')
          ! dalsia, o nieco menej korenista rutinka fok :-)))
          call MkI_Q47(wrk(PosV3),wrk(PosV1),dimb,dima,no)

          !Q4.8f Q(be',u,i,a') <<- V2(be',u_b,b',j_be) . V3(b',j_a,i_b,a')
          call mc0c1a3b(dimbe*no,dimb*no,dimb*no,dima*no,dimbe*no,dima*no,dimbe*no,dimb*no,dima*no,wrk(PosV2),wrk(PosV3),wrk(PosQ))

          addb = addb+dimb
        end do

        !Hvv2.5f Add Hvv(a,be) <<- - H3(be',a')
        call AdH_Hvv2(wrk(PosH3),wrk(PosHvv),dima,dimbe,adda,addbe,nv)

        ! write Q and K submatrix to corresponding files
        LunName = Tmp1Name(beGrp,aGrp)
        dim_1 = dimbe*dima*no*no
        call SaveX(wrk(PosQ),dim_1,LunAux,LunName,1,0)
        call SaveX(wrk(PosK),dim_1,LunAux,LunName,0,1)

      end if
      adda = adda+dima
    end do

    !T1G Add T1n(be,u) <<- H4(be',u)
    call AdT_T17(wrk(PosT1n),wrk(PosH4),nv,dimbe,no,addbe,One)

  end if
  addbe = addbe+dimbe
end do

#ifdef _MOLCAS_MPP_
!## Synchronizacny bod:
! Allreduce Hoo,Hvv,Hvo
! Allreduce A,Aex
dim_1 = no*no
call gadgop(wrk(PosHoo),dim_1,'+')
dim_1 = nv*nv
call gadgop(wrk(PosHvv),dim_1,'+')
dim_1 = no*nv
call gadgop(wrk(PosHvo),dim_1,'+')
dim_1 = no*no*nTri_Elem(no)
call gadgop(wrk(PosA),dim_1,'+')
if (intkey == 0) call gadgop(wrk(PosAex),dim_1,'+')
#endif

!Hoo1.1 Hoo(i,u) <<- Foo(i,u)
dim_1 = no*nv
wrk(PosHoo:PosHoo+dim_1-1) = wrk(PosHoo:PosHoo+dim_1-1)+wrk(PosFoo:PosFoo+dim_1-1)

!Hvv1.1 Hvv(a,be) <<- Fvv(a,be)
dim_1 = nv*nv
wrk(PosHvv:PosHvv+dim_1-1) = wrk(PosHvv:PosHvv+dim_1-1)+wrk(PosFvv:PosFvv+dim_1-1)

!Hvo1.1 Hvo(a,i) <<- Foo(a,i)
dim_1 = no*nv
wrk(PosHvo:PosHvo+dim_1-1) = wrk(PosHvo:PosHvo+dim_1-1)+wrk(PosFvo:PosFvo+dim_1-1)

!A1.1 read V1(IJ,KL) <- I0(ij,kl)
LunName = I0Name
dim_1 = nTri_Elem(no)**2
call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

!A1.2f Add A(ij,u,v) <<- (iu|jv) from V1(iu,jv)
dim_1 = nTri_Elem(no)
call MkV_A1(wrk(PosA),wrk(PosV1),dim_1,no)

if (intkey == 0) then
  !A4.1f Add A(ij,u,v) <<- Aex(ij,u,v)
  dim_1 = no*no*nTri_Elem(no)
  wrk(PosA:PosA+dim_1-1) = wrk(PosA:PosA+dim_1-1)+wrk(PosAex:PosAex+dim_1-1)
end if

!@@
!call Chck_Hoo(wrk(PosHoo))
!call Chck_Hvv(wrk(PosHvv))
!call Chck_Hvo(wrk(PosHvo))
!call Chck_A(wrk(PosA))
!@@

return

end subroutine o3v3jk

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine CnstTrf(nTrf,Trf0,Trf)

use caspt2_global, only: TraFro
use caspt2_module, only: IfChol, NASH, NBAS, NDEL, NFRO, NISH, NRAS1, NRAS2, NRAS3, NSSH, NSYM
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nTrf
real(kind=wp), intent(in) :: Trf0(nTrf)
real(kind=wp), intent(inout) :: Trf(nTrf)
integer(kind=iwp) :: I, iAsh, iIsh, IJ, ipTrfL, iSQ, iSsh, iSym, iTOrb, J, jAsh, jIsh, jSsh, nAshI, nBasI, nCor, nDelI, nFroI, &
                     nIshI, NR1, NR2, NR3, nSshI, nVir

iSQ = 0
iTOrb = 1 ! LTOrb
ipTrfL = 0
do iSym=1,nSym
  nBasI = nBas(iSym)
  nFroI = nFro(iSym)
  nIshI = nIsh(iSym)
  nAshI = nAsh(iSym)
  nSshI = nSsh(iSym)
  nDelI = nDel(iSym)
  NR1 = nRAS1(iSym)
  NR2 = nRAS2(iSym)
  NR3 = nRAS3(iSym)
  nCor = nFroI+nIshI
  nVir = nSshI+nDelI
  ipTrfL = ipTrfL+iSQ
  !! frozen + inactive
  !do iIsh=1,nFroI+nIshI
  !  Trf(ipTrfL+iIsh+nBasI*(iIsh-1)) = One
  !end do
  !! frozen
  if (IfChol) then
    do J=1,nFroI
      Trf(ipTrfL+nBasI*(J-1)+1:ipTrfL+nBasI*(J-1)+nFroI) = TraFro(nFroI*(J-1)+1:nFroI*J)
    end do
  else
    do iIsh=1,nFroI
      Trf(ipTrfL+iIsh+nBasI*(iIsh-1)) = One
    end do
  end if
  !! inactive
  do I=1,nIshI
    iIsh = nFroI+I
    do J=1,nIshI
      jIsh = nFroI+J
      IJ = I-1+nIshI*(J-1)
      Trf(ipTrfL+iIsh+nBasI*(jIsh-1)) = Trf0(iTOrb+IJ)
    end do
  end do
  iTOrb = iTOrb+nIshI*nIshI
  !! RAS1 space
  do I=1,NR1
    iAsh = nCor+I
    do J=1,NR1
      jAsh = nCor+J
      IJ = I-1+NR1*(J-1)
      Trf(ipTrfL+iAsh+nBasI*(jAsh-1)) = Trf0(iTOrb+IJ)
    end do
  end do
  iTOrb = iTOrb+NR1*NR1
  !! RAS2 space
  do I=1,NR2
    iAsh = nCor+NR1+I
    do J=1,NR2
      jAsh = nCor+NR1+J
      IJ = I-1+NR2*(J-1)
      Trf(ipTrfL+iAsh+nBasI*(jAsh-1)) = Trf0(iTOrb+IJ)
    end do
  end do
  iTOrb = iTOrb+NR2*NR2
  !! RAS3 space
  do I=1,NR3
    iAsh = nCor+NR1+NR2+I
    do J=1,NR3
      jAsh = nCor+NR1+NR2+J
      IJ = I-1+NR3*(J-1)
      Trf(ipTrfL+iAsh+nBasI*(jAsh-1)) = Trf0(iTOrb+IJ)
    end do
  end do
  iTOrb = iTOrb+NR3*NR3
  !call sqprt(trf,12)
  !! Active
  !do iAsh0=1,nAshI
  !  iAsh = nCor+iAsh0
  !  do jAsh0=1,nAshI
  !    jAsh = nCor+jAsh0
  !    Work(ipTrfL+iAsh-1+nBasI*(jAsh-1)) = Work(iTOrb+nIshI*nIshI+iAsh0-1+nAshI*(jAsh0-1))
  !    Trf(ipTrfL+iAsh+nBasI*(jAsh-1)) = Trf0(iTOrb+iAsh0-1+nAshI*(jAsh0-1))
  !  end do
  !end do
  !call sqprt(trf,12)
  !! virtual + deleted (deleted is not needed, though)
  !do iSsh=nOcc+1,nOcc+nVir
  !  Trf(ipTrfL+iSsh+nBasI*(iSsh-1)) = One
  !end do
  do I=1,nVir
    iSsh = nCor+nAshI+I
    do J=1,nVir
      jSsh = nCor+nAshI+J
      IJ = I-1+nVir*(J-1)
      Trf(ipTrfL+iSsh+nBasI*(jSsh-1)) = Trf0(iTOrb+IJ)
    end do
  end do
  iTOrb = iTOrb+nSshI*nSshI
  !call sqprt(trf,12)
  iSQ = iSQ+nBasI*nBasI

  !n123 = nAshI*nAshI !! just for CAS at present
  !iTOrb = iTOrb+n123+nSshI*nSshI
  !write(u6,*) 'transformation matrix'
  !call sqprt(trf,nbasi)
end do

return

end subroutine CnstTrf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************
Module ChoArr
Implicit none
Private
Public:: iSOShl, iShlSO, iBasSh, nBasSh, nBstSh, iSP2F, iAtomShl, iRS2F, IntMap, iScr, &
         nDimRS, iL2G, iShP2RS, iShP2Q, iOff_Batch, nDim_Batch, iQL2G, LQ, LQ_Tot, &
         nQual_L, Idle, MySP, n_MySP, iSimRI
Integer, Allocatable:: iSOShl(:)
Integer, Allocatable:: iShlSO(:)
Integer, Allocatable:: iBasSh(:,:)
Integer, Allocatable:: nBasSh(:,:)
Integer, Allocatable:: nBstSh(:)
Integer, Allocatable:: iSP2F(:)
Integer, Allocatable:: iAtomShl(:)
Integer, Allocatable:: iRS2F(:,:)
Integer, Allocatable:: IntMap(:)
Integer, Allocatable:: iScr(:)
Integer, Allocatable:: nDimRS(:,:)
Integer, Allocatable:: iL2G(:)
Integer, Allocatable:: iShP2RS(:,:)
Integer, Allocatable:: iShP2Q(:,:)
Integer, Allocatable:: iSimRI(:)

Integer, Allocatable:: iOff_Batch(:,:)
Integer:: nDim_Batch(8)

Integer, Allocatable:: iQL2G(:,:)

Type rPointers
     Real*8, Pointer:: Array(:,:)=>Null()
End Type rPointers

Type (rPointers):: LQ(8)
Real*8, Allocatable, Target:: LQ_Tot(:)

Integer:: nQual_L(8)

Integer, Allocatable:: Idle(:)
Integer, Allocatable:: MySP(:)
Integer:: n_MySP

End Module ChoArr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine dafupd_cvb(lu,ioffset)
      implicit real*8(a-h,o-z)
#include "idbl_cvb.fh"
      dimension ibuf(1000)
      Integer   mxddr
      data ibuf/1000*0/

      mxddr=1000
      nwrite=1000

      Call iDaFile(lu,8,ibuf,nwrite,mxddr)

      if(mxddr.lt.ioffset)then
        ioff=mxddr
100     nwrite=min((ioffset-ioff)*idbl,1000)
        call iDaFile(lu,1,ibuf,nwrite,ioff)
        if(ioff.lt.ioffset)goto 100
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module output_caspt2

  use definitions, only: wp,iwp

  implicit none

  ! amount of output written
  Integer(kind=iwp),parameter :: silent  = 0
  Integer(kind=iwp),parameter :: terse   = 1
  Integer(kind=iwp),parameter :: usual   = 2
  Integer(kind=iwp),parameter :: verbose = 3
  Integer(kind=iwp),parameter :: debug   = 4
  Integer(kind=iwp),parameter :: insane  = 5

  Integer(kind=iwp) :: iPrGlb

  ! thresholds for printing
  Real(kind=wp) :: dnmThr,cmpThr,cntThr

  Real(kind=wp) :: EMP2
  Real(kind=wp) :: STrA, STrF, STrX

end module

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine svd(nm,m,n,a,w,matu,u,matv,v,ierr,rv1)
! this subroutine is a translation of the algol procedure svd,
! num. math. 14, 403-420(1970) by golub and reinsch.
! handbook for auto. comp., vol ii-linear algebra, 134-151(1971).
!
! this subroutine determines the singular value decomposition
!      t
! a=usv  of a real m by n rectangular matrix.  householder
! bidiagonalization and a variant of the qr algorithm are used.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.  note that nm must be at least
!      as large as the maximum of m and n.
!
!    m is the number of rows of a (and u).
!
!    n is the number of columns of a (and u) and the order of v.
!
!    a contains the rectangular input matrix to be decomposed.
!
!    matu should be set to .true. if the u matrix in the
!      decomposition is desired, and to .false. otherwise.
!
!    matv should be set to .true. if the v matrix in the
!      decomposition is desired, and to .false. otherwise.
!
! on output
!
!    a is unaltered (unless overwritten by u or v).
!
!    w contains the n (non-negative) singular values of a (the
!      diagonal elements of s).  they are unordered.  if an
!      error exit is made, the singular values should be correct
!      for indices ierr+1,ierr+2,...,n.
!
!    u contains the matrix u (orthogonal column vectors) of the
!      decomposition if matu has been set to .true.  otherwise
!      u is used as a temporary array.  u may coincide with a.
!      if an error exit is made, the columns of u corresponding
!      to indices of correct singular values should be correct.
!
!    v contains the matrix v (orthogonal) of the decomposition if
!      matv has been set to .true.  otherwise v is not referenced.
!      v may also coincide with a if u is not needed.  if an error
!      exit is made, the columns of v corresponding to indices of
!      correct singular values should be correct.
!
!    ierr is set to
!      zero       for normal return,
!      k          if the k-th singular value has not been
!                 determined after 30 iterations.
!
!    rv1 is a temporary storage array.
!
! calls pythag for  sqrt(a*a + b*b) .
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------
!
!  TESTING FOR EQUALITY OR ZERO NOW DONE USING THRESHOLD, TT, 110100.

use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, m, n
real(kind=wp), intent(in) :: a(nm,n)
real(kind=wp), intent(out) :: w(n), u(nm,n), rv1(n)
real(kind=wp), intent(inout) :: v(nm,n)
logical(kind=iwp), intent(in) :: matu, matv
integer(kind=iwp), intent(out) :: ierr
integer(kind=iwp) :: i, i1, ii, its, j, k, k1, kk, l, l1, ll, mn
real(kind=wp) :: c, f, g, h, pythag, s, scl, tst1, tst2, x, y, z
logical(kind=iwp) :: skip
real(kind=wp), parameter :: thresh = 1.0e-16_wp

! The next two initializations are to appease a compiler
f = Zero
h = Zero

ierr = 0
l = 0 ! dummy initialize
l1 = 0 ! dummy initialize

u(1:m,1:n) = a(1:m,1:n)
! .......... householder reduction to bidiagonal form ..........
g = Zero
scl = Zero
x = Zero

do i=1,n
  l = i+1
  rv1(i) = scl*g
  g = Zero
  s = Zero
  scl = Zero

  if (i <= m) then
    scl = scl+sum(abs(u(i:m,i)))

    if (abs(scl) >= thresh) then
      u(i:m,i) = u(i:m,i)/scl
      s = s+sum(u(i:m,i)**2)

      f = u(i,i)
      g = -sign(sqrt(s),f)
      h = f*g-s
      u(i,i) = f-g

      if (i /= n) then
        do j=l,n

          s = sum(u(i:m,i)*u(i:m,j))

          f = s/h

          u(i:m,j) = u(i:m,j)+f*u(i:m,i)
        end do
      end if

      u(i:m,i) = scl*u(i:m,i)
    end if
  end if

  w(i) = scl*g
  g = Zero
  s = Zero
  scl = Zero

  if ((i <= m) .and. (i /= n)) then
    scl = scl+sum(abs(u(i,l:)))

    if (abs(scl) >= thresh) then
      u(i,l:) = u(i,l:)/scl
      s = s+sum(u(i,l:)**2)

      f = u(i,l)
      g = -sign(sqrt(s),f)
      h = f*g-s
      u(i,l) = f-g

      rv1(l:) = u(i,l:)/h

      if (i /= m) then
        do j=l,m
          s = sum(u(j,l:)*u(i,l:))

          u(j,l:) = u(j,l:)+s*rv1(l:)
        end do
      end if

      u(i,l:) = scl*u(i,l:)
    end if
  end if

  x = max(x,abs(w(i))+abs(rv1(i)))
end do
! .......... accumulation of right-hand transformations ..........
if (matv) then
  ! .......... for i=n step -1 until 1 do -- ..........
  do ii=1,n
    i = n+1-ii

    if (i /= n) then
      if (abs(g) >= thresh) then
        ! .......... double division avoids possible underflow ..........
        v(l:n,i) = (u(i,l:n)/u(i,l))/g

        do j=l,n
          s = sum(u(i,l:)*v(l:n,j))

          v(l:n,j) = v(l:n,j)+s*v(l:n,i)
        end do
      end if

      v(i,l:n) = Zero
      v(l:n,i) = Zero
    end if

    v(i,i) = One
    g = rv1(i)
    l = i
  end do
end if
! .......... accumulation of left-hand transformations ..........
if (matu) then
  ! ..........for i=min(m,n) step -1 until 1 do -- ..........
  mn = n
  if (m < n) mn = m

  do ii=1,mn
    i = mn+1-ii
    l = i+1
    g = w(i)

    if (i /= n) u(i,l:) = Zero

    if (abs(g) < thresh) then
      u(i:m,i) = Zero
    else
      if (i /= mn) then
        do j=l,n
          s = sum(u(l:m,i)*u(l:m,j))
          ! .......... double division avoids possible underflow ..........
          f = (s/u(i,i))/g

          u(i:m,j) = u(i:m,j)+f*u(i:m,i)
        end do
      end if

      u(i:m,i) = u(i:m,i)/g
    end if

    u(i,i) = u(i,i)+One
  end do
end if
! .......... diagonalization of the bidiagonal form ..........
tst1 = x
! .......... for k=n step -1 until 1 do -- ..........
do kk=1,n
  k1 = n-kk
  k = k1+1
  its = 0

  do
    ! .......... test for splitting. for l=k step -1 until 1 do -- ..........
    skip = .false.
    do ll=1,k
      l1 = k-ll
      l = l1+1
      tst2 = tst1+abs(rv1(l))
      if (abs(tst2-tst1) < thresh) then
        skip = .true.
        exit
      end if
      ! .......... rv1(1) is always zero, so there is no exit through the bottom of the loop ..........
      tst2 = tst1+abs(w(l1))
      if (abs(tst2-tst1) < thresh) exit
    end do
    if (.not. skip) then
      ! .......... cancellation of rv1(l) if l greater than 1 ..........
      c = Zero
      s = One

      do i=l,k
        f = s*rv1(i)
        rv1(i) = c*rv1(i)
        tst2 = tst1+abs(f)
        if (abs(tst2-tst1) < thresh) exit
        g = w(i)
        h = pythag(f,g)
        w(i) = h
        c = g/h
        s = -f/h

        if (matu) then
          do j=1,m
            y = u(j,l1)
            z = u(j,i)
            u(j,l1) = y*c+z*s
            u(j,i) = -y*s+z*c
          end do
        end if

      end do
    end if
    ! .......... test for convergence ..........
    z = w(k)
    if (l == k) then
      ! .......... convergence ..........
      if (z >= Zero) exit
      ! .......... w(k) is made non-negative ..........
      w(k) = -z

      if (matv) v(1:n,k) = -v(1:n,k)
      exit
    else
      ! .......... shift from bottom 2 by 2 minor ..........
      if (its == 30) then
        ! .......... set error -- no convergence to a singular value after 30 iterations ..........
        ierr = k
        return
      end if
      its = its+1
      x = w(l)
      y = w(k1)
      g = rv1(k1)
      h = rv1(k)
      f = Half*(((g+z)/h)*((g-z)/y)+y/h-h/y)
      g = pythag(f,One)
      f = x-(z/x)*z+(h/x)*(y/(f+sign(g,f))-h)
      ! .......... next qr transformation ..........
      c = One
      s = One

      do i1=l,k1
        i = i1+1
        g = rv1(i)
        y = w(i)
        h = s*g
        g = c*g
        z = pythag(f,h)
        rv1(i1) = z
        c = f/z
        s = h/z
        f = x*c+g*s
        g = -x*s+g*c
        h = y*s
        y = y*c

        if (matv) then
          do j=1,n
            x = v(j,i1)
            z = v(j,i)
            v(j,i1) = x*c+z*s
            v(j,i) = -x*s+z*c
          end do
        end if

        z = pythag(f,h)
        w(i1) = z
        ! .......... rotation can be arbitrary if z is zero ..........
        if (abs(z) >= thresh) then
          c = f/z
          s = h/z
        end if
        f = c*g+s*y
        x = -s*g+c*y

        if (matu) then
          do j=1,m
            y = u(j,i1)
            z = u(j,i)
            u(j,i1) = y*c+z*s
            u(j,i) = -y*s+z*c
          end do
        end if

      end do

      rv1(l) = Zero
      rv1(k) = f
      w(k) = x
    end if

  end do

end do

return

end subroutine svd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module DLFCN

use, intrinsic :: iso_c_binding, only: c_char, c_funptr, c_int, c_ptr
use ISO_C_UTILITIES, only: C_F_STRING

implicit none
private

! Valid modes for mode in DLOpen, obtained from the output of a C program:
integer, parameter :: RTLD_LAZY = 1, RTLD_GLOBAL = 256

! Struct for DLAddr
type, bind(C) :: DL_info
  type(c_ptr) :: dli_fname
  type(c_funptr) :: dli_fbase
  type(c_ptr) :: dli_sname
  type(c_funptr) :: dli_saddr
end type DL_info

public :: DL_info, DLAddr, DLClose, DLError, DLOpen, DLSym, RTLD_GLOBAL, RTLD_LAZY

interface ! All we need is interfaces for the prototypes in <dlfcn.h>

  function DLOpen(file,mode) result(handle) bind(C,name="dlopen")
    ! void *dlopen(const char *file, int mode);

    import :: c_char, c_int, c_ptr
    character(kind=c_char), dimension(*), intent(in) :: file
    ! C strings should be declared as character arrays
    integer(c_int), value :: mode
    type(c_ptr) :: handle

  end function DLOpen

  function DLSym(handle,name) result(funptr) bind(C,name="dlsym")
    ! void *dlsym(void *handle, const char *name);

    import :: c_char, c_funptr, c_ptr
    type(c_ptr), value :: handle
    character(kind=c_char), dimension(*), intent(in) :: name
    type(c_funptr) :: funptr ! A function pointer

  end function DLSym

  function DLClose(handle) result(status) bind(C,name="dlclose")
    ! int dlclose(void *handle);

    import :: c_int, c_ptr
    type(c_ptr), value :: handle
    integer(c_int) :: status

  end function DLClose

  function DLError() result(error) bind(C,name="dlerror")
    ! char *dlerror(void);

    import :: c_ptr
    type(c_ptr) :: error

  end function DLError

  ! dladdr is a Glibc extension, not POSIX
  function DLAddr(funptr,info) result(output) bind(C,name="dladdr")
    ! int dladdr(void *addr, Dl_info *info)

    import :: c_funptr, c_int, c_ptr
    type(c_funptr), value :: funptr ! A function pointer
    type(c_ptr), value :: info
    integer(c_int) :: output

  end function DLAddr

end interface

end module DLFCN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_INT1_1_DBG2_CMP(XINT1,XINT2,NI,NJ,
     &                                   ERRMIN,IMN,JMN,
     &                                   ERRMAX,IMX,JMX,
     &                                   ITST,IERR,THR,PRTERR,LUPRI)
#include "implicit.fh"
      DIMENSION XINT1(NI,NJ), XINT2(NJ,NI)
      LOGICAL PRTERR

      IF ((NI.LT.1) .OR. (NJ.LT.1)) THEN
         ERRMAX = 0.0D0
         ERRMIN = 0.0D0
         IMN = 0
         JMN = 0
         IMX = 0
         JMX = 0
         RETURN
      END IF

      ERRMAX = XINT1(1,1) - XINT2(1,1)
      ERRMIN = XINT1(1,1) - XINT2(1,1)
      IMN = 1
      JMN = 1
      IMX = 1
      JMX = 1

      JERR = 0
      DO J = 1,NJ
         DO I = 1,NI
            ITST = ITST + 1
            DIFF = XINT1(I,J) - XINT2(J,I)
            IF (ABS(DIFF) .GT. THR) THEN
               JERR = JERR + 1
               IF (PRTERR) THEN
                  WRITE(LUPRI,*) '      Error: ',I,J,DIFF
               END IF
            END IF
            IF (DIFF .LT. ERRMIN) THEN
               ERRMIN = DIFF
               IMN = I
               JMN = J
            END IF
            IF (DIFF .GT. ERRMAX) THEN
               ERRMAX = DIFF
               IMX = I
               JMX = J
            END IF
         END DO
      END DO
      IERR = IERR + JERR

      IF ((JERR.NE.0) .AND. (NI.EQ.NJ)) THEN
         JERR = 0
         WRITE(LUPRI,*) '         Checking for identity...'
         DO J = 1,NJ
            DO I = 1,NI
               DIFF = XINT1(I,J) - XINT2(I,J)
               IF (ABS(DIFF) .GT. 1.0D-14) JERR = JERR + 1
            END DO
         END DO
         IF (JERR .NE. 0) THEN
            WRITE(LUPRI,*) '      ...not identical!!'
         ELSE
            WRITE(LUPRI,*) '      ...identical!!'
         END IF
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2007, Roland Lindh                                *
!***********************************************************************

subroutine PGet2_RI2(iCmp,jBas,lBas,iAO,iAOst,nijkl,PSO,nPSO,ExFac,CoulFac,PMax,V_K,mV_K,Z_p_K,nSA,nZ_p_k)
!***********************************************************************
!  Object: to assemble the 2nd order density matrix of a SCF wave      *
!          function from the 1st order density matrix.                 *
!                                                                      *
!          The indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             January '92.                                             *
!                                                                      *
!             Modified to RI-DFT, March 2007                           *
!***********************************************************************

use Basis_Info, only: nBas, nBas_Aux
use SOAO_Info, only: iAOtSO
use pso_stuff, only: DMdiag, lPSO, lSA, nnP
use Symmetry_Info, only: Mul, nIrrep
use RI_glob, only: A, CijK, iAdrCVec, iMP2prpt, LuCVector, nIJ1, tavec
use Constants, only: Zero, One, Half, Quart
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCmp(4), jBas, lBas, iAO(4), iAOst(4), nijkl, nPSO, mV_K, nSA, nZ_p_k
real(kind=wp), intent(out) :: PSO(nijkl,nPSO), PMax
real(kind=wp), intent(in) :: ExFac, CoulFac, V_K(mV_K,nSA), Z_p_K(nZ_p_k,*)
integer(kind=iwp) :: CumnnP(0:7), CumnnP2(0:7), i, i2, i4, iAdrJ, iAdrL, iE, iS, iSO, iSym, iUHF, j, j2, j4, jAOj, jp, jpSOj, &
                     jpSOl, js, jSO, jSOj, jSym(0:7), kSym, lAOl, ls, lSO, lSOl, lSym(0:7), MemSO2, mijkl, nB, nik, njSym, nlSym
real(kind=wp) :: Cpu, Cpu1, Cpu2, Fac, Fact, temp, temp2, Wall, Wall1, Wall2
logical(kind=iwp) :: Found
real(kind=wp), pointer :: CiKj(:), CiKl(:), V2(:)

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt('V_K',' ',V_K,1,mV_K)
#endif

call CWTime(Cpu1,Wall1)
!                                                                      *
!***********************************************************************
!                                                                      *
PMax = Zero
iSO = 1

PSO(:,:) = Zero

if (lPSO) then
  CumnnP(0) = 0
  CumnnP2(0) = 0
  do i=1,nIrrep-1
    nB = nBas_Aux(i-1)
    if (i == 1) nB = nB-1
    CumnnP(i) = CumnnP(i-1)+nnP(i-1)
    CumnnP2(i) = CumnnP2(i-1)+nnP(i-1)*nB
  end do
end if

call Qpg_iScalar('SCF mode',Found)
if (Found) then
  call Get_iScalar('SCF mode',iUHF) ! either 0 or 1
else
  iUHF = 0
end if

!                                                                      *
!***********************************************************************
!                                                                      *
Fac = Quart
MemSO2 = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Pure DFT

if (ExFac == Zero) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do i2=1,iCmp(2)
    njSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) then
        jSym(njSym) = j
        njSym = njSym+1
      end if
    end do

    do i4=1,iCmp(4)
      nlSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(4)+i4,j) > 0) then
          lSym(nlSym) = j
          nlSym = nlSym+1
        end if
      end do
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Loop over irreps which are spanned by the basis function.

      do js=0,njSym-1
        j2 = jSym(js)
        jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)

        do ls=0,nlSym-1
          j4 = lSym(ls)
          if (j2 /= j4) cycle
          lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)

          MemSO2 = MemSO2+1
          if (j2 /= 0) cycle

          mijkl = 0
          do lAOl=0,lBas-1
            lSOl = lSO+lAOl-nBas(j4)
            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-nBas(j2)
              mijkl = mijkl+1

              ! Coulomb contribution
              if (j2 == 0) then
                ! j4 == 0 also
                temp = V_K(jSOj,1)*V_K(lSOl,1)*CoulFac
                !temp = Zero
              else
                temp = Zero
              end if

              PMax = max(PMax,abs(Temp))
              PSO(mijkl,MemSO2) = Fac*temp

            end do
          end do

        end do
      end do

    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((iMP2prpt /= 2) .and. (.not. lPSO) .and. (iUHF == 0)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Hybrid DFT and HF

  do i2=1,iCmp(2)
    njSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) then
        jSym(njSym) = j
        njSym = njSym+1
      end if
    end do

    do i4=1,iCmp(4)
      nlSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(4)+i4,j) > 0) then
          lSym(nlSym) = j
          nlSym = nlSym+1
        end if
      end do
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Loop over irreps which are spanned by the basis function.

      do js=0,njSym-1
        j2 = jSym(js)
        jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)

        do ls=0,nlSym-1
          j4 = lSym(ls)
          if (j2 /= j4) cycle
          lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)

          MemSO2 = MemSO2+1

          A(1:jBas*lBas) = Zero

          do iSym=1,nIrrep
            kSym = Mul(j2+1,iSym)
            nik = nIJ1(iSym,kSym,iSO)

            if (nik == 0) cycle

            iS = 1
            iE = nik*jBas
            CiKj(1:nik*jBas) => CijK(iS:iE)

            jSOj = jSO-nBas(j2)
            iAdrJ = nik*(jSOj-1)+iAdrCVec(j2+1,iSym,iSO)
            call dDaFile(LuCVector(j2+1,iSO),2,CikJ,nik*jBas,iAdrJ)

            if (lSO /= jSO) then
              iS = iE+1
              iE = iE+nik*lBas
              CiKl(1:nik*lBas) => CijK(iS:iE)

              lSOl = lSO-nBas(j4)
              iAdrL = nik*(lSOl-1)+iAdrCVec(j4+1,iSym,iSO)
              call dDaFile(LuCVector(j4+1,iSO),2,CiKl,nik*lBas,iAdrL)
              V2(1:) => CiKl(1:)
            else
              V2(1:) => CiKj(1:)
            end if

            Fact = One
            if (iSym /= kSym) Fact = Half
            call DGEMM_('T','N',jBas,lBas,nik,Fact,CikJ,nik,V2,nik,One,A,jBas)

          end do

          mijkl = 0
          do lAOl=0,lBas-1
            lSOl = lSO+lAOl-nBas(j4)
            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-nBas(j2)
              mijkl = mijkl+1

              ! Coulomb contribution
              if (j2 == 0) then
                ! j4 == 0 also
                temp = V_K(jSOj,1)*V_K(lSOl,1)*CoulFac
                !temp = Zero
              else
                temp = Zero
              end if

              ! Exchange contribution
              temp = temp-ExFac*A(mijkl)

              PMax = max(PMax,abs(Temp))
              PSO(mijkl,MemSO2) = Fac*temp

            end do
          end do

        end do
      end do

    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((iMP2prpt /= 2) .and. (.not. lPSO) .and. (iUHF == 1)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Hybrid UDFT and UHF

  write(u6,*) 'Pget2_RI2: UDFT/UHF not implemented yet.'
  call Abend()
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((iMP2prpt /= 2) .and. lPSO .and. (.not. LSA)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! CASSCF

  do i2=1,iCmp(2)
    njSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) then
        jSym(njSym) = j
        njSym = njSym+1
      end if
    end do

    do i4=1,iCmp(4)
      nlSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(4)+i4,j) > 0) then
          lSym(nlSym) = j
          nlSym = nlSym+1
        end if
      end do
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Loop over irreps which are spanned by the basis function.

      do js=0,njSym-1
        j2 = jSym(js)
        jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)

        do ls=0,nlSym-1
          j4 = lSym(ls)
          if (j2 /= j4) cycle
          lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)

          MemSO2 = MemSO2+1

          A(1:jBas*lBas) = Zero

          do iSym=1,nIrrep
            kSym = Mul(j2+1,iSym)
            nik = nIJ1(iSym,kSym,iSO)

            if (nik == 0) cycle

            iS = 1
            iE = nik*jBas
            CiKj(1:nik*jBas) => CijK(iS:iE)

            jSOj = jSO-nBas(j2)
            iAdrJ = nik*(jSOj-1)+iAdrCVec(j2+1,iSym,iSO)
            call dDaFile(LuCVector(j2+1,iSO),2,CiKj,nik*jBas,iAdrJ)

            if (lSO /= jSO) then
              iS = iE+1
              iE = iE+nik*lBas
              CiKl(1:nik*lBas) => CijK(iS:iE)

              lSOl = lSO-nBas(j4)
              iAdrL = nik*(lSOl-1)+iAdrCVec(j4+1,iSym,iSO)
              call dDaFile(LuCVector(j4+1,iSO),2,CiKl,nik*lBas,iAdrL)
              V2(1:) => CiKl(1:)
            else
              V2(1:) => CiKj(1:)
            end if

            Fact = One
            if (iSym /= kSym) Fact = Half
            call DGEMM_('T','N',jBas,lBas,nik,Fact,CikJ,nik,V2,nik,One,A,jBas)

          end do

          mijkl = 0
          do lAOl=0,lBas-1
            lSOl = lSO+lAOl-nBas(j4)
            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-nBas(j2)
              mijkl = mijkl+1

              ! Coulomb contribution
              if (j2 == 0) then
                ! j4 == 0 also
                temp = V_K(jSOj,1)*V_K(lSOl,1)*CoulFac
                !temp = Zero
              else
                temp = Zero
              end if

              ! Exchange contribution
              temp = temp-ExFac*A(mijkl)

              temp2 = Zero
              jpSOj = CumnnP2(j2)+(jSOj-1)*nnP(j2)
              jpSOl = CumnnP2(j2)+(lSOl-1)*nnP(j2)
              do jp=1,nnP(j2)
                temp2 = temp2+sign(One,DMdiag(CumnnP(j2)+jp,1))*Z_p_K(jpSOj+jp,1)*Z_p_K(jpSOl+jp,1)
              end do
              temp = temp+temp2

              PMax = max(PMax,abs(Temp))
              PSO(mijkl,MemSO2) = Fac*temp

            end do
          end do

        end do
      end do

    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((iMP2prpt /= 2) .and. lPSO .and. lSA) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! SA-CASSCF

  write(u6,*) 'Pget2_ri2: SA-CASSCF not implemented yet'
  call Abend()

  do i2=1,iCmp(2)
    njSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) then
        jSym(njSym) = j
        njSym = njSym+1
      end if
    end do

    do i4=1,iCmp(4)
      nlSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(4)+i4,j) > 0) then
          lSym(nlSym) = j
          nlSym = nlSym+1
        end if
      end do
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Loop over irreps which are spanned by the basis function.

      do js=0,njSym-1
        j2 = jSym(js)
        jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)

        do ls=0,nlSym-1
          j4 = lSym(ls)
          if (j2 /= j4) cycle
          lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)

          MemSO2 = MemSO2+1

          A(1:jBas*lBas) = Zero

          do iSym=1,nIrrep
            kSym = Mul(j2+1,iSym)
            nik = nIJ1(iSym,kSym,iSO)

            if (nik == 0) cycle

            iS = 1
            iE = nik*jBas
            CiKj(1:nik*jBas) => CijK(iS:iE)

            jSOj = jSO-nBas(j2)
            iAdrJ = nik*(jSOj-1)+iAdrCVec(j2+1,iSym,iSO)
            call dDaFile(LuCVector(j2+1,iSO),2,CiKj,nik*jBas,iAdrJ)

            if (lSO /= jSO) then
              iS = iE+1
              iE = iE+nik*lBas
              CiKl(1:nik*lBas) => CijK(iS:iE)

              lSOl = lSO-nBas(j4)
              iAdrL = nik*(lSOl-1)+iAdrCVec(j4+1,iSym,iSO)
              call dDaFile(LuCVector(j4+1,iSO),2,CiKl,nik*lBas,iAdrL)
              V2(1:) => CiKl(1:)
            else
              V2(1:) => CiKj(1:)
            end if

            Fact = One
            if (iSym /= kSym) Fact = Half
            call DGEMM_('T','N',jBas,lBas,nik,Fact,CiKJ,nik,V2,nik,One,A,jBas)

          end do

          mijkl = 0
          do lAOl=0,lBas-1
            lSOl = lSO+lAOl-nBas(j4)
            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-nBas(j2)
              mijkl = mijkl+1

              ! Coulomb contribution
              if (j2 == 0) then
                ! j4 == 0 also
                temp = CoulFac*(V_K(lSOl,1)*V_K(jSOj,2)+V_K(lSOl,2)*V_K(jSOj,1)+V_K(lSOl,3)*V_K(jSOj,4)+V_K(lSOl,4)*V_K(jSOj,3))
                !temp = Zero
              else
                temp = Zero
              end if

              ! Exchange contribution
              temp = temp-ExFac*A(mijkl)

              PMax = max(PMax,abs(Temp))
              PSO(mijkl,MemSO2) = Fac*temp

            end do
          end do

        end do
      end do

    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! MP2

  write(u6,*) 'Pget2_ri2: MP2 not implemented yet'
  call Abend()

  do i2=1,iCmp(2)
    njSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) then
        jSym(njSym) = j
        njSym = njSym+1
      end if
    end do

    do i4=1,iCmp(4)
      nlSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(4)+i4,j) > 0) then
          lSym(nlSym) = j
          nlSym = nlSym+1
        end if
      end do
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Loop over irreps which are spanned by the basis function.

      do js=0,njSym-1
        j2 = jSym(js)
        jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)

        do ls=0,nlSym-1
          j4 = lSym(ls)
          if (j2 /= j4) cycle
          lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)

          MemSO2 = MemSO2+1

          A(1:jBas*lBas) = Zero

          do iSym=1,nIrrep
            kSym = Mul(j2+1,iSym)
            nik = nIJ1(iSym,kSym,iSO)

            if (nik == 0) cycle

            iS = 1
            iE = nik*jBas
            CiKj(1:nik*jBas) => CijK(iS:iE)

            jSOj = jSO-nBas(j2)
            iAdrJ = nik*(jSOj-1)+iAdrCVec(j2+1,iSym,iSO)
            call dDaFile(LuCVector(j2+1,iSO),2,CiKj,nik*jBas,iAdrJ)

            if (lSO /= jSO) then
              iS = iE+1
              iE = iE+nik*lBas
              CiKl(1:nik*lBas) => CijK(iS:iE)

              lSOl = lSO-nBas(j4)
              iAdrL = nik*(lSOl-1)+iAdrCVec(j4+1,iSym,iSO)
              call dDaFile(LuCVector(j4+1,iSO),2,CiKl,nik*lBas,iAdrL)
              V2(1:) => CiKl(1:)
            else
              V2(1:) => CiKj(1:)
            end if

            Fact = One
            if (iSym /= kSym) Fact = Half
            call DGEMM_('T','N',jBas,lBas,nik,Fact,CiKj,nik,V2,nik,One,A,jBas)

          end do

          mijkl = 0
          do lAOl=0,lBas-1
            lSOl = lSO+lAOl-nBas(j4)
            do jAOj=0,jBas-1
              jSOj = jSO+jAOj-nBas(j2)
              mijkl = mijkl+1

              ! Coulomb contribution
              if (j2 == 0) then
                ! j4 == 0 also
                temp = V_K(jSOj,1)*V_K(lSOl,1)*CoulFac
                !temp = Zero
              else
                temp = Zero
              end if

              ! Exchange contribution
              temp = temp-ExFac*A(mijkl)

              PMax = max(PMax,abs(Temp))
              PSO(mijkl,MemSO2) = Fac*temp

            end do
          end do

        end do
      end do

    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
nullify(CiKj,CiKl,V2)
!                                                                      *
!***********************************************************************
!                                                                      *
if (nPSO /= MemSO2) then
  write(u6,*) ' PGet2: nPSO /= MemSO2'
  write(u6,*) nPSO,MemSO2
  call Abend()
end if

#ifdef _DEBUGPRINT_
call RecPrt(' In PGet2_RI2:PSO ',' ',PSO,nijkl,nPSO)
#endif

call CWTime(Cpu2,Wall2)
Cpu = Cpu2-Cpu1
Wall = Wall2-Wall1
tavec(1) = tavec(1)+Cpu
tavec(2) = tavec(2)+Wall

return

end subroutine PGet2_RI2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine ThetaOpt(FRot,theta,SumVee,StatePair,NPairs,DDg)

use rasscf_global, only: lRoots
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: FRot(lRoots,lRoots)
integer(kind=iwp), intent(in) :: NPairs, StatePair(NPairs,2)
real(kind=wp), intent(out) :: theta(NPairs), SumVee
real(kind=wp), intent(in) :: DDG(lRoots,lRoots,lRoots,lRoots)
integer(kind=iwp) :: IPair

do IPair=1,NPairs
  call OptOneAngle(theta(iPair),SumVee,FRot,DDg,StatePair(IPair,1),StatePair(IPair,2),lRoots)
end do
do IPair=NPairs-1,1,-1
  call OptOneAngle(theta(iPair),SumVee,FRot,DDg,StatePair(IPair,1),StatePair(IPair,2),lRoots)
end do

end subroutine ThetaOpt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function is_opened(lu)
! help function to get the value without using the module

use Fast_IO, only: isOpen, MxFile
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: is_opened
integer(kind=iwp), intent(in) :: lu

if ((lu > 0) .and. (lu < MxFile)) then
  is_opened = isOpen(lu) /= 0
else
  is_opened = .false.
end if

return

end function is_opened

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RFTTS(BLOCKSI,BLOCKSO,IBLOCK,NBLOCK,NSMST,NSASO,NSBSO,IDC)
! Reformat between determinant and combination form of matrices.
! No scaling is performed.
!
! dets to combs
!
! Combination storage mode is defined BY IDC
!
! Jeppe Olsen, August 1995

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: BLOCKSI(*)
real(kind=wp), intent(_OUT_) :: BLOCKSO(*)
integer(kind=iwp), intent(in) :: NBLOCK, IBLOCK(8,NBLOCK), NSMST, NSASO(NSMST,*), NSBSO(NSMST,*), IDC
integer(kind=iwp) :: IASM, IATP, IBSM, IBTP, IOFFI, IOFFO, IPACK, JBLOCK, LENGTH, NELMNT, NIA, NIB

LENGTH = 0

#ifdef _DEBUGPRINT_
write(u6,*) ' Information from RFTTS'
write(u6,*) ' ======================'
write(u6,*) ' Input vector'
call WRTTTS(BLOCKSI,IBLOCK,NBLOCK,NSMST,NSASO,NSBSO,1)
#endif

do JBLOCK=1,NBLOCK

  IATP = IBLOCK(1,JBLOCK)
  IBTP = IBLOCK(2,JBLOCK)
  IASM = IBLOCK(3,JBLOCK)
  IBSM = IBLOCK(4,JBLOCK)
  if (IBLOCK(1,JBLOCK) > 0) then

    IOFFI = IBLOCK(5,JBLOCK)
    IOFFO = IBLOCK(6,JBLOCK)
    ! Is this block diagonal in packed form
    if ((IDC == 2) .and. (IASM == IBSM) .and. (IATP == IBTP)) then
      IPACK = 1
    else
      IPACK = 0
    end if
    NIA = NSASO(IASM,IATP)
    NIB = NSBSO(IBSM,IBTP)
    ! Number of elements in output block
    if (IPACK == 1) then
      NELMNT = nTri_Elem(NIA)
    else
      NELMNT = NIA*NIB
    end if
    !write(u6,*) ' JBLOCK, NELMNT = ',JBLOCK,NELMNT
    !write(u6,*) ' RFTTS : IATP IBTP IASM IBSM ',IATP,IBTP,IASM,IBSM
    !write(u6,*) ' RFTTS : NIA NIB IOFFI,IOFFO',NIA,NIB,IOFFI,IOFFO

    if (IPACK == 0) then
      ! Just copy
      BLOCKSO(IOFFO:IOFFO+NELMNT-1) = BLOCKSI(IOFFI:IOFFI+NELMNT-1)
    else
      ! unpacked => packed
      !    TRIPK31(AUTPAK,APAK,MATDIM,NDIM)
      call TRIPK31(BLOCKSI(IOFFI),BLOCKSO(IOFFO),NIA,NIA)
    end if
    LENGTH = LENGTH+NELMNT
  end if
end do

BLOCKSI(1:LENGTH) = BLOCKSO(1:LENGTH)

#ifdef _DEBUGPRINT_
write(u6,*) ' Information from RFTTS'
write(u6,*) ' ======================'
write(u6,*) ' Output vector'
call WRTTTS(BLOCKSO,IBLOCK,NBLOCK,NSMST,NSASO,NSBSO,2)
#endif

end subroutine RFTTS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE NEXT(P,DPS,CN)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION P(*),DPS(*),CN(*)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
C
      IAD=IADDP(1)
      CALL dDAFILE(Lu_CI,2,P,NCONF,IAD)
      ITM=ITPUL-1
      DO 5 I=1,ITM
        IN=I+1
        CTOT=0.0D00
        DO 6 J=IN,ITPUL
          CTOT=CTOT+CN(J)
6       CONTINUE
        IAD=IADDP(I+1)
        CALL dDAFILE(Lu_CI,2,DPS,NCONF,IAD)
        CALL VSMA(DPS,1,CTOT,P,1,P,1,NCONF)
5     CONTINUE
      IF(IPRINT.GE.15)WRITE(6,19)(P(I),I=1,NCONF)
19    FORMAT(6X,'C(NEXT)',5F10.6)
C
      IADC(ITPUL+2)=IAD
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*  Branching_Plane_Update
*
*> @brief
*>   Apply the Branching plane update method of Maeda et al.
*> @author Roland Lindh
*> @modified_by Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> The branching plane of conical intersection is defined by two vectors,
*> the gradient difference vector (GDV) and the coupling derivative vector
*> (CDV). Equivalently, it can be defined with two orthonormal vectors
*> \f$ x \f$ and \f$ y \f$, such that \f$ x \f$ has the same direction as
*> GDV and \f$ \{x,y\} \f$ spans the same space as GDV and CDV.
*>
*> This routine obtains an approximate \f$ y \f$ vector, by assuming that
*> the branching plane defined by \f$ \{x,y\} \f$ changes the least from
*> iteration to iteration \cite Mae2010-JCTC-6-1538. Thus:
*>
*> \f[ y_k = \beta y_{k-1} - \alpha x_{k-1} \\
*>     \alpha = \frac{y_{k-1}\cdot x_k}{w} \\
*>     \beta  = \frac{x_{k-1}\cdot x_k}{w} \\
*>     w      = \sqrt{(y_{k-1}\cdot x_k)^2+(x_{k-1}\cdot x_k)^2} \f]
*>
*> As an initial guess for the CDV, the average gradient vector (AGV) at
*> the first iteration is used.
*>
*> @param[in]     AGV   Average gradient vector(s)
*> @param[in]     DGV   Difference gradient vector(s)
*> @param[in,out] CDV   Approximate coupling derivative vector, \f$ y \f$
*> @param[in]     n     Size of the vectors
*> @param[in]     nIter Iteration number
************************************************************************
      Subroutine Branching_Plane_Update(AGV,DGV,CDV,n,nIter)
      Implicit Real*8 (a-h,o-z)
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
      Real*8 AGV(n,nIter), DGV(n,nIter), CDV(n)
      Real*8, Allocatable:: x0(:), x1(:)
*
      iRout = 31
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.6) Then
         Write (6,*) 'Branching plane'
         Write (6,*) 'n,nIter=',n,nIter
         Call RecPrt('AGV',' ',AGV,n,nIter)
         Call RecPrt('DGV',' ',DGV,n,nIter)
         Call RecPrt('CDV (init)',' ',CDV,n,1)
      End If
      Call mma_allocate(x0,n,Label='x0')
      Call mma_allocate(x1,n,Label='x1')
*
*     Get the directional vector for the first difference gradient
*     vector (DGV).
*
      call dcopy_(n,DGV,1,x0,1)
      r = One / Sqrt(DDot_(n,x0,1,x0,1))
      Call DScal_(n,r,x0,1)
      call dcopy_(n,x0,1,x1,1)
*
*     Initial guess for the coupling derivative vector (CDV) is the
*     average gradient vector (AGV).
*     ... or rather its component perpendicular to DGV
*     so, remove the projection of CDV along DGV and renormalize
*
      call dcopy_(n,AGV,1,CDV,1)
      proj = DDot_(n,CDV,1,x0,1)
      Call DaXpY_(n,-proj,x0,1,CDV,1)
      r = One / Sqrt(DDot_(n,CDV,1,CDV,1))
      Call DScal_(n,r,CDV,1)
      If (iPrint.ge.6) Then
         Call RecPrt('CDV(0)',' ',CDV,n,1)
      End If
*
*     Apply the MOM update method to correct the guessed CDV.
*
*     ipx0: xk-1, ~DGV of previous iteration
*     ipx1: xk,   ~DGV of current iteration
*
      Do iter=2,nIter
         call dcopy_(n,DGV(1,iter),1,x1,1)
         r = One / Sqrt(DDot_(n,x1,1,x1,1))
         Call DScal_(n,r,x1,1)
*
         xx=DDot_(n,x0,1,x1,1)
         yx=DDot_(n,CDV,1,x1,1)
         yx_xx=Sqrt(yx**2+xx**2)
*
*        different signs from the paper, should not matter,
*        but will keep the y vector sign if x does not change
         alpha=-yx/yx_xx
         beta=xx/yx_xx
         Call DScal_(n,beta,CDV,1)
         Call DaXpY_(n,alpha,x0,1,CDV,1)
*
*        remove the projection of CDV along DGV and renormalize
*
         If (iPrint.ge.6) Then
            Write (6,*)
            Write (6,*) 'iter=',iter
            Write (6,*) 'r(DGV)=',r
            Write (6,*) 'xx=',xx
            Write (6,*) 'yx=',yx
            Write (6,*) 'alpha,beta=',alpha,beta
         End If
*
         proj=DDot_(n,CDV,1,x1,1)
         Call DaXpY_(n,-proj,x1,1,CDV,1)
         r = One / Sqrt(DDot_(n,CDV,1,CDV,1))
         Call DScal_(n,r,CDV,1)
*
         If (iPrint.ge.6) Then
            Write (6,*) 'r(CDV)=',r
         End IF
*
         If (iter.ne.nIter) call dcopy_(n,x0,1,x1,1)
*
      End Do
*
      Call mma_deallocate(x1)
      Call mma_deallocate(x0)
      If (iPrint.ge.6) Then
         Call RecPrt('CDV',' ',CDV,n,1)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1993,1999, Roland Lindh                           *
*               1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine Eval_ijkl(iiS,jjS,kkS,llS,TInt,nTInt,Integ_Proc)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals, parallel region          *
*          contains memory partitioning and loops over uncontracted    *
*          functions...                                                *
*                                                                      *
*  Input:                                                              *
*          iiS,jjS,kkS,llS     : shell indices                         *
*          TInt                : Computed Integrals                    *
*                                                                      *
*  Auxiliary:                                                          *
*          ipMem1              : base pointer to Scratch space for     *
*                                Integral batch, which is further      *
*                                partitioned within this subroutine    *
*          MemMax              : amount of wrkspace for processing of  *
*                                integral batch                        *
*                                                                      *
*  Local:                                                              *
*          Coor                : coordinates of four centers           *
*          iAngV               : angular momenta                       *
*          iCmpV               : # spherical components                *
*          iShelV,iShllV       : shell indices                         *
*          iAOV                : pointers to ??                        *
*          iStabs              : IDs of 4 unique centers, i.e. ptrs to *
*          Shijij,                           : swap booleans           *
*                                                                      *
*          nTInt               : dimension of TInt                     *
*          iTOffs              : iTOffs holds symmetry block offsets   *
*                                                                      *
*     Author: Roland Lindh / Martin Schuetz,                           *
*             Dept. of Theoretical Chemistry, University of Lund,      *
*             SWEDEN.                                                  *
*             Modified for k2 loop. August '91                         *
*             Modified for direct SCF. January '93                     *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. '93          *
*             parallel region split off in drvtwo.f, April '95         *
*             Total rehack May '99                                     *
************************************************************************
      use k2_setup
      use k2_arrays
      use iSD_data
      use Basis_Info
      use Real_Info, only: CutInt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Integ_Proc
*
*     Dummy definitions
*
      Parameter (nDens=1, lDens=1)
      Real*8 Fock(lDens), Dens(lDens), ExFac(nDens)
      Logical FckNoClmb(nDens), FckNoExch(nDens)
#include "iTOffs.fh"
*
*     subroutine parameters
      Real*8  Coor(3,4),Thize, Disc_Mx,Disc, TInt(nTInt), Tmax
      Integer iAngV(4),iCmpV(4), iShelV(4),iShllV(4),iAOV(4),iStabs(4),
     &        ipMem1,MemMax, kOp(4) ,Map4(4)
      Logical Shijij, W2Disc,PreSch,NoInts, DoIntegrals,DoFock
*
#include "ndarray.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "setup.fh"
#include "status.fh"
*
      Common /ibas_ricd/ jbas_, lbas_
*     local variables to save
      Integer ipDDij,ipDDkl,ipDDik,ipDDil,ipDDjk,ipDDjl,
     &        iBsInc,jBsInc,kBsInc,lBsInc,iPrInc,jPrInc,kPrInc,lPrInc,
     &        ipMem2,
     &        Mem1,Mem2
      Save    ipDDij,ipDDkl,ipDDik,ipDDil,ipDDjk,ipDDjl,
     &        iBsInc,jBsInc,kBsInc,lBsInc,iPrInc,jPrInc,kPrInc,lPrInc,
     &        ipMem2,
     &        Mem1,Mem2
*     other local variables
      Integer iAOst(4), iPrimi,jPrimj,kPrimk,lPriml,
     &        iBasi,jBasj,kBask,lBasl,
     &  iBasn,jBasn,kBasn,lBasn,
     &  k2ij,nDCRR,k2kl,nDCRS, ipTmp,
     &  mDij,mDik,mDjk,mDkl,mDil,mDjl,
     &  mDCRij,mDCRik,mDCRjk,mDCRkl,mDCRil,mDCRjl,
     &  ipDij,ipDik,ipDjk,ipDkl,ipDil,ipDjl,
     &  ipZI,ipKab,ipP,nZeta,
     &  ipEta,ipEI,ipiEta,ipKcd,ipQ,nEta
      Integer   nSO,iBasAO,jBasAO,kBasAO,lBasAO,
     &  iS,jS,kS,lS,ijS,klS,ikS,ilS,jkS,jlS
      Logical IJeqKL
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      nElem(i)=(i+1)*(i+2)/2
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      mDCRij=1
      mDCRkl=1
*                                                                      *
************************************************************************
*                                                                      *
      If (ERI_Status.ne.Active) Then
         Call WarningMessage(2,
     &               'Eval_Ints_: Integral environment is not set up!')
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      iRout=9
      iPrint=nPrint(iRout)
*
      NoInts=.True.
      Tmax=Zero
      Thize=0.0D0
      W2Disc=.False.
      PreSch=.True.
      Disc_Mx=0.0D0
      Disc=0.0D0
      Quad_ijkl=0.0D0
      DoIntegrals=.True.
      DoFock=.False.
      FckNoClmb(1)=.False.
      FckNoExch(1)=.False.
*                                                                      *
************************************************************************
*                                                                      *
*     If memory not allocated already at this point allocate!          *
*                                                                      *
      If (.Not.Allocated(Sew_Scr)) Then
C        Write (*,*) 'Eval_ints: Allocate memory'
         Call mma_MaxDBLE(MemMax)
         Call mma_allocate(Sew_Scr,MemMax,Label='Sew_Scr')
      Else
C        Write (*,*) 'Eval_ints: Memory already allocated'
         MemMax=SIZE(Sew_Scr)
      End If
C     Write (*,*) 'Eval_ints: MemMax=',MemMax
      ipMem1=1
*
      Map4(1)=1
      Map4(2)=2
      Map4(3)=3
      Map4(4)=4
      iS_=Max(iiS,jjS)
      jS_=Min(iiS,jjS)
      kS_=Max(kkS,llS)
      lS_=Min(kkS,llS)
      If (iiS.ne.iS_) Then
          iTmp=Map4(1)
          Map4(1)=Map4(2)
          Map4(2)=iTmp
      End If
      If (kkS.ne.kS_) Then
          iTmp=Map4(3)
          Map4(3)=Map4(4)
          Map4(4)=iTmp
      End If
*     Write (*,*) ' -->',iS_,jS_,kS_,lS_,'<--'
*                                                                      *
************************************************************************
*                                                                      *
      Call Int_Setup(iSD,mSkal,iS_,jS_,kS_,lS_,Coor,Shijij,
     &               iAngV,iCmpV,iShelV,iShllV,iAOV,iStabs)
*                                                                      *
************************************************************************
*                                                                      *
      iPrimi   = Shells(iShllV(1))%nExp
      jPrimj   = Shells(iShllV(2))%nExp
      kPrimk   = Shells(iShllV(3))%nExp
      lPriml   = Shells(iShllV(4))%nExp
      iBasi    = Shells(iShllV(1))%nBasis
      jBasj    = Shells(iShllV(2))%nBasis
      kBask    = Shells(iShllV(3))%nBasis
      lBasl    = Shells(iShllV(4))%nBasis
      nZeta    = iPrimi * jPrimj
      nEta     = kPrimk * lPriml
      mDij=nZeta+1 ! Dummy initialize
      mDkl=nEta+1  ! Dummy initialize
*
      nHRRAB=iCmpV(1)*iCmpV(2)*
     &      (nabSz(iAngV(1)+iAngV(2)) -
     &       nabSz(Max(iAngV(1),iAngV(2))-1))
      nHRRCD=iCmpV(3)*iCmpV(4)*
     &      (nabSz(iAngV(3)+iAngV(4)) -
     &       nabSz(Max(iAngV(3),iAngV(4))-1))
      nHRRAB=nHRRAB*nIrrep
      nHRRCD=nHRRCD*nIrrep
      If (DoGrad_) Then
         ijCmp=nElem(iAngV(1))*nElem(iAngV(2))
         klCmp=nElem(iAngV(3))*nElem(iAngV(4))
      Else
         ijCmp=0
         klCmp=0
      End If
      mData1=nZeta*(nDArray+2*ijCmp)+nDScalar+nHRRAB
      mData2=nEta*(nDArray+2*klCmp)+nDScalar+nHRRCD
*                                                                      *
************************************************************************
*                                                                      *
*     partition memory for K2(ij)/K2(kl) temp spaces zeta,eta,kappa,P,Q
      ipZI  = ipZeta + nZeta
      ipKab = ipZI   + nZeta
      ipP   = ipKab  + nZeta
      ipEta = ipP    + nZeta*3
      ipEI  = ipEta  + nEta
      ipKcd = ipEI   + nEta
      ipQ   = ipKcd  + nEta
      ipiEta = ipiZet + nZeta + 1
*                                                                      *
************************************************************************
*                                                                      *
*
*     No SO block in direct construction of the Fock matrix.
      nSO = MemSO2(iAngV(1),iAngV(2),iAngV(3),iAngV(4),
     &             iCmpV(1),iCmpV(2),iCmpV(3),iCmpV(4),
     &             iShelV(1),iShelV(2),iShelV(3),iShelV(4),
     &             iAOV(1),iAOV(2),iAOV(3),iAOV(4))
      If (nSO.eq.0) Then
        Return
      End If
      If (.Not.DoIntegrals) nSO = 0
*
      iS = iShelV(1)
      jS = iShelV(2)
      kS = iShelV(3)
      lS = iShelV(4)
      ijS = iTri(iS,jS)
      klS = iTri(kS,lS)
      ikS = iTri(iS,kS)
      ilS = iTri(iS,lS)
      jkS = iTri(jS,kS)
      jlS = iTri(jS,lS)
*                                                                      *
************************************************************************
*                                                                      *
*-----Pick up pointers to k2 entities.
*

      k2ij  = IndK2(1,ijS)
      nDCRR = IndK2(2,ijS)
      k2kl  = IndK2(1,klS)
      nDCRS = IndK2(2,klS)
*                                                                      *
************************************************************************
*                                                                      *
*-----Pick up pointers to desymmetrized 1st order density
*     matrices. Observe that the desymmetrized 1st order
*     density matrices follows the contraction index.
*
      If (DoFock) Then
         ipTmp = ipDijs
         Nr_of_D=1
         Call Dens_Info(ijS,ipDij,ipDum,mDCRij,ipDDij,ipTmp,Nr_of_D)
         Call Dens_Info(klS,ipDkl,ipDum,mDCRkl,ipDDkl,ipTmp,Nr_of_D)
         Call Dens_Info(ikS,ipDik,ipDum,mDCRik,ipDDik,ipTmp,Nr_of_D)
         Call Dens_Info(ilS,ipDil,ipDum,mDCRil,ipDDil,ipTmp,Nr_of_D)
         Call Dens_Info(jkS,ipDjk,ipDum,mDCRjk,ipDDjk,ipTmp,Nr_of_D)
         Call Dens_Info(jlS,ipDjl,ipDum,mDCRjl,ipDDjl,ipTmp,Nr_of_D)
*
c        Write (*,*) ' Pointers to D=',
c    &                ipDij,ipDkl,ipDik,ipDil,ipDjk,ipDjl
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.99) Then
         Write (6,*) ' *** Centers ***'
         Write (6,'(3F7.3,6X,3F7.3)')
     &         ((Coor(i,j),i=1,3),j=1,2)
         Write (6,'(3F7.3,6X,3F7.3)')
     &         ((Coor(i,j),i=1,3),j=3,4)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Compute memory request for the primitives, i.e.
*     how much memory is needed up to the transfer
*     equation.
      Call MemRys(iAngV,MemPrm)
*                                                                      *
************************************************************************
*                                                                      *
*     Decide on the partioning of the shells based on the
*     available memory and the requested memory.
      Call PSOAO0(nSO,MemPrm,MemMax,
     &            iAngV,iCmpV,
     &            iBasi,iBsInc,jBasj,jBsInc,
     &            kBask,kBsInc,lBasl,lBsInc,
     &            iPrimi,iPrInc,jPrimj,jPrInc,
     &            kPrimk,kPrInc,lPriml,lPrInc,
     &            ipMem1,ipMem2,
     &            Mem1,Mem2,DoFock)
      If (iPrint.ge.59) Then
         Write (6,*) ' ************** Memory partioning **************'
         Write (6,*) ' ipMem1=',ipMem1
         Write (6,*) ' ipMem2=',ipMem2
         Write (6,*) ' Mem1=',Mem1
         Write (6,*) ' Mem2=',Mem2
         Write (6,*) ' iBasi,iBsInc=',iBasi,iBsInc
         Write (6,*) ' jBasj,jBsInc=',jBasj,jBsInc
         Write (6,*) ' kBasi,kBsInc=',kBask,kBsInc
         Write (6,*) ' lBasl,lBsInc=',lBasl,lBsInc
         Write (6,*) ' iPrimi,iPrInc=',iPrimi,iPrInc
         Write (6,*) ' jPrimj,jPrInc=',jPrimj,jPrInc
         Write (6,*) ' kPrimk,kPrInc=',kPrimk,kPrInc
         Write (6,*) ' lPriml,lPrInc=',lPriml,lPrInc
         Write (6,*) ' ***********************************************'
      End If
*                                                                      *
************************************************************************
*                                                                      *
      jbas_=jBasj
      lbas_=lBasl
*                                                                      *
************************************************************************
*                                                                      *
*     FacInt : scaling factor for the integrals passed down to         *
*              Integ_Proc                                              *
*
      FacInt=1.0D0
*                                                                      *
************************************************************************
*                                                                      *
*     These loops will partition the contraction loops if there is not
*     enough memory to store the whole SO/AO-block simultaneously. The
*     memory partitioning is determined by PSOAO0.
*
      Do iBasAO = 1, iBasi, iBsInc
         iBasn=Min(iBsInc,iBasi-iBasAO+1)
         iAOst(1) = iBasAO-1
*
         Do jBasAO = 1, jBasj, jBsInc
            jBasn=Min(jBsInc,jBasj-jBasAO+1)
            iAOst(2) = jBasAO-1
*
*---------- Move appropiate portions of the desymmetrized 1st
*           order density matrix.
*
            If (DoFock) Then
               Call Picky_(iBasi,iBsInc,iPrimi,iBasAO,iBasn,
     &                     jBasj,jBsInc,jPrimj,jBasAO,jBasn,
     &                     iCmpV(1),iCmpV(2),iShelV(1),iShelV(2),
     &                     mDCRij,ipDij,ipDDij,mDij,DeDe,nDeDe)
            End If
*
            Do kBasAO = 1, kBask, kBsInc
               kBasn=Min(kBsInc,kBask-kBasAO+1)
               iAOst(3) = kBasAO-1
*
               If (DoFock) Then
                  Call Picky_(iBasi,iBsInc,iPrimi,iBasAO,iBasn,
     &                        kBask,kBsInc,kPrimk,kBasAO,kBasn,
     &                        iCmpV(1),iCmpV(3),iShelV(1),iShelV(3),
     &                        mDCRik,ipDik,ipDDik,mDik,DeDe,nDeDe)
               End If
*
               If (DoFock) Then
                  Call Picky_(jBasj,jBsInc,jPrimj,jBasAO,jBasn,
     &                        kBask,kBsInc,kPrimk,kBasAO,kBasn,
     &                        iCmpV(2),iCmpV(3),iShelV(2),iShelV(3),
     &                        mDCRjk,ipDjk,ipDDjk,mDjk,DeDe,nDeDe)
               End If
*
                Do lBasAO = 1, lBasl, lBsInc
                   lBasn=Min(lBsInc,lBasl-lBasAO+1)
                   iAOst(4) = lBasAO-1
*
                   If (DoFock) Then
                      Call Picky_(kBask,kBsInc,kPrimk,kBasAO,kBasn,
     &                            lBasl,lBsInc,lPriml,lBasAO,lBasn,
     &                            iCmpV(3),iCmpV(4),iShelV(3),iShelV(4),
     &                            mDCRkl,ipDkl,ipDDkl,mDkl,DeDe,nDeDe)
                   End If
*
                   If (DoFock) Then
                      Call Picky_(iBasi,iBsInc,iPrimi,iBasAO,iBasn,
     &                            lBasl,lBsInc,lPriml,lBasAO,lBasn,
     &                            iCmpV(1),iCmpV(4),iShelV(1),iShelV(4),
     &                            mDCRil,ipDil,ipDDil,mDil,DeDe,nDeDe)
                   End If
*
                   If (DoFock) Then
                      Call Picky_(jBasj,jBsInc,jPrimj,jBasAO,jBasn,
     &                            lBasl,lBsInc,lPriml,lBasAO,lBasn,
     &                            iCmpV(2),iCmpV(4),iShelV(2),iShelV(4),
     &                            mDCRjl,ipDjl,ipDDjl,mDjl,DeDe,nDeDe)
                   End If
*                                                                      *
************************************************************************
*                                                                      *
*                 Compute SO/AO-integrals
*
                  If (nIrrep.eq.1) Then
*
                  Call TwoEl_NoSym_New(iS_,jS_,kS_,lS_,
     &                            Coor,
     &                            iAngV,iCmpV,iShelV,iShllV,
     &                            iAOV,iAOst,NoInts,
     &                            iStabs(1),iStabs(2),
     &                            iStabs(3),iStabs(4),
     &                            iPrimi,iPrInc,jPrimj,jPrInc,
     &                            kPrimk,kPrInc,lPriml,lPrInc,
     &                            Data_k2(k2ij),mData1,nDCRR,
     *                            Data_k2(k2kl),mData2,nDCRS,
     &                            IJeqKL,kOp,Disc_Mx,Disc,Thize,
     &                            DeDe(ipDDij),mDij,mDCRij,
     &                            DeDe(ipDDkl),mDkl,mDCRkl,
     & DeDe(ipDDik),mDik,mDCRik,DeDe(ipDDil),mDil,mDCRil,
     & DeDe(ipDDjk),mDjk,mDCRjk,DeDe(ipDDjl),mDjl,mDCRjl,
     &           Fock,Dens,lDens,
     &                  Shells(iShllV(1))%pCff(1,iBasAO),iBasn,
     &                  Shells(iShllV(2))%pCff(1,jBasAO),jBasn,
     &                  Shells(iShllV(3))%pCff(1,kBasAO),kBasn,
     &                  Shells(iShllV(4))%pCff(1,lBasAO),lBasn,
     &                  FT,nFT,
     & Mem_DBLE(ipZeta),Mem_DBLE(ipZI),Mem_INT(ipiZet),Mem_DBLE(ipKab),
     & Mem_DBLE(ipP),nZeta,
     & Mem_DBLE(ipEta), Mem_DBLE(ipEI),Mem_INT(ipiEta),Mem_DBLE(ipKcd),
     & Mem_DBLE(ipQ),nEta,
     & Sew_Scr(ipMem1),nSO,Sew_Scr(ipMem2),Mem2,
     & Shijij,W2Disc,PreSch,Quad_ijkl,nHRRAB,nHRRCD,
     & DoIntegrals,DoFock,FckNoClmb(1),FckNoExch(1),Aux,nAux,
     & ExFac(1))
*
                  Else
*

                  Call TwoEl_Sym_New(iS_,jS_,kS_,lS_,
     &                            Coor,
     &                            iAngV,iCmpV,iShelV,iShllV,
     &                            iAOV,iAOst,NoInts,
     &                            iStabs(1),iStabs(2),
     &                            iStabs(3),iStabs(4),
     &                            iPrimi,iPrInc,jPrimj,jPrInc,
     &                            kPrimk,kPrInc,lPriml,lPrInc,
     &                            Data_k2(k2ij),mData1,nDCRR,
     &                            Data_k2(k2kl),mData2,nDCRS,
     &                            IJeqKL,kOp,Disc_Mx,Disc,Thize,
     &                            DeDe(ipDDij),mDij,mDCRij,
     &                            DeDe(ipDDkl),mDkl,mDCRkl,
     & DeDe(ipDDik),mDik,mDCRik,DeDe(ipDDil),mDil,mDCRil,
     & DeDe(ipDDjk),mDjk,mDCRjk,DeDe(ipDDjl),mDjl,mDCRjl,
     &           Fock,Dens,lDens,
     &                  Shells(iShllV(1))%pCff(1,iBasAO),iBasn,
     &                  Shells(iShllV(2))%pCff(1,jBasAO),jBasn,
     &                  Shells(iShllV(3))%pCff(1,kBasAO),kBasn,
     &                  Shells(iShllV(4))%pCff(1,lBasAO),lBasn,
     &                            FT,nFT,
     & Mem_DBLE(ipZeta),Mem_DBLE(ipZI),Mem_INT(ipiZet),Mem_DBLE(ipKab),
     & Mem_DBLE(ipP),nZeta,
     & Mem_DBLE(ipEta), Mem_DBLE(ipEI),Mem_INT(ipiEta),Mem_DBLE(ipKcd),
     & Mem_DBLE(ipQ),nEta,
     & Sew_Scr(ipMem1),nSO,Sew_Scr(ipMem2),Mem2,
     & Shijij,W2Disc,PreSch,Quad_ijkl,nHRRAB,nHRRCD,
     & DoIntegrals,DoFock,FckNoClmb(1),FckNoExch(1),Aux,nAux,
     & ExFac(1))
*
                  End If
*                                                                      *
************************************************************************
*                                                                      *
*              Process SO/AO-integrals
*
                  nijkl=iBasn*jBasn*kBasn*lBasn
                  If (DoIntegrals.and..Not.NoInts) Then
*                    Get max AO/SO integrals
                     If (nIrrep.eq.1) Then
                        n=nijkl*iCmpV(1)*iCmpV(2)*iCmpV(3)*iCmpV(4)
                        ip=ipMem2
                     Else
                        n=nijkl*nSO
                        ip=ipMem1
                     End If
                     Tmax=max(Tmax,
     &                        abs(Sew_Scr(ip+
     &                            iDAMax_(n,Sew_Scr(ip),1)-1)))
                     If (Tmax.gt.CutInt) Then
                        Call Integ_Proc(iCmpV,iShelV,Map4,
     &                                  iBasn,jBasn,kBasn,lBasn,kOp,
     &                                  Shijij,IJeqKL,iAOV,iAOst,nijkl,
     &                                  Sew_Scr(ipMem2),
     &                                  Sew_Scr(ipMem1),nSO,
     &                                  iSOSym,mSkal,nSOs,
     &                                  TInt,nTInt,iTOffs,nIrrep)
                     Else
                        Tmax=Zero
                     End If
                  End If
*
               End Do
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine EGrad(O,T,V,S,D,nOTSD,C,nC,G,nG,nD,CMO)
************************************************************************
*                                                                      *
*     purpose: This routine calculates the gradient of the SCF energy  *
*              with respect to the rotation parameters.                *
*              Grad(E) = C(t)(FDS-SDF)C                                *
*                                                                      *
*                                                                      *
*     input:                                                           *
*       O       : one-electron hamiltonian of length nOTSD             *
*       T       : two-electron hamiltonian of length nOTSD             *
*       V       : external potential       of length nOTSD             *
*       S       : overlap in AO basis of length nOTSD                  *
*       D       : density matrix of length nOTSD                       *
*       C       : matrix transforming to the set of orthonormal        *
*                 (and spherical, if needed) functions of length nC    *
*                                                                      *
*     output:                                                          *
*       G       : gradient of the SCF energy with respect to the       *
*                 rotation parameters of length nG                     *
*                                                                      *
*     called from: GrdClc                                              *
*                                                                      *
*     calls to: ModFck, Asym                                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*                                                                      *
*     Corrected for an error of 2.0                                    *
*     R. Lindh, Harvard University, 2017                               *
*                                                                      *
************************************************************************
      Use Orb_Type
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 O(nOTSD),T(nOTSD,nD),S(nOTSD),D(nOTSD,nD),C(nC,nD),
     &       V(nOTSD,nD), G(nG,nD), CMO(nC,nD)
*
      Real*8, Dimension(:,:), Allocatable:: FckM
      Real*8, Dimension(:), Allocatable:: Aux1, Aux2, Aux3
*
*----------------------------------------------------------------------*
*     Start
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call NrmClc(O,nOTSD   ,'EGrad','O')
      Call NrmClc(S,nOTSD   ,'EGrad','S')
      Call NrmClc(D,nOTSD*nD,'EGrad','D')
      Call NrmClc(T,nOTSD*nD,'EGrad','T')
      Call NrmClc(V,nOTSD*nD,'EGrad','V')
      Call NrmClc(C,nC   *nD,'EGrad','C')
#endif
*----------------------------------------------------------------------*
*
*---- Allocate memory for modified fock matrix
      Call mma_allocate(FckM,nBT,nD,Label='FckM')
      Call FZero(FckM,nBT*nD)
      Call FZero(G,nG*nD)
*
*---- Allocate memory for auxiliary matrices
      Call mma_allocate(Aux1,MaxBas**2,Label='Aux1')
      Call mma_allocate(Aux2,MaxBas**2,Label='Aux2')
      Call mma_allocate(Aux3,MaxBas**2,Label='Aux3')
*
      Do iD = 1, nD
*
         Call DZAXPY(nBT,1.0D0,O,1,T(1,iD),1,FckM(1,iD),1)
#ifdef _DEBUGPRINT_
         Call NrmClc(FckM(1,iD),nBT,'EGrad','FckM')
#endif
         If (nnFr.gt.0)
     &      Call ModFck(FckM(1,iD),S,nBT,CMO(1,iD),nBO,nOcc(1,1))
*
         Call DaXpY_(nBT,1.0D0,V(1,iD),1,FckM(1,iD),1)
#ifdef _DEBUGPRINT_
         Call NrmClc(FckM(1,iD),nBT,'EGrad','FckM')
#endif
*
         iOff = 0
         ij = 1
         it = 1
         ig = 1
         Do iSym = 1, nSym
            nBs = nBas(iSym)
            nOr = nOrb(iSym)
            nOrbmF = nOrb(iSym)-nFro(iSym)
*
            If (nOrb(iSym).gt.0) Then
*define _ALTERNATIVE_CODE_
#ifdef _ALTERNATIVE_CODE_
*
*              This is an alternative section to compute the gradients.
*              In this section you have an early difference followed
*              by a late purification to guarantee G is stricktly
*              anti-symmetric.
*
*              Observations so far is only minute changes on very small
*              gradients.
*
*----------    Square Fock matrix
               Call Square(FckM(ij,iD),Aux1,1,nBs,nBs)
*----------    Square density matrix
               Call DSq(D(ij,iD),Aux2,1,nBs,nBs)
*----------    Perform FD
               Call DGEMM_('N','N',
     &                     nBs,nBs,nBs,
     &                     1.0D0,Aux1,nBs,
     &                           Aux2,nBs,
     &                     0.0D0,Aux3,nBs)
*----------    Square overlap matrix and perform FDS
               Call Square(S(ij),Aux1,1,nBs,nBs)
               Call DGEMM_('N','N',
     &                     nBs,nBs,nBs,
     &                     1.0D0,Aux3,nBs,
     &                           Aux1,nBs,
     &                     0.0D0,Aux2,nBs)
*----------    Form FDS-SDF
               Call Asym(Aux2,Aux3,nBs)
*----------    Perform C(T)(FDS-SDF)
               Call DGEMM_('T','N',
     &                     nOr,nBs,nBs,
     &                     1.0d0,C(it,iD),nBs,
     &                           Aux3,nBs,
     &                     0.0d0,Aux1,nOr)
*----------    Perform C(T)(FDS-SDF)C
               Call DGEMM_('N','N',
     &                     nOr,nOr,nBs,
     &                     1.0d0,Aux1,nOr,
     &                           C(it,iD),nBs,
     &                     0.0d0,G(ig,iD),nOr)
               Call Purify(G(ig,iD),nOr)
#else
*
*----------    Square Fock matrix and perform C(T)F
               Call Square(FckM(ij,iD),Aux2,1,nBs,nBs)
               Call DGEMM_('T','N',
     &                     nOr,nBs,nBs,
     &                     1.0d0,C(it,iD),nBs,
     &                           Aux2,nBs,
     &                     0.0d0,Aux1,nOr)
*
*----------    Square density matrix and perform C(T)FD
               Call DSq(D(ij,iD),Aux2,1,nBs,nBs)
               Call DGEMM_('N','N',
     &                     nOr,nBs,nBs,
     &                     1.0d0,Aux1,nOr,
     &                           Aux2,nBs,
     &                     0.0d0,Aux3,nOr)
*
*----------    Square overlap matrix and perform C(T)FDS
               Call Square(S(ij),Aux2,1,nBs,nBs)
               Call DGEMM_('N','N',
     &                     nOr,nBs,nBs,
     &                     1.0d0,Aux3,nOr,
     &                           Aux2,nBs,
     &                     0.0d0,Aux1,nOr)
*----------    C(T)FDSC
               Call DGEMM_('N','N',
     &                     nOr,nOr,nBs,
     &                     1.0d0,Aux1,nOr,
     &                           C(it,iD),nBs,
     &                     0.0d0,Aux2,nOr)
*
               Call Asym(Aux2,G(ig,iD),nOr)
#endif
*
*              At this point enforce that the gradient is exactly zero
*              for elements corresponding to orbitals of different
*              fermion types.
*
               Do i = 1, nOr
                  If (i.le.nFro(iSym)) Then
                     k=-1
                  Else
                     k=OrbType(iOff+i-nFro(iSym),iD)
                  End If
*
                  Do j = 1, nOr
                     If (i.le.nFro(iSym)) Then
                        l=-1
                     Else
                        l=OrbType(iOff+j-nFro(iSym),iD)
                     End If
*
                     ih = ig + (i-1)*nOr + j - 1
                     If (k.lt.0 .or. l.lt.0 .or. k.ne.l) G(ih,iD)=0.0D0
*
                  End Do
               End Do
*
            End If
            ij = ij + nBs*(nBs + 1)/2
            it = it + nBs*nOr
            ig = ig + nOr*nOr
            iOff = iOff + nOrbmF
*
         End Do ! iSym
*
      End Do ! iD
*
*---- Deallocate memory
      Call mma_deallocate(Aux3)
      Call mma_deallocate(Aux2)
      Call mma_deallocate(Aux1)
      Call mma_deallocate(FckM)
*
      Call DScal_(nG*nD,2.0D0,G,1)
*
#ifdef _DEBUGPRINT_
*     Call RecPrt('EGrad: G',' ',G,nG,nD)
#endif
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End
      SubRoutine Asym(H,A,n)
************************************************************************
*                                                                      *
*     purpose: Antisymmetrize matrix                                   *
*                                                                      *
*     input:                                                           *
*       H       : input matrix                                         *
*       n       : dimension                                            *
*                                                                      *
*     output:                                                          *
*       A       : antisymmetrized matrix                               *
*                                                                      *
*     called from: EGrad                                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
      Real*8 H(n,n),A(n,n)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*
      Do j = 1, n
         Do i = 1, n
            A(i,j) = H(i,j) - H(j,i)
         End Do
      End Do
*
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End
#ifdef _NEW_CODE_
      Subroutine Purify(A,n)
      Implicit Real*8 (a-h,o-z)
      Real*8 A(n,n)
*
      Do i = 1, n
         Do j = 1, n
            tmp = A(i,j) - A(j,i)
            A(i,j) = 0.5D0*tmp
            A(j,i) = -A(i,j)
         End Do
      End Do
      Return
      End
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_SetAddr()
!
! Purpose: set initial disk addresses for local as well as global reduced sets.

use Cholesky, only: Cho_Real_Par, InfRed, InfRed_G, InfVec, InfVec_G, LuPri, MaxRed, MaxVec, nSym, XnPass
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: irc
character(len=*), parameter :: SecNam = 'Cho_P_SetAddr'

if (Cho_Real_Par) then

  ! The variable XnPass must be zero: restart is not possible.
  ! ----------------------------------------------------------

  if (XnPass /= 0) call Cho_Quit('XnPass>0 error in '//SecNam,104)

  ! Global.
  ! -------

  call Cho_P_SetAddr_2(InfRed_G,InfVec_G,MaxRed,MaxVec,size(InfVec,2),nSym,irc)
  if (irc /= 0) then
    write(Lupri,*) SecNam,': Cho_P_SetAddr_2 returned ',irc
    call Cho_Quit('Error in '//SecNam,104)
  end if

end if

! Local.
! ------

call Cho_SetAddr(InfRed,InfVec,MaxRed,MaxVec,size(InfVec,2),nSym)

end subroutine Cho_P_SetAddr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine espf_write(MltOrd,iRMax,DeltaR,iGrdTyp,nGrdPt,DoTinker,DoGromacs,lMorok,Mltp,nMult,IsMM,natom,Show_espf,Forces,DoDirect)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: MltOrd, iRMax, iGrdTyp, nGrdPt, nMult, natom, IsMM(natom)
real(kind=wp), intent(in) :: DeltaR, Mltp(nMult)
logical(kind=iwp), intent(in) :: DoTinker, DoGromacs, lMorok, Show_espf, Forces, DoDirect
integer(kind=iwp) :: iAt, iMlt, iPL, IPotFl, ITkQMMM
real(kind=wp) :: EQMMM
logical(kind=iwp) :: Exists
real(kind=wp), allocatable :: Grad(:,:)
integer(kind=iwp), external :: iPL_espf, IsFreeUnit

! Espf data are saved

iPL = iPL_espf()

! Save data in the ESPF.DATA file

IPotFl = 12
IPotFl = IsFreeUnit(IPotFl)
call Molcas_Open(IPotFl,'ESPF.DATA')
write(IPotFl,'(A10,I10)') 'MLTORD    ',MltOrd/4
write(IPotFl,'(A10,I10)') 'IRMAX     ',iRMax
write(IPotFl,'(A10,F12.9)') 'DELTAR    ',DeltaR
write(IPotFl,'(A10,I10)') 'GRIDTYPE  ',iGrdTyp
write(IPotFl,'(A10,I10)') 'GRID      ',nGrdPt
if (DoTinker) write(IPotFl,'(A10)') 'TINKER    '
if (DoGromacs) write(IPotFl,'(A10)') 'GROMACS   '
if (lMorok) write(IPotFl,'(A10)') 'LA_MOROK  '
if (DoDirect) write(IPotFl,'(A10)') 'DIRECT    '
if (nMult > 0) then
  write(IPotFl,'(A10,I10)') 'MULTIPOLE ',nMult
  iMlt = 1
  do iAt=1,natom
    if (IsMM(iAt) == 0) then
      if (MltOrd == 1) then
        write(IPotFl,'(I6,4F15.8)') iAt,Mltp(iMlt),Zero,Zero,Zero
      else
        write(IPotFl,'(I6,4F15.8)') iAt,Mltp(iMlt:iMlt+3)
      end if
      iMlt = iMlt+MltOrd
    end if
  end do
end if
write(IPotFl,'(A10)') 'ENDOFESPF '
close(IPotFl)

if (Show_espf .or. (iPL >= 4)) then
  write(u6,'(/,A,/)') ' Informations found in the ESPF data file:'
  write(u6,'(A10,I10)') ' MLTORD   ',MltOrd/4
  write(u6,'(A10,I10)') ' IRMAX    ',iRMax
  write(u6,'(A10,F12.9)') ' DELTAR   ',DeltaR
  write(u6,'(A10,I10)') ' GRIDTYPE ',iGrdTyp
  write(u6,'(A10,I10)') ' GRID     ',nGrdPt
  if (DoTinker) write(u6,'(A10)') ' TINKER   '
  if (DoGromacs) write(u6,'(A10)') ' GROMACS  '
  if (lMorok) write(u6,'(A10)') ' LA_MOROK '
  if (DoDirect) write(u6,'(A10)') ' DIRECT   '
  if (nMult > 0) then
    write(u6,'(A10,I10)') ' MULTIPOLE ',nMult
    iMlt = 1
    do iAt=1,natom
      if (IsMM(iAt) == 0) then
        if (MltOrd == 1) then
          write(u6,'(I6,4F15.8)') iAt,Mltp(iMlt),Zero,Zero,Zero
        else
          write(u6,'(I6,4F15.8)') iAt,Mltp(iMlt:iMlt+3)
        end if
        iMlt = iMlt+MltOrd
      end if
    end do
  end if
  write(u6,'(A10)') ' ENDOFESPF'
end if

! Special case: Tinker is the driver of the QM/MM calculation.
! QM energy + gradient + ESPF multipoles are stored into the QMMM file

call F_Inquire('QMMM',Exists)
if (Exists .and. Forces .and. (.not. DoTinker)) then
  ITkQMMM = IsFreeUnit(15)
  call Molcas_Open(ITkQMMM,'QMMM')
  call Get_dScalar('Last energy',EQMMM)
  write(ITkQMMM,'(F12.7,I5)') EQMMM,MltOrd/4
  call mma_allocate(Grad,3,nAtom,Label='Grad')
  call Get_dArray_chk('GRAD',Grad,3*nAtom)
  iMlt = 1
  do iAt=1,natom
    write(ITkQMMM,'(7F12.7)') Grad(1:3,iAt),Mltp(iMlt:iMlt+MltOrd-1)
    iMlt = iMlt+MltOrd
  end do
  close(ITkQMMM)
  call mma_deallocate(Grad)
  close(ITkQMMM)
end if

return

end subroutine espf_write

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_SrtDrv(irc,DelOrig)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: presort Cholesky vectors according to batch structure in
C              MP2 program.
C
C     DelOrig: input : flag for deleting original vector files.
C              output: flag to tell that at least 1 symmetry block has
C                      in fact been deleted.
C
#include "implicit.fh"
      Logical DelOrig
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "cholesky.fh"
#include "WrkSpc.fh"

      Character*6  ThisNm
      Character*13 SecNam
      Parameter (SecNam = 'ChoMP2_SrtDrv', ThisNm = 'SrtDrv')

      LnT1am(i,j)=iWork(ip_LnT1am-1+nSym*(j-1)+i)
      lUnit(i,j)=iWork(ip_lUnit-1+nSym*(j-1)+i)

      irc = 0
      If (nBatch .lt. 1) Return


C     Allocate available memory.
C     --------------------------

      Call GetMem('GetMax','Max ','Real',ipWrk,lWrk)
      Call GetMem('SrtMax','Allo','Real',ipWrk,lWrk)

C     Set vector type (i.e., transformed vectors or vectors from (ai|bj)
C     decomposition. Decide whether original files should be deleted.
C     ------------------------------------------------------------------

      If (DecoMP2) Then
         iTyp = 2
      Else
         iTyp = 1
      End If

      If (DelOrig) Then
         iClos = 3
      Else
         iClos = 2
      End If
      DelOrig = .false.

C     Start symmetry loop.
C     --------------------

      Do iSym = 1,nSym

C        Set number of vectors.
C        ----------------------

         If (iTyp .eq. 1) Then
            nSrtVec = NumCho(iSym)
         Else If (iTyp .eq. 2) Then
            nSrtVec = nMP2Vec(iSym)
         Else
            irc = -1
            Go To 1 ! exit
         End If

         If (nT1am(iSym).gt.0 .and. nSrtVec.gt.0) Then

C           Set up vector batch.
C           --------------------

            LnT1amx = 0
            Do iBatch = 1,nBatch
               LnT1amx = max(LnT1amx,LnT1am(iSym,iBatch))
            End Do

            MinMem = nT1am(iSym) + LnT1amx
            NumVec = min(lWrk/MinMem,nSrtVec)
            If (NumVec .lt. 1) Then
               irc = 1
               Go To 1 ! exit
            Else
               nBat = (nSrtVec - 1)/NumVec + 1
            End If

C           Open full vector file.
C           ----------------------

            Call ChoMP2_OpenF(1,iTyp,iSym)

C           Start batch loop.
C           -----------------

            Do iBat = 1,nBat

               If (iBat .eq. nBat) Then
                  NumV = nSrtVec - NumVec*(nBat-1)
               Else
                  NumV = NumVec
               End If
               iVec1 = NumVec*(iBat-1) + 1

C              Read batch of vectors.
C              ----------------------

               lChoMO = nT1am(iSym)*NumV

               kChoMO = ipWrk

               iOpt = 2
               lTot = lChoMO
               iAdr = nT1am(iSym)*(iVec1-1) + 1
               Call ddaFile(lUnit_F(iSym,iTyp),iOpt,Work(kChoMO),lChoMO,
     &                      iAdr)

C              Sort and write to disk.
C              -----------------------

               kSort  = ipWrk + lChoMO
               lSort  = lWrk  - lChoMO
               Do iBatch = 1,nBatch
                  lTot = LnT1am(iSym,iBatch)*NumV
                  If (lSort .lt. lTot) Then
                     Call ChoMP2_Quit(SecNam,'sort batch error','[0]')
                  End If
                  Call ChoMP2_Srt(Work(kChoMO),Work(kSort),NumV,
     &                            iSym,iBatch)
                  Call ChoMP2_OpenB(1,iSym,iBatch)
                  iOpt = 1
                  iAdr = LnT1am(iSym,iBatch)*(iVec1-1) + 1
                  Call ddaFile(lUnit(iSym,iBatch),iOpt,Work(kSort),lTot,
     &                         iAdr)
                  Call ChoMP2_OpenB(2,iSym,iBatch)
               End Do

            End Do

C           Close (and possibly delete) full vector file.
C           ---------------------------------------------

            Call ChoMP2_OpenF(iClos,iTyp,iSym)
            DelOrig = iClos .eq. 3

         End If

      End Do

    1 Call GetMem('SrtMax','Free','Real',ipWrk,lWrk)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1996, Markus P. Fuelscher                         *
************************************************************************
      SUBROUTINE EXPLH2(DIAG,ONEINT,TUVX,ISEL,EXPLE,EXPLV)
************************************************************************
*                                                                      *
*     Compute and diagonalize the explicit Hamiltonian in a            *
*     subspace smaller or identical to nSel. nSel may be chosen        *
*     somewhat smaller in order to avoid selecting only one of         *
*     several degenerate diagonal matrix elements.                     *
*                                                                      *
*     calling arguments:                                               *
*     DIAG    : array of Real*8                                        *
*               diagonal Hamiltonian                                   *
*     ONEINT  : array of Real*8                                        *
*               one-electron integrals                                 *
*     TUVX    : array of Real*8                                        *
*               two-electron integrals                                 *
*     ISEL    : array of integer                                       *
*               index array                                            *
*     EXPLE   : array of Real*8                                        *
*               eigenvalues of the explicit Hamiltonian                *
*     EXPLV   : array of Real*8                                        *
*               eigenvectors of the explicit Hamiltonian               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and J. Olsen                                      *
*     University of Lund, Sweden, 1990                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*     - updated for integral direct and reaction field calculations    *
*       M.P. Fuelscher, University of Lund, Sweden, 1996               *
*                                                                      *
************************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "ciinfo.fh"
#include "spinfo.fh"
#include "csfbas.fh"
#include "strnum.fh"
#include "WrkSpc.fh"
#include "timers.fh"
#include "output_ras.fh"
      PARAMETER (ROUTINE='EXPLH2  ')
      DIMENSION DIAG(*)
      DIMENSION ONEINT(*)
      DIMENSION TUVX(*)
      DIMENSION EXPLE(*)
      DIMENSION EXPLV(*)
      DIMENSION ISEL(*)
*
      Call Timing(Omega_1,Swatch,Swatch,Swatch)
      IPRLEV=IPRLOC(3)

      ECORE=0.0D0
      MXXSEL=NSEL
      NHEX=NSEL*(NSEL+1)/2
*
* ALLOCATE LOCAL MEMORY
*
      CALL GETMEM('IPCNF','ALLO','INTE',LW1,NCNASM(LSYM))
      CALL GETMEM('HONE','ALLO','REAL',LOCONE,NAC**2)
      CALL GETMEM('EXHAM','ALLO','REAL',LEXHAM,NHEX)
*
* EXPAND ONE-INTS FROM TRIANGULAR PACKING TO FULL STORAGE MODE
*
      CALL TRIEXP(ONEINT,Work(LOCONE),NAC)
*
* Load the diagonal approximation of the CI Hamiltonian
*
      Call Load_H_diag(nConf,DIAG,LuDavid)
*
* CONSTRUCT THE EXPLICIT HAMILTONIAN
*
      IPRINT=0
      IF(IPRLEV.EQ.INSANE) IPRINT=40
      CALL GETMEM('IREOTS','ALLO','INTEGER',IREOTS,NAC)
      CALL GETMEM('EXHSCR','MAX','REAL',LW2,MXXWS)
      CALL GETMEM('EXHSCR','ALLO','REAL',LW2,MXXWS)
      CALL GET_IREOTS(IWORK(IREOTS),NAC)
      CALL PHPCSF(Work(LEXHAM),ISEL,iWork(LW1),
     &            MXXSEL,Work(KDTOC),
     &            iWork(KDFTP),iWork(KICONF(1)),
     &            LSYM,Work(LOCONE),ECORE,NAC,
     &            Work(LW2),NCNASM(LSYM),
     &            (NAEL+NBEL),NAEL,NBEL,
     &            NSEL,NPCNF,DIAG,TUVX,IPRINT,ExFac,IWORK(IREOTS))
      IF ( IPRLEV.EQ.INSANE) then
        Call Square(Work(LEXHAM),EXPLV,1,NSEL,NSEL)
        CALL RECPRT('Square Explicit Hamiltonian',' ',EXPLV,NSEL,NSEL)
      END IF
      CALL GETMEM('EXHSCR','FREE','REAL',LW2,MXXWS)
      CALL GETMEM('IREOTS','FREE','INTEGER',IREOTS,NAC)
      CALL GETMEM('HONE','FREE','REAL',LOCONE,NAC**2)
      CALL GETMEM('IPCNF','FREE','INTE',LW1,NCNASM(LSYM))
*
* DIAGONALIZE THE EXPLICIT HAMILTONIAN.
*
*     If ( nSel.eq.nConf ) then
      If ( .true. ) then
        CALL DCOPY_(MXXSEL*MXXSEL,[0.0D0],0,EXPLV,1)
        DO 10 I=1,NSEL
          II=I+NSEL*(I-1)
          EXPLV(II)=1.0D00
10      CONTINUE
*       CALL Jacob(Work(LEXHAM),EXPLV,NSEL,NSEL)
#ifdef _DEBUGPRINT_
        CALL NIdiag(Work(LEXHAM),EXPLV,NSEL,NSEL,0)
#else
        CALL NIdiag_new(Work(LEXHAM),EXPLV,NSEL,NSEL,0)
#endif
        CALL JACORD(Work(LEXHAM),EXPLV,NSEL,NSEL)
        DO 15 I=1,NSEL
          EXPLE(I)=Work(LEXHAM-1+I*(I+1)/2)
15      CONTINUE
      Else
        Call GetMem('ExHscr','Allo','Real',lwscr,nSel)
        Call Square(Work(LEXHAM),EXPLV,1,NSEL,NSEL)
        Call Eigen_Molcas(NSEL,EXPLV,EXPLE,Work(lwscr))
        Call GetMem('ExHscr','Free','Real',lwscr,nSel)
      End If
      CALL GETMEM('EXHAM','FREE','REAL',LEXHAM,NHEX)
      IF( IPRLEV.GE.INSANE)
     &  CALL IVCPRT
     &    ('Configurations included in the explicit Hamiltonian',' ',
     &      ISEL,NSEL)
      IF( IPRLEV.GE.INSANE)
     &  CALL DVCPRT('Eigenvalues of the explicit Hamiltonian',' ',
     &               EXPLE,NSEL)
      IF( IPRLEV.GE.INSANE)
     &  CALL RECPRT('Eigenvectors of the explicit Hamiltonian',' ',
     &               EXPLV,NSEL,NSEL)
*
      Call Timing(Omega_2,Swatch,Swatch,Swatch)
      Omega_2 = Omega_2 - Omega_1
      Omega_3 = Omega_3 + Omega_2

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CISX(IDX,D,DS,PS,PA,SCR)

use Index_Functions, only: iTri, nTri_Elem
use rasscf_global, only: NAC, NACPR2
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IDX(NAC)
real(kind=wp), intent(inout) :: D(*), DS(*), PS(*), PA(*)
real(kind=wp), intent(_OUT_) :: SCR(*)
integer(kind=iwp) :: I, ICASE, IJKLN, IJKLO, IJNEW, IJO, J, K, KLNEW, L, LLIM, NIJ, NIJKL
real(kind=wp) :: SGN, SGN0

! Convert from CI to SX ordering
! Note: A factor of 2 arises because matrices are folded

! one-body density
IJO = 0
NIJ = nTri_Elem(NAC)
NIJKL = nTri_Elem(NIJ)
do I=1,NAC
  do J=1,I
    IJNEW = iTri(IDX(I),IDX(J))
    IJO = IJO+1
    SCR(IJNEW) = D(IJO)
  end do
end do
D(1:NIJ) = SCR(1:NIJ)

! spin density
IJO = 0
NIJ = nTri_Elem(NAC)
NIJKL = nTri_Elem(NIJ)
do I=1,NAC
  do J=1,I
    IJNEW = iTri(IDX(I),IDX(J))
    IJO = IJO+1
    SCR(IJNEW) = DS(IJO)
  end do
end do
DS(1:NIJ) = SCR(1:NIJ)

! symmetrized (iCase=1) and antisymmetrized (iCase=2) two-body density
do ICASE=1,2
  IJKLO = 0
  SCR(1:NACPR2) = Zero
  do I=1,NAC
    do J=1,I
      if (IDX(J) > IDX(I)) then
        SGN0 = -One
      else
        SGN0 = One
      end if
      IJNEW = iTri(IDX(I),IDX(J))
      do K=1,I
        LLIM = K
        if (K == I) LLIM = J
        do L=1,LLIM
          IJKLO = IJKLO+1
          if (IDX(L) > IDX(K)) then
            SGN = -SGN0
          else
            SGN = SGN0
          end if
          KLNEW = iTri(IDX(K),IDX(L))
          IJKLN = iTri(IJNEW,KLNEW)
          if (ICASE == 1) then
            if (KLNEW > IJNEW) then
              if ((K == L) .and. (I /= J)) then
                SCR(IJKLN) = Two*PS(IJKLO)
              else if ((I == J) .and. (K /= L)) then
                SCR(IJKLN) = Half*PS(IJKLO)
              else
                SCR(IJKLN) = PS(IJKLO)
              end if
            else
              SCR(IJKLN) = PS(IJKLO)
            end if
          else
            SCR(IJKLN) = SGN*PA(IJKLO)
          end if
        end do
      end do
    end do
  end do
  if (ICASE == 1) then
    PS(1:NIJKL) = SCR(1:NIJKL)
  else
    PA(1:NIJKL) = SCR(1:NIJKL)
  end if

end do

end subroutine CISX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SymAd1(lOper,iAng,jAng,iCmp,jCmp,iShell,jShell,iShll,jShll,iAO,jAO,AOInt,iBas,jBas,nIC,iIC,SOInt,nSOInt,nOp)
!***********************************************************************
!                                                                      *
! Object: to transform the one-electon matrix elements from AO basis   *
!         to SO basis.                                                 *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January '91                                              *
!***********************************************************************

use Index_Functions, only: nTri3_Elem
use Basis_Info, only: Shells
use Symmetry_Info, only: iChBas, iChTbl, iOper, nIrrep, Prmt
use SOAO_Info, only: iAOtSO
use Real_Spherical, only: iSphCr
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: lOper, iAng, jAng, iCmp, jCmp, iShell, jShell, iShll, jShll, iAO, jAO, iBas, jBas, nIC, nSOInt, &
                                 nOp(2)
real(kind=wp), intent(in) :: AOInt(iBas*jBas,iCmp,jCmp,nIC)
integer(kind=iwp), intent(inout) :: iIC
real(kind=wp), intent(inout) :: SOInt(iBas*jBas,nSOInt)
integer(kind=iwp) :: i1, i2, iChBs, ii, iIrrep, j1, j12, j2, jChBs, jIC(0:7), jj, jMx, kIC, lSO
real(kind=wp) :: pae, pbr, xa, xb

#ifdef _DEBUGPRINT_
write(u6,*) ' lOper=',lOper
write(u6,*) ' nSOInt=',nSOInt
call RecPrt(' In SymAd1: AOInt',' ',AOInt,iBas*jBas,iCmp*jCmp*nIC)
call RecPrt(' In SymAd1: SOInt',' ',SOInt,iBas*jBas,nSOInt)
write(u6,*) ' iIC=',iIC
#endif
do iIrrep=0,nIrrep-1
  jIC(iIrrep) = -999999999
  if (.not. btest(lOper,iIrrep)) cycle
  jIC(iIrrep) = iIC
  iIC = iIC+1
end do

ii = nTri3_Elem(iAng)
jj = nTri3_Elem(jAng)

lSO = 0
do j1=0,nIrrep-1
  xa = real(iChTbl(j1,nOp(1)),kind=wp)
  do i1=1,iCmp
    if (iAOtSO(iAO+i1,j1) < 0) cycle
    iChBs = iChBas(ii+i1)
    if (Shells(iShll)%Transf) iChBs = iChBas(iSphCr(ii+i1))
    pae = Prmt(iOper(nOp(1)),iChBs)

    do j2=0,nIrrep-1
      j12 = ieor(j1,j2)

      if (.not. btest(lOper,j12)) cycle
      kIC = jIC(j12)
      xb = real(iChTbl(j2,nOp(2)),kind=wp)
      jMx = jCmp
      if ((iShell == jShell) .and. (j1 == j2)) jMx = i1

      do i2=1,jMx
        if (iAOtSO(jAO+i2,j2) < 0) cycle
        lSO = lSO+1
        jChBs = iChBas(jj+i2)
        if (Shells(jShll)%Transf) jChBs = iChBas(iSphCr(jj+i2))
        pbr = Prmt(iOper(nOp(2)),jChBs)
        SOInt(:,lSO) = SOInt(:,lSO)+xa*pae*xb*pbr*AOInt(:,i1,i2,kIC)
      end do

    end do

  end do
end do
if (lSO /= nSOInt) then
  call WarningMessage(2,'Error in SymAd1, lSO /= nSOInt')
  call Abend()
end if

#ifdef _DEBUGPRINT_
call RecPrt(' In SymAd1: SOInt',' ',SOInt,iBas*jBas,nSOInt)
#endif

return

end subroutine SymAd1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Step1(iCenter,Matrix,nDim,TMatrix,iType,Matrix0,
     &                 Temp)
*                                                                      *
************************************************************************
*                                                                      *
*     Step 1. LO S0 ->S1
*     occupied virtual on the same center
*     and orthonormalization of the original AO basis
*     The call to lowdin gives me a transforation A1, and a transformed
*     S matrix
*
      Implicit ReaL*8 (A-H,O-Z)
      Real*8 Matrix(nDim*nDim),TMatrix(nDim*nDim),Matrix0(nDim*nDim),
     &       Temp(nDim*nDim)
      Integer iCenter(nDim),iType(nDim)
#include "real.fh"
*
      k=0
      Do i=1,nDim
         Do j=1,nDim
             k=k+1
c               write (*,*) iCenter(i),iCenter(j), Matrix(k)
             if (iCenter(i).ne.iCenter(j)) then
                Matrix(k)=Zero
            endif
         End Do
      End Do
      Call GramSchmidt(Matrix,TMatrix,nDim,iType,iCenter,0)
      call dcopy_(nDim**2,Matrix0,1,Matrix,1)
*
*     Now apply T1 to original S: S2=T1(T)*S*T1
*
      Call DGEMM_('N','N',
     &            nDim,nDim,nDim,
     &            1.0d0,Matrix,nDim,
     &            TMatrix,nDim,
     &            0.0d0,Temp,nDim)
      Call DGEMM_('T','N',
     &            nDim,nDim,nDim,
     &            1.0d0,TMatrix,nDim,
     &            Temp,nDim,
     &            0.0d0,Matrix,nDim)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contone(L,oneoverR3,onecontr,Lmax,contcoeff,nprim,ncont,MxcontL,dummy,onecartX,onecartY,onecartZ,charge,oneonly)
!bs contracts one-electron integrals and multiplies with l,m-dependent
!bs factors for L-,L0,L+

use index_functions, only: iTri
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: L, Lmax, nprim, ncont, MxcontL
real(kind=wp), intent(in) :: oneoverR3(*), contcoeff(nprim,ncont), charge
real(kind=wp), intent(out) :: onecontr(MxcontL,MxcontL,-Lmax:Lmax,3), dummy(ncont,ncont)
real(kind=wp), intent(inout) :: onecartX(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1)), &
                                onecartY(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1)), onecartZ(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1))
logical(kind=iwp), intent(in) :: oneonly
integer(kind=iwp) :: icont1, icont2, iprim1, iprim2, M
real(kind=wp) :: factor0, factormin, factorplus

!bs first of all cleaning dummy and onecontr
dummy(:,:) = Zero
if (oneonly) then
  onecartx(:,:,:) = Zero
  onecarty(:,:,:) = Zero
  onecartz(:,:,:) = Zero
end if
onecontr(:,:,:,:) = Zero
!bs contract onto dummy
do icont1=1,ncont
  do icont2=1,ncont
    do iprim2=1,nprim
      do iprim1=1,nprim
        dummy(icont2,icont1) = dummy(icont2,icont1)+contcoeff(iprim1,icont1)*contcoeff(iprim2,icont2)*oneoverR3(iTri(iprim1,iprim2))
      end do
    end do
  end do
end do
!bs start to add l,m dependent factors
do M=-L,L
  factormin = charge*sqrt(real(L*L-M*M+L+M,kind=wp))
  factor0 = charge*real(M,kind=wp)
  factorplus = charge*sqrt(real(L*L-M*M+L-M,kind=wp))
  onecontr(1:ncont,1:ncont,M,1) = dummy*factormin  ! L-minus
  onecontr(1:ncont,1:ncont,M,2) = dummy*factor0    ! L-0
  onecontr(1:ncont,1:ncont,M,3) = dummy*factorplus ! L-plus
end do
!bs make the final cartesian integrals
call cartoneX(L,Lmax,onecontr,ncont,MxcontL,onecartX)
call cartoneY(L,Lmax,onecontr,ncont,MxcontL,onecartY)
call cartoneZ(L,Lmax,onecontr,ncont,MxcontL,onecartZ)

return

end subroutine contone

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  SetVectTrans
*
*> @brief
*>   Computes the translation vector from geometry 2 to geometry 1
*> @author Y. Carissan
*>
*> @details
*> Computes the translation vector from geometry 2 to geometry 1.
*>
*> @param[in]  nat1  Number of atoms in \p geom1
*> @param[in]  Geom1 First Geometry to be considered, xyz coordinates
*> @param[in]  XYZ1  atom index array in the first geometry
*> @param[in]  nat2  Number of atoms in \p geom2
*> @param[in]  Geom2 Second Geometry to be considered, xyz coordinates
*> @param[in]  XYZ2  atom index array in the second geometry
*> @param[out] V     Output vector
************************************************************************
      subroutine SetVectTrans(nat1,Geom1, XYZ1, nat2,Geom2, XYZ2,V)
      implicit none
#include "debug.fh"
#include "real.fh"
      Real*8 O1(3),O2(3)
      Real*8 V(3)
      Integer XYZ1(3),XYZ2(3),nat1,nat2
      Real*8 Geom1(3,nat1),Geom2(3,nat2)

      call dcopy_(3,Geom1(1,XYZ1(1)),1,O1,1)
      call dcopy_(3,Geom2(1,XYZ2(1)),1,O2,1)
      call daxpy_(3,-One,O2,1,O1,1)
      call dcopy_(3,O1,1,V,1)

      if (debug) then
        Call RecPrt("Vtrans",' ',V,3,1)
      end if
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GTSTTPS_1(IEL1,IEL3,NEL1,NEL3,NTYP,ITYP)
! ITYP : type of strings with IEL1,IEL3 electrons
!
! IEL1, IEL3 known, find ITYP

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: IEL1, IEL3, NEL1(*), NEL3(*), NTYP
integer(kind=iwp), intent(out) :: ITYP
integer(kind=iwp) :: IITYP

ITYP = -1
do IITYP=1,NTYP
  if ((IEL1 == NEL1(IITYP)) .and. (IEL3 == NEL3(IITYP))) ITYP = IITYP
end do

!if (ITYP == -1) then
!  write(u6,*) ' Error in GTSTTPS_1'
!  write(u6,*) ' Error : Type could not be identified'
!  write(u6,*) ' Error : IEL1 IEL3 : ',IEL1,IEL3
!  write(u6,*) ' I am going to STOP'
!  stop 'GSTTPS'
!endif

#ifdef _DEBUGPRINT_
write(u6,'(A,5I4)') ' GTSTTPS_1 : IEL1 IEL3 ITYP ',IEL1,IEL3,ITYP
#endif

end subroutine GTSTTPS_1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine IJKL(INTSYM,INDX,C,S,FIJKL)

use mrci_global, only: INDSRT, IRC, IROW, LASTAD, Lu_70, LUSYMB, LN, LSYM, NSRTMX, NVIR, NVPAIR, VALSRT
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: INTSYM(*), INDX(*)
real(kind=wp), intent(in) :: C(*)
real(kind=wp), intent(inout) :: S(*)
real(kind=wp), intent(_OUT_) :: FIJKL(*)
integer(kind=iwp) :: i, IADD10, IADR, IC1, IC2, ICHK, IIN, ILEN, IND, INDA, INDB, INDI, INUM, IP, IVL, JP, KP, LENGTH, LP, NA, NB, &
                     NIJ, NIJKL, NKL, NS1, NS1L
real(kind=wp) :: COPI, FINI
integer(kind=iwp), external :: JSUNP

!------
! POW: Unnecessary but warning stopping initialization
FINI = huge(FINI)
!------
ICHK = 0
NIJ = IROW(LN+1)
NIJKL = NIJ*(NIJ+1)/2
FIJKL(1:NIJKL) = Zero
IADR = LASTAD(1)
do
  call dDAFILE(Lu_70,2,VALSRT,NSRTMX,IADR)
  call iDAFILE(Lu_70,2,INDSRT,NSRTMX+2,IADR)
  LENGTH = INDSRT(NSRTMX+1)
  IADR = INDSRT(NSRTMX+2)
  do i=1,length
    FIJKL(INDSRT(i)) = VALSRT(i)
  end do
  if (IADR == -1) exit
end do
IADD10 = IAD10(5)
do
  call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
  call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
  ILEN = ICOP1(nCOP+1)
  if (ILEN < 0) exit
  do IIN=1,ILEN
    IND = ICOP1(IIN)
    if (ICHK /= 0) then
      ICHK = 0
      INDI = IND
      IP = ibits(INDI,0,8)
      JP = ibits(INDI,8,8)
      KP = ibits(INDI,16,8)
      LP = ibits(INDI,24,8)
      NIJ = IROW(IP)+JP
      NKL = IROW(KP)+LP
      IND = NIJ*(NIJ-1)/2+NKL
      FINI = FIJKL(IND)
    else if (IND == 0) then
      ICHK = 1
    else
      IVL = ibits(IND,0,6)
      IC2 = ibits(IND,6,13)
      IC1 = ibits(IND,19,13)
      COPI = COP(IIN)*FINI
      if (IVL == 0) then
        S(IC1) = S(IC1)+COPI*C(IC2)
        S(IC2) = S(IC2)+COPI*C(IC1)
      else
        INDA = IRC(IVL)+IC1
        INDB = IRC(IVL)+IC2
        NA = INDX(INDA)
        NB = INDX(INDB)
        NS1 = JSUNP(INTSYM,INDA)
        NS1L = MUL(NS1,LSYM)
        INUM = NVIR(NS1L)
        if (IVL >= 2) INUM = NVPAIR(NS1L)
        S(NA+1:NA+INUM) = S(NA+1:NA+INUM)+COPI*C(NB+1:NB+INUM)
        S(NB+1:NB+INUM) = S(NB+1:NB+INUM)+COPI*C(NA+1:NA+INUM)
      end if
    end if
  end do
end do

return

end subroutine IJKL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,COEFF,SGM,PSI)
! Purpose: Add to the wave function SGM the result of applying
! an operator to PSI. The operator is a single creator (IMODE=1)
! or annihilator (IMODE=-1) multiplied by COEFF. Only the
! sector of SGM described by IFSBTAB1 will be updated.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IMODE, ISORB, IORBTAB(*), ISSTAB(*), IFSBTAB1(*), IFSBTAB2(*)
real(kind=wp), intent(in) :: COEFF, PSI(*)
real(kind=wp), intent(inout) :: SGM(*)
integer(kind=iwp) :: I, IBLKPOS1, IBLKPOS2, IFSB1, IFSB2, IPOS1, IPOS2, ISBS1, ISBS2, ISP, ISPART, ISST, ISST1, ISST2, &
                     ISSTARR(50), ISUM, J, KHSH2, KOINFO, KPOS, KSBS1, KSBS2, KSBSAN, KSBSCR, KSBSOP, KSORB, KSSTAN, KSSTCR, &
                     KSSTOP, KSSTTB, KSTARR1, KSTARR2, MORSBITS, NASPRT, NDI, NDJ, NFSB1, NHSH2, NPOP1, NSBS1, NSBS2, NSSTP
real(kind=wp) :: CFFPHS, SCL
integer(kind=iwp), allocatable :: SBSET(:)

if (COEFF == Zero) return
! The orbital table:
NASPRT = IORBTAB(9)
KOINFO = 19
ISPART = IORBTAB(KOINFO+6+8*(ISORB-1))
KSORB = IORBTAB(KOINFO+7+8*(ISORB-1))
! The substring table:
MORSBITS = ISSTAB(6)
NSSTP = ISSTAB(7)
KSSTTB = 15
KSSTAN = ISSTAB(9)
KSSTCR = ISSTAB(10)
KSBSAN = ISSTAB(13)
KSBSCR = ISSTAB(14)
if (IMODE == 1) then
  KSSTOP = KSSTAN
  KSBSOP = KSBSAN
else
  KSSTOP = KSSTCR
  KSBSOP = KSBSCR
end if
! The FS blocks of the SGM wave function:
NFSB1 = IFSBTAB1(3)
KSTARR1 = 8
! The FS blocks of the PSI wave function:
NHSH2 = IFSBTAB2(6)
KHSH2 = IFSBTAB2(7)
KSTARR2 = 8
! Make an array with nr of earlier substrings for each
! substring type:
call mma_allocate(SBSET,NSSTP,Label='SBSET')
ISUM = 0
do ISST=1,NSSTP
  SBSET(ISST) = ISUM
  ISUM = ISUM+ISSTAB(KSSTTB+5*(ISST-1))
end do

! Loop over FS blocks of the SGM wave function
do IFSB1=1,NFSB1
  KPOS = KSTARR1+(NASPRT+2)*(IFSB1-1)
  ISSTARR(1:NASPRT) = IFSBTAB1(KPOS:KPOS+NASPRT-1)
  IBLKPOS1 = IFSBTAB1(KPOS+NASPRT+1)
  ! Initial values for lower and higher dimensions.
  ! Also, extra phase factor due to spin orbitals in higher substrings.
  NDI = 1
  do ISP=1,ISPART-1
    ISST1 = ISSTARR(ISP)
    NDI = NDI*ISSTAB(KSSTTB+5*(ISST1-1))
  end do
  NDJ = 1
  CFFPHS = COEFF
  do ISP=ISPART+1,NASPRT
    ISST1 = ISSTARR(ISP)
    NPOP1 = ISSTAB(KSSTTB+1+5*(ISST1-1))
    NDJ = NDJ*ISSTAB(KSSTTB+0+5*(ISST1-1))
    if (NPOP1 /= 2*(NPOP1/2)) CFFPHS = -CFFPHS
  end do
  ISST1 = ISSTARR(ISPART)
  NSBS1 = ISSTAB(KSSTTB+5*(ISST1-1))

  ! Modify the bra substring type by annih or creating ISORB
  ISST2 = ISSTAB(KSSTOP-1+KSORB+MORSBITS*(ISST1-1))
  if (ISST2 == 0) cycle

  ! Determine dimensions for multiple daxpy:
  ! Dimension  for earlier subpartitions is NDI
  ! Dimension  for later   subpartitions is NDJ
  ! Dimensions for present subpartition are NSBS1,NSBS2

  NSBS2 = ISSTAB(KSSTTB+5*(ISST2-1))
  ISSTARR(ISPART) = ISST2
  ! Get the corresponding FS block number
  call HSHGET(ISSTARR,NASPRT,NASPRT+2,IFSBTAB2(KSTARR2),NHSH2,IFSBTAB2(KHSH2),IFSB2)
  ISSTARR(ISPART) = ISST1
  if (IFSB2 == 0) cycle
  KPOS = KSTARR2+(NASPRT+2)*(IFSB2-1)
  IBLKPOS2 = IFSBTAB2(KPOS+NASPRT+1)
  ! Now loop over ket substrings in this subpartition
  do KSBS1=1,NSBS1
    ISBS1 = KSBS1+SBSET(ISST1)
    ISBS2 = ISSTAB(KSBSOP-1+KSORB+MORSBITS*(ISBS1-1))
    if (ISBS2 == 0) then
      cycle
    else if (ISBS2 > 0) then
      SCL = CFFPHS
      ISBS2 = ISBS2
    else
      SCL = -CFFPHS
      ISBS2 = -ISBS2
    end if
    KSBS2 = ISBS2-SBSET(ISST2)

    ! CALL some multiple daxpy...
    if (NDI == 1) then
      if (NDJ == 1) then
        IPOS1 = IBLKPOS1+(KSBS1-1)
        IPOS2 = IBLKPOS2+(KSBS2-1)
        SGM(IPOS1) = SGM(IPOS1)+SCL*PSI(IPOS2)
      else
        do J=0,NDJ-1
          IPOS1 = IBLKPOS1+(KSBS1-1+NSBS1*J)
          IPOS2 = IBLKPOS2+(KSBS2-1+NSBS2*J)
          SGM(IPOS1) = SGM(IPOS1)+SCL*PSI(IPOS2)
        end do
      end if
    else
      if (NDJ == 1) then
        do I=0,NDI-1
          IPOS1 = IBLKPOS1+I+NDI*(KSBS1-1)
          IPOS2 = IBLKPOS2+I+NDI*(KSBS2-1)
          SGM(IPOS1) = SGM(IPOS1)+SCL*PSI(IPOS2)
        end do
      else
        do J=0,NDJ-1
          do I=0,NDI-1
            IPOS1 = IBLKPOS1+I+NDI*(KSBS1-1+NSBS1*J)
            IPOS2 = IBLKPOS2+I+NDI*(KSBS2-1+NSBS2*J)
            SGM(IPOS1) = SGM(IPOS1)+SCL*PSI(IPOS2)
          end do
        end do
      end if
    end if

  end do

  ! End of loop over FS blocks
end do
call mma_deallocate(SBSET)

end subroutine PRIMSGM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Matthew R. Hennefarth                            *
!***********************************************************************
!  get_charge
!
!> @brief gets total molecular charge
!>
!> @author Matthew R. Hennefarth
!***********************************************************************

function get_charge()

use onedat, only: snoori
use general_data, only: nactel, nfro, nish, ntot1
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u0

implicit none
integer(kind=iwp) :: get_charge
#include "warnings.h"
integer(kind=iwp) :: comp, el_charge, nuc_charge, opt, rc, sylbl
character(len=8) :: label
real(kind=wp), allocatable :: int1e_ovlp(:)

rc = -1
opt = ibset(0,sNoOri)
comp = 1
sylbl = 1
label = 'Mltpl  0'

el_charge = -2*sum(nfro+nish)-nactel

call mma_allocate(int1e_ovlp,ntot1+4,label='int1e_ovlp')
call rdone(rc,opt,label,comp,int1e_ovlp,sylbl)
if (rc /= _RC_ALL_IS_WELL_) then
  call WarningMessage(2,'Error computing system charge')
  write(u0,*) 'Error calling rdone'
  write(u0,*) 'Label = ',label
  write(u0,*) 'RC = ',rc
  call abend()
end if

nuc_charge = nint(int1e_ovlp(size(int1e_ovlp)))
call mma_deallocate(int1e_ovlp)

get_charge = nuc_charge+el_charge

end function get_charge

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function nBas_Eff(NrExp,NrBas,Cff,nExp_Eff)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: nBas_Eff
integer(kind=iwp), intent(in) :: NrExp, NrBas, nExp_Eff
real(kind=wp), intent(in) :: Cff(NrExp,NrBas)
integer(kind=iwp) :: iBas, iExp

nBas_Eff = NrBas

do iBas=1,NrBas

  do iExp=1,nExp_Eff

    if (Cff(iExp,iBas) /= Zero) then
      nBas_Eff = NrBas-iBas+1
      return
    end if

  end do

end do

return

end function nBas_Eff

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine o12sa2_cvb(c,sxc,nprm,
     >   civb,civbs,
     >   cvbdet,cvb,vec_all)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension c(nprm),sxc(nprm)
      dimension civb(ndet),civbs(ndet)
      dimension cvbdet(ndetvb),cvb(nvb),vec_all(npr)
      dimension dum(1)

c  If no optimization of structure coefficients we are doing
c  "Augmented" calc:
      if(strucopt)then
        ic1=1
      else
        ic1=2
      endif

      call str2vbc_cvb(cvb,cvbdet)
      call vb2cic_cvb(cvbdet,civb)

      call cidot_cvb(civb,civbs,ret)
      call ci2vbg_cvb(civbs,cvbdet)
      call vb2strg_cvb(cvbdet,vec_all(nprorb+1))
      call fzero(vec_all,nprorb)
      call onedens_cvb(civb,civbs,vec_all,.false.,0)
      call all2free_cvb(vec_all,sxc(ic1),1)
      if(.not.strucopt)sxc(1)=ddot_(nvb,cvb,1,vec_all(nprorb+1),1)
      call fzero(vec_all,nprorb)
      call fmove_cvb(cvb,vec_all(nprorb+1),nvb)
      call all2free_cvb(vec_all,c(ic1),1)
      if(.not.strucopt)c(1)=ddot_(nvb,cvb,1,vec_all(nprorb+1),1)
      cnrm=ddot_(nprm,c,1,sxc,1)
      call dscal_(nprm,one/sqrt(cnrm),c,1)
      call dscal_(nprm,one/sqrt(cnrm),sxc,1)
      call ddrestv_cvb(c,dum,sxc,nprm,0,.false.,.true.)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine makegjorbs_cvb(orbs,gjorb,gjorb2,gjorb3)
c  Construct Gauss-Jordan factorizations of ORBS, ORBS transpose,
c  and overlap matrix corresonding to ORBS :
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension orbs(norb,norb),gjorb(*),gjorb2(*),gjorb3(*)

      iowrk  = mstackr_cvb(norb*norb)

      call gaussj_cvb(orbs,gjorb)

      call transp_cvb(orbs,w(iowrk),norb,norb)
      call gaussj_cvb(w(iowrk),gjorb2)

      call mxattb_cvb(orbs,orbs,norb,norb,norb,w(iowrk))
      call gaussj_cvb(w(iowrk),gjorb3)

      call mfreer_cvb(iowrk)

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
!***********************************************************************
!  Author : F. Aquilante
!
!  Purpose:
!          For a given set of total symmetric AO-densities
!          (hermitian matrix representation) and MO coefficients
!          this routine
!          computes the Coulomb and Exchange contributions
!          to the Fock matrix from Cholesky vectors in full storage
!
!          Coulomb term (Drs is the lower triangular matrix
!                        of r=s symmetry block. The diagonals
!                        are scaled by a factor 1/2 already in
!                        the packed density DLT, given as input)
!
!    F(pq) = F(pq) + FactC * Sum_J Lpq,J * (Sum_rs Drs*Lrs,J)
!
!          Exchange term (Crk is the squared matrix of MO coeff.
!                             of r=s symmetry block)
!
!    F(pq) = F(pq) - FactX * Sum_Jk [(Sum_r Crk * Lpr,J) * (Sum_s Csk * Lqs,J)]
!
!    Integral-fashion formula:
!
!    F(pq) =  Sum_rs Drs * [(pq|rs)  - 0.5 (ps|rq)]
!
!----------------------------------------------------------------------
!  DoCoulomb(nDen) :  specifies the densities for which coulomb term
!                     has to be computed
!
!  DoExchange(nDen) : specifies the densities for which exchange term
!                     has to be computed
!
!  FactC(nDen) : factor for the coulomb of the corresponding density
!  FactX(nDen) : factor for the exchange of the corresponding density
!
!  ip{X}SQ(nDen) : pointer to the array containing {X} in SQ storage
!    {X=D,F,M --- Density, Fock matrix, MOs coeff.}
!
!  MinMem(nSym) : minimum amount of memory required to read
!                 a single Cholesky vector in full storage
!
!***********************************************************************

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Fock_util_global, only: Deco, DensityCheck, Lunit
use Data_Structures, only: Deallocate_DT, DSBA_Type, Integer_Pointer, SBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nDen, lOff1, MinMem(nSym)
logical(kind=iwp), intent(in) :: DoCoulomb(nDen), DoExchange(nDen)
real(kind=wp), intent(in) :: FactC(nDen), FactX(nDen)
type(DSBA_Type), intent(in) :: DLT(nDen), DSQ(nDen), MSQ(nDen)
type(DSBA_Type), intent(inout) :: FLT(nDen), FSQ(nDen)
type(Integer_Pointer), intent(in) :: pNocc(nDen)
#include "chotime.fh"
integer(kind=iwp) :: iBatch, iE, irc, iS, iSkip(nSym), iSym, ISYMA, ISYMB, ISYMD, ISYMG, iSymp, ISYMQ, iSymr, iSymr_Occ, iSyms, &
                     iVec, jB, jD, jDen, jE, jjB, jjS, jR, jS, jSR, jSym, JVEC, k, kOcc(nSym), kRdMem, kSym, l, LKV, LVK, LWORK, &
                     MaxSym, Naa, nb, nBatch, NBL, ng, nk, nMax, np, nq, nr, ns, NumB, NumCho(nSym), NumV, nVec
real(kind=wp) :: TC1X1, TC1X2, TC2X1, TC2X2, TCC1, TCC2, tcoul(2), TCR1, TCR2, TCREO1, TCREO2, TCREO3, TCREO4, texch(2), TOTCPU, &
                 TOTCPU1, TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, tread(2), TW1X1, TW1X2, TW2X1, TW2X2, TWC1, TWC2, TWR1, TWR2, &
                 TWREO1, TWREO2, TWREO3, TWREO4, xf
logical(kind=iwp) :: DoSomeC, DoSomeX, Square
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: Debug
#endif
character(len=50) :: CFmt
character(len=6) :: Fname
type(SBA_Type), target :: Wab, LqJs
real(kind=wp), allocatable :: Dchk(:)
real(kind=wp), pointer :: LrJs(:,:,:) => null(), XdJb(:) => null(), XgJk(:) => null(), XkJs(:) => null(), VJ(:) => null()
real(kind=wp), parameter :: Thr = 1.0e-12_wp
character(len=*), parameter :: BaseNm = 'CHFV', SECNAM = 'CHO_FTWO_MO'

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
Debug = .false. ! to avoid double printing in SCF-debug
#endif

call CWTIME(TOTCPU1,TOTWALL1) ! start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = zero ! time read/rreorder vectors
tcoul(:) = zero ! time for computing Coulomb
texch(:) = zero ! time for computing Exchange

if (DensityCheck) then
  Square = .true.
  xf = Two
  if (DECO) xf = One
  do jDen=1,nDen
    do jSym=1,nSym
      if ((nBas(jSym) /= 0) .and. (pNocc(jDen)%I1(jSym) /= 0)) then
        call mma_allocate(Dchk,nBas(jSym)**2,Label='Dchk')
        call Cho_X_Test(DSQ(jDen)%SB(jSym)%A2,nBas(jSym),Square,MSQ(jDen)%SB(jSym)%A2,pNocc(jDen)%I1(jSym),xf,Dchk,nBas(jSym)**2, &
                        Thr,irc)
        call mma_deallocate(Dchk)
        if (irc == 0) then
          write(u6,*) '*** DENSITY CHECK : OK! *** SYMM= ',jSym
        else
          write(u6,*) '*** DENSITY CHECK FAILED IN SYMMETRY: ',jSym,'FOR THE DENSITY NR. ',jDen
        end if
      end if
    end do
  end do
end if

! Tests on the type of calculation
DoSomeC = .false.
DoSomeX = .false.
MaxSym = 0

jD = 0
do while ((jD < nDen) .and. (.not. DoSomeX))
  jD = jD+1
  DoSomeX = DoExchange(jD)
end do
jD = 0
do while ((jD < nDen) .and. (.not. DoSomeC))
  jD = jD+1
  DoSomeC = DoCoulomb(jD)
end do

if (DoSomeX) then
  MaxSym = nSym ! we want to do some exchange
else
  if (DoSomeC) then
    MaxSym = 1 ! we want to do only Coulomb
  else
    return ! we are lazy and won't do anything
  end if
end if

! ********* Data from the Runfile
call get_iarray('NumCho',NumCho,nSym)

! *************** BIG LOOP OVER VECTORS SYMMETRY *****************
do jSym=1,MaxSym

  if (NumCho(jSym) < 1) cycle

  ! Reading of the vectors is done in the full dimension
  Lunit(:) = -1

  ! Open Files
  do ksym=1,nSym
    if (nBas(ksym) /= 0) then
      iSymp = Mul(ksym,jSym)
      if (iSymp >= ksym) then
        Lunit(iSymp) = 7
        write(Fname,'(A4,I1,I1)') BaseNm,iSymp,ksym
        call DANAME_MF_WA(Lunit(iSymp),Fname)
      end if
    end if
  end do

  ! ------------------------------------------------------

  ! SET UP THE READING
  ! ------------------
  call mma_maxDBLE(LWORK)

  if (MinMem(jSym) > 0) then
    nVec = min(LWORK/MinMem(jSym),NumCho(jSym))
  else
    ! ***QUIT*** bad initialization
    write(u6,*) 'Cho_FTwo_MO: bad initialization'
    rc = 99
    call Abend()
    nVec = -9999 ! dummy assignment - avoid compiler warnings
  end if

  !...this is ONLY for debug:
  !nVec = min(nVec,1)

  if (nVec > 0) then
    nBatch = (NumCho(jSym)-1)/nVec+1
  else
    ! ***QUIT*** insufficient memory
    write(u6,*) 'Cho_FTwo_MO: Insufficient memory for batch'
    write(u6,*) 'LWORK= ',LWORK
    write(u6,*) 'min. mem. need= ',MinMem(jSym)
    write(u6,*) 'NumCho= ',NumCho(jsym)
    write(u6,*) 'jsym= ',jsym
    rc = 205
    call Abend()
    nBatch = -9999 ! dummy assignment
  end if

  ! *************** BATCHING  *****************

  do iBatch=1,nBatch

    if (iBatch == nBatch) then
      NumV = NumCho(jSym)-nVec*(nBatch-1)
    else
      NumV = nVec
    end if

    iVec = nVec*(iBatch-1)+1

    ! Allocate memory for reading the vectors
    kRdMem = MinMem(jSym)*NumV
    call mma_allocate(Wab%A0,kRdMem,Label='Wab%A0')
    Wab%iSym = JSYM
    Wab%nSym = nSym
    Wab%iCase = 7

    !setup the skipping flags according to # of Occupied
    do k=1,nSym
      iSkip(k) = 0
      l = Mul(k,jsym) ! L(kl) returned if nOcc(k or l) /= 0
      if (k == l) then
        iSkip(k) = 666 ! always contribute to Coulomb
      else
        do jDen=1,nDen
          iSkip(k) = iSkip(k)+pNocc(jDen)%I1(k)+pNocc(jDen)%I1(l)
        end do
      end if
    end do

    ! Max dimension of a symmetry block
    Nmax = 0
    do iSym=1,nSym
      if ((NBAS(iSym) > Nmax) .and. (iSkip(iSym) /= 0)) then
        Nmax = NBAS(iSym)
      end if
    end do

    call CWTIME(TCR1,TWR1)

    iE = 0
    do ksym=1,nSym

      iSymp = Mul(ksym,jSym)

      nk = nBas(kSym)
      np = nBas(iSymp)

      if (nk*np <= 0) cycle
      iS = iE+1

      if ((iSymp == ksym) .and. (iSkip(iSymp) /= 0)) then
        NumB = nk*(nk+1)/2
        ! Special trick for the vector L11 ; used to store X(a,Jb)
        if ((ksym == 1) .and. (jSym == 1) .and. DoSomeX) then
          iE = iE+lOff1*NumV
        else
          iE = iE+NumB*NumV
        end if
        Wab%SB(iSymp)%A2(1:NumB,1:NumV) => Wab%A0(iS:iS-1+NumB*NumV)
      else
        if ((iSymp > ksym) .and. (iSkip(iSymp) /= 0)) then
          NumB = nk*np
          iE = iE+NumB*NumV
          Wab%SB(iSymp)%A3(1:np,1:nk,1:NumV) => Wab%A0(iS:iE)
          Wab%SB(iSymp)%A2(1:NumB,1:NumV) => Wab%A0(iS:iE)
        end if
      end if

    end do ! ends the loop over symmetries

    do kSym=1,nSym
      iSymp = Mul(ksym,jSym)
      if (.not. associated(Wab%SB(iSymp)%A2)) cycle
      NumB = size(Wab%SB(iSymp)%A2,1)
      call RdChoVec(Wab%SB(iSymp)%A2,NumB,NumV,iVec,Lunit(iSymp))
    end do

    call CWTIME(TCR2,TWR2)
    tread(1) = tread(1)+(TCR2-TCR1)
    tread(2) = tread(2)+(TWR2-TWR1)

#   ifdef _DEBUGPRINT_
    write(u6,*) 'Batch ',iBatch,' of ',nBatch,': NumV = ',NumV
    write(u6,*) 'Total allocated:     ',kRdMem
    write(u6,*) 'iE:              ',iE
    write(u6,*) 'JSYM:                ',jSym
#   endif

    ! Reading Done!

    ! ********************************************************************
    do jDen=1,nDen

      if ((jSym == 1) .and. DoCoulomb(jDen)) then

        ! *************** BEGIN COULOMB CONTRIBUTION  ****************
        !
        ! Computing the intermediate vector V(J)
        !
        ! Contraction with the density matrix
        ! -----------------------------------
        ! V{#J} <- V{#J} + sum_rr L(rr,{#J})*D(rr)
        !==========================================================

        call CWTIME(TCC1,TWC1)

        VJ(1:NumV) => Wab%A0(iE+1:iE+NumV)
        VJ(:) = Zero

        do iSymr=1,nSym
          if ((nBas(iSymr) /= 0) .and. (pNocc(jDen)%I1(iSymr) /= 0)) then

            Naa = nBas(iSymr)*(nBas(iSymr)+1)/2

            call DGEMV_('T',Naa,NumV,ONE,Wab%SB(iSymr)%A2,Naa,DLT(jDen)%SB(iSYMR)%A1,1,ONE,VJ,1)

          end if
        end do

        ! Contraction with the 2nd vector
        ! -----------------------------------
        ! Fss{#J} <- Fss{#J} + FactC * sum_J L(ss,{#J})*V{#J}
        !==========================================================

        do iSyms=1,nSym
          if (nBas(iSyms) /= 0) then

            Naa = nBas(iSyms)*(nBas(iSyms)+1)/2

            call DGEMV_('N',Naa,NumV,FactC(jDen),Wab%SB(iSyms)%A2,Naa,VJ,1,ONE,FLT(jDen)%SB(ISYMS)%A1,1)

          end if
        end do

        VJ => null()

        call CWTIME(TCC2,TWC2)
        tcoul(1) = tcoul(1)+(TCC2-TCC1)
        tcoul(2) = tcoul(2)+(TWC2-TWC1)

      end if ! jSym=1 & DoCoulomb

    end do ! loop over densities for the Coulomb term

    ! *************** END COULOMB CONTRIBUTION  ****************
    !
    ! WE INCLUDE THE DIAGONAL PART OF THE EXCHANGE HERE!!!!
    !
    ! ********** REORDER and SQUARE ONE VECTOR AT THE TIME *****
    !
    !     CHOVEC(nrs,numv) ---> CHOVEC(nr,numv,ns)

    if ((jSym == 1) .and. DoSomeX) then
      do iSymr=1,nSym

        iSymr_Occ = 0
        do jDen=1,nDen
          iSymr_Occ = iSymr_Occ+pNocc(jDen)%I1(iSymr)
        end do
        nr = NBAS(iSymr)
        if ((nr /= 0) .and. (iSymr_Occ > 0)) then

          call CWTIME(TCREO1,TWREO1)

          LrJs(1:nr,1:NumV,1:nr) => Wab%A0(iE+1:iE+nr*NumV*nr)

          do JVEC=1,NUMV

            do jR=1,NBAS(iSymr)
              do jS=jR,NBAS(iSymr)

                jSR = iTri(jS,jR)

                LrJs(jR,JVEC,jS) = Wab%SB(ISYMR)%A2(jSR,JVEC)

                LrJs(jS,JVEC,jR) = Wab%SB(ISYMR)%A2(jSR,JVEC)

              end do
            end do
          end do

          call CWTIME(TCREO2,TWREO2)
          tread(1) = tread(1)+(TCREO2-TCREO1)
          tread(2) = tread(2)+(TWREO2-TWREO1)

          do jDen=1,nDen

            if (DoExchange(jDen)) then

              kOcc(iSymr) = pNocc(jDen)%I1(iSymr)

              if (kOcc(iSymr) /= 0) then

                call CWTIME(TC1X1,TW1X1)

                ! Calculate intermediate:
                ! X(k,Js) = Sum(r) C(r,k) * L(r,Js).
                ! -----------------------------------
                iSyms = iSymr
                NK = kOcc(iSymr)

                XkJs(1:NK*NumV*nr) => Wab%A0(1:NK*NumV*nr)

                call DGEMM_('T','N',NK,NUMV*NBAS(ISYMR),NBAS(iSYMR),ONE,MSQ(jDen)%SB(ISYMR)%A2,NBAS(ISYMR),LrJs,NBAS(ISYMR),ZERO, &
                            XkJs,NK)

                ! Calculate exchange contribution:
                ! F(r,s) = F(r,s) - FactX * Sum(kJ) X(kJ,r) * X(kJ,s).
                ! ----------------------------------------------------
                !CALL DGEMM_('T','N',NBAS(ISYMR),NBAS(ISYMS),NK*NUMV,-FactX(jDen),XkJs,NK*NUMV,XkJs,NK*NUMV,One, &
                !            FSQ(jDen)%SB(ISYMR)%A2,NBAS(ISYMR))

                ! *** Compute only the LT part of the exchange matrix ***************
                LKV = NK*NUMV
                do jS=1,NBAS(iSymS)
                  NBL = NBAS(iSymR)-(jS-1)
                  jjS = 1+LKV*(jS-1)

                  call DGEMV_('T',LKV,NBL,-FactX(jDen),XkJs(jjS:),LKV,XkJs(jjS:),1,ONE,FSQ(jDen)%SB(ISYMR)%A2(jS:,jS),1)

                end do

                call CWTIME(TC1X2,TW1X2)
                texch(1) = texch(1)+(TC1X2-TC1X1)
                texch(2) = texch(2)+(TW1X2-TW1X1)

                XkJs => null()

              end if ! if kocc /= 0

            end if ! Do Exchange(jDen)

          end do ! loop over the densities
          LrJs => null()

        end if ! nbas /= 0

      end do ! loop over Fock mat symmetries

    end if ! jSym=1 & DoSomeX

    ! ****************** END DIAGONAL EXCHANGE **********************

    ! ************ "OFF-DIAGONAL" EXCHANGE CONTRIBUTION  ************

    if (jSym /= 1) then

      ! Reordering of the Cholesky vectors (ALL AT ONCE)
      !
      !          Reorder: L(qs,J) -> L(qJ,s).
      !
      ! CHOVEC(nq,ns,numv) ---> CHOVEC(nq,numv,ns)
      ! ------------------------------------------
      call CWTIME(TCREO3,TWREO3)

      jE = iE
      do ISYMS=1,NSYM

        ISYMQ = Mul(ISYMS,JSYM)

        ns = nBas(iSyms)
        nq = nBas(iSymq)
        if (ns*nq <= 0) cycle

        if ((ISYMQ > ISYMS) .and. (iSkip(iSymq) /= 0)) then

          jS = JE+1
          jE = JE+nq*NumV*ns
          LqJs%SB(ISYMQ)%A3(1:nq,1:NumV,1:ns) => Wab%A0(jS:jE)

          do JVEC=1,NUMV

            do jS=1,NBAS(iSyms)

              LqJs%SB(ISYMQ)%A3(:,jVec,jS) = Wab%SB(ISYMQ)%A3(:,jS,jVEC)

            end do

          end do ! loop over the vectors

        end if ! sym(Q) > sym(S)

      end do ! loop over symmetry blocks

      call CWTIME(TCREO4,TWREO4)
      tread(1) = tread(1)+(TCREO4-TCREO3)
      tread(2) = tread(2)+(TWREO4-TWREO3)

      ! -------------- REORDERING DONE !! --------

      do jDen=1,nDen

        if (DoExchange(jDen)) then
          ! **** Occupation numbers needed for the Exchange term *****
          do iSym=1,nsym
            kOcc(iSym) = pNocc(jDen)%I1(iSym)
          end do
          ! **********************************************************
          ! --- COMPUTE EXCHANGE FOR OFF-DIAGONAL VECTORS

          call CWTIME(TC2X1,TW2X1)

          do ISYMG=1,NSYM

            ISYMB = Mul(ISYMG,JSYM)

            nb = nBas(iSymb)
            ng = nBas(iSymg)
            if (nb*ng <= 0) cycle

            ISYMA = ISYMB ! block diagonal Fock Matrix
            ISYMD = ISYMG ! total symmetric densities

            if ((ISYMG > ISYMB) .and. (iSkip(iSymg) /= 0)) then

              ! ---------------------------
              ! F(a,b) = - D(g,d) * (ad|gb)
              ! ---------------------------
              NK = kOcc(iSymG)

              XdJb(1:NK*NumV*nb) => Wab%A0(1:NK*NumV*nb)

              if (NK /= 0) then

                ! Calculate intermediate:
                ! X(k,Jb) = Sum(g) C(g,k) * L(g,Jb).
                ! ----------------------------------

                call DGEMM_('T','N',NK,NUMV*NBAS(ISYMB),NBAS(ISYMG),ONE,MSQ(jDen)%SB(ISYMG)%A2,NBAS(ISYMG),LqJs%SB(ISYMG)%A3, &
                            NBAS(ISYMG),ZERO,XdJb,NK)

                ! F(a,b) = F(a,b) - Sum(kJ) X(kJ,a) * X(kJ,b).
                ! -------------------------------------------

                !CALL DGEMM_('T','N',NBAS(ISYMA),NBAS(ISYMB),NK*NUMV,-FactX(jDen),XdJb,NK*NUMV,XdJb,NK*NUMV,ONE, &
                !            FSQ(jDen)%SB(iSYMB)%A2,NBAS(ISYMA))

                ! *** Compute only the LT part of the exchange matrix ***************
                LKV = NK*NUMV
                do jB=1,NBAS(iSymB)
                  NBL = NBAS(iSymA)-(jB-1)
                  jjB = 1+LKV*(jB-1)

                  call DGEMV_('T',LKV,NBL,-FactX(jDen),XdJb(jjB:),LKV,XdJb(jjB:),1,ONE,FSQ(jDEN)%SB(ISYMB)%A2(jB:,jB),1)

                end do
                XdJb => null()
                ! ******************************************************************

              end if

              ! ---------------------------
              ! F(g,d) = - D(a,b) * (ad|gb)
              ! ---------------------------
              NK = kOcc(iSymB)

              if (NK /= 0) then

                XgJk(1:ng*NumV*NK) => Wab%A0(1:ng*NumV*NK)

                ! Calculate intermediate:
                ! X(gJ,k) = Sum(a) L(gJ,a) * C(a,k).
                ! ----------------------------------

                call DGEMM_('N','N',NBAS(ISYMG)*NUMV,NK,NBAS(ISYMA),ONE,LqJs%SB(ISYMG)%A3,NBAS(ISYMG)*NUMV,MSQ(jDen)%SB(ISYMB)%A2, &
                            NBAS(ISYMA),ZERO,XgJk,NBAS(ISYMG)*NUMV)

                ! F(g,d) = F(g,d) - Sum(Jk) X(g,Jk) * X(d,Jk).
                ! -------------------------------------------

                !CALL DGEMM_('N','T',NBAS(ISYMG),NBAS(ISYMD),NUMV*NK,-FactX(jDen),XgJk,NBAS(ISYMG),XgJk,NBAS(ISYMD),ONE, &
                !            FSQ(jDen)%SB(ISYMG)%A2,NBAS(ISYMG))

                ! *** Compute only the LT part of the exchange matrix ***************
                LVK = NUMV*NK
                do jD=1,NBAS(iSymD)
                  NBL = NBAS(iSymG)-(jD-1)

                  call DGEMV_('N',NBL,LVK,-FactX(jDen),XgJk(jD:),NBAS(iSymG),XgJk(jD:),NBAS(iSymD),ONE, &
                              FSQ(jDen)%SB(ISYMG)%A2(jD:,jD),1)
                end do

                XgJk => null()
              end if

            end if
            LqJs%SB(ISYMG)%A3 => null()

          end do ! loop over orbital symmetries

          call CWTIME(TC2X2,TW2X2)
          texch(1) = texch(1)+(TC2X2-TC2X1)
          texch(2) = texch(2)+(TW2X2-TW2X1)

          ! ************ END "OFF-DIAGONAL" EXCHANGE CONTRIBUTION  ***********

        end if ! DoExchange section

      end do ! end of the loop over densities

    end if ! jSym /= 1

    ! Free the memory
    call Deallocate_DT(Wab)

  end do ! end of the batch procedure

  ! Close Files
  do ksym=1,nSym
    if (Lunit(ksym) /= -1) then
      call DACLOS(Lunit(ksym))
      Lunit(ksym) = -1
    end if
  end do

end do ! loop over JSYM

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky SCF timing from '//SECNAM
  write(u6,CFmt) '------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Fock matrix construction        CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ/REORDER VECTORS                      ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COULOMB                                   ',tcoul(1),tcoul(2)
  write(u6,'(2x,A26,2f10.2)') 'EXCHANGE                                  ',texch(1),texch(2)

  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

! Print the Fock-matrix
#ifdef _DEBUGPRINT_
if (Debug) then ! to avoid double printing in SCF-debug

  write(u6,'(6X,A)') 'TEST PRINT FROM CHO_FTWO_MO.'
  write(u6,'(6X,A)') '***** EXCHANGE MATRIX ***** '
  do jDen=1,nDen
    write(u6,'(6X,A,I2)') 'DENSITY TYPE: ',jDen
    write(u6,'(6X,A,I2)') 'DoExchange: ',DoExchange(jDen)
    write(u6,*)
    if (DoExchange(jDen)) then
      do ISYM=1,NSYM
        NB = NBAS(ISYM)
        if (NB > 0) then
          write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
          call cho_output(FSQ(jDen)%SB(ISYM)%A2,1,NB,1,NB,NB,NB,1,u6)
        end if
      end do
    end if
  end do

end if
#endif

rc = 0

return

end subroutine CHO_FTWO_MO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_DecChk_Int(irc,lUnit,Col,Nai,Nbj,ibj1,NumVec,
     &                             Work,lWork,Fac)
C
C     Thomas Bondo Pedersen, Jan. 2005.
C
C     Purpose: compute consecutive columns of (ai|bj) matrix from
C              vectors on file (unit: lUnit)
C              vectors from MP2 decomposition).
C
#include "implicit.fh"
      Real*8  Col(Nai,Nbj),Work(lWork)

      irc = 0

C     Check dimensions.
C     -----------------

      If (Nai.lt.1 .or. Nbj.lt.1 .or. Nbj.gt.Nai) Then
         irc = -1
         return
      End If
      ibj2 = ibj1 + Nbj - 1
      If (ibj1.lt.1 .or. ibj2.gt.Nai) Then
         irc = -2
         Return
      End If

C     Scale result array.
C     -------------------

      Call dScal_(Nai*Nbj,Fac,Col,1)
      If (NumVec .lt. 1) Return

C     Set up batch.
C     -------------
      nVec = min(lWork/Nai,NumVec)
      If (nVec .lt. 1) Then
         irc = 1
         Return
      End If
      nBat = (NumVec - 1)/nVec + 1

C     Start batch loop.
C     -----------------

      Do iBat = 1,nBat

C        Set batch info.
C        ---------------

         If (iBat .eq. nBat) Then
            NumV = NumVec - nVec*(nBat - 1)
         Else
            NumV = nVec
         End If
         iVec1 = nVec*(iBat - 1) + 1

C        Read vectors.
C        -------------

         iOpt = 2
         lTot = Nai*NumV
         iAdr = Nai*(iVec1 - 1) + 1
         Call ddaFile(lUnit,iOpt,Work,lTot,iAdr)

C        Compute integrals.
C        ------------------

         Call DGEMM_('N','T',Nai,Nbj,NumV,
     &              1.0d0,Work,Nai,Work(ibj1),Nai,
     &              1.0d0,Col,Nai)

      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_VecBuf_Maintain(irc,iRed,DoTime,DoStat)
!
! Purpose: maintain Cholesky vector buffer:
!
!          1) reorder vectors in buffer to current reduced set
!             storage (defined by location 2),
!
!          2) if possible, read in new vectors and store in current
!             reduced set storage (defined by location 2).
!
!          It is assumed that all vectors in the buffer are stored
!          according to the reduced set identified by iRed.
!
! DoTime: time as vector I/O.
! DoStat: update statistics info (#calls to system for I/O).
!
! Return code:  irc  = 0 : success
!               irc != 0 : failure
!
! Index arrays from Cholesky modified by this routine:
!
! NVEC_IN_BUF() -- #vectors stored in buffer in each symmetry

use Cholesky, only: CHVBUF, InfVec, ip_CHVBUF_SYM, iScr, l_CHVBUF_SYM, LuPri, nnBstR, nSym, nSys_call, NumCho, NumChT, &
                    nVec_in_Buf, TDECOM
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iRed
logical(kind=iwp), intent(in) :: DoTime, DoStat
integer(kind=iwp) :: iE, iMapC, iOff3, iRedC, iRS2, iS, iSym, iVec, iVec1, iVec2, jRed, jRS3, jVec, kVec, l_VRd, lCol, Left, lRow, &
                     mUsed, nDisk, nErr, nSys, nVec, nVRd
real(kind=wp) :: C1, C2, W1, W2
real(kind=wp), pointer :: V2(:,:), V3(:,:)
real(kind=wp), allocatable :: VRd(:)
character(len=*), parameter :: SecNam = 'Cho_VecBuf_Maintain'

! Set return code.
! ----------------

irc = 0

! Return if there is no buffer to maintain.
! -----------------------------------------

if (.not. allocated(CHVBUF)) then
# ifdef _DEBUGPRINT_
  write(Lupri,*) SecNam,': returning: no buffer to maintain!'
# endif
  return
end if

#ifdef _DEBUGPRINT_
! Debug print.
! ------------

write(Lupri,*)
write(Lupri,*) '>>>>> Enter ',SecNam,' <<<<<'
write(Lupri,*) 'iRed = ',iRed
write(Lupri,*) 'l_ChVBuf  = ',size(CHVBUF),'   ip_ChVBuf = ',1
write(Lupri,'(A,8I16)') 'l_ChVBuf_Sym : ',(l_ChVBuf_Sym(iSym),iSym=1,nSym)
write(Lupri,'(A,8I16)') 'ip_ChVBuf_Sym: ',(ip_ChVBuf_Sym(iSym),iSym=1,nSym)
write(Lupri,'(A,8I16)') 'nVec_in_Buf  : ',(nVec_in_Buf(iSym),iSym=1,nSym)
#endif

! If there are no vectors yet, return.
! ------------------------------------

if (NumChT < 1) then
# ifdef _DEBUGPRINT_
  write(Lupri,*) SecNam,': returning: no vectors!'
  write(Lupri,*) SecNam,': NumChT = ',NumChT
# endif
  return
end if

! Check that iScr array has been allocated.
! -----------------------------------------

if (.not. allocated(iScr)) then
  write(Lupri,*) SecNam,': iScr array not allocated!'
  irc = 102
  return
end if

! Start timing.
! -------------

if (DoTime) call CWTime(C1,W1)

! Set index arrays for reduced set iRed at location 3.
! ----------------------------------------------------

if (iRed < 1) then
  nErr = 0
  do iSym=1,nSym
    if (nVec_in_Buf(iSym) /= 0) then
      write(Lupri,*) SecNam,': sym. block ',iSym,':'
      write(Lupri,*) '   iRed = ',iRed,'   #vectors in buffer: ',nVec_in_Buf(iSym),' (should be 0)'
      nErr = nErr+1
    end if
  end do
  if (nErr /= 0) then
    irc = 103
    return
  end if
  iRedC = 1
else
  iRedC = iRed
end if

call Cho_X_SetRed(irc,3,iRedC)
if (irc /= 0) then
  write(Lupri,*) SecNam,': Cho_X_SetRed returned ',irc
  irc = 104
  return
end if

! Reordering.
! ===========

do iSym=1,nSym
  if ((nnBstR(iSym,2) > 0) .and. (nVec_in_Buf(iSym) > 0)) then

    ! Check reduced set dimensions.
    ! -----------------------------

    if (nnBstR(iSym,2) > nnBstR(iSym,3)) then
      write(Lupri,*) SecNam,': dimension of reduced set at 2 is larger than that at 3'
      write(Lupri,*) 'Symmetry: ',iSym,'  ID of 3: ',iRedC
      write(Lupri,*) 'Dimension of reduced set 2: ',nnBstR(iSym,2)
      write(Lupri,*) 'Dimension of reduced set 3: ',nnBstR(iSym,3)
      write(Lupri,*) 'Unable to continue...'
      irc = 104
      return
    end if

    ! Define mapping from reduced set at location 2 to that at
    ! location 3.
    ! --------------------------------------------------------

    call Cho_RS2RS(iScr,size(iScr),2,3,iRedC,iSym)

    ! Reorder vectors.
    ! ----------------

    lRow = nnBstR(iSym,2)
    lCol = nVec_in_Buf(iSym)
    iS = ip_ChVBuf_Sym(iSym)
    iE = iS-1+lRow*lCol
    V2(1:lRow,1:lCol) => CHVBUF(iS:iE)

    lRow = nnBstR(iSym,3)
    iE = iS-1+lRow*lCol
    V3(1:lRow,1:lCol) => CHVBUF(iS:iE)

    do iVec=1,nVec_in_Buf(iSym)
      do iRS2=1,nnBstR(iSym,2)
        jRS3 = iScr(iRS2)
#       ifdef _DEBUGPRINT_
        if ((iRS2 < 1) .or. (iRS2 > size(iScr))) then
          write(LuPri,*) 'iRS2=',iRS2
          write(LuPri,*) 'SIZE(iScr)=',size(iScr)
          call Cho_Quit('RS-2-RS map error in '//SecNam,104)
        end if
        if ((jRS3 < 1) .or. (jRS3 > nnBstR(iSym,3))) then
          write(LuPri,*) 'jRS3=',JRS3
          write(LuPri,*) 'nnBstR(iSym,3)=',nnBstR(iSym,3)
          call Cho_Quit('RS-2-RS map error in '//SecNam,104)
        end if
#       endif
        V2(iRS2,iVec) = V3(jRS3,iVec)
      end do
    end do

  end if
end do
nullify(V2,V3)

! Read in more vectors.
! =====================

nSys = 0 ! #calls to reading routine (counter)

call mma_maxDBLE(l_VRd)
call mma_allocate(VRd,l_VRd,Label='VRd')
do iSym=1,nSym
  nDisk = NumCho(iSym)-nVec_in_Buf(iSym)
# ifdef _DEBUGPRINT_
  if (nDisk < 0) call Cho_Quit('nDisk < 0 in '//SecNam,103)
# endif
  iMapC = -1
  if ((nnBstR(iSym,2) > 0) .and. (nDisk > 0)) then

    ! Compute how many more vectors can be stored in buffer taking
    ! into account the number of vectors on disk.
    ! ------------------------------------------------------------

    Left = l_ChVBuf_Sym(iSym)-nnBstR(iSym,2)*nVec_in_Buf(iSym)
    if (Left >= 0) then
      nVec = min(Left/nnBstR(iSym,2),nDisk)
    else
      call Cho_Quit('Left < 0 in '//SecNam,103)
      nVec = 0
    end if
    iVec1 = nVec_in_Buf(iSym)+1
    iVec2 = iVec1+nVec-1

    ! Read and reorder vectors.
    ! -------------------------

    iVec = iVec1
    do while (iVec <= iVec2)

      ! Read vectors.
      ! -------------

      nVRd = 0
      mUsed = 0
      call Cho_VecRd(VRd,l_VRd,iVec,iVec2,iSym,nVRd,iRedC,mUsed)
      if (nVRd < 1) call Cho_Quit('Insufficient memory for read in '//SecNam,101)
      nSys = nSys+1

      ! Reorder the vectors and store in buffer in current
      ! reduced set.
      ! --------------------------------------------------

      lRow = nnBstR(iSym,2)
      lCol = nVec_in_Buf(iSym)+nVRd
      iS = ip_ChVBuf_Sym(iSym)
      iE = iS-1+lRow*lCol

      V2(1:lRow,1:lCol) => CHVBUF(iS:iE)

      iOff3 = 0
      do kVec=1,nVRd

        jVec = iVec+kVec-1
        jRed = InfVec(jVec,2,iSym)
        if (jRed /= iRedC) then
          call Cho_X_SetRed(irc,3,jRed)
          if (irc /= 0) then
            write(Lupri,*) SecNam,': Cho_X_SetRed [2] returned ',irc
            irc = 104
            return
          end if
          iRedC = jRed
        end if

        if (jRed /= iMapC) then
          call Cho_RS2RS(iScr,size(iScr),2,3,jRed,iSym)
          iMapC = jRed
        end if

        do iRS2=1,nnBstR(iSym,2)
          jRS3 = iScr(iRS2)
#         ifdef _DEBUGPRINT_
          if ((jRS3 < 1) .or. (jRS3 > nnBstR(iSym,3))) call Cho_Quit('RS-2-RS map error [2] in '//SecNam,104)
#         endif
          V2(iRS2,jVec) = VRd(iOff3+jRS3)
        end do

        iOff3 = iOff3+nnBstR(iSym,3)

      end do

      ! Update counters.
      ! ----------------

      iVec = iVec+nVRd
      nVec_in_Buf(iSym) = nVec_in_Buf(iSym)+nVRd

    end do

  end if
end do
nullify(V2)
call mma_deallocate(VRd)

! Update global timing.
! ---------------------

if (DoStat) nSys_Call = nSys_Call+nSys

! Update global timing.
! ---------------------

if (DoTime) then
  call CWTime(C2,W2)
  tDecom(1,2) = tDecom(1,2)+C2-C1
  tDecom(2,2) = tDecom(2,2)+W2-W1
end if

! Debug print.
! ------------

#ifdef _DEBUGPRINT_
write(Lupri,*) 'After updating: '
write(Lupri,'(A,8I8)') 'nVec_in_Buf  : ',(nVec_in_Buf(iSym),iSym=1,nSym)
write(Lupri,*) '>>>>> Exit  ',SecNam,' <<<<<'
#endif

end subroutine Cho_VecBuf_Maintain

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakeWw(Ww,W1,W2,aSGrp,bSGrp,beSGrp,gaSGrp,key)
! this routine does:
! Make Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
!                              and W2(b",be",a",ga")
!  where index ab" is always a">b" (not a"=b")
!  and   index bega" is be">=ga" for W+ and be">ga" for W-
! for all cases aSGrp >= bSGrp
! N.B. for a"=b" W2 is not used (although it is passed through
!      the header (because of uniform shape) but no matter what
!      is there)
! N.B. rutinky MakeWwHlpx niesu prilis vymakane @
!
! parameter description:
! Ww    - array for Ww+(-) (O)
! W1    - array for W1(a",be",b",ga") (I)
! W2    - array for W1(b",be",a",ga") (I)
! xSGrp - SubGroup of a",b",be",ga" (I)
! key   - 1 - calc Ww+, 2 - calc Ww- (I)

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimSGrpa, DimSGrpbe
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: Ww(*)
real(kind=wp), intent(in) :: W1(*), W2(*)
integer(kind=iwp), intent(in) :: aSGrp, bSGrp, beSGrp, gaSGrp, key
integer(kind=iwp) :: dima, dimab, dimb, dimbe, dimbega, dimga

!1 def dimensions

dimbe = DimSGrpbe(beSGrp)
dimga = DimSGrpbe(gaSGrp)
dima = DimSGrpa(aSGrp)
dimb = DimSGrpa(bSGrp)

if (beSGrp == gaSGrp) then
  if (key == 1) then
    dimbega = nTri_Elem(dimbe)
  else
    dimbega = nTri_Elem(dimbe-1)
  end if
else
  dimbega = dimbe*dimga
end if

if (aSGrp == bSGrp) then
  dimab = nTri_Elem(dima-1)
else
  dimab = dima*dimb
end if

!2 Make Ww matrix

if (aSGrp == bSGrp) then
  if (beSGrp == gaSGrp) then
    call MakeWwHlp1(Ww,W1,dima,dimb,dimab,dimbe,dimga,dimbega,key)
  else
    call MakeWwHlp2(Ww,W1,dima,dimb,dimab,dimbe,dimga,key)
  end if
else
  if (beSGrp == gaSGrp) then
    call MakeWwHlp3(Ww,W1,W2,dima,dimb,dimbe,dimga,dimbega,key)
  else
    call MakeWwHlp4(Ww,W1,W2,dima,dimb,dimbe,dimga,key)
  end if
end if

return

end subroutine MakeWw

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Giovanni Li Manni                                *
!               2019, Oskar Weser                                      *
!***********************************************************************
module fcidump_tables
  use stdalloc, only : mma_allocate, mma_deallocate
  use index_symmetry, only : one_el_idx, two_el_idx
  implicit none
  private
  public :: FockTable, TwoElIntTable, OrbitalTable, mma_allocate, &
    mma_deallocate, length, print, fill_orbitals, fill_fock, fill_2ElInt, &
    cutoff_default, unused
  save

  type :: FockTable
    sequence
    real*8, allocatable, dimension(:) :: values ! <i | F | j >
    integer, allocatable, dimension(:, :) :: index ! i, j
    real*8 :: cutoff
    integer :: length
  end type FockTable

  type :: TwoElIntTable
    sequence
    real*8, allocatable, dimension(:) :: values ! <ij| 1/r_{12} |kl>
    integer, allocatable, dimension(:, :) :: index ! i, j, k, l
    real*8 :: cutoff
    integer :: length
  end type TwoElIntTable

  type :: OrbitalTable
    sequence
    real*8, allocatable, dimension(:) :: values ! <i| F |i>
    integer, allocatable, dimension(:) :: index ! i
  end type OrbitalTable

  real*8, parameter :: cutoff_default = 1.0d-11

  interface mma_allocate
    module procedure FockTable_allocate, TwoElIntTable_allocate, &
      OrbitalTable_allocate
  end interface

  interface mma_deallocate
    module procedure FockTable_deallocate, TwoElIntTable_deallocate, &
      OrbitalTable_deallocate
  end interface

  interface length
    module procedure FockTable_length, TwoElIntTable_length, &
      OrbitalTable_length
  end interface

  interface print
    module procedure FockTable_print, TwoElIntTable_print, OrbitalTable_print
  end interface

  interface unused
    module procedure FockTable_unused, TwoElIntTable_unused, OrbitalTable_unused
  end interface

contains

  subroutine OrbitalTable_allocate(orbital_table, n)
    implicit none
    integer, intent(in) :: n
    type(OrbitalTable), intent(inout) :: orbital_table
    call mma_allocate(orbital_table%values, n)
    call mma_allocate(orbital_table%index, n)
  end subroutine OrbitalTable_allocate

  subroutine OrbitalTable_deallocate(orbital_table)
    implicit none
    type(OrbitalTable), intent(inout) :: orbital_table
    call mma_deallocate(orbital_table%values)
    call mma_deallocate(orbital_table%index)
  end subroutine OrbitalTable_deallocate

!>  @brief
!>    Fill in orbital energies
!>
!>  @author Oskar Weser
!>
!>  @details
!>  The orbitals table gets filled with the orbital energies from DIAF.
!>  If it is the first iteration (iter == 1) then the one electron
!>  energies are read from the InpOrb.
!>
!>  @param[in,out] orbitals Core
!>  @param[in] DIAF
!>  @param[in] iter
  subroutine fill_orbitals(table, orbital_energies)
    use general_data, only : nBas, nSym, nAsh, nFro, nIsh
    implicit none
    type(OrbitalTable), intent(inout) :: table
    real*8, intent(in) :: orbital_energies(:)
    integer :: i, n, iSym, iOff

    iOff = 0
    n = 1
    do iSym = 1, nSym
      if (nAsh(iSym) > 0) then
        do i = 1, nAsh(isym)
          table%index(n) = n
          table%values(n) = orbital_energies(ioff + nFro(iSym) + nIsh(iSym) + i)
          n = n + 1
        enddo
      end if
      iOff   = iOff + nBas(iSym)
    end do
  end subroutine fill_orbitals

  pure integer function OrbitalTable_length(table)
    type(OrbitalTable), intent(in) :: table
    OrbitalTable_length = size(table%values)
  end function OrbitalTable_length

  subroutine OrbitalTable_print(table)
    type(OrbitalTable), intent(in) :: table
    integer :: i
    do i = 1, length(table)
      write(6, '(E15.7, I7)') table%values(i), table%index(i)
    end do
  end subroutine OrbitalTable_print

  subroutine OrbitalTable_unused(table)
    type(OrbitalTable), intent(in) :: table
    integer :: n
#ifdef _WARNING_WORKAROUND_
    if (.false.) n = length(table)
#endif
  end subroutine OrbitalTable_unused

  subroutine FockTable_allocate(fock_table, n)
    implicit none
    integer, intent(in) :: n
    type(FockTable), intent(inout) :: fock_table
    call mma_allocate(fock_table%values, n)
    call mma_allocate(fock_table%index, 2, n)
  end subroutine FockTable_allocate

  subroutine FockTable_deallocate(fock_table)
    implicit none
    type(FockTable), intent(inout) :: fock_table
    call mma_deallocate(fock_table%values)
    call mma_deallocate(fock_table%index)
  end subroutine FockTable_deallocate

!>  @brief
!>    Fill in fock matrix elements.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  The fock_table gets filled with the Fock matrix elements
!>  whose absolute value is larger than cutoff.
!>  The values are given by
!>  \f[ < i | F | j > \f]
!>  The index is given by i and j.
!>
!>  @param[in,out] fock_table
!>  @param[in] CMO The occupation number vector in MO-space.
!>  @param[in] F_In
!>    \f[\sum_{\sigma\rho} {In}^D_{\sigma\rho} (g_{\mu\nu\sigma\rho})  \f]
!>  @param[in] D1I_MO The inactive one-body density matrix in MO-space
!>  @param[in] cutoff Optional parameter that is set by default to
!>    fciqmc_tables::cutoff_default.
  subroutine fill_fock(fock_table, Fock, cutoff)
    use general_data, only : nActEl, nAsh, ntot, ntot1, ntot2
    use rasscf_data, only : nAcPar
    implicit none
    real*8, intent(in) :: Fock(:)
    type(FockTable), intent(inout) :: fock_table
    real*8, optional, intent(in) :: cutoff

    integer :: i, n
    real*8 :: cutoff_

    cutoff_ = merge(cutoff, cutoff_default, present(cutoff))

    n = 0
    do i = 1, size(Fock)
      if (abs(Fock(i)) >= cutoff_) then
        n = n + 1
        call one_el_idx(i, fock_table%index(:, n))
        fock_table%values(n) = Fock(i)
      end if
    end do
    fock_table%length = n
    fock_table%cutoff = cutoff_
  end subroutine fill_fock

  pure integer function FockTable_length(table)
    implicit none
    type(FockTable), intent(in) :: table
    FockTable_length = table%length
  end function FockTable_length

  subroutine FockTable_print(table)
    type(FockTable), intent(in) :: table
    integer :: i, j
    do j = 1, length(table)
      write(6, '(E15.7, I7, I7)') table%values(j), (table%index(i, j), i=1, 2)
    end do
  end subroutine FockTable_print

  subroutine FockTable_unused(table)
    type(FockTable), intent(in) :: table
    integer :: n
#ifdef _WARNING_WORKAROUND_
    if (.false.) n = length(table)
#endif
  end subroutine FockTable_unused

  subroutine TwoElIntTable_allocate(table, n)
    implicit none
    integer, intent(in) :: n
    type(TwoElIntTable), intent(inout) :: table
    call mma_allocate(table%values, n)
    call mma_allocate(table%index, 4, n)
  end subroutine TwoElIntTable_allocate

  subroutine TwoElIntTable_deallocate(table)
    implicit none
    type(TwoElIntTable), intent(inout) :: table
    call mma_deallocate(table%values)
    call mma_deallocate(table%index)
  end subroutine TwoElIntTable_deallocate

!>  @brief
!>    Fill in two electron integrals
!>
!>  @author Oskar Weser
!>
!>  @details
!>  The two_el_table gets filled with those two electron integrals
!>  whose absolute value is larger than cutoff.
!>  The values are given by
!>  \f[ < i, j | \frac{1}{r_{1,2}} | k, l > \f]
!>  The index is given by i, j, k, and l.
!>
!>  @param[in,out] two_el_table
!>  @param[in] TUVX
!>  @param[in] cutoff Optional parameter that is set by default to
!>    fciqmc_tables::cutoff_default.
  subroutine fill_2ElInt(two_el_table, TUVX, cutoff)
    implicit none
    real*8, intent(in) :: TUVX(:)
    type(TwoElIntTable), intent(inout) :: two_el_table
    integer :: i, n
    real*8, optional :: cutoff
    real*8 :: cutoff_

    integer, parameter :: max_test = 20
    integer :: l_twoel_test

    cutoff_ = merge(cutoff, cutoff_default, present(cutoff))

    n = 0
    do i = 1, size(TUVX)
      if (abs(TUVX(i)) >= cutoff_) then
        n = n + 1
        call two_el_idx(i, two_el_table%index(:, n))
        two_el_table%values(n) = TUVX(i)
      end if
    end do
    two_el_table%length = n
    two_el_table%cutoff = cutoff_

! ========== For testing purposes FROM HERE =============
    l_twoel_test = min(max_test, length(two_el_table))
    call Add_Info('TwoEl Integral element Input', &
      TUVX(:l_twoel_test), l_twoel_test, 8)
! ========== For testing purposes TO HERE ===============
  end subroutine fill_2ElInt

  pure integer function TwoElIntTable_length(table)
    type(TwoElIntTable), intent(in) :: table
    TwoElIntTable_length = table%length
  end function TwoElIntTable_length

  subroutine TwoElIntTable_print(table)
    type(TwoElIntTable), intent(in) :: table
    integer :: i, j
    do j = 1, length(table)
      write(6, '(E15.7, I7, I7, I7, I7)') &
        table%values(j), (table%index(i, j), i=1, 4)
    end do
  end subroutine TwoElIntTable_print

  subroutine TwoElIntTable_unused(table)
    type(TwoElIntTable), intent(in) :: table
    integer :: n
#ifdef _WARNING_WORKAROUND_
    if (.false.) n = length(table)
#endif
  end subroutine TwoElIntTable_unused
end module fcidump_tables

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Ignacio Fdez. Galvan                             *
************************************************************************

      subroutine Read_Input()
      use False_Global, only: Run_Command
      implicit none
      integer :: LU,EOF
      character(len=4) :: Key
      character(len=180) :: Line
      integer, external :: IsFreeUnit
      character(len=180), external :: Get_Ln

      LU=IsFreeUnit(11)
      call SpoolInp(LU)
      rewind(LU)
      call RdNLst(LU,'false')

      EOF=0
      do
        Line=Get_Ln(LU)
        if (EOF < 0) exit
        Key=Line(1:len(Key))
        call UpCase(Key)
        if (Key(1:3) == 'END') then
          exit
        else if (Key == 'RUN') then
          Line=Get_Ln(LU)
          if (EOF /= 0) then
            call WarningMessage(2,'Error reading RUN keyword.')
            call Quit_OnUserError()
          end if
          Run_Command=Line
        else
          call WarningMessage(2,'Error in FALSE input: '//
     &       'Unknown keyword '//trim(key))
          call Quit_OnUserError()
        end if
      end do

      close(LU)

      return

      end subroutine Read_Input

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Map3_132_t3(A,B,d1,d2,d3)
! this routine does:
! map B(132) <- A(123)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: d1, d2, d3
real(kind=wp), intent(in) :: A(d1,d2,d3)
real(kind=wp), intent(out) :: B(d1,d3,d2)
integer(kind=iwp) :: i2, i3

do i2=1,d2
  do i3=1,d3
    B(:,i3,i2) = A(:,i2,i3)
  end do
end do

return

end subroutine Map3_132_t3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqk15i(f,boun,inf,a,b,reslt,abserr,resabs,resasc)
!***begin prologue  dqk15i
!***date written   800101   (yymmdd)
!***revision date  830518   (yymmdd)
!***category no.  h2a3a2,h2a4a2
!***keywords  15-point transformed gauss-kronrod rules
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  the original (infinite integration range is mapped
!            onto the interval (0,1) and (a,b) is a part of (0,1).
!            it is the purpose to compute
!            i = integral of transformed integrand over (a,b),
!            j = integral of abs(transformed integrand) over (a,b).
!***description
!
!           integration rule
!           standard fortran subroutine
!           real*8 version
!
!           parameters
!            on entry
!              f      - real*8
!                       function subprogram defining the integrand
!                       function f(x). the actual name for f needs to be
!                       declared e x t e r n a l in the calling program.
!
!              boun   - real*8
!                       finite bound of original integration
!                       range (set to zero if inf = +2)
!
!              inf    - integer
!                       if inf = -1, the original interval is
!                                   (-infinity,bound),
!                       if inf = +1, the original interval is
!                                   (bound,+infinity),
!                       if inf = +2, the original interval is
!                                   (-infinity,+infinity) and
!                       the integral is computed as the sum of two
!                       integrals, one over (-infinity,0) and one over
!                       (0,+infinity).
!
!              a      - real*8
!                       lower limit for integration over subrange
!                       of (0,1)
!
!              b      - real*8
!                       upper limit for integration over subrange
!                       of (0,1)
!
!            on return
!              reslt  - real*8
!                       approximation to the integral i
!                       result is computed by applying the 15-point
!                       kronrod rule (resk) obtained by optimal addition
!                       of abscissae to the 7-point gauss rule (resg).
!
!              abserr - real*8
!                       estimate of the modulus of the absolute error,
!                       which should equal or exceed abs(i-reslt)
!
!              resabs - real*8
!                       approximation to the integral j
!
!              resasc - real*8
!                       approximation to the integral of
!                       abs((transformed integrand)-i/(b-a)) over (a,b)
!
!***references  (none)
!***routines called  d1mach
!***end prologue  dqk15i

use Constants, only: Zero, One, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
interface
  function f(x)
    import :: wp
    real(kind=wp) :: f
    real(kind=wp), intent(in) :: x
  end function f
end interface
real(kind=wp), intent(in) :: boun, a, b
real(kind=wp), intent(out) :: reslt, abserr, resabs, resasc
integer(kind=iwp), intent(in) :: inf
integer(kind=iwp) :: j
real(kind=wp) :: absc, absc1, absc2, centr, dinf, epmach, fc, fsum, fval1, fval2, fv1(7), fv2(7), hlgth, resg, resk, reskh, &
                 tabsc1, tabsc2, uflow
real(kind=wp), external :: d1mach

! the abscissae and weights are supplied for the interval
! (-1,1).  because of symmetry only the positive abscissae and
! their corresponding weights are given.
!
! xgk    - abscissae of the 15-point kronrod rule
!          xgk(2), xgk(4), ...  abscissae of the 7-point
!          gauss rule
!          xgk(1), xgk(3), ...  abscissae which are optimally
!          added to the 7-point gauss rule
!
! wgk    - weights of the 15-point kronrod rule
!
! wg     - weights of the 7-point gauss rule, corresponding
!          to the abscissae xgk(2), xgk(4), ...
!          wg(1), wg(3), ... are set to zero.

real(kind=wp), parameter :: wg(8) = [0.000000000000000000000000000000000_wp, &
                                     0.129484966168869693270611432679082_wp, &
                                     0.000000000000000000000000000000000_wp, &
                                     0.279705391489276667901467771423780_wp, &
                                     0.000000000000000000000000000000000_wp, &
                                     0.381830050505118944950369775488975_wp, &
                                     0.000000000000000000000000000000000_wp, &
                                     0.417959183673469387755102040816327_wp]
real(kind=wp), parameter :: xgk(8) = [0.991455371120812639206854697526329_wp, &
                                      0.949107912342758524526189684047851_wp, &
                                      0.864864423359769072789712788640926_wp, &
                                      0.741531185599394439863864773280788_wp, &
                                      0.586087235467691130294144838258730_wp, &
                                      0.405845151377397166906606412076961_wp, &
                                      0.207784955007898467600689403773245_wp, &
                                      0.000000000000000000000000000000000_wp]
real(kind=wp), parameter :: wgk(8) = [0.022935322010529224963732008058970_wp, &
                                      0.063092092629978553290700663189204_wp, &
                                      0.104790010322250183839876322541518_wp, &
                                      0.140653259715525918745189590510238_wp, &
                                      0.169004726639267902826583426598550_wp, &
                                      0.190350578064785409913256402421014_wp, &
                                      0.204432940075298892414161999234649_wp, &
                                      0.209482141084727828012999174891714_wp]

! list of major variables
! -----------------------
!
! centr  - mid point of the interval
! hlgth  - half-length of the interval
! absc*  - abscissa
! tabsc* - transformed abscissa
! fval*  - function value
! resg   - result of the 7-point gauss formula
! resk   - result of the 15-point kronrod formula
! reskh  - approximation to the mean value of the transformed
!          integrand over (a,b), i.e. to i/(b-a)
!
! machine dependent constants
! ---------------------------
!
! epmach is the largest relative spacing.
! uflow is the smallest positive magnitude.
!
!***first executable statement  dqk15i

epmach = d1mach(4)
uflow = d1mach(1)
dinf = min(1,inf)

centr = Half*(a+b)
hlgth = Half*(b-a)
tabsc1 = boun+dinf*(One-centr)/centr
fval1 = f(tabsc1)
if (inf == 2) fval1 = fval1+f(-tabsc1)
fc = (fval1/centr)/centr

! compute the 15-point kronrod approximation to
! the integral, and estimate the error.

resg = wg(8)*fc
resk = wgk(8)*fc
resabs = abs(resk)
do j=1,7
  absc = hlgth*xgk(j)
  absc1 = centr-absc
  absc2 = centr+absc
  tabsc1 = boun+dinf*(One-absc1)/absc1
  tabsc2 = boun+dinf*(One-absc2)/absc2
  fval1 = f(tabsc1)
  fval2 = f(tabsc2)
  if (inf == 2) fval1 = fval1+f(-tabsc1)
  if (inf == 2) fval2 = fval2+f(-tabsc2)
  fval1 = (fval1/absc1)/absc1
  fval2 = (fval2/absc2)/absc2
  fv1(j) = fval1
  fv2(j) = fval2
  fsum = fval1+fval2
  resg = resg+wg(j)*fsum
  resk = resk+wgk(j)*fsum
  resabs = resabs+wgk(j)*(abs(fval1)+abs(fval2))
end do
reskh = resk*Half
resasc = wgk(8)*abs(fc-reskh)
do j=1,7
  resasc = resasc+wgk(j)*(abs(fv1(j)-reskh)+abs(fv2(j)-reskh))
end do
reslt = resk*hlgth
resabs = resabs*hlgth
resasc = resasc*hlgth
abserr = abs((resk-resg)*hlgth)
if ((resasc /= Zero) .and. (abserr /= Zero)) abserr = resasc*min(One,(200.0_wp*abserr/resasc)**OneHalf)
if (resabs > uflow/(50.0_wp*epmach)) abserr = max((epmach*50.0_wp)*resabs,abserr)

return

end subroutine dqk15i

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine POT(Rin,Ein,Rout,Eout,nout,ifit,Emin,Req,R0,R1,dR,
     *               npin,Title,iplot,Redm,scale,Nr)
      Implicit real*8 (A-H,O-Z)
      Parameter (lext=100,ipldim=1000)
      Character*80 Title
      Dimension Rout(*),Eout(*),Rext(lext),Eext(lext),Rin(*),Ein(*),
     *          iext(lext),Rplot(ipldim),Eplot(ipldim),Eextp(lext),
     *          Eplotp(ipldim)
#include "dimensions.fh"
#include "intinp.fh"
      Integer Print,Vibplt
      Character*15 type(3), FILENAME*8
      Data type/'Max point','Saddle point','Min point'/
      Data Vibplt/10/
C
*
      FILENAME='VIBPLT0 '
      If (Nr.ge.1 .and. Nr.lt.9) Then
         Write (FILENAME(7:7),'(I1)') Nr
      Else If (Nr.ge.10 .and. Nr.le. 99) Then
         Write (FILENAME(7:8),'(I2)') Nr
      End If
      Write (6,*) 'Generating plot file:',FILENAME
      Call Molcas_Open(Vibplt,FILENAME)
*
      Eeq=0.0D0  ! dummy intitialize
      Ree=0.0D0  ! dummy intitialize
*
      if(ifit.eq.1) goto 100
      if(ifit.eq.2) goto 200
      write(6,*)'POT Error: IFIT variable must be 1 or 2.'
      write(6,*)'           IFIT=',IFIT
      Call Quit_OnUserError()
100   Continue
      Ue=0.4D0
      print=1
      If(Ue.lt.0.1D0.or.Ue.gt.0.9D0) then
        write(6,*)'POT Error: Ue should be in 0.1..0.9'
        write(6,*)'           Ue  =',Ue
        Call Quit_OnUserError()
      end if
C
C     Find Re value
C
      Re=Rin(1)
      Eminx=Ein(1)
      Do 103 i=2,npin
       If(Ein(i).gt.Eminx) go to 103
       Re=Rin(i)
       Eminx=Ein(i)
103   Continue
C
C     Scale input potential if requested such that
C     the binding energy is 0.1 au (BOR 0601).
C
      scale=1.d0
      Escale=Ein(npin)
      if(iscale.ne.0) scale=abs(0.1d0/(Eminx-Escale))
      Do i=1,npin
       Ein(i)= Escale+scale*(Ein(i)-Escale)
      Enddo
      Redm=Redm/scale
      write(6,1002) scale
 1002 Format(/1x, 'Scaling parameter for potential:',f12.6)
C
      If(Re.lt.1.0D0.or.Re.gt.2.0D1) then
        write(6,*)'POT Error: Re should be in 1.0..20.0'
        write(6,*)'           Re  =',Re
        Call Quit_OnUserError()
      end if
      alpha=log(Ue)/Re
      Do i=1,npin
       Rin(i)=exp(alpha*Rin(i))
      Enddo
C
      Do  i=1,nout
        Rout(i)=exp(alpha*Rout(i))
      Enddo
      Rout(nout+1)=0.0D0
      next=0
      Call Sort_Pot(Rin,Ein,npin)
      next=lext
      Call Spline(Rin,Ein,npin,Rout,Eout,nout+1,Rext,Eext,iext,next,1)
      Do  i=1,npin
        Rin(i)=log(Rin(i))/alpha
      Enddo
      Call Sort_Pot(rin,ein,npin)
      Do i=1,nout
        Rout(i)=log(Rout(i))/alpha
      Enddo
      Do  i=1,next
        Rext(i)=log(Rext(i))/alpha
      Enddo
      If(print.ge.1) then
       Do i=1,next
        Eextp(i)=Escale+(Eext(i)-Escale)/scale
       Enddo
        if(next.ge.1) then
          Write(6,2002)
          Write(6,2003) (Type(iext(i)),Rext(i),
     *                   Eextp(i),i=1,next)
        End If
      End if
      If(iplot.ge.1) then
        nplot=1+int((R1-R0)/dR)
        If(nplot.gt.ipldim.or.nplot.le.0) then
          Write(6,*)'POT Error: Variable NPLOT should be in 1..IPLDIM'
          Write(6,*)'          IPLDIM=',IPLDIM
          Write(6,*)'          NPLOT =',NPLOT
          Call Quit_OnUserError()
        End If
        Do  i=1,nop
          Rin(i)=exp(alpha*Rin(i))
        Enddo
        Call Sort_Pot(Rin,Ein,nop)
        If(iplot.eq.1) then
          Do  i=1,nplot
            Rplot(i)=(i-1)*dR+R0
          Enddo
        Else
          Do  i=1,nplot
            Rplot(i)=1.0D1**((i-1)*dR+R0)
          Enddo
        End If
        Do  i=1,nplot
          Rplot(i)=exp(alpha*Rplot(i))
        Enddo
        next=lext
        Call Spline(Rin,Ein,npin,Rplot,Eplot,nplot,Rext,Eext,iext,
     *              next,1)
        Do  i=1,nplot
          Rplot(i)=log(Rplot(i))/alpha
        Enddo
        If(iplot.eq.3) then
          Do  i=1,nplot
            Rplot(i)=log10(Rplot(i))
          Enddo
        End If
        Do i=1,nplot
         Eplotp(i)=Escale+(Eplot(i)-Escale)/scale
        Enddo
        Write(Vibplt,3000) Title
        Write(Vibplt,3002) nplot
        Write(Vibplt,3001) (Rplot(i),Eplotp(i),i=1,nplot)
      End If
      if(next.le.0) then
        Write(6,*)'POT Error: Variable NEXT should be larger than 0'
        Write(6,*)'          NEXT =',NEXT
        Call Quit_OnUserError()
      End If
      Eeq=1.0d30
      imin=0
      Do  i=1,next
        if(Eeq.gt.Eext(i)) then
          imin=i
          Eeq=Eext(i)
        End If
      Enddo
      Emin=Eeq
      Ree=Rext(imin)
      if(iplot.gt.0) Ree=log(Ree)/alpha
      Req=Ree
      if(iext(imin).ne.3) then
        Write(6,*)'POT Error: IEXT(IMIN) should be = 3'
        Write(6,*)'    IEXT(IMIN) =',IEXT(IMIN)
        Call Quit_OnUserError()
      End If
      Einf=Eout(nout+1)
      Do  i=1,nout
        Eout(i)=Eout(i)-Einf
      Enddo
      Emin=Emin-Einf
      Einfp=Escale+(Einf-Escale)/scale
      Write(6,1950) Einfp
1950  Format(1x,'Extrapolated value at infinity',F13.6)
*
      Close(Vibplt)
*
      Return
C
C     Here for fitting of observable input
C
200   Continue
      Print=1
      Call Sort_Pot(Rin,Ein,npin)
      next=lext
      Call Spline(Rin,Ein,npin,Rout,Eout,nout,Rext,Eext,iext,next,1)
      If(iplot.ge.1) then
        nplot=1+int((R1-R0)/dR)
        If(nplot.gt.ipldim.or.nplot.le.0) then
          Write(6,*)'POT Error: Variable NPLOT should be in 1..IPLDIM'
          Write(6,*)'          IPLDIM=',IPLDIM
          Write(6,*)'          NPLOT =',NPLOT
          Call Quit_OnUserError()
        End If
        If(iplot.eq.1) then
          Do i=1,nplot
            Rplot(i)=(i-1)*dR+R0
          Enddo
        Else
          Do i=1,nplot
            Rplot(i)=1.0D1**((i-1)*dR+R0)
          Enddo
        End if
        next=lext
        Call Spline(Rin,Ein,npin,Rplot,Eplot,nplot,Rext,Eext,iext,
     *              next,1)
        If(iplot.eq.3) then
          Do i=1,nplot
            Rplot(i)=log10(Rplot(i))
          Enddo
        End if
        Write(Vibplt,3000) Title
        Write(Vibplt,3002) nplot
        Write(Vibplt,3001) (Rplot(i),Eplot(i),i=1,nplot)
      End if
      Req=Ree
      Emin=Eeq
*
      Close(Vibplt)
*
      Return
2002  Format(/1x,'extremum points'/24x,'R(au)',9x,'Value')
2003  Format(1x,A,2F14.6)
3000  Format(A80)
3001  Format(1x,f15.8,f20.8)
3002  Format(I4)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Angle_List(nq,nsAtom,iIter,nIter,Cx,Process,Valu,nB,qLbl,iRef,fconst,rMult,LuIC,Indq,Grad_all,iGlow,iGhi,iPrv,Proc_dB, &
                      iTabBonds,nBonds,iTabAI,mAtoms,iTabAtoms,nMax,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,nqB,Thr_small)

use Symmetry_Info, only: iOper, nIrrep
use Slapaf_Info, only: ANr, AtomLbl, Fragments_Bond, jStab, Magic_Bond, nStab, vdW_Bond
use ddvdt, only: A_Bend, aAV, f_Const_Min, rAV, rkf
use Molcas, only: LenIn
use Constants, only: Zero, One, Two, Pi, deg2rad
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nsAtom, iIter, nIter, nB, iRef, LuIC, iGlow, iGhi, iPrv, nBonds, iTabBonds(3,nBonds), mAtoms, &
                                 iTabAI(2,mAtoms), nMax, iTabAtoms(2,0:nMax,mAtoms), nB_Tot, ndB_Tot
integer(kind=iwp), intent(inout) :: nq, Indq(3,nB), mB_Tot, mdB_Tot, iBM(nB_Tot), idBM(2,ndB_Tot), nqB(nB)
real(kind=wp), intent(in) :: Cx(3,nsAtom,nIter), Thr_small
logical(kind=iwp), intent(in) :: Process, Proc_dB
real(kind=wp), intent(inout) :: Valu(nB,nIter), fconst(nB), rMult(nB), Grad_all(9,iGlow:iGhi,nIter), BM(nB_Tot), dBM(ndB_Tot)
character(len=14), intent(inout) :: qLbl(nB)
integer(kind=iwp), parameter :: mB = 3*3
integer(kind=iwp) :: iAtom, iAtom_, iBond, iBondType, iDCR(3), iDCRR(0:7), iDCRT(0:7), ideg, iE1, iE2, iE3, iF1, iF2, iF3, Ind(3), &
                     iNeighbor, ir, iStabM(0:7), iStabN(0:7), jAtom, jAtom_, jBond, jBondType, jNeighbor, jr, k, kDCR, kDCRR, &
                     kDCRT, Lambda, mAtom, mAtom_, mi, mr, nCent, nCoBond_i, nCoBond_j, nCoBond_m, nDCRR, nDCRT, nk, nNeighbor_m, &
                     nqA, nStabM, nStabN
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif
real(kind=wp) :: A(3,3), Alpha, Axis(3), BB, Deg, delta, f_Const, f_Const_Ref, Fact, Grad(mB), Grad_Ref(9), Hess(mB**2), &
                 Perp_Axis(3,2), Prv(3,3), r0, Ref(3,3), rim2, rim2_Ref, rmj2, rmj2_Ref, Val, Val_Ref
logical(kind=iwp) :: Help, MinBas
character(len=LenIn+4) :: Lbls(3)
character(len=14) :: Label
integer(kind=iwp), parameter :: iChOp(0:7) = [1,1,1,2,1,2,2,3]
character(len=*), parameter :: ChOp(0:7) = ['E  ','X  ','Y  ','XY ','Z  ','XZ ','YZ ','XYZ']
integer(kind=iwp), external :: iTabRow, nCoBond
real(kind=wp), external :: DDot_
logical(kind=iwp), external :: R_Stab_A

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
if (nBonds < 2) return

nqA = 0
#ifdef _DEBUGPRINT_
write(u6,*) ' Enter Bends.'
#endif
Hess(:) = Zero

! Loop over bends

MinBas = .false.
if (MinBas) then
  Fact = 1.3_wp
else
  Fact = One
end if
nCent = 3
!write(u6,*)

do mAtom_=1,mAtoms
  mAtom = iTabAI(1,mAtom_)
  mr = iTabRow(ANr(mAtom))
  Ind(2) = mAtom
  iDCR(2) = iTabAI(2,mAtom_)

  nNeighbor_m = iTabAtoms(1,0,mAtom_)
  nCoBond_m = nCoBond(mAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
  if (nNeighbor_m < 2) cycle

  do iNeighbor=1,nNeighbor_m
    iAtom_ = iTabAtoms(1,iNeighbor,mAtom_)
    iAtom = iTabAI(1,iAtom_)
    nCoBond_i = nCoBond(iAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
    ir = iTabRow(ANr(iAtom))
    Ind(1) = iAtom
    iDCR(1) = iTabAI(2,iAtom_)

    if (iDCR(1) /= iOper(0)) cycle
    if (R_Stab_A(iDCR(2),jStab(0,iAtom),nStab(iAtom)) .and. (iDCR(2) /= iOper(0))) cycle

    iBond = iTabAtoms(2,iNeighbor,mAtom_)
    iBondType = iTabBonds(3,iBond)
    if ((iBondType == vdW_Bond) .or. (iBondType > Magic_Bond)) cycle
#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) 'iAtom,mAtom=',iAtom,mAtom
    write(u6,*) 'iBond,iBondType=',iBond,iBondType
    write(u6,*) 'E,R=',ChOp(iDCR(1)),ChOp(iDCR(2))
#   endif

    A(:,1) = Cx(:,iAtom,iIter)
    Ref(:,1) = Cx(:,iAtom,iRef)
    Prv(:,1) = Cx(:,iAtom,iPrv)

    do jNeighbor=1,nNeighbor_m
      jAtom_ = iTabAtoms(1,jNeighbor,mAtom_)
      jAtom = iTabAI(1,jAtom_)
      nCoBond_j = nCoBond(jAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
      if ((nCoBond_i >= 8) .and. (nCoBond_j >= 8) .and. (nCoBond_m >= 8)) cycle

      jr = iTabRow(ANr(jAtom))
      Ind(3) = jAtom
      iDCR(3) = iTabAI(2,jAtom_)
      if (R_Stab_A(iDCR(3),jStab(0,iAtom),nStab(iAtom)) .and. (iDCR(3) /= iOper(0))) cycle
      if ((iDCR(3) == iOper(0)) .and. (iAtom >= jAtom)) cycle
      kDCR = ieor(iDCR(2),iDCR(3))
      if (R_Stab_A(kDCR,jStab(0,mAtom),nStab(mAtom)) .and. (iDCR(2) /= iOper(0))) cycle

      Help = (mr > 3) .or. (ir > 3) .or. (jr > 3)

      jBond = iTabAtoms(2,jNeighbor,mAtom_)
      jBondType = iTabBonds(3,jBond)
      if ((jBondType == vdW_Bond) .or. (jBondType > Magic_Bond)) cycle
#     ifdef _DEBUGPRINT_
      write(u6,*)
      write(u6,*) 'jAtom,mAtom=',jAtom,mAtom
      write(u6,*) 'jBond,jBondType=',jBond,jBondType
      write(u6,*) 'T=',ChOp(iDCR(3))
#     endif

      write(Label,'(A,I2,A,I2,A,I2,A)') 'A(',iAtom,',',mAtom,',',jAtom,')'

#     ifdef _DEBUGPRINT_
      call RecPrt('A',' ',Cx(:,iAtom,iIter),1,3)
      call RecPrt('B',' ',Cx(:,mAtom,iIter),1,3)
      call RecPrt('C',' ',Cx(:,jAtom,iIter),1,3)
#     endif

      ! Form double coset representatives for (iAtom,jAtom)

      call DCR(Lambda,jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),iDCRT,nDCRT)
#     ifdef _DEBUGPRINT_
      write(u6,'(10A)') 'T={',(ChOp(iDCRT(i)),i=0,nDCRT-1),'}  '
#     endif
      kDCRT = iDCR(3)

#     ifdef _DEBUGPRINT_
      write(u6,'(10A)') 'U={',(ChOp(jStab(i,iAtom)),i=0,nStab(iAtom)-1),'}  '
      write(u6,'(10A)') 'V={',(ChOp(jStab(i,mAtom)),i=0,nStab(mAtom)-1),'}  '
      write(u6,'(10A)') 'X={',(ChOp(jStab(i,jAtom)),i=0,nStab(jAtom)-1),'}  '
      write(u6,'(2A)') 'T=',ChOp(kDCRT)
#     endif

      call OA(kDCRT,Cx(:,jAtom,iIter),A(:,3))
      call OA(kDCRT,Cx(:,jAtom,iRef),Ref(:,3))
      call OA(kDCRT,Cx(:,jAtom,iPrv),Prv(:,3))

      ! Form the stabilizer for (iAtom,jAtom)

      if (iAtom == jAtom) then
        call Union(jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),iDCR(3),iStabN,nStabN)
      else
        call Inter(jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),iStabN,nStabN)
      end if

#     ifdef _DEBUGPRINT_
      write(u6,'(10A)') 'N={',(ChOp(iStabN(i)),i=0,nStabN-1),'}  '
#     endif

      ! Form double coset representatives for ((iAtom,mAtom),jAtom)

      call DCR(Lambda,jStab(0,mAtom),nStab(mAtom),iStabN,nStabN,iDCRR,nDCRR)
      kDCRR = iDCR(2)

#     ifdef _DEBUGPRINT_
      write(u6,'(10A)') 'R={',(ChOp(iDCRR(i)),i=0,nDCRR-1),'}  '
      write(u6,'(2A)') 'R=',ChOp(kDCRR)
#     endif

      call OA(kDCRR,Cx(:,mAtom,iIter),A(:,2))
      call OA(kDCRR,Cx(:,mAtom,iRef),Ref(:,2))
      call OA(kDCRR,Cx(:,mAtom,iPrv),Prv(:,2))

      ! Form the stabilizer for ((iAtom,mAtom),jAtom)

      call Inter(jStab(0,mAtom),nStab(mAtom),iStabN,nStabN,iStabM,nStabM)

#     ifdef _DEBUGPRINT_
      write(u6,'(10A)') 'M={',(ChOp(iStabM(i)),i=0,nStabM-1),'}  '
#     endif

      ! Compute the degeneracy of the angle

      ideg = nIrrep/nStabM
      Deg = sqrt(real(iDeg,kind=wp))
#     ifdef _DEBUGPRINT_
      write(u6,*) ' nIrrep,nStabM=',nIrrep,nStabM
#     endif

      ! Test if coordinate should be included
      ! All angles which are lower than the explicit threshold
      ! are rejected.

      if (Help) then
        rim2 = (Ref(1,1)-Ref(1,2))**2+(Ref(2,1)-Ref(2,2))**2+(Ref(3,1)-Ref(3,2))**2
        rmj2 = (Ref(1,2)-Ref(1,3))**2+(Ref(2,2)-Ref(2,3))**2+(Ref(3,2)-Ref(3,3))**2
        if ((ir == 1) .or. (jr == 1)) then
          f_Const = A_Bend(1)
        else
          f_Const = A_Bend(2)
        end if
        f_Const = f_Const*Fact
        f_Const_Ref = f_Const
      else
        r0 = rAV(ir,mr)
        Alpha = aAv(ir,mr)
        rim2_Ref = (Ref(1,1)-Ref(1,2))**2+(Ref(2,1)-Ref(2,2))**2+(Ref(3,1)-Ref(3,2))**2
        f_Const_Ref = rkf*exp(Alpha*(r0**2-rim2_Ref))
        rim2 = (A(1,1)-A(1,2))**2+(A(2,1)-A(2,2))**2+(A(3,1)-A(3,2))**2
        f_Const = rkf*exp(Alpha*(r0**2-rim2))

        r0 = rAV(mr,jr)
        Alpha = aAv(mr,jr)
        rmj2_Ref = (Ref(1,2)-Ref(1,3))**2+(Ref(2,2)-Ref(2,3))**2+(Ref(3,2)-Ref(3,3))**2
        f_Const_Ref = f_Const_Ref*exp(Alpha*(r0**2-rmj2_Ref))
        rmj2 = (A(1,2)-A(1,3))**2+(A(2,2)-A(2,3))**2+(A(3,2)-A(3,3))**2
        f_Const = f_Const*exp(Alpha*(r0**2-rmj2))

      end if
      if ((f_Const_Ref < f_Const_Min) .and. (iBondType /= Fragments_Bond) .and. (jBondType /= Fragments_Bond)) cycle
#     ifdef _DEBUGPRINT_
      write(u6,*) ' A Force Constant:',f_Const
      write(u6,*) iAtom,mAtom,jAtom,f_Const
#     endif

      call Bend(Ref,nCent,Val_Ref,Grad_Ref,.false.,.false.,'        ',Hess,Proc_dB)
      call Bend(A,nCent,Val,Grad,.false.,.false.,'        ',Hess,Proc_dB)

      ! Skip cases with a too small angle.

      if ((abs(Val_Ref) < Thr_Small) .and. (iBondType /= Fragments_Bond) .and. (jBondType /= Fragments_Bond)) cycle

      !                                                                *
      !*****************************************************************
      !                                                                *
      ! We'd like to avoid the problem with angles that have the
      ! value Pi. We introduce "linear" angles under two
      ! conditions.
      ! (1) the reference angle is within delta of Pi.
      ! (2) the actual angle is within 1.0e-11 of Pi.(?)
      ! Delta is set to 1.0e-11 if there are 3 atoms.(?)

      delta = 45.0_wp*deg2rad
      ! if (mAtoms == 3) delta = 1.0e-11_wp ! I do not understand
      ! although it is probably me who introduced it!

      if (((abs(Val_Ref-Pi) < Delta) .or. (abs(Val-Pi) < 1.0e-11_wp)) .and. &
          (.not. (((iBondType == Fragments_Bond) .or. (jBondType == Fragments_Bond)) .and. (mAtoms <= 4)))) then

        ! Reference is linear(a) or
        ! reference is NOT linear but the new structure is(b).

        if ((abs(Val-Pi) < 1.0e-11_wp) .and. (.not. (abs(Val_Ref-Pi) < Delta))) then
          ! Case b
          nk = 1
        else
          ! Case a
          nk = 2
        end if
        call CoSys(Prv,Axis,Perp_Axis)

        Label = ' '
        Label(1:1) = 'L'
        !do k=1,2
        do k=1,nk
          nq = nq+1
          if (.not. Process) mB_Tot = mB_Tot+mB
          if (.not. Proc_dB) mdB_Tot = mdB_Tot+mB**2

          nqA = nqA+1
          iF1 = 1
          call NxtWrd(AtomLbl(iAtom),iF1,iE1)
          Lbls(1) = AtomLbl(iAtom)(iF1:iE1)
          iF2 = 1
          call NxtWrd(AtomLbl(mAtom),iF2,iE2)
          Lbls(2) = AtomLbl(mAtom)(iF2:iE2)
          if (kDCRR /= 0) then
            Lbls(2)(iE2+1:iE2+2+iChOp(kDCRR)) = '('//ChOp(kDCRR)(1:iChOp(kDCRR))//')'
            call NxtWrd(Lbls(2),iF2,iE2)
          end if
          iF3 = 1
          call NxtWrd(AtomLbl(jAtom),iF3,iE3)
          Lbls(3) = AtomLbl(jAtom)(iF3:iE3)
          if (kDCRT /= 0) then
            Lbls(3)(iE3+1:iE3+2+iChOp(kDCRT)) = '('//ChOp(kDCRT)(1:iChOp(kDCRT))//')'
            call NxtWrd(Lbls(3),iF3,iE3)
          end if
          write(LuIC,'(A,I3.3,A,I1.1,6A)') 'a',nqA,' = LAngle(',k,') ',Lbls(1)(iF1:iE1),' ',Lbls(2)(iF2:iE2),' ',Lbls(3)(iF3:iE3)
#         ifdef _DEBUGPRINT_
          write(u6,'(A,I3.3,A,I1.1,6A)') 'a',nqA,' = LAngle(',k,') ',Lbls(1)(iF1:iE1),' ',Lbls(2)(iF2:iE2),' ',Lbls(3)(iF3:iE3)
          write(u6,*) 'iDeg=',iDeg
#         endif
          Label = ' '
          write(Label,'(A,I3.3)') 'a',nqA

          if (Process) then

            call LBend(A,nCent,Val,Grad_all(:,nq,iIter),.false.,'        ',Hess,Proc_dB,Axis,Perp_Axis(1,k),(k == 2))

            ! Flip Angle value and gradient if needed!

            BB = DDot_(9,Grad_all(:,nq,iPrv),1,Grad_all(:,nq,iIter),1)
            if (BB < Zero) then
              !write(u6,*) ' Angle flips, corrected!'
              Val = Two*Pi-Val
              Grad_all(:,nq,iIter) = -Grad_all(:,nq,iIter)
              Hess(:) = -Hess(:)
            end if

            Indq(1,nq) = 2+k
            mi = (iAtom-1)*nsAtom+mAtom
            Indq(2,nq) = (jAtom-1)*nsAtom**2+mi
            Indq(3,nq) = kDCRT*8+kDCRR+1

            f_Const = max(f_Const,f_Const_Min)
            if ((.not. Help) .and. ((iBondType == Fragments_Bond) .or. (jBondType == Fragments_Bond))) f_Const = f_Const*1.0e3_wp
            fconst(nq) = sqrt(f_Const)
            rMult(nq) = Deg

            Valu(nq,iIter) = Val
            qLbl(nq) = Label

            ! Project the gradient vector

            call ProjSym(nCent,Ind,A,iDCR,Grad_all(:,nq,iIter),Hess,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,Proc_dB,nqB,nB, &
                         nq,rMult(nq))

          end if

        end do

      else      ! Non-linear case

        nq = nq+1
        if (.not. Process) mB_Tot = mB_Tot+mB
        if (.not. Proc_dB) mdB_Tot = mdB_Tot+mB**2

        nqA = nqA+1
        iF1 = 1
        call NxtWrd(AtomLbl(iAtom),iF1,iE1)
        Lbls(1) = AtomLbl(iAtom)(iF1:iE1)
        iF2 = 1
        call NxtWrd(AtomLbl(mAtom),iF2,iE2)
        Lbls(2) = AtomLbl(mAtom)(iF2:iE2)
        if (kDCRR /= 0) then
          Lbls(2)(iE2+1:iE2+2+iChOp(kDCRR)) = '('//ChOp(kDCRR)(1:iChOp(kDCRR))//')'
          call NxtWrd(Lbls(2),iF2,iE2)
        end if
        iF3 = 1
        call NxtWrd(AtomLbl(jAtom),iF3,iE3)
        Lbls(3) = AtomLbl(jAtom)(iF3:iE3)
        if (kDCRT /= 0) then
          Lbls(3)(iE3+1:iE3+2+iChOp(kDCRT)) = '('//ChOp(kDCRT)(1:iChOp(kDCRT))//')'
          call NxtWrd(Lbls(3),iF3,iE3)
        end if
        write(LuIC,'(A,I3.3,6A)') 'a',nqA,' = Angle ',Lbls(1)(iF1:iE1),' ',Lbls(2)(iF2:iE2),' ',Lbls(3)(iF3:iE3)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,I3.3,6A)') 'a',nqA,' = Angle ',Lbls(1)(iF1:iE1),' ',Lbls(2)(iF2:iE2),' ',Lbls(3)(iF3:iE3)
#       endif
        Label = ' '
        write(Label,'(A,I3.3)') 'a',nqA

        if (Process) then

          call Bend(A,nCent,Val,Grad_all(:,nq,iIter),.false.,.false.,'        ',Hess,Proc_dB)

          ! Flip Angle value and gradient if needed!

          BB = DDot_(9,Grad_all(:,nq,iPrv),1,Grad_all(:,nq,iIter),1)
          if (BB < Zero) then
            !write(u6,*) ' Angle flips, corrected!'
            !write(u6,*) ' iRef,iIter=', iRef,iIter
            Val = Two*Pi-Val
            Grad_all(:,nq,iIter) = -Grad_all(:,nq,iIter)
            Hess(:) = -Hess(:)
          end if

          Indq(1,nq) = 2
          mi = (iAtom-1)*nsAtom+mAtom
          Indq(2,nq) = (jAtom-1)*nsAtom**2+mi
          Indq(3,nq) = kDCRT*8+kDCRR+1

          if ((.not. Help) .and. ((iBondType == Fragments_Bond) .or. (jBondType == Fragments_Bond))) f_Const = f_Const*1.0e2_wp
          fconst(nq) = sqrt(f_Const)
          rMult(nq) = Deg

          Valu(nq,iIter) = Val
          qLbl(nq) = Label

          ! Project the gradient vector

          call ProjSym(nCent,Ind,A,iDCR,Grad_all(:,nq,iIter),Hess,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,Proc_dB,nqB,nB,nq, &
                       rMult(nq))

        end if

      end if
      !                                                                *
      !*****************************************************************
      !                                                                *

    end do             ! End loop over jNeighbor
  end do               ! End loop over iCase
end do                 ! End loop over iBond
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Angle_List

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine individual_ranks(nDIMCF,BC,BS,Hinit,LJ,iprint)
      Implicit None
      Integer, Parameter          :: wp=selected_real_kind(p=15,r=307)
#include "stdalloc.fh"
      Integer, intent(in)         :: nDIMCF,iprint
      Real(kind=8),intent(in)    :: BC(nDIMcf,0:nDIMcf)
      Real(kind=8),intent(in)    :: BS(nDIMcf,0:nDIMcf)
      Complex(kind=8),intent(in) :: Hinit(nDIMcf,nDIMcf)
      Character(len=1),intent(in) :: LJ
      ! local variables:
      Integer                     :: i,j,k,n,m,ik,jEnd,nfields,info,
     &                               ikmax,ip,ir,iq
      Integer, allocatable        :: rankKQ(:) ! nDIMCF*(2*nDIMCF+1) )
      Integer, allocatable        :: projKQ(:) ! nDIMCF*(2*nDIMCF+1) )
      Real(kind=8)               :: Tnrm, TnrmKQ, wt
      Real(kind=8)               :: RnrmKQ( nDIMcf,-nDIMcf:nDIMcf )
      Real(kind=8), allocatable  :: ListKQ(:) ! nDIMCF*(2*nDIMCF+1) )
      Real(kind=8), allocatable  :: Rnrm(:) !nDIMCF)
      Real(kind=8), allocatable  :: Snrm(:) !nDIMCF)
      Real(kind=8), allocatable  :: Wk(:,:) !nDIMCF,nDIMCF)
      Real(kind=8), allocatable  :: Ws(:,:) !nDIMCF,nDIMCF)
      Real(kind=8), allocatable  :: Winit(:) !nDIMCF)
      Real(kind=8), external     :: dznrm2_

      Complex(kind=8)              :: zf, redME
      Complex(kind=8), allocatable :: O(:,:)  !nDIMCF,nDIMCF)! real ITO
      Complex(kind=8), allocatable :: W(:,:)  !nDIMCF,nDIMCF)! imag ITO
      Complex(kind=8), allocatable :: HCF(:,:,:) !nDIMCF,nDIMCF,nDIMCF)
      Complex(kind=8), allocatable :: HCFS(:,:,:)!nDIMCF,nDIMCF,nDIMCF)
      Complex(kind=8), allocatable :: Zk(:,:,:)  !nDIMCF,nDIMCF,nDIMCF)
      Complex(kind=8), allocatable :: Zs(:,:,:)  !nDIMCF,nDIMCF,nDIMCF)
      Complex(kind=8), allocatable :: Zinit(:,:) !nDIMCF,nDIMCF)
      Complex(kind=8), allocatable :: HKQ(:,:),Zkq(:,:)

      Real(kind=8)             :: dznrm2
      External                  :: dznrm2
      Character(len=16)         :: field(8)
      Character(len=6)          :: iprog
!-----------------------------------------------------------------------
      Call mma_allocate(Rnrm,nDIMCF,'Rnrm')
      Call mma_allocate(Snrm,nDIMCF,'Snrm')
      Call mma_allocate(Wk,nDIMCF,nDIMCF,'Wk')
      Call mma_allocate(Ws,nDIMCF,nDIMCF,'Ws')
      Call mma_allocate(Winit,nDIMCF,'Winit')
      Call mma_allocate(ListKQ,nDIMCF*(2*nDIMCF+1),'ListKQ')
      Call mma_allocate(rankKQ,nDIMCF*(2*nDIMCF+1),'rankKQ')
      Call mma_allocate(projKQ,nDIMCF*(2*nDIMCF+1),'projKQ')

      Call mma_allocate(O,nDIMCF,nDIMCF,'O')
      Call mma_allocate(W,nDIMCF,nDIMCF,'W')
      Call mma_allocate(HKQ,nDIMCF,nDIMCF,'HKQ')
      Call mma_allocate(ZKQ,nDIMCF,nDIMCF,'ZKQ')
      Call mma_allocate(HCF,nDIMCF,nDIMCF,nDIMCF,'HCF')
      Call mma_allocate(HCFS,nDIMCF,nDIMCF,nDIMCF,'HCFS')
      Call mma_allocate(Zk,nDIMCF,nDIMCF,nDIMCF,'Zk')
      Call mma_allocate(Zs,nDIMCF,nDIMCF,nDIMCF,'Zs')
      Call mma_allocate(Zinit,nDIMCF,nDIMCF,'Zinit')

      Call dcopy_(nDIMCF,[0.0_wp],0,Rnrm,1)
      Call dcopy_(nDIMCF,[0.0_wp],0,Snrm,1)
      Tnrm= 0.0_wp
      Call dcopy_(nDIMCF*nDIMCF,[0.0_wp],0,Wk,1)
      Call dcopy_(nDIMCF*nDIMCF,[0.0_wp],0,Ws,1)
      Call dcopy_(nDIMCF,[0.0_wp],0,Winit,1)

      Call zcopy_(nDIMCF*nDIMCF,[(0.0_wp,0.0_wp)],0,Zinit,1)
      Call zcopy_(nDIMCF*nDIMCF*nDIMCF,[(0.0_wp,0.0_wp)],0,HCF,1)
      Call zcopy_(nDIMCF*nDIMCF*nDIMCF,[(0.0_wp,0.0_wp)],0,HCFS,1)
      Call zcopy_(nDIMCF*nDIMCF*nDIMCF,[(0.0_wp,0.0_wp)],0,Zk,1)
      Call zcopy_(nDIMCF*nDIMCF*nDIMCF,[(0.0_wp,0.0_wp)],0,Zs,1)
!-----------------------------------------------------------------------
      ! re-construct the  initial CF matrix:
      Do N=2,nDIMcf-1,2
        Do M=0,N
          Call Liviu_ESO(nDIMcf,N,M,O,W,redME)
          If(M==0) Then
            zf=cmplx(BC(N,0),0.0_wp,wp)
            Call zaxpy_(nDIMcf*nDIMcf,zf,O,1,HCF(N,1:nDIMcf,1:nDIMcf),1)
          Else
            zf=cmplx(BC(N,M),0.0_wp,wp)
            Call zaxpy_(nDIMcf*nDIMcf,zf,O,1,HCF(N,1:nDIMcf,1:nDIMcf),1)
            zf=cmplx(BS(N,M),0.0_wp,wp)
            Call zaxpy_(nDIMcf*nDIMcf,zf,W,1,HCF(N,1:nDIMcf,1:nDIMcf),1)
          End If
        End Do
      End Do

      Do k=2,nDIMCF-1,2
        Do ik=2,k
          ! add the ranks as follows:
          ! O2= O2
          ! O4= O2+O4
          ! O6= O2+O4+O6
          ! O8= O2+O4+O6+O8
          ! etc...
          ! compute the cumulative CF matrix
          Do i=1,nDIMcf
            Do j=1,nDIMcf
              HCFS(k,i,j) = HCFS(k,i,j) + HCF(ik,i,j)
            End Do
          End Do
        End Do
      End Do

      Do N=2,nDIMCF-1,2
        Rnrm(N)=dznrm2(nDIMcf*nDIMcf,HCF(N,:,:),1)
        Tnrm   =Tnrm+Rnrm(N)
        Do i=2,N,2
          Snrm(N)=Snrm(N)+Rnrm(i)
        End Do
      End Do
      ! compute the CF spinting of individual weight operators:
      Do k=2,nDIMcf-1,2
        CALL DIAG_C2(  HCF(k,:,:), nDIMcf, info, Wk(k,:), Zk(k,:,:) )
        CALL DIAG_C2( HCFS(k,:,:), nDIMcf, info, Ws(k,:), Zs(k,:,:) )
      End Do
      ! set the initial energies as to the sum of all contributions:
      CALL DIAG_C2( Hinit, nDIMcf, info, Winit, Zinit )

!-----------------------------------------------------------------------
! individual parameter contribution:
      TnrmKQ=0.0_wp
      RnrmKQ(:,:)=0.0_wp
      ListKQ(:)=0.0_wp
      projKQ(:)=0
      rankKQ(:)=0
      ik=0
      Do N=2,nDIMcf-1,2
        Do M=-N,N
          ik=ik+1
          ! generate ITO operators:
          Call Liviu_ITO(nDIMcf,N,ABS(M),O,W,redME)
          ! generate HCF for each parameter rank and projection:
          Call zcopy_(nDIMcf*nDIMcf,[(0.0_wp,0.0_wp)],0,HKQ,1)
          If (M<0) Then
            zf=cmplx(BS(N,ABS(M)),0.0_wp,wp)
            Call zaxpy_(nDIMcf*nDIMcf,zf,W,1,HKQ,1)
          Else If (M>=0) Then
            zf=cmplx(BC(N,ABS(M)),0.0_wp,wp)
            Call zaxpy_(nDIMcf*nDIMcf,zf,O,1,HKQ,1)
          End If
!         find the rank value of each NM operator
!         for further estimate the effect of the corresponding CF parameter
          RnrmKQ(N,M)=dznrm2_(nDIMcf*nDIMcf,HKQ(:,:),1)
          TnrmKQ=TnrmKQ+RnrmKQ(N,M)

          ! indexing lists
          ListKQ(ik)=RnrmKQ(N,M)
          rankKQ(ik)=N
          projKQ(ik)=M
        End Do
      End Do
      ikmax=ik
      ! make an ordered list of CF parameters
      ! following their descending effect:
      Call sort_KQ(ikmax,ListKQ,rankKQ,projKQ,2)
!--------- below we just print the data --------------------------------
      If(LJ=='L') then
          iprog='RASSCF'
      Else
          iprog=' RASSI'
      End If

      If ( iprint >= 4 ) Then
        Write(6,'(A,F20.12)') 'Tnrm=',Tnrm
        Do k=1,nDIMCF-1
          Write(6,'(2(A,i2,A,F20.12,2x))') 'Rnrm(',k,')=',Rnrm(k),
     &                                     'Snrm(',k,')=',Snrm(k)
        End Do
      End If


      ! print the cumulative and individual rank weight:
      Write(6,'(/)')
      Write(6,'(A)') 'CUMULATIVE WEIGHT OF INDIVIDUAL-RANK OPERATORS '//
     &               'ON THE CRYSTAL FIELD SPLITTING:'
      If((nDIMCF-1) >= 2) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O2 :------------------------------------------: ',
     &                             (Snrm(2)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 4) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O2 + O4 :-------------------------------------: ',
     &                             (Snrm(4)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 6) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O2 + O4 + O6 :--------------------------------: ',
     &                             (Snrm(6)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 8) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O2 + O4 + O6 + O8 :---------------------------: ',
     &                             (Snrm(8)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 10) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O2 + O4 + O6 + O8 + O10 :---------------------: ',
     &                             (Snrm(10)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 12) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O2 + O4 + O6 + O8 + O10 + O12 :---------------: ',
     &                             (Snrm(12)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 14) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O2 + O4 + O6 + O8 + O10 + O12 + O14 :---------: ',
     &                             (Snrm(14)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 16) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O2 + O4 + O6 + O8 + O10 + O12 + O14 + O16 :---: ',
     &                             (Snrm(16)/Tnrm)*100.0_wp ,' %.'
      End If

!-----------------------------------------------------------------------
      Write(6,*)
      Write(6,'(A)') 'ENERGY SPLITTING INDUCED BY CUMMULATIVE '//
     & 'INDIVIDUAL-RANK OPERATORS (in cm-1).'
      field(1)='      O2       |'
      field(2)='     O2+O4     |'
      field(3)='   O2+O4+O6    |'
      field(4)='  O2+O4+O6+O8  |'
      field(5)=' O2+O4+...+O10 |'
      field(6)=' O2+O4+...+O12 |'
      field(7)=' O2+O4+...+O14 |'
      field(8)=' O2+O4+...+O16 |'
      nfields=INT((nDIMCF-1)/2)
      Do J=1,nfields,4
        jEnd=MIN(nfields,J+3)
        Write(6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)

        If(MOD(nDIMcf,2).eq.1) Then
          Write(6,'(3A,I2,3x,A,5x,A,4x,A,10(5x,A,6x,A))')
     &     '  ',LJ,' =', (nDIMcf-1)/2,'|',
     &      iprog,'|',('ONLY','|',i=j,jEnd)
        Else
          Write(6,'(3A,I3,A,5x,A,4x,A,10(5x,A,6x,A))')
     &     ' ',LJ,' =',(nDIMcf-1),'/2 |',
     &      iprog,'|',('ONLY','|',i=j,jEnd)
        End If

        Write(6,'(10x,10A)') '|     INITIAL   |',(field(i),i=j,jEnd)
        Write(6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)
        Do i=1,nDIMcf
          Write(6,'(1x,A,1x,i2,2x,a,12(f14.8,1x,a))') 'w.f.',i,'|',
     &            (Winit(i)-Winit(1)), '|',
     &           (( Ws(k,i)- Ws(k,1)), '|', k=2*j,2*jEnd,2)
        End Do
        Write(6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)
      End Do ! j




      Write(6,'(/)')
      Write(6,'(A)') 'WEIGHT OF INDIVIDUAL-RANK OPERATORS ON THE '//
     &               'CRYSTAL FIELD SPLITTING:'
      If((nDIMCF-1) >= 2) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O2  :-----------------------------------------: ',
     &                             (Rnrm(2)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 4) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O4  :-----------------------------------------: ',
     &                             (Rnrm(4)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 6) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O6  :-----------------------------------------: ',
     &                             (Rnrm(6)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 8) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O8  :-----------------------------------------: ',
     &                             (Rnrm(8)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 10) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O10 :-----------------------------------------: ',
     &                             (Rnrm(10)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 12) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O12 :-----------------------------------------: ',
     &                             (Rnrm(12)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 14) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O14 :-----------------------------------------: ',
     &                             (Rnrm(14)/Tnrm)*100.0_wp ,' %.'
      End If
      If((nDIMCF-1) >= 16) Then
         Write(6,'(2x,A,F10.6,A)')
     &         'O16 :-----------------------------------------: ',
     &                             (Rnrm(16)/Tnrm)*100.0_wp ,' %.'
      End If

!-----------------------------------------------------------------------
      Write(6,'(/)')
      Write(6,'(A)') 'ENERGY SPLITTING INDUCED BY '//
     & 'INDIVIDUAL-RANK OPERATORS (in cm-1).'
      field(1)='      O2       |'
      field(2)='      O4       |'
      field(3)='      O6       |'
      field(4)='      O8       |'
      field(5)='      O10      |'
      field(6)='      O12      |'
      field(7)='      O14      |'
      field(8)='      O16      |'
      nfields=INT((nDIMCF-1)/2)

      Do J=1,nfields,4
        jEnd=MIN(nfields,J+3)
        Write(6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)

        If(MOD(nDIMcf,2).eq.1) Then
          Write(6,'(3A, I2,3x,A,5x,A,4x,A,10(5x,A,6x,A))')
     &     '  ',LJ,' =', (nDIMcf-1)/2,'|',
     &     iprog,'|',('ONLY','|',i=j,jEnd)
        Else
          Write(6,'(3A,I3,a,5x,A,4x,A,10(5x,A,6x,A))')
     &     ' ',LJ,' =',(nDIMcf-1),'/2 |',
     &        iprog,'|',('ONLY','|',i=j,jEnd)
        End If

        Write(6,'(10x,10A)') '|     INITIAL   |',(field(i),i=j,jEnd)
        Write(6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)
        Do i=1,nDIMcf
          Write(6,'(1x,A,1x,i2,2x,a,12(f14.8,1x,a))') 'w.f.',i,'|',
     &            (Winit(i)-Winit(1)), '|',
     &           (( Wk(k,i)- Wk(k,1)), '|', k=2*j,2*jEnd,2)
        End Do
        Write(6,'(16A)') '----------|',('---------------|',i=j,jEnd+1)
      End Do ! j


!-----------------------------------------------------------------------
      Write(6,'(/)')
      Write(6,'(A)') 'WEIGHT OF INDIVIDUAL CRYSTAL FIELD PARAMETERS'//
     & ' ON THE CRYSTAL FIELD SPLITTING: (in descending order):'
      Write(6,'(A)') 'CFP are given in ITO used in J. Chem. Phys. '//
     &               '137, 064112 (2012).'

      Write(6,'(100A)') ('-',i=1,55),'|'
      Write(6,'(A)') '  k |  q  |         B(k,q)        |'//
     &                          '    Weight (in %)   |'
      Write(6,'(A)') '----|-----|-----------------------|'//
     &                          '--------------------|'
      Do ik=1,ikmax
         ip=projKQ(ik)
         iq=abs(projKQ(ik))
         ir=rankKQ(ik)
         wt=100_wp*ListKQ(ik)/TnrmKQ

         If(projKQ(ik)>=0) Then
            Write(6,'((1x,I2,1x,A),(1x,I3,1x,A),(E22.14,1x,A)'//
     &                'F19.14,1x,A)')
     &               ir,'|',ip,'|',BC(ir,iq),'|',wt,'|'
         Else
            Write(6,'((1x,I2,1x,A),(1x,I3,1x,A),(E22.14,1x,A)'//
     &                'F19.14,1x,A)')
     &               ir,'|',ip,'|',BS(ir,iq),'|',wt,'|'
         End If
      End Do
      Write(6,'(A)') '----|-----|-----------------------|'//
     &                          '--------------------|'




!-----------------------------------------------------------------------
      Call mma_deallocate(Rnrm)
      Call mma_deallocate(Snrm)
      Call mma_deallocate(Wk)
      Call mma_deallocate(Ws)
      Call mma_deallocate(Winit)

      Call mma_deallocate(O)
      Call mma_deallocate(W)
      Call mma_deallocate(HKQ)
      Call mma_deallocate(HCF)
      Call mma_deallocate(HCFS)
      Call mma_deallocate(Zk)
      Call mma_deallocate(Zkq)
      Call mma_deallocate(Zs)
      Call mma_deallocate(Zinit)
      Call mma_deallocate(ListKQ)
      Call mma_deallocate(rankKQ)
      Call mma_deallocate(projKQ)

      Return
      End Subroutine individual_ranks




      Subroutine sort_KQ(N,ARR,rank,proj,iopt)
      Implicit None
      Integer, Parameter          :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)         :: N, iopt
      Integer, intent(inout)      :: rank(N), proj(N)
      Real(kind=8), intent(inout):: ARR(N)
      ! local
      Integer       :: i,j,ir,ip
      Real(kind=8) :: a
!  iopt = 1   => sort in ascending order
!  iopt = 2   => sort in descending order

      If (iopt==1) Then
         Do j=2,N
            a=ARR(j)
            ir=rank(j)
            ip=proj(j)

            Do i = j-1,1,-1
               If ( ARR(i)<=a ) goto 10
               ARR(i+1) =ARR(i)
               rank(i+1)=rank(i)
               proj(i+1)=proj(i)
            End Do
            i=0
 10         Continue
            ARR(i+1) =a
            rank(i+1)=ir
            proj(i+1)=ip
         End Do
      Else If (iopt==2) Then
         Do j=2,N
            a=ARR(j)
            ir=rank(j)
            ip=proj(j)

            Do i = j-1,1,-1
               If ( ARR(i)>=a ) goto 11
               ARR(i+1) =ARR(i)
               rank(i+1)=rank(i)
               proj(i+1)=proj(i)
            End Do
            i=0
 11         Continue
            ARR(i+1) =a
            rank(i+1)=ir
            proj(i+1)=ip
         End Do
      Else
         Write(6,'(A)') 'sort_KQ error:  iopt parameter is wrong.'
         Write(6,    *) 'iopt = ', iopt
         Write(6,'(A)') 'iopt = 1, sort in ascending order'
         Write(6,'(A)') 'iopt = 2, sort in descending order'
         Write(6,'(A)') 'Return, wthout sorting'
         Call xFlush(6)
         Return
      End If

      Return
      End Subroutine sort_KQ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!***********************************************************************

subroutine ORBORD(NSM,NR4TP,NRSOBS,NTOOBS,IREOTS,ISFTO,IBSO,NTSOB,IBTSOB,ITSOB,NOBPTS,NNOBPT,NOBPT)
! Obtain Reordering arrays for orbitals
! (See note below for assumed ordering)
!
! =====
! Input
! =====
!  NSM    : Number of orbital symmetries
!  NR4TP  : Number of RAS4 types
!  NRSOBS : Number of orbitals per symmetry in RAS1,RAS2,RAS3
!  NTOOBS : Number of orbitals per symmetry,all types
!
! ======
! Output
! ======
!  IREOTS : Reordering array type     => symmetry
!  ISFTO  : Symmetry array for type ordered orbitals
!  IBSO   : First orbital of given symmetry (symmetry ordered)
!  NTSOB  : Number of active orbitals of give RAS type and SYM
!  IBTSOB : Off set for active orbitals of given RAS type and SYM
!  ITSOB  : Orbitals of given RAS type and sym
!
!  NOBPTS : Number of orbitals per subtype and symmetry
!
! Jeppe Olsen, Winter 1991

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NSM, NR4TP, NRSOBS(NSM,3), NTOOBS(*), NNOBPT
integer(kind=iwp), intent(_OUT_) :: IREOTS(*), ISFTO(*), IBSO(*), NTSOB(3,*), IBTSOB(3,*), ITSOB(*), NOBPTS(NNOBPT,*)
integer(kind=iwp), intent(out) :: NOBPT(NNOBPT)
integer(kind=iwp) :: i, I123, IAC, IACS, IBSM, IIAC, IOFF, IORB, IOTYPE, IRS, ISM, ISMOB, ITYPE, LORB, NPREVS
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: NACOB, NTOOB
#endif

! =========================
! Note on order of orbitals
! =========================
!
! The orbitals are supposed to be imported ordered symmetry-type
! ordered as
! Loop over symmetries of orbitals
!   Inactive  of this symmetry
!   Core      of this symmetry
!   RAS1      of this symmetry
!   RAS2      of this symmetry
!   RAS3      of this symmetry
!   Secondary of this symmetry
!   Deleted   of this symmetry
! End of loop over symmetries
!
! Internally the orbitals are reordered to type symmetry order
! where the outer loop os over types and the inner loop is
! over symmetries.The types are arranged as
!  Ras1
!  Ras2
!  Ras3
!  Core
!  Secondary
!  Inactive
!  Deleted orbitals

! Active orbitals

IAC = 0
!IBSM = 0   ! dummy initialize
!NPREVS = 0 ! dummy initialize
!IORB = 0   ! dummy initialize
do IRS=1,3
  do ISM=1,NSM
    if (ISM == 1) then
      IBSM = 1
    else
      IBSM = IBSM+NTOOBS(ISM-1)
    end if
    NPREVS = sum(NRSOBS(ISM,1:IRS-1)) ! +NINOBS(ISM)+NR0OBS(ISM)
    IORB = NRSOBS(ISM,IRS)
    !if (IRS == 1) then
    !  NPREVS = 0 ! NINOBS(ISM)+NR0OBS(ISM)
    !  IORB = NRSOBS(ISM,1)
    !else if (IRS == 2) then
    !  NPREVS = NRSOBS(ISM,1) ! NINOBS(ISM)+NR0OBS(ISM)+NRSOBS(ISM,1)
    !  IORB = NRSOBS(ISM,2)
    !else if (IRS == 3) then
    !  NPREVS = NRSOBS(ISM,1)+NRSOBS(ISM,2) ! NINOBS(ISM)+NR0OBS(ISM)+NRSOBS(ISM,1)+NRSOBS(ISM,2)
    !  IORB = NRSOBS(ISM,3)
    !end if
    do IIAC=1,IORB
      ! Type ordered index
      IAC = IAC+1
      ! Symmetry ordered index
      IACS = IBSM+NPREVS-1+IIAC
      ISFTO(IAC) = ISM
      !ITFSO(IACS) = IRS
      IREOTS(IAC) = IACS
    end do
  end do
end do
!NACOB = IAC
!write(u6,*) ' IAC ',IAC

! RAS 0 orbitals

!IR0 = NACOB
!do ISM=1,NSM
!  if (ISM == 1) then
!    IBSM = 1
!  else
!    IBSM = IBSM+NTOOBS(ISM-1)
!  end if
!  NPREVS = NINOBS(ISM)
!  do IIR0=1,NR0OBS(ISM)
!    ! Type ordered index
!    IR0 = IR0+1
!    ! Symmetry ordered index
!    IR0S = IBSM+NPREVS-1+IIR0
!    ISFTO(IR0) = ISM
!    !ITFSO(IR0S) = 4
!    IREOTS(IR0) = IR0S
!  end do
!end do
!NR0OB = IR0-NACOB
!write(u6,*) ' IR0 ',IR0

! RAS 4 orbitals

!IR4 = NACOB+NR0OB
!do ISM=1,NSM
!  if (ISM == 1) then
!    IBSM = 1
!  else
!    IBSM = IBSM+NTOOBS(ISM-1)
!  end if
!  NPREVS = NINOBS(ISM)+NR0OBS(ISM)+NACOBS(ISM)
!  do ITP=1,NR4TP
!    do IIR4=1,NR4OBS(ISM,ITP)
!      ! Type ordered index
!      IR4 = IR4+1
!      ! Symmetry ordered index
!      IR4S = IBSM+NPREVS-1+IIR4
!      ISFTO(IR4) = ISM
!      !ITFSO(IR4S) = 5
!      IREOTS(IR4) = IR4S
!    end do
!  end do
!end do
!NR4OB = IR4-NACOB-NR0OB
!write(u6,*) ' IR4 ',IR4

! Inactive orbitals

!IIN = NACOB+NR0OB+NR4OB
!do ISM=1,NSM
!  if (ISM == 1) then
!    IBSM = 1
!  else
!    IBSM = IBSM+NTOOBS(ISM-1)
!  end if
!  NPREVS = 0
!  do IIIN=1,NINOBS(ISM)
!    ! Type ordered index
!    IIN = IIN+1
!    ! Symmetry ordered index
!    IINS = IBSM+NPREVS-1+IIIN
!    ISFTO(IIN) = ISM
!    !ITFSO(IINS) = 6
!    IREOTS(IIN) = IINS
!  end do
!end do
!NINOB = IIN-NACOB-NR0OB-NR4OB
!write(u6,*) ' IIN ',IIN

! Deleted orbitals

!IDE = NACOB+NR0OB+NR4OB+NINOB
!do ISM=1,NSM
!  if (ISM == 1) then
!    IBSM = 1
!  else
!    IBSM = IBSM+NTOOBS(ISM-1)
!  end if
!  IR4 = 0
!  do ITP=1,NR4TP
!    IR4 = IR4+NR4OBS(ISM,ITP)
!  end do
!
!  NPREVS = NINOBS(ISM)+NR0OBS(ISM)+NACOBS(ISM)+IR4
!  do IIDE=1,NDEOBS(ISM)
!    ! Type ordered index
!    IDE = IDE+1
!    ! Symmetry ordered index
!    IDES = IBSM+NPREVS-1+IIDE
!    ISFTO(IDE) = ISM
!    !ITFSO(IDES) = 7
!    IREOTS(IDE) = IDES
!  end do
!end do
!write(u6,*) ' IDE ',IDE

IBSO(1) = 1
do ISM=2,NSM
  IBSO(ISM) = IBSO(ISM-1)+NTOOBS(ISM-1)
end do

! ==================
! NTSOB,IBTSOB,ITSOB
! ==================

IOFF = 1
do I123=1,3
  do ISM=1,NSM
    NTSOB(I123,ISM) = NRSOBS(ISM,I123)
    IBTSOB(I123,ISM) = IOFF
    ITSOB(IOFF:IOFF+NRSOBS(ISM,I123)-1) = [(i,i=IOFF,IOFF+NRSOBS(ISM,I123)-1)]
    IOFF = IOFF+NRSOBS(ISM,I123)
  end do
end do

! ============
! NOBPTS NOBPT
! ============

! Loop over types in input order
NOBPT(1:NR4TP+6) = 0
LORB = 0   ! dummy initialize
IOTYPE = 0 ! dummy initialize
do ISMOB=1,NSM
  do ITYPE=1,NR4TP+6
    if (ITYPE == 1) then
      ! Inactive (frozen in normal notation)
      LORB = 0 ! NINOBS(ISMOB)
      IOTYPE = 5+NR4TP
    else if (ITYPE == 2) then
      ! RAS0 (inactive in normal notation)
      LORB = 0 ! NR0OBS(ISMOB)
      IOTYPE = 4
    else if (ITYPE == 3) then
      ! RAS1
      LORB = NRSOBS(ISMOB,1)
      IOTYPE = 1
    else if (ITYPE == 4) then
      ! RAS2
      LORB = NRSOBS(ISMOB,2)
      IOTYPE = 2
    else if (ITYPE == 5) then
      ! RAS3
      LORB = NRSOBS(ISMOB,3)
      IOTYPE = 3
    else if ((ITYPE >= 6) .and. (ITYPE <= NR4TP+6-1)) then
      ! RAS4
      LORB = 0 ! NR4OBS(ISMOB,ITYPE-5)
      IOTYPE = ITYPE-1
    else if (ITYPE == NR4TP+6) then
      ! deleted orbitals
      LORB = 0 ! NDEOBS(ISMOB)
      IOTYPE = ITYPE
    end if
    NOBPTS(IOTYPE,ISMOB) = LORB
    NOBPT(IOTYPE) = NOBPT(IOTYPE)+LORB
  end do
end do

#ifdef _DEBUGPRINT_
NACOB = IAC
NTOOB = NACOB
!NTOOB = IDE
write(u6,*) ' =================='
write(u6,*) ' Output from ORBORD'
write(u6,*) ' =================='
write(u6,*) ' Symmetry of orbitals, type ordered'
call IWRTMA(ISFTO,1,NTOOB,1,NTOOB)
write(u6,*) ' Type => symmetry reordering array'
call IWRTMA(IREOTS,1,NTOOB,1,NTOOB)
write(u6,*) ' IBSO array'
call IWRTMA(IBSO,1,NSM,1,NSM)

write(u6,*) ' NTSOB array :'
call IWRTMA(NTSOB,3,NSM,3,NSM)
write(u6,*) ' IBTSOB array'
call IWRTMA(IBTSOB,3,NSM,3,NSM)
write(u6,*) ' ITSOB'
call IWRTMA(ITSOB,1,NACOB,1,NACOB)

write(u6,*) ' NOBPTS'
call IWRTMA(NOBPTS,NR4TP+6,NSM,NNOBPT,NSM)
write(u6,*) ' NOBPT'
call IWRTMA(NOBPT,NR4TP+6,1,NNOBPT,1)

write(u6,*) ' ISFTO array :'
call IWRTMA(ISFTO,1,NTOOB,1,NTOOB)
!write(u6,*) ' ITFSO array :'
!call IWRTMA(ITFSO,1,NTOOB,1,NTOOB)
#endif

end subroutine ORBORD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine symchk_cvb()
      implicit real*8 (a-h,o-z)
c ... Make: up to date? ...
      logical, external :: up2date_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      logical recinpcmp_cvb

      if(up2date_cvb('SYMINIT'))then
c  iorts:
        if(recinpcmp_cvb(14))call touch_cvb('ORBFREE')
c  irots:
        if(recinpcmp_cvb(15))call touch_cvb('ORBFREE')
c  iorbrel:
        if(recinpcmp_cvb(9))then
          call touch_cvb('SYMINIT')
          call touch_cvb('ORBFREE')
        endif
c  ifxorb:
        if(recinpcmp_cvb(11))then
          call touch_cvb('SYMINIT')
          call touch_cvb('ORBFREE')
        endif
      endif
      if(up2date_cvb('CONSTRUC'))then
c  ifxstr:
        if(recinpcmp_cvb(12))then
          call touch_cvb('CONSTRUC')
          call touch_cvb('CIFREE')
        endif
c  idelstr:
        if(recinpcmp_cvb(13))then
          call touch_cvb('CONSTRUC')
          call touch_cvb('CIFREE')
        endif
c  izeta:
        if(recinpcmp_cvb(16))then
          call touch_cvb('CONSTRUC')
          call touch_cvb('CIFREE')
        endif
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine TERI1(Zeta,Eta,P,Q,nT,T,ZEInv,IsChi,ChiI2)
!***********************************************************************
!                                                                      *
! Object: to entities for the two-electron integrals which are used in *
!         in the Rys quadrature to evaluate these integrals.           *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!***********************************************************************

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nT, IsChi
real(kind=wp), intent(in) :: Zeta(nT), Eta(nT), P(nT,3), Q(nT,3), ChiI2
real(kind=wp), intent(out) :: T(nT), ZEInv(nT)
integer(kind=iwp) :: iT
real(kind=wp) :: PQ2, Rho, tmp

#ifdef _DEBUGPRINT_
iRout = 56
iPrint = nPrint(iRout)
if (iPrint >= 99) then
  call RecPrt(' Zeta in TERI1',' ',Zeta,nT,1)
  call RecPrt(' Eta in TERI1',' ',Eta,nT,1)
  call RecPrt(' P in TERI1',' ',P,nT,3)
  call RecPrt(' Q in TERI1',' ',Q,nT,3)
end if
#endif

do iT=1,nT
  tmp = One/(Zeta(iT)+Eta(iT)+(Eta(iT)*Zeta(iT)*ChiI2)*real(IsChi,kind=wp))
  ZEInv(iT) = tmp
  Rho = Zeta(iT)*Eta(iT)*tmp
  PQ2 = (P(iT,1)-Q(iT,1))**2+(P(iT,2)-Q(iT,2))**2+(P(iT,3)-Q(iT,3))**2
  T(iT) = Rho*PQ2
end do

#ifdef _DEBUGPRINT_
if (iPrint >= 99) then
  call RecPrt('Tvalue',' ',T,nT,1)
end if
#endif

return

end subroutine TERI1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine aikcof_cvb(aikcof,bikcof,ndet,ifns,kbasis,share)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ndet, ifns, kbasis
real(kind=wp), intent(inout) :: aikcof(ndet,ifns)
real(kind=wp), intent(in) :: bikcof(ndet,ifns)
logical(kind=iwp), intent(in) :: share
real(kind=wp), allocatable :: sovr(:,:)

if (kbasis == 6) return

! Generate mapping from determinants to spin functions
! (If KBASIS<=2 then AIKCOF=BIKCOF and they (probably) share memory)
if (kbasis > 2) then
  call mma_allocate(sovr,ifns,ifns,label='sovr')
  call mxattb_cvb(bikcof,bikcof,ifns,ndet,ifns,sovr)
  call mxinv_cvb(sovr,ifns)
  call mxatb_cvb(bikcof,sovr,ndet,ifns,ifns,aikcof)
  call mma_deallocate(sovr)
else if (.not. share) then
  aikcof(:,:) = bikcof(:,:)
end if

return

end subroutine aikcof_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Roland Lindh                                           *
!***********************************************************************

subroutine Rd_UDIC(iInt,nFix,nRowH)
!***********************************************************************
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Slapaf_Info, only: iRow
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: iInt, nFix, nRowH
integer(kind=iwp) :: iLines, jLines, kLines, lLines, Lu_UDIC, Skip
logical(kind=iwp) :: Found
character(len=120) :: Temp
character(len=16) :: filnam
integer(kind=iwp), external :: IsFreeUnit

Lu_UDIC = IsFreeUnit(91)
filnam = 'UDIC'
call molcas_open(Lu_UDIC,filnam)
!open(Lu_UDIC,File=filnam,Form='FORMATTED',Status='OLD')
rewind(Lu_UDIC)

! Find begining of definitions of internal coordinates

Found = .false.
do iLines=1,iRow
  read(Lu_UDIC,'(A)') Temp
  call UpCase(Temp)
  if (Temp(1:4) == 'VARY') then
    Found = .true.
    exit
  end if
end do
if (.not. Found) then
  call WarningMessage(2,' No internal coordinates are defined!')
  call Quit_OnUserError()
end if

Skip = 2
iInt = 0
nFix = 0
nRowH = 0 ! Number of Rows of Hessian Numerically estimated
do jLines=iLines+1,iRow
  read(Lu_UDIC,'(A)') Temp
  call UpCase(Temp)
  if (Temp(1:3) == 'FIX') then
    Skip = 0
    exit
  end if
  if (Temp(1:4) == 'ROWH') then
    kLines = jLines
    Skip = 1
    exit
  end if
  ! Do not count line if continuation character
  if (index(Temp,'&') == 0) iInt = iInt+1
end do

if (Skip < 2) then
  if (Skip < 1) then
    do kLines=jLines+1,iRow
      read(Lu_UDIC,'(A)') Temp
      call UpCase(Temp)
      if (Temp(1:4) == 'ROWH') exit
      ! Do not count line if continuation character
      if (index(Temp,'&') == 0) nFix = nFix+1
    end do
  end if
  do lLines=kLines+1,iRow
    read(Lu_UDIC,'(A)') Temp
    call UpCase(Temp)
    ! Do not count line if continuation character
    if (index(Temp,'&') == 0) nRowH = nRowH+1
  end do
end if

close(Lu_UDIC)

return

end subroutine Rd_UDIC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SETSH2(ISHLSO,ISOSHL,NBSTSH,NBAST,NSHELL)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NBAST, ISOSHL(NBAST), NSHELL, NBSTSH(NSHELL)
integer(kind=iwp), intent(out) :: ISHLSO(NBAST)
integer(kind=iwp) :: I, ICOUNT, ISHL

do ISHL=1,NSHELL
  ICOUNT = 0
  I = 0
  do while ((I < NBAST) .and. (ICOUNT < NBSTSH(ISHL)))
    I = I+1
    if (ISOSHL(I) == ISHL) then
      ICOUNT = ICOUNT+1
      ISHLSO(I) = ICOUNT
    end if
  end do
end do

end subroutine CHO_SETSH2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_T(Z_Tot,T,ZA,RA,nAtoms)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms
real(kind=wp), intent(in) :: Z_Tot, ZA(nAtoms), RA(3,nAtoms)
real(kind=wp), intent(out) :: T(3)
integer(kind=iwp) :: iAtom, iCar
real(kind=wp) :: Tmp

!                                                                      *
!***********************************************************************
!                                                                      *
! Form the center of nuclear charge

do iCar=1,3
  Tmp = Zero
  do iAtom=1,nAtoms
    Tmp = Tmp+ZA(iAtom)*RA(iCar,iAtom)
  end do
  T(iCar) = Tmp/Z_Tot
end do
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Compute_T

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_GetMQ(MQ,l_MQ,List_QShp,nQShp)

use Cholesky, only: iiBstR, iiBstRSh, IndRed, IndRSh, iQuAB, LuSel, nnBstR, nnBstRSh, nnShl, nQual, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: l_MQ, nQShp, List_QShp(nQShp)
real(kind=wp), intent(out) :: MQ(l_MQ)
integer(kind=iwp) :: iAB, iabSh, iAdr, iL_Shp, iL_ShpG, ipfr, ipS, ipto, iQ, iQoff, isAB, iShAB, iShABG, iShp, iShpAdr, jQ, jSym, &
                     Lint, Lread
integer(kind=iwp), allocatable :: kOff_Shp(:)
real(kind=wp), allocatable :: Scr(:)
integer(kind=iwp), parameter :: iOpt = 2
integer(kind=iwp), external :: Cho_F2SP, Cho_P_LocalSP

if (sum(nQual(1:nSym)) < 1) return ! this test makes sense for parallel run

call mma_allocate(kOff_Shp,nnShl,Label='kOff_Shp')

iQoff = 0
do jSym=1,nSym

  if (nQual(jSym) < 1) cycle ! next symmetry

  Lint = 0
  do iShp=1,nQShp  ! set only the needed offsets
    iL_ShpG = List_QShp(iShp) ! Shell pair
    iL_Shp = Cho_P_LocalSP(iL_ShpG) ! local shell pair
    kOff_Shp(iL_Shp) = Lint
    Lint = Lint+nnBstRSh(jSym,iL_Shp,2)
  end do

  call mma_allocate(Scr,Lint,Label='Scr')

  ! Read the integrals
  !-------------------
  do jQ=1,nQual(jSym)

    iAdr = nnBstr(jSym,2)*(jQ-1)

    do iShp=1,nQShp

      iL_ShpG = List_QShp(iShp)
      iL_Shp = Cho_P_LocalSP(iL_ShpG) ! local shell pair
      ipS = 1+kOff_Shp(iL_Shp)
      iShpAdr = iAdr+iiBstRSh(jSym,iL_Shp,2)
      Lread = nnBstRSh(Jsym,iL_Shp,2)
      call dDaFile(LuSel(JSym),iOpt,Scr(ipS),Lread,iShpAdr)

    end do

    ! Extract the matrix of qualified integrals
    !------------------------------------------
    do iQ=1,nQual(jSym)

      iAB = iQuAB(iQ,jSym)  ! addr curr red set
      isAB = iAB-iiBstR(jSym,2)  ! symm. reduction
      iShABG = IndRsh(IndRed(iAB,2)) ! glob. SP it belongs to
      iShAB = Cho_P_LocalSP(Cho_F2SP(iShABG)) ! local SP
      iabSh = isAB-iiBstRSh(jSym,iShAB,2) ! addr within Shp
      ipfr = kOff_Shp(iShAB)+iabSh
      ipto = iQoff+nQual(jSym)*(jQ-1)+iQ
      MQ(ipto) = Scr(ipfr)

    end do

  end do

  iQoff = iQoff+nQual(jSym)**2

  call mma_deallocate(Scr)

end do

call mma_deallocate(kOff_Shp)

return

end subroutine Cho_GetMQ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2006  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE SPECIAL(G1,G2,G3,F1,F2,F3,idxG3)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION G1(NASHT,NASHT),G2(NASHT,NASHT,NASHT,NASHT),G3(*)
      DIMENSION F1(NASHT,NASHT),F2(NASHT,NASHT,NASHT,NASHT),F3(*)
      INTEGER*1 idxG3(6,*)
      INTEGER I1
      PARAMETER (I1=KIND(idxG3))
C SPECIAL-CASE ROUTINE. DELIVERS G AND F MATRICES FOR A HIGH-SPIN
C OR CLOSED-SHELL SCF CASE.
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "pt2_guga.fh"

#include "para_info.fh"
      LOGICAL RSV_TSK


      CALL DCOPY_(NG1,[0.0D0],0,G1,1)
      CALL DCOPY_(NG2,[0.0D0],0,G2,1)
      CALL DCOPY_(NG3,[0.0D0],0,G3,1)
      CALL DCOPY_(NG1,[0.0D0],0,F1,1)
      CALL DCOPY_(NG2,[0.0D0],0,F2,1)
      CALL DCOPY_(NG3,[0.0D0],0,F3,1)

      ESUM=0.0D0
      DO I=1,NLEV
        ESUM=ESUM+ETA(I)
      END DO
C ISCF=1 for closed-shell, =2 for hispin
      OCC=2.0D0
      IF(ISCF.EQ.2) OCC=1.0D0
      DO IT=1,NASHT
        G1(IT,IT)=OCC
        LT=LEVEL(IT)
        F1(IT,IT)=(ESUM*OCC-ETA(LT))*G1(IT,IT)
      END DO

      IF(NACTEL.EQ.1) THEN
        NG3=0
        GOTO 999
      END IF

      DO IT=1,NASHT
       LT=LEVEL(IT)
       DO IU=1,NASHT
        LU=LEVEL(IU)
        G2(IT,IT,IU,IU)=G1(IT,IT)*G1(IU,IU)
        IF(IU.EQ.IT) THEN
         G2(IT,IT,IU,IU)=G2(IT,IT,IU,IU)-G1(IT,IU)
        ELSE
         G2(IT,IU,IU,IT)=-G1(IT,IT)
        END IF
        F2(IT,IT,IU,IU)=(ESUM*OCC-ETA(LT)-ETA(LU))*G2(IT,IT,IU,IU)
        F2(IT,IU,IU,IT)=(ESUM*OCC-ETA(LT)-ETA(LU))*G2(IT,IU,IU,IT)
       END DO
      END DO

      IF(NACTEL.EQ.2) THEN
        NG3=0
        GOTO 999
      END IF

      NLEV2=NLEV**2
      NLEV4=NLEV**4

      iG3=0
      nTask=NLEV4
C SVC20100908 initialize the series of tasks
      Call Init_Tsk(ID, nTask)

 500  CONTINUE
#ifdef _MOLCAS_MPP_
      IF ((NG3-iG3).LT.NLEV2) GOTO 501
#endif
 502  IF (.NOT.Rsv_Tsk(ID,iTask)) GOTO 501

      IND1=MOD(iTask-1,NLEV2)+1
      IND2=((iTask-IND1)/(NLEV2))+1
      IF(IND2.GT.IND1) GOTO 502

      IT1=MOD(IND1-1,NASHT)+1
      IU1=(IND1-IT1)/NASHT+1
      LU1=LEVEL(IU1)
      IT2=MOD(IND2-1,NASHT)+1
      IU2=(IND2-IT2)/NASHT+1
      LU2=LEVEL(IU2)

      DO IT3=1,NLEV
       DO IU3=1,NLEV
        IND3=IT3+NASHT*(IU3-1)
        IF(IND3.GT.IND2) GOTO 198
        LU3=LEVEL(IU3)
        VAL=G1(IT1,IU1)*G1(IT2,IU2)*G1(IT3,IU3)

C Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
C Add here the necessary Kronecker deltas times 2-body matrix
C elements and lower, so we get a true normal-ordered density matrix
C element.

C <PSI1|E(T1,U1,T2,U2,T3,U3)|PSI2>
C = <PSI1|E(T1,U1)E(T2,U2)E(T3,U3)|PSI2>
C -D(T3,U2)*(G2(T1,U1,T2,U3)+D(T2,U1)*G1(T1,U3))
C -D(T2,U1)*G2(T1,U2,T3,U3)
C -D(T3,U1)*G2(T2,U2,T1,U3)

        IF(IT3.EQ.IU2) THEN
          VAL=VAL-G2(IT1,IU1,IT2,IU3)
          IF(IT2.EQ.IU1) THEN
            VAL=VAL-G1(IT1,IU3)
          END IF
        END IF
        IF(IT2.EQ.IU1) THEN
          VAL=VAL-G2(IT1,IU2,IT3,IU3)
        END IF
        IF(IT3.EQ.IU1) THEN
          VAL=VAL-G2(IT2,IU2,IT1,IU3)
        END IF

C VAL is now =<PSI1|E(IT1,IU1,IT2,IU2,IT3,IU3)|PSI2>
        iG3=iG3+1
        idxG3(1,iG3)=INT(iT1,I1)
        idxG3(2,iG3)=INT(iU1,I1)
        idxG3(3,iG3)=INT(iT2,I1)
        idxG3(4,iG3)=INT(iU2,I1)
        idxG3(5,iG3)=INT(iT3,I1)
        idxG3(6,iG3)=INT(iU3,I1)
        G3(iG3)=VAL
        F3(iG3)=(ESUM*OCC-ETA(LU1)-ETA(LU2)-ETA(LU3))*VAL

 198    CONTINUE
        END DO
      END DO

CSVC: The master node now continues to only handle task scheduling,
C     needed to achieve better load balancing. So it exits from the task
C     list.  It has to do it here since each process gets at least one
C     task.
#if defined (_MOLCAS_MPP_) && !defined (_GA_)
      IF (IS_REAL_PAR().AND.KING().AND.(NPROCS.GT.1)) GOTO 501
#endif

      GO TO 500
 501  CONTINUE

C SVC2010: no more tasks, wait here for the others.
      CALL Free_Tsk(ID)

      NG3=iG3

 999  CONTINUE

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

subroutine ClsSew()
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Real_Spherical, only: Sphere_Free
use EFP_module, only: ABC, EFP_COORS, FRAG_TYPE, lEFP
use External_Centers, only: external_centers_free
use Basis_Info, only: Basis_Info_Free, Seward_Activated
use Center_Info, only: Center_Info_Free
use Symmetry_Info, only: Symmetry_Info_Free
use SOAO_Info, only: SOAO_Info_Free
use stdalloc, only: mma_deallocate

implicit none

if (Seward_Activated) then

  call Term_Ints()
  call Free_RctFld()
  call Free_HerRW()
  call Sphere_Free()
  call SOAO_Info_Free()
  call Basis_Info_Free()
  call SYmmetry_Info_Free()
  call Center_Info_Free()
  call External_Centers_Free()
  call Free_iSD()
  call CloseR()

  if (lEFP) then
    call mma_deallocate(FRAG_TYPE)
    call mma_deallocate(ABC)
    call mma_deallocate(EFP_COORS)
    lEFP = .false.
  end if

  Seward_Activated = .false.

end if

return

end subroutine ClsSew

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GFPrnt_i(EVal,nDim)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(in) :: EVal(nDim)
integer(kind=iwp) :: i, iHarm, Inc, Jnc
character(len=120) :: Line
character(len=80) :: frmt

Inc = 6
do iHarm=1,nDim,Inc
  Jnc = min(Inc,nDim-iHarm+1)
  write(frmt,'(A,I3,A)') '(5X,A10,1x,',Jnc,'I10)'
  write(u6,frmt) ' ',(i,i=iHarm,iHarm+Jnc-1)
  write(u6,*)

  write(frmt,'(A,I3,A)') '(A12,1x,',Jnc,'F10.2)'
  Line = ' '
  write(Line,frmt) 'Freq.',(EVal(i),i=iHarm,iHarm+Jnc-1)
  do i=1,120
    if (Line(i:i) == '-') Line(i:i) = 'i'
  end do
  write(u6,'(5X,A)') Line
  write(u6,*)

  write(u6,*)
end do

return

end subroutine GFPrnt_i

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Anders Bernhardsson                              *
!***********************************************************************

subroutine Drvetc(nGrad)
!***********************************************************************
!                                                                      *
! Object: driver for computation of gradients of one-electron matrices.*
!                                                                      *
!             Written by Anders Bernhardsson for electric field        *
!             Gradients                                                *
!             October  97                                              *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Basis_Info, only: dbsc, nBas, nCnttp
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nGrad
integer(kind=iwp) :: iCar, iCnt, iCnttp, idCar, idcnt, idum, iIrrep, iopt, irc, isym, loper, nDens
real(kind=wp) :: Ccoor(3)
character(len=8) :: Lbl
real(kind=wp), allocatable :: D0(:), EG(:), Temp(:)
integer(kind=iwp), external :: irrfnc
external :: ElGrd, ElGrddot, ElMem

Ccoor(:) = Zero

nDens = 0
do iIrrep=0,nIrrep-1
  nDens = nDens+nTri_Elem(nBas(iIrrep))
end do

call mma_Allocate(D0,nDens,Label='D0')
call Get_D1ao_Var(D0,nDens)

call mma_allocate(EG,3*nGrad,Label='EG')
call Dot1El2(ElGrddot,ElMem,EG,3*nGrad,.true.,CCoor,D0,1)
call mma_deallocate(D0)

EG(:) = -EG(:)

call mma_allocate(Temp,3*nGrad,Label='Temp')
Temp(:) = Zero

call Drvel1(Temp)

EG(:) = EG(:)+Temp(:)

Lbl = 'NUCELGR'
idum = 1
iopt = 128
irc = 3*nGrad
call dWrMCk(irc,iopt,LBL,idum,Temp,idum)
if (irc /= 0) call SysAbendMsg('drvect','error during write in dwrmck',' ')

idum = 1
iopt = 128
irc = 3*nGrad
Lbl = 'DOTELGR'
call dWrMCk(irc,iopt,LBL,idum,EG,idum)
if (irc /= 0) call SysAbendMsg('drvect','error during write in dwrmck',' ')
call mma_deallocate(EG)
call mma_deallocate(Temp)

! needed in RASSI
loper = 0
do iCar=1,3

  isym = irrfnc(2**(icar-1)) ! nropr(ichbas(1+iCar))
  write(Lbl,'(a,i2)') 'ELEC ',iCar
  idcnt = 0
  do iCnttp=1,nCnttp
    do iCnt=1,dbsc(iCnttp)%nCntr
      idcnt = idcnt+1
      do idCar=1,3
        call Cnt1El2(ELGRD,ELMEM,Lbl,idcnt,idcar,loper,One,.true.,lbl,0,isym,icar,1)
      end do
    end do
  end do

end do

return

end subroutine Drvetc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!               1995, Martin Schuetz                                   *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine AlloK2()
!***********************************************************************
!                                                                      *
!  Object: Allocate space for K2 entities.                             *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, Sweden. November '92                 *
!             Martin Schuetz, Dept. of Theoretical Chemistry,          *
!             University of Lund, Sweden. Jun '95                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem, nTri_Elem1, nTri3_Elem1
use k2_arrays, only: DoGrad_, MaxDe, nDeDe
use iSD_data, only: iSD
use Basis_Info, only: Shells
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use k2_structure, only: Allocate_k2data, Allocate_k2data_in, IndK2, k2_Processed, k2data, ZZZ_i, ZZZ_r
use stdalloc, only: mma_allocate
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: iAng, iAO, iBas, iCmp, iDeSiz, iIrrep, ijCmp, ijS, ik2, iPrim, iS, iShell, iShll, iSMLbl, jAng, jAO, jBas, &
                     jCmp, jPrim, jS, jShell, jShll, nData, nHm, nIndK2, nk2_integer, nk2_real, nSkal, nSO, nZeta
integer(kind=iwp), parameter :: nr_of_Densities = 1 ! Hardwired option
integer(kind=iwp), external :: MemSO1

#ifdef _DEBUGPRINT_
if (allocated(k2Data) .and. k2_processed) then
  write(u6,*) 'Enter Allok2, k2_Status=Processed'
else if (allocated(k2Data)) then
  write(u6,*) 'Enter Allok2, k2_Status=Active'
else
  write(u6,*) 'Enter Allok2, k2_Status=InActive'
end if
#endif
if (allocated(k2Data) .or. k2_processed) return

call Nr_Shells(nSkal)

ik2 = 0
nk2_real = 0
nk2_integer = 0
do iS=1,nSkal
  iShll = iSD(0,iS)
  if (Shells(iShll)%Aux .and. (iS /= nSkal)) cycle
  iPrim = iSD(5,iS)
  iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  do jS=1,iS
    jShll = iSD(0,jS)
    if (Shells(iShll)%Aux .and. (.not. Shells(jShll)%Aux)) cycle
    if (Shells(jShll)%Aux .and. (jS == nSkal)) cycle
    jPrim = iSD(5,jS)
    jAng = iSD(1,jS)
    jCmp = iSD(2,jS)

    nZeta = iPrim*jPrim
    ijCmp = 0
    if (DoGrad_) ijCmp = nTri_Elem1(iAng)*nTri_Elem1(jAng)
    nHm = iCmp*jCmp*(nTri3_Elem1(iAng+jAng)-nTri3_Elem1(max(iAng,jAng)-1))

    ik2 = ik2+1

    nData = nZeta*(10+ijCmp*2)+nHm*nIrrep
    nk2_real = nk2_real+nData*nIrrep
    nk2_integer = nk2_integer+(nZeta+1)*nIrrep

  end do
end do

call mma_allocate(ZZZ_r,nk2_real,Label='ZZZ_r')
call mma_allocate(ZZZ_i,nk2_integer,Label='ZZZ_i')
call Allocate_k2Data(nIrrep,ik2)

! determine memory size for K2 entities
! for this, run dummy K2 loop...
ik2 = 0
nDeDe = 0
MaxDe = 0

nIndk2 = nTri_Elem(S%nShlls)
call mma_allocate(Indk2,3,nIndk2,Label='Indk2')
Indk2(:,:) = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Double loop over shells. These loops decide the integral type

do iS=1,nSkal
  iShll = iSD(0,iS)
  if (Shells(iShll)%Aux .and. (iS /= nSkal)) cycle
  iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  iShell = iSD(11,iS)

  do jS=1,iS
    jShll = iSD(0,jS)
    if (Shells(iShll)%Aux .and. (.not. Shells(jShll)%Aux)) cycle
    if (Shells(jShll)%Aux .and. (jS == nSkal)) cycle
    jAng = iSD(1,jS)
    jCmp = iSD(2,jS)
    jBas = iSD(3,jS)
    jPrim = iSD(5,jS)
    jAO = iSD(7,jS)
    jShell = iSD(11,jS)

    if (nIrrep == 1) then
      iDeSiz = 1+iPrim*jPrim+iCmp*jCmp
    else
      iDeSiz = 1+iPrim*jPrim+(iBas*jBas+1)*iCmp*jCmp
    end if

    MaxDe = max(MaxDe,iDeSiz)
    iSmLbl = 1
    nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
    if (nSO > 0) nDeDe = nDeDe+nr_of_Densities*iDeSiz*nIrrep

    nZeta = iPrim*jPrim
    ijCmp = 0
    if (DoGrad_) ijCmp = nTri_Elem1(iAng)*nTri_Elem1(jAng)
    nHm = iCmp*jCmp*(nTri3_Elem1(iAng+jAng)-nTri3_Elem1(max(iAng,jAng)-1))

    ijS = iTri(iShell,jShell)
    ik2 = ik2+1
    Indk2(3,ijS) = ik2
    do iIrrep=1,nIrrep
      call Allocate_k2data_in(k2data(iIrrep,ik2),nZeta,ijCmp,nHm)
    end do

  end do
end do

return

end subroutine AlloK2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NXTIJ(       I,       J,      NI,      NJ,    IJSM,
     &                    NONEW)
*
* An ordered pair (I,J) is given ,I.LE.NI,J.LE.NJ
*
* Find next pair, if IJSM .ne. 0 ,I .ge. J
*
      NONEW = 0
  100 CONTINUE
      IF(I.LT.NI) THEN
        I = I + 1
      ELSE
        IF(J.LT.NJ) THEN
          I = 1
          J = J+1
        ELSE
          NONEW = 1
          GOTO 101
        END IF
      END IF
      IF(IJSM.NE.0.AND.I.LT.J) GOTO 100
  101 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' next (i,j) pair ', I,J
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE RSSBCB2(    IASM,    IATP,      IBSM,    IBTP,
     &                        JASM,    JATP,    JBSM,    JBTP,
     &                       NGAS,    IAOC,    IBOC,    JAOC,    JBOC,
     &                       NAEL,    NBEL,  IJAGRP,  IJBGRP,      SB,
     &                         CB,   JDOH2,   ADSXA,    STSTSX,
*
     &                     DXSTST,  STSTDX,  SXDXSX,  NOBPTS,  IOBPTS,
     &                    MXPNGAS,   ITSOB,    MAXI,    MAXK,    SSCR,
     &                       CSCR,      I1,    XI1S,      I2,    XI2S,
     &                       XINT,      C2,   NSMOB,   NSMST,   NSMSX,
     &                      NSMDX,     NIA,     NIB,     NJA,     NJB,
*
     &                     MXPOBS,     IDC,         CJRES,
     &                      SIRES,      I3,    XI3S,      I4,    XI4S,
     &                     MXSXBL,  MXSXST,   MOCAA,
     &                      IPRNT,   IHAPR,
     &                       SCLFAC, IUSE_PH,  IPHGAS,
*
     &                   I_RES_AB,
     &                     XINT2)
*
* SUBROUTINE RSSBCB2 --> 82
*
*
* Contributions to sigma block (iasm iatp, ibsm ibtp ) from
* C block (jasm jatp , jbsm, jbtp)
*
* =====
* Input
* =====
*
* IASM,IATP : Symmetry and type of alpha strings in sigma
* IBSM,IBTP : Symmetry and type of beta  strings in sigma
* JASM,JATP : Symmetry and type of alpha strings in C
* JBSM,JBTP : Symmetry and type of beta  strings in C
* NGAS      : Number of active spaces in calculation
* IAOC,IBOC : Number of electrons in each AS for sigma supergroups
* JAOC,JBOC : Number of electrons in each AS for C     supergroups
* NAEL : Number of alpha electrons
* NBEL : Number of  beta electrons
* IJAGRP    : IA and JA belongs to this group of strings
* IJBGRP    : IB and JB belongs to this group of strings
* CB : Input c block
* IDOH2 : = 0 => no two electron operator
* IDOH2 : = 1 =>    two electron operator
* ADASX : sym of a+, a => sym of a+a
* ADSXA : sym of a+, a+a => sym of a
* SXSTST : Sym of sx,!st> => sym of sx !st>
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
*          is nonvanishing by symmetry
* DXSTST : Sym of dx,!st> => sym of dx !st>
* STSTDX : Sym of !st>,dx!st'> => sym of dx so <st!dx!st'>
*          is nonvanishing by symmetry
* NTSOB  : Number of orbitals per type and symmetry
* IBTSOB : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* MAXI   : Largest Number of ' spectator strings 'treated simultaneously
* MAXK   : Largest number of inner resolution strings treated at simult.
*
*
* IHAPR : .ne. 0 implies thatt the exact Hamiltonian shoulf not be uses
* In the case IPTSPC and JPTSPC defined the perturbation spaces
* a nonvanishing perturbation is allowed inside each subspace.
* The actual type of approximate Hamiltonian in each subspace is defined by
* IHFORM
* NNSEL2E : Only selected 2e terms will be included
* ISEL2E : orbital spaces in which 2e terms are included
*          (Currently : all indices identical )
*
* ======
* Output
* ======
* SB : fresh sigma block
*
* =======
* Scratch
* =======
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* C2 : Must hold largest STT block of sigma or C
*
* XINT : Scratch space for integrals.
*
* Jeppe Olsen , Winter of 1991
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "timers.fh"
      INTEGER  ADSXA(*),STSTSX(*),DXSTST(*),STSTDX(*),SXDXSX(*)
*. Output
      DIMENSION CB(*),SB(*)
*. Scratch
      DIMENSION SSCR(*),CSCR(*),I1(*),XI1S(*),I2(*),XI2S(*)
      DIMENSION I3(*),XI3S(*),I4(*),XI4S(*)
      DIMENSION C2(*)
      DIMENSION CJRES(*),SIRES(*)
      DIMENSION IBLOCK(8)
      DIMENSION IPHGAS(*)
      DIMENSION XINT(*),XINT2(*)

      DIMENSION ITSOB(*),NOBPTS(*),IOBPTS(*)
      DIMENSION IAOC(*),JAOC(*),IBOC(*),JBOC(*)
*. For H(apr)
*
      NTEST = 00
      NTEST = MAX(NTEST,IPRNT)
*
      IF(NTEST.GE.200) THEN
        WRITE(6,*) ' ==============================='
        WRITE(6,*) ' RSSBCB2 :  C block (transposed)'
        WRITE(6,*) ' ================================'
        CALL WRTMAT(CB,NJB,NJA,NJB,NJA)
        WRITE(6,*) ' ======================================='
        WRITE(6,*) ' RSSBCB2 : Initial  S block(transposed) '
        WRITE(6,*) ' ======================================='
        CALL WRTMAT(SB,NIA,NIB,NIA,NIB)
        WRITE(6,*) ' Overall scalefactor ',SCLFAC
        WRITE(6,*) ' IHAPR,JDOH2 = ', IHAPR,JDOH2
        WRITE(6,*) ' IUSE_PH,I_RES_AB = ', IUSE_PH,I_RES_AB
      END IF
*
      IF(NTEST.GE.500) THEN
        WRITE(6,*) ' IAOC and IBOC '
        CALL IWRTMA(IAOC,1,NGAS,1,NGAS)
        CALL IWRTMA(IBOC,1,NGAS,1,NGAS)
        WRITE(6,*) ' JAOC and JBOC  : '
        CALL IWRTMA(JAOC,1,NGAS,1,NGAS)
        CALL IWRTMA(JBOC,1,NGAS,1,NGAS)
        WRITE(6,*) ' IASM IATP JASM JATP ', IASM,IATP,JASM,JATP
        WRITE(6,*) ' IBSM IBTP JBSM JBTP ', IBSM,IBTP,JBSM,JBTP
        WRITE(6,*) ' NAEL NBEL ', NAEL, NBEL
      END IF
* Should the corresponding Hamiltonian matrix block be
* calculated exactly or approximately
c      IF(IHAPR.NE.0) THEN
c        CALL HMATAPR(IASM,IATP,IBSM,IBTP,JASM,JATP,JBSM,JBTP,
c     &               IPTSPC,JPTSPC,IJOP,IJOP,IIF,JDOH2,IDOH2,
c     &               IMZERO,IDIAG)
c        IF(NTEST.GE. 20)
c     &  WRITE(6,*) ' RSSBCBN : ', NNSEL2E, ISEL2E(1)
c        NSEL2E = NNSEL2E
c        IF(IMZERO.NE.0) GOTO 9999
c      ELSE
*. Operator specified by input
        IDOH2 = JDOH2
        IDIAG = 0
c      END IF
      IF(NTEST.GE. 20)
     &WRITE(6,*) ' IHAPR, IDIAG IDOH2 ' , IHAPR,IDIAG, IDOH2
*
*
      IF(IDC.EQ.2.AND.IATP.EQ.IBTP.AND.IASM.EQ.IBSM .AND.
     &   I_RES_AB.EQ.0.AND.JASM.EQ.JBSM.AND.JATP.EQ.JBTP) THEN
*. Diagonal sigma block, use alpha-beta symmetry to reduce computations.
        IUSEAB = 1
      ELSE
        IUSEAB = 0
      END IF
*
      IF(IDIAG.EQ.0) THEN
*
* Calculate block exactly
*
      IF(I_RES_AB.NE.1.AND.IUSEAB.EQ.0.
     &   AND.IATP.EQ.JATP.AND.JASM.EQ.IASM) THEN
*
* =============================
* Sigma beta beta contribution
* =============================
*
* Sigma aa(IA,IB) = sum(i.gt.k,j.gt.l)<IB!Eb(ij)Eb(kl)!JB>
*                 * ((ij!kl)-(il!kj)) C(IA,JB)
*                 + sum(ij) <IB!Eb(ij)!JB> H(ij) C(IA,JB)
*.One electron part
          CALL TRPMT3(SB,NIB,NIA,C2)
          CALL COPVEC(C2,SB,NIA*NIB)
          CALL TRPMT3(CB,NJB,NJA,C2)
          CALL COPVEC(C2,CB,NJA*NJB)

        IF(NBEL.GE.0) THEN
           IF(NTEST.GE.500) THEN
             WRITE(6,*) ' SB before RSBB1E'
             call wrtmat(sb,nia,nib,nia,nib)
           END IF
          IF(NTEST.GE.101)
     &    WRITE(6,*) ' I am going to call RSBB1E'
          CALL TIMING(CPU0,CPU,WALL0,WALL)
          CALL RSBB1E_LUCIA(   IBSM,   IBTP,   JBSM,   JBTP, IJBGRP,
     &                          NIA,   NGAS,   IBOC,   JBOC,     SB,
     &                           CB,  ADSXA, STSTSX, NOBPTS,   MAXI,
     &                         MAXK,   SSCR,   CSCR,     I1,   XI1S,
     &                           I2,   XI2S,   XINT,  NSMOB,  NSMST,
*
     &                        NSMSX,  MOCAA, MXSXST,  MOCAA, SCLFAC,
     &                      IUSE_PH, IPHGAS,  NTEST)
          CALL TIMING(CPU1,CPU,WALL1,WALL)
          TSIGMA(1)=TSIGMA(1)+(WALL1-WALL0)
*
* CALL RSBB1E_LUCIA --> 33
*
           IF(NTEST.GE.500) THEN
             WRITE(6,*) ' SB after RSBB1E'
             call wrtmat(sb,nib,nia,nib,nia)
           END IF
           IF(NTEST.GE.100) THEN
             WRITE(6,*) ' first element of SB after RSBB1E',
     &       SB(1)
           END IF

        END IF
        IF(IDOH2.NE.0.AND.NBEL.GE.0) THEN
*. Two electron part
          IF(NTEST.GE.101)
     &    WRITE(6,*) ' I am going to call RSBB2A'
          CALL TIMING(CPU0,CPU,WALL0,WALL)
          CALL RSBB2A_LUCIA(   IBSM,   IBTP,   JBSM,   JBTP, IJBGRP,
     &                          NIA,   NIB,    NGAS,   IBOC,   JBOC,
     &                           SB,     CB,  ADSXA,  STSTDX,
     &                       SXDXSX, NOBPTS,
     &                         MAXI,   MAXK,   SSCR,   CSCR,     I1,
*
     &                         XI1S,    XINT,  NSMOB,
     &                        NSMST,    NSMDX,
     &                         MXSXST, MXSXBL,  MOCAA, SCLFAC,
     &                        NTEST,   IPHGAS)
          CALL TIMING(CPU1,CPU,WALL1,WALL)
          TSIGMA(2)=TSIGMA(2)+(WALL1-WALL0)
*
*
* CALL RSBB2A_LUCIA --> 46
*
           IF(NTEST.GE.500) THEN
             WRITE(6,*) ' SB after RSBB2a'
             call wrtmat(sb,nib,nia,nib,nia)
           END IF
           IF(NTEST.GE.100) THEN
             WRITE(6,*) ' first element of SB after RSBB1E',
     &       SB(1)
           END IF
        END IF
        CALL TRPMT3(SB,NIA,NIB,C2)
        CALL COPVEC(C2,SB,NIA*NIB)
        CALL TRPMT3(CB,NJA,NJB,C2)
        CALL COPVEC(C2,CB,NJA*NJB)
      END IF
*
* =============================
* Sigma alpha beta contribution
* =============================
*
      IF(IDOH2.NE.0.AND.NAEL.GE.0.AND.NBEL.GE.0) THEN
        IF(NTEST.GE.101)
     &  WRITE(6,*) ' I am going to call RSBB2B'
        IIITRNS = 1
        IF(IIITRNS.EQ.1) THEN
*. Call advice routine
C     ADVICE_SIGMA(IAOCC,IBOCC,JAOCC,JBOCC,ITERM,LADVICE)
           CALL ADVICE_SIGMA(   IAOC,   IBOC,   JAOC,   JBOC, LADVICE)
*. LADVICE = 2 => implies transpose
           IF(LADVICE.EQ.2) THEN
             JJJTRNS = 1
           ELSE
             JJJTRNS = 0
           END IF
        END IF
*
C       WRITE(6,*) ' IUSE_PA = ', IUSE_PA
*
        IF (JJJTRNS.EQ.0) THEN
c          IF( IUSE_PA.EQ.0 ) THEN
          CALL TIMING(CPU0,CPU,WALL0,WALL)
          CALL RSBB2BN_LUCIA(   IASM,   IATP,   IBSM,   IBTP,    NIA,
     &                           NIB,   JASM,   JATP,   JBSM,   JBTP,
     &                           NJA,    NJB, IJAGRP, IJBGRP,   NGAS,
     &                          IAOC,   IBOC,   JAOC,   JBOC,     SB,
     &                            CB,  ADSXA, STSTSX,MXPNGAS, NOBPTS,
*
     &                          MAXK,   SSCR,   CSCR,     I1,   XI1S,
     &                            I2,   XI2S,     I3,   XI3S,     I4,
     &                          XI4S,   XINT,  NSMOB,  NSMST,  NSMSX,
     &                         NSMDX, MXPOBS, IUSEAB,  CJRES,  SIRES,
     &                        SCLFAC,  NTEST,      0,    [0],IUSE_PH,
*
     &                        IPHGAS,  XINT2)
          CALL TIMING(CPU1,CPU,WALL1,WALL)
          TSIGMA(3)=TSIGMA(3)+(WALL1-WALL0)
*
* CALL RSBB2BN_LUCIA --> 52
*
c          ELSE IF ( IUSE_PA.EQ.1 ) THEN
cC         WRITE(6,*) ' RSBB2BVN will be called '
c          CALL RSBB2BVN(IASM,IATP,IBSM,IBTP,NIA,NIB,
c     &         JASM,JATP,JBSM,JBTP,NJA,NJB,
c     &         IJAGRP,IJBGRP,NGAS,IAOC,IBOC,JAOC,JBOC,
c     &         SB,CB,ADSXA,STSTSX,MXPNGAS,
c     &         NOBPTS,MAXK,
c     &         SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,
c     &         XINT,NSMOB,NSMST,NSMSX,NSMDX,MXPOBS,
c     &         IUSEAB,CJRES,SIRES,SCLFAC,NTEST,0,0,IUSE_PH,IPHGAS,
c     &         CJPA,SIPA)
c          END IF
*
         ELSE IF ( JJJTRNS.EQ.1) THEN
*. well lets give the transpose routine some more practice : Transpose back
          CALL TRPMT3(SB,NIB,NIA,C2)
          CALL COPVEC(C2,SB,NIA*NIB)
*
          CALL TRPMT3(CB,NJB,NJA,C2)
          CALL COPVEC(C2,CB,NJA*NJB)
C         WRITE(6,*) ' RSSBCB2 : Transpose path choosen'
*
c          IF(IUSE_PA.EQ.0) THEN
*. No division into active/passive
          CALL TIMING(CPU0,CPU,WALL0,WALL)
          CALL RSBB2BN_LUCIA(   IBSM,   IBTP,   IASM,   IATP,    NIB,
     &                           NIA,   JBSM,   JBTP,   JASM,   JATP,
     &                           NJB,    NJA, IJBGRP, IJAGRP,   NGAS,
     &                          IBOC,   IAOC,   JBOC,   JAOC,     SB,
     &                            CB,  ADSXA, STSTSX,MXPNGAS, NOBPTS,
*
     &                          MAXK,   SSCR,   CSCR,     I1,   XI1S,
     &                            I2,   XI2S,     I3,   XI3S,     I4,
     &                          XI4S,   XINT,  NSMOB,  NSMST,  NSMSX,
     &                         NSMDX, MXPOBS, IUSEAB,  CJRES,  SIRES,
     &                        SCLFAC,  NTEST,      0,    [0],IUSE_PH,
*
     &                        IPHGAS,  XINT2)
          CALL TIMING(CPU1,CPU,WALL1,WALL)
          TSIGMA(3)=TSIGMA(3)+(WALL1-WALL0)
*
* CALL RSBB2BN_LUCIA --> 52
*
c          ELSE
c*. Divide into active/passive
c          CALL RSBB2BVN(IBSM,IBTP,IASM,IATP,NIB,NIA,
c     &         JBSM,JBTP,JASM,JATP,NJB,NJA,
c     &         IJBGRP,IJAGRP,NGAS,IBOC,IAOC,JBOC,JAOC,
c     &         SB,CB,ADSXA,STSTSX,MXPNGAS,
c     &         NOBPTS,MAXK,
c     &         SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,
c     &         XINT,NSMOB,NSMST,NSMSX,NSMDX,MXPOBS,
c     &         IUSEAB,CJRES,SIRES,SCLFAC,NTEST,0,0,IUSE_PH,IPHGAS,
c     &         CJPA,SIPA)
c           END IF

*. Transpose ( To compensate later transposition )
          CALL TRPMT3(SB,NIA,NIB,C2)
          CALL COPVEC(C2,SB,NIA*NIB)
          CALL TRPMT3(CB,NJA,NJB,C2)
          CALL COPVEC(C2,CB,NJA*NJB)
        END IF
           IF(NTEST.GE.101) THEN
             WRITE(6,*) ' SB after RSBB2B, first element '
             call wrtmat(sb,1,1    ,nia,nib)
           END IF
           IF(NTEST.GE.500) THEN
             WRITE(6,*) ' SB after RSBB2b'
             call wrtmat(sb,nia,nib,nia,nib)
           END IF
      END IF
*
* =============================
* Sigma alpha alpha contribution
* =============================
*
      IF(I_RES_AB.NE.-1.AND.
     &   NAEL.GE.0.AND.IBTP.EQ.JBTP.AND.IBSM.EQ.JBSM) THEN
*
* alpha single excitation
*
        IF(NTEST.GE.101)
     &  WRITE(6,*) ' I am going to call RSBB1E (last time )'
        CALL TIMING(CPU0,CPU,WALL0,WALL)
        CALL RSBB1E_LUCIA(    IASM,    IATP,    JASM,    JATP,  IJAGRP,
     &                         NIB,    NGAS,    IAOC,    JAOC,      SB,
     &                          CB,   ADSXA,  STSTSX,  NOBPTS,    MAXI,
     &                        MAXK,    SSCR,    CSCR,      I1,    XI1S,
     &                          I2,    XI2S,    XINT,   NSMOB,   NSMST,
*
     &                       NSMSX,   MOCAA,  MXSXST,   MOCAA,  SCLFAC,
     &                     IUSE_PH,  IPHGAS,   NTEST)
        CALL TIMING(CPU1,CPU,WALL1,WALL)
        TSIGMA(1)=TSIGMA(1)+(WALL1-WALL0)
*
* CALL RSBB1E_LUCIA --> 33
*
           IF(NTEST.GE.101) THEN
             WRITE(6,*) ' SB transposed after RSBB1, first element '
             call wrtmat(sb,1,1    ,nia,nib)
           END IF
           IF(NTEST.GE.500) THEN
             WRITE(6,*) ' SB transposed  after RSBB1E'
             call wrtmat(SB,nib,nia,nib,nia)
           END IF
*
* alpha double excitation
*
        IF(IDOH2.NE.0.AND.NAEL.GE.0) THEN
          IF(NTEST.GE.101)
     &    WRITE(6,*) ' I am going to call RSBB2A (last time )'
          CALL TIMING(CPU0,CPU,WALL0,WALL)
          CALL RSBB2A_LUCIA(   IASM,   IATP,   JASM,   JATP, IJAGRP,
     &                          NIB,   NIA,    NGAS,   IAOC,   JAOC,
     &                           SB,     CB,  ADSXA,  STSTDX,
     &                       SXDXSX, NOBPTS,
     &                         MAXI,   MAXK,   SSCR,   CSCR,     I1,
*
     &                         XI1S,       XINT,  NSMOB,
     &                        NSMST,   NSMDX,
     &                         MXSXST, MXSXBL,  MOCAA, SCLFAC,
     &                        NTEST,   IPHGAS)
          CALL TIMING(CPU1,CPU,WALL1,WALL)
          TSIGMA(2)=TSIGMA(2)+(WALL1-WALL0)
*
*
* CALL RSBB2A_LUCIA --> 46
*
        END IF
*
           IF(NTEST.GE.101) THEN
             WRITE(6,*) ' SB transposed after RSBB2A, first element '
             call wrtmat(sb,1,1    ,nia,nib)
           END IF
        IF(NTEST.GE.500) THEN
          WRITE(6,*) ' SB after RSBB2A'
          call wrtmat(sb,nia,nib,nia,nib)
        END IF
      END IF
*
      ELSE IF (IDIAG.EQ.1) THEN
*
*. Diagonal approxiation (IDIAG = 1)
*  or complete orbital conserving part of Ham (IH_OCC_CONS = 1)
*
       IBLOCK(1) = IATP
       IBLOCK(2) = IBTP
       IBLOCK(3) = IASM
       IBLOCK(4) = IBSM
       IBLOCK(5) = 1
       IBLOCK(6) = 1
       IF(IDOH2.EQ.0) THEN
         I12 = 1
       ELSE
         I12 = 2
       END IF
C?     WRITE(6,*) ' IDOH2, I12 ', IDOH2,I12
       ITASK = 2
       FACTOR = 0.0D0
*. Well, we are not using transposed matrices here so
       CALL TRPMT3(CB,NJB,NJA,C2)
       CALL COPVEC(C2,CB,NJA*NJB)

       IF(IATP.EQ.JATP.AND.IBTP.EQ.JBTP.AND.
     &    IASM.EQ.JASM.AND.IBSM.EQ.JBSM) THEN
C?       WRITE(6,*) ' DIATERM2_GAS will be called '
         CALL COPVEC(CB,C2,NJA*NJB)
*. Input is in det basis
         IIDC = 1
         CALL DIATERM2_GAS(  FACTOR,   ITASK,      C2,       1,  IBLOCK,
     &                            1,       0,     I12,    IIDC)
       ELSE
         ZERO = 0.0D0
         CALL SETVEC(C2,ZERO,NIA*NIB)
       END IF
*. Remaining occupation conserving operator
c       IF(IH_OCC_CONS.EQ.1) THEN
c         CALL HCONFDIA_BBM(NAEL,NBEL,IJAGRP,IJBGRP,
c     &        IASM,IATP,IAOC,NIA,IBSM,IBTP,IBOC,NIB,
c     &        JASM,JATP,JAOC,NJA,JBSM,JBTP,JBOC,NJB,XINT,CB,C2)
c       END IF

       IF(IUSEAB.EQ.0) THEN
         FACTOR = 1.0D0*SCLFAC
       ELSE
         FACTOR = 0.5D0*SCLFAC
       END IF
C           MAT_P_MATT(A,B,NR,NC,COEF)
       CALL MAT_P_MATT(SB,C2,NIB,NIA,FACTOR)
       CALL TRPMT3(CB,NJA,NJB,C2)
       CALL COPVEC(C2,CB,NJA*NJB)
      END IF
*
c 9999 CONTINUE
c      IF(IHAPR.NE.0) THEN
c*. Clean up
c        CALL HMATAPR(IASM,IATP,IBSM,IBTP,JASM,JATP,JBSM,JBTP,
c     &               IPTSPC,JPTSPC,IJOP,IJOP,IIF,JDOH2,IDOH2,
c     &               IMZERO,IDIAG)
c      END IF
*
      IF(NTEST.GE.200) THEN
        WRITE(6,*) ' ==================================='
        WRITE(6,*) ' RSSBCB : Final S block (transposed)'
        WRITE(6,*) ' ==================================='
        CALL WRTMAT(SB,NIB,NIA,NIB,NIA)
      END IF
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(DXSTST)
        CALL Unused_integer_array(IOBPTS)
        CALL Unused_integer_array(ITSOB)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Chunk(ip_ChoVec,LenVec,NumVec_,iChoVec,iSym,
     &                     ip_iMap,iVec_Global)
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "mafdecls.fh"
#endif
*
#ifdef _MOLCAS_MPP_
      If (Is_Real_Par()) Then
         Call GA_Sync()
         Call Cho_RI_SwapVecUnit(iSym)
*
*        Get the subrange and check that we are within range.
*
         J_s=iWork(ip_iMap+MyRank)
         If (J_s.gt.NumVec_) Go To 999
         J_e=iWork(ip_iMap+MyRank+1)-1
         J_e=Min(J_e,NumVec_)
         nJ=J_e-J_s+1
         If (nJ.gt.0) Then
            MuNu_s=1
            MuNu_e=LenVec
            Call GA_Access(ip_ChoVec,MuNu_s,MuNu_e,J_s,J_e,Index,ld)
C           Call RecPrt('Dbl_Mb(Index)',' ',Dbl_Mb(Index),LenVec,nJ)
            Call Cho_PutVec(DBL_MB(Index),LenVec,nJ,iChoVec+1,iSym)
            Call Cho_RI_SetInfVec_5(iVec_Global,iChoVec+1,J_s,J_e,iSym)
            Call GA_Release(ip_ChoVec,MuNu_s,MuNu_e,J_s,J_e)
            iChoVec = iChoVec + nJ
         End If
  999    Continue
         Call Cho_RI_SwapVecUnit(iSym)
      Else
         Call Cho_PutVec(Work(ip_ChoVec),LenVec,NumVec_,iChoVec+1,iSym)
         iChoVec = iChoVec + NumVec_
      End If
*
#else
      Call Cho_PutVec(Work(ip_ChoVec),LenVec,NumVec_,iChoVec+1,iSym)
      iChoVec = iChoVec + NumVec_
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(ip_iMap)
         Call Unused_integer(iVec_Global)
      End If
#endif
*
      Return
      End
#if defined (_MOLCAS_MPP_)
      SubRoutine Cho_RI_SetInfVec_5(iVec_Global,iVec_Local,J_s,J_e,iSym)
C
C     Set mapping from local to global vector index (needed in parallel
C     RI gradient code).
C
      Implicit None
      Integer iVec_Global, iVec_Local, J_s, J_e, iSym
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer kOff, iOff, nVec, iVec

      kOff = ip_InfVec-2+MaxVec*(InfVec_N2*(iSym-1)+4)+iVec_Local
      iOff = iVec_Global + J_s - 2
      nVec = J_e - J_s + 1
      Do iVec = 1,nVec
         iWork(kOff+iVec) = iOff + iVec
      End Do

      End
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CheckB2F(n,Full)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: check extraction blocked to full and back.
C
      Implicit None
      Integer n
      Real*8  Full(n,n)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Character*12 SecNam
      Parameter (SecNam='LDF_CheckB2F')

      Real*8 Tol
      Parameter (Tol=1.0d-14)

      Logical  BlockMatricesAreIdentical

      Logical  isSymmetric
      External isSymmetric

      Integer ip_Packed, l_Packed
      Integer ip_Packed2, l_Packed2
      Integer ip_Full2, l_Full2
      Integer u, v, ip0, uv, iCount
      Integer ip_BlocksFromFull, ip_BlocksFromPacked

      Integer i, j
      Integer iTri
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      ! Check dimension
      If (n.ne.nBas_Valence) Then
         Call WarningMessage(2,SecNam//': n != nBas_Valence')
         Call LDF_Quit(1)
      End If

      ! Check that Full is symmetric
      If (.not.isSymmetric(Full,n,1.0d-14)) Then
         Call WarningMessage(2,SecNam//': Full is not symmetric')
         Call LDF_Quit(1)
      End If

      ! Allocate extra Packed and Full matrices
      l_Packed=n*(n+1)/2
      Call GetMem('Packed','Allo','Real',ip_Packed,l_Packed)
      l_Packed2=l_Packed
      Call GetMem('Packed2','Allo','Real',ip_Packed2,l_Packed2)
      l_Full2=n**2
      Call GetMem('Full2','Allo','Real',ip_Full2,l_Full2)

      ! Allocate block matrices
      Call LDF_AllocateBlockMatrix('BfF',ip_BlocksFromFull)
      Call LDF_AllocateBlockMatrix('BfP',ip_BlocksFromPacked)

      ! Get packed matrix
      ip0=ip_Packed-1
      Do v=1,n
         Do u=v,n
            Work(ip0+iTri(u,v))=Full(u,v)
         End Do
      End Do

      ! Get extra Packed and Full matrices
      Call dCopy_(l_Packed,Work(ip_Packed),1,Work(ip_Packed2),1)
      Call dCopy_(l_Full2,Full,1,Work(ip_Full2),1)

      ! Get block matrix from Full and from Packed
      Call LDF_Full2Blocked(Full,.False.,ip_BlocksFromFull)
      Call LDF_Full2Blocked(Work(ip_Packed),.True.,ip_BlocksFromPacked)

      ! Check that block matrices are identical
      If (.not.BlockMatricesAreIdentical(ip_BlocksFromFull,
     &                                   ip_BlocksFromPacked,
     &                                   1.0d-14)) Then
         Call WarningMessage(2,SecNam//': Error in extraction')
         Call LDF_Quit(1)
      End If

      ! Extract Packed and Full matrices from blocked ones
      Call LDF_Blocked2Full(ip_BlocksFromFull,.True.,Work(ip_Packed2))
      Call LDF_Blocked2Full(ip_BlocksFromFull,.False.,Work(ip_Full2))

      ! Check that they are identical to input matrix
      iCount=0
      uv=0
      Do v=1,n
         Do u=1,n
            uv=uv+1
            If (abs(Work(ip_Full2-1+uv)-Full(u,v)).gt.Tol) Then
               iCount=iCount+1
            End If
         End Do
      End Do
      If (iCount.ne.0) Then
         Call WarningMessage(2,SecNam//': Error in Full extraction')
         Call LDF_Quit(1)
      End If
      iCount=0
      Do uv=1,l_Packed
         If (abs(Work(ip_Packed2-1+uv)-Work(ip_Packed-1+uv)).gt.Tol)
     &   Then
            iCount=iCount+1
         End If
      End Do
      If (iCount.ne.0) Then
         Call WarningMessage(2,SecNam//': Error in Packed extraction')
         Call LDF_Quit(1)
      End If

      ! Deallocate block matrices
      Call LDF_DeallocateBlockMatrix('BfF',ip_BlocksFromFull)
      Call LDF_DeallocateBlockMatrix('BfP',ip_BlocksFromPacked)

      ! Deallocate extra Packed and Full matrices
      Call GetMem('Full2','Free','Real',ip_Full2,l_Full2)
      Call GetMem('Packed2','Free','Real',ip_Packed2,l_Packed2)
      Call GetMem('Packed','Free','Real',ip_Packed,l_Packed)

      Write(6,'(/,A,A,/)')
     & SecNam,': Full2Blocked and Blocked2Full checked - all seems OK!'
      Call xFlush(6)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Logical Function BlockMatricesAreIdentical(ip_Block1,ip_Block2,
     &                                           Tol)
      Implicit None
      Integer ip_Block1
      Integer ip_Block2
      Real*8  Tol
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Integer iCount
      Integer AB
      Integer ip1, ip2
      Integer k, n

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      iCount=0
      Do AB=1,NumberOfAtomPairs
         ip1=iWork(ip_Block1-1+AB)
         ip2=iWork(ip_Block2-1+AB)
         n=LDF_nBas_Atom(AP_Atoms(1,AB))*LDF_nBas_Atom(AP_Atoms(2,AB))
         Do k=0,n-1
            If (abs(Work(ip1+k)-Work(ip2+k)).gt.Tol) Then
               iCount=iCount+1
            End If
         End Do
      End Do
      BlockMatricesAreIdentical=iCount.eq.0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SETMAXSHL(DIAG,DIASH,ISYSH,IRED)
!
! Purpose: set max. shell pair data for selection procedure.

use Cholesky, only: CHO_1CENTER, CHO_NO2CENTER, iAtomShl, iiBstR, iiBstRSh, IndRed, iSP2F, LuPri, nnBstRSh, nnShl, nSym
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: DIAG(*)
real(kind=wp), intent(out) :: DIASH(nnShl)
integer(kind=iwp), intent(out) :: ISYSH(nnShl)
integer(kind=iwp), intent(in) :: IRED
integer(kind=iwp) :: IAB, IAB1, IAB2, ISAB, ISHLA, ISHLAB, ISHLB, ISYMAB, JAB, JAB1, JAB2
character(len=*), parameter :: SECNAM = 'CHO_SETMAXSHL'

! Initialize the largest diagonal in each shell pair.
! ---------------------------------------------------

DIASH(:) = Zero
ISYSH(:) = 0

! Find largest diagonal in each shell pair. Loop only
! over those that are included in the reduced set at hand.
! --------------------------------------------------------

if (IRED == 1) then
  do ISYMAB=1,NSYM
    do ISHLAB=1,NNSHL
      IAB1 = IIBSTR(ISYMAB,IRED)+IIBSTRSH(ISYMAB,ISHLAB,IRED)+1
      IAB2 = IAB1+NNBSTRSH(ISYMAB,ISHLAB,IRED)-1
      do IAB=IAB1,IAB2
        DIASH(ISHLAB) = max(DIASH(ISHLAB),DIAG(IAB))
        if (DIASH(ISHLAB) == DIAG(IAB)) ISYSH(ISHLAB) = ISYMAB
      end do
    end do
  end do
else if ((IRED == 2) .or. (IRED == 3)) then
  do ISYMAB=1,NSYM
    do ISHLAB=1,NNSHL
      JAB1 = IIBSTR(ISYMAB,IRED)+IIBSTRSH(ISYMAB,ISHLAB,IRED)+1
      JAB2 = JAB1+NNBSTRSH(ISYMAB,ISHLAB,IRED)-1
      do JAB=JAB1,JAB2
        IAB = INDRED(JAB,IRED)
        DIASH(ISHLAB) = max(DIASH(ISHLAB),DIAG(IAB))
        if (DIASH(ISHLAB) == DIAG(IAB)) ISYSH(ISHLAB) = ISYMAB
      end do
    end do
  end do
else
  write(LUPRI,*) SECNAM,': unknown reduced set, IRED = ',IRED
  call CHO_QUIT('Unknown reduced set in '//SECNAM,104)
end if

! Exclude 2-center diagonals (if requested).
! The effect of this is that 2-center diagonals can never be
! qualified; they may still be included in the vectors, though.
! If CHO_NO2CENTER=T, the 2-center diagonals are removed from the
! initial diagonal and we need not worry here.
! ---------------------------------------------------------------

if (CHO_1CENTER .and. (.not. CHO_NO2CENTER)) then
  do ISAB=1,NNSHL
    ISHLAB = ISP2F(ISAB)
    call CHO_INVPCK(ISHLAB,ISHLA,ISHLB,.true.)
    if (IATOMSHL(ISHLA) /= IATOMSHL(ISHLB)) DIASH(ISAB) = Zero
  end do
end if

end subroutine CHO_SETMAXSHL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Bernd Artur Hess                                 *
************************************************************************
      SubRoutine VPInt(
#define _CALLING_
#include "int_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of  pV integrals          *
*                                                                      *
*     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
*             Chemie, University of Bonn, Germany, April 1993          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      External TNAI, Fake, XCff2D, XRys2D
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = ((ixyz+1)*(ixyz+2))/2
*
      iRout = 221
      iPrint = nPrint(iRout)
*
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In vpint: Alpha','(5D20.13)',Alpha,nAlpha,1)
         Call RecPrt(' In vpint: Beta','(5D20.13)',Beta,nBeta,1)
      End If
*
      nRys=nHer
*
      nip = 1
      ipB = nip
      nip = nip + nZeta
      ipS1 = nip
      nip = nip + nZeta*nElem(la)*nElem(lb+1)
      If (lb.gt.0) Then
         ipS2 = nip
         nip = nip + nZeta*nElem(la)*nElem(lb-1)
      Else
         ipS2=ipS1
      End If
      ipArr = nip
      mArr = nArr - (nip-1)/nZeta
      If (mArr.lt.0) Then
         Call WarningMessage(2,'VpInt: mArr<0!')
         Call Abend()
      End If
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
      call dcopy_(nZeta*nArr,[Zero],0,Array,1)
*     Compute contribution from a,b+1
*
      kRys = ((la+1)+lb+2)/2
*
      kIC=1
      kComp=1
      Call NAInt(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &           Array(ipS1),nZeta,nIC,nComp,la,lb+1,A,RB,kRys,
     &           Array(ipArr),mArr,CCoor,nOrdOp,lOper,iChO,
     &           iStabM,nStabM,
     &           PtChrg,nGrid,iAddPot)

      ipOff = ipB
      Do 100 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipOff),nAlpha)
         ipOff = ipOff + 1
100   Continue
*
*     Compute contribution from a,b-1
*
      If (lb.gt.0) Then
         kRys = ((la-1)+lb+2)/2
*
         Call NAInt(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &              Array(ipS2),nZeta,kIC,kComp,la,lb-1,A,RB,nRys,
     &              Array(ipArr),mArr,CCoor,nOrdOp,lOper,iChO,
     &              iStabM,nStabM,
     &              PtChrg,nGrid,iAddPot)
      End If
*
*     Assemble final integral from the derivative integrals
*
      If (iPrint.ge.99) Call RecPrt(' In vpint: Beta (expanded)',
     &                  '(5D20.13)',Array(ipB),nZeta,1)
*
      Call Util8(Array(ipB),nZeta,Final,la,lb,Array(ipS1),Array(ipS2))
*
      If (iPrint.ge.49) Then
         Do i=1,3
            Call RecPrt('VpInt: Final',' ',Final(1,1,1,i),nZeta,
     &                 nElem(la)*nElem(lb))
         End Do
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dv_drt_ci_new()

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, ipae, ipael, jml, jmr, jpad, jpadl, jpadlr, linelp, lpblock_dv
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: jptyl, jptyr, lpb

call external_space_plpmode_value_dv()

idisk_lp = idisk_array(2)
do lpb=1,lpblock_dv
  call read_lp()
  ipael = iml+1
  ipae = 1
  call get_jpty(jpadlr,jptyl,jptyr)
  call get_jp(jptyl,jml,jpadl,1)
  call get_jp(jptyr,jmr,jpad,1)
  !jmlr = Mul(jml,jmr)
  call gsd_determine_extarmode_paras(iml,imr,.false.)
  if (linelp <= 12) then
    call dv_ext_head_in_act()
  else
    call dv_ext_head_in_dbl()
  end if
end do

return

end subroutine dv_drt_ci_new

subroutine dv_ext_head_in_dbl()

use gugaci_global, only: iml, intind_ijka, ipae, ipael, jb_sys, jml, jmr, jpad, jpadl, jpadlr, jud, just, linelp, logic_dh, &
                         lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, nlg1, nlg2, norb_dz, &
                         norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dv, w0_sd, w0_sv, w0_td, w0_vv, w1_sd, w1_sv, &
                         w1_td, w1_tv
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ijk, imap_1, intpos, isma, iwal, iwar, iwdl, iwdr, jk, jmlr, lmd, lmi, lmij, lmj, lpok, lra, lrd, lri, lrj, &
                     lrk, mpl, ni
real(kind=wp) :: w0, w0sd1, w0sd11, w0sd12, w0sd14, w0sd16, w0sd2, w0sd4, w0sd5, w0sd8, w0sd9, w0sv2, w0td1, w0td2, w0td3, w0td4, &
                 w0td5, w1sd11, w1sd12, w1sd5, w1sd8, w1sd9, w1sv2, w1td2, w1td3, w1td4, w1tv
integer(kind=iwp), external :: iwalk_ad

logic_dh = .true.
isma = iml
lpok = jpadlr
jmlr = Mul(jml,jmr)
select case (lpok)
  case (1)
    !===================================================================
    ! ss(1)     act -b^l-
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call ss_drl_act_bl(23,lra)
      if (jb_sys > 0) then
        call ss_drl_act_bl_sgt0(23,lra)
      end if
    else
      call ss_arbl_act_bl(23,lra)
      if (jb_sys > 0) then
        call ss_arbl_act_bl_sgt0(23,lra)
        call ss_s_drl_act_bl_sgt0(23,lra)
      end if
    end if

  case (2)
    !===================================================================
    ! st(2)      act -b^l
    if ((linelp /= 15) .or. (nlg2 /= 2)) return
    lra = nlg1
    call st_arbl_act_bl(23,lra)
    if (jb_sys > 0) call st_arbl_act_bl_sgt0(23,lra)
    if (jml /= jmr) return
    call st_drl_act_bl(23,lra)
    if (jb_sys > 0) call st_drl_act_bl_sgt0(23,lra)

  case (3)
    !===================================================================
    ! ts(3)   act -b^l ............................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 /= 2) return
    call ts_arbl_act_bl(23,lra)
    if (jb_sys > 0) call ts_arbl_act_bl_sgt0(23,lra)

  case (4)
    !===================================================================
    ! stt(4) act-b^l ..............................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) return
    call stt_arbl_act_bl_sgt1(23,lra)

  case (5)
    !===================================================================
    ! tts(5) act-b^l ..............................................
    if ((linelp /= 15) .or. (nlg2 /= 2)) return
    lra = nlg1
    call tts_arbl_act_bl_sgt1(23,lra)
    call tts_drl_act_bl_sgt1(23,lra)

  case default ! (6)
    !===================================================================
    ! sd(6-1) a&r(02)-
    ! sd(6-2) c(22)a&(13)-
    ! sd(6-3) a&r(13)c'(22)-
    ! sd(6-4) a&r(23)c'(12)-
    ! sd(6-5) a&r(23)b&r(13)b^r(32)
    ! sd(6-6) a&r(13)b&r(23)b^r(32)
    ! sd(6-7) a&r(13)b&l(32)b^l(23)
    ! sd(6-8) a&r(23)b&l(32)b^l(13)
    ! sd(6-9) d&r&r(03)b^r(32)
    ! sd(6-10) d&r&l(12)b^l(23)
    ! sd(6-11) d&r&l(22)b^l(13)
    ! sd(6-12) d&r&l(33)b^l(02)
    ! sd(6-13) (22)d&r&l(33)b^l(13)
    ! sd(6-14) d&r&l(33)c"(22)b^l(13)
    ! sd(6-15) d&r&l(33)b^l(13)c'(22)
    ! sd(6-16) d&r&l(33)b^l(23)c'(12)
    if (linelp == 13) then
      if (jb_sys > 0) call sd_adb_act_c_ext_ar(23)
      do lri=norb_frz+1,norb_dz
        lmi = lsm_inn(lri)
        if (lmi /= jmlr) cycle
        w0sd1 = w0_sd(1)
        w0sd9 = w0_sd(9)
        w1sd9 = w1_sd(9)
        w0sd12 = w0_sd(12)
        w1sd12 = w1_sd(12)
        ni = mod(norb_dz-lri,2)
        if (ni == 1) w0sd1 = -w0sd1
        if (ni == 1) w0sd9 = -w0sd9
        if (ni == 1) w1sd9 = -w1sd9
        if (ni == 1) w0sd12 = -w0sd12
        if (ni == 1) w1sd12 = -w1sd12
        if ((jml == 1) .and. (lmi == jmr)) then
          iwdl = just(lri,lri)
          iwdr = jud(lri)
          do mpl=1,mhlp
            iwal = lpnew_lwei(mpl)
            iwar = lpnew_rwei(mpl)
            lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
          end do

          ! sd(6-1) a&r(02)-
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
          end do
          call ar_dv_ext_ar(26,isma,lri,lrj)   !ar_dv

          ! sd(6-12) d&r&l(33)b^l(02)
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd12
            vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd12
          end do
          do lrk=1,lri-1
            call drl_bl_ext_ar_new(23,lrk,lri)
          end do

          ! sd(6-9) d&r&r(03)b^r(32)
          do lrk=norb_frz+1,lri-1
            iwdl = just(lrk,lrk)
            iwdr = jud(lri)
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd9
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd9
            end do
            call drr_br_ext_ar(23,lrk,lri)
          end do
        end if
      end do

      do lri=norb_frz+1,norb_dz
        lmi = lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj = lsm_inn(lrj)
          lmij = Mul(lmi,lmj)
          if (lmij /= jml) cycle

          if (lmi == jmr) then
            iwdl = just(lri,lrj)
            iwdr = jud(lri)
            w0sd2 = w0_sd(2)
            w0sd11 = w0_sd(11)
            w1sd11 = w1_sd(11)
            w0sd14 = w0_sd(14)
            ni = mod(norb_dz-lrj,2)
            if (ni == 1) then
              w0sd2 = -w0sd2
              w0sd11 = -w0sd11
              w1sd11 = -w1sd11
              w0sd14 = -w0sd14
            end if
            ! sd(6-2) c(22)-a&r(13)-
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_dv_ext_ar(25,isma,lrj,lri) !ar_dv
            ! sd(6-11) d&r&l(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd11
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd11
            end do
            call drl_bl_ext_ar_new(23,lri,lrj)
            ! sd(6-14) (22)d&r&l(33)b^l(13)
            ! sd(6-14) d&r&l(33)c"(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd14
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lrj-1
              if (lrk == lri) cycle
              call drl_bl_ext_ar_new(23,lrk,lrj)
            end do
          end if
          ! sd(6-4) a&r(23)-c'(12)-
          w0sd4 = w0_sd(4)
          w0sd16 = w0_sd(16)
          ni = mod(norb_dz-lri,2)
          if (ni == 0) then
            w0sd4 = -w0sd4
            w0sd16 = -w0sd16
          end if
          if (lmj == jmr) then
            iwdl = just(lri,lrj)
            iwdr = jud(lrj)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd4
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_dv_ext_ar(28,isma,lri,lrj)   !ar_dv
            ! sd(6-16) d&r&l(33)b^l(23)c'(12)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd16
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(23,lrk,lri)
            end do
          end if
          ! sd(6-5) a&r(23)b&r(13)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle

            w0sd5 = w0_sd(5)
            w1sd5 = w1_sd(5)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0sd5 = -w0sd5
              w1sd5 = -w1sd5
            end if
            iwdl = just(lri,lrj)
            iwdr = jud(lrd)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd5
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd5
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos = intind_ijka(ijk)
            call ar_br_br_ext_ar_new(23,intpos,isma)
          end do
          ! sd(6-8) a&r(23)b&l(32)b^l(13)
          do lrd=lri+1,lrj-1
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdl = just(lri,lrj)
            iwdr = jud(lrd)
            w0sd8 = w0_sd(8)
            w1sd8 = w1_sd(8)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0sd8 = -w0sd8
              w1sd8 = -w1sd8
            end if
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd8
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd8
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            ijk = lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos = intind_ijka(ijk)
            call ar_bl_bl_ext_ar_new(23,intpos,isma,1)
          end do
        end do
      end do
    end if
    !===================================================================
    ! sd(6)    act -br-br-
    if (linelp == 20) then
      jk = nlg1
      call sd_ar_act_brbr(23,jk)
      if (jb_sys > 0) call sd_ar_act_brbr_sgt0(23,jk)
    end if
    ! sd(6)  act -bl-bl-
    if (linelp == 22) then
      jk = nlg1
      call sd_ar_act_blbl(23,jk)
      if (jb_sys > 0) call sd_ar_act_blbl_sgt0(23,jk)
    end if

  case (8)
    !===================================================================
    ! sdd(8) act-b^l -c'- -c"-..........................................
    if (linelp == 13) then
      lra = nlg1
      call sdd_drlbl_act_c_sgt0(23)
      call sdd_drrbr_act_c_sgt0(23)
      call sdd_abb_act_c_sgt0(23)
      call sdd_ar_act_c_sd_ext_sgt0(23)
    else
      lra = nlg1
      if (linelp == 20) call sdd_ar_act_brbr_sgt0(23,lra)
      if (linelp == 22) call sdd_ar_act_blbl_sgt0(23,lra)
    end if

  case (9)
    !===================================================================
    ! dds(9) act -c'- ..............................................
    if (linelp == 13) then
      lra = nlg1
      call dds_abb_act_c_sgt0(23)
    end if

  case (10)
    !===================================================================
    ! sv(10)     act -b^r-
    ! sv(10-1) ar(13)-br(23)-
    ! sv(10-2) ar(23)-br(13)-
    ! sv(10-3) drr(03)-
    if ((linelp /= 16) .or. (nlg2 /= 2)) return
    lra = nlg1
    if (jb_sys > 0) then
      call sv_arbr_act_br_sgt0(23,lra)
    end if
    do lri=norb_frz+1,norb_dz
      lmi = lsm_inn(lri)
      do lrj=lri,norb_dz
        lmj = lsm_inn(lrj)
        lmij = Mul(lmi,lmj)
        if (lmij /= jml) cycle
        w0sv2 = w0_sv(2)
        w1sv2 = w1_sv(2)
        ni = mod(lrj-lri,2)
        if (ni == 0) then
          w0sv2 = -w0sv2
          w1sv2 = -w1sv2
        end if
        !---------------------------------------------------------------
        iwdl = just(lri,lrj)
        iwdr = 0
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        if (lri /= lrj) then
          ! sv(10-2) ar(23)-br(13)-
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0sv2
            vplp_w1(mpl) = vplpnew_w1(mpl)*w1sv2
          end do
          ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos = intind_ijka(ijk)
          call ar_br_br_ext_ar_new(23,intpos,isma)
        else
          ! sv(10-3) drr(03)-
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0_sv(3)
            vplp_w1(mpl) = vplpnew_w1(mpl)*w1_sv(3)
          end do
          call drr_br_ext_ar(23,lri,lra)
        end if
      end do
    end do

  case (11)
    !===================================================================
    ! tt(11)   act -b^l
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call tt_drl_act_bl(23,lra)
    else
      call tt_arbl_act_bl(23,lra)
    end if

  case (12)
    !===================================================================
    ! tttt(12)   act -b^l
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call tttt_drl_act_bl_sgt1(23,lra)
    else
      call tttt_arbl_act_bl_sgt1(23,lra)
    end if

  case (13)
    !===================================================================
    ! td(13)                                  act -c'-
    ! td(13-1) (22)a&(23)
    ! td(13-1) a&(23)c'(22)
    ! td(13-2) a&(23)b&r(23)b^r(32)
    ! td(13-3) a&(23)b&l(32)b^l(23)
    ! td(13-4) d&r&l(22)b^l(23)
    ! td(13-5) (22)d&&l(33)b^l(23)
    ! td(13-5) d&rl(33)c"(22)b^l(23)
    ! td(13-5) d&rl(33)b^l(23)c'(22)
    if (linelp == 13) then
      do lri=norb_frz+1,norb_dz
        lmi = lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj = lsm_inn(lrj)
          lmij = Mul(lmi,lmj)
          if (lmij /= jml) cycle
          w0td1 = w0_td(1)
          w0td4 = w0_td(4)
          w1td4 = w1_td(4)
          w0td5 = w0_td(5)
          ni = mod(norb_dz-lrj,2)
          if (ni == 1) then
            w0td1 = -w0td1
            w0td4 = -w0td4
            w1td4 = -w1td4
            w0td5 = -w0td5
          end if
          iwdl = just(lri,lrj)
          !-------------------------------------------------------------
          ! td(13-1) (22)a&(23)
          if (lmi == jmr) then
            iwdr = jud(lri)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_dv_ext_ar(43,isma,lrj,lri)
            ! td(13-4) d&r&l(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td4
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1td4
            end do
            call drl_bl_ext_ar_new(23,lri,lrj)
            ! td(13-5) (22)d&rl(33)b^l(23)
            ! td(13-5) d&rl(33)c"(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td5
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lrj-1
              if (lrk == lri) cycle
              call drl_bl_ext_ar_new(23,lrk,lrj)
            end do
          end if
          !-------------------------------------------------------------
          ! td(13-1) a&(23)c'(22)
          if (lmj == jmr) then
            iwdr = jud(lrj)
            w0td1 = w0_td(1)
            w0td5 = w0_td(5)
            ni = mod(norb_dz-lri,2)
            if (ni == 0) then
              w0td1 = -w0td1
              w0td5 = -w0td5
            end if
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_dv_ext_ar(46,isma,lri,lrj) !ar_dv
            ! td(13-5) d&rl(33)b^l(23)c'(22)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td5
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(23,lrk,lri)
            end do
          end if
          !-------------------------------------------------------------
          ! td(13-2) a&(23)b&r(23)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdr = jud(lrd)
            ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos = intind_ijka(ijk)
            w0td2 = w0_td(2)
            w1td2 = w1_td(2)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0td2 = -w0td2
              w1td2 = -w1td2
            end if
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td2
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1td2
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_br_br_ext_ar_new(23,intpos,isma)
          end do
          !-------------------------------------------------------------
          ! td(13-3) a&(23)b&l(32)b^l(23)
          do lrd=lri+1,lrj-1
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdr = jud(lrd)
            w0td3 = w0_td(3)
            w1td3 = w1_td(3)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0td3 = -w0td3
              w1td3 = -w1td3
            end if
            ijk = lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos = intind_ijka(ijk)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td3
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1td3
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_bl_bl_ext_ar_new(23,intpos,isma,1)
          end do
          !-------------------------------------------------------------
        end do
      end do
    end if
    !===================================================================
    ! td(13) act -br-br-
    if (linelp == 20) then
      jk = nlg1
      call td_ar_act_brbr(23,jk)
    end if
    ! td(13)  act -bl-bl-
    if (linelp == 22) then
      jk = nlg1
      call td_ar_act_blbl(23,jk)
    end if

  case (15)
    !===================================================================
    ! ttdd(15)    act -c'-   -br-br- -bl-bl
    lra = nlg1
    if (linelp == 13) then
      call ttdd_drlbl_act_c_sgt1(23)
      call ttdd_abb_act_c_sgt1(23)             ! ????
      call ttdd_ar_act_c_ttdd_ext_sgt1(23)
    end if
    if (linelp == 20) then
      call ttdd_ar_act_brbr_sgt0(23,lra)
    end if
    if (linelp == 22) then
      call ttdd_ar_act_blbl_sgt0(23,lra)
    end if

  case (17)
    !===================================================================
    ! tv(17)    act -b^r-
    if ((linelp /= 16) .or. (nlg2 /= 2)) return
    lra = nlg1
    do lri=norb_frz+1,norb_dz-1
      lmi = lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj = lsm_inn(lrj)
        lmij = Mul(lmi,lmj)
        if (lmij /= jml) cycle

        w1tv = w1_tv
        ni = mod(lrj-lri,2)
        if (ni == 0) w1tv = -w1tv

        !---------------------------------------------------------------
        ! tv(17) ar(23)-br(23)-
        iwdl = just(lri,lrj)
        iwdr = 0
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1tv
        end do
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
        intpos = intind_ijka(ijk)
        call ar_br_br_ext_ar_new(23,intpos,isma)
      end do
    end do

  case (18)
    !===================================================================
    ! ttv(19) act -b^r- ................................................
    if ((linelp /= 16) .or. (nlg2 /= 2)) return
    lra = nlg1
    call ttv_arbr_act_c_sgt1(23,lra)

  case (19)
    !===================================================================
    ! dd(19) act -b^l- .................................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call dd_drl_act_bl(23,lra)
    else
      call dd_arbl_act_bl(23,lra)
    end if

  case (20)
    !===================================================================
    ! dddd(19) act -b^l- -br- ..........................................
    lra = nlg1
    if (linelp == 15) then
      if (nlg2 == 2) then
        call dddd_arbl_act_bl_sgt0(23,lra)
      else
        call dddd_drl_act_bl_sgt0(23,lra)
      end if
    end if

  case (21)
    !===================================================================
    ! dd1(21) act -b^l-  ...............................................
    if ((linelp /= 15) .or. (nlg2 /= 2)) return
    lra = nlg1
    call dd1_arbl_act_bl_sgt0(23,lra)

  case (22)
    !===================================================================
    ! d1d(21) act -b^l-  ...............................................
    lra = nlg1
    if ((linelp == 15) .and. (nlg2 == 2)) then
      call d1d_arbl_act_bl_sgt0(23,lra)
      call d1d_drl_act_bl_sgt0(23,lra)
    end if

  case (23)
    !===================================================================
    ! dv(23) act -c'-..................................................
    ! dv(23-1) ar(23)-
    ! dv(23-2) drl(33)-bl(23)-
    if (linelp == 13) then
      imap_1 = 0
      do lrd=norb_frz+1,norb_dz
        lmd = lsm_inn(lrd)
        if (lmd /= jml) cycle
        ni = mod(norb_dz-lrd,2)

        ! dv(23-1) ar(23)-
        w0 = w0_dv(1)
        if (ni == 1) w0 = -w0_dv(1)
        iwdl = jud(lrd)
        iwdr = 0
        imap_1 = imap_1+1
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0
        end do
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_dv_ext_ar(51,isma,lrd,0)   !ar_dv
        ! dv(23-2) drl(33)-bl(23)-
        w0 = w0_dv(2)
        if (ni == 1) w0 = -w0_dv(2)
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0
          vplp_w1(mpl) = Zero
        end do
        do lrk=1,lrd-1
          call drl_bl_ext_ar_new(23,lrk,lrd)
        end do
      end do
    end if
    !===================================================================
    ! dv(23) act -br-br-................................................
    if (linelp == 20) then
      jk = nlg1
      do lrd=norb_frz+1,norb_dz
        lmd = lsm_inn(lrd)
        if (lmd /= jml) cycle
        ni = mod(norb_dz-lrd,2)
        w0 = w0_dv(1)
        if (ni == 1) w0 = -w0_dv(1)
        !..............................................................
        ! dv(23-1) ar(23)-
        iwdl = jud(lrd)
        iwdr = 0
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0
          vplp_w1(mpl) = vplpnew_w1(mpl)*w0
        end do
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        ijk = lrd-norb_frz+jk
        intpos = intind_ijka(ijk)
        call ar_br_br_ext_ar_new(23,intpos,isma)
      end do
    end if
    ! dv(23) act -bl-bl-................................................
    if (linelp /= 22) return
    jk = nlg1
    do lrd=norb_frz+1,norb_dz
      lmd = lsm_inn(lrd)
      if (lmd /= jml) cycle
      ni = mod(norb_dz-lrd,2)
      w0 = w0_dv(1)
      if (ni == 1) w0 = -w0_dv(1)
      ! dv(23-1) ar(23)-
      iwdl = jud(lrd)
      iwdr = 0
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0
        vplp_w1(mpl) = vplpnew_w1(mpl)*w0
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      ijk = lrd-norb_frz+jk
      intpos = intind_ijka(ijk)
      call ar_bl_bl_ext_ar_new(23,intpos,isma,1)
    end do

  case (24)
    !===================================================================
    ! d1v(24) act -bl-bl -br-br- -c'- ..................................
    lra = nlg1
    if (linelp == 13) then
      call d1v_drl_bl_act_c_sgt0(23)    ! drl-bl- ar-
    end if
    if (linelp == 22) then
      call d1v_ar_act_blbl_sgt0(23,lra)
    end if
    if (linelp == 20) then
      call d1v_ar_act_brbr_sgt0(23,lra)
    end if

  case (25)
    !===================================================================
    ! vv(25) act -b^l- .................................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      iwdl = 0
      iwdr = 0
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0_vv
        vplp_w1(mpl) = Zero
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call drl_bl_sum_ar_new(23,0,0,lra)
      !do lrk=1,norb_dz
      !  call drl_bl_ext_ar_new(23,lrk,lra)
      !end do
    end if

  case (7,14,16,26)
end select

return

end subroutine dv_ext_head_in_dbl

subroutine dv_ext_head_in_act()

use gugaci_global, only: iml, linelp, logic_dh, nlg1, nlg2
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: intpos, isma, lri, lrj

logic_dh = .false.
lri = nlg1
lrj = nlg2
intpos = nlg1
isma = iml

select case (linelp)
  case default ! (1)
    ! line=1 a&r<-->a^r
    call ar_dv_ext_ar(51,isma,lri,lrj)      ! ar_dv_ext_ar(100_???
  case (4)
    ! line=4 a&r--b&r--b^r<-->a^r
    call ar_br_br_ext_ar_new(23,intpos,isma)
  case (7)
    ! line=7 a&r--b&l--b^l<-->a^r
    call ar_bl_bl_ext_ar_new(23,intpos,isma,1)
  case (10)
    ! line=10 d&rr--b^r<-->a^r
    call drr_br_ext_ar(23,lri,lrj)
  case (12)
    ! line=12 d&rl--b^l<-->a^r
    call drl_bl_ext_ar_new(23,lri,lrj)
  case (2:3,5:6,8:9,11)
end select

return

end subroutine dv_ext_head_in_act

subroutine sd_drt_ci_new_den()

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, ipae, ipael, jml, jmr, jpad, jpadl, jpadlr, linelp, lpblock_sd
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: jptyl, jptyr, lpb

!write(u6,*) '  sd_wyb'

!logic_sd = .true.
call external_space_plpmode_value_sd()

idisk_lp = idisk_array(11)

do lpb=1,lpblock_sd
  call read_lp()
  ipael = iml+17
  ipae = imr+1
  call get_jpty(jpadlr,jptyl,jptyr)
  call get_jp(jptyl,jml,jpadl,1)
  call get_jp(jptyr,jmr,jpad,1)
  !jmlr = Mul(jml,jmr)
  call gsd_determine_extarmode_paras(iml,imr,.true.)
  if (linelp <= 12) then
    call sd_ext_head_in_act()
  else
    call sd_ext_head_in_dbl()
  end if
end do

return

end subroutine sd_drt_ci_new_den

subroutine sd_drt_ci_new()

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, ipae, ipael, jml, jmr, jpad, jpadl, jpadlr, linelp, lpblock_sd
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: jptyl, jptyr, lpb

!write(u6,*) '  sd_wyb'

!logic_sd = .true.
call external_space_plpmode_value_sd()

idisk_lp = idisk_array(11)

do lpb=1,lpblock_sd
  call read_lp()
  ipael = iml+17
  ipae = imr+1
  call get_jpty(jpadlr,jptyl,jptyr)
  call get_jp(jptyl,jml,jpadl,1)
  call get_jp(jptyr,jmr,jpad,1)
  !jmlr = Mul(jml,jmr)
  call gsd_determine_extarmode_paras(iml,imr,.true.)
  if (linelp <= 12) then
    call sd_ext_head_in_act()
  else
    call sd_ext_head_in_dbl()
  end if
end do

return

end subroutine sd_drt_ci_new

subroutine sd_ext_head_in_dbl()

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jb_sys, jml, jmr, jpad, jpadl, jpadlr, jud, just, linelp, logic_dh, &
                         lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, nlg1, nlg2, norb_dz, &
                         norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dv, w0_sd, w0_sv, w0_td, w0_vv, w1_sd, w1_sv, &
                         w1_td, w1_tv
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ijk, imap_1, intpos, isma, iwal, iwar, iwdl, iwdr, jk, jmlr, lmd, lmi, lmij, lmj, lpok, lra, lrd, lri, lrj, &
                     lrk, mpl, ni
real(kind=wp) :: w0, w0sd1, w0sd11, w0sd12, w0sd14, w0sd16, w0sd2, w0sd4, w0sd5, w0sd8, w0sd9, w0sv2, w0td1, w0td2, w0td3, w0td4, &
                 w0td5, w1sd11, w1sd12, w1sd5, w1sd8, w1sd9, w1sv2, w1td2, w1td3, w1td4, w1tv
integer(kind=iwp), external :: iwalk_ad

logic_dh = .true.
isma = Mul(iml,imr)
jmlr = Mul(jml,jmr)
lpok = jpadlr
select case (lpok)
  case (1)
    !===================================================================
    ! ss(1)     act -b^l-
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call ss_drl_act_bl(6,lra)
      if (jb_sys > 0) call ss_drl_act_bl_sgt0(6,lra)
    else
      call ss_arbl_act_bl(6,lra)
      if (jb_sys > 0) then
        call ss_arbl_act_bl_sgt0(6,lra)
        call ss_s_drl_act_bl_sgt0(6,lra)
      end if
    end if

  case (2)
    !===================================================================
    ! st(2)      act -b^l
    if ((linelp /= 15) .or. (nlg2 /= 2)) return
    lra = nlg1
    call st_arbl_act_bl(6,lra)
    if (jml == jmr) then
      call st_drl_act_bl(6,lra)
    end if
    if (jb_sys > 0) then
      call st_arbl_act_bl_sgt0(6,lra)
      if (jml == jmr) then
        call st_drl_act_bl_sgt0(6,lra)
      end if
    end if

  case (3)
    !===================================================================
    ! ts(3)   act -b^l ............................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 2) then
      call ts_arbl_act_bl(6,lra)
    end if

  case (4)
    !===================================================================
    ! stt(4) act-b^l ..............................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) return
    call stt_arbl_act_bl_sgt1(6,lra)

  case (5)
    !===================================================================
    ! tts(5) act-b^l ..............................................
    if ((linelp /= 15) .or. (nlg2 /= 2)) return
    lra = nlg1
    call tts_arbl_act_bl_sgt1(6,lra)
    call tts_drl_act_bl_sgt1(6,lra)

  case default ! (6)
    !===================================================================
    ! sd(6-1) a&r(02)-
    ! sd(6-2) c(22)a&(13)-
    ! sd(6-3) a&r(13)c'(22)-
    ! sd(6-4) a&r(23)c'(12)-
    ! sd(6-5) a&r(23)b&r(13)b^r(32)
    ! sd(6-6) a&r(13)b&r(23)b^r(32)
    ! sd(6-7) a&r(13)b&l(32)b^l(23)
    ! sd(6-8) a&r(23)b&l(32)b^l(13)
    ! sd(6-9) d&r&r(03)b^r(32)
    ! sd(6-10) d&r&l(12)b^l(23)
    ! sd(6-11) d&r&l(22)b^l(13)
    ! sd(6-12) d&r&l(33)b^l(02)
    ! sd(6-13) (22)d&r&l(33)b^l(13)
    ! sd(6-14) d&r&l(33)c"(22)b^l(13)
    ! sd(6-15) d&r&l(33)b^l(13)c'(22)
    ! sd(6-16) d&r&l(33)b^l(23)c'(12)
    if (linelp == 13) then
      if (jb_sys > 0) then
        call sd_adb_act_c_ext_ar(6)
      end if
      do lri=norb_frz+1,norb_dz
        lmi = lsm_inn(lri)
        if (lmi /= jmlr) cycle
        w0sd1 = w0_sd(1)
        w0sd9 = w0_sd(9)
        w1sd9 = w1_sd(9)
        w0sd12 = w0_sd(12)
        w1sd12 = w1_sd(12)
        ni = mod(norb_dz-lri,2)
        if (ni == 1) w0sd1 = -w0sd1
        if (ni == 1) w0sd9 = -w0sd9
        if (ni == 1) w1sd9 = -w1sd9
        if (ni == 1) w0sd12 = -w0sd12
        if (ni == 1) w1sd12 = -w1sd12
        if ((jml == 1) .and. (lmi == jmr)) then
          iwdl = just(lri,lri)
          iwdr = jud(lri)
          do mpl=1,mhlp
            iwal = lpnew_lwei(mpl)
            iwar = lpnew_rwei(mpl)
            lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
          end do

          ! sd(6-1) a&r(02)-
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
          end do
          call ar_sd_ext_ar(26,lri,lrj,isma)
          call ar_sd_ext_rest(lri)

          ! sd(6-12) d&r&l(33)b^l(02)
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd12
            vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd12
          end do
          do lrk=1,lri-1
            call drl_bl_ext_ar_new(6,lrk,lri)
          end do
          ! sd(6-9) d&r&r(03)b^r(32)
          do lrk=norb_frz+1,lri-1
            iwdl = just(lrk,lrk)
            iwdr = jud(lri)
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd9
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd9
            end do
            call drr_br_ext_ar(6,lrk,lri)
          end do
        end if
      end do

      do lri=norb_frz+1,norb_dz
        lmi = lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj = lsm_inn(lrj)
          lmij = Mul(lmi,lmj)
          if (lmij /= jml) cycle

          if (lmi == jmr) then
            iwdl = just(lri,lrj)
            iwdr = jud(lri)
            w0sd2 = w0_sd(2)
            w0sd11 = w0_sd(11)
            w1sd11 = w1_sd(11)
            w0sd14 = w0_sd(14)
            ni = mod(norb_dz-lrj,2)
            if (ni == 1) then
              w0sd2 = -w0sd2
              w0sd11 = -w0sd11
              w1sd11 = -w1sd11
              w0sd14 = -w0sd14
            end if
            ! sd(6-2) c(22)-a&r(13)-
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_sd_ext_ar(25,lrj,lri,isma)
            call ar_sd_ext_rest(lrj)
            ! sd(6-11) d&r&l(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd11
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd11
            end do
            call drl_bl_ext_ar_new(6,lri,lrj)
            ! sd(6-14) (22)d&r&l(33)b^l(13)
            ! sd(6-14) d&r&l(33)c"(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd14
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lrj-1
              if (lrk == lri) cycle
              call drl_bl_ext_ar_new(6,lrk,lrj)
            end do
          end if
          ! sd(6-4) a&r(23)-c'(12)-
          w0sd4 = w0_sd(4)
          w0sd16 = w0_sd(16)
          ni = mod(norb_dz-lri,2)
          if (ni == 0) then
            w0sd4 = -w0sd4
            w0sd16 = -w0sd16
          end if
          if (lmj == jmr) then
            iwdl = just(lri,lrj)
            iwdr = jud(lrj)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd4
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_sd_ext_ar(28,lri,lrj,isma)
            call ar_sd_ext_rest(lri)
            ! sd(6-16) d&r&l(33)b^l(23)c'(12)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd16
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(6,lrk,lri)
            end do
          end if
          ! sd(6-5) a&r(23)b&r(13)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle

            w0sd5 = w0_sd(5)
            w1sd5 = w1_sd(5)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0sd5 = -w0sd5
              w1sd5 = -w1sd5
            end if
            iwdl = just(lri,lrj)
            iwdr = jud(lrd)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd5
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd5
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos = intind_ijka(ijk)
            call ar_br_br_ext_ar_new(6,intpos,isma)
          end do
          ! sd(6-8) a&r(23)b&l(32)b^l(13)
          do lrd=lri+1,lrj-1
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdl = just(lri,lrj)
            iwdr = jud(lrd)
            w0sd8 = w0_sd(8)
            w1sd8 = w1_sd(8)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0sd8 = -w0sd8
              w1sd8 = -w1sd8
            end if
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd8
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd8
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            ijk = lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos = intind_ijka(ijk)
            call ar_bl_bl_ext_ar_new(6,intpos,isma,1)
          end do
        end do
      end do
    end if
    !===================================================================
    ! sd(6)    act -br-br-
    if (linelp == 20) then
      jk = nlg1
      call sd_ar_act_brbr(6,jk)
      if (jb_sys > 0) call sd_ar_act_brbr_sgt0(6,jk)
    end if
    ! sd(6)  act -bl-bl-
    if (linelp == 22) then
      jk = nlg1
      call sd_ar_act_blbl(6,jk)
      if (jb_sys > 0) call sd_ar_act_blbl_sgt0(6,jk)
    end if

  case (8)
    !===================================================================
    ! sdd(8) act-b^l -c'- -c"-..........................................
    lra = nlg1
    if (linelp == 13) then
      call sdd_drlbl_act_c_sgt0(6)
      call sdd_drrbr_act_c_sgt0(6)
      call sdd_abb_act_c_sgt0(6)
      call sdd_ar_act_c_sd_ext_sgt0(6)
    else
      lra = nlg1
      if (linelp == 20) call sdd_ar_act_brbr_sgt0(6,lra)
      if (linelp == 22) call sdd_ar_act_blbl_sgt0(6,lra)
    end if

  !case (9)
  !  !==================================================================
  !  ! dds(9) act -c'- ..............................................
  !  if (linelp == 13) then
  !    lra = nlg1
  !    call dds_abb_act_c_sgt0(6)
  !  end if

  case (10)
    !===================================================================
    ! sv(10)     act -b^r-
    ! sv(10-1) ar(13)-br(23)-
    ! sv(10-2) ar(23)-br(13)-
    ! sv(10-3) drr(03)-
    if ((linelp /= 16) .or. (nlg2 /= 2)) return
    lra = nlg1
    if (jb_sys > 0) then
      call sv_arbr_act_br_sgt0(6,lra)
    end if
    do lri=norb_frz+1,norb_dz
      lmi = lsm_inn(lri)
      do lrj=lri,norb_dz
        lmj = lsm_inn(lrj)
        lmij = Mul(lmi,lmj)
        if (lmij /= jml) cycle
        w0sv2 = w0_sv(2)
        w1sv2 = w1_sv(2)
        ni = mod(lrj-lri,2)
        if (ni == 0) then
          w0sv2 = -w0sv2
          w1sv2 = -w1sv2
        end if
        !---------------------------------------------------------------
        iwdl = just(lri,lrj)
        iwdr = 0
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        if (lri /= lrj) then
          ! sv(10-2) ar(23)-br(13)-
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0sv2
            vplp_w1(mpl) = vplpnew_w1(mpl)*w1sv2
          end do
          ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos = intind_ijka(ijk)
          call ar_br_br_ext_ar_new(6,intpos,isma)
        else
          ! sv(10-3) drr(03)-
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0_sv(3)
            vplp_w1(mpl) = vplpnew_w1(mpl)*w1_sv(3)
          end do
          call drr_br_ext_ar(6,lri,lra)
        end if
      end do
    end do

  case (11)
    !===================================================================
    ! tt(11)   act -b^l
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call tt_drl_act_bl(6,lra)
    else
      call tt_arbl_act_bl(6,lra)
    end if

  case (12)
    !===================================================================
    ! tttt(12)   act -b^l
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call tttt_drl_act_bl_sgt1(6,lra)
    else
      call tttt_arbl_act_bl_sgt1(6,lra)
    end if

  case (13)
    !===================================================================
    ! td(13)                                  act -c'-
    ! td(13-1) (22)a&(23)
    ! td(13-1) a&(23)c'(22)
    ! td(13-2) a&(23)b&r(23)b^r(32)
    ! td(13-3) a&(23)b&l(32)b^l(23)
    ! td(13-4) d&r&l(22)b^l(23)
    ! td(13-5) (22)d&&l(33)b^l(23)
    ! td(13-5) d&rl(33)c"(22)b^l(23)
    ! td(13-5) d&rl(33)b^l(23)c'(22)
    if (linelp == 13) then
      do lri=norb_frz+1,norb_dz
        lmi = lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj = lsm_inn(lrj)
          lmij = Mul(lmi,lmj)
          if (lmij /= jml) cycle
          w0td1 = w0_td(1)
          w0td4 = w0_td(4)
          w1td4 = w1_td(4)
          w0td5 = w0_td(5)
          ni = mod(norb_dz-lrj,2)
          if (ni == 1) then
            w0td1 = -w0td1
            w0td4 = -w0td4
            w1td4 = -w1td4
            w0td5 = -w0td5
          end if
          iwdl = just(lri,lrj)
          !-------------------------------------------------------------
          ! td(13-1) (22)a&(23)
          if (lmi == jmr) then
            iwdr = jud(lri)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_sd_ext_ar(43,lrj,lri,isma)
            call ar_sd_ext_rest(lrj)
            ! td(13-4) d&r&l(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td4
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1td4
            end do
            call drl_bl_ext_ar_new(6,lri,lrj)
            ! td(13-5) (22)d&rl(33)b^l(23)
            ! td(13-5) d&rl(33)c"(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td5
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lrj-1
              if (lrk == lri) cycle
              call drl_bl_ext_ar_new(6,lrk,lrj)
            end do
          end if
          !-------------------------------------------------------------
          ! td(13-1) a&(23)c'(22)
          if (lmj == jmr) then
            iwdr = jud(lrj)
            w0td1 = w0_td(1)
            w0td5 = w0_td(5)
            ni = mod(norb_dz-lri,2)
            if (ni == 0) then
              w0td1 = -w0td1
              w0td5 = -w0td5
            end if
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_sd_ext_ar(46,lri,lrj,isma)
            call ar_sd_ext_rest(lri)
            ! td(13-5) d&rl(33)b^l(23)c'(22)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td5
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(6,lrk,lri)
            end do
          end if
          !-------------------------------------------------------------
          ! td(13-2) a&(23)b&r(23)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdr = jud(lrd)
            ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos = intind_ijka(ijk)
            w0td2 = w0_td(2)
            w1td2 = w1_td(2)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0td2 = -w0td2
              w1td2 = -w1td2
            end if
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td2
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1td2
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_br_br_ext_ar_new(6,intpos,isma)
          end do
          !-------------------------------------------------------------
          ! td(13-3) a&(23)b&l(32)b^l(23)
          do lrd=lri+1,lrj-1
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdr = jud(lrd)
            w0td3 = w0_td(3)
            w1td3 = w1_td(3)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0td3 = -w0td3
              w1td3 = -w1td3
            end if
            ijk = lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos = intind_ijka(ijk)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td3
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1td3
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_bl_bl_ext_ar_new(6,intpos,isma,1)
          end do
          !-------------------------------------------------------------
        end do
      end do
    end if
    !===================================================================
    ! td(13) act -br-br-
    if (linelp == 20) then
      jk = nlg1
      call td_ar_act_brbr(6,jk)
    end if
    ! td(13)  act -bl-bl-
    if (linelp == 22) then
      jk = nlg1
      call td_ar_act_blbl(6,jk)
    end if

  case (15)
    !===================================================================
    ! ttdd(15)    act -c'-   -br-br- -bl-bl
    lra = nlg1
    if (linelp == 13) then                  ! no complete ar-
      !if (nlg2 == 1) then
      call ttdd_drlbl_act_c_sgt1(6)
      call ttdd_abb_act_c_sgt1(6)           ! ????
      call ttdd_ar_act_c_ttdd_ext_sgt1(6)
      !end if
    end if
    if (linelp == 20) then
      call ttdd_ar_act_brbr_sgt0(6,lra)
    end if
    if (linelp == 22) then
      call ttdd_ar_act_blbl_sgt0(6,lra)
    end if

  case (17)
    !===================================================================
    ! tv(17)    act -b^r-
    if ((linelp /= 16) .or. (nlg2 /= 2)) return
    lra = nlg1
    do lri=norb_frz+1,norb_dz-1
      lmi = lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj = lsm_inn(lrj)
        lmij = Mul(lmi,lmj)
        if (lmij /= jml) cycle

        w1tv = w1_tv
        ni = mod(lrj-lri,2)
        if (ni == 0) w1tv = -w1tv

        !---------------------------------------------------------------
        ! tv(17) ar(23)-br(23)-
        iwdl = just(lri,lrj)
        iwdr = 0
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1tv
        end do
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
        intpos = intind_ijka(ijk)
        call ar_br_br_ext_ar_new(6,intpos,isma)
      end do
    end do

  case (18)
    !===================================================================
    ! ttv(19) act -b^r- ................................................
    if ((linelp /= 16) .or. (nlg2 /= 2)) return
    lra = nlg1
    call ttv_arbr_act_c_sgt1(6,lra)

  case (19)
    !===================================================================
    ! dd(19) act -b^l- .................................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call dd_drl_act_bl(6,lra)
    else
      call dd_arbl_act_bl(6,lra)
    end if

  case (20)
    !===================================================================
    ! dddd(19) act -b^l- -br- ..........................................
    lra = nlg1
    if (linelp == 15) then
      if (nlg2 == 2) then
        call dddd_arbl_act_bl_sgt0(6,lra)
      else
        call dddd_drl_act_bl_sgt0(6,lra)
      end if
    end if

  case (21)
    !===================================================================
    ! dd1(21) act -b^l-  ...............................................
    if ((linelp /= 15) .or. (nlg2 /= 2)) return
    lra = nlg1
    call dd1_arbl_act_bl_sgt0(6,lra)

  case (22)
    !===================================================================
    ! d1d(22) act -b^l-  ...............................................
    lra = nlg1
    if ((linelp == 15) .and. (nlg2 == 2)) then
      call d1d_arbl_act_bl_sgt0(6,lra)
      call d1d_drl_act_bl_sgt0(6,lra)
    end if

  case (23)
    !===================================================================
    ! dv(23) act -c'-..................................................
    ! dv(23-1) ar(23)-
    ! dv(23-2) drl(33)-bl(23)-
    if (linelp == 13) then
      imap_1 = 0
      do lrd=norb_frz+1,norb_dz
        lmd = lsm_inn(lrd)
        if (lmd /= jml) cycle
        ni = mod(norb_dz-lrd,2)

        ! dv(23-1) ar(23)-
        w0 = w0_dv(1)
        if (ni == 1) w0 = -w0_dv(1)
        iwdl = jud(lrd)
        iwdr = 0
        imap_1 = imap_1+1
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0
        end do
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_sd_ext_ar(51,lrd,0,isma)
        call ar_sd_ext_rest(lrd)
        ! dv(23-2) drl(33)-bl(23)-
        w0 = w0_dv(2)
        if (ni == 1) w0 = -w0_dv(2)
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0
          vplp_w1(mpl) = Zero
        end do
        do lrk=1,lrd-1
          call drl_bl_ext_ar_new(6,lrk,lrd)
        end do
      end do
    end if
    !===================================================================
    ! dv(23) act -br-br-................................................
    if (linelp == 20) then
      jk = nlg1
      do lrd=norb_frz+1,norb_dz
        lmd = lsm_inn(lrd)
        if (lmd /= jml) cycle
        ni = mod(norb_dz-lrd,2)
        w0 = w0_dv(1)
        if (ni == 1) w0 = -w0_dv(1)
        !...............................................................
        ! dv(23-1) ar(23)-
        iwdl = jud(lrd)
        iwdr = 0
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0
          vplp_w1(mpl) = vplpnew_w1(mpl)*w0
        end do
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        ijk = lrd-norb_frz+jk
        intpos = intind_ijka(ijk)
        call ar_br_br_ext_ar_new(6,intpos,isma)
      end do
    end if
    ! dv(23) act -bl-bl-................................................
    if (linelp /= 22) return
    jk = nlg1
    do lrd=norb_frz+1,norb_dz
      lmd = lsm_inn(lrd)
      if (lmd /= jml) cycle
      ni = mod(norb_dz-lrd,2)
      w0 = w0_dv(1)
      if (ni == 1) w0 = -w0_dv(1)
      ! dv(23-1) ar(23)-
      iwdl = jud(lrd)
      iwdr = 0
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0
        vplp_w1(mpl) = vplpnew_w1(mpl)*w0
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      ijk = lrd-norb_frz+jk
      intpos = intind_ijka(ijk)
      call ar_bl_bl_ext_ar_new(6,intpos,isma,1)
    end do

  case (24)
    !===================================================================
    ! d1v(24) act -c'-..................................................
    ! d1v(24-1) ar(13)-
    ! d1v(24-2) drl(33)-bl(13)-
    if (linelp == 13) then
      call d1v_ar_act_c_ext(6)
    end if
    if (linelp == 20) then
      jk = nlg1
      call d1v_ar_act_brbr_ext(6,jk)
    end if
    if (linelp == 22) then
      jk = nlg1
      call d1v_ar_act_blbl_ext(6,jk)
    end if

  case (25)
    !===================================================================
    ! vv(25) act -b^l- .................................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      iwdl = 0
      iwdr = 0
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0_vv
        vplp_w1(mpl) = Zero
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call drl_bl_sum_ar_new(6,0,0,lra)
      !do lrk=1,norb_dz
      !  call drl_bl_ext_ar_new(6,lrk,lra)
      !end do
    end if

  case (7,9,14,16,26)
end select

return

end subroutine sd_ext_head_in_dbl

subroutine sd_ext_head_in_act()

use gugaci_global, only: iml, imr, linelp, logic_dh, nlg1, nlg2
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: intpos, isma, lri, lrj

logic_dh = .false.
lri = nlg1
lrj = nlg2
intpos = nlg1
isma = Mul(iml,imr)

select case (linelp)
  case default ! (1)
    ! line=1 a&r<-->a^r
    call ar_sd_ext_ar(100,lri,lrj,isma)
    call ar_sd_ext_rest(lri)
  case (4)
    ! line=4 a&r--b&r--b^r<-->a^r
    call ar_br_br_ext_ar_new(6,intpos,isma)
  case (7)
    ! line=7 a&r--b&l--b^l<-->a^r
    call ar_bl_bl_ext_ar_new(6,intpos,isma,1)
  case (10)
    ! line=10 d&rr--b^r<-->a^r
    call drr_br_ext_ar(6,lri,lrj)
  case (12)
    ! line=12 d&rl--b^l<-->a^r
    call drl_bl_ext_ar_new(6,lri,lrj)
  case (2:3,5:6,8:9,11)
end select

return

end subroutine sd_ext_head_in_act

subroutine sd_ext_space_w01plp_value()

use gugaci_global, only: w0_sdplp, w0g25a, w0g26a, w0g27, w0g28a, w0g29, w0g30, w0g31, w0g32, w0plp25, w0plp26, w0plp27, w0plp28, &
                         w0plp29, w0plp30, w0plp31, w0plp32, w1g27, w1g31, w1g32, w1plp27, w1plp31, w1plp32

implicit none

w0plp25 = w0_sdplp*w0g25a
w0plp26 = w0_sdplp*w0g26a
w0plp27 = w0_sdplp*w0g27
w1plp27 = w0_sdplp*w1g27
w0plp28 = w0_sdplp*w0g28a
w0plp29 = w0_sdplp*w0g29
w0plp30 = w0_sdplp*w0g30
w0plp31 = w0_sdplp*w0g31
w1plp31 = w0_sdplp*w1g31
w0plp32 = w0_sdplp*w0g32
w1plp32 = w0_sdplp*w1g32

end subroutine sd_ext_space_w01plp_value

subroutine gsd_samesym_aaa(lri,isma)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, intind_iabc, intind_iaqq, iwt_orb_ext, m_jd, nabc, ngw2, ngw3, norb_ext, &
                         norb_number, value_lpext, vint_ci, w0g28a, w0plp27, w0plp28, w0plp31, w0plp32, w1plp27, w1plp31, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma
integer(kind=iwp) :: ia, ia0, iabc, iabc0, iaqq, iasta, ib, ibend, ibsta, ic, ilwei, intpos, iposint, jcoffset, lrc

ia0 = (lri-1)*norb_ext
iabc0 = (lri-1)*nabc

ic = m_jd
lrc = norb_number(ic)
jcoffset = lrc*2-2

iasta = ibsm_ext(isma)
ibend = iesm_ext(isma)
ibsta = iasta+1

ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)
do ib=ibsta,ic-1
  do ia=iasta,ib-1
    ! g31   type_12 arbrb^ra^r
    iabc = iabc0+ia+ngw2(ib)+ngw3(ic)
    iposint = intind_iabc(iabc)
    value_lpext(ilwei) = vint_ci(iposint+1)*w0plp31+vint_ci(iposint+2)*w1plp31
    ilwei = ilwei+1
  end do
end do

ib = ic
ilwei = icnt_base+iwt_orb_ext(iasta,ib)
do ia=iasta,ib-1
  ! g28     cw-ar                    330
  iaqq = ia0+ia
  intpos = intind_iaqq(iaqq)
  iposint = intpos+jcoffset
  value_lpext(ilwei) = (vint_ci(iposint)/w0g28a+vint_ci(iposint+1))*w0plp28
  ilwei = ilwei+1
end do

ia = ic
do ib=ic+1,ibend
  ! g25,g27: bl(20)-drl(11)         220
  iaqq = ia0+ib
  intpos = intind_iaqq(iaqq)
  iposint = intpos+jcoffset
  ilwei = icnt_base+iwt_orb_ext(ic,ib)
  value_lpext(ilwei) = vint_ci(iposint)*w0plp27-vint_ci(iposint+1)*w1plp27
end do

do ib=ic+1,ibend
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    ! g32a   type g12
    iabc = iabc0+ia+ngw2(ic)+ngw3(ib)
    iposint = intind_iabc(iabc)
    value_lpext(ilwei) = vint_ci(iposint+2)*w0plp32-vint_ci(iposint)*w1plp32 !severe_new_er
    ilwei = ilwei+1
  end do
end do

do ib=ic+2,ibend
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,ib-1
    iabc = iabc0+ic+ngw2(ia)+ngw3(ib)
    iposint = intind_iabc(iabc)
    ! g32b  type 11
    value_lpext(ilwei) = vint_ci(iposint+1)*w0plp32-vint_ci(iposint)*w1plp32 !severe_new_
    ilwei = ilwei+1
  end do
end do

end subroutine gsd_samesym_aaa

subroutine gsd_diffsamesym_abb(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, intind_iabc, intind_iaqq, iwt_orb_ext, m_jc, m_jd, nabc, ngw2, ngw3, &
                         norb_ext, norb_number, value_lpext, vint_ci, w0g28a, w0plp28, w0plp31, w0plp32, w1plp31, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, ia0, iabc, iabc0, iaend, iaqq, iasta, ib, ibend, ibsta, ic, ilwei, intpos, iposint, jb, jcoffset, lrc

ia0 = (lri-1)*norb_ext
iabc0 = (lri-1)*nabc

ic = m_jd
lrc = norb_number(ic)
jcoffset = lrc*2-2

iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)

ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)
do ib=ibsta,ic-1
  do ia=iasta,iaend
    ! g31
    ! g31   type_12 arbrb^ra^r
    iabc = iabc0+ia+ngw2(ib)+ngw3(ic)
    iposint = intind_iabc(iabc)
    value_lpext(ilwei) = vint_ci(iposint+1)*w0plp31+vint_ci(iposint+2)*w1plp31 !severe_new_
    ilwei = ilwei+1
  end do
end do

ilwei = icnt_base+iwt_orb_ext(iasta,ic+1)
jb = m_jc
do ib=ic+1,ibend
  jb = jb+1
  do ia=iasta,iaend
    ! g32a
    iabc = iabc0+ia+ngw2(ic)+ngw3(ib)
    iposint = intind_iabc(iabc)
    value_lpext(ilwei) = vint_ci(iposint+2)*w0plp32-vint_ci(iposint)*w1plp32 !severe_new_err
    ilwei = ilwei+1
  end do
end do

ib = ic
ilwei = icnt_base+iwt_orb_ext(iasta,ib)
do ia=iasta,iaend      !ib-1      !severe_error_1020
  ! g28
  iaqq = ia0+ia
  intpos = intind_iaqq(iaqq)
  iposint = intpos+jcoffset
  !value_lpext(ilwei) = (vint_ci(iposint2)+
  value_lpext(ilwei) = w0plp28*(vint_ci(iposint)/w0g28a+vint_ci(iposint+1))
  ilwei = ilwei+1
end do

end subroutine gsd_diffsamesym_abb

subroutine gsd_diffsamesym_aab(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, intind_iabc, intind_iaqq, iwt_orb_ext, m_jd, nabc, ngw2, ngw3, norb_ext, &
                         norb_number, value_lpext, vint_ci, w0plp27, w0plp32, w1plp27, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, ia0, iabc, iabc0, iaend, iaqq, iasta, ib, ibend, ibsta, ic, ilwei, intpos, iposint, jcoffset, lrc

ia0 = (lri-1)*norb_ext
iabc0 = (lri-1)*nabc

ic = m_jd
lrc = norb_number(ic)
jcoffset = lrc*2-2

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)

! if (ic-1 > iasta) then
do ib=ibsta,ibend
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    ! g32a
    iabc = iabc0+ia+ngw2(ic)+ngw3(ib)
    iposint = intind_iabc(iabc)
    value_lpext(ilwei) = vint_ci(iposint+2)*w0plp32-vint_ci(iposint)*w1plp32 !severe_new_
    ilwei = ilwei+1
  end do
end do

do ib=ibsta,ibend
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,iaend      !ib-1      !severe_error_1020
    iabc = iabc0+ic+ngw2(ia)+ngw3(ib)
    iposint = intind_iabc(iabc)
    ! g32b
    value_lpext(ilwei) = vint_ci(iposint+1)*w0plp32-vint_ci(iposint)*w1plp32 !severe_new_err
    ilwei = ilwei+1
  end do
end do

ia = ic
do ib=ibsta,ibend
  ! g25
  iaqq = ia0+ib
  intpos = intind_iaqq(iaqq)
  iposint = intpos+jcoffset
  ilwei = icnt_base+iwt_orb_ext(ic,ib)
  value_lpext(ilwei) = vint_ci(iposint)*w0plp27-vint_ci(iposint+1)*w1plp27
end do

end subroutine gsd_diffsamesym_aab

subroutine gsd_arlp_s1(lri)

use gugaci_global, only: icnt_base, intind_iaqq, isegdownwei, m_jd, norb_ext, norb_number, value_lpext, vint_ci, w0plp26, w0plp29, &
                         w0plp30
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp) :: ia0, iaqq, ic, ilwei, intoffset, intpos, iposint, is1orb, lrk

ia0 = (lri-1)*norb_ext
ic = m_jd

iaqq = ia0+ic
intpos = intind_iaqq(iaqq)

ilwei = icnt_base+isegdownwei-norb_ext+1
do is1orb=1,ic-1
  ! g30 -b^rd^rr
  lrk = norb_number(is1orb)
  intoffset = (lrk-1)*2
  iposint = intpos+intoffset
  value_lpext(ilwei) = vint_ci(iposint)*w0plp30
  ilwei = ilwei+1
end do

! g26 -a^r     610
lrk = norb_number(ic)
intoffset = (lrk-1)*2
iposint = intpos+intoffset
value_lpext(ilwei) = vint_ci(iposint)*w0plp26
ilwei = ilwei+1

! g29 -dl^ra^l
do is1orb=ic+1,norb_ext
  lrk = norb_number(is1orb)
  intoffset = (lrk-1)*2
  iposint = intpos+intoffset
  value_lpext(ilwei) = vint_ci(iposint)*w0plp29
  ilwei = ilwei+1
end do

end subroutine gsd_arlp_s1

subroutine td_drt_ci_new()

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, ipae, ipael, jml, jmr, jpad, jpadl, jpadlr, linelp, lpblock_td, w0_sdplp
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: jptyl, jptyr, lpb

!write(u6,*) '  td_wyb'

!logic_sd = .true.
call external_space_plpmode_value_td()
w0_sdplp = One
call sd_ext_space_w01plp_value()

idisk_lp = idisk_array(7)
do lpb=1,lpblock_td
  call read_lp()
  ipael = iml+9
  ipae = imr+1
  call get_jpty(jpadlr,jptyl,jptyr)
  call get_jp(jptyl,jml,jpadl,1)
  call get_jp(jptyr,jmr,jpad,1)
  !jmlr = Mul(jml,jmr)
  call gsd_determine_extarmode_paras(iml,imr,.false.)
  if (linelp <= 12) then
    call td_ext_head_in_act()
  else
    call td_ext_head_in_dbl()
  end if
end do

return

end subroutine td_drt_ci_new

subroutine td_ext_head_in_dbl()

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jb_sys, jml, jmr, jpad, jpadl, jpadlr, jud, just, linelp, logic_dh, &
                         lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, nlg1, nlg2, norb_dz, &
                         norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dv, w0_sd, w0_sv, w0_td, w0_vv, w1_sd, w1_sv, &
                         w1_td, w1_tv
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ijk, imap_1, intpos, isma, iwal, iwar, iwdl, iwdr, jk, jmlr, lmd, lmi, lmij, lmj, lpok, lra, lrd, lri, lrj, &
                     lrk, mpl, ni
real(kind=wp) :: w0, w0sd1, w0sd11, w0sd12, w0sd14, w0sd16, w0sd2, w0sd4, w0sd5, w0sd8, w0sd9, w0sv2, w0td1, w0td2, w0td3, w0td4, &
                 w0td5, w1sd11, w1sd12, w1sd5, w1sd8, w1sd9, w1sv2, w1td2, w1td3, w1td4, w1tv
integer(kind=iwp), external :: iwalk_ad

logic_dh = .true.
isma = Mul(iml,imr)
jmlr = Mul(jml,jmr)
lpok = jpadlr
select case (lpok)
  case (1)
    !===================================================================
    ! ss(1)     act -b^l-
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call ss_drl_act_bl(13,lra)
      if (jb_sys > 0) call ss_drl_act_bl_sgt0(13,lra)
    else
      call ss_arbl_act_bl(13,lra)
      if (jb_sys > 0) then
        call ss_arbl_act_bl_sgt0(13,lra)
        call ss_s_drl_act_bl_sgt0(13,lra)
      end if
    end if

  case (2)
    !===================================================================
    ! st(2)      act -b^l
    if ((linelp /= 15) .or. (nlg2 /= 2)) return
    lra = nlg1
    call st_arbl_act_bl(13,lra)
    if (jb_sys > 0) call st_arbl_act_bl_sgt0(13,lra)
    if (jml == jmr) then
      call st_drl_act_bl(13,lra)
      if (jb_sys > 0) call st_drl_act_bl_sgt0(13,lra)
    end if

  case (3)
    !===================================================================
    ! ts(3)   act -b^l ............................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 2) then
      call ts_arbl_act_bl(13,lra)
      if (jb_sys > 0) call ts_arbl_act_bl_sgt0(13,lra)
    end if

  case (4)
    !===================================================================
    ! stt(4) act-b^l ..............................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) return
    call stt_arbl_act_bl_sgt1(13,lra)

  case (5)
    !===================================================================
    ! tts(5) act-b^l ..............................................
    if ((linelp /= 15) .or. (nlg2 /= 2)) return
    lra = nlg1
    call tts_arbl_act_bl_sgt1(13,lra)
    call tts_drl_act_bl_sgt1(13,lra)

  case default ! (6)
    !===================================================================
    ! sd(6-1) a&r(02)-
    ! sd(6-2) c(22)a&(13)-
    ! sd(6-3) a&r(13)c'(22)-
    ! sd(6-4) a&r(23)c'(12)-
    ! sd(6-5) a&r(23)b&r(13)b^r(32)
    ! sd(6-6) a&r(13)b&r(23)b^r(32)
    ! sd(6-7) a&r(13)b&l(32)b^l(23)
    ! sd(6-8) a&r(23)b&l(32)b^l(13)
    ! sd(6-9) d&r&r(03)b^r(32)
    ! sd(6-10) d&r&l(12)b^l(23)
    ! sd(6-11) d&r&l(22)b^l(13)
    ! sd(6-12) d&r&l(33)b^l(02)
    ! sd(6-13) (22)d&r&l(33)b^l(13)
    ! sd(6-14) d&r&l(33)c"(22)b^l(13)
    ! sd(6-15) d&r&l(33)b^l(13)c'(22)
    ! sd(6-16) d&r&l(33)b^l(23)c'(12)
    if (linelp == 13) then
      if (jb_sys > 0) then
        call sd_adb_act_c_ext_ar(13)
      end if
      do lri=norb_frz+1,norb_dz
        lmi = lsm_inn(lri)
        if (lmi /= jmlr) cycle
        w0sd1 = w0_sd(1)
        w0sd9 = w0_sd(9)
        w1sd9 = w1_sd(9)
        w0sd12 = w0_sd(12)
        w1sd12 = w1_sd(12)
        ni = mod(norb_dz-lri,2)
        if (ni == 1) w0sd1 = -w0sd1
        if (ni == 1) w0sd9 = -w0sd9
        if (ni == 1) w1sd9 = -w1sd9
        if (ni == 1) w0sd12 = -w0sd12
        if (ni == 1) w1sd12 = -w1sd12
        if ((jml == 1) .and. (lmi == jmr)) then
          iwdl = just(lri,lri)
          iwdr = jud(lri)
          do mpl=1,mhlp
            iwal = lpnew_lwei(mpl)
            iwar = lpnew_rwei(mpl)
            lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
          end do

          ! sd(6-1) a&r(02)-
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
          end do
          call ar_td_ext_ar(26,lri,lrj,isma)
          call ar_td_ext_rest(lri)

          ! sd(6-12) d&r&l(33)b^l(02)
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd12
            vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd12
          end do
          do lrk=1,lri-1
            call drl_bl_ext_ar_new(13,lrk,lri)
          end do

          ! sd(6-9) d&r&r(03)b^r(32)
          do lrk=norb_frz+1,lri-1
            iwdl = just(lrk,lrk)
            iwdr = jud(lri)
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd9
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd9
            end do
            call drr_br_ext_ar(13,lrk,lri)
          end do
        end if
      end do

      do lri=norb_frz+1,norb_dz
        lmi = lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj = lsm_inn(lrj)
          lmij = Mul(lmi,lmj)
          if (lmij /= jml) cycle

          if (lmi == jmr) then
            iwdl = just(lri,lrj)
            iwdr = jud(lri)
            w0sd2 = w0_sd(2)
            w0sd11 = w0_sd(11)
            w1sd11 = w1_sd(11)
            w0sd14 = w0_sd(14)
            ni = mod(norb_dz-lrj,2)
            if (ni == 1) then
              w0sd2 = -w0sd2
              w0sd11 = -w0sd11
              w1sd11 = -w1sd11
              w0sd14 = -w0sd14
            end if
            ! sd(6-2) c(22)-a&r(13)-
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_td_ext_ar(25,lrj,lri,isma)
            call ar_td_ext_rest(lrj)
            ! sd(6-11) d&r&l(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd11
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd11
            end do
            call drl_bl_ext_ar_new(13,lri,lrj)
            ! sd(6-14) (22)d&r&l(33)b^l(13)
            ! sd(6-14) d&r&l(33)c"(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd14
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lrj-1
              if (lrk == lri) cycle
              call drl_bl_ext_ar_new(13,lrk,lrj)
            end do
          end if
          ! sd(6-4) a&r(23)-c'(12)-
          w0sd4 = w0_sd(4)
          w0sd16 = w0_sd(16)
          ni = mod(norb_dz-lri,2)
          if (ni == 0) then
            w0sd4 = -w0sd4
            w0sd16 = -w0sd16
          end if
          if (lmj == jmr) then
            iwdl = just(lri,lrj)
            iwdr = jud(lrj)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd4
              !vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd4
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_td_ext_ar(28,lri,lrj,isma)
            call ar_td_ext_rest(lri)
            ! sd(6-16) d&r&l(33)b^l(23)c'(12)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd16
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(13,lrk,lri)
            end do
          end if
          ! sd(6-5) a&r(23)b&r(13)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle

            w0sd5 = w0_sd(5)
            w1sd5 = w1_sd(5)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0sd5 = -w0sd5
              w1sd5 = -w1sd5
            end if
            iwdl = just(lri,lrj)
            iwdr = jud(lrd)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd5
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd5
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos = intind_ijka(ijk)
            call ar_br_br_ext_ar_new(13,intpos,isma)
          end do
          ! sd(6-8) a&r(23)b&l(32)b^l(13)
          do lrd=lri+1,lrj-1
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdl = just(lri,lrj)
            iwdr = jud(lrd)
            w0sd8 = w0_sd(8)
            w1sd8 = w1_sd(8)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0sd8 = -w0sd8
              w1sd8 = -w1sd8
            end if
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd8
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd8
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            ijk = lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos = intind_ijka(ijk)
            call ar_bl_bl_ext_ar_new(13,intpos,isma,1)
          end do
        end do
      end do
    end if
    !===================================================================
    ! sd(6)    act -br-br-
    if (linelp == 20) then
      jk = nlg1
      call sd_ar_act_brbr(13,jk)
      if (jb_sys > 0) call sd_ar_act_brbr_sgt0(13,jk)
    end if
    ! sd(6)  act -bl-bl-
    if (linelp == 22) then
      jk = nlg1
      call sd_ar_act_blbl(13,jk)
      if (jb_sys > 0) call sd_ar_act_blbl_sgt0(13,jk)
    end if

  case (8)
    !===================================================================
    ! sdd(8) act-b^l -c'- -c"-..........................................
    if (linelp == 13) then
      lra = nlg1
      call sdd_drlbl_act_c_sgt0(13)
      call sdd_drrbr_act_c_sgt0(13)
      call sdd_abb_act_c_sgt0(13)
      call sdd_ar_act_c_sd_ext_sgt0(13)
    else
      lra = nlg1
      if (linelp == 20) call sdd_ar_act_brbr_sgt0(13,lra)
      if (linelp == 22) call sdd_ar_act_blbl_sgt0(13,lra)
    end if

  case (9)
    !===================================================================
    ! dds(9) act -c'- ..............................................
    if (linelp == 13) then
      lra = nlg1
      call dds_abb_act_c_sgt0(13)
    end if

  case (10)
    !===================================================================
    ! sv(10)     act -b^r-
    ! sv(10-1) ar(13)-br(23)-
    ! sv(10-2) ar(23)-br(13)-
    ! sv(10-3) drr(03)-
    if ((linelp /= 16) .or. (nlg2 /= 2)) return
    lra = nlg1
    if (jb_sys > 0) then
      call sv_arbr_act_br_sgt0(13,lra)
    end if
    do lri=norb_frz+1,norb_dz
      lmi = lsm_inn(lri)
      do lrj=lri,norb_dz
        lmj = lsm_inn(lrj)
        lmij = Mul(lmi,lmj)
        if (lmij /= jml) cycle
        w0sv2 = w0_sv(2)
        w1sv2 = w1_sv(2)
        ni = mod(lrj-lri,2)
        if (ni == 0) then
          w0sv2 = -w0sv2
          w1sv2 = -w1sv2
        end if
        !---------------------------------------------------------------
        iwdl = just(lri,lrj)
        iwdr = 0
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        if (lri /= lrj) then
          ! sv(10-2) ar(23)-br(13)-
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0sv2
            vplp_w1(mpl) = vplpnew_w1(mpl)*w1sv2
          end do
          ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos = intind_ijka(ijk)
          call ar_br_br_ext_ar_new(13,intpos,isma)
        else
          ! sv(10-3) drr(03)-
          do mpl=1,mtype
            vplp_w0(mpl) = vplpnew_w0(mpl)*w0_sv(3)
            vplp_w1(mpl) = vplpnew_w1(mpl)*w1_sv(3)
          end do
          call drr_br_ext_ar(13,lri,lra)
        end if
      end do
    end do

  case (11)
    !===================================================================
    ! tt(11)   act -b^l
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call tt_drl_act_bl(13,lra)
    else
      call tt_arbl_act_bl(13,lra)
    end if

  case (12)
    !===================================================================
    ! tttt(12)   act -b^l
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call tttt_drl_act_bl_sgt1(13,lra)
    else
      call tttt_arbl_act_bl_sgt1(13,lra)
    end if

  case (13)
    !===================================================================
    ! td(13)                                  act -c'-
    ! td(13-1) (22)a&(23)
    ! td(13-1) a&(23)c'(22)
    ! td(13-2) a&(23)b&r(23)b^r(32)
    ! td(13-3) a&(23)b&l(32)b^l(23)
    ! td(13-4) d&r&l(22)b^l(23)
    ! td(13-5) (22)d&&l(33)b^l(23)
    ! td(13-5) d&rl(33)c"(22)b^l(23)
    ! td(13-5) d&rl(33)b^l(23)c'(22)
    if (linelp == 13) then
      do lri=norb_frz+1,norb_dz
        lmi = lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj = lsm_inn(lrj)
          lmij = Mul(lmi,lmj)
          if (lmij /= jml) cycle
          w0td1 = w0_td(1)
          w0td4 = w0_td(4)
          w1td4 = w1_td(4)
          w0td5 = w0_td(5)
          ni = mod(norb_dz-lrj,2)
          if (ni == 1) then
            w0td1 = -w0td1
            w0td4 = -w0td4
            w1td4 = -w1td4
            w0td5 = -w0td5
          end if
          iwdl = just(lri,lrj)
          !-------------------------------------------------------------
          ! td(13-1) (22)a&(23)
          if (lmi == jmr) then
            iwdr = jud(lri)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_td_ext_ar(43,lrj,lri,isma)
            call ar_td_ext_rest(lrj)
            ! td(13-4) d&r&l(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td4
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1td4
            end do
            call drl_bl_ext_ar_new(13,lri,lrj)
            ! td(13-5) (22)d&rl(33)b^l(23)
            ! td(13-5) d&rl(33)c"(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td5
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lrj-1
              if (lrk == lri) cycle
              call drl_bl_ext_ar_new(13,lrk,lrj)
            end do
          end if
          !-------------------------------------------------------------
          ! td(13-1) a&(23)c'(22)
          if (lmj == jmr) then
            iwdr = jud(lrj)
            w0td1 = w0_td(1)
            w0td5 = w0_td(5)
            ni = mod(norb_dz-lri,2)
            if (ni == 0) then
              w0td1 = -w0td1
              w0td5 = -w0td5
            end if
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_td_ext_ar(46,lri,lrj,isma)
            call ar_td_ext_rest(lri)
            ! td(13-5) d&rl(33)b^l(23)c'(22)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td5
              vplp_w1(mpl) = Zero
            end do
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(13,lrk,lri)
            end do
          end if
          !-------------------------------------------------------------
          ! td(13-2) a&(23)b&r(23)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdr = jud(lrd)
            ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos = intind_ijka(ijk)
            w0td2 = w0_td(2)
            w1td2 = w1_td(2)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0td2 = -w0td2
              w1td2 = -w1td2
            end if
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td2
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1td2
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_br_br_ext_ar_new(13,intpos,isma)
          end do
          !-------------------------------------------------------------
          ! td(13-3) a&(23)b&l(32)b^l(23)
          do lrd=lri+1,lrj-1
            lmd = lsm_inn(lrd)
            if (lmd /= jmr) cycle
            iwdr = jud(lrd)
            w0td3 = w0_td(3)
            w1td3 = w1_td(3)
            ni = mod(lrj-lri+norb_dz-lrd,2)
            if (ni == 0) then
              w0td3 = -w0td3
              w1td3 = -w1td3
            end if
            ijk = lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos = intind_ijka(ijk)
            do mpl=1,mtype
              vplp_w0(mpl) = vplpnew_w0(mpl)*w0td3
              vplp_w1(mpl) = vplpnew_w1(mpl)*w1td3
            end do
            do mpl=1,mhlp
              iwal = lpnew_lwei(mpl)
              iwar = lpnew_rwei(mpl)
              lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
            end do
            call ar_bl_bl_ext_ar_new(13,intpos,isma,1)
          end do
          !-------------------------------------------------------------
        end do
      end do
    end if
    !===================================================================
    ! td(13) act -br-br-
    if (linelp == 20) then
      jk = nlg1
      call td_ar_act_brbr(13,jk)
    end if
    ! td(13)  act -bl-bl-
    if (linelp == 22) then
      jk = nlg1
      call td_ar_act_blbl(13,jk)
    end if

  case (15)
    !===================================================================
    ! ttdd(15)    act -c'-   -br-br- -bl-bl
    lra = nlg1
    if (linelp == 13) then                  ! no complete ar-
      !if (nlg2 == 1) then
      call ttdd_drlbl_act_c_sgt1(13)
      call ttdd_abb_act_c_sgt1(13)             ! ????
      call ttdd_ar_act_c_ttdd_ext_sgt1(13)
      !end if
    end if
    if (linelp == 20) then
      call ttdd_ar_act_brbr_sgt0(13,lra)
    end if
    if (linelp == 22) then
      call ttdd_ar_act_blbl_sgt0(13,lra)
    end if

  case (17)
    !===================================================================
    ! tv(17)    act -b^r-
    if ((linelp /= 16) .or. (nlg2 /= 2)) return
    lra = nlg1
    do lri=norb_frz+1,norb_dz-1
      lmi = lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj = lsm_inn(lrj)
        lmij = Mul(lmi,lmj)
        if (lmij /= jml) cycle

        w1tv = w1_tv
        ni = mod(lrj-lri,2)
        if (ni == 0) w1tv = -w1tv

        !---------------------------------------------------------------
        ! tv(17) ar(23)-br(23)-
        iwdl = just(lri,lrj)
        iwdr = 0
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1tv
        end do
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
        intpos = intind_ijka(ijk)
        call ar_br_br_ext_ar_new(13,intpos,isma)
      end do
    end do

  case (18)
    !===================================================================
    ! t1v(18) arbr act -c"- ext -br-ar -ar  ! no complete
    if ((nlg2 /= 2) .or. (linelp /= 16)) return
    lra = nlg1
    call ttv_arbr_act_c_sgt1(13,lra)

  case (19)
    !===================================================================
    ! dd(19) act -b^l- .................................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call dd_drl_act_bl(13,lra)
    else
      call dd_arbl_act_bl(13,lra)
    end if

  case (20)
    !===================================================================
    ! dddd(20) act -b^l-  ..............................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      call dddd_drl_act_bl_sgt0(13,lra)
    else
      call dddd_arbl_act_bl_sgt0(13,lra)
    end if

  case (21)
    !===================================================================
    ! dd1(21) act -b^l-  ...............................................
    if ((linelp /= 15) .or. (nlg2 /= 2)) return
    lra = nlg1
    call dd1_arbl_act_bl_sgt0(13,lra)

  case (22)
    !===================================================================
    ! d1d(22) act -b^l-  ...............................................
    lra = nlg1
    if ((linelp == 15) .and. (nlg2 == 2)) then
      call d1d_arbl_act_bl_sgt0(13,lra)
      call d1d_drl_act_bl_sgt0(13,lra)
    end if

  case (23)
    !===================================================================
    ! dv(23) act -c'-..................................................
    ! dv(23-1) ar(23)-
    ! dv(23-2) drl(33)-bl(23)-
    if (linelp == 13) then
      imap_1 = 0
      do lrd=norb_frz+1,norb_dz
        lmd = lsm_inn(lrd)
        if (lmd /= jml) cycle
        ni = mod(norb_dz-lrd,2)

        ! dv(23-1) ar(23)-
        w0 = w0_dv(1)
        if (ni == 1) w0 = -w0_dv(1)
        iwdl = jud(lrd)
        iwdr = 0
        imap_1 = imap_1+1
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0
        end do
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_td_ext_ar(51,lrd,0,isma)
        call ar_td_ext_rest(lrd)
        ! dv(23-2) drl(33)-bl(23)-
        w0 = w0_dv(2)
        if (ni == 1) w0 = -w0_dv(2)
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0
          vplp_w1(mpl) = Zero
        end do
        do lrk=1,lrd-1
          call drl_bl_ext_ar_new(13,lrk,lrd)
        end do
      end do
    end if
    !===================================================================
    ! dv(23) act -br-br-................................................
    if (linelp == 20) then
      jk = nlg1
      do lrd=norb_frz+1,norb_dz
        lmd = lsm_inn(lrd)
        if (lmd /= jml) cycle
        ni = mod(norb_dz-lrd,2)
        w0 = w0_dv(1)
        if (ni == 1) w0 = -w0_dv(1)
        !...............................................................
        ! dv(23-1) ar(23)-
        iwdl = jud(lrd)
        iwdr = 0
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0
          vplp_w1(mpl) = vplpnew_w1(mpl)*w0
        end do
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        ijk = lrd-norb_frz+jk
        intpos = intind_ijka(ijk)
        call ar_br_br_ext_ar_new(13,intpos,isma)
      end do
    end if
    ! dv(23) act -bl-bl-................................................
    if (linelp /= 22) return
    jk = nlg1
    do lrd=norb_frz+1,norb_dz
      lmd = lsm_inn(lrd)
      if (lmd /= jml) cycle
      ni = mod(norb_dz-lrd,2)
      w0 = w0_dv(1)
      if (ni == 1) w0 = -w0_dv(1)
      ! dv(23-1) ar(23)-
      iwdl = jud(lrd)
      iwdr = 0
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0
        vplp_w1(mpl) = vplpnew_w1(mpl)*w0
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      ijk = lrd-norb_frz+jk
      intpos = intind_ijka(ijk)
      call ar_bl_bl_ext_ar_new(13,intpos,isma,1)
    end do

  case (24)
    !===================================================================
    ! d1v(24) act -c'-..................................................
    ! d1v(24-1) ar(13)-
    ! d1v(24-2) drl(33)-bl(13)-
    if (linelp == 13) then
      call d1v_ar_act_c_ext(13)
    end if
    if (linelp == 20) then
      jk = nlg1
      call d1v_ar_act_brbr_ext(13,jk)
    end if
    if (linelp == 22) then
      jk = nlg1
      call d1v_ar_act_blbl_ext(13,jk)
    end if

  case (25)
    !===================================================================
    ! vv(25) act -b^l- .................................................
    if (linelp /= 15) return
    lra = nlg1
    if (nlg2 == 1) then
      iwdl = 0
      iwdr = 0
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0_vv
        vplp_w1(mpl) = Zero
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call drl_bl_sum_ar_new(13,0,0,lra)
      !do lrk=1,norb_dz
      !  call drl_bl_ext_ar_new(13,lrk,lra)
      !end do
    end if

  case (7,14,16,26)
end select

return

end subroutine td_ext_head_in_dbl

subroutine td_ext_head_in_act()

use gugaci_global, only: iml, imr, linelp, logic_dh, nlg1, nlg2
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: intpos, isma, lri, lrj

logic_dh = .false.
lri = nlg1
lrj = nlg2
intpos = nlg1
isma = Mul(iml,imr)

select case (linelp)
  case default ! (1)
    ! line=1 a&r<-->a^r
    call ar_td_ext_ar(100,lri,lrj,isma)
    call ar_td_ext_rest(lri)
  case (4)
    ! line=4 a&r--b&r--b^r<-->a^r
    call ar_br_br_ext_ar_new(13,intpos,isma)
  case (7)
    ! line=7 a&r--b&l--b^l<-->a^r
    call ar_bl_bl_ext_ar_new(13,intpos,isma,1)
  case (10)
    ! line=10 d&rr--b^r<-->a^r
    call drr_br_ext_ar(13,lri,lrj)
  case (12)
    ! line=12 d&rl--b^l<-->a^r
    call drl_bl_ext_ar_new(13,lri,lrj)
  case (2:3,5:6,8:9,11)
end select

return

end subroutine td_ext_head_in_act

subroutine gsd_ext_sequence(iltype,ilsm,irsm,lri)

use gugaci_global, only: ibsm_ext, icano_nnend, icano_nnsta, icnt_base, iesm_ext, iseg_downwei, isegdownwei, m_jc, m_jd, ng_sm
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iltype, ilsm, irsm, lri
integer(kind=iwp) :: ic, icano_nn, icend, icsta, ilnodedownwei, indl, isma, ismb, ismnoded, ismnodes

ismnodes = ilsm
ismnoded = irsm
indl = 0 !?
if (iltype == 2) indl = 1+ismnodes
if (iltype == 3) indl = 9+ismnodes
if (iltype == 4) indl = 17+ismnodes
ilnodedownwei = iseg_downwei(indl)
isegdownwei = ilnodedownwei
icano_nnsta = 1
icnt_base = 0
icsta = ibsm_ext(ismnoded)
icend = iesm_ext(ismnoded)
m_jc = 0

do ic=icsta,icend
  m_jd = ic
  m_jc = ic-icsta+1
  icano_nn = m_jc
  icano_nnend = icano_nn
  do ismb=1,ismnoded-1
    isma = Mul(ismnodes,ismb)
    if (isma > ismb) cycle
    call g31_diffsym(lri,isma,ismb)
  end do

  ismb = ismnoded
  isma = Mul(ismnodes,ismb)
  if (isma == ismb) then
    call gsd_samesym_aaa(lri,isma)
  else if (isma < ismb) then
    call gsd_diffsamesym_abb(lri,isma,ismb)
  end if

  do ismb=ismnoded+1,ng_sm
    isma = Mul(ismnodes,ismb)
    if (isma > ismb) cycle
    if (ismnoded > isma) then
      call g32a_diffsym(lri,isma,ismb)
    else if (ismnoded == isma) then
      call gsd_diffsamesym_aab(lri,isma,ismb)
    else
      call g32b_diffsym(lri,isma,ismb)
    end if
  end do

  if ((ismnodes == 1) .and. (iltype == 4)) then
    call gsd_arlp_s1(lri)
  end if
  icnt_base = icnt_base+ilnodedownwei

end do

end subroutine gsd_ext_sequence

subroutine ar_sd_ext_rest(lri)

use gugaci_global, only: icnt_base, ihy, ihyl, ilsegdownwei, iml, imr, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, &
                         jpadl, jphy, logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, mtype, ndim, nstaval, &
                         nvalue, value_lpext, value_lpext1, vplp_w0, vplpnew_w0, w0_sdplp
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp) :: ihypos, iiext, ilpend, ilpsta, ilw, in_, iplp, irw, iw0, iwal, iwal0, iwar, iwar0, iwd, iwuplwei
real(kind=wp) :: w0_old, w0multi
integer(kind=iwp), external :: iwalk_ad

iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)

if (logic_grad) then
  call gsd_ext_sequence_g(4,iml,imr,lri)

  w0_old = One
  do iw0=1,mtype
    w0_sdplp = vplpnew_w0(iw0)
    if (logic_dh) w0_sdplp = vplp_w0(iw0)
    w0multi = w0_sdplp/w0_old
    w0_old = w0_sdplp
    do iiext=1,icnt_base
      value_lpext(iiext) = value_lpext(iiext)*w0multi
      value_lpext1(iiext) = value_lpext1(iiext)*w0multi
    end do
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then              !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call complete_sd_ar_ext_loop_g(ilw,irw,ilsegdownwei)
      else
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call complete_sd_ar_ext_loop_g(ilw,irw,ilsegdownwei)
          end do
        end do
      end if
    end do
  end do

else
  call gsd_ext_sequence(4,iml,imr,lri)

  w0_old = One
  do iw0=1,mtype
    w0_sdplp = vplpnew_w0(iw0)
    if (logic_dh) w0_sdplp = vplp_w0(iw0)
    w0multi = w0_sdplp/w0_old
    w0_old = w0_sdplp
    do iiext=1,icnt_base
      value_lpext(iiext) = value_lpext(iiext)*w0multi
    end do
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then              !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call complete_sd_ar_ext_loop(ilw,irw,ilsegdownwei)
      else                            !lp_head is in act_s
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call complete_sd_ar_ext_loop(ilw,irw,ilsegdownwei)
          end do
        end do
      end if
    end do
  end do
end if

return

end subroutine ar_sd_ext_rest

subroutine ar_td_ext_rest(lri)

use gugaci_global, only: icnt_base, ihy, ihyl, ilsegdownwei, iml, imr, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, &
                         jpadl, jphy, logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, mtype, ndim, nstaval, &
                         nvalue, value_lpext, value_lpext1, vplp_w0, vplpnew_w0, w0_sdplp
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp) :: ihypos, iiext, ilpend, ilpsta, ilw, in_, iplp, irw, iw0, iwal, iwal0, iwar, iwar0, iwd, iwuplwei
real(kind=wp) :: w0_old, w0multi
integer(kind=iwp), external :: iwalk_ad

iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)

if (logic_grad) then
  call gsd_ext_sequence_g(3,iml,imr,lri)

  w0_old = One
  do iw0=1,mtype
    w0_sdplp = vplpnew_w0(iw0)
    if (logic_dh) w0_sdplp = vplp_w0(iw0)
    w0multi = w0_sdplp/w0_old
    w0_old = w0_sdplp
    do iiext=1,icnt_base
      value_lpext(iiext) = value_lpext(iiext)*w0multi
      value_lpext1(iiext) = value_lpext1(iiext)*w0multi
    end do
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then              !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call complete_sd_ar_ext_loop_g(ilw,irw,ilsegdownwei)
      else                            !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call complete_sd_ar_ext_loop_g(ilw,irw,ilsegdownwei)
          end do
        end do
      end if
    end do
  end do

else

  call gsd_ext_sequence(3,iml,imr,lri)

  w0_old = One
  do iw0=1,mtype
    w0_sdplp = vplpnew_w0(iw0)
    if (logic_dh) w0_sdplp = vplp_w0(iw0)
    w0multi = w0_sdplp/w0_old
    w0_old = w0_sdplp
    do iiext=1,icnt_base
      value_lpext(iiext) = value_lpext(iiext)*w0multi
    end do
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then              !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call complete_sd_ar_ext_loop(ilw,irw,ilsegdownwei)
      else                            !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call complete_sd_ar_ext_loop(ilw,irw,ilsegdownwei)
          end do
        end do
      end if
    end do
  end do
end if

return

end subroutine ar_td_ext_rest

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2002, Laura Gagliardi                                  *
*               2002, Roland Lindh                                     *
************************************************************************
      Subroutine Polar(ireturn)
************************************************************************
*      Author:Laura Gagliardi, Dipartimento di Chimica Fisica,         *
*             University of Palermo, ITALY. December 2002              *
*             Roland Lindh, Department of Chemical Physics, University *
*             of Lund, SWEDEN.                                         *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "itmax.fh"
#include "Molcas.fh"
#include "timtra.fh"
      Parameter (nElem=(iTabMx*(iTabMx**2+6*iTabMx+11)+6)/6)
#include "WrkSpc.fh"
#include "real.fh"
      Real*8 Origin(3,0:iTabMx), CoC(3)
      Integer nBas(8), ip_mu(0:nElem-1), nOrb(8),ip_sq_mu(0:nElem-1),
     &        ip_D(0:6)
      Logical NoField, Standard, Utility, UserDen,PrintDen,SubtractDen
      Logical Restart, TDensity, XHole, Diffuse(3), Exist,  LIonize
      Character*(LENIN) LblCnt(MxAtom)
      Character*(LENIN4) LblCnt4(MxAtom)
      Character*12  Opt_Method
      Dimension dLimmo(2)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      Utility = .False.
      ireturn=99
*                                                                      *
************************************************************************
*                                                                      *
*     Prelude
*
      Call Init_LoProp(nSym,nBas,nOrb,CoC,nAtoms,ipC,ipQ_Nuc,ip_ANr,
     &                 ip_Type,ip_Center,nSize,nBas1,nBas2,nBasMax,ipP,
     &                 ipPInv)
*                                                                      *
************************************************************************
*                                                                      *
*     Read the input
*
*     NoField is defaulted to true if symmetry is implied.
*
      NoField = nSym.ne.1
      Call Readin_polar(NoField,Delta,MpProp_Level,Bond_Threshold,
     &                  iPlot,iPrint,Standard,Opt_Method,UserDen,
     &                  PrintDen,SubtractDen,SubScale,Restart,TDensity,
     &                  nStateI,nStateF,XHole,Diffuse,dLimmo,Thrs1,
     &                  Thrs2,nThrs,ThrsMul,Alpha,LIonize)
      Call InfoToMp(nSym,nBas,Energy_Without_FFPT,ip_Ene_Occ,nOcOb,
     &                  UserDen,Restart)
*                                                                      *
************************************************************************
*                                                                      *
*     Do the LoProp localization.
*
      Call GetMem('Ttot','Allo','Real',ip_Ttot,nBas1**2)
      Call GetMem('TtotInv','Allo','Real',ip_Ttot_Inv,nBas1**2)
*
      Call  Localize_LoProp_Drv(Work(ip_Ttot),Work(ip_Ttot_Inv),nBas,
     &                          iWork(ip_Center),iWork(ip_Type),
     &                          nBas1,nBas2,nSym,nBasMax,ipPInv,Restart)
*
      Call Free_iWork(ip_type)
*                                                                      *
************************************************************************
*                                                                      *
*     Read in the multipole moment integrals once and for all.
*
      Call Get_iScalar('Highest Mltpl',lMax)
      Write (6,'(A,I2)') ' Multipole moments will be processed up to'//
     &                   ' order ',lMax
      Write(6,*)
      mElem=(lMax*(lMax**2+6*lMax+11)+6)/6
*
      nTemp = nBas1**2
      Call Allocate_Work(ip_tmp,nTemp)
*
      Call Allocate_Work(ipMPq,mElem)
      Call Read_Multipole_Int(lMax,ip_sq_mu,nBas,ip_mu,
     &                        Work(ip_Ttot),Work(ip_tmp),Origin,
     &                        Work(ipMPq),mElem,nBas1,nBas2,nBasMax,
     &                        nTemp,nSym,ipPInv,Restart,Utility)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the 1-particle density matrix
*
      Dlt=-Delta
      iPert = 0
      Call Get_Density_Matrix(ip_D(0),nBas1,nBas2,nBasMax,nBas,nSym,ipP
     &                      ,UserDen,PrintDen,SubtractDen,SubScale,
     &                       Work(ipQ_Nuc),nAtoms,iPert,Restart,Utility
     &                      ,TDensity,nStateI,nStateF)
*
*   If computing local xhole-dipole moments. Should come after
*   get_density_matrix so modified densities are used.
      If(XHole) Call Compute_XHole_Int(nBas,nSym,ipXHole2,dMolExpec,
     &                                 nSize)

      If (.Not.NoField) Then
*        Read the one-electron hamiltonian.
         Call Read_h0(nSize,nBas(1),ip_h0,Restart)
         Do iPert = 1, 6
            iF = (iPert+1)/2
            Dlt = - Dlt
            If ((.NOT. Restart).and.(.not.UserDen)) Then
               Call Comp_F(Work(ip_h0),Work(ip_mu(iF)),nBas(1),Dlt, Ep,
     &                     Work(ip_mu(0)),CoC(iF),Origin(iF,1))
            End If
            Call Get_Density_Matrix(ip_D(iPert),nBas1,nBas2,nBasMax,
     &                  nBas,nSym,ipP,UserDen,PrintDen,SubtractDen,
     &              SubScale,Work(ipQ_Nuc),nAtoms,iPert,Restart,Utility,
     &              TDensity,nStateI,nStateF)
         End Do
         Call Free_Work(ip_h0)
      End If
      Do i = mElem, 1, -1
         Call Free_Work(ip_mu(i-1))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     S T A T I C   P R O P E R T I E S                                *
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute localized multipole moments
*
      nPert = 2*3+1
      If (NoField) nPert=1
      nij= (nAtoms*(nAtoms+1)/2)
      nmu=nij*mElem*nPert
      Call Allocate_Work(ipMP,nmu)
      Call Allocate_Work(ip_sq_temp,nTemp)
      Call Allocate_Work(ip_EC,3*nij)
*
      Call Local_Properties(Work(ipC),nAtoms,ip_sq_mu,mElem,
     &                      Work(ip_sq_temp),Origin,
     &                      iWork(ip_center),Work(ip_Ttot_Inv),
     &                      Work(ip_tmp),nij,nPert,ip_D,
     &                      Work(ipMP),lMax,Work(ipMPq),CoC,Work(ip_EC),
     &                      iWork(ip_ANr),Standard,nBas1,nTemp,
     &                      Work(ipQ_Nuc),Bond_Threshold,
     &                      Utility,Opt_Method,iPlot,iPrint,nSym)
*
*---- If XHole integrals are available, localize them. Most unfortunate,
*     the local_properties routine is focused on multipole moments,
*     hence we rather write a new routine for Xhole, than significantly
*     edit the local_properties routine.
      If(XHole) then
        Call Allocate_Work(ipXHLoc2,nij)
        Call Local_Xhole(ipXHole2,dMolExpec,nAtoms,nBas1,nTemp
     &                  ,iWork(ip_center),Work(ip_Ttot)
     &                  ,Work(ip_Ttot_Inv),Work(ipC)
     &                  ,nij,Work(ip_EC),iWork(ip_ANr)
     &                  ,Bond_Threshold,iPrint,ipXHLoc2)
        Call Free_Work(ipXHole2)
      Else
        ipXHLoc2 = ip_Dummy
      Endif
*
*---- If the dear user has requested to get diffuse distributions
*     associated to the multipoles, go here.
      If(Diffuse(1)) then
        Call GetMem('ToPoint','Allo','Real',iTP,nAtoms)
        Call GetMem('NotToPoint','Allo','Real',ipMPp,nmu)
        call dcopy_(nmu,Work(ipMP),1,Work(ipMPp),1)
        Call CoreToPoint(nAtoms,ipMPp,iTP)
        LuYou=IsFreeUnit(81)
        Call OpnFl('DIFFPR',LuYou,Exist)
        Call Diff_MotherGoose(Diffuse,nAtoms,nBas1,ipMPp,ipC,nij,ip_EC
     &                       ,ip_ANr,ip_Ttot
     &                       ,ip_Ttot_Inv,lMax,iTP,dLimmo
     &                       ,Thrs1,Thrs2,nThrs,iPrint
     &                       ,ThrsMul,LuYou)
        Close(LuYou)
        Call GetMem('ToPoint','Free','Real',iTP,nAtoms)
        Call GetMem('NotToPoint','Free','Real',ipMPp,nmu)
      Endif
*
      Do i = mElem, 1, -1
         Call Free_Work(ip_sq_mu(i-1))
      End Do
      Call Free_Work(ip_Ttot)
      Call Free_Work(ip_Ttot_Inv)
      Call Free_Work(ip_sq_temp)
      Call Free_iWork(ip_center)
*                                                                      *
************************************************************************
*                                                                      *
      Call Allocate_Work(ipPol,6*nij)
      Call Allocate_Work(ipCpl,6*nij)
      Call Allocate_Work(ipCplT,6*nij)

      If (.Not.NoField) Then
*                                                                      *
************************************************************************
*                                                                      *
*        D Y N A M I C   P R O P E R T I E S                           *
*                                                                      *
************************************************************************
*                                                                      *
*        Compute the fluctuating charges
*
         Call Make_Fluctuating_Charges(nAtoms,iWork(ip_ANr),nij,nPert,
     &                                 Work(ipMP),mElem,Work(ip_EC),
     &                                 Alpha)
*                                                                      *
************************************************************************
*                                                                      *
*        Assemble the localized polarizabilities
*
         Call Dynamic_Properties(Work(ip_tmp),nAtoms,Work(ipMP),nij,
     &                           nPert,mElem,Delta,Work(ip_EC),
     &                           Work(ipPol),iWork(ip_ANr),
     &                           Bond_Threshold, Work(ipCpl),
     &                           Work(ipCplT))

*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Print out the properties
*
      Call Get_cArray('LP_L',LblCnt4,(LENIN4)*nAtoms)
      Do i=1,nAtoms
       LblCnt(i)(1:LENIN)=LblCnt4(i)(1:LENIN)
      EndDo
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate arrays needed in Print_Local
*
      nDim = nij*mElem
      Call Allocate_Work(ipxMP,nDim)
      Call Allocate_Work(ipxxMP,nDim)
      Call Allocate_Work(ipnxMP,nDim)
      Call Print_Local(Work(ipMP),nij,mElem,Work(ipC),nAtoms,CoC,
     &                 Work(ipQ_Nuc),lMax,LblCnt,Work(ipMPq),
     &                 Work(ip_EC),Work(ipPol),NoField,Work(ip_Tmp),
     &                 Work(ipxMP),Work(ipxxMP), Work(ipnxMP),
     &                 iWork(ip_ANr),nOcOb,Energy_Without_FFPT,
     &                 ip_Ene_Occ,MpProp_Level,Bond_Threshold,
     &                 XHole,Work(ipXHLoc2),dMolExpec,
     &                 Work(ipCpl), Work(ipCplT), LIonize)

      Call Free_Work(ipxMP)
      Call Free_Work(ipxxMP)
      Call Free_Work(ipnxMP)
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_Work(ipPol)
      Call Free_Work(ipCpl)
      Call Free_Work(ipCplT)

      Call Free_Work(ipQ_Nuc)
      Call Free_Work(ipMPq)
      Call Free_Work(ip_EC)
      Call Free_Work(ipMP)
      Call Free_Work(ip_Tmp)
      Call Free_iWork(ip_ANr)
      Call Free_Work(ipC)
      If(Xhole)Call Free_Work(ipXHLoc2)
      If (nSym.ne.1) Then
         Call Free_Work(ipP)
         Call Free_Work(ipPInv)
      End If
*
* Set flag on runfile to identify that it can be used to restart a
* LoProp calculation in the future.
*
      If (.Not. Restart) Then
         LoProp_Mode = 1
         If (NoField) Then
            LoProp_Mode = 2
         End If
         Call Put_iScalar('LoProp Restart',LoProp_Mode)
      End If
*
*                                                                      *
************************************************************************
*                                                                      *
*     Cleanup so that finish will not scream.
*
      nfld_tim =0
      nfld_stat=0
*                                                                      *
************************************************************************
*                                                                      *
      ireturn=0
*                                                                      *
************************************************************************
*                                                                      *
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Ignacio Fdez. Galvan                             *
!***********************************************************************
! Interfaces to C functions needed to create and remove
! a subdirectory in WorkDir

module subdirs

implicit none
private

character(len=1024) :: Sub, OldWorkDir, NewWorkDir

public :: f_setsubdir, Sub, OldWorkDir, NewWorkDir

contains

subroutine f_setsubdir(sub)
# ifdef _HAVE_EXTRA_
  use, intrinsic :: iso_c_binding, only: c_null_char
  implicit none
  character(len=*), intent(in) :: sub
  interface
    subroutine c_setsubdir(sub) bind(C,name="setsubdir")
      use, intrinsic :: iso_c_binding, only: c_char
      character(kind=c_char) :: sub(*)
    end subroutine c_setsubdir
  end interface
  if (trim(sub) == '') then
    call c_setsubdir(''//c_null_char)
  else
    call c_setsubdir('/'//trim(sub)//c_null_char)
  end if
# else
  use Prgm, only: SetSubDir
  implicit none
  character(len=*), intent(in) :: sub
  if (trim(sub) == '') then
    call SetSubDir('')
  else
    call SetSubDir('/'//trim(sub))
  end if
# endif
end subroutine f_setsubdir

end module subdirs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003, Valera Veryazov                                  *
!               2016,2017, Roland Lindh                                *
!***********************************************************************

subroutine FinalSCF()
!***********************************************************************
!                                                                      *
!     purpose: perform final calculations                              *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Interfaces_SCF, only: dOne_SCF
use OFembed, only: Do_OFemb, FMaux, NDSD
use SpinAV, only: DSc
use InfSCF, only: BName, CMO, Darwin, Dens, DMOMax, Do_Addc, Do_Tw, DSCF, E1V, E2V, EneV, EOrb, Falcon, FMOMax, FockAO, FThr, &
                  iPrForm, iPrint, iStatPrn, kIVO, KntE, KSDFT, MaxBas, MaxBXO, MssVlc, NamFld, nBas, nBB, nBO, nBT, nD, nDel, &
                  nDens, nFld, nFro, nIter, nIterP, nnB, nnO, nOcc, NoProp, nOrb, nSym, OccNo, OneHam, Ovrlp, TimFld, TwoHam
use SCFFiles, only: LuOut
#ifdef _EFP_
use EFP_Module, only: EFP_Instance
use EFP, only: EFP_Shutdown
#endif
#ifdef _HDF5_
use mh5, only: mh5_put_dset
use SCFWFn, only: wfn_mocoef, wfn_mocoef_a, wfn_mocoef_b, wfn_occnum, wfn_occnum_a, wfn_occnum_b, wfn_orbene, wfn_orbene_a, &
                  wfn_orbene_b, wfn_tpidx, wfn_tpidx_a, wfn_tpidx_b
#endif
#ifdef _FDE_
use Embedding_Global, only: embPot, embWriteEsp
use InfSCF, only: nAtoms
#endif
use Molcas, only: MxSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: iBas, iCMO, iD, iFld, iFock, iiOrb, ij, IndType(7,8), iOpt, iOrb, iRC, iRef, iSym, iSymLb, iVirt, iWFType, &
                     jBas, jRef, jVirt, kBas, kl, lk, nFldP, nOccMax(nSym), nOccMin(nSym)
real(kind=wp) :: Dummy(1), TCPU1, TCPU2, TotCpu, TWall1, TWall2
logical(kind=iwp) :: FstItr
character(len=128) :: OrbName
character(len=80) :: Note
character(len=60) :: Frmt
character(len=8) :: Method, RlxLbl, What
real(kind=wp), allocatable :: CMOn(:), DMat(:,:), E_Or(:,:), Epsn(:), Etan(:), GVFck(:,:), Scrt1(:,:), Scrt2(:,:), Temp(:)
logical(kind=iwp), external :: RF_On, Langevin_On, PCM_On
#ifdef _HDF5_
integer(kind=iwp) :: IndTypeT(8,7), nSSh(mxSym), nZero(mxSym)
character, allocatable :: typestring(:)
#endif
#ifdef _EFP_
logical(kind=iwp), external :: EFP_On
#endif

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Read remaining one-electron integrals
call R1IntB()

call CWTime(TCpu1,TWall1)

What = 'COEI'

call SorbCMOs(CMO,nBB,nD,EOrb,OccNo,nnB,nBas,nOrb,nSym)

call Put_darray('SCF orbitals',CMO(1,1),nBB)
if (nD == 2) call Put_darray('SCF orbitals_ab',CMO(1,2),nBB)

if (nIter(nIterP) <= 0) then

  FstItr = .true.
  call SCF_Energy(FstItr,E1V,E2V,EneV)
  Dens(:,:,nDens) = Dens(:,:,1)
  TwoHam(:,:,nDens) = TwoHam(:,:,1)

  DMOMax = Zero
  FMOMax = Zero

else

  ! Compute improved virtuals (if needed)
  if (kIvo == 1) then
    do iD=1,nD
      call IvoGen(OneHam,nBT,CMO(:,iD),nBO,EOrb(:,iD),nnO,nOcc(:,iD))
    end do
  end if

  !------------------------------------------------
  !----- Write stuff for gradient calculation -----
  !------------------------------------------------

  ! Add Fock operator matrix

  ! Note that we need an array with four additional
  ! elements due to the use of WrOne, which adds
  ! four elements for some auxiliary information!

  call mma_allocate(Temp,nBT+4,Label='Temp')
  Temp(:) = Zero

  do iD=1,nD
    Temp(1:nBT) = FockAO(:,iD)
    iRc = -1
    iOpt = 0
    RlxLbl = 'Fock Op '
    if (iD == 2) RlxLbl = 'Fock Op2'
    iSymLb = 1
    call WrOne(iRc,iOpt,RlxLbl,1,Temp,iSymLb)
    if (iRc /= 0) then
      write(u6,*) 'Final: Error writing on ONEINT'
      write(u6,'(A,A)') 'RlxLbl=',RlxLbl
      call Abend()
    end if
  end do
  call mma_deallocate(Temp)

  ! Construct the generalized variational Fock matrix

  call mma_allocate(GVFck,nBT,nD,Label='GVFck')
  call mma_allocate(Scrt1,MaxBas**2,nD,Label='Scrt1')
  call mma_allocate(Scrt2,MaxBxO,nD,Label='Scrt2')

  iFock = 1
  iCMo = 1
  do iSym=1,nSym
    if (nOrb(iSym) <= 0) cycle

    do iD=1,nD
      call Square(FockAO(iFock,iD),Scrt1(1,iD),1,nBas(iSym),nBas(iSym))
      ! Transform to MO basis
      call DGEMM_('T','N',nOrb(iSym),nBas(iSym),nBas(iSym), &
                  One,CMO(iCMo,iD),nBas(iSym), &
                  Scrt1(1,iD),nBas(iSym), &
                  Zero,Scrt2(1,iD),nOrb(iSym))
      call DGEMM_('N','N',nOrb(iSym),nOrb(iSym),nBas(iSym), &
                  One,Scrt2(1,iD),nOrb(iSym), &
                  CMO(iCMo,iD),nBas(iSym), &
                  Zero,Scrt1(1,iD),nOrb(iSym))

      ! Set elements with both indices virtual to zero
      do iVirt=1,nOrb(iSym)-nOcc(iSym,iD)
        jVirt = 1+nOcc(iSym,iD)*nOrb(iSym)+nOcc(iSym,iD)+(iVirt-1)*nOrb(iSym)
        Scrt1(jVirt:jVirt+nOrb(iSym)-nOcc(iSym,iD)-1,iD) = Zero
      end do
      ! Now project back to the SO basis
      call DGEMM_('N','N',nBas(iSym),nOrb(iSym),nOrb(iSym), &
                  One,CMO(iCMo,iD),nBas(iSym), &
                  Scrt1(1,iD),nOrb(iSym), &
                  Zero,Scrt2(1,iD),nBas(iSym))
      call DGEMM_('N','T',nBas(iSym),nBas(iSym),nOrb(iSym), &
                  One,Scrt2(1,iD),nBas(iSym), &
                  CMO(iCMo,iD),nBas(iSym), &
                  Zero,Scrt1(1,iD),nBas(iSym))

      ij = iFock
      do iBas=1,nBas(iSym)
        do jBas=1,iBas-1
          kl = nBas(iSym)*(jBas-1)+iBas
          lk = nBas(iSym)*(iBas-1)+jBas
          GVFck(ij,iD) = Scrt1(kl,iD)+Scrt1(lk,iD)
          ij = ij+1
        end do
        kl = nBas(iSym)*(iBas-1)+iBas
        GVFck(ij,iD) = Scrt1(kl,iD)
        ij = ij+1
      end do

    end do ! iD

    iFock = iFock+nTri_Elem(nBas(iSym))
    iCMo = iCMo+nBas(iSym)*nOrb(iSym)

  end do  ! iSym
  call mma_deallocate(Scrt2)
  call mma_deallocate(Scrt1)

  ! Add elementary info
  Method = 'RHF-SCF '
  if (nD == 2) Method = 'UHF-SCF '

  if (kIvo /= 0) Method = 'IVO-SCF '
  if (KSDFT /= 'SCF') Method = 'KS-DFT  '
  call Put_cArray('Relax Method',Method,8)
  !call Put_Energy(EneV)
  call Store_Energies(1,[EneV],1)
  call Put_dScalar('SCF energy',EneV)
  !if (nD == 2) call Put_dScalar('Ener_ab',EneV_ab)
  call Put_iArray('nIsh',nOcc(1,1),nSym)
  if (nD == 2) call Put_iArray('nIsh_ab',nOcc(1,2),nSym)
  call Put_iArray('nOrb',nOrb,nSym)
  call Put_iArray('nDel',nDel,nSym)
  call Put_iArray('nFroPT',nFro,nSym)    ! for Cholesky-CC
  call Put_iArray('nDelPT',nDel,nSym)    !

  ! Add MO-coefficients
  call Put_dArray('Last orbitals',CMO(1,1),nBB)
  if (nD == 2) call Put_dArray('CMO_ab',CMO(1,2),nBB)

  ! Add one body density matrix in AO/SO basis

  ! If the density matrix is explicitly calculated in the beginning we will
  ! use that one instead.
  if (nIter(nIterP) <= 0) then
    call DensAB(nBT,nDens,nD,Dens)
  else
    call mma_allocate(DMat,nBT,nD,Label='DMat')

    if (nD == 1) then
      call dOne_SCF(nSym,nBas,nOrb,nFro,CMO(:,1),nBB,OccNo(:,1),DMat(:,1),.true.)
    else
      call dOne_SCF(nSym,nBas,nOrb,nFro,CMO(:,1),nBB,OccNo(:,1),DMat(:,1),.true.)
      call dOne_SCF(nSym,nBas,nOrb,nFro,CMO(:,2),nBB,OccNo(:,2),DMat(:,2),.false.)
      call Put_dArray('D1aoVar',Dummy,0) ! Undefined the field.
    end if

    call DensAB(nBT,1,nD,DMat)
    call mma_deallocate(DMat)
  end if

  if (nD == 2) then
    call mma_allocate(CMOn,nBB,Label='CMOn')
    call mma_allocate(Etan,nnB,Label='Etan')
    call mma_allocate(Epsn,nnB,Label='Epsn')
    call NatoUHF(Dens(:,1,1),Dens(:,2,1),FockAO(:,1),FockAO(:,2),nBT,CMO(:,1),nBB,Ovrlp,CMOn,Etan,Epsn,nnB,nSym,nBas,nOrb)
    call PadCMO(CMOn,nSym,nBas,nOrb)
    call PadEor(Etan,nSym,nBas,nOrb)
    call PadEor(Epsn,nSym,nBas,nOrb)
  end if

  ! Add generalized Fock matrix
  if (nD == 2) then
    GVFck(:,1) = GVFck(:,1)+GVFck(:,2)
  else
    GVFck(:,1) = Two*GVFck(:,1)
  end if
  call Put_dArray('FockOcc',GVFck(:,1),nBT)
  call mma_deallocate(GVFck)

  ! Add SCF orbital energies
  call Put_dArray('OrbE',EOrb(:,1),nnB)
  if (nD == 2) call Put_dArray('OrbE_ab',EOrb(:,2),nnB)

  call Put_dScalar('Thrs',Fthr)
end if

#ifdef _FDE_
! Embedding
if (embPot .and. embWriteEsp) call embPotOutput(nAtoms,Dens)
#endif

! t.t.;
! store Fock matrix in Runfile in case of fragment calculation
if (Falcon) then
  !write(u6,*) 'Fock matrix is written in RunFile.'
  !write(u6,*) 'fck:'
  !write(u6,*) 'nbt=',nbt
  !write(u6,*) 'ndens=',ndens
  !write(u6,*) (FockAO(itt),itt=1,nbt)
  call Put_dArray('Fragment_Fock',FockAO(1,1),nBT)
end if

! t.t.; end
! Final printout
! original PrFin was splitted to 3 parts to run in UHF mode

nDel(1:nSym) = nBas(1:nSym)-nOrb(1:nSym)
call PrFin0(Dens(:,1,nDens),Dens(:,nD,nDens),nBT,EOrb(:,1),nnB,CMO(:,1),nBO,KntE)

do iD=1,nD
  call PrFin(OneHam,Ovrlp,Dens(:,iD,nDens),TwoHam(:,iD,nDens),nBT,EOrb(:,iD),OccNo(:,iD),nnB,CMO(:,iD),nBO,Note,iD-1,MssVlc,Darwin)

  call PrFin2(Ovrlp,nBT,OccNo(:,iD),nnB,CMO(:,iD),nBO,Note)
end do

if ((iPrint >= 2) .and. (nD == 2)) &
  call PriMO('Natural orbitals',.true.,.true.,Zero,2.0e9_wp,nSym,nBas,nOrb,BName,Epsn,Etan,CMOn,iPrForm)
! Calculate expectation values
if (.not. NoProp) then
  if (iPrint >= 3) write(u6,'(/6X,A)') 'Expectation values of various operators'
  call Prpt()
end if

! make a fix for energies for deleted orbitals
call mma_allocate(E_Or,nnB,nD,Label='E_Or')

iRef = 1
jRef = 1
do iSym=1,nSym
  iiOrb = nOrb(iSym)-nDel(iSym)
  do iOrb=1,iiOrb
    E_Or(iRef,1:nD) = EOrb(jRef,1:nD)
    iRef = iRef+1
    jRef = jRef+1
  end do
  do iOrb=1,nDel(iSym)
    E_Or(iRef,1:nD) = 1000.0_wp
    iRef = iRef+1
  end do
end do

if (nD == 1) then
  IndType(1,1:nSym) = nFro(1:nSym)
  IndType(2,1:nSym) = nOcc(1:nSym,1)
  IndType(3,1:nSym) = 0
  IndType(4,1:nSym) = 0
  IndType(5,1:nSym) = 0
  IndType(6,1:nSym) = nOrb(1:nSym)-nFro(1:nSym)-nOcc(1:nSym,1)-nDel(1:nSym)
  IndType(7,1:nSym) = nDel(1:nSym)
else
  nOccMax(:) = max(nOcc(1:nSym,1),nOcc(1:nSym,2))
  nOccMin(:) = min(nOcc(1:nSym,1),nOcc(1:nSym,2))
  IndType(1,1:nSym) = nFro(1:nSym)
  IndType(2,1:nSym) = nOccMin(:)
  IndType(3,1:nSym) = 0
  IndType(4,1:nSym) = nOccMax(:)-nOccMin(:)
  IndType(5,1:nSym) = 0
  IndType(6,1:nSym) = nOrb(1:nSym)-nFro(1:nSym)-nOccMax(:)-nDel(1:nSym)
  IndType(7,1:nSym) = nDel(1:nSym)
end if
if (nD == 1) then
  OrbName = 'SCFORB'
  if (KSDFT == 'SCF') then
    iWFtype = 2
  else
    Note = trim(Note)//' / '//trim(KSDFT)
    iWFtype = 3
  end if
  call WrVec_(OrbName,LuOut,What,nD-1,nSym,nBas,nBas,CMO(:,1),Dummy,OccNo(:,1),Dummy,E_Or(:,1),Dummy,IndType,Note,iWFtype)
# ifdef _HDF5_
  nZero = 0
  call mma_allocate(typestring,nnB)
  nSSh(1:nSym) = nBas(1:nSym)-nFro(1:nSym)-nOcc(1:nSym,1)-nDel(1:nSym)
  call orb2tpstr(NSYM,NBAS,NFRO,NOCC(1,1),NZERO,NZERO,NZERO,NSSH,NDEL,typestring)
  call mh5_put_dset(wfn_tpidx,typestring)
  call mma_deallocate(typestring)
  call mh5_put_dset(wfn_mocoef,CMO(1,1))
  call mh5_put_dset(wfn_occnum,OccNo(1,1))
  call mh5_put_dset(wfn_orbene,EOrb(1,1))
# endif
else
  OrbName = 'UHFORB'
  if (KSDFT == 'SCF') then
    iWFtype = 4
  else
    Note = trim(Note)//' / '//trim(KSDFT)
    iWFtype = 5
  end if
  call WrVec_(OrbName,LuOut,What,nD-1,nSym,nBas,nBas,CMO(:,1),CMO(:,2),OccNo(:,1),OccNo(:,2),E_Or(:,1),E_Or(:,2),IndType,Note, &
              iWFtype)
# ifdef _HDF5_
  nZero = 0
  call mma_allocate(typestring,nnB)
  nSSh(1:nSym) = nBas(1:nSym)-nFro(1:nSym)-nOcc(1:nSym,1)-nDel(1:nSym)
  call orb2tpstr(NSYM,NBAS,NFRO,NOCC(1,1),NZERO,NZERO,NZERO,NSSH,NDEL,typestring)
  call mh5_put_dset(wfn_tpidx_a,typestring)
  nSSh(1:nSym) = nBas(1:nSym)-nFro(1:nSym)-nOcc(1:nSym,2)-nDel(1:nSym)
  call orb2tpstr(NSYM,NBAS,NFRO,NOCC(1,2),NZERO,NZERO,NZERO,NSSH,NDEL,typestring)
  call mh5_put_dset(wfn_tpidx_b,typestring)
  call mh5_put_dset(wfn_mocoef_a,CMO(1,1))
  call mh5_put_dset(wfn_occnum_a,OccNo(1,1))
  call mh5_put_dset(wfn_orbene_a,EOrb(1,1))
  call mh5_put_dset(wfn_mocoef_b,CMO(1,2))
  call mh5_put_dset(wfn_occnum_b,OccNo(1,2))
  call mh5_put_dset(wfn_orbene_b,EOrb(1,2))
# endif
  iBas = 0
  IndType(1,1:nSym) = nFro(1:nSym)
  IndType(2,1:nSym) = 0
  IndType(3,1:nSym) = 0
  IndType(4,1:nSym) = 0
  IndType(5,1:nSym) = 0
  IndType(6,1:nSym) = nOrb(1:nSym)-nFro(1:nSym)-nDel(1:nSym)
  IndType(7,1:nSym) = nDel(1:nSym)
  do iSym=1,nSym
    do kBas=1,nBas(iSym)
      iBas = iBas+1
      if (Etan(iBas) > 1.99_wp) then
        IndType(2,iSym) = IndType(2,iSym)+1
        IndType(6,iSym) = IndType(6,iSym)-1
      else if (Etan(iBas) > 0.01_wp) then
        IndType(4,iSym) = IndType(4,iSym)+1
        IndType(6,iSym) = IndType(6,iSym)-1
      end if
    end do
  end do
  OrbName = 'UNAORB'
  Note = 'UHF natural orbitals'
  if (KSDFT == 'SCF') then
    iWFtype = 6
  else
    iWFtype = 7
  end if
  call WrVec_(OrbName,LuOut,What,0,nSym,nBas,nBas,CMOn,Dummy,Etan,Dummy,Epsn,Dummy,IndType,Note,iWFtype)
# ifdef _HDF5_
  IndTypeT = transpose(IndType)
  call orb2tpstr(NSYM,NBAS,NFRO,IndTypeT(:,2),NZERO,IndTypeT(:,4),NZERO,IndTypeT(:,6),NDEL,typestring)
  call mh5_put_dset(wfn_tpidx,typestring)
  call mma_deallocate(typestring)
  call mh5_put_dset(wfn_mocoef,CMOn)
  call mh5_put_dset(wfn_occnum,Etan)
  call mh5_put_dset(wfn_orbene,Epsn)
# endif
  call mma_deallocate(Epsn)
  call mma_deallocate(Etan)
  call mma_deallocate(CMOn)
end if

call mma_deallocate(E_Or)

! release Buffers for semi-direct SCF
if (DSCF) call ClsBuf()
! release SEWARD
if (DSCF .or. RF_On() .or. Langevin_On() .or. PCM_On() .or. Do_OFemb .or. Do_Tw .or. Do_Addc .or. &
#   ifdef _EFP_
    EFP_On() .or. &
#   endif
    (KSDFT /= 'SCF')) call ClsSew()

call mma_deallocate(FMaux,safe='*')
call mma_deallocate(NDSD,safe='*')
call mma_deallocate(DSc,safe='*')
#ifdef _EFP_
if (EFP_On()) call EFP_ShutDown(EFP_Instance)
#endif

call CWTime(TCpu2,TWall2)
TimFld(15) = TimFld(15)+(TCpu2-TCpu1)
TotCpu = max(TCpu2,0.1_wp)

! Write out timing informations
if (.not. NoProp) then
  nFldP = nFld-1
else
  nFldP = nFld-2
end if
Frmt = '(2x,A)'
if (iStatPRN > 0) then
  write(u6,*)
  call CollapseOutput(1,'Statistics and timing')
  write(u6,'(3X,A)') '---------------------'
  write(u6,*)
  write(u6,Frmt) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,Frmt) '   Part of the program                              CPU    fraction'
  write(u6,Frmt) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
  do iFld=1,nFldP
    if ((iFld == 3) .or. (iFld == 4)) cycle
    write(u6,'(2x,A45,2f10.2)') NamFld(iFld),TimFld(iFld),TimFld(iFld)/TotCpu
  end do
  write(u6,*)
  write(u6,'(2x,A45,2F10.2)') NamFld(nFld),TotCpu
  write(u6,Frmt) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
  call CollapseOutput(0,'Statistics and timing')
  write(u6,*)
end if

end subroutine FinalSCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_XCV_RdVec(irc,Vec,l_Vec,NVT,myRankSP,n_myRankSP,
     &                         J1,J2,iSym)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: Read partial Cholesky vectors J1 to J2 on disk.
C              (Parallel two-step algorithm)
C
#if defined (_DEBUGPRINT_)
      use ChoSwp, only: nnBstRSh
#endif
      Implicit None
      Integer irc
      Integer l_Vec
      Real*8  Vec(l_Vec)
      Integer NVT
      Integer n_myRankSP
      Integer myRankSP(n_myRankSP)
      Integer J1, J2, iSym

#if defined (_DEBUGPRINT_)
#include "cho_para_info.fh"
#include "cholesky.fh"

      Integer i, n
#endif

      irc=0
      If (n_myRankSP.eq.0 .or. (J2-J1+1).eq.0) Then
         Return ! nothing to do
      End If

#if defined (_DEBUGPRINT_)
      If (n_myRankSP.lt.1 .or. n_myRankSP.gt.nnShl .or. iSym.lt.1 .or.
     &    iSym.gt.nSym .or. NVT.lt.1) Then
         irc=-1
         Return
      End If
      If (J1.lt.1 .or. J1.gt.NVT .or. J2.lt.1 .or. J2.gt.NVT .or.
     &    J1.gt.J2 .or. (J2-J1+1).gt.NVT) Then
         irc=-2
         Return
      End If
      n=nnBstRSh(iSym,myRankSP(1),2)*(J2-J1+1)
      Do i=2,n_myRankSP
         n=n+nnBstRSh(iSym,myRankSP(i),2)*(J2-J1+1)
      End Do
      If (l_Vec.lt.n) Then
         irc=-3
         Return
      End If

      If (.not.Cho_Real_Par) Then
         If (NVT.ne.NumCho(iSym)) Then
            irc=-4
            Return
         End If
         n=0
         Do i=1,n_myRankSP
            If (myRankSP(i).ne.i) Then
               n=n+1
            End If
         End Do
         If (n.ne.0) Then
            irc=-5
            Return
         End If
      End If
#endif

      ! Block read on temp files
      Call Cho_XCV_RdVec_(irc,Vec,myRankSP,n_myRankSP,NVT,J1,J2,iSym)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C BLOCK READ
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SubRoutine Cho_XCV_RdVec_(irc,Vec,myRankSP,n_myRankSP,NVT,
     &                          J1,J2,iSym)
C
C     Read the vector blocks.
C
      use ChoSwp, only: nnBstRSh
      Implicit None
      Integer irc
      Real*8  Vec(*)
      Integer n_myRankSP
      Integer myRankSP(n_myRankSP)
      Integer NVT
      Integer J1, J2, iSym
#include "cholesky.fh"

      Integer iOpt
      Parameter (iOpt=2)

      Integer kV, n, i
      Integer lTot, iAdr, iAdr0
      Integer iSP

      irc=0

      n=J2-J1+1
      iAdr0=0
      kV=1
      Do i=1,n_myRankSP
         iSP=myRankSP(i)
         lTot=nnBstRSh(iSym,iSP,2)*n
         If (lTot.gt.0) Then
            iAdr=iAdr0+nnBstRSh(iSym,iSP,2)*(J1-1)
            Call DDAFile(LuTmp(iSym),iOpt,Vec(kV),lTot,iAdr)
            kV=kV+lTot
         End If
         iAdr0=iAdr0+nnBstRSh(iSym,iSP,2)*NVT
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Per-Olof Widmark                                 *
*               1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine iRdOne(rc,Option,InLab,Comp,Data,SymLab)
************************************************************************
*                                                                      *
*     Purpose: Read data from one-electron integral file               *
*                                                                      *
*     Calling parameters:                                              *
*     rc      : Return code                                            *
*     Option  : Switch to set options                                  *
*     InLab   : Identifier for the data to read                        *
*     Comp    : Composite identifier to select components              *
*     Data    : contains on output the requested data                  *
*     SymLab  : symmetry label of the requested data                   *
*                                                                      *
*     Global data declarations (Include file):                         *
*     Parm    : Table of paramaters                                    *
*     rcParm  : Table of return codes                                  *
*     Switch  : Table of options                                       *
*     Common  : Common block containing ToC                            *
*     Data    : Data definitions                                       *
*                                                                      *
*     Local data declarations:                                         *
*     Label   : character*8, used to covert incoming names             *
*     TmpBuf  : I/O buffer                                             *
*     HldBuf  : I/O buffer                                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark and M.P. Fuelscher                                  *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
#include "OneRc.fh"
#include "OneFlags.fh"

#include "OneDat.fh"
*
      Character*(*) InLab
      Dimension Data(*)
*
      Character*8 TmpLab,Label
*     Dimension LabTmp(2)
*     Equivalence (TmpLab,LabTmp)
*
      Parameter (lBuf=1024)
      Real*8    TmpBuf(lBuf),AuxBuf(4)
      Logical debug, Close
      Data CurrOp/1/
      Save CurrOp
*----------------------------------------------------------------------*
*     Start procedure:                                                 *
*     Define inline function (symmetry multiplication)                 *
*----------------------------------------------------------------------*
      MulTab(i,j)=iEor(i-1,j-1)+1
*----------------------------------------------------------------------*
*     Pick up the file definitions                                     *
*----------------------------------------------------------------------*
      rc    = rc0000
      LuOne = AuxOne(pLu  )
      Open  = AuxOne(pOpen)
*----------------------------------------------------------------------*
*     Check the file status                                            *
*----------------------------------------------------------------------*
      Close=.False.
      If ( Open.ne.1 ) Then
*        Write (*,*) ' I will open the file for you!'
*
*------- Well, I'll open and close it for you under the default name
*
         LuOne=77
         LuOne=isFreeUnit(LuOne)
         Label='ONEINT  '
*        Write(*,*) 'RdOne: opening OneInt'
         iRC=-1
         iOpt=0
         Call OpnOne(iRC,iOpt,Label,LuOne)
         If (iRC.ne.0) Then
            Write (6,*) 'RdOne: Error opening file'
            Call Abend
         End If
         Close=.True.
      End If
*----------------------------------------------------------------------*
*     Truncate the label to 8 characters and convert it to upper case  *
*----------------------------------------------------------------------*
      Label=InLab
      Call UpCase(Label)
      TmpLab=Label
*----------------------------------------------------------------------*
*     Print debugging information                                      *
*----------------------------------------------------------------------*
      debug=.false.
      If(iAnd(option,1024).ne.0) debug=.true.
      If(debug) Then
         Write(6,*) '<<< Entering RdOne >>>'
         Write(6,'(a,z8)') ' rc on entry:     ',rc
         Write(6,'(a,a)')  ' Label on entry:  ',Label
         Write(6,'(a,z8)') ' Comp on entry:   ',Comp
         Write(6,'(a,z8)') ' SymLab on entry: ',SymLab
         Write(6,'(a,z8)') ' Option on entry: ',Option
      End If
*----------------------------------------------------------------------*
*     Check reading mode                                               *
*----------------------------------------------------------------------*
      If((iAnd(iAnd(option,sRdFst),sRdNxt)).ne.0) then
         Write (6,*) 'RdOne: Invalid option(s)'
         Write (6,*) 'option=',option
         Call Abend()
      Else If((iAnd(iAnd(option,sRdFst),sRdCur)).ne.0) then
         Write (6,*) 'RdOne: Invalid option(s)'
         Write (6,*) 'option=',option
         Call Abend()
      Else If((iAnd(iAnd(option,sRdNxt),sRdCur)).ne.0) then
         Write (6,*) 'RdOne: Invalid option(s)'
         Write (6,*) 'option=',option
         Call Abend()
      End If
*----------------------------------------------------------------------*
*     Load back TocOne                                                 *
*----------------------------------------------------------------------*
      iDisk=0
      Call iDaFile(LuOne,2,TocOne,lToc,iDisk)
*----------------------------------------------------------------------*
*     Read data from ToC                                               *
*----------------------------------------------------------------------*
      NoGo=sRdFst+sRdNxt+sRdCur
*----------------------------------------------------------------------*
*     Read operators from integral records                             *
*----------------------------------------------------------------------*
      If (iAnd(option,sRdNxt).ne.0) Then
         CurrOp=CurrOp+1
         If (CurrOp.gt.MxOp) Then
            CurrOp=0
         Else If(TocOne(pOp+LenOp*(CurrOp-1)+oLabel).eq.Nan) Then
            CurrOp=0
         Else
            i=CurrOp
*            LabTmp(1)=TocOne(pOp+LenOp*(i-1)+oLabel  )
*#ifndef _I8_
*            LabTmp(2)=TocOne(pOp+LenOp*(i-1)+oLabel+1)
*#endif
            Call ByteCopy(TocOne(pOp+LenOp*(i-1)+oLabel),TmpLab,8)
            Label=TmpLab
            InLab=Label
            SymLab=TocOne(pOp+LenOp*(i-1)+oSymLb)
            Comp=TocOne(pOp+LenOp*(i-1)+oComp   )
         End If
      Else If(iAnd(option,sRdFst).ne.0) Then
         CurrOp=1
         If(TocOne(pOp+LenOp*(CurrOp-1)+oLabel).eq.Nan) Then
            CurrOp=0
         Else
            i=CurrOp
*            LabTmp(1)=TocOne(pOp+LenOp*(i-1)+oLabel  )
*#ifndef _I8_
*            LabTmp(2)=TocOne(pOp+LenOp*(i-1)+oLabel+1)
*#endif
            Call ByteCopy(TocOne(pOp+LenOp*(i-1)+oLabel),TmpLab,8)
            Label=TmpLab
            InLab=Label
            SymLab=TocOne(pOp+LenOp*(i-1)+oSymLb)
            Comp=TocOne(pOp+LenOp*(i-1)+oComp   )
         End If
      Else If(iAnd(option,sRdCur).ne.0) Then
         If(CurrOp.lt.1 .or. CurrOp.gt.MxOp) Then
            CurrOp=0
         Else If(TocOne(pOp+LenOp*(CurrOp-1)+oLabel).eq.Nan) Then
            CurrOp=0
         Else
            i=CurrOp
*            LabTmp(1)=TocOne(pOp+LenOp*(i-1)+oLabel  )
*#ifndef _I8_
*            LabTmp(2)=TocOne(pOp+LenOp*(i-1)+oLabel+1)
*#endif
            Call ByteCopy(TocOne(pOp+LenOp*(i-1)+oLabel),TmpLab,8)
            Label=TmpLab
            InLab=Label
            SymLab=TocOne(pOp+LenOp*(i-1)+oSymLb)
            Comp=TocOne(pOp+LenOp*(i-1)+oComp   )
         End If
      Else
         CurrOp=0
         Do 500 i=MxOp,1,-1
*            LabTmp(1)=TocOne(pOp+LenOp*(i-1)+oLabel  )
*#ifndef _I8_
*            LabTmp(2)=TocOne(pOp+LenOp*(i-1)+oLabel+1)
*#endif
            Call ByteCopy(TocOne(pOp+LenOp*(i-1)+oLabel),TmpLab,8)
            CmpTmp=TocOne(pOp+LenOp*(i-1)+oComp   )
            TmpCmp=Comp
            If(TmpLab.eq.Label .and. CmpTmp.eq.TmpCmp) CurrOp=i
500      Continue
      End If
      If(CurrOp.eq.0) Then
         rc=rcRD03
*        Write (*,*) 'RdOne: Information not available'
*        Write (*,*) 'Option=',Option
*        Write (*,*) 'Comp=',Comp
*        Write (*,*) 'SymLab=',SymLab
*        Write (*,*) 'Label=',Label
         Go To 999
      End If
      SymLab=TocOne(pOp+LenOp*(CurrOp-1)+oSymLb)
      Len=0
      Do 510 i=1,nSym
      Do 511 j=1,i
         ij=MulTab(i,j)-1
         If(iAnd(2**ij,SymLab).ne.0) Then
            If(i.eq.j) Then
               Len=Len+nBas(i)*(nBas(i)+1)/2
            Else
               Len=Len+nBas(i)*nBas(j)
            End If
         End If
511   Continue
510   Continue
      Data(1)=Len
      If ( IAND(option,sOpSiz).eq.0 ) Then
         IndAux = 0
         IndDta = 0
         iDisk=TocOne(pOp+LenOp*(CurrOp-1)+oAddr)
         Do i = 0,Len+3,lBuf
           nCopy  = MAX(0,MIN(lBuf,Len+4-i))
           nSave  = MAX(0,MIN(lBuf,Len-i))
           Call dDaFile(LuOne,2,TmpBuf,nCopy,iDisk)
           Call idCopy(nSave,TmpBuf,1,Data(IndDta+1),1)
           IndDta = IndDta+RtoI*nSave
           Do j = nSave+1,nCopy
             IndAux = IndAux+1
*            AuxBuf(IndAux) = TmpBuf(nSave+IndAux)
             AuxBuf(IndAux) = TmpBuf(j)
           End Do
         End Do
         If(iAnd(sNoOri,option).eq.0) Then
            Call idCopy(3,AuxBuf,1,Data(IndDta+1),1)
         End If
         If(iAnd(sNoNuc,option).eq.0) Then
            Call idCopy(1,AuxBuf(4),1,Data(IndDta+RtoI*3+1),1)
         End If
      End If
*
 999  Continue
      If (Close) Then
*        Write (*,*) ' I will close the file for you!'
         iRC=-1
         iOpt=0
         Call ClsOne(iRC,iOpt)
         If (iRC.ne.0) Then
            Write (6,*) 'RdOne: Error closing file'
            Call Abend
         End If
      End If
*----------------------------------------------------------------------*
*     Terminate procedure                                              *
*----------------------------------------------------------------------*
      Return
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine idCopy(n,Src,n1,Dst,n2)
      Use iso_c_binding
      Integer, Target :: Dst(*)
      Real*8, Pointer :: dDst(:)
      Real*8 :: Src(*)
      Integer :: n,n1,n2
      Call c_f_pointer(c_loc(Dst),dDst,[n])
      Call dCopy_(n,Src,n1,dDst,n2)
      Nullify(dDst)
      End Subroutine idCopy
*
      End

      Subroutine RdOne(rc,Option,InLab,Comp,Data,SymLab)
      Implicit Integer (A-Z)
*
      Character*(*) InLab
      Real*8 Data(*)
*
      Call RdOne_Internal(Data)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine RdOne_Internal(Data)
      Use Iso_C_Binding
      Real*8, Target :: Data(*)
      Integer, Pointer :: iData(:)
      Call C_F_Pointer(C_Loc(Data(1)),iData,[1])
      Call iRdOne(rc,Option,InLab,Comp,iData,SymLab)
      Nullify(iData)
      return
      End Subroutine RdOne_Internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1992, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CmbnRF(Rnxyz,nZeta,la,lb,lr,Zeta,rKappa,rFinal,nComp,Fact,Temp)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             Modified for reaction field calculations July '92        *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1, nTri3_Elem
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, lr, nComp
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la,0:lb,0:lr), Zeta(nZeta), rKappa(nZeta)
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nComp), Fact(nZeta), Temp(nZeta)
integer(kind=iwp) :: iComp, ipa, ipb, ir, ix, ixa, ixb, iy, iya, iyaMax, iyb, iybMax, iz, iza, izb

Fact(:) = rKappa(:)*sqrt(Zeta(:)**(-3))
do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)
#       ifdef _DEBUGPRINT_
        write(u6,*) ixa,iya,iza,ixb,iyb,izb
        write(u6,*) ipa,ipb
#       endif

        ! Combine multipole moment integrals

        do ix=0,lr
          do iy=0,lr-ix
            Temp(:) = Fact(:)*Rnxyz(:,1,ixa,ixb,ix)*Rnxyz(:,2,iya,iyb,iy)
            do ir=ix+iy,lr
              iz = ir-ix-iy
              iComp = C_Ind(ir,ix,iz)+nTri3_Elem(ir)
              rFinal(:,ipa,ipb,iComp) = Temp(:)*Rnxyz(:,3,iza,izb,iz)
            end do
          end do
        end do

      end do
    end do
  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt('Final',' ',rFinal,nZeta*nTri_Elem1(la)*nTri_Elem1(lb),nComp)
#endif

return

end subroutine CmbnRF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Trans(A,n,m,B)
*
      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
      Real*8 A(n,m), B(m,n)
*
      Do i=1, m
         Do j=1, n
            B(i,j) = A(j,i)
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine SavTim(iFld,TCPU,TWall)
      Use Para_Info, Only: MyRank
      Implicit Real*8 (a-h,o-z)
#include "timtra.fh"
#include "WrkSpc.fh"
*
      if(nfld_tim.eq.0) return
      If (iFld.gt.nfld_tim) Then
         Call WarningMessage(2,'SavTim: iFld.gt.nfld_tim')
         Write (6,*) 'iFld=',iFld
         Write (6,*) 'nFld_tim=',nFld_tim
         Call Abend()
      End If
      iad=iGATim+myrank*nFld_Tim*2+iFld-1
      Work(iad)=Work(iad)+TCPU
      Work(iad+nFld_Tim)=Work(iad+nFld_Tim)+TWall
      Return
      End
      SubRoutine SavStat(iFld,Value,op)
      Use Para_Info, Only: MyRank
      Implicit Real*8 (a-h,o-z)
      character*(*) op
#include "timtra.fh"
#include "WrkSpc.fh"
*
      if(nfld_stat.eq.0) return
      If (iFld.gt.nfld_Stat) Then
         Call WarningMessage(2,'SavStat: iFld.gt.nfld_stat')
         Write (6,*) 'iFld=',iFld
         Write (6,*) 'nFld_Stat=',nFld_Stat
         Call Abend()
      End If
      iad=iGAStat+myrank*nFld_stat+iFld-1
      if(op.eq.'+') then
        Work(iad)=Work(iad)+Value
      else if(op.eq.'-') then
        Work(iad)=Work(iad)-Value
      else if(op.eq.'=') then
        Work(iad)=Value
      end if
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine creates a symmetric ON basis a la Lowdin                *
* Not true if orbitals are deleted.                                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: Oct 2004                                                    *
*                                                                      *
************************************************************************
      Subroutine goLowdin(CMO)
      Implicit None
#include "Molcas.fh"
#include "stdalloc.fh"
#include "commgo.fh"
*----------------------------------------------------------------------*
* Dummy variables.                                                     *
*----------------------------------------------------------------------*
      Real*8 CMO(*)
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Logical Debug
      Logical Trace
      Integer nBig
      Integer nTot
      Integer nTri
      Integer nTriTot
      Integer iSym
      Integer iBas
      Integer jBas
      Integer kBas
      Integer iOrb
      Integer ipOvl(8)
      Integer ipCMO
      Integer npSmat
      Integer irc
      Integer iSymlb
      Real*8 Temp, OrbPhase
      Real*8, Dimension(:), Allocatable :: Ovl, SMat, Vec, Eig
      Real*8, Dimension(:,:), Allocatable :: Tmp
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Debug=.false.
      Trace=.false.
      If(Trace) Write(6,*) '>>> Entering golowdin'
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      nBig=0
      nTot=0
      nTriTot=0
      Do iSym=1,nSym
         nTot=nTot+nBas(iSym)
         nTriTot=nTriTot+nBas(iSym)*(nBas(iSym)+1)/2
         If(nBig.lt.nBas(iSym)) nBig=nBas(iSym)
      End Do
*----------------------------------------------------------------------*
* Get overlap matrix                                                   *
*----------------------------------------------------------------------*
      npSmat=nBig*nBig
      Call mma_allocate(Ovl,nTriTot+4)
      ipOvl(1)=1
      Call mma_allocate(Smat,npSmat)
      iSymlb=1
      Call RdOne(irc,2,'Mltpl  0',1,Ovl,iSymlb)
      Do iSym=1,nSym-1
         ipOvl(iSym+1)=ipOvl(iSym)+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Call mma_allocate(Vec,nBig**2)
      Call mma_allocate(Eig,nBig)

      ipCMO=1
      Do iSym=1,nSym
         nTri=nBas(iSym)*(nBas(iSym)+1)/2
         Call dCopy_(nTri,Ovl(ipOvl(iSym)),1,Smat,1)
         If(Debug) Then
            Write(6,*)
            Write(6,*) '***'
            Write(6,*) '*** lowdin: symmetry',iSym
            Write(6,*) '***'
            Write(6,*)
            Call TriPrt('Overlap matrix','(12f18.12)',
     &                  Ovl(ipOvl(iSym)),nBas(iSym))
         End If
         Call FZero(Vec,nBas(iSym)**2)
         Call DCopy_(nBas(iSym),[1.0D0],0,Vec,nBas(iSym)+1)
         Call NIdiag_New(Ovl(ipOvl(iSym)),Vec,nBas(iSym),nbas(iSym),0)
*
         Do iBas = 1, nBas(iSym)
            temp=OrbPhase(Vec((iBas-1)*nBas(iSym)+1),nBas(iSym))
         End Do
*
         If(Debug) Then
            Call RecPrt('Transformation','(12f18.12)',
     &                  Vec,nBas(iSym),nBas(iSym))
         End If
         Call goPickUp(Ovl(ipOvl(iSym)),Eig,nBas(iSym))
         If(Debug) Then
            Call RecPrt('Overlap eigenvalues before sort','(12f18.12)',
     &         Eig,1,nBas(iSym))
         End If
         Do iBas=1,nBas(iSym)
            Eig(iBas)=-Eig(iBas)
         End Do
         Call goSort(Eig,Vec,nBas(iSym),nBas(iSym))
         Do iBas=1,nBas(iSym)
            Eig(iBas)=-Eig(iBas)
         End Do
         If(Debug) Then
            Call RecPrt('Overlap eigenvalues after sort','(12f18.12)',
     &         Eig,1,nBas(iSym))
         End If
         nDel(iSym)=0
         Do iBas=1,nBas(iSym)
            If(Eig(iBas).lt.SThr) nDel(iSym)=nDel(iSym)+1
         End Do
         Do iBas=1,nBas(iSym)
            Eig(iBas)=1.0d0/sqrt(Eig(iBas))
         End Do
         If(.false.) Then
            Do iBas=1,nBas(iSym)
               Do jBas=1,nBas(iSym)
                  Temp=0.0d0
                  Do kBas=1,nBas(iSym)
                     Temp=Temp + Eig(kBas)
     &                        *Vec(nBas(iSym)*(kBas-1)+iBas)
     &                        *Vec(nBas(iSym)*(kBas-1)+jBas)
                  End Do
                  CMO(ipCMO+nBas(iSym)*(jBas-1)+(iBas-1))=Temp
               End Do
            End Do
         Else
            Call dCopy_(nBas(iSym)*nBas(iSym),Vec,1,CMO(ipCMO),1)
            Do iOrb=1,nBas(iSym)
               Temp=Eig(iOrb)
               Do iBas=1,nBas(iSym)
                  CMO(ipCMO-1+iBas+nBas(iSym)*(iOrb-1))=
     &               Temp*CMO(ipCMO-1+iBas+nBas(iSym)*(iOrb-1))
               End Do
            End Do
         End If
         If(Debug) Then
            Call RecPrt('Symmetric orbitals','(12f18.12)',
     &                  CMO(ipCMO),nBas(iSym),nBas(iSym))
         End If
         If(Debug) Then
            Call mma_allocate(Tmp,nBas(iSym),nBas(iSym))
            iSymlb=1
            Call RdOne(irc,2,'Mltpl  0',1,Ovl(ipOvl(1)),iSymlb)
            Do iBas=1,nBas(iSym)
               Do jBas=1,nBas(iSym)
                  Temp=0.0
                  Do kBas=1,nBas(iSym)
                     Temp=Temp+ CMO(ipCMO+nBas(iSym)*(kBas-1)+(iBas-1))
     &                       *CMO(ipCMO+nBas(iSym)*(jBas-1)+(kBas-1))
                  End Do
                  Tmp(iBas,jBas)=Temp
               End Do
            End Do
            Call RecPrt('Inverted overlap matrix','(12f18.12)',
     &                  Tmp,nBas(iSym),nBas(iSym))
            Call mma_deallocate(Tmp)
         End If
         ipCMO=ipCMO+nBas(iSym)*nBas(iSym)
      End Do


      Call mma_deallocate(Eig)
      Call mma_deallocate(Vec)
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Call mma_deallocate(Smat)
      Call mma_deallocate(Ovl)
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      If(Trace) Write(6,*) '<<< Exiting golowdin'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefParo3v3(NvGrp,maxdim)
! This routine does:
! define parameters in o3v3.fh using NvGrp,maxdim
!
! I/O parameter description:
! NvGrp    - # of groups in a,b,be,ga set (I)
! maxdim   - # maximal dimension of (a,b,be,ga)" Groups(O)

use chcc_global, only: DimGrpv, I1Name, I2Name, I3Name, L1Name, L2Name, maxGrp, nv, T2Name, Tmp1Name, Tmp2Name
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NvGrp
integer(kind=iwp), intent(out) :: maxdim
integer(kind=iwp) :: i, j, Low(MaxGrp), Up(MaxGrp)
real(kind=wp) :: rdim

!1 define parameters of Groups of v set

rdim = real(nv,kind=wp)/real(NvGrp,kind=wp)

do i=1,NvGrp

  if (i == 1) then
    Up(i) = int(rdim*i)
    Low(i) = 1
  else if (i == NvGrp) then
    Up(i) = nv
    Low(i) = Up(i-1)+1
  else
    Up(i) = int(rdim*i)
    Low(i) = Up(i-1)+1
  end if

  DimGrpv(i) = (Up(i)-Low(i))+1

end do

!5 find maximal dimensions of v'

maxdim = DimGrpv(1)
do i=1,NvGrp
  if (DimGrpv(i) > maxdim) maxdim = DimGrpv(i)
end do

!6.1 def L2Name, T2Name, I2Name,I3Name,Tmp1Name,Tmp2Name

do i=1,MaxGrp
  do j=1,MaxGrp
    call DefParo3v3Hlp1(i,j,'L2',L2Name(i,j))
    call DefParo3v3Hlp1(i,j,'T2',T2Name(i,j))
    call DefParo3v3Hlp1(i,j,'I2',I2Name(i,j))
    call DefParo3v3Hlp1(i,j,'I3',I3Name(i,j))
    call DefParo3v3Hlp1(i,j,'X1',Tmp1Name(i,j))
    call DefParo3v3Hlp1(i,j,'X2',Tmp2Name(i,j))
  end do
end do

!6.2 def L1Name,I1Name

do i=1,MaxGrp
  call DefParo3v3Hlp2(i,'L1vc',L1Name(i))
  call DefParo3v3Hlp2(i,'I1in',I1Name(i))
end do

return

end subroutine DefParo3v3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_T_pair_mould

use fmm_global_paras, only: INTK, gen_mm_paras, LHS_RHS_type, T_pair_single, scheme_paras, LHS_raw_RHS_raw, LHS_box_RHS_box, One
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_init_T_pair_mould, &
          fmm_close_T_pair_mould

integer(INTK), save :: LHS_LMAX, RHS_LMAX
! flag to test initialisation
character(len=11), save :: fmm_init_mould

contains

!-------------------------------------------------------------------------------

subroutine fmm_close_T_pair_mould()

  implicit none
  if (fmm_init_mould /= 'initialised') call fmm_quit('mm_T_pair_mould init')
  fmm_init_mould = ' '
  LHS_LMAX = 0
  RHS_LMAX = 0

end subroutine fmm_close_T_pair_mould

!-------------------------------------------------------------------------------

subroutine fmm_set_T_pair_basics(LHS,RHS,id,weight,T_pair)

# include "macros.fh"

  implicit none
  type(gen_mm_paras), intent(in)   :: LHS, RHS
  type(LHS_RHS_type), intent(in)   :: id
  integer(INTK), intent(in)        :: weight
  type(T_pair_single), intent(out) :: T_pair

  unused_var(LHS)
  unused_var(RHS)
  unused_var(id)

  T_pair%N_or_T = 'N' ! not used for T contractions, so null
  ! init. normalisation scalar for other options
  T_pair%paras%ratio = one
  ! here, T_pair%r_ab is the unnormalised vector

  ! weighting to account for double-counting in T-pair generation
  T_pair%paras%weight = weight

  T_pair%LMAX = max(T_pair%paras%LHS_LMAX,T_pair%paras%RHS_LMAX)
  T_pair%lm_max = (1+T_pair%LMAX)**2

end subroutine fmm_set_T_pair_basics

!-------------------------------------------------------------------------------

subroutine fmm_set_RR_paras(LHS,RHS,id,T_pair)

  implicit none
  type(gen_mm_paras), intent(in)   :: LHS, RHS
  type(LHS_RHS_type), intent(in)   :: id
  type(T_pair_single), intent(out) :: T_pair

  ! interaction vector for building T-matrix
  T_pair%r_ab = RHS%raw_paras(id%RHS)%cntr-LHS%raw_paras(id%LHS)%cntr
  ! indices to map back to actual moments in separate array
  T_pair%paras%LHS_id = LHS%raw_paras(id%LHS)%id
  T_pair%paras%RHS_id = RHS%raw_paras(id%RHS)%id
  ! check that paras:moments mapping was built
  if (T_pair%paras%LHS_id == 0) call fmm_quit('LHS paras:moments mapping')
  if (T_pair%paras%RHS_id == 0) call fmm_quit('RHS paras:moments mapping')

end subroutine fmm_set_RR_paras

!-------------------------------------------------------------------------------

subroutine fmm_set_BB_paras(LHS,RHS,id,T_pair)

  implicit none
  type(gen_mm_paras), intent(in)   :: LHS, RHS
  type(LHS_RHS_type), intent(in)   :: id
  type(T_pair_single), intent(out) :: T_pair

  ! interaction vector for building T-matrix
  T_pair%r_ab = RHS%box_paras(id%RHS)%cntr-LHS%box_paras(id%LHS)%cntr
  ! indices to map back to actual moments in separate array
  T_pair%paras%LHS_id = LHS%box_paras(id%LHS)%id
  T_pair%paras%RHS_id = RHS%box_paras(id%RHS)%id
  ! check that paras:moments mapping was built
  if (T_pair%paras%LHS_id == 0) call fmm_quit('LHS paras:moments mapping')
  if (T_pair%paras%RHS_id == 0) call fmm_quit('RHS paras:moments mapping')

end subroutine fmm_set_BB_paras

!-------------------------------------------------------------------------------

subroutine fmm_set_LHS_LMAX(X,Y,T_pair)

# include "macros.fh"

  implicit none
  type(gen_mm_paras), intent(in)   :: X        ! dummy variables
  type(LHS_RHS_type), intent(in)   :: Y        ! dummy variables
  type(T_pair_single), intent(out) :: T_pair

  unused_var(X)
  unused_var(Y)

  T_pair%paras%LHS_LMAX = LHS_LMAX

end subroutine fmm_set_LHS_LMAX

!-------------------------------------------------------------------------------

subroutine fmm_set_RHS_LMAX(X,Y,T_pair)

# include "macros.fh"

  implicit none
  type(gen_mm_paras), intent(in)   :: X        ! dummy variables
  type(LHS_RHS_type), intent(in)   :: Y        ! dummy variables
  type(T_pair_single), intent(out) :: T_pair

  unused_var(X)
  unused_var(Y)

  T_pair%paras%RHS_LMAX = RHS_LMAX

end subroutine fmm_set_RHS_LMAX

!-------------------------------------------------------------------------------
! This routine directs the saving of functions in fmm_proc_selector.c
! relevant to the formation of a T-pair entity.
! There are 4 parts to the making of a T-pair once raw data has been
! suppplied from the classical interaction search algorithm.
! These are all called consecutively from the C-code via
! fmm_stored_t_pair_mould.
! The 4 functions saved are selected here and depend on whether
! pure boxed moments, or unboxed moments, are being contracted.

subroutine fmm_init_T_pair_mould(scheme,pair_type)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  integer(INTK), intent(in)      :: pair_type
  external :: fmm_store_t_pair_mould1   ! raw/box dependent variables
  external :: fmm_store_t_pair_mould2   ! set LMAX (LHS)
  external :: fmm_store_t_pair_mould3   ! set LMAX (RHS)
  external :: fmm_store_t_pair_mould4   ! common to all T-pair builds

  call fmm_store_t_pair_mould2(fmm_set_LHS_LMAX)
  call fmm_store_t_pair_mould3(fmm_set_RHS_LMAX)
  call fmm_store_t_pair_mould4(fmm_set_T_pair_basics)
  select case (pair_type)
    case (LHS_raw_RHS_raw)
      LHS_LMAX = scheme%raw_LMAX
      RHS_LMAX = scheme%raw_LMAX
      call fmm_store_t_pair_mould1(fmm_set_RR_paras)
    case (LHS_box_RHS_box)
      LHS_LMAX = scheme%trans_LMAX
      RHS_LMAX = scheme%trans_LMAX
      call fmm_store_t_pair_mould1(fmm_set_BB_paras)
    case default
      call fmm_quit('cannot recognise T_pair type!')
  end select

  fmm_init_mould = 'initialised'

end subroutine fmm_init_T_pair_mould

!-------------------------------------------------------------------------------

end module fmm_T_pair_mould

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, IBM                                              *
************************************************************************
      Subroutine  mHrr(la,lb,nSize,nMem)
      Implicit Real*8 (a-h,o-z)
*
*     Statement function for canonical indices
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
*     First find the size of the working array.
*
      nMem  = 0
      nMem2 = 0
      nSize = 0
      Do 100 ib = 0, Min(la,lb)
         nMem1 = 0
         Do 150 ia = Max(la,lb), la+lb-ib
            nSize = nSize + nElem(ib)*nElem(ia)
            nMem1 = nMem1 + nElem(ib)*nElem(ia)
 150     Continue
         nMem=Max(nMem,nMem1+nMem2)
         nMem2 = nMem1
         If (ib.eq.0) nSize = 0
 100  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
!               Francesco Aquilante                                    *
!***********************************************************************

subroutine ChoMP2_Energy_Contr(EMP2,EOcc,EVir,Xaibj,LnT2am,LiT2am,iBatch,jBatch)
!
! Thomas Bondo Pedersen, Dec. 2004 / Feb. 2005.
!
! Purpose: compute (MINUS the) energy contribution from a
!          batch of (ai|bj) integrals.
!
! Modified by F. Aquilante to compute separately the Opposite-Spin
!                          contribution to the MP2 energy

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Cholesky, only: nSym
use ChoMP2, only: ChoAlg, DoT1amp, EOSMP2, iFirstS, iMatab, iOcc, iVir, LiMatij, LiT1am, LnOcc, LnT1am, nMatab, nVir, Wref
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LnT2am, LiT2am(8), iBatch, jBatch
real(kind=wp), intent(inout) :: EMP2, Xaibj(LnT2am)
real(kind=wp), intent(in) :: EOcc(*), EVir(*)
integer(kind=iwp) :: a, abij, aibj, b, baij, biaj, i, ij, iSym1, iSym2, iSyma, iSymab, iSymai, iSymaj, iSymb, iSymbi, iSymbj, &
                     iSymi, iSymij, iSymj, j, Lai, Laj, Lbi, Lbj, Li, Lj
real(kind=wp) :: Dnom, Eaibj, EMP2_sav, EOSMP2_sav, Taibj, Waibj, WREF_sav

if (DoT1amp) then
  call ChoMP2_Energy_Contr_T1(EMP2,EOcc,EVir,Xaibj,LnT2am,LiT2am,iBatch,jBatch)
  return
end if

call Cho_GAdGOp(Xaibj,LnT2am,'+')

if (iBatch == jBatch) then

  if (ChoAlg == 2) then ! M(ab,ij)=(ai|bj) with i<=j.
    do iSymj=1,nSym
      iSymi = iSymj
      do Lj=1,LnOcc(iSymj,jBatch)
        j = iFirstS(iSymj,jBatch)+Lj-1
        do Li=1,LnOcc(iSymi,iBatch)
          i = iFirstS(iSymi,iBatch)+Li-1
          ij = LiMatij(iSymi,iSymj,iBatch)+iTri(Li,Lj)
          do iSymb=1,nSym
            iSyma = iSymb
            do b=1,nVir(iSymb)
              abij = LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSyma,iSymb)+nVir(iSyma)*(b-1)
              baij = LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSyma)-nVir(iSymb)+b
              do a=1,nVir(iSyma)
                abij = abij+1
                baij = baij+nVir(iSymb)
                Dnom = EVir(iVir(iSyma)+a)-EOcc(iOcc(iSymi)+i)+EVir(iVir(iSymb)+b)-EOcc(iOcc(iSymj)+j)
                Taibj = Xaibj(abij)/Dnom
                Waibj = Two*Xaibj(abij)
                EOSMP2 = EOSMP2+Taibj*Waibj
                Waibj = Waibj-Xaibj(baij)
                Eaibj = Taibj*Waibj
                EMP2 = EMP2+Eaibj
                WREF = WREF+Eaibj/Dnom
              end do
            end do
          end do
        end do
      end do
    end do
    do iSymij=2,nSym
      iSymab = iSymij
      do iSym2=1,nSym
        iSym1 = Mul(iSym2,iSymij)
        iSymj = max(iSym1,iSym2)
        iSymi = min(iSym1,iSym2)
        do Lj=1,LnOcc(iSymj,jBatch)
          j = iFirstS(iSymj,jBatch)+Lj-1
          do Li=1,LnOcc(iSymi,iBatch)
            i = iFirstS(iSymi,iBatch)+Li-1
            ij = LiMatij(iSymi,iSymj,iBatch)+LnOcc(iSymi,iBatch)*(Lj-1)+Li
            do iSymb=1,nSym
              iSyma = Mul(iSymb,iSymab)
              do b=1,nVir(iSymb)
                abij = LiT2am(iSymij)+nMatab(iSymab)*(ij-1)+iMatab(iSyma,iSymb)+nVir(iSyma)*(b-1)
                baij = LiT2am(iSymij)+nMatab(iSymab)*(ij-1)+iMatab(iSymb,iSyma)-nVir(iSymb)+b
                do a=1,nVir(iSyma)
                  abij = abij+1
                  baij = baij+nVir(iSymb)
                  Dnom = EVir(iVir(iSyma)+a)-EOcc(iOcc(iSymi)+i)+EVir(iVir(iSymb)+b)-EOcc(iOcc(iSymj)+j)
                  Taibj = Xaibj(abij)/Dnom
                  Waibj = Two*Xaibj(abij)
                  EOSMP2 = EOSMP2+Taibj*Waibj
                  Waibj = Waibj-Xaibj(baij)
                  Eaibj = Taibj*Waibj
                  EMP2 = EMP2+Eaibj
                  WREF = WREF+Eaibj/Dnom
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  else ! triangular storage, (ai|bj) with ai<=bj.
    do iSymbj=1,nSym
      iSymai = iSymbj
      do iSymj=1,nSym
        iSymb = Mul(iSymj,iSymbj)
        do Lj=1,LnOcc(iSymj,jBatch)
          j = iFirstS(iSymj,jBatch)+Lj-1
          do b=1,nVir(iSymb)
            Lbj = LiT1am(iSymb,iSymj,jBatch)+nVir(iSymb)*(Lj-1)+b
            do iSymi=1,nSym
              iSyma = Mul(iSymi,iSymai)
              iSymaj = Mul(iSyma,iSymj)
              iSymbi = iSymaj
              do Li=1,LnOcc(iSymi,iBatch)
                i = iFirstS(iSymi,iBatch)+Li-1
                Lbi = LiT1am(iSymb,iSymi,iBatch)+nVir(iSymb)*(Li-1)+b
                do a=1,nVir(iSyma)
                  Lai = LiT1am(iSyma,iSymi,iBatch)+nVir(iSyma)*(Li-1)+a
                  Laj = LiT1am(iSyma,iSymj,jBatch)+nVir(iSyma)*(Lj-1)+a
                  aibj = LiT2am(iSymai)+iTri(Lai,Lbj)
                  biaj = LiT2am(iSymbi)+iTri(Lbi,Laj)
                  Dnom = EVir(iVir(iSyma)+a)-EOcc(iOcc(iSymi)+i)+EVir(iVir(iSymb)+b)-EOcc(iOcc(iSymj)+j)
                  Taibj = Xaibj(aibj)/Dnom
                  Waibj = Two*Xaibj(aibj)
                  EOSMP2 = EOSMP2+Taibj*Waibj
                  Waibj = Waibj-Xaibj(biaj)
                  Eaibj = Taibj*Waibj
                  EMP2 = EMP2+Eaibj
                  WREF = WREF+Eaibj/Dnom
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end if

else ! rectangular storage (ai|bj) with ai<bj.

  EMP2_sav = EMP2
  EMP2 = Zero
  WREF_sav = WREF
  WREF = Zero
  EOSMP2_sav = EOSMP2
  EOSMP2 = Zero
  do iSymbj=1,nSym
    iSymai = iSymbj
    do iSymj=1,nSym
      iSymb = Mul(iSymj,iSymbj)
      do Lj=1,LnOcc(iSymj,jBatch)
        j = iFirstS(iSymj,jBatch)+Lj-1
        do b=1,nVir(iSymb)
          Lbj = LiT1am(iSymb,iSymj,jBatch)+nVir(iSymb)*(Lj-1)+b
          do iSymi=1,nSym
            iSyma = Mul(iSymi,iSymai)
            iSymaj = Mul(iSyma,iSymj)
            iSymbi = iSymaj
            do Li=1,LnOcc(iSymi,iBatch)
              i = iFirstS(iSymi,iBatch)+Li-1
              Lbi = LiT1am(iSymb,iSymi,iBatch)+nVir(iSymb)*(Li-1)+b
              do a=1,nVir(iSyma)
                Lai = LiT1am(iSyma,iSymi,iBatch)+nVir(iSyma)*(Li-1)+a
                Laj = LiT1am(iSyma,iSymj,jBatch)+nVir(iSyma)*(Lj-1)+a
                aibj = LiT2am(iSymai)+LnT1am(iSymai,iBatch)*(Lbj-1)+Lai
                biaj = LiT2am(iSymbi)+LnT1am(iSymbi,iBatch)*(Laj-1)+Lbi
                Dnom = EVir(iVir(iSyma)+a)-EOcc(iOcc(iSymi)+i)+EVir(iVir(iSymb)+b)-EOcc(iOcc(iSymj)+j)
                Taibj = Xaibj(aibj)/Dnom
                Waibj = Two*Xaibj(aibj)
                EOSMP2 = EOSMP2+Taibj*Waibj
                Waibj = Waibj-Xaibj(biaj)
                Eaibj = Taibj*Waibj
                EMP2 = EMP2+Eaibj
                WREF = WREF+Eaibj/Dnom
              end do
            end do
          end do
        end do
      end do
    end do
  end do
  EMP2 = EMP2_sav+Two*EMP2
  EOSMP2 = EOSMP2_sav+Two*EOSMP2
  WREF = WREF_sav+Two*WREF

end if

EOSMP2 = Half*EOSMP2

end subroutine ChoMP2_Energy_Contr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine int2char_cvb(a,int,iform)
c  Simulates internal write :    write(a,'(i<iform>)')int
      implicit real*8(a-h,o-z)
      character*(*) a
      character*1 blank,minus,cnumb(0:9)
      save blank,minus,cnumb
      data blank/' '/,minus/'-'/
      data cnumb/'0','1','2','3','4','5','6','7','8','9'/

      la=len(a)
      if(iform.gt.la)then
        write(6,*)' Illegal call to int2char_cvb:',iform,la
        call abend_cvb()
      endif
      dum=log10(DBLE(max(abs(int),1)))
      idum=nint(dum)
      if(abs(int).ge.10**idum)then
        iamax=idum+1
      else
        iamax=idum
      endif
      if(int.lt.0)iamax=iamax+1
      if(iamax.gt.iform)then
        write(6,*)' Integer too large in int2char_cvb:',int,iform
        call abend_cvb()
      endif
      ia=0
      do 100 i=1,iform-iamax
      ia=ia+1
      a(ia:ia)=blank
100   continue
      if(int.lt.0)then
        ia=ia+1
        a(ia:ia)=minus
        iamax=iamax-1
      endif
      int2=abs(int)
      do 200 i=iamax-1,0,-1
      ia=ia+1
      numb=int2/(10**i)
      a(ia:ia)=cnumb(numb)
      int2=int2-numb*(10**i)
200   continue
      if(int.eq.0)a(iform:iform)=cnumb(0)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grc24C(a,b,c,mvec,ssa,ssb,pbar,ix)

use ccsd_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
type(Map_Type), intent(in) :: a, b
type(Map_Type), intent(inout) :: c
integer(kind=iwp), intent(out) :: mvec(4096,7)
integer(kind=iwp), intent(in) :: ssa, ssb, pbar
integer(kind=iwp), intent(inout) :: ix
integer(kind=iwp) :: ia, ib, ic, nhelp1, nhelp2, nhelp3, nhelp31, nhelp32, nhelp33, nhelp4, nsymb3, ntest1, ntest2, posct, sa1, &
                     sa2, sb1, sb12, sb123, sb2, sb3, sb4

!1*

if (pbar == 1) then

  ! structure A(p,q)*B(q,rst)=C(p,rst)

  !1.0 prepare c%d,c%i

  call grc0(4,b%d(0,6),a%d(0,1),b%d(0,2),b%d(0,3),b%d(0,4),mmul(ssa,ssb),posct,c)

  !1.1 define limitations - q,r>s,t must be tested - ntest1
  !                       - q,r,s>t must be tested - ntest2

  if (b%d(0,6) == 2) then
    ntest1 = 1
  else
    ntest1 = 0
  end if

  if (b%d(0,6) == 3) then
    ntest2 = 1
  else
    ntest2 = 0
  end if

  !1.2 def symm states and test the limitations

  ix = 1
  do sa1=1,nsym

    sa2 = mmul(ssa,sa1)
    sb1 = sa2

    do sb2=1,nsym
      sb12 = mmul(sb1,sb2)
      if (ntest1 == 1) then
        nsymb3 = sb2
      else
        nsymb3 = nsym
      end if

      do sb3=1,nsymb3
        sb123 = mmul(sb12,sb3)

        sb4 = mmul(ssb,sb123)
        ! Meggie out
        if ((ntest2 == 1) .and. (sb3 < sb4)) cycle

        !1.3 def mvec,c%d and c%i

        ia = a%i(sa1,1,1)
        ib = b%i(sb1,sb2,sb3)
        ic = c%i(sa1,sb2,sb3)

        ! yes/no
        if ((a%d(ia,2) <= 0) .or. (b%d(ib,2) <= 0)) cycle
        nhelp1 = 1

        ! rowA
        nhelp2 = dimm(a%d(0,1),sa1)

        ! colB
        nhelp31 = dimm(b%d(0,2),sb2)
        nhelp32 = dimm(b%d(0,3),sb3)
        nhelp33 = dimm(b%d(0,4),sb4)
        if ((ntest1 == 1) .and. (sb2 == sb3)) then
          nhelp3 = nhelp31*(nhelp31-1)*nhelp33/2
        else if ((ntest2 == 1) .and. (sb3 == sb4)) then
          nhelp3 = nhelp31*nhelp32*(nhelp32-1)/2
        else
          nhelp3 = nhelp31*nhelp32*nhelp33
        end if

        ! sum
        nhelp4 = dimm(a%d(0,2),sa2)

        mvec(ix,1) = nhelp1
        mvec(ix,2) = a%d(ia,1)
        mvec(ix,3) = b%d(ib,1)
        mvec(ix,4) = c%d(ic,1)
        mvec(ix,5) = nhelp2
        mvec(ix,6) = nhelp4
        mvec(ix,7) = nhelp3

        ix = ix+1

      end do
    end do
  end do

end if
ix = ix-1

return

end subroutine grc24C

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine Orthox(S,C,nOrb,nBas)
!***********************************************************************
!                                                                      *
!     purpose: Perform Gram-Schmidt orthogonalization scheme           *
!                                                                      *
!     input:                                                           *
!       S       : overlap in non-orthonormal basis (square storage)    *
!       C       : matrix transforming non-orthonormal basis            *
!      nBas,nOrb: dimensions                                           *
!                                                                      *
!     output:                                                          *
!       C       : matrix transforming orthonormal basis                *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOrb, nBas
real(kind=wp), intent(inout) :: S(nOrb,nOrb), C(nBas,nOrb)
integer(kind=iwp) :: iOrb, jOrb
real(kind=wp) :: A, F

do iOrb=1,nOrb
  F = Zero
  if (S(iOrb,iOrb) > Zero) F = One/sqrt(S(iOrb,iOrb))
  C(:,iOrb) = F*C(:,iOrb)
  S(iOrb,:) = F*S(iOrb,:)
  S(:,iOrb) = F*S(:,iOrb)
  S(iOrb,iOrb) = One
  do jOrb=iOrb+1,nOrb
    A = S(iOrb,jOrb)
    C(:,jOrb) = C(:,jOrb)-A*C(:,iOrb)
    S(jOrb,:) = S(jOrb,:)-A*S(iOrb,:)
    S(:,jOrb) = S(:,jOrb)-A*S(:,iOrb)
  end do
end do

end subroutine Orthox

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Naoki Nakatani                                   *
!***********************************************************************

subroutine BlockCtl(LW1,TUVX,IFINAL,IRST)
!***********************************************************************
!                                                                      *
!     Description                                                      *
!                                                                      *
!     This is an alternative of DavCtl for DMRG-CASSCF in DMRGCtl      *
!                                                                      *
!***********************************************************************
!                                                                      *
!     DMRG control section                                             *
!                                                                      *
!     calling arguments:                                               *
!     LW1     : array of real*8                                        *
!               Memory pointer to active Fock matrix                   *
!     TUVX    : array of real*8                                        *
!               two-electron integrals (tu!vx)                         *
!     IFINAL  : integer                                                *
!               termination flag                                       *
!     IRST    : integer                                                *
!               restart flag of DMRG                                   *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     N. Nakatani, Hokkaido University, Japan, 2014                    *
!                                                                      *
!***********************************************************************

use rasscf_data, only: Do3RDM, ENER, HFOCC, iOrbTyp, ITER, lRoots, mxSym, MxDMRG, NAC, ROTMAX, THRE
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Five, Ten
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: LW1(*), TUVX(*)
integer(kind=iwp), intent(in) :: IFINAL, IRST
#include "general.fh"
integer(kind=iwp) :: iChMolpro(8), iOper, iOrb, iSigma, iSym, jOrb, JRST, lSymMolpro, nIrrep, NRDM_ORDER
real(kind=wp) :: ThDMRG, ThNoise
character(len=3) :: Label
integer(kind=iwp), allocatable :: OrbSym(:)

! Load symmetry info from RunFile
call Get_iScalar('NSYM',nIrrep)
call Get_iArray('Symmetry operations',iOper,nIrrep)
call Get_iScalar('Rotational Symmetry Number',iSigma)

! Get character table to convert MOLPRO symmetry format
call MOLPRO_ChTab(nSym,Label,iChMolpro)

! Convert orbital symmetry into MOLPRO format
call mma_allocate(OrbSym,NAC,label='OrbSym')
iOrb = 1
do iSym=1,nSym
  do jOrb=1,NASH(iSym)
    OrbSym(iOrb) = iChMolpro(iSym)
    iOrb = iOrb+1
  end do
end do
lSymMolpro = iChMolpro(stSym)

NRDM_ORDER = 2
if (NACTEL == 1) NRDM_ORDER = 1

! Default setting for the first iteraction
JRST = IRST
ThDMRG = THRE*Ten
ThNoise = 1.0e-4_wp

if (JRST /= 0) then
  if (IFINAL == 0) then
    if (abs(ROTMAX) >= 1.0e-1_wp) then
      ! No restart
      JRST = 0
      ThDMRG = THRE*Ten
      ThNoise = 1.0e-4_wp
    else if (abs(ROTMAX) >= 0.5e-1_wp) then
      ! Full-restart with noise
      JRST = 2
      ThDMRG = THRE*Five
      ThNoise = 1.0e-5_wp
    else if (abs(ROTMAX) >= 1.0e-2_wp) then
      ! Full-restart with smaller noise
      JRST = 2
      ThDMRG = THRE
      ThNoise = 1.0e-6_wp
    else
      ! Restart without noise
      JRST = 1
      ThDMRG = THRE
      ThNoise = Zero
    end if
  else if (IFINAL == 1) then
    ! Full-restart for CI-only
    JRST = 2
    ThDMRG = THRE
    ThNoise = 1.0e-6_wp
  else
    ! Full-restart for the final wavefunction
    if (iOrbTyp == 2) then
      ! with OutOrb = Canonical, this will be problematic for LMO-DMRG calc.
      JRST = 2
      ThDMRG = THRE
      ThNoise = 1.0e-6_wp
    else
      ! by default, just restarting
      JRST = 1
      ThDMRG = THRE
      ThNoise = Zero
    end if
  end if
end if

! In the following calls the extra array HFOCC has been passed
! from Molcas to Block to have a user customized reference det.
! This change must be done accordingly into the block code.
! In particular, in file molcas/block_calldmrg.C:
! line~23:  const char* hf_occ)
! line~24:  block_calldmrg(*Restart, *N_roots, *N_act, *N_elec, *M_s, Sym, *iSym, OrbSym, *E_core, h0, tuvx, *M_state, *N_pdm, *T_sweep, *T_noise, E_sweep, hf_occ);
! line~63:  const char* hf_occ)
! line~186: fcon << "hf_occ " << hf_occ << endl;
!
! In molcas/block_calldmrg.h:
! line~25:  const char* hf_occ);
! line~46:  const char* hf_occ);

! Compute DMRG
call block_calldmrg(JRST,lRoots,NAC,NACTEL,ISPIN-1,Label,lSymMolpro,OrbSym,Zero,LW1,TUVX,MxDMRG,NRDM_ORDER,ThDMRG, &
                    ThNoise,ENER(1,ITER),HFOCC,NRS2T)

if (IFINAL == 2 .and. Do3RDM .and. NACTEL > 2) then
  ! Compute 3RDM for DMRG-cu4-CASPT2
  call block_calldmrg(1,lRoots,NAC,NACTEL,ISPIN-1,Label,lSymMolpro,OrbSym,Zero,LW1,TUVX,MxDMRG,3,THRE,Zero,ENER(1,ITER), &
                      HFOCC,NRS2T)
end if

call mma_deallocate(OrbSym)

return

end subroutine BlockCtl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mk_T1t(T1,H,dimbepp,no,nv,addbepp)
! this routine does:
! H(i,be") <- T1o(be,i)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimbepp, no, nv, addbepp
real(kind=wp), intent(in) :: T1(nv,no)
real(kind=wp), intent(out) :: H(no,dimbepp)
integer(kind=iwp) :: bepp

do bepp=1,dimbepp
  H(:,bepp) = T1(addbepp+bepp,:)
end do

return

end subroutine Mk_T1t

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine replace1 (i,j,k,l,ordercounter,opcounter,operleng,
     *                     oporder,evenodd,doperators,operators,
     *                     reslengl,reslengr,rescharl,rescharr,
     *                     oddcounter,oddleng,oddorder,eoodd,dodd,odd)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 30.06.2005
c
c   first version: 18.06.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      real*8 one
      parameter (one=+1.0d0)
c
      integer i,j,k,l,ordercounter(0:maxorder),opcounter,
     *        operleng(maxoperators),oporder(maxoperators,3),
     *        evenodd(maxoperators),
     *        oddcounter,oddleng(maxuops),oddorder(maxuops,3),
     *        eoodd(maxuops),reslengl,reslengr
      real*8 doperators(maxoperators),dodd(maxuops),
     *                 signum1,signum2,scrcoeff1,scrcoeff2
      character*(maxlength) odd(maxuops),rescharl,rescharr
#if defined(_MOLCAS_) || defined(MOLPRO)
      character*(maxlength) opstring
      character operators(*)
#else
      character*(maxlength) operators(maxoperators)
#endif
C     integer idum1,idum2,idum3,m,n
      integer idum1,idum2,idum3,m
      logical ctrlflg
      intrinsic ABS,DBLE,SIGN
c
      idum1=j
      idum2=k
      idum3=l
      signum1=SIGN(one,doperators(k))
      signum2=SIGN(one,doperators(l))
      scrcoeff1=doperators(k)
      scrcoeff2=doperators(l)
      ctrlflg=.false.
c
      if (abs(doperators(idum2)+doperators(idum3)).lt.dkhzero) then
        if(idum2.eq.idum3) then
          write (stdout,3012) idum2
3012      format (/2X,'ERROR in subroutine "replace1": idum2 = idum3 =',
     *          I6,//2X,'STOP.',/)
          Call Abend
        endif
        do 20 m=idum3,opcounter
          operleng(m)=operleng(m+1)
          oporder(m,1)=oporder(m+1,1)
          oporder(m,2)=oporder(m+1,2)
          oporder(m,3)=oporder(m+1,3)
          evenodd(m)=evenodd(m+1)
          doperators(m)=doperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call copy_dkoperators(m+1,operators,m,operators)
#else
          operators(m)=operators(m+1)
#endif
  20    continue
        ordercounter(idum1)=ordercounter(idum1)-1
        opcounter=opcounter-1
        if (idum2.gt.idum3) idum2=idum2-1
        do 30 m=opcounter,idum2+1,-1
          operleng(m+oddcounter-1)=operleng(m)
          oporder(m+oddcounter-1,1)=oporder(m,1)
          oporder(m+oddcounter-1,2)=oporder(m,2)
          oporder(m+oddcounter-1,3)=oporder(m,3)
          evenodd(m+oddcounter-1)=evenodd(m)
          doperators(m+oddcounter-1)=doperators(m)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call copy_dkoperators(m,operators,m+oddcounter-1,operators)
#else
          operators(m+oddcounter-1)=operators(m)
#endif
  30    continue
        do 40 m=1,oddcounter
          operleng(idum2+m-1)=reslengl+oddleng(m)+reslengr
          oporder(idum2+m-1,1)=oporder(idum2,1)
          oporder(idum2+m-1,2)=oporder(idum2,2)
          oporder(idum2+m-1,3)=oporder(idum2,3)
          evenodd(idum2+m-1)=evenodd(idum2)
          doperators(idum2+m-1)=scrcoeff1*(-1.0d0)*dodd(m)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call concatenate (operleng(idum2+m-1),opstring,
     *                      reslengl,rescharl,oddleng(m),odd(m),
     *                      reslengr,rescharr)
          call put_dkoperators(idum2+m-1,opstring,operators)
#else
          call concatenate (operleng(idum2+m-1),operators(idum2+m-1),
     *                      reslengl,rescharl,oddleng(m),odd(m),
     *                      reslengr,rescharr)
#endif
  40    continue
        ordercounter(idum1)=ordercounter(idum1)+oddcounter-1
        opcounter=opcounter+oddcounter-1
        ctrlflg=.true.
        goto 6734
      endif
      if ((abs(doperators(idum2))-abs(doperators(idum3)))
     *                                                 .gt.dkhzero) then
        if(idum2.eq.idum3) then
          write (stdout,3022) idum2
 3022     format (/2X,'ERROR in subroutine "replace1": idum2 = idum3 =',
     *          I6,//2X,'STOP.',/)
          Call Abend
        endif
c
        doperators(idum2)=scrcoeff1+scrcoeff2
        do 120 m=idum3,opcounter
          operleng(m)=operleng(m+1)
          oporder(m,1)=oporder(m+1,1)
          oporder(m,2)=oporder(m+1,2)
          oporder(m,3)=oporder(m+1,3)
          evenodd(m)=evenodd(m+1)
          doperators(m)=doperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call copy_dkoperators(m+1,operators,m,operators)
#else
          operators(m)=operators(m+1)
#endif
 120    continue
        ordercounter(idum1)=ordercounter(idum1)-1
        opcounter=opcounter-1
        if (idum2.gt.idum3) idum2=idum2-1
        do 130 m=opcounter,idum2+1,-1
          operleng(m+oddcounter)=operleng(m)
          oporder(m+oddcounter,1)=oporder(m,1)
          oporder(m+oddcounter,2)=oporder(m,2)
          oporder(m+oddcounter,3)=oporder(m,3)
          evenodd(m+oddcounter)=evenodd(m)
          doperators(m+oddcounter)=doperators(m)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call copy_dkoperators(m,operators,m+oddcounter,operators)
#else
          operators(m+oddcounter)=operators(m)
#endif
 130    continue
        do 140 m=1,oddcounter
          operleng(idum2+m)=reslengl+oddleng(m)+reslengr
          oporder(idum2+m,1)=oporder(idum2,1)
          oporder(idum2+m,2)=oporder(idum2,2)
          oporder(idum2+m,3)=oporder(idum2,3)
          evenodd(idum2+m)=evenodd(idum2)
          doperators(idum2+m)=scrcoeff2*dodd(m)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call concatenate (operleng(idum2+m),opstring,
     *                      reslengl,rescharl,oddleng(m),odd(m),
     *                      reslengr,rescharr)
          call put_dkoperators(idum2+m,opstring,operators)
#else
          call concatenate (operleng(idum2+m),operators(idum2+m),
     *                      reslengl,rescharl,oddleng(m),odd(m),
     *                      reslengr,rescharr)
#endif
 140    continue
        ordercounter(idum1)=ordercounter(idum1)+oddcounter
        opcounter=opcounter+oddcounter
        ctrlflg=.true.
        goto 6734
      endif
c
      if ((abs(doperators(idum3))-abs(doperators(idum2)))
     *                                                 .gt.dkhzero) then
        if(idum2.eq.idum3) then
          write (stdout,3032) idum2
 3032     format (/2X,'ERROR in subroutine "replace1": idum2 = idum3 =',
     *          I6,//2X,'STOP.',/)
          Call Abend
        endif

        doperators(idum3)=scrcoeff1+scrcoeff2
        do 220 m=idum2,opcounter
          operleng(m)=operleng(m+1)
          oporder(m,1)=oporder(m+1,1)
          oporder(m,2)=oporder(m+1,2)
          oporder(m,3)=oporder(m+1,3)
          evenodd(m)=evenodd(m+1)
          doperators(m)=doperators(m+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call copy_dkoperators(m+1,operators,m,operators)
#else
          operators(m)=operators(m+1)
#endif
 220    continue
        ordercounter(idum1)=ordercounter(idum1)-1
        opcounter=opcounter-1
        if (idum3.gt.idum2) idum3=idum3-1
        do 230 m=opcounter,idum3+1,-1
          operleng(m+oddcounter)=operleng(m)
          oporder(m+oddcounter,1)=oporder(m,1)
          oporder(m+oddcounter,2)=oporder(m,2)
          oporder(m+oddcounter,3)=oporder(m,3)
          evenodd(m+oddcounter)=evenodd(m)
          doperators(m+oddcounter)=doperators(m)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call copy_dkoperators(m,operators,m+oddcounter,operators)
#else
          operators(m+oddcounter)=operators(m)
#endif
 230    continue
        do 240 m=1,oddcounter
          operleng(idum3+m)=reslengl+oddleng(m)+reslengr
          oporder(idum3+m,1)=oporder(idum3,1)
          oporder(idum3+m,2)=oporder(idum3,2)
          oporder(idum3+m,3)=oporder(idum3,3)
          evenodd(idum3+m)=evenodd(idum3)
          doperators(idum3+m)=scrcoeff1*(-1.0d0)*dodd(m)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call concatenate (operleng(idum3+m),opstring,
     *                      reslengl,rescharl,oddleng(m),odd(m),
     *                      reslengr,rescharr)
          call put_dkoperators(idum3+m,opstring,operators)
#else
          call concatenate (operleng(idum3+m),operators(idum3+m),
     *                      reslengl,rescharl,oddleng(m),odd(m),
     *                      reslengr,rescharr)
#endif
 240    continue
        ordercounter(idum1)=ordercounter(idum1)+oddcounter
        opcounter=opcounter+oddcounter
        ctrlflg=.true.
        goto 6734
      endif
c
6734  continue
c
      if (.not.ctrlflg) then
        write (stdout,6327)
 6327   format (/2X,'ERROR in subroutine replace1: None of the 3 cases',
     *          ' has been detected.',//2X,'STOP.',/)
        CALL Abend
      endif
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(i)
        call Unused_integer_array(oddorder)
        call Unused_integer_array(eoodd)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012,2013, Victor P. Vysotskiy                         *
!***********************************************************************
!***********************************************************************
!                                                                      *
!                     Thread safe                                      *
!                     POSIX - I/O                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! rc=AixPRd(Handle,Buf,nBuf,iDisk,iErrSkip)                            *
!                                                                      *
! A buffer is read from a file associated with the file handle. The    *
! operation is synchronous, but can be done in parallel by multiple    *
! threads                                                              *
!                                                                      *
! Input:  Handle   - This is the unique file identifier associated     *
!                    with the file. It is created by AixOpn, and must  *
!                    be used on subsequent references to the file.     *
!         Buf      - The buffer that is to be written to disk.         *
!         nBuf     - Length of the buffer in words.                    *
!         iDisk    - External disk address.                            *
!         iErrSkip - if 0 : stop in the error case                     *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Victor P. Vysotskiy                                         *
!          University of Lund, Sweden, 2012-2013                       *
! Written: 2012-2013                                                   *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! History:                                                             *
!                                                                      *
!***********************************************************************

function AixPRd(handle,Buf,nBuf,iDisk,iErrSkip)

#include "intent.fh"

use Fast_IO, only: CtlBlk, eEof, eNtOpn, FCtlBlk, MxFile, pDesc, pHndle, ProfData, pWhere
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: AixPRd
integer(kind=iwp), intent(in) :: handle, nBuf, iDisk, iErrSkip
integer(kind=iwp), intent(_OUT_) :: Buf(*)
integer(kind=iwp) :: desc, Lu, n, nFile, pDisk, rc
real(kind=wp) :: CPUA, CPUE, TIOA, TIOE
character(len=80) :: ErrTxt
character(len=*), parameter :: TheName = 'AixPRd'
interface
  function AixErr(FileName) bind(C,name='aixerr_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: AixErr
    character(kind=c_char) :: FileName(*)
  end function AixErr
end interface

#include "warnings.h"

!----------------------------------------------------------------------*
! Entry to AixPRd                                                      *
!----------------------------------------------------------------------*
AixPRd = 0
rc = 0
!----------------------------------------------------------------------*
! Check if file is opened.                                             *
!----------------------------------------------------------------------*
n = 1
do
  if (CtlBlk(pHndle,n) == handle) exit
  n = n+1
  if (n > MxFile) then
    AixPRd = eNtOpn
    return
  end if
end do
nFile = n
desc = CtlBlk(pDesc,nFile)
call FSCB2UNIT(handle,Lu)
call Timing(CPUA,CPUE,TIOA,TIOE)
!----------------------------------------------------------------------*
! Position file pointer                                                *
!----------------------------------------------------------------------*
pDisk = iDisk
if (CtlBlk(pWhere,nFile) /= pDisk) then
  ProfData(8,Lu) = ProfData(8,Lu)+1
end if
!----------------------------------------------------------------------*
! Read from file                                                       *
!----------------------------------------------------------------------*
CtlBlk(pWhere,nFile) = pDisk+nBuf
if (nBuf > 0) rc = c_pread_wrapper(desc,Buf,nBuf,pDisk)
if (rc < 0) then
  if (iErrSkip == 1) then
    AixPRd = 99
    return
  end if
  call FASTIO('STATUS')
  AixPRd = AixErr(ErrTxt)
  call SysQuitFileMsg(_RC_IO_ERROR_READ_,TheName,FCtlBlk(nFile),'Premature abort while reading buffer from disk',ErrTxt)

else if (rc /= nBuf) then
  if (iErrSkip == 1) then
    AixPRd = 99
    return
  end if
  call FASTIO('STATUS')
  AixPRd = eEof
  call SysQuitFileMsg(_RC_IO_ERROR_READ_,TheName,FCtlBlk(nFile),'Premature abort while reading buffer from disk:', &
                      '\n End of file reached ')
end if
call Timing(CPUA,CPUE,TIOA,TIOE)
ProfData(4,Lu) = ProfData(4,Lu)+1
ProfData(5,Lu) = ProfData(5,Lu)+nBuf
ProfData(6,Lu) = ProfData(6,Lu)+TIOE
!----------------------------------------------------------------------*
! Finished so return to caller                                         *
!----------------------------------------------------------------------*
return

contains

function c_pread_wrapper(FileDescriptor,Buffer,nBytes,Offset)

  use, intrinsic :: iso_c_binding, only: c_loc

  integer(kind=iwp) :: c_pread_wrapper
  integer(kind=iwp), intent(in) :: FileDescriptor, nBytes, Offset
  integer(kind=iwp), target, intent(_OUT_) :: Buffer(*)
  interface
    function c_pread(FileDescriptor,Buffer,nBytes,Offset) bind(C,name='c_pread_')
      use, intrinsic :: iso_c_binding, only: c_ptr
      use Definitions, only: MOLCAS_C_INT
      integer(kind=MOLCAS_C_INT) :: c_pread
      type(c_ptr), value :: Buffer
      integer(kind=MOLCAS_C_INT) :: FileDescriptor, nBytes, Offset
    end function c_pread
  end interface

  c_pread_wrapper = c_pread(FileDescriptor,c_loc(Buffer(1)),nBytes,Offset)

end function c_pread_wrapper

end function AixPRd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001-2016, Valera Veryazov                             *
!***********************************************************************

subroutine prgmtranslate_master(namein,nameout,lout)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: namein
character(len=*), intent(out) :: nameout
integer(kind=iwp), intent(out) :: lout
integer(kind=iwp), external :: Strnln
integer(kind=iwp) :: lin
interface
  subroutine PrgmTranslateC(InStr,l1,OutStr,l2,Par) bind(C,name='prgmtranslatec_')
  use, intrinsic :: iso_c_binding, only: c_char
  use Definitions, only: MOLCAS_C_INT
# include "intent.fh"
  character(kind=c_char), intent(in) :: InStr(*)
  integer(kind=MOLCAS_C_INT), intent(in) :: l1, Par
  character(kind=c_char), intent(_OUT_) :: OutStr(*)
  integer(kind=MOLCAS_C_INT), intent(out) :: l2
  end subroutine
end interface

lin = Strnln(namein)
nameout = ' '
if (index(namein,'/') /= 0) then
  ! just in case we process a translated name!
  nameout = namein
  lout = lin
else
  call prgmtranslatec(namein,lin,nameout,lout,0)
end if
nameout = nameout(1:lout)

return

end subroutine prgmtranslate_master

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine dkh_geneu(n,m,xord,c,w,xl,xs,t1,t2,t3)
C
C Calculate the DKH unitary transformation truncated at [xord] order
C   U_{DKH}=U_{0}U_{1}U_{2}...U_{xord}
C   U_{k}=\sum_{i=0}^{xord/k}c_{i}W_{k}^{i}
C
      implicit none
C
C Input
C   n    dimension of matrix
C   m    =2*n
C   c    expansion coefficients of unitary transformation in terms of W
C   w    stored W matrices
C
      integer n,m,xord
      Real*8 c(*),w(n,n,2,xord)
C Output
C   xl   upper part
C   xs   lower part
      Real*8 xl(n,n),xs(n,n)
C Temp
      Real*8 t1(m,m),t2(m,m),t3(m,m)
      integer i,j,k,iord
C
      do iord=1,xord
C       ! initial unit matrix
        do i=1,m
          do j=1,m
            if(j.eq.i)then
              t2(j,i) = 1.d0
            else
              t2(j,i) = 0.d0
            end if
          end do
        end do
        do k=1,xord/iord
          if(mod(k,2).eq.1)then
            if(k.eq.1)then
              do i=1,n
                do j=1,n
C                 ! unitary transformation in right side, had {\dag} to original definition of U
                  xs(j,i) = -w(j,i,1,iord)
                end do
              end do
            else
              call dmxma(n,'N','N',xl,w(1,1,1,iord),xs,-1.d0)
            end if
            do i=1,n
              do j=1,n
                t2(j  ,i+n) = t2(j  ,i+n) + xs(j,i) * c(k)
                t2(j+n,i  ) = t2(j+n,i  ) - xs(i,j) * c(k)
              end do
            end do
          else
            call dmxma(n,'C','N',w(1,1,1,iord),xs,xl,1.d0)
            do i=1,n
              do j=1,n
                t2(j+n,i+n) = t2(j+n,i+n) + xl(j,i) * c(k)
              end do
            end do
            call dmxma(n,'N','C',xs,w(1,1,1,iord),xl,1.d0)
            do i=1,n
              do j=1,n
                t2(j  ,i  ) = t2(j  ,i  ) + xl(j,i) * c(k)
              end do
            end do
          end if
        end do
        if(iord.eq.1)then
          do i=1,m
            do j=1,m
              t1(j,i) = t2(j,i)
            end do
          end do
        else
C         ! multiply U_{iord} in right side
          call dmxma(m,'N','N',t1,t2,t3,1.d0)
          do i=1,m
            do j=1,m
              t1(j,i) = t3(j,i)
            end do
          end do
        end if
      end do
      do i=1,n
        do j=1,n
          xl(j,i) = t1(j  ,i)
          xs(j,i) = t1(j+n,i)
        end do
      end do
C
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      SUBROUTINE CHO_SUBTR0(XINT,WRK,LWRK,ISYM)
C
C     Purpose: subtract contributions from previous vectors
C              from the qualified integrals (in XINT).
C              This version is memory-driven.
C
C     Screening in subtraction introduced Jan. 2006, TBP.
C
      use ChoSwp, only: iQuAB, nnBstRSh, iiBstRSh
      use ChoArr, only: LQ
      use ChoVecBuf, only: nVec_in_Buf
      use ChoSubScr, only: Cho_SScreen, SSTau, SubScrStat, DSubScr,
     &                     DSPNm, SSNorm
#include "implicit.fh"
      DIMENSION XINT(*), WRK(LWRK)
#include "cholesky.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_SUBTR0')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

      INTEGER  CHO_LREAD
      EXTERNAL CHO_LREAD

      PARAMETER (XMONE = -1.0D0, ONE = 1.0D0)

C     Return if nothing to do.
C     ------------------------

      IF (NUMCHO(ISYM) .LT. 1) RETURN

      NVEC_TO_READ = NUMCHO(ISYM) - NVEC_IN_BUF(ISYM)
      IF (NVEC_TO_READ .EQ. 0) RETURN
      IF (NVEC_TO_READ .LT. 0) THEN
         CALL CHO_QUIT('Vector buffer error in '//SECNAM,104)
      END IF

C     Initialize.
C     -----------

      XTOT = 0.0D0
      XDON = 0.0D0

C     Reserve space needed for reading previous vectors.
C     --------------------------------------------------

      LREAD = CHO_LREAD(ISYM,LWRK)
      IF (LREAD .LT. 1) THEN
         WRITE(LUPRI,*) SECNAM,': CHO_LREAD returned ',LREAD
         CALL CHO_QUIT('Memory error in '//SECNAM,101)
         LWRK1 = 0 ! to avoid compiler warnings
      ELSE
         LWRK1 = LWRK - LREAD
      END IF

C     Set up batch.
C     -------------

      MMEM = NNBSTR(ISYM,2) + NQUAL(ISYM)
      NVEC = MIN(LWRK1/MMEM,NVEC_TO_READ)
      IF (NVEC .LT. 1) THEN
         CALL CHO_QUIT('Batch failure in '//SECNAM,101)
      END IF
      NBATCH = (NVEC_TO_READ - 1)/NVEC + 1

C     Start batch loop.
C     -----------------

      DO IBATCH = 1,NBATCH

         IF (IBATCH .EQ. NBATCH) THEN
            NUMV = NVEC_TO_READ - NVEC*(NBATCH - 1)
         ELSE
            NUMV = NVEC
         END IF
         IVEC1 = NVEC_IN_BUF(ISYM) + NVEC*(IBATCH - 1) + 1

C        Complete allocation.
C        --------------------

         KCHO1 = 1
         KCHO2 = KCHO1 + NNBSTR(ISYM,2)*NUMV
         KEND2 = KCHO2 + NQUAL(ISYM)*NUMV
         LWRK2 = LWRK  - KEND2 + 1
         IF (LWRK2 .LT. LREAD) THEN
            CALL CHO_QUIT('Batch error in '//SECNAM,104)
         END IF

C        Read previous vectors.
C        ----------------------

         CALL CHO_TIMER(C1,W1)
         CALL CHO_GETVEC(WRK(KCHO1),NNBSTR(ISYM,2),NUMV,IVEC1,ISYM,
     &                   WRK(KEND2),LWRK2)
         CALL CHO_TIMER(C2,W2)
         TDECOM(1,2) = TDECOM(1,2) + C2 - C1
         TDECOM(2,2) = TDECOM(2,2) + W2 - W1


C        Screened or unscreened subtraction section.
C        The screened version uses level 2 blas, while the unscreened
C        one employs level 3 blas.
C        ------------------------------------------------------------

         CALL CHO_TIMER(C1,W1)

         IF (CHO_SSCREEN) THEN ! screened subtraction

            KOFB0 = KCHO1 - 1 - IIBSTR(ISYM,2)
            DO J = 1,NUMV
               KOFFA = KCHO2 + J - 1
               KOFFB = KOFB0 + NNBSTR(ISYM,2)*(J - 1)
               DO IAB = 1,NQUAL(ISYM)
                  WRK(KOFFA+NUMV*(IAB-1))=WRK(KOFFB+IQUAB(IAB,ISYM))
               END DO
            END DO

C           Subtract:
C           (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L(#J,{ab})
C           for each ab in {ab}.
C           ----------------------------------------------------

            CALL CHO_SUBSCR_DIA(WRK(KCHO1),NUMV,iSym,2,SSNorm)
            DO IAB = 1,NQUAL(ISYM)
               DO ISHGD = 1,NNSHL
                  NGD = NNBSTRSH(ISYM,ISHGD,2)
                  IF (NGD .GT. 0) THEN
                     XTOT = XTOT + 1.0D0
                     JAB = IQUAB(IAB,ISYM) - IIBSTR(ISYM,2)
                     TST = SQRT(DSPNM(ISHGD)*DSUBSCR(JAB))
                     IF (TST .GT. SSTAU) THEN
                        XDON = XDON + 1.0D0
                        KOFF1 = KCHO1 + IIBSTRSH(ISYM,ISHGD,2)
                        KOFF2 = KCHO2 + NUMV*(IAB-1)
                        KOFF3 = NNBSTR(ISYM,2)*(IAB-1)
     &                        + IIBSTRSH(ISYM,ISHGD,2) + 1
                        CALL DGEMV_('N',NGD,NUMV,
     &                             XMONE,WRK(KOFF1),NNBSTR(ISYM,2),
     &                             WRK(KOFF2),1,ONE,XINT(KOFF3),1)
                     END IF
                  END IF
               END DO
            END DO

         ELSE ! unscreened subtraction

           IF (Associated(LQ(ISYM)%Array)) THEN

C              If the qualified block, L({ab},#J), is already in core,
C              use this block.
C              -------------------------------------------------------

               CALL DGEMM_('N','T',NNBSTR(ISYM,2),NQUAL(ISYM),NUMV,
     &                    XMONE,WRK(KCHO1),NNBSTR(ISYM,2),
     &                          LQ(ISYM)%Array(:,IVEC1),
     &                          SIZE(LQ(ISYM)%Array,1),
     &                    ONE,XINT,NNBSTR(ISYM,2))


            ELSE

C              Copy out sub-blocks corresponding to qualified diagonals:
C              L({ab},#J)
C              ---------------------------------------------------------

               DO J = 1,NUMV
                  DO IAB = 1,NQUAL(ISYM)
                     KOFF1 = KCHO2 + NQUAL(ISYM)*(J - 1)
     &                     + IAB - 1
                     KOFF2 = KCHO1 + NNBSTR(ISYM,2)*(J - 1)
     &                     + IQUAB(IAB,ISYM) - IIBSTR(ISYM,2) - 1
                     WRK(KOFF1) = WRK(KOFF2)
                  END DO
               END DO

C              Subtract:
C              (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L({ab},#J)
C              ----------------------------------------------------

               CALL DGEMM_('N','T',NNBSTR(ISYM,2),NQUAL(ISYM),NUMV,
     &                    XMONE,WRK(KCHO1),NNBSTR(ISYM,2),
     &                          WRK(KCHO2),NQUAL(ISYM),
     &                    ONE,XINT,NNBSTR(ISYM,2))

            END IF

C           Update DGEMM-call counter.
C           --------------------------

            NDGM_CALL = NDGM_CALL + 1

         END IF

         CALL CHO_TIMER(C2,W2)
         TDECOM(1,3) = TDECOM(1,3) + C2 - C1
         TDECOM(2,3) = TDECOM(2,3) + W2 - W1

      END DO

C     Update screening statistics.
C     ----------------------------

      IF (CHO_SSCREEN) THEN
         SUBSCRSTAT(1) = SUBSCRSTAT(1) + XTOT
         SUBSCRSTAT(2) = SUBSCRSTAT(2) + XDON
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GETSTR_TOTSM_SPGP(ISTRTP,ISPGRP,ISPGRPSM, NEL,NSTR,
     &                               ISTR, NORBT,IDOREO,    IZ,  IREO)
*
* Obtain all super-strings of given total symmetry and given
* occupation in each GAS space
*
*.If  IDOREO .NE. 0 THEN reordering array : lexical => actual order is obtained
*
* Nomenclature of the day : superstring : string in complete
*                           orbital space, product of strings in
*                           each GAS space
* =====
* Input
* =====
*
* ISTRTP  : Type of of superstrings ( alpha => 1, beta => 2 )
* ISPGRP :  supergroup number, (relative to start of this type )
* ISPGRPSM : Total symmetry of superstrings
* NEL : Number of electrons
* IZ  : Reverse lexical ordering array for this supergroup
*
*
* ======
* Output
* ======
*
* NSTR : Number of superstrings generated
* ISTR : Occupation of superstring
* IREO : Reorder array ( if IDOREO.NE.0)
*
*
* Jeppe Olsen, July 1995
*
      IMPLICIT REAL*8 (A-H,O-Z)
*. Input
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "strbas.fh"
#include "csm.fh"
      INTEGER IZ(NORBT,NEL)
*. output
      INTEGER ISTR(*), IREO(*)
*. Local scratch
      INTEGER NELFGS(MXPNGAS), ISMFGS(MXPNGAS),ITPFGS(MXPNGAS)
      INTEGER MAXVAL(MXPNGAS),MINVAL(MXPNGAS)
      INTEGER NNSTSGP(MXPNSMST,MXPNGAS)
      INTEGER IISTSGP(MXPNSMST,MXPNGAS)
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' ============================== '
        WRITE(6,*) ' Welcome to GETSTR_TOTSM_SPGP '
        WRITE(6,*) ' ============================== '
        WRITE(6,*)
        WRITE(6,'(A,3I3)')
     & ' Strings to be obtained : Type, supergroup, symmetry ',
     &   ISTRTP,ISPGRP,ISPGRPSM
        WRITE(6,*)
      END IF
*. Absolut number of this supergroup
      ISPGRPA = IBSPGPFTP(ISTRTP) - 1 + ISPGRP
*. Occupation per gasspace
*. Largest occupied space
      NGASL = 0
*. Largest and lowest symmetries active in each GAS space
      DO IGAS = 1, NGAS
        ITPFGS(IGAS) = ISPGPFTP(IGAS,ISPGRPA)
        NELFGS(IGAS) = NELFGP(ITPFGS(IGAS))
        IF(NELFGS(IGAS).GT.0) NGASL = IGAS
      END DO
      IF(NGASL.EQ.0) NGASL = 1
*. Number of strings per GAS space and offsets for strings of given sym
      DO IGAS = 1, NGAS
        CALL ICOPVE2(iWORK(KNSTSGP(1)),(ITPFGS(IGAS)-1)*NSMST+1,NSMST,
     &               NNSTSGP(1,IGAS))
        CALL ICOPVE2(iWORK(KISTSGP(1)),(ITPFGS(IGAS)-1)*NSMST+1,NSMST,
     &               IISTSGP(1,IGAS))
      END DO
*
      DO IGAS = 1, NGAS
        DO ISMST =1, NSMST
          IF(NNSTSGP(ISMST,IGAS).GT.0) MAXVAL(IGAS) = ISMST
        END DO
        DO ISMST = NSMST,1,-1
          IF(NNSTSGP(ISMST,IGAS).GT.0) MINVAL(IGAS) = ISMST
        END DO
      END DO
* Largest and lowest active symmetries for each GAS space
      IF(NTEST.GE.200) THEN
         WRITE(6,*) ' Type of each GAS space '
         CALL IWRTMA(ITPFGS,1,NGAS,1,NGAS)
         WRITE(6,*) ' Number of elecs per GAS space '
         CALL IWRTMA(NELFGS,1,NGAS,1,NGAS)
      END IF
*
*. Loop over symmetries of each GAS
*
      MAXLEX = 0
      IFIRST = 1
      ISTRBS = 1
 1000 CONTINUE
        IF(IFIRST .EQ. 1 ) THEN
          DO IGAS = 1, NGASL - 1
            ISMFGS(IGAS) = MINVAL(IGAS)
          END DO
        ELSE
*. Next distribution of symmetries in NGAS -1
C        NXTNUM2(INUM,NELMNT,MINVAL,MAXVAL,NONEW)
C        CALL NXTNUM2(ISMFGS,NGASL-1,1,MAXVAL,NONEW)
C        CALL NXTNUM3(IOCA,NGAS,IGSMIN,IGSMAX,NONEW)
         CALL NXTNUM3(ISMFGS,NGASL-1,MINVAL,MAXVAL,NONEW)
         IF(NONEW.NE.0) GOTO 1001
        END IF
        IFIRST = 0
        IF(NTEST.GE.200) THEN
          WRITE(6,*) ' next symmetry of NGASL-1 spaces '
          CALL IWRTMA(ISMFGS,NGASL-1,1,NGASL-1,1)
        END IF
*. Symmetry of NGASL -1 spaces given, symmetry of total space
        ISTSMM1 = 1
        DO IGAS = 1, NGASL -1
C         SYMCOM(ITASK,IOBJ,I1,I2,I12)
          CALL  SYMCOM(3,1,ISTSMM1,ISMFGS(IGAS),JSTSMM1)
          ISTSMM1 = JSTSMM1
C?        write(6,*) ' ISTSMM1 : ', ISTSMM1
        END DO
*. required sym of SPACE NGASL
        CALL SYMCOM(2,1,ISTSMM1,ISMGSN,ISPGRPSM)
        ISMFGS(NGASL) = ISMGSN
*
        DO IGAS = NGASL+1,NGAS
          ISMFGS(IGAS) = 1
        END DO
        IF(NTEST.GE.200) THEN
          WRITE(6,*) ' Next symmetry distribution '
          CALL IWRTMA(ISMFGS,1,NGAS,1,NGAS)
        END IF
*. Obtain all strings of this symmetry
        CALL GETSTRN_GASSM_SPGP( ISMFGS,
     &                           ITPFGS,
     &                          ISTR(1+NEL*(ISTRBS-1)),
     &                             NSTR,
     &                              NEL,
*
     &                          NNSTSGP,
     &                          IISTSGP)
*. Reorder Info : Lexical => actual number
        IF(IDOREO.NE.0) THEN
*. Lexical number of NEL electrons
*. Can be made smart by using common factor for first NGAS-1 spaces
          DO JSTR = ISTRBS, ISTRBS+NSTR-1
            LEX = 1
            DO IEL = 1, NEL
              LEX = LEX + IZ(ISTR(IEL+NEL*(JSTR-1)),IEL)
            END DO
C           WRITE(6,*) ' string '
C           CALL IWRTMA(ISTR(1,JSTR),1,NEL,1,NEL)
C           WRITE(6,*) ' JSTR and LEX ', JSTR,LEX
*
            MAXLEX = MAX(MAXLEX,LEX)
            IREO(LEX) = JSTR
          END DO
        END IF
*
        ISTRBS = ISTRBS + NSTR
*. ready for next symmetry distribution
        IF(NGAS-1.NE.0) GOTO 1000
 1001 CONTINUE
*. End of loop over symmetry distributions
      NSTR = ISTRBS - 1
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Number of strings generated ', NSTR
        WRITE(6,*)
        WRITE(6,*) ' Strings : '
        WRITE(6,*)
        CALL PRTSTR(ISTR,NEL,NSTR)
*
        IF(IDOREO.NE.0) THEN
          WRITE(6,*) 'Largest Lexical number obtained ', MAXLEX
          WRITE(6,*) ' Reorder array '
          CALL IWRTMA(IREO,1,NSTR,1,NSTR)
        END IF
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!  fock_update
!
!> @brief construct PDFT generalized fock matrix
!***********************************************************************

subroutine FOCK_update(F,FI,FP,D,P,Q,NQ,FINT,CMO)
! This subroutine is supposed to add the dft portions of the mcpdft fock
! matrix to the Fock matrix pieces that have already been built for the
! CASSCF portion.

! Calculation of the MCSCF fock matrix F(eq.(7) in I.J.Q.C.S14,175)
! FP is the matrix FI+FA (FP is FA at entrance)
! F is stored as a symmetry blocked square matrix, by columns.
! Note that F contains all elements, also the zero elements
! occurring when the first index is secondary.
!
! FockOcc is further constructed as well

use Index_Functions, only: iTri, nTri_Elem
use PrintLevel, only: DEBUG
use mcpdft_output, only: iPrLoc
use rasscf_global, only: ISTORD, ISTORP, nacpar, nFint, nTot3, nTot4
use general_data, only: nash, nbas, nish, norb, nsym, nTot1, nTot2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: iwp, wp, u6

implicit none
real(kind=wp), intent(inout) :: F(nTot4), FP(nTot1)
real(kind=wp), intent(in) :: FI(nTot1), D(nacpar), P(*), FINT(nFint), CMO(nTot2)
integer(kind=iwp), intent(in) :: NQ
real(kind=wp), intent(out) :: Q(NQ)
integer(kind=iwp) :: ipFMCSCF, iprlev, ISTAV(8), ISTD, ISTFCK, ISTFP, ISTP, ISTSQ(8), iSym, JSTF, NAO, NI, NIO, NM, NO, NO2, NOR, &
                     NP, NT, NTM, NTV, NUVX, NV, NVI, NVM
real(kind=wp) :: QNTM
real(kind=wp), allocatable :: TF(:)

IPRLEV = IPRLOC(4)

call mma_allocate(TF,NTOT4,Label='TF')
TF(:) = Zero

ISTSQ(1) = 0
ISTAV(1) = 0
do iSym=2,nSym
  ISTSQ(iSym) = ISTSQ(iSym-1)+nBas(iSym-1)**2
  ISTAV(iSym) = ISTAV(iSym-1)+nBas(iSym-1)*nAsh(iSym-1)
end do

! add FI to FA to obtain FP
FP(:ntot3) = FP(:ntot3)+FI(:ntot3)

ISTFCK = 0
ISTFP = 0
ISTD = 0
! A long loop over symmetry
do ISYM=1,NSYM
  NIO = NISH(ISYM)
  NAO = NASH(ISYM)
  NO = NORB(ISYM)
  NO2 = nTri_Elem(NO)
  if (NO == 0) cycle

  ! First index in F is inactive
  if (NIO /= 0) then
    do NP=1,NO
      do NI=1,NIO
        TF(ISTFCK+NO*(NP-1)+NI) = Two*FP(ISTFP+iTri(NP,NI))
      end do
    end do
  end if

  ! first index in F active
  if (NAO /= 0) then

    ISTP = ISTORP(ISYM)+1
    JSTF = ISTORD(ISYM)+1
    NUVX = (ISTORP(ISYM+1)-ISTORP(ISYM))/NAO

    ! first compute the Q-matrix (equation (19))
    !
    ! Q(m,v) = sum_wxy  (m|wxy) * P(wxy,v)
    !
    ! P is packed in xy and pre-multiplied by 2
    !                   and reordered
    call DGEMM_('N','N', &
                NO,NAO,NUVX, &
                One,FINT(JSTF),NO, &
                P(ISTP),NUVX, &
                Zero,Q,NO)

    ! Now Q should contain the additional 2-electron part of the fock matrix
    ! for mcpdft, for the active region, at least.
    !
    ! We should also have contributions from terms like FI and FA, too.
    ! FA takes care of the 1-RDM/2e- integral terms?
    ! FI takes care of the one-body hamiltonian and the occ/occ and occ/act
    ! contributions.

    ! Fock matrix
    NTM = 0
    do NT=1,NAO
      do NM=1,NO
        NTM = NTM+1
        QNTM = Q(NTM)
        do NV=1,NAO
          NVI = NV+NIO
          NTV = iTri(NT,NV)+ISTD
          NVM = iTri(NVI,NM)+ISTFP
          QNTM = QNTM+D(NTV)*FI(NVM)
        end do
        TF(ISTFCK+NO*(NM-1)+NT+NIO) = QNTM
      end do
    end do
  end if

  ! End of long loop over symmetry
  ISTFCK = ISTFCK+NO**2
  ISTFP = ISTFP+NO2
  ISTD = ISTD+nTri_Elem(NAO)
end do

F(:ntot4) = F(:ntot4)+TF(:ntot4)

! Calculate Fock matrix for occupied orbitals.

! I am going to add the Fock matrix temporarily to the Runfile.
! I don't want to construct it again in MCLR in the case of gradients.
if (iPrLev >= DEBUG) then
  write(u6,'(A)') ' MCSCF Fock-matrix in MO-basis'
  ipFMCSCF = 1
  do iSym=1,nSym
    nOr = nOrb(iSym)
    call RecPrt(' ',' ',F(ipFMCSCF),nOr,nOr)
    ipFMCSCF = ipFMCSCF+nOr*nOr
  end do
end if

! This will set FockOcc in wadr
call FOCKOC(Q,F,CMO)

call mma_deallocate(TF)

end subroutine FOCK_update

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Get_TUVX(PUVX,TUVX)
************************************************************************
*                                                                      *
*     extract the subset of ERIs (tu!vx) from the set (pu!vx)          *
*                                                                      *
*     calling arguments:                                               *
*     PUVX    : input, array of real                                   *
*               ERIs with indices (pu!vx)                              *
*               (three active, one general)                            *
*     TUVX    : output, array of real                                  *
*               ERIs with indices (tu!vx)                              *
*               (four active)                                          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension PUVX(*), TUVX(*)

#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='XXXXXXXX')

      Integer off_Ash(mxSym), off_PUVX(mxSym)

      iTri(i) = (i*i-i)/2

      lSym_tmp=lSym
*     generate offsets
      iStack = 0
      Do iSym = 1,nSym
        off_Ash(iSym) = iStack
        iStack = iStack + nAsh(iSym)
      End Do

      iStack = 0
      Do iSym = 1,nSym
        off_PUVX(iSym) = iStack
        iOrb = nOrb(iSym)
        Do jSym = 1,nSym
          jAsh = nAsh(jSym)
          ijSym = 1 + ieor(iSym-1,jSym-1)
          Do kSym = 1,nSym
            kAsh = nAsh(kSym)
            Do lSym = 1,kSym
              lAsh = nAsh(lSym)
              klSym = 1 + ieor(kSym-1,lSym-1)
              If ( ijSym.eq.klSym) then
                kl_Orb_pairs = kAsh*lAsh
                If ( kSym.eq.lSym ) kl_Orb_pairs = (kAsh*kAsh+kAsh)/2
                iStack = iStack + iOrb*jAsh*kl_Orb_pairs
              End If
            End Do
          End Do
        End Do
      End Do

*     select integrals with all 4 indices active

      Do iSym = 1,nSym
        iOrb = nOrb(iSym)
        iAsh = nAsh(iSym)
        iIsh = nIsh(iSym)
        iPUVX = off_PUVX(iSym)
        Do jSym = 1,nSym
          jAsh = nAsh(jSym)
          ijSym = 1 + ieor(iSym-1,jSym-1)
          Do kSym = 1,nSym
            kAsh = nAsh(kSym)
            lSym = 1 + ieor(ijSym-1,kSym-1)
            lAsh = nAsh(lSym)

            If ( lSym.le.kSym .and.
     &           iAsh*jAsh*kAsh*lAsh.ne.0 ) then


c           Write(LF,*)'sym(p,w,x,y),offset= ',isym,jsym,ksym,lsym,iPUVX
c           call recprt('(pw|xy)','(1P,5D16.8)',PUVX(iPUVX+1),iorb*jAsh,
c     &                    kAsh*lAsh+Min(ijSym-2,0)*kAsh*(lAsh-1)/2)

              Do iV = 1,kAsh
                lMax = lAsh
                If ( kSym.eq.lSym ) lMax = iV
                Do iX = 1,lMax
                  Do iU = 1,jAsh
                    Do iP = 1,iOrb
                      iT = iP - iIsh
                      iPUVX=iPUVX+1
                      If ( iT.gt.0 .and. iT.le.iAsh ) then
                        iiT = iT + off_Ash(iSym)
                        iiU = iU + off_Ash(jSym)
                        If ( iiU.gt.iiT ) then
                          iiT = iU + off_Ash(jSym)
                          iiU = iT + off_Ash(iSym)
                        End If
*
                        iTU = iiU + iTri(iiT)
                        iiV = iV + off_Ash(kSym)
                        iiX = iX + off_Ash(lSym)
                        If ( iiX.gt.iiV ) then
                          iiV = iX + off_Ash(lSym)
                          iiX = iV + off_Ash(kSym)
                        End If
                        iVX = iiX + iTri(iiV)
                        If ( iVX.gt.iTU ) then
                          iTemp = iTU
                          iTU = iVX
                          iVX = iTemp
                        End If
                        iTUVX = iVX + iTri(iTU)
                        TUVX(iTUVX) = PUVX(iPUVX)
                      End If

                    End Do
                  End Do
                End Do
              End Do
            End If

          End Do
        End Do
      End Do
      LSYM=lSym_tmp

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SphInt(xyz,nCent,OfRef,lOR,RR0,Bf,l_Write,Label,dBf,ldB)

use Slapaf_Info, only: RefGeo, Weights
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCent
real(kind=wp), intent(in) :: xyz(3,nCent), OfRef(3,nCent)
real(kind=wp), intent(out) :: RR0, Bf(3,nCent)
logical(kind=iwp), intent(in) :: lOR, l_Write, ldB
character(len=8), intent(in) :: Label
real(kind=wp), intent(inout) :: dBf(3,nCent,3,nCent)
integer(kind=iwp) :: iCar, iCent, ixyz, jCent, jxyz
real(kind=wp) :: Fact, RR0_unscaled, SqInvTWeight, temp, Tweight, xWeight, yWeight
real(kind=wp), allocatable :: xyz_0(:,:)
integer(kind=iwp), external :: iDeg

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the radius of the hypersphere

call mma_allocate(xyz_0,3,nCent,Label='xyz_0')
!call RecPrt('SphInt: xyz',' ',xyz,3,nCent)
if (lOR) then
  xyz_0(:,:) = xyz(:,:)-OfRef(:,:)
  !call RecPrt('Ref:',' ',OfRef,3,nCent)
else
  xyz_0(:,:) = xyz(:,:)-RefGeo(:,:)
  !call RecPrt('Ref:',' ',RefGeo,3,nCent)
end if
RR0 = Zero
TWeight = Zero
do iCent=1,nCent
  Fact = real(iDeg(xyz(1,iCent)),kind=wp)
  xWeight = Fact*Weights(iCent)
  TWeight = TWeight+xWeight
  !write(u6,*) 'xWeight=',xWeight
  do ixyz=1,3
    !write(u6,*) xyz_0(ixyz,iCent)
    RR0 = RR0+xWeight*xyz_0(ixyz,iCent)**2
  end do
end do
RR0_unscaled = sqrt(RR0)

! RR0_unscaled is the real (weighthed) distance,
! RR0 is scaled by 1/Sqrt(TWeight) and so are the derivatives

SqInvTWeight = One/sqrt(TWeight)
RR0 = RR0_unscaled*SqInvTWeight

if (l_Write) write(u6,'(2A,F18.8,A)') Label,' : Radius of h-sphere= ',RR0,' au (weighted/sqrt(total weight))'
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the WDC B-matrix

!FIXME: revise the symmetry
do iCent=1,nCent
  Fact = real(iDeg(xyz(1,iCent)),kind=wp)
  xWeight = Fact*Weights(iCent)
  do iCar=1,3
    if (RR0_unscaled /= Zero) then
      Bf(iCar,iCent) = xWeight*xyz_0(iCar,iCent)/RR0_unscaled*SqInvTWeight
    else

      ! If we are standing on the reference point the gradient
      ! is not well defined.

      Bf(iCar,iCent) = Zero
    end if
  end do
end do
!call RecPrt('Bf',' ',Bf,3,nCent)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the cartesian derivative of the B-Matrix.

!FIXME: revise the symmetry
if (ldB) then
  dBf(:,:,:,:) = Zero
  if (RR0 /= Zero) then
    do iCent=1,nCent
      Fact = real(iDeg(xyz(1,iCent)),kind=wp)
      xWeight = Fact*Weights(iCent)
      do ixyz=1,3
        do jCent=1,nCent
          Fact = real(iDeg(xyz(1,jCent)),kind=wp)
          yWeight = Fact*Weights(jCent)
          do jxyz=1,3
            temp = Zero
            if ((ixyz == jxyz) .and. (iCent == jCent)) temp = RR0_unscaled
            temp = temp-yWeight*xyz_0(ixyz,iCent)*xyz_0(jxyz,jCent)/RR0_unscaled
            temp = (xWeight*temp)/RR0_unscaled**2
            dBf(ixyz,iCent,jxyz,jCent) = temp*SqInvTWeight
          end do
        end do
      end do
    end do
  end if
  !call RecPrt('dBf',' ',dBf,3*nCent,3*nCent)

end if

call mma_deallocate(xyz_0)

return

end subroutine SphInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Get_Vir_Select(irc,CMO,XMO,Eorb,Smat,Name,NamAct,
     &                   ind_V,nSym,nActa,mOrb,nBas,ortho,n_OK)

************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
      Real*8  CMO(*), XMO(*), Eorb(*), Smat(*)
      Integer irc, nSym, nActa, mOrb(nSym), nBas(nSym), n_OK(nSym)
      Integer ind_V(*)
      Character*(LENIN8)  Name(*)
      Character*(LENIN) NamAct(nActa)
      Logical ortho
#include "WrkSpc.fh"
      Character*(LENIN) tmp
************************************************************************
      kD(i) = iWork(ip_iD-1+i)
      lD(i) = iWork(ip_iD+nOrbmx-1+i)
************************************************************************
*
      irc=0
*
      nBmx=0
      nOrbmx=0
      Do iSym=1,nSym
         nBmx=Max(nBmx,nBas(iSym))
         nOrbmx=Max(nOrbmx,mOrb(iSym))
      End Do
      Call GetMem('iD','Allo','Inte',ip_iD,2*nOrbmx)
      Call GetMem('LCMO','Allo','Real',ip_C,(5*nBmx+nOrbmx+2)*nOrbmx)
      lScr=nBmx*nOrbmx
      ip_CC=ip_C+lScr
      ip_X=ip_CC+lScr
      iZ=ip_X+lScr
      ipScr=iZ+lScr
      ip_U=ipScr+lScr
      ip_Fock=ip_U+nOrbmx**2
      jp_Fock=ip_Fock+nOrbmx
*
      iOff=0
      jOff=0
      kOff=0
      lOff=0
      Do iSym=1,nSym

         iS=kOff+1
         n_OK(iSym)=0
         n_KO=0
         Do i=1,mOrb(iSym)
            ja=iOff+ind_V(i+iOff)
            tmp=Name(ja)(1:LENIN)
            jfr=jOff+nBas(iSym)*(i-1)+1
            kx=0
*
*            write(6,*)' We simulate Afreeze with all Vir'
*            kx=1
*
            Do j=1,nActa
               If(NamAct(j).eq.tmp) kx=kx+1
            End Do
            If (kx.gt.0) Then
                 jX=ip_X+nBas(iSym)*n_OK(iSym)
                 call dcopy_(nBas(iSym),Xmo(jfr),1,Work(jX),1)
                 iWork(ip_iD+n_OK(iSym))=i
                 n_OK(iSym)=n_OK(iSym)+1
            Else
                 jZ=iZ+nBas(iSym)*n_KO
                 call dcopy_(nBas(iSym),Xmo(jfr),1,Work(jZ),1)
                 iWork(ip_iD+nOrbmx+n_KO)=i
                 n_KO=n_KO+1
            EndIf
         End Do
*
         If (.not.ortho) Then

            Call Ortho_orb(Work(ip_X),Smat(iS),nBas(iSym),
     &                     n_OK(iSym),2,.false.)
            Call Ortho_orb(Work(iZ),Smat(iS),nBas(iSym),
     &                     n_KO,2,.false.)
         EndIf
*
         nBx=Max(1,nBas(iSym))
         mOx=Max(1,mOrb(iSym))
*
         Call DGEMM_('T','N',mOrb(iSym),nBas(iSym),nBas(iSym),
     &                           1.0d0,Cmo(jOff+1),nBx,
     &                                 Smat(iS),nBx,
     &                           0.0d0,Work(ip_CC),mOx)
*
         If (n_KO .gt.0 ) Then
           Call DGEMM_('N','N',mOrb(iSym),n_KO,nBas(iSym),
     &                              1.0d0,Work(ip_CC),mOx,
     &                                    Work(iZ),nBx,
     &                              0.0d0,Work(ip_U),mOx)
*
           Call Get_Can_Lorb(Eorb(lOff+1),Work(ip_Fock),n_KO,mOrb(iSym),
     &                        iWork(ip_iD+nOrbmx),Work(ip_U),iSym)
*
           Call DGEMM_('N','N',nBas(iSym),n_KO,n_KO,
     &                  1.0d0,Work(iZ),nBx,
     &                        Work(ip_U),n_KO,
     &                  0.0d0,Work(ipScr),nBx)
*
*  Reorder the final MOs such that those of the active site come first
           km=jOff+nBas(iSym)*n_OK(iSym)+1
           call dcopy_(nBas(iSym)*n_KO,Work(ipScr),1,Cmo(km),1)
           call dcopy_(nOrbmx,Work(ip_Fock),1,Work(jp_Fock),1)
         EndIf
*
         Call DGEMM_('N','N',mOrb(iSym),n_OK(iSym),nBas(iSym),
     &                           1.0d0,Work(ip_CC),mOx,
     &                                 Work(ip_X),nBx,
     &                           0.0d0,Work(ip_U),mOx)
*
         Call Get_Can_Lorb(Eorb(lOff+1),Work(ip_Fock),n_OK(iSym),
     &                     mOrb(iSym),
     &                     iWork(ip_iD),Work(ip_U),iSym)
*
         nOx=Max(1,n_OK(iSym))
         Call DGEMM_('N','N',nBas(iSym),n_OK(iSym),n_OK(iSym),
     &                1.0d0,Work(ip_X),nBx,
     &                      Work(ip_U),nOx,
     &                0.0d0,Work(ipScr),nBx)
*
         Do i=1,n_OK(iSym)
            j=kD(i)
            k=lOff+i
            l=ip_Fock+j-1
            Eorb(k)=Work(l)
         End Do
         km=jOff+1
         call dcopy_(nBas(iSym)*n_OK(iSym),Work(ipScr),1,Cmo(km),1)
*
         Do i=1,n_KO
            j=lD(i)
            k=lOff+n_OK(iSym)+i
            l=jp_Fock+j-1
            Eorb(k)=Work(l)
         End Do
*
         iOff=iOff+nBas(iSym)
         jOff=jOff+nBas(iSym)*mOrb(iSym)
         kOff=kOff+nBas(iSym)**2
         lOff=lOff+mOrb(iSym)
      End Do
*
      Call GetMem('LCMO','Free','Real',ip_C,(5*nBmx+nOrbmx+2)*nOrbmx)
      Call GetMem('iD','Free','Inte',ip_iD,2*nOrbmx)
*
      Return
      End
************************************************************************
*                                                                      *
************************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function CHO_TABIND(TABLE,LKEY,NTABLE,EOINP,LEOINP,NEOINP,WORD)
!
! Purpose: table lookup.
!          First, try to find WORD in TABLE. If success, return ID,
!          else, check if WORD is a special string
!          in EOINP (if any supplied). If success, return NTABLE+1,
!          else, return -1.

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: CHO_TABIND
integer(kind=iwp), intent(in) :: LKEY, NTABLE, LEOINP, NEOINP
character(len=LKEY), intent(in) :: TABLE(NTABLE), WORD
character(len=LEOINP), intent(in) :: EOINP(NEOINP)
integer(kind=iwp) :: IJUMP, LCMP
logical(kind=iwp) :: Test

! Find entry.
! -----------

if ((LKEY > 0) .and. (NTABLE > 0)) then
  IJUMP = 1
  Test = IJUMP <= NTABLE
  if (Test) Test = TABLE(IJUMP) /= WORD
  do while (Test)
    IJUMP = IJUMP+1
    Test = IJUMP <= NTABLE
    if (Test) Test = TABLE(IJUMP) /= WORD
  end do
  if (IJUMP > NTABLE) then
    if ((LEOINP > 0) .and. (NEOINP > 0)) then
      LCMP = min(LEOINP,LKEY)
      IJUMP = 1
      Test = (IJUMP <= NEOINP)
      if (Test) Test = EOINP(IJUMP)(1:LCMP) /= WORD(1:LCMP)
      do while (Test)
        IJUMP = IJUMP+1
        Test = IJUMP <= NTABLE
        if (Test) Test = EOINP(IJUMP)(1:LCMP) /= WORD(1:LCMP)
      end do
      if (IJUMP > NEOINP) then
        CHO_TABIND = -1
      else
        CHO_TABIND = NTABLE+1
      end if
    else
      CHO_TABIND = -1
    end if
  else
    CHO_TABIND = IJUMP
  end if
else
  CHO_TABIND = -1
end if

end function CHO_TABIND

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_Xred (X,dimbe,addbe,dimga,addga)
c
c        check X(be,u,ga,v)
c        do X clenu nieje zahrnuty prispevok od Aex, preto picuje
c
        implicit none
#include "chcc1.fh"
        integer dimbe,addbe,dimga,addga
         real*8 X(1:dimbe,1:no,1:dimga,1:no)
c
        integer be,u,ga,v,bad
        integer a,i,j
        real*8 s,s1
c
        bad=0
        do v=1,no
        do ga=addga+1,addga+dimga
        do u=1,no
        do be=addbe+1,addbe+dimbe
c
          s=0.0d0
c
c         X2 (T24)   + Gvv(a,be)   . t2(ga,a,v,u)
          s1=0.0d0
          do a=1,nv
           s1=s1+Gvvc(be,a)*T2c(a,ga,u,v)
          end do
          s=s+2.0d0*s1
c
c         X3 (T25)   - Goo(i,u)    . t2(ga,be,v,i)
          s1=0.0d0
          do i=1,no
           s1=s1+Gooc(i,u)*T2c(ga,be,v,i)
          end do
          s=s-2.0d0*s1
c
c
c          T1 cleny
          s1=0.0d0
c
          do a=1,nv
           s1=s1+Q3(a,ga,be,u)*T1c(a,v)
          end do
c
          do i=1,no
           s1=s1-Q1(be,u,i,v)*T1c(ga,i)
          end do
c
          do i=1,no
          do a=1,nv
           s1=s1-(Q22(a,ga,i,u)*T1c(be,i))*T1c(a,v)
           s1=s1-(Q21(a,i,be,u)*T1c(a,v))*T1c(ga,i)
          end do
          end do
c
cred          s=s+2.0d0*s1
c
c
c         X4 (T22)   + sum(i,j)   [ Ta(be,ga,i,j) . A(i,j,u,v)  ]
          s1=0.0d0
          do i=1,no
           do j=1,no
          s1=s1+Ac(i,j,u,v)*(T2c(be,ga,i,j)+T1c(be,i)*T1c(ga,j))
          end do
          end do
           s=s+s1
c
c
c         X1   <-  Q(be,u,i,a) . (2 t2(ga,a,v,i) - t2(ga,a,i,v))
c         calc as (2J(be,i,u,a)-K(i,be,u,a)*(2t2(a,ga,i,v)-t2(ga,a,i,v)
          s1=0.d0
          do i=1,no
          do a=1,nv
          s1=s1+(2.0d0*Jc(be,i,u,a)-Kc(i,be,u,a))*
     c          (2.0d0*T2c(a,ga,i,v)-T2c(ga,a,i,v))
          end do
          end do
          s=s+s1
c
c         <- V1(be',u,ga',v)
          s1=Q21(be,u,ga,v)
          s=s+s1

           if (abs(X(be-addbe,u,ga-addga,v)-s).gt.1.0d-10) then
            bad=bad+1
          end if
c
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck X :',bad
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Torsion_List(nq,nsAtom,iIter,nIter,Cx,Process,Valu,nB,qLbl,iRef,fconst,rMult,LuIC,Indq,iPrv,Proc_dB,iTabBonds,nBonds, &
                        iTabAI,mAtoms,iTabAtoms,nMax,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,nqB)

use Symmetry_Info, only: iOper, nIrrep
use Slapaf_Info, only: ANr, AtomLbl, Fragments_Bond, jStab, Magic_Bond, nStab, vdW_Bond
use ddvdt, only: A_Trsn, aAV, f_Const_Min, rAV, rkt
use Molcas, only: LenIn
use Constants, only: Zero, One, Two, Ten, Pi, Angstrom, deg2rad
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Slapaf_Info, only: BondType
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nsAtom, iIter, nIter, nB, iRef, LuIC, iPrv, nBonds, iTabBonds(3,nBonds), mAtoms, &
                                 iTabAI(2,mAtoms), nMax, iTabAtoms(2,0:nMax,mAtoms), nB_Tot, ndB_Tot
integer(kind=iwp), intent(inout) :: nq, Indq(3,nB), mB_Tot, mdB_Tot, iBM(nB_Tot), idBM(2,ndB_Tot), nqB(nB)
real(kind=wp), intent(in) :: Cx(3,nsAtom,nIter)
logical(kind=iwp), intent(in) :: Process, Proc_dB
real(kind=wp), intent(inout) :: Valu(nB,nIter), fconst(nB), rMult(nB), BM(nB_Tot), dBM(ndB_Tot)
character(len=14), intent(inout) :: qLbl(nB)
integer(kind=iwp), parameter :: mB = 4*3
integer(kind=iwp) :: iAtom, iAtom_, iBond, iBondType, iCase, iDCR(4), iDCRR(0:7), iDCRS(0:7), iDCRT(0:7), iDCRX(0:7), iDCRY(0:7), &
                     iDeg, iE1, iE2, iE3, iE4, iF1, iF2, iF3, iF4, ij, ijDCR, iMagic, Ind(4), iNeighbor, ir, iStabM(0:7), &
                     iStabN(0:7), iStabO(0:7), jAtom, jAtom_, jBond, jBondType, jr, kAtom, kAtom_, kBond, kBondType, kDCRR, kDCRS, &
                     kDCRT, kDCRTS, kl, kr, Lambda, lAtom, lAtom_, lNeighbor, lr, mCent, mE, nCent, nCoBond_j, nCoBond_k, nDCRR, &
                     nDCRS, nDCRT, nDCRX, nDCRY, nE, nFgBond_j, nFgBond_k, nNeighbor_j, nNeighbor_k, nqT, nStabM, nStabN, nStabO
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif
real(kind=wp) :: A(3,4), Alpha, CosFact, CosFi, CosThr, Deg, delta, Diff, f_Const, f_Const_ij, f_Const_ij_Ref, f_Const_ijk, &
                 f_Const_ijk_Ref, f_Const_Ref, Fact, Fi2, Fi3, Grad(mB), Grad_ref(9), Hess(mB**2), Prv(3,4), r0, Range1, Range2, &
                 Range3, Rbc, RbcCov, Ref(3,4), rij2, rij2_Ref, rjk2, rjk2_Ref, rkl2, rkl2_Ref, Val, Val_Prv
logical(kind=iwp) :: Help, MinBas
character(len=LenIn+4) :: Lbls(4)
character(len=14) :: Label
integer(kind=iwp), parameter :: iChOp(0:7) = [1,1,1,2,1,2,2,3]
real(kind=wp), parameter :: f_Const_Min2 = 1.0e-1_wp
character(len=*), parameter :: ChOp(0:7) = ['E  ','X  ','Y  ','XY ','Z  ','XZ ','YZ ','XYZ']
integer(kind=iwp), external :: iTabRow, nCoBond, nFgBond
real(kind=wp), external :: CovRadT
logical(kind=iwp), external :: R_Stab_A, Torsion_Check

!                                                                      *
!***********************************************************************
!                                                                      *
if (nBonds < 3) return

nqT = 0
Hess(:) = Zero

! Loop over dihedrals

MinBas = .false.
if (MinBas) then
  Fact = 1.3_wp
else
  Fact = One
end if
nCent = 4

! Order will play a role here. That is, the torsion
! A-R(B)-T(C)-TS(D) is NOT identical to
! A-R(B)-TS(D)-T(C). Hence we put no restriction on the
! pairs AB and CD. However, for the pair of pairs we have
! that order is irrelevant, i.e. ABCD is identical to
! DCBA. To guarantee this we limit the pairs to the unique
! combinations.

! Start with the center bond: B-C

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'List of all available bonds'
write(u6,*)
do iBond=1,nBonds
  iBondType = iTabBonds(3,iBond)
  write(u6,*)
  jAtom_ = iTabBonds(1,iBond)
  kAtom_ = iTabBonds(2,iBond)
  jAtom = iTabAI(1,jAtom_)
  kAtom = iTabAI(1,kAtom_)
  write(u6,*) 'Atoms-pair:  ',AtomLbl(jAtom),AtomLbl(kAtom)
  write(u6,*) 'iBond,iBondType=',iBond,Bondtype(min(3,iBondType))
end do
#endif
do iBond=1,nBonds

  ! The center bond may be a "magic" bond
  iBondType = iTabBonds(3,iBond)
# ifdef _DEBUGPRINT_
  write(u6,*)
  jAtom_ = iTabBonds(1,iBond)
  kAtom_ = iTabBonds(2,iBond)
  jAtom = iTabAI(1,jAtom_)
  kAtom = iTabAI(1,kAtom_)
  write(u6,*) 'Atoms-pair:',AtomLbl(jAtom),AtomLbl(kAtom)
  write(u6,*) 'iBond,iBondType=',iBond,Bondtype(min(3,iBondType))
# endif

  ! Center bond should not be a van der Waals bond,
  ! anything else goes!

  if (iBondType == vdW_Bond) cycle

  ! Extract index to the center atom in an "Magic" bond if this
  ! is a magic bond.

  if (iBondType > Magic_Bond) then
    iMagic = iBondType-3
  else
    iMagic = 0
  end if

  ! cases: BC or CB

  do iCase=1,2

    if (iCase == 1) then
      jAtom_ = iTabBonds(1,iBond)
      kAtom_ = iTabBonds(2,iBond)
    else
      jAtom_ = iTabBonds(2,iBond)
      kAtom_ = iTabBonds(1,iBond)
    end if

    jAtom = iTabAI(1,jAtom_)
    kAtom = iTabAI(1,kAtom_)
    jr = iTabRow(ANr(jAtom))
    kr = iTabRow(ANr(kAtom))
    Ind(2) = jAtom
    Ind(3) = kAtom
    iDCR(2) = iTabAI(2,jAtom_)
    if (R_Stab_A(iDCR(2),jStab(0,jAtom),nStab(jAtom))) iDCR(2) = iOper(0)
    iDCR(3) = iTabAI(2,kAtom_)
    if (R_Stab_A(iDCR(3),jStab(0,kAtom),nStab(kAtom))) iDCR(3) = iOper(0)
#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) 'R,T=',AtomLbl(jAtom),ChOp(iDCR(2)),AtomLbl(kAtom),ChOp(iDCR(3))
    write(u6,*)
#   endif

    nNeighbor_j = iTabAtoms(1,0,jAtom_)
    nCoBond_j = nCoBond(jAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
    nFgBond_j = nFgBond(jAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
    nNeighbor_k = iTabAtoms(1,0,kAtom_)
    nCoBond_k = nCoBond(kAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
    nFgBond_k = nFgBond(kAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
    if ((nCoBond_j < 2) .and. (nFgBond_j == 0)) cycle
    if ((nCoBond_k < 2) .and. (nFgBond_k == 0)) cycle

#   ifdef _DEBUGPRINT_
    write(u6,*) 'nNeighbor_j,nNeighbor_k=',nNeighbor_j,nNeighbor_k
    write(u6,*)
#   endif

    do iNeighbor=1,nNeighbor_j
      iAtom_ = iTabAtoms(1,iNeighbor,jAtom_)
      !nCoBond_i = nCoBond(iAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
      !nFgBond_i = nFgBond(iAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
      jBond = iTabAtoms(2,iNeighbor,jAtom_)
      if (jBond == iBond) cycle
      jBondType = iTabBonds(3,jBond)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'jBond,jBondType=',jBond,BondType(min(3,jBondType))
#     endif
      if ((jBondType == vdW_Bond) .or. (jBondType == Magic_Bond)) cycle
      !if ((nCoBond_j > 2) .and. (nCoBond_i >= 4) .and. (nFgBond_i == 0)) cycle
      !if ((nCoBond_i >= 8) .and. (nCoBond_j >= 8) .and. (nCoBond_k >= 8)) cycle
      iAtom = iTabAI(1,iAtom_)
      if ((iBondType > Magic_Bond) .and. (iAtom == iMagic)) cycle
      ir = iTabRow(ANr(iAtom))
      Ind(1) = iAtom
      iDCR(1) = iTabAI(2,iAtom_)
      if (R_Stab_A(iDCR(1),jStab(0,iAtom),nStab(iAtom))) iDCR(1) = iOper(0)

      ! Torsion should be A-..., eliminate P(A)-...

      if (iDCR(1) /= iOper(0)) cycle

      ! Eliminate A-R(B)-T(C)-TS(C) over A-B-RT(C)-RTS(D)
      ! Proceed if A-R-T(C)-TS(C)

      if (R_Stab_A(iDCR(2),jStab(0,iAtom),nStab(iAtom)) .and. (iDCR(2) /= iOper(0))) cycle

      ! Eliminate A-R(B)-T(C)-TS(D) over A-R(B)-C-S(D)
      ! Proceed if A-R(B)-C-S(D)

      if (R_Stab_A(iDCR(3),jStab(0,iAtom),nStab(iAtom)) .and. R_Stab_A(iDCR(3),jStab(0,jAtom),nStab(jAtom)) .and. &
          (iDCR(3) /= iOper(0))) cycle
#     ifdef _DEBUGPRINT_
      write(u6,*)
      write(u6,*) 'E=',AtomLbl(iAtom),ChOp(iDCR(1))
#     endif
      A(:,1) = Cx(:,iAtom,iIter)
      Ref(:,1) = Cx(:,iAtom,iRef)
      Prv(:,1) = Cx(:,iAtom,iPrv)
      Help = (ir > 3) .or. (jr > 3)

      ! Form double coset representatives for (iAtom,jAtom)

      call DCR(Lambda,jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),iDCRR,nDCRR)
      kDCRR = iDCR(2)
#     ifdef _DEBUGPRINT_
      write(u6,'(10A)') 'R={',(ChOp(iDCRR(i)),i=0,nDCRR-1),'}  '
      write(u6,'(2A)') 'R=',ChOp(kDCRR)
#     endif
      call OA(kDCRR,Cx(:,jAtom,iIter),A(:,2))
      call OA(kDCRR,Cx(:,jAtom,iRef),Ref(:,2))
      call OA(kDCRR,Cx(:,jAtom,iPrv),Prv(:,2))
#     ifdef _DEBUGPRINT_
      write(u6,'(10A)') 'U={',(ChOp(jStab(i,iAtom)),i=0,nStab(iAtom)-1),'}  '
      write(u6,'(10A)') 'V={',(ChOp(jStab(i,jAtom)),i=0,nStab(jAtom)-1),'}  '
#     endif

      ! Form stabilizer for (iAtom,jAtom)

      call Inter(jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),iStabM,nStabM)
#     ifdef _DEBUGPRINT_
      write(u6,'(10A)') 'M={',(ChOp(iStabM(i)),i=0,nStabM-1),'}  '
#     endif
      if (Help) then
        rij2 = (Ref(1,1)-Ref(1,2))**2+(Ref(2,1)-Ref(2,2))**2+(Ref(3,1)-Ref(3,2))**2
        r0 = Zero
        Alpha = Zero
        f_Const_ij = Zero
        f_Const_ij_Ref = f_Const_ij
      else
        r0 = rAV(ir,jr)
        Alpha = aAv(ir,jr)
        rij2_Ref = (Ref(1,1)-Ref(1,2))**2+(Ref(2,1)-Ref(2,2))**2+(Ref(3,1)-Ref(3,2))**2
        f_Const_ij_Ref = rkt*exp(Alpha*(r0**2-rij2_Ref))
        rij2 = (A(1,1)-A(1,2))**2+(A(2,1)-A(2,2))**2+(A(3,1)-A(3,2))**2
        f_Const_ij = rkt*exp(Alpha*(r0**2-rij2))
      end if

      do lNeighbor=1,nNeighbor_k
        lAtom_ = iTabAtoms(1,lNeighbor,kAtom_)
        !nCoBond_l = nCoBond(lAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
        !nFgBond_l = nFgBond(lAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
        lAtom = iTabAI(1,lAtom_)
        Ind(4) = lAtom
        iDCR(4) = iTabAI(2,lAtom_)
        if (R_Stab_A(iDCR(4),jStab(0,lAtom),nStab(lAtom))) iDCR(4) = iOper(0)
        kBond = iTabAtoms(2,lNeighbor,kAtom_)
        if (kBond == iBond) cycle
        if (lAtom_ == iAtom_) cycle
        kBondType = iTabBonds(3,kBond)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'kBond,kBondType=',kBond,Bondtype(min(3,kBondType))
#       endif
        if ((kBondType == vdW_Bond) .or. (kBondType == Magic_Bond)) cycle
        !if ((nCoBond_k > 2) .and. (nCoBond_l >= 4) .and. (nFgBond_l == 0)) cycle
        !if ((nCoBond_j >= 8) .and. (nCoBond_k >= 8) .and. (nCoBond_l >= 8)) cycle

        if ((iBondType > Magic_Bond) .and. (lAtom == iMagic)) cycle
        lr = iTabRow(ANr(lAtom))
        kDCRT = iDCR(3)
        kDCRTS = iDCR(4)
        kDCRS = ieor(kDCRTS,kDCRT)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'i,j,k,l=',AtomLbl(iAtom),ChOp(iDCR(1)),AtomLbl(jAtom),ChOp(iDCR(2)),AtomLbl(kAtom),ChOp(iDCR(3)), &
                    AtomLbl(lAtom),ChOp(iDCR(4))
#       endif

        ! Eliminate A-R(B)-T(C)-TS(D) over A-TSR(B)-S(C)-D

        if (R_Stab_A(iDCR(4),jStab(0,iAtom),nStab(iAtom)) .and. R_Stab_A(iDCR(4),jStab(0,jAtom),nStab(jAtom)) .and. &
            R_Stab_A(iDCR(4),jStab(0,kAtom),nStab(kAtom)) .and. (iDCR(4) /= iOper(0))) cycle

        nE = 1
        if (iDCR(2) == iOper(0)) nE = nE+1
        if (iDCR(3) == iOper(0)) nE = nE+1
        if (iDCR(4) == iOper(0)) nE = nE+1
        mE = 1
        if (R_Stab_A(iDCR(4),jStab(0,iAtom),nStab(iAtom))) mE = mE+1
        if (R_Stab_A(ieor(iDCR(4),iDCR(3)),jStab(0,kAtom),nStab(kAtom))) mE = mE+1
        if (R_Stab_A(ieor(iDCR(4),iDCR(2)),jStab(0,jAtom),nStab(jAtom))) mE = mE+1
        if (nE < mE) cycle
        if ((nE == mE) .and. (iAtom > lAtom)) cycle

#       ifdef _DEBUGPRINT_
        write(u6,*)
        write(u6,*) 'TS=',AtomLbl(lAtom),ChOp(iDCR(4))
#       endif

        Help = (ir > 3) .or. (jr > 3) .or. (kr > 3) .or. (lr > 3)

        write(Label,'(A,I2,A,I2,A,I2,A,I2,A)') 'D(',iAtom,',',jAtom,',',kAtom,',',lAtom,')'
#       ifdef _DEBUGPRINT_
        write(u6,'(A,I2,A,I2,A,I2,A,I2,A)') 'D(',iAtom,',',jAtom,',',kAtom,',',lAtom,')'
#       endif

        ! Form double coset representatives for (kAtom,lAtom)

        call DCR(Lambda,jStab(0,kAtom),nStab(kAtom),jStab(0,lAtom),nStab(lAtom),iDCRS,nDCRS)
#       ifdef _DEBUGPRINT_
        write(u6,'(10A)') 'S={',(ChOp(iDCRS(i)),i=0,nDCRS-1),'}  '
        write(u6,'(10A)') 'W={',(ChOp(jStab(i,kAtom)),i=0,nStab(kAtom)-1),'}  '
        write(u6,'(10A)') 'X={',(ChOp(jStab(i,lAtom)),i=0,nStab(lAtom)-1),'}  '
        write(u6,'(2A)') 'S=',ChOp(kDCRS)
#       endif

        Ref(1:3,3) = Cx(:,kAtom,iRef)
        call OA(kDCRS,Cx(:,lAtom,iRef),Ref(:,4))
        Prv(1:3,3) = Cx(:,kAtom,iPrv)
        call OA(kDCRS,Cx(:,lAtom,iPrv),Prv(:,4))

        if (Help) then
          rkl2 = (Ref(1,3)-Ref(1,4))**2+(Ref(2,3)-Ref(2,4))**2+(Ref(3,3)-Ref(3,4))**2
        else
          r0 = rAV(kr,lr)
          rkl2 = (Ref(1,3)-Ref(1,4))**2+(Ref(2,3)-Ref(2,4))**2+(Ref(3,3)-Ref(3,4))**2
        end if

        ! Form stabilizer for (kAtom,lAtom)

        call Inter(jStab(0,kAtom),nStab(kAtom),jStab(0,lAtom),nStab(lAtom),iStabN,nStabN)

#       ifdef _DEBUGPRINT_
        write(u6,'(10A)') 'N={',(ChOp(iStabN(i)),i=0,nStabN-1),'}  '
#       endif

        ! Form double coset representatives for
        ! ((iAtom,jAtom),(kAtom,lAtom))

        call DCR(Lambda,iSTabM,nStabM,iStabN,nStabN,iDCRT,nDCRT)

        ! Take care of some special cases which normally
        ! are not included. If A=B we will normally exclude
        ! the pairs R(A)-A and TS(C)-T(C).

        iDCRX(0:nDCRT-1) = iDCRT(0:nDCRT-1)
        iDCRY(0:nDCRT-1) = iDCRT(0:nDCRT-1)
        nDCRX = nDCRT
        nDCRY = nDCRT
        if (iAtom == jAtom) then
          !write(u6,*) ' Special fix'
          call Union(iDCRX,nDCRX,iDCRY,nDCRY,kDCRR,iDCRT,nDCRT)
        else if (kAtom == lAtom) then
          !write(u6,*) ' Special fix'
          call Union(iDCRX,nDCRX,iDCRY,nDCRY,kDCRS,iDCRT,nDCRT)
        end if

#       ifdef _DEBUGPRINT_
        write(u6,'(10A)') 'T={',(ChOp(iDCRT(i)),i=0,nDCRT-1),'}  '
        write(u6,'(2A)') 'kDCRT=',ChOp(kDCRT)
        write(u6,'(2A)') 'T=',ChOp(kDCRT)
#       endif

        kDCRTS = ieor(kDCRT,kDCRS)

        call OA(kDCRT,Cx(:,kAtom,iIter),A(:,3))
        call OA(kDCRT,Cx(:,kAtom,iRef),Ref(:,3))
        call OA(kDCRT,Cx(:,kAtom,iPrv),Prv(:,3))
        call OA(kDCRTS,Cx(:,lAtom,iIter),A(:,4))
        call OA(kDCRTS,Cx(:,lAtom,iRef),Ref(:,4))
        call OA(kDCRTS,Cx(:,lAtom,iPrv),Prv(:,4))

        ! Form the stabilizer for the torsion

        if ((iAtom == lAtom) .and. (jAtom == kAtom) .and. (kDCRR == kDCRS)) then
          call Union(iStabM,nStabM,iStabN,nStabN,kDCRTS,iStabO,nStabO)
        else
          call Inter(iStabM,nStabM,iStabN,nStabN,iStabO,nStabO)
        end if

#       ifdef _DEBUGPRINT_
        write(u6,'(10A)') 'M={',(ChOp(iStabM(i)),i=0,nStabM-1),'}  '
        write(u6,'(10A)') 'N={',(ChOp(iStabN(i)),i=0,nStabN-1),'}  '
        write(u6,'(10A)') 'O={',(ChOp(iStabO(i)),i=0,nStabO-1),'}  '
#       endif

        ! Compute the degeneracy of the torsion

        iDeg = nIrrep/nStabO
        Deg = sqrt(real(iDeg,kind=wp))

        ! Test if coordinate should be included

        if (Help) then
          rjk2 = (Ref(1,2)-Ref(1,3))**2+(Ref(2,2)-Ref(2,3))**2+(Ref(3,2)-Ref(3,3))**2
          Rbc = sqrt(rjk2)
          RbcCov = (CovRadT(ANr(jAtom))+CovRadT(ANr(kAtom)))/Angstrom
          Diff = RbcCov-Rbc
          if (Diff < Zero) Diff = Zero
          f_Const = A_Trsn(1)+A_Trsn(2)*Diff
          f_Const = f_Const*Fact
          r0 = Zero
          Alpha = Zero
          f_Const_Ref = f_Const
        else
          r0 = rAV(jr,kr)
          Alpha = aAv(jr,kr)
          rjk2_Ref = (Ref(1,2)-Ref(1,3))**2+(Ref(2,2)-Ref(2,3))**2+(Ref(3,2)-Ref(3,3))**2
          f_Const_ijk_Ref = f_Const_ij_Ref*exp(Alpha*(r0**2-rjk2_Ref))
          rjk2 = (A(1,2)-A(1,3))**2+(A(2,2)-A(2,3))**2+(A(3,2)-A(3,3))**2
          f_Const_ijk = f_Const_ij*exp(Alpha*(r0**2-rjk2))

          r0 = rAV(kr,lr)
          Alpha = aAv(kr,lr)
          rkl2_Ref = (Ref(1,3)-Ref(1,4))**2+(Ref(2,3)-Ref(2,4))**2+(Ref(3,3)-Ref(3,4))**2
          f_Const_Ref = f_Const_ijk_Ref*exp(Alpha*(r0**2-rkl2_Ref))
          rkl2 = (A(1,3)-A(1,4))**2+(A(2,3)-A(2,4))**2+(A(3,3)-A(3,4))**2
          f_Const = f_Const_ijk*exp(Alpha*(r0**2-rkl2))
        end if
        if (Torsion_Check(iAtom,jAtom,kAtom,lAtom,Ref,iTabAtoms,nMax,mAtoms)) f_Const_Ref = max(f_Const_Ref,Ten*F_Const_Min)

        if ((f_Const_Ref < f_Const_Min) .and. (iBondType /= Fragments_Bond) .and. (iBondType <= Fragments_Bond) .and. &
            (jBondType /= Fragments_Bond) .and. (kBondType /= Fragments_Bond)) cycle

        ! Check that valence angles are above threshold

        mCent = 3
        delta = 15.0_wp*deg2rad
        if (nsAtom == 4) delta = -Ten
        call Bend(Ref(1,1),mCent,Fi2,Grad_ref,.false.,.false.,'        ',Hess,.false.)
        if (Fi2 > Pi-delta) cycle
        if (Fi2 < delta) cycle
        call Bend(Ref(1,2),mCent,Fi3,Grad_ref,.false.,.false.,'        ',Hess,.false.)
        if (Fi3 > Pi-delta) cycle
        if (Fi3 < delta) cycle
        !write(u6,*) ' T Force Constant:',f_Const

        nq = nq+1
        if (.not. Process) mB_Tot = mB_Tot+mB
        if (.not. Proc_dB) mdB_Tot = mdB_Tot+mB**2
        !write(u6,*) 'nq=',nq

        nqT = nqT+1
        iF1 = 1
        call NxtWrd(AtomLbl(iAtom),iF1,iE1)
        Lbls(1) = AtomLbl(iAtom)(iF1:iE1)
        iF2 = 1
        call NxtWrd(AtomLbl(jAtom),iF2,iE2)
        Lbls(2) = AtomLbl(jAtom)(iF2:iE2)
        if (kDCRR /= 0) then
          Lbls(2)(iE2+1:iE2+2+iChOp(kDCRR)) = '('//ChOp(kDCRR)(1:iChOp(kDCRR))//')'
          call NxtWrd(Lbls(2),iF2,iE2)
        end if
        iF3 = 1
        call NxtWrd(AtomLbl(kAtom),iF3,iE3)
        Lbls(3) = AtomLbl(kAtom)(iF3:iE3)
        if (kDCRT /= 0) then
          Lbls(3)(iE3+1:iE3+2+iChOp(kDCRT)) = '('//ChOp(kDCRT)(1:iChOp(kDCRT))//')'
          call NxtWrd(Lbls(3),iF3,iE3)
        end if
        iF4 = 1
        call NxtWrd(AtomLbl(lAtom),iF4,iE4)
        Lbls(4) = AtomLbl(lAtom)(iF4:iE4)
        if (kDCRTS /= 0) then
          Lbls(4)(iE4+1:iE4+2+iChOp(kDCRTS)) = '('//ChOp(kDCRTS)(1:iChOp(kDCRTS))//')'
          call NxtWrd(Lbls(4),iF4,iE4)
        end if
        write(LuIC,'(A,I3.3,8A)') 't',nqT,' = Dihedral ',Lbls(1)(iF1:iE1),' ',Lbls(2)(iF2:iE2),' ',Lbls(3)(iF3:iE3),' ', &
                                  Lbls(4)(iF4:iE4)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,I3.3,8A)') 't',nqT,' = Dihedral ',Lbls(1)(iF1:iE1),' ',Lbls(2)(iF2:iE2),' ',Lbls(3)(iF3:iE3),' ', &
                                Lbls(4)(iF4:iE4)
        write(u6,*) 'iDeg=',iDeg
#       endif
        Label = ' '
        write(Label,'(A,I3.3)') 't',nqT

        call Trsn(A,nCent,Val,Grad,.false.,.false.,'        ',Hess,Proc_dB)
        if (iIter == iPrv) then
          Val_Prv = Val
        else
          Val_Prv = Valu(nq,iPrv)
        end if

        ! correct for 2Pi flip relative to reference.

        Range1 = Two*Pi*0.8_wp
        Range2 = Pi*0.8_wp
        Range3 = Pi*1.2_wp
        if (abs(Val_Prv-Val) > Range1) then
          if (sign(One,Val_Prv) == One) then
            Val = Val+Two*Pi
          else
            Val = Val-Two*Pi
          end if
        else if ((abs(Val_Prv-Val) > Range2) .and. (abs(Val_Prv-Val) < Range3)) then
          if (Val_Prv-Val > Zero) then
            Val = Val+Pi
          else
            Val = Val-Pi
          end if
        end if
#       ifdef _DEBUGPRINT_
        call RecPrt('Trsns:  B',' ',Grad,3,4)
        call RecPrt('Trsns: dB',' ',Hess,12,12)
#       endif

        if (Process) then

          Indq(1,nq) = 5
          ij = (jAtom-1)*nsAtom+iAtom
          kl = (lAtom-1)*nsAtom+kAtom
          Indq(2,nq) = (kl-1)*nsAtom**2+ij
          ijDCR = kDCRT*8+kDCRR+1
          Indq(3,nq) = kDCRS*8**2+ijDCR

          if (iMagic /= 0) then
            f_Const = max(f_Const,f_Const_Min2)
          else if ((.not. Help) .and. &
                   ((iBondType == Fragments_Bond) .or. (jBondType == Fragments_Bond) .or. (kBondType == Fragments_Bond))) then
            f_Const = max(f_Const,f_Const_Min*1.0e3_wp)
          else
            f_Const = max(f_Const,f_Const_Min)
          end if
          fconst(nq) = sqrt(f_Const)
          rMult(nq) = Deg
          ! Scale down fconst if angles are close to linear
          CosFi = max(abs(cos(Fi2)),abs(cos(Fi3)))
          CosThr = 0.97_wp
          if (CosFi > CosThr) then
            CosFact = (CosFi-CosThr)/(One-CosThr)
            CosFact = One-(One-1.0e-3_wp)*CosFact**2
            fconst(nq) = CosFact*fconst(nq)
          end if

          Valu(nq,iIter) = Val
          qLbl(nq) = Label

          ! Project the gradient vector

          call ProjSym(nCent,Ind,A,iDCR,Grad,Hess,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,Proc_dB,nqB,nB,nq,rMult(nq))

        end if

      end do    ! iNeighbor_k
    end do      ! iNeighbor_j
  end do        ! iCase
end do          ! iBonds
#ifdef _DEBUGPRINT_
write(u6,*) 'nqT=',nqT
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Torsion_List

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
C#define _DEBUGPRINT_
      Subroutine ChoLSOSMP2_Energy(irc,EMP2,EOcc,EVir,Sorted,DelOrig)
C
C     Thomas Bondo Pedersen, December 2012.
C
C     Compute Laplace-SOS-MP2 energy.
C
      Implicit None
      Integer irc
      Real*8  EMP2
      Real*8  EOcc(*)
      Real*8  EVir(*)
      Logical Sorted
      Logical DelOrig

#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "cholesky.fh"
#include "stdalloc.fh"

      Character(LEN=17), Parameter:: SecNam='ChoLSOSMP2_Energy'

      Integer  CheckDenomRange
      Integer, External:: TestMinimaxLaplace

#if defined (_DEBUGPRINT_)
      Logical, Parameter:: Debug=.true.
#else
      Logical, Parameter:: Debug=.false.
#endif

      Logical Verb, FermiShift

      Integer l_w

      Real*8 ELOMO, EHOMO
      Real*8 ELUMO, EHUMO
      Real*8 EFermi
      Real*8 xmin, xmax

      Integer iSym
      Integer i

      Real*8, Allocatable:: W(:), T(:)

C====================
C     Initializations
C====================

      Call Untested('Laplace-SOS-MP2')

      ! init return code
      irc=0

      ! init flag for Fermi shift done
      FermiShift=.false.

      ! check that Laplace is requested
      If (.not.Laplace) Then
         Call WarningMessage(1,SecNam//' was called - '
     &                       //'but this is not a Laplace calculation!')
         Call xFlush(6)
         irc=-1
         Return
      End If

      ! Debug: test minimax Laplace grid generation
      If (Debug) Then
         Verb=.false.
         irc=TestMinimaxLaplace(1.0d-7,Verb)
         If (irc.ne.0) Then
            Call WarningMessage(2,SecNam
     &         //': error detected in numerical Laplace transformation')
            Write(6,'(A,I6)') 'irc=',irc
            Call Abend()
         End If
      End If

C====================================================
C     Parameters for numerical Laplace transformation
C====================================================

      ! get max and min orbital energies
      ELOMO=0.0d0
      EHOMO=0.0d0
      ELUMO=0.0d0
      EHUMO=0.0d0
      i=0
      Do iSym=1,nSym
         If (nOcc(iSym).gt.0) Then
            If (i.eq.0) Then
               i=1
               ELOMO=EOcc(iOcc(iSym)+1)
               EHOMO=EOcc(iOcc(iSym)+nOcc(iSym))
            Else
               ELOMO=min(ELOMO,EOcc(iOcc(iSym)+1))
               EHOMO=max(EHOMO,EOcc(iOcc(iSym)+nOcc(iSym)))
            End If
         End If
      End Do
      If (i.eq.0) Then
         Call WarningMessage(2,
     &                        SecNam//': unable to determine LOMO,HOMO')
         Call Abend()
      End If
      i=0
      Do iSym=1,nSym
         If (nVir(iSym).gt.0) Then
            If (i.eq.0) Then
               i=1
               ELUMO=EVir(iVir(iSym)+1)
               EHUMO=EVir(iVir(iSym)+nVir(iSym))
            Else
               ELUMO=min(ELUMO,EVir(iVir(iSym)+1))
               EHUMO=max(EHUMO,EVir(iVir(iSym)+nVir(iSym)))
            End If
         End If
      End Do
      If (i.eq.0) Then
         Call WarningMessage(2,
     &                        SecNam//': unable to determine LUMO,HUMO')
         Call Abend()
      End If
C-tbp:
      write(6,*) 'ELOMO,EHOMO=',ELOMO,EHOMO
      write(6,*) 'ELUMO,EHUMO=',ELUMO,EHUMO

      ! compute "Fermi energy" as the midpoint between HOMO and LUMO.
      EFermi=0.5d0*(EHOMO+ELUMO)

      ! translate orbital energy origin to EFermi
      Do iSym=1,nSym
         Do i=1,nOcc(iSym)
            EOcc(iOcc(iSym)+i)=EOcc(iOcc(iSym)+i)-EFermi
         End Do
         Do i=1,nVir(iSym)
            EVir(iVir(iSym)+i)=EVir(iVir(iSym)+i)-EFermi
         End Do
      End Do
      ELOMO=ELOMO-EFermi
      EHOMO=EHOMO-EFermi
      ELUMO=ELUMO-EFermi
      EHUMO=EHUMO-EFermi
      FermiShift=.true.

      ! compute range of orbital energy denominator
      xmin=2.0d0*(ELUMO-EHOMO)
      xmax=2.0d0*(EHUMO-ELOMO)
      ! Debug: check range
      If (Debug) Then
         irc=CheckDenomRange(xmin,xmax,nSym,EOcc,Evir,iOcc,nOcc,
     &                                                iVir,nVir)
         If (irc.ne.0) Then
            Call WarningMessage(2,SecNam
     &         //': error detected in orbital energy denominator range')
            Write(6,'(A,I6)') 'irc=',irc
            Call Abend()
         End If
      End If

      ! get weights and grid points for numerical Laplace transform
      If (Laplace_nGridPoints.eq.0) Then
         l_w=Laplace_mGridPoints
      Else
         l_w=Laplace_nGridPoints
      End If
      Call mma_allocate(W,l_w,Label='W')
      Call mma_allocate(T,l_w,Label='T')
      Call MinimaxLaplace(Verbose,Laplace_nGridPoints,xmin,xmax,
     &                    l_w,W,T,irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I6)') SecNam,': MinimaxLaplace returned',irc
         irc=1
         Go To 1 ! exit after cleanup actions
      End If

C======================================
C     Compute SOS-MP2 energy correction
C======================================

      If (Sorted) Then
         Call ChoLSOSMP2_Energy_Srt(Laplace_nGridPoints,
     &                              W,T,EOcc,EVir,DelOrig,EMP2,irc)
         If (irc .ne. 0) Then
            Write(6,'(A,A,I6)')
     &      SecNam,': ChoLSOSMP2_Energy_Srt returned',irc
            Go To 1 ! exit
         End If
      Else
         If (nBatch .eq. 1) Then
            Call ChoLSOSMP2_Energy_Fll(Laplace_nGridPoints,
     &                                 W,T,EOcc,EVir,DelOrig,EMP2,irc)
            If (irc .ne. 0) Then
               Write(6,'(A,A,I6)')
     &         SecNam,': ChoLSOSMP2_Energy_Fll returned',irc
               Go To 1 ! exit after cleanup
            End If
         Else
            Call WarningMessage(1,
     &                        SecNam//': unsorted case not implemented')
            irc=-2
            Go To 1 ! exit after cleanup
         End If
      End If

C============
C     Cleanup
C============
    1 Continue ! errors jump to this point

      ! translate orbital energy origin from Fermi back to original
      If (FermiShift) Then
         Do iSym=1,nSym
            Do i=1,nOcc(iSym)
               EOcc(iOcc(iSym)+i)=EOcc(iOcc(iSym)+i)+EFermi
            End Do
            Do i=1,nVir(iSym)
               EVir(iVir(iSym)+i)=EVir(iVir(iSym)+i)+EFermi
            End Do
         End Do
      End If

      ! deallocations
      Call mma_deallocate(T)
      Call mma_deallocate(W)

      End
      Integer Function CheckDenomRange(xmin,xmax,nSym,EOcc,Evir,
     &                                 iOcc,nOcc,iVir,nVir)
      Implicit None
      Real*8  xmin
      Real*8  xmax
      Integer nSym
      Real*8  EOcc(nSym)
      Real*8  EVir(nSym)
      Integer iOcc(nSym)
      Integer nOcc(nSym)
      Integer iVir(nSym)
      Integer nVir(nSym)

      Real*8 Tol
      Parameter (Tol=1.0d-12)

      Real*8 e, emin, emax

      Integer iSym, i
      Integer aSym, a
      Integer irc

      emin=9.9d15
      emax=-9.9d15
      Do iSym=1,nSym
         Do i=iOcc(iSym)+1,iOcc(iSym)+nOcc(iSym)
            Do aSym=1,nSym
               Do a=iVir(aSym)+1,iVir(aSym)+nVir(aSym)
                  e=EVir(a)-EOcc(i)
                  emin=min(emin,e)
                  emax=max(emax,e)
               End Do
            End Do
         End Do
      End Do
      emin=2.0d0*emin
      emax=2.0d0*emax

      irc=0
      If (abs(emin-xmin).gt.Tol) irc=irc+1
      If (abs(emax-xmax).gt.Tol) irc=irc+2

C-tbp:
      if (irc.ne.0) then
         write(6,'(A,1P,2D25.16)') 'xmin,xmax=',xmin,xmax
         write(6,'(A,1P,2D25.16)') 'emin,emax=',emin,emax
         write(6,'(A,1P,2D25.16)') 'diff=     ',xmin-emin,xmax-emax
      end if

      CheckDenomRange=irc

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Oskar Weser                                      *
************************************************************************

#include "compiler_features.h"
#include "molcastypes.fh"

      module filesystem
      use, intrinsic :: iso_c_binding, only: c_char, MOLCAS_C_INT,
     &      C_INT, c_ptr, C_NULL_CHAR
      use fortran_strings, only: split, StringWrapper_t, Cptr_to_str,
     &  str
      implicit none
      private
      public :: getcwd_, chdir_, symlink_, get_errno_, strerror_,
     &    mkdir_, remove_, real_path, basename
      interface
      subroutine getcwd_c(path, n, err) bind(C, name="getcwd_wrapper")
        import :: c_char, MOLCAS_C_INT
        implicit none
        character(len=1, kind=c_char), intent(out) :: path(*)
        integer(MOLCAS_C_INT), intent(in) :: n
        integer(MOLCAS_C_INT), intent(out) :: err
      end subroutine

      subroutine chdir_c(path, err) bind(C, name="chdir_wrapper")
        import :: c_char, MOLCAS_C_INT
        implicit none
        character(len=1, kind=c_char), intent(in) :: path(*)
        integer(MOLCAS_C_INT), intent(out) :: err
      end subroutine

      subroutine symlink_c(to, from, err)bind(C, name="symlink_wrapper")
        import :: c_char, MOLCAS_C_INT
        implicit none
        character(len=1, kind=c_char), intent(in) :: to(*), from(*)
        integer(MOLCAS_C_INT), intent(out) :: err
      end subroutine

      subroutine mkdir_c(path, mode, err) bind(C, name="mkdir_wrapper")
        import :: c_char, MOLCAS_C_INT
        implicit none
        character(len=1, kind=c_char), intent(in) :: path(*)
        integer(kind=MOLCAS_C_INT), intent(in) :: mode
        integer(kind=MOLCAS_C_INT), intent(out) :: err
      end subroutine mkdir_c

      function get_errno_c() bind(C, name="get_errno")
        import :: MOLCAS_C_INT
        implicit none
        integer(MOLCAS_C_INT) :: get_errno_c
      end function

#ifdef C_PTR_BINDING
      function strerror_c(errno) bind(C, name="strerror")
        import :: c_ptr, C_INT
        implicit none
        integer(C_INT), value, intent(in) :: errno
        type(c_ptr) :: strerror_c
       end function
#endif

      subroutine remove_c(path, err) bind(C, name="remove_wrapper")
        import :: c_char, MOLCAS_C_INT
        implicit none
        integer(kind=MOLCAS_C_INT), intent(out) :: err
        character(len=1, kind=c_char), intent(in) :: path(*)
      end subroutine remove_c

      end interface

      contains

      subroutine getcwd_(path, err)
        character(len=*), intent(out) :: path
        integer, intent(out), optional :: err
        integer(MOLCAS_C_INT) :: c_err
        call getcwd_c(path, len(path, MOLCAS_C_INT), c_err)
        if (present(err)) err = int(c_err)
      end subroutine

      subroutine chdir_(path, err)
        character(len=*), intent(in) :: path
        integer, intent(out), optional :: err
        integer(MOLCAS_C_INT) :: c_err
        call chdir_c(trim(path)//C_NULL_CHAR, c_err)
        if (present(err)) err = int(c_err)
      end subroutine

      subroutine symlink_(to, from, err)
        character(len=*), intent(in) :: to, from
        integer, intent(out), optional :: err
        integer(MOLCAS_C_INT) :: c_err
        call symlink_c(
     &    trim(to)//C_NULL_CHAR, trim(from)//C_NULL_CHAR, c_err)
        if (present(err)) err = int(c_err)
      end subroutine

      subroutine mkdir_(path, err)
        character(len=*), intent(in) :: path
        integer, optional, intent(out) :: err
        integer(MOLCAS_C_INT) :: loc_err
        call mkdir_c(trim(path)//C_NULL_CHAR,
     &        int(o'772', MOLCAS_C_INT), loc_err)
        if (present(err)) err = loc_err
      end subroutine

      integer function get_errno_()
        get_errno_ = int(get_errno_c())
      end function

!> Return Error String from Error number
      function strerror_(errnum) result(res)
        integer, intent(in) :: errnum
        character(len=:), allocatable :: res
#ifdef C_PTR_BINDING
        res = Cptr_to_str(strerror_c(int(errnum, C_INT)))
#else
        integer :: rc
        character(len=80) :: errstr
        integer, external :: aixerr
        errstr = ''
        rc = aixerr(errstr)
        res = trim(errstr)
#endif
      end function

      subroutine remove_(path, err)
        character(len=*) :: path
        integer, optional, intent(out) :: err
        integer(MOLCAS_C_INT) :: loc_err
        call remove_c(trim(path)//C_NULL_CHAR, loc_err)
        if (present(err)) err = int(loc_err)
      end subroutine

      function real_path(molcas_name) result(path)
        character(len=*), intent(in) :: molcas_name
        character(len=:), allocatable :: path
        character(len=1024) :: buffer
        integer :: L
        call prgmtranslate_master(molcas_name, buffer, L)
        path = buffer(:L)
      end function

      function basename(path) result(res)
        character(len=*), intent(in) :: path
        character(len=:), allocatable :: res
        type(StringWrapper_t), allocatable :: names(:)

        call split(path, '/', names)

        if (size(names(size(names))%str) /= 0) then
        ! Base is a normal file that is not a directory .../.../basename
            res = str(names(size(names))%str)
        else
        ! Base is itself a directory .../.../basename/
            res = str(names(size(names) - 1)%str)
        end if
      end function
      end module filesystem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
*  CHO_get_Rij
*
*> @author F. Aquilante
*>
*> @details
*> Computes the \f$ R \f$ matrix used for the
*> maximization of Edmiston--Ruedenberg functional
*>
*> \f[ \mathit{ER} = \sum_i (ii|ii) = \mathrm{Tr}(R) \f]
*>
*> for a given set of MOs.
*>
*> \f$ R \f$ is defined from the two-electron integrals
*> computed from the MO-transformed Cholesky vectors
*>
*> \f[ R_{ij} = (ij|jj) = \sum_K L_{ij,K} L_{jj,K} \f]
*>
*> and the condition for the maximization of the ER-functional
*> is given by
*>
*> \f[ \mathrm{grad}(\mathit{ER})_{ij} = 4(R_{ij} - R_{ji}) = 0 \quad (\forall i,j) \f]
*>
*> @note
*> Requires initialization of the Cholesky information.
*>
*> @param[out]    irc     Return code
*> @param[in]     ipMO    Pointers to each symmetry block of the MO matrix, stored as \p C(k,a)
*> @param[in]     nOcc    Number of orbitals to be localized in each symmetry
*> @param[in,out] Rij     \p nOcc &times; \p nOcc symmetry blocked matrix \f$  R_{ij} = (ij|jj) \f$
*> @param[in]     timings Switch on/off timings printout
************************************************************************
      SUBROUTINE CHO_get_Rij(irc,ipMO,nOcc,Rij,timings)
      Implicit Real*8 (a-h,o-z)
      Logical timings,DoRead
      Integer nOcc(*),iOcc(8),iOcs(8),ipLib(8),iSkip(8),ipMO(*)
      Real*8  Rij(*)
      Real*8  tread(2),tintg(2),tmotr(2)
      Character*11  SECNAM

      parameter (SECNAM = 'CHO_get_Rij')
      parameter (zero = 0.0d0, one = 1.0d0, DoRead = .false.)

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )

************************************************************************
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
************************************************************************

      IREDC = -1

      JSYM=1
      If (NumCho(JSYM).lt.1) Then
         Write(6,*)SECNAM//': No total symmetric vectors present'
         irc = 77
         Return
      EndIf

      Do kS=1,nSym
         If ( nOcc(kS).gt.nBas(kS) .or. nOcc(kS).lt.0) Then
          Write(6,*)SECNAM//': Wrong nOcc in symmetry ',kS
          Write(6,*)'nOcc(',kS,')= ',nOcc(kS)
          Write(6,*)'nBas(',kS,')= ',nBas(kS)
          irc = 79
          Return
         EndIf
      End Do

      CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

      do i=1,2            ! 1 --> CPU   2 --> Wall
         tread(i) = zero  !time for reading the vectors
         tmotr(i) = zero  !time for MO transformation of the vectors
         tintg(i) = zero  !time for computing the functional
      end do

C --- compute some offsets and other quantities
      iOcc(1)=0
      iOcs(1)=0
      Mocc=nOcc(1)
      Do kSym=2,nSym
         iOcc(kSym) = iOcc(kSym-1) + nOcc(kSym-1)
         iOcs(kSym) = iOcs(kSym-1) + nOcc(kSym-1)**2
         Mocc = Max(Mocc,nOcc(kSym))
      End Do

      nOcs = iOcs(nSym) + nOcc(nSym)**2

      Call FZero(Rij(1),nOcs)

      Do kS=1,nSym
         iSkip(kS) = Min(nOcc(kS),1) ! initialize skipping flags
      End Do

C --- Memory need for 1 of the half-transformed vectors : L(aj)
      Maj=0
      Do iSyma=1,nSym
         Maj = Maj + nBas(iSyma)*nOcc(iSyma)
      End Do

      iLoc = 3 ! use scratch location in reduced index arrays

      JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
      JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

      Do JRED=JRED1,JRED2

C --- Memory management section -----------------------------
C ---
      CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

      if (nVrs.eq.0) goto 999

      if (nVrs.lt.0) then
         Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs < 0. STOP!!'
         call abend()
      endif

      Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
      if(irc.ne.0)then
       Write(6,*)SECNAM//': cho_X_setred non-zero return code. rc= ',irc
       call abend()
      endif

      IREDC=JRED

      nRS = nDimRS(JSYM,JRED)

      Mneed = Max(nRS, Mocc**2 + 1) ! mem. for Lab and (Lij + Ljj)

      Call GetMem('MaxM','Max','Real',KDUM,LWORK)

      nVec  = Min(LWORK/(Maj+Mneed),nVrs)

      If (nVec.lt.1) Then
         WRITE(6,*) SECNAM//': Insufficient memory for batch'
         WRITE(6,*) 'LWORK= ',LWORK
         WRITE(6,*) 'min. mem. need= ',Maj+Mneed
         irc = 33
         CALL Abend()
         nBatch = -9999  ! dummy assignment
      End If

      LREAD = nRS*nVec

      Call GetMem('rsL','Allo','Real',ipLab,Mneed*nVec)
      Call GetMem('Ltr','Allo','Real',ipLtr,Maj*nVec)

C --- BATCH over the vectors in JSYM=1 ----------------------------

      nBatch = (nVrs-1)/nVec + 1

      DO iBatch=1,nBatch

         If (iBatch.eq.nBatch) Then
            JNUM = nVrs - nVec*(nBatch-1)
         else
            JNUM = nVec
         endif

         JVEC = nVec*(iBatch-1) + iVrs
         IVEC2 = JVEC - 1 + JNUM

         CALL CWTIME(TCR1,TWR1)

         CALL CHO_VECRD(Work(ipLab),LREAD,JVEC,IVEC2,JSYM,
     &                  NUMV,JRED,MUSED)

         If (NUMV.le.0 .or. NUMV.ne.JNUM) then
            irc=77
            RETURN
         End If

         CALL CWTIME(TCR2,TWR2)
         tread(1) = tread(1) + (TCR2 - TCR1)
         tread(2) = tread(2) + (TWR2 - TWR1)

C --- First half-transformation of the vectors : Lab,J --> LiJ,b
C --------------------------------------------------------------
         iSwap = 2  ! LiK,b are returned

         kMOs = 1
         nMOs = 1

         lChoT=0
         Do kSym=1,nSym

            ipLib(kSym) = ipLtr + lChot
            lChot = lChot + nOcc(kSym)*JNUM*nBas(kSym)

         End Do


         CALL CWTIME(TCT1,TWT1)

         CALL CHO_X_getVtra(irc,Work(ipLab),LREAD,jVEC,JNUM,
     &                         JSYM,iSwap,IREDC,nMOs,kMOs,ipMO,nOcc,
     &                         ipLib,iSkip,DoRead)

               if (irc.ne.0) then
                   RETURN
               endif


         CALL CWTIME(TCT2,TWT2)
         tmotr(1) = tmotr(1) + (TCT2 - TCT1)
         tmotr(2) = tmotr(2) + (TWT2 - TWT1)


         ipLij = ipLab  ! re-use mem used for reading from red-sets

         Do kSym=1,nSym

            If (iSkip(kSym) .ne. 0) Then

               ipLjj = ipLij + nOcc(kSym)**2 * JNUM

               CALL CWTIME(TCT1,TWT1)
C ---------------------------------------------------------------------
C --- Second half-transformation  L(iK,j) = sum_b  L(iK,b) * C(j,b)
C ---------------------------------------------------------------------

              CALL DGEMM_('N','T',nOcc(kSym)*JNUM,nOcc(kSym),nBas(kSym),
     &                            One,Work(ipLib(kSym)),nOcc(kSym)*JNUM,
     &                                Work(ipMO(kSym)),nOcc(kSym),
     &                           Zero,Work(ipLij),nOcc(kSym)*JNUM)


               CALL CWTIME(TCT2,TWT2)
               tmotr(1) = tmotr(1) + (TCT2 - TCT1)
               tmotr(2) = tmotr(2) + (TWT2 - TWT1)


               CALL CWTIME(TCI1,TWI1)

               Do lj=1,nOcc(kSym)

                  Do jv=1,JNUM

                     jfrom = ipLij + nOcc(kSym)*JNUM*(lj-1)
     &                     + nOcc(kSym)*(jv-1) + lj - 1
                     jto = ipLjj + jv - 1
                     Work(jto) = Work(jfrom)

                  End Do

C --------------------------------------------------------------------
C --- Compute   R(i,j) = sum_K  L(i,K)[j] * L(K)[j]
C --------------------------------------------------------------------

                  jpR = iOcs(kSym) + nOcc(kSym)*(lj-1) + 1
                  ipLik = ipLij + nOcc(kSym)*JNUM*(lj-1)

                  CALL DGEMV_('N',nOcc(kSym),JNUM,
     &                       ONE,Work(ipLik),nOcc(kSym),
     &                           Work(ipLjj),1,ONE,Rij(jpR),1)


               End Do

               CALL CWTIME(TCI2,TWI2)
               tintg(1) = tintg(1) + (TCI2 - TCI1)
               tintg(2) = tintg(2) + (TWI2 - TWI1)

            EndIf

         End Do



      END DO  !end batch loop

C --- free memory
      Call GetMem('Ltr','Free','Real',ipLtr,Maj*nVec)
      Call GetMem('rsL','Free','Real',ipLab,Mneed*nVec)


999   Continue

      END DO   ! loop over red sets

C --- sync Rij

      Call GAdGOp(Rij,nOcs,'+')

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1

*
*---- Write out timing information
      if(timings)then

      Write(6,*)
      Write(6,*)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)'Timing from ', SECNAM,'           CPU      WALL  '
      Write(6,*)'- - - - - - - - - - - - - - - - - - - - - - - - -'
         Write(6,'(2x,A26,2f10.2)')'READ VECTORS                     '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'TRANSFORM VECTORS                '
     &                           //'         ',tmotr(1),tmotr(2)
         Write(6,'(2x,A26,2f10.2)')'COMPUTE Rij = (ij|jj)            '
     &                           //'         ',tintg(1),tintg(2)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,*)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


      irc=0

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Build_AMatrix(nAtoms,iANr,AMatrix,AInvMatrix,EC,nij,Alpha)
!***********************************************************************

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, iANr(nAtoms), nij
real(kind=wp), intent(out) :: AMatrix(nAtoms,nAtoms), AInvMatrix(nAtoms,nAtoms)
real(kind=wp), intent(in) :: EC(3,nij), Alpha
integer(kind=iwp) :: i, iAtom, ii, ISING, j, jAtom, jj
real(kind=wp) :: A(3), B(3), DET, R_BS_i, R_BS_j, rij02, rij2, Shift, temp
real(kind=wp), external :: Bragg_Slater

!                                                                      *
!***********************************************************************
!                                                                      *
do iAtom=1,nAtoms
  ii = iAtom*(iAtom+1)/2
  A(:) = EC(:,ii)
  R_BS_i = Bragg_Slater(iANr(iAtom))
  do jAtom=1,iAtom-1
    jj = jAtom*(jAtom+1)/2
    B(:) = EC(:,jj)
    R_BS_j = Bragg_Slater(iANr(jAtom))
    rij2 = (A(1)-B(1))**2+(A(2)-B(2))**2+(A(3)-B(3))**2
    rij02 = ((R_BS_i+R_BS_j))**2
    AMatrix(iAtom,jAtom) = exp(-Alpha*(rij2/rij02))/Two
    AMatrix(jAtom,iAtom) = exp(-Alpha*(rij2/rij02))/Two
  end do

  temp = zero
  do jAtom=1,nAtoms
    jj = jAtom*(jAtom+1)/2
    B(:) = EC(:,jj)
    R_BS_j = Bragg_Slater(iANr(jAtom))
    rij2 = (A(1)-B(1))**2+(A(2)-B(2))**2+(A(3)-B(3))**2
    rij02 = ((R_BS_i+R_BS_j))**2
    if (jAtom /= iAtom) then
      temp = temp-exp(-Alpha*(rij2/rij02))/Two
    end if
  end do
  AMatrix(iAtom,iAtom) = Temp

end do
!call RecPrt('A-matrix','(5G12.5)',AMatrix,nAtoms,nAtoms)
!                                                                      *
!***********************************************************************
!                                                                      *
Shift = Zero
do i=1,nAtoms
  do j=1,i
    Shift = max(abs(AMatrix(i,j)),Shift)
  end do
end do
Shift = Two*Shift
!write(u6,*) 'Shift=',Shift
call DaXpY_(nAtoms**2,Shift,[One],0,AMatrix,1)
!call RecPrt('A-matrix(Shifted)','(5G12.5)',AMatrix,nAtoms, nAtoms)
!                                                                      *
!***********************************************************************
!                                                                      *
call MINV(AMatrix,AInvMatrix,ISING,DET,nAtoms)
!call RecPrt('AInv-matrix',' ',AIntMatrix,nAtoms,nAtoms)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Build_AMatrix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine change4_cvb()

use casvb_global, only: endvar, iciweights, icrit, ifhamil, ifinish, imethod, lcalccivbs, lcalcevb, lcalcsvb, lciweights, &
                        memplenty, nalf, nbet, nda, ndb, ndet, ndres, ndres_ok, norb, npcf, nv, variat
use stdalloc, only: mma_maxDBLE
use Constants, only: Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: icase, icritold, ifin_old, mavailr
real(kind=wp) :: strtcas
logical(kind=iwp) :: changed
logical(kind=iwp), external :: chpcmp_cvb, &  ! ... Change of dimensioning variables ...
                               ifcasci_cvb, & ! ... Files available ...
                               up2date_cvb    ! ... Make: up to date? ...

! This was in a common block, but never initialized or used elsewhere
strtcas = 0

changed = .false.
! CI vectors
call icomb_cvb(norb,nalf,nda)
call icomb_cvb(norb,nbet,ndb)
ndet = nda*ndb
ndres = 1+ndet

call mma_maxDBLE(mavailr)
memplenty = (mavailr > 9*ndet)

if (chpcmp_cvb(ndres)) changed = .true.
ndres_ok = (.not. changed) .and. (up2date_cvb('MEM3'))

if (changed) call touch_cvb('RDCAS')
if (chpcmp_cvb(nint(strtcas*Ten))) call touch_cvb('RDCAS')
call chpcmp2_cvb(icrit,icritold)
call chpcmp2_cvb(ifinish,ifin_old)
if (.not. ((icritold == 1) .and. (ifin_old == 0))) call touch_cvb('RDCAS')

if ((ifinish == 1) .or. (ifinish == 2)) then
  ! Logical variables for wavefunction analysis:
  ! Always evaluate svb/evb when possible
  !   (a) to get exact values (wfn is updated by optim in last iteration)
  !   (b) to generate ESYM (variational calculations)
  lcalcsvb = ifcasci_cvb()
  lcalcevb = ifhamil
  lcalccivbs = .true.
  lciweights = ((npcf > -2) .and. ((.not. variat) .or. endvar) .and. (iciweights > 0))
end if
if ((imethod == 11) .and. (ifinish == 0)) then
  nv = 2
  icase = 2
else if ((imethod /= 4) .and. (ifinish == 0)) then
  if (memplenty) then
    nv = 8
    icase = 1
  else
    if ((icrit == 2) .and. (imethod /= 6)) then
      ! No need for CITMP:
      nv = 3
      icase = 5
    else
      nv = 5
      icase = 2
    end if
  end if
else if ((imethod == 4) .and. (ifinish == 0)) then
  nv = 2
  icase = 2
else if ((imethod == 12) .and. (ifinish == 0)) then
  nv = 8
  icase = 7
else if ((ifinish == 1) .or. (ifinish == 2)) then
  nv = 5
  if (.not. lciweights) then
    nv = nv-1
    if ((.not. lcalcevb) .or. lcalccivbs) nv = nv-1
    if ((.not. lcalcsvb) .or. lcalccivbs) nv = nv-1
  end if
  icase = 3
else
  nv = 3
  icase = 4
end if
if (chpcmp_cvb(nv)) changed = .true.
if (chpcmp_cvb(icase)) changed = .true.
if (changed) call touch_cvb('MEM4')

return

end subroutine change4_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************

subroutine STINI(JSTATE)

use Index_Functions, only: iTri, nTri_Elem
#ifdef _DMRG_
use, intrinsic :: iso_c_binding, only: c_int
use qcmaquis_interface, only: qcmaquis_interface_set_state
use caspt2_module, only: DMRG
#endif
use PrintLevel, only: DEBUG, USUAL
use caspt2_global, only: DREF, iPrGlb, PREF
use caspt2_module, only: CLab10, CPUFG3, CPUSIN, EASUM, EPSA, ERef, HZERO, iAdr10, mState, nAshT, RefEne, TIOFG3, TIOSIN
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: JSTATE
integer(kind=iwp) :: I, J
real(kind=wp) :: CPE, CPTF0, CPTF11, CPU, CPU0, CPU1, TIO, TIO0, TIO1, TIOE, TIOTF0, TIOTF11
logical(kind=iwp) :: mkF
character(len=50) :: STLNE2
logical(kind=iwp), parameter :: IFTEST = .false.

!***********************************************************************
call TIMING(CPTF0,CPE,TIOTF0,TIOE)
!***********************************************************************

if (HZERO == 'DYALL') then
  mkF = .false.
else
  mkF = .true.
end if

write(STLNE2,'(A,I0)') 'Compute H0 matrices for state ',MSTATE(JSTATE)
call StatusLine('CASPT2: ',STLNE2)
if (IPRGLB >= USUAL) then
  write(u6,'(A)') repeat('*',80)
  write(u6,'(A,I4)') ' Compute H0 matrices for state ',MSTATE(JSTATE)
  write(u6,'(A)') repeat('-',80)
end if

! Reinitialize labels for saving density matrices on disk.
! The fields IADR10 and CLAB10 are kept in the module caspt2_module
IADR10(:,1) = -1
IADR10(:,2) = 0
CLAB10(:) = '   EMPTY'
IADR10(1,1) = 0

#ifdef _DMRG_
if (DMRG) then
  ! set state number here because in poly1 we have no reference
  ! to which state we are computing
  if (iPrGlb >= DEBUG) write(u6,*) 'STINI setting DMRG state number to ',mstate(jstate)-1
  ! Convert to the root number despite having
  ! set only the checkpoint file paths for the desired state(s)
  call qcmaquis_interface_set_state(int(mstate(jstate)-1,c_int))
end if
#endif
if (IPRGLB >= DEBUG) write(u6,*) ' STINI calling POLY3...'
call TIMING(CPU0,CPU,TIO0,TIO)

call POLY3(mkF)

call TIMING(CPU1,CPU,TIO1,TIO)
CPUFG3 = CPU1-CPU0
TIOFG3 = TIO1-TIO0
if (IPRGLB >= DEBUG) write(u6,*) ' STINI back from POLY3.'

! GETDPREF: Restructure GAMMA1 and GAMMA2, as DREF and PREF arrays.
call GETDPREF(DREF,size(DREF),PREF,size(PREF))

if (IFTEST) then
  write(u6,*) ' DREF for state nr. ',MSTATE(JSTATE)
  do I=1,NASHT
    write(u6,'(1x,14f10.6)') (DREF(iTri(I,J)),J=1,I)
  end do
  write(u6,*)
end if

EREF = REFENE(JSTATE)
! With new DREF, recompute EASUM:
EASUM = Zero
do I=1,NASHT
  EASUM = EASUM+EPSA(I)*DREF(nTri_Elem(I))
end do

if (IPRGLB >= USUAL) then
  write(u6,'(A)') repeat('-',80)
  write(u6,'(A)') ' H0 matrices have been computed.'
  write(u6,*)
end if
!***********************************************************************
call TIMING(CPTF11,CPE,TIOTF11,TIOE)
CPUSIN = CPTF11-CPTF0
TIOSIN = TIOTF11-TIOTF0
!***********************************************************************

end subroutine STINI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine movebraces (length,operator)
c
c*************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 13.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
C     integer length,idum,posp1,posp2,istart,posq,pospp
      integer length,     posp1,posp2,istart,posq,pospp
      character*(maxlength) operator
CMR      logical action
cAOM<
c... AOM: logical flag is introduced
c...      there was a bug with index boundaries
      logical action,flag
cAOM>
c
      istart=1
1000  continue
      action=.false.
      if (index(operator(istart:length),'P').gt.0) then
        posp1=istart-1+index(operator(istart:length),'P')
      else
        istart=1
        goto 2000
      endif
      if (index(operator(posp1+1:length),'P').gt.0) then
        posp2=posp1+index(operator(posp1+1:length),'P')
      else
        istart=1
        goto 2000
      endif
CMR<
c      if ( operator(posp1+1:posp1+1).ne.'V' .and.
c     *       operator(posp1+1:posp1+1).ne.'E' .and.
c     *       operator(posp1+1:posp1+1).ne.'S' .and.
c     *       operator(posp1+1:posp1+2).ne.'[P' .and.
c     *       operator(posp1+1:posp1+1).ne.'X' .and.
c     *       operator(posp1+1:posp1+1).ne.'C' .and.
c     *       posp1.lt.posp2-1) then
CMR the following 3 lines may be erased once the code has been tested
CMR      if(posp1.lt.length-1)
CMR     *  write(*,*) "WARNING in movebraces: posp1.lt.length-1, posp1=",
CMR     *             posp1
      flag=.true.
      if (operator(posp1+1:posp1+1).eq.'V') flag=.false.
      if (operator(posp1+1:posp1+1).eq.'E') flag=.false.
      if (operator(posp1+1:posp1+1).eq.'S') flag=.false.
      if (operator(posp1+1:posp1+2).eq.'[P') flag=.false.
      if (operator(posp1+1:posp1+1).eq.'X') flag=.false.
      if (operator(posp1+1:posp1+1).eq.'C'.and.
     *    posp1.lt.length-1) flag=.false.
      if (posp1.ge.posp2-1) flag=.false.
      if (flag) then
        action=.true.
        operator(posp1:posp1)=operator(posp1+1:posp1+1)
        operator(posp1+1:posp1+1)='P'
      endif
CMR>

CMR<
c      if (operator(posp2-1:posp2-1).ne.'V' .and.
c     *      operator(posp2-3:posp2-1).ne.'E01' .and.
c     *      operator(posp2-2:posp2-1).ne.'P]' .and.
c     *      operator(posp2-4:posp2-4).ne.'S' .and.
c     *      operator(posp2-1:posp2-1).ne.'X' .and.
c     *      operator(posp2-3:posp2-1).ne.'CE0' .and.
c     *      posp1.lt.posp2-1) then
CMR the following line may be erased once the code has been tested
CMR      write(*,*) "WARNING in movebraces: posp2.ge.length ..., posp2=",posp2
      flag=.true.
      if (operator(posp2-1:posp2-1).eq.'V') flag=.false.
      if (operator(posp2-1:posp2-1).eq.'X') flag=.false.
      if (posp2-4.gt.0) then
        if (operator(posp2-4:posp2-4).eq.'S') flag=.false.
        if (operator(posp2-3:posp2-1).eq.'E01') flag=.false.
        if (operator(posp2-3:posp2-1).eq.'CE0') flag=.false.
        if (operator(posp2-2:posp2-1).eq.'P]') flag=.false.
      else if (posp2-3.gt.0) then
        if (operator(posp2-3:posp2-1).eq.'E01') flag=.false.
        if (operator(posp2-3:posp2-1).eq.'CE0') flag=.false.
        if (operator(posp2-2:posp2-1).eq.'P]') flag=.false.
      else if (posp2-2.gt.0) then
        if (operator(posp2-2:posp2-1).eq.'P]') flag=.false.
      end if
      if (posp1.ge.posp2-1) flag=.false.
      if (flag) then
        action=.true.
        operator(posp2:posp2)=operator(posp2-1:posp2-1)
        operator(posp2-1:posp2-1)='P'
        goto 1000
      endif
CMR>
      if (action) goto 1000
      istart=posp2+1
      if (istart.lt.length-2) goto 1000
      istart=1
2000  continue
      action=.false.
      if (index(operator(istart:length),'Q').gt.0) then
        posq=istart-1+index(operator(istart:length),'Q')
      else
        istart=1
        goto 3000
      endif
cAOM<
      flag=.true.
      if(posq.le.1) flag=.false.
CMR the following 2 lines may be erased once the code has been tested
CMR      if(posq.le.1)
CMR     *  write(*,*) "WARNING in movebraces: posq.le.1, posq=",posq
      if (flag.and.operator(posq-1:posq-1).eq.'[') then
        action=.true.
        operator(posq-1:posq-1)='Q'
        operator(posq:posq)='['
        istart=posq-1
      endif
      flag=.true.
      if(posq.ge.length) flag=.false.
CMR the following 2 lines may be erased once the code has been tested
CMR      if(posq.ge.length)
CMR     *  write(*,*) "WARNING in movebraces: posq.ge.length, posq=",posq
      if (flag.and.operator(posq+1:posq+1).eq.']') then
        action=.true.
        operator(posq+1:posq+1)='Q'
        operator(posq:posq)=']'
        istart=posq+1
      endif
cAOM>
      if (action) goto 2000
      istart=posq+2
      if (istart.lt.length-2) goto 2000
      istart=1
3000  continue
      action=.false.
      if (index(operator(istart:length),'PP').gt.0) then
        pospp=istart-1+index(operator(istart:length),'PP')
      else
        goto 4000
      endif
cAOM<
      flag=.true.
      if(pospp.le.1.or.pospp.ge.length) flag=.false.
CMR the following 3 lines may be erased once the code has been tested
CMR      if(pospp.ge.(length-1))
CMR     * write(*,*) "WARNING in movebraces: pospp.le.1.or.pospp.ge.length"
CMR     *            //", pospp=",pospp
      if (flag.and.operator(pospp-1:pospp-1).eq.'[') then
        action=.true.
        operator(pospp-1:pospp)='PP'
        operator(pospp+1:pospp+1)='['
        istart=pospp-1
      endif
      flag=.true.
      if(pospp.ge.(length-1)) flag=.false.
CMR the following 3 lines may be erased once the code has been tested
CMR      if(pospp.ge.(length-1))
CMR     *  write(*,*) "WARNING in movebraces: pospp.ge.(length-1), pospp=",
CMR     *             pospp
      if (flag.and.operator(pospp+2:pospp+2).eq.']') then
        action=.true.
        operator(pospp+1:pospp+2)='PP'
        operator(pospp:pospp)=']'
        istart=pospp+1
      endif
cAOM>
      if (action) goto 3000
      istart=pospp+2
      if (istart.lt.length-2) goto 3000
c
4000  continue
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

function SymDsp(iBsFnc)
!***********************************************************************
!                                                                      *
! Object: to establish if a translation or a rotation belongs to the   *
!         total symmetric irreducible representation.                  *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             April '92                                                *
!***********************************************************************

use Symmetry_Info, only: nIrrep, iOper
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: SymDsp
integer(kind=iwp), intent(in) :: iBsFnc
integer(kind=iwp) :: i, iAcc, j, jBsFnc, mask
integer(kind=iwp), external :: iPrmt

!write(u6,*) ' iBsFnc=',iBsFnc
SymDsp = .true.
mask = 0
do i=0,nIrrep-1
  do j=1,3
    if (btest(iOper(i),j-1)) mask = ibset(mask,j-1)
  end do
end do
jBsFnc = iand(mask,iBsFnc)
!write(u6,*) ' jBsFnc=',jBsFnc

! Loop over operators

iAcc = 0
do i=0,nIrrep-1
  iAcc = iAcc+iPrmt(i,jBsFnc)
end do
if (iAcc == 0) SymDsp = .false.

return

end function SymDsp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!               2017, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine VecFind(OccSet,FermSet,CharSet,SpinSet)
!***********************************************************************
!                                                                      *
! This routine figure out which set of starting orbitals are used.     *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University, Sweden                                     *
!                                                                      *
!          R. Lindh                                                    *
!          Uppsala University, Sweden, Feb 2017                        *
!          Remove Work                                                 *
!                                                                      *
!***********************************************************************
!                                                                      *
! Input vector mappings                                                *
!                                                                      *
! LstVec              InVec                                            *
! -1 Die               0 Core                                          *
!  0 Old SCF           1 NDDO (not used)                               *
!  1 Guessorb          2 Lumorb                                        *
!  2 Lumorb            3 Old density                                   *
!  3 Old Density       4 Restart (not used)                            *
!  4 Core              8 Old SCF                                       *
!  5 NDDO (use not)    9 Guessorb                                      *
!                                                                      *
!***********************************************************************

use InfSCF, only: iAu_ab, InVec, isHDF5, LstVec, nAufb, nBas, nD, nOcc, nStOpt, nSym, SCF_FileOrb, Tot_Charge, Tot_El_Charge, &
                  Tot_Nuc_Charge
#ifdef _HDF5_
use mh5, only: mh5_fetch_attr
use InfSCF, only: FileOrb_ID
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(inout) :: OccSet, FermSet, CharSet
logical(kind=iwp), intent(in) :: SpinSet
integer(kind=iwp) :: i, iBas, iDSpin, iOff, iRC, iSym, iTmp, iVer, j, mTmp, mynBas(8), mynOrb(8), mynSym, n, N1, N2, nData, nEle, &
                     nEle1, nEle2, nSQRSum
real(kind=wp) :: eAlpha, eBeta, GAP, tmp
logical(kind=iwp) :: Found
character(len=80) :: cList
character(len=10) :: infoLbl
real(kind=wp), allocatable :: EOrb(:)

!----------------------------------------------------------------------*
! Setup                                                                *
!----------------------------------------------------------------------*
nSqrSum = sum(nBas(1:nSym)*nBas(1:nSym))
!----------------------------------------------------------------------*
! Check start orbital priority list                                    *
!----------------------------------------------------------------------*
#ifdef _DEBUGPRINT_
write(u6,*) 'VecFind: LstVec',LstVec
#endif
do i=1,nStOpt
  Found = .false.
  select case (LstVec(i))
    case (0)
#     ifdef _DEBUGPRINT_
      write(u6,'(2i5,a)') i,LstVec(i),' Old scf orbitals'
#     endif
      call qpg_darray('SCF orbitals',Found,nData)
      if (Found .and. (nData == nSqrSum)) then
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Found orbitals'
#       endif
        call qpg_darray('OrbE',Found,nData)
        if (Found) then
#         ifdef _DEBUGPRINT_
          write(u6,*) 'Found energies'
#         endif
          InVec = 8
          exit
        end if
      end if
    case (1)
#     ifdef _DEBUGPRINT_
      write(u6,'(2i5,a)') i,LstVec(i),' Guessorb orbitals'
#     endif
      call qpg_darray('Guessorb',Found,nData)
      if (Found .and. (nData == nSqrSum)) then
        call qpg_darray('Guessorb energies',Found,nData)
        if (Found) then
          InVec = 9
          exit
        end if
      end if
    case (2)
#     ifdef _DEBUGPRINT_
      write(u6,'(2i5,a)') i,LstVec(i),' Lumorb orbitals'
#     endif
      call F_Inquire(SCF_FileOrb,Found)
      if (Found) then
        if (isHDF5) then
#         ifdef _HDF5_
          iVer = -1
          call mh5_fetch_attr(fileorb_id,'NSYM',mynSym)
          call mh5_fetch_attr(fileorb_id,'NBAS',mynBas)
#         endif
        else
          call ChkVec(SCF_FileOrb,iVer,mynSym,mynBas,mynOrb,InfoLbl,iRc)
        end if
        if (iVer == 0) Found = .false.
        if (mynSym /= nSym) Found = .false.
        do j=1,nSym
          if (mynBas(j) /= nBas(j)) Found = .false.
        end do
      end if
      if (Found) then
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Found INPORB'
#       endif
        InVec = 2
        exit
      end if
    case (3)
#     ifdef _DEBUGPRINT_
      write(u6,'(2i5,a)') i,LstVec(i),' Density'
#     endif
      InVec = 0
    case (4)
#     ifdef _DEBUGPRINT_
      write(u6,'(2i5,a)') i,LstVec(i),' Core orbitals'
#     endif
      InVec = 0
      Found = .true.
      exit
    case default
#     ifdef _DEBUGPRINT_
      write(u6,'(2i5,a)') i,LstVec(i),' Die'
#     endif
      InVec = 0
      exit
  end select
# ifdef _DEBUGPRINT_
  write(u6,*) 'LstVec(i),Found:',LstVec(i),Found
# endif
end do
#ifdef _DEBUGPRINT_
write(u6,*) 'VecFind: InVec, Found=',InVec,Found
#endif
!----------------------------------------------------------------------*
! Did we find the requested orbitals?                                  *
!----------------------------------------------------------------------*
if (.not. Found) then
  cList = ''
  n2 = 0
  do i=1,nStOpt
    select case (LstVec(i))
      case (0)
        n1 = n2+1
        n2 = n1+9
        write(cList(n1:n2),'(a)') 'Old Scf, '
      case (1)
        n1 = n2+1
        n2 = n1+10
        write(cList(n1:n2),'(a)') 'Guessorb, '
      case (2)
        n1 = n2+1
        n2 = n1+8
        if (isHDF5) then
          write(cList(n1:n2),'(a)') 'HDF5, '
        else
          write(cList(n1:n2),'(a)') 'Lumorb, '
        end if
      case (3)
        n1 = n2+1
        n2 = n1+13
        write(cList(n1:n2),'(a)') 'Old density, '
      case (4)
        n1 = n2+1
        n2 = n1+6
        write(cList(n1:n2),'(a)') 'Core, '
      case (5)
        n1 = n2+1
        n2 = n1+6
        write(cList(n1:n2),'(a)') 'NDDO, '
      case (-1)
        exit
      case default
        n1 = n2+1
        n2 = n1+9
        write(cList(n1:n2),'(a)') 'Unknown, '
    end select
  end do
  call SysAbendMsg('SCF:','Cannot find start orbitals according to list: ',cList)
end if
!----------------------------------------------------------------------*
! What are the defaults for the different cases?                       *
!----------------------------------------------------------------------*
call Get_dScalar('Total Nuclear Charge',Tot_Nuc_Charge)
Tot_El_Charge = Tot_Charge-Tot_Nuc_Charge
if (InVec == 0) then

  ! We will use core diagonalization

# ifdef _DEBUGPRINT_
  write(u6,*) 'Using core diagonalization'
# endif
  OccSet = .false.
  FermSet = .true.
else if (Invec == 1) then

  ! We will use NDDO orbitals, should not be used!

# ifdef _DEBUGPRINT_
  write(u6,*) 'Using NDDO orbitals'
# endif
else if (Invec == 2) then

  ! We will use Lumorb orbitals

# ifdef _DEBUGPRINT_
  write(u6,*) 'Using Lumorb orbitals'
# endif
  call ChkLumo(OccSet,FermSet,SpinSet)
else if (Invec == 3) then

  ! We will use density as start, does it even work?

# ifdef _DEBUGPRINT_
  write(u6,*) 'Using density'
# endif
else if (Invec == 4) then

  ! This is a restart case

# ifdef _DEBUGPRINT_
  write(u6,*) 'Using Restart'
# endif
else if (Invec == 8) then

! We will use old SCF orbitals

# ifdef _DEBUGPRINT_
  write(u6,*) 'Using SCF orbitals'
  write(u6,*) 'tot_charge',tot_charge
  write(u6,*) 'tot_el_charge',tot_el_charge
  write(u6,*) 'tot_nuc_charge',tot_nuc_charge
# endif
  call qpg_iarray('SCF nOcc',Found,nData)
  idspin = 0
  if (Found) then
#   ifdef _DEBUGPRINT_
    write(u6,*) 'vecfind: Alright, old scf orbitals it is'
#   endif
    if (nD == 1) then
      call Get_iarray('SCF nOcc',nOcc(1,1),nSym)
      call Get_iScalar('SCF mode',iTmp)
      if (iTmp == 0) then
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Starting RHF with RHF orbitals'
#       endif
        nEle = 2*sum(nOcc(1:nSym,1))
      else
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Starting RHF with UHF orbitals'
#       endif
        call Get_iarray('SCF nOcc_ab',nOcc(1,2),nSym)
        nEle1 = 2*sum(nOcc(1:nSym,1))
        nEle2 = sum(nOcc(1:nSym,1:2))
        idspin = sum(nOcc(1:nSym,1)-nOcc(1:nSym,2))
        if (nEle1 /= nEle2) then
          !Tot_Charge = Tot_Nuc_Charge-nEle1
          !Tot_El_Charge = -nEle1
          CharSet = .true.
        end if
        nEle = nEle2
#       ifdef _DEBUGPRINT_
        write(u6,*) 'After strange code'
        write(u6,*) 'tot_charge',tot_charge
        write(u6,*) 'tot_el_charge',tot_el_charge
        write(u6,*) 'tot_nuc_charge',tot_nuc_charge
#       endif
      end if
    else
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Starting UHF with RHF/UHF orbitals'
#     endif
      call Get_iarray('SCF nOcc',nOcc(1,1),nSym)
      call qpg_iarray('SCF nOcc_ab',Found,nData)
      if (Found) then
        call Get_iarray('SCF nOcc_ab',nOcc(1,2),nSym)
      else
        call Get_iarray('SCF nOcc',nOcc(1,2),nSym)
      end if
      nEle = sum(nOcc(1:nSym,1:2))
      idspin = sum(nOcc(1:nSym,1)-nOcc(1:nSym,2))
    end if
#   ifdef _DEBUGPRINT_
    write(u6,*) 'idspin',idspin
    write(u6,*) 'iAu_ab',iAu_ab
#   endif
    idspin = idspin-iAu_ab
    if ((abs(Tot_El_Charge+nEle) > Half) .or. (idspin /= 0)) then
#     ifdef _DEBUGPRINT_
      if (abs(Tot_El_Charge+nEle) > Half) write(u6,*) 'System have changed charge!'
      if (idspin /= 0) write(u6,*) 'System have changed spin!'
#     endif
      if (CharSet .or. (idspin /= 0)) then
        OccSet = .false.
        FermSet = .true.
      else
        OccSet = .true.
        FermSet = .false.
        !Tot_Charge = Tot_Nuc_Charge-nEle
        !Tot_El_Charge = -nEle
      end if
    else
#     ifdef _DEBUGPRINT_
      write(u6,*) 'System have same spin and charge'
#     endif
      OccSet = .true.
      FermSet = .false.
    end if
#   ifdef _DEBUGPRINT_
    write(u6,*) 'OccSet  ',OccSet
    write(u6,*) 'FermSet ',FermSet
    write(u6,*) 'CharSet ',CharSet
    write(u6,*) 'SpinSet ',SpinSet
    write(u6,*) 'nOcc',nOcc
#   endif
  else
    OccSet = .false.
    FermSet = .true.
  end if
else if (Invec == 9) then

  ! We will use Guessorb orbitals

# ifdef _DEBUGPRINT_
  write(u6,*) 'Using Guessorb orbitals'
# endif
  if (OccSet) then
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Occupation is set'
#   endif
  else if (FermSet) then
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Fermi is set'
#   endif
  else
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Must decide if to use Fermi'
#   endif
    if (nAufb(1) == -1) then
      mtmp = int(-Tot_El_Charge+0.1_wp)
      if (nD == 1) then
        if (mod(mtmp,2) /= 0) then
          write(u6,*) 'VecFind: Error in number of electrons'
          write(u6,*) '         An even number of electrons ','are required by RHF, use UHF'
          write(u6,*)
          call Abend()
        end if
        nAufb(1) = mtmp/2
      else
        nAufb(2) = (mtmp-iAu_ab)/2
        nAufb(1) = int(-Tot_El_Charge-nAufb(2))
      end if
    end if
#   ifdef _DEBUGPRINT_
    write(u6,*) 'nAufb',nAufb
    write(u6,*) 'Now figure out homo-lumo gap'
#   endif
    call qpg_darray('Guessorb energies',Found,nData)
    call mma_allocate(EOrb,nData,Label='EOrb')
    call get_darray('Guessorb energies',Eorb,nData)
    if (nD == 1) then
      call GetGap(Eorb,nData,nAufb(1),Gap,Ealpha)
    else
      call GetGap(Eorb,nData,nAufb(1),tmp,Ealpha)
      call GetGap(Eorb,nData,nAufb(2),Gap,Ebeta)
      Gap = min(tmp,Gap)
    end if
    call get_darray('Guessorb energies',Eorb,nData)
    if (Gap >= Half) then
      if (nD == 1) then
        iOff = 0
        do iSym=1,nSym
          n = 0
          do iBas=1,nBas(iSym)
            if (EOrb(iOff+iBas) < Ealpha) n = n+1
          end do
          nOcc(iSym,1) = n
          iOff = iOff+nBas(iSym)
        end do
      else
        iOff = 0
        do iSym=1,nSym
          n = 0
          do iBas=1,nBas(iSym)
            if (EOrb(iOff+iBas) < Ealpha) n = n+1
          end do
          nOcc(iSym,1) = n
          iOff = iOff+nBas(iSym)
        end do
        iOff = 0
        do iSym=1,nSym
          n = 0
          do iBas=1,nBas(iSym)
            if (EOrb(iOff+iBas) < Ebeta) n = n+1
          end do
          nOcc(iSym,2) = n
          iOff = iOff+nBas(iSym)
        end do
      end if
      OccSet = .true.
      FermSet = .false.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Decided on occupation list'
#     endif
    else
      OccSet = .false.
      FermSet = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Decided on Fermi aufbau'
#     endif
    end if
    call mma_deallocate(EOrb)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Gap is',Gap
#   endif
  end if
else

  ! This case should not appear

  call SysAbendMsg('SCF:','Internal error in VecFind!','InVec have illegal value')
end if
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
#ifdef _DEBUGPRINT_
write(u6,'(a,i2)') 'VecFind: InVec=',InVec
write(u6,*) 'OccSet=',OccSet
write(u6,*) 'FermSet=',FermSet
#endif
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine VecFind

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986,1995, Bernd Artur Hess                            *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

subroutine TrSmtr(A,B,C,FACTOR,N,H,W)
! B*A*BT

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: A(N*(N+1)/2), B(N,N), FACTOR
real(kind=wp), intent(inout) :: C(N*(N+1)/2)
real(kind=wp), intent(out) :: H(N,N), W(N,N)

call Square(A,W,n,1,n)
call DGEMM_('N','N',n,n,n,One,B,n,W,n,Zero,H,n)
call dGemm_tri('N','T',n,n,n,One,H,n,B,n,Factor,C,n)

return

end subroutine TrSmtr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKCOT_MCLR
     &           (NSYM,NLEV,NVERT,MIDLEV,NMIDV,MIDV1,MIDV2,NWALK,NIPWLK,
     &            ISM,IDOWN,NOW,IOW,NCSF,IOCSF,NOCSF,ISCR,IPRINT)
C
C     PURPOSE: SET UP COUNTER AND OFFSET TABLES FOR WALKS AND CSFS
C     NOTE:    TO GET GET VARIOUS COUNTER AND OFFSET TABLES
C              THE DOWN-CHAIN TABLE IS SCANNED TO PRODUCE ALL POSSIBLE
C              WALKS. POSSIBLY, THERE ARE MORE EFFICIENNET WAYS, BUT
C              SINCE ONLY UPPER AND LOWER WALKS ARE REQUIRED
C              THERE NUMBER IS VERY LIMITTED, EVEN FOR LARGE CASES.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION ISM(NLEV),IDOWN(NVERT,0:3)
      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)
      DIMENSION NOCSF(NSYM,NMIDV,NSYM),IOCSF(NSYM,NMIDV,NSYM)
      DIMENSION ISCR(3,0:NLEV)
      DIMENSION NCSF(NSYM)
      PARAMETER(IVERT=1,ISYM=2,ISTEP=3)
C
C
C     CLEAR ARRAYS IOW AND NOW
C
      DO 10 IHALF=1,2
        DO 11 MV=1,NMIDV
          DO 12 IS=1,NSYM
            NOW(IHALF,IS,MV)=0
            IOW(IHALF,IS,MV)=0
12        CONTINUE
11      CONTINUE
10    CONTINUE
C
C     CLEAR ARRAYS IOCSF AND NOCSF
C
      DO 20 IS=1,NSYM
        DO 21 MV=1,NMIDV
          DO 22 JS=1,NSYM
            IOCSF(JS,MV,IS)=0
            NOCSF(JS,MV,IS)=0
22        CONTINUE
21      CONTINUE
20    CONTINUE
C
C     START MAIN LOOP OVER UPPER AND LOWER WALKS, RESPECTIVELY.
C
      DO 500 IHALF=1,2
        IF(IHALF.EQ.1) THEN
          IVTSTA=1
          IVTEND=1
          LEV1=NLEV
          LEV2=MIDLEV
        ELSE
          IVTSTA=MIDV1
          IVTEND=MIDV2
          LEV1=MIDLEV
          LEV2=0
        END IF
C
C     LOOP OVER VERTICES STARTING AT TOP OF SUBGRAPH
C
        DO 400 IVTOP=IVTSTA,IVTEND
C     SET CURRENT LEVEL=TOP LEVEL OF SUBGRAPH
          LEV=LEV1
          ISCR(IVERT,LEV)=IVTOP
          ISCR(ISYM,LEV)=1
          ISCR(ISTEP,LEV)=-1
100       IF(LEV.GT.LEV1) GOTO 400
C     FIND FIRST POSSIBLE UNTRIED ARC DOWN FROM CURRENT VERTEX
          IVT=ISCR(IVERT,LEV)
          DO 110 ISTP=ISCR(ISTEP,LEV)+1,3
            IVB=IDOWN(IVT,ISTP)
            IF(IVB.EQ.0) GOTO 110
            GOTO 200
110       CONTINUE
C     NO SUCH ARC WAS POSSIBLE. GO UP ONE STEP AND TRY AGAIN.
          ISCR(ISTEP,LEV)=-1
          LEV=LEV+1
          GOTO 100
C     SUCH AN ARC WAS FOUND. WALK DOWN:
200       ISCR(ISTEP,LEV)=ISTP
          ISML=1
          IF((ISTP.EQ.1).OR.(ISTP.EQ.2)) ISML=ISM(LEV)
          LEV=LEV-1
          ISCR(ISYM,LEV)=1+IEOR(ISML-1,ISCR(ISYM,LEV+1)-1)
          ISCR(IVERT,LEV)=IVB
          ISCR(ISTEP,LEV)=-1
          IF (LEV.GT.LEV2) GOTO 100
C     WE HAVE REACHED THE BOTTOM LEVEL. THE WALK IS COMPLETE.
C     FIND MIDVERTEX NUMBER ORDERING NUMBER AND SYMMETRY OF THIS WALK
          MV=ISCR(IVERT,MIDLEV)+1-MIDV1
          IWSYM=ISCR(ISYM,LEV2)
          ILND=1+NOW(IHALF,IWSYM,MV)
C     SAVE THE MAX WALK NUMBER FOR GIVEN SYMMETRY AND MIDVERTEX
          NOW(IHALF,IWSYM,MV)=ILND
C     BACK UP ONE LEVEL AND TRY AGAIN:
          LEV=LEV+1
          GOTO 100
400     CONTINUE
500   CONTINUE
C
C     NOW,CONSTRUCT OFFSET TABLES FOR UPPER AND LOWER WALKS
C     SEPARATED FOR EACH MIDVERTEX AND SYMMETRY
C
      NUW=0
      DO 251 MV=1,NMIDV
        DO 252 IS=1,NSYM
          IOW(1,IS,MV)=NUW*NIPWLK
          NUW=NUW+NOW(1,IS,MV)
252     CONTINUE
251   CONTINUE
      NWALK=NUW
      DO 253 MV=1,NMIDV
        DO 254 IS=1,NSYM
          IOW(2,IS,MV)=NWALK*NIPWLK
          NWALK=NWALK+NOW(2,IS,MV)
254     CONTINUE
253   CONTINUE
      NLW=NWALK-NUW
C
C     FINALLY, CONSTRUCT COUNTER AND OFFSET TABLES FOR THE CSFS
C     SEPARATED BY MIDVERTICES AND SYMMETRY.
C     FORM ALSO CONTRACTED SUMS OVER MIDVERTICES.
C
      DO 271 ISYTOT=1,NSYM
        NCSF(ISYTOT)=0
        DO 272 MV=1,NMIDV
          DO 273 ISYUP=1,NSYM
            ISYDWN=1+IEOR(ISYTOT-1,ISYUP-1)
            N=NOW(1,ISYUP,MV)*NOW(2,ISYDWN,MV)
            NOCSF(ISYUP,MV,ISYTOT)=N
            IOCSF(ISYUP,MV,ISYTOT)=NCSF(ISYTOT)
            NCSF(ISYTOT)=NCSF(ISYTOT)+N
273       CONTINUE
272     CONTINUE
271   CONTINUE
      IF (IPRINT.GE.5) THEN
        WRITE(6,*)
        WRITE(6,*)' TOTAL NR OF WALKS: UPPER ',NUW
        WRITE(6,*)'                    LOWER ',NLW
        WRITE(6,*)'                     SUM  ',NWALK
        WRITE(6,*)
        WRITE(6,*)' NR OF CONFIGURATIONS/SYMM:'
        WRITE(6,'(8(1X,I8))')(NCSF(IS),IS=1,NSYM)
        WRITE(6,*)
        WRITE(6,*)
        WRITE(6,*)' NR OF WALKS AND CONFIGURATIONS IN NRCOUP'
        WRITE(6,*)' BY MIDVERTEX AND SYMMETRY.'
        DO 310 MV=1,NMIDV
          WRITE(6,*)
          WRITE(6,1234) MV,(NOW(1,IS,MV),IS=1,NSYM)
          WRITE(6,1235)    (NOW(2,IS,MV),IS=1,NSYM)
          DO 305 IST=1,NSYM
            WRITE(6,1236)IST,(NOCSF(IS,MV,IST),IS=1,NSYM)
305       CONTINUE
1234  FORMAT('  MV=',I2,'    UPPER WALKS:',8I6)
1235  FORMAT('           LOWER WALKS:',8I6)
1236  FORMAT(' IST=',I2,'  CONFIGURATIONS:',8I6)
310     CONTINUE
        WRITE(6,*)' OFFSETS IN NRCOUP'
        WRITE(6,*)' BY MIDVERTEX AND SYMMETRY.'
        DO 377 MV=1,NMIDV
          WRITE(6,*)
          WRITE(6,1234) MV,(IOW(1,IS,MV),IS=1,NSYM)
          WRITE(6,1235)    (IOW(2,IS,MV),IS=1,NSYM)
377     CONTINUE
      ENDIF
C
C
C     EXIT
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Marcus Johansson                                 *
!***********************************************************************

subroutine fmsym(rc)

use, intrinsic :: iso_c_binding, only: c_ptr
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: rc
type(c_ptr) :: ctx

call fmsym_create_context(ctx)
call fmsym_set_elements(ctx)
call fmsym_find_symmetry(ctx)
call fmsym_symmetrize_molecule(ctx)
call fmsym_generate_orbital_subspaces(ctx)
call fmsym_symmetrize_orb_file(ctx,'INPORB')
call fmsym_release_context(ctx)
rc = 0

return

end subroutine fmsym

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_AuxVec(ipVk,ipZpk,myProc,nProc,nVec)

use Index_Functions, only: nTri_Elem
use pso_stuff, only: AOrb, CMO, D0, lPSO, lSA, n_Txy, nDens, nnP, npos, nV_k, nZ_p_k, Txy, U_k, V_k, Z_p_k
use Basis_Info, only: nBas, nBas_Aux
use Gateway_global, only: force_out_of_core
use RICD_Info, only: Cholesky, Do_RI
use Symmetry_Info, only: Mul, nIrrep
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use RI_glob, only: DMLT, DoCholExch, iMP2prpt, nAdens, nAvec, nChOrb, nJdens, nKdens, nKvec
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nProc, nVec, ipVk(nProc,nVec), ipZpk(nProc), myProc
#include "cholesky.fh"
#include "etwas.fh"
#include "chotime.fh"
integer(kind=iwp) :: i, iADens, iAvec, iBas, iCount, iIrrep, ij, iOff, iOff2, iOffDSQ, ipTxy(0:7,0:7,2), irc, irun, iSO, isym, j, &
                     jCount, jIrrep, jp_U_k, jp_V_k, jp_Z_p_k, jrun, k, kIrrep, kOff1, l, mAO, MemMax, NChVMx, nIOrb(0:7), nnAorb, &
                     nQMax, nQv, nQvMax, nSA, nU_l(0:7), nU_ls, nU_t(0:7), nV_l(0:7), nV_ls, nV_t(0:7)
real(kind=wp) :: Cho_thrs, tmp
logical(kind=iwp) :: DoCAS, DoExchange, Estimate, Update
character(len=8) :: Method
type(DSBA_Type) :: ChM(5), DLT2, DSQ
real(kind=wp), allocatable :: Qv(:), Scr(:), TmpD(:), Zv(:)

!                                                                      *
!***********************************************************************
!                                                                      *
DoExchange = Exfac /= Zero

nV_l(0:nIrrep-1) = NumCho(1:nIrrep) ! local # of vecs in parallel run
nV_t(0:nIrrep-1) = NumCho(1:nIrrep)
nV_ls = 0
do i=0,nIrrep-1
  nV_ls = nV_ls+nV_l(i)
end do
call GAIGOP(nV_t,nIrrep,'+') ! total # of vecs
if (nV_t(0) == 0) then
  call WarningMessage(2,'Compute_AuxVec: no total symmetric vectors!!')
  call Abend()
end if

if (iMp2prpt == 2) then
  if (nVec < 2) then
    write(u6,*) 'nVec < 2, no ipUk input present!'
    call Abend()
  end if
  nU_l(0:nIrrep-1) = NumCho(1:nIrrep) ! local # of vecs in parallel run
  nU_t(0:nIrrep-1) = NumCho(1:nIrrep)
  nU_ls = 0
  do i=0,nIrrep-1
    nU_ls = nU_ls+nU_l(i)
  end do
  call GAIGOP(nU_t,nIrrep,'+') ! total # of vecs
  if (nU_t(0) == 0) then
    call WarningMessage(2,'Compute_AuxVec: no total symmetric vectors!!')
    call Abend()
  end if
end if

NChVMx = 0
nQMax = 0
do i=0,nIrrep-1
  NChVMx = max(NChVMx,nV_t(i))
  nQMax = max(nQMax,nBas_Aux(i))
end do
nChOrb(0:nIrrep-1,1:2) = 0
nQvMax = nQMax*NChVMx
call mma_allocate(Scr,nQMax)

DoCAS = lPSO

if (nV_ls >= 1) then ! can be = 0 in a parallel run

  jp_V_k = ipVk(myProc,1)
  jp_Z_p_k = ipZpk(myProc)
  jp_U_k = 1
  if (iMp2prpt == 2) then
    jp_U_k = ipVk(myProc,2)
  end if
  !*********************************************************************
  !                                                                    *
  !      Get (and transform) the density matrices                      *
  !                                                                    *
  !*********************************************************************

  Timings = .false.
  !Timings = .true.

  call Get_iArray('nIsh',nIOrb,nIrrep)

  if (iMp2prpt /= 2) then
    if (DoCAS .and. lSA) then
      nSA = 5
      do i=1,nSA
        call Allocate_DT(DMLT(i),nBas,nBas,nSym,aCase='TRI')
        DMLT(i)%A0(:) = D0(:,i)
      end do
      ! Refold some density matrices
      do iIrrep=0,nIrrep-1
        ij = 1
        do iBas=2,nBas(iIrrep)
          DMLT(1)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1) = Two*DMLT(1)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1)
          DMLT(3)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1) = Two*DMLT(3)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1)
          DMLT(5)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1) = Two*DMLT(5)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1)
          ij = ij+iBas
        end do
      end do
    else
      call Allocate_DT(DMLT(1),nBas,nBas,nSym,aCase='TRI')
      call Get_D1AO_Var(DMLT(1)%A0,nDens)
    end if
  else
    call Allocate_DT(DMLT(1),nBas,nBas,nSym,aCase='TRI')
    call Get_D1AO(DMLT(1)%A0,nDens)
  end if

  if (nKdens == 2) then
    call Allocate_DT(DMLT(2),nBas,nBas,nSym,aCase='TRI')
    ! spin-density matrix
    call Get_D1SAO_Var(DMLT(2)%A0,nDens)
    DMLT(2)%A0(:) = Half*(DMLT(1)%A0-DMLT(2)%A0) ! beta DMAT
    DMLT(1)%A0(:) = DMLT(1)%A0-DMLT(2)%A0 ! alpha DMAT
  else if ((nKdens > 4) .or. (nKdens < 1)) then
    call WarningMessage(2,'Compute_AuxVec: invalid nKdens!!')
    call Abend()
  end if
  if (iMp2prpt == 2) then
    call Allocate_DT(DLT2,nBas,nBas,nSym,aCase='TRI')
    call Get_D1AO_Var(DLT2%A0,nDens)
    DLT2%A0(:) = DLT2%A0-DMLT(1)%A0
  else
  end if
  !*********************************************************************
  !                                                                    *
  !     Compute Fr+In+Ac localized orbitals                            *
  !     using Cholesky  decomposition for PD matrices                  *
  !     using Eigenvalue decomposition for non-PD matrices (SA-CASSCF) *
  !                                                                    *
  !*********************************************************************
  !DoExchange = Exfac /= Zero

  call Get_cArray('Relax Method',Method,8)
  if (Method == 'MCPDFT ') exfac = One
  DoExchange = Exfac /= Zero

  if (DoExchange .or. DoCAS) then
    do i=1,nKdens
      call Allocate_DT(ChM(i),nBas,nBas,nSym)
    end do
    if (lSA) then
      call mma_allocate(TmpD,nDens,Label='TmpD')
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! PD matrices

    call Allocate_DT(DSQ,nBas,nBas,nSym)
    do j=1,nKvec
      if (lSA) then
        if (j == 1) then
          TmpD(:) = DMLT(1)%A0
        else if (j == 2) then
          TmpD(:) = DMLT(3)%A0
        end if
        call UnFold(TmpD,nDens,DSQ%A0,size(DSQ%A0),nIrrep,nBas)
      else
        call UnFold(DMLT(j)%A0,nDens,DSQ%A0,size(DSQ%A0),nIrrep,nBas)
      end if

      do i=0,nIrrep-1
        call CD_InCore(DSQ%SB(i+1)%A2,nBas(i),ChM(j)%SB(i+1)%A2,nBas(i),nChOrb(i,j),1.0e-12_wp,irc)
      end do
      if (irc /= 0) then
        write(u6,*) 'Compute_AuxVec: failed to get Cholesky MOs !'
        call Abend()
      end if
    end do
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! non-PD matrices

    if (lSA) then

      do i=3,4

        ! Get the appropriate density matrix

        if (i == 3) then
          TmpD(:) = DMLT(2)%A0
        else if (i == 4) then
          TmpD(:) = DMLT(4)%A0
        end if

        ! And eigenvalue-decompose it

        iOffDSQ = 0
        do isym=0,nIrrep-1

          ChM(i)%SB(iSym+1)%A2(:,:) = Zero
          call dcopy_(nbas(isym),[One],0,ChM(i)%SB(iSym+1)%A2,nBas(isym)+1)
          call NIdiag(TmpD(1+iOffDSQ),ChM(i)%SB(iSym+1)%A2,nBas(isym),nBas(isym))

          ! First sort eigenvectors and eigenvalues

          do j=1,nBas(isym)
            irun = iOffDSQ+nTri_Elem(j)
            do k=j,nBas(isym)
              jrun = iOffDSQ+nTri_Elem(k)
              if (TmpD(irun) < TmpD(jrun)) then
                tmp = TmpD(irun)
                TmpD(irun) = TmpD(jrun)
                TmpD(jrun) = tmp
                do l=1,nBas(isym)
                  tmp = ChM(i)%SB(iSym+1)%A2(l,j)
                  ChM(i)%SB(iSym+1)%A2(l,j) = ChM(i)%SB(iSym+1)%A2(l,k)
                  ChM(i)%SB(iSym+1)%A2(l,k) = tmp
                end do
              end if
            end do
          end do

          Cho_thrs = 1.0e-12_wp

          l = 0
          do j=1,nBas(isym)
            if (TmpD(iOffDSQ+nTri_Elem(j)) > Cho_thrs) then
              l = l+1
              tmp = sqrt(TmpD(iOffDSQ+nTri_Elem(j)))
              ChM(i)%SB(iSym+1)%A2(:,l) = tmp*ChM(i)%SB(iSym+1)%A2(:,j)
            end if
          end do
          npos(isym,i-2) = l

          do j=1,nBas(isym)
            if (-TmpD(iOffDSQ+nTri_Elem(j)) > Cho_thrs) then
              l = l+1
              irun = (l-1)*nBas(isym)
              jrun = (j-1)*nBas(isym)
              tmp = sqrt(-TmpD(iOffDSQ+nTri_Elem(j)))
              ChM(i)%SB(iSym+1)%A2(:,l) = tmp*ChM(i)%SB(iSym+1)%A2(:,j)
            end if
          end do
          nChOrb(isym,i) = l

          iOffDSQ = iOffDSQ+nTri_Elem(nBas(isym))
        end do

      end do

      ! Refold the other DM

      do iIrrep=0,nIrrep-1
        ij = 1
        do iBas=2,nBas(iIrrep)
           DMLT(2)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1) = Two*DMLT(2)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1)
           DMLT(4)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1) = Two*DMLT(4)%SB(iIrrep+1)%A1(ij+1:ij+iBas-1)
           ij = ij+iBas
        end do
      end do
    end if
    call Deallocate_DT(DSQ)
    if (lSA) call mma_deallocate(TmpD)
  end if
  !*********************************************************************
  !                                                                    *
  !      First contract the RI vectors with the density matrix         *
  !                                                                    *
  !*********************************************************************
  ! Pointers to the Cholesky vectors of P2
  mAO = 0
  iOff = 0
  do kIrrep=0,nIrrep-1 ! compound symmetry
    iOff2 = 0
    do jIrrep=0,nIrrep-1
      iIrrep = Mul(jIrrep+1,kIrrep+1)-1
      if (iIrrep < jIrrep) then
        nnAorb = nASh(iIrrep)*nAsh(jIrrep)
      else if (iIrrep == jIrrep) then
        nnAorb = nTri_Elem(nAsh(iIrrep))
      else
        cycle
      end if
      ipTxy(iIrrep,jIrrep,1) = 1+iOff2+iOff
      ipTxy(jIrrep,iIrrep,1) = ipTxy(iIrrep,jIrrep,1)
      if (lSA) then
        ipTxy(iIrrep,jIrrep,2) = ipTxy(iIrrep,jIrrep,1)+n_Txy
        ipTxy(jIrrep,iIrrep,2) = ipTxy(iIrrep,jIrrep,2)
      end if
      iOff2 = iOff2+nnAorb
    end do
    iOff = iOff+iOff2*nnP(kIrrep)
    mAO = mAO+nBas(kIrrep)*nASh(kIrrep)
  end do

  call Allocate_DT(AOrb,nADens,nAsh,nBas,nIrrep,label='AOrb')

  ! Reordering of the active MOs :  C(a,v) ---> C(v,a)

  iCount = 0
  do iIrrep=0,nIrrep-1

    jCount = iCount+nBas(iIrrep)*nIOrb(iIrrep)

    iCount = iCount+nBas(iIrrep)**2
    if (nBas(iIrrep)*nASh(iIrrep) == 0) cycle

    do iADens=1,nADens

      do i=1,nASh(iIrrep)
        kOff1 = 1+jCount+nBas(iIrrep)*(i-1)
        AOrb(iADens)%SB(iIrrep+1)%A2(i,1:nBas(iIrrep)) = CMO(kOff1:kOff1-1+nBas(iIrrep),iADens)
      end do

    end do ! iADens

  end do ! iIrrep

  if (nKdens == 2) DMLT(1)%A0(:) = DMLT(1)%A0+DMLT(2)%A0 ! for Coulomb term

  ! Add the density of the environment in a OFE calculation (Coulomb)

  call OFembed_dmat(DMlt(1)%A0,nDens)

  !nScreen = 10 ! Some default values for the screening parameters
  !dmpK = One
  Estimate = .false.
  Update = .true.
  call Cho_Get_Grad(irc,nKdens,DMLT,DLT2,ChM,Txy,n_Txy*nAdens,ipTxy,DoExchange,lSA,nChOrb,AOrb,nAsh,DoCAS,Estimate,Update, &
                    V_k(jp_V_k,1),nV_k,U_k(jp_U_k),Z_p_k(jp_Z_p_k,1),nZ_p_k,nnP,npos)

  if (irc /= 0) then
    call WarningMessage(2,'Compute_AuxVec: failed in Cho_Get_Grad !!')
    call Abend()
  end if

  if (DoCAS .or. DoExchange) then
    do i=1,nKdens
      call deallocate_DT(ChM(i))
    end do
  end if
  if (iMp2prpt == 2) then
    call deallocate_DT(DLT2)
  end if

end if ! no vectors on this node

! For parallel run: reordering of the V_k(tilde) vector from
! the "node storage" to the Q-vector storage
if (nProc > 1) then
  do i=1,size(V_K,2)
    call Reord_Vk(ipVk(:,1),nProc,myProc,nV_l,nV_t,[1],1,V_k(:,i))
  end do
end if
!***********************************************************************
!                                                                      *
!     Second step: contract with the Q-vectors to produce V_k          *
!            ~  T                                                      *
!     V = V Q                                                          *
!                                                                      *
!***********************************************************************

if (Cholesky .and. (.not. Do_RI)) then ! to cope with the calls below
  nBas_Aux(0) = nBas_Aux(0)+1
end if

call mma_maxDBLE(MemMax)

if (Force_out_of_Core) MemMax = 4*(nQvMax)/10
nQv = min(MemMax,nQvMax)
call mma_allocate(Qv,nQv,Label='Qv')

! Coulomb

do i=1,nJdens
  call Mult_Vk_Qv_s(V_k(ipVk(1,1),i),nV_t(0),Qv,nQv,Scr,nQMax,nBas_Aux,nV_t(0),nIrrep,'T')
  V_k(ipVk(1,1):ipVk(1,1)+nV_k-1,i) = Scr(1:nV_k)
end do

! MP2

if (iMp2prpt == 2) then
  call Mult_Vk_Qv_s(U_k(ipVk(1,2)),nU_t(0),Qv,nQv,Scr,nQMax,nBas_Aux,nU_t(0),nIrrep,'T')
  U_k(ipVk(1,2):ipVk(1,2)+nV_k-1) = Scr(1:nV_k)
end if

! Active term

if (DoCAS) then ! reorder Zp_k

  call mma_allocate(Zv,nZ_p_k,Label='Zv')

  do iAvec=1,nAvec
    if (nProc > 1) call Reord_Vk(ipZpk,nProc,myProc,nV_l,nV_t,nnP,nIrrep,Z_p_k(:,iAVec))

    call Mult_Zp_Qv_s(Z_p_k(ipZpk(1),iAvec),nZ_p_k,Qv,nQv,Zv,nZ_p_k,nV_t,nnP,nBas_Aux,nIrrep,'T')

    Z_p_k(ipZpk(1):ipZpk(1)+nZ_p_k-1,iAvec) = Zv
  end do
  call mma_deallocate(Zv)
end if

call mma_deallocate(Qv)
call mma_deallocate(Scr)

! Exchange

if (DoExchange) then
  DoCholExch = .true.
  do iSO=1,nKvec
    call Mult_RijK_QKL(iSO,nBas_aux,nIrrep)
  end do
  if (iMp2prpt == 2) then
    call Mult_with_Q_MP2(nBas_aux,nBas,nIrrep)
  end if
end if
if (Cholesky .and. (.not. Do_RI)) nBas_Aux(0) = nBas_Aux(0)-1

return

end subroutine Compute_AuxVec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module SCFWfn

use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: wfn_energy, wfn_fileid, wfn_mocoef, wfn_mocoef_a, wfn_mocoef_b, wfn_occnum, wfn_occnum_a, wfn_occnum_b, &
                     wfn_orbene, wfn_orbene_a, wfn_orbene_b, wfn_tpidx, wfn_tpidx_a, wfn_tpidx_b

public :: wfn_energy, wfn_fileid, wfn_mocoef, wfn_mocoef_a, wfn_mocoef_b, wfn_occnum, wfn_occnum_a, wfn_occnum_b, wfn_orbene, &
          wfn_orbene_a, wfn_orbene_b, wfn_tpidx, wfn_tpidx_a, wfn_tpidx_b

end module SCFWfn

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine percentzero(wrk,wrksize,map,pz)
! this routine tests % of small elements in mediate, decribed by map
!
! map - map type of required mediate (I)

use ccsd_global, only: Map_Type
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(in) :: wrk(wrksize)
type(Map_Type), intent(in) :: map
real(kind=wp), intent(out) :: pz
integer(kind=iwp) :: length, nhelp, nzero, pos
real(kind=wp) :: zerolim

! def length, pos, zerolim

pos = map%d(1,1)
nhelp = map%d(0,5)
length = map%d(nhelp,1)+map%d(nhelp,2)-map%d(1,1)
zerolim = 1.0e-6_wp

if (length > 0) then
  nzero = 0
  do nhelp=pos,pos+length-1
    if (abs(wrk(nhelp)) < zerolim) nzero = nzero+1
  end do
  pz = real(100*nzero,kind=wp)/real(length,kind=wp)
else
  pz = One
end if

return

end subroutine percentzero

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  HelState
*
*> @brief
*>   Couple the electrostatic part of the solvent with the QM-region.
*>   Only include the static part, no polarization at this moment
*> @author A. Ohrn
*>
*> @note
*> The quadrupoles are put in 'Buckingham-style'.
*>
*> @details
*> Rather easy to follow. This subroutine is a slightly modified
*> copy of hel.f. The interesting quantities are collected in
*> \p Vmat and are later to be added to the 'RASSI-matrix'.
*>
*> @param[in]  Eint    Field from static part of solvent on the Qm-molecule centers
*> @param[in]  nrstate Number of states in RASSI
*> @param[in]  ici     Number of MME-centers
*> @param[in]  Cha     Charges
*> @param[in]  Dip     Dipoles
*> @param[in]  Qua     Quadrupoles
*> @param[out] Vmat    The electrostatic part of the solute-solvent interaction matrix
*> @param[in]  iPrint  Print-level
************************************************************************
      Subroutine HelState(Eint,nrstate,ici,Cha,Dip,Qua,Vmat,iPrint)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "WrkSpc.fh"

      Dimension Eint(MxQCen,10),Vmat(MxOt)
      Dimension Cha(MxStOT,MxQCen),Dip(MxStOT,3,MxQCen)
      Dimension Qua(MxStOT,6,MxQCen)

      kaunt=0
      Do 9, i=1,nrState
        Do 99, j=1,i
          kaunt=kaunt+1
          Vmat(kaunt)=0.0d0
99      Continue
9     Continue

      kaunt=0  !The interaction between the distributed multipoles
               !and the generalized field from the solvent.
      Do 10, i=1,nrState
        Do 11, j=1,i
          kaunt=kaunt+1
          Do 12, k=1,ici
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,1)*Cha(kaunt,k)
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,2)*Dip(kaunt,1,k)
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,3)*Dip(kaunt,2,k)
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,4)*Dip(kaunt,3,k)
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,5)*Qua(kaunt,1,k)
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,7)*Qua(kaunt,3,k)
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,10)*Qua(kaunt,6,k)
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,6)*Qua(kaunt,2,k)*2
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,8)*Qua(kaunt,4,k)*2
            Vmat(kaunt)=Vmat(kaunt)+Eint(k,9)*Qua(kaunt,5,k)*2
12        Continue
11      Continue
10    Continue

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iPrint)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine string_cvb(arr,nmax,nread,ifc)

use casvb_global, only: inputmode
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nmax, ifc
character(len=*), intent(inout) :: arr(nmax)
integer(kind=iwp), intent(inout) :: nread
integer(kind=iwp) :: i, iaux(1), ierr, ifcuse
character(len=100) :: string
logical(kind=iwp) :: done

if (inputmode == 2) then
  call geth_cvb(iaux,1)
  nread = iaux(1)
  call geths_cvb(arr,nread)
  return
end if
nread = 0

if (nmax > 0) then
  ! Treat first field differently
  ifcuse = mod(ifc,4)
  if (ifcuse >= 2) ifcuse = 2
  call popfield_cvb(ifcuse)
  call rdstring_cvb(string,ierr)
  done = .false.
  if (ierr <= 0) then
    arr(1) = string
    nread = nread+1

    ifcuse = mod(ifc,2)
    done = .true.
    do i=2,nmax
      call popfield_cvb(ifcuse)
      call rdstring_cvb(string,ierr)
      if (ierr > 0) then
        done = .false.
        exit
      end if
      arr(i) = string
      nread = nread+1
    end do
  end if
  if (.not. done) call pushfield_cvb()
end if
if (inputmode == 1) call seths_cvb(arr,nread)

return

end subroutine string_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRPRTTAB(IPRTTAB)
      IMPLICIT NONE
      INTEGER IPRTTAB(*)
      INTEGER IPART,NPART
      INTEGER NSYM,ISYM
C     INTEGER MXMEM

C Executable statements
      WRITE(6,*)
      WRITE(6,*)' Partition table printout'
      WRITE(6,'(A,I5)')'Table size        NSIZE=',IPRTTAB(1)
      WRITE(6,'(A,I5)')'Table type ID     ITYPE=',IPRTTAB(2)
      WRITE(6,'(A,I5)')'Nr of partitions  NPART=',IPRTTAB(3)
      WRITE(6,'(A,I5)')'Nr of symm labels NSYM =',IPRTTAB(4)
      NPART=IPRTTAB(3)
      NSYM =IPRTTAB(4)
      WRITE(6,'(8X,I5,5X,8I5)')(IPRTTAB(5+ISYM),ISYM=0,NSYM)
      DO IPART=1,NPART
       WRITE(6,'(I3,5X,I5,5X,8I5)')IPART,
     &      (IPRTTAB(5+ISYM+(NSYM+1)*IPART),ISYM=0,NSYM)
      END DO
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Anders Bernhardsson                              *
*               1999, Coen de Graaf                                    *
************************************************************************
      Subroutine Dens_IF_SCF(COEFF,CMO,Mode)
*
*     A small stupid interface for creating the alpha and beta
*     occupation numbers and corresponding molecular orbitals,
*     used in MOLDEN.
*
*     EAW 990118
*
*     For SCF it gets even more 'stupid', just reading the MO coefficients and
*     dumping it into a large matrix of dimension nTot x nTot
*       (Coen de Graaf, Oct. 99)
*
      Implicit Real*8 (a-h,o-z)

#include "SysDef.fh"
#include "real.fh"
      Real*8 COEFF(*), CMO(*)
      Character Mode*1
      Integer nBas(0:7)
*
*     COEN WANTED IT AS A BLOCKED MATRIX, SO HERE THEY COME...
*
      Call Get_iScalar('nSym',nIrrep)
      Call Get_iArray('nBas',nBas,nIrrep)
      nTot=0
      nTot2=0
      Do iS=0,nIrrep-1
         nTot=nTot+nBas(iS)
         nTot2=nTot2+nBas(iS)**2
      End Do
*
      ip1=1
      ip2=1
      If (Mode.eq.'F') call dcopy_(nTot**2,[Zero],0,COEFF,1)
C     Call RecPrt('COEFF',' ',Coeff,nTot,nTot)
      Do iS=0,nIrrep-1
         If (Mode.eq.'B') call dcopy_(nbas(is)**2,[Zero],0,CMO(ip1),1)
C        Call RecPrt('CMO',' ',CMO(ip1),nbas(is),nbas(is))
         Do i=1,nbas(is)
            If (Mode.eq.'F') call dcopy_(nbas(is),CMO(ip1),  1,
     &                                           COEFF(ip2),1)
            If (Mode.eq.'B') call dcopy_(nbas(is),COEFF(ip2),1,
     &                                           CMO(ip1),  1)
            ip1=ip1+nbas(is)
            ip2=ip2+nTot
         End Do
C        Call RecPrt('CMO',' ',CMO(ip1-nbas(is)**2),nbas(is),nbas(is))
         ip2=ip2+nbas(is)
      End Do
C     Call RecPrt('COEFF',' ',Coeff,nTot,nTot)
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GDMAT(NSYM,NBAS,ISTART,NUSE,CNAT,nCMO,OCC,nOCC,GDAO,nGDAO)
! General density matrix, in the sense of using a specified
! but arbitrary range of orbitals in each symmetry, and an
! occupation number.

! The input arguments:
!    NSYM=Nr of symmetry blocks,
!    NBAS(i), i=1..NSYM: Number of basis functions, equal
!       also to total number of orbitals, in each symmetry.
!    CNAT(i),i=1..sum(NBAS(i)**2,i=1..NSYM): The CMO
!       coefficients, stored as square symmetry blocks CN(a,q)
!       where a is basis function, q is orbital index.
!    ISTART(i), i=1..NSYM: Orbital number to start using
!        in each symmetry block, numbered 1,2,..NBAS(i)
!    NUSE(i), i=1..NSYM: How many orbitals to use,
!    OCC(i),i=1..sum(NBAS(i),i=1..NSYM): The natural
!        occupation number of each orbital.
! Output: Array GDAO.

! Computes the AO density matrix, using formula
!  D(a,b) = sum( CN(a,p)*xn(p)*CN(b,p), p=1..n)
! where a,b are basis function indices, p is an MO index,
!  CN() and xn() are CMO coefficients and occupation
! numbers of natural orbitals, and the indices and matrices
! are defined within symmetry blocks.
! The symmetry blocks of D are then stored triangularly
! after each other in the array GDAO.

use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NSYM, NBAS(NSYM), ISTART(NSYM), NUSE(NSYM), nCMO, nOcc, nGDAO
real(kind=wp), intent(in) :: CNAT(nCMO), OCC(nOcc)
real(kind=wp), intent(out) :: GDAO(nGDAO)
integer(kind=iwp) :: IOEND, ICEND, IDAB, ISYM, NB, NW, IW1, IW2, IA, IB, IW
real(kind=wp) :: DAB

IOEND = 0
ICEND = 0
IDAB = 0
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  if (NB < 1) cycle
  GDAO(IDAB+1:IDAB+nTri_Elem(NB)) = Zero
  NW = NUSE(ISYM)
  if (NW > 0) then
    IW1 = ISTART(ISYM)
    IW2 = IW1-1+NW
    do IA=1,NB
      do IB=1,IA
        IDAB = IDAB+1
        DAB = GDAO(IDAB)
        do IW=IW1,IW2
          DAB = DAB+OCC(IOEND+IW)*CNAT(ICEND+IA+NB*(IW-1))*CNAT(ICEND+IB+NB*(IW-1))
        end do
        GDAO(IDAB) = DAB
      end do
    end do
  else
    IDAB = IDAB+nTri_Elem(NB)
  end if
  IOEND = IOEND+NB
  ICEND = ICEND+NB**2
end do

end subroutine GDMAT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
!#define _FULL_SPACE_
subroutine S_GEK_Optimizer(dq,mOV,dqdq,UpMeth,Step_Trunc,SOrange)
!***********************************************************************
!                                                                      *
!     Object: subspace gradient-enhanced kriging optimization.         *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chemistry -- BMC,                 *
!             University of Uppsala, SWEDEN                            *
!             May '22, November-December '22                           *
!***********************************************************************

use InfSCF, only: Energy, HDiag, iter, IterGEK, Loosen, TimFld
use LnkLst, only: Init_LLs, LLGrad, LLx, LstPtr, SCF_V
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
#ifndef _FULL_SPACE_
use Constants, only: One
#endif
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mOV
real(kind=wp), intent(inout) :: dq(mOV)
real(kind=wp), intent(out) :: dqdq
character(len=6), intent(inout) :: UpMeth
character, intent(inout) :: Step_Trunc
logical(kind=iwp), intent(in) :: SOrange
integer(kind=iwp) :: i, iFirst, ipg, ipq, j, k, l, mDIIS, nDIIS, nExplicit
real(kind=wp) :: Cpu1, Cpu2, gg, Tim1, Tim2, Tim3
real(kind=wp), allocatable :: D(:,:), dq_diis(:), e_diis(:,:), g(:,:), g_diis(:,:), H_Diis(:,:), q(:,:), q_diis(:,:), w(:,:)
integer(kind=iwp), parameter :: Max_Iter = 50, nWindow = 20
real(kind=wp), parameter :: Beta_Disp_Min = 5.0e-3_wp, Beta_Disp_Seed = 0.05_wp, StepMax_Seed = 0.1_wp, Thr_RS = 1.0e-7_wp, &
                            ThrGrd = 1.0e-7_wp
#ifndef _FULL_SPACE_
real(kind=wp), allocatable :: aux_a(:), aux_b(:)
#endif
real(kind=wp), external :: DDot_

call Timing(Cpu1,Tim1,Tim2,Tim3)

#ifdef _DEBUGPRINT_
write(u6,*) 'Enter S-GEK Optimizer'
#endif
if (.not. Init_LLs) then
  write(u6,*) 'Link list not initiated'
  call Abend()
end if

! define first iteration considered in the subspace
! the last nDIIS iterations, of which the first is iFirst
nDIIS = min(IterGEK,nWindow)
iFirst = Iter-nDIIS+1
!if (nDIIS == 1) then
!# ifdef _DEBUGPRINT_
!  write(u6,*) 'Exit S-GEK Optimizer'
!# endif
!  return
!end if

call mma_allocate(q,mOV,nDIIS,Label='q')
call mma_allocate(g,mOV,nDIIS,Label='g')

if (nDIIS == 1) then
# ifdef _DEBUGPRINT_
  write(u6,*) 'Exit S-GEK Optimizer'
# endif
  call mma_deallocate(g)
  call mma_deallocate(q)
  return
end if

! Pick up coordinates and gradients in full space
j = 0
do i=iFirst,iter
  j = i-iFirst+1
  !write(u6,*) 'i,j,iter=',i,j,iter

  ! Coordinates
  ipq = LstPtr(i,LLx)
  q(:,j) = SCF_V(ipq)%A(:)

  ! Gradients
  ipg = LstPtr(i,LLGrad)
  g(:,j) = SCF_V(ipg)%A(:)

end do

#ifdef _DEBUGPRINT_
write(u6,*) 'nWindow=',nWindow
write(u6,*) 'nDIIS=',nDIIS
write(u6,*) 'IterGEK=',IterGEK
call RecPrt('q',' ',q,mOV,nDIIS)
call RecPrt('g',' ',g,mOV,nDIIS)
call RecPrt('g(:,nDIIS)',' ',g(:,nDIIS),mOV,1)
#endif

!=======================================================================
! Select the subspace

#ifdef _FULL_SPACE_

! Set up the full space
nExplicit = mOV
call mma_allocate(e_diis,mOV,nExplicit,Label='e_diis')
e_diis(:,:) = Zero
do k=1,nExplicit
  e_diis(k,k) = One
end do

#else

!nExplicit = 2 * (nDIIS - 1) + mOV + 2
nExplicit = 2*(nDIIS-1)+2
call mma_allocate(e_diis,mOV,nExplicit,Label='e_diis')

call mma_allocate(Aux_a,mOV,Label='Aux_a')
call mma_allocate(Aux_b,mOV,Label='Aux_b')

j = 0
do k=1,nDIIS-1
  j = j+1
  Aux_a(:) = g(:,k+1)-g(:,k)
  e_diis(:,j) = Aux_a(:)/sqrt(DDot_(mOV,Aux_a(:),1,Aux_a(:),1))

  j = j+1
  Aux_a(:) = q(:,k+1)-q(:,k)
  !call SOrUpV(Aux_a(:),mOV,Aux_b(:),'GRAD','BFGS')
  Aux_b(:) = Aux_a(:)
  e_diis(:,j) = Aux_b(:)/sqrt(DDot_(mOV,Aux_b(:),1,Aux_b(:),1))

end do
call mma_deallocate(Aux_b)

! Add some unit vectors corresponding to the Krylov subspace algorithm, g, Ag, A^2g, ....
j = j+1
Aux_a(:) = g(:,nDIIS)
e_diis(:,j) = Aux_a(:)/sqrt(DDot_(mOV,Aux_a(:),1,Aux_a(:),1))
j = j+1
Aux_a(:) = dq(:)
e_diis(:,j) = Aux_a(:)/sqrt(DDot_(mOV,Aux_a(:),1,Aux_a(:),1))
call mma_deallocate(Aux_a)

#endif

! Now orthogonalize all unit vectors
#ifdef _DEBUGPRINT_
if (allocated(e_diis)) call RecPrt('e_diis(unnorm)',' ',e_diis,mOV,nExplicit)
#endif
do l=1,2
  j = 1
  do i=2,nExplicit
    do k=1,j
      gg = DDot_(mOV,e_diis(:,i),1,e_diis(:,k),1)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'i,k,gg=',i,k,gg
#     endif
      e_diis(:,i) = e_diis(:,i)-gg*e_diis(:,k)
    end do
    gg = DDot_(mOV,e_diis(:,i),1,e_diis(:,i),1) ! renormalize
#   ifdef _DEBUGPRINT_
    write(u6,*) 'j,i,gg=',j,i,gg
#   endif
    if (gg > 1.0e-17_wp) then   ! Skip vector if linear dependent.
      j = j+1
      e_diis(:,j) = e_diis(:,i)/sqrt(gg)
    end if
  end do
end do
! normally mDIIS=2*nDIIS, but it can happen that not all unit vectors are linear independent (mDIIS<=2*nDIIS).
! mDIIS is then the number of linear independent e_diis column vectors that span the subspace
mDIIS = j

#ifdef _DEBUGPRINT_
write(u6,*) '      mOV:',mOV
write(u6,*) 'nExplicit:',nExplicit
write(u6,*) 'IterGEK   :',IterGEK
write(u6,*) '    nDIIS:',nDIIS
write(u6,*) '    mDIIS:',mDIIS

write(u6,*) 'Check the orthonormality'
do i=1,mDIIS
  do j=1,i
    write(u6,*) i,j,DDot_(mOV,e_diis(:,i),1,e_diis(:,j),1)
  end do
  write(u6,*)
end do
if (allocated(e_diis)) call RecPrt('e_diis',' ',e_diis,mOV,mDIIS)
#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Compute the projected displacement coordinates. Note that the displacements are relative to the last coordinate, q(:,nDIIS). !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
call mma_allocate(q_diis,mDIIS,nDIIS+Max_Iter,Label='q_diis')
q_diis(:,:) = Zero
do i=1,nDIIS
  do k=1,mDIIS
    q_diis(k,i) = sum((q(:,i)-q(:,nDIIS))*e_diis(:,k))
  end do
end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Computed the projected gradients !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
call mma_allocate(g_diis,mDIIS,nDIIS+Max_Iter,Label='g_diis')
g_diis(:,:) = Zero
do i=1,nDIIS
  do k=1,mDIIS
    g_diis(k,i) = sum(g(:,i)*e_diis(:,k))
  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt('q_diis',' ',q_diis,mDIIS,nDIIS)
call RecPrt('g_diis',' ',g_diis,mDIIS,nDIIS)
#endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Project the approximate Hessian to the subspace !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

call mma_allocate(H_diis,mDIIS,mDIIS,Label='H_diis')
!call mma_allocate(HDiag_diis,mDIIS,Label='HDiag_diis')

do i=1,mDiis
  do j=1,mDiis
    H_diis(i,j) = sum(e_diis(:,i)*HDiag(:)*e_diis(:,j))
  end do
end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Undershoot avoidance: Scale along dq !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
if (Loosen%Factor /= One) then
  ! Components of dq in the subspace
  call mma_allocate(w,mDIIS,mDIIS,Label='w')
  gg = sqrt(DDot_(mOV,dq,1,dq,1))
  do i=1,mDIIS
    w(i,1) = DDot_(mOV,dq,1,e_diis(:,i),1)/gg
  end do
  ! D = I + (f-1) * w w^T
  ! H' = D^T H D
  call mma_allocate(D,mDIIS,mDIIS,Label='D')
  do i=1,mDIIS
    D(:,i) = (One/Loosen%Factor-One)*w(i,1)*w(:,1)
    D(i,i) = D(i,i)+One
  end do
  call dgemm_('N','N',mDIIS,mDIIS,mDIIS,One,H_diis,mDIIS,D,mDIIS,Zero,w,mDIIS)
  call dgemm_('N','N',mDIIS,mDIIS,mDIIS,One,D,mDIIS,w,mDIIS,Zero,H_diis,mDIIS)
  call mma_deallocate(D)
  call mma_deallocate(w)
end if

!do i=1,mDiis
!  HDiag_Diis(i) = H_Diis(i,i)
!end do
#ifdef _DEBUGPRINT_
call RecPrt('H_diis(HDiag)',' ',H_diis,mDIIS,mDIIS)
#endif


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

call mma_allocate(dq_diis,mDiis,Label='dq_Diis')
dq_diis(:) = Zero

!=======================================================================
! Start the optimization

Call GEK_Optimizer(mDiis,nDiis,Max_Iter,q_diis,g_diis,dq_diis,Energy(iFirst:),H_diis,dqdq,Step_Trunc,UpMeth,SORange)

!=======================================================================

! Compute the displacement in the full space.
dq(:) = Zero
do i=1,mDIIS
  dq(:) = dq(:)+dq_diis(i)*e_diis(:,i)
end do
dqdq = sqrt(DDot_(size(dq),dq(:),1,dq(:),1))

#ifdef _DEBUGPRINT_
write(u6,*) '||dq||=',sqrt(DDot_(size(dq),dq(:),1,dq(:),1))
call RecPrt('dq',' ',dq(:),size(dq),1)
#endif

call Finish_Kriging()
call mma_deallocate(dq_diis)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

call mma_deallocate(H_diis)
call mma_deallocate(q_diis)
call mma_deallocate(g_diis)
call mma_deallocate(e_diis,safe='*')

call mma_deallocate(g)
call mma_deallocate(q)

#ifdef _DEBUGPRINT_
write(u6,*) 'Exit S-GEK Optimizer'
#endif
call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(12) = TimFld(12)+(Cpu2-Cpu1)

end subroutine S_GEK_Optimizer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
*  CollapseOutput
*
*> @brief
*>   Place markers for collapsed parts in output
*> @author V. Veryazov
*>
*> @details
*> If \p iSw = ``1``, print Message preceded by a marker to
*> start collapsed part in the output.
*>
*> If \p iSw = ``0``, place a marker to terminate collapsed part.
*> \p STR is not used, but recommended.
*>
*> @param[in] iSw Begin/End switch
*> @param[in] STR Message
************************************************************************
      Subroutine CollapseOutput(iSw, STR)
      character*(*) STR
      Integer iSw
      Common /icolorize/icolorize
      if(icolorize.eq.1) then
       if(iSw.eq.1) then
         write(6,'(A,A)') '++ ',STR(:mylen(STR))
       else
        write(6,'(A)') '--'
       endif
      else
         if(iSw.eq.1) write(6,'(A)') STR(:mylen(STR))
      endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqelg(n,epstab,reslt,abserr,res3la,nres)
!***begin prologue  dqelg
!***refer to  dqagie,dqagoe,dqagpe,dqagse
!***routines called  d1mach
!***revision date  830518   (yymmdd)
!***keywords  epsilon algorithm, convergence acceleration,
!             extrapolation
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  the routine determines the limit of a given sequence of
!            approximations, by means of the epsilon algorithm of
!            p.wynn. an estimate of the absolute error is also given.
!            the condensed epsilon table is computed. only those
!            elements needed for the computation of the next diagonal
!            are preserved.
!***description
!
!           epsilon algorithm
!           standard fortran subroutine
!           real*8 version
!
!           parameters
!              n      - integer
!                       epstab(n) contains the new element in the
!                       first column of the epsilon table.
!
!              epstab - real*8
!                       vector of dimension 52 containing the elements
!                       of the two lower diagonals of the triangular
!                       epsilon table. the elements are numbered
!                       starting at the right-hand corner of the
!                       triangle.
!
!              reslt  - real*8
!                       resulting approximation to the integral
!
!              abserr - real*8
!                       estimate of the absolute error computed from
!                       result and the 3 previous results
!
!              res3la - real*8
!                       vector of dimension 3 containing the last 3
!                       results
!
!              nres   - integer
!                       number of calls to the routine
!                       (should be zero at first call)
!
!***end prologue  dqelg

use Constants, only: One, Five
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: n, nres
real(kind=wp), intent(inout) :: epstab(52), res3la(3)
real(kind=wp), intent(out) :: reslt, abserr
integer(kind=iwp) :: i, ib, ib2, ie, indx, k1, k2, k3, limexp, newelm, num
real(kind=wp) :: delta1, delta2, delta3, epmach, epsinf, error, err1, err2, err3, e0, e1, e1abs, e2, e3, oflow, res, ss, tol1, &
                 tol2, tol3
real(kind=wp), external :: d1mach

! list of major variables
! -----------------------
!
! e0     - the 4 elements on which the computation of a new
! e1       element in the epsilon table is based
! e2
! e3                 e0
!              e3    e1    new
!                    e2
! newelm - number of elements to be computed in the new
!          diagonal
! error  - error = abs(e1-e0)+abs(e2-e1)+abs(new-e2)
! reslt  - the element in the new diagonal with least value
!          of error
!
! machine dependent constants
! ---------------------------
!
! epmach is the largest relative spacing.
! oflow is the largest positive magnitude.
! limexp is the maximum number of elements the epsilon
! table can contain. if this number is reached, the upper
! diagonal of the epsilon table is deleted.
!
!***first executable statement  dqelg

epmach = d1mach(4)
oflow = d1mach(2)
nres = nres+1
abserr = oflow
reslt = epstab(n)
if (n < 3) then
  abserr = max(abserr,Five*epmach*abs(reslt))
  return
end if
limexp = 50
epstab(n+2) = epstab(n)
newelm = (n-1)/2
epstab(n) = oflow
num = n
k1 = n
do i=1,newelm
  k2 = k1-1
  k3 = k1-2
  res = epstab(k1+2)
  e0 = epstab(k3)
  e1 = epstab(k2)
  e2 = res
  e1abs = abs(e1)
  delta2 = e2-e1
  err2 = abs(delta2)
  tol2 = max(abs(e2),e1abs)*epmach
  delta3 = e1-e0
  err3 = abs(delta3)
  tol3 = max(e1abs,abs(e0))*epmach
  if ((err2 < tol2) .and. (err3 < tol3)) then

    ! if e0, e1 and e2 are equal to within machine
    ! accuracy, convergence is assumed.
    ! reslt = e2
    ! abserr = abs(e1-e0)+abs(e2-e1)

    reslt = res
    abserr = err2+err3
    ! ***jump out of do-loop
    abserr = max(abserr,Five*epmach*abs(reslt))
    return
  end if
  e3 = epstab(k1)
  epstab(k1) = e1
  delta1 = e1-e3
  err1 = abs(delta1)
  tol1 = max(e1abs,abs(e3))*epmach

  ! if two elements are very close to each other, omit
  ! a part of the table by adjusting the value of n

  if ((err1 <= tol1) .or. (err2 <= tol2) .or. (err3 <= tol3)) then
    n = i+i-1
    ! ***jump out of do-loop
    exit
  end if
  ss = One/delta1+One/delta2-One/delta3
  epsinf = abs(ss*e1)

  ! test to detect irregular behaviour in the table, and
  ! eventually omit a part of the table adjusting the value
  ! of n.

  if (epsinf <= 1.0e-4_wp) then
    n = i+i-1
    ! ***jump out of do-loop
    exit
  end if

  ! compute a new element and eventually adjust
  ! the value of reslt.

  res = e1+One/ss
  epstab(k1) = res
  k1 = k1-2
  error = err2+abs(res-e2)+err3
  if (error <= abserr) cycle
  abserr = error
  reslt = res
end do

! shift the table.

if (n == limexp) n = 2*(limexp/2)-1
ib = 1
if ((num/2)*2 == num) ib = 2
ie = newelm+1
do i=1,ie
  ib2 = ib+2
  epstab(ib) = epstab(ib2)
  ib = ib2
end do
if (num /= n) then
  indx = num-n+1
  do i=1,n
    epstab(i) = epstab(indx)
    indx = indx+1
  end do
end if
if (nres < 4) then
  res3la(nres) = reslt
  abserr = oflow
  abserr = max(abserr,Five*epmach*abs(reslt))
  return
end if

! compute error estimate

abserr = abs(reslt-res3la(3))+abs(reslt-res3la(2))+abs(reslt-res3la(1))
res3la(1) = res3la(2)
res3la(2) = res3la(3)
res3la(3) = reslt
abserr = max(abserr,Five*epmach*abs(reslt))

return

end subroutine dqelg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c
       subroutine fack (wrk,wrksize,
     & nind,newtyp,mapda,ssa,mapia,mapdb,mapib,possb0,
     &                  rc)
c
c     nind   - # of indexes in matrices A,B (Input)
c     newtyp - typ of final matrix B (Input) (i.e. mapdb(0,6), see docc.txt)
c     mapda  - direct map matrix corresponding to A (Input) (see docc.txt)
c     ssa    - overall symmetry state of matrix A (Input)
c     mapia  - inverse map matrix corresponding to A (Input) (see docc.txt)
c     mapdb  - direct map matrix corresponding to B (Output) (see docc.txt)
c     mapib  - inverse map matrix corresponding to B (Output) (see docc.txt)
c     possb0 - initial possition of B matrix in WRK (Input)
c     rc     - return (error) code (Output)
c
c     this routine realize following packings :

c     Operation                   Nind    TypA    TypB
c
c     B(pq)     = A(p,q)     - A(q,p)          2       0       1
c     B(pq,r)   = A(p,q,r)   - A(q,p,r)        3       0       1
c     B(p,qr)   = A(p,q,r)   - A(p,r,q)        3       0       2
c     B(pq,r,s) = A(p,q,r,s) - A(q,p,r,s)      4       0       1
c     B(p,q,rs) = A(p,q,r,s) - A(q,p,s,r)      4       0       3
c     B(pq,rs)  = NCI                          4       0       4
c     B(pq,rs)  = A(pq,r,s)  - A(pq,s,r)       4       1       4
c     B(pq,rs)  = A(p,q,rs)  - A(q,p,rs)       4       3       4
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer nind,newtyp,ssa,possb0,rc
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8,
     & nhelp9
       integer sb1,sb2,sb3,sb4
       integer rc1,ib,iap,iam,posst
c
       rc=0
c
c     get mapdb,mapib
c
       call grc0 (nind,newtyp,mapda(0,1),mapda(0,2),mapda(0,3),mapda(0,
     &            4),ssa,
     & possb0,posst,mapdb,mapib)
c
       if (nind.lt.2) then
c
c     *********  less than 2 ind ***
c
c     RC=1 less than 2 indexes
       rc=1
       return
c
       else if (nind.eq.2) then
c
c     *********  2 indexes *********
c
c2.1  A(p,q) -> B(pq)
c
       if (mapda(0,6).ne.0) then
c     RC=2 bad type for: nind=2
       rc=2
       return
       end if
c
       do 210 ib=1,mapdb(0,5)
c
       sb1=mapdb(ib,3)
       sb2=mapdb(ib,4)
       if (mapdb(ib,2).eq.0) goto 210
c
       if (sb1.eq.sb2) then
c     sym b1 = sym b2
c
c     def ia+,-
       iap=mapia(sb1,1,1)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
c
c     def size
       nhelp9=nhelp4*(nhelp4-1)/2
c
       call pack210 (wrk(nhelp2),wrk(nhelp1),nhelp9,nhelp4,rc1)
c
       else
c     sym b1 > sym b2
c
c     def ia+,-
       iap=mapia(sb1,1,1)
       iam=mapia(sb2,1,1)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
       nhelp3=mapda(iam,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
c
       call pack211 (wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,
     &               rc1)
c

       end if
c
 210    continue
c
       else if (nind.eq.3) then
c
c     *********  3 indexes *********
c
       if (mapda(0,6).ne.0) then
c     RC=3 bad type for: nind=3
       rc=3
       return
       end if
c
       if (newtyp.eq.1) then
c
c3.1  A(p,q,r) -> B(pq,r)
c
       do 310 ib=1,mapdb(0,5)
c
       sb1=mapdb(ib,3)
       sb2=mapdb(ib,4)
       sb3=mapdb(ib,5)
       if (mapdb(ib,2).eq.0) goto 310
c
       if (sb1.eq.sb2) then
c     sym b1 = sym b2
c
c     def ia+,-
       iap=mapia(sb1,sb2,1)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp6=dimm(mapdb(0,3),sb3)
c
c     def size
       nhelp9=nhelp4*(nhelp4-1)/2
c
       call pack310 (wrk(nhelp2),wrk(nhelp1),nhelp9,nhelp6,nhelp4,rc1)
c
       else
c     sym b1 > sym b2
c
c     def ia+,-
       iap=mapia(sb1,sb2,1)
       iam=mapia(sb2,sb1,1)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
       nhelp3=mapda(iam,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
       nhelp6=dimm(mapdb(0,3),sb3)
c
       call pack311 (wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,
     &               nhelp6,rc1)
c
       end if
c
 310    continue
c
       else if (newtyp.eq.2) then
c
c3.2  A(p,q,r) -> B(p,qr)
c
       do 320 ib=1,mapdb(0,5)
c
       sb1=mapdb(ib,3)
       sb2=mapdb(ib,4)
       sb3=mapdb(ib,5)
       if (mapdb(ib,2).eq.0) goto 320
c
       if (sb2.eq.sb3) then
c     sym b2 = sym b3
c
c     def ia+,-
       iap=mapia(sb1,sb2,1)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
c
c     def size
       nhelp9=nhelp5*(nhelp5-1)/2
c
       call pack320 (wrk(nhelp2),wrk(nhelp1),nhelp4,nhelp9,nhelp5,rc1)
c
       else
c     sym b2 > sym b3
c
c     def ia+,-
       iap=mapia(sb1,sb2,1)
       iam=mapia(sb1,sb3,1)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
       nhelp3=mapda(iam,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
       nhelp6=dimm(mapdb(0,3),sb3)
c
       call pack321 (wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,
     &               nhelp6,rc1)
c
       end if
c
 320    continue
c
       else
c     RC=4 : bad newtyp for: nind=3
       rc=4
       return
       end if
c
       else if (nind.eq.4) then
c
c     *********  4 indexes *********
c
       if (mapda(0,6).eq.0) then
c
c*    case A(p,q,r,s) => newtyp can be 1,3,4
c
       if (newtyp.eq.1) then
c
c4.1  A(p,q,r,s) -> B(pq,r,s)
c
       do 410 ib=1,mapdb(0,5)
c
       sb1=mapdb(ib,3)
       sb2=mapdb(ib,4)
       sb3=mapdb(ib,5)
       sb4=mapdb(ib,6)
       if (mapdb(ib,2).eq.0) goto 410
c
       if (sb1.eq.sb2) then
c     sym b1 = sym b2
c
c     def ia+,-
       iap=mapia(sb1,sb2,sb3)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp6=dimm(mapdb(0,3),sb3)
       nhelp7=dimm(mapdb(0,4),sb4)
c
c     def size
       nhelp8=nhelp4*(nhelp4-1)/2
       nhelp9=nhelp6*nhelp7
c
       call pack310 (wrk(nhelp2),wrk(nhelp1),nhelp8,nhelp9,nhelp4,rc1)
c
       else
c     sym b1 > sym b2
c
c     def ia+,-
       iap=mapia(sb1,sb2,sb3)
       iam=mapia(sb2,sb1,sb3)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
       nhelp3=mapda(iam,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
       nhelp6=dimm(mapdb(0,3),sb3)
       nhelp7=dimm(mapdb(0,4),sb4)
c
c     def size
       nhelp9=nhelp6*nhelp7
c
       call pack311 (wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,
     &               nhelp9,rc1)
c
       end if
c
 410    continue
c
       else if (newtyp.eq.3) then
c
c4.2  A(p,q,r,s) -> B(p,q,rs)
c
       do 420 ib=1,mapdb(0,5)
c
       sb1=mapdb(ib,3)
       sb2=mapdb(ib,4)
       sb3=mapdb(ib,5)
       sb4=mapdb(ib,6)
       if (mapdb(ib,2).eq.0) goto 420
c
       if (sb3.eq.sb4) then
c     sym b3 = sym b4
c
c     def ia+,-
       iap=mapia(sb1,sb2,sb3)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
       nhelp6=dimm(mapdb(0,3),sb3)
c
c     def size
       nhelp8=nhelp6*(nhelp6-1)/2
       nhelp9=nhelp4*nhelp5
c
       call pack320 (wrk(nhelp2),wrk(nhelp1),nhelp9,nhelp8,nhelp6,rc1)
c
       else
c     sym b3 > sym b4
c
c     def ia+,-
       iap=mapia(sb1,sb2,sb3)
       iam=mapia(sb1,sb2,sb4)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
       nhelp3=mapda(iam,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
       nhelp6=dimm(mapdb(0,3),sb3)
       nhelp7=dimm(mapdb(0,4),sb4)
c
c     def size
       nhelp9=nhelp4*nhelp5
c
       call pack321 (wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp9,nhelp6,
     &               nhelp7,rc1)
c
       end if
c
 420    continue
c
       else if (newtyp.eq.4) then
c
c4.3  A(p,q,r,s) -> B(pq,rs)
c
c     RC=5 : Not Currently Implemented : nind=4, oldtyp=0, newtyp=4
       rc=5
       return
c
       else
c     RC=6 : incompatible newtyp for: nind=4, oldtyp=0
       rc=6
       return
       end if
c
       else if (mapda(0,6).eq.1) then
c
c*    case A(pq,r,s) => newtyp can be 4
c
       if (newtyp.eq.4) then
c
c4.4  A(pq,r,s) -> B(pq,rs)
c
       do 440 ib=1,mapdb(0,5)
c
       sb1=mapdb(ib,3)
       sb2=mapdb(ib,4)
       sb3=mapdb(ib,5)
       sb4=mapdb(ib,6)
       if (mapdb(ib,2).eq.0) goto 440
c
       if (sb3.eq.sb4) then
c     sym b3 = sym b4
c
c     def ia+,-
       iap=mapia(sb1,sb2,sb3)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
       nhelp6=dimm(mapdb(0,3),sb3)
c
c     def size
       nhelp8=nhelp6*(nhelp6-1)/2
       if (sb1.eq.sb2) then
       nhelp9=nhelp4*(nhelp4-1)/2
       else
       nhelp9=nhelp4*nhelp5
       end if
c
       call pack320 (wrk(nhelp2),wrk(nhelp1),nhelp9,nhelp8,nhelp6,rc1)
c
       else
c     sym b3 > sym b4
c
c     def ia+,-
       iap=mapia(sb1,sb2,sb3)
       iam=mapia(sb1,sb2,sb4)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
       nhelp3=mapda(iam,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
       nhelp6=dimm(mapdb(0,3),sb3)
       nhelp7=dimm(mapdb(0,4),sb4)
c
c     def size
       if (sb1.eq.sb2) then
       nhelp9=nhelp4*(nhelp4-1)/2
       else
       nhelp9=nhelp4*nhelp5
       end if
c
       call pack321 (wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp9,nhelp6,
     &               nhelp7,rc1)
c
       end if
c
 440    continue
c
       else
c     RC=7 : incompatible newtyp for: nind=4, oldtyp=1
       rc=7
       return
       end if
c
       else if (mapda(0,6).eq.3) then
c
c*    case A(p,q,rs) => newtyp can be 4
c
       if (newtyp.eq.4) then
c
c4.5  A(p,q,rs) -> B(pq,rs)
c
       do 450 ib=1,mapdb(0,5)
c
       sb1=mapdb(ib,3)
       sb2=mapdb(ib,4)
       sb3=mapdb(ib,5)
       sb4=mapdb(ib,6)
       if (mapdb(ib,2).eq.0) goto 450
c
       if (sb1.eq.sb2) then
c     sym b1 = sym b2
c
c     def ia+,-
       iap=mapia(sb1,sb2,sb3)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp6=dimm(mapdb(0,3),sb3)
       nhelp7=dimm(mapdb(0,4),sb4)
c
c     def size
       nhelp8=nhelp4*(nhelp4-1)/2
       if (sb3.eq.sb4) then
       nhelp9=nhelp6*(nhelp6-1)/2
       else
       nhelp9=nhelp6*nhelp7
       end if
c
       call pack310 (wrk(nhelp2),wrk(nhelp1),nhelp8,nhelp9,nhelp4,rc1)
c
       else
c     sym b1 > sym b2
c
c     def ia+,-
       iap=mapia(sb1,sb2,sb3)
       iam=mapia(sb2,sb1,sb3)
c
c     poss B,A+,A-
       nhelp1=mapdb(ib,1)
       nhelp2=mapda(iap,1)
       nhelp3=mapda(iam,1)
c
c     dimp-s
       nhelp4=dimm(mapdb(0,1),sb1)
       nhelp5=dimm(mapdb(0,2),sb2)
       nhelp6=dimm(mapdb(0,3),sb3)
       nhelp7=dimm(mapdb(0,4),sb4)
c
c     def size
       if (sb3.eq.sb4) then
       nhelp9=nhelp6*(nhelp6-1)/2
       else
       nhelp9=nhelp6*nhelp7
       end if
c
       call pack311 (wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,
     &               nhelp9,rc1)
c
       end if
c
 450    continue
c
       else
c     RC=8 : incompatible newtyp for: nind=4, oldtyp=3
       rc=8
       return
       end if
c
       else
c     RC=9 : incompatible typold for: nind=4
       rc=9
       return
       end if
c
       else
c
c     *********  more than 4 ind ***
c
c     RC=10: more than 4 indexes
       rc=10
       return
       end if
c
       return
       end
c
c     -----------------------
c
       subroutine pack210 (a,b,dimpq,dimp,rc)
c
c     this routine do: B(pq) = A(p,q) - A(q,p) for symp=symq
c
       integer dimp,dimpq,rc
       real*8 a(1:dimp,1:dimp)
       real*8 b(1:dimpq)
c
c     help variables
c
       integer p,q,pq
c
       rc=0
       if (dimp.gt.1) then
c
       pq=0
       do 100 p=2,dimp
       do 101 q=1,p-1
       pq=pq+1
       b(pq)=a(p,q)-a(q,p)
 101    continue
 100    continue
c
       else
c     RC=1 : dimp is less than 2
       rc=1
       end if
c
       return
       end
c
c     -----------------------
c
       subroutine pack211 (ap,am,b,dimp,dimq,rc)
c
c     this routine do: B(p,q) = A+(p,q) - A-(q,p) for symp>symq
c
       integer dimp,dimq,rc
       real*8 ap(1:dimp,1:dimq)
       real*8 am(1:dimq,1:dimp)
       real*8 b(1:dimp,1:dimq)
c
c     help variables
c
       integer p,q
c
       rc=0
       do 100 q=1,dimq
       do 101 p=1,dimp
       b(p,q)=ap(p,q)-am(q,p)
 101    continue
 100    continue
c
       return
       end
c
c     -----------------------
c
       subroutine pack310 (a,b,dimpq,dimr,dimp,rc)
c
c     this routine do: B(pq,r) = A(p,q,r) - A(q,p,r) for symp=symq
c
       integer dimp,dimpq,dimr,rc
       real*8 a(1:dimp,1:dimp,1:dimr)
       real*8 b(1:dimpq,1:dimr)
c
c     help variables
c
       integer p,q,r,pq
c
       rc=0
       if (dimp.gt.1) then
c
       do 100 r=1,dimr
       pq=0
       do 101 p=2,dimp
       do 102 q=1,p-1
       pq=pq+1
       b(pq,r)=a(p,q,r)-a(q,p,r)
 102    continue
 101    continue
 100    continue
c
       else
c     RC=1 : dimp is less than 2
       rc=1
       end if
c
       return
       end
c
c     -----------------------
c
       subroutine pack311 (ap,am,b,dimp,dimq,dimr,rc)
c
c     this routine do: B(p,q,r) = A+(p,q,r) - A-(q,p,r) for symp>symq
c
       integer dimp,dimq,dimr,rc
       real*8 ap(1:dimp,1:dimq,1:dimr)
       real*8 am(1:dimq,1:dimp,1:dimr)
       real*8 b(1:dimp,1:dimq,1:dimr)
c
c     help variables
c
       integer p,q,r
c
       rc=0
       do 100 r=1,dimr
       do 101 q=1,dimq
       do 102 p=1,dimp
       b(p,q,r)=ap(p,q,r)-am(q,p,r)
 102    continue
 101    continue
 100    continue
c
       return
       end
c
c     -----------------------
c
       subroutine pack320 (a,b,dimp,dimqr,dimq,rc)
c
c     this routine do: B(p,qr) = A(p,q,r) - A(p,r,q) for symq=symr
c
       integer dimp,dimqr,dimq,rc
       real*8 a(1:dimp,1:dimq,1:dimq)
       real*8 b(1:dimp,1:dimqr)
c
c     help variables
c
       integer p,q,r,qr
c
       rc=0
       if (dimq.gt.1) then
c
       qr=0
       do 100 q=2,dimq
       do 101 r=1,q-1
       qr=qr+1
       do 102 p=1,dimp
       b(p,qr)=a(p,q,r)-a(p,r,q)
 102    continue
 101    continue
 100    continue
c
       else
c     RC=1 : dimp is less than 2
       rc=1
       end if
c
       return
       end
c
c     -----------------------
c
       subroutine pack321 (ap,am,b,dimp,dimq,dimr,rc)
c
c     this routine do: B(p,q,r) = A+(p,q,r) - A-(p,r,q) for symq>symr
c
       integer dimp,dimq,dimr,rc
       real*8 ap(1:dimp,1:dimq,1:dimr)
       real*8 am(1:dimp,1:dimr,1:dimq)
       real*8 b(1:dimp,1:dimq,1:dimr)
c
c     help variables
c
       integer p,q,r
c
       rc=0
       do 100 r=1,dimr
       do 101 q=1,dimq
       do 102 p=1,dimp
       b(p,q,r)=ap(p,q,r)-am(p,r,q)
 102    continue
 101    continue
 100    continue
c
       return
       end
c
c     -----------------------
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Anders Bernhardsson                              *
************************************************************************
      SubRoutine UnCompress2(ArrayIn,ArrayOut,dsym)
*
*************************************************************
*
*     Change from vector to kappa   notation
*                               ip
*
*     where i is occupied and p is general
*
*     used by the preconditioner.
*
*************************************************************
*
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
      Integer dsym
      Real*8  ArrayIn(nDensC),ArrayOut(nDens)
      indexC=0
      Fact=1.0d0
      If (dsym.lt.0) Fact=-Fact
      dsym=abs(dsym)
      call dcopy_(nDens,[0.0d0],0,ArrayOut,1)
      jT=0 ! dummy initialize
      i1=0 ! dummy initialize
      j1=0 ! dummy initialize
      Do iSym=1,nSym
       Do jSym=1,nSym
        If (iEOr(iSym-1,jSym-1)+1.eq.dSym) Then
         Do jBas=1,nB(jSym)
          If (jBas.le.nIsh(jsym)) Then
             jT=0
             i1=nIsh(isym)
             j1=nIsh(jsym)
          Else If (jBas.le.nIsh(jsym)+nRs1(jsym)) Then
             jT=1
             i1=nRs1(isym)
             j1=nRs1(jsym)
          Else If (jBas.le.nIsh(jsym)+nRs2(jsym)) Then
             jT=2
             i1=nRs2(isym)
             j1=nRs2(jsym)
          Else If (jBas.le.nIsh(jsym)+nRs3(jsym)) Then
             jT=3
             i1=nRs3(isym)
             j1=nRs3(jsym)
          End If
          Do iBas=1,nOrb(iSym)
           If (iBas.le.nIsh(isym)) Then
             iT=0
             ij=0
             ji=j1
           Else If (iBas.le.nIsh(isym)+nRs1(isym)) Then
             iT=1
             ij=0
             ji=j1
             if (it.gt.jt) then
               ij=i1
               ji=0
             end if
           Else If (iBas.le.nIsh(isym)+nRs2(isym)) Then
             iT=2
             ij=0
             ji=j1
             if (it.gt.jt) then
               ij=i1
               ji=0
             end if
           Else If (iBas.le.nIsh(isym)+nRs3(isym)) Then
             iT=3
             ij=0
             ji=j1
             if (it.gt.jt) then
               ij=i1
               ji=0
             end if
           Else
             iT=4
             ij=i1
             ji=0
           End If
           If (Timedep) Then
            If (iT.ne.jT) Then
             indexC=indexc+1
             Index1=ipMat(iSym,jSym)+(jBas-1)*norb(iSym)+iBas-1
             ArrayOut(Index1)=Fact*ArrayIn(indexC)
            End If
           Else
            If (iT.gt.jT) Then
             indexC=indexc+1
             Index1=ipMat(iSym,jSym)+
     &               (jBas-1)*norb(iSym)+iBas-ij-1
             Index2=ipMat(jSym,iSym)+
     &               (iBas-1)*norb(jSym)+jBas-ji-1
             ArrayOut(Index1)=Fact*ArrayIn(indexC)
             If (iBas.le.nB(isym))
     &        ArrayOut(Index2)=Fact*ArrayIn(indexC)
            End If
           End If
          End Do
         End Do
        End If
       End Do
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine LEVQAD(Y1,Y2,Y3,H,RT,ANS1,ANS2)
!** Subroutine "LEVQAD" fits quadratic  Y = A + B*X + C*X**2  through
!  function values  Y1, Y2, Y3  at equally spaced points separated by
!  distance H, where  Y1 < 0  and (Y2,Y3 >= 0), locates the function
!  zero (at RT, relative to  X1 < X2 = 0) between points X1 & X2, and
!  evaluates the integral from RT to R3 of   1/sqrt(Y)  , called
!  ANS1, and the integral (same range) of  sqrt(Y) , which is ANS2
!** Alternately, if Y1 & Y3 both  < 0  and only the middle point
!  Y2 >= 0 ,   fit the points to:  Y = A - B*(X-X0)**2 , locate the
!  turning points between which  Y(X) > 0  and evaluate these integrals
!  on this interval.  *************************************************
!----------------------------------------------------------------------

use Constants, only: Zero, One, Two, Three, Four, Half, Pi
use Definitions, only: wp, u6

implicit none
real(kind=wp), intent(in) :: Y1, Y2, Y3, H
real(kind=wp), intent(out) :: RT, ANS1, ANS2
real(kind=wp) :: A, B, C, CQ, R1, R2, RCQ, RR, SL3, SLT, X0, ZT

if ((Y1 >= 0) .or. (Y2 < 0)) then
  write(u6,602) Y1,Y2
  ANS1 = Zero
  ANS2 = Zero
else if (Y3 < Zero) then
  ! Here treat case when only 'Y2' is non-negative
  RR = (Y2-Y1)/(Y2-Y3)
  X0 = H*(RR-ONe)/((RR+ONe)*Two)
  B = (Y2-Y1)/(H*(Two*X0+H))
  A = Y2+B*X0**2
  ZT = sqrt(A/B)
  RT = X0-ZT
  ANS1 = PI/sqrt(B)
  ANS2 = ANS1*A*Half
else
  ! Here treat case where both 'Y2' & 'Y3' are positive
  if (abs((Y2-Y1)/(Y3-Y2)-One) < 1.0e-10_wp) then
    ! ... special case of true (to 1/10^10) linearity ...
    RT = -H*Y2/(Y2-Y1)
    ANS1 = Two*(H-RT)/sqrt(Y3)
    ANS2 = ANS1*Y3/Three
    return
  end if
  C = (Y3-Two*Y2+Y1)/(Two*H*H)
  B = (Y3-Y2)/H-C*H
  A = Y2
  CQ = B**2-Four*A*C
  RCQ = sqrt(CQ)
  R1 = (-B-RCQ)/(Two*C)
  R2 = R1+RCQ/C
  if ((R2 <= Zero) .and. (R2 >= -H)) RT = R2
  if ((R1 <= Zero) .and. (R1 >= -H)) RT = R1
  SL3 = Two*C*H+B
  SLT = Two*C*RT+B
  if (C < Zero) then
    ANS1 = -(asin(SL3/RCQ)-sign(Half*Pi,SLT))/sqrt(-C)
  else
    ANS1 = log((Two*sqrt(C*Y3)+SL3)/SLT)/sqrt(C)
  end if
  ANS2 = (SL3*sqrt(Y3)-CQ*ANS1*Half)/(Four*C)
  if (RT >= H) write(u6,601) H,R1,R2
end if

return

601 format(' *** CAUTION *** in LEVQAD, turning point not between points 1 & 2.   H =',F9.6,'   R1 =',F9.6,'   R2 =',F9.6)
602 format(' *** ERROR in LEVQAD *** No turning point between 1-st two points as   Y1=',ES10.3,'   Y2=',ES10.3)

end subroutine LEVQAD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RdVec_Localisation(nSym,nBas,nOrb,IndT,CMO,Occ,EOrb,
     &                              FName)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Read orbital info and return in a format suitable for module
C     localisation: deleted orbitals are included (as zeros). This is a
C     work-around to fix bugs when orbitals are deleted.
C
      Implicit None
      Integer nSym ! number of irreps
      Integer nBas(nSym)  ! number of basis functions
      Integer nOrb(nSym)  ! number of orbitals
      Integer IndT(*)  ! type indices, dim: nBas
      Real*8  CMO(*)   ! MO coefficients, dim: nBas*nBas
      Real*8  Occ(*)   ! Occupation numbers, dim: nBas
      Real*8  EOrb(*)  ! EOrb, dim: nBas
      Character*(*) FName ! filename with input orbitals
#include "warnings.fh"
#include "WrkSpc.fh"

      Character*18 SecNam
      Parameter (SecNam='RdVec_Localisation')

      Character*80 VTitle

      Integer nBasT, nOrbT, iSym
      Integer ip_CMO, l_CMO
      Integer ip_Occ, l_Occ
      Integer ip_EOr, l_EOr
      Integer ip_Ind, l_Ind
      Integer Lu, iUHF, iWarn, iErr, iWFType, k1, k2, i
      Integer mylen
      External mylen

      Real*8 Dummy(1)

      nBasT=nBas(1)
      nOrbT=nOrb(1)
      Do iSym=2,nSym
         nBasT=nBasT+nBas(iSym)
         nOrbT=nOrbT+nOrb(iSym)
      End Do

      l_CMO=nBas(1)*nOrb(1)
      Do iSym=2,nSym
         l_CMO=l_CMO+nBas(iSym)*nOrb(iSym)
      End Do
      l_Occ=nOrbT
      l_EOr=nOrbT
      l_Ind=nBasT
      Call GetMem('CMO_','Allo','Real',ip_CMO,l_CMO)
      Call GetMem('Occ_','Allo','Real',ip_Occ,l_Occ)
      Call GetMem('EOr_','Allo','Real',ip_EOr,l_EOr)
      Call GetMem('Ind_','Allo','Inte',ip_Ind,l_Ind)

      Lu=75
      iUHF=0  ! restricted HF
      iWarn=2 ! abend if nBas/nOrb info is inconsistent
      iErr=-1 ! init return code
      iWFType=-1 ! init wave function type
      Dummy(1)=9.9d9 ! dummy variable
      Call RdVec_(FName,Lu,'COEI',iUHF,nSym,nBas,nOrb,
     &            Work(ip_CMO),Dummy,Work(ip_Occ),Dummy,
     &            Work(ip_EOr),Dummy,iWork(ip_Ind),VTitle,iWarn,iErr,
     &            iWFType)
      If (iErr.ne.0) Then
         Call WarningMessage(2,
     &                     SecNam//': Non-zero return code from RdVec_')
         Write(6,'(A,A,I9)') SecNam,': RdVec_ returned code',iErr
         Call xFlush(6)
         Call xQuit(_RC_IO_ERROR_READ_)
      End If
      Write (6,*)
      Write (6,'(A)') ' Header from vector file:'
      Write (6,*)
      Write (6,'(A)') VTitle(:mylen(VTitle))
      Write (6,*)

      k1=ip_CMO
      k2=1
      Do iSym=1,nSym
         Call dCopy_(nBas(iSym)*nOrb(iSym),Work(k1),1,CMO(k2),1)
         Call Cho_dZero(CMO(k2+nBas(iSym)*nOrb(iSym)),
     &                  nBas(iSym)*(nBas(iSym)-nOrb(iSym)))
         k1=k1+nBas(iSym)*nOrb(iSym)
         k2=k2+nBas(iSym)*nBas(iSym)
      End Do

      k1=ip_Occ
      k2=1
      Do iSym=1,nSym
         Call dCopy_(nOrb(iSym),Work(k1),1,Occ(k2),1)
         Call Cho_dZero(Occ(k2+nOrb(iSym)),
     &                  nBas(iSym)-nOrb(iSym))
         k1=k1+nOrb(iSym)
         k2=k2+nBas(iSym)
      End Do

      k1=ip_EOr
      k2=1
      Dummy(1)=9.9d9
      Do iSym=1,nSym
         Call dCopy_(nOrb(iSym),Work(k1),1,EOrb(k2),1)
         Call dCopy_(nBas(iSym)-nOrb(iSym),Dummy(1),0,
     &                                    EOrb(k2+nOrb(iSym)),1)
         k1=k1+nOrb(iSym)
         k2=k2+nBas(iSym)
      End Do

      k1=ip_Ind
      k2=1
      Do iSym=1,nSym
         Call iCopy(nOrb(iSym),iWork(k1),1,IndT(k2),1)
         Do i=nOrb(iSym),nBas(iSym)-1
            IndT(k2+i)=7
         End Do
         k1=k1+nOrb(iSym)
         k2=k2+nBas(iSym)
      End Do

      Call GetMem('Ind_','Free','Inte',ip_Ind,l_Ind)
      Call GetMem('EOr_','Free','Real',ip_EOr,l_EOr)
      Call GetMem('Occ_','Free','Real',ip_Occ,l_Occ)
      Call GetMem('CMO_','Free','Real',ip_CMO,l_CMO)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function isitareal_cvb(a)

use Definitions, only: iwp

implicit none
logical(kind=iwp) :: isitareal_cvb
character(len=*), intent(in) :: a
integer(kind=iwp) :: ich, j
logical(kind=iwp) :: done
integer(kind=iwp), parameter :: nallowed = 17
character, parameter :: allowedchars(nallowed) = ['+','-','0','1','2','3','4','5','6','7','8','9','.','E','e','D','d']

done = .false.
do ich=1,len_trim(a)
  do j=1,nallowed
    if (a(ich:ich) == allowedchars(j)) then
      done = .true.
      exit
    end if
  end do
  if (.not. done) then
    isitareal_cvb = .false.
    return
  end if
end do
isitareal_cvb = .true.

return

end function isitareal_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine exctdm(SIJ, TRAD, TDMAB, iRC, CMO1, CMO2, TDMZZ,
     &                  TRASD, TSDMAB, TSDMZZ, istate, jstate)

      use Basis_Info, only: nBas
      use Constants, only: Zero, Half
      use Data_structures, only: DSBA_Type, Allocate_DT, Deallocate_DT
      use Definitions, only: wp, iwp, u6
      use frenkel_global_vars, only: iTyp, labb, doexch, VNucB, eNucB
      use stdalloc, only: mma_allocate, mma_deallocate
      use Cntrl, only: NSTATE, MLTPLT
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NTDMAB,NASHT,NTDMZZ,NCMO,CHFRACMEM,NBASF

      IMPLICIT None
      type(DSBA_Type) :: DLT(1), SDLT(1), Salpha(1), Sbeta(1)
      integer(kind=iwp) :: nbas_tot(1), nbas_A(1), nbas_B(1),
     &        iRC, NNLTD, istate, jstate, run,
     &        m(1), n(1), a
      integer(kind=iwp), external :: isFreeUnit
      real(kind=wp) TDMAB(NTDMAB)
      real(kind=wp) TRAD(NASHT,NASHT)
      real(kind=wp) TRASD(NASHT,NASHT)
      real(kind=wp) TSDMAB(NTDMAB)
      real(kind=wp) TDMZZ(NTDMZZ)
      real(kind=wp) TSDMZZ(NTDMZZ)
      real(kind=wp) CMO1(NCMO)
      real(kind=wp) CMO2(NCMO)
      character(len=13) :: filnam
      real(kind=wp)  :: SIJ
      real(kind=wp), Allocatable:: TDMZZ_mtx(:,:), TDMZZ_new(:),
     &                            STDMZZ_mtx(:,:), STDMZZ_new(:)
      integer(kind=iwp) LuT, LuT_, I, J, K, INTEG, IPNB
      real(kind=wp), External :: DDot_
#ifdef _DEBUGPRINT_RASSI_
      logical :: debug_rassi_code = .true.
#else
      logical :: debug_rassi_code = .false.
#endif


!      write(u6,*) 'MLTPL', MLTPLT(1)
! Write number of states in files, since they can differ on monomers
        write(filnam,'(A,I1)') 'states_', iTyp
        LuT_ = 10
        LuT = isFreeUnit(LuT_)
        call molcas_open(LuT, filnam)
        write(LuT,*) NSTATE
        close(LuT)

! get number of basis functions for different monomers

      if (LABB) then
        nbas_B = NBASF(1)
        if (debug_rassi_code) then
          write(u6,*) 'basis functions of mon B', nbas_B
        end if
        call NameRun('AUXRFIL1')
        call get_iArray('nBas',nBas,nSym)
        nbas_tot = nBas(0)
        call NameRun('#Pop')    ! switch back to old RUNFILE
        if (debug_rassi_code) then
         write(u6,*) 'total num of basis functions', nbas_tot
        end if
        nbas_A = nbas_tot-nbas_B
        if (debug_rassi_code) then
         write(u6,*) 'basis functions of mon A', nbas_A
        end if
      end if

      if (.not. LABB) then
        nbas_A = NBASF(1)
        if (debug_rassi_code) then
          write(u6,*) 'basis functions of mon A', nbas_A
        end if
        call NameRun('AUXRFIL1')
        call get_iArray('nBas',nBas,nSym)
        nbas_tot = nBas(0)
        call NameRun('#Pop')    ! switch back to old RUNFILE
        if (debug_rassi_code) then
         write(u6,*) 'total num of basis functions', nbas_tot
        end if
        nbas_B = nbas_tot-nbas_A
        if (debug_rassi_code) then
         write(u6,*) 'basis functions of mon B', nbas_B
        end if
      end if
! get the dimensions of the packed lower triangular TDM
      NNLTD=nbas_tot(1)*(nbas_tot(1)+1)/2
      m = nbas_tot
      n = nbas_tot

!> regular-TDM
      call MKTDAB(SIJ,TRAD,TDMAB,iRC)
!> transform to AO basis
      call MKTDZZ(CMO1,CMO2,TDMAB,TDMZZ,iRC)
      call Allocate_DT(DLT(1),n,m,nSym,aCase='TRI')

      if (doexch) then
! for the exchange part we need the spin density
!> spin-TDM
        call MKTDAB(Zero,TRASD,TSDMAB,iRC)
!> transform to AO basis
        call MKTDZZ(CMO1,CMO2,TSDMAB,TSDMZZ,iRC)
! alpha part of the spin density
        if (MLTPLT(1) == 1) then
          call Allocate_DT(Salpha(1),nbas_tot,nbas_tot,nSym)
        else
          call Allocate_DT(Salpha(1),nbas_tot,nbas_tot,nSym)
          call Allocate_DT(Sbeta(1),nbas_tot,nbas_tot,nSym)
! allocate matrix for the spin density difference
          call Allocate_DT(SDLT(1),nbas_tot,nbas_tot,nSym)
          SDLT(1)%A00(:)=Zero
        end if
      end if

! case where MON B of the exciton calculation was calculated first
      if (labb) then
        call mma_allocate(TDMZZ_mtx,nbas_tot(1),nbas_tot(1))
        call mma_allocate(TDMZZ_new,nbas_tot(1)*nbas_tot(1))
        TDMZZ_mtx(:,:) = Zero
        TDMZZ_new(:) = Zero
! fill a matrix in combined basis with the TDM of MON B
! here, one shifts the entries of row and column of the matrix
! by the number of basis functions of MON A
! the fast running index is the column, because TDMZZ is filled in
! column-major order
        run=0
        do i=1,nbas_B(1)
          do j=1,nbas_B(1)
            run=run+1
            TDMZZ_mtx(j+nbas_A(1),i+nbas_A(1)) = TDMZZ(run)
          end do
        end do
! fill the TDM in common basis in an array
! in column-major order
        run=0
        do i=1,nbas_tot(1)
          do j=1,nbas_tot(1)
            run= run + 1
            TDMZZ_new(run) = TDMZZ_mtx(j,i)
          end do
        end do
! fill DLT (=TDM in common basis in packed, lower trangular storage)
        do i=1,nbas_tot(1)
          do j=1,i-1
            DLT(1)%A00(max(i,j)*(max(i,j)-3)/2 + i + j) =
     &        TDMZZ_new(nbas_tot(1)*(j-1)+i)
     &        + TDMZZ_new(nbas_tot(1)*(i-1)+j)
          end do
          DLT(1)%A00(j*(j-3)/2 + 2*j) = TDMZZ_new(nbas_tot(1)*(j-1)+j)
        end do

      if (debug_rassi_code) then
        write(u6,*) 'TDMZZvector:'
        k = nbas_B(1)*nbas_B(1)
        do i=1,k
          write(u6,*) TDMZZ(i)
        end do

        write(u6,*) 'TDMZZ:'
        k = int(sqrt(dble(nTDMZZ)))
        do i=1,k
          write(u6,'(100ES18.8)') (TDMZZ(i+(j-1)*k),j=1,k)
        end do

        write(u6,*) 'TDMZZ_new vector:'
        k = nbas_tot(1)*nbas_tot(1)
        do i=1,k
          write(u6,*) TDMZZ_new(i)
        end do

        write(u6,*) 'TDMZZ_new:'
        k = nbas_tot(1)
        do i=1,k
          write(u6,'(1000ES18.8)') (TDMZZ_new(i+(j-1)*k),j=1,k)
        end do
        write(u6,*) 'TDMZZ_mtx:'
        do i=1,k
          write(u6,'(1000ES18.8)') (TDMZZ_mtx(i,j),j=1,k)
        end do

        write(u6,*) 'DLT:'
        write(u6,*) DLT(1)%A00(:)
        write(u6,*) 'DLT as mtx:'
        k = 0
        do i=1,nbas_tot(1)
          write(u6,'(1000ES18.8)')  (DLT(1)%SB(1)%A1(j+k),j=1,i)
          k=k+i
        end do
      endif
! spin part if KCOUL is requested in excitonic section
      if (DoExch) then
        call mma_allocate(STDMZZ_mtx,nbas_tot(1),nbas_tot(1))
        call mma_allocate(STDMZZ_new,nbas_tot(1)*nbas_tot(1))
        STDMZZ_mtx(:,:) = Zero
        STDMZZ_new(:) = Zero
        run = 0
        do i=1,nbas_B(1)
          do j=1,nbas_B(1)
            run=run+1
            STDMZZ_mtx(j+nbas_A(1),i+nbas_A(1))=TSDMZZ(run)
          end do
        end do
        run = 0
        do i=1,nbas_tot(1)
          do j=1,nbas_tot(1)
            run = run + 1
            STDMZZ_new(run) = STDMZZ_mtx(j,i)
          end do
        end do
! fill SDLT (spin density difference)
        if (MLTPLT(1) > 1) then
          run = 0
          do i=1,nbas_tot(1)
            do j=1,nbas_tot(1)
              run= run + 1
              SDLT(1)%SB(1)%A1(run) = STDMZZ_mtx(i,j)
            end do
          end do
        end if
! fill Salpha from matrix, due to the row major data type
        run = 0
        do i=1,nbas_tot(1)
          do j=1,nbas_tot(1)
            run = run + 1
            Salpha(1)%SB(1)%A1(run) = TDMZZ_mtx(i,j)
          end do
        end do

        if (MLTPLT(1) > 1) then
! Salpha(1) = TM = GAA+GBB
! Salpha(1) becomes TM + SDLT = GAA+GBB+GAA-GBB=2GAA
          run = 0
          do i=1,nbas_tot(1)
            do j=1,nbas_tot(1)
              run = run + 1
              Salpha(1)%SB(1)%A1(run) =
     &        Salpha(1)%SB(1)%A1(run) + SDLT(1)%SB(1)%A1(run)
            end do
          end do
! Salpha(1) besomces GAA
          integ = int(nbas_tot(1)*nbas_tot(1), kind=iwp)
          call dscal_(integ, Half, Salpha(1)%A00(1), 1)
!Sbeta(1) becomes GBB
          run = 0
          do i=1,nbas_tot(1)
            do j=1,nbas_tot(1)
              run = run + 1
              Sbeta(1)%SB(1)%A1(run) = TDMZZ_new(run)-
     &                                 Salpha(1)%SB(1)%A1(run)
            end do
          end do
        end if

        call mma_deallocate(STDMZZ_new)
        call mma_deallocate(STDMZZ_mtx)
!end Exch statement
      end if

      call mma_deallocate(TDMZZ_new)
      call mma_deallocate(TDMZZ_mtx)
! end LABB statement
      end if


!case where MON A was calculated first
      if (.not. LABB) then
        call mma_allocate(TDMZZ_mtx,nbas_tot(1),nbas_tot(1))
        call mma_allocate(TDMZZ_new,nbas_tot(1)*nbas_tot(1))
        TDMZZ_mtx(:,:) = Zero
        TDMZZ_new(:) = Zero
! fill matrix with the TDM in common basis (column-major order)
        run = 0
        do i=1,nbas_A(1)
          do j=1,nbas_A(1)
            run = run + 1
            TDMZZ_mtx(j,i) = TDMZZ(run)
          end do
        end do
! fill TDM back as array
        run=0
        do i=1,nbas_tot(1)
          do j=1,nbas_tot(1)
            run = run + 1
            TDMZZ_new(run) = TDMZZ_mtx(j,i)
          end do
        end do

! fill DLT in packed lower triangular storage
        do i=1,nbas_tot(1)
          do j=1,i-1
            DLT(1)%A00(max(i,j)*(max(i,j)-3)/2 + i + j) =
     & TDMZZ_new(nbas_tot(1)*(j-1)+i) + TDMZZ_new(nbas_tot(1)*(i-1)+j)
          end do
          DLT(1)%A00(j*(j-3)/2 + 2*j) = TDMZZ_new(nbas_tot(1)*(j-1)+j)
        end do

        if (debug_rassi_code) then
          write(u6,*) 'TDMZZ vector:'
          a = nbas_A(1)*nbas_A(1)
          do i=1,a
            write(u6,*) TDMZZ(i)
          end do
          write(u6,*) 'TDMZZ:'
          a = int(sqrt(dble(nTDMZZ)))
          do i=1,a
            write(u6,'(100ES18.8)') (TDMZZ(i+(j-1)*a),j=1,a)
          end do

          write(u6,*) 'TDMZZ_new vector:'
          a = nbas_tot(1)*nbas_tot(1)
          do i=1,a
            write(u6,*) TDMZZ_new(i)
          end do

          write(u6,*) 'TDMZZ_new:'
          a = nbas_tot(1)
          do i=1,a
            write(u6,'(1000ES18.8)') (TDMZZ_new(i+(j-1)*a),j=1,a)
          end do

          write(u6,*) 'TDMZZ_mtx:'
          do i=1,a
            write(u6,'(1000ES18.8)') (TDMZZ_mtx(i,j),j=1,a)
          end do

          write(u6,*) 'DLT:'
          write(u6,*) DLT(1)%A00(:)
        end if

! spin part
        if (DoExch) then
          call mma_allocate(STDMZZ_mtx,nbas_tot(1),nbas_tot(1))
          call mma_allocate(STDMZZ_new,nbas_tot(1)*nbas_tot(1))
          STDMZZ_mtx(:,:) = Zero
          STDMZZ_new(:) = Zero
          run = 0
          do i=1,nbas_A(1)
            do j=1,nbas_A(1)
              run= run + 1
              STDMZZ_mtx(i,j) = TSDMZZ(run)
            end do
          end do
! fill back as array
          run = 0
          do i=1,nbas_tot(1)
            do j=1,nbas_tot(1)
              run = run + 1
              STDMZZ_new(run) = STDMZZ_mtx(i,j)
            end do
          end do
! fill SDLT (spin density difference)
          if (MLTPLT(1) > 1) then
            run=0
            do i=1,nbas_tot(1)
              do j=1,nbas_tot(1)
                run = run + 1
                SDLT(1)%SB(1)%A1(run) = STDMZZ_mtx(i,j)
              end do
            end do
          end if

! fillSalpha from matrix, since here the row major data type
          run = 0
          do i=1,nbas_tot(1)
            do j=1,nbas_tot(1)
              run = run + 1
              Salpha(1)%SB(1)%A1(run) = TDMZZ_mtx(i,j)
            end do
          end do

          if (MLTPLT(1) > 1) then
! Salpha(1) = TM = GAA+GBB
! Salpha(1) becomes TM + SDLT = GAA+GBB+GAA-GBB=2GAA
            run = 0
            do i=1,nbas_tot(1)
              do j=1,nbas_tot(1)
                run = run + 1
                Salpha(1)%SB(1)%A1(run) =
     &            Salpha(1)%SB(1)%A1(run)+SDLT(1)%SB(1)%A1(run)
              end do
            end do
! Salpha(1) becomes GAA
            integ = int(nbas_tot(1)*nbas_tot(1), kind=iwp)
            call dscal_(integ, Half, Salpha(1)%A00(1), 1)
!Sbeta(1) becomes GBB
            run = 0
            do i=1,nbas_tot(1)
              do j=1,nbas_tot(1)
                run = run + 1
                Sbeta(1)%SB(1)%A1(run) = TDMZZ_new(run)-
     &                                   Salpha(1)%SB(1)%A1(run)
              end do
            end do
          end if
!      call daxpy_(integ,1.0D0,SDLT%A00(1),
!     & 1,Salpha%A00(1),1)
          call mma_deallocate(STDMZZ_new)
          call mma_deallocate(STDMZZ_mtx)
!end EXCH
        end if

        call mma_deallocate(TDMZZ_new)
        call mma_deallocate(TDMZZ_mtx)
!end filling MON A
      end if
      ipNB=ISTATE*(ISTATE-1)/2+JSTATE

! calculate rho-nuc interaction (TDM with core potential)
      eNucB(ipNB) = ddot_(NNLTD,DLT(1)%A0,1,VNucB(1),1)

! change the RunFile to the one
! from bsse calculation to get the cholesky vectors
      call NameRun('AUXRFIL1')
      call CHO_X_INIT(irc,ChFracMem)
      call CHO_TRDENS(irc,DLT,Salpha(1),istate,jstate,
     &                iTyp,DoExch,LABB)
      call NameRun('#Pop')    ! switch back to old RUNFILE
      call deallocate_DT(DLT(1))
      if (DOEXCH) then
        if(MLTPLT(1) == 1) then
          call deallocate_DT(Salpha(1))
        else
          call deallocate_DT(Salpha(1))
          call deallocate_DT(Sbeta(1))
          call deallocate_DT(SDLT(1))
        end if
      end if

      end subroutine exctdm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine Anasize_Localisation(Den,CMO,XMO,nShell,nOrb,iSym)
C
C     Author: T.B. Pedersen
C
C     Purpose: sparsity analysis of shell-based matrices.
C
      Implicit Real*8 (a-h,o-z)
      Real*8 Den(nShell,nShell), CMO(nShell,nOrb), XMO(nShell,nOrb)
#include "WrkSpc.fh"

      Character*17 XHead
      Character*20 CHead
      Character*36 DHead

C     Return if nothing to do.
C     ------------------------

      If (nShell .lt. 0) Return

C     Set up bins.
C     ------------

      lBin = 9
      Call GetMem('Bin','Allo','Real',ipBin,lBin)
      StpSiz = 1.0d-1
      Work(ipBin) = 1.0d0
      ip0 = ipBin - 1
      Do iBin = 2,lBin
         Work(ip0+iBin) = Work(ip0+iBin-1)*StpSiz
      End Do

C     Density.
C     --------

      lDLT = nShell*(nShell+1)/2
      Call GetMem('LTDen','Allo','Real',ipDLT,lDLT)
      Call Sq2Tri(Den,Work(ipDLT),nShell)
      Write(DHead,'(A34,I2)') 'Histogram of density matrix , sym.',iSym
      Call Cho_Head(DHead,'=',80,6)
      Call Cho_Anasize(Work(ipDLT),lDlt,Work(ipBin),lBin,6)
      Call GetMem('LTDen','Free','Real',ipDLT,lDLT)

      If (nOrb .lt. 1) Go To 1 ! return after de-allocation

C     Original MOs.
C     -------------

      Write(CHead,'(A18,I2)') 'Original MOs, sym.',iSym
      Call Cho_Head(CHead,'=',80,6)
      Do i = 1,nOrb
         Write(6,'(/,2X,A,I5)') 'Original MO no.',i
         Call Cho_Anasize(CMO(1,i),nShell,Work(ipBin),lBin,6)
      End Do

C     Local MOs.
C     ----------

      Write(XHead,'(A15,I2)') 'Local MOs, sym.',iSym
      Call Cho_Head(XHead,'=',80,6)
      Do i = 1,nOrb
         Write(6,'(/,2X,A,I5)') 'Local MO no.',i
         Call Cho_Anasize(XMO(1,i),nShell,Work(ipBin),lBin,6)
      End Do

C     De-allocate and return.
C     -----------------------

    1 Call GetMem('Bin','Free','Real',ipBin,lBin)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               1993, Per-Olof Widmark                                 *
!***********************************************************************

subroutine ClsMCK(rc,option)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Close the one-electron integral file.                            *
!                                                                      *
!     input:                                                           *
!     option : Switch to set options                                   *
!              (not used at present)                                   *
!                                                                      *
!     output:                                                          *
!     rc     : Return code.                                            *
!              A value of 0 (zero) is returned upon successful         *
!              completion of the request. A nonzero value indicates    *
!              an error.                                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher and P.O. Widmark                                 *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use MckDat, only: AuxMck, pBas, pEnd, pFID, pNext, pOp, pSym, pSymOp, pTitle, pVersN, rcMck, sDmp, TocMck
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp), intent(in) :: option
integer(kind=iwp) :: LuMCK

!----------------------------------------------------------------------*
! Check file status                                                    *
!----------------------------------------------------------------------*
if (.not. AuxMck%Opn) then
  rc = rcMck%CL01
  call SysAbendMsg('ClsMCK','The MCK file has not been opened',' ')
end if
if (btest(Option,sDmp)) then
  write(u6,'(i6,z8)') pFID,TocMck(pFID)
  write(u6,'(i6,z8)') pVersN,TocMck(pVersN)
  write(u6,'(i6,z8)') pTitle,TocMck(pTitle)
  write(u6,'(i6,z8)') pOp,TocMck(pOp)
  write(u6,'(i6,z8)') pSym,TocMck(pSym)
  write(u6,'(i6,z8)') pSymOp,TocMck(pSymOp)
  write(u6,'(i6,z8)') pBas,TocMck(pBas)
  write(u6,'(i6,z8)') pNext,TocMck(pNext)
  write(u6,'(i6,z8)') pEnd,TocMck(pEnd)
end if
!----------------------------------------------------------------------*
! Reset error code,open flag and unit number. Close file.              *
!----------------------------------------------------------------------*
LuMCK = AuxMck%Lu
call DaClos(LuMCK)
AuxMck%Lu = 0
AuxMck%Opn = .false.
rc = rcMck%good

!----------------------------------------------------------------------*
! Terminate procedure                                                  *
!----------------------------------------------------------------------*
return

end subroutine ClsMCK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine writes a record into the runfile.                       *
! Data type is Integer.                                                *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund university, Sweden                                     *
! Written: August 2003                                                 *
!                                                                      *
!***********************************************************************

subroutine ixWrRun(iRc,Label,iData,nData,iOpt)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use RunFile_data, only: TypInt
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: iRc
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: iData(*), nData, iOpt
character(len=64) :: Errmsg

call ixWrRun_Internal(iData)

! This is to allow type punning without an explicit interface
contains

subroutine ixWrRun_Internal(iData)

  integer(kind=iwp), target, intent(in) :: iData(*)
  character, pointer :: cData(:)

  !--------------------------------------------------------------------*
  ! Check that arguments are ok.                                       *
  !--------------------------------------------------------------------*
  if (iOpt /= 0) then
    write(ErrMsg,*) 'Illegal option flag:',iOpt
    call SysAbendMsg('ixWrRun',ErrMsg,' ')
  end if
  iRc = 0
  !--------------------------------------------------------------------*
  ! Call generic writing routine.                                      *
  !--------------------------------------------------------------------*
  call c_f_pointer(c_loc(iData(1)),cData,[1])
  call gxWrRun(iRc,Label,cData,nData,iOpt,TypInt)
  nullify(cData)
  !--------------------------------------------------------------------*
  !                                                                    *
  !--------------------------------------------------------------------*
  return

end subroutine ixWrRun_Internal

end subroutine ixWrRun

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Francesco Aquilante                              *
************************************************************************
      SUBROUTINE Delete_Ghosts(irc,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &                         NAME,nUniqAt,ThrS,isCASPT2,CMO,EOrb)
************************************************************************
*                                                                      *
* Purpose:  Eliminates MOs of ghost atoms from PT2 treatment           *
*                                                                      *
* Author:   F. Aquilante  (Geneva, July 2010)                          *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
*
      Integer nBas(nSym),nFro(nSym),nIsh(nSym),nAsh(nSym),nSsh(nSym),
     &        nDel(nSym)
      Integer irc,nUniqAt
      Real*8  ThrS, CMO(*), EOrb(*)
      Logical isCASPT2
      Character*(LENIN8) NAME(*)
      Character*(LENIN) blank, NamAct(mxAtom), tmp
      Integer n_OK(8)
************************************************************************
      jD(i) = iWork(ip_iD-1+i)
************************************************************************
*
*
      irc=0
      blank='   '
*
*----------------------------------------------------------------------*
*     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
*----------------------------------------------------------------------*
*
      nBasT=0
      ntri=0
      nSQ=0
      nBmx=0
      nSmx=0
      mAsh=0
      Do i=1,nSym
        nBasT=nBasT+nBas(i)
        ntri=ntri+nBas(i)*(nBas(i)+1)/2
        nSQ=nSQ+nBas(i)**2
        nBmx=Max(nBmx,nBas(i))
        nSmx=Max(nSmx,nSsh(i))
        mAsh=Max(mAsh,nIsh(i)+nAsh(i))
      End Do
      NCMO=nSQ
      IF(nBasT.GT.mxBas) then
       Write(6,'(/6X,A)')
     & 'The number of basis functions exceeds the present limit'
       Call Abend
      Endif
*
*     nUniqAt = # of symm. unique atoms. Initialize NamAct to blanks.
*     ---------------------------------------------------------------

      If (nUniqAt.lt.1 .or. nUniqAt.gt.MxAtom) Then
         Write(6,'(A,I9)') 'nUniqAt =',nUniqAt
         Call Abend()
      End If
      Do iAt=1,nUniqAt
         NamAct(iAt)=blank
      End Do

C     Allocate and get index arrays for basis functions per atom.
C     -----------------------------------------------------------

      l_nBas_per_Atom = nUniqAt
      l_nBas_Start    = nUniqAt
      Call GetMem('nB_per_Atom','Allo','Inte',
     &            ip_nBas_per_Atom,l_nBas_per_Atom)
      Call GetMem('nB_Start','Allo','Inte',
     &            ip_nBas_Start,l_nBas_Start)
*
*----------------------------------------------------------------------*
*     Read the overlap matrix                                          *
*----------------------------------------------------------------------*
      CALL GetMem('SMAT','ALLO','REAL',ipSQ,nSQ)
      CALL GetMem('SLT','ALLO','REAL',ipS,nTri)
      isymlbl=1
      Call RdOne(irc,6,'Mltpl  0',1,Work(ipS),isymlbl)
      If(irc.ne.0) return
      ltri=0
      lsq=0
      Do iSym=1,nSym
         Call Square(Work(ipS+ltri),Work(ipSQ+lsq),1,nBas(iSym),
     &                                               nBas(iSym))
         ltri=ltri+nBas(iSym)*(nBas(iSym)+1)/2
         lsq=lsq+nBas(iSym)**2
      End Do
      CALL GetMem('SLT','FREE','REAL',ipS,nTri)
*
      CALL GETMEM('LCMO','ALLO','REAL',LCMO,NCMO)
      call dcopy_(NCMO,CMO,1,WORK(LCMO),1)

*----------------------------------------------------------------------*
*     Compute Mulliken atomic charges of each occupied orbital         *
*             on each center to define the Active Site                 *
*----------------------------------------------------------------------*
      Call GetMem('Qai','Allo','Real',ipQ,nUniqAt*(mAsh+1))
      ipQa=ipQ+nUniqAt*mAsh
      Call Fzero(Work(ipQa),nUniqAt)
      Call GetMem('Zm','Allo','Real',ipZ,nBmx*mAsh)
      lBas=0
      iOff=0
      Do iSym=1,nSym
         nOkk=nIsh(iSym)+nAsh(iSym)
         iSQ=ipSQ+iOff
         ipAsh=LCMO+iOff+nBas(iSym)*nFro(iSym)
         nBx=Max(1,nBas(iSym))
         Call DGEMM_('N','N',nBas(iSym),nOkk,nBas(iSym),
     &                      1.0d0,Work(iSQ),nBx,
     &                            Work(ipAsh),nBx,
     &                      0.0d0,Work(ipZ),nBx)
         jBas=lBas+1
         kBas=lBas+nBas(iSym)
         Call BasFun_Atom_(iWork(ip_nBas_per_Atom),iWork(ip_nBas_Start),
     &                     Name,jBas,kBas,nUniqAt,.false.)
         Do ik=0,nOkk-1
            nAk=nUniqAt*ik
            nBk=nBas(iSym)*ik
            jCMO=ipAsh+nBk-1
            jZ=ipZ+nBk-1
            Do iAt=0,nUniqAt-1
               iBat=iWork(ip_nBas_Start+iAt)
               jjCMO=jCMO+iBat
               jjZ=jZ+iBat
               nBat=iWork(ip_nBas_per_Atom+iAt)
               iQQ=ipQ+nAk+iAt
               Work(iQQ)=ddot_(nBat,Work(jjCMO),1,Work(jjZ),1)
            End Do
         End Do
         Do iAt=0,nUniqAt-1
            jQ=ipQ+iAt
            iQa=ipQa+iAt
            Work(iQa) = Work(iQa)
     &                + ddot_(nOkk,Work(jQ),nUniqAt,
     &                            Work(jQ),nUniqAt)
            If (sqrt(Work(iQa)).ge.ThrS) Then
               jBat=iWork(ip_nBas_Start+iAt)+lBas
               If (iWork(ip_nBas_per_Atom+iAt) .gt. 0)
     &            NamAct(iAt+1)=Name(jBat)(1:LENIN)
            EndIf
         End Do
         lBas=lBas+nBas(iSym)
         iOff=iOff+nBas(iSym)**2
      End Do
      Call GetMem('Zm','Free','Real',ipZ,nBmx*mAsh)
      Call GetMem('Qai','Free','Real',ipQ,nUniqAt*(mAsh+1))

*     We have now completed the definition of the active site
*----------------------------------------------------------------------*
      Call GetMem('ID_A','Allo','Inte',iD,nUniqAt)
      nActa=0
      Do iAt=1,nUniqAt
         If (NamAct(iAt)(1:4).ne.blank) Then
            iWork(iD+nActa)=iAt
            nActa=nActa+1
         EndIf
      End Do
      Do iAt=1,nActa
         jAt=iWork(iD+iAt-1)
         NamAct(iAt)=NamAct(jAt)
      End Do
      Do iAt=nActa+1,nUniqAt
         NamAct(iAt)(1:4)=Trim(blank)
      End Do
      Write(6,*)
      Write(6,'(A,F6.3)') ' Threshold for atom selection: ',ThrS
      Write(6,*)
      If (nActa.ne.0) Then
         Write(6,'(A,I3,A)') ' Selected ',nActa,' atoms: '
         Write(6,*)
         Write(6,*) (NamAct(i),i=1,nActa)
         Write(6,*)
      Else
         Write(6,*)' None of the occupied non-frozen orbitals has been '
         Write(6,*)' assigned to the Active region of the molecule.    '
         Write(6,*)' This is presumably NOT what you want !!!          '
         Write(6,*)' I will Stop here. Bye Bye !! '
         Write(6,*)
         Call Abend
      EndIf

      Call GetMem('ID_A','Free','Inte',iD,nUniqAt)
      Call GetMem('nB_per_Atom','Free','Inte',
     &            ip_nBas_per_Atom,l_nBas_per_Atom)
      Call GetMem('nB_Start','Free','Inte',
     &            ip_nBas_Start,l_nBas_Start)

*----------------------------------------------------------------------*
*     Virtual orbital selection                                        *
*----------------------------------------------------------------------*
      Call GetMem('ID_vir','Allo','Inte',ip_iD,nBmx+2*nSmx)
      nSmall=nBmx**2+nSmx+3*nBmx*nSmx
      Call GetMem('Small','Allo','Real',iS,nSmall)
      iQ=iS+nBmx**2
      iC=iQ+nSmx
      iZ=iC+nBmx*nSmx
      iX=iZ+nBmx*nSmx
*
      iOff=0
      kOff=0
      Do iSym=1,nSym

         nBa=0
         Do ia=1,nBas(iSym)
            ja=ia+iOff
            tmp=Name(ja)(1:LENIN)
            Do j=1,nActa
               If(NamAct(j).eq.tmp) Then
                  iWork(ip_iD+nBa)=ia
                  nBa=nBa+1
               EndIf
            End Do
         End Do

         iCMO=LCMO+kOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
         Do ia=1,nBa
            ifr=iCMO+jD(ia)-1
            ito=iC+ia-1
            call dcopy_(nSsh(iSym),Work(ifr),nBas(iSym),Work(ito),nBa)
         End Do

         iSQ=ipSQ+kOff
         Do ia=1,nBa
            jb=jD(ia)
            jfr=iSQ+nBas(iSym)*(jb-1)
            jto=iS+nBas(iSym)*(ia-1)
            call dcopy_(nBas(iSym),Work(jfr),1,Work(jto),1)
         End Do

         nBx=Max(1,nBas(iSym))
         nBax=Max(1,nBa)
         Call DGEMM_('T','N',nBa,nSsh(iSym),nBas(iSym),
     &                    1.0d0,Work(iS),nBx,
     &                          Work(iCMO),nBx,
     &                    0.0d0,Work(iZ),nBax)
         Do i=0,nSsh(iSym)-1
            jQ=iQ+i
            jC=iC+nBa*i
            jZ=iZ+nBa*i
            Work(jQ)=ddot_(nBa,Work(jC),1,Work(jZ),1)**2
         End Do
         n_OK(iSym)=0
         n_KO=0
         Do i=1,nSsh(iSym)
            jQ=iQ+i-1
            jfr=iCMO+nBas(iSym)*(i-1)
            If (sqrt(Work(jQ)).ge.ThrS) Then
               jX=iX+nBas(iSym)*n_OK(iSym)
               call dcopy_(nBas(iSym),Work(jfr),1,Work(jX),1)
               iWork(ip_iD+nBmx+n_OK(iSym))=i
               n_OK(iSym)=n_OK(iSym)+1
            Else
               jZ=iZ+nBas(iSym)*n_KO
               call dcopy_(nBas(iSym),Work(jfr),1,Work(jZ),1)
               iWork(ip_iD+nBmx+nSmx+n_KO)=i
               n_KO=n_KO+1
            EndIf
         End Do
*
         call dcopy_(nBas(iSym)*n_OK(iSym),Work(iX),1,Work(iCMO),1)
         kCMO=iCMO+nBas(iSym)*n_OK(iSym)
         call dcopy_(nBas(iSym)*n_KO,Work(iZ),1,Work(kCMO),1)
         If (.not.isCASPT2) Then
            jZ=iZ
            jOff=iOff+nFro(iSym)+nOkk
            Do i=nBmx+1,nBmx+n_OK(iSym)
               iv=jD(i)+jOff
               Work(jZ)=EOrb(iv)
               jZ=jZ+1
            End Do
            Do i=nBmx+nSmx+1,nBmx+nSmx+n_KO
               iv=jD(i)+jOff
               Work(jZ)=EOrb(iv)
            End Do
            call dcopy_(nSsh(iSym),Work(iZ),1,EOrb(1+jOff),1)
         EndIf
*
         iOff=iOff+nBas(iSym)
         kOff=kOff+nBas(iSym)**2
      End Do
      Call GetMem('Small','Free','Real',iS,nSmall)
      Call GetMem('ID_vir','Free','Inte',ip_iD,nBmx+2*nSmx)
*                                                                      *
*----------------------------------------------------------------------*
*
*     Update nSsh, nDel for the Active site PT2
      Do iSym=1,nSym
         nDel(iSym)=nDel(iSym)+nSsh(iSym)-n_OK(iSym)
         nSsh(iSym)=n_OK(iSym)
      End Do
*
      call dcopy_(NCMO,WORK(LCMO),1,CMO,1)
*
      CALL GETMEM('LCMO','FREE','REAL',LCMO,NCMO)
      CALL GetMem('SMAT','FREE','REAL',ipSQ,nSQ)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ReExpand(rMP,nij,nElem,A,B,ij,lMax)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "itmax.fh"
#include "binom.fh"
      Real*8 rMP(nij,nElem), A(3), B(3)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      mElem(i)=(i+1)*(i+2)*(i+3)/6
*                                                                      *
************************************************************************
*                                                                      *
*
C     Call RecPrt('A',' ',A,1,3)
C     Call RecPrt('B',' ',B,1,3)
C     Call RecPrt('rMP',' ',rMP,nij,nElem)
      Do l = lMax, 0, -1
         iElem = mElem(l-1)
         Do ix = l, 0, -1
            ABx = A(1)-B(1)
            Do iy = l-ix, 0, -1
               ABy = A(2)-B(2)
               iz = l-ix-iy
               ABz = A(3)-B(3)
               iElem = iElem + 1
C              Write (*,*)
C              Write (*,*)
C              Write (*,*) 'ix,iy,iz=',ix,iy,iz
C              Write (*,*)
*
               temp = Zero
               Do jx = 0, ix
               Do jy = 0, iy
               Do jz = 0, iz
C              Write (*,*) 'jx,jy,jz=',jx,jy,jz
*
                  If (ix-jx.eq.0) then
                   ABx_=One
                  else
                   ABx_=ABx**(ix-jx)
                  endif
                  If (iy-jy.eq.0) then
                   ABy_=One
                  else
                   ABy_=ABy**(iy-jy)
                  endif
                  If (iz-jz.eq.0) then
                   ABz_=One
                  else
                   ABz_=ABz**(iz-jz)
                  endif
                  k=jx+jy+jz
                  jElem = mElem(k-1)+(jy+jz)*(jy+jz+1)/2+jz+1
C                 Write (6,*) 'jElem=',jElem
C                 Write (6,*)   binom(ix,jx),binom(iy,jy),binom(iz,jz),
C    &                   rMP(ij,jElem) ,
C    &                    ABx_ , ABy_ , ABz_
                  temp = temp + binom(ix,jx)*binom(iy,jy)*binom(iz,jz)
     &                  *rMP(ij,jElem)
     &                  * ABx_ * ABy_ * ABz_
*
               End Do
               End Do
               End Do
               rMP(ij,iElem)=temp
*
            End Do
         End Do
      End Do
C     Call RecPrt('rMP',' ',rMP,nij,nElem)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE PRMBLK(     IDC,    ISGV,    IASM,    IBSM,    IATP,
     &                      IBTP,      PS,      PL,    JATP,    JBTP,
     &                      JASM,    JBSM,    ISGN,    ITRP,   NPERM)
*
* A block of CI coefficients defined by by IATP,IASM,IBTP,IBSM is given
*
* Obtain the number of other blocks that can be obtained by spin
* and relection symmetry.
*
* Jeppe Olsen, July 1993
*
* =====
* Output
* =====
* JATP(I),JASM(I),JBTP(I),JBSM(I) Indeces for Block I
* NPERM : Number of blocks  that can be obtained
* ITRP(I) = 1 => block should     be transposed
*         = 0 => block should not be transposed
* ISGN   : Sign to multiply previous block with to getnew sign
*
*
* There are four types of permutations
*
*    operation   *      JASM  *      JBSM  * JATP * JBTP * Iperm * Sign *
*   *********************************************************************
*   * Identity   *      IASM  *      IBSM  * IATP * IBTP *   0   * 1    *
*   * Ml         * ISGV(IASM) * ISGV(IBSM) * IATP * IBTP *   0   * PL   *
*   * Ms         *      IBSM  *      IASM  * IBTP * IATP *   1   * PS   *
*   * Ms+Ml      * ISGV(IBSM) * ISGV(IASM) * IBTP * IATP *   1   * PS PL*
*   *********************************************************************
*
      IMPLICIT REAL*8 (A-H,O-Z)
*.Input
      DIMENSION ISGV(*)
*.Output
      DIMENSION JATP(4),JBTP(4),JASM(4),JBSM(4),ISGN(4),ITRP(4)
*
*. To eliminate some compiler warnings
      KASM = 0
      KBSM = 0
      KATP = 0
      KBTP = 0
      KSIGN = 0
      KTRP = 0
      LSIGN = 0
      LTRP = 0
*
      NPERM = 0
      DO 100 IPERM = 1, 4
        ISET = 0
        IF(IPERM.EQ.1) THEN
*
* Identity operation
*
          KASM = IASM
          KBSM = IBSM
          KATP = IATP
          KBTP = IBTP
          KSIGN = 1
          KTRP = 0
          ISET = 1
        ELSE IF(IPERM.EQ.2.AND.(IDC.EQ.3.OR.IDC.EQ.4)) THEN
*
* Ml reflection
*
          KASM = ISGV(IASM)
          KBSM = ISGV(IBSM)
          KATP = IATP
          KBTP = IBTP
          IF(PL.EQ.1.0D0) THEN
            KSIGN = 1
          ELSE IF (PL .EQ. -1.0D0) THEN
            KSIGN = -1
          END IF
          KTRP = 0
          ISET = 1
        ELSE IF(IPERM.EQ.3.AND.(IDC.EQ.2.OR.IDC.EQ.4)) THEN
*
* Ms reflection
*
          KASM = IBSM
          KBSM = IASM
          KATP = IBTP
          KBTP = IATP
          IF(PS.EQ.1.0D0) THEN
            KSIGN = 1
          ELSE IF (PS .EQ. -1.0D0) THEN
            KSIGN = -1
          END IF
          KTRP = 1
          ISET = 1
        ELSE IF(IPERM.EQ.4 .AND. IDC.EQ.4) THEN
*
* Ms Ml  reflection
*
          KASM = ISGV(IBSM)
          KBSM = ISGV(IASM)
          KATP = IBTP
          KBTP = IATP
          IF(PS*PL.EQ.1.0D0) THEN
            KSIGN = 1
          ELSE IF (PS .EQ. -1.0D0) THEN
            KSIGN = -1
          END IF
          KTRP = 1
          ISET = 1
        END IF
*
        IF(ISET.EQ.1) THEN
*. A new permutation was found, check and see if it was obtained previously
          INEW = 1
          DO 50 LPERM = 1, NPERM
            IF(JATP(LPERM).EQ.KATP  .AND. JASM(LPERM).EQ.KASM .AND.
     &         JBTP(LPERM).EQ.KBTP  .AND. JBSM(LPERM).EQ.KBSM) INEW = 0
   50     CONTINUE
          IF(INEW.EQ.1) THEN
*. The permutation was new, add it to the list
            NPERM = NPERM + 1
            JASM(NPERM) = KASM
            JBSM(NPERM) = KBSM
            JATP(NPERM) = KATP
            JBTP(NPERM) = KBTP
            IF(NPERM.EQ.1. OR. (NPERM.GE.1.AND.KSIGN.EQ.LSIGN))THEN
              ISGN(NPERM) = 1
            ELSE
              ISGN(NPERM) = -1
            END IF
            LSIGN = KSIGN
            IF(NPERM.EQ.1. OR. (NPERM.GE.1.AND.KTRP.EQ.LTRP))THEN
              ITRP(NPERM) = 0
            ELSE
              ITRP(NPERM) = 1
            END IF
            LTRP = KTRP
          END IF
        END IF
  100 CONTINUE
*
*. Should the block be trnasposed or scaled to return to initial form
      ITRP(NPERM+1) = LTRP
      ISGN(NPERM+1) = LSIGN
      IFNSGN = LSIGN
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,'(A,4I4)') ' Blocks obtained from IASM IBSM IATP IBTP ',
     &  IASM,IBSM,IATP,IBTP
        WRITE(6,*)
        WRITE(6,'(A)') ' JASM JBSM JATP JBTP Isgn Itrp  '
        WRITE(6,*)
        DO 10 IPERM = 1, NPERM
          WRITE(6,'(2x,6I4)') JASM(IPERM),JBSM(IPERM),JATP(IPERM),
     &                        JBTP(IPERM),ISGN(IPERM),ITRP(IPERM)
   10   CONTINUE
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function NAlPar(MxBond,IAt,IAn,NBond,IBond,Chg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: NAlPar
integer(kind=iwp), intent(in) :: MxBond, IAt, IAn(*), NBond(*), IBond(MxBond,*)
real(kind=wp), intent(in) :: Chg(*)
integer(kind=iwp) :: ianj, iank, JAt, jj, KAt, kk, NArI, nbj, nbk, NCSP2J, NHetJ
real(kind=wp) :: chgk

NAlPar = -1
NArI = 0
do jj=1,3
  NCSP2J = 0
  NHetJ = 0
  JAt = IBond(jj,IAt)
  ianj = ian(JAt)
  nbj = nbond(JAt)
  if ((ianj == 7) .and. (nbj >= 3)) NCSP2J = 2
  if ((ianj == 6) .and. (nbj == 3)) then
    do kk=1,3
      KAt = IBond(kk,JAt)
      iank = ian(KAt)
      nbk = nbond(KAt)
      chgk = chg(KAt)
      if (chgk < 0.4_wp) then
        if ((iank == 6) .and. (nbk == 3)) NCSP2J = NCSP2J+1
        if ((iank == 8) .or. (iank == 9)) NHetJ = NHetJ+1
        if ((iank == 17) .or. (iank == 35) .or. (iank == 53)) NHetJ = NHetJ+1
        if (iank == 7) then
          if (nbk <= 2) NHetJ = NHetJ+1
          if (nbk >= 3) NCSP2J = NCSP2J+1
        end if
      end if
    end do
  end if
  if ((NCSP2J >= 2) .and. (NHetJ == 0)) NarI = NArI+1
end do
if (NArI >= 2) NAlPar = 1

return

end function NAlPar

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

subroutine GSBBD2B_MCLR(RHO2,IASM,IATP,IBSM,IBTP,NIA,NIB,JASM,JATP,JBSM,JBTP,NJA,NJB,IAGRP,IBGRP,NGAS,IAOC,IBOC,JAOC,JBOC,SB,CB, &
                        NOBPTS,IOBPTS,MAXK,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,X,NSM,IUSEAB,CJRES,SIRES,NORB,ieaw)
! alpha-beta contribution to two-particle density matrix
! from given c-block and s-block.
!
! =====
! Input
! =====
! IASM,IATP : Symmetry and type of alpha  strings in sigma
! IBSM,IBTP : Symmetry and type of beta   strings in sigma
! JASM,JATP : Symmetry and type of alpha  strings in C
! JBSM,JBTP : Symmetry and type of beta   strings in C
! NIA,NIB   : Number of alpha-(beta-) strings in sigma
! NJA,NJB   : Number of alpha-(beta-) strings in C
! IAGRP     : String group of alpha strings
! IBGRP     : String group of beta strings
! IAEL1(3)  : Number of electrons in RAS1(3) for alpha strings in sigma
! IBEL1(3)  : Number of electrons in RAS1(3) for beta  strings in sigma
! JAEL1(3)  : Number of electrons in RAS1(3) for alpha strings in C
! JBEL1(3)  : Number of electrons in RAS1(3) for beta  strings in C
! CB        : Input C block
! NTSOB     : Number of orbitals per type and symmetry
! IBTSOB    : base for orbitals of given type and symmetry
! IBORB     : Orbitals of given type and symmetry
! NSM       : Number of symmetries of orbitals
! MAXK      : Largest number of inner resolution strings treated at simult.
!
! ======
! Output
! ======
! SB : updated sigma block
!
! =======
! Scratch
! =======
! I1, XI1S : at least MXSTSO : Largest number of strings of given
!            type and symmetry
! I2, XI2S : at least MXSTSO : Largest number of strings of given
!            type and symmetry
! X        : Space for block of two-electron integrals
!
! Jeppe Olsen, Fall of 1996

use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: RHO2(*)
integer(kind=iwp), intent(in) :: IASM, IATP, IBSM, IBTP, NIA, NIB, JASM, JATP, JBSM, JBTP, NJA, NJB, IAGRP, IBGRP, IAOC(*), &
                                 IBOC(*), JAOC(*), JBOC(*), NOBPTS(3,*), IOBPTS(3,*), MAXK, NSM, IUSEAB, NORB, ieaw
integer(kind=iwp), intent(out) :: NGAS
real(kind=wp), intent(in) :: SB(*), CB(*)
real(kind=wp), intent(_OUT_) :: XI1S(*), XI2S(*), XI3S(*), XI4S(*), X(*), CJRES(*), SIRES(*)
integer(kind=iwp), intent(_OUT_) :: I1(*), I2(*), I3(*), I4(*)
integer(kind=iwp) :: IDOCOMP, II, IJSM, IJTYP, IKABTC, IKORD, IOFF, ISM, ITP(3), ITYP, itype, JJ, JOFF, JSM, JTP(3), JTYP, KABOT, &
                     KAEND, KATOP, KBBOT, KBEND, KBTOP, KLSM, KLTYP, KOFF, KSM, KTP(3), KTYP, LKABTC, LOFF, LSM, LTP(3), LTYP, NI, &
                     NIJTYP, NJ, NK, NKABTC, NKAEFF, NKASTR, NKBSTR, NKLTYP, NL

NGAS = 3

! Symmetry of allowed excitations
IJSM = Mul(IASM,JASM)
KLSM = Mul(IBSM,JBSM)
itype = 2
if (ieaw == 1) itype = 3
if ((IJSM == 0) .or. (KLSM == 0)) return
! Types of SX that connects the two strings
call SXTYP_GAS(NKLTYP,KTP,LTP,NGAS,IBOC,JBOC)
call SXTYP_GAS(NIJTYP,ITP,JTP,NGAS,IAOC,JAOC)
if ((NIJTYP == 0) .or. (NKLTYP == 0)) return
do IJTYP=1,NIJTYP
  ITYP = ITP(IJTYP)
  JTYP = JTP(IJTYP)
  do ISM=1,NSM
    JSM = Mul(ISM,IJSM)
    if (JSM == 0) cycle
    IOFF = IOBPTS(ITYP,ISM)
    JOFF = IOBPTS(JTYP,JSM)
    NI = NOBPTS(ITYP,ISM)
    NJ = NOBPTS(JTYP,JSM)
    if ((NI == 0) .or. (NJ == 0)) cycle
    !EAW
    ! Find Ka strings that connect with Ja strings for given group of Jorbs
    KABOT = 1
    ! Obtain all strings
    KATOP = -1
    call ADST(JOFF,NJ,JATP,JASM,IAGRP,KABOT,KATOP,I1,XI1S,MAXK,NKASTR,KAEND)
    call ADST(IOFF,NI,IATP,IASM,IAGRP,KABOT,KATOP,I3,XI3S,MAXK,NKASTR,KAEND)
    IDOCOMP = 1
    if (IDOCOMP == 1) then
      call COMPRS2LST(I1,XI1S,NJ,I3,XI3S,NI,NKASTR,NKAEFF)
    else
      NKAEFF = NKASTR
    end if

    ! Loop over batches of KA strings
    NKABTC = NKAEFF/MAXK
    if (NKABTC*MAXK < NKAEFF) NKABTC = NKABTC+1
    do IKABTC=1,NKABTC
      KABOT = (IKABTC-1)*MAXK+1
      KATOP = min(KABOT+MAXK-1,NKAEFF)
      LKABTC = KATOP-KABOT+1
      ! Obtain C(ka,J,JB) for Ka in batch
      do JJ=1,NJ
        call GET_CKAJJB(CB,NJ,NJA,CJRES,LKABTC,NJB,JJ,I1(KABOT+(JJ-1)*NKASTR),XI1S(KABOT+(JJ-1)*NKASTR))
      end do
      ! Obtain S(ka,i,Ib) for Ka in batch
      do II=1,NI
        call GET_CKAJJB(SB,NI,NIA,SIRES,LKABTC,NIB,II,I3(KABOT+(II-1)*NKASTR),XI3S(KABOT+(II-1)*NKASTR))
      end do

      do KLTYP=1,NKLTYP
        KTYP = KTP(KLTYP)
        LTYP = LTP(KLTYP)

        do KSM=1,NSM
          LSM = Mul(KSM,KLSM)
          if (LSM == 0) cycle
          KOFF = IOBPTS(KTYP,KSM)
          LOFF = IOBPTS(LTYP,LSM)
          NK = NOBPTS(KTYP,KSM)
          NL = NOBPTS(LTYP,LSM)
          ! If IUSEAB is used, only terms with i >= k will be generated so
          IKORD = 0
          if ((IUSEAB == 1) .and. (ISM > KSM)) cycle
          if ((IUSEAB == 1) .and. (ISM == KSM) .and. (ITYP < KTYP)) cycle
          if ((IUSEAB == 1) .and. (ISM == KSM) .and. (ITYP == KTYP)) IKORD = 1

          if ((NK == 0) .or. (NL == 0)) cycle
          !EAW
          ! Obtain all connections a+l!Kb> = +/-/0!Jb>
          ! NKBSTR must be given as input
          ! obtain cb(KA,KB,jl) =  sum(JA,JB)<KA!a la!JA><KB!a jb !JB>C(JA,JB)

          KBBOT = 1
          ! Obtain all strings
          KBTOP = -1
          call ADST(LOFF,NL,JBTP,JBSM,IBGRP,KBBOT,KBTOP,I2,XI2S,MAXK,NKBSTR,KBEND)
          call ADST(KOFF,NK,IBTP,IBSM,IBGRP,KBBOT,KBTOP,I4,XI4S,MAXK,NKBSTR,KBEND)

          !if (NKBSTR == 0) cycle
          X(1:NI*NJ*NK*NL) = Zero

          call ABTOR2(SIRES,CJRES,LKABTC,NKBSTR,X,NI,NJ,NK,NL,NKBSTR,I4,XI4S,I2,XI2S,IKORD)
          ! contributions to Rho2(ij,kl) has been obtained, scatter out
          call ADTOR2_MCLR(RHO2,X,itype,NI,IOFF,NJ,JOFF,NK,KOFF,NL,LOFF,NORB)

        end do
      end do
    end do
    ! End of loop over partitioning of alpha strings
  end do
end do

end subroutine GSBBD2B_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine change2_cvb()
      implicit real*8 (a-h,o-z)
      logical changed
c ... Change of dimensioning variables ...
      logical, external :: chpcmp_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "rls_cvb.fh"

      changed=.false.
c  VB wavefunction
c  (MXNVB should be upper bound on KBASIS & KBASISCVB ) :
      nvb_alloc=max(nvb_cvb(kbasiscvb),nvb_cvb(kbasis),mxnvb)
      if(chpcmp_cvb(norb))changed=.true.
      if(chpcmp_cvb(nvb_alloc))changed=.true.
      if(changed)call touch_cvb('MEM2')
      return

      entry chop2_cvb()
      if(release(2))call mfreer_cvb(lv(1))
      release(2)=.true.
      release(3)=.false.

c  Note zeroing of ORBS and CVB :
      lv(1) = mstackrz_cvb(norb*norb)
c  (MXNVB should be upper bound on KBASIS & KBASISCVB ) :
      nvb_alloc=max(nvb_cvb(kbasiscvb),nvb_cvb(kbasis),mxnvb)
      lv(2)= mstackrz_cvb(nvb_alloc)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DEPSAOffO(nOLag,nAshT,NBSQT,OLag,DEPSA,FIFA)

use caspt2_module, only: NASH, NBAS, NDEL, NFRO, NISH, NSYM
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOLag, nAshT, NBSQT
real(kind=wp), intent(in) :: OLag(nOLag), FIFA(NBSQT)
real(kind=wp), intent(inout) :: DEPSA(nAshT,nAshT)
integer(kind=iwp) :: iAsh, iMO, iOrb, iSym, jAsh, jOrb, nAshI, nBasI, nFroI, nIshI, nOrbI
real(kind=wp) :: EigI, EigJ, OLagIJ, OLagJI, Tmp

! This is much easier; similar to the frozen core approximation.
! Corresponds to the first term in Eq. (70)

iMO = 1
do iSym=1,nSym
  nAshI = nAsh(iSym)
  nOrbI = 0
  if (nAshI /= 0) then
    nOrbI = nBas(iSym)-nDel(iSym)
    nFroI = nFro(iSym)
    nIshI = nIsh(iSym)
    nBasI = nBas(iSym)

    do iAsh=1,nAshI
      iOrb = iAsh+nFroI+nIshI
      EigI = FIFA(iMO+iOrb-1+nBasI*(iOrb-1))
      do jAsh=1,iAsh-1
        jOrb = jAsh+nFroI+nIshI
        EigJ = FIFA(iMO+jOrb-1+nBasI*(jOrb-1))
        OLagIJ = OLag(iMO+iOrb-1+nOrbI*(jOrb-1))
        OLagJI = OLag(iMO+jOrb-1+nOrbI*(iOrb-1))
        Tmp = -(OLagIJ-OLagJI)/(EigI-EigJ)*Half

        DEPSA(iAsh,jAsh) = DEPSA(iAsh,jAsh)+Tmp
        DEPSA(jAsh,iAsh) = DEPSA(jAsh,iAsh)+Tmp
      end do
    end do
  end if
  iMO = iMO+nOrbI*nOrbI
end do

end subroutine DEPSAOffO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Roland Lindh                                     *
!***********************************************************************
      Module RASSI_GLOBAL_ARRAYS
      Real*8, Allocatable:: HAM(:,:), SFDYS(:,:,:), &
                            SODYSAMPS(:,:), SODYSAMPSR(:,:), &
                            SODYSAMPSI(:,:), EIGVEC(:,:), &
                            PROP(:,:,:), ESHFT(:), HDIAG(:)
      Integer, Allocatable:: JBNUM(:), LROOT(:)
      End Module RASSI_GLOBAL_ARRAYS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_DiaSh(ip_DiaSh)
C
C     Purpose: allocate double precision array DiaSh(nnShl_G)
C
C     (placed in separate routine as global data is accessed)
C
      Implicit None
      Integer ip_DiaSh
#include "choglob.fh"

      Integer l_DiaSh

      l_DiaSh = nnShl_G
      Call GetMem('DiaSh','Allo','Real',ip_DiaSh,l_DiaSh)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module CCT3_global

! Common variables of whole T3 program
!
!1    max. number of orbitals (basis functions)
!     - maxorb
!
!2    characteristics from MOLCAS
!
!2.1  Number of active electrons
!     - nactel (*)
!2.2  spin state of the system
!     - ispin
!2.3  number of irreps in the system
!     - nsym
!2.4  symmetry state of the system
!     - lsym
!2.5  matrix multiplication table
!     - mmul
!2.6  vectors containing size of the system
!     - noa,nob,nva,nvb,norb
!2.7  orbital energies
!     - eps
!
!3    internal CCSD characteristics
!
!3.1  size characteristic Table
!     - dimm
!3.2  shift vector
!     - nshf
!
!4    input parameters (read from input file)
!
!4.1  title of the job + number ot tilte lines
!     - title,ntit (*)
!4.3  type of t3 contribution
!     - typt3
!4.4  type of denominator
!     - typden
!4.10 spin adaptation key
!     - keysa
!4.12 restart information file name
!     - filerst
!4.13 type of machine (from point of mtx multiplication efficiency)
!     (parameter posd0 will be defined in initfile if mchntyp=2)
!     - mchntyp,posd0
!4.14 limiting ratio for using AT*B mtx multiplication, if mchntyp=2
!     - slim
!4.15 denominator shifts
!     - shifto,shiftv
!4.16 maximal allowed work space
!     - maxspace
!4.17 level of printing control parameter
!     - fullprint
!4.17 No operation key
!     - noop
!4.18 I/O control key
!     - iokey
!4.19 Matrix handling control key
!     - mhkey
!4.20 Key for swithching segmentation of I,J cycle
!     - ijsegkey
!4.21 Lower and upper limitations of I,J cycle (for ijsegkey=1)
!     - symimin,symimax,symjmin,symjmax
!     - imin,imax,jmin,jmax
!
!5    diska address file
!     - daddr
!
! Maps for all mediates, used in NIT3
!
!1   maps for fixed mediates
!
!1.0 maps for DP - diagonal part
!     DP1 - dp(p)a
!     DP2 - dp(p)b
!
!1.1 maps for T1
!     T11 - t1oaa(a,i)
!     T12 - t1obb(a,i)
!
!1.5 maps for FK
!     FK1 - f(a,b)aa
!     FK2 - f(a,b)bb
!     FK3 - f(a,i)aa
!     FK4 - f(a,i)bb
!     FK5 - f(i,j)aa
!     FK6 - f(i,j)bb
!
!1.6 maps for T2
!     T21 - t2n(ab,ij)aaaa
!     T22 - t2n(ab,ij)bbbb
!     T33 - t2n(a,b,i,j)abab
!
!1.8 maps for W1
!     W11 - <ie||mn>aaaa
!     W12 - <ie||mn>bbbb
!     W13 - <ie||mn>abab
!     W14 - <ie||nm>baab
!
!1.9 maps for W2
!     W21 - <ab||ij>aaaa
!     W22 - <ab||ij>bbbb
!     W23 - <a,b|i,j>abab
!
!2   maps for help files
!    There are :
!     2  WX,VX files - vv2 type
!     2  L     files - vvv(vvo) type
!     3  RX    files - vv2* type
!     3  M     files - of vv (vo)  type
!     3  H     files - of v (o)  type
!     2  N,PX  files - of nn   type

use Definitions, only: wp, iwp

implicit none
private

! pos0 - initial position
! d    - direct map
! i    - inverse map
type Map_Type
  integer(kind=iwp) :: d(0:512,6), i(8,8,8), pos0
end type Map_Type

integer(kind=iwp), parameter :: maxorb = 1024
character(len=*), parameter :: t3nam = 'T3VVVO'
integer(kind=iwp) :: daddr(8), dimm(5,8), fullprint, ijsegkey, imax, imin, iokey, ispin, jmax, jmin, keysa, lsym, maxspace, &
                     mchntyp, mhkey, mmul(8,8), noa(8), nob(8), noop, norb(8), nshf(maxorb), nsym, nva(8), nvb(8), posd0, &
                     symimax, symimin, symjmax, symjmin, T3IntPos(maxorb), T3Off(512,8), typden, typt3
real(kind=wp) :: eps(maxorb), shifto, shiftv, slim
character(len=6) :: filerst
type(Map_Type) :: dp1, dp2, fk1, fk2, fk3, fk4, fk5, fk6, h1, h2, h3, l1, l2, m1, m2, m3, n, px, rx1, rx2, rx3, t11, t12, t21, &
                  t22, t23, vx, w11, w12, w13, w14, w21, w22, w23, wx

public :: daddr, dimm, dp1, dp2, eps, filerst, fk1, fk2, fk3, fk4, fk5, fk6, fullprint, h1, h2, h3, ijsegkey, imax, imin, iokey, &
          ispin, jmax, jmin, keysa, l1, l2, lsym, m1, m2, m3, Map_Type, maxorb, maxspace, mchntyp, mhkey, mmul, n, noa, nob, noop, &
          norb, nshf, nsym, nva, nvb, posd0, px, rx1, rx2, rx3, shifto, shiftv, slim, symimax, symimin, symjmax, symjmin, t11, &
          t12, t21, t22, t23, typden, typt3, vx, w11, w12, w13, w14, w21, w22, w23, wx

public :: T3IntPos, t3nam, T3Off

end module CCT3_global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!***********************************************************************
! SubRoutine GATskL(create,nTsk,igaTsk)                                *
!  -> initialize or kill global task list                              *
!     create:   Logical: .TRUE. -> create / .FALSE. -> kill            *
!     nTsk:     # of tasks                                             *
!     igaTsk:   global array handle to global task list (on return)    *
!***********************************************************************

subroutine GATskL(create,nTsk,igaTsk)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: GA_Create, GA_Destroy, GA_NNodes, MT_INT
use Definitions, only: u6
#endif
use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: create
#ifdef _MOLCAS_MPP_
integer(kind=iwp), intent(in) :: nTsk
integer(kind=iwp), intent(out) :: igaTsk
integer(kind=iwp) :: Chk, nProcs
logical(kind=iwp) :: ok

if (.not. Is_Real_Par()) return
if (create) then
  nProcs = ga_nnodes()
  Chk = (nTsk+nProcs-1)/nProcs
  ok = ga_create(MT_INT,nTsk,1,'GlTskL',Chk,1,igaTsk)
  if (.not. ok) then
    write(u6,*) 'GATskL: ga_create not OK!'
    call ga_error('GATskL',42)
    call Abend()
  end if
  call ga_zero(igaTsk)
else
  ok = ga_destroy(igaTsk)
end if
#else
integer(kind=iwp), intent(in) :: nTsk, igaTsk
#include "macros.fh"
unused_var(create)
unused_var(nTsk)
unused_var(igaTsk)
#endif

end subroutine GATskL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE CPFCTL(H)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION H(*)

#include "SysDef.fh"

#include "cpfmcpf.fh"
C
      CALL CPFCTL_INTERNAL(H)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE CPFCTL_INTERNAL(H)
      USE ISO_C_BINDING
      REAL*8, TARGET :: H(*)
      INTEGER, POINTER :: iH1(:),iH2(:),iH3(:)
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL EPSBIS(iH2,iH3,H(LW(26)),H(LW(28)),H(LW(75)))
      NULLIFY(iH2,iH3)
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL EPSPRIM(iH2,iH3,H(LW(26)),H(LW(27)),H(LW(32)))
      NULLIFY(iH2,iH3)
      IP=IRC(4)
      CALL VECSUM_CPFMCPF(H(LW(32)),ENER,IP)
      ETOTT=ENER+POTNUC
      DELE=ETOTT-ETOT
      ETOT=ETOTT
      IF(ITER.EQ.1) THEN
        WRITE(6,'(1X,A)')' ITER      TOTAL ENERGY'
     &       //'          CORR ENERGY           DECREASE'
        CALL XFLUSH(6)
      END IF
      WRITE(6,'(1X,I3,3(5X,F16.8))')ITER,ETOT,ENER,DELE
      CALL XFLUSH(6)
      IF(ABS(DELE).LT.ETHRE.AND.ITPUL.NE.1)ICONV=1
      IF(ICONV.EQ.0.AND.ITER.NE.MAXIT)GO TO 20
C If more iterations should be done, goto 20.

      IF(ICONV.EQ.1)WRITE(6,37)
37    FORMAT(/,5X,'CALCULATION CONVERGED')
      IF(ICONV.EQ.0)WRITE(6,38)
38    FORMAT(/,5X,'CALCULATION NOT COMPLETELY CONVERGED')
      IF(ISDCI.EQ.1) WRITE(6,30)ETOT
30    FORMAT(/,5X,'FINAL CI ENERGY',6X,F17.8)
      IF(ICPF.EQ.1)WRITE(6,35)ETOT
35    FORMAT(/,5X,'FINAL CPF ENERGY',5X,F17.8)
      IF(INCPF.EQ.1)WRITE(6,39)ETOT
39    FORMAT(/,5X,'FINAL ACPF ENERGY',4X,F17.8)
      IF(ISDCI.EQ.0.AND.ICPF.EQ.0.AND.INCPF.EQ.0)WRITE(6,36)ETOT
36    FORMAT(/,5X,'FINAL MCPF ENERGY',5X,F17.8)
      WRITE(6,31)ENER,POTNUC
      CALL XFLUSH(6)
31    FORMAT(5X,'FINAL CORRELATION ENERGY',F14.8,'  REFERENCE ENERGY',
     *F17.8)
      If (ISDCI.EQ.1) Call Add_Info('E_SDCI',[ETOT],1,8)
      If (ICPF.EQ.1)  Call Add_Info('E_CPF',[ETOT],1,8)
      If (INCPF.EQ.1) Call Add_Info('E_ACPF',[ETOT],1,8)
      If (ISDCI.EQ.0.AND.ICPF.EQ.0.AND.INCPF.EQ.0)
     &                Call Add_Info('E_MCPF',[ETOT],1,8)
      CALL XFLUSH(6)
      IF(ISDCI.EQ.0)GO TO 21
      EENP=H(LW(31)+IRC(4)-1)
      C0=D1/SQRT(EENP)
      DECORR=ENER*(EENP-D1)
      DETOT=ETOT+DECORR
      WRITE(6,32)DETOT
32    FORMAT(5X,'DAVIDSON CORR. ENERGY',F17.8)
      WRITE(6,33)DECORR,C0
33    FORMAT(5X,'DAVIDSON CORRECTION',F19.8,'  C0 = ',F12.6)
      CALL XFLUSH(6)

21    CONTINUE
      IF(IPRINT.GT.5) THEN
        ISTA=LW(31)
        IEND=ISTA+IRC(4)-1
        IF(IPRINT.GT.5)WRITE(6,34)(H(I),I=ISTA,IEND)
34      FORMAT(/,(5X,'ENP',5F10.6))
      END IF

      RETURN

20    CONTINUE
C Here if ICONV.EQ.0 and  ITER.NE.MAXIT (More iterations to do).
      IDIIS=0
      IF(ITPUL.EQ.MAXITP)IDIIS=1
      CALL C_F_POINTER(C_LOC(H(LW(1))),iH1,[1])
      CALL  APPRIM(H(LW(32)),H(LW(75)),H(LW(30)),H(LW(76)),H(LW(31)),
     &             H(LW(79)),H(LW(80)),iH1)
      NULLIFY(iH1)
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL CUPDATE(iH2,iH3,H(LW(26)),H(LW(27)),
     &             H(LW(76)),H(LW(33)),H(LW(80)),H(LW(31)))
      NULLIFY(iH2,iH3)
      ITP=ITPUL+1
      CALL    DIIS_CPF(H(LW(26)),H(LW(27)),H(LW(33)),
     &             MAXIT,H(LW(77)),ITP,H(LW(78)))
      RETURN
      END SUBROUTINE CPFCTL_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Daoling Peng                                     *
!               2021, Rulin Feng                                       *
!***********************************************************************

subroutine DKRelint_DP()
! modified by D. Peng, ETH Zurich, October 2011
!
! Interface/Driver routine for scalar relativistic
!       arbitrary-order DKH method,
!       exact decoupling X2C method &
!       exact decoupling BSS method.

use Basis_Info, only: dbsc, nBas, ncnttp
use DKH_Info, only: cLightAU, iRelae, LDKroll, radiLD
use Symmetry_Info, only: nIrrep
use Gateway_Info, only: lMXTC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: dkhorder, dkhparam, i, i_Dim, iAngr, iBas, icnt, iCnttp, iComp, idbg, idum(1), iExp, iibas, iMEF, iOpt, &
                     iPrint, iProps, iRC, iRout, iSize, iSizec, iSizep, iSizes, iTemp, jCent, jExp, k, kAng, kC, kCof, kCofi, &
                     kCofj, kExp, kExpi, kExpj, ks, kz, L, lOper, lOper_save, Lu_One, n, n_Int, nAtoms, nBas_cont(8), &
                     nBas_prim(8), nbl, nComp, nSym, numb_props, Op, relmethod, xorder
real(kind=wp) :: rCofi, rCofj, rEpsilon, rExpi, rExpj, rI, rNorm, rSum, VELIT
logical(kind=iwp) :: DoFullLT
!character(len=3) :: paramtype
character(len=8) :: Label, pXpLbl
integer(kind=iwp), allocatable :: indx(:), Loc(:), Map(:), Ind(:,:)
real(kind=wp), allocatable :: iK(:), SS(:), V(:), pVp(:), K_Save(:), K_Done(:), U_L(:), U_S(:), X(:), pXp(:), Prop(:), Pmag(:), &
                              Y(:), P(:), G(:), Ev2(:,:), Eig(:,:), Sinv(:,:), Ew(:), E(:), Aa(:), Rr(:), Tt(:), Re1r(:,:), &
                              Auxi(:,:), Tmp(:), Even1(:,:), Pvpt(:), Bu(:), H(:), H_nr(:), H_temp(:)
logical(kind=iwp), parameter :: Debug = .false.
integer(kind=iwp), external :: nProp_Int
#include "Molcas.fh"
#include "rinfo.fh"
#include "print.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 77
iPrint = nPrint(iRout)

if (Debug) then
  idbg = 6
else
  idbg = -1
end if

!                                                                      *
!***********************************************************************
!                                                                      *
! Save basis set info from contracted run

if (iprint >= 10) write(u6,*) ' In DKRelInt',ncnttp
kCof = 0
kAng = 0
kExp = 0
kC = 0

! Normalize coefficients

do iCnttp=1,nCnttp

  ! The non-valence type shells come at the end.
  ! When this block is encountered stop the procedure.

  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag .or. (dbsc(iCnttp)%nFragType > 0)) exit

  do icnt=1,dbsc(iCnttp)%nCntr
    kC = kC+1
    do iAngr=0,nAngr(kC)
      rI = real(iAngr,kind=wp)+One+Half
      kAng = kAng+1
      do iBas=1,nBasisr(kAng)
        rSum = Zero
        kExpi = kExp
        kCofi = kCof
        do iExp=1,nPrimr(kAng)
          kExpi = kExpi+1
          kCofi = kCofi+1
          rExpi = rExp(kExpi)
          !write(u6,'(a11,f20.8)') ' Exponents',rExpi
          rCofi = rCof(kCofi)
          kExpj = kExp
          kCofj = kCof
          do jExp=1,nPrimr(kAng)
            kExpj = kExpj+1
            kCofj = kCofj+1
            rExpj = rExp(kExpj)
            rCofj = rCof(kCofj)
            rSum = rSum+rCofi*rCofj*(Two*sqrt(rExpi*rExpj)/(rExpi+rExpj))**rI
          end do
        end do
        rNorm = One/sqrt(rSum)
        if (iprint >= 10) write(u6,*) ' rNorm',kAng,rNorm
        do iExp=1,nPrimr(kAng)
          rCof(kCof+iExp) = rCof(kCof+iExp)*rNorm
          if (iprint >= 10) then
            write(u6,'(a24,f20.6)') ' normalized coefficients',rCof(kCof+iExp)
          end if
        end do
        kCof = kCof+nPrimr(kAng)
      end do
      kExp = kExp+nPrimr(kAng)
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (iPrint >= 10) then
  i = 0
  do L=1,nrSym
    write(u6,*) ' Irreducible representation',L
    do ibas=1,nrBas(L)
      i = i+1
      write(u6,'(20i4)') i,icent(i),lnang(i),lmag(i)
    end do
  end do
end if

nBas_Cont(:) = nBas
nSym = nIrrep
!                                                                      *
!***********************************************************************
!                                                                      *
! Close ONEINT

iOpt = 0
call ClsOne(iRC,iOpt)
!                                                                      *
!***********************************************************************
!                                                                      *
! HFC magnetic integrals

if (lMXTC) then
  call Get_nAtoms_All(nAtoms)
  call copy_mag_ints(nAtoms)
end if

! Open ONEREL

iOpt = 0
iRC = -1
Lu_One = 2
call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
if (iRC /= 0) call Error()

call OneBas('PRIM')
!                                                                      *
!***********************************************************************
!                                                                      *
call Get_iArray('nBas_Prim',nBas,nSym)
nBas_prim(:) = nBas
if (iPrint >= 10) then
  write(u6,'(a,8i5)') ' Symmetries          ',nSym
  write(u6,'(a,8i5)') ' Primitive basis fcns',(nBas(i),i=0,nSym-1)
end if

! Allocate memory for relativistic part

VELIT = cLightAU
iSizep = 0
iSizes = 0
iSizec = 0
iibas = 0
do L=0,nSym-1
  iSizep = iSizep+nBas(L)*(nBas(L)+1)/2
  iSizes = iSizes+nBas(L)*nBas(L)
  iSizec = iSizec+nrBas(L+1)*(nrBas(L+1)+1)/2
  iibas = iibas+nbas(L)
end do
if (iPrint >= 10) write(u6,*) ' iSizep',iSizep

call mma_allocate(iK,iSizep+4,label='Kin')
call mma_allocate(SS,iSizep+4,label='SS')
call mma_allocate(V,iSizep+4,label='V')
call mma_allocate(pVp,iSizep+4,label='pVp')

Label = 'Mltpl  0'
iComp = 1
iOpt = 0
iRC = -1
call RdOne(iRC,iOpt,Label,1,SS,lOper)
if (iRC /= 0) then
  write(u6,*) 'DKRelInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
nComp = 1
if (iPrint >= 20) call PrMtrx(Label,[lOper],nComp,[1],SS)
Label = 'Attract '
iRC = -1
call RdOne(iRC,iOpt,Label,1,V,lOper)
if (iRC /= 0) then
  write(u6,*) 'DKRelInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
if (iPrint >= 20) call PrMtrx(Label,[lOper],nComp,[1],V)
Label = 'Kinetic '
iRC = -1
call RdOne(iRC,iOpt,Label,1,iK,lOper)
if (iRC /= 0) then
  write(u6,*) 'DKRelInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
if (iPrint >= 20) call PrMtrx(Label,[lOper],nComp,[1],iK)
Label = 'pVp     '
iRC = -1
call RdOne(iRC,iOpt,Label,1,pVp,lOper)
if (iRC /= 0) then
  write(u6,*) 'DKRelInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
if (iPrint >= 20) call PrMtrx(Label,[lOper],nComp,[1],pVp)

iOpt = 0
call ClsOne(iRC,iOpt)
!                                                                      *
!***********************************************************************
!                                                                      *
if (IRELAE >= 100) then
  if (IRELAE >= 1000) then

    ! IRELAE codes the method (DKH=1), the order (01 to 99), and the
    ! parametrization (1 to 5), i.e. 3rd order DKH with sqrt
    ! parametrization: 1-03-3, i.e. IRELAE=1033

    relmethod = 1

    ! relmethod = 1  arbitrary order DKH
    !           = 2  exact decoupling X2C
    !           = 3  exact decoupling BSS

    xOrder = iRELAE/10000
    iTemp = iRELAE-1000-xOrder*10000
    dkhorder = iTemp/10
    iTemp = iTemp-dkhorder*10
    dkhparam = iTemp
    if (xorder > dkhorder) then
      write(u6,'(a,i3,a,i3)') ' xorder was reduced from ',xorder,' to ',dkhorder
      xorder = dkhorder
    end if
    !if (iTemp == 1) then
    !  paramtype = 'OPT'
    !else if (iTemp == 2) then
    !  paramtype = 'EXP'
    !else if (iTemp == 3) then
    !  paramtype = 'SQR'
    !else if (iTemp == 4) then
    !  paramtype = 'MCW'
    !else if (iTemp == 5) then
    !  paramtype = 'CAY'
    !else
    if ((iTemp < 1) .or. (iTemp > 5)) then
      write(u6,*) 'dkrelint: Illegal parametrization!'
      call Abend()
    end if
    !write(u6,'(A)') ' Computing the arbitrary order DKH Hamiltonian'
  else if (IRELAE == 101) then
    relmethod = 2
    xorder = 1
    !write(u6,'(A)') ' Computing the exact decoupling X2C Hamiltonian'
  else if (IRELAE == 102) then
    relmethod = 3
    xorder = 1
    !write(u6,'(A)') ' Computing the exact decoupling BSS Hamiltonian'
  else
    write(u6,*) 'dkrelint: Unknown method !'
    call Abend()
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call mma_allocate(K_Save,iSizep+4,label='K_Save')
  call mma_allocate(K_Done,iSizep+4,label='K_Done')
  call dcopy_(iSizep+4,iK,1,K_Save,1)

  call mma_allocate(U_L,iSizes+4,label='U_L')
  call mma_allocate(U_S,iSizes+4,label='U_S')

  ! Read block information if do local transformation

  if (LDKroll) then
    call mma_allocate(indx,iibas,label='Index')
    call xdr_indx(iibas,indx)
    DoFullLT = .true.
    if (radiLD == Zero) DoFullLT = .false.
    if (DoFullLT) then
      if ((relmethod == 1) .and. (xorder == 0)) then
        xorder = dkhorder
      end if
      write(u6,'(A)') '   DLU Local Transformation'
    else
      write(u6,'(A)') '   DLH Local Transformation'
    end if
  end if

  ! Do the Hamiltonian separately

  k = 1
  ks = 1
  kz = 1

  do L=0,nSym-1
    n = nBas(L)
    iSize = n*(n+1)/2
    if (iSize == 0) cycle
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    if (LDKroll) then
      call mma_allocate(Loc,n,label='InfoLoc')
      call mma_allocate(Map,n,label='InfoMap')
      call xdr_info_local(n,indx(kz),nbl,Loc,Map)
      !DP write(u6,'(a,i1,i5,a,99i4)') '   Sym: ',L+1,n,'  = Local ',(Loc(i),i=1,nbl)
      call XDR_Local_Ham(n,isize,n*n,relmethod,dkhparam,dkhorder,xorder,SS(k),iK(k),V(k),pVp(k),U_L(ks),U_S(ks),nbl,Loc,Map, &
                         DoFullLT,cLightAU)
      call mma_deallocate(Loc)
      call mma_deallocate(Map)
    else
      call XDR_Ham(n,isize,n*n,relmethod,dkhparam,dkhorder,xorder,SS(k),iK(k),V(k),pVp(k),U_L(ks),U_S(ks),cLightAU)
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ks = ks+n*n
    kz = kz+n
    k = k+isize
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call dcopy_(iSizep+4,iK,1,K_Done,1)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (xOrder > 0) then
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Pick up the number of property integrals to process.

#   ifndef MOLPRO
    numb_props = nProp_Int(.false.,idum,0)
    call mma_allocate(Ind,4,numb_props,label='Ind')
    numb_props = nProp_Int(.true.,Ind,numb_props)
    do iProps=1,numb_props
      Op = Ind(1,iProps)
      iMEF = Ind(2,iProps)
      iComp = Ind(3,iProps)
      jCent = Ind(4,iProps)

      call dcopy_(iSizep+4,K_Save,1,iK,1)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Read the property integrals
      !
      ! Open ONEREL

      iOpt = 0
      iRC = -1
      Lu_One = 2
      call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
      if (iRC /= 0) call Error()

      call OneBas('PRIM')

      if (Op == 1) then
        write(Label,'(a,i2)') 'MLTPL ',iMEF
      else if (Op == 2) then
        write(Label,'(a,i1,i5)') 'EF',iMEF,jCent
      else if (Op == 3) then
        write(Label,'(a,i5)') 'Cnt',jCent
      else if (Op == 4) then
        write(Label,'(A,I3)') 'MAGXP',jCent
      else
        write(u6,*) 'DKRelInt: illegal property!'
        call Abend()
      end if
      !write(u6,*)
      !write(u6,*) 'Label=',Label
      !write(u6,*) 'iComp=',iComp
      !write(u6,*)

      iOpt = 1
      iRC = -1
      lOper = -1
      call iRdOne(iRC,iOpt,Label,iComp,idum,lOper)
      if (iRC == 0) n_Int = idum(1)
      !write(u6,*) 'lOper=',lOper
      call mma_allocate(X,n_Int+4,label='X')
      iRC = -1
      iOpt = 0
      call RdOne(iRC,iOpt,Label,iComp,X,lOper)
      if (iRC /= 0) then
        write(u6,*) 'DKRelInt: Error reading from ONEREL'
        write(u6,'(A,A)') 'Label=',Label
        write(u6,'(A,A)') 'iRC=',iRC
        call Abend()
      end if
      call CmpInt(X,n_Int,nBas_Prim,nSym,lOper)
      if (n_Int == 0) then
        iOpt = 0
        call ClsOne(iRC,iOpt)
      else

        if (Op == 1) then
          write(pXpLbl,'(A,I2)') 'pMp   ',iMEF
        else if (Op == 2) then
          write(pXpLbl,'(A,I1,I5)') 'PP',iMEF,jCent
        else if (Op == 3) then
          write(pXpLbl,'(A,I2)') 'pCp   ',jCent
        else if (Op == 4) then
          write(pXpLbl,'(A,I3)') 'MAGPX',jCent
        end if
        iOpt = 1
        iRC = -1
        call iRdOne(iRC,iOpt,pXpLbl,iComp,idum,lOper)
        if (iRC == 0) n_Int = idum(1)
        call mma_allocate(pXp,n_Int+4,label='pXp')
        iOpt = 0
        iRC = -1
        call RdOne(iRC,iOpt,pXpLbl,iComp,pXp,lOper)
        if (iRC /= 0) then
          write(u6,*) 'DKRelInt: Error reading from ONEREL'
          write(u6,'(A,A)') 'pXpLbl=',pXpLbl
          write(u6,'(A,A)') 'iRC=',iRC
          call Abend()
        end if
        call CmpInt(pXp,n_Int,nBas_Prim,nSym,lOper)

        iOpt = 0
        call ClsOne(iRC,iOpt)

        !call mma_maxDBLE(Mem_Available)
        !write(u6,*) 'Mem_Available=',Mem_Available
        k = 1
        ks = 1
        do L=0,nSym-1
          n = nBas(L)
          iSize = n*(n+1)/2
          if (iSize == 0) cycle

          ! Skip if the propetry operator does not have a total
          ! symmetric component!

          if (btest(lOper,0)) then
            !                                                          *
            !***********************************************************
            !                                                          *
            call XDR_Prop(n,isize,n*n,relmethod,dkhparam,xorder,SS(k),iK(k),V(k),pVp(k),X(k),pXp(k),U_L(ks),U_S(ks),cLightAU, &
                          Label,iComp,iSizec)
            ks = ks+n*n
          end if
          k = k+isize
        end do
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Put the picture change corrected integral back to the
        ! ONEINT file. Primitives in X.
        !
        ! First contract the result, store in Prop

        call mma_allocate(Prop,iSizec+4,label='Prop')
        call repmat(idbg,X,Prop,.true.)
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Read the contracted property integrals from OneInt

        iOpt = 0
        iRC = -1
        Lu_One = 2
        call OpnOne(iRC,iOpt,'ONEINT',Lu_One)
        if (iRC /= 0) call Error()

        if (Op == 4) then
          call mma_allocate(Pmag,iSizec+4,label='Pmag')
          call repmat(idbg,X,Pmag,.false.)
          lOper_save = lOper
          lOper = 255
          call WrOne(iRC,iOpt,Label,iComp,Pmag,lOper)
          call WrOne(iRC,iOpt,pXpLbl,iComp,Pmag,lOper)
          iOpt = 0
          call ClsOne(iRC,iOpt)
          call mma_deallocate(X)
          call mma_deallocate(pXp)
          call mma_deallocate(Prop)
          call mma_deallocate(Pmag)
          lOper = lOper_save
          cycle
        end if

        iOpt = 1
        iRC = -1
        lOper = -1
        call iRdOne(iRC,iOpt,Label,iComp,idum,lOper)
        if (iRC == 0) n_Int = idum(1)
        call mma_allocate(Y,n_Int+4,label='Y')
        iRC = -1
        iOpt = 0
        call RdOne(iRC,iOpt,Label,iComp,Y,lOper)
        !write(u6,*) 'Y1=',DDot_(n_Int,Y,1,One,0)
        if (iRC /= 0) then
          write(u6,*) 'DKRelInt: Error reading from ONEINT'
          write(u6,'(A,A)') 'Label=',Label
          call Abend()
        end if

        ! Put the picture change corrected blocks in. Note that this
        ! is just the diagonal symmetry blocks.

        call Cp_Prop_Int(Y,n_Int,Prop,iSizec,nrBas,nIrrep,lOper)

        ! Now write it back to disc

        iOpt = 0
        call WrOne(iRC,iOpt,Label,iComp,Y,lOper)

        iOpt = 0
        call ClsOne(iRC,iOpt)

        call mma_deallocate(Prop)
        call mma_deallocate(Y)

        call mma_deallocate(pXp)
      end if
      call mma_deallocate(X)
      !                                                                *
      !*****************************************************************
      !                                                                *
    end do ! iProps

    call mma_deallocate(Ind)
#   endif
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call dcopy_(iSizep+4,K_Done,1,iK,1)
  call mma_deallocate(K_Save)
  call mma_deallocate(K_Done)
  call mma_deallocate(U_L)
  call mma_deallocate(U_S)
  if (LDKroll) then
    call mma_deallocate(indx)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  !      The Old code, no option for property integrals.
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  !      Loop over the symmetry blocks
  !
  rEpsilon = 1.0e-10_wp
  k = 1
  do L=0,nSym-1
    n = nBas(L)
    iSize = n*(n+1)/2
    if (iSize == 0) cycle
    ! Allocate

    call mma_allocate(P,iSize+4,label='P')
    call mma_allocate(G,iSize+4,label='G')
    call mma_allocate(Ev2,n,n,label='Ev2')
    call mma_allocate(Eig,n,n,label='Eig')
    call mma_allocate(Sinv,n,n,label='Sinv')
    call mma_allocate(Ew,n,label='Ew')
    call mma_allocate(E,n,label='E')
    call mma_allocate(Aa,n,label='Aa')
    call mma_allocate(Rr,n,label='Rr')
    call mma_allocate(Tt,n,label='Tt')
    call mma_allocate(Re1r,n,n,label='Re1r')
    call mma_allocate(Auxi,n,n,label='Auxi')
    call mma_allocate(Tmp,iSize,label='Tmp')
    if (IRELAE == 0) then
      call mma_allocate(Even1,1,1,label='Even1')
      call mma_allocate(Pvpt,1,label='Pvpt')
      call mma_allocate(Bu,1,label='Bu')
      i_Dim = 1
    else
      call mma_allocate(Even1,n,n,label='Even1')
      call mma_allocate(Pvpt,iSize,label='Pvpt')
      call mma_allocate(Bu,iSize,label='Bu')
      i_Dim = n
    end if

    ! call to package relsew

    call SCFCLI(idbg,rEpsilon,SS(k),iK(k),V(k),pVp(k),n,iSize,VELIT,Bu,P,G,Ev2,Eig,Sinv,Ew,E,Aa,Rr,Tt,Pvpt,Even1,Re1r,Auxi,Tmp, &
                i_Dim)

    call mma_deallocate(P)
    call mma_deallocate(G)
    call mma_deallocate(Ev2)
    call mma_deallocate(Eig)
    call mma_deallocate(Sinv)
    call mma_deallocate(Ew)
    call mma_deallocate(E)
    call mma_deallocate(Aa)
    call mma_deallocate(Rr)
    call mma_deallocate(Tt)
    call mma_deallocate(Re1r)
    call mma_deallocate(Auxi)
    call mma_deallocate(Tmp)
    call mma_deallocate(Even1)
    call mma_deallocate(Pvpt)
    call mma_deallocate(Bu)
    k = k+isize
  end do

end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate arrays in contracted basis

call mma_allocate(H,iSizec+4,label='H')
call mma_allocate(H_nr,iSizec+4,label='H_o')
call mma_allocate(H_temp,iSizec+4,label='H_temp')
H(:) = Zero
H_nr(:) = Zero
H_temp(:) = Zero

#ifdef MOLPRO
! store relativistic H
call repmat(idbg,ik,H_temp,.true.)
call fperm(H_temp,H)
call writem(H,iSizec+2,1,1200,0,'H0')
call writem(H,iSizec+2,1,1210,0,'H01')
! store V=H-T
call lesw(SS,iSizec,1,1400,0)
call daxpy_(iSizec,-One,SS,1,H,1)
call writem(H,iSizec+2,1,1410,0,'POT')
! reset contracted basis size
nBas(:) = nBas_Cont
call mma_deallocate(iK)
call mma_deallocate(SS)
call mma_deallocate(V)
#else

! Note: in combination with ECPs V is only based on the effective
!       charges of the atoms. In the primitive basis, however, we
!       have temporarily introduced the actual atomic charges. We
!       have to fix this now. Hence the somewhat strange way in
!       which the DKH corrected Hamiltonian is computed.
!
! Compute stripped non-relativistic H H_temp
!                                                                      *
!***********************************************************************
!                                                                      *
! Open ONEREL

iOpt = 0
iRC = -1
Lu_One = 2
call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
if (iRC /= 0) call Error()

call OneBas('PRIM')

Label = 'Kinetic '
call RdOne(iRC,iOpt,Label,1,SS,lOper)
if (iRC /= 0) then
  write(u6,*) 'DKRelInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
Label = 'Attract '
call RdOne(iRC,iOpt,Label,1,V,lOper)
if (iRC /= 0) then
  write(u6,*) 'DKRelInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
! Add Kinetic and Attraction term
call DaXpY_(iSizep+4,One,SS,1,V,1)
if (iPrint >= 20) then
  call iSwap(8,nBas,1,nBas_Prim,1)
  call PrMtrx('Attract+Kinetic (prim)',[lOper],nComp,[1],V)
  call PrMtrx('Kinetic (prim)',[lOper],nComp,[1],SS)
  call iSwap(8,nBas,1,nBas_Prim,1)
end if
H_temp(iSizec+1:) = Zero
! Contract and store in H_temp
call repmat(idbg,V,H_temp,.true.)

call mma_deallocate(SS)
call mma_deallocate(V)

! Close ONEREL and re-open ONEINT

iOpt = 0
iRC = -1
call ClsOne(iRC,iOpt)
if (iRC /= 0) call Error()
iOpt = 0
iRC = -1
Lu_One = 2
call OpnOne(iRC,iOpt,'ONEINT',Lu_One)
if (iRC /= 0) call Error()

if (iPrint >= 20) then
  call iSwap(8,nBas,1,nBas_Cont,1)
  call PrMtrx('H_temp (cont)',[lOper],nComp,[1],H_temp)
  call iSwap(8,nBas,1,nBas_Cont,1)
end if

! Transform DKH Hamiltonian to contracted basis (H)

if (iPrint >= 20) then
  call iSwap(8,nBas,1,nBas_Prim,1)
  call PrMtrx('iK (prim)',[lOper],nComp,[1],iK)
  call iSwap(8,nBas,1,nBas_Prim,1)
end if
call repmat(idbg,iK,H,.true.)
if (iPrint >= 20) then
  call iSwap(8,nBas,1,nBas_Cont,1)
  call PrMtrx('H (cont)',[lOper],nComp,[1],H)
  call iSwap(8,nBas,1,nBas_Cont,1)
end if

call mma_deallocate(iK)

iOpt = 0
iRC = -1
Label = 'OneHam 0'
call RdOne(iRC,iOpt,Label,1,H_nr,lOper)
if (iRC /= 0) then
  write(u6,*) 'DKRelInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
iOpt = 0
iRC = -1

! final Hamiltonian computed as H(nrel) + ( Hrel(s) - Hnrel(s))
! where (s) is stripped and with full charge

call DaXpY_(iSizec+4,-One,H_temp,1,H,1)
call DaXpY_(iSizec+4,One,H_nr,1,H,1)

call Get_iArray('nBas',nBas,nSym)
if (iPrint >= 10) then
  write(u6,'(a11,10i5)') ' Symmetries',nSym
  write(u6,'(a11,10i5)') ' Contracted',(nBas(i),i=0,nSym-1)
end if
Label = 'OneHam 0'
lOper = 1
nComp = 1
if (iPrint >= 20) call PrMtrx(Label,[lOper],nComp,[1],H)

! Replace 1-el Hamiltonian on ONEINT

iRC = -1
call WrOne(iRC,iOpt,Label,1,H,lOper)
Label = 'OneHam  '
call WrOne(iRC,iOpt,Label,1,H,lOper)
if (iRC /= 0) then
  write(u6,*) 'DKRelInt: Error reading from ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if

if (IRELAE == 23) then   ! IORA

  ! Replace overlap on ONEINT

  call repmat(idbg,pVp,H,.true.)
  iRC = -1
  Label = 'Mltpl  0'
  call WrOne(iRC,iOpt,Label,1,H,lOper)
  if (iRC /= 0) then
    write(u6,*) 'DKInt: Error reading from ONEINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if
end if
#endif

call mma_deallocate(pVp)
call mma_deallocate(H)
call mma_deallocate(H_nr)
call mma_deallocate(H_temp)

return

contains

subroutine Error()
  write(u6,*) ' *** Error in subroutine DKRelInt ***'
  write(u6,*) '     Abend in subroutine OpnOne'
  call Abend()
end subroutine Error

end subroutine DKRelint_DP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Markus P. Fuelscher                              *
************************************************************************
      Subroutine RdInp_FFPT
*
************************************************************************
*                                                                      *
*     Objective: Read and interprete input                             *
*                                                                      *
************************************************************************
*                                                                      *
*     In order to introduce the ffpt input to the CERIUS2 interface    *
*     the parser had to be changed!                                    *
*     M. Fuelscher, Lund Univeristy, Sweden, February 2000             *
*                                                                      *
************************************************************************
*
      Implicit Real*8 ( A-H,O-Z )
*

#include "input.fh"
*
      Parameter ( mCom = 11 )
      Character*20 FmtLog
      Character*4 Com(mCom)
      Data Com / 'TITL','DIPO','EFLD','QUAD','OCTU',
     &           'EFGR','RELA','GLBL','SELE','CUMU','END ' /
*
      Character*72 Line,Temp1,Temp2
      Character*4  Token
      Logical      Op0(9)
      Data         Op0 /9*.false./
      Logical      Op2(3)
      Data         Op2 /3*.false./
      Logical      Op3(4)
      Data         Op3 /4*.false./
      Logical      Op4(8)
      Data         Op4 /8*.false./
      Logical      Op5(12)
      Data         Op5 /12*.false./
      Logical      Op6(8)
      Data         Op6 /8*.false./

      LCumulate=.False.
*
*----------------------------------------------------------------------*
*                                                                      *
*     Start procedure                                                  *
*     Locate "start of input"                                          *
*                                                                      *
*----------------------------------------------------------------------*
*
      Call RdNlst(5,'FFPT')
      Temp2 = ' '
      Temp1 = ' '
      Line  = ' &FFPT &END'
*
*----------------------------------------------------------------------*
*     Initialize counters                                              *
*----------------------------------------------------------------------*
*
      newline = 0
      mLbl = 0
      mTit = 0
*
*----------------------------------------------------------------------*
*     Read the input stream line by line and identify key command      *
*----------------------------------------------------------------------*
*
      jCom=0
 1    Temp2 = Temp1
      Temp1 = Line
      Read(5,'(A)',Err=991,End=991) Line
      newline = newline+1
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 1
      Call StdFmt(Line,Token)
 2    jCom=0
      Do iCom=1,mCom
        If ( Token.eq.Com(iCom) ) jCom=iCom
      End Do
      If ( jCom.eq.0 ) Goto 992
*
*----------------------------------------------------------------------*
*     Branch to the processing of the command sections                 *
*----------------------------------------------------------------------*
*
      Goto (10,20,30,40,50,60,70,80,90,100,1000),jCom
*
*---  Process the "TITL" command --------------------------------------*
*
 10   Continue
      If ( Op0(1) ) Goto 993
      Op0(1) = .true.
      ComStk(1,0,0,0)=.true.
 15   Temp2 = Temp1
      Temp1 = Line
      newline = newline+1
      Read(5,'(A)',Err=991,End=991) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 15
      Call StdFmt(Line,Token)
      Do iCom=1,mCom
        If ( Token.eq.Com(iCom) ) Goto 2
      End Do
      mTit=mTit+1
      If ( mTit.le.MxTitL ) then
         Title(mTit)=Line
      End If
      Goto 15
*
*---  Process the "DIPO" command --------------------------------------*
*
 20   Continue
      If ( Op0(2) ) Goto 993
      Op0(2) = .true.
 25   Temp2 = Temp1
      Temp1 = Line
      newline = newline+1
      Read(5,'(A)',Err=991,End=991) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 25
      Call UpCase(Line)
      Do i = 1,LEN(Line)
        If ( Line(i:i).eq.'=' ) Line(i:i) = ' '
        If ( Line(i:i).eq.CHAR(9) ) Line(i:i) = ' '
      End Do
      Call StdFmt(Line,Token)
      Do iCom=1,mCom
        If ( Token.eq.Com(iCom) ) Goto 2
      End Do
      i1 = 2
      i2 = LEN(Line)
      If ( Token.eq.'X' ) then
        If ( Op2(1) ) Goto 993
        Op2(1) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,1,1,0) = .true.
        ComStk(2,1,1,1) = .true.
        ComVal(2,1,1,1) = W
        Goto 25
      End If
      If ( Token.eq.'Y' ) then
        If ( Op2(2) ) Goto 993
        Op2(2) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,1,1,0) = .true.
        ComStk(2,1,1,2) = .true.
        ComVal(2,1,1,2) = W
        Goto 25
      End If
      If ( Token.eq.'Z' ) then
        If ( Op2(3) ) Goto 993
        Op2(3) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,1,1,0) = .true.
        ComStk(2,1,1,3) = .true.
        ComVal(2,1,1,3) = W
        Goto 25
      End If
      Goto 992
*
*---  Process the "EFLD" command --------------------------------------*
*
 30   Continue
      If ( Op0(3) ) Goto 993
      Op0(3) = .true.
 35   Temp2 = Temp1
      Temp1 = Line
      newline = newline+1
      Read(5,'(A)',Err=991,End=991) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 35
      Call UpCase(Line)
      Do i = 1,LEN(Line)
        If ( Line(i:i).eq.'=' ) Line(i:i) = ' '
        If ( Line(i:i).eq.CHAR(9) ) Line(i:i) = ' '
      End Do
      Call StdFmt(Line,Token)
      Do iCom=1,mCom
        If ( Token.eq.Com(iCom) ) Goto 2
      End Do
      i1 = 2
      i2 = LEN(Line)
      If ( Token.eq.'X' ) then
        If ( Op3(1) ) Goto 993
        Op3(1) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,3,1,0) = .true.
        ComStk(2,3,1,1) = .true.
        ComVal(2,3,1,1) = W
        Goto 35
      End If
      If ( Token.eq.'Y' ) then
        If ( Op3(2) ) Goto 993
        Op3(2) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,3,1,0) = .true.
        ComStk(2,3,1,2) = .true.
        ComVal(2,3,1,2) = W
        Goto 35
      End If
      If ( Token.eq.'Z' ) then
        If ( Op3(3) ) Goto 993
        Op3(3) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,3,1,0) = .true.
        ComStk(2,3,1,3) = .true.
        ComVal(2,3,1,3) = W
        Goto 35
      End If
      i1 = 5
      If ( Token.eq.'ORIG' ) then
        If ( Op3(4) ) Goto 993
        Op3(4) = .true.
        i1=5
        Read(Line(i1:i2),*,Err=991,End=991) X,Y,Z
        ComStk(2,3,2,0) = .true.
        ComStk(2,3,2,1) = .true.
        ComVal(2,3,2,1) = X
        ComStk(2,3,2,2) = .true.
        ComVal(2,3,2,2) = Y
        ComStk(2,3,2,3) = .true.
        ComVal(2,3,2,3) = Z
        Goto 35
      End If
      Goto 992
*
*---  Process the "QUAD" command --------------------------------------*
*
 40   Continue
      If ( Op0(4) ) Goto 993
      Op0(4) = .true.
 45   Temp2 = Temp1
      Temp1 = Line
      newline = newline+1
      Read(5,'(A)',End=991) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 45
      Call UpCase(Line)
      Do i = 1,LEN(Line)
        If ( Line(i:i).eq.'=' ) Line(i:i) = ' '
        If ( Line(i:i).eq.CHAR(9) ) Line(i:i) = ' '
      End Do
      Call StdFmt(Line,Token)
      Do iCom=1,mCom
        If ( Token.eq.Com(iCom) ) Goto 2
      End Do
      i1 = 3
      i2 = LEN(Line)
      If ( Token.eq.'XX' ) then
        If ( Op4(1) ) Goto 993
        Op4(1) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,2,1,0) = .true.
        ComStk(2,2,1,1) = .true.
        ComVal(2,2,1,1) = W
        Goto 45
      End If
      If ( Token.eq.'YY' ) then
        If ( Op4(2) ) Goto 993
        Op4(2) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,2,1,0) = .true.
        ComStk(2,2,1,4) = .true.
        ComVal(2,2,1,4) = W
        Goto 45
      End If
      If ( Token.eq.'ZZ' ) then
        If ( Op4(3) ) Goto 993
        Op4(3) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,2,1,0) = .true.
        ComStk(2,2,1,6) = .true.
        ComVal(2,2,1,6) = W
        Goto 45
      End If
      If ( Token.eq.'XY' ) then
        If ( Op4(4) ) Goto 993
        Op4(4) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,2,1,0) = .true.
        ComStk(2,2,1,2) = .true.
        ComVal(2,2,1,2) = W
        Goto 45
      End If
      If ( Token.eq.'XZ' ) then
        If ( Op4(5) ) Goto 993
        Op4(5) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,2,1,0) = .true.
        ComStk(2,2,1,3) = .true.
        ComVal(2,2,1,3) = W
        Goto 45
      End If
      If ( Token.eq.'YZ' ) then
        If ( Op4(6) ) Goto 993
        Op4(6) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,2,1,0) = .true.
        ComStk(2,2,1,5) = .true.
        ComVal(2,2,1,5) = W
        Goto 45
      End If
      If ( Token.eq.'RR' ) then
        If ( Op4(7) ) Goto 993
        Op4(7) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,2,1,0) = .true.
        ComStk(2,2,1,7) = .true.
        ComVal(2,2,1,7) = W
        Goto 45
      End If
      If ( Token.eq.'ORIG' ) then
        If ( Op4(8) ) Goto 993
        Op4(8) = .true.
        i1=5
        Read(Line(i1:i2),*,Err=991,End=991) X,Y,Z
        ComStk(2,2,2,0) = .true.
        ComStk(2,2,2,1) = .true.
        ComVal(2,2,2,1) = X
        ComStk(2,2,2,2) = .true.
        ComVal(2,2,2,2) = Y
        ComStk(2,2,2,3) = .true.
        ComVal(2,2,2,3) = Z
        Goto 45
      End If
      Goto 992
*
*---  Process the "OCTU" command --------------------------------------*
*
 50   Continue
      If ( Op0(5) ) Goto 993
      Op0(5) = .true.
 55   Temp2 = Temp1
      Temp1 = Line
      newline = newline+1
      Read(5,'(A)',Err=991,End=991) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 55
      Call UpCase(Line)
      Do i = 1,LEN(Line)
        If ( Line(i:i).eq.'=' ) Line(i:i) = ' '
        If ( Line(i:i).eq.CHAR(9) ) Line(i:i) = ' '
      End Do
      Call StdFmt(Line,Token)
      Do iCom=1,mCom
        If ( Token.eq.Com(iCom) ) Goto 2
      End Do
      i1 = 4
      i2 = LEN(Line)
      If ( Token.eq.'XXX' ) then
        If ( Op5(1) ) Goto 993
        Op5(1) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,1) = .true.
        ComStk(2,6,1,1) = .true.
        ComVal(2,6,1,1) = W
        Goto 55
      End If
      If ( Token.eq.'XYY' ) then
        If ( Op5(2) ) Goto 993
        Op5(2) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,4) = .true.
        ComStk(2,6,1,4) = .true.
        ComVal(2,6,1,4) = W
        Goto 55
      End If
      If ( Token.eq.'XZZ' ) then
        If ( Op5(3) ) Goto 993
        Op5(3) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,6) = .true.
        ComStk(2,6,1,6) = .true.
        ComVal(2,6,1,6) = W
        Goto 55
      End If
      If ( Token.eq.'XXY' ) then
        If ( Op5(4) ) Goto 993
        Op5(4) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,2) = .true.
        ComStk(2,6,1,2) = .true.
        ComVal(2,6,1,2) = W
        Goto 55
      End If
      If ( Token.eq.'YYY' ) then
        If ( Op5(5) ) Goto 993
        Op5(5) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,7) = .true.
        ComStk(2,6,1,7) = .true.
        ComVal(2,6,1,7) = W
        Goto 55
      End If
      If ( Token.eq.'YZZ' ) then
        If ( Op5(6) ) Goto 993
        Op5(6) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,9) = .true.
        ComStk(2,6,1,9) = .true.
        ComVal(2,6,1,9) = W
        Goto 55
      End If
      If ( Token.eq.'XXZ' ) then
        If ( Op5(7) ) Goto 993
        Op5(8) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,3) = .true.
        ComStk(2,6,1,3) = .true.
        ComVal(2,6,1,3) = W
        Goto 55
      End If
      If ( Token.eq.'YYZ' ) then
        If ( Op5(9) ) Goto 993
        Op5(9) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,8) = .true.
        ComStk(2,6,1,8) = .true.
        ComVal(2,6,1,8) = W
        Goto 55
      End If
      If ( Token.eq.'ZZZ' ) then
        If ( Op5(10) ) Goto 993
        Op5(10) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,10) = .true.
        ComStk(2,6,1,10) = .true.
        ComVal(2,6,1,10) = W
        Goto 55
      End If
      If ( Token.eq.'XYZ' ) then
        If ( Op5(11) ) Goto 993
        Op5(11) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,6,1,5) = .true.
        ComStk(2,6,1,5) = .true.
        ComVal(2,6,1,5) = W
        Goto 55
      End If
      If ( Token.eq.'ORIG' ) then
        If ( Op5(12) ) Goto 993
        Op5(12) = .true.
        i1=5
        Read(Line(i1:i2),*,Err=991,End=991) X,Y,Z
        ComStk(2,6,2,0) = .true.
        ComStk(2,6,2,1) = .true.
        ComVal(2,6,2,1) = X
        ComStk(2,6,2,2) = .true.
        ComVal(2,6,2,2) = Y
        ComStk(2,6,2,3) = .true.
        ComVal(2,6,2,3) = Z
        Goto 55
      End If
      Goto 992
*
*---  Process the "EFGR" command --------------------------------------*
*
 60   Continue
      If ( Op0(6) ) Goto 993
      Op0(6) = .true.
 65   Temp2 = Temp1
      Temp1 = Line
      newline = newline+1
      Read(5,'(A)',Err=991,End=991) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 65
      Call UpCase(Line)
      Do i = 1,LEN(Line)
        If ( Line(i:i).eq.'=' ) Line(i:i) = ' '
        If ( Line(i:i).eq.CHAR(9) ) Line(i:i) = ' '
      End Do
      Call StdFmt(Line,Token)
      Do iCom=1,mCom
        If ( Token.eq.Com(iCom) ) Goto 2
      End Do
      i1 = 3
      i2 = LEN(Line)
      If ( Token.eq.'XX' ) then
        If ( Op6(1) ) Goto 993
        Op6(1) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,4,1,0) = .true.
        ComStk(2,4,1,1) = .true.
        ComVal(2,4,1,1) = W
        Goto 65
      End If
      If ( Token.eq.'YY' ) then
        If ( Op6(2) ) Goto 993
        Op6(2) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,4,1,0) = .true.
        ComStk(2,4,1,4) = .true.
        ComVal(2,4,1,4) = W
        Goto 65
      End If
      If ( Token.eq.'ZZ' ) then
        If ( Op6(3) ) Goto 993
        Op6(3) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,4,1,0) = .true.
        ComStk(2,4,1,6) = .true.
        ComVal(2,4,1,6) = W
        Goto 65
      End If
      If ( Token.eq.'XY' ) then
        If ( Op6(4) ) Goto 993
        Op6(4) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,4,1,0) = .true.
        ComStk(2,4,1,2) = .true.
        ComVal(2,4,1,2) = W
        Goto 65
      End If
      If ( Token.eq.'XZ' ) then
        If ( Op6(5) ) Goto 993
        Op6(5) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,4,1,0) = .true.
        ComStk(2,4,1,3) = .true.
        ComVal(2,4,1,3) = W
        Goto 65
      End If
      If ( Token.eq.'YZ' ) then
        If ( Op6(6) ) Goto 993
        Op6(6) = .true.
        Read(Line(i1:i2),*,Err=991,End=991) W
        ComStk(2,4,1,0) = .true.
        ComStk(2,4,1,5) = .true.
        ComVal(2,4,1,5) = W
        Goto 65
      End If
      If ( Token.eq.'ORIG' ) then
        If ( Op6(8) ) Goto 993
        Op6(8) = .true.
        i1=5
        Read(Line(i1:i2),*,Err=991,End=991) X,Y,Z
        ComStk(2,4,2,0) = .true.
        ComStk(2,4,2,1) = .true.
        ComVal(2,4,2,1) = X
        ComStk(2,4,2,2) = .true.
        ComVal(2,4,2,2) = Y
        ComStk(2,4,2,3) = .true.
        ComVal(2,4,2,3) = Z
        Goto 65
      End If
      Goto 992
*
*---  Process the "RELA" command --------------------------------------*
*
 70   Continue
      If ( Op0(7) ) Goto 993
      Op0(7) = .true.
 75   Temp2 = Temp1
      Temp1 = Line
      newline = newline+1
      Read(5,'(A)',Err=991,End=991) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 75
      i1 = 1
      i2 = LEN(Line)
      Read(Line(i1:i2),*,Err=991,End=991) W
      ComStk(2,5,0,0) = .true.
      ComStk(2,5,0,1) = .true.
      ComVal(2,5,0,1) = W
      Goto 1
*
*---  Process the "GLBL" command --------------------------------------*
*
 80   Continue
      If ( Op0(8) ) Goto 993
      Op0(8) = .true.
      ComStk(3,0,0,0)=.true.
 85   Temp2 = Temp1
      Temp1 = Line
      newline = newline+1
      Read(5,'(A)',Err=991,End=991) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 85
      Call UpCase(Line)
      Call StdFmt(Line,Token)
      Do iCom=1,mCom
        If ( Token.eq.Com(iCom) ) Goto 2
      End Do
      i1 = 1
      i2 = LEN(Line)
      mLbl = mLbl+1
      If ( mLbl.gt.MxLbl ) Goto 994
      iSta = INDEX(Line,'''')
      Line(i1:iSta) = ' '
      iEnd = INDEX(Line,'''')
      gLblN(mLbl) = Line(iSta+1:iEnd-1)
      Line(i1:iEnd) = ' '
      Read(Line(i1:i2),*,End=991) C,W
      gLblC(mLbl) = NINT(C)
      gLblW(mLbl) = W
      Do i = 1,mLbl-1
        If ( gLblN(i).eq.gLblN(mLbl)
     &      .and.
     &       gLblC(i).eq.gLblC(mLbl) ) Goto 993
      End Do
      Goto 85
*
*---  Process the "SELE" command --------------------------------------*
*
 90   Continue
*-- Initialize
      Do i=1,MxSets
        Atoms(i)=.false.
        Do j=1,MxSets
          Bonds(i,j)=.false.
        Enddo
      Enddo
      ComStk(4,0,0,0)=.true.
 95   Temp2=Temp1
      Temp1=Line
      newline=newline+1
      Read(5,'(A)',Err=991,End=991) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 95
      Read(Line,*)nSets
      Do i=1,nSets
        Read(5,*)Atoms(i),iSelection(1,i),iSelection(2,i)
      Enddo
      Do i=2,nSets
        If(i.lt.10) Write(FmtLog,79121)'(',i-1,'L2)'
        If(i.ge.10) Write(FmtLog,79122)'(',i-1,'L2)'
        Read(5,FmtLog)(Bonds(i,j),j=1,i-1)
        Do j=1,i-1
          Bonds(j,i)=Bonds(i,j)
        Enddo
      Enddo
      Read(5,*)(TranCoo(k),k=1,3)
*      Read(5,*)SiffBond
79121 Format(A,I1,A)
79122 Format(A,I2,A)
      Go to 1
*
*---  Process the "CUMU" command --------------------------------------*
*
 100  Continue
*     Add the perturbation to the current H0 instead of
*     to the vacuum H0. This enables multiple FFPT runs after eachother,
*     useful when using SELE.
      LCumulate=.True.
      Go to 1

*
*---  Process the "END " command --------------------------------------*
*
 1000 Continue
      If ( Op0(9) ) Goto 993
      Op0(9) = .true.
*      ComStk(4,0,0,0) = .true.
      ComStk(5,0,0,0) = .true.
*---  Check for redunancy in the origin input
      If ( ComStk(2,2,2,4) ) Then
         If ( ComStk(2,2,2,1) .or.
     &        ComStk(2,2,2,2) .or.
     &        ComStk(2,2,2,3)      ) Goto 996
      End If
      If ( ComStk(2,3,2,4) ) Then
         If ( ComStk(2,3,2,1) .or.
     &        ComStk(2,3,2,2) .or.
     &        ComStk(2,3,2,3)      ) Goto 996
      End If
      If ( ComStk(2,4,2,4) ) Then
         If ( ComStk(2,4,2,1) .or.
     &        ComStk(2,4,2,2) .or.
     &        ComStk(2,4,2,3)      ) Goto 996
      End If
      If ( ComStk(2,6,2,4) ) Then
         If ( ComStk(2,6,2,1) .or.
     &        ComStk(2,6,2,2) .or.
     &        ComStk(2,6,2,3)      ) Goto 996
      End If
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
*
*----------------------------------------------------------------------*
*     Error handling                                                   *
*----------------------------------------------------------------------*
*
 991  Write (6,*)
      Write(6,'(2X,A)') 'The program failed to read the input.'
      Write(6,'(2X,A)') 'Please check your input data.'
      Write(6,*)
      Write(6,'(2X,A,I3.3,A)') 'The error occured at line',newline,
     &                         ' after the &FFPT &END line'
      Write(6,'(2X,A,A)') 'The current line is:      ',Line
      Write(6,'(2X,A,A)') 'The previous line is:     ',Temp1
      Write(6,'(2X,A,A)') 'The next previous line is:',Temp2
      Call Quit_OnUserError
 992  Write (6,*)
      Write(6,'(2X,A)') 'The program has been supplied with an unknown'
      Write(6,'(2X,A)') 'keyword. Please correct your input data.'
      Write(6,*)
      Write(6,'(2X,A,I3.3,A)') 'The error occured at line',newline,
     &                         ' after the &FFPT &END line'
      Write(6,'(2X,A,A)') 'The current line is:      ',Line
      Write(6,'(2X,A,A)') 'The previous line is:     ',Temp1
      Write(6,'(2X,A,A)') 'The next previous line is:',Temp2
      Call Quit_OnUserError
 993  Write (6,*)
      Write(6,'(2X,A)') 'A command or one of its components has been'
      Write(6,'(2X,A)') 'multiply defined. Please correct your input.'
      Write(6,*)
      Write(6,'(2X,A,I3.3,A)') 'The error occured at line',newline,
     &                         ' after the &FFPT &END line'
      Write(6,'(2X,A,A)') 'The current line is:      ',Line
      Write(6,'(2X,A,A)') 'The previous line is:     ',Temp1
      Write(6,'(2X,A,A)') 'The next previous line is:',Temp2
      Call Quit_OnUserError
 994  Write (6,*)
      Write(6,'(2X,A)') 'The number of perturbations requested exceeds'
      Write(6,'(2X,A)') 'the internal buffer size. Increase the para-'
      Write(6,'(2X,A)') 'meter MxLbl and recompile the program.'
      Call Quit_OnUserError
 996  Write (6,*)
      Write(6,'(2X,A)') 'The definition of the origin of an operator '
      Write(6,'(2X,A)') 'is not unique.  Please correct your input.'
      Call Quit_OnUserError
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine Get_Nat_Lorb(Occ,FOcc,nO,nX,jOrb,Umat)

#include "intent.fh"

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Occ(*)
real(kind=wp), intent(_OUT_) :: FOcc(*)
real(kind=wp), intent(inout) :: Umat(*)
integer(kind=iwp), intent(in) :: nO, nX, jOrb(nO)
integer(kind=iwp) :: i, ii, j, nOx, nXx
real(kind=wp), allocatable :: eta(:), Z(:), ZZ(:)

if (nO < 1) return

call mma_allocate(eta,nX**2,label='eta_ik')
call mma_allocate(Z,nX**2,label='Z')
call mma_allocate(ZZ,nX,label='ZZ')
eta(:) = Zero
do i=1,nX
  ii = nX*(i-1)+i
  eta(ii) = Occ(i)
end do
nXx = max(1,nX)
nOx = max(1,nO)
call DGEMM_('N','N',nX,nO,nX,One,eta,nXx,Umat,nXx,Zero,Z,nXx)
call DGEMM_('T','N',nO,nO,nX,One,Umat,nXx,Z,nXx,Zero,eta,nOx)

call Eigen_Molcas(nO,eta,ZZ,Z)

call dcopy_(nO**2,eta,1,Umat,1)
do i=1,nO
  j = jOrb(i)
  FOcc(j) = ZZ(i)
end do
call mma_deallocate(eta)
call mma_deallocate(Z)
call mma_deallocate(ZZ)

return

end subroutine Get_Nat_Lorb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine diish1(wrk,wrksize,nind,rdiis1,v1,v2,v3,v4,ndiis,szkey)
! this routine upgrades rdiis1(p,q) matrix
! rdiis1(p,q) = szkey*rdiis1(p,q) + (xp|xq)
!
! nind   - number of indices in vectors (i)
! rdiis1 - overlap matrix of 1-4 vectors (O)
! v1     - map type of vector 1 (i)
! v2     - map type of vector 1 (i)
! v3     - map type of vector 1 (i)
! v4     - map type of vector 1 (i)
! if there is less than 4 vectors, use any map
! ndiis  - dimension of DIIS (2-4) (I)
! szkey  - 0 - no vanishing rdiis1 at the beginning
!          1 - vanishing rdiis1 at the beginning

use ccsd_global, only: Map_Type
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, nind, ndiis, szkey
real(kind=wp), intent(in) :: wrk(wrksize)
real(kind=wp), intent(inout) :: rdiis1(4,4)
type(Map_Type), intent(in) :: v1, v2, v3, v4
integer(kind=iwp) :: num, rc
real(kind=wp) :: scalar

num = ndiis+1

if (szkey == 1) rdiis1(:,:) = Zero

if (num > 0) then
  ! calc X11
  call multdot(wrk,wrksize,nind,v1,1,v1,1,scalar,rc)
  rdiis1(1,1) = rdiis1(1,1)+scalar
end if

if (num > 1) then
  ! X21
  call multdot(wrk,wrksize,nind,v2,1,v1,1,scalar,rc)
  rdiis1(2,1) = rdiis1(2,1)+scalar
  rdiis1(1,2) = rdiis1(1,2)+scalar
  ! X22
  call multdot(wrk,wrksize,nind,v2,1,v2,1,scalar,rc)
  rdiis1(2,2) = rdiis1(2,2)+scalar
end if

if (num > 2) then
  ! X31
  call multdot(wrk,wrksize,nind,v3,1,v1,1,scalar,rc)
  rdiis1(3,1) = rdiis1(3,1)+scalar
  rdiis1(1,3) = rdiis1(1,3)+scalar
  ! X32
  call multdot(wrk,wrksize,nind,v3,1,v2,1,scalar,rc)
  rdiis1(3,2) = rdiis1(3,2)+scalar
  rdiis1(2,3) = rdiis1(2,3)+scalar
  ! X33
  call multdot(wrk,wrksize,nind,v3,1,v3,1,scalar,rc)
  rdiis1(3,3) = rdiis1(3,3)+scalar
end if

if (num > 3) then
  ! X41
  call multdot(wrk,wrksize,nind,v4,1,v1,1,scalar,rc)
  rdiis1(4,1) = rdiis1(4,1)+scalar
  rdiis1(1,4) = rdiis1(1,4)+scalar
  ! X42
  call multdot(wrk,wrksize,nind,v4,1,v2,1,scalar,rc)
  rdiis1(4,2) = rdiis1(4,2)+scalar
  rdiis1(2,4) = rdiis1(2,4)+scalar
  ! X43
  call multdot(wrk,wrksize,nind,v4,1,v3,1,scalar,rc)
  rdiis1(4,3) = rdiis1(4,3)+scalar
  rdiis1(3,4) = rdiis1(3,4)+scalar
  ! X44
  call multdot(wrk,wrksize,nind,v4,1,v4,1,scalar,rc)
  rdiis1(4,4) = rdiis1(4,4)+scalar
end if

return

end subroutine diish1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine qbess( alpha,      apwr,       aterm1,     aterm2,
     &      binom,      bpref,      bpwr,       bterm1,     dfac,
     &      l,          lambu,      lmahi,      lmbhi,      ltot1,
     &      nu,         prd,        qsum,       rka,        rkb,
     &      ssi )
c
c  compute type 2 radial integrals, scaled by exp(-arc2)/sqrt(pi),
c  using the bessel function formula for
c  lama=max(l,nu) to lmahi, lamb=max(l,nu) to lmbhi, n=lama+lamb-l-l
c
      implicit real*8 (a-h,o-z)
      parameter (a0=0.0d0, a1=1.0d0, a2=2.0d0, a4=4.0d0)
      dimension apwr(*), aterm1(*), aterm2(*), binom(*), bpref(*),
     &  bpwr(*), bterm1(*), dfac(*), qsum(ltot1,lambu,*), ssi(*)
c
c     nu=l+1-npi/2
c     # bessel function formula applies to all npi=2 cases, no npi=1
c     # cases, and some npi=0 cases.
      num1=nu-1
      lmlo=max(l,nu)
      lmaphi=lmahi-num1
      lmbphi=lmbhi-num1
      fcta=rka/(alpha+alpha)
      fct=rka*fcta
      fctb=rkb/(alpha+alpha)
      bpref(1)=fctb**num1
      do 24 lambp=2,lmbphi
        bpref(lambp)=fctb*bpref(lambp-1)
   24 continue
      apwr(1)=a1
      apwr(2)=fct
      do 28 lambp=3,lmbphi
        apwr(lambp)=fct*apwr(lambp-1)
   28 continue
      fct=rkb*fctb
      bpwr(1)=a1
      bpwr(2)=fct
      do 32 lamap=3,lmaphi
        bpwr(lamap)=fct*bpwr(lamap-1)
   32 continue
      lmihi=lmaphi+lmbphi+(nu-2)
      call ssibfn(lmihi-1,rka*fctb,ssi)
      do 36 lami=1,lmihi
        ssi(lami)=ssi(lami)/dfac(lami+lami-1)
   36 continue
      lmplo=lmlo-num1
      fctra=(alpha+alpha)**(nu-2)*fcta**(lmlo-1)*prd/sqrt(a4*alpha)*
     &  ((dfac(2*(2*lmplo+num1)-1)/dfac(2*(lmplo+num1)+1))*
     &  dfac(2*num1+1))/dfac(2*(lmplo+num1)+1)
      fctran=(2*(2*lmplo+num1)-1)
      fctrad=(2*(lmplo+num1)+1)
      do 64 lamap=lmplo,lmaphi
        fctru=a1
        fctrun=(nu+num1)
        fctrud=(2*(lamap+num1)+1)
        do 40 iu=1,lmbphi
          aterm1(iu)=fctru*apwr(iu)
          fctru=fctru*fctrun/fctrud
          fctrun=fctrun+a2
          fctrud=fctrud+a2
   40   continue
        do 44 it=1,lamap
          bterm1(it)=binom((lamap*(lamap-1))/2+it)*bpwr(it)
   44   continue
        fctrb=fctra
        fctrbn=(2*(lamap+lmplo+num1)-1)
        fctrbd=(2*(lmplo+num1)+1)
        do 60 lambp=lmplo,lmbphi
          n=((2*(nu-l)-1)+lamap)+lambp
          do 48 iu=1,lambp
            aterm2(iu)=binom((lambp*(lambp-1))/2+iu)*aterm1(iu)
   48     continue
          sum=a0
          fctrt=a1
          fctrtn=(nu+num1)
          fctrtd=(2*(lambp+num1)+1)
          do 56 it=1,lamap
            do 52 iu=1,lambp
              sum=sum+aterm2(iu)*(fctrt*bterm1(it))*
     &          ssi((it+(nu-2))+iu)
   52       continue
            fctrt=fctrt*fctrtn/fctrtd
            fctrtn=fctrtn+a2
            fctrtd=fctrtd+a2
   56     continue
          qsum(n,lambp+num1,lamap+num1)=qsum(n,lambp+num1,lamap+num1)+
     &      fctrb * bpref(lambp) * sum
          fctrb=fctrb*fctrbn/fctrbd
          fctrbn=fctrbn+a2
          fctrbd=fctrbd+a2
   60   continue
        fctra=fcta*fctra*fctran/fctrad
        fctran=fctran+a2
        fctrad=fctrad+a2
   64 continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FMAT_CHO(CMO,NCMO,FFAO,FIAO,FAAO,HONE,NHONE,FIMO,NFIMO,
     &                                                       FAMO,NFAMO)
      use definitions, only: iwp, wp
#ifdef _DEBUGPRINT_
      use definitions, only: u6
#endif
      use constants, only: Zero, One
      use caspt2_global, only: FIFA, DREF
      use caspt2_global, only: LUONEM
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NBTRI, EASUM, IEOF1M, notri, NSYM, NBAS,
     &                         NORB, NFRO, IAD1M, NISH, NASH, EPS, EPSI,
     &                         EPSA, EPSE, NAES
#ifdef _DEBUGPRINT_
      use caspt2_module, only: NASHT, NISHT, NORBT, NSSHT
#endif
      IMPLICIT None
      integer(kind=iwp), intent(in):: NCMO, NHONE, NFIMO, NFAMO
      real(kind=wp), intent(in):: CMO(NCMO)
      real(kind=wp), intent(in):: FFAO(NBTRI),FIAO(NBTRI),FAAO(NBTRI)
      real(kind=wp), intent(out):: HONE(NHONE),FIMO(NFIMO),FAMO(NFAMO)

      real(kind=wp), allocatable:: SCR1(:), SCR2(:), SCR3(:)
      real(kind=wp) E
      integer(kind=iwp) I, ID, IDISK, IEPS, IEPSA, IEPSE, IEPSI, IFAO,
     &                  IJ, IOFMO, ISTLT, ISYM, ITOT, J, LSC, LSCI,
     &                  NA, NB, NBBMX, NBBT, NBOMX, NF, NI, NO, NO_X,
     &                  NOOMX

C THIS ROUTINE IS USED IF THE TWO-ELECTRON INTEGRALS ARE
C REPRESENTED BY CHOLESKY VECTORS:
C TRANSFORM FOCK MATRICES COMPUTED BY TRACHO
C TO MO BASIS FOR USE IN CASPT2.



      NBBT=0
      NBBMX=0
      NBOMX=0
      NOOMX=0
      DO ISYM=1,NSYM
       NB=NBAS(ISYM)
       NO=NORB(ISYM)
       NBBT=NBBT+(NB*(NB+1))/2
       NBBMX=MAX(NBBMX,NB*NB)
       NBOMX=MAX(NBOMX,NB*NO)
       NOOMX=MAX(NOOMX,NO*NO)
      END DO

      CALL mma_allocate(SCR1,NBBMX,LABEL='SCR1')
      CALL mma_allocate(SCR2,NBOMX,LABEL='SCR2')
      CALL mma_allocate(SCR3,NOOMX,LABEL='SCR3')

      IFAO=1
      IOFMO=0
      LSC=1
      DO ISYM=1,NSYM
       NB=NBAS(ISYM)
       If (NB.eq.0) CYCLE
       NO=NORB(ISYM)
       NO_X = Max(1,NO)
       NF=NFRO(ISYM)
       LSCI=LSC+NF*NB
* The frozen Fock matrix:
       CALL SQUARE(FFAO(IFAO),SCR1,NB,1,NB)
       CALL DGEMM_('N','N',NB,NO,NB, One,SCR1,NB,
     &            CMO(LSCI),NB,Zero,SCR2,NB)
       CALL DGEMM_('T','N',NO,NO,NB, One,CMO(LSCI),NB,
     &            SCR2,NB,Zero,SCR3,NO_X)
       IJ=0
       DO I=1,NO
        DO J=1,I
         IJ=IJ+1
         HONE(IOFMO+IJ)=SCR3(I+NO*(J-1))
        END DO
       END DO
* The inactive Fock matrix:
       CALL SQUARE(FIAO(IFAO),SCR1,NB,1,NB)
       CALL DGEMM_('N','N',NB,NO,NB, One,SCR1,NB,
     &            CMO(LSCI),NB,Zero,SCR2,NB)
       CALL DGEMM_('T','N',NO,NO,NB, One,CMO(LSCI),NB,
     &            SCR2,NB,Zero,SCR3,NO_X)
       IJ=0
       DO I=1,NO
        DO J=1,I
         IJ=IJ+1
         FIMO(IOFMO+IJ)=SCR3(I+NO*(J-1))
        END DO
       END DO
* The active Fock matrix:
       CALL SQUARE(FAAO(IFAO),SCR1,NB,1,NB)
       CALL DGEMM_('N','N',NB,NO,NB, One,SCR1,NB,
     &            CMO(LSCI),NB,Zero,SCR2,NB)
       CALL DGEMM_('T','N',NO,NO,NB, One,CMO(LSCI),NB,
     &            SCR2,NB,Zero,SCR3,NO_X)
       IJ=0
       DO I=1,NO
        DO J=1,I
         IJ=IJ+1
         FAMO(IOFMO+IJ)=SCR3(I+NO*(J-1))
        END DO
       END DO
       IFAO=IFAO+(NB*(NB+1))/2
       IOFMO=IOFMO+(NO*(NO+1))/2
       LSC=LSC+NB**2
      END DO

      CALL mma_deallocate(SCR1)
      CALL mma_deallocate(SCR2)
      CALL mma_deallocate(SCR3)

c Transformed frozen Fock matrix = Effective one-electron
* Hamiltonian HONE at IAD1M(3)
      IDISK=IEOF1M
      IAD1M(3)=IDISK
      CALL DDAFILE(LUONEM,1,HONE,notri,IDISK)
      IEOF1M=IDISK

      CALL DAXPY_(notri,One,HONE,1,FIMO,1)
      CALL DCOPY_(NOTRI,FIMO,1,FIFA,1)
      CALL DAXPY_(notri,One,FAMO,1,FIFA,1)

c   Orbital energies, EPS, EPSI,EPSA,EPSE:
      IEPS=0
      IEPSI=0
      IEPSA=0
      IEPSE=0
      ISTLT=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NO=NORB(ISYM)
        DO I=1,NI
          E=FIFA(ISTLT+(I*(I+1))/2)
          IEPS=IEPS+1
          EPS(IEPS)=E
          IEPSI=IEPSI+1
          EPSI(IEPSI)=E
        END DO
        DO I=NI+1,NI+NA
          E=FIFA(ISTLT+(I*(I+1))/2)
          IEPS=IEPS+1
          EPS(IEPS)=E
          IEPSA=IEPSA+1
          EPSA(IEPSA)=E
        END DO
        DO I=NI+NA+1,NO
          E=FIFA(ISTLT+(I*(I+1))/2)
          IEPS=IEPS+1
          EPS(IEPS)=E
          IEPSE=IEPSE+1
          EPSE(IEPSE)=E
        END DO
        ISTLT=ISTLT+(NO*(NO+1))/2
      END DO

C EASUM=CONTRACT EPSA WITH DIAGONAL OF ACTIVE DENS
C This is never used anywhere, and it is actually
C wrong in XMS, since the DREF used is not the average
C density.
      EASUM=Zero
      DO ISYM=1,NSYM
        NA=NASH(ISYM)
        DO I=1,NA
          ITOT=NAES(ISYM)+I
          ID=(ITOT*(ITOT+1))/2
          EASUM=EASUM+EPSA(ITOT)*DREF(ID)
        END DO
      END DO

#ifdef _DEBUGPRINT_
        WRITE(6,*)'      INACTIVE FOCK MATRIX IN MO BASIS'
        ISTLT=1
        DO ISYM=1,NSYM
          NO=NORB(ISYM)
          IF ( NO.GT.0 ) THEN
            WRITE(6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
            CALL TRIPRT(' ',' ',FIMO(ISTLT),NO)
            ISTLT=ISTLT+(NO*(NO+1))/2
          END IF
        END DO

        WRITE(6,*)'        ACTIVE FOCK MATRIX IN MO BASIS'
        ISTLT=1
        DO ISYM=1,NSYM
          NO=NORB(ISYM)
          IF ( NO.GT.0 ) THEN
            WRITE(6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
            CALL TRIPRT(' ',' ',FAMO(ISTLT),NO)
            ISTLT=ISTLT+(NO*(NO+1))/2
          END IF
        END DO

        WRITE(6,*)'      TOTAL FOCK MATRIX IN MO BASIS'
        ISTLT=1
        DO ISYM=1,NSYM
          IF ( NORB(ISYM).GT.0 ) THEN
            WRITE(6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
            CALL TRIPRT(' ',' ',FIFA(ISTLT),NORB(ISYM))
            ISTLT=ISTLT+NORB(ISYM)*(NORB(ISYM)+1)/2
          END IF
        END DO

        WRITE(u6,*)
        WRITE(u6,*)'      ORBITAL ENERGIES, EPS:'
        WRITE(u6,'(1X,5F12.6)')(EPS(I),I=1,NORBT)
        WRITE(u6,*)'      INACTIVE ORBITAL ENERGIES, EPSI:'
        WRITE(u6,'(1X,5F12.6)')(EPSI(I),I=1,NISHT)
        WRITE(u6,*)'        ACTIVE ORBITAL ENERGIES, EPSA:'
        WRITE(u6,'(1X,5F12.6)')(EPSA(I),I=1,NASHT)
        WRITE(u6,*)'      EXTERNAL ORBITAL ENERGIES, EPSE:'
        WRITE(u6,'(1X,5F12.6)')(EPSE(I),I=1,NSSHT)
#endif

      END SUBROUTINE FMAT_CHO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION GETH1E(IORB,ITP,ISM,JORB,JTP,JSM)
*
* One-electron integral for active
* orbitals (IORB,ITP,ISM),(JORB,JTP,JSM)
*
* The orbital symmetries are used to obtain the
* total symmetry of the operator
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "glbbas.fh"
#include "lucinp.fh"
#include "orbinp.fh"
#include "multd2h.fh"
#include "intform.fh"
#include "oper.fh"
*
      IJSM = MULTD2H(ISM,JSM)
      GETH1E = 0.0D0
      IF(IH1FORM.EQ.1) THEN
*. Normal integrals, lower triangular packed
        IF(IJSM.EQ.1) THEN
C?        WRITE(6,*) ' GETH1E, old route '
          GETH1E =
     &    GTH1ES(IREOTS,iWORK(KPINT1),WORK(KINT1),IBSO,MXPNGAS,
     &              IOBPTS,NACOBS,IORB,ITP,ISM,JORB,JTP,JSM,1)
        ELSE
          GETH1E =
     &    GTH1ES(IREOTS,iWORK(KPGINT1(IJSM)),WORK(KINT1),IBSO,MXPNGAS,
     &              IOBPTS,NACOBS,IORB,ITP,ISM,JORB,JTP,JSM,1)
        END IF
      ELSE
*. Integrals are in full blocked form
        GETH1E =
     &  GTH1ES(IREOTS,iWORK(KPGINT1A(IJSM)),WORK(KINT1),IBSO,MXPNGAS,
     &         IOBPTS,NACOBS,IORB,ITP,ISM,JORB,JTP,JSM,0)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine DerCtr(ldot,JfGrd,IndGrd,JfHss,IndHss,JfG,nSD,iSD4)

use McKinley_global, only: sIrrep
use Index_Functions, only: iTri
use Disp, only: IndDsp
use Symmetry_Info, only: nIrrep
use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: ldot
logical(kind=iwp), intent(out) :: JfGrd(3,4), JfHss(4,3,4,3), JfG(4)
integer(kind=iwp), intent(out) :: IndGrd(3,4,0:7), IndHss(4,3,4,3,0:7)
integer(kind=iwp), intent(in) :: nSD, iSD4(0:nSD,4)
integer(kind=iwp) :: iAtom, ic1, ic2, iCar, iComp, ii, iIrrep, ij, istop, jAtom, jCar, JndGrd(3,4,0:7), mdci, mdcj, mdck, mdcl, &
                     nDisp, nnIrrep
logical(kind=iwp) :: IfG(4), IfGrd(3,4), IfHss(4,3,4,3)
logical(kind=iwp), external :: TF

mdci = iSD4(10,1)
mdcj = iSD4(10,2)
mdck = iSD4(10,3)
mdcl = iSD4(10,4)

nnIrrep = nIrrep
IfGrd(:,:) = .false.
if (sIrrep) nnIrrep = 1

do iIrrep=0,nnIrrep-1
  nDisp = IndDsp(mdci,iIrrep)
  do iCar=0,2
    iComp = 2**iCar
    if (TF(mdci,iIrrep,iComp)) then
      nDisp = nDisp+1
      IndGrd(iCar+1,1,iIrrep) = nDisp
      IfGrd(iCar+1,1) = .true.
    else
      IndGrd(iCar+1,1,iIrrep) = 0
    end if
  end do
end do
do iIrrep=0,nnIrrep-1
  nDisp = IndDsp(mdcj,iIrrep)
  do iCar=0,2
    iComp = 2**iCar
    if (TF(mdcj,iIrrep,iComp)) then
      nDisp = nDisp+1
      IndGrd(iCar+1,2,iIrrep) = nDisp
      IfGrd(iCar+1,2) = .true.
    else
      IndGrd(iCar+1,2,iIrrep) = 0
    end if
  end do
end do
do iIrrep=0,nnIrrep-1
  nDisp = IndDsp(mdck,iIrrep)
  do iCar=0,2
    iComp = 2**iCar
    if (TF(mdck,iIrrep,iComp)) then
      nDisp = nDisp+1
      IndGrd(iCar+1,3,iIrrep) = nDisp
      IfGrd(iCar+1,3) = .true.
    else
      IndGrd(iCar+1,3,iIrrep) = 0
    end if
  end do
end do
do iIrrep=0,nnIrrep-1
  nDisp = IndDsp(mdcl,iIrrep)
  do iCar=0,2
    iComp = 2**iCar
    if (TF(mdcl,iIrrep,iComp)) then
      nDisp = nDisp+1
      IndGrd(iCar+1,4,iIrrep) = nDisp
      IfGrd(iCar+1,4) = .true.
    else
      IndGrd(iCar+1,4,iIrrep) = 0
    end if
  end do
end do
JndGrd(:,:,0:nnIrrep-1) = IndGrd(:,:,0:nnIrrep-1)
JfGrd(:,:) = IfGrd(:,:)
IndHss(:,:,:,:,0:nirrep-1) = 0
IfHss(:,:,:,:) = .false.
JfHss(:,:,:,:) = .false.
if (.not. ldot) return

do iAtom=1,4
  do jAtom=1,iAtom

    ! Calculate the index for the derivative

    do iIrrep=0,nnIrrep-1
      do iCar=1,3
        if (iAtom == jAtom) then
          iStop = iCar
        else
          iStop = 3
        end if
        do jCar=1,iStop
          IfHss(iAtom,iCar,jAtom,jCar) = .true.
          if ((jndGrd(iCar,iAtom,iIrrep) > 0) .and. (jndGrd(jCar,jAtom,iIrrep) > 0)) then
            IndHss(iAtom,iCar,jAtom,jCar,iIrrep) = iTri(JndGrd(iCar,iAtom,iIrrep),JndGrd(jCar,jAtom,iIrrep))
          else
            IndHss(iAtom,iCar,jAtom,jCar,iIrrep) = 0
          end if
        end do
      end do
    end do
  end do
end do

! Scramble the control array for the hessian

IfG(:) = .true.
do iAtom=1,4
  JfG(iAtom) = IfG(iAtom)
  do jAtom=1,iAtom
    do iCar=1,3
      if (iAtom == jAtom) then
        iStop = iCar
      else
        iStop = 3
      end if
      if (iAtom >= jAtom) then
        JfHss(iAtom,iCar,jAtom,1:iStop) = IfHss(iAtom,iCar,jAtom,1:iStop)
      else if (iAtom < jAtom) then
        JfHss(iAtom,iCar,jAtom,1:iStop) = IfHss(jAtom,1:iStop,iAtom,iCar)
      end if
    end do
  end do
end do
if (sIrrep) then
  do ii=1,4
    do ic1=1,3
      if (IndGrd(ic1,ii,0) == 0) JfGrd(ic1,ii) = .false.
      do ij=1,4
        do ic2=1,3
          if (IndHss(ii,ic1,ij,ic2,0) == 0) JfHss(ii,ic1,ij,ic2) = .false.
        end do
      end do
    end do
  end do
end if
!----------------------------------------------------------------------*
!
!  End Hess
!
!----------------------------------------------------------------------*

end subroutine DerCtr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Map2_21_t3(A,B,d1,d2)
! this routine does:
! map B(21) <- A(12)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: d1, d2
real(kind=wp), intent(in) :: A(d1,d2)
real(kind=wp), intent(out) :: B(d2,d1)
integer(kind=iwp) :: i1

do i1=1,d1
  B(:,i1) = A(i1,:)
end do

return

end subroutine Map2_21_t3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine recover_exch_HAM_from_Naoya_ITO(n1,n2,J,HAM)
      Implicit none
      Integer, Parameter            :: wp=selected_real_kind(p=15,r=307)
#include "stdalloc.fh"
      Integer, intent(in)           :: n1, n2
      Complex(kind=8), intent(in)  ::
     &     J( (n1-1), -(n1-1):(n1-1), (n2-1), -(n2-1):(n2-1) )
      Complex(kind=8),intent(out)  :: HAM(n1,n1,n2,n2)
      ! local variables:
      Integer                       :: k1,k2,q1,q2,m1,m2,l1,l2
      Real(kind=8)                 :: C01,C02
      Complex(kind=8), allocatable :: O1(:,:), O2(:,:),
     &                                 W1(:,:), W2(:,:)
      Complex(kind=8), allocatable :: OO(:,:,:,:), WW(:,:,:,:),
     &                                 OW(:,:,:,:), WO(:,:,:,:)
!---------------------------------------------------------------------
!  recover the original HAMILTONIAN using the J parameters
!==================================================================
      Call mma_allocate(O1,n1,n1,'operator O1')
      Call mma_allocate(O2,n2,n2,'operator O2')
      Call mma_allocate(W1,n1,n1,'operator W1')
      Call mma_allocate(W2,n2,n2,'operator W2')
      Call mma_allocate(OO,n1,n1,n2,n2,'operator OO')
      Call mma_allocate(OW,n1,n1,n2,n2,'operator WO')
      Call mma_allocate(WO,n1,n1,n2,n2,'operator OW')
      Call mma_allocate(WW,n1,n1,n2,n2,'operator WW')
      Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,HAM,1)
      Do k1=1,n1-1
       Do q1=0,k1
        Do k2=1,n2-1
         Do q2=0,k2
          ! generate the operator matrix K=ik, Q=iq, dimension=na
          Call ITO(n1,k1,q1,C01,O1,W1)
          Call ITO(n2,k2,q2,C02,O2,W2)
          !generate coupled operators:
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,OO,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,OW,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,WO,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,WW,1)
          Do m1=1,n1
           Do m2=1,n1
            Do l1=1,n2
             Do l2=1,n2
               OO(m1,m2,l1,l2) = O1(m1,m2) * O2(l1,l2)
               OW(m1,m2,l1,l2) = O1(m1,m2) * W2(l1,l2)
               WO(m1,m2,l1,l2) = W1(m1,m2) * O2(l1,l2)
               WW(m1,m2,l1,l2) = W1(m1,m2) * W2(l1,l2)
             End Do
            End Do
           End Do
          End Do !m1
          ! compute the exchange Hamiltonian:
          If((q1==0).and.(q2==0)) Then
           Call zaxpy_(n1*n1*n2*n2,J(k1,  0,k2,  0),OO,1,HAM,1)
          Else If ((q1==0).and.(q2.ne.0)) Then
           Call zaxpy_(n1*n1*n2*n2,J(k1,  0,k2, q2),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1,  0,k2,-q2),OW,1,HAM,1)
          Else If ((q1.ne.0).and.(q2==0)) Then
           Call zaxpy_(n1*n1*n2*n2,J(k1, q1,k2,  0),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1,-q1,k2,  0),WO,1,HAM,1)
          Else If ((q1.ne.0).and.(q2.ne.0)) Then
           Call zaxpy_(n1*n1*n2*n2,J(k1, q1,k2, q2),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1, q1,k2,-q2),OW,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1,-q1,k2, q2),WO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1,-q1,k2,-q2),WW,1,HAM,1)
          End If
         End Do !q
        End Do !k
       End Do !q
      End Do !k

      Call mma_deallocate(O1)
      Call mma_deallocate(O2)
      Call mma_deallocate(W1)
      Call mma_deallocate(W2)
      Call mma_deallocate(OO)
      Call mma_deallocate(OW)
      Call mma_deallocate(WO)
      Call mma_deallocate(WW)

      Return
      End Subroutine recover_exch_HAM_from_Naoya_ITO





      Subroutine recover_exch_HAM_from_Liviu_ITO(n1,n2,B,HAM)
      Implicit none
      Integer, Parameter            :: wp=selected_real_kind(p=15,r=307)
#include "stdalloc.fh"
      Integer, intent(in)           :: n1, n2
      Complex(kind=8), intent(in)  ::
     &     B( (n1-1), -(n1-1):(n1-1), (n2-1), -(n2-1):(n2-1) )
      Complex(kind=8),intent(out)  :: HAM(n1,n1,n2,n2)
      ! local variables:
      Integer                       :: k1,k2,q1,q2,m1,m2,l1,l2
      Complex(kind=8)              :: redME1,redME2
      Complex(kind=8), allocatable :: O1(:,:), O2(:,:),
     &                                 W1(:,:), W2(:,:)
      Complex(kind=8), allocatable :: OO(:,:,:,:), WW(:,:,:,:),
     &                                 OW(:,:,:,:), WO(:,:,:,:)

!---------------------------------------------------------------------
!  recover the original HAMILTONIAN using the J parameters
!==================================================================
      Call mma_allocate(O1,n1,n1,'operator O1')
      Call mma_allocate(O2,n2,n2,'operator O2')
      Call mma_allocate(W1,n1,n1,'operator W1')
      Call mma_allocate(W2,n2,n2,'operator W2')
      Call mma_allocate(OO,n1,n1,n2,n2,'operator OO')
      Call mma_allocate(OW,n1,n1,n2,n2,'operator WO')
      Call mma_allocate(WO,n1,n1,n2,n2,'operator OW')
      Call mma_allocate(WW,n1,n1,n2,n2,'operator WW')
      Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,HAM,1)
      Do k1=1,n1-1
       Do q1=0,k1
        Do k2=1,n2-1
         Do q2=0,k2
          ! generate the operator matrix K=ik, Q=iq, dimension=na
          Call Liviu_ITO(n1,k1,q1,O1,W1,redME1)
          Call Liviu_ITO(n2,k2,q2,O2,W2,redME2)
          !generate coupled operators:
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,OO,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,OW,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,WO,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,WW,1)
          Do m1=1,n1
           Do m2=1,n1
            Do l1=1,n2
             Do l2=1,n2
               OO(m1,m2,l1,l2) = O1(m1,m2) * O2(l1,l2)
               OW(m1,m2,l1,l2) = O1(m1,m2) * W2(l1,l2)
               WO(m1,m2,l1,l2) = W1(m1,m2) * O2(l1,l2)
               WW(m1,m2,l1,l2) = W1(m1,m2) * W2(l1,l2)
             End Do
            End Do
           End Do
          End Do !m1
          ! compute the exchange Hamiltonian:
          If((q1==0).and.(q2==0)) Then
           Call zaxpy_(n1*n1*n2*n2,B(k1,  0,k2,  0),OO,1,HAM,1)
          Else If ((q1==0).and.(q2.ne.0)) Then
           Call zaxpy_(n1*n1*n2*n2,B(k1,  0,k2, q2),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,B(k1,  0,k2,-q2),OW,1,HAM,1)
          Else If ((q1.ne.0).and.(q2==0)) Then
           Call zaxpy_(n1*n1*n2*n2,B(k1, q1,k2,  0),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,B(k1,-q1,k2,  0),WO,1,HAM,1)
          Else If ((q1.ne.0).and.(q2.ne.0)) Then
           Call zaxpy_(n1*n1*n2*n2,B(k1, q1,k2, q2),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,B(k1, q1,k2,-q2),OW,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,B(k1,-q1,k2, q2),WO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,B(k1,-q1,k2,-q2),WW,1,HAM,1)
          End If
         End Do !q
        End Do !k
       End Do !q
      End Do !k

      Call mma_deallocate(O1)
      Call mma_deallocate(O2)
      Call mma_deallocate(W1)
      Call mma_deallocate(W2)
      Call mma_deallocate(OO)
      Call mma_deallocate(OW)
      Call mma_deallocate(WO)
      Call mma_deallocate(WW)

      Return
      End Subroutine recover_exch_HAM_from_Liviu_ITO






      Subroutine recover_exch_HAM_from_Stevens_ESO(n1,n2,S,HAM)
      Implicit none
      Integer, Parameter            :: wp=selected_real_kind(p=15,r=307)
#include "stdalloc.fh"
      Integer, intent(in)           :: n1, n2
      Complex(kind=8), intent(in)  ::
     &     S( (n1-1), -(n1-1):(n1-1), (n2-1), -(n2-1):(n2-1) )
      Complex(kind=8),intent(out)  :: HAM(n1,n1,n2,n2)
      ! local variables:
      Integer                       :: k1,k2,q1,q2,m1,m2,l1,l2
      Complex(kind=8)              :: redME1,redME2
      Complex(kind=8), allocatable :: O1(:,:), O2(:,:),
     &                                 W1(:,:), W2(:,:)
      Complex(kind=8), allocatable :: OO(:,:,:,:), WW(:,:,:,:),
     &                                 OW(:,:,:,:), WO(:,:,:,:)

!---------------------------------------------------------------------
!  recover the original HAMILTONIAN using the S parameters
!==================================================================
      Call mma_allocate(O1,n1,n1,'operator O1')
      Call mma_allocate(O2,n2,n2,'operator O2')
      Call mma_allocate(W1,n1,n1,'operator W1')
      Call mma_allocate(W2,n2,n2,'operator W2')
      Call mma_allocate(OO,n1,n1,n2,n2,'operator OO')
      Call mma_allocate(OW,n1,n1,n2,n2,'operator WO')
      Call mma_allocate(WO,n1,n1,n2,n2,'operator OW')
      Call mma_allocate(WW,n1,n1,n2,n2,'operator WW')
      Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,HAM,1)
      Do k1=1,n1-1
       Do q1=0,k1
        Do k2=1,n2-1
         Do q2=0,k2
          ! generate the operator matrix K=ik, Q=iq, dimension=na
          Call ESO(n1,k1,q1,O1,W1,redME1)
          Call ESO(n2,k2,q2,O2,W2,redME2)
          !generate coupled operators:
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,OO,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,OW,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,WO,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,WW,1)
          Do m1=1,n1
           Do m2=1,n1
            Do l1=1,n2
             Do l2=1,n2
               OO(m1,m2,l1,l2) = O1(m1,m2) * O2(l1,l2)
               OW(m1,m2,l1,l2) = O1(m1,m2) * W2(l1,l2)
               WO(m1,m2,l1,l2) = W1(m1,m2) * O2(l1,l2)
               WW(m1,m2,l1,l2) = W1(m1,m2) * W2(l1,l2)
             End Do
            End Do
           End Do
          End Do !m1
          ! compute the exchange Hamiltonian:
          If((q1==0).and.(q2==0)) Then
           Call zaxpy_(n1*n1*n2*n2,S(k1,  0,k2,  0),OO,1,HAM,1)
          Else If ((q1==0).and.(q2.ne.0)) Then
           Call zaxpy_(n1*n1*n2*n2,S(k1,  0,k2, q2),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,S(k1,  0,k2,-q2),OW,1,HAM,1)
          Else If ((q1.ne.0).and.(q2==0)) Then
           Call zaxpy_(n1*n1*n2*n2,S(k1, q1,k2,  0),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,S(k1,-q1,k2,  0),WO,1,HAM,1)
          Else If ((q1.ne.0).and.(q2.ne.0)) Then
           Call zaxpy_(n1*n1*n2*n2,S(k1, q1,k2, q2),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,S(k1, q1,k2,-q2),OW,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,S(k1,-q1,k2, q2),WO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,S(k1,-q1,k2,-q2),WW,1,HAM,1)
          End If
         End Do !q
        End Do !k
       End Do !q
      End Do !k

      Call mma_deallocate(O1)
      Call mma_deallocate(O2)
      Call mma_deallocate(W1)
      Call mma_deallocate(W2)
      Call mma_deallocate(OO)
      Call mma_deallocate(OW)
      Call mma_deallocate(WO)
      Call mma_deallocate(WW)

      Return
      End Subroutine recover_exch_HAM_from_Stevens_ESO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_Hoo (Hoo)
c
c        check Hoo
c
        implicit none
#include "chcc1.fh"
        real*8 Hoo(1:no,1:no)
c
c        help var
        integer i,u,j,a,b,bad
        real*8 s
c
        bad=0
c
        do i=1,no
        do u=1,no
c
          s=0.0d0
          do j=1,no
          do a=1,nv
          do b=1,nv
          s=s+(2.0d0*Q21(a,i,b,j)-Q21(a,j,b,i))*
     c        (T2c(a,b,u,j)+T1c(a,u)*T1c(b,j))
          end do
          end do
          end do
c
          Hooc(i,u)=s
c
          if (abs(Hoo(i,u)-s).gt.1.0d-10) then
          bad=bad+1
c          write (6,*) Hoo(i,u),s
          end if
c
        end do
        end do
c
        write (6,*) ' Hoo Chck :',bad
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mu_order(d,MS,MM,gtens,order,HCF2,AMM,AMS,Z,iprint)
! This Subroutine receives the moment matrix dipso(3,d,d) and Returns the matrix re-builted using only the 1-st order operators.
!   MS: initial spin moment
!   MM: initial magnetic moment
!  AMS: transformed spin moment
!  AMM: transformed magnetic moment

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Half, cZero, Onei
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: d, order, iprint
complex(kind=wp), intent(in) :: MS(3,d,d), MM(3,d,d)
real(kind=wp), intent(out) :: gtens(3)
complex(kind=wp), intent(out) :: HCF2(d,3,d,d), AMM(3,d,d), AMS(3,d,d), Z(d,d)
integer(kind=iwp) :: i, i1, i2, j, l, m, n
real(kind=wp) :: m_fact, maxes(3,3)
complex(kind=wp) :: O1, O2, SP_DIPO(3), SP_DIPW(3), SP_MOW
complex(kind=wp), allocatable :: AMS_TMP(:,:), B(:,:,:), BNMC(:,:,:), BNMS(:,:,:), DIP_O(:,:), DIP_W(:,:), TMP(:,:,:)
complex(kind=wp), external :: trace
!------------------------------------------------------------

Z(:,:) = cZero
! get the local pseudospin:
call pseudospin(MM,d,Z,3,1,iprint)
! re-write MM and MS to the new pseudospin basis:
AMS(:,:,:) = cZero
AMM(:,:,:) = cZero
do i=1,d
  do j=1,d
    do i1=1,d
      do i2=1,d
        AMM(:,i,j) = AMM(:,i,j)+MM(:,i1,i2)*conjg(Z(i1,i))*Z(i2,j)
        AMS(:,i,j) = AMS(:,i,j)+MS(:,i1,i2)*conjg(Z(i1,i))*Z(i2,j)
      end do
    end do
  end do
end do
if (iprint > 2) then
  call prMom('MU_ORDER:   AMM(l,i,j):',AMM,d)
  call prMom('MU_ORDER:   AMS(l,i,j):',AMS,d)
end if
! project the moment on ITO:
! obtain the b3m and c3m coefficients:
call mma_allocate(B,[1,3],[1,d],[-d,d],label='B')
call mma_allocate(BNMC,[1,3],[1,d],[0,d],label='BNMC')
call mma_allocate(BNMS,[1,3],[1,d],[0,d],label='BNMS')
call mma_allocate(DIP_O,d,d,label='DIP_O')
call mma_allocate(DIP_W,d,d,label='DIP_W')
call mma_allocate(AMS_TMP,d,d,label='AMS_TMP')
B(:,:,:) = cZero
do N=1,d-1
  do M=0,N
    DIP_O(:,:) = cZero
    DIP_W(:,:) = cZero
    call Stewens_matrixel(N,M,d,DIP_O,DIP_W,iprint)
    if (iprint > 5) then
      write(u6,*)
      write(u6,'( 5x,a,i2,a,i3)') 'DIP_O, n = ',N,', m =',m
      write(u6,*)
      do i=1,d
        write(u6,'(20(2F10.6,2x))') (DIP_O(i,j),j=1,d)
      end do
      write(u6,*)
      write(u6,'( 5x,a,i2,a,i3)') 'DIP_W, n = ',N,', m =',m
      write(u6,*)
      do i=1,d
        write(u6,'(20(2F10.6,2x))') (DIP_W(i,j),j=1,d)
      end do
    end if

    SP_DIPO(:) = czero
    SP_DIPW(:) = czero
    SP_MOW = trace(d,DIP_O,DIP_W)
    do l=1,3
      AMS_TMP(:,:) = AMS(l,:,:)
      SP_DIPO(l) = trace(d,AMS_TMP,DIP_O)
      SP_DIPW(l) = trace(d,AMS_TMP,DIP_W)

      B(l,n,-m) = SP_DIPO(l)/SP_MOW
      B(l,n,m) = SP_DIPW(l)/SP_MOW
    end do ! l
  end do ! m
end do ! n

do n=1,d-1
  BNMC(:,n,0) = B(:,n,0)
  do m=1,N
    m_fact = (-One)**M
    BNMC(:,n,m) = B(:,n,m)+m_fact*B(:,n,-m)
    BNMS(:,n,m) = -Onei*(B(:,n,m)-m_fact*B(:,n,-m))
  end do
end do !n

if (iprint > 2) then
  write(u6,'(2A)') repeat('-',47),'|'
  write(u6,'(A)') '  n  |  m  |   |       B       |       C       |'
  do N=1,d-1
    write(u6,'(A)') '-----|-----|---|---------------|---------------|'
    do M=0,N
      if (M /= 0) write(u6,'(A)') '     |-----|---|---------------|---------------|'
      write(u6,'(2(2x,I1,2x,A),1x,A,1x,A,2(F14.9,1x,A))') N,'|',M,'|','X','|',real(BNMC(1,N,M)),'|',real(BNMS(1,N,M)),'|'
      write(u6,'(2(2x,I1,2x,A),1x,A,1x,A,2(F14.9,1x,A))') N,'|',M,'|','Y','|',real(BNMC(2,N,M)),'|',real(BNMS(2,N,M)),'|'
      write(u6,'(2(2x,I1,2x,A),1x,A,1x,A,2(F14.9,1x,A))') N,'|',M,'|','Z','|',real(BNMC(3,N,M)),'|',real(BNMS(3,N,M)),'|'
    end do
  end do
  write(u6,'(2A)') repeat('-',47),'|'
end if

HCF2(:,:,:,:) = cZero
do N=1,d-1
  do M=0,N
    DIP_O(:,:) = cZero
    DIP_W(:,:) = cZero

    call Stewens_matrixel(N,M,d,DIP_O,DIP_W,iprint)

    do l=1,3
      do i=1,d
        do j=1,d
          if (M == 0) then
            HCF2(N,l,i,j) = HCF2(N,l,i,j)+BNMC(l,N,M)*DIP_O(i,j)
          else
            m_fact = (-One)**M
            O1 = Half*(m_fact*DIP_W(i,j)+DIP_O(i,j))
            O2 = -Half*Onei*(m_fact*DIP_W(i,j)-DIP_O(i,j))

            HCF2(N,l,i,j) = HCF2(N,l,i,j)+BNMC(l,N,M)*O1+BNMS(l,N,M)*O2
          end if
        end do
      end do
    end do
  end do
end do ! n

call mma_deallocate(B)
call mma_deallocate(BNMC)
call mma_deallocate(BNMS)
call mma_deallocate(DIP_O)
call mma_deallocate(DIP_W)
call mma_deallocate(AMS_TMP)

if (iprint > 2) then
  do N=1,d-1,2
    write(u6,*)
    write(u6,'( 5x,a,I2,a)') 'HCF2(',N,',l,i,j)'
    do l=1,3
      write(u6,*)
      write(u6,'(a,i3)') 'PROJECTION =',l
      do i=1,d
        write(u6,'(20(2F12.8,2x))') (HCF2(N,l,i,j),j=1,d)
      end do
    end do
    write(u6,*)
  end do
end if

call mma_allocate(TMP,3,d,d,label='TMP')
TMP(:,:,:) = HCF2(order,:,:,:)
call ATENS(TMP,d,gtens,maxes,1)
call mma_deallocate(TMP)

return

end subroutine mu_order

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  OverLq
*
*> @brief
*>   Compute overlap between primitve bases, which for bases of other type than s,
*>   will mean that several overlaps between basis-functions are computed. One
*>   function is on the solvent, the other in the QM-region. Observe that we do not
*>   care about overlaps within the QM-region or among the solvent molecules.
*> @author A. Ohrn
*>
*> @details
*> Uses the formulas in \cite Tak1966-JPSJ-21-2313. It is hard to give any
*> easy explanation, so if you want to understand exactly what is
*> going on below, see the article, especially equations (2.4) and
*> (2.12); then the source-code comments will provide you with
*> sufficient information.
*>
*> @param[in]  Bori   Center for the QM-region contracted basis-function
*> @param[in]  Cori   Like Bori, but for the solvent basis-function
*> @param[in]  Alfa   Exponents for the primitive basis-functions that build this contracted function
*> @param[in]  Beta   Like \p alfa, but for solvent
*> @param[in]  iQ1    = ``1`` if s-type, = ``2`` if p-type, etc. for the function in the QM-region
*> @param[in]  iQ2    Like \p iQ1, but for solvent function
*> @param[in]  nExp1  How many primitives there are in this contracted function
*> @param[in]  nExp2  Like \p nExp1, but for (surprise) the solvent
*> @param[out] iPSint Pointer to the matrix of overlaps
*> @param[in]  Trans  Transition matrix between Cartesian and spherical basis functions
************************************************************************
      Subroutine OverLq(Bori,Cori,Alfa,Beta,iQ1,iQ2,nExp1,nExp2,iPSint
     &                 ,Trans)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

* MaxAngqNr=4 means f-function is top. There is no limit in the
* algorithm though, so if higher is needed, change this number.
      Parameter(MaxAr=MxAngqNr*(MxAngqNr+1)/2)
      Dimension Bori(3),Cori(3),Alfa(MxCont),Beta(MxCont)
      Dimension Trans(int(dble(3*MxAngqNr**2-2*MxAngqNr-10+8*MxAngqNr**3
     &                +3*MxAngqNr**4)/12))
      Dimension PAxyz(3),PBxyz(3),TheCent(3)
      Dimension FactorX(2*MxAngqNr+1),FactorY(2*MxAngqNr+1)
      Dimension FactorZ(2*MxAngqNr+1)
      Dimension nCartxQ(MaxAr),nCartyQ(MaxAr),nCartzQ(MaxAr)
      Dimension nCartxC(MaxAr),nCartyC(MaxAr),nCartzC(MaxAr)
*----------------------------------------------------------------------*
* Prepare some numbers for later.                                      *
*----------------------------------------------------------------------*
      ind=0
      nSpecific1=iQ1*(iQ1+1)/2 !Remember that each base consist of
      nSpecific2=iQ2*(iQ2+1)/2 !many functions - this is how many.
      icompo=nSpecific1
      Do 14, ix=0,iQ1-1  !Then follows the NEW loops that compute how
        Do 15, iy=0,iQ1-1-ix !the cartesian components are ordered in
          iz=iQ1-1-iy-ix    !various basis functions.
          ncartxQ(icompo)=ix
          ncartyQ(icompo)=iy
          ncartzQ(icompo)=iz
          icompo=icompo-1
15       Continue
14     Continue
      icompo=nSpecific2
      Do 16, ix=0,iQ2-1       !And for the solvent orbitals.
        Do 17, iy=0,iQ2-1-ix
          iz=iQ2-1-iy-ix
          ncartxC(icompo)=ix
          ncartyC(icompo)=iy
          ncartzC(icompo)=iz
          icompo=icompo-1
17       Continue
16     Continue
      nSph1=2*iQ1-1
      nSph2=2*iQ2-1
      nSizeCart=nSpecific1*nSpecific2
      nSizeSph=nSph1*nSph2
      nBigP=nExp1*nExp2*nSph1*nSph2
      Call GetMem('PrimCar','Allo','Real',iPpS,nSizeCart)
      Call GetMem('PrimSph','Allo','Real',iPsphS,nSizeSph)
      Call GetMem('AllPrims','Allo','Real',iPSint,nBigP)
      Do 8, i=1,nBigP
        Work(iPSint+i-1)=0
8     Continue
      Separation=((Bori(1)-Cori(1))**2+(Bori(2)-Cori(2))**2
     &          +(Bori(3)-Cori(3))**2)
*----------------------------------------------------------------------*
* Start loop over primitives.                                          *
*----------------------------------------------------------------------*
      Kaunt=0
      Do 101, iP1=1,nExp1
        Do 102, iP2=1,nExp2
          Kaunt=Kaunt+1
          TheCent(1)=(Alfa(iP1)*Bori(1)+Beta(iP2)*Cori(1))
          TheCent(2)=(Alfa(iP1)*Bori(2)+Beta(iP2)*Cori(2))
          TheCent(3)=(Alfa(iP1)*Bori(3)+Beta(iP2)*Cori(3))
          Divide=1/(Alfa(iP1)+Beta(iP2))  !gamma in article
          TheCent(1)=TheCent(1)*Divide  !The new center, P
          TheCent(2)=TheCent(2)*Divide
          TheCent(3)=TheCent(3)*Divide
          Piconst=Pi*Divide
          SqPiconst=sqrt(Piconst)
          Piconst=Piconst*SqPiconst  !That constant to the power of 3/2
          Expo=Alfa(iP1)*Beta(iP2)*Separation*Divide
          TheFirstFac=Piconst*exp(-Expo) !This is the exponential factor
*Now we should get those difficult f-functions.
          PAxyz(1)=TheCent(1)-Bori(1)
          PAxyz(2)=TheCent(2)-Bori(2)
          PAxyz(3)=TheCent(3)-Bori(3)
          PBxyz(1)=TheCent(1)-Cori(1)
          PBxyz(2)=TheCent(2)-Cori(2)
          PBxyz(3)=TheCent(3)-Cori(3)
          kaunter=0
          Do 103, iSp1=1,nSpecific1
            Do 104, iSp2=1,nSpecific2
              kaunter=kaunter+1
              loneX=ncartxQ(iSp1)
              ltwoX=ncartxC(iSp2)
              lsumX=loneX+ltwoX
              loneY=ncartyQ(iSp1)
              ltwoY=ncartyC(iSp2)
              lsumY=loneY+ltwoY
              loneZ=ncartzQ(iSp1)
              ltwoZ=ncartzC(iSp2)
              lsumZ=loneZ+ltwoZ
              Call fFactor(loneX,ltwoX,lsumX,loneY,ltwoY,lsumY,loneZ
     &                    ,ltwoZ,lsumZ,PAxyz,PBxyz,FactorX,FactorY
     &                    ,FactorZ)
*Now we have the f-factors for this specific angular type of this
*specific primitive basis-function. Now put things together.
              iUpX=lsumX/2 !Yes, it should be like this, even when lsumX
              iUpY=lsumY/2 !is odd.
              iUpZ=lsumZ/2
              SummaX=0
              SummaY=0
              SummaZ=0
              Do 131, ixxx=0,iUpX
                Extra=iDubFac(2*ixxx-1)*(0.5*Divide)**ixxx !This is
                SummaX=SummaX+FactorX(2*ixxx+1)*Extra  !just a matter of
131           Continue                               !putting things
              Do 132, iyyy=0,iUpY             !together according to the
                Extra=iDubFac(2*iyyy-1)*(0.5*Divide)**iyyy  !formula
                SummaY=SummaY+FactorY(2*iyyy+1)*Extra
132           Continue
              Do 133, izzz=0,iUpZ
                Extra=iDubFac(2*izzz-1)*(0.5*Divide)**izzz
                SummaZ=SummaZ+FactorZ(2*izzz+1)*Extra
133           Continue
              Primequals=TheFirstFac*SummaX*SummaY*SummaZ
              Work(iPpS+kaunter-1)=Primequals
104         Continue
103       Continue
*----------------------------------------------------------------------*
* This was the overlap for the primitives in terms of cartesian        *
* functions, but in the new qmstat we use spherical functions, so we   *
* need to transform if any d-function or higher is involved. In the    *
* matrix Trans the numbers for how spherical functions are expressed in*
* cartesian functions are stored, including the extra normalization so *
* that all d-functions (and higher) have the same combined contraction *
* and normalization coefficient. The rest is just a matter of getting  *
* the matrix multiplications right. The convention I use is this: The  *
* matrix with the overlaps contain elements such as <psi_QM|psi_Solv>  *
* in other words, the QM-orbitals count over the rows and the solvent  *
* orbitals over the columns; observe however that this is NOT the way  *
* the matrix enters from above, since there the fastest couting index  *
* is over solvent orbitals (iSp2), so given this and the knowledge of  *
* how Fortran stores multidimensional matrices, we can figure out when *
* to transpose. All this means that if it is the QM-orbitals that are  *
* to be transformed, the transformation matrix is multiplied from left,*
* while it is multiplied from the right -- transposed of course -- if  *
* it is the solvent orbitals that are to be transformed. In the case   *
* that both orbitals are to be transformed we simply apply the trans-  *
* formation matrix from both directions.                               *
*----------------------------------------------------------------------*
          If(iQ1.ge.3.or.iQ2.ge.3) then !Check if any transformations
                                        !are necessary.
            If(iQ2.lt.3) then  !If only the base of the QM-region needs
                               !to be transformed.
              ind=1+(iQ1-3)*(3*iQ1**3+5*iQ1**2+12*iQ1+40)/12
              Call Dgemm_('N','T',nSph1,nSpecific2,nSpecific1,ONE
     &                  ,Trans(ind),nSph1,Work(iPps),nSpecific2,ZERO
     &                  ,Work(iPsphS),nSph1)
            Elseif(iQ1.lt.3) then !If only solvent base needs to be
                                  !transformed.
              ind=1+(iQ2-3)*(3*iQ2**3+5*iQ2**2+12*iQ2+40)/12
              Call Dgemm_('T','T',nSph1,nSph2,nSpecific2,ONE
     &                  ,Work(iPps),nSpecific2,Trans(ind),nSph2,ZERO
     &                  ,Work(iPsphS),nSph1)
            Else !Both QM-region and Solvent need to be transformed.
              ind1=1+(iQ1-3)*(3*iQ1**3+5*iQ1**2+12*iQ1+40)/12
              ind2=1+(iQ2-3)*(3*iQ2**3+5*iQ2**2+12*iQ2+40)/12
              Call GetMem('Intmd','Allo','Real',iPInte,nSph1*nSpecific2)
              Call Dgemm_('N','T',nSph1,nSpecific2,nSpecific1,ONE
     &                  ,Trans(ind1),nSph1,Work(iPps),nSpecific2,ZERO
     &                  ,Work(iPInte),nSph1)
              Call Dgemm_('N','T',nSph1,nSph2,nSpecific2,ONE
     &                  ,Work(iPInte),nSph1,Trans(ind2),nSph2,ZERO
     &                  ,Work(iPsphS),nSph1)
              Call GetMem('Intmd','Free','Real',iPInte,nSph1*nSpecific2)
            Endif
          Else  !Here we only transpose to get integrals in right
            krakna=0  !order.
            Do 136, i=0,nSph1-1
              Do 137, j=0,nSph2-1
                Work(iPsphS+krakna)=Work(iPps+i+j*nSph1)
                krakna=krakna+1
137           Continue
136         Continue
          Endif
*----------------------------------------------------------------------*
* Put this thing in the slowly growing overlap matrix for the          *
* primitive basis functions. The reason the index is so nasty is that  *
* we compute small blocks of the matrix and now have to fit it in the  *
* right place in the growing, much larger, matrix. Nasty!              *
*----------------------------------------------------------------------*
          krakna=0
          Do 141, j=0,nSph2-1
            Do 142, i=0,nSph1-1
              jndex=i+j*nExp1*nSph1+(iP1-1)*nSph1
     &              +(iP2-1)*nExp1*nSph1*nSph2
              Work(iPSint+jndex)=Work(iPsphS+krakna)
              krakna=krakna+1
142         Continue
141       Continue
102     Continue
101   Continue
*----------------------------------------------------------------------*
* Deallocate and ta'ta!                                                *
*----------------------------------------------------------------------*
      Call GetMem('PrimCar','Free','Real',iPpS,nSizeCart)
      Call GetMem('PrimSph','Free','Real',iPsphS,nSizeSph)

      Return
      End

*----------------------------------------------------------------------*
* A function that returns the binomial coefficient. The coefficients   *
* are stored since N and P will not under normal circumstances be      *
* so large.                                                            *
*----------------------------------------------------------------------*
      Integer Function NoverP_Q(N,P)
      Integer N,P,Bino(22)
      Data (Bino(i),i=1,21)/1,1,1,1,2,1,1,3,3,1
     &        ,1,4,6,4,1,1,5,10,10,5,1/
      NoverP_Q=1
      If(N.ge.6) then
        Write(6,*)'Must extend NoverP_Q!'
        Call Quit(_RC_INTERNAL_ERROR_)
      Else
        ind=(N+1)*(N+2)/2-(N-P)
        NoverP_Q=Bino(ind)
      Endif
      Return
      End
*----------------------------------------------------------------------*
* A function that will return the double factorial. We do not expect   *
* big numbers, so we do it brute-force. Observe that N must be odd, but*
* to skip the if-sentence, we assume that the one who calls this       *
* function has seen to that.                                           *
*----------------------------------------------------------------------*
      Integer Function iDubFac(N)
      Integer N
      iDubFac=1
      Do 1101, k=3,N,2
        iDubFac=iDubFac*k
1101  Continue
      Return
      End
*----------------------------------------------------------------------*
* A subroutine that computes those darn f-factors. They are definied   *
* in equation (2.4) in the article cited above. As can be seen from    *
* that equation, the computation of the f-factors is actually a matter *
* of using the binomial theorem. This is what we do below and to make  *
* the computation efficient the expression (2.4) is written as a       *
* succint double sum.                                                  *
*----------------------------------------------------------------------*
      Subroutine fFactor(loneX,ltwoX,lsumX,loneY,ltwoY,lsumY,loneZ
     &                 ,ltwoZ,lsumZ,PAxyz,PBxyz,FactorX,FactorY,FactorZ)
      Implicit Real*8 (a-h,o-z)

      Parameter(MaxAngqNr=6,MaxAr=MaxAngqNr*(MaxAngqNr+1)/2)
      Dimension FactorX(2*MaxAngqNr+1),FactorY(2*MaxAngqNr+1)
      Dimension FactorZ(2*MaxAngqNr+1)
      Dimension PAxyz(3),PBxyz(3)

      Do 105, ia=0,lsumX !We use unrolled loops with regard to x,y and z
        fff2=0          !therefore, here we start with the x-factors.
        iLowB=max(0,ia-ltwoX)  !These lower and upper bounds have to do
        iUpB=min(ia,loneX)   !with the allowed numbers in the binomial
        Do 106, i=iLowB,iUpB  !coefficients.
          fff1=NoverP_Q(loneX,i)*NoverP_Q(ltwoX,ia-i)
          If(i.ne.0) then  !This is needed for some compilers (NAG_64)
            PAraise=PAxyz(1)**i
          Else
            PAraise=1.0d0
          Endif
          If(ia-i.ne.0) then
            PBraise=PBxyz(1)**(ia-i)
          Else
            PBraise=1.0d0
          Endif
          fff2=fff2+fff1*PAraise*PBraise
106     Continue
        FactorX(lsumX-ia+1)=fff2
105   Continue
      Do 115, ia=0,lsumY  !y-factors.
        fff2=0
        iLowB=max(0,ia-ltwoY)
        iUpB=min(ia,loneY)
        Do 116, i=iLowB,iUpB
          fff1=NoverP_Q(loneY,i)*NoverP_Q(ltwoY,ia-i)
          If(i.ne.0) then  !This is needed for some compilers (NAG_64)
            PAraise=PAxyz(2)**i
          Else
            PAraise=1.0d0
          Endif
          If(ia-i.ne.0) then
            PBraise=PBxyz(2)**(ia-i)
          Else
            PBraise=1.0
          Endif
          fff2=fff2+fff1*PAraise*PBraise
116     Continue
        FactorY(lsumY-ia+1)=fff2
115   Continue
      Do 125, ia=0,lsumZ  !z-factorz.
        fff2=0
        iLowB=max(0,ia-ltwoZ)
        iUpB=min(ia,loneZ)
        Do 126, i=iLowB,iUpB
          fff1=NoverP_Q(loneZ,i)*NoverP_Q(ltwoZ,ia-i)
          If(i.ne.0) then  !This is needed for some compilers (NAG_64)
            PAraise=PAxyz(3)**i
          Else
            PAraise=1.0d0
          Endif
          If(ia-i.ne.0) then
            PBraise=PBxyz(3)**(ia-i)
          Else
            PBraise=1.0d0
          Endif
          fff2=fff2+fff1*PAraise*PBraise
126     Continue
        Factorz(lsumZ-ia+1)=fff2
125   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_multc0(wrk,wrksize,mvec,ix,c,key)
! This routine realizes multiplying according mvec
! for C=A*B
! N.B. if key=0, C file is not vanished (ie can be used for
! adding to some existing file)
!
! If C=A*B process is faster or comparable with C=AT*B then mchntyp should be set to 1.
! If C=AT*B is significantly faster than C=A*T (more than 20%), then mchntyp should be set to 2. (default is 1)
! if mchntyp is 2, then
!   1) processes with scale(A)/scale(B) > scalelim will be calculated as C=A*B
!   2) processes with scale(A)/scale(B) < scalelim will be calculated as C=AT*B
! Note, that for mchntyp =2 more memory is required, due to requirement of
! aditional o2v2 help file posd0

use CCT3_global, only: Map_Type, mchntyp, posd0, slim
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, mvec(4096,7), ix, key
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: c
integer(kind=iwp) :: ic, iix, nhelp1, nhelp2, nhelp3, nhelp4, nhelp5, nhelp6
real(kind=wp) :: sc

!1 set C=0

if (key == 1) then

  ! C matrix must be vanished

  do ic=1,c%d(0,5)
    nhelp1 = c%d(ic,1)
    nhelp2 = c%d(ic,2)
    wrk(nhelp1:nhelp1+nhelp2-1) = Zero
  end do

end if

!2 C=C+A*B

do iix=1,ix

  ! skip this summation if yes/no=0
  if (mvec(iix,1) == 0) cycle

  ! realize individual summation

  ! def positions of A,B,C
  nhelp1 = mvec(iix,2)
  nhelp2 = mvec(iix,3)
  nhelp3 = mvec(iix,4)

  ! def rowA(rowC), colA(rowB,sum), colB(colC)
  nhelp4 = mvec(iix,5)
  nhelp5 = mvec(iix,6)
  nhelp6 = mvec(iix,7)

  if (mchntyp == 1) then

    ! Typ 1
    call cct3_mc0c1a3b(nhelp4,nhelp5,nhelp5,nhelp6,nhelp4,nhelp6,nhelp4,nhelp5,nhelp6,wrk(nhelp1),wrk(nhelp2),wrk(nhelp3))

  else

    ! Typ2
    sc = real(nhelp4,kind=wp)/real(nhelp6,kind=wp)
    if (sc > slim) then
      call cct3_mc0c1a3b(nhelp4,nhelp5,nhelp5,nhelp6,nhelp4,nhelp6,nhelp4,nhelp5,nhelp6,wrk(nhelp1),wrk(nhelp2),wrk(nhelp3))

    else
      ! map D=AT
      call cct3_map21(wrk(nhelp1),wrk(posd0),nhelp4,nhelp5,2,1,1)
      ! calc C=DT*B
      call cct3_mc0c1at3b(nhelp5,nhelp4,nhelp5,nhelp6,nhelp4,nhelp6,nhelp4,nhelp5,nhelp6,wrk(posd0),wrk(nhelp2),wrk(nhelp3))
    end if

  end if

end do

return

end subroutine cct3_multc0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dbl_space_loop_g()

use gugaci_global, only: norb_dbl

implicit none

if (norb_dbl == 0) return
call dbl_space_loop_ijkk_sgezero_g()
call dbl_space_loop_ijkl_sgezero_g()

return

end subroutine dbl_space_loop_g

subroutine dbl_space_loop_ijkk_sgezero_g()

use gugaci_global, only: jb_sys, jud, just, lsm_inn, norb_dz, norb_frz, ns_sm
use Symmetry_Info, only: Mul
use Constants, only: One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: im, imi, imm, iwdl, iwdr, iwld, iwls, iwlt, iwrd, iwrs, iwrt, jpat, jpdd, jpds, jpds0, jpdt, jpdt1, kij, lmi, &
                     lmij, lmj, lr, lri, lrj, lrm, mij, ni, nxo, nxo_1, nxo_2
real(kind=wp) :: db, vl0_2, vl_0, vl_1, vlp_1, vls0, vls0_2, vls1, vls10_2, vls10_2b, vls1_a, vls_c, vlt0, vlt1, wl, wl0, wl0_1, &
                 wl0_2, wls, wls1, wls1_1, wls1_2, wls2, wls2_1, wls2_2, wls_1, wls_2, wls_a_1, wls_a_2, wls_b, wlt, wlt_1, wlt_2

!==============================  g1,2,4,6,7,8 ==========================
!zz = ' doub_800_v'
db = jb_sys
im = ns_sm
jpds0 = im+17
do lri=norb_frz+1,norb_dz-1
  !mi = lsm_inn(lri)
  iwdl = just(lri,lri)         !drr(03)-drr(30)
  do lrj=lri+1,norb_dz
    !wl = voint(lrj,lri)          ! vdint(itailorb,iheadorb)
    !wl = One
    !=================================
    ! drr-drr
    ! wl=Two but not One is based on that the non-diagonal just uses th
    ! non-triangle <ci|h|cj> which designates that i > j. drr-drr

    wl = Two
    iwdr = just(lrj,lrj)
    call trans_ijkl_intpos(lrj,lri,lrj,lri,nxo)
    call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
  end do
end do
if (jb_sys > 0) then
  ! drl(12)-drl(21)
  vlp_1 = -sqrt(db*(db+2))/(db+1)
  do lri=norb_frz+1,norb_dz
    lmi = lsm_inn(lri)
    do lrj=lri+1,norb_dz
      lmj = lsm_inn(lrj)
      lmij = Mul(lmi,lmj)
      jpds = 17+Mul(lmij,ns_sm)
      iwdl = just(lrj,lri)
      iwdr = just(lri,lrj)
      !wl = -vlp_1*voint(lrj,lri)
      wl = -vlp_1*Two
      !write(nf2,*) 'wl=',wl
      call trans_ijkl_intpos(lrj,lri,lrj,lri,nxo)
      call prodab_2(1,0,jpds,iwdl,iwdr,0,wl,0,nxo)
    end do
  end do
end if

do lri=norb_frz+1,norb_dz-1           !frz
  imi = lsm_inn(lri)
  !n2 = ngw2(lri-2)
  do lrj=lri+1,norb_dz
    mij = Mul(imi,lsm_inn(lrj))
    if (mij /= 1) cycle
    ni = mod(lrj-lri,2)
    !=========== down comm for 2 4 =====================================
    vl_0 = sqrt((db+2)/(db+1))
    vl_1 = sqrt(db/(db+1))
    if (ni == 0) vl_0 = -vl_0
    if (ni == 0) vl_1 = -vl_1
    vl0_2 = One
    vls0_2 = 1/(db+1)
    vls10_2 = sqrt(db*(db+2))/(db+1)
    !if (ni == 1) vl0_2 = -vl0_2
    vls0 = -Half
    vls1 = (db+3)/(2*db+2)
    vls1_a = (db-1)/(2*db+2)
    vls_c = db/(db+1)
    vlt0 = -Half
    vlt1 = -Half
    vls10_2b = sqrt(db*(db+2))/(db+1)
    if (ni == 1) then
      vl0_2 = -vl0_2
      vls0_2 = -vls0_2
      vls10_2 = -vls10_2
      vls_c = -vls_c
    end if
    if (ni == 0) then
      vls0 = -vls0
      vls1 = -vls1
      vls1_a = -vls1_a
      vls10_2b = -vls10_2b
      vlt0 = -vlt0
      vlt1 = -vlt1
    end if
    !wl0 = Zero
    !wl10 = Zero
    ! for 2,4 the common
    ! ar(23)-c"(33)-ar(10) ar(13)-c"(33)-ar(20)
    ! ar(23)-drl(33)-ar(10)  ar(13)-drl(33)-ar(20)    310
    !======================
    ! for 2 the common

    !wltmp = Zero
    do lr=lri+1,lrj-1
      !list = list3(lri,lrj,lr)
      !wltmp = wltmp+2*vint_ci(list+1)-vint_ci(list)
      !wl0 = wl0+vlt0*(2*vint_ci(list+1)-vint_ci(list))
      !wl10 = wl10+vlt1*(2*vint_ci(list+1)-vint_ci(list))
      !wl0 = wl0+vl0_1*(2*vint_ci(list+1)-vint_ci(list)) !310:neoc=2,
      iwdl = just(lri,lrj)
      iwdr = just(lrj,lrj)
      wl = vl_0*2
      call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      wl = -vl_0
      call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      if (jb_sys > 0) then
        iwdl = just(lrj,lri)
        wl = vl_1*2
        call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
        wl = -vl_1
        call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      end if

    end do
    !wl0 = vl_0*wltmp
    !wl10 = vl_1*wltmp
    ! neoc(k)*wg43*(vint(list+2)+coe(k)*vint(list+1))
    ! drl(33)-bl(23)-ar(10)
    ! drl(33)-bl(13)-ar(20)
    !wltmp = Zero

    do lr=1,lri-1
      !list = list3(lri,lrj,lr)
      !wltmp = wltmp+2*vint_ci(list+1)-vint_ci(list) ! 430 w0=-vl0 w
      iwdl = just(lri,lrj)
      iwdr = just(lrj,lrj)
      wl = vl_0*2
      call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      wl = -vl_0
      call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      if (jb_sys > 0) then
        iwdl = just(lrj,lri)
        wl = vl_1*2
        call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
        wl = -vl_1
        call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      end if

    end do
    !wl0 = wl0+vl_0*wltmp
    !wl10 = wl10+vl_1*wltmp
    ! ar(23)-bl(10)-drl(33)
    ! ar(13)-bl(20)-drl(33)
    !wltmp = Zero

    do lr=lrj+1,norb_dz
      !list = list3(lri,lrj,lr)
      !wltmp = wltmp+2*vint_ci(list+1)-vint_ci(list)  ! 220 w0=-vl0
      iwdl = just(lri,lrj)
      iwdr = just(lrj,lrj)
      wl = vl_0*2
      call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      wl = -vl_0
      call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      if (jb_sys > 0) then
        iwdl = just(lrj,lri)
        wl = vl_1*2
        call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
        wl = -vl_1
        call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      end if

    end do
    !======================
    ! for 4 the common

    !wltmp = Zero
    do lr=lri+1,lrj-1
      !list = list3(lri,lrj,lr)
      !wltmp = wltmp+2*vint_ci(list+1)-vint_ci(list)
      !wl0 = wl0 +vlt0*(2*vint_ci(list+1)-vint_ci(list))
      !wl10 = wl10+vlt1*(2*vint_ci(list+1)-vint_ci(list))
      !wl0 = wl0+vl0_1*(2*vint_ci(list+1)-vint_ci(list)) !310:neoc=2,
      iwdl = just(lri,lri)
      iwdr = just(lri,lrj)
      wl = vl_0*2
      call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      wl = -vl_0
      call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      if (jb_sys > 0) then
        iwdr = just(lrj,lri)
        wl = vl_1*2
        call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
        wl = -vl_1
        call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      end if

    end do
    !wl0 = vl_0*wltmp
    !wl10 = vl_1*wltmp
    ! neoc(k)*wg43*(vint(list+2)+coe(k)*vint(list+1))
    ! drl(33)-bl(23)-ar(10)
    ! drl(33)-bl(13)-ar(20)
    !wltmp = Zero

    do lr=1,lri-1
      !list = list3(lri,lrj,lr)
      !wltmp = wltmp+2*vint_ci(list+1)-vint_ci(list) ! 430 w0=-vl0 w
      iwdl = just(lri,lri)
      iwdr = just(lri,lrj)
      wl = vl_0*2
      call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      wl = -vl_0
      call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      if (jb_sys > 0) then
        iwdr = just(lrj,lri)
        wl = vl_1*2
        call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
        wl = -vl_1
        call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      end if

    end do
    !wl0 = wl0+vl_0*wltmp
    !wl10 = wl10+vl_1*wltmp
    ! ar(23)-bl(10)-drl(33)
    ! ar(13)-bl(20)-drl(33)
    !wltmp = Zero

    do lr=lrj+1,norb_dz
      !list = list3(lri,lrj,lr)
      !wltmp = wltmp+2*vint_ci(list+1)-vint_ci(list)  ! 220 w0=-vl0
      iwdl = just(lri,lri)
      iwdr = just(lri,lrj)
      wl = vl_0*2
      call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      wl = -vl_0
      call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
      call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      if (jb_sys > 0) then
        iwdr = just(lrj,lri)
        wl = vl_1*2
        call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
        wl = -vl_1
        call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
        call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
      end if

    end do

    !wl0 = wl0+vl_0*wltmp
    !wl10 = wl10+vl_1*wltmp
    !=========== start comm for 2 4 ====================================
    do lrm=norb_frz+1,norb_dz        !ic=1,norb_act   !frz
      imm = lsm_inn(lrm)
      im = Mul(imm,imi)
      im = Mul(im,ns_sm)
      kij = 0
      if (lrm == lrj) kij = 2
      if (lrm == lri) kij = 4
      if (lrm < lri) kij = 7
      if (lrm > lrj) kij = 6
      if ((lrm > lri) .and. (lrm < lrj)) kij = 8
      select case (kij)
        case (2)
          ! ss(1-c1)  ar(23)-ar(10)-    ar(13)-ar(20)
          iwdl = just(lri,lrj)
          iwdr = just(lrj,lrj)
          !list = list3(lri,lrj,lri)
          !wl = wl0+vl_0*(voint(lri,lrj)+vint_ci(list))
          wl = vl_0
          call prodab_1(1,0,jpds0,iwdl,iwdr,0,wl,0,lri,lrj)
          call trans_ijkl_intpos(lrj,lri,lri,lri,nxo)
          call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)

          if (jb_sys > 0) then
            !wl = wl10+vl_1*(voint(lri,lrj)+vint_ci(list))
            iwdl = just(lrj,lri)
            wl = vl_1
            call prodab_1(1,0,jpds0,iwdl,iwdr,0,wl,0,lri,lrj)
            call trans_ijkl_intpos(lrj,lri,lri,lri,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)

          end if

        case (4)
          ! ss(1-c2)  ar(02)-ar(31)    ar(01)-ar(32)
          iwdl = just(lri,lri)
          iwdr = just(lri,lrj)
          !list = list3(lri,lrj,lrj)
          !wl = wl0+vl_0*(voint(lri,lrj)+vint_ci(list))
          wl = vl_0
          call prodab_1(1,0,jpds0,iwdl,iwdr,0,wl,0,lri,lrj)
          call trans_ijkl_intpos(lrj,lrj,lri,lrj,nxo)
          call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)

          if (jb_sys > 0) then
            iwdr = just(lrj,lri)
            !wl = wl10+vl_1*(voint(lri,lrj)+vint_ci(list))
            wl = vl_1
            call prodab_1(1,0,jpds0,iwdl,iwdr,0,wl,0,lri,lrj)
            call trans_ijkl_intpos(lrj,lrj,lri,lrj,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)

          end if

        case (6)
          ! ar(23)-br(13)-drr(30)  w0=-sqrt((db+2)/(db+1)) w1=0
          ! ar(13)-br(23)-drr(30)  w0=-sqrt(db/(db+1)) w1=0
          iwdl = just(lri,lrj)
          iwdr = just(lrm,lrm)
          !list = list3(lri,lrj,lrm)
          !wl = -vl_0*vint_ci(list)
          wl = -vl_0
          call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
          call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          if (jb_sys > 0) then
            iwdl = just(lrj,lri)
            !wl = -vl_1*vint_ci(list)
            wl = -vl_1
            call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          end if

        case (7)
          ! drr(03)br(32)br(31)   w0=-sqrt((db+2)/(db+1)) w1=0
          ! drr(03)br(31)br(32)   w0=-sqrt(db/(db+1)) w1=0
          iwdl = just(lrm,lrm)
          iwdr = just(lri,lrj)
          !list = list3(lri,lrj,lrm)
          !wl = -vl_0*vint_ci(list)
          wl = -vl_0
          call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
          call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          if (jb_sys > 0) then
            iwdr = just(lrj,lri)
            iwdl = just(lrm,lrm)
            !wl = -vl_1*vint_ci(list)
            wl = -vl_1
            call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          end if

        case (8)
          ! ar(23)-drl(30)-al(13)   w0=sqrt((db+2)/(db+1)) w1=0
          ! ar(13)-drl(30)-al(23)   w0=sqrt(db/(db+1)) w1=0
          iwdl = just(lri,lrj)
          iwdr = just(lrm,lrm)
          !list = list3(lri,lrj,lrm)
          !wl = -vl_0*vint_ci(list)
          wl = -vl_0
          call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
          call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          if (jb_sys > 0) then
            ! ar(13)-drl(30)-al(23)   w0=sqrt(db/(db+1)) w1=0
            iwdl = just(lrj,lri)
            !wl = -vl_1*vint_ci(list)
            wl = -vl_1
            call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          end if
          !========= start  d9(ss) d35(tt) =============================
          jpds = 17+im
          jpdt = 9+im
          jpdt1 = jpdt+24
          !iwls = just(lri,lrm)
          !iwrs = just(lrm,lrj)
          !iwlt = iwls
          !iwrt = iwrs
          ! t  ar(23)-c'(22)-cw(33)-ar(32)   w0=1 w1=0
          ! t  ar(13)-c'(11)-cw(33)-ar(31)   w0=1 w1=0
          ! s  ar(23)-c'(12)-cw(33)-ar(31)   w0=-1/(db+1) w1=0
          ! s  ar(23)-c'(11)-cw(33)-ar(32)   w0=-sqrt(db*(db+2))/(db+1) w1=0
          ! s  ar(13)-c'(21)-cw(33)-ar(32)   w0=1/(db+1) w1=0
          ! s  ar(13)-c'(22)-cw(33)-ar(31)   w0=-sqrt(db*(db+2))/(db+1) w1=0
          !wlt0 = Zero
          !wls0 = Zero
          !wls0_1 = Zero                   ! bbs_tmp
          !wls0_2 = Zero
          !wltmp = Zero
          do lr=lrm+1,lrj-1
            !list = list3(lri,lrj,lr)
            !wltmp = wltmp+2*vint_ci(list+1)-vint_ci(list)
            !wlt0 = wlt0+vl0_2*(2*vint_ci(list+1)-vint_ci(list))
            iwls = just(lri,lrm)
            iwrs = just(lrm,lrj)
            iwlt = iwls
            iwrt = iwrs
            wlt_1 = vl0_2*2
            wls_1 = -vls0_2*2
            wls1_1 = -vls10_2*2
            wls2_1 = vls0_2*2
            wlt_2 = -vl0_2
            wls_2 = vls0_2
            wls1_2 = vls10_2
            wls2_2 = -vls0_2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            nxo_1 = nxo
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            nxo_2 = nxo

            call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
            call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
            call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
            if (jb_sys > 0) then
              iwls = just(lri,lrm)
              iwrs = just(lrj,lrm)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
              iwls = just(lrm,lri)
              iwrs = just(lrj,lrm)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
              iwls = just(lrm,lri)
              iwrs = just(lrm,lrj)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
            end if
            if (jb_sys > 1) then
              call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
              call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
            end if

          end do
          !wlt0 = wlt0+vl0_2*wltmp
          !wls0 = wls0-vls0_2*wltmp
          !wls0_1 = wls0_1-vls10_2*wltmp
          !wls0_2 = wls0_2+vls0_2*wltmp
          !wls2 = wls0
          ! t  ar(23)-cw(33)-c'(22)-ar(32)      w0=1 w1=0
          ! t  ar(13)-cw(33)-c'(11)-ar(31)      w0=1 w1=0
          ! s  ar(23)-cw(33)-c'(12)-ar(31)      w0=-1/(db+1) w1=0
          ! s  ar(23)-cw(33)-c'(11)-ar(32)      w0=-sqrt(db*(db+2))/(db+1) w1=0
          ! s  ar(13)-cw(33)-c'(21)-ar(32)      w0=1/(db+1) w1=0
          ! s  ar(13)-cw(33)-c'(22)-ar(31)      w0=-sqrt(db*(db+2))/(db+1) w1=0

          !wltmp = Zero
          do lr=lri+1,lrm-1
            !list = list3(lri,lrj,lr)
            iwls = just(lri,lrm)
            iwrs = just(lrm,lrj)
            iwlt = iwls
            iwrt = iwrs
            !wltmp = wltmp+2*vint_ci(list+1)-vint_ci(list)
            !wlt0 = wlt0+vl0_2*(2*vint_ci(list+1)-vint_ci(list))
            wlt_1 = vl0_2*2
            wls_1 = -vls0_2*2
            wls1_1 = -vls10_2*2
            wls2_1 = vls0_2*2
            wlt_2 = -vl0_2
            wls_2 = vls0_2
            wls1_2 = vls10_2
            wls2_2 = -vls0_2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            nxo_1 = nxo
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            nxo_2 = nxo

            call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
            call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
            call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
            if (jb_sys > 0) then
              iwls = just(lri,lrm)
              iwrs = just(lrj,lrm)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
              iwls = just(lrm,lri)
              iwrs = just(lrj,lrm)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
              iwls = just(lrm,lri)
              iwrs = just(lrm,lrj)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
            end if
            if (jb_sys > 1) then
              call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
              call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
            end if

          end do

          !wlt0 = wlt0+vl0_2*wltmp
          !wls0 = wls0-vls0_2*wltmp
          !wls0_1 = wls0_1-vls10_2*wltmp
          !wls0_2 = wls0_2+vls0_2*wltmp
          ! t  drl(33)-bl(23)-c'(22)-ar(32) w0=-1 w1=0
          ! t  drl(33)-bl(13)-c'(11)-ar(31) w0=-1 w1=0
          ! s  drl(33)-bl(23)-c'(12)-ar(31) w0=1/(db+1)  w1=0
          ! s  drl(33)-bl(23)-c'(11)-ar(32) w0=sqrt(db*(db+2))/(db+1) w1=0
          ! s  drl(33)-bl(13)-c'(21)-ar(32) w0=-1/(db+1)  w1=0
          ! s  drl(33)-bl(13)-c'(22)-ar(31) w0=sqrt(db*(db+2))/(db+1)   w1=0

          !wltmp = Zero
          do lr=1,lri-1
            !list = list3(lri,lrj,lr)
            !wltmp = wltmp+(vint_ci(list)-2*vint_ci(list+1))
            iwls = just(lri,lrm)
            iwrs = just(lrm,lrj)
            iwlt = iwls
            iwrt = iwrs
            wlt_1 = vl0_2*2
            wls_1 = -vls0_2*2
            wls1_1 = -vls10_2*2
            wls2_1 = vls0_2*2
            wlt_2 = -vl0_2
            wls_2 = vls0_2
            wls1_2 = vls10_2
            wls2_2 = -vls0_2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            nxo_1 = nxo
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            nxo_2 = nxo

            call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
            call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
            call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
            if (jb_sys > 0) then
              iwls = just(lri,lrm)
              iwrs = just(lrj,lrm)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
              iwls = just(lrm,lri)
              iwrs = just(lrj,lrm)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
              iwls = just(lrm,lri)
              iwrs = just(lrm,lrj)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
            end if
            if (jb_sys > 1) then
              call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
              call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
            end if

          end do

          !wlt0 = wlt0-vl0_2*wltmp                  !bbs_tmp
          !wls0 = wls0+vls0_2*wltmp
          !wls0_1 = wls0_1+vls10_2*wltmp
          !wls0_2 = wls0_2-vls0_2*wltmp
          ! t  ar(23)-c'(22)-bl(32)-drl(33) w0=-1 w1=0
          ! t  ar(13)-c'(11)-bl(31)-drl(33) w0=-1 w1=0
          ! s  ar(23)-c'(12)-br(31)-drl(33) w0=1/(db+1)  w1=0
          ! s  ar(23)-c'(11)-br(32)-drl(33) w0=sqrt(db*(db+2))/(db+1) w1=0
          ! s  ar(13)-c'(21)-br(32)-drl(33) w0=-1/(db+1)  w1=0
          ! s  ar(13)-c'(22)-br(31)-drl(33) w0=sqrt(db*(db+2))/(db+1) w1=0

          !wltmp = Zero
          do lr=lrj+1,norb_dz
            !list = list3(lri,lrj,lr)
            !wltmp = wltmp+(vint_ci(list)-2*vint_ci(list+1))
            iwls = just(lri,lrm)
            iwrs = just(lrm,lrj)
            iwlt = iwls
            iwrt = iwrs
            wlt_1 = vl0_2*2
            wls_1 = -vls0_2*2
            wls1_1 = -vls10_2*2
            wls2_1 = vls0_2*2
            wlt_2 = -vl0_2
            wls_2 = vls0_2
            wls1_2 = vls10_2
            wls2_2 = -vls0_2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            nxo_1 = nxo
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            nxo_2 = nxo

            call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
            call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
            call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
            if (jb_sys > 0) then
              iwls = just(lri,lrm)
              iwrs = just(lrj,lrm)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
              iwls = just(lrm,lri)
              iwrs = just(lrj,lrm)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
              iwls = just(lrm,lri)
              iwrs = just(lrm,lrj)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
            end if
            if (jb_sys > 1) then
              call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
              call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
            end if

          end do

          !wlt0 = wlt0+vl0_2*wltmp
          !wls0 = wls0-vls0_2*wltmp
          !wls0_1 = wls0_1+vls10_2*wltmp
          !wls0_2 = wls0_2+vls0_2*wltmp
          !wlt0 = wlt0-vl0_2*wltmp
          !wls0 = wls0+vls0_2*wltmp
          !wls0_1 = wls0_1+vls10_2*wltmp
          !wls0_2 = wls0_2-vls0_2*wltmp
          !wls0 = -wlt0
          !========= up comm for 9 35 ==================================
          ! t ar(23)-c'(22)-arw(32) w0=1 w1=0
          ! t ar(13)-c'(11)-arw(31) w0=1 w1=0
          ! s ar(23)-c'(12)-arw(31) w0=-1/(db+1)  w1=0
          ! s ar(23)-c'(11)-arw(31) w0=-sqrt(db*(db+2))/(db+1) w1=0
          ! s ar(13)-c'(21)-arw(32) w0=1/(db+1)  w1=0
          ! s ar(13)-c'(22)-arw(31) w0=-sqrt(db*(db+2))/(db+1) w1=0
          !list = list3(lri,lrj,lrj)
          !wlt = wlt0+vl0_2*vint_ci(list)
          !wls = wls0-vl0_2*vint_ci(list)
          !list = list3(lri,lrj,lrj)
          !wlt = wlt0+vl0_2*vint_ci(list)
          !wls = wls0-vls0_2*vint_ci(list)
          !wls1 = wls0_1-vls10_2*vint_ci(list)
          !wls2 = wls0_2+vls0_2*vint_ci(list)
          iwls = just(lri,lrm)
          iwrs = just(lrm,lrj)
          iwlt = iwls
          iwrt = iwrs
          wlt = vl0_2
          wls = -vls0_2
          wls1 = -vls10_2
          wls2 = vls0_2
          call trans_ijkl_intpos(lrj,lrj,lri,lrj,nxo)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wls,0,nxo)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt,0,nxo)
          if (jb_sys > 0) then
            iwls = just(lri,lrm)
            iwrs = just(lrj,lrm)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo)
            iwls = just(lrm,lri)
            iwrs = just(lrj,lrm)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls2,0,nxo)
            iwls = just(lrm,lri)
            iwrs = just(lrm,lrj)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo)
          end if
          if (jb_sys > 1) then
            call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt,0,nxo)    !bbs_tm
          end if

          !wl_bbs = -vls0_2*vint_ci(list)
          ! t  ar(23)-cw(22)-ar(32)
          ! t  ar(13)-cw(11)-ar(31)
          ! s  ar(23)-cw(12)-ar(31)    w0=-1/(db+1)    ar(12)-drr(22)-ar(32)
          ! s  ar(23)-cw(11)-ar(32)    w0=-sqrt(db*(db+1))/(db+1)
          ! s  ar(13)-cw(21)-ar(32)    w0=1/(db+1)
          ! s  ar(13)-cw(22)-ar(31)  w0=-sqrt(db*(db+1))/(db+1)
          !list = list3(lri,lrj,lrm)

          !wlt = wlt+vl0_2*vint_ci(list+1)
          !wls = wls-vls0_2*(vint_ci(list+1)-(db+2)*vint_ci(list)) !coe
          !wls1 = wls1-vls10_2*(vint_ci(list+1)-vint_ci(list))  !coe=-1
          !wls2 = wls2+vls0_2*(vint_ci(list+1)+db*vint_ci(list)) !coe=db
          iwls = just(lri,lrm)
          iwrs = just(lrm,lrj)
          iwlt = iwls
          iwrt = iwrs
          wlt = vl0_2
          wls_1 = -vls0_2
          wls1_1 = -vls10_2
          wls2_1 = vls0_2
          call trans_ijkl_intpos(lrj,lri,lrm,lrm,nxo)
          nxo_1 = nxo
          wls_2 = vls0_2*(db+2)
          wls1_2 = vls10_2
          wls2_2 = vls0_2*db
          call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
          nxo_2 = nxo

          call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt,0,nxo_1)
          if (jb_sys > 0) then
            iwls = just(lri,lrm)
            iwrs = just(lrj,lrm)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
            iwls = just(lrm,lri)
            iwrs = just(lrj,lrm)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
            iwls = just(lrm,lri)
            iwrs = just(lrm,lrj)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
          end if
          !-------------------------------------------------------------
          ! lyb
          if (jb_sys > 1) then
            call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt,0,nxo_1)
          end if

          !wls2 = wls2+vls0_2*(vint_ci(list+1)-2*vint_ci(list))
          !wl_bbs = wl_bbs-vls0_2*(vint_ci(list+1)-2*vint_ci(list))
          ! t  arw(23)-c'(22)-ar(32)
          ! t  arw(13)-c'(11)-ar(31)
          ! s  arw(23)-c'(12)-ar(31)
          ! s  arw(23)-c'(11)-ar(32)
          ! s  arw(13)-c'(21)-ar(32)
          ! s  arw(13)-c'(22)-ar(31)
          ! t  ar(23)-c'(22)-ar(32)    w0=1
          ! t  ar(13)-c'(11)-ar(31)    w0=1
          ! s  ar(23)-c'(12)-ar(31)    w0=-1/(db+1)  w1=0
          ! s  ar(23)-c'(11)-ar(32)    w0=-sqrt(db*(db+2))/(db+1) w1=0
          ! s  ar(13)-c'(21)-ar(32)    w0=1/(db+1)  w1=0
          ! s  ar(13)-c'(22)-ar(31)    w0=-sqrt(db*(db+2))/(db+1) w1=0
          !list = list3(lri,lrj,lri)
          !wlt = wlt+vl0_2*(voint(lri,lrj)+ vint_ci(list))
          !wls = wls-vls0_2*(voint(lri,lrj)+ vint_ci(list))
          !wls1 = wls1-vls10_2*(voint(lri,lrj)+ vint_ci(list))
          !wls2 = wls2+vls0_2*(voint(lri,lrj)+ vint_ci(list))
          !wl_bbs = wl_bbs-vls0_2*(voint(lri,lrj)+ vint_ci(list))
          iwls = just(lri,lrm)
          iwrs = just(lrm,lrj)
          iwlt = iwls
          iwrt = iwrs
          wlt = vl0_2
          wls = -vls0_2
          wls1 = -vls10_2
          wls2 = vls0_2
          call trans_ijkl_intpos(lrj,lri,lri,lri,nxo)

          ! ar(23)-drr(12)-ar(31)  w0=(db+2)/(db+1)   ???? complete
          call prodab_1(1,0,jpds,iwls,iwrs,0,wls,0,lri,lrj)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wls,0,nxo)
          call prodab_1(1,0,jpdt,iwlt,iwrt,0,wlt,0,lri,lrj)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt,0,nxo)
          if (jb_sys > 0) then
            iwls = just(lri,lrm)
            iwrs = just(lrj,lrm)
            call prodab_1(1,0,jpds,iwls,iwrs,0,wls1,0,lri,lrj)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo)
            iwls = just(lrm,lri)
            iwrs = just(lrj,lrm)
            call prodab_1(1,0,jpds,iwls,iwrs,0,wls2,0,lri,lrj)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls2,0,nxo)
            iwls = just(lrm,lri)
            iwrs = just(lrm,lrj)
            call prodab_1(1,0,jpds,iwls,iwrs,0,wls1,0,lri,lrj)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo)
          end if
          if (jb_sys > 1) then
            call prodab_1(1,0,jpdt1,iwlt,iwrt,0,wlt,0,lri,lrj)
            call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt,0,nxo)
          end if

        case default
      end select

    end do
    !=========== start  d10_ss(dd,ss,tt)  ==============================
    ! ar(23)-drr(33)-ar(32)  ar(23)-cw(33)-ar(23)
    ! ar(13)-drr(33)-ar(31)  ar(13)-cw(33)-ar(13) w0=1 w1=0
    !if ((lri == 2) .and. (lrj == 4)) write(u6,*) 'bbs_tmp err'

    !wl0 = Zero
    !wltmp = Zero
    do lrm=lri+1,lrj-1
      !list = list3(lri,lrj,lrm)
      !wltmp = wltmp+(2*vint_ci(list+1)-vint_ci(list))
      wl0_1 = -vl0_2*2
      wl0_2 = vl0_2
      call trans_ijkl_intpos(lrj,lri,lrm,lrm,nxo)
      nxo_1 = nxo
      call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
      nxo_2 = nxo

      im = Mul(lsm_inn(lri),ns_sm)
      jpdd = 1+im
      iwld = jud(lri)
      iwrd = jud(lrj)
      call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
      call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)

      if (jb_sys > 0) then
        jpdd = jpdd+24
        call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)
      end if
      do lr=lrj+1,norb_dz
        im = Mul(lsm_inn(lri),lsm_inn(lr))
        im = Mul(im,ns_sm)
        jpds = 17+im
        jpdt = 9+im
        iwls = just(lri,lr)
        iwrs = just(lrj,lr)
        iwlt = iwls
        iwrt = iwrs
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
        if (jb_sys > 0) then
          iwls = just(lr,lri)
          iwrs = just(lr,lrj)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        end if
        if (jb_sys > 1) then
          jpdt = jpdt+24
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
        end if
      end do

      do lr=norb_frz+1,lri-1
        im = Mul(lsm_inn(lri),lsm_inn(lr))
        im = Mul(im,ns_sm)
        jpds = 17+im
        jpdt = 9+im
        iwls = just(lr,lri)
        iwrs = just(lr,lrj)
        iwlt = iwls
        iwrt = iwrs
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
        if (jb_sys > 0) then
          iwls = just(lri,lr)
          iwrs = just(lrj,lr)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        end if
        if (jb_sys > 1) then
          jpat = jpdt+24
          call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_2,0,nxo_2)
        end if
      end do
    end do
    !wl0 = wl0-vl0_2*wltmp

    ! drl(33)-bl(23)-ar(32)
    ! drl(33)-bl(13)-ar(31)
    !wltmp = Zero
    do lrm=1,lri-1
      !list = list3(lri,lrj,lrm)
      !wltmp = wltmp+(vint_ci(list)-2*vint_ci(list+1))
      wl0_1 = -vl0_2*2
      wl0_2 = vl0_2
      call trans_ijkl_intpos(lrj,lri,lrm,lrm,nxo)
      nxo_1 = nxo
      call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
      nxo_2 = nxo

      im = Mul(lsm_inn(lri),ns_sm)
      jpdd = 1+im
      iwld = jud(lri)
      iwrd = jud(lrj)
      call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
      call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)

      if (jb_sys > 0) then
        jpdd = jpdd+24
        call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)
      end if
      do lr=lrj+1,norb_dz
        im = Mul(lsm_inn(lri),lsm_inn(lr))
        im = Mul(im,ns_sm)
        jpds = 17+im
        jpdt = 9+im
        iwls = just(lri,lr)
        iwrs = just(lrj,lr)
        iwlt = iwls
        iwrt = iwrs
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
        if (jb_sys > 0) then
          iwls = just(lr,lri)
          iwrs = just(lr,lrj)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        end if
        if (jb_sys > 1) then
          jpdt = jpdt+24
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
        end if
      end do

      do lr=norb_frz+1,lri-1
        im = Mul(lsm_inn(lri),lsm_inn(lr))
        im = Mul(im,ns_sm)
        jpds = 17+im
        jpdt = 9+im
        iwls = just(lr,lri)
        iwrs = just(lr,lrj)
        iwlt = iwls
        iwrt = iwrs
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
        if (jb_sys > 0) then
          iwls = just(lri,lr)
          iwrs = just(lrj,lr)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        end if
        if (jb_sys > 1) then
          jpat = jpdt+24
          call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_2,0,nxo_2)
        end if
      end do
    end do

    !wl0 = wl0+vl0_2*wltmp

    ! ar(23)-bl(32)-drl(33)
    ! ar(13)-bl(31)-drl(33)
    !wltmp = Zero
    do lrm=lrj+1,norb_dz
      !list = list3(lri,lrj,lrm)
      !wltmp = wltmp+(vint_ci(list)-2*vint_ci(list+1))
      wl0_1 = -vl0_2*2
      wl0_2 = vl0_2
      call trans_ijkl_intpos(lrj,lri,lrm,lrm,nxo)
      nxo_1 = nxo
      call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
      nxo_2 = nxo

      im = Mul(lsm_inn(lri),ns_sm)
      jpdd = 1+im
      iwld = jud(lri)
      iwrd = jud(lrj)
      call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
      call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)

      if (jb_sys > 0) then
        jpdd = jpdd+24
        call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)
      end if
      do lr=lrj+1,norb_dz
        im = Mul(lsm_inn(lri),lsm_inn(lr))
        im = Mul(im,ns_sm)
        jpds = 17+im
        jpdt = 9+im
        iwls = just(lri,lr)
        iwrs = just(lrj,lr)
        iwlt = iwls
        iwrt = iwrs
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
        if (jb_sys > 0) then
          iwls = just(lr,lri)
          iwrs = just(lr,lrj)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        end if
        if (jb_sys > 1) then
          jpdt = jpdt+24
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
        end if
      end do

      do lr=norb_frz+1,lri-1
        im = Mul(lsm_inn(lri),lsm_inn(lr))
        im = Mul(im,ns_sm)
        jpds = 17+im
        jpdt = 9+im
        iwls = just(lr,lri)
        iwrs = just(lr,lrj)
        iwlt = iwls
        iwrt = iwrs
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
        if (jb_sys > 0) then
          iwls = just(lri,lr)
          iwrs = just(lrj,lr)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
        end if
        if (jb_sys > 1) then
          jpat = jpdt+24
          call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_1,0,nxo_1)
          call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_2,0,nxo_2)
        end if
      end do
    end do
    !wl0 = wl0+vl0_2*wltmp
    !wl_tmp = vl0_2*wltmp

    ! ar-arw    arw-al   ar-ar
    !list = list3(lri,lrj,lrj)
    !wl0 = wl0-vl0_2*vint_ci(list)
    wl0 = -vl0_2
    call trans_ijkl_intpos(lrj,lrj,lri,lrj,nxo)
    im = Mul(lsm_inn(lri),ns_sm)
    jpdd = 1+im
    iwld = jud(lri)
    iwrd = jud(lrj)
    call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0,0,nxo)
    if (jb_sys > 0) then
      jpdd = jpdd+24
      call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0,0,nxo)
    end if
    do lr=lrj+1,norb_dz
      im = Mul(lsm_inn(lri),lsm_inn(lr))
      im = Mul(im,ns_sm)
      jpds = 17+im
      jpdt = 9+im
      iwls = just(lri,lr)
      iwrs = just(lrj,lr)
      iwlt = iwls
      iwrt = iwrs
      call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
      call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
      if (jb_sys > 0) then
        iwls = just(lr,lri)
        iwrs = just(lr,lrj)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
      end if
      if (jb_sys > 1) then
        jpdt = jpdt+24
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
      end if
    end do

    do lr=norb_frz+1,lri-1
      im = Mul(lsm_inn(lri),lsm_inn(lr))
      im = Mul(im,ns_sm)
      jpds = 17+im
      jpdt = 9+im
      iwls = just(lr,lri)
      iwrs = just(lr,lrj)
      iwlt = iwls
      iwrt = iwrs
      call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
      call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
      if (jb_sys > 0) then
        iwls = just(lri,lr)
        iwrs = just(lrj,lr)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
      end if
      if (jb_sys > 1) then
        jpat = jpdt+24
        call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0,0,nxo)
      end if
    end do

    !list = list3(lri,lrj,lri)
    !wl0 = wl0-vl0_2*(voint(lri,lrj)+vint_ci(list))
    wl0 = -vl0_2
    call trans_ijkl_intpos(lrj,lri,lri,lri,nxo)

    im = Mul(lsm_inn(lri),ns_sm)
    jpdd = 1+im
    iwld = jud(lri)
    iwrd = jud(lrj)
    call prodab_1(1,0,jpdd,iwld,iwrd,0,wl0,0,lri,lrj)
    call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0,0,nxo)
    if (jb_sys > 0) then
      jpdd = jpdd+24
      call prodab_1(1,0,jpdd,iwld,iwrd,0,wl0,0,lri,lrj)
      call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0,0,nxo)
    end if
    do lr=lrj+1,norb_dz
      im = Mul(lsm_inn(lri),lsm_inn(lr))
      im = Mul(im,ns_sm)
      jpds = 17+im
      jpdt = 9+im
      iwls = just(lri,lr)
      iwrs = just(lrj,lr)
      iwlt = iwls
      iwrt = iwrs
      call prodab_1(1,0,jpds,iwls,iwrs,0,wl0,0,lri,lrj)
      call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
      call prodab_1(1,0,jpdt,iwlt,iwrt,0,wl0,0,lri,lrj)
      call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
      if (jb_sys > 0) then
        iwls = just(lr,lri)
        iwrs = just(lr,lrj)
        call prodab_1(1,0,jpds,iwls,iwrs,0,wl0,0,lri,lrj)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
      end if
      if (jb_sys > 1) then
        jpdt = jpdt+24
        call prodab_1(1,0,jpdt,iwlt,iwrt,0,wl0,0,lri,lrj)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
      end if
    end do

    do lr=norb_frz+1,lri-1
      im = Mul(lsm_inn(lri),lsm_inn(lr))
      im = Mul(im,ns_sm)
      jpds = 17+im
      jpdt = 9+im
      iwls = just(lr,lri)
      iwrs = just(lr,lrj)
      iwlt = iwls
      iwrt = iwrs
      call prodab_1(1,0,jpds,iwls,iwrs,0,wl0,0,lri,lrj)
      call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
      call prodab_1(1,0,jpdt,iwlt,iwrt,0,wl0,0,lri,lrj)
      call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
      if (jb_sys > 0) then
        iwls = just(lri,lr)
        iwrs = just(lrj,lr)
        call prodab_1(1,0,jpds,iwls,iwrs,0,wl0,0,lri,lrj)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
      end if
      if (jb_sys > 1) then
        jpat = jpdt+24
        call prodab_1(1,0,jpat,iwlt,iwrt,0,wl0,0,lri,lrj)
        call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0,0,nxo)
      end if
    end do

    !===================================================================

    do lr=lrj+1,norb_dz
      !list = list3(lri,lrj,lr)
      !wls = wl0+(vls0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))-vls1*vint_ci(list)
      ! ar(23)-bl(32)-drl(22) ar(13)-bl(31)-drl(11)
      !wlt = wl0+(vlt0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))-vlt1*vint_ci(list)
      wls_1 = vls0-vl0_2-vls1
      wls_2 = -(vls0-vl0_2)*2
      wlt_1 = vlt0-vl0_2-vlt1
      wlt_2 = -(vlt0-vl0_2)*2
      call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
      nxo_1 = nxo
      call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
      nxo_2 = nxo
      im = Mul(lsm_inn(lri),lsm_inn(lr))
      im = Mul(im,ns_sm)
      jpds = 17+im
      jpdt = 9+im
      iwls = just(lri,lr)
      iwrs = just(lrj,lr)
      iwlt = iwls
      iwrt = iwrs
      call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
      call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
      call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
      call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
      if (jb_sys > 0) then
        !wls_a = wl0+(vls0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))-vls1_a*vint_ci(list)
        wls_b = -vls10_2b
        wls_a_1 = vls0-vl0_2-vls1_a
        wls_a_2 = -(vls0-vl0_2)*2

        iwls = just(lr,lri)
        iwrs = just(lr,lrj)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wls_a_1,0,nxo_1)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wls_a_2,0,nxo_2)
        iwls = just(lri,lr)
        iwrs = just(lr,lrj)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wls_b,0,nxo_1)
        iwls = just(lr,lri)
        iwrs = just(lrj,lr)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wls_b,0,nxo_1)
      end if
      if (jb_sys > 1) then
        jpdt = jpdt+24
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
        call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
      end if

    end do
    !======= start d5(ss),d40(tt) ======================================
    do lr=norb_frz+1,lri-1
      !list = list3(lri,lrj,lr)
      ! drl(22)-bl(13)-ar(31)
      !wls = wl0+(vls0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))-vls1*vint_ci(list)
      ! drl(22)-bl(23)-ar(32)  drl(11)-bl(13)-ar(31)
      !wlt = wl0+(vlt0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))-vlt1*vint_ci(list)
      wls_1 = vls0-vl0_2-vls1
      wls_2 = -(vls0-vl0_2)*2
      wlt_1 = vlt0-vl0_2-vlt1
      wlt_2 = -(vlt0-vl0_2)*2
      call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
      nxo_1 = nxo
      call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
      nxo_2 = nxo

      im = Mul(lsm_inn(lri),lsm_inn(lr))
      im = Mul(im,ns_sm)
      jpds = 17+im
      jpdt = 9+im
      iwls = just(lr,lri)
      iwrs = just(lr,lrj)
      iwlt = iwls
      iwrt = iwrs
      call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
      call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
      call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
      call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
      if (jb_sys > 0) then
        ! drl(11)-bl(23)-ar(32)
        !wls = wl0+(vls0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))-vls1_a*vint_ci(list)
        wls_1 = vls0-vl0_2-vls1_a
        wls_2 = -(vls0-vl0_2)*2
        iwls = just(lri,lr)
        iwrs = just(lrj,lr)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
        ! drl(12)-bl(23)-ar(31) drl(21)-bl(13)-ar(32)
        !wls = -vls10_2b*vint_ci(list)
        wls = -vls10_2b
        iwls = just(lri,lr)
        iwrs = just(lr,lrj)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wls,0,nxo_1)
        iwls = just(lr,lri)
        iwrs = just(lrj,lr)
        call prodab_2(1,0,jpds,iwls,iwrs,0,wls,0,nxo_1)
      end if
      if (jb_sys > 1) then
        jpat = jpdt+24
        call prodab_2(1,0,jpat,iwlt,iwrt,0,wlt_1,0,nxo_1)
        call prodab_2(1,0,jpat,iwlt,iwrt,0,wlt_2,0,nxo_2)
      end if

    end do
    !======= end g5,40 =================================================
  end do
end do

return

end subroutine dbl_space_loop_ijkk_sgezero_g

subroutine dbl_space_loop_ijkl_sgezero_g()

use gugaci_global, only: jb_sys, just, lsm_inn, norb_dz, norb_frz, ns_sm
use Symmetry_Info, only: Mul
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: im, imi, imij, imik, imil, imj, imk, iml, iwls, iwls1, iwlt, iwrs, iwrs1, iwrt, jpds, jpdt, jpdt1, lri, lrj, &
                     lrk, lrl, ni, nxo, nxo_1, nxo_2
real(kind=wp) :: db, w0, w1, wls1, wls1_1, wls1_2, wls2_1, wls2_2, wls_1, wls_2, wlt_1, wlt_2

!==============================  g11,12  == (v-s)=======================
!==============================  g41,42  == (v-t)=======================
wls1 = Zero
!wls2 = Zero
wls1_1 = Zero
wls1_2 = Zero
wls2_1 = Zero
wls2_2 = Zero
db = jb_sys
do lrl=norb_frz+1,norb_dz-3
  iml = lsm_inn(lrl)
  do lrk=lrl+1,norb_dz-2
    imk = lsm_inn(lrk)
    do lrj=lrk+1,norb_dz-1
      imj = lsm_inn(lrj)
      do lri=norb_dz,lrj+1,-1
        imi = lsm_inn(lri)

        !list = list4(lrl,lrk,lrj,lri)
        ni = mod(lrk-lrl+lri-lrj,2)
        imik = Mul(imi,imk)
        if (imik == Mul(imj,iml)) then
          im = Mul(imik,ns_sm)
          jpds = 17+im
          jpdt = 9+im
          jpdt1 = jpdt+24
          iwls = just(lrl,lrj)
          iwrs = just(lrk,lri)
          iwlt = iwls
          iwrt = iwrs
          if (jb_sys == 0) then
            ! w0g11=-1/2, w1g11=-3/2                 === g11 ===
            !wls = vint_ci(list+1)+vint_ci(list+2)
            wls_1 = One
            wls_2 = One

            ! w0g42=-1/2, w1g42=1/2                  === g42 ===
            !wlt = vint_ci(list+1)-vint_ci(list+2)
            wlt_1 = One
            wlt_2 = -One
          end if
          if (jb_sys > 0) then
            ! wog11=-1/2, w1g11=-(db+3)/(2*db+2)
            ! ar(23)bl(32)bl(13)ar(31)
            w1 = -(db+3)/(2*db+2)
            !wls = vint_ci(list+1)+(-Half-w1)*vint_ci(list+2)
            wls_1 = One
            wls_2 = -Half-w1
            ! wog42=-1/2, w1g42=1/2     ar(23)bl(32)bl(23)ar(32)
            !wlt = vint_ci(list+1)-vint_ci(list+2)
            wlt_1 = One
            wlt_2 = -One
            ! w0=0, w1=-sqrt(db*(db+2)/(db+1))
            ! ar(13)bl(32)bl(23)ar(31)     ar(23)bl(31)bl(13)ar(32)
            w1 = -sqrt(db*(db+2))/(db+1)
            !wls1 = -w1*vint_ci(list+2)
            wls1 = -w1
            ! ar(13)bl(31)bl(23)ar(32)      w0=-1/2
            w1 = -(db-1)/(2*db+2)
            !wls2 = vint_ci(list+1)+(-Half-w1)*vint_ci(list+2)
            wls2_1 = One
            wls2_2 = -Half-w1
            ! ar(13)bl(31)bl(13)ar(31)
            ! w0=-1/2 w1=1/2
            !wlt1 = wlt
          end if
          ! if (ni == 1) wls = -wls
          if (ni == 1) then
            wls_1 = -wls_1
            wls_2 = -wls_2
            wlt_1 = -wlt_1
            wlt_2 = -wlt_2
            wls1 = -wls1
            wls2_1 = -wls2_1
            wls2_2 = -wls2_2
          end if
          call trans_ijkl_intpos(lri,lrj,lrk,lrl,nxo)
          nxo_1 = nxo
          call trans_ijkl_intpos(lri,lrl,lrk,lrj,nxo)
          nxo_2 = nxo
          call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
          if (jb_sys > 0) then
            iwrs1 = just(lrk,lri)
            iwls1 = just(lrj,lrl)
            call prodab_2(1,0,jpds,iwls1,iwrs1,0,wls1,0,nxo_2)
            iwrs1 = just(lri,lrk)
            iwls1 = just(lrl,lrj)
            call prodab_2(1,0,jpds,iwls1,iwrs1,0,wls1,0,nxo_2)
            iwrs1 = just(lri,lrk)
            iwls1 = just(lrj,lrl)
            call prodab_2(1,0,jpds,iwls1,iwrs1,0,wls2_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls1,iwrs1,0,wls2_2,0,nxo_2)
          end if
          if (jb_sys > 1) then
            call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
            call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
          end if
        end if

        imil = Mul(imi,iml)
        if (imil == Mul(imj,imk)) then
          im = Mul(imil,ns_sm)
          jpds = 17+im
          jpdt = 9+im
          jpdt1 = jpdt+24
          iwls = just(lrl,lri)
          iwrs = just(lrk,lrj)
          iwlt = iwls
          iwrt = iwrs
          if (jb_sys == 0) then
            ! w0g11=-1/2 w1g11=-3/2                  === g11 ===
            !wls = vint_ci(list)+vint_ci(list+1)
            wls_1 = One
            wls_2 = One
            ! w0g42=-1/2 w1g42=1/2                   === g42 ===
            !wlt = vint_ci(list+1)-vint_ci(list)
            wlt_1 = One
            wlt_2 = -One
          end if
          if (jb_sys > 0) then
            ! wog11=-1/2 w1g11=-(db+3)/(2*db+2)
            ! ar(23)bl(32)br(31)al(13)
            w1 = -(db+3)/(2*db+2)
            !wls = (-Half-w1)*vint_ci(list)+vint_ci(list+1)
            wls_1 = One
            wls_2 = -Half-w1
            ! wog42=-1/2 w1g42=1/2
            ! ar(23)bl(32)br(23)al(32)
            !wlt = vint_ci(list+1)-vint_ci(list)
            wlt_1 = One
            wlt_2 = -One
            ! w0=0 w1=-sqrt(db*(db+2)/(db+1))
            ! ar(23)bl(31)br(32)al(13)
            w1 = -sqrt(db*(db+2))/(db+1)
            !wls1 = -w1*vint_ci(list)
            wls1 = -w1
            ! ar(13)bl(31)br(32)al(23)
            ! w0=-1/2 w1=-(db-1)/(2*db+2)
            w1 = -(db-1)/(2*db+2)
            !wls2 = (-Half-w1)*vint_ci(list)+vint_ci(list+1)
            wls2_1 = One
            wls2_2 = -Half-w1
          end if
          if (ni == 1) then
            wls_1 = -wls_1
            wls_2 = -wls_2
            wlt_1 = -wlt_1
            wlt_2 = -wlt_2
            wls1 = -wls1
            wls2_1 = -wls2_1
            wls2_2 = -wls2_2
          end if
          call trans_ijkl_intpos(lri,lrj,lrk,lrl,nxo)
          nxo_1 = nxo
          call trans_ijkl_intpos(lri,lrk,lrj,lrl,nxo)
          nxo_2 = nxo
          call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
          if (jb_sys > 0) then
            iwls = just(lri,lrl)
            iwrs = just(lrk,lrj)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo_2)
            iwls = just(lrl,lri)
            iwrs = just(lrj,lrk)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo_2)
            iwls = just(lri,lrl)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
          end if
          if (jb_sys > 1) then
            call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
            call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
          end if
        end if

        imij = Mul(imi,imj)
        if (imij == Mul(imk,iml)) then
          im = Mul(imij,ns_sm)
          jpds = 17+im
          jpdt = 9+im
          jpdt1 = 24+jpdt
          iwls = just(lrl,lrk)
          iwrs = just(lrj,lri)
          iwlt = iwls
          iwrt = iwrs
          if (jb_sys == 0) then
            ! w0g12=1, w1g12=0                                === g12 ===
            !wls = vint_ci(list)+vint_ci(list+2)
            wls_1 = One
            wls_2 = One
            ! w0g41=0, w1g41=1                                === g41 ===
            !wlt = vint_ci(list)-vint_ci(list+2)
            wlt_1 = One
            wlt_2 = -One
          end if
          if (jb_sys > 0) then
            w0 = (db+2)/(2*db+2)
            w1 = db/(2*db+2)
            !wls = (w0+w1)*vint_ci(list)+(w0-w1)*vint_ci(list+2)
            wls_1 = w0+w1
            wls_2 = w0-w1
            !wlt = vint_ci(list)-vint_ci(list+2)
            wlt_1 = One
            wlt_2 = -One
            w0 = sqrt(db*(db+2))/(2*db+2)
            w1 = -w0
            !wls1 = (w0+w1)*vint_ci(list)+(w0-w1)*vint_ci(list+2)
            wls1_1 = w0+w1
            wls1_2 = w0-w1

            w0 = db/(2*db+2)
            w1 = (db+2)/(2*db+2)
            !wls2 = (w0+w1)*vint_ci(list)+(w0-w1)*vint_ci(list+2)
            wls2_1 = w0+w1
            wls2_2 = w0-w1
          end if
          if (ni == 1) then
            wls_1 = -wls_1
            wls_2 = -wls_2
            wlt_1 = -wlt_1
            wlt_2 = -wlt_2
            wls1_1 = -wls1_1
            wls1_2 = -wls1_2
            wls2_1 = -wls2_1
            wls2_2 = -wls2_2
          end if
          call trans_ijkl_intpos(lri,lrk,lrj,lrl,nxo)
          nxo_1 = nxo
          call trans_ijkl_intpos(lri,lrl,lrk,lrj,nxo)
          nxo_2 = nxo
          call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
          call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
          call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
          if (jb_sys > 0) then
            iwls = just(lrl,lrk)
            iwrs = just(lri,lrj)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
            iwls = just(lrk,lrl)
            iwrs = just(lrj,lri)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
            iwrs = just(lri,lrj)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
            call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
          end if
          if (jb_sys > 1) then
            call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
            call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
          end if
        end if
      end do
    end do
  end do
end do

return

end subroutine dbl_space_loop_ijkl_sgezero_g

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004-2007, Markus Reiher                               *
*               2004-2006, Alexander Wolf                              *
************************************************************************
c
c
c*****************************************************************************************
c
c                  Implementation of the scalar-relativistic
c
c                       I N F I N I T E - O R D E R
c
c      G E N E R A L I Z E D   D O U G L A S - K R O L L - H E S S  (DKH)
c
c                         T R A N S F O R M A T I O N
c
c                                    F O R
c
c             H A M I L T O N I A N   A N D   P R O P E R T Y
c
c                 2006 Markus Reiher and Alexander Wolf, ETH Zurich
c                      Infinite-order DKH
c                      {markus.reiher,alexander.wolf}@phys.chem.ethz.ch
c
c
c   Reference to the infinite-order DKH method:
c
c     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 2037    part I   [Theory]
c     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 10945   part II  [Algorithm]
c     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064102  part III (Properties: theory)
c     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064103  part IV  (Properties: implem.)
c
c   Reference to the generalized higher-order DKH method:
c
c     A. Wolf, M. Reiher, B.A. Hess, J. Chem. Phys. 117 (2002) 9215-9226
c
c
c*****************************************************************************************
c
c
c
c
      subroutine adjust_param (dkhorder,xorder)
c
c***************************************************************************
c
c   Adjust parameters "maxoperators" and "maxuops" approriately,
c   i.e., depending on the chosen value of dkhorder.
c
c   written by:  M. Reiher and A. Wolf  (Univ. Jena)
c
c   last modified:  14.11.2006 (MR, ETH Zurich)
c
c***************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,xorder
c
      maxoperators=0
      maxuops=0
c
      if (dkhorder.le.6) then
         maxoperators=4000+xorder*2500
         maxuops=500+xorder*100
      else if (dkhorder.eq.7) then
         maxoperators=7000+xorder*2500
         maxuops=500+xorder*100
      else if (dkhorder.eq.8) then
        maxoperators=9500+xorder*8000
        maxuops=500+xorder*250
      else if (dkhorder.eq.9) then
        maxoperators=12500+xorder*10000
        maxuops=500+xorder*250
      else if (dkhorder.eq.10) then
        maxoperators=19000+xorder*17000
        maxuops=1000+xorder*300
      else if (dkhorder.eq.11) then
        maxoperators=30000+xorder*30000
        maxuops=1500+xorder*200
      else if (dkhorder.eq.12) then
        maxoperators=100000+xorder*100000
        maxuops=2000+xorder*200
      else
        write (stdout,1001)
 1001   format (/2X,'ERROR: In Subroutine adjust_param (dkhinf.f):',
     *    //11X,'Increase values for parameters ',
     *    'maxoperators and maxuops and recompile the code.',//2X,
     *    'STOP.',/2X)
         CALL Abend
      endif
c
      return
      end
c

c
      subroutine build_U (i,uniorder,dkhorder,xorder,dkhscfflg,ucounter,
     *               uopsleng,uoporder,eouops,duops,puop,uops,opcounter,
     *               operleng,oporder,evenodd,doperators,operators,
     *               wordercounter,wopscounter,wopsleng,woporder,eowops,
     *               dwops,wops,oddcounter,oddleng,oddorder,eoodd,dodd,
     *               odd,ducoeffs)
c
c*************************************************************************
c
c   Construct actual high-level U_i-operator, i.e., W_i and W_i^n.
c
c   Simplify it by neglect of all terms, which are irrelevant for
c     the chosen order, and eliminate all terms with 'coefficient=0'.
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 18.07.2005
c
c   first version: 22.07.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer i,uniorder,dkhorder,xorder
      integer ucounter,uopsleng(maxuops),uoporder(maxuops),
     *        eouops(maxuops),puop(maxuops)
      real*8 duops(maxuops)
      character*(maxlength) uops(maxuops)
c
      integer opcounter,operleng(maxoperators),oporder(maxoperators,3),
     *        evenodd(maxoperators),
     *        wordercounter(maxorder),wopscounter,wopsleng(maxuops),
     *        woporder(maxuops,3),eowops(maxuops),
     *        oddcounter,oddleng(maxuops),oddorder(maxuops,3),
     *        eoodd(maxuops)
      real*8 doperators(maxoperators),dwops(maxuops),
     *                 dodd(maxuops)
      character*(maxlength) wops(maxuops),odd(maxuops)
#if defined(_MOLCAS_) || defined(MOLPRO)
      character operators(*)
      character*(maxlength) opstring
#else
      character*(maxlength) operators(maxoperators)
#endif
c
      real*8 ducoeffs(maxorder)
c
      character*(3) scrchar, dkh_int2char
      integer maxpuop,j,k,idum
      intrinsic DBLE,DABS,INT
      do 10 j=1,maxuops
        uopsleng(j)=0
        uoporder(j)=0
        eouops(j)=0
        duops(j)=0.0d0
        puop(j)=0
        do 20 k=1,maxlength
          uops(j)(k:k)=' '
  20    continue
  10  continue
c   wordercounter(i):  number of terms (high-level) contributing to W_i.
c   NB: wordercounter(i)=oddcounter for actual 'i'
      wordercounter(i)=0
      oddcounter=0
      idum=0
      do 30 j=1,i-1
        idum=idum+wordercounter(j)
  30  continue
c
      do 50 j=1,opcounter
        if (evenodd(j).eq.-1 .and. oporder(j,3).eq.i) then
          wordercounter(i)=wordercounter(i)+1
          woporder(idum+wordercounter(i),1)=oporder(j,1)
          woporder(idum+wordercounter(i),2)=oporder(j,2)
          woporder(idum+wordercounter(i),3)=oporder(j,3)
          eowops(idum+wordercounter(i))=evenodd(j)
          dwops(idum+wordercounter(i))=doperators(j)
          wopsleng(idum+wordercounter(i))=operleng(j)+3
          if (wopsleng(idum+wordercounter(i)).gt.maxlength) then
            write (stdout,1001)
1001        format (/2X,'ERROR1 in SR "build_U":  wopsleng > maxlength',
     *              //2X,'STOP.',/2X)
            CALL Abend
          endif
#if defined(_MOLCAS_) || defined(MOLPRO)
          call get_dkoperators(j,opstring,operators)
          wops(idum+wordercounter(i))='B['//opstring(1:operleng(j))//']'
#else
          wops(idum+wordercounter(i))(1:wopsleng(idum+wordercounter(i)))
     *             ='B['//operators(j)(1:operleng(j))//']'
#endif
          oddcounter=oddcounter+1
          oddorder(oddcounter,1)=oporder(j,1)
          oddorder(oddcounter,2)=oporder(j,2)
          oddorder(oddcounter,3)=oporder(j,3)
          eoodd(oddcounter)=evenodd(j)
          dodd(oddcounter)=doperators(j)
          oddleng(oddcounter)=operleng(j)
#if defined(_MOLCAS_) || defined(MOLPRO)
          odd(oddcounter)=opstring(1:operleng(j))
#else
          odd(oddcounter)(1:oddleng(oddcounter))=
     *             operators(j)(1:operleng(j))
#endif
        endif
  50  continue
c
      wopscounter=wopscounter+wordercounter(i)
      maxpuop=INT(DBLE(max(dkhorder,xorder))/DBLE(i))
      if(i.ge.1.and.i.le.99) then
          scrchar=dkh_int2char(i)
          scrchar(1:1)='W'
      endif
cvv      do 13 k=1,99
cvv         if (i.eq.k) then
cvv          scrchar=dkh_int2char(k)
cvv          scrchar(1:1)='W'
cvv        endif
cvv 13   continue
      if (uniorder.gt.99) then
        write (stdout,1002)
1002    format (/2X,'Note: So far only 99 unitary transformations U_i',
     *          ' are possible in SR "build_U".')
        CALL Abend
      endif
c
      ucounter=1
      uoporder(1)=i
      eouops(1)=-1
      duops(1)=ducoeffs(1)
      puop(1)=1
      uopsleng(1)=3
      uops(1)(1:uopsleng(1))=scrchar
c
      do 100 j=2,maxpuop
        ucounter=ucounter+1
        uoporder(ucounter)=i*j
        eouops(ucounter)=(-1)**j
        duops(ucounter)=ducoeffs(j)
        puop(j)=j
        uopsleng(ucounter)=uopsleng(ucounter-1)+3
        if (uopsleng(ucounter).gt.maxlength) then
CMR040307        if (wopsleng(idum+wordercounter(i)).gt.maxlength) then
          write (stdout,1003)
CMR0403071003      format (/2X,'ERROR2 in SR "build_U:  wopsleng > maxlength'
1003      format (/2X,'ERROR2 in SR "build_U:  uleng > maxlength',
     *            //2X,'STOP.',/2X)
          CALL Abend
        endif
        uops(ucounter)(1:uopsleng(ucounter))=scrchar//uops(ucounter-1)
 100  continue
2000  continue
      do 110 j=1,ucounter
       if (abs(duops(j)).lt.dkhzero) then
         do 120 k=j+1,ucounter
            uoporder(k-1)=uoporder(k)
            eouops(k-1)=eouops(k)
            duops(k-1)=duops(k)
            puop(k-1)=puop(k)
            uopsleng(k-1)=uopsleng(k)
            uops(k-1)=uops(k)
 120      continue
          ucounter=ucounter-1
          goto 2000
        endif
 110  continue
CMR      if (i.le.9) then
CMR        write (stdout,1005) i,wordercounter(i)
CMR1005    format (2X,'Number of terms contributing to W',I1,':',2X,I6)
CMR      endif
CMR      if (i.ge.10) then
CMR        write (stdout,1006) i,wordercounter(i)
CMR1006    format (2X,'Number of terms contributing to W',I2,':',1X,I6)
CMR      endif
c
      if (ucounter.gt.maxuops) then
        write (stdout,1007)
1007    format (/2X,'WARNING: Too many U-operators (ucounter >',
     *          ' maxuops)!',/15X,'Increase maxuops ',
     *          '(e.g., by one order of magnitude)!')
        CALL Abend
      endif
c
CMR      if (i.le.9) then
CMR        write (stdout,1009) i,ucounter
CMR1009    format (2X,'Number of terms contributing to U',I1,':',2X,I6)
CMR      endif
CMR      if (i.ge.10) then
CMR        write (stdout,1010) i,ucounter
CMR1010    format (2X,'Number of terms contributing to U',I2,':',1X,I6)
CMR      endif
      if (dbgflg.ge.1 .and. i.le.9) write (dbgunit,1021) i,i,
     *                                                  wordercounter(i)
1021  format (//2X,'Transformation U',I1,' constructed. Operator W',I1,
     *        ' (',I4,' terms) stored in wops.')
      if (dbgflg.ge.1 .and.i.ge.10) write (dbgunit,1022) i,i,
     *                                                  wordercounter(i)
1022  format (//2X,'Transformation U',I2,' constructed. Operator W',I2,
     *        ' (',I4,' terms) stored in wops.')
c
      if (dbgflg.ne.0.and.(dbgflg.ge.2 .or. i.eq.uniorder)) then
        if (i.le.9) write (dbgunit,1023) i
1023    format (/2X,'Form of stored W-operators (wops) after ',
     *        'transformation U',I1,':',/2X,58('-'))
        if (i.ge.10) write (dbgunit,1024) i
1024    format (/2X,'Form of stored W-operators (wops) after ',
     *        'transformation U',I2,':',/2X,59('-'))
        call output2 (dbgunit,wopscounter,wopsleng,woporder,eowops,
     *                dwops,wops)
      endif
c
      if (dbgflg.ge.2) then
        write (dbgunit,1025)
1025    format(2X/)
        if (i.le.9.and.dbgflg.gt.0) then
          write (dbgunit,1027) i
1027      format (2X,'Terms contributing to transformation U',I1,':',
     *            /2X,40('-'))
        endif
        if (i.ge.10.and.dbgflg.gt.0) then
          write (dbgunit,1028) i
1028      format (2X,'Terms contributing to transformation U',I2,':',
     *            /2X,41('-'))
        endif
        call output2b (dbgunit,dkhscfflg,ucounter,uopsleng,uoporder,
     *                 eouops,duops,uops)
      endif
c
      return
      end
c
c
c
      subroutine calc_E0 (nbas,isize,h,revt,ew)
c
************************************************************************
c
c   Calculate  E0=h  (position space)
c
c   This SR belongs to dkhparser_numeric.
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 15.01.2007 (M. Reiher, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer nbas,isize,i,j,ij,k
      real*8 h(isize),revt(nbas,nbas),ew(nbas)
      ij=0
      do 100 i=1,nbas
        do 110 j=1,i
          ij=ij+1
          h(ij)=0.0D0
          do 120 k=1,nbas
            h(ij)=h(ij)+revt(i,k)*revt(j,k)*ew(k)
  120     continue
  110   continue
  100 continue
c
      return
      end
c
c
      subroutine calc_E1 (nbas,isize,xorder,dkhscfflg,h,v,pvp,x,pxp,vv,
     *                    dd,xx,jj,revt,tran,sinv,aa,rr,tt,scrno1,
     *                    scrno2,scr5,scr8,no_prop,nbasp,nbaso,dkhadr,
     *                    adrmem,dkh_48,adrnext)
c
************************************************************************
c
c   a) Calculate  E1=scr8(,1)  and  PE1P=scr8(,2)
c                 X0=scr8(,3)  and  PX0P=scr8(,4)
c
c   b) Set up  vv=V,  dd=pVp,  xx=X,  jj=pXp
c
c   c) CAUTION: x() is used a scratch here, so x() must be defined even
c               if no_prop=.true. !
c               (it contains the final result at the end but until then
c                it is considered scratch)
c
c   This SR belongs to dkhparser_numeric.
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena / ETH Zurich)
c
c   version:  2.2.0
c
c   last modified: 26.02.2007  (M. Reiher, ETH Zurich)
c            * completely rewritten to save memory
c            * required memory now: scrno2=5
c              (or only scrno2=3 if no_prop=.true.)
c            * note scrno1=3 here
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg,no_prop
      integer nbas,isize,xorder,scrno1,scrno2,nbasp,nbaso
      real*8 h(isize),v(isize),pvp(isize),x(isize),pxp(isize),
     *                 vv(nbaso,nbaso),dd(nbaso,nbaso),
     *                 xx(nbasp,nbasp),jj(nbasp,nbasp)
      real*8 revt(nbas,nbas),tran(nbas,nbas),sinv(nbas,nbas),
     *                 aa(nbas),rr(nbas),tt(nbas)
      real*8 scr5(nbas,nbas,scrno1),scr8(isize,scrno2)
c
      integer i,j,ij
c
      integer dkh_48,adrmem
      integer one,dkhadr(adrmem),adr,adrnext
      parameter(one=1)
c
c     consider Hamiltonian first; transform V to p**2-basis
c
      call trsm_dkh(v,sinv,scr5(1,1,3),nbas,scr5(1,1,1),scr5(1,1,2))
      call trsm_dkh(scr5(1,1,3),tran,scr8(1,3),nbas,scr5(1,1,1),
     *              scr5(1,1,2))
***   now: scr8(,3)=V (momentum-space)
c
c     Store V in momentum-space as square matrix vv if Out_Of_Core=.false.
c
      call mat_axa_tri (scr8(1,3),nbas,aa)
      if (Out_Of_Core) then
        dkhadr(1)=0
        adr=dkhadr(1)
        call ddafile(dkh_48,one,scr8(1,3),isize,adr)
      else
        call mat_sq_from_t (vv,nbas,scr8(1,3))
***     now:  vv=AVA (momentum space) (rectangular)
      end if
c
c     Multiply V with aa and rr factors
c
      ij=0
      do 10 i=1,nbas
        do 20 j=1,i
          ij=ij+1
          scr8(ij,1)=scr8(ij,3)
          scr8(ij,2)=4.0D0*rr(i)*rr(i)*tt(i)*
     *               scr8(ij,3)*tt(j)*rr(j)*rr(j)
  20   continue
  10  continue
***   now:  scr8(,1) = AVA (momentum-space)
c
c     Transform pVp integrals to p**2-basis
c
      call trsm_dkh(pvp,sinv,scr5(1,1,3),nbas,scr5(1,1,1),scr5(1,1,2))
      call trsm_dkh(scr5(1,1,3),tran,scr8(1,3),nbas,scr5(1,1,1),
     *              scr5(1,1,2))
***   now:  scr8(,3) = pVp (momentum-space)
c
c     Store pVp in momentum-space as square matrix dd
c
      call mat_arxra_tri (scr8(1,3),nbas,aa,rr)
      if (Out_Of_Core) then
        dkhadr(2)=adr
        call ddafile(dkh_48,one,scr8(1,3),isize,adr)
        adrnext=adr
      else
        call mat_sq_from_t (dd,nbas,scr8(1,3))
***     now:  dd=ApVpA (momentum space) (rectangular)
      end if
c
c     Multiply pVp  with aa and rr factors
c
      ij=0
      do 30 i=1,nbas
        do 40 j=1,i
          ij=ij+1
          scr8(ij,1)=scr8(ij,1)+scr8(ij,3)
          scr8(ij,2)=scr8(ij,2)+scr8(ij,3)
***   now: scr8(,2) = ARpVpRa = APVPA (momentum space)
***   now: scr8(,1) = E1 = AVA + APVPA (momentum-space)
c
  40    continue
  30  continue
c
      if (.not.no_prop) then
c
c     next: consider property operator; transform X to p**2-basis
c
        call trsm_dkh(x,sinv,scr5(1,1,3),nbas,scr5(1,1,1),scr5(1,1,2))
        call trsm_dkh(scr5(1,1,3),tran,scr8(1,5),nbas,scr5(1,1,1),
     *                scr5(1,1,2))
***   now: scr8(,5)=X (momentum-space)
c
c     Store X in momentum-space as square matrix xx
c
        call mat_axa_tri (scr8(1,5),nbas,aa)
        if (Out_Of_Core) then
          dkhadr(3)=adr
          call ddafile(dkh_48,one,scr8(1,5),isize,adr)
        else
          call mat_sq_from_t (xx,nbas,scr8(1,5))
***       now: xx=AXA (momentum space) (rectangular)
        end if
c
c     Multiply X with aa and rr factors
c
        ij=0
        do 11 i=1,nbas
          do 21 j=1,i
            ij=ij+1
            scr8(ij,3)=scr8(ij,5)
            scr8(ij,4)=4.0D0*rr(i)*rr(i)*tt(i)*
     *                 scr8(ij,5)*tt(j)*rr(j)*rr(j)
  21     continue
  11    continue
***   scr8(,3) = AXA (momentum-space)
c
c     Transform pXp integrals to p**2-basis
c
        call trsm_dkh(pxp,sinv,scr5(1,1,3),nbas,scr5(1,1,1),scr5(1,1,2))
        call trsm_dkh(scr5(1,1,3),tran,scr8(1,5),nbas,scr5(1,1,1),
     *                scr5(1,1,2))
***   now:  scr8(,5) = pXp (momentum-space)
c
c     Store pXp in momentum-space as square matrix jj
c
        call mat_arxra_tri (scr8(1,5),nbas,aa,rr)
        if (Out_Of_Core) then
          dkhadr(4)=adr
          call ddafile(dkh_48,one,scr8(1,5),isize,adr)
          adrnext=adr
        else
          call mat_sq_from_t (jj,nbas,scr8(1,5))
***       now: jj=ApXpA (momentum space) (rectangular)
        end if
c
c     Multiply pXp  with aa and rr factors
c
        ij=0
        do 31 i=1,nbas
          do 41 j=1,i
            ij=ij+1
            scr8(ij,3)=scr8(ij,3)+scr8(ij,5)
            scr8(ij,4)=scr8(ij,4)+scr8(ij,5)
***   now: scr8(,4) = ARpXpRa = APXPA (momentum space)
***   now: scr8(,3) = X0 = AXA + APXPA (momentum-space)
c
  41      continue
  31    continue
c
      end if
c
c  --> triangular E1, PE1P and X0, PX0P (momentum space) set up finished
c
c
c   the next steps are different for variational and perturbative treatment of X
c
      if (dkhscfflg.and..not.no_prop) then
***   scr8(,5) = E1 = E1 + X0 = E1(lambda) (momentum space)
        call mat_copy2 (scr8(1,5),isize,scr8(1,1))
        if (xorder.gt.0) call mat_tadd (1.0d0,scr8(1,5),isize,1.0d0,
     *                                  scr8(1,3))
c     transform E1 back to position-space
        call trsmt(scr8(1,5),revt,x,nbas,scr5(1,1,1),
     *               scr5(1,1,2))
***   now:  x = E1(X) (position space)
c
c     add E1 to final Hamiltonian
        call mat_tadd (1.0d0,h,isize,1.0d0,x)
c
      else
c
c     transform E1, X0 back to position-space
        call trsmt(scr8(1,1),revt,scr5(1,1,3),nbas,scr5(1,1,1),
     *               scr5(1,1,2))
c     add E1 to final Hamiltonian
        call mat_tadd (1.0d0,h,isize,1.0d0,scr5(1,1,3))
***   now:  h = E0+E1  (position-space)
        if (.not.no_prop) call trsmt(scr8(1,3),revt,x,nbas,scr5(1,1,1),
     *                               scr5(1,1,2))
***   now:  x        = X0 (position space)  --- if no_prop=.false.
c
      endif
c
      return
      end
c
c
c
c
      subroutine calc_operators (nbas,isize,dkhorder,xorder,dkhscfflg,
     *                       posu,post,poss,vv,nn,dd,yy,ff,gg,pp,xx,
     *                       ii,jj,kk,ll,mm,e,snumber,tnumber,unumber,
     *                       scrno1,scrno2,scr1,scr2,scr3,
     *                       scr5,scr8,revt,h,nbasp,nbaso,
     *                       dkhadr,adrmem,dkh_48,adrnext)
c
c************************************************************************
c
c   Calculate Hamiltonian up to desired order
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 13.03.2007 (MR, ETH Zurich)
c           * matrices can be read from disk
c           * scr4 and scr6 were eliminated from this routine and have been
c             replaced by scr5 and scr8, resp.;
c             hence, scrno1 has to be at least 3 (scrno1=3)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer nbas,isize,dkhorder,xorder,posu(maxunumber),nbasp,nbaso,
     *        post(maxsnumber),poss(maxsnumber),snumber,tnumber,unumber,
     *        scrno1,scrno2
c
      real*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp),e(nbas)
c
      real*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),
     *                 scr5(nbas,nbas,scrno1),
     *                 scr8(isize,scrno2),revt(nbas,nbas),h(isize)
c
      integer length,order(3),termcounter
c
      integer dkh_48,adrmem,adrnext
      integer dkhadr(adrmem)
c
#ifdef _MOLCAS_
      Integer IsFreeUnit
#endif
      character*(maxlength) scrtxt,term
CMR      character*(2) dkh_int2char2
      real*8 coeff
c
      integer i,j,k,idum1
c
#ifndef MOLPRO
#ifdef _MOLCAS_
      dkhunit1=11
      dkhunit1=IsFreeUnit(dkhunit1)
      Call Molcas_Open(dkhunit1,'dkhops.11')
#else
      open (dkhunit1, file='dkhops.11', status='OLD',
     *        form='FORMATTED')
#endif
#endif
      rewind(dkhunit1)
1009  read (dkhunit1,'(A3)') scrtxt(1:3)
      if (scrtxt(1:3).ne.'+++') goto 1009
c
CMR      if (dkhorder.gt.1 .and. dkhorder.le.9) then
CMR        write (stdout,1010) dkhorder
CMR1010    format (/,'SR calc_operators:  Start evaluation of the DKH',I1,
CMR     *          ' Hamiltonian.',/2X)
CMR      endif
CMR      if (dkhorder.ge.10) then
CMR        write (stdout,1011) dkhorder
CMR1011    format (/,'SR calc_operators:  Start evaluation of the DKH',I2,
CMR     *          ' Hamiltonian.',/2X)
CMR      endif
CMR      if (dkhorder.le.1) then
CMR        write (stdout,1012)
CMR1012    format (/,'SR calc_operators:  Nothing to do for DKH0 or DKH1.',
CMR     *          /2X)
CMR      endif
      do 10 i=2,dkhorder
CMR        write(*,*) "dkhorder=",i
c
1022    read (dkhunit1,'(A3)') scrtxt(1:3)
        if (scrtxt(1:3).ne.'***') goto 1022
        call mat_zero (scr5(1,1,1),nbas)
        do 20 j=1,maxlength
          scrtxt(j:j)=' '
  20    continue
        idum1=0
        do 23 j=1,3
          order(j)=0
  23    continue
        read (dkhunit1,'(5X,I2,19X,I6)') order(3),termcounter
        do 30 j=1,termcounter
          do 40 k=1,maxlength
            term(k:k)=' '
  40      continue
          idum1=0
c
          read (dkhunit1,
     *         '(I7,1X,I3,4X,I2,1X,I2,1X,I2,1X,A90,4X,F17.14)')
     *          idum1,length,order(1),order(2),order(3),
     *                       term(1:90),coeff
          do 50 k=1,length
            term(k:k)=term(90-length+k:90-length+k)
            term(90-length+k:90-length+k)=' '
  50      continue
CMR       write(*,*) "termcounter,term(1:length)=",j,term(1:length)
          call evalstring (length,term,coeff,nbas,posu,post,poss,vv,nn,
     *                     dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,
     *                     snumber,tnumber,unumber,scrno1,scr1,
     *                     scr2,scr3,scr5,nbasp,nbaso,dkhadr,adrmem,
     *                     dkh_48,adrnext)
          if (.not.(dkhscfflg .and. order(2).gt.xorder))
     *      call mat_plainadd (scr5(1,1,1),nbas,scr5(1,1,scrno1))
c
  30    continue
CMR      write(*,*) "calc_operators2: scr5(1,1,1)=",scr5(1,1,1)
        call mat_triang (scr8(1,1),nbas,scr5(1,1,1))
        call TrSmt(scr8(1,1),revt,scr8(1,2),nbas,scr5(1,1,scrno1-1),
     *             scr5(1,1,scrno1))
        call mat_tadd (1.0d0,h,isize,1.0d0,scr8(1,2))
CMR        write (stdout,1060) dkh_int2char2(i)
CMR1060    format (15X,'All terms belonging to E',A2,' have been ',
CMR     *          'evaluated.')
c
  10  continue
c
#ifndef MOLPRO
      close (dkhunit1)
#endif
c
      return
      end
c
c
      subroutine calc_orders (dkhscfflg,length,orderv,orderx,ordertot,
     *                        term,sorder,uorder)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 18.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer length,orderv,orderx, ordertot,sorder(maxsnumber,3),
     *        uorder(maxunumber,3)
      character*(maxlength) term
c
      integer poss,post,posw,i,idum,dkh_char2int
c
      posw=index(term(1:length),'W')
      if (posw.gt.0) then
        write (stdout,1002)
 1002   format (/2X,'ERROR in SR "calc_orders": W-operator occurs in ',
     *          'expression. This is not possible at this stage.',//2X,
     *          'STOP.',/2X)
        Call Abend
      endif
      poss=index(term(1:length),'S')
      post=index(term(1:length),'T')
c
      if (dkhscfflg) then
        if (poss.eq.0 .and. post.eq.0) then
          orderv=0
          orderx=0
          do 10 i=1,length
            if (term(i:i).eq.'V'.or.term(i:i).eq.'N'.or.term(i:i).eq.'D'
     *          .or. term(i:i).eq.'Y'.or.term(i:i).eq.'F'
     *          .or. term(i:i).eq.'G')  orderv=orderv+1
            if (term(i:i).eq.'X'.or.term(i:i).eq.'I'.or.term(i:i).eq.'J'
     *          .or. term(i:i).eq.'K'.or.term(i:i).eq.'L'
     *          .or. term(i:i).eq.'M')  orderx=orderx+1
            if (term(i:i).eq.'U') then
              idum=dkh_char2int(3,term(i+1:i+3))
              orderv=orderv+uorder(idum,1)
              orderx=orderx+uorder(idum,2)
            endif
  10      continue
        else
          orderv=0
          orderx=0
        endif
c
      else
c
        orderv=0
        orderx=0
        do 20 i=1,length
          if (term(i:i).eq.'V'.or.term(i:i).eq.'N'.or.term(i:i).eq.'D'
     *        .or. term(i:i).eq.'Y'.or.term(i:i).eq.'F'
     *        .or. term(i:i).eq.'G')  orderv=orderv+1
          if (term(i:i).eq.'X'.or.term(i:i).eq.'I'.or.term(i:i).eq.'J'
     *        .or. term(i:i).eq.'K'.or.term(i:i).eq.'L'
     *        .or. term(i:i).eq.'M')  orderx=orderx+1
          if (term(i:i).eq.'S' .or. term(i:i).eq.'T') then
            idum=dkh_char2int(3,term(i+1:i+3))
            orderv=orderv+sorder(idum,1)
            orderx=orderx+sorder(idum,2)
          endif
          if (term(i:i).eq.'U') then
            idum=dkh_char2int(3,term(i+1:i+3))
            orderv=orderv+uorder(idum,1)
            orderx=orderx+uorder(idum,2)
          endif
  20    continue
c
      endif
        if (.not.dkhscfflg .and. (orderv+orderx .ne. ordertot)) then
          write (stdout,1023) orderv,orderx,ordertot
1023      format (2X,'ERROR in SR "calc_orders":  orderv = ',I2,',',3X,
     *            'orderx = ',I2,',',5X,'ordertot = ',I2,//2X,'STOP.',
     *            //2X)
          CALL Abend
        endif
c
      return
      end
c
      subroutine calc_prefactors (nbas,isize,clight,aa,rr,tt,pp,e,ew)
c
c************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 25.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer nbas,isize
      real*8 clight,aa(nbas),rr(nbas),tt(nbas),pp(nbas),
     *                 e(nbas),ew(nbas)
      real*8 cl2,invcl2,ratio,tv1,tv2,tv3,tv4
      integer i
c
      cl2=clight*clight
      invcl2=1d0/(clight*clight)
c
      do 10 i=1,nbas
        if (ew(i).lt.0.0D0) then
          write(stdout,1000) i,ew(i)
1000      format (2X,'ERROR in SR "calc_prefactors":  ew(',I4,') = ',
     *            F16.8,' is less than zero.',//2X,'STOP.',/)
          CALL Abend
        endif
c
        ratio=ew(i)/clight
        tt(i)=ew(i)
c
        if (ratio.gt.0.02d0) then
          ew(i)=cl2*(sqrt(1.0D0+(invcl2+invcl2)*ew(i))-1.0d0)
        else
          tv1=ew(i)
          tv2=-tv1*ew(i)*invcl2/2.D0
          tv3=-tv2*ew(i)*invcl2
          tv4=-tv3*ew(i)*invcl2*1.25D0
          ew(i)=tv1+tv2+tv3+tv4
        endif
        e(i)=ew(i)+cl2
c
        aa(i)=sqrt((cl2+e(i))/(2.0D0*e(i)))
        rr(i)=clight/(cl2+e(i))
        pp(i)=2.0D0*tt(i)*rr(i)*rr(i)
c
  10  continue
c
c
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(isize)
      end
c
c
      subroutine calc_revt (nbas,revt,tran,sinv,scrmat1,scrmat2)
c
c************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 25.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer nbas
      real*8 revt(nbas,nbas),tran(nbas,nbas),sinv(nbas,nbas),
     *                 scrmat1(nbas,nbas),scrmat2(nbas,nbas)
      integer i,j,k
      call mat_zero (scrmat2,nbas)
      call mat_zero (revt,nbas)
c
      do 10 i=1,nbas
        do 20 j=1,nbas
          do 30 k=i,nbas
            scrmat2(i,j)=scrmat2(i,j)+sinv(i,k)*tran(k,j)
  30       continue
  20     continue
  10   continue
c
      do 40 i=1,nbas
        do 50 j=1,nbas
          do 60 k=1,nbas
            revt(i,j)=revt(i,j)+scrmat1(i,k)*scrmat2(k,j)
  60      continue
  50    continue
  40  continue
c
      return
      end
c
c
      subroutine calc_smult (jnumber,smult,termcounter,termleng,term)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 18.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer jnumber,smult,termcounter,termleng(maxoperators)
#if defined(_MOLCAS_) || defined(MOLPRO)
      integer term(*)
      character*(maxlength) termstr
#else
      character*(maxlength) term(maxoperators)
#endif
c
      integer k,l
c
      smult=0
      do 100 k=1,termcounter
#if defined(_MOLCAS_) || defined(MOLPRO)
        call get_dkoperators_i(k,termstr,term)
#endif
        do 200 l=1,termleng(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
          if ( termstr(l:l).eq.'V' .or. termstr(l:l).eq.'N' .or.
     *         termstr(l:l).eq.'D' .or. termstr(l:l).eq.'Y' .or.
     *         termstr(l:l).eq.'F' .or. termstr(l:l).eq.'G' .or.
     *         termstr(l:l).eq.'Z' .or. termstr(l:l).eq.'Q' .or.
     *         termstr(l:l).eq.'X' .or. termstr(l:l).eq.'I' .or.
     *         termstr(l:l).eq.'J' .or. termstr(l:l).eq.'K' .or.
     *         termstr(l:l).eq.'L' .or. termstr(l:l).eq.'M' .or.
     *         termstr(l:l).eq.'S' .or. termstr(l:l).eq.'T' .or.
     *         termstr(l:l).eq.'U' )   smult=smult+1
#else
          if ( term(k)(l:l).eq.'V' .or. term(k)(l:l).eq.'N' .or.
     *         term(k)(l:l).eq.'D' .or. term(k)(l:l).eq.'Y' .or.
     *         term(k)(l:l).eq.'F' .or. term(k)(l:l).eq.'G' .or.
     *         term(k)(l:l).eq.'Z' .or. term(k)(l:l).eq.'Q' .or.
     *         term(k)(l:l).eq.'X' .or. term(k)(l:l).eq.'I' .or.
     *         term(k)(l:l).eq.'J' .or. term(k)(l:l).eq.'K' .or.
     *         term(k)(l:l).eq.'L' .or. term(k)(l:l).eq.'M' .or.
     *         term(k)(l:l).eq.'S' .or. term(k)(l:l).eq.'T' .or.
     *         term(k)(l:l).eq.'U' )   smult=smult+1
#endif
 200    continue
 100  continue
      smult=smult-termcounter
c
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(jnumber)
      end
c
c
c
      subroutine calc_stimes1 (knumber,wstart,sused,stimes,wstimes,
     *                         ttimes,reslengl,reslengr,rescharl,
     *                         rescharr)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 18.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer knumber,wstart,sused,reslengl,reslengr,stimes(maxsnumber),
     *        m,wstimes(maxuops,maxsnumber),ttimes(maxsnumber)
      character*(maxlength) rescharl,rescharr
      integer dummyleng,idum,istart,iposs,dkh_char2int
c
      if (knumber.gt.1) then
        istart=1
1083    continue
        iposs=0
        iposs=index(rescharl(istart:reslengl),'S')
        if (iposs.gt.0) then
          dummyleng=3
          idum=dkh_char2int(dummyleng,
     *                        rescharl(istart+iposs:istart+iposs+2))
          stimes(idum)=stimes(idum)+1
          istart=istart+iposs+3
          goto 1083
        endif
        istart=1
1084    continue
        iposs=0
        if (istart.le.reslengr) then
          iposs=index(rescharr(istart:reslengr),'S')
          if (iposs.gt.0) then
            dummyleng=3
            idum=dkh_char2int(dummyleng,
     *                          rescharr(istart+iposs:istart+iposs+2))
            stimes(idum)=stimes(idum)+1
            istart=istart+iposs+3
            goto 1084
          endif
        endif
c
      endif
      if (knumber.gt.1) then
        istart=1
1093    continue
        iposs=0
        iposs=index(rescharl(istart:reslengl),'T')
        if (iposs.gt.0) then
          dummyleng=3
          idum=dkh_char2int(dummyleng,
     *                        rescharl(istart+iposs:istart+iposs+2))
          ttimes(idum)=ttimes(idum)+1
          istart=istart+iposs+3
          goto 1093
        endif
        istart=1
1094    continue
        iposs=0
        if (istart.le.reslengr) then
          iposs=index(rescharr(istart:reslengr),'T')
          if (iposs.gt.0) then
            dummyleng=3
            idum=dkh_char2int(dummyleng,
     *                          rescharr(istart+iposs:istart+iposs+2))
            ttimes(idum)=ttimes(idum)+1
            istart=istart+iposs+3
            goto 1094
          endif
        endif
c
      endif
      do 352 m=1,sused
        stimes(m)=stimes(m)+wstimes(knumber+wstart-1,m)
 352  continue
c
      return
      end
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine calc_stimes2 (stimes,ttimes,reslengl,reslengr,
     *                         rescharl,rescharr)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 11.10.2006 (MR, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer reslengl,reslengr,stimes(maxsnumber),
     *        ttimes(maxsnumber)
      character*(maxlength) rescharl,rescharr
      integer dummyleng,idum,istart,iposs,dkh_char2int
c
      istart=1
1083  continue
      iposs=0
      iposs=index(rescharl(istart:reslengl),'S')
      if (iposs.gt.0) then
        dummyleng=3
        idum=dkh_char2int(dummyleng,
     *                      rescharl(istart+iposs:istart+iposs+2))
        stimes(idum)=stimes(idum)+1
        istart=istart+iposs+3
        goto 1083
      endif
      istart=1
1084  continue
      iposs=0
      if (istart.le.reslengr) then
        iposs=index(rescharr(istart:reslengr),'S')
        if (iposs.gt.0) then
          dummyleng=3
          idum=dkh_char2int(dummyleng,
     *                        rescharr(istart+iposs:istart+iposs+2))
          stimes(idum)=stimes(idum)+1
          istart=istart+iposs+3
          goto 1084
        endif
      endif
      istart=1
1093  continue
      iposs=0
      iposs=index(rescharl(istart:reslengl),'T')
      if (iposs.gt.0) then
        dummyleng=3
        idum=dkh_char2int(dummyleng,
     *                      rescharl(istart+iposs:istart+iposs+2))
        ttimes(idum)=ttimes(idum)+1
        istart=istart+iposs+3
        goto 1093
      endif
      istart=1
1094  continue
      iposs=0
      if (istart.le.reslengr) then
        iposs=index(rescharr(istart:reslengr),'T')
        if (iposs.gt.0) then
          dummyleng=3
          idum=dkh_char2int(dummyleng,
     *                        rescharr(istart+iposs:istart+iposs+2))
          ttimes(idum)=ttimes(idum)+1
          istart=istart+iposs+3
          goto 1094
        endif
      endif
c
      return
      end
c
c
      subroutine calc_Sxxx (nbas,dkhorder,xorder,dkhscfflg,posu,post,
     *                      poss,vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,
     *                      mm,e,snumber,tnumber,unumber,scrno1,
     *                      scr1,scr2,scr3,scr5,nbasp,nbaso,
     *                      dkhadr,adrmem,dkh_48,adrnext)
c
c************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 13.03.2007 (M. Reiher, ETH Zurich)
c            * result matrix can now be written to disk
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
#include "WrkSpc.fh"
c
      logical dkhscfflg
      integer nbas,dkhorder,xorder,posu(maxunumber),post(maxsnumber),
     *        poss(maxsnumber),snumber,tnumber,unumber,scrno1,nbasp,
     *        nbaso
c
      real*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp),e(nbas)
c
      real*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),
     *                 scr5(nbas,nbas,scrno1)
c
      integer length,order(3),termcounter
      character*(maxlength) scrtxt,term
#ifdef _MOLCAS_
      Integer IsFreeUnit
#endif
#ifdef _DEBUGPRINT_
      character*(3) dkh_int2char
#endif
      real*8 coeff
c
      integer i,j,k,idum1,idum2
c
      integer dkh_48,adrmem,idum3,iscr,adrnext,adr
      integer one,dkhadr(adrmem)
      parameter(one=1)
      idum3=0
c
#ifndef MOLPRO
#ifdef _MOLCAS_
      dkhunit3=13
      dkhunit3=IsFreeUnit(dkhunit3)
      Call Molcas_Open(dkhunit3,'dkhops.13')
#else
      open (dkhunit3, file='dkhops.13', status='OLD',
     *        form='FORMATTED')
#endif
#endif
      rewind(dkhunit3)
1009  read (dkhunit3,'(A3)') scrtxt(1:3)
      if (scrtxt(1:3).ne.'+++') goto 1009
      read (dkhunit3, '(I3)') idum1
c
CMR      if (snumber.gt.0) then
CMR        write (stdout,1010) snumber
CMR1010    format (/,'SR calc_Sxxx:  Start evaluation of the ',I3,
CMR     *          ' Sxxx matrices.',/2X)
CMR      endif
CMR      if (snumber.eq.0) then
CMR        write (stdout,1011)
CMR1011    format (/,'SR calc_Sxxx:  Nothing to do here.',/2X)
CMR      endif
c
      if (Out_Of_Core)
     *  call GetMem('calc_Un ','ALLO','REAL',iscr,nbas*nbas+4)
c
      do 10 i=1,snumber
c
1022    read (dkhunit3,'(A3)') scrtxt(1:3)
        if (scrtxt(1:3).ne.'***') goto 1022
        do 20 j=1,maxlength
          scrtxt(j:j)=' '
  20    continue
        idum1=0
        do 23 j=1,3
          order(j)=0
  23    continue
        read (dkhunit3,'(A1,I3,1X,A9,1X,I2,1X,I2,1X,I2,2X,I7)')
     *          scrtxt(1:1),idum1,scrtxt(1:9),order(1),order(2),
     *          order(3),termcounter
        poss(idum1)=i
        if (Out_Of_Core) then
          idum3=1000+idum1
          call mat_zero (work(iscr),nbas)
        else
          call mat_zero (scr1(1,1,poss(idum1)),nbas)
        end if
        if (order(3).gt.Max(dkhorder,xorder+1)) then
#ifdef _DEBUGPRINT_
          write (stdout,1040) i,dkh_int2char(idum1)
1040      format (15X,I3,2X,'S',A3,' is not required here; thus skip ',
     *            'it.')
#endif
          goto 10
        endif
        do 30 j=1,termcounter
          do 40 k=1,maxlength
            term(k:k)=' '
  40      continue
          idum2=0
          do 43 k=1,3
            order(k)=0
  43      continue
c
          read (dkhunit3,
     *         '(I7,2X,I3,3X,I2,1X,I2,1X,I2,1X,A90,4X,F17.14)')
     *          idum2,length,order(1),order(2),order(3),
     *                      term(1:90),coeff
          do 50 k=1,length
            term(k:k)=term(90-length+k:90-length+k)
            term(90-length+k:90-length+k)=' '
  50      continue
          call evalstring (length,term,coeff,nbas,posu,post,poss,vv,nn,
     *                     dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,
     *                     snumber,tnumber,unumber,scrno1,scr1,
     *                     scr2,scr3,scr5,nbasp,nbaso,dkhadr,adrmem,
     *                     dkh_48,adrnext)
          if (.not.(dkhscfflg .and. order(2).gt.xorder)) then
            if (Out_Of_Core) then
              call mat_plainadd (work(iscr),nbas,scr5(1,1,scrno1))
            else
              call mat_plainadd (scr1(1,1,poss(idum1)),nbas,
     *                          scr5(1,1,scrno1))
            end if
          end if
c
  30    continue
c
        if (Out_Of_Core) then
          if (i.eq.1) adr=adrnext
          dkhadr(idum3)=adr
          call ddafile(dkh_48,one,work(iscr),nbas*nbas,adr)
          if (i.eq.snumber) adrnext=adr
CMR        write(*,*) "S : scr1(1,1,poss(idum1))=",work(iscr)
        else
CMR        write(*,*) "S : scr1(1,1,poss(idum1))=",scr1(1,1,poss(idum1))
        end if
c
#ifdef _DEBUGPRINT_
        write (stdout,1060) i,dkh_int2char(idum1)
1060    format (15X,I3,2X,'S',A3,' has now been completed.')
#endif
c
  10  continue
c
      if (Out_Of_Core)
     *  call GetMem('calc_Un ','FREE','REAL',iscr,nbas*nbas+4)
c
#ifndef MOLPRO
      close (dkhunit3)
#endif
c
CMR      write (stdout,1090)
CMR1090  format (/15X,'All Sxxx matrices have been stored in scr1().')
c
      return
      end
c
c
      subroutine calc_Txxx (nbas,dkhorder,xorder,dkhscfflg,posu,post,
     *                      poss,vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,
     *                      mm,e,snumber,tnumber,unumber,scrno1,
     *                      scr1,scr2,scr3,scr5,nbasp,nbaso,
     *                      dkhadr,adrmem,dkh_48,adrnext)
c
c************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 13.03.2007 (M. Reiher, ETH Zurich)
c            * result matrix can now be written to disk
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
#include "WrkSpc.fh"
c
      logical dkhscfflg
      integer nbas,dkhorder,xorder,posu(maxunumber),post(maxsnumber),
     *        poss(maxsnumber),snumber,tnumber,unumber,scrno1,nbasp,
     *        nbaso
c
      real*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp),e(nbas)
c
      real*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),
     *                 scr5(nbas,nbas,scrno1)
c
      integer length,order(3),termcounter
      character*(maxlength) scrtxt,term
CMR      character*(3) dkh_int2char
#ifdef _MOLCAS_
      Integer IsFreeUnit
#endif
      real*8 coeff
c
      integer i,j,k,idum1,idum2
c
      integer dkh_48,adrmem,idum3,iscr,adrnext,adr
      integer one,dkhadr(adrmem)
      parameter(one=1)
      idum3=0
c
#ifndef MOLPRO
#ifdef _MOLCAS_
      dkhunit4=14
      dkhunit4=IsFreeUnit(dkhunit4)
      Call Molcas_Open(dkhunit4,'dkhops.14')
#else
      open (dkhunit4, file='dkhops.14', status='OLD',
     *        form='FORMATTED')
#endif
#endif
      rewind(dkhunit4)
1009  read (dkhunit4,'(A3)') scrtxt(1:3)
      if (scrtxt(1:3).ne.'+++') goto 1009
      read (dkhunit4, '(I3)') idum1
c
CMR      if (tnumber.gt.0) then
CMR        write (stdout,1010) tnumber
CMR1010    format (/,'SR calc_Txxx:  Start evaluation of the ',I3,
CMR     *          ' Txxx matrices.',/2X)
CMR      endif
CMR      if (tnumber.eq.0) then
CMR        write (stdout,1011)
CMR1011    format (/,'SR calc_Txxx:  Nothing to do here.')
CMR      endif
c
      if (Out_Of_Core)
     *  call GetMem('calc_Un ','ALLO','REAL',iscr,nbas*nbas+4)
c
      do 10 i=1,tnumber
c
1022    read (dkhunit4,'(A3)') scrtxt(1:3)
        if (scrtxt(1:3).ne.'***') goto 1022
        do 20 j=1,maxlength
          scrtxt(j:j)=' '
  20    continue
        idum1=0
        do 23 j=1,3
          order(j)=0
  23    continue
        read (dkhunit4,'(A1,I3,1X,A11,1X,I2,1X,I2,1X,I2,2X,I7)')
     *          scrtxt(1:1),idum1,scrtxt(1:11),order(1),order(2),
     *          order(3),termcounter
        post(idum1)=i
        if (Out_Of_Core) then
          idum3=2000+idum1
          call mat_zero (work(iscr),nbas)
        else
          call mat_zero (scr2(1,1,post(idum1)),nbas)
        end if
        if (order(3).gt.Max(dkhorder,xorder+1)) then
CMR          write (stdout,1040) i,dkh_int2char(idum1)
CMR1040      format (15X,I3,2X,'T',A3,' is not required here; thus skip ',
CMR     *            'it.')
          goto 10
        endif
        do 30 j=1,termcounter
          do 40 k=1,maxlength
            term(k:k)=' '
  40      continue
          idum2=0
          do 43 k=1,3
            order(k)=0
  43      continue
c
          read (dkhunit4,
     *         '(I7,2X,I3,5X,I2,1X,I2,1X,I2,1X,A90,4X,F17.14)')
     *          idum2,length,order(1),order(2),order(3),
     *                       term(1:90),coeff
          do 50 k=1,length
            term(k:k)=term(90-length+k:90-length+k)
            term(90-length+k:90-length+k)=' '
  50      continue
          call evalstring (length,term,coeff,nbas,posu,post,poss,vv,nn,
     *                     dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,
     *                     snumber,tnumber,unumber,scrno1,scr1,
     *                     scr2,scr3,scr5,nbasp,nbaso,dkhadr,adrmem,
     *                     dkh_48,adrnext)
          if (.not.(dkhscfflg .and. order(2).gt.xorder)) then
            if (Out_Of_Core) then
              call mat_plainadd (work(iscr),nbas,scr5(1,1,scrno1))
            else
              call mat_plainadd (scr2(1,1,post(idum1)),nbas,
     *                           scr5(1,1,scrno1))
            end if
          end if
c
  30    continue
c
        if (Out_Of_Core) then
          if (i.eq.1) adr=adrnext
          dkhadr(idum3)=adr
          call ddafile(dkh_48,one,work(iscr),nbas*nbas,adr)
          if (i.eq.tnumber) adrnext=adr
        end if
c
CMR        write (stdout,1060) i,dkh_int2char(idum1)
CMR1060    format (15X,I3,2X,'T',A3,' has now been completed.')
c
  10  continue
c
      if (Out_Of_Core)
     *  call GetMem('calc_Un ','FREE','REAL',iscr,nbas*nbas+4)
c
#ifndef MOLPRO
      close (dkhunit4)
#endif
c
CMR      if (tnumber.gt.0) write (stdout,1090)
CMR1090  format (/15X,'All Txxx matrices have been stored in scr2().')
c
      return
      end
c
c
      subroutine calc_Uxxx (nbas,dkhorder,xorder,dkhscfflg,posu,post,
     *                      poss,vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,
     *                      mm,e,snumber,tnumber,unumber,scrno1,
     *                      scr1,scr2,scr3,scr5,nbasp,nbaso,
     *                      dkhadr,adrmem,dkh_48,adrnext)
c
c************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 13.03.2007 (M. Reiher, ETH Zurich)
c            * result matrix may be written to disk
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer nbas,dkhorder,xorder,posu(maxunumber),post(maxsnumber),
     *        poss(maxsnumber),snumber,tnumber,unumber,scrno1,nbasp,
     *        nbaso
c
      real*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp),e(nbas)
c
      real*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),
     *                 scr5(nbas,nbas,scrno1)
c
      character*(maxlength) scrtxt
#ifdef _MOLCAS_
      Integer IsFreeUnit
#endif
      integer length,i,j,idum1,order(3)
      real*8 coeff
c
      integer dkh_48,adrmem,idum2,adrnext,adr
      integer one,dkhadr(adrmem)
      parameter(one=1)
c
#ifndef MOLPRO
#ifdef _MOLCAS_
      dkhunit5=15
      dkhunit5=IsFreeUnit(dkhunit5)
      Call Molcas_Open(dkhunit5,'dkhops.15')
#else
      open (dkhunit5, file='dkhops.15', status='OLD',
     *        form='FORMATTED')
#endif
#endif
      rewind(dkhunit5)
1009  read (dkhunit5,'(A3)') scrtxt(1:3)
      if (scrtxt(1:3).ne.'+++') goto 1009
      read (dkhunit5, '(I3)') idum1
c
      do 10 i=1,unumber
        do 20 j=1,maxlength
          scrtxt(j:j)=' '
  20    continue
        length=0
        idum1=0
        do 23 j=1,3
          order(j)=0
  23    continue
        read (dkhunit5,'(I1,3X,A1,I3,3X,A3,8X,I2,8X,I2,9X,I2)')
     *          length,scrtxt(1:1),idum1,scrtxt(1:3),order(1),order(2),
     *          order(3)
        posu(idum1)=i
        coeff=1.0d0
        call evalstring (length,scrtxt,coeff,nbas,posu,post,poss,vv,nn,
     *                   dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,snumber,
     *                   tnumber,unumber,scrno1,scr1,scr2,scr3,scr5,
     *                   nbasp,nbaso,dkhadr,adrmem,dkh_48,adrnext)
        if (dkhscfflg .and. order(2).gt.xorder) then
          call mat_zero (scr5(1,1,scrno1),nbas)
        else
          if (Out_Of_Core) then
            if (i.eq.1) adr=adrnext
            idum2=idum1+3000
            dkhadr(idum2)=adr
            call ddafile(dkh_48,one,scr5(1,1,scrno1),nbas*nbas,
     *                   adr)
            if (i.eq.unumber) adrnext=adr
          else
            call mat_copy (scr3(1,1,posu(idum1)),nbas,nbas,
     *                     scr5(1,1,scrno1))
          endif
CMR       write(*,*) "U : scr5(1,1,scrno1)=",scr5(1,1,scrno1)
        endif
c
  10  continue
CMR      if (unumber.gt.0) then
CMR        write (stdout,1072) unumber
CMR1072    format (/,'SR calc_Uxxx:  All ',I3,' Uxxx matrices ',
CMR     *          'have successfully been evaluated.',/15X,'They have ',
CMR     *          'been stored in scr3().')
CMR      endif
CMR      if (unumber.eq.0) then
CMR        write (stdout,1073)
CMR1073    format (/,'SR calc_Uxxx:  Nothing to do here.')
CMR      endif
c
#ifndef MOLPRO
      close (dkhunit5)
#endif
c
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dkhorder)
      end
c
c
      subroutine calc_xoperators (nbas,isize,dkhorder,xorder,dkhscfflg,
     *                      posu,post,poss,vv,nn,dd,yy,ff,gg,pp,xx,
     *                      ii,jj,kk,ll,mm,e,snumber,tnumber,unumber,
     *                      scrno1,scrno2,scr1,scr2,scr3,
     *                      scr5,scr8,revt,x,nbasp,nbaso,
     *                      dkhadr,adrmem,dkh_48,adrnext)
c
c************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 13.03.2007 (MR, ETH Zurich)
c             * scr4 and scr7 were eliminated and replaced by scr5 and
c               scr7, resp.; hence,
c               scrno1 now must be at least 3 (scrno1=3)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer nbas,isize,dkhorder,xorder,posu(maxunumber),nbasp,nbaso,
     *        post(maxsnumber),poss(maxsnumber),snumber,tnumber,unumber,
     *        scrno1,scrno2
c
      real*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp),e(nbas)
c
      real*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),
     *                 scr5(nbas,nbas,scrno1),
     *                 scr8(isize,scrno2),revt(nbas,nbas),x(isize)
c
      integer dkh_48,adrmem,adrnext
      integer dkhadr(adrmem)
c
      integer length,order,termcounter
      character*(maxlength) scrtxt,term
#ifdef _MOLCAS_
      Integer IsFreeUnit
#endif
CMR      character*(2) dkh_int2char2
      real*8 coeff
c
      integer i,j,k,idum1
c
#ifndef MOLPRO
#ifdef _MOLCAS_
      dkhunit2=12
      dkhunit2=IsFreeUnit(dkhunit2)
      Call Molcas_Open(dkhunit2,'dkhops.12')
#else
      open (dkhunit2, file='dkhops.12', status='OLD',
     *        form='FORMATTED')
#endif
#endif
      rewind(dkhunit2)
1009  read (dkhunit2,'(A3)') scrtxt(1:3)
      if (scrtxt(1:3).ne.'+++') goto 1009
c
CMR      if (xorder.ge.1 .and. xorder.le.9) then
CMR        write (stdout,1010) xorder
CMR1010    format (/,'SR calc_xoperators:  Start evaluation of the DKH',I1,
CMR     *          '-transformed property X.',/2X)
CMR      endif
CMR      if (xorder.ge.10) then
CMR        write (stdout,1011) xorder
CMR1011    format (/,'SR calc_xoperators:  Start evaluation of the DKH',I2,
CMR     *          '-transformed property X.',/2X)
CMR      endif
CMR      if (xorder.le.0) then
CMR        write (stdout,1012)
CMR1012    format (/,'SR calc_xoperators:  Nothing to do for X(,0).',
CMR     *          /2X)
CMR      endif
c
      do 10 i=1,xorder
c
1022    read (dkhunit2,'(A3)') scrtxt(1:3)
        if (scrtxt(1:3).ne.'***') goto 1022
        call mat_zero (scr5(1,1,1),nbas)
        do 20 j=1,maxlength
          scrtxt(j:j)=' '
  20    continue
        idum1=0
        order=0
        read (dkhunit2,'(5X,I2,17X,I6)') order,termcounter
        do 30 j=1,termcounter
          do 40 k=1,maxlength
            term(k:k)=' '
  40      continue
          idum1=0
          order=0
c
          read (dkhunit2,'(I7,1X,I3,5X,I2,5X,A90,4X,F17.14)')
     *            idum1,length,order,term(1:90),coeff
          do 50 k=1,length
            term(k:k)=term(90-length+k:90-length+k)
            term(90-length+k:90-length+k)=' '
  50      continue
          call evalstring (length,term,coeff,nbas,posu,post,poss,vv,nn,
     *                     dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,
     *                     snumber,tnumber,unumber,scrno1,scr1,scr2,
     *                     scr3,scr5,nbasp,nbaso,dkhadr,adrmem,dkh_48,
     *                     adrnext)
          call mat_plainadd (scr5(1,1,1),nbas,scr5(1,1,scrno1))
c
  30    continue
        call mat_triang (scr8(1,1),nbas,scr5(1,1,1))
        call TrSmt(scr8(1,1),revt,scr8(1,2),nbas,scr5(1,1,scrno1-1),
     *                                               scr5(1,1,scrno1))
        call mat_tadd (1.0d0,x(1),isize,1.0d0,scr8(1,2))
CMR        write (stdout,1060) dkh_int2char2(i)
CMR1060    format (15X,'All terms belonging to X',A2,' have been ',
CMR     *          'evaluated.')
c
  10  continue
c
#ifndef MOLPRO
      close (dkhunit2)
#endif
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(dkhorder)
        call Unused_logical(dkhscfflg)
      end if
      end
c
c
      subroutine concatenate (operleng,operator,reslengl,rescharl,
     *                        termleng,term,reslengr,rescharr)
c
c***************************************************************************
c
c   Concatenate:  operator = rescharl // term // rescharr
c
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 12.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer operleng,reslengl,termleng,reslengr
      character*(maxlength) operator,rescharl,rescharr
      character*(*) term
c
c  Consistency check
      if (operleng.ne.reslengl+termleng+reslengr) then
        write (stdout,3000) operleng,reslengl,termleng,reslengr
3000    format (/2X,'ERROR in subroutine concatenate: operleng =',
     *          I4,' is not equal to reslengl+termleng+reslengr (=',
     *          I3,'+',I3,'+',I3,') as it should.',//2X,'STOP.',/)
        CALL Abend
      endif
c
#if defined(_MOLCAS_) || defined(MOLPRO)
      if (reslengl.ne.0.and.reslengr.ne.0)
     *    operator=rescharl(1:reslengl)//term(1:termleng)
     *       //rescharr(1:reslengr)
      if (reslengl.ne.0.and.reslengr.eq.0)
     *    operator=rescharl(1:reslengl)//term(1:termleng)
      if (reslengl.eq.0.and.reslengr.ne.0)
     *    operator=term(1:termleng)//rescharr(1:reslengr)
      if (reslengl.eq.0.and.reslengr.eq.0)
     *    operator=term(1:termleng)
#else
      if (reslengl.ne.0.and.reslengr.ne.0)
     *    operator(1:operleng)=rescharl(1:reslengl)//term(1:termleng)
     *       //rescharr(1:reslengr)
      if (reslengl.ne.0.and.reslengr.eq.0)
     *    operator(1:operleng)=rescharl(1:reslengl)//term(1:termleng)
      if (reslengl.eq.0.and.reslengr.ne.0)
     *    operator(1:operleng)=term(1:termleng)//rescharr(1:reslengr)
      if (reslengl.eq.0.and.reslengr.eq.0)
     *    operator(1:operleng)=term(1:termleng)
#endif
c
      return
      end
c
c
      subroutine determine_factor (length,term,iact,nbas,posu,post,poss,
     *                       vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,
     *                       snumber,tnumber,unumber,scr1,scr2,scr3,
     *                       factor,nbasp,nbaso,dkhadr,adrmem,dkh_48,
     *                       adrnext)
c
c****************************************************************************
c
c   Determine which factor stands at position 'iact' of 'term'.
c   Store its matrix representation in 'factor'.
c
c   Adjust value of 'iact', such that it points at beginning of next factor.
c
c   Note: There are no brackets [] occurring in term.
c
c   This SR belongs to dkhparser_numeric.
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.2.0
c
c   last modified: 13.03.2007 (M. Reiher, ETH Zurich)
c                  * reading from disk was included
c                  * a couple of loops were re-arranged for speed up
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c****************************************************************************
c
      implicit none
#include "dkhparameters.fh"
#include "WrkSpc.fh"
c
      integer length,iact,nbas,posu(maxunumber),post(maxsnumber),
     *        poss(maxsnumber),snumber,tnumber,unumber,nbasp,nbaso
      character*(maxlength) term
c
      real*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp)
      real*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),factor(nbas,nbas)
c
      integer idum1,dkh_char2int,i,j
c
      integer dkh_48,adrmem,adr,iscr,isize,adrnext
      integer two,dkhadr(adrmem)
      logical flag
      parameter(two=2)
      flag=.true.
      isize=(nbas*(nbas+1)/2)
c
c------------------------------------------------------------------------
c
      if (Out_Of_Core) then
       if (term(iact:iact).eq.'S') then
         idum1=dkh_char2int(3,term(iact+1:iact+3))
         idum1=1000+idum1
         iact=iact+4
         adr=dkhadr(idum1)
         isize=nbas*nbas
       else if (term(iact:iact).eq.'T') then
         idum1=dkh_char2int(3,term(iact+1:iact+3))
         idum1=2000+idum1
         iact=iact+4
         adr=dkhadr(idum1)
         isize=nbas*nbas
       else if (term(iact:iact).eq.'U') then
         idum1=dkh_char2int(3,term(iact+1:iact+3))
         idum1=3000+idum1
         iact=iact+4
         adr=dkhadr(idum1)
         isize=nbas*nbas
       else if (term(iact:iact).eq.'V') then
         iact=iact+1
         adr=dkhadr(1)
       else if (term(iact:iact).eq.'N') then
         iact=iact+1
         adr=dkhadr(5)
       else if (term(iact:iact).eq.'D') then
         iact=iact+1
         adr=dkhadr(2)
       else if (term(iact:iact).eq.'Y') then
         iact=iact+1
         adr=dkhadr(6)
       else if (term(iact:iact).eq.'F') then
         iact=iact+1
         adr=dkhadr(7)
       else if (term(iact:iact).eq.'G') then
         iact=iact+1
         adr=dkhadr(8)
       else if (term(iact:iact).eq.'Z') then
         call mat_sq_from_d (factor,nbas,pp)
         iact=iact+1
         flag=.false.
       else if (term(iact:iact).eq.'Q') then
         call mat_sq_dev_d (factor,nbas,pp)
         iact=iact+1
         flag=.false.
       else if (term(iact:iact).eq.'X') then
         iact=iact+1
         adr=dkhadr(3)
       else if (term(iact:iact).eq.'I') then
         iact=iact+1
         adr=dkhadr(9)
       else if (term(iact:iact).eq.'J') then
         iact=iact+1
         adr=dkhadr(4)
       else if (term(iact:iact).eq.'K') then
         iact=iact+1
         adr=dkhadr(10)
       else if (term(iact:iact).eq.'L') then
         iact=iact+1
         adr=dkhadr(11)
       else if (term(iact:iact).eq.'M') then
         iact=iact+1
         adr=dkhadr(12)
       end if
       if (flag) then
        if (isize.eq.nbas*nbas) then
         call ddafile(dkh_48,two,factor,nbas*nbas,adr)
        else
CMR it would be advantageous to have a triangular scratch
CMR   matrix permanently available
         call GetMem('DetFac  ','ALLO','REAL',iscr,isize+4)
         call ddafile(dkh_48,two,work(iscr),isize,adr)
         call mat_sq_from_t(factor,nbas,work(iscr))
         call GetMem('DetFac  ','FREE','REAL',iscr,isize+4)
        end if
       end if
      else
       if (term(iact:iact).eq.'S') then
         idum1=dkh_char2int(3,term(iact+1:iact+3))
         do 10 i=1,nbas
           do 20 j=1,nbas
             factor(j,i)=scr1(j,i,poss(idum1))
  20       continue
  10     continue
         iact=iact+4
       else if (term(iact:iact).eq.'T') then
         idum1=dkh_char2int(3,term(iact+1:iact+3))
         do 30 i=1,nbas
           do 40 j=1,nbas
             factor(j,i)=scr2(j,i,post(idum1))
  40       continue
  30     continue
         iact=iact+4
       else if (term(iact:iact).eq.'U') then
         idum1=dkh_char2int(3,term(iact+1:iact+3))
         do 50 i=1,nbas
           do 60 j=1,nbas
             factor(j,i)=scr3(j,i,posu(idum1))
  60       continue
  50     continue
         iact=iact+4
       else if (term(iact:iact).eq.'V') then
         call mat_copy (factor,nbas,nbas,vv)
         iact=iact+1
       else if (term(iact:iact).eq.'N') then
         call mat_copy (factor,nbas,nbas,nn)
         iact=iact+1
       else if (term(iact:iact).eq.'D') then
         call mat_copy (factor,nbas,nbas,dd)
         iact=iact+1
       else if (term(iact:iact).eq.'Y') then
         call mat_copy (factor,nbas,nbas,yy)
         iact=iact+1
       else if (term(iact:iact).eq.'F') then
         call mat_copy (factor,nbas,nbas,ff)
         iact=iact+1
       else if (term(iact:iact).eq.'G') then
         call mat_copy (factor,nbas,nbas,gg)
         iact=iact+1
       else if (term(iact:iact).eq.'Z') then
         call mat_sq_from_d (factor,nbas,pp)
         iact=iact+1
       else if (term(iact:iact).eq.'Q') then
         call mat_sq_dev_d (factor,nbas,pp)
         iact=iact+1
       else if (term(iact:iact).eq.'X') then
CMR         if (nbasp.eq.1) stop "PROGRAM ERROR"
         call mat_copy (factor,nbasp,nbasp,xx)
         iact=iact+1
       else if (term(iact:iact).eq.'I') then
CMR         if (nbasp.eq.1) stop "PROGRAM ERROR"
         call mat_copy (factor,nbasp,nbasp,ii)
         iact=iact+1
       else if (term(iact:iact).eq.'J') then
CMR         if (nbasp.eq.1) stop "PROGRAM ERROR"
         call mat_copy (factor,nbasp,nbasp,jj)
         iact=iact+1
       else if (term(iact:iact).eq.'K') then
CMR         if (nbasp.eq.1) stop "PROGRAM ERROR"
         call mat_copy (factor,nbasp,nbasp,kk)
         iact=iact+1
       else if (term(iact:iact).eq.'L') then
CMR         if (nbasp.eq.1) stop "PROGRAM ERROR"
         call mat_copy (factor,nbasp,nbasp,ll)
         iact=iact+1
       else if (term(iact:iact).eq.'M') then
CMR         if (nbasp.eq.1) stop "PROGRAM ERROR"
         call mat_copy (factor,nbasp,nbasp,mm)
         iact=iact+1
       else
         write (stdout,1083)
1083        format (2X,'ERROR in determine_factor(): could not ',
     *        'determine factor!'//2X,'STOP.',/2X)
         write(stdout,*) "term(iact:iact)=",term(iact:iact)
            CALL Abend
        endif
      endif
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(length)
        call Unused_integer(adrnext)
      end if
      end
c
c
c***********************************************************************
c
c   'dkhmatut.f' :  SRs for matrix operations for DKHPACK
c   -----------------------------------------------------
c
c   Contains all subroutines (SR) for matrix operations needed by DKHPACK.
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_mulP (p,nbas,d,q)
c
c***********************************************************************
c
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),d(nbas),q(nbas,nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          q(i,j)=p(i,j)*d(j)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_mulQ (p,nbas,d,q)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),d(nbas),q(nbas,nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          q(i,j)=p(i,j)/d(j)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_axa (p,nbas,aa)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),aa(nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(i,j)=p(i,j)*aa(i)*aa(j)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_axa_tri (p,nbas,aa)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j,ii
      real*8 p(nbas*(nbas+1)/2),aa(nbas)
c
      ii=0
      do 10 i=1,nbas
        do 20 j=1,i-1
          ii=ii+1
          p(ii)=p(ii)*aa(i)*aa(j)
  20    continue
        ii=ii+1
        p(ii)=p(ii)*aa(i)*aa(i)
  10  continue
c
      return
      end

c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_arxra (p,nbas,aa,rr)

c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),aa(nbas),rr(nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(i,j)=p(i,j)*aa(i)*aa(j)*rr(i)*rr(j)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_arxra_tri (p,nbas,aa,rr)

c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j,ii
      real*8 p(nbas*(nbas+1)/2),aa(nbas),rr(nbas)
c
      ii=0
      do 10 i=1,nbas
        do 20 j=1,i-1
          ii=ii+1
          p(ii)=p(ii)*aa(i)*aa(j)*rr(i)*rr(j)
  20    continue
        ii=ii+1
        p(ii)=p(ii)*aa(i)*aa(i)*rr(i)*rr(i)
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_copy (p,nbas1,nbas2,q)

c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas1,nbas2,i,j
      real*8 p(nbas1,nbas2),q(nbas1,nbas2)
c
      do 10 i=1,nbas2
        do 20 j=1,nbas1
          p(j,i)=q(j,i)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_copy_c (p,nbas1,nbas2,q,c)

c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Markus Reiher  (ETH Zurich)
c
c   version:  2.1.0
c
c   first version: 14.01.2007  (Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas1,nbas2,i,j
      real*8 p(nbas1,nbas2),q(nbas1,nbas2),c
c
      if (c.ne.1.0d0) then
        do 10 i=1,nbas2
          do 20 j=1,nbas1
            p(j,i)=q(j,i)*c
  20      continue
  10    continue
      else
        do 30 i=1,nbas2
          do 40 j=1,nbas1
            p(j,i)=q(j,i)
  40      continue
  30    continue
      end if
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_copy2 (p,isize,q)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer isize,i
      real*8 p(isize),q(isize)
c
      do 10 i=1,isize
        p(i)=q(i)
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_copy3 (p,nbas,nbasmax,q)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,nbasmax,i,j,ij
      real*8 p(nbasmax,nbasmax),q(nbasmax*nbasmax)
c
      call mat_zero (p,nbasmax)
      ij=0
      do 10 i=1,nbas
        do 20 j=1,nbas
          ij=ij+1
          p(j,i)=q(ij)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_zero (p,nbas)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas)
c
      do 10 i=1,nbas
        do 20 j=1,nbas
          p(j,i)=0.0D0
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_zero2 (p,isize)

c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer isize,i
      real*8 p(isize)
c
      do 10 i=1,isize
        p(i)=0.0D0
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_triang (p,nbas,q)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j,ii
      real*8 p(nbas*(nbas+1)/2),q(nbas,nbas)
c
      ii=0
      do 10 i=1,nbas
        do 20 j=1,i
          ii=ii+1
          p(ii)=q(j,i)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_sq_from_t (p,nbas,q)

c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer ii,i,j,nbas
      real*8 p(nbas,nbas),q(nbas*(nbas+1)/2)
c
      ii=0
      do 10 i=1,nbas
        do 20 j=1,i-1
          ii=ii+1
          p(i,j)=q(ii)
          p(j,i)=q(ii)
  20    continue
        ii=ii+1
        p(i,i)=q(ii)
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_sq_from_d (p,nbas,q)

c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer i,nbas
      real*8 p(nbas,nbas),q(nbas)
c
      call mat_zero (p,nbas)
      do 10 i=1,nbas
        p(i,i)=q(i)
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_sq_dev_d (p,nbas,q)

c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer i,nbas
      real*8 p(nbas,nbas),q(nbas)
c
      call mat_zero (p,nbas)
      do 10 i=1,nbas
        p(i,i)=1.0d0/q(i)
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_plainadd (p,nbas,q)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),q(nbas,nbas)
c
      do 10 i=1,nbas
        do 20 j=1,nbas
          p(j,i)=p(j,i)+q(j,i)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_tadd (alpha,p,isize,beta,q)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer isize,i
      real*8 alpha,beta,p(isize),q(isize)
c
      do 10 i=1,isize
          p(i) = alpha*p(i) + beta*q(i)
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_1_over_h (p,nbas,e)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),e(nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(i,j)=p(i,j)/(e(i)+e(j))
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_1_over_h_tri (p,nbas,e)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j,ii
      real*8 p(nbas*(nbas+1)/2),e(nbas)
c
      ii=0
      do 10 i=1,nbas
        do 20 j=1,i-1
          ii=ii+1
          p(ii)=p(ii)/(e(i)+e(j))
  20    continue
        ii=ii+1
        p(ii)=p(ii)/(e(i)+e(i))
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_1_over_h2 (p,nbas,e,q)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),e(nbas),q(nbas,nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(i,j)=q(i,j)/(e(i)+e(j))
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_times_p2 (p,nbas,pp)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c     multiplication with diag(pp(j)) from the right
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),pp(nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(i,j)=p(i,j)*pp(j)
  20    continue
  10  continue
c
      return
      end
c
c
      subroutine mat_times_p2b (p,q,nbas,pp)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c     multiplication with diag(pp(j)) from the right
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),q(nbas,nbas),pp(nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(i,j)=q(i,j)*pp(j)
  20    continue
  10  continue
c
      return
      end
c
c
      subroutine mat_times_p2c (p,q,nbas,pp)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c     multiplication with diag(pp(j)) from the left
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),q(nbas,nbas),pp(nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(j,i)=q(j,i)*pp(j)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_div_p2 (p,nbas,pp)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c     multiplication with diag(1/pp(j)) from the right
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),pp(nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(i,j)=p(i,j)/pp(j)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_div_p2b (p,q,nbas,pp)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c     multiplication with diag(1/pp(j)) from the right
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),q(nbas,nbas),pp(nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(i,j)=q(i,j)/pp(j)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_div_p2c (p,q,nbas,pp)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c     multiplication with diag(1/pp(j)) from the left
c
c   version:  1.0.0
c
c   first version: 13.03.2007  (M. Reiher, Theoretical Chemistry, ETH Zurich)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j
      real*8 p(nbas,nbas),q(nbas,nbas),pp(nbas)
c
      do 10 j=1,nbas
        do 20 i=1,nbas
          p(j,i)=q(j,i)/pp(j)
  20    continue
  10  continue
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_Strans_op (p,nbas,isize,sinv,q,scrmat,p_mat,q_mat)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 22.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,isize,i,j,k
      real*8 p(isize),q(isize),sinv(nbas,nbas),
     *                 scrmat(nbas,nbas),p_mat(nbas,nbas),
     *                 q_mat(nbas,nbas)
c
c   Initialize all matrices
      call mat_zero2 (p,isize)
      call mat_zero (scrmat,nbas)
      call mat_zero (q_mat,nbas)
      call mat_zero (p_mat,nbas)
c
c   Build q_mat
      call mat_sq_from_t (q_mat,nbas,q)
c
c   Calculate scrmat = q * sinv
      do 50 i=1,nbas
        do 60 j=1,nbas
          scrmat(i,j)=0.0d0
          do 70 k=1,j
c  note: sinv is upper triangular matrix!
            scrmat(i,j)=scrmat(i,j)+q_mat(i,k)*sinv(k,j)
  70      continue
  60    continue
  50  continue
c
c   Calculate p_mat = sinv^dagger * scrmat = sinv^dagger * q * sinv
      do 150 i=1,nbas
        do 160 j=1,nbas
          p_mat(i,j)=0.0d0
          do 170 k=1,i
            p_mat(i,j)=p_mat(i,j)+sinv(k,i)*scrmat(k,j)
 170      continue
 160    continue
 150  continue
c
c   Copy p_mat back to array of length isize
      call mat_triang (p,nbas,p_mat)
c
      return
      end
c
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c
      subroutine mat_Strans_vec (nbas,sinv,eigvect1,eigvect2)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
c
      integer nbas,i,j,k
      real*8 eigvect1(nbas,nbas),eigvect2(nbas,nbas),
     *                 sinv(nbas,nbas)
c
      do 10 i=1,nbas
        call mat_zero2 (eigvect1(1,i),nbas)
        do 20 j=1,nbas
          do 30 k=j,nbas
            eigvect1(j,i)=eigvect1(j,i)+sinv(j,k)*eigvect2(k,i)
  30     continue
  20    continue
  10  continue
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2020, Roland Lindh                                *
!***********************************************************************

subroutine Get_Info_Dynamic()
!***********************************************************************
!                                                                      *
! Object: to read all input information on the file INFO.              *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January 1992                                             *
!***********************************************************************

use Basis_Info, only: Basis_Info_Get
use Center_Info, only: Center_Info_Get
use SOAO_Info, only: SOAO_Info_Get

implicit none

!                                                                      *
!***********************************************************************
!                                                                      *
call Basis_Info_Get()
call Center_Info_Get()
call SOAO_Info_Get()
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Get_Info_Dynamic

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GASSPC()
! Divide orbital spaces into
!
! Inactive spaces : Orbitals that are doubly occupied in all CI spaces
! Active orbitals : Orbitals that have variable occ in atleast some spaces.
! Secondary spaces: Orbitals that are unoccupied in all spaces
!
! I_IAD : Division based upon occupation in Compound CI spaces IGSOCC
! I_IADX: Division based upon occupation in First CI space
!
! Jeppe Olsen, Summer of 98 (not much of an summer!)

use lucia_data, only: NGAS, NGSOBT
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use lucia_data, only: IGSOCC, IGSOCCX, NELEC
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IGAS, NEL_MAX
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I_IAD(NGAS), I_IADX(NGAS), NEL_REF
#endif

! Some dummy initializations
NEL_MAX = 0 ! jwk-cleanup

#ifdef _DEBUGPRINT_
NEL_REF = NELEC(1)+NELEC(2)
#endif

! For compound space

do IGAS=1,NGAS

  if (IGAS == 1) then
    NEL_MAX = 2*NGSOBT(IGAS)
  else
    NEL_MAX = NEL_MAX+2*NGSOBT(IGAS)
  end if

# ifdef _DEBUGPRINT_
  if ((IGSOCC(IGAS,1) == NEL_MAX) .and. (IGSOCC(IGAS,2) == NEL_MAX)) then
    ! Inactive  space
    I_IAD(IGAS) = 1
  else if (IGAS > 1) then
    ! Delete space
    if (IGSOCC(IGAS-1,1) == NEL_REF) I_IAD(IGAS) = 3
  else
    ! Active space
    I_IAD(IGAS) = 2
  end if
# endif

end do

! For First CI space

do IGAS=1,NGAS

  if (IGAS == 1) then
    NEL_MAX = 2*NGSOBT(IGAS)
  else
    NEL_MAX = NEL_MAX+2*NGSOBT(IGAS)
  end if

# ifdef _DEBUGPRINT_
  if ((IGSOCCX(IGAS,1,1) == NEL_MAX) .and. (IGSOCCX(IGAS,2,1) == NEL_MAX)) then
    ! Inactive  space
    I_IADX(IGAS) = 1
  else if (IGAS > 1) then
    ! Delete space
    if (IGSOCCX(IGAS-1,1,1) == NEL_REF) I_IADX(IGAS) = 3
  else
    ! Active space
    I_IADX(IGAS) = 2
  end if
# endif

end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Division of orbitals according to compound CI space'
write(u6,*) ' ==================================================='
write(u6,*)
write(u6,*) ' Inactive = 1, Active = 2, Delete = 3'
write(u6,*)
call IWRTMA(I_IAD,1,NGAS,1,NGAS)
write(u6,*)
write(u6,*) ' Division of orbitals according to first CI space'
write(u6,*) ' ================================================'
write(u6,*)
write(u6,*) ' Inactive = 1, Active = 2, Delete = 3'
write(u6,*)
call IWRTMA(I_IADX,1,NGAS,1,NGAS)
#endif

end subroutine GASSPC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010,2012,2017, Francesco Aquilante                    *
!               2015,2017, Alexander Zech                              *
!***********************************************************************

subroutine DrvEMB(nh1,KSDFT,Do_Grad,Grad,nGrad,DFTFOCK)
!***********************************************************************
!***********************************************************************
!** Orbital-Free Embedding calculation                               ***
!**                                                                  ***
!** Method:                                                          ***
!**     T. A. Wesolowski, A. Warshel, J. Phys. Chem. 97 (1993) 8050. ***
!**                                                                  ***
!** NDSD potential:                                                  ***
!**     J.-M. Garcia Lastra, J. W. Kaminski, T. A. Wesolowski,       ***
!**                               J. Chem. Phys.  129 (2008) 074107. ***
!**                                                                  ***
!** Embedding multi-determinantal wfs:                               ***
!**     T. A. Wesolowski, Phys. Rev.A. 77 (2008) 012504.             ***
!**                                                                  ***
!**                                                                  ***
!** Embedding Hartree-Fock wf:                                       ***
!**     F. Aquilante, T. A. Wesolowski                               ***
!**                       J. Chem. Phys. 135 (2011) 084120.          ***
!**                                                                  ***
!**                                                                  ***
!** Author: F. Aquilante, Geneva July 2010                           ***
!**                                                                  ***
!**                       (last update: Feb 2012)                    ***
!**                                                                  ***
!***********************************************************************
!***********************************************************************

use OFembed, only: dFMD, Energy_NAD, Func_A, Func_AB, Func_B, NDSD, OFE_first, V_emb, V_Nuc_AB, V_Nuc_BA, Xsigma
use nq_Info, only: Dens_I
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nh1, nGrad
character(len=*), intent(inout) :: KSDFT
logical(kind=iwp), intent(in) :: Do_Grad
real(kind=wp), intent(inout) :: Grad(nGrad)
character(len=4), intent(in) :: DFTFOCK
#include "debug.fh"
integer(kind=iwp) :: i, iSpin, j, kSpin, nD, nFckDim
real(kind=wp) :: d_Alpha, d_Beta, DSpn, DTot, Ec_A, Fact, Fact_, Fakt_, Func_A_TF, Func_B_TF, tmp, xElAB, Vxc_ref(2)
logical(kind=iwp) :: is_rhoA_on_file
character(len=16) :: NamRfil
real(kind=wp), allocatable :: D_DS(:,:), F_DFT(:,:), Fcorr(:,:), TmpA(:)
real(kind=wp), external :: Xlambda
real(kind=r8), external :: dDot_
#ifdef _NOT_USED_
integer(kind=iwp) :: nDens
real(kind=wp) :: Func_AB_TF, TF_NAD, V_emb_x, V_emb_x_ref, Xint_Ts_A, Xint_Ts_AB, Xint_Ts_NAD, Xnorm, Ynorm
real(kind=wp), allocatable :: D1ao_x(:), D1ao_y(:), Vemb(:)
#endif

Debug = .false.
is_rhoA_on_file = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
call Setup_iSD()
if (Do_Grad) Grad(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _NOT_USED_
! Section to calculate Nonelectr. V_emb with current density
! Temporarily turned off (clean output)
if (.not. OFE_first) then
  call mma_allocate(D1ao_y,nh1)
  call Get_NameRun(NamRfil) ! save the old RUNFILE name
  call NameRun('AUXRFIL')   ! switch RUNFILE name
  call mma_allocate(Vemb,nh1,label='Vemb')
  call Get_dArray('dExcdRa',Vemb,nh1)
  call mma_allocate(TmpA,nh1,Label='TmpA')
  call Get_dArray('Nuc Potential',TmpA,nh1)
  ! Subtract V_nuc_B
  Vemb(:) = Vemb-TmpA
  ! Calculate nonelectr. V_emb with current Density
  Ynorm = dDot_(nh1,D1ao_y,1,D1ao_y,1)
  V_emb_x = dDot_(nh1,Vemb,1,D1ao_y,1)
  write(u6,'(A,F19.10,4X,A,F10.5)') 'Nonelectr. Vemb w. current density: ',V_emb_x,'Y_Norm = ',Ynorm
  call mma_deallocate(D1ao_y)
  ! Get rho_A_ref
  call NameRun('PRERFIL')
  call mma_allocate(D1ao_x,nDens,Label='D1ao_x')
  call get_dArray('D1ao',D1ao_x,nDens)
  Xnorm = dDot_(nh1,D1ao_x,1,D1ao_x,1)
  V_emb_x_ref = dDot_(nh1,Vemb,1,D1ao_x,1)
  write(u6,'(A,F19.10,4X,A,F10.5)') 'Nonelectr. Vemb w.    ref. density: ',V_emb_x_ref,'X_Norm = ',Xnorm
  call VEMB_Exc_states(Vemb,nh1,KSDFT,Func_B)
  call mma_deallocate(TmpA)
  call mma_deallocate(D1ao_x)
  call mma_dealloacte(Vemb)
  call NameRun(NamRfil)  ! switch back to RUNFILE
end if
! Section End
#endif
call f_Inquire('PRERFIL',is_rhoA_on_file) ! rho_A from file
if (is_rhoA_on_file .and. (.not. OFE_first)) return ! Vemb on disk

!***********************************************************************
!                                                                      *
!     Setup of density matrices for subsys B (environment)             *
!                                                                      *
!***********************************************************************
call Get_NameRun(NamRfil) ! save the old RUNFILE name
call NameRun('AUXRFIL')   ! switch RUNFILE name
!                                                                      *
!***********************************************************************
!                                                                      *
nD = 4
call mma_allocate(F_DFT,nh1,nD,Label='F_DFT')
call mma_allocate(D_DS,nh1,nD,Label='D_DS')
Vxc_ref(1) = Zero
Vxc_ref(2) = Zero

! Get the density matrix of the environment (rho_B)

call Get_iScalar('Multiplicity',kSpin)
call Get_D1ao(D_DS(:,1),nh1)
!call RecPrt('D1ao',' ',D_DS(:,1),nh1,1)

! Get the spin density matrix of the environment

if (kSpin /= 1) then
  call Get_D1Sao(D_DS(:,2),nh1)
  !call RecPrt('D1Sao',' ',D_DS(:,2),nh1,1)
end if

! Compute alpha and beta density matrices of the environment

nFckDim = 2
if (kSpin == 1) then
  D_DS(:,1) = Half*D_DS(:,1)
  D_DS(:,2) = D_DS(:,1)
  nFckDim = 1
else
  do i=1,nh1
    DTot = D_DS(i,1)
    DSpn = D_DS(i,2)
    d_Alpha = Half*(DTot+DSpn)
    d_Beta = Half*(DTot-DSpn)
    D_DS(i,1) = d_Alpha
    D_DS(i,2) = d_Beta
  end do
  !call RecPrt('Da',' ',D_DS(:,1),nh1,1)
  !call RecPrt('Db',' ',D_DS(:,2),nh1,1)
end if

!if (OFE_first) then
!---AZECH 10/2015
! kinetic part of E_xct, Subsys B
Func_B_TF = Zero
call wrap_DrvNQ('TF_only',F_DFT(:,1:nFckDim),nFckDim,Func_B_TF,D_DS(:,1:nFckDim),nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK)

if (OFE_first) then

  call wrap_DrvNQ(KSDFT,F_DFT(:,1:nFckDim),nFckDim,Func_B,D_DS(:,1:nFckDim),nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK)

  if (KSDFT(1:4) == 'NDSD') then
    call mma_allocate(NDSD,nh1,nFckDim,label='NDSD')
    NDSD(:,:) = F_DFT(:,1:nFckDim)
    KSDFT(1:4) = 'LDTF' !set to Thomas-Fermi for subsequent calls
  end if

end if

!***********************************************************************
!                                                                      *
!     Setup of density matrices for subsys A                           *
!                                                                      *
!***********************************************************************
call NameRun(NamRfil)    ! switch back RUNFILE name

if (is_rhoA_on_file) call NameRun('PRERFIL')
! Get the density matrix for rho_A

call Get_D1ao(D_DS(:,3),nh1)
!call RecPrt('D1ao',' ',D_DS(:,3),nh1,1)

call Get_iScalar('Multiplicity',iSpin)
if ((iSpin == 1) .and. (kSpin /= 1) .and. OFE_first) then
  call WarningMessage(0,'Non-singlet environment perturbation on singlet state!;'// &
                      'Spin-components of the OFE potential will be averaged.')
end if

! Get the spin density matrix of A

if (iSpin /= 1) then
  call Get_D1Sao(D_DS(:,4),nh1)
  !call RecPrt('D1Sao',' ',D_DS(:,4),nh1,1)
end if

! Compute alpha and beta density matrices of subsystem A

nFckDim = 2
if (iSpin == 1) then
  D_DS(:,3) = Half*D_DS(:,3)
  D_DS(:,4) = D_DS(:,3)
  if (kSpin == 1) nFckDim = 1
else
  do i=1,nh1
    DTot = D_DS(i,3)
    DSpn = D_DS(i,4)
    d_Alpha = Half*(DTot+DSpn)
    d_Beta = Half*(DTot-DSpn)
    D_DS(i,3) = d_Alpha
    D_DS(i,4) = d_Beta
  end do
  !call RecPrt('Da',' ',D_DS(:,3),nh1,1)
  !call RecPrt('Db',' ',D_DS(:,4),nh1,1)
end if

!---AZECH 10/2015
! kinetic part of E_xct, Subsys A
call wrap_DrvNQ('TF_only',F_DFT(:,3:nFckDim+2),nFckDim,Func_A_TF,D_DS(:,3:nFckDim+2),nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK)

call wrap_DrvNQ(KSDFT,F_DFT(:,3:nFckDim+2),nFckDim,Func_A,D_DS(:,3:nFckDim+2),nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK)

! Fraction of correlation potential from A (cases: HF or Trunc. CI)

if (dFMD > Zero) then

  call mma_allocate(Fcorr,nh1,nFckDim,Label='Fcorr')

  call cwrap_DrvNQ(KSDFT,nFckDim,Ec_A,D_DS(:,3:nFckDim+2),nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK,Fcorr(:,1:nFckDim))
end if

!***********************************************************************
!                                                                      *
!     Calculation on the supermolecule                                 *
!                                                                      *
!***********************************************************************
nFckDim = 2
if ((iSpin == 1) .and. (kSpin == 1)) then
  nFckDim = 1
  D_DS(:,1) = D_DS(:,1)+D_DS(:,3)
else
  D_DS(:,1) = D_DS(:,1)+D_DS(:,3)
  D_DS(:,2) = D_DS(:,2)+D_DS(:,4)
end if
#ifdef _NOT_USED_
!---AZECH 10/2015
! kinetic part of E_xct, Subsys A+B
! temporarily turned off to clean output
if (.false.) then
  Func_AB_TF = Zero
  call wrap_DrvNQ('TF_only',F_DFT(:,1:nFckDim),nFckDim,Func_AB_TF,D_DS(:,1:nFckDim),nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK)
  TF_NAD = Func_AB_TF-Func_A_TF-Func_B_TF
  write(u6,*) 'kinetic part of E_xc,T (Thomas-Fermi ONLY)'
  write(u6,'(A,F19.10)') 'Ts(A+B): ',Func_AB_TF
  write(u6,'(A,F19.10)') 'Ts(A):   ',Func_A_TF
  write(u6,'(A,F19.10)') 'Ts(B):   ',Func_B_TF
  write(u6,'(A,F19.10)') '-------------------'
  write(u6,'(A,F19.10)') 'Ts_NAD:  ',TF_NAD
  ! calculate v_T, Subsys A+B
  Xint_Ts_AB = dDot_(nh1,F_DFT(:,1),1,D_DS(:,3),1)
  Xint_Ts_NAD = Xint_Ts_AB-Xint_Ts_A
  ! scale by 2 because wrapper only handles spin-densities
  Xint_Ts_NAD = Two*Xint_Ts_NAD
  write(u6,*) 'integrated v_Ts_NAD (Thomas-Fermi) with rhoA current'
  write(u6,'(A,F19.10)') 'Ts(A+B)_integral: ',Xint_Ts_AB
  write(u6,'(A,F19.10)') 'Ts(A)_integral:   ',Xint_Ts_A
  write(u6,'(A,F19.10)') '-------------------'
  write(u6,'(A,F19.10)') 'Ts_NAD_integral:  ',Xint_Ts_NAD
end if
#endif

call wrap_DrvNQ(KSDFT,F_DFT(:,1:nFckDim),nFckDim,Func_AB,D_DS(:,1:nFckDim),nh1,nFckDim,Do_Grad,Grad,nGrad,DFTFOCK)

Energy_NAD = Func_AB-Func_A-Func_B

!---AZECH 10/2015
! exchange-correlation part of E_xct, Subsys A+B
! temporarily turned off to clean output
!write(u6,*) 'E_xc_NAD (determined with Thomas-Fermi)'
!Func_xc_NAD = Energy_NAD-TF_NAD
!write(u6,'(A,F19.10)') 'E_xc_NAD: ',Func_xc_NAD

if (dFMD > Zero) then
  xElAB = Dens_I
  Fakt_ = -Xlambda(abs(Energy_NAD)/xElAB,Xsigma)
  F_DFT(:,3:nFckDim+2) = F_DFT(:,3:nFckDim+2)+Fakt_*Fcorr(:,:)
  call mma_deallocate(Fcorr)
# ifdef _DEBUGPRINT_
  write(u6,*) ' lambda(E_nad) = ',dFMD*Fakt_
# endif
end if

!                                                                      *
!***********************************************************************
!                                                                      *
! Non Additive (NAD) potential: F(AB)-F(A)
do i=1,nFckDim
  F_DFT(:,i) = F_DFT(:,i)-F_DFT(:,2+i)
end do

! NDSD potential for T_nad: add the (B)-dependent term
if (allocated(NDSD)) then
  j = 1
  do i=1,nFckDim
    F_DFT(:,i) = F_DFT(:,i)+NDSD(:,j)
    if (kSpin /= 1) j = j+1
  end do
end if

! Add the Nuc Attr potential (from subsystem B) and then
! put out the DFT Fock matrices from the (NAD) embedding potential
! on the runfile (AUXRFIL). Note that the classical Coulomb
! interaction potential from subsystem B is computed in the std
! Fock matrix builders

call NameRun('AUXRFIL')  ! switch RUNFILE name

call mma_allocate(TmpA,nh1,Label='TmpA')
call Get_dArray('Nuc Potential',TmpA,nh1)

Fact = Two ! because Dmat has been scaled by half
if (kSpin /= 1) Fact = One
Fact_ = Fact

V_emb = Fact*dDot_(nh1,F_DFT(:,1),1,D_DS(:,3),1)
V_Nuc_AB = Fact*dDot_(nh1,TmpA,1,D_DS(:,3),1)
if (kSpin /= 1) then
  V_emb = V_emb+Fact*dDot_(nh1,F_DFT(:,2),1,D_DS(:,4),1)
  V_Nuc_AB = V_Nuc_AB+Fact*dDot_(nh1,TmpA,1,D_DS(:,4),1)
end if

! Averaging the spin-components of F(AB) iff non-spol(A)//spol(B)
if ((iSpin == 1) .and. (kSpin /= 1)) then
  do i=1,nh1
    tmp = Half*(F_DFT(i,1)+F_DFT(i,2))
    F_DFT(i,1) = tmp
  end do
  nFckDim = 1  ! reset stuff as if A+B had been spin compensated
  Fact = Two
end if

do i=1,nFckDim
  F_DFT(:,i) = F_DFT(:,i)+TmpA
  Vxc_ref(i) = Fact*dDot_(nh1,F_DFT(:,i),1,D_DS(:,i+2),1)
end do

if (dFMD > Zero) call Put_dScalar('KSDFT energy',Ec_A)
call Put_dArray('Vxc_ref ',Vxc_ref,2)

call Put_dArray('dExcdRa',F_DFT(:,1:nFckDim),nh1*nFckDim)
call NameRun(NamRfil)  ! switch back RUNFILE name

call Get_dArray('Nuc Potential',TmpA,nh1)
V_Nuc_BA = Fact_*(dDot_(nh1,TmpA,1,D_DS(:,1),1)-dDot_(nh1,TmpA,1,D_DS(:,3),1))
if (kSpin /= 1) then
  V_Nuc_BA = V_Nuc_BA+Fact_*(dDot_(nh1,TmpA,1,D_DS(:,2),1)-dDot_(nh1,TmpA,1,D_DS(:,4),1))
end if

call mma_deallocate(TmpA)

#ifdef _DEBUGPRINT_
if (nFckDim == 1) then
  do i=1,nh1
    write(u6,'(i4,f22.16)') i,F_DFT(i,1)
  end do
else
  do i=1,nh1
    write(u6,'(i4,3f22.16)') i,F_DFT(i,1),F_DFT(i,2),Half*(F_DFT(i,1)+F_DFT(i,2))
  end do
end if
write(u6,'(a,f22.16)') ' NAD DFT Energy :',Energy_NAD
#endif

call mma_deallocate(F_DFT)
call mma_deallocate(D_DS)
call Free_iSD()

return

end subroutine DrvEMB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PtDipo(H0,Ovlp,RR,nSize,Temp,nTemp)
*
************************************************************************
*                                                                      *
*     Objective: Construct the modified Hamiltonian,                   *
*                i.e., add dipole perturbation operator                *
*                                                                      *
************************************************************************
*
      Implicit Real*8 ( A-H,O-Z )
*

#include "input.fh"
*
      Real*8 H0(nSize), Ovlp(nSize), RR(nSize), Temp(nTemp)
      Character*8 Label
      Character*20 PriLbl
      Logical Debug,Exec
      Data    Debug/.False./
      Dimension idum(1)
*
*----------------------------------------------------------------------*
*                                                                      *
*     Start procedure                                                  *
*     Check if the command has been specified on input                 *
*                                                                      *
*----------------------------------------------------------------------*
*
*
      Exec=.false.
      Exec=Exec.or.ComStk(2,1,1,1)
      Exec=Exec.or.ComStk(2,1,1,2)
      Exec=Exec.or.ComStk(2,1,1,3)
      If ( .not.Exec ) then
         Return
      End If
*
*----------------------------------------------------------------------*
*     Loop over all components and add constributions to the           *
*     one-electron Hamiltonian                                         *
*----------------------------------------------------------------------*
*
      Do iComp=1,3
        If ( ComStk(2,1,1,iComp) ) Then
          Label='MltPl  1'
          iRc=-1
          iOpt1=1
          iOpt2=2
          iSyLbl=0
          Alpha=-ComVal(2,1,1,iComp)
          Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
          nInts=idum(1)
          If ( iRc.ne.0 ) Goto 991
          Call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
          If ( iRc.ne.0 ) Goto 991
          Call CmpInt(Temp,nInts,nBas,nSym,iSyLbl)
          If ( Debug ) Then
            Write (6,'(6X,A,F8.6)') 'weight =',Alpha
            PriLbl='MltPl  1; Comp =    '
            Write(PriLbl(19:20),'(I2)') iComp
            Call PrDiOp(PriLbl,nSym,nBas,Temp)
            Write (6,*) 'Nuclear contribution=',Temp(nInts+4)
          End If
          call daxpy_(nInts,Alpha,Temp,1,H0,1)
          H0(nInts+4)=H0(nInts+4)-Alpha*Temp(nInts+4)
        End If
      End Do
*
*----------------------------------------------------------------------*
*     Normal Exit                                                      *
*----------------------------------------------------------------------*
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(Ovlp)
        Call Unused_real_array(RR)
      End If
*
*----------------------------------------------------------------------*
*     Error Exit                                                       *
*----------------------------------------------------------------------*
*
991   Write (6,*) 'PtDipi: Error reading ONEINT'
      Write (6,'(A,A)') 'Label=',Label
      Call Abend()
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
!SVC: DGA can't distribute stripes for some small dimensions so we have
!to explicitly use the irregular versions. These is a wrapper routine to
!create horizontal (H) and vertical (V) stripes. The dimensions are
!divided evenly, with the remainder spread over the leading stripes.
#ifdef _MOLCAS_MPP_
      SUBROUTINE GA_CREATE_STRIPED (ORI,NROW,NCOL,LABEL,LG_M)
      IMPLICIT NONE
      CHARACTER :: ORI
      CHARACTER(LEN=*) :: LABEL
      INTEGER :: NROW, NCOL, LG_M
#include "global.fh"
#include "mafdecls.fh"
      LOGICAL :: BSTAT
      INTEGER :: NPROCS
      INTEGER :: NBLOCK1, NBLOCK2
      INTEGER, ALLOCATABLE :: MAP1(:), MAP2(:)
      INTEGER :: NDIM, NBASE, NREST, IOFF, I

      NPROCS=GA_NNODES()

      NBLOCK1=1
      ALLOCATE(MAP1(NBLOCK1))
      MAP1(1)=1

      NDIM=0
      IF (ORI.EQ.'H') THEN
        NDIM=NROW
      ELSE IF (ORI.EQ.'V') THEN
        NDIM=NCOL
      END IF
      NBLOCK2=MIN(NDIM,NPROCS)
      NBASE=NDIM/NPROCS
      NREST=MOD(NDIM,NPROCS)
      ALLOCATE(MAP2(NBLOCK2))
      IOFF=1
      DO I=1,NBLOCK2
        MAP2(I)=IOFF
        IF (I.LE.NREST) THEN
          IOFF=IOFF+NBASE+1
        ELSE
          IOFF=IOFF+NBASE
        END IF
      END DO

      BSTAT=.FALSE.
      IF (ORI.EQ.'H') THEN
        BSTAT = GA_CREATE_IRREG (MT_DBL,NROW,NCOL,LABEL,
     &                     MAP2,NBLOCK2,MAP1,NBLOCK1,LG_M)
      ELSE IF (ORI.EQ.'V') THEN
        BSTAT = GA_CREATE_IRREG (MT_DBL,NROW,NCOL,LABEL,
     &                     MAP1,NBLOCK1,MAP2,NBLOCK2,LG_M)
      END IF

      DEALLOCATE(MAP1,MAP2)

      IF (.NOT.bStat) THEN
        WRITE(6,*) 'GA_CREATE_HS: could not create array, abort'
        CALL AbEnd()
      END IF
      END
#elif defined (NAGFOR)
c Some compilers do not like empty files
      SUBROUTINE EMPTY_GA_CREATE_STRIPED ()
      END
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Laplace_PRSQ(V,M,N,NDIM)

use ReMez_mod, only: IW
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: M, N, NDIM
real(kind=wp), intent(in) :: V(NDIM,M)
integer(kind=iwp) :: I, IMAX, IMIN, J, NMAX

! ----- PRINT OUT A SQUARE MATRIX -----
! -V- IS -N- ROWS BY -M- COLUMNS, WITH LEADING REAL -NDIM-

NMAX = 10
IMAX = 0
do
  IMIN = IMAX+1
  IMAX = IMAX+NMAX
  if (IMAX > M) IMAX = M
  write(IW,9008)
  write(IW,9028) (I,I=IMIN,IMAX)
  do J=1,N
    write(IW,9048) J,(V(J,I),I=IMIN,IMAX)
  end do
  if (IMAX >= M) exit
end do

return

9008 format(1X)
9028 format(10X,10(4X,I4,4X))
9048 format(I5,1X,10F12.7)

end subroutine Laplace_PRSQ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function DER(IDER,IS1,IS2,AL,BE)
! CALCULATE INTEGRAL OVER DERIVATIVE OF THE FUNCTIONS

use crelop, only: GA
use Constants, only: Zero, One, Two, Three, Four, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: DER
integer(kind=iwp), intent(in) :: IDER, IS1(3), IS2(3)
real(kind=wp), intent(in) :: AL, BE
integer(kind=iwp) :: I, I1(2,3), I2(2,3), II, J, J1, J2, JJ, KK, L1, L2
real(kind=wp) :: ANG, EX, F(2), G(2), SUM_
real(kind=wp), external :: PHI, THETA

do I=1,3
  do J=1,2
    I1(J,I) = IS1(I)
    I2(J,I) = IS2(I)
  end do
end do
I1(1,IDER) = I1(1,IDER)+1
I1(2,IDER) = I1(2,IDER)-1
I2(1,IDER) = I2(1,IDER)+1
I2(2,IDER) = I2(2,IDER)-1
L1 = IS1(IDER)+1
J1 = 0
select case (L1)
  case default
    write(u6,100) IDER,IS1,IS2,AL,BE
    call Abend()
  case (1)
    F(1) = -TWo*AL
    J1 = 1
  case (2)
    F(2) = One
    F(1) = -Two*AL
    J1 = 2
  case (3)
    F(2) = TWo
    F(1) = -TWo*AL
    J1 = 2
  case (4)
    F(2) = Three
    F(1) = -Two*AL
    J1 = 2
  case (5)
    F(2) = Four
    F(1) = -Two*AL
    J1 = 2
end select

L2 = IS2(IDER)+1
J2 = 0
select case (L2)
  case default
    write(u6,100) IDER,IS1,IS2,AL,BE
    call Abend()
  case (1)
    G(1) = -Two*BE
    J2 = 1
  case (2)
    G(2) = One
    G(1) = -Two*BE
    J2 = 2
  case (3)
    G(2) = Two
    G(1) = -Two*BE
    J2 = 2
  case (4)
    G(2) = Three
    G(1) = -Two*BE
    J2 = 2
  case (5)
    G(2) = Four
    G(1) = -Two*BE
    J2 = 2
end select

SUM_ = Zero
do I=1,J1
  do J=1,J2
    II = I1(I,1)+I2(J,1)
    JJ = I1(I,2)+I2(J,2)
    KK = I1(I,3)+I2(J,3)
    ANG = THETA(II+JJ,KK)*PHI(JJ,II)
    if (ANG == Zero) cycle
    EX = -real(II+JJ+KK+2,kind=wp)*Half
    SUM_ = SUM_+F(I)*G(J)*Half*ANG*GA(II+JJ+KK+2)*(AL+BE)**EX
  end do
end do
DER = SUM_

return

100 format(' ILLEGAL ANGULAR MOMENTUM (DER)'/,' IDER,IS1,IS2,AL,BE PRINTED'/,1X,7I5,3X,2d20.8)

end function DER

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETREDIND(IIBSTRSH,NNBSTRSH,MSYM,MMSHL,IRED)
C
C     Purpose: set index arrays for reduced set IRED. The counter
C              array NNBSTRSH must be set on entry.
C
#include "implicit.fh"
      INTEGER IIBSTRSH(MSYM,MMSHL,3), NNBSTRSH(MSYM,MMSHL,3)
#include "cholesky.fh"

      CHARACTER*13 SECNAM
      PARAMETER (SECNAM = 'CHO_SETREDIND')

      J = IRED

#if defined (_DEBUGPRINT_)
      IF ((NNSHL.NE.MMSHL) .OR. (NSYM.NE.MSYM))
     & CALL CHO_QUIT('[1] Dimension error in '//SECNAM,104)
      IF ((J.LT.1) .OR. (J.GT.3))
     & CALL CHO_QUIT('[2] Dimension error in '//SECNAM,104)
#endif

      IF (NNSHL .LT. 1) THEN ! may occur in parallel runs
         NNBSTRT(J) = 0
         CALL CHO_IZERO(IIBSTR(1,J),NSYM)
         CALL CHO_IZERO(NNBSTR(1,J),NSYM)
         RETURN
      END IF

      NNBSTRT(J) = 0
      DO ISYM = 1,NSYM
         IIBSTRSH(ISYM,1,J) = 0
         NNBSTR(ISYM,J) = NNBSTRSH(ISYM,1,J)
         DO ISHLAB = 2,NNSHL
            IIBSTRSH(ISYM,ISHLAB,J) = NNBSTR(ISYM,J)
            NNBSTR(ISYM,J) = NNBSTR(ISYM,J) + NNBSTRSH(ISYM,ISHLAB,J)
         END DO
         IIBSTR(ISYM,J) = NNBSTRT(J)
         NNBSTRT(J) = NNBSTRT(J) + NNBSTR(ISYM,J)
      END DO

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1998,2005, Roland Lindh                 *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drv2El_2Center_RI(Integral_WrOut,ThrAO,ipA_Diag,
     &                             nSO_Aux,MaxCntr,ipSO2C)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals.                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August '91                         *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. '93          *
*             Modified driver. Jan. '98                                *
*             Modified to 2-center ERIs for RI June '05                *
************************************************************************
      use Basis_Info, only: nBas_Aux
      use iSD_data
      use Wrj12
      use Index_arrays, only: iSO2Sh, nShBF
      use Real_Info, only: CutInt
      use RICD_Info, only: LDF
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Integral_WrOut
#include "Molcas.fh"
#include "setup.fh"
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "nsd.fh"
#define _no_nShs_
#include "iTOffs.fh"
      Integer iAddr_AQ(0:7), kCol_Irrep(0:7)
      Logical Verbose, Indexation, FreeK2, DoGrad, DoFock
      Character Name_Q*6
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*----- Statement functions
*
      TMax(i)=Work(ipTMax-1+i)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 9
      iPrint = nPrint(iRout)
*
      Call StatusLine(' Seward:',' Computing 2-center RI integrals')
*                                                                      *
************************************************************************
*                                                                      *
*     Handle only the auxiliary basis set
*
      Call Set_Basis_Mode('Auxiliary')
      Call SetUp_iSD()
*                                                                      *
************************************************************************
*                                                                      *
*     Initialize for 2-electron integral evaluation.
*
      DoGrad=.False.
      DoFock=.False.
      Indexation = .True.
      Call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
*
      Call mma_Allocate(SO2Ind,nSOs,Label='SO2Ind')
      Call Mk_iSO2Ind(iSO2Sh,SO2Ind,nSOs,nSkal)
*
       nSO_Aux=nSOs-1
      If (LDF) Then
         Call GetMem('SO2C','Allo','Inte',ipSO2C,nSO_Aux)
         MaxCntr=0
         Do i = 1, nSO_Aux
            iSh = iSO2Sh(i)
            iCenter=iSD(10,iSh)
            MaxCntr=Max(MaxCntr,iCenter)
            iWork(ipSO2C+i-1)=iCenter
         End Do
      Else
         MaxCntr=0
         ipSO2C=ip_Dummy
      End If
*
      nBfn2 = 0
      nBfnTot=0
      Do iIrrep = 0, nIrrep-1
         iTOffs(iIrrep+1) = nBfn2
*
         lJ=nBas_Aux(iIrrep)
         If (iIrrep.eq.0) lJ=lJ-1
         nBfn2 = nBfn2 + lJ**2
         nBfnTot=nBfnTot+lJ
      End Do
      nA_Diag=nBfnTot
      Call GetMem('A_Diag','Allo','Real',ipA_Diag,nA_Diag)
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      Call GetMem('TMax','Allo','Real',ipTMax,nSkal)
      Call Allocate_Work(ip_Tmp,nSkal**2)
      Call Shell_MxSchwz(nSkal,Work(ip_Tmp))

c      Call RecPrt('ip_Tmp',' ',Work(ip_Tmp),nSkal,nSkal)

      call dcopy_(nSkal,Work(ip_Tmp+(nSkal-1)*nSkal),1,Work(ipTMax),1)
      Call Free_Work(ip_Tmp)
      TMax_all=Zero
      Do iS = 1, nSkal
         TMax_all=Max(TMax_all,TMax(iS))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Preallocate some core for Seward!
*
      Call GetMem('MaxMem','Max','Real',iDummy,MemSew)
      MemLow=Min(MemSew/2,1024*128)
      MemSew=Max(MemSew/10,MemLow)
      Call xSetMem_Ints(MemSew)
*                                                                      *
************************************************************************
*                                                                      *
*-----Temporary buffer for computed integrals, compute the largest
*     required buffer size and set up iOffA.
*
      nTInt=0
      Do jS = 1, nSkal-1
         nTInt = Max( nTInt,
     &                  nMemAm(nShBF,nIrrep,nSkal-1,jS,iOffA,
     &                         .True.) )
      End Do
      Call GetMem('Am','Allo','Real',ipTInt,nTInt)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Call CWTime(TCpu1,TWall1)
*
*     Open files for the A-vectors, set iAddr_AQ, kCol_iIrrep and
*     iOffA(3,iIrrep).
*
      nBfnTot=0
      Do iIrrep = 0, nIrrep-1
         iOffA(3,iIrrep)=nBfnTot
         mB=nBas_Aux(iIrrep)
         If (iIrrep.eq.0) mB = mB - 1
         nBfnTot=nBfnTot+mB
*
         iSeed=63+iIrrep
         Lu_A(iIrrep)=IsFreeUnit(iSeed)
         Write(Name_Q,'(A4,I2.2)') 'AVEC',iIrrep
         If (mB.ne.0) Call DaName_MF_WA(Lu_A(iIrrep),Name_Q)
*
         iAddr_AQ(iIrrep)=0
         kCol_Irrep(iIrrep)=0
      End Do
*
      iS = nSkal
      kS = nSkal
*
      Do jS = 1, nSkal-1
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*        Initialize the buffer
*
         nTInt_=nMemAm(nShBF,nIrrep,nSkal-1,jS,iOffA,.True.)
         Call FZero(Work(ipTInt),nTInt_)
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*        First compute the A matrix
*
         Do lS = 1, jS
*
            Aint=TMax(jS)*TMax(lS)
            If (AInt.lt.CutInt) Go To 14
            Call Eval_IJKL(iS,jS,kS,lS,Work(ipTInt),nTInt_,
     &                    Integral_WrOut)
 14         Continue
*
*           Use a time slot to save the number of tasks and shell
*           quadrupltes process by an individual node
            Call SavStat(1,One,'+')
            Call SavStat(2,One,'+')
*
         End Do ! lS
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*        Write the A-vectors to disk
*
         Do iIrrep = 0, nIrrep-1
            mB = iOffA(2,iIrrep)           ! # of bf of shell jS
            If (mB.ne.0) Then
*
               ip_A_n=ipTInt + iOffA(1,iIrrep)
               iAddr=iAddr_AQ(iIrrep) ! Disk address
*
               nB = nBas_Aux(iIrrep)
               If (iIrrep.eq.0) nB = nB - 1 ! subtract dummy af
               ip_Save = ip_A_n
               Do kCol = 1+kCol_Irrep(iIrrep), mB+kCol_Irrep(iIrrep)
*
*                 Write the A-vector to file
*
                  Call dDaFile(Lu_A(iIrrep),1,Work(ip_A_n),
     &                         kCol,iAddr)

                  ipAs_Diag=ipA_Diag+iOffA(3,iIrrep)+kCol-1
                  Work(ipAs_Diag)=Work(ip_A_n+kCol-1)
                  ipAs_Diag=ipAs_Diag+1
                  nZero=nB-kCol
                  If (nZero.ne.0) Call dDaFile(Lu_A(iIrrep),0,
     &                                         Work(ip_A_n),
     &                                         nZero,iAddr)
*
                  ip_A_n = ip_A_n + kCol
               End Do
*
               kCol_Irrep(iIrrep)=kCol_Irrep(iIrrep)+mB
               iAddr_AQ(iIrrep)=iAddr
            End If
*
         End Do ! iIrrep
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      End Do    ! jS
*----------------------------------------------------------------------*
*                                                                      *
*     Release the Seward core memory, the buffer, etc.
*
      Call Free_iSD()
      Call xRlsMem_Ints
      Call GetMem('Am', 'Free','Real',ipTInt,nTInt)
      Call GetMem('TMax','Free','Real',ipTMax,nSkal)
      Call mma_deallocate(SO2Ind)
*                                                                      *
************************************************************************
*                                                                      *
*     Terminate integral environment.
*
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu2,TWall2)
      Call SavTim(1,TCpu2-TCpu1,TWall2-TWall1)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine add (wrk,wrksize,
     & ninda,nindb,nindext,typext,u,v,ssu,ssv,factor,
     & mapda,ssa,mapdb,mapib,ssb,rc)
c
c     this routine do:
c     B(indb) = B(indb) + factor * A(inda)
c
c     ninda   - # of indexes in matrix A (1-4)
c     nindb   - # of indexes in matrix B (1-4)
c     nindext - # of external (frozen, fixed) indexes (now:0-2)
c     typext  - characterize external indexes as follows:
c     0 - no frozen index
c     1 - frozen index p
c     2 - frozen index q
c     3 - frozen index r
c     4 - frozen index s
c     5 - frozen indexes p,q
c     6 - frozen indexes r,s
c     u       - value of first external index (if any, else 0)
c     v       - value of second external index (if any, else 0)
c     ssu     - symmetry of u (if any, else 1)
c     ssv     - symmetry of v (if any, else 1)
c     factor  - multiplicative factor (see def)
c     mapda   - direct map matrix corresponding to A (see docc.txt)
c     ssa     - overall spin state of matrix A
c     mapdb   - direct map matrix corresponding to B (see docc.txt)
c     mapib   - inverse map matrix corresponding to B (see docc.txt)
c     ssb     - overall spin state of matrix B
c     rc      - return (error) code
c
c     Table of present implementations:
c
c     nindB  nindxet  typext  typB  =>   Implemented
c     >4                                   No
c
c     4       0        0    0-4            Yes
c     4       1       1-4   0,4            Yes
c     4       1       1-4   2,3            No
c     4       2        5    0,4            Yes
c     4       2        5    2,3            No
c     4       2       6-n                  No
c     4       3                            No
c
c     3       0       0     0-2            Yes
c     3       1       1-3    0             Yes
c     3       1       1-3   1,2            No
c     3       2                            No
c
c     2       0       0     0,1            Yes
c     2       1       1-2    0             Yes
c     2       1       1-2    1             No
c     2       2                            No
c
c     1                                    No
c
c
c     !N.B. oprav co je oznacene c@!
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer ninda,nindb,nindext,typext,u,v,ssu,ssv,ssa,ssb,rc
       real*8 factor
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
c
       integer mapib(1:8,1:8,1:8)
c
c     help variables
c
       integer sa1,sa2,sa3,ssp,ssq,pq
       integer:: nhelp1=0,nhelp2=0,nhelp3=0,nhelp4=0,nhelp5=0
       integer:: nhelp6=0,nhelp7=0,nhelp8=0,nhelp9=0,nhelp10=0
       integer ia,ib,ibm
       integer typa,typb,p,q
       real*8 fact
c     To fix compiler warnings
      p=0
      q=0
c     general tests
c
       nhelp1=nindA+nindext
c
       if (nhelp1.ne.nindb) then
c     RC=1  : incompatible (nindA, nindB and nindext, Stup)
       rc=1
       return
       end if
c
       nhelp1=mmul(ssu,ssv)
       nhelp1=mmul(ssa,nhelp1)
       if (nhelp1.ne.ssb) then
c     RC=2  : incompatible (ssa, ssb ,ssu and ssv, Stup)
       rc=2
       return
       end if
c
       typa=mapda(0,6)
       typb=mapdb(0,6)
       fact=factor
c
       if ((typb.ge.1).and.(typb.le.3)) then
c     RC=3 : typB is 1,2 or 3 (NCI)
       rc=3
       return
       end if

c
       if ((nindext.eq.2).and.(typb.eq.4)) then
c
c     def p,q,ssp,ssq,fact(new)
c
       if (ssu.gt.ssv) then
c     ssu>ssv
       p=u
       q=v
       ssp=ssu
       ssq=ssv
       fact=factor
       else if (ssu.eq.ssv) then
c     ssu=ssv
       if (u.ge.v) then
       p=u
       q=v
       ssp=ssu
       ssq=ssv
       fact=factor
       else
       p=v
       q=u
       ssp=ssv
       ssq=ssu
       fact=-factor
       end if
       else
c     ssu<ssv
       p=v
       q=u
       ssp=ssv
       ssq=ssu
       fact=-factor
       end if
c
       end if
c
       if (nindb.eq.4) then
c
c     **********  -> B(pqrs) **********
c
       if (nindext.eq.0) then
c
c400  case B(pqrs) <-- A(pqrs) or B(p,q,r,s) <-- A(p,q,r,s)
c
c     tests
c
       if (typa.ne.typb) then
c     RC=4 : nindB=4, nindext=0 (TypA incompatible with TypB ,Stup)
       rc=4
       return
       end if
c
       do 400 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(sa1,sa2,sa3)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 400
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
       call add10 (wrk(nhelp2),wrk(nhelp3),nhelp1,fact)
c
 400    continue
c
       else if (nindext.eq.1) then
c
       if (typext.eq.1) then
c
       if (typb.eq.0) then
c
c4110 case B(p,q,r,s) <-- A(q,r,s)
c
c     tsets
c
       if (typa.ne.0) then
c     RC=5 : nindB=4, nindeext=1, typext=1, typB=0 (typA is not 0, Stup)
       rc=5
       return
       end if
c
       do 4110 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(ssu,sa1,sa2)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4110
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       nhelp8=nhelp5*nhelp6*nhelp7
c
       call add21 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp8,fact)
c
 4110   continue
c
       else if (typb.eq.4) then
c
c4114 case B(pq,rs) <-- A(q,rs)
c
c     tsets
c
       if (typa.ne.2) then
c     RC=6  : nindB=4, nindeext=1, typext=1, typB=4 (typA is not 2, Stup)
       rc=6
       return
       end if
c
       do 4114 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(ssu,sa1,sa2)
       ibm=mapib(sa1,ssu,sa2)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4114
c
c     def possA
       nhelp2=mapda(ia,1)
c
c
       if (ssu.gt.sa1) then
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       if (sa2.eq.sa3) then
       nhelp8=nhelp6*(nhelp6-1)/2
       else
       nhelp8=nhelp6*nhelp7
       end if
c
c     def possB
       nhelp3=mapdb(ib,1)
c     def fictive dimensions
       nhelp9=nhelp5*nhelp8
       call add21 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp9,fact)
c
       else if (ssu.eq.sa1) then
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       if (sa2.eq.sa3) then
       nhelp8=nhelp6*(nhelp6-1)/2
       else
       nhelp8=nhelp6*nhelp7
       end if
c
c     def possB
       nhelp3=mapdb(ib,1)
c     def fictive dimensions
       nhelp9=nhelp4*(nhelp4-1)/2
       call add41 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp9,nhelp8,fact)
c
       else
c     ssu<sa1  B(qp,rs) <-- -A_p (q,rs)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ibm,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ibm,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ibm,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ibm,6))
c
c     def fictive dimensions
       if (sa2.eq.sa3) then
       nhelp8=nhelp6*(nhelp6-1)/2
       else
       nhelp8=nhelp6*nhelp7
       end if
c
c     def possB-
       nhelp3=mapdb(ibm,1)
       call add32 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,nhelp8,-fact)
c
       end if
c
 4114   continue
c
       else
c     RC=7 : nindB=4, nindext=1, typext=1, (typA is not 0 or 4, (NCI))
       rc=7
       return
       end if
c
       else if (typext.eq.2) then
c
       if (typb.eq.0) then
c
c4120 case B(p,q,r,s) <-- A(p,r,s)
c
c     tsets
c
       if (typa.ne.0) then
c     RC=8 : nindB=4, nindeext=1, typext=2, typB=0 (typA is not 0, Stup)
       rc=8
       return
       end if
c
       do 4120 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(sa1,ssu,sa2)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4120
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       nhelp8=nhelp6*nhelp7
c
       call add32 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,nhelp8,fact)
c
 4120   continue
c
       else if (typb.eq.4) then
c
c4124 case B(pq,rs) <-- A(p,rs)
c
c     tsets
c
       if (typa.ne.2) then
c     RC=9 : nindB=4, nindeext=1, typext=2, typB=4 (typA is not 2, Stup)
       rc=9
       return
       end if
c
       do 4124 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(sa1,ssu,sa2)
       ibm=mapib(ssu,sa1,sa2)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4124
c
c     def possA
       nhelp2=mapda(ia,1)
c
c
       if (sa1.gt.ssu) then
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       if (sa2.eq.sa3) then
       nhelp8=nhelp6*(nhelp6-1)/2
       else
       nhelp8=nhelp6*nhelp7
       end if
c
c     def possB
       nhelp3=mapdb(ib,1)
       call add32 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,nhelp8,fact)
c
c
       else if (sa1.eq.ssu) then
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       if (sa2.eq.sa3) then
       nhelp8=nhelp6*(nhelp6-1)/2
       else
       nhelp8=nhelp6*nhelp7
       end if
c
c     def possB
       nhelp3=mapdb(ib,1)
c     def fictive dimensions
       nhelp9=nhelp4*(nhelp4-1)/2
       call add42 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp9,nhelp8,fact)
c
c
       else
c     sa1<ssu  B(qp,rs) <-- -A_q (p,rs)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ibm,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ibm,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ibm,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ibm,6))
c
c     def fictive dimensions
       if (sa2.eq.sa3) then
       nhelp8=nhelp6*(nhelp6-1)/2
       else
       nhelp8=nhelp6*nhelp7
       end if
c
c     def possB-
       nhelp3=mapdb(ibm,1)
c     def fictive index
       nhelp9=nhelp8*nhelp5
       call add21 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp9,-fact)
c
       end if
c
 4124   continue
c
       else
c     RC=10: nindB=4, nindext=1, typext=2, (typA is not 0 or 4, (NCI))
       rc=10
       return
       end if
c
       else if (typext.eq.3) then
c
       if (typb.eq.0) then
c
c4130 case B(p,q,r,s) <-- A(p,q,s)
c
c     tsets
c
       if (typa.ne.0) then
c     RC=11: nindB=4, nindeext=1, typext=3, typB=0 (typA is not 0, Stup)
       rc=11
       return
       end if
c
       do 4130 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(sa1,sa2,ssu)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4130
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       nhelp8=nhelp4*nhelp5
c
       call add32 (wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp6,nhelp7,fact)
c
 4130   continue
c
       else if (typb.eq.4) then
c
c4134 case B(pq,rs) <-- A(pq,s)
c@!   oprav to tak ako v typext 1 a 2
c
c     tsets
c
       if (typa.ne.1) then
c     RC=12: nindB=4, nindeext=1, typext=3, typB=4 (typA is not 1, Stup)
       rc=12
       return
       end if
c
       do 4134 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(sa1,sa2,ssu)
       ibm=mapib(sa1,sa2,sa3)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4134
c
c     def possA
       nhelp2=mapda(ia,1)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       if (sa1.eq.sa2) then
       nhelp8=nhelp4*(nhelp4-1)/2
       else
       nhelp8=nhelp4*nhelp5
       end if
c
       if (ssu.gt.sa3) then
c
c     def possB
       nhelp3=mapdb(ib,1)
       call add32 (wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp6,nhelp7,fact)
c
       else if (ssu.eq.sa3) then
c
c     def possB
       nhelp3=mapdb(ib,1)
c     def fictive dimensions
       nhelp9=nhelp6*(nhelp6-1)/2
       call add43 (wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp9,nhelp6,fact)
c
       else
c     ssu<sa3  B(pq,sr) <-- -A_r (pq,s)
c     def possB-
       nhelp3=mapdb(ibm,1)
c     def fictive dimension
       nhelp9=nhelp8*nhelp7
       call add22 (wrk(nhelp2),wrk(nhelp3),u,nhelp9,nhelp6,-fact)
c
       end if
c
 4134   continue
c
       else
c     RC=13: nindB=4, nindext=1, typext=3, (typA is not 0 or 4, (NCI))
       rc=13
       return
       end if
c
       else if (typext.eq.4) then
c
       if (typb.eq.0) then
c
c4140 case B(p,q,r,s) <-- A(p,q,r)
c
c     tsets
c
       if (typa.ne.0) then
c     RC=14: nindB=4, nindeext=1, typext=4, typB=0 (typA is not 0, Stup)
       rc=14
       return
       end if
c
       do 4140 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(sa1,sa2,sa3)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4140
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       nhelp8=nhelp4*nhelp5*nhelp6
c
       call add22 (wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp7,fact)
c
 4140   continue
c

       else if (typb.eq.4) then
c
c4144 case B(pq,rs) <-- A(pq,r)
c@!   oprav to tak ako v typext 1 a 2
c
c     tsets
c
       if (typa.ne.1) then
c     RC=15: nindB=4, nindeext=1, typext=4, typB=4 (typA is not 1, Stup)
       rc=15
       return
       end if
c
       do 4144 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(sa1,sa2,sa3)
       ibm=mapib(sa1,sa2,ssu)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4144
c
c     def possA
       nhelp2=mapda(ia,1)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     def fictive dimensions
       if (sa1.eq.sa2) then
       nhelp8=nhelp4*(nhelp4-1)/2
       else
       nhelp8=nhelp4*nhelp5
       end if
c
       if (sa3.gt.ssu) then
c
c     def possB
       nhelp3=mapdb(ib,1)
c     def fictive dimension
       nhelp9=nhelp8*nhelp6
       call add22 (wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp7,fact)
c
       else if (sa3.eq.ssu) then
c
c     def possB
       nhelp3=mapdb(ib,1)
c     def fictive dimensions
       nhelp9=nhelp6*(nhelp6-1)/2
       call add44 (wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp9,nhelp6,fact)
c
       else
c     sa3<ssu  B(pq,sr) <-- -A_s (pq,r)
c     def possB-
       nhelp3=mapdb(ibm,1)
       call add32 (wrk(nhelp2),wrk(nhelp3),u,nhelp8,nhelp7,nhelp6,-fact)
c
       end if
c
 4144   continue
c
       else
c     RC=16: nindB=4, nindext=1, typext=4, (typA is not 0 or 4, (NCI))
       rc=16
       return
       end if
c
       else
c     RC=17: nindB=4, nindext=1, typext=@  (Stup)
       rc=17
       return
       end if
c
       else if (nindext.eq.2) then
c
       if (typext.eq.5) then
c
       if (typb.eq.0) then
c
c4250 case B(p,q,r,s) <-- A(r,s)
c
c     tests
c
       if ((typb.eq.0).and.(typa.ne.0)) then
c     RC=18: nindB=4, nindext=2, typext=5, typB=0 (typA is not 0, Stup)
       rc=18
       return
       end if
c
       do 4250 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
c@
       nhelp1=mmul(ssu,ssv)
       nhelp1=mmul(nhelp1,sa1)
       nhelp1=mmul(nhelp1,ssb)
       if (nhelp1.ne.sa2) then
       write(6,*) ' Add Bpqrs <- Ars incorrect',ssp,ssq,sa1,nhelp1,sa1,
     & sa2
       goto 4250
       end if
c@@
c
       ib=mapib(ssu,ssv,sa1)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4250
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     calc joined pq index
       pq=(v-1)*nhelp4+u
c
c     calc fictive lengths
       nhelp9=nhelp6*nhelp7
       nhelp10=nhelp4*nhelp5
c
       call add21 (wrk(nhelp2),wrk(nhelp3),pq,nhelp10,nhelp9,fact)
c
 4250   continue
c
       else if (typb.eq.4) then
c
c4254 case B(pq,rs) <-- A(rs)
c
c     tests
c
       if ((typb.eq.4).and.(typa.ne.1)) then
c     RC=19: nindB=4, nindext=2, typext=5, typB=4 (typA is not 1, Stup)
       rc=19
       return
       end if
c
       do 4254 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
c
c@
       nhelp1=mmul(ssp,ssq)
       nhelp1=mmul(nhelp1,sa1)
       nhelp1=mmul(nhelp1,ssb)
       if (nhelp1.ne.sa2) then
       write(6,*) ' Add Bpqrs <- Ars incorrect'
       goto 4254
       end if
c@@
       ib=mapib(ssp,ssq,sa1)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 4254
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq,dimr,dims
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
       nhelp7=dimm(mapdb(0,4),mapdb(ib,6))
c
c     calc joined pq index and fictive length of pq pair
       if (ssp.eq.ssq) then
       pq=(p-1)*(p-2)/2+q
       nhelp10=nhelp4*(nhelp4-1)/2
       else
       pq=(q-1)*nhelp4+p
       nhelp10=nhelp4*nhelp5
       end if
c
c     calc fictive lengths
       if (sa1.eq.sa2) then
       nhelp9=nhelp6*(nhelp6-1)/2
       else
       nhelp9=nhelp6*nhelp7
       end if
c
       call add21 (wrk(nhelp2),wrk(nhelp3),pq,nhelp10,nhelp9,fact)
c
 4254   continue
c
       else
c     RC=20: nindB=4, nindext=2, typext=5 (typB is not 0 or 4, NCI)
       rc=20
       return
       end if
c
       else if (typext.eq.6) then
c
c426  case B(p,q,r,s) <-- A(p,q) and B(pq,rs) <-- A(pq)
c
c     RC=21: nindB=4, nindext=2, typext=6, NCI)
       rc=21
       return
c
       else
c     RC=22: nindB=4, nindext=2, (typext is not 5 or 6, NCI)
       rc=22
       return
       end if
c
       else
c     RC=23: nindB=4, nindext>2 (NCI)
       rc=23
       return
       end if
c
       else if (nindb.eq.3) then
c
c     **********  -> B(pqr) **********
c
       if (nindext.eq.0) then
c
c300  case B(pqr) <-- A(pqr)
c
c     tests
c
       if (typa.ne.typb) then
c     RC=24: nindB=3, nindext=0 (TypA incompatible with TypB ,Stup)
       rc=24
       return
       end if
c
       do 300 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib=mapib(sa1,sa2,1)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 300
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
       call add10 (wrk(nhelp2),wrk(nhelp3),nhelp1,fact)
c
 300    continue
c
       else if (nindext.eq.1) then
c
       if (typext.eq.1) then
c
c311  case B(p,q,r) <-- A(q,r)
c
       if ((typa.eq.0).and.(typb.eq.0)) then
c
c311  case B(p,q,r) <-- A(q,r)
c
       do 311 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
c
       ib=mapib(ssu,sa1,1)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 311
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq,dimr
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
c
c     def fictive dimensions
       nhelp7=nhelp5*nhelp6
c
       call add21 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp7,fact)
c
 311    continue
c
       else
c     RC=25: nindB=3, nindext=1, typext=1 (tybA,B is not 0, NCI)
       rc=25
       return
       end if
c
       else if (typext.eq.2) then
c
       if ((typa.eq.0).and.(typb.eq.0)) then
c
c312  case B(p,q,r) <-- A(p,r)
c
       do 312 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
c
       ib=mapib(sa1,ssu,1)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 312
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq,dimr
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
c
       call add32 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp6,nhelp7,fact)
c
 312    continue
c
       else
c     RC=26: nindB=3, nindext=1, typext=2 (tybA,B is not 0, NCI)
       rc=26
       return
       end if
c
       else if (typext.eq.3) then
c
       if ((typa.eq.0).and.(typb.eq.0)) then
c
c313  case B(p,q,r) <-- A(p,q)
c
       do 313 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
c
       ib=mapib(sa1,sa2,1)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 313
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq,dimr
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
       nhelp6=dimm(mapdb(0,3),mapdb(ib,5))
c
c     def fictive dimensions
       nhelp7=nhelp4*nhelp5
c
       call add21 (wrk(nhelp2),wrk(nhelp3),u,nhelp7,nhelp6,fact)
c
 313    continue
c
       else
c     RC=27: nindB=3, nindext=1, typext=3 (tybA,B is not 0, NCI)
       rc=27
       return
       end if
c
       else
c     RC=28: nindB=3 , typext=@ (Stup)
       rc=28
       return
       end if
c
       else
c     RC=29: nindB=3, nindext>1 (NCI)
       rc=29
       return
       end if
c
       else if (nindb.eq.2) then
c
c     **********  -> B(pq) **********
c
       if (nindext.eq.0) then
c
c200  case B(p,q) <-- A(p,q)
c
       do 200 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
c
       ib=mapib(sa1,1,1)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 200
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
       call add10 (wrk(nhelp2),wrk(nhelp3),nhelp1,fact)
c
 200    continue
c
       else if (nindext.eq.1) then
c
       if (typext.eq.1) then
c
c211  case B(p,q) <-- A(q)
c
       if ((typa.eq.0).and.(typb.eq.0)) then
c
       do 211 ia=1,mapda(0,5)
c
       ib=mapib(ssu,1,1)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 211
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
c
       call add21 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,fact)
c
 211    continue
c
       else
c     RC=30: nindB=2, nindext=1, typext=1, (typA,B is not 0, NCI)
       rc=30
       return
       end if
c
       else if (typext.eq.2) then
c
c212  case B(p,q) <-- A(p)
c
       if ((typa.eq.0).and.(typb.eq.0)) then
c
       do 212 ia=1,mapda(0,5)
c
       sa1=mapda(ia,3)
       ib=mapib(sa1,1,1)
c
c     def length
       nhelp1=mapda(ia,2)
       if (nhelp1.eq.0) goto 212
c
c     def possA,possB
       nhelp2=mapda(ia,1)
       nhelp3=mapdb(ib,1)
c
c     def dimp,dimq
       nhelp4=dimm(mapdb(0,1),mapdb(ib,3))
       nhelp5=dimm(mapdb(0,2),mapdb(ib,4))
c
       call add22 (wrk(nhelp2),wrk(nhelp3),u,nhelp4,nhelp5,fact)
c
 212    continue
c
       else
c     RC=31: nindB=2, nindext=1, typext=2, (typA,B is not 0, NCI)
       rc=31
       return
       end if
c
       else
c     RC=32: nindB=2, nindext=1, typext=@ (Stup)
       rc=32
       return
       end if
c
       else
c     RC=33: nindB=2, ininext>1 (NCI)
       rc=33
       return
       end if
c
       else
c     RC=34: nindb less then 2 (NCI/Stup)
       rc=34
       return
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakeWwdHlp2(Ww,W1,dima,dimbe,dimga)
! this routine does:
! Make Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
! for the case a"=b" , beSGrp/=gaSGrp
! N.B. algoritmus nieje prilis vymakany
!
! parameter description
! Ww   - array for Ww+(-) (O)
! W1   - array for W1(a",be",b",ga") (I)
! dimx - dimension of a",be",ga" (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimbe, dimga
real(kind=wp), intent(out) :: Ww(dima,dimbe,dimga)
real(kind=wp), intent(in) :: W1(dima,dimbe,dima,dimga)
integer(kind=iwp) :: a

do a=1,dima
  !DEC$ VECTOR UNALIGNED
  Ww(a,:,:) = W1(a,:,a,:)
end do

return

end subroutine MakeWwdHlp2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Absolutely NOT to be used for production!!!!                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: Oct 2004                                                    *
!                                                                      *
!***********************************************************************

subroutine Fmod1s(StandAlone)

use GuessOrb_Global, only: Label, nBas, nSym, PrintMOs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
!----------------------------------------------------------------------*
! Dummy arguments                                                      *
!----------------------------------------------------------------------*
logical(kind=iwp), intent(in) :: StandAlone
!----------------------------------------------------------------------*
! Local variables                                                      *
!----------------------------------------------------------------------*
logical(kind=iwp) :: Debug, Trace
! Basis set indices
integer(kind=iwp) :: iSym, iBas, jBas, kBas
! Dimensions
integer(kind=iwp) :: nBasMax, nBasTot, nTriTot, nSqrTot, n2Full
! Pointers
integer(kind=iwp) :: ipTmp1, ipTmp2, ipTmp3, ipTmp4
! Matrix elements
real(kind=wp) :: Sii, Sjj, Sik, Sjk, Skk
! Various variables
integer(kind=iwp) :: indx, iSymlb, irc, Lu, iDummy(7,8), RC
real(kind=wp) :: Det, dsum, eps
character(len=32) :: Line
character(len=80) :: Title
real(kind=wp), allocatable :: SmTr(:), DeTr(:), Esym(:), Edes(:), Smat(:), Ovl(:), Aux1(:), Sdes(:), Fdes(:), FSym(:), Fock(:), &
                              CMOs(:), Evec(:), Fmo(:), Aux2(:)
!----------------------------------------------------------------------*
! Some setup                                                           *
!----------------------------------------------------------------------*
if (StandAlone) then
  Debug = .false.
  Trace = .false.
else
  Debug = .false.
  Trace = .false.
end if
if (Trace) write(u6,*) '>>> Entering fmod1s'
!----------------------------------------------------------------------*
! Should only be called if symmetry is used.                           *
!----------------------------------------------------------------------*
if (nSym == 1) then
  call SysAbendMsg('fmod1s','internal error 001',' ')
end if
!----------------------------------------------------------------------*
! Setup various counters.                                              *
!----------------------------------------------------------------------*
nBasMax = 0
nBasTot = 0
nTriTot = 0
nSqrTot = 0
do iSym=1,nSym
  if (nBasMax < nBas(iSym)) nBasMax = nBas(iSym)
  nTriTot = nTriTot+nBas(iSym)*(nBas(iSym)+1)/2
  nSqrTot = nSqrTot+nBas(iSym)*nBas(iSym)
  nBasTot = nBasTot+nBas(iSym)
end do
n2Full = nBasTot*nBasTot
!----------------------------------------------------------------------*
! Get symmetry transformation matrix.                                  *
!----------------------------------------------------------------------*
call mma_allocate(SmTr,n2Full)
call mma_allocate(DeTr,n2Full)
call Get_dArray('SM',SmTr,n2Full)
call Minv(SmTr,DeTr,0,Det,nBasTot)
if (Debug) then
  call RecPrt('Symmetrization transformation matrix','(10f12.6)',SmTr,nBasTot,nBasTot)
  call RecPrt('Desymmetrization transformation matrix','(10f12.6)',DeTr,nBasTot,nBasTot)
end if
!----------------------------------------------------------------------*
! Create model Fock operator.                                          *
!----------------------------------------------------------------------*
call mma_allocate(Esym,nBasTot)
call FockOper(RC,Esym)
if (RC /= 0) then
  call mma_deallocate(Esym)
  call mma_deallocate(DeTr)
  call mma_deallocate(SmTr)
  return
end if
if (Debug) then
  call RecPrt('Diagonal of Fock','(10f12.6)',Esym,1,nBasTot)
end if
!----------------------------------------------------------------------*
! Desymmetrize model Fock operator                                     *
!----------------------------------------------------------------------*
call mma_allocate(Edes,nBasTot)
do iBas=1,nBasTot
  do kBas=1,nBasTot
    indx = kBas+nBasTot*(iBas-1)
    if (abs(SmTr(indx)) > 1.0e-3_wp) then
      Edes(kBas) = Esym(iBas)
    end if
  end do
end do
if (Debug) then
  call RecPrt('Desymmetrized diagonal of Fock','(10f12.6)',Edes,1,nBasTot)
end if
!----------------------------------------------------------------------*
! Read and square overlap matrix.                                      *
!----------------------------------------------------------------------*
call mma_allocate(Smat,n2Full)
call mma_allocate(Ovl,nTriTot)
iSymlb = 1
call RdOne(irc,2,'Mltpl  0',1,Ovl,iSymlb)
call dCopy_(n2Full,[Zero],0,Smat,1)
ipTmp1 = 1
ipTmp2 = 1
do iSym=1,nSym
  call Square(Ovl(ipTmp1),SMat(ipTmp2),1,nBasTot,nBas(iSym))
  ipTmp1 = ipTmp1+nBas(iSym)*(nBas(iSym)+1)/2
  ipTmp2 = ipTmp2+nBas(iSym)*nBasTot+nBas(iSym)
end do
if (Debug) then
  call RecPrt('Full overlap matrix','(10f12.6)',Smat,nBasTot,nBasTot)
end if
call mma_deallocate(Ovl)
!----------------------------------------------------------------------*
! Desymmetrize overlap matrix.                                         *
!----------------------------------------------------------------------*
call mma_allocate(Sdes,n2Full)
call mma_allocate(Aux1,n2Full)
call DGEMM_('N','N',nBasTot,nBasTot,nBasTot,One,Smat,nBasTot,DeTr,nBasTot,Zero,Aux1,nBasTot)
call DGEMM_('T','N',nBasTot,nBasTot,nBasTot,One,DeTr,nBasTot,Aux1,nBasTot,Zero,Sdes,nBasTot)
if (Debug) then
  call RecPrt('Desymmetrized overlap matrix','(10f12.6)',Sdes,nBasTot,nBasTot)
end if
call mma_deallocate(Aux1)
!----------------------------------------------------------------------*
! Build Fock matrix                                                    *
!----------------------------------------------------------------------*
call mma_allocate(Fdes,n2Full)
do iBas=1,nBasTot
  Sii = Sdes(iBas+nBasTot*(iBas-1))
  do jBas=1,nBasTot
    Sjj = Sdes(jBas+nBasTot*(jBas-1))
    dsum = Zero
    do kBas=1,nBasTot
      eps = Edes(kBas)
      Skk = Sdes(kBas+nBasTot*(kBas-1))
      Sik = Sdes(iBas+nBasTot*(kBas-1))
      Sjk = Sdes(jBas+nBasTot*(kBas-1))
      dsum = dsum+eps*Sik*Sjk/sqrt(Sii*Sjj*Skk*Skk)
    end do
    Fdes(iBas+nBasTot*(jBas-1)) = dsum
  end do
end do
if (Debug) then
  call RecPrt('Desymmetrized Fock matrix','(10f12.6)',Fdes,nBasTot,nBasTot)
end if
!----------------------------------------------------------------------*
! Symmetrize Fock matrix.                                              *
!----------------------------------------------------------------------*
call mma_allocate(Fsym,n2Full)
call mma_allocate(Aux1,n2Full)
call DGEMM_('N','N',nBasTot,nBasTot,nBasTot,One,Fdes,nBasTot,SmTr,nBasTot,Zero,Aux1,nBasTot)
call DGEMM_('T','N',nBasTot,nBasTot,nBasTot,One,SmTr,nBasTot,Aux1,nBasTot,Zero,Fsym,nBasTot)
if (Debug) then
  call RecPrt('Symmetrized overlap matrix','(10f12.6)',Fsym,nBasTot,nBasTot)
end if
call mma_deallocate(Aux1)
!----------------------------------------------------------------------*
! Compact the symmetrized Fock matrix.                                 *
!----------------------------------------------------------------------*
call mma_allocate(Fock,nTriTot)
ipTmp1 = 1
ipTmp2 = 1
do iSym=1,nSym
  indx = 1
  do iBas=1,nBas(iSym)
    do jBas=1,iBas
      Fock(indx) = Fsym(iBas+nBasTot*(jBas-1))
      indx = indx+1
    end do
  end do
  if (Debug) then
    write(Line,'(a,i2)') 'Fock matrix, symmetry ',iSym
    call TriPrt(Line,'(10f12.6)',Fock(ipTmp2),nBas(iSym))
  end if
  ipTmp1 = ipTmp1+nBas(iSym)*nBasTot+nBas(iSym)
  ipTmp2 = ipTmp2+nBas(iSym)*(nBas(iSym)+1)/2
end do
!----------------------------------------------------------------------*
! Make ON basis                                                        *
!----------------------------------------------------------------------*
call mma_allocate(CMOs,nSqrTot)
call goLowdin(CMOs)
!----------------------------------------------------------------------*
! Transform Fock matrix to MO basis and diagonalize                    *
!----------------------------------------------------------------------*
call mma_allocate(Evec,nTriTot)
call mma_allocate(Fmo,nTriTot)
call mma_allocate(Aux1,nBasMax*nBasMax)
call mma_allocate(Aux2,nBasMax*nBasMax)

ipTmp1 = 1
ipTmp2 = 1
ipTmp3 = 1
ipTmp4 = 1
do iSym=1,nSym
  if (nBas(iSym) > 0) then
    call Square(Fock(ipTmp1),Aux1,1,nBas(iSym),nBas(iSym))
    call DGEMM_('N','N',nBas(iSym),nBas(iSym),nbas(iSym),One,Aux1,nBas(iSym),CMOs(ipTmp2),nBas(iSym),Zero,Aux2,nBas(iSym))
    call DGEMM_Tri('T','N',nBas(iSym),nBas(iSym),nBas(iSym),One,CMOs(ipTmp2),nBas(iSym),Aux2,nBas(iSym),Zero,Fmo(ipTmp3),nBas(iSym))
    if (Debug) then
      write(Line,'(a,i2)') 'MO Fock matrix, symmetry ',iSym
      call TriPrt(Line,'(10f12.6)',Fmo(ipTmp3),nBas(iSym))
    end if
    !call Jacob(Fmo(ipTmp3),CMOs(ipTmp2),nBas(iSym),nBas(iSym))
    call NIdiag(Fmo(ipTmp3),CMOs(ipTmp2),nBas(iSym),nBas(iSym))
    if (Debug) then
      write(Line,'(a,i2)') 'Diagonal Fock matrix, symmetry ',iSym
      call TriPrt(Line,'(10f12.6)',Fmo(ipTmp3),nBas(iSym))
    end if
    call goPickup(Fmo(ipTmp3),Evec(ipTmp4),nBas(iSym))
    call goSort(Evec(ipTmp4),CMOs(ipTmp2),nBas(iSym),nBas(iSym))
  end if
  ipTmp1 = ipTmp1+nBas(iSym)*(nBas(iSym)+1)/2
  ipTmp2 = ipTmp2+nBas(iSym)*nBas(iSym)
  ipTmp3 = ipTmp3+nBas(iSym)*(nBas(iSym)+1)/2
  ipTmp4 = ipTmp4+nBas(iSym)
end do
call mma_deallocate(Fmo)
call mma_deallocate(Aux2)
call mma_deallocate(Aux1)
!----------------------------------------------------------------------*
! Present data.                                                        *
!----------------------------------------------------------------------*
if (PrintMOs) then
  call PriMO('Start orbitals',.false.,.true.,Zero,1.0e6_wp,nSym,nBas,nBas,Label,Evec,Evec,CMOs,3)
end if
call put_darray('Guessorb',CMOs,nSqrTot)
call put_darray('Guessorb energies',Evec,nBasTot)
call Put_iArray('nOrb',nBas,nSym)
call mma_allocate(Aux1,nBasTot)
Aux1(:) = 0.0d0
Lu = 20
Title = 'Guess orbitals'
call WrVec('GSSORB',Lu,'COE',nSym,nBas,nBas,CMOs,Aux1,Evec,iDummy,Title)
call mma_deallocate(Aux1)
!----------------------------------------------------------------------*
! Done, deallocate the rest.                                           *
!----------------------------------------------------------------------*
call mma_deallocate(Evec)
call mma_deallocate(CMOs)
call mma_deallocate(Fock)
call mma_deallocate(Fsym)
call mma_deallocate(Fdes)
call mma_deallocate(Sdes)
call mma_deallocate(Smat)
call mma_deallocate(Edes)
call mma_deallocate(Esym)
call mma_deallocate(DeTr)
call mma_deallocate(SmTr)
if (trace) write(u6,*) '<<< Exiting fmod1s'

return

end subroutine Fmod1s

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine get_Cm_(IPCSF,IPCNF,MXPDIM,NCONF,NPCSF,NPCNF,Cn,EnFin,DTOC,IPRODT,ICONF,IREFSM,ONEBOD,ECORE,NACTOB,NEL,NAEL,NBEL,TUVX, &
                   NTEST,ExFac,IREOTS,Ctot)
! Obtain Cm coefficients out of the AA Block
! to the first order in Lowdin equation
!
! ARGUMENTS :
! ===========
! IPCSF      : CSF's order - Index Array -                    (Input)
! IPCNF      : CNF's order - Index Array -                    (Input)
! MXPDIM     : Total number of CSFs                           (Input)
! NCONF      : Total Number of CNFs of symmetry IREFSM        (Input)
! NPCSF      : Number of CSFs in AA block                     (Input)
! NPCNF      : Number of CNFs in AA block                     (Input)
! Cn         : AA Block CI-Coefficients for root selected     (Input)
! EnFin      : Final Energy for the root selected             (Input)
! DTOC       : Transformation matrix between CSF's and DET's  (Input)
! IPRODT     : Prototype determinants                         (Input)
! ICONF      : List of configurations                         (Input)
! IREFSM     : symmetry of considered CI space                (Input)
! Onebod     : one body Hamilton matrix in rectangular form   (Input)
! ECORE      : Core energy                                    (Input)
! NACTOB     : Number of active orbitals                      (Input)
! NEL        : total number of active electrons               (Input)
! NAEL       : number of alpha active electron                (Input)
! NBEL       : number of beta active electron                 (Input)
! TUVX       : Two-electron integrals (MO space)
! IREOTS     : Type => symmetry reordering array
! Ctot       : Vector of all nConf CI-coeff for a single root (Output)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: MXPDIM, NCONF, IPCSF(MXPDIM), IPCNF(NCONF), NPCSF, NPCNF, IPRODT(*), ICONF(*), IREFSM, NACTOB, &
                                 NEL, NAEL, NBEL, IREOTS(NACTOB)
real(kind=wp), intent(in) :: Cn(NPCSF), EnFin, DTOC(*), ONEBOD(NACTOB,NACTOB), ECORE, TUVX(*), ExFac
integer(kind=iwp), intent(inout) :: NTEST
real(kind=wp), intent(out) :: Ctot(MXPDIM)
integer(kind=iwp) :: iAlpha, IATYP, IBblockV, IIA, IIAB, IIL, IILACT, IILB, iKACONF, iKLCONF, ILAI, ILTYP, ITYP, KACONF, KLAUXD, &
                     KLCONF, KLFREE, Mindex, MXCSFC, MXXWS, NCSFA, NCSFL
real(kind=wp) :: C_AlphaLoop1, C_AlphaLoop2, C_computeH_AB, C_computeH_AB1, C_computeH_AB2, C_ComputeH_BB, C_computeH_BB1, &
                 C_computeH_BB2, C_last1, C_last2, C_Oper, C_oper1, C_oper2, W_AlphaLoop1, W_AlphaLoop2, W_ComputeH_AB, &
                 W_computeH_AB1, W_computeH_AB2, W_ComputeH_BB, W_computeH_BB1, W_computeH_BB2, W_last1, W_last2, W_Oper, W_oper1, &
                 W_oper2, xmaxGaTi
real(kind=wp), allocatable :: AuxBB(:,:), AuxD(:), AuxGa(:), AuxGaTi(:), AuxV(:,:), Scr(:)
integer(kind=iwp), external :: ip_of_iWork_d, ip_of_Work
real(kind=r8), external :: ddot_
#include "spinfo.fh"
#include "WrkSpc.fh"

if (NTEST >= 30) then
  write(u6,*) ' Input in get_Cm_'
  write(u6,*) ' =================='
  write(u6,*) ' Total Number of CNFs ',NCONF
  write(u6,*) ' Total Number of CSFs ',MXPDIM
  write(u6,*) ' CNFs included :'
  call IWRTMA(IPCNF,1,NCONF,1,NCONF)
  write(u6,*) ' CSFs included :'
  call IWRTMA(IPCSF,1,MXPDIM,1,MXPDIM)
  write(u6,*) ' Number of CNFs in AA block:',NPCNF
  write(u6,*) ' Number of CSFs in AA block:',NPCSF
  write(u6,*) 'Cn Coefficients'
  call wrtmat(Cn,NPCSF,1,NPCSF,1)
end if

Ctot(:) = Zero

MXCSFC = 0
do ITYP=1,NTYP
  MXCSFC = max(MXCSFC,NCSFTP(ITYP))
end do

IBblockV = MXPDIM-NPCSF
call mma_allocate(AuxD,MXCSFC,label='AuxDia')
call mma_allocate(AuxGa,MXCSFC,label='AuxGa')
call mma_allocate(AuxGaTi,MXCSFC,label='AuxGaTi')
call mma_allocate(AuxV,NPCSF,MXCSFC,label='AuxVer')
call mma_allocate(AuxBB,IBblockV,MXCSFC,label='AuxBB')
call mma_maxDBLE(MXXWS)
call mma_allocate(Scr,MXXWS,label='EXHSCR')

KACONF = ip_of_Work(Scr(1))
KLCONF = KACONF+NEL
KLAUXD = KLCONF+NEL
KLFREE = KLAUXD+MXCSFC*MXCSFC

! Shape of matrix:
!
!           CNFL (n)
!
!      1  2  4  7 11 16 22 ...
!  C   -  3  5  8 12 17 23 ...
!  N   -  -  6  9 13 18 24 ...
!  F   -  -  - 10 14 19 25 ...
!  R   -  -  -  - 15 20 26 ...
! (m)  -  -  -  -  - 21 27 ...
!      -  -  -  -  -  - 28 ...
!      -  -  -  -  -  -  - ...
!
! Splitting:
!
!          |
!     AA   |   AB
!  --------|--------
!     BA   |   BB
!          |

call cwtime(C_AlphaLoop1,W_AlphaLoop1)
C_ComputeH_AB = Zero
W_ComputeH_AB = Zero
C_ComputeH_BB = Zero
W_ComputeH_BB = Zero
C_Oper = Zero
W_Oper = Zero

IIAB = 1
do iAlpha=NPCNF+1,NCONF
  !call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
  call cwtime(C_computeH_AB1,W_computeH_AB1)
  if (NTEST >= 30) write(u6,*) 'iAlpha = ',iAlpha
  iKACONF = ip_of_iWork_d(Work(KACONF))
  call GETCNF_LUCIA(iWork(iKACONF),IATYP,IPCNF(iAlpha),ICONF,IREFSM,NEL)
  NCSFA = NCSFTP(IATYP)
  if (NTEST >= 30) write(u6,*) 'NCSFA = ',NCSFA
  !*********************************************************************
  !                      BB-Block DIAGONAL Elements                    *
  !*********************************************************************
  iKACONF = ip_of_iWork_d(Work(KACONF))
  call CNHCN(iWork(iKACONF),IATYP,iWork(iKACONF),IATYP,Work(KLAUXD),Work(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX, &
             NTEST,ExFac,IREOTS)
  if (NTEST >= 30) then
    write(u6,*) 'Alpha_Alpha elements in BB-block'
    call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
  end if
  do IIA=1,NCSFA
    ILAI = IIA*IIA
    AuxD(IIA) = Work(KLAUXD+ILAI-1)
    !write(u6,*) 'ILAI =',ILAI
    if (NTEST >= 30) then
      write(u6,*) 'AuxD(IIA)',AuxD(IIA)
    end if
  end do

  IILB = 1
  do Mindex=1,NPCNF ! Loop over AB-Block
    !call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
    if (NTEST >= 30) then
      write(u6,*) 'Mindex in AB-Block',Mindex
    end if
    iKLCONF = ip_of_iWork_d(Work(KLCONF))
    call GETCNF_LUCIA(iWork(iKLCONF),ILTYP,IPCNF(Mindex),ICONF,IREFSM,NEL)
    NCSFL = NCSFTP(ILTYP)
    if (NTEST >= 30) write(u6,*) 'NCSFL = ',NCSFL
    iKACONF = ip_of_iWork_d(Work(KACONF))
    iKLCONF = ip_of_iWork_d(Work(KLCONF))
    call CNHCN(iWork(iKACONF),IATYP,iWork(iKLCONF),ILTYP,Work(KLAUXD),Work(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX, &
               NTEST,ExFac,IREOTS)
    if (NTEST >= 30) then
      write(u6,*) 'M_Alpha elements'
      call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
    end if
    do IIA=1,NCSFA
      do IIL=1,NCSFL
        IILACT = IILB-1+IIL
        ILAI = (IIL-1)*NCSFA+IIA
        !ILAI = (IIA-1)*MXCSFC+IIL
        AuxV(IILACT,IIA) = Work(KLAUXD+ILAI-1)
        if (NTEST >= 30) then
          write(u6,*) 'ILAI, IILACT, IIA =',ILAI,IILACT,IIA
          write(u6,*) 'AuxV(IILACT,IIA)',AuxV(IILACT,IIA)
        end if
      end do
    end do
    IILB = IILB+NCSFL
  end do ! End loop over AB-Block
  call cwtime(C_computeH_AB2,W_computeH_AB2)
  C_ComputeH_AB = C_ComputeH_AB+C_computeH_AB2-C_computeH_AB1
  W_ComputeH_AB = W_ComputeH_AB+W_computeH_AB2-W_computeH_AB1

  if (NTEST >= 30) then
    write(u6,*) 'AB-Block Vertical Vector'
    call wrtmat(AuxV,NPCSF,NCSFA,NPCSF,NCSFA)
  end if

  !*********************************************************************
  ! Compute:                                                           *
  ! 1.  G_Alpha_tilde                                                  *
  ! 2.  G_Alpha                                                        *
  !*********************************************************************
  call cwtime(C_oper1,W_oper1)
  do IIA=1,NCSFA
    AuxGaTi(IIA) = ddot_(NPCSF,AuxV(:,IIA),1,Cn,1)
    AuxGa(IIA) = AuxGaTi(IIA)/(EnFin-AuxD(IIA))
    if (NTEST >= 30) then
      write(u6,*) 'AuxGaTi(IIA)',AuxGaTi(IIA)
      write(u6,*) 'AuxGa(IIA)  ',AuxGa(IIA)
    end if
  end do
  call cwtime(C_oper2,W_oper2)
  C_oper = C_oper+C_oper2-C_oper1
  W_oper = W_oper+W_oper2-W_oper1

  !*********************************************************************
  ! Loop over BB block to get the first order correction to Cm.        *
  ! If not required by the USER (with a keyword) it will be skipped!   *
  !*********************************************************************

  xmaxGaTi = Zero
  do IIA=1,NCSFA
    xmaxGaTi = max(xmaxGaTi,abs(AuxGaTi(IIA)))
  end do
  if (xmaxGaTi >= 1.0e-12_wp) then ! let's try this trick to make SplitCAS faster!
    call cwtime(C_computeH_BB1,W_computeH_BB1)
    AuxBB(:,:) = Zero
    IILB = 1
    do Mindex=NPCNF+1,NCONF ! Loop over BB-Block
      !call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
      !if (NTEST >= 30) write(u6,*) 'Mindex in BB-Block',Mindex
      iKLCONF = ip_of_iWork_d(Work(KLCONF))
      call GETCNF_LUCIA(iWork(iKLCONF),ILTYP,IPCNF(Mindex),ICONF,IREFSM,NEL)
      NCSFL = NCSFTP(ILTYP)
      !if (NTEST >= 30) write(u6,*) 'NCSFL = ',NCSFL
      iKACONF = ip_of_iWork_d(Work(KACONF))
      iKLCONF = ip_of_iWork_d(Work(KLCONF))
      call CNHCN(iWork(iKACONF),IATYP,iWork(iKLCONF),ILTYP,Work(KLAUXD),Work(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB, &
                 TUVX,NTEST,ExFac,IREOTS)
      !if (NTEST >= 30) then
      !  write(u6,*) 'M_Alpha elements in BB-block'
      !  call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
      !end if
      do IIA=1,NCSFA
        do IIL=1,NCSFL
          IILACT = IILB-1+IIL
          !IIAACT = NPCSF*(IIA-1)
          ILAI = (IIL-1)*NCSFA+IIA
          !ILAI = (IIA-1)*MXCSFC+IIL
          AuxBB(IILACT,IIA) = Work(KLAUXD+ILAI-1)
          if ((iAlpha == Mindex) .and. (IIA == IIL)) then
            !write(u6,*) 'iAlpha, IIAB',iAlpha,IIAB
            AuxBB(IILACT,IIA) = Zero
          end if
          !write(u6,*) 'ILAI, IILACT, IIA =',ILAI,IILACT,IIA
          !if (NTEST >= 30) then
          !  write(u6,*) 'AuxBB(IILACT,IIA)',AuxBB(IILACT,IIA)
          !end if
        end do
      end do
      IILB = IILB+NCSFL
    end do ! End Loop over BB-Block
    !if (NTEST >= 30) then
    !  write(u6,*) 'BB-Block Vertical Vector'
    !  call wrtmat(AuxBB,iBblockV,NCSFA,iBblockV,NCSFA)
    !end if
    call cwtime(C_computeH_BB2,W_computeH_BB2)
    C_ComputeH_BB = C_ComputeH_BB+C_computeH_BB2-C_computeH_BB1
    W_ComputeH_BB = W_ComputeH_BB+W_computeH_BB2-W_computeH_BB1

    call cwtime(C_oper1,W_oper1)
    do IIA=1,NCSFA
      AuxBB(:,IIA) = AuxGa(IIA)*AuxBB(:,IIA)
      if (NTEST >= 30) then
        write(u6,*) 'BB-Block Vertical Vector times Ga'
        call wrtmat(AuxBB,iBblockV,NCSFA,iBblockV,NCSFA)
      end if
      call daxpy_(iBblockV,One,AuxBB(:,IIA),1,Ctot(NPCSF+1),1)
      if (NTEST >= 30) then
        write(u6,*) 'Ctot correction'
        call wrtmat(Ctot,MXPDIM,1,MXPDIM,1)
      end if
    end do
  end if ! End of trick to make SplitCAS faster

  do IIA=1,NCSFA
    Ctot(NPCSF+IIAB+IIA-1) = Ctot(NPCSF+IIAB+IIA-1)+AuxGaTi(IIA)
    if (NTEST >= 30) then
      write(u6,*) 'Ctot'
      call wrtmat(Ctot,MXPDIM,1,MXPDIM,1)
    end if
  end do
  call cwtime(C_oper2,W_oper2)
  C_oper = C_oper+C_oper2-C_oper1
  W_oper = W_oper+W_oper2-W_oper1

  IIAB = IIAB+NCSFA
end do ! End of the loop over iAlpha
if (NTEST >= 30) then
  call cwtime(C_AlphaLoop2,W_AlphaLoop2)
  write(u6,*) 'Total time needed to get_Cm_ in Alpha Loop'
  write(u6,*) 'CPU timing : ',C_AlphaLoop2-C_AlphaLoop1
  write(u6,*) 'W. timing  : ',W_AlphaLoop2-W_AlphaLoop1

  write(u6,*) 'Total time to read H_AB :'
  write(u6,*) 'CPU timing : ',C_ComputeH_AB
  write(u6,*) 'W. timing  : ',W_ComputeH_AB

  write(u6,*) 'Total time to read H_BB :'
  write(u6,*) 'CPU timing : ',C_ComputeH_BB
  write(u6,*) 'W. timing  : ',W_ComputeH_BB

  write(u6,*) 'Total time to calculate (ddot+dscal+daxpy) :'
  write(u6,*) 'CPU timing : ',C_Oper
  write(u6,*) 'W. timing  : ',W_Oper
end if

call cwtime(C_last1,W_last1)
IIAB = 1
do Mindex=NPCNF+1,NCONF
  !call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
  if (NTEST >= 30) write(u6,*) 'Mindex last do loop = ',Mindex
  iKACONF = ip_of_iWork_d(Work(KACONF))
  call GETCNF_LUCIA(iWork(iKACONF),IATYP,IPCNF(Mindex),ICONF,IREFSM,NEL)
  NCSFA = NCSFTP(IATYP)
  if (NTEST >= 30) write(u6,*) 'NCSFA = ',NCSFA
  iKACONF = ip_of_iWork_d(Work(KACONF))
  call CNHCN(iWork(iKACONF),IATYP,iWork(iKACONF),IATYP,Work(KLAUXD),Work(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX, &
             NTEST,ExFac,IREOTS)
  if (NTEST >= 30) then
    write(u6,*) 'Alpha_Alpha elements in BB-block'
    call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
  end if
  do IIA=1,NCSFA
    ILAI = IIA*IIA
    !AuxD(IIA) = Work(KLAUXD+ILAI-1)
    if (NTEST >= 30) then
      write(u6,*) 'Work(KLAUXD+ILAI-1)',Work(KLAUXD+ILAI-1)
    end if
    !AuxD(IIA) = One/(EnFin-Work(KLAUXD+ILAI-1))
    Ctot(NPCSF+IIAB+IIA-1) = Ctot(NPCSF+IIAB+IIA-1)/(EnFin-Work(KLAUXD+ILAI-1))
  end do
  IIAB = IIAB+NCSFA
end do
if (NTEST >= 30) then
  call cwtime(C_last2,W_last2)
  write(u6,*) 'Time last iteration over Hbb :'
  write(u6,*) 'CPU timing : ',C_last2-C_last1
  write(u6,*) 'W. timing  : ',W_last2-W_last1
end if

Ctot(1:NPCSF) = Cn(:)
if (NTEST >= 30) then
  write(u6,*) 'final Ctot vector'
  call wrtmat(Ctot,MXPDIM,1,MXPDIM,1)
end if
call mma_deallocate(AuxD)
call mma_deallocate(AuxGa)
call mma_deallocate(AuxGaTi)
call mma_deallocate(AuxV)
call mma_deallocate(AuxBB)
call mma_deallocate(Scr)

return

end subroutine get_Cm_

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_CASPT2_RDINP(DFonly,LuSpool)
!***********************************************************************
!
!  Purpose:   If DFonly, use defaults only.
!             Else, read and process input for Cholesky section
!             in CASPt2
!
!***********************************************************************

use Fock_util_global, only: ALGO, Deco, DensityCheck, REORD
use Cholesky, only: timings
use ChoCASPT2, only: iALGO
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp), intent(in) :: DFonly
integer(kind=iwp), intent(in) :: LuSpool
integer(kind=iwp) :: iChrct, Last
character(len=180) :: KWord, Key
integer(kind=iwp), external :: iCLast
character(len=180), external :: Get_Ln

!                                                                      *
!***********************************************************************
!                                                                      *
! Algorithms for generating MO integrals in CASPT2
!
!    iALGO :
!           0  --> MOLINT file is generated from the
!                  transformed Cholesky vectors. Both "Coulomb" and
!                  "Exchange(1,2)" integrals are computed and stored
!                  on disk
!! Is iALGO = 0 really working?
!
!           1  --> Only the "Exchange" integrals are computed and
!                  combined directly in order to compute the RHS
!                  of the caspt2 equations. The latter is then
!                  stored on disk. The AO Fock matrix is
!                  computed during the MO transformation of the
!                  vectors and it is stored on disk
!
!***********************************************************************
!
!**** Algorithms for using Cholesky vectors in Fock matrix generation **
!
!   ALGO:
!      0  --->  Integrals are regenerated on the fly
!               from a set of Cholesky vectors resorted on disk
!
!      1  --->  The resorted Cholesky vectors are used directly
!               by the Fock matrix builder routines and contracted
!               with the proper density matrices. Uses
!               vectors resorted either on disk or on the fly
!
!      2  --->  As in option 1 but using the MO-basis transformed
!               vectors for computing the exchange term
!
!                                                                      *
!***********************************************************************
!                                                                      *
! Default  parameters

if (DFonly) then
  iALGO = 1
  ALGO = 2
  REORD = .false.
  DECO = .true.
  DensityCheck = .false.
  timings = .false.
  return
end if

! set some parameters if not specified in ChoInput section
iALGO = 1
ALGO = 2
REORD = .false.
DECO = .true.
DensityCheck = .false.
timings = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
! Process the input

!----------------------------------------------------------------------*
! The big turning point.                                               *
!----------------------------------------------------------------------*
do
  !--------------------------------------------------------------------*
  ! Use Get_Ln to read the lines.                                      *
  !--------------------------------------------------------------------*
  Key = Get_Ln(LuSpool)
  Kword = Key
  call UpCase(Kword)
  !--------------------------------------------------------------------*
  ! The keywords and their labels.                                     *
  !--------------------------------------------------------------------*

  if (KWord(1:1) == '*') cycle
  if (KWord == '') cycle

  select case (KWord(1:4))

    case ('ALGO')
      ! Read Cholesky algorithm parameters
      read(LuSpool,*) ALGO

    case ('IALG')
      read(LuSpool,*) iALGO

    case ('REOR')
      REORD = .true.
      write(u6,*) 'Vectors reordered on FILE'
      write(u6,*)

    case ('DECO')
      DECO = .true.
      write(u6,*) 'Decomposed densty matrix'
      write(u6,*)

    case ('TIME')
      timings = .true.

    case ('DCHK')
      DensityCheck = .true.

    case ('END ','ENDO')
      ! End of input
      return
    case Default
      !----------------------------------------------------------------*
      ! Control section                                                *
      !----------------------------------------------------------------*
      iChrct = len(KWord)
      Last = iCLast(KWord,iChrct)
      write(u6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
      write(u6,*) 'CHO_CASPT2_RDINP Error in keyword.'
      call ABEND()
  end select
end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine CHO_CASPT2_RDINP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  dGeMM_Tri
!
!> @brief
!>   Compute matrix product, store result in triangular storage format.
!>   May be used exactly as level 3 BLAS library routine ::DGEMM with \p C stored triangularly.
!> @author Thomas Bondo Pedersen
!>
!> @details
!> This subroutine computes the matrix product of matrices \p A and \p B
!> in a manner similar to the level 3 BLAS routine ::DGEMM. Unlike
!> ::DGEMM, however, the result matrix \p C is computed in triangular
!> storage (i.e., only upper triangle [identical to lower triangle
!> if \p C is symmetric] including diagonal elements). The argument
!> list is identical to that of ::DGEMM. Note, however, that \p m must
!> be equal to \p n. Moreover, \p ldC is not used here (it is included
!> only to have the same interface as ::DGEMM), but must be at least
!> ``1``.
!>
!> @param[in]     TransA Transposition of \p A
!> @param[in]     TransB Transposition of \p B
!> @param[in]     m      Row dimension of \p C
!> @param[in]     n      Column dimension of \p C
!> @param[in]     k      Dimension of summation index
!> @param[in]     alpha  Scale factor
!> @param[in]     A      Factor matrix \p A
!> @param[in]     ldA    Leading dimension of \p A
!> @param[in]     B      Factor matrix \p B
!> @param[in]     ldB    Leading dimension of\p  B
!> @param[in]     beta   Scale factor
!> @param[in,out] C      Result matrix
!> @param[in]     ldC    Leading dimension of \p C
!***********************************************************************

subroutine dGeMM_Tri(TransA,TransB,m,n,k,alpha,A,ldA,B,ldB,beta,C,ldC)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
character, intent(in) :: TransA, TransB
integer(kind=iwp), intent(in) :: m, n, k, ldA, ldB, ldC
real(kind=wp), intent(in) :: alpha, A(ldA,*), B(ldB,*), beta
real(kind=wp), intent(inout) :: C(*)
integer(kind=iwp) :: iArg, j, kOff, ldARef, ldBRef
logical(kind=iwp) :: NoAB, NoC
character(len=2) :: ArgNum
character(len=*), parameter :: ArgErr = ' Illegal argument number ', SecNam = 'dGeMM_Tri'

! Test input parameters.
! ----------------------

if ((TransA == 'N') .or. (TransA == 'n')) then
  ldARef = m
else if ((TransA == 'T') .or. (TransA == 't')) then
  ldARef = k
else
  ArgNum = ' 1'
  call SysAbendMsg(SecNam,ArgErr,ArgNum)
  ldARef = 1
end if
ldARef = max(ldARef,1)

if ((TransB == 'N') .or. (TransB == 'n')) then
  ldBRef = k
else if ((TransB == 'T') .or. (TransB == 't')) then
  ldBRef = n
else
  ArgNum = ' 2'
  call SysAbendMsg(SecNam,ArgErr,ArgNum)
  ldBRef = 1
end if
ldBRef = max(ldBRef,1)

iArg = 0
if (m < 0) then
  iArg = 3
else if (n /= m) then
  iArg = 4
else if (k < 0) then
  iArg = 5
else if (ldA < ldARef) then
  iArg = 8
else if (ldB < ldBRef) then
  iArg = 10
else if (ldC < 1) then
  iArg = 13
end if
if (iArg /= 0) then
  write(ArgNum,'(I2)') iArg
  call SysAbendMsg(SecNam,ArgErr,ArgNum)
end if

! Scale C and return if possible.
! -------------------------------

NoC = n == 0
NoAB = (alpha == Zero) .or. (k == 0)
if (NoC .or. (NoAB .and. (beta == one))) return
if (beta == Zero) then
  C(1:nTri_Elem(n)) = Zero
else if (beta /= One) then
  C(1:nTri_Elem(n)) = beta*C(1:nTri_Elem(n))
end if
if (NoAB) return

! Compute using level 2 BLAS library (matrix-vector products).
! ------------------------------------------------------------

kOff = 1
if ((TransB == 'N') .or. (TransB == 'n')) then
  if ((TransA == 'N') .or. (TransA == 'n')) then
    do j=1,n
      call dGeMV_('N',j,k,alpha,A,ldA,B(:,j),1,One,C(kOff),1)
      kOff = kOff+j
    end do
  else
    do j=1,n
      call dGeMV_('T',k,j,alpha,A,ldA,B(:,j),1,One,C(kOff),1)
      kOff = kOff+j
    end do
  end if
else
  if ((TransA == 'N') .or. (TransA == 'n')) then
    do j=1,n
      call dGeMV_('N',j,k,alpha,A,ldA,B(j,1),ldB,One,C(kOff),1)
      kOff = kOff+j
    end do
  else
    do j=1,n
      call dGeMV_('T',k,j,alpha,A,ldA,B(j,1),ldB,One,C(kOff),1)
      kOff = kOff+j
    end do
  end if
end if

end subroutine dGeMM_Tri

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine bikset_cvb(aikcof,bikcof,
     > nel,nalf,i2s,ndet,ifns,kbasis,share,iprint)
      implicit real*8 (a-h,o-z)
      logical share
      dimension aikcof(ndet,ifns),bikcof(ndet,ifns)
#include "malloc_cvb.fh"

      if(i2s.ne.2*nalf-nel)then
        nalf_use=(i2s+nel)/2
        ndet_use=ndet_cvb(nel,nalf_use)
        i1 = mstackr_cvb(ndet_use*ifns)
        i2 = mstackr_cvb(ndet_use*ifns)
        call biksmain_cvb(w(i1),w(i2),
     >   nel,nalf_use,ndet_use,ifns,kbasis,.false.,iprint)
        call sminus_cvb(w(i1),bikcof,
     >    nel,nalf_use,nalf,ifns)
        if(.not.share)call sminus_cvb(w(i2),aikcof,
     >    nel,nalf_use,nalf,ifns)
        call mfreer_cvb(i1)
      else
        call biksmain_cvb(aikcof,bikcof,
     >   nel,nalf,ndet,ifns,kbasis,share,iprint)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine rdbis_cvb(ivec,n,ioffset)
! Buffered integer IO with integer offset

use casvb_global, only: ibuf, ibuffer, lbuf
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
integer(kind=iwp), intent(out) :: ivec(n)
integer(kind=iwp), intent(inout) :: ioffset
integer(kind=iwp) :: i_max, i_min, ibuf_max, ibuf_min, ivec_max, ivec_offs, jbuf
logical(kind=iwp), parameter :: debug = .false.

if (n <= 0) return

ibuf_min = ioffset/lbuf+1
ibuf_max = (ioffset+n-1)/lbuf+1
ivec_offs = 1
do jbuf=ibuf_min,ibuf_max
  i_min = max(1,ioffset+1-(jbuf-1)*lbuf)
  i_max = min(lbuf,ioffset+n-(jbuf-1)*lbuf)

  if (ibuf /= jbuf) then
    ! Following line only needed if reads and writes can be mixed
    call bufio_wrbuf_cvb()
    call bufio_chbuf_cvb(jbuf)
    call bufio_rdbuf_cvb()
  end if
  ivec_max = ivec_offs+i_max-i_min
  ivec(ivec_offs:ivec_max) = ibuffer(i_min:i_max)
  ivec_offs = ivec_max+1
end do

if (debug) then
  write(u6,*) ' rdbis :',n,ioffset
  write(u6,'(40i4)') ivec
end if
ioffset = ioffset+n

return

end subroutine rdbis_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine mkp1inv(rdia)
      use negpre
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
#include "stdalloc.fh"
#include "incdia.fh"
      Real*8 rdia(*)
      Real*8, Allocatable:: TMP1(:), TMP2(:)

      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

      Call mma_allocate(TMP1,nconf,Label='TMP1')
      Call mma_allocate(TMP2,nconf,Label='TMP2')

      idisk=0
      Do i=1,lroots
       jdisk=idisk
       Call dDaFile(LuCIV,2,Tmp1,nconf,iDisk)
       Call ExpHinvv(rdia,Tmp1,Tmp1,0.0d0,1.0d0)
       Do j=i,lroots
         Call dDafile(luciv,2,Tmp2,nconf,jDisk)
         p1INV(itri(i,j))=DDOT_(nconf,Tmp2,1,Tmp1,1)
       End Do
      End Do

      Call mma_deallocate(TMP1)
      Call mma_deallocate(TMP2)

      Return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!SUBROUTINE fmm_call_car_to_sph(CarMoms,SphMoms,ndim,LMAX)
!
!   USE fmm_global_paras
!   USE fmm_car_to_sph, ONLY: fmm_init_car_to_sph,      &
!                             fmm_free_car_to_sph,      &
!                             fmm_transform_car_to_sph
!
!   IMPLICIT NONE
!   INTEGER(INTK), INTENT(IN)  :: ndim, LMAX
!   REAL(REALK),   INTENT(IN)  :: CarMoms(ndim, (LMAX+1)*(LMAX+2)/2 , 0:LMAX)
!   REAL(REALK),   INTENT(OUT) :: SphMoms(ndim, 2*LMAX+1 , 0:LMAX)
!
!   CALL fmm_init_car_to_sph(LMAX)
!   CALL fmm_transform_car_to_sph(CarMoms,SphMoms,ndim,LMAX)
!   CALL fmm_free_car_to_sph
!
!END SUBROUTINE fmm_call_car_to_sph
!
!------------------------------------------------------------------------------

SUBROUTINE fmm_call_get_J_matrix(ndim,nBas,dens,Fock)

   USE fmm_global_paras
   USE fmm_interface, ONLY: fmm_get_J_matrix

   IMPLICIT NONE
   INTEGER(INTK), INTENT(IN)    :: ndim, nBas
   REAL(REALK),   INTENT(IN)    :: dens(ndim)
   REAL(REALK),   INTENT(INOUT) :: Fock(ndim)

!   print *, "Calling FMM code..."
!   CALL fmm_get_J_matrix(1,dens(1),Fock(1))
!   CALL fmm_get_J_matrix(nbas,dens,Fock)
!   print *, "Returning from FMM code..."

! Avoid unused argument warnings
   IF (.FALSE.) THEN
      CALL Unused_integer(nBas)
      CALL Unused_real_array(dens)
      CALL Unused_real_array(Fock)
   END IF
END SUBROUTINE fmm_call_get_J_matrix

!------------------------------------------------------------------------------

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Martin Schuetz                                   *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine TraFck(Fock,nFock,CMO,nCMO,canorb,
     &                  FOVMax,EOrb,nEOrb,Ovrlp,nD)
************************************************************************
*                                                                      *
*     purpose: Transform Fock Matrix to get Orbital energies           *
*                                                                      *
*     input:                                                           *
*       Fock    : Fock matrix of length nFock                          *
*       CMO     : orthonormal vectors from previous iteration of       *
*                 length nCMO                                          *
*       canorb  : Boolean: TRUE, if canonical orbs are desired,        *
*                          FALSE otherwise                             *
*                                                                      *
*     output:                                                          *
*       FOVMax  : Max Element of occ/virt block in Fock Matrix,        *
*                 transformed into MO basis                            *
*       CMO     : canonical orthonormal vectors in last iteration      *
*                 (only if canorb was set to TRUE)                     *
*       EOrb    : orbital energies of length nEOrb                     *
*                 (only if canorb was set to TRUE)                     *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*     calls to: ModFck, PickUp, SortEig                                *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.Schuetz                                                        *
*     University of Lund, Sweden, 1994                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      use SpinAV, only: Do_SpinAV
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Integer nFock,nCMO,nEOrb
      Real*8 Fock(nFock,nD),CMO(nCMO,nD),FOVMax,EOrb(nEOrb,nD),
     &       Ovrlp(nFock)
      Logical canorb
*
      Real*8, Dimension(:), Allocatable:: FckM, FckS, HlfF, EigV,
     &                                    Ctmp, Scratch, CMOOld,
     &                                    Scrt, COvrlp
      Real*8 Fia
      Real*8 Cpu1,Tim1,Tim2,Tim3
      Integer ioFckM,iCMO,jEOr,iptr,iptr2,nOrbmF,nOccmF,
     &        nVrt,ii,ia
*
      Call Timing(Cpu1,Tim1,Tim2,Tim3)
#ifdef _SPECIAL_DEBUGPRINT_
      Call DebugCMOx(CMO,nCMO,nD,nBas,nOrb,nSym,'TraFck: CMO old')
#endif
#ifdef _DEBUGPRINT_
      Call NrmClc(Fock,nFock*nD,'TraFck','Fock')
#endif
*---- allocate memory for modified Fock matrix
      Call mma_allocate(FckM,nBT,Label='FckM')
*---- allocate memory for squared Fock matrix
      Call mma_allocate(FckS,MaxBas**2,Label='FckS')
*
      FOVMax=Zero
*
      Do iD = 1, nD
*
*---- modify Fock matrix
      call dcopy_(nBT,Fock(1,iD),1,FckM,1)
      If (nnFr.gt.0) then
        Call ModFck(FckM,Ovrlp,nBT,CMO(1,iD),nBO,
     &              nOcc(1,iD))
      endif
*
      ioFckM=1
      iCMO=1
      jEOr=1

      Do iSym = 1,nSym
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
         Write (6,*) 'iD=',iD
         Call RecPrt('TraFck: Old CMO',' ',CMO(iCMO,iD),
     &               nBas(iSym),nOrb(iSym))
         jCMO=iCMO
#endif
        nOrbmF=nOrb(iSym)-nFro(iSym)
        nOccmF=nOcc(iSym,iD)-nFro(iSym)
        nVrt=nOrb(iSym)-nOcc(iSym,iD)
*------ find the proper pointer to CMO
        iCMO=iCMO+nBas(iSym)*nFro(iSym)
        If (nOrbmF.gt.0) Then
*         allocate memory for half-transformed Fock matrix
          Call mma_allocate(HlfF,nBas(iSym)*nOrbmF,Label='HlfF')
*-------- transform Fock matrix into new MO space
          Call Square(FckM(ioFckM),FckS,1,
     &                nBas(iSym),nBas(iSym))
          Call DGEMM_('N','N',
     &                nBas(iSym),nOrbmF,nBas(iSym),
     &                1.0d0,FckS,nBas(iSym),
     &                CMO(iCMO,iD),nBas(iSym),
     &                0.0d0,HlfF,nBas(iSym))
          Call DGEMM_Tri('T','N',nOrbmF,nOrbmF,nBas(iSym),
     &                  One,CMO(iCMO,iD),nBas(iSym),
     &                      HlfF,nBas(iSym),
     &                  Zero,FckS,nOrbmF)
*debug
c         Write(6,*) 'transformed Fck in trafck:'
c         Call TriPrt(' ',' ',FckS,nOrbmF)
*debug
*         dispose memory of half-transformed Fock matrix
          Call mma_deallocate(HlfF)
          If ((nOccmF.gt.0).AND.(nVrt.gt.0)) Then
             iptr=1+nOccmF*(nOccmF+1)/2
*
*            get max Fock Matrix Element in OV block...
*
             Do ia=1,nVrt
                Fia=abs(FckS(iptr+IDAMAX_(nOccmF,FckS(iptr),1)-1))
                FOVMax=Max(Fia,FOVMax)
                iptr=iptr+nOccmF+ia
             End Do
          End If
*
*-------- eventually diagonalize occ/occ & virt/virt Block separately
*-------- to form canonical orbitals
*
          If (canorb) Then
*           allocate space for Eigenvectors of occ/occ & virt/virt block
            Call mma_allocate(EigV,Max(nOccmF,nVrt)**2,Label='EigV')
*           allocate space for temporary CMO (for MatMul)
            Call mma_allocate(CTmp,Max(nOccmF,nVrt)*nBas(iSym),
     &                        Label='CTmpX')
            If (.NOT.FckAuf) Then
                Call mma_allocate(CMOOld,nOccmF*nBas(iSym),
     &                            Label='CMOOld')
                Call DCopy_(nOccmF*nBas(iSym),CMO(iCMO,iD),1,CMOOld,1)
                Call mma_allocate(Scrt,nBas(iSym)**2,Label='Scrt')
                Call mma_allocate(COvrlp,nBas(iSym)*nOccmF,
     &                            Label='COvrlp')
            End If
*
            If (nOccmF.gt.0) Then
*
*------------ diagonalize occ/occ first
*             find the proper pointer to EOr
*
              jEOr=jEOr+nFro(iSym)
              Call mma_allocate(Scratch,nOccmF**2,Label='Scratch')
              Dummy=0.0D0
              iDum=0
              nOccmF=nOccmF-nConstr(iSym)
*
              Call Diag_Driver('V','A','L',nOccmF,FckS,
     &                         Scratch,nOccmF,Dummy,Dummy,iDum,
     &                         iDum,EOrb(jEOr,iD),EigV,nOccmF,
     &                         1,0,'J',nFound,iErr)
*
              If (nConstr(iSym).gt.0) Then
                 Call FZero(Scratch,(nOccmF+nConstr(iSym))**2)
                 Do j=1,nOccmF
                    iiEigV=1+nOccmF*(j-1)
                    iiScratch=1+(nOccmF+nConstr(iSym))*(j-1)
                    call dcopy_(nOccmF,EigV(iiEigV),1,
     &                                 Scratch(iiScratch),1)
                 End Do
                 Do j=nOccmF+1,nOccmF+nConstr(iSym)
                    iiScratch=1+(nOccmF+nConstr(iSym))*(j-1)+j-1
                    Scratch(iiScratch)=1.0d0
                 End Do
                 call dcopy_((nOccmF+nConstr(iSym))**2,Scratch,1,
     &                                                EigV,1)
              EndIf
              nOccmF=nOccmF+nConstr(iSym)
              Call mma_deallocate(Scratch)
              n2zero=nOccmF
              If (Do_SpinAV) n2zero=n2zero+nConstr(iSym)
              Call dCopy_(n2zero*(n2zero+1)/2,[Zero],0,FckS,1)
*
              iDiag = 0
              Do i = 1, n2zero
                iDiag = iDiag + i
                FckS(iDiag) = EOrb(jEOr+i-1,iD)
              End Do
*
*------------ rotate MOs to diagonalize occ/occ block
*             Call RecPrt('Old CMO',' ',CMO(iCMO,iD),nBas(iSym),nOccmF)
              Do ii=0,nOccmF-1
                call dcopy_(nBas(iSym),CMO(iCMO+nBas(iSym)*ii,iD),1,
     &                                 CTmp(1+nBas(iSym)*ii),1)
              End Do
              Call DGEMM_('N','N',
     &                    nBas(iSym),nOccmF,nOccmF,
     &                    1.0d0,Ctmp,nBas(iSym),
     &                          EigV,nOccmF,
     &                    0.0d0,CMO(iCMO,iD),nBas(iSym))
*             Call RecPrt('New CMO',' ',CMO(iCMO,iD),nBas(iSym),nOccmF)
*
*             Fix standard phase pf the orbitals
*
              Do i = 1, nOccmF
                 call VecPhase(CMO(iCMO+(i-1)*nBas(iSym),iD),nBas(iSym))
              End Do
*
*             Order the occupied orbitals by maximum overlap with
*             the old MOs.
*
              If (.NOT.FckAuf) Then
*
                 Call FZero(COvrlp,nOccmF*nBas(iSym))
                 Call Square(Ovrlp(ioFckM),Scrt,1,nBas(iSym),
     &                       nBas(iSym))
                 Call DGEMM_('T','N',
     &                       nOccmF,nBas(iSym),nBas(iSym),
     &                       1.0D0,CMO(iCMO,iD),nBas(iSym),
     &                             Scrt,nBas(iSym),
     &                       0.0D0,COvrlp,nOccmF)
*
                 Do iOcc = 1, nOccmF-1  !  Loop over the new MOs
*
                    iOff = (iOcc-1)*nBas(iSym) + iCMO
                    kOcc=0
                    Tmp0=0.0D0
                    Do jOcc = 1, nOccmF !  Loop over the new MOs
                       Tmp1=Abs(DDot_(nBas(iSym),COvrlp(jOcc),nOccmF,
     &                                           CMO(iOff,iD),1))
                       If (Tmp1.gt.Tmp0) Then
                          Tmp0=Tmp1
                          kOcc=jOcc
                       End If
                    End Do
*
                    If (iOcc.ne.kOcc) Then
                       ii = iOcc + jEOr - 1
                       kk = kOcc + jEOr - 1
                       tmp = EOrb(ii,iD)
                       EOrb(ii,iD) = EOrb(kk,iD)
                       EOrb(kk,iD) = tmp
                       kOff = (kOcc-1)*nBas(iSym) + iCMO
                       Call DSwap_(nBas(iSym),CMO(iOff,iD),1,
     &                                        CMO(kOff,iD),1)
                    End If
                 End Do
*
                 iDiag = 0
                 Do i = 1, n2zero
                   iDiag = iDiag + i
                   FckS(iDiag) = EOrb(jEOr+i-1,iD)
                 End Do
*
              End If
*             Call RecPrt('New CMO(2)',' ',CMO(iCMO,iD),nBas(iSym),
*    &                    nOccmF)
            End If
#ifdef _SPECIAL_DEBUGPRINT_
            If (iD.eq.1.and.nD.eq.1) Then
               Call DebugCMOx(CMO(1,iD),nCMO,1,nBas,nOrb,nSym,
     &                        'TraFck: RHF CMO new')
            Else If (iD.eq.1) Then
               Call DebugCMOx(CMO(1,iD),nCMO,1,nBas,nOrb,nSym,
     &                        'TraFck: UHF alpha CMO new')
            Else
               Call DebugCMOx(CMO(1,iD),nCMO,1,nBas,nOrb,nSym,
     &                        'TraFck: UHF Beta CMO new')
            End If
#endif
*
            If (nVrt.gt.0) Then
*
*------------ now diagonalize virt/virt block
*             setup virt/virt block in triangular Fock Matrix
*
              iptr=1+nOccmF*(nOccmF+3)/2
              iptr2=1
              Do ia=1,nVrt
                call dcopy_(ia,FckS(iptr),1,FckS(iptr2),1)
                iptr=iptr+nOccmF+ia
                iptr2=iptr2+ia
              End Do
              Call mma_allocate(Scratch,nVrt**2,Label='Scratch')
              If (Do_SpinAV) Then
                 nVrt=nVrt-nConstr(iSym)
                 jEOr = jEOr + nConstr(iSym)
                 iptr=1+nOccmF*(nOccmF+3)/2
                 Do ia=1,nConstr(iSym)
                    iptr=iptr+nOccmF+ia
                    FckS(iptr)=-0.666d3*dble(1000-ia)
                 End Do
              EndIf
                Dummy=0.0D0
                iDum=0
              Call Diag_Driver('V','A','L',nVrt,FckS,
     &                         Scratch,nVrt,Dummy,Dummy,iDum,
     &                         iDum,EOrb(jEOr+nOccmF,iD),EigV,
     &                         nVrt,1,0,'J',nFound,iErr)
              If (Do_SpinAV) Then
                 nVrt=nVrt+nConstr(iSym)
                 jEOr = jEOr - nConstr(iSym)
                 Call FZero(Scratch,nVrt**2)
                 Do j=1,nVrt-nConstr(iSym)
                    iiEigV=1+(nVrt-nConstr(iSym))*(j-1)
                    iiScratch=1+nVrt*(nConstr(iSym)+j-1)
                    call dcopy_(nVrt-nConstr(iSym),EigV(iiEigV),1,
     &                                         Scratch(iiScratch),1)
                 End Do
                 Do j=1,nConstr(iSym)
                    iiScratch=1+nVrt*(j-1)+j-1
                    Scratch(iiScratch)=1.0d0
                 End Do
                 call dcopy_(nVrt**2,Scratch,1,EigV,1)
              EndIf
              Call mma_deallocate(Scratch)
*------------ rotate MOs to diagonalize virt/virt block
              iptr=iCMO+nOccmF*nBas(iSym)
              Do ia=0,nVrt-1
                call dcopy_(nBas(iSym),CMO(iptr+nBas(iSym)*ia,iD),1,
     &                     CTmp(1+nBas(iSym)*ia),1)
              End Do
              Call DGEMM_('N','N',
     &                    nBas(iSym),nVrt,nVrt,
     &                    1.0d0,Ctmp,nBas(iSym),
     &                    EigV,nVrt,
     &                    0.0d0,CMO(iptr,iD),nBas(iSym))
            End If
#ifdef _SPECIAL_DEBUGPRINT_
            If (iD.eq.1.and.nD.eq.1) Then
               Call DebugCMOx(CMO(1,iD),nCMO,1,nBas,nOrb,nSym,
     &                        'TraFck: RHF CMO new')
            Else If (iD.eq.1) Then
               Call DebugCMOx(CMO(1,iD),nCMO,1,nBas,nOrb,nSym,
     &                        'TraFck: UHF alpha CMO new')
            Else
               Call DebugCMOx(CMO(1,iD),nCMO,1,nBas,nOrb,nSym,
     &                        'TraFck: UHF Beta CMO new')
            End If
#endif
*
            If (nConstr(iSym).gt.0) Then
*----------    Sort non-wavelet eigenvalues/eigenvectors
               n2sort=nOccmF-nConstr(iSym)
               If (FckAuf)
     &         Call SortEig(EOrb(jEOr,iD),CMO(iCMO,iD),n2sort,
     &                      nBas(iSym))
               jjEOr=jEOr+nOccmF+nConstr(iSym)
               iiCMO=iCMO+nBas(iSym)*(nOccmF+nConstr(iSym))
               n2sort=nVrt-nConstr(iSym)
               If (FckAuf)
     &         Call SortEig(EOrb(jjEOr,iD),CMO(iiCMO,iD),n2sort,
     &                      nBas(iSym))
            Else
*----------    Sort all eigenvalues and eigenvectors
               If (FckAuf)
     &         Call SortEig(EOrb(jEOr,iD),CMO(iCMO,iD),nOrbmF,
     &                      nBas(iSym))
            EndIf
#ifdef _SPECIAL_DEBUGPRINT_
            If (iD.eq.1.and.nD.eq.1) Then
               Call DebugCMOx(CMO(1,iD),nCMO,1,nBas,nOrb,nSym,
     &                        'TraFck: RHF CMO new')
            Else If (iD.eq.1) Then
               Call DebugCMOx(CMO(1,iD),nCMO,1,nBas,nOrb,nSym,
     &                        'TraFck: UHF alpha CMO new')
            Else
               Call DebugCMOx(CMO(1,iD),nCMO,1,nBas,nOrb,nSym,
     &                        'TraFck: UHF Beta CMO new')
            End If
#endif
*
*           dispose memory
            If (.NOT.FckAuf) Then
               Call mma_deallocate(COvrlp)
               Call mma_deallocate(Scrt)
               Call mma_deallocate(CMOOld)
            End If
            Call mma_deallocate(CTmp)
            Call mma_deallocate(EigV)
          End If
        End If
*------ Update pointers
        iCMO=iCMO+nOrbmF*nBas(iSym)
        ioFckM=ioFckM+nBas(iSym)*(nBas(iSym)+1)/2
        jEOr=jEOr+nOrbmF
#ifdef _DEBUGPRINT_
         Call RecPrt('TraFck: New CMO',' ',CMO(jCMO,iD),
     &               nBas(iSym),nOrb(iSym))
#endif
      End Do
      If (canorb) Then
*------ Check orthogonality
        Call ChkOrt(CMO(1,iD),nBO,Ovrlp,nBT,Whatever)
      End If
*
      End Do
*
*---- Deallocate memory
      Call mma_deallocate(FckS)
      Call mma_deallocate(FckM)
*
#ifdef _SPECIAL_DEBUGPRINT_
      Call DebugCMOx(CMO,nCMO,nD,nBas,nOrb,nSym,'TraFck: CMO new')
#endif
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld(13) = TimFld(13) + (Cpu2 - Cpu1)
      Return
      End
#ifdef _SPECIAL_DEBUGPRINT_
      Subroutine DebugCMOx(CMO,nCMO,nD,nBas,nOrb,nSym,Label)
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
      Real*8 CMO(nCMO,nD)
      Integer nBas(nSym),nOrb(nSym)
      Character*(*) Label
      Integer, Dimension(:), Allocatable:: iFerm
*
      nnB=0
      Do iSym=1,nSym
         nnB=nnB+nOrb(iSym)
      End Do
      Call mma_allocate(iFerm,nnB,Label='iFerm')
      Call Get_iArray('Fermion IDs',iFerm,nnB)
*
      Write (6,*) Label
*
      Do iD = 1, nD
         Write (6,*)
         If (iD.eq.1) Then
            If (nD.eq.1) Then
               Write (6,*) ' RHF CMOs'
            Else
               Write (6,*) ' UHF alpha CMOs'
            End If
         Else
            Write (6,*) ' UHF beta CMOs'
         End If
         Write (6,*)
         jOff=0
         iOff=1
         Do iSym = 1, nSym
            Do iOrb = 1, nOrb(iSym)
               tmp=0.0D0
               Do k = 1, nBas(iSym)
                  tmp = tmp + DBLE(iFerm(jOff+k))
     &                      * ABS(CMO(iOff-1+(iOrb-1)*nBas(iSym)+k,iD))
               End Do
               Write (6,*)
               If (tmp.ne.0.0D0) Then
                  Write (6,*) 'Muonic Orbital:',iOrb
               Else
                  Write (6,*) 'Electronic  Orbital:',iOrb
               End If
               Call RecPrt('CMO',' ',CMO(iOff+(iOrb-1)*nBas(iSym),iD),
     &                      1,nBas(iSym))
            End Do
            jOff = jOff + nOrb(iSym)
            iOff = iOff + nBas(iSym)*nOrb(iSym)
         End Do
      End Do
      Call mma_deallocate(iFerm)
*
      Return
      End
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function get_ln_quit(lunit,icritical)
!***********************************************************************
! This function replaces function getln                                *
!                                                                      *
! It reads, broadcasts, and parses an input line                       *
!                                                                      *
! Blank lines or lines containing star (*) in column 1 are skipped     *
! Lines staring with exclaimation (!) in column 1 are skipped          *
!                                                                      *
! After this routine has been called, data can be retrieved using      *
! the subroutines                                                      *
!                                                                      *
!   Get_F(icol,array,n)  (for floating point values)                   *
!   Get_I(icol,iarry,n)  (for integer values)                          *
!   Get_S(icol,strgs,n)  (for character strings)                       *
!                                                                      *
! where icol is the first non-blank work to be taken, and n is the     *
! number of data.                                                      *
!                                                                      *
!***********************************************************************

use getline_mod, only: iEnd, iGetLine, iStrt, Line, MyUnit, nCol, Quit_On_Error
use Definitions, only: iwp, u6

implicit none
character(len=180) :: get_ln_quit
integer(kind=iwp), intent(in) :: lUnit, iCritical
integer(kind=iwp) :: i, icom, istatus, j, l
character(len=256) :: filename

Quit_On_Error = .false.
myunit = lunit
do
  read(lunit,'(A)',iostat=istatus) line
  if (istatus /= 0) exit
  igetline = igetline+1
  if ((line /= ' ') .and. (line(1:1) /= '*') .and. (line(1:1) /= '!')) exit
end do
if (istatus >= 0) then
  if (istatus == 0) then
    l = len(line)
    do i=1,l
      if (ichar(line(i:i)) == 9) line(i:i) = ' '
      if (line(i:i) == ';') line(i:l) = ' '
    end do
    ncol = 0
    j = 1
    do
      icom = 0
      do i=j,l
        if (line(i:i) == ',') then
          icom = icom+1
          if (icom /= 1) exit
        else
          if (line(i:i) /= ' ') exit
        end if
      end do
      if (i > l) then
        get_ln_quit = line
        return
      end if
      do j=i,l
        if ((line(j:j) == ' ') .or. (line(j:j) == ',')) exit
      end do
      ncol = ncol+1
      istrt(ncol) = i
      iend(ncol) = j-1
    end do
  end if

  filename = ' '
  inquire(unit=lunit,name=filename)
  if (filename /= ' ') then
    write(u6,'(a,a)') 'Error reading file=',filename
  else
    write(u6,'(a,i8)') 'Error reading unit=',lunit
  end if
  write(u6,'(a)') 'Line: ',line(1:80)
  Quit_On_Error = .true.
end if
if (icritical == 0) then
  Quit_On_Error = .true.
  return
end if

filename = ' '
inquire(unit=lunit,name=filename)
if (filename /= ' ') then
  write(u6,'(a,a)') 'EOF reached for file=',filename
else
  write(u6,'(a,i8)') 'EOF reached for unit=',lunit
end if

Quit_On_Error = .true.

end function get_ln_quit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RPA_SetInc()
      Implicit None
#include "rpa_config.fh"
#include "rpa_data.fh"
      Integer i, j
      ! rpa_config
      Reference='Non'
      RPAModel='None@Non'
      DFTFunctional='Not defined     '
      dRPA=.false.
      SOSEX=.false.
      doCD=.false.
      doDF=.false.
      doLDF=.false.
      LumOrb=.false.
      iPrint=0
      ! rpa_data
      Do i=1,mTitle
         Write(Title(i),'(80A1)') (' ',j=1,80)
      End Do
      nTitle=0
      nSym=0
      Call iZero(nFreeze,2)
      Call iZero(nBas,8)
      Call iZero(nOrb,8)
      Call iZero(nFro,16)
      Call iZero(nDel,16)
      Call iZero(nOcc,16)
      Call iZero(nVir,16)
      Call iZero(ip_CMO,2)
      Call iZero(l_CMO,2)
      Call iZero(ip_EMO,2)
      Call iZero(l_EMO,2)
      Call iZero(ip_OccEn,2)
      Call iZero(l_OccEn,2)
      Call iZero(ip_VirEn,2)
      Call iZero(l_VirEn,2)
      NuclearRepulsionEnergy(1)=0.0d0
      End
************************************************************************
      Subroutine RPA_SetIntegralRepresentation()
      Implicit None
#include "rpa_config.fh"
      Call DecideOnCholesky(doCD)
      Call DecideOnDF(doDF)
      Call DecideOnLocalDF(doLDF)
      If (doLDF) Then
         doCD=.false.
         doDF=.false.
      Else If (doDF) Then
         doCD=.false.
         doLDF=.false.
      Else If (doCD) Then
         doDF=.false.
         doLDF=.false.
      End If
      End
************************************************************************
      Subroutine RPA_CheckIntegralRepresentation()
      Implicit None
#include "rpa_config.fh"
      If (.not.(doCD.or.doDF.or.doLDF)) Then
         Call RPA_Warn(2,'RPA requires CD, DF, or LDF. '//
     *                        'Conventional integrals not implemented.')
      End If
      End
************************************************************************
      Integer Function RPA_iUHF()
      Implicit None
#include "rpa_config.fh"
      Integer iUHF
      If (Reference(1:1).eq.'R') Then
         iUHF=1
      Else If (Reference(1:1).eq.'U') Then
         iUHF=2
      Else
         Write(6,'(A,A)') 'Reference=',Reference
         Call RPA_Warn(3,'Unable to determine iUHF in RPA')
         iUHF=-1
      End If
      RPA_iUHF=iUHF
      End
************************************************************************
      Integer Function RPA_LENIN8()
      Implicit None
#include "Molcas.fh"
      RPA_LENIN8=LENIN8
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine map22 (a,b,dimp,dimq,dim1,dim2,p,q,nfact)
c
       integer dimp,dimq,dim1,dim2,p,q,nfact
       real*8 a(1:dimp,1:dimq)
       real*8 b(1:dim1,1:dim2)
c       integer index(1:2)
c
       integer pp,qq
c
       if (nfact.eq.1) then
c
c     nfact = + 1
c
c     do 100 qq=1,dimq
c     index(q)=qq
c     do 100 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2))=a(pp,qq)
c100  continue
c
       if (p.eq.1) then
c     1* (2)
       do 110 qq=1,dimq
       do 111 pp=1,dimp
       b(pp,qq)=a(pp,qq)
 111    continue
 110    continue
       else
c     2* (1)
       do 120 qq=1,dimq
       do 121 pp=1,dimp
       b(qq,pp)=a(pp,qq)
 121    continue
 120    continue
       end if
c
c
       else
c
c     nfact = -1
c
c     do 200 qq=1,dimq
c     index(q)=qq
c     do 200 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2))=-a(pp,qq)
c200  continue
c
       if (p.eq.1) then
c     1* (2)
       do 210 qq=1,dimq
       do 211 pp=1,dimp
       b(pp,qq)=-a(pp,qq)
 211    continue
 210    continue
       else
c     2* (1)
       do 220 qq=1,dimq
       do 221 pp=1,dimp
       b(qq,pp)=-a(pp,qq)
 221    continue
 220    continue
       end if
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(q)
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine STRINF()
! Strings for internal space.
! Information is stored in
! Largest allowed length is MSTINF
!
! Input
! /LUCINP/,/ORBINP/,/CSM/
! Output
! /STRINP/,/STINF/,/STRBAS/ and string information in STIN

use Str_Info, only: ISTAC, IUNIQMP, IUNIQTP, MNRS1, MNRS3, MXRS1, MXRS3, NELEC, NOCTYP, NSTFTP, NSTTYP, STR
use MCLR_Data, only: NACOB, NORB1, NORB2, NORB3
use input_mclr, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxINT
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IMAX, ISGSTI(1), ISGSTO(1), ITYP, JTYP, LROW
integer(kind=iwp), allocatable :: KFREEL(:)

! 2 : Number of classes per string type and mappings between string types (/STINF/)

call ZSTINF_MCLR()

! 3 : Static memory for string information

call MEMSTR()

! 4 :Reverse lexical adresing schemes for each type of string

! First free address
call mma_MaxINT(imax)
call mma_allocate(KFREEL,imax,Label='KFREEL')
do ITYP=1,NSTTYP
  if (IUNIQTP(ITYP) == ITYP) &
    call WEIGHT_mclr(Str(ITYP)%Z,NELEC(ITYP),NORB1,NORB2,NORB3,MNRS1(ITYP),MXRS1(ITYP),MNRS3(ITYP),MXRS3(ITYP),KFREEL)
end do

! 5 : Number of electrons in RAS1 and RAS3 per string sub type

do ITYP=1,NSTTYP
  if (IUNIQTP(ITYP) == ITYP) &
    call IEL13(MNRS1(ITYP),MXRS1(ITYP),MNRS3(ITYP),MXRS3(ITYP),NELEC(ITYP),NOCTYP(ITYP),Str(ITYP)%EL1,Str(ITYP)%EL3,Str(ITYP)%EL123)
end do

! 6 : Number of strings per type and symmetry for a given string type

do ITYP=1,NSTTYP
  if (IUNIQTP(ITYP) == ITYP) then
    call NSTRSO_MCLR(NELEC(ITYP),NORB1,NORB2,NORB3,MNRS1(ITYP),MXRS1(ITYP),MNRS3(ITYP),MXRS3(ITYP),KFREEL,Str(ITYP)%NSTSO, &
                     NOCTYP(ITYP),nIrrep,ITYP)
    ! Corresponding offset array
    call ZBASE(Str(ITYP)%NSTSO,Str(ITYP)%ISTSO,nIrrep*NOCTYP(ITYP))
    ! Symmetry and class index for each string
    call ZSMCL(nIrrep,NOCTYP(ITYP),Str(ITYP)%NSTSO,Str(ITYP)%STSM,Str(ITYP)%STCL)
  end if
end do

! 7 Construct strings, ordered according to symmetry and class

do ITYP=1,NSTTYP
  if (IUNIQTP(ITYP) == ITYP) &
    call GENSTR_MCLR(NELEC(ITYP),MNRS1(ITYP),MXRS1(ITYP),MNRS3(ITYP),MXRS3(ITYP),Str(ITYP)%ISTSO,NOCTYP(ITYP),nIrrep,Str(ITYP)%Z, &
                     KFREEL,Str(ITYP)%STREO,Str(ITYP)%OCSTR,KFREEL(1+NOCTYP(ITYP)*nIrrep),ITYP)
end do

! 8 Internal annihilation arrays between types of strings

do ITYP=1,NSTTYP
  if (IUNIQMP(ITYP) == ITYP) then
    if (ISTAC(ITYP,1) /= 0) then
      JTYP = ISTAC(ITYP,1)
#     ifdef _DEBUGPRINT_
      write(u6,*) ' Annihilator arrays between types ',ITYP,JTYP
      write(u6,*) ' ==========================================='
#     endif
      if (ISTAC(ITYP,2) == 0) then
        LROW = NELEC(ITYP)
      else
        LROW = NACOB
      end if
      Str(ITYP)%STSTM(1:NSTFTP(ITYP)*LROW,1) = 0
      Str(ITYP)%STSTM(1:NSTFTP(ITYP)*LROW,2) = 0
      call ANNSTR(Str(ITYP)%OCSTR,NSTFTP(ITYP),NSTFTP(JTYP),NELEC(ITYP),NACOB,Str(JTYP)%Z,Str(JTYP)%STREO,LROW,0,ISGSTI,ISGSTO, &
                  Str(ITYP)%STSTM(:,1),Str(ITYP)%STSTM(:,2),JTYP)
    end if
  end if
end do

! 6 : Creation arrays

do ITYP=1,NSTTYP
  if (IUNIQMP(ITYP) == ITYP) then
    if (ISTAC(ITYP,2) /= 0) then
      ! Type of creation map
      if (ISTAC(ITYP,1) == 0) then
        ! Only creation map, compact scheme with offsets
        LROW = -1
      else if (ISTAC(ITYP,1) /= 0) then
        ! Both annihilation and creation, use full form
        LROW = NACOB
      end if
      JTYP = ISTAC(ITYP,2)
#     ifdef _DEBUGPRINT_
      write(u6,*) ' Creator  arrays between types ',ITYP,JTYP
      write(u6,*) ' ==========================================='
#     endif
      call CRESTR(Str(ITYP)%OCSTR,NSTFTP(ITYP),NSTFTP(JTYP),NELEC(ITYP),NACOB,Str(JTYP)%Z,Str(JTYP)%STREO,0,ISGSTI,ISGSTO, &
                  Str(ITYP)%STSTM(:,1),Str(ITYP)%STSTM(:,2),Str(ITYP)%STSTMN,Str(ITYP)%STSTMI,LROW,JTYP)
    end if
  end if
end do
call mma_deallocate(KFREEL)

return

end subroutine STRINF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2002, Roland Lindh                                     *
************************************************************************
      Subroutine DFT_Grad(Grad,nGrad,dF_dRho,ndF_dRho,iSpin,
     &                    Grid,mGrid,dRho_dR,ndRho_dR,nGrad_Eff,
     &                    Rho,nRho,IndGrd,Weights,iTab,Temp,F_xc,
     &                    dW_dR,iNQ)
************************************************************************
*                                                                      *
*     Object: to trace the correct parts to get the contributions to   *
*             the gradient due to the DFT energy.                      *
*                                                                      *
*     Author: Roland Lindh, Dept. of Chemical Physics, University of   *
*             Lund, Sweden.  May 2002 in Bologna, Italy.               *
************************************************************************
      use KSDFT_Info, only: KSDFA
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "nq_info.fh"
#include "WrkSpc.fh"
#include "debug.fh"
#include "Molcas.fh"
#include "itmax.fh"
#include "ksdft.fh"
      Parameter (Mxdc=MxAtom)
#include "disp.fh"
#include "nq_index.fh"
      Real*8 Grad(nGrad), Temp(nGrad_Eff), Grid(3,mGrid),
     &       dF_dRho(ndF_dRho,mGrid),
     &       dRho_dR(ndRho_dR,mGrid,nGrad_Eff), OV(3,3), V(3,3),
     &       Rho(nRho,mGrid), R_Grid(3),
     &       Weights(mGrid), F_xc(mGrid), dW_dR(nGrad_Eff,mGrid)
      Integer IndGrd(nGrad_Eff), iTab(4,nGrad_Eff)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
#include "nq_structure.fh"
      declare_ip_coor
      declare_ip_dodx
*                                                                      *
************************************************************************
*                                                                      *
      LuWr=6
      R_Grid(1)=Work(ip_Coor(iNQ)  )
      R_Grid(2)=Work(ip_Coor(iNQ)+1)
      R_Grid(3)=Work(ip_Coor(iNQ)+2)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Debug=.True.
      If (Debug) Then
         Call RecPrt('R_Grid',' ',R_Grid,1,3)
         Call RecPrt('Grid',' ',Grid,3,mGrid)
         Call RecPrt('Weights',' ',Weights,1,mGrid)
         Call RecPrt('dW_dR',' ',dW_dR,nGrad_Eff,mGrid)
         Call RecPrt('dRho_dR(1)',' ',dRho_dR,ndRho_dR,mGrid)
         Call RecPrt('dF_dRho',' ',dF_dRho,ndF_dRho,mGrid)
         Do iEff = 1, nGrad_Eff
            Write (6,*) 'iTab=',iTab(1,iEff),iTab(2,iEff),iTab(3,iEff),
     &                          iTab(3,iEff)
            Write (6,*) 'IndGrd=',IndGrd(iEff)
         End Do
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Call FZero(Temp,nGrad_Eff)
      Call FZero(OV,9)
*                                                                      *
************************************************************************
*                                                                      *
*     We have that the DFT energy is expressed as
*
*     E_DFT = Sum_Gg  w(r_g(G))  f(G,r_g(G))
*
*     r_g = R_G + O s_g
*
*     The first derivative is computed as
*
*     E_DFT^x = Sum w^x f  + w f^x
*
*     where
*
*     f^x = f^(x) + <nabla_r  f * r^x >
*
*     where
*
*     nabla_r f is the functional differentiated with respect to a
*     displacement of a grid point.
*
*     and
*
*     r^x = delta_AG e_i + O^x s
*                                                                      *
************************************************************************
*                                                                      *
*     Add the contributions
*
*     w * f^x to centers other than the origin of the current
*             set of grid points.
*
*     Note that for x being one of the cartesian components of the
*     center of the atomic grid we do not have f^x but rather f^(x).
*     The correct contribution will be added below.
*
*     Here we also accumulate contributions for the rotational
*     invariance.
*
*
*                                                                      *
************************************************************************
*                                                                      *
      If (Functional_type.eq.LDA_type) Then
*
         If (iSpin.eq.1) Then
            Do i_Eff=1, nGrad_Eff
               tmp=Zero
               ixyz=iTab(1,i_Eff)
               Do j = 1, mGrid
                  dF_dr = dF_dRho(ipR,j)    *dRho_dR(1,j,i_Eff)
*
                  tmp = tmp + Weights(j) * dF_dr
*
*                 For rotational invariance accumulate
*
*                 (nabla_r f_g)^T O s_g
*
                  OV(ixyz,1) = OV(ixyz,1) + Two* Weights(j) *
     &                        dF_dr * (Grid(1,j)-R_Grid(1))
                  OV(ixyz,2) = OV(ixyz,2) + Two* Weights(j) *
     &                        dF_dr * (Grid(2,j)-R_Grid(2))
                  OV(ixyz,3) = OV(ixyz,3) + Two* Weights(j) *
     &                        dF_dr * (Grid(3,j)-R_Grid(3))
               End Do
               If (iTab(2,i_Eff).ne.Off)
     &            Temp(i_Eff)=Temp(i_Eff)-Two*tmp
            End Do
         Else
            Do i_Eff=1, nGrad_Eff
               tmp=Zero
               ixyz=iTab(1,i_Eff)
               Do j = 1, mGrid
                  dF_dr = dF_dRho(ipRa,j)    *dRho_dR(1,j,i_Eff)
     &                  +dF_dRho(ipRb,j)    *dRho_dR(2,j,i_Eff)
                  tmp = tmp + Weights(j) * dF_dr
*
*                 Accumulate stuff for rotational invariance
*
                  OV(ixyz,1) = OV(ixyz,1) +      Weights(j) *
     &                        dF_dr * (Grid(1,j)-R_Grid(1))
                  OV(ixyz,2) = OV(ixyz,2) +      Weights(j) *
     &                        dF_dr * (Grid(2,j)-R_Grid(2))
                  OV(ixyz,3) = OV(ixyz,3) +      Weights(j) *
     &                        dF_dr * (Grid(3,j)-R_Grid(3))
               End Do
               If (iTab(2,i_Eff).ne.Off)
     &            Temp(i_Eff)=Temp(i_Eff)-tmp
            End Do

*****************************************************************************************************************
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Functional_type.eq.GGA_type) Then
*
         If (iSpin.eq.1) Then
            Do i_Eff=1, nGrad_Eff
               tmp=Zero
               ixyz=iTab(1,i_Eff)
               Do j = 1, mGrid
                  gx=rho(2,j)
                  gy=rho(3,j)
                  gz=rho(4,j)
                  Temp0=dF_dRho(ipR,j)
                  Temp1=(2.0d0*dF_dRho(ipGxx,j)+dF_dRho(ipGxy,j))*gx
                  Temp2=(2.0d0*dF_dRho(ipGxx,j)+dF_dRho(ipGxy,j))*gy
                  Temp3=(2.0d0*dF_dRho(ipGxx,j)+dF_dRho(ipGxy,j))*gz
*
                  dF_dr = Temp0*dRho_dR(1,j,i_Eff)
     &                  + Temp1*dRho_dR(2,j,i_Eff)
     &                  + Temp2*dRho_dR(3,j,i_Eff)
     &                  + Temp3*dRho_dR(4,j,i_Eff)
                  tmp = tmp  + Weights(j) * dF_dr
*
*                 Accumulate stuff for rotational invariance

*****************************************************************************************************************
*
                  OV(ixyz,1) = OV(ixyz,1) + Two* Weights(j) *
     &                        dF_dr * (Grid(1,j)-R_Grid(1))
                  OV(ixyz,2) = OV(ixyz,2) + Two* Weights(j) *
     &                        dF_dr * (Grid(2,j)-R_Grid(2))
                  OV(ixyz,3) = OV(ixyz,3) + Two* Weights(j) *
     &                        dF_dr * (Grid(3,j)-R_Grid(3))
               End Do
               If (iTab(2,i_Eff).ne.Off)
     &            Temp(i_Eff)=Temp(i_Eff)-Two*tmp
            End Do
         Else
            Do i_Eff=1, nGrad_Eff
               tmp=Zero
               ixyz=iTab(1,i_Eff)
               Do j = 1, mGrid
                  gxa=rho(3,j)
                  gya=rho(4,j)
                  gza=rho(5,j)
                  gxb=rho(6,j)
                  gyb=rho(7,j)
                  gzb=rho(8,j)

                  Temp0a=dF_dRho(ipRa,j)
                  Temp0b=dF_dRho(ipRb,j)
                  Temp1a=( 2.0d0*dF_dRho(ipGaa,j)*gxa
     &                          +dF_dRho(ipGab,j)*gxb )
                  Temp1b=( 2.0d0*dF_dRho(ipGbb,j)*gxb
     &                          +dF_dRho(ipGab,j)*gxa )
                  Temp2a=( 2.0d0*dF_dRho(ipGaa,j)*gya
     &                          +dF_dRho(ipGab,j)*gyb )
                  Temp2b=( 2.0d0*dF_dRho(ipGbb,j)*gyb
     &                          +dF_dRho(ipGab,j)*gya )
                  Temp3a=( 2.0d0*dF_dRho(ipGaa,j)*gza
     &                          +dF_dRho(ipGab,j)*gzb )
                  Temp3b=( 2.0d0*dF_dRho(ipGbb,j)*gzb
     &                          +dF_dRho(ipGab,j)*gza )
*
                  dF_dr = Temp0a*dRho_dR(1,j,i_Eff)
     &                  + Temp0b*dRho_dR(2,j,i_Eff)
     &                  + Temp1a*dRho_dR(3,j,i_Eff)
     &                  + Temp2a*dRho_dR(4,j,i_Eff)
     &                  + Temp3a*dRho_dR(5,j,i_Eff)
     &                  + Temp1b*dRho_dR(6,j,i_Eff)
     &                  + Temp2b*dRho_dR(7,j,i_Eff)
     &                  + Temp3b*dRho_dR(8,j,i_Eff)
                  tmp = tmp + Weights(j) * dF_dR
*
*                 Accumulate stuff for rotational invariance
*
                  OV(ixyz,1) = OV(ixyz,1) +      Weights(j) *
     &                        dF_dr * (Grid(1,j)-R_Grid(1))
                  OV(ixyz,2) = OV(ixyz,2) +      Weights(j) *
     &                        dF_dr * (Grid(2,j)-R_Grid(2))
                  OV(ixyz,3) = OV(ixyz,3) +      Weights(j) *
     &                        dF_dr * (Grid(3,j)-R_Grid(3))
               End Do
               If (iTab(2,i_Eff).ne.Off)
     &            Temp(i_Eff)=Temp(i_Eff)-tmp
            End Do
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Functional_type.eq.meta_GGA_type1) Then
         If (iSpin.eq.1) Then
            Do i_Eff=1, nGrad_Eff
               tmp=Zero
               ixyz=iTab(1,i_Eff)
               Do j = 1, mGrid
                  gx=rho(2,j)
                  gy=rho(3,j)
                  gz=rho(4,j)
                  Temp0=dF_dRho(ipR,j)
                  Temp1=(2.0d0*dF_dRho(ipGxx,j)+dF_dRho(ipGxy,j))*gx
                  Temp2=(2.0d0*dF_dRho(ipGxx,j)+dF_dRho(ipGxy,j))*gy
                  Temp3=(2.0d0*dF_dRho(ipGxx,j)+dF_dRho(ipGxy,j))*gz
                  Temp4=Half*dF_dRho(ipT,j)
*
                  dF_dr = Temp0*dRho_dR(1,j,i_Eff)
     &                  + Temp1*dRho_dR(2,j,i_Eff)
     &                  + Temp2*dRho_dR(3,j,i_Eff)
     &                  + Temp3*dRho_dR(4,j,i_Eff)
     &                  + Temp4*dRho_dR(5,j,i_Eff)
                  tmp = tmp  + Weights(j) * dF_dr
*
*                 Accumulate stuff for rotational invariance
*
                  OV(ixyz,1) = OV(ixyz,1) + Two* Weights(j) *
     &                        dF_dr * (Grid(1,j)-R_Grid(1))
                  OV(ixyz,2) = OV(ixyz,2) + Two* Weights(j) *
     &                        dF_dr * (Grid(2,j)-R_Grid(2))
                  OV(ixyz,3) = OV(ixyz,3) + Two* Weights(j) *
     &                        dF_dr * (Grid(3,j)-R_Grid(3))
               End Do
               If (iTab(2,i_Eff).ne.Off)
     &            Temp(i_Eff)=Temp(i_Eff)-Two*tmp
            End Do
         Else
            Do i_Eff=1, nGrad_Eff
               tmp=Zero
               ixyz=iTab(1,i_Eff)
               Do j = 1, mGrid
                  gxa=rho(3,j)
                  gya=rho(4,j)
                  gza=rho(5,j)
                  gxb=rho(6,j)
                  gyb=rho(7,j)
                  gzb=rho(8,j)

                  Temp0a=dF_dRho(ipRa,j)
                  Temp0b=dF_dRho(ipRb,j)
                  Temp1a=( 2.0d0*dF_dRho(ipGaa,j)*gxa
     &                          +dF_dRho(ipGab,j)*gxb )
                  Temp1b=( 2.0d0*dF_dRho(ipGbb,j)*gxb
     &                          +dF_dRho(ipGab,j)*gxa )
                  Temp2a=( 2.0d0*dF_dRho(ipGaa,j)*gya
     &                          +dF_dRho(ipGab,j)*gyb )
                  Temp2b=( 2.0d0*dF_dRho(ipGbb,j)*gyb
     &                          +dF_dRho(ipGab,j)*gya )
                  Temp3a=( 2.0d0*dF_dRho(ipGaa,j)*gza
     &                          +dF_dRho(ipGab,j)*gzb )
                  Temp3b=( 2.0d0*dF_dRho(ipGbb,j)*gzb
     &                          +dF_dRho(ipGab,j)*gza )
                  Temp4a=dF_dRho(ipTa,j)
                  Temp4b=dF_dRho(ipTb,j)
*
                  dF_dr = Temp0a*dRho_dR(1,j,i_Eff)
     &                  + Temp0b*dRho_dR(2,j,i_Eff)
     &                  + Temp1a*dRho_dR(3,j,i_Eff)
     &                  + Temp2a*dRho_dR(4,j,i_Eff)
     &                  + Temp3a*dRho_dR(5,j,i_Eff)
     &                  + Temp1b*dRho_dR(6,j,i_Eff)
     &                  + Temp2b*dRho_dR(7,j,i_Eff)
     &                  + Temp3b*dRho_dR(8,j,i_Eff)
     &                  + Temp4a*dRho_dR(9,j,i_Eff)
     &                  + Temp4b*dRho_dR(10,j,i_Eff)
                  tmp = tmp + Weights(j) * dF_dR
*
*                 Accumulate stuff for rotational invariance
*
                  OV(ixyz,1) = OV(ixyz,1) +      Weights(j) *
     &                        dF_dr * (Grid(1,j)-R_Grid(1))
                  OV(ixyz,2) = OV(ixyz,2) +      Weights(j) *
     &                        dF_dr * (Grid(2,j)-R_Grid(2))
                  OV(ixyz,3) = OV(ixyz,3) +      Weights(j) *
     &                        dF_dr * (Grid(3,j)-R_Grid(3))
               End Do
               If (iTab(2,i_Eff).ne.Off)
     &            Temp(i_Eff)=Temp(i_Eff)-tmp
            End Do
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Functional_type.eq.meta_GGA_type2) Then
         If (iSpin.eq.1) Then
            Do i_Eff=1, nGrad_Eff
               tmp=Zero
               ixyz=iTab(1,i_Eff)
               Do j = 1, mGrid
                  gx=rho(2,j)
                  gy=rho(3,j)
                  gz=rho(4,j)
                  Temp0=dF_dRho(ipR,j)
                  Temp1=(2.0d0*dF_dRho(ipGxx,j)+dF_dRho(ipGxy,j))*gx
                  Temp2=(2.0d0*dF_dRho(ipGxx,j)+dF_dRho(ipGxy,j))*gy
                  Temp3=(2.0d0*dF_dRho(ipGxx,j)+dF_dRho(ipGxy,j))*gz
                  Temp4=dF_dRho(ipT,j)
                  Temp5=dF_dRho(ipL,j)
*
                  dF_dr = Temp0*dRho_dR(1,j,i_Eff)
     &                  + Temp1*dRho_dR(2,j,i_Eff)
     &                  + Temp2*dRho_dR(3,j,i_Eff)
     &                  + Temp3*dRho_dR(4,j,i_Eff)
     &                  + Temp4*dRho_dR(5,j,i_Eff)
     &                  + Temp5*dRho_dR(6,j,i_Eff)
                  tmp = tmp  + Weights(j) * dF_dr
*
*                 Accumulate stuff for rotational invariance
*
                  OV(ixyz,1) = OV(ixyz,1) + Two* Weights(j) *
     &                        dF_dr * (Grid(1,j)-R_Grid(1))
                  OV(ixyz,2) = OV(ixyz,2) + Two* Weights(j) *
     &                        dF_dr * (Grid(2,j)-R_Grid(2))
                  OV(ixyz,3) = OV(ixyz,3) + Two* Weights(j) *
     &                        dF_dr * (Grid(3,j)-R_Grid(3))
               End Do
               If (iTab(2,i_Eff).ne.Off)
     &            Temp(i_Eff)=Temp(i_Eff)-Two*tmp
            End Do
         Else
            Do i_Eff=1, nGrad_Eff
               tmp=Zero
               ixyz=iTab(1,i_Eff)
               Do j = 1, mGrid
                  gxa=rho(3,j)
                  gya=rho(4,j)
                  gza=rho(5,j)
                  gxb=rho(6,j)
                  gyb=rho(7,j)
                  gzb=rho(8,j)

                  Temp0a=dF_dRho(ipRa,j)
                  Temp0b=dF_dRho(ipRb,j)
                  Temp1a=( 2.0d0*dF_dRho(ipGaa,j)*gxa
     &                          +dF_dRho(ipGab,j)*gxb )
                  Temp1b=( 2.0d0*dF_dRho(ipGbb,j)*gxb
     &                          +dF_dRho(ipGab,j)*gxa )
                  Temp2a=( 2.0d0*dF_dRho(ipGaa,j)*gya
     &                          +dF_dRho(ipGab,j)*gyb )
                  Temp2b=( 2.0d0*dF_dRho(ipGbb,j)*gyb
     &                          +dF_dRho(ipGab,j)*gya )
                  Temp3a=( 2.0d0*dF_dRho(ipGaa,j)*gza
     &                          +dF_dRho(ipGab,j)*gzb )
                  Temp3b=( 2.0d0*dF_dRho(ipGbb,j)*gzb
     &                          +dF_dRho(ipGab,j)*gza )
                  Temp4a=dF_dRho(ipTa,j)
                  Temp4b=dF_dRho(ipTb,j)
                  Temp5a=dF_dRho(ipLa,j)
                  Temp5b=dF_dRho(ipLb,j)
*
                  dF_dr = Temp0a*dRho_dR(1,j,i_Eff)
     &                  + Temp0b*dRho_dR(2,j,i_Eff)
     &                  + Temp1a*dRho_dR(3,j,i_Eff)
     &                  + Temp2a*dRho_dR(4,j,i_Eff)
     &                  + Temp3a*dRho_dR(5,j,i_Eff)
     &                  + Temp1b*dRho_dR(6,j,i_Eff)
     &                  + Temp2b*dRho_dR(7,j,i_Eff)
     &                  + Temp3b*dRho_dR(8,j,i_Eff)
     &                  + Temp4a*dRho_dR(9,j,i_Eff)
     &                  + Temp4b*dRho_dR(10,j,i_Eff)
     &                  + Temp5a*dRho_dR(11,j,i_Eff)
     &                  + Temp5b*dRho_dR(12,j,i_Eff)
                  tmp = tmp + Weights(j) * dF_dR
*
*                 Accumulate stuff for rotational invariance
*
                  OV(ixyz,1) = OV(ixyz,1) +      Weights(j) *
     &                        dF_dr * (Grid(1,j)-R_Grid(1))
                  OV(ixyz,2) = OV(ixyz,2) +      Weights(j) *
     &                        dF_dr * (Grid(2,j)-R_Grid(2))
                  OV(ixyz,3) = OV(ixyz,3) +      Weights(j) *
     &                        dF_dr * (Grid(3,j)-R_Grid(3))
               End Do
               If (iTab(2,i_Eff).ne.Off)
     &            Temp(i_Eff)=Temp(i_Eff)-tmp
            End Do
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else
*
         Call WarningMessage(2,'Do_Grad: wrong functional type!')
         Call Abend()
      End If
#ifdef _DEBUGPRINT_
      If (Debug) Then
         Call RecPrt('w * f^x before translational contributions',
     &               ' ',Temp,1,nGrad_Eff)
         Call RecPrt('OV',' ',OV,3,3)
      End If
#endif
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Here we compute the term
*
*     w * f^x
*
*     for x being a cartesian component of the center of the atomic
*     grid. This is done using the translational invariance condition.
*
      If (Grid_Type.eq.Moving_Grid) Then
         Do ixyz = 1, 3
            iGrad=0
            Do jGrad = 1, nGrad_Eff
               If (iTab(1,jGrad).eq.ixyz .and.
     &             iTab(2,jGrad).eq.Off  .and.
     &             IndGrd(jGrad).gt.0           ) iGrad=jGrad
            End Do
#ifdef _DEBUGPRINT_
            If (Debug) Write (6,*) 'iGrad=',iGrad
#endif
            If (iGrad.ne.0) Then
*
*              Evaluate indirectly via the translational invariance
*              the sum of the direct and indirect term
*
               Do jGrad = 1, nGrad_Eff
                  If (jGrad.ne.iGrad .and. iTab(1,jGrad).eq.ixyz ) Then
*
                      Temp(iGrad)=Temp(iGrad)-Temp(jGrad)
*
#ifdef _DEBUGPRINT_
            If (Debug) Write (6,*) 'jGrad,Temp(jGrad)=',
     &                              jGrad,Temp(jGrad)
#endif
                  End If
               End Do
*
            End If
         End Do
#ifdef _DEBUGPRINT_
      If (Debug) Call RecPrt('w * f^x',' ',Temp,1,nGrad_Eff)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     For a "moving" grid add contributions due to the derivative with
*     respect to the partitioning.
*
*     w^x * f
*
         Call DGEMM_('N','N',nGrad_Eff,1,mGrid,
     &              One,dW_dR,nGrad_Eff,
     &                  F_xc,mGrid,
     &              One,Temp,nGrad_Eff)
#ifdef _DEBUGPRINT_
      If (Debug) Call RecPrt('w * f^x + w^x * f',' ',Temp,1,nGrad_Eff)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        Add the rotational invariance term
*
*        First transform back to the cartesian coordinates system.
*
         Call DGEMM_('N','N',
     &               3,3,3,
     &               1.0d0,OV,3,
     &               Work(ip_O),3,
     &               0.0d0,V,3)
#ifdef _DEBUGPRINT_
      If (Debug) Call RecPrt('V',' ',V,3,3)
#endif
*
         Do i_Eff = 1, nGrad_Eff
            iCar = iTab(1,i_Eff)
            jNQ  = iTab(3,i_Eff)
*
*           Compute < nabla_r f * r^x > as Tr (O^x V)
*
      If(KSDFA(1:5).eq.'TLSDA'.or. !GLM
     &        KSDFA(1:6).eq.'FTLSDA'.or.
     &        KSDFA(1:6).eq.'FTBLYP'.or.
     &        KSDFA(1:5).eq.'FTPBE'.or.
     &        KSDFA(1:7).eq.'TREVPBE'.or.
     &        KSDFA(1:8).eq.'FTREVPBE'.or.
     &        KSDFA(1:5).eq.'TBLYP'.or.
     &        KSDFA(1:5).eq.'TOPBE'.or.
     &        KSDFA(1:6).eq.'FTOPBE'.or.
     &        KSDFA(1:4).eq.'TPBE') then
            Tmp = DDot_(9,Work(ip_dOdx(jNQ,iCar)),1,V,1)*0.5
      else
            Tmp = DDot_(9,Work(ip_dOdx(jNQ,iCar)),1,V,1)
      end if
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*)
               Write (6,*) 'iCar,jNQ=',iCar,jNQ
               Call RecPrt('dOdx',' ',Work(ip_dOdx(jNQ,iCar)),3,3)
               Write (6,*) 'Tmp=',Tmp
            End If
#endif
            Temp(i_Eff) = Temp(i_Eff) - Tmp
         End Do
*
      End If !moving grid
#ifdef _DEBUGPRINT_
      If (Debug) Call RecPrt('Gradient contribution from this block',
     &                       ' ',Temp,1,nGrad_Eff)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Accumulate and symmetry adapt.
*
      Do i_Eff = 1, nGrad_Eff
         i = IndGrd(i_Eff)
         If (i.ge.1) Then
            Fact=DBLE(iTab(4,i_Eff))
            Grad(i) = Grad(i) + Fact*Temp(i_Eff)
         End If
      End Do
#ifdef _DEBUGPRINT_
      If (Debug) Call RecPrt('Gradient accumulated so far',
     &                     ' ',Grad,1,nGrad)
      Debug=.False.
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      ! Copy-transpose matrix A to B using blocks to optimize cache
      ! usage or extended BLAS functionality if present.
      ! B := transpose(A)

      ! double precision version
      SUBROUTINE DTRANS(NROWS,NCOLS,A,LDA,B,LDB)
      IMPLICIT NONE
      ! arguments
      INTEGER, INTENT(IN) :: NROWS, NCOLS
      INTEGER, INTENT(IN) :: LDA, LDB
      REAL*8, INTENT(IN)  :: A(LDA,*)
      REAL*8, INTENT(OUT) :: B(LDB,*)
      ! local variables
#ifndef _MKL_
      INTEGER :: NBLKSZ, LROWS, LCOLS, MAXROW, MAXCOL
      INTEGER :: I, J, IB, JB
#endif

      IF (NROWS.LE.0.OR.NCOLS.LE.0) THEN
        WRITE(5,'(1X,A)') 'DTRANS: Error: invalid dimension(s)'
        WRITE(5,'(1X,2(A,I9))') 'NROWS = ', NROWS, 'NCOLS = ', NCOLS
        CALL AbEnd
      ELSE IF(NROWS > LDA .OR. NCOLS > LDB) THEN
        WRITE(5,'(1X,A)') 'DTRANS: Error: dimension(s) out-of-bounds'
        WRITE(5,'(1X,2(A,I9))') 'NROWS = ', NROWS, 'NCOLS = ', NCOLS
        WRITE(5,'(1X,2(A,I9))') 'LDA   = ', LDA  , 'LDB   = ', LDB
        CALL AbEnd
      END IF

#ifdef _MKL_
      CALL mkl_domatcopy('C', 'T', NROWS, NCOLS, 1.0D0, A, LDA, B, LDB)
#else
      NBLKSZ=8
      LROWS=MOD(NROWS,NBLKSZ)
      LCOLS=MOD(NCOLS,NBLKSZ)
      MAXROW=NROWS-LROWS
      MAXCOL=NCOLS-LCOLS
      IF (MAXROW.GT.0.AND.MAXCOL.GT.0) THEN
        DO IB=1,MAXROW,NBLKSZ
          DO JB=1,MAXCOL,NBLKSZ
            DO I=IB,IB+NBLKSZ-1
              DO J=JB,JB+NBLKSZ-1
                B(J,I)=A(I,J)
              END DO
            END DO
          END DO
        END DO
      END IF
* remainder of the blocks
      IF (MAXROW.GT.0.AND.LCOLS.GT.0) THEN
        DO IB=1,MAXROW,NBLKSZ
          DO I=IB,IB+NBLKSZ-1
            DO J=MAXCOL+1,MAXCOL+LCOLS
              B(J,I)=A(I,J)
            END DO
          END DO
        END DO
      END IF
      IF (MAXCOL.GT.0.AND.LROWS.GT.0) THEN
        DO JB=1,MAXCOL,NBLKSZ
          DO I=MAXROW+1,MAXROW+LROWS
            DO J=JB,JB+NBLKSZ-1
              B(J,I)=A(I,J)
            END DO
          END DO
        END DO
      END IF
* remainder block
      IF (LROWS.GT.0.AND.LCOLS.GT.0) THEN
        DO I=MAXROW+1,MAXROW+LROWS
          DO J=MAXCOL+1,MAXCOL+LCOLS
            B(J,I)=A(I,J)
          END DO
        END DO
      END IF
#endif
      END SUBROUTINE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine loopcntr_cvb(icode1)

use casvb_global, only: icnt, icode, inputmode, ioptstep, ipos, joptstep, loopstep, loopstepmx, mxstep, ncnt, noptstep
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: icode1
logical(kind=iwp) :: begbracket

loopstep = loopstep+1
if ((inputmode == 2) .and. ((icode1 == 5) .or. (icode1 == 6))) return
if (loopstep > mxstep) then
  write(u6,*) ' Loop structure too complicated -- mxstep :',mxstep
  call abend_cvb()
end if
if (inputmode == 1) then
  icode(loopstep) = icode1
  ipos(loopstep) = ncnt
end if
if ((icode(loopstep) == 1) .or. (icode(loopstep) == 3)) joptstep = joptstep+1
if (inputmode == 2) then
  if (joptstep == ioptstep) call setifinish_cvb(icode(loopstep))
  begbracket = ((icode(loopstep) == 1) .and. (icode(loopstep+1) == 2)) .or. ((icode(loopstep) == 3) .and. (icode(loopstep+1) == 4))
  if ((joptstep >= ioptstep+1) .or. ((joptstep == ioptstep) .and. (.not. begbracket))) then
    ! Go to end of input:
    icnt = ncnt
    loopstep = loopstepmx
    joptstep = noptstep
  else if ((joptstep < ioptstep) .and. begbracket) then
    ! Go to next closing bracket:
    icnt = ipos(loopstep+1)
    loopstep = loopstep+1
  end if
end if

return

end subroutine loopcntr_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TCMO(A,isym,ictl)

use Symmetry_Info, only: Mul
use MCLR_Data, only: CMO, ipCM, ipMat, nDens
use input_mclr, only: nBas, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: A(*)
integer(kind=iwp), intent(in) :: iSym, iCtl
integer(kind=iwp) :: iip(8), ip(8), iRC, iS, jS, nCMOInv, niCMOInv
integer(kind=iwp), allocatable :: iCMOInv(:)
real(kind=wp), allocatable :: CMOInv(:), Temp(:)

call mma_allocate(Temp,nDens,Label='Temp')
call ReLoad(A,isym,norb,nbas)

! irc used in call later must not be uninitialized
! since then MKL library gets upset...
irc = 0

if (ictl == -1) then

  nCMOInv = 0
  niCMOInv = 0
  ip(:) = 0
  iip(:) = 0
  do iS=1,nSym
    if (nbas(is) == 0) cycle
    ip(iS) = 1+nCMOInv
    iip(iS) = 1+nICMOInv
    nCMOInv = nCMOInv+nBas(is)**2
    niCMOInv = niCMOInv+nBas(is)
  end do
  call mma_allocate(CMOInv,nCMOInv,Label='CMOINV')
  call mma_allocate(iCMOInv,niCMOInv,Label='iCMOINV')

  do iS=1,nSym
    if (nbas(is) == 0) cycle
    CMOINV(ip(is):ip(is)+nbas(is)**2-1) = CMO(ipcm(is):ipcm(is)+nbas(is)**2-1)
    call dgetrf_(nBas(is),nBas(is),CMOINV(ip(is)),nBas(is),iCMOINV(iip(is)),irc)
    if (irc /= 0) call SysAbendMsg('tcmo','DGETRF returns non zero',' ')
  end do

  do iS=1,nSym
    js = Mul(is,isym)
    if (nbas(is)*nbas(js) == 0) cycle
    call dgetrs_('T',nbas(is),nbas(js),CMOINV(ip(is)),nBas(is),iCMOINV(iip(is)),A(ipMat(is,js)),nBas(is),irc)
    if (irc /= 0) call SysAbendMsg('tcmo','DGETRS returns non zero',' ')
    call DGETMO(A(ipMat(is,js)),nBas(is),nbas(is),nbas(js),Temp,nbas(js))
    call dgetrs_('T',nbas(js),nbas(is),CMOINV(ip(js)),nBas(js),iCMOINV(iip(js)),Temp,nBas(js),irc)
    if (irc /= 0) call SysAbendMsg('tcmo','DGETRS returns non zero',' ')
    call DGETMO(Temp,nBas(js),nbas(js),nbas(is),A(ipMat(is,js)),nbas(is))
  end do

  call mma_deallocate(CMOInv)
  call mma_deallocate(iCMOInv)

else if (ictl == 1) then

  do iS=1,nSym
    js = Mul(is,isym)
    if (nBas(is)*nBas(js) == 0) cycle
    call DGEMM_('T','N',nOrb(iS),nBas(jS),nBas(iS),One,CMO(ipCM(iS)),nBas(is),A(ipmat(is,js)),nBas(iS),Zero,Temp,nOrb(iS))
    call DGEMM_('N','N',nOrb(is),nOrb(jS),nBas(jS),One,Temp,nOrb(iS),CMO(ipCM(jS)),nBas(jS),Zero,A(ipMat(iS,jS)),nOrb(iS))
  end do

else if (ictl == -2) then

  do iS=1,nSym
    js = Mul(is,isym)
    if (nBas(is)*nBas(js) == 0) cycle
    call DGEMM_('N','N',nBas(iS),nOrb(jS),nOrb(iS),One,CMO(ipCM(iS)),nBas(is),A(ipmat(is,js)),nOrb(iS),Zero,Temp,nBas(iS))
    call DGEMM_('N','T',nBas(is),nBas(jS),nOrb(jS),One,Temp,nBas(iS),CMO(ipCM(jS)),nBas(jS),Zero,A(ipMat(iS,jS)),nBas(iS))
  end do

else

  write(u6,*) 'Oink'
  call SysHalt('tcmo')

end if

call mma_deallocate(Temp)

end subroutine TCMO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE INT1(I,J,K,L,IT1,IT2,II,IID,JJ,JJD,JTYP,ITAI,
     *L0,L1,L2,L3)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ITAI(*),L0(*),L1(*),L2(*),L3(*)
C     I.LT.J.LT.K.LT.L
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      LJS=IJ(L+1)+1
      LJM=IJ(L)
      ITYP=0
      DO 10 LJ=LJS,LJM
      ITAIL=IX(IT2+LJ)
      IF(IT1.NE.IT2)CALL TAIL(L,LJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
      IWAY(L)=1
32    KM=L
      J2(KM+1)=LJ
      J1(KM+1)=LJ
      CALL LOOP1(L,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 10
41    KM=KM-1
      IWAY(KM)=1
      IF(KM.EQ.K)GO TO 51
42    CALL LOOP5(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 41
      KM=KM+1
      IF(KM.EQ.L)GO TO 32
      GO TO 42
51    IWAY(K)=1
52    KM=K
      CALL LOOP3(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 30
      KM=KM+1
      IF(KM.EQ.L)GO TO 32
      GO TO 42
30    KM=KM-1
      IWAY(KM)=1
      IF(KM.EQ.J)GO TO 133
62    CALL PATH(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 30
      KM=KM+1
      IF(KM.EQ.K)GO TO 52
      GO TO 62
133   IWAY(J)=1
132   KM=J
      IF(IT1.GE.IT2)CALL LOOP1(KM,ISTOP,IT1,IT2)
      IF(IT2.GT.IT1)CALL LOOP2(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 141
      KM=KM+1
      IF(KM.EQ.K)GO TO 52
      GO TO 62
141   KM=KM-1
      IF(KM.EQ.0)GO TO 20
      IWAY(KM)=1
      IF(KM.EQ.I)GO TO 151
142   IF(IT1.GE.IT2)CALL LOOP5(KM,ISTOP,IT1,IT2)
      IF(IT2.GT.IT1)CALL LOOP6(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 141
      KM=KM+1
      IF(KM.EQ.J)GO TO 132
      GO TO 142
151   IWAY(I)=1
152   KM=I
      IF(IT1.GE.IT2)CALL LOOP3(KM,ISTOP,IT1,IT2)
      IF(IT2.GT.IT1)CALL LOOP4(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 153
      COUP(I)=COUP(I)*COUP(K)
      IF(ABS(COUP(I)).LT.1.D-06)GO TO 152
      ICPI=ICOUP(I)
      ICP1I=ICOUP1(I)
      ICOUP(I)=ICOUP(J+1)+ICPI
      ICOUP1(I)=ICOUP1(J+1)+ICP1I
      CALL COMP(I,LJ,ITYP,I,IT1,IT2)
      ICOUP(I)=ICOUP(J+1)+ICP1I
      ICOUP1(I)=ICOUP1(J+1)+ICPI
      CALL COMP(I,LJ,ITYP,I,IT1,IT2)
      GO TO 152
153   KM=KM+1
      IF(KM.EQ.J)GO TO 132
      GO TO 142
20    COUP(1)=COUP(1)*COUP(K)
      IF(ABS(COUP(1)).LT.1.D-06)GO TO 154
      ICOUP(1)=ICOUP(J+1)+ICOUP(1)
      ICOUP1(1)=ICOUP1(J+1)+ICOUP1(1)
      CALL COMP1(LJ,ITYP,L,IT2,II,IID,JJ,JJD,JTYP,ITAI)
154   KM=1
      IF(KM.EQ.J)GO TO 132
      GO TO 142
10    CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine hmod(gx,gy,gz,V,EFx,EFy,EFz,Cavxyz,lmax_)
************************************************************************
*                                                                      *
*     Object: to compute the potential and electric field in a point   *
*             due to the multipole moment expansion at origin.         *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Cavxyz((lMax_+1)*(lMax_+2)*(lMax_+3)/6)
*
*---- Statement function
*
      iOff(ix,iy,iz)=(ix+iy+iz)*(ix+iy+iz+1)*(ix+iy+iz+2)/6
      Index(ix,iy,iz) = iOff(ix,iy,iz) + (iy+iz)*(iy+iz+1)/2 + iz + 1
*
      V  = Zero
      EFx= Zero
      EFy= Zero
      EFz= Zero
*
*     nCavxyz=(lMax_+1)*(lMax_+2)*(lMax_+3)/6
*     Write (*,*) 'lMax_,nCavxyz=',lMax_,nCavxyz
      lmax=lmax_-1
      Do ix = 0, lmax
         If (ix.eq.0) Then
            xeff = One
         Else
            xeff = gx**ix
         End If
         ax = DBLE(ix) + One
         Do iy = 0, lmax-ix
            If (iy.eq.0) Then
               xyeff = xeff
            Else
               xyeff = xeff * gy**iy
            End If
            ay = DBLE(iy) + One
            Do iz = 0, lmax-ix-iy
               If (iz.eq.0) Then
                  xyzeff = xyeff
               Else
                  xyzeff = xyeff * gz**iz
               End If
               az = DBLE(iz) + One
*              Write (*,*) ix,iy,iz,Index(ix,iy,iz),
*    &                     Index(ix+1,iy,iz),Index(ix,iy+1,iz),
*    &                     Index(ix,iy,iz+1)
*
*------------- Charge term
*
               V=V+xyzeff*Cavxyz(Index(ix  ,iy  ,iz  ))
*
*------------- Dipole terms
*
               EFx=EFx+ax*xyzeff*Cavxyz(Index(ix+1,iy  ,iz  ))
               EFy=EFy+ay*xyzeff*Cavxyz(Index(ix  ,iy+1,iz  ))
               EFz=EFz+az*xyzeff*Cavxyz(Index(ix  ,iy  ,iz+1))
*
            End Do
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1996, Markus P. Fuelscher                         *
*               1993, Per Ake Malmqvist                                *
*               1998, Roland Lindh                                     *
************************************************************************
      Subroutine SORT2
************************************************************************
*                                                                      *
*     Purpose: Control phase 2 of bin sorting algorithm. First,        *
*              reload all integrals belonging to the same slice        *
*              and sort them ( c.f. SORT2A ). While reading the        *
*              keep a trace of the records which have been read.       *
*              They are used to generate forward chaining indices.     *
*              Also integrals which are of zero value are placed       *
*              back into the list. In the second step put the sorted   *
*              integrals back onto disk. If new records are needed     *
*              append them to the end of the list.                     *
*                                                                      *
*     Called from: Seward_main                                         *
*                                                                      *
*     Calls to : Sort2A,Sort2B,Sort3                                   *
*                                                                      *
*     Calling parameters: none                                         *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDef  : definitions of the record structure                    *
*     TwoDat : definitions of sorting flags and address tables         *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*     Srt1    : common block containing information the number of      *
*               bins and partitioning of symmetry blocks               *
*     Srt2    : common block containing information pertinent to       *
*               the bin sorting algorithm                              *
*     Srt3    : dynamic stack to control inout and output of           *
*               integral buffers                                       *
*                                                                      *
*     local data declarations: none                                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.-AA. Malmqvist                             *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*     - modified to possibly use a virtual disk                        *
*       M. P. Fuelscher,University of Lund, Sweden, 1996               *
*     - modified to compute MxOrd                                      *
*       R. Lindh,University of Lund, Sweden, 1998                      *
*                                                                      *
************************************************************************
*
      use srt2
      Implicit Real*8 (A-H,O-Z)
*
#include "Molcas.fh"
#include "TwoDat.fh"
#include "srt0.fh"
#include "srt1.fh"
*---------------------------------------------------------------------*
*                                                                     *
*     Stack information pertinent to phase2 of sorting                *
*     (to keep track of records that have been read in and/or         *
*      written out                                                    *
*                                                                     *
*     lStk   : size of the stack                                      *
*                                                                     *
*---------------------------------------------------------------------*
C     Parameter ( lStk = 64*1024 )
C     Integer IOStk(lStk)
C     Common /SRT3/ nStk,IOStk
C     Common /SRT3/ nStk,ip_IOStk,lStk
      Integer nStk,lStk
*
#include "stdalloc.fh"
#include "SysDef.fh"
#include "print.fh"
      Integer, Allocatable:: IOStk(:)
      Real*8, Allocatable:: SrtA(:), Scr(:)
*
*----------------------------------------------------------------------*
*     pick up the print level                                          *
*----------------------------------------------------------------------*
*
      iRout = 84
      iPrint = nPrint(iRout)
      If ( iPrint.ge.10) Write (6,*) ' >>> Enter SORT2 <<<'
*
*----------------------------------------------------------------------*
*     Turn timing ON                                                   *
*----------------------------------------------------------------------*
*
*
*----------------------------------------------------------------------*
*     Initialize the IO-stack                                          *
*----------------------------------------------------------------------*
*
      Call mma_MaxINT(lStk_Max)
      lStk=Max(64*1024,lStk_Max/5)
      Call mma_allocate(IOStk,lStk,Label='IOStk')
      IOStk(:)=0
      nStk=0
*
*----------------------------------------------------------------------*
*     loop over all submatrices of 2el integrals (slices)              *
*----------------------------------------------------------------------*
*
      iOrd=0
      iBin=0
      nSym=nSyOp
      Do iSymi=1,nSym
        ib=nBs(iSymi)
        iSkip=nSkip(iSymi)
        Do jSymj=1,iSymi
          iSymj=1+ieor(iSymi-1,jSymj-1)
          iSyblj=jSymj+iSymi*(iSymi-1)/2
          jb=nBs(jSymj)
          ibj=ib*jb
          If( iSymi.eq.jSymj ) ibj=ib*(ib+1)/2
          jSkip=nSkip(jSymj)
          kSymMx=iSymi
          If( Square ) kSymMx=nSym
          Do kSymk=1,kSymMx
            kb=nBs(kSymk)
            kSkip=nSkip(kSymk)
            lSymMx=jSymj
            If( kSymk.ne.iSymi .or. Square ) lSymMx=kSymk
            Do lSyml=1,lSymMx
              kSyml=1+ieor(kSymk-1,lSyml-1)
              kSybll=lSyml+kSymk*(kSymk-1)/2
              If( ieor(iSymj-1,kSyml-1).eq.0 ) then
                lb=nBs(lSyml)
                kbl=kb*lb
                If( kSymk.eq.lSyml ) kbl=kb*(kb+1)/2
                lSkip=nSkip(lSyml)
                iSyBlk=kSybll+mxSyP*(iSyblj-1)
*
                If ( (iSkip+jSkip+kSkip+lSkip).eq.0 .and.
     &               (ibj*kbl).ne.0 ) Then
*                                                                      *
************************************************************************
*                                                                      *
                   If (RAMD) Then
*
*                     RAMD option
*
                      lSrtA=ibj*kbl
                      iBin = iBin + 1
                      iBatch=nBatch(iSyBlk)
                      iOff = RAMD_Adr(iBatch)+1
                      Call SORT2B(iBin,lSrtA,iOrd,lSrtA,RAMD_Ints(iOff),
     &                            IOStk,lStk,nStk)
*                                                                      *
************************************************************************
*                                                                      *
                   Else
*                                                                      *
************************************************************************
*                                                                      *
*                    Sorting option
*
                      nSlice=nSln(iSyBlk)
                      lSlice=lSll(iSyBlk)
                      nij=lSlice/kbl
                      mxij=ibj
*
                      lSrtA_=min(mxij,nij)*kbl
                      Call mma_allocate(SrtA,lSrtA_,Label='SrtA')
*
*----------------------------------------------------------------------*
*     Allocate space to keep all integrals of a slice in memory,       *
*     fetch them from disk and sort them.                              *
*----------------------------------------------------------------------*
*
                      Do iSlice=1,nSlice
                         iBin=iBin+1
                         lSrtA=min(mxij,nij)*kbl
                         SrtA(1:lSrtA)=0.0D0
                         Call SORT2A(iBin,lSrtA,SrtA,IOStk,lStk,nStk)
*
*----------------------------------------------------------------------*
*     Sort the IO-stack in ascending order, i.e., preference is        *
*     always given to the lowest available disk adresses.              *
*----------------------------------------------------------------------*
*
                         Call ILASRT('D',nStk,IOStk,iErr)
*
*----------------------------------------------------------------------*
*     Restore integrals on LuTwo                                       *
*----------------------------------------------------------------------*
*
                         Call SORT2B(iBin,lSrtA,iOrd,lSrtA,SrtA,
     &                               IOStk,lStk,nStk)
                         mxij=mxij-nij
                      End Do
*
                      Call mma_deallocate(SrtA)
*                                                                      *
************************************************************************
*                                                                      *
                   End If
*                                                                      *
************************************************************************
*                                                                      *
                End If
              End If
            End Do
          End Do
        End Do
      End Do
*
*----------------------------------------------------------------------*
*     Clean the remaining records in the I/O Stack                     *
*----------------------------------------------------------------------*
*
      Call mma_allocate(Scr,lStRec,Label='Scr')
      Scr(:)=0.0D0
      Do iStk=1,nStk
        iOrd=iOrd+1
        iDisk=IOStk(iStk)
        Scr(2)=DBLE(iOrd)
        iOpt=1
        Call dDAFILE(LuTwo,iOpt,Scr,lStRec,iDisk)
      End Do
      MxOrd=iOrd
      Call mma_deallocate(Scr)
      Call mma_deallocate(IOStk)
*
      If (.Not.RAMD) Then
         Call mma_deallocate(ValBin)
         Call mma_deallocate(IndBin)
      End If
*
*----------------------------------------------------------------------*
*     Turn timing OFF and exit                                         *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine GetChckData (LunAux)
c
c        this routine do:
c        Get Chck Data from ChkDat file
c
        implicit none
#include "chcc1.fh"
        integer LunAux
c
*       open (unit=LunAux,file='ChKDat',form='unformatted')
        Call Molcas_BinaryOpen_Vanilla(LunAux,'ChKDat')
          read(LunAux) T1c,T2c,OEo,OEv,Q0,Q1,Q21,Q22,Q3,Q4
     c                 ,L0k,L1k,L2k
        close (LunAux)
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 FUNCTION THETA(M,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CRELOP/ PI,ZWP,SQPI,VELIT,PREA,CSQ,ZWPH32,FAK(26),
     *ZWPH12,BCO(210),GAM(20),IMAX
C
C     INTEGRATION OVER THETA. INCLUDES A FACTOR SIN(TH)
C     FOR THE VOLUME ELEMENT
C
      IF (MOD(N,2).EQ.1) GOTO 10
      THETA=GAM(M+2)*GAM(N+1)/GAM(M+N+3)
      RETURN
10    THETA=0.D0
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  readgeo
*
*> @brief
*>   Reads a geometry and stores it into memory
*> @author Y. Carissan
*>
*> @details
*> Reads a geometry in the XYZ format and stores it
*> in memory at address \c Work(ipgeo(ig)).
*>
*> @param[in] iLU logic unit number
*> @param[in] ig  geometry index
************************************************************************
      subroutine readgeo(iLU,ig)
      implicit none
#include "WrkSpc.fh"
#include "debug.fh"
#include "geoms.fh"
      Character*180 Get_Ln
      External Get_Ln
      integer iLU,ig,natoms
      integer iat
      Character Line*180
      character lbl*20
      character cName*6

      if ((ig.lt.1).or.(ig.gt.2))
     &    Call SysAbendMsg("ReadGeo",
     &       "Wrong ig ","Shoot the programmer")

c read natoms
      Line=Get_ln(iLU)
      Call Put_ln(Line)
      Call Get_I1(1,natoms)

      If (natoms.gt.500) Call SysAbendMsg("ReadGeo",
     & "Too many atoms in geom","")

      if (debug) Write(6,*) 'In READGEO : Nat=',natoms

      nat(ig)=natoms
c
c allocate memory for the geometry
c
      if (ig.lt.10) then
        Write(cName,'(a5,i1)') "GEOM0",ig
        title(ig)=cName
      else if (ig.lt.100) then
        Write(cName,'(a4,i2)') "GEOM",ig
        title(ig)=cName
      end if
      Call GetMem(cName,"Allo","Real",ipgeo(ig),3*nat(ig))
c
c read title
c
      Line=Get_ln(iLU)
      title(ig)=Trim(line)
c
c read label and coords
c
      iat=0
666     continue
        Line=Get_ln(iLU)
        Call Put_ln(Line)
        Call Get_S(1,lbl,1)
        if (lbl.eq.'END ') then
          Goto 999
        else
          iat=iat+1
          if (iat.gt.nat(ig)) Call SysAbendMsg("ReadGeo",
     &        "More atoms read than declared", "")

          geoLbl(iat,ig)=lbl
          Call Get_F(2,Work(ipgeo(ig)+(iat-1)*3),3)
        end if
      goto 666

      Call SysAbendMsg("ReadGeo","you should never get here",
     &     "shoot the programmer")

999   continue
      call PrintGeom(-1,nat(ig),title(ig),Work(ipgeo(ig)),geolbl(1,ig))
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_CC_drv(rc,CMO)

************************************************************************
C
C      a,b,g,d:  AO-index
C      p,q,r,s:  MO-indices belonging to (probably frozen excluded ?)
C
************************************************************************
      use ChoArr, only: nDimRS
      use ChoSwp, only: InfVec
      use Data_Structures, only: DSBA_Type, SBA_Type
      use Data_Structures, only: Allocate_DT, Deallocate_DT
      Implicit Real*8 (a-h,o-z)

      Integer   rc
      Type (DSBA_Type) CMO

      Real*8    tread(2),tmotr1(2),tmotr2(2)
      Logical   DoRead
      Integer   nPorb(8)

      Character*50 CFmt
      Character(LEN=10), Parameter:: SECNAM = 'CHO_CC_drv'

#include "real.fh"
#include "chotime.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "stdalloc.fh"

      Type (SBA_Type) Laq(1)
      Real*8, Allocatable:: Lrs(:,:)
      Real*8, Allocatable,Target:: Lpq(:)
      Real*8, Pointer:: pLpq(:,:,:)=>Null()

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
************************************************************************

      LunChVF = 80
      LunChVF = isfreeunit(LunChVF)
      call DaName_mf_wa (LunChVF,'CD1tmp')
      idisk=1
      DoRead  = .false.
      IREDC = -1  ! unknown reduced set in core

      iSwap = 0  ! Lpb,J are returned by cho_x_getVtra
      kMOs = 1
      nMOs = 1


        CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        do i=1,2            ! 1 --> CPU   2 --> Wall
           tread(i) = zero   !time read/write vectors
           tmotr1(i) = zero  !time 1st MO half-transf.
           tmotr2(i) = zero  !time 2nd MO half-transf.
        end do

c --- Define MOs used in CC
c -----------------------------------
        do i=1,nSym
           nPorb(i) = SIZE(CMO%SB(i)%A2,1)
        end do


C ==================================================================

c --- Various offsets & pointers
c ------------------------------

      iLoc = 3 ! use scratch location in reduced index arrays

C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
c
c
      DO jSym=1,nSym

         If (NumCho(jSym).lt.1) GOTO 1000

C -------------------------------------------------------------


C ****************     MEMORY MANAGEMENT SECTION    *****************
C ------------------------------------------------------------------
C --- compute memory needed to store at least 1 vector of JSYM
C --- and do all the subsequent calculations
C ------------------------------------------------------------------
         mTvec  = 0  ! mem for storing half-transformed vec Laq,J
         mTTvec = 0  ! mem for storing transformed vec Lpq,J

         do l=1,nSym
            k=Muld2h(l,JSYM)
            mTvec = mTvec + nPorb(l)*nBas(k)
            mTTvec = Max(mTTvec,nPorb(l)*nPorb(k))
         end do

         mvec = mTvec + mTTvec

C ------------------------------------------------------------------
C ------------------------------------------------------------------

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

         Do JRED=JRED1,JRED2

            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               call abend()
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.',
     &                         ' rc= ',irc
              call abend()
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            Call mma_maxDBLE(LWORK)

            nVec  = Min(LWORK/(nRS+mvec),nVrs)

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) 'LWORK= ',LWORK
               WRITE(6,*) 'min. mem. need= ',nRS+mTvec
               WRITE(6,*) 'reading ',nRS,' and transforming to ',mvec
               WRITE(6,*) 'of jsym= ',jsym,' and JRED= ',JRED
               rc = 33
               CALL Abend()
               nBatch = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call mma_allocate(Lrs,nRS,nVec,Label='Lrs')
            Call Allocate_DT(Laq(1),nPorb,nBas,nVec,jSym,nSym,iSwap)
            Call mma_allocate(Lpq,mTTVec*nVec,Label='Lpq')

C --- BATCH over the vectors ----------------------------

            nBatch = (nVrs-1)/nVec + 1

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM) then
                  rc=77
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

C --------------------------------------------------------------------
C --- First half MO transformation  Lpb,J = sum_a  C(p,a) * Lab,J
C --------------------------------------------------------------------

               CALL CWTIME(TCM1,TWM1)

               CALL CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,
     &                           JSYM,iSwap,IREDC,nMOs,kMOs,[CMO],
     &                           Laq(1),DoRead)

               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif

               CALL CWTIME(TCM2,TWM2)
               tmotr1(1) = tmotr1(1) + (TCM2 - TCM1)
               tmotr1(2) = tmotr1(2) + (TWM2 - TWM1)

C --------------------------------------------------------------------
C --- 2nd half of MO transformation  Lpq,J = sum_b  Lpb,J * C(q,b)
C --------------------------------------------------------------------
               Do iSymb=1,nSym

                  iSymp = MulD2h(JSYM,iSymb)
                  NAp = nPorb(iSymp)
                  NAq = nPorb(iSymb) ! iSymb=iSymq
                  iS = 1
                  iE = NAp * NAq * JNUM

                  pLpq(1:NAp,1:NAq,1:JNUM) => Lpq(iS:iE)

                  CALL CWTIME(TCM3,TWM3)

                  If(NAp*NAq.ne.0)Then

                    Do JVC=1,JNUM

                      CALL DGEMM_('N','T',NAp,NAq,nBas(iSymb),
     &                           One,Laq(1)%SB(iSymb)%A3(:,:,JVC),NAp,
     &                               CMO%SB(iSymb)%A2,NAq,
     &                          Zero,pLpq(:,:,JVC),NAp)

                      End Do

                  EndIf

                  CALL CWTIME(TCM4,TWM4)
                  tmotr2(1) = tmotr2(1) + (TCM4 - TCM3)
                  tmotr2(2) = tmotr2(2) + (TWM4 - TWM3)

C if u need to compute fock matrix elements this should be done probably here
C     I can help you with that

                  CALL CWTIME(TCR3,TWR3)
C --- WRITE transformed vectors to disk (each Jsym on a separate file!)
c
                  call ddafile (LunChVF,1,Lpq,NAp*NAq*JNUM,idisk)
c
C --- remember that this is inside a batch over J, the vector index

                  CALL CWTIME(TCR4,TWR4)
                  tread(1) = tread(1) + (TCR4 - TCR3)
                  tread(2) = tread(2) + (TWR4 - TWR3)

                  pLpq => Null()

               End Do

C --------------------------------------------------------------------
C --------------------------------------------------------------------

            END DO  ! end batch loop

C --- free memory
            Call mma_deallocate(Lpq)
            Call Deallocate_DT(Laq(1))
            Call mma_deallocate(Lrs)

999         CONTINUE

         END DO   ! loop over red sets


1000     CONTINUE

      END DO   !loop over JSYM
      call daclos(LunChVF)

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1
*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky-CC timing from '//SECNAM
      Write(6,CFmt)'----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'MO transf. Cholesky vectors     CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ/WRITE VECTORS               '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'1st half-transf.                 '
     &                           //'         ',tmotr1(1),tmotr1(2)
         Write(6,'(2x,A26,2f10.2)')'2nd half-transf.                 '
     &                           //'         ',tmotr2(1),tmotr2(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif

      rc  = 0

      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine paras_calculate()

use gugaci_global, only: ibsm_ext, iesm_ext, iwt_orb_ext, iwt_sm_s_ext, jb_sys, jroute_sys, ng_sm, nlsm_dbl, nlsm_ext, spin
                         !, n_electron, norb_all, norb_dbl, norb_dz, norb_ext
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
#include "Molcas.fh"
integer(kind=iwp) :: iaend, iaorb, iasta, ibend, iborb, ibsta, icnttmp, ijsm, isma, ismb, isumtmp, iwt_sm_sab(mxSym), iwttmp, ni, &
                     nij, nj
!integer(kind=iwp), parameter :: inlptb_new(156) = [ &
!                                                  ! 1  2  3  4  5  6  7  8  9  10  11  12 13
!                                                  ! a^r=1
!                                                   -1, 0, 0, 0, 0, 0,-7, 0,-9,-10,  0,-12, 0, &
!                                                  ! a^l=2
!                                                    0, 0, 0, 0, 0,-6, 0,-8, 0,  0,-11,  0, 0, &
!                                                  ! b_r=3
!                                                    4, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0, 0, &
!                                                  ! b_l=4
!                                                    5, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0, 0, &
!                                                  ! b^r=5
!                                                    0, 7, 8,10,11, 0, 0, 0, 0,  0,  0,  0, 0, &
!                                                  ! b^l=6
!                                                    0, 0, 9, 0,12, 0, 0, 0, 0,  0,  0,  0, 9, &
!                                                  ! c^'=7
!                                                    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 3, &
!                                                  ! c^"=8
!                                                    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12,13, &
!                                                  ! d_l^r=9
!                                                    6, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0, 0, &
!                                                  ! d^r^r=10
!                                                    0,-2, 0,-4, 0, 0, 0, 0, 0,  0,  0,  0, 0, &
!                                                  ! d^r^l=11
!                                                    0, 0,-3, 0,-5, 0, 0, 0, 0,  0,  0,  0, 0, &
!                                                  ! c^'" =12
!                                                    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 0], &
!***********************************************************************
!   ar      =1 (+a^r)     drr     =2 (+d^rr)   drl     =3 (+d^rl)
!   arbr    =4 (+d^rr)    arbl    =5 (+d^rl)   ard_l^r =6 (+a^l)
!   drrb^r  =7 (+a^r)     drlb^r  =8 (+a^l)    drlb^l  =9 (+a^r)
!   arbrb^r =10 (+a^r)    arblb^r =11 (+a^l)   arblb^l =12 (+a^r)
!   drl     =13 (*)
!***********************************************************************
!                      inlptb_new(169) = [ -1,  0,  4,  5,  0,  0,  1,  1,  6,  0,  0,  1, &
!                                           0,  0,  0,  0,  7,  0,  2,  2,  0, -2,  0,  2, &
!                                           0,  0,  0,  0,  8,  9,  3,  3,  0,  0, -3,  3, &
!                                           0,  0,  0,  0, 10,  0,  4,  4,  0, -4,  0,  4, &
!                                           0,  0,  0,  0, 11, 12,  5,  5,  0,  0, -5,  5, &
!                                           0, -6,  0,  0,  0,  0,  6,  6,  0,  0,  0,  6, &
!                                          -7,  0,  0,  0,  0,  0,  7,  7,  0,  0,  0,  7, &
!                                           0, -8,  0,  0,  0,  0,  8,  8,  0,  0,  0,  8, &
!                                          -9,  0,  0,  0,  0,  0,  9,  9,  0,  0,  0,  9, &
!                                         -10,  0,  0,  0,  0,  0, 10, 10,  0,  0,  0, 10, &
!                                           0,-11,  0,  0,  0,  0, 11, 11,  0,  0,  0, 11, &
!                                         -12,  0,  0,  0,  0,  0, 12, 12,  0,  0,  0, 12, &
!                                           0,  0,  0,  0,  0,  9,  3, 13,  0,  0,  0,  0], &
!                      indord_plptype(12) = [0,0,0,1,1,3,3,1,1,2,2,2]   !severe_new_error_1

!ja_sys = int(n_electron*Half-spin)-norb_dz
jb_sys = int(spin+spin)
!jc_sys = norb_all-ja_sys-jb_sys
!jsm_sys = ns_sm
!write(u6,'(a9,3(1x,i3))') 'ja,jb,jc ',ja_sys,jb_sys,jc_sys
!if (jb_sys == jb_sys/2*2) then    ????? 11.2
!  w0_drl2_44 = v_sqtwo
!  w0_drl2_1122 = v_onevsqtwo
!else
!  w0_drl2_44 = -v_sqtwo
!  w0_drl2_1122 = v_onevsqtwo
!end if

if (jb_sys == 0) jroute_sys = 1
if (jb_sys == 1) jroute_sys = 2
if (jb_sys > 1) jroute_sys = 3

!do i=1,ng_sm
!  iwt_ext(i,1) = 0
!  iwt_ext(i,2) = nlsm_ext(i)
!end do
!iwt_ext(1,1) = 1
!
!do i=1,ng_sm
!  ni = nlsm_ext(i)
!  do j=i,ng_sm
!    nj = nlsm_ext(j)
!    if (i == j) then
!      nij = ni*(ni-1)/2
!    else
!      nij = ni*nj
!    end if
!    ijsm = Mul(i,j)
!    iwt_ext(ijsm,3) = iwt_ext(ijsm,3)+nij
!    iwt_ext(ijsm,4) = iwt_ext(ijsm,4)+nij
!  end do
!end do
!iwt_ext(1,4) = iwt_ext(1,4)+norb_ext
!
!do i=1,ng_sm
!  iwt_dbl(i,1) = 0
!  iwt_dbl(i,2) = nlsm_dbl(Mul(i,jsm_sys))
!  if (jroute_sys > 1) then
!    iwt_dbl(i,3) = nlsm_dbl(Mul(i,jsm_sys))
!  end if
!end do
!iwt_dbl(ns_sm,1) = 1
!
!do i=1,ng_sm
!  ni = nlsm_dbl(i)
!  do j=i,ng_sm
!    nj = nlsm_dbl(j)
!    if (i == j) then
!      nij = ni*(ni-1)/2
!    else
!      nij = ni*nj
!    end if
!    ijsm = Mul(Mul(i,j),ns_sm)
!    iwt_dbl(ijsm,4) = iwt_dbl(ijsm,4)+nij
!    if (jroute_sys > 2) then
!      iwt_dbl(ijsm,5) = iwt_dbl(ijsm,5)+nij
!    end if
!    iwt_dbl(ijsm,6) = iwt_dbl(ijsm,6)+nij
!    if (jroute_sys > 1) then
!      iwt_dbl(ijsm,6) = iwt_dbl(ijsm,6)+nij
!    end if
!  end do
!end do
!iwt_dbl(ns_sm,6) = iwt_dbl(ns_sm,6)+norb_dbl

do ismb=1,ng_sm
  iwt_sm_sab(ismb) = 0
end do
do ismb=1,ng_sm
  ni = nlsm_ext(ismb)
  ibsta = ibsm_ext(ismb)
  ibend = iesm_ext(ismb)
  do isma=1,ismb
    nj = nlsm_ext(isma)
    if (isma == ismb) then
      nij = ni*(ni-1)/2
    else
      nij = ni*nj
    end if
    ijsm = Mul(isma,ismb)
    !iwt_sm_sab(ijsm) = iwt_sm_sab(ijsm)+nij
    ! iwt_sm_sab function as a tmp array
    !iwt_sm_ext(isma,ismb) = iwt_sm_sab(ijsm)

    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) then
      ibsta = iasta+1
    end if
    iwttmp = iwt_sm_sab(ijsm)
    do iborb=ibsta,ibend
      do iaorb=iasta,min(iaend,iborb-1)
        iwttmp = iwttmp+1
        !if ((iaorb <= 0) .or. (iaorb > max_extorb)) write(u6,*)
        !if ((iborb <= 0) .or. (iborb > max_extorb)) write(u6,*)
        iwt_orb_ext(iaorb,iborb) = iwttmp
      end do
    end do

    iwt_sm_sab(ijsm) = iwt_sm_sab(ijsm)+nij
  end do
end do
iwt_sm_s_ext = iwt_sm_sab(1)

isumtmp = 0
do ismb=1,ng_sm
  icnttmp = iwt_sm_sab(ismb)
  iwt_sm_sab(ismb) = isumtmp
  isumtmp = isumtmp+icnttmp
end do
! imap_revorbtoorb_ext()
!do ismb=1,ng_sm
!  ibsta = ibsm_ext(ismb)
!  ibend = iesm_ext(ismb)
!  do isma=1,ismb
!    iasta = ibsm_ext(isma)
!    iaend = iesm_ext(isma)
!    if (isma == ismb) iaend = iaend-1
!
!    ismab = Mul(isma,ismb)
!    iwttmp = iwt_sm_ext(isma,ismb)+iwt_sm_sab(ismab)
!    do iaorb=iasta,iaend
!      do iborb=max(iaorb+1,ibsta),ibend
!        iwttmp = iwttmp+1
!        iwt_revorb_ext(iaorb,iborb) = iwttmp
!        imap_revorbtoorb_ext(iwttmp) = iwt_orb_ext(iaorb,iborb)
!      end do
!    end do
!  end do
!end do

do ismb=1,ng_sm
  iwt_sm_sab(ismb) = 0
end do
do ismb=1,ng_sm
  ni = nlsm_dbl(ismb)
  !ibsta = ibsm_dbl(ismb)
  !ibend = iesm_dbl(ismb)
  do isma=1,ismb
    nj = nlsm_dbl(isma)
    if (isma == ismb) then
      nij = ni*(ni-1)/2
    else
      nij = ni*nj
    end if
    ijsm = Mul(isma,ismb)
    !iwt_sm_dbl(isma,ismb) = iwt_sm_sab(ijsm)

    !iasta = ibsm_dbl(isma)
    !iaend = iesm_dbl(isma)
    !if (ismb == isma) then
    !  ibsta = iasta+1
    !end if
    !iwttmp = iwt_sm_sab(ijsm)
    !do iborb=ibsta,ibend
    !  do iaorb=iasta,min(iaend,iborb-1)
    !    iwttmp = iwttmp+1
    !    iwt_orb_dbl(iaorb,iborb) = iwttmp
    !  end do
    !end do

    iwt_sm_sab(ijsm) = iwt_sm_sab(ijsm)+nij
  end do
end do

!isumtmp = 0
!do ismb=1,ng_sm
!  icnttmp = iwt_sm_sab(ismb)
!  iwtsmsabtmp(ismb) = isumtmp
!  isumtmp = isumtmp+icnttmp
!end do
! imap_revorbtoorb_dbl()
!do ismb=1,ng_sm
!  ibsta = ibsm_dbl(ismb)
!  ibend = iesm_dbl(ismb)
!  do isma=1,ismb
!    iasta = ibsm_dbl(isma)
!    iaend = iesm_dbl(isma)
!    if (isma == ismb) iaend = iaend-1
!    ismab = Mul(isma,ismb)
!    iwttmp = iwt_sm_dbl(isma,ismb)+iwtsmsabtmp(ismab)
!    do iaorb=iasta,iaend
!      do iborb=max(iaorb+1,ibsta),ibend
!        iwttmp = iwttmp+1
!        iwt_revorb_dbl(iaorb,iborb) = iwttmp
!        imap_revorbtoorb_dbl(iwttmp) = iwt_orb_dbl(iaorb,iborb)
!      end do
!    end do
!  end do
!end do

!do ism=1,ng_sm
!  jsm = Mul(ism,ns_sm)
!  if (ism < jsm) then
!    itmp = iwt_sm_sab(jsm)
!    iwt_sm_sab(jsm) = iwt_sm_sab(ism)
!    iwt_sm_sab(ism) = itmp
!  end if
!end do
!
!iwt_sm_s_dbl = iwt_sm_sab(ns_sm)
!if (jroute_sys > 2) then
!  iwt_sm_s_dbl = iwt_sm_s_dbl*2
!end if

end subroutine paras_calculate

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_Reorder_RI(Vec,lVec,nVec,iSym)
      Implicit Real*8 (a-h,o-z)
      Real*8 Vec(lVec,nVec)
#include "cholesky.fh"
#include "choorb.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
      iRS2F(i,j)=iWork(ip_iRS2F-1+2*(j-1)+i)

      If (nVec .lt. 1) Return
      If (lVec .lt. 1) Return
      If (lVec.ne.nnBstR(iSym,1) .or. nVec.gt.NumCho(iSym)) Then
         Call SysAbendMsg('Cho_Reorder_RI','Input argument error!',' ')
      End If
      If (nnShl .ne. nnShl_Tot) Then
         Call SysAbendMsg('Cho_Reorder_RI','Screening is not allowed!',
     &                    '(nnShl.ne.nnShl_Tot)')
      End If

C     Set mapping from global address to reduced set.
C     -----------------------------------------------

      liF2RS = nBasT*(nBasT+1)/2
      Call GetMem('CR_RI_F2RS','Allo','Inte',ipiF2RS,liF2RS)
      Call iCopy(liF2RS,[0],0,iWork(ipiF2RS),1)
      Do iRS = 1,nnBstR(iSym,1)
         iRS_tot = iiBstR(iSym,1) + iRS
         na = iRS2F(1,iRS_tot)
         nb = iRS2F(2,iRS_tot)
         nab = iTri(na,nb)
         iWork(ipiF2RS-1+nab) = iRS
      End Do

C     Reorder.
C     --------

      lScr = lVec
      Call GetMem('CR_RI_Scr','Allo','Real',ipScr,lScr)
      Do iVec = 1,nVec

         Call dCopy_(lVec,Vec(1,iVec),1,Work(ipScr),1)
         kFrom = ipScr - 1
         Do iSymb = 1,nSym

            iSyma = MulD2h(iSymb,iSym)

            If (iSyma .gt. iSymb) Then
               Do ib = 1,nBas(iSymb)
                  nb = iBas(iSymb) + ib
                  Do ia = 1,nBas(iSyma)
                     na = iBas(iSyma) + ia
                     nab = iTri(na,nb)
                     iRS = iWork(ipiF2RS-1+nab)
#if defined (_DEBUGPRINT_)
                     If (iRS.lt.1 .or. iRS.gt.nnBstR(iSym,1)) Then
                        Call SysAbendMsg('Cho_Reorder_RI',
     &                                   'Index out of bounds',' ')
                     End If
#endif
                     kFrom = kFrom + 1
                     Vec(iRS,iVec) = Work(kFrom)
                  End Do
               End Do
            Else If (iSyma .eq. iSymb) Then
               Do ia = 1,nBas(iSyma)
                  na = iBas(iSyma) + ia
                  Do ib = 1,ia
                     nb = iBas(iSymb) + ib
                     nab = iTri(na,nb)
                     iRS = iWork(ipiF2RS-1+nab)
#if defined (_DEBUGPRINT_)
                     If (iRS.lt.1 .or. iRS.gt.nnBstR(iSym,1)) Then
                        Call SysAbendMsg('Cho_Reorder_RI',
     &                                   'Index out of bounds',' ')
                     End If
#endif
                     kFrom = kFrom + 1
                     Vec(iRS,iVec) = Work(kFrom)
                  End Do
               End Do
            End If

         End Do

      End Do
      Call GetMem('CR_RI_Scr','Free','Real',ipScr,lScr)

      Call GetMem('CR_RI_F2RS','Free','Inte',ipiF2RS,liF2RS)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRIPK3(  AUTPAK,    APAK,    IWAY,  MATDIM,    NDIM,
     &                      SIGN)
C
C
C.. REFORMATING BETWEEN LOWER TRIANGULAR PACKING
C   AND FULL MATRIX FORM FOR A SYMMETRIC OR ANTI SYMMETRIC MATRIX
C
C   IWAY = 1 : FULL TO PACKED
C              LOWER HALF OF AUTPAK IS STORED IN APAK
C   IWAY = 2 : PACKED TO FULL FORM
C              APAK STORED IN LOWER HALF
C               SIGN * APAK TRANSPOSED IS STORED IN UPPPER PART
C.. NOTE : COLUMN WISE STORAGE SCHEME IS USED FOR PACKED BLOCKS
*
* Some considerations on cache minimization used for IMET = 2 Loop
*
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION AUTPAK(MATDIM,MATDIM),APAK(*)
*. To get rid of annoying and incorrect compiler warnings
      IOFF = 0
      JOFF = 0
*
*. Packing : No problem with cache misses
*
      IF( IWAY .EQ. 1 ) THEN
        IJ = 0
        DO J = 1,NDIM
          DO I = J , NDIM
            APAK(IJ+I) = AUTPAK(I,J)
          END DO
          IJ = IJ +NDIM-J
        END DO
      END IF
*
* Unpacking : cache misses can occur so two routes
*
      IF( IWAY .EQ. 2 ) THEN
*. Use blocked algorithm
      IMET = 2
      IF(IMET.EQ.1) THEN
*. No blocking
        IJ = 0
        DO J = 1,NDIM
          DO I = J,NDIM
           AUTPAK(J,I) = SIGN*APAK(IJ+I)
           AUTPAK(I,J) = APAK(IJ+I)
          END DO
          IJ = IJ + NDIM-J
        END DO
      ELSE IF (IMET .EQ. 2 ) THEN
*. Blocking
        LBLK = 40
        NBLK = MATDIM/LBLK
        IF(LBLK*NBLK.LT.MATDIM) NBLK = NBLK + 1
        DO JBLK = 1, NBLK
          IF(JBLK.EQ.1) THEN
            JOFF = 1
          ELSE
            JOFF = JOFF + LBLK
          END IF
          JEND = MIN(JOFF+LBLK-1,MATDIM)
          DO IBLK = JBLK, NBLK
            IF(IBLK.EQ.JBLK) THEN
              IOFF = JOFF
            ELSE
              IOFF = IOFF + LBLK
            END IF
            IEND = MIN(IOFF+LBLK-1,MATDIM)
              DO J = JOFF,JEND
                IF(IBLK.EQ.JBLK) THEN
                  IOFF2 = J
                ELSE
                  IOFF2 = IOFF
                END IF
                IJOFF = (J-1)*MATDIM-J*(J-1)/2
                DO I = IOFF2,IEND
                  AUTPAK(J,I) = SIGN*APAK(IJOFF+I)
                  AUTPAK(I,J) = APAK(IJOFF+I)
                END DO
              END DO
*. End of loop over I and J
            END DO
          END DO
*. End of loop over blocks of I and J
        END IF
      END IF
*
      NTEST = 0
      IF( NTEST .NE. 0 ) THEN
        WRITE(6,*) ' AUTPAK AND APAK FROM TRIPK3 '
        CALL WRTMAT(AUTPAK,NDIM,MATDIM,NDIM,MATDIM)
        CALL PRSM2(APAK,NDIM)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ERRSET(ierno, inoal, inomes, itrace, iusadr, irange)
C
C     DUMMY SUBROUTINE TO REPLACE THE ERRSET ROUTINE
C     AVAILABLE IN VM FORTRAN.
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_integer(ierno)
         CALL Unused_integer(inoal)
         CALL Unused_integer(inomes)
         CALL Unused_integer(itrace)
         CALL Unused_integer(iusadr)
         CALL Unused_integer(irange)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003, Valera Veryazov                                  *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine EneClc(En1V,En2V,EnerV)
!***********************************************************************
!                                                                      *
! Purpose: Compute one- and two-electron energies                      *
!                                                                      *
! output:                                                              *
!   En1V    : one-electron energy (variational)                        *
!   En2V    : two-electron energy (variational)                        *
!   EnerV   : En1V + En2V + PotNuc                                     *
!                                                                      *
!***********************************************************************

#ifdef _FDE_
use Embedding_Global, only: Eemb, embInt, embPot
#endif
use OFembed, only: Do_OFemb, Rep_EN
use InfSCF, only: Dens, EDFT, ELst, ipsLst, Iter, KSDFT, nBT, nD, nOcc, nSym, OneHam, PotNuc, TimFld, TwoHam
use Constants, only: Zero, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(out) :: En1V, En2V, EnerV
integer(kind=iwp) :: nElec
real(kind=wp) :: CPU1, CPU2, E_DFT, En1V_AB, En2V_AB, Tim1, Tim2, Tim3
real(kind=wp), external :: DDot_

!----------------------------------------------------------------------*
! Start                                                                *
!----------------------------------------------------------------------*
call Timing(Cpu1,Tim1,Tim2,Tim3)

! Allocate memory for full Dens and TwoHam

! set to Zero for RHF
En1V_ab = Zero
En2V_ab = Zero

En1V = DDot_(nBT,OneHam,1,Dens(1,1,iPsLst),1)
if (nD == 2) En1V_ab = DDot_(nBT,OneHam,1,Dens(1,2,iPsLst),1)

E_DFT = EDFT(iter)

#ifdef _FDE_
! Embedding
if (embPot) Eemb = DDot_(nBT*nD,embInt,1,Dens(1,1,iPsLst),1)
#endif

! If just one electron make sure that the two-electron energy is zero.

if (nD == 1) then
  nElec = 2*sum(nOcc(1:nSym,1))
else
  nElec = sum(nOcc(1:nSym,1:2))
end if
En2V = Zero
if ((nElec > 1) .or. (KSDFT /= 'SCF')) then
  En2V = DDot_(nBT,TwoHam(1,1,iPsLst),1,Dens(1,1,iPsLst),1)
  if (nD == 2) En2V_ab = DDot_(nBT,TwoHam(1,2,iPsLst),1,Dens(1,2,iPsLst),1)
end if

if (Do_OFemb) then
  if (nD == 2) then ! equipartition
    En2V = En2V-Half*Rep_EN
    En2V_ab = En2V_ab-Half*Rep_EN
  else
    En2V = En2V-Rep_EN
  end if
end if

! Note that the DFT energy cannot be computed as a trace.

#ifdef _DEBUGPRINT_
if (nD == 2) then
  write(u6,*) 'EnerClc:',En1V,En2V,PotNuc,E_DFT
  write(u6,*) 'EnerClc:',En1V_ab,En2V_ab
else
  write(u6,*) 'EnerClc:',En1V,En2V,PotNuc,E_DFT
end if
#endif
if (nD == 2) then
  Elst(iter,1) = En1V+Half*En2V+Half*PotNuc+Half*E_DFT
  Elst(iter,2) = En1V_ab+Half*En2V_ab+Half*PotNuc+Half*E_DFT
else
  Elst(iter,1) = En1V+Half*En2V+PotNuc+E_DFT
end if

if (nD == 1) then
  En2V = Half*En2V
else
  En2V = Half*(En2V+En2V_ab)
end if
En1V = (En1V+En1V_ab)+E_DFT
EnerV = En1V+En2V+PotNuc
#ifdef _DEBUGPRINT_
write(u6,*) 'EneClc: Ene=',En1V,En1V_ab,En2V,EnerV
#endif
call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(14) = TimFld(14)+(Cpu2-Cpu1)
!----------------------------------------------------------------------*
! Exit                                                                 *
!----------------------------------------------------------------------*
return

end subroutine EneClc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CleanSheet(nShell_Valence,nShell_Auxiliary)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Get a fresh start with Seward.
C
      Implicit None
      Integer nShell_Valence, nShell_Auxiliary
#include "status.fh"

      Logical Verbose, Free_K2
      Logical Indexation, DoFock, DoGrad
      Integer nShell_Tot
      Real*8  ThrAO

      Call Free_iSD()
      ! Essentially close seward
      Verbose=.False.
      Free_K2=.True.
      Call Term_Ints(Verbose,Free_K2)
      Call Free_iSD()

      ! Get number of valence shells
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
      Indexation=.False.
      ThrAO=0.0d0
      DoFock=.False.
      DoGrad=.False.
      Call Setup_Ints(nShell_Valence,Indexation,ThrAO,DoFock,DoGrad)
      Verbose=.False.
      Free_K2=.True.
      Call Term_Ints(Verbose,Free_K2)
      Call Free_iSD()

      ! Set up seward for val+aux shells w. indexation
      Call Set_Basis_Mode('WithAuxiliary')
      Call Setup_iSD()
      Indexation=.True.
      ThrAO=0.0d0
      DoFock=.False.
      DoGrad=.False.
      Call Setup_Ints(nShell_Tot,Indexation,ThrAO,DoFock,DoGrad)

      ! Get number of auxiliary shells
      nShell_Auxiliary=nShell_Tot-1-nShell_Valence

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SortCoefficients(StorageMode,AB,n,M,C)
C
C     Thomas Bondo Pedersen, September 2012.
C
C     Sort coefficients according to storage mode.
C       StorageMode=0: shell-pair blocks [nothing done]
C                  =1: canonical
C                  anything else is an error.
C
C     Can of course be used for 3-index integrals as well.
C
      Implicit None
      Integer StorageMode
      Integer AB
      Integer n, M
      Real*8  C(n,M)
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

      Character*20 SecNam
      Parameter (SecNam='LDF_SortCoefficients')
      Character*53 text ! length=len(SecNam)+33

      Integer  LDF_nShell_Atom
      External LDF_nShell_Atom
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomPairInfoIsSet
      External LDF_AtomPairInfoIsSet
      Integer  LDF_AtomPair_DiagDim, LDF_nBasAux_Pair
      Integer  LDF_nBasAux_Pair_wLD
      External LDF_AtomPair_DiagDim, LDF_nBasAux_Pair
      External LDF_nBasAux_Pair_wLD
#endif

      Logical OffsetDefined

      Integer A, B
      Integer nSA, nSB
      Integer ip_iOff, l_iOff
      Integer ip_Scr, l_Scr
      Integer K

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Check StorageMode
      If (StorageMode.eq.0) Then
         Return
      Else If (StorageMode.ne.1) Then
         Write(text,'(A,A,I4,A)') SecNam,': StorageMode',StorageMode,
     &                          ' not implemented'
         Call WarningMessage(2,text)
         Call LDF_Quit(1)
      End If

#if defined (_DEBUGPRINT_)
      ! Check
      If (.not.LDF_AtomPairInfoIsSet()) Then
         Call WarningMessage(2,SecNam//': atom pair info not set')
         Call LDF_Quit(1)
      End If
      If (AB.lt.1 .or. AB.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,SecNam//': AB out of bounds')
         Call LDF_Quit(1)
      End If
      If (n.ne.LDF_AtomPair_DiagDim(AB)) Then
         Call WarningMessage(2,
     &                     SecNam//': C array not properly dimensioned')
         Call LDF_Quit(1)
      End If
      If (M.ne.LDF_nBasAux_Pair(AB) .and. M.ne.LDF_nBasAux_Pair_wLD(AB))
     & Then
         Call WarningMessage(0,
     &              SecNam//': C array may not be properly dimensioned')
      End If
#endif

      ! Get atoms of atom pair AB
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)

      ! Allocate shell-pair offset array
      nSA=LDF_nShell_Atom(A)
      nSB=LDF_nShell_Atom(B)
      l_iOff=nSA*nSB
      Call GetMem('SrtOff','Allo','Inte',ip_iOff,l_iOff)
      OffsetDefined=.False.

      ! Allocate scratch array
      l_Scr=n
      Call GetMem('SrtScr','Allo','Real',ip_Scr,l_Scr)

      ! Sort
      Do K=1,M
         Call LDF_SortCanonical(AB,l_Scr,Work(ip_Scr),
     &                          OffsetDefined,
     &                          nSA,nSB,iWork(ip_iOff),
     &                          n,C(1,K))
      End Do

      ! Deallocations
      Call GetMem('SrtScr','Free','Real',ip_Scr,l_Scr)
      Call GetMem('SrtOff','Free','Inte',ip_iOff,l_iOff)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine ALFas(NDP,YMIN,YH,NCN,V,SWF,VLIM,KVMAX,AFLAG,EPS,GV,BFCT,INNODE,INNR,IWR)
!***********************************************************************
!** The subroutine ALF (Automatic vibrational Level Finder) will
!   automatically generate the eigenvalues from the first vibrational
!   level (v=0) to a user specified level (v=KVMAX) or the highest
!   allowed vibrational level of a given smooth single (or double)
!   minimum potential (V). These energies are stored and returned to the
!   calling program in the molecular constants array GV(v=0-KVMAX).
!** For any errors that cannot be resolved within the subroutine, ALF
!   returns AFLAG with a value that defines which error had occured.
!** Uses the Schrodinger solver subroutine SCHRQas.
!
!** On entry:
!    NDP   is the number of datapoints used for the potential.
!    YMIN  is the innermost dimensionless radial distance
!    YH    is the dimensionless radial meshvalue
!    NCN   is the (integer) inverse power defining the linmiting attractive
!          long-range behaviour of the potential.  For a barrier, set NCN=99
!    V(i)  is the scaled input potential in 'AS' units
!    VLIM  is the potential asymptote (cm-1).
!    KVMAX is v for the highest vibrational level we wish to find.
!    AFLAG is rot.quantum J for the (centrifugally distorted) potential
!    EPS   is the energy convergence criterion (cm-1).
!    BFCT  it the internal unit scaling factor (2*mu/hbar^2)*RH^2.
!    INNODE specifies whether wave fx. initiation @ RMIN starts with a
!        note (normal case: INNODE > 0) or zero slope (when INNODE <= 0)
!    IWR    specifies the level of printing inside SCHRQ
!           /= 0 : print error & warning descriptions.
!           >= 1 : also print final eigenvalues & node count.
!           >= 2 : also show end-of-range wave function amplitudes.
!           >= 3 : print also intermediate trial eigenvalues, etc.
!
!** On exit:
!    KVMAX   is vib.quantum number for the highest vibrational level
!            found (may be less than the input value of KVMAX).
!    AFLAG   returns calculation outcome to calling program.
!            >=  0 : found all levels to v=KVMAX{input} & AFLAG= J
!             = -1 : KVMAX larger than number of levels found.
!    GV(v)   contains the vibrational energy levels found for v=0-KVMAX
!    INNR(v) labels each level as belonging to the inner (INNR = 1) or
!            outer (INNR = 0) well.
!
!** Flags: Modify only when debugging.
!    AWO   specifies the level of printing inside ALF
!          /= 0 : print error & warning descriptions.
!          >  0 : also print intermediate ALF messages.
!    INNER specifies wave function matching (& initiation) conditions.
!         <= 0 : Match inward & outward solutions at outermost well t.p.
!          > 0 : Match at innermost well inner turning point
!        For most normal cases set INNER = 0,  but ......
!            To find "inner-well-dominated" solutions of an asymmetric
!            double minimum potential, set  INNER > 0.
!    LPRWF specifies option of printing out generated wavefunction
!          > 0 : print wave function every LPRWF-th  point.
!          < 0 : compactly write to channel-7 every |LPRWF|-th wave
!                function value.
!          A lead "card" identifies the level, gives the position of
!          1-st point and radial mesh, & states No. of  points.
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!** The dimensioning parameters must be consistant with the sizes of the
!   arrays used in the calling program.
!
!    NVIBMX  is the maximum number of vibrational levels considered.
!            Note: NVIBMX should be larger than KVMAX.

use LEVEL_COMMON, only: SDRDY, VBZ, YVB
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), parameter :: AWO = 1, LPRWF = 0, NVIBMX = 400
integer(kind=iwp), intent(in) :: NDP, NCN, INNODE, IWR
real(kind=wp), intent(in) :: YMIN, YH, V(NDP), VLIM, EPS, BFCT
integer(kind=iwp), intent(inout) :: KVMAX, AFLAG
real(kind=wp), intent(out) :: SWF(NDP), GV(0:KVMAX)
integer(kind=iwp), intent(out) :: INNR(0:NVIBMX)
! NF counts levels found in automatic search option
integer(kind=iwp) :: I, ICOR, INNER, IPMIN, IPMINN, JROT, KV, LTRY, NBEG, NEND, NF, NPMAX, NPMIN
real(kind=wp) :: BMAX, DGDV2, EO, ESAV, GAMA, PMAX, VMAX, VME1, VME2, VME3, VMIN, VPMAX(10), VPMIN(10), YPMAX(10), YPMIN(10), ZPEHO
logical(kind=iwp) :: DoIt, NOMAX
!integer(kind=iwp) :: NBEGG(0:NVIBMX), NENDD(0:NVIBMX)
!real(kind=wp) :: RE, YMAX

ipminn = 0
! OPTIONALLY WRITE THESE VARIABLES WHEN DEBUGGING:
!write(u6,*) ''
!write(u6,*) 'NPP=',NDP
!write(u6,*) 'YMIN=',YMIN
!write(u6,*) 'YH=',YH
!write(u6,*) 'NCN1=',NCN
!do I=1,3
!  write(u6,*) 'RVB=',RVB(I)
!  write(u6,*) 'VJ=',V(I)
!  write(u6,*) 'WF1=',SWF(I)
!  write(u6,*) 'GV=',GV(I)
!  write(u6,*) 'INNR=',INNR(I)
!end do
!write(u6,*) 'VLIM1=',VLIM
!write(u6,*) 'VMAX=',KVMAX
!write(u6,*) 'AFLAG=',AFLAG
!
!write(u6,*) 'EPS=',EPS
!write(u6,*) 'BFCT=',BFCT
!write(u6,*) 'INNOD1=',INNODE
!write(u6,*) 'IWR=',IWR
!write(u6,*) ''
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! Check that the array dimensions are adequate.
if (KVMAX > NVIBMX) then
  write(u6,602) KVMAX,NVIBMX
  !stop
  call ABEND()
end if

! Initialize remaining variables and flags. NF is label of level being sought
NF = 0
!KVB = -1
KV = 0
INNER = 0
LTRY = 0
! Initialize level counters for each well.
INNR(0:KVMAX) = -1
! Store input rotational quantum number.
JROT = AFLAG
AFLAG = -1

! YMAX is the outer radial distance over which potential is defined.
!YMAX = YMIN+real(NDP-1,kind=wp)*YH
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! Locate the potential minima.
NPMIN = 0
IPMIN = 2
VMIN = 1.0e99_wp
VME2 = VBZ(2)
VME3 = VBZ(3)
do I=4,NDP-1
  VME1 = VME2
  VME2 = VME3
  VME3 = VBZ(I)
  if ((VME2 < VME1) .and. (VME2 < VME3)) then
    NPMIN = NPMIN+1
    YPMIN(NPMIN) = YVB(I)
    VPMIN(NPMIN) = VME2/BFCT
    if (NPMIN == 1) IPMIN = I
    if (VPMIN(NPMIN) < VMIN) then
      !RE = YPMIN(NPMIN)
      VMIN = VPMIN(NPMIN)
      IPMINN = I
    end if
    if (NPMIN == 10) exit
  end if
end do
if (NPMIN == 0) then
  if (V(2) <= V(1)) then
    ! If NO minimum & potential has negative slope, print a warning and stop.
    write(u6,608) JROT
    KVMAX = -1
    return
  end if
  !...  but if potl. alway has positive slope, mesh point #1 is minimum
  NPMIN = 1
  IPMIN = 1
  YPMIN(NPMIN) = YVB(1)
  !RE = YVB(1)
  VPMIN(NPMIN) = VBZ(1)
  VMIN = YPMIN(NPMIN)
  write(u6,618) VPMIN(1),YMIN
  !write(u6,*) 'Stuff about minima but error'
end if
! Locate any potential maxima (if they exist).
NPMAX = 0
VMAX = -9.0e99_wp
VME2 = VBZ(IPMIN)
VME3 = VBZ(IPMIN+1)
do I=IPMIN+2,NDP-1
  VME1 = VME2
  VME2 = VME3
  VME3 = VBZ(I)
  if ((VME2 > VME1) .and. (VME2 > VME3)) then
    NPMAX = NPMAX+1
    YPMAX(NPMAX) = YVB(I)
    VPMAX(NPMAX) = VME2/BFCT
    if (VPMAX(NPMAX) > VMAX) VMAX = VPMAX(NPMAX)
    if (NPMAX == 10) exit
  end if
end do
NOMAX = (NPMAX == 0)
if (NPMAX > 0) then
  if (YPMAX(NPMAX) < YPMIN(NPMIN)) NOMAX = .true.
end if
if (NOMAX) then
  ! If no maxima found or there is no barrier past outermost minimum,
  ! set an energy maximum to be the value at the end of the radial range.
  NPMAX = NPMAX+1
  YPMAX(NPMAX) = YVB(NDP-1)
  !?? should this limit be set at  VLIM ??
  VPMAX(NPMAX) = VBZ(NDP-1)/BFCT
  if (VPMAX(NPMAX) > VMAX) VMAX = VPMAX(NPMAX)
end if

! If innermost maximum lies inside innermost minimum, the potential
! turns over in short range region OR have a minimim at mesh point #1:
! PRINT a Warning
if (YPMAX(1) < YPMIN(1)) write(u6,610) YPMAX(1)

! Otherwise, print out potential extrema count
if (NPMIN > 0) then
  !write(u6,*) 'Stuff about minima but gives error'
  !write(u6,614) NPMIN,(VPMIN(I),I= 1,NPMIN)
  !write(u6,616) (YPMIN(I),I=1,NPMIN)
  !write(u6,*) 'Stuff about maximum but gives error'
  !write(u6,618) NPMAX,(VPMAX(I),I=1,NPMAX)
  !write(u6,616) (YPMAX(I),I=1,NPMAX)
  if (NPMIN > 2) then
    ! If potential has more than two minima - print warning & stop
    write(u6,620)
    !stop
  end if
end if
!** Set BMAX as barrier height of double-minimum potential
BMAX = -9.0e9_wp
if (NPMIN > 1) then
  do I=1,NPMAX
    if ((YPMAX(I) > YPMIN(1)) .and. (YPMAX(I) < YPMIN(2))) BMAX = VPMAX(I)
  end do
end if
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!*** Use harmonic approximation to estimate zero point energy.
ZPEHO = sqrt((VBZ(IPMINN+20)-VBZ(IPMINN))/400.0_wp)/BFCT
EO = VMIN+ZPEHO
write(u6,*) ''
write(u6,634) BFCT
!write(u6,*) 'IPMINN:                                 ',IPMINN
!write(u6,*) 'VBZ(1):                                 ',VBZ(1)
!write(u6,*) 'VBZ(IPMINN):                            ',VBZ(IPMINN)
!write(u6,*) 'VBZ(IPMINN+20)',VBZ(IPMINN+20)
write(u6,632) ZPEHO
write(u6,*) 'Trial energy obtained from harmonic oscillator:  ',EO

!=========== Begin Actual Eigenvalue Calculation Loop Here =============
! Compute eigenvalues ... etc. up to the KVMAX'th vibrational level.
! When attempts to find the next eigenvalue fails, then perhaps the
! next level is located in a second (inner) well. If so, then the
! subroutine will set INNER = 1, and attempt to find that level.

ICOR = 0
DoIt = .true.
do
  if (DoIt) then
    !KVBB = KVB
    !KVB = KV
    KV = NF
  else
    DoIt = .true.
  end if
  ESAV = EO
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ! Call subroutine SCHRQ to find eigenvalue EO and eigenfunction SWF(I).
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ! OPTIONALLY WRITE THESE VARIABLES WHEN DEBUGGING:
  write(u6,*) ''
  write(u6,*) 'Exiting alfas'
  write(u6,*) 'Entering schrqas'
  !write(u6,*) 'Entering schrqas with the following parameters:'
  !write(u6,*) ''
  !write(u6,*) 'KV=',KV
  !write(u6,*) 'JROT=',JROT
  !write(u6,*) 'EO=',EO
  !write(u6,*) 'GAMA=',GAMA
  !write(u6,*) 'VMAX=',PMAX
  !write(u6,*) 'VLIM=',VLIM
  !do I=1,3
  !  write(u6,*) 'V=',V(I)
  !  write(u6,*) 'WF=',SWF(I)
  !end do
  !write(u6,*) 'BFCT=',BFCT
  !write(u6,*) 'EEPS=',EPS
  !write(u6,*) 'YMIN=',YMIN
  !write(u6,*) 'YH=',YH
  !write(u6,*) 'NPP=',NDP
  !write(u6,*) 'NBEG=',NBEG
  !write(u6,*) 'NEND=',NEND
  !write(u6,*) 'INNODE=',INNODE
  !write(u6,*) 'INNER=',INNER
  !write(u6,*) 'IWR=',IWR
  !write(u6,*) 'LPRWF=',LPRWF
  write(u6,*) ''
  call SCHRQas(KV,JROT,EO,GAMA,PMAX,VLIM,V,SWF,BFCT,EPS,YMIN,YH,NDP,NBEG,NEND,INNODE,INNER,IWR,LPRWF)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  if (KV < 0) then
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    ! The SCHRQ error condition is KV < 0.  Allow for 3 cases:
    !   EO > VMAX : energy from previous trial above potential maximum
    !   NF = 0 : Looking for the first vibrational level (v = 0)
    !   NF > 0 : Looking for the other vibrational levels (v > 0)
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    if (EO > VMAX) then
      ! For the case when the previous trial gave energy above the potential
      ! maximum, make one last ditch attempt to find the highest bound level
      ! (quasi or otherwise) in the potential.
      if (LTRY < 1) then
        LTRY = 1
        KV = 999
        EO = VMAX-1.0e-4_wp
        DoIt = .false.
        cycle
      else
        !... if that was unsuccessful, then print out a warning and exit.
        write(u6,622) NF,EO,VMAX
        KV = NF-1
        exit
      end if
    end if
    write(u6,624) NF,JROT,ESAV
    !.. eigenvalue of -9.9e9 signifies that eigenvalue search failed completely
    KVMAX = NF-1
    EO = -9.9e9_wp
    return
  end if
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ! If calculated vibrational level is the desired level, NF, then ...
  ! call SCECOR to calculate dG/dv and predict next higher level
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  if (KV == NF) then
    !NBEGG(KV) = NBEG
    !NENDD(KV) = NEND
    GV(NF) = EO
    INNR(NF) = INNER
    do
      NF = NF+1
      if (NF <= KVMAX) then
        if (INNR(NF) <= 0) exit
      else
        !... if the next level was found earlier in overshoot ...
        if (AWO > 0) write(u6,626) JROT,KVMAX
        AFLAG = JROT
        return
      end if
    end do
    ICOR = 0
    call SCECORas(KV,NF,JROT,INNER,ICOR,IWR,EO,YH,BFCT,NDP,NCN,VBZ,SDRDY,BMAX,VLIM,DGDV2)
    if (EO > VPMAX(NPMAX)) then
      !... if estimated energy above highest barrier, set value below it
      EO = VPMAX(NPMAX)-0.05_wp*DGDV2
      ICOR = 20
    end if
    LTRY = 0
    KV = NF
  else
    ! If last level found is not the desired one ...
    if (INNR(KV) == -1) then
      !... Record vibrational level (if haven't already) for posterity.
      GV(KV) = EO
      INNR(KV) = INNER
    end if
    ICOR = ICOR+1
    if (ICOR <= 20) then
      !... Call subroutine using semiclassical methods to estimate correct energy
      call SCECORas(KV,NF,JROT,INNER,ICOR,IWR,EO,YH,BFCT,NDP,NCN,VBZ,SDRDY,BMAX,VLIM,DGDV2)
      if (EO > VPMAX(NPMAX)) then
        !... if estimated energy above highest barrier, set value below it
        KV = 999
        EO = VPMAX(NPMAX)-0.05_wp*DGDV2
      end if
    else
      ! If the calculated wavefunction is still for the wrong vibrational
      ! level, then write out a warning return
      write(u6,628) NF,JROT
      KVMAX = NF-1
      exit
    end if
  end if
end do
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! If unable to find all KVMAX+1 levels requested, then return KVMAX as
! v for the highest vibrational level actually found, and print out the
! the energy of that level.
if ((AFLAG < 0) .and. (AWO /= 0)) write(u6,630) KVMAX,GV(KVMAX)

return

602 format(/'  *** ALF ERROR ***'/4X,'Number of vib levels requested=',i4,' exceeds internal ALF array dimension  NVIBMX=',i4)
!604 format(/' *** ALF ERROR ***   Find NO potential minima for   J=',i4)
!606 format(/'  ALF  finds onee potential minimum of',ES15.7,'  at  R(1)=',f9.6)
608 format(/'  *** ALF ERROR ***   Unable to find a potential minimum for   J=',i4)
610 format(/'  *** ALF CAUTION ***'/4X,'The potential turns over in the short range region at  y= ',G15.8)
!614 format(' Find',F3.5,'  potential minima:   Vmin=',8F11.3)
!616 format(19x,'located at   y =',8f11.5)
618 format(' Find',I3,'  potential maxima:   Vmax=',8F11.3)
620 format(' *** So  STOP !!!!')
622 format(/' ALF search finds next estimated trial energy  E(v=',I3,')=',G15.8/8X, &
           'lies above potential maximum or asymptote at  VMAX=',G15.8)
624 format(/' *** SCHRQ FAILS in ALF when searching for  v=',i3,' J=',i3,'   with   EO=',f9.3/5x, &
           'Check range and/or contact Nike Dattani [nike@hpqc.org,ndattani@uwaterloo.ca]')
626 format(/' ALF successfully finds all (J=',i3,') vibrational levels up to   v= KVMAX=',I3)
628 format(4x,'ALF fails to find level   v=',i3,', J=',i3)
630 format(' Highest calculated level found by ALF is   E(v=',I3,')=',ES17.9/)
632 format(' Zero point energy (measured from VLIM) approximated using a harmonic osccilator:        ',8F11.3)
634 format(' Mult. V(R) by this factor (BFCT) for solving the SE in dimensionless units: ',ES20.13)

end subroutine ALFas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SOEIG(PROP,USOR,USOI,ENSOR,NSS,ENERGY)
      !> module dependencies
      use rassi_global_arrays, only: JBNUM
      use sorting, only : argsort
      use sorting_funcs, only : leq_r
#ifdef _HDF5_
      use Dens2HDF5
      use mh5, only: mh5_put_dset
#endif
#ifdef _DMRG_
      use rasscf_data, only: doDMRG
      use qcmaquis_interface_cfg
#endif
      IMPLICIT NONE
#include "prgm.fh"
#include "SysDef.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "rassi.fh"
#include "symmul.fh"
#include "Files.fh"
#include "WrkSpc.fh"
#include "constants.fh"
#include "stdalloc.fh"
#include "rassiwfn.fh"

      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='SOEIG')

      INTEGER NSS
      REAL*8 USOR(NSS,NSS),USOI(NSS,NSS),ENSOR(NSS)
      REAL*8 PROP(NSTATE,NSTATE,NPROP),ENERGY(NSTATE)

      INTEGER I,N
      INTEGER ITOL,IDX
      INTEGER JOB
      INTEGER IPROP
      INTEGER IAMFIX,IAMFIY,IAMFIZ,IAMX,IAMY,IAMZ
      INTEGER ISS,JSS,IJSS,ISTATE,JSTATE
      INTEGER LHTOTI,LHTOTR
      INTEGER LJ2I,LJ2R,LJXI,LJXR,LJYI,LJYR,LJZI,LJZR,LLXI,LLYI,LLZI
      INTEGER LMAPMS,LMAPSP,LMAPST,LOMGI,LOMGR
      INTEGER MAGN
      INTEGER MPLET,MPLET1,MPLET2,MSPROJ,MSPROJ1,MSPROJ2

      REAL*8 AU2EV,AU2CM
      REAL*8 AMFIX,AMFIY,AMFIZ
      REAL*8 CG0,CGM,CGP,CGX,CGY
      REAL*8 E,E0,E1,E2,E3,E_TMP,FACT,FRAC,EI,EPSH,EPSS,ERMS,V2SUM
      REAL*8 HSOI,HSOR,HSOTOT
      REAL*8 OMEGA
      REAL*8 S1,S2,SM1,SM2
      REAL*8 SOTHR_MIN
      REAL*8 X,X_THR,XJEFF
      REAL*8, ALLOCATABLE :: ESO(:), HAMSOR(:,:), HAMSOI(:,:)
#ifdef _DMRG_
      complex*16, allocatable :: hso_tmp(:,:)
      complex*16, allocatable :: ccwork(:)
      real*8    , allocatable :: rwork(:)
      integer                 :: lcwork, info
#endif
      Integer, Allocatable :: IndexE(:)

      REAL*8, EXTERNAL :: DCLEBS

      Logical lOMG, lJ2
      Integer  cho_x_gettol
      External cho_x_gettol
      LOGICAL :: debug_dmrg_rassi_code = .false.




C CONSTANTS:
      AU2EV=CONV_AU_TO_EV_
      AU2CM=CONV_AU_TO_CM1_
      lOMG=.False.
      lJ2 =.False.

C Identify AMFI and ANGMOM matrix elements:
      IAMFIX=0
      IAMFIY=0
      IAMFIZ=0
      DO IPROP=1,NPROP
       IF(PNAME(IPROP)(1:4).EQ.'AMFI') THEN
         IF(ICOMP(IPROP).EQ.1) IAMFIX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMFIY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMFIZ=IPROP
       ELSE IF(PNAME(IPROP)(1:6).EQ.'ANGMOM') THEN
         IF(ICOMP(IPROP).EQ.1) IAMX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMZ=IPROP
       END IF
      END DO

C Mapping from spin states to spin-free state and to spin:
      CALL GETMEM('MAPST','ALLO','INTE',LMAPST,NSS)
      CALL GETMEM('MAPSP','ALLO','INTE',LMAPSP,NSS)
      CALL GETMEM('MAPMS','ALLO','INTE',LMAPMS,NSS)
      ISS=0
      DO ISTATE=1,NSTATE
       JOB=JBNUM(ISTATE)
       MPLET=MLTPLT(JOB)
       DO MSPROJ=-MPLET+1,MPLET-1,2
        ISS=ISS+1
        IWORK(LMAPST-1+ISS)=ISTATE
        IWORK(LMAPSP-1+ISS)=MPLET
        IWORK(LMAPMS-1+ISS)=MSPROJ
       END DO
      END DO
C Complex hamiltonian matrix elements over spin states:
      CALL GETMEM('HTOTR','ALLO','REAL',LHTOTR,NSS**2)
      CALL GETMEM('HTOTI','ALLO','REAL',LHTOTI,NSS**2)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LHTOTR),1)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LHTOTI),1)

      IF(IPGLOB.GE.TERSE) THEN
       WRITE(6,*)
       WRITE(6,*)
       WRITE(6,*)
       WRITE(6,'(6X,100A1)') ('*',i=1,100)
       WRITE(6,'(6X,A,98X,A)') '*','*'
       WRITE(6,'(6X,A,34X,A,34X,A)')
     &      '*','       Spin-orbit section     ','*'
       WRITE(6,'(6X,A,98X,A)') '*','*'
       WRITE(6,'(6X,100A1)') ('*',i=1,100)
       WRITE(6,*)
      ENDIF

      if(debug_dmrg_rassi_code)then
        write(6,*) 'BLUBB BLUBB debug print of property matrix'
        do istate = 1, nstate
        do jstate = 1, nstate
        DO IPROP=1,NPROP
          if(abs(prop(istate,jstate,iprop)) > 1.0d-14)
     &    write(6,*) 'prop(',istate,',',jstate,',',iprop,') = ',
     &                prop(istate,jstate,iprop)
        end do
        end do
        end do
      end if

      DO ISS=1,NSS
        ISTATE=IWORK(LMAPST-1+ISS)
        MPLET1=IWORK(LMAPSP-1+ISS)
        MSPROJ1=IWORK(LMAPMS-1+ISS)
        S1=0.5D0*DBLE(MPLET1-1)
        SM1=0.5D0*DBLE(MSPROJ1)
        DO JSS=1,NSS
          JSTATE=IWORK(LMAPST-1+JSS)
          MPLET2=IWORK(LMAPSP-1+JSS)
          MSPROJ2=IWORK(LMAPMS-1+JSS)
          S2=0.5D0*DBLE(MPLET2-1)
          SM2=0.5D0*DBLE(MSPROJ2)
          AMFIX=0.0D0
          IF(IAMFIX.NE.0) AMFIX=PROP(ISTATE,JSTATE,IAMFIX)
          AMFIY=0.0D0
          IF(IAMFIY.NE.0) AMFIY=PROP(ISTATE,JSTATE,IAMFIY)
          AMFIZ=0.0D0
          IF(IAMFIZ.NE.0) AMFIZ=PROP(ISTATE,JSTATE,IAMFIZ)
* PAM07          HSCAL=0.0D0
* PAM07          IF(ISS.EQ.JSS) HSCAL=ENERGY(ISTATE)
          IJSS=ISS+NSS*(JSS-1)
C WIGNER-ECKART THEOREM:
          FACT=1.0D0/SQRT(DBLE(MPLET1))
          IF(MPLET1.EQ.MPLET2-2) FACT=-FACT
          CGM=FACT*DCLEBS(S2,1.0D0,S1,SM2,-1.0D0,SM1)
          CG0=FACT*DCLEBS(S2,1.0D0,S1,SM2, 0.0D0,SM1)
          CGP=FACT*DCLEBS(S2,1.0D0,S1,SM2,+1.0D0,SM1)
          CGX= SQRT(0.5D0)*(CGM-CGP)
          CGY=-SQRT(0.5D0)*(CGM+CGP)
C SPIN-ORBIT HAMILTONIAN MATRIX ELEMENTS:
          HSOR=CGY*AMFIY
          HSOI=CGX*AMFIX+CG0*AMFIZ
* PAM07: Delay addition of diagonal scalar part until later, see below:
*          WORK(LHTOTR-1+IJSS)=HSCAL+HSOR
          WORK(LHTOTR-1+IJSS)=HSOR
          WORK(LHTOTI-1+IJSS)=HSOI

        END DO
      END DO

* VKochetov 2021 put SOC matrix elements to hdf5:
#ifdef _HDF5_
      if (rhodyn) then
        call mh5_put_dset(wfn_sos_vsor, work(LHTOTR))
        call mh5_put_dset(wfn_sos_vsoi, work(LHTOTI))
      endif
#endif

* Perhaps write out large spin-orbit coupling elements:
      IF(NSOTHR_PRT.GT.0) THEN
* Prevent infinite loop below:
       SOTHR_MIN=MAX(SOTHR_PRT,1.0D-6)
* And work with quantities larger than 1:
       X_THR=SOTHR_PRT/SOTHR_MIN
  13   CONTINUE
       N=0
       DO ISS=1,NSS
        DO JSS=1,ISS
         IJSS=ISS+NSS*(JSS-1)
         HSOR=WORK(LHTOTR-1+IJSS)
         HSOI=WORK(LHTOTI-1+IJSS)
         HSOTOT=SQRT(HSOR**2+HSOI**2)
         IF(HSOTOT*AU2CM.GT.SOTHR_PRT) N=N+1
        END DO
       END DO
       IF(N.LE.NSOTHR_PRT) GOTO 17
       X_THR=X_THR*1.2D0
       MAGN=INT(LOG10(X_THR))
       X=X_THR/DBLE(10**MAGN)
       X_THR=0.1D0*DBLE(NINT(10.0D0*X))*DBLE(10**(MAGN))
       SOTHR_PRT=X_THR*SOTHR_MIN
       GOTO 13

  17   CONTINUE

       IF (N.GT.0) THEN
       WRITE(6,*)
       WRITE(6,*)'Complex SO-Hamiltonian matrix elements over'
       WRITE(6,*)'spin components of spin-free eigenstates (SFS):'
       WRITE(6,'(1x,A,F10.3,A)')
     &              '(In cm-1. Print threshold: ',SOTHR_PRT,' cm-1)'
       WRITE(6,'(1X,10A7)')('-------',I=1,10)
       WRITE(6,*)
         WRITE(6,'(A)')'  I1  S1  MS1    I2  S2  MS2 '//
     &            '   Real part    Imag part      Absolute'
       DO  ISS=1,NSS
        ISTATE=IWORK(LMAPST-1+ISS)
        MPLET1=IWORK(LMAPSP-1+ISS)
        MSPROJ1=IWORK(LMAPMS-1+ISS)
        S1=0.5D0*DBLE(MPLET1-1)
        SM1=0.5D0*DBLE(MSPROJ1)
        DO JSS=1,ISS
         IJSS=ISS+NSS*(JSS-1)
         HSOR=WORK(LHTOTR-1+IJSS)
         HSOI=WORK(LHTOTI-1+IJSS)
         HSOTOT=SQRT(HSOR**2+HSOI**2)
         IF(HSOTOT*AU2CM.GE.SOTHR_PRT) THEN
          JSTATE=IWORK(LMAPST-1+JSS)
          MPLET2=IWORK(LMAPSP-1+JSS)
          MSPROJ2=IWORK(LMAPMS-1+JSS)
          S2=0.5D0*DBLE(MPLET2-1)
          SM2=0.5D0*DBLE(MSPROJ2)
         WRITE(6,'(1X,I5,F5.1,F5.1,I5,F5.1,F5.1,3F14.3)') ISS,S1,SM1,
     &         JSS,S2,SM2,HSOR*AU2CM,HSOI*AU2CM,HSOTOT*AU2CM
         END IF
        END DO
       END DO
       WRITE(6,'(1X,10A7)')('-------',I=1,10)

       END IF
      ENDIF

* PAM07: Addition of scalar diagonal part was delayed until here, see above.
      DO ISS=1,NSS
        ISTATE=IWORK(LMAPST-1+ISS)
        IJSS=ISS+NSS*(ISS-1)
        HSOR=WORK(LHTOTR-1+IJSS)
        WORK(LHTOTR-1+IJSS)=HSOR+ENERGY(ISTATE)
      END DO


      IF(IPGLOB.GE.VERBOSE) THEN
       WRITE(6,*)
       WRITE(6,*)
       WRITE(6,*)'Complex Hamiltonian matrix including SO-coupling'
       WRITE(6,*)'over spin components of spin-free eigenstates (SFS):'
       WRITE(6,'(1X,11A7)')('-------',I=1,11)
       CALL PRCHAM(NSS,WORK(LHTOTR),WORK(LHTOTI))
       WRITE(6,'(1X,11A7)')('-------',I=1,11)
      ENDIF
      ! save the Hamiltonian
      call mma_allocate(HAMSOR,NSS,NSS,'HAMSOR')
      call mma_allocate(HAMSOI,NSS,NSS,'HAMSOI')
      call dcopy_(NSS*NSS,[0.d0],0,HAMSOR,1)
      call dcopy_(NSS*NSS,[0.d0],0,HAMSOI,1)
      call dcopy_(NSS*NSS,WORK(LHTOTR),1,HAMSOR,1)
      call dcopy_(NSS*NSS,WORK(LHTOTI),1,HAMSOI,1)
      call put_darray('HAMSOR_SINGLE',HAMSOR,NSS*NSS)
      call put_darray('HAMSOI_SINGLE',HAMSOI,NSS*NSS)
#ifdef _HDF5_
      call mh5_put_dset(wfn_sos_hsor,HAMSOR)
      call mh5_put_dset(wfn_sos_hsoi,HAMSOI)
#endif

      !> use complex matrix diagonalization
#ifdef _DMRG_
      if(doDMRG)then
        call mma_allocate(hso_tmp,nss,nss)
        call mma_allocate(ccwork,(2*nss-1))
        call mma_allocate(rwork,(3*nss-2))
        hso_tmp = 0; ccwork = 0; rwork = 0

        DO jss = 1, nss
          DO iss = 1, nss
            hso_tmp(iss,jss) = dcmplx(WORK(LHTOTR-1+ISS+NSS*(JSS-1)),
     &                                WORK(LHTOTI-1+ISS+NSS*(JSS-1)))
!         write(6,*) ' hso_tmp(',iss,',',jss,') = ',hso_tmp(iss,jss)
          END DO
        END DO

        lcwork = (2*nss-1); info = 0
        call zheev('V','U',nss,hso_tmp,nss,ensor,ccwork,lcwork,
     &             rwork,info)

        if(info /= 0)then
          write(6,*) '* WARNING in rassi/soeig.f *'
          write(6,*) 'zheev did return with an error message,info=',info
        else
          write(6,*) 'zheev in rassi/soeig.f succeeded!'
        end if

!       write(6,*) 'eigenvalues of zheev, info=',info
!       do iss = 1, nss
!         write(6,*) 'ensor(',iss,') =',ensor(iss)
!       end do

        !> save eigenvectors
        DO jss = 1, nss
          DO iss = 1, nss
            usor(iss,jss) = dble(hso_tmp(iss,jss))
            usoi(iss,jss) = aimag(hso_tmp(iss,jss))
          END DO
        END DO

        !> sort eigenvalues in increasing sequence (using the same algorithm as zjac)
        call zorder(nss,nss,usor,usoi,ensor,0)

        CALL MMA_DEALLOCATE(hso_tmp)
        CALL MMA_DEALLOCATE(ccwork)
        CALL MMA_DEALLOCATE(rwork)
      else
#endif
        !> diagonalize H_SO and get array of eigenvalues/eigenvectors
        CALL ZJAC(NSS,WORK(LHTOTR),WORK(LHTOTI),
     &          NSS,USOR,USOI)
        DO ISS=1,NSS
         ENSOR(ISS)=WORK(LHTOTR-1+ISS+NSS*(ISS-1))
        END DO
#ifdef _DMRG_
      end if
#endif

!     write(6,*) 'eigenvectors of zheev/zjac (real)'
!     do iss = 1, nss
!       do jss = 1, nss
!         write(6,*) 'usor(',iss,',',jss,') =',usor(iss,jss)
!       end do
!     end do
!     write(6,*) 'eigenvectors of zheev/zjac (imag)'
!     do iss = 1, nss
!       do jss = 1, nss
!         write(6,*) 'usoi(',iss,',',jss,') =',usoi(iss,jss)
!       end do
!     end do

#ifdef _HDF5_
      call mh5_put_dset(wfn_sos_energy, ENSOR)
      call mh5_put_dset(wfn_sos_coefr,USOR)
      call mh5_put_dset(wfn_sos_coefi,USOI)
#endif
      !> free memory for H_SO - do not use it below!
      !> eigenvalues are stored in ENSOR!
      CALL GETMEM('HTOTR','FREE','REAL',LHTOTR,NSS**2)
      CALL GETMEM('HTOTI','FREE','REAL',LHTOTI,NSS**2)
C
C     BOR in Krapperup 070227
C     Compute J-values and Omega here instead of in subroutine PRPROP
C
      IAMFIX=0
      IAMFIY=0
      IAMFIZ=0
      IAMX=0
      IAMY=0
      IAMZ=0
      DO IPROP=1,NPROP
       IF(PNAME(IPROP)(1:4).EQ.'AMFI') THEN
         IF(ICOMP(IPROP).EQ.1) IAMFIX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMFIY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMFIZ=IPROP
       ELSE IF(PNAME(IPROP)(1:6).EQ.'ANGMOM') THEN
         IF(ICOMP(IPROP).EQ.1) IAMX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMZ=IPROP
       END IF
      END DO

* The following matrix elements  require angular moment integrals:
C     IF(IAMX.eq.0 .or. IAMY.eq.0 .or. IAMZ.eq.0) GOTO 910
C Complex matrix elements of Jx, Jy, and/or Jz over spin states:
      CALL GETMEM('LXI','ALLO','REAL',LLXI,NSS**2)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LLXI),1)
      CALL GETMEM('LYI','ALLO','REAL',LLYI,NSS**2)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LLYI),1)
      CALL GETMEM('LZI','ALLO','REAL',LLZI,NSS**2)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LLZI),1)
      IF(IAMX.GT.0) CALL SMMAT(PROP,WORK(LLXI),NSS,IAMX,0)
      IF(IAMY.GT.0) CALL SMMAT(PROP,WORK(LLYI),NSS,IAMY,0)
      IF(IAMZ.GT.0) CALL SMMAT(PROP,WORK(LLZI),NSS,IAMZ,0)

      CALL GETMEM('JXR','ALLO','REAL',LJXR,NSS**2)
      CALL GETMEM('JXI','ALLO','REAL',LJXI,NSS**2)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LJXR),1)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LJXI),1)
      CALL GETMEM('JYR','ALLO','REAL',LJYR,NSS**2)
      CALL GETMEM('JYI','ALLO','REAL',LJYI,NSS**2)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LJYR),1)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LJYI),1)
      CALL GETMEM('JZR','ALLO','REAL',LJZR,NSS**2)
      CALL GETMEM('JZI','ALLO','REAL',LJZI,NSS**2)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LJZR),1)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LJZI),1)

      CALL SMMAT(PROP,WORK(LJXR),NSS,0,1)
      CALL SMMAT(PROP,WORK(LJYI),NSS,0,2)
      CALL SMMAT(PROP,WORK(LJZR),NSS,0,3)

      CALL DAXPY_(NSS**2,1.0D0,WORK(LLXI),1,WORK(LJXI),1)
      CALL DAXPY_(NSS**2,1.0D0,WORK(LLYI),1,WORK(LJYI),1)
      CALL DAXPY_(NSS**2,1.0D0,WORK(LLZI),1,WORK(LJZI),1)

      CALL GETMEM('LXI','FREE','REAL',LLXI,NSS**2)
      CALL GETMEM('LYI','FREE','REAL',LLYI,NSS**2)
      CALL GETMEM('LZI','FREE','REAL',LLZI,NSS**2)

      CALL GETMEM('OMGR','ALLO','REAL',LOMGR,NSS**2)
      CALL GETMEM('OMGI','ALLO','REAL',LOMGI,NSS**2)
      lOMG=.True.
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LOMGR),1)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LOMGI),1)

      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS, 1.0D0,WORK(LJZR),NSS,
     &     WORK(LJZR),NSS,0.0D0,WORK(LOMGR),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS,-1.0D0,WORK(LJZI),NSS,
     &     WORK(LJZI),NSS,1.0D0,WORK(LOMGR),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS, 1.0D0,WORK(LJZR),NSS,
     &     WORK(LJZI),NSS,0.0D0,WORK(LOMGI),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS, 1.0D0,WORK(LJZI),NSS,
     &     WORK(LJZR),NSS,1.0D0,WORK(LOMGI),NSS)

      CALL GETMEM('JZR','FREE','REAL',LJZR,NSS**2)
      CALL GETMEM('JZI','FREE','REAL',LJZI,NSS**2)

      lJ2 =.True.
      CALL GETMEM('J2R','ALLO','REAL',LJ2R,NSS**2)
      CALL GETMEM('J2I','ALLO','REAL',LJ2I,NSS**2)
      CALL DCOPY_(NSS**2,WORK(LOMGR),1,WORK(LJ2R),1)
      CALL DCOPY_(NSS**2,WORK(LOMGI),1,WORK(LJ2I),1)

      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS, 1.0D0,WORK(LJXR),NSS,
     &     WORK(LJXR),NSS,1.0D0,WORK(LJ2R),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS,-1.0D0,WORK(LJXI),NSS,
     &     WORK(LJXI),NSS,1.0D0,WORK(LJ2R),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS, 1.0D0,WORK(LJYR),NSS,
     &     WORK(LJYR),NSS,1.0D0,WORK(LJ2R),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS,-1.0D0,WORK(LJYI),NSS,
     &     WORK(LJYI),NSS,1.0D0,WORK(LJ2R),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS, 1.0D0,WORK(LJXR),NSS,
     &     WORK(LJXI),NSS,1.0D0,WORK(LJ2I),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS, 1.0D0,WORK(LJXI),NSS,
     &     WORK(LJXR),NSS,1.0D0,WORK(LJ2I),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS, 1.0D0,WORK(LJYR),NSS,
     &     WORK(LJYI),NSS,1.0D0,WORK(LJ2I),NSS)
      CALL DGEMM_('NSS','NSS',NSS,NSS,NSS, 1.0D0,WORK(LJYI),NSS,
     &     WORK(LJYR),NSS,1.0D0,WORK(LJ2I),NSS)

      CALL GETMEM('JXR','FREE','REAL',LJXR,NSS**2)
      CALL GETMEM('JXI','FREE','REAL',LJXI,NSS**2)
      CALL GETMEM('JYR','FREE','REAL',LJYR,NSS**2)
      CALL GETMEM('JYI','FREE','REAL',LJYI,NSS**2)
      CALL ZTRNSF(NSS,USOR,USOI,WORK(LOMGR),WORK(LOMGI))
      CALL ZTRNSF(NSS,USOR,USOI,WORK(LJ2R),WORK(LJ2I))

* Jump here to skip computing omega and/or J:
C910  CONTINUE

      IF(IPGLOB.GE.TERSE) THEN
       WRITE(6,*)
       WRITE(6,'(6X,A)')' Total energies including SO-coupling:'
       DO ISS=1,NSS
       E_tmp=ENSOR(ISS)+EMIN
       Call PrintResult(6, '(6x,A,I5,5X,A,F23.14)',
     &  'SO-RASSI State',ISS,'Total energy:',[E_tmp],1)
       END DO
      END IF

* Find E0=lowest energy, to use for printing table:
      IF(IPGLOB.GE.TERSE) THEN
       E0=ENSOR(1)
       DO ISS=2,NSS
         E=ENSOR(ISS)
        IF(E.LT.E0) THEN
         E0=E
        END IF
       END DO
       WRITE(6,*)
       WRITE(6,*)
       WRITE(6,*)'  Eigenvalues of complex Hamiltonian:'
       WRITE(6,*)'  -----------------------------------'
       IF(EMIN.NE.0.0D0)
     &  WRITE(6,'(1X,A,F22.10,A1)')' (Shifted by EMIN (a.u.) =',EMIN,')'
       WRITE(6,*)
       if(ifj2.ne.0.and.ifjz.ne.0) then
        WRITE(6,*)'SO State       Relative EMIN(au)   Rel lowest'//
     &          ' level(eV)    D:o, cm**(-1)     J-value  Omega'
       else if(ifj2.ne.0.and.ifjz.eq.0) then
        WRITE(6,*)'SO State       Relative EMIN(au)   Rel lowest'//
     &          ' level(eV)    D:o, cm**(-1)     J-value'
       else if(ifj2.eq.0.and.ifjz.ne.0) then
        WRITE(6,*)'SO State       Relative EMIN(au)   Rel lowest'//
     &          ' level(eV)    D:o, cm**(-1)      Omega'
       else if(ifj2.eq.0.and.ifjz.eq.0) then
        WRITE(6,*)'SO State       Relative EMIN(au)   Rel lowest'//
     &          ' level(eV)    D:o, cm**(-1)'
       endif
       WRITE(6,*)
       E0=ENSOR(1)
       DO ISS=1,NSS
        E1=ENSOR(ISS)
        IF (E1.lt.E0) E0=E1
       END DO
       CALL MMA_ALLOCATE(ESO,NSS)
       DO ISS=1,NSS
        E1=ENSOR(ISS)
        E2=AU2EV*(E1-E0)
        E3=AU2CM*(E1-E0)
        IF (IFJ2.gt.0) THEN
         XJEFF=SQRT(0.25D0+WORK(LJ2R-1+ISS+NSS*(ISS-1)))-0.5D0
        END IF
        IF (IFJZ.gt.0) THEN
        OMEGA=SQRT(1.0D-12+WORK(LOMGR-1+ISS+NSS*(ISS-1)))
        END IF

C Added by Ungur Liviu on 04.11.2009
C Saving the SO energies in ESO array.
        ESO(ISS)=E3
        if(ifj2.ne.0.and.ifjz.ne.0) then
          WRITE(6,'(1X,I5,7X,2(F18.10,2X),F18.4,4X,2(2X,F6.1))')
     &        ISS,E1,E2,E3,XJEFF,OMEGA
        else if(ifj2.ne.0.and.ifjz.eq.0) then
          WRITE(6,'(1X,I5,7X,2(F18.10,2X),F18.4,6X,F6.1)')
     &        ISS,E1,E2,E3,XJEFF
        else if(ifj2.eq.0.and.ifjz.ne.0) then
          WRITE(6,'(1X,I5,7X,2(F18.10,2X),F18.4,6X,F6.1)')
     &        ISS,E1,E2,E3,OMEGA
        else if(ifj2.eq.0.and.ifjz.eq.0) then
          WRITE(6,'(1X,I5,7X,2(F18.10,2X),F18.4)')
     &      ISS,E1,E2,E3
        endif
       ENDDO

C Added by Ungur Liviu on 04.11.2009
C Saving the ESO array in the RunFile.
       CALL Put_iscalar('NSS_SINGLE',NSS)
       CALL Put_dArray( 'ESO_SINGLE',ESO,NSS)
       CALL Put_dArray( 'ESO_LOW'   ,ENSOR+EMIN,NSS)
       CALL MMA_DEALLOCATE(ESO)
      END IF

      IF(lOMG) THEN
       CALL GETMEM('OMGR','FREE','REAL',LOMGR,NSS**2)
       CALL GETMEM('OMGI','FREE','REAL',LOMGI,NSS**2)
      END IF
      IF(lJ2) THEN
       CALL GETMEM('J2R','FREE','REAL',LJ2R,NSS**2)
       CALL GETMEM('J2I','FREE','REAL',LJ2I,NSS**2)
      END IF

C Put energy onto info file for automatic verification runs:
      EPSS=5.0D-11
      EPSH=MAX(5.0D-10,ABS(ENSOR(1)+EMIN)*EPSS)
      IDX=100
      DO ISS=1,NSS
       EI=(ENSOR(ISS)+EMIN)*EPSS
       V2SUM=0.0D0
       DO JSS=1,NSS
        V2SUM=V2SUM+USOR(JSS,ISS)**2+USOI(JSS,ISS)**2
       END DO
       ERMS=SQRT(EPSH**2+EI**2)*V2SUM
       IDX=MIN(IDX,INT(-LOG10(ERMS)))
      END DO
      iTol=cho_x_gettol(IDX) ! reset thr iff Cholesky
      Call Add_Info('ESO_LOW',ENSOR+EMIN,NSS,iTol)

      IF(IPGLOB.GE.VERBOSE) THEN
       WRITE(6,*)
       WRITE(6,*)' Complex eigenvectors in basis of non-so eigenstates:'
       WRITE(6,*)'-----------------------------------------------------'
       WRITE(6,*)
       IF(IPGLOB.GE.DEBUG) THEN
         FRAC=0.0D0
       ELSE
         FRAC=0.25D0
         WRITE(6,*)'    (A selection of the largest components)'
       END IF
      END IF
       CALL PRCEVC(NSS,FRAC,ENSOR,IWORK(LMAPST),IWORK(LMAPSP),
     &            IWORK(LMAPMS),USOR,USOI)

C Update LoopDivide (SUBSets keyword)
C Assume the SO "ground states" are mostly formed by the SF "ground states"
      If (ReduceLoop) Then
        Call mma_Allocate(IndexE,nState,Label='IndexE')
        IndexE(:)=ArgSort(Energy, leq_r)
        n=0
        Do iState=1,LoopDivide
          Job=JbNum(IndexE(iState))
          n=n+Mltplt(Job)
        End Do
        LoopDivide=n
#ifdef _HDF5_
        If (IFTRD1.or.IFTRD2)
     &    Call UpdateIdx(IndexE,nSS,USOR,USOI,iWork(lMapSt))
#endif
        Call mma_deAllocate(IndexE)
      End If

      CALL GETMEM('MAPST','FREE','INTE',LMAPST,NSS)
      CALL GETMEM('MAPSP','FREE','INTE',LMAPSP,NSS)
      CALL GETMEM('MAPMS','FREE','INTE',LMAPMS,NSS)

      call mma_deallocate(HAMSOR)
      call mma_deallocate(HAMSOI)
      RETURN

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE SXTYP_GAS(  NSXTYP,     ITP,     JTP,    NGAS,    ILTP,
     &                         IRTP)
*
* Two supergroups are given. Find single excitations that connects
* these supergroups
*
* Jeppe Olsen, July 1995
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION ILTP(NGAS),IRTP(NGAS)
*. Output
      DIMENSION ITP(*),JTP(*)
* Some dummy initializations
      ICREA = 0 ! jwk-cleanup
      IANNI = 0 ! jwk-cleanup
*. Differences between occupations :
      NCREA = 0
      NANNI = 0
      DO IAS = 1, NGAS
        IF(ILTP(IAS).GT.IRTP(IAS)) THEN
         NCREA = NCREA + ILTP(IAS) - IRTP(IAS)
         ICREA = IAS
        ELSE IF(IRTP(IAS).GT.ILTP(IAS)) THEN
         NANNI = NANNI + IRTP(IAS) - ILTP(IAS)
         IANNI = IAS
        END IF
      END DO
*
      IF(NCREA.GT.1) THEN
*. Sorry : No single excitation connects
        NSXTYP = 0
      ELSE IF(NCREA .EQ. 1 ) THEN
*. Supergroups differ by one sngle excitation.
        NSXTYP = 1
        ITP(1) = ICREA
        JTP(1) = IANNI
      ELSE IF (NCREA.EQ.0 ) THEN
*. Supergroups are identical, connects with all
*  diagonal excitations.
        NSXTYP = 0
        DO IAS = 1, NGAS
          IF(IRTP(IAS).NE.0) THEN
            NSXTYP = NSXTYP + 1
            ITP(NSXTYP) = IAS
            JTP(NSXTYP) = IAS
          END IF
        END DO
      END IF
*
      NTEST = 000
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Output from SXTYP_GAS : '
        WRITE(6,*) ' ======================= '
        WRITE(6,*) ' Input left  supergroup '
        CALL IWRTMA(ILTP,1,NGAS,1,NGAS)
        WRITE(6,*) ' Input right supergroup '
        CALL IWRTMA(IRTP,1,NGAS,1,NGAS)
        WRITE(6,*)
     &  ' Number of connecting single excitations ', NSXTYP
        IF(NSXTYP.NE.0) THEN
          WRITE(6,*) ' Connecting single excitations '
          DO ISX = 1, NSXTYP
            WRITE(6,*) ITP(ISX),JTP(ISX)
          END DO
        END IF
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine GT1DIA_MCLR(H1DIA)
      use Arrays, only: FIMO
      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
      Real*8 H1DIA(*)

      i=1
      Do iS=1,nSym
       ii=ipCM(iS)+nOrb(iS)*(nIsh(iS)-1)+nIsh(iS)-1
       Do iAsh=1,nAsh(iS)
        ii=ii+nOrb(iS)+1
        H1DIA(i) = FIMO(ii)
        i=i+1
       End Do
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Steven Vancoillie                                *
!               2018, Ignacio Fdez. Galvan                             *
!***********************************************************************

module pt2wfn

use Definitions, only: wp, iwp

implicit none
private

# ifdef _HDF5_
integer(kind=iwp) :: pt2wfn_cicoef, pt2wfn_dens, pt2wfn_energy, pt2wfn_heff, pt2wfn_id, pt2wfn_mocoef, pt2wfn_occnum, &
                     pt2wfn_orbene, pt2wfn_refene
#endif
logical(kind=iwp) :: pt2wfn_is_h5 = .false.

public :: pt2wfn_close, pt2wfn_data, pt2wfn_densstore, pt2wfn_estore, pt2wfn_init

#include "macros.fh"

contains

subroutine pt2wfn_init()
  ! SVC: Create a wavefunction file. If another .wfn file already
  ! exists, it will be overwritten.

  use Index_Functions, only: nTri_Elem
  use Molcas, only: MxAct
  use refwfn, only: refwfn_active
# ifdef _HDF5_
  use refwfn, only: refwfn_is_h5
  use mh5, only: mh5_close_dset, mh5_create_dset_real, mh5_create_dset_str, mh5_create_file, mh5_init_attr, mh5_put_dset
  use sguga, only: L2ACT, LEVEL
  use caspt2_global, only: do_grad
  use caspt2_module, only: DMRG, IfMix, IfMSCOUP, IfProp, iSpin, lRoots, mState, nActEl, nBas, nBasT, nBSqT, nConf, nDel, nDet, &
                           nEle3, nFro, nHole1, nIsh, nOrb, nRas1, nRas1T, nRas2, nRas3, nRas3T, nSsh, nState, nSym, Root2State, &
                           STSym
  use stdalloc, only: mma_allocate, mma_deallocate
# endif

# ifdef _HDF5_
  integer(kind=iwp) :: dsetid, ndmat
  character, allocatable :: typestring(:)
# endif

  if (refwfn_active) then
    call WarningMessage(2,'Active reference wavefunction file, cannot create new PT2 wavefunction file, aborting!')
    call AbEnd()
  end if

# ifdef _HDF5_
  if (refwfn_is_h5) then
    pt2wfn_is_h5 = .true.
    ! create a new wavefunction file!
    pt2wfn_id = mh5_create_file('PT2WFN')
    ! no JOBMIX for HDF5 files
    ifmix = .false.

    ! set module type
    call mh5_init_attr(pt2wfn_id,'MOLCAS_MODULE','CASPT2')

    ! copy basic molecular information to the HDF5 file
    call run2h5_molinfo(pt2wfn_id)
    call one2h5_ovlmat(pt2wfn_id,nsym,nbas)
    call one2h5_fckint(pt2wfn_id,nsym,nbas)
    call one2h5_crtmom(pt2wfn_id,nsym,nbas)

    ! set wavefunction type
    if (NRAS1T+NRAS3T == 0) then
      call mh5_init_attr(pt2wfn_id,'CI_TYPE','CAS')
    else
      call mh5_init_attr(pt2wfn_id,'CI_TYPE','RAS')
    end if

    ! general wavefunction attributes
    call mh5_init_attr(pt2wfn_id,'SPINMULT',iSpin)
    call mh5_init_attr(pt2wfn_id,'LSYM',stSym)
    call mh5_init_attr(pt2wfn_id,'NACTEL',nActEl)
    call mh5_init_attr(pt2wfn_id,'NHOLE1',nHole1)
    call mh5_init_attr(pt2wfn_id,'NELEC3',nEle3)
    call mh5_init_attr(pt2wfn_id,'NCONF',nConf)
    call mh5_init_attr(pt2wfn_id,'NSTATES',NSTATE)
    call mh5_init_attr(pt2wfn_id,'NDET',NDET)

    call mh5_init_attr(pt2wfn_id,'L2ACT',1,[mxAct],L2ACT)
    call mh5_init_attr(pt2wfn_id,'A2LEV',1,[mxAct],LEVEL)

    ! molecular orbital type index
    call mma_allocate(typestring,nbast)
    call orb2tpstr(NSYM,NBAS,NFRO,NISH,NRAS1,NRAS2,NRAS3,NSSH,NDEL,typestring)
    dsetid = mh5_create_dset_str(pt2wfn_id,'MO_TYPEINDICES',1,[NBAST],1)
    call mh5_init_attr(dsetid,'DESCRIPTION', &
                       'Type index of the molecular orbitals arranged as blocks of size [NBAS(i)], i=1,#irreps')
    call mh5_put_dset(dsetid,typestring)
    call mma_deallocate(typestring)
    call mh5_close_dset(dsetid)

    ! roots
    call mh5_init_attr(pt2wfn_id,'STATE_ROOTID',1,[NSTATE],MSTATE)
    call mh5_init_attr(pt2wfn_id,'ROOT2STATE',1,[LROOTS],ROOT2STATE)

    ! reference energy (for each CI root)
    pt2wfn_refene = mh5_create_dset_real(pt2wfn_id,'STATE_REFWF_ENERGIES',1,[NSTATE])
    call mh5_init_attr(pt2wfn_refene,'DESCRIPTION','Reference energy for each state, arranged as array of [NSTATES]')

    ! PT2 energy (for each CI root)
    pt2wfn_energy = mh5_create_dset_real(pt2wfn_id,'STATE_PT2_ENERGIES',1,[NSTATE])
    call mh5_init_attr(pt2wfn_energy,'DESCRIPTION','PT2 energy for each state, arranged as array of [NSTATES]')

    ! molecular orbital coefficients
    pt2wfn_mocoef = mh5_create_dset_real(pt2wfn_id,'MO_VECTORS',1,[NBSQT])
    call mh5_init_attr(pt2wfn_mocoef,'DESCRIPTION', &
                       'Coefficients of the average orbitals, arranged as blocks of size [NBAS(i)**2], i=1,#irreps')

    ! molecular orbital occupation numbers
    ! (most probably empty, but left for compatibility)
    pt2wfn_occnum = mh5_create_dset_real(pt2wfn_id,'MO_OCCUPATIONS',1,[NBAST])
    call mh5_init_attr(pt2wfn_occnum,'DESCRIPTION', &
                       'Occupation numbers of the average orbitals arranged as blocks of size [NBAS(i)], i=1,#irreps')

    ! molecular orbital energies
    ! (most probably empty, but left for compatibility)
    pt2wfn_orbene = mh5_create_dset_real(pt2wfn_id,'MO_ENERGIES',1,[NBAST])
    call mh5_init_attr(pt2wfn_orbene,'DESCRIPTION', &
                       'Orbital energies of the average orbitals arranged as blocks of size [NBAS(i)], i=1,#irreps')

    ! CI data for each root
    if (.not. DMRG) then
      pt2wfn_cicoef = mh5_create_dset_real(pt2wfn_id,'CI_VECTORS',2,[nConf,NSTATE])
      call mh5_init_attr(pt2wfn_cicoef,'DESCRIPTION', &
                         'Coefficients of configuration state functions in Split-GUGA ordering for each STATE, arranged as '// &
                         'matrix of size [NCONF,NSTATES]')
    end if

    ! effective Hamiltonian coefficients
    if (IFMSCOUP) then
      pt2wfn_heff = mh5_create_dset_real(pt2wfn_id,'H_EFF',2,[NSTATE,NSTATE])
      call mh5_init_attr(pt2wfn_heff,'DESCRIPTION', &
                         'Effective (X)MS-CASPT2 Hamiltonian, arranged as matrix of size [NSTATES,NSTATES]')
    end if

    ! density matrices
    if (IFPROP .or. do_grad) then
      ndmat = sum(nTri_Elem(NORB(1:NSYM)))

      pt2wfn_dens = mh5_create_dset_real(pt2wfn_id,'DENSITY_MATRIX',2,[ndmat,NSTATE])
      call mh5_init_attr(pt2wfn_dens,'DESCRIPTION', &
                         '1-body density matrix, arranged as blocks of size NDMAT=sum([NORB(i)*(NORB(i)+1)/2], i=1,#irreps), '// &
                         'where NORB excludes frozen and deleted orbitals, for each state: [NDMAT,NSTATES].')
    end if

  else
# endif
    pt2wfn_is_h5 = .false.
# ifdef _HDF5_
  end if
# endif

end subroutine pt2wfn_init

subroutine pt2wfn_data()

# ifdef _HDF5_
  use mh5, only: mh5_put_dset
  use caspt2_global, only: IDCIEX, LUCIEX, LUONEM, NCMO
  use caspt2_module, only: DMRG, iAd1m, nConf, nState
  use stdalloc, only: mma_allocate, mma_deallocate

  real(kind=wp), allocatable :: BUF(:)
  integer(kind=iwp) :: IDISK, ISTATE

  if (pt2wfn_is_h5) then
    if (.not. DMRG) then
      call mma_allocate(BUF,NCONF)
      do ISTATE=1,NSTATE
        IDISK = IDCIEX(ISTATE)
        call DDAFILE(LUCIEX,2,BUF,NCONF,IDISK)
        call mh5_put_dset(pt2wfn_cicoef,BUF,[NCONF,1],[0,ISTATE-1])
      end do
      call mma_deallocate(BUF)
    end if

    call mma_allocate(BUF,NCMO)
    IDISK = IAD1M(1)
    call DDAFILE(LUONEM,2,BUF,NCMO,IDISK)
    call mh5_put_dset(pt2wfn_mocoef,BUF)
    call mma_deallocate(BUF)
  end if
# endif

end subroutine pt2wfn_data

subroutine pt2wfn_estore(Heff,nState)

# ifdef _HDF5_
  use mh5, only: mh5_put_dset
  use caspt2_module, only: Energy, IfMSCOUP, RefEne
# endif

  integer(kind=iwp), intent(in) :: nstate
  real(kind=wp), intent(in) :: Heff(nstate,nstate)

# ifdef _HDF5_
  if (pt2wfn_is_h5) then
    call mh5_put_dset(pt2wfn_energy,ENERGY)
    call mh5_put_dset(pt2wfn_refene,REFENE)
    if (IFMSCOUP) call mh5_put_dset(pt2wfn_heff,Heff)
  end if
# else
  unused_var(Heff)
#endif

end subroutine pt2wfn_estore

subroutine pt2wfn_densstore(Dmat,nDmat)

# ifdef _HDF5_
  use mh5, only: mh5_put_dset
  use caspt2_module, only: jState
# endif

  integer(kind=iwp), intent(in) :: nDmat
  real(kind=wp), intent(in) :: Dmat(nDmat)

# ifdef _HDF5_
  if (pt2wfn_is_h5) call mh5_put_dset(pt2wfn_dens,Dmat,[nDmat,1],[0,JSTATE-1])
# else
  unused_var(Dmat)
# endif

end subroutine pt2wfn_densstore

subroutine pt2wfn_close()

# ifdef _HDF5_
  use mh5, only: mh5_close_file

  if (pt2wfn_is_h5) call mh5_close_file(pt2wfn_id)
  pt2wfn_id = -1
#endif

end subroutine pt2wfn_close

end module pt2wfn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, IBM                                              *
************************************************************************
      Integer Function iCFrst(KWord,iChrct)
      Character KWord*(*)
      Do 10 i = 1,iChrct
         If (KWord(i:i).ne.' ') Go To 11
 10   Continue
 11   Continue
      iCFrst = i
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine tosigY(m1,m2,m3,m4,angint,mcombina,ncontl1,ncontl2,ncontl3,ncontl4,carteY,preY,interxyz,isgnprod,cleaner)
!bs this subroutine combines the angular integrals
!bs to the integrals for the real-valued linear
!bs combinations for the sigma_X part
!bs definition of the real-valued linear combinations:
!bs
!bs M=0  is the same as   Y(L,0)
!bs
!bs M > 0
!bs
!bs | L,M,+> = 2**(-0.5) ( (-1)**M Y(L,M) + Y(L,-M))
!bs
!bs | L,M,-> = -i 2**(-0.5) ( (-1)**M Y(L,M) - Y(L,-M)) ($$$$)
!bs
!bs due to symmetry, there can be only integrals
!bs with one or three (sigma_+ and sigma_-)  - combinations

use AMFI_global, only: Lmax
use Constants, only: Zero, One, speed => c_in_au
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: m1, m2, m3, m4, mcombina(2,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax), ncontl1, ncontl2, &
                                 ncontl3, ncontl4, interxyz(*), isgnprod(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax)
real(kind=wp), intent(in) :: angint(ncontl1,ncontl2,ncontl3,ncontl4,*), preY(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax)
!bs !!!!!!!!!!!changing now to the order of chemists notation!!!!!!!!!!
real(kind=wp), intent(out) :: carteY(ncontl1,ncontl3,ncontl2,ncontl4)
logical(kind=iwp), intent(in) :: cleaner
integer(kind=iwp) :: iblock, irun, isgnM(-1:1,-1:1,-1:1,-1:1), ityp, Mabs1, Mabs2, Mabs3, Mabs4
real(kind=wp) :: factor, prey1234
real(kind=wp), parameter :: fine = One/speed, speed2 = speed*speed

!write(u6,*) 'begin tosigy '
!bs cleaning up the integral-array
carteY(:,:,:,:) = Zero
!bs set some signs
!bs isgnM will give an additonal minus-sign if both m-values
!bs (cartesian and angular) are negative  see $$$$
isgnM(:,:,:,:) = 1
if (m1 < 0) isgnM(-1,:,:,:) = -isgnM(-1,:,:,:)
if (m2 < 0) isgnM(:,-1,:,:) = -isgnM(:,-1,:,:)
if (m3 < 0) isgnM(:,:,-1,:) = -isgnM(:,:,-1,:)
if (m4 < 0) isgnM(:,:,:,-1) = -isgnM(:,:,:,-1)
!bs define absolute m-values
Mabs1 = abs(m1)
Mabs2 = abs(m2)
Mabs3 = abs(m3)
Mabs4 = abs(m4)
irun = 0
if (interxyz(1) == 0) then
  write(u6,*) 'tosigy: no interaction: ',m1,m2,m3,m4
  call Abend()
end if
prey1234 = preY(m1,m2,m3,m4)
!write(u6,*) 'prey ',prey1234
do while (interxyz(irun+1) > 0)
  irun = irun+1
  !write(u6,*) 'tosigy: ',irun,interxyz(irun)

  select case (interxyz(irun))

    case (1)
      ityp = mcombina(1,Mabs1,Mabs2,Mabs3,Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 1',' ')
      iblock = mcombina(2,Mabs1,Mabs2,Mabs3,Mabs4)
      factor = isgnM(1,1,1,1)*prey1234*real(isgnprod(Mabs1,Mabs2,Mabs3,Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (2)
      ityp = mcombina(1,-Mabs1,-Mabs2,-Mabs3,-Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 2',' ')
      iblock = mcombina(2,-Mabs1,-Mabs2,-Mabs3,-Mabs4)
      factor = isgnM(-1,-1,-1,-1)*prey1234*real(isgnprod(-Mabs1,-Mabs2,-Mabs3,-Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (3)
      ityp = mcombina(1,Mabs1,Mabs2,Mabs3,-Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 3',' ')
      iblock = mcombina(2,Mabs1,Mabs2,Mabs3,-Mabs4)
      factor = isgnM(1,1,1,-1)*prey1234*real(isgnprod(Mabs1,Mabs2,Mabs3,-Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (4)
      ityp = mcombina(1,-Mabs1,-Mabs2,-Mabs3,Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 4',' ')
      iblock = mcombina(2,-Mabs1,-Mabs2,-Mabs3,Mabs4)
      factor = isgnM(-1,-1,-1,1)*prey1234*real(isgnprod(-Mabs1,-Mabs2,-Mabs3,Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (5)
      ityp = mcombina(1,Mabs1,Mabs2,-Mabs3,Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 5',' ')
      iblock = mcombina(2,Mabs1,Mabs2,-Mabs3,Mabs4)
      factor = isgnM(1,1,-1,1)*prey1234*real(isgnprod(Mabs1,Mabs2,-Mabs3,Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (6)
      ityp = mcombina(1,-Mabs1,-Mabs2,Mabs3,-Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 6',' ')
      iblock = mcombina(2,-Mabs1,-Mabs2,Mabs3,-Mabs4)
      factor = isgnM(-1,-1,1,-1)*prey1234*real(isgnprod(-Mabs1,-Mabs2,Mabs3,-Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (7)
      ityp = mcombina(1,Mabs1,-Mabs2,Mabs3,Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 7',' ')
      iblock = mcombina(2,Mabs1,-Mabs2,Mabs3,Mabs4)
      factor = isgnM(1,-1,1,1)*prey1234*real(isgnprod(Mabs1,-Mabs2,Mabs3,Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (8)
      ityp = mcombina(1,-Mabs1,Mabs2,-Mabs3,-Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 8',' ')
      iblock = mcombina(2,-Mabs1,Mabs2,-Mabs3,-Mabs4)
      factor = isgnM(-1,1,-1,-1)*prey1234*real(isgnprod(-Mabs1,Mabs2,-Mabs3,-Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (9)
      ityp = mcombina(1,-Mabs1,Mabs2,Mabs3,Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 9',' ')
      iblock = mcombina(2,-Mabs1,Mabs2,Mabs3,Mabs4)
      factor = isgnM(-1,1,1,1)*prey1234*real(isgnprod(-Mabs1,Mabs2,Mabs3,Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (10)
      ityp = mcombina(1,Mabs1,-Mabs2,-Mabs3,-Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 10',' ')
      iblock = mcombina(2,Mabs1,-Mabs2,-Mabs3,-Mabs4)
      factor = isgnM(1,-1,-1,-1)*prey1234*real(isgnprod(Mabs1,-Mabs2,-Mabs3,-Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (11)
      ityp = mcombina(1,Mabs1,Mabs2,-Mabs3,-Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 11',' ')
      iblock = mcombina(2,Mabs1,Mabs2,-Mabs3,-Mabs4)
      factor = isgnM(1,1,-1,-1)*prey1234*real(isgnprod(Mabs1,Mabs2,-Mabs3,-Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (12)
      ityp = mcombina(1,-Mabs1,-Mabs2,Mabs3,Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 12',' ')
      iblock = mcombina(2,-Mabs1,-Mabs2,Mabs3,Mabs4)
      factor = isgnM(-1,-1,1,1)*prey1234*real(isgnprod(-Mabs1,-Mabs2,Mabs3,Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (13)
      ityp = mcombina(1,Mabs1,-Mabs2,Mabs3,-Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 13',' ')
      iblock = mcombina(2,Mabs1,-Mabs2,Mabs3,-Mabs4)
      factor = isgnM(1,-1,1,-1)*prey1234*real(isgnprod(Mabs1,-Mabs2,Mabs3,-Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (14)
      ityp = mcombina(1,-Mabs1,Mabs2,-Mabs3,Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 14',' ')
      iblock = mcombina(2,-Mabs1,Mabs2,-Mabs3,Mabs4)
      factor = isgnM(-1,1,-1,1)*prey1234*real(isgnprod(-Mabs1,Mabs2,-Mabs3,Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (15)
      ityp = mcombina(1,Mabs1,-Mabs2,-Mabs3,Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 15',' ')
      iblock = mcombina(2,Mabs1,-Mabs2,-Mabs3,Mabs4)
      factor = isgnM(1,-1,-1,1)*prey1234*real(isgnprod(Mabs1,-Mabs2,-Mabs3,Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

    case (16)
      ityp = mcombina(1,-Mabs1,Mabs2,Mabs3,-Mabs4)
      if ((ityp /= 1) .and. (ityp /= 3)) call SysAbendMsg('tosigy','wrong ityp in tosigY 16',' ')
      iblock = mcombina(2,-Mabs1,Mabs2,Mabs3,-Mabs4)
      factor = isgnM(-1,1,1,-1)*prey1234*real(isgnprod(-Mabs1,Mabs2,Mabs3,-Mabs4),kind=wp)
      if (ityp == 3) factor = -factor
      call daxpint(angint(:,:,:,:,iblock),carteY,factor,ncontl1,ncontl2,ncontl3,ncontl4)

  end select
end do
if (cleaner) then
  do irun=1,ncontl1
    carteY(irun,irun,:,:) = Zero
  end do
end if

return

end subroutine tosigY

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_K (K,dimbe,addbe,dima,adda)
c
c        check K(be,u,i,a)
c
        implicit none
#include "chcc1.fh"
        integer dimbe,addbe,dima,adda
        real*8 K(1:dimbe,1:no,1:no,1:dima)
c
        integer be,u,i,a,bad
        real*8 s
c
        bad=0
        do a=adda+1,adda+dima
        do i=1,no
        do u=1,no
        do be=addbe+1,addbe+dimbe
c
          s=Kc(i,be,u,a)
c
          if (abs(K(be-addbe,u,i,a-adda)-s).gt.1.0d-10) then
            bad=bad+1
          end if
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck K :',bad
c99        format (a9,1x,i8,1x,4(i3,1x))
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_Vx(V)
! check V

use chcc_global, only: Jc, Kc, no, nv
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: V(nv,no,nv,no)
integer(kind=iwp) :: a, bad, be, i, u
real(kind=wp) :: s

bad = 0
do a=1,nv
  do i=1,no
    do u=1,no
      do be=1,nv

        s = Two*Jc(be,i,u,a)-Kc(i,be,u,a)
        s = Kc(i,be,u,a)

        if (abs(V(be,u,a,i)-s) > 1.0e-10_wp) then
          bad = bad+1
          V(be,u,a,i) = s
        end if

      end do
    end do
  end do
end do

write(u6,*) ' Chck Vx :',bad

return

end subroutine Chck_Vx

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_multy0(wrk,wrksize,mvec,ix,y,key)
! This routine realizes multiplying according mvec
! for Y=A*B
! N.B. if key=0, Y file is not vanished (ie can be used for
! adding to some existing file)

use CCT3_global, only: Map_Type
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, mvec(4096,7), ix, key
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: y
integer(kind=iwp) :: iix, iy, nhelp1, nhelp2, nhelp3, nhelp4, nhelp5

!1 set C=0

if (key == 1) then

  ! Y vector must be vanished

  do iy=1,y%d(0,5)
    nhelp1 = y%d(iy,1)
    nhelp2 = y%d(iy,2)
    wrk(nhelp1:nhelp1+nhelp2-1) = Zero
  end do

end if

!2 Y=Y+A*B

do iix=1,ix

  ! skip this sumation if yes/no=0
  if (mvec(iix,1) == 0) cycle

  ! realize individial sumation

  ! def positions of A,B,Y
  nhelp1 = mvec(iix,2)
  nhelp2 = mvec(iix,3)
  nhelp3 = mvec(iix,4)

  ! def rowA(rowY), colA(sum)
  nhelp4 = mvec(iix,5)
  nhelp5 = mvec(iix,6)

  call cct3_mv0v1a3u(nhelp4,nhelp5,nhelp5,nhelp4,nhelp4,nhelp5,1,1,wrk(nhelp1),wrk(nhelp2),wrk(nhelp3))

end do

return

end subroutine cct3_multy0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine o123a2_cvb(nparm,grad,eigvec,eigval,gradp)
      implicit real*8 (a-h,o-z)
#include "opt_cvb.fh"
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

      dimension grad(nparm)
      dimension eigvec(nparm,nparm),eigval(nparm)
      dimension gradp(nparm)

      call gethess_cvb(eigvec)
      call mxdiag_cvb(eigvec,eigval,nparm)
      call mxatb_cvb(grad,eigvec,1,nparm,nparm,gradp)
      if(ip.ge.2)then
        write(6,'(a)')' Gradient in basis of Hessian eigenvectors :'
        call vecprint_cvb(gradp,nparm)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine tql1(n,d,e,ierr)
! this subroutine is a translation of the algol procedure tql1,
! num. math. 11, 293-306(1968) by bowdler, martin, reinsch, and
! wilkinson.
! handbook for auto. comp., vol.ii-linear algebra, 227-240(1971).
!
! this subroutine finds the eigenvalues of a symmetric
! tridiagonal matrix by the ql method.
!
! on input
!
!    n is the order of the matrix.
!
!    d contains the diagonal elements of the input matrix.
!
!    e contains the subdiagonal elements of the input matrix
!      in its last n-1 positions.  e(1) is arbitrary.
!
!  on output
!
!    d contains the eigenvalues in ascending order.  if an
!      error exit is made, the eigenvalues are correct and
!      ordered for indices 1,2,...ierr-1, but may not be
!      the smallest eigenvalues.
!
!    e has been destroyed.
!
!    ierr is set to
!      zero       for normal return,
!      j          if the j-th eigenvalue has not been
!                 determined after 30 iterations.
!
! calls pythag for  sqrt(a*a + b*b) .
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: d(n), e(n)
integer(kind=iwp), intent(out) :: ierr
integer(kind=iwp) :: i, ii, j, l, l1, l2, m, mml
real(kind=wp) :: c, c2, c3, dl1, el1, f, g, h, p, r, s, s2, tst1, tst2
logical(kind=iwp) :: skip
real(kind=wp), external :: pythag

ierr = 0
c3 = Zero ! dummy initialize
s2 = Zero ! dummy initialize
if (n == 1) return

e(1:n-1) = e(2:)

f = Zero
tst1 = Zero
e(n) = Zero

do l=1,n
  j = 0
  h = abs(d(l))+abs(e(l))
  if (tst1 < h) tst1 = h
  ! .......... look for small sub-diagonal element ..........
  do m=l,n
    tst2 = tst1+abs(e(m))
    if (tst2 == tst1) exit
    ! .......... e(n) is always zero, so there is no exit through the bottom of the loop ..........
  end do

  if (m /= l) then
    do
      if (j == 30) then
        ! .......... set error -- no convergence to an eigenvalue after 30 iterations ..........
        ierr = l
        return
      end if
      j = j+1
      ! .......... form shift ..........
      l1 = l+1
      l2 = l1+1
      g = d(l)
      p = (d(l1)-g)/(Two*e(l))
      r = pythag(p,One)
      d(l) = e(l)/(p+sign(r,p))
      d(l1) = e(l)*(p+sign(r,p))
      dl1 = d(l1)
      h = g-d(l)

      d(l2:) = d(l2:)-h

      f = f+h
      ! .......... ql transformation ..........
      p = d(m)
      c = One
      c2 = c
      el1 = e(l1)
      s = Zero
      mml = m-l
      ! .......... for i=m-1 step -1 until l do -- ..........
      do ii=1,mml
        c3 = c2
        c2 = c
        s2 = s
        i = m-ii
        g = c*e(i)
        h = c*p
        r = pythag(p,e(i))
        e(i+1) = s*r
        s = e(i)/r
        c = p/r
        p = c*d(i)-s*g
        d(i+1) = h+s*(c*g+s*d(i))
      end do

      p = -s*s2*c3*el1*e(l)/dl1
      e(l) = s*p
      d(l) = c*p
      tst2 = tst1+abs(e(l))
      if (tst2 <= tst1) exit
    end do
  end if
  p = d(l)+f
  ! .......... order eigenvalues ..........
  skip = .false.
  if (l /= 1) then
    ! .......... for i=l step -1 until 2 do -- ..........
    do ii=2,l
      i = l+2-ii
      if (p >= d(i-1)) then
        skip = .true.
        exit
      end if
      d(i) = d(i-1)
    end do
  end if

  if (.not. skip) i = 1
  d(i) = p
end do

return

end subroutine tql1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine GenerateGeoms(Q)
      implicit none
#include "geoms.fh"
#include "debug.fh"
#include "WrkSpc.fh"
#include "options.fh"
      Real*8 Q(0:3)
      Real*8 Vtrans(3)
      integer igeom,iLU
      character*6 fname
      integer isfreeunit

      Do igeom=3,ngeoms+2
        call dcopy_(nat(igeom)*3,Work(ipgeo(2)),1,Work(ipgeo(igeom)),1)
      End Do
      if (rotate) Call RotateGeoms(Q)
      if (translate) then
        Call SetVectTrans(nat(1),Work(ipgeo(1)), XYZ1,
     &                            nat(2),Work(ipgeo(2)), XYZ2,Vtrans)
        Call TranslateGeoms(Vtrans)
       End If

      iLU=12
      iLU=isfreeunit(iLU)
      Do igeom=1,ngeoms+2
        if (igeom.lt.100) write(fname,'(a4,i2)') "GEOM",igeom
        if (igeom.lt.10) write(fname,'(a5,i1)') "GEOM0",igeom
        call Molcas_Open (iLU,fname)
        call PrintGeom(iLU,nat(igeom),title(igeom),
     &           Work(ipgeo(igeom)),geolbl(1,igeom))
        close (iLU)
      End Do

      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ISWAP(N,X,incX,Y,incY)
!***********************************************************************
!                                                                      *
!     Interchange vectors X and Y                                      *
!                                                                      *
!     calling arguments:                                               *
!     N       : Integer, input.                                        *
!               Number of input elements.                              *
!     X       : Array of Integer                                       *
!               Vector X                                               *
!     incX    : Integer, input.                                        *
!               Stride of vector X.                                    *
!     Y       : Array of Integer                                       *
!               Vector Y                                               *
!     incY    : Integer, input.                                        *
!               Stride of vector Y.                                    *
!                                                                      *
!***********************************************************************

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, incX, incY
integer(kind=iwp), intent(inout) :: X(*), Y(*)
integer(kind=iwp) :: i, iX, iY, Temp

if (N < 0) then
  write(u6,*)
  write(u6,*) '  *** Error in subroutine ISWAP ***'
  write(u6,*) '  Invalid number of elements in vectors X and Y :'
  write(u6,*) '  N must be larger than zero'
  write(u6,*)
  call Abend()
end if

iX = 1
if (incX < 0) iX = 1+(1-N)*incX
iY = 1
if (incY < 0) iY = 1+(1-N)*incY

do i=0,N-1
  Temp = Y(iY+i*incY)
  Y(iY+i*incY) = X(iX+i*incX)
  X(iX+i*incX) = Temp
end do

return

end subroutine ISWAP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Freezer(EAll,nFre,nFro,nFro1,nOcc,nBas,nSym,LocPrt)

      Implicit Real*8 (a-h,o-z)
      Real*8  EAll(*)
      Integer nFro(nSym), nFro1(nSym), nOcc(nSym), nBas(nSym)
      Logical LocPrt
#include "WrkSpc.fh"

      Character*7 SecNam
      Parameter (SecNam = 'Freezer')

      Integer  Cho_iRange
      External Cho_iRange

      Integer iOcc(8)

C     For nSym=1, simply transfer nFre to nFro1.
C     Else initialize nFro1 array.
C     ------------------------------------------

      If (nSym.lt.1 .or. nSym.gt.8) Then
         Write(6,*) SecNam,': illegal nSym = ',nSym
         Call SysAbendMsg(SecNam,'illegal nSym',' ')
      Else If (nSym .eq. 1) Then
         nFro1(1) = nFre
         Return
      Else
         Call Cho_iZero(nFro1,nSym)
      End If

C     Set up array of active occupied orbital energies.
C     -------------------------------------------------

      lPoint = nFre

      iOcc(1) = 0
      lEOcc   = nOcc(1)
      Do iSym = 2,nSym
         iOcc(iSym) = lEOcc
         lEOcc = lEOcc + nOcc(iSym)
      End Do

      Call GetMem('ScrOcc','Allo','Real',ipEOcc,lEOcc)
      Call GetMem('Pivot','Allo','Inte',ipPivot,lEOcc)
      Call GetMem('Point','Allo','Inte',ipPoint,lPoint)

      iCount = 1
      Do iSym = 1,nSym
         kAll = iCount + nFro(iSym)
         kOcc = ipEOcc + iOcc(iSym)
         Call dCopy_(nOcc(iSym),EAll(kAll),1,Work(kOcc),1)
         iCount = iCount + nBas(iSym)
      End Do

C     Find pointers to lowest nFre occupied orbital energies.
C     -------------------------------------------------------

      xMin   = -1.0D15
      NumFre = nFre
      Call dScal_(lEOcc,-1.0D0,Work(ipEOcc),1) ! DiaMax finds MAX values
      Call CD_DiaMax(Work(ipEOcc),lEOcc,iWork(ipPivot),iWork(ipPoint),
     &               NumFre,xMin)
      If (NumFre .ne. nFre) Then
         Write(6,*) SecNam,': an error occurred in CD_DiaMax!'
         Write(6,*) 'NumFre = ',NumFre,' != ',nFre,' = nFre'
         Call SysAbendMsg(SecNam,'CD_DiaMax failure',' ')
      End If

C     Set up nFro1 array.
C     -------------------

      Do iFre = 1,nFre
         iSym = Cho_iRange(iWork(ipPoint-1+iFre),iOcc,nSym,.false.)
         nFro1(iSym) = nFro1(iSym) + 1
      End Do

C     If requested, print.
C     --------------------

      If (LocPrt) Then
         Write(6,'(/,3X,A,A,A)') 'Output from ',SecNam,':'
         Write(6,'(1X,A,I5,A)')
     &   'The',nFre,' lowest occupied orbitals have been frozen.'
         Write(6,'(1X,A)') 'List of frozen occupied orbitals:'
         Do iFre = 1,nFre
            kOcc = iWork(ipPoint-1+iFre)
            jSym = Cho_iRange(kOcc,iOcc,nSym,.false.)
            jOcc = kOcc - iOcc(jSym)
            Write(6,'(1X,A,I5,A,I1,A,F15.8)')
     &      'Occupied orbital',jOcc,' of symmetry ',jSym,
     &      ' and energy ',-Work(ipEOcc-1+kOcc)
         End Do
      End If

C     Free memory.
C     ------------

      Call GetMem('Point','Free','Inte',ipPoint,lPoint)
      Call GetMem('Pivot','Free','Inte',ipPivot,lEOcc)
      Call GetMem('ScrOcc','Free','Real',ipEOcc,lEOcc)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1987, Bjorn O. Roos                                    *
!               1992, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1987  B. O. ROOS                           *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND, SWEDEN                 *
!--------------------------------------------*

subroutine TR2Sq(CMO,X1,X2,X3,URPQ,RUPQ,TUPQ,lBuf)
! SECOND ORDER TWO-ELECTRON TRANSFORMATION ROUTINE
!
! THIS ROUTINE IS CALLED FOR EACH SYMMETRY BLOCK OF INTEGRALS
! (ISP,ISQ,ISR,ISS) WITH ISP >= ISQ AND ISR >= ISS.
! P,Q,R,S are SO indices.
! A,B are MO indices, counting only non-frozen and non-deleted.
! T,U are occupied MO indices, only non-frozen and non-deleted.
! INTEGRALS (AB/TU) ARE ALWAYS GENERATED
! EXCHANGE INTEGRALS (AT/BU) ARE GENERATED AS FOLLOWS:
! (AT/BU) IF ISP >= ISR
! (AT/UB) IF ISP > ISS AND ISP /= ISQ
! (TA/BU) IF ISQ > ISR AND ISP /= ISQ
! (TA/UB) IF ISQ >= ISS AND ISP /= ISQ
!
! ********** IBM-3090 RELEASE 87 09 14 **********
! Replace MXMA with DGEMM. P-AA Malmqvist 1992-05-06.

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: lBuf
#include "rasdim.fh"
#include "caspt2.fh"
real(kind=wp), intent(in) :: CMO(NCMO)
real(kind=wp), intent(_OUT_) :: X1(*), X2(*), X3(*)
real(kind=wp), intent(inout) :: URPQ(*), RUPQ(*), TUPQ(*)
integer(kind=iwp) :: IAD1, IAD1S, IAD2, IAD2S, IAD3, IAD3S, iOpt, IOUT1, IOUT2, IOUT3, IPQ, IPQMX1, IPQMX2, IPQMX3, IPQST, IR, &
                     iRc, IRSST, IRU, ISPQRS, IST, ITU, IX2, KKTU, LAR, LPQ, LR, NA, NAT, NORU, NOTU, NOUR, NP, NQ, NQM, NR, &
                     NSYMP, NT, NTM, NTMAX, NU, NUM, NUMAX
#include "intgrl.fh"
#include "trafo.fh"

NSYMP = (NSYM**2+NSYM)/2
NORU = NBR*NOCS
NOUR = NBS*NOCR
NOTU = NOCR*NOCS
if (ISR == ISS) NOTU = (NOCR**2+NOCR)/2

! CHECK FOR IN CORE OR OUT OF CORE TRANSFORMATION

! 1. SORT OF PARTIALLY TRANSFORMED INTEGRALS (RU/PQ) ON UNIT LUHLF1
IPQMX1 = NBPQ
if (NBPQ*NORU > LRUPQ) then
  IPQMX1 = LRUPQ/NORU
  !write(u6,*) 'OUT OF CORE SORT FOR INTEGRALS (RU/PQ)',IPQMX1
  IAD1S = 0
  call dDAFILE(LUHLF1,0,RUPQ,IPQMX1,IAD1S)
end if
IAD1 = 0
IOUT1 = 0
! 2. SORT OF PARTIALLY TRANSFORMED INTEGRALS (UR/PQ) ON UNIT LUHLF2
IPQMX2 = NBPQ
if (NBPQ*NOUR > LURPQ) then
  IPQMX2 = LURPQ/NOUR
  !write(u6,*) 'OUT OF CORE SORT FOR INTEGRALS (UR/PQ)',IPQMX2
  IAD2S = 0
  call dDAFILE(LUHLF2,0,URPQ,IPQMX2,IAD2S)
end if
IAD2 = 0
IOUT2 = 0
! 3. SORT OF PARTIALLY TRANSFORMED INTEGRALS (TU/PQ) ON UNIT LUHLF3
IPQMX3 = NBPQ
if (NBPQ*NOTU > LTUPQ) then
  IPQMX3 = LTUPQ/NOTU
  !write(u6,*) 'OUT OF CORE SORT FOR INTEGRALS (TU/PQ)',IPQMX3
  IAD3S = 0
  call dDAFILE(LUHLF3,0,TUPQ,IPQMX3,IAD3S)
end if
IAD3 = 0
IOUT3 = 0

! START LOOP OVER SORTED AO-INTEGRALS: NPQ PQ-PAIRS IN EACH BUFFER

IPQ = 0
LPQ = 0
NPQ = 0
iOpt = 1
iRc = 0
IRSST = 1-NBRS
do NP=1,NBP
  NQM = NBQ
  if (ISP == ISQ) NQM = NP
  do NQ=1,NQM
    IPQ = IPQ+1
    IOUT1 = IOUT1+1
    IOUT2 = IOUT2+1
    IOUT3 = IOUT3+1

    ! READ IN A BLOCK OF INTEGRALS FOR NPQ PQ-VALUES

    if (LPQ == NPQ) then
      call RdOrd(iRc,iOpt,isP,isQ,isR,isS,X1,lBuf,nPQ)
      if (IRC > 1) then
        write(u6,*) ' ERROR RETURN CODE IRC=',IRC
        write(u6,*) ' FROM RDORD, CALLED FROM TRA2.'
        call Abend()
      end if
      iOpt = 2
      LPQ = 0
      IRSST = 1-NBRS
    end if
    LPQ = LPQ+1
    IRSST = IRSST+NBRS

    ! START TRANFORMATION OF THIS PQ PAIR

    if (ISR == ISS) then
      call SQUARE(X1(IRSST),X2,1,NBS,NBS)
    else
      call DCOPY_(NBRS,X1(IRSST),1,X2,1)
    end if

    ! INTEGRALS (PQ/UR)

    if (((ISP /= ISQ) .and. (ISP > ISS)) .and. (NOCR /= 0)) then
      call DGEMM_('N','N',NBS,NOCR,NBR,One,X2,NBS,CMO(LMOR2),NBR,Zero,X3,NBS)

      ! SORT THESE INTEGRALS AS (UR/PQ)

      if (IOUT2 > IPQMX2) then
        IOUT2 = 1
        call dDAFILE(LUHLF2,1,URPQ,IPQMX2*NOUR,IAD2)
      end if
      call DCOPY_(NOUR,X3,1,URPQ(IOUT2),IPQMX2)
    end if

    ! INTEGRALS (PQ/RU)

    if (NOCS /= 0) then
      call DGEMM_('T','N',NBR,NOCS,NBS,One,X2,NBS,CMO(LMOS2),NBS,Zero,X3,NBR)

      ! SORT THESE INTEGRALS AS (RU/PQ)

      if (ISP >= ISR) then
        if (IOUT1 > IPQMX1) then
          IOUT1 = 1
          call dDAFILE(LUHLF1,1,RUPQ,IPQMX1*NORU,IAD1)
        end if
        call DCOPY_(NORU,X3,1,RUPQ(IOUT1),IPQMX1)
      end if
    end if

    ! INTEGRALS (PQ/TU)

    if (NOCR*NOCS /= 0) then
      if (ISR == ISS) then
        call DGEMM_Tri('T','N',NOCR,NOCR,NBR,One,X3,NBR,CMO(LMOR2),NBR,Zero,X2,NOCR)
      else
        call DGEMM_('T','N',NOCS,NOCR,NBR,One,X3,NBR,CMO(LMOR2),NBR,Zero,X2,NOCS)
      end if

      ! SORT INTEGRALS (PQ/TU) INTO TUPQ (SORT AFTER PQ INSTEAD OF TU)

      if (IOUT3 > IPQMX3) then
        IOUT3 = 1
        !vv do I=1,NOTU
        !vv   call dDAFILE(LUHLF3,1,TUPQ(1+IPQMX3*(I-1)),IPQMX3,IAD3)
        !vv end do
        call dDAFILE(LUHLF3,1,TUPQ,IPQMX3*NOTU,IAD3)

      end if
      call DCOPY_(NOTU,X2,1,TUPQ(IOUT3),IPQMX3)
    end if

    ! WE NOW HAVE THREE SETS OF PARTIALLY TRANSFORMED INTEGRALS
    ! IN TUPQ: (TU/PQ)   TRIANGULAR FOR ISR == ISS
    ! IN RUPQ: (RU/PQ)   IF ISP >= ISR
    ! IN URPQ: (UR/PQ)   IF (ISP > ISQ) .AND. (ISP > ISS)

  end do
end do

! EMPTY LAST BUFFERS

if (IPQMX1 < NBPQ) then
  !vv do I=1,NORU
  !vv   call dDAFILE(LUHLF1,1,RUPQ(1+IPQMX1*(I-1)),IPQMX1,IAD1)
  !vv end do
  call dDAFILE(LUHLF1,1,RUPQ,IPQMX1*NORU,IAD1)
end if
if (IPQMX2 < NBPQ) then
  !vv do I=1,NOUR
  !vv   call dDAFILE(LUHLF2,1,URPQ(1+IPQMX2*(I-1)),IPQMX2,IAD2)
  !vv end do
  call dDAFILE(LUHLF2,1,URPQ,IPQMX2*NOUR,IAD2)
end if
if (IPQMX3 < NBPQ) then
  !vv do I=1,NOTU
  !vv   call dDAFILE(LUHLF3,1,TUPQ(1+IPQMX3*(I-1)),IPQMX3,IAD3)
  !vv end do
  call dDAFILE(LUHLF3,1,TUPQ,IPQMX3*NOTU,IAD3)

end if

! FIRST PARTIAL TRANSFORMATION FINISHED
! SORTED INTEGRALS ARE ON UNITS LUHLF1 (RUPQ), LUHLF2 (URPQ),
! AND LUHLF3 (TUPQ), CONTROLLED BY THE ADRESSES IAD1,IAD2, AND IAD3,
! OR IN CORE (RUPQ, URPQ, AND TUPQ)

! SECOND HALF TRANSFORMATION FOR INTEGRALS (PQ/TU)
! FIRST SAVE THE START ADDRESS ON LUINTM FOR THIS BLOCK OF INTEGRALS
! NOTE THAT THE SYMMETRY LABEL ISPQRS ASSUMES THAT SYMMETRY LOOPS
! IN THE ORDER T,U,A,B FOR ALL INTEGRAL TYPES.

if (NOCR*NOCS /= 0) then
  ISPQRS = ((ISR**2-ISR)/2+ISS-1)*NSYMP+(ISP**2-ISP)/2+ISQ
  IAD2M(1,ISPQRS) = IAD13
  ITU = 0
  do NT=1,NOCR
    NUM = NT
    if (ISS /= ISR) NUM = NOCS
    do NU=1,NUM
      IPQST = 1+NBPQ*ITU
      ITU = ITU+1

      ! READ ONE BUFFER OF INTEGRALS BACK INTO CORE

      if (IPQMX3 < NBPQ) then
        !*sta0830
        call RBuf_tra2(LUHLF3,TUPQ,NBPQ,IPQMX3,NOTU,ITU,IPQST,IAD3S)
        !*end0830
      end if

      if (ISP == ISQ) then
        call SQUARE(TUPQ(IPQST),X2,1,NBQ,NBQ)
        call DGEMM_('N','N',NBQ,NOP,NBP,One,X2,NBQ,CMO(LMOP),NBP,Zero,X1,NBP)
        call DGEMM_Tri('T','N',NOP,NOP,NBQ,One,X1,NBQ,CMO(LMOQ),NBQ,ZERO,X2,NOP)
        IX2 = (NOP+NOP**2)/2
      else
        call DGEMM_('N','N',NBQ,NOP,NBP,One,TUPQ(IPQST),NBQ,CMO(LMOP),NBP,Zero,X1,NBQ)
        call DGEMM_('T','N',NOQ,NOP,NBQ,One,CMO(LMOQ),NBQ,X1,NBQ,Zero,X2,NOQ)
        IX2 = NOP*NOQ
      end if

      ! WRITE INTEGRALS (AB/TU) ON OUTPUT UNIT LUINTM
      ! INTEGRALS FOR SYMMETRY BLOCK (ISP,ISQ,ISR,ISS) ARE STORED
      ! ONE BLOCK FOR EACH TU STARTING AT ADDRESS IAD2M(1,ISPQRS).
      ! TRIANGULAR IN AB AND TU IF ISP == ISQ ( AND ISR == ISS)

      call GADSum(X2,IX2)
      call dDAFILE(LUINTM,1,X2,IX2,IAD13)

      ! EXTRACT INTEGRALS WITH ALL INDICES ACTIVE INTO TUVX
      ! Not used with caspt2. If wanted, TUVX must be declared.

      !if ((ISP >= ISR) .and. (NASH(ISP)*NASH(ISQ) /= 0)) call GTUVX(X2,TUVX,NT,NU,ITP,ITQ,ITR,ITS,ISP,ISQ)

    end do
  end do
end if

! SECOND PARTIAL TRANSFORMATION FOR INTEGRALS (PQ/RU)-> (AT/BU)
! IF ISP == ISR THEN T >= U BUT ALWAYS ALL A AND B

NOTU = NOCQ*NOCS
if (ISQ == ISS) NOTU = (NOCQ**2+NOCQ)/2
if ((ISP >= ISR) .and. (NOTU /= 0)) then
  LAR = LTUPQ/NOTU
  LR = LAR/NOP
  if (LR > NBR) LR = NBR
  LAR = NOP*LR
  IAD3S = 0
  call dDAFILE(LUHLF3,0,TUPQ,LAR,IAD3S)
  IAD3 = 0
  IR = 0
  do NR=1,NBR
    IR = IR+1
    do NU=1,NOCS
      IRU = NBR*(NU-1)+NR
      IPQST = 1+NBPQ*(IRU-1)

      ! READ ONE BUFFER OF INTEGRALS BACK INTO CORE

      if (IPQMX1 < NBPQ) then
        !*sta0830
        call RBuf_tra2(LUHLF1,RUPQ,NBPQ,IPQMX1,NORU,IRU,IPQST,IAD1S)
        !*end0830
      end if
      if (ISP == ISQ) then
        call SQUARE(RUPQ(IPQST),X2,1,NBQ,NBQ)
      else
        call DCOPY_(NBPQ,RUPQ(IPQST),1,X2,1)
      end if
      if (ISQ == ISS) then
        call DGEMM_('T','N',NBP,NOCQ-NU+1,NBQ,One,X2,NBQ,CMO(LMOQ2+NBQ*(NU-1)),NBQ,Zero,X1,NBP)
        call DGEMM_('T','N',NOCQ-NU+1,NOP,NBP,One,X1,NBP,CMO(LMOP),NBP,Zero,X2,NOCQ-NU+1)
      else
        call DGEMM_('T','N',NBP,NOCQ,NBQ,One,X2,NBQ,CMO(LMOQ2),NBQ,Zero,X1,NBP)
        call DGEMM_('T','N',NOCQ,NOP,NBP,One,X1,NBP,CMO(LMOP),NBP,Zero,X2,NOCQ)
      end if

      ! INTEGRALS (AT/RU) ARE NOW IN X2 FOR ONE VALUE OF R,U AND ALL
      ! VALUES OF A,T (T >= U IF ISQ == ISS)
      !
      ! SORT THESE INTEGRALS AFTER PAIR INDEX TU, IN CORE IF POSSIBLE
      ! OTHERWISE USE LUHLF3 FOR TEMPORARY STORAGE (SAME POSITION AS FOR
      ! INTEGRALS (TU/PQ)

      if (IR > LR) then
        IR = 1
        !vv do I=1,NOTU
        !vv   call dDAFILE(LUHLF3,1,TUPQ(1+LAR*(I-1)),LAR,IAD3)
        !vv end do
        call dDAFILE(LUHLF3,1,TUPQ,LAR*NOTU,IAD3)
      end if
      NAT = 0
      do NA=1,NOP
        NTM = 1
        if (ISQ == ISS) NTM = NU
        do NT=NTM,NOCQ
          ITU = NOCS*(NT-1)+NU-1
          if (ISQ < ISS) ITU = NOCQ*(NU-1)+NT-1
          if (ISQ == ISS) ITU = (NT**2-NT)/2+NU-1
          NAT = NAT+1
          TUPQ(LAR*ITU+NOP*(IR-1)+NA) = X2(NAT)
        end do
      end do
    end do
  end do

  ! EMPTY LAST BUFFER IF LR < NBR

  if (LR < NBR) then
    !vv do I=1,NOTU
    !vv   call dDAFILE(LUHLF3,1,TUPQ(1+LAR*(I-1)),LAR,IAD3)
    !vv end do
    call dDAFILE(LUHLF3,1,TUPQ,LAR*NOTU,IAD3)
  end if

  ! NOW TRANSFORM INDEX R TO B

  ! FIRST COMPUTE AND SAVE START ADDRESS FOR THIS SYMMETRY BLOCK

  if (ISQ >= ISS) then
    ISPQRS = ((ISQ**2-ISQ)/2+ISS-1)*NSYMP+(ISP**2-ISP)/2+ISR
    IAD2M(2,ISPQRS) = IAD13
    NTMAX = NOCQ
    NUMAX = NOCS
  else
    ISPQRS = ((ISS**2-ISS)/2+ISQ-1)*NSYMP+(ISP**2-ISP)/2+ISR
    IAD2M(3,ISPQRS) = IAD13
    NTMAX = NOCS
    NUMAX = NOCQ
  end if
  KKTU = 0
  IST = 1-NOP*NBR
  do NT=1,NTMAX
    NUM = NUMAX
    if (ISQ == ISS) NUM = NT
    do NU=1,NUM
      KKTU = KKTU+1
      IST = IST+NOP*NBR
      if (LR < NBR) then
        !*sta0830
        call RBuf_tra2(LUHLF3,TUPQ,NBR*NOP,LAR,NOTU,KKTU,IST,IAD3S)
        !*end0830
      end if
      call DGEMM_('T','T',NOR,NOP,NBR,One,CMO(LMOR),NBR,TUPQ(IST),NOP,Zero,X2,NOR)

      ! WRITE THESE BLOCK OF INTEGRALS ON LUINTM

      call GADSum(X2,NOP*NOR)
      call dDAFILE(LUINTM,1,X2,NOP*NOR,IAD13)
    end do
  end do
end if

! SECOND PARTIAL TRANSFORMATION FOR INTEGRALS (PQ/RU)-> (TA/BU)

NOTU = NOCP*NOCS
if (((ISP /= ISQ) .and. (ISQ > ISR)) .and. (NOTU /= 0)) then
  LAR = LTUPQ/NOTU
  LR = LAR/NOQ
  if (LR > NBR) LR = NBR
  LAR = NOQ*LR
  IAD3S = 0
  call dDAFILE(LUHLF3,0,TUPQ,LAR,IAD3S)
  IAD3 = 0
  IRU = 0
  IR = 0
  do NR=1,NBR
    IR = IR+1
    do NU=1,NOCS
      IRU = NBR*(NU-1)+NR
      IPQST = 1+NBPQ*(IRU-1)

      ! READ ONE BUFFER OF INTEGRALS BACK INTO CORE

      if (IPQMX1 < NBPQ) then
        !*sta0830
        call RBuf_tra2(LUHLF1,RUPQ,NBPQ,IPQMX1,NORU,IRU,IPQST,IAD1S)
        !*end0830
      end if
      call DGEMM_('N','N',NBQ,NOCP,NBP,One,RUPQ(IPQST),NBQ,CMO(LMOP2),NBP,Zero,X1,NBQ)
      call DGEMM_('T','N',NOCP,NOQ,NBQ,One,X1,NBQ,CMO(LMOQ),NBQ,Zero,X2,NOCP)

      ! INTEGRALS (TA/RU) ARE NOW IN X2 FOR ONE VALUE OF R,U AND ALL
      ! VALUES OF T,A . NOTE THAT T AND U HERE ALWAYS ARE OF DIFFERENT
      ! SYMMETRIES
      !
      ! SORT THESE INTEGRALS AFTER PAIR INDEX TU, IN CORE IF POSSIBLE
      ! OTHERWISE USE LUHLF3 FOR TEMPORARY STORAGE (SAME POSITION AS FOR
      ! INTEGRALS (TU/PQ)

      if (IR > LR) then
        IR = 1
        !vv do I=1,NOTU
        !vv   call dDAFILE(LUHLF3,1,TUPQ(1+LAR*(I-1)),LAR,IAD3)
        !vv end do
        call dDAFILE(LUHLF3,1,TUPQ,LAR*NOTU,IAD3)

      end if
      NAT = 0
      do NA=1,NOQ
        do NT=1,NOCP
          ITU = NOCS*(NT-1)+NU-1
          NAT = NAT+1
          TUPQ(LAR*ITU+NOQ*(IR-1)+NA) = X2(NAT)
        end do
      end do
    end do
  end do

  ! EMPTY LAST BUFFER IF LR < NBR

  if (LR < NBR) then
    !vv do I=1,NOTU
    !vv   call dDAFILE(LUHLF3,1,TUPQ(1+LAR*(I-1)),LAR,IAD3)
    !vv end do
    call dDAFILE(LUHLF3,1,TUPQ,LAR*NOTU,IAD3)
  end if

  ! NOW TRANSFORM INDEX R TO B

  ! FIRST COMPUTE AND SAVE START ADDRESS FOR THIS SYMMETRY BLOCK

  ISPQRS = ((ISP**2-ISP)/2+ISS-1)*NSYMP+(ISQ**2-ISQ)/2+ISR
  IAD2M(2,ISPQRS) = IAD13
  KKTU = 0
  IST = 1-NOQ*NBR
  do NT=1,NOCP
    do NU=1,NOCS
      KKTU = KKTU+1
      IST = IST+NOQ*NBR
      if (LR < NBR) then
        !*sta0830
        call RBuf_tra2(LUHLF3,TUPQ,NBR*NOQ,LAR,NOTU,KKTU,IST,IAD3S)
        !*end0830
      end if
      call DGEMM_('T','T',NOR,NOQ,NBR,One,CMO(LMOR),NBR,TUPQ(IST),NOQ,Zero,X2,NOR)

      ! WRITE THESE BLOCK OF INTEGRALS ON LUINTM

      call GADSum(X2,NOR*NOQ)
      call dDAFILE(LUINTM,1,X2,NOR*NOQ,IAD13)
    end do
  end do
end if

! SECOND PARTIAL TRANSFORMATION FOR INTEGRALS (PQ/UR)-> (AT/UB)

NOTU = NOCQ*NOCR
if (((ISP /= ISQ) .and. (ISP > ISS)) .and. (NOTU /= 0)) then
  LAR = (LRUPQ+LTUPQ)/NOTU
  LR = LAR/NOP
  if (LR > NBS) LR = NBS
  LAR = NOP*LR
  IAD3S = 0
  call dDAFILE(LUHLF3,0,RUPQ,LAR,IAD3S)
  IAD3 = 0
  IRU = 0
  IR = 0
  do NR=1,NBS
    IR = IR+1
    do NU=1,NOCR
      IRU = NBS*(NU-1)+NR
      IPQST = 1+NBPQ*(IRU-1)

      ! READ ONE BUFFER OF INTEGRALS BACK INTO CORE

      if (IPQMX2 < NBPQ) then
        !*sta0830
        call RBuf_tra2(LUHLF2,URPQ,NBPQ,IPQMX2,NOUR,IRU,IPQST,IAD2S)
        !*end0830
      end if
      call DGEMM_('T','N',NBP,NOCQ,NBQ,One,URPQ(IPQST),NBQ,CMO(LMOQ2),NBQ,Zero,X1,NBP)
      call DGEMM_('T','N',NOCQ,NOP,NBP,One,X1,NBP,CMO(LMOP),NBP,Zero,X2,NOCQ)

      ! INTEGRALS (AT/UR) ARE NOW IN X2 FOR ONE VALUE OF R,U AND ALL
      ! VALUES OF A,T. NOTE THAT T AND U HAVE DIFFERENT SYMMETRIES.
      !
      ! SORT THESE INTEGRALS AFTER PAIR INDEX TU, IN CORE IF POSSIBLE
      ! OTHERWISE USE LUHLF3 FOR TEMPORARY STORAGE (SAME POSITION AS FOR
      ! INTEGRALS (TU/PQ)

      if (IR > LR) then
        IR = 1
        !vv do I=1,NOTU
        !vv   call dDAFILE(LUHLF3,1,RUPQ(1+LAR*(I-1)),LAR,IAD3)
        !vv end do
        call dDAFILE(LUHLF3,1,RUPQ,LAR*NOTU,IAD3)
      end if
      NAT = 0
      do NA=1,NOP
        do NT=1,NOCQ
          ITU = NOCR*(NT-1)+NU-1
          if (ISQ < ISR) ITU = NOCQ*(NU-1)+NT-1
          NAT = NAT+1
          RUPQ(LAR*ITU+NOP*(IR-1)+NA) = X2(NAT)
        end do
      end do
    end do
  end do

  ! EMPTY LAST BUFFER IF LR < NBS

  if (LR < NBS) then
    !vv do I=1,NOTU
    !vv   call dDAFILE(LUHLF3,1,RUPQ(1+LAR*(I-1)),LAR,IAD3)
    !vv end dO
    call dDAFILE(LUHLF3,1,RUPQ,LAR*NOTU,IAD3)
  end if

  ! NOW TRANSFORM INDEX R TO B

  ! FIRST COMPUTE AND SAVE START ADDRESS FOR THIS SYMMETRY BLOCK

  if (ISQ >= ISR) then
    ISPQRS = ((ISQ**2-ISQ)/2+ISR-1)*NSYMP+(ISP**2-ISP)/2+ISS
    IAD2M(2,ISPQRS) = IAD13
    NTMAX = NOCQ
    NUMAX = NOCR
  else
    ISPQRS = ((ISR**2-ISR)/2+ISQ-1)*NSYMP+(ISP**2-ISP)/2+ISS
    IAD2M(3,ISPQRS) = IAD13
    NTMAX = NOCR
    NUMAX = NOCQ
  end if
  KKTU = 0
  IST = 1-NBS*NOP
  do NT=1,NTMAX
    do NU=1,NUMAX
      KKTU = KKTU+1
      IST = IST+NBS*NOP
      if (LR < NBS) then
        !*sta0830
        call RBuf_tra2(LUHLF3,RUPQ,NBS*NOP,LAR,NOTU,KKTU,IST,IAD3S)
        !*end0830
      end if
      call DGEMM_('T','T',NOS,NOP,NBS,One,CMO(LMOS),NBS,RUPQ(IST),NOP,Zero,X2,NOS)

      ! WRITE THESE BLOCK OF INTEGRALS ON LUINTM

      call GADSum(X2,NOS*NOP)
      call dDAFILE(LUINTM,1,X2,NOS*NOP,IAD13)
    end do
  end do
end if

! SECOND PARTIAL TRANSFORMATION FOR INTEGRALS (PQ/UR)-> (TA/UB)

NOTU = NOCP*NOCR
if (((ISP /= ISQ) .and. (ISQ >= ISS)) .and. (NOTU /= 0)) then
  if (ISP == ISR) NOTU = (NOCP**2+NOCP)/2
  LAR = (LRUPQ+LTUPQ)/NOTU
  LR = LAR/NOQ
  if (LR > NBS) LR = NBS
  LAR = NOQ*LR
  IAD3S = 0
  call dDAFILE(LUHLF3,0,RUPQ,LAR,IAD3S)
  IAD3 = 0
  IRU = 0
  IR = 0
  do NR=1,NBS
    IR = IR+1
    do NU=1,NOCR
      IRU = NBS*(NU-1)+NR
      IPQST = 1+NBPQ*(IRU-1)

      ! READ ONE BUFFER OF INTEGRALS BACK INTO CORE

      if (IPQMX2 < NBPQ) then
        !*sta0830
        call RBuf_tra2(LUHLF2,URPQ,NBPQ,IPQMX2,NOUR,IRU,IPQST,IAD2S)
        !*end0830
      end if
      if (ISP == ISR) then
        call DGEMM_('N','N',NBQ,NOCP-NU+1,NBP,One,URPQ(IPQST),NBQ,CMO(LMOP2+NBP*(NU-1)),NBP,Zero,X1,NBQ)
        call DGEMM_('T','N',NOCP-NU+1,NOQ,NBQ,One,X1,NBQ,CMO(LMOQ),NBQ,Zero,X2,NOCP-NU+1)
      else
        call DGEMM_('N','N',NBQ,NOCP,NBP,One,URPQ(IPQST),NBQ,CMO(LMOP2),NBP,Zero,X1,NBQ)
        call DGEMM_('T','N',NOCP,NOQ,NBQ,One,X1,NBQ,CMO(LMOQ),NBQ,Zero,X2,NOCP)
      end if

      ! INTEGRALS (TA/UR) ARE NOW IN X2 FOR ONE VALUE OF R,U AND ALL
      ! VALUES OF A,T
      !
      ! SORT THESE INTEGRALS AFTER PAIR INDEX TU, IN CORE IF POSSIBLE
      ! OTHERWISE USE LUHLF3 FOR TEMPORARY STORAGE (SAME POSITION AS FOR
      ! INTEGRALS (TU/PQ)

      if (IR > LR) then
        IR = 1
        !vv do I=1,NOTU
        !vv   call dDAFILE(LUHLF3,1,RUPQ(1+LAR*(I-1)),LAR,IAD3)
        !vv end do
        call dDAFILE(LUHLF3,1,RUPQ,LAR*NOTU,IAD3)
      end if
      NAT = 0
      do NA=1,NOQ
        NTM = 1
        if (ISP == ISR) NTM = NU
        do NT=NTM,NOCP
          ITU = NOCR*(NT-1)+NU-1
          if (ISP < ISR) ITU = NOCP*(NU-1)+NT-1
          if (ISP == ISR) ITU = (NT**2-NT)/2+NU-1
          NAT = NAT+1
          RUPQ(LAR*ITU+NOQ*(IR-1)+NA) = X2(NAT)
        end do
      end do
    end do
  end do

  ! EMPTY LAST BUFFER IF LR < NBS

  if (LR < NBS) then
    !vv do I=1,NOTU
    !vv   call dDAFILE(LUHLF3,1,RUPQ(1+LAR*(I-1)),LAR,IAD3)
    !vv end do
    call dDAFILE(LUHLF3,1,RUPQ,LAR*NOTU,IAD3)
  end if

  !NOW TRANSFORM INDEX R TO B

  ! FIRST COMPUTE AND SAVE START ADDRESS FOR THIS SYMMETRY BLOCK

  if (ISP >= ISR) then
    ISPQRS = ((ISP**2-ISP)/2+ISR-1)*NSYMP+(ISQ**2-ISQ)/2+ISS
    IAD2M(2,ISPQRS) = IAD13
    NTMAX = NOCP
    NUMAX = NOCR
  else
    ISPQRS = ((ISR**2-ISR)/2+ISP-1)*NSYMP+(ISQ**2-ISQ)/2+ISS
    IAD2M(3,ISPQRS) = IAD13
    NTMAX = NOCR
    NUMAX = NOCP
  end if
  KKTU = 0
  IST = 1-NOQ*NBS
  do NT=1,NTMAX
    NUM = NUMAX
    if (ISP == ISR) NUM = NT
    do NU=1,NUM
      KKTU = KKTU+1
      IST = IST+NOQ*NBS
      if (LR < NBS) then
        !*sta0830
        call RBuf_tra2(LUHLF3,RUPQ,NBS*NOQ,LAR,NOTU,KKTU,IST,IAD3S)
        !*end0830
      end if
      call DGEMM_('T','T',NOS,NOQ,NBS,One,CMO(LMOS),NBS,RUPQ(IST),NOQ,Zero,X2,NOS)

      ! WRITE THESE BLOCK OF INTEGRALS ON LUINTM

      call GADSum(X2,NOS*NOQ)
      call dDAFILE(LUINTM,1,X2,NOS*NOQ,IAD13)
    end do
  end do
end if

! END OF TRANSFORMATION FOR THIS SYMMETRY BLOCK
!
! IAD2M CONTAINS START ADRESS FOR EACH TYPE OF INTEGRALS:
! IAD2M(1,ISPQRS)   COULOMB INTEGRALS (AB|TU)
! IAD2M(2,ISPQRS)   EXCHANGE INTEGRALS <AB|TU> FOR SYM T > SYM U
! IAD2M(3,ISPQRS)   EXCHANGE INTEGRALS <AB|TU> FOR SYM T < SYM U
! THE LAST ADRESS IS ZERO IF SYM T = SYM U
! TO SEE HOW THE INTEGRALS ARE USED LOOK IN RDINT2

return

end subroutine TR2Sq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Dipol_Exchange( N1, N2, vec, dist, M1, M2,  HDIP )
c this Subroutine computes the dipolar coupling between the two moments
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)           :: N1, N2
      Real(kind=8), intent(in)     :: vec(3), dist
      Complex(kind=8), intent(in)  :: M1(3,N1,N1)
      Complex(kind=8), intent(in)  :: M2(3,N2,N2)
      Complex(kind=8), intent(out) :: HDIP(N1,N1,N2,N2)
c local variables
      Integer          :: m,i1,j1,i2,j2
      Real(kind=8)    :: MB2
      Complex(kind=8) :: p2a, p2b, p1, HL, d3, mb2c, threeC, vec1(3)


!     * in cm-1*T-1   -- the value of (mu_Bohr*mu_Bohr)/(Angstrom^3)  in cm-1
      MB2=0.4329701512063995_wp
c
      If( (N1<=0).OR.(N2<=0) ) Return
      Call zcopy_(N1*N1*N2*N2,[(0.0_wp,0.0_wp)],0,HDIP,1)
      If(dist.eq.0.0_wp) Then
        Write(6,'(A)') 'DIPOL_EXCHANGE::  dist = 0'
        Write(6,'(A)') 'this is not normal. Stop.'
        Return
      End If
      ! switch to Complex arithmetic:
      ! kind=8, complex double precision
      d3    =(0.0_wp,0.0_wp)
      mb2c  =(0.0_wp,0.0_wp)
      threeC=(3.0_wp,0.0_wp)
      d3    =cmplx(dist*dist*dist,0.0_wp, wp)
      mb2c  =cmplx(MB2,0.0_wp, wp)
      Do m=1,3
        vec1(m)=cmplx(vec(m),0.0_wp, wp)
      End Do
      ! calculate the dipolar coupling:
      Do i1=1,N1
        Do j1=1,N1
          Do i2=1,N2
            Do j2=1,N2
              p2a=(0.0_wp,0.0_wp)
              p2b=(0.0_wp,0.0_wp)
              p1 =(0.0_wp,0.0_wp)
              HL =(0.0_wp,0.0_wp)
              Do m=1,3
                p2a=p2a+M1(m,i1,j1)*vec1(m)
                p2b=p2b+M2(m,i2,j2)*vec1(m)
                p1 =p1 + M1(m,i1,j1) * M2(m,i2,j2)
              End Do
              HL = p1 - threeC * p2a * p2b
              HDIP(i1,j1,i2,j2)=mb2c * HL / d3
            End Do
          End Do
        End Do
      End Do


      Return
      End Subroutine Dipol_Exchange

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine saoon_cvb(c1,c2,n2,s,n,metr)
c  Put matrix product S*C1 in C2:
      implicit real*8 (a-h,o-z)
      dimension c1(n,n2),c2(n,n2),s(*)

      if(metr.eq.0)then
        call fmove_cvb(c1,c2,n*n2)
      elseif(metr.eq.1)then
        call mxatb_cvb(s,c1,n,n,n2,c2)
      elseif(metr.eq.2)then
        call fzero(c2,n*n2)
        do 100 j=1,n2
        ik=0
        do 200 k=1,n
        do 300 i=1,k-1
        ik=ik+1
        c2(i,j)=c2(i,j)+s(ik)*c1(k,j)
        c2(k,j)=c2(k,j)+s(ik)*c1(i,j)
300     continue
        ik=ik+1
        c2(k,j)=c2(k,j)+s(ik)*c1(k,j)
200     continue
100     continue
      endif
      return
      end
c  *******************************
c  ** Vector sorting and search **
c  *******************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

function TestMinimaxLaplace(Tolerance,Verbose)
!
! Thomas Bondo Pedersen, December 2012.
!
! Test that the minimax code from Ten-no gives correct results
! (test case provided by Ten-no). The minimax code is called
! through routine MinimaxLaplace.
!
! Input:
!    Tolerance -- >=0: defines tolerance for test
!                 <0:  default tolerance used
!    Verbose   -- If .true., print information
!
! Returns:
!    -1: nonzero return code from MinimaxLaplace
!     0: weights OK, grid points OK
!     1: weights wrong, grid points OK
!     2: weights OK, grid points wrong
!     3: weights wrong, grid points wrong

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: TestMinimaxLaplace
real(kind=wp), intent(in) :: Tolerance
logical(kind=iwp), intent(in) :: Verbose
integer(kind=iwp) :: irc, K_Lap, l_t, l_t_ref, l_w, l_w_ref, l_wt
real(kind=wp) :: Emax, Emin, RMSt, RMSw, Tol
real(kind=wp), allocatable :: tmlwr(:), tmltr(:), tmlw(:), tmlt(:)
integer(kind=iwp), parameter :: N = 8
real(kind=wp), parameter :: xmax = 1.08976414_wp, xmin = 1.08976414_wp
real(kind=wp), external :: ddot_

if (Verbose) then
  write(u6,'(//,A)') '>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<'
  write(u6,'(A)') '>>>>>>>>>> Enter TestMinimaxLaplace <<<<<<<<<<'
  write(u6,'(A,//)') '>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<'
  call xFlush(u6)
end if

if (Tolerance < Zero) then
  Tol = 1.0e-7_wp
else
  Tol = Tolerance
end if

l_w_ref = N
l_t_ref = N
l_w = N
l_t = N
call mma_allocate(tmlwr,l_w_ref,Label='tmlwr')
call mma_allocate(tmltr,l_t_ref,Label='tmltr')
call mma_allocate(tmlw,l_w,Label='tmlw')
call mma_allocate(tmlt,l_t,Label='tmlt')

tmlwr(1) = 0.097293042801116517_wp
tmlwr(2) = 0.237233954792368945_wp
tmlwr(3) = 0.407050561470959249_wp
tmlwr(4) = 0.635894859784969846_wp
tmlwr(5) = 0.973101625527261427_wp
tmlwr(6) = 1.505487565587009913_wp
tmlwr(7) = 2.419319385961121949_wp
tmlwr(8) = 4.393171503147499379_wp

tmltr(1) = 0.03771106629456916_wp
tmltr(2) = 0.20333950465288628_wp
tmltr(3) = 0.52200685559948912_wp
tmltr(4) = 1.03690003666258002_wp
tmltr(5) = 1.82953857756319826_wp
tmltr(6) = 3.04727454214513793_wp
tmltr(7) = 4.96421466224179220_wp
tmltr(8) = 8.21146012481546705_wp

K_Lap = N
Emin = xmin
Emax = xmax
l_wt = N
call MinimaxLaplace(Verbose,K_Lap,Emin,Emax,l_wt,tmlw,tmlt,irc)
if (Verbose) then
  write(u6,'(A,I6)') 'Return code from MinimaxLaplace=',irc
  call xFlush(u6)
end if
if (irc /= 0) then
  irc = -1
else
  tmlw(1:N) = tmlw(1:N)-tmlwr(1:N)
  tmlt(1:N) = tmlt(1:N)-tmltr(1:N)
  RMSw = sqrt(dDot_(N,tmlw,1,tmlw,1)/real(N,kind=wp))
  RMSt = sqrt(dDot_(N,tmlt,1,tmlt,1)/real(N,kind=wp))
  if (Verbose) then
    write(u6,'(A,ES25.16)') 'Weight RMS error=    ',RMSw
    write(u6,'(A,ES25.16)') 'Grid point RMS error=',RMSt
    write(u6,'(A,ES25.16)') 'Tolerance=           ',Tol
    call xFlush(u6)
  end if
  irc = 0
  if (RMSw > Tol) irc = irc+1
  if (RMSt > Tol) irc = irc+2
end if

call mma_deallocate(tmlt)
call mma_deallocate(tmlw)
call mma_deallocate(tmltr)
call mma_deallocate(tmlwr)

if (Verbose) then
  write(u6,'(A,I3)') 'TestMinimaxLaplace=',irc
  write(u6,'(//,A)') '>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<'
  write(u6,'(A)') '>>>>>>>>>> Exit TestMinimaxLaplace <<<<<<<<<<'
  write(u6,'(A,//)') '>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<'
  call xFlush(u6)
end if

TestMinimaxLaplace = irc

end function TestMinimaxLaplace

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine strip_blanks_cvb(line,lenline,blanks,nblank,blankdelim)
c  If BLANKDELIM, a given number of blanks (not leading or trailing)
c  will be subsituted by a single blank. Otherwise all blanks are
c  stripped.
      implicit real*8 (a-h,o-z)
      logical blankdelim
      character*(*) line
      character*1 blanks(nblank)
#include "malloc_cvb.fh"

      do 100 iblank=1,nblank
      if(blanks(iblank).ne.' ')then
        do 200 ich=1,lenline
        if(line(ich:ich).eq.blanks(iblank))line(ich:ich)=' '
200     continue
      endif
100   continue
      ilv=mstacki_cvb(lenline)
      ich2=0
      do 300 ich=1,lenline
      if(line(ich:ich).ne.' ')then
        ich2=ich2+1
        iw(ich2+ilv-1)=ich
c  (Final condition eliminates leading blanks :)
      elseif(blankdelim.and.ich.ge.2.and.line(ich-1:ich-1).ne.' '
     >  .and.ich2.ne.0)then
        ich2=ich2+1
        iw(ich2+ilv-1)=ich
      endif
300   continue
      do 400 ich=1,ich2
      line(ich:ich)=line(iw(ich+ilv-1):iw(ich+ilv-1))
400   continue
      lenline=ich2
      call mfreei_cvb(ilv)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FetchTDM(nB,nS,iBigT,TDMchar)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "WrkSpc.fh"

      Dimension iTocBig(MxStOT)

      Character TDMchar*6

      iDisk=0
      kaunter=0
      nSize=nB*(nB+1)/2
      index=0
      Lu=72
      Lu=IsFreeUnit(Lu)
      Call DaName(Lu,TDMchar)
      Call iDaFile(Lu,2,iTocBig,MxStOT,iDisk)
      Do 99991, iS1=1,nS
        Do 99992, iS2=1,iS1
          kaunter=kaunter+1
          iDisk=iTocBig(kaunter)
          Call dDaFile(Lu,2,Work(iBigT+index),nSize,iDisk)
          index=index+nSize
99992   Continue
99991 Continue
      Call DaClos(Lu)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contf4(wrk,wrksize,lunt2o1,lunt2o2,lunt2o3)
! this routine does: FIV1,FIV2,T22

!     FIV1
!1    FIV(b,e)aa <= FI(b,e)aa
!2    FIV(b,e)bb <= FI(b,e)bb
!
!     FIV2
!3    FIV(b,e)aa <- -0.5 sum(m-a) [ T1o(b,m)aa . FIII(e,m)aa ]
!4    FIV(b,e)bb <- -0.5 sum(m-b) [ T1o(b,m)bb . FIII(e,m)bb ]
!
!     T22
!5    Q(c,d,ij)aaaa   <- - sum(e-a) [ FIV(c,e)aa . T2o(e,d,ij)aaaa ]
!5    T2n(ab,ij)aaaa   <- Q(b,a,ij)aaaa - Q(a,b,ij)aaaa
!6    Q(c,d,ij)bbbb   <- - sum(e-b) [ FIV(c,e)bb . T2o(e,d,ij)bbbb ]
!6    T2n(ab,ij)bbbb   <- Q(b,a,ij)bbbb - Q(a,b,ij)bbbb
!7    T2n(a,b,i,j)abab <- sum (e-a)  [ FIV(a,e)aa . T2o(e,b,i,j)abab ]
!8    T2n(a,b,i,j)abab <- sum (e-b)  [ FIV(b,e)bb . T2o(a,e,i,j)abab ]
!
! N.B. use and destroy : V1,V2,V3,M1,M2,M3
! N.B. # of read       : 3
! N.B. Parallel : in the case where idaaaa /= idbaab and
!      idaaaa /= idbaab this routine runs contributions to
!      T2n also on idaaaa and idbbbb nodes, but only with
!      FIV = FI, since on these nodes there is a specific
!      part of contributions F13 (see notes in sumoverb routine)
!      which are not presented on pilot nodes

use ccsd_global, only: f11, f12, f31, f32, idaaaa, idaabb, idbaab, idbbbb, m1, m2, m3, t11, t12, t21, t22, t23, v1, v2, v3
use Para_Info, only: MyRank
use Constants, only: One, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp), intent(_IN_) :: lunt2o1, lunt2o2, lunt2o3
integer(kind=iwp) :: post, rc, ssc

!par
if ((myRank == idbaab) .or. (myRank == idaabb) .or. (myRank == idaaaa) .or. (myRank == idbbbb)) then
  !78.0 read V1(c,d,i,j) <= T2o(c,d,i,j)abab
  call filemanager(2,lunt2o3,rc)
  call getmediate(wrk,wrksize,lunt2o3,v1,rc)
end if

!1 FIV(b,e)aa <= FI(b,e)aa

!par
if ((myRank == idbaab) .or. (myRank == idaaaa)) then

  !1.1 map M1(b,e) <= F1(b,e)aa
  call map(wrk,wrksize,2,1,2,0,0,f11,1,m1,post,rc)

end if

!3 FIV(b,e)aa <- -0.5 sum(m-a) [ T1o(b,m)aa . FIII(e,m)aa ]

!par
if (myRank == idbaab) then

  !3.1 map M2(m,e) <= f3(e,m)aa
  call map(wrk,wrksize,2,2,1,0,0,f31,1,m2,post,rc)

  !3.2 mult M3(b,e) <= T1o(b,m)aa . M2(m,e)
  call ccmult(wrk,wrksize,2,2,2,1,t11,1,m2,1,m3,ssc,rc)

  !3.3 add M1(b,e) <- -0.5 M3(b,e)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,-Half,m3,1,m1,1,rc)

end if
!parend

!par
if ((myRank == idbaab) .or. (myRank == idaaaa)) then

  !5 Q(c,d,ij)aaaa   <- - sum(e-a) [ FIV(c,e)aa . T2o(e,d,ij)aaaa ]
  !5 T2n(ab,ij)aaaa   <- Q(b,a,ij)aaaa - Q(a,b,ij)aaaa

  !5.1 read V2(ed,ij) <= T2o(ed,ij)aaaa
  call filemanager(2,lunt2o1,rc)
  call getmediate(wrk,wrksize,lunt2o1,v2,rc)

  !5.2 expand V3(e,d,ij) <= V2 (ed,ij)
  call expand(wrk,wrksize,4,5,v2,1,v3,rc)

  !5.3 mult V2(c,d,ij) <= M1(c,e) . V3(e,d,ij)
  call ccmult(wrk,wrksize,2,4,4,1,m1,1,v3,1,v2,ssc,rc)

  !5.4 pack V3(ab,ij) <= V2(a,b,ij) - V2(b,a,ij)
  call fack(wrk,wrksize,4,4,v2,1,v3,rc)

  !5.5 add T2n(ab,ij)aaaa <- V3(ab,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,t21,1,rc)

  !7 T2n(a,b,i,j)abab <- sum (e-a)  [ FIV(a,e)aa . T2o(e,b,i,j)abab ]

  !7.1 mult V2(a,b,i,j) <= M1(a,e) . V1(e,b,i,j)
  call ccmult(wrk,wrksize,2,4,4,1,m1,1,v1,1,v2,ssc,rc)

  !7.2 add T2n(a,b,i,j)abab <- V2(a,b,i,j)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v2,1,t23,1,rc)

end if
!parend

!2 FIV(b,e)bb <= FI(b,e)bb

!par
if ((myRank == idaabb) .or. (myRank == idbbbb)) then

  !2.1 map M1(b,e) <= F1(b,e)bb
  call map(wrk,wrksize,2,1,2,0,0,f12,1,m1,post,rc)

end if

!4 FIV(b,e)bb <- -0.5 sum(m-b) [ T1o(b,m)bb . FIII(e,m)bb ]

!par
if (myRank == idaabb) then

  !4.1 map M2(m,e) <= f3(e,m)bb
  call map(wrk,wrksize,2,2,1,0,0,f32,1,m2,post,rc)

  !4.2 mult M3(b,e) <= T1o(b,m)bb . M2(m,e)
  call ccmult(wrk,wrksize,2,2,2,1,t12,1,m2,1,m3,ssc,rc)

  !4.3 add M1(b,e) <- -0.5 M3(b,e)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,-Half,m3,1,m1,1,rc)

end if
!parend

!par
if ((myRank == idaabb) .or. (myRank == idbbbb)) then

  !6 Q(c,d,ij)bbbb   <- - sum(e-b) [ FIV(c,e)bb . T2o(e,d,ij)bbbb ]
  !6 T2n(ab,ij)bbbb   <- Q(b,a,ij)bbbb - Q(a,b,ij)bbbb

  !6.1 read V2(cd,ij) <= T2o(cd,ij)bbbb
  call filemanager(2,lunt2o2,rc)
  call getmediate(wrk,wrksize,lunt2o2,v2,rc)

  !6.2 expand V3(e,d,ij) <= V2 (cd,ij)
  call expand(wrk,wrksize,4,5,v2,1,v3,rc)

  !6.3 mult V2(c,d,ij) <= M1(c,d) . V3(e,d,ij)
  call ccmult(wrk,wrksize,2,4,4,1,m1,1,v3,1,v2,ssc,rc)

  !6.4 pack V3(ab,ij) <= V2(a,b,ij) - V2(b,a,ij)
  call fack(wrk,wrksize,4,4,v2,1,v3,rc)

  !6.5 add T2n(ab,ij)bbbb <- V3(ab,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,t22,1,rc)

  !8 T2n(a,b,i,j)abab <- sum (e-b)  [ FIV(b,e)bb . T2o(a,e,i,j)abab ]

  !8.1 map V3(e,a,i,j) <= V1(a,e,i,j)
  call map(wrk,wrksize,4,2,1,3,4,v1,1,v3,post,rc)

  !8.2 mult V2(b,a,i,j) <= M1(b,e) . V3(e,a,i,j)
  call ccmult(wrk,wrksize,2,4,4,1,m1,1,v3,1,v2,ssc,rc)

  !8.3 map V3(a,b,i,j) <= V2(b,a,i,j)
  call map(wrk,wrksize,4,2,1,3,4,v2,1,v3,post,rc)

  !8.4 add T2n(a,b,i,j)abab <- V3(a,b,i,j)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,One,v3,1,t23,1,rc)

end if
!parend

return

end subroutine contf4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Fold(nSym,nBas,A,B)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Fold up symmetry blocked matrix A stored as square blocks        *
*     into triangular matrices and scale the off-diagonal elements     *
*     by a factor of 2 (two). The input and output matrices may be     *
*     identical.                                                       *
*                                                                      *
*     calling arguments:                                               *
*     nSym    : input, integer                                         *
*               number of symmetry blocks                              *
*     nBas    : input, array of integers                               *
*               matrix dimension per symmetry block                    *
*     A       : input, array of real*8                                 *
*               Unfolded input matrix                                  *
*     B       : output, array of real*8                                *
*               Folded output matrix                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension nBas(*) , A(*) , B(*)

      Parameter ( Two=2.0d0 )

      iOff1 = 0
      iOff2 = 0
      Do iSym = 1, nSym
        mBas = nBas(iSym)
        Do iBas= 1, mBas
          Do jBas = 1 , iBas-1
            B(iOff2+jBas) =  Two * A(iOff1+jBas)
          End Do
          B(iOff2+iBas) =  A(iOff1+iBas)
          iOff1 = iOff1 + mBas
          iOff2 = iOff2 + iBas
        End Do
      End Do

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine casinfoinp_cvb()
      implicit real*8 (a-h,o-z)
#include "casinfo_cvb.fh"
      parameter (nstrin=6,ncmp=4)
      character*8 string
      dimension string(nstrin)
      save string
      data string/'RAS2    ','INACTIVE','FROZEN  ','NACTEL  ',
     >  'SPIN    ','SYMMETRY'/
      dimension nactel(3)
      save one
      data one/1d0/

1000  call fstring_cvb(string,nstrin,istr,ncmp,2)

      if(istr.eq.1)then
c 'RAS2'
        call izero(iorocc_d,mxirrep_ci)
        call int_cvb(iorocc_d,mxirrep_ci,nread,1)
      elseif(istr.eq.2)then
c 'INACTIVE'
        call izero(iorclos_d,mxirrep_ci)
        call int_cvb(iorclos_d,mxirrep_ci,nread,1)
      elseif(istr.eq.3)then
c 'FROZEN'
        call izero(iorcore_d,mxirrep_ci)
        call int_cvb(iorcore_d,mxirrep_ci,nread,1)
      endif
      if(istr.eq.4.or.istr.eq.5.or.istr.eq.6)then
c 'NACTEL' or 'SPIN' or 'SYMMETRY'
        if(nstsym_d.eq.0)then
          call izero(istnel_d,mxstsy_ci)
          call izero(istsy_d,mxstsy_ci)
          call izero(istms2_d,mxstsy_ci)
          call izero(nstats_d,mxstsy_ci)
          call fzero(weight_d,mxstt_ci*mxstsy_ci)
          nstsym_d=1
          istsy_d(nstsym_d)=1
          nstats_d(nstsym_d)=1
          weight_d(1,nstsym_d)=one
        endif
      endif
      if(istr.eq.4)then
c 'NACTEL'
        call izero(nactel,3)
        call int_cvb(nactel,3,nread,1)
        if(nactel(2).ne.0.or.nactel(3).ne.0)then
          write(6,*)' Illegal NACTEL read :',nactel
          write(6,*)' Use CASVB only with CASSCF wavefunctions!'
          call abend_cvb()
        endif
        istnel_d(nstsym_d)=nactel(1)
      elseif(istr.eq.5)then
c 'SPIN'
        call int_cvb(istms2_d(nstsym_d),1,nread,1)
        istms2_d(nstsym_d)=istms2_d(nstsym_d)-1
      elseif(istr.eq.6)then
c 'SYMMETRY'
        call int_cvb(istsy_d(nstsym_d),1,nread,1)
      endif
c Unrecognized keyword -- end of input :
      if(istr.ne.0)goto 1000
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Martin Schuetz                                   *
!               2017, Roland Lindh                                     *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

!#define _DEBUGPRINT_
subroutine vOO2OV_inner(v1,n1,v2,n2,iD)
!***********************************************************************
!                                                                      *
!     purpose: converts vector of dim nOO (e.g. gradient) to vector    *
!              of lower dimension nOV (occ-virt block only)            *
!              if n1==nOO && n2==nOV  -> compress                      *
!              else if if n1==nOV && n2==nOO -> decompress             *
!                                                                      *
!     output:                                                          *
!       v2      : compressed or decompressed vector, dep. on input     *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. Schuetz                                                       *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!     Roland Lindh                                                     *
!     Uppsala University, Sweden, 2017                                 *
!     Fortran pointer structure                                        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use InfSCF, only: kOV, nFro, nOcc, nOO, nOrb, nSym
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: n1, n2, iD
real(kind=wp), target, intent(in) :: v1(n1)
real(kind=wp), target, intent(inout) :: v2(n2)
integer(kind=iwp) :: ii, ioffs, iSym, ivoffs, nia1, nia2, nii1, nii2, nv1, nv2
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iOff, nO, nV
#endif
real(kind=wp), pointer :: pv1(:,:), pv2(:,:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

#ifdef _DEBUGPRINT_
write(u6,*) 'n1,n2,nOO,kOV(:)=',n1,n2,nOO,kOV(:)
iOff = 1
do iSym=1,nSym
  if (n1 == nOO) then
    nO = nOrb(iSym)
    call RecPrt('vOO2OV: v1',' ',v1(ioff),nO,nO)
    iOff = iOff+nO**2
  else if (n1 == kOV(iD)) then
    nO = nOcc(iSym,iD)-nFro(iSym)
    nV = nOrb(iSym)-nOcc(iSym,iD)-nFro(iSym)
    call RecPrt('vOO2OV: v1',' ',v1(ioff),nO,nV)
    iOff = iOff+nO*nV
  end if
end do
#endif
ioffs = 0
ivoffs = 1
do iSym=1,nSym
  ! range for occupied non-frozen orbitals
  nii1 = nFro(iSym)+1
  nii2 = nOcc(iSym,iD)
  ! range for virtual orbitals
  nia1 = nOcc(iSym,iD)+1
  nia2 = nOrb(iSym)
  ! size of the full block
  nv1 = nia2**2
  ! size of the virtual-occupied block
  nv2 = (nia2-nia1+1)*(nii2-nii1+1)

  if ((nv1 > 0) .and. (nv2 > 0)) then
    if ((n1 == nOO) .and. (n2 == kOV(iD))) then

      ! compress

      pv1(1:nia2,1:nia2) => v1(ioffs+1:ioffs+nv1)
      pv2(nia1:nia2,nii1:nii2) => v2(ivoffs:ivoffs+nv2-1)

      !do ii=nii1,nii2
      !  do ia=nia1,nia2
      !    if (pv1(ia,ii) /= -pv1(ii,ia)) then
      !      write(u6,*) 'inconsistency in gradient'
      !      call Abend()
      !    end if
      !  end do
      !end do
      pv2(nia1:nia2,nii1:nii2) = pv1(nia1:nia2,nii1:nii2)

    else if ((n1 == kOV(iD)) .and. (n2 == nOO)) then

      ! decompress

      pv1(nia1:nia2,nii1:nii2) => v1(ivoffs:ivoffs+nv2-1)
      pv2(1:nia2,1:nia2) => v2(ioffs+1:ioffs+nv1)

      pv2(nia1:nia2,nii1:nii2) = pv1(nia1:nia2,nii1:nii2)
      do ii=nii1,nii2
        pv2(ii,nia1:nia2) = -pv1(nia1:nia2,ii)
      end do
    end if

    nullify(pv1,pv2)
    ivoffs = ivoffs+nv2
  end if
  ioffs = ioffs+(nOrb(iSym)*nOrb(iSym))
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'n1,n2,nOO,kOV=',n1,n2,nOO,kOV(:)
iOff = 1
do iSym=1,nSym
  if (n2 == nOO) then
    nO = nOrb(iSym)
    call RecPrt('vOO2OV: v2',' ',v2(ioff),nO,nO)
    iOff = iOff+nO**2
  else if (n2 == kOV(iD)) then
    nO = nOcc(iSym,iD)-nFro(iSym)
    nV = nOrb(iSym)-nOcc(iSym,iD)-nFro(iSym)
    call RecPrt('vOO2OV: v2',' ',v2(ioff),nO,nV)
    iOff = iOff+nO*nV
  end if
end do
#endif

return

#undef _DEBUGPRINT_
end subroutine vOO2OV_inner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRSYM(A,MATDIM)
! PRINT LOWER HALF OF A SYMMETRIC MATRIX OF DIMENSION MATDIM.
! THE LOWER HALF OF THE MATRIX IS SUPPOSED TO BE IN VECTOR A.

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: MATDIM
real(kind=wp), intent(in) :: A(nTri_Elem(MATDIM))
integer(kind=iwp) :: I, J, JSTART, JSTOP

JSTART = 1
JSTOP = 0
do I=1,MATDIM
  JSTART = JSTART+I-1
  JSTOP = JSTOP+I
  write(u6,1010) I,(A(J),J=JSTART,JSTOP)
end do

return
1010 format('0',2X,I3,5(ES14.7),/,(1X,5X,5(ES14.7)))

end subroutine PRSYM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*     nSh2BF   - field with dim. nIrrep,nShlls
*                # SO functions in irrep for shell iShell
*     iShOff   - field with dim. nIrrep,nShlls
*                position of 1st component of iShell in irrep
*     iSh2Sh   - field with dim. nShlls*nIrrep
*                pseudo shell index of iShell in irrep
*                (not any iShell contributes to all irreps)
*     nShIrp(0:nIrrep-1)
*              - # of shells contributing to each irrep
*     nShBFMx  - largest shell size (of all irrep, all shells)
*     iSO2Sh   - field with dim. nDim
*                shell the SO index iSO in irp belongs to
*     icntr  - field holding center number for each shell
*
      Module Index_arrays
      Integer nShIrp(0:7),nShBFMx
      Integer, Allocatable:: nShBF(:,:), iShOff(:,:), iSh2Sh(:,:),
     &                       iSO2Sh(:), iCntr(:)
      End Module Index_arrays

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! look for partial loops in active space drt and save them into disk
subroutine guga_ploop(npl,maxplcon)

use gugaci_global, only: idisk_array, idisk_lp, LuLoop, mhlpmax
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: npl, maxplcon

maxplcon = 0
mhlpmax = 0
idisk_lp = 0
idisk_array = 0
call idafile(luloop,1,idisk_array,13,idisk_lp)
npl = 0
call vd_lp_search(npl)
call dv_lp_search(npl)
call dd_lp_search(npl)
call dt_lp_search(npl)
call ds_lp_search(npl)
call tv_lp_search(npl)
call td_lp_search(npl)
call tt_lp_search(npl)
call ts_lp_search(npl)
call sv_lp_search(npl)
call sd_lp_search(npl)
call st_lp_search(npl)
call ss_lp_search(npl)

maxplcon = mhlpmax
idisk_lp = 0
call idafile(luloop,1,idisk_array,13,idisk_lp)
write(u6,'(4x,a,i20)') 'Max number of partial loops: ',mhlpmax
!write(u6,*) 'idisk_array'
!write(u6,'(13i8)') idisk_array

return

end subroutine guga_ploop

subroutine sv_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_sv, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(10) = idisk_lp

imr = 1
do iml_=1,ng_sm
  iml = iml_
  call act_lp_search(4,4,1)     !id=4
end do
lpblock_sv = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'sv:',lpblock,mhsum !,idisk_array(10),idisk_l

return

end subroutine sv_lp_search

subroutine sd_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_sd, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_, imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(11) = idisk_lp

do iml_=1,ng_sm
  iml = iml_
  do imr_=1,ng_sm
    imr = imr_
    call act_lp_search(1,4,2)    !id=1
  end do
end do
lpblock_sd = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'sd:',lpblock,mhsum

return

end subroutine sd_lp_search

subroutine st_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_st, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_, imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(12) = idisk_lp

do iml_=1,ng_sm
  iml = iml_
  do imr_=1,ng_sm
    imr = imr_
    call act_lp_search(3,4,3)   !id=3
  end do
end do
lpblock_st = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'st:',lpblock,mhsum

return

end subroutine st_lp_search

subroutine ss_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_ss, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_, imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(13) = idisk_lp

do iml_=1,ng_sm
  iml = iml_
  do imr_=1,ng_sm
    imr = imr_
    call act_lp_search(3,4,4)    !id=3
  end do
end do
lpblock_ss = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'ss:',lpblock,mhsum

return

end subroutine ss_lp_search

subroutine tv_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_tv, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(6) = idisk_lp

imr = 1
do iml_=1,ng_sm
  iml = iml_
  call act_lp_search(4,3,1)       !id=4
end do
lpblock_tv = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'tv:',lpblock,mhsum

return

end subroutine tv_lp_search

subroutine td_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_td, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_, imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(7) = idisk_lp

do iml_=1,ng_sm
  iml = iml_
  do imr_=1,ng_sm
    imr = imr_
    call act_lp_search(1,3,2)    !id=1
  end do
end do
lpblock_td = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'td:',lpblock,mhsum

return

end subroutine td_lp_search

subroutine tt_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_tt, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_, imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(8) = idisk_lp

do iml_=1,ng_sm
  iml = iml_
  do imr_=1,ng_sm
    imr = imr_
    call act_lp_search(3,3,3)    !id=3
  end do
end do
lpblock_tt = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'tt:',lpblock,mhsum

return

end subroutine tt_lp_search

subroutine ts_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_ts, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_, imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(9) = idisk_lp

do iml_=1,ng_sm
  iml = iml_
  do imr_=1,ng_sm
    imr = imr_
    call act_lp_search(3,3,4)    !id=3
  end do
end do
lpblock_ts = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'ts:',lpblock,mhsum

return

end subroutine ts_lp_search

subroutine dv_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_dv, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(2) = idisk_lp

imr = 1
do iml_=1,ng_sm
  iml = iml_
  call act_lp_search(1,2,1)      !id=1
end do
lpblock_dv = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'dv:',lpblock,mhsum

return

end subroutine dv_lp_search

subroutine dd_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_dd, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_, imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(3) = idisk_lp

do iml_=1,ng_sm
  iml = iml_
  do imr_=1,ng_sm
    imr = imr_
    call act_lp_search(3,2,2)    !id=3
  end do
end do
lpblock_dd = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'dd:',lpblock,mhsum

return

end subroutine dd_lp_search

subroutine dt_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_dt, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_, imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(4) = idisk_lp

do iml_=1,ng_sm
  iml = iml_
  do imr_=1,ng_sm
    imr = imr_
    call act_lp_search(2,2,3)      !id=2
  end do
end do
lpblock_dt = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'dt:',lpblock,mhsum

return

end subroutine dt_lp_search

subroutine ds_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_ds, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: iml_, imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(5) = idisk_lp

do iml_=1,ng_sm
  iml = iml_
  do imr_=1,ng_sm
    imr = imr_
    call act_lp_search(2,2,4)    !id=2
  end do
end do
lpblock_ds = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'ds:',lpblock,mhsum

return

end subroutine ds_lp_search

subroutine vd_lp_search(npl)

use gugaci_global, only: idisk_array, idisk_lp, iml, imr, lp_count, lpblock, lpblock_vd, mhsum, ng_sm
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: npl
integer(kind=iwp) :: imr_

mhsum = 0
lpblock = 0
lp_count(1:22) = 0
idisk_array(1) = idisk_lp

iml = 1
do imr_=1,ng_sm
  imr = imr_
  call act_lp_search(2,1,2)       !id=2
end do
lpblock_vd = lpblock
npl = npl+mhsum
write(u6,'(a15,2i10)') 'vd:',lpblock,mhsum

return

end subroutine vd_lp_search

subroutine act_lp_search(id,iptyl,iptyr)

use gugaci_global, only: iml, imr, ipae, ipael, jml, jmr, jpad, jpadl, jpadlr, jpae, jpael, map_jplr, ndim, ng_sm, ns_sm, nu_ad, &
                         nu_ae
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: id, iptyl, iptyr
integer(kind=iwp) :: ide, ipaer, jml_, jmlend, jmlsta, jmr_, jmrend, jmrsta, jpadr, jpaer, jptyl, jptyr, jptyrend

call get_jp(iptyl,iml,ipael,0)
call get_jp(iptyr,imr,ipaer,0)

jpael = nu_ae(ipael)
jpaer = nu_ae(ipaer)
if ((jpael == 0) .or. (jpaer == 0)) return
ide = 0
if ((iptyl == 4) .and. (iptyr == 4)) ide = 1
if ((iptyl == 4) .and. (iptyr == 3)) ide = 2
if ((iptyl == 3) .and. (iptyr == 4)) ide = 2
do jptyl=1,6            !1,6???
  jptyrend = 6
  if (jptyl == 1) jptyrend = 1
  jmlsta = 1
  jmlend = ng_sm
  if (jptyl == 1) jmlsta = ns_sm
  if (jptyl == 1) jmlend = ns_sm
  do jml_=jmlsta,jmlend
    jml = jml_          ! jml is in global module, is this necessary?
    call get_jp(jptyl,jml,jpadl,0)
    if (nu_ad(jpadl) == 0) cycle
    jpad = jpadl
    jpae = jpael
    ipae = ipael
    call seg_drt()
    if (ndim == 0) cycle
    call copy_to_drtl()
    do jptyr=1,jptyrend
      jmrsta = 1
      jmrend = ng_sm
      if (jptyr == 1) jmrsta = ns_sm
      if (jptyr == 1) jmrend = ns_sm
      do jmr_=jmrsta,jmrend
        jmr = jmr_      ! jmr is in global module, is this necessary?
        call get_jp(jptyr,jmr,jpadr,0)
        if (nu_ad(jpadr) == 0) cycle
        jpad = jpadr
        jpae = jpaer
        ipae = ipaer
        call seg_drt()
        if (ndim == 0) cycle
        jpadlr = map_jplr(jptyl,jptyr)
        if (id == 1) call lp_head_in_dbl_1()
        if (id == 2) call lp_head_in_dbl_2()
        if (id == 3) call lp_head_in_dbl_3(ide)
        if (id == 4) call lp_head_in_dbl_4()
        if (jpadl /= jpadr) cycle
        if (id == 1) call lp_head_in_act_1()
        if (id == 2) call lp_head_in_act_2()
        if (id == 3) call lp_head_in_act_3(ide)
        if (id == 4) call lp_head_in_act_4()
      end do
    end do
  end do
end do

return

end subroutine act_lp_search

subroutine lp_head_in_act_1()      !for dv,td,sd

use gugaci_global, only: iml, imr, intind_ijka, linelp, log_prod, logic_br, lpblock, lsm_inn, mhlp, ngw2, ngw3, nlg1, nlg2, &
                         norb_dz, norb_frz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ijk, imlr, intpos, lma, lmai, lmk, lra, lrai, lraj, lrak, lsmi, lsmij, lsmj, lsmk, mh

imlr = Mul(iml,imr)
do lra=norb_dz+1,norb_inn
  lma = lsm_inn(lra)
  if (lma /= imlr) cycle
  ! line=1 a&r<-->a^r
  call head_ar_at_given_orb(mh,lra)
  call link_c1_to_given_orb_coe(mh,lra+1,norb_inn)
  if (mh == 0) cycle
  call value_sort_ploop(mh,.true.,.true.,.false.)
  if (log_prod == 3) then
    linelp = 1
    mhlp = mh
    nlg1 = lra
    nlg2 = 0
    call ext_head_in_act()
  else
    call save_lp(1,mh,lra,0)
    lpblock = lpblock+1
  end if
end do

do lrai=norb_dz+1,norb_inn
  lsmi = lsm_inn(lrai)
  do lraj=lrai+1,norb_inn
    lsmj = lsm_inn(lraj)
    lsmij = Mul(lsmi,lsmj)
    lmk = Mul(lsmij,imlr)
    do lrak=lraj+1,norb_inn
      lsmk = lsm_inn(lrak)
      if (lmk /= lsmk) cycle
      ijk = lrai-norb_frz+ngw2(lraj-norb_frz)+ngw3(lrak-norb_frz)
      intpos = intind_ijka(ijk)
      ! line=4  a&r--b&r--b^r<-->a^r
      call head_ar_at_given_orb(mh,lrai)
      call link_c1_to_given_orb(mh,lrai+1,lraj-1)
      call link_b4_at_given_orb(mh)
      logic_br(1:mh) = .true.
      call link_c2_to_given_orb(mh,lraj+1,lrak-1)
      call link_b2_at_given_orb(mh)
      call link_c1_to_given_orb(mh,lrak+1,norb_inn)
      if (mh /= 0) then
        call value_sort_ploop(mh,.false.,.true.,.true.)
        if (log_prod == 3) then
          linelp = 4
          mhlp = mh
          nlg1 = intpos
          nlg2 = 0
          call ext_head_in_act()
        else
          call save_lp(4,mh,intpos,0)
          lpblock = lpblock+1
        end if
      end if
      ! line=7 a&r--b&l--b^l<-->a^r
      call head_ar_at_given_orb(mh,lrai)
      call link_c1_to_given_orb(mh,lrai+1,lraj-1)
      call link_b3_at_given_orb(mh)
      logic_br(1:mh) = .true.
      call link_c2_to_given_orb(mh,lraj+1,lrak-1)
      call link_b1_at_given_orb(mh)
      call link_c1_to_given_orb(mh,lrak+1,norb_inn)
      if (mh == 0) cycle
      call value_sort_ploop(mh,.false.,.true.,.true.)
      if (log_prod == 3) then
        linelp = 7
        mhlp = mh
        nlg1 = intpos
        nlg2 = 0
        call ext_head_in_act()
      else
        call save_lp(7,mh,intpos,0)
        lpblock = lpblock+1
      end if
    end do
  end do
end do
do lrai=norb_dz+2,norb_inn
  lmai = lsm_inn(lrai)
  if (lmai /= imlr) cycle
  do lrak=norb_dz+1,lrai-1
    ! line=10 d&rr--b^r<-->a^r
    call head_drr_at_given_orb(mh,lrak)
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrak+1,lrai-1)
    call link_b2_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrai+1,norb_inn)
    if (mh /= 0) then
      call value_sort_ploop(mh,.false.,.true.,.true.)
      if (log_prod == 3) then
        linelp = 10
        mhlp = mh
        nlg1 = lrak
        nlg2 = lrai
        call ext_head_in_act()
      else
        call save_lp(10,mh,lrak,lrai)
        lpblock = lpblock+1
      end if
    end if
    ! line=12 d&rl--b^l<-->a^r
    call head_drl_at_given_orb(mh,lrak)
    call link_c2_to_given_orb(mh,lrak+1,lrai-1)
    call link_b1_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrai+1,norb_inn)
    if (mh == 0) cycle
    call value_sort_ploop(mh,.false.,.true.,.true.)
    if (log_prod == 3) then
      linelp = 12
      mhlp = mh
      nlg1 = lrak
      nlg2 = lrai
      call ext_head_in_act()
    else
      call save_lp(12,mh,lrak,lrai)
      lpblock = lpblock+1
    end if
  end do
end do

return

end subroutine lp_head_in_act_1

subroutine lp_head_in_act_2()      !for vd,dt,ds

use gugaci_global, only: iml, imr, intind_ijka, linelp, log_prod, logic_br, lpblock, lsm_inn, mhlp, ngw2, ngw3, nlg1, nlg2, &
                         norb_dz, norb_frz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ijk, imlr, intpos, lma, lmai, lmk, lra, lrai, lraj, lrak, lrd, lsmi, lsmij, lsmj, lsmk, mh

imlr = Mul(iml,imr)

do lra=norb_dz+1,norb_inn
  lma = lsm_inn(lra)
  if (lma /= imlr) cycle
  do lrd=lra+1,norb_inn
    ! line=2 a&r--d&l^r<-->a^l
    call head_ar_at_given_orb(mh,lra)
    call link_c1_to_given_orb(mh,lra+1,lrd-1)
    call link_d10_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrd+1,norb_inn)
    if (mh == 0) cycle
    call value_sort_ploop(mh,.false.,.true.,.false.)
    if (log_prod == 3) then
      linelp = 2
      mhlp = mh
      nlg1 = lra
      nlg2 = lrd
      !call print_lp()
      call ext_head_in_act()
    else
      linelp = 2
      mhlp = mh
      nlg1 = lra
      nlg2 = lrd
      !call print_lp()
      call save_lp(2,mh,lra,lrd)
      lpblock = lpblock+1
    end if
  end do
end do

do lrai=norb_dz+1,norb_inn
  lsmi = lsm_inn(lrai)
  do lraj=lrai+1,norb_inn
    lsmj = lsm_inn(lraj)
    lsmij = Mul(lsmi,lsmj)
    lmk = Mul(lsmij,imlr)
    do lrak=lraj+1,norb_inn
      lsmk = lsm_inn(lrak)
      if (lmk /= lsmk) cycle
      ijk = lrai-norb_frz+ngw2(lraj-norb_frz)+ngw3(lrak-norb_frz)
      intpos = intind_ijka(ijk)
      ! line=6  a&r--b&l--b^r<-->a^l
      call head_ar_at_given_orb(mh,lrai)
      call link_c1_to_given_orb(mh,lrai+1,lraj-1)
      call link_b3_at_given_orb(mh)
      logic_br(1:mh) = .true.
      call link_c2_to_given_orb(mh,lraj+1,lrak-1)
      call link_b2_at_given_orb(mh)
      call link_c1_to_given_orb(mh,lrak+1,norb_inn)
      if (mh == 0) cycle
      call value_sort_ploop(mh,.false.,.true.,.true.)
      if (log_prod == 3) then
        linelp = 6
        mhlp = mh
        nlg1 = intpos
        nlg2 = 0
        !call print_lp()
        call ext_head_in_act()
      else
        call save_lp(6,mh,intpos,0)
        lpblock = lpblock+1
      end if
    end do
  end do
end do

do lrai=norb_dz+2,norb_inn
  lmai = lsm_inn(lrai)
  if (lmai /= imlr) cycle
  do lrak=norb_dz+1,lrai-1
    ! line=11 d&rl--b^r<-->a^l
    call head_drl_at_given_orb(mh,lrak)
    call link_c2_to_given_orb(mh,lrak+1,lrai-1)
    call link_b2_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lrai+1,norb_inn)
    if (mh == 0) cycle
    call value_sort_ploop(mh,.false.,.true.,.true.)
    if (log_prod == 3) then
      linelp = 11
      mhlp = mh
      nlg1 = lrak
      nlg2 = lrai
      !call print_lp()
      call ext_head_in_act()
    else
      call save_lp(11,mh,lrak,lrai)
      lpblock = lpblock+1
    end if
  end do
end do

return

end subroutine lp_head_in_act_2

subroutine lp_head_in_act_3(ide)      !for ide=0:dd,tt,ide=1:ss,id

use gugaci_global, only: iml, imr, logic_br, lpblock, lsm_inn, norb_dz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ide
integer(kind=iwp) :: imlr, lra, lrai, lraj, lsmi, lsmij, lsmj, mh

imlr = Mul(iml,imr)

do lra=norb_dz+1,norb_inn
  ! line=9 d&r&l-
  call head_drl_at_given_orb(mh,lra)
  call link_c2_to_given_orb(mh,lra+1,norb_inn)
  if (mh == 0) cycle
  call value_sort_ploop(mh,.false.,.true.,.true.)
  call save_lp(9,mh,lra,0)
  lpblock = lpblock+1
end do
do lrai=norb_dz+1,norb_inn
  lsmi = lsm_inn(lrai)
  do lraj=lrai+1,norb_inn
    lsmj = lsm_inn(lraj)
    lsmij = Mul(lsmi,lsmj)
    if (lsmij /= imlr) cycle
    ! line=5 a&r-b&l-
    call head_ar_at_given_orb(mh,lrai)
    call link_c1_to_given_orb(mh,lrai+1,lraj-1)
    call link_b3_at_given_orb(mh)
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lraj+1,norb_inn)
    if (mh == 0) cycle
    select case (ide)
      case (0)
        call value_sort_ploop(mh,.false.,.true.,.true.)
      case default ! (1)
        call value_sort_ploop(mh,.false.,.true.,.false.)    !ss
      case (2)
        call value_sort_ploop(mh,.false.,.false.,.true.)    !st,ts
    end select
    call save_lp(5,mh,lrai,lraj)
    lpblock = lpblock+1
  end do
end do

return

end subroutine lp_head_in_act_3

subroutine lp_head_in_act_4()

use gugaci_global, only: iml, imr, linelp, log_prod, logic_br, lpblock, lsm_inn, mhlp, nlg1, nlg2, norb_dz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: imlr, lra, lrai, lraj, lsmi, lsmij, lsmj, mh

imlr = Mul(iml,imr)

do lra=norb_dz+1,norb_inn
  ! line=8 d&rr-
  call head_drr_at_given_orb(mh,lra)
  logic_br(1:mh) = .true.
  call link_c2_to_given_orb(mh,lra+1,norb_inn)
  if (mh == 0) cycle
  call value_sort_ploop(mh,.false.,.true.,.true.)
  if (log_prod == 3) then
    linelp = 8
    mhlp = mh
    nlg1 = lra
    nlg2 = 0
    call ext_head_in_act()
  else
    call save_lp(8,mh,lra,0)
    lpblock = lpblock+1
  end if
end do
do lrai=norb_dz+1,norb_inn
  lsmi = lsm_inn(lrai)
  do lraj=lrai+1,norb_inn
    lsmj = lsm_inn(lraj)
    lsmij = Mul(lsmi,lsmj)
    if (lsmij /= imlr) cycle
    call head_ar_at_given_orb(mh,lrai)
    call link_c1_to_given_orb(mh,lrai+1,lraj-1)
    call link_b4_at_given_orb(mh)
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lraj+1,norb_inn)
    if (mh == 0) cycle
    call value_sort_ploop(mh,.false.,.true.,.true.)
    if (log_prod == 3) then
      linelp = 3
      mhlp = mh
      nlg1 = lrai
      nlg2 = lraj
      call ext_head_in_act()
    else
      call save_lp(3,mh,lrai,lraj)
      lpblock = lpblock+1
    end if
  end do
end do

return

end subroutine lp_head_in_act_4

subroutine lp_head_in_dbl_1()      !for dv,sd,td

use gugaci_global, only: iml, imr, jml, jmr, logic_br, lpblock, lsm_inn, ngw2, ngw3, norb_dz, norb_frz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: imlr, jk, jmlr, lend, lra, lrai, lraj, lsma, lsmact, lsmi, lsmij, lsmj, lsta, mh

imlr = Mul(iml,imr)
jmlr = Mul(jml,jmr)
lsmact = Mul(imlr,jmlr)
lsta = norb_dz+1
lend = norb_inn

if (imlr == jmlr) then       !!! imlr == 1

  ! line=13 -c'-
  call link_c1_to_given_orb_coe(mh,lsta,lend)
  if (mh /= 0) then
    call value_sort_ploop(mh,.true.,.true.,.true.)
    call save_lp(13,mh,0,0)
    lpblock = lpblock+1
  end if
end if

! line=15 -b^l-
do lra=norb_dz+1,norb_inn
  lsma = lsm_inn(lra)

  if (lsma /= lsmact) cycle

  if (jml == jmr) then
    logic_br(1) = .false.
    call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
    call link_b1_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lra+1,norb_inn)
    if (mh /= 0) then
      call value_sort_ploop(mh,.false.,.true.,.true.)
      call save_lp(15,mh,lra,1)
      lpblock = lpblock+1
    end if
  end if
  logic_br(1) = .true.
  call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
  call link_b1_at_given_orb(mh)        !b^l
  call link_c1_to_given_orb(mh,lra+1,norb_inn)
  if (mh /= 0) then
    call value_sort_ploop(mh,.false.,.true.,.true.)
    call save_lp(15,mh,lra,2)
    lpblock = lpblock+1
  end if

  ! line=16 -b^r-
  if (jml == jmr) then
    logic_br(1) = .false.
    call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
    call link_b2_at_given_orb(mh)
    call link_c1_to_given_orb(mh,lra+1,norb_inn)
    if (mh /= 0) then
      call value_sort_ploop(mh,.false.,.true.,.true.)
      call save_lp(16,mh,lra,1)
      lpblock = lpblock+1
    end if
  end if

  logic_br(1) = .true.
  call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
  call link_b2_at_given_orb(mh)
  call link_c1_to_given_orb(mh,lra+1,norb_inn)
  if (mh == 0) cycle
  call value_sort_ploop(mh,.false.,.true.,.true.)
  call save_lp(16,mh,lra,2)
  lpblock = lpblock+1

end do

! line=20 -b&r-b^r-
do lrai=norb_dz+1,norb_inn-1
  lsmi = lsm_inn(lrai)
  do lraj=lrai+1,norb_inn
    lsmj = lsm_inn(lraj)
    lsmij = Mul(lsmi,lsmj)
    if (lsmij /= lsmact) cycle
    jk = ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)

    call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b4_at_given_orb(mh)        !b&r
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrai+1,lraj-1)
    call link_b2_at_given_orb(mh)        !b^r
    call link_c1_to_given_orb(mh,lraj+1,norb_inn)
    if (mh /= 0) then
      call value_sort_ploop(mh,.false.,.true.,.true.)
      call save_lp(20,mh,jk,0)
      lpblock = lpblock+1
    end if
    ! line=22 -b&l-b^l-
    call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b3_at_given_orb(mh)        !b&l
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrai+1,lraj-1)
    call link_b1_at_given_orb(mh)        !b^l
    call link_c1_to_given_orb(mh,lraj+1,norb_inn)
    if (mh == 0) cycle
    call value_sort_ploop(mh,.false.,.true.,.true.)
    call save_lp(22,mh,jk,0)
    lpblock = lpblock+1
  end do
end do

return

end subroutine lp_head_in_dbl_1

!subroutine lp_head_in_dbl_1_mrpt2()    !for dv,sd,td       !200709
!
!use gugaci_global, only: iml, imr, jml, jmr, jpadlr, jpadlrel, linelp, logic_br, lsm_inn, mhlp, ngw2, ngw3, nlg1, nlg2, norb_dz, &
!                         norb_frz, norb_inn
!use Symmetry_Info, only: Mul
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp) :: imlr, jk, jmlr, lend, lra, lrai, lraj, lsma, lsmact, lsmi, lsmij, lsmj, lsta, mh
!logical(kind=iwp) :: do_15, do_16
!
!imlr = Mul(iml,imr)
!jmlr = Mul(jml,jmr)
!lsmact = Mul(imlr,jmlr)
!lsta = norb_dz+1
!lend = norb_inn
!
!do_15 = .false.
!do_16 = .false.
!select case (jpadlrel(jpadlr)) !200709
!  case default ! (1)
!    if (imlr == jmlr) then               !!! imlr == 1
!      ! line=13 -c'-
!      call link_c1_to_given_orb_coe(mh,lsta,lend)
!      if (mh == 0) then
!        do_15 = .true.
!      else
!        call value_sort_ploop(mh,.true.,.true.,.true.)
!        linelp = 13
!        mhlp = mh
!        nlg1 = 0
!        nlg2 = 0
!        call ext_head_in_dbl()
!      end if
!    end if
!
!    if (.not. do_15) then
!      ! line=20 -b&r-b^r-
!      do lrai=norb_dz+1,norb_inn-1
!        lsmi = lsm_inn(lrai)
!        do lraj=lrai+1,norb_inn
!          lsmj = lsm_inn(lraj)
!          lsmij = Mul(lsmi,lsmj)
!          if (lsmij /= lsmact) cycle
!          jk = ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)
!
!          call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
!          call link_b4_at_given_orb(mh)        !b&r
!          logic_br(1:mh) = .true.
!          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
!          call link_b2_at_given_orb(mh)        !b^r
!          call link_c1_to_given_orb(mh,lraj+1,norb_inn)
!          if (mh /= 0) then
!            call value_sort_ploop(mh,.false.,.true.,.true.)
!            linelp = 20
!            mhlp = mh
!            nlg1 = jk
!            nlg2 = 0
!            call ext_head_in_dbl()
!          end if
!          ! line=22 -b&l-b^l-
!          call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
!          call link_b3_at_given_orb(mh)        !b&l
!          logic_br(1:mh) = .true.
!          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
!          call link_b1_at_given_orb(mh)        !b^l
!          call link_c1_to_given_orb(mh,lraj+1,norb_inn)
!          if (mh == 0) cycle
!          call value_sort_ploop(mh,.false.,.true.,.true.)
!          linelp = 22
!          mhlp = mh
!          nlg1 = jk
!          nlg2 = 0
!          call ext_head_in_dbl()
!        end do
!      end do
!    end if
!
!  case (2)
!
!  case (3)
!    do_15 = .true.
!
!  case (4)
!    do_16 = .true.
!end select
!
!! line=15 -b^l-
!if (do_15) then
!  do lra=norb_dz+1,norb_inn
!    lsma = lsm_inn(lra)
!
!    if (lsma /= lsmact) cycle
!
!    if (jml == jmr) then
!      logic_br(1) = .false.
!      call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
!      call link_b1_at_given_orb(mh)
!      call link_c1_to_given_orb(mh,lra+1,norb_inn)
!      if (mh /= 0) then
!        call value_sort_ploop(mh,.false.,.true.,.true.)
!        linelp = 15
!        mhlp = mh
!        nlg1 = lra
!        nlg2 = 1
!        call ext_head_in_dbl()
!        !write(u6,*) mh,linelp
!      end if
!    end if
!    logic_br(1) = .true.
!    call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
!    call link_b1_at_given_orb(mh)        !b^l
!    call link_c1_to_given_orb(mh,lra+1,norb_inn)
!    if (mh == 0) then
!      do_16 = .true.
!      exit
!    else
!      call value_sort_ploop(mh,.false.,.true.,.true.)
!      linelp = 15
!      mhlp = mh
!      nlg1 = lra
!      nlg2 = 2
!      call ext_head_in_dbl()
!      !write(u6,*) mh,linelp
!    end if
!  end do
!end if
!
!! line=16 -b^r-
!if (do_16) then
!  do lra=norb_dz+1,norb_inn
!    lsma = lsm_inn(lra)
!    if (jml == jmr) then
!      logic_br(1) = .false.
!      call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
!      call link_b2_at_given_orb(mh)
!      call link_c1_to_given_orb(mh,lra+1,norb_inn)
!      if (mh /= 0) then
!        call value_sort_ploop(mh,.false.,.true.,.true.)
!        linelp = 16
!        mhlp = mh
!        nlg1 = lra
!        nlg2 = 1
!        call ext_head_in_dbl()
!        !write(u6,*) mh,linelp
!      end if
!    end if
!
!    logic_br(1) = .true.
!    call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
!    call link_b2_at_given_orb(mh)
!    call link_c1_to_given_orb(mh,lra+1,norb_inn)
!    if (mh == 0) cycle
!    call value_sort_ploop(mh,.false.,.true.,.true.)
!    linelp = 16
!    mhlp = mh
!    nlg1 = lra
!    nlg2 = 2
!    call ext_head_in_dbl()
!    !write(u6,*) mh,linelp
!
!  end do
!end if
!
!return
!
!end subroutine lp_head_in_dbl_1_mrpt2

subroutine lp_head_in_dbl_2()      !for vd,dt,ds

use gugaci_global, only: iml, imr, jml, jmr, linelp, log_prod, logic_br, lpblock, lsm_inn, mhlp, ngw2, ngw3, nlg1, nlg2, norb_dz, &
                         norb_frz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: imlr, jk, jmlr, lend, lra, lrai, lraj, lsma, lsmact, lsmi, lsmij, lsmj, lsta, mh

imlr = Mul(iml,imr)
jmlr = Mul(jml,jmr)
lsmact = Mul(imlr,jmlr)
lsta = norb_dz+1
lend = norb_inn

if (imlr == jmlr) then       !!! imlr == 1

  ! line=13 -c'-
  call link_c1_to_given_orb_coe(mh,lsta,lend)
  if (mh /= 0) then
    call value_sort_ploop(mh,.true.,.true.,.true.)
    if (log_prod == 3) then
      ! mrpt2, do not save loop
      linelp = 13
      mhlp = mh
      nlg1 = 0
      nlg2 = 0
      call ext_head_in_dbl()
    else
      call save_lp(13,mh,0,0)
      lpblock = lpblock+1
    end if
  end if
end if

! line=16 -b^r-
do lra=norb_dz+1,norb_inn
  lsma = lsm_inn(lra)

  if (lsma == lsmact) then

    if (jml == jmr) then
      logic_br(1) = .false.
      call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
      call link_b2_at_given_orb(mh)        !b^r
      call link_c1_to_given_orb(mh,lra+1,norb_inn)
      if (mh /= 0) then
        call value_sort_ploop(mh,.false.,.true.,.true.)
        if (log_prod == 3) then
          linelp = 16
          mhlp = mh
          nlg1 = lra
          nlg2 = 1
          call ext_head_in_dbl()
        else
          call save_lp(16,mh,lra,1)
          lpblock = lpblock+1
        end if
      end if
    end if

    logic_br(1) = .true.
    call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
    call link_b2_at_given_orb(mh)        !b^r
    call link_c1_to_given_orb(mh,lra+1,norb_inn)
    if (mh /= 0) then
      call value_sort_ploop(mh,.false.,.true.,.true.)
      if (log_prod == 3) then
        linelp = 16
        mhlp = mh
        nlg1 = lra
        nlg2 = 2
        call ext_head_in_dbl()
      else
        call save_lp(16,mh,lra,2)
        lpblock = lpblock+1
      end if
    end if

  end if

  ! line=19 -d&r^l-
  call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
  call link_d10_at_given_orb(mh)
  call link_c1_to_given_orb(mh,lra+1,norb_inn)
  if (mh == 0) cycle
  call value_sort_ploop(mh,.true.,.true.,.true.)
  if (log_prod == 3) then
    linelp = 19
    mhlp = mh
    nlg1 = lra
    nlg2 = 0
    call ext_head_in_dbl()
  else
    call save_lp(19,mh,lra,0)
    lpblock = lpblock+1
  end if
end do

do lrai=norb_dz+1,norb_inn-1
  lsmi = lsm_inn(lrai)
  do lraj=lrai+1,norb_inn
    lsmj = lsm_inn(lraj)
    lsmij = Mul(lsmi,lsmj)
    if (lsmij /= lsmact) cycle
    jk = ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)

    ! line=21 -b&l-b^r-
    call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
    call link_b3_at_given_orb(mh)        !b&l
    logic_br(1:mh) = .true.
    call link_c2_to_given_orb(mh,lrai+1,lraj-1)
    call link_b2_at_given_orb(mh)        !b^r
    call link_c1_to_given_orb(mh,lraj+1,norb_inn)
    if (mh == 0) cycle
    call value_sort_ploop(mh,.false.,.true.,.true.)
    if (log_prod == 3) then
      linelp = 21
      mhlp = mh
      nlg1 = jk
      nlg2 = 0
      call ext_head_in_dbl()
    else
      call save_lp(21,mh,jk,0)
      lpblock = lpblock+1
    end if
  end do
end do

return

end subroutine lp_head_in_dbl_2

!subroutine lp_head_in_dbl_2_mrpt2()          !for vd,dt,ds
!
!use gugaci_global, only: iml, imr, jml, jmr, jpadlr, jpadlrel, linelp, logic_br, lsm_inn, mhlp, ngw2, ngw3, nlg1, nlg2, norb_dz, &
!                         norb_frz, norb_inn
!use Symmetry_Info, only: Mul
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp) :: imlr, jk, jmlr, lend, lra, lrai, lraj, lsma, lsmact, lsmi, lsmij, lsmj, lsta, mh
!logical(kind=iwp) :: do_16
!
!imlr = Mul(iml,imr)
!jmlr = Mul(jml,jmr)
!lsmact = Mul(imlr,jmlr)
!lsta = norb_dz+1
!lend = norb_inn
!
!do_16 = .false.
!select case (jpadlrel(jpadlr)) !200709
!  case default ! (1)
!    do lra=norb_dz+1,norb_inn
!      lsma = lsm_inn(lra)
!      ! line=19 -d&l^r-
!      call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
!      call link_d10_at_given_orb(mh)
!      call link_c1_to_given_orb(mh,lra+1,norb_inn)
!      if (mh == 0) cycle
!      call value_sort_ploop(mh,.true.,.true.,.true.)
!      linelp = 19
!      mhlp = mh
!      nlg1 = lra
!      nlg2 = 0
!      !call print_lp()
!      call ext_head_in_dbl()
!    end do
!
!    do lrai=norb_dz+1,norb_inn-1
!      lsmi = lsm_inn(lrai)
!      do lraj=lrai+1,norb_inn
!        lsmj = lsm_inn(lraj)
!        lsmij = Mul(lsmi,lsmj)
!        if (lsmij /= lsmact) cycle
!        jk = ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)
!
!        ! line=21 -b&l-b^r-
!        call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
!        call link_b3_at_given_orb(mh)        !b&l
!        logic_br(1:mh) = .true.
!        call link_c2_to_given_orb(mh,lrai+1,lraj-1)
!        call link_b2_at_given_orb(mh)        !b^r
!        call link_c1_to_given_orb(mh,lraj+1,norb_inn)
!        if (mh == 0) cycle
!        call value_sort_ploop(mh,.false.,.true.,.true.)
!        linelp = 21
!        mhlp = mh
!        nlg1 = jk
!        nlg2 = 0
!        !call print_lp()
!        call ext_head_in_dbl()
!      end do
!    end do
!
!  case (2)
!    if (imlr == jmlr) then               !!! imlr == 1
!
!      ! line=13 -c'-
!      call link_c1_to_given_orb_coe(mh,lsta,lend)
!      if (mh == 0) then
!        do_16 = .true.
!      else
!        call value_sort_ploop(mh,.true.,.true.,.true.)
!        linelp = 13
!        mhlp = mh
!        nlg1 = 0
!        nlg2 = 0
!        !call print_lp()
!        call ext_head_in_dbl()
!      end if
!
!    end if
!
!  case (3)
!    do_16 = .true.
!
!  case (4)
!end select
!
!! line=16 -b^r-
!if (do_16) then
!  do lra=norb_dz+1,norb_inn
!    lsma = lsm_inn(lra)
!
!    if (lsma /= lsmact) cycle
!
!    if (jml == jmr) then
!      logic_br(1) = .false.
!      call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
!      call link_b2_at_given_orb(mh)        !b^r
!      call link_c1_to_given_orb(mh,lra+1,norb_inn)
!      if (mh /= 0) then
!        call value_sort_ploop(mh,.false.,.true.,.true.)
!        linelp = 16
!        mhlp = mh
!        nlg1 = lra
!        nlg2 = 1
!        !call print_lp()
!        call ext_head_in_dbl()
!      end if
!    end if
!
!    logic_br(1) = .true.
!    call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
!    call link_b2_at_given_orb(mh)        !b^r
!    call link_c1_to_given_orb(mh,lra+1,norb_inn)
!    if (mh == 0) cycle
!    call value_sort_ploop(mh,.false.,.true.,.true.)
!    linelp = 16
!    mhlp = mh
!    nlg1 = lra
!    nlg2 = 2
!    !call print_lp()
!    call ext_head_in_dbl()
!  end do
!end if
!
!return
!
!end subroutine lp_head_in_dbl_2_mrpt2

subroutine lp_head_in_dbl_3(ide)      !for ide=0:dd,tt,ide=1:ss,id

use gugaci_global, only: iml, imr, jml, jmr, logic_br, lpblock, lsm_inn, norb_dz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ide
integer(kind=iwp) :: imlr, jmlr, lend, lra, lsma, lsmact, lsta, mh

imlr = Mul(iml,imr)
jmlr = Mul(jml,jmr)
lsmact = Mul(imlr,jmlr)
lsta = norb_dz+1
lend = norb_inn

if (imlr == jmlr) then       !!! imlr == 1

  ! line=14 -c"-
  if (jml == jmr) then
    logic_br(1) = .false.
    call link_c2_to_given_orb(mh,lsta,lend)
    if (mh /= 0) then
      call value_sort_ploop(mh,.true.,.true.,.true.)
      call save_lp(14,mh,0,1)
      lpblock = lpblock+1
    end if
  end if

  logic_br(1) = .true.
  call link_c2_to_given_orb(mh,lsta,lend)
  if (mh /= 0) then
    call value_sort_ploop(mh,.true.,.true.,.true.)
    call save_lp(14,mh,0,2)
    lpblock = lpblock+1
  end if

end if

do lra=norb_dz+1,norb_inn
  lsma = lsm_inn(lra)
  if (lsma /= lsmact) cycle

  ! line=17 -b&l-
  call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
  call link_b3_at_given_orb(mh)        !b&l
  logic_br(1:mh) = .true.
  call link_c2_to_given_orb(mh,lra+1,norb_inn)
  if (mh == 0) cycle
  select case (ide)
    case (0)
      call value_sort_ploop(mh,.false.,.true.,.true.)
    case default ! (1)
      call value_sort_ploop(mh,.false.,.true.,.false.)    !ss
    case (2)
      call value_sort_ploop(mh,.false.,.false.,.true.)    !st,ts
  end select
  call save_lp(17,mh,lra,0)
  lpblock = lpblock+1

end do

return

end subroutine lp_head_in_dbl_3

subroutine lp_head_in_dbl_4()

use gugaci_global, only: iml, imr, jml, jmr, logic_br, lpblock, lsm_inn, norb_dz, norb_inn
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: imlr, jmlr, lend, lra, lsma, lsmact, lsta, mh

imlr = Mul(iml,imr)
jmlr = Mul(jml,jmr)
lsmact = Mul(imlr,jmlr)
lsta = norb_dz+1
lend = norb_inn

if (imlr == jmlr) then       !!! imlr == 1

  ! line=14 -c"-
  if (jml == jmr) then
    logic_br(1) = .false.
    call link_c2_to_given_orb(mh,lsta,lend)
    if (mh /= 0) then
      call value_sort_ploop(mh,.true.,.true.,.true.)
      call save_lp(14,mh,0,1)
      lpblock = lpblock+1
    end if
  end if

  logic_br(1) = .true.
  call link_c2_to_given_orb(mh,lsta,lend)
  if (mh /= 0) then
    call value_sort_ploop(mh,.true.,.true.,.true.)
    call save_lp(14,mh,0,2)
    lpblock = lpblock+1
  end if

end if
do lra=norb_dz+1,norb_inn
  lsma = lsm_inn(lra)
  if (lsma /= lsmact) cycle

  ! line=18 -b&r-
  call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
  call link_b4_at_given_orb(mh)        !b&r
  logic_br(1:mh) = .true.
  call link_c2_to_given_orb(mh,lra+1,norb_inn)
  if (mh == 0) cycle
  call value_sort_ploop(mh,.false.,.true.,.true.)
  call save_lp(18,mh,lra,0)
  lpblock = lpblock+1

end do

return

end subroutine lp_head_in_dbl_4

!subroutine lp_head_in_dbl_4_mrpt2()
!
!use gugaci_global, only: iml, imr, jml, jmr, jpadlr, jpadlrel, linelp, logic_br, lsm_inn, mhlp, nlg1, nlg2, norb_dz, norb_inn
!use Symmetry_Info, only: Mul
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp) :: imlr, jmlr, lend, lra, lsma, lsmact, lsta, mh
!logical(kind=iwp) :: do_15
!
!imlr = Mul(iml,imr)
!jmlr = Mul(jml,jmr)
!lsmact = Mul(imlr,jmlr)
!lsta = norb_dz+1
!lend = norb_inn
!
!do_15 = .false.
!select case (jpadlrel(jpadlr)) !200709
!  case default ! (1)
!    do_15 = .true.
!
!  case (2)
!
!  case (3)
!
!  case (4)
!    if (imlr == jmlr) then               !!! imlr == 1
!
!      ! line=14 -c"-
!      if (jml == jmr) then
!        logic_br(1) = .false.
!        call link_c2_to_given_orb(mh,lsta,lend)
!        if (mh /= 0) then
!          call value_sort_ploop(mh,.true.,.true.,.true.)
!          linelp = 14
!          mhlp = mh
!          nlg1 = 0
!          nlg2 = 1
!          call ext_head_in_dbl()
!        end if
!      end if
!
!      logic_br(1) = .true.
!      call link_c2_to_given_orb(mh,lsta,lend)
!      if (mh == 0) then
!        do_15 = .true.
!      else
!        call value_sort_ploop(mh,.true.,.true.,.true.)
!        linelp = 14
!        mhlp = mh
!        nlg1 = 0
!        nlg2 = 2
!        call ext_head_in_dbl()
!      end if
!
!    end if
!end select
!
!if (do_15) then
!  do lra=norb_dz+1,norb_inn
!    lsma = lsm_inn(lra)
!    if (lsma /= lsmact) cycle
!
!    ! line=18 -b&r-
!    call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
!    call link_b4_at_given_orb(mh)        !b&r
!    logic_br(1:mh) = .true.
!    call link_c2_to_given_orb(mh,lra+1,norb_inn)
!    if (mh == 0) cycle
!    call value_sort_ploop(mh,.false.,.true.,.true.)
!    linelp = 18
!    mhlp = mh
!    nlg1 = lra
!    nlg2 = 0
!    call ext_head_in_dbl()
!
!  end do
!end if
!
!return
!
!end subroutine lp_head_in_dbl_4_mrpt2

!subroutine print_lp()
!
!use gugaci_global, only: ihy, ihyl, iml, imr, jml, jmr, jpadlr, jphy, jphyl, linelp, lp_count, lpnew_coe, lpnew_head, lpnew_lwei, &
!                         lpnew_rwei, mhlp, mhsum, mtype, nlg1, nlg2, norb_dz, norb_inn, ns_sm, nstaval, nvalue, vplpnew_w0, &
!                         vplpnew_w1
!use Symmetry_Info, only: Mul
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp) :: in_, jhyl, jhyr, jph, jpml, jpmr, lg1, lg2, line, m, mh
!
!line = linelp
!mh = mhlp
!lg1 = nlg1
!lg2 = nlg2
!
!mhsum = mhsum+mh
!lp_count(line) = lp_count(line)+1
!if (((line == 14) .or. (line == 15) .or. (line == 16)) .and. (lg2 == 1)) then
!  mhsum = mhsum-mh
!  lp_count(line) = lp_count(line)-1
!end if
!!=======================================================================
!jpml = Mul(jml,ns_sm)
!jpmr = Mul(jmr,ns_sm)
!write(20,'(2x,10i8)') line,iml,imr,jpml,jpmr,jpadlr,mtype,mh,lg1,lg2
!write(20,'(7f12.6)') vplpnew_w0(1:mtype)
!write(20,'(7f12.6)') vplpnew_w1(1:mtype)
!write(20,'(8i4)') nstaval(1:mtype)
!write(20,'(8i4)') nvalue(1:mtype)
!write(20,'(8i6)') lpnew_lwei(1:mh)
!write(20,'(8i6)') lpnew_rwei(1:mh)
!!=======================================================================
!if (line <= 12) then
!  ! upwei_record
!  do m=1,mh
!    jph = lpnew_head(m)
!    jhyl = jphyl(jph)
!    jhyr = jphy(jph)
!    in_ = ihyl(jhyl)
!    write(20,'(8(1x,i4))') jph,jhyl,jhyr,in_,ihyl(jhyl+1:jhyl+in_),ihy(jhyr+1:jhyr+in_)
!  end do
!end if
!if ((line /= 1) .and. (line /= 13)) return
!! coe_record
!do m=1,mh
!  write(20,*) lpnew_coe(norb_dz+1:norb_inn,m)
!end do
!
!end subroutine print_lp

subroutine save_lp(line,mh,lg1,lg2)

use gugaci_global, only: idisk_lp, ihy, ihyl, iml, imr, jml, jmr, jpadlr, jphy, jphyl, lp_count, lpnew_coe, lpnew_head, &
                         lpnew_lwei, lpnew_rwei, LuLoop, mhlpmax, mhsum, mtype, norb_dz, norb_inn, ns_sm, nstaval, nvalue, &
                         vplpnew_w0, vplpnew_w1
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: line, mh, lg1, lg2
integer(kind=iwp) :: idum(1), in_, info(10), jhyl, jhyr, jph, jpml, jpmr, lenw, m

if (mh > mhlpmax) mhlpmax = mh
mhsum = mhsum+mh
lp_count(line) = lp_count(line)+1
if (((line == 14) .or. (line == 15) .or. (line == 16)) .and. (lg2 == 1)) then
  mhsum = mhsum-mh
  lp_count(line) = lp_count(line)-1
end if
info = 0
!=======================================================================
!jpml = Mul(jml,ns_sm)
!jpmr = Mul(jmr,ns_sm)
!write(200,'(2x,10i8)') line,iml,imr,jpml,jpmr,jpadlr,mtype,mh,lg1,lg2
!write(200,*) vplpnew_w0(1:mtype)
!write(200,*) vplpnew_w1(1:mtype)
!write(200,*) nstaval(1:mtype)
!write(200,*) nvalue(1:mtype)
!write(200,*) lpnew_lwei(1:mh)
!write(200,*) lpnew_rwei(1:mh)
!=======================================================================
jpml = Mul(jml,ns_sm)
jpmr = Mul(jmr,ns_sm)
info(1) = line
info(2) = iml
info(3) = imr
info(4) = jpml
info(5) = jpmr
info(6) = jpadlr
info(7) = mtype
info(8) = mh
info(9) = lg1
info(10) = lg2
call idafile(luloop,1,info,10,idisk_lp)
!write(u6,*) 'in save_lp, linelp',line,idisk_lp,mh,mtype
call ddafile(luloop,1,vplpnew_w0,mtype,idisk_lp)
call ddafile(luloop,1,vplpnew_w1,mtype,idisk_lp)
call idafile(luloop,1,nstaval,mtype,idisk_lp)
call idafile(luloop,1,nvalue,mtype,idisk_lp)
call idafile(luloop,1,lpnew_lwei,mh,idisk_lp)
call idafile(luloop,1,lpnew_rwei,mh,idisk_lp)
if (line <= 12) then
  do m=1,mh
    jph = lpnew_head(m)
    jhyl = jphyl(jph)
    jhyr = jphy(jph)
    in_ = ihyl(jhyl)
    idum(1) = in_
    call idafile(luloop,1,idum,1,idisk_lp)
    call idafile(luloop,1,ihyl(jhyl+1:jhyl+in_),in_,idisk_lp)
    call idafile(luloop,1,ihy(jhyr+1:jhyr+in_),in_,idisk_lp)
    !write(20) in,ihyl(jhyl+1:jhyl+in),ihy(jhyr+1:jhyr+in)
  end do
end if
if ((line /= 1) .and. (line /= 13)) return
!write(u6,*) 'in read_lp, write coe',idisk_lp,norb_inn-norb_dz
! coe_record
lenw = norb_inn-norb_dz
do m=1,mh
  call idafile(luloop,1,lpnew_coe(norb_dz+1:norb_inn,m),lenw,idisk_lp)
end do

return

end subroutine save_lp

subroutine read_lp()

use gugaci_global, only: idisk_lp, ihy, ihyl, iml, imr, jml, jmr, jpadlr, jphy, linelp, lpnew_coe, lpnew_lwei, lpnew_rwei, LuLoop, &
                         mhlp, mtype, ndim, nlg1, nlg2, norb_dz, norb_inn, nstaval, nvalue, vplpnew_w0, vplpnew_w1
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ihypos, info(10), lenr, m

call idafile(luloop,2,info,10,idisk_lp)
linelp = info(1)
iml = info(2)
imr = info(3)
jml = info(4)
jmr = info(5)
jpadlr = info(6)
mtype = info(7)
mhlp = info(8)
nlg1 = info(9)
nlg2 = info(10)
call ddafile(luloop,2,vplpnew_w0,mtype,idisk_lp)
call ddafile(luloop,2,vplpnew_w1,mtype,idisk_lp)
call idafile(luloop,2,nstaval,mtype,idisk_lp)
call idafile(luloop,2,nvalue,mtype,idisk_lp)
call idafile(luloop,2,lpnew_lwei,mhlp,idisk_lp)
call idafile(luloop,2,lpnew_rwei,mhlp,idisk_lp)
!=======================================================================

if (linelp <= 12) then
  ! upwei_read
  ihypos = 1
  do m=1,mhlp
    jphy(m) = ihypos
    call idafile(luloop,2,info,1,idisk_lp)
    ndim = info(1)
    call idafile(luloop,2,ihyl(ihypos+1:ihypos+ndim),ndim,idisk_lp)
    call idafile(luloop,2,ihy(ihypos+1:ihypos+ndim),ndim,idisk_lp)
    ihy(ihypos) = ndim
    ihypos = ihypos+ndim+1
  end do
end if
if ((linelp /= 1) .and. (linelp /= 13)) return
!write(u6,*) 'in read_lp, read coe',idisk_lp,norb_inn-norb_dz
! coe_read
lenr = norb_inn-norb_dz
do m=1,mhlp
  call idafile(luloop,2,lpnew_coe(norb_dz+1:norb_inn,m),lenr,idisk_lp)
end do

return

end subroutine read_lp

subroutine value_sort_ploop(mh,logic_ar,logic_w0,logic_w1)

use gugaci_global, only: lp_coe, lp_head, lp_lwei, lp_rwei, lpnew_coe, lpnew_head, lpnew_lwei, lpnew_rwei, mtype, norb_dz, &
                         norb_inn, nstaval, nvaltype, nvalue, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mh
logical(kind=iwp), intent(in) :: logic_ar, logic_w0, logic_w1
integer(kind=iwp) :: lr, m, mnew, mty, n, nty
real(kind=wp) :: s_w0, s_w1, w0, w1
integer(kind=iwp), allocatable :: ntype(:)

call mma_allocate(ntype,nvaltype,label='nvaltype')
nvalue(1:nvaltype) = 0
ntype(1:mh) = 0
mtype = 0
if (.not. logic_w0) then
  do n=1,mh
    vplp_w0(n) = Zero
  end do
end if
if (.not. logic_w1) then
  do n=1,mh
    vplp_w1(n) = Zero
  end do
end if
do n=1,mh
  if (ntype(n) /= 0) cycle
  s_w0 = vplp_w0(n)
  s_w1 = vplp_w1(n)
  mtype = mtype+1
  if (mtype > nvaltype) then
    write(u6,*) ' out of array boundary'
    write(u6,*) ' subroutine value_sort_ploop'
    write(u6,*) ' program stop'
#   ifndef MOLPRO
    call abend()
#   endif
  end if
  ntype(n) = mtype
  nvalue(mtype) = nvalue(mtype)+1
  vplpnew_w0(mtype) = vplp_w0(n)
  vplpnew_w1(mtype) = vplp_w1(n)
  do m=n+1,mh
    if (ntype(m) /= 0) cycle
    w0 = vplp_w0(m)
    w1 = vplp_w1(m)
    if ((w0 /= s_w0) .or. (w1 /= s_w1)) cycle
    ntype(m) = mtype
    nvalue(mtype) = nvalue(mtype)+1
  end do
end do

nstaval(1) = 0
do mty=1,mtype-1
  nstaval(mty+1) = nstaval(mty)+nvalue(mty)
end do

mnew = 0
do mty=1,mtype
  do n=1,mh
    nty = ntype(n)
    if (nty == mty) then
      mnew = mnew+1
      lpnew_head(mnew) = lp_head(n)
      lpnew_lwei(mnew) = lp_lwei(n)
      lpnew_rwei(mnew) = lp_rwei(n)
      if (logic_ar) then
        do lr=norb_dz+1,norb_inn
          lpnew_coe(lr,mnew) = lp_coe(lr,n)
        end do
      end if
    end if
  end do
end do
call mma_deallocate(ntype)

return

end subroutine value_sort_ploop

subroutine ext_head_in_act()

use gugaci_global, only: ipaety, jml, jmr, logic_dh, ns_sm
use Symmetry_Info, only: Mul

implicit none

logic_dh = .false.
jml = Mul(jml,ns_sm)
jmr = Mul(jmr,ns_sm)
select case (ipaety)
  case default ! (10)
    call sv_ext_head_in_act()
  case (17)
    call tv_ext_head_in_act()
  case (23)
    call dv_ext_head_in_act()
  case (26)
    call vd_ext_head_in_act()
  case (1:9,11:16,18:22,24:25)
end select
jml = Mul(jml,ns_sm)
jmr = Mul(jmr,ns_sm)

return

end subroutine ext_head_in_act

subroutine ext_head_in_dbl()

use gugaci_global, only: ipaety, jml, jmr, logic_dh, ns_sm
use Symmetry_Info, only: Mul

implicit none

logic_dh = .true.
jml = Mul(jml,ns_sm)
jmr = Mul(jmr,ns_sm)
select case (ipaety)
  case default ! (10)
    call sv_ext_head_in_dbl()
  case (17)
    call tv_ext_head_in_dbl()
  case (23)
    call dv_ext_head_in_dbl()
  case (26)
    call vd_ext_head_in_dbl()
  case (1:9,11:16,18:22,24:25)
end select
jml = Mul(jml,ns_sm)
jmr = Mul(jmr,ns_sm)

return

end subroutine ext_head_in_dbl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1994, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine vRys2D(xyz2D,nArg,lRys,nabMax,ncdMax,PAWP,QCWQ,
     &                 B10,laa,B00,lac,B01,lcc)
************************************************************************
*                                                                      *
* Object: to compute the 2-dimensional integrals of the Rys            *
*         quadrature. The z components are assumed to be pre-          *
*         conditioned with the weights of the roots of the             *
*         Rys polynomial.                                              *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
* Modified loop structure for RISC 1991 R. Lindh Dept. of Theoretical  *
* Chemistry, University of Lund, Sweden.                               *
* Further modifications in Jan-Feb. 1994.                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 xyz2D(nArg*lRys*3,0:nabMax,0:ncdMax),
     &       PAWP(nArg*lRys*3), QCWQ(nArg*lRys*3),
     &       B10(nArg*lRys), B00(nArg*lRys),
     &       B01(nArg*lRys)
      Logical lPAWP, lQCWQ
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Character*30 Label
*
      If (nabMax.gt.0) Call RecPrt('PAWP',' ',PAWP,lRys,nArg*3)
      If (ncdMax.gt.0) Call RecPrt('QCWQ',' ',QCWQ,lRys,nArg*3)
      If (laa.ne.0) Call RecPrt(' B10',' ',B10,lRys,nArg)
      If (lac.ne.0) Call RecPrt(' B00',' ',B00,lRys,nArg)
      If (lcc.ne.0) Call RecPrt(' B01',' ',B01,lRys,nArg)
#endif
*
      iOffy =   nArg*lRys
      iOffz = 2*nArg*lRys
      tTwo = Two
      If (nabMax.eq.0 .and. ncdMax.eq.0) Then
      Else
*
*--------General code
*
*-----Store away PAWPz and QCPQz
*
      lPAWP = nabMax.gt.2
      lQCWQ = ncdMax.gt.2
      If (nabMax.ge.1 .and. ncdMax.ge.1) Then
         If (ncdMax.le.nabMax) Then
            lPAWP = .True.
         Else
            lQCWQ = .True.
         End If
      End If
      If (lPAWP)
     &      call dcopy_(nArg*lRys,PAWP(1+iOffz),1,xyz2D(1      ,0,0),1)
      If (lQCWQ)
     &      call dcopy_(nArg*lRys,QCWQ(1+iOffz),1,xyz2D(1+iOffy,0,0),1)
*
*     Compute 2D integrals with index (i,0)
*
      If (nabMax.eq.0) Then
*
      Else If (nabMax.eq.1) Then
         Do 2000 i = 1, nArg*lRys
            PAWPz = xyz2D(i+iOffz,1,0)
            xyz2D(i+iOffz,1,0) = PAWPz*xyz2D(i+iOffz,0,0)
 2000    Continue
      Else If (nabMax.ge.2) Then
         Do 2001 i = 1, nArg*lRys
            PAWPx = xyz2D(i,1,0)
            xyz2D(i      ,2,0) = PAWPx*xyz2D(i      ,1,0)
     &                         + B10(i)
*
            PAWPy = xyz2D(i+iOffy,1,0)
            xyz2D(i+iOffy,2,0) = PAWPy*xyz2D(i+iOffy,1,0)
     &                         + B10(i)
*
            PAWPz = xyz2D(i+iOffz,1,0)
            xyz2D(i+iOffz,1,0) = PAWPz*xyz2D(i+iOffz,0,0)
            xyz2D(i+iOffz,2,0) = PAWPz*xyz2D(i+iOffz,1,0)
     &                         + B10(i)*xyz2D(i+iOffz,0,0)
 2001    Continue
         If (nabMax.gt.2) Then
            Fact = Two
            Do 250 iab = 2, nabMax-1
               Do 260 i = 1, nArg*lRys
                  PAWPx = xyz2D(i      ,1,0)
                  PAWPy = xyz2D(i+iOffy,1,0)
                  PAWPz = xyz2D(i      ,0,0)
                  temp1x= PAWPx * xyz2D(i      ,iab,0)
                  temp1y= PAWPy * xyz2D(i+iOffy,iab,0)
                  temp1z= PAWPz * xyz2D(i+iOffz,iab,0)
                  temp2x= Fact * B10(i) * xyz2D(i      ,iab-1,0)
                  temp2y= Fact * B10(i) * xyz2D(i+iOffy,iab-1,0)
                  temp2z= Fact * B10(i) * xyz2D(i+iOffz,iab-1,0)
                  xyz2D(i      ,iab+1,0) = temp1x + temp2x
                  xyz2D(i+iOffy,iab+1,0) = temp1y + temp2y
                  xyz2D(i+iOffz,iab+1,0) = temp1z + temp2z
 260           Continue
               Fact = Fact + One
 250        Continue
         End If
      End If
*
*     Compute 2D integrals with index (0,i)
*
      If (ncdMax.eq.1) Then
         Do 2002 i = 1, nArg*lRys
*
            QCWQz = xyz2D(i+iOffz,0,1)
            xyz2D(i+iOffz,0,1) = QCWQz*xyz2D(i+iOffz,0,0)
 2002    Continue
      Else If (ncdMax.ge.2) Then
         Do 2003 i = 1, nArg*lRys
            QCWQx = xyz2D(i,0,1)
            xyz2D(i      ,0,2) = QCWQx*xyz2D(i      ,0,1)
     &                         + B01(i)
*
            QCWQy = xyz2D(i+iOffy,0,1)
            xyz2D(i+iOffy,0,2) = QCWQy*xyz2D(i+iOffy,0,1)
     &                         + B01(i)
*
            QCWQz = xyz2D(i+iOffz,0,1)
            xyz2D(i+iOffz,0,1) = QCWQz*xyz2D(i+iOffz,0,0)
            xyz2D(i+iOffz,0,2) = QCWQz*xyz2D(i+iOffz,0,1)
     &                         + B01(i)*xyz2D(i+iOffz,0,0)
 2003    Continue
         If (ncdMax.gt.2) Then
            Fact = Two
            Do 350 icd = 2, ncdMax-1
               Do 360 i = 1, nArg*lRys
                  QCWQx = xyz2D(i      ,0,1)
                  QCWQy = xyz2D(i+iOffy,0,1)
                  QCWQz = xyz2D(i+iOffy,0,0)
                  temp1x= QCWQx * xyz2D(i      ,0,icd)
                  temp1y= QCWQy * xyz2D(i+iOffy,0,icd)
                  temp1z= QCWQz * xyz2D(i+iOffz,0,icd)
                  temp2x= Fact * B01(i) * xyz2D(i      ,0,icd-1)
                  temp2y= Fact * B01(i) * xyz2D(i+iOffy,0,icd-1)
                  temp2z= Fact * B01(i) * xyz2D(i+iOffz,0,icd-1)
                  xyz2D(i      ,0,icd+1) = temp1x+ temp2x
                  xyz2D(i+iOffy,0,icd+1) = temp1y+ temp2y
                  xyz2D(i+iOffz,0,icd+1) = temp1z+ temp2z
 360           Continue
               Fact = Fact + One
 350        Continue
         End If
      End If
*
*
*     Compute 2D integrals with index (i,j)
*
      If (ncdMax.le.nabMax) Then
         Fac1 = One
         Do 400 icd = 1, ncdMax
            If (icd.eq.1) Then
               Do 425 i = 1, nArg*lRys
                  PAWPx = xyz2D(i      ,1,0)
                  PAWPy = xyz2D(i+iOffy,1,0)
                  PAWPz = xyz2D(i      ,0,0)
                  xyz2D(i      ,1,1) = PAWPx*xyz2D(i      ,0,1)
     &                               +        B00(i)
                  xyz2D(i+iOffy,1,1) = PAWPy*xyz2D(i+iOffy,0,1)
     &                               +        B00(i)
                  xyz2D(i+iOffz,1,1) = PAWPz*xyz2D(i+iOffz,0,1)
     &                               +        B00(i)*xyz2D(i+iOffz,0,0)
 425           Continue
            Else
               Do 4251 i = 1, nArg*lRys
                  PAWPx = xyz2D(i      ,1,0)
                  PAWPy = xyz2D(i+iOffy,1,0)
                  PAWPz = xyz2D(i,      0,0)
                  xyz2D(i      ,1,icd) = PAWPx * xyz2D(i,0,icd)
     &                           + Fac1 * B00(i) * xyz2D(i,0,icd-1)
                  xyz2D(i+iOffy,1,icd) = PAWPy * xyz2D(i+iOffy,0,icd)
     &                           + Fac1* B00(i) * xyz2D(i+iOffy,0,icd-1)
                  xyz2D(i+iOffz,1,icd)  = PAWPz * xyz2D(i+iOffz,0,icd)
     &                           + Fac1* B00(i) * xyz2D(i+iOffz,0,icd-1)
 4251          Continue
            End If
            If (nabMax.eq.2) Then
               Do 420 i = 1, nArg*lRys
                  PAWPx = xyz2D(i      ,1,0)
                  PAWPy = xyz2D(i+iOffy,1,0)
                  PAWPz = xyz2D(i      ,0,0)
                  xyz2D(i,2,icd) =
     &                               PAWPx * xyz2D(i,1,icd)
     &                           +  B10(i) * xyz2D(i,0,icd)
     &                      + Fac1 *B00(i) * xyz2D(i,1,icd-1)
                  xyz2D(i+iOffy,2,icd) =
     &                               PAWPy * xyz2D(i+iOffy,1,icd)
     &                           +  B10(i) * xyz2D(i+iOffy,0,icd)
     &                      + Fac1 *B00(i) * xyz2D(i+iOffy,1,icd-1)
                  xyz2D(i+iOffz,2,icd) =
     &                               PAWPz * xyz2D(i+iOffz,1,icd)
     &                           +  B10(i) * xyz2D(i+iOffz,0,icd)
     &                      + Fac1 *B00(i) * xyz2D(i+iOffz,1,icd-1)
 420              Continue
            Else If (nabMax.gt.2) Then
               Fac2 = One
               Do 450 iab = 1, nabMax-1
                  Do 460 i = 1, nArg*lRys
                     PAWPx = xyz2D(i      ,1,0)
                     PAWPy = xyz2D(i+iOffy,1,0)
                     PAWPz = xyz2D(i      ,0,0)
                     temp1x= PAWPx * xyz2D(i     ,iab,icd)
                     temp1y= PAWPy * xyz2D(i+iOffy,iab,icd)
                     temp1z= PAWPz * xyz2D(i+iOffz,iab,icd)
                     temp2x= Fac2 *B10(i) *xyz2D(i      ,iab-1,icd)
                     temp2y= Fac2 *B10(i) *xyz2D(i+iOffy,iab-1,icd)
                     temp2z= Fac2 *B10(i) *xyz2D(i+iOffz,iab-1,icd)
                     temp3x= Fac1 *B00(i) *xyz2D(i      ,iab,icd-1)
                     temp3y= Fac1 *B00(i) *xyz2D(i+iOffy,iab,icd-1)
                     temp3z= Fac1 *B00(i) *xyz2D(i+iOffz,iab,icd-1)
                     xyz2D(i      ,iab+1,icd) = temp1x+ temp2x+ temp3x
                     xyz2D(i+iOffy,iab+1,icd) = temp1y+ temp2y+ temp3y
                     xyz2D(i+iOffz,iab+1,icd) = temp1z+ temp2z+ temp3z
 460              Continue
                  Fac2 = Fac2 + One
 450           Continue
            End If
            Fac1 = Fac1 + One
 400     Continue
      Else
         Fac1 = One
         Do 500 iab = 1, nabMax
            If (iab.eq.1) Then
               Do 525 i = 1, nArg*lRys
                  QCWQx = xyz2D(i      ,0,1)
                  QCWQy = xyz2D(i+iOffy,0,1)
                  QCWQz = xyz2D(i+iOffy,0,0)
                  xyz2D(i      ,1,1) = QCWQx*xyz2D(i      ,1,0)
     &                               +        B00(i)
                  xyz2D(i+iOffy,1,1) = QCWQy*xyz2D(i+iOffy,1,0)
     &                               +        B00(i)
                  xyz2D(i+iOffz,1,1) = QCWQz*xyz2D(i+iOffz,1,0)
     &                               +        B00(i)*xyz2D(i+iOffz,0,0)
 525           Continue
            Else
               Do 5251 i = 1, nArg*lRys
                  QCWQx = xyz2D(i      ,0,1)
                  QCWQy = xyz2D(i+iOffy,0,1)
                  QCWQz = xyz2D(i+iOffy,0,0)
                  xyz2D(i,iab,1) = QCWQx *xyz2D(i,iab,0)
     &                           + Fac1 *B00(i) *xyz2D(i,iab-1,0)
                  xyz2D(i+iOffy,iab,1) =
     &                            QCWQy *xyz2D(i+iOffy,iab,0)
     &                           + Fac1 *B00(i) *xyz2D(i+iOffy,iab-1,0)
                  xyz2D(i+iOffz,iab,1) =
     &                            QCWQz *xyz2D(i+iOffz,iab,0)
     &                           + Fac1 *B00(i) *xyz2D(i+iOffz,iab-1,0)
 5251          Continue
            End If
            If (ncdMax.eq.2) Then
               Do 520 i = 1, nArg*lRys
                  QCWQx = xyz2D(i      ,0,1)
                  QCWQy = xyz2D(i+iOffy,0,1)
                  QCWQz = xyz2D(i+iOffy,0,0)
                  xyz2D(i,iab,2) =QCWQx   *xyz2D(i,iab,1)
     &                           + B01(i) *xyz2D(i,iab,0)
     &                     + Fac1 *B00(i) *xyz2D(i,iab-1,1)
                  xyz2D(i+iOffy,iab,2) =
     &                            QCWQy   *xyz2D(i+iOffy,iab,1)
     &                           + B01(i) *xyz2D(i+iOffy,iab,0)
     &                     + Fac1 *B00(i) *xyz2D(i+iOffy,iab-1,1)
                  xyz2D(i+iOffz,iab,2) =
     &                            QCWQz   *xyz2D(i+iOffz,iab,1)
     &                           + B01(i) *xyz2D(i+iOffz,iab,0)
     &                     + Fac1 *B00(i) *xyz2D(i+iOffz,iab-1,1)
 520           Continue
            Else If (ncdMax.gt.2) Then
               Fac2 = One
               Do 550 icd = 1, ncdmax-1
                  Do 560 i = 1, nArg*lRys
                     QCWQx = xyz2D(i      ,0,1)
                     QCWQy = xyz2D(i+iOffy,0,1)
                     QCWQz = xyz2D(i+iOffy,0,0)
                     temp1x= QCWQx *xyz2D(i      ,iab,icd)
                     temp1y= QCWQy *xyz2D(i+iOffy,iab,icd)
                     temp1z= QCWQz *xyz2D(i+iOffz,iab,icd)
                     temp2x= Fac2 *B01(i) *xyz2D(i      ,iab,icd-1)
                     temp2y= Fac2 *B01(i) *xyz2D(i+iOffy,iab,icd-1)
                     temp2z= Fac2 *B01(i) *xyz2D(i+iOffz,iab,icd-1)
                     temp3x= Fac1 *B00(i) *xyz2D(i      ,iab-1,icd)
                     temp3y= Fac1 *B00(i) *xyz2D(i+iOffy,iab-1,icd)
                     temp3z= Fac1 *B00(i) *xyz2D(i+iOffz,iab-1,icd)
                     xyz2D(i      ,iab,icd+1) = temp1x+ temp2x+ temp3x
                     xyz2D(i+iOffy,iab,icd+1) = temp1y+ temp2y+ temp3y
                     xyz2D(i+iOffz,iab,icd+1) = temp1z+ temp2z+ temp3z
 560              Continue
                  Fac2 = Fac2 + One
 550           Continue
            End If
            Fac1 = Fac1 + One
 500     Continue
      End If
      End If
*
#ifdef _DEBUGPRINT_
      Do iab = 0, nabMax
         Do icd = 0, ncdMax
            Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(x)'
            Call RecPrt(Label,' ',
     &                  xyz2D(1            ,iab,icd),lRys,nArg)
            Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(y)'
            Call RecPrt(Label,' ',
     &                  xyz2D(1+  nArg*lRys,iab,icd),lRys,nArg)
            Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(z)'
            Call RecPrt(Label,' ',
     &                  xyz2D(1+2*nArg*lRys,iab,icd),lRys,nArg)
         End Do
      End Do
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(laa)
         Call Unused_integer(lac)
         Call Unused_integer(lcc)
      End If
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine CalcAXPzx(AXPzx,GDMat,PUVX,NPUVX,IndTUVX,DDg,zx)
!***********************************************************************
!  Some notes from the author:
!
!  Sum_KL{z_KL * (d^2)Q/(dX_KL)(dP_MLam)}_tuvx =
!
!   2 * Sum_K[ z_MK * <K| E_tu |Lam> * (D^MM_vx - D^KK_vx) ]   !
! - 2 * Sum_K[ z_KM * <K| E_tu |Lam> * (D^MM_vx - D^KK_vx) ]   !       (1)
!
! + <M| E_tu |Lam> * 4*Sum_K[ z_MK * D^MK_vx - z_KM * D^KM_vx ]!       (2)
!
! + Sum_KL z_KL * { c_LLam * [ 2 * (DDg_KMLL - DDg_KLKK) + 4 * DDg_KLLM ]
! + c_KLam * [ 2 * (DDg_LMLL - DDg_LMKK) - 4 * DDg_KLKM ] }            (3)
!
!  Now let's consider some details of the code.
!
!  Loop over M.
!
!  Computing (1) ...
!
!  Loop over K.
!
!  For each K, calculate Ddiff^KM_tu = D^MM_tu - D^KK_tu
!
!  Then construct the operator, Wop
!   if M > K, Wop_tu =  2 * Sum_vx z_MK * Ddiff^KM_vx * g_tuvx
!   if M < K, Wop_tu = -2 * Sum_vx z_KM * Ddiff^KM_vx * g_tuvx
!
!  Then call CISigma_sa, and save the results to the array WSLam
!  (wo...si... <= ...? an example of a bad variable name)
!  daxpy WSLam((K-1)*nConf1+1) to AXPzx(1,M)
!
!  End looping over K
!
!  Computing (2)
!
!  Define a density matrix that accumutates the 4*Sum half in part (2).
!  Note this density matrix as D_acc
!
!  zero out D_acc
!
!  Loop over K again.
!   if M > K, daxpy  4*z_MK D^MK to D_acc.
!   if M < K, daxpy -4*z_KM D^MK to D_acc.
!
!  End looping over K
!
!  Now my Wop_tu is computed as
!  Wop_tu = sum_vx D_acc_vx * g_tuvx
!
!  Then call CISigma_sa, and daxpy WSLam((M-1)*nConf1+1) to
!  AXPzx(1,M)
!
!  Computing (3)
!
!  declare coeff1 and coeff2
!
!  Loop over KL
!
!  In each KL
!  coeff1 = z_KL * [ 2 * (DDg_KMLL - DDg_KLKK) + 4 * DDg_KLLM ]
!  coeff2 = z_KL * [ 2 * (DDg_LMLL - DDg_LMKK) - 4 * DDg_KLKM ]
!
!  Then daxpy coeff1 CIVec((L-1)*nConf1+1) to AXPzx(1,M)
!  and  daxpy coeff2 CIVec((K-1)*nConf1+1) to AXPzx(1,M)
!
!  End looping over M
!
!  It can be dissembled into three parts to compute the term above, as
!  labeled in the equations.
!
!  In computing part (1), note that z_MK applies to cases when K < M,
!  and z_KM applies to cases when K > M. Computing this term requires
!  calling CISigma_sa for each K != M. After the loop over M is done, there
!  will be N*(N-1) times when it is called, where N is the number of
!  states.
!
!  The rules for z_MK or z_KM are the same for part (2) as for part
!  (1). For each M, CISigma_sa is called only once, so CISigma_sa is called
!  only N times for computing part (2).
!
!  In total CISigma_sa will be called N^2 times, but the memory needed to
!  compute AXPzx is a real(kind=wp) array sized nConf1,nRoots.
!
!  In CalcAXPzx1, CISigma_sa is called N*(N-1)/2 times, but array is sized
!  N*(N-1)/2*nRoots*nConf1 (note that N = nRoots).  Maybe this is a good
!  reason to keep both algorithms.
!
!  End of the "essay".
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use ipPage, only: ipget, W
use MCLR_Data, only: ipCI, nConf1, nDens, nNA, XISPSM
use MCLR_procedures, only: CISigma_sa
use input_mclr, only: State_Sym, nSym, nRoots, ntAsh, nAsh
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: AXPzx(nConf1,nRoots)
integer(kind=iwp), intent(in) :: NPUVX, IndTUVX(ntAsh,ntAsh,ntAsh,ntAsh)
real(kind=wp), intent(in) :: GDMat(nTri_Elem(nRoots),nnA,nnA), PUVX(NPUVX), DDg(nTri_Elem(nRoots),nTri_Elem(nRoots)), &
                             zX(nTri_Elem(nRoots-1))
integer(kind=iwp) :: I, iKK, iKL, iKL2, iKM, iKM2, iLL, iLM, ipwslam, jSym, K, L, M, nconf3, off_Ash(nSym)
real(kind=wp) :: Coeff, coeff1, coeff2, dRoots, tempda(1)
real(kind=wp), allocatable :: D_acc(:), Ddiff(:), ovrlp(:,:), Wop(:)
real(kind=wp), external :: DDot_

AXPzx(:,:) = Zero
! Converting nRoots to double prec type
dRoots = real(nRoots,8)
! Symmetry offset
off_Ash(1) = 0
do jSym=2,nSym
  off_Ash(jSym) = off_Ash(jSym-1)+nAsh(jSym-1)
end do

! Memory allocation
nConf3 = nint(max(xispsm(State_SYM,1),xispsm(State_SYM,1)))
ipwslam = ipGet(nConf3*nRoots)

call mma_allocate(Wop,nDens)
call mma_allocate(Ddiff,nnA**2)
call mma_allocate(D_acc,nnA**2)

Wop(:) = Zero
! only a subset, and the same one, of Wop is overwritten
! so it is ok to zero it here only once

! Starting the procedure in the "essay"
! looping over M

do M=1,nRoots
  ! Computing (1)
  do K=1,nRoots
    if (K == M) cycle
    if (M > K) then
      iKM2 = nTri_Elem(M-2)+K
    else
      iKM2 = nTri_Elem(K-2)+M
    end if
    call CalcDdiff(Ddiff,GDMat,M,K,nnA,nRoots)
    Coeff = Two*zx(IKM2)
    if (K > M) Coeff = -Coeff
    call CalcWop(Wop,Ddiff,PUVX,NPUVX,IndTUVX,Coeff,off_Ash)
    call CISigma_SA(0,State_Sym,State_Sym,Wop,nDens,tempda,1,tempda,1,ipci,ipwslam,.false.)
    !call ipin(ipwslam)
    AXPzx(:,M) = AXPzx(:,M)+dRoots*W(ipwslam)%A((K-1)*nConf1+1:K*nConf1)
  end do
  ! Computing (2)
  D_acc(:) = Zero
  call CalcDacc(D_acc,GDMat,M,nnA,nRoots,zx)
  call CalcWop(Wop,D_acc,PUVX,NPUVX,IndTUVX,One,off_Ash)
  call CISigma_SA(0,State_Sym,State_Sym,Wop,nDens,tempda,1,tempda,1,ipci,ipwslam,.false.)
  AXPzx(:,M) = AXPzx(:,M)+dRoots*W(ipwslam)%A((M-1)*nConf1+1:M*nConf1)
  ! Computing (3)
  do K=2,nRoots
    IKK = nTri_Elem(K)
    IKM = iTri(K,M)
    do L=1,K-1
      ILL = nTri_Elem(L)
      IKL = iTri(K,L)
      IKL2 = nTri_Elem(K-2)+L
      ILM = iTri(L,M)
      Coeff1 = zx(IKL2)*(Two*(DDg(IKM,ILL)-DDg(IKM,IKK))+Four*DDg(IKL,ILM))
      Coeff2 = zx(IKL2)*(Two*(DDg(ILM,ILL)-DDg(ILM,IKK))-Four*DDg(IKL,IKM))

      AXPzx(:,M) = AXPzx(:,M)+Coeff1*W(ipCI)%A((L-1)*nConf1+1:L*nConf1)+Coeff2*W(ipCI)%A((K-1)*nConf1+1:K*nConf1)
    end do
  end do
end do

! Memory deallocation
call mma_deallocate(Wop)
call mma_deallocate(Ddiff)
call mma_deallocate(D_acc)

! Now making AXPzx orthogonal to intermediate states
! This part is not mentioned in the equation above because
! the method is straightforward.

! AXPzx_orthonal = AXPzx * (1- Sum_I |I><I|)

call mma_allocate(ovrlp,nRoots,nRoots)

do M=1,nRoots
  do I=1,nRoots
    ovrlp(I,M) = ddot_(nConf1,W(ipCI)%A((I-1)*nConf1+1),1,AXPzx(:,M),1)
  end do
end do

do M=1,nRoots
  do I=1,nRoots
    AXPzx(:,M) = AXPzx(:,M)-ovrlp(I,M)*W(ipCI)%A((I-1)*nConf1+1:I*nConf1)
  end do
end do

AXPzx(:,:) = -AXPzx(:,:)

call mma_deallocate(ovrlp)

end subroutine CalcAXPzx

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine In_place_Square(Buff,nBuff)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBuff
real(kind=wp), intent(inout) :: Buff(nBuff,nBuff)
integer(kind=iwp) :: i, j

!call RecPrt('Buff',' ',Buff,nBuff,nBuff)
do j=1,nBuff
  do i=1,j-1
    Buff(j,i) = Buff(i,j)
  end do
end do
!call RecPrt('Buff',' ',Buff,nBuff,nBuff)
!write(u6,'(10F10.3)') (Buff(i,i),i=1,nBuff)

return

end subroutine In_place_Square

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine mkcipre
      use negpre
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
#include "Pointers.fh"
#include "Input.fh"

      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      irec(i,j)=i+(j-1)*2*lroots


      Call mma_allocate(SS,4*lroots**2,Label='SS')
      DO I=1,lroots
       DO J=1,lroots
        SS(irec(2*i-1,2*j-1))=P1(itri(i,j))
       End Do
      End Do
      DO I=1,lroots
        SS(irec(2*i-1,2*i-1))= SS(irec(2*i-1,2*i-1))+ERAS(I)-ERASSCF(1)
        SS(irec(2*i,2*i-1))=-1.0d0
        SS(irec(2*i-1,2*i))=-1.0d0
      End Do
      SS(irec(2*lroots-1,2*lroots-1))=
     &     SS(irec(2*lroots-1,2*lroots-1))+1.0d0
      Call MatInvert(SS,2*lroots)
      DO I=1,lroots
       DO J=1,lroots
        SS(irec(2*i-1,2*j-1))= SS(irec(2*i-1,2*j-1))+P1INV(itri(i,j))
        SS(irec(2*i,2*j))= SS(irec(2*i,2*j))+P1(itri(i,j))
       End Do
      End Do
      DO I=1,lroots
          SS(irec(2*i,2*i-1)) = SS(irec(2*i,2*i-1)) + 1.0d0
          SS(irec(2*i-1,2*i)) = SS(irec(2*i-1,2*i)) + 1.0d0
      End Do
      Call MatInvert(SS,2*lroots)
      Call DSCAL_(4*lroots**2,-1.0d0,SS,1)
      SS(irec(2*lroots,2*lroots))= SS(irec(2*lroots,2*lroots))-1.0d0

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetTau(Tau,T1,aGrp,bGrp,dima,dimb,adda,addb,lunTau)
! this routine does:
! 1) read the block of T2((a,b)',ij) from T2Name(aGrp,bGrp)
! 2) Make Tau ((a,b)',ij) in T2((a,b)',ij) array
!
! I/O parameter description:
! Tau    - array for Tau((a,b),ij) (O)
! aGrp   - group of a index
! bGrp   - group of b index
! dima   - dimension group of a' index
! dimb   - dimension group of b' index
! adda   - shift of a' in full virtual space
! addb   - shift of b' in full virtual space
! lunTau - Lun of opened file, where Tau is stored

use Index_Functions, only: nTri_Elem
use chcc_global, only: no, nv, T2Name
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: Tau(*), T1(*)
integer(kind=iwp), intent(in) :: aGrp, bGrp, dima, dimb, adda, addb, lunTau
integer(kind=iwp) :: length

!1 def length

if (aGrp == bGrp) then
  ! groups of a and b are equal, reading for a'>=b'
  length = no*no*nTri_Elem(dima)
else
  ! aGrp>bGrp, reading for a',b' in given groups
  length = no*no*dima*dimb
end if

!2 read block of T2 amplitudes

call GetX(Tau,length,LunTau,T2Name(aGrp,bGrp),1,1)

!3 make Tau

if (aGrp /= bGrp) then
  call GetTauHlp1(Tau,T1,dima,dimb,adda,addb,no,nv)
else
  call GetTauHlp2(Tau,T1,dima,adda,no,nv)
end if

return

end subroutine GetTau

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CRESTR(STRING,NSTINI,NSTINO,NEL,NORB,
     &                  Z,NEWORD,LSGSTR,ISGSTI,ISGSTO,TI,TTO,
     &                  ISTMPL,ISTMPO,LROW,I1TYP,IPRNT)
*
* A set of strings containing NEL electrons are given
* set up all possible ways of adding an electron to this set of strings
*
*========
* Input :
*========
*
*
* STRING : Input strings containing NEL electrons
* NSTINI : Number of input  strings
* NSTINO : Number of output strings
* NEL    : Number of electrons in input strings
* NORB   : Number of orbitals
* Z      : Lexical ordering matrix for output strings containing
*          NEL + 1 electrons
* NEWORD : Reordering array for N+1 strings
* LSGSTR : .NE.0 => Include sign arrays ISGSTI,ISGSTO of strings
* ISGSTI : Sign array for NEL   strings
* ISGSTO : Sign array for NEL+1 strings
*
* LROW   : Length of tables for each string, negative number
*          indicates compact form
*=========
* Output :
*=========
*
*TI      : TI(I,ISTRIN) .gt. 0 indicates that orbital I can be added
*          to string ISTRIN .
*TTO     : Resulting NEL + 1 strings
*          if the resulting string has carries a negative sign
*          then the string number is negative
*          TTO(I,ISTRIN) = LSTRIN.NE.0 indicates that I added to
*                          ISTRIN  gives LSTRIN . If LSTRIN is
*                          gt. NSTINO then
*                          A+(I)!ISTRIN>=-!LSTRIN-NSTINO> .
*. If lrow .le. 0 TI and TTO are constructed in sparse form using
*. ISTMPO and ISTMPL as pointers
* ISTST
      IMPLICIT REAL*8           (A-H,O-Z)
      INTEGER  STRING,TI,TTO,STRIN2,Z
*.Input
      DIMENSION STRING(NEL,NSTINI),NEWORD(NSTINO),Z(NORB,NEL+1)
      DIMENSION ISGSTI(NSTINI),ISGSTO(NSTINO)
*.Output
C     DIMENSION TI(NORB,NSTINI),TTO(NORB,NSTINI)
      DIMENSION TI(*), TTO(*)
      DIMENSION ISTMPO(*),ISTMPL(*)
*.Scratch
      DIMENSION STRIN2(500)
*
* LCR NOT DECLARED !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*  I SET I TO ZERO
      LCR=0
      NTEST0 =  000
      NTEST = MAX(IPRNT,NTEST0)
      IF( NTEST .GE. 20 ) THEN
        WRITE(6,*)  ' =============== '
        WRITE(6,*)  ' CRESTR speaking '
        WRITE(6,*)  ' =============== '
      END IF
      LUOUT = 6
*
      IOFF=0     ! dummy initialize
      IPLACE=-1  ! dummy initialize
      DO 1000 ISTRIN = 1,NSTINI
*. Offset for current creations from this string
       IF(ISTRIN.EQ.1) THEN
         IOFF = 1
       ELSE
         IF(LROW.GT.0) THEN
            IOFF = (ISTRIN-1)*LROW + 1
         ELSE
            IOFF = IOFF + LCR
         END IF
       END IF
       LCR = 0
        DO 100 IORB = 1, NORB
           IF(NEL.EQ.0) THEN
             IPLACE = 1
             GOTO 11
           ELSE IF ( NEL .NE. 0 ) THEN
            DO 10 IEL = 1, NEL
              IF(IEL.EQ.1.AND.STRING(1,ISTRIN).GT.IORB) THEN
                IPLACE = 1
                GOTO 11
              ELSE IF( (IEL.EQ.NEL.AND.IORB.GT.STRING(IEL,ISTRIN)) .OR.
     &                 (IEL.LT.NEL.AND.IORB.GT.STRING(IEL,ISTRIN).AND.
     &                  IORB.LT.STRING(IEL+1,ISTRIN)) ) THEN
                IPLACE = IEL+1
                GOTO 11
              ELSE IF(STRING(IEL,ISTRIN).EQ.IORB) THEN
                IPLACE = 0
                GOTO 11
              END IF
   10       CONTINUE
           END IF
   11     CONTINUE
*
          IF(IPLACE.NE.0) THEN
*. Generate next string
            DO 30 I = 1, IPLACE-1
            STRIN2(I) = STRING(I,ISTRIN)
   30       CONTINUE
            STRIN2(IPLACE) = IORB
            DO 40 I = IPLACE,NEL
            STRIN2(I+1) = STRING(I,ISTRIN)
   40       CONTINUE
*. Is new string allowed ?
            ITYPE = IOCTP2_MCLR(STRIN2,NEL+1,I1TYP)
            IF(ITYPE.NE.0) THEN
              JSTRIN = ISTRNM(STRIN2,NORB,NEL+1,Z,NEWORD,1)
*. Save it !
              IF(LROW.GT.0) THEN
                LCR = IORB
              ELSE
                LCR = LCR + 1
              END IF

              TTO(IOFF-1+LCR ) = JSTRIN
              IIISGN = (-1)**(IPLACE-1)
              IF(LSGSTR.NE.0)
     &        IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
              IF(IIISGN .EQ. -1 ) TTO(IOFF-1+LCR ) = - TTO(IOFF-1+LCR )
              TI(IOFF-1+LCR ) = IORB

C             TTO(IORB,ISTRIN) = JSTRIN
C             IIISGN = (-1)**(IPLACE-1)
C             IF(LSGSTR.NE.0)
C    &        IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
C             IF(IIISGN .EQ. -1 ) TTO(IORB,ISTRIN) = - TTO(IORB,ISTRIN)
C             TI(IORB,ISTRIN) = IORB
            END IF
          END IF
  100   CONTINUE
*
        IF(LROW.LT.0) THEN
          ISTMPO(ISTRIN) = IOFF
          ISTMPL(ISTRIN) = LCR
C          write(6,*) ' ISTRIN ISTMPO ISTMPL '
C          write(6,*) ISTRIN, ISTMPO(ISTRIN), ISTMPL(ISTRIN)
        END IF
 1000 CONTINUE
*
      IF ( NTEST .GE. 20) THEN
        MAXPR = 60
        NPR = MIN(NSTINI,MAXPR)
        WRITE(LUOUT,*) ' Output from CRESTR : '
        WRITE(LUOUT,*) '==================='
*
        IF(LROW.GT.0) THEN
          WRITE(6,*) ' Full map '
          WRITE(6,*)
          WRITE(LUOUT,*) ' Strings with an electron added  '
          DO ISTRIN = 1, NPR
             WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &       'String..',ISTRIN,' New strings.. ',
     &       (TTO((ISTRIN-1)*LROW+I),I = 1,NORB)
          END DO
          DO ISTRIN = 1, NPR
             WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &       'String..',ISTRIN,' orbitals added or removed ' ,
     &       (TI((ISTRIN-1)*LROW+I),I = 1,NORB)
          END DO
        ELSE
          WRITE(6,*) ' Compact map '
          WRITE(6,*)
          WRITE(LUOUT,*) ' Strings with an electron added  '
          DO ISTRIN = 1, NPR
             WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &       'String..',ISTRIN,' New strings.. ',
     &       (TTO(ISTMPO(ISTRIN)-1+I),I = 1,ISTMPL(ISTRIN))
          END DO
          DO ISTRIN = 1, NPR
             WRITE(6,'(2X,A,I4,A,/,(10I5))')
     &       'String..',ISTRIN,' orbitals added or removed ' ,
     &       (TI(ISTMPO(ISTRIN)-1+I),I = 1,ISTMPL(ISTRIN))
          END DO
        END IF
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine dumps characters in xml format.                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University, Sweden                                     *
!                                                                      *
!***********************************************************************

subroutine xml_cDump(TagName,Appear,Units,Level,Content,nx,ny)

use Definitions, only: iwp

implicit none
!----------------------------------------------------------------------*
! Dummy arguments                                                      *
!----------------------------------------------------------------------*
character(len=*), intent(in) :: TagName, Appear, Units, Content(*)
integer(kind=iwp), intent(in) :: nx, ny, Level
!----------------------------------------------------------------------*
! Local variables                                                      *
!----------------------------------------------------------------------*
integer(kind=iwp) :: ix, iy, ind, opt
interface
  subroutine xml_cDumpa(name_,nx_name,appear,nx_appear,units,nx_units,Level,nxx,nyx,optx) bind(C,name='xml_cdumpa_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    character(kind=c_char) :: name_(*), appear(*), units(*)
    integer(kind=MOLCAS_C_INT) :: nx_name, nx_appear, nx_units, Level, nxx, nyx, optx
  end subroutine xml_cDumpa
  subroutine xml_cDumpb(name_,nx_name,optx) bind(C,name='xml_cdumpb_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    character(kind=c_char) :: name_(*)
    integer(kind=MOLCAS_C_INT) :: nx_name, optx
  end subroutine xml_cDumpb
  subroutine xml_cDumpc(name_,nx_name) bind(C,name='xml_cdumpc_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    character(kind=c_char) :: name_(*)
    integer(kind=MOLCAS_C_INT) :: nx_name
  end subroutine xml_cDumpc
end interface
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
if ((ny == 1) .and. (nx < 5)) then
  call xml_cDumpa(TagName,len(TagName),Appear,len(Appear),Units,len(Units),Level,nx,ny,0)
  do ix=1,nx
    call xml_cDumpb(Content(ix),len(Content(ix)),0)
  end do
else
  call xml_cDumpa(TagName,len(TagName),Appear,len(Appear),Units,len(Units),Level,nx,ny,1)
  do iy=1,ny
    do ix=1,nx
      ind = (ix-1)*ny+iy
      if ((mod(ix,10) == 0) .or. (ix == nx)) then
        opt = 1
      else
        opt = 0
      end if
      call xml_cDumpb(Content(ind),len(Content(ind)),opt)
    end do
  end do
end if
call xml_cDumpc(TagName,len(TagName))
!----------------------------------------------------------------------*
! Done                                                                 *
!----------------------------------------------------------------------*
return

end subroutine xml_cDump

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_PRTTIM(SECTION,TCPU2,TCPU1,TWALL2,TWALL1,IOPT)
C
C     Purpose: print timing for a section.
C
      IMPLICIT NONE
      CHARACTER*(*) SECTION
      REAL*8        TCPU1, TCPU2, TWALL1, TWALL2
      INTEGER       IOPT
#include "cholesky.fh"

      INTEGER IHRC, IMNC
      INTEGER IHRW, IMNW
      INTEGER LENSEC
      REAL*8  TCPUT, TWALLT, SECC, SECW
      CHARACTER*80 STRING

      TCPUT  = TCPU2  - TCPU1
      TWALLT = TWALL2 - TWALL1
      CALL CHO_CNVTIM(TCPUT,IHRC,IMNC,SECC)
      CALL CHO_CNVTIM(TWALLT,IHRW,IMNW,SECW)

      IF (IOPT .EQ. 0) THEN
         LENSEC = LEN(SECTION)
         WRITE(LUPRI,'(/,A,A,A)')
     &   '***** ',SECTION(1:LENSEC),' completed *****'
         WRITE(LUPRI,'(A,I8,A,I2,A,F6.2,A)')
     &   'Total CPU  time:',IHRC,' hours ',IMNC,' minutes ',SECC,
     &   ' seconds'
         WRITE(LUPRI,'(A,I8,A,I2,A,F6.2,A,/)')
     &   'Total wall time:',IHRW,' hours ',IMNW,' minutes ',SECW,
     &   ' seconds'
      ELSE IF (IOPT .EQ. 1) THEN
         LENSEC = LEN(SECTION)
         WRITE(LUPRI,'(///,A,A,A)')
     &   '***** ',SECTION(1:LENSEC),' completed *****'
         WRITE(LUPRI,'(A,I8,A,I2,A,F6.2,A)')
     &   'Total CPU  time:',IHRC,' hours ',IMNC,' minutes ',SECC,
     &   ' seconds'
         WRITE(LUPRI,'(A,I8,A,I2,A,F6.2,A,//)')
     &   'Total wall time:',IHRW,' hours ',IMNW,' minutes ',SECW,
     &   ' seconds'
      ELSE IF (IOPT .EQ. 2) THEN
         LENSEC = MIN(LEN(SECTION),70)
         WRITE(STRING,'(A10,A)') 'Timing of ',SECTION(1:LENSEC)
         LENSEC = LENSEC + 10
         CALL CHO_HEAD(STRING(1:LENSEC),'=',80,LUPRI)
         WRITE(LUPRI,'(/,A,I8,A,I2,A,F6.2,A)')
     &   'Total CPU  time:',IHRC,' hours ',IMNC,' minutes ',SECC,
     &   ' seconds'
         WRITE(LUPRI,'(A,I8,A,I2,A,F6.2,A)')
     &   'Total wall time:',IHRW,' hours ',IMNW,' minutes ',SECW,
     &   ' seconds'
      ELSE
         WRITE(LUPRI,'(/,A,I8,A,I2,A,F6.2,A)')
     &   'Total CPU  time:',IHRC,' hours ',IMNC,' minutes ',SECC,
     &   ' seconds'
         WRITE(LUPRI,'(A,I8,A,I2,A,F6.2,A)')
     &   'Total wall time:',IHRW,' hours ',IMNW,' minutes ',SECW,
     &   ' seconds'
      END IF

      CALL CHO_FLUSH(LUPRI)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine touchdepend_cvb(chr1,chr2)

use casvb_global, only: charobj, j_dep_on_i, joffs, mxdep, ndep_ji, nobj, up2date
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: chr1, chr2
integer(kind=iwp) :: i, iobj, jobj

call undepend2_cvb(chr1,chr2,2)

iobj = 0
jobj = 0
do i=1,nobj
  if (charobj(i) == chr1) iobj = i
  if (charobj(i) == chr2) jobj = i
end do
if (iobj == 0) then
  write(u6,*) ' Make object not found :',chr1
  call abend_cvb()
end if
if (jobj == 0) then
  write(u6,*) ' Make object not found :',chr2
  call abend_cvb()
end if
ndep_ji = ndep_ji+1
if (ndep_ji > mxdep) then
  write(u6,*) ' Too many make dependencies, max :',mxdep
  call abend_cvb()
end if
j_dep_on_i(joffs(jobj+1)+2:joffs(nobj+1)+1) = j_dep_on_i(joffs(jobj+1)+1:joffs(nobj+1))
j_dep_on_i(joffs(jobj+1)+1) = iobj
joffs(jobj+1:nobj+1) = joffs(jobj+1:nobj+1)+1

if (.not. up2date(jobj)) up2date(iobj) = .false.

return

end subroutine touchdepend_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Get_Exc_dft(nh1,Grad,nGrad,DFTFOCK,F_DFT,D_DS,nBT,nD,KSDFT)

use nq_Info, only: Dens_I, Grad_I, Tau_I
use InfSCF, only: Erest_xc
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nh1, nGrad, nBT, nD
real(kind=wp), intent(inout) :: Grad(nGrad), F_DFT(nBT,nD)
character(len=4), intent(in) :: DFTFOCK
real(kind=wp), intent(in) :: D_DS(nBT,nD)
character(len=80), intent(in) :: KSDFT
integer(kind=iwp) :: nFckDim
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif
real(kind=wp) :: Func
logical(kind=iwp) :: Do_Grad, Do_MO, Do_TwoEl

!                                                                      *
!***********************************************************************
!                                                                      *
! DFT functionals, compute integrals over the potential

Func = Zero
Dens_I = Zero
Grad_I = Zero
Tau_I = Zero
Do_MO = .false.
Do_TwoEl = .false.
Do_Grad = .false.

nFckDim = 2
!                                                                      *
!***********************************************************************
!                                                                      *
call Driver(KSDFT,Do_Grad,Func,Grad,nGrad,Do_MO,Do_TwoEl,D_DS,F_DFT,nh1,nFckDim,DFTFOCK)
!                                                                      *
!***********************************************************************
!                                                                      *
Erest_xc = Erest_xc-Func

#ifdef _DEBUGPRINT_
write(u6,*) ' XC-part of energy-restoring term : ',-Func
write(u6,*)
write(u6,*) ' XC-potentials: (itri,F_alpha,F_beta)'
write(u6,*)
do i=1,nh1
  write(u6,'(i4,3f22.16)') i,F_DFT(i,1),F_DFT(i,2)
end do
#endif

return

end subroutine Get_Exc_dft

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_PrtInt(iSCD,iSAB,xInt,lInt)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: Print integral shell quadruple (IfcSew=2 or 3).
C
      use ChoArr, only: iSP2F, nBstSh, iShP2RS, iShP2Q, nDim_Batch
      Implicit None
      Integer iSCD, iSAB
      Integer lInt
      Real*8  xInt(lInt)
#include "cholesky.fh"

      Character*10 SecNam
      Parameter (SecNam='Cho_PrtInt')

      Integer nRow(8)
      Integer iSC, iSD, iSA, iSB
      Integer nCD, nAB
      Integer AB, CD
      Integer iAB, iCD
      Integer iSym
      Integer kOffI

      Real*8 xNorm

      ! Set row dimension
      If (IfcSew.eq.2) Then
         Do iSym=1,nSym
            nRow(iSym)=nnBstR(iSym,2)
         End Do
      Else If (IfcSew.eq.3) Then
         Do iSym=1,nSym
            nRow(iSym)=nDim_Batch(iSym)
         End Do
      Else
         Call Cho_Quit(SecNam//': Illegal IfcSew',103)
         Do iSym=1,nSym ! avoid compiler warnings
            nRow(iSym)=0
         End Do
      End If

      ! Get full shell pair dimensions
      Call Cho_InvPck(iSP2F(iSCD),iSC,iSD,.True.)
      If (iSC.eq.iSD) Then
         nCD=nBstSh(iSC)*(nBstSh(iSC)+1)/2
      Else
         nCD=nBstSh(iSC)*nBstSh(iSD)
      End If
      Call Cho_InvPck(iSP2F(iSAB),iSA,iSB,.True.)
      If (iSA.eq.iSB) Then
         nAB=nBstSh(iSA)*(nBstSh(iSA)+1)/2
      Else
         nAB=nBstSh(iSA)*nBstSh(iSB)
      End If

      ! Loop through integral shell quadruple
      Write(LuPri,'(//,A,I4,A,I4,A,I4,A,I4,A)')
     & 'Shell Quadruple (',iSC,',',iSD,'|',iSA,',',iSB,'):'
      Do AB=1,nAB
         iAB=iShP2Q(1,AB)
         If (iAB.gt.0) Then
            iSym=iShP2Q(2,AB)
            kOffI=iOff_Col(iSym)+nRow(iSym)*(iAB-1)
            xNorm=0.0d0
            Do CD=1,nCD
               iCD=iShP2RS(1,CD)
               If (iCD.gt.0) Then
                  If (iShP2RS(2,CD).eq.iSym) Then
                     Write(Lupri,'(2X,A,I4,A,I4,A,1P,D15.6)')
     &               '(',CD,'|',AB,') =',xInt(kOffI+iCD)
                     xNorm=xNorm+xInt(kOffI+iCD)**2
                  End If
               End If
            End Do
            Write(Lupri,'(A,I4,A,1P,D15.6)')
     &      '**Norm of column',AB,':',sqrt(xNorm)
         End If
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_W_buffer

   USE fmm_global_paras

   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_add_to_W_buffer,   &
             fmm_open_W_buffer,     &
             fmm_close_W_buffer

   ! diagnostic flag
   CHARACTER(LEN=4), SAVE :: W_buffer_stat

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_add_to_W_buffer(W_pair)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: W_pair
      EXTERNAL fmm_selected_w_buffer
      EXTERNAL fmm_selected_w_contractor

      CALL fmm_selected_w_buffer(fmm_selected_w_contractor,W_pair)

   END SUBROUTINE fmm_add_to_W_buffer

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_close_W_buffer(scheme)

      USE fmm_W_contractors, ONLY: fmm_lock_W_con
      USE fmm_tree_buffer,   ONLY: fmm_tree_buffer_finish

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      EXTERNAL fmm_selected_w_contractor

      IF (W_buffer_stat /= 'OPEN') CALL fmm_quit ('W_buffer already closed!')
      SELECT CASE (scheme%W_con%W_buffer)
         CASE (SKIP_W_BUFFER)
            ! do nothing
         CASE (NULL_W_BUFFER)
            ! do nothing
         CASE (TREE_W_BUFFER)
            CALL fmm_tree_buffer_finish(fmm_selected_w_contractor)
         CASE DEFAULT
            CALL fmm_quit ('cannot reconcile list type in fmm_close_W_buffer')
      END SELECT
      W_buffer_stat = 'FREE'
      fmm_lock_W_con = .FALSE.

   END SUBROUTINE fmm_close_W_buffer

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_null_W_buffer(W_contractor,W_pair)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: W_pair
      EXTERNAL W_contractor

      CALL W_contractor(W_pair)

   END SUBROUTINE fmm_null_W_buffer

!-------------------------------------------------------------------------------
! for diagnostic use only

   SUBROUTINE fmm_skip_W_buffer(W_contractor,W_pair)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: W_pair
      EXTERNAL W_contractor

      RETURN

! Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL W_contractor(W_pair)
      END IF
   END SUBROUTINE fmm_skip_W_buffer

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_open_W_buffer(scheme)

      USE fmm_W_contractors, ONLY: fmm_lock_W_con
      USE fmm_tree_buffer,   ONLY: fmm_tree_buffer_init,      &
                                   fmm_tree_buffer_add

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      EXTERNAL fmm_store_w_buffer

      IF (W_buffer_stat == 'OPEN') CALL fmm_quit('cannot reopen W_buffer')

      SELECT CASE (scheme%W_con%W_buffer)
         CASE (SKIP_W_BUFFER)
            ! all W-contractions will be skipped by this choice of buffer
            CALL fmm_store_w_buffer(fmm_skip_W_buffer)
         CASE (NULL_W_BUFFER)
            CALL fmm_store_w_buffer(fmm_null_W_buffer)
         CASE (TREE_W_BUFFER)
             ! use tree-based sorting/evaluating module
            CALL fmm_store_w_buffer(fmm_tree_buffer_add)
            CALL fmm_tree_buffer_init(TREE_LENGTH,scheme%W_con%sort_para)
         CASE DEFAULT
         CALL fmm_quit ('cannot reconcile list type in fmm_open_W_buffer')
      END SELECT

      W_buffer_stat = 'OPEN'
      fmm_lock_W_con = .TRUE.

   END SUBROUTINE fmm_open_W_buffer

!-------------------------------------------------------------------------------

END MODULE fmm_W_buffer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine rumer_cvb(bikcof,nel,nalf,nbet,ndet,ifns,kbasis,iprint,nswpdim)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nel, nalf, nbet, ndet, ifns, kbasis, iprint, nswpdim
real(kind=wp), intent(out) :: bikcof(ndet,ifns)
integer(kind=iwp) :: ia, iachek, ib, ii, indx, iorb, iswp, nbet2, rc
real(kind=wp) :: abphase, bikvalue, scl
integer(kind=iwp), allocatable :: ialfs(:), ibets(:), ioccswp(:,:), iw(:), locca(:), lnocca(:), maxspn(:), maxswp(:), minspn(:), &
                                  minswp(:), nkspn(:), nkswp(:), xdet(:,:), xspin(:)
integer(kind=iwp), external :: indget_cvb
real(kind=wp), external :: party_cvb

bikcof(:,:) = Zero

call mma_allocate(xdet,[0,nel],[0,nalf],label='xdet')

! Determinant weight array (index from alpha spin string):
call weightfl_cvb(xdet,nalf,nel)
if (ndet /= xdet(nel,nalf)) then
  write(u6,*) ' Discrepancy in NDET:',ndet,xdet(nel,nalf)
  call abend_cvb()
end if

! Rumer spin functions

if ((iprint >= 2) .and. ((kbasis == 3) .or. (kbasis == 4))) write(u6,6100) 2**nbet
abphase = real(1-2*mod(nTri_Elem(nbet-1),2),kind=wp)

call mma_allocate(minswp,[0,2*nbet],label='minswp')
call mma_allocate(maxswp,[0,2*nbet],label='maxswp')
call mma_allocate(nkswp,[0,2*nbet],label='nkswp')
call mma_allocate(ioccswp,nbet,nswpdim,label='ioccswp')

! Prepare NKs for a<->b interchanges in (ab-ba) terms:
nbet2 = 2*nbet
do iorb=0,nbet2
  minswp(iorb) = iorb/2
  maxswp(iorb) = (iorb+1)/2
end do
nkswp(:) = maxswp(:)
iswp = 0
do
  iswp = iswp+1
  do ia=1,nbet
    ioccswp(ia,iswp) = nkswp(2*ia)-nkswp(2*ia-1)
  end do
  call loop_cvb(nbet2,nkswp,minswp,maxswp,rc)
  if (rc == 0) exit
end do

call mma_deallocate(minswp)
call mma_deallocate(maxswp)
call mma_deallocate(nkswp)
call mma_allocate(minspn,[0,nel],label='minspn')
call mma_allocate(maxspn,[0,nel],label='maxspn')
call mma_allocate(nkspn,[0,nel],label='nkspn')
call mma_allocate(locca,nel,label='locca')
call mma_allocate(lnocca,nel,label='lnocca')
call mma_allocate(xspin,(nel+1)*(nalf+1),label='xspin')

! Spin function weight arrays:
do iorb=0,nel
  minspn(iorb) = max(iorb-nalf,0)
  maxspn(iorb) = min(iorb/2,nbet)
end do
call weight_cvb(xspin,minspn,maxspn,nbet,nel)
if ((ifns /= xspin((nel+1)*(nbet+1))) .and. (kbasis /= 6)) then
  write(u6,*) ' Discrepancy in IFNS:',ifns,xspin((nel+1)*(nbet+1))
  call abend_cvb()
end if
nkspn(:) = maxspn(:)
call occupy_cvb(nkspn,nel,locca,lnocca)

call mma_allocate(iw,nel,label='iw')
call mma_allocate(ialfs,nalf,label='ialfs')
call mma_allocate(ibets,nbet,label='ibets')

! Loop:
indx = 1
! Determine pairings
do while ((kbasis /= 6) .or. (indx <= ifns))
  do ib=1,nbet
    ibets(ib) = locca(ib)
    do ia=nalf,1,-1
      ialfs(ib) = lnocca(ia)
      if (ialfs(ib) < ibets(ib)) then
        do iachek=1,ib-1
          if (ialfs(iachek) == ialfs(ib)) exit
        end do
        if (iachek >= ib) exit
      end if
    end do
  end do
  do ib=nbet+1,nalf
    do ia=1,nalf
      ialfs(ib) = lnocca(ia)
      do iachek=1,ib-1
        if (ialfs(iachek) == ialfs(ib)) exit
      end do
      if (iachek >= ib) exit
    end do
  end do

  if ((iprint >= 2) .and. ((kbasis == 3) .or. (kbasis == 4))) write(u6,6200) indx,(ialfs(ii),ibets(ii),ii=1,nbet)

  if (kbasis == 4) then
    bikvalue = One
  else
    bikvalue = abphase*party_cvb(ialfs,nalf)*party_cvb(ibets,nbet)
  end if

  do iswp=1,nswpdim
    iw(:) = 0
    do ia=1,nalf
      iw(ialfs(ia)) = 1
    end do
    do ia=1,nbet
      if (ioccswp(ia,iswp) /= 0) then
        ! IA => alpha electron in position number 2 (= swap).
        iw(ialfs(ia)) = 0
        iw(ibets(ia)) = 1
      end if
    end do
    bikcof(indget_cvb(iw,nalf,nel,xdet),indx) = bikvalue
  end do
  call loind_cvb(nel,nbet,nkspn,minspn,maxspn,locca,lnocca,indx,xspin,rc)
  if (rc == 0) exit
end do

call mma_deallocate(minspn)
call mma_deallocate(maxspn)
call mma_deallocate(nkspn)
call mma_deallocate(ioccswp)
call mma_deallocate(locca)
call mma_deallocate(lnocca)
call mma_deallocate(xdet)
call mma_deallocate(xspin)
call mma_deallocate(iw)
call mma_deallocate(ialfs)
call mma_deallocate(ibets)

! Normalise
scl = One/sqrt(real(2**nbet,kind=wp))
bikcof(:,:) = scl*bikcof(:,:)

return

6100 format(/,' Number of determinants per structure:',i4)
6200 format(2x,i3,' ==> ',8(i2,'-',i2,3x))

end subroutine rumer_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine biks_cvb(aikcof,bikcof,ikcoff,
     >  nel,kbasis,share,iprint)
      implicit real*8 (a-h,o-z)
      logical share
      character*10 basis(7)
      dimension aikcof(*),bikcof(*),ikcoff(0:nel,0:nel,0:nel)
      save basis
      data basis/'Kotani','Serber','Rumer','Rumer (LT)',
     >  'projected','Determ','Determ'/

      aikcof(1)=DBLE(kbasis)
      bikcof(1)=DBLE(kbasis)
      if(kbasis.eq.6)return

      if(iprint.ge.1)write(6,6100)
     >  basis(kbasis)(1:len_trim_cvb(basis(kbasis)))

      do 100 nel1=0,nel
      do 101 nalf1=0,nel
      do 102 i2s1=0,nel
      if(ikcoff(nel1,nalf1,i2s1).ne.-1)then
        ifns=ifns_cvb(nel1,(nel1+i2s1)/2,kbasis)
        ndet=ndet_cvb(nel1,nalf1)
        call bikset_cvb(
     >    aikcof(2+ikcoff(nel1,nalf1,i2s1)),
     >    bikcof(2+ikcoff(nel1,nalf1,i2s1)),
     >    nel1,nalf1,i2s1,ndet,ifns,kbasis,share,iprint)
      endif
102   continue
101   continue
100   continue
      return
6100  format(/,' Generate ',a,' spin functions.')
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine magnetization(nss,nM,nTempMagn,nDirTot,nDir,nDirZee,nH,iPrint,LUZee,mem,nsymm,ngrid,compute_Mdir_vector,zeeman_energy, &
                         hinput,m_paranoid,smagn,doplot,TempMagn,eso,dirX,dirY,dirZ,dir_weight,hexp,magn_exp,zJ,hmin,hmax,EM,thrs, &
                         dipm,sm,dbg)
!***********************************************************************
!                                                                      *
!     MAGNETIZATION control section                                    *
!                                                                      *
!     calling arguments:                                               *
!     NSS     : number of spin-orbit states (total)                    *
!               scalar integer                                         *
!     NM      : size of the Zeeman Hamiltonian matrix                  *
!               scalar integer                                         *
!     EM      : cut-off energy (energy of the last s-o state which is  *
!               included in the Zeeman matrix                          *
!               scalar real                                            *
!     EM      : cut-off energy (energy of the last s-o state which is  *
!               included in the Zeeman matrix                          *
!               scalar real                                            *
!     IFINAL  : integer                                                *
!               termination flag                                       *
!                                                                      *
!     local variables:                                                 *
!     MVEC, SVEC : magnetization and spin vector                       *
!     MAV, SAV   : average powder M and S                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     Liviu Ungur                                                      *
!     University of Leuven, Belgium, 2008-2017                         *
!                                                                      *
!----------------------------------------------------------------------*
!     History:                                                         *
!     Liviu Ungur, 2008-2017 various modifications                     *
!***********************************************************************

use Lebedev_quadrature, only: order_table
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: nss, nM, nTempMagn, nDirTot, nDir, nDirZee, nH, iprint, LUZee(nDirZee), mem, nsymm, ngrid
logical(kind=iwp), intent(in) :: compute_Mdir_vector, zeeman_energy, hinput, m_paranoid, smagn, DoPlot, dbg
real(kind=wp), intent(in) :: TempMagn(nTempMagn), eso(nss), dirX(nDir), dirY(nDir), dirZ(nDir), dir_weight(nDirZee,3), hexp(nH), &
                             magn_exp(nH,nTempMagn), zj, hmin, hmax, EM, thrs
complex(kind=wp), intent(in) :: dipm(3,nss,nss), sm(3,nss,nss)
integer(kind=iwp) :: I, IDIR, IH, IM, iT, iTemp, iTEnd, J, L, mem_local, nP
real(kind=wp) :: DLTH, mv, sv
character(len=99) :: STLNE2
real(kind=wp), allocatable :: dHW(:), dHX(:), dHY(:), dHZ(:), H(:), MAV(:,:), MT(:,:,:), MT_TMP(:,:), MVEC(:,:,:,:), SAV(:,:), &
                              ST(:,:,:), ST_TMP(:,:), STDEV(:), SVEC(:,:,:,:), WM(:), ZT(:,:), ZT_TMP(:)
real(kind=wp), external :: dev

!-----------------------------------------------------------------------
! Allocate necessary memory
mem_local = 0

! Zeeman exchange energy spectrum
call mma_allocate(WM,nM,'W')
mem_local = mem_local+size(WM)*RtoB

call mma_allocate(MT,3,nH,nTempMagn,'MT')
call mma_allocate(MT_TMP,3,nTempMagn,'MT_TMP')
mem_local = mem_local+size(MT)*RtoB
mem_local = mem_local+size(MT_TMP)*RtoB

call mma_allocate(ST,3,nH,nTempMagn,'ST')
call mma_allocate(ST_TMP,3,nTempMagn,'ST_TMP')
mem_local = mem_local+size(ST)*RtoB
mem_local = mem_local+size(ST_TMP)*RtoB

call mma_allocate(MAV,nH,nTempMagn,'MAV')
MAV(:,:) = Zero
mem_local = mem_local+size(MAV)*RtoB

call mma_allocate(SAV,nH,nTempMagn,'SAV')
SAV(:,:) = Zero
mem_local = mem_local+size(SAV)*RtoB

call mma_allocate(ZT,nH,nTempMagn,'ZT')
call mma_allocate(ZT_TMP,nTempMagn,'ZT_TMP')
mem_local = mem_local+size(ZT)*RtoB
mem_local = mem_local+size(ZT_TMP)*RtoB

call mma_allocate(MVEC,nDirTot,nH,nTempMagn,3,'MVEC')
call mma_allocate(SVEC,nDirTot,nH,nTempMagn,3,'SVEC')
mem_local = mem_local+size(MVEC)*RtoB
mem_local = mem_local+size(SVEC)*RtoB

call mma_allocate(H,nH,'H')
mem_local = mem_local+size(H)*RtoB

call mma_allocate(STDEV,nTempMagn,'STDEV')
mem_local = mem_local+size(STDEV)*RtoB

call mma_allocate(dHX,nDirTot,'dHX')
call mma_allocate(dHY,nDirTot,'dHY')
call mma_allocate(dHZ,nDirTot,'dHZ')
call mma_allocate(dHW,nDirTot,'dHW')
mem_local = mem_local+size(dHX)*RtoB
mem_local = mem_local+size(dHY)*RtoB
mem_local = mem_local+size(dHZ)*RtoB
mem_local = mem_local+size(dHW)*RtoB
if (dbg) then
  write(u6,*) 'MAGNETIZATION:  memory allocated (local):'
  write(u6,*) 'mem_local=',mem_local
  write(u6,*) 'MAGNETIZATION:  memory allocated (total):'
  write(u6,*) 'mem_total=',mem+mem_local
end if
!-----------------------------------------------------------------------
write(u6,*)
write(u6,'(A)') repeat('%',96)
write(u6,'(40X,A)') 'CALCULATION OF THE MOLAR MAGNETIZATION'
write(u6,'(A)') repeat('%',96)
write(u6,*)
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
if (DBG .or. (iprint > 3)) then
  write(u6,'(A, I5)') 'nH                  = ',nH
  write(u6,'(A, I5)') 'nM                  = ',nM
  write(u6,'(A, I5)') 'nsymm               = ',nsymm
  write(u6,'(A, I5)') 'ngrid               = ',ngrid
  write(u6,'(A, I5)') 'nDir                = ',nDir
  write(u6,'(A, I5)') 'nDirZee             = ',nDirZee
  write(u6,'(A, I5)') 'nDirTot             = ',nDirTot
  write(u6,'(A, F9.5)') 'HMIN                = ',hmin
  write(u6,'(A, F9.5)') 'HMAX                = ',hmax
  write(u6,'(A, F9.5)') 'zJ                  = ',zJ
  write(u6,*) 'compute_Mdir_vector = ',compute_Mdir_vector
  write(u6,*) 'hinput              = ',hinput
  write(u6,*) 'zeeman_energy       = ',zeeman_energy
  write(u6,*) 'hinput              = ',hinput
  write(u6,*) 'smagn               = ',smagn
  write(u6,'(A)') 'dir_weight'
  do i=1,nDirZee
    write(u6,'(3F10.6)') (dir_weight(i,j),j=1,3)
  end do
  write(u6,'(A)') 'nDir'
  do i=1,nDir
    write(u6,'(3F10.6)') dirX(i),dirY(i),dirZ(i)
  end do
  write(u6,'(30(F6.3,a))') (TempMagn(iTemp),' K.;',iTemp=1,nTempMagn)
  if (zeeman_energy) then
    write(u6,'(A)') 'dir_weight'
    do i=1,nDirZee
      write(u6,'(3F10.6)') (dir_weight(i,j),j=1,3)
    end do
  end if
end if

nP = order_table(nsymm,ngrid)

call hdir(nDir,nDirZee,dirX,dirY,dirZ,dir_weight,nP,nsymm,ngrid,nDirTot,dHX,dHY,dHZ,dHW)

write(u6,'(2X,A,i3,A)') 'Molar magnetization will be calculated in ',NH,' points, equally distributed in magnetic field range'
write(u6,'(2X,F4.1,1x,a,1X,F4.1,a,10(F6.3,a))') HMIN,'--',HMAX,' T., at the following temperatures:'
do i=1,nTempMagn,10
  j = min(nTempMagn,i+9)
  write(u6,'(10(F8.4,A))') (TempMagn(l),' K.;',l=i,j)
end do
write(u6,'(2X,A,I4,A)') 'Powder molar magnetization will be averaged on ',nP,' directions of the applied magnetic field.'
write(u6,'(2x,10A)') ('--------',i=1,10)
if (nsymm == 1) then
  write(u6,'(23x,A)') 'Lebedev-Laikov grid on a hemisphere:'
  write(u6,'(38x,A)') 'z >= 0;'
else if (nsymm == 2) then
  write(u6,'(23x,A)') 'Lebedev-Laikov grid on a 4th-of-a-sphere:'
  write(u6,'(34x,A)') 'x >= 0; z >= 0;'
else if (nsymm == 3) then
  write(u6,'(23x,A)') 'Lebedev-Laikov grid on a 8th-of-a-sphere:'
  write(u6,'(30x,A)') 'x >= 0; y >= 0; z >= 0;'
end if
write(u6,'(2x,10A)') ('--------',i=1,10)
write(u6,'(2x,A,12x,A,2(18x,A),16x,A)') 'Nr.','x','y','z','weight'
do i=1,nP
  write(u6,'(i4,2x,4(F18.12,1x))') i,dHX(i+nDir+nDirZee),dHY(i+nDir+nDirZee),dHZ(i+nDir+nDirZee),dHW(i+nDir+nDirZee)
end do

if (nDir > 0) then
  write(u6,'(2x,10A)') ('--------',i=1,10)
  write(u6,'(23x,A)') ' Magnetization vector will be computed'
  write(u6,'(2x,10A)') ('--------',i=1,10)
  write(u6,'(2x,A,12x,A,2(18x,A))') 'Nr.','x','y','z'
  do i=1,nDir
    write(u6,'(i4,2x,4(F18.12,1x))') i,dHX(i),dHY(i),dHZ(i)
  end do
end if

if (zeeman_energy) then
  write(u6,'(2x,10A)') ('--------',i=1,10)
  write(u6,'(23x,A)') 'Zeeman Energy Splitting will be computed'
  write(u6,'(2x,10A)') ('--------',i=1,10)
  write(u6,'(2x,A,12x,A,2(18x,A))') 'Nr.','x','y','z'
  do i=1,nDirZee
    j = i+nDir
    write(u6,'(i4,2x,4(F18.12,1x))') j,dHX(j),dHY(j),dHZ(j)
  end do
end if

write(u6,'(2x,10A)') ('--------',i=1,10)
write(u6,'(2X,A)') 'The cut-off energy for the exact diagonalization of the Zeeman Hamiltonian is:'
write(u6,'(2x,a,F15.9,A)') 'E = ',EM,' cm(-1).'
if (NM < 10) then
  write(u6,'(2X,A,i2,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 10) .and. (NM < 100)) then
  write(u6,'(2X,A,i3,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 100) .and. (NM < 1000)) then
  write(u6,'(2X,A,i4,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 1000) .and. (NM < 10000)) then
  write(u6,'(2X,A,i5,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
end if
if (compute_Mdir_vector) then
  write(u6,'(2x,A,i2,a)') 'The magnetization vector for ',nDir,' directions of the applied magnetic field will be calculated.'
else
  write(u6,'(2X,A)') 'The magnetization vector was not calculated.'
end if
if (zeeman_energy) then
  write(u6,'(2x,A,i2,a)') 'The Zeeman splitting for ',nDirZee,' directions of the applied magnetic field will be calculated.'
  write(u6,'(2x,a     )') 'The Zeeman energies for each direction of the applied magnetic field are written in files '// &
                          '"zeeman_energy_xxx.txt".'
else
  write(u6,'(2X,A)') 'Computation of the Zeeman splitting was not requested.'
end if
!smagn = .false.
!m_paranoid = .true.
!THRS = 1.0e-10_wp ! threshold for convergence of average spin, in case (zJ /= 0)
! /// opening the loop over the field points
do iH=1,nH
  !/// -----------------------------------------------------------------
  if (HINPUT) then
    H(iH) = HEXP(iH)
    if (H(iH) == Zero) H(iH) = 0.0001_wp
  else
    DLTH = (HMAX-HMIN)/real(NH-1,kind=wp)
    if (iH == 1) then
      H(IH) = HMIN+0.0001_wp
    else
      H(IH) = HMIN+DLTH*real(IH-1,kind=wp)
    end if
    if (H(iH) == Zero) H(iH) = 0.0001_wp
  end if

  if (DBG) write(u6,'(A,i0,A,F10.5,A,L2,A,L2)') 'MAGNETIZATION::  H(',iH,') = ',H(iH),'smagn=',smagn,' m_paranoid=',m_paranoid

  !/// opening the loop over different directions of the magnetic field
  do iM=1,NDIRTOT
    ! Entry into monitor: Status line
    write(STLNE2,'(A,I4,A,I4,A,I4,A,I4)') 'Field: ',IH,' from ',nH,' at direction ',IM,' from ',NDIRTOT
    call StatusLine('SINGLE_ANISO: powder magnetization: ',STLNE2)
    ! actual calculation of the MT and ST, ZT
    call MAGN(NSS,NM,dHX(iM),dHY(iM),dHZ(iM),H(iH),ESO,zJ,THRS,DIPM,SM,nTempMagn,TempMagn,smagn,WM,ZT_TMP,ST_TMP,MT_TMP, &
              m_paranoid,DBG)
    ZT(iH,:) = ZT_TMP(:)
    ST(:,iH,:) = ST_TMP(:,:)
    MT(:,iH,:) = MT_TMP(:,:)
    if (DBG .and. (iH == nH) .and. (iM == 23)) then
      write(u6,'(A,3ES16.8)') 'iM:',dHX(iM),dHY(iM),dHZ(iM)
      write(u6,'(2(A,3ES16.8,1x),A,ES16.8)') 'MT:',(MT(l,iH,1),l=1,3),'ST:',(ST(l,iH,1),l=1,3),'ZSTAT:',ZT(iH,1)
      write(u6,'(A,3ES16.8)') 'WM:',(WM(l),l=1,nM)
    end if
    !-------------------------------------------------------------------
    if (zeeman_energy) then
      if ((iH == 1) .and. (iM == nDir+1)) &
        write(u6,'(A)') 'Energies of the Zeeman Hamiltonian for the following directions of the applied field:'
      if ((iH == 1) .and. (iM > nDir) .and. (iM <= nDir+nDirZee)) then
        write(u6,'(A,I3,A,3F10.6,3x,5A)') 'direction Nr.',iM-nDir,' : ',dHX(iM),dHY(iM),dHZ(iM),'written in file "zeeman_energy_', &
                                          char(48+mod((iM-nDir)/100,10)),char(48+mod((iM-nDir)/10,10)), &
                                          char(48+mod(iM-nDir,10)),'.txt".'

        write(LUZee(iM-nDir),'(A,3F24.15)') '# direction of the applied magnetic field:',dHX(iM),dHY(iM),dHZ(iM)
        write(LUZee(iM-nDir),'(A,6x,A,1000(I4,6x) )') '# H(T)',' State =>',(i,i=1,nm)
      end if

      if ((iM > nDir) .and. (iM <= nDir+nDirZee)) write(LUZee(iM-nDir),'(F8.4,1000F10.3)') H(IH),(WM(I),I=1,NM)
    end if !zeeman_energy
    !-------------------------------------------------------------------
    ! computing the AVERAGE MOMENTS calculated at different temperatures
    ! (TempMagn(i))
    do iT=1,nTempMagn
      MVEC(iM,iH,iT,:) = MT(:,iH,iT)
      SVEC(iM,iH,iT,:) = ST(:,iH,iT)

      if (iM > nDir+nDirZee) then
        ! accumulate contributions:
        MAV(iH,iT) = MAV(iH,iT)+dHW(iM)*(dHX(iM)*MT(1,iH,iT)+dHY(iM)*MT(2,iH,iT)+dHZ(iM)*MT(3,iH,iT))
        SAV(iH,iT) = SAV(iH,iT)+dHW(iM)*(dHX(iM)*ST(1,iH,iT)+dHY(iM)*ST(2,iH,iT)+dHZ(iM)*ST(3,iH,iT))
      end if
      if (iprint > 2) then
        if ((iM == 1) .and. (iH == 1)) write(u6,'(2x,A,1x,A,4x,A,7x,A,7x,A)') 'iH','iM','iT','moment(iM,iT)','spin(iM,iT)'
        write(u6,'(3i4,3(F21.15,1x))') iH,iM,iT,(MT(1,iH,iT)*dHX(iM)+MT(2,iH,iT)*dHY(iM)+MT(3,iH,iT)*dHZ(iM)), &
                                       (ST(1,iH,iT)*dHX(iM)+ST(2,iH,iT)*dHY(iM)+ST(3,iH,iT)*dHZ(iM))
      end if
    end do ! iT
    !-------------------------------------------------------------------
    !/// closing the loop over directions of magnetic field
  end do   ! iM
  !/// -----------------------------------------------------------------
  !/// closing the loop over the points of magnetic field:
end do ! IH
!/// -------------------------------------------------------------------
! Close Zeeman files, if opened
if (Zeeman_Energy) then
  do i=1,nDirZee
    close(LUZee(i))
  end do
end if

!/// -------------------------------------------------------------------
if (nDir > 0) then

  if (smagn) then
    do iT=1,nTempMagn
      write(u6,*)
      do iDir=1,nDir
        write(u6,*)
        write(u6,'(A,A,1x,A)') '--------|','------------------------------------------------------------|', &
                               '|------------------------------------------------------------|'
        write(u6,'(A,i3,26x,A,1x,A,60x,A)') 'Direction of the applied magnetic field:',iDir,'|','|','|'
        write(u6,'(A,F18.14,44x,A,1x,A,60x,A)') 'proj X=',dHX(iDIR),'|','|','|'
        write(u6,'(A,F18.14,44x,A,1x,A,60x,A)') 'proj Y=',dHY(iDir),'|','|','|'
        write(u6,'(A,F18.14,44x,A,1x,A,60x,A)') 'proj Z=',dHZ(iDir),'|','|','|'
        write(u6,'(A,F7.4,A,41x,A,1x,A,60x,A)') 'Temperature = ',TempMagn(iT),' kelvin','|','|','|'
        write(u6,'(A,A,1x,A)') '--------|','------------------------------------------------------------|', &
                               '|------------------------------------------------------------|'
        write(u6,'(2x,A,12x,2A,1x,A,10x,2A)') 'Field |','Magnetization Vector            |','   Total Magn. |','|', &
                                              'Spin Magnetization Vector         |','   Total Magn. |'
        write(u6,'(5A,1x,5A)') '--------|','--- proj X ---|','--- proj Y ---|','--- proj Z ---|','- in this dir.-|', &
                               '|--- proj X ---|','--- proj Y ---|','--- proj Z ---|','- in this dir.-|'
        do iH=1,nH
          mv = MVEC(iDir,iH,iT,1)*dHX(iDir)+MVEC(iDir,iH,iT,2)*dHY(iDir)+MVEC(iDir,iH,iT,3)*dHZ(iDir)
          sv = SVEC(iDir,iH,iT,1)*dHX(iDir)+SVEC(iDir,iH,iT,2)*dHY(iDir)+SVEC(iDir,iH,iT,3)*dHZ(iDir)

          write(u6,'(F7.3,1x,A, 3(ES13.6,1x,A),ES14.7,1x,A,1x,A,3(ES13.6,1x,A),ES14.7,1x,A)') H(iH),'|',MVEC(iDir,iH,iT,1),' ', &
                                                                                              MVEC(iDir,iH,iT,2),' ', &
                                                                                              MVEC(iDir,iH,iT,3),'|',mv,'|','|', &
                                                                                              SVEC(iDir,iH,iT,1),' ', &
                                                                                              SVEC(iDir,iH,iT,2),' ', &
                                                                                              SVEC(iDir,iH,iT,3),'|',sv,'|'
        end do
        write(u6,'(A,A,1x,A)') '--------|','------------------------------------------------------------|', &
                               '|------------------------------------------------------------|'
      end do ! iDir
    end do ! iT

  else ! smagn == .false.

    do iT=1,nTempMagn
      write(u6,*)
      do iDir=1,nDir
        write(u6,*)
        write(u6,'(2A)') '--------|','------------------------------------------------------------|'
        write(u6,'(A,i3,26x,A)') 'Direction of the applied magnetic field:',iDir,'|'
        write(u6,'(A,F18.14,44x,A)') 'proj X=',dHX(iDIR),'|'
        write(u6,'(A,F18.14,44x,A)') 'proj Y=',dHY(iDir),'|'
        write(u6,'(A,F18.14,44x,A)') 'proj Z=',dHZ(iDir),'|'
        write(u6,'(A,F7.4,A,41x,A)') 'Temperature = ',TempMagn(iT),' kelvin','|'
        write(u6,'(2A)') '--------|','------------------------------------------------------------|'
        write(u6,'(2x,A,12x,2A)') 'Field |','Magnetization Vector            |','   Total Magn. |'
        write(u6,'(5A)') '--------|','--- proj X ---|','--- proj Y ---|','--- proj Z ---|','- in this dir.-|'
        do iH=1,nH
          mv = MVEC(iDir,iH,iT,1)*dHX(iDir)+MVEC(iDir,iH,iT,2)*dHY(iDir)+MVEC(iDir,iH,iT,3)*dHZ(iDir)
          write(u6,'(F7.3,1x,A,3(ES13.6,1x,A),ES14.7,1x,A)') H(iH),'|',MVEC(iDir,iH,iT,1),' ',MVEC(iDir,iH,iT,2),' ', &
                                                             MVEC(iDir,iH,iT,3),'|',mv,'|'
        end do
        write(u6,'(2A)') '--------|','------------------------------------------------------------|'
      end do !iDir
    end do !iT
  end if !(smagn)
end if !(nDir>0)
!/// -------------------------------------------------------------------
! COMPUTING THE STANDARD DEVIATION OF THE MAGNETIZATION
if (HINPUT) then
  do iT=1,nTempMagn
    STDEV(iT) = dev(nH,MAV(:,iT),magn_exp(:,iT))
  end do
end if
!/// -------------------------------------------------------------------

write(u6,*)
write(u6,'(25X,A)') 'HIGH-FIELD POWDER MAGNETIZATION'
write(u6,'(30X,A)') '(Units: Bohr magneton)'
write(u6,*)
do iT=1,nTempMagn,5
  iTEnd = min(nTempMagn,iT+4)

  write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
  write(u6,'(A,10(F10.3,A))') '   H(T)    |STATISTICAL SUM|',(TempMagn(i),' K.  |',i=iT,iTEnd)
  write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)

  do iH=1,nH
    write(u6,'(F10.6,1X,A,F14.7,1x,A,11(f14.10,1x,A))') H(iH),'|',ZT(iH,1),'|',(MAV(iH,i),'|',i=iT,iTEnd)
  end do

  write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
  if (HINPUT) then
    write(u6,'(A,15x,11(f14.10,1x,A) )') 'ST.DEV.M   |',(STDEV(i),'|',i=1,nTempMagn)
    write(u6,'(A,11A)') '-----------|',('---------------|',i=iT,iTEnd+1)
  end if
end do

if (smagn) then
  write(u6,*)
  write(u6,'(15X,A)') 'HIGH-FIELD POWDER SPIN MAGNETIZATION'
  write(u6,'(20X,A)') '(Units: Bohr magneton)'
  write(u6,*)
  do iT=1,nTempMagn,5
    iTEnd = min(nTempMagn,iT+4)
    write(u6,'(A,11A)') '---------|',('---------------|',i=iT,iTEnd+1)
    write(u6,'(A,11(F10.3,A))') '   H(T)  |STATISTICAL SUM|',(TempMagn(i),' K.  |',i=iT,iTEnd)
    write(u6,'(A,11A)') '---------|',('---------------|',i=iT,iTEnd+1)
    do iH=1,nH
      write(u6,'(F10.6,1X,A,F14.7,1x,A,11(f14.10,1x,A))') H(iH),'|',ZT(iH,1),'|',(SAV(iH,i),'|',i=iT,iTEnd)
    end do
    write(u6,'(A,11A)') '---------|',('---------------|',i=iT,iTEnd+1)
  end do
end if!smagn

if (DoPlot) then
  if (hinput) then
    call plot_MH_with_Exp(nH,H,nTempMagn,TempMagn,MAV,magn_exp)
  else
    call plot_MH_no_Exp(nH,H,nTempMagn,TempMagn,MAV)
  end if
  !if (zeeman_energy) then
  !  call plot_zeeman(nH,nM,nDirZee,H,LuZee)
  !end if
end if

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

call Add_Info('MAGN_AVERAGED',MAV,nH*nTempMagn,5)
if (compute_Mdir_vector) then
  call Add_Info('MAGN_VECT_X(2)     ',MVEC(1,2,1,1),1,4)
  call Add_Info('MAGN_VECT_X(nH/2)  ',MVEC(1,(NH-1)/2,1,1),1,4)
  call Add_Info('MAGN_VECT_X(nH)    ',MVEC(1,NH,1,1),1,4)
  call Add_Info('MAGN_VECT_Y(2)     ',MVEC(1,2,1,2),1,4)
  call Add_Info('MAGN_VECT_Y(nH/2)  ',MVEC(1,(NH-1)/2,1,2),1,4)
  call Add_Info('MAGN_VECT_Y(nH)    ',MVEC(1,NH,1,2),1,4)
  call Add_Info('MAGN_VECT_Z(2)     ',MVEC(1,2,1,3),1,4)
  call Add_Info('MAGN_VECT_Z(nH/2)  ',MVEC(1,(NH-1)/2,1,3),1,4)
  call Add_Info('MAGN_VECT_Z(nH)    ',MVEC(1,NH,1,3),1,4)
end if

!-----------------------------------------------------------------------
! Deallocate necessary memory
call mma_deallocate(WM)
call mma_deallocate(MT)
call mma_deallocate(MT_TMP)
call mma_deallocate(ST)
call mma_deallocate(ST_TMP)
call mma_deallocate(MAV)
call mma_deallocate(SAV)
call mma_deallocate(ZT)
call mma_deallocate(ZT_TMP)
call mma_deallocate(MVEC)
call mma_deallocate(SVEC)
call mma_deallocate(H)
call mma_deallocate(STDEV)
call mma_deallocate(dHX)
call mma_deallocate(dHY)
call mma_deallocate(dHZ)
call mma_deallocate(dHW)

return

end subroutine magnetization

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LDF_PrintIntegralPrescreeningInfo(tau)
      Implicit None
      Real*8  tau
#include "WrkSpc.fh"
#include "localdf.fh"
#include "localdf_int.fh"
#include "ldf_integral_prescreening_info.fh"
#include "ldf_atom_pair_info.fh"

      Logical  LDF_IntegralPrescreeningInfoIsSet
      External LDF_IntegralPrescreeningInfoIsSet

      Integer  LDF_nAtom, LDF_nShell_Atom, LDF_nAuxShell_Atom
      Integer  LDF_GlobalToAtomicShell
      External LDF_nAtom, LDF_nShell_Atom, LDF_nAuxShell_Atom
      External LDF_GlobalToAtomicShell

      Real*8 tau2
      Real*8 Total, Calc

      Integer A, B, AB, CD
      Integer nSA, nSB, iSA, iSB, ip
      Integer nnShl, ijS, iShell, jShell

      Integer i, j
      Real*8  Imax
      Real*8  Gmax_1C
      Real*8  Gmax_2C
      Integer ip_Imax
      Integer ip_Gmax_1C
      Integer ip_Gmax_2C
      Integer AP_Atoms
      Integer AP_2CFunctions
      Imax(i)=Work(ip_IDiag_Mx-1+i)
      Gmax_1C(i)=Work(ip_GDiag_1C_Mx-1+i)
      Gmax_2C(i)=Work(ip_GDiag_2C_Mx-1+i)
      ip_Imax(i)=iWork(ip_IDiag+2*(i-1)+1)
      ip_Gmax_1C(i)=iWork(ip_GDiag_1C+2*(i-1)+1)
      ip_Gmax_2C(i)=iWork(ip_GDiag_2C+2*(i-1)+1)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      If (.not.LDF_IntegralPrescreeningInfoIsSet()) Return

      Call Cho_Head('Max integral diagonals, atom pair based','=',80,6)
      Write(6,'(/,A)')
     & 'Atom Pair      max(uv|uv)'
      Write(6,'(A)')
     & '-------------------------'
      Do AB=1,NumberOfAtomPairs
         Write(6,'(I9,1X,1P,D15.6)') AB,Imax(AB)
      End Do
      Write(6,'(A)')
     & '-------------------------'

      Call Cho_Head('Max integral diagonals, shell based','=',80,6)
      Write(6,'(/,A)')
     & '   Atom A    Atom B   Shell A   Shell B      max(uv|uv)'
      Write(6,'(A)')
     & '-------------------------------------------------------'
      Do AB=1,NumberOfAtomPairs
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         nSA=LDF_nShell_Atom(A)
         nSB=LDF_nShell_Atom(B)
         ip=ip_Imax(AB)-1
         Do iSB=1,nSB
            Do iSA=1,nSA
               Write(6,'(4(I9,1X),1P,D15.6)')
     &         A,B,iSA,iSB,Work(ip+nSA*(iSB-1)+iSA)
            End Do
         End Do
      End Do
      Write(6,'(A)')
     & '-------------------------------------------------------'

      Call Cho_Head('Max 1C G diagonals, atom based','=',80,6)
      Write(6,'(/,A)')
     & '     Atom    max(J_A|J_A)'
      Write(6,'(A)')
     & '-------------------------'
      Do A=1,LDF_nAtom()
         Write(6,'(I9,1X,1P,D15.6)') A,Gmax_1C(A)
      End Do
      Write(6,'(A)')
     & '-------------------------'

      Call Cho_Head('Max 1C G diagonals, shell based','=',80,6)
      Write(6,'(/,A)')
     & '     Atom  AuxShell    max(J_A|J_A)'
      Write(6,'(A)')
     & '-----------------------------------'
      Do A=1,LDF_nAtom()
         nSA=LDF_nAuxShell_Atom(A)
         ip=ip_Gmax_1C(A)-1
         Do iSA=1,nSA
            Write(6,'(2(I9,1X),1P,D15.6)')
     &      A,iSA,Work(ip+iSA)
         End Do
      End Do
      Write(6,'(A)')
     & '-----------------------------------'

      If (LDF2) Then
         Call Cho_Head('Max 2C G diagonals, atom pair based','=',80,6)
         Write(6,'(/,A)')
     &   'Atom Pair  max(J_AB|J_AB)'
         Write(6,'(A)')
     &   '-------------------------'
         Do AB=1,NumberOfAtomPairs
            If (AP_2CFunctions(1,AB).gt.0) Then
               Write(6,'(I9,1X,1P,D15.6)') AB,Gmax_2C(AB)
            End If
         End Do
         Write(6,'(A)')
     &   '-------------------------'
         Call Cho_Head('Max 2C G diagonals, shell based','=',80,6)
         Write(6,'(/,A)')
     &   '   Atom A    Atom B   Shell A   Shell B  max(J_AB|J_AB)'
         Write(6,'(A)')
     &   '-------------------------------------------------------'
         Do AB=1,NumberOfAtomPairs
            If (AP_2CFunctions(1,AB).gt.0) Then
               Call LDF_SetIndxG(AB)
               nnShl=iWork(ip_GDiag_2C+2*(AB-1))
               If (nnShl.ne.l_2CList_2) Then
                  Call WarningMessage(2,
     &          'LDF_PrintIntegraPrescreeningInfo: nnShl != l_2CList_2')
                  Call LDF_Quit(1)
               End If
               ip=ip_Gmax_2C(AB)
               A=AP_Atoms(1,AB)
               B=AP_Atoms(2,AB)
               Do ijS=0,nnShl-1
                  iShell=iWork(ip_2CList+3*ijS)
                  iSA=LDF_GlobalToAtomicShell(A,iShell)
                  jShell=iWork(ip_2CList+3*ijS+1)
                  iSB=LDF_GlobalToAtomicShell(B,jShell)
                  Write(6,'(4(I9,1X),1P,D15.6)')
     &            A,B,iSA,iSB,Work(ip+ijS)
               End Do
               Call LDF_UnsetIndxG()
            End If
         End Do
         Write(6,'(A)')
     &   '-------------------------------------------------------'
      End If

      tau2=tau**2
      Call Cho_Head('Atom/Pair block screening statistics','=',80,6)
      Write(6,'(/,A,1P,D15.6)') 'Screening threshold: ',tau
      Calc=0.0d0
      Do AB=1,NumberOfAtomPairs
         Do A=1,LDF_nAtom()
            If (Imax(AB)*Gmax_1C(A).gt.tau2) Then
               Calc=Calc+1.0d0
            End If
         End Do
      End Do
      Total=dble(NumberOfAtomPairs)*dble(LDF_nAtom())
      Write(6,'(A,F7.2,A)')
     & 'Screening percentage for (u_A v_B|J_C): ',
     & 1.0d2*(Total-Calc)/Total,' %'
      If (LDF2) Then
         Total=0.0d0
         Calc=0.0d0
         Do AB=1,NumberOfAtomPairs
            Do CD=1,NumberOfAtomPairs
               If (AP_2CFunctions(1,CD).gt.0) Then
                  Total=Total+1.0d0
                  If (Imax(AB)*Gmax_2C(CD).gt.tau2) Then
                     Calc=Calc+1.0d0
                  End If
               End If
            End Do
         End Do
         If (Total.gt.0.0d0) Then
            Write(6,'(A,F7.2,A)')
     &      'Screening percentage for (u_A v_B|J_CD):',
     &      1.0d2*(Total-Calc)/Total,' %'
         End If
      End If
      Calc=0.0d0
      Do A=1,LDF_nAtom()
         Do B=1,A
            If (Gmax_1C(A)*Gmax_1C(B).gt.tau2) Then
               Calc=Calc+1.0d0
            End If
         End Do
      End Do
      Total=dble(LDF_nAtom())*(dble(LDF_nAtom())+1.0d0)/2.0d0
      Write(6,'(A,F7.2,A)')
     & 'Screening percentage for (J_A|J_B):     ',
     & 1.0d2*(Total-Calc)/Total,' %'
      If (LDF2) Then
         Total=0.0d0
         Calc=0.0d0
         Do A=1,LDF_nAtom()
            Do CD=1,NumberOfAtomPairs
               If (AP_2CFunctions(1,CD).gt.0) Then
                  Total=Total+1.0d0
                  If (Gmax_1C(A)*Gmax_2C(CD).gt.tau2) Then
                     Calc=Calc+1.0d0
                  End If
               End If
            End Do
         End Do
         If (Total.gt.0.0d0) Then
            Write(6,'(A,F7.2,A)')
     &      'Screening percentage for (J_A|J_CD):    ',
     &      1.0d2*(Total-Calc)/Total,' %'
         End If
         Total=0.0d0
         Calc=0.0d0
         Do AB=1,NumberOfAtomPairs
            If (AP_2CFunctions(1,AB).gt.0) Then
               Do CD=1,AB
                  If (AP_2CFunctions(1,CD).gt.0) Then
                     Total=Total+1.0d0
                     If (Gmax_2C(AB)*Gmax_2C(CD).gt.tau2) Then
                        Calc=Calc+1.0d0
                     End If
                  End If
               End Do
            End If
         End Do
         If (Total.gt.0.0d0) Then
            Write(6,'(A,F7.2,A)')
     &      'Screening percentage for (J_AB|J_CD):   ',
     &      1.0d2*(Total-Calc)/Total,' %'
         End If
      End If

      Call xFlush(6)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_PrtInt(iSCD,iSAB,xInt,lInt)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: Print integral shell quadruple (IfcSew=2 or 3).

use Index_Functions, only: nTri_Elem
use Cholesky, only: IFCSEW, iOff_col, iShP2Q, iShP2RS, iSP2F, LuPri, nBstSh, nDim_Batch, nnBstR, nSym
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSCD, iSAB, lInt
real(kind=wp), intent(in) :: xInt(lInt)
integer(kind=iwp) :: AB, CD, iAB, iCD, iSA, iSB, iSC, iSD, iSym, kOffI, nAB, nCD, nRow(8)
real(kind=wp) :: xNorm
character(len=*), parameter :: SecNam = 'Cho_PrtInt'

! Set row dimension
if (IfcSew == 2) then
  nRow(1:nSym) = nnBstR(1:nSym,2)
else if (IfcSew == 3) then
  nRow(1:nSym) = nDim_Batch(1:nSym)
else
  call Cho_Quit(SecNam//': Illegal IfcSew',103)
  nRow(1:nSym) = 0 ! avoid compiler warnings
end if

! Get full shell pair dimensions
call Cho_InvPck(iSP2F(iSCD),iSC,iSD,.true.)
if (iSC == iSD) then
  nCD = nTri_Elem(nBstSh(iSC))
else
  nCD = nBstSh(iSC)*nBstSh(iSD)
end if
call Cho_InvPck(iSP2F(iSAB),iSA,iSB,.true.)
if (iSA == iSB) then
  nAB = nTri_Elem(nBstSh(iSA))
else
  nAB = nBstSh(iSA)*nBstSh(iSB)
end if

! Loop through integral shell quadruple
write(LuPri,'(//,A,I4,A,I4,A,I4,A,I4,A)') 'Shell Quadruple (',iSC,',',iSD,'|',iSA,',',iSB,'):'
do AB=1,nAB
  iAB = iShP2Q(1,AB)
  if (iAB > 0) then
    iSym = iShP2Q(2,AB)
    kOffI = iOff_Col(iSym)+nRow(iSym)*(iAB-1)
    xNorm = Zero
    do CD=1,nCD
      iCD = iShP2RS(1,CD)
      if (iCD > 0) then
        if (iShP2RS(2,CD) == iSym) then
          write(Lupri,'(2X,A,I4,A,I4,A,ES15.6)') '(',CD,'|',AB,') =',xInt(kOffI+iCD)
          xNorm = xNorm+xInt(kOffI+iCD)**2
        end if
      end if
    end do
    write(Lupri,'(A,I4,A,ES15.6)') '**Norm of column',AB,':',sqrt(xNorm)
  end if
end do

end subroutine Cho_PrtInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2007, Roland Lindh                                *
!               2009, Francesco Aquilante                              *
!***********************************************************************

subroutine PGet1_RI2(PAO,ijkl,nPAO,iCmp,iAO,iAOst,jBas,lBas,kOp,ExFac,CoulFac,PMax,V_K,U_K,mV_K,Z_p_K,nSA)
!***********************************************************************
!  Object: to assemble the 2nd order density matrix of a SCF wave      *
!          function from the 1st order density.                        *
!                                                                      *
!          (Only for use with C1 point group symmetry)                 *
!                                                                      *
!          The indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             January '92.                                             *
!                                                                      *
!             Modified for RI-DFT, March 2007                          *
!                                                                      *
!             Modified for RI-HF/CAS, Dec 2009 (F. Aquilante)          *
!***********************************************************************

use Symmetry_Info, only: Mul
use Basis_Info, only: nBas
use SOAO_Info, only: iAOtSO
use pso_stuff, only: DMdiag, lPSO, lSA, nnP, nPos
use RI_glob, only: A, AMP2, CijK, iAdrCVec, iMP2prpt, LuAVector, LuCVector, nAuxVe, nChOrb, nIJ1, nKvec, tavec
use Constants, only: Zero, One, Two, Half, Quart
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ijkl, nPAO, iCmp(4), iAO(4), iAOst(4), jBas, lBas, kOp(4), mV_K, nSA
real(kind=wp), intent(out) :: PAO(ijkl,nPAO), PMax
real(kind=wp), intent(in) :: ExFac, CoulFac, V_K(mV_K,nSA), U_K(mV_K), Z_p_K(nnP(0),mV_K,*)
logical(kind=iwp) :: Found
integer(kind=iwp) :: i, i2, i4, iAdrA, iAdrJ, iAdrL, iE, iOffA, iPAO, iS, iSO, iSO2, iSym, iUHF, j, jAOj, jik, jil, jp, jSO, jSOj, &
                     jSym, k, kl, kSym, l, lAOl, lSO, lSOl, lSym, lTot, n, nijkl, nik, nik1, nik2
real(kind=wp) :: Cpu, Cpu1, Cpu2, Fac, Factor, temp, temp2, tempJ_mp2, tempK_mp2, tmp, Wall, Wall1, Wall2
real(kind=wp), pointer :: CiKj(:,:), CiKl(:), V2(:)

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
do i=1,nSA
  call RecPrt('PGet1_RI2: V_k',' ',V_k(1,i),1,mV_k)
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! DeSymP will treat up to eight fold degeneracy due to permutational
! symmetry of shell quadruplets. We will have to compensate for that
! here since we only have shell doublets.

call CWTime(Cpu1,Wall1)

if (min(lBas,jBas) == 0) return

Fac = Quart
PMax = Zero
iPAO = 0
iOffA = nBas(0)

call Qpg_iScalar('SCF mode',Found)
if (Found) then
  call Get_iScalar('SCF mode',iUHF) ! either 0 or 1
else
  iUHF = 0
end if
!                                                                      *
!***********************************************************************
!                                                                      *

if (ExFac == Zero) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Pure DFT

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)

    do i4=1,iCmp(4)

      lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

      iPAO = iPAO+1
      nijkl = 0

      do lAOl=0,lBas-1
        lSOl = lSO+lAOl-iOffA
        do jAOj=0,jBas-1

          jSOj = jSO+jAOj-iOffA
          nijkl = nijkl+1

          ! Coulomb contribution
          temp = CoulFac*V_K(jSOj,1)*V_K(lSOl,1)
          !temp = Zero

          PMax = max(PMax,abs(temp))
          PAO(nijkl,iPAO) = Fac*temp

        end do
      end do
    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((iMP2prpt /= 2) .and. (.not. lPSO) .and. (iUHF == 0)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Hybrid DFT and HF

  iSO = 1

  jSym = 1
  kSym = jSym
  iSym = 1
  lSym = Mul(jSym,iSym)

  nik = nIJ1(iSym,kSym,iSO)

  n = nik*jBas
  iS = 1
  iE = n
  CiKj(1:n,1:1) => CijK(iS:iE)
  n = nik*lBas
  iS = iE+1
  iE = iE+n
  CiKl(1:n) => CijK(iS:iE)

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)

    ! Pick up the MO transformed fitting coefficients, C_ik^J
    jSOj = jSO-iOffA
    iAdrJ = nik*(jSOj-1)+iAdrCVec(jSym,iSym,1)
    call dDaFile(LuCVector(jSym,1),2,CikJ(:,1),nik*jBas,iAdrJ)

    do i4=1,iCmp(4)
      lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

      iPAO = iPAO+1
      nijkl = 0

      if (lSO /= jSO) then
        lSOl = lSO-iOffA
        iAdrL = nik*(lSOl-1)+iAdrCVec(jSym,iSym,1)
        call dDaFile(LuCVector(jSym,1),2,CiKl,nik*lBas,iAdrL)

        V2(1:) => CiKl(1:)
      else
        V2(1:) => CiKj(1:,1)
      end if

      A(1:jBas*lBas) = Zero
      call DGEMM_('T','N',jBas,lBas,nik,One,CiKj,nik,V2,nik,Zero,A,jBas)

      do lAOl=0,lBas-1
        lSOl = lSO+lAOl-iOffA
        do jAOj=0,jBas-1
          jSOj = jSO+jAOj-iOffA
          nijkl = nijkl+1

          temp = CoulFac*V_K(jSOj,1)*V_K(lSOl,1)
          temp = temp-ExFac*A(nijkl)

          PMax = max(PMax,abs(temp))
          PAO(nijkl,iPAO) = Fac*temp
        end do
      end do
    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((iMP2prpt /= 2) .and. (.not. lPSO) .and. (iUHF == 1)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Hybrid UDFT and UHF

  jSym = 1
  kSym = jSym
  iSym = 1
  lSym = Mul(jSym,iSym)
  nik1 = nIJ1(iSym,kSym,1)
  nik2 = nIJ1(iSym,kSym,2)
  nik = max(nik1,nik2)

  n = nik*jBas
  iS = 1
  iE = n*2
  CiKj(1:n,1:2) => CijK(iS:iE)

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
    jSOj = jSO-iOffA

    ! Pick up the MO transformed fitting coefficients, C_ik^J
    if (nik1 /= 0) then
      iAdrJ = nik1*(jSOj-1)+iAdrCVec(jSym,iSym,1)
      call dDaFile(LuCVector(jSym,1),2,CiKj(:,1),nik1*jBas,iAdrJ)
    end if

    if (nik2 /= 0) then
      iAdrJ = nik2*(jSOj-1)+iAdrCVec(jSym,iSym,2)
      call dDaFile(LuCVector(jSym,2),2,CikJ(:,2),nik2*jBas,iAdrJ)
    end if

    do i4=1,iCmp(4)
      lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

      iPAO = iPAO+1
      nijkl = 0

      Factor = Zero
      A(1:jBas*lBas) = Zero
      do iSO=1,nKVec
        nik = nIJ1(iSym,kSym,iSO)

        CiKl(1:nik*lBas) => CijK(iE+1:iE+nik*lBas)

        if (nik == 0) cycle

        if (lSO /= jSO) then
          lSOl = lSO-iOffA
          iAdrL = nik*(lSOl-1)+iAdrCVec(jSym,iSym,iSO)
          call dDaFile(LuCVector(jSym,iSO),2,CiKl,nik*lBas,iAdrL)
          V2(1:) => CiKl(1:)
        else
          V2(1:) => CiKj(1:,iSO)
        end if

        call DGEMM_('T','N',jBas,lBas,nik,One,CikJ(:,iSO),nik,V2,nik,Factor,A,jBas)
        Factor = One
      end do

      do lAOl=0,lBas-1
        lSOl = lSO+lAOl-iOffA
        do jAOj=0,jBas-1
          jSOj = jSO+jAOj-iOffA
          nijkl = nijkl+1

          temp = CoulFac*V_K(jSOj,1)*V_K(lSOl,1)
          temp = temp-Two*ExFac*A(nijkl)

          PMax = max(PMax,abs(temp))
          PAO(nijkl,iPAO) = Fac*temp
        end do
      end do
    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((iMP2prpt /= 2) .and. lPSO .and. (.not. LSA)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! CASSCF

  iSO = 1

  jSym = 1
  kSym = jSym
  iSym = 1
  lSym = Mul(jSym,iSym)

  nik = nIJ1(iSym,kSym,iSO)
  iS = 1
  iE = nik*jBas
  CiKj(1:nik*jBas,1:1) => CijK(iS:iE)
  iS = iE+1
  iE = iE+nik*lBas
  CiKl(1:nik*lBas) => CijK(iS:iE)

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)

    ! Pick up the MO transformed fitting coefficients, C_ik^J
    jSOj = jSO-iOffA
    iAdrJ = nik*(jSOj-1)+iAdrCVec(jSym,iSym,1)
    call dDaFile(LuCVector(jSym,1),2,CiKj(:,1),nik*jBas,iAdrJ)

    do i4=1,iCmp(4)
      lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

      iPAO = iPAO+1
      nijkl = 0

      if (lSO /= jSO) then
        lSOl = lSO-iOffA
        iAdrL = nik*(lSOl-1)+iAdrCVec(jSym,iSym,1)
        call dDaFile(LuCVector(jSym,1),2,CiKl,nik*lBas,iAdrL)

        V2(1:) => CiKl(1:)
      else
        V2(1:) => CiKj(1:,1)
      end if

      A(1:jBas*lBas) = Zero
      call DGEMM_('T','N',jBas,lBas,nik,One,CiKj(:,1),nik,V2,nik,Zero,A,jBas)

      do lAOl=0,lBas-1
        lSOl = lSO+lAOl-iOffA
        do jAOj=0,jBas-1
          jSOj = jSO+jAOj-iOffA
          nijkl = nijkl+1

          temp = CoulFac*V_K(jSOj,1)*V_K(lSOl,1)
          temp = temp-ExFac*A(nijkl)

          ! Active space contribution
          temp2 = Zero
          do jp=1,nnP(0)
            temp2 = temp2+sign(One,DMdiag(jp,1))*Z_p_K(jp,jSOj,1)*Z_p_K(jp,lSOl,1)
          end do
          temp = temp+temp2

          PMax = max(PMax,abs(temp))
          PAO(nijkl,iPAO) = Fac*temp
        end do
      end do
    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((iMP2prpt /= 2) .and. lPSO .and. lSA) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !   SA-CASSCF

  jSym = 1
  kSym = jSym
  iSym = 1
  lSym = Mul(jSym,iSym)

  nik1 = nIJ1(iSym,kSym,1)
  nik2 = nIJ1(iSym,kSym,2)
  nik = max(nik1,nik2)

  iS = 1
  iE = 2*nik*jBas
  CiKj(1:nik*jBas,1:2) => CijK(iS:iE)

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
    jSOj = jSO-iOffA

    ! Pick up the MO transformed fitting coefficients, C_ik^J
    if (nik1 /= 0) then
      iAdrJ = nik1*(jSOj-1)+iAdrCVec(jSym,iSym,1)
      call dDaFile(LuCVector(jSym,1),2,CikJ(:,1),nik1*jBas,iAdrJ)
    end if

    if (nik2 /= 0) then
      iAdrJ = nik2*(jSOj-1)+iAdrCVec(jSym,iSym,2)

      call dDaFile(LuCVector(jSym,2),2,CikJ(:,2),nik2*jBas,iAdrJ)
    end if

    do i4=1,iCmp(4)
      lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

      iPAO = iPAO+1
      nijkl = 0

      Factor = Zero
      A(1:jBas*lBas) = Zero

      do iSO=1,nKVec
        nik = nIJ1(iSym,kSym,iSO)

        CiKl(1:nik*lBas) => CijK(iE+1:iE+nik*lBas)

        if (nik == 0) cycle

        if (lSO /= jSO) then
          lSOl = lSO-iOffA
          iAdrL = nik*(lSOl-1)+iAdrCVec(jSym,iSym,iSO)
          call dDaFile(LuCVector(jSym,iSO),2,CikL,nik*lBas,iAdrL)
          V2(1:) => CiKl(1:)
        else
          V2(1:) => CiKj(1:,iSO)
        end if

        ! Here one should keep track of negative eigenvalues of the densities

        iSO2 = iSO+2

        do l=1,lBas
          do k=1,jBas

            tmp = Zero

            do i=1,nChOrb(0,iSO)
              do j=1,nChOrb(0,iSO2)

                jik = j+nChOrb(0,iSO2)*(i-1)+nik*(k-1)
                jil = j+nChOrb(0,iSO2)*(i-1)+nik*(l-1)
                if (j <= npos(0,iSO)) then
                  tmp = tmp+CiKj(jik,iSO)*V2(jil)
                else
                  tmp = tmp-CiKj(jik,iSO)*V2(jil)
                end if
              end do
            end do

            kl = k+jBas*(l-1)
            A(kl) = Factor*A(kl)+tmp

          end do
        end do
        Factor = One

      end do

      do lAOl=0,lBas-1
        lSOl = lSO+lAOl-iOffA
        do jAOj=0,jBas-1
          jSOj = jSO+jAOj-iOffA
          nijkl = nijkl+1

          temp = CoulFac*(V_K(lSOl,1)*V_K(jSOj,2)+V_K(lSOl,2)*V_K(jSOj,1)+V_K(lSOl,3)*V_K(jSOj,4)+V_K(lSOl,4)*V_K(jSOj,3)+ &
                          V_K(lSOl,1)*V_K(jSOj,5)+V_K(lSOl,5)*V_K(jSOj,1))
          temp = temp-ExFac*A(nijkl)

          ! Active space contribution
          temp2 = Zero
          do jp=1,nnP(0)
            temp2 = temp2+sign(One,DMdiag(jp,1))*Z_p_K(jp,jSOj,1)*Z_p_K(jp,lSOl,1)+ &
                    sign(Two,DMdiag(jp,2))*(Z_p_K(jp,jSOj,2)*Z_p_K(jp,lSOl,3)+Z_p_K(jp,jSOj,3)*Z_p_K(jp,lSOl,2))
          end do
          temp = temp+temp2

          PMax = max(PMax,abs(temp))
          PAO(nijkl,iPAO) = Fac*temp
        end do
      end do
    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! MP2

  iSO = 1

  jSym = 1
  kSym = jSym
  iSym = 1
  lSym = Mul(jSym,iSym)

  nik = nIJ1(iSym,lSym,iSO)

  iS = 1
  iE = nik*max(jBas,lBas)*2
  CiKj(1:nik*max(jBas,lBas),1:2) => CijK(iS:iE)

  do i2=1,iCmp(2)
    jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)

    jSOj = jSO-iOffA
    iAdrJ = nik*(jSOj-1)+iAdrCVec(jSym,iSym,1)
    call dDaFile(LuCVector(jSym,1),2,CiKj(:,1),nik*jBas,iAdrJ)

    do i4=1,iCmp(4)
      lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
      iPAO = iPAO+1
      nijkl = 0

      if (lSO /= jSO) then
        lSOl = lSO-iOffA
        iAdrL = nik*(lSOl-1)+iAdrCVec(jSym,iSym,1)
        call dDaFile(LuCVector(jSym,1),2,CiKj(:,2),nik*lBas,iAdrL)

        V2(1:) => CiKj(1:,2)
      else
        V2(1:) => CiKj(1:,1)
      end if

      A(1:jBas*lBas) = Zero
      call DGEMM_('T','N',jBas,lBas,nik,One,CiKj(:,1),nik,V2,nik,Zero,A,jBas)

      do lAOl=0,lBas-1
        lSOl = lSO+lAOl-iOffA

        ! While the I/O here has been moved outside the
        ! inner loop this needs to be reconsidered and
        ! improved such that it can be moved out yet
        ! another loop (or more.)

        lTot = jBas
        iAdrA = nAuxVe*(lSOl-1)+(jSO-iOffA)
        call dDaFile(LuAVector(1),2,AMP2(:,1),lTot,iAdrA)
        iAdrA = nAuxVe*(lSOl-1)+(jSO-iOffA)
        call dDaFile(LuAVector(2),2,AMP2(:,2),lTot,iAdrA)

        do jAOj=0,jBas-1
          jSOj = jSO+jAOj-iOffA
          nijkl = nijkl+1

          temp = CoulFac*V_K(jSOj,1)*V_K(lSOl,1)+CoulFac*V_K(jSOj,1)*U_K(lSOl)+CoulFac*U_K(jSOj)*V_K(lSOl,1)-ExFac*A(nijkl)

          tempJ_mp2 = AMP2(1+jAOj,2)
          temp = temp+tempJ_mp2*CoulFac

          tempK_mp2 = AMP2(1+jAOj,1)
          temp = temp-ExFac*half*tempK_mp2

          PMax = max(PMax,abs(temp))
          PAO(nijkl,iPAO) = Fac*temp
        end do
      end do
    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if

nullify(CiKj,CiKl,V2)
!                                                                      *
!***********************************************************************
!                                                                      *
if (iPAO /= nPAO) then
  write(u6,*) ' Error in PGet1_RI2!'
  call Abend()
end if

#ifdef _DEBUGPRINT_
call RecPrt(' In PGet1_RI2:PAO ',' ',PAO,ijkl,nPAO)
#endif
call CWTime(Cpu2,Wall2)
Cpu = Cpu2-Cpu1
Wall = Wall2-Wall1
tavec(1) = tavec(1)+Cpu
tavec(2) = tavec(2)+Wall

return

end subroutine PGet1_RI2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine put_dkoperators_i(i,string,iarray)
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
#include "dkhparameters.fh"
      character*(*) string
      dimension iarray(*)
*
      lwop=8/intrea()
      nwop=(maxlength-1)/lwop+1
      koff=(i-1)*nwop
*
      Call ByteCopy(String,iArray(koff+1),MaxLength)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine max5h1(imax,rmax,symp,symq,symr,syms,p,q,r,s,val)
! this routine adds new max amplitude and skips smallest
!
! imax - store of indices of 5 max (I/O)
! rmax - store of values of 5 max (I/O)
! symp - symmetry of p index (I)
! symq - symmetry of q index (I)
! symr - symmetry of r index (I)
! syms - symmetry of s index (I)
! p    - value of p index (I)
! q    - value of q index (I)
! r    - value of r index (I)
! s    - value of s index (I)
! val  - value of amplitude (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: imax(8,5)
real(kind=wp), intent(inout) :: rmax(5)
integer(kind=iwp), intent(in) :: symp, symq, symr, syms, p, q, r, s
real(kind=wp), intent(in) :: val
integer(kind=iwp) :: nhelp1, nhelp2

!1 find position of this value

do nhelp1=1,5
  if (abs(val) >= abs(rmax(nhelp1))) exit
end do

!2 1-(nhelp1-1) stay untouched

!3 push other records if nec.

if (nhelp1 < 5) then
  do nhelp2=4,nhelp1,-1
    rmax(nhelp2+1) = rmax(nhelp2)
    imax(:,nhelp2+1) = imax(:,nhelp2)
  end do
end if

!4 add new one

rmax(nhelp1) = val
imax(1,nhelp1) = symp
imax(2,nhelp1) = symq
imax(3,nhelp1) = symr
imax(4,nhelp1) = syms
imax(5,nhelp1) = p
imax(6,nhelp1) = q
imax(7,nhelp1) = r
imax(8,nhelp1) = s

return

end subroutine max5h1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, IBM                                              *
*               1991, Roland Lindh                                     *
************************************************************************
      Logical Function TstFnc(iCoSet,iIrrep,iBsFnc,nStab)
************************************************************************
*                                                                      *
* Object: to establish if a function is a basis function of a          *
*         irreducible representation.                                  *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             September 1991                                           *
************************************************************************
      use Symmetry_Info, only: nIrrep, iOper, iChTbl
      Implicit Real*8 (A-H,O-Z)
      Integer iCoSet(0:7,0:7), iAcc(0:7)
      Integer iBsFnc
*
      TstFnc = .True.
      nCoSet=nIrrep/nStab
      iAcc(0:nCoSet-1)=0
*
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*) 'TstFnc'
      Write (6,*)
      Write (6,*) 'Coset:'
      Do i = 0, nCoSet-1
         Write (6,'(8I4)') (iCoSet(i,j),j=0,nStab-1)
      End Do

      Write (6,*)
      Write (6,*) 'iOper:'
      Write (6,'(8I4)') (iOper(i),i=0,nIrrep-1)
      Write (6,*)
      Write (6,*) 'iBsFnc=',iBsFnc
      Write (6,*)
      Write (6,*) 'iChTbl:'
      Write (6,'(8I4)') (iChTbl(iIrrep,i),i=0,nIrrep-1)
#endif
*
*     Loop over operators
*
      Do i = 0, nIrrep-1
*
*        Find index of the generated center
*
         n = -1
         Do j = 0, nCoSet-1
            If (n.ge.0) Cycle
            Do k = 0, nStab-1
               If (iOper(i).eq.iCoSet(j,k)) n = j
            End Do
         End Do
*
         If (n.lt.0 .or. n.gt.nCoSet-1) Then
            Call WarningMessage(2,'TstFnc: n.lt.0 .or. n.gt.nCoSet-1')
            Write (6,*) ' Coset index',n,' is wrong!'
            Call Abend()
         End If
*
         iCom=iAnd(iOper(i),iBsFnc)
         iAcc(n) = iAcc(n) + iChTbl(iIrrep,i)*iPrmt_(iCom)
*
      End Do
      Do i = 0, nCoSet-1
         If (iAcc(i).eq.0) TstFnc = .False.
      End Do
*
      Return
      End Function TstFnc
*
      Logical Function TF(mdc,iIrrep,iComp)
      Use Center_Info, Only : dc
      Implicit Real*8 (a-h,o-z)
      Logical, External :: TstFnc
      TF = TstFnc(dc(mdc)%iCoSet,iIrrep,iComp,dc(mdc)%nStab)
      End Function TF
*
      Integer Function iPrmt_(iCom)
************************************************************************
*     Returns the phase factor of a basis function under a symmetry    *
*     operation, jOper. iChct contains the information about the       *
*     character of the basis function.                                 *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Integer i, iCom
      iPrmt_= 1
      Do i = 1, 3
         If (iAnd(iCom,2**(i-1)).ne.0) iPrmt_= iPrmt_*(-1)
      End Do
      Return
      End Function iPrmt_

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Jonas Bostrom                                    *
************************************************************************

      Subroutine Construct_WDensII(EOcc,EVir,EFro,EDel)
*
*     Jonas Bostrom, October 2008
*
*     Purpose: Construct the piece of the energy-weighted density
*              usually labeled II.
*
#include "implicit.fh"
      Real*8 EOcc(*), EVir(*), EFro(*), EDel(*)
#include "cholesky.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"
*
      Character*20 ThisNm
      Character*25 SecNam
      Parameter (SecNam = 'Construct_WDensII',
     &           ThisNm = 'Construct_WDensII')
*
      iDensActOcc(i,j,k) = ip_Density(k)
     &                   +  j-1
     &                   + (nOrb(k) + nDel(k))
     &                   * (i + nFro(k) - 1)
      iWDensActOcc(i,j,k) = ip_WDensity(k)
     &                    +  j-1
     &                    + (nOrb(k) + nDel(k))
     &                    * (i-1 + nFro(k))
      iDensVactVall(i,j,k) = ip_Density(k)
     &                     + j-1 + nFro(k) + nOcc(k)
     &                     + (nOrb(k) + nDel(k))
     &                     * (i-1 + nFro(k) + nOcc(k))
      iWDensVactVall(i,j,k) = ip_WDensity(k)
     &                      + j-1 + nFro(k) + nOcc(k)
     &                      + (nOrb(k) + nDel(k))
     &                      * (i-1 + nFro(k) + nOcc(k))
      iDensVallOcc(i,j,k) = ip_Density(k)
     &                    +  j-1
     &                    + (nOrb(k) + nDel(k))
     &                    * (i-1 + nFro(k) + nOcc(k))
      iWDensVallOcc(i,j,k) = ip_WDensity(k)
     &                    +  j-1
     &                    + (nOrb(k) + nDel(k))
     &                    * (i-1 + nFro(k) + nOcc(k))
*
      Do iSym = 1, nSym
********************************************************************
*     Construct Wij(II)
********************************************************************
         Do iI = 1, nOcc(iSym)
            E_i = EOcc(iOcc(iSym) + iI)
            Do iJ = 1, nFro(iSym) + nOcc(iSym)
               If(iJ .le. nFro(iSym)) Then
                  E_j = EFro(iFro(iSym) + iJ)
               Else
                  E_j = EOcc(iOcc(iSym) + iJ - nFro(iSym))
               End If
               Work(iWDensActOcc(iI,iJ,iSym)) =
     &              Work(iWDensActOcc(iI,iJ,iSym))
     &           -  0.5d0 * Work(iDensActOcc(iI,iJ,iSym))
     &           * (E_i + E_j)
            End Do
         End Do
*********************************************************************
*     Construct Wab(II)
*********************************************************************
         Do iA = 1, nVir(iSym)
            E_a = EVir(iVir(iSym) + iA)
            Do iB = 1, nVir(iSym) + nDel(iSym)
               If(iB .gt. nVir(iSym)) Then
                  E_b = EDel(iDel(iSym) + iB - nVir(iSym))
               Else
                  E_b = EVir(iVir(iSym) + iB)
               End If
               Work(iWDensVactVall(iA,iB,iSym)) =
     &              Work(iWDensVactVall(iA,iB,iSym))
     &           -  0.5d0 * Work(iDensVactVall(iA,iB,iSym))
     &           * (E_a + E_b)
            End Do
************************************************************************
*     Construct Wai(II) (The factor 2 in front of Pai is because Ppq is
*                        already symmetrized here)
************************************************************************
            Do iI = 1, nFro(iSym) + nOcc(iSym)
               If(iI .le. nFro(iSym)) Then
                  E_i = EFro(iFro(iSym) + iI)
               Else
                  E_i = EOcc(iOcc(iSym) + iI - nFro(iSym))
               End If
               Work(iWDensVallOcc(iA,iI,iSym)) =
     &              Work(iWDensVallOcc(iA,iI,iSym))
     &           - 2.0d0 * Work(iDensVallOcc(iA,iI,iSym))
     &           * (E_i)
            End Do
         End Do
      End Do
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Jie J. Bao                                       *
************************************************************************
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Aug. 06, 2020, created this file.               *
* ****************************************************************
      subroutine CalcAXPzx(AXPzx,GDMat,PUVX,NPUVX,IndTUVX,DDg,zx)
***************************************************************************
*  Some notes from the author:
*
*  Sum_KL{z_KL * (d^2)Q/(dX_KL)(dP_MLam)}_tuvx =
*
*   2 * Sum_K[ z_MK * <K| E_tu |Lam> * (D^MM_vx - D^KK_vx) ]   !
* - 2 * Sum_K[ z_KM * <K| E_tu |Lam> * (D^MM_vx - D^KK_vx) ]   !       (1)
*
* + <M| E_tu |Lam> * 4*Sum_K[ z_MK * D^MK_vx - z_KM * D^KM_vx ]!       (2)
*
* + Sum_KL z_KL * { c_LLam * [ 2 * (DDg_KMLL - DDg_KLKK) + 4 * DDg_KLLM ]
* + c_KLam * [ 2 * (DDg_LMLL - DDg_LMKK) - 4 * DDg_KLKM ] }            (3)
*
*  Now let's consider some details of the code.
*
*  Loop over M.
*
*  Computing (1) ...
*
*  Loop over K.
*
*  For each K, calculate Ddiff^KM_tu = D^MM_tu - D^KK_tu
*
*  Then construct the operator, Wop
*   if M > K, Wop_tu =  2 * Sum_vx z_MK * Ddiff^KM_vx * g_tuvx
*   if M < K, Wop_tu = -2 * Sum_vx z_KM * Ddiff^KM_vx * g_tuvx
*
*  Then call CISigma, and save the results to the array WSLam
*  (wo...si...le...? an example of a bad variable name)
*  daxpy WSLam((K-1)*nConf1+1) to AXPzx((M-1)*nConf1+1)
*
*  End looping over K
*
*  Computing (2)
*
*  Define a density matrix that accumutates the 4*Sum half in part (2).
*  Note this density matrix as D_acc
*
*  Fzero D_acc
*
*  Loop over K again.
*   if M > K, daxpy  4*z_MK D^MK to D_acc.
*   if M < K, daxpy -4*z_KM D^MK to D_acc.
*
*  End looping over K
*
*  Now my Wop_tu is computed as
*  Wop_tu = sum_vx D_acc_vx * g_tuvx
*
*  Then call CISigma, and daxpy WSLam((M-1)*nConf1+1) to
*  AXPzx((M-1)*nConf1+1)
*
*  Computing (3)
*
*  declare coeff1 and coeff2
*
*  Loop over KL
*
*  In each KL
*  coeff1 = z_KL * [ 2 * (DDg_KMLL - DDg_KLKK) + 4 * DDg_KLLM ]
*  coeff2 = z_KL * [ 2 * (DDg_LMLL - DDg_LMKK) - 4 * DDg_KLKM ]
*
*  Then daxpy coeff1 CIVec((L-1)*nConf1+1) to AXPzx((M-1)...)
*  and  daxpy coeff2 CIVec((K-1)*nConf1+1) to AXPzx((M-1)...)
*
*  End looping over M
*
*  It can be dissembled into three parts to compute the term above, as
*  labeled in the equations.
*
*  In computing part (1), note that z_MK applies to cases when K < M,
*  and z_KM applies to cases when K > M. Computing this term requires
*  calling CISigma for each K != M. After the loop over M is done, there
*  will be N*(N-1) times when it is called, where N is the number of
*  states.
*
*  The rules for z_MK or z_KM are the same for part (2) as for part
*  (1). For each M, CISigma iscalled only once, so CISigma is called
*  only N times for computing part (2).
*
*  In total CISigma will be called N^2 times, but the memory needed to
*  compute AXPzx is a real*8 array sized nRoots*nConf1.
*
*  In CalcAXPzx1, CISigma is called N*(N-1)/2 times, but array is sized
*  N*(N-1)/2*nRoots*nConf1 (note that N = nRoots).  Maybe this is a good
*  reason to keep both algorithms.
*
*  End of the "essay".
*
************************************************************************
      use ipPage, only: W
      Implicit Real*8 (a-h,o-z)

#include "stdalloc.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"


******Input
      Real*8,DIMENSION((nRoots-1)*nRoots/2)::zX
      Real*8,DIMENSION(nRoots*(nRoots+1)/2,nnA,nnA)::GDMat
      Integer NPUVX
      Real*8,DIMENSION(NPUVX)::PUVX
      INTEGER,DIMENSION(ntAsh,ntAsh,ntAsh,ntAsh)::IndTUVX
      Real*8,DIMENSION((nRoots+1)*nRoots/2,(nRoots+1)*nRoots/2)::DDg
******Output
      Real*8,DIMENSION(NConf1*nRoots)::AXPzx
******Auxiliaries
      Real*8,DIMENSION(:),Allocatable::Wop,Ddiff,D_acc
      INTEGER K,L,M
      INTEGER jSym
      INTEGER iKK,iLL,iKL,iKL2,iKM2,iLM
      Integer,DIMENSION(nSym):: off_Ash
      Real*8 coeff1,coeff2,Coeff,dRoots
      Integer tempi1,ipwslam,nconf3
      Real*8,DIMENSION(1)::tempda

      INTEGER I
      Real*8,DIMENSION(:),Allocatable:: ovrlp
*                                                                      *
************************************************************************
*                                                                      *
      Interface
       SubRoutine CISigma_sa(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,
     &                       Int2a,nInt2a,ipCI1,ipCI2, Have_2_el)
       Integer iispin, iCsym, iSSym
       Integer nInt1, nInt2s, nInt2a
       Real*8, Target:: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
       Integer ipCI1, ipCI2
       Logical Have_2_el
       End SubRoutine CISigma_sa
      End Interface
*                                                                      *
************************************************************************
*                                                                      *


      CALL FZero(AXPzx,nConf1*nRoots)
******Covnerting nRoots to double prec type
      dRoots=Real(nRoots,8)
******Symmetry off-set
      tempi1=0
      DO jSym=1, nSym
       off_Ash(jSym)=tempi1
       tempi1=tempi1+nAsh(jSym)
      END DO

******memory allocation
      nConf3=nint(Max(xispsm(State_SYM,1),xispsm(State_SYM,1)))
      ipwslam=ipGet(nConf3*nRoots)

      CALL mma_allocate(Wop,nDens2)
      CALL mma_allocate(Ddiff,nnA**2)
      CALL mma_allocate(D_acc,nnA**2)

      CALL FZero(Wop,nDens2)
*     only a subset, and the same one, of Wop is overwritten
*     so it is ok to fzero it here only once

***** Starting the procedure in the "essay"
****  looping over M


      DO M=1,nRoots
****  Computing (1)
       Do K=1,nRoots
        IF(K.eq.M) Cycle
        IF(M.gt.K) THEN
         iKM2=(M-2)*(M-1)/2+K
        ELSE
         iKM2=(K-2)*(K-1)/2+M
        END IF
        CALL CalcDdiff(Ddiff,GDMat,M,K,nnA,nRoots)
        Coeff=2.0d0*zx(IKM2)
        IF(K.gt.M) Coeff=-Coeff
        CALL CalcWop(Wop,Ddiff,PUVX,NPUVX,IndTUVX,Coeff,off_Ash)
        CALL CISigma_SA(0,State_Sym,State_Sym,Wop,nDens2,tempda,1,
     &  tempda,1,ipci,ipwslam,.false.)
*        irc=ipin(ipwslam)
        CALL dAXpY_(nConf1,dRoots,W(ipwslam)%Vec((K-1)*nConf1+1),1,
     &  AXPzx((M-1)*nConf1+1),1)
       End Do
****  Computing (2)
       CALL FZero(D_acc,nnA**2)
       CALL CalcDacc(D_acc,GDMat,M,nnA,nRoots,zx)
       CALL CalcWop(Wop,D_acc,PUVX,NPUVX,IndTUVX,1.0d0,off_Ash)
       CALL CISigma_SA(0,State_Sym,State_Sym,Wop,nDens2,tempda,1,
     & tempda,1,ipci,ipwslam,.false.)
       CALL dAXpY_(nConf1,dRoots,W(ipwslam)%Vec((M-1)*nConf1+1),1,
     & AXPzx((M-1)*nConf1+1),1)
****  Computing (3)
       Do K=2,nRoots
        IKK=(K+1)*K/2
        IF(K.lt.M) IKM=(M-1)*M/2+K
        IF(K.ge.M) IKM=(K-1)*K/2+M
        do L=1,K-1
         ILL=(L+1)*L/2
         IKL=(K-1)*K/2+L
         IKL2=(K-1)*(K-2)/2+L
         IF(L.lt.M) ILM=(M-1)*M/2+L
         IF(L.ge.M) ILM=(L-1)*L/2+M
         Coeff1=zx(IKL2)*
     &   (2.0d0*(DDg(IKM,ILL)-DDg(IKM,IKK))+4.0d0*DDg(IKL,ILM))
         Coeff2=zx(IKL2)*
     &   (2.0d0*(DDg(ILM,ILL)-DDg(ILM,IKK))-4.0d0*DDg(IKL,IKM))

         CALL DAXpY_(nConf1,Coeff1,W(ipCI)%Vec((L-1)*nConf1+1),1,
     &                                  AXPzx((M-1)*nConf1+1),1)
         CALL DAXpY_(nConf1,Coeff2,W(ipCI)%Vec((K-1)*nConf1+1),1,
     &                                  AXPzx((M-1)*nConf1+1),1)
        end do
       End Do
      END DO

***** memory deallocation
      CALL mma_deallocate(Wop)
      CALL mma_deallocate(Ddiff)
      CALL mma_deallocate(D_acc)

***** Now making AXPzx orthogonal to intermediate states
***** This part is not mentioned in the equation above because
***** the method is straightforward.

***** AXPzx_orthonal = AXPzx * (1- Sum_I |I><I|)

      CALL mma_allocate(ovrlp,nRoots**2)

      DO M=1,nRoots
       Do I=1,nRoots
        ovrlp((M-1)*nRoots+I)=
     & ddot_(nConf1,W(ipCI)%Vec((I-1)*nConf1+1),1,
     &                   AXPzx((M-1)*nConf1+1),1)
       End Do
      END DO

      DO M=1,nRoots
       Do I=1,nRoots
        CALL daxpy_(nConf1,-ovrlp((M-1)*nRoots+I),
     &                W(ipCI)%Vec((I-1)*nConf1+1),1,
     &                     AXPzx((M-1)*nConf1+1),1)
       End Do
      END DO

      CALL DScal_(nRoots*nConf1,-1.0d0,AXPzx,1)

      CALL mma_deallocate(ovrlp)

      RETURN
      END SUBROUTINE
******************************************************

******************************************************
      SUBROUTINE CalcWop(Wop,D,PUVX,NPUVX,IndTUVX,Coeff,Off_Ash)
#include "stdalloc.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"
******Input
      INTEGER NPUVX
      Real*8 Coeff
      REAL*8,DIMENSION(nnA**2)::D
      REAL*8,DIMENSION(NPUVX) ::PUVX
      INTEGER,DIMENSION(nnA,nnA,nnA,nnA)::IndTUVX
      INTEGER,DIMENSION(nSym)::  Off_Ash
******Output
      REAL*8,DIMENSION(nDens2)::Wop
******Auxiliaries
      INTEGER jSym,it,iu,t,u,v,x,pt,qu,iLoc1,iLoc2,jAsh
      REAL*8 tempd1

      DO jSym=1,nSym
       jAsh=nAsh(jSym)
       IF(jAsh.eq.0) Cycle
       Do iu=1,jAsh
        u=iu+off_Ash(jSym)
        qu=iu+nIsh(jSym)
        iLoc1=(qu-1)*nBas(jSym)+ipMat(jSym,jSym)-1
       Do it=1,jAsh
        t=it+off_Ash(jSym)
        pt=it+nIsh(jSym)
        tempd1=0.0d0
        do v=1,nnA
         iLoc2=(v-1)*nnA
        do x=1,nnA
         IF(IndTUVX(t,u,v,x).ne.0)
     &    tempd1=tempd1+D(iLoc2+x)*PUVX(IndTUVX(t,u,v,x))
        end do
        end do
        Wop(iLoc1+pt)=tempd1
       End Do
       End Do
      END DO

      CALL DScal_(nDens2,Coeff,Wop,1)

      RETURN
      END SUBROUTINE




******************************************************
      SUBROUTINE CalcDdiff(Ddiff,GDMat,M,K,nnA,nRoots)
      INTEGER nnA,nRoots,M,K
      REAL*8,DIMENSION((nRoots+1)*nRoots/2,nnA,nnA)::GDMat
      REAL*8,DIMENSION(nnA**2)::Ddiff

      INTEGER it,iu,iMM,iKK

      iMM=(M+1)*M/2
      iKK=(K+1)*K/2

      DO it=1,nnA
       Do iu=1,nnA
        Ddiff((it-1)*nnA+iu)=GDMat(iMM,it,iu)-GDMat(iKK,it,iu)
       End Do
      END DO

      RETURN
      END SUBROUTINE

******************************************************
      Subroutine CalcDacc(Dacc,GDMat,M,nnA,nRoots,zx)
      INTEGER nnA,nRoots,M
      REAL*8,DIMENSION((nRoots+1)*nRoots/2,nnA,nnA)::GDMat
      REAL*8,DIMENSION(nnA**2)::Dacc
      REAL*8,DIMENSION((nRoots-1)*nRoots/2)::zx

      INTEGER it,iu,K,IKM,IKM2,iLoc1,iLoc2
      REAL*8 Fact

      CALL FZero(Dacc,nnA**2)

      DO K=1,nRoots
       IF(K.eq.M) Cycle
       IF(M.gt.K) THEN
        IKM =(M-1)*M/2+K
        IKM2=(M-1)*(M-2)/2+K
       ELSE
        IKM =(K-1)*K/2+M
        iKM2=(K-1)*(K-2)/2+M
       END IF
       Fact=4.0d0*zx(IKM2)
       IF(K.gt.M) Fact=-Fact
       Do it=1,nnA
        iLoc1=(it-1)*nnA
        do iu=1,nnA
         iLoc2=iLoc1+iu
         Dacc(iLoc2)=Dacc(iLoc2)+GDMat(IKM,it,iu)*Fact
        end do
       End Do
      END DO
      RETURN
      END SUBROUTINE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_SetPass(Diag,Sync,DiaSh,iSySh,iLoc,Conv,nPotSh)
!
! Purpose: check convergence and, if not converged, set up next
!          next integral pass
!          Diag is the local diagonal; the global diagonal is
!          synchronized if Sync=.True. Note that DiaSh and iSySh
!          must be allocated with dimension nnShl_G (global number
!          of shell pairs in 1st reduced set). iLoc is the location
!          to use in the reduced set index arrays. On exit,
!          Conv=.True. if converged and nPotSh is the number of
!          shell pairs whose max. diagonal element is larger than
!          the decomposition threshold.

use Cholesky, only: Cho_Real_Par, Diag_G
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: Diag(*)
logical(kind=iwp), intent(in) :: Sync
real(kind=wp), intent(_OUT_) :: DiaSh(*)
integer(kind=iwp), intent(_OUT_) :: iSySh(*)
integer(kind=iwp), intent(in) :: iLoc
logical(kind=iwp), intent(out) :: Conv
integer(kind=iwp), intent(out) :: nPotSh

if (Cho_Real_Par) then

  ! Sync diagonal if requested.
  ! ---------------------------

  if (Sync) call Cho_P_SyncDiag(Diag,iLoc)

  ! Swap local and global index arrays and set next integral pass
  ! original serial routine.
  ! -------------------------------------------------------------

  call Cho_P_IndxSwp()
  call Cho_SetPass(Diag_G,DiaSh,iSySh,iLoc,Conv,nPotSh)
  call Cho_P_IndxSwp()

else

  call Cho_SetPass(Diag,DiaSh,iSySh,iLoc,Conv,nPotSh)

end if

end subroutine Cho_P_SetPass

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine generate_juzekOE(oe,oeh,oep,no,nv)
! this routine does:
!
! modifies standard oe record to one used by DIRCC
!
! oeh = ( oe_occ(alpha) ... oe_occ(beta) )   (alpha=beta for this implementation)
!
! oep = ( oe_virt(alpha) ... oe_virt(beta) ) (alpha=beta for this implementation)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: no, nv
real(kind=wp), intent(in) :: oe(no+nv)
real(kind=wp), intent(out) :: oeh(no,2), oep(nv,2)

oeh(:,1) = oe(1:no)
oeh(:,2) = oe(1:no)

oep(:,1) = oe(no+1:no+nv)
oep(:,2) = oe(no+1:no+nv)

return

end subroutine generate_juzekOE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Francesco Aquilante                              *
!***********************************************************************

subroutine Tw_corr(irc,DeTW,CMOI,EOcc,EVir)

use InfSCF, only: nBas, nBT, nDel, nFro, nOcc, nSym
use ChoMP2, only: ChoAlg, DoDens
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iRC
real(kind=wp), intent(out) :: DeTW
real(kind=wp), intent(in) :: CMOI(*), EOcc(*), EVir(*)
integer(kind=iwp) :: i, nElk, nExt(8)
real(kind=wp) :: Grad(1), TW, TW0
real(kind=wp), allocatable :: DMAT(:,:), F_DFT(:)

DoDens = .false.
ChoAlg = 2

call mma_allocate(DMAT,nBT,2,Label='DMAT')

nElk = 0
do i=1,nSym
  nElk = nElk+2*(nFro(i)+nOcc(i,1))
end do
nExt(1:nSym) = nBas(1:nSym)-nDel(1:nSym)-nOcc(1:nSym,1)-nFro(1:nSym)

call DM_FNO_RHF(irc,nSym,nBas,nFro,nOcc(1,1),nExt,nDel,CMOI,EOcc,EVir,DMAT(:,2),DMAT(:,1))
if (irc /= 0) then
  write(u6,*) 'DM_FNO_RHF returned ',irc
  call SysAbendMsg('DM_FNO_RHF','Non-zero return code from DM_FNO_RHF',' ')
end if

call mma_allocate(F_DFT,nBT,Label='F_DFT')

call Fold_tMat(nSym,nBas,DMAT(:,1),DMAT(:,1))
DMAT(:,1) = Half*DMAT(:,1)
call Fold_tMat(nSym,nBas,DMAT(:,2),DMAT(:,2))
DMAT(:,2) = Half*DMAT(:,2)
Grad = Zero

call wrap_DrvNQ('HUNTER',F_DFT,1,TW,DMAT(:,1),nBT,1,.false.,Grad,1,'SCF ')

call wrap_DrvNQ('HUNTER',F_DFT,1,TW0,DMAT(:,2),nBT,1,.false.,Grad,1,'SCF ')
DeTW = (TW-TW0)/real(nElk,kind=wp)

call mma_deallocate(F_DFT)
call mma_deallocate(DMAT)

return

end subroutine Tw_corr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DistMemo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c                 mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,
     c                 PossTau,PossT2n1,PossT2n2,PossT2w,
     c                 PossL11,PossL12,
     c                 PossL21,PossL22,PossL23,PossL24,PossL2W,
     c                 PossH1,PossH2,
     c                 PossM1,PossM2,PossW1,PossW2,PossWw,PossWx,
     c                 PossT,NL2)
c
c       This routine do:
c       define initial possitions of T,L,M and W arrays,
c       described in o2v4ctl routine
c
c
c       I/O parameter description:
c       NaGrp    - # of groups in a set (I)
c       NbeGrp   - # of groups in be set (I)
c       NaSGrp   - # of subgroups in each (a)' group (I)
c       NbeSGrp  - # of subgroups in each (be)' group (I)
c       mdGrpa   - # maximal dimension od (a)' group (I)
c       mdGrpbe  - # maximal dimension od (be)' group (I)
c       mdSGrpa  - # maximal dimension od (a)" subgroup (I)
c       mdSGrpbe - # maximal dimension od (be)" subgroup (I)
c       PossX    - initial possitinos of arrays (O-all)
c       PossT    - next free possition (O)
c       NL2      - # of L2 vectors (O)
c
        implicit none
#include "chcc1.fh"
c
        integer NaGrp,NbeGrp,NaSGrp,NbeSgrp
        integer mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
        integer PossTau,PossT2n1,PossT2n2,PossT2w
        integer PossL11,PossL12
        integer PossH1,PossH2
        integer PossL21,PossL22,PossL23,PossL24,PossL2W
        integer PossM1,PossM2,PossW1,PossW2,PossWw,PossWx
        integer PossT,NL2
c
c       help variables
        integer length,lenab,lenbega
c
c1      Tau
c
        PossTau=possT
        if (NaGrp.eq.1) then
          length=no*no*nv*(nv+1)/2
        else
          length=no*no*mdGrpa*mdGrpa
        end if
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,99) 'DM Tau',PossTau
        end if
c
c2      T2n files
c
        possT2n1=PossT
        if ((NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
          length=no*(no+1)*nv*(nv+1)/4
        else
          length=no*(no+1)*mdSGrpbe*mdSGrpbe/2
        end if
        PossT=PossT+length
c
        possT2n2=PossT
        if ((NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
          length=no*(no-1)*nv*(nv-1)/4
        else
          length=no*(no-1)*mdSGrpbe*mdSGrpbe/2
        end if
        PossT=PossT+length
c
        possT2w=PossT
        if ((NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
          length=no*(no+1)*nv*(nv+1)/4
        else
          length=no*(no+1)*mdSGrpbe*mdSGrpbe/2
        end if
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,99) 'DM T2 ',PossT2n1,PossT2n2,PossT2w
        end if
c
c       L1 files
c
        if (intkey.eq.1) then
c        integral based
          length=0
        else
c        cholesky based
          length=nc*mdGrpa*no
        end if
c
        if (NaGrp.eq.1) then
          PossL11=PossT
          PossL12=PossT
          PossT=PossT+length
        else
          PossL11=PossT
          PossT=PossT+length
          PossL12=PossT
          PossT=PossT+length
        end if
        if (printkey.ge.10) then
        write (6,99) 'DM L1 ',PossL11,PossL12
        end if
c
c       L2 files
c
        if (intkey.eq.1) then
c        integral based
          length=0
        else
c        cholesky based
          length=nc*mdGrpa*mdGrpbe
        end if
c
        if (NaGrp.eq.1) then
          if (NbeGrp.eq.1) then
c         All L2 are identical
            PossL21=PossT
            PossL22=PossT
            PossL23=PossT
            PossL24=PossT
            PossT=PossT+length
            NL2=1
          else
c         L21=L23 and L22=L24
            PossL21=PossT
            PossL23=PossT
            PossT=PossT+length
            PossL22=PossT
            PossL24=PossT
            PossT=PossT+length
            NL2=2
          end if
        else
          if (NbeGrp.eq.1) then
c         L21=L22 and L23=L24
            PossL21=PossT
            PossL22=PossT
            PossT=PossT+length
            PossL23=PossT
            PossL24=PossT
            PossT=PossT+length
            NL2=2
          else
c         all L2 files are different
            PossL21=PossT
            PossT=PossT+length
            PossL22=PossT
            PossT=PossT+length
            PossL23=PossT
            PossT=PossT+length
            PossL24=PossT
            PossT=PossT+length
            NL2=4
          end if
        end if
c
        PossL2W=PossT
        if (intkey.eq.1) then
c        integral based
          length=0
        else
c        cholesky based
        if ((NaGrp.eq.1).and.(NbeGrp.eq.1)) then
          length=nc*nv*(nv+1)/2
        else
          length=nc*mdGrpa*mdGrpbe
        end if
        if ((no*mdGrpbe).gt.length) then
          length=no*mdGrpbe
        end if
        if (nc*no*mdGrpa.gt.length) then
          length=nc*no*mdGrpa
        end if
        end if
c
        PossT=PossT+length
c
        if (printkey.ge.10) then
        write (6,99) 'DM L2 ',PossL21,PossL22,PossL23,PossL24,
     c                       PossL2W
        end if
c
c       H files
c
        length=no*mdSGrpbe
        if (intkey.eq.1) then
          PossH1=PossT
          PossT=PossT+length
          PossH2=PossT
          PossT=PossT+length
        else
          PossH1=PossT
          PossH2=PossT
        end if
        if (printkey.ge.10) then
        write (6,99) 'DM H  ',PossH1,PossH2
        end if
c
c       M files
c
        length=nc*mdSGrpa*mdSGrpbe
c
        if ((NaGrp.eq.1).and.(NaSGrp.eq.1).and.
     c      (NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
c       M1=M2
          PossM1=PossT
          PossM2=PossT
          PossT=PossT+length
        else
c       M files are different
          PossM1=PossT
          PossT=PossT+length
          PossM2=PossT
          PossT=PossT+length
        end if
        if (printkey.ge.10) then
        write (6,99) 'DM M  ',PossM1,PossM2
        end if
c
c       W1,W2 files
c
        if (NaGrp*NaSGrp.eq.1) then
c       W1 and W2 are identical
          length=mdSGrpa*mdSGrpbe*mdSGrpa*mdSGrpbe
          if ((no.gt.mdSGrpbe).and.(intkey.eq.1)) then
          length=mdSGrpa*mdSGrpbe*mdSGrpa*no
          end if
          PossW1=PossT
          PossW2=PossT
          PossT=PossT+length
        else
c       W1 and W2 are different
          length=mdSGrpa*mdSGrpbe*mdSGrpa*mdSGrpbe
          if ((no.gt.mdSGrpbe).and.(intkey.eq.1)) then
          length=mdSGrpa*mdSGrpbe*mdSGrpa*no
          end if
          PossW1=PossT
          PossT=PossT+length
          PossW2=PossT
          PossT=PossT+length
        end if
c
c       Ww file
c
        PossWw=PossT
c
        if ((NaGrp.eq.1).and.(NaSGrp.eq.1)) then
          lenab=nv*(nv+1)/2
        else
          lenab=mdSGrpa*mdSGrpa
        end if
        if ((NbeGrp.eq.1).and.(NbeSGrp.eq.1)) then
          lenbega=nv*(nv+1)/2
        else
          lenbega=mdSGrpbe*mdSGrpbe
        end if
c
        length=lenab*lenbega
        if (intkey.eq.1) then
          length=mdSGrpa*mdSGrpbe*mdSGrpa*mdSGrpbe
          if (no.gt.mdSGrpbe) then
          length=mdSGrpa*mdSGrpbe*mdSGrpa*no
          end if
        end if
        PossT=PossT+length
c
c        Wx file
c
        PossWx=PossT
        length=mdSGrpa*mdSGrpbe*mdSGrpa*no
        if (intkey.eq.0) then
          length=0
        end if
        PossT=PossT+length
c
        if (printkey.ge.10) then
        write (6,99) 'DM W  ',PossW1,PossW2,PossWw,PossWx
c
        write (6,99) 'PossT ',PossT
        end if
c
99        format (a7,10(i10,1x))
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine unpckhelp2(ap,am,b,dimp,dimq,dime,dimf,eadd,noe,fadd,nof)
! this routine does:
! b(e,f) = a(pe,qf)-a(qf,pe) for symp>symq

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dime, dimf, eadd, noe, fadd, nof
real(kind=wp), intent(in) :: ap(dimp,dimq), am(dimq,dimp)
real(kind=wp), intent(inout) :: b(dime,dimf)
integer(kind=iwp) :: f

do f=1,nof
  b(1:noe,f) = ap(eadd+1:eadd+noe,fadd+f)-am(fadd+f,eadd+1:eadd+noe)
end do

return

end subroutine unpckhelp2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1994, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine vCff2D(iDum1 ,iDum2 ,nRys,
     &                  Zeta,ZInv,Eta,EInv,nT,
     &                  Coori,CoorAC,P,Q,
     &                  la,lb,lc,ld,
     &                  U2,PAQP,QCPQ,B10,B00,lac,B01)
************************************************************************
*                                                                      *
* Object: to compute the coefficients in the three terms recurrence    *
*         relation of the 2D-integrals.                                *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Modified loop structure for RISC 1991                    *
*             Modified for decreased memory access January '94.        *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 Zeta(nT), ZInv(nT), Eta(nT), EInv(nT),
     &       Coori(3,4), CoorAC(3,2),
     &       P(nT,3), Q(nT,3), U2(nRys,nT),
     &       PAQP(nRys,nT,3), QCPQ(nRys,nT,3),
     &       B10(nRys,nT),
     &       B00(nRys,nT),
     &       B01(nRys,nT)
      Real*8 tmp
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
*     Local arrays
      Character*30 Label
#endif
      Logical AeqB, CeqD, EQ, PrintB10, PrintB00, PrintB01
*
      iRout = 14
*
#ifdef _DEBUGPRINT_
      Call RecPrt(' In vCff2D: Coori',' ',Coori,3,4)
      Call RecPrt(' In vCff2D: U2',' ',U2,nRys,nT)
      Call RecPrt(' in vCff2d: Zeta',' ',Zeta,1,nT)
      Call RecPrt(' in vCff2d: Eta ',' ',Eta, 1,nT)
      Call RecPrt(' in vCff2d: ZInv',' ',ZInv,1,nT)
      Call RecPrt(' in vCff2d: EInv',' ',EInv,1,nT)
#endif
      AeqB = EQ(Coori(1,1),Coori(1,2))
      CeqD = EQ(Coori(1,3),Coori(1,4))
      PrintB10=.False.
      PrintB01=.False.
      PrintB00=.False.
*
      nabMax = la+lb
      ncdMax = lc+ld
      h12 = Half
         If (nabMax.ge.2 .and. ncdMax.ge.2) Then
      Do iT = 1, nT
         Do iRys = 1, nRys
            tmp=h12 * U2(iRys,iT)
            B00(iRys,iT) = tmp
            B10(iRys,iT) = ( h12 - tmp * Eta(iT))*ZInv(iT)
            B01(iRys,iT) = ( h12 - tmp * Zeta(iT))*EInv(iT)
         EndDo
      EndDo
      PrintB10=.True.
      PrintB01=.True.
      PrintB00=.True.
         Else If (ncdMax.eq.0 .and. nabMax.ge.2) Then
      Do iT = 1, nT
         Do iRys = 1, nRys
            B10(iRys,iT) = ( h12 - h12 * U2(iRys,iT) * Eta(iT))*ZInv(iT)
         EndDo
      EndDo
      PrintB10=.True.
         Else If (nabMax.eq.0 .and. ncdMax.ge.2) Then
      Do iT = 1, nT
         Do iRys = 1, nRys
            B01(iRys,iT) =( h12 - h12 * U2(iRys,iT) * Zeta(iT))*EInv(iT)
         EndDo
      EndDo
      PrintB01=.True.
         Else If (ncdMax.eq.1 .and. nabMax.ge.2) Then
      Do iT = 1, nT
         Do iRys = 1, nRys
            tmp=h12 * U2(iRys,iT)
            B00(iRys,iT) = tmp
            B10(iRys,iT) = ( h12 - tmp * Eta(iT))*ZInv(iT)
         EndDo
      EndDo
      PrintB10=.True.
      PrintB00=.True.
         Else If (nabMax.eq.1 .and. ncdMax.ge.2) Then
      Do iT = 1, nT
         Do iRys = 1, nRys
            tmp=h12 * U2(iRys,iT)
            B00(iRys,iT) = tmp
            B01(iRys,iT) = ( h12 - tmp * Zeta(iT))*EInv(iT)
         EndDo
      EndDo
      PrintB01=.True.
      PrintB00=.True.
         Else  If (nabMax.eq.1 .and. ncdMax.eq.1) Then
      Do iT = 1, nT
         Do iRys = 1, nRys
            B00(iRys,iT) = h12*U2(iRys,iT)
         EndDo
      EndDo
      PrintB00=.True.
         End If
*
      If (nabMax.ne.0 .and. ncdMax.ne.0) Then
         If (.Not.AeqB .and. .Not.CeqD) Then
          Do iCar = 1,3
             Do iT = 1, nT
                Do iRys = 1, nRys
                  tmp=U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar))
                  PAQP(iRys,iT,iCar) =
     &                  P(iT,iCar) - CoorAC(iCar,1) + Eta(iT)*tmp
                  QCPQ(iRys,iT,iCar) =
     &                  Q(iT,iCar) - CoorAC(iCar,2) - Zeta(iT)*tmp
               EndDo
            EndDo
          EndDo
         Else If (AeqB .and. .Not.CeqD) Then
          Do iCar=1,3
             Do iT = 1, nT
                Do iRys = 1, nRys
                  tmp=U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar))
                  PAQP(iRys,iT,iCar) = Eta(iT)*tmp
                  QCPQ(iRys,iT,iCar) =
     &                Q(iT,iCar) - CoorAC(iCar,2) - Zeta(iT)*tmp
               EndDo
            EndDo
          EndDo
         Else If (.Not.AeqB .and. CeqD) Then
          Do iCar=1,3
             Do iT = 1, nT
                Do iRys = 1, nRys
                  tmp= U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar))
                  PAQP(iRys,iT,iCar) =
     &                   P(iT,iCar) - CoorAC(iCar,1) + Eta(iT)*tmp
                  QCPQ(iRys,iT,iCar) = - Zeta(iT)*tmp
               EndDo
            EndDo
          EndDo
         Else
          Do iCar=1,3
             Do iT = 1, nT
                Do iRys = 1, nRys
                  tmp=U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar))
                   PAQP(iRys,iT,iCar) = Eta(iT)*tmp
                   QCPQ(iRys,iT,iCar) = - Zeta(iT)*tmp
               EndDo
            EndDo
          EndDo
         End If
      Else If (nabMax.ne.0) Then
         If (.Not.AeqB) Then
          Do iCar=1,3
             Do iT = 1, nT
                Do iRys = 1, nRys
                  PAQP(iRys,iT,iCar) =
     &                P(iT,iCar) - CoorAC(iCar,1) + Eta(iT)
     &                * (U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar)))
               EndDo
            EndDo
          EndDo
         Else
          Do iCar=1,3
             Do iT = 1, nT
                Do iRys = 1, nRys
                  PAQP(iRys,iT,iCar) = Eta(iT)
     &                * (U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar)))
               EndDo
            EndDo
          EndDO
         End If
      Else If (ncdMax.ne.0) Then
         If (.Not.CeqD) Then
          Do iCar=1,3
             Do iT = 1, nT
                Do iRys = 1, nRys
                  QCPQ(iRys,iT,iCar) =
     &                Q(iT,iCar) - CoorAC(iCar,2) - Zeta(iT)
     &                * (U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar)))
               EndDo
            EndDo
          EndDO
         Else
          Do iCar=1,3
             Do iT = 1, nT
                Do iRys = 1, nRys
                  QCPQ(iRys,iT,iCar) = - Zeta(iT)
     &                * (U2(iRys,iT) * (Q(iT,iCar)-P(iT,iCar)))
               EndDo
            EndDo
          EndDo
         End If
      End If
#ifdef _DEBUGPRINT_
      If (la+lb.gt.0) Then
         Write (Label,'(A)') ' PAQP(x)'
*        Call RecPrt(Label,' ',PAQP(1,1,1),nRys,nT)
         Write (Label,'(A)') ' PAQP(y)'
*        Call RecPrt(Label,' ',PAQP(1,1,2),nRys,nT)
         Write (Label,'(A)') ' PAQP(z)'
*        Call RecPrt(Label,' ',PAQP(1,1,3),nRys,nT)
      End If
      If (lc+ld.gt.0) Then
         Write (Label,'(A)') ' QCPQ(x)'
*        Call RecPrt(Label,' ',QCPQ(1,1,1),nRys,nT)
         Write (Label,'(A)') ' QCPQ(y)'
*        Call RecPrt(Label,' ',QCPQ(1,1,2),nRys,nT)
         Write (Label,'(A)') ' QCPQ(z)'
*        Call RecPrt(Label,' ',QCPQ(1,1,3),nRys,nT)
      End If
      If (PrintB10) Then
         Write (Label,'(A)') ' B10'
         Call RecPrt(Label,' ',B10(1,1),nRys,nT)
      End If
      If (PrintB00) Then
         Write (Label,'(A)') ' B00'
         Call RecPrt(Label,' ',B00(1,1),nRys,nT)
      End If
      If (PrintB01) Then
         Write (Label,'(A)') ' B01'
         Call RecPrt(Label,' ',B01(1,1),nRys,nT)
      End If
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iDum1)
         Call Unused_integer(iDum2)
         Call Unused_integer(lac)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine clearcnt_cvb(icode)
c  ICODE=1 : Orbitals changed
c  ICODE=2 : CI coefficients changed
c  ICODE=3 : Everything changed
      implicit real*8 (a-h,o-z)
      logical initialize
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"
      dimension iunset(mxciobj,2)
      data initialize/.true./
      save iunset,initialize
      if (initialize) then
       iunset(1,1)=0
       iunset(1,2)=0
       do 50 i=2,mxciobj
       iunset(i,1)=1
       iunset(i,2)=1
50     continue
       initialize=.false.
      endif

      if(icode.eq.3)then
        do 100 i=1,mxciobj
        icnt_ci(i)=0
100     continue
      else
        ipow1=2
        ipow2=1
        do 200 ichg=1,2
        if(mod(icode,ipow1).ge.ipow2)then
          do 300 i=1,mxciobj
          if(iunset(i,ichg).eq.1)icnt_ci(i)=0
300       continue
        endif
        ipow1=2*ipow1
        ipow2=2*ipow2
200     continue
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************

!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*
subroutine MKMAW(SGS)

use gugx, only: SGStruct
use stdalloc, only: mma_allocate
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
type(SGStruct), intent(inout) :: SGS
integer(kind=iwp) :: IC, ID, ISUM, IU, IV

call mma_allocate(SGS%MAW,[1,SGS%nVert],[0,3],Label='SGS%MAW')

! COPY LOWER PART OF DIRECT ARC WEIGHT TABLE INTO MAW:
SGS%MAW(SGS%MVSta:SGS%nVert,0:3) = SGS%DAW(SGS%MVSta:SGS%nVert,0:3)
! COPY UPPER PART OF REVERSE ARC WEIGHT TABLE INTO MAW. HOWEVER,
!    NOTE THAT THE MAW TABLE IS ACCESSED BY THE UPPER VERTEX.
SGS%MAW(1:SGS%MVSta-1,0:3) = 0
do IU=1,SGS%MVSta-1
  do IC=0,3
    ID = SGS%Down(IU,IC)
    if (ID /= 0) SGS%MAW(IU,IC) = SGS%RAW(ID,IC)
  end do
end do
! FINALLY, ADD AN OFFSET TO ARCS LEADING TO MIDLEVELS:
ISUM = 1
do IV=SGS%MVSta,SGS%MVEnd
  do IC=0,3
    IU = SGS%Up(IV,IC)
    if (IU == 0) cycle
    SGS%MAW(IU,IC) = ISUM+SGS%MAW(IU,IC)
  end do
  ISUM = ISUM+SGS%RAW(IV,4)
end do
do IV=SGS%MVSta,SGS%MVEnd
  do IC=0,3
    if (SGS%Down(IV,IC) == 0) cycle
    SGS%MAW(IV,IC) = ISUM+SGS%MAW(IV,IC)
  end do
  ISUM = ISUM+SGS%DAW(IV,4)
end do
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' THE MODIFIED ARC WEIGHT TABLE IN MKMAW:'
do IV=1,SGS%nVert
  write(u6,'(1X,I4,5X,5(1X,I6))') IV,SGS%MAW(IV,0:3)
end do
write(u6,*)
#endif

end subroutine MKMAW

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
*               2015, Lasse Kragh Soerensen                            *
************************************************************************
      SUBROUTINE GASDIAS(    NAEL,   IASTR,    NBEL,   IBSTR,    NORB,
     &                       DIAG,   NSMST,       H,            XB,
     &                            RJ,      RK,   NSSOA,   NSSOB,
     &                      LUDIA,   ECORE,   PSSIGN,   IPRNT,
     &                      NTOOB,  ICISTR,   RJKAA,     I12,   IBLTP,
*
     &                     NBLOCK, IBLKFO,I_AM_OUT,N_ELIMINATED_BATCHES)
*
* Calculate determinant diagonal
* Turbo-ras version
*
* Driven by IBLKFO, May 97
*
* ========================
* General symmetry version
* ========================
*
* Jeppe Olsen, July 1995, GAS version
*
* I12 = 1 => only one-body part
*     = 2 =>      one+two-body part
*
* Added the possibility to zero out unwanted diagonal part
* which is needed for highly excited states. Lasse 2015
*
      IMPLICIT REAL*8           (A-H,O-Z)
#include "io_util.fh"
C     REAL * 8  INPROD
*.General input
      DIMENSION NSSOA(NSMST,*),NSSOB(NSMST,*)
      DIMENSION H(NORB)
      DIMENSION I_AM_OUT(*)
*. Specific input
      DIMENSION IBLTP(*),IBLKFO(8,NBLOCK)
*. Scratch
      DIMENSION RJ(NTOOB,NTOOB),RK(NTOOB,NTOOB)
      DIMENSION XB(NORB)
      DIMENSION IASTR(NAEL,*),IBSTR(NBEL,*)
      DIMENSION RJKAA(*)
*. Output
      DIMENSION DIAG(*)

      INTEGER IDUM_ARR(1)
*
      NTEST =  0
      NTEST = MAX(NTEST,IPRNT)
      IF(PSSIGN.EQ.-1.0D0) THEN
         XADD = 1.0D6
      ELSE
         XADD = 0.0D0
      END IF
*

      IF( NTEST .GE. 20 ) THEN
        WRITE(6,*) ' Diagonal one electron integrals'
        CALL WRTMAT(H,1,NORB,1,NORB)
        WRITE(6,*) ' Core energy ', ECORE
        IF(I12.EQ.2) THEN
          WRITE(6,*) ' Coulomb and exchange integrals '
          CALL WRTMAT(RJ,NORB,NORB,NTOOB,NTOOB)
          WRITE(6,*)
          CALL WRTMAT(RK,NORB,NORB,NTOOB,NTOOB)
        END IF
*
        WRITE(6,*) ' TTSS for Blocks '
        DO IBLOCK = 1, NBLOCK
          WRITE(6,'(10X,4I3,2I8)') (IBLKFO(II,IBLOCK),II=1,4)
        END DO
*
        WRITE(6,*) ' I12 = ',I12
      END IF
*
*  Diagonal elements according to Handys formulae
*   (corrected for error)
*
*   DIAG(IDET) = HII*(NIA+NIB)
*              + 0.5 * ( J(I,J)-K(I,J) ) * NIA*NJA
*              + 0.5 * ( J(I,J)-K(I,J) ) * NIB*NJB
*              +         J(I,J) * NIA*NJB
*
*. K goes to J - K
      IF(I12.EQ.2)
     &CALL VECSUM(RK,RK,RJ,-1.0D0,+1.0D0,NTOOB **2)
      IDET = 0
      ITDET = 0
      IF(LUDIA.NE.0) IDISK(LUDIA)=0
*
      DO IBLK = 1, NBLOCK
* Lasse addition
        I_AM_NOT_WANTED = 0
        DO I = 1, N_ELIMINATED_BATCHES
          IF(I_AM_OUT(I).EQ.IBLK) THEN
            I_AM_NOT_WANTED = 1
            EXIT
          END IF
        END DO
* Lasse addition end
*
        IATP = IBLKFO(1,IBLK)
        IBTP = IBLKFO(2,IBLK)
        IASM = IBLKFO(3,IBLK)
        IBSM = IBLKFO(4,IBLK)
*
        IF(IBLTP(IASM).EQ.2) THEN
          IREST1 = 1
        ELSE
          IREST1 = 0
        END IF
*
*. Construct array RJKAA(*) =   SUM(I) H(I)*N(I) +
*                           0.5*SUM(I,J) ( J(I,J) - K(I,J))*N(I)*N(J)
*
*. Obtain alpha strings of sym IASM and type IATP
        IDUM = 0
        IDUM_ARR=0
        CALL GETSTR_TOTSM_SPGP(      1,   IATP,   IASM,   NAEL, NASTR1,
     &                           IASTR,   NORB,     0,IDUM_ARR,IDUM_ARR)
        IOFF =  1
        DO IA = 1, NSSOA(IASM,IATP)
          EAA = 0.0D0
          DO IEL = 1, NAEL
            IAEL = IASTR(IEL,IA)
            EAA = EAA + H(IAEL)
            IF(I12.EQ.2) THEN
              DO JEL = 1, NAEL
                EAA =   EAA + 0.5D0*RK(IASTR(JEL,IA),IAEL )
              END DO
            END IF
          END DO
          RJKAA(IA-IOFF+1) = EAA
        END DO
*. Obtain beta strings of sym IBSM and type IBTP
        CALL GETSTR_TOTSM_SPGP(      2,   IBTP,   IBSM,   NBEL, NBSTR1,
     &                           IBSTR,   NORB,     0,IDUM_ARR,IDUM_ARR)
        IBSTRT = 1
        IBSTOP =  NSSOB(IBSM,IBTP)
        DO IB = IBSTRT,IBSTOP
          IBREL = IB - IBSTRT + 1
*
*. Terms depending only on IB
*
          HB = 0.0D0
          RJBB = 0.0D0
          CALL SETVEC(XB,0.0D0,NORB)
*
          DO IEL = 1, NBEL
            IBEL = IBSTR(IEL,IB)
            HB = HB + H(IBEL )
*
            IF(I12.EQ.2) THEN
              DO JEL = 1, NBEL
                RJBB = RJBB + RK(IBSTR(JEL,IB),IBEL )
              END DO
*
              DO IORB = 1, NORB
                XB(IORB) = XB(IORB) + RJ(IORB,IBEL)
              END DO
            END IF
          END DO
          EB = HB + 0.5D0*RJBB + ECORE
*
          IF(IREST1.EQ.1.AND.IATP.EQ.IBTP) THEN
            IASTRT =  IB
          ELSE
            IASTRT = 1
          END IF
          IASTOP = NSSOA(IASM,IATP)
*
          DO IA = IASTRT,IASTOP
            IDET = IDET + 1
            ITDET = ITDET + 1
            X = EB + RJKAA(IA-IOFF+1)
            DO IEL = 1, NAEL
              X = X +XB(IASTR(IEL,IA))
            END DO
* Lasse addition
            IF(I_AM_NOT_WANTED.EQ.0) THEN
              DIAG(IDET) = X
              IF(IB.EQ.IA) DIAG(IDET) = DIAG(IDET) + XADD
            ELSE
              DIAG(IDET) = 0.0D0
            END IF
* Lasse addition end
          END DO
*         ^ End of loop over alpha strings|
        END DO
*       ^ End of loop over betastrings
*. Yet a RAS block of the diagonal has been constructed
        IF(ICISTR.GE.2) THEN
          IF(NTEST.GE.100) THEN
            write(6,*) ' number of diagonal elements to disc ',IDET
            CALL WRTMAT(DIAG,1,IDET,1,IDET)
          END IF
          CALL ITODS([IDET],1,-1,LUDIA)
          CALL TODSC(DIAG,IDET,-1,LUDIA)
          IDET = 0
        END IF
      END DO
*        ^ End of loop over blocks

      IF(NTEST.GE.5) WRITE(6,*)
     &' Number of diagonal elements generated (1)',ITDET
*
      IF(NTEST .GE.100 .AND.ICISTR.LE.1 ) THEN
        WRITE(6,*) ' CIDIAGONAL '
        CALL WRTMAT(DIAG(1),1,IDET,1,IDET)
      END IF
*
      IF ( ICISTR.GE.2 ) CALL ITODS([-1],1,-1,LUDIA)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Roland Lindh                                     *
!               2010, Mickael G. Delcey                                *
!               2020, Ignacio Fdez. Galvan                             *
!***********************************************************************

function dmwdot(nAt,mAt,A,B)

use Basis_Info, only: dbsc, nCnttp
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: dmwdot
integer(kind=iwp), intent(in) :: nAt, mAt
real(kind=wp), intent(in) :: A(3,nAt), B(3,nAt)
real(kind=wp) :: Fact, TMass, tmp, xMass
integer(kind=iwp) :: i, iAt, iCnt, iCnttp, nData
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: W(:)
integer(kind=iwp), external :: iDeg

!***********************************************************************
!                                                                      *
!      Object : compute the weighted dot product of two vectors        *
!                                                                      *
!***********************************************************************
tmp = Zero
TMass = Zero
call Qpg_dArray('Weights',Found,nData)
if (Found .and. (nData >= mAt)) then
  call mma_allocate(W,nData,label='W')
  call Get_dArray('Weights',W,nData)
else
  call SysAbendMsg('dmwdot','No or wrong weights were found in the RUNFILE.','')
end if
iAt = 0
do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
    do iCnt=1,dbsc(iCnttp)%nCntr
      iAt = iAt+1
      Fact = real(iDeg(A(1,iAt)),kind=wp)
      xMass = Fact*W(iAt)
      TMass = TMass+xMass
      do i=1,3
        tmp = tmp+xMass*A(i,iAt)*B(i,iAt)
      end do
    end do
  end if
end do
call mma_deallocate(W)
dmwdot = tmp/TMass

return

end function dmwdot

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine PickOrb(ipNz,ipSort,ipGref,ipSort_ab,
     &  ipGref_ab,ipVol,ipE,ipOcc,ipE_ab,ipOcc_ab,
     &  nShowMOs,nShowMOs_ab,isener,nMOs,myTitle,ipType)
************************************************************************
* Adapted from SAGIT to work with OpenMolcas (October 2020)            *
************************************************************************
      Use Basis_Info, Only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "grid.fh"
      character myTitle*(*)


       ispin=index(myTitle,' spin')

       ik_ab=0
       ii_ab=0
       il_ab=0
       nShowMOs_ab=0
       do i=0,nMOs-1
        iWork(ipSort+i)=0
        if(isUHF.eq.1) iWork(ipSort_ab+i)=0
       enddo

       ishift=0
       do i=0, nIrrep-1
        if(nBas(i).gt.0) Then
         do j=1,nBas(i)
          iWork(ipNZ+j-1+ishift)=i+1
          iWork(ipNZ+j-1+ishift+nMOs)=j
         enddo
        endif
        ishift=ishift+nBas(i)
       enddo

       eps=1d-6
c if no input, but TypeIndex contains 123
      if(isAuMO.eq.-1.and.isAll.ne.1) then
       iActive=0
       do i=0,nMOs-1
        if(iWork(ipType+i).ge.3
     &     .and.iWork(ipType+i).le.5) iActive=iActive+1
       enddo
       if(iActive.gt.0) then
        ii=0
        do i=0,nMOs-1
        if(iWork(ipType+i).ge.3
     &     .and.iWork(ipType+i).le.5) then
          iWork(ipGref+ii)=i+1
          ii=ii+1
         endif
        enddo
        nShowMOs=iActive
       goto 555

       endif
       endif

       if(isAuMo.eq.-1.and.ispin.gt.0) then
               isAuMO=1
               Region(1)=-2+eps
               Region(2)=-eps
               itRange=0
               isEner=0
       endif

        if(isAll.eq.0) then
          if(isAuMO.eq.1.and.itRange.eq.1) then
               s=Region(1)
               Region(1)=MIN(-Region(2),-Region(1))
               Region(2)=MAX(-Region(2),-s)
               s=Region(1)
               Region(1)=-Region(2)
               Region(2)=-s
          endif
          if(isAuMO.eq.-1 .and. itRange.eq.0) then
               isAuMO=1
               Region(1)=-2+eps
               Region(2)=-eps
          endif
          if(isAuMO.eq.-1 .and. isEner.eq.1) then
           Region(1)=-1000
           Region(2)=1000
          endif
        endif
        if(isAll.eq.1) then
         isAuto=1
         Region(1)=-1000
         Region(2)=1000
        endif
c

*
* 1. user defined number of orbitals. No auto function at all.
*
      if(isAuMO.eq.0) then
       ishift=0
       do i=0, nIrrep-1
         if(nBas(i).gt.0) Then
          iWork(ipSort+i)=ishift
* use Sort as temp
         endif
        ishift=ishift+nBas(i)
        enddo
c
      do i=1,nReq
        iia=iReq(i*2-1)
        iib=iReq(i*2)
        if(iia.le.0.or.iia.gt.nIrrep
     &     .or.iib.lt.0.or.iib.gt.nBas(iia-1)) then
        write (6,'(a)') 'Requested orbital does not exist'
        Call Quit_OnUserError()
c
        endif
        iWork(ipGref+i-1)=iWork(ipSort+iia-1)+iib
        if(isUHF.eq.1)
     *        iWork(ipGref_ab+i-1)=iWork(ipGref+i-1)
      enddo

      nShowMOs=nReq
        if(isUHF.eq.1) nShowMOs_ab=nReq
      goto 555
      endif
***************************************************************
* Well. The user didn't make an exact request. we need to choose orbitals.
       if(itRange.eq.0) then
           isEner=0
           R=Region(2)
           Region(2)=-Region(1)
           Region(1)=-R
       endif

       do i=0,nMOs-1
        Work(ipVol+i)=0.0
        iWork(ipSort+i)=0
        if(isEner.eq.0)  then
           Work(ipE+i)=-Work(ipOcc+i)
           if(isUHF.eq.1) then
           Work(ipE_ab+i)=-Work(ipOcc_ab+i)
           endif
        endif
       enddo


*  Well, now we need to choose rest (nGrid-1) grids.
*
*  Make stupid sorting...
*
       if(NoSort.eq.1) then
        ik=0
        do i=0,nMOs-1
          if(Work(ipE+i).gt.Region(1)
     &       .and.Work(ipE+i).lt.Region(2)) then
c       print *,'EE',Work(ipE+i), Region(1),Region(2)
           ik=ik+1
        iWork(ipSort+i)=ik
          endif
        enddo
        ik_ab=ik
       else

        ik=0
        do i=0,nMOs-1
          if(Work(ipE+i).gt.Region(1)
     &       .and.Work(ipE+i).lt.Region(2)) then
            do j=0,nMOs-1
              if(Work(ipE+j).ge.Work(ipE+i).and.
     &                 Work(ipE+j).ge.Region(1).and.
     &           Work(ipE+j).le.Region(2)) then
                 if(Work(ipE+j).eq.Work(ipE+i)) then
                   if(Work(ipOcc+j).le.Work(ipOcc+i)) then
                     iWork(ipSort+i)=iWork(ipSort+i)+1
                       if(ik.lt.iWork(ipSort+i)) ik=iWork(ipSort+i)
                   endif
                 else
                   iWork(ipSort+i)=iWork(ipSort+i)+1
                    if(ik.lt.iWork(ipSort+i)) ik=iWork(ipSort+i)
                 endif
               endif
             enddo
           endif
        enddo

        if(isUHF.eq.1) then
        ik_ab=0
          do i=0,nMOs-1
            if(Work(ipE_ab+i).gt.Region(1).and.
     &         Work(ipE_ab+i).lt.Region(2)) then
              do j=0,nMOs-1
                if(Work(ipE_ab+j).ge.Work(ipE_ab+i).and.
     &                Work(ipE_ab+j).ge.Region(1).and.
     &          Work(ipE_ab+j).le.Region(2)) then
                 if(Work(ipE_ab+j).eq.Work(ipE_ab+i)) then
                   if(Work(ipOcc_ab+j).le.Work(ipOcc_ab+i)) then
                     iWork(ipSort_ab+i)=iWork(ipSort_ab+i)+1
                       if(ik_ab.lt.iWork(ipSort_ab+i))
     &                           ik_ab=iWork(ipSort_ab+i)
                   endif
                 else
                   iWork(ipSort_ab+i)=iWork(ipSort_ab+i)+1
                    if(ik_ab.lt.iWork(ipSort_ab+i))
     &                          ik_ab=iWork(ipSort_ab+i)
                 endif
               endif
             enddo
           endif
        enddo
       endif
       endif
        if(isAuMO.eq.-1 .and. isEner.ne.0.and.isAll.eq.0) then
         ef=-1000.
         ief=0
         ef_ab=ef
         ief_ab=ief
        do i=0,nMOs-1
          if(Work(ipE+i).gt.ef.and.Work(ipOcc+i).gt.eps) then
            ef=Work(ipE+i)
            ief=i
          endif
          if(isUHF.eq.1) then
          if(Work(ipE_ab+i).gt.ef_ab.and.Work(ipOcc_ab+i).gt.eps) then
            ef_ab=Work(ipE_ab+i)
            ief_ab=i
          endif
          endif
        enddo
c       print *,'ef=',ef
c        print *,'ief=',ief, ief_ab
          ii=iWork(ipSort+ief)
          if(isUHF.eq.1) ii_ab=iWork(ipSort_ab+ief_ab)
        do i=0,nMOs-1
          if(iWork(ipSort+i).gt.ii+iMaxUp.or.
     *        iWork(ipSort+i).lt.ii-iMaxDown) iWork(ipSort+i)=0
          if(isUHF.eq.1) then
            if(iWork(ipSort_ab+i).gt.ii_ab+iMaxUp.or.
     *      iWork(ipSort_ab+i).lt.ii_ab-iMaxDown) iWork(ipSort_ab+i)=0
          endif
        enddo
        endif

      il=0
      do j=1,ik
      do i=0,nMOs-1
        if (iWork(ipSort+i).eq.j) then
          iWork(ipGRef+il)= i+1
          il=il+1
        endif
      enddo
      enddo
      if(isUHF.eq.1) then
      il_ab=0
      do j=1,ik_ab
      do i=0,nMOs-1
        if (iWork(ipSort_ab+i).eq.j) then
          iWork(ipGRef_ab+il_ab)= i+1
          il_ab=il_ab+1
        endif
      enddo
      enddo
      endif
      nShowMOs=il
      if(isUHF.eq.1) nShowMOs_ab=il_ab
555   return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine HRR1(ab1,nab1,a1b,na1b,cffAB,ab,nab,na,nb,na1,nb1,nPrim,la,lb)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             June '91                                                 *
!***********************************************************************

use Index_Functions, only: C_Ind3, nTri_Elem1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nab1, na1b, nab, na, nb, na1, nb1, nPrim, la, lb
real(kind=wp), intent(out) :: ab1(nPrim,nab1)
real(kind=wp), intent(in) :: a1b(nPrim,na1b), cffAB(3), ab(nPrim,nab)
integer(kind=iwp) :: ipA1B, ipAB, ipAB1, ipxyz, ixa, ixb, ixyza, ixyza1, ixyzb, ixyzb1, iya, iyb, iza, izb
#ifdef _DEBUGPRINT_
character(len=72) :: Label
#endif

#ifdef _DEBUGPRINT_
write(Label,'(A,i1,A,i1,A)') ' Source: (',na1,',',nb,'|'
call RecPrt(Label,' ',a1b,nPrim,na1b)
call RecPrt(' Coordinates (A-B)',' ',cffAB,1,3)
write(Label,'(A,i1,A,i1,A)') ' Source: (',na,',',nb,'|'
call RecPrt(Label,' ',ab,nPrim,nab)
#endif

! Loop over indices of the target batch

do ixb=nb1,0,-1
  do iyb=nb1-ixb,0,-1
    izb = nb1-ixb-iyb
    ixyzb1 = C_Ind3(ixb,iyb,izb)

    do ixa=na,0,-1
      do iya=na-ixa,0,-1
        iza = na-ixa-iya

        ixyza = C_Ind3(ixa,iya,iza)

        ! Find a angular index which can be decremented

        if (ixb /= 0) then
          ipxyz = 1
          ixyza1 = C_Ind3(ixa,iya,iza)
          ixyzb = C_Ind3(ixb,iyb,izb)
        else if (iyb /= 0) then
          ipxyz = 2
          ixyza1 = C_Ind3(ixa,iya+1,iza)
          ixyzb = C_Ind3(ixb,iyb-1,izb)
        else
          ipxyz = 3
          ixyza1 = C_Ind3(ixa,iya,iza+1)
          ixyzb = C_Ind3(ixb,iyb,izb-1)
        end if
        if (la >= lb) then
          ipab1 = ixyza+nTri_Elem1(na)*(ixyzb1-1)
          ipa1b = ixyza1+nTri_Elem1(na1)*(ixyzb-1)
          ipab = ixyza+nTri_Elem1(na)*(ixyzb-1)
        else
          ipab1 = ixyzb1+nTri_Elem1(nb1)*(ixyza-1)
          ipa1b = ixyzb+nTri_Elem1(nb)*(ixyza1-1)
          ipab = ixyzb+nTri_Elem1(nb)*(ixyza-1)
        end if
        if (cffAB(ipxyz) /= Zero) then
          ab1(:,ipab1) = a1b(:,ipa1b)+cffAB(ipxyz)*ab(:,ipab)
        else
          ab1(:,ipab1) = a1b(:,ipa1b)
        end if
      end do
    end do
  end do
end do

#ifdef _DEBUGPRINT_
write(Label,'(A,i1,A,i1,A)') ' Target: (',na,',',nb1,'|'
call RecPrt(Label,' ',ab1,nPrim,nab1)
#endif

return

end subroutine HRR1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2007, Roland Lindh                                *
************************************************************************
      SubRoutine PGet1_RI3(PAO,ijkl,nPAO,iCmp,
     &                 iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,kOp,
     &                 DSO,DSSO,DSO_Var,nDSO,ExFac,CoulFac,PMax,V_K,
     &                 U_K,mV_k,ZpK,nnP1,nSA,nAct)
************************************************************************
*  Object: to assemble the 2nd order density matrix of a SCF wave      *
*          function from the 1st order density.                        *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*                                                                      *
*             Modified for 3-center RI gradients, March 2007           *
************************************************************************
      use Basis_Info, only: nBas
      use SOAO_Info, only: iAOtSO
      use pso_stuff, only: lPSO, lsa, ipAorb, Thpkl
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "chomp2g_alaska.fh"
#include "exterm.fh"
#include "WrkSpc.fh"
      Real*8 PAO(ijkl,nPAO), DSO(nDSO,nSA), DSSO(nDSO), V_k(mV_k,nSA),
     &       U_k(mV_k), DSO_Var(nDSO),ZpK(nnP1,mV_K,*)
      Integer iAO(4), kOp(4), iAOst(4), iCmp(4)
      Integer nj(4),jSkip(4),jp_Xli2(2),jp_Xki2(2),jp_Xki3(2),
     &        jp_Xli3(2),NumOrb(4),nAct(0:7)
      Logical Shijij,Found
#include "ymnij.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      kYmnij(l,iDen)=iWork(ipYmnij(iDen)-1+l)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 39
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      iPrint=99
      If (iPrint.ge.99) Then
         iComp = 1
         Call PrMtrx('DSO     ',[iD0Lbl],iComp,1,D0)
      End If
      Write (6,*)
      Write (6,*) 'Distribution of Ymnij'
      iSym=1
      If (nYmnij(iSym,1).gt.0) Then
         Write (6,*) 'iSym=',iSym
         Do i = iOff_Ymnij(iSym,1)+1, iOff_Ymnij(iSym,1)+nYmnij(iSym,1)
            Write (6,*) 'kYmnij=',kYmnij(i,1)
         End Do
       End If
       Write (6,*) 'jbas,kbas,lbas=',jBas,kBas,lBas
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     DeSymP will compensate for degeneracy due to permutational
*     symmetry. We will have to compensate for that here!
*
      Call CWTime(Cpu1,Wall1)
*
      nBas0 = nBas(0)
      iOff1 = nBas(0)
      Fac = One / Four
      PMax=Zero
      iPAO = 0
*
      jSym = 1
      kSym = 1
      lSym = iEor(jSym-1,kSym-1)+1
      NumOrb(1) = nChOrb(kSym-1,1)
*
      Call Qpg_iScalar('SCF mode',Found)
      If (Found) Then
         Call Get_iScalar('SCF mode',iUHF) ! either 0 or 1
      Else
         iUHF=0
      EndIf
*
*     Test if we have any exchange contribution of significance
*
*
      ExFac_=ExFac
      If (ExFac.ne.0) Then
*
*        Pick up the number of MOs which passed the threshold test.
*
         nj2=0
         Do iSO=1,nKdens
           jSkip(iSO)=0
           nj(iSO)=nYmnij(jSym,iSO)
           NumOrb(iSO) = nChOrb(kSym-1,iSO)
*
*        If all included skip presceening.
*
!          trick for skipping unnecessary overhead
           If (-nj(iSO).eq.NumOrb(iSO)) Then
              jSkip(iSO)=1
              nj(iSO)=NumOrb(iSO)
           EndIf
*
*        If all excluded process only for Coulombic contributions.
*
           nj2=nj2+nj(iSO)
         End Do
         If ((nj2.eq.0).and.(.not.lPSO))  ExFac=Zero
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (ExFac.ne.Zero .and. NumOrb(1).gt.0 .and. iMP2prpt.ne.2
     &    .and. .not. lPSO  .and. iUHF.eq.0 ) Then
*                                                                      *
************************************************************************
*                                                                      *
*        HF and Hybrid DFT
*
*        number of functions in the kS and lS shell
*
         nKBas = kBas*iCmp(3)
         nLBas = lBas*iCmp(4)
*
         kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
         index2k= NumOrb(1)*(kSO-1)
         lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)
         index2l= NumOrb(1)*(lSO-1)
*
*        Pointers to the full list of the X_mu,i elements.
*
         jp_Xki=ip_CMOi(1)+index2k
         jp_Xli=ip_CMOi(1)+index2l
*
*        Collect the X_mu,i which survived the prescreening.
*        Replace the pointers above, i.e. jp_Xki, jp_Xli.
*
         If (nj(1).le.NumOrb(1) .and. jSkip(1).eq.0) Then
*
*           Note that the X_mu,i are stored as X_i,mu!
*
            jp_Xki=ip_CMOi(1)+index2k-1
            jp_Xli=ip_CMOi(1)+index2l-1
*
            imo=0
            Do k=1,nj(1)
               kmo=kYmnij(k,1) ! CD-MO index
*
*              Pick up X_mu,i for all mu's that belong to shell k
*
               jCMOk=jp_Xki+kmo
               jr=jr_Xki(1)+imo
               call dcopy_(nKBas,Work(jCMOk),NumOrb(1),Work(jr),nj(1))
*
*              Pick up X_mu,i for all mu's that belong to shell l
*
               jCMOl=jp_Xli+kmo
               jr=jr_Xli(1)+imo
               call dcopy_(nLBas,Work(jCMOl),NumOrb(1),Work(jr),nj(1))
*
               imo=imo+1
            End Do
*           Reset pointers!
            jp_Xki=jr_Xki(1)
            jp_Xli=jr_Xli(1)
         ElseIf (nj(1).gt.NumOrb(1)) Then
            Call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
            Call Abend()
         EndIf

         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
            jSO_off = jSO - iOff1
*
*           Read a block of C_kl^J
*
            lCVec = nIJR(kSym,lSym,1)*jBas ! Block size
            iAdr = nIJR(kSym,lSym,1)*(jSO_off-1) + iAdrCVec(jSym,kSym,1)
            Call dDaFile(LuCVector(jSym,1),2,Work(ip_CijK),lCVec,iAdr)
*
*           Extract only those C_kl^Js for which we deem k and l to
*           belong to the shell-pair and to be of significance.
*
            If (nj(1).le.NumOrb(1) .and. jSkip(1).eq.0) Then
               ij=0
               Do j=1,nj(1)
                 jmo=kYmnij(j,1)
                 Do i=1,nj(1)
                   imo=kYmnij(i,1)
                   jC=ip_CijK-1+NumOrb(1)*(jmo-1)+imo
                   jr=ip_CilK+ij
                   call dcopy_(jBas,Work(jC),NumOrb(1)**2,Work(jr),
     &                        nj(1)**2)
                   ij=ij+1
                 End Do
               End Do
              Call dCopy_(nj(1)**2*jBas,Work(ip_CilK),1,Work(ip_CijK),1)
            End If
*
*           Transform according to Eq. 16 (step 4) and generate B_kl^J
*
*** ----    E(jK,m) = Sum_i C(i,jK)' * X(i,m)
*
            Call dGEMM_('T','N',nj(1)*jBas,nKBas,nj(1),
     &                   1.0d0,Work(ip_CijK),nj(1),
     &                         Work(jp_Xki),nj(1),
     &                   0.0d0,Work(ip_CilK),nj(1)*jBas)
*
*** ----    B(Km,n) = Sum_j E(j,Km)' * X(j,n)
*
            Call dGEMM_('T','N',jBas*nKBas,nLBas,nj(1),
     &                   1.0d0,Work(ip_CilK),nj(1),
     &                         Work(jp_Xli),nj(1),
     &                   0.0d0,Work(ip_BklK),jBas*nKBas)
*
            Do i3 = 1, iCmp(3)
               kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i4 = 1, iCmp(4)
                  lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
                  iPAO = iPAO + 1
                  nijkl = 0
*
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl
                     LTh=lAOl + (i4-1)*lBas
                     Do kAOk = 0, kBas-1
                        kSOk = kSO + kAOk
                        Kth=kAOk+(i3-1)*kBas
*
                        indexB = ip_BklK + (kAOk + (i3-1)*kBas)*jBas
     &                         + (lAOl + (i4-1)*lBas)*nKBas*jBas - 1
                        Indk=Max(kSOk,lSOl)
                        Indl=kSOk+lSOl-Indk
                        Indkl=(Indk-1)*Indk/2+Indl
*
                        Do jAOj = 0, jBas-1
                           jSOj = jSO + jAOj - iOff1
                           nijkl = nijkl + 1
                           indexB = indexB + 1
*
*-----------------------Coulomb contribution: V_k(j)*D(kl)
*
                           temp=CoulFac*V_k(jSOj,1)*DSO(Indkl,1)
*
*-----------------------Exchange contribution: B(K,m,n)
*
                           temp = temp - ExFac*Half*Work(indexB)
*
                           PMax=Max(PMax,Abs(temp))
                           PAO(nijkl,iPAO) =  Fac * temp
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      Else If (ExFac.ne.Zero .and. NumOrb(1).gt.0 .and. iMP2prpt.ne.2
     &    .and. .not. lPSO  .and. iUHF.eq.1 ) Then
*                                                                      *
************************************************************************
*                                                                      *
*        UHF and Hybrid UDFT
*
*        number of functions in the kS and lS shell
*
         nKBas = kBas*iCmp(3)
         nLBas = lBas*iCmp(4)
*
         kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
         lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)
*
*        Pointers to the full list of the X_mu,i elements.
*
         Do iSO=1,2
           If (nIJR(kSym,lSym,iSO).ne.0) Then

              index2k= NumOrb(iSO)*(kSO-1)
              index2l= NumOrb(iSO)*(lSO-1)
*
             jp_Xki2(iSO)=ip_CMOi(iSO)+index2k
             jp_Xli2(iSO)=ip_CMOi(iSO)+index2l
*
*        Collect the X_mu,i which survived the prescreening.
*        Replace the pointers above, i.e. jp_Xki, jp_Xli.
*
             If (nj(iSO).le.NumOrb(iSO) .and. jSkip(iSO).eq.0) Then
*
*           Note that the X_mu,i are stored as X_i,mu!
*
               jp_Xki2(iSO)=ip_CMOi(iSO)+index2k-1
               jp_Xli2(iSO)=ip_CMOi(iSO)+index2l-1
*
               imo=0
               Do k=1,nj(iSO)
                 kmo=kYmnij(k,iSO) ! CD-MO index
*
*              Pick up X_mu,i for all mu's that belong to shell k
*
                 jCMOk=jp_Xki2(iSO)+kmo
                 jr=jr_Xki(iSO)+imo
                 call dcopy_(nKBas,Work(jCMOk),NumOrb(iSO),
     &                      Work(jr),nj(iSO))
*
*              Pick up X_mu,i for all mu's that belong to shell l
*
                 jCMOl=jp_Xli2(iSO)+kmo
                 jr=jr_Xli(iSO)+imo
                 call dcopy_(nLBas,Work(jCMOl),NumOrb(iSO),
     &                      Work(jr),nj(iSO))
*
                 imo=imo+1
               End Do
*           Reset pointers!
               jp_Xki2(iSO)=jr_Xki(iSO)
               jp_Xli2(iSO)=jr_Xli(iSO)
             ElseIf (nj(iSO).gt.NumOrb(iSO)) Then
               Call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
               Call Abend()
             EndIf
           EndIf
         End Do

         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
            jSO_off = jSO - iOff1
*
            Factor=0.0d0
*
            Do iSO=1,2
               If ((nIJR(kSym,lSym,iSO).ne.0).and.(nj(iSO).ne.0)) Then
*
*           Read a block of C_kl^J
*
                 lCVec = nIJR(kSym,lSym,iSO)*jBas ! Block size
                 iAdr = nIJR(kSym,lSym,iSO)*(jSO_off-1) +
     &                  iAdrCVec(jSym,kSym,iSO)
                 Call dDaFile(LuCVector(jSym,iSO),2,Work(ip_CijK),
     &                        lCVec,iAdr)
*
*           Extract only those C_kl^Js for which we deem k and l to
*           belong to the shell-pair and to be of significance.
*
                 If (nj(iSO).le.NumOrb(iSO) .and. jSkip(iSO).eq.0) Then
                    ij=0
                    Do j=1,nj(iSO)
                      jmo=kYmnij(j,iSO)
                      Do i=1,nj(iSO)
                        imo=kYmnij(i,iSO)
                        jC=ip_CijK-1+NumOrb(iSO)*(jmo-1)+imo
                        jr=ip_CilK+ij
                        call dcopy_(jBas,Work(jC),NumOrb(iSO)**2,
     &                        Work(jr),nj(iSO)**2)
                        ij=ij+1
                      End Do
                    End Do
                    Call dCopy_(nj(iSO)**2*jBas,Work(ip_CilK),1,
     &                         Work(ip_CijK),1)
                 End If
*
*           Transform according to Eq. 16 (step 4) and generate B_kl^J
*
*** ----    E(jK,m) = Sum_i C(i,jK)' * X(i,m)
*
                 Call dGEMM_('T','N',nj(iSO)*jBas,nKBas,nj(iSO),
     &                        1.0d0,Work(ip_CijK),nj(iSO),
     &                              Work(jp_Xki2(iSO)),nj(iSO),
     &                        0.0d0,Work(ip_CilK),nj(iSO)*jBas)
*
*** ----    B(Km,n) = Sum_j E(j,Km)' * X(j,n)
*
                 Call dGEMM_('T','N',jBas*nKBas,nLBas,nj(iSO),
     &                        1.0d0,Work(ip_CilK),nj(iSO),
     &                              Work(jp_Xli2(iSO)),nj(iSO),
     &                        Factor,Work(ip_BklK),jBas*nKBas)
                 Factor=1.0d0
              EndIf
            End Do
*
            Do i3 = 1, iCmp(3)
               kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i4 = 1, iCmp(4)
                  lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
                  iPAO = iPAO + 1
                  nijkl = 0
*
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl
                     LTh=lAOl + (i4-1)*lBas
                     Do kAOk = 0, kBas-1
                        kSOk = kSO + kAOk
                        Kth=kAOk+(i3-1)*kBas
*
                        indexB = ip_BklK + (kAOk + (i3-1)*kBas)*jBas
     &                         + (lAOl + (i4-1)*lBas)*nKBas*jBas - 1
                        Indk=Max(kSOk,lSOl)
                        Indl=kSOk+lSOl-Indk
                        Indkl=(Indk-1)*Indk/2+Indl
*
                        Do jAOj = 0, jBas-1
                           jSOj = jSO + jAOj - iOff1
                           nijkl = nijkl + 1
                           indexB = indexB + 1
*
*-----------------------Coulomb contribution: V_k(j)*D(kl)
*
                           temp=CoulFac*V_k(jSOj,1)*DSO(Indkl,1)
*
*-----------------------Exchange contribution: B(K,m,n)
*
                           temp = temp - ExFac*Work(indexB)
*
                           PMax=Max(PMax,Abs(temp))
                           PAO(nijkl,iPAO) =  Fac * temp
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      Else If (ExFac.ne.Zero .and. NumOrb(1).gt.0 .and. iMP2prpt.ne.2
     &    .and. lPSO .and. .not. LSA ) Then
*                                                                      *
************************************************************************
*                                                                      *
*        CASSCF case
*
*        number of functions in the kS and lS shell
*
         nKBas = kBas*iCmp(3)
         nLBas = lBas*iCmp(4)
*
         kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
         index2k= NumOrb(1)*(kSO-1)
         lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)
         index2l= NumOrb(1)*(lSO-1)
*
*        Pointers to the full list of the X_mu,i elements.
*
         jp_Xki=ip_CMOi(1)+index2k
         jp_Xli=ip_CMOi(1)+index2l
*
*        Collect the X_mu,i which survived the prescreening.
*        Replace the pointers above, i.e. jp_Xki, jp_Xli.
*
         If (nj(1).le.NumOrb(1) .and. jSkip(1).eq.0.and.nj(1).ne.0) Then
*
*           Note that the X_mu,i are stored as X_i,mu!
*
            jp_Xki=ip_CMOi(1)+index2k-1
            jp_Xli=ip_CMOi(1)+index2l-1
*
            imo=0
            Do k=1,nj(1)
               kmo=kYmnij(k,1) ! CD-MO index
*
*              Pick up X_mu,i for all mu's that belong to shell k
*
               jCMOk=jp_Xki+kmo
               jr=jr_Xki(1)+imo
               call dcopy_(nKBas,Work(jCMOk),NumOrb(1),Work(jr),nj(1))
*
*              Pick up X_mu,i for all mu's that belong to shell l
*
               jCMOl=jp_Xli+kmo
               jr=jr_Xli(1)+imo
               call dcopy_(nLBas,Work(jCMOl),NumOrb(1),Work(jr),nj(1))
*
               imo=imo+1
            End Do
*           Reset pointers!
            jp_Xki=jr_Xki(1)
            jp_Xli=jr_Xli(1)
         ElseIf (nj(1).gt.NumOrb(1)) Then
            Call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
            Call Abend()
         EndIf

         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
            jSO_off = jSO - iOff1
*
*           Read a block of C_kl^J
*
            lCVec = nIJR(kSym,lSym,1)*jBas ! Block size
            iAdr = nIJR(kSym,lSym,1)*(jSO_off-1) + iAdrCVec(jSym,kSym,1)
            Call dDaFile(LuCVector(jSym,1),2,Work(ip_CijK),lCVec,iAdr)
*
*           Extract only those C_kl^Js for which we deem k and l to
*           belong to the shell-pair and to be of significance.
*
            If (nj(1).ne.0) Then
              If (nj(1).le.NumOrb(1) .and. jSkip(1).eq.0) Then
                 ij=0
                 Do j=1,nj(1)
                   jmo=kYmnij(j,1)
                   Do i=1,nj(1)
                     imo=kYmnij(i,1)
                     jC=ip_CijK-1+NumOrb(1)*(jmo-1)+imo
                     jr=ip_CilK+ij
                     call dcopy_(jBas,Work(jC),NumOrb(1)**2,Work(jr),
     &                          nj(1)**2)
                     ij=ij+1
                   End Do
                 End Do
                 Call dCopy_(nj(1)**2*jBas,Work(ip_CilK),1,
     &                                    Work(ip_CijK),1)
              End If
*
*             Transform according to Eq. 16 (step 4) and generate B_kl^J
*
*** ----      E(jK,m) = Sum_i C(i,jK)' * X(i,m)
*
              Call dGEMM_('T','N',nj(1)*jBas,nKBas,nj(1),
     &                     1.0d0,Work(ip_CijK),nj(1),
     &                           Work(jp_Xki),nj(1),
     &                     0.0d0,Work(ip_CilK),nj(1)*jBas)
*
*** ----      B(Km,n) = Sum_j E(j,Km)' * X(j,n)
*
              Call dGEMM_('T','N',jBas*nKBas,nLBas,nj(1),
     &                     1.0d0,Work(ip_CilK),nj(1),
     &                           Work(jp_Xli),nj(1),
     &                     0.0d0,Work(ip_BklK),jBas*nKBas)
*
            Else
               Call Dzero(Work(ip_BklK),jBas*nKBas*nLBas)
            EndIf
*
**          Active term
*
            Do jAOj=0,jBas-1
              jSOj = jSO_off + jAOj
              Do i4 = 1, iCmp(4)
                lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
                Do lAOl = 0, lBas-1
                  lSOl = lSO + lAOl-1
                  lp=ipAOrb(0,1)+lSOl*nAct(lSym-1)
                  Do kAct=1,nAct(kSym-1)
                    tmp=ddot_(kact,Zpk(kAct*(kAct-1)/2+1,jSOj,1),1,
     &                       Work(lp),1)
*
*
                    Do lAct=kAct+1,nAct(lSym-1)
                      tmp=tmp+Zpk(lAct*(lAct-1)/2+kAct,jSOj,1)*
     &                        Work(lp+lAct-1)
                    End Do
                    Work(ip_Cilk+kAct-1)=tmp
                  End Do
*
                  Do i3 = 1, iCmp(3)
                    kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
                    kp=ipAOrb(0,1)+(kSO-1)*nAct(kSym-1)
                    iThpkl= jAOj+ (i3-1)*kBas*jBas
     &                         + (lAOl + (i4-1)*lBas)*nKBas*jBas+1
                    Call dGeMV_('T',nAct(kSym-1),kBas,1.0d0,
     &                         Work(kp),
     &                         nAct(kSym-1),Work(ip_Cilk),1,0.0d0,
     &                         Thpkl(iThpkl),jBas)
                  End Do
                End Do
              End Do
            End Do
*
            Do i3 = 1, iCmp(3)
               kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i4 = 1, iCmp(4)
                  lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
                  iPAO = iPAO + 1
                  nijkl = 0
*
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl
                     LTh=lAOl + (i4-1)*lBas
                     Do kAOk = 0, kBas-1
                        kSOk = kSO + kAOk
                        Kth=kAOk+(i3-1)*kBas
*
                        iThpkl=(kAOk + (i3-1)*kBas)*jBas
     &                         + (lAOl + (i4-1)*lBas)*nKBas*jBas
                        indexB=ip_BklK +iThpkl - 1
                        Indk=Max(kSOk,lSOl)
                        Indl=kSOk+lSOl-Indk
                        Indkl=(Indk-1)*Indk/2+Indl
*
                        Do jAOj = 0, jBas-1
                           jSOj = jSO + jAOj - iOff1
                           nijkl = nijkl + 1
                           indexB = indexB + 1
                           iThpkl = iThpkl + 1
*
*-----------------------Coulomb contribution: V_k(j)*D(kl)
*
                           temp=CoulFac*V_k(jSOj,1)*DSO(Indkl,1)
*
*-----------------------Exchange contribution: B(K,m,n)
*
                           temp = temp - ExFac*Half*Work(indexB)
*
*-----------------------Active space contribution: Sum_p Z(p,K)*Th(p,m,n)
*
                           temp=temp+Thpkl(iThpkl)
*
                           PMax=Max(PMax,Abs(temp))
                           PAO(nijkl,iPAO) =  Fac * temp
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      Else If (ExFac.ne.Zero .and. iMP2prpt.ne.2
     &   .and. lPSO .and. lSA ) Then
*                                                                      *
************************************************************************
*                                                                      *
*        SA-CASSCF case
*
*        number of functions in the kS and lS shell
*
         nKBas = kBas*iCmp(3)
         nLBas = lBas*iCmp(4)
*
         kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
         lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)
*
*        Pointers to the full list of the X_mu,i elements.
*
         Do iSO=1,2
           If (nIJR(kSym,lSym,iSO).ne.0) Then
             iMOleft=iSO
             iMOright=iSO+2
*
             index2k= NumOrb(iMOright)*(kSO-1)
             index2l= NumOrb(iMOleft)*(lSO-1)
             index3l= NumOrb(iMOright)*(lSO-1)
             index3k= NumOrb(iMOleft)*(kSO-1)
*
             jp_Xki2(iSO)=ip_CMOi(iMOright)+index2k
             jp_Xli2(iSO)=ip_CMOi(iMOleft)+index2l
             jp_Xli3(iSO)=ip_CMOi(iMOright)+index2l
             jp_Xki3(iSO)=ip_CMOi(iMOleft)+index2k
*
*            Collect the X_mu,i which survived the prescreening.
*            Replace the pointers above, i.e. jp_Xki, jp_Xli.
*
             If ((nj(iMOright).le.NumOrb(iMOright))
     &           .and.(jSkip(iMOright).eq.0)) Then

*               Note that the X_mu,i are stored as X_i,mu!
*
                jp_Xki2(iSO)=ip_CMOi(iMOright)+index2k-1
                jp_Xli3(iSO)=ip_CMOi(iMOright)+index3l-1
*
                imo=0
                Do k=1,nj(iMOright)
                   kmo=kYmnij(k,iMOright) ! CD-MO index
*
*                  Pick up X_mu,i for all mu's that belong to shell k
*
                   jCMOk=jp_Xki2(iSO)+kmo
                   jr=jr_Xki(iMOright)+imo
                   call dcopy_(nKBas,Work(jCMOk),NumOrb(iMOright),
     &                 Work(jr),nj(iMOright))

                   jCMOl=jp_Xli3(iSO)+kmo
                   jr=jr_Xli(iMOright)+imo
                   call dcopy_(nLBas,Work(jCMOl),NumOrb(iMOright),
     &                   Work(jr),nj(iMOright))
*
                   imo=imo+1
                End Do
*               Reset pointers!
                jp_Xki2(iSO)=jr_Xki(iMOright)
                jp_Xli3(iSO)=jr_Xli(iMOright)
             ElseIf (nj(iMOright).gt.NumOrb(iMOright)) Then
                Call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
                Call Abend()
             End If
*
             If ((nj(iMOleft).le.NumOrb(iMOleft))
     &            .and.(jSkip(iMOleft).eq.0)) Then
*
                jp_Xli2(iSO)=ip_CMOi(iMOleft)+index2l-1
                jp_Xki3(iSO)=ip_CMOi(iMOleft)+index3k-1
*
                imo=0
                Do k=1,nj(iMOleft)
                   kmo=kYmnij(k,iMOleft) ! CD-MO index
*
*                  Pick up X_mu,i for all mu's that belong to shell l
*
                   jCMOl=jp_Xli2(iSO)+kmo
                   jr=jr_Xli(iMOleft)+imo
                   call dcopy_(nLBas,Work(jCMOl),NumOrb(iMOleft),
     &                   Work(jr),nj(iMOleft))
*
                   jCMOk=jp_Xki3(iSO)+kmo
                   jr=jr_Xki(iMOleft)+imo
                   call dcopy_(nKBas,Work(jCMOk),NumOrb(iMOleft),
     &                 Work(jr),nj(iMOleft))
                   imo=imo+1
                End Do
                jp_Xli2(iSO)=jr_Xli(iMOleft)
                jp_Xki3(iSO)=jr_Xki(iMOleft)

             ElseIf (nj(iMOleft).gt.NumOrb(iMOleft)) Then
                Call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
                Call Abend()
             EndIf
           EndIf
         End Do

         Do i2 = 1, iCmp(2)
*
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
            jSO_off = jSO - iOff1
*
            Factor=0.0d0
*
            Do iSO=1,2
              iMOleft=iSO
              iMOright=iSO+2
              If ((nIJR(kSym,lSym,iSO).ne.0).and.(nj(iMOright).ne.0)
     &           .and.(nj(iMOleft).ne.0))  Then
*
*           Read a block of C_kl^J
*
                lCVec = nIJR(kSym,lSym,iSO)*jBas ! Block size
                iAdr = nIJR(kSym,lSym,iSO)*(jSO_off-1) +
     &                 iAdrCVec(jSym,kSym,iSO)
                Call dDaFile(LuCVector(jSym,iSO),2,Work(ip_CijK),
     &               lCVec,iAdr)
*
*           Extract only those C_kl^Js for which we deem k and l to
*           belong to the shell-pair and to be of significance.
*
*MGD skipped jSkip() since not used and complicated in this case
                 If (nj(iMOright).le.NumOrb(iMOright).or.
     &               nj(iMOleft ).le.NumOrb(iMOleft )) Then
                   ij=0
                   Do j=1,nj(iMOleft)
                     jmo=kYmnij(j,iMOleft)
                     Do i=1,nj(iMOright)
                       imo=kYmnij(i,iMOright)
                       jC=ip_CijK-1+NumOrb(iMOright)*(jmo-1)+imo
                       jr=ip_CilK+ij
                       call dcopy_(jBas,Work(jC),NumOrb(iMOright)*
     &                             NumOrb(iMOleft),Work(jr),
     &                             nj(iMOright)*nj(iMOleft))
                       ij=ij+1
                     End Do
                   End Do
                   Call dCopy_(nj(iMOright)*nj(iMOleft)*jBas,
     &                       Work(ip_CilK),1,Work(ip_CijK),1)
                 End If
*
*           Transform according to Eq. 16 (step 4) and generate B_kl^J
*
*** ----    E(jK,m) = Sum_i C(i,jK)' * X(i,m)
*
                Call dGEMM_('T','N',nj(iMOleft)*jBas,nKBas,nj(iMOright),
     &                     1.0d0,Work(ip_CijK),nj(iMOright),
     &                           Work(jp_Xki2(iSO)),nj(iMOright),
     &                     0.0d0,Work(ip_CilK),nj(iMOleft)*jBas)
*
*** ----    B(Km,n) = Sum_j E(j,Km)' * X(j,n)
*
                Call dGEMM_('T','N',jBas*nKBas,nLBas,nj(iMOleft),
     &                     1.0d0,Work(ip_CilK),nj(iMOleft),
     &                           Work(jp_Xli2(iSO)),nj(iMOleft),
     &                     Factor,Work(ip_BklK),jBas*nKBas)
                Factor=1.0d0
*
** Add transpose
*
*Transpose Cijk->Cjik
                Do ijBas=0,jBas-1
                  ijbas_off=ip_CijK+ijBas*nj(iMOleft)*nj(iMOright)
                  ijbas_off2=ip_CilK+ijBas*nj(iMOleft)*nj(iMOright)
                  Do ileft=0,nj(iMOleft)-1
                    ileft_off=ileft*nj(iMOright)+ijbas_off
                    Do iright=0,nj(iMOright)-1
                      iright_off=ileft_off+iright
                      iright_off2=ijbas_off2+iright*nj(iMOleft)+ileft
*
                      Work(iright_off2)=Work(iright_off)
                    End Do
                  End Do
                End Do
*
*** ----    E(iK,m) = Sum_j C(j,iK)' * X(j,m)
*
                Call dGEMM_('T','N',nj(iMOright)*jBas,nKBas,nj(iMOleft),
     &                     1.0d0,Work(ip_CilK),nj(iMOleft),
     &                           Work(jp_Xki3(iSO)),nj(iMOleft),
     &                     0.0d0,Work(ip_CijK),nj(iMOright)*jBas)
*
*** ----    B(Km,n) = Sum_j E(i,Km)' * X(i,n)
*
                Call dGEMM_('T','N',jBas*nKBas,nLBas,nj(iMOright),
     &                     1.0d0,Work(ip_CijK),nj(iMOright),
     &                           Work(jp_Xli3(iSO)),nj(iMOright),
     &                     Factor,Work(ip_BklK),jBas*nKBas)
              EndIf
            End Do
*
**          Active term
*
            Call dzero(Thpkl,jBas*nKBas*nLBas)
            Do iVec=1,4
              iMO1=1
              iMO2=1
              iVec_=iVec
              fact=1.0d0
              If (iVec.eq.2) iMO2=2
              If (iVec.eq.3) fact=2.0d0
              If (iVec.eq.4) Then
                iMO1=2
                iVec_=2
              EndIf

              Do jAOj=0,jBas-1
                jSOj = jSO_off + jAOj
                Do i4 = 1, iCmp(4)
                  lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
                  Do lAOl = 0, lBas-1
                    lSOl = lSO + lAOl-1
                    lp=ipAOrb(0,iMO1)+lSOl*nAct(lSym-1)
                    Do kAct=1,nAct(kSym-1)
                     tmp=ddot_(kact,Zpk(kAct*(kAct-1)/2+1,jSOj,iVec_),1,
     &                         Work(lp),1)
                      Do lAct=kAct+1,nAct(lSym-1)
                        tmp=tmp+Zpk(lAct*(lAct-1)/2+kAct,jSOj,iVec_)*
     &                    Work(lp+lAct-1)
                      End Do
                      Work(ip_Cilk+kAct-1)=tmp
                    End Do
*
                    Do i3 = 1, iCmp(3)
                      kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
                      kp=ipAOrb(0,iMO2)+(kSO-1)*nAct(kSym-1)
                      iThpkl= jAOj+ (i3-1)*kBas*jBas
     &                           + (lAOl + (i4-1)*lBas)*nKBas*jBas+1
                      Call dGeMV_('T',nAct(kSym-1),kBas,fact,
     &                           Work(kp),
     &                           nAct(kSym-1),Work(ip_Cilk),1,1.0d0,
     &                           Thpkl(iThpkl),jBas)
                    End Do
                  End Do
                End Do
              End Do
            End Do
*
            Do i3 = 1, iCmp(3)
               kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i4 = 1, iCmp(4)
                  lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
                  iPAO = iPAO + 1
                  nijkl = 0
*
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl
                     LTh=lAOl + (i4-1)*lBas
                     Do kAOk = 0, kBas-1
                        kSOk = kSO + kAOk
                        Kth=kAOk+(i3-1)*kBas
*
                        iThpkl=(kAOk + (i3-1)*kBas)*jBas
     &                         + (lAOl + (i4-1)*lBas)*nKBas*jBas
                        indexB=ip_BklK +iThpkl - 1
                        Indk=Max(kSOk,lSOl)
                        Indl=kSOk+lSOl-Indk
                        Indkl=(Indk-1)*Indk/2+Indl
*
                        Do jAOj = 0, jBas-1
                           jSOj = jSO + jAOj - iOff1
                           nijkl = nijkl + 1
                           indexB = indexB + 1
                           iThpkl = iThpkl + 1
*
*-----------------------SA-CASSCF Coulomb contribution
*
                           temp=CoulFac*(V_k(jSOj,1)*DSO(Indkl,2)+
     &                                   V_k(jSOj,2)*DSO(Indkl,1)+
     &                                   V_k(jSOj,3)*DSO(Indkl,4)+
     &                                   V_k(jSOj,4)*DSO(Indkl,3)+
     &                                   V_k(jSOj,1)*DSO(Indkl,5)+
     &                                   V_k(jSOj,5)*DSO(Indkl,1))
*
*-----------------------Exchange contribution: B(K,m,n)
*
*
                           temp = temp - Factor*ExFac*Half*Work(indexB)
*
*-----------------------Active space contribution: Sum_p Z(p,K)*Th(p,m,n)
*
                           temp=temp+Thpkl(iThpkl)
*
                           PMax=Max(PMax,Abs(temp))
                           PAO(nijkl,iPAO) =  Fac * temp
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      Else If (ExFac.ne.Zero.and.NumOrb(1).gt.0.and.iMP2prpt.eq.2) Then
*                                                                      *
************************************************************************
*                                                                      *
*        MP2 case
*
         nKBas = kBas*iCmp(3)
         nLBas = lBas*iCmp(4)

         kSO = iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)
         index2k= NumOrb(1)*(kSO-1)
         lSO = iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)
         index2l= NumOrb(1)*(lSO-1)

         jp_Xki=ip_CMOi(1)+index2k
         jp_Xli=ip_CMOi(1)+index2l

         If (nj(1).le.NumOrb(1) .and. jSkip(1).eq.0) Then
            jp_Xki=ip_CMOi(1)+index2k-1
            jp_Xli=ip_CMOi(1)+index2l-1
            imo=0
            Do k=1,nj(1)
               kmo=kYmnij(k,1)
               jCMOk=jp_Xki+kmo
               jr=jr_Xki(1)+imo
               call dcopy_(nKBas,Work(jCMOk),NumOrb(1),Work(jr),nj(1))
               jCMOl=jp_Xli+kmo
               jr=jr_Xli(1)+imo
               call dcopy_(nLBas,Work(jCMOl),NumOrb(1),Work(jr),nj(1))
               imo=imo+1
            End Do
            jp_Xki=jr_Xki(1)
            jp_Xli=jr_Xli(1)
         ElseIf (nj(1).gt.NumOrb(1)) Then
            Call WarningMessage(2,'Pget1_RI3: nj > NumOrb.')
            Call Abend()
         EndIf

         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
            jSO_off = jSO - iOff1
*
            lCVec = nIJR(kSym,lSym,1)*jBas
            iAdr = nIJR(kSym,lSym,1)*(jSO_off-1) + iAdrCVec(jSym,kSym,1)
            Call dDaFile(LuCVector(jSym,1),2,Work(ip_CijK),lCVec,iAdr)
*
            If (nj(1).le.NumOrb(1) .and. jSkip(1).eq.0) Then
               ij=0
               Do j=1,nj(1)
                 jmo=kYmnij(j,1)
                 Do i=1,nj(1)
                   imo=kYmnij(i,1)
                   jC=ip_CijK-1+NumOrb(1)*(jmo-1)+imo
                   jr=ip_CilK+ij
                   call dcopy_(jBas,Work(jC),NumOrb(1)**2,Work(jr),
     &                        nj(1)**2)
                   ij=ij+1
                 End Do
               End Do
              call dcopy_(nj(1)**2*jBas,Work(ip_CilK),1,Work(ip_CijK),1)
            EndIf
*
*** ---- C(jK,m) = sum_i C(i,jK)' * X(i,m)
*
            Call dGEMM_('T','N',nj(1)*jBas,nKBas,nj(1),
     &                   1.0d0,Work(ip_CijK),nj(1),
     &                         Work(jp_Xki),nj(1),
     &                   0.0d0,Work(ip_CilK),nj(1)*jBas)
*
*** ---- B(Km,n) = sum_j C(j,Km)' * X(j,n)
*
            Call dGEMM_('T','N',jBas*nKBas,nLBas,nj(1),
     &                   1.0d0,Work(ip_CilK),nj(1),
     &                         Work(jp_Xli),nj(1),
     &                   0.0d0,Work(ip_BklK),jBas*nKBas)
*
****
            lBVec = nBas(0)*nBas(0)*jBas
            Do i = 1,2
               iAdr = 1 + nBas(0)*nBas(0)*(jSO_off-1)
               Call dDaFile(LuBVector(i),2,Work(ip_B_mp2(i)),
     &                      lBVec,iAdr)
            End Do
*
            Do i3 = 1, iCmp(3)
               kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i4 = 1, iCmp(4)
                  lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
                  iPAO = iPAO + 1
                  nijkl = 0
*
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl
                     Do kAOk = 0, kBas-1
                        kSOk = kSO + kAOk
*
                        indexB = ip_BklK + (kAOk + (i3-1)*kBas)*jBas
     &                         + (lAOl + (i4-1)*lBas)*nKBas*jBas - 1
                        Indk=Max(kSOk,lSOl)
                        Indl=kSOk+lSOl-Indk
                        Indkl=(Indk-1)*Indk/2+Indl
*
                        Do jAOj = 0, jBas-1
                           jSOj = jSO + jAOj - iOff1
                           nijkl = nijkl + 1
                           indexB = indexB + 1
*
*-----------------------Coulomb contribution: V_k(j)*D(kl)
*
                           temp = CoulFac*(V_k(jSOj,1)*DSO(Indkl,1)
     &                       + U_k(jSOj)*DSO(Indkl,1)
     &                       + V_k(jSOj,1)*(DSO_Var(Indkl)-DSO(indkl,1))
     &                       + Compute_B_4(irc,kSOk,lSOl,jAOj,iOff1,2))
*
*-----------------------Exchange contribution: B(K,m,n)
*
                           temp = temp - ExFac*Half*(Work(indexB)
     &                        + Compute_B_4(irc,kSOk,lSOl,jAOj,iOff1,1))
*                          temp = temp - ExFac*Half*(
*    &                        + Compute_B_4(irc,kSOk,lSOl,jAOj,iOff1,1))

                           PMax=Max(PMax,Abs(temp))
                           PAO(nijkl,iPAO) =  Fac * temp
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
*        Pure DFT or case when no exhange
*
         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
            Do i3 = 1, iCmp(3)
               kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i4 = 1, iCmp(4)
                  lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
                  iPAO = iPAO + 1
                  nijkl = 0
*
                  Do lAOl = 0, lBas-1
                     lSOl = lSO + lAOl
                     Do kAOk = 0, kBas-1
                        kSOk = kSO + kAOk
*
                        Indk=Max(kSOk,lSOl)
                        Indl=kSOk+lSOl-Indk
                        Indkl=(Indk-1)*Indk/2+Indl
*
                        Do jAOj = 0, jBas-1
                           jSOj = jSO + jAOj - iOff1
                           nijkl = nijkl + 1
*
*-----------------------Coulomb contribution: V_k(j)*D(kl)
*
                           temp=CoulFac*V_k(jSOj,1)*DSO(Indkl,1)
*                          temp=0.0D0
*
                           PMax=Max(PMax,Abs(temp))
                           PAO(nijkl,iPAO) =  Fac * temp
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*     Reset ExFac always.
*
      ExFac=ExFac_
*
      If (iPAO.ne.nPAO) Then
         Write (6,*) ' Error in PGet1_RI3!'
         Call Abend
      End If
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' In PGet1_RI3:PAO ',' ',PAO,ijkl,nPAO)
         Do i = 1, ijkl
            Write (6,*) DDot_(nPAO,PAO(i,1),ijkl,
     &                            PAO(i,1),ijkl)
         End Do
      End If
      Call GetMem(' Exit PGet1_RI3','CHECK','REAL',iDum,iDum)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(Cpu2,Wall2)
      Cpu = Cpu2 - Cpu1
      Wall = Wall2 - Wall1
      tbvec(1) = tbvec(1) + Cpu
      tbvec(2) = tbvec(2) + Wall
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Shijij)
         Call Unused_integer(iBas)
         Call Unused_real_array(DSSO)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ddrestart_cvb(c,axc,vec,hp,solp,maxdav,n,nvguess1,nvrestart1)

use casvb_global, only: ifollow, nroot
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: maxdav, n
real(kind=wp), intent(inout) :: c(n,maxdav), axc(n,maxdav)
real(kind=wp), intent(out) :: vec(n)
real(kind=wp), intent(in) :: hp(maxdav,maxdav), solp(maxdav)
integer(kind=iwp), intent(out) :: nvguess1, nvrestart1
integer(kind=iwp) :: ir, ir_use
real(kind=wp), allocatable :: eigval(:), eigvec(:,:)

call mma_allocate(eigval,maxdav,label='eigval')
call mma_allocate(eigvec,maxdav,maxdav,label='eigvec')
eigvec(:,:) = hp(:,:)
call mxdiag_cvb(eigvec,eigval,maxdav)
call mma_deallocate(eigval)

nvrestart1 = 0
nvguess1 = 0
call mxatb_cvb(c,solp,n,maxdav,1,vec)
if (ifollow <= 2) then
  ! (Put lower-lying solutions in AxC :)
  do ir=1,nroot-1
    if (ifollow == 1) then
      ir_use = maxdav-ir+1
    else
      ir_use = ir
    end if
    call mxatb_cvb(c,eigvec(:,ir_use),n,maxdav,1,axc(:,ir+1))
  end do
  c(:,2:nroot) = axc(:,2:nroot)
end if
c(:,1) = vec(:)
call mma_deallocate(eigvec)

return

end subroutine ddrestart_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKTDAO(CMO,TDMO,TDAO,SCR)

use mrci_global, only: ICH, NBAS, NBAST, NBMAX, NCMO, NDEL, NDMO, NFMO, NFRO, NORB, NORBT, NSYM
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CMO(NCMO)
real(kind=wp), intent(out) :: TDMO(NBAST,NBAST), TDAO(NBAST,NBAST), SCR(NBMAX,NBMAX)
integer(kind=iwp) :: I, IEB, IECMO, IEO, II, ISB, ISCMO, ISCO, ISO, ISYM, J, JJ, NB, NBCO, NBD, NBF, NCO, ND, NF, NO

! REORDER TDMO (USE TDAO AS TEMPORARY STORAGE):
TDAO(:,:) = Zero
do I=1,NORBT
  II = ICH(I)
  if (II > 0) then
    do J=1,NORBT
      JJ = ICH(J)
      if (JJ > 0) TDAO(I,J) = TDMO(II,JJ)
    end do
  end if
end do
TDMO(:,:) = TDAO(:,:)
IECMO = 0
IEO = 0
IEB = 0
do ISYM=1,NSYM
  ISO = IEO+1
  ISB = IEB+1
  NO = NORB(ISYM)
  NB = NBAS(ISYM)
  IEO = IEO+NO
  IEB = IEB+NB
  ! ORBITALS PRE-FROZEN IN MOTRA, OR FROZEN IN MRCI:
  NF = NFMO(ISYM)+NFRO(ISYM)
  NBF = NB*NF
  ISCMO = IECMO+1
  IECMO = IECMO+NBF
  ! ORBITALS EXPLICITLY USED IN CI:
  NCO = NO-NFRO(ISYM)-NDEL(ISYM)
  ISCO = ISO+NFRO(ISYM)
  NBCO = NB*NCO
  ISCMO = IECMO+1
  IECMO = IECMO+NBCO
  if (NCO > 0) then
    call DGEMM_('N','N',NB,NCO,NCO,One,CMO(ISCMO),NB,TDMO(ISCO,ISCO),NBAST,Zero,SCR,NB)
    call DGEMM_('N','T',NB,NB,NCO,One,SCR,NB,CMO(ISCMO),NB,One,TDAO(ISB,ISB),NBAST)
  end if
  ! ORBITALS PRE-DELETED IN MOTRA OR DELETED IN MRCI:
  ND = NDMO(ISYM)+NDEL(ISYM)
  NBD = NB*ND
  ISCMO = IECMO+1
  IECMO = IECMO+NBD
end do

return

end subroutine MKTDAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1995, Roland Lindh                                *
*               Markus P. Fuelscher                                    *
************************************************************************
      SubRoutine Drvh1(Grad,Temp,nGrad)
************************************************************************
*                                                                      *
* Object: driver for computation of gradient with respect to the one-  *
*         electron hamiltonian and the overlap matrix. The former will *
*         be contracted with the "variational" first order density     *
*         matrix and the latter will be contracted with the generalized*
*         Fock matrix.                                                 *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
*                                                                      *
* modified by M.P. Fuelscher                                           *
* make use of the RELAX file                                           *
*                                                                      *
*             Modified to Sperical Well, External Field, and SRO       *
*             gradients, April '95. R. Lindh                           *
*             Modified to Self Consistent Reaction Fields, May '95     *
************************************************************************
      use PCM_arrays, only: PCM_SQ
      use External_Centers
      use Basis_Info, only: nCnttp, dbsc, nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External OvrGrd, KneGrd, NAGrd, PrjGrd, M1Grd, M2Grd, SROGrd,
     &         WelGrd, XFdGrd, RFGrd, PCMGrd, PPGrd, COSGrd, FragPGrd
      External OvrMmG, KneMmG, NAMmG, PrjMmG, M1MmG, M2MmG, SROMmG,
     &         WelMmg, XFdMmg, RFMmg, PCMMmg, PPMmG, FragPMmG
#include "Molcas.fh"
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "disp.fh"
#include "wldata.fh"
#include "rctfld.fh"
      Character Method*8, Label*80
      Real*8 Grad(nGrad), Temp(nGrad)
      parameter (lforce=20)
      real*8 force(lforce)
      common /finfld/force
      character*30 fldname
      External MltGrd,MltMmG
      Real*8, Allocatable:: Coor(:,:), Fock(:), D_Var(:)
      Integer, Allocatable:: lOper(:), lOperf(:)
CAOM>
      Logical DiffOp, lECP, lPP, lFAIEMP
*
*-----Statement function
*
      nElem(i) = (i+1)*(i+2)/2
*
*...  Prologue
      iRout = 131
      iPrint = nPrint(iRout)
      Call CWTime(TCpu1,TWall1)
      Call StatusLine(' Alaska:',' Computing 1-electron gradients')
*
*---- Allocate memory for density and Fock matrices
*
      nFock = 0
      nDens = 0
      Do iIrrep = 0, nIrrep - 1
         nFock = nFock + nBas(iIrrep)*(nBas(iIrrep)+1)/2
         nDens = nDens + nBas(iIrrep)*(nBas(iIrrep)+1)/2
      End Do
      lECP=.False.
      lPP =.False.
      lFAIEMP =.False.
      Do i = 1, nCnttp
         lECP = lECP .or. dbsc(i)%ECP
         lPP  = lPP  .or. dbsc(i)%nPP.ne.0
         lFAIEMP = LFAIEMP .or. dbsc(i)%Frag
      End Do
*
*
*...  Get the method label
*     print *,' Read Method label'
      Call Get_cArray('Relax Method',Method,8)
*
*...  Read the variational 1st order density matrix
*...  density matrix in AO/SO basis
*     print *,' Read density matrix'

      Call mma_allocate(D_Var,nDens,Label='D_Var')
      Call Get_D1ao_Var(D_Var,nDens)
      If (iPrint.ge.99) then
         Write(6,*) 'variational 1st order density matrix'
         ii=1
         Do iIrrep = 0, nIrrep - 1
            Write(Label,*) 'symmetry block',iIrrep
            Call TriPrt(Label,' ',D_Var(ii),nBas(iIrrep))
            ii = ii + nBas(iIrrep)*(nBas(iIrrep)+1)/2
         End Do
      End If
*
*...  Read the generalized Fock matrix
*...  Fock matrix in AO/SO basis
*     print *,' Read Fock matrix'
      If (.Not.HF_Force) Then
         Call mma_allocate(Fock,nDens,Label='Fock')
         Call Get_Fock_Occ(Fock,nDens)
         If (iPrint.ge.99) then
            Write(6,*) 'generalized Fock matrix'
            ii=1
            Do iIrrep = 0, nIrrep - 1
               Write(Label,*) 'symmetry block',iIrrep
               Call TriPrt(Label,' ',Fock(ii),nBas(iIrrep))
               ii = ii + nBas(iIrrep)*(nBas(iIrrep)+1)/2
            End Do
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     nOrdOp: order/rank of the operator
*     lOper: lOper of each component of the operator
*
      nOrdOp=0
      nComp = nElem(nOrdOp)
      Call mma_allocate(Coor,3,nComp,Label='Coor')
      Call mma_allocate(lOper,nComp,Label='lOper')
      Coor(:,:)=Zero
      lOper(1)=1
      If (HF_Force) Go To 1003
************************************************************************
*1)                                                                    *
*     Trace the generalized Fock matrix with the gradient of the       *
*     overlap matrix.                                                  *
*                                                                      *
************************************************************************
*
      DiffOp = .False.
      Label  = ' The Renormalization Contribution'
      Call OneEl_g(OvrGrd,OvrMmG,Temp,nGrad,DiffOp,Coor,
     &             Fock,nFock,lOper,nComp,nOrdOp,Label)
      Call DaXpY_(nGrad,-One,Temp,1,Grad,1)
*
************************************************************************
*2)                                                                    *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the kinetic energy integrals.                        *
*                                                                      *
************************************************************************
*
      DiffOp = .False.
      Label  = ' The Kinetic Energy Contribution'
      Call OneEl_g(KneGrd,KneMmG,Temp,nGrad,DiffOp,Coor,
     &             D_Var,nDens,lOper,nComp,nOrdOp,Label)
      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
CAOM<
C... Check finite field operators...
      nextfld=0
 1100 call GetNextFfield(nextfld,fldname,nOrdOpf,ncmp,force,lforce)
      if(nextfld.ne.0) then
        if(nOrdOpf.eq.0) then
          if(fldname(1:2).ne.'OV') then
            Call WarningMessage(2,'Error in Drvh1')
            Write(6,*) 'Finite field gradients only for MLTP'
            Call Quit_OnUserError()
          endif
        endif
        nCompf = nElem(nOrdOpf)
        Label=fldname
        if(ncompf.ne.ncmp) then
           Call WarningMessage(2,'Error in Drvh1')
           Write(6,*) 'Wrong number of components in FF grad'
           Call Quit_OnUserError()
        endif
        Call mma_allocate(lOperf,nCompf,Label='lOperf')
        lOperf(:)=1
        DiffOp=.False.
        if(nOrdOpf.gt.0) DiffOp=.True.
        Call OneEl_g(MltGrd,MltMmG,Temp,nGrad,DiffOp,Coor,
     &               D_Var,nDens,lOperf,nCompf,nOrdOpf,Label)
        Call MltGrdNuc(Temp,nGrad,nOrdOpf)
        Call mma_deallocate(lOperf)
        Call DaXpY_(nGrad,-One,Temp,1,Grad,1)
        goto 1100
      endif
CAOM>
*
************************************************************************
*3)                                                                    *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the nuclear attraction integrals.                    *
*                                                                      *
************************************************************************
*
 1003 Continue
      DiffOp = .True.
      Label = ' The Nuclear Attraction Contribution'
      Call OneEl_g(NAGrd,NAMmG,Temp,nGrad,DiffOp,Coor,
     &             D_Var,nDens,lOper,nComp,nOrdOp,Label)
      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
      If (HF_Force) Then
         If (lECP.or.nWel.ne.0.or.Allocated(XF).or.lRF) Then
            Call WarningMessage(2,'Error in Drvh1')
            Write (6,*) 'HF forces not implemented yet for this case!'
            Call Quit_OnUserError()
         End If
         Go To 1099
      End If
*
************************************************************************
*4)                                                                    *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the ECP integrals.                                   *
*                                                                      *
************************************************************************
*
      If (lECP) Then
         DiffOp = .True.
         Label = ' The Projection Operator Contribution'
         Call OneEl_g(PrjGrd,PrjMmG,Temp,nGrad,DiffOp,Coor,
     &                D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
         Label = ' The M1 Operator Contribution'
         Call OneEl_g( M1Grd, M1MmG,Temp,nGrad,DiffOp,Coor,
     &                D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
         Label = ' The M2 Operator Contribution'
         Call OneEl_g( M2Grd, M2MmG,Temp,nGrad,DiffOp,Coor,
     &                D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
         Label = ' The SR Operator Contribution'
         Call OneEl_g(SROGrd,SROMmG,Temp,nGrad,DiffOp,Coor,
     &              D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
      End If
      If (lPP) Then
         Label = ' The Pseudo Potential Contribution'
         Call OneEl_g(PPGrd,PPMmG,Temp,nGrad,DiffOp,Coor,
     &              D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
      End If
*
************************************************************************
*5)                                                                    *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the Spherical well integrals.                        *
*                                                                      *
************************************************************************
      DiffOp = .True.
      Do iWel = 1, nWel
         r0   = Wel_Info(1,iWel)
         ExpB = Wel_Info(2,iWel)
         Label = ' The Spherical Well Contribution'
         Call OneEl_g(WelGrd,WelMmG,Temp,nGrad,DiffOp,Coor,
     &              D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Fact = Wel_Info(3,iWel)
         Call DaXpY_(nGrad,Fact,Temp,1,Grad,1)
      End Do
************************************************************************
*6)                                                                    *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the external field integrals.                        *
*                                                                      *
************************************************************************
      If (Allocated(XF)) Then
         DiffOp = .True.
         Label = ' The External Field Contribution'
         Call OneEl_g(XFdGrd,XFdMmG,Temp,nGrad,DiffOp,Coor,
     &              D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
      End If
*
************************************************************************
*7)                                                                    *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the reaction field integrals.                        *
*                                                                      *
************************************************************************
*
      If (lRF.and..Not.lLangevin.and..Not.PCM) Then
         Call mma_deallocate(lOper)
         Call mma_deallocate(Coor)
*
*------- The Kirkwood model
*
         nOrdOp=lMax
         nComp=(lMax+1)*(lMax+2)*(lMax+3)/6
         Call mma_allocate(lOper,nComp,Label='lOper')
*
*------- Store permutation symmetry of components of the EF
*
         iComp = 1
         Do iMltpl = 0, lMax
            Do ix = iMltpl, 0, -1
               If (Mod(ix,2).eq.0) Then
                  iSymX=1
               Else
                  ixyz=1
                  iSymX=2**IrrFnc(ixyz)
               End If
               Do iy = iMltpl-ix, 0, -1
                  If (Mod(iy,2).eq.0) Then
                     iSymY=1
                  Else
                     ixyz=2
                     iSymY=2**IrrFnc(ixyz)
                  End If
                  iz = iMltpl-ix-iy
                  If (Mod(iz,2).eq.0) Then
                     iSymZ=1
                  Else
                     ixyz=4
                     iSymZ=2**IrrFnc(ixyz)
                  End If
*                 lOper(iComp) = MltLbl(iSymX,MltLbl(iSymY,iSymZ))
*-----------------Compute only total symmetric contributions
                  lOper(iComp) = 1
                  iComp = iComp + 1
               End Do
            End Do
         End Do
         Call mma_allocate(Coor,3,nComp,Label='Coor')
         Coor(:,:)=Zero
         DiffOp = .True.
         Label = ' The Electronic Reaction Field Contribution'
         Call OneEl_g(RFGrd,RFMmG,Temp,nGrad,DiffOp,Coor,
     &              D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
      Else If (lRF.and.PCM) Then
         iCOSMO=0
*------- The PCM / COSMO model
*
         If (iCOSMO.le.0) Then
            iPrint=15
            Call DScal_(nTs*2,One/DBLE(nIrrep),PCM_SQ,1)
         End If
         lOper(1) = 1
         DiffOp = .True.
         If (iCOSMO.gt.0) Then
            Call dzero(Temp,ngrad)
            Label= ' The Electronic Reaction Field Contribution (COSMO)'
            Call OneEl_g(COSGrd,PCMMmG,Temp,nGrad,DiffOp,Coor,
     &                   D_Var,nDens,lOper,nComp,nOrdOp,
     &                   Label)
            If (iPrint.ge.15) Then
               Label=' Reaction Field (COSMO) Contribution'
               Call PrGrad(Label,Temp,nGrad,ChDisp,5)
            End If
         Else
            Label = ' The Electronic Reaction Field Contribution (PCM)'
            Call OneEl_g(PCMGrd,PCMMmG,Temp,nGrad,DiffOp,Coor,
     &                   D_Var,nDens,lOper,nComp,nOrdOp,
     &                   Label)
            If (iPrint.ge.15) Then
               Label=' Reaction Field (PCM) Contribution'
               Call PrGrad(Label,Temp,nGrad,ChDisp,5)
            End If
         End If

         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
         If (iCOSMO.eq.0) Call DScal_(nTs*2,DBLE(nIrrep),PCM_SQ,1)
*
      End If
*
************************************************************************
*8)                                                                    *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the FAIEMP integrals.                                *
*                                                                      *
************************************************************************
*
      If(lFAIEMP) Then
        DiffOp = .True.
        Label = ' The FAIEMP Projection Operator Contribution'
        Call OneEl_g(FragPGrd,FragPMmG,Temp,nGrad,DiffOp,Coor,
     &               D_Var,nDens,lOper,nComp,nOrdOp,Label)
        Call DaXpY_(nGrad,One,Temp,1,Grad,1)
        Call DrvG_FAIEMP(Grad,Temp,nGrad)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(lOper)
      Call mma_deallocate(Coor)
*                                                                      *
************************************************************************
1099  Continue
*                                                                      *
*...  Epilogue, end
*
      If (.Not.HF_Force) Call mma_deallocate(Fock)
      Call mma_deallocate(D_Var)
*
      Call CWTime(TCpu2,TWall2)
      Call SavTim(3,TCpu2-TCpu1,TWall2-TWall1)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine W1TW2(IVEC,JVEC,CI,SGM,nCI)
! Given contravariant indices of two wave operators W1 and W2,
! in the vectors numbered IVEC and JVEC on file (unit LUSOLV),
! compute the vector in CAS space
!   | SGM > := | SGM > + (W1 conj)*(W2)*| CI >

use Index_Functions, only: nTri_Elem, nTri3_Elem
use caspt2_module, only: nAshT, STSym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC, nCI
real(kind=wp), intent(in) :: ci(nCI)
real(kind=wp), intent(inout) :: sgm(nCI)
integer(kind=iwp) :: nOp1, nOp2, nOp3
real(kind=wp) :: OP0
real(kind=wp), allocatable :: OP1(:), OP2(:), OP3(:)

! (1): Compute a representation of the operator PCAS*W1T*W2
NOP1 = NASHT**2
NOP2 = nTri_Elem(NOP1)
NOP3 = nTri3_Elem(NOP1)
call mma_allocate(OP1,NOP1,Label='OP1')
call mma_allocate(OP2,NOP2,Label='OP2')
call mma_allocate(OP3,NOP3,Label='OP3')

call MKWWOP(IVEC,JVEC,OP0,OP1,NOP2,OP2,NOP3,OP3)

! Modify the coefficients, see subroutine MODOP.

call MODOP(OP1,NOP2,OP2,NOP3,OP3)

! (2) Apply the operators:
call HAM3(OP0,OP1,NOP2,OP2,NOP3,OP3,STSYM,CI,SGM,nCI)

call mma_deallocate(OP1)
call mma_deallocate(OP2)
call mma_deallocate(OP3)

end subroutine W1TW2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Subroutine Binom(n,i,iBin)
************************************************************************
*                                                                      *
* Object: to compute the binomial factor                               *
*                                                                      *
* Called from: Azmthl                                                  *
*              R2N                                                     *
*                                                                      *
* Calling    : None                                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
************************************************************************
      Implicit real*8 (a-h,o-z)
      Num = 1
      iDen = 1
      Do 10 j = 1, i
         Num  = Num * (n-j+1)
         iDen = iDen * j
 10   Continue
      iBin = Num/iDen
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE DENS_CPF(C,D,ICASE,A)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(*),D(*)
      DIMENSION ICASE(*)

#include "SysDef.fh"

#include "cpfmcpf.fh"
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CRL   JO(L)=IAND(ISHFT(QOCC((L+29)/30),-2*((L+29)/30*30-L)),3)
CPAM97      JO(L)=UNPACK(QOCC((L+29)/30), 2*L-(2*L-1)/60*60, 2)
      JO(L)=ICUNP(ICASE,L)
C
      ILIM=NORBT*(NORBT+1)/2
      CALL SETZ(D,ILIM)
      C(IREF0)=D0
CRL   CALL DOTPR(C,1,C,1,A,NCONF)
      A=DDOT_(NCONF,C,1,C,1)
      WRITE(6,20)A
      CALL XFLUSH(6)
20    FORMAT(5X,'SUM OF SQUARED CPX(BAR)',F10.4)
      C(IREF0)=D1
      EMA=D1-A
      II1=(IREF0-1)*LN
      DO 5 I=1,LN
      JOJ=JO(II1+I)
      IF(JOJ.GE.2)JOJ=JOJ-1
      II=I*(I+1)/2
      D(II)=JOJ*EMA
5     CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module DFT_Functionals

use Definitions, only: iwp

implicit none
private

abstract interface
  subroutine DFT_FUNCTIONAL( &
#                           define _CALLING_
#                           include "dft_functional.fh"
                           )
    import :: iwp
#   include "dft_functional.fh"
  end subroutine DFT_FUNCTIONAL
end interface

public :: DFT_FUNCTIONAL, NDSD_Ts, NucAtt, Overlap

contains

#define _IN_MODULE_
#include "overlap.F90"
#include "nucatt.F90"
#include "ndsd_ts.F90"

end module DFT_Functionals

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine PrBeg(Meth)
************************************************************************
*                                                                      *
*     purpose: Print the header to iterations                          *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*

#include "mxdm.fh"
#include "infscf.fh"
      Character*(*) Meth
      Character*10 Label
      Character *4 cUHF


      If (jPrint.ge.2) Then

      Write(6,*)
      call CollapseOutput(1,'Convergence information')
      iDummy_run=0
      cUHF='    '
      if(iUHF.eq.1) cUHF='UHF '
      Label=Meth(1:10)
      If (nIter(nIterP).gt.0) Then
        Write(6,'(31x,A,A,A)') cUHF,Label,' iterations: Energy and '//
     &                     'convergence statistics'
        Write(6,*)
        Write(6,'(A,A,A)')'Iter     Tot. ',Label,' One-elec.   '//
     &          '    Two-elec.     Energy      Max Dij or  Max Fij '//
     &          '     DNorm      TNorm      AccCon     Time'
        Write(6,'(A)')'         Energy          Energy          '//
     &          'Energy        Change      Delta Norm           '//
     &          '                                     in Sec.'
      Else
         iDummy_run=1
         Write(6,'(45x,A)')'No optimization is performed'
         If (InVec.eq.1) Then
            Write(6,'(29x,A)') 'Results refer to orbitals obtained '
     &                       //'from core diagonalization'
         Else If (InVec.eq.2) Then
            Write(6,'(34x,A,A)') 'Results refer to input orbitals '
     &            //'read from ',Trim(SCF_FileOrb)
         Else If (InVec.eq.3) Then
            Write(6,'(34x,A)') 'Results refer to density matrix '
     &                       //'read from COMOLD'
         End If
      End If
      End If

      End subroutine PrBeg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Init_SCF()
      use SCF_Arrays
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
      Integer nAsh(8)
*
      nD = 1
      If (iUHF.eq.1) nD=2
*
*---- Clear Dens and TwoHam matrices
      Call FZero(Dens  ,nBT*nD*nDens)
      Call FZero(TwoHam,nBT*nD*nDens)
      Call FZero(Vxc   ,nBT*nD*nDens)
*
*---- Set number of active shells on the RUNFILE to zero
*
      Call ICopy(8,[0],0,nAsh,1)
      Call Peek_iScalar('nSym',i)
* PAM Jan 2007 -- deactivated, improper. Fixed in nqutil in
* another way (query rather than get from runfile)
*      Call Put_iArray('nAsh',nAsh,i)
      NACTEL = 0
      Call Put_iScalar('nActel',NACTEL)
*
      Call IniLLs
*     clear MapDns ...
      iZero=0
      Call ICopy(MxKeep,[iZero],0,MapDns,1)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ATENS_RASSI(moment,ndim,gtens,maxes,IPGLOB)
!------------------------------------------------
!  ndim   -- size of the matrices
!  moment -- matrix of size (3,ndim,ndim) of the moment (magnetic, spin or angular)
!  gtens  -- array of size (3) keeping the main values of the A tensor ( dsqrt(main_values) )
!  maxes  -- array of size (3,3) keeping the main axes of the A tensor writen in
!            the right coordinate system (Determinant = +1)
!  IPGLOB -- the print level of the subroutine
!----------------------------------------------

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Six, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndim, IPGLOB
complex(kind=wp), intent(in) :: moment(3,ndim,ndim)
real(kind=wp), intent(out) :: gtens(3), maxes(3,3)
integer(kind=iwp) :: i, ic1, ic2, info, j, k
real(kind=wp) :: A_TENS_TERM(3,3), Det_gtens, diff12, diff23, MAIN(3), W(3), Z(3,3), ZR(3,3)
complex(kind=wp) :: AC_TENS(3,3)
complex(kind=wp), allocatable :: A_TEMP(:,:,:,:)

! initialization:

call mma_allocate(A_TEMP,3,3,ndim,ndim,Label='A_TEMP')

AC_TENS(:,:) = cZero
A_TENS_TERM(:,:) = Zero
A_TEMP(:,:,:,:) = cZero

do j=1,ndim
  do i=1,ndim
    do ic2=1,3
      do ic1=1,3
        A_temp(ic1,ic2,i,j) = A_temp(ic1,ic2,i,j)+sum(moment(ic1,i,:)*moment(ic2,:,j))
      end do
    end do
  end do
end do

if (IPGLOB >= 4) then
  write(u6,'(/)')
  write(u6,'(5X,A)') 'BPMOMENT(ic1,ic2):'
  write(u6,*)
  do ic1=1,3
    do i=1,ndim
      do j=1,ndim
        write(u6,*) moment(ic1,i,j)
      end do
    end do
  end do

  write(u6,'(/)')
  write(u6,'(5X,A)') 'A_TEMP(ic1,ic2):'
  write(u6,*)
  do ic1=1,3
    do ic2=1,3
      do i=1,ndim
        do j=1,ndim
          write(u6,*) A_temp(ic1,ic2,i,j)
        end do
      end do
    end do
  end do
end if

do ic1=1,3
  do ic2=1,3
    do k=1,ndim
      Ac_tens(ic1,ic2) = Ac_tens(ic1,ic2)+A_temp(ic1,ic2,k,k)
    end do
  end do
end do
call mma_deallocate(A_TEMP)
do ic1=1,3
  A_TENS_TERM(ic1,:) = Six*real(Ac_tens(ic1,:)+Ac_tens(:,ic1))/real(ndim**3-ndim,kind=wp)
end do

!if (IPGLOB > 2) then
write(u6,'(/)')
write(u6,'(5X,A)') 'A_TENS_TERM(ic1,ic2):'
write(u6,*)
do ic1=1,3
  !write(u6,'(5X,3(2F14.7,3x))') (A_TENS_TERM(ic1,ic2),ic2=1,3)
  write(u6,'(5X,3(2F21.14,3x))') (A_TENS_TERM(ic1,ic2),ic2=1,3)
end do
!endif

! Diagonalization of A_tens - g tensors

W(:) = Zero
Z(:,:) = Zero
info = 0

call DIAG_R2_RASSI(A_TENS_TERM,3,info,w,z)
if (INFO /= 0) return

if (all(w(:) < Zero)) then
  write(u6,'(2x,A)') 'ALL EIGENVALUES OF THE A-TENSOR ARE NEGATIVE'
  write(u6,'(2X,A)') 'THIS IS A VERY UNUSUAL SITUATION. PLEASE CHECK MANUALLY'
  write(u6,'(2x,A)') 'THE FOLLOWING PART OF THE PSEUDOSPIN SECTION'
  write(u6,'(2x,A)') 'MUST BE DISREGARDED. THE RESULTS ARE NOT TRUSTABLE.'
  return
end if

if (IPGLOB >= 4) then
  write(u6,*)
  write(u6,'(4x,A)') 'A_TENS_TERM TENSOR:'
  write(u6,'(2a)') repeat('-',56),'|'
  write(u6,'(4x,A,4x,A,13x,A,5x,a,3x,a)') 'MAIN VALUES','|','MAIN MAGNETIC AXES','|','x , y , z  -- initial Cartesian axes'
  write(u6,'(4a,3x,a)') repeat('-',19),'|',repeat('-',36),'|','Xm, Ym, Zm -- main magnetic axes'
  write(u6,'(19x,a,4x,a,5x,a,9x,a,9x,a,5x,a)') '|','|','x','y','z','|'
  write(u6,'(6a)') repeat('-',19),'|',repeat('-',4),'|',repeat('-',31),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gX = ',w(1),' | Xm |',(z(j,1),j=1,3),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gY = ',w(2),' | Ym |',(z(j,2),j=1,3),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gZ = ',w(3),' | Zm |',(z(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',56),'|'
end if

do I=1,3
  if (W(I) < Zero) W(I) = 1.0e-15_wp
  MAIN(i) = sqrt(W(i))
end do

if (IPGLOB >= 4) write(u6,'(5x,a,3F9.5)') 'EIGenValues after DSPEV:',(W(I),I=1,3)

! Check the sign of the coordinate system. if CS is Left-handed,
! then change it to RIGHT-handed
Det_gtens = Zero
ZR(:,:) = Z(:,:)
Det_gtens = ZR(1,1)*(ZR(2,2)*ZR(3,3)-ZR(2,3)*ZR(3,2))-ZR(1,2)*(ZR(2,1)*ZR(3,3)-ZR(2,3)*ZR(3,1))+ &
            ZR(1,3)*(ZR(2,1)*ZR(3,2)-ZR(2,2)*ZR(3,1))
if (Det_gtens < Zero) then
  Z(:,1) = -Z(:,1)
  if (IPGLOB > 2) write(u6,'(a)') 'The original coordinate system was LEFT-handed. It has been changed to the RIGHT-handed'
end if
diff12 = MAIN(2)-MAIN(1)
diff23 = MAIN(3)-MAIN(2)
if (IPGLOB >= 4) then
  write(u6,'(5x,a,3F19.15)') 'diff12 = ',diff12
  write(u6,'(5x,a,3F19.15)') 'diff23 = ',diff23
end if

gtens(:) = Zero
maxes(:,:) = Zero
! set the main Z axis:
if (diff12 > diff23) then
  gtens(3) = MAIN(1)
  gtens(2) = MAIN(2)
  gtens(1) = MAIN(3)
  if (Z(3,1) >= Zero) then
    maxes(:,3) = Z(:,1)
    maxes(:,1) = Z(:,3)
  else if (Z(3,1) < Zero) then
    maxes(:,3) = -Z(:,1)
    maxes(:,1) = Z(:,3)
  end if
else if (diff23 > diff12) then
  gtens(3) = MAIN(3)
  gtens(2) = MAIN(2)
  gtens(1) = MAIN(1)
  if (Z(3,3) >= Zero) then
    maxes(:,3) = Z(:,3)
    maxes(:,1) = Z(:,1)
  else if (Z(3,3) < Zero) then
    maxes(:,3) = -Z(:,3)
    maxes(:,1) = Z(:,1)
  end if
end if
maxes(1,2) = maxes(2,3)*maxes(3,1)-maxes(2,1)*maxes(3,3)
maxes(2,2) = maxes(1,1)*maxes(3,3)-maxes(1,3)*maxes(3,1)
maxes(3,2) = maxes(1,3)*maxes(2,1)-maxes(1,1)*maxes(2,3)

if (IPGLOB > 2) then
  write(u6,*)
  write(u6,'(20X,A)') 'A-TENSOR:'
  write(u6,*)
  write(u6,'(10X,A,10X,3(F11.5,2X))') '|  xx    xy    xz  |',(A_TENS_TERM(1,ic2),ic2=1,3)
  write(u6,'(10X,A,10X,3(F11.5,2X))') '|  yx    yy    yz  |',(A_TENS_TERM(2,ic2),ic2=1,3)
  write(u6,'(10X,A,10X,3(F11.5,2X))') '|  zx    zy    zz  |',(A_TENS_TERM(3,ic2),ic2=1,3)
end if

if (IPGLOB > 2) then
  write(u6,*)
  write(u6,'(4x,A)') 'g TENSOR:'
  write(u6,'(2a)') repeat('-',56),'|'
  write(u6,'(4x,A,4x,A,13x,A,5x,a,3x,a)') 'MAIN VALUES','|','MAIN MAGNETIC AXES','|','x , y , z  -- initial Cartesian axes'
  write(u6,'(4a,3x,a)') repeat('-',19),'|',repeat('-',36),'|','Xm, Ym, Zm -- main magnetic axes'
  write(u6,'(19x,a,4x,a,5x,a,9x,a,9x,a,5x,a)') '|','|','x','y','z','|'
  write(u6,'(6a)') repeat('-',19),'|',repeat('-',4),'|',repeat('-',31),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gX = ',gtens(1),' | Xm |',(maxes(j,1),j=1,3),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gY = ',gtens(2),' | Ym |',(maxes(j,2),j=1,3),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gZ = ',gtens(3),' | Zm |',(maxes(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',56),'|'
  !call Add_Info('GTENS_MAIN',gtens,3,5)
end if

end subroutine ATENS_RASSI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine SphAve
      Implicit Real*8 (a-h,o-z)
#include "parm.fh"
#include "common.fh"
      iPtr=0
      Do 100 iLqn=0,MxLqn
         nDim=nPrim(iLqn)*(nPrim(iLqn)+1)/2
         Do 110 ij=1,nDim
            ind=iPtr+ij
            t=0.0d0
            Do 111 i=0,2*iLqn
               t=t+tDsym(ind+i*nDim)
111         Continue
            t=t/(2*iLqn+1)
            Do 112 i=0,2*iLqn
               tDsym(ind+i*nDim)=t
112         Continue
110      Continue
         iPtr=iPtr+(2*iLqn+1)*nDim
100   Continue
*      Write(*,*) '*** Density matrix in SphAve ***'
*      iBlk=0
*      Do 200 iLqn=0,MxLqn
*         Do 210 iShell=-iLqn,iLqn
*            iBlk=iBlk+1
*            If(nPrim(iLqn).gt.0) Then
*               Write(*,'(a,2i5)') ' Block',iLqn,iShell
*               Call Triprt(' ','(6F12.6)',tDsym(iSymbk(iBlk)),
*    &                      nPrim(iLqn))
*            End If
*210      Continue
*200   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Pseudo(ai,xi,yi,zi,lit,aj,xj,yj,zj,ljt,gout,intmax,lmn1u,ccr,zcr,nkcrl,nkcru,lcr,ncr,xc,yc,zc,npot)
!***********************************************************************
! This collection of subroutines, adapted from the ARGOS suite of programs,
! calculates integrals of an atomic semi-local one-component (i.e., non-
! relativistic or scalar-relativistic) pseudopotential (PP) between two shells
! of primitive cartesian GTOs. The integrals are contained in field gout(*).
! lmn1u is the maximum l value + 1 of the basis functions
! lproju is the maximum l value + 1 of the pseudopotential
! GTO parameters
!
! The GTOs are given by Ni (x-xi)^li (y-yi)^mi (z-zi)^ni exp(-ai(r-ri)^2)
! and Nj (x-xj)^lj (y-yj)^mj (z-zj)^nj exp(-aj(r-rj)^2). The Ni, Nj are
! chosen such that the integrals are normalized to (2l-1)!!(2m-1)!!(2n-1)!!.
! Input data are
! ai, aj : exponents
! xi,yi,zi, xj,yj,zj : centers
! lit = li+mi+ni+1, ljt = lj+mj+nj+1 : angular-momentum values + 1
! PP parameters
!
! The pseudopotential is of the form V_loc + sum_l V_l P_l, where V_loc and the V_l
! are radial potentials and P_l is the projector onto angular-momentum l.
! Both V_loc and the V_l are given by expansions of the form
! V = sum_i ccr(i) ( r^(ncr(i)-2) exp(-zcr(i)*r^2) ),
! where r is the distance from the PP center (xc, yc, zc).
! The PP parameters are assumed to be taken from a list of PPs for several atoms
! containing the following input data:
! npot : number of radial potentials in the list
! ccr(i) : coefficients
! ncr(i), zcr(i) : exponential parameters
! nkcrl(1,k) : lower index i for V_loc at nucleus k
! nkcru(1,k) : upper index i for V_loc at nucleus k
! nkcrl(l+2,k) : lower index i for V_l at nucleus k
! nkcru(l+2,k) : upper index i for V_l at nucleus k
! lcr(k) : maximum l value + 1 of the PP at nucleus k
! k=kcrs : specifies the PP for which integrals are calculated
! xc,yc,zc : position of nucleus kcrs
!
!***********************************************************************

use ppint_arrays, only: binom, dfac, hpt, hwt, lmf, lml, lmnv, lmx, lmy, lmz, zlm
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: OneHalf, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), parameter :: lproju = 9, imax = 100, kcrs = 1
integer(kind=iwp), intent(in) :: lit, ljt, intmax, lmn1u, nkcrl(lproju+1,kcrs), nkcru(lproju+1,kcrs), lcr(kcrs), ncr(imax), npot
real(kind=wp), intent(in) :: ai, xi, yi, zi, aj, xj, yj, zj, ccr(npot), zcr(npot), xc, yc, zc
real(kind=wp), intent(inout) :: gout(2*intmax)
integer(kind=iwp) :: i, l1max2, lambu, lcru, litot, ljtot, lmax, lmnpwr, lmnvmx, lproju1, ltot1, mproju, ncru, ndfac
real(kind=wp) :: crda(lproju,3), crdb(lproju,3), eps
real(kind=wp), parameter :: facij = Pi**OneHalf

!write(u6,*) 'ncr',(ncr(i),i=1,npot)
!write(u6,*) 'zcr',(zcr(i),i=1,npot)
!write(u6,*) 'ccr',(ccr(i),i=1,npot)
!write(u6,*) 'nkcrl',(nkcrl(i,1),i=1,lcr(1)+1)
!write(u6,*) 'nkcru',(nkcru(i,1),i=1,lcr(1)+1)
!write(u6,*)
!                                                                      *
!***********************************************************************
!                                                                      *
lmnvmx = (lmn1u*(lmn1u+1)*(lmn1u+2))/6
ncru = 0
do i=1,npot
  ncru = max(ncru,ncr(i))
end do
ndfac = max(4*lmn1u+2*lproju-3,6*lproju+3,4*lmn1u-1,2*lmn1u+2*lproju+1,4,ncru+4*lmn1u+2*lproju-1)
lmax = max(1,lmn1u-1+max(lmn1u-1,lproju))
l1max2 = (lmax+1)**2
lmnpwr = (((lmax*(lmax+2)*(lmax+4))/3)*(lmax+3)+(lmax+2)**2*(lmax+4))/16
ltot1 = lit+ljt-1
mproju = 2*lproju+1
lambu = ljt+lproju

call mma_allocate(lmnv,3,lmnvmx,label='lmnv')
call mma_allocate(lmf,l1max2,label='lmf')
call mma_allocate(lml,l1max2,label='lml')
call mma_allocate(lmx,lmnpwr,label='lmx')
call mma_allocate(lmy,lmnpwr,label='lmy')
call mma_allocate(lmz,lmnpwr,label='lmz')
call mma_allocate(binom,lmn1u*(lmn1u+1)/2,label='binom')
call mma_allocate(dfac,ndfac,label='dfac')
call mma_allocate(zlm,lmnpwr,label='zlm')

call lmnvgn(lmn1u,lmnv)
eps = 1.0e-12_wp

call cortab(binom,dfac,eps,lmf,lml,lmx,lmy,lmz,lmax,lmn1u,ndfac,zlm)
!                                                                      *
!***********************************************************************
!                                                                      *
! integrals for V_loc part of PP

lproju1 = lproju+1
call pseud1(ccr,gout,ltot1,ncr,nkcrl,nkcru,zcr,lit,ljt,ai,aj,xi,yi,zi,xj,yj,zj,xc,yc,zc,kcrs,lproju1,crda,crdb)
!                                                                      *
!***********************************************************************
!                                                                      *
! integrals for V_l P_l parts of PP

lcru = lcr(kcrs)
call pseud2(ccr,gout,lambu,ltot1,mproju,ncr,nkcrl,nkcru,zcr,lit,ljt,ai,aj,xi,yi,zi,xj,yj,zj,xc,yc,zc,kcrs,lcru,lproju1,crda,crdb)

call mma_deallocate(lmnv)
call mma_deallocate(lmf)
call mma_deallocate(lml)
call mma_deallocate(lmx)
call mma_deallocate(lmy)
call mma_deallocate(lmz)
call mma_deallocate(binom)
call mma_deallocate(dfac)
call mma_deallocate(zlm)
call mma_deallocate(hpt)
call mma_deallocate(hwt)

!                                                                      *
!***********************************************************************
!                                                                      *
! final results with normalization factors

!faci = sqrt((Four*ai)**lit/Two*sqrt(Two*ai))/((Four*ai)**(Half*(lit-1))*(Two*ai/Pi)**(Three/Four))
!facj = sqrt((Four*aj)**ljt/Two*sqrt(Two*aj))/((Four*aj)**(Half*(ljt-1))*(Two*aj/Pi)**(Three/Four))
!facij = faci*facj
litot = lit*(lit+1)/2
ljtot = ljt*(ljt+1)/2

call DScal_(litot*ljtot,facij,gout,1)

!do i=1,litot
!  do j=1,ljtot
!    gout(i+(j-1)*litot) = gout(i+(j-1)*litot)*facij
!  end do
!end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Reorder integrals from Argos to Molcas order

call Molcas_Order(GOut,litot,ljtot)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Pseudo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine POLY_ANISO_1(nneq,neqv,nmax,exch,nLoc,nCenter,nT,nH,nTempMagn,nDir,nDirZee,nMult,nPair,MxRank1,MxRank2, &
                        old_aniso_format,iReturn)
! definition of the cluster:
!  nneq : number of non-equivalent sites
!  neqv : number of equivalent sites of each type, neqv = MAXVAL(neq(:))
!  nCenter, neq
! definition of the local metal sites
!  nLoc : number of spin-orbit states. nLoc = MAXVAL(nss(:));
!  nss, nsfs, multiplicity, gtens_input, D_fact, EoverD_fact
! definition of the main local axes in general coord system
!  riso, R_LG, R_ROT
! spin orbit energies on individual metal sites
!  eso, eso_au, dipso, s_so, itype, namefile_aniso, ifHDF, old_aniso_format, DoPlot
! definition of the exchange:
!  exch     : total number of exchange states
!  nPair    : number of metal pairs (number of interactions)
!  nmax     : exchange basis, nmax = MAXVAL(nexch(:))
!  i_pair   : index of the metal site in a given interacting pair
!  imaxrank : index of rank ITOs for JITO exchange definition
!  Jex      : Lines exchange    ( 1 parameter / interacting pair)
!  JAex     : Anisotropic Lines ( 3 parameter / interacting pair)
!  JAex9    : Anisotropic Lines full ( 9 parameters / interacting pair)
!  JDMex    : Anisotropic Lines ( 3 parameter / interacting pair)
!  W        : exchange spectrum
!  Z        : exchange eigenstates
!  dipexch  : exchange magnetic moment
!  s_exch   : exchange spin moment
!  MxRank1, MxRank2, nexch, AnisoLines1, AnisoLines3, AnisoLines9, Dipol, DM_exchange, decompose_exchange, JITO_exchange, JITOexR,
!  JITOexI
! options used in connection with KE
!  lant, multLn, KEOPT, KE, tpar, upar
! options used in connection with Dipol-Dipol interaction
!  MagnCoords, nTempMagn
! definition of g and D tensors
!  nMult : multiplicity of each multiplet
!  gtens : gtensor of each multiplet
!  maxes : main axes of each multiplet
!  compute_g_tensors, nDim
! definition of data for susceptibility
!  nT, compute_susceptibility, tinput, tmin, tmax, dltT0, T, XTexp, XT_no_field, chit_exp, Texp, XLM, ZLM, XRM, ZRM
! options related to XT_MoverH
!  Xfield
! definition of data for magnetization:
!  nH, nM, iopt, TempMagn, Hexp, Mexp, thrs, em, hmin, hmax, dltH0, hinput, compute_magnetization, compute_Mdir_vector,
!  zeeman_energy, m_paranoid, m_accurate, smagn
! options used to set up nM and EM
!  encut_definition
!  nK, mG     : encut_definition=1;
!  ncut       : encut_definition=2;
!  encut_rate : encut_definition=3;
! magnetization torque
!  compute_torque, AngPoints, nP
! Zeeman energy and M vector
!  nDir, nDirZee, nDirTot, LuZee, dirX, dirY, dirZ, dir_weight
! definition of mean field parameter
!  zJ
! definition of the crystal axes:
!  cryst(6) : a, b, c, alpha, beta, gamma
!  coord(3) : Cartesian coordinates of the main metal site, or center
!  Do_structure_abc
! definitions for blocking barrier
!  nBlock, compute_barrier
! options for automatic fitting of parameters:
!  fitCHI : not used so far
!  fitM   : not used so far
!  iPrint, imltpl, Ifunct, iReturn, i, i1, i2, j, l, imanifold, check_title, Title, GRAD, fname, LuAniso

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, auTocm
use Definitions, only: wp, iwp, u6, CtoB, ItoB, RtoB

implicit none
integer(kind=iwp), intent(inout) :: nneq, nT, nH, nTempMagn, nDir, nDirZee, nMult, nPair
integer(kind=iwp), intent(in) :: neqv, nmax, exch, nLoc, nCenter, MxRank1, MxRank2
logical(kind=iwp), intent(in) :: old_aniso_format
integer(kind=iwp), intent(out) :: iReturn
integer(kind=iwp) :: AngPoints, encut_definition, i, i1, i2, Ifunct, imanifold, imltpl, iopt, iPrint, j, KEOPT, l, lant, LuAniso, &
                     mem, mG, multLn, nBlock, ncut, nDirTot, ngrid, nK, nM, nP, nsymm
real(kind=wp) :: coord(3), cryst(6), dltH0, dltT0, em, encut_rate, gtens(3), hmax, hmin, maxes(3,3), thrs, tmax, tmin, tpar, upar, &
                 Xfield, zJ
logical(kind=iwp) :: AnisoLines1, AnisoLines3, AnisoLines9, check_title, compute_barrier, compute_g_tensors, &
                     compute_magnetization, compute_Mdir_vector, compute_susceptibility, compute_torque, decompose_exchange, &
                     Dipol, DM_exchange, Do_structure_abc, DoPlot, fitCHI, fitM, GRAD, hinput, ifHDF, JITO_exchange, KE, &
                     m_accurate, m_paranoid, smagn, tinput, zeeman_energy
character(len=180) :: fname, namefile_aniso(nneq), Title
character :: itype(nneq)
integer(kind=iwp), allocatable :: i_pair(:,:), imaxrank(:,:), LuZee(:), nDim(:), neq(:), nexch(:), nsfs(:), nss(:)
real(kind=wp), allocatable :: chit_exp(:), D_fact(:), dir_weight(:,:), dirX(:), dirY(:), dirZ(:), EoverD_fact(:), eso(:,:), &
                              eso_au(:,:), eso_tmp(:), eso_tmp2(:,:), gtens_input(:,:), Hexp(:), JAex(:,:), JAex9(:,:,:), &
                              JDMex(:,:), Jex(:), JITOexI(:,:,:,:,:), JITOexR(:,:,:,:,:), MagnCoords(:,:), Mexp(:,:), &
                              R_LG(:,:,:,:), R_ROT(:,:,:,:), riso(:,:,:), T(:), TempMagn(:), Texp(:), W(:), XLM(:,:,:,:), &
                              XRM(:,:,:,:), XT_no_field(:), XTexp(:), ZLM(:,:), ZRM(:,:)
complex(kind=wp), allocatable :: dipexch(:,:,:), dipexch_tmp(:,:,:), dipso(:,:,:,:), dipso_tmp(:,:,:), dipso_tmp2(:,:,:,:), &
                                 s_exch(:,:,:), s_exch_tmp(:,:,:), s_so(:,:,:,:), s_so_tmp(:,:,:), s_so_tmp2(:,:,:,:), Z(:,:)
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: dbg = _DBG_
integer(kind=iwp), external :: IsFreeUnit

#include "warnings.h"

!-----------------------------------------------------------------------
! Constants:
GRAD = .false.
!-----------------------------------------------------------------------
! Allocate memory for all arrays:
!-----------------------------------------------------------------------
#ifdef _DEBUGPRINT_
write(u6,*) '      exch = ',exch
write(u6,*) '     nPair = ',nPair
write(u6,*) '     nMult = ',nMult
write(u6,*) '      nneq = ',nneq
write(u6,*) '      neqv = ',neqv
write(u6,*) '      nLoc = ',nLoc
write(u6,*) '   nDirZee = ',nDirZee
write(u6,*) '      nDir = ',nDir
write(u6,*) '        nH = ',nH
write(u6,*) '        nT = ',nT
write(u6,*) ' nTempMagn = ',nTempMagn
write(u6,*) 'old_format = ',old_aniso_format
write(u6,*) '   MxRank1 = ',MxRank1
write(u6,*) '   MxRank2 = ',MxRank2
#endif

mem = 0

! exchange energy spectrum
call mma_allocate(W,exch,'W')
mem = mem+size(W)*RtoB
! exchange eigenvectors:
call mma_allocate(Z,exch,exch,'Z')
mem = mem+size(Z)*CtoB
! magnetic moment
call mma_allocate(dipexch,3,exch,exch,'dipexch')
mem = mem+size(dipexch)*CtoB
! spin moment
call mma_allocate(s_exch,3,exch,exch,'s_exch')
mem = mem+size(s_exch)*CtoB
! allocated memory counter
#ifdef _DEBUGPRINT_
write(u6,'(A,I16)') 'mem 1 =',mem
#endif

! index of metal site for each interacting pair:
call mma_allocate(i_pair,nPair,2,'i_pair')
mem = mem+size(i_pair)*ItoB
! exchange Lines-1 parameter
call mma_allocate(Jex,nPair,'Jex')
Jex(:) = Zero
mem = mem+size(Jex)*RtoB
! exchange Lines-3 parameter
call mma_allocate(JAex,nPair,3,'Jex')
JAex(:,:) = Zero
mem = mem+size(JAex)*RtoB
! exchange Lines-9 parameter
call mma_allocate(JAex9,nPair,3,3,'Jex')
JAex9(:,:,:) = Zero
mem = mem+size(JAex9)*RtoB
! exchange Dzyaloshinsky-Morya parameter
call mma_allocate(JDMex,nPair,3,'Jex')
JDMex(:,:) = Zero
mem = mem+size(JDMex)*RtoB
! index of ITO ranks for for each interacting pair:
call mma_allocate(imaxrank,nPair,2,'imaxrank')
imaxrank(:,:) = 0
mem = mem+size(imaxrank)*ItoB
! exchange JITO
#ifdef _DEBUGPRINT_
write(u6,'(A,I10)') 'nPair  =',nPair
write(u6,'(A,I10)') 'MxRank1=',MxRank1
write(u6,'(A,I10)') 'MxRank2=',MxRank2
write(u6,'(A,I10)') 'ibuf   =',nPair*MxRank1*MxRank2*(2*MxRank1+1)*(2*MxRank2+1)
call xFlush(u6)
#endif
call mma_allocate(JITOexR,[1,nPair],[1,MxRank1],[-MxRank1,MxRank1],[1,MxRank2],[-MxRank2,MxRank2],'JITOexR')
call mma_allocate(JITOexI,[1,nPair],[1,MxRank1],[-MxRank1,MxRank1],[1,MxRank2],[-MxRank2,MxRank2],'JITOexI')
JITOexR(:,:,:,:,:) = Zero
JITOexI(:,:,:,:,:) = Zero
mem = mem+size(JITOexR)*RtoB
mem = mem+size(JITOexI)*RtoB
! allocated memory counter
#ifdef _DEBUGPRINT_
write(u6,'(A,I16)') 'mem 2 =',mem
#endif

! index of metal site for each interacting pair:
call mma_allocate(nDim,nMult,'nDim')
nDim(:) = 0
mem = mem+size(nDim)*ItoB
! allocated memory counter
#ifdef _DEBUGPRINT_
write(u6,'(A,I16)') 'mem 3 =',mem
#endif

! number of equivalent centers, per type
call mma_allocate(neq,nneq,'neq')
mem = mem+size(neq)*ItoB
! local number of spin orbit states:
call mma_allocate(nss,nneq,'nss')
nss(:) = 0
mem = mem+size(nss)*ItoB
! local number of spin free states:
call mma_allocate(nsfs,nneq,'nsfs')
nsfs(:) = 0
mem = mem+size(nsfs)*ItoB
! local basis for exchange:
call mma_allocate(nexch,nneq,'nexch')
mem = mem+size(nexch)*ItoB
! gtens_input(:,:)
call mma_allocate(gtens_input,3,nneq,'gtens_input')
mem = mem+size(gtens_input)*RtoB
! D_fact
call mma_allocate(D_fact,nneq,'D_fact')
mem = mem+size(D_fact)*RtoB
! EoverD_fact
call mma_allocate(EoverD_fact,nneq,'EoverD_fact')
mem = mem+size(EoverD_fact)*RtoB
! MagnCoords()
call mma_allocate(MagnCoords,nneq,3,'MagnCoords')
MagnCoords(:,:) = Zero
mem = mem+size(MagnCoords)*RtoB
! riso
call mma_allocate(riso,3,3,nneq,'riso')
riso(:,:,:) = Zero
mem = mem+size(riso)*RtoB

! R_LG
call mma_allocate(r_lg,nneq,neqv,3,3,'r_lg')
r_lg(:,:,:,:) = Zero
mem = mem+size(r_lg)*RtoB
! R_ROT
call mma_allocate(r_rot,nneq,neqv,3,3,'r_rot')
r_rot(:,:,:,:) = Zero
mem = mem+size(r_rot)*RtoB

! local spin orbit states
call mma_allocate(eso,nneq,nLoc,'eso')
mem = mem+size(eso)*RtoB
call mma_allocate(eso_au,nneq,nLoc,'eso_au')
mem = mem+size(eso_au)*RtoB
! local magnetic moment
call mma_allocate(dipso,nneq,3,nLoc,nLoc,'dipso')
mem = mem+size(dipso)*CtoB
! local spin moment
call mma_allocate(s_so,nneq,3,nLoc,nLoc,'s_so')
mem = mem+size(s_so)*CtoB

! allocated memory counter
#ifdef _DEBUGPRINT_
write(u6,'(A,I16)') 'mem 4 =',mem
#endif

! unit numbers of the files containing Zeeman states
call mma_allocate(LuZee,nDirZee,'LuZee')
LuZee(:) = 0
mem = mem+size(LuZee)*ItoB
! directional vectors for the magnetic field, for computing Zeeman states
call mma_allocate(dir_weight,nDirZee,3,'dir_weight')
dir_weight(:,:) = Zero
mem = mem+size(dir_weight)*ItoB
! allocated memory counter
#ifdef _DEBUGPRINT_
write(u6,'(A,I16)') 'mem 5 =',mem
#endif

! magnetization vectors
call mma_allocate(dirX,nDir,'dirX')
call mma_allocate(dirY,nDir,'dirY')
call mma_allocate(dirZ,nDir,'dirZ')
dirX(:) = Zero
dirY(:) = Zero
dirZ(:) = Zero
mem = mem+size(dirX)*RtoB
mem = mem+size(dirY)*RtoB
mem = mem+size(dirZ)*RtoB
! allocated memory counter
#ifdef _DEBUGPRINT_
write(u6,'(A,I16)') 'mem 6 =',mem
#endif

! experimental field points:
call mma_allocate(Hexp,nH,'Hexp')
Hexp(:) = Zero
mem = mem+size(Hexp)*RtoB
! experimental magnetisation:
call mma_allocate(Mexp,nH,nTempMagn,'Mexp')
Mexp(:,:) = Zero
mem = mem+size(Mexp)*RtoB
! temperature points for magnetization:
call mma_allocate(TempMagn,nTempMagn,'TempMagn')
mem = mem+size(TempMagn)*RtoB
! allocated memory counter
#ifdef _DEBUGPRINT_
write(u6,'(A,I16)') 'mem 7 =',mem
#endif

! XT for local centers, all states
call mma_allocate(XLM,nCenter,nTempMagn,3,3,'XLM')
XLM(:,:,:,:) = Zero
mem = mem+size(XLM)*RtoB
! Statistical sum for local centers, all states
call mma_allocate(ZLM,nCenter,nTempMagn,'ZLM')
ZLM(:,:) = Zero
mem = mem+size(ZLM)*RtoB
! XT for local centers, exchange states
call mma_allocate(XRM,nCenter,nTempMagn,3,3,'XRM')
XRM(:,:,:,:) = Zero
mem = mem+size(XRM)*RtoB
! Statistical sum for local centers, exchange states
call mma_allocate(ZRM,nCenter,nTempMagn,'ZRM')
ZRM(:,:) = Zero
mem = mem+size(ZRM)*RtoB
! allocated memory counter
#ifdef _DEBUGPRINT_
write(u6,'(A,I16)') 'mem 8 =',mem
#endif

! T experimental given by user in the input
call mma_allocate(Texp,nT,'Texp')
Texp(:) = Zero
mem = mem+size(Texp)*RtoB
! XT experimental given by user in the input
call mma_allocate(chit_exp,nT,'chit_exp')
chit_exp(:) = Zero
mem = mem+size(chit_exp)*RtoB

! -- add nTempMagn points, so that all measurables are computed at once...
! temperature points for which XT will be computed
call mma_allocate(T,nTempMagn+nT,'Temperature')
mem = mem+size(T)*RtoB
! XT experimental tmagn XTexp+Tmagn
call mma_allocate(XTexp,nTempMagn+nT,'XTexp')
mem = mem+size(XTexp)*RtoB
! XT in the absence of the magnetic field
call mma_allocate(XT_no_field,nTempMagn+nT,'XT_no_field')
mem = mem+size(XT_no_field)*RtoB
! allocated memory counter
#ifdef _DEBUGPRINT_
write(u6,'(A,I16)') 'mem 9 =',mem
#endif

write(u6,'(A,I16,A)') 'The code allocated at least:',mem,' bytes of memory for this run.'
!-----------------------------------------------------------------------
! set default values of the main variables and arrays:
#ifdef _DEBUGPRINT_
call xFlush(u6)
write(u6,*) 'Enter set_defaults'
#endif
call set_defaults(nneq,nTempMagn,nDir,nDirZee,nMult,neq,nexch,nK,mG,ncut,nP,AngPoints,nBlock,encut_definition,iopt,iPrint,nsymm, &
                  ngrid,dltT0,dltH0,zJ,tmin,tmax,hmin,hmax,XField,thrs,TempMagn,cryst,coord,encut_rate,gtens_input,D_fact, &
                  EoverD_fact,riso,decompose_exchange,AnisoLines1,AnisoLines3,AnisoLines9,DM_exchange,Dipol,KE,JITO_exchange, &
                  fitCHI,fitM,Do_structure_abc,doplot,compute_g_tensors,tinput,compute_susceptibility,compute_torque, &
                  compute_barrier,compute_magnetization,hinput,compute_Mdir_vector,zeeman_energy,m_paranoid,m_accurate,smagn,itype)
#ifdef _DEBUGPRINT_
write(u6,*) 'Exit set_defaults'
#endif
if (neqv > 1) then
# ifdef _DEBUGPRINT_
  write(u6,*) 'Enter fetch_neq'
# endif
  call fetch_neq(nneq,neq(1:nneq),nexch(1:nneq))
# ifdef _DEBUGPRINT_
  write(u6,*) 'Exit fetch_neq'
# endif
end if

!-----------------------------------------------------------------------
! read the Standard Input:
#ifdef _DEBUGPRINT_
write(u6,*) 'Enter Readin_poly'
#endif
call Readin_poly(nneq,neq,neqv,exch,nCenter,nT,nH,nTempMagn,nDir,nDirZee,nMult,nPair,nexch,nDim,i_pair,lant,multLn,iPrint,keopt, &
                 encut_definition,nK,mG,iopt,nP,AngPoints,ncut,LUZee,MxRank1,MxRank2,imaxrank,nsymm,ngrid,TempMagn,R_LG,R_ROT,Jex, &
                 JAex,JAex9,JDMex,JITOexR,JITOexI,tpar,upar,cryst,coord,Xfield,gtens_input,D_fact,EoverD_fact,riso,MagnCoords, &
                 thrs,tmin,tmax,hmin,hmax,Texp,chit_exp,Hexp,Mexp,encut_rate,zJ,dirX,dirY,dirZ,dir_weight,Title,itype,ifHDF, &
                 compute_g_tensors,compute_magnetization,TINPUT,HINPUT,Do_structure_abc,doplot,compute_Mdir_vector,zeeman_energy, &
                 m_paranoid,m_accurate,smagn,compute_susceptibility,decompose_exchange,KE,fitCHI,fitM,compute_torque, &
                 compute_barrier,Dipol,check_title,AnisoLines1,AnisoLines3,AnisoLines9,DM_exchange,JITO_exchange)
#ifdef _DEBUGPRINT_
write(u6,*) 'Exit Readin_poly'
call xFlush(u6)
#endif
!-----------------------------------------------------------------------
! fetch the data from aniso_x.input files: (formatted ANISOINPUT)
do i=1,nneq
# ifdef _DEBUGPRINT_
  write(u6,'(A,A)') 'itype(i)=',itype(i)
  !write(u6,*) '   nss(i)=',nss(i)
  !write(u6,*) '  nsfs(i)=',nsfs(i)
  write(u6,*) ' nexch(i)=',nexch(i)
  write(u6,*) '     nLoc=',nLoc
  write(u6,*) ' gtens_input(1:3,i)=',(gtens_input(j,i),j=1,3)
  write(u6,*) 'D_fact(i)=',D_fact(i)
  !write(u6,*) 'eso(i,1:nexch(i))=',(eso(i,j),j=1,nexch(i))
  write(u6,*) 'old_aniso_format=',old_aniso_format
  call xFlush(u6)
# endif

  if ((itype(i) == 'B') .or. (itype(i) == 'C')) then

#   ifdef _DEBUGPRINT_
    write(u6,*) 'Enter generate_isotrop_site'
    call xFlush(u6)
#   endif
    call mma_allocate(eso_tmp,nexch(i),label='eso_tmp')
    call mma_allocate(dipso_tmp,3,nexch(i),nexch(i),label='dipso_tmp')
    call mma_allocate(s_so_tmp,3,nexch(i),nexch(i),label='s_so_tmp')
    call generate_isotrop_site(nss(i),nsfs(i),nexch(i),gtens_input(:,i),riso(:,:,i),D_fact(i),EoverD_fact(i),eso_tmp,dipso_tmp, &
                               s_so_tmp)
    eso(i,1:nexch(i)) = eso_tmp(:)
    dipso(i,:,1:nexch(i),1:nexch(i)) = dipso_tmp(:,:,:)
    s_so(i,:,1:nexch(i),1:nexch(i)) = s_so_tmp(:,:,:)
    call mma_deallocate(eso_tmp)
    call mma_deallocate(dipso_tmp)
    call mma_deallocate(s_so_tmp)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Exit generate_isotrop_site'
    call xFlush(u6)
#   endif

  else if (itype(i) == 'A') then

    if (ifHDF) then
      ! set their names:
      if (i < 10) then
        write(namefile_aniso(i),'(4A)') 'aniso_hdf_',char(48+mod(int(i),10)),'.input'
#       ifdef _DEBUGPRINT_
        write(u6,'(A,i2,A,A)') 'namefile_aniso(',i,')=',namefile_aniso(i)
#       endif
      else if ((i >= 10) .and. (i <= 99)) then
        write(namefile_aniso(i),'(4A)') 'aniso_hdf_',char(48+mod(i/10,10)),char(48+mod(i,10)),'.input'
      end if
#     ifdef _DEBUGPRINT_
      write(u6,*) 'PA:  namefile_aniso(i)=',trim(namefile_aniso(i))
#     endif

#     ifdef _HDF5_
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Enter read_hdf5_poly'
#     endif
      call read_hdf5_init(namefile_aniso(i),nsfs(i),nss(i))
#     ifdef _DEBUGPRINT_
      write(u6,*) 'i=',i,'nsfs(i),nss(i)=',nsfs(i),nss(i)
#     endif
      call mma_allocate(eso_tmp,nss(i),label='eso_tmp')
      call mma_allocate(dipso_tmp,3,nss(i),nss(i),label='dipso_tmp')
      call mma_allocate(s_so_tmp,3,nss(i),nss(i),label='s_so_tmp')
      call read_hdf5_poly(namefile_aniso(i),nss(i),nsfs(i),eso_tmp,dipso_tmp,s_so_tmp,iReturn)
      eso(i,1:nss(i)) = eso_tmp(:)
      dipso(i,:,1:nss(i),1:nss(i)) = dipso_tmp(:,:,:)
      s_so(i,:,1:nss(i),1:nss(i)) = s_so_tmp(:,:,:)
      call mma_deallocate(eso_tmp)
      call mma_deallocate(dipso_tmp)
      call mma_deallocate(s_so_tmp)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Exit read_hdf5_poly'
      write(u6,*) 'ESO(i)=',(ESO(i,j),j=1,nss(i))
#     endif
#     else
      call WarningMessage(2,'File '//trim(namefile_aniso(i))//' cannot be opened. Molcas was compiled without HDF5 option.')
      call Quit_OnUserError()
#     endif
    else
      ! set their names:
      if (i < 10) then
        write(namefile_aniso(i),'(4A)') 'aniso_',char(48+mod(i,10)),'.input'
      else if ((i >= 10) .and. (i <= 99)) then
        write(namefile_aniso(i),'(4A)') 'aniso_',char(48+mod(i/10,10)),char(48+mod(i,10)),'.input'
      end if

      if (old_aniso_format) then
        ! get the information from OLD formatted
        ! aniso.input file:
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Enter read_formatted_aniso_poly'
        !write(u6,*) 'nss(i) =',nss(i)
        !write(u6,*) 'nsfs(i)=',nsfs(i)
        !write(u6,*) 'nLoc   =',nLoc
        call xFlush(u6)
#       endif

        call mma_allocate(eso_tmp,nLoc,label='eso_tmp')
        call mma_allocate(dipso_tmp,3,nLoc,nLoc,label='dipso_tmp')
        call mma_allocate(s_so_tmp,3,nLoc,nLoc,label='s_so_tmp')
        call read_formatted_aniso_poly(namefile_aniso(i),nss(i),nsfs(i),nLoc,eso_tmp,dipso_tmp,s_so_tmp,iReturn)
        eso(i,1:nLoc) = eso_tmp(:)
        dipso(i,:,1:nLoc,1:nLoc) = dipso_tmp(:,:,:)
        s_so(i,:,1:nLoc,1:nLoc) = s_so_tmp(:,:,:)
        call mma_deallocate(eso_tmp)
        call mma_deallocate(dipso_tmp)
        call mma_deallocate(s_so_tmp)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Exit read_formatted_aniso_poly'
#       endif

      else ! old_aniso_format is false, i.e. the default

        ! get the information from NEW formatted
        ! aniso.input file:
#       ifdef _DEBUGPRINT_
        write(u6,*) 'read formatted_aniso_poly_NEW'
#       endif
        LuAniso = IsFreeUnit(81)
        call molcas_open(LuAniso,namefile_aniso(i))
        ! nss(i) is yet undefined up till this place
        call read_nss(LuAniso,nss(i),dbg)
        call read_nstate(LuAniso,nsfs(i),dbg)
        call mma_allocate(eso_tmp,nss(i),label='eso_tmp')
        call mma_allocate(dipso_tmp,3,nss(i),nss(i),label='dipso_tmp')
        call mma_allocate(s_so_tmp,3,nss(i),nss(i),label='s_so_tmp')
        call read_eso(LuAniso,nss(i),eso_tmp,dbg)
        eso_au(i,1:nss(i)) = eso_tmp(:)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'poly_aniso: eso_au=',(eso_au(i,j),j=1,nss(i))
#       endif
        call read_magnetic_moment(LuAniso,nss(i),dipso_tmp,dbg)
        dipso(i,:,1:nss(i),1:nss(i)) = dipso_tmp(:,:,:)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Call read_spin_moment'
        call xFlush(u6)
#       endif
        call read_spin_moment(LuAniso,nss(i),s_so_tmp,dbg)
        s_so(i,:,1:nss(i),1:nss(i)) = s_so_tmp(:,:,:)
        ! compute the relative spin-orbit energies in cm-1
        eso(i,1:nss(i)) = (eso_au(i,1:nss(i))-eso_au(i,1))*auTocm
        close(LuAniso)
        call mma_deallocate(eso_tmp)
        call mma_deallocate(dipso_tmp)
        call mma_deallocate(s_so_tmp)

      end if
    end if ! ifHDF
  else
    call quit(_RC_INTERNAL_ERROR_)
  end if
end do

#ifdef _DEBUGPRINT_
do i=1,nneq
  call mma_allocate(dipso_tmp,3,nss(i),nss(i),label='dipso_tmp')
  call mma_allocate(s_so_tmp,3,nss(i),nss(i),label='s_so_tmp')
  dipso_tmp(:,:,:) = dipso(i,:,1:nss(i),1:nss(i))
  s_so_tmp(:,:,:) = s_so(i,:,1:nss(i),1:nss(i))
  write(u6,*) 'MAGNETIC MOMENT  ON  SITE 1'
  call prMom('site i',dipso_tmp,nss(i))
  write(u6,*) 'SPIN MOMENT  ON  SITE 1'
  call prMom('site i',s_so_tmp,nss(i))
  call mma_deallocate(dipso_tmp)
  call mma_deallocate(s_so_tmp)
end do
#endif

#ifdef _DEBUGPRINT_
write(u6,*) 'Enter input_process'
#endif
call input_process(nneq,neq,neqv,nmax,nCenter,nexch,nDir,nDirZee,nDirTot,nH,nT,exch,nBlock,nTempMagn,iopt,nMult,nDim,nPair,i_pair, &
                   nP,AngPoints,lant,multLn,KEOPT,encut_definition,nK,mG,ncut,nsfs,nss,nLoc,MxRank1,MxRank2,imaxrank,iPrint,nsymm, &
                   ngrid,R_LG,gtens_input,dirX,dirY,dirZ,dir_weight,zJ,cryst,coord,hmin,hmax,TempMagn,thrs,Hexp,Mexp,tmin,tmax, &
                   chit_exp,Texp,Xfield,Jex,JAex,JAex9,JDMex,tpar,upar,MagnCoords,encut_rate,eso,JITOexR,JITOexI,Title,itype, &
                   namefile_aniso,Do_structure_abc,old_aniso_format,compute_barrier,fitCHI,fitM,hinput,tinput, &
                   compute_magnetization,compute_Mdir_vector,zeeman_energy,m_paranoid,m_accurate,smagn,compute_g_tensors, &
                   compute_torque,compute_susceptibility,AnisoLines1,AnisoLines3,AnisoLines9,Dipol,check_title,KE,DM_exchange, &
                   JITO_exchange)
#ifdef _DEBUGPRINT_
write(u6,*) 'Exit input_process'
#endif

! at this moment all input values are set. proceed to compute various
! properties:
!-----------------------------------------------------------------------
! in case J coupling parameters are not known, proceed to get them from
! a minimization scheme between calculated and measured magnetic susceptibility
!
! the function below optimizes the N+1 parameters:
! N - exchange couplings J, and one parameter for total shift of all experimental points;
!if (fitCHI) Call fitCHI()
!c at this point all J parameters are known; we can proceed to compute
! the energy spectrum and the resulting properties
!-----------------------------------------------------------------------
!Lines = .true.
!if (AnisoLines) Lines = .false.
!Dipol = dipole_included
!KE = exch_long

#ifdef _DEBUGPRINT_
write(u6,*) 'Dipol         = ',Dipol
write(u6,*) 'AnisoLines1   = ',AnisoLines1
write(u6,*) 'AnisoLines3   = ',AnisoLines3
write(u6,*) 'AnisoLines9   = ',AnisoLines9
write(u6,*) 'DM_exchange   = ',DM_exchange
write(u6,*) 'JITO_exchange = ',JITO_exchange
write(u6,*) 'nmax          = ',nmax
#endif

call mma_allocate(eso_tmp2,nneq,nmax,label='eso_tmp2')
call mma_allocate(dipso_tmp2,nneq,3,nmax,nmax,label='dipso_tmp2')
call mma_allocate(s_so_tmp2,nneq,3,nmax,nmax,label='s_so_tmp2')
eso_tmp2(:,:) = eso(1:nneq,1:nmax)
dipso_tmp2(:,:,:,:) = dipso(1:nneq,:,1:nmax,1:nmax)
s_so_tmp2(:,:,:,:) = s_so(1:nneq,:,1:nmax,1:nmax)

call exchctl(exch,nneq,neqv,neq,nexch,nmax,nCenter,npair,i_pair,MxRank1,MxRank2,imaxrank,Jex,JAex,JAex9,JDMex,JITOexR,JITOexI, &
             eso_tmp2,s_so_tmp2,dipso_tmp2,MagnCoords,R_ROT,R_LG,riso,tpar,upar,lant,itype,Dipol,AnisoLines1,AnisoLines3, &
             AnisoLines9,KE,KEOPT,DM_exchange,JITO_exchange,W,Z,S_EXCH,DIPEXCH,iPrint,mem)
dipso(1:nneq,:,1:nmax,1:nmax) = dipso_tmp2(:,:,:,:)
s_so(1:nneq,:,1:nmax,1:nmax) = s_so_tmp2(:,:,:,:)
!-----------------------------------------------------------------------
!     generate an 'aniso -like file' for testign exchange proj in SA
fname = 'ANISOINPUT_POLY'
call write_formatted_aniso_poly(fname,exch,W,dipexch,s_exch)
!-----------------------------------------------------------------------
! compute the magnetic moments on individual metal sites, for
! the lowest NSTA exchange states;
!   NMAX = maximal number of local states which participate into the exchange coupling
call MOMLOC2(exch,nmax,nneq,neq,neqv,r_rot,nCenter,nExch,W,Z,dipexch,s_exch,dipso_tmp2,s_so_tmp2)

call mma_deallocate(eso_tmp2)
call mma_deallocate(dipso_tmp2)
call mma_deallocate(s_so_tmp2)

!-----------------------------------------------------------------------
if (compute_g_tensors) then
# ifdef _DEBUGPRINT_
  write(u6,'(A,90I3)') 'nmult= ',nmult
  write(u6,'(A,90I3)') 'ndim() = ',ndim(1:nmult)
# endif

  Ifunct = 0
  do imltpl=1,nmult
    iReturn = 0
    i1 = 1+Ifunct
    i2 = ndim(imltpl)+Ifunct

    if (ndim(imltpl) > 1) then
      if (i2 > exch) exit

      call mma_allocate(s_exch_tmp,3,ndim(imltpl),ndim(imltpl),label='s_exch_tmp')
      call mma_allocate(dipexch_tmp,3,ndim(imltpl),ndim(imltpl),label='dipexch_tmp')
      s_exch_tmp(:,:,:) = s_exch(:,i1:i2,i1:i2)
      dipexch_tmp(:,:,:) = dipexch(:,i1:i2,i1:i2)

#     ifdef _DEBUGPRINT_
      write(u6,'(A,90I3)') 'ndim(imltpl)=',ndim(imltpl)
      call prmom('PA: s_exch:',s_exch_tmp,ndim(imltpl))
      call prmom('PA: dip_exch:',dipexch_tmp,ndim(imltpl))
#     endif

      call g_high(w(i1:i2),GRAD,s_exch_tmp,dipexch_tmp,imltpl,ndim(imltpl),Do_structure_abc,cryst,coord,gtens,maxes,iprint)

      call mma_deallocate(s_exch_tmp)
      call mma_deallocate(dipexch_tmp)

    end if
    Ifunct = Ifunct+ndim(imltpl)
    if (iReturn /= 0) call Abend()
  end do ! imltpl
end if

!----------------------------------------------------------------------|
! >> AB INITIO BLOCKING BARRIER FOR SMMs <<
if (compute_barrier) then
  if (nBlock /= 0) then
    imanifold = 1

    write(u6,'(A)') 'UBAR:: matrix elements of the (input) magnetic moment '
    write(u6,'(A)') '                |         - projection - X -        |         - projection - Y -        |'// &
                    '         - projection - Z -        |'
    write(u6,'(A)') '----------------|----- Real ------|---- Imaginary --|----- Real ------|---- Imaginary --|-'// &
                    '---- Real ------|---- Imaginary --|'
    do i=1,nBlock
      do j=1,i
        write(u6,'(A,i2,A,i2,A,6ES18.10)') '< ',i,'|M_xyz|',j,' > ',(dipexch(l,i,j),l=1,3)
      end do
    end do

    call mma_allocate(dipexch_tmp,3,nBlock,nBlock,label='dipexch_tmp')
    dipexch_tmp(:,:,:) = dipexch(:,1:nBlock,1:nBlock)
    call BARRIER(nBlock,dipexch_tmp,W(1:nBlock),imanifold,nMult,nDim(1:nMult),DoPlot,iprint)
    call mma_deallocate(dipexch_tmp)

  else
    write(u6,'(A)') 'nBlock parameter is not defined. '
    write(u6,'(A)') 'Did you specify the MLTP keyword in the input?'
    write(u6,'(A)') 'If the problem persists,please, submit a bug report.'
  end if
end if

!-----------------------------------------------------------------------
! MAGNETIC SUSCEPTIBILITY
!-----------------------------------------------------------------------
if (compute_susceptibility .and. (nT > 0)) then

  ! set nT, T(i) and XTexp(i) arrays:
  call set_T(nT,nTempMagn,TINPUT,TempMagn,Tmin,Tmax,chit_exp,Texp,T,XTexp)

  ! XT at H=0
  call susceptibility_pa(exch,nLoc,nCenter,nneq,neqv,neq,nss,nexch,nTempMagn,nT,Tmin,Tmax,XTexp,eso,dipso,s_so,W,dipexch,s_exch,T, &
                         R_LG,zJ,tinput,XLM,ZLM,XRM,ZRM,iopt,XT_no_field,DoPlot,mem)

  if (Xfield /= Zero) then
    ! XT at H>0:

    call set_nm(exch,ncut,encut_definition,nk,mg,nTempMagn,hmax,w,encut_rate,TempMagn,nM,EM,dbg)
    do i=1,nT+nTempMagn
      write(u6,*) i,T(i)
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) 'nm    =',nm
    write(u6,*) 'Tmin  =',Tmin
    write(u6,*) 'Tmax  =',Tmax
    write(u6,*) 'THRS  =',THRS
    write(u6,*) 'smagn =',smagn
    write(u6,*) 'm_par =',m_paranoid
    write(u6,*) 'm_acc =',m_accurate
    write(u6,*) 'tinpu =',tinput
#   endif

    ! nm = exch
    call XT_dMoverdH(exch,nLoc,nCenter,nneq,neqv,neq,nss,nexch,nTempMagn,nT,exch,iopt,mem,Tmin,Tmax,XTexp,eso,w,T,R_ROT,zJ,Xfield, &
                     THRS,XT_no_field,dipso,s_so,dipexch,s_exch,tinput,smagn,m_paranoid,m_accurate,doplot)
  end if
else
  write(u6,'(A)') 'Computation of the magnetic susceptibility... skipped by the user'
end if
!-----------------------------------------------------------------------
! MAGNETIC TORQUE
!-----------------------------------------------------------------------

if (compute_torque) then
!        set the NM- number of states to be exactly diagonalized in Zeeman Interaction
  call set_nm(exch,ncut,encut_definition,nk,mg,nTempMagn,hmax,w,encut_rate,TempMagn,nM,EM,dbg)

  ! nm = exch
  call torque_pa(nneq,nCenter,neq,neqv,nLoc,exch,nTempMagn,nH,exch,AngPoints,nexch,iopt,nss,mem,smagn,m_paranoid,m_accurate, &
                 TempMagn,w,hmin,hmax,dltH0,EM,zJ,THRS,hexp,dipexch,s_exch,dipso,s_so,eso,hinput,r_rot,XLM,ZLM,XRM,ZRM)

else
  write(u6,'(A)') 'Computation of the magnetization torque ... skipped by the user'
end if !compute_torque
!-----------------------------------------------------------------------
! MOLAR MAGNETIZATION
!-----------------------------------------------------------------------
if (compute_magnetization .and. (nH > 0)) then
  ! set the NM- number of states to be exactly diagonalized in Zeeman Interaction
  call set_nm(exch,ncut,encut_definition,nk,mg,nTempMagn,hmax,w,encut_rate,TempMagn,nM,EM,dbg)

  call magnetization_pa(exch,nLoc,nM,nH,nneq,neq,neqv,nCenter,nTempMagn,nDir,nDirZee,nDirTot,nss,nexch,iopt,LUZee,nsymm,ngrid, &
                        TempMagn,hexp,mexp,hmin,hmax,em,zJ,thrs,dirX,dirY,dirZ,dir_weight,w,dipexch,s_exch,dipso,s_so,eso,hinput, &
                        r_rot,XLM,ZLM,XRM,ZRM,zeeman_energy,compute_Mdir_vector,m_paranoid,m_accurate,smagn,mem,doplot)
else
  write(u6,'(A)') 'Computation of the molar magnetization ... skipped by the user'
end if !compute_magnetization

!-----------------------------------------------------------------------
! Deallocate memory for big arrays:
!-----------------------------------------------------------------------
call mma_deallocate(W)
call mma_deallocate(Z)
call mma_deallocate(dipexch)
call mma_deallocate(s_exch)
call mma_deallocate(i_pair)
call mma_deallocate(Jex)
call mma_deallocate(JAex)
call mma_deallocate(JAex9)
call mma_deallocate(JDMex)
call mma_deallocate(imaxrank)
call mma_deallocate(JITOexR)
call mma_deallocate(JITOexI)

call mma_deallocate(nDim)
call mma_deallocate(neq)
call mma_deallocate(nss)
call mma_deallocate(nsfs)
call mma_deallocate(nexch)
call mma_deallocate(gtens_input)
call mma_deallocate(D_fact)
call mma_deallocate(EoverD_fact)
call mma_deallocate(MagnCoords)
call mma_deallocate(riso)
call mma_deallocate(r_lg)
call mma_deallocate(r_rot)
call mma_deallocate(eso)
call mma_deallocate(eso_au)
call mma_deallocate(dipso)
call mma_deallocate(s_so)

call mma_deallocate(LuZee)
call mma_deallocate(dir_weight)

call mma_deallocate(dirX)
call mma_deallocate(dirY)
call mma_deallocate(dirZ)

! experimental field points:
call mma_deallocate(Hexp)
call mma_deallocate(Mexp)
call mma_deallocate(TempMagn)

call mma_deallocate(XLM)
call mma_deallocate(ZLM)
call mma_deallocate(XRM)
call mma_deallocate(ZRM)
call mma_deallocate(Texp)
call mma_deallocate(chit_exp)
call mma_deallocate(T)
call mma_deallocate(XTexp)
call mma_deallocate(XT_no_field)
!-----------------------------------------------------------------------
write(u6,*)
write(u6,'(10A)') ('-@-#-$-%-&-*-',i=1,10)
write(u6,*)
write(u6,'(10X,A)') 'HAPPY   LANDING !!!   POLY_ANISO ENDED  OK !'
write(u6,*)
write(u6,'(10A)') ('-*-&-%-$-#-@-',i=1,10)
call xFlush(u6)

return

end subroutine POLY_ANISO_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_PrintAtomPairDiagonal(iAtomPair)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: print information about the atom pair diagonal
C
      Implicit None
      Integer iAtomPair
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

      Character*25 SecNam
      Parameter (SecNam='LDF_PrintAtomPairDiagonal')

      Integer  LDF_AtomPair_DiagDim
      External LDF_AtomPair_DiagDim

      real*8 ddot_

      Integer l
      Integer ipD, ipDB
      Integer nNegD, nNegDB

      Real*8 NormD, NormDB
      Real*8 SumD, SumDB
      Real*8 AvgD, AvgDB
      Real*8 StdDevD, StdDevDB
      Real*8 MinD, MinDB
      Real*8 MaxD, MaxDB

      Integer i, j
      Integer ip_DB, ip_D, AP_Atoms
      ip_DB(i)=iWork(ip_AP_DiagBak-1+i)
      ip_D(i)=iWork(ip_AP_Diag-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      l=LDF_AtomPair_DiagDim(iAtomPair)
      If (l.lt.1) Then
         Call WarningMessage(2,SecNam//': l < 1')
         Call LDF_Quit(1)
      End If

      ipDB=ip_DB(iAtomPair)
      NormDB=sqrt(dDot_(l,Work(ipDB),1,Work(ipDB),1))
      ipD=ip_D(iAtomPair)
      NormD=sqrt(dDot_(l,Work(ipD),1,Work(ipD),1))

      SumDB=Work(ipDB)
      SumD=Work(ipD)
      Do i=1,l-1
         SumDB=SumDB+Work(ipDB+i)
         SumD=SumD+Work(ipD+i)
      End Do
      AvgDB=SumDB/dble(l)
      AvgD=SumD/dble(l)

      StdDevDB=(Work(ipDB)-AvgDB)**2
      StdDevD=(Work(ipD)-AvgD)**2
      Do i=1,l-1
         StdDevDB=(Work(ipDB+i)-AvgDB)**2
         StdDevD=(Work(ipD+i)-AvgD)**2
      End Do
      StdDevDB=sqrt(StdDevDB/dble(l))
      StdDevD=sqrt(StdDevD/dble(l))

      MinDB=Work(ipDB)
      MinD=Work(ipD)
      MaxDB=Work(ipDB)
      MaxD=Work(ipD)
      Do i=1,l-1
         MinDB=min(MinDB,Work(ipDB+i))
         MinD=min(MinD,Work(ipD+i))
         MaxDB=max(MaxDB,Work(ipDB+i))
         MaxD=max(MaxD,Work(ipD+i))
      End Do

      nNegDB=0
      nNegD=0
      Do i=0,l-1
         If (Work(ipDB+i).lt.0.0d0) nNegDB=nNegDB+1
         If (Work(ipD+i).lt.0.0d0) nNegD=nNegD+1
      End Do

      Write(6,'(/,A,I10)') 'Atom Pair............',iAtomPair
      Write(6,'(A,2I10)')  'Atoms................',
     & AP_Atoms(1,iAtomPair),AP_Atoms(2,iAtomPair)
      Write(6,'(A,I10)')   'Diagonal dimension...',l
      Write(6,'(/,17X,A,10X,A)') 'Original','Current'
      Write(6,'(A,1P,2(1X,D16.6))') 'Norm    ',NormDB,NormD
      Write(6,'(A,1P,2(1X,D16.6))') 'Sum     ',SumDB,SumD
      Write(6,'(A,1P,2(1X,D16.6))') 'Average ',AvgDB,AvgD
      Write(6,'(A,1P,2(1X,D16.6))') 'Std Dev ',StdDevDB,StdDevD
      Write(6,'(A,1P,2(1X,D16.6))') 'Min     ',MinDB,MinD
      Write(6,'(A,1P,2(1X,D16.6))') 'Max     ',MaxDB,MaxD
      Write(6,'(A,7X,I10,7X,I10)')  'Negative',nNegDB,nNegD
      Call xFlush(6)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RDDBUF(DIAG,BUF,IBUF,INDRSH,INDRED,LENBUF,LMMBSTRT,NDUMP)
!
! Purpose: read diagonal from disk and set first reduced set indices.

use Cholesky, only: iiBstR, iiBstRsh, iSP2F, lBuf, LuPri, LuScr
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: Diag(*)
integer(kind=iwp), intent(in) :: LENBUF, LMMBSTRT, NDUMP
real(kind=wp), intent(out) :: BUF(LENBUF)
integer(kind=iwp), intent(out) :: IBUF(4,LENBUF), INDRSH(LMMBSTRT), INDRED(LMMBSTRT,3)
integer(kind=iwp) :: IAB, IDUMP, ISHLAB, ISYMAB, IUNIT, L, LENGTH
character(len=*), parameter :: SECNAM = 'CHO_RDDBUF'

if (LENBUF < LBUF) then
  write(LUPRI,'(//,1X,A,A)') SECNAM,': LENBUF >= LBUF required!'
  write(LUPRI,'(1X,A,I10)') 'LENBUF = ',LENBUF
  write(LUPRI,'(1X,A,I10,/)') 'LBUF   = ',LBUF
  call CHO_QUIT('Buffer error in '//SECNAM,102)
end if

IUNIT = LUSCR
LUSCR = -1
rewind(IUNIT)

do IDUMP=1,NDUMP
  call CHO_RDBUF(LENGTH,BUF,IBUF,LBUF,IUNIT)
  if (IDUMP == NDUMP) call CHO_CLOSE(IUNIT,'DELETE')
  do L=1,LENGTH
    if (IBUF(2,L) > 0) then
      ISHLAB = IBUF(1,L)
      ISYMAB = IBUF(3,L)
      IAB = IIBSTR(ISYMAB,1)+IIBSTRSH(ISYMAB,ISHLAB,1)+IBUF(2,L)
      DIAG(IAB) = BUF(L)
      INDRSH(IAB) = ISP2F(ISHLAB)
      INDRED(IAB,1) = IBUF(4,L)
    end if
  end do
end do

end subroutine CHO_RDDBUF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!----------------------------------------------------------------------*
! Compute rotation matrix for this specific solvent.                   *
!----------------------------------------------------------------------*
subroutine TransRot(Cordst,i,Rot,xt,yt,zt,Ax,Ay,Az)

use qmstat_global, only: nCent
use Constants, only: Zero, One, Ten, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Cordst(3,3), Ax, Ay, Az
integer(kind=iwp), intent(in) :: i
real(kind=wp), intent(out) :: Rot(3,3), xt, yt, zt
integer(kind=iwp) :: IFLAG
real(kind=wp) :: A, ANORM, DELR, DEL(3), TAL, XA(3), XH(3), XO(3)
#include "warnings.h"

XO(1) = CORDST(1,1)-AX
XO(2) = CORDST(2,1)-AY
XO(3) = CORDST(3,1)-AZ
XH(1) = CORDST(1,2)-AX
XH(2) = CORDST(2,2)-AY
XH(3) = CORDST(3,2)-AZ
XA(1) = CORDST(1,3)-AX
XA(2) = CORDST(2,3)-AY
XA(3) = CORDST(3,3)-AZ
DEL = (XH+XA)*Half-XO
DELR = DEL(1)**2+DEL(2)**2+DEL(3)**2
DELR = DELR-1.225449_wp
!This is a check of the water geometry.
!If we enter here, something is wrong.
if (abs(DELR) > 1.0e-4_wp) then
  write(u6,*) 'Molecule',((i-1)/nCent)+1
  write(u6,*) ' WARNING IN TRANSROT ','delr',delr
  write(u6,*) ' O',XO
  write(u6,*) ' H',XH
  write(u6,*) ' A',XA
  call Quit(_RC_GENERAL_ERROR_)
end if
XT = XO(1)+0.3_wp/1.107_wp*DEL(1)
YT = XO(2)+0.3_wp/1.107_wp*DEL(2)
ZT = XO(3)+0.3_wp/1.107_wp*DEL(3)
ROT(1,3) = (XO(1)-XT)/0.3_wp
ROT(2,3) = (XO(2)-YT)/0.3_wp
ROT(3,3) = (XO(3)-ZT)/0.3_wp
ROT(:,2) = (XH-XA)/2.86_wp
ANORM = One/sqrt(ROT(1,3)**2+ROT(2,3)**2+ROT(3,3)**2)
ROT(:,3) = ROT(:,3)*ANORM
ANORM = One/sqrt(ROT(1,2)**2+ROT(2,2)**2+ROT(3,2)**2)
ROT(:,2) = ROT(:,2)*ANORM
ROT(1,1) = One-ROT(1,3)**2-ROT(1,2)**2
if (ROT(1,1) < Zero) ROT(1,1) = Zero
ROT(1,1) = sqrt(ROT(1,1))
ROT(2,1) = One-ROT(2,2)**2-ROT(2,3)**2
if (ROT(2,1) < Zero) ROT(2,1) = Zero
ROT(2,1) = sqrt(ROT(2,1))
ROT(3,1) = One-ROT(3,3)**2-ROT(3,2)**2
if (ROT(3,1) < Zero) ROT(3,1) = Zero
ROT(3,1) = sqrt(ROT(3,1))

IFLAG = 0
do
  TAL = ROT(1,1)*ROT(1,2)+ROT(2,1)*ROT(2,2)+ROT(3,1)*ROT(3,2)
  ROT(:,1) = ROT(:,1)-TAL*ROT(:,2)
  TAL = ROT(1,1)*ROT(1,3)+ROT(2,1)*ROT(2,3)+ROT(3,1)*ROT(3,3)
  ROT(:,1) = ROT(:,1)-TAL*ROT(:,3)
  A = One/sqrt(ROT(1,1)**2+ROT(2,1)**2+ROT(3,1)**2)
  ROT(:,1) = ROT(:,1)*A
  IFLAG = IFLAG+1
  if (IFLAG > 3) then
    write(u6,*) ' STOP IN TRANSROT'
    call Quit(_RC_GENERAL_ERROR_)
  end if
  if (A <= Ten) exit
end do

return

end subroutine TransRot

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_O4_Drv(irc,EMP2,CMO,EOcc,EVir)
!
! Thomas Bondo Pedersen, Jan. 2008.
! - based on ChoMP2_Drv() by T. B. Pedersen.
!
! Purpose: driver for computing the MP2 energy correction EMP2
!          using Cholesky decomposed two-electron integrals
!          in a quartic scaling fashion.
!          Input must have been processed and MO coefficients
!          and orbital energies must be passed as arguments.
!
! Notes:
!
!   - all MO Cholesky vector files generated here are deleted before
!     exit, except for error terminations (i.e. no cleanup actions
!     are taken!)

use Symmetry_Info, only: Mul
use Cholesky, only: nBas, nSym
use ChoMP2, only: iOcc, iT1am, iVir, nOcc, nT1am, nVir, Verbose
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(out) :: EMP2
real(kind=wp), intent(in) :: CMO(*), EOcc(*), EVir(*)
integer(kind=iwp) :: a, ai, i, iSym, iSyma, iSymb, iSymi, iTyp, kD0, kD1, kD2, lDiag, lU_AO(8)
real(kind=wp) :: CPUBT1, CPUBT2, CPUDec1, CPUDec2, CPUIni1, CPUIni2, CPUTot1, CPUTot2, CPUTra1, CPUTra2, DE, Ei, FracMem, WallBT1, &
                 WallBT2, WallDec1, WallDec2, WallIni1, WallIni2, WallTot1, WallTot2, WallTra1, WallTra2
logical(kind=iwp) :: Delete, DoAmpDiag
character(len=3) :: BaseName_AO
real(kind=wp), allocatable :: Check(:), Diag(:)
integer(kind=iwp), parameter :: iFmt = 0
real(kind=wp), parameter :: Chk_Mem_ChoMP2 = 0.123456789_wp, Tol = 1.0e-15_wp
logical(kind=iwp), parameter :: Delete_def = .true.
character(len=*), parameter :: SecNam = 'ChoMP2_O4_Drv'

#ifdef _DEBUGPRINT_
Verbose = .true.
#endif
if (Verbose) call CWTime(CPUTot1,WallTot1)

! Initializations.
! ----------------

irc = 0

EMP2 = Zero

if (Verbose) call CWTime(CPUIni1,WallIni1)

call mma_allocate(Check,1,Label='Check')
Check(1) = Chk_Mem_ChoMP2

FracMem = Zero ! no buffer allocated
call Cho_X_Init(irc,FracMem)
if (irc /= 0) then
  write(u6,*) SecNam,': Cho_X_Init returned ',irc
  call SysAbendMsg(SecNam,'Cholesky initialization error',' ')
end if

!-TBP:
! Frankie,
! The setup is still the same here (i.e. batching etc. is included)
! I don't use the batching info at all, though, so it should be save
! to remove it - unless you need it, of course.

call ChoMP2_Setup(irc)
if (irc /= 0) then
  write(u6,*) SecNam,': ChoMP2_Setup returned ',irc
  call Finish_this()
  return
end if

if (Verbose) then
  call ChoMP2_Setup_Prt(irc)
  if (irc /= 0) then
    write(u6,*) SecNam,': ChoMP2_Setup_Prt returned ',irc
    call Finish_this()
    return
  end if
  call CWTime(CPUIni2,WallIni2)
  call Cho_PrtTim('Cholesky MP2 initialization',CPUIni2,CPUIni1,WallIni2,WallIni1,iFmt)
end if

! Transform Cholesky vectors directly from reduced set to MO
! representation. Result vectors are stored on disk.
! Compute also amplitude diagonal here.
! ----------------------------------------------------------

if (Verbose) call CWTime(CPUTra1,WallTra1)

lDiag = sum(nT1am(1:nSym))

call mma_allocate(Diag,lDiag,Label='Diag')

call ChoMP2_TraDrv(irc,CMO,Diag,.true.)
if (irc /= 0) then
  write(u6,*) SecNam,': ChoMP2_TraDrv returned ',irc
  call Finish_this()
  return
end if
kD0 = 0
do iSym=1,nSym
  do iSymi=1,nSym
    iSyma = Mul(iSymi,iSym)
    kD1 = kD0+iT1Am(iSyma,iSymi)
    do i=1,nOcc(iSymi)
      kD2 = kD1+nVir(iSyma)*(i-1)
      Ei = EOcc(iOcc(iSymi)+i)
      do a=1,nVir(iSyma)
        ai = kD2+a
        DE = Two*(EVir(iVir(iSyma)+a)-Ei)
        Diag(ai) = Diag(ai)/DE
      end do
    end do
  end do
  kD0 = kD0+nT1Am(iSym)
end do

if (Verbose) then
  call CWTime(CPUTra2,WallTra2)
  call Cho_PrtTim('Cholesky MP2 transformation',CPUTra2,CPUTra1,WallTra2,WallTra1,iFmt)
end if

! Decompose MP2 amplitudes (times -1).
! ------------------------------------

if (Verbose) call CWTime(CPUDec1,WallDec1)

!-TBP:
! Frankie,
! I just modified the decomposition slightly so that it treats
! amplitudes, too. You should be aware, though, that result vectors
! are always written on the same files, so if you do another
! decomposition of, say, integrals (or squared integrals), then
! the vector files will be overwritten!!
! The number of vectors is always written to nMP2Vec(iSym) in
! ChoMP2 - this is overwritten too, if you do another CD!!

Delete = Delete_def ! delete transf. vector files after dec.
call ChoMP2_DecDrv(irc,Delete,Diag,'Amplitudes')
if (irc /= 0) then
  write(u6,*) SecNam,': ChoMP2_DecDrv returned ',irc
  call SysAbendMsg(SecNam,'MP2 decomposition failed!',' ')
end if
call mma_deallocate(Diag)

if (Verbose) then
  call CWTime(CPUDec2,WallDec2)
  call Cho_PrtTim('Cholesky MP2 decomposition',CPUDec2,CPUDec1,WallDec2,WallDec1,iFmt)
end if

! Backtransform amplitude vectors to AO basis.
! Calculate also backtransformed amplitude diagonal.
! --------------------------------------------------

if (Verbose) call CWTime(CPUBT1,WallBT1)

iTyp = 2 ! type of MO vectors (i.e. amp. vectors)
Delete = Delete_def ! delete amp. vectors after backtransf.
BaseName_AO = 'AAO' ! basename for multifiles of AO vectors
DoAmpDiag = .true. ! calculate backtransf. amp. diagonal
lDiag = 0
do iSym=1,nSym
  do iSymb=1,nSym
    iSyma = Mul(iSymb,iSym)
    lDiag = lDiag+nBas(iSyma)*nBas(iSymb)
  end do
end do

call mma_allocate(Diag,lDiag,Label='Diag')
call ChoMP2_VectorMO2AO(iTyp,Delete,BaseName_AO,CMO,DoAmpDiag,Diag,lDiag,lU_AO,irc)
if (irc /= 0) then
  write(u6,*) SecNam,': ChoMP2_VectorMO2AO returned ',irc
  call SysAbendMsg(SecNam,'MP2 amplitude vector backtransformation failed!',' ')
end if
call mma_deallocate(Diag)

if (Verbose) then
  call CWTime(CPUBT2,WallBT2)
  call Cho_PrtTim('Cholesky MP2 backtransformation',CPUBT2,CPUBT1,WallBT2,WallBT1,iFmt)
end if

!-TBP:
! Frankie,
! You can now read the AO vectors from the units lU_AO(iSym)
! using ddaFile(). The files are word-addressable so that it
! is possible to read from the file as if addressing an array.
! The number of vectors is nMP2Vec(iSym) stored in ChoMP2.
! To save memory, you may want to finalize Cholesky info before
! continuing with the backtransformed vectors - but remember
! that all Cholesky information (from the AO integral CD) is
! then lost (f.ex. NumCho(iSym) becomes useless).

! Finalize Cholesky info.
! -----------------------

call Cho_X_Final(irc)
if (irc /= 0) then
  write(u6,*) SecNam,': Cho_X_Final returned ',irc
  call Finish_this()
  return
end if

! Close and delete files containing backtransformed amplitude vectors.
! --------------------------------------------------------------------

do iSym=1,nSym
  call daEras(lU_AO(iSym))
end do

call Finish_this()

contains

! Exit.
! -----
subroutine Finish_this()

  real(kind=wp) :: Diff

  Diff = abs(Check(1)-Chk_Mem_ChoMP2)
  if (Diff > Tol) then
    write(u6,*) SecNam,': Memory Boundary Error!'
    if (irc == 0) irc = -9999
  end if
  if (Verbose) then
    call CWTime(CPUTot2,WallTot2)
    call Cho_PrtTim('Cholesky MP2',CPUTot2,CPUTot1,WallTot2,WallTot1,iFmt)
  end if

  call mma_deallocate(Check)

end subroutine Finish_this

end subroutine ChoMP2_O4_Drv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_GetQD(QD)
C
C     Purpose: copy qualified diagonal elements from global diagonal to
C              array QD.
C
      Implicit None
      Real*8 QD(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "choglob.fh"
#include "WrkSpc.fh"

      Integer kQD, kD, iSym, iQ, iAB
      Integer IndRed_G, iQuAB, i, j

      IndRed_G(i,j)=iWork(ip_IndRed_G-1+mmBstRT_G*(j-1)+i)
      iQuAB(i,j)=iWork(ip_iQuAB-1+MaxQual*(j-1)+i)

      kQD = 0
      kD = ip_Diag_G - 1
      Do iSym = 1,nSym
         Do iQ = 1,nQual(iSym)
            iAB = IndRed_G(iQuAB(iQ,iSym),2)
            QD(kQD+iQ) = Work(kD+iAB)
         End Do
         kQD = kQD + nQual(iSym)
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Cholesky_Vectors(ITK,ITQ,JSYM,Array,mArray,nArray,IBSTA,IBEND)

use CHOVEC_IO, only: IDLOC_CHOGROUP, NPQ_CHOTYPE, NVLOC_CHOBATCH
use caspt2_global, only: LUDRA
use caspt2_module, only: NSYM
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ITK, ITQ, JSYM, mArray, IBSTA, IBEND
real(kind=wp), intent(out) :: Array(mArray)
integer(kind=iwp), intent(out) :: nArray
integer(kind=iwp) :: IB, ICASE, IDISK, ISYK, LKETSM, NKETSM, NQK, NV

! ugly hack to convert separate k/q orbital types into a specific case
ICASE = ITK*ITQ
if (ICASE == 3) then
  ICASE = 4
else
  ICASE = ICASE/2
end if

LKETSM = 1
do ISYK=1,NSYM
  NQK = NPQ_CHOTYPE(ICASE,ISYK,JSYM)
  if (NQK == 0) cycle
  do IB=IBSTA,IBEND
    NV = NVLOC_CHOBATCH(IB)
    NKETSM = NQK*NV
    IDISK = IDLOC_CHOGROUP(ICASE,ISYK,JSYM,IB)
    call DDAFILE(LUDRA,2,Array(LKETSM),NKETSM,IDISK)
    LKETSM = LKETSM+NKETSM
  end do
end do
nArray = LKETSM-1

end subroutine Get_Cholesky_Vectors

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ConvdFdRho(mGrid,dF_dRho,ndF_dRho,RhoI,RhoA,mRho)
      Implicit Real*8 (A-H,O-Z)
      Dimension dF_dRho(ndF_dRho,mGrid)
      Dimension RhoI(mRho,mGrid),RhoA(mRho,mGrid)
*
      If (mRho.eq.1) Then
        Do iGrid=1,mGrid
         dFdRho = dF_dRho(1,iGrid)
         dFdP2  = dF_dRho(2,iGrid)
*
         dF_dRho(1,iGrid)= dFdRho + RhoI(1,iGrid)*dFdP2
         dF_dRho(2,iGrid)= RhoA(1,iGrid)*dFdP2/2.0d0
        End Do
      Else If (mRho.eq.4) Then
        Do iGrid=1,mGrid
         dFdRho = dF_dRho(1,iGrid)
         dFdRhox= dF_dRho(3,iGrid)
         dFdRhoy= dF_dRho(5,iGrid)
         dFdRhoz= dF_dRho(7,iGrid)
         dFdP2  = dF_dRho(2,iGrid)
         dFdP2x = dF_dRho(4,iGrid)
         dFdP2y = dF_dRho(6,iGrid)
         dFdP2z = dF_dRho(8,iGrid)
*
         dF_dRho(1,iGrid)=dFdRho +
     &        RhoI(1,iGrid)*dFdP2  +
     &       (RhoI(2,iGrid)*dFdP2x + RhoI(3,iGrid)*dFdP2y +
     &        RhoI(4,iGrid)*dFdP2z)*2.0d0*1.0d0
         dF_dRho(3,iGrid)=dFdRhox + RhoI(1,iGrid)*dFdP2x
         dF_dRho(5,iGrid)=dFdRhoy + RhoI(1,iGrid)*dFdP2y
         dF_dRho(7,iGrid)=dFdRhoz + RhoI(1,iGrid)*dFdP2z
*
         dF_dRho(2,iGrid)=
     &       RhoA(1,iGrid)*dFdP2/2.0d0 +
     &       (RhoA(2,iGrid)*dFdP2x + RhoA(3,iGrid)*dFdP2y +
     &       RhoA(4,iGrid)*dFdP2z)*1.0d0
         dF_dRho(4,iGrid)=RhoA(1,iGrid)*dFdP2x/2.0d0
         dF_dRho(6,iGrid)=RhoA(1,iGrid)*dFdP2y/2.0d0
         dF_dRho(8,iGrid)=RhoA(1,iGrid)*dFdP2z/2.0d0
        End Do
      Else
        Call WarningMessage(2,'Somethings is wrong in ConvdFdRho')
         Call Abend()
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine CmpInt(XInt,nInt,nBas,nIrrep,Label)
************************************************************************
*                                                                      *
* Object: to remove the offdiagonal nonzero blocks of matrix elements  *
*         for an operator.                                             *
*                                                                      *
*         XInt(1:nInt):array with nonzero elements                     *
*                                                                      *
*         nBas(0:nIrrep-1):number of basis functions in each irrep     *
*                                                                      *
*         Label: symmetry label of the operator for which the          *
*                matrix elements where computed.                       *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             March 1991                                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 XInt(nInt+4)
      Integer nBas(0:nIrrep-1)
*
      iCmp = 1
      iExp = 1
      Do 10 iIrrep = 0, nIrrep-1
         Do 20 jIrrep = 0, iIrrep
            ij = iEor(iIrrep,jIrrep)
            If (iAnd(Label,2**ij).eq.0) Go To 20
            If (iIrrep.eq.jIrrep) Then
               Len = nBas(iIrrep)*(nBas(iIrrep)+1)/2
               Do 30 iLen = 0, Len-1
                  XInt(iLen+iCmp) = Xint(iLen+iExp)
 30            Continue
               iCmp = iCmp + Len
               iExp = iExp + Len
            Else
               Len = nBas(iIrrep)*nBas(jIrrep)
               iExp = iExp + Len
            End If
 20      Continue
 10   Continue
      do 40 iadd=0,3
        XInt(iCmp+iadd)=XInt(iExp+iadd)
 40   continue
      nInt = iCmp-1
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Put_Coord_New
*
*> @brief
*>   Write the updated/new symmetry unique Cartesian coordinates of the basis set centers on the runfile
*> @author R. Lindh
*>
*> @details
*> The utility will write updated/new symmetry unique Cartesian coordinates of the basis set centers on the runfile.
*>
*> @param[in] Coord  Array of the updated/new symmetry unique Cartesian coordinates of the basis set centers
*> @param[in] nAtoms Number of symmetry unique basis set centers
************************************************************************
      Subroutine Put_Coord_New(Coord,nAtoms)
      Implicit Real*8 (a-h,o-z)

      Real*8       Coord(3,nAtoms)
      Character*24 Label

      Label='GeoNew'
      Call Put_dArray(Label,Coord,3*nAtoms)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine GeoNew(Print)
************************************************************************
*                                                                      *
* Object: to pick up the geometry from a special file. This will only  *
*         make any difference of there exist a file otherwise SEWARD   *
*         will use the geometry as specified by the standard input     *
*         file.                                                        *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             March 1991                                               *
************************************************************************
      use Basis_Info
      Implicit Real*8 (A-H,O-Z)
      Logical Print
#include "real.fh"
#include "stdalloc.fh"
#include "SysDef.fh"
      Logical Exist
      Real*8, Dimension (:,:), Allocatable :: CN
      Interface
        Subroutine Get_Coord_New(CN,lBuf)
        Real*8, Dimension (:,:), Allocatable :: CN
        Integer lBuf
        End Subroutine
      End Interface

*
*     Prologue
*
*     Check if there is a data field called 'NewGeom'
*
      Call Get_Coord_New(CN,lBuf)
*
*     Quit if the datadfield 'NewGeom' is not available. However,
*     if the field is available on RUNOLD pick it up there.
*
      If ( lBuf.eq.0 ) Then
*
*        Check RUNOLD
*
         Call f_Inquire('RUNOLD',Exist)
         If (Exist) Then
            Call NameRun('RUNOLD')
            Call Get_Coord_New(CN,lBuf)
            If (lBuf.eq.0) Then
               nNuc=0
               Call NameRun('RUNFILE')
               Return
            Else
               Call Get_iScalar('Unique atoms',nNuc)
               Call NameRun('RUNFILE')
               If (Print) Then
                  Write (6,*)
                  Write (6,'(A)') '    Geometry read from RUNOLD'
                  Write (6,*)
               End If
            End If
         Else
            nNuc=0
            Return
         End If
      Else
         Call Get_iScalar('Unique atoms',nNuc)
         If (Print) Then
            Write (6,*)
            Write (6,'(A)') '    Geometry read from RUNFILE'
            Write (6,*)
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Replace coodinates read in subroutine input
*
      iDC = 1
      iNuc = 0
*     Call RecPrt('CN',' ',CN,3,nNuc)
      Do iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%pChrg.and..Not.dbsc(iCnttp)%Frag .and.
     &       .Not.dbsc(iCnttp)%Aux) Then
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               dbsc(iCnttp)%Coor(1:3,iCnt)=CN(1:3,iDC)
               iDC = iDC + 1
               iNuc = iNuc + 1
               If (iNuc.eq.nNuc) Go To 999
            End Do
         End If
      End Do
 999  Continue
*                                                                      *
************************************************************************
*                                                                      *
*     Epilogue, end
*
      Call mma_deallocate(CN)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Arta Safari                                      *
!***********************************************************************

module spin_correlation
  use definitions, only: wp, u6
  use stdalloc, only: mma_allocate, mma_deallocate
  use CI_solver_util, only: rdm_from_runfile
  use rasscf_global, only : LRoots, iAdr15, nacpar, nacpr2
  use index_symmetry, only : one_el_idx_flatten, two_el_idx_flatten
  use general_data, only: JobIPH

  implicit none
  private
  public :: spin_correlation_driver
  integer, allocatable, public, save :: orb_range_p(:), orb_range_q(:)
  integer, public :: same_orbs
  logical, public :: tRootGrad = .false.


contains


  subroutine spin_correlation_driver(orb_range_p, orb_range_q, iroot)
    !! spin-spin-correlation function using orbital-resolved 2RDMs.
    !! For details see Dobrautz et al. 2021, 10.1021/acs.jctc.1c00589.
    integer, intent(in) :: orb_range_p(:), orb_range_q(:), iroot(:)
    real(wp), allocatable :: spin_correlations(:)
    real(wp) :: dmat(nacpar), dspn(nacpar), pamat(nacpr2), psmat(nacpr2)
    integer :: jDisk, i, j
    logical :: disk_pointer_moved

    jDisk = iAdr15(3)
    call mma_allocate(spin_correlations, size(iroot))
    spin_correlations(:) = 0.0_wp

    ! the following disk pointer logic is necessary, because a user may
    ! optimise less roots than included in the Davidson matrix, e.g.
    ! roots (1, 2, 5, 8, 10). In &RASSCF RDMs for all Lroots
    ! will be computed, hence the memory reference here needs to be
    ! incremented accordingly to compute the SSCR for the correct roots.

    write(u6,'(a)') new_line('a')
    do i = 1, LRoots
      disk_pointer_moved = .False.
      do j = 1, size(iroot)
        if (iroot(j) == i) then
          call rdm_from_runfile(dmat, dspn, psmat, pamat, jDisk)
          disk_pointer_moved = .true.
          spin_correlations(j) = correlation_func(orb_range_p, orb_range_q, &
                                                  dmat, psmat, pamat)
          write(u6,'(a,i2,a,f12.8)') '::    RASSCF root number ', iroot(j), &
            ' Spin Correlation:  ', spin_correlations(j)
        end if
      end do
      if (.not. disk_pointer_moved) then
        ! dummy write to move jDisk pointer
        call ddafile(JOBIPH, 0, dmat, NACPAR, jDisk)
        call ddafile(JOBIPH, 0, dspn, NACPAR, jDisk)
        call ddafile(JOBIPH, 0, psmat, NACPR2, jDisk)
        call ddafile(JOBIPH, 0, pamat, NACPR2, jDisk)
      end if
    end do

    ! for testing purposes
    call Add_Info('spin correlation', spin_correlations(1), 1, 8)

    call mma_deallocate(spin_correlations)
  end subroutine spin_correlation_driver


  real(wp) function correlation_func(orb_range_p, orb_range_q, &
                                     dmat, psmat, pamat) result(corr)
    !! extract spin-spin-correlation function from orbital resolved RDMs.
    integer, intent(in) :: orb_range_p(:), orb_range_q(:)
    real(wp), intent(in) :: dmat(nacpar), psmat(nacpr2), pamat(nacpr2)
    integer :: rp, rq, p, q, pp, pppp, pqqp, ppqq
    real(wp) :: twordm_pqqp, twordm_ppqq, twordm_pppp, onerdm_pp

    corr = 0.0_wp

    do p = 1, size(orb_range_p)
      do q = 1, size(orb_range_q)
        ! dummy variables to save space
        rp = orb_range_p(p); rq = orb_range_q(q)
        if (rp /= rq) then
          pqqp = two_el_idx_flatten(rp, rq, rq, rp)
          ppqq = two_el_idx_flatten(rp, rp, rq, rq)
          twordm_pqqp = psmat(pqqp) - pamat(pqqp)
          twordm_ppqq = 2 * (psmat(ppqq) + pamat(ppqq))

          corr = corr - 0.5_wp * (twordm_pqqp + 0.5_wp * twordm_ppqq)
        else
          pppp = two_el_idx_flatten(rp, rp, rp, rp)
          pp = one_el_idx_flatten(rp, rp)

          twordm_pppp = 2 * (psmat(pppp) + pamat(pppp))
          onerdm_pp = dmat(pp)
          corr = corr + 0.75_wp * (onerdm_pp - twordm_pppp)
        end if
      end do
    end do
  end function correlation_func

end module spin_correlation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine pack210 (a,b,dimpq,dimp,rc)
c
c     this routine do: B(pq) = A(p,q) - A(q,p) for symp=symq
c
       integer dimp,dimpq,rc
       real*8 a(1:dimp,1:dimp)
       real*8 b(1:dimpq)
c
c     help variables
c
       integer p,q,pq
c
       rc=0
       if (dimp.gt.1) then
c
       pq=0
       do 100 p=2,dimp
       do 101 q=1,p-1
       pq=pq+1
       b(pq)=a(p,q)-a(q,p)
 101    continue
 100    continue
c
       else
c     RC=1 : dimp is less than 2
       rc=1
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DerHEff(nConf,nRoots,nState,CLag,VECROT)

use Index_Functions, only: nTri3_Elem
use caspt2_global, only: IDTCEX, LUCIEX
use EQSOLV, only: IVECC, IVECW
use caspt2_module, only: ISCF, JSTATE, MXCI, NASHT, STSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nConf, nRoots, nState
real(kind=wp), intent(inout) :: CLag(nConf,nRoots)
real(kind=wp), intent(in) :: VECROT(nState)
integer(kind=iwp) :: I, IDCI, IST, JST, NTG1, NTG2, NTG3
real(kind=wp) :: DUMMY(1), OVL
real(kind=wp), allocatable :: CI1(:), CI2(:), CI3(:), DTG1(:), DTG2(:), DTG3(:)

!return

! We evaluate the effective Hamiltonian matrix element in two steps.

NTG1 = NASHT**2
NTG2 = NASHT**4
NTG3 = nTri3_Elem(NTG1)
! Note: Need proper allocation even if unused, sinced allocated
! arrays are in subroutine parameter lists of MKTG3, HCOUP.
NTG1 = max(1,NTG1)
NTG2 = max(1,NTG2)
NTG3 = max(1,NTG3)
call mma_allocate(DTG1,NTG1,Label='DTG1')
call mma_allocate(DTG2,NTG2,Label='DTG2')
call mma_allocate(DTG3,NTG3,Label='DTG3')
DTG1(:) = Zero
DTG2(:) = Zero
DTG3(:) = Zero

!! OVL will contain the derivative contribution?
!! It should be ignored
OVL = Zero
call DerHeffX(IVECW,IVECC,NASHT,NTG3,OVL,DTG1,DTG2,DTG3)

call mma_allocate(CI1,MXCI,Label='MCCI1')
call mma_allocate(CI2,MXCI,Label='MCCI2')
call mma_allocate(CI3,MXCI,Label='MCCI3')

if (ISCF == 0) then
  JST = jState
  CI1(1:NCONF) = Zero
  do I=1,NSTATE
    IDCI = IDTCEX(I)
    IST = I
    if (IST == JST) then
      call DDAFILE(LUCIEX,2,CI2,NCONF,IDCI)
    else if (abs(VECROT(IST)) <= 1.0e-12_wp) then
      call DDAFILE(LUCIEX,0,DUMMY,NCONF,IDCI)
    else
      call DDAFILE(LUCIEX,2,CI3,NCONF,IDCI)
      CI1(1:NCONF) = CI1(1:NCONF)+VECROT(IST)*CI3(1:NCONF)
    end if
  end do

  CI3(1:NCONF) = Zero
  call DERTG3(.true.,STSYM,STSYM,NCONF,NASHT,CI1,CI2,OVL,DTG1,DTG2,NTG3,DTG3,CI3,CLag(1,JST))

  do I=1,NSTATE
    IST = I
    if (IST == JST) then
      cycle
    else if (abs(VECROT(IST)) <= 1.0e-12_wp) then
      cycle
    else
      CLag(1:NCONF,IST) = CLag(1:NCONF,IST)+VECROT(IST)*CI3(1:NCONF)
    end if
  end do
end if

call mma_deallocate(CI1)
call mma_deallocate(CI2)
call mma_deallocate(CI3)

call mma_deallocate(DTG1)
call mma_deallocate(DTG2)
call mma_deallocate(DTG3)

end subroutine DerHEff

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine CCT3(ireturn)
c
c     this program calculate noniterative T3 contributions
c     to CCSD energy
c
      use Para_Info, only: MyRank, nProcs
#include "t31.fh"
#include "t32.fh"
c
c     work file declaration
       integer wrksize
#include "WrkSpc.fh"
c
c     variables
c
       real*8 eccsd,eaaa(1),eaab(1),eabb(1),ebbb(1),ec
       integer i,j,k,i3,j3,k3,symi,symj,symk,symi3,symj3,symk3
       integer symijk,symij
       integer nsg,keyyes,rc1,jup,ilow,posst,ssl1,ssl2,ssm1,ssm2
       integer symjstart,symjstop
       integer jstart,jstop,istart,istop
cpar
       integer id,counter
c
c       integer nhelp
c
c
cpar
cstare Call SetTim
cstare call MPI_COMM_RANK(MPI_COMM_WORLD,myRank,rc)
cstare call MPI_COMM_SIZE(MPI_COMM_WORLD,nProcs,rc)

cI    **************  start   section **************
c
cI.1  read input data form INPDAT (reorg) and input file
      fullprint=0
      If (iPrintLevel(-1).LE.0) fullprint=-1
      If (fullprint.GE.0) then
         Write(6,*)
         Write(6,*)' **********************************'
         Write(6,*)'  Triples Contribution Calculation '
         Write(6,*)' **********************************'
         Write(6,*)
      EndIf
      call t3reainput
c
cI.2  write head to output file
      If (fullprint.GE.0) call t3wrhead
c
cI.3.1 calc. work space requirements to fix and help mediates
      call t3initfiles (wrksize)
      If (fullprint.GE.0)
     & write(6,*) ' Work space requirements :',wrksize
c
cI.3.2 allocate work space
c
      Call GetMem('CCT3','Max','Real',maxspace,maxspace)
      maxspace=maxspace-4
      if (maxspace.lt.wrksize) then
         write(6,*) ' Allocation of work space failed',maxspace
         write(6,*) ' Increase the value of the variable MOLCAS_MEM'
         Call Abend()
      end if
      Call GetMem('CCT3','Allo','Real',iOff,wrksize)
c
cI.3.3 set wrk = 0
      call cct3_mv0zero (wrksize,wrksize,Work(iOff))
      If (fullprint.GE.0) write(6,*) ' Allocation of work space : Done'
c
cI.4  read static integrals from INTSTA (reorg) file
      call t3reaintsta (Work(iOff),wrksize)
c
cI.5  divide fok to faa,fai,fii and dp
      call cct3_divfok (Work(iOff),wrksize,
     & mapdn,mapin,possn0,mapdp,mapip,possp0,
     & mapdfk1,mapifk1,possfk10,mapdfk2,mapifk2,possfk20,
     & mapdfk3,mapifk3,possfk30,mapdfk4,mapifk4,possfk40,
     & mapdfk5,mapifk5,possfk50,mapdfk6,mapifk6,possfk60,
     & mapddp1,mapidp1,possdp10,mapddp2,mapidp2,possdp20,rc1)
c
cI.6  read CCSD energy and amplitudes
      call t3reaccsd (Work(iOff),wrksize,
     & eccsd)
c
cI.7  get address vector T3IntPos
c       they are located at the beggining of the t3nam file
      call GetIntPoss
c
cI.*  set energies=0
      eaaa=0.0d0
      eaab=0.0d0
      eabb=0.0d0
      ebbb=0.0d0
c
cI.par initialize parallel counter
      counter=0
c
c
c     ***** work section *****
c
c
      if (ijsegkey.eq.0) then
cNo Segmentation
         symimin=1
         symimax=nsym
      end if
c
cSegmented
cnoseg do 1400 symi=1,nsym
      do 1400 symi=symimin,symimax
       if (noa(symi).eq.0) then
       goto 1400
       end if
c
c      def symjstart,symjstop
c
       if (ijsegkey.eq.0) then
cNo Segmentation
          symjstart=1
          symjstop=symi
       else
c
cSegmented
       if (symimin.eq.symjmax) then
c      case symimin=symi=symimax
         symjstart=symjmin
         symjstop=symjmax
       else
c      case symimin<symjmax
c
         if(symi.eq.symimin) then
           symjstart=symjmin
           symjstop=symi
         else if (symi.eq.symimax) then
           symjstart=1
           symjstop=symjmax
         else
cc       sub case symimin<symi<symimax
           symjstart=1
           symjstop=symi
         end if
c
       end if
       end if
c
c
cnoseg do 1300 symj=1,symi
       do 1300 symj=symjstart,symjstop
       if ((symi.eq.symj).and.(noa(symi).le.1)) then
       goto 1300
       else if (noa(symj).eq.0) then
       goto 1300
       end if
c
c*    define sym(ij)
       symij=mmul(symi,symj)
c
c*    write symmetry starus of I and J
       if (fullprint.gt.0) then
       write(6,*) ' SYMI',symi,'SYMJ',symj
       end if
c
c
       if (symi.eq.symj) then
       ilow=2
       else
       ilow=1
       end if
c
c
c*    loop over inex I
c
c       define istart,istop
c
       if (ijsegkey.eq.0) then
cNo Segmentation
          istart=ilow
          istop=noa(symi)
       else
c
cSegmented
        if ((symi.eq.symimin).and.(symj.eq.symjmin)) then
          istart=imin
        else
          istart=ilow
        end if
c
        if ((symi.eq.symimax).and.(symj.eq.symjmax)) then
          istop=imax
        else
          istop=noa(symi)
        end if
c
       end if
c
cnoseg    do 1200 i=ilow,noa(symi)
          do 1200 i=istart,istop
c
c*    get integrals <ab|ic> for given i into R1(a,bc)
       call cct3_getint (Work(iOff),wrksize,
     & i,symi,possr10,mapdr1,mapir1,rc1)
c
c*    def upper limit for index j
       if (symi.eq.symj) then
       jup=i-1
       else
       jup=noa(symj)
       end if
c
c
c*    loop over index J
c
c*      def jstart,jstop
c
       if (ijsegkey.eq.0) then
cNo Segmentation
          jstart=1
          jstop=jup
       else
c
cSegmented
         if ((symimin.eq.symimax).and.(symjmin.eq.symjmax)) then
c        we are in the only symmetry block taken
c        into the consideration
           if (imin.eq.imax) then
              jstart=jmin
              jstop=jmax
           else if (i.eq.imin) then
              jstart=jmin
              jstop=jup
           else if (i.eq.imax) then
              jstart=1
              jstop=jmax
           else
              jstart=1
              jstop=jup
           end if
         else if ((symi.eq.symimin).and.(symj.eq.symjmin)) then
c        we are in initial symmetry block
           if (i.eq.imin) then
             jstart=jmin
             jstop=jup
           else
             jstart=1
             jstop=jup
           end if
         else if ((symi.eq.symimax).and.(symj.eq.symjmax)) then
c        we are in terminal symmetry block
           if (i.eq.imax) then
             jstart=1
             jstop=jmax
           else
             jstart=1
             jstop=jup
           end if
         else
c        we are in intermediate symmetry block
           jstart=1
           jstop=jup
         end if
c
       end if
c
c
cnoseg do 1200 j=1,jup
       do 1201 j=jstart,jstop
c
c*    get integrals <ab|jc> for given j into R2(a,bc)
       call cct3_getint (Work(iOff),wrksize,
     & j,symj,possr20,mapdr2,mapir2,rc1)
c
c
       do 1100 symk=1,nsym
       if (noa(symk).eq.0) then
       goto 1100
       end if
c
       if (fullprint.gt.1) then
       write(6,*) ' SYMI',symi,'SYMJ',symj,'SYMK',symk
       end if
c
c*    define sym(ijk)
       symijk=mmul(symij,symk)
c
c
c*    loop over index K
c
       do 1000 k=1,noa(symk)
       if (fullprint.ge.2) then
       write (6,999) i,j,k
999    format (' I,J,K ',3(i3,1x))
       end if
c
cpar    update parallel counter, choose proper id for this 'portion'
c       and skip if this portion is not for myRank
        counter=counter+1
        id=mod(counter,nProcs)
        if (myRank.ne.id) goto 1000
c
c*    get integrals <ab|kc> for given k into R3(a,bc)
       call cct3_getint (Work(iOff),wrksize,
     & k,symk,possr30,mapdr3,mapir3,rc1)
c
c
c1    ***** aaa spin combination *****
c
c
c1*   def keyyes
       if (symj.gt.symk) then
       keyyes=1
       else if (symj.eq.symk) then
       if (j.gt.k) then
       keyyes=1
       else
       keyyes=0
       end if
       else
       keyyes=0
       end if
c
       if (keyyes.eq.1) then
c
c1.*  define maps of W(abc)
       call cct3_t3grc0(3,5,3,3,3,0,symijk,possw0,posst,mapdw,mapiw)
c
c1.*  vanish W(abc)
       call stz (Work(iOff),wrksize,
     & mapdw)
c
c
c1.1  permutations (ijk) P(a,bc) (general sign+)
       nsg=1
c
c
c1.1.1V graph
c
c1.1.1*            def L1(bc,d) <- R3(b,cd) for given k
       call defv (Work(iOff),wrksize,
     & 1,possl10,mapdl1,mapil1,ssl1,
     & mapdr3,mapir3,symk,rc1)
c
c1.1.1*            ext M1(da) <- T2aaaa(da,ij) for given i,j
       call ext(Work(iOff),wrksize,
     & 4,7,i,j,0,symi,symj,0,mapdt21,mapit21,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c1.1.1*            exp M2(d,a) <- M1(da)
       call cct3_expand (Work(iOff),wrksize,
     & 2,1,mapdm1,mapim1,ssm1,possm20,mapdm2,mapim2,
     & rc1)
       ssm2=ssm1
c
c1.1.1*            mult L2(bc,a) <- L1(bc,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c1.1.1*            pack W(abc) <-  P(a,bc) [L2(bc,a)] (minus due to the
c     usung Tikda instead of T2ikad)
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,0,rc1)
c
c1.1.2O graph
c
c1.1.2*            ext L1(bc,l) <- T2aaaa(bc,kl) for given k
       call ext(Work(iOff),wrksize,
     & 4,3,k,0,0,symk,0,0,mapdt21,mapit21,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c1.1.2*     ext M1(l,a) <- W11(l,a,ij)=<la||ij>aaaa for given ij
       call ext(Work(iOff),wrksize,
     & 4,7,i,j,0,symi,symj,0,mapdw11,mapiw11,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c1.1.2*            mult L2(bc,a) <- L1(bc,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c1.1.2*            pack W(abc) <- P(a,bc) [L2(bc,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c
c1.2  permutations (ikj) P(a,bc)
       nsg=-1
c
c
c1.2.1V graph
c
c1.2.1*            def L1(bc,d) <- R2(b,cd) for given j
       call defv (Work(iOff),wrksize,
     & 1,possl10,mapdl1,mapil1,ssl1,
     & mapdr2,mapir2,symj,rc1)
c
c1.2.1*            ext M1(da) <- T2aaaa(da,ik) for given i,k
       call ext(Work(iOff),wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdt21,mapit21,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c1.2.1*            exp M2(d,a) <- M1(da)
       call cct3_expand (Work(iOff),wrksize,
     & 2,1,mapdm1,mapim1,ssm1,possm20,mapdm2,mapim2,
     & rc1)
       ssm2=ssm1
c
c1.2.1*            mult L2(bc,a) <- L1(bc,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c1.2.1*            pack W(abc) <- - P(a,bc) [L2(bc,a)] (minus is due to
c     usung Tikda instead of T2ikad)
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,0,rc1)
c
c1.2.2O graph
c
c1.2.2*            ext L1(bc,l) <- T2aaaa(bc,jl) for given j
       call ext(Work(iOff),wrksize,
     & 4,3,j,0,0,symj,0,0,mapdt21,mapit21,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c1.2.2*     ext M1(l,a) <- W11(l,a,ik)=<la||ik>aaaa for given ik
       call ext(Work(iOff),wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdw11,mapiw11,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c1.2.2*            mult L2(bc,a) <- L1(bc,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c1.2.2*            pack W(abc) <- P(a,bc) [L2(bc,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c
c1.3  permutations (jki) P(a,bc)
       nsg=1
c
c
c1.3.1V graph
c
c1.3.1*            def L1(bc,d) <- R1(b,cd) for given i
       call defv (Work(iOff),wrksize,
     & 1,possl10,mapdl1,mapil1,ssl1,
     & mapdr1,mapir1,symi,rc1)
c
c1.3.1*            ext M1(da) <- T2aaaa(da,jk) for given j,k
       call ext(Work(iOff),wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdt21,mapit21,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c1.3.1*            exp M2(d,a) <- M1(da)
       call cct3_expand (Work(iOff),wrksize,
     & 2,1,mapdm1,mapim1,ssm1,possm20,mapdm2,mapim2,
     & rc1)
       ssm2=ssm1
c
c1.3.1*            mult L2(bc,a) <- L1(bc,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c1.3.1*            pack W(abc) <- - P(a,bc) [L2(bc,a)] (minus is due to
c     usung Tjkda instead of T2jkad)
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,0,rc1)
c
c1.3.2O graph
c
c1.3.2*            ext L1(bc,l) <- T2aaaa(bc,kl) for given i
       call ext(Work(iOff),wrksize,
     & 4,3,i,0,0,symi,0,0,mapdt21,mapit21,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c1.3.2*     ext M1(l,a) <- W11(l,a,jk)=<la||jk>aaaa for given jk
       call ext(Work(iOff),wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdw11,mapiw11,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c1.3.2*            mult L2(bc,a) <- L1(bc,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c1.3.2*            pack W(abc) <-  P(a,bc) [L2(bc,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c
c1.4  add singles
c
c1.4.0mov V <- -W
       call cct3_t3grc0(3,5,3,3,3,0,symijk,possv0,posst,mapdv,mapiv)
       call minusa (Work(iOff),wrksize,
     & mapdw,-1.0d0)
       call setb (Work(iOff),wrksize,
     & mapdw,mapdv,1.0d0)
c
       if (typt3.gt.1) then
c1.4.1add part W2 . T1
       call t3sgl(Work(iOff),wrksize,
     & mapdv,symijk,mapdt11,mapit11,mapdt12,mapit12,
     & mapdw21,mapiw21,mapdw22,mapiw22,
     & 1,i,j,k,symi,symj,symk,rc1,
     & mapdm1,mapim1,possm10,mapdh1,mapih1,possh10,
     & mapdm2,mapim2,possm20,mapdh2,mapih2,possh20,
     & mapdm3,mapim3,possm30,mapdh3,mapih3,possh30)
       end if
c
       if (typt3.eq.3) then
c1.4.2add part T2 . U
       call t3sgl(Work(iOff),wrksize,
     & mapdv,symijk,mapdfk3,mapifk3,mapdfk4,mapifk4,
     & mapdt21,mapit21,mapdt22,mapit22,
     & 1,i,j,k,symi,symj,symk,rc1,
     & mapdm1,mapim1,possm10,mapdh1,mapih1,possh10,
     & mapdm2,mapim2,possm20,mapdh2,mapih2,possh20,
     & mapdm3,mapim3,possm30,mapdh3,mapih3,possh30)
       end if
c
c
c1.5  divide by denominators and calc energy contribution
c
c
c1.5.1divide by den.
       call t3div(Work(iOff),wrksize,
     & mapdw,mapdv,symijk,mapddp1,mapidp1,mapddp2,
     & mapidp2,1,i,j,k,symi,symj,symk,ec,rc1)
c
c1.5.2add energy contribution
       eaaa=eaaa+ec
c
       end if
c
c
c2    ***** aab spin combination *****
c
c
c2*   def keyyes
       if (k.le.nob(symk)) then
       keyyes=1
       else
       keyyes=0
       end if
c
       if (keyyes.eq.1) then
c
c2.*  define maps of W(abc)
       call cct3_t3grc0(3,1,3,3,4,0,symijk,possw0,posst,mapdw,mapiw)
c
c2.*  vanish W(abc)
       call stz (Work(iOff),wrksize,
     & mapdw)
c
c
c2.1  permutations (ijk) P(a,b) (c)
       nsg=1
c
c2.1.1V graph
c
c2.1.1*            def L1(b,c,d)aba <- R3(b,cd) for given k
       call defv (Work(iOff),wrksize,
     & 4,possl10,mapdl1,mapil1,ssl1,
     & mapdr3,mapir3,symk,rc1)
c
c2.1.1*            ext M1(da) <- T2aaaa(da,ij) for given i,j
       call ext(Work(iOff),wrksize,
     & 4,7,i,j,0,symi,symj,0,mapdt21,mapit21,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.1.1*            exp M2(d,a) <- M1(da)
       call cct3_expand (Work(iOff),wrksize,
     & 2,1,mapdm1,mapim1,ssm1,possm20,mapdm2,mapim2,
     & rc1)
       ssm2=ssm1
c
c2.1.1*            mult L2(b,c,a) <- L1(b,c,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.1.1*            pack W(ab,c) <- - P(a,b) [L2(b,c,a)] (minus is due to
c     usung Tijda instead of T2ijad)
       call t3addpck(Work(iOff),wrksize,
     & 3,2,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,0,rc1)
c
c2.1.2O graph
c
c2.1.2*            ext L1(b,c,l) <- T2abab(b,c,l,k) for given k
       call ext(Work(iOff),wrksize,
     & 4,4,k,0,0,symk,0,0,mapdt23,mapit23,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c2.1.2*     ext M1(l,a) <- W12(l,a,ij)=<la||ij>aaaa for given ij
       call ext(Work(iOff),wrksize,
     & 4,7,i,j,0,symi,symj,0,mapdw11,mapiw11,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.1.2*            mult L2(b,c,a) <- L1(b,c,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.1.2*            pack W(ab,c) <- - P(a,b) [L2(b,c,a)] (-, premutation in V)
       call t3addpck(Work(iOff),wrksize,
     & 3,2,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,0,rc1)
c
c
c2.2  permutations (ijk) (cab) do not nontribute
c
c
c2.3  permutations (ikj) P(a,b) (c)
       nsg=-1
c
c2.3.1V graph
c
c2.3.1*            def L1(b,c,d)abb <- R2(b,cd) for given j
       call defv (Work(iOff),wrksize,
     & 3,possl10,mapdl1,mapil1,ssl1,
     & mapdr2,mapir2,symj,rc1)
c
c2.3.1*            ext M1(a,d) <- T2abab(a,d,i,k) for given i,k
       call ext(Work(iOff),wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdt23,mapit23,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.3.1*            map M2(d,a) <- M1(a,d)
       call cct3_map (Work(iOff),wrksize,
     & 2,2,1,0,0,mapdm1,mapim1,ssm1,mapdm2,mapim2,
     & possm20,posst,rc1)
       ssm2=ssm1
c
c2.3.1*            mult L2(b,c,a) <- L1(b,c,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.3.1*            pack W(ab,c) <-  P(a,b) [L2(b,c,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,2,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c2.3.2O graph
c
c2.3.2*            ext L1(b,c,l) <- T2abab(b,c,j,l) for given j
       call ext(Work(iOff),wrksize,
     & 4,3,j,0,0,symj,0,0,mapdt23,mapit23,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c2.3.2*     ext M1(l,a) <- W14(l,a,ik)=<la||ik>baab for given ik
       call ext(Work(iOff),wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdw14,mapiw14,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.3.2*            mult L2(b,c,a) <- L1(b,c,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.3.2*            pack W(ab,c) <- P(a,b) [L2(b,c,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,2,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c
c2.4  permutations (ikj) (cab)
       nsg=-1
c
c
c2.4.1V graph
c
c2.4.1*            def L1(ab,d)aaa <- R2(a,bc) for given j
       call defv (Work(iOff),wrksize,
     & 1,possl10,mapdl1,mapil1,ssl1,
     & mapdr2,mapir2,symj,rc1)
c
c2.4.1*            ext M1(d,c) <- T2abab(d,c,i,k) for given i,k
       call ext(Work(iOff),wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdt23,mapit23,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.4.1*            mult L2(ab,c) <- L1(ab,d) . M1(d,c)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.4.1*            add (pack) W(ab,c) <-  [L2(b,c,a)] (- due to permuted T)
       call cct3_add (Work(iOff),wrksize,
     & 3,3,0,0,0,0,1,1,-1.0d0*nsg,mapdl2,symijk,
     & mapdw,mapiw,symijk,rc1)
c
c2.4.2O graph
c
c2.4.2*            ext L1(ab,l) <- T2aaaa(ab,jl) for given j
       call ext(Work(iOff),wrksize,
     & 4,3,j,0,0,symj,0,0,mapdt21,mapit21,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c2.4.2*     ext M1(l,c) <- W13(l,c,ik)=<lc||ik>abab for given ik
       call ext(Work(iOff),wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdw13,mapiw13,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.4.2*            mult L2(ab,c) <- L1(ab,l) . M1(l,c)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.4.2*            add (pack) W(ab,c) <- [L2(ab,c)]
       call cct3_add (Work(iOff),wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0*nsg,mapdl2,symijk,
     & mapdw,mapiw,symijk,rc1)
c
c
c2.5  permutations (jki) P(a,b) (c)
       nsg=1
c
c
c2.5.1V graph
c
c2.5.1*            def L1(b,c,d)abb <- R1(b,cd) for given i
       call defv (Work(iOff),wrksize,
     & 3,possl10,mapdl1,mapil1,ssl1,
     & mapdr1,mapir1,symi,rc1)
c
c2.5.1*            ext M1(a,d) <- T2abab(a,d,j,k) for given j,k
       call ext(Work(iOff),wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdt23,mapit23,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.5.1*            map M2(d,a) <- M1(a,d)
       call cct3_map (Work(iOff),wrksize,
     & 2,2,1,0,0,mapdm1,mapim1,ssm1,mapdm2,mapim2,
     & possm20,posst,rc1)
       ssm2=ssm1
c
c2.5.1*            mult L2(b,c,a) <- L1(b,c,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.5.1*            pack W(ab,c) <-  P(a,b) [L2(b,c,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,2,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c2.5.2O graph
c
c2.5.2*            ext L1(b,c,l) <- T2abab(b,c,i,l) for given i
       call ext(Work(iOff),wrksize,
     & 4,3,i,0,0,symi,0,0,mapdt23,mapit23,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c2.5.2*     ext M1(l,a) <- W14(l,a,jk)=<la||jk>baab for given jk
       call ext(Work(iOff),wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdw14,mapiw14,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.5.2*            mult L2(b,c,a) <- L1(b,c,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.5.2*            pack W(ab,c) <- P(a,b) [L2(b,c,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,2,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c
c2.6  permutations (ikj) (cab)
       nsg=1
c
c
c2.6.1V graph
c
c2.6.1*            def L1(ab,d)aaa <- R1(a,bc) for given i
       call defv (Work(iOff),wrksize,
     & 1,possl10,mapdl1,mapil1,ssl1,
     & mapdr1,mapir1,symi,rc1)
c
c2.6.1*            ext M1(d,c) <- T2abab(d,c,j,k) for given j,k
       call ext(Work(iOff),wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdt23,mapit23,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.6.1*            mult L2(ab,c) <- L1(ab,d) . M1(d,c)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.6.1*            add (pack) W(ab,c) <-  [L2(b,c,a)] (- due to permuted T)
       call cct3_add (Work(iOff),wrksize,
     & 3,3,0,0,0,0,1,1,-1.0d0*nsg,mapdl2,symijk,
     & mapdw,mapiw,symijk,rc1)
c
c2.6.2O graph
c
c2.6.2*            ext L1(ab,l) <- T2aaaa(ab,il) for given i
       call ext(Work(iOff),wrksize,
     & 4,3,i,0,0,symi,0,0,mapdt21,mapit21,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c2.6.2*     ext M1(l,c) <- W13(l,c,jk)=<lc||jk>abab for given jk
       call ext(Work(iOff),wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdw13,mapiw13,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c2.6.2*            mult L2(ab,c) <- L1(ab,l) . M1(l,c)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c2.6.2*            add (pack) W(ab,c) <- [L2(ab,c)]
       call cct3_add (Work(iOff),wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0*nsg,mapdl2,symijk,
     & mapdw,mapiw,symijk,rc1)
c
c
c2.7  add singles
c
c
c2.7.0mov V <- W
       call cct3_t3grc0(3,1,3,3,4,0,symijk,possv0,posst,mapdv,mapiv)
       call minusa (Work(iOff),wrksize,
     & mapdw,-1.0d0)
       call setb (Work(iOff),wrksize,
     & mapdw,mapdv,1.0d0)
c
       if (typt3.gt.1) then
c2.7.1add part W2 . T1
       call t3sgl(Work(iOff),wrksize,
     & mapdv,symijk,mapdt11,mapit11,mapdt12,mapit12,
     & mapdw21,mapiw21,mapdw23,mapiw23,
     & 2,i,j,k,symi,symj,symk,rc1,
     & mapdm1,mapim1,possm10,mapdh1,mapih1,possh10,
     & mapdm2,mapim2,possm20,mapdh2,mapih2,possh20,
     & mapdm3,mapim3,possm30,mapdh3,mapih3,possh30)
       end if
c
       if (typt3.eq.3) then
c2.7.2add part T2 . U
       call t3sgl(Work(iOff),wrksize,
     & mapdv,symijk,mapdfk3,mapifk3,mapdfk4,mapifk4,
     & mapdt21,mapit21,mapdt23,mapit23,
     & 2,i,j,k,symi,symj,symk,rc1,
     & mapdm1,mapim1,possm10,mapdh1,mapih1,possh10,
     & mapdm2,mapim2,possm20,mapdh2,mapih2,possh20,
     & mapdm3,mapim3,possm30,mapdh3,mapih3,possh30)
       end if
c
c
c2.8  divide by denominators and calc energy contribution
c
c
c2.8.1divide by den.
       call t3div(Work(iOff),wrksize,
     & mapdw,mapdv,symijk,mapddp1,mapidp1,mapddp2,
     & mapidp2,2,i,j,k,symi,symj,symk,ec,rc1)
c
c2.8.2add energy contribution
       eaab=eaab+ec
c
       end if
c
c
c3    ***** abb spin combination *****
c
c
c     Note:
c     in spin combination 3-abb indexes are changed as follows
c
       i3=k
       symi3=symk
       j3=i
       symj3=symi
       k3=j
       symk3=symj
c
c     therefore, also R files are mixed:
c     R13 = R3, R23=R1 and R33=R2, symijk3=symijk
c
c3.*  def keyyes
       if (symj3.gt.symk3) then
       if ((j3.le.nob(symj3)).and.(k3.le.nob(symk3))) then
       keyyes=1
       else
       keyyes=0
       end if
       else if (symj3.eq.symk3) then
       if ((j3.gt.k3).and.(j3.le.nob(symj3))) then
       keyyes=1
       else
       keyyes=0
       end if
       else
       keyyes=0
       end if
c
       if (keyyes.eq.1) then
c
c3.*  define maps of W(a,bc)
       call cct3_t3grc0(3,2,3,4,4,0,symijk,possw0,posst,mapdw,mapiw)
c
c3.*  vanish W(abc)
       call stz (Work(iOff),wrksize,
     & mapdw)
c
c
c3.1  permutation (ijk) (abc)
       nsg=1
c
c
c3.1.1V graph
c
c3.1.1*            def L1(bc,d) <- R33(b,cd) for given k3
       call defv (Work(iOff),wrksize,
     & 2,possl10,mapdl1,mapil1,ssl1,
     & mapdr2,mapir2,symk3,rc1)
c
c3.1.1*            ext M1(a,d) <- T2abab(a,d,i3,j3) for given i3,j3
       call ext(Work(iOff),wrksize,
     & 4,7,i3,j3,0,symi3,symj3,0,mapdt23,mapit23,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.1.1*            map M2(d,a) <- M1(a,d)
       call cct3_map (Work(iOff),wrksize,
     & 2,2,1,0,0,mapdm1,mapim1,ssm1,mapdm2,mapim2,
     & possm20,posst,rc1)
       ssm2=ssm1
c
c3.1.1*            mult L2(bc,a) <- L1(bc,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.1.1map L1(a,bc) <- L2(bc,a)
       call cct3_map (Work(iOff),wrksize,
     & 3,2,3,1,0,mapdl2,mapil2,ssl2,mapdl1,mapil1,
     & possl10,posst,rc1)
       ssl1=ssl2
c3.1.1*            add (pack) W(a,bc) <- [L1(a,bc)]
       call cct3_add (Work(iOff),wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0*nsg,mapdl1,symijk,
     & mapdw,mapiw,symijk,rc1)
c
c3.1.2O graph
c
c3.1.2*            ext L1(bc,l) <- T2bbbb(bc,k3l) for given k3
       call ext(Work(iOff),wrksize,
     & 4,3,k3,0,0,symk3,0,0,mapdt22,mapit22,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c3.1.2*     ext M1(l,a) <- W14(l,a,i3j3)=<la||i3j3>baab for given i3,j3
       call ext(Work(iOff),wrksize,
     & 4,7,i3,j3,0,symi3,symj3,0,mapdw14,mapiw14,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.1.2*            mult L2(bc,a) <- L1(bc,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.1.2map L1(a,bc) <- L2(bc,a)
       call cct3_map (Work(iOff),wrksize,
     & 3,2,3,1,0,mapdl2,mapil2,ssl2,mapdl1,mapil1,
     & possl10,posst,rc1)
       ssl1=ssl2

c3.1.2*            add (pack) W(a,bc) <- [L1(a,bc)]
       call cct3_add (Work(iOff),wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0*nsg,mapdl1,symijk,
     & mapdw,mapiw,symijk,rc1)
c
c
c3.2  permutations (ijk)(bac),(ijk)(cab)
       nsg=1
c
c
c3.2.1V graph
c
c3.2.1*            def L1(a,c,d)aba <- R33(a,cd) for given k3
       call defv (Work(iOff),wrksize,
     & 4,possl10,mapdl1,mapil1,ssl1,
     & mapdr2,mapir2,symk3,rc1)
c
c3.2.1*            ext M1(d,b) <- T2abab(d,b,i3,j3) for given i3,j3
       call ext(Work(iOff),wrksize,
     & 4,7,i3,j3,0,symi3,symj3,0,mapdt23,mapit23,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.2.1*            mult L2(ac,b) <- L1(a,c,d) . M1(d,b)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.2.1*            add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm T)
       call t3addpck (Work(iOff),wrksize,
     & 3,3,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,
     & 0,rc1)
c
c3.2.2O graph
c
c3.2.2*            ext L1(a,c,l) <- T2abab(a,c,l,k3) for given k3
       call ext(Work(iOff),wrksize,
     & 4,4,k3,0,0,symk3,0,0,mapdt23,mapit23,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c3.2.2*     ext M1(l,b) <- W13(l,b,i3j3)=<la||i3j3>abab for given i3,j3
       call ext(Work(iOff),wrksize,
     & 4,7,i3,j3,0,symi3,symj3,0,mapdw13,mapiw13,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.2.2*            mult L2(ac,b) <- L1(a,c,l) . M1(l,b)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.2.2*            add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm V)
       call t3addpck (Work(iOff),wrksize,
     & 3,3,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,
     & 0,rc1)
c
c
c3.3  permutation (ikj) (abc)
       nsg=-1
c
c
c3.3.1V graph
c
c3.3.1*            def L1(bc,d) <- R23(b,cd) for given j3
       call defv (Work(iOff),wrksize,
     & 2,possl10,mapdl1,mapil1,ssl1,
     & mapdr1,mapir1,symj3,rc1)
c
c3.3.1*            ext M1(a,d) <- T2abab(a,d,i3,k3) for given i3,k3
       call ext(Work(iOff),wrksize,
     & 4,7,i3,k3,0,symi3,symk3,0,mapdt23,mapit23,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.3.1*            map M2(d,a) <- M1(a,d)
       call cct3_map (Work(iOff),wrksize,
     & 2,2,1,0,0,mapdm1,mapim1,ssm1,mapdm2,mapim2,
     & possm20,posst,rc1)
       ssm2=ssm1
c
c3.3.1*            mult L2(bc,a) <- L1(bc,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.3.1map L1(a,bc) <- L2(bc,a)
       call cct3_map (Work(iOff),wrksize,
     & 3,2,3,1,0,mapdl2,mapil2,ssl2,mapdl1,mapil1,
     & possl10,posst,rc1)
       ssl1=ssl2

c3.3.1*            add (pack) W(a,bc) <- [L1(a,bc)]
       call cct3_add (Work(iOff),wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0*nsg,mapdl1,symijk,
     & mapdw,mapiw,symijk,rc1)
c
c3.3.2O graph
c
c3.3.2*            ext L1(bc,l) <- T2bbbb(bc,j3l) for given j3
       call ext(Work(iOff),wrksize,
     & 4,3,j3,0,0,symj3,0,0,mapdt22,mapit22,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c3.3.2*     ext M1(l,a) <- W14(l,a,i3k3)=<la||i3k3>baab for given i3,k3
       call ext(Work(iOff),wrksize,
     & 4,7,i3,k3,0,symi3,symk3,0,mapdw14,mapiw14,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.3.2*            mult L2(bc,a) <- L1(bc,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.3.2map L1(a,bc) <- L2(bc,a)
       call cct3_map (Work(iOff),wrksize,
     & 3,2,3,1,0,mapdl2,mapil2,ssl2,mapdl1,mapil1,
     & possl10,posst,rc1)
       ssl1=ssl2

c3.3.2*            add (pack) W(a,bc) <- [L1(a,bc)]
       call cct3_add (Work(iOff),wrksize,
     & 3,3,0,0,0,0,1,1,1.0d0*nsg,mapdl1,symijk,
     & mapdw,mapiw,symijk,rc1)
c
c
c3.4  permutations (ikj)(bac),(ikj)(cab)
       nsg=-1
c
c
c3.4.1V graph
c
c3.4.1*            def L1(a,c,d)aba <- R23(a,cd) for given j3
       call defv (Work(iOff),wrksize,
     & 4,possl10,mapdl1,mapil1,ssl1,
     & mapdr1,mapir1,symj3,rc1)
c
c3.4.1*            ext M1(d,b) <- T2abab(d,b,i3,k3) for given i3,k3
       call ext(Work(iOff),wrksize,
     & 4,7,i3,k3,0,symi3,symk3,0,mapdt23,mapit23,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.4.1*            mult L2(ac,b) <- L1(a,c,d) . M1(d,b)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.4.1*            add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm T)
       call t3addpck (Work(iOff),wrksize,
     & 3,3,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,
     & 0,rc1)
c
c3.4.2O graph
c
c3.4.2*            ext L1(a,c,l) <- T2abab(a,c,l,j3) for given j3
       call ext(Work(iOff),wrksize,
     & 4,4,j3,0,0,symj3,0,0,mapdt23,mapit23,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c3.4.2*     ext M1(l,b) <- W13(l,b,i3k3)=<la||i3k3>abab for given i3,k3
       call ext(Work(iOff),wrksize,
     & 4,7,i3,k3,0,symi3,symk3,0,mapdw13,mapiw13,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.4.2*            mult L2(ac,b) <- L1(a,c,l) . M1(l,b)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.4.2*            add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm V)
       call t3addpck (Work(iOff),wrksize,
     & 3,3,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,
     & 0,rc1)
c
c
c3.5  permutations (jki)(abc) do not contribute
c
c
c3.6  permutations (jki)(bac),(jki)(cab)
       nsg=1
c
c
c3.6.1V graph
c
c3.6.1*            def L1(a,c,d)abb <- R13(a,cd) for given i3
       call defv (Work(iOff),wrksize,
     & 3,possl10,mapdl1,mapil1,ssl1,
     & mapdr3,mapir3,symi3,rc1)
c
c3.6.1*            ext M1(db) <- T2bbbb(db,j3k3) for given j3,k3
       call ext(Work(iOff),wrksize,
     & 4,7,j3,k3,0,symj3,symk3,0,mapdt22,mapit22,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.6.1*            exp M2(d,a) <- M1(da)
       call cct3_expand (Work(iOff),wrksize,
     & 2,1,mapdm1,mapim1,ssm1,possm20,mapdm2,mapim2,
     & rc1)
       ssm2=ssm1
c
c3.6.1*            mult L2(ac,b) <- L1(a,c,d) . M2(d,b)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.6.1*            add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm T)
       call t3addpck (Work(iOff),wrksize,
     & 3,3,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,
     & 0,rc1)
c
c3.6.2O graph
c
c3.6.2*            ext L1(a,c,l) <- T2abab(a,c,i3,l) for given i3
       call ext(Work(iOff),wrksize,
     & 4,3,i3,0,0,symi3,0,0,mapdt23,mapit23,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c3.6.2*     ext M1(l,b) <- W12(l,b,j3k3)=<la||j3k3>bbbb for given j3,k3
       call ext(Work(iOff),wrksize,
     & 4,7,j3,k3,0,symj3,symk3,0,mapdw12,mapiw12,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c3.6.2*            mult L2(ac,b) <- L1(a,c,l) . M1(l,b)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c3.6.2*            add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)]
       call t3addpck (Work(iOff),wrksize,
     & 3,3,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,
     & 0,rc1)
c
c
c3.7  add singles
c
c
c3.7.0mov V <- W
       call cct3_t3grc0(3,2,3,4,4,0,symijk,possv0,posst,mapdv,mapiv)
       call minusa (Work(iOff),wrksize,
     & mapdw,-1.0d0)
       call setb (Work(iOff),wrksize,
     & mapdw,mapdv,1.0d0)
c
       if (typt3.gt.1) then
c3.7.1add part W2 . T1
       call t3sgl(Work(iOff),wrksize,
     & mapdv,symijk,mapdt11,mapit11,mapdt12,mapit12,
     & mapdw23,mapiw23,mapdw22,mapiw22,
     & 3,i3,j3,k3,symi3,symj3,symk3,rc1,
     & mapdm1,mapim1,possm10,mapdh1,mapih1,possh10,
     & mapdm2,mapim2,possm20,mapdh2,mapih2,possh20,
     & mapdm3,mapim3,possm30,mapdh3,mapih3,possh30)
       end if
c
       if (typt3.eq.3) then
c3.7.2add part T2 . U
       call t3sgl(Work(iOff),wrksize,
     & mapdv,symijk,mapdfk3,mapifk3,mapdfk4,mapifk4,
     & mapdt23,mapit23,mapdt22,mapit22,
     & 3,i3,j3,k3,symi3,symj3,symk3,rc1,
     & mapdm1,mapim1,possm10,mapdh1,mapih1,possh10,
     & mapdm2,mapim2,possm20,mapdh2,mapih2,possh20,
     & mapdm3,mapim3,possm30,mapdh3,mapih3,possh30)
       end if
c
c
c3.8  divide by denominators and calc energy contribution
c
c
c3.8.1divide by den.
       call t3div(Work(iOff),wrksize,
     & mapdw,mapdv,symijk,mapddp1,mapidp1,mapddp2,
     & mapidp2,3,i3,j3,k3,symi3,symj3,symk3,ec,rc1)
c
c3.8.2add energy contribution
       eabb=eabb+ec
c
       end if
c
c
c4    ***** bbb spin combination *****
c
c
c4.*  def keyyes
       if (symj.gt.symk) then
       keyyes=1
       else if (symj.eq.symk) then
       if (j.gt.k) then
       keyyes=1
       else
       keyyes=0
       end if
       else
       keyyes=0
       end if
c
       if ((i.gt.nob(symi)).or.(j.gt.nob(symj))
     & .or.(k.gt.nob(symk))) then
       keyyes=0
       end if
c
       if (keyyes.eq.1) then
c
c4.*  define maps of W(abc)
       call cct3_t3grc0(3,5,4,4,4,0,symijk,possw0,posst,mapdw,mapiw)
c
c4.*  vanish W(abc)
       call stz (Work(iOff),wrksize,
     & mapdw)
c
c
c4.1  permutations (ijk) P(a,bc) (general sign+)
       nsg=1
c
c
c4.1.1V graph
c
c4.1.1*            def L1(bc,d) <- R3(b,cd) for given k
       call defv (Work(iOff),wrksize,
     & 2,possl10,mapdl1,mapil1,ssl1,
     & mapdr3,mapir3,symk,rc1)
c
c4.1.1*            ext M1(da) <- T2bbbb(da,ij) for given i,j
       call ext(Work(iOff),wrksize,
     & 4,7,i,j,0,symi,symj,0,mapdt22,mapit22,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c4.1.1*            exp M2(d,a) <- M1(da)
       call cct3_expand (Work(iOff),wrksize,
     & 2,1,mapdm1,mapim1,ssm1,possm20,mapdm2,mapim2,
     & rc1)
       ssm2=ssm1
c
c4.1.1*            mult L2(bc,a) <- L1(bc,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c4.1.1*            pack W(abc) <-  P(a,bc) [L2(bc,a)] (minus due to the
c     usung Tikda instead of T2ikad)
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,0,rc1)
c
c4.1.2O graph
c
c4.1.2*            ext L1(bc,l) <- T2bbbb(bc,kl) for given k
       call ext(Work(iOff),wrksize,
     & 4,3,k,0,0,symk,0,0,mapdt22,mapit22,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c4.1.2*     ext M1(l,a) <- W12(l,a,ij)=<la||ij>bbbb for given ij
       call ext(Work(iOff),wrksize,
     & 4,7,i,j,0,symi,symj,0,mapdw12,mapiw12,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c4.1.2*            mult L2(bc,a) <- L1(bc,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c4.1.2*            pack W(abc) <- P(a,bc) [L2(bc,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c
c4.2  permutations (ikj) P(a,bc)
       nsg=-1
c
c
c4.2.1V graph
c
c4.2.1*            def L1(bc,d) <- R2(b,cd) for given j
       call defv (Work(iOff),wrksize,
     & 2,possl10,mapdl1,mapil1,ssl1,
     & mapdr2,mapir2,symj,rc1)
c
c4.2.1*            ext M1(da) <- T2bbbb(da,ik) for given i,k
       call ext(Work(iOff),wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdt22,mapit22,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c4.2.1*            exp M2(d,a) <- M1(da)
       call cct3_expand (Work(iOff),wrksize,
     & 2,1,mapdm1,mapim1,ssm1,possm20,mapdm2,mapim2,
     & rc1)
       ssm2=ssm1
c
c4.2.1*            mult L2(bc,a) <- L1(bc,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c4.2.1*            pack W(abc) <- - P(a,bc) [L2(bc,a)] (minus is due to
c     usung Tikda instead of T2ikad)
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,0,rc1)
c
c4.2.2O graph
c
c4.2.2*            ext L1(bc,l) <- T2bbbb(bc,jl) for given j
       call ext(Work(iOff),wrksize,
     & 4,3,j,0,0,symj,0,0,mapdt22,mapit22,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c4.2.2*     ext M1(l,a) <- W12(l,a,ik)=<la||ik>bbbb for given ik
       call ext(Work(iOff),wrksize,
     & 4,7,i,k,0,symi,symk,0,mapdw12,mapiw12,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c4.2.2*            mult L2(bc,a) <- L1(bc,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c4.2.2*            pack W(abc) <- P(a,bc) [L2(bc,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c
c4.3  permutations (jki) P(a,bc)
       nsg=1
c
c
c4.3.1V graph
c
c4.3.1*            def L1(bc,d) <- R1(b,cd) for given i
       call defv (Work(iOff),wrksize,
     & 2,possl10,mapdl1,mapil1,ssl1,
     & mapdr1,mapir1,symi,rc1)
c
c4.3.1*            ext M1(da) <- T2bbbb(da,jk) for given j,k
       call ext(Work(iOff),wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdt22,mapit22,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c4.3.1*            exp M2(d,a) <- M1(da)
       call cct3_expand (Work(iOff),wrksize,
     & 2,1,mapdm1,mapim1,ssm1,possm20,mapdm2,mapim2,
     & rc1)
       ssm2=ssm1
c
c4.3.1*            mult L2(bc,a) <- L1(bc,d) . M2(d,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm2,mapim2,ssm2,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c4.3.1*            pack W(abc) <- - P(a,bc) [L2(bc,a)] (minus is due to
c     usung Tjkda instead of T2jkad)
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,-nsg,0,rc1)
c
c4.3.2O graph
c
c4.3.2*            ext L1(bc,l) <- T2bbbb(bc,kl) for given i
       call ext(Work(iOff),wrksize,
     & 4,3,i,0,0,symi,0,0,mapdt22,mapit22,1,
     & possl10,mapdl1,mapil1,ssl1,rc1)
c
c4.3.2*     ext M1(l,a) <- W12(l,a,jk)=<la||jk>bbbb for given jk
       call ext(Work(iOff),wrksize,
     & 4,7,j,k,0,symj,symk,0,mapdw12,mapiw12,1,
     & possm10,mapdm1,mapim1,ssm1,rc1)
c
c4.3.2*            mult L2(bc,a) <- L1(bc,l) . M1(l,a)
       call cct3_mult(Work(iOff),wrksize,
     & 3,2,3,1,mapdl1,mapil1,ssl1,mapdm1,mapim1,ssm1,
     & mapdl2,mapil2,ssl2,possl20,rc1)
c
c4.3.2*            pack W(abc) <-  P(a,bc) [L2(bc,a)]
       call t3addpck(Work(iOff),wrksize,
     & 3,1,mapdl2,mapil2,ssl2,mapdw,mapiw,nsg,0,rc1)
c
c
c4.4  add singles
c
c
c4.4.0mov V <- W
       call cct3_t3grc0(3,5,4,4,4,0,symijk,possv0,posst,mapdv,mapiv)
       call minusa (Work(iOff),wrksize,
     & mapdw,-1.0d0)
       call setb (Work(iOff),wrksize,
     & mapdw,mapdv,1.0d0)
c
       if (typt3.gt.1) then
c4.4.1add part W2 . T1
       call t3sgl(Work(iOff),wrksize,
     & mapdv,symijk,mapdt12,mapit12,mapdt11,mapit11,
     & mapdw22,mapiw22,mapdw21,mapiw21,
     & 1,i,j,k,symi,symj,symk,rc1,
     & mapdm1,mapim1,possm10,mapdh1,mapih1,possh10,
     & mapdm2,mapim2,possm20,mapdh2,mapih2,possh20,
     & mapdm3,mapim3,possm30,mapdh3,mapih3,possh30)
       end if
c
       if (typt3.eq.3) then
c4.4.2add part T2 . U
       call t3sgl(Work(iOff),wrksize,
     & mapdv,symijk,mapdfk4,mapifk4,mapdfk3,mapifk3,
     & mapdt22,mapit22,mapdt21,mapit21,
     & 1,i,j,k,symi,symj,symk,rc1,
     & mapdm1,mapim1,possm10,mapdh1,mapih1,possh10,
     & mapdm2,mapim2,possm20,mapdh2,mapih2,possh20,
     & mapdm3,mapim3,possm30,mapdh3,mapih3,possh30)
       end if
c
c
c4.5  divide by denominators and calc energy contribution
c
c
c4.5.1divide by den.
       call t3div(Work(iOff),wrksize,
     & mapdw,mapdv,symijk,mapddp2,mapidp2,mapddp1,
     & mapidp1,1,i,j,k,symi,symj,symk,ec,rc1)
c
c4.5.2add energy contribution
       ebbb=ebbb+ec
c
       end if
c
c
 1000   continue
 1100   continue
c
cpar   Separate printing of partial energies e... are
c      useful only in serial run. For parallel run also
c      cycle over k is segmented (via paralelization),
c      so e... are not complete contributions (only sum
c      over all nodes have some sense). Thus, these values
c      in parallel run are too dangerous to use separately
c      so their printout is supressed.
c
       if (nProcs.eq.1) then
         call t3wresult (symi,symj,i,j,eaaa(1),eaab(1),eabb(1),ebbb(1))
         if (fullprint.gt.1) then
           write(6,*) ' Eaaa =',eaaa
           write(6,*) ' Eaab =',eaab
           write(6,*) ' Eabb =',eabb
           write(6,*) ' Ebbb =',ebbb
         end if
       end if
cendpar
c
 1201   continue
 1200   continue
 1300   continue
 1400   continue
c
c
co    ***** final section *****
c
co.*        allreduced energy components
        call gadgop (eaaa,1,'+')
        call gadgop (eaab,1,'+')
        call gadgop (eabb,1,'+')
        call gadgop (ebbb,1,'+')
cstare  call MPI_ALLREDUCE (ebbb,ec,1,
c    c  MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,rc)
c       ebbb=ec
c
c
co.*  type results
c
      IF (fullprint.GE.0) THEN
         write(6,'(6X,A,F24.13)')' CCSD     =',eccsd
         write(6,'(6X,A,F24.13)')' T3 corr. =',eaaa+eaab+eabb+ebbb
         write(6,'(6X,A,F24.13)')' CCSD + T3=',eccsd+eaaa+eaab+eabb+ebbb
         write(6,*) ' T3 energy decomposition into spin parts'
         write(6,*) ' Eaaa =',eaaa
         write(6,*) ' Eaab =',eaab
         write(6,*) ' Eabb =',eabb
         write(6,*) ' Ebbb =',ebbb
         write(6,*)
         write(6,*)
         write(6,'(6X,A)') 'Happy Landing!'
         write(6,*)
      ENDIF
      call add_Info('E_CCSD_T',eccsd+eaaa+eaab+eabb+ebbb,1,8)
c Export a method and energy to the MOLCAS runfile
      Call Put_cArray('Relax Method','CCSDT   ',8)
      Call Store_Energies(1,eccsd+eaaa+eaab+eabb+ebbb,1)
c     Releasing the memory
      Call GetMem('CCT3','Free','Real',iOff,wrksize)
c
c
      ireturn=0
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Luis Manuel Frutos                               *
!               2015, Alessio Valentini                                *
!               2023, Ignacio Fdez. Galvan                             *
!***********************************************************************

! This module calculates an external force applied to the system.

subroutine extf(ireturn)

use spool, only: Spoolinp
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, auToN
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: atomNumberx3, cnt, efatom1, efatom2, efatom3, efatom4, i, LuSpool, nCent, nRoots, nsAtom
real(kind=wp) :: Bt(3,4), dBt(3,4,3,4), Dum, efmodul, efmodulAU, fourAtoms(3,4), gau_sigma, gau_t0, mdtime, norm, time_scaling
logical(kind=iwp) :: bending, Found, gaussian_force, ldB, linear, lWarn, lWrite, torsional
character(len=180) :: Key, Line
character(len=8) :: Label
real(kind=wp), allocatable :: coord(:,:), ExtGrad(:,:), gradient(:,:), modgrad(:,:)
real(kind=wp), parameter :: nnewt = auToN*1.0e9_wp
integer(kind=iwp), external :: isfreeunit, Read_Grad
character(len=180), external :: Get_Ln

! get initial values

!call Mem_Info('EXTF')

call Get_iScalar('Unique atoms',nsAtom)

atomNumberx3 = 3*nsAtom
call mma_allocate(gradient,3,nsAtom,label='gradient')
call mma_allocate(ExtGrad,3,nsAtom,label='ExtGrad')
call mma_allocate(modgrad,3,nsAtom,label='modgrad')
call mma_allocate(coord,3,nsAtom,label='coord')

call Get_dArray('GRAD',gradient,atomNumberx3)
call Get_dArray('Unique Coordinates',coord,atomNumberx3)
! read molcas input

LuSpool = isfreeunit(21)
call SpoolInp(LuSpool)

efmodul = Zero
linear = .false.
bending = .false.
torsional = .false.
gaussian_force = .false.

rewind(LuSpool)
call RdNLst(LuSpool,'extf')
do
  Key = Get_Ln(LuSpool)
  Line = Key
  call UpCase(Line)
  if (Line(1:3) == 'END') then
    exit
  else if (Line(1:4) == 'MODU') then
    Line = Get_Ln(LuSpool)
    call Get_F1(1,efmodul)
    write(u6,*) 'Force:',efmodul,' nN'
  else if (Line(1:4) == 'LINE') then
    !>>> LINEAR FORCE <<<
    linear = .true.
    write(u6,*) 'Linear forces between two atoms selected'
    Line = Get_Ln(LuSpool)
    call Get_I1(1,efatom1)
    call Get_I1(2,efatom2)
    write(u6,*) 'atom1:',efatom1
    write(u6,*) 'atom2:',efatom2
  else if (Line(1:4) == 'BEND') then
    !>>> BENDING FORCE <<<
    bending = .true.
    write(u6,*) 'Bending force on an angle selected'
    Line = Get_Ln(LuSpool)
    call Get_I1(1,efatom1)
    call Get_I1(2,efatom2)
    call Get_I1(3,efatom3)
    write(u6,*) 'atom1:',efatom1
    write(u6,*) 'atom2:',efatom2
    write(u6,*) 'atom3:',efatom3
  else if (Line(1:4) == 'TORS') then
    !>>> TORSIONAL FORCE <<<
    torsional = .true.
    write(u6,*) 'Torsional force on a dihedral selected'
    Line = Get_Ln(LuSpool)
    call Get_I1(1,efatom1)
    call Get_I1(2,efatom2)
    call Get_I1(3,efatom3)
    call Get_I1(4,efatom4)
    write(u6,*) 'atom1:',efatom1
    write(u6,*) 'atom2:',efatom2
    write(u6,*) 'atom3:',efatom3
    write(u6,*) 'atom4:',efatom4
  else if (Line(1:4) == 'GAUS') then
    gaussian_force = .true.
    Line = Get_Ln(LuSpool)
    call Get_F1(1,gau_t0)
    call Get_F1(2,gau_sigma)
  else
    call WarningMessage(2,'Error in EXTF input: Unknown keyword '//trim(Line))
    call Quit_OnUserError()
  end if
end do

close(LuSpool)

cnt = 0
if (linear) cnt = cnt+1
if (bending) cnt = cnt+1
if (torsional) cnt = cnt+1
if (cnt == 0) then
  call WarningMessage(2,'Error in FALSE input: One of LINE, BEND, TORS must be given')
  call Quit_OnUserError()
else if (cnt > 1) then
  call WarningMessage(2,'Error in FALSE input: Only one of LINE, BEND, TORS can be given')
  call Quit_OnUserError()
end if

write(u6,*) 'Coordinates Found:'
do i=1,nsAtom
  write(u6,*) i,coord(:,i)
end do
write(u6,*)

write(u6,*) 'Gradient Found:'
do i=1,nsAtom
  write(u6,*) i,gradient(:,i)
end do
write(u6,*)

! from nN to atomic units
efmodulAU = efmodul/nnewt

! initializations
ExtGrad(:,:) = Zero
fourAtoms(:,:) = Zero
Bt(:,:) = Zero
dBt(:,:,:,:) = Zero ! second derivative
lWrite = .true. ! write something in output file
lWarn = .true. ! write warnings in output file
ldB = .false. ! this will NOT calculate the second derivative

!>>>>>>>>>>>>>>>>>>>>> LINEAR CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
if (linear) then

  if (efmodul > Zero) then
    write(u6,*) 'Compression force'
  else
    write(u6,*) 'Extension force'
  end if

  fourAtoms(:,1) = coord(:,efatom1)
  fourAtoms(:,2) = coord(:,efatom2)

  nCent = 2
  Label = 'Line'
  call Strtch(fourAtoms,nCent,Dum,Bt,lWrite,Label,dBt,ldB)

  write(u6,*) "Bt vector:"
  do i=1,nCent
    write(u6,*) i,Bt(:,i)
  end do

  norm = sqrt(sum(Bt(:,1:nCent)**2))
  write(u6,*) 'Bt norm before normalization:',norm
  Bt(:,1:nCent) = Bt(:,1:nCent)/norm

  ExtGrad(:,efatom1) = Bt(:,1)*efmodulAU
  ExtGrad(:,efatom2) = Bt(:,2)*efmodulAU

end if
!>>>>>>>>>>>>>>>>>>>>> end of linear code <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

!>>>>>>>>>>>>>>>>>>>>> BENDING CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
if (bending) then

  if (efmodul > Zero) then
    write(u6,*) 'Closing force'
  else
    write(u6,*) 'Opening force'
  end if

  fourAtoms(:,1) = coord(:,efatom1)
  fourAtoms(:,2) = coord(:,efatom2)
  fourAtoms(:,3) = coord(:,efatom3)

  nCent = 3
  Label = 'Angle'
  call Bend(fourAtoms,nCent,Dum,Bt,lWrite,lWarn,Label,dBt,ldB)

  write(u6,*) "Bt vector:"
  do i=1,nCent
    write(u6,*) i,Bt(:,i)
  end do

  norm = sqrt(sum(Bt(:,1:nCent)**2))
  write(u6,*) 'Bt norm before normalization:',norm
  Bt(:,1:nCent) = Bt(:,1:nCent)/norm

  ExtGrad(:,efatom1) = Bt(:,1)*efmodulAU
  ExtGrad(:,efatom2) = Bt(:,2)*efmodulAU
  ExtGrad(:,efatom3) = Bt(:,3)*efmodulAU

end if
!>>>>>>>>>>>>>>>>>>>>> end of bending code <<<<<<<<<<<<<<<<<<<<<<<<<<<<<

!>>>>>>>>>>>>>>>>>>>>> TORSIONAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
if (torsional) then

  if (efmodul > Zero) then
    write(u6,*) 'Closing force'
  else
    write(u6,*) 'Opening force'
  end if

  fourAtoms(:,1) = coord(:,efatom1)
  fourAtoms(:,2) = coord(:,efatom2)
  fourAtoms(:,3) = coord(:,efatom3)
  fourAtoms(:,4) = coord(:,efatom4)

  nCent = 4
  Label = 'Dihedral'
  call Trsn(fourAtoms,nCent,Dum,Bt,lWrite,lWarn,Label,dBt,ldB)

  write(u6,*) "Bt vector:"
  do i=1,nCent
    write(u6,*) i,Bt(:,i)
  end do

  norm = sqrt(sum(Bt(:,1:nCent)**2))
  write(u6,*) 'Bt norm before normalization:',norm
  Bt(:,1:nCent) = Bt(:,1:nCent)/norm

  ExtGrad(:,efatom1) = Bt(:,1)*efmodulAU
  ExtGrad(:,efatom2) = Bt(:,2)*efmodulAU
  ExtGrad(:,efatom3) = Bt(:,3)*efmodulAU
  ExtGrad(:,efatom4) = Bt(:,4)*efmodulAU

end if
!>>>>>>>>>>>>>>>>>>>>> end of torsional code <<<<<<<<<<<<<<<<<<<<<<<<<<<

!>>>>>>>>>>>>>>>>>>>>> GAUSSIAN CODE <<<<_<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
if (gaussian_force) then
  ! AV: This is called before dynamix, so at fist step it would not find the time value in the runfile
  mdtime = Zero
  call Qpg_dScalar('MD_Time',Found)
  if (Found) call Get_dScalar('MD_Time',mdtime)

  write(u6,*) 'Gaussian shaped force'
  write(u6,*) 'sigma',gau_sigma,'t0',gau_t0
  time_scaling = exp(-(mdtime-gau_t0)**2/(2*(gau_sigma**2)))
  write(u6,*) 'gaussian:',mdtime,time_scaling

  ExtGrad(:,:) = ExtGrad(:,:)*time_scaling

end if
!>>>>>>>>>>>>>>>>>>>>> end of gaussian code <<<<<<<<<<<<<<<<<<<<<<<<<<<<

write(u6,*)
write(u6,*) 'External Force'
do i=1,nsAtom
  write(u6,*) i,-ExtGrad(:,i)
end do
write(u6,*)

! Creating the final modified external gradient vector (modgrad)
modgrad(:,:) = gradient(:,:)+ExtGrad(:,:)

write(u6,*)
write(u6,*) 'Gradient after force application:'
do i=1,nsAtom
  write(u6,*) i,modgrad(:,i)
end do
write(u6,*)

call Put_dArray('GRAD',modgrad,atomNumberx3)

! Modify the GRADS file too
call Get_iScalar('Number of roots',nRoots)
do i=1,nRoots
  if (Read_Grad(gradient,3*nsAtom,i,0,0) == 1) then
    modgrad(:,:) = gradient(:,:)+ExtGrad(:,:)
    call Store_Grad(modgrad,3*nsAtom,i,0,0)
  end if
end do

call mma_deallocate(gradient)
call mma_deallocate(ExtGrad)
call mma_deallocate(modgrad)
call mma_deallocate(coord)

ireturn = 0

return

end subroutine extf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine ddV(Cart,mTtAtm,Hess,iANr,
     &               iTabBonds,iTabAtoms,nBonds,nMax,nHidden)
      Use Symmetry_Info, only: VarR, VarT
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
      Real*8 Cart(3,mTtAtm+nHidden),Hess((3*mTtAtm)*(3*mTtAtm+1)/2)
      Integer   iANr(mTtAtm+nHidden), iTabBonds(3,nBonds),
     &          iTabAtoms(2,0:nMax,mTtAtm+nHidden)
      Real*8, Allocatable:: HBig(:)
      Logical VRSave, VTSave
*
*  Temporary big hessian
*
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
*                                                                      *
************************************************************************
      If (nHidden.gt.0) Then
         nTot = mTtAtm+nHidden
         Call mma_allocate(HBig,(3*nTot)*(3*nTot+1)/2,Label='HBig')
*
* Temporary turn on the translational/rotational invariance
*
         VRSave = VarR
         VTSave = VarT
         VarR = .False.
         VarT = .False.
         Call ddV_(Cart,nTot,HBig,iANr,iTabBonds,
     &             iTabAtoms,nBonds,nMax,nHidden)
         VarR = VRSave
         VarT = VTSave
         Call dCopy_((3*mTtAtm)*(3*mTtAtm+1)/2,HBig,1,Hess,1)
#ifdef _DEBUGPRINT_
         write(6,*) 'DDV: Improved Hessian'
         Call RecPrt('Coord (with hidden atoms):',' ',Cart,3,nTot)
         Call TriPrt('Hessian (hidden atoms):',' ',HBig,3*nTot)
         Call TriPrt('Hessian (normal):',' ',Hess,3*mTtAtm)
#endif
         Call mma_deallocate(HBig)
      Else
         Call ddV_(Cart,mTtAtm,Hess,iANr,iTabBonds,
     &             iTabAtoms,nBonds,nMax,nHidden)
      End If
      End
*
      Subroutine ddV_(Cart,mTtAtm,Hess,iANr,iTabBonds,
     &               iTabAtoms,nBonds,nMax,nHidden)
      use Symmetry_Info, only: nIrrep, iOper, VarR, VarT
      use Slapaf_Parameters, only: ddV_Schlegel, iOptC
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
#include "stdalloc.fh"
      Real*8 Cart(3,mTtAtm),rij(3),rjk(3),rkl(3),
     &       Hess((3*mTtAtm)*(3*mTtAtm+1)/2),si(3),sj(3),sk(3),
     &       sl(3),sm(3),x(2),y(2),z(2),
     &       xyz(3,4), C(3,4), Dum(1),
     &       ril(3), rik(3)
      Integer   iANr(mTtAtm), iTabBonds(3,nBonds),
     &          iTabAtoms(2,0:nMax,mTtAtm)
      Logical MinBas, Help, Torsion_Check, Invariant(3)
*
      Real*8 Trans(3), RotVec(3), RotMat(3,3)
      Real*8, Allocatable:: xMass(:), Grad(:,:,:), CurrXYZ(:,:)
*
#include "warnings.h"
#define _FMIN_
#define _VDW_
#include "ddvdt.fh"
#include "ddvdt_RF.fh"
#define _SCHLEGEL_
#include "ddvdt_bond.fh"
#include "bondtypes.fh"
#include "ddvdt_bend.fh"
#include "ddvdt_trsn.fh"
#include "ddvdt_outofp.fh"
#include "constants.fh"
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*) 'ddV: nBonds=',nBonds
      nqR=0
      nqB=0
      nqT=0
      nqO=0
      Do iAtom = 1, mTtAtm
*
         nNeighbor_i = iTabAtoms(1,0,iAtom)
         Write (6,*) 'iAtom,nNeighbor=',iAtom,nNeighbor_i
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
      f_const_min_=f_const_min * 1.0D-1
      f_const=0.0D0
*
      bohr=CONST_BOHR_RADIUS_IN_SI_ * 1.0D+10
      MinBas=.False.
      If (MinBas) Then
         Fact=1.3d0
      Else
         Fact=One
      End If
      rZero=1.0d-10
      n3=3*mTtAtm
*
      call dcopy_((n3*(n3+1)/2),[Zero],0,Hess,1)
#ifdef _DEBUGPRINT_
      Call TriPrt(' In LNM: Hessian at start','(12f8.3)',
     &               Hess,n3)
      Call DiagMtrx_T(Hess,n3,iNeg)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(xMass,mTtAtm,Label='xMass')
      Call Get_Mass_All(xMass,mTtAtm-nHidden)
      Do iAtom=mTtAtm-nHidden+1,mTtAtm
         xMass(iAtom)=rMass(iANr(iAtom))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Hessian for translational coordinates in case of a RF calculation.
*
      If (.Not.VarT) Go To 777
*
      Do ixyz = 1, 3
         Invariant(ixyz)=.False.
         iTest=2**(ixyz-1)
         Do iSym = 0, nIrrep-1
            If (iOper(iSym).eq.iTest) Invariant(ixyz)=.True.
         End Do
      End Do
      If (Invariant(1).and.Invariant(2).and.Invariant(3)) Go To 777
*
      Fact=One
      If (.Not.VarR) Fact=2.0D-2
*
      TMass=Zero
      Do iAtom = 1, mTtAtm
         TMass=TMass+xMass(iAtom)
      End Do
      Do iAtom = 1, mTtAtm
         f1=xMass(iAtom)/TMass
         Do jAtom = 1, iAtom-1
            f2=xMass(jAtom)/TMass
*
            f_const=Max(Trans_Const,f_const_Min_)
            gmm=Fact*f_const*f1*f2
*
            If (.Not.Invariant(1))
     &      Hess(LHR(1,iAtom,1,jAtom))=Hess(LHR(1,iAtom,1,jAtom))+gmm
            If (.Not.Invariant(2))
     &      Hess(LHR(2,iAtom,2,jAtom))=Hess(LHR(2,iAtom,2,jAtom))+gmm
            If (.Not.Invariant(3))
     &      Hess(LHR(3,iAtom,3,jAtom))=Hess(LHR(3,iAtom,3,jAtom))+gmm
*
         End Do
*
         f_const=Max(Trans_Const,f_const_Min_)
         gmm=Fact*f_const*f1*f1
*
         If (.Not.Invariant(1))
     &   Hess(LHR(1,iAtom,1,iAtom))=Hess(LHR(1,iAtom,1,iAtom))+gmm
         If (.Not.Invariant(1))
     &   Hess(LHR(2,iAtom,2,iAtom))=Hess(LHR(2,iAtom,2,iAtom))+gmm
         If (.Not.Invariant(1))
     &   Hess(LHR(3,iAtom,3,iAtom))=Hess(LHR(3,iAtom,3,iAtom))+gmm
*
      End Do
#ifdef _DEBUGPRINT_
      Call TriPrt(' In LNM: Hessian after Translation','(6f12.7)',
     &               Hess,n3)
      Call DiagMtrx_T(Hess,n3,iNeg)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Hessian for rotational coordinates
*
 777  Continue
      If (.Not.VarR) Go To 778
*
      Do ixyz = 1, 3
         Invariant(ixyz)=.False.
         If (ixyz.eq.1) Then
            iTest=6
         Else If (ixyz.eq.2) Then
            iTest=5
         Else
            iTest=3
         End If
         Do iSym = 0, nIrrep-1
            If (iOper(iSym).eq.iTest) Invariant(ixyz)=.True.
         End Do
      End Do
      If (Invariant(1).and.Invariant(2).and.Invariant(3)) Go To 778
*
c     If (mTtAtm.le.2) Then
c        Call WarningMessage(2,'Error in ddV')
c        Write (6,*)
c        Write (6,*) ' Warning!'
c        Write (6,*) ' Rotational internal coordinates not implemented'
c    &             //' for fewer than 3 atoms!'
c        Write (6,*) ' Add dummy atoms to your input and try again!'
c        Write (6,*)
c        Call Quit(_RC_GENERAL_ERROR_)
c     End If
      Call mma_allocate(Grad,3,3,mTtAtm,Label='Grad')
      Call mma_allocate(CurrXYZ,3,mTtAtm,Label='CurrXYZ')
      Do iAtom = 1, mTtAtm
         If (iANr(iAtom).le.0) Then
            xMass(iAtom) = 1.0D-10
         End If
      End Do
      nOrder=1
      Trans(:)=Zero
      RotVec(:)=Zero
      CurrXYZ(:,:)=Cart(:,:)
      Call RotDer(mTtAtm,xMass,CurrXYZ,Cart,Trans,RotAng,
     &            RotVec,RotMat,nOrder,Grad,dum)
      Call mma_deallocate(CurrXYZ)
*
*
      Do iAtom = 1, mTtAtm
         dO1_dx1 =  Grad(1,1,iAtom)
         dO2_dx1 =  Grad(2,1,iAtom)
         dO3_dx1 =  Grad(3,1,iAtom)
         dO1_dy1 =  Grad(1,2,iAtom)
         dO2_dy1 =  Grad(2,2,iAtom)
         dO3_dy1 =  Grad(3,2,iAtom)
         dO1_dz1 =  Grad(1,3,iAtom)
         dO2_dz1 =  Grad(2,3,iAtom)
         dO3_dz1 =  Grad(3,3,iAtom)
         If (Invariant(1)) Then
            dO1_dx1 = Zero
            dO1_dy1 = Zero
            dO1_dz1 = Zero
         End If
         If (Invariant(2)) Then
            dO2_dx1 = Zero
            dO2_dy1 = Zero
            dO2_dz1 = Zero
         End If
         If (Invariant(3)) Then
            dO3_dx1 = Zero
            dO3_dy1 = Zero
            dO3_dz1 = Zero
         End If
         Do jAtom = 1, iAtom-1
            dO1_dx2 =  Grad(1,1,jAtom)
            dO2_dx2 =  Grad(2,1,jAtom)
            dO3_dx2 =  Grad(3,1,jAtom)
            dO1_dy2 =  Grad(1,2,jAtom)
            dO2_dy2 =  Grad(2,2,jAtom)
            dO3_dy2 =  Grad(3,2,jAtom)
            dO1_dz2 =  Grad(1,3,jAtom)
            dO2_dz2 =  Grad(2,3,jAtom)
            dO3_dz2 =  Grad(3,3,jAtom)
            If (Invariant(1)) Then
               dO1_dx2 = Zero
               dO1_dy2 = Zero
               dO1_dz2 = Zero
            End If
            If (Invariant(2)) Then
               dO2_dx2 = Zero
               dO2_dy2 = Zero
               dO2_dz2 = Zero
            End If
            If (Invariant(3)) Then
               dO3_dx2 = Zero
               dO3_dy2 = Zero
               dO3_dz2 = Zero
            End If
*
            f_const=Max(Rot_Const,f_const_Min_)
            Hess(LHR(1,iAtom,1,jAtom))=Hess(LHR(1,iAtom,1,jAtom))
     &          + f_const  *(dO1_dx1*dO1_dx2
     &                      +dO2_dx1*dO2_dx2
     &                      +dO3_dx1*dO3_dx2)
            Hess(LHR(1,iAtom,2,jAtom))=Hess(LHR(1,iAtom,2,jAtom))
     &          + f_const  *(dO1_dx1*dO1_dy2
     &                      +dO2_dx1*dO2_dy2
     &                      +dO3_dx1*dO3_dy2)
            Hess(LHR(1,iAtom,3,jAtom))=Hess(LHR(1,iAtom,3,jAtom))
     &          + f_const  *(dO1_dx1*dO1_dz2
     &                      +dO2_dx1*dO2_dz2
     &                      +dO3_dx1*dO3_dz2)
            Hess(LHR(2,iAtom,1,jAtom))=Hess(LHR(2,iAtom,1,jAtom))
     &          + f_const  *(dO1_dy1*dO1_dx2
     &                      +dO2_dy1*dO2_dx2
     &                      +dO3_dy1*dO3_dx2)
            Hess(LHR(2,iAtom,2,jAtom))=Hess(LHR(2,iAtom,2,jAtom))
     &          + f_const  *(dO1_dy1*dO1_dy2
     &                      +dO2_dy1*dO2_dy2
     &                      +dO3_dy1*dO3_dy2)
            Hess(LHR(2,iAtom,3,jAtom))=Hess(LHR(2,iAtom,3,jAtom))
     &          + f_const  *(dO1_dy1*dO1_dz2
     &                      +dO2_dy1*dO2_dz2
     &                      +dO3_dy1*dO3_dz2)
            Hess(LHR(3,iAtom,1,jAtom))=Hess(LHR(3,iAtom,1,jAtom))
     &          + f_const  *(dO1_dz1*dO1_dx2
     &                      +dO2_dz1*dO2_dx2
     &                      +dO3_dz1*dO3_dx2)
            Hess(LHR(3,iAtom,2,jAtom))=Hess(LHR(3,iAtom,2,jAtom))
     &          + f_const  *(dO1_dz1*dO1_dy2
     &                      +dO2_dz1*dO2_dy2
     &                      +dO3_dz1*dO3_dy2)
            Hess(LHR(3,iAtom,3,jAtom))=Hess(LHR(3,iAtom,3,jAtom))
     &          + f_const  *(dO1_dz1*dO1_dz2
     &                      +dO2_dz1*dO2_dz2
     &                      +dO3_dz1*dO3_dz2)
*
         End Do
*
         Hess(LHR(1,iAtom,1,iAtom))=Hess(LHR(1,iAtom,1,iAtom))
     &          + f_const  *(dO1_dx1*dO1_dx1
     &                      +dO2_dx1*dO2_dx1
     &                      +dO3_dx1*dO3_dx1)
         Hess(LHR(2,iAtom,1,iAtom))=Hess(LHR(2,iAtom,1,iAtom))
     &          + f_const  *(dO1_dy1*dO1_dx1
     &                      +dO2_dy1*dO2_dx1
     &                      +dO3_dy1*dO3_dx1)
         Hess(LHR(2,iAtom,2,iAtom))=Hess(LHR(2,iAtom,2,iAtom))
     &          + f_const  *(dO1_dy1*dO1_dy1
     &                      +dO2_dy1*dO2_dy1
     &                      +dO3_dy1*dO3_dy1)
         Hess(LHR(3,iAtom,1,iAtom))=Hess(LHR(3,iAtom,1,iAtom))
     &          + f_const  *(dO1_dz1*dO1_dx1
     &                      +dO2_dz1*dO2_dx1
     &                      +dO3_dz1*dO3_dx1)
         Hess(LHR(3,iAtom,2,iAtom))=Hess(LHR(3,iAtom,2,iAtom))
     &          + f_const  *(dO1_dz1*dO1_dy1
     &                      +dO2_dz1*dO2_dy1
     &                      +dO3_dz1*dO3_dy1)
         Hess(LHR(3,iAtom,3,iAtom))=Hess(LHR(3,iAtom,3,iAtom))
     &          + f_const  *(dO1_dz1*dO1_dz1
     &                      +dO2_dz1*dO2_dz1
     &                      +dO3_dz1*dO3_dz1)
*
      End Do
      Call mma_deallocate(Grad)
#ifdef _DEBUGPRINT_
      Call TriPrt(' In LNM: Hessian after Rotation','(12f12.7)',
     &               Hess,n3)
      Call DiagMtrx_T(Hess,n3,iNeg)
#endif
 778  Continue
      Call mma_deallocate(xMass)
*                                                                      *
************************************************************************
*                                                                      *
*     Hessian for tension
*
*
      Do iBond = 1, nBonds
         kAtom = iTabBonds(1,iBond)
         lAtom = iTabBonds(2,iBond)
         iBondType  = iTabBonds(3,iBond)
C        If (iBondType.gt.Magic_Bond) Go To 10
         kr=iTabRow(iANr(kAtom))
         lr=iTabRow(iANr(lAtom))
         Help = kr.gt.3.or.lr.gt.3
         xkl=Cart(1,kAtom)-Cart(1,lAtom)
         ykl=Cart(2,kAtom)-Cart(2,lAtom)
         zkl=Cart(3,kAtom)-Cart(3,lAtom)
         rkl2 = xkl**2 + ykl**2 + zkl**2
*
         If (ddV_Schlegel.or.Help) Then
            Rab=Sqrt(rkl2)
            RabCov=CovRad(iANr(kAtom))+CovRad(iANr(lAtom))
            If ((kr.eq.1.and.lr.eq.1).or.Help) Then
               gmm=Fact*A_StrH(1)*Exp(-A_StrH(2)*(Rab-RabCov))
            Else
               ij=Max(kr,lr)*(Max(kr,lr)-1)/2 + Min(kr,lr)
               gmm=Fact*A_Str/(Rab-B_Str(ij))**3
            End If
         Else
            r0=rAv(kr,lr)
            alpha=aAv(kr,lr)
            gmm=rkr     *Exp(alpha    *(r0    **2-rkl2))
            If (iAnd(iOptC,1024).eq.1024) Then
               r0_vdW= r_ref_vdW(kr,lr)
               g_vdW = rkr_vdW*Exp(-alpha_vdW*(r0_vdW-SQRT(rkl2))**2)
            Else
               g_vdW=0.0D0
            End If
            gmm = gmm + g_vdW
         End If
*
         f_const = Max(gmm,f_const_Min_)
#ifdef _DEBUGPRINT_
         nqR=nqR+1
         Write (6,*) 'ddV: bonds: kAtom,lAtom=',kAtom,LAtom
         Write (6,*) '          : Bondtype=',iBondType
*        Write (6,*) gmm/rkr, f_const, g_vdW
         Write (6,*) f_const
#endif
         Hxx=f_const*xkl*xkl/rkl2
         Hxy=f_const*xkl*ykl/rkl2
         Hxz=f_const*xkl*zkl/rkl2
         Hyy=f_const*ykl*ykl/rkl2
         Hyz=f_const*ykl*zkl/rkl2
         Hzz=f_const*zkl*zkl/rkl2
*
         Hess(LHR(1,kAtom,1,kAtom))=Hess(LHR(1,kAtom,1,kAtom))+Hxx
         Hess(LHR(2,kAtom,1,kAtom))=Hess(LHR(2,kAtom,1,kAtom))+Hxy
         Hess(LHR(2,kAtom,2,kAtom))=Hess(LHR(2,kAtom,2,kAtom))+Hyy
         Hess(LHR(3,kAtom,1,kAtom))=Hess(LHR(3,kAtom,1,kAtom))+Hxz
         Hess(LHR(3,kAtom,2,kAtom))=Hess(LHR(3,kAtom,2,kAtom))+Hyz
         Hess(LHR(3,kAtom,3,kAtom))=Hess(LHR(3,kAtom,3,kAtom))+Hzz
*
         Hess(LHR(1,kAtom,1,lAtom))=Hess(LHR(1,kAtom,1,lAtom))-Hxx
         Hess(LHR(1,kAtom,2,lAtom))=Hess(LHR(1,kAtom,2,lAtom))-Hxy
         Hess(LHR(1,kAtom,3,lAtom))=Hess(LHR(1,kAtom,3,lAtom))-Hxz
         Hess(LHR(2,kAtom,1,lAtom))=Hess(LHR(2,kAtom,1,lAtom))-Hxy
         Hess(LHR(2,kAtom,2,lAtom))=Hess(LHR(2,kAtom,2,lAtom))-Hyy
         Hess(LHR(2,kAtom,3,lAtom))=Hess(LHR(2,kAtom,3,lAtom))-Hyz
         Hess(LHR(3,kAtom,1,lAtom))=Hess(LHR(3,kAtom,1,lAtom))-Hxz
         Hess(LHR(3,kAtom,2,lAtom))=Hess(LHR(3,kAtom,2,lAtom))-Hyz
         Hess(LHR(3,kAtom,3,lAtom))=Hess(LHR(3,kAtom,3,lAtom))-Hzz
*
         Hess(LHR(1,lAtom,1,lAtom))=Hess(LHR(1,lAtom,1,lAtom))+Hxx
         Hess(LHR(2,lAtom,1,lAtom))=Hess(LHR(2,lAtom,1,lAtom))+Hxy
         Hess(LHR(2,lAtom,2,lAtom))=Hess(LHR(2,lAtom,2,lAtom))+Hyy
         Hess(LHR(3,lAtom,1,lAtom))=Hess(LHR(3,lAtom,1,lAtom))+Hxz
         Hess(LHR(3,lAtom,2,lAtom))=Hess(LHR(3,lAtom,2,lAtom))+Hyz
         Hess(LHR(3,lAtom,3,lAtom))=Hess(LHR(3,lAtom,3,lAtom))+Hzz
*
C10      Continue
      End Do
#ifdef _DEBUGPRINT_
      Call TriPrt(' In LNM: Hessian after tension','(12f12.7)',
     &               Hess,n3)
      Call DiagMtrx_T(Hess,n3,iNeg)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Hessian for bending
*
      If (nBonds.lt.2) Go To 999
      Do mAtom = 1, mTtAtm
         mr=iTabRow(iANr(mAtom))
*
         nNeighbor=iTabAtoms(1,0,mAtom)
         If (nNeighbor.lt.2) Go To 20
         Do iNeighbor = 1, nNeighbor
            iAtom=iTabAtoms(1,iNeighbor,mAtom)
            iBond=iTabAtoms(2,iNeighbor,mAtom)
            iBondType  = iTabBonds(3,iBond)
            If (iBondType.gt.Magic_Bond) Go To 30
            ir=iTabRow(iANr(iAtom))
*
            xmi=(Cart(1,iAtom)-Cart(1,mAtom))
            ymi=(Cart(2,iAtom)-Cart(2,mAtom))
            zmi=(Cart(3,iAtom)-Cart(3,mAtom))
            rmi2 = xmi**2 + ymi**2 + zmi**2
            rmi=sqrt(rmi2)
*
            Do jNeighbor = 1, iNeighbor-1
               jAtom=iTabAtoms(1,jNeighbor,mAtom)
               jBond=iTabAtoms(2,jNeighbor,mAtom)
               jBondType  = iTabBonds(3,jBond)
               If (jBondType.gt.Magic_Bond) Go To 40
               jr=iTabRow(iANr(jAtom))
               Help=mr.gt.3.or.ir.gt.3.or.jr.gt.3
*
               xmj=(Cart(1,jAtom)-Cart(1,mAtom))
               ymj=(Cart(2,jAtom)-Cart(2,mAtom))
               zmj=(Cart(3,jAtom)-Cart(3,mAtom))
               rmj2 = xmj**2 + ymj**2 + zmj**2
               rmj=sqrt(rmj2)
*
*------------- Test if zero angle
*
               Test_zero=xmi*xmj+ymi*ymj+zmi*zmj
               Test_zero=Test_zero/(rmi*rmj)
               If (Abs(Test_zero-One).lt.1.0D-12) Go To 40
*
               xij=(Cart(1,jAtom)-Cart(1,iAtom))
               yij=(Cart(2,jAtom)-Cart(2,iAtom))
               zij=(Cart(3,jAtom)-Cart(3,iAtom))
               rij2 = xij**2 + yij**2 + zij**2
               rrij=sqrt(rij2)
*
               If (ddV_Schlegel.or.Help) Then
                  Rab=rmi
                  RabCov=CovRad(iANr(iAtom))+CovRad(iANr(mAtom))
                  Rbc=rmj
                  RbcCov=CovRad(iANr(jAtom))+CovRad(iANr(mAtom))
                  If (ir.eq.1.or.jr.eq.1) Then
                     gij=Fact*A_Bend(1)
                  Else
                     gij=Fact*A_Bend(2)
                  End If
               Else
                  r0mi=rAv(mr,ir)
                  ami=aAv(mr,ir)
                  r0mj=rAv(mr,jr)
                  amj=aAv(mr,jr)
                  gim=exp(ami*(r0mi**2-rmi2))
                  gjm=exp(amj*(r0mj**2-rmj2))
                  If (iAnd(iOptC,1024).eq.1024) Then
                     r0_vdW_im= r_ref_vdW(ir,mr)
                     g_vdW_im = Exp(-alpha_vdW*
     &                              (r0_vdW_im-SQRT(rmi2))**2
     &                             )
                     r0_vdW_jm= r_ref_vdW(jr,mr)
                     g_vdW_jm = Exp(-alpha_vdW*
     &                              (r0_vdW_jm-SQRT(rmj2))**2
     &                             )
                  Else
                     g_vdW_im=0.0D0
                     g_vdW_jm=0.0D0
                  End If
                  g_vdW_im = g_vdW_im * rkr_vdW / rkr
                  g_vdW_jm = g_vdW_jm * rkr_vdW / rkr
                  gim = gim + Half*g_vdW_im
                  gjm = gjm + Half*g_vdW_jm
                  gij = rkf* gim*gjm
               End If
               rL2=(ymi*zmj-zmi*ymj)**2
     &            +(zmi*xmj-xmi*zmj)**2
     &            +(xmi*ymj-ymi*xmj)**2
chjw modified
            If(rL2.lt.1.d-14) then
              rL=Zero
            else
              rL=sqrt(rL2)
            end if
            gij=Max(gij,f_const_Min_)
#ifdef _DEBUGPRINT_
            Write (6,*) 'iAtom,mAtom,jAtom=',iAtom,mAtom,jAtom
            Write (6,*) 'gij=',gij
            Write (6,*) 'rmj=',rmj
            Write (6,*) 'rmi=',rmi
            Write (6,*) 'rrij=',rrij
#endif
*
            if ((rmj.gt.rZero).and.(rmi.gt.rZero).and.
     &                                (rrij.gt.rZero)) Then
#ifdef _DEBUGPRINT_
              nqB=nqB+1
#endif
              SinPhi=rL/(rmj*rmi)
              rmidotrmj=xmi*xmj+ymi*ymj+zmi*zmj
              CosPhi=rmidotrmj/(rmj*rmi)
*
*-------------Non-linear case
*
              Thr_Line=Sin(Pi*25.0d0/180.0D0)
              If (mTtAtm.eq.3) Thr_Line=rZero
              If (SinPhi.gt.Thr_Line) Then
                si(1)=(xmi/rmi*cosphi-xmj/rmj)/(rmi*sinphi)
                si(2)=(ymi/rmi*cosphi-ymj/rmj)/(rmi*sinphi)
                si(3)=(zmi/rmi*cosphi-zmj/rmj)/(rmi*sinphi)
                sj(1)=(cosphi*xmj/rmj-xmi/rmi)/(rmj*sinphi)
                sj(2)=(cosphi*ymj/rmj-ymi/rmi)/(rmj*sinphi)
                sj(3)=(cosphi*zmj/rmj-zmi/rmi)/(rmj*sinphi)
                sm(1)=-si(1)-sj(1)
                sm(2)=-si(2)-sj(2)
                sm(3)=-si(3)-sj(3)
                Do icoor=1,3
                   Do jCoor=1,3
                    If (mAtom.gt.iAtom) Then
                       Hess(LHR(icoor,mAtom,jcoor,iAtom))=
     &                        Hess(LHR(icoor,mAtom,jcoor,iAtom))
     &                        +gij*sm(icoor)*si(jcoor)
                    else
                      Hess(LHR(icoor,iAtom,jcoor,mAtom))=
     &                        Hess(LHR(icoor,iAtom,jcoor,mAtom))
     &                        +gij*si(icoor)*sm(jcoor)
                    End If
                    If (mAtom.gt.jAtom) Then
                        Hess(LHR(icoor,mAtom,jcoor,jAtom))=
     &                        Hess(LHR(icoor,mAtom,jcoor,jAtom))
     &                        +gij*sm(icoor)*sj(jcoor)
                    else
                      Hess(LHR(icoor,jAtom,jcoor,mAtom))=
     &                        Hess(LHR(icoor,jAtom,jcoor,mAtom))
     &                        +gij*sj(icoor)*sm(jcoor)
                    End If
                    If (iAtom.gt.jAtom) Then
                        Hess(LHR(icoor,iAtom,jcoor,jAtom))=
     &                        Hess(LHR(icoor,iAtom,jcoor,jAtom))
     &                        +gij*si(icoor)*sj(jcoor)
                     else
                        Hess(LHR(icoor,jAtom,jcoor,iAtom))=
     &                        Hess(LHR(icoor,jAtom,jcoor,iAtom))
     &                        +gij*sj(icoor)*si(jcoor)
                     End If
                   End Do
                End Do
                Do icoor=1,3
                  Do jCoor=1,icoor
                    Hess(LHR(icoor,iAtom,jcoor,iAtom))=
     &                        Hess(LHR(icoor,iAtom,jcoor,iAtom))
     &                        +gij*si(icoor)*si(jcoor)
                    Hess(LHR(icoor,mAtom,jcoor,mAtom))=
     &                        Hess(LHR(icoor,mAtom,jcoor,mAtom))
     &                        +gij*sm(icoor)*sm(jcoor)
                    Hess(LHR(icoor,jAtom,jcoor,jAtom))=
     &                        Hess(LHR(icoor,jAtom,jcoor,jAtom))
     &                        +gij*sj(icoor)*sj(jcoor)

*
                  End Do
                End Do
              Else
*
*---------------Linear case
*
                If ((abs(ymi).gt.rZero).or.
     &              (abs(xmi).gt.rZero)) Then
                   x(1)=-ymi
                   y(1)=xmi
                   z(1)=Zero
                   x(2)=-xmi*zmi
                   y(2)=-ymi*zmi
                   z(2)=xmi*xmi+ymi*ymi
                Else
                   x(1)=One
                   y(1)=Zero
                   z(1)=Zero
                   x(2)=Zero
                   y(2)=One
                   z(2)=Zero
                End If
#ifdef _DEBUGPRINT_
                nqB=nqB+2
#endif
                Do i=1,2
                   r1=sqrt(x(i)**2+y(i)**2+z(i)**2)
                   cosThetax=x(i)/r1
                   cosThetay=y(i)/r1
                   cosThetaz=z(i)/r1
                   si(1)=-cosThetax/rmi
                   si(2)=-cosThetay/rmi
                   si(3)=-cosThetaz/rmi
                   sj(1)=-cosThetax/rmj
                   sj(2)=-cosThetay/rmj
                   sj(3)=-cosThetaz/rmj
                   sm(1)=-(si(1)+sj(1))
                   sm(2)=-(si(2)+sj(2))
                   sm(3)=-(si(3)+sj(3))
*
                   Do icoor=1,3
                      Do jCoor=1,3
                         If (mAtom.gt.iAtom) Then
                          Hess(LHR(icoor,mAtom,jcoor,iAtom))=
     &                        Hess(LHR(icoor,mAtom,jcoor,iAtom))
     &                         +gij*sm(icoor)*si(jcoor)
                        else
                           Hess(LHR(icoor,iAtom,jcoor,mAtom))=
     &                        Hess(LHR(icoor,iAtom,jcoor,mAtom))
     &                         +gij*si(icoor)*sm(jcoor)
                        End If
                        If (mAtom.gt.jAtom) Then
                          Hess(LHR(icoor,mAtom,jcoor,jAtom))=
     &                        Hess(LHR(icoor,mAtom,jcoor,jAtom))
     &                         +gij*sm(icoor)*sj(jcoor)
                        else
                          Hess(LHR(icoor,jAtom,jcoor,mAtom))=
     &                        Hess(LHR(icoor,jAtom,jcoor,mAtom))
     &                         +gij*sj(icoor)*sm(jcoor)
                        End If
                        If (iAtom.gt.jAtom) Then
                           Hess(LHR(icoor,iAtom,jcoor,jAtom))=
     &                        Hess(LHR(icoor,iAtom,jcoor,jAtom))
     &                         +gij*si(icoor)*sj(jcoor)
                        else
                           Hess(LHR(icoor,jAtom,jcoor,iAtom))=
     &                        Hess(LHR(icoor,jAtom,jcoor,iAtom))
     &                         +gij*sj(icoor)*si(jcoor)
                        End If
                       End Do
                     End Do
                     Do icoor=1,3
                       Do jCoor=1,icoor
                         Hess(LHR(icoor,iAtom,jcoor,iAtom))=
     &                        Hess(LHR(icoor,iAtom,jcoor,iAtom))
     &                         +gij*si(icoor)*si(jcoor)
                         Hess(LHR(icoor,mAtom,jcoor,mAtom))=
     &                        Hess(LHR(icoor,mAtom,jcoor,mAtom))
     &                         +gij*sm(icoor)*sm(jcoor)
                         Hess(LHR(icoor,jAtom,jcoor,jAtom))=
     &                         Hess(LHR(icoor,jAtom,jcoor,jAtom))
     &                         +gij*sj(icoor)*sj(jcoor)
                       End Do
                     End Do
                 End Do
              End If
            End If
*
 40         Continue
        End Do
 30         Continue
       End Do
 20    Continue
      End Do
#ifdef _DEBUGPRINT_
      Call TriPrt(' In LNM: Hessian after bending','(12f12.7)',
     &               Hess,n3)
      Call DiagMtrx_T(Hess,n3,iNeg)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Hessian for torsion
*
      If (nBonds.lt.3) Go To 999
      Do iBond = 1, nBonds
         jAtom=iTabBonds(1,iBond)
         kAtom=iTabBonds(2,iBond)
         iBondType =iTabBonds(3,iBond)
         Fact = One
         If (iBondType.gt.Magic_Bond) Fact=Two
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*) '*',jAtom,kAtom,' *'
         Write (6,*)
         Write (6,*) 'BondType=',iBondType
#endif
*
*        Allow center bond to be a "magic" bond
*
C        If (iBondType.eq.vdW_Bond) Go To 444

         jr=iTabRow(iANr(jAtom))
         kr=iTabRow(iANr(kAtom))
*
         call dcopy_(3,Cart(1,jAtom),1,xyz(1,2),1)
         call dcopy_(3,Cart(1,kAtom),1,xyz(1,3),1)
*
         nNeighbor_j = iTabAtoms(1,0,jAtom)
         If (nNeighbor_j.lt.2) Go To 444
         nNeighbor_k = iTabAtoms(1,0,kAtom)
         If (nNeighbor_k.lt.2) Go To 444
*
         Do jNeighbor = 1, nNeighbor_j
            iAtom = iTabAtoms(1,jNeighbor,jAtom)
#ifdef _DEBUGPRINT_
*           Write (6,*)
*           Write (6,*) iAtom,jAtom,kAtom,' *'
*           Write (6,*)
#endif
            jBond = iTabAtoms(2,jNeighbor,jAtom)
            If (iBond.eq.jBond) Go To 333
            jBondType =iTabBonds(3,jBond)
C           If (jBondType.eq.vdW_Bond) Go To 333
            If (jBondType.gt.Magic_Bond) Go To 333
            ir=iTabRow(iANr(iAtom))
*
            call dcopy_(3,Cart(1,iAtom),1,xyz(1,1),1)
*
            Do kNeighbor = 1, nNeighbor_k
               lAtom = iTabAtoms(1,kNeighbor,kAtom)
               kBond = iTabAtoms(2,kNeighbor,kAtom)
               If (iBond.eq.kBond) Go To 222
               If (lAtom.eq.iAtom) Go To 222
               kBondType =iTabBonds(3,kBond)
C              If (kBondType.eq.vdW_Bond) Go To 222
               If (kBondType.gt.Magic_Bond) Go To 222
               lr=iTabRow(iANr(lAtom))
               Help=kr.gt.3.or.ir.gt.3.or.jr.gt.3.or.lr.gt.3
*
               call dcopy_(3,Cart(1,lAtom),1,xyz(1,4),1)
*
               rij(1)=Cart(1,iAtom)-Cart(1,jAtom)
               rij(2)=Cart(2,iAtom)-Cart(2,jAtom)
               rij(3)=Cart(3,iAtom)-Cart(3,jAtom)
               rij2=rij(1)**2+rij(2)**2+rij(3)**2
*
               rjk(1)=Cart(1,jAtom)-Cart(1,kAtom)
               rjk(2)=Cart(2,jAtom)-Cart(2,kAtom)
               rjk(3)=Cart(3,jAtom)-Cart(3,kAtom)
               rjk2=rjk(1)**2+rjk(2)**2+rjk(3)**2
*
               rkl(1)=Cart(1,kAtom)-Cart(1,lAtom)
               rkl(2)=Cart(2,kAtom)-Cart(2,lAtom)
               rkl(3)=Cart(3,kAtom)-Cart(3,lAtom)
               rkl2=rkl(1)**2+rkl(2)**2+rkl(3)**2
*
*              Allow only angles in the range of 35-145
               A35 = (35.0D0/180.D0)* Pi
               CosFi_Max=Cos(A35)
               CosFi2=(rij(1)*rjk(1)+rij(2)*rjk(2)+rij(3)*rjk(3))
     &               /Sqrt(rij2*rjk2)
               If (Abs(CosFi2).gt.CosFi_Max) Go To 222
               CosFi3=(rkl(1)*rjk(1)+rkl(2)*rjk(2)+rkl(3)*rjk(3))
     &               /Sqrt(rkl2*rjk2)
               If (Abs(CosFi3).gt.CosFi_Max) Go To 222
#ifdef _DEBUGPRINT_
               Write (6,*) 'CosFi2,CosFi3=',CosFi2,CosFi3
               Write (6,*) 'rij=',rij,rij2
               Write (6,*) 'rjk=',rjk,rjk2
               Write (6,*) 'rkl=',rkl,rkl2
#endif
*
               If (ddV_Schlegel.or.Help) Then
                  Rab=Sqrt(rij2)
                  RabCov=(CovRadT(iANr(iAtom))
     &                   +CovRadT(iANr(jAtom)))/bohr
                  Rbc=Sqrt(rjk2)/Fact
                  RbcCov=(CovRadT(iANr(jAtom))
     &                   +CovRadT(iANr(kAtom)))/bohr
                  Diff=RbcCov-Rbc
                  If (Diff.lt.Zero) Diff=Zero
                  tij=Fact*A_Trsn(1)+A_Trsn(2)*Diff
               Else
                  rij0=rAv(ir,jr)**2
                  aij =aAv(ir,jr)
                  rjk0=rAv(jr,kr)**2
                  ajk =aAv(jr,kr)
                  rkl0=rAv(kr,lr)**2
                  akl =aAv(kr,lr)
*                 Magic bond fix
                  rjk2=rjk2/Fact**2
*
                  g_ij=exp(aij*(rij0-rij2))
                  g_jk=exp(ajk*(rjk0-rjk2))
                  g_kl=exp(akl*(rkl0-rkl2))
                  If (iAnd(iOptC,1024).eq.1024) Then
                     r0_vdW_ij= r_ref_vdW(ir,jr)
                     g_vdW_ij = Exp(-alpha_vdW*
     &                              (r0_vdW_ij-SQRT(rij2))**2
     &                             )
                     r0_vdW_jk= r_ref_vdW(jr,kr)
                     g_vdW_jk = Exp(-alpha_vdW*
     &                              (r0_vdW_jk-SQRT(rjk2))**2
     &                             )
                     r0_vdW_kl= r_ref_vdW(kr,lr)
                     g_vdW_kl = Exp(-alpha_vdW*
     &                              (r0_vdW_kl-SQRT(rkl2))**2
     &                             )
                  Else
                     g_vdW_ij=0.0D0
                     g_vdW_jk=0.0D0
                     g_vdW_kl=0.0D0
                  End If
                  g_vdW_ij = g_vdW_ij * rkr_vdW / rkr
                  g_vdW_jk = g_vdW_jk * rkr_vdW / rkr
                  g_vdW_kl = g_vdW_kl * rkr_vdW / rkr
                  g_ij=g_ij + Half * g_vdW_ij
                  g_jk=g_jk + Half * g_vdW_jk
                  g_kl=g_kl + Half * g_vdW_kl
                  tij=rkt*g_ij*g_jk*g_kl
               End If
               tij = Max(tij,f_const_Min_)
               If (Torsion_Check(iAtom,jAtom,kAtom,lAtom,
     &                           xyz,iTabAtoms,
     &                           nMax,mTtAtm) )Then
                  tij = Max(tij,10.0D0*f_const_Min_)
               End If
#ifdef _DEBUGPRINT_
               nqT=nqT+1
               Write (6,*)
               Write (6,*) iAtom,jAtom,kAtom,lAtom
               Write (6,*) tij
#endif
*
               Call Trsn(xyz,4,Tau,C,.False.,.False.,'        ',
     &                   Dum,.False.)
               call dcopy_(3,C(1,1),1,si,1)
               call dcopy_(3,C(1,2),1,sj,1)
               call dcopy_(3,C(1,3),1,sk,1)
               call dcopy_(3,C(1,4),1,sl,1)
#ifdef _DEBUGPRINT_
*              Call RecPrt('C',' ',C,3,4)
#endif
*
*------------- Off diagonal block
*
              Do icoor=1,3
                Do jCoor=1,3
                 Hess(LHR(icoor,iAtom,jcoor,jAtom))=
     &           Hess(LHR(icoor,iAtom,jcoor,jAtom))
     &            +tij*si(icoor) * sj(jcoor)
                 Hess(LHR(icoor,iAtom,jcoor,kAtom))=
     &           Hess(LHR(icoor,iAtom,jcoor,kAtom))
     &            +tij*si(icoor) * sk(jcoor)
                 Hess(LHR(icoor,iAtom,jcoor,lAtom))=
     &           Hess(LHR(icoor,iAtom,jcoor,lAtom))
     &            +tij*si(icoor) * sl(jcoor)
                 Hess(LHR(icoor,jAtom,jcoor,kAtom))=
     &           Hess(LHR(icoor,jAtom,jcoor,kAtom))
     &            +tij*sj(icoor) * sk(jcoor)
                 Hess(LHR(icoor,jAtom,jcoor,lAtom))=
     &           Hess(LHR(icoor,jAtom,jcoor,lAtom))
     &            +tij*sj(icoor) * sl(jcoor)
                 Hess(LHR(icoor,kAtom,jcoor,lAtom))=
     &           Hess(LHR(icoor,kAtom,jcoor,lAtom))
     &            +tij*sk(icoor) * sl(jcoor)

                End Do
              End Do
*
*-------------Diagonal block
*
              Do icoor=1,3
                Do jCoor=1,icoor
                 Hess(LHR(icoor,iAtom,jcoor,iAtom))=
     &           Hess(LHR(icoor,iAtom,jcoor,iAtom))
     &            +tij*si(icoor) * si(jcoor)
                 Hess(LHR(icoor,jAtom,jcoor,jAtom))=
     &           Hess(LHR(icoor,jAtom,jcoor,jAtom))
     &            +tij*sj(icoor) * sj(jcoor)
                 Hess(LHR(icoor,kAtom,jcoor,kAtom))=
     &           Hess(LHR(icoor,kAtom,jcoor,kAtom))
     &            +tij*sk(icoor) * sk(jcoor)
                 Hess(LHR(icoor,lAtom,jcoor,lAtom))=
     &           Hess(LHR(icoor,lAtom,jcoor,lAtom))
     &            +tij*sl(icoor) * sl(jcoor)

*
                 End Do
               End Do
*
 222           Continue
            End Do          ! iNeigbor_k
 333        Continue
         End Do             ! iNeighbor_j
 444     Continue
      End Do                ! iBonds
#ifdef _DEBUGPRINT_
      Call TriPrt(' In LNM: Hessian after torsion','(12f12.7)',
     &               Hess,n3)
      Call DiagMtrx_T(Hess,n3,iNeg)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*                                      k
*                                     /
*     Hessian for out-of-plane   j - i
*                                     \
*                                      l
*
C     Go To 999
      If (nBonds.lt.3) Go To 999
*
      Do iAtom = 1, mTtAtm
*
         nNeighbor_i = iTabAtoms(1,0,iAtom)
C        Write (*,*) 'iAtom,nNeighbor_i=',iAtom,nNeighbor_i
         If (nNeighbor_i.lt.3) Go To 446
         ir=iTabRow(iANr(iAtom))
         call dcopy_(3,Cart(1,iAtom),1,xyz(1,4),1)
*
         Do iNb0 = 1, nNeighbor_i
            jAtom = iTabAtoms(1,iNb0,iAtom)
C           Write (*,*) 'jAtom=',jAtom
            jr=iTabRow(iANr(jAtom))
            iBond = iTabAtoms(2,iNb0,iAtom)
            iBondType=iTabBonds(3,iBond)
C           Write (*,*) 'iBondType=',iBondType
            nCoBond_j=nCoBond(jAtom,mTtAtm,nMax,iTabBonds,
     &                        nBonds,iTabAtoms)
            If (nCoBond_j.gt.1) Go To 447
*           If (iBondType.eq.vdW_Bond) Go To 447
            If (iBondType.gt.Magic_Bond) Go To 447
            call dcopy_(3,Cart(1,jAtom),1,xyz(1,1),1)
*
            Do iNb1 = 1, nNeighbor_i
               kAtom = iTabAtoms(1,iNb1,iAtom)
C              Write (*,*) 'kAtom=',kAtom
               kBond = iTabAtoms(2,iNb1,iAtom)
               If (kAtom.eq.jAtom) Go To 335
               kBondType=iTabBonds(3,kBond)
C              Write (*,*) 'kBondType=',kBondType
*              If (kBondType.eq.vdW_Bond) Go To 335
               If (kBondType.gt.Magic_Bond) Go To 335
               kr=iTabRow(iANr(kAtom))
*
               call dcopy_(3,Cart(1,kAtom),1,xyz(1,2),1)
*
               Do iNb2 = 1, nNeighbor_i
                  lAtom = iTabAtoms(1,iNb2,iAtom)
C                 Write (6,*) 'lAtom=',lAtom
                  lBond = iTabAtoms(2,iNb2,iAtom)

                  If (lAtom.eq.jAtom) Go To 224
                  If (lAtom.le.kAtom) Go To 224
                  lBondType=iTabBonds(3,lBond)
C                 Write (*,*) 'lBondType=',lBondType
*                 If (lBondType.eq.vdW_Bond) Go To 224
                  If (lBondType.gt.Magic_Bond) Go To 224
                  lr=iTabRow(iANr(lAtom))
                  Help=kr.gt.3.or.ir.gt.3.or.jr.gt.3.or.lr.gt.3
*
C                 Write (*,*) 'i,j,k,l=',iAtom,jAtom,kAtom,lAtom
C                 Write (*,*) 'Help=',Help
*
                  call dcopy_(3,Cart(1,lAtom),1,xyz(1,3),1)
*
                  rij(1)=Cart(1,iAtom)-Cart(1,jAtom)
                  rij(2)=Cart(2,iAtom)-Cart(2,jAtom)
                  rij(3)=Cart(3,iAtom)-Cart(3,jAtom)
*
                  rik(1)=Cart(1,iAtom)-Cart(1,kAtom)
                  rik(2)=Cart(2,iAtom)-Cart(2,kAtom)
                  rik(3)=Cart(3,iAtom)-Cart(3,kAtom)
*
                  ril(1)=Cart(1,iAtom)-Cart(1,lAtom)
                  ril(2)=Cart(2,iAtom)-Cart(2,lAtom)
                  ril(3)=Cart(3,iAtom)-Cart(3,lAtom)
*
                  rij2=rij(1)**2+rij(2)**2+rij(3)**2
                  rik2=rik(1)**2+rik(2)**2+rik(3)**2
                  ril2=ril(1)**2+ril(2)**2+ril(3)**2
*
                  ThrFi1=Cos(90.0D0*Pi/(180.0D0))
                  ThrFi2=Cos(150.0D0*Pi/(180.0D0))
                  CosFi2=(rij(1)*rik(1)+rij(2)*rik(2)+rij(3)*rik(3))
     &                  /Sqrt(rij2*rik2)
                  If (CosFi2.gt.ThrFi1 .or. CosFi2.lt.ThrFi2) Go To 224
*
                  CosFi3=(rij(1)*ril(1)+rij(2)*ril(2)+rij(3)*ril(3))
     &                  /Sqrt(rij2*ril2)
                  If (CosFi3.gt.ThrFi1 .or. CosFi3.lt.ThrFi2) Go To 224
*
                  CosFi4=(rik(1)*ril(1)+rik(2)*ril(2)+rik(3)*ril(3))
     &                  /Sqrt(rik2*ril2)
                  If (CosFi4.gt.ThrFi1 .or. CosFi4.lt.ThrFi2) Go To 224
#ifdef _DEBUGPRINT_
                  Write (6,*) 'CosFi2,CosFi3,CosFi4=',
     &                        CosFi2,CosFi3,CosFi4
#endif
*
                  If (ddV_Schlegel.or.Help) Then
*
*------------------- I do not have a clue to how this will really work!
*
                     tij = f_const_Min_
                 Else
                     rij0=rAv(ir,jr)**2
                     aij =aAv(ir,jr)
                     rik0=rAv(ir,kr)**2
                     aik =aAv(ir,kr)
                     ril0=rAv(ir,lr)**2
                     ail =aAv(ir,lr)
                     beta=rko*
     &                        exp( (aij*rij0+aik*rik0+ail*ril0))
                     tij=beta*exp(-(aij*rij2+aik*rik2+ail*ril2))
                  End If
C                 tij=Max(tij,f_const_Min_)
*
                  Call OutofP(xyz,4,Tau,C,.False.,.False.,'        ',
     &                        Dum,.False.)
                  If (Abs(Tau).gt.25.0D0*(Pi/180.D0)) Go To 224
#ifdef _DEBUGPRINT_
                  nqO=nqO+1
#endif
*
                  call dcopy_(3,C(1,4),1,si,1)
                  call dcopy_(3,C(1,1),1,sj,1)
                  call dcopy_(3,C(1,2),1,sk,1)
                  call dcopy_(3,C(1,3),1,sl,1)
#ifdef _DEBUGPRINT_
                  Write (6,*) 'iAtoms=',
     &                         iAtom,jAtom,kAtom,lAtom
                  Write(6,*) 'tij,Tau=',tij,Tau
*                 Call RecPrt('si',' ',si,1,3)
*                 Call RecPrt('sj',' ',sj,1,3)
*                 Call RecPrt('sk',' ',sk,1,3)
*                 Call RecPrt('sl',' ',sl,1,3)
#endif
*
*---------------- Off diagonal block
*
                  Do icoor=1,3
                    Do jCoor=1,3
                     Hess(LHR(icoor,iAtom,jcoor,jAtom))=
     &               Hess(LHR(icoor,iAtom,jcoor,jAtom))
     &                +tij*si(icoor) * sj(jcoor)
                     Hess(LHR(icoor,iAtom,jcoor,kAtom))=
     &               Hess(LHR(icoor,iAtom,jcoor,kAtom))
     &                +tij*si(icoor) * sk(jcoor)
                     Hess(LHR(icoor,iAtom,jcoor,lAtom))=
     &               Hess(LHR(icoor,iAtom,jcoor,lAtom))
     &                +tij*si(icoor) * sl(jcoor)
                     Hess(LHR(icoor,jAtom,jcoor,kAtom))=
     &               Hess(LHR(icoor,jAtom,jcoor,kAtom))
     &                +tij*sj(icoor) * sk(jcoor)
                     Hess(LHR(icoor,jAtom,jcoor,lAtom))=
     &               Hess(LHR(icoor,jAtom,jcoor,lAtom))
     &                +tij*sj(icoor) * sl(jcoor)
                     Hess(LHR(icoor,kAtom,jcoor,lAtom))=
     &               Hess(LHR(icoor,kAtom,jcoor,lAtom))
     &                +tij*sk(icoor) * sl(jcoor)

                    End Do
                  End Do
*
*---------------- Diagonal block
*
                  Do icoor=1,3
                    Do jCoor=1,icoor
                     Hess(LHR(icoor,iAtom,jcoor,iAtom))=
     &               Hess(LHR(icoor,iAtom,jcoor,iAtom))
     &                +tij*si(icoor) * si(jcoor)
                     Hess(LHR(icoor,jAtom,jcoor,jAtom))=
     &               Hess(LHR(icoor,jAtom,jcoor,jAtom))
     &                +tij*sj(icoor) * sj(jcoor)
                     Hess(LHR(icoor,kAtom,jcoor,kAtom))=
     &               Hess(LHR(icoor,kAtom,jcoor,kAtom))
     &                +tij*sk(icoor) * sk(jcoor)
                     Hess(LHR(icoor,lAtom,jcoor,lAtom))=
     &               Hess(LHR(icoor,lAtom,jcoor,lAtom))
     &                +tij*sl(icoor) * sl(jcoor)

*
                     End Do
                   End Do
*
 224            Continue
                End Do        ! iNb2
 335        Continue
            End Do          ! iNb1
 447        Continue
         End Do             ! iCase
 446     Continue
      End Do               ! iBond
#ifdef _DEBUGPRINT_
      Call TriPrt(' In LNM: Hessian after out-of-plane','(12f12.7)',
     &               Hess,n3)
      Call DiagMtrx_T(Hess,n3,iNeg)
#endif
*                                                                      *
************************************************************************
*                                                                      *
 999  Continue
#ifdef _DEBUGPRINT_
      Write (6,*) 'ddV: nqR, nqB, nqT, nqO=',nqR, nqB, nqT, nqO
#endif
      Return
      End
#ifdef _DEBUGPRINT_
      Subroutine DiagMtrx_T(H,nH,iNeg)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
      character*16 filnam
      Real*8 H(*)
      Logical Exist
      Real*8, Allocatable:: EVal(:), EVec(:), rK(:), qEVec(:)
*
      Lu=6
      iRout=22
      iprint=nPrint(iRout)
*
      Call mma_allocate(EVal,nH*(nH+1)/2,Label='EVal')
      Call mma_allocate(EVec,nH*nH,Label='EVec')
*
*---- Copy elements for H
*
      call dcopy_(nH*(nH+1)/2,H,1,EVal,1)
*
*---- Set up a unit matrix
*
      call dcopy_(nH*nH,[Zero],0,EVec,1)
      call dcopy_(nH,[One],0,EVec,nH+1)
*
*---- Compute eigenvalues and eigenvectors
*
      Call NIDiag_new(EVal,EVec,nH,nH)
      Call Jacord(EVal,EVec,nH,nH)
*
*---- Print out the result
*
      iNeg=0
      Do i = 1, nH
         If (EVal(i*(i+1)/2).lt.Zero) iNeg=iNeg+1
      End Do
      IF (iprint.gt.5) THEN
        Write (Lu,*)
        Write (Lu,*) 'Eigenvalues of the Hessian'
        Write (Lu,*)
        Write (Lu,'(5G20.6)') (EVal(i*(i+1)/2),i=1,nH)
      END IF
*
      call f_Inquire('SPCINX',Exist)
*
      If (Exist .AND. iprint.gt.5) Then
*
*        Read linear combinations from disc
*

         LuTmp=11
         filnam='SPCINX'
c         Open(luTmp,File=filnam,Form='unformatted',Status='unknown')
         Call molcas_binaryopen_vanilla(luTmp,filnam)
         ReWind (LuTmp)
*
         Read (LuTmp) nq,nQQ
*
         If (nQQ.eq.nH) Then
*
           Call mma_allocate(rK,nq*nQQ,Label='rK')
           Call mma_allocate(qEVec,nq*nH,Label='qEVec')

           Call Print_qEVec(EVec,nH,EVal,nq,rK,qEVec,LuTmp)
*
           Call mma_deallocate(qEVec)
           Call mma_deallocate(rk)
*
         Else
*
           Write (Lu,*)
           Write (Lu,*) 'Eigenvectors of the Hessian'
           Write (Lu,*)
           Do i = 1, nH
              Write (Lu,'(10F10.5)')
     &              (EVec((j-1)*nH+i),j=1,nH)
           End Do
         End If
*
         Close (LuTmp)
*
      ElSE IF (iprint.gt.5) THEN
         Write (Lu,*)
         Write (Lu,*) 'Eigenvectors of the Hessian'
         Write (Lu,*)
         Do i = 1, nH
            Write (Lu,'(10F10.5)') (EVec((j-1)*nH+i),j=1,nH)
         End Do
*
      End If
*
      Call mma_deallocate(EVec)
      Call mma_deallocate(EVal)
*
      Return
      End
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CofMss(Coor,dMass,nsAtom,LWrite,cMass,iSym)
************************************************************************
*     Object: To calculate the molecular mass, the center of mass and  *
*             move the coordinates so origo is the center of mass.     *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 COOR(3,nsAtom), dMass(nsAtom), cMass(3)
      Integer iSym(3)
      Logical LWRITE
*
      Return
*
*     Calculate the molecular mass.
*
      TMass = Zero
      Do I = 1, nsAtom
         TMass = TMass + dMass(I) * DBLE(iDeg(Coor(1,i)))
      End Do
      iCOM=-1
      If (TMass.ge.1.D99) Then
         Do i = 1, nsAtom
            If (dMass(i).eq.1.D99) Then
               iCOM=i
               Go To 99
            End If
         End Do
      End If
 99   Continue
*
*     calculate the center of mass
*
      call dcopy_(3,[Zero],0,cMass,1)
*-----Loop over the unique centers
      Do i = 1, nsAtom
         Do j = 1, 3
*-----------Add contribution
            If (iSym(j).eq.0) cMass(j) = cMass(j) +
     &         dMass(i) *  Coor(j,i) *
     &         DBLE(iDeg(Coor(1,i)))
         End Do
      End Do
*
      Do i = 1, 3
         cMass(i) = cMass(i) / TMass
      End Do
      If (iCOM.ge.1.and.iCOM.le.nsAtom)
     &   call dcopy_(3,COOR(1,iCOM),1,cMass,1)
*
      If (LWrite) Write(6,100) (cMass(i),i=1,3), TMass
 100  FORMAT(//,' Center of Mass (Bohr) ',3F10.5,/,
     &          ' Molecular Mass   (au) ',1F15.5)
*
*     translate the center of mass to origo
*
      Do i = 1, nsAtom
         Do j = 1, 3
            Coor(j,i) = Coor(j,i) - cMass(j)
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module welcom

use define_af, only: iTabMx
use Constants, only: Half, Quart
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: kMax = iTabMx+6, k2 = int(kmax*Half)+1, k4 = int(kmax*Quart)+1
integer(kind=iwp) :: ipot3(0:kmax+1)
real(kind=wp) :: anorm(0:kmax,0:k2,0:k4), binom(-1:kmax,-1:kmax), fac(0:kmax), fiint(0:kmax,0:kmax), tetint(0:kmax,0:k2)

public :: anorm, binom, fac, fiint, ipot3, kMax, tetint

end module welcom

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_HEAD(STRING,LINE,LENMAX,LUNIT)
!
! Purpose: print a header.

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: STRING
character, intent(in) :: LINE
integer(kind=iwp), intent(in) :: LENMAX, LUNIT
integer(kind=iwp) :: I, LENSTR, LENTOT

LENSTR = len(STRING)
LENTOT = min(LENSTR,LENMAX-2)
if (LENTOT > 0) then
  write(LUNIT,'(//,2X,A)') STRING(1:LENTOT)
  write(LUNIT,'(2X,80A)') (LINE,I=1,LENTOT)
else
  write(LUNIT,'(//,2X,A,/)') STRING(1:LENSTR)
end if

end subroutine CHO_HEAD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
         subroutine faibj3(NSIJ,IFT,
     &  AIBJ,FSEC,FAC,IN,INS,IPOA,IPOF)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION IPOF(9),IPOA(9),
     & AIBJ(*),FSEC(*)
         CALL IPO(IPOA,NVIR,MUL,NSYM,NSIJ,IFT)
C INTEGRAL COMBINATION APPROPRIATE FOR SINGLET-COUPLING:
         DO 170 IASYM=1,NSYM
            IBSYM=MUL(NSIJ,IASYM)
            IF(IBSYM.GT.IASYM)GO TO 170
            IAB=IPOA(IASYM+1)-IPOA(IASYM)
            IF(IAB.EQ.0)GO TO 170
            IF(NSIJ.EQ.1) THEN
              CALL SECEQ(AIBJ(IPOF(IASYM)+1),AIBJ(IPOF(IBSYM)+1),
     *             FSEC(IN+1),NVIR(IASYM),0,FAC)
            ELSE
              CALL SECNE(AIBJ(IPOF(IASYM)+1),AIBJ(IPOF(IBSYM)+1),
     *             FSEC(IN+1),NVIR(IASYM),NVIR(IBSYM),NSIJ,0)
            END IF
            IN=IN+IAB
170      CONTINUE
         INS=IN
C INTEGRAL COMBINATION APPROPRIATE FOR TRIPLET-COUPLING:
         DO 180 IASYM=1,NSYM
            IBSYM=MUL(NSIJ,IASYM)
            IF(IBSYM.GT.IASYM)GO TO 180
            IAB=IPOA(IASYM+1)-IPOA(IASYM)
            IF(IAB.EQ.0)GO TO 180
            IF(NSIJ.EQ.1) THEN

              CALL SECEQ(AIBJ(IPOF(IASYM)+1),AIBJ(IPOF(IBSYM)+1),
     *             FSEC(IN+1),NVIR(IASYM),1,DUMMY)
            ELSE
              CALL SECNE(AIBJ(IPOF(IASYM)+1),AIBJ(IPOF(IBSYM)+1),
     *             FSEC(IN+1),NVIR(IASYM),NVIR(IBSYM),NSIJ,1)
            END IF
            IN=IN+IAB
180      CONTINUE
         return
         end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!               1994, Anders Bernhardsson                              *
!***********************************************************************

subroutine Dot1El2(Kernel,KrnlMm,Hess,nGrad,DiffOp,CCoor,FD,nordop)
!***********************************************************************
!                                                                      *
! Object: to compute gradients of the one electron integrals.          *
!         The memory at this point is assumed to be large enough to do *
!         the computation in core.                                     *
!         The data is structured with respect to four indices, two (my *
!         ny or i j) refer to primitives or basis functions and two (a *
!         b) refer to the components of the cartesian or spherical     *
!         harmonic gaussians.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!             Modified for Hermite-Gauss quadrature November '90       *
!             Modified for Rys quadrature November '90                 *
!             Modified for multipole moments November '90              *
!                                                                      *
!             Modified for general kernel routines January '91         *
!             Modified for nonsymmetrical operators February '91       *
!             Modified for gradients October '91                       *
!             Modified for Hessians by AB   Dec '94                    *
!***********************************************************************

use mck_interface, only: mck_mem, oneeldot_mck_kernel
use Index_Functions, only: nTri_Elem, nTri_Elem1
use Real_Spherical, only: ipSph, RSph
use iSD_data, only: iSD
use Basis_Info, only: dbsc, MolWgh, Shells
use Center_Info, only: dc
use Symmetry_Info, only: iOper, nIrrep
use Sizes_of_Seward, only: S
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
procedure(oneeldot_mck_kernel) :: Kernel
procedure(mck_mem) :: KrnlMm
integer(kind=iwp), intent(in) :: nGrad, nordop
real(kind=wp), intent(out) :: Hess(nGrad)
logical(kind=iwp), intent(in) :: DiffOp
real(kind=wp), intent(in) :: CCoor(3), FD(*)
#include "Molcas.fh"
#include "disp.fh"
integer(kind=iwp) :: i, iAng, iAO, iBas, iCar, iCmp, iCnt, iCnttp, iCoM(0:7,0:7), iComp, iDCRR(0:7), iDCRT(0:7), ielem, iirrep, &
                     ijS, IndGrd(2,3,3,0:7), iPrim, iS, iShell, iShll, iSmLbl, iStabM(0:7), iStabO(0:7), iTmp(0:7), iuv, j, jAng, &
                     jAO, jBas, jCar, jCmp, jCnt, jCnttp, jIrrep, jj, jPrim, jS, jShell, jShll, kk, lDCRR, lloper, LmbdR, LmbdT, &
                     mdci, mdcj, MemKer, MemKrn, nDAO, nDCRR, nDCRT, nDisp, nMax, nOp(2), nOrder, nScrt1, nScrt2, nSkal, nSO, &
                     nStabM, nStabO, nTasks
real(kind=wp) :: A(3), B(3), FactNd, RB(3)
logical(kind=iwp) :: AeqB
real(kind=wp), allocatable :: DAO(:), DSO(:), DSOpr(:), Kappa(:), Kern(:), PCoor(:,:), Scrt1(:), Scrt2(:), Zeta(:), ZI(:)
integer(kind=iwp), external :: irrfnc, MemSO1, n2Tri, NrOpr
logical(kind=iwp), external :: EQ, TF

Hess(:) = Zero

! Auxiliary memory allocation.

call mma_allocate(Zeta,S%m2Max,Label='Zeta')
call mma_allocate(ZI,S%m2Max,Label='ZI')
call mma_allocate(Kappa,S%m2Max,Label='Kappa')
call mma_allocate(PCoor,S%m2Max,3,Label='PCoor')
!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Basis_Mode('Valence')
call Nr_Shells(nSkal)
call Setup_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
! Double loop over shells.

nTasks = nTri_Elem(nSkal)
iS = 0
jS = 0
do ijS=1,nTasks
  jS = jS+1
  if (jS > iS) then
    iS = jS
    jS = 1
  end if
  !do iS=1,nSkal
  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  mdci = iSD(10,iS)
  iShell = iSD(11,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

  !  do jS=1,iS
  jShll = iSD(0,jS)
  jAng = iSD(1,jS)
  jCmp = iSD(2,jS)
  jBas = iSD(3,jS)
  jPrim = iSD(5,jS)
  jAO = iSD(7,jS)
  mdcj = iSD(10,jS)
  jShell = iSD(11,jS)
  jCnttp = iSD(13,jS)
  jCnt = iSD(14,jS)
  B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

  ! Call kernel routine to get memory requirement.

  call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)
  MemKrn = MemKer*S%m2Max
  call mma_allocate(Kern,MemKrn,Label='Kern')

  ! Allocate memory for the final integrals, all in the primitive basis.

  ! Scratch area for contraction step

  nScrt1 = S%MaxPrm(iAng)*S%MaxPrm(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  call mma_allocate(Scrt1,nScrt1,Label='Scrt1')

  ! Scratch area for the transformation to spherical gaussians

  nScrt2 = S%MaxPrm(iAng)*S%MaxPrm(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  call mma_allocate(Scrt2,nScrt2,Label='Scrt2')

  nDAO = iPrim*jPrim*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  call mma_allocate(DAO,nDAO,Label='DAO')

  ! At this point we can compute Zeta.

  call ZXia(Zeta,ZI,iPrim,jPrim,Shells(iShll)%Exp,Shells(jShll)%Exp)

  AeqB = iS == jS

  ! Find the DCR for A and B

  call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
  if (DiffOp .or. (nDCRR /= 1) .or. (.not. EQ(A,B))) then

    ! Find the stabilizer for A and B

    call Inter(dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iStabM,nStabM)

    ! Generate all possible (left) CoSet
    ! To the stabilizer of A and B

    do j=0,nStabM-1
      iCoM(0:nIrrep-1,j) = ieor(iOper(0:nIrrep-1),iStabM(j))
    end do
    !  Order the Coset so we will have the unique ones first
    nMax = 1
    loop1: do j=1,nIrrep-1
      ! Check uniqueness
      do i=0,nMax-1
        do ielem=0,nStabM-1
          if (iCoM(i,1) == iCoM(j,ielem)) cycle loop1
        end do
      end do
      ! Move unique CoSet
      nMax = nMax+1
      iTmp(0:nStabM-1) = iCoM(nMax-1,0:nStabM-1)
      iCoM(nMax-1,0:nStabM-1) = iCoM(j,0:nStabM-1)
      iCoM(j,0:nStabM-1) = iTmp(0:nStabM-1)
      if (nMax == nIrrep/nStabM) exit loop1
    end do loop1

    ! Allocate memory for the elements of the Fock or 1st order
    ! denisty matrix which are associated with the current shell pair.

    iSmLbl = 1
    nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
    if (nSO /= 0) then
      call mma_allocate(DSOpr,nSO*iPrim*jPrim,Label='DSOpr')
      DSOpr(:) = Zero
      call mma_allocate(DSO,nSO*iPrim*jPrim,Label='DSO')
      DSO(:) = Zero

      ! Gather the elements from 1st order density / Fock matrix.

      call SOGthr(DSO,iBas,jBas,nSO,FD,n2Tri(iSmLbl),iSmLbl,iCmp,jCmp,iShell,jShell,AeqB,iAO,jAO)

      ! Project the Fock/1st order density matrix in AO
      ! basis on to the primitive basis.

      ! Transform IJ,AB to J,ABi
      call DGEMM_('T','T',jBas*nSO,iPrim,iBas,One,DSO,iBas,Shells(iShll)%pCff,iPrim,Zero,DSOpr,jBas*nSO)
      ! Transform J,ABi to AB,ij
      call DGEMM_('T','T',nSO*iPrim,jPrim,jBas,One,DSOpr,jBas,Shells(jShll)%pCff,jPrim,Zero,DSO,nSO*iPrim)
      ! Transpose to ij,AB
      call DGeTmO(DSO,nSO,nSO,iPrim*jPrim,DSOpr,iPrim*jPrim)
      call mma_deallocate(DSO)

      ! Loops over symmetry operations.

      nOp(1) = NrOpr(0)
      if (jBas < -999999) write(u6,*) 'gcc overoptimization',nDCRR
      do lDCRR=0,nDCRR-1
        call OA(iDCRR(lDCRR),B,RB)
        nOp(2) = NrOpr(iDCRR(lDCRR))
        if (EQ(A,RB) .and. (.not. DiffOp)) cycle

        lloper = 1
        call SOS(iStabO,nStabO,llOper)
        call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

        ! Compute normalization factor due the DCR symmetrization
        ! of the two basis functions and the operator.

        iuv = dc(mdci)%nStab*dc(mdcj)%nStab
        FactNd = real(iuv*nStabO,kind=wp)/real(nIrrep**2*LmbdT,kind=wp)
        if (MolWgh == 1) then
          FactNd = FactNd*real(nIrrep,kind=wp)**2/real(iuv,kind=wp)
        else if (MolWgh == 2) then
          FactNd = sqrt(real(iuv,kind=wp))*nStabO/real(nIrrep*LmbdT,kind=wp)
        end if

        ! Desymmetrize the matrix with which we will contract the trace.

        call DesymD(iSmLbl,iAng,jAng,iCmp,jCmp,iShell,jShell,iShll,jShll,iAO,jAO,DAO,iPrim,jPrim,DSOpr,nSO,nOp,FactNd)

        ! Project the spherical harmonic space onto the cartesian space.

        kk = nTri_Elem1(iAng)*nTri_Elem1(jAng)
        if (Shells(iShll)%Transf .or. Shells(jShll)%Transf) then

          ! ij,AB --> AB,ij
          call DGeTmO(DAO,iPrim*jPrim,iPrim*jPrim,iCmp*jCmp,Scrt1,iCmp*jCmp)
          ! AB,ij --> ij,ab
          call SphCar(Scrt1,iCmp*jCmp,iPrim*jPrim,Scrt2,nScrt2,RSph(ipSph(iAng)),iAng,Shells(iShll)%Transf,Shells(iShll)%Prjct, &
                      RSph(ipSph(jAng)),jAng,Shells(jShll)%Transf,Shells(jShll)%Prjct,DAO,kk)
        end if

        ! Compute kappa and P.

        call Setup1(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,A,RB,Kappa,PCoor,ZI)

        IndGrd(:,:,:,0:nirrep-1) = 0
        kk = 0
        do jIrrep=0,nirrep-1
          do jCar=1,3
            iirrep = irrfnc(2**(jcar-1))
            if (iirrep == jirrep) then
              jj = 0
              do i=0,jirrep-1
                jj = ldisp(i)+jj
              end do
              nDisp = IndDsp(mdci,jIrrep)-jj
              do iCar=1,3
                iComp = 2**(iCar-1)
                if (TF(mdci,jIrrep,iComp)) then
                  ndisp = ndisp+1
                  IndGrd(1,icar,jcar,jIrrep) = kk+nDisp
                end if
              end do
              kk = kk+ldisp(jirrep)
            end if
          end do
        end do

        kk = 0
        do jIrrep=0,nirrep-1
          do jCar=1,3
            iirrep = irrfnc(2**(jcar-1))
            if (iirrep == jirrep) then
              jj = 0
              do i=0,jirrep-1
                jj = ldisp(i)+jj
              end do
              nDisp = IndDsp(mdcj,jIrrep)-jj
              do iCar=1,3
                iComp = 2**(iCar-1)
                if (TF(mdcj,jIrrep,iComp)) then
                  ndisp = ndisp+1
                  IndGrd(2,icar,jcar,jIrrep) = kk+nDisp
                end if
              end do
              kk = kk+ldisp(jirrep)
            end if
          end do
        end do

        ! Compute gradients of the primitive integrals and trace the result.

        call Kernel(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,Zeta,Kappa,Pcoor,iPrim*jPrim,iAng,jAng,A,RB,nOrder,Kern, &
                    MemKer,Ccoor,nOrdOp,Hess,indgrd,DAO,mdci,mdcj,nOp)

      end do

      call mma_deallocate(DSOpr)
    end if
  end if
  call mma_deallocate(DAO)
  call mma_deallocate(Scrt2)
  call mma_deallocate(Scrt1)
  call mma_deallocate(Kern)

  !  end do
  !end do
end do

call Free_iSD()

call mma_deallocate(PCoor)
call mma_deallocate(Kappa)
call mma_deallocate(ZI)
call mma_deallocate(Zeta)

return

end subroutine Dot1El2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module SGUGA

use Molcas, only: MxLev
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
private

! Split-Graph descriptor, sizes, addresses...
type SGStruct
  integer(kind=iwp) :: NSym = 0, nActEl = 0, IFRAS = 0
  integer(kind=iwp) :: IA0, IB0, IC0, iSpin, nLev, nVert, nVert0, MidLev, MVSta, MVEnd, MXUP, MXDWN, LV1RAS, LM1RAS, LV3RAS, LM3RAS
  integer(kind=iwp), allocatable :: ISm(:), DRT(:,:), DRT0(:,:), Down(:,:), Down0(:,:), Up(:,:), Ver(:), MAW(:,:), LTV(:), &
                                    DAW(:,:), RAW(:,:), SCR(:,:)
  integer(kind=iwp), pointer :: DRTP(:,:), DOWNP(:,:)
end type SGStruct

! CI Structures, addresses,..
type CIStruct
  integer(kind=iwp) :: nMidV, nIpWlk, nWalk
  integer(kind=iwp), allocatable :: NOW(:,:,:), IOW(:,:,:), NCSF(:), NOCSF(:,:,:), IOCSF(:,:,:), ICase(:), IVR(:,:), ISGM(:,:)
  real(kind=wp), allocatable :: VSGM(:,:)
end type CIStruct

! Excitation operators, coupling coefficients,...
type EXStruct
  integer(kind=iwp) :: MxEO, nICoup
  integer(kind=iwp), allocatable :: NOCP(:,:,:), IOCP(:,:,:), ICoup(:,:), MVL(:,:), MVR(:,:), USGN(:,:), LSGN(:,:)
  real(kind=wp), allocatable :: VTab(:), SGTMP(:)
end type EXStruct

type(SGStruct), target :: SGS
type(CIStruct), target :: CIS
type(EXStruct), target :: EXS

integer(kind=iwp) :: iq
integer(kind=iwp), protected :: L2ACT(MXLEV) = [(iq,iq=1,MXLEV)]
integer(kind=iwp), protected :: LEVEL(MXLEV) = [(iq,iq=1,MXLEV)]

integer(kind=iwp), parameter :: IBVPT(26) = [0,0,0,0,1,1,2,2,1,1,2,1,1,2,2,1,2,2,3,3,3,3,3,3,3,3], &
                                IC1(26) = [0,1,2,3,0,2,0,1,0,1,1,2,3,0,1,2,2,3,1,3,2,3,0,1,2,3], &
                                IC2(26) = [0,1,2,3,1,3,2,3,0,1,2,2,3,0,1,1,2,3,0,2,0,1,0,1,2,3], &
                                ISVC(26) = [1,1,1,1,1,6,1,5,1,2,4,7,2,1,7,3,2,2,1,5,1,6,1,1,1,1], &
                                ITVPT(26) = [0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,2,2,1,1,2,2,3,3,3,3]

public :: CIS, CIStruct, EXS, EXStruct, L2ACT, LEVEL, MkCList, MkCOT, MkCoup, MkMAW, MkSeg, MkSgNum, MKSGUGA, NrCOUP, SG_Free, &
          SG_Init, SG_Init_Simple, SGS, SGStruct

contains

subroutine MKSGUGA(SGS,CIS)
  ! PURPOSE: MAKE THE GUGA TABLES
  ! NOTE:    TO RETAIN THE TABLES AVAILABLE FOR LATER PURPOSES
  !          THE START ADDRESSES OF OF THE ARRAYS ETC. ARE STORED IN
  !          THREE USER DEFINED TYPES. Consult the gugx module for the details.

  type(SGStruct), target, intent(inout) :: SGS
  type(CIStruct), intent(inout) :: CIS
  integer(kind=iwp), parameter :: LTAB = 1, NTAB = 2, ATAB = 3, BTAB = 4, CTAB = 5

  ! COMPUTE TOP ROW OF THE GUGA TABLE

  call mknVert0(SGS)

  ! SET UP A FULL PALDUS DRT TABLE:
  ! (INITIALLY NO RESTRICTIONS ARE PUT UP)

  SGS%nVert = SGS%nVert0
  if (SGS%IFRAS /= 0) then
    call mma_allocate(SGS%DRT0,SGS%nVert0,5,Label='DRT0')
    call mma_allocate(SGS%DOWN0,[1,SGS%nVert0],[0,3],Label='DOWN0')
    SGS%DRTP => SGS%DRT0
    SGS%DOWNP => SGS%DOWN0
  else
    call mma_allocate(SGS%DRT,SGS%nVert,5,Label='SGS%DRT')
    call mma_allocate(SGS%DOWN,[1,SGS%nVert],[0,3],Label='SGS%DOWN')
    SGS%DRTP => SGS%DRT
    SGS%DOWNP => SGS%DOWN
  end if

  call mkDRT0(SGS)

  ! IF THIS IS A RAS CALCULATION PUT UP RESTRICTIONS BY DELETING
  ! VERTICES WHICH VIOLATE THE FORMER.

  if (SGS%IFRAS /= 0) then
    call mkRAS(SGS)

    ! REASSEMBLE THE DRT TABLE (REMOVE DISCONNECTED VERTICES)

    call mkDRT(SGS)

    ! IF THIS IS A CAS CALCULATION PROCEED WITH THE UNRESTRICTED DRT TABLE

  end if

  nullify(SGS%DOWNP,SGS%DRTP)

  ! CALCULATE ARC WEIGHT.

  call MKDAW(SGS)

  ! COMPUTE UPCHAIN TABLE AND REVERSE ARC WEIGHTS

  call MKRAW(SGS)

  ! COMPUTE LTV TABLES.

  call MKLTV(SGS)

  ! COMPUTE MIDLEVEL AND LIMITS ON MIDVERTICE.

  call MKMID(SGS)

  contains

  subroutine mknVert0(SGS)

    type(SGStruct), target, intent(inout) :: SGS
    integer(kind=iwp) :: IAC

    SGS%IB0 = SGS%iSpin-1
    SGS%IA0 = (SGS%nActEl-SGS%IB0)/2
    SGS%IC0 = SGS%nLev-SGS%IA0-SGS%IB0

    if ((2*SGS%IA0+SGS%IB0 /= SGS%nActEl) .or. (SGS%IA0 < 0) .or. (SGS%IB0 < 0) .or. (SGS%IC0 < 0)) then
      write(u6,*) 'mknVert0 Error: Impossible specifications.'
      write(u6,'(1x,a,3I8)') 'NACTEL,NLEV,ISPIN:',SGS%nActEl,SGS%nLev,SGS%iSpin
      write(u6,'(1x,a,3I8)') 'IA0,IB0,IC0:      ',SGS%IA0,SGS%IB0,SGS%IC0
      write(u6,*) ' This is a severe internal error, or possibly'
      write(u6,*) ' indicates a strange input which should have been'
      write(u6,*) ' diagnosed earlier. Please submit a bug report.'
      call Abend()
    end if
    IAC = min(SGS%IA0,SGS%IC0)
    SGS%nVert0 = ((SGS%IA0+1)*(SGS%IC0+1)*(2*SGS%IB0+IAC+2))/2-(IAC*(IAC+1)*(IAC+2))/6

  end subroutine mknVert0

  subroutine mkDRT0(SGS)
    ! PURPOSE: CONSTRUCT THE UNRESTRICTED GUGA TABLE

    use Index_Functions, only: nTri_Elem1

    type(SGStruct), target, intent(inout) :: SGS
    integer(kind=iwp) :: ADDR, ADWN, AUP, BC, BDWN, BUP, CDWN, CUP, DWN, LEV, MXADDR, NACTEL, nTmp, STEP, VDWN, VEND, VSTA, VUP, &
                         VUPS
    integer(kind=iwp), allocatable :: TMP(:)
    integer(kind=iwp), parameter :: DA(0:3) = [0,0,1,1], DB(0:3) = [0,1,-1,0], DC(0:3) = [1,0,1,0]
#   ifdef _DEBUGPRINT_
    integer(kind=iwp) :: VERT
#   endif

    NTMP = nTri_Elem1(SGS%nLev+1)
    call mma_allocate(TMP,NTMP,Label='TMP')

    ! SET UP TOP ROW

    NACTEL = 2*SGS%IA0+SGS%IB0
    SGS%nLev = SGS%IA0+SGS%IB0+SGS%IC0
    SGS%DRTP(1,LTAB) = SGS%nLev
    SGS%DRTP(1,NTAB) = NACTEL
    SGS%DRTP(1,ATAB) = SGS%IA0
    SGS%DRTP(1,BTAB) = SGS%IB0
    SGS%DRTP(1,CTAB) = SGS%IC0
    VSTA = 1
    VEND = 1
#   ifdef _DEBUGPRINT_
    write(u6,*) 'A0,B0,C0,NVERT=',SGS%IA0,SGS%IB0,SGS%IC0,SGS%nVert
#   endif

    ! LOOP OVER ALL LEVELS

    do LEV=SGS%nLev,1,-1
      MXADDR = ((LEV+1)*(LEV+2))/2
      TMP(1:MXADDR) = 0

      ! LOOP OVER VERTICES

      do VUP=VSTA,VEND
        AUP = SGS%DRTP(VUP,ATAB)
        BUP = SGS%DRTP(VUP,BTAB)
        CUP = SGS%DRTP(VUP,CTAB)

        ! LOOP OVER CASES
        ! AND STORE ONLY VALID CASE NUMBERS WITH ADDRESSES

        do STEP=0,3
          SGS%DownP(VUP,STEP) = 0
          ADWN = AUP-DA(STEP)
          if (ADWN < 0) cycle
          BDWN = BUP-DB(STEP)
          if (BDWN < 0) cycle
          CDWN = CUP-DC(STEP)
          if (CDWN < 0) cycle
          BC = BDWN+CDWN
          ADDR = 1+(BC*(BC+1))/2+CDWN
          TMP(ADDR) = 4*VUP+STEP
          SGS%DownP(VUP,STEP) = ADDR
        end do
      end do
      VDWN = VEND

      ! NOW INSERT VALID CASES INTO DRT TABLE

      do ADDR=1,MXADDR
        VUPS = TMP(ADDR)
        if (VUPS == 0) cycle
        VUP = VUPS/4
        STEP = mod(VUPS,4)
        VDWN = VDWN+1
        SGS%DRTP(VDWN,ATAB) = SGS%DRTP(VUP,ATAB)-DA(STEP)
        SGS%DRTP(VDWN,BTAB) = SGS%DRTP(VUP,BTAB)-DB(STEP)
        SGS%DRTP(VDWN,CTAB) = SGS%DRTP(VUP,CTAB)-DC(STEP)
        TMP(ADDR) = VDWN
      end do

      ! CREATE DOWN CHAIN TABLE

      do VUP=VSTA,VEND
        do STEP=0,3
          DWN = SGS%DownP(VUP,STEP)
          if (DWN /= 0) SGS%DownP(VUP,STEP) = TMP(DWN)
        end do
      end do
      VSTA = VEND+1
      VEND = VDWN
    end do
    ! End of loop over levels.

    ! ADDING THE ZERO LEVEL TO DRT AND DOWNCHAIN TABLE

    SGS%DRTP(VEND,1:5) = 0
    SGS%DownP(VEND,0:3) = 0

    ! COMPLETE DRT TABLE BY ADDING NO. OF ORBITALS AND ELECTRONS
    ! INTO THE FIRST AND SECOND COLUMN

    SGS%DRTP(1:VEND,LTAB) = SGS%DRTP(1:VEND,ATAB)+SGS%DRTP(1:VEND,BTAB)+SGS%DRTP(1:VEND,CTAB)
    SGS%DRTP(1:VEND,NTAB) = 2*SGS%DRTP(1:VEND,ATAB)+SGS%DRTP(1:VEND,BTAB)
#   ifdef _DEBUGPRINT_
    do VERT=1,VEND
      write(u6,*) 'DRT0(:,LTAB)=',SGS%DRTP(VERT,LTAB)
      write(u6,*) 'DRT0(:,NTAB)=',SGS%DRTP(VERT,NTAB)
    end do
#   endif

    call mma_deallocate(TMP)

  end subroutine mkDRT0

  subroutine mkRAS(SGS)

    use UnixInfo, only: ProgName

    type(SGStruct), target, intent(inout) :: SGS

    if (ProgName(1:5) == 'rassi') then
      call rmvert(SGS)
    else
      call RESTR(SGS)
    end if

  end subroutine mkRAS

  subroutine mkDRT(SGS)
    ! PURPOSE: USING THE UNRESTRICTED DRT TABLE GENERATED BY DRT0 AND
    !          THE MASKING ARRAY PRODUCED BY RESTR COPY ALL VALID
    !          VERTICES FROM THE OLD TO THE NEW DRT TABLE

    type(SGStruct), target, intent(inout) :: SGS
    integer(kind=iwp) :: IC, ID, IDNEW, IV, IVNEW

    call mma_allocate(SGS%DRT,SGS%nVert,5,Label='DRT')
    call mma_allocate(SGS%Down,[1,SGS%nVert],[0,3],Label='SGS%DOWN')

    do IV=1,SGS%nVert0
      IVNEW = SGS%Ver(IV)
      if (IVNEW == 0) cycle
      SGS%DRT(IVNEW,:) = SGS%DRT0(IV,1:5)
      do IC=0,3
        ID = SGS%Down0(IV,IC)
        IDNEW = 0
        if (ID /= 0) IDNEW = SGS%Ver(ID)
        SGS%Down(IVNEW,IC) = IDNEW
      end do
    end do
#   ifdef _DEBUGPRINT_
    do IV=1,SGS%nVert
      write(u6,*) 'DRT(i,:)=',SGS%DRT(IV,:)
    end do
#   endif

    call mma_deallocate(SGS%Ver)
    call mma_deallocate(SGS%DRT0)
    call mma_deallocate(SGS%Down0)

  end subroutine mkDRT

  subroutine MKDAW(SGS)
    ! PURPOSE: CONSTRUCT DIRECT ARC WEIGHTS TABLE

    type(SGStruct), target, intent(inout) :: SGS
    integer(kind=iwp) :: IC, IDWN, ISUM, IV

    call mma_allocate(SGS%DAW,[1,SGS%nVert],[0,4],Label='SGS%DAW')

    ! BEGIN TO CONSTRUCT DOWN CHAIN TABLE

    SGS%DAW(SGS%nVert,0:3) = 0
    SGS%DAW(SGS%nVert,4) = 1
    do IV=SGS%nVert-1,1,-1
      ISUM = 0
      do IC=0,3
        SGS%DAW(IV,IC) = 0
        IDWN = SGS%Down(IV,IC)
        if (IDWN == 0) cycle
        SGS%DAW(IV,IC) = ISUM
        ISUM = ISUM+SGS%DAW(IDWN,4)
      end do
      SGS%DAW(IV,4) = ISUM
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) ' DIRECT ARC WEIGHTS:'
    do IV=1,SGS%nVert
      write(u6,'(1X,I4,5X,5(1X,I6))') IV,SGS%DAW(IV,0:4)
    end do
    write(u6,*)
#   endif

  end subroutine MKDAW

  subroutine MKRAW(SGS)
    ! PURPOSE: CONSTRUCT UPCHAIN INDEX TABLE AND REVERSE ARC WEIGHTS

    type(SGStruct), target, intent(inout) :: SGS
    integer(kind=iwp) :: IC, IDWN, ISUM, IU, IV

    call mma_allocate(SGS%UP,[1,SGS%nVert],[0,3],Label='SGS%UP')
    call mma_allocate(SGS%RAW,[1,SGS%nVert],[0,4],Label='SGS%RAW')

    ! BEGIN BY CONSTRUCTING THE UPCHAIN TABLE IUP:

    SGS%Up(:,:) = 0
    do IU=1,SGS%nVert-1
      do IC=0,3
        IDWN = SGS%Down(IU,IC)
        if (IDWN == 0) cycle
        SGS%Up(IDWN,IC) = IU
      end do
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) ' THE UPCHAIN TABLE IN MKRAW:'
    do IV=1,SGS%nVert
      write(u6,'(1X,I4,5X,4(1X,I6))') IV,SGS%Up(IV,0:3)
    end do
    write(u6,*)
#   endif

    ! USE UPCHAIN TABLE TO CALCULATE THE REVERSE ARC WEIGHT TABLE:

    SGS%RAW(:,0:3) = 0
    SGS%RAW(1,4) = 1
    do IV=2,SGS%nVert
      ISUM = 0
      do IC=0,3
        IU = SGS%Up(IV,IC)
        if (IU == 0) cycle
        SGS%RAW(IV,IC) = ISUM
        ISUM = ISUM+SGS%RAW(IU,4)
      end do
      SGS%RAW(IV,4) = ISUM
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) ' THE REVERSE ARC WEIGHT TABLE IN MKRAW:'
    do IV=1,SGS%nVert
      write(u6,'(1X,I4,5X,5(1X,I6))') IV,SGS%RAW(IV,0:4)
    end do
    write(u6,*)
#   endif

  end subroutine MKRAW

  subroutine MKLTV(SGS)
    ! PURPOSE: FIND THE MIDLEVEL

    type(SGStruct), target, intent(inout) :: SGS
    integer(kind=iwp) :: IV, LEV

    call mma_allocate(SGS%LTV,[-1,SGS%nLev],Label='LTV')

    ! SET UP A LEVEL-TO-VERTEX TABLE, LTV, AND IDENTIFY MIDVERTICES:

    SGS%LTV(:) = 0

    do IV=1,SGS%nVert
      LEV = SGS%DRT(IV,LTAB)
      SGS%LTV(LEV) = SGS%LTV(LEV)+1
    end do

    do LEV=SGS%nLev,0,-1
      SGS%LTV(LEV-1) = SGS%LTV(LEV-1)+SGS%LTV(LEV)
    end do

    do LEV=-1,SGS%nLev-1
      SGS%LTV(LEV) = 1+SGS%LTV(LEV+1)
    end do

  end subroutine MKLTV

  subroutine MKMID(SGS)
    ! PURPOSE: FIND THE MIDLEVEL

    type(SGStruct), target, intent(inout) :: SGS
    integer(kind=iwp) :: IL, IV, MINW, MV, NW

    ! USE DAW,RAW TABLES TO DETERMINE MIDLEV.
    ! THE ASSUMPTION IS THAT A BALANCED NUMBER OF UPPER/LOWER WALKS
    ! IS THE BEST CHOICE.

    !hrl 980529 fix for nLev=0 (no orbitals in any active space)
    ! Since LTV(-1:nLev)  and the statement after the loop
    ! MVSta=LTV(MidLev) we have the condition MidLev>=nLev
    ! Hence MidLev=1 is inappropriate for nLev=0
    ! MIDLEV=1

    if (SGS%nLev == 0) then
      SGS%MidLev = 0
    else
      SGS%MidLev = 1
    end if
    MINW = 1000000
    do IL=1,SGS%nLev-1
      NW = 0
      do IV=SGS%LTV(IL),SGS%LTV(IL-1)-1
        NW = NW+SGS%RAW(IV,4)-SGS%DAW(IV,4)
      end do
      NW = abs(NW)
      if (NW >= MINW) cycle
      SGS%MidLev = IL
      MINW = NW
    end do
    SGS%MVSta = SGS%LTV(SGS%MidLev)
    SGS%MVEnd = SGS%LTV(SGS%MidLev-1)-1
    CIS%nMidV = SGS%MVEnd-SGS%MVSta+1

    ! NOW FIND THE MAX NUMBERS OF UPPER AND LOWER WALKS. RESPECTIVELY
    ! (DISREGARDING SYMMETRY)

    SGS%MxUp = 0
    SGS%MxDwn = 0
    do MV=SGS%MVSta,SGS%MVEnd
      if (SGS%MxUp < SGS%RAW(MV,4)) SGS%MxUp = SGS%RAW(MV,4)
      if (SGS%MxDwn < SGS%DAW(MV,4)) SGS%MxDwn = SGS%DAW(MV,4)
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,'(A,I3)') ' MIDLEVEL =             ',SGS%MidLev
    write(u6,'(A,I3)') ' NUMBER OF MIDVERTICES =',CIS%NMIDV
    write(u6,'(A,I3)') ' FIRST MIDVERTEX =      ',SGS%MVSta
    write(u6,'(A,I3)') ' LAST MIDVERTEX =       ',SGS%MVEnd
    write(u6,'(A,I3)') ' MAX. NO UPPER WALKS=   ',SGS%MxUp
    write(u6,'(A,I3)') ' MAX. NO LOWER WALKS=   ',SGS%MxDwn
    write(u6,*)
#   endif

  end subroutine MKMID

  subroutine RMVERT(SGS)
    ! Purpose: Remove vertices from a DRT table.

    use RasDef, only: nRas, nRasEl, nRsPrt

    implicit none
    type(SGStruct), intent(inout) :: SGS
    integer(kind=iwp) :: IC, ID, iRO, iSy, IV, L, Lev, N, NCHANGES, NLD, NV
    logical(kind=iwp) :: Test
    integer(kind=iwp), allocatable :: CONN(:), Lim(:)
    integer(kind=iwp), parameter :: LTAB = 1, NTAB = 2

    ! Construct a restricted graph.
    call mma_allocate(Lim,SGS%nLev,Label='Lim')
    Lim(:) = 0
    ! Fill in the occupation limit table:
    Lev = 0
    do iRO=1,nRsPrt
      do iSy=1,SGS%nSym
        Lev = Lev+nRas(iSy,iRO)
      end do
      if (Lev > 0) Lim(Lev) = nRasEl(iRO)
    end do

    call mma_allocate(SGS%Ver,SGS%nVert0,Label='SGS%Ver')
    call mma_allocate(CONN,SGS%nVert,Label='CONN')

    ! KILL VERTICES THAT DO NOT OBEY RESTRICTIONS.
    do IV=1,SGS%nVert-1
      SGS%Ver(IV) = 1
      L = SGS%DRT0(IV,LTAB)
      N = SGS%DRT0(IV,NTAB)
      if (N < Lim(L)) SGS%Ver(IV) = 0
    end do
    SGS%Ver(SGS%nVert) = 1

    NCHANGES = 1 ! Initiate first loop
    do while (NCHANGES > 0)
      ! REMOVE ARCS HAVING A DEAD UPPER OR LOWER VERTEX.
      ! COUNT THE NUMBER OF ARCS REMOVED OR VERTICES KILLED.
      NCHANGES = 0
      do IV=1,SGS%nVert-1
        if (SGS%Ver(IV) == 0) then
          do IC=0,3
            ID = SGS%Down0(IV,IC)
            if (ID > 0) then
              SGS%Down0(IV,IC) = 0
              NCHANGES = NCHANGES+1
            end if
          end do
        else
          NLD = 0
          do IC=0,3
            ID = SGS%Down0(IV,IC)
            if (ID > 0) then
              if (SGS%Ver(ID) == 0) then
                SGS%Down0(IV,IC) = 0
                NCHANGES = NCHANGES+1
              else
                NLD = NLD+1
              end if
            end if
          end do
          if (NLD == 0) then
            SGS%Ver(IV) = 0
            NCHANGES = NCHANGES+1
          end if
        end if
      end do
      ! ALSO CHECK ON CONNECTIONS FROM ABOVE:
      CONN(:) = 0
      CONN(1) = SGS%Ver(1)
      do IV=1,SGS%nVert-1
        if (SGS%Ver(IV) == 1) then
          do IC=0,3
            ID = SGS%Down0(IV,IC)
            Test = ID > 0
            if (Test) Test = SGS%Ver(ID) == 1
            if (Test) CONN(ID) = 1
          end do
        end if
      end do
      do IV=1,SGS%nVert
        if ((SGS%Ver(IV) == 1) .and. (CONN(IV) == 0)) then
          SGS%Ver(IV) = 0
          NCHANGES = NCHANGES+1
        end if
      end do

    end do

    ! IF NO CHANGES, THE REMAINING GRAPH IS VALID.
    ! EVERY VERTEX OBEYS THE RESTRICTIONS. EVERY VERTEX IS
    ! CONNECTED ABOVE AND BELOW (EXCEPTING THE TOP AND BOTTOM)
    ! TO OTHER CONFORMING VERTICES.
    ! THE PROCEDURE IS GUARANTEED TO FIND A STABLE SOLUTIONS,
    ! SINCE EACH ITERATION REMOVES ARCS AND/OR VERTICES FROM THE
    ! FINITE NUMBER WE STARTED WITH.

    if (SGS%Ver(1) == 0) then
      write(u6,*) 'RASSI/RMVERT: Too severe restrictions.'
      write(u6,*) 'Not one single configuration is left.'
      call ABEND()
    end if

    NV = 0
    do IV=1,SGS%nVert
      if (SGS%Ver(IV) == 1) then
        NV = NV+1
        SGS%Ver(IV) = NV
      end if
    end do
    SGS%nVert = NV

    call mma_deallocate(CONN)
    call mma_deallocate(Lim)

  end subroutine RMVERT

  subroutine RESTR(SGS)
    ! PURPOSE: PUT THE RAS CONSTRAINT TO THE DRT TABLE BY CREATING A MASK

    type(SGStruct), intent(inout) :: SGS
    integer(kind=iwp) :: IC, ID, IV, IVD, IVV, LEV, MASK, N
    integer(kind=iwp), parameter :: i_and(0:3,0:3) = reshape([0,0,0,0,0,1,0,1,0,0,2,2,0,1,2,3],[4,4]), &
                                    i_or(0:3,0:3) = reshape([0,1,2,3,1,1,3,3,2,3,2,3,3,3,3,3],[4,4]), &
                                    LTAB = 1, NTAB = 2

    call mma_allocate(SGS%Ver,SGS%nVert0,Label='V11')

    ! LOOP OVER ALL VERTICES AND CHECK ON RAS CONDITIONS
    ! CREATE MASK

    do IV=1,SGS%nVert0
      LEV = SGS%DRT0(IV,LTAB)
      N = SGS%DRT0(IV,NTAB)
      SGS%Ver(IV) = 0
      if ((LEV == SGS%LV1RAS) .and. (N >= SGS%LM1RAS)) SGS%Ver(IV) = 1
      if ((LEV == SGS%LV3RAS) .and. (N >= SGS%LM3RAS)) SGS%Ver(IV) = SGS%Ver(IV)+2
    end do

    ! NOW LOOP FORWARDS, MARKING THOSE VERTICES CONNECTED FROM ABOVE.
    ! SINCE VER WAS INITIALIZED TO ZERO, NO CHECKING IS NEEDED.

    do IV=1,SGS%nVert0-1
      IVV = SGS%Ver(IV)
      do IC=0,3
        ID = SGS%Down0(IV,IC)
        if (ID /= 0) SGS%Ver(ID) = i_or(SGS%Ver(ID),IVV)
      end do
    end do

    ! THEN LOOP BACKWARDS. SAME RULES, EXCEPT THAT CONNECTIVITY
    ! SHOULD BE PROPAGATED ONLY ABOVE THE RESTRICTION LEVELS.

    do IV=SGS%nVert0-1,1,-1
      LEV = SGS%DRT0(IV,LTAB)
      MASK = 0
      if (LEV > SGS%LV1RAS) MASK = 1
      if (LEV > SGS%LV3RAS) MASK = MASK+2
      IVV = SGS%Ver(IV)
      do IC=0,3
        ID = SGS%Down0(IV,IC)
        if (ID /= 0) then
          IVD = SGS%Ver(ID)
          IVV = i_or(IVV,i_and(MASK,IVD))
        end if
      end do
      SGS%Ver(IV) = IVV
    end do

    ! WE ARE NOW INTERESTED ONLY IN VERTICES CONNECTED BOTH TO
    ! ALLOWED VERTICES FOR RAS-SPACE 1 AND RAS-SPACE 3.
    ! THOSE ARE NUMBERED IN ASCENDING ORDER, THE REST ARE ZEROED.

    SGS%nVert = 0
    do IV=1,SGS%nVert0
      if (SGS%Ver(IV) == 3) then
        SGS%nVert = SGS%nVert+1
        SGS%Ver(IV) = SGS%nVert
      else
        SGS%Ver(IV) = 0
      end if
    end do
    if (SGS%nVert == 0) call SysAbendMsg('Restr','No configuration was found\n','Check NACTEL, RAS1, RAS2, RAS3 values')
#   ifdef _DEBUGPRINT_
    write(u6,*) 'RESTR:'
    write(u6,*) 'LV1RAS, LV3RAS, LM1RAS, LM3RAS=',SGS%LV1RAS,SGS%LV3RAS,SGS%LM1RAS,SGS%LM3RAS
    do IV=1,SGS%nVert0
      write(u6,*) 'VER(:)=',SGS%Ver(IV)
    end do
#   endif

  end subroutine RESTR

end subroutine MKSGUGA

subroutine SG_Init_Simple(nSym,nActEl,iSpin,SGS,CIS,EXS,nHole1,nEle3,nRs1,nRs2,nRs3,xLevel,xL2Act,xNLEV,xNSM,Do_MkSGUGA)

  integer(kind=iwp), intent(in) :: nSym, nActEl, iSpin
  type(SGStruct), intent(inout) :: SGS
  type(CIStruct), intent(inout) :: CIS
  type(EXStruct), optional, intent(inout) :: EXS
  integer(kind=iwp), optional, intent(in) :: nHole1, nEle3, nRs1(nSym), nRs2(nSym), nRs3(nSym), xLevel(MxLev), xL2Act(MxLev), &
                                             xNLEV, xNSM(MxLev)
  logical(kind=iwp), optional, intent(in) :: Do_MkSGUGA
  integer(kind=iwp) :: IS, nRas1T, nRas2T, nRas3T

  ! Make sure that we start from a clean slate.
  if (present(EXS)) then
    ! Here if the extended parameter list was used.
    call SG_Free(SGS,CIS,EXS)
  else
    ! Here if the terse parameter list was used.
    call SG_Free(SGS,CIS)
  end if

  if (nSym < 1 .or. nSym > 8) then
    write(u6,*) ' SG_Init_Simple: illegal nSym value:',nSym
    call Abend()
  end if
  if (iSpin < 1) then
    write(u6,*) ' SG_Init_Simple: illegal iSpin value:',iSpin
    call Abend()
  end if
  if (nActEl < 0) then
    write(u6,*) ' SG_Init_Simple: illegal nActEl value:',nActEl
    call Abend()
  end if

  SGS%nSym = nSym
  SGS%iSpin = iSpin
  SGS%nActEl = nActEl

  if (present(EXS)) then

    nRAS1T = sum(nRs1(1:nSym))
    nRAS2T = sum(nRs2(1:nSym))
    nRAS3T = sum(nRs3(1:nSym))

    SGS%LV1RAS = NRAS1T
    SGS%LV3RAS = nRAS1T+NRAS2T
    SGS%LM1RAS = 2*nRas1T-NHOLE1
    SGS%LM3RAS = NACTEL-NELE3
    if ((NRAS1T+NRAS3T) /= 0) then
      SGS%IFRAS = 1
      do IS=1,NSYM
        if (nRs1(IS)+nRs2(IS)+nRs3(IS) /= 0) SGS%IFRAS = SGS%IFRAS+1
      end do

    else
      SGS%IFRAS = 0
    end if
  else
    SGS%LV1RAS = 0
    SGS%LV3RAS = 0
    SGS%LM1RAS = 0
    SGS%LM3RAS = 0
  end if

  if (present(xLevel)) Level(:) = xLevel(:)
  if (present(xL2Act)) L2Act(:) = xL2Act(:)
  ! Initiate if not already set externally.
  if (LEVEL(1) == 0) LEVEL(1:SGS%nLev) = [(iq,iq=1,SGS%nLev)]
  if (L2Act(1) == 0) L2Act(1:SGS%nLev) = [(iq,iq=1,SGS%nLev)]

  ! CREATE THE SYMMETRY INDEX VECTOR

  SGS%NLEV = xnLEV
  ! Allocate Level to Symmetry table ISm:
  call mma_allocate(SGS%ISM,SGS%nLev,Label='SGS%ISM')
  SGS%ISM(1:SGS%nLev) = xNSM(1:SGS%nLev)

  if (present(Do_MkSGUGA)) then
    if (Do_MkSGUGA) call MkSGUGA(SGS,CIS)
  else
    call MkSGUGA(SGS,CIS)
  end if

end subroutine SG_Init_Simple

subroutine SG_Init(nSym,nActEl,iSpin,SGS,CIS,EXS,nHole1,nEle3,nRs1,nRs2,nRs3,xLevel,xL2Act,xNLEV,xNSM)

  integer(kind=iwp), intent(in) :: nSym, nActEl, iSpin
  type(SGStruct), intent(inout) :: SGS
  type(CIStruct), intent(inout) :: CIS
  integer(kind=iwp), optional, intent(in) :: nHole1, nEle3, nRs1(nSym), nRs2(nSym), nRs3(nSym), xLevel(MxLev), xL2Act(MxLev), &
                                             xnLev, xNSM(MxLev)
  type(EXStruct), optional, intent(inout) :: EXS

  call SG_Init_Simple(nSym,nActEl,iSpin,SGS,CIS,EXS,nHole1,nEle3,nRs1,nRs2,nRs3,xLevel,xL2Act,xnLev,xNSM)

  ! DECIDE MIDLEV AND CALCULATE MODIFIED ARC WEIGHT TABLE.

  call MKMAW(SGS)

  if (present(EXS)) then
    ! FORM VARIOUS OFFSET TABLES:
    ! NOTE: NIPWLK AND DOWNWLK ARE THE NUMER OF INTEGER WORDS USED
    !       TO STORE THE UPPER AND LOWER WALKS IN PACKED FORM.

    call MKCOT(SGS,CIS)

    ! CONSTRUCT THE CASE LIST

    call MKCLIST(SGS,CIS)

    ! THE DAW, UP AND RAW TABLES WILL NOT BE NEEDED ANY MORE:

    ! CALCULATE SEGMENT VALUES. ALSO, MVL AND MVR TABLES.

    call MKSEG(SGS,CIS,EXS)

    ! NIPWLK: NR OF INTEGERS USED TO PACK EACH UP- OR DOWNWALK.

    call NRCOUP(SGS,CIS,EXS)

    call MKCOUP(SGS,CIS,EXS)
  end if

end subroutine SG_Init

subroutine SG_Free(SGS,CIS,EXS)
! PURPOSE: FREE THE SGUGA TABLES

  type(SGStruct), intent(_OUT_) :: SGS
  type(CIStruct), intent(_OUT_) :: CIS
  type(EXStruct), optional, intent(_OUT_) :: EXS

  call mma_deallocate(SGS%ISM,safe='*')
  call mma_deallocate(SGS%DRT0,safe='*')
  call mma_deallocate(SGS%DOWN0,safe='*')
  call mma_deallocate(SGS%DRT,safe='*')
  call mma_deallocate(SGS%DOWN,safe='*')
  call mma_deallocate(SGS%UP,safe='*')
  call mma_deallocate(SGS%MAW,safe='*')
  call mma_deallocate(SGS%LTV,safe='*')
  call mma_deallocate(SGS%DAW,safe='*')
  call mma_deallocate(SGS%RAW,safe='*')
  call mma_deallocate(SGS%SCR,safe='*')
  call mma_deallocate(SGS%Ver,safe='*')
  nullify(SGS%DRTP,SGS%DOWNP)

  call mma_deallocate(CIS%NOW,safe='*')
  call mma_deallocate(CIS%IOW,safe='*')
  call mma_deallocate(CIS%NCSF,safe='*')
  call mma_deallocate(CIS%NOCSF,safe='*')
  call mma_deallocate(CIS%IOCSF,safe='*')
  call mma_deallocate(CIS%ICase,safe='*')
  call mma_deallocate(CIS%VSGM,safe='*')
  call mma_deallocate(CIS%IVR,safe='*')
  call mma_deallocate(CIS%ISGM,safe='*')

  if (present(EXS)) then
    call mma_deallocate(EXS%NOCP,safe='*')
    call mma_deallocate(EXS%IOCP,safe='*')
    call mma_deallocate(EXS%ICoup,safe='*')
    call mma_deallocate(EXS%VTab,safe='*')
    call mma_deallocate(EXS%SGTMP,safe='*')
    call mma_deallocate(EXS%MVL,safe='*')
    call mma_deallocate(EXS%MVR,safe='*')
    call mma_deallocate(EXS%USGN,safe='*')
    call mma_deallocate(EXS%LSGN,safe='*')
  end if

end subroutine SG_Free

subroutine MKCOT(SGS,CIS)
! PURPOSE: SET UP COUNTER AND OFFSET TABLES FOR WALKS AND CSFS
! NOTE:    TO GET GET VARIOUS COUNTER AND OFFSET TABLES
!          THE DOWN-CHAIN TABLE IS SCANNED TO PRODUCE ALL POSSIBLE
!          WALKS. POSSIBLY, THERE ARE MORE EFFICIENT WAYS, BUT
!          SINCE ONLY UPPER AND LOWER WALKS ARE REQUIRED
!          THEIR NUMBER IS VERY LIMITTED, EVEN FOR LARGE CASES.

  type(SGStruct), intent(inout) :: SGS
  type(CIStruct), intent(inout) :: CIS
  integer(kind=iwp) :: IHALF, ILND, ISML, ISTP, IVB, IVT, IVTEND, IVTOP, IVTSTA, IWSYM, LEV, LEV1, LEV2, MV, NUW
  integer(kind=iwp), parameter :: IVERT = 1, ISYM = 2, ISTEP = 3
# ifdef _DEBUGPRINT_
  integer(kind=iwp) :: IS
# endif

  CIS%nIpWlk = 1+(SGS%MidLev-1)/15
  CIS%nIpWlk = max(CIS%nIpWlk,1+(SGS%nLev-SGS%MidLev-1)/15)
  call mma_allocate(CIS%NOW,2,SGS%nSym,CIS%nMidV,Label='CIS%NOW')
  call mma_allocate(CIS%IOW,2,SGS%nSym,CIS%nMidV,Label='CIS%IOW')
  call mma_allocate(CIS%NOCSF,SGS%nSym,CIS%nMidV,SGS%nSym,Label='CIS%NOCSF')
  call mma_allocate(CIS%IOCSF,SGS%nSym,CIS%nMidV,SGS%nSym,Label='CIS%IOCSF')
  call mma_allocate(CIS%NCSF,SGS%nSym,Label='CIS%NCSF')
  call mma_allocate(SGS%Scr,[1,3],[0,SGS%nLev],Label='SGS%Scr')

  ! CLEAR ARRAYS IOW AND NOW

  CIS%NOW(:,:,:) = 0
  CIS%IOW(:,:,:) = 0

  ! CLEAR ARRAYS IOCSF AND NOCSF

  CIS%IOCSF(:,:,:) = 0
  CIS%NOCSF(:,:,:) = 0

  ! START MAIN LOOP OVER UPPER AND LOWER WALKS, RESPECTIVELY.

  do IHALF=1,2
    if (IHALF == 1) then
      IVTSTA = 1
      IVTEND = 1
      LEV1 = SGS%nLev
      LEV2 = SGS%MidLev
    else
      IVTSTA = SGS%MVSta
      IVTEND = SGS%MVEnd
      LEV1 = SGS%MidLev
      LEV2 = 0
    end if

    ! LOOP OVER VERTICES STARTING AT TOP OF SUBGRAPH

    do IVTOP=IVTSTA,IVTEND
      ! SET CURRENT LEVEL=TOP LEVEL OF SUBGRAPH
      LEV = LEV1
      SGS%Scr(IVERT,LEV) = IVTOP
      SGS%Scr(ISYM,LEV) = 1
      SGS%Scr(ISTEP,LEV) = -1
      do while (LEV <= LEV1)
        ! FIND FIRST POSSIBLE UNTRIED ARC DOWN FROM CURRENT VERTEX
        IVT = SGS%Scr(IVERT,LEV)
        do ISTP=SGS%Scr(ISTEP,LEV)+1,3
          IVB = SGS%Down(IVT,ISTP)
          if (IVB /= 0) exit
        end do
        ! NO SUCH ARC WAS POSSIBLE. GO UP ONE STEP AND TRY AGAIN.
        if (ISTP > 3) then
          SGS%Scr(ISTEP,LEV) = -1
          LEV = LEV+1
          cycle
        end if
        ! SUCH AN ARC WAS FOUND. WALK DOWN:
        SGS%Scr(ISTEP,LEV) = ISTP
        ISML = 1
        if ((ISTP == 1) .or. (ISTP == 2)) ISML = SGS%ISm(LEV)
        LEV = LEV-1
        SGS%Scr(ISYM,LEV) = Mul(ISML,SGS%Scr(ISYM,LEV+1))
        SGS%Scr(IVERT,LEV) = IVB
        SGS%Scr(ISTEP,LEV) = -1
        if (LEV > LEV2) cycle
        ! WE HAVE REACHED THE BOTTOM LEVEL. THE WALK IS COMPLETE.
        ! FIND MIDVERTEX NUMBER ORDERING NUMBER AND SYMMETRY OF THIS WALK
        MV = SGS%Scr(IVERT,SGS%MidLev)+1-SGS%MVSta
        IWSYM = SGS%Scr(ISYM,LEV2)
        ILND = 1+CIS%NOW(IHALF,IWSYM,MV)
        ! SAVE THE MAX WALK NUMBER FOR GIVEN SYMMETRY AND MIDVERTEX
        CIS%NOW(IHALF,IWSYM,MV) = ILND
        ! BACK UP ONE LEVEL AND TRY AGAIN:
        LEV = LEV+1
      end do
    end do
  end do

  call CSFCOUNT(CIS,SGS%nSym,NUW)

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) ' TOTAL NR OF WALKS: UPPER ',NUW
  write(u6,*) '                    LOWER ',CIS%nWalk-NUW
  write(u6,*) '                     SUM  ',CIS%nWalk
  write(u6,*)
  write(u6,*) ' NR OF CONFIGURATIONS/SYMM:'
  write(u6,'(8(1X,I8))') (CIS%NCSF(IS),IS=1,SGS%nSym)
  write(u6,*)
  write(u6,*)
  write(u6,*) ' NR OF WALKS AND CONFIGURATIONS IN NRCOUP'
  write(u6,*) ' BY MIDVERTEX AND SYMMETRY.'
  do MV=1,CIS%nMidV
    write(u6,'(A,I2,A,8I6)') '  MV=',MV,'    UPPER WALKS:',(CIS%NOW(1,IS,MV),IS=1,SGS%nSym)
    write(u6,'(A,8I6)') '           LOWER WALKS:',(CIS%NOW(2,IS,MV),IS=1,SGS%nSym)
    do ISTP=1,SGS%nSym
      write(u6,'(A,I2,A,8I6)') ' ISTP=',ISTP,'  CONFIGURATIONS:',(CIS%NOCSF(IS,MV,ISTP),IS=1,SGS%nSym)
    end do
  end do
#endif

end subroutine MKCOT

subroutine MKCLIST(SGS,CIS)
! PURPOSE: CONSTRUCT THE COMPRESSED CASE-LIST, I.E.,
!          STORE THE STEP VECTOR FOR ALL POSSIBLE WALKS
!          IN THE ARRAY ICASE. GROUPS OF 15 CASES ARE PACKED
!          INTO ONE INTEGER WORD.

  type(SGStruct), intent(inout) :: SGS
  type(CIStruct), intent(inout) :: CIS
  integer(kind=iwp) :: IC, IHALF, ILND, IPOS, ISML, ISTP, IVB, IVT, IVTEND, IVTOP, IVTSTA, IWSYM, L, LEV, LEV1, LEV2, LL, MV
  logical(kind=iwp) :: Found
  integer(kind=iwp), parameter :: IVERT = 1, ISYM = 2, ISTEP = 3

  call mma_allocate(CIS%ICase,CIS%nWalk*CIS%nIpWlk,Label='CIS%ICase',safe='*')
  call mma_allocate(SGS%Scr,[1,3],[0,SGS%nLev],Label='SGS%Scr',safe='*')

  ! CLEAR ARRAY NOW. IT WILL BE RESTORED FINALLY

  CIS%NOW(:,:,:) = 0

  ! START MAIN LOOP OVER UPPER AND LOWER WALKS, RESPECTIVELY.

  do IHALF=1,2
    if (IHALF == 1) then
      IVTSTA = 1
      IVTEND = 1
      LEV1 = SGS%nLev
      LEV2 = SGS%MidLev
    else
      IVTSTA = SGS%MVSta
      IVTEND = SGS%MVEnd
      LEV1 = SGS%MidLev
      LEV2 = 0
    end if

    ! LOOP OVER VERTICES STARTING AT TOP OF SUBGRAPH

    do IVTOP=IVTSTA,IVTEND
      ! SET CURRENT LEVEL=TOP LEVEL OF SUBGRAPH:
      LEV = LEV1
      SGS%Scr(IVERT,LEV) = IVTOP
      SGS%Scr(ISYM,LEV) = 1
      SGS%Scr(ISTEP,LEV) = -1
      do while (LEV <= LEV1)
        ! FIND FIRST POSSIBLE UNTRIED ARC DOWN FROM CURRENT VERTEX:
        IVT = SGS%Scr(IVERT,LEV)
        Found = .false.
        do ISTP=SGS%Scr(ISTEP,LEV)+1,3
          IVB = SGS%Down(IVT,ISTP)
          if (IVB /= 0) then
            Found = .true.
            exit
          end if
        end do
        if (Found) then
          ! ALT A -- SUCH AN ARC WAS FOUND. WALK DOWN:
          SGS%Scr(ISTEP,LEV) = ISTP
          ISML = 1
          if ((ISTP == 1) .or. (ISTP == 2)) ISML = SGS%ISm(LEV)
          LEV = LEV-1
          SGS%Scr(ISYM,LEV) = Mul(ISML,SGS%Scr(ISYM,LEV+1))
          SGS%Scr(IVERT,LEV) = IVB
          SGS%Scr(ISTEP,LEV) = -1
          if (LEV > LEV2) cycle
          ! WE HAVE REACHED THE LOWER LEVEL. THE WALK IS COMPLETE.
          ! MIDVERTEX NUMBER:
          MV = SGS%Scr(IVERT,SGS%MidLev)+1-SGS%MVSta
          ! SYMMETRY LABEL OF THIS WALK:
          IWSYM = SGS%Scr(ISYM,LEV2)
          ! ITS ORDERING NUMBER WITHIN THE SAME BATCH OF (IHALF,IWSYM,MV):
          ILND = 1+CIS%NOW(IHALF,IWSYM,MV)
          CIS%NOW(IHALF,IWSYM,MV) = ILND
          ! CONSEQUENTLY, THE POSITION IMMEDIATELY BEFORE THIS COMPRESSED WALK:
          IPOS = CIS%IOW(IHALF,IWSYM,MV)+(ILND-1)*CIS%nIpWlk
          ! PACK THE STEPS IN GROUPS OF 15 LEVELS PER INTEGER:
          do LL=LEV2+1,LEV1,15
            IC = 0
            do L=min(LL+14,LEV1),LL,-1
              IC = 4*IC+SGS%Scr(ISTEP,L)
            end do
            IPOS = IPOS+1
            CIS%ICase(IPOS) = IC
          end do
          ! FINISHED WITH THIS WALK. BACK UP ONE LEVEL AND TRY AGAIN:
          LEV = LEV+1
        else
          ! ALT B -- NO SUCH ARC WAS POSSIBLE. GO UP ONE STEP AND TRY AGAIN.
          SGS%Scr(ISTEP,LEV) = -1
          LEV = LEV+1
        end if
      end do
    end do
  end do

  call mma_deallocate(SGS%Scr)

end subroutine MKCLIST

subroutine MKMAW(SGS)

  type(SGStruct), intent(inout) :: SGS
  integer(kind=iwp) :: IC, ID, ISUM, IU, IV

  call mma_allocate(SGS%MAW,[1,SGS%nVert],[0,3],Label='SGS%MAW')

  ! COPY LOWER PART OF DIRECT ARC WEIGHT TABLE INTO MAW:
  SGS%MAW(SGS%MVSta:SGS%nVert,0:3) = SGS%DAW(SGS%MVSta:SGS%nVert,0:3)
  ! COPY UPPER PART OF REVERSE ARC WEIGHT TABLE INTO MAW. HOWEVER,
  !    NOTE THAT THE MAW TABLE IS ACCESSED BY THE UPPER VERTEX.
  SGS%MAW(1:SGS%MVSta-1,0:3) = 0
  do IU=1,SGS%MVSta-1
    do IC=0,3
      ID = SGS%Down(IU,IC)
      if (ID /= 0) SGS%MAW(IU,IC) = SGS%RAW(ID,IC)
    end do
  end do
  ! FINALLY, ADD AN OFFSET TO ARCS LEADING TO MIDLEVELS:
  ISUM = 1
  do IV=SGS%MVSta,SGS%MVEnd
    do IC=0,3
      IU = SGS%Up(IV,IC)
      if (IU == 0) cycle
      SGS%MAW(IU,IC) = ISUM+SGS%MAW(IU,IC)
    end do
    ISUM = ISUM+SGS%RAW(IV,4)
  end do
  do IV=SGS%MVSta,SGS%MVEnd
    do IC=0,3
      if (SGS%Down(IV,IC) == 0) cycle
      SGS%MAW(IV,IC) = ISUM+SGS%MAW(IV,IC)
    end do
    ISUM = ISUM+SGS%DAW(IV,4)
  end do
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) ' THE MODIFIED ARC WEIGHT TABLE IN MKMAW:'
  do IV=1,SGS%nVert
    write(u6,'(1X,I4,5X,5(1X,I6))') IV,SGS%MAW(IV,0:3)
  end do
  write(u6,*)
# endif

end subroutine MKMAW

subroutine MKSEG(SGS,CIS,EXS)
! PURPOSE: CONSTRUCT THE TABLES ISGM AND VSGM.
! ISGM(IVLT,ISGT) REFERS TO A SEGMENT OF THE SEGMENT TYPE
!    ISGT=1,..,26, WHOSE TOP LEFT VERTEX IS IVLT. ISGM GIVES
!    ZERO IF THE SEGMENT IS IMPOSSIBLE IN THE GRAPH DEFINED BY
!    THE PALDUS TABLE DRT, ELSE IT IS THE BOTTOM LEFT VERTEX
!    NUMBER OF THE SEGMENT. THE SEGMENT VALUE IS THEN VSGM.

  type(SGStruct), intent(in) :: SGS
  type(CIStruct), intent(inout) :: CIS
  type(EXStruct), intent(inout) :: EXS
  integer(kind=iwp) :: IA, IAL, IB, IBL, ISGT, ITT, IV, IV1, IV2, IVL, IVLB, IVLT, IVRB, IVRT, LEV, MV, MVLL, MVRR
  real(kind=wp) :: V
  integer(kind=iwp), parameter :: IATAB = 3, IBTAB = 4
# ifdef _DEBUGPRINT_
  integer(kind=iwp) :: ICL, ICR, ID
  character(len=20) :: TEXT
  character(len=*), parameter :: FRML(7) = ['        1.0         ','       -1.0         ','        1/(B+1)     ', &
                                            '       -1/(B+1)     ','  SQRT(   B /(B+1)) ','  SQRT((B+2)/(B+1)) ', &
                                            '  SQRT(B(B+2))/(B+1)']
# endif

  call mma_allocate(CIS%IVR,SGS%nVert,2,Label='CIS%IVR')
  call mma_allocate(CIS%ISGM,SGS%nVert,26,Label='CIS%ISGM')
  call mma_allocate(CIS%VSGM,SGS%nVert,26,Label='CIS%VSGM')
  call mma_allocate(EXS%MVL,CIS%nMidV,2,Label='EXS%MVL')
  call mma_allocate(EXS%MVR,CIS%nMidV,2,Label='EXS%MVR')

  CIS%IVR(:,:) = 0
  do LEV=1,SGS%nLev
    IV1 = SGS%LTV(LEV)
    IV2 = SGS%LTV(LEV-1)-1
    do IVL=IV1,IV2
      IAL = SGS%DRT(IVL,IATAB)
      IBL = SGS%DRT(IVL,IBTAB)
      do IV=IVL+1,IV2
        IA = SGS%DRT(IV,IATAB)
        if (IA == IAL) then
          IB = SGS%DRT(IV,IBTAB)
          if (IB == (IBL-1)) CIS%IVR(IVL,1) = IV
        else if (IA == (IAL-1)) then
          IB = SGS%DRT(IV,IBTAB)
          if (IB == (IBL+1)) CIS%IVR(IVL,2) = IV
        end if
      end do
    end do
  end do
  ! CONSTRUCT THE MVL AND MVR TABLES:
  do IVL=SGS%MVSta,SGS%MVEnd
    MVLL = IVL-SGS%MVSta+1
    MVRR = 0
    if (CIS%IVR(IVL,1) /= 0) MVRR = CIS%IVR(IVL,1)-SGS%MVSta+1
    EXS%MVR(MVLL,1) = MVRR
    MVRR = 0
    if (CIS%IVR(IVL,2) /= 0) MVRR = CIS%IVR(IVL,2)-SGS%MVSta+1
    EXS%MVR(MVLL,2) = MVRR
    EXS%MVL(MVLL,1) = 0
    EXS%MVL(MVLL,2) = 0
  end do
  do MV=1,CIS%nMidV
    if (EXS%MVR(MV,1) /= 0) EXS%MVL(EXS%MVR(MV,1),1) = MV
    if (EXS%MVR(MV,2) /= 0) EXS%MVL(EXS%MVR(MV,2),2) = MV
  end do

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) ' MIDVERT PAIR TABLES MVL,MVR IN MKSEG:'
  write(u6,*) ' MVL TABLE:'
  write(u6,1234) (MV,EXS%MVL(MV,1),EXS%MVL(MV,2),MV=1,CIS%nMidV)
  write(u6,*) ' MVR TABLE:'
  write(u6,1234) (MV,EXS%MVR(MV,1),EXS%MVR(MV,2),MV=1,CIS%nMidV)
  write(u6,*)
  write(u6,*) ' VERTEX PAIR TABLE IVR IN MKSEG:'
  write(u6,1234) (IVL,CIS%IVR(IVL,1),CIS%IVR(IVL,2),IVL=1,SGS%nVert)
# endif

  ! INITIALIZE SEGMENT TABLES, AND MARK VERTICES AS UNUSABLE:
  CIS%ISGM(:,:) = 0
  CIS%VSGM(:,:) = Zero

  do IVLT=1,SGS%nVert
    do ISGT=1,26
      ITT = ITVPT(ISGT)
      IVRT = IVLT
      if ((ITT == 1) .or. (ITT == 2)) IVRT = CIS%IVR(IVLT,ITT)
      if (IVRT == 0) cycle
      IVLB = SGS%Down(IVLT,IC1(ISGT))
      if (IVLB == 0) cycle
      IVRB = SGS%Down(IVRT,IC2(ISGT))
      if (IVRB == 0) cycle
      ! SEGMENT IS NOW ACCEPTED AS POSSIBLE.

      CIS%ISGM(IVLT,ISGT) = IVLB
      IB = SGS%DRT(IVLT,IBTAB)
      select case (ISVC(ISGT))
        case (1)
          V = One
        case (2)
          V = -One
        case (3)
          V = One/real(1+IB,kind=wp)
        case (4)
          V = -One/real(1+IB,kind=wp)
        case (5)
          V = sqrt(real(IB,kind=wp)/real(1+IB,kind=wp))
        case (6)
          V = sqrt(real(2+IB,kind=wp)/real(1+IB,kind=wp))
        case (7)
          V = sqrt(real(IB*(2+IB),kind=wp))/real(1+IB,kind=wp)
        case default
          V = Zero ! Dummy assignment
          call Abend()
      end select
      CIS%VSGM(IVLT,ISGT) = V
    end do
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) ' SEGMENT TABLE IN MKSEG.'
  write(u6,*) ' VLT SGT ICL ICR VLB       SEGMENT TYPE         FORMULA'
  do IV=1,SGS%nVert
    do ISGT=1,26
      ID = CIS%ISGM(IV,ISGT)
      if (ID == 0) cycle
      ICL = IC1(ISGT)
      ICR = IC2(ISGT)
      if (ISGT <= 4) TEXT = '  WALK SECTION.'
      if ((ISGT >= 5) .and. (ISGT <= 8)) TEXT = ' TOP SEGMENT.'
      if ((ISGT >= 9) .and. (ISGT <= 18)) TEXT = ' MID-SEGMENT.'
      if ((ISGT >= 19) .and. (ISGT <= 22)) TEXT = ' BOTTOM SEGMENT.'
      if (ISGT > 22) TEXT = ' DOWN-WALK SECTION.'
      write(u6,2345) IV,ISGT,ICL,ICR,ID,TEXT,FRML(ISVC(ISGT))
    end do
  end do
  1234 format(3(3(1X,I4),4X))
  2345 format(1X,5I4,5X,A20,5X,A20)
# endif

end subroutine MKSEG

subroutine NRCOUP(SGS,CIS,EXS)

  type(SGStruct), intent(in) :: SGS
  type(CIStruct), intent(inout) :: CIS
  type(EXStruct), intent(inout) :: EXS
  integer(kind=iwp) :: IBSYM, ICL, INDEO, INDEOB, INDEOT, IP, IPQ, IQ, ISGT, ISYDS1, ISYM, ISYUS1, ITSYM, IVLB, IVLT, LEV, LFTSYM, &
                       MV, MV1, MV2, MV3, MV4, MV5, MXDWN, MXUP, N, NDWNS1, NSGMX, NSGTMP, NT1TMP, NT2TMP, NT3TMP, NT4TMP, NT5TMP, &
                       NUPS1, NUW
  integer(kind=iwp), allocatable :: NRL(:,:,:)
  integer(kind=iwp), parameter :: LTAB = 1
# ifdef _DEBUGPRINT_
  integer(kind=iwp) :: IS, IST, NCP
# endif

  call mma_allocate(CIS%NOW,2,SGS%nSym,CIS%nMidV,Label='CIS%NOW',safe='*')
  call mma_allocate(CIS%IOW,2,SGS%nSym,CIS%nMidV,Label='CIS%IOW',safe='*')
  call mma_allocate(CIS%NCSF,SGS%nSym,Label='CIS%NCSF',safe='*')
  call mma_allocate(CIS%NOCSF,SGS%nSym,CIS%nMidV,SGS%nSym,Label='CIS%NOCSF',safe='*')
  call mma_allocate(CIS%IOCSF,SGS%nSym,CIS%nMidV,SGS%nSym,Label='CIS%IOCSF',safe='*')

  EXS%MxEO = (SGS%nLev*(SGS%nLev+5))/2
  call mma_allocate(EXS%NOCP,EXS%MxEO,SGS%nSym,CIS%nMidV,Label='EXS%NOCP')
  call mma_allocate(EXS%IOCP,EXS%MxEO,SGS%nSym,CIS%nMidV,Label='EXS%IOCP')
  call mma_allocate(NRL,[1,SGS%nSym],[1,SGS%nVert],[0,EXS%MxEO],Label='NRL')

  NRL(:,1:SGS%MVEnd,:) = 0
  NRL(1,1,0) = 1

  do IVLT=1,SGS%MVSta-1
    LEV = SGS%DRT(IVLT,LTAB)
    do ISGT=1,26
      IVLB = CIS%ISGM(IVLT,ISGT)
      if (IVLB == 0) cycle
      ICL = IC1(ISGT)
      ISYM = 1
      if ((ICL == 1) .or. (ICL == 2)) ISYM = SGS%ISm(LEV)
      do ITSYM=1,SGS%nSym
        IBSYM = Mul(ITSYM,ISYM)

        select case (ISGT)
          case (:4)
            ! THIS IS AN UPPER WALK.
            NRL(IBSYM,IVLB,0) = NRL(IBSYM,IVLB,0)+NRL(ITSYM,IVLT,0)
          case (5:8)
            ! THIS IS AN TOP SEGMENT.
            INDEO = LEV+(IBVPT(ISGT)-1)*SGS%nLev
            NRL(IBSYM,IVLB,INDEO) = NRL(IBSYM,IVLB,INDEO)+NRL(ITSYM,IVLT,0)
          case (9:18)
            ! THIS IS A MID-SEGMENT.
            do IP=LEV+1,SGS%nLev
              INDEOT = IP+(ITVPT(ISGT)-1)*SGS%nLev
              INDEOB = IP+(IBVPT(ISGT)-1)*SGS%nLev
              NRL(IBSYM,IVLB,INDEOB) = NRL(IBSYM,IVLB,INDEOB)+NRL(ITSYM,IVLT,INDEOT)
            end do
          case (19:22)
            ! THIS IS A BOTTOM SEGMENT.
            do IP=LEV+1,SGS%nLev
              INDEOT = IP+(ITVPT(ISGT)-1)*SGS%nLev
              IPQ = (IP*(IP-1))/2+LEV
              INDEOB = IPQ+2*SGS%nLev
              NRL(IBSYM,IVLB,INDEOB) = NRL(IBSYM,IVLB,INDEOB)+NRL(ITSYM,IVLT,INDEOT)
            end do
          case default
            ! THIS IS A LOWER WALK.
            do INDEO=2*SGS%nLev+1,EXS%MxEO
              NRL(IBSYM,IVLB,INDEO) = NRL(IBSYM,IVLB,INDEO)+NRL(ITSYM,IVLT,INDEO)
            end do
        end select
      end do
    end do
  end do

  MXUP = 0
  do MV=1,CIS%nMidV
    IVLT = MV+SGS%MVSta-1
    do LFTSYM=1,SGS%nSym
      CIS%NOW(1,LFTSYM,MV) = NRL(LFTSYM,IVLT,0)
      MXUP = max(MXUP,CIS%NOW(1,LFTSYM,MV))
      do INDEO=1,EXS%MxEO
        EXS%NOCP(INDEO,LFTSYM,MV) = NRL(LFTSYM,IVLT,INDEO)
      end do
    end do
  end do

  NRL(:,SGS%MVSta:,:) = 0
  NRL(1,SGS%nVert,0) = 1
  do IVLT=SGS%nVert-1,SGS%MVSta,-1
    LEV = SGS%DRT(IVLT,LTAB)
    do ISGT=1,26
      IVLB = CIS%ISGM(IVLT,ISGT)
      if (IVLB == 0) cycle
      ICL = IC1(ISGT)
      ISYM = 1
      if ((ICL == 1) .or. (ICL == 2)) ISYM = SGS%ISm(LEV)
      do ITSYM=1,SGS%nSym
        IBSYM = Mul(ITSYM,ISYM)
        select case (ISGT)
          case (23:)
            ! THIS IS A LOWER WALK.
            NRL(ITSYM,IVLT,0) = NRL(ITSYM,IVLT,0)+NRL(IBSYM,IVLB,0)
          case (19:22)
            ! THIS IS AN BOTTOM SEGMENT.
            INDEO = LEV+(ITVPT(ISGT)-1)*SGS%nLev
            NRL(ITSYM,IVLT,INDEO) = NRL(ITSYM,IVLT,INDEO)+NRL(IBSYM,IVLB,0)
          case (9:18)
            ! THIS IS A MID-SEGMENT.
            do IQ=1,LEV-1
              INDEOT = IQ+(ITVPT(ISGT)-1)*SGS%nLev
              INDEOB = IQ+(IBVPT(ISGT)-1)*SGS%nLev
              NRL(ITSYM,IVLT,INDEOT) = NRL(ITSYM,IVLT,INDEOT)+NRL(IBSYM,IVLB,INDEOB)
            end do
          case (5:8)
            ! THIS IS AN TOP SEGMENT.
            do IQ=1,LEV-1
              INDEOB = IQ+(IBVPT(ISGT)-1)*SGS%nLev
              IPQ = (LEV*(LEV-1))/2+IQ
              INDEOT = IPQ+2*SGS%nLev
              NRL(ITSYM,IVLT,INDEOT) = NRL(ITSYM,IVLT,INDEOT)+NRL(IBSYM,IVLB,INDEOB)
            end do
          case default
            ! THIS IS AN UPPER WALK.
            do IPQ=1,(LEV*(LEV-1))/2
              INDEO = 2*SGS%nLev+IPQ
              NRL(ITSYM,IVLT,INDEO) = NRL(ITSYM,IVLT,INDEO)+NRL(IBSYM,IVLB,INDEO)
            end do
        end select
      end do
    end do
  end do

  MXDWN = 0
  do MV=1,CIS%nMidV
    IVLT = MV+SGS%MVSta-1
    do LFTSYM=1,SGS%nSym
      CIS%NOW(2,LFTSYM,MV) = NRL(LFTSYM,IVLT,0)
      MXDWN = max(MXDWN,CIS%NOW(2,LFTSYM,MV))
      do INDEO=1,EXS%MxEO
        N = NRL(LFTSYM,IVLT,INDEO)
        if (N /= 0) EXS%NOCP(INDEO,LFTSYM,MV) = N
      end do
    end do
  end do

  EXS%nICOup = 0
  do INDEO=1,EXS%MxEO
    do MV=1,CIS%nMidV
      do LFTSYM=1,SGS%nSym
        EXS%IOCP(INDEO,LFTSYM,MV) = EXS%nICOup
        EXS%nICOup = EXS%nICOup+EXS%NOCP(INDEO,LFTSYM,MV)
      end do
    end do
  end do

  call CSFCOUNT(CIS,SGS%nSym,NUW)

  !AR INSERT FOR US IN SIGMA ROUTINE

  NSGMX = 1
  NDWNS1 = 0  ! Dummy initialization
  NSGTMP = max(MXUP,MXDWN)
  do MV3=1,CIS%nMidV
    MV1 = EXS%MVL(MV3,2)
    MV2 = EXS%MVL(MV3,1)
    MV4 = EXS%MVR(MV3,1)
    MV5 = EXS%MVR(MV3,2)
    do ISYUS1=1,SGS%nSym
      NUPS1 = CIS%NOW(1,ISYUS1,MV3)
      do ISYDS1=1,SGS%nSym
        NDWNS1 = CIS%NOW(2,ISYDS1,MV3)
        NSGMX = max(NSGMX,CIS%NOCSF(ISYUS1,MV3,ISYDS1))

        if (MV1 /= 0) then
          NT4TMP = NUPS1*CIS%NOW(2,ISYDS1,MV1)
          NSGTMP = max(NSGTMP,NT4TMP)
          NT5TMP = NDWNS1*CIS%NOW(1,ISYUS1,MV1)
          NSGTMP = max(NSGTMP,NT5TMP)
        end if

        if (MV2 /= 0) then
          NT3TMP = NUPS1*CIS%NOW(2,ISYDS1,MV2)
          NSGTMP = max(NSGTMP,NT3TMP)
          NT5TMP = NDWNS1*CIS%NOW(1,ISYUS1,MV2)
          NSGTMP = max(NSGTMP,NT5TMP)
        end if

        if (MV4 /= 0) then
          NT1TMP = NUPS1*CIS%NOW(2,ISYDS1,MV4)
          NSGTMP = max(NSGTMP,NT1TMP)
          NT5TMP = NDWNS1*CIS%NOW(1,ISYUS1,MV4)
          NSGTMP = max(NSGTMP,NT5TMP)
        end if

        if (MV5 /= 0) then
          NT2TMP = NUPS1*CIS%NOW(2,ISYDS1,MV5)
          NSGTMP = max(NSGTMP,NT2TMP)
          NT5TMP = NDWNS1*CIS%NOW(1,ISYUS1,MV5)
          NSGTMP = max(NSGTMP,NT5TMP)
        end if

      end do
    end do
  end do

  call mma_allocate(EXS%SGTMP,NSGTMP,Label='EXS%SGTMP')

# ifdef _DEBUGPRINT_
  write(u6,600) MXUP,MXDWN,NSGMX,NSGMX,NSGTMP

  !AR END OF INSERT
  write(u6,*)
  write(u6,*) ' TOTAL NR OF WALKS: UPPER ',NUW
  write(u6,*) '                    LOWER ',CIS%nWalk-NUW
  write(u6,*) '                     SUM  ',CIS%nWalk
  write(u6,*) ' TOTAL NR OF COUPL COEFFS ',EXS%nICOup
  INDEO = 2*SGS%nLev+1
  write(u6,*) '         OF TYPE 1&2 ONLY:',EXS%IOCP(INDEO,1,1)
  write(u6,*)
  write(u6,*) ' NR OF CONFIGURATIONS/SYMM:'
  write(u6,'(8(1X,I8))') (CIS%NCSF(IS),IS=1,SGS%nSym)
  write(u6,*)

  write(u6,*)
  write(u6,*) ' NR OF WALKS AND CONFIGURATIONS IN NRCOUP'
  write(u6,*) ' BY MIDVERTEX AND SYMMETRY.'
  do MV=1,CIS%nMidV
    write(u6,*)
    write(u6,1234) MV,(CIS%NOW(1,IS,MV),IS=1,SGS%nSym)
    write(u6,1235) (CIS%NOW(2,IS,MV),IS=1,SGS%nSym)
    do IST=1,SGS%nSym
      write(u6,1236) IST,(CIS%NOCSF(IS,MV,IST),IS=1,SGS%nSym)
    end do
  end do
  write(u6,*)
  write(u6,*) ' NR OF COUPLING COEFFICIENTS:'
  write(u6,*) ' 1. OPEN LOOPS TYPE 1:'
  do IP=1,SGS%nLev
    do MV=1,CIS%nMidV
      do IS=1,SGS%nSym
        NCP = EXS%NOCP(IP,IS,MV)
        if (NCP /= 0) write(u6,2345) IP,MV,IS,NCP
      end do
    end do
  end do
  write(u6,*)
  write(u6,*) ' 2. OPEN LOOPS TYPE 2:'
  do IP=1,SGS%nLev
    do MV=1,CIS%nMidV
      do IS=1,SGS%nSym
        NCP = EXS%NOCP(SGS%nLev+IP,IS,MV)
        if (NCP /= 0) write(u6,2345) IP,MV,IS,NCP
      end do
    end do
  end do
  write(u6,*)
  write(u6,*) ' 3. CLOSED LOOPS:'
  do IP=2,SGS%nLev
    do IQ=1,IP-1
      INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
      do MV=1,CIS%nMidV
        do IS=1,SGS%nSym
          NCP = EXS%NOCP(INDEO,IS,MV)
          if (NCP /= 0) write(u6,2346) IP,IQ,MV,IS,NCP
        end do
      end do
    end do
  end do
  600 format(/,' MAXIMUM NUMBER OF WALKS', &
              /,' UPPER ',I6,' LOWER ',I6, &
              /,' LENGTH OF LARGEST WORK ARRAYS IN SUBROUTINE SIGMA', &
              /,' TEMPORARY SGM1 ',I7, &
              /,' TEMPORARY SGM2 ',I7, &
              /,' NSGTMP         ',I7)
  1234 format('  MV=',I2,'    UPPER WALKS:',8I6)
  1235 format('           LOWER WALKS:',8I6)
  1236 format(' IST=',I2,'  CONFIGURATIONS:',8I6)
  2345 format(' P=',I2,'  MV=',I2,' SYMM ',I1,' NOCP=',I4)
  2346 format(' P=',I2,'  Q=',I2,'  MV=',I2,' SYMM ',I1,' NOCP=',I4)
#endif

  call mma_deallocate(NRL)

end subroutine NRCOUP

subroutine MKCOUP(SGS,CIS,EXS)
! Purpose: Compute and return the table ICOUP(1..3,ICOP).
! The number of coupling coeffs is obtained from NOCP, the offset to
! the ICOP numbering is given by IOCP. The numbers ICOUP(1..3,ICOP) are
! then the ket and bra half-walks, enumerated by the Lund scheme,
! and the index into the VTAB table (the pool of possible values of
! coupling coefficients).

! Any loop is regarded as a segment path from top to midlevel, or
! from midlevel to bottom.
! The segment path is described by the table ISGPTH. It is
! essentially a list of which one of segments nr 1..26 that are
! used at each level. The segments are of three types:
! Type 0: Upwalk segment or top loop segment.
! Type 1: Mid segment.
! Type 2: Bottom segment.
! Type 3: Downwalk segment.
! ISGPTH(IVLFT,LEV)=Left upper vertex.
! ISGPTH(ITYPE,LEV)=Type of segment, (0..3).
! ISGPTH(IAWSL,LEV)=Left arc weight sum (from top, or from bottom).
! ISGPTH(IAWSR,LEV)=Similar, right.
! ISGPTH(ILS  ,LEV)=Left symmetry label (accum from top or bottom).
! ISGPTH(ICS  ,LEV)=Left coupling case number (0..3).
! ISGPTH(ISEG ,LEV)=Segment type (1..26).
! These indices are used to denote the columns of table ISGPTH.

  type(SGStruct), intent(in) :: SGS
  type(CIStruct), intent(inout) :: CIS
  type(EXStruct), intent(inout) :: EXS
  integer(kind=iwp) :: i, i1, i2, IAWS, IC, ICL, ICOP, ICR, IHALF, iLnd, IndEO, iP, iPos, iQ, iS, iSg, iSgt, iSym, iT, iTyp, &
                       iTypMx, iTypT, iVlb, iVlt, iVrt, iVrTop, iVTab, iVTEnd, iVTop, iVTSta, L, Lev, Lev1, Lev2, LftSym, LL, MV, &
                       nCheck, nVTab_Final
  real(kind=wp) :: C
# ifdef _DEBUGPRINT_
  integer(kind=iwp) :: I3, ICOP1, ICOP2, ICP1, ICP2, N, NRC, NRCPQ
  real(kind=wp) :: CP
# endif
  integer(kind=iwp), allocatable :: ILNDW(:), ISGPTH(:,:)
  real(kind=wp), allocatable :: val(:), VTab(:)
  integer(kind=iwp), parameter :: IVLFT = 1, ITYPE = 2, IAWSL = 3, IAWSR = 4, ILS = 5, ICS = 6, ISEG = 7, nVTab = 5000

  call mma_allocate(ILNDW,CIS%nWalk,Label='ILNDW')
  call mma_allocate(ISGPTH,[1,7],[0,SGS%nLev],Label='ISGPTH')
  call mma_allocate(val,[0,SGS%nLev],Label='val')
  call mma_allocate(VTab,nVTab,Label='VTab')

  call mma_allocate(EXS%ICoup,3,EXS%nICoup,Label='EXS%ICoup')
  call mma_allocate(CIS%ICase,CIS%nWalk*CIS%nIpWlk,Label='CIS%ICase',safe='*')

  !CIS%nIpWlk = 1+(SGS%MidLev-1)/15
  !CIS%nIpWlk = max(CIS%nIpWlk,1+(nLev-SGS%MidLev-1)/15)
  ! NOW IS ZEROED AND WILL BE USED AS AN ARRAY OF COUNTERS, BUT WILL BE RESTORED FINALLY.
  do IHALF=1,2
    do MV=1,CIS%nMidV
      do IS=1,SGS%nSym
        CIS%NOW(IHALF,IS,MV) = 0
      end do
    end do
  end do
  ! SIMILAR FOR THE COUPLING COEFFICIENT TABLE:
  do INDEO=1,EXS%MxEO
    do MV=1,CIS%nMidV
      do IS=1,SGS%nSym
        EXS%NOCP(INDEO,IS,MV) = 0
      end do
    end do
  end do

  ! COUPLING COEFFICIENT VALUE TABLE:
  NVTAB_FINAL = 2
  VTab(1) = One
  VTab(2) = -One

  NCHECK = 0

  do IHALF=1,2
    if (IHALF == 1) then
      IVTSTA = 1
      IVTEND = 1
      LEV1 = SGS%nLev
      LEV2 = SGS%MidLev
      ITYPMX = 0
    else
      IVTSTA = SGS%MVSta
      IVTEND = SGS%MVEnd
      LEV1 = SGS%MidLev
      LEV2 = 0
      ITYPMX = 2
    end if
    do IVTOP=IVTSTA,IVTEND
      do ITYP=0,ITYPMX
        IVRTOP = IVTOP
        if (ITYP > 0) IVRTOP = CIS%IVR(IVTOP,ITYP)
        if (IVRTOP == 0) cycle
        LEV = LEV1
        ISGPTH(IVLFT,LEV) = IVTOP
        ISGPTH(ITYPE,LEV) = ITYP
        ISGPTH(IAWSL,LEV) = 0
        ISGPTH(IAWSR,LEV) = 0
        ISGPTH(ILS,LEV) = 1
        ISGPTH(ISEG,LEV) = 0
        val(LEV) = One
        do while (LEV <= LEV1)
          ITYPT = ISGPTH(ITYPE,LEV)
          IVLT = ISGPTH(IVLFT,LEV)
          do ISGT=ISGPTH(ISEG,LEV)+1,26
            IVLB = CIS%ISGM(IVLT,ISGT)
            if (IVLB == 0) cycle
            if (ITYPT == ITVPT(ISGT)) exit
          end do
          if (ISGT > 26) then
            ISGPTH(ISEG,LEV) = 0
            LEV = LEV+1
          else
            ISGPTH(ISEG,LEV) = ISGT
            ICL = IC1(ISGT)
            ISYM = 1
            if ((ICL == 1) .or. (ICL == 2)) ISYM = SGS%ISm(LEV)
            IVRT = IVLT
            if ((ITYPT == 1) .or. (ITYPT == 2)) IVRT = CIS%IVR(IVLT,ITYPT)
            ICR = IC2(ISGT)
            ISGPTH(ICS,LEV) = ICL
            LEV = LEV-1
            ISGPTH(IAWSL,LEV) = ISGPTH(IAWSL,LEV+1)+SGS%MAW(IVLT,ICL)
            ISGPTH(IAWSR,LEV) = ISGPTH(IAWSR,LEV+1)+SGS%MAW(IVRT,ICR)
            val(LEV) = val(LEV+1)*CIS%VSGM(IVLT,ISGT)
            ISGPTH(ILS,LEV) = Mul(ISYM,ISGPTH(ILS,LEV+1))
            ISGPTH(IVLFT,LEV) = IVLB
            ISGPTH(ITYPE,LEV) = IBVPT(ISGT)
            ISGPTH(ISEG,LEV) = 0
            if (LEV > LEV2) cycle

            MV = ISGPTH(IVLFT,SGS%MidLev)+1-SGS%MVSta
            LFTSYM = ISGPTH(ILS,LEV2)
            IT = ISGPTH(ITYPE,SGS%MidLev)
            if (IT == 0) IT = 3
            if (ISGPTH(ITYPE,LEV2) == 0) IT = 0

            if (IT == 0) then
              ILND = 1+CIS%NOW(IHALF,LFTSYM,MV)
              IAWS = ISGPTH(IAWSL,LEV2)
              ILNDW(IAWS) = ILND
              CIS%NOW(IHALF,LFTSYM,MV) = ILND
              IPOS = CIS%IOW(IHALF,LFTSYM,MV)+(ILND-1)*CIS%nIpWlk
              do LL=LEV2+1,LEV1,15
                IC = 0
                do L=min(LL+14,LEV1),LL,-1
                  IC = 4*IC+ISGPTH(ICS,L)
                end do
                IPOS = IPOS+1
                CIS%ICase(IPOS) = IC
              end do
            else
              IP = 0
              IQ = 0
              do L=LEV2+1,LEV1
                ISG = ISGPTH(ISEG,L)
                if ((ISG >= 5) .and. (ISG <= 8)) IP = L
                if ((ISG >= 19) .and. (ISG <= 22)) IQ = L
              end do
              if (IP == 0) IP = IQ
              INDEO = SGS%nLev*(IT-1)+IP
              if (IT == 3) INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
              ICOP = 1+EXS%NOCP(INDEO,LFTSYM,MV)
              EXS%NOCP(INDEO,LFTSYM,MV) = ICOP
              ICOP = EXS%IOCP(INDEO,LFTSYM,MV)+ICOP
              NCHECK = NCHECK+1
              if (ICOP > EXS%nICoup) then
                write(u6,*) ' ERROR: NICOUP=',EXS%nICoup
                write(u6,*) ' NR OF COUPS PRODUCED:',NCHECK
                write(u6,*) '           TYPE NR IT:',IT
                write(u6,*) '            IP,IQ    :',IP,IQ
                write(u6,*) '            INDEO    :',INDEO
                write(u6,*) '        MIDVERTEX MV :',MV
                write(u6,*) ' LEFT SYMMETRY LFTSYM:',LFTSYM
                write(u6,*) ' COUP OFFSET IOCP    :',EXS%IOCP(INDEO,LFTSYM,MV)
                write(u6,*) ' COUP SERIAL NR ICOP :',ICOP
                write(u6,*) ' D:O, WITHOUT OFFSET :',ICOP-EXS%IOCP(INDEO,LFTSYM,MV)
                write(u6,*) ' CURRENT NOCP NUMBER :',EXS%NOCP(INDEO,LFTSYM,MV)
                call ABEND()
              end if

              C = val(LEV2)
              do I=1,NVTAB_FINAL
                IVTAB = I
                if (abs(C-VTab(I)) < 1.0e-10_wp) exit
              end do
              if (I > NVTAB_FINAL) then
                NVTAB_FINAL = NVTAB_FINAL+1
                if (NVTAB_FINAL > nVTab) then
                  write(u6,*) 'MKCOUP: NVTAB_FINAL=',NVTAB_FINAL
                  write(u6,*) 'NVTAB_FINAL should not be allowed to grow'
                  write(u6,*) 'beyond nVTab which was set provisionally'
                  write(u6,*) 'in subroutine GINIT in file ginit.f.'
                  write(u6,*) 'Now nVTab=',nVTab
                  write(u6,*) 'This may indicate a problem with your input.'
                  write(u6,*) 'If you do want to do this big calculation, try'
                  write(u6,*) 'increasing nVTab in GINIT and recompile.'
                  call ABEND()
                end if
                VTab(NVTAB_FINAL) = C
                IVTAB = NVTAB_FINAL
              end if
              EXS%ICoup(1,ICOP) = ISGPTH(IAWSL,LEV2)
              EXS%ICoup(2,ICOP) = ISGPTH(IAWSR,LEV2)
              EXS%ICoup(3,ICOP) = IVTAB
              if (ICOP > EXS%nICoup) then
                write(u6,*) 'MKCOUP: ICOP>NICOUP!'
                call ABEND()
              end if
            end if

            LEV = LEV+1
          end if
        end do

      end do
    end do
  end do
  ! RENUMBER THE COUPLING COEFFICIENT INDICES BY LUND SCHEME:
  do ICOP=1,EXS%nICoup
    I1 = EXS%ICoup(1,ICOP)
    I2 = EXS%ICoup(2,ICOP)
    EXS%ICoup(1,ICOP) = ILNDW(I1)
    EXS%ICoup(2,ICOP) = ILNDW(I2)
  end do

  call mma_deallocate(val)
  call mma_deallocate(ISGPTH)
  call mma_deallocate(ILNDW)

# ifdef _DEBUGPRINT_
  ICOP1 = 0
  ICOP2 = 0
  write(u6,*) ' NR OF DIFFERENT VALUES OF COUP:',NVTAB_FINAL
  do ICOP=1,EXS%nICoup
    I3 = EXS%ICoup(3,ICOP)
    if (I3 == 1) ICOP1 = ICOP1+1
    if (I3 == 2) ICOP2 = ICOP2+1
  end do
  write(u6,*)
  write(u6,*) ' NR OF COUPS WITH VALUE  1.0:',ICOP1
  write(u6,*) ' NR OF COUPS WITH VALUE -1.0:',ICOP2
  write(u6,*)
  write(u6,*) ' COUPLING COEFFICIENTS:'
  write(u6,*) '    IP    IQ    MV LFTSYM NOCP'
  write(u6,*) ' 1. OPEN LOOPS TYPE 1.'
  do IP=1,SGS%nLev
    do MV=1,CIS%nMidV
      do LFTSYM=1,SGS%nSym
        N = EXS%NOCP(IP,LFTSYM,MV)
        write(u6,'(6X,6(1X,I5),F10.7)') IP,MV,LFTSYM,N
      end do
    end do
  end do
  write(u6,*) ' 2. OPEN LOOPS TYPE 2.'
  do IP=1,SGS%nLev
    INDEO = SGS%nLev+IP
    do MV=1,CIS%nMidV
      do LFTSYM=1,SGS%nSym
        N = EXS%NOCP(INDEO,LFTSYM,MV)
        write(u6,'(6X,6(1X,I5),F10.7)') IP,MV,LFTSYM,N
      end do
    end do
  end do
  write(u6,*) ' 3. CLOSED LOOPS.'
  do IP=1,SGS%nLev
    do IQ=1,IP
      INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
      do MV=1,CIS%nMidV
        do LFTSYM=1,SGS%nSym
          N = EXS%NOCP(INDEO,LFTSYM,MV)
          write(u6,'(7(1X,I5),F10.7)') IP,IQ,MV,LFTSYM,N
        end do
      end do
    end do
  end do
  write(u6,*)
  write(u6,*) ' COUPLING COEFFICIENTS:'
  write(u6,*) '    IP    IQ    MV LFTSYM ICOP ICOUP1&2   COUP'
  write(u6,*) ' 1. OPEN LOOPS TYPE 1.'
  do IP=1,SGS%nLev
    do MV=1,CIS%nMidV
      do LFTSYM=1,SGS%nSym
        N = EXS%NOCP(IP,LFTSYM,MV)
        ICOP = EXS%IOCP(IP,LFTSYM,MV)
        do I=1,N
          ICOP = ICOP+1
          ICP1 = EXS%ICoup(1,ICOP)
          ICP2 = EXS%ICoup(2,ICOP)
          CP = VTab(EXS%ICoup(3,ICOP))
          write(u6,'(6X,6(1X,I5),F10.7)') IP,MV,LFTSYM,ICOP,ICP1,ICP2,CP
        end do
      end do
    end do
  end do
  write(u6,*) ' 2. OPEN LOOPS TYPE 2.'
  do IP=1,SGS%nLev
    INDEO = SGS%nLev+IP
    do MV=1,CIS%nMidV
      do LFTSYM=1,SGS%nSym
        N = EXS%NOCP(INDEO,LFTSYM,MV)
        ICOP = EXS%IOCP(INDEO,LFTSYM,MV)
        do I=1,N
          ICOP = ICOP+1
          ICP1 = EXS%ICoup(1,ICOP)
          ICP2 = EXS%ICoup(2,ICOP)
          CP = VTab(EXS%ICoup(3,ICOP))
          write(u6,'(6X,6(1X,I5),F10.7)') IP,MV,LFTSYM,ICOP,ICP1,ICP2,CP
        end do
      end do
    end do
  end do
  write(u6,*) ' 3. CLOSED LOOPS.'
  do IP=1,SGS%nLev
    do IQ=1,IP
      INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
      do MV=1,CIS%nMidV
        do LFTSYM=1,SGS%nSym
          N = EXS%NOCP(INDEO,LFTSYM,MV)
          ICOP = EXS%IOCP(INDEO,LFTSYM,MV)
          do I=1,N
            ICOP = ICOP+1
            ICP1 = EXS%ICoup(1,ICOP)
            ICP2 = EXS%ICoup(2,ICOP)
            CP = VTab(EXS%ICoup(3,ICOP))
            write(u6,'(7(1X,I5),F10.7)') IP,IQ,MV,LFTSYM,ICOP,ICP1,ICP2,CP
          end do
        end do
      end do
    end do
  end do
  write(u6,*)
  write(u6,*) ' CONVENTIONAL NR OF COUPLING COEFFS, BY PAIR:'
  NRC = 0
  do IP=2,SGS%MidLev
    do IQ=1,IP-1
      NRCPQ = 0
      INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
      do LFTSYM=1,SGS%nSym
        ISYM = LFTSYM
        do MV=1,CIS%nMidV
          NRCPQ = NRCPQ+EXS%NOCP(INDEO,LFTSYM,MV)*CIS%NOW(1,ISYM,MV)
        end do
      end do
      write(u6,'(1X,2I5,5X,I9)') IP,IQ,NRCPQ
      NRC = NRC+NRCPQ
    end do
  end do
  do IP=SGS%MidLev+1,SGS%nLev
    do IQ=1,SGS%MidLev
      NRCPQ = 0
      do LFTSYM=1,SGS%nSym
        ISYM = LFTSYM
        do MV=1,CIS%nMidV
          NRCPQ = NRCPQ+EXS%NOCP(IP,LFTSYM,MV)*EXS%NOCP(IQ,ISYM,MV)
          NRCPQ = NRCPQ+EXS%NOCP(SGS%nLev+IP,LFTSYM,MV)*EXS%NOCP(SGS%nLev+IQ,ISYM,MV)
        end do
      end do
      write(u6,'(1X,2I5,5X,I9)') IP,IQ,NRCPQ
      NRC = NRC+NRCPQ
    end do
  end do
  do IP=SGS%MidLev+2,SGS%nLev
    do IQ=SGS%MidLev+1,IP-1
      NRCPQ = 0
      INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
      do LFTSYM=1,SGS%nSym
        ISYM = LFTSYM
        do MV=1,CIS%nMidV
          NRCPQ = NRCPQ+EXS%NOCP(INDEO,LFTSYM,MV)*CIS%NOW(2,ISYM,MV)
        end do
      end do
      write(u6,'(1X,2I5,5X,I9)') IP,IQ,NRCPQ
      NRC = NRC+NRCPQ
    end do
  end do
  write(u6,*)
  write(u6,*) ' TOTAL CONVENTIONAL COUPLING COEFFS:',NRC
# endif

  call mma_allocate(EXS%VTab,nVTab_Final,Label='EXS%VTab')
  EXS%VTab(1:nVTab_final) = VTab(1:nVTab_final)
  call mma_deallocate(VTab)

end subroutine MKCOUP

subroutine MKSGNUM(STSYM,SGS,CIS,EXS)
! PURPOSE: FOR ALL UPPER AND LOWER WALKS
!          COMPUTE THE DIRECT ARC WEIGHT SUM AND THE
!          REVERSE ARC WEIGHT SUM, RESPECTIVELY.
!          STORE THE DATA IN THE TABLES USGN AND LSGN

  integer(kind=iwp), intent(in) :: STSYM
  type(SGStruct), intent(in) :: SGS
  type(CIStruct), intent(in) :: CIS
  type(EXStruct), intent(inout) :: EXS
  integer(kind=iwp) :: IC, ICODE, ICONF, IDAWSUM, ILOFF, ILW, IPOS, IRAWSUM, ISTEP, ISYM, IUOFF, IUW, JPOS, JSYM, LEV, LV, MIDV, &
                       NLW, NUW
  integer(kind=iwp), allocatable :: ISTEPVEC(:)

  call mma_allocate(EXS%USGN,SGS%MxUp,CIS%nMidV,Label='EXS%USGN')
  call mma_allocate(EXS%LSGN,SGS%MxDwn,CIS%nMidV,Label='EXS%LSGN')
  call mma_allocate(ISTEPVEC,SGS%nLev,Label='ISTEPVEC')

  ! INITIALIZE NUMBERING TABLES

  EXS%USGN(:,:) = 0
  EXS%LSGN(:,:) = 0

  ! MAIN LOOP RUNS OVER MIDVERTICES AND SYMMETRIES

  ICONF = 0
  do MIDV=1,CIS%nMidV
    do ISYM=1,SGS%nSym
      IUOFF = 1+CIS%IOW(1,ISYM,MIDV)
      NUW = CIS%NOW(1,ISYM,MIDV)
      JSYM = Mul(ISYM,STSYM)
      ILOFF = 1+CIS%IOW(2,JSYM,MIDV)
      NLW = CIS%NOW(2,JSYM,MIDV)
      if ((NUW == 0) .or. (NLW == 0)) cycle

      ! LOOP OVER ALL UPPER WALKS

      do IUW=1,NUW
        IPOS = IUOFF+CIS%nIpWlk*(IUW-1)
        ! UNPACK THE UPPER WALK STEP VECTOR
        ICODE = CIS%iCase(IPOS)
        JPOS = 0
        do LEV=SGS%MidLev+1,SGS%nLev
          JPOS = JPOS+1
          if (JPOS == 16) then
            JPOS = 1
            IPOS = IPOS+1
            ICODE = CIS%iCase(IPOS)
          end if
          ISTEP = mod(ICODE,4)
          ISTEPVEC(LEV) = ISTEP
          ICODE = ICODE/4
        end do
        ! GET REVERSE ARC WEIGHT FOR UPPER WALK
        IRAWSUM = 1
        LV = 1
        do LEV=SGS%nLev,SGS%MidLev+1,-1
          IC = ISTEPVEC(LEV)
          LV = SGS%Down(LV,IC)
          IRAWSUM = IRAWSUM+SGS%RAW(LV,IC)
        end do
        EXS%USGN(IRAWSUM,MIDV) = IUW
      end do

      ! LOOP OVER ALL LOWER WALKS

      do ILW=1,NLW
        IPOS = ILOFF+CIS%nIpWlk*(ILW-1)
        ! UNPACK WALK STEP VECTOR
        ICODE = CIS%iCase(IPOS)
        JPOS = 0
        do LEV=1,SGS%MidLev
          JPOS = JPOS+1
          if (JPOS == 16) then
            JPOS = 1
            IPOS = IPOS+1
            ICODE = CIS%iCase(IPOS)
          end if
          ISTEP = mod(ICODE,4)
          ISTEPVEC(LEV) = ISTEP
          ICODE = ICODE/4
        end do
        ! GET DIRECT ARC WEIGHT FOR THE LOWER WALK
        IDAWSUM = 1
        LV = SGS%nVert
        do LEV=1,SGS%MidLev
          IC = ISTEPVEC(LEV)
          LV = SGS%Up(LV,IC)
          IDAWSUM = IDAWSUM+SGS%DAW(LV,IC)
        end do
        EXS%LSGN(IDAWSUM,MIDV) = ICONF
        ICONF = ICONF+NUW
      end do

    end do
  end do
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) ' LSGN IN SUBROUTINE MKSGNUM'
  do MIDV=1,CIS%nMidV
    write(u6,'(1X,''MIDV='',I3,/,(20I6))') MIDV,EXS%LSGN(:,MIDV)
  end do
  write(u6,*)
  write(u6,*) ' USGN IN SUBROUTINE MKSGNUM'
  do MIDV=1,CIS%nMidV
    write(u6,'(1X,''MIDV='',I3,/,(20I6))') MIDV,EXS%USGN(:,MIDV)
  end do
  write(u6,*)
# endif

  call mma_deallocate(ISTEPVEC)

end subroutine MKSGNUM

subroutine CSFCOUNT(CIS,NSYM,NUW)

  type(CIStruct), intent(inout) :: CIS
  integer(kind=iwp), intent(in) :: NSYM
  integer(kind=iwp), intent(out) :: NUW
  integer(kind=iwp) :: ISYDWN, ISYM, ISYTOT, ISYUP, MV, N

  ! CONSTRUCT OFFSET TABLES FOR UPPER AND LOWER WALKS
  ! SEPARATED FOR EACH MIDVERTEX AND SYMMETRY

  NUW = 0
  do MV=1,CIS%nMidV
    do ISYM=1,NSYM
      CIS%IOW(1,ISYM,MV) = NUW*CIS%nIpWlk
      NUW = NUW+CIS%NOW(1,ISYM,MV)
    end do
  end do
  CIS%nWalk = NUW
  do MV=1,CIS%nMidV
    do ISYM=1,NSYM
      CIS%IOW(2,ISYM,MV) = CIS%nWalk*CIS%nIpWlk
      CIS%nWalk = CIS%nWalk+CIS%NOW(2,ISYM,MV)
    end do
  end do

  ! CONSTRUCT COUNTER AND OFFSET TABLES FOR THE CSFS
  ! SEPARATED BY MIDVERTICES AND SYMMETRY.
  ! FORM ALSO CONTRACTED SUMS OVER MIDVERTICES.

  CIS%NCSF(:) = 0
  do ISYTOT=1,NSYM
    do MV=1,CIS%nMidV
      do ISYUP=1,NSYM
        ISYDWN = Mul(ISYTOT,ISYUP)
        N = CIS%NOW(1,ISYUP,MV)*CIS%NOW(2,ISYDWN,MV)
        CIS%NOCSF(ISYUP,MV,ISYTOT) = N
        CIS%IOCSF(ISYUP,MV,ISYTOT) = CIS%NCSF(ISYTOT)
        CIS%NCSF(ISYTOT) = CIS%NCSF(ISYTOT)+N
#       include "compiler_features.h"
#       ifdef _BUGGY_INTEL_LLVM_
        ! dummy statement to work around compiler bug, will never be executed
        if (ISYUP > 99) CIS%NCSF(ISYTOT) = -1
#       endif
      end do
    end do
  end do

end subroutine CSFCOUNT

end module SGUGA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReaW3hlp3(Ww,Wx,dima,dimbe,dimb,no,LunName,LunAux)
! this routine does:
! reconstruct  Ww(a",be',b,i)  for aSGrp<beSGrp
! from (be",a"|b,i) records in V3 file LunName

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimbe, dimb, no, LunAux
real(kind=wp), intent(out) :: Ww(dima,dimbe,dimb,no), Wx(dima*dimbe*dimb*no)
character(len=8) :: LunName
integer(kind=iwp) :: a, b, beabi, i, length

! read block (be",a"|b"_i)

length = dima*dimbe*dimb*no
!open(unit=LunAux,file=LunName,form='unformatted')
call Molcas_BinaryOpen_Vanilla(LunAux,LunName)
call rea_chcc(LunAux,length,Wx)
!mp Wx(1:length) = Zero
close(LunAux)

! Map Ww(a",be",b",i) <- Wx(be",a"|b"_i)

beabi = 0
do i=1,no
  do b=1,dimb
    do a=1,dima
      Ww(a,:,b,i) = Wx(beabi+1:beabi+dimbe)
      beabi = beabi+dimbe
    end do
  end do
end do

return

end subroutine ReaW3hlp3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine EXCIND(IAS,INS,ISYM,ICASE,IP,IQ,IR,IS)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IAS, INS, ISYM, ICASE
integer(kind=iwp), intent(out) :: IP, IQ, IR, IS
integer(kind=iwp) :: IR1, IR2

!PAM99 New call sequence for ASIND
call ASIND(IAS,ISYM,ICASE,IR,IP,IR1)
call NSIND(INS,ISYM,ICASE,IS,IQ,IR2)

end subroutine EXCIND

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine xsetmem_ints(mem)

use k2_arrays, only: Sew_Scr, XMem
use stdalloc, only: mma_allocate, mma_maxDBLE
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: mem
integer(kind=iwp) :: mem_, MemMax

if (XMem) then
  call WarningMessage(2,'External handling of scratch already active!')
  call Abend()
end if
Mem_ = Mem
! Avoid using up all available memory
call mma_maxDBLE(MemMax)
if ((MemMax-Mem_ < 8000) .and. (Mem_ > 8000)) Mem_ = Mem_-8000
!write(u6,*) 'xsetmem_ints: External allocate:',Mem_
call mma_allocate(Sew_Scr,Mem_,Label='Sew_Scr')
XMem = .true.
!call mma_MaxDBLE(nu)
!write(u6,*) 'xsetmem_ints: External allocate left to allocate:',nu

end subroutine xsetmem_ints

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      Integer Function IrrFnc(iFnc)
      use Symmetry_Info
      Integer iTest(8)
      ix = iAnd(iFnc,1)
      iy = iAnd(iFnc,2)/2
      iz = iAnd(iFnc,4)/4
      Do i = 1, nIrrep
         jx = iAnd(iOper(i-1),1)
         jy = iAnd(iOper(i-1),2)/2
         jz = iAnd(iOper(i-1),4)/4
         iCh = 1
         If (ix.ne.0 .and. jx.ne.0) iCh = -iCh
         If (iy.ne.0 .and. jy.ne.0) iCh = -iCh
         If (iz.ne.0 .and. jz.ne.0) iCh = -iCh
         iTest(i)=iCh
      End Do
      IrrFnc=iNew(iTest,nIrrep)-1
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,2000, Markus P. Fuelscher                         *
*               1993, Per-Olof Widmark                                 *
************************************************************************
      Subroutine INIPKR8(PkAcc,PkMode)
************************************************************************
*                                                                      *
*     purpose: initial step for the packing and unpacking              *
*              routines. It has to be called prior to any calls to     *
*              the subroutines PKR8 and UPKR8. This routine determines *
*              the number of bytes which can be stripped of from a     *
*              given double precision number,i.e. the least significant*
*              bytes are replaced by zero) such that the resulting     *
*              absolute error is smaller than a given threshold.       *
*                                                                      *
*    Calling parameters:                                               *
*    PkAcc  : desired packing accuracy                                 *
*    PkMode : This is a flag to turn packing on and off                *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    PkCtl : Packing table                                             *
*                                                                      *
*    Local data declarations: none                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and P. O. Widmark                                 *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     replacement of packing routines                                  *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 2000                                 *
*                                                                      *
************************************************************************

#include "PkCtl.fh"

      Real*8 PkAcc
      Logical PkMode

*----------------------------------------------------------------------*
*     The Assm keyword key is set permanently to false.  The former    *
*     IBM specific assembler code has been removed!                    *
*----------------------------------------------------------------------*

      Assm=.false.

*----------------------------------------------------------------------*
*     Packing is disabled on the C90 due to the CRAY specific data     *
*     representation.                                                  *
*----------------------------------------------------------------------*

#ifdef _CRAY_C90_
      PkMode=.False.
#endif

*----------------------------------------------------------------------*
*     initialize the packing table                                     *
*     note, the variables PkTab, PkScal, and PkCutof are obsolete      *
*----------------------------------------------------------------------*

      PkThrs=PkAcc
      Pack=PkMode
      Do i=0,4095
        PkTab(i)=8
      End Do
      PkCutof=PkAcc
      PkScal=1.0D0
*
      Init_do_setup_e=1
      Init_do_setup_d=1
      Init_do_setup_l=1
      Return
      End
      Subroutine PARMPKR8(PkAcc,PkMode)
#include "PkCtl.fh"

      Real*8 PkAcc
      Logical PkMode
*
      PkAcc=PkThrs
      PkMode=Pack
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module timers

use Constants, only: Zero
use Definitions, only: wp

implicit none
private

real(kind=wp) :: C_Dress = Zero, C_get_Cm = Zero, TimeAoMo = Zero, TimeCIOpt = Zero, TimeDavid = Zero, TimeDens = Zero, &
                 TimeFock = Zero, TimeHCSCE = Zero, TimeHDiag = Zero, TimeHSel = Zero, TimeInput = Zero, TimeOrb = Zero, &
                 TimeOutput = Zero, TimePage = Zero, TimeRelax = Zero, TimeSigma = Zero, TimeTotal = Zero, TimeTrans = Zero, &
                 TimeWfn = Zero, W_Dress = Zero, W_get_Cm = Zero

public :: C_Dress, C_get_Cm, TimeAoMo, TimeCIOpt, TimeDavid, TimeDens, TimeFock, TimeHCSCE, TimeHDiag, TimeHSel, TimeInput, &
          TimeOrb, TimeOutput, TimePage, TimeRelax, TimeSigma, TimeTotal, TimeTrans, TimeWfn, W_Dress, W_get_Cm

end module timers

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1992, Roland Lindh                                *
!***********************************************************************

subroutine HRR2Da_mck(Arr1,nVec,nabMax,ncdMax,Arr2,A,B,la,lb,lc,ld,IfHss,IfGrd)
!***********************************************************************
!                                                                      *
! Object: to apply the transfer equation to the 2D-integrals.          *
!         The transformation is in place and the recursion             *
!         is replaced with the indentity when applicable.              *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             September '91                                            *
!             Modified to recurrence algorithm, February '92.          *
!             Improved algorithm, June '92.                            *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nVec, nabMax, ncdMax, la, lb, lc, ld
real(kind=wp), intent(in) :: Arr1(nVec,3,0:nabMax,0:ncdMax), A(3), B(3)
real(kind=wp), intent(out) :: Arr2(nVec,0:la+2,0:lb+2,0:ncdMax,3)
logical(kind=iwp), intent(in) :: IfHss(4,3,4,3), IfGrd(3,4)
integer(kind=iwp) :: ia, iab, ib, iCar, icd, ja, jb, ka, kb, lla, llb, llcd, ma, mb
real(kind=wp) :: AB

!iRout = 233
!iPrint = nPrint(iRout)

do iCar=1,3
  lla = 0
  llb = 0
  llcd = 0
  if (IfGrd(iCar,1)) lla = max(1,lla)
  if (IfHss(1,iCar,1,iCar)) lla = 2
  if (IfGrd(iCar,2)) llb = max(1,llb)
  if (IfHss(2,iCar,2,iCar)) llb = 2
  if (IfGrd(iCar,3) .or. IfGrd(iCar,4)) llcd = max(1,llcd)
  if (IfHss(3,iCar,3,iCar) .or. IfHss(4,iCar,4,iCar)) llcd = 2
  AB = A(iCar)-B(iCar)
  if (AB == Zero) then
    do icd=0,lc+ld+llcd
      ! Using the identity
      do ia=0,la+lla
        do ib=0,lb+llb
          iab = ia+ib
          if (iab > la+lb+max(lla,llb)) cycle
          Arr2(:,ia,ib,icd,iCar) = Arr1(:,iCar,iab,icd)
        end do
      end do
    end do
  else if (la >= lb) then
    do icd=0,lc+ld+llcd
      ! Move the first row I(ia,0)
      do ia=0,la+lb+max(lla,llb)
        ja = ia
        jb = 0
        if (ja > la+2) then
          ja = ja-(la+3)
          jb = 1
        end if
        Arr2(:,ja,jb,icd,iCar) = Arr1(:,iCar,ia,icd)
      end do
      ! Generate I(ia,ib) for fixed ib
      do ib=1,lb+llb
        do ia=la+lb+max(lla,llb)-ib,0,-1
          ja = ia
          jb = ib
          mb = ib-1
          if (ja > la+2) then
            ja = ja-(la+3)
            jb = jb+1
            mb = mb+1
          end if
          ma = ja
          ka = ia+1
          kb = ib-1
          if (ka > la+2) then
            ka = ka-(la+3)
            kb = kb+1
          end if
          Arr2(:,ja,jb,icd,iCar) = AB*Arr2(:,ma,mb,icd,iCar)+Arr2(:,ka,kb,icd,iCar)
        end do
      end do
    end do
  else
    AB = -AB
    do icd=0,lc+ld+llcd
      ! Move the first row I(0,ib)
      do ib=0,la+lb+max(lla,llb)
        jb = ib
        ja = 0
        if (jb > lb+2) then
          jb = jb-(lb+3)
          ja = 1
        end if
        Arr2(:,ja,jb,icd,iCar) = Arr1(:,iCar,ib,icd)
      end do
      ! Generate I(ia,ib) for fixed ia
      do ia=1,la+lla
        do ib=la+lb+max(lla,llb)-ia,0,-1
          jb = ib
          ja = ia
          ma = ia-1
          if (jb > lb+2) then
            jb = jb-(lb+3)
            ja = ja+1
            ma = ma+1
          end if
          mb = jb
          kb = ib+1
          ka = ia-1
          if (kb > lb+2) then
            kb = kb-(lb+3)
            ka = ka+1
          end if
          Arr2(:,ja,jb,icd,iCar) = AB*Arr2(:,ma,mb,icd,iCar)+Arr2(:,ka,kb,icd,iCar)
        end do
      end do
    end do
  end if
end do

return

end subroutine HRR2Da_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RPA_RdOrb()
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Read orbitals and orbital energies from InpOrb or from Runfile.
C
      Implicit None
#include "rpa_config.fh"

      Character*9 SecNam
      Parameter (SecNam='RPA_RdOrb')


      If (LumOrb) Then
         ! read from InpOrb
         Call RPA_RdOrb_FromInpOrb()
      Else
         ! read from Runfile
         Call RPA_RdOrb_FromRunfile()
      End If


      End
************************************************************************
      Subroutine RPA_RdOrb_FromInpOrb()
      Implicit None

      Character*20 SecNam
      Parameter (SecNam='RPA_RdOrb_FromInpOrb')

      Call RPA_Warn(3,
     *    SecNam//': Reading orbitals from INPORB not implemented yet')

      End
************************************************************************
      Subroutine RPA_RdOrb_FromRunfile()
      Implicit None
#include "rpa_config.fh"
#include "rpa_data.fh"
#include "WrkSpc.fh"

      Character*21 SecNam
      Parameter (SecNam='RPA_RdOrb_FromRunfile')

      Integer  RPA_iUHF
      External RPA_iUHF

      Integer iUHF
      Integer iSym
      Integer i
      Integer nB, nB2
      Integer ip, ipO, ipV

      ! Restricted (1) or unrestricted (2)
      iUHF=RPA_iUHF()

      ! Allocate memory for CMO
      l_CMO(1)=nBas(1)*nOrb(1)
      nB2=nBas(1)**2
      Do iSym=2,nSym
         l_CMO(1)=l_CMO(1)+nBas(iSym)*nOrb(iSym)
         nB2=nB2+nBas(iSym)**2
      End Do
      Call GetMem('CMO(RPA)','Allo','Real',ip_CMO(1),l_CMO(1))
      If (iUHF.eq.2) Then
         l_CMO(2)=l_CMO(1)
         Call GetMem('CMO(RPA)','Allo','Real',ip_CMO(2),l_CMO(2))
      Else
         ip_CMO(2)=0
         l_CMO(2)=0
      End If

      ! Read CMO array(s) from Runfile
      Call Get_CMO(Work(ip_CMO(1)),nB2)
      If (iUHF.eq.2) Then
         Call Get_dArray('CMO_ab',Work(ip_CMO(2)),nB2)
      End If

      ! Allocate memory for orbital energies
      nB=nBas(1)
      Do iSym=2,nSym
         nB=nB+nBas(iSym)
      End Do
      Do i=1,iUHF
         l_OccEn(i)=nOcc(1,i)
         l_VirEn(i)=nVir(1,i)
         Do iSym=2,nSym
            l_OccEn(i)=l_OccEn(i)+nOcc(iSym,i)
            l_VirEn(i)=l_VirEn(i)+nVir(iSym,i)
         End Do
         Call GetMem('OccEn','Allo','Real',ip_OccEn(i),l_OccEn(i))
         Call GetMem('VirEn','Allo','Real',ip_VirEn(i),l_VirEn(i))
      End Do
      If (iUHF.eq.1) Then
         ip_OccEn(2)=0
         l_OccEn(2)=0
         ip_VirEn(2)=0
         l_VirEn(2)=0
      End If

      ! Read orbital energies from Runfile
      Call Get_OrbE(ip_EMO(1),l_EMO(1))
      If (l_EMO(1).ne.nB) Then
         Call RPA_Warn(3,SecNam//': unexpected EMO dimension')
      End If
      ip=ip_EMO(1)
      ipO=ip_OccEn(1)
      ipV=ip_VirEn(1)
      Do iSym=1,nSym
         Call dCopy_(nOcc(iSym,1),Work(ip),1,Work(ipO),1)
         Call dCopy_(nVir(iSym,1),Work(ip+nOcc(iSym,1)),1,Work(ipV),1)
         ip=ip+nOrb(iSym)
         ipO=ipO+nOcc(iSym,1)
         ipV=ipV+nVir(iSym,1)
      End Do
      If (iUHF.eq.2) Then
         l_EMO(2)=l_EMO(1)
         Call GetMem('EMO(RPA)','Allo','Real',ip_EMO(2),l_EMO(2))
         Call Get_dArray('OrbE_ab',Work(ip_EMO(2)),l_EMO(2))
         ip=ip_EMO(2)
         ipO=ip_OccEn(2)
         ipV=ip_VirEn(2)
         Do iSym=1,nSym
            Call dCopy_(nOcc(iSym,2),Work(ip),1,Work(ipO),1)
           Call dCopy_(nVir(iSym,2),Work(ip+nOcc(iSym,2)),1,Work(ipV),1)
            ip=ip+nOrb(iSym)
            ipO=ipO+nOcc(iSym,2)
            ipV=ipV+nVir(iSym,2)
         End Do
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PRMBLK(IDC,ISGV,IASM,IBSM,IATP,IBTP,PS,PL,JATP,JBTP,JASM,JBSM,ISGN,ITRP,NPERM)
! A block of CI coefficients defined by by IATP,IASM,IBTP,IBSM is given
!
! Obtain the number of other blocks that can be obtained by spin
! and relection symmetry.
!
! Jeppe Olsen, July 1993
!
! =====
! Output
! =====
! JATP(I),JASM(I),JBTP(I),JBSM(I) indices for Block I
! NPERM : Number of blocks  that can be obtained
! ITRP(I) = 1 => block should     be transposed
!         = 0 => block should not be transposed
! ISGN   : Sign to multiply previous block with to getnew sign
!
! There are four types of permutations
!
!    operation   *      JASM  *      JBSM  * JATP * JBTP * Iperm * Sign *
!   *********************************************************************
!   * Identity   *      IASM  *      IBSM  * IATP * IBTP *   0   * 1    *
!   * Ml         * ISGV(IASM) * ISGV(IBSM) * IATP * IBTP *   0   * PL   *
!   * Ms         *      IBSM  *      IASM  * IBTP * IATP *   1   * PS   *
!   * Ms+Ml      * ISGV(IBSM) * ISGV(IASM) * IBTP * IATP *   1   * PS PL*
!   *********************************************************************

use Constants, only: One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: IDC, ISGV(*), IASM, IBSM, IATP, IBTP
integer(kind=iwp), intent(out) :: JATP(4), JBTP(4), JASM(4), JBSM(4), ISGN(4), ITRP(4), NPERM
real(kind=wp), intent(in) :: PS, PL
integer(kind=iwp) :: IPERM, ISET, KASM, KATP, KBSM, KBTP, KSIGN, KTRP, LPERM, LSIGN, LTRP

! To eliminate some compiler warnings
KASM = 0
KBSM = 0
KATP = 0
KBTP = 0
KSIGN = 0
KTRP = 0
LSIGN = 0
LTRP = 0

NPERM = 0
do IPERM=1,4
  ISET = 0
  if (IPERM == 1) then

    ! Identity operation

    KASM = IASM
    KBSM = IBSM
    KATP = IATP
    KBTP = IBTP
    KSIGN = 1
    KTRP = 0
    ISET = 1
  else if ((IPERM == 2) .and. ((IDC == 3) .or. (IDC == 4))) then

    ! Ml reflection

    KASM = ISGV(IASM)
    KBSM = ISGV(IBSM)
    KATP = IATP
    KBTP = IBTP
    if (PL == One) then
      KSIGN = 1
    else if (PL == -One) then
      KSIGN = -1
    end if
    KTRP = 0
    ISET = 1
  else if ((IPERM == 3) .and. ((IDC == 2) .or. (IDC == 4))) then

    ! Ms reflection

    KASM = IBSM
    KBSM = IASM
    KATP = IBTP
    KBTP = IATP
    if (PS == One) then
      KSIGN = 1
    else if (PS == -One) then
      KSIGN = -1
    end if
    KTRP = 1
    ISET = 1
  else if ((IPERM == 4) .and. (IDC == 4)) then

    ! Ms Ml  reflection

    KASM = ISGV(IBSM)
    KBSM = ISGV(IASM)
    KATP = IBTP
    KBTP = IATP
    if (PS*PL == One) then
      KSIGN = 1
    else if (PS == -One) then
      KSIGN = -1
    end if
    KTRP = 1
    ISET = 1
  end if

  if (ISET == 1) then
    ! A new permutation was found, check and see if it was obtained previously
    do LPERM=1,NPERM
      if ((JATP(LPERM) == KATP) .and. (JASM(LPERM) == KASM) .and. (JBTP(LPERM) == KBTP) .and. (JBSM(LPERM) == KBSM)) exit
    end do
    if (LPERM > NPERM) then
      ! The permutation was new, add it to the list
      NPERM = NPERM+1
      JASM(NPERM) = KASM
      JBSM(NPERM) = KBSM
      JATP(NPERM) = KATP
      JBTP(NPERM) = KBTP
      if ((NPERM == 1) .or. ((NPERM >= 1) .and. (KSIGN == LSIGN))) then
        ISGN(NPERM) = 1
      else
        ISGN(NPERM) = -1
      end if
      LSIGN = KSIGN
      if ((NPERM == 1) .or. ((NPERM >= 1) .and. (KTRP == LTRP))) then
        ITRP(NPERM) = 0
      else
        ITRP(NPERM) = 1
      end if
      LTRP = KTRP
    end if
  end if
end do

! Should the block be trnasposed or scaled to return to initial form
ITRP(NPERM+1) = LTRP
ISGN(NPERM+1) = LSIGN
#ifdef _DEBUGPRINT_
write(u6,'(A,4I4)') ' Blocks obtained from IASM IBSM IATP IBTP ',IASM,IBSM,IATP,IBTP
write(u6,*)
write(u6,'(A)') ' JASM JBSM JATP JBTP Isgn Itrp'
write(u6,*)
do IPERM=1,NPERM
  write(u6,'(2x,6I4)') JASM(IPERM),JBSM(IPERM),JATP(IPERM),JBTP(IPERM),ISGN(IPERM),ITRP(IPERM)
end do
#endif

end subroutine PRMBLK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1995,1996, Anders Bernhardsson                         *
!***********************************************************************

subroutine Eval_g2_ijkl(iS,jS,kS,lS,Hess,nHess,Post_Process,iInt,n_Int,nACO,lGrad,lHess,lPick,nBuffer,Buffer,nDens,DTemp,DInAc, &
                        MOip,nTwo2,nQuad)

use setup, only: nAux
use McKinley_global, only: nMethod, RASSCF
use Index_Functions, only: iTri
use iSD_data, only: iSD, nSD
use k2_arrays, only: Aux, Create_Braket, Destroy_Braket, nFT, Sew_Scr
use stdalloc, only: mma_allocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iS, jS, kS, lS, nHess, n_Int, nACO, nBuffer, nDens, MOip(0:7), nTwo2, nQuad
real(kind=wp), intent(inout) :: Hess(nHess), iInt(n_Int), Buffer(nBuffer), DTemp(nDens), DInAc(nDens)
logical(kind=iwp), intent(inout) :: Post_Process
logical(kind=iwp), intent(in) :: lGrad, lHess, lPick
integer(kind=iwp) :: iAng(4), iBasAO, iBasi, iBasn, iBsInc, iDer, iFnc(4), ipFin, ipMem2, ipMem3, ipMem4, ipMemX, ipMOC, ipPSO, &
                     iSD4(0:nSD,4), jBasAO, jBasj, jBasn, jBsInc, JndGrd(3,4,0:7), JndHss(4,3,4,3,0:7), kBasAO, kBask, kBasn, &
                     kBsInc, kCmp, lBasAO, lBasl, lBasn, lBsInc, lCmp, Mem1, Mem2, Mem3, Mem4, MemCMO, MemFck, MemFin, MemMax, &
                     MemPrm, MemPSO, MemX, nijkl, nRys, nSO, nTemp
real(kind=wp) :: Coor(3,4), PMax
logical(kind=iwp) :: JfG(4), JfGrd(3,4), JfHss(4,3,4,3), lDot, lDot2, lTri
real(kind=wp), pointer :: Fin(:), MOC(:), PSO(:,:), Temp(:), Work2(:), Work3(:), Work4(:), WorkX(:)
logical(kind=iwp), parameter :: n8 = .true.
integer(kind=iwp), external :: MemSO2_P

iFnc(:) = -99
PMax = Zero
if (.not. allocated(Sew_Scr)) then
  call mma_MaxDBLE(MemMax)
  if (MemMax > 8000) MemMax = MemMax-8000
  call mma_allocate(Sew_Scr,MemMax,Label='Sew_Scr')
else
  MemMax = size(Sew_Scr)
end if
ipMOC = 1

call Gen_iSD4(iS,jS,kS,lS,iSD,nSD,iSD4)

call Coor_setup(iSD4,nSD,Coor)
!                                                                      *
!***********************************************************************
!                                                                      *
! The code is working in such away that the MO needs upper and lower
! triangular parts of ij kl but hessian needs only lower, check if the
! integralbatch is lower or upper!!

lTri = (iTri(iS,jS) >= iTri(kS,lS))
if ((.not. lTri) .and. (nMethod /= RASSCF)) return
lDot = (lTri .and. lHess)

!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate memory for zeta, eta, kappa, P and Q.
! Allocate also for Alpha, Beta , Gamma and Delta in expanded form.

call Create_BraKet(iSD4(5,1)*iSD4(5,2),iSD4(5,3)*iSD4(5,4))
!                                                                      *
!***********************************************************************
!                                                                      *
! Fix the 1st order density matrix

! Pick up pointers to desymmetrized 1st order density matrices.
! Observe that the desymmetrized 1st order density matrices
! follow the contraction index.

if (lTri .and. lPick) call Dens_Infos(nMethod)

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute total size of the second order density matrix in SO basis.
!----------------------------------------------------------------------*
nSO = MemSO2_P(nSD,iSD4)
ldot2 = ldot
if (nSO == 0) ldot2 = .false.

! Compute memory request for the primitives.

iDer = 2
if (.not. ldot2) iDer = 1
iAng(:) = iSD4(1,:)
call MemRg2(iAng,nRys,MemPrm,iDer)

!----------------------------------------------------------------------*
!
! Calculate which derivatives should be made.
!
!----------------------------------------------------------------------*

call DerCtr(ldot2,JfGrd,JndGrd,JfHss,JndHss,JfG,nSD,iSD4)

!----------------------------------------------------------------------*
!
! Decide on the partitioning of the shells based on the
! available memory and the requested memory.
!
!----------------------------------------------------------------------*

call PSOAO2(nSO,MemPrm,MemMax,iFnc,nAco,Mem1,Mem2,Mem3,Mem4,MemX,MemPSO,MemFck,nFT,MemFin,nBuffer,nSD,iSD4)

iBasi = iSD4(3,1)
jBasj = iSD4(3,2)
kBask = iSD4(3,3)
lBasl = iSD4(3,4)

iBsInc = iSD4(4,1)
jBsInc = iSD4(4,2)
kBsInc = iSD4(4,3)
lBsInc = iSD4(4,4)

kCmp = iSD(2,kS)
lCmp = iSD(2,lS)

!----------------------------------------------------------------------*
!
! Loop over basis function if we do not have enough of memory to
! calculate them in one step.
!
!----------------------------------------------------------------------*
do iBasAO=1,iBasi,iBsInc
  iBasn = min(iBsInc,iBasi-iBasAO+1)
  iSD4(8,1) = iBasAO-1
  iSD4(19,1) = iBasn

  !--------------------------------------------------------------------*
  !
  ! Move appropriate portions of the desymmetrized 1st order density matrix.
  !
  !--------------------------------------------------------------------*
  do jBasAO=1,jBasj,jBsInc
    jBasn = min(jBsInc,jBasj-jBasAO+1)
    iSD4(8,2) = jBasAO-1
    iSD4(19,2) = jBasn

    if (lpick) call Picky_Mck(nSD,iSD4,1,2,nMethod)

    do kBasAO=1,kBask,kBsInc
      kBasn = min(kBsInc,kBask-kBasAO+1)
      iSD4(8,3) = kBasAO-1
      iSD4(19,3) = kBasn

      if (lpick) then
        call Picky_Mck(nSD,iSD4,1,3,nMethod)
        call Picky_Mck(nSD,iSD4,2,3,nMethod)
      end if

      do lBasAO=1,lBasl,lBsInc
        lBasn = min(lBsInc,lBasl-lBasAO+1)
        iSD4(8,4) = lBasAO-1
        iSD4(19,4) = lBasn

        if (lpick) then
          call Picky_Mck(nSD,iSD4,3,4,nMethod)
          call Picky_Mck(nSD,iSD4,1,4,nMethod)
          call Picky_Mck(nSD,iSD4,2,4,nMethod)
        end if

        !--------------------------------------------------------------*

        nijkl = iBasn*jBasn*kBasn*lBasn

        ! Mark out the memory allocations explicitly with pointers
        ! MO tranformation buffer
        MemCMO = nACO*(kCmp*kBasn+lCmp*lBasn)
        MOC(1:MemCMO) => Sew_Scr(ipMOC:ipMOC+MemCMO-1)
        ! Area for the AO integrals
        ipFin = ipMOC+MemCMO
        Fin(1:MemFin) => Sew_Scr(ipFin:ipFin+MemFin-1)
        ! Area for 2el density
        ipPSO = ipFin+MemFin
        PSO(1:nijkl,1:nSO) => Sew_Scr(ipPSO:ipPSO+nijkl*nSO-1)
        if (nijkl*nSO > Mem1) then
          write(u6,'(A)') 'nijkl*nSO>Mem1'
          write(u6,*) 'njikl,nSO=',nijkl,nSO
          write(u6,*) 'Mem1=',Mem1
          call Abend()
        end if
        ipMem2 = ipPSO+Mem1  ! Work
        Work2(1:Mem2) => Sew_Scr(ipMem2:ipMem2+Mem2-1)
        ipMem3 = ipMem2+Mem2 ! Work
        Work3(1:Mem3) => Sew_Scr(ipMem3:ipMem3+Mem3-1)
        ipMemX = ipMem3+Mem3 ! Work
        WorkX(1:MemX) => Sew_Scr(ipMemX:ipMemX+MemX-1)

        ! If MO transformation is performed in the standard way
        ! reserve memory for partial transformed integrals

        ! Multilayer

        ipMem4 = ipMem2+Mem2-Mem4
        Work4(1:Mem4) => Sew_Scr(ipMem4:ipMem4+Mem4-1)
        nTemp = Mem2+Mem3+MemX
        Temp(1:nTemp) => Sew_Scr(ipMem2:ipMem2+nTemp-1)

        !--------------------------------------------------------------*
        !
        ! Get the 2nd order density matrix in SO basis.
        !
        !--------------------------------------------------------------*

        if (n8) call PickMO(MOC,MemCMO,nSD,iSD4)
        if (ldot2) call PGet0(nijkl,PSO,nSO,iFnc,MemPSO,Temp,nTemp,nQuad,PMax,iSD4)

        ! Compute gradients of shell quadruplet

        call TwoEl_mck(Coor,nRys,Hess,nHess,JfGrd,JndGrd,JfHss,JndHss,JfG,PSO,nijkl,nSO,Work2,Mem2,Work3,Mem3,Work4,Mem4,Aux,nAux, &
                       WorkX,MemX,Fin,MemFin,Temp,nTemp,nTwo2,nFT,iInt,Buffer,nBuffer,lgrad,ldot2,n8,ltri,DTemp,DInAc,moip,nAco, &
                       MOC,MemCMO,iSD4)
        Post_Process = .true.

        nullify(MOC)
        nullify(Fin)
        nullify(PSO)
        nullify(Work2)
        nullify(Work3)
        nullify(WorkX)
        nullify(Work4)
        nullify(Temp)

        !--------------------------------------------------------------*

      end do
    end do
  end do
end do
call Destroy_Braket()

contains

subroutine Dens_Infos(nMethod)

  use Dens_stuff, only: ipDDij, ipDDij2, ipDDik, ipDDik2, ipDDil, ipDDil2, ipDDjk, ipDDjk2, ipDDjl, ipDDjl2, ipDDkl, ipDDkl2, &
                        ipDij, ipDij2, ipDik, ipDik2, ipDil, ipDil2, ipDjk, ipDjk2, ipDjl, ipDjl2, ipDkl, ipDkl2, mDCRij, mDCRik, &
                        mDCRil, mDCRjk, mDCRjl, mDCRkl
  use k2_arrays, only: ipDijS, ipDijS2
  use Index_Functions, only: iTri

  integer(kind=iwp), intent(in) :: nMethod
  integer(kind=iwp) :: ijS, ikS, ilS, ipDum, ipTmp, ipTmp2, iS, jkS, jlS, jS, klS, kS, lS
  integer(kind=iwp), parameter :: Nr_of_Densities = 1

  iS = iSD4(11,1)
  jS = iSD4(11,2)
  kS = iSD4(11,3)
  lS = iSD4(11,4)

  ijS = iTri(iS,jS)
  klS = iTri(kS,lS)
  ikS = iTri(iS,kS)
  ilS = iTri(iS,lS)
  jkS = iTri(jS,kS)
  jlS = iTri(jS,lS)
  ijS = iTri(iS,jS)
  klS = iTri(kS,lS)
  ikS = iTri(iS,kS)
  ilS = iTri(iS,lS)
  jkS = iTri(jS,kS)
  jlS = iTri(jS,lS)
  ipTmp = ipDijs
  if (nMethod == RASSCF) ipTmp2 = ipDijs2
  call Dens_Info(ijS,ipDij,ipDum,mDCRij,ipDDij,ipTmp,nr_of_Densities,nMethod,ipTmp2,ipDij2,ipDDij2)
  call Dens_Info(klS,ipDkl,ipDum,mDCRkl,ipDDkl,ipTmp,nr_of_Densities,nMethod,ipTmp2,ipDkl2,ipDDkl2)
  call Dens_Info(ikS,ipDik,ipDum,mDCRik,ipDDik,ipTmp,nr_of_Densities,nMethod,ipTmp2,ipDik2,ipDDik2)
  call Dens_Info(ilS,ipDil,ipDum,mDCRil,ipDDil,ipTmp,nr_of_Densities,nMethod,ipTmp2,ipDil2,ipDDil2)
  call Dens_Info(jkS,ipDjk,ipDum,mDCRjk,ipDDjk,ipTmp,nr_of_Densities,nMethod,ipTmp2,ipDjk2,ipDDjk2)
  call Dens_Info(jlS,ipDjl,ipDum,mDCRjl,ipDDjl,ipTmp,nr_of_Densities,nMethod,ipTmp2,ipDjl2,ipDDjl2)

end subroutine Dens_Infos

end subroutine Eval_g2_ijkl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ss_head_dbl_tail_act(lra)

use gugaci_global, only: jb_sys, jml, jmr, jpad, jpadl, jpel, jper, just, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w0, &
                         w0_ss, w1, w1_ss
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, lmi, lmij, lmj, lmk, lmki, lmkj, lr0, lri, lrj, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0ss1, w0ss10, w0ss11, w0ss12, w0ss13, w0ss14, w0ss15, w0ss16, w0ss17, w0ss18, w0ss2, w0ss20, &
                 w0ss3, w0ss4, w0ss5, w0ss6, w0ss7, w0ss8, w0ss9, w1ss1, w1ss10, w1ss11, w1ss12, w1ss13, w1ss14, w1ss15, w1ss16, &
                 w1ss17, w1ss18, w1ss2, w1ss3, w1ss4, w1ss5, w1ss6, w1ss7, w1ss8, w1ss9, wl, wl1, wl2, wl3, wl4

w0ss1 = Zero
w1ss1 = Zero
w0ss2 = Zero
w1ss2 = Zero
w0ss3 = Zero
w1ss3 = Zero
w0ss4 = Zero
w1ss4 = Zero
w0ss5 = Zero
w1ss5 = Zero
w0ss6 = Zero
w1ss6 = Zero
w0ss7 = Zero
w1ss7 = Zero
w0ss8 = Zero
w1ss8 = Zero
w0ss9 = Zero
w1ss9 = Zero
w0ss10 = Zero
w1ss10 = Zero
w0ss11 = Zero
w1ss11 = Zero
w0ss12 = Zero
w1ss12 = Zero
w0ss13 = Zero
w1ss13 = Zero
w0ss14 = Zero
w1ss14 = Zero
w0ss15 = Zero
w1ss15 = Zero
w0ss16 = Zero
w1ss16 = Zero
w0ss18 = Zero
w1ss18 = Zero

! ss(1-1)  ar(01)-bl(32)-
! ss(1-2)  ar(02)-bl(31)-
! ss(1-3)  ar(13)-bl(20)-
! ss(1-4)  ar(23)-bl(10)-
! ss(1-5)  (22)-ar(13)-bl(31)-
! ss(1-6)  (11)-ar(23)-bl(32)-
! ss(1-7)  ar(13)-c'(21)-bl(32)-
! ss(1-8)  ar(13)-c'(22)-bl(31)-
! ss(1-9)  ar(23)-c'(11)-bl(32)-
! ss(1-10) ar(23)-c'(12)-bl(31)-
! ss(1-11) ar(13)-bl(31)-c"(22)-
! ss(1-12) ar(13)-bl(32)-c"(21)-
! ss(1-13) ar(23)-bl(31)-c"(12)-
! ss(1-14) ar(23)-bl(32)-c"(11)-
! ss(1-15) (22)-drl(11)-
! ss(1-16) (11)-drl(22)-
! ss(1-17) drl(22)-c"(11)-
! ss(1-18) drl(11)-c"(22)-
! ss(1-19) drl(12)-c"(21)-
! ss(1-20) drl(33)-c"(00)-
! ss(1-20) drl(33)-c"(11)-c"(22)-
! ss(1-20) (11)drl(33)-c"(22)-
! ss(1-20) (11)(22)drl(33)-
! ss(1-20) drl(33)-c"(22)-c"(11)-
! ss(1-20) (22)drl(33)-c"(11)-
! ss(1-20) (22)(11)drl(33)-
! ss(1-20) (21)(12)drl(33)-
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    jmlr = Mul(jml,jmr)
    if (lmij /= jmlr) cycle
    w0ss2 = w0_ss(2)
    w1ss2 = w1_ss(2)
    w0ss4 = w0_ss(4)
    w1ss4 = w1_ss(4)
    w0ss5 = w0_ss(5)
    w1ss5 = w1_ss(5)
    w0ss10 = -w0_ss(10)
    w1ss10 = -w1_ss(10)
    w0ss14 = w0_ss(14)
    w1ss14 = w1_ss(14)
    if (jb_sys > 0) then
      w0ss1 = w0_ss(1)
      w1ss1 = w1_ss(1)
      w0ss3 = w0_ss(3)
      w1ss3 = w1_ss(3)
      w0ss6 = w0_ss(6)
      w1ss6 = w1_ss(6)
      w0ss7 = w0_ss(7)
      w1ss7 = w1_ss(7)
      w0ss8 = w0_ss(8)
      w1ss8 = w1_ss(8)
      w0ss9 = w0_ss(9)
      w1ss9 = w1_ss(9)
      w0ss11 = w0_ss(11)
      w1ss11 = w1_ss(11)
      w0ss12 = w0_ss(12)
      w1ss12 = w1_ss(12)
      w0ss13 = w0_ss(13)
      w1ss13 = w1_ss(13)
    end if
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0ss2 = -w0ss2
      w1ss2 = -w1ss2
      w0ss4 = -w0ss4
      w1ss4 = -w1ss4
      w0ss5 = -w0ss5
      w1ss5 = -w1ss5
      w0ss10 = -w0ss10
      w1ss10 = -w1ss10
      w0ss14 = -w0ss14
      w1ss14 = -w1ss14
      if (jb_sys > 0) then
        w0ss1 = -w0ss1
        w1ss1 = -w1ss1
        w0ss3 = -w0ss3
        w1ss3 = -w1ss3
        w0ss6 = -w0ss6
        w1ss6 = -w1ss6
        w0ss7 = -w0ss7
        w1ss7 = -w1ss7
        w0ss8 = -w0ss8
        w1ss8 = -w1ss8
        w0ss9 = -w0ss9
        w1ss9 = -w1ss9
        w0ss11 = -w0ss11
        w1ss11 = -w1ss11
        w0ss12 = -w0ss12
        w1ss12 = -w1ss12
        w0ss13 = -w0ss13
        w1ss13 = -w1ss13
      end if
    end if

    if ((jml == 1) .and. (lmij == jmr)) then
      iwdl = just(lri,lri)
      ! ss(1-1)   ar(01)-bl(32)-
      if (jb_sys > 0) then
        iwdr = just(lrj,lri)
        vlop0 = w0*w0ss1
        vlop1 = w1*w1ss1
        if (line == 26) then    !lri,lrj,lra
          call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        end if
        if (line == 28) then    !lri,lrj,lrs,lra
          call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        end if
        if (line == 29) then    !lri,lrj,lrs,lra
          call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        end if
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      end if
      ! ss(1-2)  ar(02)-bl(31)-
      iwdr = just(lri,lrj)
      vlop0 = w0*w0ss2
      vlop1 = w1*w1ss2
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if

    if ((jmr == 1) .and. (lmij == jml)) then
      iwdr = just(lrj,lrj)
      ! ss(1-3)  ar(13)-bl(20)-
      if (jb_sys > 0) then
        iwdl = just(lrj,lri)
        vlop0 = w0*w0ss3
        vlop1 = w1*w1ss3
        if (line == 26) then    !lri,lrj,lra
          call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        end if
        if (line == 28) then    !lri,lrj,lrs,lra
          call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        end if
        if (line == 29) then    !lri,lrj,lrs,lra
          call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        end if
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      end if
      ! ss(1-4)  ar(23)-bl(10)-        act -c"-                  ! iprad
      iwdl = just(lri,lrj)
      vlop0 = w0*w0ss4
      vlop1 = w1*w1ss4
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if

    vlop0 = w0*w0ss5
    vlop1 = w1*w1ss5
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (jb_sys > 0) then
      vlop0 = w0*w0ss6
      vlop1 = w1*w1ss6
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
    end if
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! ss(1-5)  (22)-ar(13)-bl(31)-
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        if (jb_sys > 0) then
          ! ss(1-6)  (11)-ar(23)-bl(32)-
          iwdl = just(lri,lrk)
          iwdr = just(lrj,lrk)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper)
        end if
      end if
    end do

    if (jb_sys > 0) then
      vlop0 = w0*w0ss7
      vlop1 = w1*w1ss7
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      vlop0 = w0*w0ss8
      vlop1 = w1*w1ss8
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
      end if
      vlop0 = w0*w0ss9
      vlop1 = w1*w1ss9
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
      end if
    end if
    vlop0 = w0*w0ss10
    vlop1 = w1*w1ss10
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
    end if

    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        if (jb_sys > 0) then
          ! ss(1-7)  ar(13)-c'(21)-bl(32)-
          iwdl = just(lrk,lri)
          iwdr = just(lrj,lrk)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl1,jper)
          ! ss(1-8)  ar(13)-c'(22)-bl(31)-
          iwdl = just(lrk,lri)
          iwdr = just(lrk,lrj)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl2,jper)
          ! ss(1-9)  ar(23)-c'(11)-bl(32)-
          iwdl = just(lri,lrk)
          iwdr = just(lrj,lrk)
          !wl = (vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl3,jper)
        end if
        ! ss(1-10) ar(23)-c'(12)-bl(31)-
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl4,jper)
      end if
    end do

    if (jb_sys > 0) then
      vlop0 = w0*w0ss11
      vlop1 = w1*w1ss11
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      vlop0 = w0*w0ss12
      vlop1 = w1*w1ss12
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
      end if
      vlop0 = w0*w0ss13
      vlop1 = w1*w1ss13
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
      end if
    end if
    vlop0 = w0*w0ss14
    vlop1 = w1*w1ss14
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
    end if

    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        if (jb_sys > 0) then
          ! ss(1-11) ar(13)-bl(31)-c"(22)-
          iwdl = just(lrk,lri)
          iwdr = just(lrk,lrj)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper)
          ! ss(1-12) ar(13)-bl(32)-c"(21)-
          iwdl = just(lrk,lri)
          iwdr = just(lrj,lrk)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper)
          ! ss(1-13) ar(23)-bl(31)-c"(12)-
          iwdl = just(lri,lrk)
          iwdr = just(lrk,lrj)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl3,jper)
        end if
        ! ss(1-14) ar(23)-bl(32)-c"(11)- act -c"-
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl4,jper)
      end if
    end do
  end do
end do

if (jpad /= jpadl) return

!if ((jb_sys > 0) .or. (jwl >= jwr)) then
if (jb_sys > 0) then
  if ((jpad > 17) .and. (jpad < 25)) then
    do lri=norb_frz+1,norb_dz
      lmi = lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj = lsm_inn(lrj)
        lmij = Mul(lmi,lmj)
        if ((lmij /= jml) .or. (jml /= jmr)) cycle
        iwdl = just(lrj,lri)
        iwdr = just(lri,lrj)
        ! ss(1-19) drl(12)-c"(21)-
        vlop0 = w0*w0_ss(19)
        vlop1 = w1*w1_ss(19)
        if (line == 26) then    !lri,lra
          call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
        end if
        if (line == 28) then    !lri,lrs,lra
          call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
        end if
        if (line == 29) then    !lri,lrs,lra
          call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
        end if
        !wl = (vlop0-vlop1)*voint(lri,lrb)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      end do
    end do
  end if
end if
if (jwl >= jwr) return

w0ss15 = w0_ss(15)
w1ss15 = w1_ss(15)
w0ss17 = w0_ss(17)
w1ss17 = w1_ss(17)
w0ss20 = w0_ss(20)
if (jb_sys > 0) then
  w0ss16 = w0_ss(16)
  w1ss16 = w1_ss(16)
  w0ss18 = w0_ss(18)
  w1ss18 = w1_ss(18)
end if

if ((jml == 1) .and. (jmr == 1)) then
  ! ss(1-20) drl(33)-c"(00)-                          ! ipl(r)ad=1 or =ns
  do lr0=norb_frz+1,norb_dz
    iwdl = just(lr0,lr0)
    iwdr = iwdl
    vlop0 = w0*w0_ss(20)
    vlop1 = Zero
    wl = Zero
    do lrk=1,norb_dz
      if (lrk == lr0) cycle
      if (line == 26) then    !lrk,lra
        call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wl1)
      end if
      if (line == 28) then    !lrk,lrs,lra    lrs,lra,lrk
        !call comp_loop(12,lrk,lrs,lra,lra,vlop0,vlop1,wl1)
        call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 29) then    !lrk,lrs,lra
        call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wl1)
        !call comp_loop(11,lrk,lrs,lra,lra,vlop0,vlop1,wl1)
      end if
      wl = wl+wl1
    end do
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
end if
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if ((lmij /= jml) .or. (jml /= jmr)) cycle
    if ((jwl >= jwr) .and. (jb_sys == 0)) cycle
    wl = Zero
    iwdl = just(lri,lrj)
    iwdr = iwdl
    ! ss(1-15) (22)-drl(11)-
    vlop0 = w0*w0ss15
    vlop1 = w1*w1ss15
    wl = Zero
    if (line == 26) then    !lrj,lra
      call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl1)
    end if
    if (line == 28) then    !lrj,lrs,lra
      call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl1)
    end if
    if (line == 29) then    !lrj,lrs,lra
      call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl1)
    end if
    wl = wl+wl1
    !wl = wl+(vlop0-vlop1)*voint(lrj,lrb)
    ! ss(1-17) drl(22)-c"(11)-
    vlop0 = w0*w0ss17
    vlop1 = w1*w1ss17
    if (line == 26) then    !lri,lra
      call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl1)
    end if
    if (line == 28) then    !lri,lrs,lra
      call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl1)
    end if
    if (line == 29) then    !lri,lrs,lra
      call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl1)
    end if
    wl = wl+wl1
    !wl = wl+(vlop0-vlop1)*voint(lri,lrb)
    ! ss(1-20) (22)(11)drl(33)-
    ! ss(1-20) (22)drl(33)-c"(11)-
    ! ss(1-20) drl(33)-c"(22)-c"(11)-
    vlop0 = w0*w0ss20
    vlop1 = Zero
    do lrk=1,norb_dz
      if (lrk == lri) cycle
      if (lrk == lrj) cycle
      if (line == 26) then    !lrk,lra
        call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wl1)
      end if
      if (line == 28) then    !lrk,lrs,lra
        call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 29) then    !lrk,lrs,lra
        call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wl1)
      end if
      wl = wl+wl1
      !wl = wl+vlop0*voint(lrk,lrb)
    end do
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    if (jb_sys > 0) then
      iwdl = just(lrj,lri)
      iwdr = iwdl
      !ss(1-16) (11)-drl(22)-
      vlop0 = w0*w0ss16
      vlop1 = w1*w1ss16
      wl = Zero
      if (line == 26) then    !lrj,lra
        call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl1)
      end if
      if (line == 28) then    !lrj,lrs,lra
        call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 29) then    !lrj,lrs,lra
        call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl1)
      end if
      wl = wl+wl1
      !wl = (vlop0-vlop1)*voint(lrj,lrb)
      ! ss(1-18) drl(11)-c"(22)-
      vlop0 = w0*w0ss18
      vlop1 = w1*w1ss18
      if (line == 26) then    !lri,lra
        call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl1)
      end if
      if (line == 28) then    !lri,lrs,lra
        call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 29) then    !lri,lrs,lra
        call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl1)
      end if
      wl = wl+wl1
      !wl = wl+(vlop0-vlop1)*voint(lri,lrb)
      ! ss(1-20) drl(33)-c"(11)-c"(22)-
      ! ss(1-20) (11)drl(33)-c"(22)-
      ! ss(1-20) (11)(22)drl(33)-
      vlop0 = w0*w0ss20
      vlop1 = Zero
      do lrk=1,norb_dz
        if (lrk == lri) cycle
        if (lrk == lrj) cycle
        if (line == 26) then    !lrk,lra
          call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wl1)
        end if
        if (line == 28) then    !lrk,lrs,lra
          call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wl1)
        end if
        if (line == 29) then    !lrk,lrs,lra
          call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wl1)
        end if
        wl = wl+wl1
        !wl = wl+vlop0*voint(lrk,lrb)
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
  end do
end do

return

end subroutine ss_head_dbl_tail_act

subroutine st_head_dbl_tail_act(lra)

use gugaci_global, only: jb_sys, jml, jmr, jpel, jper, just, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwds, iwdt, jmlr, lmi, lmij, lmj, lmk, lri, lrj, lrk, ni
real(kind=wp) :: vlop0, vlop1, w1st1, w1st2, w1st3, w1st4, wl, wl1

! st(2-1) ar(02)-bl(32)-
! st(2-2) (22)ar(13)-bl(32)-
! st(2-4) ar(23)-c'(12)-bl(32)-
! st(2-4) ar(23)-bl(32)-c'(12)-
! st(2-5) (22)drl(12)-
! st(2-6) drl(22)-c"(12)-
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    lmij = Mul(lmij,1)
    if ((jml == jmr) .and. (lmij == jml)) then
      iwds = just(lri,lrj)
      iwdt = iwds
      ! st(2-5) (22)drl(12)-
      vlop1 = w1*w1_st(5)             !d2-5
      vlop0 = Zero
      if (line == 26) then    !lrj,lra
        call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lrj,lrs,lra
        call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lrj,lrs,lra
        call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl)
      end if
      ! st(2-6) drl(22)-c"(12)-
      vlop1 = w1*w1_st(6)             !d2-6
      vlop0 = Zero
      if (line == 26) then    !lri,lra
        call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl1)
      end if
      if (line == 28) then    !lri,lrs,lra
        call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 29) then    !lri,lrs,lra
        call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl1)
      end if
      wl = wl+wl1
      !list = list3(lra,lrb,lri)
      !wl = wl-vlop1*vint_ci(list)    !4.3 vlop0=0        !!!!!
      call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
      ! st(2-7) drl(12)-c"(22)-
      if (jb_sys > 0) then
        iwds = just(lrj,lri)
        iwdt = just(lri,lrj)
        vlop1 = w1*w1_st(7)
        vlop0 = Zero             !d2-6
        !list = list3(lra,lrb,lri)
        !wl = wl-vlop1*vint_ci(list)    !4.3 vlop0=0        !!!!!
        if (line == 26) then    !lri,lra
          call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
        end if
        if (line == 28) then    !lri,lrs,lra
          call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
        end if
        if (line == 29) then    !lri,lrs,lra
          call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
        end if
        call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
      end if
    end if

    jmlr = Mul(jml,jmr)
    if (lmij /= jmlr) cycle
    w1st1 = w1_st(1)
    w1st2 = w1_st(2)
    w1st3 = w1_st(3)
    w1st4 = w1_st(4)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1st1 = -w1st1
      w1st2 = -w1st2
      w1st3 = -w1st3
      w1st4 = -w1st4
    end if
    if (jml == 1) then
      ! st(2-1) ar(02)-bl(32)-
      iwds = just(lri,lri)
      iwdt = just(lri,lrj)
      vlop1 = w1*w1st1
      vlop0 = Zero
      !list = list4(lri,lrj,lra,lrb)
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then     !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then     !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      !wl = -vlop1*vint_ci(list)    !1.1 vlop0=0        !!!!!
      call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
    end if

    ! st(2-2) (22)ar(13)-bl(32)-
    vlop1 = w1*w1st2
    !wl = -vlop1*vint_ci(list)    !1.1
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      if (Mul(lmk,lmi) /= jml) cycle
      if (Mul(lmk,lmj) /= jmr) cycle
      iwds = just(lrk,lri)
      iwdt = just(lrk,lrj)
      call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
    end do
    ! st(2-3) ar(13)-bl(32)-c'(22)-
    ! st(2-4) ar(23)-bl(32)-c'(12)-
    vlop1 = w1*w1st4
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    !wl = -vlop1*vint_ci(list)    !1.1 vlop0=0
    if (jb_sys > 0) then
      vlop1 = w1*w1st3
      vlop0 = Zero
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
      end if
    end if
    !wl1 = -vlop1*vint_ci(list)
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      if (Mul(lmk,lmi) /= jml) cycle
      if (Mul(lmk,lmj) /= jmr) cycle
      iwds = just(lri,lrk)
      iwdt = just(lrj,lrk)
      call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
      if (jb_sys > 0) then
        iwds = just(lrk,lri)
        call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl1,jper)
      end if
    end do
    ! st(2-4) ar(23)-c'(12)-bl(32)-
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      if (Mul(lmk,lmi) /= jml) cycle
      if (Mul(lmk,lmj) /= jmr) cycle
      iwds = just(lri,lrk)
      iwdt = just(lrk,lrj)
      call prodab(3,jpel,iwds,iwdt,jwl,jwr,-wl,jper)
      ! st(2-3) ar(13)-c'(22)-bl(32)-
      if (jb_sys > 0) then
        iwds = just(lrk,lri)
        call prodab(3,jpel,iwds,iwdt,jwl,jwr,-wl1,jper)
      end if
    end do
  end do
end do

return

end subroutine st_head_dbl_tail_act

subroutine ts_head_dbl_tail_act(lra)

use gugaci_global, only: jb_sys, jml, jmr, jpel, jper, just, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w1, w1_ts
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwds, iwdt, lmas, lmi, lmij, lmj, lmk, lri, lrj, lrk, ni
real(kind=wp) :: vlop0, vlop1, w1ts1, w1ts2, w1ts3, w1ts4, wl

! ts(3-1) ar(23)-bl(20)-
! ts(3-2) (22)ar(23)-bl(31)-
! ts(3-2) ar(23)-c'(22)-bl(31)-
! ts(3-3) ar(23)-bl(31)-c"(22)-
! ts(3-4) ar(23)-bl(32)-c"(21)-
lmas = Mul(lsm_inn(lra),lsm_inn(lrs))
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmas /= lmij) cycle
    w1ts1 = w1_ts(1)
    w1ts2 = w1_ts(2)
    w1ts3 = w1_ts(3)
    w1ts4 = w1_ts(4)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1ts1 = -w1ts1
      w1ts2 = -w1ts2
      w1ts3 = -w1ts3
      w1ts4 = -w1ts4
    end if
    !list = list3(lri,lrj,lrb)
    !-------------------------------------------------------------------
    ! ts(3-1) ar(23)-bl(20)-
    if ((jmr == 1) .and. (lmij == jml)) then
      iwdt = just(lri,lrj)
      iwds = just(lrj,lrj)
      vlop1 = w1*w1ts1             !d3-1
      vlop0 = Zero
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      !wl = -vlop1*(vint_ci(list))    !2.2 vlop0=0
      call prodab(3,jpel,iwdt,iwds,jwl,jwr,wl,jper)
    end if
    !-------------------------------------------------------------------
    vlop1 = w1*w1ts2             !d3-2
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    !wl = -vlop1*(vint_ci(list))    !2.2 vlop0=0
    ! ts(3-2) (22)ar(23)-bl(31)-
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      if ((Mul(lmk,lmi) /= jml) .or. (Mul(lmk,lmj) /= jmr)) cycle
      iwdt = just(lrk,lri)
      iwds = just(lrk,lrj)
      call prodab(3,jpel,iwdt,iwds,jwl,jwr,wl,jper)
    end do
    ! ts(3-2) ar(23)-c'(22)-bl(31)-
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      if ((Mul(lmk,lmi) /= jml) .or. (Mul(lmk,lmj) /= jmr)) cycle
      iwdt = just(lri,lrk)
      iwds = just(lrk,lrj)
      call prodab(3,jpel,iwdt,iwds,jwl,jwr,-wl,jper)
    end do
    !-------------------------------------------------------------------
    ! ts(3-4) ar(23)-bl(32)-c"(21)-
    vlop1 = w1*w1ts4             !d3-4
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      if ((Mul(lmk,lmi) /= jml) .or. (Mul(lmk,lmj) /= jmr)) cycle
      iwdt = just(lri,lrk)
      iwds = just(lrj,lrk)
      call prodab(3,jpel,iwdt,iwds,jwl,jwr,wl,jper)
    end do
    !-------------------------------------------------------------------
    ! ts(3-3) ar(23)-bl(31)-c"(22)-
    if (jb_sys > 0) then
      vlop1 = w1*w1ts3             !d3-4
      vlop0 = Zero
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      !wl = -vlop1*vint_ci(list)    !2.2 vlop0=0
      do lrk=lrj+1,norb_dz
        lmk = lsm_inn(lrk)
        if ((Mul(lmk,lmi) /= jml) .or. (Mul(lmk,lmj) /= jmr)) cycle
        iwdt = just(lri,lrk)
        iwds = just(lrk,lrj)
        call prodab(3,jpel,iwdt,iwds,jwl,jwr,wl,jper)
      end do
    end if
  end do
end do

return

end subroutine ts_head_dbl_tail_act

subroutine stt_head_dbl_tail_act(lra)

use gugaci_global, only: jml, jmr, jpel, jper, just, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w1, w1_st1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwdl, iwdr, lmi, lmij, lmj, lmk, lri, lrj, lrk, ni
real(kind=wp) :: vlop0, vlop1, w1st1, w1st2, w1st3, w1st4, wl

! st1(4-1) ar(01)-bl(31)-
! st1(4-2) (11)ar(23)-bl(31)-
! st1(4-3) ar(13)-c'(21)-bl(31)-
! st1(4-3) ar(13)-bl(31)-c"(21)-
! st1(4-4) ar(23)-c'(11)-bl(31)-
! st1(4-4) ar(23)-bl(31)-c"(11)-
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    w1st1 = w1_st1(1)
    w1st2 = w1_st1(2)
    w1st3 = w1_st1(3)
    w1st4 = w1_st1(4)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1st1 = -w1st1
      w1st2 = -w1st2
      w1st3 = -w1st3
      w1st4 = -w1st4
    end if
    !list = list3(lri,lrj,lrb)
    if ((jml == 1) .and. (lmij == jmr)) then
      ! st1(4-1) ar(01)-bl(31)-
      iwdl = just(lri,lri)
      iwdr = just(lri,lrj)
      vlop1 = w1*w1st1
      vlop0 = Zero
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      !wl = -vlop1*(vint_ci(list))    !2.2 vlop0=0
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
    ! st1(4-2) (11)ar(23)-bl(31)-
    vlop1 = w1*w1st2
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      if ((Mul(lmk,lmi) /= jml) .or. (Mul(lmk,lmj) /= jmr)) cycle
      !wl = -vlop1*vint_ci(list)
      iwdl = just(lri,lrk)
      iwdr = just(lrk,lrj)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
    vlop1 = w1*w1st4
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    ! st1(4-4) ar(23)-c'(11)-bl(31)-
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      if ((Mul(lmi,lmk) /= jml) .or. (Mul(lmk,lmj) /= jmr)) cycle
      iwdl = just(lri,lrk)
      iwdr = just(lrk,lrj)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
    end do
    ! st1(4-4) ar(23)-bl(31)-c"(11)-
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      if ((Mul(lmi,lmk) /= jml) .or. (Mul(lmj,lmk) /= jmr)) cycle
      iwdl = just(lri,lrk)
      iwdr = just(lrj,lrk)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do

    vlop1 = w1*w1st3
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    ! st1(4-3) ar(13)-c'(21)-bl(31)-
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      if ((Mul(lmi,lmk) /= jml) .or. (Mul(lmk,lmj) /= jmr)) cycle
      iwdl = just(lrk,lri)
      iwdr = just(lrk,lrj)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
    end do
    ! st1(4-3) ar(13)-bl(31)-c"(21)-
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      if ((Mul(lmi,lmk) /= jml) .or. (Mul(lmj,lmk) /= jmr)) cycle
      iwdl = just(lrk,lri)
      iwdr = just(lrj,lrk)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
  end do
end do

return

end subroutine stt_head_dbl_tail_act

subroutine tts_head_dbl_tail_act(lra)

use gugaci_global, only: jml, jmr, jpel, jper, just, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w1, w1_t1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwdl, iwdr, lmi, lmij, lmj, lmk, lri, lrj, lrk, ni
real(kind=wp) :: vlop0, vlop1, w1t1s1, w1t1s2, w1t1s3, w1t1s4, w1t1s5, w1t1s6, w1t1s7, wl

! t1s(5-1)   ar(13)-bl(10)-
! t1s(5-2)   ar(13)-bl(32)-
! t1s(5-2)   ar(13)-c'(11)-bl(32)-
! t1s(5-3)   ar(13)-bl(31)-c"(12)-
! t1s(5-4)   ar(13)-bl(32)-c"(11)-
! t1s(5-5)   drl(12)-
! t1s(5-6)   drl(12)-c"(12)-
! t1s(5-7)   drl(12)-c"(11)-
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    w1t1s1 = w1_t1s(1)
    w1t1s2 = w1_t1s(2)
    w1t1s3 = w1_t1s(3)
    w1t1s4 = w1_t1s(4)
    w1t1s5 = w1_t1s(5)
    w1t1s6 = w1_t1s(6)
    w1t1s7 = w1_t1s(7)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1t1s1 = -w1t1s1
      w1t1s2 = -w1t1s2
      w1t1s3 = -w1t1s3
      w1t1s4 = -w1t1s4
      !w1t1s5 = -w1t1s5
      !w1t1s6 = -w1t1s6
      !w1t1s7 = -w1t1s7
    end if
    !list = list3(lri,lrj,lrb)
    if ((jml == lmij) .and. (jmr == 1)) then
      ! t1s(5-1)   ar(13)-bl(10)-
      vlop1 = w1*w1t1s1
      vlop0 = Zero
      if (line == 26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      !wl = -vlop1*vint_ci(list)
      iwdl = just(lri,lrj)
      iwdr = just(lrj,lrj)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
    vlop1 = w1*w1t1s2
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    !wl = -vlop1*vint_ci(list)
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      ! t1s(5-2)   (11)ar(13)-bl(32)-
      if ((jml /= Mul(lmk,lmi)) .or. (jmr /= Mul(lmk,lmj))) cycle
      !vlop1 = w1*w1t1s2
      !wl = -vlop1*vint_ci(list)
      iwdl = just(lrk,lri)
      iwdr = just(lrj,lrk)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      ! t1s(5-2)   ar(13)-c'(11)-bl(32)-
      if ((jml /= Mul(lmi,lmk)) .or. (jmr /= Mul(lmk,lmj))) cycle
      !vlop1 = w1*w1t1s2
      !wl = -vlop1*vint_ci(list)
      iwdl = just(lri,lrk)
      iwdr = just(lrj,lrk)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
    end do
    vlop1 = w1*w1t1s3
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      ! t1s(5-3)   ar(13)-bl(31)-c"(12)-
      if ((jml /= Mul(lmi,lmk)) .or. (jmr /= Mul(lmj,lmk))) cycle
      !vlop1 = w1*w1t1s3
      !wl = -vlop1*vint_ci(list)
      iwdl = just(lri,lrk)
      iwdr = just(lrk,lrj)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
    vlop1 = w1*w1t1s4
    vlop0 = Zero
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrk,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrk,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    !wl = -vlop1*vint_ci(list)
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      ! t1s(5-4)   ar(13)-bl(32)-c"(11)-
      if ((jml /= Mul(lmi,lmk)) .or. (jmr /= Mul(lmj,lmk))) cycle
      iwdl = just(lri,lrk)
      iwdr = just(lrj,lrk)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
    if ((lmij == jml) .and. (lmij == jmr)) then
      ! t1s(5-5)   (11)drl(12)-
      vlop1 = w1*w1t1s5
      vlop0 = Zero
      if (line == 26) then    !lrj,lra
        call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lrj,lrs,lra
        call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lrj,lrs,lra
        call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl)
      end if
      !wl = -vlop1*voint(lrb,lrj)
      iwdl = just(lri,lrj)
      iwdr = just(lrj,lri)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      ! t1s(5-6)   drl(11)-c"(12)-
      vlop1 = w1*w1t1s6
      vlop0 = Zero
      if (line == 26) then    !lri,lra
        call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lri,lrs,lra
        call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lri,lrs,lra
        call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
      end if
      !wl = -vlop1*voint(lrb,lri)
      iwdl = just(lri,lrj)
      iwdr = just(lrj,lri)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      ! t1s(5-7)   drl(12)-c"(11)-
      vlop1 = w1*w1t1s7
      vlop0 = Zero
      if (line == 26) then    !lri,lra
        call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lri,lrs,lra
        call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lri,lrs,lra
        call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
      end if
      !wl = -vlop1*voint(lrb,lri)
      iwdl = just(lri,lrj)
      iwdr = iwdl
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
  end do
end do

return

end subroutine tts_head_dbl_tail_act

subroutine tt_head_dbl_tail_act(lra)

use gugaci_global, only: jml, jmr, jpad, jpadl, jpel, jper, just, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_tt, w1, &
                         w1_tt
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwdl, iwdr, jmlr, lmi, lmij, lmj, lmk, lmki, lmkj, lri, lrj, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0tt1, w0tt2, w0tt3, w1tt1, w1tt2, wl, wltmp

! tt(11-1) (22)ar(23)-bl(32)-
! tt(11-1) ar(23)-c'(22)-bl(32)-
! tt(11-1) ar(23)-bl(32)-c"(22)-
! tt(11-2) (22)drl(22)-
! tt(11-2) drl(22)-c"(22)-
! tt(11-3) (22)drl(33)-
! tt(11-3) drl(33)-c"(22)-
! tt(11-3) drl(33)-c"(22)-c"(22)-
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    jmlr = Mul(jml,jmr)
    if (lmij /= jmlr) cycle
    w0tt1 = w0_tt(1)
    w1tt1 = w1_tt(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0tt1 = -w0tt1
      w1tt1 = -w1tt1
    end if
    !list = list3(lri,lrj,lrb)
    vlop0 = w0*w0tt1
    vlop1 = w1*w1tt1
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    !wl = (vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
    ! tt(11-1) (22)ar(23)-bl(32)-
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      end if
    end do
    ! tt(11-1) ar(23)-bl(32)-c"(22)-    act -c"-
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      end if
    end do
    ! tt(11-1) ar(23)-c'(22)-bl(32)-    act -c"-
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
      end if
    end do
  end do
end do

if (jpad /= jpadl) return
if (jwl >= jwr) return

w0tt2 = w0_tt(2)
w1tt2 = w1_tt(2)
w0tt3 = w0_tt(3)

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if ((lmij /= jml) .or. (lmij /= jmr)) cycle
    if (jwl >= jwr) cycle
    ! tt(11-2) (22)drl(22)-
    ! tt(11-2) drl(22)-c"(22)-
    iwdl = just(lri,lrj)
    iwdr = iwdl
    vlop0 = w0*w0tt2
    vlop1 = w1*w1tt2
    if (line == 26) then    !lrj,lra
      call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lrj,lrs,lra
      call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lrj,lrs,lra
      call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 26) then    !lri,lra
      call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wltmp)
    end if
    if (line == 28) then    !lri,lrs,lra
      call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wltmp)
    end if
    if (line == 29) then    !lri,lrs,lra
      call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wltmp)
    end if
    wl = wl+wltmp
    !wl = (vlop0-vlop1)*(voint(lrb,lri)+voint(lrb,lrj))
    vlop0 = w0*w0tt3
    vlop1 = Zero
    do lrk=1,norb_dz
      if (lrk == lri) cycle
      if (lrk == lrj) cycle
      ! tt(11-3) drl(33)-c"(22)-c"(22)-
      ! tt(11-3) (22)drl(33)-c"(22)-
      ! tt(11-3) (22)(22)drl(33)-
      if (line == 26) then    !lrk,lra
        call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wltmp)
      end if
      if (line == 28) then    !lrk,lrs,lra
        call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
      end if
      if (line == 29) then    !lrk,lrs,lra
        call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
      end if
      wl = wl+wltmp
    end do
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
end do

return

end subroutine tt_head_dbl_tail_act

subroutine tttt_head_dbl_tail_act(lra)

use gugaci_global, only: jml, jmr, jpad, jpadl, jpel, jper, just, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_t1t1, &
                         w1, w1_t1t1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwdl, iwdr, lmi, lmij, lmj, lmm, lri, lrj, lrk, lrm, ni
real(kind=wp) :: vlop0, vlop1, w0tt1, w1tt1, wl, wltmp

! t1t1(12-1)  ar(13)-bl(31)-
! t1t1(12-1)  ar(13)-c'(11)-bl(31)-
! t1t1(12-1)  ar(13)-bl(31)-c"(11)-
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    w0tt1 = w0_t1t1(1)
    w1tt1 = w1_t1t1(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0tt1 = -w0tt1
      w1tt1 = -w1tt1
    end if
    !list = list4(lri,lrj,lra,lrb)
    vlop0 = w0*w0tt1
    vlop1 = w1*w1tt1
    if (line == 26) then    !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lri,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    !wl = (vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
    ! t1t1(12-1)  (11)ar(13)-bl(31)-
    do lrm=norb_frz+1,lri-1
      lmm = lsm_inn(lrm)
      if ((jml /= Mul(lmi,lmm)) .or. (jmr /= Mul(lmm,lmj))) cycle
      iwdl = just(lrm,lri)
      iwdr = just(lrm,lrj)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
    ! t1t1(12-1)  ar(13)-bl(31)-c"(11)-
    do lrm=lrj+1,norb_dz
      lmm = lsm_inn(lrm)
      if ((jml /= Mul(lmi,lmm)) .or. (jmr /= Mul(lmm,lmj))) cycle
      iwdl = just(lri,lrm)
      iwdr = just(lrj,lrm)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
    ! t1t1(12-1)  ar(13)-c'(11)-bl(31)-
    do lrm=lri+1,lrj-1
      lmm = lsm_inn(lrm)
      if ((jml /= Mul(lmi,lmm)) .or. (jmr /= Mul(lmm,lmj))) cycle
      iwdl = just(lri,lrm)
      iwdr = just(lrm,lrj)
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
    end do
  end do
end do

if (jpad /= jpadl) return
if (jwl >= jwr) return

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz               !bbs_tmp
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (jml /= lmij) cycle
    vlop0 = w0*w0_t1t1(2)
    vlop1 = w1*w1_t1t1(2)
    ! t1t1(12-2)  (11)drl(11)-
    if (line == 26) then    !lri,lra
      call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then    !lrk,lrs,lra
      call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then    !lrk,lrs,lra
      call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
    end if
    ! t1t1(12-2)  drl(11)-c"(11)-
    if (line == 26) then    !lrj,lra
      call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wltmp)
    end if
    if (line == 28) then    !lrj,lrs,lra
      call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wltmp)
    end if
    if (line == 29) then    !lrj,lrs,lra
      call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wltmp)
    end if
    wl = wl+wltmp
    ! t1t1(12-3)  (11)(11)drl(33)-
    ! t1t1(12-3)  (11)drl(33)-c"(11)-
    ! t1t1(12-3)  drl(33)-c"(11)-c"(11)-
    do lrk=1,norb_dz
      if (lrk == lri) cycle
      if (lrk == lrj) cycle
      vlop0 = w0*w0_t1t1(3)
      vlop1 = Zero
      if (line == 26) then    !lrk,lra
        call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wltmp)
      end if
      if (line == 28) then    !lrk,lrs,lra
        call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
      end if
      if (line == 29) then    !lrk,lrs,lra
        call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
      end if
      wl = wl+wltmp
    end do
    iwdl = just(lri,lrj)
    iwdr = iwdl
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
end do

return

end subroutine tttt_head_dbl_tail_act

subroutine dd_head_dbl_tail_act(lra)

use gugaci_global, only: jml, jmr, jpel, jper, jud, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_dd, w1, w1_dd
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: imil, imir, iwdl, iwdr, lril, lrir, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0dd1, w1dd1, wl, wltmp

! dd(19-1) ar(23)-bl(32)-
! dd(19-2) drl(22)-
! dd(19-3) drl(33)-
! dd(19-3) drl(33)-c"(22)-
do lril=norb_frz+1,norb_dz
  imil = lsm_inn(lril)
  if (imil /= jml) cycle
  iwdl = jud(lril)
  do lrir=lril,norb_dz
    imir = lsm_inn(lrir)
    if (imir /= jmr) cycle
    iwdr = jud(lrir)

    w0dd1 = w0_dd(1)
    w1dd1 = w1_dd(1)
    ni = mod(lrir-lril,2)
    if (ni == 0) then
      w0dd1 = -w0dd1
      w1dd1 = -w1dd1
    end if

    if ((lril == lrir) .and. (jwl < jwr)) then
      ! dd(19-2) drl(22)-
      vlop0 = w0*w0_dd(2)
      vlop1 = w1*w1_dd(2)
      if (line == 26) then    !lril,lra
        call comp_loop(9,lril,0,0,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lril,lrs,lra
        call comp_loop(12,lril,0,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lril,lrs,lra
        call comp_loop(11,lril,0,lrs,lra,vlop0,vlop1,wl)
      end if
      !wl = (vlop0-vlop1)*voint(lra,lril)
      !call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      ! dd(19-3) drl(33)-
      vlop0 = w0*w0_dd(3)
      vlop1 = Zero
      do lrk=1,norb_dz
        if (lrk == lril) cycle
        !list = list3(lrs,lra,lrk)
        if (line == 26) then    !lrk,lra
          call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wltmp)     !wyb
        end if
        if (line == 28) then    !lrk,lrs,lra
          call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wltmp)  !wyb
        end if
        if (line == 29) then    !lrk,lrs,lra
          call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wltmp)  !wyb
        end if
        !wl = wl+vlop0*voint(lrk,lra)
        wl = wltmp+wl
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
    if (lril /= lrir) then
      ! dd(19-1) ar(23)-bl(32)-
      vlop0 = w0*w0dd1
      vlop1 = w1*w1dd1
      if (line == 26) then   !lril,lrir,lra
        call comp_loop(5,lril,lrir,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then   !lril,lrir,lrs,lra
        call comp_loop(7,lril,lrir,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then   !lril,lrir,lrs,lra
        call comp_loop(6,lril,lrir,lrs,lra,vlop0,vlop1,wl)
      end if
      !list = list4(lril,lrir,lrs,lra)
      !wl = vlop0*(vint_ci(list)-2*vint_ci(list+1))-vlop1*vint_ci(list) !1.1       !!!!!
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
  end do
end do

return

end subroutine dd_head_dbl_tail_act

subroutine dddd_head_dbl_tail_act(lra)

use gugaci_global, only: jml, jmr, jpel, jper, jud, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_d1d1, w1, w1_d1d1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: imil, imir, iwdl, iwdr, lril, lrir, lrk, ni
real(kind=wp) :: vlop0, vlop1, w0dd1, w1dd1, wl, wltmp

! d1d1(20-1) ar(13)-bl(31)-
! d1d1(20-1) drl(11)-
! d1d1(20-1) drl(33)-
! d1d1(20-1) drl(33)-c"(11)-
do lril=norb_frz+1,norb_dz
  imil = lsm_inn(lril)
  if (imil /= jml) cycle
  iwdl = jud(lril)
  do lrir=lril,norb_dz
    imir = lsm_inn(lrir)
    if (imir /= jmr) cycle
    w0dd1 = w0_d1d1(1)
    w1dd1 = w1_d1d1(1)
    ni = mod(lrir-lril,2)
    if (ni == 0) then
      w0dd1 = -w0dd1
      w1dd1 = -w1dd1
    end if
    iwdr = jud(lrir)
    if ((lril == lrir) .and. (jwl < jwr)) then
      ! d1d1(20-1) drl(11)-
      vlop0 = w0*w0_d1d1(2)
      vlop1 = w1*w1_d1d1(2)
      if (line == 26) then    !lril,lra
        call comp_loop(9,lril,0,0,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then    !lril,lrs,lra
        call comp_loop(12,lril,0,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then    !lril,lrs,lra
        call comp_loop(11,lril,0,lrs,lra,vlop0,vlop1,wl)
      end if
      ! d1d1(20-1) drl(33)-
      ! d1d1(20-1) drl(33)-c"(11)-
      vlop0 = w0*w0_d1d1(3)
      vlop1 = Zero
      do lrk=1,norb_dz
        if (lrk == lril) cycle
        if (line == 26) then    !lrk,lra
          call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wltmp)
        end if
        if (line == 28) then    !lrk,lrs,lra
          call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
        end if
        if (line == 29) then    !lrk,lrs,lra
          call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
        end if
        wl = wl+wltmp
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
    if (lril /= lrir) then
      ! d1d1(20-1) ar(13)-bl(31)-
      vlop0 = w0*w0dd1
      vlop1 = w1*w1dd1
      if (line == 26) then   !lril,lrir,lra
        call comp_loop(5,lril,lrir,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 28) then   !lril,lrir,lrs,lra
        call comp_loop(7,lril,lrir,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 29) then   !lril,lrir,lrs,lra
        call comp_loop(6,lril,lrir,lrs,lra,vlop0,vlop1,wl)
      end if
      !list = list3(lril,lrir,lra)
      !wl = (vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)   !2
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
  end do
end do

return

end subroutine dddd_head_dbl_tail_act

subroutine dd1_head_dbl_tail_act(lra)

use gugaci_global, only: jml, jmr, jpel, jper, jud, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w1, w1_dd1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwdl, iwdr, lmi, lmj, lri, lrj, ni
real(kind=wp) :: vlop0, vlop1, wl

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  iwdl = jud(lri)
  do lrj=lri+1,norb_dz
    ! dd1(21) ar(23)-bl(31)-
    lmj = lsm_inn(lrj)
    if ((jml /= lmi) .or. (jmr /= lmj)) cycle
    vlop1 = w1*w1_dd1
    vlop0 = Zero
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      vlop1 = -vlop1
    end if

    if (line == 26) then   !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then   !lril,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then   !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    !list = list3(lri,lrj,lra)
    !wl = -vlop1*vint_ci(list)
    iwdr = jud(lrj)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
end do

return

end subroutine dd1_head_dbl_tail_act

subroutine d1d_head_dbl_tail_act(lra)

use gugaci_global, only: jml, jmr, jpel, jper, jud, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w1, w1_d1d
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwdl, iwdr, lmi, lmj, lri, lrj
real(kind=wp) :: vlop0, vlop1, wl

! d1d(22-1)   ar(13)-bl(32)-
! d1d(22-2)   drl(12)-
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  iwdl = jud(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    if ((jml /= lmi) .or. (jmr /= lmj)) cycle
    vlop1 = w1*w1_d1d(1)
    vlop0 = Zero
    if (mod(lrj-lri,2) == 0) then
      vlop1 = -vlop1
    end if
    if (line == 26) then   !lri,lrj,lra
      call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 28) then   !lril,lrj,lrs,lra
      call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    if (line == 29) then   !lri,lrj,lrs,lra
      call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
    end if
    !list = list3(lri,lrj,lra)
    !wl = -vlop1*vint_ci(list)
    iwdr = jud(lrj)
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
end do
vlop1 = w1*w1_d1d(2)
vlop0 = Zero
do lri=norb_frz+1,norb_dz
  ! d1d(22-2)   drl(12)-
  lmi = lsm_inn(lri)
  if ((jml /= lmi) .or. (jmr /= lmi)) cycle
  if (line == 26) then    !lri,lra
    call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
  end if
  if (line == 28) then    !lri,lrs,lra
    call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
  end if
  if (line == 29) then    !lri,lrs,lra
    call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
  end if
  !vlop1 = w1*w1_d1d(2)
  !wl = -vlop1*voint(lri,lra)
  iwdl = jud(lri)
  iwdr = iwdl
  call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
end do

return

end subroutine d1d_head_dbl_tail_act

subroutine sv_head_dbl_tail_act(lra)

use gugaci_global, only: jb_sys, jml, jpel, jper, just, jwl, jwr, line, lrs, lsm_inn, norb_dz, norb_frz, w0, w0_sv, w1, w1_sv
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwdl, iwdr, lmi, lmij, lmj, lri, lrj, ni
real(kind=wp) :: vlop0, vlop1, w0sv1, w0sv2, w1sv1, w1sv2, wl

! sv(10-1) ar(13)-br(23)-
! sv(10-2) ar(23)-br(13)-
! sv(10-3) drr(03)-
iwdr = 0
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    w0sv1 = w0_sv(1)
    w1sv1 = w1_sv(1)
    w0sv2 = w0_sv(2)
    w1sv2 = w1_sv(2)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0sv1 = -w0sv1
      w1sv1 = -w1sv1
      w0sv2 = -w0sv2
      w1sv2 = -w1sv2
    end if
    iwdl = just(lri,lrj)
    if (lri == lrj) then
      vlop0 = w0*w0_sv(3)            !d10-3
      vlop1 = Zero
      !wl = vlop0*voint(lra,lri)/2
      if (line == 25) then    !lri,lra
        ! wyb call comp_loop(8,lri,lrg,lrs,lra,vlop0,vlop1,wl)
        call comp_loop(8,lri,0,0,lra,vlop0,vlop1,wl)
      end if
      if (line == 27) then    !lri,lrs,lra
        ! wyb call comp_loop(10,lri,lrs,lra,lra,vlop0,vlop1,wl)
        call comp_loop(10,lri,0,lrs,lra,vlop0,vlop1,wl)
      end if
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    else
      vlop0 = w0*w0sv2             !d10-2
      vlop1 = w1*w1sv2
      !list = list3(lri,lrj,lra)
      !wl = (vlop0+vlop1)*vint_ci(list)        !2.1          !!!!!
      if (line == 25) then    !lri,lrj,lra
        call comp_loop(3,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      if (line == 27) then    !lri,lrj,lrs,lra
        call comp_loop(4,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      end if
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      if (jb_sys > 0) then
        iwdl = just(lrj,lri)
        vlop0 = w0*w0sv1
        vlop1 = w1*w1sv1
        !list = list3(lri,lrj,lra)
        !wl = (vlop0+vlop1)*vint_ci(list)        !2.1          !!!!!
        if (line == 25) then    !lri,lrj,lra
          call comp_loop(3,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        end if
        if (line == 27) then    !lri,lrj,lrs,lra
          call comp_loop(4,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        end if
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      end if
    end if
  end do
end do

return

end subroutine sv_head_dbl_tail_act

subroutine sd_head_dbl_tail_act(lra,lpcoe)

use gugaci_global, only: jb_sys, jml, jmr, jpel, jper, jud, just, jwl, jwr, lsm_inn, norb_dz, norb_frz, norb_inn, vint_ci, voint, &
                         w0, w0_sd, w1, w1_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra, lpcoe(norb_dz+1:norb_inn)
integer(kind=iwp) :: iwdl, iwdl1, iwdr, jmlr, kcoe, list, lmd, lmi, lmij, lmj, lr, lrd, lri, lrj, lrk, ni, nocc
real(kind=wp) :: tcoe, vlop0, vlop1, w0sd1, w0sd11, w0sd12, w0sd14, w0sd15, w0sd16, w0sd2, w0sd3, w0sd4, w0sd5, w0sd6, w0sd7, &
                 w0sd8, w0sd9, w1sd10, w1sd11, w1sd2, w1sd5, w1sd6, w1sd7, w1sd8, wl
integer(kind=iwp), external :: list3, list4

jmlr = Mul(jml,jmr)
! sd(6-1) a&r(02)-
! sd(6-2) c(22)a&r(13)-
! sd(6-4) a&r(23)c'(12)-
! sd(6-5) a&r(23)b&r(13)b^r(32)
! sd(6-8) a&r(23)b&l(32)b^l(13)
! sd(6-9) d&r&r(03)b^r(32)
! sd(6-11) d&r&l(22)b^l(13)
! sd(6-12) d&r&l(33)b^l(02)
! sd(6-13) (22)d&r&l(33)b^l(13)
! sd(6-14) d&r&l(33)c"(22)b^l(13)
! sd(6-16) d&r&l(33)b^l(23)c'(12)

! sd(6-3) a&r(13)c'(22)-
! sd(6-6) a&r(13)b&r(23)b^r(32)
! sd(6-7) a&r(13)b&l(32)b^l(23)
! sd(6-10) d&r&l(12)b^l(23)
! sd(6-15) d&r&l(33)b^l(13)c'(22)

if (jml == 1) then

  ! sd(6-1) a&r(02)-
  do lri=norb_frz+1,norb_dz
    lmi = lsm_inn(lri)
    iwdl = just(lri,lri)
    w0sd1 = w0_sd(1)
    w0sd12 = w0_sd(12)
    ni = mod(norb_dz-lri,2)
    if (ni == 1) then
      w0sd1 = -w0sd1
      w0sd12 = -w0sd12
    end if
    if (lmi == jmlr) then
      iwdr = jud(lri)
      vlop0 = w0*w0sd1
      wl = vlop0*voint(lri,lra)             !310,act_coe,610,710
      do lr=lri+1,norb_dz
        list = list3(lri,lra,lr)
        wl = wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2,
      end do
      do lrk=norb_dz+1,lra
        list = list3(lri,lra,lrk)
        kcoe = lpcoe(lrk)
        call neoc(kcoe,nocc,tcoe)
        wl = wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
      end do
      !wl = wl*vlop0
      ! sd(6-12) d&rl(33)b^l(02)
      vlop0 = w0*w0sd12
      do lrk=1,lri-1
        list = list3(lri,lra,lrk)
        wl = wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if

    ! sd(6-9) d&r&r(03)b^r(32)
    do lrd=lri+1,norb_dz
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle
      w0sd9 = w0_sd(9)
      ni = mod(norb_dz-lrd,2)
      if (ni == 1) w0sd9 = -w0sd9
      iwdr = jud(lrd)
      vlop0 = w0*w0sd9
      list = list3(lrd,lra,lri)
      wl = vint_ci(list)*vlop0
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
  end do

end if

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    w0sd2 = w0_sd(2)
    w1sd2 = w1_sd(2)
    w0sd11 = w0_sd(11)
    w1sd11 = w1_sd(11)
    w0sd14 = w0_sd(14)
    ni = mod(norb_dz-lrj,2)
    if (ni == 1) then
      w0sd2 = -w0sd2
      w1sd2 = -w1sd2
      w0sd11 = -w0sd11
      w1sd11 = -w1sd11
      w0sd14 = -w0sd14
    end if
    iwdl = just(lri,lrj)
    iwdl1 = just(lrj,lri)
    !*******************************************************************
    ! sd(6-2) c(22)-a&r(13)-
    if (lmi == jmr) then
      iwdr = jud(lri)
      vlop0 = w0*w0sd2
      list = list3(lrj,lra,lrj)
      wl = vlop0*(voint(lrj,lra)+vint_ci(list))          !310,act_co
      do lr=lrj+1,norb_dz
        list = list3(lrj,lra,lr)
        wl = wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=
      end do
      do lrk=norb_dz+1,lra
        list = list3(lrj,lra,lrk)
        kcoe = lpcoe(lrk)
        call neoc(kcoe,nocc,tcoe)
        wl = wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
      end do
      !wl = wl*vlop0
      ! sd(6-11) d&r&l(22)b^l(13)
      vlop0 = w0*w0sd11
      vlop1 = w1*w1sd11
      list = list3(lrj,lra,lri)
      wl = wl+(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
      ! sd(6-13) (22)d&r&l(33)b^l(13)
      ! sd(6-14) d&r&l(33)c"(22)b^l(13)
      vlop0 = w0*w0sd14
      do lrk=1,lrj-1
        if (lrk == lri) cycle
        list = list3(lrj,lra,lrk)
        wl = wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
    if (jb_sys > 0) then
      if (lmj == jmr) then
        iwdr = jud(lrj)
        w0sd3 = w0_sd(3)
        w0sd15 = w0_sd(15)
        w1sd10 = w1_sd(10)
        ni = mod(norb_dz-lri,2)
        if (ni == 0) then
          w0sd3 = -w0sd3
          w0sd15 = -w0sd15
          w1sd10 = -w1sd10
        end if
        ! sd(6-3) a&r(13)-c'(22)-
        vlop0 = w0*w0sd3
        list = list3(lri,lra,lri)
        wl = voint(lri,lra)+vint_ci(list)            !310,act_coe,610
        list = list3(lri,lra,lrj)
        wl = wl+vint_ci(list+1)-vint_ci(list)  !310 c(22)neoc=1,coe=
        do lr=lri+1,norb_dz
          if (lr == lrj) cycle
          list = list3(lri,lra,lr)
          wl = wl+2*vint_ci(list+1)-vint_ci(list)     !310:neoc=2,co
        end do
        do lrk=norb_dz+1,lra
          list = list3(lri,lra,lrk)
          kcoe = lpcoe(lrk)
          call neoc(kcoe,nocc,tcoe)
          wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
        end do
        wl = wl*vlop0
        ! sd(6-15) d&r&l(33)b^l(13)c'(22)
        vlop0 = w0*w0sd15
        do lrk=1,lri-1
          list = list3(lri,lra,lrk)
          wl = wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
        end do
        call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
      end if
      if ((lmij == jml) .and. (lmi == jmr)) then
        iwdr = jud(lri)
        iwdl1 = just(lrj,lri)
        w1sd10 = w1_sd(10)
        if (mod(norb_dz-lrj,2) == 1) then
          w1sd10 = -w1sd10
        end if
        ! sd(6-10) d&r&l(12)b^l(23)
        vlop1 = w1*w1sd10
        list = list3(lrj,lra,lri)
        wl = -vlop1*vint_ci(list)      !4.3
        call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
      end if
    end if
    ! sd(6-4) a&r(23)-c'(12)-
    if (lmj == jmr) then
      iwdr = jud(lrj)
      w0sd4 = w0_sd(4)
      w0sd16 = w0_sd(16)
      ni = mod(norb_dz-lri,2)
      if (ni == 0) w0sd4 = -w0sd4
      if (ni == 0) w0sd16 = -w0sd16
      vlop0 = w0*w0sd4
      list = list3(lri,lra,lri)
      wl = voint(lri,lra)+vint_ci(list)             !310,act_coe,610
      list = list3(lri,lra,lrj)
      wl = wl+vint_ci(list+1)-(jb_sys+2)*vint_ci(list)
      do lr=lri+1,norb_dz
        if (lr == lrj) cycle
        list = list3(lri,lra,lr)
        wl = wl+2*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,co
      end do
      do lrk=norb_dz+1,lra
        list = list3(lri,lra,lrk)
        kcoe = lpcoe(lrk)
        call neoc(kcoe,nocc,tcoe)
        wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
      end do
      wl = wl*vlop0
      ! sd(6-16) d&r&l(33)b^l(23)c'(12)
      vlop0 = w0*w0sd16
      do lrk=1,lri-1
        list = list3(lri,lra,lrk)
        wl = wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if

    ! sd(6-5) a&r(23)b&r(13)b^r(32)
    do lrd=lrj+1,norb_dz
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle
      iwdr = jud(lrd)
      w0sd5 = w0_sd(5)
      w1sd5 = w1_sd(5)
      ni = mod(lrj-lri+norb_dz-lrd,2)
      if (ni == 0) w0sd5 = -w0sd5
      if (ni == 0) w1sd5 = -w1sd5
      vlop0 = w0*w0sd5
      vlop1 = w1*w1sd5
      list = list4(lri,lrj,lrd,lra)
      wl = (vlop0-vlop1)*vint_ci(list+2)+(vlop0+vlop1)*vint_ci(list)     !1.3
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
    if (jb_sys > 0) then
      ! sd(6-6) a&r(13)b&r(23)b^r(32)
      do lrd=lrj+1,norb_dz
        lmd = lsm_inn(lrd)
        if (lmd /= jmr) cycle
        iwdr = jud(lrd)
        w0sd6 = w0_sd(6)
        w1sd6 = w1_sd(6)
        ni = mod(lrj-lri+norb_dz-lrd,2)
        if (ni == 0) w0sd6 = -w0sd6
        if (ni == 0) w1sd6 = -w1sd6
        vlop0 = w0*w0sd6
        vlop1 = w1*w1sd6
        list = list4(lri,lrj,lrd,lra)
        wl = (vlop0-vlop1)*vint_ci(list+2)+(vlop0+vlop1)*vint_ci(list)   !1.3
        call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
      end do
      ! sd(6-7) a&r(13)b&l(32)b^l(23)
      do lrd=lri+1,lrj-1
        lmd = lsm_inn(lrd)
        if (lmd /= jmr) cycle
        iwdr = jud(lrd)
        w0sd7 = w0_sd(7)
        w1sd7 = w1_sd(7)
        ni = mod(lrd-lri+norb_dz-lrj,2)
        if (ni == 0) w0sd7 = -w0sd7
        if (ni == 0) w1sd7 = -w1sd7
        vlop0 = w0*w0sd7
        vlop1 = w1*w1sd7
        list = list4(lri,lrd,lrj,lra)
        wl = (vlop0-vlop1)*vint_ci(list+2)-2*vlop0*vint_ci(list+1)       !1.2
        call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
      end do
    end if
    ! sd(6-8) a&r(23)b&l(32)b^l(13)
    do lrd=lri+1,lrj-1
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle
      iwdr = jud(lrd)
      w0sd8 = w0_sd(8)
      w1sd8 = w1_sd(8)
      ni = mod(lrd-lri+norb_dz-lrj,2)
      if (ni == 0) w0sd8 = -w0sd8
      if (ni == 0) w1sd8 = -w1sd8
      vlop0 = w0*w0sd8
      vlop1 = w1*w1sd8
      list = list4(lri,lrd,lrj,lra)
      wl = (vlop0-vlop1)*vint_ci(list+2)-2*vlop0*vint_ci(list+1)         !1.2
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
  end do
end do

return

end subroutine sd_head_dbl_tail_act

subroutine sdd_head_dbl_tail_act(lra,lpcoe)

use gugaci_global, only: jb_sys, jml, jmr, jpel, jper, jud, just, jwl, jwr, lsm_inn, norb_dz, norb_frz, norb_inn, vint_ci, voint, &
                         w0, w0_sd1, w1, w1_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra, lpcoe(norb_dz+1:norb_inn)
integer(kind=iwp) :: iwdl, iwdl1, iwdr, jmlr, kcoe, list, lmd, lmi, lmij, lmj, lr, lrd, lri, lrj, lrk, ni, nocc
real(kind=wp) :: tcoe, vlop0, vlop1, w0sd1, w0sd10, w0sd11, w0sd12, w0sd13, w0sd2, w0sd3, w0sd4, w0sd5, w0sd6, w0sd7, w0sd8, &
                 w0sd9, w1sd10, w1sd2, w1sd3, w1sd4, w1sd5, w1sd6, w1sd7, w1sd8, wl
integer(kind=iwp), external :: list3, list4

jmlr = Mul(jml,jmr)
! sd1(8-1) a&r(01)-
! sd1(8-2) c(11)a&r(23)-
! sd1(8-3) a&r(13)c'(21)-
! sd1(8-4) a&r(23)c'(11)-
! sd1(8-5) a&r(13)b&r(23)b^r(31)
! sd1(8-6) a&r(23)b&r(13)b^r(31)
! sd1(8-7) a&r(13)b&l(31)b^l(23)
! sd1(8-8) a&r(23)b&l(31)b^l(13)
! sd1(8-9) d&r&r(03)b^r(31)
! sd1(8-10) d&r&l(11)b^l(23)
! sd1(8-11) d&r&l(33)b^l(01)
! sd1(8-12) d&r&l(33)b^l(23)
! sd1(8-13) d&r&l(33)c"(13)b^l(23)
! sd1(8-14) d&r&l(33)b^l(11)c'(23)
! sd1(8-15) d&r&l(33)b^l(23)c'(11)
if (jml == 1) then
  do lri=norb_frz+1,norb_dz
    ! sd1(8-1) a&r(01)-
    lmi = lsm_inn(lri)
    iwdl = just(lri,lri)
    w0sd1 = w0_sd1(1)
    w0sd11 = w0_sd1(9)
    ni = mod(norb_dz-lri,2)
    if (ni == 1) then
      w0sd1 = -w0sd1
      w0sd11 = -w0sd11
    end if
    if (lmi == jmlr) then
      iwdr = jud(lri)
      vlop0 = w0*w0sd1
      wl = vlop0*voint(lri,lra)             !310,act_coe,610,710
      do lr=lri+1,norb_dz
        list = list3(lri,lra,lr)
        wl = wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2,
      end do
      do lrk=norb_dz+1,lra
        list = list3(lri,lra,lrk)
        kcoe = lpcoe(lrk)
        call neoc(kcoe,nocc,tcoe)
        wl = wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
      end do
      !wl = wl*vlop0
      ! sd1(8-11) d&rl(33)b^l(01)
      vlop0 = w0*w0sd11
      do lrk=1,lri-1
        list = list3(lri,lra,lrk)
        wl = wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
    ! sd1(8-9) d&r&r(03)b^r(31)
    do lrd=lri+1,norb_dz
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle
      w0sd9 = w0_sd1(9)
      ni = mod(norb_dz-lrd,2)
      if (ni == 1) w0sd9 = -w0sd9
      iwdr = jud(lrd)
      vlop0 = w0*w0sd9
      list = list3(lrd,lra,lri)
      wl = vint_ci(list)*vlop0
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
  end do
end if

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    if (lri == lrj) cycle
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    w0sd2 = w0_sd1(2)
    w1sd2 = w1_sd1(2)
    w0sd3 = w0_sd1(3)
    w1sd3 = w1_sd1(3)
    w0sd4 = w0_sd1(4)
    w1sd4 = w1_sd1(4)
    w0sd10 = w0_sd1(10)
    w1sd10 = w1_sd1(10)
    w0sd11 = w0_sd1(11)
    w0sd12 = w0_sd1(12)
    w0sd13 = w0_sd1(13)
    ni = mod(norb_dz-lrj,2)
    if (ni == 1) then
      w0sd2 = -w0sd2
      w1sd2 = -w1sd2
      w0sd10 = -w0sd10
      w1sd10 = -w1sd10
      w0sd11 = -w0sd11
    end if
    if (mod(norb_dz-lri,2) == 1) then
      w0sd3 = -w0sd3
      w1sd3 = -w1sd3
      w0sd4 = -w0sd4
      w1sd4 = -w1sd4
      w0sd12 = -w0sd12
      w0sd13 = -w0sd13
    end if
    iwdl = just(lrj,lri)
    iwdl1 = just(lri,lrj)
    !*******************************************************************
    ! sd1(8-2) c(11)-a&r(23)-
    if (lmi == jmr) then
      iwdl = just(lrj,lri)
      iwdr = jud(lri)
      vlop0 = w0*w0sd2
      list = list3(lrj,lra,lrj)
      wl = vlop0*(voint(lrj,lra)+vint_ci(list))          !310,act_co
      do lr=lrj+1,norb_dz
        list = list3(lrj,lra,lr)
        wl = wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=
      end do
      do lrk=norb_dz+1,lra
        list = list3(lrj,lra,lrk)
        kcoe = lpcoe(lrk)
        call neoc(kcoe,nocc,tcoe)
        wl = wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
      end do
      !wl = wl*vlop0
      ! sd1(8-10) d&r&l(11)b^l(23)
      vlop0 = w0*w0sd10
      vlop1 = w1*w1sd10
      list = list3(lrj,lra,lri)
      wl = wl+(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
      ! sd1(8-11) (11)d&r&l(33)b^l(23)
      ! sd1(8-11) d&r&l(33)c"(11)b^l(23)
      vlop0 = w0*w0sd11
      do lrk=1,lrj-1
        if (lrk == lri) cycle
        list = list3(lrj,lra,lrk)
        wl = wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if

    ! sd1(8-3) a&r(13)-c'(21)-
    if (lmj == jmr) then
      vlop0 = -w0*w0sd3
      list = list3(lri,lra,lri)
      wl = voint(lri,lra)+vint_ci(list)             !310,act_coe,610
      list = list3(lri,lra,lrj)
      wl = wl+vint_ci(list+1)+jb_sys*vint_ci(list)         !310
      do lr=lri+1,norb_dz
        if (lr == lrj) cycle
        list = list3(lri,lra,lr)
        wl = wl+2*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,co
      end do
      do lrk=norb_dz+1,lra
        list = list3(lri,lra,lrk)
        kcoe = lpcoe(lrk)
        call neoc(kcoe,nocc,tcoe)
        wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
      end do
      wl = wl*vlop0
      ! sd1(8-12) drl(33)-bl(13)-c'(21)-
      iwdl = just(lrj,lri)
      iwdr = jud(lrj)
      vlop0 = -w0*w0sd12
      do lrk=1,lri-1
        list = list3(lri,lra,lrk)
        wl = wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
    ! sd1(8-4) a&r(23)-c'(11)-
    if (lmj == jmr) then
      vlop0 = -w0*w0sd4
      list = list3(lri,lra,lri)
      wl = voint(lri,lra)+vint_ci(list)           !310,act_coe,610
      list = list3(lri,lra,lrj)
      wl = wl+vint_ci(list+1)-vint_ci(list)       !310 c(11)neoc=
      do lr=lri+1,norb_dz
        if (lr == lrj) cycle
        list = list3(lri,lra,lr)
        wl = wl+2*vint_ci(list+1)-vint_ci(list)   !310:neoc=2,co
      end do
      do lrk=norb_dz+1,lra
        list = list3(lri,lra,lrk)
        kcoe = lpcoe(lrk)
        call neoc(kcoe,nocc,tcoe)
        wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
      end do
      wl = wl*vlop0
      ! sd1(8-13) drl(33)-bl(23)-c'(11)-
      iwdl = just(lri,lrj)
      iwdr = jud(lrj)
      vlop0 = -w0*w0sd13
      do lrk=1,lri-1
        list = list3(lri,lra,lrk)
        wl = wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
      end do
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end if
    ! sd1(8-5) a&r(13)b&r(23)b^r(31)
    do lrd=lrj+1,norb_dz
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle
      iwdl = just(lrj,lri)
      iwdr = jud(lrd)
      w0sd5 = w0_sd1(5)
      w1sd5 = w1_sd1(5)
      ni = mod(lrj-lri+norb_dz-lrd,2)
      if (ni == 0) w0sd5 = -w0sd5
      if (ni == 0) w1sd5 = -w1sd5
      vlop0 = w0*w0sd5
      vlop1 = w1*w1sd5
      list = list4(lri,lrj,lrd,lra)
      wl = (vlop0-vlop1)*vint_ci(list+2)+(vlop0+vlop1)*vint_ci(list)     !1.3
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      ! sd1(8-6) a&r(23)b&r(13)b^r(31)
      iwdl = just(lri,lrj)
      w0sd6 = w0_sd1(6)
      w1sd6 = w1_sd1(6)
      ni = mod(lrj-lri+norb_dz-lrd,2)
      if (ni == 0) w0sd6 = -w0sd6
      if (ni == 0) w1sd6 = -w1sd6
      vlop0 = w0*w0sd6
      vlop1 = w1*w1sd6
      list = list4(lri,lrj,lrd,lra)
      wl = (vlop0-vlop1)*vint_ci(list+2)+(vlop0+vlop1)*vint_ci(list)     !1.3
      call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
    end do
    ! sd1(8-7) a&r(13)b&l(31)b^l(23)
    do lrd=lri+1,lrj-1
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle
      iwdr = jud(lrd)
      iwdl = just(lrj,lri)
      w0sd7 = w0_sd1(7)
      w1sd7 = w1_sd1(7)
      ni = mod(lrd-lri+norb_dz-lrj,2)
      if (ni == 0) w0sd7 = -w0sd7
      if (ni == 0) w1sd7 = -w1sd7
      vlop0 = w0*w0sd7
      vlop1 = w1*w1sd7
      list = list4(lri,lrd,lrj,lra)
      wl = (vlop0-vlop1)*vint_ci(list+2)-2*vlop0*vint_ci(list+1)         !1.2
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      ! sd1(8-8) a&r(23)b&l(31)b^l(13)
      iwdl = just(lri,lrj)
      w0sd8 = w0_sd1(8)
      w1sd8 = w1_sd1(8)
      ni = mod(lrd-lri+norb_dz-lrj,2)
      if (ni == 0) w0sd8 = -w0sd8
      if (ni == 0) w1sd8 = -w1sd8
      vlop0 = w0*w0sd8
      vlop1 = w1*w1sd8
      list = list4(lri,lrd,lrj,lra)
      wl = (vlop0-vlop1)*vint_ci(list+2)-2*vlop0*vint_ci(list+1)         !1.2
      call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
    end do
  end do
end do

return

end subroutine sdd_head_dbl_tail_act

!subroutine td_head_dbl_tail_act(lra,lpcoe)
!
!use gugaci_global, only: jml, jmr, jpel, jper, jud, just, jwl, jwr, lsm_inn, norb_dz, norb_frz, norb_inn, vint_ci, voint, w0, &
!                         w0_td, w1, w1_td
!use Symmetry_Info, only: Mul
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: lra, lpcoe(norb_dz+1:norb_inn)
!integer(kind=iwp) :: iwdl, iwdr, jmlr, kcoe, list, lmd, lmi, lmij, lmj, lr, lrd, lri, lrj, lrk, ni, nocc
!real(kind=wp) :: tcoe, vlop0, vlop1, w0td1, w0td2, w0td3, w0td4, w0td5, w1td2, w1td3, wl
!integer(kind=iwp), external :: list3, list4
!
!jmlr = Mul(jml,jmr)
!! td(13-1) (22)a&(23)
!! td(13-1) a&(23)c'(22)
!! td(13-5) (22)d&&l(33)b^l(23)
!do lri=norb_frz+1,norb_dz
!  lmi = lsm_inn(lri)
!  if (lmi /= jmlr) cycle
!  w0td1 = w0_td(1)
!  w0td4 = w0_td(4)
!  w0td5 = w0_td(5)
!  ni = mod(norb_dz-lri,2)
!  if (ni == 1) w0td1 = -w0td1
!  if (ni == 1) w0td4 = -w0td4
!  if (ni == 1) w0td5 = -w0td5
!
!  ! td(13-1) a&(23)c'(22)
!  do lrd=lri+1,norb_dz
!    lmd = lsm_inn(lrd)
!    if (lmd /= jmr) cycle
!    iwdl = just(lri,lrd)
!    iwdr = jud(lrd)
!    vlop0 = -w0*w0td1
!    list = list3(lri,lra,lri)
!    wl = voint(lri,lra)+vint_ci(list)        !310,act_coe,610,7
!    list = list3(lri,lra,lrd)
!    wl = wl+vint_ci(list+1)                  !310 c(22) coe
!    do lr=lri+1,norb_dz
!      if (lr == lrd) cycle
!      list = list3(lri,lra,lr)
!      wl = wl+2*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,coe=
!    end do
!    do lrk=norb_dz+1,lra
!      list = list3(lri,lra,lrk)
!      kcoe = lpcoe(lrk)
!      call neoc(kcoe,nocc,tcoe)
!      wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
!    end do
!    wl = wl*vlop0
!    ! td(13-5) d&rl(33)b^l(23)c'(22)          !cc (22)d&rl(33)b^l(23)???
!    vlop0 = -w0*w0td5
!    do lrk=1,lri-1
!      list = list3(lri,lra,lrk)
!      wl = wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
!    end do
!    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!  end do
!  !---------------------------------------------------------------------
!  do lrd=norb_frz+1,lri-1
!    lmd = lsm_inn(lrd)
!    if (lmd /= jmr) cycle
!    iwdl = just(lrd,lri)
!    iwdr = jud(lrd)
!    ! td(13-1) (22)a&(23)
!    vlop0 = w0*w0td1
!    list = list3(lri,lra,lri)
!    wl = vlop0*(voint(lri,lra)+vint_ci(list))             !310,act_c
!    do lr=lri+1,norb_dz
!      list = list3(lri,lra,lr)
!      wl = wl+vlop0*(2*vint_ci(list+1)-vint_ci(list))     !310:neoc=2,
!    end do
!    do lrk=norb_dz+1,lra
!      list = list3(lri,lra,lrk)
!      kcoe = lpcoe(lrk)
!      call neoc(kcoe,nocc,tcoe)
!      wl = wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
!    end do
!    !wl = wl*vlop0
!    ! td(13-4) d&r&l(22)b^l(23)
!    vlop0 = w0*w0td4
!    vlop1 = w1*w0td4
!    list = list3(lri,lra,lrd)
!    wl = wl+(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
!    ! td(13-5) d&rl(33)c"(22)b^l(23)
!    vlop0 = w0*w0td5
!    do lrk=1,lri-1
!      if (lrk == lrd) cycle
!      list = list3(lri,lra,lrk)
!      wl = wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))      !4.3
!    end do
!    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!  end do
!end do
!do lri=norb_frz+1,norb_dz-1
!  lmi = lsm_inn(lri)
!  do lrj=lri+1,norb_dz
!    lmj = lsm_inn(lrj)
!    lmij = Mul(lmi,lmj)
!    if (lmij /= jml) cycle
!    iwdl = just(lri,lrj)
!
!    ! td(13-2) a&(23)b&r(23)b^r(32)
!    do lrd=lrj+1,norb_dz
!      lmd = lsm_inn(lrd)
!      if (lmd /= jmr) cycle
!      w0td2 = w0_td(2)
!      w1td2 = w1_td(2)
!      ni = mod(lrj-lri+norb_dz-lrd,2)
!      if (ni == 0) w0td2 = -w0td2
!      if (ni == 0) w1td2 = -w1td2
!
!      iwdr = jud(lrd)
!      vlop0 = w0*w0td2
!      vlop1 = w1*w1td2
!      list = list4(lri,lrj,lrd,lra)
!      wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list)) !1.3
!      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!    end do
!    ! td(13-3) a&(23)b&l(32)b^l(23)
!    do lrd=lri+1,lrj-1
!      lmd = lsm_inn(lrd)
!      if (lmd /= jmr) cycle
!      iwdr = jud(lrd)
!      w0td3 = w0_td(3)
!      w1td3 = w1_td(3)
!      ni = mod(lrd-lri+norb_dz-lrj,2)
!      if (ni == 0) w0td3 = -w0td3
!      if (ni == 0) w1td3 = -w1td3
!      vlop0 = w0*w0td3                !d6-8
!      vlop1 = w1*w1td3
!      list = list4(lri,lrd,lrj,lra)
!      wl = vlop0*(vint_ci(list+2)-2*vint_ci(list+1))-vlop1*vint_ci(list+2)    !1.2
!      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!    end do
!  end do
!end do
!
!return
!
!end subroutine td_head_dbl_tail_act

subroutine ttdd_head_dbl_tail_act(lra,lpcoe)

use gugaci_global, only: jml, jmr, jpel, jper, jud, just, jwl, jwr, lsm_inn, norb_dz, norb_frz, norb_inn, vint_ci, voint, w0, &
                         w0_t1d1, w1, w1_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra, lpcoe(norb_dz+1:norb_inn)
integer(kind=iwp) :: iwdl, iwdr, jmlr, kcoe, list, lmd, lmi, lmij, lmj, lr, lrd, lri, lrj, lrk, ni, nocc
real(kind=wp) :: tcoe, vlop0, vlop1, w0td1, w0td2, w0td3, w0td4, w0td5, w1td2, w1td3, wl
integer(kind=iwp), external :: list3, list4

jmlr = Mul(jml,jmr)
! t1d1(15-1) (11)a&(13)
! t1d1(15-1) a&(13)c'(11)
! t1d1(15-5) (11)d&&l(33)b^l(13)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_t1d1(1)
  w0td4 = w0_t1d1(4)
  w0td5 = w0_t1d1(5)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0td1 = -w0td1
    w0td4 = -w0td4
    w0td5 = -w0td5
  end if
  ! t1d1(15-2) a&(13)c'(11)
  do lrd=lri+1,norb_dz
    lmd = lsm_inn(lrd)
    if (lmd /= jmr) cycle
    iwdl = just(lri,lrd)
    iwdr = jud(lrd)
    vlop0 = -w0*w0td1
    list = list3(lri,lra,lri)
    wl = voint(lri,lra)+vint_ci(list)           !310,act_coe,610,7
    list = list3(lri,lra,lrd)
    wl = wl+vint_ci(list+1)
    do lr=lri+1,norb_dz
      if (lr == lrd) cycle
      list = list3(lri,lra,lr)
      wl = wl+2*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,coe=
    end do
    do lrk=norb_dz+1,lra
      list = list3(lri,lra,lrk)
      kcoe = lpcoe(lrk)
      call neoc(kcoe,nocc,tcoe)
      wl = wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
    end do
    wl = wl*vlop0
    ! t1d1(15-5) d&rl(33)b^l(13)c'(11)
    vlop0 = -w0*w0td5
    do lrk=1,lri-1
      list = list3(lri,lra,lrk)
      wl = wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
    end do
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
  !---------------------------------------------------------------------
  do lrd=norb_frz+1,lri-1
    lmd = lsm_inn(lrd)
    if (lmd /= jmr) cycle
    iwdl = just(lrd,lri)
    iwdr = jud(lrd)
    ! t1d1(15-1) (11)a&(13)
    vlop0 = w0*w0td1
    list = list3(lri,lra,lri)
    wl = vlop0*(voint(lri,lra)+vint_ci(list))             !310,act_c
    do lr=lri+1,norb_dz
      list = list3(lri,lra,lr)
      wl = wl+vlop0*(2*vint_ci(list+1)-vint_ci(list))     !310:neoc=2,
    end do
    do lrk=norb_dz+1,lra
      list = list3(lri,lra,lrk)
      kcoe = lpcoe(lrk)
      call neoc(kcoe,nocc,tcoe)
      wl = wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
    end do
    !wl = wl*vlop0
    ! t1d1(15-4) d&r&l(11)b^l(13)
    vlop0 = w0*w0td4
    vlop1 = w1*w0td4
    list = list3(lri,lra,lrd)
    wl = wl+(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
    ! t1d1(15-5) d&rl(33)c"(11)b^l(13)
    vlop0 = w0*w0td5
    do lrk=1,lri-1
      if (lrk == lrd) cycle
      list = list3(lri,lra,lrk)
      wl = wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))      !4.3
    end do
    call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
  end do
end do
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    iwdl = just(lri,lrj)

    ! t1d1(15-2) a&(13)b&r(13)b^r(31)
    do lrd=lrj+1,norb_dz
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle
      w0td2 = w0_t1d1(2)
      w1td2 = w1_t1d1(2)
      ni = mod(lrj-lri+norb_dz-lrd,2)
      if (ni == 0) w0td2 = -w0td2
      if (ni == 0) w1td2 = -w1td2

      iwdr = jud(lrd)
      vlop0 = w0*w0td2
      vlop1 = w1*w1td2
      list = list4(lri,lrj,lrd,lra)
      wl = vlop0*(vint_ci(list+2)+vint_ci(list))-vlop1*(vint_ci(list+2)-vint_ci(list))   !1.3
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
    ! t1d1(15-3) a&(13)b&l(31)b^l(13)
    do lrd=lri+1,lrj-1
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle
      iwdr = jud(lrd)
      w0td3 = w0_t1d1(3)
      w1td3 = w1_t1d1(3)
      ni = mod(lrd-lri+norb_dz-lrj,2)
      if (ni == 0) w0td3 = -w0td3
      if (ni == 0) w1td3 = -w1td3
      vlop0 = w0*w0td3                !d6-8
      vlop1 = w1*w1td3
      list = list4(lri,lrd,lrj,lra)
      wl = vlop0*(vint_ci(list+2)-2*vint_ci(list+1))-vlop1*vint_ci(list+2)   !1.2
      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
    end do
  end do
end do

return

end subroutine ttdd_head_dbl_tail_act

subroutine sv_arbr_act_c_ext_stv_sgt0(lin)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sv, w1_sv
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0sv1, w1sv1
integer(kind=iwp), external :: iwalk_ad

! sv(10-1) ar(13)br(23)  act -c"-  tv_ext -br-ar
jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    !-------------------------------------------------------------------
    w0sv1 = w0_sv(1)
    w1sv1 = w1_sv(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0sv1 = -w0sv1
      w1sv1 = -w1sv1
    end if
    iwdl = just(lrj,lri)
    iwdr = 0
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sv1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1sv1
    end do
    if (lin == 10) then
      call ar_br_sv_ext_br_ar(lri,lrj)
    end if
    if (lin == 17) then
      call ar_br_tv_ext_br_ar(lri,lrj)
    end if
  end do
end do

return

end subroutine sv_arbr_act_c_ext_stv_sgt0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine change7_cvb()

use casvb_global, only: icase7, icrit, ifinish, imethod
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: changed
logical(kind=iwp), external :: chpcmp_cvb ! ... Change of dimensioning variables ...

! Inconsequential work arrays
changed = .false.
if (((imethod /= 4) .and. (ifinish == 0)) .or. ((ifinish == 1) .or. (ifinish == 2))) then
  icase7 = 1
else if ((imethod == 4) .and. (icrit == 1) .and. (ifinish == 0)) then
  icase7 = 2
else if ((imethod == 4) .and. (icrit == 2) .and. (ifinish == 0)) then
  icase7 = 3
else
  icase7 = 4
end if
if (chpcmp_cvb(icase7)) changed = .true.
if (changed) call touch_cvb('MEM7')

return

end subroutine change7_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine rc_msg_init
      implicit none
#include "warnings.fh"
      rc_msg                           ='_UNKNOWN_ERROR_CODE_          '

      rc_msg(_RC_ALL_IS_WELL_         )='_ALL_IS_WELL_                 '
      rc_msg(_RC_JOB_KILLED_          )='_JOB_KILLED_                  '
      rc_msg(_RC_CONTINUE_LOOP_       )='_CONTINUE_LOOP_               '
      rc_msg(_RC_INVOKED_OTHER_MODULE_)='_INVOKED_OTHER_MODULE_        '
      rc_msg(_RC_CONTINUE_UNIX_LOOP_  )='_CONTINUE_UNIX_LOOP_          '
      rc_msg(_RC_CHO_DUM_             )='_CHO_DUM_                     '
      rc_msg(_RC_EXIT_                )='_EXIT_                        '
      rc_msg(_RC_EXIT_EXPECTED_       )='_EXIT_EXPECTED_               '
      rc_msg(_RC_DO_TASKS_            )='_DO_TASKS_                    '
      rc_msg(_RC_GENERAL_WARNING_     )='_GENERAL_WARNING_             '
      rc_msg(_RC_NOT_CONVERGED_       )='_NOT_CONVERGED_               '
      rc_msg(_RC_TIMEOUT_             )='_TIMEOUT_                     '
      rc_msg(_RC_INPUT_ERROR_         )='_INPUT_ERROR_                 '
      rc_msg(_RC_INPUT_EMIL_ERROR_    )='_INPUT_EMIL_ERROR_            '
      rc_msg(_RC_LICENSE_             )='_LICENSE_                     '
      rc_msg(_RC_CHO_INP_             )='_CHO_INP_                     '
      rc_msg(_RC_CHECK_ERROR_         )='_CHECK_ERROR_                 '
      rc_msg(_RC_INSTALL_ERROR_       )='_INSTALL_ERROR_               '
      rc_msg(_RC_INTERNAL_ERROR_      )='_INTERNAL_ERROR_              '
      rc_msg(_RC_EXTERNAL_TERMINATION_)='_EXTERNAL_TERMINATION_        '
      rc_msg(_RC_GENERAL_ERROR_       )='_GENERAL_ERROR_               '
      rc_msg(_RC_FLOATING_EXCEPTION_  )='_FLOATING_EXCEPTION_          '
      rc_msg(_RC_EXTERNAL_TERM_       )='_EXTERNAL_TERM_               '
      rc_msg(_RC_MEMORY_ERROR_        )='_MEMORY_ERROR_                '
      rc_msg(_RC_IO_ERROR_WRITE_      )='_IO_ERROR_WRITE_              '
      rc_msg(_RC_IO_ERROR_READ_       )='_IO_ERROR_READ_               '
      rc_msg(_RC_CHO_MEM_             )='_CHO_MEM_                     '
      rc_msg(_RC_CHO_INI_             )='_CHO_INI_                     '
      rc_msg(_RC_CHO_LOG_             )='_CHO_LOG_                     '
      rc_msg(_RC_CHO_RUN_             )='_CHO_RUN_                     '
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PCM_EF_grd(Grad,nGrad)

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use PCM_arrays, only: dCntr, dPnt, PCM_SQ, PCMiSph, PCMTess
use Gateway_global, only: PrPrt
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
integer(kind=iwp) :: i, iTile, jCnt, jCnttp, MaxAto, mCnt, nc, nComp, ndc, nDens, nOrdOp
real(kind=wp) :: EF_Temp(3), Z
logical(kind=iwp) :: Save_tmp, Found
integer(kind=iwp), allocatable :: lOper(:)
real(kind=wp), allocatable :: Chrg(:), Cord(:,:), D1ao(:), EF(:,:,:), FactOp(:)
#include "rctfld.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Basis_Mode('Valence')
call Setup_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
Save_tmp = PrPrt
PrPrt = .true.
nOrdOp = 1
nComp = (nOrdOp+1)*(nOrdOp+2)/2
call mma_allocate(EF,nComp,2,nTs,label='EF')
!                                                                      *
!***********************************************************************
!                                                                      *
call Get_nAtoms_All(MaxAto)

call mma_allocate(Cord,3,MaxAto)
call mma_allocate(Chrg,MaxAto)

ndc = 0
nc = 1
do jCnttp=1,nCnttp
  if (dbsc(jCnttp)%Aux) cycle
  Z = dbsc(jCnttp)%Charge
  mCnt = dbsc(jCnttp)%nCntr
  do jCnt=1,mCnt
    ndc = ndc+1
    do i=0,nIrrep/dc(ndc)%nStab-1
      call OA(dc(ndc)%iCoSet(i,0),dbsc(jCnttp)%Coor(1:3,jCnt),Cord(1:3,nc))
      Chrg(nc) = Z
      nc = nc+1
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the the electric field on the tiles

! 1) The nuclear contribution

do iTile=1,nTs
  call EFNuc(PCMTess(1,iTile),Chrg,Cord,MaxAto,EF_temp,nOrdOp)
  EF(:,1,iTile) = EF_Temp(:)
  EF(:,2,iTile) = Zero
end do

call mma_deallocate(Cord)
call mma_deallocate(Chrg)

! 2) The electronic contribution

! Get the total 1st order AO density matrix

call Qpg_dArray('D1ao',Found,nDens)
if (Found .and. (nDens /= 0)) then
  call mma_allocate(D1ao,nDens,Label='D1ao')
else
  write(u6,*) 'pcm_ef_grd: D1ao not found.'
  call Abend()
end if
call Get_D1ao(D1ao,nDens)

call mma_allocate(FactOp,nTs)
call mma_allocate(lOper,nTs)
FactOp(:) = One
lOper(:) = 255

call Drv1_PCM(FactOp,nTs,D1ao,nDens,PCMTess,lOper,EF,nOrdOp)

call mma_deallocate(lOper)
call mma_deallocate(FactOp)
call mma_deallocate(D1ao)
!                                                                      *
!***********************************************************************
!                                                                      *
! Now form the correct combinations

call Cmbn_EF_DPnt(EF,nTs,dPnt,MaxAto,dCntr,nS,PCMiSph,PCM_SQ,Grad,nGrad)

!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(EF)
PrPrt = Save_tmp
call Free_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine PCM_EF_grd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
!*****************************************************************

subroutine CMSFitTrigonometric(x,y)

use Constants, only: Four, Quart, Pi
use Definitions, only: wp

implicit none
real(kind=wp), intent(inout) :: x(4), y(4)
real(kind=wp) :: a, b, c, c12, c23, d12, d23, k, phi, psi1, psi2, s12, s23, val1, val2
real(kind=wp), parameter :: atan1 = Quart*Pi

s12 = sin(Four*x(1))-sin(Four*x(2))
s23 = sin(Four*x(2))-sin(Four*x(3))
c12 = cos(Four*x(1))-cos(Four*x(2))
c23 = cos(Four*x(2))-cos(Four*x(3))
d12 = y(1)-y(2)
d23 = y(2)-y(3)
k = s12/s23
c = (d12-k*d23)/(c12-k*c23)
b = (d12-c*c12)/s12
a = y(1)-b*sin(Four*x(1))-c*cos(Four*x(1))
phi = atan(b/c)
psi1 = phi*Quart
if (psi1 > atan1) then
  psi2 = psi1-atan1
else
  psi2 = psi1+atan1
end if
val1 = b*sin(Four*psi1)+c*cos(Four*psi1)
val2 = b*sin(Four*psi2)+c*cos(Four*psi2)
if (val1 > val2) then
  x(4) = psi1
  !y(4) = val1
else
  x(4) = psi2
  !y(4) = val2
end if
y(4) = a+sqrt(b**2+c**2)
!write(u6,*) a,b,c,x(4),y(4)

end subroutine CMSFitTrigonometric

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SubWorkDir
      use subdirs, only : f_setsubdir, Sub, OldWorkDir, NewWorkDir
      use filesystem, only : getcwd_, chdir_, mkdir_
      Implicit None
      Integer :: i,Length,iErr
      Integer, Parameter :: nFiles=22
      Character(Len=1024) :: Names(nFiles),
     &                       OldFile(nFiles),NewFile(nFiles)
      Logical :: Found

*     Define name of subdirectory and files that must be copied over
      Sub='NG'
      Names( 1)='RUNFILE'
      Names( 2)='SEWARINP'
      Names( 3)='SCFINP'
      Names( 4)='RASSCINP'
      Names( 5)='CASPTINP'
      Names( 6)='MBPT2INP'
      Names( 7)='RASSIINP'
      Names( 8)='MOTRAINP'
      Names( 9)='CCSDTINP'
      Names(10)='CHCCINP'
      Names(11)='CHT3INP'
      Names(12)='ESPFINP'
      Names(13)='FALSEINP'
      Names(14)='JOBIPH'
      Names(15)='ESPF.SAV'
      Names(16)='TINKER.XYZ'
      Names(17)='TINKER.KEY'
      Names(18)='MCPDFINP'
      Names(19)='CHEMNATFIE'
      Names(20)='CHEMCANFIE'
      Names(21)='CHEMNATMPS0'
      Names(22)='CHEMCANMPS0'

*     Get real filenames to copy
      Do i=1,nFiles
        Call prgmtranslate(Names(i),OldFile(i),Length)
      End Do

*     Create the new directory and switch to it
      Call getcwd_(OldWorkDir)
      NewWorkDir=Trim(OldWorkDir)//'/'//Trim(Sub)
      Call mkdir_(NewWorkDir)
      Call chdir_(NewWorkDir)
      Call f_setsubdir(Sub)

*     Get real target filenames
      Do i=1,nFiles
        Call prgmtranslate(Names(i),NewFile(i),Length)
*       ESPF.SAV is copied to ESPF.DATA
        If (Names(i).eq.'ESPF.SAV') Then
          Call prgmtranslate('ESPF.DATA',NewFile(i),Length)
        End If
      End Do

*     Copy the files from the old directory to the new
      Do i=1,nFiles
        Call f_inquire(OldFile(i),Found)
        If (Found) Call fcopy(OldFile(i),NewFile(i),iErr)
      End Do

*     The INPORB file is special...
      Call f_inquire('../INPORB',Found)
      If (Found) Call fcopy('../INPORB','./INPORB',iErr)

      End Subroutine SubWorkDir

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************
!        OCSTR        :        Offsets for occupation of strings
!        STREO        :        reordering array
!        STSM         :        Symmetry of each string
!        STCL         :        Class of each string
!        NSTSO        :        Number of strings per symmetry and occupation
!        ISTSO        :        Offset of strings per symmetry and occupation
!        EL1          :        Number of electrons in RAS1 per sub type
!        EL3          :        Number of electrons in RAS3 per sub type
!        ACTP         :        is sub-type active
!        Z            :         Lexical adressing of arrays
!        EL123        :        -"-    But array
!        STSTMI       :        Explicit offsets and lengths
!        STSTMN       :                  "
!        STSTM        :        ?
!        NDMAP        :        Down mappings of strings containing the same number of electrons
!        NUMAP        :          Up mappings of strings containing the same number of electrons


! Not used
!        COBSM        :        Symmetry of conjugated orbitals
!        NIFSJ        :
!        IFSJ         :
!        IFSJO        :
!        STSTX        :        Symmetry of excitation connecting strings of given symmetry

Module Str_Info

Implicit None
Private
Public::String_Info, Str, NSTTYP_MAX, ITYP_DUMMY, NSTTYP, NELEC, MNRS1, MXRS1, MNRS3, MXRS3, IZORR, ISTTP, iuniqmp, iuniqtp, &
        IAZTP,IBZTP,IARTP,IBRTP, NZSTTP,NRSTTP, IATPM1,IATPM2,IBTPM1,IBTPM2, ISTAC, NOCTYP, NSTFTP, INUMAP, INDMAP, MXNSTR,  &
        DFTP, CFTP, DTOC, Storage, CNSM


Type String_Info
     Sequence
     Integer, Pointer:: OCSTR(:)=>Null()
     Integer, Allocatable:: OCSTR_hidden(:)
     Integer, Pointer:: STREO(:)=>Null()
     Integer, Allocatable:: STREO_hidden(:)
     Integer, Pointer:: STSM(:)=>Null()
     Integer, Allocatable:: STSM_hidden(:)
     Integer, Pointer:: STCL(:)=>Null()
     Integer, Allocatable:: STCL_hidden(:)
     Integer, Pointer:: NSTSO(:)=>Null()
     Integer, Allocatable:: NSTSO_hidden(:)
     Integer, Pointer:: ISTSO(:)=>Null()
     Integer, Allocatable:: ISTSO_hidden(:)
     Integer, Pointer:: EL1(:)=>Null()
     Integer, Allocatable:: EL1_hidden(:)
     Integer, Pointer:: EL3(:)=>Null()
     Integer, Allocatable:: EL3_hidden(:)
     Integer, Pointer:: ACTP(:)=>Null()
     Integer, Allocatable:: ACTP_hidden(:)
     Integer, Pointer:: Z(:)=>Null()
     Integer, Allocatable:: Z_hidden(:)
     Integer, Pointer:: EL123(:)=>Null()
     Integer, Allocatable:: EL123_hidden(:)
     Integer, Allocatable:: STSTMI(:)
     Integer, Allocatable:: STSTMN(:)
     Integer, Pointer:: STSTM(:,:)=>Null()
     Integer, Allocatable:: STSTM_hidden(:,:)
     Integer, Allocatable:: NUMAP(:)
     Integer, Allocatable:: NDMAP(:)
End Type String_Info

Type (String_Info), Allocatable, Target:: Str(:)
!     Integer, Allocatable:: COBSM(:)
!     Integer, Allocatable:: NIFSJ(:)
!     Integer, Allocatable:: IFSJ(:)
!     Integer, Allocatable:: IFSJO(:)
!     Integer, Allocatable:: STSTX(:)

!             INITITIALIZED IN STRTYP
!        NSTTYP       :        Number of string types
!        MNRS1        :        Min ras1
!        MXRS1        :        Max ras1
!        MNRS3        :        Min ras3
!        MXRS3        :        Max ras3
!        NELEC        :        Number of electrons
!        IZORR        :        Zero orde y/n
!        IAZTP        :        Pointer to alpha types
!        IBZTP        :        Pointer to beta types
!
!not in use (just zero order space)
!        IARTP        :        Give type nr to certain exc
!        IBRTP        :        Give type nr to certain exc
!
!        NZSTTP       :        Not in use
!        NRSTTP       :        Not in use
!
!        ISTTP        :        Space (0=zero order)
!        iuniqmp      :        Unique types (not necessary here just 0order space)
Integer, Parameter:: NSTTYP_MAX=6+1   ! "+1" is the dummy layer
Integer:: ITYP_DUMMY=0
Integer i
Integer::     NSTTYP,                                         &
              NELEC(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],         &
              MNRS1(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],         &
              MXRS1(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],         &
              MNRS3(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],         &
              MXRS3(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],         &
              IZORR(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],         &
              ISTTP(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],         &
              iuniqmp(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],       &
              iuniqtp(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],       &
              IAZTP,IBZTP,IARTP(3,10),IBRTP(3,10),            &
              NZSTTP,NRSTTP,                                  &
              IATPM1,IATPM2,IBTPM1,IBTPM2

!        ISTAC                 : Stringtype maping; a(or a+) i -> istac(j,1(2))
!        NOCTYP                : Number of occupation classes for given type
!        NSTFTP                : Number of strings of this type
!        INUMAP                : Mapping of string type to next more general type
!        INDMAP                : Mapping of string type to next more restricted type
!        MXNSTR                : Largest number of strings of given sym and type
!
Integer:: ISTAC(NSTTYP_MAX,2),                          &
          NOCTYP(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],      &
          NSTFTP(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],      &
          INUMAP(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],      &
          INDMAP(NSTTYP_MAX)=[(0,i=1,NSTTYP_MAX)],      &
          MXNSTR

#include "detdim.fh"
!     DFTP          :        OPEN SHELL DETERMINANTS OF PROTO TYPE
!     CFTP          :        BRANCHING DIAGRAMS FOR PROTO TYPES
!     DTOC          :        CSF-DET TRANSFORMATION FOR PROTO TYPES
!     CNSM(:)%ICONF :        NCNSM  CONFIGURATION EXPANSIONS
!     CNSM(I)%ICTS  :        adress of determinant I in STRING ordering for
!                            determinant I in CSF ordering
!                            reference symmetry IREFSM.
Integer, Allocatable:: DFTP(:)
Integer, Allocatable:: CFTP(:)
Real*8,  Allocatable:: DTOC(:)
Type Storage
  Integer, Allocatable:: ICONF(:)
  Integer, Allocatable:: ICTS(:)
End Type Storage
Type (Storage) :: CNSM(MXCNSM)

End Module Str_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SetUp_iSD()

use setup, only: mSkal, MxPrm
use iSD_data, only: iSD, nSD, nSkal_iSD
use k2_arrays, only: MxDij, MxFT
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iBas, iCmp, iPrim, iS, nSkal

!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(iSD,safe='*')
call Nr_Shells(nSkal)
mSkal = nSkal
nSkal_iSD = nSkal+4  ! Add four slots for future use.
call mma_allocate(iSD,[0,nSD],[1,nSkal_iSD],label='iSD')
call Def_Shells(iSD,nSD,nSkal)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the size of and allocate auxiliary memory

MxPrm = 0
MxFT = 0
MxDij = 0
do iS=1,nSkal
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  MxPrm = max(MxPrm,iPrim)
  if (nIrrep == 1) then
    MxFT = 1 ! Dummy assignment
    MxDij = max(MxDij,iCmp**2+iPrim**2+1)
  else
    MxFT = max(MxFT,6*(iBas*iCmp)**2)
    MxDij = max(MxDij,(iBas**2+1)*iCmp**2+iPrim**2+1)
  end if
end do
MxDij = 6*nIrrep*MxDij
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine SetUp_iSD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Per-Olof Widmark                                 *
!***********************************************************************

subroutine NatoUHF(DensA,DensB,FockA,FockB,nBT,CMO,nBB,Ovl,Nato,Eta,Eps,nnB,nSym,nBas,nOrb)
!***********************************************************************
!                                                                      *
! This routine computes the natural orbitals for a UHF wavefunction.   *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBT, nBB, nnB, nSym, nBas(nSym), nOrb(nSym)
real(kind=wp), intent(in) :: DensA(nBT), DensB(nBT), FockA(nBT), FockB(nBT), CMO(nBB), Ovl(nBT)
real(kind=wp), intent(out) :: Nato(nBB), Eta(nnB), Eps(nnB)
integer(kind=iwp) :: indx, iOffCMO, iOffEta, iOffSqr, iOffTri, iOrb, iSym, MaxSqr, MaxTri, nCMO, nEta, nSqr, nTri
real(kind=wp) :: tmp
real(kind=wp), allocatable :: Aux1(:), Aux2(:), Aux3(:), Dens(:), Fock(:), SMat(:)

!----------------------------------------------------------------------*
! Setup                                                                *
!----------------------------------------------------------------------*
MaxTri = 0
MaxSqr = 0
nTri = 0
nSqr = 0
nCMO = 0
nEta = 0
do iSym=1,nSym
  MaxTri = max(MaxTri,nTri_Elem(nBas(iSym)))
  MaxSqr = max(MaxSqr,nBas(iSym)**2)
  nTri = nTri+nTri_Elem(nBas(iSym))
  nSqr = nSqr+nBas(iSym)**2
  nCMO = nCMO+nBas(iSym)*nOrb(iSym)
  nEta = nEta+nOrb(iSym)
end do
!----------------------------------------------------------------------*
! Allocate arrays                                                      *
!----------------------------------------------------------------------*
call mma_allocate(Dens,nTri,Label='Dens')
call mma_allocate(Fock,nTri,Label='Fock')
call mma_allocate(SMat,MaxSqr,Label='SMat')
call mma_allocate(Aux1,MaxSqr,Label='Aux1')
call mma_allocate(Aux2,MaxSqr,Label='Aux2')
call mma_allocate(Aux3,MaxSqr,Label='Aux3')
!----------------------------------------------------------------------*
! Add up the densities                                                 *
!----------------------------------------------------------------------*
Dens(:) = DensA(1:nTri)+DensB(1:nTri)
!----------------------------------------------------------------------*
! Copy orbitals                                                        *
!----------------------------------------------------------------------*
Nato(1:nCMO) = CMO(1:nCMO)
!----------------------------------------------------------------------*
! Average Fock matrix.                                                 *
!----------------------------------------------------------------------*
Fock(:) = Half*(FockA(1:nTri)+FockB(1:nTri))
!iOffTri = 0
!do iSym=1,nSym
!  call TriPrt('natouhf: Fock A','(20f10.4)',FockA(1+iOffTri),nBas(iSym))
!  call TriPrt('natouhf: Fock B','(20f10.4)',FockB(1+iOffTri),nBas(iSym))
!  call TriPrt('natouhf: Average Fock','(20f10.4)',FockB(1+iOffTri),nBas(iSym))
!  iOffTri = iOffTri+nTri_Elem(nBas(iSym))
!end do
!----------------------------------------------------------------------*
! Form density in MO basis: C(t)SDSC                                   *
!----------------------------------------------------------------------*
iOffSqr = 0
iOffTri = 0
iOffCMO = 0
iOffEta = 0
do iSym=1,nSym
  if (iSym > 1) then
    iOffTri = iOffTri+nTri_Elem(nBas(iSym-1))
    iOffSqr = iOffSqr+nBas(iSym-1)**2
    iOffEta = iOffEta+nOrb(iSym-1)
    iOffCMO = iOffCMO+nBas(iSym-1)*nOrb(iSym-1)
  end if
  if (nBas(iSym) <= 0) cycle

  ! Compute C(t)S (=aux1), but square S first

  call Square(Ovl(iOfftri+1),Smat,1,nBas(iSym),nBas(iSym))
  !call RecPrt('natouhf: Smat','(12f12.6)',Smat,nBas(iSym),nBas(iSym))
  call DGEMM_('T','N',nOrb(iSym),nBas(iSym),nBas(iSym), &
              One,CMO(iOffCMO+1),nBas(iSym), &
              Smat,nBas(iSym), &
              Zero,Aux1,nOrb(iSym))
  !call RecPrt('natouhf: C(t)S','(12f12.6)',Aux1,nOrb(iSym),nBas(iSym))

  ! Compute C(t)SD (=aux3), but first unfold D (=aux2)

  call Dsq(Dens(1+iOffTri),Aux2,1,nBas(iSym),nBas(iSym))
  !call RecPrt('natouhf: Density','(12f12.6)',Aux2,nBas(iSym),nBas(iSym))
  call DGEMM_('N','N',nOrb(iSym),nBas(iSym),nBas(iSym), &
              One,Aux1,nOrb(iSym), &
              Aux2,nBas(iSym), &
              Zero,Aux3,nOrb(iSym))
  !call RecPrt('natouhf: C(t)SD','(12f12.6)',Aux3,nOrb(iSym),nBas(iSym))

  ! Compute C(t)SDS (=aux1)

  call DGEMM_('N','N',nOrb(iSym),nBas(iSym),nBas(iSym), &
              One,Aux3,nOrb(iSym), &
              Smat,nBas(iSym), &
              Zero,Aux1,nOrb(iSym))
  !call RecPrt('natouhf: C(t)SDS','(12f12.6)',Aux1,nOrb(iSym),nBas(iSym))

  ! Compute C(t)SDSC (=aux2)

  call DGEMM_Tri('N','N',nOrb(iSym),nOrb(iSym),nBas(iSym), &
                 One,Aux1,nOrb(iSym), &
                 CMO(iOffCMO+1),nBas(iSym), &
                 Zero,Aux2,nOrb(iSym))
  !call TriPrt('natouhf: C(t)SDSC','(12f12.6)',Aux2,nOrb(iSym))

  ! Shift diagonal slightly

  tmp = 1.0e-6_wp
  do iOrb=1,nOrb(iSym)
    indx = nTri_Elem(iOrb)
    Aux2(indx) = Aux2(indx)+tmp
    tmp = Half*tmp
  end do
  !call TriPrt('natouhf: C(t)SDSC + shift','(12f12.6)',Aux2,nOrb(iSym))

  ! Diagonalize

  call NIdiag(Aux2,Nato(iOffCMO+1),nOrb(iSym),nBas(iSym))
  call Pickup(Aux2,Eta(iOffEta+1),nOrb(iSym))
  Eta(iOffEta+1:iOffEta+nOrb(iSym)) = -Eta(iOffEta+1:iOffEta+nOrb(iSym))
  call SortEig(Eta(iOffEta+1),Nato(iOffCMO+1),nOrb(iSym),nBas(iSym),1,.true.)
  Eta(iOffEta+1:iOffEta+nOrb(iSym)) = -Eta(iOffEta+1:iOffEta+nOrb(iSym))
end do
!----------------------------------------------------------------------*
! Compute diagonal of average Fock matrix                              *
!----------------------------------------------------------------------*
call MkEorb_Inner(Fock,nBT,Nato,nBB,Eps,nnB,nSym,nBas,nOrb)
!call PriMO('natouhf: UHF nato',.true.,.true.,-One,1.0e6_wp,nSym,nBas,nOrb,Name,Eps,Eta,Nato,3)
!----------------------------------------------------------------------*
! Deallocate arrays                                                    *
!----------------------------------------------------------------------*
call mma_deallocate(Aux3)
call mma_deallocate(Aux2)
call mma_deallocate(Aux1)
call mma_deallocate(SMat)
call mma_deallocate(Fock)
call mma_deallocate(Dens)
!----------------------------------------------------------------------*
! Done                                                                 *
!----------------------------------------------------------------------*
return

end subroutine NatoUHF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine STEPVEC(ICL,IOP,NCL,NOP,ISPIN,NORB,IWALK)
! PURPOSE: A SPIN-COUPLED CSF IS SPECIFIED BY NCL CLOSED SHELL
!          AND NOP OPEN SHELL AND OCCUPATION VECTORS ICL AND IOP,
!          RESPECTIVELY. THE SPIN COUPLING IS STORED IN THE
!          VECTOR ISPIN. TRANSLATE THESE DATA INTO THE
!          CORRESPONDING STEP VECTOR.

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NCL, NOP, ICL(NCL), IOP(NOP), ISPIN(NOP), NORB
integer(kind=iwp), intent(out) :: IWALK(NORB)
integer(kind=iwp) :: IDELSP, IORB, NXTCL, NXTOP
logical(kind=iwp) :: Test1, Test2

NXTCL = 1
NXTOP = 1
do IORB=1,NORB

  Test1 = NXTCL <= NCL
  if (Test1) Test1 = IORB == ICL(NXTCL)

  Test2 = NXTOP <= NOP
  if (Test2) Test2 = IORB == IOP(NXTOP)

  if (Test1) then

    IWALK(IORB) = 3
    NXTCL = NXTCL+1

  else if (Test2) then

    if (ISPIN(NXTOP) == 1) then
      IDELSP = 1
    else
      IDELSP = -1
    end if
    if (IDELSP == 1) then
      IWALK(IORB) = 1
    else if (IDELSP == -1) then
      IWALK(IORB) = 2
    end if
    NXTOP = NXTOP+1

  else

    IWALK(IORB) = 0

  end if

end do

! EXIT

return

end subroutine STEPVEC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CalcAMt (iOpt,LUQRP,MPLbl,lMax,iSRShll,
     &                    nProj,iCoShll,rcharge)
************************************************************************
*                                                                      *
*...       calculates the non-diagonal spectral representation         *
*          A matrix for an atom. Note that its signs is such           *
*          that the spectral representation must be ADDED to the       *
*          one-electron hamiltonian.                                   *
*                                                                      *
*     Internal matrices fixed the maximum number of primitives         *
*     per symmetry to 'maxprim'                                        *
*                                                                      *
************************************************************************
      Use Basis_Info
      Implicit Real*8 (A-H,O-Z)
      External Agin, Ovlmp, Vexch, Vqr
#include "relmp.fh"
#include "stdalloc.fh"
      Character*20 MPLbl

C...  working variables (change this)
      Parameter (maxprim=40)
      Parameter (mx100=100)
      Parameter (Mxlpq=(mx100*(mx100+1)/2))
      Parameter (Nrel=7*Mxlpq+5*mx100*mx100+5*mx100)
      Real*8 COREK(maxprim,maxprim,2),OVL(maxprim,maxprim),
     &       rel(Nrel),
     &       srel(maxprim*(maxprim+1)/2),
     &       trel(maxprim*(maxprim+1)/2),
     &       urel(maxprim*(maxprim+1)/2),
     &       tnrel(maxprim*(maxprim+1)/2),
     &       unrel(maxprim*(maxprim+1)/2),
     &       hcorr(maxprim*(maxprim+1)/2)
      Real*8 VEXTT(maxprim*(maxprim+1)/2),PVPT(maxprim*(maxprim+1)/2),
     &       EVN1(maxprim,maxprim),EVN2(maxprim,maxprim),
     &       RE1R(maxprim,maxprim),
     &       AUXI(maxprim,maxprim),
     &       W1W1(maxprim,maxprim),W1E0W1(maxprim,maxprim)
      Data iExch/1/,iMVPot/2/,iDWPot/4/,iNPPot/8/
*
      PI=2D0*ACOS(0D0)
      iprint=0
      Call Agin
      call dcopy_(2*MaxPrim**2,[0.0D0],0,Corek,1)
c
c     calculate relativistic integrals if needed
      lpq=0
      do i=1,lmax+1
         nnexp=Shells(isrshll+i-1)%nExp
         lpq=lpq+nnexp*(nnexp+1)/2
      enddo
      if(4*lpq.gt.Nrel) then
         write(6,*) ' problem. Nrel and lpq are', nrel,lpq
         write(6,*) ' The dimension of rel must somehow be increased.'
         Call Abend
      endif
#ifdef _DEBUGPRINT_
      write(6,*) ' basis:', (Shells(isrshll+i-1)%nExp,i=1,lmax+1)
      do i=1,lmax+1
         nnExp=Shells(isrshll+i-1)%nExp
         write(6,*) ' number of exponents', nnExp
         write(6,*) ' exponents, symmetry', i
         do j=1,nnExp
            write(6,*) Shells(iSRShll+i-1)%Exp(j)
         enddo
      enddo
#endif
      Do 1000 lP1=1,lMax+1
        iSRSh=iSRShll+lP1-1
        nP=Shells(iSRSh)%nExp
        If (np.gt.maxprim) Then
          Write (6,*) 'CalcAMt: np.gt.maxprim',np,maxprim
          Write (6,*) 'Abend: Increase MaxPrim !'
          Call Abend
        End If
        N=lP1
        LAM=lP1
        If (nP.le.0) Go To 1000
C
        call dcopy_(nRel,[0.0D0],0,Rel,1)
        If (iAnd(iOpt,iMVPot).ne.0 .and.
     &      iAnd(iOpt,iDWPot).ne.0 ) Then
C...      Mass-velocity and/or Darwin potentials
          Call Vqr(LUQRP,MPLbl,lP1,Shells(iSRSh)%Exp,nP,rel)
        Else If ((iAnd(iOpt,iMVPot).ne.0 .and.
     &            iAnd(iOpt,iDWPot).eq.0 ) .or.
     &           (iAnd(iOpt,iMVPot).eq.0 .and.
     &            iAnd(iOpt,iDWPot).ne.0 )) Then
          Write (6,*) 'Mass-Velocity and Darwin potentials must be'
          Write (6,*) 'active simultaneosly.'
          Call Abend
        Endif
C
      If (iAnd(iOpt,iNPPot).ne.0) then   ! Zero
         call oeisg(rel,srel,trel,urel,Shells(iSRSh)%Exp,
     &   rCharge,mx100,lp1,Shells(iSRSh)%nExp,unrel,tnrel,hcorr,iprint,
     &   VEXTT,PVPT,EVN1,EVN2,RE1R,AUXI,W1W1,W1E0W1)
         nmat=(Shells(iSRSh)%nExp*(Shells(iSRSh)%nExp+1))/2
         if(iprint.ge.10) then
            write(6,*) ' relativistic integrals'
            write(6,12) (hcorr(i),i=1,nmat)
 12      format(4d19.12)
         endif
         call dcopy_(nRel,[0.0D0],0,Rel,1)
      endif
C
C...    Overlap and, if neccesary, exchange.
        IJ=0
        DO 101 I=1,NP
          ZI=Shells(iSRSh)%Exp(I)
          DO 102 J=1,I
            IJ=IJ+1
            ZJ=Shells(iSRSh)%Exp(J)
            COREK(I,J,1)=rel(ij)
            If (iAnd(iOpt,iNPPot).ne.0) Then
               corek(i,j,2)=hcorr(ij)
            End If
            If (iAnd(iOpt,iExch).ne.0) Then
C...          minus exchange potential
              AuxLs=VExch(ZI,N,ZJ,N,LAM,nProj,iCoShll)
              COREK(I,J,1)=COREK(I,J,1)-AuxLs
            ENDIF
            OVL(I,J)=OVLMP(N,ZI,N,ZJ)
            OVL(J,I)=OVL(I,J)
            COREK(J,I,1)=COREK(I,J,1)
            COREK(J,I,2)=COREK(I,J,2)
102       CONTINUE
101     CONTINUE
C
        CALL MATINV (OVL,rel,NP,0,maxprim)
C
        PreFac = sqrt((2D0/PI)**3) * 4D0**(lP1-1)
*
        Call mma_Allocate(Shells(ISRSh)%Akl,NP,NP,2,Label='Akl')
        Shells(ISRSh)%nAkl=NP
        DO iq = 1, 2
           DO I=1,NP
              ZI=Shells(iSRSh)%Exp(I)
              DO L=1,NP
                 rel(L)=0.D0
                 DO K=1,NP
                    rel(L)=rel(L)+OVL(I,K)*COREK(K,L,iq)
                 END DO
              END DO
              DO J=1,I
                 ZJ=Shells(iSRSh)%Exp(J)
                 ADUM=0.D0
                 DO L=1,NP
                    ADUM=ADUM+rel(L)*OVL(L,J)
                 END DO
*                in MOLCAS3:X1
*                multiply by the (radial) normalization constants
*                of the primitives i and j, so that the spectral
*                representation coeffients correspond to the
*                (radially) unnormalized primitives.
                 ADUM=ADUM*PreFac*sqrt(sqrt( (ZI*ZJ)**(3+2*(lP1-1)) ))
                 Shells(iSRSh)%Akl(I,J,iq)=ADUM
                 Shells(iSRSh)%Akl(J,I,iq)=ADUM
              END DO
           END DO
           IJAM0=IJAM0+NP**2
        END DO
*
1000  CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Giovanni Li Manni                                *
!               2013, Dongxia Ma                                       *
!***********************************************************************

subroutine DmatDmat(Dmat,DDarray)
!***********************************************************************
! Purpose: To construct an array containing Dpq*Drs elements
!          (product of one-body density matrix elements) ordered
!          according to the ordering of the 2-electron integrals
!          elements g(pqrs).
!
! Author : Giovanni Li Manni and Dongxia Ma
! Date   : June 21st 2013 ... When Minnesotan summer seems to arrive!
!***********************************************************************

use Symmetry_Info, only: Mul
use Index_Functions, only: i_Tri => iTri, nTri_Elem
use rasscf_global, only: ISTORP
use general_data, only: NASH, NSYM
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: Dmat(*)
real(kind=wp), intent(_OUT_) :: DDarray(*)
integer(kind=iwp) :: indx1, indx2, indxDpq, indxDrs, iOffOrb(nSym), iOrbP, iOrbQ, iOrbR, iOrbS, iorp, iPsm, iQsm, iRsm, iSmPQ, &
                     iSsm, iSym, nRS
real(kind=wp) :: FACT

! Initialization of variables

iorp = 0
indx1 = 0
iOffOrb(1) = 0

do iSym=2,nSym
  iOffOrb(iSym) = iOffOrb(iSym-1)+NaSh(iSym-1)
end do

DDarray(1:istorp(nSym+1)) = Zero

do iPsm=1,nSym
  do iOrbP=1,NASh(iPsm)
    do iQsm=1,nSym
      if (NASh(iQsm) == 0) cycle  ! next iQsm
      iSmPQ = Mul(iPsm,iQsm)
      indx2 = 0
      do iRsm=1,nSym
        iSsm = Mul(iSmPQ,iRsm)
        if ((min(NASh(iRsm),NASh(iSsm)) /= 0) .and. (iSsm <= iRsm)) then
          nRS = NASh(iRsm)*NASh(iSsm)
          if (iSsm == iRsm) then
            nRS = nTri_Elem(NASh(iRsm))
          end if
          if ((iRsm /= iSsm) .or. (iQsm /= iPsm)) then
            iorp = iorp+nRS*NASh(iQsm)
          else
            do iOrbR=1,NASH(iRsm)
              do iOrbS=1,iOrbR
                if (iOrbR /= iOrbS) then
                  FACT = Two
                else
                  FACT = One
                end if
                do iOrbQ=1,NASH(iQsm)
                  iorp = iorp+1
                  indxDpq = indx1+i_Tri(iOrbP,iOrbQ)
                  indxDrs = indx2+i_Tri(iOrbR,iOrbS)
                  DDarray(iorp) = Dmat(indxDpq)*Dmat(indxDrs)*FACT
                end do ! Loop over iOrbQ
              end do ! Loop over iOrbS
            end do ! Loop over iOrbR
          end if
        end if
        indx2 = indx2+nTri_Elem(NASH(iRsm))
      end do ! loop over iRsm
    end do ! Loop over iQsm
  end do ! Loop over iOrbP
  indx1 = indx1+nTri_Elem(NASH(iPsm))
end do ! Loop over iPsm

end subroutine DmatDmat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module HFC_logical

use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: MagX2C_Req
logical(kind=iwp) :: MagX2C_Avail, UHF_HFC

! VARIABLE DESCRIPTION
!
!  UHF_HFC     : to control the calculation of hyperfine coupling tensor
!               matrix in unrestricted Hartree-Fock scf calculations.
!               It is mainly used in scf program and the related integral_util
!               directory.
!
! MagX2C_Req   : an integer specifies whether RX2C, MTXC are requested in &SEWARD
!              = -2 (non-relativistic case), both are turned off: no RX2C, no MXTC
!              = -1 RX2C = ON, but users do not specify MXTC
!              =  2 both are turned on
!
! MagX2C_Avail : is controlled by iRdOne.
!             = .TRUE. when MagX2C integral is accessible and vice versa
!
! NOTE: MagX2C_Req is used for handling input instead of calling iRdOne.

public :: MagX2C_Avail, MagX2C_Req, UHF_HFC

end module HFC_logical

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine rad2(ccr,kcrl,kcru,l,lambu,lmahi,lmalo,lmbhi,lmblo,ltot1,ncr,qsum,rka,rkb,zcr,lit,ljt,ca,cb,tai,taj,aa,aarr2,fctr2)
! compute type 2 radial integrals.
!
! 28-nov-90 new version replaced old version. -rmp
! 19-jan-97 put Bessel formula into a separate subroutine, qbess. -rmp

use ppint_arrays, only: binom, dfac, hpt, hwt
use Constants, only: Zero, One, Two, Four, Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: kcrl, kcru, l, lambu, lmahi, lmalo, lmbhi, lmblo, ltot1, ncr(*), lit, ljt
real(kind=wp), intent(in) :: ccr(*), rka, rkb, zcr(*), ca, cb, tai, taj, aa, aarr2, fctr2
real(kind=wp), intent(out) :: qsum(ltot1,lambu,lmahi)
integer(kind=iwp) :: kcr, lama, lamb, ldifa1, ldifb, n, nhi, nlim, nlo, npi, nu
real(kind=wp) :: alpha, arc2, dum, f2lma3, f2lmb3, prd, qlim, rc, rk, t
real(kind=wp), parameter :: eps1 = 1.0e-15_wp, tol = 20.0_wp*log(Ten)
real(kind=wp), external :: qcomp

qsum(:,:,:) = Zero
! sum over potential terms
do kcr=kcrl,kcru
  npi = ncr(kcr)
  alpha = aa+zcr(kcr)
  rc = (rka+rkb)/(alpha+alpha)
  arc2 = alpha*rc*rc
  dum = aarr2+zcr(kcr)*arc2/aa
  if (dum > tol) cycle
  prd = fctr2*ccr(kcr)*exp(-dum)

  if ((rka == Zero) .and. (rkb == Zero)) then
    ! rka=0 and rkb=0
    rk = Zero
    t = Zero
    qsum(ltot1,1,1) = qsum(ltot1,1,1)+prd*qcomp(alpha,dfac,npi+ltot1-1,0,t,rk)
  else if (rka == Zero) then
    ! rka=0 and rkb>0
    rk = rkb
    t = arc2
    do lamb=l,lmbhi
      qsum(lamb-l+lit,lamb,1) = qsum(lamb-l+lit,lamb,1)+prd*qcomp(alpha,dfac,npi+lamb-l+lit-1,lamb-1,t,rk)
    end do
  else if (rkb == Zero) then
    ! rka>0 and rkb=0
    rk = rka
    t = arc2
    do lama=l,lmahi
      qsum(lama-l+ljt,1,lama) = qsum(lama-l+ljt,1,lama)+prd*qcomp(alpha,dfac,npi+lama-l+ljt-1,lama-1,t,rk)
    end do
  else if (npi == 2) then
    ! rka>0 and rkb>0; use bessel function formula.
    ! To be applicable for a set of integrals, must have nu<=l and
    ! nu==(integer), where nu=l+1-npi/2, so it is used here only
    ! for the npi=2 case. It can't be used at all for npi=(odd) and
    ! only for partial sets for npi=0
    nu = l
    call qbess(alpha,binom,dfac,l,lambu,lmahi,lmbhi,ltot1,nu,prd,qsum,rka,rkb)
  else if (arc2 >= 50.0_wp) then
    ! rka>0 and rkb>0; use pts and wts method
    ! estimate radial integrals and compare to threshold
    qlim = abs(prd)/(max(One,(rc+rc)*rka)*max(One,(rc+rc)*rkb))*sqrt(Four*(tai+tai)**lit*(taj+taj)**ljt*sqrt(tai*taj)/alpha)
    if (rc < ca) then
      nlim = npi
      qlim = qlim*ca**(lit-1)
    else
      nlim = npi+(lit-1)
    end if
    if (rc < cb) then
      qlim = qlim*cb**(ljt-1)
    else
      nlim = nlim+(ljt-1)
    end if
    if (qlim*rc**nlim >= eps1) then
      call ptwt(arc2,dfac,npi,l,lambu,ltot1,lmahi,lmbhi,alpha,rc,rka,rkb,prd,hpt,hwt,qsum)
    end if
  else
    ! rka>0 and rkb>0; use partially asymptotic method
    call qpasy(alpha,dfac,npi,l,lambu,lmahi,lmbhi,ltot1,rka,rkb,fctr2*ccr(kcr),dum+arc2,qsum)
  end if
end do

if ((rka == Zero) .and. (rkb /= Zero)) then
  ! rka=0 and rkb>0
  f2lmb3 = real(2*lmbhi-3,kind=wp)
  do lamb=lmbhi-2,lmblo,-1
    nlo = abs(lamb-l+1)+lit+1
    nhi = ljt-mod((ljt-1)-abs(lamb-l),2)+lit-1
    do n=nlo,nhi,2
      qsum(n,lamb,1) = qsum(n,lamb+2,1)+(f2lmb3/rkb)*qsum(n-1,lamb+1,1)
    end do
    f2lmb3 = f2lmb3-Two
  end do
else if ((rka /= Zero) .and. (rkb == Zero)) then
  ! rka>0 and rkb=0
  f2lma3 = real(2*lmahi-3,kind=wp)
  do lama=lmahi-2,lmalo,-1
    nlo = abs(lama-l+1)+ljt+1
    nhi = lit-mod((lit-1)-abs(lama-l),2)+ljt-1
    do n=nlo,nhi,2
      qsum(n,1,lama) = qsum(n,1,lama+2)+(f2lma3/rka)*qsum(n-1,1,lama+1)
    end do
    f2lma3 = f2lma3-Two
  end do
else if ((rka /= Zero) .and. (rkb /= Zero)) then
  ! rka>0 and rkb>0
  f2lma3 = real(lmahi+lmahi+1,kind=wp)
  do lama=lmahi,lmalo,-1
    ldifa1 = abs(l-lama)+1
    f2lmb3 = real(2*lmbhi+1,kind=wp)
    do lamb=lmbhi,lmblo,-1
      ldifb = abs(l-lamb)
      nlo = ldifa1+ldifb
      nhi = (ltot1-mod(lit-ldifa1,2))-mod((ljt-1)-ldifb,2)
      do n=nlo,nhi,2
        if (n-(lama+lamb) == (1-l-l)) cycle
        if ((lama > lmahi-2) .or. (n <= abs(l-lama-2)+ldifb)) then
          ! lamb recursion
          qsum(n,lamb,lama) = qsum(n,lamb+2,lama)+(f2lmb3/rkb)*qsum(n-1,lamb+1,lama)
        else
          ! lama recursion
          qsum(n,lamb,lama) = qsum(n,lamb,lama+2)+(f2lma3/rka)*qsum(n-1,lamb,lama+1)
        end if
      end do
      f2lmb3 = f2lmb3-Two
    end do
    f2lma3 = f2lma3-Two
  end do
end if

return

end subroutine rad2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************
!  CHO_get_ER
!
!> @brief
!>   Compute the Edmiston--Ruedenberg functional for a given set of occupied MOs
!> @author F. Aquilante
!>
!> @details
!> Computes the Edmiston--Ruedenberg functional
!>
!> \f[ W = \sum_i \mathit{ER}[i] = \sum_i (ii|ii) \f]
!>
!> for a given set of occupied MOs.
!>
!> The functional orbital components \p ER(i) are
!> computed by using the Cholesky representation \f$ L_{ab,J} \f$
!> of the AO two-electron integrals, namely
!>
!> \f[ \mathit{ER}[i] = \sum_J V[i]_J V[i]_J \f]
!>
!> where
!>
!> \f[ V[i]_J = \sum_{ab} D[i]_{ab} L_{ab,J} \f]
!>
!> and
!>
!> \f[ D[i]_{a,b} = C[i]_a C[i]_b \f]
!>
!> @note
!> Requires initialization of the Cholesky information.
!>
!> @param[out] irc     return code
!> @param[in]  CMO     MOs matrix, stored as \p C(a,k)
!> @param[in]  nOcc    number of occupied orbitals in each symmetry
!> @param[out] ER      orbital components of the ER functional}
!> @param[out] W       value of the Edmiston--Ruedenberg functional
!> @param[in]  timings switch on/off timings printout
!***********************************************************************

subroutine CHO_get_ER(irc,CMO,nOcc,ER,W,timings)

use Index_Functions, only: iTri, nTri_Elem
use Cholesky, only: InfVec, nBas, nDimRS, nSym, NumCho
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp), intent(in) :: nOcc(*)
real(kind=wp), intent(_OUT_) :: ER(*)
real(kind=wp), intent(out) :: W
logical(kind=iwp), intent(in) :: timings
integer(kind=iwp) :: ia, ib, iBatch, ik, iLoc, iOcc(8), ipa, ipab, ipb, isMO(8), IVEC2, iVrs, JNUM, JRED, JRED_, JRED1, JRED2, &
                     JSYM, jv, JVEC, kSym, LREAD, LWORK, MaxB, MaxBB, MUSED, nBatch, nOccT, nRS, NUMV, nVec, nVrs
real(kind=wp) :: TCI1, TCI2, TCR1, TCR2, tintg(2), TOTCPU, TOTCPU1, TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, tread(2), TWI1, TWI2, &
                 TWR1, TWR2
real(kind=wp), allocatable :: Dab(:), DLT(:), Lab(:), VJ(:)
character(len=*), parameter :: SECNAM = 'CHO_get_ER'

JSYM = 1
if (NumCho(JSYM) < 1) then
  write(u6,*) SECNAM//'No total symmetric vectors present'
  irc = 77
  return
end if

call CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = Zero  !time for reading the vectors
tintg(:) = Zero  !time for computing the functional

! compute some offsets and other quantities
MaxB = nBas(1)
iOcc(1) = 0
isMO(1) = 0
do kSym=2,nSym
  iOcc(kSym) = iOcc(kSym-1)+nOcc(kSym-1)
  isMO(kSym) = isMO(kSym-1)+nBas(kSym-1)**2
  MaxB = max(MaxB,nBas(kSym))
end do

MaxBB = nTri_Elem(MaxB)
nOccT = iOcc(nSym)+nOcc(nSym)

W = Zero ! initialization of the ER-functional value
ER(1:nOccT) = Zero ! and its orbital components

call mma_allocate(DLT,MaxBB,Label='DLT')
DLT(:) = Zero

iLoc = 3 ! use scratch location in reduced index arrays

JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

do JRED=JRED1,JRED2

  ! Memory management section -----------------------------

  call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

  if (nVrs == 0) cycle

  if (nVrs < 0) then
    write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs < 0. STOP!!'
    call abend()
  end if

  call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
  if (irc /= 0) then
    write(u6,*) SECNAM//'cho_X_setred non-zero return code. rc= ',irc
    call abend()
  end if

  nRS = nDimRS(JSYM,JRED)

  call mma_allocate(Dab,nRS,Label='Dab')

  call mma_maxDBLE(LWORK)

  nVec = min(LWORK/(nRS+1),nVrs)

  if (nVec < 1) then
    write(u6,*) SECNAM//': Insufficient memory for batch'
    write(u6,*) 'LWORK= ',LWORK
    write(u6,*) 'min. mem. need= ',nRS+1
    irc = 33
    call Abend()
    nBatch = -9999  ! dummy assignment
  end if

  LREAD = nRS*nVec

  call mma_allocate(Lab,LREAD,Label='Lab')
  call mma_allocate(VJ,nVec,Label='VJ')

  ! BATCH over the vectors in JSYM=1 ----------------------------

  nBatch = (nVrs-1)/nVec+1

  do iBatch=1,nBatch

    if (iBatch == nBatch) then
      JNUM = nVrs-nVec*(nBatch-1)
    else
      JNUM = nVec
    end if

    JVEC = nVec*(iBatch-1)+iVrs
    IVEC2 = JVEC-1+JNUM

    call CWTIME(TCR1,TWR1)

    JRED_ = JRED
    call CHO_VECRD(Lab,LREAD,JVEC,IVEC2,JSYM,NUMV,JRED_,MUSED)

    if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
      irc = 77
      return
    end if

    call CWTIME(TCR2,TWR2)
    tread(1) = tread(1)+(TCR2-TCR1)
    tread(2) = tread(2)+(TWR2-TWR1)

    call CWTIME(TCI1,TWI1)

    do kSym=1,nSym

      do ik=1,nOcc(kSym)

        ! Compute the i-th orbital component D[i](a,b) of the density
        ! D[i](a,b) is stored as upper-triangular
        do ib=1,nBas(kSym)

          ipb = isMO(kSym)+nBas(kSym)*(ik-1)+ib

          do ia=1,ib-1

            ipa = isMO(kSym)+nBas(kSym)*(ik-1)+ia
            ipab = iTri(ib,ia)
            DLT(ipab) = CMO(ipa)*CMO(ipb)

          end do

          ipab = nTri_Elem(ib)
          DLT(ipab) = Half*CMO(ipb)**2  !diagonal scaled

        end do

        ! Transform the density to reduced storage
        call switch_density(iLoc,DLT,Dab,kSym)

        !  ( r >= s )
        !---------------------------------------------------------
        ! V[i]{#J} <- V[i]{#J} + 2 * sum_rs  L(rs,{#J}) * D[i](rs)
        !=========================================================

        call DGEMV_('T',nRS,JNUM,Two,Lab,nRS,Dab,1,Zero,VJ,1)

        !-------------------------------------------------------
        ! ER[i] <- ER[i]  +  sum_J V[i](J)^2
        !=======================================================
        do jv=1,JNUM

          ER(iOcc(kSym)+ik) = ER(iOcc(kSym)+ik)+VJ(jv)**2
        end do

      end do

    end do

    call CWTIME(TCI2,TWI2)
    tintg(1) = tintg(1)+(TCI2-TCI1)
    tintg(2) = tintg(2)+(TWI2-TWI1)

  end do  !end batch loop

  ! free memory
  call mma_deallocate(VJ)
  call mma_deallocate(Lab)
  call mma_deallocate(Dab)

end do   ! loop over red sets

call mma_deallocate(DLT)

! Sync components
call GAdGOp(ER,nOccT,'+')

! Compute the ER-functional from its orbital components
W = sum(ER(1:nOccT))

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  write(u6,*)
  write(u6,*) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*) 'Timing from ',SECNAM,'            CPU      WALL '
  write(u6,*) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,'(2x,A26,2f10.2)') 'READ VECTORS                              ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COMPUTE (ii|ii)                           ',tintg(1),tintg(2)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,*) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

irc = 0

return

end subroutine CHO_get_ER

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRANSFOCK(TORB,F,IDIR)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
      DIMENSION TORB(*),F(*)
* Purpose: given an orbital transformation array and some
* one-electron matrix in storage format as e.g. HONE, FIFA,
* transform the matrix to use the new orbital basis.

      NT=0
      NOMX=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NR1=NRAS1(ISYM)
        NR2=NRAS2(ISYM)
        NR3=NRAS3(ISYM)
        NS=NSSH(ISYM)
        NO=NI+NR1+NR2+NR3+NS
        NOMX=MAX(NOMX,NO)
        NT=NT+NI**2+NR1**2+NR2**2+NR3**2+NS**2
      END DO
      CALL GETMEM('FSQ','ALLO','REAL',LFSQ,NOMX**2)
      CALL GETMEM('TSQ','ALLO','REAL',LTSQ,NOMX**2)
      CALL GETMEM('TMP','ALLO','REAL',LTMP,NOMX**2)
      IJOFF=0
      ITOFF=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NR1=NRAS1(ISYM)
        NR2=NRAS2(ISYM)
        NR3=NRAS3(ISYM)
        NS=NSSH(ISYM)
        NO=NI+NR1+NR2+NR3+NS
        IF (NO.eq.0) GOTO 99
* Copy the matrices to square storage: first fill with zeroes.
        CALL DCOPY_(NO**2,[0.0D0],0,WORK(LTSQ),1)
* Copy inactive TORB block to TSQ
        IOFF=0
        DO I=1,NI
         DO J=1,NI
          WORK(LTSQ-1+I+NO*(J-1))=TORB(ITOFF+I+NI*(J-1))
         END DO
        END DO
* Copy ras1 T block to TSQ, and so on..
        ITOFF=ITOFF+NI**2
        IOFF=IOFF+NI
        DO I=1,NR1
         II=IOFF+I
         DO J=1,NR1
          JJ=IOFF+J
          WORK(LTSQ-1+II+NO*(JJ-1))=TORB(ITOFF+I+NR1*(J-1))
         END DO
        END DO
*---
        ITOFF=ITOFF+NR1**2
        IOFF=IOFF+NR1
        DO I=1,NR2
         II=IOFF+I
         DO J=1,NR2
          JJ=IOFF+J
          WORK(LTSQ-1+II+NO*(JJ-1))=TORB(ITOFF+I+NR2*(J-1))
         END DO
        END DO
*---
        ITOFF=ITOFF+NR2**2
        IOFF=IOFF+NR2
        DO I=1,NR3
         II=IOFF+I
         DO J=1,NR3
          JJ=IOFF+J
          WORK(LTSQ-1+II+NO*(JJ-1))=TORB(ITOFF+I+NR3*(J-1))
         END DO
        END DO
*--- Finally, the secondary orbitals (non-deleted, virtual).
        ITOFF=ITOFF+NR3**2
        IOFF=IOFF+NR3
        DO I=1,NS
         II=IOFF+I
         DO J=1,NS
          JJ=IOFF+J
          WORK(LTSQ-1+II+NO*(JJ-1))=TORB(ITOFF+I+NS*(J-1))
         END DO
        END DO
        ITOFF=ITOFF+NS**2
* Now transfer the Fock matrix block to square storage:
        IJ=0
        DO I=1,NO
         DO J=1,I
          IJ=IJ+1
          WORK(LFSQ-1+J+NO*(I-1))=F(IJOFF+IJ)
          WORK(LFSQ-1+I+NO*(J-1))=F(IJOFF+IJ)
         END DO
        END DO
       IF (IDIR.GE.0) THEN
* Transform, first do FSQ*TSQ -> TMP...
        CALL DGEMM_('N','N',NO,NO,NO,1.0D0,WORK(LFSQ),NO,WORK(LTSQ),NO,
     &              0.0D0,WORK(LTMP),NO)
* ... and then do TSQ(transpose)*TMP -> FSQ.
        CALL DGEMM_('T','N',NO,NO,NO,1.0D0,WORK(LTSQ),NO,WORK(LTMP),NO,
     &              0.0D0,WORK(LFSQ),NO)
       ELSE
* Or inverse transformation
        CALL DGEMM_('N','T',NO,NO,NO,1.0D0,WORK(LFSQ),NO,WORK(LTSQ),NO,
     &              0.0D0,WORK(LTMP),NO)
        CALL DGEMM_('N','N',NO,NO,NO,1.0D0,WORK(LTSQ),NO,WORK(LTMP),NO,
     &              0.0D0,WORK(LFSQ),NO)
       END IF
* Transfer FSQ values back to F, in triangular storage.
       IJ=0
       DO I=1,NO
        DO J=1,I
         IJ=IJ+1
         F(IJOFF+IJ)=WORK(LFSQ-1+I+NO*(J-1))
        END DO
       END DO
       IJOFF=IJOFF+(NO*(NO+1))/2
* and repeat, using next symmetry block.
  99   CONTINUE
      END DO
      CALL GETMEM('FSQ','FREE','REAL',LFSQ,NOMX**2)
      CALL GETMEM('TSQ','FREE','REAL',LTSQ,NOMX**2)
      CALL GETMEM('TMP','FREE','REAL',LTMP,NOMX**2)


      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function indget_cvb(iminor,i_dim,nel,ixmin)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: indget_cvb
integer(kind=iwp), intent(in) :: nel, iminor(nel), i_dim, ixmin(0:nel,0:i_dim)
integer(kind=iwp) :: i, iacc

indget_cvb = 1
iacc = 0
do i=1,nel
  if (iminor(i) == 1) then
    iacc = iacc+1
    indget_cvb = indget_cvb+ixmin(i-1,iacc)
  end if
end do

return

end function indget_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************

      SubRoutine ChoMP2g_Density3(irc,CMO)
************************************************************************
*     Jonas Bostrom, March 2010.                                       *
*                                                                      *
*     Purpose: Finalize MP2 Density.                                   *
************************************************************************
      use ChoMP2, only: MP2D, MP2W, MP2W_e, MP2D_e
      Implicit Real*8 (a-h,o-z)
      Integer irc
      Real*8 CMO(*)
#include "real.fh"
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "stdalloc.fh"
#include "chomp2g.fh"

      Character(LEN=8), Parameter:: ThisNm = 'Density3'
      Character(LEN=16), Parameter:: SecNam = 'ChoMP2g_Density3'
      Integer nOccAll(8), nOrbAll(8)

      Real*8, Allocatable:: AOTriDens(:), WAOTriDens(:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      Subroutine Build_Mp2Dens(TriDens,nTriDens,MP2X_e,CMO,mSym,
     &                         nOrbAll,nOccAll,Diagonalize)

      use ChoMP2, only: Pointer_2D

      Integer        , Intent(In)    ::nTriDens
      Real*8         , Intent(InOut) :: TriDens(nTriDens)
      Type (Pointer_2D), Intent(In)    :: MP2X_e(8)
      Real*8         , Intent(In)    :: CMO(*)
      Integer        , Intent(In)    :: mSym
      Integer        , Intent(In)    :: nOrbAll(8), nOccAll(8)
      Logical        , Intent(In)    :: Diagonalize
      End Subroutine Build_Mp2Dens
      End Interface
*                                                                      *
************************************************************************
*                                                                      *

      irc=0

      Do iSym = 1, 8
         nOccAll(iSym) = nOcc(iSym) + nFro(iSym)
         nOrbAll(iSym) = nOrb(iSym) + nDel(iSym)
      End Do

      lTriDens = 0
      Do iSym = 1, nSym
         lTriDens = lTriDens + nOrbAll(iSym)*(nOrbAll(iSym)+1)/2
      End Do

      Do iSym = 1, nSym
         Do i = 1, nOrbAll(iSym)
            Do j = 1, nOrbAll(iSym)
               If((i.le. nOrb(iSym)) .and. (j.le. nOrb(iSym))) Then
                  MP2D_e(iSym)%A(i,j) = MP2D(iSym)%A(i,j)
                  MP2W_e(iSym)%A(i,j) = MP2W(iSym)%A(i,j)
               Else
                  MP2D_e(iSym)%A(i,j) = Zero
                  MP2W_e(iSym)%A(i,j) = Zero
               End If
            End Do
         End Do
      End Do
*
      Call mma_allocate( AOTriDens,lTriDens,Label=' AOTriDens')
      Call mma_allocate(WAOTriDens,lTriDens,Label='WAOTriDens')
       AOTriDens(:)=Zero
      WAOTriDens(:)=Zero
*

      Call Build_Mp2Dens( AOTriDens,lTriDens, MP2D_e,CMO,nSym,
     &                   nOrbAll, nOccAll,.True.)
      Call Build_Mp2Dens(WAOTriDens,lTriDens, MP2W_e,CMO,nSym,
     &                   nOrbAll, nOccAll,.False.)

      Call Put_D1ao_Var(AOTriDens,lTriDens)
      Call Put_Fock_Occ(WAOTriDens,lTriDens)

      Call mma_deallocate( AOTriDens)
      Call mma_deallocate(WAOTriDens)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Get_Mass
!
!> @brief
!>   Get (symmetry-unique) atomic masses from RUNFILE
!> @author Ignacio Fdez. Galn&aacute;n
!>
!> @details
!> Place atomic masses (in a.u.) into array \p Mass_All(*).
!>
!> @param[out] Mass   Array of masses
!> @param[in]  nAtoms Number of atoms
!***********************************************************************

subroutine Get_Mass(Mass,nAtoms)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms
real(kind=wp), intent(out) :: Mass(nAtoms)
integer(kind=iwp) :: i, mAtoms, nCent
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: AtoB(:)
real(kind=wp), allocatable :: CentMass(:)

call Get_iScalar('Unique atoms',mAtoms)
if (mAtoms /= nAtoms) then
  write(u6,*) 'Get_Mass: mAtoms /= nAtoms'
  write(u6,*) 'mAtoms=',mAtoms
  write(u6,*) 'nAtoms=',nAtoms
  call Abend()
end if
call mma_allocate(AtoB,nAtoms)
call Get_iArray('Atom -> Basis',AtoB,nAtoms)
call Qpg_dArray('Isotopes',Found,nCent)
if (.not. Found) then
  write(u6,*) 'Get_Mass: Isotopes array not found'
  call Abend()
end if
call mma_allocate(CentMass,nCent)
call Get_dArray('Isotopes',CentMass,nCent)
do i=1,nAtoms
  Mass(i) = CentMass(AtoB(i))
end do
call mma_deallocate(CentMass)
call mma_deallocate(AtoB)

return

end subroutine Get_Mass

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine diag_c2(matrix,n,info,w,z)
c
c   this routine performs the diagonalization of a Complex square
c   matrix with the dimension nbtot. the eigenvalues of the diagonalization
c   are directed into w1 and the Complex eigenvectors are written to z1.
c

      Implicit None
#include "stdalloc.fh"
      Integer, parameter          ::  wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer        :: info,i,j,n
      Complex(kind=8),intent(in)  :: matrix(n,n)
      Complex(kind=8),intent(out) :: z(n,n)
      Real(kind=8), intent(out)   :: w(n)
      ! local variables:
      Real(kind=8), allocatable    :: rwork(:) !rwork(3*n-2)
      Real(kind=8), allocatable    :: w1(:)    !w1(n)
      Complex(kind=8), allocatable :: ap(:)    !ap(n*(n+1)/2)
      Complex(kind=8), allocatable :: work(:)  !work(2*n-1)
      Complex(kind=8), allocatable :: z1(:,:)  !z1(n,n)
      Real(kind=8), external       :: dznrm2_
      Real(kind=8)                 :: RM

      info=0
      Call zcopy_(       N*N,[(0.0_wp,0.0_wp)],0,   Z ,1)
      Call dcopy_(         N,        [0.0_wp] ,0,   W ,1)

      RM=0.0_wp
      RM=dznrm2_(n*n,matrix,1)

      If(RM>0.0_wp) Then
         Call mma_allocate(ap   ,(n*(n+1)/2),'ap'   )
         Call mma_allocate(work ,    (2*n-1),'work' )
         Call mma_allocate(z1   ,        n,n,'work' )
         Call zcopy_( N*(N+1)/2,[(0.0_wp,0.0_wp)],0,   AP,1)
         Call zcopy_(     2*N-1,[(0.0_wp,0.0_wp)],0, work,1)
         Call zcopy_(       N*N,[(0.0_wp,0.0_wp)],0,   Z1,1)

         Call mma_allocate(rwork,(3*n-2)    ,'rwork')
         Call mma_allocate(w1   ,          n,'w1'   )
         Call dcopy_(     3*N-2,        [0.0_wp] ,0,rwork,1)
         Call dcopy_(         N,        [0.0_wp] ,0,   W1,1)

         Do j=1,n
            Do i=1,j
              ap(i+(j-1)*j/2)=matrix(i,j)
            End Do
         End Do
         ! diagonalize:
         Call zhpev_('v','u',n,ap,w1,z1,n,work,rwork,info)
         !save results:
         Call dcopy_(   N, W1,1, W,1)
         Call zcopy_( N*N, Z1,1, Z,1)

         Call mma_deallocate(rwork)
         Call mma_deallocate(w1)
         Call mma_deallocate(ap)
         Call mma_deallocate(work)
         Call mma_deallocate(z1)
      Else
         ! return dummy results:
         Do i=1,n
            w(i)  = 0.0_wp
            z(i,i)=(1.0_wp,0.0_wp)
         End Do
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!***********************************************************************

subroutine XFdGrd( &
#                 define _CALLING_
#                 include "grd_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of nuclear attraction     *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, May 1995                                *
!***********************************************************************

use external_centers, only: iXPolType, nOrd_XF, nXF, XF
use Center_Info, only: dc
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: i, iAlpha, iAnga(4), iBeta, iCar, iChxyz, iDAO, iDCRT(0:7), iDum, iFd, ii, iOrdOp, ipA, ipAOff, ipB, ipBOff, &
                     ipDAO, iPrint, iRout, iStb(0:7), iuvwx(4), iZeta, j, jCoSet(8,8), JndGrd(3,4), jpDAO, lDCRT, LmbdT, lOp(4), &
                     mGrad, mRys, nArray, nDAO, nDCRT, nDiff, nip, nStb, nT
real(kind=wp) :: C(3), CoorAC(3,2), Coori(3,4), Fact, TC(3), TZFd(3), ZFd(3)
logical(kind=iwp) :: JfGrad(3,4), NoLoop
character(len=3), parameter :: ChOper(0:7) = ['E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz']
integer(kind=iwp), external :: iChAtm, NrOpr
external :: Fake, TNAI1, XCff2D
#include "print.fh"

#include "macros.fh"
unused_var(rFinal)
unused_var(nHer)
unused_var(Ccoor(1))
unused_var(nOrdOp)
unused_var(nComp)

iRout = 151
iPrint = nPrint(iRout)

! Modify the density matrix with the prefactor

nDAO = nTri_Elem1(la)*nTri_Elem1(lb)
do iDAO=1,nDAO
  do iZeta=1,nZeta
    Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
    DAO(iZeta,iDAO) = Fact*DAO(iZeta,iDAO)
  end do
end do
if (iPrint >= 99) call RecPrt('DAO',' ',DAO,nZeta,nDAO)

! Loop over charges and dipole moments in the external field

if ((nOrd_XF > 1) .or. (iXPolType > 0)) then
  call WarningMessage(2,'Error in xfdgrd')
  write(u6,*) 'Sorry, gradients are not implemented for'
  write(u6,*) 'higher XF than dipoles or for polarisabilities'
  call Quit_OnUserError()
end if

do iOrdOp=0,nOrd_XF

  nip = 1
  ipA = nip
  nip = nip+nAlpha*nBeta
  ipB = nip
  nip = nip+nAlpha*nBeta
  ipDAO = nip
  nip = nip+nAlpha*nBeta*nTri_Elem1(la)*nTri_Elem1(lb)*nTri_Elem1(iOrdOp)
  if (nip-1 > nZeta*nArr) then
    call WarningMessage(2,'Error in xfdgrd')
    write(u6,*) 'nip-1 > nZeta*nArr'
    call Abend()
  end if
  nArray = nZeta*nArr-nip+1

  iAnga(1) = la
  iAnga(2) = lb
  iAnga(3) = iOrdOp
  iAnga(4) = 0
  Coori(:,1) = A(:)
  Coori(:,2) = RB(:)

  ! Find center to accumulate angular momentum on. (HRR)

  if (la >= lb) then
    CoorAC(:,1) = A(:)
  else
    CoorAC(:,1) = RB(:)
  end if
  iuvwx(1) = dc(mdc)%nStab
  iuvwx(2) = dc(ndc)%nStab
  lOp(1) = kOp(1)
  lOp(2) = kOp(2)

  ipAOff = ipA
  do iBeta=1,nBeta
    call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
    ipAOff = ipAOff+nAlpha
  end do

  ipBOff = ipB
  do iAlpha=1,nAlpha
    call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
    ipBOff = ipBOff+1
  end do

  ! Loop over centers of the external field.

  iDum = 0
  do iFd=1,nXF
    if (iOrdOp == 0) then
      ZFd(1) = XF(4,iFd)
      NoLoop = ZFd(1) == Zero
    else
      ZFd(1:3) = XF(5:7,iFd)
      NoLoop = (ZFd(1) == Zero) .and. (ZFd(2) == Zero) .and. (ZFd(3) == Zero)
    end if
    if (NoLoop) cycle
    ! Pick up the center coordinates
    C(1:3) = XF(1:3,iFd)

    if (iPrint >= 99) call RecPrt('C',' ',C,1,3)

    ! Generate stabilizer of C

    iChxyz = iChAtm(C)
    call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)

    ! Find the DCR for M and S

    call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
    Fact = -real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    if (iPrint >= 99) then
      write(u6,*) ' ZFd=',(ZFd(i),i=1,nTri_Elem1(iOrdOp))
      write(u6,*) ' Fact=',Fact
      call RecPrt('DAO*Fact*ZFd()',' ',Array(ipDAO),nZeta*nDAO,nTri_Elem1(iOrdOp))
      write(u6,*) ' m      =',nStabM
      write(u6,'(9A)') '(M)=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
      write(u6,*) ' s      =',nStb
      write(u6,'(9A)') '(S)=',(ChOper(iStb(ii)),ii=0,nStb-1)
      write(u6,*) ' LambdaT=',LmbdT
      write(u6,*) ' t      =',nDCRT
      write(u6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),ii=0,nDCRT-1)
    end if
    iuvwx(3) = nStb
    iuvwx(4) = nStb
    JndGrd(:,1:2) = IndGrd(:,:)
    do i=1,3
      do j=1,2
        JfGrad(i,j) = IfGrad(i,j)
      end do
    end do

    ! No derivatives with respect to the third or fourth center.
    ! The positions of the points in the external field are frozen.

    JndGrd(:,3) = 0
    JfGrad(1,3) = .false.
    JfGrad(2,3) = .false.
    JfGrad(3,3) = .false.
    JndGrd(:,4) = 0
    JfGrad(1,4) = .false.
    JfGrad(2,4) = .false.
    JfGrad(3,4) = .false.
    mGrad = 0
    do iCar=1,3
      do i=1,2
        if (JfGrad(iCar,i)) mGrad = mGrad+1
      end do
    end do
    if (iPrint >= 99) write(u6,*) ' mGrad=',mGrad
    if (mGrad == 0) cycle

    do lDCRT=0,nDCRT-1
      lOp(3) = NrOpr(iDCRT(lDCRT))
      lOp(4) = lOp(3)
      call OA(iDCRT(lDCRT),C,TC)
      CoorAC(:,2) = TC(:)
      Coori(:,3) = TC(:)
      Coori(:,4) = TC(:)

      if (iOrdOp == 0) then
        Array(ipDAO:ipDAO+nZeta*nDAO-1) = Fact*ZFd(1)*pack(DAO,.true.)
      else
        call OA(iDCRT(lDCRT),ZFd,TZFd)
        jpDAO = ipDAO
        Array(jpDAO:jpDAO+nZeta*nDAO-1) = Fact*TZFd(1)*pack(DAO,.true.)
        jpDAO = jpDAO+nZeta*nDAO
        Array(jpDAO:jpDAO+nZeta*nDAO-1) = Fact*TZFd(2)*pack(DAO,.true.)
        jpDAO = jpDAO+nZeta*nDAO
        Array(jpDAO:jpDAO+nZeta*nDAO-1) = Fact*TZFd(3)*pack(DAO,.true.)
      end if

      ! Compute integrals with the Rys quadrature.

      nT = nZeta
      nDiff = 1
      mRys = (la+lb+2+nDiff+iOrdOp)/2
      call Rysg1(iAnga,mRys,nT,Array(ipA),Array(ipB),[One],[One],Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,Coori,Coori,CoorAC, &
                 Array(nip),nArray,TNAI1,Fake,XCff2D,Array(ipDAO),nDAO*nTri_Elem1(iOrdOp),Grad,nGrad,JfGrad,JndGrd,lOp,iuvwx)

      !call RecPrt(' In XFdGrd:Grad',' ',Grad,nGrad,1)
    end do ! End loop over DCRs

  end do   ! End loop over centers in the external field

end do     ! End loop over charges and dipole moments

return

end subroutine XFdGrd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SetPrLev(IPRGLB_IN,IPRLOC_IN)

use PrintLevel, only: DEBUG, SILENT, USUAL
use output_ras, only: IPRGLB, IPRLOC
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IPRGLB_IN, IPRLOC_IN(7)
integer(kind=iwp) :: I
logical(kind=iwp), external :: REDUCE_PRT

! The local print levels are the maximum of the requested global and
! local ones, except that if any of IPRGLB or IPRLOC(I) is zero
! (meaning silence), then IPRLOC(I) is set to zero.
IPRGLB = IPRGLB_IN
IPRLOC(:) = 0
if (IPRGLB_IN /= 0) then
  do I=1,7
    if (IPRLOC_IN(I) > 0) IPRLOC(I) = max(IPRGLB_IN,IPRLOC_IN(I))
  end do
end if
! If inside an optimization loop, set down the print
! level unless we *really* want a lot of output.
if (REDUCE_PRT()) then
  IPRGLB = max(IPRGLB-USUAL,SILENT)
  IPRLOC(:) = max(IPRLOC(:)-USUAL,SILENT)
end if

if (IPRLOC(1) >= DEBUG) then
  write(u6,*) ' SetPrLev: Print levels have been set to'
  write(u6,*) '  Global print level IPRGLB=',IPRGLB
  write(u6,*) '  Individual sections print levels, IPRLOC:'
  write(u6,'(1x,7I5)') (IPRLOC(I),I=1,7)
end if

end subroutine SetPrLev

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PolPrep(Dist,DistIm,xx,yy,zz,rr3,xxi,yyi,zzi,Gri,iCNum,nSize)

use qmstat_global, only: CordIm, Cordst, nCent, nPart, nPol
use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iCNum, nSize
real(kind=wp), intent(in) :: Dist(nCent,nCent,nTri_Elem(nPart-iCNum-1)), DistIm(nCent,nPart-iCNum,nCent,nPart-iCNum)
real(kind=wp), intent(out) :: xx(nSize,nSize), yy(nSize,nSize), zz(nSize,nSize), rr3(nSize,nSize), xxi(nSize,nSize), &
                              yyi(nSize,nSize), zzi(nSize,nSize), Gri(nSize,nSize)
integer(kind=iwp) :: i, i1, ild, imd, Indco1, IndCo2, Indp1, IndP2, IndTr, IndTr1, IndTri, j, j1, jnd, k, l, ncParm

!----------------------------------------------------------------------*
! Simply compute some vectors etc. for the ensuing polarization        *
! calculation.                                                         *
!----------------------------------------------------------------------*
ncParm = nCent*nPart-nCent*icNum
! Loop over solvent polarization sites.
rr3(nPol*iCNum+1:,nPol*iCNum+1:) = Zero
IndTr1 = 0
! If (iCNum+1) == nPart this loop will not be run, but that is
! okey since then we only have one solvent and thus it can not
! experience any field from other solvent molecules.
do i=1,nPol
  Indp1 = i+iCnum*nPol
  Indco1 = i+iCNum*nCent
  do j=iCnum+2,nPart
    IndP1 = IndP1+nPol
    IndCo1 = IndCo1+nCent
    IndTr = nTri_Elem(j-(iCnum+2))
    do k=1,nPol
      IndP2 = k+(iCnum-1)*nPol
      IndCo2 = k+(iCNum-1)*nCent
      do l=iCnum+1,j-1
        IndTr1 = Indtr1+1
        Indp2 = Indp2+nPol
        Indco2 = Indco2+nCent
        IndTri = IndTr+l-iCnum
        xx(Indp1,Indp2) = (Cordst(1,indco1)-Cordst(1,indco2))*Dist(k,i,IndTri)
        yy(Indp1,Indp2) = (Cordst(2,indco1)-Cordst(2,indco2))*Dist(k,i,IndTri)
        zz(Indp1,Indp2) = (Cordst(3,indco1)-Cordst(3,indco2))*Dist(k,i,IndTri)
        rr3(IndP1,IndP2) = Dist(k,i,IndTri)**3
        ! Why should xx(indp2,indp1)=xx(indp1,indp2), you wonder, should
        ! they not be of different sign? The answer is, it does not
        ! matter. Recall that the formula for the field from an ideal
        ! dipole changes sign twice, thus no time in effect, when
        ! the sign of the r-vector is changed.
        xx(Indp2,Indp1) = xx(Indp1,Indp2)
        yy(Indp2,Indp1) = yy(Indp1,Indp2)
        zz(Indp2,Indp1) = zz(Indp1,Indp2)
        rr3(Indp2,Indp1) = rr3(Indp1,Indp2)
      end do
    end do
  end do
end do
Gri(:,:) = Zero
do i=1,nPol
  k = i+(iCnum-1)*nCent
  do i1=iCnum+1,nPart
    k = k+nCent
    imd = (i1-1)*nPol+i
    do j=1,nPol
      l = j+(iCnum-1)*nCent
      jnd = ((i1-(iCnum+1))*nCent+i-1)*ncparm+j-nCent
      do j1=iCnum+1,nPart
        l = l+nCent
        ild = (j1-1)*nPol+j
        jnd = jnd+nCent
        Gri(imd,ild) = DistIm(j,j1-iCnum,i,i1-iCnum)
        xxi(imd,ild) = (Cordim(1,k)-Cordst(1,l))*DistIm(j,j1-iCnum,i,i1-iCnum)
        yyi(imd,ild) = (Cordim(2,k)-Cordst(2,l))*DistIm(j,j1-iCnum,i,i1-iCnum)
        zzi(imd,ild) = (Cordim(3,k)-Cordst(3,l))*DistIm(j,j1-iCnum,i,i1-iCnum)
      end do
    end do
  end do
end do

return

end subroutine PolPrep

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Giovanni Ghigo                                   *
!***********************************************************************
!  Cho_TraCtl
!
!> @brief
!>   Driver for the generation of the two-electrons integrals file (``MOLINT``) from the AO-based Cholesky Full Vectors
!> @author Giovanni Ghigo
!>
!> @details
!> All programs that need the generation of the two-electrons
!> integrals file in MO basis must tell to the Cholesky routine
!> who they are through \p iTraType:
!>
!> - ``1``: MBPT2
!> - ``2``: CASPT2
!> - ``3``: MCLR
!> - ``4``: CC
!>
!> The AO-based Cholesky Full Vectors (CHFV) are first transformed
!> in a new set of MO-based Transformed Cholesky Full Vectors
!> (TCVx) then the two-electrons integrals files (``MOLINT``) is
!> generated. The integrals in the file (``MOLINT``) are differently
!> ordered but addresses can be read from ``IAD2M`` as usual.
!>
!> The main loop runs over all the symmetries \c iSymL and for each
!> \f$ \text{CHFV}_{pq} \f$ (\f$ p,q \f$ are AO indices) the following MO-based
!> Transformed Cholesky Full Vectors (TCVx) can be generated:
!>
!> 1. TCVA: \f$ L_{ij}, L_{ji} \f$ if \c Sym(p) &ne; \c Sym(q)
!> 2. TCVB: \f$ L_{tj}, L_{ui} \f$ if \c Sym(p) &ne; \c Sym(q)
!> 3. TCVC: \f$ L_{aj}, L_{bi} \f$ if \c Sym(p) &ne; \c Sym(q)
!> 4. TCVD: \f$ L_{tu}, L_{ut} \f$ if \c Sym(p) &ne; \c Sym(q)
!> 5. TCVE: \f$ L_{au}, L_{bt} \f$ if \c Sym(p) &ne; \c Sym(q)
!> 6. TCVF: \f$ L_{ab} \f$  Only if \c DoFull = ``.True.`` (Not implemented yet!)
!>
!> MO Indices \f$ i,j \f$: Inactive; \f$ t,u \f$: Active; \f$ a,b \f$: Secondary
!>
!> Which TCVx have to be generated is defined in the logical array
!> \c TCVXist by the routine ::Mem_Est and the memory is managed through
!> the array \c TCVX of 2D allocatable matrices.
!>
!> Note that when \c Sym(p) &ne; \c Sym(q) the order of symmetry is
!> exchanged while the first index is always the MO we excite into
!> and the second index is always the MO we excite out.
!>
!> TCV type ``A`` and ``D``, \f$ L_{ji} \f$, and \f$ L_{ut} \f$, are not really generated
!> because they are just the transposed \f$ L_{ij} \f$ and \f$ L_{tu} \f$.
!> However, they are stored in memory.
!>
!> The main loop for the generation of the integrals (``MOLINT``) is
!> based on the total symmetry of the MO-based TCVx and for each
!> symmetry, a batch procedure is performed (\c nBatch). Within this
!> batch cycle, the TCVx are generated by ::Cho_TraS and ::Cho_TraA
!> depending if \c Sym(p) = \c Sym(q). In both these routines, a second
!> inner-batch procedure (\c nFBatch) is established reading the Full
!> Vectors and tranforming them in the TCVx.
!> Both the number of vectors
!> transformed in the two batch procedure are defined in ::Mem_Est
!> (\c nVec for \c nBatch and \c nFVec for \c nFBatch).
!>
!> The MO-based two-electron integrals generation is performed by
!> ::Cho_TwoEl. The integrals are \f$ (p,k|q,l) \f$ where \f$ p,q \f$: All MO; \f$ k,l \f$:
!> Occupied.
!> For MBPT2 integrals where \f$ p,q \f$ are occupied are not generated and
!> suitable routines called by ::ChoMP2_TraCtl are used.
!> For CC all \f$ p,q,k,l \f$ are all MO (not implemented yet).
!>
!> @note
!> The number of frozen and deleted MO used in the post-CASSFC/SCF
!> must be written in the RunFile in \c nFroPT and \c nDelPT arrays.
!>
!> @param[in] iTraType Caller program (see description)
!> @param[in] LUINTM   Unit number of two-electrons integrals file (``MOLINT``)
!> @param[in] CMO      MO coefficients
!> @param[in] NCMO     Total number of MO coefficients
!> @param[in] DoExch2  Flag for the generation of Exch-2 integrals
!***********************************************************************

subroutine Cho_TraCtl(iTraType,LUINTM,CMO,NCMO,DoExch2)
!***********************************************************************
! Author :  Giovanni Ghigo                                             *
!           Lund University, Sweden                                    *
!           October 2004                                               *
!----------------------------------------------------------------------*
! This is the routine for the transformation from AO basis to MO basis *
! of the Cholesky Full Vectors & Two-electrons integral generation.    *
! Reads the Cholesky Full Vectors (CHFV), generate new Transformed     *
! Cholesky Full Vectors (TCVx) then generate the Two-electrons inte-   *
! gral file (MOLINT).                                                  *
!  <p,q|k,l>  where p,q: All MO; k,l: Occupied                         *
! If DoFull=.True also <p,q|r,s> where p,q,r,s: All MO (for CC)        *
!***********************************************************************

use Cho_Tra, only: DoCoul, DoExc2, DoFull, DoTCVA, IAD2M, IfTest, nAsh, nBas, nDel, nFro, nIsh, nOrb, nOsh, nSsh, nSym, NumCho, &
                   TCVX, TCVXist
use Symmetry_Info, only: Mul
use stdalloc, only: mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iTraType, LUINTM, NCMO
real(kind=wp), intent(in) :: CMO(NCMO)
logical(kind=iwp), intent(in) :: DoExch2
integer(kind=iwp) :: i, iAddrIAD2M, iBatch, IPRX, irc, iStrtVec_AB, iSym, iSymA, iSymAI, iSymB, iSymBJ, iSymI, iSymJ, iSymL, &
                     iType, j, jSym, k, LenIAD2M, lUCHFV, nBasT, nBatch, nData, nFVec, NumV, nVec
real(kind=wp) :: CPE, CPU0, CPU1, CPU2, CPU3, CPU4, CPU_Gen, CPU_Tot, CPU_Tra, tcpu_reo, TCR1, TCR2, TIO0, TIO1, TIO2, TIO3, TIO4, &
                 TIO_Gen, TIO_Tot, TIO_Tra, TIOE, TWR1, TWR2
logical(kind=iwp) :: Found
character(len=6) :: CHName
character(len=4), parameter :: CHNm = 'CHFV'

!-----------------------------------------------------------------------
IfTest = .false.
!IfTest = .true.
!DoExch2 = .true.
!-----------------------------------------------------------------------

call Timing(CPU0,CPE,TIO0,TIOE)

!**** INITIALIZATION ***************************************************

call CWTIME(TCR1,TWR1)
call Cho_X_init(irc,Zero)
if (irc /= 0) then
  write(u6,*) ' In Cho_TraCtl: Cho_X_Init returned non-zero rc = ',irc
  call Abend()
end if
call Cho_X_ReoVec(irc) ! get (if not there) CD vects in full stor
if (irc /= 0) then
  write(u6,*) ' In Cho_TraCtl: Cho_X_ReoVec returned non-zero rc = ',irc
  call Abend()
end if
call Cho_X_final(irc)
call CWTIME(TCR2,TWR2)
tcpu_reo = (TCR2-TCR1)
write(u6,*) ' Reordering of the Cholesky vectors to full storage. '
write(u6,*) ' Elapsed time for the reordering section: ',tcpu_reo
write(u6,*) ' CPU time for the reordering section: ',tcpu_reo
write(u6,*)

! Define what has to be calculated.
!  DoExc2 flag for the generation of Exch-2 integrals
!  DoTCVA flag for the generation of TCVA
!  DoFull flag for the generation of TCVF
!  DoCoul flag for the generation of coulomb integrals

DoExc2 = DoExch2

! MBPT2
if (iTraType == 1) then
  DoTCVA = .false.
  DoFull = .false.
  DoCoul = .false.
end if

! CASPT2
if (iTraType == 2) then
  DoTCVA = .true.
  DoFull = .false.
  DoCoul = .true.
end if

! MCLR
if (iTraType == 3) then
  DoTCVA = .true.
  DoFull = .false.
  DoCoul = .true.
end if

! CC
if (iTraType == 4) then
  DoTCVA = .true.
  DoFull = .true.
  DoCoul = .true.
end if

! If Tra is not recognized it is assumed is CASPT2 type.
if (iTraType >= 5) then
  DoTCVA = .true.
  DoFull = .false.
  DoCoul = .true.
end if

! Get Informations from RunFile.
!  The following informations must be passed to the Cholesky
!  transformation routine through RunFile. COMMON blocks could
!  not be used due to several conflicts.
call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
call Get_iArray('nFroPT',nFro,nSym)
call Get_iArray('nDelPT',nDel,nSym)
call Get_iArray('nIsh',nIsh,nSym)
! PAM 2007 call Get_iArray('nAsh',nAsh,nSym)
! Replaced by:
do i=1,nSym
  nAsh(i) = 0
end do
call qpg_iArray('nAsh',Found,nData)
if (Found .and. (nData == nSym)) then
  call Get_iArray('nAsh',nAsh,nSym)
end if
! End of replacement
call Get_NVnode(NumCho)
nBasT = 0
do i=1,nSym
  nBasT = nBasT+nBas(i)
  nOrb(i) = nBas(i)-nFro(i)-nDel(i)
  nOsh(i) = nIsh(i)+nAsh(i)
  nSsh(i) = nOrb(i)-nOsh(i)
end do

! Initialize information arrays.

TCVXist(:,:,:) = .false. ! TCVx existing flag.

! The Address Field for MOLINT:
LenIAD2M = 3*36*36
do i=1,36*36
  IAD2M(1,i) = 0
  IAD2M(2,i) = 0
  IAD2M(3,i) = 0
end do
iAddrIAD2M = 0
call iDaFile(LUINTM,1,IAD2M,LenIAD2M,iAddrIAD2M)

! The Timing:
CPU_Tra = Zero
TIO_Tra = Zero
CPU_Gen = Zero
TIO_Gen = Zero

!-----------------------------------------------------------------------
if (IfTest) then
  write(u6,*)
  write(u6,'(A,8I5)') '           Symmetries :',(i,i=1,nSym)
  write(u6,*)
  write(u6,'(A,8I5)') '               Frozen :',(nFro(i),i=1,nSym)
  write(u6,'(A,8I5)') '         Inactive (I) :',(nIsh(i),i=1,nSym)
  write(u6,'(A,8I5)') '           Active (A) :',(nAsh(i),i=1,nSym)
  write(u6,'(A,8I5)') '        Secondary (S) :',(nSsh(i),i=1,nSym)
  write(u6,'(A,8I5)') '              Deleted :',(nDel(i),i=1,nSym)
  write(u6,*)
  write(u6,'(A,8I5)') '      Total correlated:',(nOrb(i),i=1,nSym)
  write(u6,*)
  call XFlush(u6)
end if
!-----------------------------------------------------------------------

!**** START LOOP iSymL on TOTAL SYMMETRY of L (iSym * jSym) ************
do iSymL=1,nSym

  TCVXist(:,:,:) = .false. ! TCVx existing flag.
  call Mem_Est(iSymL,nVec,nFVec)
  !---------------------------------------------------------------------
  if (IfTest) then
    write(u6,*)
    write(u6,*) ' TCVx generated in Symmetry',iSymL
    do i=1,nSym
      do j=1,nSym
        do k=1,6
          if (TCVXist(k,i,j)) write(u6,*) ' Type=',k,' Symmetries:',i,j
        end do
      end do
    end do
    call XFlush(u6)
  end if
  !---------------------------------------------------------------------
  if ((nVec <= 0) .or. (nFVec <= 0)) then
    write(u6,*)
    write(u6,*) ' ************************************'
    write(u6,*) ' *  Insufficient memory for batch ! *'
    write(u6,*) ' ************************************'
    write(u6,*)
    call XFlush(u6)
    call Abend()
  end if
  nBatch = (NumCho(iSymL)-1)/nVec+1

  ! START LOOP iBatch
  do iBatch=1,nBatch

    if (iBatch == nBatch) then
      NumV = NumCho(iSymL)-nVec*(nBatch-1)
    else
      NumV = nVec
    end if
    !-------------------------------------------------------------------
    !if (IfTest) then
    !  nFBatch = (NumV-1) / nFVec + 1
    !  write(u6,*)
    !  write(u6,*)' iBatch=',iBatch,' of',nBatch,' - NumV=',NumV,' - nFBatch=',nFBatch
    !  call XFlush(u6)
    !end if
    !-------------------------------------------------------------------

    ! Start Transformation of Cholesy Vectors  CHFV -> TCVx
    call Timing(CPU1,CPE,TIO1,TIOE)

    ! Start Loop on CHFV-iSym-jSym
    do iSym=1,nSym
      lUCHFV = -1
      if (nBas(iSym) > 0) then
        do jSym=1,iSym
          lUCHFV = -1
          if ((nBas(jSym) > 0) .and. (Mul(iSym,jSym) == iSymL)) then
            lUCHFV = 7
            iStrtVec_AB = nVec*(iBatch-1)+1
            write(CHName,'(A4,I1,I1)') CHNm,iSym,jSym
            call dAName_MF_WA(lUCHFV,CHName)
            !-----------------------------------------------------------
            !if (IfTest) then
            !  write(u6,*) ' - Open ',CHName,' unit=',lUCHFV,' Vect=',iStrtVec_AB
            !  call XFlush(u6)
            !end if
            !-----------------------------------------------------------

            if (iSym == jSym) then
              call Cho_TraS(iSym,jSym,NumV,CMO,NCMO,lUCHFV,iStrtVec_AB,nFVec)
            else
              call Cho_TraA(iSym,jSym,NumV,CMO,NCMO,lUCHFV,iStrtVec_AB,nFVec)
            end if

            call dAClos(lUCHFV)
            !-----------------------------------------------------------
            !if (IfTest) then
            !  write(u6,*) ' - Closed ',CHName
            !  call XFlush(u6)
            !end if
            !-----------------------------------------------------------
          end if
        end do
      end if
    end do
    ! End Loop on CHFV-iSym-jSym

    call Timing(CPU2,CPE,TIO2,TIOE)
    CPU_Tra = CPU_Tra+CPU2-CPU1
    TIO_Tra = TIO_Tra+TIO2-TIO1
    ! End Transformation of Cholesky Vectors  CHFV -> TCVx

    ! Start Generation of Integrals files  TCVx -> MOLINT
    !-------------------------------------------------------------------
    if (IfTest) then
      write(u6,*) ' - Generation of Integrals:'
      call XFlush(u6)
    end if
    !-------------------------------------------------------------------

    ! Start Loop on I, J, A, B Symmetries
    do iSymI=1,nSym
      do iSymJ=1,iSymI
        do iSymA=1,nSym
          do iSymB=1,nSym
            iSymAI = Mul(iSymA,iSymI)
            iSymBJ = Mul(iSymB,iSymJ)

            if ((iSymAI == iSymL) .and. (iSymBJ == iSymL)) call Cho_TwoEl(iBatch,NumV,LUINTM,iAddrIAD2M,iSymI,iSymJ,iSymA,iSymB)

          end do
        end do
      end do
    end do
    ! End Loop on I, J, A, B Symmetries

    do iType=1,size(TCVX,1)
      do iSym=1,size(TCVX,2)
        do jSym=1,size(TCVX,3)

          if (allocated(TCVX(iType,iSym,jSym)%A)) call mma_deallocate(TCVX(iType,iSym,jSym)%A)

        end do
      end do
    end do

    call Timing(CPU3,CPE,TIO3,TIOE)
    CPU_Gen = CPU_Gen+CPU3-CPU2
    TIO_Gen = TIO_Gen+TIO3-TIO2
    ! End Generation of Two-Electrons Integrals files

  end do
  ! END LOOP iBatchD -----------------------------------------------

end do
!**** END MAIN LOOP iSymL on TOTAL SYMMETRY of L (iSym * jSym) *********

iAddrIAD2M = 0
call iDaFile(LUINTM,1,IAD2M,LenIAD2M,iAddrIAD2M)

write(u6,*) 'TIMING INFORMATION:   CPU(s)   %CPU   Elapsed(s)'
write(u6,'(A,F9.2,1X,F6.1,1X,F12.2)') ' Transformation     ',CPU_Tra,1.0e2_wp*CPU_Tra/max(One,TIO_Tra),TIO_Tra
write(u6,'(A,F9.2,1X,F6.1,1X,F12.2)') ' Generation         ',CPU_Gen,1.0e2_wp*CPU_Gen/max(One,TIO_Gen),TIO_Gen
call Timing(CPU4,CPE,TIO4,TIOE)
CPU_Tot = CPU4-CPU0
TIO_Tot = TIO4-TIO0
write(u6,'(A,F9.2,1X,F6.1,1X,F12.2)') ' TOTAL              ',CPU_Tot,1.0e2_wp*CPU_Tot/max(One,TIO_Tot),TIO_Tot
write(u6,*)
call XFlush(u6)
!-----------------------------------------------------------------------
if (IfTest) then
  !IPRX=0    ! Do not print Coulomb nor Exchange Integrals
  IPRX = 1  ! Print only Coulomb Integrals
  !IPRX=2    ! Print all Integrals
  !IPRX=3    ! Print only Exchange Integrals
  call RdInt2(IPRX,DoTCVA)
end if
!-----------------------------------------------------------------------

call put_tra_comm(IAD2M,NSYM,NORB,NOSH,LUINTM)

return

end subroutine Cho_TraCtl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Read_Multipole_Int(lMax,ip_sq_mu,nBas,ip_mu,Ttot,Temp,
     &                              Origin,rMPq,nElem,nBas1,nBas2,
     &                           nBasMax,nTemp,nSym,ipP,Restart,Utility)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Real*8 Temp(nTemp), Ttot(nBas2), Origin(3,0:lMax),
     &       rMPq(0:nElem-1)
      Integer ip_mu(0:nElem-1), ip_sq_mu(0:nElem-1), nBas(0:nSym-1)
      Character*8 Label
      Character*16 RunFile_dLabel, RunFile_iLabel, RunFile_iLabel2
      Logical Restart, Found, Utility
      Dimension idum(1)
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*     Note that we will store two sets of the integrals.
*
*     Set 1: used to compute the localized properties.
*     Set 2: used in the finite differenc calculation of the
*            polarizability.
*
*     Set 1 will be desymmetrized in case of symmetry.
*
*     Pointers to Set 1 are stored in ip_sq_mu.
*     Pointers to Set 2 are stored in ip_mu.
*
      RunFile_dLabel  = 'LoProp Integrals'
      RunFile_iLabel  = 'LoProp nInts'
      RunFile_iLabel2 = 'LoProp iSyLbl'
      nInts_Tot = 0
      Call Allocate_iWork(ip_nComp,nElem)
      Call Allocate_iWork(ip_iSyLbl,nElem)
      If (Restart) Then
         Call Qpg_dArray(RunFile_dLabel,Found,nInts_tot)
         If (.Not. Found) Then
            Write(6,*) 'LoProp Integrals not available on the RunFile.'
            Call Abend()
         End If
         Call Allocate_Work(ip_all_ints,nInts_Tot)
         Call Get_dArray(RunFile_dLabel,Work(ip_all_ints),nInts_tot)
         Call Get_iArray(RunFile_iLabel,iWork(ip_nComp),nElem)
         Call Get_iArray(RunFile_iLabel2,iWork(ip_iSyLbl),nElem)
      End If
      nInts=0
      iOpt0=0
      iOpt1=1
      Label='Mltpl  X'
      mu = -1
      iOff = 0
      Do l = 0, lMax
         nComp = (l+1)*(l+2)/2
         Write (Label(8:8),'(I1)') l
         Do iComp = 1, nComp
#ifdef _DEBUGPRINT_
            Write (6,*) 'l,iComp=',l,iComp
#endif
            mu = mu + 1
            If (Restart) Then
               Call Allocate_Work(ip_mu(mu),iWork(ip_nComp+mu))
               nInts = iWork(ip_nComp+mu) - 4
               Call dCopy_(iWork(ip_nComp+mu),Work(ip_all_ints+iOff),1,
     &                                       Work(ip_mu(mu)),1)
               iSyLbl = iWork(ip_iSyLbl+mu)
               iOff = iOff + iWork(ip_nComp+mu)
            Else
               iRc=-1
               iSyLbl=0
               Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
               If ( iRc.ne.0 ) Then
                  Write (6,*) 'Polar: error reading length of mu!'
                  Write (6,*) 'Mu=',mu
                  Call Abend()
               End If
               nInts=idum(1)
               Call Allocate_Work(ip_mu(mu),nInts+4)
               Call RdOne(iRc,iOpt0,Label,iComp,Work(ip_mu(mu)),iSyLbl)
               If ( iRc.ne.0 ) Then
                  Write (6,*) 'Polar: error reading mu!'
                  Write (6,*) 'Mu=',mu
                  Call Abend()
               End If
               iWork(ip_iSyLbl+mu) = iSyLbl
               iWork(ip_nComp+mu)  = nInts+4
               nInts_Tot = nInts_Tot + iWork(ip_nComp+mu)
            End If
*
*           Transform multipole moment integrals to new basis
*
            Call Allocate_Work(ip_Tmp,nBas1**2)
            Call Fzero(Work(ip_Tmp),nBas1**2)
            If (nSym.eq.1) Then
               ip_sq_mu(mu) = ip_Tmp
            Else
               Call GetMem('SMatrix','Allo','Real',ip_sq_mu(mu),
     &                     nBas1**2)
            End If
*
*           Now I square the dipole moment integral matrix because it
*           has been stored as a low triangle
*
            iOfft = ip_mu(mu)
            iOffs = ip_Tmp
            Do iSym = 0, nSym-1
               Do jSym = 0, iSym
                  ijSym=iEor(iSym,jSym)
                  If (iAnd(iSyLbl,2**ijSym).eq.0) Then
                     Go To 20
                  End If
                  If (nBas(iSym)*nBas(jSym).eq.0) Then
                     Go To 20
                  End If
                  If (iSym.eq.jSym) Then
*
*                    Now I square the overlap matrix because it has been
*                    stored as a lower triangle
*
                     Call Square(Work(iOfft),Work(iOffs),1,nBas(iSym),
     &                           nBas(iSym))
*
                     iOfft = iOfft + nBas(iSym)*(nBas(iSym)+1)/2
                  Else
                     call dcopy_(nBas(iSym)*nBas(jSym),Work(iOfft),1,
     &                                                Work(iOffs),1)
                     iOfft = iOfft + nBas(iSym)*nBas(jSym)
                  End If
                  iOffs = iOffs + nBas(iSym)*nBas(jSym)
 20               Continue
               End Do
            End Do
*
            If (nSym.ne.1) Then
*
*------------- Desymmetrize
*
               nScr=nBasMax*nBas1
               Call Allocate_Work(ipScr,nScr)
               Call FZero(Work(ip_sq_mu(mu)),nBas1**2)
               Call Desymmetrize(Work(ip_Tmp),nBas2,Work(ipScr),nScr,
     &                           Work(ip_sq_mu(mu)),nBas,nBas1,
     &                           Work(ipP),nSym,iSyLbl)
               Call Free_Work(ipScr)
               Call Free_Work(ip_Tmp)
*
            End If
*
*           Now I transform with my Transformation Matrix Ttot the
*           multipole moment integral matrices
*
#ifdef _DEBUGPRINT_
            Call RecPrt('Multipole Integrals in AO Basis',' ',
     &                  Work(ip_sq_mu(mu)),nBas1,nBas1)
#endif
            Call TransMu(Work(ip_sq_mu(mu)),nBas1,Ttot,Temp)
#ifdef _DEBUGPRINT_
            Call RecPrt('Multipole Integrals in LoProp Basis',' ',
     &                  Work(ip_sq_mu(mu)),nBas1,nBas1)
#endif
*
*           Pick up the nuclear value for this operator
*
            rMPq(mu)=Work(ip_mu(mu)+nInts+3)
         End Do
*
*        Pick up the origin of this operator
*
         call dcopy_(3,Work(ip_mu(mu)+nInts),1,Origin(1,l),1)
*
      End Do
      If ((.Not. Restart) .AND. (.Not. Utility)) Then
         Call Allocate_Work(ip_all_ints,nInts_Tot)
         mu = -1
         iOff = 0
         Do l = 0, lMax
            nComp = (l+1)*(l+2)/2
            Do iComp = 1, nComp
               mu = mu + 1
               Call dCopy_(iWork(ip_nComp+mu),Work(ip_mu(mu)),1,
     &                                       Work(ip_all_ints+iOff),1)
               iOff = iOff + iWork(ip_nComp+mu)
            End Do
         End Do
         Call Put_dArray(RunFile_dLabel,Work(ip_all_ints),nInts_Tot)
         Call Put_iArray(RunFile_iLabel,iWork(ip_nComp),nElem)
         Call Put_iArray(RunFile_iLabel2,iWork(ip_iSyLbl),nElem)
      End If
      If (.Not. Utility) Then
         Call Free_Work(ip_all_ints)
      End If
      Call Free_iWork(ip_nComp)
      Call Free_iWork(ip_iSyLbl)
#ifdef _DEBUGPRINT_
      Call RecPrt('Origin',' ',Origin,3,lMax+1)
      Call RecPrt('rMPq',' ',rMPq,1,nElem)
      Call xSpot('Exit  Read_Multipole_Int')
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ZNELFSPGP()
! Generate for each supergroup the number of electrons in each active
! orbital space and store in NELFSPGP
!
! Jeppe Olsen, July 1995

use lucia_data, only: IBSPGPFTP, ISPGPFTP, NELFGP, NELFSPGP, NGAS, NSPGPFTP, NSTTP
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use lucia_data, only: MXPNGAS
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IBSPGP, IGAS, ISPGP, ITP, NSPGP

do ITP=1,NSTTP
  NSPGP = NSPGPFTP(ITP)
  IBSPGP = IBSPGPFTP(ITP)
  do ISPGP=IBSPGP,IBSPGP+NSPGP-1
    do IGAS=1,NGAS
      NELFSPGP(IGAS,ISPGP) = NELFGP(ISPGPFTP(IGAS,ISPGP))
    end do
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Distribution of electrons in Active spaces'
do ITP=1,NSTTP
  write(u6,*) ' String type ',ITP
  write(u6,*) ' Row : active space, Column: supergroup'
  NSPGP = NSPGPFTP(ITP)
  IBSPGP = IBSPGPFTP(ITP)
  call IWRTMA(NELFSPGP(1,IBSPGP),NGAS,NSPGP,MXPNGAS,NSPGP)
end do
#endif

end subroutine ZNELFSPGP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine getIphInfo(JOBIPH,nconf,LROOTS,IADR15)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: JOBIPH, IADR15(15)
integer(kind=iwp), intent(out) :: nconf, LROOTS
#include "rasdim.fh"
integer(kind=iwp) :: IAD15, NACTEL, ISPIN, NSYM, LSYM, NROOTS, NHOLE1, NELEC3, IPT2
integer(kind=iwp) :: nFro(MxSym), nISh(MxSym), nASh(MxSym), nDel(MxSym), nBas(MxSym), iRoot(MxRoot), nRS1(MxSym), nRS2(MxSym), &
                     nRS3(MxSym)
character(len=LenIn8) :: AtName(MxOrb), Title(18,MxTit)
character(len=2) :: Header(72)
real(kind=wp) :: POTNUC, Weight(MxRoot)

IAD15 = IADR15(1)
call WR_RASSCF_Info(JOBIPH,2,IAD15,NACTEL,ISPIN,NSYM,LSYM,NFRO,NISH,NASH,NDEL,NBAS,MxSym,AtName,LENIN8*mxOrb,NCONF,HEADER,2*72, &
                    TITLE,4*18*mxTit,POTNUC,LROOTS,NROOTS,IROOT,MxRoot,NRS1,NRS2,NRS3,NHOLE1,NELEC3,IPT2,WEIGHT)

return

end subroutine getIphInfo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Density_Matrix_mpprop(ip_D,nDens,nBas,nSym)

      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Integer nBas(nSym)

      If (nSym.eq.1) Then
         nDens=nBas(1)*(nBas(1)+1)/2
         Call GetMem('D1ao','Allo','Real',ip_D,nDens)
         Call Get_D1ao(Work(ip_D),nDens)
#ifdef _DEBUGPRINT_
         Call RecPrt('D',' ',Work(ip_D),1,nDens)
#endif
      Else
         Write(6,*) 'MpProp cannot handle symmetry'
         Call Abend()
      EndIf

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(nBas)
      End
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This program tests the runfile utilities.                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
* Written: July 2003                                                   *
*          Lund University, Sweden                                     *
*                                                                      *
************************************************************************
      Program TestRF
      Implicit None
#include "runtypes.fh"

      Integer      Mxdata
      Parameter    (MxData=64)

      Logical      UseOld

      Integer      iRc,iOpt
      Integer      iSeed
      Integer      Loop
      Integer      i

      Integer      nDataA,nDataB
      Integer      nDataC,nDataD
      Integer      nDataE,nDataF
      Integer      nDataAx,nDataBx
      Integer      nDataCx,nDataDx
      Integer      nDataEx,nDataFx
      Integer      RecTypA,RecTypB
      Integer      RecTypC,RecTypD
      Integer      RecTypE,RecTypF
      Real*8       DataA(MxData)
      Real*8       DataB(MxData)
      Integer      DataC(MxData)
      Integer      DataD(MxData)
      Character*1  DataE(MxData)
      Character*1  DataF(MxData)

      Real*8       Random_molcas
      External     Random_molcas

      Call Init_LinAlg
      Call PrgmInit('TestRF')
      Call NameRun('RUNFILE')
      UseOld=.false.
      If(UseOld) GoTo 500

      iSeed=12345
      nDataA=0
      nDataB=0
      nDataC=0
      nDataD=0
      nDataE=0
      nDataF=0

      Do i=1,MxData
         DataA(i)= 1.0d0*i
         DataB(i)=-1.0d0*i
         DataC(i)= i
         DataD(i)=-i
         DataE(i)= Char(64+mod(i,48))
         DataF(i)= Char(64+mod(i,48))
      End Do

      iRc=0
      iOpt=0
      Do Loop=1,16
         If(Random_molcas(iSeed).gt.0.75d0) Then
            nDataA=Int((MxData-4)*Random_molcas(iSeed)+4)
            Write(*,*) 'Adding A',nDataA
            Call dWrRun('Amat',DataA,nDataA)
         End If
         If(Random_molcas(iSeed).gt.0.75d0) Then
            nDataB=Int((MxData-4)*Random_molcas(iSeed)+4)
            Write(*,*) 'Adding B',nDataB
            Call dWrRun('Bmat',DataB,nDataB)
         End If
         If(Random_molcas(iSeed).gt.0.75d0) Then
            nDataC=Int((MxData-4)*Random_molcas(iSeed)+4)
            Write(*,*) 'Adding C',nDataC
            Call iWrRun('Cmat',DataC,nDataC)
         End If
         If(Random_molcas(iSeed).gt.0.75d0) Then
            nDataD=Int((MxData-4)*Random_molcas(iSeed)+4)
            Write(*,*) 'Adding D',nDataD
            Call iWrRun('Dmat',DataD,nDataD)
         End If
         If(Random_molcas(iSeed).gt.0.75d0) Then
            Call NameRun('RUNXXX')
            i=Int((MxData-4)*Random_molcas(iSeed)/4)
            nDataE=4*i+4
            Write(*,*) 'Adding E',nDataE
            Call cWrRun('Emat',DataE,nDataE)
            Call NameRun('RUNFILE')
         End If
         If(Random_molcas(iSeed).gt.0.75d0) Then
            i=Int((MxData-4)*Random_molcas(iSeed)/4)
            nDataF=4*i+4
            Write(*,*) 'Adding F',nDataF
            Call cWrRun('Fmat',DataF,nDataF)
         End If
      End Do

  500 Continue

      Do i=1,MxData
         DataA(i)= 0.0d0
         DataB(i)= 0.0d0
         DataC(i)= 0
         DataD(i)= 0
         DataE(i)= Char(0)
         DataF(i)= Char(0)
      End Do

      nDataAx=nDataA
      nDataBx=nDataB
      nDataCx=nDataC
      nDataDx=nDataD
      nDataEx=nDataE
      nDataFx=nDataF

      nDataA=0
      nDataB=0
      nDataC=0
      nDataD=0
      nDataE=0
      nDataF=0

      Call ffRun('aMat',nDataA,RecTypA)
      Call ffRun('bMat',nDataB,RecTypB)
      Call ffRun('cMat',nDataC,RecTypC)
      Call ffRun('dMat',nDataD,RecTypD)
      Call NameRun('RUNXXX')
      Call ffRun('eMat',nDataE,RecTypE)
      Call NameRun('RUNFILE')
      Call ffRun('fMat',nDataF,RecTypF)

      If(UseOld) Then
         nDataAx=nDataA
         nDataBx=nDataB
         nDataCx=nDataC
         nDataDx=nDataD
         nDataEx=nDataE
         nDataFx=nDataF
      End If

      If(nDataA.ne.nDataAx) Then
         Write(*,*) 'nDataA:',nDataA,nDataAx
         Stop
      End If

      If(nDataB.ne.nDataBx) Then
         Write(*,*) 'nDataB:',nDataB,nDataBx
         Stop
      End If

      If(nDataC.ne.nDataCx) Then
         Write(*,*) 'nDataC:',nDataC,nDataCx
         Stop
      End If

      If(nDataD.ne.nDataDx) Then
         Write(*,*) 'nDataD:',nDataD,nDataDx
         Stop
      End If

      If(nDataE.ne.nDataEx) Then
         Write(*,*) 'nDataE:',nDataE,nDataEx
         Stop
      End If

      If(nDataF.ne.nDataFx) Then
         Write(*,*) 'nDataF:',nDataF,nDataFx
         Stop
      End If

      If(RecTypA.ne.TypDbl) Then
         Write(*,*) 'RecTypA:',RecTypA,TypDbl
         Stop
      End If

      If(RecTypB.ne.TypDbl) Then
         Write(*,*) 'RecTypB:',RecTypB,TypDbl
         Stop
      End If

      If(RecTypC.ne.TypInt) Then
         Write(*,*) 'RecTypC:',RecTypC,TypInt
         Stop
      End If

      If(RecTypD.ne.TypInt) Then
         Write(*,*) 'RecTypD:',RecTypD,TypInt
         Stop
      End If

      If(RecTypE.ne.TypStr) Then
         Write(*,*) 'RecTypE:',RecTypE,TypStr
         Stop
      End If

      If(RecTypF.ne.TypStr) Then
         Write(*,*) 'RecTypF:',RecTypF,TypStr
         Stop
      End If

      If(nDataA.gt.0) Then
         Write(*,*) 'Testing A',nDataA
         Call dRdRun('amat',DataA,nDataA)
         Do i=1,nDataA
            If(Abs(DataA(i)-i).gt.1.0d-12) Then
               Write(*,*) 'A:',i,DataA(i)
            End If
         End Do
      End If

      If(nDataB.gt.0) Then
         Write(*,*) 'Testing B',nDataB
         Call dRdRun('bmat',DataB,nDataB)
         Do i=1,nDataB
            If(Abs(DataB(i)+i).gt.1.0d-12) Then
               Write(*,*) 'B:',i,DataB(i)
            End If
         End Do
      End If

      If(nDataC.gt.0) Then
         Write(*,*) 'Testing C',nDataC
         Call iRdRun('cmat',DataC,nDataC)
         Do i=1,nDataC
            If(DataC(i)-i.ne.0) Then
               Write(*,*) 'C:',i,DataC(i)
            End If
         End Do
      End If

      If(nDataD.gt.0) Then
         Write(*,*) 'Testing D',nDataD
         Call iRdRun('dmat',DataD,nDataD)
         Do i=1,nDataD
            If(DataD(i)+i.ne.0) Then
               Write(*,*) 'D:',i,DataD(i)
            End If
         End Do
      End If

      If(nDataE.gt.0) Then
         Call NameRun('RUNXXX')
         Write(*,*) 'Testing E',nDataE
         Call cRdRun('emat',DataE,nDataE)
         Do i=1,nDataE
            If(iChar(DataE(i))-64-mod(i,48).ne.0) Then
               Write(*,*) 'E:',i,DataE(i)
            End If
         End Do
         Call NameRun('RUNFILE')
      End If

      If(nDataF.gt.0) Then
         Write(*,*) 'Testing F',nDataF
         Call cRdRun('fmat',DataF,nDataF)
         Do i=1,nDataF
            If(iChar(DataF(i))-64-mod(i,48).ne.0) Then
               Write(*,*) 'F:',i,DataF(i)
            End If
         End Do
      End If

      Call DumpRun(iRc,iOpt)

      Stop
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
*               1993, Per-Olof Widmark                                 *
************************************************************************
      Subroutine LoadInts(iRc,iOpt)
************************************************************************
*                                                                      *
*    Purpose: Read the table of content from the OrdInt file           *
*                                                                      *
*    Calling parameters:                                               *
*    iRc    : return code                                              *
*             (zero upon successful completion)                        *
*    iOpt   : option code                                              *
*             iOpt = 0  ==> Square =.true.                             *
*             iOpt = 1  ==> Square =.false.                            *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    TwoDat : table of contents and auxiliary information              *
*    TowRc  : Table of return code                                     *
*                                                                      *
*    Local data declarations: none                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.O. Widmark                                 *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
#include "Molcas.fh"
#include "TwoDat.fh"
      Logical Square
*
*     loop over all symmetry blocks
*
      Square=iOpt.eq.1
      iOff = RAMD_anchor
      nInts = 0
      nSym=TocTwo(isSym)
      mxSyP=nSym*(nSym+1)/2
      Do iSymi=1,nSym
        ib=TocTwo(isBas+iSymi-1)
        iSkip=TocTwo(isSkip+iSymi-1)
        Do jSymj=1,iSymi
          iSymj=1+ieor(iSymi-1,jSymj-1)
          iSyblj=jSymj+iSymi*(iSymi-1)/2
          jb=TocTwo(isBas+jSymj-1)
          ibj=ib*jb
          If( iSymi.eq.jSymj ) ibj=ib*(ib+1)/2
          jSkip=TocTwo(isSkip+jSymj-1)
          kSymMx=iSymi
          If( Square ) kSymMx=nSym
          Do kSymk=1,kSymMx
            kb=TocTwo(isBas+kSymk-1)
            kSkip=TocTwo(isSkip+kSymk-1)
            lSymMx=jSymj
            If( kSymk.ne.iSymi .or. Square ) lSymMx=kSymk
            Do lSyml=1,lSymMx
              kSyml=1+ieor(kSymk-1,lSyml-1)
              kSybll=lSyml+kSymk*(kSymk-1)/2
              If( ieor(iSymj-1,kSyml-1).eq.0 ) then
                lb=TocTwo(isBas+lSyml-1)
                kbl=kb*lb
                If( kSymk.eq.lSyml ) kbl=kb*(kb+1)/2
                lSkip=TocTwo(isSkip+lSyml-1)
                iSyBlk=kSybll+mxSyP*(iSyblj-1)
                If ( (iSkip+jSkip+kSkip+lSkip).eq.0 .and.
     &               (ibj*kbl).ne.0 ) then
*
*     check if there is enough space available
*
                   lBuf = ibj*kbl
                   nInts = nInts + lBuf
                   If ( nInts.ge.RAMD_size ) then
                      iRc = 001
                      Write(6,*)
                      Write(6,'(2X,A,I3.3,A)')
     &                '*** (W)-level message LOADINTS',iRc,' ***'
                      Write(6,'(2X,A)')
     &                'There is not enough space on the RAM disk'
                      Write(6,'(2X,A)')
     &                'The program will resume normal activity'
                      Write(6,*)
                      Return
                   End If
*
*     save start address of this symmetry block
*
                   iBatch = nBatch(iSyBlk)
                   RAMD_adr(iBatch) = iOff
*
*     load integrals
*
                   iRc=0
                   iOpt=1
                   Call RdOrd(iRc,iOpt,
     &                        iSymi,jSymj,kSymk,lSyml,
     &                        RAMD_ints(iOff),lBuf+1,npq)
*
*     update pointers
*
                   iOff = iOff + lBuf

                End If
              End If
            End Do
          End Do
        End Do
      End Do
*
*     define initial load point
*
      RAMD_next=RAMD_adr(1)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!               2025, Ignacio Fdez. galvan                             *
!***********************************************************************

module Str_Info

use Definitions, only: wp, iwp

implicit none
private

! OCSTR  : Offsets for occupation of strings
! STREO  : reordering array
! STSM   : Symmetry of each string
! STCL   : Class of each string
! NSTSO  : Number of strings per symmetry and occupation
! ISTSO  : Offset of strings per symmetry and occupation
! EL1    : Number of electrons in RAS1 per sub type
! EL3    : Number of electrons in RAS3 per sub type
! Z      : Lexical addressing of arrays
! EL123  : -"-    But array
! STSTMI : Explicit offsets and lengths
! STSTMN :           "
! STSTM  : ?

type String_Info
  integer(kind=iwp), pointer :: OCSTR(:) => null(), STREO(:) => null(), STSM(:) => null(), STCL(:) => null(), NSTSO(:) => null(), &
                                ISTSO(:) => null(), EL1(:) => null(), EL3(:) => null(), Z(:) => null(), EL123(:) => null(), &
                                STSTMI(:) => null(), STSTMN(:) => null(), STSTM(:,:) => null()
end type String_Info

type String_Hidden
  integer(kind=iwp), allocatable :: OCSTR(:), STREO(:), STSM(:), STCL(:), NSTSO(:), ISTSO(:), EL1(:), EL3(:), Z(:), EL123(:), &
                                    STSTMI(:), STSTMN(:), STSTM(:,:)
end type String_Hidden

! ICONF : NCNSM  CONFIGURATION EXPANSIONS
! ICTS  : address of determinant I in STRING ordering for
!         determinant I in CSF ordering
!         reference symmetry IREFSM.
type Storage
  integer(kind=iwp), allocatable :: ICONF(:), ICTS(:)
end type Storage

integer(kind=iwp), parameter :: MXCNSM = 8, NSTTYP_MAX = 6+1  ! "+1" is the dummy layer

! INITIALIZED IN STRTYP
!  NSTTYP  : Number of string types
!  MNRS1   : Min ras1
!  MXRS1   : Max ras1
!  MNRS3   : Min ras3
!  MXRS3   : Max ras3
!  NELEC   : Number of electrons
!  IAZTP   : Pointer to alpha types
!  IBZTP   : Pointer to beta types
!  iuniqmp : Unique types (not necessary here just 0order space)
!  ISTAC   : Stringtype maping; a(or a+) i -> istac(j,1(2))
!
!  NOCTYP  : Number of occupation classes for given type
!  NSTFTP  : Number of strings of this type
!  DFTP    : OPEN SHELL DETERMINANTS OF PROTO TYPE
!  CFTP    : BRANCHING DIAGRAMS FOR PROTO TYPES
!  DTOC    : CSF-DET TRANSFORMATION FOR PROTO TYPES

integer(kind=iwp) :: IATPM1, IATPM2, IAZTP, IBTPM1, IBTPM2, IBZTP, ISTAC(NSTTYP_MAX,2), ITYP_DUMMY = 0, iuniqmp(NSTTYP_MAX) = 0, &
                     iuniqtp(NSTTYP_MAX) = 0, MNRS1(NSTTYP_MAX) = 0, MNRS3(NSTTYP_MAX) = 0, MXRS1(NSTTYP_MAX) = 0, &
                     MXRS3(NSTTYP_MAX) = 0, NELEC(NSTTYP_MAX) = 0, NOCTYP(NSTTYP_MAX) = 0, NSTFTP(NSTTYP_MAX) = 0, NSTTYP
type(Storage) :: CNSM(MXCNSM)
integer(kind=iwp), allocatable :: CFTP(:), DFTP(:)
real(kind=wp), allocatable :: DTOC(:)
type(String_Info) :: Str(NSTTYP_MAX)
type(String_Hidden), target :: Str_Hidden(NSTTYP_MAX)

public :: CFTP, CNSM, DFTP, DTOC, IATPM1, IATPM2, IAZTP, IBTPM1, IBTPM2, IBZTP, ISTAC, ITYP_DUMMY, iuniqmp, iuniqtp, MNRS1, MNRS3, &
          MXRS1, MXRS3, NELEC, NOCTYP, NSTFTP, NSTTYP, Str, Str_Hidden

end module Str_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_MpProp(nPrim,nBas,nAtoms,nCenters,!nOcOb,
     &                      nMltPl,!oNum,nOrb,
!     &                      oCof,
     &                      ip_D_p,ECENTX,ECENTY,ECENTZ,LNearestAtom,
     &                      LFirstRun,LLumOrb)
      Implicit Real*8 (a-h,o-z)
#include "MpParam.fh"
#include "WrkSpc.fh"
#include "Address.fh"
#include "MolProp.fh"
!      Dimension oNum(nOrb)
!      Dimension oCof(nBas,nPrim)
      Dimension ECENTX(nPrim*(nPrim+1)/2)
      Dimension ECENTY(nPrim*(nPrim+1)/2)
      Dimension ECENTZ(nPrim*(nPrim+1)/2)
      Logical   LNearestAtom
      Logical   LFirstRun
      Logical   LLumOrb

*
      Call Allocate_iWork(ip_iCompMat,(nMltPl+1)**3)
      Call Allocate_Work(ip_Qexp,nPrim**2)
!      Call Allocate_Work(ip_DenMat,nPrim**2)
*
      Call Get_MpProp_(nPrim,nBas,nAtoms,nCenters,!nOcOb,
     &                 nMltPl,!oNum,nOrb,
!     &                 oCof,
     &                 ip_D_p,ECENTX,ECENTY,ECENTZ,LNearestAtom,
     &                 iWork(ip_iCompMat),Work(ip_Qexp),
     &                 LFirstRun,LLumOrb)
*
!      Call Free_Work(ip_DenMat)
      Call Free_Work(ip_Qexp)
      Call Free_iWork(ip_iCompMat)
*
      Return
      End
      Subroutine Get_MpProp_(nPrim,nBas,nAtoms,nCenters,!nOcOb,
     &                      nMltPl,!oNum,nOrb,
!     &                      oCof,
     &                      ip_D_p,ECENTX,ECENTY,ECENTZ,LNearestAtom,
     &                      iCompMat,Qexp,LFirstRun,LLumOrb)
      Implicit Real*8 (a-h,o-z)
#include "MpParam.fh"
#include "WrkSpc.fh"
#include "Address.fh"
#include "MolProp.fh"
!      Dimension oNum(nOrb)
!      Dimension oCof(nBas,nPrim)
      Dimension CorP(3),CorN(3)
      Dimension iCompMat(0:nMltPl,0:nMltPl,0:nMltPl)
      Dimension ECENTX(nPrim*(nPrim+1)/2)
      Dimension ECENTY(nPrim*(nPrim+1)/2)
      Dimension ECENTZ(nPrim*(nPrim+1)/2)
      Dimension Qexp(nPrim,nPrim)
!      Dimension DenMat(nPrim,nPrim)
      Logical   LNearestAtom
      Logical   LFirstRun
      Logical   LLumOrb
*                                                                      *
************************************************************************
*                                                                      *
* SOME KIND OF PROLOG
*
      iStdout = 6
      Write(iStdOut,*)
      If(LLumOrb) Then
        Write(iStdOut,*) ' Using the INPORB file'
        If(LFirstRun) Then
          Write(iStdOut,*) ' This is first run of Get_MpProp'
          Write(iStdOut,*)
          If(Method.eq.'UHF-SCF') Then
            Write(iStdOut,*) ' Number of alpha electrons', nOcOB
          Else
            Write(iStdOut,*) ' Occupation Number ', nOcOB
          EndIf
          Write(iStdOut,*) ' Number of Orbitals' , nOrb
        Else
          Write(iStdOut,*) ' Running Get_MpProp for the second time'
          Write(iStdOut,*) ' Number beta electrons ', nOcOB
          Write(iStdOut,*) ' Number of Orbitals' , nOrb
        EndIf
      Else
        Write(iStdOut,*)' Using the densities from a Molcas calculation'
      EndIf
      Write(iStdOut,*)
* Set the varible that knowes the component
      Do iMltpl = 0,nMltPl
         iComp=0
         Do np=iMltpl,0,-1
            Do nq=iMltpl-np,0,-1
               nl=iMltpl-np-nq
               iComp=iComp+1
               iCompMat(np,nq,nl)=iComp
            EndDo
         EndDo
      EndDo
* Translate dipoles to the center for the quadrupoles
      If(LFirstRun) Then
!      Do iMltpl = 0,1
! An error written by me DH
       Do i=1,nPrim
         Do j=1,i
           Do k=1,3
             Work(iWork(iMltPlAd(1)+k-1)+i*(i-1)/2+j-1)=
     &       Work(iWork(iMltPlAd(1)+k-1)+i*(i-1)/2+j-1)+
     &       (CordMltPl(k,0)-CordMltPl(k,2))*
     &       Work(iWork(iMltPlAd(0))+i*(i-1)/2+j-1)
           EndDo
         EndDo
       EndDo
       Do iMltpl = 0,1
         CordMltPl(1,iMltPl)=CordMltPl(1,2)
         CordMltPl(2,iMltPl)=CordMltPl(2,2)
         CordMltPl(3,iMltPl)=CordMltPl(3,2)
       EndDo
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
*     GET THE DENSITY MATRIX
*
!      If(LLumOrb) Then
!       Do K = 1 , nPrim
!        Do L = 1 , K
!         DenMat(K,L) = 0.0d0
!        EndDo
!       EndDo
!       Do K=1,nPrim
!        Do L=1,K
!         Do i=1,nOcOb
!          DenMat(K,L) = DenMat(K,L) + oNum(I)*oCof(I,K)*oCof(I,L)
!         EndDo
!         DenMat(L,K) = DenMat(K,L)
!        EndDo
!       EndDo
!      Else
!        Do K=1,nPrim
!          Do L=1,K
!            DenMat(L,K) = Work(ip_D_p+K*(K-1)/2+L-1)
!            If(K.ne.L) Then
!              DenMat(K,L) = DenMat(L,K)
!            EndIf
!          EndDo
!        EndDo
!      EndIf
*                                                                      *
************************************************************************
*                                                                      *
* GET THE INTERACTIONSITES
      Write(6,*) !Dummy added due to compiler bug on adils, intelfast.
      Do i=1,nPrim
         Do j=1,i
            Qexp(i,j)=work(iwork(iMltPlAd(0))+i*(i-1)/2+j-1)*
     &      Work(ip_D_p+i*(i-1)/2+j-1)
            Qexp(j,i)=Qexp(i,j)
         EndDo
      EndDo
*
      iA = -99
      Do nA=1,nAtoms

C
C NOW SUM UP THE OTHER MULTIPOLE MOMENTS
C
         Do iMltpl = 0,nMltPl
            iComp=0
            Do np=iMltpl,0,-1
               Do nq=iMltpl-np,0,-1
                  nl=iMltpl-np-nq
                  iComp=iComp+1
                  sum=0.0d0
                  Do ip=0,np
                     Call NoverP(np,ip,rnPoveriP)
                     If(np.eq.ip) Then
                        xfac=rnpoverip
                     Else
                        xfac=rnPoveriP*(CordMltPl(1,ip)
     &                  -COR(1,nA,nA))**(np-ip)
                     EndIf
                     Do iq=0,nq
                        Call NoverP(nq,iq,rnqoveriq)
                        If(nq.eq.iq) Then
                           yfac=rnqoveriq
                        Else
                           yfac=rnqoveriq*(CordMltPl(2,iq)
     &                     -COR(2,nA,nA))**(nq-iq)
                        EndIf
                        Do il=0,nl
                           Call NoverP(nl,il,rnloveril)
                           If(nl.eq.il) Then
                              zfac=rnloveril
                           Else
                              zfac=rnloveril*(CordMltPl(3,il)
     &                        -COR(3,nA,nA))**(nl-il)
                           EndIf
                           If(xfac.eq.0.0D0.or.yfac.eq.0.0D0.or.
     &                     zfac.eq.0.0D0) Goto 10
                           Do iPBas = 1,nAtomPBas(nA)
                              i = iAtPrTab(iPBas,nA)
                              Do jPBas = 1,nAtomPBas(nA)
                                 !!!! Check i>j
                                 If(iAtPrTab(jPBas,nA).gt.i) Then
                                    jj = i
                                    ii = iAtPrTab(jPBas,nA)
                                 Else
                                    jj = iAtPrTab(jPBas,nA)
                                    ii = i
                                 EndIf
                                 sum=sum+
     &                           xfac*yfac*zfac*
     &                           Work(ip_D_p+ii*(ii-1)/2+jj-1)*
     &                           Work(iWork(iMltPlAd(ip+iq+il)+
     &                           iCompMat(ip,iq,il)-1)+ii*(ii-1)/2+jj-1)
                              EndDo
                           EndDo
10                         Continue
                        EndDo
                     EndDo
                  EndDo
                  Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
     &            +nA*(nA+1)/2-1)=
     &            Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
!                                minus from the negative sign of the electron
     &            +nA*(nA+1)/2-1)-sum
                  Work(iAtBoMltPlAdCopy(iMltpl)+nCenters*(iComp-1)
     &            +nA*(nA+1)/2-1)=
     &            Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
     &            +nA*(nA+1)/2-1)
                  Work(iAtMltPlAd(iMltPl)+nAtoms*(iComp-1)+nA-1)=
     &            Work(iAtMltPlAd(iMltPl)+nAtoms*(iComp-1)+nA-1)-sum
               EndDo
            EndDo
         EndDo
C
C THE NUCLEAR CHARGE IS ADDED ON
C
         If(LFirstRun) Then
            Work(iAtMltPlAd(0)+nA-1)=
     &      Work(iAtMltPlAd(0)+nA-1)+Work(iQnuc+nA-1)
            Work(iAtBoMltPlAd(0)+nA*(nA+1)/2-1)=
     &      Work(iAtBoMltPlAd(0)+nA*(nA+1)/2-1)+
     &      Work(iQnuc+nA-1)
            Work(iAtBoMltPlAdCopy(0)+nA*(nA+1)/2-1)=
     &      Work(iAtBoMltPlAdCopy(0)+nA*(nA+1)/2-1)+
     &      Work(iQnuc+nA-1)
         EndIf

         Do nB = 1, nA-1
C
C MULTIPOLE BETWEEN NA,NB
C
            Qp = 0.0
            Qn = 0.0
            Do i=1,3
               CorP(i)= 0.0
               CorN(i)= 0.0
            EndDo
            Do iPBas = 1,nAtomPBas(NA)
              i = iAtPrTab(iPBas,NA)
              Do jPBas = 1,nAtomPBas(NB)
                j = iAtPrTab(jPBas,NB)
                !!!! Check i>j
                If(iAtPrTab(jPBas,nB).gt.i) Then
                   jj = i
                   ii = iAtPrTab(jPBas,nB)
                Else
                   jj = iAtPrTab(jPBas,nB)
                   ii = i
                EndIf
                IF(Qexp(i,j).GT.(0.0D0)) THEN
                   Qp=Qp+Qexp(i,j)
                   CorP(1)=CorP(1)+QEXP(I,J)*ECENTX(ii*(ii-1)/2+jj)
                   CorP(2)=CorP(2)+QEXP(I,J)*ECENTY(ii*(ii-1)/2+jj)
                   CorP(3)=CorP(3)+QEXP(I,J)*ECENTZ(ii*(ii-1)/2+jj)
                ELSE
                   Qn=Qn+Qexp(i,j)
                   CorN(1)= CorN(1)+QEXP(I,J)*ECENTX(ii*(ii-1)/2+J)
                   CorN(2)= CorN(2)+QEXP(I,J)*ECENTY(ii*(ii-1)/2+J)
                   CorN(3)= CorN(3)+QEXP(I,J)*ECENTZ(ii*(ii-1)/2+J)
                ENDIF
              EndDo
            EndDo

            if(Qp.ne.0.0D00) then
               CorP(1)= CorP(1)/Qp
               CorP(2)= CorP(2)/Qp
               CorP(3)= CorP(3)/Qp
            endif
            if(Qn.ne.0.0D00) then
               CorN(1)= CorN(1)/Qn
               CorN(2)= CorN(2)/Qn
               CorN(3)= CorN(3)/Qn
            endif
            Q=Qp+Qn
            Qs=Qp-Qn
            if(Qs.ne.0.0D00) then
               FracP= Qp/Qs
               FracN=1.0D00 - FracP
            else
               FracP=0.0D00
               FracN=0.0D00
            endif
            Cor(1,nA,nB)=CorP(1)*FracP+CorN(1)*FracN
            Cor(2,nA,nB)=CorP(2)*FracP+CorN(2)*FracN
            Cor(3,nA,nB)=CorP(3)*FracP+CorN(3)*FracN

C
C CALCULATE THE WEIGTH OF EACH ATOMIC CENTER BY A SIMPLE GEOMETRIC RATIO
C
            Rwei = SQRT( (Cor(1,nA,nA)-Cor(1,nA,nB))**2
     &      +(Cor(2,nA,nA)-Cor(2,nA,nB))**2
     &      +(Cor(3,nA,nA)-Cor(3,nA,nB))**2 )
            Rtot = SQRT( (Cor(1,nA,nA)-Cor(1,nB,nB))**2
     &      +(Cor(2,nA,nA)-Cor(2,nB,nB))**2
     &      +(Cor(3,nA,nA)-Cor(3,nB,nB))**2 )
C
C FRACTION OF MULTIPOLE EXPANSION TO BE RELATED TO THE PAIR ATOMS
C
            FracB = Rwei/Rtot
            FracA = 1.0D00 - FracB
            Frac(nA,nB) = FracA

C Find the closest atom
            If(LNearestAtom.and.(.not.BondMat(nA,nB))) Then
               Smallest=1.0D200
               Do i=1,nAtoms
                  R=sqrt((Cor(1,nA,nB)-Cor(1,i,i))**2+
     &                    (Cor(2,nA,nB)-Cor(2,i,i))**2+
     &                    (Cor(3,nA,nB)-Cor(3,i,i))**2)
                  If(R.lt.Smallest) Then
                     Smallest=R
                     iA=i
                  EndIf
               EndDo
               RA=sqrt((Cor(1,nA,nB)-Cor(1,nA,nA))**2+
     &                  (Cor(2,nA,nB)-Cor(2,nA,nA))**2+
     &                  (Cor(3,nA,nB)-Cor(3,nA,nA))**2)
               RB=sqrt((Cor(1,nA,nB)-Cor(1,nB,nB))**2+
     &                  (Cor(2,nA,nB)-Cor(2,nB,nB))**2+
     &                  (Cor(3,nA,nB)-Cor(3,nB,nB))**2)
               If( ((iA.ne.nA) .and. (iA.ne.nB) ) .and.
     &             ( (Smallest.lt.RA) .and.  (Smallest.lt.RB) ) ) Then
                  iA=iA
                  iB=0
                  FracA=1.0D0
                  FracB=0.0D0
                  Write(iStdOut,*)
                  Write(iStdOut,*)' Moving bond between the atoms  ',
     &            Labe(nA),Labe(nB)
                  Write(iStdOut,*)' to the atom                    ',
     &            Labe(iA)
                  Write(iStdOut,*)
               Else
                  iA=nA
                  iB=nB
               EndIf
            Else
               iA=nA
               iB=nB
            EndIf

*                                                                      *
************************************************************************
*                                                                      *
*     TRANSFORM THE MULTIPOLES TO BONDS AND ATOMS
*
*Do multipoles
*
            Do iMltpl = 0,nMltPl
            iComp=0
            Do np=iMltpl,0,-1
               Do nq=iMltpl-np,0,-1
                  nl=iMltpl-np-nq
                  iComp=iComp+1
                  sum=0.0
                  Do ip=0,np
                     Call NoverP(np,ip,rnPoveriP)
                     If(np.eq.ip) Then
                        xfac=rnpoverip
                     Else
                        xfac=rnPoveriP*
     &                  (CordMltPl(1,ip)-COR(1,nA,nB))**(np-ip)
                     EndIf
                     Do iq=0,nq
                        Call NoverP(nq,iq,rnqoveriq)
                        If(nq.eq.iq) Then
                           yfac=rnqoveriq
                        Else
                           yfac=rnqoveriq*
     &                     (CordMltPl(2,iq)-COR(2,nA,nB))**(nq-iq)
                        EndIf
                        Do il=0,nl
                           Call NoverP(nl,il,rnloveril)
                           If(nl.eq.il) Then
                              zfac=rnloveril
                           Else
                              zfac=rnloveril*
     &                        (CordMltPl(3,il)-COR(3,nA,nB))**(nl-il)
                           EndIf
                           If(xfac.eq.0.0D0.or.yfac.eq.0.0D0.or.
     &                     zfac.eq.0.0D0) Goto 20
                           Do iPBas = 1,nAtomPBas(nA)
                              i = iAtPrTab(iPBas,nA)
                              Do jPBas = 1,nAtomPBas(nB)
                                 !!!! Check i>j
                                 If(iAtPrTab(jPBas,nB).gt.i) Then
                                    jj = i
                                    ii = iAtPrTab(jPBas,nB)
                                 Else
                                    jj = iAtPrTab(jPBas,nB)
                                    ii = i
                                 EndIf
                                 sum=sum+
     &                           xfac*yfac*zfac*2.0d0*
     &                           Work(ip_D_p+ii*(ii-1)/2+jj-1)*
     &                           Work(iWork(iMltPlAd(ip+iq+il)+
     &                           iCompMat(ip,iq,il)-1)+ii*(ii-1)/2+jj-1)
                              EndDo
                           EndDo
20                         Continue
                        EndDo
                     EndDo
                  EndDo
                  Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
     &            +nA*(nA-1)/2+nB-1)=
     &            Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
!                                   minus from the negative sign of the electron
     &            +nA*(nA-1)/2+nB-1)-sum
                  ! Copy the multipole arrays
                  Work(iAtBoMltPlAdCopy(iMltpl)+nCenters*(iComp-1)
     &            +nA*(nA-1)/2+nB-1)=
     &            Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
     &            +nA*(nA-1)/2+nB-1)
               EndDo
            EndDo
            EndDo
*
* If one should move the bond to the closest atom iA would be equal to
* that otherwise iA should be equal to nA
*
           If( ((Method.eq.'UHF-SCF').and.(LFirstRun.eqv..False.)) .or.
     &         ((Method.ne.'UHF-SCF').and.(LFirstRun.eqv..True.)) ) Then
            Do iMltpl = 0,nMltPl
            iComp=0
            Do np=iMltpl,0,-1
               Do nq=iMltpl-np,0,-1
                  nl=iMltpl-np-nq
                  iComp=iComp+1
                  sum_a=0.0D0
                  sum_b=0.0D0
                  Do ip=0,np
                     Call NoverP(np,ip,rnPoveriP)
                     If(np.eq.ip) Then
                        xfac_a=rnPoveriP
                        xfac_b=rnPoveriP
                     Else
                        xfac_a=(COR(1,nA,nB)-COR(1,iA,iA))**(np-ip)*
     &                  rnPoveriP
                        xfac_b=(COR(1,nA,nB)-COR(1,nB,nB))**(np-ip)*
     &                  rnPoveriP
                     EndIf
                     Do iq=0,nq
                        Call NoverP(nq,iq,rnqoveriq)
                        If(nq.eq.iq) Then
                           yfac_a=rnqoveriq
                           yfac_b=rnqoveriq
                        Else
                           yfac_a=(COR(2,nA,nB)-COR(2,iA,iA))**(nq-iq)*
     &                     rnqoveriq
                           yfac_b=(COR(2,nA,nB)-COR(2,nB,nB))**(nq-iq)*
     &                     rnqoveriq
                        EndIf
                        Do il=0,nl
                           Call NoverP(nl,il,rnloveril)
                           If(nl.eq.il) Then
                              zfac_a=rnloveril
                              zfac_b=rnloveril
                           Else
                             zfac_a=(COR(3,nA,nB)-COR(3,iA,iA))**(nl-il)
     &                       *rnloveril
                             zfac_b=(COR(3,nA,nB)-COR(3,nB,nB))**(nl-il)
     &                       *rnloveril
                           EndIf
                           sum_a=sum_a+
     &                     xfac_a*yfac_a*zfac_a*FracA*
     &                     Work(iAtBoMltPlAd(ip+iq+il)+
     &                     nCenters*(iCompMat(ip,iq,il)-1)
     &                     +nA*(nA-1)/2+nB-1)
                           sum_b=sum_b+
     &                     xfac_b*yfac_b*zfac_b*FracB*
     &                     Work(iAtBoMltPlAd(ip+iq+il)+
     &                     nCenters*(iCompMat(ip,iq,il)-1)
     &                     +nA*(nA-1)/2+nB-1)
                        EndDo
                     EndDo
                  EndDo
                  If(BondMat(nA,nB)) Then
                    !If bonding
                    !Do atoms
                    Work(iAtMltPlAd(iMltpl)+nAtoms*(iComp-1)+iA-1)=
     &              Work(iAtMltPlAd(iMltpl)+nAtoms*(iComp-1)+iA-1)+sum_a
                    Work(iAtMltPlAd(iMltpl)+nAtoms*(iComp-1)+nB-1)=
     &              Work(iAtMltPlAd(iMltpl)+nAtoms*(iComp-1)+nB-1)+sum_b
                  Else
                    !If not bonding
                    !Do Atoms
                    Work(iAtMltPlAd(iMltpl)+nAtoms*(iComp-1)+iA-1)=
     &              Work(iAtMltPlAd(iMltpl)+nAtoms*(iComp-1)+iA-1)+sum_a
                    Work(iAtMltPlAd(iMltpl)+nAtoms*(iComp-1)+nB-1)=
     &              Work(iAtMltPlAd(iMltpl)+nAtoms*(iComp-1)+nB-1)+sum_b
                    !Do bonds
                    Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
     &              +iA*(iA+1)/2-1)=
     &              Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
     &              +iA*(iA+1)/2-1)+sum_a
                    Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
     &              +nB*(nB+1)/2-1)=
     &              Work(iAtBoMltPlAd(iMltpl)+nCenters*(iComp-1)
     &              +nB*(nB+1)/2-1)+sum_b
                  EndIf
               EndDo
            EndDo
            EndDo
           EndIf
         EndDo
      EndDo

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nBas)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DMATRIX(E,F,Z,IPRINT)
! THIS ROUTINE COMPUTES THE USUAL D-TENSOR ON THE BASIS OF COEFFICIENTS
! OF THE STEVENS OPERATORS OF ORDER 2 (ES AND FS) AND DIAGONALIZES IT
! TO OBTAIN THE MAIN ANISOTROPY AXES

use Constants, only: Zero, One, Two, Half, OneHalf
use Definitions, only: wp, iwp, u6

implicit none
complex(kind=wp), intent(in) :: E(0:2), F(0:2)
real(kind=wp), intent(in) :: Z(3,3)
integer(kind=iwp), intent(in) :: iprint
integer(kind=iwp) :: INFO, J
real(kind=wp) :: CF, D_factor, daxes(3,3), diff12, diff23, diff31, DMATR(3,3), dtens(3), E_factor, SMAT(3,3), Unity(3,3), WD(3), &
                 ZD(3,3), ZD2(3,3)
complex(kind=wp) :: DMAT(3,3)
character(len=2) :: Lx, Ly, Lz

CF = sqrt(OneHalf)

DMAT(1,1) = CF*E(2)-E(0)
DMAT(2,2) = -CF*E(2)-E(0)
DMAT(3,3) = Two*E(0)
DMAT(1,2) = CF*F(2)
DMAT(1,3) = CF*E(1)
DMAT(2,3) = CF*F(1)
DMAT(2,1) = DMAT(1,2)
DMAT(3,1) = DMAT(1,3)
DMAT(3,2) = DMAT(2,3)

DMATR(:,:) = real(DMAT(:,:))

call DIAG_R2(DMATR,3,INFO,WD,ZD)

! calculate the rotation matrix:
call unitmat(Unity,3)

call DGEMM_('N','N',3,3,3,One,ZD,3,Unity,3,Zero,SMAT,3)

! Set the dtens and daxes with respect to the gtens and maxes.
!ccccccccccccccccccccccccccccccc
dtens(:) = Zero
if ((abs(SMAT(1,1)) > abs(SMAT(1,2))) .and. (abs(SMAT(1,1)) > abs(SMAT(1,3)))) then
  ! the WD(1) and ZD(i,1) correspond to gtens(1) and maxes(i,1)
  dtens(1) = WD(1)
  if (SMAT(1,1) > Zero) then
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(1,1) is larger than SMAT(1,2) and SMAT(1,3) and is positive'
    daxes(:,1) = ZD(:,1)
  else
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(1,1) is larger than SMAT(1,2) and SMAT(1,3) and is negative'
    daxes(:,1) = -ZD(:,1)
  end if

else if ((abs(SMAT(1,2)) > abs(SMAT(1,1))) .and. (abs(SMAT(1,2)) > abs(SMAT(1,3)))) then
  ! the WD(1) and ZD(i,1) correspond to gtens(2) and maxes(i,2)
  dtens(1) = WD(2)
  if (SMAT(1,2) > Zero) then
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(1,2) is larger than SMAT(1,1) and SMAT(1,3) and is positive'
    daxes(:,1) = ZD(:,2)
  else
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(1,2) is larger than SMAT(1,1) and SMAT(1,3) and is negative'
    daxes(:,1) = -ZD(:,2)
  end if

else if ((abs(SMAT(1,3)) > abs(SMAT(1,1))) .and. (abs(SMAT(1,3)) > abs(SMAT(1,2)))) then
  ! the WD(1) and ZD(i,1) correspond to gtens(3) and maxes(i,3)
  dtens(1) = WD(3)
  if (SMAT(1,3) > Zero) then
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(1,3) is larger than SMAT(1,1) and SMAT(1,2) and is positive'
    daxes(:,1) = ZD(:,3)
  else
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(1,3) is larger than SMAT(1,1) and SMAT(1,2) and is negative'
    daxes(:,1) = -ZD(:,3)
  end if
end if
!ccccccccccccccccccccccccccccccc

if ((abs(SMAT(2,1)) > abs(SMAT(2,2))) .and. (abs(SMAT(2,1)) > abs(SMAT(2,3)))) then
  ! the WD(2) and ZD(i,2) correspond to gtens(1) and maxes(i,1)
  dtens(2) = WD(1)
  if (SMAT(2,1) > Zero) then
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(2,1) is larger than SMAT(2,2) and SMAT(2,3) and is positive'
    daxes(:,2) = ZD(:,1)
  else
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(2,1) is larger than SMAT(2,2) and SMAT(2,3) and is negative'
    daxes(:,2) = -ZD(:,1)
  end if

else if ((abs(SMAT(2,2)) > abs(SMAT(2,1))) .and. (abs(SMAT(2,2)) > abs(SMAT(2,3)))) then
  ! the WD(2) and ZD(i,2) correspond to gtens(2) and maxes(i,2)
  dtens(2) = WD(2)
  if (SMAT(2,2) > Zero) then
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(2,2) is larger than SMAT(2,1) and SMAT(2,3) and is positive'
    daxes(:,2) = ZD(:,2)
  else
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(2,2) is larger than SMAT(2,1) and SMAT(2,3) and is negative'
    daxes(:,2) = -ZD(:,2)
  end if

else if ((abs(SMAT(2,3)) > abs(SMAT(2,1))) .and. (abs(SMAT(2,3)) > abs(SMAT(2,2)))) then
  ! the WD(2) and ZD(i,2) correspond to gtens(3) and maxes(i,3)
  dtens(2) = WD(3)
  if (SMAT(2,3) > Zero) then
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(2,3) is larger than SMAT(2,1) and SMAT(2,2) and is positive'
    daxes(:,2) = ZD(:,3)
  else
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(2,3) is larger than SMAT(2,1) and SMAT(2,2) and is negative'
    daxes(:,2) = -ZD(:,3)
  end if
end if

!ccccccccccccccccccccccccccccccc
if ((abs(SMAT(3,1)) > abs(SMAT(3,2))) .and. (abs(SMAT(3,1)) > abs(SMAT(3,3)))) then
  ! the WD(3) and ZD(i,3) correspond to gtens(1) and maxes(i,1)
  dtens(3) = WD(1)
  if (SMAT(3,1) > Zero) then
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(3,1) is larger than SMAT(3,2) and SMAT(3,3) and is positive'
    daxes(:,3) = ZD(:,1)
  else
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(3,1) is larger than SMAT(3,2) and SMAT(3,3) and is negative'
    daxes(:,3) = -ZD(:,1)
  end if

else if ((abs(SMAT(3,2)) > abs(SMAT(3,1))) .and. (abs(SMAT(3,2)) > abs(SMAT(3,3)))) then
  ! the WD(3) and ZD(i,3) correspond to gtens(2) and maxes(i,2)
  dtens(3) = WD(2)
  if (SMAT(3,2) > Zero) then
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(3,2) is larger than SMAT(3,1) and SMAT(3,3) and is positive'
    daxes(:,3) = ZD(:,2)
  else
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(3,2) is larger than SMAT(3,1) and SMAT(3,3) and is negative'
    daxes(:,3) = -ZD(:,2)
  end if

else if ((abs(SMAT(3,3)) > abs(SMAT(3,1))) .and. (abs(SMAT(3,3)) > abs(SMAT(3,2)))) then
  ! the WD(3) and ZD(i,3) correspond to gtens(3) and maxes(i,3)
  dtens(3) = WD(3)
  if (SMAT(3,3) > Zero) then
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(3,3) is larger than SMAT(3,1) and SMAT(3,2) and is positive'
    daxes(:,3) = ZD(:,3)
  else
    if (IPRINT > 2) write(u6,'(a)') 'SMAT(3,3) is larger than SMAT(3,1) and SMAT(3,2) and is negative'
    daxes(:,3) = -ZD(:,3)
  end if
end if

call DGEMM_('N','N',3,3,3,One,Z,3,daxes,3,Zero,ZD2,3)

diff12 = abs(dtens(1)-dtens(2))
diff23 = abs(dtens(2)-dtens(3))
diff31 = abs(dtens(3)-dtens(1))

if ((diff12 >= diff23) .and. (diff31 >= diff23)) then
  D_factor = OneHalf*dtens(1)
  E_factor = (dtens(2)-dtens(3))*Half
  Lx = 'Dy'
  Ly = 'Dz'
  Lz = 'Dx'
else if (diff12 > diff31) then
  D_factor = OneHalf*dtens(2)
  E_factor = (dtens(3)-dtens(1))*Half
  Lx = 'Dz'
  Ly = 'Dx'
  Lz = 'Dy'
else
  D_factor = OneHalf*dtens(3)
  E_factor = (dtens(1)-dtens(2))*Half
  Lx = 'Dx'
  Ly = 'Dy'
  Lz = 'Dz'
end if

if (iprint > 2) then
  write(u6,'(20X,A)') 'D-TENSOR:'
  write(u6,*)
  write(u6,'(10X,A,10X,3(F9.5,2X))') '|  xx    xy    xz  |',(DMATR(1,J),J=1,3)
  write(u6,'(10X,A,10X,3(F9.5,2X))') '|  yx    yy    yz  |',(DMATR(2,J),J=1,3)
  write(u6,'(10X,A,10X,3(F9.5,2X))') '|  zx    zy    zz  |',(DMATR(3,J),J=1,3)
  write(u6,*)
end if

if (iprint >= 2) then
  write(u6,*)
  write(u6,'(A)') 'D TENSOR:'
  write(u6,'(2a)') repeat('-',84),'|'
  write(u6,'(A,4x,A,27x,A,21x,a,3x,a)') 'MAIN VALUES','|','MAIN ANISOTROPY AXES','|','x , y , z  -- initial Cartesian axes'
  write(u6,'(6a,3x,a)') repeat('-',15),'|',repeat('-',36),'|',repeat('-',31),'|','Xm, Ym, Zm -- main magnetic axes'
  write(u6,'(15x,a,4x,a,5x,a,8x,a,8x,a,4x,a,5x,a,9x,a,9x,a,5x,a,3x,a)') '|','|','Xm','Ym','Zm','|','x','y','z','|', &
                                                                        'Xa, Ya, Za -- main anisotropy axes'
  write(u6,'(8a)') repeat('-',15),'|',repeat('-',4),'|',repeat('-',31),'|',repeat('-',31),'|'
  write(u6,'(A,F9.3,A,3F10.6,1x,A,3F10.6,1x,A)') ' Dx =',dtens(1),' | Xa |',(daxes(j,1),j=1,3),'|',(ZD2(j,1),j=1,3),'|'
  write(u6,'(A,F9.3,A,3F10.6,1x,A,3F10.6,1x,A)') ' Dy =',dtens(2),' | Ya |',(daxes(j,2),j=1,3),'|',(ZD2(j,2),j=1,3),'|'
  write(u6,'(A,F9.3,A,3F10.6,1x,A,3F10.6,1x,A)') ' Dz =',dtens(3),' | Za |',(daxes(j,3),j=1,3),'|',(ZD2(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',84),'|'
  write(u6,*)
  write(u6,'(A)') '2-nd order ZFS Hamiltonian:'
  write(u6,*)
  write(u6,'(A)') 'H_zfs^{2}= D * [S_{Za}^2 - S*(S+1)/3] + E * [S_{Xa}^2 - S_{Ya}^2]'
  write(u6,*)
  write(u6,'(7a)') 'Anisotropy parameters: D = 3/2 * ',Lz,';  E = (',Lx,'-',Ly,')/2;'
  write(u6,'(a,F12.4)') 'D = ',D_factor
  write(u6,'(a,F12.4)') 'E = ',E_factor
end if

return

end subroutine DMATRIX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CIO_Init(BufFrac,irc)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Initialize coefficient I/O.
C
C     BufFrac, which must be between 0.0d0 and 1.0d0, specifies the
C     fraction of available memory that will at most be allocated as
C     coefficient buffer. The buffer will never exceed the max needed
C     memory.
C
      Implicit None
      Real*8 BufFrac
      Integer irc
#include "WrkSpc.fh"
#include "ldf_cio.fh"
#include "ldf_atom_pair_info.fh"

#if defined (_DEBUGPRINT_)
      Character*12 SecNam
      Parameter (SecNam='LDF_CIO_Init')
      Real*8 Byte
      Character*2 Unt
#endif

      Integer  LDF_X_OpenCoefficientFile
      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_X_OpenCoefficientFile
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Logical CFileExists

      Real*8 Frac

      Integer ip, l
      Integer lBuf_Max
      Integer iAtomPair
      Integer iAtom, jAtom
      Integer iAddr

      Integer i, j
      Integer AP_DiskC
      Integer AP_Atoms
      AP_DiskC(i)=iWork(ip_AP_DiskC-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Init return code
      irc=0

      ! Init variables in ldf_cio.fh
      Lu_LDFC=0
      ip_LDFC_Buffer=0
      l_LDFC_Buffer=0
      ip_LDFC_Blocks=0
      l_LDFC_Blocks=0
      LastAtomPair=0

      ! Check that the coefficient file exists
      Call f_Inquire('LDFC',CFileExists)
      If (.not.CFileExists) Then
         irc=-1
#if defined (_DEBUGPRINT_)
         Write(6,'(/,A,A)') SecNam,': Coefficient file not found!!'
         Call xFlush(6)
#endif
         Return
      End If

      ! Open coefficient file
      Lu_LDFC=LDF_X_OpenCoefficientFile()

      ! Normalize BufFrac
      Frac=min(max(BufFrac,0.0d0),1.0d0)

      ! Return if no buffer requested
      If (Frac.lt.1.0d-14) Then
#if defined (_DEBUGPRINT_)
         ! Set lBuf_Max for the sake of printing
         lBuf_Max=0
#endif
         Go To 1  ! return
      End If

      ! Allocate AP block pointer array
      Call GetMem('MaxiMem','Max ','Inte',ip,l)
      If (l.lt.NumberOfAtomPairs) Return ! insufficient memory
      l_LDFC_Blocks=NumberOfAtomPairs
      Call GetMem('LDFC_Blk','Allo','Inte',ip_LDFC_Blocks,l_LDFC_Blocks)

      ! Compute max buffer size
      Call GetMem('MaxMem','Max ','Real',ip,l)
      lBuf_Max=int(Frac*dble(l))
      If (lBuf_Max.lt.1) Then ! no memory available
         Call GetMem('LDFC_Blk','Free','Inte',
     &               ip_LDFC_Blocks,l_LDFC_Blocks)
         ip_LDFC_Blocks=0
         l_LDFC_Blocks=0
         Go To 1  ! return
      End If

      ! Compute buffer size
      l=0
      iAtomPair=0
      Do While (l.lt.lBuf_Max .and. iAtomPair.lt.NumberOfAtomPairs)
         iAtomPair=iAtomPair+1
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         l=l
     &    +LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
     &    *LDF_nBasAux_Pair(iAtomPair)
         If (l.le.lBuf_Max) Then
            LastAtomPair=iAtomPair
            l_LDFC_Buffer=l
         End If
      End Do

      If (l_LDFC_Buffer.gt.0) Then
         ! Reallocate AP block pointer array
         If (LastAtomPair.lt.NumberOfAtomPairs) Then
            Call GetMem('LDFC_Blk','Free','Inte',
     &                  ip_LDFC_Blocks,l_LDFC_Blocks)
            l_LDFC_Blocks=LastAtomPair
            Call GetMem('LDFC_Blk','Allo','Inte',
     &                  ip_LDFC_Blocks,l_LDFC_Blocks)
         End If
         ! Allocate buffer
         Call GetMem('CBuffer','Allo','Real',
     &               ip_LDFC_Buffer,l_LDFC_Buffer)
         ! Read coefficients
         ip=ip_LDFC_Buffer
         Do iAtomPair=1,LastAtomPair
            iAtom=AP_Atoms(1,iAtomPair)
            jAtom=AP_Atoms(2,iAtomPair)
            l=LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
     &       *LDF_nBasAux_Pair(iAtomPair)
            iAddr=AP_DiskC(iAtomPair)
            Call dDAFile(Lu_LDFC,2,Work(ip),l,iAddr)
            iWork(ip_LDFC_Blocks-1+iAtomPair)=ip
            ip=ip+l
         End Do
#if defined (_DEBUGPRINT_)
         If (ip.ne.(ip_LDFC_Buffer+l_LDFC_Buffer)) Then
            Call WarningMessage(2,SecNam//': buffer error!')
            Call LDF_Quit(1)
         End If
#endif
      End If

    1 Continue
#if defined (_DEBUGPRINT_)
      Write(6,'(/,A,A)')
     & SecNam,': coefficient I/O has been initialized!'
      Call Cho_Head('LDF coefficient buffer info','=',80,6)
      Write(6,'(A,F9.4)')
     & 'Max memory fraction (input).......',BufFrac
      Write(6,'(A,F9.4)')
     & 'Max memory fraction (normalized)..',Frac
      Call Cho_Word2Byte(lBuf_Max,8,Byte,Unt)
      Write(6,'(A,I9,A,F7.2,1X,A,A)')
     & 'Max possible buffer size..........',lBuf_Max,' words (',
     & Byte,Unt,')'
      Call Cho_Word2Byte(l_LDFC_Buffer,8,Byte,Unt)
      Write(6,'(A,I9,A,F7.2,1X,A,A)')
     & 'Allocated buffer..................',l_LDFC_Buffer,' words (',
     & Byte,Unt,')'
      Write(6,'(A,I9)')
     & 'Total number of atom pairs........',NumberOfAtomPairs
      If (NumberOfAtomPairs.gt.0) Then
         Write(6,'(A,I9,A,F7.2,A)')
     &   'Number of atom pairs in buffer....',LastAtomPair,
     &   ' (',1.0d2*dble(LastAtomPair)/dble(NumberOfAtomPairs),'%)'
      Else
         Write(6,'(A,I9)')
     &   'Number of atom pairs in buffer....',LastAtomPair
      End If
      If (LastAtomPair.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,
     &                     SecNam//': LastAtomPair > NumberOfAtomPairs')
         Call LDF_Quit(1)
      End If
      Write(6,*)
      Call xFlush(6)
#endif

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Tra2B(iSym,jSym,
     &                 iBas,jBas,
     &                 iAsh,jAsh,
     &                 iOrb,jOrb,
     &                 ikl,nkl,
     &                 CMO_ip,CMO_jp,CMO_ia,CMO_ja,
     &                 VXIJ,X2,X3_ip,X3_jp,PUVX_jp,PUVX_ip)
************************************************************************
*                                                                      *
*     run the second half of the AO --> MO transformation with         *
*     one active and one general index, i.e.                           *
*     (vx!ij) --> (vx!up)                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 VXIJ(*), X2(*)
      Real*8 CMO_ip(iBas*iOrb), CMO_ia(iBas*iAsh),
     &       CMO_jp(jBas*jOrb), CMO_ja(jBas*jAsh),
     &       X3_jp(jAsh,iOrb),  X3_ip(iAsh,jOrb),
     &       PUVX_jp(iOrb,jAsh,nkl), PUVX_ip(jOrb,iAsh,nkl)
*
*
      If ( jAsh*iOrb.ne.0 ) then
        Call DGEMM_('T','N',
     &              iBas,jAsh,jBas,
     &              1.0d0,VXIJ,jBas,
     &              CMO_ja,jBas,
     &              0.0d0,X2,iBas)
*
        Call DGEMM_('T','N',
     &              jAsh,iOrb,iBas,
     &              1.0d0,X2,iBas,
     &              CMO_ip,iBas,
     &              0.0d0,X3_jp,jAsh)
*
        Do i = 1,jAsh
          Do j = 1,iOrb
            PUVX_jp(j,i,ikl) = X3_jp(i,j)
          End Do
        End Do
      End If
*
      If ( iSym.ne.jSym .and. iAsh*jOrb.ne.0 ) then
        Call DGEMM_('N','N',
     &              jBas,iAsh,iBas,
     &              1.0d0,VXIJ,jBas,
     &              CMO_ia,iBas,
     &              0.0d0,X2,jBas)
*
        Call DGEMM_('T','N',
     &              iAsh,jOrb,jBas,
     &              1.0d0,X2,jBas,
     &              CMO_jp,jBas,
     &              0.0d0,X3_ip,iAsh)
*
        Do i = 1,iAsh
          Do j = 1,jOrb
            PUVX_ip(j,i,ikl) = X3_ip(i,j)
          End Do
        End Do
      End If
*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!***********************************************************************

subroutine INPUT_GUGA(L0,L1,L2,L3,ISPAC)

use guga_global, only: IADD10, ICASE, ICH, IFIRST, ILIM, IPRINT, ISPIN, JRC, LN, LNP, Lu_10, MXVERT, N, NIORB, NSM, NSYM, S
use guga_util_global, only: IAD10, nIOCR
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half
use Definitions, only: iwp, u5, u6

implicit none
integer(kind=iwp), intent(out) :: L0(4*MXVERT), L1(4*MXVERT), L2(4*MXVERT), L3(4*MXVERT), ISPAC
#include "warnings.h"
integer(kind=iwp), parameter :: mxTit = 10, nCmd = 18
integer(kind=iwp) :: I, ICIALL, iCmd, ICOR(55), IFCORE, IN_, IN1, IN2, IN3, INTNUM, IOM, IONE(8), iOpt, IR, IR1, IR2, iRef, &
                     istatus, ISUM, IVER, J, jCmd, jEnd, JJS(18), JONE(8), jStart, LN1, LN2, LSYM, LV, MN, MX, NACTEL, NCOR(8), &
                     NCORI, NFREF, NISH(8), NISHI, NISHT, nJJS, nJRC, NN, NO, NONE_, NREF, NRLN1, NSH(8), NSHI, nTit, NVAL(8), NVALI
logical(kind=iwp) :: skip
character(len=132) :: ModLine
character(len=72) :: Line, Title(mxTit)
character(len=4) :: Command
integer(kind=iwp), allocatable :: IOCR(:), JREFX(:), JSY(:)
integer(kind=iwp), parameter :: MLL(64) = [1,2,3,4,5,6,7,8,2,1,4,3,6,5,8,7,3,4,1,2,7,8,5,6,4,3,2,1,8,7,6,5,5,6,7,8,1,2,3,4,6,5,8, &
                                           7,2,1,4,3,7,8,5,6,3,4,1,2,8,7,6,5,4,3,2,1]
character(len=4), parameter :: Cmd(nCmd) = ['TITL','ELEC','SPIN','SYMM','ACTI','PRIN','REFE','FIRS','INAC','CIAL','VALE','INTE', &
                                            'NOCO','ONEO','EXTR','NONI','NACT','END ']

!---  Initialize data and variables -----------------------------------*
IOM = 55
IVER = MXVERT
IFIRST = 0
IPRINT = 0
ICIALL = 0
ILIM = 4
N = -1
NACTEL = -1
NISHT = 0
!NSYM = 1
call Get_iScalar('nSym',NSYM)
NREF = 0
!PAM97 New default: Interacting space.
INTNUM = 1
!PAM97 IFCORE /= 0 means core-polarization orbitals (NOCO keyword).
IFCORE = 0
LSYM = 1
do I=1,8
  NISH(I) = 0
  NVAL(I) = 0
  NCOR(I) = 0
  NSH(I) = 0
  IONE(I) = 0
end do
do I=1,55
  ICOR(I) = 0
end do
nTit = 0
jCmd = 0
call mma_allocate(IOCR,nIOCR,label='IOCR')

!---  Read input from standard input ----------------------------------*
call RdNLst(u5,'GUGA')
skip = .false.
do
  if (skip) then
    skip = .false.
  else
    read(u5,'(A)',iostat=istatus) Line
    if (istatus < 0) call Error(1)
    Command = Line(1:8)
    call UpCase(Command)
    if (Command(1:1) == '*') cycle
    if (Command == ' ') cycle
    jCmd = 0
    do iCmd=1,nCmd
      if (Command == Cmd(iCmd)) jCmd = iCmd
    end do
  end if
  select case (jCmd)
    case default
      write(u6,*) 'Input: Illegal Keyword'
      write(u6,'(A,A)') 'Command=',Command
      call Quit(_RC_INPUT_ERROR_)
    case (1)
      !---  process TITLE    command ----------------------------------*
      do
        do
          read(u5,'(A)',iostat=istatus) Line
          if (istatus < 0) call Error(1)
          Command = Line(1:8)
          call UpCase(Command)
          if (Command(1:1) /= '*') exit
        end do
        jCmd = 0
        do iCmd=1,nCmd
          if (Command == Cmd(iCmd)) jCmd = iCmd
        end do
        if (jCmd /= 0) then
          skip = .true.
          exit
        end if
        nTit = nTit+1
        if (nTit <= mxTit) Title(nTit) = Line
      end do
    case (2)
      !---  process ELECTRON command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) N
      if (istatus > 0) call Error(2)
    case (3)
      !---  process SPIN     command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) ISPIN
      if (istatus > 0) call Error(2)
    case (4)
      !---  process SYMMETRY command ----------------------------------*
      write(u6,*) 'Input_GUGA: keyword SYMMETRY is obsolete and ignored!'
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) I
      if (istatus > 0) call Error(2)
    case (5)
      !---  process ACTIVE   command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      ModLine = Line//' 0 0 0 0 0 0 0 0'
      read(ModLine,*,iostat=istatus) (NSH(I),I=1,8)
      if (istatus > 0) call Error(2)
    case (6)
      !---  process PRINT    command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) IPRINT
      if (istatus > 0) call Error(2)
    case (7)
      !---  process REFERENC command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) nRef,LN1
      if (istatus > 0) call Error(2)
      if (LN1 /= 0) then
        jEnd = 0
        do iRef=1,nRef
          jStart = jEnd+1
          jEnd = jEnd+LN1
          read(u5,'(80I1)',iostat=istatus) (IOCR(j),j=jStart,jEnd)
          if (istatus < 0) call Error(1)
          if (istatus > 0) call Error(2)
        end do
      end if
    case (8)
      !---  process FIRST    command ----------------------------------*
      IFIRST = 1
      ILIM = 2
    case (9)
      !---  process INACTIVE command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      ModLine = Line//' 0 0 0 0 0 0 0 0'
      read(ModLine,*,iostat=istatus) (NISH(I),I=1,8)
      if (istatus > 0) call Error(2)
      NISHT = 0
      do I=1,8
        NISHT = NISHT+NISH(I)
      end do
    case (10)
      !---  process CIALL    command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) LSYM
      if (istatus > 0) call Error(2)
      ICIALL = 1
    case (11)
      !---  process VALENCE  command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      ModLine = Line//' 0 0 0 0 0 0 0 0'
      read(ModLine,*,iostat=istatus) (NVAL(I),I=1,8)
      if (istatus > 0) call Error(2)
    case (12)
      !---  process INTERACT command ----------------------------------*
      INTNUM = 1
    case (13)
      !---  process NOCORR   command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      ModLine = Line//' 0 0 0 0 0 0 0 0'
      read(ModLine,*,iostat=istatus) (NCOR(I),I=1,8)
      if (istatus > 0) call Error(2)
      !PAM97 IFCORE was not set -- assume bug. Following line inserted:
      IFCORE = 1
    case (14)
      !---  process ONEOCC   command ----------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      ModLine = Line//' 0 0 0 0 0 0 0 0'
      read(ModLine,*,iostat=istatus) (IONE(I),I=1,8)
      if (istatus > 0) call Error(2)
    case (15)
      !---  process EXTRACT  command ----------------------------------*
      write(u6,*) 'Input: EXTRACT option is redundant and is ignored!'
    case (16)
      !---  process NON-INTERACT command ------------------------------*
      INTNUM = 0
    case (17)
      !---  process NACTEL       command ------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) NACTEL
      if (istatus > 0) call Error(2)
    case (18)
      exit
  end select
end do
!---  The end of the input is reached, print the title ----------------*
if (ntit == 0) then
  ntit = 1
  title(1) = ' (No title was given)'
end if

! Nr of correlated electrons:
if ((N == -1) .and. (NACTEL == -1)) then
  write(u6,*) ' Neither the number of correlated electrons (Keyword ELECTRONS)'
  write(u6,*) ' nor the nr of active electrons in the reference space (NACTEL) has been specified.'
  write(u6,*) ' The number of active electrons are set to zero.'
  NACTEL = 0
else if ((N > -1) .and. (NACTEL > -1)) then
  write(u6,*) ' Both the number of correlated electrons (Keyword ELECTRONS)'
  write(u6,*) ' and the nr of active electrons in the reference space (NACTEL) have been specified.'
  if (N /= 2*NISHT+NACTEL) then
    N = 2*NISHT+NACTEL
    write(u6,*) ' Number of correlated electrons is recomputed,=',N
  end if
end if
if (N == -1) N = 2*NISHT+NACTEL
if (NACTEL == -1) NACTEL = N-2*NISHT

write(u6,*)
write(u6,'(6X,120A1)') ('*',i=1,120)
write(u6,'(6X,120A1)') '*',(' ',i=1,118),'*'
write(u6,'(6X,57A1,A6,57A1)') '*',(' ',i=1,56),'Title:',(' ',i=1,56),'*'
do i=1,nTit
  call Center_Text(Title(i))
  write(u6,'(6X,24A1,A72,24A1)') '*',(' ',j=1,23),Title(i),(' ',j=1,23),'*'
end do
write(u6,'(6X,120A1)') '*',(' ',i=1,118),'*'
write(u6,'(6X,120A1)') ('*',i=1,120)
write(u6,*)
S = (ISPIN-1)*Half
if (IFIRST == 0) write(u6,2)
if (IFIRST /= 0) write(u6,1)
write(u6,110) N,S
write(u6,109) (I,I=1,NSYM)
write(u6,106) (NISH(I),I=1,NSYM)
write(u6,108) (NSH(I),I=1,NSYM)
write(u6,208) (NVAL(I),I=1,NSYM)
write(u6,206) (NCOR(I),I=1,NSYM)
write(u6,209) (IONE(I),I=1,NSYM)
LN = 0
LV = 0
NIORB = 0
do I=1,NSYM
  NIORB = NIORB+NISH(I)
  LN = LN+NSH(I)+NISH(I)
  LV = LV+NVAL(I)
end do
NONE_ = 0
IN_ = LV+NIORB
do I=1,NSYM
  NN = IONE(I)
  do NO=1,NN
    NONE_ = NONE_+1
    IN_ = IN_+1
    JONE(NONE_) = IN_
  end do
  IN_ = IN_+NSH(I)-NN
end do
LN = LN+LV
if (ICIALL == 1) LN1 = LN-LV-NIORB
if (LN /= LN1+LV+NIORB) then
  write(u6,*) 'Input: LN /= LN1+LV+NIORB'
  write(u6,*) 'LN,LN1,LV,NIORB=',LN,LN1,LV,NIORB
  call Quit(_RC_INPUT_ERROR_)
end if
LNP = LN*(LN+1)/2
IN_ = 0
IN3 = 0
IN1 = LV
IN2 = NIORB+LV
do I=1,NSYM
  NISHI = NISH(I)
  NSHI = NSH(I)
  NVALI = NVAL(I)
  NCORI = NCOR(I)
  do J=1,NVALI
    IN3 = IN3+1
    IN_ = IN_+1
    NSM(IN3) = I
    ICH(IN_) = IN3
  end do
  do J=1,NISHI
    IN1 = IN1+1
    IN_ = IN_+1
    NSM(IN1) = I
    ICH(IN_) = IN1
    if (J <= NCORI) ICOR(IN1) = 1
  end do
  do J=1,NSHI
    IN2 = IN2+1
    IN_ = IN_+1
    NSM(IN2) = I
    ICH(IN_) = IN2
  end do
end do
if (LN > IOM) then
  write(u6,*) 'Input: LN > IOM'
  write(u6,*) 'LN,IOM=',LN,IOM
  call Quit(_RC_INPUT_ERROR_)
end if
call TAB2F(IVER-1,LV)
call TAB2(NREF,IOCR,nIOCR,L0,L1,L2,L3,INTNUM,LV,LSYM,ICIALL,IFCORE,ICOR,NONE_,JONE)
LN2 = LN1
if (LN1 > 8) LN2 = 16
if (LN1 == 0) then
  write(u6,55)
else
  write(u6,107) (I,I=1,LN2)
  NO = N-2*NIORB
  MX = 0
  do IREF=1,NREF
    MN = MX+1
    MX = MX+LN1
    write(u6,112) IREF,(IOCR(J),J=MN,MX)

    ! Sum up the occupation numbers of the first reference:
    ISUM = 0
    do I=1,LN1
      ISUM = ISUM+IOCR(MN+I-1)
    end do
    if (ISUM /= NO) then
      write(u6,*) ' Summed occupation nums of this reference does'
      write(u6,*) ' not match nr of electrons.'
      write(u6,*) ' In closed shells: 2*NIORB=',2*NIORB
      write(u6,*) ' Summed occupation nums   =',NO
      write(u6,*) ' Sum total is             =',2*NIORB+NO
      write(u6,*) ' But input says nr of elec=',N
      call Quit(_RC_INPUT_ERROR_)
    end if
  end do
end if

! Here with ILIM=2 (FIRST command) or 4 (normal, default).
call mma_allocate(JSY,3000,label='JSY')
call mma_allocate(JREFX,9000,label='JREFX')
call CONFIG(NREF,IOCR,nIOCR,L0,L1,L2,L3,JSY,INTNUM,LSYM,JJS,LV,IFCORE,ICOR,NONE_,JONE,JREFX,NFREF)
IR = JRC(ILIM)
ISPAC = IR*LNP
if (IPRINT >= 2) write(u6,9) ISPAC
NRLN1 = NREF*LN1
if (LN1 == 0) NRLN1 = 1
!PAM97 IR1 = (LN*IR+29)/30
IR1 = (LN*IR+14)/15
IR2 = (IR+9)/10

iOpt = 1
nJJS = size(JJS)
nJRC = size(JRC)
call WR_GUGA(Lu_10,iOpt,IADD10,NFREF,S,N,LN,NSYM,IR1,IR2,IFIRST,INTNUM,LSYM,NREF,LN1,NRLN1,NSH,NISH,8,JRC,nJRC,JJS,nJJS,NVAL,IOCR, &
             nIOCR)
call iDAFILE(Lu_10,1,ICASE,IR1,IADD10)
call iDAFILE(Lu_10,1,JSY,IR2,IADD10)
IAD10(2) = IADD10
call iDAFILE(Lu_10,1,JREFX,JRC(1),IADD10)
call mma_deallocate(IOCR)
call mma_deallocate(JREFX)
call mma_deallocate(JSY)

return

1 format(//,6X,'ONLY SINGLE REPLACEMENTS INCLUDED')
2 format(//,6X,'ALL SINGLE AND DOUBLE REPLACEMENTS')
9 format(//,6X,'ELEMENTS TO BE SORTED',I7)
55 format(//,6X,'ONE CLOSED SHELL REFERENCE STATE')
106 format(6X,'INACTIVE',8I5)
107 format(//,6X,'OCCUPATION OF REFERENCE STATES',//,6X,'REF.STATE',2X,'ORB:',I2,15I4)
108 format(6X,'ACTIVE  ',8I5)
109 format(//,14X,'ORBITALS PER SYMMETRY',/,14X,8I5)
110 format(/,6X,'NUMBER OF ELECTRONS IN CI',I10,/,6X,'TOTAL SPIN QUANTUM NUMBER',F10.2)
112 format(6X,I5,8X,16I4)
206 format(6X,'CORE    ',8I5)
208 format(6X,'VALENCE ',8I5)
209 format(6X,'ONEOCC  ',8I5)

contains

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  if (code == 1) then
    write(u6,*) 'Input: End of input file encountered'
  else if (code == 2) then
    write(u6,*) 'Input: Error while reading input!'
  end if
  write(u6,'(A,A)') 'Last Command: ',Command
  call Quit(_RC_INPUT_ERROR_)

end subroutine Error

end subroutine INPUT_GUGA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  RdChoVec
*
*> @brief
*>   Read dense Cholesky vectors in SO basis
*> @author T. B. Pedersen
*>
*> @details
*> Read dense SO Cholesky vectors \f$ L^J_{pq} \f$ where
*> \f$ J \f$ = \p iVec1, \p iVec1+1, ..., \p iVec1+nVec-1 and indices
*> \f$ p \ge q \f$.
*>
*> @note
*> Cholesky vectors must have been sorted into the
*> dense representation (by the Cholesky utility)
*> and the storage file must be open.
*>
*> @param[out] Vec   Array containing the vectors
*> @param[in]  nDim  Vector dimension
*> @param[in]  nVec  Number of vectors
*> @param[in]  iVec1 Index of first vector
*> @param[in]  Lunit Logical unit number
************************************************************************
      SubRoutine RdChoVec(Vec,nDim,nVec,iVec1,Lunit)
      Implicit None
      Real*8 Vec(*)
      Integer nDim, nVec, iVec1, Lunit

      Integer iOpt, iAdr, nTot

      iOpt = 2
      iAdr = nDim*(iVec1 - 1) + 1
      nTot = nDim*nVec
      Call dDaFile(Lunit,iOpt,Vec,nTot,iAdr)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c  ********************************************************
c  ** Public-domain library routines used by casvb only. **
c  ********************************************************
c  **********************
c  ** EISPACK ROUTINES **
c  **********************
      subroutine balbak(nm,n,low,igh,scale,m,z)
c
      integer i,j,k,m,n,ii,nm,igh,low
      REAL*8 scale(n),z(nm,m)
      REAL*8 s
c
c     this subroutine is a translation of the algol procedure balbak,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine forms the eigenvectors of a real general
c     matrix by back transforming those of the corresponding
c     balanced matrix determined by  balanc.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by  balanc.
c
c        scale contains information determining the permutations
c          and scaling factors used by  balanc.
c
c        m is the number of columns of z to be back transformed.
c
c        z contains the real and imaginary parts of the eigen-
c          vectors to be back transformed in its first m columns.
c
c     on output
c
c        z contains the real and imaginary parts of the
c          transformed eigenvectors in its first m columns.
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (m .eq. 0) go to 200
      if (igh .eq. low) go to 120
c
      do 110 i = low, igh
         s = scale(i)
c     .......... left hand eigenvectors are back transformed
c                if the foregoing statement is replaced by
c                s=1.0d0/scale(i). ..........
         do 100 j = 1, m
         z(i,j) = z(i,j) * s
  100    continue
c
  110 continue
c     ......... for i=low-1 step -1 until 1,
c               igh+1 step 1 until n do -- ..........
  120 do 140 ii = 1, n
         i = ii
         if (i .ge. low .and. i .le. igh) go to 140
         if (i .lt. low) i = low - ii
         k = Int(scale(i))
         if (k .eq. i) go to 140
c
         do 130 j = 1, m
            s = z(i,j)
            z(i,j) = z(k,j)
            z(k,j) = s
  130    continue
c
  140 continue
c
  200 return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetAtomInfo(Verbose,irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: Set atom info stored in ldf_atom_info.fh
C
C       NumberOfAtoms = #atoms
C
C       Coord(i,iAtom): x,y,z (i=1,2,3) coordinates of atom iAtom
C
C       A_Unique(iAtom): unique atom corresponding to atom iAtom
C
C       A_Shells(1,iAtom) = #valence shells on atom iAtom
C       A_Shells(2,iAtom) = pointer to list of valence shells on atom
C                           iAtom
C
C       A_AuxShells(1,iAtom)=#auxiliary shells on atom iAtom
C       A_AuxShells(2,iAtom)=pointer to list of auxiliary shells on atom
C                            iAtom
C
C     To unset the information (incl. deallocations), call
C       LDF_UnsetAtomInfo
C
C     To access the data, use the functions described in
C       ldf_atom_info.fh
C
C     Return codes:
C       irc=0: success
C       irc=1: already set
C
      Implicit None
      Logical Verbose
      Integer irc
#include "ldf_atom_info.fh"
#include "localdf_bas.fh"
#include "WrkSpc.fh"

      Character*15 SecNam
      Parameter (SecNam='LDF_SetAtomInfo')

      Logical FirstCall
      Save FirstCall
      Data FirstCall /.True./

      ! Set return code
      irc=0

      ! If already set, print warning message and return
      If (FirstCall) Then
         FirstCall=.False.
      Else
         If (LDF_AtomInfo_Status.eq.LDF_AtomInfo_Set) Then
            If (Verbose) Then
               Call WarningMessage(1,
     &                           SecNam//': LDF Atom Info already set!')
            End If
            irc=1
            Return
         End If
      End If

      ! Get number of atoms
      Call Get_iScalar('Bfn Atoms',NumberOfAtoms)

      ! Allocate and get atomic coordinates
      l_Coord=3*NumberOfAtoms
      Call GetMem('LDF_Coord','Allo','Real',ip_Coord,l_Coord)
      Call Get_dArray('Bfn Coordinates',Work(ip_Coord),l_Coord)

      ! Allocate and get unique atoms
      ! Note: this MUST be done after coordinate fetching...
      l_A_Unique=NumberOfAtoms
      Call GetMem('A_Unique','Allo','Inte',ip_A_Unique,l_A_Unique)
      Call LDF_GetAtomToUniqueAtomMap(iWork(ip_A_Unique),l_A_Unique)

      ! Allocate and set A_Shells and A_AuxShells:
      ! A_Shells(1,iAtom)=#shells on atom iAtom
      ! A_Shells(2,iAtom)=pointer to list of shells on atom iAtom
      ! A_AuxShells(1,iAtom)=#auxiliary shells on atom iAtom
      ! A_AuxShells(2,iAtom)=pointer to list of auxiliary shells on atom
      !                      iAtom
      l_A_Shells=2*NumberOfAtoms
      l_A_AuxShells=l_A_Shells
      Call GetMem('A_Shells','Allo','Inte',ip_A_Shells,l_A_Shells)
      Call GetMem('A_AuxShells','Allo','Inte',ip_A_AuxShells,
     &                                         l_A_AuxShells)
      Call LDF_SetAtomInfo_(nShell_Valence,nShell_Auxiliary,
     &                      NumberOfAtoms,
     &                      iWork(ip_A_Shells),iWork(ip_A_AuxShells))

      ! Mark info set
      LDF_AtomInfo_Status=LDF_AtomInfo_Set

      ! Print
      If (Verbose) Then
         Call LDF_PrintAtomInfo()
      End If

      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_SetAtomInfo_(nShell_Valence,nShell_Auxiliary,nAtom,
     &                            A_Shells,A_AuxShells)
      use iSD_data
      Implicit None
      Integer nShell_Valence, nShell_Auxiliary, nAtom
      Integer A_Shells(2,nAtom), A_AuxShells(2,nAtom)
#include "WrkSpc.fh"
#include "nsd.fh"
#include "setup.fh"

      Character*6 Label

      Integer iShell, jShell, iAtom
      Integer ip_Countr, l_Countr
      Integer ip, l

      Integer i
      Integer AtomOfShell
      AtomOfShell(i)=iSD(10,i)

C     Allocate scratch memory.
C     ========================

      l_Countr=nAtom
      Call GetMem('Countr','Allo','Inte',ip_Countr,l_Countr)

C     Set A_Shells
C     ============

      ! Zero A_Shells
      Call iZero(A_Shells,2*nAtom)

      ! Count number of valence shells on each atom
      Do iShell=1,nShell_Valence
         iAtom=AtomOfShell(iShell)
         A_Shells(1,iAtom)=A_Shells(1,iAtom)+1
      End Do

      ! Allocate atomic valence shell lists
      Do iAtom=1,nAtom
         l=A_Shells(1,iAtom)
         If (l.gt.0) Then
            Write(Label,'(A,I4.4)') 'SA',iAtom-1
            Call GetMem(Label,'Allo','Inte',ip,l)
            A_Shells(2,iAtom)=ip
         End If
      End Do

      ! Set atomic valence shell lists
      Call iZero(iWork(ip_Countr),l_Countr)
      Do iShell=1,nShell_Valence
         iAtom=AtomOfShell(iShell)
         iWork(ip_Countr-1+iAtom)=iWork(ip_Countr-1+iAtom)+1
         jShell=iWork(ip_Countr-1+iAtom)
         iWork(A_Shells(2,iAtom)-1+jShell)=iShell
      End Do

C     Set A_AuxShells
C     ===============

      ! Zero A_AuxShells
      Call iZero(A_AuxShells,2*nAtom)

      ! Count number of auxiliary shells on each atom
      Do iShell=nShell_Valence+1,nShell_Valence+nShell_Auxiliary
         iAtom=AtomOfShell(iShell)
         A_AuxShells(1,iAtom)=A_AuxShells(1,iAtom)+1
      End Do

      ! Allocate atomic auxiliary shell lists
      Do iAtom=1,nAtom
         l=A_AuxShells(1,iAtom)
         If (l.gt.0) Then
            Write(Label,'(A,I4.4)') 'AA',iAtom-1
            Call GetMem(Label,'Allo','Inte',ip,l)
            A_AuxShells(2,iAtom)=ip
         End If
      End Do

      ! Set atomic auxiliary shell lists
      Call iZero(iWork(ip_Countr),l_Countr)
      Do iShell=nShell_Valence+1,nShell_Valence+nShell_Auxiliary
         iAtom=AtomOfShell(iShell)
         iWork(ip_Countr-1+iAtom)=iWork(ip_Countr-1+iAtom)+1
         jShell=iWork(ip_Countr-1+iAtom)
         iWork(A_AuxShells(2,iAtom)-1+jShell)=iShell
      End Do

C     Free scratch memory
C     ===================

      Call GetMem('Countr','Free','Inte',ip_Countr,l_Countr)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Gen_Prim_Density_Matrix(nBas,nPrim,ip_D_p,nOcOb,
     &           oNum,oCof)

      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Dimension oNum(nBas)
      Dimension oCof(nBas,nPrim)

      Call GetMem('D_p','ALLO','REAL',ip_D_p,nPrim*(nPrim+1)/2)
       Do K = 1 , nPrim
        Do L = 1 , K
         Work(ip_D_p+k*(k-1)/2+l-1) = 0.0d0
        EndDo
       EndDo
       Do K=1,nPrim
         Do L=1,K
           Do i=1,nOcOb
             Work(ip_D_p+k*(k-1)/2+l-1) = Work(ip_D_p+k*(k-1)/2+l-1) +
     &       oNum(I)*oCof(I,K)*oCof(I,L)
           EndDo
         EndDo
       EndDo


      Return
      End
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CIO_ReadC(iAtomPair,C,l_C)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Read LDF fitting coefficients for atom pair iAtomPair.
C              The coefficients are read from memory (buffer) if
C              possible (though the caller need not worry about that).
C              Columns of C corresponding to linearly dependent
C              auxiliary (one-center) functions are excluded, i.e.
C              C contains only linearly independent columns.
C              For reading with linearly dependent columns,
C              use LDF_CIO_ReadC_WithLinDep.
C
      Implicit None
      Integer iAtomPair
      Integer l_C
      Real*8  C(l_C)
#include "WrkSpc.fh"
#include "ldf_cio.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Integer iAddr
      Integer iAtom, jAtom
      Integer l

#if defined (_DEBUGPRINT_)
      Real*8 Byte
      Character*2 Unt
#endif

      Integer i, j
      Integer AP_DiskC, AP_Atoms
      AP_DiskC(i)=iWork(ip_AP_DiskC-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      If (Lu_LDFC.lt.1) Then
         Call WarningMessage(2,'LDF_CIO_ReadC: Lu_LDFC<1')
         Call LDF_Quit(1)
      End If

      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)
      l=LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
     & *LDF_nBasAux_Pair(iAtomPair)
      If (l.gt.l_C) Then
         Call WarningMessage(2,
     &                    'LDF_CIO_ReadC: insufficient array dimension')
         Call LDF_Quit(1)
      End If

      If (iAtomPair.gt.LastAtomPair) Then ! read from disk
         iAddr=AP_DiskC(iAtomPair)
         Call dDAFile(Lu_LDFC,2,C,l,iAddr)
#if defined (_DEBUGPRINT_)
         Call Cho_Word2Byte(l,8,Byte,Unt)
         Write(6,'(A,I9,A,I9,A,F7.2,A,A)')
     &   'LDF_CIO_ReadC: atom pair=',iAtomPair,' Dim=',l,' (',Byte,Unt,
     &   ') coefficients read from disk'
         Call xFlush(6)
#endif
      Else ! copy from buffer
         iAddr=iWork(ip_LDFC_Blocks-1+iAtomPair)
         Call dCopy_(l,Work(iAddr),1,C,1)
#if defined (_DEBUGPRINT_)
         Call Cho_Word2Byte(l,8,Byte,Unt)
         Write(6,'(A,I9,A,I9,A,F7.2,A,A)')
     &   'LDF_CIO_ReadC: atom pair=',iAtomPair,' Dim=',l,' (',Byte,Unt,
     &   ') coefficients copied from buffer'
         Call xFlush(6)
#endif
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function ExtNuc(Ext,natom)
! Compute Z - ExtPot interactions

use espf_global, only: MxExtPotComp
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: natom
real(kind=wp), intent(in) :: Ext(MxExtPotComp,natom)
integer(kind=iwp) :: INuc, iPL, Len
real(kind=wp) :: E, ExtNuc
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: Charge(:)
integer(kind=iwp), external :: iPL_espf

iPL = iPL_espf()

call qpg_dArray('Effective nuclear Charge',Found,Len)

if (Found) then
  call mma_allocate(Charge,Len,Label='Charge')
  if (Len /= nAtom) then
    write(u6,*) 'ExtNuc: Len /= nAtom'
    call Abend()
  end if
else
  write(u6,*) 'ExtNuc: Effective nuclear Charges not found.'
  call Abend()
end if
call Get_dArray('Effective nuclear Charge',Charge,nAtom)

E = Zero
do INuc=1,natom
  E = E+Charge(iNuc)*Ext(1,INuc)
end do
if ((E /= zero) .and. (iPL >= 3)) then
  write(u6,*) ' '
  write(u6,1000) E
end if
ExtNuc = E

call mma_deallocate(Charge)

return

1000 format(' Ext Pot/(QM nuclei and MM charges) energy =',F16.10,' hartrees')

end function ExtNuc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Int_Setup(iSD,nSkal,iS,jS,kS,lS,Coor,Shijij,
     &                     iAngV,iCmpV,iShelV,iShllV,iAOV,iStabs)
      Use Basis_Info
      use Real_Info, only: RPQMin
      use Logical_Info, only: DoFMM
      Implicit Real*8 (a-h,o-z)
*
#include "nsd.fh"
#include "FMM.fh"
      Integer iSD(0:nSD,nSkal)
*
      Real*8  Coor(3,4)
      Integer iAngV(4),iCmpV(4),iShelV(4),iShllV(4),iAOV(4),iStabs(4),
     &        jQuad(4)
      Logical Shijij
*
      iCnttp=iSD(13,iS)
      iCnt  =iSD(14,iS)
      jCnttp=iSD(13,jS)
      jCnt  =iSD(14,jS)
      kCnttp=iSD(13,kS)
      kCnt  =iSD(14,kS)
      lCnttp=iSD(13,lS)
      lCnt  =iSD(14,lS)
*
      If (dbsc(iCnttp)%Aux) Then
         Coor(1:3,1)=dbsc(jCnttp)%Coor(1:3,jCnt)
      Else
         Coor(1:3,1)=dbsc(iCnttp)%Coor(1:3,iCnt)
      End If
      Coor(1:3,2)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
      If (dbsc(kCnttp)%Aux) Then
         Coor(1:3,3)=dbsc(lCnttp)%Coor(1:3,lCnt)
      Else
         Coor(1:3,3)=dbsc(kCnttp)%Coor(1:3,kCnt)
      End If
      Coor(1:3,4)=dbsc(lCnttp)%Coor(1:3,lCnt)
*
      Shijij=(iSD(0,iS).eq.iSD(0,kS).and.iSD(10,iS).eq.iSD(10,kS))
     &       .and.
     &       (iSD(0,jS).eq.iSD(0,lS).and.iSD(10,jS).eq.iSD(10,lS))
*
      jQuad(1)=iS
      jQuad(2)=jS
      jQuad(3)=kS
      jQuad(4)=lS
      Do iQuad = 1, 4
         iSkal=jQuad(iQuad)
         iAngV(iQuad)  = iSD( 1,iSkal)
         iCmpV(iQuad)  = iSD( 2,iSkal)
         iAOV(iQuad)   = iSD( 7,iSkal)
         iStabs(iQuad) = iSD(10,iSkal)
         iShelV(iQuad) = iSD(11,iSkal)
         iShllV(iQuad) = iSD( 0,iSkal)
      End Do
CMAW start
*
*  For the FMM coulomb integrals <AB(r1)|1/r12|CD(r2)>
*  Here we flag the integral routines that we only want to compute
*  the short-range non-multipole component of integrals over this
*  shell quartet if midpoint(A,B) is sufficiently far from
*  midpoint(C,D) for numerical stability.
*  Note that midpoint(X,Y) corresponds to the multipole expansion
*  centre of an XY AO-pair, regardless of exponents.
*
      FMM_shortrange = .False.
      If (DoFMM) Then
         D = 0.0d0
         DO i = 1, 3
            P = (Coor(i,1) + Coor(i,2))/2.0d0    ! AB shell-pair
            Q = (Coor(i,3) + Coor(i,4))/2.0d0    ! CD shell-pair
            D = D + (P-Q)*(P-Q)
         End Do
         IF (D .gt. RPQMIN*RPQMIN) FMM_shortrange = .True.
      End If
CMAW end
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Square_A(Lu,nB,MaxMem_,Force_out_of_Core)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Logical Force_out_of_Core
*
      If (nB.eq.0) Return
      MaxMem=MaxMem_
      nMem=nB**2
      If (Force_Out_of_Core) MaxMem=nMem/3
*
      If (nMem.le.MaxMem) Then
*
*        In-core case
*
         Call Allocate_Work(ipBuf,nMem)
         iAddr=0
         Call dDaFile(Lu,2,Work(ipBuf),nMem,iAddr)
         Call In_place_Square(Work(ipBuf),nB)
         iAddr=0
         Call dDaFile(Lu,1,Work(ipBuf),nMem,iAddr)
         Call Free_Work(ipBuf)

      Else
*
*        Out-of-core case
*
         nBuff=MaxMem/2
         Call Allocate_Work(ipBuf1,2*nBuff)
         ipBuf2 = ipBuf1+nBuff
*
         nBatch=(nMem-1)/nBuff + 1
         Inc = nBuff/nB
         iAddr1=0
         Do iB = 1, nB, Inc
            mB=Min(Inc,nB-iB+1)
            iAddrs=iAddr1
            Call dDaFile(Lu,2,Work(ipBuf1),nB*mB,iAddr1)
*
            iAddr2=iAddr1
            Do jB = iB, nB, Inc
               kB=Min(Inc,nB-jB+1)
*
               If (jB.eq.iB) Then
                  Call In_place_Diag(Work(ipBuf1),nB,iB,iB+mB-1)
               Else
                  Call dDaFile(Lu,2,Work(ipBuf2),nB*kB,iAddr2)
                  Call Off_Diagonal(Work(ipBuf1),nB,iB,iB+mB-1,
     &                              Work(ipBuf2),   jB,jB+kB-1)
               End If
            End Do
*
            iAddr1=iAddrs
            Call dDaFile(Lu,1,Work(ipBuf1),nB*mB,iAddr1)
*
         End Do
         Call Free_Work(ipBuf1)
      End If
      Return
      End
      Subroutine In_place_Square(Buff,nBuff)
      Implicit Real*8 (a-h,o-z)
      Real*8 Buff(nBuff,nBuff)
*
C     Call RecPrt('Buff',' ',Buff,nBuff,nBuff)
      Do j = 1, nBuff
         Do i = 1, j-1
            Buff(j,i)=Buff(i,j)
         End Do
      End Do
C     Call RecPrt('Buff',' ',Buff,nBuff,nBuff)
C     Write (6,'(10F10.3)') (Buff(i,i),i=1,nBuff)
*
      Return
      End
      Subroutine In_place_Diag(Buff,nBuff,iBs,iBe)
      Implicit Real*8 (a-h,o-z)
      Real*8 Buff(nBuff,iBs:iBe)
*
C     Call RecPrt('Buff',' ',Buff,nBuff,iBe-iBs+1)
      Do j = iBs, iBe
         Do i = iBs, j-1
            Buff(j,i)=Buff(i,j)
         End Do
      End Do
C     Call RecPrt('Buff',' ',Buff,nBuff,iBe-iBs+1)
*
      Return
      End
      Subroutine Off_Diagonal(B1,nB,iB1s,iB1e,B2,iB2s,iB2e)
      Implicit Real*8 (a-h,o-z)
      Real*8 B1(nB,iB1s:iB1e), B2(nB,iB2s:iB2e)
*
      Do j = iB2s, iB2e
         Do i = iB1s, iB1e
            B1(j,i)=B2(i,j)
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine QBOUNDas(KV,JROT,E,EO,VMX,DSOC,VBZ,SDRDY,RVB,YH,GB,GI,SB,SI,NPP,ITP2,ITP3,IWR,IQTST,BFCT,IT)
!***********************************************************************
!** Subroutine to initialize quasibound level wave function as Airy
!  function at third turning point (if possible). For the theory see
!  J.Chem.Phys. 54, 5114 (1971),  J.Chem.Phys. 69, 3622-31 (1978)
!----------------------------------------------------------------------
!** IQTST  is error flag. *** If (IQTST < 0) initialization fails
!  so eigenvalue calculation aborts *** (IQTST > 0) for successful
!  Airy function initialization. *** (IQTST=0) if Airy function
!  initialization prevented because 3-rd turning point beyond
!  range, so that WKB initialization is used.
!----------------------------------------------------------------------

use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: KV, JROT, NPP, IWR, IT
real(kind=wp), intent(in) :: E, EO, DSOC, VBZ(NPP), SDRDY(NPP), RVB(NPP), YH, BFCT
integer(kind=iwp), intent(out) :: ITP2, ITP3, IQTST
real(kind=wp), intent(out) :: VMX, GB, GI, SB, SI
integer(kind=iwp) :: I, II, J
real(kind=wp) :: A1, A13, A2, A23, FBA, FIA, GBA, GIA, RH, SL, VMXPR
logical(kind=iwp) :: Found
#include "compiler_features.h"
#define _C1A_ One/(Three**(Two/Three)*gamma(Two/Three))
#define _C2A_ One/(Three**(One/Three)*gamma(One/Three))
#ifdef INTRINSIC_INITIALIZATION
real(kind=wp), parameter :: C1A = _C1A_, C2A = _C2A_
#else
real(kind=wp) :: C1A, C2A
C1A = _C1A_
C2A = _C2A_
#endif

IQTST = 1
! Start by searching for third turning point.
J = NPP-1
if (VBZ(J) > E) then
  ! If 3-rd turning point beyond range start with WKB wave function
  ! at end of range.
  if (IWR /= 0) write(u6,608) JROT,EO
  ITP3 = NPP-1
  IQTST = 0
  VMX = VBZ(ITP3)
  II = ITP3
  !... and determine barrier maximum ....
  Found = .false.
  do I=2,ITP3
    II = II-1
    VMXPR = VBZ(II)
    if (VMXPR < VMX) then
      Found = .true.
      exit
    end if
    VMX = VMXPR
  end do
  if (.not. Found) then
    if (IWR /= 0) write(u6,610)
    IQTST = -9
  end if
  return
end if
Found = .false.
do I=NPP-2,1,-1
  J = J-1
  if (VBZ(J) > E) then
    Found = .true.
    exit
  end if
end do
if (.not. Found) then
  IQTST = -9
  write(u6,602) JROT,EO
  return
end if
! ITP3 is the first mesh point outside classically forbidden region
ITP3 = J+1
! Check that there is a classically allowed region inside this point
! and determine height of barrier maximum.
II = J
VMX = DSOC
Found = .false.
do I=2,J
  II = II-1
  if (VBZ(II) <= E) then
    Found = .true.
    exit
  end if
  if (VBZ(II) > VMX) VMX = VBZ(II)
end do
if (.not. Found) then
  ! Energy too high (or too low): find only one turning point.
  VMXPR = VMX/BFCT
  if (IWR /= 0) write(u6,604) JROT,EO,VMXPR/BFCT,RVB(J)
  IQTST = -1
  return
end if
! ITP2 is first mesh point inside forbidden region on left of barrier
ITP2 = II+1
! Now ... continue to set up r3(E) boundary condition ...
RH = RVB(ITP3)-RVB(ITP3-1)
GB = (VBZ(ITP3)-E)*(RH/YH)**2
GI = (VBZ(ITP3-1)-E)*(RH/YH)**2
! OPTIONALLY PRINT THESE VARIABLES WHEN DEBUGGING
!write(u6,*) 'ITP3=',ITP3
!write(u6,*) 'VBZ(ITP3-1)=',VBZ(ITP3-1)
!write(u6,*) 'E=',E
!write(u6,*) 'RH=',RH
!write(u6,*) 'YH=',YH
! Treat quasibound levels as bound using outer boundary condition
! of Airy function at third turning point ... as discussed by
! R.J.Le Roy and R.B.Bernstein  in  J.Chem.Phys. 54,5114(1971).
! Uses series expansions of Abramowitz & Stegun Eq.(10.4.3)
SL = (GI-GB)**(One/Three)/RH
A1 = GI/(SL*RH)**2
A2 = GB/(SL*RH)**2
A13 = A1*A1*A1
A23 = A2*A2*A2
FIA = One+A13*(A13*(A13+72.0_wp)+2160.0_wp)/12960.0_wp
GIA = A1+A1*A13*(A13*(A13+90.0_wp)+3780.0_wp)/45360.0_wp
FBA = One+A23*(A23*(A23+72.0_wp)+2160.0_wp)/12960.0_wp
GBA = A2+A2*A23*(A23*(A23+90.0_wp)+3780.0_wp)/45360.0_wp
! Airy function  Bi(X)  at points straddling 3-rd turning point
SI = (C1A*FIA+C2A*GIA)/SDRDY(ITP3-1)
SB = (C1A*FBA+C2A*GBA)/SDRDY(ITP3)
GI = VBZ(ITP3-1)-E
GB = VBZ(ITP3)-E
if (SB >= SI) then
  ! In case of big error - switch to node at ITP3
  SB = Zero
  SI = One
  if (IWR /= 0) write(u6,606) KV,JROT,EO,IT
end if

return

602 format(' *** QBOUND fails for   E(J=',i3,')=',f9.3,'  Find no turning point')
604 format(' For J=',I3,'  ETRY=',F11.4,' > VMAX=',F11.4,'  find onee turn point:  R=',F6.2)
606 format(' *** CAUTION ***  v=',I3,'   J=',I3,'   E=',ES13.6,'   IT=',I2/5x, &
           'Airy initialization unstable so place node just past  R(3-rd)')
608 format(' *** For  J=',I3,'  E=',F9.2,'  R(3-rd) > RMAX  & E < V(N)  so try WKB B.C. @ RMAX')
610 format(" **** QBOUND doesn't work ... no classically allowed region accessible at this energy.")

end subroutine QBOUNDas

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_TraDrv(irc,CMO,Diag,DoDiag)
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: AO-to-MO (ai) transformation of Cholesky vectors
!          performed directly in reduced sets. This assumes
!          that the MP2 program has been appropriately initialized.

use ChoMP2, only: nAOVir, nT1AOT
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(inout) :: Diag(*)
logical(kind=iwp), intent(in) :: DoDiag
real(kind=wp), allocatable :: COcc(:), CVir(:)

irc = 0

! Reorder MO coefficients.
! ------------------------

call mma_allocate(COcc,nT1AOT(1),Label='COcc')
call mma_allocate(CVir,nAOVir(1),Label='CVir')
call ChoMP2_MOReOrd(CMO,COcc,CVir)

! Transform vectors.
! ------------------

call ChoMP2_Tra(COcc,CVir,Diag,DoDiag)

! Deallocate reordered MO coefficients.
! -------------------------------------

call mma_deallocate(CVir)
call mma_deallocate(COcc)

end subroutine ChoMP2_TraDrv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine trans_amfi(coeffs,idim1,idim2,ich,nolds1,nolds2,nolds3,nolds4,nnew1,nnew2,nnew3,nnew4,array1,array2)
!bs makes the transformation for the ich-th index
!coeffs                      : (nolds(ith),nnew(ith)) modified contraction coefficients
!idim1                       :  first dimension
!idim2                       :  second dimension
!ich                         : index to be changed
!nolds1,nolds2,nolds3,nolds4 : old dimensions
!nnew1,nnew2,nnew3,nnew4     : new dimensions
!array1                      : array of size (nolds1,nolds2,nolds3,nolds4)
!array2                      : array of size (nnew1,nnew2,nnew3,nnew4)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idim1, idim2, ich, nolds1, nolds2, nolds3, nolds4, nnew1, nnew2, nnew3, nnew4
real(kind=wp), intent(in) :: coeffs(idim1,idim2), array1(nolds1,nolds2,nolds3,nolds4)
real(kind=wp), intent(out) :: array2(nnew1,nnew2,nnew3,nnew4)
integer(kind=iwp) :: ind1, ind2, ind3, ind4, ind5

!write(u6,*) 'begin trans ',ich
!write(u6,'(8I5)') nolds1,nolds2,nolds3,nolds4,nnew1,nnew2,nnew3,nnew4
array2(:,:,:,:) = Zero
if (ich == 1) then
  do ind4=1,nnew4
    do ind3=1,nnew3
      do ind2=1,nnew2
        do ind5=1,nnew1
          do ind1=1,nolds1
            array2(ind5,ind2,ind3,ind4) = array2(ind5,ind2,ind3,ind4)+coeffs(ind1,ind5)*array1(ind1,ind2,ind3,ind4)
          end do
        end do
      end do
    end do
  end do
else if (ich == 2) then
  !write(6,*) 'transform second index '
  do ind4=1,nnew4
    do ind3=1,nnew3
      do ind5=1,nnew2
        do ind2=1,nolds2
          array2(:,ind5,ind3,ind4) = array2(:,ind5,ind3,ind4)+coeffs(ind2,ind5)*array1(1:nnew1,ind2,ind3,ind4)
        end do
      end do
    end do
  end do
  !write(u6,*) 'end  to transform second index '
else if (ich == 3) then
  do ind4=1,nnew4
    do ind5=1,nnew3
      do ind3=1,nolds3
        array2(:,:,ind5,ind4) = array2(:,:,ind5,ind4)+coeffs(ind3,ind5)*array1(1:nnew1,1:nnew2,ind3,ind4)
      end do
    end do
  end do
else if (ich == 4) then
  do ind5=1,nnew4
    do ind4=1,nolds4
      array2(:,:,:,ind5) = array2(:,:,:,ind5)+coeffs(ind4,ind5)*array1(1:nnew1,1:nnew2,1:nnew3,ind4)
    end do
  end do
end if
!write(u6,*) 'end  trans '

return

end subroutine trans_amfi

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine makedx_cvb(dx,nparm,ioptc,
     >  heigvec,heigval,dxp,gradp,w2,
     >  close2conv,converged,nposeig,scalesmall,
     >  wrongstat,nnegeig,opth,alfastart,alfa)
      implicit real*8 (a-h,o-z)
#include "formats_cvb.fh"
      logical opth,close2conv,converged,wrongstat,scalesmall
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "tune_cvb.fh"
      dimension heigvec(nparm,nparm),heigval(nparm)
      dimension dxp(nparm),dx(nparm),gradp(nparm),w2(nparm)
      save zero,one
      data zero/0.d0/,one/1.d0/

      alfa=alfastart
c  << Update is small >>
      if(cnrm.lt.hh.and.scalesmall)then
c  Close to wrong stationary point :
        if(wrongstat)then
          if(dnrm2_(nparm,gradp,1).lt.grdwrngtol)then
            write(6,*)' Gradient too small - not using information!'
            call fzero(w2,nparm)
            do i=1,nnegeig
            if(heigval(i).ge.eigwrngtol)w2(i)=sign(one,gradp(i))
            enddo
            do i=nnegeig+1,nparm
            if(heigval(i).le.-eigwrngtol)w2(i)=sign(one,gradp(i))
            enddo
            call getdxp_cvb(dxp,w2,heigval,nnegeig,nparm,alfa)
            cnrm=dnrm2_(nparm,dxp,1)
          endif
          call dscal_(nparm,hh/cnrm,dxp,1)
          cnrm=hh
          goto 600
        endif
        if(.not.opth.and.ip.ge.2)write(6,form2AF)
     >     ' Scaling update from :',cnrm,' to :',hh
        call dscal_(nparm,hh/cnrm,dxp,1)
        cnrm=hh
        goto 600
      elseif(cnrm.lt.hh)then
        goto 600
      endif

      call optalf_cvb(heigval,gradp,nparm,hh,alfa,
     >  nnegeig,alfastart,alftol)
      call getdxp_cvb(dxp,gradp,heigval,nnegeig,nparm,alfa)
      call expec_cvb(dxp,gradp,heigval,nnegeig,nparm,exp,exp1,exp2)
      cnrm=dnrm2_(nparm,dxp,1)
      if(.not.opth.and.ip.ge.2)write(6,formAF)
     >   ' Alpha and norm of update :',alfa,cnrm

600   continue


      if(ioptc.gt.0.and.(.not.opth.and.cnrm.lt.cnrmtol))then
        if(ip.ge.0)then
          write(6,'(a)')' '
          write(6,formAD)' WARNING - predicted update too small :',
     >      cnrm,cnrmtol
        endif
        ioptc=-2
        return
      endif
1100  call expec_cvb(dxp,gradp,heigval,nnegeig,nparm,exp,exp1,exp2)
      if(exp1.lt.-exp12tol.or.exp2.gt.exp12tol)then
        call dscal_(nparm,0.9d0,dxp,1)
        cnrm=dnrm2_(nparm,dxp,1)
        if(cnrm.lt.cnrmtol)then
          write(6,formAD)' Norm of update too small :',cnrm,cnrmtol
          call abend_cvb()
        endif
        goto 1100
      endif
      if(ip.ge.2.and.close2conv.and.
     >  (exp1.lt.zero.or.exp2.gt.zero))then
        write(6,*)' Warning - not a max/min direction !'
        if(nnegeig.gt.0)write(6,*)' Expected change for maximized',
     >    ' variables :',exp1
        if(nposeig.gt.0)write(6,*)' Expected change for minimized',
     >    ' variables :',exp2
      endif
      call mxatb_cvb(heigvec,dxp,nparm,nparm,1,dx)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_logical(converged)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Anders Bernhardsson                              *
!***********************************************************************

subroutine Add2(rMat,fact)
! Purpose:
!   Adds the contribution from the gradient to
!    [2]
!   E   Kappa. This is done to insure us about
!   a beautiful convergence of the PCG,
!   which is just the case if E is symmetric.

use MCLR_data, only: ipCM, ipMat, SFock
use input_mclr, only: nBas, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: rMat(*)
real(kind=wp), intent(in) :: fact
integer(kind=iwp) :: iS
real(kind=wp), allocatable :: Temp(:)

do iS=1,nSym
  if (nOrb(is)*nOrb(is) == 0) cycle
  call mma_allocate(Temp,nBas(is)**2,Label='Temp')
  ! T=Brillouin matrix
  call DGeSub(SFock(ipCM(is)),nOrb(is),'N',SFock(ipCM(is)),nOrb(is),'T',Temp,nOrb(is),nOrb(is),nOrb(is))
  !             t           t
  ! +1/2 { Kappa T - T kappa  }
  rMat(ipMat(is,is):ipMat(is,is)+nOrb(is)**2-1) = rMat(ipMat(is,is):ipMat(is,is)+nOrb(is)**2-1)-Four*Fact*Temp(1:nOrb(is)**2)
  call mma_deallocate(Temp)
end do

end subroutine Add2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
Subroutine Hessian_Kriging(x0_,ddy_,ndimx)
  use kriging_mod
  Implicit None
  Integer ndimx
  Real*8 x0_(ndimx),ddy_(ndimx,ndimx)
!
!#define _Hess_Test
#ifdef _Hess_Test
  Real*8 Scale,Delta,Fact,tgrad(ndimx),thgrad(ndimx)
  Real*8 HessT, tmp
  Integer i, j
  HessT = 1.0D-3
#endif
!
!nx is the n-dimensional vector of the last iteration computed in update_sl
! subroutine
  x0(:) = x0_(:)
!
  call covarvector(2) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
  call predict(2)
  ddy_(:,:) = hpred(:,:)
!
#ifdef _Hess_Test
! Numerical Hessian of GEK
  write(6,*) 'Begining Numerical Hessian'
!
  hpred(:,:) = 0.0D0
  Scale=0.01D0
  write(6,*) 'Hess Threshold',HessT
!
  do i = 1,nInter
    tmp=x0(i)
!
    Delta = 1.0D-5!Max(Abs(x_(i,1)),1.0D-5)*Scale
!
    x0(i) = tmp + Delta
    call covarvector(1) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
    call predict(1)
    tgrad=gpred(:)
!
    x0(i) = tmp - Delta
    call covarvector(1) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
    call predict(1)
    thgrad=gpred(:)
!
    do j=1,nInter
      hpred(i,j) = (tgrad(j)-thgrad(j))/(2.0D0*Delta)
    enddo
    x0(i) = tmp
  enddo
! Comparing Analytical solution with Numerical
  do i = 1,nInter
    do j = 1,nInter
      write(6,*) 'i,j',i,j
      write(6,*) 'hpred, ddy_',hpred(i,j),ddy_(i,j)
      if (abs(ddy_(i,j)-hpred(i,j)).gt.HessT) then
        Write(6,*) 'Error in entry',i,',',j,'of the hessian matrix'
        Call RecPrt('Anal Hess',' ',ddy_,nInter,nInter)
        Call RecPrt('Num Hess',' ',hpred,nInter,nInter)
        Write(6,*) 'abs(ddy_(i,j)+ HessT)',abs(ddy_(i,j)+ HessT)
        Write(6,*) 'abs(ddy_(i,j)- HessT)',abs(ddy_(i,j)- HessT)
        Write(6,*) 'abs(hpred(i,j))',abs(hpred(i,j))
        Call Abend()
      endif
    enddo
  enddo
#endif
!
  return
End Subroutine Hessian_Kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_CALCINT(ISHLAB)
C
C     Purpose: calculate qualified integral columns from
C              shell pair distribution (**|ISHLA ISHLB).
C
      IMPLICIT NONE
      INTEGER ISHLAB
#include "cholesky.fh"

      CHARACTER*15 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_CALCINT')

      IF (IFCSEW .EQ. 1) THEN ! store full shell quadruple
         CALL CHO_MCA_CALCINT_1(ISHLAB)
      ELSE IF (IFCSEW .EQ. 2) THEN ! store only reduced sets
         CALL CHO_MCA_CALCINT_2(ISHLAB)
      ELSE ! this is an error
         CALL CHO_QUIT('IFCSEW out of bounds in '//SECNAM,105)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Exp4 (A,B,dima2,dima,dimp2,dimp)
c
c       this routine do:
c       expand A(ab,pq) -> B(b,a,p,q)
c       for matrices, where A(ab,pq)=A(ab,qp)=A(ba,pq)=A(ba,qp)
c        N.B. kvajto odflaknute
c
c       parameter description:
c       A       - input matrix (I)
c       B       - outpun matrix (O)
c
        implicit none
        integer dima2,dima,dimp2,dimp
        real*8 A(1:dima2,1:dimp2)
        real*8 B(1:dima,1:dima,1:dimp,1:dimp)
c
c       help variables
        integer a1,b1,ab,p,q,pq
c
        pq=0
        do p=1,dimp
        do q=1,p
        pq=pq+1
c
          ab=0
          do a1=1,dima
          do b1=1,a1
          ab=ab+1
            B(a1,b1,p,q)=A(ab,pq)
            B(a1,b1,q,p)=A(ab,pq)
            B(b1,a1,p,q)=A(ab,pq)
            B(b1,a1,q,p)=A(ab,pq)
          end do
          end do
c
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2003, Valera Veryazov                                  *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine PrFin(OneHam,Ovlp,Dens,TwoHam,nDT,
     &                 EOrb,OccNo,nEO,CMO,nCMO,note,iCase,MssVlc,Darwin)
************************************************************************
*                                                                      *
*     purpose: Final printout                                          *
*                                                                      *
*     input:                                                           *
*       Dens    : the last total density                               *
*       TwoHam  : the last two-electron ham.                           *
*       OneHam  : one-electron hamiltonian of length nOOK              *
*       Ovlp    : overlap in AO basis of length nOOK                   *
*       EOrb    : orbital energies of length nEO                       *
*       OccNo   : occupation numbers of length nEO                     *
*       CMO     : molecular orbital coefficients of length nCMO        *
*                                                                      *
*     called from: Final                                               *
*                                                                      *
*     calls to: R1IntB, RelEny, SetUp, Ortho                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: UHF - V.Veryazov, 2003                                  *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      External EFP_ON
*
      Real*8 Dens(nDT),TwoHam(nDT),OneHam(nDT),Ovlp(nDT),
     &       EOrb(nEO),OccNo(nEO),CMO(nCMO),MssVlc(nDT),Darwin(nDT)
      Character*80 Note
*
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "file.fh"
#include "stdalloc.fh"
#include "rctfld.fh"
#include "oneswi.fh"
      Logical Do_SpinAV
      COMMON  / SPAVE_L  / Do_SpinAV
*
*---- Define local variables
      Character Fmt*60
      Logical PrEne,PrOcc, get_BasisType
      Logical DeBug, First, NonEq, Dff, Do_DFT, FullMlk, Reduce_Prt
      External Reduce_Prt
      Real*8, Dimension(:), Allocatable:: RFfld, Scr2, Scr3
cnf
      Logical Do_ESPF, EFP_On
cnf
*     Save ipScr1
      Character AlphaLabel*30
      Dimension Dumm0(1),Dumm1(1)
*
*----------------------------------------------------------------------*
*     Warning!
*  this routine uses a dirty trick in UHF case
*  ipScr1 is used to keep a temporary array in memory
*  which is released during a second call.
*----------------------------------------------------------------------*
*


#include "SysDef.fh"

*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      jPrint=iPrint
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0
      If (iPL.le.1) jPrint=1
*
*----------------------------------------------------------------------*
*
#ifdef _DEBUGPRINT_
      Debug=.true.
#else
      Debug=.false.
      If (jPrint.ge.4) Debug=.True.
#endif
*
      Fmt = '(6X,A,T50,F17.10)'
      AlphaLabel=' '
      if(iUHF.eq.1.and.iCase.eq.0) AlphaLabel=' (alpha) '
      if(iUHF.eq.1.and.iCase.eq.1) AlphaLabel=' (beta)  '

      if (Do_SpinAV) AlphaLabel=Alphalabel(1:9)//'and (spin-averaged)'

*---- Compute relativistic corrections
      If (lRel) Then
         Call RelEny(ERelMV,ERelDC,Dens,
     &               MssVlc,Darwin,nBT)
         If (jPrint.ge.2) Then
            Write(6,*)
            Write(6,'(6X,A)') '1st order relativistic corrections'
            Write(6,Fmt)'Total energy',EneV+ERelMV+ERelDC
            Write(6,Fmt)'Mass-velocity correction',ERelMV
            Write(6,Fmt)'1-el Darwin correction',ERelDC
            Write(6,Fmt)'Sum of relatvity corrections',ERelDC+ERelMV
            Write(6,*)
         End If
      End If
*
*---- Print numerical quadrature information
      iSpin=1
      if(iUHF.eq.1) iSpin=2
      If (KSDFT.ne.'SCF'.and.iCase.eq.0) Call Print_NQ_Info(iSpin)
*
*---- Write out last density matrix to output
      If (DeBug) Then
         Write(6,'(6x,A)')'Last density matrix (interpolated) '
     &                  //'in AO basis'
         ij = 1
         Do iSym = 1, nSym
            Write(6,*)' symmetry',iSym
            Call TriPrt(' ',' ',Dens(ij),nBas(iSym))
            ij=ij+nBas(iSym)*(nBas(iSym)+1)/2
         End Do
         Write(6,*)
         Write(6,'(6x,A)')'Last 2-el. Hamiltonian (interpolated) '
     &                  //'in AO basis'
         ij = 1
         Do iSym = 1, nSym
            Write(6,*)' symmetry',iSym
            Call TriPrt(' ',' ',TwoHam(ij),nBas(iSym))
            ij=ij+nBas(iSym)*(nBas(iSym)+1)/2
         End Do
         Write(6,*)
         Write(6,'(6x,A)')'Last 1-el. Hamiltonian (interpolated) '
     &                  //'in AO basis'
         ij = 1
         Do iSym = 1, nSym
            Write(6,*)' symmetry',iSym
            Call TriPrt(' ',' ',OneHam(ij),nBas(iSym))
            ij=ij+nBas(iSym)*(nBas(iSym)+1)/2
         End Do
         Write(6,*)
      End If
*
*...  Process the external potential with the total electronic density
*
cnf
      Call DecideOnESPF(Do_ESPF)
      If ( (Do_ESPF .or. lRF .or. KSDFT.ne.'SCF' .or. EFP_On()) .and.
     &      .Not.NDDO .and. iCase.eq.0) Then
cnf      If ( (lRF .or. KSDFT.ne.'SCF') .and.  .Not.NDDO .and.
         iCharge=Int(Tot_Charge)
         NonEq=.False.
*        Call Get_PotNuc(PotNuc)
*        Call Get_dScalar('PotNuc',PotNuc)
         Call Peek_dScalar('PotNuc',PotNuc)
         Call mma_allocate(RFfld,nBT,Label='RFfld')
         call dcopy_(nBT,[Zero],0,RFfld,1)
         First=.True.
         Dff = .False.
         Do_DFT=.False. ! We do not need to redo the DFT!
         iDumm=1
         Call DrvXV(RFfld,RFfld,Dens,
     &             PotNuc,nBT,First,Dff,NonEq,lRF,KSDFT,ExFac,
     &             iCharge,iSpin,
     &             Dumm0,Dumm1,iDumm,'SCF ',Do_DFT)
         Call mma_deallocate(RFfld)
*
*------- Print multipole analysis of the reaction field contributions
*
         Call RFmltp()
*
      End If
*
*
*---- Print orbitals (the case InVec=3 and nIter=0 is set up in RdInp)
      Fmt = '(6X,A)'
      If (iPrOrb.ge.1) Then
         FullMlk=.True.
         PrEne=.True.
         PrOcc=.True.
         If (iPrOrb.eq.1) Then
            EHomo = -99999.0d+00
            ELumo =  99999.0d+00
            ij = 1
            Do iSym = 1, nSym
              Do iv=1,nOrb(iSym)
              if(OccNo(ij+iv-1).gt.0.001) then
               EHomo = Max(EHomo,EOrb(ij + iv - 1))
              else
               ELumo = Min(ELumo,EOrb(ij + iv -1 ))
              endif
              End Do
               ij    = ij + nOrb(iSym)
            End Do
cvv            ThrEne = Abs(Two*EHomo - ELumo)
            ThrEne = ELumo+0.5
            If (jPrint.ge.2) Then
               Write(6,*)
               Write(6,Fmt)'All orbitals with orbital energies smaller '
     &                //'than  E(LUMO)+0.5 are printed'
            End If
c         print *,'Elumo',Elumo
         Else
            If (jPrint.ge.2) Then
               Write(6,*)
               Write(6,'(6X,2A,E11.4,A)')'All orbitals with orbital',
     &              ' energies smaller than',ThrEne,' are printed'
            End If
         End If
         ThrOcc = -99999.0d+00
         If (KSDFT.eq.'SCF') Then
            If(iUHF.eq.0) Then
               Note='SCF orbitals'//AlphaLabel
               If (kIvo.ne.0)  Note='SCF orbitals + IVO'
               If (iCoCo.ne.0)
     &            Note='SCF orbitals + arbitrary occupations'
            Else
               Note='UHF orbitals'//AlphaLabel
               If (kIvo.ne.0)  Note='UHF orbitals + IVO'
               If (iCoCo.ne.0)
     &            Note='UHF orbitals + arbitrary occupations'
            End If
         Else
            If(iUHF.eq.0) Then
               Note='RKS-DFT orbitals'//AlphaLabel
               If (kIvo.ne.0)  Note='RKS-DFT orbitals + IVO'
               If (iCoCo.ne.0)
     &            Note='RKS-DFT orbitals + arbitrary occupations'
            Else
               Note='UKS-DFT orbitals'//AlphaLabel
               If (kIvo.ne.0)  Note='UKS-DFT orbitals + IVO'
               If (iCoCo.ne.0)
     &            Note='UKS-DFT orbitals + arbitrary occupations'
            End If
         End If
         If (jPrint.ge.2)
     &      Call PriMO(Note,PrOcc,PrEne,ThrOcc,ThrEne,
     &              nSym,nBas,nOrb,Name,EOrb,OccNo,CMO,iPrForm)
      Else
         If (jPrint.ge.2)
     &      Write(6,Fmt)'No orbitals printed'
         FullMlk=.False.
      End If
*
      If (InVec.ne.3 . or . nIter(nIterP).gt.0) Then
         Call mma_allocate(Scr2,nBB,Label='Scr2')
         Call mma_allocate(Scr3,nnB,Label='Scr3')
*
*------- Prepare CMO in symmetry blocks nBas x nBas
         iVec  = 0
         iCMO  = 0
         Do iSym = 1, nSym
            Do i = 1, nBas(iSym)*nOrb(iSym)
               Scr2(iVec + i) = CMO(iCMO + i)
            End Do
            iVec = iVec + nBas(iSym)*nOrb(iSym)
            Do i = 1, nBas(iSym)*(nBas(iSym) - nOrb(iSym))
               Scr2(iVec + i) = Zero
            End Do
            iVec = iVec + nBas(iSym)*(nBas(iSym) - nOrb(iSym))
            iCMO = iCMO + nOrb(iSym)*nBas(iSym)
         End Do
*
*------- Prepare occupation numbers
*
         iOr = 0
         iBs = 0
         Do iSym = 1, nSym
            Do j = 1, nOrb(iSym)
               Scr3(iBs + j) = OccNo(iOr + j)
            End Do
            Do j = nOrb(iSym) + 1, nBas(iSym)
               Scr3(iBs + j) = Zero
            End Do
            iOr = iOr + nOrb(iSym)
            iBs = iBs + nBas(iSym)
         End Do

         If(.not.NoProp) Then
*
*------- Population analysis
*
         jCase=iCase
         if(iUHF.eq.0) jCase=2
         Call Charge(nSym,nBas,Name,Scr2,Scr3,
     &               Ovlp,jCase,FullMlk,.True.)

         If (get_BasisType('ANO')) Then
            iRc = 0
            Call LoProp(iRc)
*
*------- NBO analysis
*
            Call Nat_Bond_Order(nSym,nBas,Name,jCase)
         End If
         End If
*
*------- ESPF analysis
*
         If (Do_ESPF) Call espf_analysis(.True.)
*
         Call mma_deallocate(Scr3)
         Call mma_deallocate(Scr2)
*
      End If

      End subroutine PrFin

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Int_Parm_g(iSD4,nSD,iAnga,iCmpa,iShlla,iShela,iPrimi,jPrimj,kPrimk,lPriml,k2ij,nDCRR,k2kl,nDCRS,mdci,mdcj,mdck,mdcl, &
                      AeqB,CeqD,nZeta,nEta,ipZeta,ipZI,ipP,ipEta,ipEI,ipQ,ipiZet,ipiEta,ipxA,ipxB,ipxG,ipxD,l2DI,nab,nHmab,ncd, &
                      nHmcd,nIrrep)

use k2_setup, only: Indk2
use Basis_Info, only: Shells
use Index_Functions, only: nTri_Elem1, nTri3_Elem1
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nSD, iSD4(0:nSD,4), ipZeta, ipiZet, nIrrep
integer(kind=iwp), intent(out) :: iAnga(4), iCmpa(4), iShlla(4), iShela(4), iPrimi, jPrimj, kPrimk, lPriml, k2ij, nDCRR, k2kl, &
                                  nDCRS, mdci, mdcj, mdck, mdcl, nZeta, nEta, ipZI, ipP, ipEta, ipEI, ipQ, ipiEta, ipxA, ipxB, &
                                  ipxG, ipxD, nab, nHmab, ncd, nHmcd
logical(kind=iwp), intent(out) :: AeqB, CeqD
logical(kind=iwp), intent(in) :: l2DI
integer(kind=iwp) :: iAng, iCmp, ijShll, iShell, jAng, jCmp, jShell, kAng, kCmp, klShll, kShell, lAng, lCmp, lShell

iAnga(:) = iSD4(1,:)
iCmpa(:) = iSD4(2,:)
iShlla(:) = iSD4(0,:)
iShela(:) = iSD4(11,:)
iPrimi = Shells(iSD4(0,1))%nExp
jPrimj = Shells(iSD4(0,2))%nExp
kPrimk = Shells(iSD4(0,3))%nExp
lPriml = Shells(iSD4(0,4))%nExp
iShell = iSD4(11,1)
jShell = iSD4(11,2)
kShell = iSD4(11,3)
lShell = iSD4(11,4)
if (iShell >= jShell) then
  ijShll = iShell*(iShell-1)/2+jShell
else
  ijShll = jShell*(jShell-1)/2+iShell
end if
if (kShell >= lShell) then
  klShll = kShell*(kShell-1)/2+lShell
else
  klShll = lShell*(lShell-1)/2+kShell
end if
iAng = iSD4(1,1)
jAng = iSD4(1,2)
kAng = iSD4(1,3)
lAng = iSD4(1,4)
iCmp = iSD4(2,1)
jCmp = iSD4(2,2)
kCmp = iSD4(2,3)
lCmp = iSD4(2,4)

nab = nTri_Elem1(iAng)*nTri_Elem1(jAng)
ncd = nTri_Elem1(kAng)*nTri_Elem1(lAng)
nHmab = iCmp*jCmp*(nTri3_Elem1(iAng+jAng)-nTri3_Elem1(max(iAng,jAng)-1))
nHmab = nHmab*nIrrep
nHmcd = kCmp*lCmp*(nTri3_Elem1(kAng+lAng)-nTri3_Elem1(max(kAng,lAng)-1))
nHmcd = nHmcd*nIrrep
if (.not. l2DI) then
  nab = 0
  ncd = 0
end if
k2ij = Indk2(1,ijShll)
nDCRR = Indk2(2,ijShll)
k2kl = Indk2(1,klShll)
nDCRS = Indk2(2,klShll)
mdci = iSD4(10,1)
mdcj = iSD4(10,2)
mdck = iSD4(10,3)
mdcl = iSD4(10,4)
AeqB = (iSD4(13,1) == iSD4(13,2)) .and. (mdci == mdcj)
CeqD = (iSD4(13,3) == iSD4(13,4)) .and. (mdck == mdcl)
nZeta = iPrimi*jPrimj
nEta = kPrimk*lPriml
ipZI = ipZeta+nZeta
ipP = ipZI+nZeta
ipxA = ipP+nZeta*3
ipxB = ipxA+nZeta
ipEta = ipxB+nZeta
ipEI = ipEta+nEta
ipQ = ipEI+nEta
ipxG = ipQ+nEta*3
ipxD = ipxG+nEta

ipiEta = ipiZet+nZeta+1

return

end subroutine Int_Parm_g

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,2023, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine Rys2DN(xyz2D,xyz2DN,nArg,lRys,nabMax,ncdMax,CoorAC)
!***********************************************************************
!                                                                      *
! Object: to compute the 2-dimensional integrals of the Rys            *
!         quadrature. The z components are assumed to be pre-          *
!         conditioned with the weights of the roots of the             *
!         Rys polynomial.                                              *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
! Modified loop structure for RISC 1991 R. Lindh Dept. of Theoretical  *
! Chemistry, University of Lund, Sweden.                               *
! VV: improve loop structure                                           *
! Modified for use to compute generalized 2D integrals to compute      *
! integrals for the Breit-Dirac and the Berit-Pauli Hamiltonian.       *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nArg, lRys, nabMax, ncdMax
real(kind=wp), intent(inout) :: xyz2D(lRys,nArg,3,0:nabMax+2,0:ncdMax+2)
real(kind=wp), intent(out) :: xyz2DN(lRys,nArg,3,2,0:nabMax+1,0:ncdMax+1)
real(kind=wp), intent(in) :: CoorAC(3,2)
integer(kind=iwp) :: i_f, ie
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iab, icd, iOrdOp
character(len=30) :: Label
#endif

#ifdef _DEBUGPRINT_
call RecPrt('Rys2Dn: AC',' ',CoorAC,3,2)
do iab=0,nabMax+2
  do icd=0,ncdMax+2
    write(Label,'(A,I3,A,I3,A)') ' In Rys2Dn: xyz2D(x)(',iab,',',icd,')'
    call RECPRT(Label,' ',xyz2D(:,:,1,iab,icd),lRys,nArg)
    write(Label,'(A,I3,A,I3,A)') ' In Rys2Dn: xyz2D(y)(',iab,',',icd,')'
    call RECPRT(Label,' ',xyz2D(:,:,2,iab,icd),lRys,nArg)
    write(Label,'(A,I3,A,I3,A)') ' In Rys2Dn: xyz2D(z)(',iab,',',icd,')'
    call RECPRT(Label,' ',xyz2D(:,:,3,iab,icd),lRys,nArg)
  end do
end do
#endif

xyz2DN(:,:,:,:,:,:) = Zero

do ie=0,nabMax+1
  do i_f=0,ncdMax+1
    xyz2DN(:,:,1,1,ie,i_f) = xyz2D(:,:,1,ie+1,i_f)-xyz2D(:,:,1,ie,i_f+1)+(CoorAC(1,1)-CoorAC(1,2))*xyz2D(:,:,1,ie,i_f)
    xyz2DN(:,:,2,1,ie,i_f) = xyz2D(:,:,2,ie+1,i_f)-xyz2D(:,:,2,ie,i_f+1)+(CoorAC(2,1)-CoorAC(2,2))*xyz2D(:,:,2,ie,i_f)
    xyz2DN(:,:,3,1,ie,i_f) = xyz2D(:,:,3,ie+1,i_f)-xyz2D(:,:,3,ie,i_f+1)+(CoorAC(3,1)-CoorAC(3,2))*xyz2D(:,:,3,ie,i_f)
  end do
end do
do ie=0,nabMax
  do i_f=0,ncdMax
    xyz2DN(:,:,1,2,ie,i_f) = xyz2DN(:,:,1,1,ie+1,i_f)-xyz2DN(:,:,1,1,ie,i_f+1)+(CoorAC(1,1)-CoorAC(1,2))*xyz2DN(:,:,1,1,ie,i_f)
    xyz2DN(:,:,2,2,ie,i_f) = xyz2DN(:,:,2,1,ie+1,i_f)-xyz2DN(:,:,2,1,ie,i_f+1)+(CoorAC(2,1)-CoorAC(2,2))*xyz2DN(:,:,2,1,ie,i_f)
    xyz2DN(:,:,3,2,ie,i_f) = xyz2DN(:,:,3,1,ie+1,i_f)-xyz2DN(:,:,3,1,ie,i_f+1)+(CoorAC(3,1)-CoorAC(3,2))*xyz2DN(:,:,3,1,ie,i_f)
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Generalized 2D integrals: 2D(:,ie,i_f,iOrdOp)'
do iOrdOp=1,2
  do ie=0,nabMax
    do i_f=0,ncdMax
      write(Label,'(A,I2,A,I2,A,I2,A)') 'Rys2Dn: 2DN(',ie,',',i_f,',',iOrdOp,')(x)'
      call RecPrt(Label,' ',xyz2DN(:,:,1,iOrdOp,ie,i_f),lRys,nArg)
      write(Label,'(A,I2,A,I2,A,I2,A)') 'Rys2Dn: 2DN(',ie,',',i_f,',',iOrdOp,')(y)'
      call RecPrt(Label,' ',xyz2DN(:,:,2,iOrdOp,ie,i_f),lRys,nArg)
      write(Label,'(A,I2,A,I2,A,I2,A)') 'Rys2Dn: 2DN(',ie,',',i_f,',',iOrdOp,')(z)'
      call RecPrt(Label,' ',xyz2DN(:,:,3,iOrdOp,ie,i_f),lRys,nArg)
    end do
  end do
end do
#endif

return

end subroutine Rys2DN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine TERIS(Zeta,Eta,P,Q,rKapab,rKapcd,T,Fact,ZEInv,nT,IsChi,
     &                 ChiI2)
************************************************************************
*                                                                      *
* Object: compute the arguments for the reduced list of integrals which*
*         are used in prescreening.                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             June '91, modified for k2 loop.                          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Zeta(nT), P(nT,3), rKapab(nT), T(nT), Fact(nT),
     &       ZEInv(nT)
*
      iRout = 244
      iPrint = nPrint(iRout)
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' Zeta in TERIS',' ',Zeta,nT,1)
         Call RecPrt(' P in TERIS',' ',P,nT,3)
         Call RecPrt(' Kab in TERIS',' ',rKapab,nT,1)
      End If
#endif
*
      Do iT = 1, nT
         T(iT) = 0.0D0
         tmp = 1.0D0/(Zeta(iT)+Zeta(iT)
     >         +(Zeta(iT)*Zeta(iT)*ChiI2)*Dble(IsChi))
         ZEInv(iT) = tmp
         Fact(iT) =  rKapab(iT) **2 * Sqrt(tmp)
      End Do
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt('In TERIS: Tvalue',' ',T,nT,1)
         Call RecPrt('In TERIS: Fact  ',' ',Fact,nT,1)
      End If
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(P)
#endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(Eta)
         Call Unused_real(Q)
         Call Unused_real(rKapcd)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_PrintLB()

use Para_Info, only: MyRank, nProcs
use Cholesky, only: LuPri, nnBstRT
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i
integer(kind=iwp), allocatable :: LB(:)

call mma_allocate(LB,[0,nProcs-1],Label='LB')
LB(:) = 0

LB(myRank) = nnBstRT(1)
call Cho_GAIGop(LB,nProcs,'+')
call Cho_Head('Cholesky vector dimension on each node','=',80,LuPri)
do i=0,nProcs-1
  write(LuPri,'(2X,A,I4,5X,A,I7)') 'Node:',i,'Dimension:',LB(i)
end do

call mma_deallocate(LB)

end subroutine Cho_PrintLB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module sorting_funcs

use Definitions, only: wp, iwp

implicit none
private

public :: leq_i, leq_r, leq_c, geq_i, geq_r, geq_c

contains

pure function leq_i(x,y)
  logical(kind=iwp) :: leq_i
  integer(kind=iwp), intent(in) :: x, y
  leq_i = x <= y
end function

pure function leq_r(x,y)
  logical(kind=iwp) :: leq_r
  real(kind=wp), intent(in) :: x, y
  leq_r = x <= y
end function

pure function leq_c(x,y)
  logical(kind=iwp) :: leq_c
  complex(kind=wp), intent(in) :: x, y
  leq_c = real(x)**2+aimag(x)**2 <= real(y)**2+aimag(y)**2
end function

pure function geq_i(x,y)
  logical(kind=iwp) :: geq_i
  integer(kind=iwp), intent(in) :: x, y
  geq_i = x >= y
end function

pure function geq_r(x,y)
  logical(kind=iwp) :: geq_r
  real(kind=wp), intent(in) :: x, y
  geq_r = x >= y
end function

pure function geq_c(x,y)
  logical(kind=iwp) :: geq_c
  complex(kind=wp), intent(in) :: x, y
  geq_c = real(x)**2+aimag(x)**2 >= real(y)**2+aimag(y)**2
end function

end module sorting_funcs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

subroutine NmHess(dq,nInter,g,nIter,Hess,Delta,q,FEq,Cubic,DipM,dDipM)
!***********************************************************************
!                                                                      *
! Object: to numerically evaluate the molecular Hessian.               *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             May '92                                                  *
!***********************************************************************

use Constants, only: Two, Six, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nInter, nIter
real(kind=wp), intent(in) :: dq(nInter,nIter), g(nInter,nIter), Delta, q(nInter,nIter+1), DipM(3,nIter)
logical(kind=iwp), intent(in) :: Cubic
real(kind=wp), intent(out) :: Hess(nInter,nInter), FEq(merge(nInter,0,Cubic),nInter,nInter), dDipM(3,nInter)
integer(kind=iwp) :: iCount, iInter, jInter, kInter, kIter, kIter1, kIter2, kIter3, kIter4

#ifdef _DEBUGPRINT_
call RecPrt('NmHess:  g',' ',g,nInter,nIter)
call RecPrt('NmHess:  q',' ',q,nInter,nIter)
call RecPrt('NmHess: dq',' ',dq,nInter,nIter)
#else
#include "macros.fh"
unused_var(q)
unused_var(dq)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Form the derivative of the dipole moment

do iInter=1,nInter
  kIter = 1+(iInter-1)*2
  kIter1 = kIter+1
  kIter2 = kIter+2
  !write(u6,*) kIter1,kIter2
  dDipM(:,iInter) = (DipM(:,kIter1)-DipM(:,kIter2))/(Two*Delta)
end do
#ifdef _DEBUGPRINT_
call RecPrt('DipM',' ',DipM,3,nIter)
call RecPrt('dDipM',' ',dDipM,3,nInter)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Evaluate the Hessian

do jInter=1,nInter
  kIter = 1+(jInter-1)*2
  kIter1 = kIter+1
  kIter2 = kIter+2
  !write(u6,*) jInter,kIter1,kIter2
  ! Observe the sign convention due to the use of forces
  ! rather than gradients!!!
  Hess(:,jInter) = -(g(:,kIter1)-g(:,kIter2))/(Two*Delta)
end do
#ifdef _DEBUGPRINT_
call RecPrt(' Numerical Hessian',' ',Hess,nInter,nInter)
#endif

! Symmetrize

do iInter=1,nInter
  do jInter=1,iInter-1
    Hess(iInter,jInter) = (Hess(iInter,jInter)+Hess(jInter,iInter))*Half
    Hess(jInter,iInter) = Hess(iInter,jInter)
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt(' Symmetrized Hessian',' ',Hess,nInter,nInter)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the numerical cubic constants if data is available.

if (Cubic) then

  ! F(i,j,j)

  do jInter=1,nInter
    kIter = 1+(jInter-1)*2
    kIter1 = kIter+1
    kIter2 = kIter+2
    ! Observe the sign convention due to the use of forces
    ! rather than gradients!!!
    FEq(:,jInter,jInter) = -(g(:,kIter1)+g(:,kIter2))/(Delta**2)
  end do

  ! F(i,j,k); j>k

  iCount = 0
  do jInter=1,nInter
    do kInter=1,jInter-1
      iCount = iCount+1
      kIter = 1+2*nInter+(iCount-1)*4
      kIter1 = kIter+1
      kIter2 = kIter+2
      kIter3 = kIter+3
      kIter4 = kIter+4
      ! Observe the sign convention due to the use of forces
      ! rather than gradients!!!
      FEq(:,jInter,kInter) = -(g(:,kIter1)-g(:,kIter2)-g(:,kIter3)+g(:,kIter4))/(Two*Delta)**2
    end do
  end do

  ! Symmetrize

  do iInter=1,nInter
    do jInter=1,iInter
      do kInter=1,jInter
        FEq(iInter,jInter,kInter) = (FEq(iInter,jInter,kInter)+FEq(iInter,kInter,jInter)+FEq(jInter,iInter,kInter)+ &
                                     FEq(jInter,kInter,iInter)+FEq(kInter,jInter,iInter)+FEq(kInter,iInter,jInter))/Six
        FEq(iInter,jInter,kInter) = FEq(iInter,jInter,kInter)
        FEq(iInter,kInter,jInter) = FEq(iInter,jInter,kInter)
        FEq(jInter,iInter,kInter) = FEq(iInter,jInter,kInter)
        FEq(jInter,kInter,iInter) = FEq(iInter,jInter,kInter)
        FEq(kInter,iInter,jInter) = FEq(iInter,jInter,kInter)
      end do
    end do
  end do

end if

return

end subroutine NmHess

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine contf24 (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,
     &                     lunt2o3)
c
c     this routine do:
c     5)  FII4  f2(m,i) <- sum(n,e>f) [ <ef||mn> . Tap(in,ef)]
c
c     N.B. use and destroy : V1,V2,V3,V4,M1
c     N.B. # of get v2o2 : 6
c     N.B. possible fusion with f14 graph
c
       use Para_Info, only: MyRank
#include "ccsd2.fh"
#include "parallel.fh"
#include "wrk.fh"
       integer lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,lunt2o3
c
c     help variables
c
       integer posst,rc,ssc
c
c1    f2(m,i)aa <- sum(n,e>f-aaa) [ <ef||mn>aaaa . Tap(ef,in)aaaa ]
c
cpar
      if (myRank.eq.idbaab) then
c
c1.1  read V1(af,mn) <= T2o(ef,in)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv10,mapdv1,mapiv1,rc)
c
c1.2  make Tap V1(ef,in) from V1(ef,in)
       call mktau (wrk,wrksize,
     & mapdv1,mapiv1,mapdt11,mapit11,mapdt12,mapit12,0.5d0,
     &             rc)
c
c1.3  expand V2(ef,i,n) <= V1(ef,in)
       call expand (wrk,wrksize,
     & 4,6,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c1.4  map V4(ef,n,i) <= V2(ef,i,n)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
c
c1.5  read V1(ef,mn) <= <ef||mn>aaaa
       call filemanager (2,lunabij1,rc)
       call getmediate (wrk,wrksize,
     & lunabij1,possv10,mapdv1,mapiv1,rc)
c
c1.6  expand V3(ef,m,n) <= V1(ef,mn)
       call expand (wrk,wrksize,
     & 4,6,mapdv1,mapiv1,1,possv30,mapdv3,mapiv3,rc)
c
c1.7  map V1(m,ef,n) <= V3(ef,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv3,mapiv3,1,mapdv1,mapiv1,possv10,posst,
     &           rc)
c
c1.8  mult M1(m,i) <= V1(m,ef,n) . V4(ef,n,i)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv1,mapiv1,1,mapdv4,mapiv4,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c1.9  add f2(m,i)aa <- M1(m,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdf21,mapif21,1,rc)
c
       end if
c
c
c
c2    f2(m,i)bb <- sum(n,e>f-bbb) [ <ef||mn>bbbb . Tap(ef,in)bbbb ]
c
cpar
      if (myRank.eq.idaabb) then
c
c2.1  read V1(af,mn) <= T2o(ef,in)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv10,mapdv1,mapiv1,rc)
c
c2.2  make Tap V1(ef,in) from V1(ef,in)
       call mktau (wrk,wrksize,
     & mapdv1,mapiv1,mapdt11,mapit11,mapdt12,mapit12,0.5d0,
     &             rc)
c
c2.3  expand V2(ef,i,n) <= V1(ef,in)
       call expand (wrk,wrksize,
     & 4,6,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c2.4  map V4(ef,n,i) <= V2(ef,i,n)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
c
c2.5  read V1(ef,mn) <= <ef||mn>bbbb
       call filemanager (2,lunabij2,rc)
       call getmediate (wrk,wrksize,
     & lunabij2,possv10,mapdv1,mapiv1,rc)
c
c2.6  expand V3(ef,m,n) <= V1(ef,mn)
       call expand (wrk,wrksize,
     & 4,6,mapdv1,mapiv1,1,possv30,mapdv3,mapiv3,rc)
c
c2.7  map V1(m,ef,n) <= V3(ef,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv3,mapiv3,1,mapdv1,mapiv1,possv10,posst,
     &           rc)
c
c2.8  mult M1(m,i) <= V1(m,ef,n) . V4(ef,n,i)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv1,mapiv1,1,mapdv4,mapiv4,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c2.9  add f2(m,i)bb <- M1(m,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdf22,mapif22,1,rc)
c
       end if
c
c
c3*   f2(m,i)aa <- sum(nef-bab) [ <ef||mn>abab . Tap(e,f,i,n)abab ]
c4*   f2(m,i)bb <- sum(nef-aab) [ <ef||nm>abab . Tap(e,f,n,i)abab ]
c
cpar
      if ((myRank.eq.idbaab).or.(myRank.eq.idaabb)) then
c
c34.1 read V1(e,f,k,l) <= T2o(e,f,k,l)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv10,mapdv1,mapiv1,rc)
c
c34.2 read V2(e,f,k,l) <= <ef||kl>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
c
c34.3 make Tap V1(e,f,k,l) from V1(e,f,k,l)
       call mktau (wrk,wrksize,
     & mapdv1,mapiv1,mapdt11,mapit11,mapdt12,mapit12,0.5d0,
     &             rc)
       end if
c
cpar
      if (myRank.eq.idbaab) then
c
c3.1  map V3(m,e,f,n) <= V2(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
c
c3.2  map V4(e,f,n,i) <= V1(e,f,i,n)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv1,mapiv1,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
c
c3.3  mult M1(m,i) <= V3(m,e,f,n) . V4(e,f,n,i)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv3,mapiv3,1,mapdv4,mapiv4,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c3.4  add f2(m,i)aa <- M1(m,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdf21,mapif21,1,rc)
c
       end if
c
cpar
      if (myRank.eq.idaabb) then
c
c4.1  map V3(m,e,f,n) <= V2(e,f,n,m)
       call map (wrk,wrksize,
     & 4,2,3,4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
c
c4.3  mult M1(m,i) <= V3(m,e,f,n) . V1(e,f,n,i)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv3,mapiv3,1,mapdv1,mapiv1,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c4.4  add f2(m,i)bb <- M1(m,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdf22,mapif22,1,rc)
c
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cont(L,breit,ifinite,TKIN,evec,eval,Energy,type1,type2,scratch)
!bs ####################################################################
!bs   cont prepares all required contraction coefficients for functions
!bs   with angular momentum L
!bs ####################################################################

use AMFI_global, only: cntscrtch, contrarray, exponents, MxcontL, MxprimL, ncontrac, normovlp, nprimit, OVLPinv, rootOVLP, &
                       rootOVLPinv
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: L, ifinite
logical(kind=iwp), intent(in) :: breit
real(kind=wp), intent(out) :: TKIN(MxprimL,MxprimL), evec(MxprimL,MxprimL), eval(MxprimL), Energy(MxprimL), type1(MxprimL), &
                              type2(MxprimL), scratch(MxprimL,MxprimL,3)
logical(kind=iwp), parameter :: breit_finite = .true.

!bs transcon transfers and normalizes contracted functions
!bs ore more precisely the coefficients
call transcon(cntscrtch(:,:,L),MxprimL,MxcontL,normovlp(:,:,L),contrarray(:,0,L),nprimit(L),ncontrac(L))
!bs gentkin generates the matrix of kinetic energy TKIN
call gentkin(L,TKIN,nprimit(L),exponents(:,L),rootOVLPinv(:,:,L))
!bs kindiag diagonalizes TKIN
!bs for finite nucleus
if ((ifinite == 2) .and. (L == 0)) then
  call kindiag(TKIN,nprimit(L),evec,eval,breit_finite)
else
  call kindiag(TKIN,nprimit(L),evec,eval,breit)
end if
!bs kinemat generates kinematic factors in
!bs the basis of eigenvectors
call kinemat(nprimit(L),eval,type1,type2,Energy)
!bs chngcont= changecont generates the contraction coeffs
!bs including kinematic factors and even exponents as factors
call chngcont(contrarray(:,0,L),contrarray(:,1,L),contrarray(:,2,L),contrarray(:,3,L),contrarray(:,4,L),ncontrac(L),nprimit(L), &
              evec,type1,type2,scratch(:,:,1),scratch(:,:,2),scratch(:,:,3),MxprimL,rootOVLP(:,:,L),OVLPinv(:,:,L),exponents(:,L))

return

end subroutine cont

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRCTL_MCLR()
! Two-electron integral transformation program: control section
!
! Purpose: Set up of memory locations (decide if out of core is
!          needed. Loop over symmetry blocks of AO integrals.
!          The transformation routine TRAMO is called for each
!          symmetry block of integrals.

use Symmetry_Info, only: Mul
use MCLR_Data, only: CMO, FnHlf2, FnHlf3, FnTri1, FnTri2, FnTri3, FnTri4, FnTri5, ipCM, LuHlf2, LuHlf3, LuTri1, LuTri2, LuTri3, &
                     LuTri4, LuTri5
use input_mclr, only: nAsh, nBas, nFro, nIsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iAd13, iAD14, iAd23, iAd24, iAd34, iBatch, IntBuf, ipB, ipi, iSP, iSQ, iSR, iSS, lW1, lW2, lW3, lW4, lW5, &
                     MemX, nAP, nAQ, nAR, nAS, nBP, nBPQRS, nBQ, nBR, nBS, nDP, nDQ, nDR, nDS, nORBP, nSPQ, nSPQR, nSPQRS, nW1, &
                     nW2, nW3, nW4, nW5
integer(kind=iwp), allocatable :: Hlf1(:,:)
real(kind=wp), allocatable :: Buffer(:)
integer(kind=iwp), parameter :: LIOTAB = 512*512

!                                                                      *
!***********************************************************************
!                                                                      *

call DANAME_wa(LUTRI1,FNTRI1)
call DANAME_wa(LUTRI2,FNTRI2)
call DANAME_wa(LUTRI3,FNTRI3)
call DANAME_wa(LUTRI4,FNTRI4)
call DANAME_wa(LUTRI5,FNTRI5)
IAD14 = 0
IAD13 = 0
IAD23 = 0
IAD24 = 0
IAD34 = 0
call mma_allocate(Hlf1,LIOTAB,4,Label='Hlf1')

! Precompute start points

! Loop over quadruples of symmetries (nsp,nsq,nsr,nss)
! Note that the integrals on LUTWOAO have to be sorted in the
! same order as the loop structure below.

call mma_maxDBLE(MEMX)
MEMX = max(MEMX-MEMX/10,0)
call mma_allocate(Buffer,MEMX,Label='Buffer')
ipB = 1
IBATCH = 0
do iSP=1,NSYM
  NBP = NBAS(iSP)
  NAP = NASH(iSP)+nish(isp)
  nDP = nFro(iSP)!+nDel(iSP)
  do iSQ=1,iSP
    NBQ = NBAS(iSQ)
    NAQ = NASH(iSQ)+nish(isq)
    nDQ = nFro(iSQ)!+nDel(iSQ)
    NSPQ = Mul(iSP,iSQ)
    do iSR=1,NSYM
      NBR = NBAS(iSR)
      NAR = NASH(iSR)+nish(isr)
      nDR = nFro(iSR)!+nDel(iSR)
      NSPQR = Mul(NSPQ,iSR)
      do iSS=1,iSR
        NBS = NBAS(iSS)
        NAS = NASH(iSS)+nIsh(iSS)
        nDS = nFro(iSS)!+nDel(iSS)
        NSPQRS = Mul(NSPQR,iSS)

        ! Check the loop conditions and skip transformation step if possible

        NORBP = NAP*NAQ+NAR*NAS+NAP*NAR+NAP*NAS+NAQ*NAR+NAQ*NAS
        NBPQRS = NBP*NBQ*NBR*NBS
        if (NSPQRS /= 1) cycle
        IBATCH = IBATCH+1
        if (NORBP == 0) cycle
        if (NBPQRS == 0) cycle
        if (NAR+NAS == 0) cycle

        ! Set up dynamic memory

        INTBUF = 256*256
        ipi = ipB
        LW1 = ipi
        NW1 = max(NBP*NBQ,NBR*NBS)
        ipi = ipi+nw1
        LW2 = ipi
        NW2 = max(nBR*nAS,nAQ*nBP)
        ipi = ipi+nw2
        lw3 = ipi
        NW3 = max(nAR*nBS,nBQ*nAP)
        ipi = ipi+nw3
        lw4 = ipi
        NW4 = NAR*NAS
        ipi = ipi+nw4
        lw5 = ipi
        NW5 = MEMX-nw1-nw2-nw3-nw4

        ! transform the symmetry block (ISP,ISQ|ISR,ISS)

        call TRAMO_MCLR(INTBUF,Buffer(LW1:LW1+NW1-1),NW1,Buffer(LW2:LW2+NW2-1),NW2,Buffer(LW3:LW3+NW3-1),NW3, &
                        Buffer(LW4:LW4+NW4-1),NW4,Buffer(LW5:LW5+NW5-1),NW5,nBP,nBQ,nBR,nBS,iSP,iSQ,iSR,iSS,nAP,nAQ,nAR,nAS, &
                        CMO(ipCM(iSP)+nBP*nDP),CMO(ipCM(iSQ)+nBQ*nDQ),CMO(ipCM(iSR)+nBR*nDR),CMO(ipCM(iSS)+nBS*nDS),iAD13,iAD14, &
                        iAD23,iAD24,iAD34,Hlf1(:,1),Hlf1(:,2),Hlf1(:,3),Hlf1(:,4),LIOTAB)

        ! End of loop over quadruples of symmetries
      end do
    end do
  end do
end do

call mma_deallocate(Buffer)
call mma_deallocate(Hlf1)
call DAName_wa(LUHLF2,FNHLF2)
call DAName_wa(LUHLF3,FNHLF3)
call DaEras(LUHLF2)
call DaEras(LUHLF3)

end subroutine TRCTL_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
Module DKH_Info
Private
Public :: nCtrLD, iCtrLD, radiLD, DKroll, LDKroll, BSS, &
          DKH_Info_Get, DKH_Info_Dmp
#include "stdalloc.fh"
Integer :: i
Integer ::  nCtrLD=0, iCtrLD(10)=[(0,i=1,10)]
Real*8  :: radiLD=0.0D0
Logical :: DKroll=.False.
Logical :: LDKroll=.False.
Logical :: BSS   =.False.
Integer :: iRelae_Info=0

Contains

Subroutine DKH_Info_Dmp()
#include "relae.fh"
  Real*8, Allocatable:: rDmp(:)
  Integer:: Len=1+10+5
  Integer i

  iRelae_Info=iRelae

  Call mma_allocate(rDmp,Len,Label='rDmp:DKH')
  rDmp(1)=DBLE(nCtrLD)
  Do i = 1, 10
    rDMP(i+1)=iCtrLD(i)
  End Do
  rDMP(12)=radiLD
  rDMP(13)=DBLE(0)
  If (DKroll) rDMP(13)=DBLE(1)
  rDMP(14)=DBLE(0)
  If (LDKroll) rDMP(14)=DBLE(1)
  rDMP(15)=DBLE(0)
  If (BSS) rDMP(15)=DBLE(1)
  rDmp(16)=DBLE(iRelae_Info)
  Call Put_dArray('DKH_Info',rDmp,Len)
  Call mma_deallocate(rDmp)
End Subroutine DKH_Info_Dmp


Subroutine DKH_Info_Get()
#include "relae.fh"
  Real*8, Allocatable:: rDmp(:)
  Integer:: Len=1+10+5
  Integer i

  Call mma_allocate(rDmp,Len,Label='rDmp:DKH')
  Call Get_dArray('DKH_Info',rDmp,Len)

  nCtrLD=NINT(rDmp(1))
  Do i = 1, 10
    iCtrLD(i)=NINT(rDMP(i+1))
  End Do
  radiLD=rDMP(12)
  DKroll  = NINT(rDMP(13)).eq.1
  LDKroll = NINT(rDMP(14)).eq.1
  BSS     = NINT(rDMP(15)).eq.1
  iRelae_Info = NINT(rDmp(16))

  iRelae=iRelae_Info

  Call mma_deallocate(rDmp)
End Subroutine DKH_Info_Get

End Module DKH_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FixHess(H,nH,iOptC,MF,GNrm,nsAtom,AnalHess,AllowFindTS)

use Index_Functions, only: nTri_Elem
use Slapaf_Info, only: iNeg, GNrm_Threshold, Mode
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Ten, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nH, nsAtom
real(kind=wp), intent(inout) :: H(nH,nH), MF(3,nsAtom)
integer(kind=iwp), intent(inout) :: iOptC
real(kind=wp), intent(in) :: GNrm
logical(kind=iwp), intent(in) :: AnalHess, AllowFindTS
integer(kind=iwp) :: i, ij, iLow, iStatus, iTest, j, jNeg, nRP, NumVal, nVStep
real(kind=wp) :: dRx, Fact, Fix_Val, rLow, rq, SumHii, temp, Test
logical(kind=iwp) :: Corrected, Found
real(kind=wp), allocatable :: EVal(:), FixVal(:), LowVal(:), LowVec(:,:), Rx(:,:), Tmp(:,:), Vect(:)
real(kind=wp), parameter :: HHigh = One, HTh = 1.0e-3_wp, ZTh = 1.0e-12_wp
real(kind=wp), external :: DDot_
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: Too_Small
#endif

#ifdef _DEBUGPRINT_
write(u6,*) 'AnalHess=',AnalHess
call RecPrt('FixHess: H(Start)',' ',H,nH,nH)
Too_Small = .false.
#endif

Corrected = .false.

call mma_allocate(EVal,nTri_Elem(nH),Label='EVal')

! Copy elements for H

SumHii = Zero
ij = 0
do i=1,nH
  do j=1,i
    ij = ij+1
    EVal(ij) = H(i,j)
  end do
  SumHii = SumHii+H(i,i)
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'FixHess: SumHii=',SumHii
call RecPrt('FixHess: Hessian',' ',H,nH,nH)
call TriPrt('FixHess: H',' ',EVal,nH)
#endif

! Compute eigenvalues and eigenvectors

! Davidson procedure to compute only the lowest eigenvalues
! For small matrices we can afford to solve it directly
! (tested with NumVal=2 in all cases)
if (nH <= 30) then
  NumVal = nH
else
  NumVal = 2
end if
nVStep = 2
Found = .false.
call mma_allocate(LowVal,NumVal,Label='LowVal')
call mma_allocate(LowVec,nH,NumVal,Label='LowVec')
LowVec(:,:) = Zero
! Stop when the highest eigenvalue found is larger than HTh * 10
do while (.not. Found)
  call Davidson(EVal,nH,NumVal,LowVal,LowVec,iStatus)
# ifdef _DEBUGPRINT_
  call RecPrt(' Eigenvalues',' ',LowVal,1,NumVal)
  call RecPrt(' Eigenvectors',' ',LowVec,nH,NumVal)
# endif
  if (iStatus > 0) call SysWarnMsg('FixHess','Davidson procedure did not converge','')
  if ((LowVal(NumVal) > Ten*HTh) .or. (NumVal >= nH)) then
    Found = .true.
  else
    ! Increase the number of eigenpairs to compute
    call mma_allocate(Tmp,nH,NumVal,Label='Tmp')
    Tmp(:,:) = LowVec(:,:)
    call mma_deallocate(LowVal)
    call mma_deallocate(LowVec)
    ! At some point, start doubling the number
    if (NumVal >= 16) NVStep = NumVal
    nVStep = min(nVStep,nH-NumVal)
    NumVal = NumVal+nVStep
    call mma_allocate(LowVal,NumVal,Label='LowVal')
    LowVal(:) = Zero
    call mma_allocate(LowVec,nH,NumVal,Label='LowVec')
    LowVec(:,:) = Zero
    LowVec(:,1:NumVal-nVStep) = Tmp(:,:)
    call mma_deallocate(Tmp)
  end if
end do
call mma_deallocate(EVal)

! Apply corrections if any ...

call mma_allocate(FixVal,NumVal,Label='FixVal')
#ifdef _DEBUGPRINT_
call RecPrt(' Eigenvalues',' ',LowVal,1,NumVal)
call RecPrt(' Eigenvectors',' ',LowVec,nH,NumVal)
#endif
iNeg(1) = 0
jNeg = 0
rLow = Ten
iLow = 0
! with sorted eigenvalues, jNeg=iNeg, iLow=1
do i=1,NumVal
  temp = LowVal(i)
  FixVal(i) = temp
  if (temp < rlow) then
    rlow = temp
    iLow = i
  end if
  ! No fixes if the Hessian is analytical
  if ((.not. AnalHess) .and. (abs(temp) < HTh)) then
#   ifdef _DEBUGPRINT_
    Too_Small = .true.
#   endif
    Corrected = .true.

    ! For redundant coordinates we will have some
    ! eigenvalues which are zero due to the redundancy.

    if (abs(temp) < ZTh) then
      temp = Zero
      FixVal(i) = Zero
    else
      FixVal(i) = sign(HTh,temp)
    end if
  end if
  if (temp < Zero) then
    iNeg(1) = iNeg(1)+1
    jNeg = i
    if (((.not. AnalHess) .or. btest(iOptC,8)) .and. btest(iOptC,7) .and. (.not. btest(iOptC,12))) then

      ! Change the sign and if just too large reduce the value
      ! to the default of HHigh.

      FixVal(i) = min(HHigh,abs(FixVal(i)))
      Corrected = .true.
    end if
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! If FindTS and we have got a negative eigenvalue signal that
! we are in the TS regime.

if (AllowFindTS) then
  call qpg_darray('TanVec',Found,nRP)
  if (btest(iOptC,12) .and. ((iNeg(1) >= 1) .or. (Mode >= 0)) .and. ((GNrm <= GNrm_Threshold) .or. Found)) then
    if (.not. btest(iOptC,13)) then
      write(u6,*) '**************************'
      write(u6,*) '* Enable TS optimization *'
      write(u6,*) '**************************'
    end if
    iOptC = ibset(iOptC,13)
  end if
  if (btest(iOptC,13)) iOptC = ibclr(iOptC,7)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
if (Too_Small) then
  write(u6,*)
  write(u6,*) ' Some too small eigenvalues has been corrected'
  write(u6,*)
end if
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! MINIMA
!                                                                      *
!***********************************************************************
!                                                                      *
if (btest(iOptC,7)) then

  if ((iNeg(1) /= 0) .and. (.not. btest(iOptC,8))) then
    Corrected = .true.
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Some negative eigenvalues has been corrected'
    write(u6,*) 'iNeg=',iNeg(1)
    write(u6,*)
#   endif
  end if
!                                                                      *
!***********************************************************************
!                                                                      *
! TRANSITION STATE SEARCH
!                                                                      *
!***********************************************************************
!                                                                      *
else if (btest(iOptC,3) .or. btest(iOptC,13)) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! 1 negative eigenvalue

  if (iNeg(1) == 1) then

    if (Mode <= 0) then

      ! Store the eigenvector which we are following

      Mode = jNeg
      call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,I3)') ' Store Original mode:',Mode
      call RecPrt(' Reaction mode',' ',MF,3,nsAtom)
#     endif

    else

      ! Check that it is the correct eigenvector!

#     ifdef _DEBUGPRINT_
      call RecPrt(' Old Reaction mode',' ',MF,3,nsAtom)
#     endif
      iTest = 0
      Test = Zero
      call mma_allocate(Rx,3,nsAtom,Label='Rx')
      do i=1,NumVal
        call ReacX(LowVec(:,i),nH,Rx,3*nsAtom)
        dRx = sqrt(DDot_(3*nsAtom,Rx,1,Rx,1))
        rq = abs(DDot_(3*nsAtom,MF,1,Rx,1))/dRx
        if (rq > Test) then
          iTest = i
          Test = rq
        end if
        Temp = FixVal(i)
#       ifdef _DEBUGPRINT_
        write(u6,*) '<old|new>,H_new=',rq,Temp
#       endif
      end do
      call mma_deallocate(Rx)

      ! Only iTest and jNeg may be touched
      if (iTest == jNeg) then
        Mode = jNeg
      else
#       ifdef _DEBUGPRINT_
        write(u6,*) ' Warning: wrong eigenvector has negative eigenvalue.'
#       endif
        ! Keep the old vector if there is significant overlap
        ! Note: there could be a better vector not in the computed set
        if ((.not. AnalHess) .and. (Test > Half)) then
          Mode = iTest
#         ifdef _DEBUGPRINT_
          write(u6,*) 'Keep old eigenvector!',Mode
#         endif
          FixVal(jNeg) = abs(FixVal(jNeg))
          Corrected = .true.
          ! Prefer the new eigenvector if the Hessian is analytical
          ! or if the best overlap is poor
        else
          Mode = jNeg
#         ifdef _DEBUGPRINT_
          write(u6,*) 'Take new eigenvector!',Mode
#         endif
        end if
      end if

      FixVal(Mode) = -abs(FixVal(Mode))
      call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,1X,I3)') ' Store mode:',Mode
      call RecPrt(' New Reaction mode',' ',MF,3,nsAtom)
#     endif

    end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! 0 negative eigenvalues

  else if (iNeg(1) == 0) then

    if (Mode < 1) then

      ! Store the eigenvector which we are following

      Mode = iLow
      call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,I3)') ' Store Original mode:',Mode
      call RecPrt(' Reaction mode',' ',MF,3,nsAtom)
#     endif

    else

      ! Find the eigenvector with the best overlap

#     ifdef _DEBUGPRINT_
      call RecPrt(' Old Reaction mode',' ',MF,3,nsAtom)
#     endif
      iTest = 0
      Test = Zero
      call mma_allocate(Rx,3,nsAtom,Label='Rx')
      do i=1,NumVal
        call ReacX(LowVec(:,i),nH,Rx,3*nsAtom)
        dRx = sqrt(DDot_(3*nsAtom,Rx,1,Rx,1))
        rq = abs(DDot_(3*nsAtom,MF,1,Rx,1))/dRx
        if (rq > Test) then
          iTest = i
          Test = rq
        end if
        Temp = FixVal(i)
#       ifdef _DEBUGPRINT_
        write(u6,*) '<old|new>,H_new=',rq,Temp
#       endif
      end do
      call mma_deallocate(Rx)

      ! Keep the old vector if there is significant overlap
      ! Note: there could be a better vector not in the computed set
      if (Test > Half) then
        Mode = iTest
        ! Prefer the lowest eigenvector if the best overlap is poor
      else
        Mode = iLow
#       ifdef _DEBUGPRINT_
        write(u6,*) ' Warning: no good overlap among the computed set of eigenvectors.'
#       endif
      end if

      call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,1X,I3)') ' Store mode:',Mode
      call RecPrt(' New Reaction mode',' ',MF,3,nsAtom)
#     endif

    end if

    FixVal(Mode) = -Half*abs(FixVal(Mode))
    Corrected = .true.
#   ifdef _DEBUGPRINT_
    write(u6,'(A,I2,A)') ' No negative eigenvalue, correction: mode ',Mode,' was changed to negative'
    write(u6,*)
#   endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! 2 or more negative eigenvalues

  else if (iNeg(1) >= 2) then

    if (Mode < 1) then

      ! Store the eigenvector which we are following

      Mode = iLow
      call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,I3)') ' Store Original mode:',Mode
      call RecPrt(' Reaction mode',' ',MF,3,nsAtom)
#     endif

    else

      ! Find the eigenvector with the best overlap

#     ifdef _DEBUGPRINT_
      call RecPrt(' Old Reaction mode',' ',MF,3,nsAtom)
#     endif
      iTest = 0
      Test = Zero
      call mma_allocate(Rx,3,nsAtom,Label='Rx')
      do i=1,NumVal
        call ReacX(LowVec(:,i),nH,Rx,3*nsAtom)
        dRx = sqrt(DDot_(3*nsAtom,Rx,1,Rx,1))
        rq = abs(DDot_(3*nsAtom,MF,1,Rx,1))/dRx
        if (rq > Test) then
          iTest = i
          Test = rq
        end if
        Temp = FixVal(i)
#       ifdef _DEBUGPRINT_
        write(u6,*) '<old|new>,H_new=',rq,Temp
#       endif
      end do
      call mma_deallocate(Rx)

      ! Keep the old vector if there is significant overlap
      ! Note: there could be a better vector not in the computed set
      if (Test > Half) then
        Mode = iTest
        ! Prefer the lowest eigenvector if the best overlap is poor
      else
        Mode = iLow
#       ifdef _DEBUGPRINT_
        write(u6,*) ' Warning: no good overlap among the computed set of eigenvectors.'
#       endif
      end if

      call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,1X,I3)') ' Store mode:',Mode
      call RecPrt(' New Reaction mode',' ',MF,3,nsAtom)
#     endif

    end if

    ! Caution! Negative eigenvalues which are not assigned
    ! to the reaction mode will be increased by two orders of magnitude!

    Fact = Ten**2
    do i=1,NumVal
      Temp = FixVal(i)
      if (i == Mode) then
        FixVal(i) = -abs(Temp)
      else if (Temp < 0) then
        FixVal(i) = abs(Temp)*Fact
      else
        FixVal(i) = abs(Temp)
      end if
    end do
    Corrected = .true.
#   ifdef _DEBUGPRINT_
    write(u6,'(A,I2,A)') ' Too many negative eigenvalue, correction: mode ',Mode,' was kept'
    write(u6,*)
#   endif

  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
#ifdef _DEBUGPRINT_
else
  write(u6,*) 'No Hessian massage!'
#endif
end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' Analysis of the Hessian'
write(u6,*)
call RecPrt(' Eigenvalues',' ',FixVal,1,NumVal)
call RecPrt(' Eigenvectors',' ',LowVec,nH,NumVal)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Recompute the Hessian if needed

iNeg(2) = iNeg(1)
if (Corrected) then

# ifdef _DEBUGPRINT_
  call RecPrt(' Corrected eigenvalues',' ',FixVal,1,NumVal)
  call RecPrt(' Hessian',' ',H,nH,nH)
# endif

  call mma_allocate(Vect,nH,Label='Vect')
  iNeg(1) = 0
  do i=1,NumVal
    if (FixVal(i) < Zero) iNeg(1) = iNeg(1)+1
    Fix_Val = FixVal(i)-LowVal(i)
    if (abs(Fix_Val) > ZTh) then
      Fix_Val = FixVal(i)+LowVal(i)

      ! H |i>

      call dGeMV_('N',nH,nH,One,H,nH,LowVec(:,i),1,Zero,Vect,1)

      ! H' = (I-|i><i|) H (I-|i><i|) + val_new |i><i|
      !    = H - H|i> <i| - |i> <i|H + (val_old + val_new) |i> <i|
      !
      ! (since |i> is an eigenvector this could be used instead):
      ! H' = H + (val_new - val_old) |i> <i|

      do j=1,nH
        H(:,j) = H(:,j)-Vect(:)*LowVec(j,i)-Vect(j)*LowVec(:,i)+Fix_Val*LowVec(:,i)*LowVec(j,i)
      end do
    end if
  end do
  call mma_deallocate(Vect)

end if

#ifdef _DEBUGPRINT_
call RecPrt('FixHess: Hessian',' ',H,nH,nH)
#endif

call mma_deallocate(FixVal)
call mma_deallocate(LowVal)
call mma_deallocate(LowVec)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine FixHess

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Per Ake Malmqvist                                *
!***********************************************************************

subroutine NewGS(N,S,C,Temp,M)
! PAM 2009, New Gram-Schmidt 090216

use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: N
integer(kind=iwp), intent(out) :: M
real(kind=wp), intent(in) :: S(N,N)
real(kind=wp), intent(inout) :: C(N,N)
real(kind=wp), intent(out) :: Temp(N)
integer(kind=iwp) :: i, isfail, k, Loop
real(kind=wp) :: ovl, X, xn2, Y
real(kind=r8), external :: DDOT_

M = 0
outer: do i=1,N
  X = S(i,i)
  if (X < 1.0e-6_wp) cycle
  Y = One/sqrt(X)
  C(:,M+1) = Zero
  C(i,M+1) = Y
  Temp(:) = Y*S(:,i)

  Loop = 0
  do
    Loop = Loop+1
    do k=1,M
      ovl = DDOT_(N,Temp,1,C(1,k),1)
      C(:,M+1) = C(:,M+1)-ovl*C(:,k)
    end do
    call dGeMV_('N',N,N,One,S,N,C(1,M+1),1,Zero,Temp,1)
    xn2 = DDOT_(N,Temp,1,C(1,M+1),1)

    if (xn2 < 1.0e-6_wp) cycle outer

    Y = One/sqrt(xn2)
    C(:,M+1) = Y*C(:,M+1)
    call dGeMV_('N',N,N,One,S,N,C(1,M+1),1,Zero,Temp,1)
    if ((Loop /= 1) .or. (Y <= 100.0_wp)) exit
  end do
  ! MGD issues with many states : to be very safe, test the result
  isfail = 0
  do k=1,M
    ovl = DDOT_(N,Temp,1,C(1,k),1)
    if (abs(ovl) > 1.0e-4_wp) isfail = 1
  end do
  if (isfail == 0) M = M+1

end do outer

return

end subroutine NewGS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine contract_Zpk_Tpxy(Zpk,nZpk,Txy,nTxy,Scrt,nScrt,
     &                             Diag,nDiag,nnP,nBas_Aux,
     &                             nAdens,nAvec,nAct,nIrrep)
      Implicit none
      Integer nZpk,nTxy,nScrt,nDiag,nIrrep,nnP(0:nIrrep-1),
     &        nBas_Aux(0:nIrrep-1),nact(0:nIrrep-1),nAdens,nAvec,
     &        i,j,k,l,nCumnnP,nCumnnP2,nCumnnP3,
     &        ip,jp,kp,iSym,jSym,kSym,iDen
      Real*8 Zpk(nZpk,nAVec),Txy(nTxy,nAdens),Scrt(nScrt),
     &       Diag(nDiag,nADens)
************************************************************************
*
      Do l=1,nAVec
        iDen=1
        If (l.gt.1) iDen=2
*
        nCumnnP=0
        nCumnnP2=0
        nCumnnP3=0
        Do iSym=0,nIrrep-1
          Do i=1,nBas_Aux(iSym)
             ip=nCumnnP2+(i-1)*nnP(iSym)
             Do j=1,nnP(iSym)
                Scrt(j)=0.0d0
                Do k=1,nnP(iSym)
                  kp=nCumnnP3+(k-1)*nnP(iSym)
                  Scrt(j)=Scrt(j)+Sign(1.0d0,Diag(nCumnnP+k,iDen))
     &                    *Zpk(k+ip,l)*Txy(j+kp,iDen)
                End Do
             End Do
             Do j=1,nnP(iSym)
               Zpk(j+ip,l)=Scrt(j)
             End Do
          End Do
*Now correct for the 2 factor
          Do i=1,nBas_Aux(iSym)
             ip=nCumnnP2+(i-1)*nnP(iSym)
             Do jSym=0,nIrrep-1
               kSym=iEOR(jsym,isym)
               If (kSym.le.jSym) Then
                 Do j=1,nAct(jSym)
                   If (kSym.eq.jSym) Then
                     jp=ip+j*(j-1)/2
                     Do k=1,j-1
                       Zpk(jp+k,l)=Zpk(jp+k,l)/2.0d0
                     End Do
                   Else
                     jp=ip+(j-1)*nAct(kSym)
                     Do k=1,nAct(kSym)
                       Zpk(jp+k,l)=Zpk(jp+k,l)/2.0d0
                     End Do
                   EndIf
                 End Do
                 If (kSym.eq.jSym) Then
                   ip=ip+nAct(jSym)*(nAct(jSym)+1)/2
                 Else
                   ip=ip+nAct(jSym)*nAct(kSym)
                 End If
               End If
             End Do
          End Do
*
*       Call RecPrt('Zpk',' ',Zpk(nCumnnP2+1,l),nnP(iSym),nBas_Aux(iSym))
          nCumnnP=nCumnnP+nnP(iSym)
          nCumnnP2=nCumnnP2+nnP(iSym)*nBas_Aux(iSym)
          nCumnnP3=nCumnnP3+nnP(iSym)**2
        End Do
      End Do
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
      REAL*8 FUNCTION THREEJ(XJ1,XJ2,XJ3,XM1,XM2,XM3)
      IMPLICIT REAL*8 (A-H,O-Z)
C ThreeJ: REAL*8 Wigner 3-j coefficients. From a modification of
C Racah''s formula for Clebsch-Gordan coeffs.

      THREEJ=DCLEBS(XJ1,XJ2,XJ3,XM1,XM2,-XM3)
      IF(THREEJ.EQ.0.0D0) RETURN
      I=NINT(XJ1-XJ2-XM3)
      IF(I.NE.(I/2)*2) THREEJ=-THREEJ
      THREEJ=THREEJ/SQRT(2.0D0*XJ3+1.0D0)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Arta Safari                                      *
!***********************************************************************

module spin_correlation

use CI_solver_util, only: rdm_from_runfile
use rasscf_global, only: iAdr15, lRoots, nacpar, nacpr2
use index_symmetry, only: one_el_idx_flatten, two_el_idx_flatten
use general_data, only: JobIPH
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
private

integer(kind=iwp) :: same_orbs
logical(kind=iwp) :: tRootGrad = .false.
integer(kind=iwp), allocatable :: orb_range_p(:), orb_range_q(:)

public :: orb_range_p, orb_range_q, same_orbs, spin_correlation_driver, tRootGrad

contains

subroutine spin_correlation_driver(orb_range_p,orb_range_q,iroot)
!! spin-spin-correlation function using orbital-resolved 2RDMs.
!! For details see Dobrautz et al. 2021, 10.1021/acs.jctc.1c00589.

  integer(kind=iwp), intent(in) :: orb_range_p(:), orb_range_q(:), iroot(:)
  integer(kind=iwp) :: i, j, jDisk
  logical(kind=iwp) :: disk_pointer_moved
  real(kind=wp), allocatable :: dmat(:), dspn(:), pamat(:), psmat(:), spin_correlations(:)

  jDisk = iAdr15(3)
  call mma_allocate(dmat,nacpar,Label='dmat')
  call mma_allocate(dspn,nacpar,Label='dspn')
  call mma_allocate(pamat,nacpr2,Label='pamat')
  call mma_allocate(psmat,nacpr2,Label='psmat')
  call mma_allocate(spin_correlations,size(iroot))
  spin_correlations(:) = Zero

  ! the following disk pointer logic is necessary, because a user may
  ! optimise less roots than included in the Davidson matrix, e.g.
  ! roots (1, 2, 5, 8, 10). In &RASSCF RDMs for all Lroots
  ! will be computed, hence the memory reference here needs to be
  ! incremented accordingly to compute the SSCR for the correct roots.

  write(u6,'(a)') new_line('a')
  do i=1,LRoots
    disk_pointer_moved = .false.
    do j=1,size(iroot)
      if (iroot(j) == i) then
        call rdm_from_runfile(dmat,dspn,psmat,pamat,jDisk)
        disk_pointer_moved = .true.
        spin_correlations(j) = correlation_func(orb_range_p,orb_range_q,dmat,psmat,pamat)
        write(u6,'(a,i2,a,f12.8)') '::    RASSCF root number ',iroot(j),' Spin Correlation:  ',spin_correlations(j)
      end if
    end do
    if (.not. disk_pointer_moved) then
      ! dummy write to move jDisk pointer
      call ddafile(JOBIPH,0,dmat,NACPAR,jDisk)
      call ddafile(JOBIPH,0,dspn,NACPAR,jDisk)
      call ddafile(JOBIPH,0,psmat,NACPR2,jDisk)
      call ddafile(JOBIPH,0,pamat,NACPR2,jDisk)
    end if
  end do

  ! for testing purposes
  call Add_Info('spin correlation',spin_correlations(1),1,8)

  call mma_deallocate(dmat)
  call mma_deallocate(dspn)
  call mma_deallocate(pamat)
  call mma_deallocate(psmat)
  call mma_deallocate(spin_correlations)

end subroutine spin_correlation_driver

function correlation_func(orb_range_p,orb_range_q,dmat,psmat,pamat) result(corr)
!! extract spin-spin-correlation function from orbital resolved RDMs.

  use Constants, only: Half

  real(kind=wp) :: corr
  integer(kind=iwp), intent(in) :: orb_range_p(:), orb_range_q(:)
  real(kind=wp), intent(in) :: dmat(nacpar), psmat(nacpr2), pamat(nacpr2)
  integer(kind=iwp) :: p, pp, pppp, ppqq, pqqp, q, rp, rq
  real(kind=wp) :: onerdm_pp, twordm_pppp, twordm_ppqq, twordm_pqqp

  corr = Zero

  do p=1,size(orb_range_p)
    do q=1,size(orb_range_q)
      ! dummy variables to save space
      rp = orb_range_p(p)
      rq = orb_range_q(q)
      if (rp /= rq) then
        pqqp = two_el_idx_flatten(rp,rq,rq,rp)
        ppqq = two_el_idx_flatten(rp,rp,rq,rq)
        twordm_pqqp = psmat(pqqp)-pamat(pqqp)
        twordm_ppqq = 2*(psmat(ppqq)+pamat(ppqq))

        corr = corr-Half*(twordm_pqqp+Half*twordm_ppqq)
      else
        pppp = two_el_idx_flatten(rp,rp,rp,rp)
        pp = one_el_idx_flatten(rp,rp)

        twordm_pppp = 2*(psmat(pppp)+pamat(pppp))
        onerdm_pp = dmat(pp)
        corr = corr+0.75_wp*(onerdm_pp-twordm_pppp)
      end if
    end do
  end do

end function correlation_func

end module spin_correlation

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_ANADIA(DIAG,BIN1,STEP,NUMBIN,FULL)
!
! Purpose: analyze diagonal (histogram).

use Cholesky, only: DIAMNZ, IABMNZ, LuPri, nnBstRT, nnZTot, ThrCom
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*), BIN1, STEP
integer(kind=iwp), intent(in) :: NUMBIN
logical(kind=iwp), intent(in) :: FULL
integer(kind=iwp), parameter :: MAXBIN = 50, NUMSTA = 7
integer(kind=iwp) :: IAB, IBIN, MBIN, NBIN, NCONV
real(kind=wp) :: BIN(MAXBIN), BINLOC, STAT(NUMSTA), STPLOC
logical(kind=iwp) :: FOUND

! Print header.
! -------------

call CHO_HEAD('Histogram of Diagonal Elements','=',80,LUPRI)

! Set up size bins for analysis of diagonal.
! ------------------------------------------

if (NUMBIN < 1) then
  MBIN = min(10,MAXBIN)
  BINLOC = 1.0e2_wp
  STPLOC = 1.0e-2_wp
else
  MBIN = min(NUMBIN,MAXBIN)
  BINLOC = BIN1
  STPLOC = STEP
end if

BIN(1) = BINLOC
do IBIN=2,MBIN
  BIN(IBIN) = BIN(IBIN-1)*STPLOC
end do

! Set smallest BIN according to full.
! -----------------------------------

if (FULL) then
  NBIN = MBIN
else
  NBIN = MBIN
  IBIN = MBIN
  FOUND = .false.
  do while ((IBIN > 1) .and. (.not. FOUND))
    IBIN = IBIN-1
    if (THRCOM >= BIN(IBIN)) then
      NBIN = IBIN+1
    else
      FOUND = .true.
    end if
  end do
end if

! Histogram.
! ----------

call CHO_ANASIZE(DIAG,NNBSTRT(1),BIN,NBIN,LUPRI)

! Count converged.
! ----------------

NCONV = 0
do IAB=1,NNBSTRT(1)
  if (DIAG(IAB) <= THRCOM) NCONV = NCONV+1
end do
write(LUPRI,'(/,1X,A,I10,/,1X,A,I10)') 'Converged  : ',NCONV,'Unconverged: ',NNBSTRT(1)-NCONV

! Print total number of negative zeroed diagonal as well as the most
! negative one.
! ------------------------------------------------------------------

write(LUPRI,'(/,1X,A,5X,I10)') 'Total number of zeroed negative diagonals: ',NNZTOT
if (NNZTOT > 0) then
  if (IABMNZ < 1) then
    write(LUPRI,'(1X,A)') 'WARNING: most negative zeroed diagonal has not been stored!'
  else
    write(LUPRI,'(1X,A,ES15.6)') '- most negative zeroed diagonal          : ',DIAMNZ
  end if
end if

! Print statistics.
! -----------------

call STATISTICS(DIAG,NNBSTRT(1),STAT,1,2,3,4,5,6,7)
write(LUPRI,'(/,1X,A,ES15.6)') 'Minimum diagonal: ',STAT(3)
write(LUPRI,'(1X,A,ES15.6)') 'Maximum diagonal: ',STAT(4)
write(LUPRI,'(1X,A,ES15.6)') 'Mean value      : ',STAT(1)
write(LUPRI,'(1X,A,ES15.6)') 'Mean abs. value : ',STAT(2)
write(LUPRI,'(1X,A,ES15.6)') 'Biased variance : ',STAT(6)
write(LUPRI,'(1X,A,ES15.6,A)') 'Standard dev.   : ',STAT(7),' (unbiased variance)'

end subroutine CHO_ANADIA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SG_Setup_RASSCF(DBG,SkipGUGA,initial_occ)

use Molcas, only: MxLev
use fciqmc, only: DoNECI
use fcidump, only: DumpOnly
use CC_CI_mod, only: Do_CC_CI
use gas_data, only: iDoGAS, NGAS, NGSSH
use rasscf_global, only: DoBlockDMRG, NSM
use general_data, only: iSpin, nActel, nConf, nElec3, nHole1, nRs1, nRs2, nRs3, nSym, STSYM
use sguga, only: CIS, EXS, MKCLIST, MKCOT, MKSGNUM, SG_Init_Simple, SGS
#ifdef _DMRG_
use rasscf_global, only: DoDMRG
use input_ras, only: Key
use stdalloc, only: mma_deallocate
#endif
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(inout) :: DBG, SkipGUGA
integer(kind=iwp), allocatable, optional, intent(inout) :: initial_occ(:,:)
integer(kind=iwp) :: IGAS, iq, ISYM, Level(MxLev), NLEV, NSTA
real(kind=wp) :: dum1, dum2, dum3, Eterna_1, Eterna_2

NLEV = 0
do IGAS=1,NGAS
  do ISYM=1,NSYM
    NSTA = NLEV+1
    NLEV = NLEV+NGSSH(IGAS,ISYM)
    NSM(NSTA:NLEV) = ISYM
  end do
end do
Level(1:MxLev) = [(iq,iq=1,MxLev)]

! Construct the Guga tables

if (.not.(DoNECI .or. Do_CC_CI .or. DumpOnly .or. SkipGUGA)) then
  ! right now skip most part of gugactl for GAS, but only call mkism.
  if (.not. iDoGas) then
    ! DMRG calculation no need the SG_Init_RASSCF subroutine
#   ifdef _DMRG_
    if (Key('DMRG') .or. doDMRG) then
      call mma_deallocate(initial_occ)
      SkipGUGA = .true.
    else
#   else
#   include "macros.fh"
    unused_opt(initial_occ)
#   endif
      call Timing(Eterna_1,dum1,dum2,dum3)
      if (DBG) write(u6,*) ' Call SG_Init_Simple'
      call SG_Init_Simple(nSym,nActEl,iSpin,SGS,CIS,EXS,nHole1,nElec3,nRs1,nRs2,nRs3,xLevel=Level,xL2Act=Level,xNLEV=NLEV,xNSM=NSM)

      if (SGS%NVERT0 == 0) then
        CIS%NCSF(STSYM) = 0
      else
        if (doBlockDMRG) then
          CIS%NCSF(STSYM) = 1
        else

          ! FORM VARIOUS OFFSET TABLES:
          ! NOTE: NIPWLK AND DOWNWLK ARE THE NUMER OF INTEGER WORDS USED
          !       TO STORE THE UPPER AND LOWER WALKS IN PACKED FORM.

          call MKCOT(SGS,CIS)

          ! CONSTRUCT THE CASE LIST

          call MKCLIST(SGS,CIS)

          ! SET UP ENUMERATION TABLES

          call MKSGNUM(STSYM,SGS,CIS,EXS)

          if (NActEl == 0) CIS%NCSF(STSYM) = 1

          ! (SGS%IFRAS-1) IS THE NUMBER OF SYMMETRIES CONTAINING ACTIVE ORBITALS
          ! IF THIS IS GREATER THAN 1 ORBITAL REORDERING INTEGRALS IS REQUIRED
          ! SET UP THE REINDEXING TABLE
        end if
      end if
      call SETSXCI()
      NCONF = CIS%NCSF(STSYM)

      call Timing(Eterna_2,dum1,dum2,dum3)
#   ifdef _DMRG_
    end if
#   endif
  end if
end if

end subroutine sg_setup_rasscf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mksyminit_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"

c  Generate symmetry information - first call gets dimensions :
      i1 = mstacki_cvb(4*norbrel)
      i2 = mstacki_cvb(norb*norbrel)
      i3 = mstacki_cvb(norb)
      i4 = mstackr_cvb(norb*norb)
      i5 = mstackr_cvb(norb*norb)
      i6 = mstackr_cvb(norb)
      i7 = mstackr_cvb(norb)
      i8 = mstackr_cvb(norb*norb)
      i9 = mstackr_cvb(norb*norb)
      i10= mstacki_cvb(norb)
      call syminit2_cvb(w(ls(1)),iw(ls(2)),iw(ls(3)),w(ls(4)),
     >  iw(ls(5)),w(ls(6)),iw(i1),iw(i2),iw(i3),w(i4),w(i5),
     >  w(i6),w(i7),w(i8),w(i9),iw(i10),
     >  iw(ls(8)),iw(ls(9)),iw(ls(10)),
     >  iw(ls(11)),iw(ls(12)),iw(ls(13)))
      call mfreei_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Valera Veryazov                                  *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!       general purpose routine for printing nice messages             *
!       with simple reformatting:                                      *
!           \n and long string converted to new line                   *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     V.Veryazov University of Lund, 2001                              *
!                                                                      *
!***********************************************************************

subroutine SysPuts(str,str1,str2)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: str, str1, str2
integer(kind=iwp) :: i, icr, icr1, ii, iii, ij, iLongEnough, ipos, iTooLong, j, mlen, mleni
character(len=len(str)+len(str1)+len(str2)) :: Junk

! because of bug in g77 we can't just concatenate strings and
! had to have limited length of the string
iTooLong = 60
iLongEnough = 50
Junk = str//trim(str1)//trim(str2)
mlen = len_trim(Junk)
mleni = mlen
ipos = 1
! check is '\n' == <CR>?
icr = len('\n')-1
icr1 = 0
do
  j = 100000
  ii = index(Junk(ipos:mleni),'\n')
  if (ii > 0) j = min(j,ii)
  iii = index(Junk(ipos:mleni),';')
  if (iii > 0) j = min(j,iii)
  if ((j == ii) .and. (ii > 0)) icr1 = icr
  if ((j == iii) .and. (iii > 0)) icr1 = 0
  if (j == 100000) j = 0
  i = j
  if ((i > iTooLong) .or. ((i == 0) .and. (mlen > iTooLong))) then
    ij = index(Junk(ipos+iLongEnough:mleni),' ')
    if (ij == 0) then
      call SysDumpStr(Junk(ipos:mleni))
      if (i == 0) return
    else
      ij = ij+iLongEnough-1
      call SysDumpStr(Junk(ipos:ipos+ij))
    end if
    ipos = ipos+ij+1
    mlen = mlen-ij-1
    cycle
  end if
  if (i == 0) then
    call SysDumpStr(Junk(ipos:mleni))
    return
  end if
  call SysDumpStr(Junk(ipos:ipos+i-2))
  ipos = ipos+i+icr1
  mlen = mlen-i-icr1
  if (mlen <= 0) exit
end do

return

end subroutine SysPuts

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CtlDns(iDCRR,iDCRS,iDCRT,jOp)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iDCRR, iDCRS, iDCRT
integer(kind=iwp), intent(out) :: jOp(6)
integer(kind=iwp) :: iR, iRT, iRTS, iS, iT, iTS
integer(kind=iwp), external :: NrOpr

! Djl. Some care has to be taken here. Assume that there
! are two operators, T and S which generates the center
! pairs A,T(B) and A,S(B). If these pairs are symmetry
! related we will only

! Dij
iR = iDCRR
jOp(1) = NrOpr(iR)+1
! Dkl
iS = iDCRS
jOp(2) = NrOpr(iS)+1
! Dik
iT = iDCRT
jOp(3) = NrOpr(iT)+1
! Dil
iTS = ieor(iT,iS)
jOp(4) = NrOpr(iTS)+1
! Djk
iRT = ieor(iR,iT)
jOp(5) = NrOpr(iRT)+1
! Djl
iRTS = ieor(iRT,iS)
jOp(6) = NrOpr(iRTS)+1

return

end subroutine CtlDns

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Angle_List(
     &                 nq,
     &                 nsAtom,iIter,nIter,Cx,
     &                 Process,Value,
     &                 nB,qLbl,iRef,
     &                 fconst,rMult,LuIC,Indq,
     &                 Grad_all,iGlow,iGhi,iPrv,Proc_dB,
     &                 iTabBonds,nBonds,iTabAI,mAtoms,iTabAtoms,nMax,
     &                 mB_Tot,mdB_Tot,
     &                 BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,nqB,Thr_small)
      use Symmetry_Info, only: nIrrep, iOper
      use Slapaf_Info, only: jStab, nStab, AtomLbl, ANr
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
#include "Molcas.fh"
      Parameter (mB = 3*3)
      Real*8 Cx(3,nsAtom,nIter), A(3,3), Hess(mB**2),
     &       fconst(nB),Value(nB,nIter), rMult(nB),
     &       Ref(3,3), Prv(3,3),
     &       Grad_Ref(9), Axis(3), Perp_Axis(3,2), Grad(mB),
     &       Grad_all(9,iGlow:iGhi,nIter),
     &       BM(nB_Tot), dBM(ndB_Tot)
      Integer   iDCRR(0:7), iStabM(0:7), Ind(3), iDCR(3), iDCRT(0:7),
     &          iStabN(0:7), iChOp(0:7), Indq(3,nB), nqB(nB),
     &          iTabBonds(3,nBonds), iTabAI(2,mAtoms),
     &          iTabAtoms(2,0:nMax,mAtoms), iBM(nB_Tot),idBM(2,ndB_Tot)
      Logical Process, MinBas, Help, Proc_dB, R_Stab_A
      Character*14 Label, qLbl(nB)
      Character*3 ChOp(0:7)
      Character*(LENIN4) Lbls(3)
#include "bondtypes.fh"
#define _FMIN_
#include "ddvdt.fh"
#include "ddvdt_bend.fh"
      Data ChOp/'E  ','X ','Y ','XY ','Z  ','XZ ','YZ ','XYZ'/
      Data iChOp/1,1,1,2,1,2,2,3/
#include "constants.fh"
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      If (nBonds.lt.2) Return
#ifdef _DEBUGPRINT_
      iRout=150
      iPrint=nPrint(iRout)
      iPrint=99
#endif
*
      nqA=0
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Write (6,*) ' Enter Bends.'
#endif
      Call FZero(Hess,81)
*
*---- Loop over bends
*
      MinBas=.False.
      If (MinBas) Then
         Fact=1.3d0
      Else
         Fact=One
      End If
      nCent=3
*     Write (6,*)
*
      Do mAtom_ = 1, mAtoms
         mAtom = iTabAI(1,mAtom_)
         mr = iTabRow(ANr(mAtom))
         Ind(2) = mAtom
         iDCR(2) = iTabAI(2,mAtom_)

         nNeighbor_m = iTabAtoms(1,0,mAtom_)
         nCoBond_m=nCoBond(mAtom_,mAtoms,nMax,iTabBonds,
     &                     nBonds,iTabAtoms)
         If (nNeighbor_m.lt.2) Go To 100
*
         Do iNeighbor = 1, nNeighbor_m
            iAtom_ = iTabAtoms(1,iNeighbor,mAtom_)
            iAtom = iTabAI(1,iAtom_)
            nCoBond_i=nCoBond(iAtom_,mAtoms,nMax,iTabBonds,
     &                        nBonds,iTabAtoms)
            ir = iTabRow(ANr(iAtom))
            Ind(1) = iAtom
            iDCR(1) = iTabAI(2,iAtom_)
*
            If (iDCR(1).ne.iOper(0)) Go To 200
            If (R_Stab_A(iDCR(2),jStab(0,iAtom),nStab(iAtom)) .and.
     &          iDCR(2).ne.iOper(0)) Go To 200
*
            iBond = iTabAtoms(2,iNeighbor,mAtom_)
            iBondType=iTabBonds(3,iBond)
            If (iBondType.eq.vdW_Bond.or.
     &          iBondType.gt.Magic_Bond) Go To 200
#ifdef _DEBUGPRINT_
            Write (6,*)
            Write (6,*) 'iAtom,mAtom=',iAtom,mAtom
            Write (6,*) 'iBond,iBondType=',iBond,iBondType
            Write (6,*) 'E,R=',ChOp(iDCR(1)),ChOp(iDCR(2))
#endif
*
            call dcopy_(3,Cx(1,iAtom,iIter),1,A,1)
            call dcopy_(3,Cx(1,iAtom,iRef),1,Ref,1)
            call dcopy_(3,Cx(1,iAtom,iPrv),1,Prv,1)
*
            Do jNeighbor = 1, nNeighbor_m
               jAtom_ = iTabAtoms(1,jNeighbor,mAtom_)
               jAtom = iTabAI(1,jAtom_)
               nCoBond_j=nCoBond(jAtom_,mAtoms,nMax,iTabBonds,
     &                           nBonds,iTabAtoms)
               If (nCoBond_i.ge.8 .and.
     &             nCoBond_j.ge.8 .and.
     &             nCoBond_m.ge.8       ) Go To 300
*
               jr = iTabRow(ANr(jAtom))
               Ind(3) = jAtom
               iDCR(3) = iTabAI(2,jAtom_)
               If (R_Stab_A(iDCR(3),jStab(0,iAtom),nStab(iAtom)) .and.
     &             iDCR(3).ne.iOper(0)) Go To 300
               If (iDCR(3).eq.iOper(0) .and. iAtom.ge.jAtom) Go To 300
               kDCR=iEor(iDCR(2),iDCR(3))
               If (R_Stab_A(kDCR,jStab(0,mAtom),nStab(mAtom)) .and.
     &             iDCR(2).ne.iOper(0)) Go To 300
*
               Help=mr.gt.3 .or. ir.gt.3 .or. jr.gt.3
*
               jBond = iTabAtoms(2,jNeighbor,mAtom_)
               jBondType=iTabBonds(3,jBond)
               If (jBondType.eq.vdW_Bond.or.
     &             jBondType.gt.Magic_Bond) Go To 300
#ifdef _DEBUGPRINT_
               Write (6,*)
               Write (6,*) 'jAtom,mAtom=',jAtom,mAtom
               Write (6,*) 'jBond,jBondType=',jBond,jBondType
               Write (6,*) 'T=',ChOp(iDCR(3))
#endif
*
               Write (Label,'(A,I2,A,I2,A,I2,A)')
     &                'A(',iAtom,',',mAtom,',',jAtom,')'
*
#ifdef _DEBUGPRINT_
               If (iPrint.ge.99) Then
                  Call RecPrt('A',' ',Cx(1,iAtom,iIter),1,3)
                  Call RecPrt('B',' ',Cx(1,mAtom,iIter),1,3)
                  Call RecPrt('C',' ',Cx(1,jAtom,iIter),1,3)
               End If
#endif
*
*------------- Form double coset representatives for (iAtom,jAtom)
*
               Call DCR(Lambda,
     &                  jStab(0,iAtom),nStab(iAtom),
     &                  jStab(0,jAtom),nStab(jAtom),iDCRT,nDCRT)
#ifdef _DEBUGPRINT_
               Write (6,'(10A)') 'T={',
     &               (ChOp(iDCRT(i)),i=0,nDCRT-1),'}  '
#endif
               kDCRT=iDCR(3)
*
#ifdef _DEBUGPRINT_
               If (iPrint.ge.99) Then
                  Write (6,'(10A)') 'U={',
     &                  (ChOp(jStab(i,iAtom)),i=0,nStab(iAtom)-1),'}  '
                  Write (6,'(10A)') 'V={',
     &                  (ChOp(jStab(i,mAtom)),i=0,nStab(mAtom)-1),'}  '
                  Write (6,'(10A)') 'X={',
     &                  (ChOp(jStab(i,jAtom)),i=0,nStab(jAtom)-1),'}  '
                  Write (6,'(2A)') 'T=',ChOp(kDCRT)
               End If
#endif
*
               Call OA(kDCRT,Cx(1:3,jAtom,iIter),  A(1:3,3))
               Call OA(kDCRT,Cx(1:3,jAtom,iRef ),Ref(1:3,3))
               Call OA(kDCRT,Cx(1:3,jAtom,iPrv ),Prv(1:3,3))
*
*------------- Form the stabilizer for (iAtom,jAtom)
*
               If (iAtom.eq.jAtom) Then
                     Call Union(jStab(0,iAtom),nStab(iAtom),
     &                          jStab(0,jAtom),nStab(jAtom),
     &                          iDCR(3),iStabN,nStabN)
               Else
                     Call Inter(jStab(0,iAtom),nStab(iAtom),
     &                          jStab(0,jAtom),nStab(jAtom),
     &                          iStabN,nStabN)
               End If
*
#ifdef _DEBUGPRINT_
               If (iPrint.ge.99) Then
                  Write (6,'(10A)') 'N={',
     &                  (ChOp(iStabN(i)),i=0,nStabN-1),'}  '
               End If
#endif
*
*------------- Form double coset representatives for
*              ((iAtom,mAtom),jAtom)
*
               Call DCR(Lambda,
     &                  jStab(0,mAtom),nStab(mAtom),
     &                  iStabN,nStabN,iDCRR,nDCRR)
               kDCRR = iDCR(2)
*
#ifdef _DEBUGPRINT_
               If (iPrint.ge.99) Then
                  Write (6,'(10A)') 'R={',
     &                  (ChOp(iDCRR(i)),i=0,nDCRR-1),'}  '
                  Write (6,'(2A)') 'R=',ChOp(kDCRR)
               End If
#endif
*
               Call OA(kDCRR,Cx(1:3,mAtom,iIter),  A(1:3,2))
               Call OA(kDCRR,Cx(1:3,mAtom,iRef ),Ref(1:3,2))
               Call OA(kDCRR,Cx(1:3,mAtom,iPrv ),Prv(1:3,2))
*
*------------- Form the stabilizer for ((iAtom,mAtom),jAtom)
*
               Call Inter(jStab(0,mAtom),nStab(mAtom),
     &                    iStabN,nStabN,
     &                    iStabM,nStabM)
*
#ifdef _DEBUGPRINT_
               If (iPrint.ge.99) Then
                  Write (6,'(10A)') 'M={',
     &                  (ChOp(iStabM(i)),i=0,nStabM-1),'}  '
               End If
#endif
*
*------------- Compute the degeneracy of the angle
*
               ideg=nIrrep/nStabM
               Deg=Sqrt(DBLE(iDeg))
#ifdef _DEBUGPRINT_
               If (iPrint.ge.99) Write (6,*)
     &            ' nIrrep,nStabM=',nIrrep,nStabM
#endif
*
*------------- Test if coordinate should be included
*              All angles which are lower than the explicit threshold
*              are rejected.
*
               If (Help) Then
                  rim2=(Ref(1,1)-Ref(1,2))**2
     &                +(Ref(2,1)-Ref(2,2))**2
     &                +(Ref(3,1)-Ref(3,2))**2
                  rmj2=(Ref(1,2)-Ref(1,3))**2
     &                +(Ref(2,2)-Ref(2,3))**2
     &                +(Ref(3,2)-Ref(3,3))**2
                  If (ir.eq.1.or.jr.eq.1) Then
                     f_Const=A_Bend(1)
                  Else
                     f_Const=A_Bend(2)
                  End If
                  f_Const=f_Const*Fact
                  f_Const_Ref=f_Const
               Else
                  r0=rAV(ir,mr)
                  Alpha=aAv(ir,mr)
                  rim2_Ref=(Ref(1,1)-Ref(1,2))**2
     &                    +(Ref(2,1)-Ref(2,2))**2
     &                    +(Ref(3,1)-Ref(3,2))**2
                  f_Const_Ref=rkf*Exp(Alpha*(r0**2-rim2_Ref))
                  rim2=(A(1,1)-A(1,2))**2
     &                +(A(2,1)-A(2,2))**2
     &                +(A(3,1)-A(3,2))**2
                  f_Const=rkf*Exp(Alpha*(r0**2-rim2))
*
                  r0=rAV(mr,jr)
                  Alpha=aAv(mr,jr)
                  rmj2_Ref=(Ref(1,2)-Ref(1,3))**2
     &                    +(Ref(2,2)-Ref(2,3))**2
     &                    +(Ref(3,2)-Ref(3,3))**2
                  f_Const_Ref=f_Const_Ref*Exp(Alpha*(r0**2-rmj2_Ref))
                  rmj2=(A(1,2)-A(1,3))**2
     &                +(A(2,2)-A(2,3))**2
     &                +(A(3,2)-A(3,3))**2
                  f_Const=f_Const*Exp(Alpha*(r0**2-rmj2))
*
               End If
               If (f_Const_Ref.lt.f_Const_Min .and.
     &             iBondType.ne.Fragments_Bond .and.
     &             jBondType.ne.Fragments_Bond ) Go To 300
#ifdef _DEBUGPRINT_
               Write (6,*) ' A Force Constant:',f_Const
               Write (6,*) iAtom,mAtom,jAtom, f_Const
#endif
*
               Call Bend(Ref,nCent,Val_Ref,Grad_Ref,.False.,
     &                   .False.,'        ',Hess,Proc_dB)
               Call Bend(A,nCent,Val,Grad,.False.,
     &                   .False.,'        ',Hess,Proc_dB)
*
*------------- Skip cases with a too small angle.
*
               If (Abs(Val_Ref).lt.Thr_Small .and.
     &             iBondType.ne.Fragments_Bond .and.
     &             jBondType.ne.Fragments_Bond) Go To 300
*
*                                                                      *
************************************************************************
*                                                                      *
*              We'd like to avoid the problem with angles that have the
*              value Pi. We introduce "linear" angles under two
*              conditions.
*              (1) the reference angle is within delta of Pi.
*              (2) the actual angle is within 1.0D-11 of Pi.(?)
*              Delta is set to 1.0D-11 if there are 3 atoms.(?)
*
               delta=(45.0D0/180.0D0)*Pi
*              If (mAtoms.eq.3) delta=1.0D-11 ! I do not understand
*              although it is probably me who introduced it!
*
               If ( (Abs(Val_Ref-Pi).lt.Delta .or.
     &               Abs(Val-Pi).lt.1.0D-11) .and.
     &            .NOT.(
     &                  (iBondType.eq.Fragments_Bond .or.
     &                   jBondType.eq.Fragments_Bond)
     &                   .and. mAtoms.le.4
     &                  )
     &            ) Then
*
*---------------- Reference is linear(a) or
*---------------- reference is NOT linear but the new structure is(b).
*
                  If (Abs(Val-Pi).lt.1.0D-11 .and.
     &                .Not.(Abs(Val_Ref-Pi).lt.Delta)) Then
*                    Case b
                     nk=1
                  Else
*                    Case a
                     nk=2
                  End If
                  Call CoSys(Prv,Axis,Perp_Axis)
*
                  Label=' '
                  Label(1:1)='L'
C                 Do k = 1, 2
                  Do k = 1, nk
                     nq = nq + 1
                     If (.Not.Process) mB_Tot = mB_Tot + mB
                     If (.Not.Proc_dB) mdB_Tot = mdB_Tot + mB**2
*
                     nqA = nqA + 1
                     iF1=1
                     Call NxtWrd(AtomLbl(iAtom),iF1,iE1)
                     Lbls(1)=AtomLbl(iAtom)(iF1:iE1)
                     iF2=1
                     Call NxtWrd(AtomLbl(mAtom),iF2,iE2)
                     Lbls(2)=AtomLbl(mAtom)(iF2:iE2)
                     If (kDCRR.ne.0) Then
                        Lbls(2)(iE2+1:iE2+2+iChOp(kDCRR))=
     &                   '('//ChOp(kDCRR)(1:iChOp(kDCRR))//')'
                        Call NxtWrd(Lbls(2),iF2,iE2)
                     End If
                     iF3=1
                     Call NxtWrd(AtomLbl(jAtom),iF3,iE3)
                     Lbls(3)=AtomLbl(jAtom)(iF3:iE3)
                     If (kDCRT.ne.0) Then
                        Lbls(3)(iE3+1:iE3+2+iChOp(kDCRT))=
     &                   '('//ChOp(kDCRT)(1:iChOp(kDCRT))//')'
                        Call NxtWrd(Lbls(3),iF3,iE3)
                     End If
                     Write (LuIC,'(A,I3.3,A,I1.1,6A)')
     &                      'a',nqA,' = LAngle(',k,') ',
     &                          Lbls(1)(iF1:iE1),
     &                      ' ',Lbls(2)(iF2:iE2),
     &                      ' ',Lbls(3)(iF3:iE3)
#ifdef _DEBUGPRINT_
                     If (iPrint.ge.49)
     &               Write (6,'(A,I3.3,A,I1.1,6A)')
     &                      'a',nqA,' = LAngle(',k,') ',
     &                          Lbls(1)(iF1:iE1),
     &                      ' ',Lbls(2)(iF2:iE2),
     &                      ' ',Lbls(3)(iF3:iE3)
                     Write (6,*) 'iDeg=',iDeg
#endif
                     Label=' '
                     Write (Label,'(A,I3.3)') 'a',nqA
*
                     If (Process) Then
*
                        Call LBend(A,nCent,Val,
     &                             Grad_all(1,nq,iIter),
     &                             .False.,
     &                             '        ',Hess,Proc_dB,Axis,
     &                             Perp_Axis(1,k),(k.eq.2))
*
*---------------------- Flip Angle value and gradient if needed!
*
                        BB=DDot_(9,Grad_all(1,nq, iPrv),1,
     &                             Grad_all(1,nq,iIter),1)
                        If (BB.lt.Zero) Then
*                          Write (6,*) ' Angle flips, corrected!'
                           Val=Two*Pi-Val
                           Call DScal_(9,-One,
     &                                Grad_all(1,nq,iIter),1)
                           Call DScal_(81,-One,Hess,1)
                        End If
*
                        Indq(1,nq)=2+k
                        mi = (iAtom-1)*nsAtom + mAtom
                        Indq(2,nq)= (jAtom-1)*nsAtom**2 + mi
                        Indq(3,nq)= kDCRT*8 + kDCRR+1
*
                        f_Const=Max(f_Const,f_Const_Min)
                        If (.Not.Help .and.
     &                     (iBondType.eq.Fragments_Bond .or.
     &                      jBondType.eq.Fragments_Bond ))
     &                      f_Const=f_Const*1.D3
                        fconst(nq)=Sqrt(f_Const)
                        rMult(nq)=Deg
*
                        Value(nq,iIter)=Val
                        qLbl(nq)=Label
*
*---------------------- Project the gradient vector
*
                        Call ProjSym(nCent,Ind,A,iDCR,
     &                               Grad_all(1,nq,iIter),
     &                               Hess,
     &                               mB_Tot,mdB_Tot,
     &                               BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,
     &                               Proc_dB,nqB,nB,nq,rMult(nq))
*
                     End If
*
                  End Do
*
               Else      ! Non-linear case
*
                  nq = nq + 1
                  If (.Not.Process) mB_Tot = mB_Tot + mB
                  If (.Not.Proc_dB) mdB_Tot = mdB_Tot + mB**2
*
                  nqA = nqA + 1
                  iF1=1
                  Call NxtWrd(AtomLbl(iAtom),iF1,iE1)
                  Lbls(1)=AtomLbl(iAtom)(iF1:iE1)
                  iF2=1
                  Call NxtWrd(AtomLbl(mAtom),iF2,iE2)
                  Lbls(2)=AtomLbl(mAtom)(iF2:iE2)
                  If (kDCRR.ne.0) Then
                     Lbls(2)(iE2+1:iE2+2+iChOp(kDCRR))=
     &                '('//ChOp(kDCRR)(1:iChOp(kDCRR))//')'
                     Call NxtWrd(Lbls(2),iF2,iE2)
                  End If
                  iF3=1
                  Call NxtWrd(AtomLbl(jAtom),iF3,iE3)
                  Lbls(3)=AtomLbl(jAtom)(iF3:iE3)
                  If (kDCRT.ne.0) Then
                     Lbls(3)(iE3+1:iE3+2+iChOp(kDCRT))=
     &                '('//ChOp(kDCRT)(1:iChOp(kDCRT))//')'
                     Call NxtWrd(Lbls(3),iF3,iE3)
                  End If
                  Write (LuIC,'(A,I3.3,6A)')
     &                   'a',nqA,' = Angle ',
     &                       Lbls(1)(iF1:iE1),
     &                   ' ',Lbls(2)(iF2:iE2),
     &                   ' ',Lbls(3)(iF3:iE3)
#ifdef _DEBUGPRINT_
                  If (iPrint.ge.49)
     &            Write (6,'(A,I3.3,6A)')
     &                   'a',nqA,' = Angle ',
     &                       Lbls(1)(iF1:iE1),
     &                   ' ',Lbls(2)(iF2:iE2),
     &                   ' ',Lbls(3)(iF3:iE3)
#endif
                  Label=' '
                  Write (Label,'(A,I3.3)') 'a',nqA
*
                  If (Process) Then
*
                     Call Bend(A,nCent,Val,Grad_all(1,nq,iIter),
     &                         .False.,.False.,'        ',Hess,
     &                         Proc_dB)
*
*---------------------- Flip Angle value and gradient if needed!
*
                     BB=DDot_(9,Grad_all(1,nq,iPrv),1,
     &                       Grad_all(1,nq,iIter),1)
                     If (BB.lt.Zero) Then
*                       Write (*,*) ' Angle flips, corrected!'
*                       Write (*,*) ' iRef,iIter=', iRef,iIter
                        Val=Two*Pi-Val
                        Call DScal_(9,-One,Grad_all(1,nq,iIter),1)
                        Call DScal_(81,-One,Hess,1)
                     End If
*
                     Indq(1,nq)=2
                     mi = (iAtom-1)*nsAtom + mAtom
                     Indq(2,nq)= (jAtom-1)*nsAtom**2 + mi
                     Indq(3,nq)= kDCRT*8 + kDCRR+1
*
                     If (.Not.Help .and.
     &                  (iBondType.eq.Fragments_Bond .or.
     &                   jBondType.eq.Fragments_Bond ))
     &                   f_Const=f_Const*100.D0
                     fconst(nq)=Sqrt(f_Const)
                     rMult(nq)=Deg
*
                     Value(nq,iIter)=Val
                     qLbl(nq)=Label
*
*------------------- Project the gradient vector
*
                     Call ProjSym(nCent,Ind,A,iDCR,
     &                            Grad_all(1,nq,iIter),
     &                            Hess,
     &                            mB_Tot,mdB_Tot,
     &                            BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,
     &                            Proc_dB,nqB,nB,nq,rMult(nq))
*
                  End If
*
               End If
*                                                                      *
************************************************************************
*                                                                      *
*
  300          Continue
            End Do             ! End loop over jNeighbor
  200       Continue
         End Do                ! End loop over iCase
  100    Continue
      End Do                   ! End loop over iBond
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  DEV2A  := calculate two-electron Hessian                           *
!*                                                                     *
!***********************************************************************
subroutine dev2a_cvb(v1,v2,cfrom,hessorb,oaa2,aa1)
! Calculates V1 EijEkl CFROM and V2 EijEkl CFROM

use casvb_global, only: iform_ci, n_2el, ndet, nprorb
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: v1(0:ndet), v2(0:ndet), cfrom(0:ndet), oaa2, aa1
real(kind=wp), intent(inout) :: hessorb(nprorb,nprorb)
integer(kind=iwp) :: icfrom

icfrom = nint(cfrom(0))
n_2el = n_2el+2
if (iform_ci(icfrom) /= 0) then
  write(u6,*) ' Unsupported format in DEV2A :',iform_ci(icfrom)
  call abend_cvb()
end if

call dev2a_2_cvb(v1(1:),v2(1:),cfrom(1:),hessorb,oaa2,aa1)

return

end subroutine dev2a_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Martin Schuetz                                   *
!               1998, Roland Lindh                                     *
!               2000-2015, Steven Vancoillie                           *
!***********************************************************************

! initialize GA, returns rank of process and # of processes
subroutine GAInit()
!***********************************************************************
!     purpose: initialize DGA and set the global rank and number of    *
!              processes in mpp_procid and mpp_nprocs. Then also set   *
!              the (initial) local myRank and nProcs variables.        *
!***********************************************************************

use Para_Info, only: MyRank, nProcs
#ifdef _MOLCAS_MPP_
use Para_Info, only: mpp_nprocs, mpp_procid, mpp_workshare
use GA_Wrapper, only: GA_NNodes, GA_NodeId
#ifdef _GA_
use Definitions, only: MPIInt
#endif
use Definitions, only: iwp
#endif

implicit none
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: molcas_nprocs, iRC
#ifdef _GA_
integer(kind=MPIInt) :: iRC2
#endif
character(len=8) :: molcas_nprocs_env

! SVC: bypass MPI initialization if only 1 process, this is needed for a
! specific version of GEO (so that the serial tasks which are run by MPI
! do not try to re-initialize MPI). This has the consequence that for any
! calculation where the number of processes is 1, calls to MPI/GA will fail
! at runtime (even though it will compile when inside _MOLCAS_MPP_!)
call getenvf('MOLCAS_NPROCS',molcas_nprocs_env)
if (molcas_nprocs_env(1:1) == ' ') then
  molcas_nprocs = -1
else
  read(molcas_nprocs_env,*) molcas_nprocs
end if
if (molcas_nprocs /= 1) then
# ifdef _GA_
  call mpi_init(iRC2)
  call ga_initialize()
  call ga_replace_ma()
# else
  call ga_initialize()
# endif
  mpp_procid = ga_nodeid()
  mpp_nprocs = ga_nnodes()
  mpp_workshare = .true.
  ! make each slave process go to its proper work directory
  call slaveschdir(mpp_procid,iRC)
  if (iRC /= 0) call Abend()
else
  mpp_procid = 0
  mpp_nprocs = 1
  mpp_workshare = .false.
end if
MyRank = mpp_procid
nProcs = mpp_nprocs
#else
MyRank = 0
nProcs = 1
#endif

end subroutine GAInit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Giovanni Ghigo                              *
!               2021, Roland Lindh                                     *
!***********************************************************************
!  Cho_TraS
!
!> @brief
!>   Routine for the transformation of the Cholesky vectors in MO-based TCVx for case \c Sym(i) = \c Sym(j)
!> @author Giovanni Ghigo
!>
!> @details
!> In the inner batch the Cholesky Full Vectors are transformed and
!> stored in memory. Adresses (``1``) and length (``2``) are stored in the
!> matrix <tt>TCVX(iType, Sym(i), Sym(j)) of allocatable 2D arrays.</tt>.
!>
!> - \c iType = ``1``: TCVA
!> - \c iType = ``2``: TCVB
!> - \c iType = ``3``: TCVC
!> - \c iType = ``4``: TCVD
!> - \c iType = ``5``: TCVE
!> - \c iType = ``6``: TCVF
!> - \c iType = ``7``: TCVG
!>
!> Types ``1``, ``2`` and ``4``--``7`` are generated only if \c DoTCVA = ``.True.``
!> TCVC is always generated.
!>
!> In the first half-transformation the vectors are contracted
!> only with the occupied (inactive and active) MO coefficients
!> for \c Sym(j). In the second half-transformation the vectors are
!> contracted with all MO coefficients.
!>
!> @note
!> The logical matrix \c TCVXist must be defined.
!>
!> @param[in] iSym        Symmetry(``i``) of the Cholesky Full Vector
!> @param[in] jSym        Symmetry(``j``) of the Cholesky Full Vector
!> @param[in] NumV        Number of Cholesky vectors to transform in the current batch
!> @param[in] CMO         MO coefficients
!> @param[in] NCMO        Total number of MO coefficients
!> @param[in] lUCHFV      Unit number of the Cholesky Full Vector to transform (``CHFV``)
!> @param[in] iStrtVec_AB Current initial disk pointer of the Cholesky Full Vector to transform (``CHFV``)
!> @param[in] nFVec       Number of Cholesky vectors to transform in the inner batch procedure
!***********************************************************************

subroutine Cho_TraS(iSym,jSym,NumV,CMO,NCMO,lUCHFV,iStrtVec_AB,nFVec)
!***********************************************************************
!  This is the routine for the transformation from AO basis to MO      *
!  basis of the Cholesky Full Vectors when  iSym == jSym.              *
!  The new Transformed Cholesky Full Vectors L are :                   *
!                                                                      *
!   TCVA: L_ij  if DoTCVA=.True.                                       *
!   TCVB: L_tj  if DoTCVA=.True.                                       *
!   TCVC: L_aj                                                         *
!   TCVD: L_tu  if DoTCVA=.True.                                       *
!   TCVE: L_au  if DoTCVA=.True.                                       *
!   TCVF: L_ab  if DoTCVA=.True.                                       *
!   TCVG: L_jt  if DoTCVA=.True.                                       *
!  For generation of <pk|ql>  p,q: All MO, k,l: Occupied (i & t)       *
!  MO Indices  i,j: Inactive;   t,u: Active;   a,b: Secondary          *
!                                                                      *
!----------------------------------------------------------------------*
!  Author  :  Giovanni Ghigo                                           *
!             Lund University, Sweden & University di Torino, Italia   *
!  Written :  October 2004                                             *
!  Modified:  July 2005                                                *
!***********************************************************************

use Cho_Tra, only: nAsh, nBas, nFro, nIsh, nSsh, TCVX, TCVXist
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSym, jSym, NumV, NCMO, lUCHFV, iStrtVec_AB, nFVec
real(kind=wp), intent(in) :: CMO(NCMO)
integer(kind=iwp) :: i, iFBatch, iiVec, iStrt, iStrt0MO, iStrtVec_FAB, iVec, j, jStrt, jStrt0MO, jVec, Len_XAb, Len_XAj, Len_XAu, &
                     Nab, Naj, Nau, NFAB, Nij, Njt, Ntj, Ntu, NumFV
logical(kind=iwp) :: TCVA, TCVB, TCVC, TCVD, TCVE, TCVF
real(kind=wp), allocatable :: FAB(:,:), XAb(:), XAj(:), XAu(:)

! Memory to allocate & Nr. of Cholesky vectors transformable
! A=Alpha(AO);  B=Beta(AO)

TCVA = .false.
TCVB = .false.
TCVC = .false.
TCVD = .false.
TCVE = .false.
TCVF = .false.

Nij = 0
Ntj = 0
Njt = 0
Naj = 0
Ntu = 0
Nau = 0
Nab = 0

Len_XAj = 0
Len_XAu = 0
Len_XAb = 0

NFAB = nBas(iSym)*(nBas(jSym)+1)/2

! Allocate memory for Transformed Cholesky Vectors - TCVx
! TCV-A :
if (TCVXist(1,iSym,jSym)) then
  TCVA = .true.
  Len_XAj = nBas(iSym)*nIsh(jSym)
  Nij = nIsh(iSym)*nIsh(jSym)
  call mma_allocate(TCVX(1,iSym,jSym)%A,Nij,NumV,Label='TCVA')
end if

! TCV-B :
if (TCVXist(2,iSym,jSym)) then
  TCVB = .true.
  Len_XAj = nBas(iSym)*nIsh(jSym)
  Ntj = nAsh(iSym)*nIsh(jSym)
  Njt = nIsh(jSym)*nAsh(iSym)
  call mma_allocate(TCVX(2,iSym,jSym)%A,Ntj,NumV,Label='TCVB')
  call mma_allocate(TCVX(7,jSym,iSym)%A,Njt,NumV,Label='TCVB')
end if

! TCV-C :
if (TCVXist(3,iSym,jSym)) then
  TCVC = .true.
  Len_XAj = nBas(iSym)*nIsh(jSym)
  Naj = nSsh(iSym)*nIsh(jSym)
  call mma_allocate(TCVX(3,iSym,jSym)%A,Naj,NumV,Label='TCVC')
end if

! TCV-D :
if (TCVXist(4,iSym,jSym)) then
  TCVD = .true.
  Len_XAu = nBas(iSym)*nAsh(jSym)
  Ntu = nAsh(iSym)*nAsh(jSym)
  call mma_allocate(TCVX(4,iSym,jSym)%A,Ntu,NumV,Label='TCVD')
end if

! TCV-E :
if (TCVXist(5,iSym,jSym)) then
  TCVE = .true.
  Len_XAu = nBas(iSym)*nAsh(jSym)
  Nau = nSsh(iSym)*nAsh(jSym)
  call mma_allocate(TCVX(5,iSym,jSym)%A,Nau,NumV,Label='TCVE')
end if

! TCV-F :
if (TCVXist(6,iSym,jSym)) then
  TCVF = .true.
  Len_XAb = nBas(iSym)*nSsh(jSym)
  Nab = nSsh(iSym)*nssh(jSym)
  call mma_allocate(TCVX(6,iSym,jSym)%A,Nab,NumV,Label='TCVF')
end if

iStrt = 1
do i=1,iSym-1
  iStrt = iStrt+nBas(i)*nBas(i)
end do

jStrt = 1
do j=1,jSym-1
  jStrt = jStrt+nBas(j)*nBas(j)
end do

! START LOOP iiVec
do iiVec=1,NumV,nFVec
  NumFV = max(nFVec,NumV-iiVec+1)
  iFBatch = (iiVec+nFVec-1)/nFVec

  ! Allocate memory & Load Full Cholesky Vectors - CHFV

  iStrtVec_FAB = iStrtVec_AB+nFVec*(iFBatch-1)

  call mma_allocate(FAB,NFAB,NumFV,Label='FAB')
  call RdChoVec(FAB,NFAB,NumFV,iStrtVec_FAB,lUCHFV)

  ! Start Loop jVec
  do jVec=iiVec,iiVec+NumFV-1   ! Loop  jVec
    iVec = jVec-iiVec+1

    ! 1st Half-Transformation  iBeta(AO) -> q(MO) only occupied
    jStrt0MO = jStrt+nFro(jSym)*nBas(jSym)

    ! From CHFV A(Alpha,Beta) to XAj(Alpha,jMO)
    if (TCVA .or. TCVB .or. TCVC) then
      call mma_allocate(XAj,Len_XAj,Label='XAj')
      call ProdsS_1(FAB(:,iVec),nBas(iSym),CMO(jStrt0MO),nIsh(jSym),XAj)
    end if
    jStrt0MO = jStrt0MO+nIsh(jSym)*nBas(jSym)

    ! From CHFV A(Alpha,Beta) to XAu(Alpha,uMO)
    if (TCVD .or. TCVE) then
      call mma_allocate(XAu,Len_XAu,Label='XAu')
      call ProdsS_1(FAB(:,iVec),nBas(iSym),CMO(jStrt0MO),nAsh(jSym),XAu)
    end if
    jStrt0MO = jStrt0MO+nAsh(jSym)*nBas(jSym)

    ! From CHFV A(Alpha,Beta) to XAb(Alpha,bMO)
    if (TCVF) then
      call mma_allocate(XAb,Len_XAb,Label='XAb')
      call ProdsS_1(FAB(:,iVec),nBas(iSym),CMO(jStrt0MO),nSsh(jSym),XAb)
    end if

    ! 2nd Half-Transformation  iAlpha(AO) -> p(MO)
    iStrt0MO = iStrt+nFro(iSym)*nBas(iSym)

    ! From XAj(Alpha,jMO) to ij(i,j)
    if (TCVA) then
      call ProdsA_1(XAj,nBas(iSym),nIsh(jSym),CMO(iStrt0MO),nIsh(iSym),TCVX(1,iSym,jSym)%A(:,jVec))
    end if
    iStrt0MO = iStrt0MO+nIsh(iSym)*nBas(iSym)

    ! From XAj(Alpha,jMO) to tj(t,j) & jt(j,t)
    if (TCVB) then
      call ProdsA_1(XAj,nBas(iSym),nIsh(jSym),CMO(iStrt0MO),nAsh(iSym),TCVX(2,iSym,jSym)%A(:,jVec))
      call Trnsps(nAsh(iSym),nIsh(jSym),TCVX(2,iSym,jSym)%A(:,jVec),TCVX(7,jSym,iSym)%A(:,jVec))
    end if

    ! From XAu(Alpha,uMO) to tu(t,u)
    if (TCVD) then
      call ProdsA_1(XAu,nBas(iSym),nAsh(jSym),CMO(iStrt0MO),nAsh(iSym),TCVX(4,iSym,JSym)%A(:,jVec))
    end if
    iStrt0MO = iStrt0MO+nAsh(iSym)*nBas(iSym)

    ! From XAj(Alpha,jMO) to aj(a,j)
    if (TCVC) then
      call ProdsA_1(XAj,nBas(iSym),nIsh(jSym),CMO(iStrt0MO),nSsh(iSym),TCVX(3,iSym,JSym)%A(:,jVec))
    end if

    ! From XAu(Alpha,uMO) to au(a,u)
    if (TCVE) then
      call ProdsA_1(XAu,nBas(iSym),nAsh(jSym),CMO(iStrt0MO),nSsh(iSym),TCVX(5,iSym,jSym)%A(:,jVec))
    end if

    ! From XAb(Alpha,bMO) to ab(a,b)
    if (TCVF) then
      call ProdsA_1(XAb,nBas(iSym),nSsh(jSym),CMO(iStrt0MO),nSsh(iSym),TCVX(6,iSym,jSym)%A(:,jVec))
    end if

    ! End of Transformations

    if (allocated(XAj)) call mma_deallocate(XAj)
    if (allocated(XAu)) call mma_deallocate(XAu)
    if (allocated(XAb)) call mma_deallocate(XAb)

  end do
  ! End Loop jVec

  call mma_deallocate(FAB)
end do
! END LOOP iiVec

return

end subroutine Cho_TraS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_HEAD(STRING,LINE,LENMAX,LUNIT)
C
C     Purpose: print a header.
C
      IMPLICIT NONE
      CHARACTER*(*) STRING
      CHARACTER*1   LINE
      INTEGER       LENMAX, LUNIT

      INTEGER LENSTR, LENTOT, I

      LENSTR = LEN(STRING)
      LENTOT = MIN(LENSTR,LENMAX-2)
      IF (LENTOT .GT. 0) THEN
         WRITE(LUNIT,'(//,2X,A)') STRING(1:LENTOT)
         WRITE(LUNIT,'(2X,80A)') (LINE,I=1,LENTOT)
      ELSE
         WRITE(LUNIT,'(//,2X,A,/)') STRING(1:LENSTR)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine JoinLvec(wrk,wrksize,PosV1,PosV2,NaGrpR,LunAux)
! This routine does:
! Join L0-L2 files (Global, dimensioned as nc)
! from local L0-L2 files (dimensioned as ncLoc)
! N.B. This file have sense only for parallel run
!
! Structure of Cholesky vector files
!
! L0(m,IJ)    L0vctr  I>=J
!
! L1(m,I ,A') L1vcxx xx - Group of A'
!@@        kokot som, ze som to takto urobil, prerobit na L(m,a,i) to treba
!
! L2(m,A'B')  L2xxyy xx - Group of A', A'>=B'
!                    yy - Group of B'
!
! Memory requirements:
!  real:
! V1 - max {ov'm; v'v'm;  oom}
! V2 - max {v'v'm, ov'm; oom}
!  actual:
! reord routine requirements are used (DistMemReord)

#ifdef _MOLCAS_MPP_
use Index_Functions, only: nTri_Elem
use chcc_global, only: DimGrpaR, L0Name, L1Name, L2Name, nc, NChLoc, no
use Para_Info, only: MyRank
use Constants, only: Zero
#endif
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, PosV1, PosV2, NaGrpR, LunAux
real(kind=wp), intent(inout) :: wrk(wrksize)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: aGrp, bGrp, dim_1, dima, dimab, dimb, ncLoc, ncOff
character(len=6) :: LunName

!7.0 calculate ncOffset for given node
ncLoc = NChLoc(myRank)
ncOff = sum(NChLoc(0:myRank-1))

!7.1 Make global L0
LunName = L0Name

!7.1.1 Read Local L0 = V2(ml,ij) on proper place in V2
dim_1 = ncLoc*nTri_Elem(no)
call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

!7.1.2 Vanish V1(m,ij)
dim_1 = nc*nTri_Elem(no)
wrk(PosV1:PosV1+dim_1-1) = Zero

!7.1.3 Insert V2(ml,ij) -> V1(m,ij)
dim_1 = nTri_Elem(no)
call InsL(wrk(PosV2),wrk(PosV1),ncLoc,nc,ncOff,dim_1)

!## Synchronizacny bod
!7.1.4 Allreduce V1
dim_1 = nc*nTri_Elem(no)
call gadgop(wrk(PosV1),dim_1,'+')

!7.1.5 Save L0 (Global)
dim_1 = nc*nTri_Elem(no)
call SaveX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

!7.2 make global L1 files

do aGrp=1,NaGrpR
  dima = DimGrpaR(aGrp)
  LunName = L1Name(aGrp)

  !7.2.1 read L1 = V2(ml,i,a') back into file
  dim_1 = no*dima*ncLoc
  call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

  !7.2.2 Vanish V1(m,i,a')
  dim_1 = nc*no*dima
  wrk(PosV1:PosV1+dim_1-1) = Zero

  !7.2.3 Insert V2(ml,i,a') -> V1(m,i,a')
  dim_1 = no*dima
  call InsL(wrk(PosV2),wrk(PosV1),ncLoc,nc,ncOff,dim_1)

  !## Synchronizacny bod
  !7.2.4 Allreduce V1
  dim_1 = nc*no*dima
  call gadgop(wrk(PosV1),dim_1,'+')

  !7.2.5 Save V1(m,i,a') (Global)
  dim_1 = nc*no*dima
  call SaveX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

end do

!2.3 Make glogal L2(m,a'b') files

do aGrp=1,NaGrpR
  dima = DimGrpaR(aGrp)
  do bGrp=1,aGrp
    dimb = DimGrpaR(bGrp)
    if (aGrp == bGrp) then
      dimab = nTri_Elem(dima)
    else
      dimab = dima*dimb
    end if
    LunName = L2Name(aGrp,bGrp)

    !7.3.1 read L2 = V2(ml,a'b') back into file
    dim_1 = dimab*ncLoc
    call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

    !7.3.2 Vanish V1(m,a'b')
    dim_1 = nc*dimab
    wrk(PosV1:PosV1+dim_1-1) = Zero

    !7.3.3 Insert V2(ml,a',b') -> V1(m,a',b')
    dim_1 = dimab
    call InsL(wrk(PosV2),wrk(PosV1),ncLoc,nc,ncOff,dim_1)

    !## Synchronizacny bod
    !7.3.4 Allreduce V1
    dim_1 = nc*dimab
    call gadgop(wrk(PosV1),dim_1,'+')

    !7.3.5 Save V1(ml,a',b') (Global)
    dim_1 = nc*dimab
    call SaveX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

  end do
end do

#else
#include "macros.fh"
unused_var(wrk)
unused_var(PosV1)
unused_var(PosV2)
unused_var(NaGrpR)
unused_var(LunAux)
#endif

return

end subroutine JoinLvec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!               1993, Per Boussard                                     *
!***********************************************************************

subroutine PrjHss( &
#                 define _CALLING_
#                 include "hss_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of ECP integrals.         *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
!             Physics, University of Stockholm, Sweden, October 1993.  *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Symmetry_Info, only: iOper
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
#include "hss_interface.fh"
integer(kind=iwp) :: iAng, iDCRT(0:7), ip, ipFA1, ipFA2, ipFB1, ipFB2, ipFin, iShll, iuvwx(4), JndGrd(3,4,0:7), &
                     jndhss(4,3,4,3,0:7), kCnt, kCnttp, kdc, kOp(4), lDCRT, LmbdT, mOp(4), nBasisi, nDCRT, nExpi, nt
real(kind=wp) :: C(3), Coor(3,4), Dum(1), Fact, g2(78), TC(3)
logical(kind=iwp) :: ifg(4), JfGrd(3,4), jfhss(4,3,4,3), tr(4)
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(P)
unused_var(rFinal)
unused_var(nHer)
unused_var(Ccoor)
unused_var(lOper)

iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
mop(1:2) = nOp
kOp(1) = iOper(nOp(1))
kOp(2) = iOper(nOp(2))

Coor(:,1) = A
Coor(:,2) = RB

kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (.not. dbsc(kCnttp)%ECP) cycle
  do kCnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    iuvwx(3) = dc(kdc+kCnt)%nStab
    iuvwx(4) = dc(kdc+kCnt)%nStab

    do lDCRT=0,nDCRT-1
      kOp(3) = iDCRT(lDCRT)
      kOp(4) = kOp(3)
      mop(3) = nropr(kop(3))
      mop(4) = mop(3)
      call OA(iDCRT(lDCRT),C,TC)
      Coor(:,3) = TC

      if (EQ(A,RB) .and. EQ(A,TC)) cycle
      call NucInd(coor,kdc+kCnt,ifgrd,ifhss,indgrd,indhss,jfgrd,jfhss,jndgrd,jndhss,tr,ifg)
      do iAng=0,dbsc(kCnttp)%nPrj-1
        iShll = dbsc(kCnttp)%iPrj+iAng
        nExpi = Shells(iShll)%nExp
        nBasisi = Shells(iShll)%nBasis
        if ((nExpi == 0) .or. (nBasisi == 0)) cycle

        ip = 1

        ipFin = ip
        ip = ip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*21

        ipFA1 = ip
        ip = ip+nAlpha*nExpi*nTri_Elem1(la)*nTri_Elem1(iAng)*4

        ipFA2 = ip
        ip = ip+nAlpha*nExpi*nTri_Elem1(la)*nTri_Elem1(iAng)*6

        ipFB1 = ip
        ip = ip+nExpi*nBeta*nTri_Elem1(iAng)*nTri_Elem1(lb)*4

        ipFB2 = ip
        ip = ip+nExpi*nBeta*nTri_Elem1(iAng)*nTri_Elem1(lb)*6

        Array(:) = Zero
        ! <a|c>,<a'|c>,<a"|c>
        call Acore(iang,la,ishll,nordop,TC,A,Array(ip),narr-ip+1,Alpha,nalpha,Array(ipFA1),array(ipfa2),jfgrd(1,1),jfhss,2,.false.)
        ! Transform to core orbital
        call LToCore(Array(ipFA1),nalpha,ishll,la,iAng,4)
        call LToCore(Array(ipFA2),nalpha,ishll,la,iAng,6)
        ! <c|b>,<c|b'>,<c|b">
        call coreB(iang,lb,ishll,nordop,TC,RB,Array(ip),narr-ip+1,Beta,nbeta,Array(ipFB1),array(ipfb2),jfgrd(1,2),jfhss,2,.false.)
        ! Transform to core orbital
        call RToCore(Array(ipFB1),nbeta,ishll,lb,iAng,4)
        call RToCore(Array(ipFB2),nbeta,ishll,lb,iAng,6)
        ! Construct complete derivative (contract core)
        call CmbnACB2(Array(ipFa1),Array(ipFa2),Array(ipFb1),Array(ipFb2),Array(ipFin),Fact,nalpha,nbeta,Dum,nBasisi,la,lb,iang, &
                      jfhss,dum,.false.)

        ! contract density
        nt = nZeta*nTri_Elem1(la)*nTri_Elem1(lb)
        g2(:) = Zero
        call dGeMV_('T',nT,21,One,Array(ipFin),nT,DAO,1,Zero,g2,1)

        ! distribute in hessian
        call Distg2(g2,Hess,nHess,JndGrd,JfHss,JndHss,iuvwx,kOp,mop,Tr,IfG)

      end do !iang
    end do !DCR
  end do !cnt
end do !cnttp

return

end subroutine PrjHss

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992, Roland Lindh                                *
!               1990, IBM                                              *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine k2Loop_mck(Coor,iAnga,iCmpa,iDCRR,nDCRR,rData,ijCmp,Alpha,nAlpha,Beta,nBeta,Coeff1,iBasn,Coeff2,jBasn,nMemab,Wk002, &
                      m002,Wk003,m003,iStb,jStb)
!***********************************************************************
!                                                                      *
! Object: to compute zeta, kappa, and P.                               *
!         This is done for all unique pairs of centers                 *
!         generated from the symmetry unique centers A and B.          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             June '91, modified to compute zeta, P, kappa and inte-   *
!             grals for Schwartz inequality in a k2 loop.              *
!             January '92 modified to gradient calculations.           *
!             April '92, modified to use the Cauchy-Schwarz inequality *
!              to estimate the integral derivatives.                   *
!                                                                      *
!             May   '95  modified (simplified) for hessian calculation *
!             By Anders Bernhardsson                                   *
!***********************************************************************

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
#include "ndarray.fh"
integer(kind=iwp), intent(in) :: iAnga(4), iCmpa(4), iDCRR(0:7), nDCRR, ijCmp, nAlpha, nBeta, iBasn, jBasn, nMemab, m002, m003, &
                                 iStb, jStb
real(kind=wp), intent(in) :: Coor(3,2), Alpha(nAlpha), Beta(nBeta), Coeff1(nAlpha,iBasn), Coeff2(nBeta,jBasn)
real(kind=wp), intent(out) :: rData(nAlpha*nBeta*nDArray+nDScalar,nDCRR), Wk002(m002)
real(kind=wp), intent(inout) :: Wk003(m003)
integer(kind=iwp) :: mStb(2), nZeta
real(kind=wp) :: abMax, CoorM(3,4), tmp, Tst, ZtMax
integer(kind=iwp), external :: ip_ab, ip_abMax, ip_Alpha, ip_Beta, ip_EstI, ip_IndZ, ip_Kappa, ip_PCoor, ip_Z, ip_ZetaM, ip_ZInv, &
                               ip_ZtMax
real(kind=wp), external :: EstI

call k2Loop_mck_internal(rData)

! This is to allow type punning without an explicit interface
contains

subroutine k2Loop_mck_internal(rData)

  real(kind=wp), target :: rData(nAlpha*nBeta*nDArray+nDScalar,nDCRR)
  integer(kind=iwp), pointer :: iData(:)
  integer(kind=iwp) :: iZeta, lDCRR

  nZeta = nAlpha*nBeta
  mStb(1) = iStb
  mStb(2) = jStb

  CoorM(1,1) = Coor(1,1)
  CoorM(2,1) = Coor(2,1)
  CoorM(3,1) = Coor(3,1)

  do lDCRR=0,nDCRR-1

    call OA(iDCRR(lDCRR),Coor(1:3,2),CoorM(1:3,2))
    CoorM(:,3:4) = CoorM(:,1:2)

    ! Compute Zeta, P and kappa.

    call c_f_pointer(c_loc(rData(ip_IndZ(1,nZeta),lDCRR+1)),iData,[nAlpha*nBeta+1])
    call DoZeta(Alpha,nAlpha,Beta,nBeta,CoorM(1,1),CoorM(1,2),rData(ip_PCoor(1,nZeta),lDCRR+1),rData(ip_Z(1,nZeta),lDCRR+1), &
                rData(ip_Kappa(1,nZeta),lDCRR+1),rData(ip_ZInv(1,nZeta),lDCRR+1),rData(ip_Alpha(1,nZeta,1),lDCRR+1), &
                rData(ip_Beta(1,nZeta,2),lDCRR+1),iData)
    nullify(iData)

    call SchInt_mck(CoorM,iAnga,nAlpha,nBeta,nMemab,rData(ip_Z(1,nZeta),lDCRR+1),rData(ip_ZInv(1,nZeta),lDCRR+1), &
                    rData(ip_Kappa(1,nZeta),lDCRR+1),rData(ip_PCoor(1,nZeta),lDCRR+1),nZeta,Wk002,m002,Wk003,m003)

    call PckInt_mck(Wk002,nZeta,ijCmp,rData(ip_ab(1,nZeta),lDCRR+1))
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Estimate the largest contracted integral.

    call c_f_pointer(c_loc(rData(ip_IndZ(1,nZeta),lDCRR+1)),iData,[nAlpha*nBeta+1])
    rData(ip_EstI(nZeta),lDCRR+1) = EstI(rData(ip_Z(1,nZeta),lDCRR+1),rData(ip_Kappa(1,nZeta),lDCRR+1),nAlpha,nBeta,Coeff1,iBasn, &
                                         Coeff2,jBasn,rData(ip_ab(1,nZeta),lDCRR+1),iCmpa(1)*iCmpa(2),Wk002,m002,iData)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Find the largest integral estimate (AO Basis).

    Tst = -One
    do iZeta=0,nZeta-1
      Tst = max(rData(ip_Z(iZeta+1,nZeta),lDCRR+1),Tst)
    end do
    rData(ip_ZetaM(nZeta),lDCRR+1) = tst

    Tst = -One
    ZtMax = Zero
    abMax = Zero
    do iZeta=1,nZeta
      tmp = rData(ip_ab(iZeta,nZeta),lDCRR+1)
      if (Tst < tmp) then
        Tst = tmp
        ZtMax = rData(ip_Z(iZeta,nZeta),lDCRR+1)
        abMax = rData(ip_ab(iZeta,nZeta),lDCRR+1)
      end if
    end do
    rData(ip_ZtMax(nZeta),lDCRR+1) = ZtMax
    rData(ip_abMax(nZeta),lDCRR+1) = abMax
  end do

  return

end subroutine k2Loop_mck_internal

end subroutine k2Loop_mck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_X_VecRd
!
!> @brief
!>   Read as many Cholesky vectors as possible in the range \p jVec1, \p jVec1+1, \p jVec1+2, ..., \p jVec2.
!> @author Thomas Bondo Pedersen
!>
!> @details
!> The vectors are returned in their native storage (reduced set).
!> Starting with vector \p jVec1, this routine will read as many
!> vectors as possible, although at most (\p jVec2-\p jVec1+1) vectors
!> are read.
!>
!> On entry as well as exit, \p iRedC identifies the
!> reduced set stored at location ``3`` (``-1`` if none or unknown).
!> On exit, \p jNum is the number
!> of vectors actually read and \p mUsed is the memory
!> (in ``real`` words) actually used.
!>
!> @note
!> The Cholesky module must be initialized.
!>
!> @param[out]    Scr   contains the vectors on exit
!> @param[in]     lScr  dimension of \p Scr
!> @param[in]     jVec1 first vector to read
!> @param[in]     jVec2 last vector allowed to read
!> @param[in]     iSym  vector symmetry
!> @param[out]    jNum  number of vectors actually read
!> @param[in,out] iRedC reduced set stored at location ``3`` on entry as well as exit
!> @param[out]    mUsed amount of memory actually used (in ``real`` words)
!***********************************************************************

subroutine Cho_X_VecRd(Scr,lScr,jVec1,jVec2,iSym,jNum,iRedC,mUsed)

use Cholesky, only: NumCho
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lScr, jVec1, jVec2, iSym
real(kind=wp), intent(out) :: Scr(lScr)
integer(kind=iwp), intent(out) :: jNum, mUsed
integer(kind=iwp), intent(inout) :: iRedC
integer(kind=iwp) :: l_jVec2

if ((iSym < 1) .or. (iSym > 8)) then
  jNum = 0
  mUsed = 0
else
  l_jVec2 = min(NumCho(iSym),jVec2)
  call Cho_VecRd(Scr,lScr,jVec1,l_jVec2,iSym,jNum,iRedC,mUsed)
end if

end subroutine Cho_X_VecRd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExH_X2(Gvv,H,dima,dimbe,nv,adda,addbe)
! this routine does:
! H(a',be') <- Gvv(be,a)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimbe, nv, adda, addbe
real(kind=wp), intent(in) :: Gvv(nv,nv)
real(kind=wp), intent(out) :: H(dima,dimbe)
integer(kind=iwp) :: be

do be=1,dimbe
  H(:,be) = Gvv(addbe+be,adda+1:adda+dima)
end do

return

end subroutine ExH_X2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997,1998, Jeppe Olsen                                 *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MINMAX_FOR_SYM_DIST(NIGRP,IGRP,MNVAL,MXVAL,NDIST)
! A combination of NIGRP groups are given (IGRP)
! Find MIN and MAX for symmetry in each group
!
! Jeppe Olsen, September 1997
!              April 1998     From  MINMAX_SM_GP

use lucia_data, only: MINMAX_SM_GP
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NIGRP, IGRP(NIGRP)
integer(kind=iwp), intent(out) :: MNVAL(NIGRP), MXVAL(NIGRP), NDIST
integer(kind=iwp) :: JGRP

#ifdef _DEBUGPRINT_
write(u6,*) ' >> Entering MINMAX_... <<'
#endif

do JGRP=1,NIGRP
  MNVAL(JGRP) = MINMAX_SM_GP(1,IGRP(JGRP))
  MXVAL(JGRP) = MINMAX_SM_GP(2,IGRP(JGRP))
end do

! Number of strings per sym and group
!do JGRP=1,NIGRP
!  LSMGP(1:NIRREP,JGRP) = NSTSGP(1)%I((IGRP(JGRP)-1)*NIRREP+1:IGRP(JGRP)*NIRREP)
!end do
!#ifdef _DEBUGPRINT_
!write(u6,*) ' LSMGP'
!call IWRTMA(LSMGP,NIRREP,NIGRP,MXPOBS,NIGRP)
!#endif
! Max and min sym in each group
!do JGRP=1,NIGRP
!
!  IMAX = 1
!  do ISM=1,NIRREP
!    if (LSMGP(ISM,JGRP) > 0) IMAX = ISM
!  end do
!  MXVAL(JGRP) = IMAX
!
!  IMIN = NIRREP
!  do ISM=NIRREP,1,-1
!    if (LSMGP(ISM,JGRP) > 0) IMIN = ISM
!  end do
!  MNVAL(JGRP) = IMIN
!end do
! Total number of symmetry distributions
NDIST = 1
do JGRP=1,NIGRP
  NDIST = NDIST*(MXVAL(JGRP)-MNVAL(JGRP)+1)
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Group combination :'
write(u6,'(5X,10I3)') (IGRP(JGRP),JGRP=1,NIGRP)
write(u6,*)
write(u6,*) ' Group Minsym Maxsym'
write(u6,*) ' ==================='
do JGRP=1,NIGRP
  write(u6,'(3I6)') IGRP(JGRP),MNVAL(JGRP),MXVAL(JGRP)
end do
write(u6,*)
write(u6,*) ' Total number of distributions',NDIST

write(u6,*) ' >> Leaving MINMAX_... <<'
#endif

end subroutine MINMAX_FOR_SYM_DIST

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Giovanni Ghigo                                   *
!***********************************************************************

subroutine MkLij(iSymI,iSymJ,iI,iJ,numV,Lij)
!***********************************************************************
! Author :  Giovanni Ghigo                                             *
!           Torino University, Italy                                   *
!           July 2005                                                  *
!----------------------------------------------------------------------*
! Purpuse:  Generation of the Cholesky vector for occupied iI(iSymI),  *
!           iJ(iSymJ) for numV vectors.                                *
!***********************************************************************

use Cho_Tra, only: IfTest, nAsh, nIsh, TCVX
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iSymI, iSymJ, iI, iJ, numV
real(kind=wp), intent(out) :: Lij(NumV)
integer(kind=iwp) :: iAddTCVX, iIx, iJy, LijType, nIx, nJy

if (iI <= nIsh(iSymI)) then
  iIx = iI
  nIx = nIsh(iSymI)
  if (iJ <= nIsh(iSymJ)) then
    LijType = 1
    iJy = iJ
    nJy = nIsh(iSymJ)
  else
    LijType = 7
    iJy = iJ-nIsh(iSymJ)
    nJy = nAsh(iSymJ)
  end if
else
  iIx = iI-nIsh(iSymI)
  nIx = nAsh(iSymI)
  if (iJ <= nIsh(iSymJ)) then
    LijType = 2
    iJy = iJ
    nJy = nIsh(iSymJ)
  else
    LijType = 4
    iJy = iJ-nIsh(iSymJ)
    nJy = nAsh(iSymJ)
  end if
end if

!-----------------------------------------------------------------------
if (IfTest) then
  write(u6,*) '     Cho_MkLij: TCVx(',LijType,': ',iSymI,',',iSymJ,')'
  call XFlush(u6)
end if
!-----------------------------------------------------------------------
iAddTCVX = iIx+nIx*(iJy-1)
call dCopy_(numV,TCVX(LijType,iSymI,iSymJ)%A(iAddTCVX,1),nIx*nJy,Lij,1)

return

end subroutine MkLij

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CIO_Final()
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Shut down LDF coefficient I/O.
C
      Implicit None
#include "ldf_cio.fh"

      ! Deallocate buffer
      If (l_LDFC_Buffer.gt.0) Then
         Call GetMem('CBuffer','Free','Real',
     &               ip_LDFC_Buffer,l_LDFC_Buffer)
         ip_LDFC_Buffer=0
         l_LDFC_Buffer=0
      End If
      If (l_LDFC_Blocks.gt.0) Then
         Call GetMem('LDFC_Blk','Free','Inte',
     &               ip_LDFC_Blocks,l_LDFC_Blocks)
         ip_LDFC_Blocks=0
         l_LDFC_Blocks=0
      End If

      ! No atom pairs in buffer
      LastAtomPair=0

      ! Close coefficient file
      If (Lu_LDFC.gt.0) Then
         Call DAClos(Lu_LDFC)
         Lu_LDFC=0
      End If

#if defined (_DEBUGPRINT_)
      Write(6,'(/,A)')
     & 'LDF_CIO_Final: coefficient I/O has been shut down!'
      Call xFlush(6)
#endif

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine construc2_cvb(tconstr)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension tconstr(nvb,nvb)
      dimension dum(1)

      iconstruc_kp=iconstruc
      iconstruc=1
      irepm = mstackr_cvb(nvb)

      call span0_cvb(nvb,nvb)
      do 100 ivb=1,nvb
      call fzero(w(irepm),nvb)
      w(ivb+irepm-1)=-1d0
      call symtrizcvb_cvb(w(irepm))
      w(ivb+irepm-1)=w(ivb+irepm-1)+1d0
      call span1_cvb(w(irepm),1,dum,nvb,0)
100   continue
      call span2_cvb(tconstr,nconstr,dum,nvb,0)

      call mfreer_cvb(irepm)
      iconstruc=iconstruc_kp
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine add43(a,b,q,dimp,dimqr,dimr,fact)
! this routine does:
! B(p,qr) <-- fact * A(p,r) for given q

use ccsd_global, only: nshf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: q, dimp, dimqr, dimr
real(kind=wp), intent(in) :: a(dimp,dimr), fact
real(kind=wp), intent(inout) :: b(dimp,dimqr)
integer(kind=iwp) :: qr, r, rq

if (q /= 1) then

  qr = nshf(q)
  b(:,qr+1:qr+q-1) = b(:,qr+1:qr+q-1)+fact*a(:,1:q-1)

end if

if (q /= dimr) then

  do r=q+1,dimr
    rq = nshf(r)+q
    b(:,rq) = b(:,rq)-fact*a(:,r)
  end do

end if

return

end subroutine add43

!**********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,2020, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine Seward_Init()
!***********************************************************************
!                                                                      *
!     Object: to set data which is stored in common blocks             *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose      *
!             January 1990                                             *
!***********************************************************************

use EFP_Module, only: lEFP, nEFP_fragments
use k2_arrays, only: XMem
use k2_structure, only: k2_processed
use Basis_Info, only: Seward_Activated
use RICD_Info, only: Do_RI, iRI_Type
use rmat, only: bParm, dipol, Dipol1, Epsabs, Epsq, Epsrel, keyr, lgamma, nagint, qCoul, Quadpack, RMat_On, RmatR, testint
use DCR_mod, only: DCR_Init
use NAC, only: isCSF, isNAC
use NDDO, only: twoel_NDDO
use PrintLevel, only: nPrint, Show
use Constants, only: Zero, Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iPL
character(len=180) :: Env
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: Reduce_Prt

!                                                                      *
!***********************************************************************
!                                                                      *
! Info

Seward_Activated = .false.

! LInfo

call GetEnvF('MOLCAS_NEW_DEFAULTS',Env)
call UpCase(Env)
if (Env == 'YES') then
  Do_RI = .true.
  iRI_Type = 4
end if

iPL = iPrintLevel(-1)
if (iPL == 2) then
  iPL = 5
else if (iPL == 3) then
  iPL = 6
else if (iPL == 4) then
  iPL = 7
else if (iPL == 5) then
  iPL = 49  ! 99 would be just too much
end if
nPrint(:) = iPL
if ((Reduce_Prt() .and. (iPL < 6)) .or. (iPL == 0)) then
  Show = .false.
else
  Show = .true.
end if

twoel_NDDO = .false.

Seward_Activated = .true.
XMem = .false.
k2_processed = .false.

call Set_Binom()
call Set_CanInd()

! Set some default value for RMAT type integration

! rmat.fh

RmatR = Ten
Epsabs = 1.0e-9_wp
Epsrel = 1.0e-14_wp
qCoul = Zero
Epsq = 1.0e-8_wp
bParm = Zero
dipol(1) = Zero
dipol(2) = Zero
dipol(3) = Zero
Dipol1 = Zero
keyr = 6
Quadpack = .true.
nagint = .false.
testint = .false.
RMat_On = .false.
lgamma = 9

call DCR_Init()

call Set_Basis_Mode('Valence')

! nac.fh

isNAC = .false.
isCSF = .false.

! EFP stuff

lEFP = .false.
nEFP_fragments = 0

end subroutine Seward_Init

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Niclas Forsberg                                  *
!***********************************************************************

subroutine SetUpHmat2(energy1,C,W,det,r1,max_mOrd,max_nOrd,max_mInc,max_nInc,mMat,nMat,mInc,nInc,mDec,nDec,H,S,Hess,G0,Base, &
                      nDimTot,nOsc)
!  Purpose:
!
!  Input:
!
!  Output:
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use mula_global, only: mdim1, mdim2, ndim1, ndim2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: max_mOrd, max_nOrd, max_mInc, max_nInc, mMat(0:mdim1,mdim2), nMat(0:ndim1,ndim2), &
                                 mInc(0:mdim1,mdim2), nInc(0:ndim1,ndim2), mDec(0:mdim1,mdim2), nDec(0:ndim1,ndim2), nDimTot, nOsc
real(kind=wp), intent(in) :: energy1, C(nOsc,nOsc), W(nOsc,nOsc), det, r1(nOsc), Hess(nOsc,nOsc), G0(nOsc,nOsc), Base(nOsc,nOsc)
real(kind=wp), intent(out) :: H(nDimTot,nDimTot), S(nDimTot,nDimTot)
integer(kind=iwp) :: max_term
real(kind=wp) :: det0, FC00
real(kind=wp), allocatable :: alpha1(:,:), alpha2(:,:), beta(:,:), C0(:,:), D3(:,:,:), D4(:,:,:,:), Gdbleprime(:,:,:,:), &
                              Gprime(:,:,:), grad(:), Hij(:,:), L(:,:), r0(:), r_diff(:), Sij(:,:), U(:,:), W0(:,:)

! Initialize.
! arrays for setuphmat2
call mma_allocate(Hij,[0,max_mOrd],[0,max_nOrd],label='Hij')
call mma_allocate(Sij,[0,max_mOrd],[0,max_nOrd],label='Sij')
call mma_allocate(r0,nOsc,label='r0')
call mma_allocate(r_diff,nOsc,label='r_diff')
call mma_allocate(alpha1,nOsc,nOsc,label='alpha1')
call mma_allocate(alpha2,nOsc,nOsc,label='alpha2')
call mma_allocate(beta,nOsc,nOsc,label='beta')
call mma_allocate(L,[0,max_mOrd],[0,max_mOrd],label='L')
call mma_allocate(U,[0,max_nOrd],[0,max_nOrd],label='U')
call mma_allocate(C0,nOsc,nOsc,label='C0')
call mma_allocate(W0,nOsc,nOsc,label='W0')
call mma_allocate(grad,nOsc,label='grad')
call mma_allocate(Gprime,nOsc,nOsc,nOsc,label='Gprime')
call mma_allocate(D3,nOsc,nOsc,nOsc,label='D3')
call mma_allocate(Gdbleprime,nOsc,nOsc,nOsc,nOsc,label='Gdbleprime')
call mma_allocate(D4,nOsc,nOsc,nOsc,nOsc,label='D4')

! - Call Franck-Condon routine.
! - Calculate matrix elements.

max_term = 2
grad(:) = Zero
D3(:,:,:) = Zero
D4(:,:,:,:) = Zero
Gprime(:,:,:) = Zero
Gdbleprime(:,:,:,:) = Zero
!Base(:,:) = Zero
!do i=1,nOsc
!  Base(i,i) = One
!end do
call Calc_r00(C,C,C0,W0,alpha1,alpha2,r0,r1,r1,det0,det,det,FC00,nOsc)
call FCval(C,W,det0,r0,C,W,det0,r0,Sij,max_mOrd,max_nOrd,max_nOrd,max_mInc,max_nInc,max_nInc,mMat,nMat,mInc,nInc,mDec,nDec,C0,W0, &
           det0,L,U,FC00,alpha1,alpha2,beta,nOsc)
r_diff(:) = Zero
call MatrixElements(L,U,FC00,Hij,C0,W0,r_diff,nMat,nInc,nDec,max_nOrd,max_mOrd,nOsc,energy1,grad,Hess,D3,D4,G0,Gprime,Gdbleprime, &
                    alpha1,alpha2,beta,max_term,Base)

H(1:max_mOrd+1,1:max_nOrd+1) = Hij
S(1:max_mOrd+1,1:max_nOrd+1) = Sij

call mma_deallocate(Hij)
call mma_deallocate(Sij)
call mma_deallocate(r0)
call mma_deallocate(r_diff)
call mma_deallocate(alpha1)
call mma_deallocate(alpha2)
call mma_deallocate(beta)
call mma_deallocate(L)
call mma_deallocate(U)
call mma_deallocate(C0)
call mma_deallocate(W0)
call mma_deallocate(grad)
call mma_deallocate(D3)
call mma_deallocate(Gprime)
call mma_deallocate(D4)
call mma_deallocate(Gdbleprime)

end subroutine SetUpHmat2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Giovanni Li Manni                                *
************************************************************************
      module print_RDMs_NECI_format
      use index_symmetry, only : two_el_idx, one_el_idx
      implicit none
      private
      public:: printRDMs_NECI
      contains

      subroutine printRDMs_NECI(DMAT,NAC,PMAT,PA,NACPAR)
      integer, intent(in) :: NAC, NACPAR
      real*8, intent(in)  :: DMAT(NAC), PMAT(NACPAR), PA(NACPAR)
      real*8, parameter :: thrsh = 1.0d-12
      integer :: i, t_idx, u_idx, v_idx, x_idx

        Write(6,*) ' In printRDMs_NECI:'

        do i = 1, (NACPAR*(NACPAR+1)/2)
          call two_el_idx(i, t_idx, u_idx, v_idx, x_idx)
          if(v_idx /= x_idx) then
             if(abs(PMAT(i)+PA(i)) > thrsh) then
                 write(6,'(1X,4I5,F20.12)')
     &           t_idx, u_idx, v_idx, x_idx, (PMAT(i)+PA(i))
             end if
             if (abs(PMAT(i)-PA(i)) > thrsh) then
                 write(6,'(1X,4I5,F20.12)')
     &           t_idx, u_idx, x_idx, v_idx, (PMAT(i)-PA(i))
             end if
          else
             if (abs(PMAT(i)*2.0d0) > thrsh) then
                write(6,'(1X,4I5,F20.12)')
     &          t_idx, u_idx, v_idx, x_idx, PMAT(i)*2.0d0
             end if
          end if
        end do

        do i = 1, (NAC*(NAC+1)/2)
          call one_el_idx(i, t_idx, u_idx)
          if(abs(DMAT(i)) > thrsh) then
             write(6,'(1X,4I5,F20.12)')
     &          t_idx, u_idx, 0, 0, DMAT(i)
          end if
        end do


      end subroutine printRDMs_NECI

      end module print_RDMs_NECI_format

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine addintabc1(wrk,wrksize,a,vint,ndimv)
! this routine adds integrals <_a,_b|p,q> for given a
! for nonsymmetrical (C1) case
! from integrals vv _a(u,p,q)

use ccsort_global, only: lunab, nob, NORB, nvb, pos30
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, a, ndimv
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
real(kind=wp), intent(in) :: vint(ndimv,ndimv,ndimv)
integer(kind=iwp) :: b, bvint, length, p, pos, q

!T if there are no _a_b,pq integrals in this symab, skip summation over ab

if (nvb(1) == 0) return

! loop over b

do b=1,a
  bvint = b+nob(1)

  ! map <_a,b|p,q> to wrk in #3
  pos = pos30
  do q=1,norb(1)
    do p=1,norb(1)
      wrk(pos) = vint(bvint,p,q)
      pos = pos+1
    end do
  end do

  ! since there must be some integrals, write them to TEMPAB

  length = pos-pos30
  call dawri(lunab,length,wrk(pos30))

end do

return

end subroutine addintabc1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine MinimaxLaplace(Verbose,N,xmin,xmax,l_wt,w,t,irc)
!
! Thomas Bondo Pedersen, November 2012.
!
! Generate grid (weights w and points t) for the
! Laplace transform of 1/x.
!
! The minimax approximation for setting up the grid
! [Takatsuka, Ten-no, Hackbusch; JCP 129, 044112 (2008)]
! is used. The source code for the minimax approximation
! was provided by Ten-no on Nov. 28, 2012 (to TBP).
!
! Verbose   -- boolean to control printing
! N         -- number of grid points requested. If N=0 on input,
!              the number of points required to get an accuracy
!              of 1.0e-6 (in the Laplace transform) is used. In
!              this case, N is the required number of grid points
!              on return.
! xmin,xmax -- range of x values to be covered.
! l_wt      -- allocated dimension of the arrays w and t.
!              If N(input)=0 and l_wt<N(output), only l_wt grid
!              points are returned in w and t. N(output) is still
!              the full number of grid points [this situation is
!              also flagged by the return code irc, see below].
! w         -- grid weights are returned in array w.
! t         -- grid points are returned in array t.
! irc       -- return code:
!              <0: input error (parameter -irc is the culprit)
!               0: all OK
!               1: l_wt is too small to store full result and only
!                  l_wt grid weights/points are returned.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: Verbose
integer(kind=iwp), intent(out) :: N, irc
real(kind=wp), intent(in) :: xmin, xmax
integer(kind=iwp), intent(in) :: l_wt
real(kind=wp), intent(out) :: w(l_wt), t(l_wt)
integer(kind=iwp) :: K_Lap
logical(kind=iwp) :: Inf
character(len=8) :: Demand
real(kind=wp), allocatable :: Coeff(:,:)
integer(kind=iwp), parameter :: mGrid = 20 ! limited by Remez implementation
character(len=*), parameter :: DefaultGrid = 'MICRO   '

irc = 0
if ((N < 0) .or. (N > mGrid)) then
  irc = -1
  return
end if
if (xmin < Zero) then
  irc = -2
  return
end if
if ((xmax-xmin) < Zero) then
  irc = -3
  return
end if
if (l_wt < 1) then
  irc = -4
  return
end if

K_Lap = N
if (N == 0) then
  Demand = DefaultGrid
else
  Demand = '        '
end if
call mma_Allocate(Coeff,2,mGrid,Label='LapCoef')
Inf = .false.
call Remez(Verbose,K_Lap,xmin,xmax,Coeff,Demand,Inf)
if (K_Lap < 0) then
  call mma_Deallocate(Coeff)
  irc = -1
  write(u6,'(A,I10)') 'MinimaxLaplace: Remez returned K_Lap=',K_Lap
  return
end if
if (N == 0) N = K_Lap
if (l_wt < K_Lap) then
  w(1:l_wt) = Coeff(1,1:l_wt)
  t(1:l_wt) = Coeff(2,1:l_wt)
  irc = 2
else
  w(1:l_wt) = Coeff(1,1:l_wt)
  t(1:l_wt) = Coeff(2,1:l_wt)
end if
call mma_Deallocate(Coeff)

end subroutine MinimaxLaplace

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine scalstruc2_cvb(orbs,cvb,iconfs,ifnss)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
      dimension orbs(norb,norb),cvb(nvb)
      dimension iconfs(noe,nconf),ifnss(0:nel,0:nel)

      if(sc)then
        fac=one
        do 100 iorb=1,norb
        fac2=ddot_(norb,orbs(1,iorb),1,orbs(1,iorb),1)
        fac=fac*sqrt(fac2)
100     continue
        call dscal_(nvb,fac,cvb,1)
      else
        do 200 iorb=1,norb
        fac2=ddot_(norb,orbs(1,iorb),1,orbs(1,iorb),1)
        fac1=sqrt(fac2)
        istr=0
        iconf_off=0
        do 300 ifrag=1,nfrag
        do 301 iS=1,nS_fr(ifrag)
        do 302 ion=0,nel/2
        nelsing=nel-2*ion
        do 400 i=iconf_off+1,iconf_off+nconfion_fr(ion,ifrag)
        if(iconfs(iorb,i).eq.1)then
          call dscal_(ifnss(nelsing,i2s_fr(iS,ifrag)),
     >      fac1,cvb(istr+1),1)
        elseif(iconfs(iorb,i).eq.2)then
          call dscal_(ifnss(nelsing,i2s_fr(iS,ifrag)),
     >      fac2,cvb(istr+1),1)
        endif
        istr=istr+ifnss(nelsing,i2s_fr(iS,ifrag))
400     continue
        iconf_off=iconf_off+nconfion_fr(ion,ifrag)
302     continue
301     continue
300     continue
        if(istr.ne.nvb)then
          write(6,*)' ISTR not equal to NVB in SCALSTRUC! ',istr,nvb
          call abend_cvb()
        endif
200     continue
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Markus P. Fuelscher                              *
************************************************************************

*>  @brief
*>    Generate the Fock-Matrix for frozen and inactive orbitals in
*>      the basis of active orbitals.
*>
*>  @author
*>    Markus P. Fuelscher
*>
*>  @details
*>  Generate the Fock-matrix for the frozen and inactive orbitals.
*>  Compute also the core energy and write to global variable EMY.
*>  Finally, transform the generated Fock-matrix
*>  into the basis of the active orbitals.
*>  Look into chapters 10.8.3 and 10.8.4 of \cite purple_book.
*>  The one body density matrices are required for e.g. reaction field
*>  or DFT calculations. In this case they are used to create a modified
*>  Fock Matrix.
*>
*>  @param[in] CMO The MO-coefficients
*>  @param[out] F The inactive Fock matrix in the basis of the active MO
*>  @param[in,out] FI The inactive Fock matrix in AO-space
*>    \f[\sum_{\sigma\rho} D^I_{\sigma\rho}(g_{\mu\nu\sigma\rho} - \frac{1}{2} g_{\mu\sigma\rho\nu})\f]
*>    In output FI contains also the core energy added to
*>    the diagonal elements.
*>    \f[\sum_{\sigma\rho} D^I_{\sigma\rho}(g_{\mu\nu\sigma\rho} - \frac{1}{2} g_{\mu\sigma\rho\nu}) + \frac{E^{(0)}}{n_{el}} \delta_{\mu\nu} \f]
*>  @param[in] D1I The inactive one-body density matrix in AO-space
*>    \f[D^{\text{AO}, I} = 2 C (C^I)^\dagger \f]
*>    See ::get_D1I_rasscf.
*>  @param[in] D1A The active one-body density matrix in AO-space
*>    \f[ D^{\text{AO}, A} = C^A D^A (C^A)^\dagger \f]
*>    See ::get_D1A_rasscf.
*>  @param[in] D1S The active spin density matrix in AO-space
*>    \f[ D^{\text{AO}, A}_S = C^A (D^A_\alpha - D^A_\beta) (C^A)^\dagger \f]
      Subroutine SGFCIN(CMO, F, FI, D1I, D1A, D1S)
      use RunFile_procedures, only: Get_dExcdRa
#ifdef _DMRG_
      use qcmaquis_interface_cfg
#endif
      use fcidump, only: DumpOnly
      use fciqmc, only: DoNECI
      use CC_CI_mod, only: Do_CC_CI

      use timers, only: TimeDens
      use lucia_data, only: INT1, INT1O
      use rasscf_global, only : EMY, KSDFT, dftfock, exfac, nac, nacpar,
     &    noneq, potnuc, rfpert,
     &    tot_charge, tot_el_charge, tot_nuc_charge,
     &    doBlockDMRG, doDMRG
      use OneDat, only: sNoNuc, sNoOri
      use general_data, only : iSpin, nActEl, nSym, nTot1,
     &    nBas, nIsh, nAsh, nFro
      use OFEmbed, only: Do_OFemb, OFE_first, FMaux
      use OFEmbed, only: Rep_EN
      use rctfld_module, only:  lRF
      use stdalloc, only: mma_allocate, mma_deallocate
      use PrintLevel, only: DEBUG
      use output_ras, only: LF,IPRLOC

      implicit none
      Character(LEN=16), Parameter :: ROUTINE='SGFCIN  '
*
      real*8, intent(in) :: CMO(*), D1I(*), D1A(*)
      real*8, intent(inout) :: FI(*), D1S(*), F(*)
      Character(LEN=8) Label
      Logical First, Dff, Do_DFT, Found
      Logical Do_ESPF
*
      real*8, parameter ::  Zero=0.0d0, One=1.0d0
      real*8 :: CASDFT_Funct, dum1, dum2, dum3, dumm(1), Emyn, Eone,
     &  Erf1, Erf2, Erfx, Etwo,  potnuc_ref, Time(2)
      integer :: i, iadd, ibas, icharge, iComp,
     &  ioff, iopt, iprlev, ntmpfck,
     &  irc, iSyLbl, iSym, iTu, j,
     &  mxna, mxnb, nAt, nst, nt, ntu, nu, nvxc
      real*8, allocatable :: TmpFckI(:), Tmpx(:)
      real*8, allocatable:: Tmp0(:), Tmp1(:), Tmp2(:), Tmp3(:),
     &                      Tmp4(:), Tmp5(:), Tmp6(:), Tmp7(:),
     &                      Tmpz(:), X0(:), X1(:), X2(:),
     &                      X3(:)
      real*8, external :: dDot_

C Local print level (if any)
      IPRLEV=IPRLOC(3)
      IPRLEV=0000
      IF(IPRLEV.ge.DEBUG) THEN
         WRITE(LF,*)' Entering ',ROUTINE
      END IF

*
*     Generate molecular charges
      Call mma_allocate(Tmp0,nTot1+4,Label='Tmp0')
      iRc=-1
      iOpt=ibset(0,sNoOri)
      iComp=1
      iSyLbl=1
      Label='Mltpl  0'
      Call RdOne(iRc,iOpt,Label,iComp,Tmp0,iSyLbl)
      Tot_Nuc_Charge=Tmp0(nTot1+4)
      If ( iRc.ne.0 ) then
         Write(LF,*) 'SGFCIN: iRc from Call RdOne not 0'
         Write(LF,*) 'Label = ',Label
         Write(LF,*) 'iRc = ',iRc
         Call Abend
      Endif
      Call mma_deallocate(Tmp0)
      Tot_El_Charge=Zero
      Do iSym=1,nSym
         Tot_El_Charge=Tot_El_Charge
     &                -2.0D0*DBLE(nFro(iSym)+nIsh(iSym))
      End Do
      Tot_El_Charge=Tot_El_Charge-DBLE(nActEl)
      Tot_Charge=Tot_Nuc_Charge+Tot_El_Charge
*
*     Load bare nuclei Hamiltonian
      Call mma_allocate(Tmp1,nTot1,Label='Tmp1')
      iComp  =  1
      iSyLbl =  1
      iRc    = -1
      iOpt   =  ibset(ibset(0,sNoOri),sNoNuc)
      Label  = 'OneHam  '
      Call RdOne(iRc,iOpt,Label,iComp,Tmp1,iSyLbl)
      If ( iRc.ne.0 ) then
         Write(LF,*) 'SGFCIN: iRc from Call RdOne not 0'
         Write(LF,*) 'Label = ',Label
         Write(LF,*) 'iRc = ',iRc
         Call Abend
      Endif
      If ( IPRLEV.ge.DEBUG ) then
       Write(LF,*)
       Write(LF,*) ' CMO in SGFCIN'
       Write(LF,*) ' ---------------------'
       Write(LF,*)
       ioff=1
       Do iSym = 1,nSym
         iBas = nBas(iSym)
         if(iBas.ne.0) then
           write(6,*) 'Sym =', iSym
           do i= 1,iBas
             write(6,*) (CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
           end do
           iOff = iOff + (iBas*iBas)
         end if
       End Do

       Write(LF,*)
       Write(LF,*) ' D1I in AO basis in SGFCIN'
       Write(LF,*) ' ---------------------'
       Write(LF,*)
       iOff=1
       Do iSym = 1,nSym
         iBas = nBas(iSym)
         call wrtmat(D1I(ioff),iBas,iBas, iBas, iBas)
         iOff = iOff + iBas*iBas
       End Do

       Write(LF,*)
       Write(LF,*) ' D1A in AO basis in SGFCIN'
       Write(LF,*) ' ---------------------'
       Write(LF,*)
       iOff=1
       Do iSym = 1,nSym
         iBas = nBas(iSym)
         call wrtmat(D1A(ioff),iBas,iBas, iBas, iBas)
         iOff = iOff + iBas*iBas
       End Do
      End If
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' OneHam in AO basis in SGFCIN'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',Tmp1(iOff),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End If
*
*     Load the nuclear repulsion energy
*
*     Call Get_PotNuc(PotNuc)
      Call Get_dScalar('PotNuc',potNuc)
*
*     modify the one electron Hamiltonian for reaction
*     field calculations
      ERFX = Zero
      iCharge=Int(Tot_Charge)

      Call mma_allocate(Tmp3,nTot1,Label='Tmp3')
      Call mma_allocate(Tmp4,nTot1,Label='Tmp4')
      Call mma_allocate(Tmp7,nTot1,Label='Tmp7')

      Call DecideOnESPF(Do_ESPF)
*
*---- Generate total density
*
      Call Fold(nSym,nBas,D1I,Tmp3)
      Call Fold(nSym,nBas,D1A,Tmp4)
      Call Daxpy_(nTot1,1.0D0,Tmp4,1,Tmp3,1)
      Call Put_dArray('D1ao',Tmp3,nTot1)
*     Write(LF,*)
*     Write(LF,*) ' D1ao in AO basis in SGFCIN'
*     Write(LF,*) ' ---------------------'
*     Write(LF,*)
*     iOff=1
*     Do iSym = 1,nSym
*       iBas = nBas(iSym)
*       Call TriPrt(' ','(5G17.11)',Tmp3(iOff),iBas)
*       iOff = iOff + (iBas*iBas+iBas)/2
*     End Do
*
*---- Generate spin-density
*
      Call Fold(nSym,nBas,D1S,Tmp7)
      Call Put_dArray('D1sao',Tmp7,nTot1)

      If(KSDFT(1:3).ne.'SCF' .or. Do_OFemb) Then
        Call Put_iArray('nFro',nFro,nSym)
        Call Put_iArray('nAsh',nAsh,nSym)
        Call Put_iArray('nIsh',nIsh,nSym)
      End If

      If ( Do_ESPF .or. lRF .or. KSDFT.ne.'SCF'
     &                      .or. Do_OFemb ) Then
*
*------ Scratch for one- and two-electron type contributions
*
        Call mma_allocate(Tmp5,nTot1,Label='Tmp5')
        Tmp5(:)=0.0D0
        Call mma_allocate(Tmp6,nTot1,Label='Tmp6')
        Tmp6(:)=0.0D0
*
        First=.True.
        Dff=.False.
        Do_DFT=.True.

        Call Timing(Time(1),dum1,dum2,dum3)

        Call DrvXV(Tmp5,Tmp6,Tmp3,
     &             PotNuc,nTot1,First,Dff,NonEq,lRF,
     &             KSDFT,ExFac,iCharge,iSpin,
     &             DFTFOCK,Do_DFT)
        If ( IPRLEV.ge.DEBUG ) then
          Write(LF,*)
          Write(LF,*) ' Tmp5, h1 (DFT), in AO basis in SGFCIN'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            Call TriPrt(' ','(5G17.11)',Tmp5(iOff),iBas)
            iOff = iOff + (iBas*iBas+iBas)/2
          End Do
        End If
        Call Timing(Time(2),dum1,dum2,dum3)
        TimeDens = TimeDens + Time(2) - Time(1)


        ERF1=Zero
        ERF2=dDot_(nTot1,Tmp6,1,Tmp4,1)
        ERFX= ERF1-0.5d0*ERF2
        Call Daxpy_(nTot1,1.0d0,Tmp5,1,Tmp1,1)

        Call Daxpy_(nTot1,1.0d0,Tmp6,1,FI,1)
*
        Call mma_deallocate(Tmp6)
        Call mma_deallocate(Tmp5)
      End If

      Call mma_deallocate(Tmp7)
      Call mma_deallocate(Tmp4)
      If(.not.Do_OFemb) Call mma_deallocate(Tmp3)
*
      If ( RFpert ) then
*
*       Read the reaction field from RunFile or RunOld
*
        Call f_Inquire('RUNOLD',Found)
        If (Found) Call NameRun('RUNOLD')
        Call mma_allocate(TmpZ,nTot1,Label='TmpZ')
        Call Get_dScalar('RF Self Energy',ERFX)
        Call Get_dArray('Reaction field',TmpZ,nTot1)
        Call Daxpy_(nTot1,1.0D0,TmpZ,1,Tmp1,1)
        Call mma_deallocate(TmpZ)
        If (Found) Call NameRun('#Pop')
      End If
      Call mma_allocate(Tmp2,nTot1,Label='Tmp2')
        If ( IPRLEV.ge.DEBUG ) then
          Write(LF,*)
          Write(LF,*) ' D1I in AO basis in SGFCIN'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            Call TriPrt(' ','(5G17.11)',D1I(ioff),iBas)
            iOff = iOff + (iBas*iBas+iBas)/2
          End Do
        End If
      Call Fold(nSym,nBas,D1I,Tmp2)

*
      If (Do_OFemb) Then
         If (OFE_first) Then
          Call mma_allocate(FMaux,nTot1,Label='FMAux')
          Call Coul_DMB(.true.,1,Rep_EN,FMaux,Tmp3,Dumm,nTot1)
          OFE_first=.false.
         Else
          Call Coul_DMB(.false.,1,Rep_EN,FMaux,Tmp3,Dumm,nTot1)
         EndIf
         Call DaXpY_(nTot1,One,FMaux,1,Tmp1,1)
*
         Call NameRun('AUXRFIL') ! switch the RUNFILE name
         Call Get_dExcdRa(Tmpx,nVxc)
         Call DaXpY_(nTot1,One,Tmpx,1,Tmp1,1)
         If (nVxc.eq.2*nTot1) Then ! Nuc Attr added twice
            Call DaXpY_(nTot1,One,Tmpx(1+nTot1),1,Tmp1,1)
            Call Get_dArray('Nuc Potential',Tmpx,nTot1)
            Call DaXpY_(nTot1,-One,Tmpx,1,Tmp1,1)
         EndIf
         Call mma_deallocate(Tmpx)
         Call mma_deallocate(Tmp3)
         Call NameRun('#Pop')    ! switch back to old RUNFILE
      End If
*
*     Compute energy contributions
      Eone = dDot_(nTot1,Tmp2,1,Tmp1,1)
*     Call Get_PotNuc(PotNuc_Ref)
      Call Get_dScalar('PotNuc',PotNuc_Ref)
      Eone = Eone + (PotNuc-PotNuc_Ref)
      Etwo = dDot_(nTot1,Tmp2,1,FI,1)
      Call mma_deallocate(Tmp2)
      EMY  = PotNuc_Ref+Eone+0.5d0*Etwo+ERFX
      CASDFT_Funct = Zero
      If(KSDFT(1:3).ne.'SCF'.and.KSDFT(1:3).ne.'PAM')
     &      Call Get_dScalar('CASDFT energy',CASDFT_Funct)
      If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*) ' Nuclear repulsion 1      :',PotNuc
         Write(LF,*) ' Nuclear repulsion 2 Ref  :',PotNuc_Ref
         Write(LF,*) ' One-electron core energy :',Eone
         Write(LF,*) ' Two-electron core energy :',Etwo
         Write(LF,*) ' Total core energy        :',EMY
         If(KSDFT(1:3).ne.'SCF'.and.KSDFT.ne.'PAM')
     &   Write(LF,*) ' CASDFT Energy            :',CASDFT_Funct
      End If

      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' FI matrix in AO in SGFCIN only 2-electron terms'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',FI(iOff),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End If
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' Tmp1 matrix in SGFCIN, one-electron term'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',Tmp1(iOff),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End If
*
*     Assemble the one-electron Tmp1 and two-electron contribution to AO Fock matrix
      Call DaXpY_(nTot1,One,Tmp1,1,FI,1)
      Call mma_deallocate(Tmp1)
*
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' Inactive Fock matrix in AO basis in SGFCIN'
        Write(LF,*) '(it already contains OneHam and TwoEl contrib.)'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',FI(iOff),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End If

*     Transform FI to active orbital basis and move it over to F.
*     Remove also the symmetry blocking.
      MXNB=0
      MXNA=0
      DO ISYM=1,NSYM
        MXNB=MAX(MXNB,NBAS(ISYM))
        MXNA=MAX(MXNA,NASH(ISYM))
      END DO
      CALL mma_allocate(X0,NTOT1,Label='X0')
      CALL mma_allocate(X1,NTOT1,Label='X1')
      CALL mma_allocate(X2,MXNB*MXNB,Label='X2')
      CALL mma_allocate(X3,MXNB*MXNA,Label='X3')
      CALL DCOPY_(NTOT1,FI,1,X1,1)
      If(KSDFT(1:3).ne.'SCF'.and.KSDFT(1:3).ne.'PAM') Then
         Call Get_dExcdRa(TmpFckI,nTmpFck)
         CALL DaXpY_(NTOT1,1.0D0,TmpFckI,1,X1,1)
        If ( IPRLEV.ge.DEBUG ) then
          Write(LF,*)
          Write(LF,*) ' Exchange correlation in AO basis in SGFCIN'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            Call TriPrt(' ','(5G17.11)',TmpFckI(ioff),iBas)
            iOff = iOff + (iBas*iBas+iBas)/2
          End Do
        End If
        Call mma_deallocate(TmpFckI)
      End If
      If ( IPRLEV.ge.DEBUG ) then
       Write(LF,*)
       Write(LF,*) ' Modified FI in AO basis in SGFCIN'
       Write(LF,*) ' ---------------------'
       Write(LF,*)
       iOff=1
       Do iSym = 1,nSym
         iBas = nBas(iSym)
         Call TriPrt(' ','(5G17.11)',X1(ioff),iBas)
         iOff = iOff + (iBas*iBas+iBas)/2
       End Do
      End If
      CALL MOTRAC(CMO,X1,X2,X3)
      Call mma_deallocate(X3)
      Call mma_deallocate(X2)
      CALL DCOPY_(NACPAR,[ZERO],0,F,1)
      NTU=0
      ITU=0
      IADD=0
Cbjp
      IF (NACTEL.NE.0) THEN
         EMYN=EMY/DBLE(NACTEL)
      ELSE
         EMYN=Zero
      ENDIF
      DO NST=1,NSYM
        NAT=NASH(NST)
        IF(NAT.NE.0) THEN
          DO NT=1,NAT
            NTU=NTU+IADD
            DO NU=1,NT
              NTU=NTU+1
              ITU=ITU+1
              F(NTU)=X1(ITU)
              IF(NT.EQ.NU) F(NTU)=F(NTU)+EMYN
              X0(ITU) = F(NTU)
            END DO
          END DO
          IADD=IADD+NAT
        ENDIF
      END DO

!Quan: Fix bug, skip Lucia stuff with DMRG
! and other external CI solvers.
      if (.not. any([DoNECI, Do_CC_CI, DumpOnly,
     &              doDMRG, doBlockDMRG])) then
        INT1(1:ITU) = X0(1:ITU)
        INT1(ITU+1:) = Zero
        INT1O(1:ITU) = X0(1:ITU)
        INT1O(ITU+1:) = Zero
      endif

      Call mma_deallocate(X1)
      Call mma_deallocate(X0)

*     print h0
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' Inactive Fock mat in act MO basis, h0, in SGFCIN'
        Write(LF,*) ' ------------'
        Write(LF,*)
        Call TriPrt(' ',' ',F,NAC)
      End If



      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Reord_chcc (wrk,wrksize,
     c             NaGrpR,NaSGrpR,NchBlk,LunAux)
c
c       This routine do:
c       1) Read local CD1 file of Cholesky vectors from MC
c       2) Reorder ChV from pq,mloc to mloc,pq
c           Make L0-L2 files (local, dimensioned as ncLoc)
c           (if needed: (JoinLkey=1)
c       3) Make I0-I3 integrals
c          Calc E MP2
c           Make T20 (fist estimation (ai|jb)/Dijab
c           Make L0-L2 files (Global, dimensioned as nc)
c           (if needed: (JoinLkey=2)
c
c        for integral based approach (intkey=1)
c        5.1) W3 (vv|vo) integrals
c        5.2) W4 (vv|vv) integrals
c        5.3) Make L0-L2 files (Global, dimensioned as nc)
c           (if needed: JoinLkey=3)
c
c
c
c1      Structure of files, where selected group of (pq|rs) are
c       stored (V'O|OO) - I1 ; (V'O|V'O) - I2 ; (V'V'|OO) - I3
c
c       (IJ |KL)  I0intg
c
c       (A'I|JK)  I1inxx xx - Group of A'
c
c       (A'I|B'J) I2xxyy xx - Group of A'
c                        yy - Group of B'
c
c       (A'B'|IJ) I3xxyy xx - Group of A'
c                        yy - Group of B'
c
c
c2      Structure of Cholesky vector files
c
c       L0(m,IJ)    L0vctr  I>=J
c
c       L1(m,I ,A') L1vcxx xx - Group of A'
c@@        kokot som, ze som to takto urobil, prerobit na L(m,a,i) to treba
c
c       L2(m,A'B')  L2xxyy xx - Group of A', A'>=B'
c                          yy - Group of B'
c
c3      Structure of Amplitude file
c       t2(A'B',I,J)  T2xxyy xx - Group of A'
c                            yy - Group of B'
c
c       Memory requirements:
c        cholesky:
c       V1   - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm;  oom}
c       V2   - max {ov'ov'; v'v'm, ov'm; oom}
c       V3   - max {ov'm; oom}
c        V4   -      oom
c        integral based:
c       V1   - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm; oom; V"V"V"V"}
c       V2   - max {ov'ov'; v'v'm, ov'm; oom}
c       V3   - max {ov'm; oom; V'V'M}
c       V4   - oom
c       M1   - V"V"m
c       M2   - max {V"V"M; OV"M)
c
#ifdef _MOLCAS_MPP_
        use Para_Info, only: MyRank
#endif
        implicit none
#include "chcc1.fh"
#include "chcc_reord.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
#include "wrk.fh"
#ifdef _MOLCAS_MPP_
#include "parcc.fh"
#endif
c
        integer NaGrpR,NaSGrpR,NChBlk
        integer LunAux

c       help variables
        integer dim1,dimij
        integer PossV1,PossV2,PossV3,PossV4,PossM1,PossM2
        integer PossT,maxdim
#ifdef _MOLCAS_MPP_
        integer j,NSGrp
#endif
        integer i,nbs,PossX
        integer ncLoc
c
        integer DimCh(1:100)
        integer LunChVF,NCh,ChLow,ChUp,idisk
c
        character*6 LunName
c
        character*24 Label
        Logical      Found
        integer      nOrbE
c
        integer dima,dimb,dimc,dimd,dimab,dimcd,dimci
        integer dimapp,dimbpp,dimcpp,dimdpp,dimabpp,dimcdpp
        integer adda,addb,addc,addd,addapp,addbpp,addcpp,adddpp
        integer aGrp,bGrp,cGrp,dGrp,aSGrp,bSGrp,cSGrp,dSGrp
        integer abGrp,cdGrp,abSGrp,cdSGrp
        integer bSGrpUp,dSGrpUp
        integer NaGrp,NbeGrp,NaSGrp,NbeSgrp
        integer mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
        character*8 LunName8
        character*10 LunName10
        integer Nv4Ints
        integer w3aby,w4aby,w3abcy,w4abcdy
c
        real*8 e2,e2os
c
        integer isfreeunit
        integer idum(1)
c
c       Def parameters
        call DefParReord (NaGrpR,maxdim)
        NaGrp=NaGrpR
        NaSGrp=NaSGrpR
        NbeGrp=NaGrpR
        NbeSGrp=NaSGrpR
        call DefParo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c                   mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
        if (printkey.ge.10) then
        write (6,*) ' Maxdim',maxdim,mdSGrpa
        end if
c
c        Distribute memory
        PossT=PossFree
        call DistMemReord (NaGrpR,maxdim,mdSGrpa,NchBlk,
     c       PossV1,PossV2,PossV3,PossV4,PossM1,PossM2,
     c       PossT)
        if (printkey.ge.10) then
        write (6,*) ' Last Value :',PossT,wrksize
        end if
        if (PossT.gt.wrksize) then
cmp!          write (6,*) ' Nieje dobre - Reord_chcc, Dr. Ch. Kokotopuloss',
        write (6,*) ' Not Enough memory in Reord_chcc step!',
     & 'Increase large and/or small segmentation ',
     c    (1.0d0*PossT)/(1.0d0*wrksize)
          call abend()
        end if
c
c*      Get Orbital energies
c
c       nOrbE=nfr+no+nv ! wrong size if ndel.ne.0
        Call Get_iArray('nBas',idum,1) ! must read always nBas fr runf
        nOrbE=idum(1)
        Label='OrbE'
        Call qpg_dArray(Label,Found,nOrbE)
        If(.not.Found .or. nOrbE.eq.0) Then
          Call SysAbendMsg('get_orbe','Did not find:',Label)
        End If
        call Get_dArray(Label,wrk(PossOE),nOrbE)
        if (printkey.ge.10) then ! toto som si nie isty
        do i=1,nfr+no+nv
        write (6,*) i,wrk(PossOE+i-1)
        end do
        end if
c
c*      skip frozen OE
        PossOE=PossOE+nfr
c
c*        Make Foo,Fvv,Fov
c        N.B. Ked bude OE(q) ine ako Fqq,  alebo F nediagonalny,
c            bude treba urobit inak
c
        dim1=no*no
        call mv0zero (dim1,dim1,wrk(PossFoo))
        dim1=nv*nv
        call mv0zero (dim1,dim1,wrk(PossFvv))
        dim1=nv*no
        call mv0zero (dim1,dim1,wrk(PossFvo))
c
c*        Escape, if Reord is not needed
c
        if (generkey.eq.0) then
          return
        end if
c
c*      ------- part 1, read  data form _CD file
c               and distributed in the form L(p',q',m') ------
c
c
c*      open _CD file and initialize parameters
c
cmp!<new 21/04/09
        LunChVF = 80
        LunChVF = isfreeunit(LunChVF)
cmp!>
        call DaName_mf_wa (LunChVF,'CD1tmp')
c
#ifdef _MOLCAS_MPP_
        ncLoc=NChLoc(myRank)
#else
        ncLoc=nc
#endif
c
        Nch=1
        ChLow=1
        ChUp=NChBlk
        DimCh(1)=ChUp-ChLow+1
        idisk=1
cmp
        if (printkey.ge.10) then
        write (6,*)
        write (6,*) 'ncLoc ',ncLoc
        write (6,*)
        end if
cmp
c
c*      read the block into V1(p,q,m') from _CD1
1       dim1=(no+nv)*(no+nv)*DimCh(NCh)
        if (printkey.ge.10) then
        write (6,*) 'Read _CD1',DimCh(NCh),dim1,idisk
        end if
        call ddafile (LunChVF,2,wrk(PossV1),dim1,idisk)
c
c
c1.1    Extract L0(ij,m')
c
        dimc=DimCh(NCh)
        nbs=no+nv
        dimij=no*(no+1)/2
        call Ext_L0 (wrk(PossV1),wrk(PossV2),
     c               no,dimij,dimc,nbs)
c
        LunName=L0Name
        dim1=dimij*dimc
        if (ChLow.eq.1) then
          call SaveX (wrk(PossV2),dim1,LunAux,LunName,1,1)
        else
          call SaveX (wrk(PossV2),dim1,LunAux,LunName,3,1)
        end if
c
c
c1.2    Extract L1(i,a',m')
c
        adda=0
        do aGrp=1,NaGrpR
        dima=DimGrpaR(aGrp)
c
          dimc=DimCh(NCh)
          nbs=no+nv
          call Ext_L1 (wrk(PossV1),wrk(PossV2),
     c                 no,dima,dimc,adda+no,nbs)
c
          LunName=L1Name(aGrp)
          dim1=dima*no*dimc
          if (ChLow.eq.1) then
            call SaveX (wrk(PossV2),dim1,LunAux,LunName,1,1)
          else
            call SaveX (wrk(PossV2),dim1,LunAux,LunName,3,1)
          end if
c
        adda=adda+dima
        end do
c
c
c1.3    Extract L2(a'b',m')
c
        adda=0
        do aGrp=1,NaGrpR
        dima=DimGrpaR(aGrp)
c
          addb=0
          do bGrp=1,aGrp
          dimb=DimGrpaR(bGrp)
c
            dimc=DimCh(NCh)
            nbs=no+nv
            if (aGrp.eq.bGrp) then
              dimab=dima*(dima+1)/2
              call Ext_L2s (wrk(PossV1),wrk(PossV2),
     c                      dima,dimab,dimc,adda+no,addb+no,nbs)
            else
              dimab=dima*dimb
              call Ext_L2u (wrk(PossV1),wrk(PossV2),
     c                      dima,dimb,dimc,adda+no,addb+no,nbs)
            end if
c
            LunName=L2Name(aGrp,bGrp)
            dim1=dimab*dimc
            if (ChLow.eq.1) then
              call SaveX (wrk(PossV2),dim1,LunAux,LunName,1,1)
            else
              call SaveX (wrk(PossV2),dim1,LunAux,LunName,3,1)
            end if
c
          addb=addb+dimb
          end do
        adda=adda+dima
        end do
c
c
c*      Upgrade parameters, if needed
        if (ChUp.lt.ncLoc) then
          Nch=Nch+1
          ChLow=ChLow+DimCh(Nch-1)
          if ((ChUp+NChBlk).gt.ncLoc) then
            ChUp=ncLoc
          else
            ChUp=ChUp+NChBlk
          end if
          DimCh(Nch)=ChUp-ChLow+1
          goto 1
        end if
c
c*      close _CD file
c
        call DaClos (LunChVF)
c
c
c
c*      ------- part 2, read data in the form L(p',q',m')
c               and redistributed in the form L(m,p'q')   --------
c
c
c*
c2.1    Reorder L0(ij,m') to L0(ml,ij)
c
          LunName=L0Name
          dimij=no*(no+1)/2
c
c2.1.1  get L0(ij,ml) into V1(ij,ml)
c
        if (NCh.eq.1) then
c       all in one
          dim1=dimij*ncLoc
          call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
        else if (NCh.eq.2) then
c       all in two
          PossX=PossV1
          dim1=dimij*DimCh(1)
          call GetX (wrk(PossX),dim1,LunAux,LunName,1,0)
          PossX=PossV1+dim1
          dim1=dimij*DimCh(2)
          call GetX (wrk(PossX),dim1,LunAux,LunName,0,1)
c
        else
c       more than 2 records
          PossX=PossV1
          dim1=dimij*DimCh(1)
          call GetX (wrk(PossX),dim1,LunAux,LunName,1,0)
          do i=2,NCh-1
            PossX=PossX+dim1
            dim1=dimij*DimCh(i)
            call GetX (wrk(PossX),dim1,LunAux,LunName,0,0)
          end do
          PossX=PossX+dim1
          dim1=dimij*DimCh(NCh)
          call GetX (wrk(PossX),dim1,LunAux,LunName,0,1)
c
        end if
c
c2.1.2  map V1(ij,ml) -> V2(ml,ij)
c
        call Map2_21 (wrk(PossV1),wrk(PossV2),dimij,ncLoc)
c
c2.1.3  write L0 = V2(ml,ij) back into file
c
        dim1=dimij*ncLoc
        call SaveX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
c
c*
c2.2    Reorder L1(i,a',m') to L1(ml,i,a')
c
        do aGrp=1,NaGrpR
        dima=DimGrpaR(aGrp)
        LunName=L1Name(aGrp)
c
c2.2.1  get L1(i,a',ml) into V1(i,a',ml)
c
        if (NCh.eq.1) then
c       all in one
          dim1=no*dima*ncLoc
          call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
        else if (NCh.eq.2) then
c       all in two
          PossX=PossV1
          dim1=no*dima*DimCh(1)
          call GetX (wrk(PossX),dim1,LunAux,LunName,1,0)
          PossX=PossV1+dim1
          dim1=no*dima*DimCh(2)
          call GetX (wrk(PossX),dim1,LunAux,LunName,0,1)
c
        else
c       more than 2 records
          PossX=PossV1
          dim1=no*dima*DimCh(1)
          call GetX (wrk(PossX),dim1,LunAux,LunName,1,0)
          do i=2,NCh-1
            PossX=PossX+dim1
            dim1=no*dima*DimCh(i)
            call GetX (wrk(PossX),dim1,LunAux,LunName,0,0)
          end do
          PossX=PossX+dim1
          dim1=no*dima*DimCh(NCh)
          call GetX (wrk(PossX),dim1,LunAux,LunName,0,1)
c
        end if
c
c2.2.2  map V1(i,a',ml) -> V2(ml,i,a')
c
        call Map2_21 (wrk(PossV1),wrk(PossV2),no*dima,ncLoc)
c
c2.2.3  write L1 = V2(ml,i,a') back into file
c
        dim1=no*dima*ncLoc
        call SaveX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
        end do
c
c
c*
c2.3    Reorder L2(a'b',m') to L2(ml,a'b')
c
        do aGrp=1,NaGrpR
        dima=DimGrpaR(aGrp)
        do bGrp=1,aGrp
        dimb=DimGrpaR(bGrp)
        if(aGrp.eq.bGrp) then
          dimab=dima*(dima+1)/2
        else
          dimab=dima*dimb
        end if
        LunName=L2Name(aGrp,bGrp)
c
c2.3.1  get L2(a'b',ml) into V1(a'b',ml)
c
        if (NCh.eq.1) then
c       all in one
          dim1=dimab*ncLoc
          call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
        else if (NCh.eq.2) then
c       all in two
          PossX=PossV1
          dim1=dimab*DimCh(1)
          call GetX (wrk(PossX),dim1,LunAux,LunName,1,0)
          PossX=PossV1+dim1
          dim1=dimab*DimCh(2)
          call GetX (wrk(PossX),dim1,LunAux,LunName,0,1)
c
        else
c       more than 2 records
          PossX=PossV1
          dim1=dimab*DimCh(1)
          call GetX (wrk(PossX),dim1,LunAux,LunName,1,0)
          do i=2,NCh-1
            PossX=PossX+dim1
            dim1=dimab*DimCh(i)
            call GetX (wrk(PossX),dim1,LunAux,LunName,0,0)
          end do
          PossX=PossX+dim1
          dim1=dimab*DimCh(NCh)
          call GetX (wrk(PossX),dim1,LunAux,LunName,0,1)
c
        end if
c
c2.3.2  map V1(a'b',ml) -> V2(ml,a'b')
c
        call Map2_21 (wrk(PossV1),wrk(PossV2),dimab,ncLoc)
c
c2.3.3  write L2 = V2(ml,a'b') back into file
c
        dim1=dimab*ncLoc
        call SaveX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
        end do
        end do
c
c
c2.4    reconstructing L0-L2 (Global, m=nc) ---
c           from Local L0-L2 (ml=NChLoc(myRank))
c        if needed (JoinLKey=1)
c
        if (JoinLkey.eq.1) then
          if (ncLoc.lt.nc) then
            call JoinLvec (wrk,wrksize,
     c                     PossV1,PossV2,NaGrpR,LunAux)
            ncLoc=nc
          end if
        end if
c
c
c
c*      ------- part 3, produce I integrals from Cholesky vectors
c
c3.1    Generate I0(ij,kl)
c
c3.124.1 read V4(ml,ij) <- L0(ml,ij)
        LunName=L0name
        dimij=no*(no+1)/2
        call GetX (wrk(PossV4),ncLoc*dimij,LunAux,LunName,1,1)
c
c3.1.2        V1(ij,kl) = V4(T)(ml,ij) . V4(ml,kl)
        dim1=dimij*dimij
        call mv0zero(dim1,dim1,wrk(PossV1))
        call mc0c1at3b (ncLoc,dimij,ncLoc,dimij,dimij,dimij,
     c                  dimij,ncLoc,dimij,
     c                  wrk(PossV4),wrk(PossV4),wrk(PossV1))
c
#ifdef _MOLCAS_MPP_
c##        Synchronizacny bod
c3.1.3        Allreduce V1
        if (ncLoc.lt.nc) then
          dim1=dimij*dimij
          call gadgop (wrk(PossV1),dim1,'+')
        end if
#endif
c
c3.1.4  write V1(ij,kl)
        LunName=I0name
        dim1=dimij*dimij
        call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c
c3.23   generate I1(a'i,jk), I2(a'i,b'j) :-)
c
c
        e2=0.0d0
        e2os=0.0d0
c
        addb=0
        do bGrp=1,NaGrpR
        dimb=DimGrpaR(bGrp)
c
c3.23.2   read V2(ml,i,b') <- L1(ml,i,b')
          LunName=L1name(bGrp)
          dim1=ncLoc*no*dimb
          call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
c3.23.3   Map V3(ml,b',i) <- V2(ml,i,b')
          call Map3_132 (wrk(PossV2),wrk(PossV3),ncLoc,no,dimb)
c
c3.2.4    calc V1(b',i,kl) <<- V3(T)(ml,b',i) . V4(ml,kl)
cBug      dim1=no*dima*dimij
          dim1=no*dimb*dimij
          call mv0zero(dim1,dim1,wrk(PossV1))
          call mc0c1at3b (ncLoc,dimb*no,ncLoc,dimij,dimb*no,dimij,
     c                    dimb*no,ncLoc,dimij,
     c                    wrk(PossV3),wrk(PossV4),wrk(PossV1))
c
#ifdef _MOLCAS_MPP_
c##          Synchronizacny bod
c3.2.5          Allreduce V1
          if (ncLoc.lt.nc) then
            dim1=no*dimb*dimij
            call gadgop (wrk(PossV1),dim1,'+')
          end if
#endif
c
c3.2.6    write V1(b',i,kl)
          LunName=I1name(bGrp)
          dim1=no*dimb*dimij
          call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c
          adda=0
          do aGrp=1,NaGrpR
          dima=DimGrpaR(aGrp)
          if (printkey.ge.10) then
          write (6,*) aGrp,bGrp,dima,dimb
          end if
c
c3.3.4      read V1(ml,i,a)
            LunName=L1name(aGrp)
            dim1=ncLoc*no*dima
            call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c3.3.5      Map V2(ml,a',i) <- V1(ml,i,a')
            call Map3_132 (wrk(PossV1),wrk(PossV2),ncLoc,no,dima)
c
c3.3.6      V1(a',i,b',j) <<- V2(T)(ml,a',i) . V3(ml,b',j)
            dim1=no*no*dima*dimb
            call mv0zero(dim1,dim1,wrk(PossV1))
            call mc0c1at3b (ncLoc,dima*no,ncLoc,dimb*no,dima*no,dimb*no,
     c                      dima*no,ncLoc,dimb*no,
     c                      wrk(PossV2),wrk(PossV3),wrk(PossV1))
c
#ifdef _MOLCAS_MPP_
c##            Synchronizacny bod
c3.3.7            Allreduce V1
            if (ncLoc.lt.nc) then
              dim1=no*no*dima*dimb
              call gadgop (wrk(PossV1),dim1,'+')
            end if
#endif
c
c3.3.8      write V1(a',i,b',j)
            LunName=I2name(aGrp,bGrp)
            dim1=no*dima*no*dimb
            call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c3.3.x      cierny vypocet E2
            call CVE2 (wrk(PossV1),wrk(PossOE),
     c                 dima,dimb,adda+no,addb+no,no,e2,e2os)
c
c
c3.3.x            Make V2(ab',i,j) <- V1(a',i,b',j)/Dijab
            if (aGrp.eq.bGrp) then
               call MkT20p (wrk(PossV2),wrk(PossV1),wrk(PossOE),
     c                     dima,adda+no,no)
            else
               call MkT20u (wrk(PossV2),wrk(PossV1),wrk(PossOE),
     c                     dima,dimb,adda+no,addb+no,no)
            end if
c
c3.3.x            Save V2 - T2(0) into T2Name
            LunName=T2Name(aGrp,bGrp)
            if (aGrp.eq.bGrp) then
              dim1=dima*(dima+1)*no*no/2
            else
              dim1=dima*dimb*no*no
            end if
            call SaveX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
          adda=adda+dima
          end do
c
        addb=addb+dimb
        end do
c
        write (6,*)
        write (6,92) ' E2 MP2    :',e2
        write (6,92) ' E2 ss     :',e2-e2os
        write (6,92) ' E2 os     :',e2os
        write (6,*)
92      format (a12,1x,f15.12)

c
c
c3.4    generate I3(a'b'|ij)
c
        adda=0
        do aGrp=1,NaGrpR
        dima=DimGrpaR(aGrp)
c
          addb=0
          do bGrp=1,aGrp
          dimb=DimGrpaR(bGrp)
c
c3.4.2      read V2(ml,a'b')
            LunName=L2name(aGrp,bGrp)
            if (aGrp.eq.bGrp) then
              dimab=dima*(dima+1)/2
            else
              dimab=dima*dimb
            end if
            call GetX (wrk(PossV2),ncLoc*dimab,LunAux,LunName,1,1)
c
c3.4.3      V1(a'b',ij) <<- V2(T)(ml,a'b') . V4(ml,ij)
            call mv0zero(dimab*dimij,dimab*dimij,wrk(PossV1))
            call mc0c1at3b (ncLoc,dimab,ncLoc,dimij,dimab,dimij,
     c                      dimab,ncLoc,dimij,
     c                      wrk(PossV2),wrk(PossV4),wrk(PossV1))
c
#ifdef _MOLCAS_MPP_
c##            Synchronizacny bod
c3.4.4            Allreduce V1
            if (ncLoc.lt.nc) then
              dim1=dimij*dimab
              call gadgop (wrk(PossV1),dim1,'+')
            end if
#endif
c
c3.4.5      write V1(a',i,b',j)
            LunName=I3name(aGrp,bGrp)
            dim1=dimij*dimab
            call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
          adda=adda+dima
          end do
c
        addb=addb+dimb
        end do
c
c
c3.5    reconstructing L0-L2 (Global, m=nc) ---
c           from Local L0-L2 (ml=NChLoc(myRank))
c        if needed (JoinLKey=2)
c
        if (JoinLkey.eq.2) then
          if (ncLoc.lt.nc) then
            call JoinLvec (wrk,wrksize,
     c                     PossV1,PossV2,NaGrpR,LunAux)
            ncLoc=nc
          end if
        end if
c
c
c        in W3 and W4 files are not generated, finish
        if (intkey.eq.0) then
          return
        end if
c
c
c*      ------- part 5, produce (vv|vo) and (vv|vv) integrals
c                        for integral based approach
c                        all terminology in o2v4 language
c
c        Extra cost: Mult. read - Na*(Na+1)/2 . L2(m,cd)
c                              - Na*(Na+1)/2 . L1(m,ci)
c
c        N.B.
c        - Ak je L2 uz spojene (ncLoc=nc) a W34DistKey=1
c          potom sa obskakuju ani nepisu tie kombinacie, ktore na
c          tomto node netreba (vhodne pre velke nProcs aj pri rychlej
c          sieti, pre pomalu siet aj pre mensie nProcs)
c        - Ak L2 este nieje spojene (ncLoc<nc) a W34DistKey=1
c          potom sa nic neobskakuje, vsetky W3 a W4 sa pocitaju
c          a allreducuju, ale sa nepisu na disk ak ich na tomto
c          node netreba, cim sa setri miesto
c          (vhodne pre mensie nProcs a rychlu siet)
c        - Ak L2 este nieje spojene (ncLoc<nc) a W34DistKey=0
c          potom sa nic neobskakuje, vsetky W3 a W4 sa pocitaju
c          a allreducuju, a pisu sa na disk vsade,
c          cim sa nesetri miesto, ale vsade su vsetky W3,4
c         (zbytocny pripad, pokial sa nechceme hrat s load-ballance
c           a nepotrebujeme mat vsade vsetko)
c        - Paralelny pripad (ncLoc=nc) a W34DistKey=0
c          bude pocitat iba kokot
c        - Osetrene na paralelny Nprocs=1, aj na skalarny case
c

#ifdef _MOLCAS_MPP_
c
        if (W34DistKey.eq.1) then
c*          case: Ditributed W34 files
c*.1          make a map, which W3 and W4 files are needed on this node
c          i.e. def InqW3, InqW4
          call Xo2v4ctl (NaGrp,NaSGrp,LunAux)
c
        else
c*          case: All W34 files on each node
c*.1          set InqW3,InqW4 - True
          NSGrp=NaGrp*NaSGrp
          do i=1,(NSGrp*(NSGrp+1))/2
            do j=1,NSGrp
            InqW3(i,j)=.True.
            end do
            do j=1,(NSGrp*(NSGrp+1))/2
            InqW4(i,j)=.True.
            end do
          end do
c
        end if
c
#endif
c
        Nv4Ints=0
c
c        cycle over a'>=b' groups
        adda=0
        do aGrp=1,NaGrp
        dima=DimGrpa(aGrp)
        addb=0
        do bGrp=1,aGrp
        dimb=DimGrpa(bGrp)
        abGrp=aGrp*(aGrp-1)/2+bGrp
c
        if (printkey.ge.10) then
        write (6,*) ' W3 + W4 ',aGrp,bGrp
        end if
c
c        test, if atleast one file of W3/W4 integrals
c        need to be calculated on this node for given a',b'
c        skip, if there is nothing to calculate for this a'b'
c        on this node and L is joined (ncLoc=nc)
        call DefW34y (aGrp,bGrp,w3aby,w4aby,NaGrp)
        if ((w3aby+w4aby).eq.0) then
          if (ncLoc.eq.nc) goto 41
        end if
c
c         read V2(ml,a'b') = L2(ml,a'b')
          LunName=L2name(aGrp,bGrp)
          if (aGrp.eq.bGrp) then
            dimab=dima*(dima+1)/2
          else
            dimab=dima*dimb
             end if
          call GetX (wrk(PossV2),ncLoc*dimab,LunAux,LunName,1,1)
c
c
c*          ---- Part 5.1 - Generation of (ab|ci) integrals ----
c               (Svincaja morda)
c
c
c          skip, if there is no W3 file to calculate for this a'b'
c          on this node and L is joined (ncLoc=nc)
          if ((w3aby).eq.0) then
            if (ncLoc.eq.nc) goto 42
          end if
c
c          cycle over c' groups
          addc=0
          do cGrp=1,NaGrp
          dimc=DimGrpa(cGrp)
c
c            test, if atleast one file of W3 integrals
c            need to be calculated on this node for given a',b',c'
c            and skip, if there is nothing to calculate for this a',b',c'
c              on this node and L is joined (ncLoc=nc)
            call DefW3y (aGrp,bGrp,cGrp,w3abcy)
            if ((w3abcy).eq.0) then
              if (ncLoc.eq.nc) goto 43
            end if


c            Get V3(ml,c',i)
c            Read V1(ml,i,c') <- L1(ml,i,c)
            dimci=dimc*no
            LunName=L1Name(cGrp)
            call GetX (wrk(PossV1),ncLoc*dimci,LunAux,LunName,1,1)
c            Map V3(ml,c',i) <- V1(ml,i,c')
            call Map3_132 (wrk(PossV1),wrk(PossV3),ncLoc,no,dimc)
c
c
c            cycle over a">=b" subgroups
            addapp=0
            do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
            dimapp=DimSGrpa(aSGrp)
            if (aGrp.eq.bGrp) then
              bSGrpUp=aSGrp
            else
              bSGrpUp=GrpaUp(bGrp)
            end if
            addbpp=0
            do bSGrp=GrpaLow(bGrp),bSGrpUp
            dimbpp=DimSGrpa(bSGrp)
            abSGrp=aSGrp*(aSGrp-1)/2+bSGrp
c
c
c              Extract M1(ml,a"b") <- V2(ml,a'b')
              if (aSGrp.eq.bSGrp) then
                dimabpp=dimapp*(dimapp+1)/2
              else
                dimabpp=dimapp*dimbpp
              end if
              call Ext_W4 (wrk(PossV2),wrk(PossM1),
     c                     ncLoc,dima,dimb,dimab,dimapp,dimbpp,dimabpp,
     c                     addapp,addbpp,aGrp,bGrp,aSGrp,bSGrp)
c
c
c              cycle over c" subgroups
              addcpp=0
              do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
              dimcpp=DimSGrpa(cSGrp)
c
#ifdef _MOLCAS_MPP_
c                skip, if W3(a"b",c"i) is not needed on this node
c               and L is joined (ncLoc=nc)
                if (InqW3(abSGrp,cSGrp).eqv..False.) then
                  if (ncLoc.eq.nc) goto 44
                end if
#endif
c
c                Extract M2(ml,c",i) <- V3(ml,c',i)
                call Ext_W3 (wrk(PossV3),wrk(PossM2),
     c                       ncLoc,no,dimc,dimcpp,addcpp)
c
c                Calc V1(a"b",c"i) <- M1(T)(ml,a"b") . M2(ml,c",i)
                dim1=dimcpp*no
                call mv0zero (dimabpp*dim1,dimabpp*dim1,wrk(PossV1))
                call mc0c1at3b (ncLoc,dimabpp,ncLoc,dim1,dimabpp,dim1,
     c                          dimabpp,ncLoc,dim1,
     c                          wrk(PossM1),wrk(PossM2),wrk(PossV1))
c
#ifdef _MOLCAS_MPP_
c##                Synchronizacny bod
c                     Allreduce V1
                if (ncLoc.lt.nc) then
                  dim1=dimabpp*dimcpp*no
                  call gadgop (wrk(PossV1),dim1,'+')
                end if
c                skip, if W3(a"b",c"i) is not needed on this node
                if (InqW3(abSGrp,cSGrp).eqv..False.) then
                  goto 44
                end if
#endif
c
c                Create Proper LunName8
                call MkNameV3 (aSGrp,bSGrp,cSGrp,'W3',LunName8)
c
c                Write integral block to proper file
*                open (unit=LunAux,file=LunName8,form='unformatted')
                 Call MOLCAS_BinaryOpen_Vanilla(LunAux,LunName8)
                call wri_chcc (LunAux,dimabpp*dimcpp*no,wrk(PossV1))
                close (LunAux)
c
c
c              end cycle over c" subgroups
#ifdef _MOLCAS_MPP_
44              continue
#endif
                addcpp=addcpp+dimcpp
              end do
c
c
c            end cycle over a">=b" subgroups
            addbpp=addbpp+dimbpp
            end do
            addapp=addapp+dimapp
            end do
c
c
c          end cycle over c' groups
43          addc=addc+dimc
          end do
c
c
c*          ---- Part 5.2 - Generation of (ab|cd) integrals ----
c               (Kobyljacaja sraka)
c
c
c          skip, if there is no W4 file to calculate for this a'b'
c          on this node and L is joined (ncLoc=nc)
42        if ((w4aby).eq.0) then
            if (ncLoc.eq.nc) goto 41
          end if
c
c          cycle over c'>=d' groups
          addc=0
          do cGrp=1,NaGrp
          dimc=DimGrpa(cGrp)
          addd=0
          do dGrp=1,cGrp
          dimd=DimGrpa(dGrp)
          cdGrp=cGrp*(cGrp-1)/2+dGrp
             if (cGrp.gt.aGrp) goto 49
c
c            test, if atleast one file of W4 integrals
c            need to be calculated on this node for given a',b',c',d'
c            and skip, if there is nothing to calculate for this
c                  a',b',c',d' on this node and L is joined (ncLoc=nc)
            call DefW4y (aGrp,bGrp,cGrp,dGrp,w4abcdy)
            if ((w4abcdy).eq.0) then
              if (ncLoc.eq.nc) goto 49
            end if
c
c           read V3(ml,c'd') = L2(ml,c'd')
            if (abGrp.eq.cdGrp) then
              dimcd=dimab
              call mv0u (ncLoc*dimcd,wrk(PossV2),1,wrk(PossV3),1)
            else
              LunName=L2name(cGrp,dGrp)
              if (cGrp.eq.dGrp) then
                dimcd=dimc*(dimc+1)/2
              else
                dimcd=dimc*dimd
                 end if
              call GetX (wrk(PossV3),ncLoc*dimcd,LunAux,LunName,1,1)
            end if

c
c            cycle over a">=b" subgroups
            addapp=0
            do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
            dimapp=DimSGrpa(aSGrp)
            if (aGrp.eq.bGrp) then
              bSGrpUp=aSGrp
            else
              bSGrpUp=GrpaUp(bGrp)
            end if
            addbpp=0
            do bSGrp=GrpaLow(bGrp),bSGrpUp
            dimbpp=DimSGrpa(bSGrp)
            abSGrp=aSGrp*(aSGrp-1)/2+bSGrp
c
c              test, if atleast one file of W4 integrals
c              need to be calculated on this node for given a",b",c',d'
c              and skip, if there is nothing to calculate for this
c                    a",b",c',d' on this node and L is joined (ncLoc=nc)
              call DefW4y2 (aSGrp,bSGrp,cGrp,dGrp,w4abcdy)
              if ((w4abcdy).eq.0) then
                if (ncLoc.eq.nc) goto 45
              end if
c
c              Extract M1(ml,a"b") <- V2(ml,a'b')
              if (aSGrp.eq.bSGrp) then
                dimabpp=dimapp*(dimapp+1)/2
              else
                dimabpp=dimapp*dimbpp
              end if
              call Ext_W4 (wrk(PossV2),wrk(PossM1),
     c                     ncLoc,dima,dimb,dimab,dimapp,dimbpp,dimabpp,
     c                     addapp,addbpp,aGrp,bGrp,aSGrp,bSGrp)
c
c
c              cycle over c">=d" subgroups
              addcpp=0
              do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
              dimcpp=DimSGrpa(cSGrp)
              if (cGrp.eq.dGrp) then
                dSGrpUp=cSGrp
              else
                dSGrpUp=GrpaUp(dGrp)
              end if
              adddpp=0
              do dSGrp=GrpaLow(dGrp),dSGrpUp
              dimdpp=DimSGrpa(dSGrp)
              cdSGrp=cSGrp*(cSGrp-1)/2+dSGrp
              if (cdSGrp.gt.abSGrp) goto 48
c
#ifdef _MOLCAS_MPP_
c                skip, if W4(a"b",c"d") is not needed on this node
c                and L is joined (ncLoc=nc)
                if (InqW4(abSGrp,cdSGrp).eqv..False.)  then
                  if (ncLoc.eq.nc) goto 48
                end if
#endif
c
c                Extract M2(ml,a"b") <- V3(ml,a'b')
                if (cSGrp.eq.dSGrp) then
                  dimcdpp=dimcpp*(dimcpp+1)/2
                else
                  dimcdpp=dimcpp*dimdpp
                end if
                call Ext_W4 (wrk(PossV3),wrk(PossM2),
     c                      ncLoc,dimc,dimd,dimcd,dimcpp,dimdpp,dimcdpp,
     c                       addcpp,adddpp,cGrp,dGrp,cSGrp,dSGrp)
c
c                Calc V1(a"b",c"d") <- M1(T)(ml,a"b") . M2(ml,c"d")
                dim1=dimabpp*dimcdpp
                call mv0zero (dim1,dim1,wrk(PossV1))
                call mc0c1at3b (ncLoc,dimabpp,ncLoc,dimcdpp,
     c                          dimabpp,dimcdpp,dimabpp,ncLoc,dimcdpp,
     c                          wrk(PossM1),wrk(PossM2),wrk(PossV1))
c
#ifdef _MOLCAS_MPP_
c##                Synchronizacny bod
c                     Allreduce V1
                if (ncLoc.lt.nc) then
                  dim1=dimabpp*dimcdpp
                  call gadgop (wrk(PossV1),dim1,'+')
                end if
c                skip, if W4(a"b",c"d") not needed on this node
                if (InqW4(abSGrp,cdSGrp).eqv..False.)  then
                  goto 48
                end if
#endif
c
c               Def proper LunName10
                call MkNameV4 (aSGrp,bSGrp,cSGrp,dSGrp,'W4',LunName10)
c
c                Write integral block to proper file
*                open (unit=LunAux,file=LunName10,form='unformatted')
                 Call MOLCAS_BinaryOpen_Vanilla(LunAux,LunName10)
                call wri_chcc (LunAux,dimabpp*dimcdpp,wrk(PossV1))
                close (LunAux)
                Nv4Ints=Nv4Ints+dimabpp*dimcdpp
c
c
c              end cycle over c">=d" subgroups
48              continue
              adddpp=adddpp+dimdpp
              end do
              addcpp=addcpp+dimcpp
              end do
c
c            end cycle over a">=b" subgroups
45          addbpp=addbpp+dimbpp
            end do
            addapp=addapp+dimapp
            end do

c          end cycle over c'>=d' groups
49          continue
          addd=addd+dimd
          end do
          addc=addc+dimc
          end do
c
c        end cycle over a'>=b' groups
41        addb=addb+dimb
        end do
        adda=adda+dima
        end do
c
        write (6,*) ' V4 ints compressing factor: ',
     c              1.0d0*(nv*nv*nv*nv)/Nv4Ints

c
c5.3    reconstructing L0-L2 (Global, m=nc) ---
c        if needed (JoinLKey=3)
c
        if (JoinLkey.eq.3) then
          if (ncLoc.lt.nc) then
            call JoinLvec (wrk,wrksize,
     c                     PossV1,PossV2,NaGrpR,LunAux)
            ncLoc=nc
          end if
        end if
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
cpgi$g opt=1
      SUBROUTINE MKHREF(HREF,FC,FIJKL,JREFX)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION HREF(*),FC(*),FIJKL(*),JREFX(NCVAL)
*
      NHREF=(NREF*(NREF+1))/2
      CALL FZERO(HREF,NHREF)
      ICHK=0
      IK=0
      FINI=0.0D00
      IADD25=0
      CALL dDAFILE(Lu_25,2,FC,NBTRI,IADD25)
      IADD10=IAD10(8)
100   CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 100
      IF(LEN.LT.0) GOTO 200
      DO 10 IN=1,LEN
      IND=ICOP1(IN)
      IF(ICHK.NE.0) THEN
        ICHK=0
        INDI=IND
*        NI=MOD(INDI,2**10)
*        NK=MOD(INDI/2**10,2**10)
        NI=IBITS(INDI, 0,10)
        NK=IBITS(INDI,10,10)
        IK=IROW(NK)+NI
        FINI=FC(IK)
        GO TO 10
      END IF
      IF(IND.EQ.0) THEN
        ICHK=1
        GO TO 10
      END IF
*      IVL=MOD(IND,2**6)
      IVL=IBITS(IND, 0, 6)
      IF(IVL.NE.IVVER)GO TO 10
*      IC2=MOD(IND/2**6,2**13)
      IC2=IBITS(IND, 6,13)
      NA=JREFX(IC2)
      IF(NA.EQ.0)GO TO 10
*      IC1=MOD(IND/2**19,2**13)
      IC1=IBITS(IND,19,13)
      NB=JREFX(IC1)
      IF(NB.EQ.0)GO TO 10
      IF(NA.LT.NB) THEN
        NAT=NA
        NA=NB
        NB=NAT
      END IF
      IVEC=(NA*(NA-1))/2+NB
      HREF(IVEC)=HREF(IVEC)+COP(IN)*FINI
10    CONTINUE
      GO TO 100
200   CONTINUE
      ICHK=0
      NIJ=IROW(LN+1)
      NIJKL=NIJ*(NIJ+1)/2
      CALL FZERO(FIJKL,NIJKL)
      FINI=0.0D00
      IADR=LASTAD(1)
201   CONTINUE
      CALL dDAFILE(Lu_70,2,VALSRT,NSRTMX,IADR)
      CALL iDAFILE(Lu_70,2,INDSRT,NSRTMX+2,IADR)
      LENGTH=INDSRT(NSRTMX+1)
      IADR=INDSRT(NSRTMX+2)
*      IF(LENGTH.GT.0) CALL SCATTER(LENGTH,FIJKL,INDSRT,VALSRT)
      do i=1,length
        FIJKL(INDSRT(i))=VALSRT(i)
      end do
      IF(IADR.NE.-1) GO TO 201
      IADD10=IAD10(5)
300   CONTINUE
      CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 300
      IF(LEN.LT.0)GOTO 400
      DO 310 IN=1,LEN
      IND=ICOP1(IN)
      IF(ICHK.NE.0) THEN
        ICHK=0
        INDI=IND
CPAM96        IP=IAND(INDI,255)
CPAM96        JP=IAND(ISHFT(INDI,-8),255)
CPAM96        KP=IAND(ISHFT(INDI,-16),255)
CPAM96        LP=IAND(ISHFT(INDI,-24),255)
*        IP=MOD(INDI,2**8)
*        JP=MOD(INDI/2**8,2**8)
*        KP=MOD(INDI/2**16,2**8)
*        LP=MOD(INDI/2**24,2**8)
        IP=IBITS(INDI, 0,8)
        JP=IBITS(INDI, 8,8)
        KP=IBITS(INDI,16,8)
        LP=IBITS(INDI,24,8)
        NIJ=IROW(IP)+JP
        NKL=IROW(KP)+LP
        IND=NIJ*(NIJ-1)/2+NKL
        FINI=FIJKL(IND)
        GOTO 310
      END IF
      IF(IND.EQ.0) THEN
        ICHK=1
        GOTO 310
      END IF
*      IVL=MOD(IND,2**6)
      IVL=IBITS(IND, 0, 6)
      IF(IVL.NE.0)GO TO 310
*      IC2=MOD(IND/2**6,2**13)
      IC2=IBITS(IND, 6,13)
      NA=JREFX(IC2)
      IF(NA.EQ.0)GO TO 310
*      IC1=MOD(IND/2**19,2**13)
      IC1=IBITS(IND,19,13)
      NB=JREFX(IC1)
      IF(NB.EQ.0)GO TO 310
      IF(NA.LT.NB) THEN
        NAT=NA
        NA=NB
        NB=NAT
      END IF
      IVEC=(NA*(NA-1))/2+NB
      HREF(IVEC)=HREF(IVEC)+COP(IN)*FINI
310   CONTINUE
      GO TO 300
400   CONTINUE
      IADD25=IAD25S
      IBUF=nCOP
      DO 410 I=1,IRC(1)
        IBUF=IBUF+1
        IF(IBUF.GT.nCOP) THEN
          CALL dDAFILE(Lu_25,2,COP,nCOP,IADD25)
          IBUF=1
        END IF
        IR=JREFX(I)
        IF(IR.GT.0) THEN
          IIR=(IR*(IR+1))/2
          HREF(IIR)=HREF(IIR)+COP(IBUF)+POTNUC
        END IF
410   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Rd1Int_MCLR()
!***********************************************************************
!                                                                      *
!     Read header and matrices from the one-electron integral file     *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use input_mclr, only: AtLbl, ChIrr, Coor, Header1I, iMethod, nAtoms, nBas, nSym, ntBas, ntBSqr, ntBTri, PotNuc
use Molcas, only: LenIn
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iSym
character(len=8) :: Method

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
!debug = .true.

call Get_cArray('Relax Method',Method,8)
if (Method == 'RHF-SCF') then
  iMethod = 1
else if ((Method == 'RASSCF') .or. (Method == 'CASSCF')) then
  iMethod = 2
else if ((Method == 'RASSCFSA') .or. (Method == 'CASSCFSA')) then
  iMethod = 2
else if (Method == 'CASPT2') then
  !iMethod = 3
  iMethod = 2 ! tentative
else if (Method == 'MBPT2') then
  iMethod = 4
else if (Method == 'MCPDFT') then
  iMethod = 2
else if (Method == 'MSPDFT') then
  iMethod = 2
end if
!---  read file header  -----------------------------------------------*
call Get_cArray('Seward Title',Header1I,144)
!---  read number of symm. species ------------------------------------*
call get_iScalar('nSym',nSym)
!---  read number of basis functions per symmetry species -------------*
call Get_iArray('nBas',nBas,nSym)
!---  read nuclear potential ------------------------------------------*
!call Get_PotNuc(PotNuc)
call Get_dScalar('PotNuc',Potnuc)
!---  read number of atoms --------------------------------------------*
call Get_iScalar('Unique atoms',nAtoms)
!---  read atom labels ------------------------------------------------*
call Get_cArray('Unique Atom Names',AtLbl,LenIn*nAtoms)
!---  read atom coordinates -------------------------------------------*
call Get_dArray('Unique Coordinates',Coor,3*nAtoms)
!---  read labels of the irreps ---------------------------------------*
call Get_cArray('Irreps',ChIrr,24)
!----------------------------------------------------------------------*
!     Precompute the total sum of variables and size of matrices       *
!----------------------------------------------------------------------*
ntBas = sum(nBas(1:nSym))
ntBsqr = sum(nBas(1:nSym)**2)
ntBtri = 0
do iSym=1,nSym
  ntBtri = ntBtri+nTri_Elem(nBas(iSym))
end do
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine Rd1Int_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c  ********************************************************
c  ** Public-domain library routines used by casvb only. **
c  ********************************************************
c  **********************
c  ** EISPACK ROUTINES **
c  **********************
      subroutine elmhes(nm,n,low,igh,a,int)
c
      integer i,j,m,n,la,nm,igh,kp1,low,mm1,mp1
      real*8 a(nm,n)
      real*8 x,y
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmhes,
c     num. math. 12, 349-368(1968) by martin and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
c
c     given a real general matrix, this subroutine
c     reduces a submatrix situated in rows and columns
c     low through igh to upper hessenberg form by
c     stabilized elementary similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the input matrix.
c
c     on output
c
c        a contains the hessenberg matrix.  the multipliers
c          which were used in the reduction are stored in the
c          remaining triangle under the hessenberg matrix.
c
c        int contains information on the rows and columns
c          interchanged in the reduction.
c          only elements low through igh are used.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      la = igh - 1
      kp1 = low + 1
      if (la .lt. kp1) go to 200
c
      do 180 m = kp1, la
         mm1 = m - 1
         x = 0.0d0
         i = m
c
         do 100 j = m, igh
            if (abs(a(j,mm1)) .le. abs(x)) go to 100
            x = a(j,mm1)
            i = j
  100    continue
c
         int(m) = i
         if (i .eq. m) go to 130
c     .......... interchange rows and columns of a ..........
         do 110 j = mm1, n
            y = a(i,j)
            a(i,j) = a(m,j)
            a(m,j) = y
  110    continue
c
         do 120 j = 1, igh
            y = a(j,i)
            a(j,i) = a(j,m)
            a(j,m) = y
  120    continue
c     .......... end interchange ..........
  130    if (x .eq. 0.0d0) go to 180
         mp1 = m + 1
c
         do 160 i = mp1, igh
            y = a(i,mm1)
            if (y .eq. 0.0d0) go to 160
            y = y / x
            a(i,mm1) = y
c
            do 140 j = m, n
            a(i,j) = a(i,j) - y * a(m,j)
  140       continue
c
            do 150 j = 1, igh
            a(j,m) = a(j,m) + y * a(j,i)
  150       continue
c
  160    continue
c
  180 continue
c
  200 return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine rhodyn(ireturn)
!***********************************************************************
! this routine performs the calls to other subroutines that
! collect all data needed for dynamics and the second part is
! responsible for dynamics itself
!***********************************************************************

use rhodyn_data, only: a_einstein, alpha, amp, basis, CI, CSF2SO, d, decay, density0, densityt, dipole, dipole_basis, DM0, &
                       DM_basis, DTOC, dysamp, dysamp_bas, E, E_SF, E_SO, emiss, flag_decay, flag_diss, flag_dyson, flag_so, &
                       H_CSF, hamiltonian, hamiltoniant, HSOCX, HTOT_CSF, HTOTRE_CSF, i_rasscf, ipglob, ispin, istates, &
                       k_bar_basis, kab_basis, kext, lroots, lrootstot, maxlroots, maxnconf, N, n_freq, nconf, nconftot, ndet, &
                       ndet_tot, Nstate, omega, out_id, p_style, phi, prep_ci, prep_hcsf, prep_id, pulse_vector, rassd_list, &
                       runmode, sigma, sint, SO_CI, taushift, tmp, U_CI, U_CI_compl, V_CSF, V_SO
use rhodyn_utils, only: dashes, mult, sortci, transform
use mh5, only: mh5_close_file, mh5_put_dset
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, auToeV
use definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: i, j, k, lu, maxnum
real(kind=wp), allocatable :: Ham(:,:) ! auxiliary matrix
integer(kind=iwp), external :: iPrintLevel, isFreeUnit

ireturn = 20
ipglob = iPrintLevel(-1) ! MOLCAS_PRINT variable

call StatusLine('RHODYN:','Starting calculation')

! initializitation of default values and printing main parameters
call rhodyn_init()
! reading input file
call read_input()

! calculation of integer parameters needed for allocation
maxnum = maxval(ndet)
maxnconf = maxval(nconf)
maxlroots = maxval(lroots)
nconftot = 0
lrootstot = 0
if (p_style == 'DET') ndet_tot = sum(ndet)  ! Nr of DETs
do i=1,N
  if (flag_so) then
    ! total number of CSF confs and SF roots including SO splitting
    nconftot = nconftot+nconf(i)*ispin(i)
    lrootstot = lrootstot+lroots(i)*ispin(i)
  else
    lrootstot = lrootstot+lroots(i)
    nconftot = nconftot+nconf(i)
  end if
end do

call mma_allocate(dipole,lrootstot,lrootstot,3)
call mma_allocate(dysamp,lrootstot,lrootstot)
call mma_allocate(dysamp_bas,lrootstot,lrootstot)
call mma_allocate(tmp,Nstate,Nstate)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! start from rassf/rassi output
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
if ((runmode /= 2) .and. (runmode /= 4)) then

  n_freq = Nstate*(Nstate-1)/2

  call mma_allocate(H_CSF,maxnconf,maxnconf,N)
  call mma_allocate(CI,maxnconf,maxlroots,N)
  call mma_allocate(E,maxlroots,N)
  call mma_allocate(U_CI,nconftot,lrootstot)
  call mma_allocate(DTOC,maxnum,maxnconf,N)
  call mma_allocate(V_CSF,nconftot,nconftot)
  call mma_allocate(HTOTRE_CSF,nconftot,nconftot)
  call mma_allocate(HTOT_CSF,nconftot,nconftot)
  call mma_allocate(a_einstein,lrootstot,lrootstot)
  call mma_allocate(emiss,n_freq)
  if (flag_so) then
    call mma_allocate(SO_CI,lrootstot,lrootstot)
    call mma_allocate(V_SO,lrootstot,lrootstot)
    call mma_allocate(CSF2SO,nconftot,lrootstot)
    call mma_allocate(E_SO,lrootstot)
  end if

  ! Create PREP file for storage of intermediate data
  call cre_prep()

  ! reading wavefunction expansion from rasscf files
  H_CSF = Zero
  CI = Zero
  ! Determine file names
  ! Expected N rassd files and 1 rassisd file
  call mma_allocate(rassd_list,N)
  do i=1,N
    write(rassd_list(i),'(A5,I1)') 'RASSD',i
    if (ipglob > 2) write(u6,*) 'reading ',rassd_list(i)
    call read_rassd(i)
  end do
  call mma_deallocate(rassd_list)

  if (i_rasscf == 1) then
    ! currently disabled
    ! Diagonalize H(RASSCF) and sort ascending the eigenvalue get the
    ! corresponding eigenvector (CI coefficients) to matrix CI(:,:,N)
    do i=1,N
      if (ipglob > 3) then
        write(u6,sint) 'H(RASSCF) in CSF basis of spin manifold:',i
        call dashes()
        do k=1,15
          write(u6,*) (H_CSF(k,j,i),j=1,15)
        end do
        call dashes()
      end if
      call mma_allocate(Ham,lroots(i),lroots(i))
      Ham(:,:) = H_CSF(1:nconf(i),1:nconf(i),i)
      call sortci(nconf(i),Ham,E(1:nconf(i),i),CI(1:nconf(i),1:lroots(i),i),ipglob)
      call mma_deallocate(Ham)
    end do
  else if ((i_rasscf == 2) .or. (i_rasscf == 3)) then
    ! Construct SF Hamiltonians from CIs and Es for each spin manifold
    do i=1,N
      do j=1,lroots(i)
        H_CSF(j,j,i) = E(j,i)
      end do
      ! H_CSF=CI*diag(E)*CI^T
      call mma_allocate(Ham,nconf(i),lroots(i))
      call mult(CI(1:nconf(i),1:lroots(i),i),H_CSF(1:lroots(i),1:lroots(i),i),Ham)
      call mult(Ham,CI(1:nconf(i),1:lroots(i),i),H_CSF(1:nconf(i),1:nconf(i),i),.false.,.true.)
      call mma_deallocate(Ham)
    end do
  end if

  call mh5_put_dset(prep_ci,CI)
  call mh5_put_dset(prep_hcsf,H_CSF)
  ! construct CI transformation matrix U_CI
  call uci()
  ! obtain pure SOC contribution to Hamiltonian
  call read_rassisd()
  if (flag_so) call get_vsoc()
  call get_hcsf()
  if (flag_so) then
    ! construct transformation matrices between bases
    call soci()
    ! process dipole moment
    call get_dipole()
  end if
  ! construct initial density matrix
  call get_dm0()

  ! close file PREP
  call mh5_close_file(prep_id)

  if (ipglob > 1) then
    call dashes()
    call dashes()
    write(u6,*) 'Preparation finished successfully'
    call dashes()
    call dashes()
  end if

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! start from intermediate preparation file PREP
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
else if (runmode == 2) then
  call mma_allocate(HTOT_CSF,nconftot,nconftot)
  call read_prep()

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! charge migration case
! only SO hamiltonian from RASSI is read
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
else if (runmode == 4) then
  ! only SF/SO basis allowed
  !basis = 'SO'
  call mma_allocate(HSOCX,Nstate,Nstate)
  call mma_allocate(CI,maxnconf,maxlroots,N)
  call mma_allocate(E,maxlroots,N)
  call mma_allocate(U_CI,nconftot,lrootstot)
  if (flag_so) then
    call mma_allocate(E_SO,Nstate)
    call mma_allocate(CSF2SO,nconftot,lrootstot)
  else
    call mma_allocate(E_SF,Nstate)
  end if
  call get_dipole()
  if ((DM_basis == 'CSF_SO') .or. (DM_basis == 'SF') .or. (DM_basis == 'ALL') .or. (DM_basis == 'CSF_SF')) then
    CI = Zero
    ! Determine file names
    ! Expected N rassd files and 1 rassisd file
    call mma_allocate(rassd_list,N)
    do i=1,N
      write(rassd_list(i),'(A5,I1)') 'RASSD',i
      write(u6,*) rassd_list(i)
      ! c
      write(u6,*) 'entering read_rassd: ',i
      call read_rassd(i)
    end do
    call mma_deallocate(rassd_list)
    ! construct CI transformation matrix
    call uci()
    ! V_SOC hamiltonian from RASSI is read (in SF basis)
    call read_rassisd()
    ! construct the transformation matrix CSF2SO from SO to CSF
    if (flag_so) call mult(cmplx(U_CI,kind=wp),SO_CI,CSF2SO)
  else
    ! this is just caution condition to make sure that CM case
    ! was tested with given DM basis
    write(u6,*) 'WARNING!!! Take care of bases in CM case'
    call dashes()
    call abend()
  end if
  !call read_rassisd()
  call get_dm0()
end if

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! dynamics part starts
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
if (runmode /= 3) then
  ! determine preliminary dimension d of propagated matrices
  select case (basis)
    case ('CSF')
      d = nconftot
    case ('SF')
      d = lrootstot
    case ('SO')
      d = lrootstot
  end select
  call mma_allocate(hamiltonian,d,d)
  call mma_allocate(density0,d,d)
  call mma_allocate(dipole_basis,d,d,3)
  call mma_allocate(hamiltoniant,Nstate,Nstate)
  call mma_allocate(densityt,Nstate,Nstate)
  call mma_allocate(decay,Nstate,Nstate)
  call mma_allocate(U_CI_compl,nconftot,lrootstot)

  if (runmode /= 4) then
    ! prepare density and hamiltonian in required basis to propagate with.
    ! here supposed that these matrices are prepared in CSF basis
    call hamdens()
  else
    ! charge migration case
    !hamiltonian = HSOCX ! transform Hamiltonian to SO basis
    if (flag_so) call transform(HSOCX,SO_CI,hamiltonian)
    density0(:,:) = DM0
    dipole_basis(:,:,:) = dipole
    U_CI_compl(:,:) = cmplx(U_CI,kind=wp)
    if (flag_dyson) then
      do i=1,3
        dipole_basis(:,:,i) = dipole_basis(:,:,i)+alpha*dysamp_bas
      end do
    end if
  end if
  ! dynamics will be performed internally using matrices
  ! of dimension d
  if (basis == 'CSF') then
    d = nconftot
  else if ((basis == 'SF') .or. (basis == 'SO')) then
    if (Nstate == lrootstot) then
      d = lrootstot
    else if (Nstate < lrootstot) then
      ! not all states were requested for dynamics
      d = Nstate
      call cut_matrices()
    end if
  end if

  ! construct dissipation operator if requested
  if (flag_diss) then
    call mma_allocate(kab_basis,d,d)
    call mma_allocate(k_bar_basis,d,d)
    if (kext) then
      call k_external()
    else
      call kab()
    end if
    if (ipglob > 3) then
      lu = isFreeUnit(19)
      call molcas_open(lu,'Kab_basis_eV.dat')
      do i=1,d
        write(lu,*) (kab_basis(i,j)*autoev,j=1,d)
      end do
      close(lu)
      lu = isFreeUnit(20)
      call molcas_open(lu,'K_bar_basis_eV.dat')
      do i=1,d
        write(lu,*) (k_bar_basis(i,j)*autoev,j=1,d)
      end do
      close(lu)
    end if
  end if

  if (flag_decay .or. flag_dyson) call prepare_decay()

  call propagate()

end if

! closing and deallocation
call StatusLine('RhoDyn:','Close files and deallocate memory')

call mh5_close_file(out_id)

! allocated in read_input
if (allocated(ndet)) call mma_deallocate(ndet)
if (allocated(nconf)) call mma_deallocate(nconf)
if (allocated(lroots)) call mma_deallocate(lroots)
if (allocated(ispin)) call mma_deallocate(ispin)
if (allocated(istates)) call mma_deallocate(istates)
if (allocated(taushift)) call mma_deallocate(taushift)
if (allocated(amp)) call mma_deallocate(amp)
if (allocated(sigma)) call mma_deallocate(sigma)
if (allocated(omega)) call mma_deallocate(omega)
if (allocated(phi)) call mma_deallocate(phi)
if (allocated(pulse_vector)) call mma_deallocate(pulse_vector)

! allocated in prepare part
if (allocated(V_CSF)) call mma_deallocate(V_CSF)
if (allocated(V_SO)) call mma_deallocate(V_SO)
if (allocated(H_CSF)) call mma_deallocate(H_CSF)
if (allocated(CI)) call mma_deallocate(CI)
if (allocated(DTOC)) call mma_deallocate(DTOC)
if (allocated(E)) call mma_deallocate(E)
if (allocated(U_CI)) call mma_deallocate(U_CI)
if (allocated(SO_CI)) call mma_deallocate(SO_CI)
if (allocated(E_SO)) call mma_deallocate(E_SO)
if (allocated(HTOTRE_CSF)) call mma_deallocate(HTOTRE_CSF)
if (allocated(dipole)) call mma_deallocate(dipole)
if (allocated(dysamp)) call mma_deallocate(dysamp)
if (allocated(dysamp_bas)) call mma_deallocate(dysamp_bas)
if (allocated(HTOT_CSF)) call mma_deallocate(HTOT_CSF)
if (allocated(CSF2SO)) call mma_deallocate(CSF2SO)
if (allocated(tmp)) call mma_deallocate(tmp)
if (allocated(DM0)) call mma_deallocate(DM0)
if (allocated(HSOCX)) call mma_deallocate(HSOCX)

! allocated in dynamics part
if (runmode /= 3) then
  if (allocated(U_CI_compl)) call mma_deallocate(U_CI_compl)
  if (allocated(dipole)) call mma_deallocate(dipole)
  if (allocated(hamiltonian)) call mma_deallocate(hamiltonian)
  if (allocated(hamiltoniant)) call mma_deallocate(hamiltoniant)
  if (allocated(density0)) call mma_deallocate(density0)
  if (allocated(decay)) call mma_deallocate(decay)
  if (allocated(densityt)) call mma_deallocate(densityt)
  if (allocated(dipole_basis)) call mma_deallocate(dipole_basis)
  if (allocated(a_einstein)) call mma_deallocate(a_einstein)
  if (allocated(emiss)) call mma_deallocate(emiss)
  if (allocated(kab_basis)) call mma_deallocate(kab_basis)
  if (allocated(k_bar_basis)) call mma_deallocate(k_bar_basis)
end if

call StatusLine('RhoDyn:','Finished')
ireturn = 0

return

end subroutine rhodyn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE cpcivc(ifile, mxrec, isym, iway,lrec)
*
* Copies the CI-vector between Molcas Rasscf and Lucia enviroment
* IWAY = 1: from Molcas to Lucia (from core to disk unit ifile).
* IWAY = 2: from Lucia to Molcas (from disk unit ifile to core).
*
      implicit real*8 (a-h,o-z)
      dimension lrec(mxrec)
#include "rasscf_lucia.fh"
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "general.fh"
#include "rasscf.fh"
#include "io_util.fh"
*
*   ========================
*      Find nrec and lrec
*   ========================
*
      CALL blkfo_min(isym, nrec, lrec)
      IDISK(IFILE)=0
*
*   =============================
*      Write CI-vector to disc
*   =============================
*
      ioff = 0
      IF (iway.eq.1) then
         NTEST = 0
         IF (NTEST .GE. 100) THEN
            write(6,*) 'Jesper: CI-vector put to disk:'
            DO IREC = 1,NREC
               IF(LREC(IREC) .GE. 0) THEN
                  call wrtmat(work(c_pointer+ioff),1,lrec(irec),
     &               1,lrec(irec))
               ioff = ioff + lrec(irec)
               ENDIF
            ENDDO
         ENDIF

         CALL todscn(work(c_pointer), nrec, lrec,
     &        -1, ifile)
         CALL itods([-1],1,-1,ifile)
*
*   ==============================
*      Read CI-vector from disc
*   ==============================
*
      ELSE
         CALL frmdscn(work(c_pointer), nrec, -1, ifile)
      ENDIF
*
      RETURN
      END
*
      SUBROUTINE cpsivc(ifile, mxrec, vec,lrec)
*
* Copies the Sigma-vector between Molcas Rasscf and Lucia enviroment
*
      implicit real*8 (a-h,o-z)
      dimension lrec(mxrec)
      dimension vec(mxrec)
#include "rasdim.fh"
#include "rasscf_lucia.fh"
#include "general.fh"
#include "io_util.fh"
*
*   ========================
*      Find nrec and lrec
*   ========================
*
      CALL blkfo_min(lsym, nrec, lrec)
      IDISK(IFILE)=0
*
*   =================================
*      Read Sigma-vector from disc
*   =================================
*
      CALL frmdscn(vec, nrec, -1, ifile)
*
      RETURN
      END

      SUBROUTINE CP_ONE_INT(W1,NDIM)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION W1(NDIM)
#include "mxpdim.fh"
#include "orbinp.fh"
#include "WrkSpc.fh"
#include "rasscf_lucia.fh"

      CALL DCOPY_(NTOOB**2,[0.0D0],0,Work(kint1_pointer),1)
      CALL DCOPY_(NDIM,W1,1,Work(kint1_pointer),1)
      CALL DCOPY_(NTOOB**2,Work(kint1_pointer),1,Work(kint1o_pointer),1)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine ddproj_cvb(c,nparm1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "malloc_cvb.fh"
      dimension c(*)

      if(.not.(imethod.eq.4.or.imethod.eq.12))
     >  call orthcvb_cvb(c,nparm1)
      ioffs=nparm1-nprvb+1
      call symtrizcvb_cvb(c(ioffs))
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RdSupS(LuInput,n,iBuff)
!***********************************************************************
!                                                                      *
!     Purpose:                                                         *
!     Read supersymmetry input.                                        *
!                                                                      *
!***********************************************************************

use Definitions, only: iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: LuInput
integer(kind=iwp), intent(out) :: n
integer(kind=iwp), intent(_OUT_) :: iBuff(*)
integer(kind=iwp) :: I, ie(288), iLast, is(288), istatus, iZ, K, l, m, nRepeat
character(len=288) :: Line

!----------------------------------------------------------------------*
!     Start procedure, initialize data counter                         *
!----------------------------------------------------------------------*
n = 0
k = -1
!---  Read next line as a character string  ---------------------------*
do
  read(LuInput,'(A)',iostat=istatus) Line
  if (istatus < 0) call Error(istatus)
  !---  Left adjust line  ---------------------------------------------*
  Line = adjustl(Line)
  if ((Line(1:1) == ' ') .or.(Line(1:1) == '*')) cycle
  !---  Remove multiple intervening blanks  ---------------------------*
  do i=1,287
    nRepeat = 0
    do while ((Line(i:i+1) == '  ') .and. (nRepeat < 288))
      nRepeat = nRepeat+1
      Line(i:287) = Line(i+1:288)
      Line(288:288) = ' '
    end do
  end do
  !---  Insert commas as the only valid separators  -------------------*
  do i=2,287
    if (Line(i:i) == ' ') then
      if ((Line(i-1:i-1) /= ' ') .and. (Line(i-1:i-1) /= ',')) then
        if ((Line(i+1:i+1) /= ' ') .and. (Line(i+1:i+1) /= ',')) Line(i:i) = ','
      end if
    end if
  end do
  !---  Get the last noblank character  -------------------------------*
  iLast = 0
  do i=1,288
    if (Line(i:i) /= ' ') iLast = i
  end do
  !---  Initialize markers  -------------------------------------------*
  is(:) = 0
  ie(:) = 0
  !---  Divide the line into substrings  ------------------------------*
  m = 1
  is(m) = 0
  do i=1,iLast
    if (Line(i:i) == ',') then
      m = m+1
      is(m) = i
    end if
  end do
  m = 0
  do i=1,iLast
    if (Line(i:i) == ',') then
      m = m+1
      ie(m) = i
    end if
  end do
  if (Line(iLast:iLast) /= ',') m = m+1
  ie(m) = iLast+1
  !---  Read by substrings  -------------------------------------------*
  do i=1,m
    l = ie(i)-is(i)
    iz = 0
    if (l > 2) then
      read(Line(is(i)+1:ie(i)-1),*,iostat=istatus) iz
      if (istatus > 0) call Error(istatus)
    else if ((l == 2) .and. (Line(is(i)+1:ie(i)-1) /= ' ')) then
      read(Line(is(i)+1:ie(i)-1),*,iostat=istatus) iz
      if (istatus > 0) call Error(istatus)
    end if
    if (k == -1) then
      k = k+1
      n = iz
    else if (k < n) then
      k = k+1
      iBuff(k) = iz
    end if
  end do
  !---  If necessary continue by next line  ---------------------------*
  if (k >= n) exit
end do
!----------------------------------------------------------------------*
!     Normal termination                                               *
!----------------------------------------------------------------------*
return

contains

!----------------------------------------------------------------------*
!     Error exit                                                       *
!----------------------------------------------------------------------*
subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  write(u6,*)
  if (code < 0) then
    write(u6,'(6X,A)') ' RASSCF was reading supersymmetry input from'
    write(u6,'(6X,A)') 'the input file, when some error occurred,'
    write(u6,'(6X,A)') 'probably end of file.'
  else if (code > 0) then
    write(u6,'(6X,A)') ' RASSCF was reading supersymmetry input from'
    write(u6,'(6X,A)') 'the input file, when some error occurred.'
    write(u6,'(6X,A)') 'Some of the input data seems to be in error.'
  end if
  write(u6,*)
  call Quit_OnUserError()

end subroutine Error

end subroutine RdSupS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Bernd Artur Hess                                 *
*               1999, Roland Lindh                                     *
************************************************************************
      SubRoutine pXpInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the comutation of pXp integrals           *
*                                                                      *
*     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
*             Chemie, University of Bonn, Germany, April 1993          *
*             R. Lindh, modified to molcas 4.1 form, Oct 1999          *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChBas
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables
      Parameter (mComp=200)
      Integer kOper(mComp), kChO(mComp)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = ((ixyz+1)*(ixyz+2))/2
*
      iRout = 220
      iPrint = nPrint(iRout)
*
      iSize=nZeta*nElem(la)*nElem(lb)*nComp
      call dcopy_(iSize,[Zero],0,Final,1)
      call dcopy_(nZeta*nArr,[Zero],0,Array,1)
      nip = 1
      ipB = nip
      nip = nip + nZeta
      ipS1 = nip
      nip = nip + nZeta*nElem(la)*nElem(lb+1)*3*nIC
      If (lb.gt.0) Then
         ipS2 = nip
         nip = nip + nZeta*nElem(la)*nElem(lb-1)*3*nIC
      Else
         ipS2=ipS1
      End If
      ipArr = nip
      mArr=nArr-(nip-1)/nZeta
      If (mArr.lt.0) Then
          Call WarningMessage(2,'pXpInt: mArr<0!')
          Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     nIC: the number of blocks of the symmetry adapted operator pXp
*     nComp: number of components of the operator pXp
*
*     pXp = d/dx X d/dx + d/dy X d/dy + d/dz X d/dz
*
      kIC=nIC*3
      kComp=nComp*3
      kOrdOp = nOrdOp-1
      If (kComp.gt.mComp) Then
         Write (6,*) 'pxpint: kComp.gt.mComp'
         Call Abend()
      End If
C     Write (6,*)
C     Write (6,*) 'pXpInt:**********'
*
      iSym_p1 = IrrFnc(1)
      iSym_p2 = IrrFnc(2)
      iSym_p3 = IrrFnc(4)
C     Write (6,*) 'iSym_p=',iSym_p1,iSym_p2,iSym_p3
      ipar_p1 = iChBas(2)
      ipar_p2 = iChBas(3)
      ipar_p3 = iChBas(4)
C     Write (6,*) 'ipar_p=',ipar_p1,ipar_p2,ipar_p3
      Do iComp = 1, nComp
         jComp1 = (iComp-1)*3 + 1
         jComp2 = (iComp-1)*3 + 2
         jComp3 = (iComp-1)*3 + 3
         iTemp = lOper(iComp)
         ipar  = iChO(iComp)
*
         jTemp1= 0
         jTemp2= 0
         jTemp3= 0
         Do iSym_pXp = 0, nIrrep-1
            If (iAnd(2**iSym_pXp,iTemp).ne.0) Then
               iSym_pX = iEor(iSym_pXp,iSym_p1)
C              Write (6,*) 'iSym_pXp,iSym_pX=',iSym_pXp,iSym_pX
               jTemp1=iOr(jTemp1,2**iSym_pX)
            End If
            If (iAnd(2**iSym_pXp,iTemp).ne.0) Then
               iSym_pX = iEor(iSym_pXp,iSym_p2)
C              Write (6,*) 'iSym_pXp,iSym_pX=',iSym_pXp,iSym_pX
               jTemp2=iOr(jTemp2,2**iSym_pX)
            End If
            If (iAnd(2**iSym_pXp,iTemp).ne.0) Then
               iSym_pX = iEor(iSym_pXp,iSym_p3)
C              Write (6,*) 'iSym_pXp,iSym_pX=',iSym_pXp,iSym_pX
               jTemp3=iOr(jTemp3,2**iSym_pX)
            End If
         End Do
         kOper(jComp1)=jTemp1
         kOper(jComp2)=jTemp2
         kOper(jComp3)=jTemp3
*
         kChO(jComp1)=iEOr(ipar,ipar_p1)
         kChO(jComp2)=iEOr(ipar,ipar_p2)
         kChO(jComp3)=iEOr(ipar,ipar_p3)
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call pXint(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &           Array(ipS1),nZeta,kIC,kComp,la,lb+1,A,RB,iDum,
     &           Array(ipArr),mArr,CCoor,kOrdOp,kOper,kChO,
     &           iStabM,nStabM,
     &           PtChrg,nGrid,iAddPot)
*                                                                      *
************************************************************************
*                                                                      *
      If (lb.gt.0) Then
         Call pXint(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &              Array(ipS2),nZeta,kIC,kComp,la,lb-1,A,RB,iDum,
     &              Array(ipArr),mArr,CCoor,kOrdOp,kOper,kChO,
     &              iStabM,nStabM,
     &              PtChrg,nGrid,iAddPot)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      ipOff = ipB
      Do iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipOff),nAlpha)
         ipOff = ipOff + 1
      End Do
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In pXpint: Beta (expanded)','(5D20.13)',
     *         Array(ipB),nZeta,1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Combine pX integrals to generate the pXp integrals.
*
*     Note that the pX integrals have 3*nComp components.
*
      Call Ass_pXp(Array(ipB),nZeta,Final,la,lb,Array(ipS1),Array(ipS2),
     &             nComp)
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.49) Call RecPrt('pXpInt: Final',' ',Final,
     &                               nZeta,nElem(la)*nElem(lb))
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nHer)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2_Read_Batch(LnPQRSprod,LiPQRSprod,Wrk,lWrk,iBatch,jBatch,kXpqrs)
!
! Jonas Bostrom, Aug 2008. (Generalization and modification of some
!                           stuff in ChoMP2_energy_*)
!
! Purpose: Reads parts of cholesky vectors from disk and
!          multiply them into two integral batches (or one batch if
!          jBatch=iBatch).

use Cholesky, only: nSym, NumCho
use ChoMP2, only: ChoAlg, LnPQprod, lUnit_F, nBatch, nPQ_prod
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LnPQRSprod, LiPQRSprod(8), lWrk, iBatch, jBatch
integer(kind=iwp), intent(out) :: kXpqrs
real(kind=wp), intent(out) :: Wrk(lWrk)
integer(kind=iwp) :: iAdr, iBat, iOpt, iSym, iTyp, iVec, iVec1, jVec, kEnd0, kEnd1, kEnd2, kOff, kRead, kVai, kVbj, kXint, lTot, &
                     lWrk0, lWrk1, lWrk2, MinMem, Nai, nBat, Nbj, nEnrVec(8), NumV, NumVec
real(kind=wp) :: Fac
real(kind=wp), parameter :: X(0:1) = [Zero,One]
character(len=*), parameter :: SecNam = 'ChoMP2_Read_Batch'

! Set number and type of vectors.
! -------------------------------

iTyp = 1
nEnrVec(1:nSym) = NumCho(1:nSym)

! Allocate memory for integrals.
! ------------------------------

kXpqrs = 1
kEnd0 = kXpqrs+LnPQRSprod
lWrk0 = lWrk-kEnd0+1
if (lWrk0 < 1) call SysAbendMsg(SecNam,'insufficient memory','[0]')

! Special code for iBatch=jBatch and ChoAlg=2:
! compute M(ab,ij) = (ai|bj) with i<=j using level 3 BLAS.
! For ChoAlg=1: use strictly lower triangular storage (=>
! level 2 BLAS).
! --------------------------------------------------------

if (ChoAlg == 2) then
  write(u6,*) 'No support for Cholesky algorithm 2'
else

  ! Loop over Cholesky vector symmetries.
  ! -------------------------------------

  do iSym=1,nSym

    Nai = LnPQprod(iSym,iBatch)
    Nbj = LnPQprod(iSym,jBatch)
    if ((Nai > 0) .and. (Nbj > 0) .and. (nEnrVec(iSym) > 0)) then

      ! Allocate memory for reading 1 vector.
      ! -------------------------------------

      kRead = kEnd0
      if (nBatch /= 1) then
        kEnd1 = kRead+nPQ_prod(iSym)
        lWrk1 = lWrk-kEnd1+1
        if (lWrk1 < 1) call SysAbendMsg(SecNam,'insufficient memory','[0.1]')
      else
        kEnd1 = kRead
        lWrk1 = lWrk0
      end if

      ! Setup Cholesky vector batching.
      ! -------------------------------

      if (jBatch == iBatch) then
        MinMem = Nai
      else
        MinMem = Nai+Nbj
      end if
      NumVec = min(lWrk1/MinMem,nEnrVec(iSym))
      if (NumVec < 1) call SysAbendMsg(SecNam,'insufficient memory','[1]')
      nBat = (nEnrVec(iSym)-1)/NumVec+1

      ! Open Cholesky vector file.
      ! --------------------------

      call ChoMP2_OpenF(1,iTyp,iSym)

      ! Cholesky vector batch loop.
      ! ---------------------------

      do iBat=1,nBat

        if (iBat == nBat) then
          NumV = nEnrVec(iSym)-NumVec*(nBat-1)
        else
          NumV = NumVec
        end if
        iVec1 = NumVec*(iBat-1)+1

        kVai = kEnd1
        kVbj = 0
        kEnd2 = 0
        lWrk2 = 0
        if (nBatch /= 1) then
          kVbj = kVai+Nai*NumV
          if (jBatch == iBatch) then
            kEnd2 = kVbj
            kVbj = kVai
          else
            kEnd2 = kVbj+Nbj*NumV
          end if
          lWrk2 = lWrk-kEnd2+1
          if (lWrk2 < 0) call SysAbendMsg(SecNam,'insufficient memory','[2]') ! this would be a bug...
        end if

        ! Read vectors, copy out sub-blocks.
        ! ----------------------------------

        if (nBatch == 1) then

          iOpt = 2
          lTot = nPQ_prod(iSym)*NumV
          iAdr = nPQ_prod(iSym)*(iVec1-1)+1
          call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVai),lTot,iAdr)
        else
          do iVec=1,NumV

            jVec = iVec1+iVec-1
            iOpt = 2
            lTot = nPQ_prod(iSym)
            iAdr = nPQ_prod(iSym)*(jVec-1)+1
            call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kRead),lTot,iAdr)
            kOff = kVai+Nai*(iVec-1)
            call ChoMP2_Srt(Wrk(kRead),Wrk(kOff),1,iSym,iBatch)
            if (jBatch /= iBatch) then
              kOff = kVbj+Nbj*(iVec-1)
              call ChoMP2_Srt(Wrk(kRead),Wrk(kOff),1,iSym,jBatch)
            end if
          end do
        end if

        ! Compute integral contribution.
        ! ------------------------------

        Fac = X(min((iBat-1),1))
        kXint = kXpqrs+LiPQRSprod(iSym)
        if (iBatch == jBatch) then
          call dGeMM_Tri('N','T',Nai,Nai,NumV,One,Wrk(kVai),Nai,Wrk(kVai),Nai,Fac,Wrk(kXint),Nai)
        else
          call DGEMM_('N','T',Nai,Nbj,NumV,One,Wrk(kVai),Nai,Wrk(kVbj),Nbj,Fac,Wrk(kXint),Nai)
        end if
      end do           ! Cholesky vector batch

      ! Close Cholesky vector files.
      ! ----------------------------

      call ChoMP2_OpenF(2,iTyp,iSym)

    end if

  end do               ! iSym

end if

return

end subroutine ChoMP2_Read_Batch

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Reord_Vk(ip_V_k,nProcs,myProc,nV_k,nV_t,nA,jSym,Array)
      Implicit None
      Integer nProcs, myProc, nV_k(*), nV_t(*), nA(*), jSym
      Integer ip_V_k(nProcs)
      Real*8 Array(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
*
      Integer ipScr, ik, ifr, ito, nAV_t, jOff, kOff, iSym
*
      Integer N2
      Parameter (N2 = InfVec_N2)
      Integer InfVec, i, j, k
*********************************************************************
      InfVec(i,j,k)=iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
*********************************************************************
*
      nAV_t=0
      Do iSym=1,jSym
         nAV_t = nAV_t + nA(iSym)*nV_t(iSym)
      End Do
      Call GetMem('Vk_scr','Allo','Real',ipScr,nAV_t)
      Call FZero(Work(ipScr),nAV_t)
*
      jOff=0
      kOff=0
      Do iSym=1,jSym
         Do ik=1,nV_k(iSym)
*
            ifr = ip_V_k(myProc) + jOff + nA(iSym)*(ik-1)
            ito = ipScr + kOff + nA(iSym)*(InfVec(ik,5,iSym)-1)
            call dcopy_(nA(iSym),Array(ifr),1,Work(ito),1)
*
         End Do
         jOff=jOff+nA(iSym)*nV_k(iSym)
         kOff=kOff+nA(iSym)*nV_t(iSym)
      End Do
*
      call dcopy_(nAV_t,Work(ipScr),1,Array(ip_V_k(1)),1)
      Call GADGOP(Array(ip_V_k(1)),nAV_t,'+')
*
      Call GetMem('Vk_scr','Free','Real',ipScr,nAV_t)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      logical function up2date_cvb(chr)
      implicit real*8 (a-h,o-z)
      character*(*) chr
#include "make_cvb.fh"

      iobj=0
      do 100 i=1,nobj
      if(charobj(i).eq.chr)iobj=i
100   continue
      if(iobj.eq.0)then
        write(6,*)' Make object not found :',chr
        call abend_cvb()
      endif
      up2date_cvb=up2date(iobj)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Schur_Skew
!
!> @brief Compute the real Schur decomposition of an antisymmetric (skew-symmetric) matrix
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Computes the real Schur decomposition of an antisymmetric real matrix \f$ A \f$.
!> The real Schur decomposition satisfies \f$ A = Z E Z^T \f$ with \f$ Z \f$ a real orthogonal matrix
!> and \f$ E \f$ an antisymmetric real, block-diagonal matrix, with \f$ 2\times 2 \f$ or \f$ 1\times 1 \f$
!> diagonal blocks.
!>
!> Only the lower triangle of \f$ A \f$ is referenced. On output, \p A contains the \f$ Z \f$ matrix,
!> and \p E contains the essential elements of \f$ E \f$, which are pairs of opposite sign
!> for the \f$ 2\times 2 \f$, or zero for the \f$ 1\times 1 \f$ blocks.
!>
!> @param[in]     N    Size of the square matrix
!> @param[in,out] A    Antisymmetric real matrix, it is replaced by its real Schur vectors
!> @param[out]    E    Vector with the real Schur form of \p A
!> @param[out]    ierr Return code (0 if success)
!***********************************************************************

subroutine schur_skew(n,A,E,ierr)
! This code is an adaptation of the code published in:
!   R. C. Ward, L. J. Gray
!   Eigensystem computation for skew-symmetric matrices and a class of symmetric matrices
!   Technical report ORNL/CSD-9 TRN: 76-016851, 1976. Oak Ridge National Laboratory, Tennessee (USA)
!   doi:10.2172/7350249

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: A(n,n)
real(kind=wp), intent(out) :: E(n)
integer(kind=iwp), intent(out) :: ierr
integer(kind=iwp) :: i, its, j, k, l, l0, l0m1, lm1, ls, m, m0, mm1
real(kind=wp) :: c, f, g, h, p, q, r, s, sc, test
logical(kind=iwp) :: break, isodd, skip
real(kind=wp), allocatable :: Z(:,:)
integer(kind=iwp), parameter :: maxit = 30
real(kind=wp), parameter :: eps = epsilon(eps)
real(kind=r8), external :: ddot_

ierr = 0

! Reduce to tridiagonal

do i=n,2,-1
  l = i-1
  ! normalize row
  sc = Zero
  do j=1,l
    sc = sc+abs(A(i,j))
  end do
  if (sc < eps) then
    E(i) = Zero
    A(i,i) = Zero
    cycle
  end if
  ! compute elements of U vector
  A(i,1:l) = A(i,1:l)/sc
  ! sum( A(i,1:l) * A(i,1:l) )
  h = ddot_(l,A(i,1),n,A(i,1),n)
  f = A(i,l)
  g = -sign(sqrt(h),f)
  h = h-f*g
  E(i) = sc*g
  A(i,l) = f-g
  A(i,i) = sqrt(h)
  if (l > 1) then
    ! compute elements of A*U/h
    h = One/h
    do j=1,l
      ! sum( A(j,j+1:l) * A(i,j+1:l) ) - sum( A(j+1:l,j) * A(i,j+1:l) )
      E(j) = (ddot_(j-1,A(j,1),n,A(i,1),n)-ddot_(l-j,A(j+1:l,j),1,A(i,j+1),n))*h
    end do
    ! compute reduced A
    do j=2,l
      A(j,1:j-1) = A(j,1:j-1)+A(i,j)*E(1:j-1)-E(j)*A(i,1:j-1)
    end do
  end if
  A(i,1:i) = sc*A(i,1:i)
end do
! enforce conventional value
E(1) = Zero

! Diagonalize skew-symmetric tridiagonal matrix

! place identity matrix in Z
allocate(Z(n,n))
Z(:,:) = Zero
do i=1,n
  Z(i,i) = One
end do

m = n
mm1 = m-1
E(1) = Zero
its = 0

outer: do while (m >= 2)
  m0 = m

  ! search for next submatrix to solve (matrix splitting)
  f = Zero
  break = .false.
  do i=1,mm1
    j = m-i
    g = abs(E(j+1))
    if (g <= eps*(abs(E(j))+f)) then
      break = .true.
      exit
    end if
    f = g
  end do
  if (.not. break) j = 0

  l0 = j+2
  l0m1 = j+1
  if (l0m1 == m) then
    ! iteration converged to one zero eigenvalue
    E(m) = Zero
    m = mm1
    its = 0
    mm1 = m-1
    cycle outer
  end if

  ! place correct sign on identity diagonals
  do i=l0m1,m,4
    Z(i,i) = -Z(i,i)
    if (i+3 > m) exit
    Z(i+3,i+3) = -Z(i+3,i+3)
  end do

  if (l0 == m) then
    ! iteration converged to eigenvalue pair
    E(mm1) = E(m)
    E(m) = -E(m)
    m = m-2
    its = 0
    mm1 = m-1
    cycle outer
  end if

  isodd = mod(m-l0,2) == 1
  l = l0
  if (isodd) then

    ! find zero eigenvalue of odd ordered submatrices
    c = Zero
    s = -One
    do i=l0,mm1,2
      k = mm1+l0-i
      q = -s*E(k+1)
      E(k+1) = c*E(k+1)
      if (abs(E(k)) > abs(q)) then
        s = q/E(k)
        r = sqrt(One+s**2)
        E(k) = E(k)*r
        c = One/r
        s = s*c
      else
        c = E(k)/q
        r = sqrt(c**2+One)
        E(k) = q*r
        s = One/r
        c = c*s
      end if

      ! accumulate transformations for eigenvectors
      Z(k-1,m) = -s*Z(k-1,k-1)
      Z(k-1,k-1) = c*Z(k-1,k-1)
      Z(k+1:m:2,k-1) = s*Z(k+1:m:2,m)
      Z(k+1:m:2,m) = c*Z(k+1:m:2,m)

    end do
    m = mm1
    mm1 = m-1
    if (l0 == m) then
      ! iteration converged to eigenvalue pair
      E(mm1) = E(m)
      E(m) = -E(m)
      m = m-2
      its = 0
      mm1 = m-1
      cycle outer
    end if

  end if

  skip = .not. isodd
  do
    if (.not. skip) then
      ! check for convergence or small subdiagonal element
      break = .false.
      do i=l0,mm1,2
        k = mm1+l0-i
        l = k+1
        test = eps*(abs(E(l))+abs(E(k-1)))
        if (abs(E(k)) <= test) then
          break = .true.
          exit
        end if
      end do
      if (.not. break) l = l0
      if (l == m) then
        ! iteration converged to eigenvalue pair
        do
          E(mm1) = E(m)
          E(m) = -E(m)
          m = m-2
          mm1 = m-1
          if (m /= l0) exit
        end do
        its = 0
        if (m > l0) cycle
        cycle outer
      end if
    end if
    skip = .false.

    ! form shift
    its = its+1
    if (its > maxit) then
      ! error exit
      ierr = m
      exit outer
    end if
    f = E(m-3)
    g = E(m-2)
    c = E(mm1)
    s = E(m)
    p = ((c-f)*(c+f)+(s-g)*(s+g))/(Two*g*c)
    r = sqrt(p*p+One)
    q = (g/(p+sign(r,p)))-c
    f = E(l)
    lm1 = l-1
    E(lm1) = ((f-s)*(f+s)+c*q)/f

    ! perform one implicit QR iteration on Cholesky factor
    ls = l0m1
    c = One
    s = One
    do i=l,mm1
      q = s*E(i+1)
      E(i+1) = c*E(i+1)
      if (abs(E(i-1)) > abs(q)) then
        s = q/E(i-1)
        r = sqrt(One+s**2)
        E(i-1) = E(i-1)*r
        c = One/r
        s = s*c
      else
        c = E(i-1)/q
        r = sqrt(c**2+One)
        E(i-1) = q*r
        s = One/r
        c = c*s
      end if
      f = E(i+1)
      E(i+1) = -s*E(i)+c*f
      E(i) = c*E(i)+s*f

      ! accumulate transformations for eigenvectors
      do j=ls,m0,2
        f = Z(j,i+1)
        Z(j,i+1) = -s*Z(j,i-1)+c*f
        Z(j,i-1) = c*Z(j,i-1)+s*f
      end do
      if (ls == l0m1) then
        ls = l0
      else
        ls = l0m1
      end if
    end do
    E(lm1) = Zero
  end do

end do outer

! Back-transform to full matrix

do i=2,n
  if (A(i,i) == Zero) cycle
  do j=1,n
    ! sum( A(i,1:i-1) * Z(1:i-1,j) ) / A(i,i)**2
    s = (ddot_(i-1,A(i,1),n,Z(1:i-1,j),1)/A(i,i))/A(i,i)
    Z(1:i-1,j) = Z(1:i-1,j)-s*A(i,1:i-1)
  end do
end do
A(:,:) = Z

deallocate(Z)

return

end subroutine schur_skew

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine PSOAO0_h(nSO,nMemab,nMemcd,MemPrm,MemMax,iAnga,iCmpa,iBas,iBsInc,jBas,jBsInc,kBas,kBsInc,lBas,lBsInc,iPrim,iPrInc, &
                    jPrim,jPrInc,kPrim,kPrInc,lPrim,lPrInc,ipMem1,ipMem2,ipMem3,ipMem4,Mem1,Mem2,Mem3,Mem4,Mend)
!***********************************************************************
!                                                                      *
!  Object: to partion the SO and AO block. It will go to some length   *
!          before it will start and break up the SO block. This will   *
!          reduce the total flop count. However, as we are breaking up *
!          the AO block this will affect the vectorization. Hence, at  *
!          some point it will actually be better to recompute the      *
!          primitives.                                                 *
!          Current stratergy:                                          *
!          1. Start reducing the length of the primitives in the order *
!             lPrim,jPrim.                                             *
!          2. Reduce the size of the SO block by reducing the number of*
!             basis functions in the order lBas, jBas.                 *
!          3. Terminate run telling job max and min of additional      *
!             memory needed to perform the calculation.                *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!***********************************************************************

use Index_Functions, only: nTri3_Elem1, nTri_Elem1
use Gateway_global, only: iWROpt
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp, u6, RtoI

implicit none
integer(kind=iwp), intent(in) :: nSO, nMemab, nMemcd, MemPrm, MemMax, iAnga(4), iCmpa(4), iBas, jBas, kBas, lBas, iPrim, jPrim, &
                                 kPrim, lPrim, ipMem1
integer(kind=iwp), intent(out) :: iBsInc, jBsInc, kBsInc, lBsInc, iPrInc, jPrInc, kPrInc, lPrInc, ipMem2, ipMem3, ipMem4, Mem1, &
                                  Mem2, Mem3, Mem4, Mend
#include "lCache.fh"
#include "pstat.fh"
#include "warnings.h"
integer(kind=iwp) :: iCmp, iFact, IncVec, jCmp, kCmp, kSOInt, la, lb, lc, lCmp, ld, lSize, mabcd, mabMax, mabMin, mcdMax, mcdMin, &
                     Mem0, MemAux, MemCon, MemPr, MemSp1, MemSp2, MemTr1, MemTr2, MemTr3, nA2, nA3, nCache_, nVec1, nVec2
logical(kind=iwp) :: Fail, QiBas, QjBas, QjPrim, QkBas, QlBas, QlPrim

!iQ = 1
la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)
iCmp = iCmpa(1)
jCmp = iCmpa(2)
kCmp = iCmpa(3)
lCmp = iCmpa(4)
iTotal = iTotal+1
mabMin = nTri3_Elem1(max(la,lb)-1)
mabMax = nTri3_Elem1(la+lb)-1
mcdMin = nTri3_Elem1(max(lc,ld)-1)
mcdMax = nTri3_Elem1(lc+ld)-1
mabcd = (mabMax-mabMin+1)*(mcdMax-mcdMin+1)

iBsInc = iBas
jBsInc = jBas
kBsInc = kBas
lBsInc = lBas
iPrInc = iPrim
jPrInc = jPrim
kPrInc = kPrim
lPrInc = lPrim
iFact = 1
if (iWropt == 0) iFact = 4/RtoI+3

do
  QjPrim = .false.
  QlPrim = .true.
  QiBas = .false.
  QjBas = .false.
  QkBas = .false.
  QlBas = .false.
  Mem0 = MemMax

  ! Work1
  ! Memory for SO block. If petite list format is used there
  ! will be no SO block.

  kSOInt = nSO*iBsInc*jBsInc*kBsInc*lBsInc
  Mem1 = iFact*kSOInt
  if (Mem1 == 0) Mem1 = 1
  if (nIrrep == 1) Mem1 = 1+(iFact-1)*iCmp*jCmp*kCmp*lCmp*iBsInc*jBsInc*kBsInc*lBsInc
  if (Mem1+1 > Mem0) then
    MaxReq = max(MaxReq,Mem1+1-Mem0)
    QjPrim = .false.
    QlPrim = .false.
    QiBas = .false.
    QjBas = .false.
    QkBas = .false.
    QlBas = .true.
    call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                MaxReq,Fail)
    if (Fail) then
      write(u6,*) ' Allocation failed for Work1'
      write(u6,*) Mem0,Mem1
      write(u6,*) iPrInc,iBsInc,kPrInc,kBsInc,jPrInc,jBsInc,lPrInc,lBsInc
      call Quit(_RC_MEMORY_ERROR_)
    end if
    cycle
  end if
  !write(u6,*) ' After Mem1',iPrInc,iBsInc,kPrInc,kBsInc,jPrInc,jBsInc,lPrInc,lBsInc
  Mem0 = Mem0-Mem1-1

  ! Work2
  ! MemPr  : Scratch for Rys
  ! MemCon : Scratch for the contraction step
  ! MemTr1 : Scratch for the 1st application of the transfer eqn.
  ! MemTr2 : Scratch for the 2nd application of the transfer eqn.

  ! Work4 (this is overlayed with Work2 and is placed at the top)
  ! MemAux : Auxiliary memory for partial contraction.

  ! Work5 (this is overlayed with Work2 and is placed at the top)

  MemPr = MemPrm*iPrInc*jPrInc*kPrInc*lPrInc
  MemCon = mabcd*max(iPrInc*jPrInc*kPrInc*lPrInc,iBsInc*jBsInc*kBsInc*lBsInc)
  if ((jPrInc /= jPrim) .or. (lPrInc /= lPrim)) then
    MemAux = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
  else
    MemAux = 0
  end if
  MemTr1 = (mabMax-mabMin+1)*nMemcd*iBsInc*jBsInc*kBsInc*lBsInc
  MemTr2 = kCmp*lCmp*nMemab*iBsInc*jBsInc*kBsInc*lBsInc
  Mem2 = max(MemPr+MemAux,MemCon+MemAux,MemTr1,MemTr2)
  if (Mem2+1 > Mem0) then
    MaxReq = max(MaxReq,Mem2+1-Mem0)
    call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                MaxReq,Fail)
    if (Fail) then
      write(u6,*) ' Allocation failed for Work2'
      write(u6,*) Mem0,Mem2,MemPr+MemAux,MemCon+MemAux,MemTr1,MemTr2
      write(u6,*) iPrInc,iBsInc,kPrInc,kBsInc,jPrInc,jBsInc,lPrInc,lBsInc
      call Quit(_RC_MEMORY_ERROR_)
    end if
    cycle
  end if
  if ((jPrInc /= jPrim) .or. (lPrInc /= lPrim)) then
    Mem4 = MemAux
  else
    Mem4 = Mem2
  end if
  !write(u6,*) ' After Mem2',jPrInc,jBsInc,lPrInc,lBsInc
  Mem0 = Mem0-Mem2-1

  ! Work3
  ! MemCon : Scratch for the contraction step, and transpose after the contraction step
  ! MemSp1 : Scratch for the 1st transformation from cartesian to spherical harmonics.
  ! MemSp2 : Scratch for the 2nd transformation from cartesian to spherical harmonics.
  ! MemTr3 : Scratch for transpose in tnsctl

  nCache_ = (3*lCache)/4-iPrim*iBas-jPrim*jBas
  lSize = iPrInc*jPrInc+max(jPrInc*iBsInc,iPrInc*jBsInc)
  nVec1 = kPrInc*lPrInc*mabcd
  IncVec = min(max(1,nCache_/lSize),nVec1)
  nA2 = max(jPrInc*iBsInc,iPrInc*jBsInc)*IncVec
  nA3 = iBsInc*jBsInc*nVec1
  MemCon = max(mabcd*iBsInc*jBsInc*kBsInc*lBsInc,nA2+nA3)

  nCache_ = (3*lCache)/4-kPrim*kBas-lPrim*lBas
  lSize = kPrInc*lPrInc+max(lPrInc*kBsInc,kPrInc*lBsInc)
  nVec2 = iBsInc*jBsInc*mabcd
  IncVec = min(max(1,nCache_/lSize),nVec2)
  nA2 = max(lPrInc*kBsInc,kPrInc*lBsInc)*IncVec
  !nA3 = kBsInc*lBsInc*nVec2
  MemCon = max(MemCon,nA3+nA2)

  !*********************************************************************

  nCache_ = (3*lCache)/4-kPrim*kBas-lPrim*lBas
  lSize = kPrInc*lPrInc+max(lPrInc*kBsInc,kPrInc*lBsInc)
  nVec1 = iPrInc*jPrInc*mabcd
  IncVec = min(max(1,nCache_/lSize),nVec1)
  nA2 = IncVec*max(lPrInc*kBsInc,kPrInc*lBsInc)
  nA3 = kBsInc*lBsInc*nVec1
  MemCon = max(MemCon,nA3+nA2)

  nCache_ = (3*lCache)/4-iPrim*iBas-jPrim*jBas
  lSize = iPrInc*jPrInc+max(jPrInc*iBsInc,iPrInc*jBsInc)
  nVec2 = kBsInc*lBsInc*mabcd
  IncVec = min(max(1,nCache_/lSize),nVec2)
  nA2 = IncVec*max(jPrInc*iBsInc,iPrInc*jBsInc)
  !nA3 = iBsInc*jBsInc*nVec2
  MemCon = max(MemCon,nA3+nA2)

  MemSp1 = (mabMax-mabMin+1)*lCmp*nTri_Elem1(lc)*iBsInc*jBsInc*kBsInc*lBsInc
  MemSp2 = lCmp*kCmp*jCmp*nTri_Elem1(la)*iBsInc*jBsInc*kBsInc*lBsInc
  MemTr3 = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
  Mem3 = max(MemCon,MemSp1,MemSp2,MemTr3)
  if (Mem3+1 <= Mem0) exit
  MaxReq = max(MaxReq,Mem3+1-Mem0)
  call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
              MaxReq,Fail)
  if (Fail) then
    write(u6,*) ' Allocation failed for Work3'
    write(u6,*) Mem0,Mem3,MemCon,MemSp1,MemSp2
    write(u6,*) iPrInc,iBsInc,kPrInc,kBsInc,jPrInc,jBsInc,lPrInc,lBsInc
    call Quit(_RC_MEMORY_ERROR_)
  end if
end do
Mem0 = Mem0-Mem3-1
MinXtr = min(MinXtr,Mem0)

ipMem2 = ipMem1+Mem1
ipMem3 = ipMem2+Mem2
ipMem4 = ipMem2+Mem2-Mem4
Mend = 0

r1 = r1+real(iBsInc,kind=wp)/real(iBas,kind=wp)
r2 = r2+real(jBsInc,kind=wp)/real(jBas,kind=wp)
r3 = r3+real(kBsInc,kind=wp)/real(kBas,kind=wp)
r4 = r4+real(lBsInc,kind=wp)/real(lBas,kind=wp)
q1 = q1+real(iPrInc,kind=wp)/real(iPrim,kind=wp)
q2 = q2+real(jPrInc,kind=wp)/real(jPrim,kind=wp)
q3 = q3+real(kPrInc,kind=wp)/real(kPrim,kind=wp)
q4 = q4+real(lPrInc,kind=wp)/real(lPrim,kind=wp)

return

end subroutine PSOAO0_h

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Giovanni Ghigo                              *
!***********************************************************************

subroutine ChoMP2_TwoEl(iBatch,numV,LUINTM,iAddrIAD2M,iSymI,iSymJ,iSymA,iSymB)
!***********************************************************************
! Author :  Giovanni Ghigo                                             *
!           Lund University, Sweden                                    *
! Written:  October-November 2004                                      *
! Modified for Cholesky-MP2 May 2005                                   *
!***********************************************************************

use Cho_Tra, only: IAD2M, nOsh, nSsh, nSym, SubBlocks
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iBatch, numV, LUINTM, iSymI, iSymJ, iSymA, iSymB
integer(kind=iwp), intent(inout) :: iAddrIAD2M
integer(kind=iwp) :: iAddrIAD2Mij, iEndJ, iI, iIJAB, iJ, nA, nB, nN_AB, nN_Ex1, nN_Ex2, nN_IJ, nSymP
real(kind=wp), allocatable :: AddEx1(:), AddEx2(:), AddEx2t(:)

nSymP = (nSym**2+nSym)/2
call LenInt(iSymI,iSymJ,iSymA,iSymB,nN_IJ,nN_AB,nN_Ex1,nN_Ex2)

!**** START GENERATION of EXCHANGE-1 INTEGRALS *************************
if (nN_IJ*nN_Ex1 > 0) then
  iIJAB = ((iSymI**2-iSymI)/2+iSymJ-1)*nSymP+(iSymA**2-iSymA)/2+iSymB
  SubBlocks(3,3) = .true.
  if (iBatch == 1) then
    IAD2M(2,iIJAB) = iAddrIAD2M
  else
    iAddrIAD2M = IAD2M(2,iIJAB)
  end if
  ! Start Loop on i, j
  iAddrIAD2Mij = iAddrIAD2M
  do iI=1,nOsh(iSymI)
    if (iSymI == iSymJ) then
      iEndJ = iI
    else
      iEndJ = nOsh(iSymJ)
    end if
    do iJ=1,iEndJ
      call mma_allocate(AddEx1,nN_Ex1,Label='AddEx1')
      if (iBatch > 1) then
        ! Reload Int
        call dDaFile(LUINTM,2,AddEx1,nN_Ex1,iAddrIAD2Mij)
        iAddrIAD2Mij = iAddrIAD2Mij-nN_Ex1
      else
        AddEx1(:) = Zero
      end if
      call ChoMP2_GenE(iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddEx1,nN_Ex1)
      call dDaFile(LUINTM,1,AddEx1,nN_Ex1,iAddrIAD2Mij)
      call mma_deallocate(AddEx1)
    end do
  end do
  ! End Loop on i, j
  iAddrIAD2M = iAddrIAD2Mij
end if
!**** END GENERATION of EXCHANGE-1 INTEGRALS ***************************

!**** START GENERATION of EXCHANGE-2 INTEGRALS *************************
if (nN_IJ*nN_Ex2 > 0) then
  iIJAB = ((iSymI**2-iSymI)/2+iSymJ-1)*nSymP+(iSymB**2-iSymB)/2+iSymA
  SubBlocks(3,3) = .true.
  if (iBatch == 1) then
    IAD2M(3,iIJAB) = iAddrIAD2M
  else
    iAddrIAD2M = IAD2M(3,iIJAB)
  end if
  ! Start Loop on i, j
  iAddrIAD2Mij = iAddrIAD2M
  do iI=1,nOsh(iSymI)
    if (iSymI == iSymJ) then
      iEndJ = iI
    else
      iEndJ = nOsh(iSymJ)
    end if
    do iJ=1,iEndJ
      nA = nSsh(iSymA)
      nB = nSsh(iSymB)
      call mma_allocate(AddEx2,nN_Ex2,Label='AddEx2')
      call mma_allocate(AddEx2t,nN_Ex2,Label='AddEx2t')
      if (iBatch > 1) then
        ! Reload Int
        call dDaFile(LUINTM,2,AddEx2,nN_Ex2,iAddrIAD2Mij)
        iAddrIAD2Mij = iAddrIAD2Mij-nN_Ex2
        call Trnsps(nA,nB,AddEx2,AddEx2t)
      else
        AddEx2t(:) = Zero
      end if
      call ChoMP2_GenE(iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddEx2t,nN_Ex2)
      call Trnsps(nB,nA,AddEx2t,AddEx2)
      call dDaFile(LUINTM,1,AddEx2,nN_Ex2,iAddrIAD2Mij)
      call mma_deallocate(AddEx2t)
      call mma_deallocate(AddEx2)
    end do
  end do
  ! End Loop on i, j
  iAddrIAD2M = iAddrIAD2Mij
end if
!**** END GENERATION of EXCHANGE-2 INTEGRALS ***************************

return

end subroutine ChoMP2_TwoEl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SDCMRF_MCLR(CSD,CCM,IWAY,IATP,IBTP,IASM,IBSM,NA,NB,
     &                  IDC,PS,PL,ISGVST,LDET,LCOMB)
*
* Change a block of coefficients bwtween combination format and
* Slater determinant format
*
*     IWAY = 1 : SD => Combinations
*     IWAY = 2 : Combinations => SD
*
* Input
* =====
* CSD : Block in determinant form
* CCM : Block in combination  form
* IWAY : as above
* IATP,IBTP : type of alpha- and beta- string
* NA,NB : Number of alpha- and beta- strings
* IDC  : Combination type
* PS   : Spin combination sign
* PL   : Ml   combination sign
* ISGVST : Ml reflection of strings
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CSD(*),CCM(*),ISGVST(*)
*
      SQRT2  = SQRT(2.0D0)
      SQRT2I = 1.0D0/SQRT2
*
*. Is combination array packed ?
*
      IPACK = 0
      FACTOR = 1.0D0
*
      IF((IDC.EQ.2.OR.IDC.EQ.4).AND.IASM.EQ.IBSM) THEN
         SIGN = PS
         FACTOR = SQRT2
         IF(IATP.EQ.IBTP) IPACK = 1
      ELSE IF( IDC.EQ.4.AND.IASM.EQ.ISGVST(IBSM)) THEN
        IF(IATP.EQ.IBTP) IPACK = 1
        SIGN = PS*PL
        FACTOR = 2.0D0
      END IF
*
      LDET = NA * NB
      IF( IPACK.EQ.0) THEN
        LCOMB = LDET
      ELSE
        LCOMB = NA*(NA+1)/2
      END IF
      IF(IDC.EQ.4.AND.IPACK.EQ.0) FACTOR = SQRT2
      IF(IWAY.EQ.2) FACTOR = 1.0D0/FACTOR
*
*. SD => combination transformation
*
      IF(IWAY .EQ. 1 ) THEN
        IF(IPACK.EQ.1) THEN
*. Pack to triangular form
          CALL TRIPK2(CSD,CCM,1,NA,NA,SIGN)
C              TRIPK2(AUTPAK,APAK,IWAY,MATDIM,NDIM,SIGN)
        ELSE
          CALL DCOPY_(NA*NB,CSD,1,CCM,1)
        END IF
*. Scale
        IF(FACTOR.NE.1.0D0) THEN
          CALL DSCAL_(LCOMB,FACTOR,CCM,1)
          IF(IPACK.EQ.1 ) THEN
            CALL SCLDIA(CCM,SQRT2I,NA,1)
          END IF
        END IF
      END IF
*
*. Combination => SD transformation
*
      IF(IWAY.EQ.2) THEN
        IF(IPACK.EQ.1) THEN
*. Unpack from triangular form
          CALL TRIPK2(CSD,CCM,2,NA,NA,SIGN)
        ELSE
           CALL DCOPY_(NA*NB,CCM,1,CSD,1)
        END IF
*. Scale
        IF(FACTOR.NE.1.0D0) THEN
          CALL DSCAL_(LDET,FACTOR,CSD,1)
          IF(IPACK.EQ.1) THEN
             CALL SCLDIA(CSD,SQRT2,NA,0)
          END IF
        END IF
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine DELTAB(NREF,IOCR,L0,L1,L2,L3,INTNUM,LV,IFCORE,ICOR,NONE_,JONE,K00,K11,K22,K33,L00,L11,L22,L33)

use guga_global, only: IB, ILIM, IV0, IWAY, J2, K0, K1, K2, K3, LN, MXVERT, NIORB, NSM
use stdalloc, only: mma_allocate, mma_deallocate
use Symmetry_Info, only: Mul
use Definitions, only: iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NREF, IOCR(*), INTNUM, LV, IFCORE, ICOR(*), NONE_, JONE(*), K00(*), K11(*), K22(*), K33(*), &
                                 L00(*), L11(*), L22(*), L33(*)
integer(kind=iwp), intent(_OUT_) :: L0(*), L1(*), L2(*), L3(*)
integer(kind=iwp) :: I, IBS, IDIF, IEL, IIJ, IJJ, INHOLE, IOC(55), IPART, IREF, IRR, ISP(55), ISTA, JHOLE, JJ1, JPART, K, KM, KM1, &
                     LNS, LSYM, NCORR, NSJ
logical(kind=iwp) :: first, last
integer(kind=iwp), allocatable :: K0M(:), K1M(:), K2M(:), K3M(:), L0M(:), L1M(:), L2M(:), L3M(:)

K0(:) = 0
K1(:) = 0
K2(:) = 0
K3(:) = 0
do I=1,4*MXVERT
  L0(I) = 0
  L1(I) = 0
  L2(I) = 0
  L3(I) = 0
end do
IBS = 0
IEL = 2
LSYM = 1
LNS = NIORB+LV+1
IRR = 0
do I=LNS,LN
  IRR = IRR+1
  if (IOCR(IRR) == 1) LSYM = Mul(LSYM,NSM(I))
end do
call mma_allocate(K0M,MXVERT,label='K0M')
call mma_allocate(K1M,MXVERT,label='K1M')
call mma_allocate(K2M,MXVERT,label='K2M')
call mma_allocate(K3M,MXVERT,label='K3M')
call mma_allocate(L0M,MXVERT,label='L0M')
call mma_allocate(L1M,MXVERT,label='L1M')
call mma_allocate(L2M,MXVERT,label='L2M')
call mma_allocate(L3M,MXVERT,label='L3M')
do IIJ=1,ILIM
  ISTA = (IIJ-1)*MXVERT
  K0M(1:IV0) = 0
  K1M(1:IV0) = 0
  K2M(1:IV0) = 0
  K3M(1:IV0) = 0
  L0M(1:IV0) = 0
  L1M(1:IV0) = 0
  L2M(1:IV0) = 0
  L3M(1:IV0) = 0
  IJJ = IV0+1-IIJ
  KM = 1
  J2(KM) = IJJ
  first = .true.
  do
    if (first) then
      KM = KM+1
      IWAY(KM) = 0
      first = .false.
    end if
    KM1 = KM-1
    if ((L00(J2(KM1)) /= 0) .and. (IWAY(KM) < 1)) then
      J2(KM) = L00(J2(KM1))
      IWAY(KM) = 1
      IOC(KM1) = 0
      ISP(KM1) = 0
    else if ((L11(J2(KM1)) /= 0) .and. (IWAY(KM) < 2)) then
      J2(KM) = L11(J2(KM1))
      IWAY(KM) = 2
      IOC(KM1) = 1
      ISP(KM1) = 1
    else if ((L22(J2(KM1)) /= 0) .and. (IWAY(KM) < 3)) then
      J2(KM) = L22(J2(KM1))
      IWAY(KM) = 3
      IOC(KM1) = 1
      ISP(KM1) = 2
    else if ((L33(J2(KM1)) /= 0) .and. (IWAY(KM) < 4)) then
      J2(KM) = L33(J2(KM1))
      IWAY(KM) = 4
      IOC(KM1) = 2
      ISP(KM1) = 3
    else
      KM = KM-1
      if (KM == 1) then
        K0(ISTA+1:ISTA+IV0) = K0M(1:IV0)
        K1(ISTA+1:ISTA+IV0) = K1M(1:IV0)
        K2(ISTA+1:ISTA+IV0) = K2M(1:IV0)
        K3(ISTA+1:ISTA+IV0) = K3M(1:IV0)
        L0(ISTA+1:ISTA+IV0) = L0M(1:IV0)
        L1(ISTA+1:ISTA+IV0) = L1M(1:IV0)
        L2(ISTA+1:ISTA+IV0) = L2M(1:IV0)
        L3(ISTA+1:ISTA+IV0) = L3M(1:IV0)
        exit
      end if
      cycle
    end if
    if (KM1 == NIORB+LV) IBS = IB(J2(KM))
    if (KM /= LN+1) then
      first = .true.
      cycle
    end if
    NSJ = 1
    INHOLE = 0
    do I=1,LN
      if (IOC(I) == 1) NSJ = Mul(NSJ,NSM(I))
      if ((I <= NIORB+LV) .and. (I > LV)) INHOLE = INHOLE+2-IOC(I)
    end do
    ! STRIKE OUT INTERNAL CONFIGURATIONS
    IPART = 0
    if (IIJ > 1) IPART = IPART+1
    if (IIJ > 2) IPART = IPART+1
    JJ1 = 0
    last = .true.
    do IREF=1,NREF
      JHOLE = 0
      JPART = IPART
      do I=1,LN
        if (I <= LV) then
          IDIF = IOC(I)
        else if (I <= NIORB+LV) then
          IDIF = IOC(I)-2
        else
          JJ1 = JJ1+1
          if (IOC(I) == IOCR(JJ1)) cycle
          IDIF = IOC(I)-IOCR(JJ1)
        end if
        if (IDIF <= 0) then
          JHOLE = JHOLE-IDIF
        else
          JPART = JPART+IDIF
        end if
      end do
      if (JPART /= JHOLE) then
        write(u6,*) 'DeltaB: JPART /= JHOLE'
        write(u6,*) 'JPART,JHOLE=',JPART,JHOLE
        write(u6,*) 'iREF=',iREF
        call Abend()
      end if
      if (JPART <= IEL) then
        last = .false.
        exit
      end if
    end do
    if (last) cycle
    if ((IPART == 0) .and. (NSJ /= LSYM)) cycle
    if ((IPART == 2) .and. (INTNUM /= 0)) then
      ! INTERACTING SPACE
      if ((INHOLE == 2) .and. (IBS /= 0)) cycle
    end if
    ! NO CORE-CORE CORRELATION
    if (IFCORE /= 0) then
      NCORR = 0
      do I=1,LN
        if (ICOR(I) == 0) cycle
        NCORR = NCORR+2-IOC(I)
      end do
      if (NCORR > 1) cycle
    end if
    ! SINGLY OCCUPIED ORBITALS
    do I=1,NONE_
      if (IOC(JONE(I)) /= 1) cycle
    end do
    do K=1,LN
      if (ISP(K)-1 < 0) then
        K0M(J2(K+1)) = K00(J2(K+1))
        L0M(J2(K)) = L00(J2(K))
      else if (ISP(K)-1 == 0) then
        K1M(J2(K+1)) = K11(J2(K+1))
        L1M(J2(K)) = L11(J2(K))
      else if (ISP(K) == 3) then
        K3M(J2(K+1)) = K33(J2(K+1))
        L3M(J2(K)) = L33(J2(K))
      else
        K2M(J2(K+1)) = K22(J2(K+1))
        L2M(J2(K)) = L22(J2(K))
      end if
    end do
  end do
end do
call mma_deallocate(K0M)
call mma_deallocate(K1M)
call mma_deallocate(K2M)
call mma_deallocate(K3M)
call mma_deallocate(L0M)
call mma_deallocate(L1M)
call mma_deallocate(L2M)
call mma_deallocate(L3M)

return

end subroutine DELTAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2003, Valera Veryazov                                  *
************************************************************************
      SubRoutine EneClc(En1V,En2V,EnerV,Dens,OneHam,TwoHam,mBT,mDens,nD,
     &                  EDFT,nEDFT)
************************************************************************
*                                                                      *
* Purpose: Compute one- and two-electron energies                      *
*                                                                      *
* output:                                                              *
*   En1V    : one-electron energy (variational)                        *
*   En2V    : two-electron energy (variational)                        *
*   EnerV   : En1V + En2V                                              *
*                                                                      *
* called from: SCF_Energy                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* written by:                                                          *
* P.O. Widmark, M.P. Fuelscher and P. Borowski                         *
* University of Lund, Sweden, 1992                                     *
*                                                                      *
************************************************************************
#ifdef _FDE_
      use Embedding_Global, only: Eemb, embInt, embPot
#endif
      use OFembed, only: Do_OFemb
      use OFembed, only: Rep_EN
      Implicit Real*8 (a-h,o-z)
*
* Declaration of procedure parameters
*
      REAL*8 En1V,En2V,EnerV
      Real*8 Dens(mBT,nD,mDens), OneHam(mBT), TwoHam(mBT,nD,mDens),
     &       EDFT(nEDFT)
#include "real.fh"

#include "mxdm.fh"
#include "infscf.fh"
*----------------------------------------------------------------------*
* Start                                                                *
*----------------------------------------------------------------------*
      Call Timing(Cpu1,Tim1,Tim2,Tim3)
*define _DEBUGPRINT_
*
* Allocate memory for full Dens and TwoHam
*
c set to Zero for RHF
      En1V_ab=0.0D0
      En2V_ab=0.0D0

      iter_d=iter-iter0
*
      En1V  = DDot_(nBT,OneHam,1,Dens(1,1,iPsLst),1)
      If(iUHF.eq.1) Then
         En1V_ab  = DDot_(nBT,OneHam,1,Dens(1,2,iPsLst),1)
      End If
*
      E_DFT = EDFT(iter_d)
*
#ifdef _FDE_
      ! Embedding
      if (embPot) Eemb = DDot_(nBT*nD,embInt,1,Dens(1,1,iPsLst),1)
#endif
*
*     If just one electron make sure that the two-electron energy
*     is zero.
*
      nElec=0
      Do iSym = 1, nSym
         nElec = nElec
     &         + (2-iUHF)*nOcc(iSym,1)
     &         +    iUHF *nOcc(iSym,2)
      End Do
      En2V=0
      If ((nElec.le.1).and.(KSDFT.eq.'SCF')) Go To 999
*
      En2V  = DDot_(nBT,TwoHam(1,1,iPsLst),1,Dens(1,1,iPsLst),1)
      If (iUHF.eq.1) Then
         En2V_ab  = DDot_(nBT,TwoHam(1,2,iPsLst),1,Dens(1,2,iPsLst),1)
      End If
999   Continue
*
      If (Do_OFemb) Then
         If(iUHF.eq.1) Then ! equipartition
            En2V   = En2V    -Half*Rep_EN
            En2V_ab= En2V_ab -Half*Rep_EN
         Else
            En2V   = En2V -        Rep_EN
         End If
      End If
*
*     Note that the DFT energy can not be computed as a trace.
*
      If(iUHF.eq.1) Then
         Elst(iter,1)=En1V   +Half*En2V   +Half*PotNuc+Half*E_DFT
         Elst(iter,2)=En1V_ab+Half*En2V_ab+Half*PotNuc+Half*E_DFT
      Else
         Elst(iter,1)=En1V   +Half*En2V        +PotNuc+     E_DFT
      End If
*
      If(iUHF.eq.0) Then
         En2V  = Half*En2V
      Else
         En2V  = Half*(En2V+En2V_ab)
      End If
      En1V= (En1V+En1V_ab) + E_DFT
      EnerV = En1V + En2V + PotNuc
#ifdef __SUNPRO_F90
      If (iUHF.gt.3) Write (6,*) 'eneclc: Ene=',En1V,En1V_ab,En2V,EnerV
#endif
#ifdef _DEBUGPRINT_
      Write (6,*) 'eneclc: Ene=',En1V,En1V_ab,En2V,EnerV
#endif
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld(14) = TimFld(14) + (Cpu2 - Cpu1)
*----------------------------------------------------------------------*
* Exit                                                                 *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Jeppe Olsen                                      *
************************************************************************
      FUNCTION NCASTR_MCLR(IAC,NSTTPI,NTPSTI,ICLSI,NOBATP,NOBTP,IELPTP)
*
* Number of allowed annihilation/creations from a given group
* of stings
*
*     Jeppe Olsen, June 1994
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER  NSTTPI(NTPSTI)
      INTEGER  NOBATP(NOBTP)
      INTEGEr IELPTP(NOBTP,*)
*
      LCA = 0
C      write(6,*) ' NCASTR: IELPTP array'
C      write(6,*) ' ===================='
C      write(6,*) ' Number of occupation types ', NTPSTI
C      call iwrtma(IELPTP,NOBTP,NTPSTI,NOBTP,NTPSTI)
C      write(6,*) ' NOBTP NTPSTI ',NOBTP,NTPSTI
C      write(6,*) ' Number of strings per type:'
C      write(6,*) (NSTTPI(I),I=1,NTPSTI)
      DO IOBTP = 1, NOBTP
        DO ISTTP = 1, NTPSTI
*. Type of resulting string
          CALL NEWTYP_MCLR(ICLSI,ISTTP,[IAC],[IOBTP],1,ICLSO,ITPO)
C?        WRITE(6,*) ' IOBTP ISTTP => ITPO, ICLSO '
C?        WRITE(6,*)   IOBTP,ISTTP,ITPO,ICLSO
C          write(6,*) ' IELPTP = ',IELPTP(IOBTP,ISTTP)
C          write(6,*) ' NOBATP = ',NOBATP(IOBTP)
          IF(IAC.EQ.1) THEN
            NENTRY = IELPTP(IOBTP,ISTTP)
          ELSE
            NENTRY = NOBATP(IOBTP)-IELPTP(IOBTP,ISTTP)
          END IF
C          write(6,*) ' NENTRY = ',NENTRY
          IF(ITPO.GT.0) THEN
            LCA = LCA + NENTRY*NSTTPI(ISTTP)
          END IF
*
        END DO
      END DO
*
*     WRITE(6,*) ' Number of generated strings ', LCA
      NCASTR_MCLR = LCA
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE WEIGHT_mclr(Z,NEL,NORB1,NORB2,NORB3,
     &                  MNRS1,MXRS1,MNRS3,MXRS3, ISCR)
*
* construct vertex weights
*
* Reverse lexical ordering is used for restricted space
*
      IMPLICIT REAL*8 ( A-H,O-Z)
      INTEGER Z(*), ISCR(*)
      NTEST=0
*
      NORB = NORB1 + NORB2 + NORB3
*
      KLFREE = 1
      KLMAX = KLFREE
      KLFREE = KLFREE + NORB
*
      KLMIN = KLFREE
      KLFREE = KLFREE + NORB
*
      KW = KLFREE
      KLFREE = KW + (NEL+1)*(NORB+1)
*.Max and min arrays for strings
      CALL RSMXMN(ISCR(KLMAX),ISCR(KLMIN),NORB1,NORB2,NORB3,
     &            NEL,MNRS1,MXRS1,MNRS3,MXRS3,NTEST)
*. Arc weights
      CALL GRAPW(ISCR(KW),Z,ISCR(KLMIN),ISCR(KLMAX),NORB,NEL,NTEST)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine DMSInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of diamagnetic shielding  *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, February '91                            *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: iComp, iDCRT(0:7), ipArr, ipRes, iPrint, ipS1, ipS2, iRout, iStabO(0:7), lDCRT, llOper, LmbdT, mArr, nComp_, &
                     nDCRT, nip, nOp, nRys, nStabO
real(kind=wp) :: TC(3,2)
integer(kind=iwp), external :: NrOpr

#include "macros.fh"
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 230
iPrint = nPrint(iRout)

nRys = nHer

if (iPrint >= 99) then
  call RecPrt(' In DMSInt: Alpha',' ',Alpha,nAlpha,1)
  call RecPrt(' In DMSInt: Beta',' ',Beta,nBeta,1)
end if

nip = 1
ipS1 = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb+1)*3
ipS2 = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*3
ipRes = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp
if (nip-1 > nZeta*nArr) then
  call WarningMessage(2,'DMSInt: nip-1 > nZeta*nArr')
  write(u6,*) 'nip=',nip
  write(u6,*) 'nZeta,nArr=',nZeta,nArr
  call Abend()
end if
ipArr = nip
mArr = nZeta*nArr-nip+1

rFinal(:,:,:,:) = Zero

iComp = 1
llOper = lOper(1)
do iComp=2,nComp
  llOper = ior(llOper,lOper(iComp))
end do
call SOS(iStabO,nStabO,llOper)
call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

do lDCRT=0,nDCRT-1
  call OA(iDCRT(lDCRT),Ccoor(1:3,1),TC(1:3,1))
  call OA(iDCRT(lDCRT),Ccoor(1:3,2),TC(1:3,2))

  ! Compute contribution from a,b+1

  nComp_ = 1
  call EFPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS1),nZeta,nComp_,la,lb+1,A,RB,nRys,Array(ipArr),mArr,TC,nOrdOp-1)

  ! Compute contribution from a,b

  call EFPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS2),nZeta,nComp_,la,lb,A,RB,nRys,Array(ipArr),mArr,TC,nOrdOp-1)

  ! Assemble final integral from the derivative integrals

  call Util4(nZeta,Array(ipRes),la,lb,Array(ipS1),Array(ipS2),RB,TC(1,2))

  nOp = NrOpr(iDCRT(lDCRT))
  call SymAdO(Array(ipRes),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,One)

end do

return

end subroutine DMSInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakeChckData(wrk,wrksize,LunAux)
! this routine generates checkeroo data
! Use id possible only when NaGrp=NaSGRp=1
!
! assumption nc>=nv>=no (inac preverit dimenzovanie)
! dimensions: V1 - no*nv*nv2, nv2*nv2
!             V2 - nc*nv2
!             V3 - nc*nv*no

use Index_Functions, only: nTri_Elem
use chcc_global, only: I0Name, I1Name, I2Name, I3Name, L0Name, L1Name, L1k, L2Name, nc, no, nv, PosOE, Q21
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, LunAux
real(kind=wp), intent(inout) :: wrk(wrksize)
character(len=6) :: LunName
integer(kind=iwp) :: dim_1, PosT, PosV1, PosV2, PosV3

call DistMemChck(PosV1,PosV2,PosV3,PosT)

!1 make Q0
LunName = I0name
dim_1 = nTri_Elem(no)**2
call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
call MkQ0(wrk(PosV1))

!2 make Q1
LunName = I1name(1)
dim_1 = nTri_Elem(no)*no*nv
call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
call MkQ1(wrk(PosV1))

!3 Read Q21
LunName = I2name(1,1)
dim_1 = no*no*nv*nv
call GetX(Q21(1,1,1,1),dim_1,LunAux,LunName,1,1)

!4make Q22
LunName = I3name(1,1)
dim_1 = nTri_Elem(no)*nTri_Elem(nv)
call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
call MkQ22(wrk(PosV1))

!5 make Q4, L2k
LunName = L2name(1,1)
dim_1 = nc*nTri_Elem(nv)
call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
call MkL2_chcc(wrk(PosV2))
dim_1 = nTri_Elem(nv)**2
wrk(PosV1:PosV1+dim_1-1) = Zero
dim_1 = nTri_Elem(nv)
call mc0c1at3b(nc,dim_1,nc,dim_1,dim_1,dim_1,dim_1,nc,dim_1,wrk(PosV2),wrk(PosV2),wrk(PosV1))
call MkQ4(wrk(PosV1))

! make Q3, L1k
LunName = L1name(1)
dim_1 = nc*no*nv
call GetX(wrk(PosV3),dim_1,LunAux,LunName,1,1)
call dcopy_(dim_1,wrk(PosV3),1,L1k,1)
dim_1 = no*nTri_Elem(nv)
wrk(PosV1:PosV1:dim_1-1) = Zero
dim_1 = nTri_Elem(nv)
call mc0c1at3b(nc,dim_1,nc,no*nv,dim_1,no*nv,dim_1,nc,no*nv,wrk(PosV2),wrk(PosV3),wrk(PosV1))
call MkQ3(wrk(PosV1))

! make L0
LunName = L0name
dim_1 = nc*nTri_Elem(no)
call GetX(wrk(PosV3),dim_1,LunAux,LunName,1,1)
call MkL0(wrk(PosV3))

! make OEo,OEv
call MkOE(wrk(PosOE))

call MkT1T2()

return

end subroutine MakeChckData

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MSSTRN(INSTRN,UTSTRN,NOPEN)
! A STRING IS GIVEN IN FORM A SEQUENCE OF ZEROES AND ONES
!
! REINTERPRET THIS AS :
!
! 1 : THE INPUT STRING IS A DETERMINANT AND THE
!     1'S INDICATE ALPHA ELECTRONS AND THE
!     0'S INDICATE BETA ELECTRONS.
!     UTSTRN IS THE MS-VALUES ATE EACH VERTEX
!
! 2 : THE INPUT STRING IS A CSF GIVEN IN A
!     BRANCHING DIAGRAM, WHERE
!     1'S INDICATE UPWARDS SPIN COUPLING
!     WHILE THE 0'S INDICATES DOWNWARDS SPIN COUPLING,
!     REEXPRESS THIS AS S VALUES OF ALL COUPLINGS
!
! THE TWO PROCEDURES ARE IDENTICAL.

use Constants, only: Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NOPEN, INSTRN(NOPEN)
real(kind=wp), intent(out) :: UTSTRN(NOPEN)
integer(kind=iwp) :: IOPEN

UTSTRN(1) = real(INSTRN(1),kind=wp)-Half
do IOPEN=2,NOPEN
  UTSTRN(IOPEN) = UTSTRN(IOPEN-1)+real(INSTRN(IOPEN),kind=wp)-Half
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' ... Output from MSSTRN'
write(u6,*) ' INSTRN AND UTSTRN'
call IWRTMA(INSTRN,1,NOPEN,1,NOPEN)
call WRTMAT(UTSTRN,1,NOPEN,1,NOPEN)
#endif

end subroutine MSSTRN

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine create_klvab_t3(vblock)
!mp subroutine create_klvab_t3(G,vblock)
!
!  creates K(alpha-beta,alpha-beta),K(beta-alpha,alpha-beta)
!  DA files KMATBA and KMATAB, LMATBA and LMATAB
!  creates L(alpha-beta,alpha-beta),K(beta-alpha,alpha-beta)
!  max G at this place
!  both matrices have to be available at a time (unfortunately)
!
!  parallelization irrelevant at the moment
!  implemented integer offsets, PV, 14 may 2004.

use ChT3_global, only: DimGrpaR, ICH, IOPT, maxdim, nblock, nc, NNOAB, no, NOAB, NUAB, nv, NvGrp, printkey
use ChT3_procedures, only: klvaa_oovo
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: vblock
integer(kind=iwp) :: A, A1, A2, a_tmp, AADT, adim, B1, b1_tmp, b2_chk, i, i_blk, IADR, ias, ias_aa, iasblock, IJS, is2, isp, ISPA, &
                     ISTEP, IUHF, j, j_blk, j_tmp, k, last, last_aa, length, length1, length2, lu, n, nga, ngaf, ngal, ngb, ngbf, &
                     ngbl, nind_ngaf, nind_ngal, nind_ngbf, nind_ngbl, NNO, NNU, NSTEP, nug, RAD
character(len=6) :: FN
real(kind=wp), allocatable :: g(:), l0(:), l1(:), l1_1(:), l2_1(:), scr(:), t2_exp(:), t2_tmp(:), tmp(:), tmp2(:), x(:)

if (printkey >= 10) then
  write(u6,*)
  write(u6,*) '------ DimGrpaR ------'
  write(u6,'(8(i5,2x))') (DimGrpaR(a_tmp),a_tmp=1,NvGrp)
  write(u6,*)
end if

! - calculate overall memory requirements

call check_create_klvab_t3_mem(vblock)

!mp call w_rescope(G,'G create KL')
!mp call w_free(g,0,'G klvab ')
N = noab(1)+nuab(1)
!NNRED = nTri_Elem(NOAB(1))
IUHF = 0
if (IOPT(1) /= 0) then
  IUHF = 1
  !NNRED = NNOAB(3)
end if
LU = 98

!mp call w_alloc(it,NNOAB(3)*NNUAB(3),'IT klvab')
!mp call w_alloc(ix,vblock*vblock*n,'IX klvab')
!mpn call mma_allocate(t,NNOAB(3)*NNUAB(3),label='create_it')
call mma_allocate(x,vblock*vblock*n,label='c1_ix')
!mp
!!FN = 'T2OLDC'
!!call GET3DM(FN,G(it),NNUAB(3),NNRED,0)
!mp

!mp call w_alloc(it2_tmp,maxdim*maxdim*no*no,'ITMP klvab')
!mp call w_alloc(itmp,maxdim*maxdim*no*no,'ITMP klvab')
!mpn call mma_allocate(t2_tmp,maxdim*maxdim*no*no,label='create_it2')
!mpn call mma_allocate(tmp,maxdim*maxdim*no*no,label='create_tmp')
!
!mp call gather_t2(G(it),G(it2_tmp),G(itmp))
!mpn call gather_t2(t,t2_tmp,tmp)
!
!
!mp call w_free(G(it2_tmp),0,'ITMP klvab ')
!mpn call mma_deallocate(tmp)
!mpn call mma_deallocate(t2_tmp)

!mpn write(u6,*) 'T2 regenerated from MOLCAS'
!mpn write(u6,*)
!
!mp call dscal_(NNUAB(3)*NNRED,-One,G(it),1)
!mp call dscal_(NNUAB(3)*NNOAB(3),-One,G(it),1)
!mpn t(:) = -t
!mp if (IUHF == 0) call decomp2ind(G(it),NNUAB(3),noab(1),NUAB(1))
!!write(u6,*) ddot_(nnoab(3)*nnuab(3),G(it),1,G(it),1)

! number of blocks written in a single multiwrite

iasblock = vblock*vblock*N/nblock
if ((iasblock*nblock) < (vblock*vblock*N)) iasblock = iasblock+1

do isp=1,IUHF+1
  is2 = 3-isp
  FN = 'KMAT'//ich(3-isp)//ich(isp)
  write(u6,*) 'FN,LU=',FN,LU
  call multi_opendir(FN,LU)
  !ndup = ndup+1
  !if (ndup > ndupmx) then
  !  write(u6,*) 'create_klvab_t3 -- ndupmx exceeded'
  !  call abend()
  !end if
  !!write(u6,*) FN,isp,ndup
  !dupfil(ndup) = FN
  if (IUHF == 0) then
    FN(5:6) = ich(isp)//ich(isp)
    call multi_opendir(FN,LU+1)
    !!ndup = ndup+1
    !if (ndup > ndupmx) then
    !  write(u6,*) 'create_klvab_t3 -- ndupmx exceeded'
    !  call abend()
    !end if
    !!write(u6,*) FN,isp,ndup+1
    !dupfil(ndup+1) = FN
  end if
  ! currently using 3-dim (big field) - will be replaced after changing
  ! stepiv and the rest
  nnu = nTri_Elem(nuab(is2))
  !mp call w_alloc(ig,(nuab(isp)*nnu),'IG klvab')
  !mp call w_alloc(iscr,nuab(is2)*nuab(is2),'IG iscr')
  !mp
  call mma_allocate(g,nuab(isp)*nnu,label='c1_ig')
  call mma_allocate(scr,nuab(is2)*nuab(is2),label='c1_iscr')
  !mp
  IAS = 1
  IAS_AA = 1

  do K=1,noab(isp)
    !!if (IUHF == 1) then
    !!  KADT = (K-1)*NNUAB(3)*(NOAB(2)*(2-ISP)+ISP-1)
    !!else
    !!  KADT = 0
    !!end if

    !mp !FN = 'VVVAI'//ICH(ISP)
    !mp !call GET3DM(FN,G(IG),NNU,NUAB(ISP),K)
    if (printkey > 1) write(u6,*) 'Regenerating VVVo integrals for o = ',K
    !mp
    !mp call w_alloc(il1_1,nc*maxdim,'IL1_1 iscr')
    !mp call w_alloc(il2_1,nc*maxdim*maxdim,'IL2_1 iscr')
    !mp call w_alloc(itmp,max(nc*maxdim*maxdim,nc*no*maxdim,maxdim*maxdim*maxdim),'ITMP iscr')
    !mp
    call mma_allocate(l1_1,nc*maxdim,label='cc_il1_1')
    call mma_allocate(l2_1,nc*maxdim*maxdim,label='cc_il2_1')
    call mma_allocate(tmp,max(nc*maxdim*maxdim,nc*no*maxdim,maxdim*maxdim*maxdim),label='cc_itmp')
    !mp
    !mp call gen_vvvo(K,G(IG),G(il1_1),G(il2_1),G(itmp))
    call gen_vvvo(K,g,l1_1,l2_1,tmp)
    !mp write(u6,*) ddot_(nnu*nuab(isp),G(ig),1,G(ig),1)
    !mp call zeroma(G(ig),1,NNU*NUAB(ISP))
    !
    !mp call w_free(G(il1_1),0,'IL1_1 iscr')
    call mma_deallocate(tmp)
    call mma_deallocate(l2_1)
    call mma_deallocate(l1_1)
    !mp
    call delf(FN,K,K)
    if (iuhf == 0) call klvaa_vvv(x,g,vblock,N,nug,LU+1,last_aa,iasblock,K,ias_aa)
    !mpn if (iuhf == 0) call klvaa_vvv(ix,it,ig,iscr,vblock,N,nug,LU+1,last_aa,iasblock,K,ias_aa)
    !mp if (iuhf == 0) call klvaa_vvv(G,ix,it,ig,iscr,vblock,N,nug,LU+1,last_aa,iasblock,K,ias_aa)

    !!call xflush(u6)
    ! (c>d|AK)

    !mpn
    nga = 0
    !mpn
    do A1=1,NUAB(ISP),vblock
      A2 = A1+min(vblock,nuab(isp)-A1+1)-1
      adim = A2-A1+1
      nga = nga+1
      ngb = 0
      do B1=1,NUAB(IS2),vblock
        ngb = ngb+1
        NSTEP = min(vblock,nuab(is2)-B1+1)
        !!bdim = NSTEP
        IJS = (A1-1)*NNU+1
        !mpn
        !mpn write(u6,*)
        !mpn write(u6,*) '================================='
        !mpn write(u6,*) ' nga, ngb',nga,ngb
        !mpn write(u6,*) '================================='
        !mpn write(u6,*)

        ! - check the largest b2

        !mpn b2_chk = b1-1+vblock
        b2_chk = b1-1+min(vblock,nuab(is2)-B1+1)

        ! - find out which T2 blocked files will be needed
        !   for particular nga, ngb

        !mpn write(u6,'(A,4(i5,2x))') 'a1,a2,b1,b2_chk = ',a1,a2,b1,b2_chk

        !switch = .false.
        if (nga < ngb) then
          !mpn write(u6,*) 'switching nga, ngb',ngb,nga
          !switch = .true.

          call block_interf(b1,b2_chk,a1,a2,ngaf,ngal,nind_ngaf,nind_ngal,ngbf,ngbl,nind_ngbf,nind_ngbl)

        else

          call block_interf(a1,a2,b1,b2_chk,ngaf,ngal,nind_ngaf,nind_ngal,ngbf,ngbl,nind_ngbf,nind_ngbl)

        end if

        !mpn write(u6,'(A,4(i5,2x))') 'ngaf, ngal, nind_ngaf, nind_ngal',ngaf,ngal,nind_ngaf,nind_ngal
        !mpn write(u6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',ngbf,ngbl,nind_ngbf,nind_ngbl

        ! - read amplitudes from T2_ngaf_ngbf ...  T2_ngaf_ngbl, nga>=ngb
        !                           ....               ....
        !                        T2ngal_ngbf  ...  T2_ngal_ngbl, nga>=ngb

        ! - calculate memory requirements (consider squared T2(a',a'))

        length1 = 0
        do i_blk=ngaf,ngal
          length1 = length1+DimGrpaR(i_blk)
        end do

        length2 = 0
        do j_blk=ngbf,ngbl
          length2 = length2+DimGrpaR(j_blk)
        end do

        !mpn write(u6,*) 'length1, vblock = ',length1,vblock
        !mpn write(u6,*) 'length2, vblock = ',length2,vblock

        length = length1*length2*no*no
        !mpn write(u6,*) 'length for blocked T2 amplitudes = ',length

        ! - setup memory

        !mpn write(u6,*) 'allocating t2_exp = ',length
        call mma_allocate(t2_exp,length,label='t2_exp')

        ! - read pertinent files and store them in the new blocked structure

        call mma_allocate(t2_tmp,maxdim*maxdim*no*no,label='cd_it2tmp')
        call mma_allocate(tmp,maxdim*maxdim*no*no,label='cd_itmp')

        call gather_t2_blocked(length1,length2,ngaf,ngal,ngbf,ngbl,t2_exp,t2_tmp,tmp)

        call mma_deallocate(tmp)
        call mma_deallocate(t2_tmp)

        t2_exp(:) = -t2_exp

        do A=A1,A2
          !mp call EXPA1_UHF(G(IJS),1,NUAB(IS2),1,G(ISCR))
          call EXPA1_UHF(g(IJS),1,NUAB(IS2),1,SCR)
          IJS = IJS+NNU
          ! Gix       <ng*ng|R,k>
          !! not needed B2 = B1+min(ng,nuab(is2)-B1+1))-1
          !mpn
          if (nga < ngb) then
            a_tmp = a-nind_ngbf
            b1_tmp = b1-nind_ngaf
          else
            a_tmp = a-nind_ngaf
            b1_tmp = b1-nind_ngbf
          end if
          !mp write(u6,'(A,2(i5,2x),A,i5,2x)') 'b1,   a     ,i,k = ',b1,a,'    i',k
          ! mv T2(B,A,I,K) >> G(ix)
          !mpn
          do I=1,NOAB(IS2)
            ISPA = ISP
            !!if (IUHF == 1) then
            !!  IADT = (I-1)*NNUAB(3)*(NOAB(2)*(2-IS2)+IS2-1)
            !!else
            !!  IADT = iTri(K,I)
            !!  IADT = (IADT-1)*NNUAB(3)
            !!  if (K < I) ISPA = IS2
            !!end if
            !mpn BADT = (2-ISPA)*B1+(ISPA-1)*(B1-1)*NUAB(2)
            !mpn!!!
            !mpn AADT_tmp = IADT+KADT+BADT+A*(ISPA-1)+(2-ISPA)*(A-1)*NUAB(2)
            !mpn!!!
            ! T2 <A,B,J,K> for isp=1 T2 <B,A,K,J> for isp=2
            !! RAD = (I-1)*vblock*vblock+(A-A1)*vblock+1
            RAD = (I-1)*adim*nstep+(A-A1)*nstep+1
            ISTEP = (ISPA-1)*NUAB(2)+2-ISPA
            !mpn
            if (nga >= ngb) then ! nga> ngb

              !mp write(u6,'(A,4(i5,2x),3x,i5)') '(I)  a_tmp,b1_tmp,k,i  nstep = ',a_tmp,b1_tmp,k,i,nstep
              ! T2(B,A,I,K) =? T2(A,B1,K,I)
              do j_tmp=0,NSTEP-1  ! istep je 1 ak dobre tusim

                AADT = (I-1)*length1*length2*NOAB(2)+(K-1)*length1*length2+(b1_tmp-1+j_tmp)*length1+a_tmp

                x(RAD+j_tmp) = t2_exp(AADT)
                !mp
                !mpn if (abs(t2_exp(AADT)-t(AADT_tmp+j_tmp)) > 1.0e-5_wp) then
                !mpn   write(u6,*) 'halohaha 1',AADT,AADT_tmp+j_tmp,t2_exp(AADT),t(AADT_tmp+j_tmp)
                !mpn   stop
                !mpn end if
                !mp
              end do

            else ! nga < ngb

              !mp write(u6,'(A,4(i5,2x),3x,i5)') '(II) b1_tmp,a_tmp,k,i   nstep = ',b1_tmp,a_tmp,i,k,nstep
              ! T2(B,A,I,K)
              do j_tmp=0,NSTEP-1  ! istep je 1 ak dobre tusim

                !mp AADT = (k-1)*length1*length2*NOAB(2)+(i-1)*length1*length2+(a_tmp-1)*length1+b1_tmp+j_tmp
                !mp !AADT = (i-1)*length1*length2*NOAB(2)+(k-1)*length1*length2+(a_tmp-1)*length1+b1_tmp+j_tmp
                AADT = (K-1)*length1*length2*NOAB(2)+(I-1)*length1*length2+(a_tmp-1)*length1+b1_tmp+j_tmp

                x(RAD+j_tmp) = t2_exp(AADT)
                !mp
                !mpn if (abs(t2_exp(AADT)-t(AADT_tmp+j_tmp)) > 1.0e-5_wp) then
                !mpn   write(u6,*) 'halohaha 2',AADT,AADT_tmp+j_tmp,t2_exp(AADT),t(AADT_tmp+j_tmp)
                !mpn   stop
                !mpn end if
                !mp

              end do
            end if

            !mpn call dcopy_(NSTEP,t2_exp(AADT),ISTEP,x(RAD),1)
            !mpn
          end do      ! I
          RAD = noab(is2)*adim*nstep+(A-A1)*nstep+1
          do IADR=B1,NUAB(IS2)*NUAB(IS2),NUAB(IS2)
            !mp call dcopy_(NSTEP,G(IADR),1,G(RAD),1)
            x(RAD:RAD+NSTEP-1) = scr(IADR:IADR+NSTEP-1)
            RAD = RAD+adim*nstep
          end do      ! IADR
        end do        ! A
        !!write(u6,'(A,4I5,4x,D15.10)') 'block-w: K,a1,b1,IAS,ddot',K,a1,b1,ias,ddot_(N*vblock*vblock,G(IX),1,G(IX),1)
        !mp call multi_wridir(G(IX),N*vblock*vblock,LU,IAS,last)

        !mp
        !mp !!do jjj = 1,N*vblock*vblock
        !mp !!if (abs(x(jjj)) > 1.0e5_wp) then
        !mp !!  write(u6,*) 'prasa 1 ',jjj,x(jjj)
        !mp !!  stop
        !mp !!end if
        !mp !!end do
        !mp
        call multi_wridir(x,N*vblock*vblock,LU,IAS,last)
        !!write(u6,*) 'N*vblock*vblock,LU,last ',N*vblock*vblock,LU,last
        ias = ias+iasblock
        !mp
        call mma_deallocate(t2_exp)
        !mp
      end do      ! B1
    end do        ! A1
  end do          ! K
  if (printkey > 1) then
    write(u6,*) 'VVVo integrals regenerated from MOLCAS'
    write(u6,*)
  end if
  !mp
  close(LU)
  !dupblk(ndup) = last
  if (IUHF == 0) then
    close(LU+1)
    !ndup = ndup+1
    !dupblk(ndup) = last_aa
  end if
  !write(u6,*) FN,isp,IAS
  !mp call w_memchk('IG klvab ')
  !mp call w_free(g(ig),0,'IG klvab ')
  !mp
  call mma_deallocate(scr)
  call mma_deallocate(g)
  !mp
end do     ! ISP

!mp call dscal_(NNUAB(3)*NNOAB(3),-One,G(it),1)
!mpn t(:) = -t
!mp??
call mma_deallocate(x)
!mp??
do isp=1,IUHF+1
  !mp call w_memchk('IX klvab ')
  !mp call w_free(g(ix),0,'IX klvab ')
  !mp
  is2 = 3-isp
  iasblock = nnoab(3)*vblock*N/nblock
  if ((iasblock*nblock) < (nnoab(3)*vblock*N)) iasblock = iasblock+1
  FN = 'LMAT'//ich(3-isp)//ich(isp)
  call multi_opendir(FN,LU)
  !ndup = ndup+1
  !if (ndup > ndupmx) then
  !  write(u6,*) 'create_klvab_t3 -- ndupmx exceeded'
  !  call abend()
  !end if
  !write(u6,*) FN,isp,ndup
  !dupfil(ndup) = FN

  FN = 'OOVAI'//ICH(ISP)
  !mp call w_alloc(ix,noab(isp)*noab(IS2)*vblock*n,'IX klvabo')
  call mma_allocate(x,noab(isp)*noab(IS2)*vblock*n,label='c2_ix')
  nno = nTri_Elem(noab(is2))
  !mp call w_alloc(ig,noab(isp)*nuab(isp)*nno,'IG klvabo')
  !mp call w_alloc(iscr,vblock*noab(IS2)*noab(IS2),'ISCRo klvabo')
  call mma_allocate(g,noab(isp)*nuab(isp)*nno,label='c2_ig')
  call mma_allocate(scr,vblock*noab(IS2)*noab(IS2),label='c2_iscr')
  !mp
  !mp !call GET3DM(FN,G(ig),NNO,NUAB(ISP)*NOAB(ISP),0)
  !mp
  !mp call w_alloc(il0,nc*nno,'IL0 klvabo')
  !mp call w_alloc(il1,nc*no*nv,'IL1 klvabo')
  !mp call w_alloc(itmp,max(nc*nno,nc*no*maxdim,nc*no*nv),'ITMP klvabo')
  !mp
  call mma_allocate(l0,nc*nno,label='cr_il0')
  call mma_allocate(l1,nc*no*nv,label='cr_il1')
  call mma_allocate(tmp,max(nc*nno,nc*no*maxdim,nc*no*nv),label='cr_itmp')
  !mp
  call gen_oovo(g,l0,l1,tmp)
  !mp call gen_oovo(G(ig),G(il0),G(il1),G(itmp))
  !mp write(u6,*) ddot_(NNO*NUAB(ISP)*NOAB(ISP),G(ig),1,G(ig),1)
  !mp call zeroma(G(ig),1,NNO*NUAB(ISP)*NOAB(ISP))

  !mp call w_free(G(il0),0,'IL0 klvab')
  call mma_deallocate(tmp)
  call mma_deallocate(l1)
  call mma_deallocate(l0)

  if (printkey > 1) write(u6,*) 'OOVO integrals regenerated from MOLCAS'
  !mp
  IAS = 1
  !mpn
  nga = 0
  !mpn
  do A1=1,NUAB(ISP),vblock
    A2 = A1+min(vblock,nuab(isp)-(A1-1))-1
    NSTEP = min(vblock,nuab(isp)-(A1-1))
    !mpn
    nga = nga+1

    !mp write(u6,*)
    !mp write(u6,*) '================================='
    !mp write(u6,*) ' nga ',nga
    !mp write(u6,*) '================================='
    !mp write(u6,*)

    !mp write(u6,'(A,2(i5,2x))') 'b1,b2 = ',a1,a2

    !mp call block_interf(1,1,a1,a2,ngaf,ngal,nind_ngaf,nind_ngal,ngbf,ngbl,nind_ngbf,nind_ngbl)
    call block_interf(1,nuab(1),a1,a2,ngaf,ngal,nind_ngaf,nind_ngal,ngbf,ngbl,nind_ngbf,nind_ngbl)

    !mp write(u6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',ngbf,ngbl,nind_ngbf,nind_ngbl

    ! - read amplitudes T2(nv,vblock,j<i)

    ! - calculate memory requirements

    length1 = nuab(isp)

    length2 = 0
    do i_blk=ngbf,ngbl
      length2 = length2+DimGrpaR(i_blk)
    end do

    !mp write(u6,*) 'length1, NUAB   = ',length1,NUAB(1)
    !mp write(u6,*) 'length2, vblock = ',length2,vblock

    length = length1*length2*no*no
    !mp write(u6,*) 'length for blocked T2 amplitudes = ',length

    ! - setup memory

    !mp write(u6,*) 'allocating t2_exp = ',length
    call mma_allocate(t2_exp,length,label='t2_exp')

    ! - read pertinent files and store them in the new blocked structure

    call mma_allocate(t2_tmp,maxdim*maxdim*no*no,label='t2_tmp')
    call mma_allocate(tmp2,maxdim*maxdim*no*no,label='tmp2')

    call gather_t2_fblocked(length1,length2,ngbf,ngbl,t2_exp,t2_tmp,tmp2)

    call mma_deallocate(tmp2)
    call mma_deallocate(t2_tmp)

    !mpn
    do k=1,noab(isp)
      !!if (IUHF == 1) then
      !!  KADT = (K-1)*NNUAB(3)*(NOAB(2)*(2-ISP)+ISP-1)
      !!else
      !!  KADT = 0
      !!end if
      IJS = 1+(A1-1)*nno+(k-1)*nuab(isp)*nno
      !mp call EXPA1_UHF(G(IJS),nstep,NOAB(IS2),1,G(iscr))
      call EXPA1_UHF(g(IJS),nstep,NOAB(IS2),1,scr)
      do I=1,noab(is2)
        ISPA = ISP
        !!if (IUHF == 1) then
        !!  IADT = (I-1)*NNUAB(3)*(NOAB(2)*(2-IS2)+IS2-1)
        !!else
        !!  IADT = iTri(K,I)
        !!  IADT = (IADT-1)*NNUAB(3)
        !!  if(K < I) ISPA = IS2
        !!end if

        do A=A1,A2

          !mpn
          a_tmp = a-nind_ngbf

          AADT = (K-1)*noab(2)*NUAB(2)*length2+(i-1)*NUAB(2)*length2+(a_tmp-1)*NUAB(2)+1
          !mpn
          ! copies T
          !mpn BADT = 2-ISPA+(ISPA-1)*NUAB(2)
          !  T2 <A,B,J,K> for isp=1 T2 <B,A,K,J> for isp=2
          ISTEP = (ISPA-1)*NUAB(2)+2-ISPA
          RAD = (I-1)*nstep*n+(A-A1)*n+noab(is2)+(K-1)*noab(is2)*nstep*N+1
          !mp call dcopy_(nuab(is2),G(AADT),ISTEP,G(RAD),1)
          !mp
          call dcopy_(nuab(is2),t2_exp(AADT),ISTEP,x(RAD),1)
        end do     ! A
      end do       ! I
      ! copies OOVO
      do J=1,noab(is2)
        do A=1,NSTEP
          RAD = 1+(A-1)*n+(J-1)*nstep*N+(K-1)*noab(is2)*nstep*N
          IADR = 1+(A-1)*noab(is2)*noab(is2)+(j-1)*noab(is2)
          !mp call dcopy_(noab(is2),G(IADR),1,G(RAD),1)
          x(RAD:RAD+noab(is2)-1) = scr(IADR:IADR+noab(is2)-1)
        end do     ! A
      end do       ! J
    end do         ! K
    !!write(u6,'(A,2I5,4x,D15.10)') 'block-w:a1,IAS,ddot',a1,ias,ddot_(N*vblock*nnoab(3),g(ix),1,g(ix),1)
    !!write(u6,'(a,a,2I4,D16.8)') 'block-w',ich(isp),(A1/vblock)+1,IAS,ddot_(N*nnoab(3)*NSTEP,g(ix),1,g(ix),1)
    !mp call multi_wridir(G(IX),N*nstep*nnoab(3),LU,IAS,last)
    !mp
    !mp !!do jjj=1,N*nstep*nnoab(3)
    !mp !!  if (abs(x(jjj)) > 1.0e5_wp) then
    !mp !!    write(u6,*) 'prasa 2 ',jjj,x(jjj)
    !mp !!    stop
    !mp !!  end if
    !mp !!end do
    !mp
    call multi_wridir(x,N*nstep*nnoab(3),LU,IAS,last)
    !mp
    IAS = IAS+iasblock
    !mpn
    call mma_deallocate(t2_exp)
    !mpn
  end do      ! A1
  close(LU)
  call mma_deallocate(scr)
  !write(u6,*) FN,isp,IAS
  !dupblk(ndup) = last
  if (IUHF == 0) then
    FN = 'LMAT'//ich(isp)//ich(isp)
    call multi_opendir(FN,LU)
    !ndup = ndup+1
    !if (ndup > ndupmx) then
    !  write(u6,*) 'create_klvab_t3 -- ndupmx exceeded'
    !  call abend()
    !end if
    !write(u6,*) FN,isp,ndup
    !dupfil(ndup) = FN
    ! this is to ensure correct copy to slaves
    IAS_AA = 1
    !mp write(u6,*) 'test 1 na iscr ',vblock*noab(IS2)*noab(IS2)
    !mp write(u6,*) 'test 1 na ig ',noab(isp)*nuab(isp)*nno
    !mp write(u6,*) 'test 1 na ix ',noab(isp)*noab(IS2)*vblock*n
    !mp call klvaa_oovo(G,ix,it,ig,iscr,vblock,N,nug,LU,last_aa,ias_aa)
    !mpn call klvaa_oovo(ix,it,ig,iscr,vblock,N,nug,LU,last_aa,ias_aa)
    call klvaa_oovo(x,g,vblock,N,nug,LU,last_aa,ias_aa)
    !mp
    !mp write(u6,*) 'klvaa_oovo finished'
    !mp
    close(LU)
    !ndup = ndup
    !dupblk(ndup) = last_aa
  end if
end do     ! ISP
!mp call w_memchk('all klvab ')
!mp call w_free(g(it),0,'IT klvab ')
! ig sa odalokuju v klva_oovo
!mp @@@ call GetMem('create_ig','Free','Real',ig,noab(isp)*nuab(isp)*nno)
!mp ???
!mp?? call GetMem('c2_ix','Free','Real',ix,noab(isp)*noab(IS2)*vblock*n)
!mpn call mma_deallocate(t)
call xflush(u6)

return

end subroutine create_klvab_t3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992,2000, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drvg1(Grad,Temp,nGrad)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals. The four outermost loops *
*          will control the type of the two-electron integral, eg.     *
*          (ss|ss), (sd|pp), etc. The next four loops will generate    *
*          list of symmetry distinct centers that do have basis        *
*          functions of the requested type.                            *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August '91                         *
*             Modified for gradient calculation. January '92           *
*             Modified for SetUp_Ints. January '00                     *
************************************************************************
      use k2_setup
      use iSD_data
      use PSO_Stuff
      use k2_arrays, only: ipZeta, ipiZet, Mem_DBLE, Aux, Sew_Scr
      use Basis_Info
      use Sizes_of_Seward, only:S
      use Real_Info, only: CutInt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Rsv_GTList
#include "itmax.fh"
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "disp.fh"
#include "nsd.fh"
#include "setup.fh"
*#define _CD_TIMING_
#ifdef _CD_TIMING_
#include "temptime.fh"
#endif
#include "para_info.fh"
*     Local arrays
      Real*8  Coor(3,4), Grad(nGrad), Temp(nGrad)
      Integer iAnga(4), iCmpa(4), iShela(4),iShlla(4),
     &        iAOV(4), istabs(4), iAOst(4), JndGrd(3,4), iFnc(4)
      Integer nHrrTb(0:iTabMx,0:iTabMx,2)
      Logical EQ, Shijij, AeqB, CeqD, lDummy,
     &        DoGrad, DoFock, Indexation,
     &        JfGrad(3,4), ABCDeq, No_Batch, Rsv_GTList,
     &        FreeK2, Verbose, Triangular
      Character Format*72
      Character*8 Method_chk
      Real*8, Allocatable:: TMax(:,:)
      Integer, Allocatable:: Ind_ij(:,:)
************ columbus interface ****************************************
      Integer  Columbus
*
      Integer iSD4(0:nSD,4)
      save MemPrm
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 9
      iPrint = nPrint(iRout)
      iPrint = 000000000

      iFnc(1)=0
      iFnc(2)=0
      iFnc(3)=0
      iFnc(4)=0
      PMax=Zero
      idum=0
      idum1=0
#ifdef _CD_TIMING_
      Twoel_CPU = 0.0d0
      Twoel_Wall = 0.0d0
      Pget_CPU = 0.0d0
      Pget_Wall = 0.0d0
#endif
      call dcopy_(nGrad,[Zero],0,Temp,1)
*
      Call StatusLine(' Alaska:',' Computing 2-electron gradients')
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
*                                                                      *
************************************************************************
*                                                                      *
*-----Precompute k2 entities.
*
      Call Get_iScalar('Columbus',Columbus)
      Indexation=.False.
*     MP2 gradients:
      Call Get_cArray('Relax Method',Method_chk,8)
      If(Method_chk.eq.'MBPT2   ') Indexation=.True.
************ columbus interface ****************************************
* in order to access the half-sorted density matrix file
* some index arrays must be generated
      If (Columbus.eq.1) Indexation=.True.
      DoFock=.False.
      DoGrad=.True.
      ThrAO=Zero
      Call SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
      mSkal=nSkal
      nPairs=nSkal*(nSkal+1)/2
      nQuad =nPairs*(nPairs+1)/2
      Pren = Zero
      Prem = Zero
*                                                                      *
************************************************************************
*                                                                      *
*-----Prepare handling of two-particle density.
*
      Call PrepP

*                                                                      *
************************************************************************
*                                                                      *
      MxPrm = 0
      Do iAng = 0, S%iAngMx
         MxPrm = Max(MxPrm,S%MaxPrm(iAng))
      End Do
      nZeta = MxPrm * MxPrm
      nEta  = MxPrm * MxPrm
*
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      Call mma_allocate(TMax,nSkal,nSkal,Label='TMax')
      Call Shell_MxSchwz(nSkal,TMax)
      TMax_all=Zero
      Do iS = 1, nSkal
         Do jS = 1, iS
            TMax_all=Max(TMax_all,TMax(iS,jS))
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Create list of non-vanishing pairs
*
      Call mma_allocate(Ind_ij,2,nskal*(nSkal+1)/2,Label='Ind_ij')
      nij=0
      Do iS = 1, nSkal
         Do jS = 1, iS
            If (TMax_All*TMax(iS,jS).ge.CutInt) Then
               nij = nij + 1
               Ind_ij(1,nij)=iS
               Ind_ij(2,nij)=jS
            End If
         End Do
      End Do
      P_Eff=Dble(nij)
*                                                                      *
************************************************************************
*                                                                      *
*-------Compute FLOPs for the transfer equation.
*
        Do iAng = 0, S%iAngMx
           Do jAng = 0, iAng
              nHrrab = 0
              Do i = 0, iAng+1
                 Do j = 0, jAng+1
                    If (i+j.le.iAng+jAng+1) Then
                       ijMax = Min(iAng,jAng)+1
                       nHrrab = nHrrab + ijMax*2+1
                    End If
                 End Do
              End Do
              nHrrTb(iAng,jAng,1)=nHrrab
              nHrrTb(jAng,iAng,1)=nHrrab
           End Do
        End Do

*                                                                      *
************************************************************************
*                                                                      *
      Triangular=.True.
      Call Alloc_TList(Triangular,P_Eff)
      Call Init_TList(Triangular,P_Eff)
      Call Init_PPList
      Call Init_GTList
      iOpt=0
*                                                                      *
************************************************************************
*                                                                      *
*     In MPP case dispatch one processor to do 1-el gradients first
*
      If (nProcs.gt.1.and.King()) Then
            Call Drvh1(Grad,Temp,nGrad)
*        If (nPrint(1).ge.15)
*    &   Call PrGrad(' Gradient excluding two-electron contribution',
*    &               Grad,lDisp(0),ChDisp,5)
         call dcopy_(nGrad,[Zero],0,Temp,1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_MaxDBLE(MemMax)
      Call mma_allocate(Sew_Scr,MemMax,Label='Sew_Scr')
      ipMem1 = 1
*                                                                      *
************************************************************************
*                                                                      *
*     big loop over individual tasks, distributed over individual nodes
   10 Continue
*     make reservation of a task on global task list and get task range
*     in return. Function will be false if no more tasks to execute.
      If (.Not.Rsv_GTList(TskLw,TskHi,iOpt,lDummy)) Go To 11
*
*     Now do a quadruple loop over shells
*
      ijS = Int((One+sqrt(Eight*TskLw-Three))/Two)
      iS = Ind_ij(1,ijS)
      jS = Ind_ij(2,ijS)
      klS = Int(TskLw-DBLE(ijS)*(DBLE(ijS)-One)/Two)
      kS = Ind_ij(1,klS)
      lS = Ind_ij(2,klS)
      Count=TskLw
      Call CWTime(TCpu1,TWall1)
  13  Continue
*
         Aint=TMax(iS,jS)*TMax(kS,lS)
         If (AInt.lt.CutInt) Go To 14
         If (iPrint.ge.15) Write (6,*) 'iS,jS,kS,lS=',iS,jS,kS,lS
*
************************************************************************
*                                                                      *
         Call Gen_iSD4(iS, jS, kS, lS,iSD,nSD,iSD4)
         Call Size_SO_block_g(iSD4,nSD,nSO,No_batch)
         If (No_batch) Go To 140
*
         Call Int_Prep_g(iSD4,nSD,Coor,Shijij,iAOV,iStabs)

*
*                                                                      *
************************************************************************
*                                                                      *
*       --------> Memory Managment <--------
*
*        Compute memory request for the primitives, i.e.
*        how much memory is needed up to the transfer
*        equation.
*
         Call MemRys_g(iSD4,nSD,nRys,MemPrm)
*                                                                      *
************************************************************************
*                                                                      *
         ABCDeq=EQ(Coor(1,1),Coor(1,2)) .and.
     &          EQ(Coor(1,1),Coor(1,3)) .and.
     &          EQ(Coor(1,1),Coor(1,4))
         ijklA=iSD4(1,1)+iSD4(1,2)
     &        +iSD4(1,3)+iSD4(1,4)
         If (nIrrep.eq.1.and.ABCDeq.and.Mod(ijklA,2).eq.1)
     &      Go To 140
*                                                                      *
************************************************************************
*                                                                      *
*        Decide on the partioning of the shells based on the
*        available memory and the requested memory.
*
*        Now check if all blocks can be computed and stored at
*        once.
*

         Call SOAO_g(iSD4,nSD,nSO,
     &               MemPrm, MemMax,
     &               iBsInc,jBsInc,kBsInc,lBsInc,
     &               iPrInc,jPrInc,kPrInc,lPrInc,
     &               ipMem1,ipMem2, Mem1,  Mem2,
     &               iPrint,iFnc, MemPSO)
         iBasi    = iSD4(3,1)
         jBasj    = iSD4(3,2)
         kBask    = iSD4(3,3)
         lBasl    = iSD4(3,4)
*                                                                      *
************************************************************************
*                                                                      *
         Call Int_Parm_g(iSD4,nSD,iAnga,
     &                 iCmpa,iShlla,iShela,
     &                 iPrimi,jPrimj,kPrimk,lPriml,
     &                 indij,k2ij,nDCRR,k2kl,nDCRS,
     &                 mdci,mdcj,mdck,mdcl,AeqB,CeqD,
     &                 nZeta,nEta,ipZeta,ipZI,
     &                 ipP,ipEta,ipEI,ipQ,ipiZet,ipiEta,
     &                 ipxA,ipxB,ipxG,ipxD,l2DI,nab,nHmab,ncd,nHmcd,
     &                 nIrrep)
*                                                                      *
************************************************************************
*                                                                      *
*        Scramble arrays (follow angular index)
*

         Do iCar = 1, 3
            Do iSh = 1, 4
               JndGrd(iCar,iSh) = iSD4(15+iCar,iSh)
               If (iAnd(iSD4(15,iSh),2**(iCar-1)) .eq.
     &             2**(iCar-1)) Then
                  JfGrad(iCar,iSh) = .True.
               Else
                  JfGrad(iCar,iSh) = .False.
               End If
            End Do
         End Do
*
         Do 400 iBasAO = 1, iBasi, iBsInc
           iBasn=Min(iBsInc,iBasi-iBasAO+1)
           iAOst(1) = iBasAO-1
         Do 410 jBasAO = 1, jBasj, jBsInc
           jBasn=Min(jBsInc,jBasj-jBasAO+1)
           iAOst(2) = jBasAO-1
         Do 420 kBasAO = 1, kBask, kBsInc
           kBasn=Min(kBsInc,kBask-kBasAO+1)
           iAOst(3) = kBasAO-1
         Do 430 lBasAO = 1, lBasl, lBsInc
           lBasn=Min(lBsInc,lBasl-lBasAO+1)
           iAOst(4) = lBasAO-1
*
*----------Get the 2nd order density matrix in SO basis.
*
           nijkl = iBasn*jBasn*kBasn*lBasn


*     Fetch the T_i,j,kappa, lambda corresponding to
*     kappa = k, lambda = l
*
#ifdef _CD_TIMING_
           CALL CWTIME(Pget0CPU1,Pget0WALL1)
#endif
           Call PGet0(iCmpa,
     &                iBasn,jBasn,kBasn,lBasn,Shijij,
     &                iAOV,iAOst,nijkl,Sew_Scr(ipMem1),nSO,
     &                iFnc(1)*iBasn,iFnc(2)*jBasn,
     &                iFnc(3)*kBasn,iFnc(4)*lBasn,MemPSO,
     &                Sew_Scr(ipMem2),Mem2,iS,jS,kS,lS,nQuad,PMax)
           If (AInt*PMax.lt.CutInt) Go To 430
#ifdef _CD_TIMING_
           CALL CWTIME(Pget0CPU2,Pget0WALL2)
           Pget_CPU = Pget_CPU + Pget0CPU2-Pget0CPU1
           Pget_Wall = Pget_Wall + Pget0WALL2-Pget0WALL1
#endif
           If (AInt*PMax.lt.CutInt) Go To 430
*
*----------Compute gradients of shell quadruplet
*
#ifdef _CD_TIMING_
           Call CWTIME(TwoelCPU1,TwoelWall1) ! timing_cdscf
#endif
           Call TwoEl_g(Coor,
     &          iAnga,iCmpa,iShela,iShlla,iAOV,
     &          mdci,mdcj,mdck,mdcl,nRys,
     &          Data_k2(k2ij),nab,nHmab,nDCRR,
     &          Data_k2(k2kl),ncd,nHmcd,nDCRS,Pren,Prem,
     &          iPrimi,iPrInc,jPrimj,jPrInc,
     &          kPrimk,kPrInc,lPriml,lPrInc,
     &          Shells(iSD4(0,1))%pCff(1,iBasAO),iBasn,
     &          Shells(iSD4(0,2))%pCff(1,jBasAO),jBasn,
     &          Shells(iSD4(0,3))%pCff(1,kBasAO),kBasn,
     &          Shells(iSD4(0,4))%pCff(1,lBasAO),lBasn,
     &          Mem_DBLE(ipZeta),Mem_DBLE(ipZI),Mem_DBLE(ipP),nZeta,
     &          Mem_DBLE(ipEta), Mem_DBLE(ipEI),Mem_DBLE(ipQ),nEta,
     &          Mem_DBLE(ipxA),Mem_DBLE(ipxB),
     &          Mem_DBLE(ipxG),Mem_DBLE(ipxD),Temp,nGrad,
     &          JfGrad,JndGrd,Sew_Scr(ipMem1), nSO,Sew_Scr(ipMem2),Mem2,
     &          Aux,nAux,Shijij)
#ifdef _CD_TIMING_
           Call CWTIME(TwoelCPU2,TwoelWall2)
           Twoel_CPU = Twoel_CPU + TwoelCPU2-TwoelCPU1
           Twoel_Wall = Twoel_Wall + TwoelWall2-TwoelWall1
#endif
            If (iPrint.ge.15)
     &         Call PrGrad(' In Drvg1: Grad',Temp,nGrad,ChDisp,5)
*
 430     Continue
 420     Continue
*
 410     Continue
 400     Continue
*
 140     Continue
*
 14      Continue
         Count=Count+One
         If (Count-TskHi.gt.1.0D-10) Go To 12
         klS = klS + 1
         If (klS.gt.ijS) Then
            ijS = ijS + 1
            klS = 1
         End If
         iS = Ind_ij(1,ijS)
         jS = Ind_ij(2,ijS)
         kS = Ind_ij(1,klS)
         lS = Ind_ij(2,klS)
         Go To 13
*
*     Task endpoint
 12   Continue
      Call CWTime(TCpu2,TWall2)
      Call SavTim(4,TCpu2-TCpu1,TWall2-Twall1)
      Call SavStat(1,One,'+')
      Call SavStat(2,TskHi-TskLw+One,'+')
      Go To 10
 11   Continue
*     End of big task loop
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _MOLCAS_MPP_
      Call GADGOP(Temp,nGrad,'+')
#endif
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Sew_Scr)
      Call Free_GTList
      Call Free_PPList
      Call Free_TList
      Call mma_deallocate(Ind_ij)
      Call mma_deallocate(TMax)
*                                                                      *
************************************************************************
*                                                                      *
      Call CloseP
#ifdef _CD_TIMING_
      Drvg1_CPU = TCpu2-TCpu1
      Drvg1_Wall= TWall2-TWall1
      Write(6,*) '-------------------------'
      Write(6,*) 'Time spent in Prepp:'
      Write(6,*) 'Wall/CPU',Prepp_Wall, Prepp_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Time spent in Pget:'
      Write(6,*) 'Wall/CPU',Pget_Wall, Pget_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Time spent in Drvg1:'
      Write(6,*) 'Wall/CPU',Drvg1_Wall, Drvg1_CPU
      Write(6,*) '-------------------------'
      Total_Dens_Wall = Prepp_Wall+Pget_Wall
      Total_Dens_CPU = Prepp_CPU+Pget_CPU
      Total_Der_Wall = Drvg1_Wall - Total_Dens_Wall
      Total_Der_CPU = Drvg1_CPU - Total_Dens_CPU
      Total_Der_Wall2 = TwoEl_Wall
      Total_Der_CPU2 = TwoEl_CPU

      Write(6,*) 'Total Time for Density:'
      Write(6,*) 'Wall/CPU',Total_Dens_Wall, Total_Dens_CPU
      Write(6,*) '-------------------------'
      Write(6,*) 'Total Time for Derivatives:'
      Write(6,*) 'Wall/CPU',Total_Der_Wall2, Total_Der_CPU2
      Write(6,*) '-------------------------'
      Write(6,*) 'Derivative check:'
      Write(6,*) 'Wall/CPU',Total_Der_Wall, Total_Der_CPU
      Write(6,*) '-------------------------'
#endif
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*                                                                      *
************************************************************************
*                                                                      *
*
      Call Sync_Data(Pren,Prem,nBtch,mBtch,kBtch)
*
      iPren=3+Max(1,Int(Log10(Pren+0.001D+00)))
      iPrem=3+Max(1,Int(Log10(Prem+0.001D+00)))
      Write (Format,'(A,I2,A,I2,A)') '(A,F',iPren,
     &           '.0,A,F',iPrem,'.0,A)'
      If (iPrint.ge.6) Then
      Write (6,Format)
     &   ' A total of', Pren,' entities were prescreened and',
     &                  Prem,' were kept.'
      End If
*
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_iSD()
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SPGRPCON(IOFSPGRP,NSPGRP,NGAS,MXPNGAS,IELFSPGRP,ISPGRPCON)
! Find connection matrix for string types
!
! ISPGRPCON(ISPGP,JSPGRP) = 0 => spgrps are identical
!                         = 1 => spgrps are connected by single excitation
!                         = 2 => spgrps are connected by double excitation
!                        >= 3 => spgrps are connected by triple or higher excitation
!
! Jeppe Olsen, September 1996

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: wp, u6
#endif

implicit none
integer(kind=iwp), intent(in) :: IOFSPGRP, NSPGRP, NGAS, MXPNGAS, IELFSPGRP(MXPNGAS,*)
integer(kind=iwp), intent(out) :: ISPGRPCON(NSPGRP,NSPGRP)
integer(kind=iwp) :: IDIF, ISPGRP, ISPGRPA, JSPGRP, JSPGRPA, NEXC
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: NEXC1, NEXC2
#endif

do ISPGRP=1,NSPGRP
  ISPGRPA = IOFSPGRP-1+ISPGRP
  do JSPGRP=1,ISPGRP
    JSPGRPA = IOFSPGRP-1+JSPGRP
    IDIF = sum(abs(IELFSPGRP(1:NGAS,ISPGRPA)-IELFSPGRP(1:NGAS,JSPGRPA)))
    NEXC = IDIF/2
    ISPGRPCON(ISPGRP,JSPGRP) = NEXC
    ISPGRPCON(JSPGRP,ISPGRP) = NEXC
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) '===================='
write(u6,*) 'output from SPGRPCON'
write(u6,*) '===================='
write(u6,*)
NEXC1 = 0
NEXC2 = 0
do ISPGRP=1,NSPGRP
  do JSPGRP=1,NSPGRP
    if (ISPGRPCON(ISPGRP,JSPGRP) == 1) then
      NEXC1 = NEXC1+1
    else if (ISPGRPCON(ISPGRP,JSPGRP) == 2) then
      NEXC2 = NEXC2+1
    end if
  end do
end do

write(u6,*) ' single excitation interactions',NEXC1,'( ',real(NEXC1,kind=wp)*100.0_wp/real(NSPGRP,kind=wp)**2,' % )'
write(u6,*) ' double excitation interactions',NEXC2,'( ',real(NEXC2,kind=wp)*100.0_wp/real(NSPGRP,kind=wp)**2,' % )'

write(u6,*) ' Supergroup connection matrix'
call IWRTMA(ISPGRPCON,NSPGRP,NSPGRP,NSPGRP,NSPGRP)
#endif

end subroutine SPGRPCON

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************

subroutine BasFun_Atom(nBas_per_Atom,nBas_Start,BName,nBas,nAtoms,DoPrint)
! Author: Y. Carissan [put in separate subroutine by T.B. Pedersen]

use Definitions, only: iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nAtoms, nBas
integer(kind=iwp), intent(out) :: nBas_per_Atom(nAtoms), nBas_Start(nAtoms)
character(len=LenIn8), intent(in) :: BName(nBas)
logical(kind=iwp), intent(in) :: DoPrint
integer(kind=iwp) :: iAt, iAt1, iBas, iCount, nBasAt
character(len=LenIn) :: Lbl, LblOld
character(len=80) :: Txt, Formt
character(len=*), parameter :: SecNam = 'BasFun_Atom'

! Counters.
! ---------

iAt = 1
nBasAt = 1
LblOld = BName(1)(1:LenIn)
do iBas=2,nBas
  Lbl = BName(iBas)(1:LenIn)
  if (Lbl /= LblOld) then
    nBas_per_Atom(iAt) = nBasAt
    iAt = iAt+1
    nBasAt = 0
    LblOld = Lbl
  end if
  nBasAt = nBasAt+1
end do
nBas_per_Atom(iAt) = nBasAt

if (iAt /= nAtoms) then ! centers without basis functions
  iAt1 = iAt+1
  do iAt=iAt1,nAtoms
    nBas_per_Atom(iAt) = 0
  end do
end if

! Offsets.
! --------

iCount = 0
do iAt=1,nAtoms
  nBas_Start(iAt) = iCount+1
  iCount = iCount+nBas_per_Atom(iAt)
end do
if (iCount /= nBas) then
  write(Txt,'(A,I9,A,I9)') 'iCount =',iCount,'  nBas =',nBas
  call SysAbendMsg(SecNam,'iCount /= nBas',Txt)
end if

! Print.
! ------

if (DoPrint) then
  write(Formt,'(3(a6,i3,a5))') '(/,a6,',nAtoms,'i5,/,','   a6,',nAtoms,'i5,/,','   a6,',nAtoms,'i5)'
  write(u6,Formt) 'Atom  ',(iAt,iAt=1,nAtoms),'Start ',nBas_Start(:),'nBas  ',nBas_per_Atom(:)
end if

end subroutine BasFun_Atom

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine EMFMem(nHer,MemVe,la,lb,lr)
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      nHer=(la+lb+lr+2)/2
      MemVe = 3*nHer*(la+1+lr) * 2
     &      + 3*nHer*(lb+1+lr) * 2
     &      + 3*(la+1+lr)*(lb+1+lr) * 2
      If (lr.eq.1) Then
         MemVe = MemVe
     &         + 6*(la+1)*(lb+1) * 2 + 2
     &         + nElem(la)*nElem(lb)*nElem(lr)*12
      Else
         MemVe = MemVe
     &         + nElem(la)*nElem(lb)*nElem(lr)*2
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lr)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2002, Sergey Gusarov                                   *
*               2002, Roland Lindh                                     *
*               2002, Per Ake Malmqvist                                *
************************************************************************
      Subroutine Do_CS(Rho,nRho,mGrid,nP2,P2_ontop,P2II,
     &                 Coeff,iSpin,F_xc,Type1,Type2,Type3)
************************************************************************
*                                                                      *
* Object: Calculate functional from Colle-Salvetty approximation,      *
*         for MC wave function (basis formuls was written by PAM,      *
*         other by maple & GS (=/= CS!!!))                             *
*                                                                      *
*     Authors: Sergey Gusarov, University of Lund, SWEDEN,             *
*              Roland Lindh,   University of Lund, SWEDEN,             *
*              P.-A.Malmqvist, University of Lund, SWEDEN,             *
*              Dec. 2002                                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Rho(nRho,mGrid), P2_ontop(nP2,mGrid),P2II(mGrid)
      Real*8 gradZ(3),
     &       gradBeta(3),
     &       dgradZdRho(3),
     &       dgradBetadRho(3),
     &       graddZdBeta(3),
     &       graddZdRho(3)
      Real*8 Type1(mGrid)
      Real*8 Type2(mGrid)
      Real*8 Type3(mGrid)
      Real*8 F_xc(mGrid)
*
*     Some functions:
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     Some constants which we need...
*
      qCS = 2.29d0
      SqrtPi = sqrt(Pi)
      Pi32 = sqrt(Pi)*Pi
      Pi2  = Pi*Pi
      Pi52 = sqrt(Pi)*Pi2
      SqrtTwo = sqrt(Two)
*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=1
*
      If (iSpin.eq.1) Then
*                                                                      *
************************************************************************
*                                                                      *
      Do iGrid = 1, mGrid
         rho_alpha =Rho(1,iGrid)
         DTot    = Two*rho_alpha
         If (DTot.lt.1.0D-50) Go To 100
*
*        Beta:
*
         Beta  = qCS*Rho(1,iGrid)**(1.0d0/3.0d0)
         Beta2 = Beta*Beta
         Beta3 = Beta2*Beta
         Beta4 = Beta2*Beta2
         Beta5 = Beta2*Beta3
         Beta6 = Beta4*Beta2
         Beta7 = Beta6*Beta
        dBetadRho = qCS/(3.0d0*Rho(1,iGrid)**(2.0d0/3.0d0))
        Do i=1,3
          gradBeta(i) = qCS*Rho(1+i,iGrid)/
     &                  (3.0d0*Rho(1+i,iGrid)**(2.0d0/3.0d0))
*
          dgradBetadRho(i) = -2.0d0*qCS*Rho(1+i,iGrid)/
     &                    (9.0d0*Rho(1,iGrid)**(5.0d0/3.0d0))
        End Do
*
*
*
        D1  = (SqrtPi*Beta+1.D0)
        D2  = D1**2
        D3  = D1**3
        D4  = D1**4
*
        Y1  = -Two*Pi2*SqrtTwo +
     &         8.0d0*Pi52*Beta +
     &         9.0d0*Pi2 -
     &         24.0d0*Pi -
     &         32.0d0*Pi32*Beta
        Y   = Y1/(8.0d0*Beta2*D2)
*
        Z1  =  24.0d0*Pi52*Beta +
     &         26.0d0*Pi2 -
     &         3.0d0*Pi2*SqrtTwo -
     &         56.0d0*Pi -
     &         64.0d0*Pi32*Beta
        Z   = Z1/(96.0d0*Beta4*D2)
*
        Z2  = 60.0d0*Pi2*Beta2 +
     &        114.0d0*Pi32*Beta -
     &        160.0d0*Pi*Beta2 -
     &        264.0d0*SqrtPi*Beta +
     &        52.0d0*Pi -
     &        9.0d0*Pi32*SqrtTwo*Beta -
     &        6.0d0*Pi*SqrtTwo -
     &        112.0d0
*
        Z3  = -2328.0d0*Pi*Beta2 -
     &         1952.0d0*SqrtPi*Beta +
     &         978.0d0*Pi2*Beta2 -
     &         30.0d0*Pi*SqrtTwo +
     &         260.0d0*Pi +
     &         360.0d0*Pi52*Beta3 -
     &         960.0d0*Pi32*Beta3 -
     &         63.0d0*Pi2*Beta2*SqrtTwo -
     &         84.0d0*Pi32*SqrtTwo*Beta -
     &         560.0d0 +
     &         872.0d0*Pi32*Beta
*
        dZdBeta   = - Z2*Pi/(48.0d0*Beta5*D3)
        d2ZdBeta2 = Pi*Z3/(48.0d0*Beta6*D4)
        dZdRho    =  dZdBeta*dBetadRho
*
        Do i=1,3
*
          gradZ(i) = dZdBeta*gradBeta(i)
*
          dgradZdRho(i) = gradBeta(i)*d2ZdBeta2*dBetadRho +
     &                    dZdBeta*dgradBetadRho(i)
        End Do
*
*
        Z4 = 63.0d0*Pi2*Beta2*SqrtTwo +
     &       84.0d0*Pi32*SqrtTwo*Beta +
     &       560.0d0 +
     &       2328.0d0*Pi*Beta2 +
     &       1952.0d0*SqrtPi*Beta -
     &       260.0d0*Pi -
     &       978.0d0*Pi2*Beta2 +
     &       30.D0*Pi*SqrtTwo -
     &       360.0d0*Pi52*Beta3 -
     &       872.0d0*Pi32*Beta +
     &       960.0d0*Pi32*Beta3
       Z5 =  - Z4/(48.0d0*Beta6*D4)
       Do i=1,3
          graddZdBeta(i) = gradBeta(i)*Z5
       End Do
*
       Do i=1,3
          graddZdRho(i) = graddZdBeta(i)*dBetadRho +
     &                    dZdBeta*dgradBetadRho(i)
       End Do
*
        Y2 = -12.0d0*Pi2*Beta2 -
     &        22.0d0*Pi32*Beta +
     &        48.0d0*Pi*Beta2 +
     &        64.0d0*SqrtPi*Beta +
     &        4.0d0*Pi32*SqrtTwo*Beta +
     &        2.0d0*Pi*SqrtTwo -
     &        9.0d0*Pi +
     &        24.0d0
        dYdRho = Y2*Pi*dBetadRho/(4.0d0*Beta3*D3)
*
        grad2Z = Zero
*
        ii=0
        Do i=1,3
           If(i.eq.1) ii=5
           If(i.eq.2) ii=8
           If(i.eq.3) ii=9
           Betaxx = - Two*qCS*Rho(1+i,iGrid)**2/
     &                (9.0d0*Rho(1,iGrid)**(5.0d0/3.0d0)) +
     &                qCS*Rho(ii,iGrid)/
     &                (3.0d0*Rho(1,iGrid)**(2.0d0/3.0d0))
*
           Betaxx1= gradBeta(i)*gradBeta(i)
*
           Zxx = 60.0d0*Betaxx*Pi52*Beta4 +
     &           174.0d0*Betaxx*Pi2**Beta3 +
     &           166.0d0*Betaxx*Pi32*Beta2 -
     &           160.0d0*Betaxx*Pi32*Beta4 -
     &           424.0d0*Betaxx*Pi*Beta3 -
     &           376.0d0*Betaxx*SqrtPi*Beta2 -
     &           6.0d0*Betaxx*Pi*Beta*SqrtTwo -
     &           360.0d0*Betaxx1*Pi52*Beta3 -
     &           978.0d0*Betaxx1*Pi2*Beta2 -
     &           872.0d0*Betaxx1*Pi32*Beta +
     &           960.0d0*Betaxx1*Pi32*Beta3 +
     &           2328.0d0*Betaxx1*Pi*Beta2 +
     &           1952.0d0*Betaxx1*SqrtPi*Beta +
     &           63.0d0*Betaxx1*Pi2*Beta2*SqrtTwo +
     &           52.0d0*Betaxx*Pi*Beta +
     &           30.0d0*Betaxx1*Pi*SqrtTwo -
     &           112.0d0*Betaxx*Beta +
     &           560.0d0*Betaxx1 -
     &           260.0d0*Betaxx1*Pi +
     &           84.0d0*Betaxx1*Pi32*Beta*SqrtTwo -
     &           15.0d0*Betaxx*Pi32*Beta2*SqrtTwo -
     &           9.0d0*Betaxx*Pi2*Beta3*SqrtTwo
*
           grad2Z = grad2Z - Pi*Zxx/(48.0d0*Beta6*D4)
        End Do
************************************************************************
*                                                                      *
*    We have Y, dY/dRho, Z, grad Z, dZ/dRho, d grad(Z)/dRho, grad^2 Z  *
*       Rho type
*       From d /dRho:
*
        Type1(iGrid) = 0.5d0*(dYdRho*P2_ontop(1,iGrid) -
     &                 0.25d0*ddot_(3,dgradZdRho,1,
     &                        P2_ontop(2,iGrid),mGrid) -
     &                 2.0d0*dZdRho*P2II(iGrid) )
*
*       P2 type
*       From (- grad d /d gradRho):
*
        Type1(iGrid) = Type1(iGrid) + 0.25d0*(
     &                 ddot_(3,graddZdRho,1,
     &                 P2_ontop(2,iGrid),mGrid) +
     &                 dZdRho*(
     &                 P2_ontop( 5,iGrid) +
     &                 P2_ontop( 8,iGrid) +
     &                 P2_ontop(10,iGrid) )  )
*
*    From d / dP2  and grad (d / d(gradP2))
*
        Type2(iGrid) = .5d0*(Y + 0.25d0*grad2Z)
*
*      Other type:
*
        Type3(iGrid) = - Z
*
*
*
        F_xc(iGrid) = 0.50d0*(Y*P2_ontop(1,iGrid) -
     &               0.250d0*ddot_(3,gradZ,1,P2_ontop(2,iGrid),mGrid) -
     &               2.0d0*Z*P2II(iGrid))
*
 100     Continue
      End Do    ! iGrid




************************************************************************
*                                                                      *
*     iSpin=/=1
*
      Else
         Call WarningMessage(2,
     &              'Do_CS: Not implemented yet for iSpin=/=1')
         Call Abend()
*                                                                      *
************************************************************************
*                                                                      *
*
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(Coeff)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine  DefW4y2 (aSGrp,bSGrp,cGrp,dGrp,w4y)
c
c        this routine do:
c        define w4y key, which indicates, if atleast one
c        W4 file need to be calculated on this node for
c        given a",b",c',d'
c
        implicit none
        integer aSGrp,bSGrp,cGrp,dGrp,w4y
#include "chcc1.fh"
#include "o2v4.fh"
#ifdef _MOLCAS_MPP_
#include "parcc.fh"
c
c        help variables
        integer abSGrp,cSGrp,cdSGrp,dSGrp,dSGrpUp
c
        w4y=0
c
c       def abSGrp
        abSGrp=aSGrp*(aSGrp-1)/2+bSGrp
c
c          cycle over  c">=d" for c',d'
          do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
          if (cGrp.eq.dGrp) then
            dSGrpUp=cSGrp
          else
            dSGrpUp=GrpaUp(dGrp)
          end if
          do dSGrp=GrpaLow(dGrp),dSGrpUp
          cdSGrp=cSGrp*(cSGrp-1)/2+dSGrp
            if (InqW4(abSGrp,cdSGrp)) then
              w4y=w4y+1
            end if
          end do
          end do
c
c
#else
        w4y=1
c Avoid unused argument warnings
        if (.false.) then
          call Unused_integer(aSGrp)
          call Unused_integer(bSGrp)
          call Unused_integer(cGrp)
          call Unused_integer(dGrp)
        end if
#endif
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*---------------------------------------------------------------------*
*                                                                     *
*     lDaRec  : minimal record (in 4Byte words) transfered by         *
*               DAFILE                                                *
*     nSect   : integer multiple of lDaRec which consitutes the       *
*               standard record length                                *
*     lStRec  : standard record length in units of integers           *
*     nDiskMx : Max disk space in units of MByte                      *
*     iDiskMx : Max disk space -1 in units of Byte                    *
*                                                                     *
*---------------------------------------------------------------------*
      Module IOBUF
*
      Real*8 DiskMx_MByte, DiskMx_Byte
      Parameter ( lDaRec  = 2**10        ) ! 1024
      Parameter ( nSect   = 2**5         ) ! 32
      Parameter ( lStRec  = nSect*lDaRec )
      Parameter ( Mode_Read = 987654321  )
      Parameter ( Mode_Write= 198765432  )
      Parameter ( Mode_None = 111111111  )
C     Parameter ( DiskMx_MByte=2.0D00**11)
C     Parameter ( DiskMx_Byte =2.0D00**31)
*     Real*8 Buf_IO(lStRec,2)
      Integer iPos, LuTmp, iStatIO, id, iBuf, ipBuf, nBuf, lBuf
      Real*8 Disk, Disk_1, Disk_2
      Logical IODone,InCore,OnDisk
      Real*8, Allocatable:: Buffer(:,:)
*
      End Module IOBUF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

subroutine Energy_Kriging_Layer(qInt,Energy,nInter)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nInter
real(kind=wp), intent(in) :: qInt(nInter)
real(kind=wp), intent(out) :: Energy
real(kind=wp), allocatable :: qInt_s(:)

call mma_allocate(qInt_s,nInter,label='qInt_s')

call Trans_K(qInt,qInt_s,nInter,1)
call Energy_Kriging(qInt_s,Energy,nInter)

call mma_deallocate(qInt_s)

end subroutine Energy_Kriging_Layer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRWVF(IORBTAB,ISSTAB,IFSBTAB,PRTHR,CI)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IORBTAB(*), ISSTAB(*), IFSBTAB(*)
real(kind=wp), intent(in) :: PRTHR, CI(*)
integer(kind=iwp) :: I, IBLKDET, ICI, ICREL, IFSB, IMORS, INDX, ISBS, ISORB, ISPART, ISST, ISSTARR(50), ISUM, KPOS, KSBSMRS, &
                     KSPART, KSSTTB, KSTARR, N, NASPRT, NBLKDET, NDIMARR(50), NFSB, NPRINTED, NSSTP
character(len=80) :: DETTXT
integer(kind=iwp), allocatable :: SBSET(:)

! The orbital table:
NASPRT = IORBTAB(9)
KSPART = IORBTAB(10)
! The substring table:
NSSTP = ISSTAB(7)
KSSTTB = 15
KSBSMRS = ISSTAB(11)
! The FS blocks of the SGM wave function:
NFSB = IFSBTAB(3)
KSTARR = 8
! Make an array with nr of earlier substrings for each
! substring type:
call mma_allocate(SBSET,NSSTP,Label='SBSET')
ISUM = 0
do ISST=1,NSSTP
  SBSET(ISST) = ISUM
  ISUM = ISUM+ISSTAB(KSSTTB+5*(ISST-1))
end do
! Loop over FS blocks of the SGM wave function
NPRINTED = 0
do IFSB=1,NFSB
  KPOS = KSTARR+(NASPRT+2)*(IFSB-1)
  ISSTARR(1:NASPRT) = IFSBTAB(KPOS:KPOS+NASPRT-1)
  NBLKDET = IFSBTAB(KPOS+NASPRT)
  IBLKDET = IFSBTAB(KPOS+NASPRT+1)
  ! Dimension of each substring type:
  do ISPART=1,NASPRT
    ISST = ISSTARR(ISPART)
    NDIMARR(ISPART) = ISSTAB(KSSTTB+5*(ISST-1))
  end do
  do ICREL=1,NBLKDET
    ICI = IBLKDET-1+ICREL
    if (abs(CI(ICI)) >= PRTHR) then
      ! Get occupation array in the form of string DETTXT:
      INDX = ICREL-1
      ISORB = 0
      do ISPART=1,NASPRT
        N = NDIMARR(ISPART)
        I = mod(INDX,N)
        INDX = INDX-N*I
        ISST = ISSTARR(ISPART)
        ISBS = SBSET(ISST)+I+1
        IMORS = ISSTAB(KSBSMRS+2*(ISBS-1))
        N = IORBTAB(KSPART-1+ISPART)
        call MORSWRITE(IMORS,DETTXT(ISORB+1:ISORB+N))
        ISORB = ISORB+N
      end do
      write(u6,'(1x,a,5x,f16.8)') DETTXT(1:ISORB),CI(ICI)
      NPRINTED = NPRINTED+1
    end if
  end do
  ! End of loop over FS blocks
end do
if (NPRINTED == 0) write(u6,*) ' (PRWVF: Nothing worth printing)'
call mma_deallocate(SBSET)

end subroutine PRWVF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_P_Distrib_SP(iOpt,mySP,N_mySP)
C
C     Thomas Bondo Pedersen, June 2007.
C
C     Determine distribution of ShellPairs.
C     iOpt=1: each node has same number of ShellPairs.
C     iOpt=2: each node has same dimension.
C
      Implicit None
      Integer iOpt
      Integer mySP(*)
      Integer N_mySP
#include "cholesky.fh"

      N_mySP = 0
      If (iOpt .eq. 1) Then
         Call Cho_P_Distrib_Vec(1,nnShl,mySP,N_mySP)
      Else
         Call Cho_P_Distrib_SP_byDim(mySP,N_mySP)
      End If

      End
      SubRoutine Cho_P_Distrib_SP_byDim(mySP,N_mySP)
C
C     Thomas Bondo Pedersen, June 2007.
C
C     Determine distribution of ShellPairs by dimension.
C
      Implicit None
      Integer mySP(*)
      Integer N_mySP
#include "cho_para_info.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer  Cho_iSumElm
      External Cho_iSumElm
      Integer  Cho_iFindSmallest
      External Cho_iFindSmallest

      Integer iSP, iNode, n
      Integer ip_Dim, l_Dim
      Integer iAB, iA, iB

      Integer iSP2F, nBstSh
      Integer i
      iSP2F(i)=iWork(ip_iSP2F-1+i)
      nBstSh(i)=iWork(ip_nBstSh-1+i)

      If (Cho_Real_Par) Then

         l_Dim = nProcs
         Call GetMem('ProcDim','Allo','Inte',ip_Dim,l_Dim)
         Call iZero(iWork(ip_Dim),l_Dim)

         N_mySP = 0
         Do iSP = 1,nnShl
            iAB = iSP2F(iSP)
            Call Cho_InvPck(iAB,iA,iB,.True.)
            If (iA .eq. iB) Then
               n = nBstSh(iA)*(nBstSh(iA)+1)/2
            Else
               n = nBstSh(iA)*nBstSh(iB)
            End If
            iNode = Cho_iFindSmallest(iWork(ip_Dim),l_Dim) - 1
            iWork(ip_Dim+iNode) = iWork(ip_Dim+iNode) + n
            If (iNode .eq. myRank) Then
               N_mySP = N_mySP + 1
               mySP(N_mySP) = iSP
            End If
         End Do

         Call GetMem('ProcDim','Free','Inte',ip_Dim,l_Dim)

      Else

         N_mySP = nnShl
         Do iSP = 1,N_mySP
            mySP(iSP) = iSP
         End Do

      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ClsFls_MCLR()
!***********************************************************************
!                                                                      *
!     Open files.                                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use MCLR_Data, only: FnMck, LuCSF2SD, LuJob, LuMck, LuQDat, LuTemp, LuTri1, SA
use input_mclr, only: iMethod, RASSI, TwoStep
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iOpt, iRC
logical(kind=iwp) :: DoCholesky
integer(kind=iwp), external :: AixRm

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
if (iMethod == 2) then
  call DaClos(LuCSF2sd)
  !---  close the JOBIPH file -----------------------------------------*
  call DaClos(LuJob)
end if
call DaClos(LuTemp)
!---  close the ORDINT file -------------------------------------------*
call DecideonCholesky(DoCholesky)
if (.not. DoCholesky) then
  iRc = -1
  call ClsOrd(iRc)
  if (iRc /= 0) then
    write(u6,*) 'ClsFls: Error closing ORDINT'
    call Abend()
  end if
end if
call DaClos(LuTri1)
if (TwoStep) then
  call DaClos(LuQDAT)
  !call DaClos(LuMOTRA)
end if

! Close the MckInt file or Remove the MCKINT file if SA----------------*
! Do not remove file if we are producing data on the MckInt file for
! the RASSI module!

if (SA .and. (.not. RASSI)) then
  ! What the...? No control at all on what file is being removed!
  !call DaEras(LuMck)
  call DaClos(LuMck)
  iRC = AixRM(FnMck)
else
  iRc = -1
  iOpt = 0
  call ClsMck(iRc,iOpt)
  if (iRc /= 0) then
    write(u6,*) 'ClsFls: Error closing MCKINT'
    call Abend()
  end if
end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*
return

end subroutine ClsFls_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_T1 (T1,key)
c
c        check T1
c
        implicit none
#include "chcc1.fh"
        real*8 T1(1:nv,1:no)
c
c        help var
        integer be,u,i,j,a,b,bad
        integer key
        real*8 s
c
        bad=0
c
        do u=1,no
        do be=1,nv
c
          s=0.0d0
c
          do a=1,nv
          s=s+Hvvc(be,a)*T1c(a,u)
          end do
c
          do i=1,no
          s=s-Hooc(i,u)*T1c(be,i)
          end do
c
          do i=1,no
          do a=1,nv
             s=s+Hvoc(a,i)*
     c      (2.0d0*T2c(a,be,i,u)-T2c(a,be,u,i)+T1c(a,u)*T1c(be,i))
          end do
          end do
c
          do i=1,no
          do a=1,nv
           s=s+(2.0d0*Q21(a,i,be,u)-Q22(a,be,i,u))*T1c(a,i)
          end do
          end do
c
          do i=1,no
          do b=1,nv
          do a=1,nv
             s=s+(2.0d0*Q3(b,be,a,i)-Q3(a,be,b,i))*
     c          (T2c(a,b,i,u)+T1c(a,i)*T1c(b,u))
          end do
          end do
          end do
c
          do i=1,no
          do j=1,no
          do a=1,nv
             s=s-(2.0d0*Q1(a,i,u,j)-Q1(a,j,u,i))*
     c          (T2c(a,be,i,j)+T1c(a,i)*T1c(be,j))
          end do
          end do
          end do
c
c            s=s/(Oeo(u)-Oev(be))
c
          if (abs(T1(be,u)-s).gt.1.0d-10) then
            bad=bad+1
            if (key.eq.1) then
              T1(be,u)=s
            end if
          end if
c
        end do
        end do
c
         write (6,*) ' T1 test :',bad
c
        return
        end
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine get_pivot_idx(Diag,n,m,lu_A0,lu_A,iD_A,Scr,lScr,Thr)
!***********************************************************************
!                                                                      *
!     Author:  F. Aquilante                                            *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: Diag(*)
integer(kind=iwp), intent(in) :: n, lu_A0, lu_A, lScr
integer(kind=iwp), intent(out) :: m, iD_A(n)
real(kind=wp), intent(out) :: Scr(lScr)
real(kind=wp), intent(in) :: Thr
#include "warnings.h"
integer(kind=iwp) :: i, iAddr, iD_Col, ij, is, istart, js, k, kAddr, kCol, ks, kScr, lindep, lmax, nMem_Col
real(kind=wp) :: Acc, XMax
integer(kind=iwp), allocatable :: list(:)

#ifdef _DEBUGPRINT_
!-tbp: check diagonal for negative entries
n_NegInpDiag = 0
d_NegInpDiag = Zero
do i=1,n
  if (Diag(i) < Zero) then
    n_NegInpDiag = n_NegInpDiag+1
    if (Diag(i) < d_NegInpDiag) then
      d_NegInpDiag = Diag(i)
    end if
  end if
end do
write(u6,'(A,I10,A,I10)') 'GET_PIVOT_IDX: number of negative input diagonals:',n_NegInpDiag,' out of ',n
if (n_NegInpDiag > 0) then
  write(u6,'(A,1P,D12.4)') 'GET_PIVOT_IDX: most negative diagonal:          ',d_NegInpDiag
end if
#endif

Acc = min(1.0e-12_wp,thr*1.0e-2_wp)
call mma_Allocate(List,n,Label='List')
do i=1,n
  list(i) = i
end do

lmax = lScr-2*n
if (lmax < n) then
  call WarningMessage(2,'Error in Get_Pivot_idx')
  write(u6,*) ' Get_Pivot_idx: too little scratch space!! '
  call Quit(_RC_CHO_LOG_)
end if

nMem_Col = min(lmax/n,n)

kAddr = 0
is = 1+n
ij = n*nMem_Col
ks = is+ij
kScr = lScr-n-ij

m = 0
do kCol=1,n

  iD_Col = 0
  XMax = Zero
  do i=1,n
    if (abs(Diag(i)) > xMax+Acc) then
      iD_Col = i
      xMax = abs(Diag(i))
    end if
  end do
  if ((iD_Col < 0) .or. (iD_Col > n)) then
    write(u6,*) 'Get_Pivot_id: Index of Max Diag out of bounds!'
    write(u6,*) 'iD_Col = ',iD_Col
    call Abend()
  else if (iD_Col == 0) then
    exit
  end if
  iD_A(kCol) = iD_Col ! set the mapping

  js = n*(kCol-1)+is ! overlay A and Z
  if (kCol > nMem_Col) js = 1

  kAddr = n*(iD_Col-1)
  call dDaFile(lu_A0,2,Scr(js),n,kAddr)

  call CHO_FACTOR(Diag,Scr(js),iD_A,kCol,n,Scr(is),nMem_Col,lu_A,Scr(ks),kScr,thr,lindep)

  if (lindep /= 0) exit

  list(iD_Col) = 0
  m = m+1

  iAddr = n*(kCol-1)
  if (kCol > nMem_Col) call dDaFile(lu_A,1,Scr,n,iAddr)

end do

iAddr = 0
call dDaFile(lu_A,1,Scr(is),ij,iAddr)

if (m < n) then
  istart = 1
  do k=m+1,n
    do i=istart,n
      if (list(i) /= 0) then
        iD_A(k) = i
        istart = i+1
        exit
      end if
    end do
  end do
else if (m > n) then
  write(u6,*) 'Get_Pivot_id: m > n is not possible!'
  call Abend()
end if
call mma_deallocate(List)

return

end subroutine get_pivot_idx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine AverMEP(Kword,Eint,Poli,ici,SumElcPot
     &                  ,NCountField,PertElcInt
     &                  ,iQ_Atoms,nBas,nOcc,natyp,nntyp)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "qminp.fh"
#include "qm1.fh"
#include "qm2.fh"
#include "qmcom.fh"
#include "files_qmstat.fh"
#include "WrkSpc.fh"
#include "warnings.fh"
      Dimension Eint(MxQCen,10),Poli(MxQCen,10)
      Dimension SumElcPot(MxQCen,10)
      Dimension PertElcInt(MxBas*(MxBas+1)/2),SumOld(MxQCen,10)
      Dimension iCent(MxBas*MxBas)
      Dimension iMME(MxMltp*(MxMltp+1)*(MxMltp+2)/6)
      Dimension nOcc(*),natyp(*),ForceNuc(MxAt,3)

      Character*4 Kword
      Character*20 MemLab,MemLab1
      Logical Exist
      Dimension iiDum(1)

      Call UpCase(Kword)
***************
* This subroutine include three different options. All have to do with the
* calculation of a Mean Electrostatic Potential, Field and Field gradients,
* and to evalute the perturbation of them in the One electron Hamiltoniam
* this perturbation is added to the SEWARD One Electron File.
* Option 1: Add the components of Potential, etc
* Option 2: Obtain the Average
* Option 3: Calculate the electrostatic perturbation energy integrals
*           and add them to the one-electron file.
* Calculation involve up to the field gradients because the charge density
* is expanded to the quadrupoles. If the expansion is bigger the number 10
* must be changed, but also all the eqscf and eqras subroutines shoud be
* change in the last option the array nMlt is used instead of the
* number so if a smaller expantion is used, non problem,
* since this index take care of that.
******************
*
*-- The keywords and their labels.
*
      If(Kword(1:4).eq.'ADD ') Go To 101
      If(Kword(1:4).eq.'AVER') Go To 102
      If(Kword(1:4).eq.'PERT') Go To 103

101   Continue
      Do 1001, i=1,iCi
        Do 1002, j=1,10 !Charges (1),Dipoles(3),Quadrupoles(6)
          SumOld(i,j)=SumElcPot(i,j)
          SumElcPot(i,j)=SumOld(i,j)+Eint(i,j)+Poli(i,j)
1002    Continue
1001  Continue
      If(iPrint.ge.9) then
        Write(6,*)'Total Sum Potential'
        Do 1010, i=1,iCi
           Write(6,*)(SumElcPot(i,j),j=1,10)
1010    Continue
      Endif
      Go to 9999

102   Continue
      Do 2001, i=1,iCi
        Do 2002, j=1,10 !Charges (1),Dipoles(3),Quadrupoles(6)
          AvElcPot(i,j)=SumElcPot(i,j)/Dble(NCountField)
2002    Continue
*
*-- The order of Field gradients is changed in order to follow
*-- the same order than Molcas
*
      AvTemp=AvElcPot(i,8)         ! This change is due to the
      AvElcPot(i,8)=AvElcPot(i,7)  ! different order of quadrupoles
      AvElcPot(i,7)=AvTemp         ! in QmStat and Molcas.
2001  Continue                     ! QmStat:xx,xy,yy,xz,yz,zz
                                   ! Molcas:xx,xy,xz,yy,yz,zz

********************************
* This multiplication comes because the off-diagonal
* quadrupoles must be multiply by two since we use
* a triangular form to compute the Interaction
* Energy with the Electric Field Gradient.
* Since it is easier multiply the Average potential
* than the quadrupole for each pair of basis, we perform
* the multiplication here
***********************
      AvElcPot(i,6)=2.0d0*AvElcPot(i,6)
      AvElcPot(i,7)=2.0d0*AvElcPot(i,7)
      AvElcPot(i,9)=2.0d0*AvElcPot(i,9)
***********************
      If(iPrint.ge.9) then
        Write(6,*)'Total Averg Potential'
        Do 1020, i=1,iCi
           Write(6,*)(AvElcPot(i,j),j=1,10)
1020    Continue
      Endif

      Go to 9999


103   Continue
*
*----First we read the multipoles expansion for each pair of basis.
*----The index iCent(i) will give us to which center belongs each pair of basis.
*
      Call GetMem('Dummy','Allo','Inte',iDum,nBas**2)
      Call MultiNew(iQ_Atoms,nBas,nOcc,natyp,nntyp,iMME
     &             ,iCent,iWork(iDum),nMlt,outxyz,SlExpQ,.false.)
      Call GetMem('Dummy','Free','Inte',iDum,nBas**2)


**********************
* Calculate the forces for the nuclei
* these forces will compensate parcially
* the forces due to the electrons
* They will be printed and added to the
* RUNFILE in the optimization procedure
* after Alaska module
*********************
* This model do not work
* To calculate the forces in the nuclei
* with a Slater representation since
* you have to calculate the field
* in a set of point charges and not in
* distributed charges as the field is calculated
* when used Slater representation
* also there are a more dark and complicated
* problem about the string interaction keeping
* together the distributed electronic charge
* and the point nuclear charge under different
* forces.
**********************
      Do 2030, i=1,iQ_Atoms
         Do 2032, j=1,3
           ForceNuc(i,j)=ChaNuc(i)*AvElcPot(i,j+1)
2032     Continue
2030  Continue
      iLuField=63
      iLuField=IsFreeUnit(iLuField)
      Call OpnFl(FieldNuc,iLuField,Exist)
         Write(6,*)'FieldNuc',FieldNuc
      Do 2036, i=1,iQ_Atoms
         Write(iLuField,*)(ForceNuc(i,j),j=1,3)
2036  Continue
      Close(iLuField)

      If(iPrint.ge.9) then
        Write(6,*)'Nuclei charge and Forces'
        Do 1030, i=1,iQ_Atoms
           Write(6,*)ChaNuc(i),(ForceNuc(i,j),j=1,3)
1030    Continue
      Endif
*********************

      nTyp=0
      Do 3000, i=1,nMlt
        nTyp=nTyp+i*(i+1)/2
3000  Continue
      Do 3001, i=1,(nBas*(nBas+1)/2)
          PertElcInt(i)=0.0d0
3001  Continue

*-- Put quadrupoles in Buckinghamform.
*
      Do 191, i1=1,nBas
        Do 192, i2=1,i1
          indMME=i2+i1*(i1-1)/2
           Do 194, j=5,10
             Work(iMME(j)+indMME-1)=
     &                Work(iMME(j)+indMME-1)*1.5
194        Continue
          Tra=Work(iMME(5)+indMME-1)
     &    +Work(iMME(8)+indMME-1)+Work(iMME(10)+indMME-1)
          Tra=Tra/3
          Work(iMME(5)+indMME-1)=Work(iMME(5)+indMME-1)-Tra
          Work(iMME(8)+indMME-1)=Work(iMME(8)+indMME-1)-Tra
          Work(iMME(10)+indMME-1)=Work(iMME(10)+indMME-1)-Tra
192     Continue
191   Continue



      irc=-1
      Lu_One=49
      Lu_One=IsFreeUnit(Lu_One)
      Call OpnOne(irc,0,'ONEINT',Lu_One)
      If(irc.ne.0) then
        Write(6,*)
        Write(6,*)'ERROR! Could not open one-electron integral file.'
        Call Quit(_RC_IO_ERROR_READ_)
      Endif

*
*---We Read the size of the unperturbed Hamiltonian 'OneHam 0' in OneInt.
*
      irc=-1
      iOpt=1
      iSmLbl=1
      nSize=0
      Call iRdOne(irc,iOpt,'OneHam 0',1,iiDum,iSmLbl)
      nSize=iiDum(1)
      If(irc.ne.0) then
        Write(6,*)
        Write(6,*)'ERROR! Failed to read number of one-electron i'
     &//'ntegrals.'
        Call Quit(_RC_IO_ERROR_READ_)
      Endif
      If(nSize.eq.0) then
        Write(6,*)
        Write(6,*)'ERROR! Problem reading size of unperturbed'
     &//' Hamiltonian in OneInt'
        Call Quit(_RC_IO_ERROR_READ_)
      Endif

*---Memory allocation for the unperturbed Hamiltonian
      Write(MemLab,*)'MAver'
      Call GetMem(MemLab,'Allo','Real',iH0,nSize+4)
      irc=-1
      iOpt=0
      iSmLbl=0

*---Read the unperturbed Hamiltonian
      Call RdOne(irc,iOpt,'OneHam 0',1
     &          ,Work(iH0),iSmLbl) !Collect non perturbed integrals
      Write(MemLab1,*)'MAver1'
      Call GetMem(MemLab1,'Allo','Real',iH1,nSize+4)
      If(iPrint.ge.9) then
        Call TriPrt('Non Perturb One-e',' ',Work(iH0),nBas)
      Endif
*

*---We perform the multiplication for each pair of basis in a triangular form.
*---The perturbation is added to the unperturbed Hamiltonian 'iH0'.
*
      kaunta=0
      Do 3003, iB1=1,nBas
        Do 3004, iB2=1,iB1
          kaunta=kaunta+1
          indMME=iB2+iB1*(iB1-1)/2
          Do 3005, iTyp=1,nTyp
            PertElcInt(indMME)=PertElcInt(indMME)
     &        +AvElcPot(iCent(kaunta),iTyp)*Work(iMME(iTyp)+indMME-1)
3005      Continue
          Work(iH1+kaunta-1)=Work(iH0+kaunta-1)+PertElcInt(indMME)
3004    Continue
3003  Continue

      If(iPrint.ge.9) then
        Call TriPrt('H0+Elec One-e',' ',Work(iH1),nBas)
      Endif

*---The non-Electrostatic perturbation is added. The PertNElcInt array comes
*---throught the include file qminp.fh.

      If(iPrint.ge.10) then
        Call TriPrt('PertNElcInt-e',' ',PertNElcInt,nBas)
      Endif

      iTriBasQ=nBas*(nBas+1)/2
      Call DaxPy_(iTriBasQ,ONE,PertNElcInt,iONE,Work(iH1),iONE)

      If(iPrint.ge.9) then
        Call TriPrt('H0+Elec+nonEl One-e',' ',Work(iH1),nBas)
      Endif

*----The perturbed Hamiltonian 'H1' is writen in OneInt.
      irc=-1
      iOpt=0
      iSmLbl=1
      Call WrOne(irc,iOpt,'OneHam  ',1
     &          ,Work(iH1),iSmLbl) !Write  perturbed integrals
      If(iPrint.ge.9) then
        Call TriPrt('Perturb One-e',' ',Work(iH1),nBas)
      Endif

      If(iPrint.ge.10) then
        Call TriPrt('Non Perturb One-e AGAIN',' ',Work(iH0),nBas)
      Endif

      Call ClsOne(irc,Lu_One)

      Call GetMem(MemLab,'Free','Real',iH0,nSize+4)
      Call GetMem(MemLab1,'Free','Real',iH1,nSize+4)


9999  Continue

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine updvec_cvb(upd,iorb,jorb,niprev,iprev,
     >  orbs,north,corth)
c  Find update for IORB as projection of JORB on allowed space
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension upd(norb)
      dimension iprev(niprev),orbs(norb,norb)
      dimension north(norb),corth(norb,niorth)
      dimension dum(1)

      i1 = mstackr_cvb(norb*norb)
      noffort=0
      do 100 ior=1,iorb-1
      noffort=noffort+north(ior)
100   continue
c  Collect all constraints and find span :
      call span0_cvb(norb,norb)
      if(north(iorb).gt.0)
     >  call span1_cvb(corth(1,1+noffort),north(iorb),dum,norb,0)
      do 200 i=1,niprev
      call span1_cvb(orbs(1,iprev(i)),1,dum,norb,0)
200   continue
      call span1_cvb(orbs(1,iorb),1,dum,norb,0)
      call span2_cvb(w(i1),ncon,dum,norb,0)

c  Orthogonalise update to all remaining constraints
      call fmove_cvb(orbs(1,jorb),upd,norb)
      call schmidtd_cvb(w(i1),ncon,upd,1,dum,norb,0)
      call mfreer_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FMMM(A,B,C,NROW,NCOL,NSUM)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NROW, NCOL, NSUM
real(kind=wp), intent(in) :: A(NROW,NSUM), B(NSUM,NCOL)
real(kind=wp), intent(out) :: C(NROW,NCOL)
integer(kind=iwp) :: I, J, K, KK
real(kind=wp) :: T
integer(kind=iwp), parameter :: KS = 48

C(:,:) = Zero

do KK=1,NSUM,KS
  do I=1,NROW
    do J=1,NCOL
      T = C(I,J)
      do K=KK,min(KK+KS-1,NSUM)
        T = T+B(K,J)*A(I,K)
      end do
      C(I,J) = T
    end do
  end do
end do

return

end subroutine FMMM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_dDipM(dDipM,DipM,mInter,nInter)
************************************************************************
*                                                                      *
*     Objective: to compute the dipole moment derivative in Cartesians *
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *

      Implicit Real*8 (a-h,o-z)
#include "info_slapaf.fh"
#include "WrkSpc.fh"
      Real*8 dDipM(3,mInter), DipM(3)
      Logical Found
*
      nX=3*nsAtom
*
      Call Allocate_Work(ipTmp2,nX**2)
      Call Allocate_Work(ipBOld,nX*nInter)
      Call Qpg_dArray('BMxOld',Found,nBMx)
      If (Found.and.(nBMx.eq.nX*nInter)) Then
         Call Get_dArray('BMxOld',Work(ipBOld),nX*nInter)
      Else
         Call Get_dArray('BMtrx',Work(ipBOld),nX*nInter)
      End If
      If (mTROld.gt.0) Then
         Call Allocate_Work(ipTROld,nX*mTROld)
         Call Qpg_dArray('TROld',Found,nTR)
         If (Found.and.(nTR.eq.nX*mTROld)) Then
            Call Get_dArray('TROld',Work(ipTROld),nX*mTROld)
         Else
            Call Get_dArray('TR',Work(ipTROld),nX*mTROld)
         End If
      Else
         ipTROld = ip_Dummy
      End If
*
      Call Get_dDipM_(nX,Work(ipBOld),Work(ipTROld),mInter,nInter,Degen,
     &                Work(ipTmp2),dDipM,mTROld,Work(ipCx),Smmtrc,
     &                nsAtom,DipM)
*
      If (mTROld.gt.0) Call Free_Work(ipTROld)
      Call Free_Work(ipBOld)
      Call Free_Work(ipTmp2)
*
      Return
      End
      Subroutine Get_dDipM_(nX,BMtrx,TRVec,mInter,nInter,Degen,
     &                     Tmp2,dDipM,mTR,Coor,Smmtrc,nAtom,DipM)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Logical Smmtrc(3,nAtom)
      Real*8 TRVec(nX,mTR), Degen(3,nAtom), BMtrx(nX,nInter),
     &       Tmp2(nX**2), Coor(3,nAtom), dDipM(3,nInter+mTR), DipM(3)
*
      Real*8 CM(3)
      Parameter ( thr = 1.0D-12 )
#ifdef _DEBUGPRINT_
      Call RecPrt('TRVec',' ',TRVec,nX,mTR)
      Call RecPrt('BMtrx',' ',BMtrx,nX,nInter)
      Call RecPrt('dDipM',' ',dDipM,3,nInter+mTR)
      Call RecPrt('DipM',' ',DipM,3,1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Analysis of the translational and rotational modes.
*     Compute the dipole moment derivative with respect to the
*     translational and rotational modes.
*
      Do i = 1, 3
         CM(i)=Zero
         rNorm=Zero
         Do iAtom = 1, nAtom
            rNorm=rNorm+Degen(i,iAtom)
            If (Smmtrc(i,iAtom)) Then
               CM(i) = CM(i) + Degen(i,iAtom)*Coor(i,iAtom)
            End If
         End Do
         CM(i)=CM(i)/rNorm
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Loop over the rotations and translations
*
      iTR=nInter+mTR
      Do iX = mTR, 1, -1
         Tx=Zero
         Ty=Zero
         Tz=Zero
         Rx=Zero
         Ry=Zero
         Rz=Zero
         Do i = 1, nAtom
            Tx = Tx + TRVec((i-1)*3+1,iX)*Degen(1,i)
            Ty = Ty + TRVec((i-1)*3+2,iX)*Degen(2,i)
            Tz = Tz + TRVec((i-1)*3+3,iX)*Degen(3,i)
            Rx = Rx +(TRVec((i-1)*3+2,iX)*(Coor(3,i)-CM(3)) -
     &                TRVec((i-1)*3+3,iX)*(Coor(2,i)-CM(2)))
     &              * Degen(1,i)
            Ry = Ry +(TRVec((i-1)*3+3,iX)*(Coor(1,i)-CM(1)) -
     &                TRVec((i-1)*3+1,iX)*(Coor(3,i)-CM(3)))
     &              * Degen(2,i)
            Rz = Rz +(TRVec((i-1)*3+1,iX)*(Coor(2,i)-CM(2)) -
     &                TRVec((i-1)*3+2,iX)*(Coor(1,i)-CM(1)))
     &              * Degen(3,i)
         End Do
#ifdef _DEBUGPRINT_
         Write (6,*) 'Tx,Ty,Tz=',Tx,Ty,Tz
         Write (6,*) 'Rx,Ry,Rz=',Rx,Ry,Rz
#endif
*
         If (Rx**2+Ry**2+Rz**2.lt.thr .and.
     &       Tx**2+Ty**2+Tz**2.gt.thr) Then
*
*-----------Translation, dipole moment invariant to translation
*
*
#ifdef _DEBUGPRINT_
            Write (6,*) 'Translation'
#endif
            call dcopy_(3,[Zero],0,dDipM(1,iTR),1)
*
         Else If (Tx**2+Ty**2+Tz**2.lt.thr .and.
     &            Rx**2+Ry**2+Rz**2.gt.thr) Then
            rNorm=(Rx**2+Ry**2+Rz**2)
*
*           Rotation, dipole moment variant to rotation
*
            If (rNorm.gt.thr) Then
*
*              General axis
*
               dDipM(1,iTR)= (DipM(2)*Rz - DipM(3)*Ry)/rNorm
               dDipM(2,iTR)= (DipM(3)*Rx - DipM(1)*Rz)/rNorm
               dDipM(3,iTR)= (DipM(1)*Ry - DipM(2)*Rx)/rNorm
            Else
               Call WarningMessage(2,' GF: too small rNorm!')
               Call Abend()
*
            End If
         End If
         iTR = iTR - 1
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('dDipM(Original)',' ',dDipM,3,nInter+mTR)
#endif
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*
*     Now backtransform to cartesian coordinates.
*
*     dmu/dx = dq/dx  dmu/dq
*
      Do ix = 1, 3
*
         jj = 0
         jjj = 0
         Do jAtom = 1, nAtom
            Do jx = 1, 3
               jjj = jjj + 1
               If (Smmtrc(jx,jAtom)) Then
                  jj = jj + 1
                  ij=(jj-1)*3+ix
*
                  tmp_ij=0.0D0
                  Do k = 1, nInter
                     tmp_ij = tmp_ij + dDipM(ix,k) * BMtrx(jjj,k)
                  End Do
                  Do k = 1, mTR
                     tmp_ij = tmp_ij + dDipM(ix,nInter+k) * TRVec(jjj,k)
                  End Do
                  Tmp2(ij)=tmp_ij
*
               End If
            End Do
         End Do
*
      End Do
      call dcopy_(3*mInter,Tmp2,1,dDipM,1)
#ifdef _DEBUGPRINT_
      Call RecPrt('dDipM(cartesian)',' ',dDipM,3,mInter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SETSH(IBASSH,NBASSH,NBSTSH,IBAS,NBAS,ISOSHL,NSYM,NSHELL,NBAST)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NSYM, IBAS(NSYM), NBAS(NSYM), NBAST, ISOSHL(NBAST), NSHELL
integer(kind=iwp), intent(out) :: IBASSH(NSYM,NSHELL), NBASSH(NSYM,NSHELL), NBSTSH(NSHELL)
integer(kind=iwp) :: IA, ISHL, ISYM

NBASSH(:,:) = 0
do ISYM=1,NSYM
  do IA=1,NBAS(ISYM)
    ISHL = ISOSHL(IBAS(ISYM)+IA)
    NBASSH(ISYM,ISHL) = NBASSH(ISYM,ISHL)+1
  end do
end do

do ISHL=1,NSHELL
  IBASSH(1,ISHL) = 0
  NBSTSH(ISHL) = NBASSH(1,ISHL)
  do ISYM=2,NSYM
    IBASSH(ISYM,ISHL) = NBSTSH(ISHL)
    NBSTSH(ISHL) = NBSTSH(ISHL)+NBASSH(ISYM,ISHL)
  end do
end do

end subroutine CHO_SETSH

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine KnEInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: to compute the kinetic energy integrals with the Gauss-      *
!         Hermite quadrature.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!             Modified to multipole moments November '90               *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW
use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "rmat_option.fh"
#include "rmat.fh"
#include "print.fh"
integer(kind=iwp) :: iBeta, icop, ipA, ipAOff, ipAxyz, ipB, ipBOff, ipBxyz, ipDi, ipqC, ipQxyz, iPrint, ipRnr, ipRxyz, ipTxyz, &
                     iRout, lsum, nip
logical(kind=iwp) :: ABeq(3)

#include "macros.fh"
unused_var(ZInv)
unused_var(lOper)
unused_var(iChO)
unused_var(iStabM)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 150
iPrint = nPrint(iRout)
ABeq(:) = A == RB

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+2)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+2)
ipRxyz = nip
nip = nip+nZeta*3*nHer*(nOrdOp-1)
ipQxyz = nip
nip = nip+nZeta*3*(la+2)*(lb+2)*(nOrdOp-1)
ipTxyz = nip
nip = nip+nZeta*3*(la+1)*(lb+1)
ipA = nip
nip = nip+nZeta
ipB = nip
nip = nip+nZeta
!                                                                      *
!***********************************************************************
!                                                                      *
if (RMat_type_integrals) then
  ipRnr = nip
  nip = nip+nZeta*(la+lb+3)
  ipqC = nip
  nip = nip+nZeta*(la+lb+1)
  ipDi = nip
  nip = nip+nZeta*(la+lb+1)
else
  ipRnr = -1
  ipqC = -1
  ipDi = -1
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (nip-1 > nArr*nZeta) then
  call WarningMessage(2,'KNEInt: nip-1 > nArr*nZeta')
  write(u6,*) 'nip=',nip
  write(u6,*) 'nArr,nZeta=',nArr,nZeta
  call Abend()
end if

if (iPrint >= 49) then
  call RecPrt(' In KnEInt: A',' ',A,1,3)
  call RecPrt(' In KnEInt: RB',' ',RB,1,3)
  call RecPrt(' In KnEInt: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In KnEInt: P',' ',P,nZeta,3)
  write(u6,*) ' In KnEInt: la,lb=',la,lb
end if

if (RMat_type_integrals) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! R-matrix calculations: continuum basis functions (A=B=P=0)
  !  Compute the contributions of the basis functions and multipole
  !  radial part

  lsum = la+lb+2
  call radlc(Zeta,nZeta,lsum,Array(ipRnr))

  ! Optional for photoionization:
  ! R-matrix calculations: continuum basis functions (A=B=P=0)
  !  Compute the contributions of the Coulomb operator times qCoul
  !  outside the sphere Omega

  if (abs(qCoul) > Epsq) then
    lsum = la+lb
    icop = 1
    call radlq(Zeta,nzeta,lsum,Array(ipqC),icop)
  end if

  if (abs(dipol1) > Epsq) then
    lsum = la+lb
    icop = 2
    call radlq(Zeta,nzeta,lsum,Array(ipDi),icop)
  end if

  ! Combine the radial and angular component to the full one electron integral.

  call CmbnKEr(Array(ipRnr),Array(ipqC),Array(ipDi),nZeta,la,lb,Zeta,rFinal,nComp,Alpha,nAlpha,Beta,nBeta)

else
  !                                                                    *
  !*********************************************************************
  !                                                                    *

  ! Compute the cartesian values of the basis functions angular part

  call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),la+1,HerR(iHerR(nHer)),nHer,ABeq)
  call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),lb+1,HerR(iHerR(nHer)),nHer,ABeq)

  ! Compute the contribution from the multipole moment operator

  ABeq(:) = .false.
  call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),nOrdOp-2,HerR(iHerR(nHer)),nHer,ABeq)

  ! Compute the cartesian components for the multipole moment
  ! integrals. The integrals are factorized into components.

  call Assmbl(Array(ipQxyz),Array(ipAxyz),la+1,Array(ipRxyz),nOrdOp-2,Array(ipBxyz),lb+1,nZeta,HerW(iHerW(nHer)),nHer)

  ! Compute the cartesian components for the kinetic energy integrals.
  ! The kinetic energy components are linear combinations of overlap components.

  ipAOff = ipA-1
  do iBeta=1,nBeta
    Array(ipAOff+1:ipAOff+nAlpha) = Alpha
    ipAOff = ipAOff+nAlpha
  end do

  ipBOff = ipB-1
  do iBeta=1,nBeta
    Array(ipBOff+1:ipBOff+nAlpha) = Beta(iBeta)
    ipBOff = ipBOff+nAlpha
  end do

  call Kntc(Array(ipTxyz),Array(ipQxyz),la,lb,Array(ipA),Array(ipB),nZeta)

  ! Combine the cartesian components to the full one electron integral.

  call CmbnKE(Array(ipQxyz),nZeta,la,lb,nOrdOp-2,Zeta,rKappa,rFinal,nComp,Array(ipTxyz))

end if

return

end subroutine KnEInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_RESTART(DIAG,WRK,LWRK,DSKDIA,LCONV)
C
C     Purpose: update and analyze diagonal for restart
C              (or check of decomposition). Index arrays
C              for first reduced set must be set up before
C              this routine is called. Reduced set 2, on the
C              other hand, is set up here.
C
#include "implicit.fh"
      DIMENSION DIAG(*), WRK(LWRK)
      LOGICAL   DSKDIA, LCONV
#include "cholesky.fh"
#include "choptr.fh"
#include "choptr2.fh"
#include "choprint.fh"
#include "chosimri.fh"
#include "WrkSpc.fh"

      external ddot_

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_RESTART')

      INTEGER  CHO_F2SP
      EXTERNAL CHO_F2SP

      LOGICAL SYNC, SCDIAG_SAVE

      PARAMETER (XMONE = -1.0D0, ZERO = 0.0D0)

      INDRSH(I)=IWORK(ip_INDRSH-1+I)
      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)
      IIBSTRSH(I,J,K)=IWORK(ip_IIBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      IATOMSHL(I)=IWORK(ip_IATOMSHL-1+I)
      MYSP(I)=IWORK(ip_MYSP-1+I)
      ISP2F(I)=IWORK(ip_iSP2F-1+I)
      ISIMRI(I)=IWORK(ip_ISIMRI-1+I)


C     Read diagonal (in reduced set 1).
C     ---------------------------------

      IF (DSKDIA) THEN
         IOPT = 2
         CALL CHO_IODIAG(DIAG,IOPT)
         CALL CHO_P_SYNCDIAG(DIAG,1)
      END IF

      IF (IPRINT .GE. INF_PASS) THEN
         WRITE(LUPRI,'(/,A,I10,/)')
     &   'Number of diagonal elements (1st reduced set): ',NNBSTRT(1)
      END IF

C     Analyze diagonal before update.
C     -------------------------------

      IF (IPRINT .GE. INF_PASS) THEN
         BIN1 = 1.0D2
         STEP = 1.0D-1
         NBIN = 18
         SYNC = .FALSE.
         CALL CHO_P_ANADIA(DIAG,SYNC,BIN1,STEP,NBIN,.TRUE.)
      END IF

C     Copy reduced set 1 to 2.
C     ------------------------

      CALL CHO_RSCOPY(IWORK(ip_IIBSTRSH),IWORK(ip_NNBSTRSH),
     &                IWORK(ip_INDRED),1,2,NSYM,NNSHL,NNBSTRT(1),3)

      IMXAB  = 0
      IMNAB  = 0
      NCONVT = 0
      DO ISYM = 1,NSYM

         NDIM = NNBSTR(ISYM,2)
         NVEC = NUMCHO(ISYM)

         IF (IPRINT .GE. INF_PASS) THEN
            WRITE(LUPRI,'(//,A,I2)')
     &      'Check information, symmetry',ISYM
            WRITE(LUPRI,'(/,A,6X,I12)')
     &      'Dimension, 1st reduced set: ',NDIM
            WRITE(LUPRI,'(A,6X,I12)')
     &      'Number of Cholesky vectors: ',NVEC
         END IF

         IF ((NVEC.GT.0) .AND. (NDIM.GT.0)) THEN

            KDIAG = 1
            KEND1 = KDIAG + NDIM
            LWRK1 = LWRK  - KEND1 + 1

            IF (LWRK1 .LE. 0) THEN
               CALL CHO_QUIT('Insufficient memory in '//SECNAM,101)
            END IF

C           Save a copy of the original diagonal.
C           -------------------------------------

            CALL DCOPY_(NDIM,DIAG(IIBSTR(ISYM,1)+1),1,WRK(KDIAG),1)

C           Calculate Cholesky diagonal.
C           ----------------------------

            CALL CHO_DIACHO(DIAG,ISYM,WRK(KEND1),LWRK1)

C           Find min. and max. error and save original value.
C           -------------------------------------------------

            ERRMX = -1.0D10
            ERRMN =  1.0D10
            EXAMX = ZERO
            EXAMN = ZERO
            DO JAB = 1,NDIM
               IAB = INDRED(IIBSTR(ISYM,2)+JAB,2)
               SAV = WRK(KDIAG-1+IAB-IIBSTR(ISYM,1))
               ERR = ABS(DIAG(IAB))
               IF (ERR .GT. ERRMX) THEN
                  ERRMX = ERR
                  EXAMX = SAV
                  IMXAB = IAB
               END IF
               IF (ERR .LT. ERRMN) THEN
                  ERRMN = ERR
                  EXAMN = SAV
                  IMNAB = IAB
               END IF
            END DO

C           Find min. and max. diagonals, zero too negative diagonals,
C           and screen (if requested).
C           ----------------------------------------------------------

            IF (CHO_DECALG .EQ. 4) THEN
               SCDIAG_SAVE = SCDIAG
               SCDIAG = .FALSE. ! do NOT screen (no zeroing of diags)
               DMX = 1.0d0
               CALL CHO_CHKDIA_A4(DIAG,DMX,ISYM,NNEG,NNEGT,NSCR,XMAX,
     &                            XMIN,XAMAX)
               SCDIAG = SCDIAG_SAVE
            ELSE
               CALL CHO_CHKDIA(DIAG,ISYM,XMIN,XMAX,XAMAX,NNEGT,NNEG,
     &                         NSCR)
            END IF

C           Count converged diagonals.
C           --------------------------

            NCONV = 0
            DO JAB = 1,NDIM
               IAB = INDRED(IIBSTR(ISYM,2)+JAB,2)
               IF (ABS(DIAG(IAB)) .LE. THRCOM) NCONV = NCONV + 1
            END DO

C           Calculate average and RMS error.
C           --------------------------------

            KOFF   = IIBSTR(ISYM,1) + 1
            XDIM   = DBLE(NDIM)
            RMSERR = SQRT(DDOT_(NDIM,DIAG(KOFF),1,DIAG(KOFF),1)/XDIM)
            AVEERR = CHO_DSUMELM(DIAG(KOFF),NDIM)/XDIM

C           Print.
C           ------

            IF (IPRINT .GE. INF_PASS) THEN
               WRITE(LUPRI,'(A,1P,D18.8)')
     &         'Minimum diagonal          : ',XMIN
               WRITE(LUPRI,'(A,1P,D18.8)')
     &         'Maximum diagonal          : ',XMAX
               WRITE(LUPRI,'(A,1P,D18.8,1X,D18.8)')
     &         'Minimum absolute error    : ',ERRMN,EXAMN
               WRITE(LUPRI,'(A,1P,D18.8,1X,D18.8)')
     &         'Maximum absolute error    : ',ERRMX,EXAMX
               WRITE(LUPRI,'(A,1P,D18.8)')
     &         'Average error             : ',AVEERR
               WRITE(LUPRI,'(A,1P,D18.8)')
     &         'Root-mean-square error    : ',RMSERR
               WRITE(LUPRI,'(A,6X,I12)')
     &         'Converged diagonals       : ',NCONV
               WRITE(LUPRI,'(A,6X,I12)')
     &         'Unconverged diagonals     : ',NDIM-NCONV
               WRITE(LUPRI,'(A,6X,I12)')
     &         'Zeroed negative diagonals : ',NNEG
               IF (CHO_DECALG .NE. 4) THEN ! NSCR is useless here
                  IF (SCDIAG) THEN
                     WRITE(LUPRI,'(A,6X,I12)')
     &               'Screened diagonals        : ',NSCR
                  ELSE
                     WRITE(LUPRI,'(A,6X,I12,A)')
     &               'Screenable diagonals      : ',NSCR,
     &               ' (not screened)'
                  END IF
               END IF
            END IF
            NCONVT = NCONVT + NCONV

         END IF

         CALL CHO_FLUSH(LUPRI)

      END DO

C     Sync diagonal and set reduced set.
C     ----------------------------------

      SYNC = .TRUE.
      CALL CHO_P_SETRED(DIAG,SYNC)
      KRED = XNPASS + 1
      CALL CHO_SETRSDIM(IWORK(ip_NDIMRS),NSYM,MAXRED,KRED,2)

C     Sync and analyze (histogram) updated diagonal.
C     ----------------------------------------------

      CALL CHO_P_SYNCDIAG(DIAG,2)
      IF (IPRINT .GE. INF_PASS) THEN
         BIN1 = 1.0D2
         STEP = 1.0D-1
         NBIN = 18
         SYNC = .FALSE.
         CALL CHO_P_ANADIA(DIAG,SYNC,BIN1,STEP,NBIN,.FALSE.)
      END IF

C     Set data for minimal integral checking.
C     ---------------------------------------

      IF (CHO_MINCHK) THEN
         IF (IMXAB .GT. 0) THEN
            ISHLAB = CHO_F2SP(INDRSH(IMXAB))
            IF (ISHLAB .GT. 0) THEN
               CALL CHO_INTCHK_REG('MAX DIAG',ISHLAB,ISHLAB)
            ELSE
               CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
            END IF
         END IF
         IF (IMNAB .GT. 0) THEN
            ISHLAB = CHO_F2SP(INDRSH(IMNAB))
            IF (ISHLAB .GT. 0) THEN
               CALL CHO_INTCHK_REG('MIN DIAG',ISHLAB,ISHLAB)
            ELSE
               CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
            END IF
         END IF
         IF (IMXAB.GT.0 .AND. IMNAB.GT.0) THEN
            ISHLAB = CHO_F2SP(INDRSH(IMXAB))
            JSHLAB = CHO_F2SP(INDRSH(IMNAB))
            IF (ISHLAB.GT.0 .AND. JSHLAB.GT.0) THEN
               CALL CHO_INTCHK_REG('MAX|MIN ',ISHLAB,JSHLAB)
            ELSE
               CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
            END IF
         END IF
         JMXAB = 0
         I0AB  = 0
         XX    = 0.0D0
         DO ISHLAB = 1,NNSHL
            NTOT = 0
            DO ISYM = 1,NSYM
               IF (NNBSTRSH(ISYM,ISHLAB,1) .GT. 0) THEN
                  IAB1 = IIBSTR(ISYM,1) + IIBSTRSH(ISYM,ISHLAB,1) + 1
                  IAB2 = IAB1 + NNBSTRSH(ISYM,ISHLAB,1) - 1
                  DO IAB = IAB1,IAB2
                     IF (DIAG(IAB) .LT. XX) THEN
                        XX    = DIAG(IAB)
                        JMXAB = IAB
                     END IF
                  END DO
                  NTOT = NTOT + 1
               END IF
            END DO
            IF (NTOT .EQ. 0) THEN
               I0AB = ISHLAB
            END IF
         END DO
         IF (JMXAB.GT.0 .AND. JMXAB.NE.IMNAB) THEN
            JSHLAB = CHO_F2SP(INDRSH(JMXAB))
            IF (JSHLAB .GT. 0) THEN
               CALL CHO_INTCHK_REG('NEG DIAG',JSHLAB,JSHLAB)
            ELSE
               CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
            END IF
            IF (IMXAB .GT. 0) THEN
               ISHLAB = CHO_F2SP(INDRSH(IMXAB))
               IF (ISHLAB .GT. 0) THEN
                  CALL CHO_INTCHK_REG('MAX|NEG ',ISHLAB,JSHLAB)
               ELSE
                  CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
               END IF
            END IF
            IF (IMNAB .GT. 0) THEN
               ISHLAB = CHO_F2SP(INDRSH(IMNAB))
               IF (ISHLAB .GT. 0) THEN
                  CALL CHO_INTCHK_REG('MIN|NEG ',ISHLAB,JSHLAB)
               ELSE
                  CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
               END IF
            END IF
         END IF
         IF (I0AB .GT. 0) THEN
            JSHLAB = CHO_F2SP(INDRSH(I0AB))
            IF (JSHLAB .GT. 0) THEN
               CALL CHO_INTCHK_REG('EXCL RS1',JSHLAB,JSHLAB)
            ELSE
               CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
            END IF
            IF (IMXAB .GT. 0) THEN
               ISHLAB = CHO_F2SP(INDRSH(IMXAB))
               IF (ISHLAB .GT. 0) THEN
                  CALL CHO_INTCHK_REG('MAX|XRS1',ISHLAB,JSHLAB)
               ELSE
                  CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
               END IF
            END IF
            IF (IMNAB .GT. 0) THEN
               ISHLAB = CHO_F2SP(INDRSH(IMNAB))
               IF (ISHLAB .GT. 0) THEN
                  CALL CHO_INTCHK_REG('MIN|XRS1',ISHLAB,JSHLAB)
               ELSE
                  CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
               END IF
            END IF
         END IF
         IF (IABMNZ.GT.0 .AND. IABMNZ.LE.NNSHL) THEN
            JSHLAB = CHO_F2SP(INDRSH(IABMNZ))
            IF (JSHLAB .GT. 0) THEN
               CALL CHO_INTCHK_REG('NEG->ZER',JSHLAB,JSHLAB)
            ELSE
               CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
            END IF
            IF (IMXAB .GT. 0) THEN
               ISHLAB = CHO_F2SP(INDRSH(IMXAB))
               IF (ISHLAB .GT. 0) THEN
                  CALL CHO_INTCHK_REG('MAX|NEGZ',ISHLAB,JSHLAB)
               ELSE
                  CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
               END IF
            END IF
            IF (IMNAB .GT. 0) THEN
               ISHLAB = CHO_F2SP(INDRSH(IMNAB))
               IF (ISHLAB .GT. 0) THEN
                  CALL CHO_INTCHK_REG('MIN|NEGZ',ISHLAB,JSHLAB)
               ELSE
                  CALL CHO_QUIT('CHO_F2SP<1 in '//SECNAM,103)
               END IF
            END IF
         END IF
      END IF

C     Set convergence flag.
C     ---------------------

      LCONV = NCONVT.EQ.NNBSTRT(1)

C     For 1-center decomposition, convergence is determined only by
C     judging the 1-center diagonals.
C     For RI simulations, diagonals that were initially zeroed may not
C     be converged, but that is OK as long as the diagonal is smaller
C     than the threshold for deletion, THR_SIMRI.
C     ----------------------------------------------------------------

      IF (CHO_1CENTER .AND. .NOT.LCONV) THEN
#if defined (_DEBUGPRINT_)
         IF (NSYM .NE. 1) THEN
            CALL CHO_QUIT(SECNAM//': CHO_1CENTER on, but NSYM != 1',103)
         END IF
         IF (l_IATOMSHL .LT. NSHELL) THEN
            CALL CHO_QUIT(SECNAM//': iAtomShl not allocated correctly!',
     &                    103)
         END IF
#endif
         LCONV  = .TRUE.
         ISHLAB = 0
         DO WHILE (ISHLAB.LT.NNSHL .AND. LCONV)
            ISHLAB = ISHLAB + 1
            CALL CHO_INVPCK(ISP2F(MYSP(ISHLAB)),ISHLA,ISHLB,.TRUE.)
            IF (IATOMSHL(ISHLA) .EQ. IATOMSHL(ISHLB)) THEN
               IAB1 = IIBSTRSH(1,ISHLAB,1) + 1
               IAB2 = IAB1 + NNBSTRSH(1,ISHLAB,1) - 1
               NCONV = 0
               DO IAB = IAB1,IAB2
                  IF (ABS(DIAG(IAB)) .LE. THRCOM) THEN
                     NCONV = NCONV + 1
                  ELSE IF (CHO_SIMRI) THEN
                     IF (ISIMRI(IAB).EQ.1 .AND.
     &                   ABS(DIAG(IAB)) .LE. THR_SIMRI) THEN
                        NCONV = NCONV + 1
                     END IF
                  END IF
               END DO
               LCONV = NCONV.EQ.NNBSTRSH(1,ISHLAB,1)
            END IF
         END DO
      END IF


      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Init_SlapAf()
      use Symmetry_Info, only: nIrrep, iOper
      use Slapaf_Info, only: q_nuclear, dMass, Coor, Grd, ANr, Degen,
     &                       jStab, nStab, iCoSet, AtomLbl, Smmtrc,
     &                       RootMap
*     use Slapaf_Info, only: R12
      use Slapaf_Parameters, only: nDimBC, Analytic_Hessian, MaxItr,
     &                             Line_Search, ThrEne, ThrGrd, ThrCons,
     &                             ThrMEP, Header, MxItr, mTtAtm,
     &                             mB_Tot, mdB_Tot, mq, Force_dB, NADC,
     &                             ApproxNADC
*     use Slapaf_Parameters, only: lRP
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
#include "stdalloc.fh"
      Integer   iAdd(0:7)
      Integer :: jPrmt(0:7)=[1,-1,-1,1,-1,1,1,-1]
      Logical Same, Do_ESPF, Exist_2, Found, Reduce_Prt
      External Reduce_Prt
      Character(LEN=8) CMAX
      Integer Columbus
#include "SysDef.fh"
      Character(LEN=100) SuperName
      Character(LEN=100), External:: Get_SuperName
      Real*8, Allocatable:: xMass(:)
*
************************************************************************
************************** StartUp section   ***************************
************************************************************************
*                                                                      *
*     Set the default value of iterations from MOLCAS_MAXITER if it
*     has been defined.
*
      Call GetEnvf('MOLCAS_MAXITER', CMAX)
*     Write (*,'(3A)') 'CMAX="',CMAX,'"'
      If (CMAX.ne.' ') Then
         Read (CMAX,'(I8)') iMAX
         MxItr = Min(MaxItr,iMax)
      Else
         MxItr = MaxItr
      End If
*                                                                      *
************************************************************************
*                                                                      *
      jPrint=10
*                                                                      *
************************************************************************
*                                                                      *
      Call DecideOnESPF(Do_ESPF)
      If (Do_ESPF) Then
         ThrGrd = 0.003D0
         ThrEne = 1.0D-5
         Line_Search=.False.
      Else
         ThrGrd = 0.0003D0
         ThrEne = 1.0D-6
         Line_Search=.True.
      End If
      ThrMEP = ThrGrd
      ThrCons = 1.0D10
*                                                                      *
************************************************************************
*                                                                      *
      iPL=iPrintLevel(-1)
      If (iPL.eq.2) Then
         iPL=5
      Else If (iPL.eq.3) Then
         iPL=6
      Else If (iPL.eq.4) Then
         iPL=99
      Else If (iPL.eq.5) Then
         iPL=99
      End If
      Do iRout = 1, nRout
         nPrint(iRout) = iPL
      End Do
*
*     Reduced print level of Slapaf parameters after the first iteration
*
      If (Reduce_Prt().and.iPL.le.5) Then
         Do iRout = 1, nRout
            nPrint(iRout) = iPL-1
         End Do
      End If
*
*                                                                      *
************************************************************************
*                                                                      *
*     Get Molecular data
*
*...  Read the title
*
      Call Get_cArray('Seward Title',Header,144)
*
*...  Read number of atoms, charges, coordinates, gradients and
*     atom labels
*
      Call Get_Molecule()
*                                                                      *
************************************************************************
*                                                                      *
      NADC=.False.
      ApproxNADC=.False.
      Call Get_iScalar('Columbus',Columbus)
      If (Columbus.eq.1) Then
*
*        C&M mode
*
         Call Get_iScalar('ColGradMode',iMode)
         If (iMode.eq.3) NADC=.True.
      Else
*
*        M mode
*
*        ISPIN should only be found for RASSCF-based
*        methods, so no CI mode for SCF, MP2, etc. (or that's the idea)
*
C        Write (6,*) 'See if CI'
         Call Qpg_iScalar('ISPIN',Found)
         If (Found) Then
            Call Get_iScalar('ISPIN',ISPIN1)
            Call Get_iScalar('STSYM',LSYM1)
         Else
            ISPIN1=0
            LSYM1=0
         End If
C        Write (6,*) 'iSpin=',ISPIN1
C        Write (6,*) 'stSym=',LSYM1
*
         Call f_Inquire('RUNFILE2',Exist_2)
C        Write (6,*) 'Exist_2=',Exist_2
         If (Exist_2) Then
            Call NameRun('RUNFILE2')
            Call Qpg_iScalar('ISPIN',Found)
            If (Found) Then
               Call Get_iScalar('ISPIN',ISPIN2)
               Call Get_iScalar('STSYM',LSYM2)
            Else
               ISPIN2=0
               LSYM2=0
            End If
            Call NameRun('RUNFILE')
         Else
            ISPIN2 = ISPIN1
            LSYM2 = LSYM1
         End If
C        Write (6,*) 'iSpin=',ISPIN1,ISPIN2
C        Write (6,*) 'stSym=',LSYM1,LSYM2
*
*
*        Do not add the constraint at the NumGrad stage
*
         SuperName=Get_Supername()
         If (SuperName.ne.'numerical_gradient') Then
            If ((ISPIN1.ne.0).and.(LSYM1.ne.0))
     &         NADC= (ISPIN1.eq.ISPIN2) .and. (LSYM1.eq.LSYM2)
C           NADC= .False. ! for debugging
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*...  Read or initialize the root map
*
      Call Qpg_iArray('Root Mapping',Found,nRM)
      If (nRM.gt.0) Then
         Call mma_allocate(RootMap,nRM,Label='RootMap')
         Call Get_iArray('Root Mapping',RootMap,nRM)
      Else
         Call Qpg_iScalar('Number of roots',Found)
         nRoots = 1
         If (Found) Call Get_iScalar('Number of roots',nRoots)
         Call mma_allocate(RootMap,nRoots,Label='RootMap')
         RootMap(:)=0
         Do i=1,nRoots
            RootMap(i)=i
         End Do
      End If
*
*...  Check if there is an analytic Hessian
      Call qpg_dArray('Analytic Hessian',Analytic_Hessian,nHess)

      If (.Not.Analytic_Hessian) Then
         Call NameRun('RUNOLD')
         Call qpg_dArray('Analytic Hessian',Analytic_Hessian,nHess)
         Call NameRun('#Pop')
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute the number of total symmetric displacements
*
      Call mma_allocate(jStab ,[0,7],[1,SIZE(Coor,2)],Label='jStab ')
      Call mma_allocate(nStab ,      [1,SIZE(Coor,2)],Label='nStab ')
      Call mma_allocate(iCoSet,[0,7],[1,SIZE(Coor,2)],Label='iCoSet')
      Call mma_allocate(Smmtrc,3,SIZE(Coor,2),Label='Smmtrc')
      jStab(:,:)=0
      nStab(:)=0
      iCoSet(:,:)=0
      Smmtrc(:,:)=.False.

      nDimbc = 0
*...  Loop over the unique atoms
      Do 610 isAtom = 1, SIZE(Coor,2)
*...     Find character of center
         iChxyz=0
         Do i = 1, 3
            If (Coor(i,isAtom).ne.Zero) Then
               Do iIrrep= 0, nIrrep-1
                  If (iAnd(2**(i-1),iOper(iIrrep)).ne.0)
     &               iChxyz=iOr(iChxyz,2**(i-1))
               End Do
            End If
         End Do
         nStb = 0
         Do iIrrep = 0, nIrrep-1
            If (iAnd(iChxyz,iOper(iIrrep)).eq.0) Then
               jStab(nStb,isAtom)=iOper(iIrrep)
               nStb = nStb + 1
            End If
         End Do
         nStab(isAtom)=nStb
*...     Find the coset representatives
         iCoSet(0,SIZE(Coor,2)) = 0      ! Put in the unit operator
         nCoSet = 1
         Do iIrrep = 1, nIrrep-1
            itest=iAnd(iChxyz,iOper(iIrrep))
            Same=.False.
            Do jCoSet = 0, nCoSet-1
               jTest = iAnd(iChxyz,iCoSet(jCoSet,isAtom))
               Same = jTest.eq.iTest
               If (Same) Go To 7777
            End Do
 7777       Continue
            If (.Not.Same) Then
               nCoSet = nCoSet + 1
               iCoSet(nCoSet-1,isAtom) = iOper(iIrrep)
            End If
         End Do
         If (nIrrep/nStb.ne.nCoSet) Then
            Call WarningMessage(2,' Error while doing cosets.')
            Call Abend()
         End If
         Do 611 i = 1, 3
            iComp = 2**(i-1)
            Call ICopy(nCoSet,[0],0,iAdd,1)
            Do 640 iIrrep = 0, nIrrep-1
*...           find the stabilizer index
               iTest=iAnd(iChxyz,iOper(iIrrep))
               n=-1
               Do 641 jCoset = 0, nCoset-1
                  jTest=iAnd(iChxyz,iCoset(jCoSet,isAtom))
                  If (iTest.eq.jTest) n = jCoset
 641           Continue
               If (n.lt.0 .or. n.gt.nCoset-1) Then
                  Call WarningMessage(2,' Error finding coset element')
                  Call Abend()
               End If
               iAdd(n) = iAdd(n) + jPrmt(iAnd(iOper(iIrrep),iComp))
 640        Continue
            Do 645 jCoSet = 0, nCoSet-1
               If (iAdd(jCoSet).eq.0) Go To 611
 645        Continue
            nDimbc = nDimbc + 1
            Smmtrc(i,isAtom)=.True.
 611     Continue
 610  Continue
*                                                                      *
************************************************************************
*                                                                      *
*     Transform charges to masses (C=12)
*
      Call mma_allocate(dMass,SIZE(Coor,2),Label='dMass')
      Call mma_allocate(xMass,SIZE(Coor,2),Label='xMass')
      Call Get_Mass(xMass,SIZE(Coor,2))
*     Call RecPrt(' Charges',' ',Q_nuclear,SIZE(Coor,2),1)
      Call mma_allocate(ANr,SIZE(Coor,2),Label='ANr')
      Do isAtom = 1, SIZE(Coor,2)
         ind = Int(Q_nuclear(isAtom))
         If (ind.le.0) Then
            dMass(isAtom) = 1.0D-10
         Else
            dMass(isAtom) = xMass(isAtom)
         End If
         ANr(isAtom)=ind
      End Do
      Call mma_deallocate(xMass)
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute the multiplicities of the cartesian coordinates and the
*     total number of atoms.
*
      mTtAtm=0
      Call mma_Allocate(Degen,3,SIZE(Coor,2),Label='Degen')
      Do isAtom = 1, SIZE(Coor,2)
         mTtAtm=mTtAtm+iDeg(Coor(:,isAtom))
         tmp = DBLE(iDeg(Coor(:,isAtom)))
         Do i = 1, 3
            Degen(i,isAtom)=tmp
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Degen',' ',Degen,3,SIZE(Coor,2))
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Call qpg_dArray('Transverse',lRP,nRP)
*     If (lRP) Then
*        Call mma_allocate(R12,3,nRP/3,Label='R12')
*        Call Get_dArray('Transverse',R12,nRP)
*     End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute center of mass and molecular mass. The molecule is
*     translated so origin and center of mass is identical.
*
      If (jPrint.ge.99) Call
     &     Prlist('Symmetry Distinct Nuclear Coordinates / Bohr',
     &                   AtomLbl,SIZE(Coor,2),Coor,3,SIZE(Coor,2))
      If (jPrint.ge.99) Call
     &     PrList('Symmetry Distinct Nuclear Forces / au',
     &                   AtomLbl,SIZE(Coor,2),Grd,3,SIZE(Coor,2))
*                                                                      *
************************************************************************
*                                                                      *
      mB_Tot=0
      mdB_Tot=0
      mq=0
      Force_dB=.False.
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine oneexc_cvb(cfrom,cto,vij,diag,iPvb)
      implicit real*8 (a-h,o-z)
      logical diag
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension vij(*),cfrom(*),cto(*)

      idens=0
      icfrom=nint(cfrom(1))
      icto=nint(cto(1))

      if(iform_ci(icfrom).ne.0)then
        write(6,*)' Unsupported format in ONEEXC/ONEDENS :',
     >    iform_ci(icfrom)
        call abend_cvb()
      elseif(iform_ci(icto).ne.0)then
        write(6,*)' Unsupported format in ONEEXC/ONEDENS :',
     >    iform_ci(icto)
        call abend_cvb()
      endif

      call oneexc2_cvb(work(iaddr_ci(icfrom)),work(iaddr_ci(icto)),vij,
     >  iwork(ll(1)),iwork(ll(2)),iwork(ll(5)),iwork(ll(6)),work(ll(9)),
     >  work(ll(10)),
     >  iwork(ll(11)),iwork(ll(12)),iwork(ll(13)),iwork(ll(14)),npvb,
     >  nda,ndb,n1a,n1b,nam1,nbm1,norb,projcas,sc,absym(3),diag,idens,
     >  iPvb)

c  If projcas and iPvb=0 we asume the normal density/1-ex. is required:
      if(projcas.and.iPvb.ne.0)then
        if(diag)then
          nvij=norb*norb
        else
          nvij=norb*(norb-1)
        endif
        ivij2=mstackr_cvb(nvij)
        if(idens.eq.0)then
          call fmove_cvb(vij,work(ivij2),nvij)
          call dscal_(nvij,-1d0,work(ivij2),1)
        else
          call fzero(work(ivij2),nvij)
        endif
        call oneexc2_cvb(work(iaddr_ci(icfrom)),work(iaddr_ci(icto)),
     >    work(ivij2),
     >    iwork(ll(1)),iwork(ll(2)),iwork(ll(5)),iwork(ll(6)),
     >    work(ll(9)),work(ll(10)),
     >    iwork(ll(11)),iwork(ll(12)),iwork(ll(13)),iwork(ll(14)),npvb,
     >    nda,ndb,n1a,n1b,nam1,nbm1,norb,projcas,sc,absym(3),diag,idens,
     >    3-iPvb)
        if(idens.eq.1)call daxpy_(nvij,-1d0,work(ivij2),1,vij,1)
        call mfreer_cvb(ivij2)
      endif
      return
      end
      subroutine onedens_cvb(cfrom,cto,vij,diag,iPvb)
      implicit real*8 (a-h,o-z)
      logical diag
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension vij(*),cfrom(*),cto(*)
      idens=1
      icfrom=nint(cfrom(1))
      icto=nint(cto(1))

      if(iform_ci(icfrom).ne.0)then
        write(6,*)' Unsupported format in ONEEXC/ONEDENS :',
     >    iform_ci(icfrom)
        call abend_cvb()
      elseif(iform_ci(icto).ne.0)then
        write(6,*)' Unsupported format in ONEEXC/ONEDENS :',
     >    iform_ci(icto)
        call abend_cvb()
      endif

      call oneexc2_cvb(work(iaddr_ci(icfrom)),work(iaddr_ci(icto)),vij,
     >  iwork(ll(1)),iwork(ll(2)),iwork(ll(5)),iwork(ll(6)),work(ll(9)),
     >  work(ll(10)),
     >  iwork(ll(11)),iwork(ll(12)),iwork(ll(13)),iwork(ll(14)),npvb,
     >  nda,ndb,n1a,n1b,nam1,nbm1,norb,projcas,sc,absym(3),diag,idens,
     >  iPvb)

c  If projcas and iPvb=0 we asume the normal density/1-ex. is required:
      if(projcas.and.iPvb.ne.0)then
        if(diag)then
          nvij=norb*norb
        else
          nvij=norb*(norb-1)
        endif
        ivij2=mstackr_cvb(nvij)
        if(idens.eq.0)then
          call fmove_cvb(vij,work(ivij2),nvij)
          call dscal_(nvij,-1d0,work(ivij2),1)
        else
          call fzero(work(ivij2),nvij)
        endif
        call oneexc2_cvb(work(iaddr_ci(icfrom)),work(iaddr_ci(icto)),
     >    work(ivij2),
     >    iwork(ll(1)),iwork(ll(2)),iwork(ll(5)),iwork(ll(6)),
     >    work(ll(9)),work(ll(10)),
     >    iwork(ll(11)),iwork(ll(12)),iwork(ll(13)),iwork(ll(14)),npvb,
     >    nda,ndb,n1a,n1b,nam1,nbm1,norb,projcas,sc,absym(3),diag,idens,
     >    3-iPvb)
        if(idens.eq.1)call daxpy_(nvij,-1d0,work(ivij2),1,vij,1)
        call mfreer_cvb(ivij2)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine cZeroMatrix(a,n)
* fills all elements of a square Complex matrix of size n by Complex zero
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          ::  n
      Complex(kind=8)             :: a(n,n)
      !local
      Integer :: i, j
      Do j=1,n
         Do i=1,n
         a(i,j)=(0.0_wp,0.0_wp)
         End Do
      End Do
      Return
      End
c------------------------------------------------------------------------
      Subroutine rZeroMatrix(a,n)
* fills all elements of a square Real matrix of size n by Complex zero
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n
      Real(kind=8)                :: a(n,n)
      !local
      Integer :: i, j
      Do j=1,n
         Do i=1,n
            a(i,j)=0.0_wp
         End Do
      End Do
      Return
      End
c------------------------------------------------------------------------
      Subroutine cZeroVector(a,n)
* fills all elements of a Complex vector of size n by Complex zero
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer                      :: n
      Complex(kind=8)             :: a(n)
      !local
      Integer :: i
      Do i=1,n
         a(i)=(0.0_wp,0.0_wp)
      End Do
      Return
      End
c------------------------------------------------------------------------
      Subroutine rZeroVector(a,n)
* fills all elements of a Complex vector of size n by Complex zero
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n
      Real(kind=8)                :: a(n)
      !local
      Integer :: i
      Do i=1,n
         a(i)=0.0_wp
      End Do
      Return
      End
c------------------------------------------------------------------------
      Subroutine cZeroMoment(a,n)
* fills all elements of a Complex matrix of size a(3,n,n)  by Complex zero
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n
      Complex(kind=8)             :: a(3,n,n)
      !local
      Integer :: i, j, l
      Do i=1,n
        Do j=1,n
          Do l=1,3
          a(l,j,i)=(0.0_wp,0.0_wp)
          End Do
        End Do
      End Do
      Return
      End
c------------------------------------------------------------------------
      Subroutine prMom(a,m,n)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n
      Complex(kind=8)             :: M(3,n,n)
      !local
      Integer           :: i, j, l
      Character(len=1)  :: proj(3)
      Character(len=*)  :: a
      Character(len=50) :: fmtline
      proj(1)='X'
      proj(2)='Y'
      proj(3)='Z'
      Write(6,*)
      Write(6,'(2a)') 'print: ',a
      Write(fmtline,'(a,i2,a)') '(',n,'(2f9.4,1x))'
      Do l=1,3
      Write(6,'(2a)') 'projection: ',proj(l)
          Do i=1,n
             Write(6,fmtline) (M(l,i,j),j=1,n)
          End Do
      Write(6,*)
      End Do
      Return
      End
c------------------------------------------------------------------------
      Subroutine prMom_herm(a,m,n)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n
      Complex(kind=8)             :: M(3,n,n)
      !local
      Integer           :: i, j, l
      Real(kind=8)     :: R
      Character(len=*)  :: a
      Write(6,*)
      Write(6,'(2a)') 'print: ',a
      Do i=1,n
          Do j=1,i
          R=0.0_wp
          R=( ABS(M(1,i,j)) + ABS(M(2,i,j)) + ABS(M(3,i,j)) ) / 3.0_wp
             Write(6,'(A,2I3,A,3(2F16.7,2x), 2F20.7)')
     &                 'i j: ',i,j,' <i|O|j>=',(M(l,i,j),l=1,3), R
          End Do
      Write(6,*)
      End Do
      Return
      End
c------------------------------------------------------------------------
      Subroutine pa_prMat(a,m,n)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n
      Complex(kind=8)             :: M(n,n)
      !local
      Integer        :: i, j
      Character*(*) a
      Character*(50) fmtline
      Write(6,*)
      Write(6,'(2a)') 'print: ',a
      Write(fmtline,'(a,i2,a)') '(',n,'(2f12.4,1x))'
      Do i=1,n
         Write(6,fmtline) (M(i,j),j=1,n)
      End Do
      Return
      End
c------------------------------------------------------------------------
      Subroutine pa_prMatR(a,m,n)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n
      Real(kind=8)                :: M(n,n)
      !local
      Integer        :: i, j
      Character*(*) a
      Character*(50) fmtline
      Write(6,*)
      Write(6,'(2a)') 'print: ',a
      Write(fmtline,'(a,i2,a)') '(',n,'(f19.14,1x))'
      Do i=1,n
         Write(6,fmtline) (M(i,j),j=1,n)
      End Do
      Return
      End
c------------------------------------------------------------------------
      Subroutine print_ZFS(a,m,n)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer                      :: i,j,n,k,jEnd
      Complex(kind=8), intent(in) :: M(n,n)
      Character*(*)                :: a


      Write(6,'(/)')
      Write(6,'(100A)') ('-',i=1,87)
      Write(6,'(A)') a
      Do j=1,n,4
         jEnd=MIN(n,J+3)
         If (MOD(n,2)==0) Then
         ! code for odd N
            Write(6,'(150A)') ('-',i=1,10),(('-',i=1,24),k=j,jEnd),'|'
            Write(6,'(10x,A,50(8x,A,I3,A,7x,A))') '|',
     &                         ('|',2*i-n-1,'/2 >','|',i=j,jEnd)
            Write(6,'(150A)')  ('-',i=1,10),'|',
     &                         ('---- Real ----- Imag --|',k=j,jEnd)
            ! print the matrix
            Do i=1,n
               Write(6,'(1x,A,I3,A,1x,A,50(2F11.5,1x,A))')
     &                                    '<',2*i-n-1,'/2','| |',
     &                                    (M(k,i),'|' ,k=j,jEnd)
            End Do
            Write(6,'(150A)') ('-',i=1,10),(('-',i=1,24),k=j,jEnd),'|'

         Else
         ! code for odd N

            Write(6,'(150A)') ('-',i=1,8),(('-',i=1,24),k=j,jEnd),'|'
            Write(6,'(8x,A,50(8x,A,I3,A,9x,A))') '|',
     &                         ('|',-(n-1)/2-1+i,' >','|',i=j,jEnd)
            Write(6,'(150A)')  ('-',i=1,8),'|',
     &                         ('---- Real ----- Imag --|',k=j,jEnd)
            Do i=1,n
               Write(6,'(1x,A,I3,1x,A,50(2F11.5,1x,A))')
     &                                '<',-(n-1)/2-1+i,'| |',
     &                                  (M(k,i),'|' ,k=j,jEnd)
            End Do
            Write(6,'(150A)') ('-',i=1,8),(('-',i=1,24),k=j,jEnd),'|'
         End If
      End Do !j

      Return
      End
c------------------------------------------------------------------------
      Subroutine print_ZFS_eigenvectors(a,m,n)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer                      :: i,j,n,k,jEnd
      Complex(kind=8), intent(in) :: M(n,n) ! eigenvectors
      Character*(1)                :: a


      Write(6,'(/)')
      Do j=1,n,2
        jEnd=MIN(n,j+1) ! '|  > |'
        Write(6,'(A,6A)') '--------|',
     &                ('-----------------------------|',i=j,jEnd)
        Write(6,'(3A,6(6x,a,i3,5x,a))') ' | ',a,'M > |',
     &                         ('ab initio state',i,'|',i=j,jEnd)
        Write(6,'(A,6A)') '--------|',
     &                ('-- Real ---- Imag --|-Weight-|',i=j,jEnd)

        Do i=1,n
          If(MOD(n,2)==1) Then
            Write(6,'(1x,A,1x,i2,A,   6(2(E22.14,1x),a,F6.1,1x,a))')
     &                '|',-(n-1)/2-(1-i),' > |',
     &         (DBLE(M(i,k)), AIMAG(M(i,k)), '|',
     &         100.0_wp*(DBLE(M(i,k))**2 + AIMAG(M(i,k))**2),
     &         '%|',k=j,jEnd)
          Else
            Write(6,'(A,i3,a,a,       6(2(E22.14,1x),a,F6.1,1x,a))')
     &                '|',-(n-1)+2*(i-1),'/2> ','|',
     &         (DBLE(M(i,k)), AIMAG(M(i,k)), '|',
     &         100.0_wp*(DBLE(M(i,k))**2 + AIMAG(M(i,k))**2),
     &         '%|',k=j,jEnd)
          End If
        End Do  !i


      Write(6,'(A,6A)') '--------|',
     &                ('-----------------------------|',i=j,jEnd)
      End Do ! j


      Return
      End
c------------------------------------------------------------------------
      Subroutine print_ZFS_naoya(A,M,N)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: N ! dimension of the pseudospin
!     complex parameters to print
      Complex(kind=8), intent(in) :: M(n,n)
      Character*(1)                :: a
      ! local variables:
      Integer       :: k,i,j,jEnd
      Real(kind=8) :: Mr(n), Mi(n), Weight(n)
      Character(Len=1)  :: cRsign(n), cIsign(n)

      Write(6,'(/)')
      Do j=1,n,2
        jEnd=MIN(n,j+1) ! '|  > |'
        If(j==1) Write(6,'(150A)') '--------|',
     &                                     (('-',k=1,58),'|',i=j,jEnd)
        Write(6,'(3A,6(16x,a,i3,24x,a))') ' | ',a,'M > |',
     &                              ('ab initio state',i,'|',i=j,jEnd)
        Write(6,'(A,6A)') '--------|',
     & ('-------  Real  -------|------  Imaginary  -------|-Weight-|',
     &                                                       i=j,jEnd)

        Do i=1,n
            ! fix the sign:
            Do k=j,jEnd
               Mr(k)=0.0_wp
               Mi(k)=0.0_wp
               Weight(k)=0.0_wp

               Mr(k)=DBLE( M(i,k))
               Mi(k)=AIMAG(M(i,k))
               Weight(k)=100.0_wp*( Mr(k)*Mr(k) + Mi(k)*Mi(k) )

               If (Mr(k) >= 0.0_wp) Then
                  cRsign(k)='+'
               Else
                  cRsign(k)='-'
               End If
               If (Mi(k) >= 0.0_wp) Then
                  cIsign(k)='+'
               Else
                  cIsign(k)='-'
               End If
            End Do

          ! print it
          If(MOD(n,2)==1) Then
            Write(6,'(1x,A,1x,i2,A, 2(2(1x,A,E20.14,1x),a,F6.1,1x,a))')
     &                '|',-(n-1)/2-(1-i),' > |',
     &         (cRsign(k),ABS(Mr(k)), cIsign(k),ABS(Mi(k)), '*I |',
     &                Weight(k),'%|',k=j,jEnd)
          Else
            Write(6,'(A,i3,a,a,     2(2(1x,A,E20.14,1x),a,F6.1,1x,a))')
     &                '|',-(n-1)+2*(i-1),'/2> ','|',
     &         (cRsign(k),ABS(Mr(k)), cIsign(k),ABS(Mi(k)), '*I |',
     &                Weight(k),'%|',k=j,jEnd)
          End If
        End Do  !i



        Write(6,'(150A)') '--------|',(('-',k=1,58),'|',i=j,jEnd)
      End Do ! j

      Return
      End Subroutine print_ZFS_naoya






      Subroutine print_CFP_alpha(nlanth,n,B,C)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n    ! dimension of the pseudospin
      Integer, intent(in)          :: nlanth  ! number of the lanthanide
!     real and imaginary CF parameters
      Real(kind=8), intent(in)    :: B(n,0:n), C(n,0:n)
      !Logical, intent(in), optional:: print_all
      ! local variables:
      Integer       :: k,q,i
      Real(kind=8) :: a(6)


      a=0.0_wp
      Call set_an(nlanth,a)

!          O(m1,m2)=(0.5_wp,0.0_wp) * ( Om + mQ*Op )
!          W(m1,m2)=(0.0_wp,0.5_wp) * ( Om - mQ*Op )
      Write(6,'(/)')
      Write(6,'(100A)') ('*',i=1,80)
      Write(6,'(A)') 'The Crystal-Field Hamiltonian:'
      Write(6,'(A)') '   Hcf = SUM_{k,q} alpha(k) * [ B(k,q) '//
     &               '* O(k,q) +  C(k,q) * W(k,q) ];'
      Write(6,'(A)') 'where:'
      Write(6,'(A)') '   O(k,q) =  0.5 * ( (-1)**q * Y(k,+q)'//
     &               ' + Y(k,-q) );'
      Write(6,'(A)') '   W(k,q) = -0.5 * ( (-1)**q * Y(k,+q)'//
     &               ' - Y(k,-q) ) * I;   (I = imaginary unit)'
      Write(6,'(A)') '   k - the rank of the ITO, = 2, 4, 6;'
      Write(6,'(A)') '   q - the component of the ITO, = 0, 1, 2, '//
     &               '... k;'
      Write(6,'(A)') '   alpha(k) - Stevens coefficients;'
      Write(6,'(A)') 'These operators have been defined in: '
      Write(6,'(A)') '  L. F. Chibotaru, L.Ungur, J. Chem. Phys., '//
     &               '137, 064112 (2012).'

      Write(6,'(100A)') ('-',i=1,76),'|'
      Write(6,'(A)') '  k  |  q  |    1/alpha(k)  |'//
     &               '         B(k,q)        |         C(k,q)        |'
      Do k=2,6,2
        If ( abs(A(k)).gt.tiny(0.0_wp) ) Then
        Write(6,'(A)') '-----|-----|----------------|'//
     &                 '-----------------------|'//
     &                 '-----------------------|'
        Do q=0,k
          If ( q==k/2) Then
            Write(6,'(2(2x,I1,2x,A),F14.5,2x,A,2(E22.14,1x,A))')
     &                k,'|',q,'|',1.0_wp/a(k),'|',
     &                B(k,q)/a(k),'|',  C(k,q)/a(k),'|'
          Else
            Write(6,'(2(2x,I1,2x,A),16x,A,2(E22.14,1x,A))')
     &                k,'|',q,'|','|',
     &                B(k,q)/a(k),'|',  C(k,q)/a(k),'|'
          End If
        End Do
        End If
      End Do
      Write(6,'(100A)') ('-',i=1,76),'|'

      Return
      End Subroutine print_CFP_alpha







      Subroutine print_CFP_LCLU(n,B,C,print_all)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n    ! dimension of the pseudospin
!     real and imaginary CF parameters
      Real(kind=8), intent(in)    :: B(n,0:n), C(n,0:n)
      Logical, intent(in)          :: print_all
      ! local variables:
      Integer       :: k,q,i

!          O(m1,m2)=(0.5_wp,0.0_wp) * ( Om + mQ*Op )
!          W(m1,m2)=(0.0_wp,0.5_wp) * ( Om - mQ*Op )
      Write(6,'(/)')
      Write(6,'(100A)') ('*',i=1,80)
      Write(6,'(A)') 'The Crystal-Field Hamiltonian:'
      Write(6,'(A)') '   Hcf = SUM_{k,q} * [ B(k,q) * O(k,q) +  '//
     &                                      'C(k,q) * W(k,q) ];'
      Write(6,'(A)') 'where:'
      Write(6,'(A)') '   O(k,q) =  0.5 * ( (-1)**q * Y(k,+q)'//
     &               ' + Y(k,-q) );'
      Write(6,'(A)') '   W(k,q) = -0.5 * ( (-1)**q * Y(k,+q)'//
     &               ' - Y(k,-q) ) * I;   (I = imaginary unit)'
      Write(6,'(A)') '   k - the rank of the ITO, = 2, 4, 6;'
      Write(6,'(A)') '   q - the component of the ITO, = 0, 1, 2, '//
     &               '... k;'
      Write(6,'(A)') 'These operators have been defined in: '
      Write(6,'(A)') '  L. F. Chibotaru, L.Ungur, J. Chem. Phys., '//
     &               '137, 064112 (2012).'

      Write(6,'(100A)') ('-',i=1,59),'|'
      Write(6,'(A)') '  k  |  q  |         B(k,q)        |'//
     &                           '         C(k,q)        |'
      If(print_all) Then
         Do k=2,n-1
           Write(6,'(A)') '-----|-----|-----------------------|'//
     &                              '-----------------------|'
           Do q=0,k
             Write(6,'(2(1x,I2,2x,A),2(E22.14,1x,A))')
     &                k,'|',q,'|',B(k,q),'|',C(k,q),'|'
           End Do
         End Do
      Else
         Do k=2,n-1,2
           Write(6,'(A)') '-----|-----|-----------------------|'//
     &                              '-----------------------|'
           Do q=0,k
             Write(6,'(2(1x,I2,2x,A),2(E22.14,1x,A))')
     &                k,'|',q,'|',B(k,q),'|',C(k,q),'|'
           End Do
         End Do
      End If
      Write(6,'(100A)') ('-',i=1,59),'|'
      Return
      End Subroutine print_CFP_LCLU



      Subroutine print_CFP_stev(n,B,print_all)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n    ! dimension of the pseudospin
!     real and imaginary CF parameters
      Real(kind=8), intent(in)    :: B(n,-n:n)
      Logical, intent(in)          :: print_all
      ! local variables:
      Integer       :: k,q,i,kmax,iq
      Real(kind=8) :: knm(12,0:12), f

      Call set_knm( knm )
      Write(6,'(/)')
      Write(6,'(100A)') ('*',i=1,80)
      Write(6,'(A)') 'The Crystal-Field Hamiltonian:'
      Write(6,'(A)') '   Hcf = SUM_{k,q} * [ B(k,q) * O(k,q) ];'
      Write(6,'(A)') 'where:'
      Write(6,'(A)') '   O(k,q) =  Extended Stevens Operators (ESO)'//
     &               'as defined in:'
      Write(6,'(10x,A)') '1. Rudowicz, C.; J.Phys.C: Solid State '//
     &                   'Phys.,18(1985) 1415-1430.'
      Write(6,'(10x,A)') '2. Implemented in the "EasySpin" function '//
     &                   'in MATLAB, www.easyspin.org.'
      Write(6,'(A)') '   k - the rank of the ITO, = 2, 4, 6, 8, 10, 12.'
      Write(6,'(A)') '   q - the component of the ITO, = -k, -k+1, '//
     &               '... 0, 1, ... k;'
      If((n-1)>12) Then
        Write(6,'(A)') 'k = 12 may not be the highest rank of '//
     &                 'the ITO for this case, but it '
        Write(6,'(A)') 'is the maximal k implemented in the'//
     &                 ' "EasySpin" function in MATLAB.'
      End If
      Write(6,'(A)') 'Knm are proportionality coefficients between'//
     &               ' the ESO and operators defined in '
      Write(6,'(A)') 'J. Chem. Phys., 137, 064112 (2012).'
      Write(6,'(100A)') ('-',i=1,48),'|'
      Write(6,'(A)') '  k |  q  |    (K)^2    |'//
     &               '         B(k,q)        |'
      If((n-1)>12) Then
        kmax=12
      Else
        kmax=n-1
      End If

      If(print_all) Then
         Do k=2,kmax
           Write(6,'(A)') '----|-----|-------------|'//
     &                    '-----------------------|'
           Do q=-k,k
             iq=abs(q)
             f=knm(k,iq)*knm(k,iq)
               Write(6,'((1x,I2,1x,A),(1x,I3,1x,A),F11.2,2x,A,'//
     &                   '2(E22.14,1x,A))')
     &                   k,'|',q,'|',f,'|',B(k,q),'|'
           End Do
         End Do
      Else
         Do k=2,kmax,2
           Write(6,'(A)') '----|-----|-------------|'//
     &                    '-----------------------|'
           Do q=-k,k
             iq=abs(q)
             f=knm(k,iq)*knm(k,iq)
               Write(6,'((1x,I2,1x,A),(1x,I3,1x,A),F11.2,2x,A,'//
     &                   '2(E22.14,1x,A))')
     &                   k,'|',q,'|',f,'|',B(k,q),'|'
           End Do
         End Do
      End If
      Write(6,'(90A)') ('-',i=1,48),'|'
      Return
      End Subroutine print_CFP_stev







      Subroutine print_CFP_naoya(N,A,print_all)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: N ! dimension of the pseudospin
!     complex parameters to print
      Complex(kind=8), intent(in) :: A( (n-1), -(n-1):(n-1) )
      Logical, intent(in)          :: print_all
      ! local variables:
      Integer       :: k,q,i
      Real(kind=8) :: Ar, Ai
      Character(Len=1)  :: cRsign, cIsign


      Write(6,'(/)')
      Write(6,'(100A)') ('*',i=1,80)
      Write(6,'(A)') 'The Crystal-Field Hamiltonian:'
      Write(6,'(A)')
      Write(6,'(A)') '   Hcf = SUM_{k,q} * [ B(k,q) * O(k,q) ];'
      Write(6,'(A)')
      Write(6,'(A)') ' where:                                  '
      Write(6,'(A)') '   O(k,q) =  Irreducible Tensor Operators'
      Write(6,'(A)') '             defined as follows:         '
      Write(6,'(A)')
      Write(6,'(A)') '          Y(k,q)             CG(J,M2,k,q,J,M1)'
      Write(6,'(A)') ' < J,M1 | ------ | J,M2 >  = -----------------'
      Write(6,'(A)') '          Y(k,0)              CG(J,J,k,0,J,J) '
      Write(6,'(A)')
      Write(6,'(A)') '  CG - Clebsh-Gordan Coefficient:'
      Write(6,'(A)') '                            c,gm     '
      Write(6,'(A)') '      CG(a,al,b,bt,c,gm) = C         '
      Write(6,'(A)') '                            a,al,b,bt'
      Write(6,'(A)')
      Write(6,'(A)') '   k - the rank of the ITO, = 2, 4, 6, 8, 10, 12.'
      Write(6,'(A)') '   q - the component of the ITO, = -k, -k+1, '//
     &               '... 0, 1, ... k;'
      ! thee table:
      Write(6,'(100A)') ('-',i=1,59),'|'
      Write(6,'(A,11x,A,12x,A)') '  k |  q  |',
     &           'Complex parameter  A(k,q)','|'
      Write(6,'(A)') '----|-----|'//
     &           '--------  Real  ------|-----  Imaginary  -------|'

      If(print_all) Then
         Do k=2,N-1
            Do q=-k,k
               Ar=DBLE( A(k,q))
               Ai=AIMAG(A(k,q))
               If (Ar.ge.0.0_wp) Then
                  cRsign='+'
               Else
                  cRsign='-'
               End If
               If (Ai.ge.0.0_wp) Then
                  cIsign='+'
               Else
                  cIsign='-'
               End If

               Write(6,'((1x,I2,1x,A),(1x,I3,1x,A),'//
     &                   'A,ES20.14,1x,A,ES20.14,A)')
     &                   k,'|',q,'| ', cRsign,ABS(Ar), cIsign,ABS(Ai),
     &                   ' *I |'

            End Do
            If(k.ne.(N-1-mod(N-1,2)))
     &      Write(6,'(A)') '----|-----|'//
     &              '----------------------|-------------------------|'
         End Do
      Else
         Do k=2,N-1,2
            Do q=-k,k
               Ar=DBLE( A(k,q))
               Ai=AIMAG(A(k,q))
               If (Ar.ge.0.0_wp) Then
                  cRsign='+'
               Else
                  cRsign='-'
               End If
               If (Ai.ge.0.0_wp) Then
                  cIsign='+'
               Else
                  cIsign='-'
               End If

               Write(6,'((1x,I2,1x,A),(1x,I3,1x,A),'//
     &                   'A,ES20.14,1x,A,ES20.14,A)')
     &                   k,'|',q,'| ', cRsign,ABS(Ar), cIsign,ABS(Ai),
     &                   ' *I |'

            End Do
            If(k.ne.(N-1-mod(N-1,2)))
     &      Write(6,'(A)') '----|-----|'//
     &              '----------------------|-------------------------|'
         End Do
      End If

      Write(6,'(100A)') ('-',i=1,59),'|'
      Return
      End Subroutine print_cfp_naoya





      Subroutine print_MOM_ITO_stev(n,B,print_all)
      Implicit None
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n    ! dimension of the pseudospin
!     real and imaginary CF parameters, for x,y,z
      Real(kind=8), intent(in)    :: B(3,n,-n:n)
      Logical, intent(in)          :: print_all
      ! local variables:
      Integer       :: k,q,i,kmax,iq
      Real(kind=8) :: knm(12,0:12), f

      Call set_knm( knm )
      Write(6,'(/)')
      Write(6,'(100A)') ('*',i=1,80)
      Write(6,'(A)') 'The magnetic moment is decomposed in Stev ITO:'
      Write(6,'(A)') '   Hcf = SUM_{k,q} * [ B(k,q) * O(k,q) ];'
      Write(6,'(A)') 'where:'
      Write(6,'(A)') '   O(k,q) =  Extended Stevens Operators (ESO)'//
     &               'as defined in:'
      Write(6,'(10x,A)') '1. Rudowicz, C.; J.Phys.C: Solid State '//
     &                   'Phys.,18(1985) 1415-1430.'
      Write(6,'(10x,A)') '2. Implemented in the "EasySpin" function '//
     &                   'in MATLAB, www.easyspin.org.'
      Write(6,'(A)') '   k - the rank of the ITO, = 1, 3, 5, 7, 9, 11.'
      Write(6,'(A)') '   q - the component of the ITO, = -k, -k+1, '//
     &               '... 0, 1, ... k;'
      If((n-1)>12) Then
        Write(6,'(A)') 'k = 12 may not be the highest rank of '//
     &                 'the ITO for this case, but it '
        Write(6,'(A)') 'is the maximal k implemented in the'//
     &                 ' "EasySpin" function in MATLAB.'
      End If
      Write(6,'(A)') 'Knm are proportionality coefficients between'//
     &               ' the ESO and operators defined in '
      Write(6,'(A)') 'J. Chem. Phys., 137, 064112 (2012).'
      Write(6,'(100A)') ('-',i=1,96),'|'
      Write(6,'(A)') '  k |  q  |    (K)^2    |'//
     &               '        B(k,q) - X     |'//
     &               '        B(k,q) - Y     |'//
     &               '        B(k,q) - Z     |'
      If((n-1)>12) Then
        kmax=12
      Else
        kmax=n-1
      End If

      If(print_all) Then

         Do k=1,kmax
           Write(6,'(A)') '----|-----|-------------|'//
     &                    '-----------------------|'//
     &                    '-----------------------|'//
     &                    '-----------------------|'
           Do q=-k,k
             iq=abs(q)
             f=knm(k,iq)*knm(k,iq)
               Write(6,'((1x,I2,1x,A),(1x,I3,1x,A),F11.2,2x,A,'//
     &                   '3(E22.14,1x,A))')
     &                   k,'|',q,'|',f,'|',
     &                   B(1,k,q),'|',B(2,k,q),'|',B(3,k,q),'|'
           End Do
         End Do

      Else

         Do k=1,kmax,2
           Write(6,'(A)') '----|-----|-------------|'//
     &                    '-----------------------|'//
     &                    '-----------------------|'//
     &                    '-----------------------|'
           Do q=-k,k
             iq=abs(q)
             f=knm(k,iq)*knm(k,iq)
               Write(6,'((1x,I2,1x,A),(1x,I3,1x,A),F11.2,2x,A,'//
     &                   '3(E22.14,1x,A))')
     &                   k,'|',q,'|',f,'|',
     &                   B(1,k,q),'|',B(2,k,q),'|',B(3,k,q),'|'
           End Do
         End Do

      End If
      Write(6,'(100A)') ('-',i=1,96),'|'
      Return
      End Subroutine print_MOM_ITO_stev

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

!--------------------------------------------------------
! PURPOSE: Adds matrix B to matrix A element by element
!
! INPUT:
! r       - Factor to multiply matrix A
! A(*)    - Source matrix stored in column-major format
! LDA     - Leading dimension of matrix A
! FORMA   - 'T': transpose A; 'N': do not transpose A
! B(*)    - Target matrix stored in column-major format
! LDB     - Leading dimension of matrix B
! M       - Number of rows in both matrices
! N       - Number of columns in both matrices
!
! OUTPUT:
! B(*)    - Updated matrix containing B + r*op(A)
!--------------------------------------------------------
subroutine dgeAcc(r,A,LDA,FORMA,B,LDB,M,N)
! MATRIX Addition (accumulation) FOR GENERAL MATRICES

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LDA, LDB, M, N
real(kind=wp), intent(in) :: r, A(LDA,*)
character, intent(in) :: FORMA
real(kind=wp), intent(inout) :: B(LDB,N)
integer(kind=iwp) :: iCol

if (FORMA == 'N') then
  b(1:m,:) = b(1:m,:)+r*a(1:m,1:n)
else if (FORMA == 'T') then
  do iCol=1,n
    b(1:m,iCol) = b(1:m,iCol)+r*a(iCol,1:m)
  end do
else
  write(u6,*) FORMA
  call Abend()
end if

end subroutine dgeAcc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Precibb(ib,is,js,nd,rout,nba,no,
     &                  Temp1,Scr,Temp2,
     &                  fockii,fockai,
     &                  focki,focka,sign)
************************************************************************
*                                        [2]
*   Calculates the diagonal submatrix of E    that couple
*
*   kappa           with   kappa                for a
*        kinactive,virtual        kinactive,virtual
*
*   single inactive index.
*   Used for preconditioner.
*
*   See Olsen,Yeager, Joergensen:
*    "Optimization and characterization of an MCSCF state"
*
*   Called by prec
*
*   ib,is       :       inactive index for the submatrix
*   js          :       symmetry of virtual,virtual
*   rOut        :       Submatrix
*
************************************************************************
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
      Real*8 rout(*)
      Real*8 Focki(no,no),Focka(no,no)
      Real*8 Temp2(*),Temp1(*), Scr(*)
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      iTri1(i,j)=nTri-itri(nd-Min(i,j)+1,nd-Min(i,j)+1)
     &          +Max(i,j)-Min(i,j)+1
*                                                                      *
************************************************************************
*                                                                      *
      nTri=itri(nd,nd)
*
      jVert=nOrb(js)-nAsh(js)-nIsh(js)
      if (jvert.eq.0) Return
*
      i1=nD-jVert+1
      ip=itri1(i1,i1)
      ra=4.0d0*sign*(Fockii+Fockai)
      Call COUL(jS,jS,iS,is,IB,iB,Temp2,Scr)
      Call Dyax(no**2,-sign*4.0d0,Temp2,1,Temp1,1)
      Call EXCH(js,is,js,is,ib,ib,Temp2,Scr)
      Call DaXpY_(no**2,sign*12.0d0,Temp2,1,Temp1,1)
      i=ip-1
      Do kB=nIsh(jS)+nAsh(jS),nOrb(jS)-1
         rOut(i+1)=rout(i+1)-ra
         Do lB=kb,nOrb(JS)-1
            i=i+1
            rOut(i)=rout(i)+Temp1(kb+1+no*lb)+
     &              sign*4.0d0*Focki(kb+1,lb+1)+
     &              sign*4.0d0*Focka(kb+1,lb+1)
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nba)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pack320(a,b,dimp,dimqr,dimq,rc)
! this routine does: B(p,qr) = A(p,q,r) - A(p,r,q) for symq=symr

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimqr, dimq
real(kind=wp), intent(in) :: a(dimp,dimq,dimq)
real(kind=wp), intent(inout) :: b(dimp,dimqr)
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: p, q, qr, r

rc = 0
if (dimq > 1) then

  qr = 0
  do q=2,dimq
    do r=1,q-1
      qr = qr+1
      do p=1,dimp
        b(p,qr) = a(p,q,r)-a(p,r,q)
      end do
    end do
  end do

else
  ! RC=1 : dimp is less than 2
  rc = 1
end if

return

end subroutine pack320

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      Subroutine rdcivec_cvb(detvec,fn,reord)
************************************************************************
*                                                                      *
*     Read the contents of the JOBIPH file.                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "rasdim.fh"
#include "jobiph_j.fh"
      character*(*) fn
      logical debug
      data debug/.false./
      dimension detvec(*)
      dimension ncix(8)
      logical reord
      dimension rdum(1)

      iwr=0

      call getnci_cvb(ncix,nactel_j,ispin_j-1,lsym_j)
      ndet_j=ncix(1)

      lujob=15
      call daname_cvb(lujob,fn)
c Allocate at least NDET words for each vector, since this is
c required by csdtvc :
c      Call GetMem('OCIvec','Allo','Real',ipCI,nConf_j*nroots_j)
      Call GetMem('OCIvec','Allo','Real',ipCI,
     >  nConf_j*nroots_j+ndet_j-nconf_j)
      if(iwr.eq.0)then
        Do 200 i=1,nroots_j
        j=iroot_j(i)
        iDisk=iadr15_j(4)
        Do 300 k=1,j-1
        Call dDaFile(LuJob,0,rdum,nConf_j,iDisk)
300     continue
        Call dDaFile(LuJob,2,Work(ipCI+(i-1)*nconf_j),
     >    nConf_j,iDisk)
200     continue

        if(reord)then
          Call GetMem('ipci2','Allo','Real',ipCI2,nConf_j)
          call reord2_cvb(work(ipci),work(ipci2),1)
          call fmove_cvb(work(ipci2),work(ipci),nconf_j)
          Call GetMem('ipci2','Free','Real',ipCI2,idum)
        endif

        call csf2det_cvb(work(ipci),detvec,lsym_j,1)
      elseif(iwr.eq.1)then
        call csf2det_cvb(work(ipci),detvec,lsym_j,2)

        if(reord)then
          Call GetMem('ipci2','Allo','Real',ipCI2,nConf_j)
          call reord2_cvb(work(ipci),work(ipci2),0)
          call fmove_cvb(work(ipci2),work(ipci),nconf_j)
          Call GetMem('ipci2','Free','Real',ipCI2,idum)
        endif

        Do 400 i=1,nroots_j
        j=iroot_j(i)
        iDisk=iadr15_j(4)
        Do 500 k=1,j-1
        Call dDaFile(LuJob,0,rdum,nConf_j,iDisk)
500     continue
        Call dDaFile(LuJob,1,Work(ipCI+(i-1)*nconf_j),
     >    nConf_j,iDisk)
400     continue
      endif
      if (debug) then
        do 600 i=0,nroots_j-1
        write(6,'(a,i3,a)')' (CSF) CI vector ',i+1,' :'
        write(6,'(a)')' ---------------------'
        call mxprint_cvb(work(ipci+nconf_j*i),1,nconf_j,0)
600     continue
      endif
      Call GetMem('OCIvec','Free','Real',ipCI,idum)
      call daclos_cvb(lujob)
      Return
      end
      subroutine wrcivec_cvb(detvec,fn,reord)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "rasdim.fh"
#include "jobiph_j.fh"
      character*(*) fn
      logical debug
      data debug/.false./
      dimension detvec(*)
      dimension ncix(8)
      logical reord
      dimension rdum(1)
      iwr=1

      call getnci_cvb(ncix,nactel_j,ispin_j-1,lsym_j)
      ndet_j=ncix(1)

      lujob=15
      call daname_cvb(lujob,fn)
c Allocate at least NDET words for each vector, since this is
c required by csdtvc :
c      Call GetMem('OCIvec','Allo','Real',ipCI,nConf_j*nroots_j)
      Call GetMem('OCIvec','Allo','Real',ipCI,
     >  nConf_j*nroots_j+ndet_j-nconf_j)
      if(iwr.eq.0)then
        Do 200 i=1,nroots_j
        j=iroot_j(i)
        iDisk=iadr15_j(4)
        Do 300 k=1,j-1
        Call dDaFile(LuJob,0,rdum,nConf_j,iDisk)
300     continue
        Call dDaFile(LuJob,2,Work(ipCI+(i-1)*nconf_j),
     >    nConf_j,iDisk)
200     continue

        if(reord)then
          Call GetMem('ipci2','Allo','Real',ipCI2,nConf_j)
          call reord2_cvb(work(ipci),work(ipci2),1)
          call fmove_cvb(work(ipci2),work(ipci),nconf_j)
          Call GetMem('ipci2','Free','Real',ipCI2,idum)
        endif

        call csf2det_cvb(work(ipci),detvec,lsym_j,1)
      elseif(iwr.eq.1)then
        call csf2det_cvb(work(ipci),detvec,lsym_j,2)

        if(reord)then
          Call GetMem('ipci2','Allo','Real',ipCI2,nConf_j)
          call reord2_cvb(work(ipci),work(ipci2),0)
          call fmove_cvb(work(ipci2),work(ipci),nconf_j)
          Call GetMem('ipci2','Free','Real',ipCI2,idum)
        endif

        Do 400 i=1,nroots_j
        j=iroot_j(i)
        iDisk=iadr15_j(4)
        Do 500 k=1,j-1
        Call dDaFile(LuJob,0,rdum,nConf_j,iDisk)
500     continue
        Call dDaFile(LuJob,1,Work(ipCI+(i-1)*nconf_j),
     >    nConf_j,iDisk)
400     continue
      endif
      if (debug) then
        do 600 i=0,nroots_j-1
        write(6,'(a,i3,a)')' (CSF) CI vector ',i+1,' :'
        write(6,'(a)')' ---------------------'
        call mxprint_cvb(work(ipci+nconf_j*i),1,nconf_j,0)
600     continue
      endif
      Call GetMem('OCIvec','Free','Real',ipCI,idum)
      call daclos_cvb(lujob)
      Return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Bjorn O. Roos                                    *
!               1989, Per Ake Malmqvist                                *
!               1991,1993,1996, Markus P. Fuelscher                    *
!***********************************************************************

subroutine SXCtl(CMO,OCC,D,P,PA,FI,FA,D1A,THMAX,IFINAL)
!*******************************************************************
!                                                                  *
! super-CI control section                                         *
!                                                                  *
! calling arguments:                                               *
! CMO     : array of real*8                                        *
!           MO-coefficients                                        *
! OCC     : array of real*8                                        *
!           orbital occupation numbers                             *
! D       : array of real*8                                        *
!           averaged one-body density matrix                       *
! P       : array of real*8                                        *
!           averaged two-body density matrix                       *
! PA      : array of real*8                                        *
!           averaged antisymmetric two-body density matrix         *
! FI      : array of real*8                                        *
!           inactive Fock matrix                                   *
! FA      : array of real*8                                        *
!           active Fock matrix                                     *
! D1A     : array of real*8                                        *
!           active one-body density matrix in AO basis             *
! IFINAL  : integer                                                *
!           termination flag                                       *
!                                                                  *
!------------------------------------------------------------------*
!                                                                  *
! written by:                                                      *
! B.O. Roos and P.Aa. Malmqvist                                    *
! University of Lund, Sweden, 1989                                 *
!                                                                  *
!------------------------------------------------------------------*
!                                                                  *
! history:                                                         *
! - updated for MOLCAS version 2                                   *
!   M.P. Fuelscher, University of Lund, Sweden, 1991               *
! - updated for MOLCAS version 3                                   *
!   M.P. Fuelscher, University of Lund, Sweden, 1993               *
! - updated for integral direct and reaction field calculations    *
!   M.P. Fuelscher, University of Lund, Sweden, 1996               *
!                                                                  *
!*******************************************************************

use Index_Functions, only: nTri_Elem
use fciqmc, only: DoNECI
use Fock_util_global, only: ALGO, DoCholesky
use Lucia_Interface, only: Lucia_Util
use wadr, only: BM, DIA, F1, F2, NLX, SXG, SXH, SXN
use input_ras, only: Key
use rasscf_global, only: DoBlockDMRG, DoDMRG, ECAS, EMY, ESX, ExFac, IADR15, iCIOnly, iPT2, ISTORP, ITER, ITERSX, ITMAX, KSDFT, &
                         l_casdft, NAC, nDimSX, nFint, NO2M, nQune, NROOT, NSXS, NTOT4, QNSTEP, QNUPDT, SXSEL, TMIN, VIA
use PrintLevel, only: DEBUG
use output_ras, only: IPRLOC
use general_data, only: JOBIPH, LUINTM, LUQUNE, NACTEL, NASH, NBAS, NDEL, NFRO, NISH, NORB, NRS1, NRS2, NRS3, NSSH, NSYM, NTOT, &
                        NTOT1, NTOT2
#ifdef _HDF5_
use mh5, only: mh5_put_dset
use raswfn, only: wfn_mocoef, wfn_occnum
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: CMO(*), OCC(*), P(*), FI(*), FA(*)
real(kind=wp), intent(in) :: D(*), PA(*), D1A(*)
real(kind=wp), intent(out) :: THMAX
integer(kind=iwp), intent(in) :: IFINAL
integer(kind=iwp) :: i, iBas, IC, iDisk, IndType(7,8), iOff, iOrb, iPrLev, iRC, iRef, iSym, iWay, j, kMax, LCSXI, LuvvVec, MIAAE, &
                     MNO, NAEAE, NAOAE, NCR, NCR1, NIAIA, NLCC, NLHH, NLOVL, NLQ, nP2Act, NQ
real(kind=wp) :: CASDFT_En, CIDUMMY(1), CPES, CPTS, Dummy(1), P2act(1), P2reo_size, TIOES, TIOS, XSXMAX
character(len=80) :: VecTyp
logical(kind=iwp) :: TraOnly
integer(kind=iwp), save :: nCall
real(kind=wp), allocatable :: CC(:), CMON(:), CMOX(:), CSX(:), DA(:), EDum(:), ENER_X(:), Fck(:), FTR(:), HH(:), OVL(:), P2Raw(:), &
                              P2reo(:), PUVX(:), QMat(:), QQ(:), SC(:), SCR(:), Sigma(:), SQ(:), STRP(:), SXDD(:), SXDF(:), &
                              SXHD(:), V1(:), V2(:), Vec(:), VL(:), VT(:), WO(:), X2(:), XMAT(:), XQN(:)
real(kind=wp), allocatable, target :: SMAT(:)
integer(kind=iwp), external :: IsFreeUnit
real(kind=wp), external :: DDot_

! PAM01 The SXCI part has been slightly modified by P-AA M Jan 15, 2001:
! Changes affect several of the subroutines of this part.
! The program should now behave more gracefully when there are (almost)
! redundant orbital rotation modes.
! For individual 2x2 rotations that are to be excluded, the SX hamiltonian
! diagonal, used in the preconditioning step in DAVCRE, is set to a huge
! value. Corresponding elements of trial vectors and sigma vectors are
! zeroed.
! To take care of 'hidden' redundant linear combinations, a small extra
! term, proportional to the square norm of the orbital rotations, is
! added to the optimization problem: this means in practice that a small
! extra term is added in the SIGVEC routine.
! Also, an extra term is added to the overlap calculation. The
! proportionality factor in SIGVEC should be small, but larger than the
! one used in the COVLP routine.
! Presently I try the following values:
! Huge elements in diagonal values: 1.0e32
! (Tested against 1.0e20 in IF-statements)
! Extra term in overlaps (COVLP, SXHAM): 1.0e-14
! Extra term in SIGVEC:                  1.0e-12

! Local print level (if any)
IPRLEV = IPRLOC(4)
!write(u6,*) 'Entering SXCTL!'
if (IPRLEV >= DEBUG) write(u6,*) ' Entering SXCTL'

! --- Check for Cholesky ---------------

!call DecideOnCholesky(DoCholesky)
! --------------------------------------

! compute constants needed for addressing
NSXS = sum((NISH(1:NSYM)+NASH(1:NSYM))*(NASH(1:NSYM)+NSSH(1:NSYM)))
NIAIA = sum((NISH(1:NSYM)+NASH(1:NSYM))**2)
NAEAE = sum((NASH(1:NSYM)+NSSH(1:NSYM))**2)
NAOAE = sum(NASH(1:NSYM)*(NASH(1:NSYM)+NSSH(1:NSYM)))
MNO = maxval(NORB(1:NSYM))
MIAAE = maxval((NISH(1:NSYM)+NASH(1:NSYM))*(NASH(1:NSYM)+NSSH(1:NSYM)))
NLX = max(MIAAE,maxval(NASH(1:NSYM)*(NISH(1:NSYM)+NASH(1:NSYM))))
NQ = max(NIAIA,maxval(NASH(1:NSYM)*NORB(1:NSYM)))
NROOT = 1
NDIMSX = NROOT+NSXS
!***********************************************************************
! load back two-electron integrals (pu|vx)
!***********************************************************************
if ((.not. DoCholesky) .or. (ALGO == 1)) then
  if (nFint > 0) then
    iDisk = 0
    call mma_allocate(PUVX,nFint,Label='PUVX')
    call DDaFile(LUINTM,2,PUVX,nFint,iDisk)
  else
    call mma_allocate(PUVX,1,Label='PUVX')
  end if
end if
if (IPRLEV >= DEBUG) then
  write(u6,*) 'PUVX integrals in SXCTL'
  call wrtmat(PUVX,1,nFInt,1,nFInt)
end if
!********************************************************************************
! update and transform the Fock matrices FI and FA in MO basis ----> Fmat routine
!********************************************************************************
if ((.not. DoCholesky) .or. (ALGO == 1)) then
  call Fmat(CMO,PUVX,D,D1A,FI,FA)

else if (ALGO == 2) then

  ! Inactive-active contribution to ECAS
  call mma_allocate(DA,nTot1,Label='DA')
  call Fold(nSym,nBas,D1A,DA) !get the packed DA
  VIA = dDot_(nTot1,FI,1,DA,1)
  ECAS = EMY+VIA
  if (IPRLEV >= DEBUG) then
    write(u6,'(A,ES20.10)') ' Total core energy:            ',EMY
    write(u6,'(A,ES20.10)') ' inactive-active interaction:  ',VIA
    write(u6,'(A,ES20.10)') ' CAS energy (core+interaction):',ECAS
  end if
  call mma_deallocate(DA)

  TraOnly = .true.
  call CHO_CAS_DRV(irc,CMO,D,FI,D1A,FA,Dummy,TraOnly)

  if (irc /= 0) then
    write(u6,*) 'SXCTL: Cho_cas_drv non-zero return code! rc= ',irc
    call abend()
  end if

else

  write(u6,*) 'SXCTL: Illegal Cholesky parameter ALGO= ',ALGO
  call abend()

end if
!***********************************************************************
! reorder the two-body density matrix P
!***********************************************************************
if (.not. l_casdft) then
  ! ISTORP(NSYM+1) represents the size of the 2-body density matrix,d(vwxy), with vwxy all active.
  ! the size is computed as NAP*NAQ*NRS (sum over all symmetries). If Sym_R = Sym_S then triangular
  ! form over NRS... with R >= S, rectanguar otherwise.
  if (ISTORP(NSYM+1) > 0) then
    call mma_allocate(STRP,ISTORP(NSYM+1),Label='STRP')

    call PMAT_RASSCF(P,STRP)

    if ((ExFac /= One) .and. (KSDFT(1:3) /= 'SCF')) then
      call mma_allocate(P2reo,ISTORP(NSYM+1),Label='P2reo')
      call Get_Temp('nP2Act  ',P2Act,1)
      nP2Act = int(P2Act(1))
      call mma_allocate(P2RAW,nP2Act,Label='P2Raw')
      call Get_Temp('P2_RAW  ',P2RAW,nP2Act)
      call PMAT_RASSCF(P2RAW,P2reo)
      call mma_deallocate(P2Raw)
      P2reo_size = real(ISTORP(NSYM+1),kind=wp)
      call Put_Temp('nP2reo  ',[P2reo_size],1)
      call Put_Temp('P2_reo  ',P2reo,ISTORP(NSYM+1))
      call mma_deallocate(P2reo)
    end if
  else
    call mma_allocate(STRP,1,Label='STRP')
  end if
else ! GLM-CASDFT
  ! ISTORP(NSYM+1) here represents the size of the Dvw*Dxy array (product of one-body
  ! density matrix,d(vwxy), with vwxy all active. The size is computed as NAP*NAQ*NRS
  ! (sum over all symmetries). If Sym_R = Sym_S then triangular form over NRS...
  ! with R >= S, rectanguar otherwise. Basically we will use same simmetry as for dvwxy.
  if (ISTORP(NSYM+1) > 0) then
    !write(u6,*)
    !write(u6,*) ' ---------------------'
    call mma_allocate(STRP,ISTORP(NSYM+1),Label='STRP')
    call DmatDmat(D,STRP)
  else
    call mma_allocate(STRP,1,Label='STRP')
  end if
end if
!***********************************************************************
! Compute the MCSCF generalized Fock matrix and Brillouin matrix elements
!***********************************************************************
call mma_allocate(FCK,NTOT4,Label='FCK')
call mma_allocate(BM,NSXS,Label='BM')
call mma_allocate(QMat,NQ,Label='QMat') ! q-matrix(1symmblock)
call FOCK(FCK,BM,FI,FA,D,STRP,QMat,PUVX,IFINAL,CMO)
! Now FA = FI + FA. Original FA has been overwritten in FOCK routine.
if (IPRLEV >= DEBUG) then
  write(u6,*)
  write(u6,*) 'FI+FA in MO-basis in sxctl (overwritten on FA)'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    call TriPrt(' ',' ',FA(iOff),iOrb)
    iOff = iOff+nTri_Elem(iOrb)
  end do
end if
call mma_deallocate(FCK)
call mma_deallocate(QMat)
call mma_deallocate(STRP,safe='*')
call mma_deallocate(PUVX,safe='*')

! PAM 2008: Orbital files should be updated each iteration
! for easy access in case of catastrophic failure.
if (IFINAL /= 1) then
  IndType(:,:) = 0
  do ISYM=1,NSYM
    IndType(:,ISYM) = [NFRO(ISYM),NISH(ISYM),NRS1(ISYM),NRS2(ISYM),NRS3(ISYM),NDEL(ISYM),NBAS(ISYM)]
    IndType(7,ISYM) = IndType(7,ISYM)-sum(IndType(1:6,ISYM))
  end do
  ! Note: This is not the final orbitals, and the orbital energies and
  ! active occupation numbers may be meaningless.
  ! There is an array with occupation numbers, so use it, even if
  ! possibly irrelevant. But put zeroes as orbital energies:
  call mma_allocate(EDUM,NTOT,Label='EDUM')
  EDUM(:) = Zero

  write(VecTyp,'(A)')
  VecTyp = '* RASSCF average (pseudo-natural) orbitals (Not final)'
  LuvvVec = 50
  LuvvVec = isfreeunit(LuvvVec)
  call WrVec('RASORB',LuvvVec,'COE',NSYM,NBAS,NBAS,CMO,OCC,EDUM,INDTYPE,VECTYP)
  call WrVec('RASORB',LuvvVec,'AI',NSYM,NBAS,NBAS,CMO,OCC,EDUM,INDTYPE,VECTYP)
  call mma_deallocate(EDUM)

# ifdef _HDF5_
  call mh5_put_dset(wfn_mocoef,CMO)
  call mh5_put_dset(wfn_occnum,OCC)
# endif
end if

if (IFINAL == 1) then
  ! If ifinal=1 , this is the last call to SXCTL for calculating
  ! the MCSCF Fock matrix for occupied orbitals, and new orbitals).
  ! First generate final orbitals:
  ! Diagonalize inactive and secondary part of FP = FI + FA.
  !         diagonal blocks of the active density matrix
  ! for RAS1, RAS2, and RAS3. All this is done in NEWORB.
  ! Finally generate orbitals and Fock matrices for CAS-PT2 runs.
  ! in FCKPT2

  ! Memory allocation and call to NEWORB and FCKPT2
  ! CMON: New molecular orbitals (NTOT2)
  ! FTR:  Temporary area for part of the Fock matrix FP (NTOT1)
  ! VEC:  EIGENVECTORS OF FTR (NO2M)
  ! SQ and WO: scratch areas

  call mma_allocate(CMON,NTOT2,Label='CMON')
  call mma_allocate(FTR,NTOT1,Label='FTR')
  call mma_allocate(VEC,NTOT2,Label='VEC')
  call mma_allocate(WO,NTOT2,Label='WO')
  call mma_allocate(SQ,NTOT2,Label='SQ')
  call mma_allocate(CMOX,NTOT2,Label='CMOX')
  if (IPRLEV >= DEBUG) then
    write(u6,*)
    write(u6,*) ' CMO in SXCTL for IFINAL=1'
    write(u6,*) ' ---------------------'
    write(u6,*)
    ioff = 0
    do iSym=1,nSym
      iBas = nBas(iSym)
      if (iBas /= 0) then
        write(u6,*) 'Sym =',iSym
        do i=1,iBas
          write(u6,*) (CMO(ioff+iBas*(i-1)+j),j=1,iBas)
        end do
        iOff = iOff+(iBas*iBas)
      end if
    end do
  end if

  if (iCIonly == 1) then
    IDISK = IADR15(2)
    call DDAFILE(JOBIPH,1,CMO,NTOT2,IDISK)
    call DDAFILE(JOBIPH,1,OCC,NTOT,IDISK)
#   ifdef _HDF5_
    call mh5_put_dset(wfn_mocoef,CMO)
    call mh5_put_dset(wfn_occnum,OCC)
#   endif
  else
    ! this part (TRACI) need to be changed to "TRAMPS", not yet ! Yingjin
    call NEWORB_RASSCF(CMO,CMON,FA,FTR,VEC,WO,SQ,CMOX,D,OCC)
    ! compute orbital overlap matrix
    !if (NACTEL > 0) then
    ! NN.14 Skip this when DMRG-CASSCF due to CI-vector dependency
    !if (.not. (DoDMRG .or. doBlockDMRG) .and. (NACTEL > 0)) then
    if (NACTEL > 0) then
      call mma_allocate(SMAT,NAC*NAC,Label='SMAT')
      IWAY = 1
      call OVLP(IWAY,CMO,CMON,SMAT)

      if (dodmrg) then
#       ifdef _DMRG_
#       ifdef BLUBB
        call mpsrot(mat,nac,nrs2,nsym)
#       endif
#       endif
      else if (doBlockDMRG .or. DoNECI) then
      else !CI
        iDisk = IADR15(4)
        call LUCIA_UTIL('TRACI',iDisk=iDisk,Lu=JOBIPH,Array=SMAT(:))
      end if
      call mma_deallocate(SMAT)
    else
      CIDUMMY = One
      IDISK = IADR15(4)
      call DDAFILE(JOBIPH,1,CIDUMMY,1,IDISK)
    end if
  end if

  ! IPT2 = 1 for OUTO, CANOnical option...
  if (IPT2 /= 0) call FCKPT2(CMO,CMON,FI,FA,FTR,VEC,WO,SQ,CMOX)

  call mma_deallocate(CMOX)
  call mma_deallocate(SQ)
  call mma_deallocate(WO)
  call mma_deallocate(VEC)
  call mma_deallocate(FTR)
  call mma_deallocate(CMON)

  call TIMING(CPTS,CPES,TIOS,TIOES)

else

  ! Memory allocation and calling sequence for SXHAM
  ! SXN: Normalization constants for super-CI vector
  ! F1 and F2: parts of the Fock matrix FP
  ! DIA: Occupied part of the density matrix (squared)
  ! SXG: The G matrix(used in sigvec)
  ! SXH: The H matrix( "    "   "   )
  ! SXHD: The diagonal of the super-CI Hamiltonian
  ! LDF: The matrix D*FP
  ! LDDIA: Diagonal of the density matrix (all elements one symmetry)

  call mma_allocate(SXN,NSXS,Label='SXN')
  call mma_allocate(F1,NIAIA,Label='F1')
  call mma_allocate(F2,NAEAE,Label='F2')
  call mma_allocate(DIA,NIAIA,Label='DIA')
  call mma_allocate(SXG,NIAIA,Label='SXG')
  call mma_allocate(SXH,NAOAE,Label='SXH')
  call mma_allocate(SXHD,NDIMSX,Label='SXHD')
  call mma_allocate(SXDF,NQ,Label='SXDF')
  call mma_allocate(SXDD,MNO,Label='SXDD')

  !call TRIPRT(' Dmat in MO in SXCTL bf call to SXHAM ',' ',D,NAC)
  !call TRIPRT(' Pmat in MO in SXCTL bf call to SXHAM ',' ',P,NACPAR)
  !call TRIPRT(' PAmat in MO in SXCTL bf call to SXHAM',' ',PA,NACPAR)
  call SXHAM(D,P,PA,FA,SXN,F1,F2,DIA,SXG,SXH,SXHD,SXDF,SXDD)

  call mma_deallocate(SXDD)
  call mma_deallocate(SXDF)

  ! PAM01 Removal of certain rotations from the BLB elements.
  ! Some additional rotations (besides those listed in IZROT) may
  ! need to be suppressed. These are rotations that are (very nearly)
  ! redundant -- they hardly affect the wave function at all.
  ! All suppressed rotations can be identified because the corresponding
  ! diagonal elements have been set to a huge number in SXHAM.
  ! Use this criterion to set some BLB elements exactly =0:
  do I=1,NSXS
    if (SXHD(NROOT+I) > 1.0e20_wp) BM(I) = Zero
  end do

  ! MEMORY ALLOCATION AND CALLING SEQUENCE FOR SX DIAGONALIZATION

  ! CSX: The super-CI vectors
  ! SIGMA: The sigma vectors
  ! HH:  The Davidson H matrix
  ! CC:   "     "     egenvectors
  ! ENER: "     "     energies
  ! SC:   Scratch area
  ! QMat:    Davidson update vectors
  ! QQ:   Norm of update vectors
  ! OVL:  Overlap matrix

  NCR = NDIMSX*NROOT*ITMAX
  KMAX = ITMAX*NROOT
  NCR1 = NDIMSX*NROOT*(ITMAX+1)
  call mma_allocate(CSX,NCR1,Label='CSX')
  call mma_allocate(SIGMA,NCR,Label='SIGMA')
  NLHH = KMAX**2+KMAX
  NLCC = KMAX**2
  NLQ = NDIMSX*(NROOT+1)
  NLOVL = ITMAX*NROOT**2
  call mma_allocate(HH,NLHH,Label='HH')
  call mma_allocate(CC,NLCC,Label='CC')
  call mma_allocate(ENER_X,KMAX,Label='ENER_X')
  call mma_allocate(SC,NDIMSX,Label='SC')
  call mma_allocate(QMat,NLQ,Label='QMat')
  call mma_allocate(QQ,NROOT,Label='QQ')
  call mma_allocate(OVL,NLOVL,Label='OVL')

  call DAVCRE(CSX,SIGMA,HH,CC,ENER_X,SXHD,SC,QMat,QQ,OVL,SXSEL,NROOT,ITMAX,NDIMSX,ITERSX,NSXS)

  ESX = ENER_X(1)
  call mma_deallocate(SIGMA)
  call mma_deallocate(HH)
  call mma_deallocate(CC)
  call mma_deallocate(ENER_X)
  call mma_deallocate(SC)
  call mma_deallocate(QMat)
  call mma_deallocate(QQ)
  call mma_deallocate(OVL)
  call mma_deallocate(F1)
  call mma_deallocate(F2)
  call mma_deallocate(SXG)
  call mma_deallocate(SXH)
  call mma_deallocate(SXHD)

  ! Renormalize the SX-coefficients

  IREF = 1
  LCSXI = 1+NDIMSX*(IREF-1)
  IC = NROOT+LCSXI-1
  CSX(IC+1:IC+NSXS) = SXN(1:NSXS)*CSX(IC+1:IC+NSXS)/CSX(LCSXI)
  XSXMAX = maxval(abs(CSX(IC+1:IC+NSXS)))
  if (IPRLEV >= DEBUG) then
    write(u6,*) 'SXCTL after DAVCRE, Renormalized SX coeffs:'
    write(u6,'(1X,8F14.6)') (CSX(IC+I),I=1,NSXS)
  end if

  ! Step size control has been built into qune now.
  !C Step length control, just for safety.
  !do I=1,NSXS
  !  VAL = CSX(IC+I)
  !  CSX(IC+I) = VAL/(One+1.7_wp*abs(VAL))
  !end do

  ! Intercept XSX and BM, to use (perhaps) Quasi-Newton or Line Search

  !if (ITER == 1) NCALL = 0
  if (ITER <= 4) NCALL = 0
  if (Key('HEUR') .and. (ITER > 10) .and. (mod(ITER,10) < 4)) NCALL = 0
  if (doDMRG .and. (ITER <= 2)) NCALL = 0  ! YM: change 4 -> 2, for saving time
  if (XSXMAX > Half) NCALL = 0
  if ((NQUNE /= 0) .and. (XSXMAX < Half)) then
    call mma_allocate(VT,NSXS,Label='VT')
    call mma_allocate(VL,NSXS,Label='VL')
    call mma_allocate(XQN,NSXS,Label='XQN')
    call mma_allocate(SCR,NSXS,Label='SCR')
    call mma_allocate(V1,NSXS,Label='V1')
    call mma_allocate(V2,NSXS,Label='V2')
    CASDFT_En = Zero
    if ((KSDFT /= 'SCF') .and. (KSDFT(1:3) /= 'PAM')) call Get_dScalar('CASDFT energy',CASDFT_En)
    CASDFT_En = ECAS+CASDFT_En
    call QUNE(NCALL,CASDFT_En,BM,CSX(NROOT+LCSXI),VL,VT,XQN,SCR,V1,V2,NSXS,LUQUNE,TMIN,QNSTEP,QNUPDT,KSDFT)

    call mma_deallocate(VT)
    call mma_deallocate(VL)
    call mma_deallocate(XQN)
    call mma_deallocate(SCR)
    call mma_deallocate(V1)
    call mma_deallocate(V2)
  end if

  ! Rotation of orbitals with exp(x) where x is obtained from
  ! the super-CI coefficients, with a Quasi Newton update (NQUNE=1)

  ! CMO:  before - old MO's           after - new MO's
  ! CMON: intermediate storage for new MO's (moved to CMO in ORTHO)
  ! X2:  work area, also in ORTHO (AO overlap matrix)
  ! Scr: WORK AREA

  call mma_allocate(CMON,NTOT2,Label='CMON')
  call mma_allocate(XMAT,NO2M,Label='XMAT')
  call mma_allocate(X2,NTOT1,Label='X2')
  call mma_allocate(Scr,NO2M,Label='SCR')

  call ROTORB(CMO,CMON,CSX(LCSXI),XMAT,X2,SCR,THMAX,FA)

  if (IPRLEV >= DEBUG) then
    write(u6,*)
    write(u6,*) 'FI+FA in SXCTL after Unitary transform in ROTORB'
    write(u6,*) ' --------------'
    write(u6,*)
    iOff = 1
    do iSym=1,nSym
      iOrb = nOrb(iSym)
      call TriPrt(' ',' ',FA(iOff),iOrb)
      iOff = iOff+nTri_Elem(iOrb)
    end do
  end if
  call mma_deallocate(CMON)
  call mma_deallocate(XMAT)
  call mma_deallocate(X2)
  call mma_deallocate(SCR)
  call mma_deallocate(SXN)
  call mma_deallocate(DIA)
  call mma_deallocate(CSX)

  IDISK = IADR15(2)
  call DDAFILE(JOBIPH,1,CMO,NTOT2,IDISK)
  call DDAFILE(JOBIPH,1,OCC,NTOT,IDISK)
# ifdef _HDF5_
  call mh5_put_dset(wfn_mocoef,CMO)
  call mh5_put_dset(wfn_occnum,OCC)
# endif
  call TIMING(CPTS,CPES,TIOS,TIOES)
end if

call mma_deallocate(BM)

end subroutine SXCtl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cvbmn_rvb(icode)
      use definitions, only: iwp
      use casvb_global, only: esym, n_iter
      implicit none
      integer(kind=iwp), intent(in):: icode

c  ICODE=0 standard casvb calculation
c  ICODE=1 variational calculation
c  ICODE=2 end of variational calculation (print summary)

      call cvbstart_rvb_lt9(icode)
      call main_cvb()
      call setretvals_cvb(esym,n_iter)

      end subroutine cvbmn_rvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ireorg1(symp,symq,symr,syms,typp,typq,typr,typs,pospv1,posqv1,posrv1,possv1,typpv1,typqv1,typrv1,typsv1,typv2,v1, &
                   v2,fact,dimpq,dimrs,dimt,dimu,dimv,dimx)
! this routine maps v2(pq,rs) <+ fact . v1 (t,u,v,z)
! v2 may be of type 0,1,3,4 (typv2) while type v1 is always 0
! symp-syms and typp-typs are symmetries and types of p-s indices
! pospv1-possv1 are corresponding positions of p-s indices in v1
!
! symp-s     - symmetries of p-s (I)
! typp-s     - types of indices p-s in V2 (I)
! posp-sv1   - positions of p-s ind. in v1 (I)
! typp-sv1   - types of indices, corresponding to p-s in V1 (I)
! typv2      - type of V2 (0,1,2,4) (I)
! v1,v2      - arrays V1 and V2  (I,O)
! fact       - multiplication factors (usually +-1.0) (I)
! dimpq,rs   - dimensions of V2 (I)
! dimt-x     - dimensions of V1 (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: symp, symq, symr, syms, typp, typq, typr, typs, pospv1, posqv1, posrv1, possv1, typpv1, typqv1, &
                                 typrv1, typsv1, typv2, dimpq, dimrs, dimt, dimu, dimv, dimx
real(kind=wp), intent(in) :: v1(dimt,dimu,dimv,dimx), fact
real(kind=wp), intent(inout) :: v2(dimpq,dimrs)
integer(kind=iwp) :: ind(4), p, paddv1 = -1, pq, pqyes, pup = 0, q, qaddv1 = -1, qup = 0, r, raddv1 = -1, rc, rs, rsyes, rup = 0, &
                     s, saddv1 = -1, sup = 0

! def additive constants

call ireorg3(symp,typp,typpv1,paddv1,rc)
call ireorg3(symq,typq,typqv1,qaddv1,rc)
call ireorg3(symr,typr,typrv1,raddv1,rc)
call ireorg3(syms,typs,typsv1,saddv1,rc)

! def summation limits

call ireorg2(symp,typp,pup,rc)
call ireorg2(symq,typq,qup,rc)
call ireorg2(symr,typr,rup,rc)
call ireorg2(syms,typs,sup,rc)

! def pqyes, rsyes (i.e. if there is a reduced summation)

if ((typv2 == 1) .or. (typv2 == 4)) then
  if (symp == symq) then
    pqyes = 1
  else
    pqyes = 0
  end if
else
  pqyes = 0
end if

if ((typv2 == 3) .or. (typv2 == 4)) then
  if (symr == syms) then
    rsyes = 1
  else
    rsyes = 0
  end if
else
  rsyes = 0
end if

if ((pqyes == 1) .and. (rsyes == 1)) then

  ! case p>q, r>s

  rs = 0
  do r=2,rup
    ind(posrv1) = raddv1+r
    do s=1,r-1
      ind(possv1) = saddv1+s
      rs = rs+1

      pq = 0
      do p=2,pup
        ind(pospv1) = paddv1+p
        do q=1,p-1
          ind(posqv1) = qaddv1+q
          pq = pq+1

          v2(pq,rs) = v2(pq,rs)+fact*v1(ind(1),ind(2),ind(3),ind(4))

        end do
      end do
    end do
  end do

else if (pqyes == 1) then

  ! case p>q, r,s

  rs = 0
  do s=1,sup
    ind(possv1) = saddv1+s
    do r=1,rup
      ind(posrv1) = raddv1+r
      rs = rs+1

      pq = 0
      do p=2,pup
        ind(pospv1) = paddv1+p
        do q=1,p-1
          ind(posqv1) = qaddv1+q
          pq = pq+1

          v2(pq,rs) = v2(pq,rs)+fact*v1(ind(1),ind(2),ind(3),ind(4))

        end do
      end do
    end do
  end do

else if (rsyes == 1) then

  ! case p,q, r>s

  rs = 0
  do r=2,rup
    ind(posrv1) = raddv1+r
    do s=1,r-1
      ind(possv1) = saddv1+s
      rs = rs+1

      pq = 0
      do q=1,qup
        ind(posqv1) = qaddv1+q
        do p=1,pup
          ind(pospv1) = paddv1+p
          pq = pq+1

          v2(pq,rs) = v2(pq,rs)+fact*v1(ind(1),ind(2),ind(3),ind(4))

        end do
      end do
    end do
  end do

else

  ! case p,q, r,s

  rs = 0
  do s=1,sup
    ind(possv1) = saddv1+s
    do r=1,rup
      ind(posrv1) = raddv1+r
      rs = rs+1

      pq = 0
      do q=1,qup
        ind(posqv1) = qaddv1+q
        do p=1,pup
          ind(pospv1) = paddv1+p
          pq = pq+1

          v2(pq,rs) = v2(pq,rs)+fact*v1(ind(1),ind(2),ind(3),ind(4))

        end do
      end do
    end do
  end do

end if

return

end subroutine ireorg1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkV_K22 (W1,W2,dim)
c
c       this routine do
c       W1(p) = -W2(p)
c
c       N.B. toto je iba plytke copy s opacnym znamienkom,
c            da sa aj s blasmi spravit
c       N.B. Kvajt odflaknute
c
c
        implicit none
        integer dim
        real*8 W1(1:dim)
        real*8 W2(1:dim)
c
c       help variables
        integer p
c
c
        do p=1,dim
          W1(p)=-W2(p)
        end do
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagFro3(NBSQT,FIFA,FIMO,WRK1,WRK2)

use Index_Functions, only: nTri_Elem
use caspt2_global, only: CMOPT2
use caspt2_module, only: NBAS, NBTRI, NDEL, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NBSQT
real(kind=wp), intent(inout) :: FIFA(NBSQT), FIMO(NBSQT)
real(kind=wp), intent(out) :: WRK1(NBSQT), WRK2(NBSQT)
integer(kind=iwp) :: iAO, iAOtr, iCMO, ICOMP, iMO, IOPT, IRC, ISYLBL, iSym, nBasI, nOrbI
character(len=8) :: Label
real(kind=wp), allocatable :: WFLT(:)

!! Read H_{\mu \nu}
call mma_allocate(WFLT,NBTRI,Label='WFLT')
IRC = -1
IOPT = 6
ICOMP = 1
ISYLBL = 1
Label = 'OneHam  '
call RDONE(IRC,IOPT,Label,ICOMP,WFLT,ISYLBL)

!! AO -> MO transformation
iAO = 1
iAOtr = 1
iCMO = 1
iMO = 1
do iSym=1,nSym
  nBasI = nBas(iSym)
  nOrbI = nBas(iSym)-nDel(iSym)

  !! FIFA
  !! WRK1 = G(D)
  WRK1(1:nBasI*nBasI) = FIFA(iAO:iAO+nBasI*nBasI-1)
  !! WRK1 = H+G(D)
  call Square(WFLT(iAOtr),WRK2,1,nBasI,nBasI)
  WRK1(1:nBasI*nBasI) = WRK1(1:nBasI*nBasI)+WRK2(1:nBasI*nBasI)
  !! AO -> MO transformation of H+G(D)
  call OLagTrf(2,iSym,NBSQT,CMOPT2(iCMO),FIFA(iMO),WRK1,WRK2)

  !! FIMO
  !! WRK1 = G(D)
  WRK1(1:nBasI*nBasI) = FIMO(iAO:iAO+nBasI*nBasI-1)
  !! WRK1 = H+G(D)
  call Square(WFLT(iAOtr),WRK2,1,nBasI,nBasI)
  WRK1(1:nBasI*nBasI) = WRK1(1:nBasI*nBasI)+WRK2(1:nBasI*nBasI)
  !! AO -> MO transformation of H+G(D)
  call OLagTrf(2,iSym,NBSQT,CMOPT2(iCMO),FIMO(iMO),WRK1,WRK2)

  iAO = iAO+nBasI*nBasI
  iAOtr = iAOtr+nTri_Elem(nBasI)
  iCMO = iCMO+nBasI*nOrbI !?
  iMO = iMO+nOrbI*nOrbI
end do
!write(u6,*) 'FIFA'
!call sqprt(fifa,nbast)
!write(u6,*) 'FIMO'
!call sqprt(fimo,nbast)

call mma_deallocate(WFLT)

end subroutine OLagFro3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PrInp_MCLR(iPL)
************************************************************************
*                                                                      *
*     Echo input                                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "disp_mclr.fh"
#include "sa.fh"
      Character*8   Fmt1,Fmt2
      Character XYZ(3)
      Character*100  Line,BlLine,StLine
      Data XYZ / 'X','Y','Z' /
*----------------------------------------------------------------------*
*     Start and define the paper width                                 *
*----------------------------------------------------------------------*
      lPaper=110
*     lPaper=80
*----------------------------------------------------------------------*
*     Initialize blank and header lines                                *
*----------------------------------------------------------------------*

      lLine=Len(Line)
      Do i=1,lLine
         BlLine(i:i)=' '
         StLine(i:i)='*'
      End Do
      lPaper=132
*     left=(lPaper-lLine)/2
      left=5
      Write(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
*----------------------------------------------------------------------*
*     Print the project title                                          *
*----------------------------------------------------------------------*
*     If ( mTit.gt.0 ) then
         If (iPL.ge.3) Write(6,*)
         nLine=mTit+5
         Do i=1,nLine
            Line=BlLine
            If ( i.eq.1 .or. i.eq.nLine ) Line=StLine
            If ( i.eq.3 ) Line='Project:'
            If ( i.ge.4 .and. i.le.nLine-2 )
     &         Write(Line,'(18A4)')(TitleIN((i-4)*18+j),j=1,18)
            If (iPL.ge.3) Then
               Call Center(Line)
               Write(6,Fmt1) '*'//Line//'*'
            End If
         End Do
         If (iPL.ge.3) Write(6,*)
*     End If
*----------------------------------------------------------------------*
*     Print file identifiers                                           *
*----------------------------------------------------------------------*
      If (iPL.ge.3) Then
         Write(6,*)
         Write(6,Fmt1) 'Header of the ONEINT file:'
         Write(6,Fmt1) '--------------------------'
         Write(Line,Fmt1)  Header1I(1)
         Write(6,'(A)') Line(:mylen(Line))
         Write(Line,Fmt1)  Header1I(2)
         Write(6,'(A)') Line(:mylen(Line))
         Write(6,*)
*----------------------------------------------------------------------*
*     Print cartesian coordinates of the system                        *
*----------------------------------------------------------------------*
         Write(6,*)
         Write(6,Fmt1)'Cartesian coordinates:'
         Write(6,Fmt1)'----------------------'
         Write(6,*)
       Write(6,Fmt1)'----------------------------------------------'
       Write(6,Fmt1)' No.    Label       X         Y         Z     '
       Write(6,Fmt1)'----------------------------------------------'
         Do 10 iAt=1,nAtoms
            Write(6,Fmt2//'I3,5X,A6,2X,3F10.5)')
     &      iAt,AtLbl(iAt),Coor(1,iAt),Coor(2,iAt),Coor(3,iAt)
10       Continue
       Write(6,Fmt1)'----------------------------------------------'
       Write(6,Fmt2//'A,F20.10)')'Nuclear repulsion energy =',PotNuc
      End If
*----------------------------------------------------------------------*
*     Print orbital and wavefunction specifications                    *
*----------------------------------------------------------------------*
      If (iMethod.eq.iCASSCF) Then
         ntIsh=0
         ntAsh=0
         ntSsh=0
         ntBas=0
         Do 20 iSym=1,nSym
            ntIsh=ntIsh+nIsh(iSym)
            ntAsh=ntAsh+nAsh(iSym)
            ntBas=ntBas+nBas(iSym)
            ntSsh=ntSsh+nBas(iSym)
     &           -nFro(iSym)-nDel(iSym)-nIsh(iSym)-nAsh(iSym)
20       Continue
         If (iPL.ge.2) Then
            Write(6,*)
            Line=''
            Write(Line(left-2:),'(A)') 'Wave function specifications:'
            Call CollapseOutput(1,Line)
            Write(6,Fmt1)              '-----------------------------'
            Write(6,*)
            Write(6,Fmt2//'A,T47,I6)')
     &                  'Number of closed shell electrons',
     &                              2*ntIsh
            Write(6,Fmt2//'A,T47,I6)')
     &                  'Number of electrons in active shells',
     &                              nActEl
            Write(6,Fmt2//'A,T47,I6)')
     &               'Max number of holes in RAS1 space',
     &                           nHole1
            Write(6,Fmt2//'A,T47,I6)')
     &                  'Max number of electrons in RAS3 space',
     &                              nElec3
            Write(6,Fmt2//'A,T47,I6)')
     &                 'Number of inactive orbitals',
     &                              ntIsh
            Write(6,Fmt2//'A,T47,I6)')
     &                 'Number of active orbitals',
     &                              ntAsh
            Write(6,Fmt2//'A,T47,I6)')
     &                 'Number of secondary orbitals',
     &                              ntSsh
            Write(6,Fmt2//'A,T47,F6.1)')
     &                'Spin quantum number',
     &                              (dble(iSpin)-1.)/2.
            Write(6,Fmt2//'A,T47,I6)')
     &               'State symmetry',
     &                             State_Sym
            Write(6,Fmt2//'A,T47,I6)') 'Number of roots',nroots
            Write(6,Fmt2//'A,(T47,10I6))')
     &       'States considered ',(iroot(i),i=1,nroots)
            Write(6,Fmt2//'A,(T47,10F6.3))') 'Weights ',
     &           (weight(i),i=1,nroots)
            Write(6,*)
            Write(6,Fmt2//'A,T47,8I6)')
     &           'Symmetry species',
     &                            (i,i=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)')
     &           'Skiped sym. species',
     &            (nSkip(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)')
     &            'Frozen orbitals',
     &            (nFro(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)')
     &            'Inactive orbitals',
     &                               (nIsh(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)')
     &             'Active orbitals',
     &                               (nAsh(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)') 'RAS1 orbitals',
     &                              (nRs1(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)') 'RAS2 orbitals',
     &                              (nRs2(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)') 'RAS3 orbitals',
     &                              (nRs3(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)') 'Deleted orbitals',
     &                              (nDel(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)')
     &               'Number of basis functions',
     &                              (nBas(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I6)')
     &               'Number of Orbitals',
     &                              (nOrb(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T47,8I8)')
     &            'Number of configurations',
     &                             (ncsf(isym),isym=1,nsym)

            Write(6,Fmt2//'A,T47,8I6)')
     &            'Number of combinations',
     &                             (nint(xispsm(isym,1)),isym=1,nsym)
*
            If ( iPt2.eq.0 ) then
               Write(6,Fmt1)
     &              'Natural orbitals are used in the last CI'
            Else
               Write(6,Fmt1)
     &          'Pseudo canonical orbitals are used in the last CI'
            End If
*
            Write(6,Fmt2//'A,T33,F20.10)')
     &           'RASSCF state energy = ',ERASSCF(istate)
            Write(6,Fmt2//'A,T47,I6)')
     &          'Size of explicit Hamiltonian in PCG: ',nExp_Max
            Call CollapseOutput(0,'Wave function specifications:')
         End If
      Else
         If (iPL.ge.2) Then
            Write(6,*)
            Line=''
            Write(Line(left-2:),'(A)') 'Wave function specifications:'
            Call CollapseOutput(1,Line)
            Write(6,Fmt1)              '-----------------------------'
            Write(6,Fmt2//'A,T50,A)')
     &                'Wavefunction type:','SCF'
            Write(6,Fmt2//'A,T45,I6)')
     &                'Number of irreducible symmetry groups',
     &                         nSym
            Write(6,Fmt2//'A,T45,8I6)')
     &                'Number of basis functions',
     &                         (nBas(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T45,8I6)')
     &                'Number of occupied orbitals',
     &                         (nish(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T31,F20.10)')
     &             'SCF energy = ',ESCF
            Call CollapseOutput(0,'Wave function specifications:')
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iPL.ge.2) Then
*                                                                      *
************************************************************************
*                                                                      *
         Write(6,*)
         Write(6,Fmt2//'A,T42,ES11.4)')
     &      'Convergence threshold= ',Epsilon
         Write(6,Fmt2//'A,T45,I8)')
     &      'Max number of iterations in PCG: ',nIter
*
      If (SPINPOL) Then
         Write(6,Fmt1) 'CALCULATING SPIN POLARIZATION'
      Else If (PT2) Then
         Write(6,Fmt2//'A,A)') 'CALCULATING LAGRANGIAN MULTIPLIER',
     &                      ' FOR CASPT2'
      Else If (SA.or.iMCPD) Then
         If (isNAC) Then
            Write(6,Fmt2//'A,I3,"/",I3)')'Lagrangian multipliers '//
     &                            'are calculated for states no. ',
     &                            NACstates(1),NACstates(2)
            If ((NSSA(1).ne.NACstates(1)).or.
     &          (NSSA(2).ne.NACstates(2))) Then
               Write(6,Fmt2//'39X,A,I3,"/",I3,A)')'(SA roots no. ',
     &                               NSSA(1),NSSA(2),')'
            End If
         Else
            Write(6,Fmt2//'A,I3)')'Lagrangian multipliers are '//
     &                            'calculated for state no. ',irlxroot
            If (istate.ne.irlxroot) Then
               Write(6,Fmt2//'39X,A,I3,A)')'(SA root no. ',istate,')'
            End If
         End If
         If(TwoStep) Then
            If(StepType.eq.'RUN1') Write(6,Fmt1)
     &                      'TwoStep activated. Run 1 (preparation).'
            If(StepType.eq.'RUN2') Write(6,Fmt1)
     &                      'TwoStep activated. Run 2 (final run).'
         End If
      Else
         If (ndisp.ne.0) Then
            Write(6,*)
            Line=''
            Write(Line(left-2:),'(A)') 'Perturbation specifications:'
            Call CollapseOutput(1,Line)
            Write(6,Fmt1)              '----------------------------'
            Write(6,*)
            Write(6,Fmt2//'A,T47,8I4)')
     &             'Number of perturbations in each symmetry',
     &                           (ldisp(iSym),iSym=1,nSym)
            Write(6,Fmt2//'A,T50,A)') 'Type of perturbation:',
     &                            Perturbation
            Call CollapseOutput(0,'Perturbation specifications:')
            Write(6,*)
            Line=''
            Write(Line(left-2:),'(A)') 'Perturbations:'
            Call CollapseOutput(1,Line)
            Write(6,Fmt1)              '--------------'
            Write(6,*)
            Write(6,Fmt1)
     &             '-------------------------------------'
            Write(6,Fmt1)
     &          ' No.    Symmetry    Center Direction '
            Write(6,Fmt1)
     &             '-------------------------------------'
            jDisp=0
            Do iSym=1,nSym
               Do iDisp=1,lDisp(iSym)
                  jDisp=jDisp+1
                  If (iand(ntpert(jdisp),16).eq.16) Then
                     Write(6,Fmt2//'I3,T16,A3,T29,A)')
     &                  jDisp,chIrr(isym),ChDisp(dspvec(jDisp))
                  Else
                     Write(6,Fmt2//'I3,T16,A3,T29,A8,A,A)')
     &                  jDisp,chIrr(isym),swlbl(jDisp),' ',
     &                  XYZ(dspvec(jDisp))
                  End If
               End Do
            End Do
            Write(6,Fmt1) '-------------------------------------'
            Call CollapseOutput(0,'Perturbations:')
         End If
      End If
      Write(6,*)
*----------------------------------------------------------------------*
*     Print reference state information                                *
*----------------------------------------------------------------------*
      If (.Not. SA) Then
         Write(6,*)
         If (iMethod.eq.iCASSCF) Then
             Write(6,Fmt2//'A,I3)')
     &          'Linear response function is computed '//
     &                        'for root no. = ',irlxroot
         Else
            Write(6,Fmt2//'A,I3)')
     &         'Linear response function is computed '//
     &                       'for Restricted Hartree-Fock wavefunction'
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Write(6,*)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkT_CAlld (T2,X,Y,dimbe,no)
c
c        this routine do:
c       T2n(be',ga',u,v) <-
c           C1                + 1/2 X(be',u,ga',v)
c           C2                + 1/2 X(ga',v,be',u)
c           C3                - 1/2 Y(be',u,ga',v)
c           C4                - 1/2 Y(ga',v,be',u)
c           C5                - 1   Y(ga',u,be',v)
c           C6                - 1   Y(be',v,ga',u)
c        for beGrp=gaGrp
c
        implicit none
        integer dimbe,no
        real*8 T2(1:dimbe,1:dimbe,1:no,1:no)
        real*8 X(1:dimbe,1:no,1:dimbe,1:no)
        real*8 Y(1:dimbe,1:no,1:dimbe,1:no)
c
c        help variables
        integer u,v,be,ga
c
        do v=1,no
          do u=1,no
            do ga=1,dimbe
c              do be=1,dimbe  - povodne, stacia iba cleny be>=ga
              do be=ga,dimbe
        T2(be,ga,u,v)=(X(be,u,ga,v)-Y(be,u,ga,v))/2-Y(be,v,ga,u)
              end do
            end do
          end do
        end do
c
        do v=1,no
          do u=1,no
            do be=1,dimbe
c              do ga=1,dimbe  - povodne, stacia iba cleny be>=ga
              do ga=1,be
                 T2(be,ga,u,v)=T2(be,ga,u,v)
     c                       +(X(ga,v,be,u)-Y(ga,v,be,u))/2
     c                       -Y(ga,u,be,v)
              end do
            end do
          end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_PUTVEC2(CHOVEC,NUMVEC,IVEC1,ISYM)
C
C     Purpose: write Cholesky vectors IVEC=IVEC1,...,IVEC1+NUMVEC-1
C              of symmetry ISYM to file.
C
C     Version 2: handles several reduced set at a time.
C
      use ChoArr, only: nDimRS
      use ChoSwp, only: InfVec
#include "implicit.fh"
      DIMENSION CHOVEC(*)
#include "cholesky.fh"

      external ddot_

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_PUTVEC2')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

C     Return if no vectors.
C     ---------------------

      IF (NUMVEC .LT. 1) THEN
         IF (LOCDBG) THEN
            WRITE(LUPRI,*) SECNAM,': WARNING: no vectors in this call!'
            WRITE(LUPRI,*) SECNAM,': NUMVEC = ',NUMVEC
         END IF
         return
      END IF

C     Check symmetry.
C     ---------------

      IF ((ISYM.LT.1) .OR. (ISYM.GT.NSYM)) THEN
         WRITE(LUPRI,*) SECNAM,': symmetry out of bounds'
         WRITE(LUPRI,*) 'ISYM = ',ISYM
         CALL CHO_QUIT('Symmetry out of bounds in '//SECNAM,104)
      END IF

C     Check vector index.
C     -------------------

      IVEC2 = IVEC1 + NUMVEC - 1
      IF ((IVEC1.LT.1) .OR. (IVEC1.GT.MAXVEC) .OR.
     &    (IVEC2.LT.1) .OR. (IVEC2.GT.MAXVEC)) THEN
         WRITE(LUPRI,*) SECNAM,': vector index out of bounds'
         WRITE(LUPRI,*) 'IVEC1 = ',IVEC1,' IVEC2 = ',IVEC2
         WRITE(LUPRI,*) '...must be between 1 and ',MAXVEC
         CALL CHO_QUIT('Vector index out of bounds in '
     &                 //SECNAM,104)
      END IF

C     Check for overflow for WA file addressing.
C     ------------------------------------------

      IF (CHO_ADRVEC .EQ. 1) THEN
         IADR2 = INFVEC(IVEC2,4,ISYM)
         IF (INFVEC(IVEC1,4,ISYM) .LT. 0) THEN
            WRITE(LUPRI,*) 'Error in ',SECNAM,':'
            WRITE(LUPRI,*) 'Illegal disk address for first vector: ',
     &                     INFVEC(IVEC1,4,ISYM)
            IF (INFVEC(IVEC1,4,ISYM) .LT. -1) THEN
               WRITE(LUPRI,*) '....is it an overflow?'
            END IF
            WRITE(LUPRI,*) 'IVEC1 = ',IVEC1,' ISYM = ',ISYM
            CALL CHO_QUIT('Illegal disk address in '//SECNAM,104)
         ELSE IF (IADR2 .LT. INFVEC(IVEC1,4,ISYM)) THEN
            WRITE(LUPRI,*) 'Error in ',SECNAM,':'
            WRITE(LUPRI,*) 'Illegal disk address for last vector: ',
     &                     IADR2
            IF (IADR2 .LT. -1) THEN
               WRITE(LUPRI,*) '....is it an overflow?'
            END IF
            WRITE(LUPRI,*) 'IVEC2 = ',IVEC2,' ISYM = ',ISYM
            CALL CHO_QUIT('Illegal disk address in '//SECNAM,104)
         END IF
      END IF

C     Call the low-level I/O routines.
C     CHO_ADRVEC=1: WA files.
C     CHO_ADRVEC=2: DA files.
C     Set (next) disk addresses.
C     --------------------------------


      IF (CHO_ADRVEC .EQ. 1) THEN
         IOPT = 1  ! synchronous write option
         LTOT = 0
         DO IVEC = 1,NUMVEC
            JVEC = IVEC1 + IVEC - 1
            JRED = INFVEC(JVEC,2,ISYM)
            LTOT = LTOT + NDIMRS(ISYM,JRED)
         END DO
         IADR = INFVEC(IVEC1,3,ISYM)
         CALL DDAFILE(LUCHO(ISYM),IOPT,CHOVEC,LTOT,IADR)
         DO IVEC = 1,NUMVEC-1
            JVEC = IVEC1 + IVEC - 1
            JRED = INFVEC(JVEC,2,ISYM)
            INFVEC(JVEC+1,3,ISYM) =
     &      INFVEC(JVEC,3,ISYM) + NDIMRS(ISYM,JRED)
         END DO
         IVEC = NUMVEC
         JVEC = IVEC1 + IVEC - 1
         IF (JVEC .LT. MAXVEC) THEN
            JRED = INFVEC(JVEC,2,ISYM)
            INFVEC(JVEC+1,3,ISYM) =
     &      INFVEC(JVEC,3,ISYM) + NDIMRS(ISYM,JRED)
         END IF
      ELSE IF (CHO_ADRVEC .EQ. 2) THEN
         IOPT = 1  ! synchronous write option
         KOFF = 1
         DO IVEC = 1,NUMVEC-1
            JVEC = IVEC1 + IVEC - 1
            JRED = INFVEC(JVEC,2,ISYM)
            LTOT = NDIMRS(ISYM,JRED)
            IADR = INFVEC(JVEC,3,ISYM)
            CALL DDAFILE(LUCHO(ISYM),IOPT,CHOVEC(KOFF),LTOT,IADR)
            INFVEC(JVEC+1,3,ISYM) = IADR
            KOFF = KOFF + LTOT
         END DO
         IVEC = NUMVEC
         JVEC = IVEC1 + IVEC - 1
         JRED = INFVEC(JVEC,2,ISYM)
         LTOT = NDIMRS(ISYM,JRED)
         IADR = INFVEC(JVEC,3,ISYM)
         CALL DDAFILE(LUCHO(ISYM),IOPT,CHOVEC(KOFF),LTOT,IADR)
         IF (JVEC .LT. MAXVEC) THEN
            INFVEC(JVEC+1,3,ISYM) = IADR
         END IF
      ELSE
         CALL CHO_QUIT('CHO_ADRVEC out of bounds in '//SECNAM,102)
      END IF

C     Debug stuff.
C     ------------

      IF (LOCDBG) THEN
         WRITE(LUPRI,*)
         WRITE(LUPRI,*) SECNAM,':'
         WRITE(LUPRI,*) 'Vectors ',IVEC1,' to ',IVEC1+NUMVEC-1,
     &                  ' of symmetry ',ISYM,' written to unit ',
     &                  LUCHO(ISYM)
         KOFF = 1
         DO IVEC = 1,NUMVEC
            JVEC = IVEC1 + IVEC - 1
            JRED = INFVEC(JVEC,2,ISYM)
            LVEC = NDIMRS(ISYM,JRED)
            JADR = INFVEC(JVEC,3,ISYM)
            XNRM = SQRT(DDOT_(LVEC,CHOVEC(KOFF),1,CHOVEC(KOFF),1))
            WRITE(LUPRI,*) 'Vector:',JVEC,' address: ',JADR,' norm: ',
     &                     XNRM,' dimension: ',LVEC
            KOFF = KOFF + LVEC
         END DO
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine Contact(Zeta,P,nZeta,A,Axyz,la,RB,Bxyz,lb, Ccoor,
     &                   lOper,iChO,nIC,Array,nArr,Final,
     &                   iStabM,nStabM,nComp,rKappa)
************************************************************************
*                                                                      *
* Object: to compoute the 1-electron contact term.                     *
*                                                                      *
*     Author: Roland Lindh, Dept. Of Theoretical Chemistry,            *
*             University of Lund, Sweden, February '91                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nIC),
     &       rKappa(nZeta), Ccoor(3),
     &       Array(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2),
     &       Axyz(nZeta,3,0:la), Bxyz(nZeta,3,0:lb),
     &       Zeta(nZeta), P(nZeta,3), A(3), RB(3), TC(3)
      Integer iStabM(0:nStabM-1), iStabO(0:7), iDCRT(0:7), lOper(nComp),
     &       iChO(nComp)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 170
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In Contact: rKappa',' ',rKappa,nZeta,1)
         Call RecPrt(' In Contact: Zeta',' ',Zeta,nZeta,1)
         Call RecPrt(' In Contact: P',' ',P,nZeta,3)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      llOper = lOper(1)
      Do iComp = 2, nComp
         llOper = iOr(llOper,lOper(iComp))
      End Do
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
      Do lDCRT = 0, nDCRT-1
         Call OA(iDCRT(lDCRT),Ccoor,TC)
*
         call dcopy_(nZeta*nElem(la)*nElem(lb),[Zero],0,Array,1)
*
*--------Compute the value of the angular components associated
*        to the basis functions centered on the first center.
*
         call dcopy_(nZeta*3,[One],0,Axyz(1,1,0),1)
         If (la.eq.0) Go To 60
*
         Do iCar = 1, 3
*
            Do iZeta = 1, nZeta
               Axyz(iZeta,iCar,1) =TC(iCar) -A(iCar)
            End Do
*
            Do ia = 2, la
               Do iZeta = 1, nZeta
                  Axyz(iZeta,iCar,ia) = Axyz(iZeta,iCar,1) *
     &                                  Axyz(iZeta,iCar,ia-1)
               End Do
            End Do
*
         End Do
 60      Continue
*
*--------Compute the value of the angular components associated to
*        the basis functions centered on the second center.
*
         call dcopy_(nZeta*3,[One],0,Bxyz(1,1,0),1)
*
*--------Modify z-component to carry the the exponetial
*        contribution.
*
         Do iZeta = 1, nZeta
            Bxyz(iZeta,3,0) =
     &          Exp ( -Zeta(iZeta) * ( (TC(1)-P(iZeta,1))**2 +
     &                                 (TC(2)-P(iZeta,2))**2 +
     &                                 (TC(3)-P(iZeta,3))**2 ))
         End Do
         If (lb.eq.0) Go To 61
*
         Do iCar = 1, 3
*
            Do iZeta = 1, nZeta
               Bxyz(iZeta,iCar,1) =TC(iCar) -RB(iCar)
            End Do
*
            Do ib = 2, lb
               Do iZeta = 1, nZeta
                  Bxyz(iZeta,iCar,ib) = Bxyz(iZeta,iCar,1) *
     &                                  Bxyz(iZeta,iCar,ib-1)
               End Do
            End Do
         End Do
*
*--------Modify z-components with the exponential contribution
*
         Do ib = 1, lb
            Do iZeta = 1, nZeta
               Bxyz(iZeta,3,ib) = Bxyz(iZeta,3,ib) *
     &                            Bxyz(iZeta,3,0)
            End Do
         End Do
*
 61      Continue
*
*--------Combine contributions from the varoius angular
*        components.
*
         Do ixa = la, 0, -1
            Do ixb = lb, 0, -1
               Do iya = la-ixa, 0, -1
                  iza = la-ixa-iya
                  ipa = Ind(la,ixa,iza)
                  Do iyb = lb-ixb, 0, -1
                     izb = lb-ixb-iyb
                     ipb = Ind(lb,ixb,izb)
                     Do iZeta = 1, nZeta
                        Array(iZeta,ipa,ipb) =
     &                     Array(iZeta,ipa,ipb) +
     &                                rKappa(iZeta) *
     &                                Axyz(iZeta,1,ixa) *
     &                                Axyz(iZeta,2,iya) *
     &                                Axyz(iZeta,3,iza) *
     &                                Bxyz(iZeta,1,ixb) *
     &                                Bxyz(iZeta,2,iyb) *
     &                                Bxyz(iZeta,3,izb)
                     End Do
                  End Do
               End Do
            End Do
         End Do
*
*------- Accumulate contributions
*
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array,nZeta,la,lb,nComp,Final,nIC,
     &               nOp         ,lOper,iChO,One)
*
      End Do
*
*     Call GetMem(' Exit Contact ','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nArr)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine Rd2Int_SCF()
!***********************************************************************
!                                                                      *
!     purpose: Read basis set informations from two-electron file      *
!              and compare them with those read from 2-el. file        *
!                                                                      *
!***********************************************************************

use InfSCF, only: nBas, nSkip, nSym
use Molcas, only: MxSym
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iRC, iSym, nBasX(MxSym), nSymX
logical(kind=iwp) :: SqI2

iRc = -1
call GetOrd(iRc,SqI2,nSymX,nBasX,nSkip)
if (iRc /= 0) then
  write(u6,*) 'The program failed to read the header of ORDINT.'
  call Abend()
end if

if (nSymX /= nSym) then
  write(u6,*) 'nSymX /= nSym, nSymX, nSym=',nSymX,nSym
  call Abend()
end if
do iSym=1,nSym
  if (nBas(iSym) /= nBasX(iSym)) then
    write(u6,*) 'nBas(iSym) /= nBasX(iSym)'
    write(u6,*) 'nBas=',nBas
    write(u6,*) 'nBasX=',nBasX
    call Abend()
  end if
end do

end subroutine Rd2Int_SCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1994, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE MEMSTR()
      Use Str_Info
*
*
* Construct pointers for saving information about strings and
* their mappings
*
*========
* Input :
*========
* Number and types of strings defined by /STRINP/
* Symmetry information stored in         /CSM/
* String information stored in           /STINF/
*=========
* Output
*=========
* Pointers stored in common block /STRBAS/
*
* Jeppe Olsen , Winter of 1990
*
* Last Revision , Dec 24 1990 , Almaden
*
* Updated with iuniqtp, dec 11, 1994
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "detdim.fh"
#include "stdalloc.fh"
#include "orbinp_mclr.fh"
#include "csm.fh"
      LENGTH=100
*. Start of string information
*
* =====================================================================
*
* 1 : String information
*
* =====================================================================
*
*     Some calls are done with points which are out of bounds. To make
*     this to be strictly secure we add a dummy layer and point to that
*     in the case that we are out of bounds. The code seems, however,
*     not to touch these arrays.
*
      ITYP_Dummy=NSTTYP+1
      Allocate(Str(1:NSTTYP+1))

      DO ITYP = 1, NSTTYP
        IF (IUNIQTP(ITYP).EQ.ITYP) THEN
        NSTRIN = NUMST3(NELEC(ITYP),NORB1,MNRS1(ITYP),MXRS1(ITYP),
     &                  NORB2,NORB3,MNRS3(ITYP),MXRS3(ITYP) )
        LSTRIN = NSTRIN * NELEC(ITYP)
*.  Offsets for occupation of strings and reordering array
          Call mma_allocate(Str(ITYP)%OCSTR_Hidden,LSTRIN,Label='OCSTR')
          Str(ITYP)%OCSTR => Str(ITYP)%OCSTR_Hidden
          Call mma_allocate(Str(ITYP)%STREO_Hidden,NSTRIN,Label='STREO')
          Str(ITYP)%STREO => Str(ITYP)%STREO_Hidden

*. Symmetry and class of each string
          Call mma_allocate(Str(ITYP)%STSM_Hidden,NSTRIN,Label='STSM')
          Str(ITYP)%STSM  => Str(ITYP)%STSM_Hidden
          Call mma_allocate(Str(ITYP)%STCL_Hidden,NSTRIN,Label='STCL')
          Str(ITYP)%STCL  => Str(ITYP)%STCL_Hidden
        ELSE
          IITYP = - IUNIQTP(ITYP)
          Str(ITYP)%OCSTR => Str(IITYP)%OCSTR_Hidden
          Str(ITYP)%STREO => Str(IITYP)%STREO_Hidden
          Str(ITYP)%STSM  => Str(IITYP)%STSM_Hidden
          Str(ITYP)%STCL  => Str(IITYP)%STCL_Hidden
        END IF
      END DO

*. Number of strings per symmetry and occupation
      DO ITYP = 1, NSTTYP
        IF (IUNIQTP(ITYP).EQ.ITYP) THEN
           Call mma_allocate(Str(ITYP)%NSTSO_Hidden,NOCTYP(ITYP)*NSMST,
     &                       Label='NSTSO')
           Str(ITYP)%NSTSO => Str(ITYP)%NSTSO_Hidden
*. Offset of strings per symmetry and occupation
           Call mma_allocate(Str(ITYP)%ISTSO_Hidden,NOCTYP(ITYP)*NSMST,
     &                       Label='ISTSO')
           Str(ITYP)%ISTSO => Str(ITYP)%ISTSO_Hidden
*. Number of electrons in RAS1 and RAS3 per sub type, is sub-type active
           Call mma_allocate(Str(ITYP)%EL1_Hidden,NOCTYP(ITYP),
     &                       Label='EL1')
           Str(ITYP)%EL1  => Str(ITYP)%EL1_Hidden
           Call mma_allocate(Str(ITYP)%EL3_Hidden,NOCTYP(ITYP),
     &                       Label='EL3')
           Str(ITYP)%EL3  => Str(ITYP)%EL3_Hidden
           Call mma_allocate(Str(ITYP)%ACTP_Hidden,NOCTYP(ITYP),
     &                       Label='ACTP')
           Str(ITYP)%ACTP => Str(ITYP)%ACTP_Hidden
CMS: New array introduced according to Jeppes new strinfo representation
           Call mma_allocate(Str(ITYP)%EL123_Hidden,3*NOCTYP(ITYP),
     &                       Label='EL123')
           Str(ITYP)%EL123=> Str(ITYP)%EL123_Hidden
**. Lexical adressing of arrays: NB! Not allocated here in Jeppes new version!
           Call mma_allocate(Str(ITYP)%Z_Hidden,NACOB*NELEC(ITYP),
     &                       Label='Z')
           Str(ITYP)%Z=> Str(ITYP)%Z_Hidden
        ELSE
*. redirect
          IITYP = - IUNIQTP(ITYP)
          Str(ITYP)%NSTSO => Str(IITYP)%NSTSO_Hidden
          Str(ITYP)%ISTSO => Str(IITYP)%ISTSO_Hidden
          Str(ITYP)%EL1   => Str(IITYP)%EL1_Hidden
          Str(ITYP)%EL3   => Str(IITYP)%EL3_Hidden
          Str(ITYP)%ACTP  => Str(IITYP)%ACTP_Hidden
          Str(ITYP)%EL123 => Str(IITYP)%EL123_Hidden
          Str(ITYP)%Z     => Str(IITYP)%Z_Hidden
        END IF
      END DO

CMS: Introduced according to Jeppes new concept.
CMS: NB! Str(ITYP)%EL123 added to IEL13 parameter list!
CMS: Be aware that IEL13 is also called in STRINF
      DO  ITYP = 1, NSTTYP
        IF(IUNIQTP(ITYP).EQ.ITYP) THEN
        CALL IEL13(MNRS1(ITYP),MXRS1(ITYP),MNRS3(ITYP),MXRS3(ITYP),
     &             NELEC(ITYP),NOCTYP(ITYP),Str(ITYP)%EL1,
     &             Str(ITYP)%EL3,Str(ITYP)%EL123,
     &             Str(ITYP)%ACTP)
        END IF
      END DO

*. Mappings between different string types
      DO ITYP = 1, NSTTYP
c        write(6,*) nelec(ityp),nstrin
         NSTRIN = NSTFTP(ITYP)

         IF (ISTAC(ITYP,2).NE.0.AND.ISTAC(ITYP,1).NE.0) THEN
*.creation on string allowed , use full orbital notation
            LENGTH = NACOB*NSTRIN
            Call mma_allocate(Str(ITYP)%STSTMI,1,Label='STSTMI')
            Call mma_allocate(Str(ITYP)%STSTMN,1,Label='STSTMN')
         ELSE IF(ISTAC(ITYP,1).NE.0.AND.ISTAC(ITYP,2).EQ.0) THEN

*. only annihilation allowed, use compact scheme
            LENGTH = NELEC(ITYP)*NSTRIN
            Call mma_allocate(Str(ITYP)%STSTMI,1,Label='STSTMI')
            Call mma_allocate(Str(ITYP)%STSTMN,1,Label='STSTMN')
CMS: New else block
          ELSE IF (ISTAC(ITYP,1).EQ.0.AND.ISTAC(ITYP,2).NE.0) THEN
*. Only creation allowed, use compact scheme with offsets
*
             CALL NUMST4_MCLR(NELEC(ITYP),NORB1,MNRS1(ITYP),MXRS1(ITYP),
     &                     NORB2,NORB3,MNRS3(ITYP),MXRS3(ITYP),
     &                     Str(ITYP)%NSTSO)
            LENGTH = NCASTR_MCLR(2,Str(ITYP)%NSTSO,NOCTYP(ITYP),
     &                      ITYP,NOBPT,3,Str(ITYP)%EL123)
*. Explicit offsets and lengths
            Call mma_allocate(Str(ITYP)%STSTMI,NSTRIN,Label='STSTMI')
            Call mma_allocate(Str(ITYP)%STSTMN,NSTRIN,Label='STSTMN')
          END IF

*. has this map been constructed before ?
          IIIITEST = 0
          IF(IUNIQTP(ITYP).EQ.ITYP.OR.IIIITEST.EQ.1) THEN
            IMNEW = 1
            IUNIQMP(ITYP) = ITYP
          ELSE
*. check type of previous map
            DO JJTYP = 1, ITYP-1
            IITYP = -IUNIQTP(ITYP)
            IF(ABS(IUNIQTP(JJTYP)).EQ.IITYP.AND.
     &          IUNIQMP(JJTYP).EQ.JJTYP) THEN
            IF((ISTAC(ITYP,1).EQ.0.AND.ISTAC(JJTYP,1).EQ.0).OR.
     &         (ISTAC(ITYP,1).NE.0.AND.ISTAC(JJTYP,1).NE.0.AND.
     &          ABS(IUNIQTP(ISTAC(ITYP,1))).EQ.
     &          ABS(IUNIQTP(ISTAC(JJTYP,1)))) ) THEN
                IANEQ = 1
            ELSE
                IANEQ = 0
            END IF
            IF((ISTAC(ITYP,2).EQ.0.AND.ISTAC(JJTYP,2).EQ.0).OR.
     &         (ISTAC(ITYP,2).NE.0.AND.ISTAC(JJTYP,2).NE.0.AND.
     &          ABS(IUNIQTP(ISTAC(ITYP,2))).EQ.
     &          ABS(IUNIQTP(ISTAC(JJTYP,2)))) ) THEN
                ICREQ = 1
            ELSE
                ICREQ = 0
            END IF
            IF(IANEQ.EQ.1.AND.ICREQ.EQ.1) THEN
              IMNEW = 0
              IUNIQMP(ITYP) = -JJTYP
              GOTO 1211
            END IF
*
            END IF
            END DO
*. Normal exit from DO loop only if no identical map was found
            IMNEW = 1
            IUNIQMP(ITYP) = ITYP
 1211       CONTINUE
          END IF

          IF(IMNEW.EQ.1) THEN
            Call mma_allocate(Str(ITYP)%STSTM_Hidden,LENGTH,2,
     &                        Label='STSTM')
            Str(ITYP)%STSTM => Str(ITYP)%STSTM_Hidden
          ELSE
            IITYP = -IUNIQMP(ITYP)
            Str(ITYP)%STSTM => Str(IITYP)%STSTM_Hidden
          END IF

      END DO

*. Symmetry of conjugated orbitals and orbital excitations
*     COBSM,NIFSJ,IFSJ,IFSJO
!     Call mma_allocate(COBSM,NACOB,Label='COBSM')
!     Call mma_allocate(NIFSJ,NACOB*NSMSX,Label='NIFSJ')
!     Call mma_allocate(IFSJ,NACOB**2,Label='IFSJ')
!     Call mma_allocate(IFSJO,NACOB*NSMSX,Label='IFSJO')
*. Symmetry of excitation connecting  strings of given symmetry
!     Call mma_allocate(STSTX,NSMST*NSMST,Label='STSTX')
*
**. Up and down mappings of strings containing the same number of electrons
*
      DO ITYP = 1, NSTTYP
         IF(INUMAP(ITYP).NE.0)
     &     Call mma_allocate(Str(ITYP)%NUMAP,NSTFTP(ITYP),Label='NUMAP')
         IF(INDMAP(ITYP).NE.0)
     &     Call mma_allocate(Str(ITYP)%NDMAP,NSTFTP(ITYP),Label='NDMAP')
      END DO
*
*     Some dummy allocations
*
      ITYP=ITYP_Dummy
      Call mma_allocate(Str(ITYP)%NSTSO_Hidden,1,Label='NSTSO')
      Str(ITYP)%NSTSO => Str(ITYP)%NSTSO_Hidden
      Call mma_allocate(Str(ITYP)%EL1_Hidden,1,Label='EL1')
      Str(ITYP)%EL1  => Str(ITYP)%EL1_Hidden
      Call mma_allocate(Str(ITYP)%EL3_Hidden,1,Label='EL3')
      Str(ITYP)%EL3  => Str(ITYP)%EL3_Hidden

*. Last word of string information
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine xquit(rc)
CSVC: routine that terminates Molcas properly
      implicit none
      integer rc, lb, ub
#include "warnings.fh"
      character(len=128) :: msg
      logical, external :: bomb_on_error
#ifdef _MOLCAS_MPP_
      logical, external :: King
#endif

      call xflush(6)

CSVC: write rc to stderr if not 0 (all is well)
      if (rc .ne. _RC_ALL_IS_WELL_) then
CIFG: do not write message if rc is "out of bounds"
C     (this avoids it, e.g., when a slave process quits with -2,
C     also avoids writing garbage from rc_msg)
        lb = lbound(rc_msg,dim=1)
        ub = ubound(rc_msg,dim=1)
        if (rc .ge. lb .and. rc .le. ub) then
          write(msg,'(a,i6,2a)') 'xquit (rc = ', rc, '): ', rc_msg(rc)
          call write_stderr(msg)
        end if
      end if

CSVC: write return code to file
      call write_rc(rc)

CSVC: critical errors result in backtrace + immediate abort, while
C     regular errors only do this if MOLCAS_BOMB has been set too.
      if (        (rc .ge. _RC_GROUP_CRITICAL_)
#if _MOLCAS_MPP_
CIFG: in a parallel (real or fake) run, we have to be more strict
C     with errors, or a deadlock may occur when some slave process
C     quits (e.g., a glitch or bug causes a missing file). Of course,
C     it could be argued that the error raised for those cases should
C     be critical... but it's often an "INPUT ERROR"
     &        .or.(rc .ge. _RC_GROUP_USER_ERROR_ .and. (.not.King()))
#endif
     &        .or.(rc .ge. _RC_GROUP_ERROR_ .and. bomb_on_error())) then
        call xabort(rc)
      end if

CSVC: terminate GA/MPI gracefully
      call GATerminate

CSVC: eventual exit normally. We should not exit with rc here because
C     some MPI implementations (like MPICH) will treat a non-zero return
C     code similar to an abort.
      stop
      end

      function bomb_on_error() result(rc)
      implicit none
      logical :: rc
      character(len=16) :: bomb, env
      bomb=' '
      env='MOLCAS_BOMB'
      call getenvf(env,bomb)
      if (bomb(1:1).eq.'Y'.or.bomb(1:1).eq.'y'.or.bomb(1:1).eq.'1') then
        rc = .true.
      else
        rc = .false.
      end if
      end
c-----------------------------------------------------------------------
c     convenient wrapper routines for xquit
c-----------------------------------------------------------------------
      subroutine quit(rc)
      implicit none
      integer rc
      call xquit(rc)
      End
      Subroutine Quit_OnUserError
      implicit none
#include "warnings.fh"
      Call xQuit(_RC_INPUT_ERROR_)
      End
      Subroutine Quit_OnConvError
      implicit none
#include "warnings.fh"
      Call xQuit(_RC_NOT_CONVERGED_)
      End
      Subroutine Quit_OnInstError
      implicit none
#include "warnings.fh"
      Call xQuit(_RC_INSTALL_ERROR_)
      End
      Subroutine Quit_OnTimeOut
      implicit none
#include "warnings.fh"
      Call xQuit(_RC_TIMEOUT_)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Francesco Aquilante                              *
************************************************************************
*  GEN_INT
*
*> @brief
*>   Generates integrals from Cholesky vectors
*> @author F. Aquilante, May 2004
*> @modified_by F. Aquilante, Sep. 2004
*>
*> @note
*> The transposition ``L(ab,J)`` &rarr; ``L(ba,J)`` of the vectors
*> ``(syma.ne.symb)`` is necessary because the calling routine
*> requires the integrals in the order \f$ (sr|qp) \f$ which
*> is reversed compared to the order of the symmetries
*> given as input arguments.
*>
*> @param[out] rc
*> @param[in]  iSymp
*> @param[in]  iSymq
*> @param[in]  iSymr
*> @param[in]  iSyms
*> @param[in]  ipq1
*> @param[in]  numpq
*> @param[out] Xint
************************************************************************
      SUBROUTINE GEN_INT(rc,iSymp,iSymq,iSymr,iSyms,ipq1,numpq,Xint)
************************************************************************
*
*   Modified  September 2004
*   Reason:
*   the transposition L(ab,J) --> L(ba,J) of the vectors
*   (syma.ne.symb) is necessary because the calling routine
*   requires the integrals in the order (sr|qp) which
*   is reversed compared to the order of the symmetries
*   given as input arguments
*
************************************************************************

      Implicit Real*8 (a-h,o-z)
      INTEGER   rc
      INTEGER   iSymp,iSymq,iSymr,iSyms
      INTEGER   pq,pq2,numpq,pq1_save
      Real*8    Xint(*)

#include "RdOrd.fh"

#include "WrkSpc.fh"
#include "TwoRc.fh"

C *************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
C *************************************

      jSym = MulD2h(iSymp,iSymq)

      If (NumCho(jSym) .lt. 1) Return

C --- save the value of pq1 because it belongs to a Common block
      pq1_save = pq1
      pq1      = ipq1

      pq2 = pq1 + numpq - 1
      If (iSymp .eq. iSymq) Then
         Npq = nBas(iSymp)*(nBas(iSymp) + 1)/2
      Else
         Npq = nBas(iSymp)*nBas(iSymq)
      End If

      If (iSymr .eq. iSyms) Then
         Nrs = nBas(iSymr)*(nBas(iSymr) + 1)/2
      Else
         Nrs = nBas(iSymr)*nBas(iSyms)
      End If

C --- Set up the batch procedure
C ------------------------------
      Call GetMem('Maxmem','MAX ','REAL',KDUM,LWORK)

C------- Memory management ----------------------------
      if (iSymp.ne.iSymr) then
              mNeed = 2*Max(Npq,Nrs) + Nrs
      else
              mNeed = 2*Npq
      endif
C------------------------------------------------------
      If (mNeed .gt. 0) Then
         nVec = Min(LWORK/mNeed,NumCho(jSym))
      Else
C         ***QUIT*** bad initialization
         WRITE(6,*) 'Gen_Int: bad initialization'
         rc=99
         CALL Abend()
         nVec = -9999  ! dummy assignment - avoid compiler warnings
      End If
      If (nVec .gt. 0) Then
         nBatch = (NumCho(jSym) - 1)/nVec + 1
      Else
C         ***QUIT*** insufficient memory
         WRITE(6,*) 'Gen_Int: Insufficient memory for batch'
         WRITE(6,*) 'LWORK= ',LWORK
         WRITE(6,*) 'mNeed= ',mNeed
         WRITE(6,*) 'NumCho= ',NumCho(jsym)
         WRITE(6,*) 'jsym= ',jsym
         rc = rcRD05
         CALL Abend()
         nBatch = -9999  ! dummy assignment
      End If

C  --- Start the batch procedure for reading the vectors and computing
C  the integrals ---

c      Call FZero(Xint,numpq*Nrs)
      Do i=1,numpq*Nrs
         Xint(i) = ZERO
      End Do

      DO iBatch = 1,nBatch

         If (iBatch .eq. nBatch) Then
            NumV = NumCho(jSym) - nVec*(nBatch - 1)
         Else
            NumV = nVec
         End If

         iVec1 = nVec*(iBatch - 1) + 1

         if (iSymp.ne.iSymr) then

            LenMem1 = Max(Npq,Nrs)*NumV
            LenMem2 = Max(Npq,Nrs)*NumV
            LenMem3 = Nrs*NumV
C --- Allocate memory for reading the vectors and do the transposition
            Call GetMem('MemC1','ALLO','REAL',kVec1,LenMem1)
            Call GetMem('MemC2','ALLO','REAL',kVec2,LenMem2)
            Call GetMem('MemC3','ALLO','REAL',kVec3,LenMem3)

         else

            LenMem1 = Npq*NumV  ! equal to LenMem2
C --- Allocate memory for reading the vectors and do the transposition
            Call GetMem('MemC1','ALLO','REAL',kVec1,LenMem1)
            Call GetMem('MemC2','ALLO','REAL',kVec2,LenMem1)

         endif

C !--- Copying out (and transpose) the elements of the 1st vector ---!
C ---------------- L(pq,J) ---> L(qp,J)  -----------------------------
C --------------------------------------------------------------------
         if (iSymp.ne.iSymq) then  ! transposition needed
            Call RdChoVec(Work(kVec1),Npq,NumV,iVec1,LuCVec(1))
            koff1=0
            koff2=0
            do jvec=1,NumV
             do jq=1,nBas(iSymq)
               do jp=1,nBas(iSymp)

                  koff1 = kVec1 + Npq*(jvec-1) + nBas(iSymp)*(jq-1)
     &                          + (jp-1)
                  koff2 = kVec2 + Npq*(jvec-1) + nBas(iSymq)*(jp-1)
     &                          + (jq-1)
                  work(koff2) = work(koff1)

               end do
             end do
            end do
         else  ! no need to transpose "diagonal" vectors
            Call RdChoVec(Work(kVec2),Npq,NumV,iVec1,LuCVec(1))
         endif
         kWqp=kVec2
C --------------------------------------------------------------------

      IF (numpq.eq.Npq) THEN

       If (iSymp.ne.iSymr) THEN !need to read the 2nd vector also
C --------------------------------------------------------------------
         if (iSymr.ne.iSyms) then
            Call RdChoVec(Work(kVec1),Nrs,NumV,iVec1,LuCVec(2))
            koff1=0
            koff2=0
            do jvec=1,NumV
             do js=1,nBas(iSyms)
               do jr=1,nBas(iSymr)

                  koff1 = kVec1 + Nrs*(jvec-1) + nBas(iSymr)*(js-1)
     &                          + (jr-1)
                  koff2 = kVec3 + Nrs*(jvec-1) + nBas(iSyms)*(jr-1)
     &                          + (js-1)
                  work(koff2) = work(koff1)

               end do
             end do
            end do
         else
            Call RdChoVec(Work(kVec3),Nrs,NumV,iVec1,LuCVec(2))
         endif
         kWsr = kVec3
C --------------------------------------------------------------------

C --- Computing the integrals (II|JJ)
C -----------------------------------
C --- (sr|{qp}) <- (sr|{qp}) + sum_I L(sr,#I)* L({qp},#I)
C==========================================================
         CALL DGEMM_('N','T',Nrs,numpq,NumV,
     &              ONE,Work(kWsr),Nrs,
     &              WORK(kWqp),numpq,ONE,Xint,Nrs)


       ELSE ! isymp = isymr   (Npq=Nrs)

C --- Computing integrals of the type (II|II) and (IJ|IJ)

         CALL DGEMM_('N','T',Nrs,numpq,NumV,
     &              ONE,Work(kWqp),Nrs,
     &              WORK(kWqp),numpq,ONE,Xint,Nrs)


       END If


      ELSE  ! numpq.ne.Npq

C !--- Copying out the elements of the 1st vector ---!
C ----------------------------------------------------
            Do J = 1,NumV
               Do jpq = 1,numpq
                  pq = pq1 + jpq - 1
C --- Address of the matrix element (pq,J) in the full matrix
                  kOff1 = kVec2 + Npq*(J - 1) + (pq - 1)
C --- Address of the matrix element (pq,J) in the sub-block matrix
                  kOff2 = kVec1 + numpq*(J - 1) + (jpq - 1)
C --- Copy out the elements of the sub-block matrix if not the full
C --- matrix
                  Work(kOff2) = Work(kOff1)
               End Do
            End Do
            kXqp = kVec1
            kWsr = kVec2

       If (iSymp.ne.iSymr) Then
C --------------------------------------------------------------------
         if (iSymr.ne.iSyms) then  !   L(rs,J) ---> L(sr,J)
            Call RdChoVec(Work(kVec2),Nrs,NumV,iVec1,LuCVec(2))
            koff1=0
            koff2=0
            do jvec=1,NumV
             do js=1,nBas(iSyms)
               do jr=1,nBas(iSymr)

                  koff1 = kVec2 + Nrs*(jvec-1) + nBas(iSymr)*(js-1)
     &                          + (jr-1)
                  koff2 = kVec3 + Nrs*(jvec-1) + nBas(iSyms)*(jr-1)
     &                          + (js-1)
                  work(koff2) = work(koff1)

               end do
             end do
            end do
         else
            Call RdChoVec(Work(kVec3),Nrs,NumV,iVec1,LuCVec(2))
         endif
         kWsr = kVec3
C --------------------------------------------------------------------
       Endif

C --- Computing the integrals
C -----------------------------------
C --- (sr|{qp}) <- (sr|{qp}) + sum_I L(sr,#I)* L({qp},#I)
C==========================================================
         CALL DGEMM_('N','T',Nrs,numpq,NumV,
     &              ONE,Work(kWsr),Nrs,
     &              WORK(kXqp),numpq,ONE,Xint,Nrs)


      ENDIF


C --- Free the memory
       if (iSymp.ne.iSymr) then
          Call GetMem('MemC3','FREE','REAL',kVec3,LenMem3)
          Call GetMem('MemC2','FREE','REAL',kVec2,LenMem2)
          Call GetMem('MemC1','FREE','REAL',kVec1,LenMem1)
       else
          Call GetMem('MemC2','FREE','REAL',kVec2,LenMem1)
          Call GetMem('MemC1','FREE','REAL',kVec1,LenMem1)
       endif

      END DO  ! end of the batch procedure

      rc  = rc0000
      pq1 = pq1_save

      Return
      END

**************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine fout_cvb(f,a1,a2)

use Definitions, only: wp, u6

implicit none
real(kind=wp), intent(in) :: f
character(len=*), intent(in) :: a1, a2
character(len=46) :: b2
character(len=15) :: b1
character(len=12) :: b3
real(kind=wp), parameter :: hge = 1.0e20_wp

b1 = a1
b2 = a2
if (abs(f) /= hge) then
  write(b3,'(es12.4)') f
else
  b3 = '    Disabled'
end if
write(u6,'(1x,3a)') b1,b2,b3

return

end subroutine fout_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1996, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine SetUp_RW(DoRys,nDiff)
!***********************************************************************
!                                                                      *
! Object: to setup tables for auxiliary functions to be used direct    *
!         in the recurrence relations of integral form or indirectly   *
!         to compute the Rys roots and weights which are used in the   *
!         recurrence relations of integrand form. For the lower order  *
!         Rys polynomials the roots and weight are computed from expa- *
!         nsion coefficients.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!                                                                      *
!             Unified version August '96, RL.                          *
!***********************************************************************

use External_Centers, only: nOrdEF, XF
use Sizes_of_Seward, only: S
use Gateway_Info, only: GIAO
use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: DoRys
integer(kind=iwp), intent(in) :: nDiff
integer(kind=iwp) :: iAng2, mRys

! Compute max sum of angular momentum index

iAng2 = 4*S%iAngMx

! Set up roots and weights for Hermite polynomials.

call SetHer(nDiff)

! Set up coefficients for Rys polynomials.

! 1) for two-electron integrals
! 2) for external field and nuclear attraction

mRys = (iAng2+2+nDiff)/2
if (allocated(XF) .or. (nOrdEF == 1) .or. GIAO) mRys = max(mRys,(2*S%iAngMx+1+2+nDiff)/2)
if (nOrdEF == 2) mRys = max(mRys,(2*S%iAngMx+2+2+nDiff)/2)
if (DoRys) call SetUpR(mRys)

return

end subroutine SetUp_RW

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RPA_Setup_Add_Info()
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Data for RPA tests, checking the setup.
C     Testing these data is as much a test of the preceding SCF run as
C     a test of the RPA setup.
C
      Implicit None
#include "rpa_config.fh"
#include "rpa_data.fh"
#include "WrkSpc.fh"

      Character*18 SecNam
      Parameter (SecNam='RPA_Setup_Add_Info')

      Integer  RPA_iUHF, Cho_X_GetTol
      External RPA_iUHF, Cho_X_GetTol
      Real*8   Cho_dSumElm, dDot_
      External Cho_dSumElm, dDot_

      Character*13 orbitals

      Integer Tol
      Integer iUHF
      Integer l_orbitals
      Integer iSpin
      Integer iSym
      Integer ipO, ipV
      Integer i

      Real*8 Tst(8)

      ! Check that molecular geometry is the expected one:
      ! nuclear repulsion energy
      Tol=12
      Call Add_Info('PotNuc',NuclearRepulsionEnergy,1,Tol)

      ! Check orbital spaces: sums and norms of orbital energies.
      Tol=min(Cho_X_GetTol(2),2)
      iUHF=RPA_iUHF()
      If (iUHF.eq.1) Then
         orbitals=' orbital'
         l_orbitals=8
      Else If (iUHF.eq.2) Then
         orbitals=' spin-orbital'
         l_orbitals=13
      Else
         Write(6,'(A,I6)') 'iUHF=',iUHF
         Call RPA_Warn(3,SecNam//': iUHF error')
         orbitals=' '
         l_orbitals=1
      End If
      Call fZero(Tst,8)
      Do iSpin=1,iUHF
         ipO=ip_OccEn(iUHF)
         ipV=ip_VirEn(iUHF)
         Do iSym=1,nSym
            Tst(1)=Tst(1)+Cho_dSumElm(Work(ipO),nFro(iSym,iSpin))
            Tst(2)=Tst(2)+dDot_(nFro(iSym,iSpin),Work(ipO),1,
     *                                          Work(ipO),1)
            ipO=ipO+nFro(iSym,iSpin)
            Tst(3)=Tst(3)+Cho_dSumElm(Work(ipO),nOcc(iSym,iSpin))
            Tst(4)=Tst(4)+dDot_(nOcc(iSym,iSpin),Work(ipO),1,
     *                                          Work(ipO),1)
            ipO=ipO+nOcc(iSym,iSpin)
            Tst(5)=Tst(5)+Cho_dSumElm(Work(ipV),nVir(iSym,iSpin))
            Tst(6)=Tst(6)+dDot_(nVir(iSym,iSpin),Work(ipV),1,
     *                                          Work(ipV),1)
            ipV=ipV+nVir(iSym,iSpin)
            Tst(7)=Tst(7)+Cho_dSumElm(Work(ipV),nDel(iSym,iSpin))
            Tst(8)=Tst(8)+dDot_(nDel(iSym,iSpin),Work(ipV),1,
     *                                          Work(ipV),1)
            ipV=ipV+nDel(iSym,iSpin)
         End Do
      End Do
      Do i=2,8,2
         Tst(i)=sqrt(Tst(i))
      End Do
      Call Add_Info(Reference//orbitals(1:l_orbitals)//' energy',Tst,8,
     *              Tol)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MAX_OPEN_ORB(MAXOP,IOCLS,NGAS,NOCLS,NOBPT)
! Max number of open orbitals in occupation classes
!
! Jeppe Olsen, November 2001

use csfbas, only: maxop_lucia
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(out) :: MAXOP
integer(kind=iwp), intent(in) :: NGAS, NOCLS, IOCLS(NGAS,NOCLS), NOBPT(NGAS)
integer(kind=iwp) :: IGAS, JOCLS, MAXOP_IGAS, MAXOP_J, NEL, NORB

MAXOP = 0
!write(u6,*) ' NOCLS, NGAS = ',NOCLS,NGAS
do JOCLS=1,NOCLS
  MAXOP_J = 0
  do IGAS=1,NGAS
    NEL = IOCLS(IGAS,JOCLS)
    NORB = NOBPT(IGAS)
    !write(u6,*) ' IGAS, NEL, NORB = ',IGAS,NEL,NORB
    MAXOP_IGAS = min(NEL,2*NORB-NEL)
    MAXOP_J = MAXOP_J+MAXOP_IGAS
  end do
  MAXOP = max(MAXOP,MAXOP_J)
end do
maxop_lucia = maxop

#ifdef _DEBUGPRINT_
write(u6,*) ' Max number of unpaired orbitals = ',MAXOP
#endif

end subroutine MAX_OPEN_ORB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine WRVEC_DYSON(filename,LUNIT,NSYM,NBAS,ORBNUM,CMO,AMPS,DYSEN,TITLE,NZ)
! Sort Dyson orbitals according to symmetry so that they can be
! written with WrVec

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: filename, TITLE
integer(kind=iwp), intent(in) :: LUNIT, NSYM, NBAS(NSYM), ORBNUM, NZ
real(kind=wp), intent(in) :: CMO(NZ,ORBNUM), AMPS(ORBNUM), DYSEN(ORBNUM)
integer(kind=iwp) :: DUMMY(7,8), I, J, NB(0:NSYM), NBAS_(NSYM), NBT, NORB(NSYM), NSYM_, OFF, ORBSYM(ORBNUM)
real(kind=wp) :: RSUM
logical(kind=iwp) :: DODESYM
real(kind=wp), allocatable :: DESYM(:,:), REORD(:)

! First count how many orbitals in each symmetry
NB(0) = 1
do I=1,NSYM
  NB(I) = NB(I-1)+NBAS(I)
end do
DODESYM = .false.
NORB(:) = 0
ORBSYM(:) = 0
outer: do I=1,ORBNUM
  do J=1,NSYM
    RSUM = sum(abs(CMO(NB(J-1):NB(J)-1,I)))
    if (RSUM > Zero) then
      ! If there is any orbital with mixture of symmetries,
      ! we have to desymmetrize the whole thing
      if (ORBSYM(I) /= 0) then
        DODESYM = .true.
        exit outer
      end if
      ORBSYM(I) = J
      NORB(J) = NORB(J)+1
    end if
  end do
end do outer
if (DODESYM) then
  NSYM_ = 1
  NBAS_(1) = sum(NBAS(1:NSYM))
  NB(1) = NBAS_(1)
  NORB(1) = ORBNUM
  ORBSYM(:) = 1
else
  NSYM_ = NSYM
  NBAS_(:) = NBAS(:)
end if
NBT = sum(NORB(1:NSYM)*NBAS_(1:NSYM))
call mma_allocate(REORD,NBT,Label='REORD')
if (DODESYM) then
  ! Here do a plain desymmetrization
  NBT = NBAS_(1)
  call mma_allocate(DESYM,NBT,NBT,Label='DESYM')
  call get_dArray('SM',DESYM,NBT**2)
  call DGEMM_('N','N',NBT,NORB(1),NBT,One,DESYM,NBT,CMO,NBT,Zero,REORD,NBT)
  call mma_deallocate(DESYM)
else
  ! Here distribute the coefficients
  OFF = 0
  do I=1,NSYM_
    do J=1,ORBNUM
      if (ORBSYM(J) /= I) cycle
      REORD(OFF+1:OFF+NBAS_(I)) = CMO(NB(I-1):NB(I)-1,J)
      OFF = OFF+NBAS_(I)
    end do
  end do
end if

! And call WrVec with the reordered data
call WRVEC(filename,LUNIT,'COE',NSYM_,NBAS_,NORB,REORD,AMPS,DYSEN,DUMMY,TITLE)

call mma_deallocate(REORD)

return

end subroutine WRVEC_DYSON

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine GetChVHlp2 (L2Status,NL2,used,kam)
c
c       this routine do:
c       Define, which one of unused L2 arrays allocated in memory
c       will be used for placing newly needed L2x
c       Criteria of present approach:
c       1) First those possitions that are allocated, but never used yet
c       2) if no 1), take first unused in this step, according L2Status
c          N.B. 2) druhy krok moze byt eventuelne vylepseny, zatial
c               takto odflaknute
c
c       description ov variables:
c       L2Status  - L2 Status array (I)
c       NL2       - number of L2 arrays reserver in memory (I)
c       used      - array indicating, which L2x are already used
c                   in this step (those cannot be touched) (I)
c       kam       - index of possition, where new L2 can be placed (O)
c
        implicit none
        integer L2Status(1:4,1:3)
        integer used(1:4)
        integer NL2,kam
c
c       help variables
        integer i
c
c
c1      search, if there are never used possitions
c
        do i=1,NL2
          if (L2Status(i,1).eq.0) then
          kam=i
          return
          end if
        end do
c
c2      find first unused in this step
c
        do i=1,NL2
          if (used(i).eq.0) then
          kam=i
          return
          end if
        end do
c
c       Jaj nieje dobre ak sme sa dostali az sem
        write (6,*) ' Sorry fish getChVHlp2 '
        call Abend()
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Dynamic_Properties(Temp,nAtoms,rMP,nij,nPert,nElem,Delta,EC,Polar,iANr,Bond_Threshold,ChPol,ChPolBB)

use Constants, only: Zero, One, Two, Three, Eight, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nij, nPert, nElem, iANr(nAtoms)
real(kind=wp), intent(out) :: Temp(nij), Polar(6,nij), ChPol(6,nij), ChPolBB(6,nij)
real(kind=wp), intent(in) :: rMP(nij,0:nElem-1,0:nPert-1), Delta, EC(3,nij), Bond_Threshold
integer(kind=iwp) :: iAtom, iCar, ii, ij, iPert, iPert_, iPol, jAtom, jCar, jj, jPert, jPert_
real(kind=wp) :: A(3), B(3), Pol1, Pol1a, Pol1b, Pol2, Rij_iCar

!                                                                      *
!***********************************************************************
!                                                                      *
!call RecPrt('rMP',' ',rMP,nij*nElem,nPert)
write(u6,*)
write(u6,*) ' D y n a m i c  P r o p e r t i e s'
write(u6,*)
write(u6,*) ' Properties computed with FFPT'
write(u6,*)

do iPol=1,6
  do iAtom=1,nAtoms
    do jAtom=1,iAtom
      ij = iAtom*(iAtom-1)/2+jAtom
      ChPol(iPol,ij) = Zero
      ChPolBB(iPol,ij) = Zero
    end do
  end do
end do

! iPol: index vector for polarizability
!       (1,2,3,4,5,6)=(xx,yx,yy,zx,zy,zz)

do iPol=1,6
  Temp(:) = Zero
  !write (u6,*)
  do iAtom=1,nAtoms
    ii = iAtom*(iAtom+1)/2
    call dcopy_(3,EC(1,ii),1,A,1)
    do jAtom=1,iAtom
      jj = jAtom*(jAtom+1)/2
      call dcopy_(3,EC(1,jj),1,B,1)

      ij = iAtom*(iAtom-1)/2+jAtom
      !                                                                *
      !*****************************************************************
      !                                                                *
      !        Polarizabilities: alpha(iAtom,jAtom,iCar,jCar)          *
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! iCar, jCar: index of cartesian for each perturbation
      !           1=x, 2=y, 3=z
      iCar = int((One+sqrt(Eight*real(iPol,kind=wp)-Three))/Two)
      jCar = iPol-iCar*(iCar-1)/2

      ! iPert, jPert: index vector to actuall perturbation
      !       (1,2,3,4,5,6)=(+dx,-dx,+dy,-dy,+dz,-dz)
      iPert = (jCar-1)*2+1
      jPert = iPert+1
      !
      ! Contribution due to change of localized dipole moment
      !
      !------- mu(iAtom,jAtom,iCar,+dF(jCar))
      !------- mu(iAtom,jAtom,iCar,-dF(jCar))
      !
      Pol1a = (rMP(ij,iCar,iPert)-rMP(ij,iCar,jPert))/(Two*Delta)
      !
      iPert_ = (iCar-1)*2+1
      jPert_ = iPert_+1
      Pol1b = (rMP(ij,jCar,iPert_)-rMP(ij,jCar,jPert_))/(Two*Delta)
      Pol1 = Half*(Pol1a+Pol1b)
      !write(u6,*) 'Pol1',ij,iCar,iPert,jPert
      !write(u6,*) rMP(ij,iCar,iPert),rMP(ij,iCar,jPert)
      !
      ! Contribution due to change of localized charges
      !
      if (iAtom /= jAtom) then
        Rij_iCar = B(iCar)-A(iCar)
        !write(u6,*) rMP(ij,0,iPert),rMP(ij,0,jPert)
        Pol2 = (rMP(ij,0,iPert)-rMP(ij,0,jPert))*Rij_iCar/(Two*Delta)
      else
        Pol2 = Zero
      end if

      !write(u6,*) Pol1, Pol2

      Temp(ij) = Temp(ij)+Pol1+Pol2
      Polar(iPol,ij) = Temp(ij)
      !                                                                *
      !*****************************************************************
      !        Compute Charge contrib                                  *
      !*****************************************************************
      !                                                                *
      ChPol(iPol,ij) = ChPol(iPol,ij)+Pol2
      ChPolBB(iPol,ij) = ChPolBB(iPol,ij)+Pol2
      !                                                                *
      !*****************************************************************
      !                                                                *
    end do   ! jAtom
  end do     ! iAtom
!                                                                      *
!***********************************************************************
!                                                                      *
end do   ! iPol
!                                                                      *
!***********************************************************************
!                                                                      *
!            Move the polarizabilities to the atoms if needed          *
!                                                                      *
!***********************************************************************
!                                                                      *
call Move_Polar(Polar,EC,nAtoms,nij,iANr,Bond_Threshold)
call Move_Polar(ChPol,EC,nAtoms,nij,iANr,Bond_Threshold)

return

end subroutine Dynamic_Properties

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SONATORBM_INT(DENS, CHARPROP, IC_,CHARTYPE,ASS,BSS,
     &                         iOpt,ROTMAT,
     &                         PROPVALXR,PROPVALYR,PROPVALZR,
     &                         PROPVALXI,PROPVALYI,PROPVALZI)
      use OneDat, only: sOpSiz
      use stdalloc, only: mma_allocate, mma_deallocate
      use rassi_data, only: NBTRI

      IMPLICIT None
      Real*8 DENS(6,NBTRI)
      CHARACTER(LEN=8) CHARPROP
      INTEGER IC_
      CHARACTER(LEN=8) CHARTYPE
      INTEGER ASS, BSS, iOpt
      Real*8 ROTMAT(3,3),
     &       PROPVALXR,PROPVALYR,PROPVALZR,
     &       PROPVALXI,PROPVALYI,PROPVALZI

      Integer IDUM(1)
      Real*8, allocatable:: IP(:), IPX(:), IPY(:), IPZ(:)
      Integer ITYPE, NIP, IC_End, IC_Str, IC, JOPT, ICMP, IRC, I, ISCHK

C NOW DO INTEGRATION WITH AO MATRICES
C FOR THE EXPECTATION VALUE

C Get the proper type of the property
      ITYPE=0
      IF(CHARTYPE.EQ.'HERMSING') ITYPE=1
      IF(CHARTYPE.EQ.'ANTISING') ITYPE=2
      IF(CHARTYPE.EQ.'HERMTRIP') ITYPE=3
      IF(CHARTYPE.EQ.'ANTITRIP') ITYPE=4
      IF(ITYPE.EQ.0) THEN
        WRITE(6,*)'RASSI/SONATORB internal error.'
        WRITE(6,*)'Erroneous property type:',CHARTYPE
        CALL ABEND()
      END IF

C ALLOCATE A BUFFER FOR READING ONE-ELECTRON INTEGRALS
c The extra 4 elements correspond to the nuclear contribution
c and the origin of the operator
      NIP=4+NBTRI
      CALL mma_allocate(IP,NIP,Label='IP')
      If (iOpt.eq.1) Then
         CALL mma_allocate(IPX,NIP,Label='IPX')
         CALL mma_allocate(IPY,NIP,Label='IPY')
         CALL mma_allocate(IPZ,NIP,Label='IPZ')
         IPX(:)=0.0D0
         IPY(:)=0.0D0
         IPZ(:)=0.0D0
      End If

      If (iOpt.eq.1) Then
         IC_End=3
         IC_Str=1
      Else
         IC_End=IC_
         IC_Str=IC_
      End If
      DO IC=IC_Str,IC_End ! loop over reading X,Y, and Z AO Integrals

C Get info from the stored integrals
c JOPT controls what is read.
c JOPT=1 Read the size information
c JOPT=0 Read the property
c JOPT=6 Read the property, skipping the nuclear contribution and the origin
c (see OneDat module)
      JOPT=ibset(0,sOpSiz)
      ICMP=IC
      CALL iRDONE(IRC,JOPT,CHARPROP,ICMP,IDUM,ISCHK)

c Actually read the integral
      JOPT=0
      CALL RDONE(IRC,JOPT,CHARPROP,ICMP,IP,ISCHK)

      IF ( IRC.NE.0 ) THEN
        WRITE(6,*)
        WRITE(6,'(6X,A)')'*** ERROR IN SUBROUTINE SONATORB ***'
        WRITE(6,'(6X,A)')'  FAILED IN READING FROM  ONEINT'
        WRITE(6,'(6X,A,A)')'  LABEL     = ',CHARPROP
        WRITE(6,'(6X,A,I2)')'  COMPONENT = ',IC
        WRITE(6,*)
        CALL ABEND()
      END IF

      If (iOpt.eq.1) Then
c        note reordering
             CALL DAXPY_(NIP,ROTMAT(IC,1),IP,1,IPX,1)
             CALL DAXPY_(NIP,ROTMAT(IC,2),IP,1,IPY,1)
             CALL DAXPY_(NIP,ROTMAT(IC,3),IP,1,IPZ,1)
      End If

      END DO ! end loop over reading X,Y, and Z AO Integrals

      PROPVALXR=0.0d0
      PROPVALYR=0.0d0
      PROPVALZR=0.0d0
      PROPVALXI=0.0d0
      PROPVALYI=0.0d0
      PROPVALZI=0.0d0

C The integral is NBTRI matrix
C The property is NBTRI matrix
c We only work with half the matrix. Therefore, this would
c have a factor of 2. However, the factor of 1/2 was missing
c in SONATORB.F from the symmetric/antisymmetric equations
      IF(ITYPE.EQ.1.OR.ITYPE.EQ.3) THEN
        If (iOpt.eq.1) Then
        DO I=1,NBTRI
          PROPVALXR=PROPVALXR+IPX(I)*DENS(1,I)
          PROPVALYR=PROPVALYR+IPY(I)*DENS(2,I)
          PROPVALZR=PROPVALZR+IPZ(I)*DENS(3,I)

          PROPVALXI=PROPVALXI+IPX(I)*DENS(4,I)
          PROPVALYI=PROPVALYI+IPY(I)*DENS(5,I)
          PROPVALZI=PROPVALZI+IPZ(I)*DENS(6,I)
        END DO
        Else
        DO I=1,NBTRI
          PROPVALXR=PROPVALXR+IP(I)*DENS(1,I)
          PROPVALYR=PROPVALYR+IP(I)*DENS(2,I)
          PROPVALZR=PROPVALZR+IP(I)*DENS(3,I)

          PROPVALXI=PROPVALXI+IP(I)*DENS(4,I)
          PROPVALYI=PROPVALYI+IP(I)*DENS(5,I)
          PROPVALZI=PROPVALZI+IP(I)*DENS(6,I)
        END DO
        End If
      ELSE
        If (iOpt.eq.1) Then
        DO I=1,NBTRI
          PROPVALXI=PROPVALXI+IPX(I)*DENS(1,I)
          PROPVALYI=PROPVALYI+IPY(I)*DENS(2,I)
          PROPVALZI=PROPVALZI+IPZ(I)*DENS(3,I)

          PROPVALXR=PROPVALXR-IPX(I)*DENS(4,I)
          PROPVALYR=PROPVALYR-IPY(I)*DENS(5,I)
          PROPVALZR=PROPVALZR-IPZ(I)*DENS(6,I)
        END DO
        Else
        DO I=1,NBTRI
          PROPVALXI=PROPVALXI+IP(I)*DENS(1,I)
          PROPVALYI=PROPVALYI+IP(I)*DENS(2,I)
          PROPVALZI=PROPVALZI+IP(I)*DENS(3,I)

          PROPVALXR=PROPVALXR-IP(I)*DENS(4,I)
          PROPVALYR=PROPVALYR-IP(I)*DENS(5,I)
          PROPVALZR=PROPVALZR-IP(I)*DENS(6,I)
        END DO
        End If
      END IF

      WRITE(6,*)
      WRITE(6,*) "************************************"
      WRITE(6,*) "SONATORB EXPECTATION VALUES"
      WRITE(6,*) " PROPERTY: ", CHARPROP
      WRITE(6,*) " TYPE: ", CHARTYPE
      WRITE(6,*) " STATE (K,L): ",ASS,BSS
      WRITE(6,*) "************************************"
      WRITE(6,*) "Property: Re(X): ",PROPVALXR
      WRITE(6,*) "Property: Re(Y): ",PROPVALYR
      WRITE(6,*) "Property: Re(Z): ",PROPVALZR
      WRITE(6,*) "Property: Im(X): ",PROPVALXI
      WRITE(6,*) "Property: Im(Y): ",PROPVALYI
      WRITE(6,*) "Property: Im(Z): ",PROPVALZI
      WRITE(6,*) "************************************"

c Free up un-needed space
      call mma_deallocate(IP)
      If (iOpt.eq.1) Then
         call mma_deallocate(IPX)
         call mma_deallocate(IPY)
         call mma_deallocate(IPZ)
      End If

      END SUBROUTINE SONATORBM_INT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine PRWF_CP2(ISYCI,NCO,CI,THR)

use sguga, only: CIS
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ISYCI, NCO
real(kind=wp), intent(in) :: CI(NCO), THR

write(u6,'(A)') repeat('-',80)
write(u6,'(a,es9.2)') ' CI COEFFICIENTS LARGER THAN ',THR
call PRWF1_CP2(CIS%NOCSF,CIS%IOCSF,CIS%NOW,CIS%IOW,ISYCI,CI,nCO,THR,CIS%nMidV)

end subroutine PRWF_CP2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Francesco Aquilante                              *
!***********************************************************************

subroutine Cho_SOSmp2_Col(Col,nDim,iCol,nCol,Buf,l_Buf)
! Francesco Aquilante, May 2007.
!
! Purpose: compute specified M(ai,bj)=(ai|bj)^2 columns.

use ChoMP2, only: OldVec
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDim, nCol, iCol(nCol), l_Buf
real(kind=wp), intent(inout) :: Col(nDim,nCol)
real(kind=wp), intent(out) :: Buf(l_Buf)
integer(kind=iwp) :: ia, iAdr, iBat, iOpt, irc, iSym, iVec1, jCol, lScr, lTot, lWrk, lWsav, nBat, NumV, nVec
real(kind=wp) :: Fac
logical(kind=iwp) :: DoClose
real(kind=wp), allocatable :: Wrk(:)
character(len=*), parameter :: SecNam = 'Cho_SOSmp2_Col'
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"

if ((nCol < 1) .or. (nDim < 1)) return

iSym = NowSym
if (nDim /= nT1am(iSym)) then
  write(u6,*) SecNam,': inconsistent dimension. Expected: ',nT1am(iSym),'   Received: ',nDim
  write(u6,*) SecNam,': symmetry from chomp2_dec.fh: ',iSym
  call ChoMP2_Quit(SecNam,'inconsistent dimension',' ')
end if

if (NumCho(iSym) < 1) then
  Col(:,:) = Zero
  return
end if

irc = 0

if (InCore(iSym)) then  ! old vectors available in core

  Fac = Zero
  call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,OldVec,NumCho(iSym),Buf,l_Buf,Fac,irc)
  if (irc /= 0) then
    write(u6,*) SecNam,': ChoMP2_Col_Comp returned ',irc
    call ChoMP2_Quit(SecNam,'ChoMP2_Col_Comp error','[1]')
  end if

else ! old vectors must be read on disk

  DoClose = .false.
  if (lUnit_F(iSym,1) < 1) then
    call ChoMP2_OpenF(1,1,iSym)
    DoClose = .true.
  end if

  call mma_maxDBLE(lWrk)

  if (l_Buf > lWrk) then ! use Buf as work space

    nVec = min(l_Buf/(nDim+1),NumCho(iSym))
    if (nVec < 1) then
      write(u6,*) SecNam,': insufficient memory for batch!'
      call ChoMP2_Quit(SecNam,'insufficient memory','[1]')
      nBat = 0
    else
      nBat = (NumCho(iSym)-1)/nVec+1
    end if

    do iBat=1,nBat

      if (iBat == nBat) then
        NumV = NumCho(iSym)-nVec*(nBat-1)
      else
        NumV = nVec
      end if
      iVec1 = nVec*(iBat-1)+1

      iOpt = 2
      lTot = nDim*NumV
      iAdr = nDim*(iVec1-1)+1
      call ddaFile(lUnit_F(iSym,1),iOpt,Buf,lTot,iAdr)

      if (iBat == 1) then
        Fac = Zero
      else
        Fac = One
      end if

      lScr = l_Buf-lTot
      if (lWrk > lScr) then
        lWsav = lWrk
        call mma_allocate(Wrk,lWrk,label='ColScr')
        call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,Buf,NumV,Wrk,lWrk,Fac,irc)
        call mma_deallocate(Wrk)
        lWrk = lWsav
      else
        call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,Buf,NumV,Buf(1+lTot),lScr,Fac,irc)
      end if
      if (irc /= 0) then
        write(u6,*) SecNam,': ChoMP2_Col_Comp returned ',irc
        call ChoMP2_Quit(SecNam,'ChoMP2_Col_Comp error','[2]')
      end if

    end do

  else ! use temp as work space

    call mma_allocate(Wrk,lWrk,label='ColWrk')

    nVec = min(lWrk/nDim,NumCho(iSym))
    if (nVec < 1) then
      write(u6,*) SecNam,': insufficient memory for batch!'
      call ChoMP2_Quit(SecNam,'insufficient memory','[2]')
      nBat = 0
    else
      nBat = (NumCho(iSym)-1)/nVec+1
    end if

    do iBat=1,nBat

      if (iBat == nBat) then
        NumV = NumCho(iSym)-nVec*(nBat-1)
      else
        NumV = nVec
      end if
      iVec1 = nVec*(iBat-1)+1

      iOpt = 2
      lTot = nDim*NumV
      iAdr = nDim*(iVec1-1)+1
      call ddaFile(lUnit_F(iSym,1),iOpt,Wrk,lTot,iAdr)

      if (iBat == 1) then
        Fac = Zero
      else
        Fac = One
      end if

      lScr = lWrk-lTot
      if (l_Buf > lScr) then
        call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,Wrk,NumV,Buf,l_Buf,Fac,irc)
      else
        call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,Wrk(1:lTot),NumV,Wrk(lTot+1:lWrk),lScr,Fac,irc)
      end if
      if (irc /= 0) then
        write(u6,*) SecNam,': ChoMP2_Col_Comp returned ',irc
        call ChoMP2_Quit(SecNam,'ChoMP2_Col_Comp error','[3]')
      end if

    end do

    call mma_deallocate(Wrk)

  end if

  if (DoClose) then
    call ChoMP2_OpenF(2,1,iSym)
    DoClose = .false.
  end if

end if

! Squaring each element of the integral columns
! ---------------------------------------------
do jCol=1,nCol
  do ia=1,nDim
    Col(ia,jCol) = Col(ia,jCol)**2
  end do
end do

end subroutine Cho_SOSmp2_Col

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,2020,  Roland Lindh                               *
*               1990, IBM                                              *
*               1993, Per Boussard                                     *
************************************************************************
************************************************************************
*                                                                      *
*    Objective: To read ECP information, excluding the valence basis-  *
*               set. This means that we read (from input stream) the   *
*               effective charge, the model potential terms (M1 and    *
*               M2), projection parameters and projection orbital      *
*               basis-set (exponents and coefficients)                 *
*                                                                      *
* Called from: Input                                                   *
*                                                                      *
* Calling    : RecPrt, Rdbsl                                           *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*                                                                      *
*     Modified: Per Boussard -93.                                      *
************************************************************************
#define _ACTUAL_
#include "getecp_interface.fh"
*     Local variables
      Character(LEN=180) Line, Get_Ln
*     External Get_Ln
      Integer mPP(2)
      Real*8, Dimension(:), Allocatable :: Scrt1, Scrt2
*                                                                      *
************************************************************************
*                                                                      *
      Interface
         Subroutine Read_v(lunit,Work,istrt,iend,inc,ierr)
         Integer lUnit, iStrt, Inc, iErr
         Real*8 Work(iend)
         End Subroutine Read_v
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
*---- Process Pseudo Potentials
*
      Line=Get_Ln(lUnit)
*
      If (Index(Line,'PP').ne.0) Then
*
         dbsc(nCnttp)%iPP=iShll+1
*
C        Write (6,*) 'Line=',Line
         If (Index(Line,'PPSO').ne.0) Then
           Call Get_i(4,mPP,2)
         Else
           Call Get_i(4,mPP,1)
           mPP(2)=0
         Endif
C        Write (6,*) 'mPP=',mPP
         dbsc(nCnttp)%nPP = 1 + mPP(1) + mPP(2)
*
         Do iPP = 0, mPP(1)
            iShll = iShll + 1
C           Write (6,*) 'iPP,dbsc(nCnttp)%nPP=',iPP,dbsc(nCnttp)%nPP
            If (iShll.gt.MxShll) Then
               Call WarningMessage(2,
     &                     'Abend in GetECP: Increase MxShll')
               Call Abend()
            End If
*
*---------- Pick up the number of terms in the shell
            Line=Get_Ln(lUnit)
C           Write (6,*) 'Line=',Line
            Call Get_i1(1,kcr)
C           Write (6,*) 'kcr,iShll=',kcr,iShll
            Shells(iShll)%nExp = 3*kcr
            Call mma_allocate(Shells(iShll)%Exp,3*kcr,Label='Exp')
*
            iStrt=1
            Do jcr = 1, kcr
               Line=Get_Ln(lUnit)
*
               Call Get_I1(1,ncr)
C              Write (6,*) 'ncr=',ncr
               Shells(iShll)%Exp(iStrt)=DBLE(ncr)
               iStrt=iStrt+1
               Call Get_F1(2,zcr)
C              Write (6,*) 'zcr=',zcr
               Shells(iShll)%Exp(iStrt)=zcr
               iStrt=iStrt+1
               Call Get_F1(3,ccr)
C              Write (6,*) 'ccr=',ccr
               Shells(iShll)%Exp(iStrt)=ccr
               iStrt=iStrt+1
            End Do
*
         End Do
         Do iPP = 1, mPP(2)
            iShll = iShll + 1
C           Write (6,*) 'iPP,dbsc(nCnttp)%nPP=',iPP,dbsc(nCnttp)%nPP
            If (iShll.gt.MxShll) Then
               Call ErrTra
               Write (6,*) 'Abend in GetECP: Increase MxShll'
               Call Abend
            End If
*
*---------- Pick up the number of terms in the shell
            Line=Get_Ln(lUnit)
C           Write (6,*) 'Line=',Line
            Call Get_i1(1,kcr)
C           Write (6,*) 'kcr,iShll=',kcr,iShll
            Shells(iShll)%nExp=3*kcr
            Call mma_allocate(Shells(iShll)%Exp,3*kcr,Label='Exp')
*
            iStrt=1
            Do jcr = 1, kcr
               Line=Get_Ln(lUnit)
*
               Call Get_I1(1,ncr)
C              Write (6,*) 'ncr=',ncr
               ncr=ncr+1000
               Shells(iShll)%Exp(iStrt)=DBLE(ncr)
               iStrt=iStrt+1
               Call Get_F1(2,zcr)
C              Write (6,*) 'zcr=',zcr
               Shells(iShll)%Exp(iStrt)=zcr
               iStrt=iStrt+1
               Call Get_F1(3,ccr)
C              Write (6,*) 'ccr=',ccr
               Shells(iShll)%Exp(iStrt)=ccr
               iStrt=iStrt+1
            End Do
*
         End Do
C        Write (6,*) 'Done'
*
         Return
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     M1 section                                                       *
*                                                                      *
*     Write (6,*) ' Reading M1'
      If (Index(Line,'M1').eq.0) Then
         Call WarningMessage(2,
     &              'ERROR: Keyword M1 expected, offending line : '
     &            //Line)
         Call Quit_OnUserError()
      Endif
      Line=Get_Ln(lUnit)
      Call Get_i1(1,nM1)
      dbsc(nCnttp)%nM1=nM1
      If (nM1.gt.0) Then
         Call mma_allocate(dbsc(nCnttp)%M1xp,nM1,Label='dbsc:M1xp')
         Call mma_allocate(dbsc(nCnttp)%M1cf,nM1,Label='dbsc:M1cf')
         Call Read_v(lUnit,dbsc(nCnttp)%M1xp(1),1,nM1,1,ierr)
         Call Read_v(lUnit,dbsc(nCnttp)%M1cf(1),1,nM1,1,ierr)
       End If
*                                                                      *
************************************************************************
*                                                                      *
*     M2 section                                                       *
*                                                                      *
*     Write (*,*) ' Reading M2'
      Line=Get_Ln(lUnit)
      If (Index(Line,'M2').eq.0) Then
         Call WarningMessage(2,
     &              'ERROR: Keyword M2 expected, offending line : '
     &            //Line)
         Call Quit_OnUserError()
      Endif
      Line=Get_Ln(lUnit)
      Call Get_i1(1,nM2)
      dbsc(nCnttp)%nM2=nM2
      If (nM2.gt.0) Then
         Call mma_allocate(dbsc(nCnttp)%M2xp,nM2,Label='dbsc:M2xp')
         Call mma_allocate(dbsc(nCnttp)%M2cf,nM2,Label='dbsc:M2cf')
         Call Read_v(lUnit,dbsc(nCnttp)%M2xp,1,nM2,1,ierr)
         Call Read_v(lUnit,dbsc(nCnttp)%M2cf,1,nM2,1,ierr)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Read core-repulsion parameter
*
*     Write (6,*) ' Reading Core-repulsion'
      Line=Get_Ln(lUnit)
      If (Index(Line,'COREREP').eq.0) Then
         Call WarningMessage(2,
     &              'ERROR: Keyword COREREP expected, offending line : '
     &            //Line)
         Call Quit_OnUserError()
      Endif
      Line=Get_Ln(lUnit)
      Call Get_F1(1,dbsc(nCnttp)%CrRep)
*                                                                      *
************************************************************************
*                                                                      *
*     Now read Projection parameters
*
*     Write (6,*) ' Reading projection operator'
      Line=Get_Ln(lUnit)
      If (Index(Line,'PROJOP').eq.0) Then
         Call WarningMessage(2,
     &              'ERROR: Keyword PROJOP expected, offending line : '
     &            //Line)
         Call Quit_OnUserError()
      Endif
*
*     Now read projection basis set
*     Loop over each shell type (s,p,d,etc....)
*     The ECP is assumed to contain s,p,d and f functions,
*     Read(Line,*,Err=993) nProj
      Line = Get_Ln(lUnit)
      Call Get_I1(1,nProj)
*
      If (nProj.lt.0) Return
      Do 10 iAng = 0, nProj
*        Write (6,*) ' iAng=',iAng
         n_Elec=2*(2*iAng+1)
         iShll = iShll + 1
         If (iShll.gt.MxShll) Then
            Call WarningMessage(2,
     &                  'Abend in GetECP: Increase MxShll')
            Call Quit_OnUserError()
         End If
*        Read (Line,*,Err=993) nPrim, nCntrc
         Line = Get_Ln(lUnit)
         Call Get_I1(1,nPrim)
         Call Get_i1(2,nCntrc)
*
         Shells(iShll)%nExp=nPrim
         Shells(iShll)%nBasis = nCntrc
*
*------- Check if occupation number is included on the line
*
         iSS=1
         Call NxtWrd(Line,iSS,iEE)
         iSS=iEE+1
         Call NxtWrd(Line,iSS,iEE)
         iSS=iEE+1
         Call NxtWrd(Line,iSS,iEE)
         Call mma_allocate(Shells(iShll)%Occ,nCntrc,Label='Occ')
         If (iEE.gt.0) Then
            Do i = 1, nCntrc
               Call Get_i1(2+i,n_Occ)
               Shells(iShll)%Occ(i)=DBLE(n_Occ)/DBLE(n_Elec)
*              Write (*,*) 'n_Occ=',n_Occ
            End Do
         Else
            Shells(iShll)%Occ(:)=One
         End If
*
*        Read "orbital energies"
*
*        Write (6,*) ' Reading Bk'
         Call mma_allocate(Shells(iShll)%Bk,nCntrc,Label='Bk')
         Shells(iShll)%nBk=nCntrc
         If (nCntrc.gt.0) Call Read_v(lUnit,Shells(iShll)%Bk,
     &                                1,nCntrc,1,ierr)
         If (ierr.ne.0) goto 992
*
*        Read gaussian EXPonents
*
*        Write (6,*) ' Reading Exponents'
         Call mma_allocate(Shells(iShll)%Exp,nPrim,Label='Exp')
         Shells(iShll)%nExp=nPrim
         If (nPrim.gt.0) Call Read_v(lUnit,Shells(iShll)%Exp,1,nPrim,1,
     &                               ierr)
         If (ierr.ne.0) goto 992
*        Call RecPrt(' Exponents',Shells(iShll)%nExp,nPrim,1)
         Call mma_allocate(Shells(iShll)%Cff_c,nPrim,nCntrc,2,
     &                     Label='Cff_c')
         Call mma_allocate(Shells(iShll)%pCff,nPrim,nCntrc,
     &                     Label='pCff')
         Call mma_allocate(Shells(iShll)%Cff_p,nPrim,nPrim,2,
     &                     Label='Cff_p')
         Shells(iShll)%Cff_p(:,:,:)=Zero  ! dummy assign
         Shells(iShll)%nBasis=nCntrc
*
*        Read contraction coefficients
*        Observe that the matrix will have nPrim rows and
*        nCntrc columns
*
*        Write (6,*) ' Reading coefficients'
         Do iPrim = 1, nPrim
            Call Read_v(lUnit,Shells(iShll)%Cff_c(1,1,1),
     &                  iPrim,nPrim*nCntrc,nPrim,ierr)
            If(ierr.ne.0) goto 991
         End Do
*
*--------Renormalize
*
         call mma_allocate(Scrt1,nPrim**2)
         call mma_allocate(Scrt2,nPrim*nCntrc)
         Call Nrmlx(Shells(iShll)%Exp,nPrim,
     &              Shells(iShll)%Cff_c(1,1,1),nCntrc,
     &                      Scrt1,nPrim**2,
     &                      Scrt2, nPrim*nCntrc,iAng)
         call mma_deallocate(Scrt1)
         call mma_deallocate(Scrt2)
*
*        Duplicate!
*
         Shells(iShll)%Cff_c(:,:,2)=Shells(iShll)%Cff_c(:,:,1)
*
         If (.Not.UnNorm) Then
            nExpi=Shells(iShll)%nExp
            If (nExpi*Shells(iShll)%nBasis.ge.1) Then
               Call Nrmlz(Shells(iShll)%Exp,nExpi,
     &                    Shells(iShll)%Cff_c(1,1,1),
     &                    Shells(iShll)%nBasis,iAng)
            End If
         End If
         Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
*
 10   Continue
*
      Return
*                                                                      *
************************************************************************
*                                                                      *
 992  Continue
         Call WarningMessage(2,
     &      'Abend in GetBS: Error while reading the exponents')
         Call Quit_OnUserError()
 991  Continue
         Call WarningMessage(2,
     &      'Abend in GetBS: Error while reading the coefficients')
         Call Quit_OnUserError()
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine XT_dMoverdH( exch, nLoc, nCenter, nneq, neqv, neq,
     &                         nss, nexch, nTempMagn, nT, NM, iopt,
     &                         mem,
     &                         Tmin, Tmax, chit_exp, eso, w, T, RROT,
     &                         zJ, Xfield, EM, THRS, XT_no_field,
     &                         dipso, s_so, dipexch, s_exch,
     &                         tinput, smagn, m_paranoid, m_accurate,
     &                         doplot )
c this Subroutine computes the XT as M/H as it is observed for most of experiments.
c The M is averaged over the grid for each temperature point.
c       chi*t ----------- the units are cgsemu: [ cm^3*k/mol ]

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
#include "mgrid.fh"
#include "stdalloc.fh"
      Integer, intent(in)          :: exch, nLoc, nCenter, nneq, neqv
      Integer, intent(in)          :: nTempMagn, nT, NM, iopt, mem
      Integer, intent(in)          :: neq(nneq), nss(nneq), nexch(nneq)


      Real(kind=8), intent(in)    :: Tmin, Tmax
      Real(kind=8), intent(in)    :: eso(nneq,nLoc)
      Real(kind=8), intent(in)    :: W(exch)
      Real(kind=8), intent(in)    :: zJ
      Real(kind=8), intent(in)    :: RROT(nneq,neqv,3,3)
      Real(kind=8), intent(in)    :: T(nT+nTempMagn)
      Real(kind=8), intent(in)    :: chit_exp(nT)
      Real(kind=8), intent(in)    :: XT_no_field(nT+nTempMagn)
      Real(kind=8), intent(in)    :: Xfield
      Real(kind=8), intent(in)    :: EM
      Real(kind=8), intent(in)    :: THRS
      Complex(kind=8), intent(in) :: dipso(nneq,3,nLoc,nLoc)
      Complex(kind=8), intent(in) ::  s_so(nneq,3,nLoc,nLoc)
      Complex(kind=8), intent(in) :: dipexch(3,exch,exch)
      Complex(kind=8), intent(in) ::  s_exch(3,exch,exch)
      Logical, intent(in)          :: tinput, smagn, m_paranoid, doplot
cccc local variables ccc
      Integer                      :: nDirX
      Integer       :: iM,iT,jT,i,j,l,n,isite !,nP

      Real(kind=8), allocatable :: WEX0(:)
      Real(kind=8), allocatable :: WEX1(:)
      Real(kind=8), allocatable :: WEX2(:)   ! Zeeman exchange energies
      Real(kind=8), allocatable :: WL0(:,:)    ! Zeeman local energies
      Real(kind=8), allocatable :: WL1(:,:)
      Real(kind=8), allocatable :: WL2(:,:)    ! Zeeman local energies
!     Zeeman local reduced energies, using only NEXCH states;
      Real(kind=8), allocatable :: WR0(:,:)
      Real(kind=8), allocatable :: WR1(:,:)
!     Zeeman local reduced energies, using only NEXCH states;
      Real(kind=8), allocatable :: WR2(:,:)

!     local statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZL0(:,:)
!     local statistical sum, Boltzmann distribution, using only NEXCH states
      Real(kind=8), allocatable :: ZR0(:,:)
!     local statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZL1(:,:)
!     local statistical sum, Boltzmann distribution, using only NEXCH states
      Real(kind=8), allocatable :: ZR1(:,:)
!     local statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZL2(:,:)
!     local statistical sum, Boltzmann distribution, using only NEXCH states
      Real(kind=8), allocatable :: ZR2(:,:)
!     spin magnetisation, from the local sites, using ALL states ;
      Real(kind=8), allocatable :: SL0(:,:,:)
!     spin magnetisation, from the local sites, using only NEXCH states ;
      Real(kind=8), allocatable :: SR0(:,:,:)
!     spin magnetisation, from the local sites, using ALL states ;
      Real(kind=8), allocatable :: SL1(:,:,:)
!     spin magnetisation, from the local sites, using only NEXCH states ;
      Real(kind=8), allocatable :: SR1(:,:,:)
!     spin magnetisation, from the local sites, using ALL states ;
      Real(kind=8), allocatable :: SL2(:,:,:)
!     spin magnetisation, from the local sites, using only NEXCH states ;
      Real(kind=8), allocatable :: SR2(:,:,:)
!     magnetisation, from local sites, using ALL states;
      Real(kind=8), allocatable :: ML0(:,:,:)
!     magnetisation, from local sites, using only NEXCH states;
      Real(kind=8), allocatable :: MR0(:,:,:)
!     magnetisation, from local sites, using ALL states;
      Real(kind=8), allocatable :: ML1(:,:,:)
!     magnetisation, from local sites, using only NEXCH states;
      Real(kind=8), allocatable :: MR1(:,:,:)
!     magnetisation, from local sites, using ALL states;
      Real(kind=8), allocatable :: ML2(:,:,:)
!     magnetisation, from local sites, using only NEXCH states;
      Real(kind=8), allocatable :: MR2(:,:,:)

!     spin magnetisation, from the exchange block;
      Real(kind=8), allocatable :: SEX0(:,:)
!     spin magnetisation, from the exchange block;
      Real(kind=8), allocatable :: SEX1(:,:)
!     spin magnetisation, from the exchange block;
      Real(kind=8), allocatable :: SEX2(:,:)
!     magnetisation, form the exchange block
      Real(kind=8), allocatable :: MEX0(:,:)
!     magnetisation, form the exchange block
      Real(kind=8), allocatable :: MEX1(:,:)
!     magnetisation, form the exchange block
      Real(kind=8), allocatable :: MEX2(:,:)
!     exchange statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZEX0(:)
!     exchange statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZEX1(:)
!     exchange statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZEX2(:)
c total vectors in general coordinate system:
      Real(kind=8), allocatable :: ZRT0(:,:)
      Real(kind=8), allocatable :: ZLT0(:,:)
      Real(kind=8), allocatable :: ZRT1(:,:)
      Real(kind=8), allocatable :: ZLT1(:,:)
      Real(kind=8), allocatable :: ZRT2(:,:)
      Real(kind=8), allocatable :: ZLT2(:,:)
      Real(kind=8), allocatable :: MRT0(:,:,:)
      Real(kind=8), allocatable :: MLT0(:,:,:)
      Real(kind=8), allocatable :: SRT0(:,:,:)
      Real(kind=8), allocatable :: SLT0(:,:,:)
      Real(kind=8), allocatable :: MRT1(:,:,:)
      Real(kind=8), allocatable :: MLT1(:,:,:)
      Real(kind=8), allocatable :: SRT1(:,:,:)
      Real(kind=8), allocatable :: SLT1(:,:,:)
      Real(kind=8), allocatable :: MRT2(:,:,:)
      Real(kind=8), allocatable :: MLT2(:,:,:)
      Real(kind=8), allocatable :: SRT2(:,:,:)
      Real(kind=8), allocatable :: SLT2(:,:,:)
c data for total system:
! total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT0(:)
! total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT1(:)
! total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT2(:)
      Real(kind=8), allocatable :: MT0(:,:) ! total magnetisation
      Real(kind=8), allocatable :: MT1(:,:) ! total magnetisation
      Real(kind=8), allocatable :: ST0(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: ST1(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: ST2(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT2(:,:) ! total magnetisation
c standard deviation data:
      Real(kind=8)              :: dev
      Real(kind=8), allocatable :: XTM_MH(:)
      Real(kind=8), allocatable :: XTM_dMdH(:)
      Real(kind=8), allocatable :: XTtens_MH(:,:,:)
      Real(kind=8), allocatable :: XTtens_dMdH(:,:,:)

      Integer                    :: nTempTotal
      Real(kind=8)              :: Xfield_1, Xfield_2, dltXF, F1, F2
      !Real(kind=8)             :: XTS(nT+nTempMagn)
c Zeeman energy and M vector
c      Real(kind=8)             :: dirX(nDir), dirY(nDir), dirZ(nDir)
c      Real(kind=8)             :: dir_weight(nDirZee,3)

      Real(kind=8)              :: dHX(3)
      Real(kind=8)              :: dHY(3)
      Real(kind=8)              :: dHZ(3)
      Integer                    :: RtoB, mem_local

      Integer                    :: info, ibuf, ibuf1, ibuf3
      Real(kind=8)              :: wt(3), zt(3,3)

      Real(kind=8)              :: dnrm2_
      External                   :: dev, dnrm2_
      Real(kind=8)              :: cm3tomB
      logical                    :: DBG, m_accurate
      Character(len=50) :: label
      DBG=.false.
      !m_paranoid=.true.!.false.
      cm3tomB=0.55849389040_wp   !   in cm3 * mol-1 * T
cccc-------------------------------------------------------cccc
      If(DBG) Then
         Write(6,'(A,   I5)') '      exch =',exch
         Write(6,'(A,   I5)') '      nLoc =',nLoc
         Write(6,'(A,   I5)') '   nCenter =',nCenter
         Write(6,'(A,   I5)') '      nneq =',nneq
         Write(6,'(A,   I5)') '      neqv =',neqv
         Write(6,'(A, 10I5)') '    neq(i) =',(neq(i),i=1,nneq)
         Write(6,'(A, 10I5)') '  nexch(i) =',(nexch(i),i=1,nneq)
         Write(6,'(A, 10I5)') '    nss(i) =',(nss(i),i=1,nneq)
         Write(6,'(A,   I5)') ' nTempMagn =',nTempMagn
         Write(6,'(A,   I5)') '        nT =',nT
         Write(6,'(A,   I5)') '        nM =',nM
         Write(6,'(A,   I5)') '      iopt =',iopt
         Write(6,'(A,F12.5)') '      Tmin =',Tmin
         Write(6,'(A,F12.5)') '      Tmax =',Tmax
         Write(6,'(A,F12.5)') '        zJ =',zJ
         Write(6,'(A,F12.5)') '    Xfield =',Xfield
         Write(6,'(A,F12.5)') '        EM =',EM
         Write(6,'(A,E12.5)') '      THRS =',THRS
         Write(6,          *) 'm_accurate =',m_accurate
         Write(6,          *) '     smagn =',smagn
         Write(6,          *) 'm_paranoid =',m_paranoid
         Write(6,          *) '    tinput =',tinput
         If (tinput) Then
            Do iT=1,nTempMagn
               Write(6,'(2(A,i3,A,F12.6,2x))') 'T(',iT,')=',T(iT)
            End Do
            Do iT=1,nT
               jT=iT+nTempMagn
               Write(6,'(2(A,i3,A,F12.6,2x))') 'T(',jT,')=',T(jT),
     &                          ' chiT_exp(',iT,')=',chit_exp(iT)
           End Do

         Else
           Do iT=1,nT+nTempMagn
             Write(6,'(2(A,i3,A,F12.6,2x))') 'T(',iT,')=',T(iT)
           End Do
         End If
         Write(6,'(A)') 'local ESO:'
         Do i=1,nneq
            Write(6,'(A,i3)') 'site:',i
            Write(6,'(10F12.5)') (eso(i,j),j=1,nss(i))
         End Do
         Write(6,'(A)') 'EXCHANGE ENERGY'
         Write(6,'(10F12.5)') (W(i),i=1,exch)
         Write(6,'(A)') 'Rotation Matrices:'
         Do i=1,nneq
            Write(6,'(A,i3)') 'site:',i
            Do j=1,neq(i)
               Do l=1,3
                  Write(6,'(10F12.5)') (RROT(i,j,l,n),n=1,3)
               End Do
            End Do
         End Do
         Call xFlush(6)
      End If !DBG
cccc-------------------------------------------------------cccc
      Write(6,*)
      Write(6,'(100A)') (('%'),J=1,95)
      Write(6,'(16X,A)') 'CALCULATION OF THE FIELD-DEPENDENT '//
     &                   'MAGNETIC SUSCEPTIBILITY'
      Write(6,'(18X,A)') 'within true (dM/dH) and "experimentalists"'//
     &                   ' (M/H) models'
      Write(6,'(100A)') (('%'),J=1,95)
      Write(6,*)
      Write(6,'(2x,A,F10.6,A)') 'Magnetic field strength:',Xfield,
     &                          ' Tesla.'
      If(tinput) Then
         Write(6,'(2x,a)') 'Temperature dependence of the magnetic '//
     &                     'susceptibility and'
         Write(6,'(2x,a)') 'high-field magnetization will be '//
     &                     'calculated according to '
         Write(6,'(2x,a)') 'experimental values provided by the '//
     &                     'user in file "chitexp.input".'
      Else
         Write(6,'(2x,a,i3,a)') 'Temperature dependence of the '//
     &                          'magnetic susceptibility will be '//
     &                          'calculated in',nT,' points, '
         Write(6,'(2x,a,f4.1,a,f6.1,a)') 'equally distributed in '//
     &                          'temperature range ',tmin,' ---',
     &                           tmax,' K.'
      End If

!=======================================================================
      mem_local=0
      RtoB=8
      Call mma_allocate(WEX0,nM,'WEX0')
      Call mma_allocate(WEX1,nM,'WEX1')
      Call mma_allocate(WEX2,nM,'WEX2')
      Call dcopy_(nM,[0.0_wp],0,WEX0,1)
      Call dcopy_(nM,[0.0_wp],0,WEX1,1)
      Call dcopy_(nM,[0.0_wp],0,WEX2,1)
      mem_local=mem_local+3*nM*RtoB

      Call mma_allocate(WL0,nneq,nLoc,'WL0')
      Call mma_allocate(WL1,nneq,nLoc,'WL1')
      Call mma_allocate(WL2,nneq,nLoc,'WL2')
      Call mma_allocate(WR0,nneq,nLoc,'WR0')
      Call mma_allocate(WR1,nneq,nLoc,'WR1')
      Call mma_allocate(WR2,nneq,nLoc,'WR2')
      Call dcopy_(nneq*nLoc,[0.0_wp],0,WL0,1)
      Call dcopy_(nneq*nLoc,[0.0_wp],0,WL1,1)
      Call dcopy_(nneq*nLoc,[0.0_wp],0,WL2,1)
      Call dcopy_(nneq*nLoc,[0.0_wp],0,WR0,1)
      Call dcopy_(nneq*nLoc,[0.0_wp],0,WR1,1)
      Call dcopy_(nneq*nLoc,[0.0_wp],0,WR2,1)
      mem_local=mem_local+6*nneq*nLoc*RtoB

      Call mma_allocate(ZL0,nneq,(nT+nTempMagn),'ZL0')
      Call mma_allocate(ZR0,nneq,(nT+nTempMagn),'ZR0')
      Call mma_allocate(ZL1,nneq,(nT+nTempMagn),'ZL1')
      Call mma_allocate(ZR1,nneq,(nT+nTempMagn),'ZR1')
      Call mma_allocate(ZL2,nneq,(nT+nTempMagn),'ZL2')
      Call mma_allocate(ZR2,nneq,(nT+nTempMagn),'ZR2')
      Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZL0,1)
      Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZR0,1)
      Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZL1,1)
      Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZR1,1)
      Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZL2,1)
      Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZR2,1)
      mem_local=mem_local+6*nneq*(nT+nTempMagn)*RtoB

      Call mma_allocate(SL0,nneq,3,(nT+nTempMagn),'SL0')
      Call mma_allocate(SR0,nneq,3,(nT+nTempMagn),'SR0')
      Call mma_allocate(SL1,nneq,3,(nT+nTempMagn),'SL1')
      Call mma_allocate(SR1,nneq,3,(nT+nTempMagn),'SR1')
      Call mma_allocate(SL2,nneq,3,(nT+nTempMagn),'SL2')
      Call mma_allocate(SR2,nneq,3,(nT+nTempMagn),'SR2')
      Call mma_allocate(ML0,nneq,3,(nT+nTempMagn),'ML0')
      Call mma_allocate(MR0,nneq,3,(nT+nTempMagn),'MR0')
      Call mma_allocate(ML1,nneq,3,(nT+nTempMagn),'ML1')
      Call mma_allocate(MR1,nneq,3,(nT+nTempMagn),'MR1')
      Call mma_allocate(ML2,nneq,3,(nT+nTempMagn),'ML2')
      Call mma_allocate(MR2,nneq,3,(nT+nTempMagn),'MR2')
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SL0,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SR0,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SL1,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SR1,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SL2,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SR2,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,ML0,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,MR0,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,ML1,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,MR1,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,ML2,1)
      Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,MR2,1)
      mem_local=mem_local+12*3*nneq*(nT+nTempMagn)*RtoB

      Call mma_allocate(ZEX0,(nT+nTempMagn),'ZEX0')
      Call mma_allocate(ZEX1,(nT+nTempMagn),'ZEX1')
      Call mma_allocate(ZEX2,(nT+nTempMagn),'ZEX2')
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,ZEX0,1)
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,ZEX1,1)
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,ZEX2,1)
      mem_local=mem_local+3*(nT+nTempMagn)*RtoB

      Call mma_allocate(ZT0,(nT+nTempMagn),'ZT0')
      Call mma_allocate(ZT1,(nT+nTempMagn),'ZT1')
      Call mma_allocate(ZT2,(nT+nTempMagn),'ZT2')
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,ZEX0,1)
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,ZEX1,1)
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,ZEX2,1)
      mem_local=mem_local+3*(nT+nTempMagn)*RtoB

      Call mma_allocate(SEX0,3,(nT+nTempMagn),'SEX0')
      Call mma_allocate(SEX1,3,(nT+nTempMagn),'SEX1')
      Call mma_allocate(SEX2,3,(nT+nTempMagn),'SEX2')
      Call mma_allocate(MEX0,3,(nT+nTempMagn),'MEX0')
      Call mma_allocate(MEX1,3,(nT+nTempMagn),'MEX1')
      Call mma_allocate(MEX2,3,(nT+nTempMagn),'MEX2')
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,SEX0,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,SEX1,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,SEX2,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MEX0,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MEX1,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MEX2,1)
      mem_local=mem_local+6*3*(nT+nTempMagn)*RtoB

      Call mma_allocate(ST0,3,(nT+nTempMagn),'ST0')
      Call mma_allocate(ST1,3,(nT+nTempMagn),'ST1')
      Call mma_allocate(ST2,3,(nT+nTempMagn),'ST2')
      Call mma_allocate(MT0,3,(nT+nTempMagn),'MT0')
      Call mma_allocate(MT1,3,(nT+nTempMagn),'MT1')
      Call mma_allocate(MT2,3,(nT+nTempMagn),'MT2')
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST0,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST1,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST2,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT0,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT1,1)
      Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT2,1)
      mem_local=mem_local+6*3*(nT+nTempMagn)*RtoB

      Call mma_allocate(XTM_MH  ,(nT+nTempMagn),'XTM_MH')
      Call mma_allocate(XTM_dMdH,(nT+nTempMagn),'XTM_dMdH')
      Call mma_allocate(XTtens_MH  ,3,3,(nT+nTempMagn),'XTtens_MH')
      Call mma_allocate(XTtens_dMdH,3,3,(nT+nTempMagn),'XTtens_dMdH')
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,XTM_MH,1)
      Call dcopy_((nT+nTempMagn),[0.0_wp],0,XTM_dMdH,1)
      Call dcopy_(3*3*(nT+nTempMagn),[0.0_wp],0,XTtens_MH,1)
      Call dcopy_(3*3*(nT+nTempMagn),[0.0_wp],0,XTtens_dMdH,1)
      mem_local=mem_local+20*(nT+nTempMagn)*RtoB

      Call mma_allocate(ZRT0,nCenter,(nT+nTempMagn),'ZRT0')
      Call mma_allocate(ZLT0,nCenter,(nT+nTempMagn),'ZLT0')
      Call mma_allocate(ZRT1,nCenter,(nT+nTempMagn),'ZRT1')
      Call mma_allocate(ZLT1,nCenter,(nT+nTempMagn),'ZLT1')
      Call mma_allocate(ZRT2,nCenter,(nT+nTempMagn),'ZRT2')
      Call mma_allocate(ZLT2,nCenter,(nT+nTempMagn),'ZLT2')
      Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZRT0,1)
      Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZLT0,1)
      Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZRT1,1)
      Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZLT1,1)
      Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZRT2,1)
      Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZLT2,1)
      mem_local=mem_local+6*3*nCenter*(nT+nTempMagn)*RtoB

      Call mma_allocate(MRT0,nCenter,3,(nT+nTempMagn),'MRT0')
      Call mma_allocate(MLT0,nCenter,3,(nT+nTempMagn),'MLT0')
      Call mma_allocate(SRT0,nCenter,3,(nT+nTempMagn),'SRT0')
      Call mma_allocate(SLT0,nCenter,3,(nT+nTempMagn),'SLT0')
      Call mma_allocate(MRT1,nCenter,3,(nT+nTempMagn),'MRT1')
      Call mma_allocate(MLT1,nCenter,3,(nT+nTempMagn),'MLT1')
      Call mma_allocate(SRT1,nCenter,3,(nT+nTempMagn),'SRT1')
      Call mma_allocate(SLT1,nCenter,3,(nT+nTempMagn),'SLT1')
      Call mma_allocate(MRT2,nCenter,3,(nT+nTempMagn),'MRT2')
      Call mma_allocate(MLT2,nCenter,3,(nT+nTempMagn),'MLT2')
      Call mma_allocate(SRT2,nCenter,3,(nT+nTempMagn),'SRT2')
      Call mma_allocate(SLT2,nCenter,3,(nT+nTempMagn),'SLT2')
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MRT0,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MLT0,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SRT0,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SLT0,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MRT1,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MLT1,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SRT1,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SLT1,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MRT2,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MLT2,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SRT2,1)
      Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SLT2,1)
      mem_local=mem_local+12*3*nCenter*(nT+nTempMagn)*RtoB

      If(dbg) Write(6,*) 'XT_MH:  memory allocated (local):'
      If(dbg) Write(6,*) 'mem_local=', mem_local
      If(dbg) Write(6,*) 'XT_MH:  memory allocated (total):'
      If(dbg) Write(6,*) 'mem_total=', mem+mem_local

!=======================================================================
      dHX=0.0_wp
      dHY=0.0_wp
      dHZ=0.0_wp

      nDirX=3

      dHX(1)=1.0_wp
      dHY(1)=0.0_wp
      dHZ(1)=0.0_wp

      dHX(2)=0.0_wp
      dHY(2)=1.0_wp
      dHZ(2)=0.0_wp

      dHX(3)=0.0_wp
      dHY(3)=0.0_wp
      dHZ(3)=1.0_wp

      Xfield_1=0.0_wp
      Xfield_2=0.0_wp
      dltXF=0.0_wp
      Xfield_1=Xfield*0.99999_wp
      Xfield_2=Xfield*1.00001_wp
      dltXF=Xfield_2-Xfield_1

      nTempTotal=nT+nTempMagn

c ///  opening the loop over different directions of the magnetic field
      Do iM=1,nDirX
        Call dcopy_(nM,[0.0_wp],0,WEX0,1)
        Call dcopy_(nM,[0.0_wp],0,WEX1,1)
        Call dcopy_(nM,[0.0_wp],0,WEX2,1)
        Call dcopy_((nT+nTempMagn),[0.0_wp],0,ZEX0,1)
        Call dcopy_((nT+nTempMagn),[0.0_wp],0,ZEX1,1)
        Call dcopy_((nT+nTempMagn),[0.0_wp],0,ZEX2,1)
        Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,SEX0,1)
        Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,SEX1,1)
        Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,SEX2,1)
        Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MEX0,1)
        Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MEX1,1)
        Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MEX2,1)
        Call dcopy_(nneq*nLoc,[0.0_wp],0,WL0,1)
        Call dcopy_(nneq*nLoc,[0.0_wp],0,WL1,1)
        Call dcopy_(nneq*nLoc,[0.0_wp],0,WL2,1)
        Call dcopy_(nneq*nLoc,[0.0_wp],0,WR0,1)
        Call dcopy_(nneq*nLoc,[0.0_wp],0,WR1,1)
        Call dcopy_(nneq*nLoc,[0.0_wp],0,WR2,1)
        Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZL0,1)
        Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZR0,1)
        Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZL1,1)
        Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZR1,1)
        Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZL2,1)
        Call dcopy_(nneq*(nT+nTempMagn),[0.0_wp],0,ZR2,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SL0,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SR0,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SL1,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SR1,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SL2,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,SR2,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,ML0,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,MR0,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,ML1,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,MR1,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,ML2,1)
        Call dcopy_(3*nneq*(nT+nTempMagn),[0.0_wp],0,MR2,1)

        Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZRT0,1)
        Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZLT0,1)
        Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZRT1,1)
        Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZLT1,1)
        Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZRT2,1)
        Call dcopy_(nCenter*(nT+nTempMagn),[0.0_wp],0,ZLT2,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MRT0,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MLT0,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SRT0,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SLT0,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MRT1,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MLT1,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SRT1,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SLT1,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MRT2,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,MLT2,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SRT2,1)
        Call dcopy_(3*nCenter*(nT+nTempMagn),[0.0_wp],0,SLT2,1)
c exchange magnetization:
         Call MAGN( EXCH, NM, dHX(iM), dHY(iM), dHZ(iM),
     &              XField, W, zJ, THRS,
     &              DIPEXCH(1:3,1:exch,1:exch),
     &               S_EXCH(1:3,1:exch,1:exch),
     &              nTempTotal, T(1:nTempTotal), smagn,
     &              Wex0(1:nM),
     &              Zex0(1:nTempTotal),
     &              Sex0(1:3,1:nTempTotal),
     &              Mex0(1:3,1:nTempTotal), m_paranoid, DBG )
         Call MAGN( EXCH, NM, dHX(iM), dHY(iM), dHZ(iM),
     &              XField_1, W, zJ, THRS,
     &              DIPEXCH(1:3,1:exch,1:exch),
     &               S_EXCH(1:3,1:exch,1:exch),
     &              nTempTotal, T(1:nTempTotal), smagn,
     &              Wex1(1:nM),
     &              Zex1(1:nTempTotal),
     &              Sex1(1:3,1:nTempTotal),
     &              Mex1(1:3,1:nTempTotal), m_paranoid, DBG )
         Call MAGN( EXCH, NM, dHX(iM), dHY(iM), dHZ(iM),
     &              XField_2, W, zJ, THRS,
     &              DIPEXCH(1:3,1:exch,1:exch),
     &               S_EXCH(1:3,1:exch,1:exch),
     &              nTempTotal, T(1:nTempTotal), smagn,
     &              Wex2(1:nM),
     &              Zex2(1:nTempTotal),
     &              Sex2(1:3,1:nTempTotal),
     &              Mex2(1:3,1:nTempTotal), m_paranoid, DBG )
      If(DBG) Then
        Do i=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex0(',i,')=',(Mex0(l,i),l=1,3)
        End Do
        Do i=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex1(',i,')=',(Mex1(l,i),l=1,3)
        End Do
        Do i=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex2(',i,')=',(Mex2(l,i),l=1,3)
        End Do
        Do i=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex 2-1 (',i,')=',
     &                                (Mex2(l,i)-Mex1(l,i),l=1,3)
        End Do
      End If !DBG

       Call Add_Info('dM/dH   Mex0',[dnrm2_(3*nTempTotal,Mex0,1)],1,8)
       Call Add_Info('dM/dH   Sex0',[dnrm2_(3*nTempTotal,Sex0,1)],1,8)
       Call Add_Info('dM/dH   Zex0',[dnrm2_(  nTempTotal,Zex0,1)],1,8)
       Call Add_Info('dM/dH   Wex0',[dnrm2_(          nM,Wex0,1)],1,8)

       Call Add_Info('dM/dH   Mex1',[dnrm2_(3*nTempTotal,Mex1,1)],1,8)
       Call Add_Info('dM/dH   Sex1',[dnrm2_(3*nTempTotal,Sex1,1)],1,8)
       Call Add_Info('dM/dH   Zex1',[dnrm2_(  nTempTotal,Zex1,1)],1,8)
       Call Add_Info('dM/dH   Wex1',[dnrm2_(          nM,Wex1,1)],1,8)

       Call Add_Info('dM/dH   Mex2',[dnrm2_(3*nTempTotal,Mex2,1)],1,8)
       Call Add_Info('dM/dH   Sex2',[dnrm2_(3*nTempTotal,Sex2,1)],1,8)
       Call Add_Info('dM/dH   Zex2',[dnrm2_(  nTempTotal,Zex2,1)],1,8)
       Call Add_Info('dM/dH   Wex2',[dnrm2_(          nM,Wex2,1)],1,8)

c compute local magnetizations:
         If(m_accurate) Then
            Do i=1,nneq
c all states:
               If ( NSS(i).gt.NEXCH(i) )  Then
c this check is to avoid the unnecessary computation, in cases when no local excited states are present
                  Call MAGN( NSS(i), NEXCH(i), dHX(iM),dHY(iM),dHZ(iM),
     &                       XField,
     &                       ESO(i,1:NSS(i)), zJ, THRS,
     &                       DIPSO(i,1:3,1:NSS(i),1:NSS(i)),
     &                        S_SO(i,1:3,1:NSS(i),1:NSS(i)),
     &                       nTempTotal, T(1:(nT+nTempMagn)), smagn,
     &                       WL0(i,1:NSS(i)),
     &                       ZL0(i,1:(nT+nTempMagn)),
     &                       SL0(i,1:3,1:(nT+nTempMagn)),
     &                       ML0(i,1:3,1:(nT+nTempMagn)),
     &                       m_paranoid, DBG )

                  Call MAGN( NSS(i), NEXCH(i), dHX(iM),dHY(iM),dHZ(iM),
     &                       XField_1,
     &                       ESO(i,1:NSS(i)), zJ, THRS,
     &                       DIPSO(i,1:3,1:NSS(i),1:NSS(i)),
     &                        S_SO(i,1:3,1:NSS(i),1:NSS(i)),
     &                       nTempTotal, T(1:(nT+nTempMagn)), smagn,
     &                       WL1(i,1:NSS(i)),
     &                       ZL1(i,1:(nT+nTempMagn)),
     &                       SL1(i,1:3,1:(nT+nTempMagn)),
     &                       ML1(i,1:3,1:(nT+nTempMagn)),
     &                       m_paranoid, DBG )

                  Call MAGN( NSS(i), NEXCH(i), dHX(iM),dHY(iM),dHZ(iM),
     &                       Xfield_2,
     &                       ESO(i,1:NSS(i)), zJ, THRS,
     &                       DIPSO(i,1:3,1:NSS(i),1:NSS(i)),
     &                        S_SO(i,1:3,1:NSS(i),1:NSS(i)),
     &                       nTempTotal, T(1:(nT+nTempMagn)), smagn,
     &                       WL2(i,1:NSS(i)),
     &                       ZL2(i,1:(nT+nTempMagn)),
     &                       SL2(i,1:3,1:(nT+nTempMagn)),
     &                       ML2(i,1:3,1:(nT+nTempMagn)),
     &                       m_paranoid, DBG )
c only local "exchange states":
                  Call MAGN( NEXCH(i), NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),
     &                       XField,
     &                       ESO(i,1:NEXCH(i)), zJ, THRS,
     &                       DIPSO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                        S_SO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                       nTempTotal, T(1:(nT+nTempMagn)), smagn,
     &                       WR0(i,1:Nexch(i)),
     &                       ZR0(i,1:(nT+nTempMagn)),
     &                       SR0(i,1:3,1:(nT+nTempMagn)),
     &                       MR0(i,1:3,1:(nT+nTempMagn)),
     &                       m_paranoid, DBG )

                  Call MAGN( NEXCH(i), NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),
     &                       XField_1,
     &                       ESO(i,1:NEXCH(i)), zJ, THRS,
     &                       DIPSO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                        S_SO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                       nTempTotal, T(1:(nT+nTempMagn)), smagn,
     &                       WR1(i,1:Nexch(i)),
     &                       ZR1(i,1:(nT+nTempMagn)),
     &                       SR1(i,1:3,1:(nT+nTempMagn)),
     &                       MR1(i,1:3,1:(nT+nTempMagn)),
     &                       m_paranoid, DBG )

                  Call MAGN( NEXCH(i), NEXCH(i),dHX(iM),dHY(iM),dHZ(iM),
     &                       XField_2,
     &                       ESO(i,1:NEXCH(i)), zJ, THRS,
     &                       DIPSO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                        S_SO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                       nTempTotal, T(1:(nT+nTempMagn)), smagn,
     &                       WR2(i,1:Nexch(i)),
     &                       ZR2(i,1:(nT+nTempMagn)),
     &                       SR2(i,1:3,1:(nT+nTempMagn)),
     &                       MR2(i,1:3,1:(nT+nTempMagn)),
     &                       m_paranoid, DBG )
                  If (DBG) Then
                     Do iT=1,nTempTotal
                        Write(6,'(A,i1,A,i3,A,3E22.14)')
     &                          'ML(',i,',L,',iT,')=',
     &                                   (ML2(i,l,iT)-ML1(i,l,iT),l=1,3)
                        Write(6,'(A,i1,A,i3,A,3E22.14)')
     &                          'MR(',i,',L,',iT,')=',
     &                                   (MR2(i,l,iT)-MR1(i,l,iT),l=1,3)
                     End Do
                  End If ! DBG
               End If ! NSS(i).gt.NEXCH(i)
            End Do ! i=1,nneq


       ibuf1=nTempTotal*nneq
       ibuf3=3*ibuf1
       Call Add_Info('dM/dH    ML0',[dnrm2_(  ibuf3,ML0,1)],1,8)
       Call Add_Info('dM/dH    SL0',[dnrm2_(  ibuf3,SL0,1)],1,8)
       Call Add_Info('dM/dH    ZL0',[dnrm2_(  ibuf1,ZL0,1)],1,8)
       Call Add_Info('dM/dH    WL0',[dnrm2_(nLoc*nneq,WL0,1)],1,8)

       Call Add_Info('dM/dH    MR0',[dnrm2_(  ibuf3,MR0,1)],1,8)
       Call Add_Info('dM/dH    SR0',[dnrm2_(  ibuf3,SR0,1)],1,8)
       Call Add_Info('dM/dH    ZR0',[dnrm2_(  ibuf1,ZR0,1)],1,8)
       Call Add_Info('dM/dH    WR0',[dnrm2_(nLoc*nneq,WR0,1)],1,8)

       Call Add_Info('dM/dH    ML1',[dnrm2_(  ibuf3,ML1,1)],1,8)
       Call Add_Info('dM/dH    SL1',[dnrm2_(  ibuf3,SL1,1)],1,8)
       Call Add_Info('dM/dH    ZL1',[dnrm2_(  ibuf1,ZL1,1)],1,8)
       Call Add_Info('dM/dH    WL1',[dnrm2_(nLoc*nneq,WL1,1)],1,8)

       Call Add_Info('dM/dH    MR1',[dnrm2_(  ibuf3,MR1,1)],1,8)
       Call Add_Info('dM/dH    SR1',[dnrm2_(  ibuf3,SR1,1)],1,8)
       Call Add_Info('dM/dH    ZR1',[dnrm2_(  ibuf1,ZR1,1)],1,8)
       Call Add_Info('dM/dH    WR1',[dnrm2_(nLoc*nneq,WR1,1)],1,8)

       Call Add_Info('dM/dH    ML2',[dnrm2_(  ibuf3,ML2,1)],1,8)
       Call Add_Info('dM/dH    SL2',[dnrm2_(  ibuf3,SL2,1)],1,8)
       Call Add_Info('dM/dH    ZL2',[dnrm2_(  ibuf1,ZL2,1)],1,8)
       Call Add_Info('dM/dH    WL2',[dnrm2_(nLoc*nneq,WL2,1)],1,8)

       Call Add_Info('dM/dH    MR2',[dnrm2_(  ibuf3,MR2,1)],1,8)
       Call Add_Info('dM/dH    SR2',[dnrm2_(  ibuf3,SR2,1)],1,8)
       Call Add_Info('dM/dH    ZR2',[dnrm2_(  ibuf1,ZR2,1)],1,8)
       Call Add_Info('dM/dH    WR2',[dnrm2_(nLoc*nneq,WR2,1)],1,8)

c expand the basis and rotate local vectors to the general
c coordinate system:

            isite=0
            Do i=1,NNEQ
               Do j=1,NEQ(i)
                  isite=isite+1
c statistical distributions
                  Do iT=1,nTempTotal
                     ZLT0(isite,iT)=ZL0(i,iT)
                     ZRT0(isite,iT)=ZR0(i,iT)
                     ZLT1(isite,iT)=ZL1(i,iT)
                     ZRT1(isite,iT)=ZR1(i,iT)
                     ZLT2(isite,iT)=ZL2(i,iT)
                     ZRT2(isite,iT)=ZR2(i,iT)
                  End Do
c magnetizations:
c    use R_rot matrices, which have determinant +1.
c  note that  R_lg matrices have arbitrary determinant.
                  Do iT=1,nTempTotal
                     Do l=1,3
                        Do n=1,3
        MLT0(isite,l,iT) = MLT0(isite,l,iT) + rrot(i,j,l,n)*ML0(i,n,iT)
        SLT0(isite,l,iT) = SLT0(isite,l,iT) + rrot(i,j,l,n)*SL0(i,n,iT)
        MRT0(isite,l,iT) = MRT0(isite,l,iT) + rrot(i,j,l,n)*MR0(i,n,iT)
        SRT0(isite,l,iT) = SRT0(isite,l,iT) + rrot(i,j,l,n)*SR0(i,n,iT)

        MLT1(isite,l,iT) = MLT1(isite,l,iT) + rrot(i,j,l,n)*ML1(i,n,iT)
        SLT1(isite,l,iT) = SLT1(isite,l,iT) + rrot(i,j,l,n)*SL1(i,n,iT)
        MRT1(isite,l,iT) = MRT1(isite,l,iT) + rrot(i,j,l,n)*MR1(i,n,iT)
        SRT1(isite,l,iT) = SRT1(isite,l,iT) + rrot(i,j,l,n)*SR1(i,n,iT)

        MLT2(isite,l,iT) = MLT2(isite,l,iT) + rrot(i,j,l,n)*ML2(i,n,iT)
        SLT2(isite,l,iT) = SLT2(isite,l,iT) + rrot(i,j,l,n)*SL2(i,n,iT)
        MRT2(isite,l,iT) = MRT2(isite,l,iT) + rrot(i,j,l,n)*MR2(i,n,iT)
        SRT2(isite,l,iT) = SRT2(isite,l,iT) + rrot(i,j,l,n)*SR2(i,n,iT)
                        End Do
                     End Do
                  End Do

               End Do ! j, neq(i)
            End Do ! i, nneq
            ibuf=0
            ibuf=3*(nT+nTempMagn)*nCenter
            Call Add_Info('dM/dH    MLT0',[dnrm2_(ibuf,MLT0,1)],1,8)
            Call Add_Info('dM/dH    SLT0',[dnrm2_(ibuf,SLT0,1)],1,8)
            Call Add_Info('dM/dH    MRT0',[dnrm2_(ibuf,MRT0,1)],1,8)
            Call Add_Info('dM/dH    SRT0',[dnrm2_(ibuf,SRT0,1)],1,8)
            !
            Call Add_Info('dM/dH    MLT1',[dnrm2_(ibuf,MLT1,1)],1,8)
            Call Add_Info('dM/dH    SLT1',[dnrm2_(ibuf,SLT1,1)],1,8)
            Call Add_Info('dM/dH    MRT1',[dnrm2_(ibuf,MRT1,1)],1,8)
            Call Add_Info('dM/dH    SRT1',[dnrm2_(ibuf,SRT1,1)],1,8)
            !
            Call Add_Info('dM/dH    MLT2',[dnrm2_(ibuf,MLT2,1)],1,8)
            Call Add_Info('dM/dH    SLT2',[dnrm2_(ibuf,SLT2,1)],1,8)
            Call Add_Info('dM/dH    MRT2',[dnrm2_(ibuf,MRT2,1)],1,8)
            Call Add_Info('dM/dH    SRT2',[dnrm2_(ibuf,SRT2,1)],1,8)
c compute the total magnetizations according to the derived formulas:
            If(dbg) Write(6,*) 'check point MLT0'
            Do iT=1,nTempTotal
               If (smagn) Then
                  Call MSUM( nCenter, Sex0(1:3,iT), Zex0(iT),
     &                       SLT0(1:nCenter,1:3,iT), ZLT0(1:nCenter,iT),
     &                       SRT0(1:nCenter,1:3,iT), ZRT0(1:nCenter,iT),
     &                       iopt, ST0(1:3,iT),  ZT0(iT)  )
                  Call MSUM( nCenter, Sex1(1:3,iT), Zex1(iT),
     &                       SLT1(1:nCenter,1:3,iT), ZLT1(1:nCenter,iT),
     &                       SRT1(1:nCenter,1:3,iT), ZRT1(1:nCenter,iT),
     &                       iopt, ST1(1:3,iT),  ZT1(iT)  )
                  Call MSUM( nCenter, Sex2(1:3,iT), Zex2(iT),
     &                       SLT2(1:nCenter,1:3,iT), ZLT2(1:nCenter,iT),
     &                       SRT2(1:nCenter,1:3,iT), ZRT2(1:nCenter,iT),
     &                       iopt, ST2(1:3,iT),  ZT2(iT)  )
               End If

               If(dbg) Write(6,*) 'check point MSUM'
                  Call MSUM( nCenter, Mex0(1:3,iT), Zex0(iT),
     &                       MLT0(1:nCenter,1:3,iT), ZLT0(1:nCenter,iT),
     &                       MRT0(1:nCenter,1:3,iT), ZRT0(1:nCenter,iT),
     &                       iopt, MT0(1:3,iT),  ZT0(iT)  )
                  Call MSUM( nCenter, Mex1(1:3,iT), Zex1(iT),
     &                       MLT1(1:nCenter,1:3,iT), ZLT1(1:nCenter,iT),
     &                       MRT1(1:nCenter,1:3,iT), ZRT1(1:nCenter,iT),
     &                       iopt, MT1(1:3,iT),  ZT1(iT)  )
                  Call MSUM( nCenter, Mex2(1:3,iT), Zex2(iT),
     &                       MLT2(1:nCenter,1:3,iT), ZLT2(1:nCenter,iT),
     &                       MRT2(1:nCenter,1:3,iT), ZRT2(1:nCenter,iT),
     &                       iopt, MT2(1:3,iT),  ZT2(iT)  )
            End Do

         End If ! m_accurate

         ibuf=0
         ibuf=3*(nT+nTempMagn)
         Call Add_Info('dM/dH    ST0', [dnrm2_(ibuf, ST0,1)],1,6)
         Call Add_Info('dM/dH    ST1', [dnrm2_(ibuf, ST1,1)],1,6)
         Call Add_Info('dM/dH    ST2', [dnrm2_(ibuf, ST2,1)],1,6)
         Call Add_Info('dM/dH    MT0', [dnrm2_(ibuf, MT0,1)],1,6)
         Call Add_Info('dM/dH    MT1', [dnrm2_(ibuf, MT1,1)],1,6)
         Call Add_Info('dM/dH    MT2', [dnrm2_(ibuf, MT2,1)],1,6)
c  computing the AVERAGE MOMENTS calculated at dIfferent temperatures (T(i))
         Do iT=1,nTempTotal
            F1=T(iT)*cm3tomB/dltXF
            F2=T(iT)*cm3tomB/Xfield

            ! dM/dH model
            XTtens_dMdH(iM,1,iT) = (MT2(1,iT)-MT1(1,iT))*F1
            XTtens_dMdH(iM,2,iT) = (MT2(2,iT)-MT1(2,iT))*F1
            XTtens_dMdH(iM,3,iT) = (MT2(3,iT)-MT1(3,iT))*F1

            ! M/H model
            XTtens_MH(iM,1,iT) = MT0(1,iT)*F2
            XTtens_MH(iM,2,iT) = MT0(2,iT)*F2
            XTtens_MH(iM,3,iT) = MT0(3,iT)*F2
         End Do
c ///  closing the loops over field directions
      End Do ! iM (nDirX)
c computing the XT as tensor's average:
      XTM_dMdH=0.0_wp
      XTM_MH  =0.0_wp
      Do iT=1,nTempTotal
         XTM_dMdH(iT) = ( XTtens_dMdH(1,1,iT)
     &                  + XTtens_dMdH(2,2,iT)
     &                  + XTtens_dMdH(3,3,iT) ) / 3.0_wp

         XTM_MH(iT)   = ( XTtens_MH(1,1,iT)
     &                  + XTtens_MH(2,2,iT)
     &                  + XTtens_MH(3,3,iT)   ) / 3.0_wp
      End Do !iT

      ibuf=0
      ibuf=9*(nT+nTempMagn)
      Call Add_Info('dM/dH    XTtens_dMdH',
     &                              [dnrm2_(ibuf,XTtens_dMdH,1)],1,5)
      Call Add_Info('dM/dH    XTtens_MH',
     &                              [dnrm2_(ibuf,XTtens_MH,1)],1,6)
      ibuf=0
      ibuf=nT+nTempMagn
      Call Add_Info('dM/dH    XTM_dMdH',
     &                              [dnrm2_(ibuf,XTM_dMdH,1)],1,5)
      Call Add_Info('dM/dH    XTM_MH',
     &                              [dnrm2_(ibuf,XTM_MH,1)],1,6)
C -------------------------------------------------------------------
C   WRITING SOME OF THE OUTPUT....
C -------------------------------------------------------------------
      Write(6,*)
      Write(6,'(A)') '----------------------------------------------'//
     &               '----------------------------|'
      Write(6,'(A)') '     |     T      | Statistical |   CHI*T     '//
     &               '|   CHI*T     |   CHI*T     |'
      Write(6,'(A,F6.3,A,F6.3,A)')
     &                '     |            |  Sum (Z)    | H = 0.000 T '//
     &               '| H =',Xfield,' T | H =',XField,' T |'
      Write(6,'(A)') '     |            |             |             '//
     &               '| X = dM/dH   | X = M/H     |'
      Write(6,'(A)') '-----|----------------------------------------'//
     &               '----------------------------|'
      Write(6,'(A)') 'Units|   Kelvin   |    ---      |  cm3*K/mol  '//
     &               '|  cm3*K/mol  |  cm3*K/mol  |'
      Write(6,'(A)') '-----|----------------------------------------'//
     &               '----------------------------|'

      Do iT=1,nT
         jT=iT+nTempMagn
         Write(6,'(A,F11.6,A,E12.5,A,F12.8,A,F12.8,A,F12.7,A)')
     & '     |',T(jT),' |', ZT0(jT),' |',XT_no_field(jT),' |',
     &          XTM_dMdH(jT),' |', XTM_MH(jT), ' |'
      End Do
      Write(6,'(A)') '-----|----------------------------------------'//
     &               '----------------------------|'

c  calcualtion of the standard deviation:
      If (tinput) Then
         Write(6,'(a,5x, f20.14)') 'ST.DEV: X= dM/dH:',
     &          dev( nT, XTM_dMdH((1+nTempMagn):(nT+nTempMagn)),
     &                   chit_exp((1+nTempMagn):(nT+nTempMagn))  )
         Write(6,'(a,5x, f20.14)') 'ST.DEV: X=  M/H :',
     &          dev( nT, XTM_MH(  (1+nTempMagn):(nT+nTempMagn)),
     &                   chit_exp((1+nTempMagn):(nT+nTempMagn))  )
      Write(6,'(A)') '-----|----------------------------------------'//
     &               '----------------------------|'
      End If !tinput


!-------------------------  PLOTs -------------------------------------!
      WRITE(label,'(A)') "with_field_M_over_H"
      FLUSH(6)
      IF ( DoPlot ) THEN
         IF ( tinput ) THEN
            Call plot_XT_with_Exp(label, nT,
     &                           T((1+nTempMagn):(nT+nTempMagn) ),
     &                      XTM_MH((1+nTempMagn):(nT+nTempMagn) ),
     &                    chit_exp((1+nTempMagn):(nT+nTempMagn) ), zJ )
         ELSE
            Call plot_XT_no_Exp(  label, nT,
     &                           T((1+nTempMagn):(nT+nTempMagn) ),
     &                      XTM_MH((1+nTempMagn):(nT+nTempMagn) ), zJ )
         END IF
      END IF


      WRITE(label,'(A)') "with_field_dM_over_dH"
      FLUSH(6)
      IF ( DoPlot ) THEN
         IF ( tinput ) THEN
            Call plot_XT_with_Exp(label, nT,
     &                           T((1+nTempMagn):(nT+nTempMagn) ),
     &                    XTM_dMdH((1+nTempMagn):(nT+nTempMagn) ),
     &                    chit_exp((1+nTempMagn):(nT+nTempMagn) ), zJ )
         ELSE
            Call plot_XT_no_Exp(  label, nT,
     &                           T((1+nTempMagn):(nT+nTempMagn) ),
     &                    XTM_dMdH((1+nTempMagn):(nT+nTempMagn) ), zJ )
         END IF
      END IF
!------------------------- END PLOTs -------------------------------------!




c print out the main VAN VLECK SUSCEPTIBILITY TENSOR, its main values and main axes:
      Write(6,'(/)')
      Write(6,'(111A)') ('-',i=1,110),'|'
      Write(6,'(25X,A,15x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR '//
     &                         'FOR the  X=dM/dH  model,  '//
     &                         'in cm3*K/mol','|'
      Write(6,'(111A)') ('-',i=1,110),'|'
      Write(6,'(A)') '     T(K)   |   |          Susceptibility '//
     &               'Tensor      |    Main Values  |           '//
     &               '    Main Axes             |'
      Do iT=1,nT
        jT=iT+nTempMagn
        info=0
        wt=0.0_wp
        zt=0.0_wp
        Call DIAG_R2( XTtens_dMdH(1:3,1:3,jT) ,3,info,wt,zt)
        Write(6,'(A)') '------------|---|'//
     &                 '------- x --------- y --------- z ---|'//
     &                 '-----------------|'//
     &                 '------ x --------- y --------- z ----|'
        Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                 '            | x |',
     &                  (XTtens_dMdH(1,j,jT),j=1,3),
     &                 ' |  X:',wt(1),'|',(zt(j,1),j=1,3),'|'
        Write(6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),
     &                             '| y |',
     &                  (XTtens_dMdH(2,j,jT),j=1,3),
     &                 ' |  Y:',wt(2),'|',(zt(j,2),j=1,3),'|'
        Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                 '            | z |',
     &                  (XTtens_dMdH(3,j,jT),j=1,3),
     &                 ' |  Z:',wt(3),'|',(zt(j,3),j=1,3),'|'
      End Do
      Write(6,'(111A)') ('-',i=1,110),'|'




      Write(6,'(/)')
      Write(6,'(111A)') ('-',i=1,110),'|'

      Write(6,'(25X,A,15x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR '//
     &                         'FOR the  X = M/H  model,  '//
     &                         'in cm3*K/mol','|'
      Write(6,'(111A)') ('-',i=1,110),'|'
      Write(6,'(A)') '     T(K)   |   |          Susceptibility '//
     &               'Tensor      |    Main Values  |           '//
     &               '    Main Axes             |'
      Do iT=1,nT
        jT=iT+nTempMagn
        info=0
        wt=0.0_wp
        zt=0.0_wp
        Call DIAG_R2( XTtens_MH(1:3,1:3,jT) ,3,info,wt,zt)
        Write(6,'(A)') '------------|---|'//
     &                 '------- x --------- y --------- z ---|'//
     &                 '-----------------|'//
     &                 '------ x --------- y --------- z ----|'
        Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                 '            | x |',
     &                  (XTtens_MH(1,j,jT),j=1,3),
     &                 ' |  X:',wt(1),'|',(zt(j,1),j=1,3),'|'
        Write(6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),
     &                             '| y |',
     &                  (XTtens_MH(2,j,jT),j=1,3),
     &                 ' |  Y:',wt(2),'|',(zt(j,2),j=1,3),'|'
        Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                 '            | z |',
     &                  (XTtens_MH(3,j,jT),j=1,3),
     &                 ' |  Z:',wt(3),'|',(zt(j,3),j=1,3),'|'
      End Do
      Write(6,'(111A)') ('-',i=1,110),'|'




!=======================================================================
      Call mma_deallocate(WEX0)
      Call mma_deallocate(WEX1)
      Call mma_deallocate(WEX2)
      Call mma_deallocate(WL0)
      Call mma_deallocate(WL1)
      Call mma_deallocate(WL2)
      Call mma_deallocate(WR0)
      Call mma_deallocate(WR1)
      Call mma_deallocate(WR2)

      Call mma_deallocate(ZL0)
      Call mma_deallocate(ZR0)
      Call mma_deallocate(ZL1)
      Call mma_deallocate(ZR1)
      Call mma_deallocate(ZL2)
      Call mma_deallocate(ZR2)
      Call mma_deallocate(SL0)
      Call mma_deallocate(SR0)
      Call mma_deallocate(SL1)
      Call mma_deallocate(SR1)
      Call mma_deallocate(SL2)
      Call mma_deallocate(SR2)
      Call mma_deallocate(ML0)
      Call mma_deallocate(MR0)
      Call mma_deallocate(ML1)
      Call mma_deallocate(MR1)
      Call mma_deallocate(ML2)
      Call mma_deallocate(MR2)

      Call mma_deallocate(ZEX0)
      Call mma_deallocate(ZEX1)
      Call mma_deallocate(ZEX2)
      Call mma_deallocate(ZT0)
      Call mma_deallocate(ZT1)
      Call mma_deallocate(ZT2)
      Call mma_deallocate(SEX0)
      Call mma_deallocate(SEX1)
      Call mma_deallocate(SEX2)
      Call mma_deallocate(MEX0)
      Call mma_deallocate(MEX1)
      Call mma_deallocate(MEX2)
      Call mma_deallocate(ST0)
      Call mma_deallocate(ST1)
      Call mma_deallocate(ST2)
      Call mma_deallocate(MT0)
      Call mma_deallocate(MT1)
      Call mma_deallocate(MT2)
      Call mma_deallocate(XTM_MH)
      Call mma_deallocate(XTM_dMdH)
      Call mma_deallocate(XTtens_MH)
      Call mma_deallocate(XTtens_dMdH)

      Call mma_deallocate(ZRT0)
      Call mma_deallocate(ZLT0)
      Call mma_deallocate(ZRT1)
      Call mma_deallocate(ZLT1)
      Call mma_deallocate(ZRT2)
      Call mma_deallocate(ZLT2)
      Call mma_deallocate(MRT0)
      Call mma_deallocate(MLT0)
      Call mma_deallocate(SRT0)
      Call mma_deallocate(SLT0)
      Call mma_deallocate(MRT1)
      Call mma_deallocate(MLT1)
      Call mma_deallocate(SRT1)
      Call mma_deallocate(SLT1)
      Call mma_deallocate(MRT2)
      Call mma_deallocate(MLT2)
      Call mma_deallocate(SRT2)
      Call mma_deallocate(SLT2)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Roland Lindh                                     *
************************************************************************
      SubRoutine Start6(FName,LuOrb,CMO,mBB,nD,EOrb,OccNo,mmB)
************************************************************************
*                                                                      *
*     purpose: Generate constrained orbitals from INPORB               *
*                                                                      *
*     called from: SOrb                                                *
*                                                                      *
************************************************************************
      use SpinAV
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "file.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Character FName*(*), Line*62
      Integer nTmp(8), nIF(8), nRASO(8), nBD(8), nZero(8), nHoles(8)
      Integer nSsh(8), nSsh_ab(8)
#include "dcscf.fh"
* Pam 2012 Changed VECSORT arg list, need dummy array:
      Integer iDummy(1)
      Real*8 CMO(mBB,nD), EOrb(mmB,nD), OccNo(mmB,nD)
      Integer, Dimension(:), Allocatable:: IndT, ID_vir
      Real*8, Allocatable:: Da(:,:)
      Integer, Allocatable:: Match(:,:)
      Real*8, Dimension(:), Allocatable:: Corb, SAV, SLT, SQ
      Real*8 Dummy(1)
************************************************************************
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Erest_xc=0.0d0
*
      If(.not.DoCholesky .or. DoLDF) then
       write(6,*)
       write(6,*) ' ERROR in Constrained SCF: problem in start6.'
       write(6,*) '*** Constrained NOs implemented only with CD or RI.'
       write(6,*) '*** Use Cholesky or RICD in Seward and rerun! *****'
       Call Abend
      Endif
*
      Do iSym=1,nSym
         nDiff_ab=nOcc(iSym,1)-nOcc(iSym,2)
         If (nDiff_ab .lt. 0) Then
            write(6,*)
            write(6,*) ' ERROR in Constrained SCF: problem in start6.'
            write(6,*) '*** #alpha < #beta not permitted in CNOs    ***'
            write(6,*) '*** Change SCF input accordingly and rerun! ***'
            Call Abend
         EndIf
         nHoles(iSym)=nDiff_ab
      End Do
*
      write(6,*) ' -------------------------------------------------'
      If (Do_SpinAV) Then
       write(6,*)' Spin-averaged wavelets (+/-) '
      Else
       write(6,*)' Configuration of the constrained spins (up/down) '
      EndIf
      write(6,*) ' -------------------------------------------------'
      Do iSym=1,nSym
         write(6,'(1X,A,I1)') ' sym: ',iSym
         Line(1:14)='         (+) '
         k=15
         Do j=1,nConstr(iSym)
            If (indxC(j,1,iSym).eq.1) Then
               If (Do_SpinAV) Then
                  Line(k:k+2)=' + '
               Else
                  Line(k:k+2)=' u '
               EndIf
            ElseIf (indxC(j,1,iSym).eq.2) Then
               If (Do_SpinAV) Then
                  Line(k:k+2)=' - '
               Else
                  Line(k:k+2)=' d '
               EndIf
            Else
               Line(k:k+2)='   '
            EndIf
            k=k+3
         End Do
         write(6,*) Line(1:k-1)
         Line(1:14)='         (-) '
         k=15
         Do j=1,nConstr(iSym)
            If (indxC(j,2,iSym).eq.1) Then
               If (Do_SpinAV) Then
                  Line(k:k+2)=' + '
               Else
                  Line(k:k+2)=' u '
               EndIf
            ElseIf (indxC(j,2,iSym).eq.2) Then
               If (Do_SpinAV) Then
                  Line(k:k+2)=' - '
               Else
                  Line(k:k+2)=' d '
               EndIf
            Else
               Line(k:k+2)='   '
            EndIf
            k=k+3
         End Do
         write(6,*) Line(1:k-1)
      End Do
      write(6,*) ' -------------------------------------------------'
*
      Lu_=LuOrb
      Call mma_Allocate(IndT,nnB,Label='IndT')
      If (isHDF5) Then
         Call RdVec_HDF5(fileorb_id,'COEI',nSym,nBas,
     &                   CMO,OccNo,EOrb,IndT)
      Else
         Call RdVec_(FName,Lu_,'COEI',0,nSym,nBas,nOrb,
     &               CMO,Dummy,
     &               OccNo,Dummy,
     &               EOrb,Dummy,
     &               IndT,VTitle,1,iErr,iWFtype)
      End If
      Call RdTwoEnrg(Lu_,E_nondyn)
      Call VecSort(nSym,nBas,nBas,CMO,OccNo,IndT,0,iDummy,iErr)
      indx=1
      Do iSym=1,nSym
         nZero(iSym)=0
         nTmp(iSym)=0
         nIF(iSym)=0
         nRASO(iSym)=0
         nDiff_ab=0
         Do iBas=1,nBas(iSym)
            If(IndT(indx).eq.1 .or. IndT(indx).eq.2) Then
               nIF(iSym)=nIF(iSym)+1 ! froz + inac orbitals
            End If
            If(IndT(indx).eq.3) Then ! a trick for odd number of
               nIF(iSym)=nIF(iSym)+1  ! electrons (place them in RAS1)
               nDiff_ab=nDiff_ab+1
            End If
            If(IndT(indx).gt.3 .and. IndT(indx).lt.6) Then
               nRASO(iSym)=nRASO(iSym)+1
            End If
            If(IndT(indx).eq.7) Then
               nTmp(iSym)=nTmp(iSym)+1
            End If
            indx=indx+1
         End Do
         If (nRASO(iSym).ne.2*nConstr(iSym)) Then
            write(6,*) ' ERROR in Constrained SCF: problem in start6.'
            write(6,*) ' Detected inconsistency between # of partially',
     &'occupied orbitals and # of constraints. Sym: ',iSym
            Call Abend
         EndIf
         If (nHoles(iSym).ne.nDiff_ab) Then
            write(6,*) ' ERROR in Constrained SCF: problem in start6.'
            write(6,*) ' Detected inconsistency between # of excess',
     &'alpha orbitals and # of RAS1 orbitals. Sym: ',iSym
            Call Abend
         EndIf
         If(nOrb(iSym).gt.nBas(iSym)-nTmp(iSym)) Then
            nOrb(iSym)=nBas(iSym)-nTmp(iSym)
            nDel(iSym)=nTmp(iSym)
         End If
      End Do
*
      Call TrimCMO(CMO,CMO,nSym,nBas,nOrb)
      Call TrimEor(EOrb,EOrb,nSym,nBas,nOrb)
      Call mma_deallocate(IndT)
*
      Call Setup()
*
      Call Izero(nBD,nSym)
      Do iSym=2,nSym
         nBD(iSym) = nBD(iSym-1)
     &             + nBas(iSym-1)*(nBas(iSym-1)+1)/2
      End Do
      Call mma_allocate(Da,nBT,2,Label='Da')
      Da(:,:)=Zero
      Call mma_allocate(Match,2,MxConstr,Label='Match')
      Call mma_allocate(Corb,MaxBas,Label='Corb')
*
      If (Do_SpinAV) call mma_allocate(SAV,2*MaxBas**2,Label='SAV')
*
      iOff=1
      jOff=0
      Do iSym=1,nSym
         call dcopy_(nBas(iSym)*nOrb(iSym),CMO(iOff,1),1,CMO(iOff,2),1)
         call dcopy_(nOrb(iSym),EOrb(1+jOff,1),1,EOrb(1+jOff,2),1)
         lOcc=1+jOff+nIF(iSym)
         call dcopy_(nRASO(iSym),OccNo(lOcc,1),1,OccNo(1,2),1)
         Call BestMatch(nConstr(iSym),nRASO(iSym),OccNo(1,2),Match,
     &                  MxConstr)
         Do i=1,nConstr(iSym)
            k=Match(1,i) ! (+) wavelet
            jOcc=jOff+nIF(iSym)+k
            xOkk=OccNo(jOcc,1)/2.0d0
            kc=iOff+nBas(iSym)*(nIF(iSym)+k-1)
            l=Match(2,i)  ! (-) wavelet
            iOcc=jOff+nIF(iSym)+l
            yOkk=OccNo(iOcc,1)/2.0D0
            xnorm=sqrt(abs(xOkk)+abs(yOkk)) ! ensures correct normaliz
            lc=iOff+nBas(iSym)*(nIF(iSym)+l-1)
            xOkk=sqrt(abs(xOkk))/xnorm
            yOkk=sqrt(abs(yOkk))/xnorm
            If (Do_SpinAV) Then
               kkc=1+nBas(iSym)*(k-1)
               llc=1+nBas(iSym)*(nConstr(iSym)+l-1)
               call dcopy_(nBas(iSym),CMO(kc,1),1,SAV(kkc),1)
               call dcopy_(nBas(iSym),CMO(lc,1),1,SAV(llc),1)
               call dscal_(nBas(iSym),yOkk,SAV(kkc),1)
               call dscal_(nBas(iSym),xOkk,SAV(llc),1)
               call dcopy_(nBas(iSym),SAV(kkc),1,Corb,1)
               call dcopy_(nBas(iSym),CMO(kc,1),1,SAV(kkc),1)
               Call daxpy_(nBas(iSym),-1.0d0,SAV(llc),1,SAV(kkc),1)
               Call daxpy_(nBas(iSym),1.0d0,Corb,1,SAV(llc),1)
            EndIf
            call dscal_(nBas(iSym),xOkk,CMO(kc,1),1)
            call dscal_(nBas(iSym),yOkk,CMO(lc,1),1)
            call dcopy_(nBas(iSym),CMO(lc,1),1,Corb,1)
            Call daxpy_(nBas(iSym), 1.0d0,CMO(kc,1),1,Corb,1)
            Call daxpy_(nBas(iSym),-1.0d0,CMO(kc,1),1,CMO(lc,1),1)
            call dscal_(nBas(iSym),-1.0d0,CMO(lc,1),1)
            call dcopy_(nBas(iSym),Corb,1,CMO(kc,1),1)
         End Do
         jc=1
         kc=nConstr(iSym)+1
         Do i=1,nConstr(iSym)
            l=Match(indxC(i,2,iSym),i)
            lc1=iOff+nBas(iSym)*(nIF(iSym)+l-1)
            lc2=iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym)+jc-1)
            call dcopy_(nBas(iSym),CMO(lc1,1),1,CMO(lc2,2),1)
            k=Match(indxC(i,1,iSym),i)
            kc1=iOff+nBas(iSym)*(nIF(iSym)+k-1)
            kc2=iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym)+kc-1)
            call dcopy_(nBas(iSym),CMO(kc1,1),1,CMO(kc2,2),1)
            jc=jc+1
            kc=kc+1
         End Do
         kc=nConstr(iSym)+1
         Do i=1,nConstr(iSym)
            ic1=iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym)+i-1)
            ic2=iOff+nBas(iSym)*(nIF(iSym)+kc-1)
            call dcopy_(nBas(iSym),CMO(ic1,2),1,CMO(ic2,1),1)
            kc1=iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym)+kc-1)
            kc2=iOff+nBas(iSym)*(nIF(iSym)+i-1)
            call dcopy_(nBas(iSym),CMO(kc1,2),1,CMO(kc2,1),1)
            kc=kc+1
         End Do
         kc=nConstr(iSym)+1  ! wavelets in virt space
         If (Do_SpinAV) Then
            Do i=1,nConstr(iSym)
               k=Match(1,i)
               kks=1+nBas(iSym)*(k-1)
               l=Match(2,i)
               lls=1+nBas(iSym)*(nConstr(iSym)+l-1)
               mOff=iOff+nBas(iSym)*(nIF(iSym)+kc-1)
               kk=indxC(i,1,iSym)
               If (kk.eq.1) Then ! => (+) wavelet is in alpha
                  ipMK=mOff
                  ipML=mOff-nBas(iSym)*nHoles(iSym)
                  call dcopy_(nBas(iSym),SAV(kks),1,CMO(ipMK,1),1)
                  call dcopy_(nBas(iSym),SAV(lls),1,CMO(ipML,2),1)
               ElseIf (kk.eq.2) Then
                  ipMK=mOff-nBas(iSym)*nHoles(iSym)
                  ipML=mOff
                  call dcopy_(nBas(iSym),SAV(kks),1,CMO(ipMK,2),1)
                  call dcopy_(nBas(iSym),SAV(lls),1,CMO(ipML,1),1)
               Else
                  ipMK=666666  ! avoid compiler wrngs
                  ipML=666666
                  write(6,*) ' Start6: wrong indxC value: ',kk
                  Call Abend()
               EndIf
               kc=kc+1
            End Do
         EndIf
         iOff=iOff+nBas(iSym)*nOrb(iSym)
         jOff=jOff+nOrb(iSym)
      End Do
*
      If (Do_SpinAV) Then
         Call mma_deallocate(SAV)
         Call mma_Allocate(DSc,nBB,Label='DSc')
         DSC(:)=Zero
      EndIf
*
      iOff=1
      lOff=0
      Do iSym=1,nSym
         ipDaa=1+nBD(iSym)
         mAdCMOO=iOff+nBas(iSym)*nIF(iSym)
         Call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nConstr(iSym),
     &                    1.0d0,CMO(mAdCMOO,1),nBas(iSym),
     &                          CMO(mAdCMOO,1),nBas(iSym),
     &                    0.0d0,Da(ipDaa,1),nBas(iSym))
         ipDbb=1+nBD(iSym)
         mAdCMOO=iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym))
         Call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nConstr(iSym),
     &                    1.0d0,CMO(mAdCMOO,2),nBas(iSym),
     &                          CMO(mAdCMOO,2),nBas(iSym),
     &                    0.0d0,Da(ipDbb,2),nBas(iSym))
*
         If (Do_SpinAV) Then
            ipDScc=lOff
            Do j=1,nBas(iSym)
               Do i=1,j
                  ji=j*(j-1)/2+i
                  iDaa=ipDaa-1+ji
                  iDbb=ipDbb-1+ji
                  iDSc=ipDScc+nBas(iSym)*(j-1)+i
                  DSc(iDSc)=0.5d0*(Da(iDaa,1)-Da(iDbb,2))
                  kDSc=ipDScc+nBas(iSym)*(i-1)+j
                  DSc(kDSc)=DSc(iDSc)
               End Do
            End Do
            lOff=lOff+nBas(iSym)**2
         EndIf
*
         Do j=1,nBas(iSym)
            Do i=1,j-1
               ji=j*(j-1)/2+i
               iDaa=ipDaa-1+ji
               Da(iDaa,1)=2.0d0*Da(iDaa,1)
               iDbb=ipDbb-1+ji
               Da(iDbb,2)=2.0d0*Da(iDbb,2)
            End Do
         End Do
         iOff=iOff+nBas(iSym)*nOrb(iSym)
      End Do
*
      Call Cho_X_init(irc,ChFracMem)
      if (irc.ne.0) then
         Call WarningMessage(2,'Start6. Non-zero rc in Cho_X_init.')
         Call Abend
      endif
*----------------------------------------------------------------------*
      Call Get_Fmat_nondyn(Da(:,1),Da(:,2),nBT,.false.)
*----------------------------------------------------------------------*

      Call Cho_X_Final(irc)
      if (irc.ne.0) then
         Call WarningMessage(2,'Start6. Non-zero rc in Cho_X_Final.')
         CALL Abend
      endif
*
      Call mma_deallocate(Da)
      Call mma_deallocate(Corb)
      Call mma_deallocate(Match)
*
      iOff=0
      jOff=0
      Do iSym=1,nSym
         Do iOrb=1,nOcc(iSym,1)
            OccNo(iOrb+iOff,1)=1.0d0
         End Do
         Do iOrb=nOcc(iSym,1)+1,nOrb(iSym)
            OccNo(iOrb+iOff,1)=0.0d0
         End Do
*
         Do iOrb=1,nOcc(iSym,2)
            OccNo(iOrb+iOff,2)=1.0d0
         End Do
         Do iOrb=nOcc(iSym,2)+1,nOrb(iSym)
            OccNo(iOrb+iOff,2)=0.0d0
         End Do
         iOff=iOff+nOrb(iSym)
      End Do
*
      Call mma_allocate(SLT,nBT,Label='SLT')
      isymlbl=1
      Call RdOne(irc,6,'Mltpl  0',1,SLT,isymlbl)
      If(irc.ne.0) Then
       write(6,*) ' Start6 : error in getting overlap matrix '
       Call Abend
      Endif
      Call s2calc(CMO(1,1),CMO(1,2),SLT,nOcc(1,1),
     &            nOcc(1,2),nBas,nOrb,nSym,s2CNO)

      If (.not.Do_SpinAV) Then
      write(6,'(A,f9.6)')'  Initial value of Total Spin, S(S+1): ',s2CNO
      write(6,*)' -------------------------------------------------'
      EndIf
      write(6,*)
*
*----------------------------------------------------------------------*
*  Virtual space must be orthogonal to the occupied space              *
*----------------------------------------------------------------------*
      If (Do_SpinAV) Then
         Do i=1,nSym
            nOcc(i,1)=nOcc(i,1)+nConstr(i)
            nOcc(i,2)=nOcc(i,2)+nConstr(i)
         End Do
      EndIf
*
      Thrd=1.0d-6
      Do i=1,nSym
         nSsh(i)=nOrb(i)-nOcc(i,1)-nFro(i)
         nSsh_ab(i)=nOrb(i)-nOcc(i,2)-nFro(i)
      End Do
*
      Call mma_allocate(SQ,nBB,Label='SQ')
      ltri=1
      lsq=1
      Do iSym=1,nSym
         Call Square(SLT(ltri),SQ(lsq),1,nBas(iSym),nBas(iSym))
         ltri=ltri+nBas(iSym)*(nBas(iSym)+1)/2
         lsq=lsq+nBas(iSym)**2
      End Do
      Call mma_allocate(ID_vir,nnB,Label='ID_vir')
      Call Cho_ov_Loc(irc,Thrd,nSym,nBas,nOcc(1,1),nZero,
     &                    nZero,nSsh,CMO(1,1),SQ,ID_vir)

      If(irc.ne.0) then
       write(6,*) ' Start6 : error in getting alpha virt MOs '
       Call Abend
      Endif
*
      iOff=1
      Do iSym=1,nSym
         iCMO=iOff+nBas(iSym)*(nFro(iSym)+nOcc(iSym,1))
         Call Ortho_Orb(CMO(iCMO,1),SQ,nBas(iSym),nSsh(iSym),2,.true.)
         iOff=iOff+nBas(iSym)*nOrb(iSym)
      End Do
c      Call ChkOrt(CMO(1,1),nBB,SLT,nnB,Whatever) ! silent
*

      Call Cho_ov_Loc(irc,Thrd,nSym,nBas,nOcc(1,2),nZero,
     &                    nZero,nSsh_ab,CMO(1,2),SQ,iD_vir)

      If(irc.ne.0) then
       write(6,*) ' Start6 : error in getting beta virt MOs '
       Call Abend
      Endif
*
      iOff=1
      Do iSym=1,nSym
         iCMO=iOff+nBas(iSym)*(nFro(iSym)+nOcc(iSym,2))
         Call Ortho_Orb(CMO(iCMO,2),SQ,nBas(iSym),nSsh_ab(iSym),2,
     &                  .true.)
         iOff=iOff+nBas(iSym)*nOrb(iSym)
      End Do
c      Call ChkOrt(CMO(1,2),nBB,SLT,nnB,Whatever) ! silent
*
      If (Do_SpinAV) Then ! reset # of occupied
         Do i=1,nSym
            nOcc(i,1)=nOcc(i,1)-nConstr(i)
            nOcc(i,2)=nOcc(i,2)-nConstr(i)
         End Do
      EndIf
*
      Call mma_deallocate(ID_vir)
      Call mma_deallocate(SQ)
      Call mma_deallocate(SLT)
*
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine Get_Fmat_nondyn(Dma,Dmb,nBDT,DFTX)
      Use Fock_util_global, only: Deco
      use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
      use SpinAV
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Integer nBDT
      Real*8  Dma(nBDT), Dmb(nBDT)
      Logical DFTX
#include "choscf.fh"
      Integer nForb(8,2), nIorb(8,2)
      Real*8, Dimension(:,:), Allocatable:: Dm
      Real*8 E2act(1)
*
      Real*8   Get_ExFac
      External Get_ExFac
      Type (DSBA_Type) FLT(2), KLT(2), POrb(2), PLT(2)
*
#include "dcscf.fh"
*
      nDMat=2
      Do i=1,nSym
         nForb(i,1)=0
         nForb(i,2)=0
      End Do
      If (DFTX) Then
         FactXI=Get_ExFac(KSDFT)-One ! note this trick
      Else
         FactXI=One
      EndIf
*
      Call Allocate_DT(PLT(1),nBas,nBas,nSym,aCase='TRI')
      Call Allocate_DT(PLT(2),nBas,nBas,nSym,aCase='TRI',Ref=PLT(1)%A0)
      If (DFTX) Then
         PLT(1)%A0(:)=Zero
      Else
         PLT(1)%A0(:)= Dma(:) + Dmb(:)
      EndIf
*
      Call Allocate_DT(POrb(1),nBas,nBas,nSym)
      Call Allocate_DT(POrb(2),nBas,nBas,nSym)

      Call mma_allocate(Dm,nBB,2,Label='Dm')
      Call UnFold(Dma,nBDT,Dm(:,1),nBB,nSym,nBas)
      Call UnFold(Dmb,nBDT,Dm(:,2),nBB,nSym,nBas)
*
      If (Do_SpinAV) Then
         If (.not.DECO) Then
           write(6,*) ' Keywords NODE and SAVE are incompatible. '
           write(6,*) ' NODE will be reset to default. '
           DECO=.true.
         EndIf
         Call daxpy_(NBB,-1.0d0,DSc,1,Dm(:,1),1)
         Call daxpy_(NBB, 1.0d0,DSc,1,Dm(:,2),1)
      EndIf
*
      iOff=0
      Do i=1,nSym
         ipDai=1+iOff
         Call CD_InCore(Dm(ipDai,1),nBas(i),Porb(1)%SB(i)%A2,nBas(i),
     &                  nIorb(i,1),1.0d-12,irc)
         If (irc.ne.0) Then
            write(6,*) ' Alpha density. Sym= ',i,'   rc= ',irc
            Call RecPrt('Dm',' ',Dm(ipDai,1),nBas(i),nBas(i))
            Call Abend()
         EndIf
         ipDbi=1+iOff
         Call CD_InCore(Dm(ipDbi,2),nBas(i),Porb(2)%SB(i)%A2,nBas(i),
     &                  nIorb(i,2),1.0d-12,irc)
         If (irc.ne.0) Then
            write(6,*) ' Beta density. Sym= ',i,'   rc= ',irc
            Call RecPrt('Dm',' ',Dm(ipDbi,1),nBas(i),nBas(i))
            Call Abend()
         EndIf
         iOff=iOff+nBas(i)**2
      End Do
*
      Call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI')
      Call Allocate_DT(FLT(2),nBas,nBas,nSym,aCase='TRI')
      FLT(1)%A0(:)=Zero
      FLT(2)%A0(:)=Zero

      Call Allocate_DT(KLT(1),nBas,nBas,nSym,aCase='TRI')
      Call Allocate_DT(KLT(2),nBas,nBas,nSym,aCase='TRI')
      KLT(1)%A0(:)=Zero
      KLT(2)%A0(:)=Zero
*
      dFmat=0.0d0
      Call CHO_LK_SCF(irc,nDMat,FLT,KLT,nForb,nIorb,
     &                Porb,PLT,FactXI,nSCReen,dmpk,dFmat)
      if (irc.ne.0) then
         Call WarningMessage(2,'Start6. Non-zero rc in Cho_LK_scf.')
         CALL Abend
      endif
*
      If (Do_SpinAV) Then
         Call UnFold(Dma,nBDT,Dm(1,1),nBB,nSym,nBas)
         Call UnFold(Dmb,nBDT,Dm(1,2),nBB,nSym,nBas)
         Call daxpy_(NBB,-1.0d0,DSc,1,Dm(1,1),1)
         Call daxpy_(NBB, 1.0d0,DSc,1,Dm(1,2),1)
         Call Fold(nSym,nBas,Dm(1,1),Dma)
         Call Fold(nSym,nBas,Dm(1,2),Dmb)
      EndIf
*
      E2act(1) = 0.5d0*(ddot_(nBDT,Dma,1,FLT(1)%A0,1)
     &         +        ddot_(nBDT,Dmb,1,FLT(2)%A0,1))
      Call GADSum(E2act(1),1)
*
      If (DFTX) Then
         Erest_xc=Erest_xc-E2act(1)
      Else
         E_nondyn=E_nondyn-E2act(1)
      EndIf
*
      Call Deallocate_DT(KLT(2))
      Call Deallocate_DT(KLT(1))
      Call Deallocate_DT(FLT(2))
      Call Deallocate_DT(FLT(1))
      Call mma_deallocate(Dm)
      Call Deallocate_DT(POrb(2))
      Call Deallocate_DT(POrb(1))
      Call Deallocate_DT(PLT(2))
      Call Deallocate_DT(PLT(1))
*
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine RdTwoEnrg(LU,E2act)

      Implicit Real*8 (a-h,o-z)
      Integer LU
      Real*8  E2act

      Logical Exist
      CHARACTER LINE*80

      Call OpnFl('INPORB',LU,Exist)
      If (.Not.Exist) Then
        Write (6,*) 'RdTwoEnrg: INPORB not found!'
        Call Abend()
      End If
      Rewind(LU)
 55   READ(LU,'(A80)',END=888,ERR=888) Line
      If(Line(1:22).ne.'* ACTIVE TWO-EL ENERGY') goto 55
      READ(LU,'(E19.12)',err=888,end=888) E2act

      Close(LU)
      Return
 888  Call SysWarnFileMsg('RdTwoEnrg','INPORB',
     &   'Error during reading INPORB\n','Field not there')
      Call Abend()
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_IODIAG(DIAG,IOPT)
      IMPLICIT NONE
      REAL*8  DIAG(*)
      INTEGER IOPT

      CHARACTER*7 FNAME
      PARAMETER (FNAME = 'CHODIAG')

      CALL CHO_IODIAG_1(DIAG,IOPT,FNAME)

      END
*
      SUBROUTINE CHO_IOCHODIAG(DIAG,IOPT)
      IMPLICIT NONE
      REAL*8  DIAG(*)
      INTEGER IOPT

      CHARACTER*5 FNAME
      PARAMETER (FNAME = 'CDIAG')

      CALL CHO_IODIAG_1(DIAG,IOPT,FNAME)

      END
*
      SUBROUTINE CHO_IODIAG_1(DIAG,IOPT,FNAME)
C
C     Purpose: write/read a copy of diagonal to disk (1st reduced set).
C              The file is opened and closed here.
C              IOPT=1: write
C              IOPT=2: read
C
#include "implicit.fh"
      DIMENSION     DIAG(*)
      CHARACTER*(*) FNAME
#include "cholesky.fh"

      CHARACTER*12 SECNAM
      PARAMETER (SECNAM = 'CHO_IODIAG_1')

      LUNIT = 7
      CALL DANAME(LUNIT,FNAME)
      IF (IOPT.EQ.1 .OR. IOPT.EQ.2) THEN
         LENGTH = NNBSTRT(1)
         IADR   = 0
         CALL DDAFILE(LUNIT,IOPT,DIAG,LENGTH,IADR)
      ELSE   ! error
         WRITE(LUPRI,*) SECNAM,': IOPT out of bounds: ',IOPT
         CALL CHO_QUIT('Error in '//SECNAM,104)
      END IF
      CALL DACLOS(LUNIT)

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
*  Store_Grad
*
*> @brief Store a vector in the gradients file
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Stores a gradient or coupling vector in the gradients file (GRADS).
*> For a gradient use \p iNAC, \p jNAC = 0. For a coupling vector use
*> \p iRoot = 0.
*>
*> @param[in] Grad  Gradient vector to store
*> @param[in] nGrad Length of \p Grad
*> @param[in] iRoot Root number to which the gradient belongs
*> @param[in] iNAC  First root of a coupling vector
*> @param[in] jNAC  Second root of a coupling vector
************************************************************************
      Subroutine Store_Grad(Grad,nGrad,iRoot,iNAC,jNAC)
      Implicit None
#include "real.fh"
#include "stdalloc.fh"
      Integer :: nGrad,iRoot,iNAC,jNAC
      Real*8 :: Grad(nGrad)
      Integer, Dimension(5) :: TOC
      Integer, Dimension(1) :: Length
      Integer, Dimension(:), Allocatable :: i_grad,i_nac
      Integer :: nRoots,nCoup,LuGrad,iAd,iSt,jSt,idx
      Integer, External :: AixRm
      Logical :: Found, BadFile
      Character(Len=5) :: Filename
*
*define _DEBUGPRINT_
*
* Create GRADS file if it does not exist
*
      Call Get_iScalar('Number of roots',nRoots)
      Filename='GRADS'
      LuGrad=20
      Call f_Inquire(Filename,Found)
      If (.Not.Found) Call Create_Grads(Filename,nRoots,nGrad)
*
* Read the header
*
      BadFile=.False.
      Call DaName(LuGrad,Filename)
      iAd=0
      Call iDaFile(LuGrad,2,TOC,Size(TOC),iAd)
      iAd=TOC(1)
      Call iDaFile(LuGrad,2,Length,1,iAd)
      If (Length(1).ne.nRoots) BadFile=.True.
      iAd=TOC(2)
      Call iDaFile(LuGrad,2,Length,1,iAd)
      If (Length(1).ne.nGrad) BadFile=.True.
      If (BadFile) Then
        Call DaClos(LuGrad)
        If (AixRm('GRADS').ne.0) Call Abend()
        Call WarningMessage(1,'Number of roots and/or length of '//
     &       'gradients do not match, re-creating GRADS file')
        Call Create_Grads(Filename,nRoots,nGrad)
        Call DaName(LuGrad,Filename)
        iAd=0
        Call iDaFile(LuGrad,1,TOC,Size(TOC),iAd)
      End If
      nCoup=Max(1,nRoots*(nRoots-1)/2)
      Call mma_Allocate(i_grad,nRoots)
      Call mma_Allocate(i_nac,nCoup)
      iAd=TOC(3)
      Call iDaFile(LuGrad,2,i_grad,nRoots,iAd)
      iAd=TOC(4)
      Call iDaFile(LuGrad,2,i_nac,nCoup,iAd)
*
* Write the gradient or NAC vector
*
      If (iRoot.eq.0) Then
        If ((iNAC.ne.0).and.(jNAC.ne.0)) Then
          iSt=Max(iNAC,jNAC)-1
          jSt=Min(iNAC,jNAC)
          idx=iSt*(iSt-1)/2+jSt
          If (i_nac(idx).eq.0) Then
            i_nac(idx)=TOC(5)
            Call dDaFile(LuGrad,1,Grad,nGrad,TOC(5))
            iAd=0
            Call iDaFile(LuGrad,1,TOC,Size(TOC),iAd)
            iAd=TOC(4)
            Call iDaFile(LuGrad,1,i_nac,nCoup,iAd)
          Else
            iAd=i_nac(idx)
            Call dDaFile(LuGrad,1,Grad,nGrad,iAd)
          End If
        End If
      Else
        idx=iRoot
        If (i_grad(idx).eq.0) Then
          i_grad(idx)=TOC(5)
          Call dDaFile(LuGrad,1,Grad,nGrad,TOC(5))
          iAd=0
          Call iDaFile(LuGrad,1,TOC,Size(TOC),iAd)
          iAd=TOC(3)
          Call iDaFile(LuGrad,1,i_grad,nRoots,iAd)
        Else
          iAd=i_grad(idx)
          Call dDaFile(LuGrad,1,Grad,nGrad,iAd)
        End If
      End If
*
#ifdef _DEBUGPRINT_
      write(6,*) 'iRoot, iNAC, jNAC:',iRoot,iNAC,jNAC
      write(6,*) 'grads:',i_grad
      write(6,*) 'nacs:',i_nac
#endif
      Call DaClos(LuGrad)
      Call mma_Deallocate(i_grad)
      Call mma_Deallocate(i_nac)
*
      End Subroutine Store_Grad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ThrdO(nInter,g,A,e,Fail)
!***********************************************************************
!                                                                      *
! Object: to find the error vector given the gradient, and the Hessian *
!                                                                      *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nInter
real(kind=wp), intent(in) :: g(nInter), A(nInter,nInter)
real(kind=wp), intent(out) :: e(nInter,2)
logical(kind=iwp), intent(out) :: Fail
integer(kind=iwp) :: i, i0, i1, iRC, iStep, iter, iterMx, itmp
real(kind=wp) :: diff, Test
real(kind=wp), parameter :: Thrd = 1.0e-6_wp

i0 = 1
i1 = 2
iter = 0
iStep = 0
Fail = .true.

! Compile the error vector, starting in position 1
! Observe that g is the force and NOT the gradient

e(:,i0) = g(:)
call DPOTRS('U',nInter,1,A,nInter,e(:,i0),nInter,iRC)
if (iRC /= 0) then
  write(u6,*) 'ThrdO(DPOTRS): iRC=',iRC
  call Abend()
end if

call RecPrt(' ThrdO: e(0)',' ',e(:,i0),nInter,1)

iterMx = 40

do
  iStep = iStep+1

  ! Newton-Raphson scheme

  e(:,i1) = g(:)
  call DPOTRS('U',nInter,1,A,nInter,e(:,i1),nInter,iRC)
  if (iRC /= 0) then
    write(u6,*) 'ThrdO(DPOTRS): iRC=',iRC
    call Abend()
  end if

  !call RecPrt(' ThrdO: e',' ',e(:,i1),nInter,1)
  iter = iter+1

  ! Check if the error vectors are self consistent.

  Test = Zero
  do i=1,nInter
    diff = abs(e(i,i0)-e(i,i1))
    if (diff > Test) Test = diff
  end do
  !write(u6,*) iter,diff

  if (iter > iterMx) then
    call WarningMessage(1,'ThrdO: Exceeded max iterations')
    return
  end if

  if (Test < Thrd) then
    ! Copy converged vectors to slot 1
    if (i1 /= 1) e(:,1) = e(:,i1)
    if (iStep == 10) then
      call RecPrt(' ThrdO: e(Final)',' ',e,nInter,1)
      Fail = .false.
      exit
    else
      iter = 0
    end if
  else
    ! If not change vector slot
    itmp = i0
    i0 = i1
    i1 = itmp
    iStep = iStep-1
  end if
end do
if (Fail) then
  call WarningMessage(2,'Error in ThrdO')
  call Abend()
end if

end subroutine ThrdO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine bss_ts1e(n,s,t,v,w,ul,us,clight)
! Evaluate the BSS Hamiltonian matrix and store the transform matrices

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
! w   aka pVp
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: s(n,n), t(n,n), w(n,n), clight
real(kind=wp), intent(inout) :: v(n,n)
real(kind=wp), intent(out) :: ul(n,n), us(n,n)
integer(kind=iwp) :: m, i, j, lwork, info
real(kind=wp), allocatable :: Tr(:,:), Bk(:,:), EL(:,:), ES(:,:), OL(:,:), OS(:,:), Ep(:), E0(:), KC(:,:), tF(:,:), W1(:), tmp(:), &
                              A(:,:), B(:,:), X(:,:), M1(:,:,:)

! Transform to the free-particle Foldy-Wothuysen picture

call mma_allocate(Tr,n,n,label='Tr') !IFG
call mma_allocate(Bk,n,n,label='Back')
call mma_allocate(EL,n,n,label='mEL')
call mma_allocate(ES,n,n,label='mES')
call mma_allocate(OL,n,n,label='mOL')
call mma_allocate(OS,n,n,label='mOS')
call mma_allocate(Ep,n,label='Ep')
call mma_allocate(E0,n,label='E0')
call mma_allocate(KC,n,3,label='KC') !IFG

call XDR_fpFW(n,s,t,v,w,Tr,Bk,EL,ES,OL,OS,Ep,E0,KC(:,1),KC(:,2),KC(:,3),clight)

! Diagonalize to get the X matrix

do i=1,n
  ! add (diagonal) kinetic matrix in fpFW picture
  EL(i,i) = EL(i,i)+E0(i)
  ES(i,i) = ES(i,i)-Ep(i)-clight*clight
end do
m = n+n
lwork = 8*m
call mma_allocate(tF,m,m,label='Fock')
call mma_allocate(W1,m,label='Eig')
call mma_allocate(tmp,lwork,label='Tmp')
do i=1,n
  do j=1,n
    tF(j,i) = EL(j,i)
    tF(j,i+n) = OL(j,i)
    tF(j+n,i) = OS(j,i)
    tF(j+n,i+n) = ES(j,i)
  end do
end do
call dsyev_('V','L',m,tF,m,W1,tmp,lwork,info)
call mma_deallocate(W1)
call mma_deallocate(tmp)
call mma_allocate(A,n,n,label='tmpA')
call mma_allocate(B,n,n,label='tmpB')
call mma_allocate(X,n,n,label='tmpX')
do i=1,n
  do j=1,n
    A(j,i) = tF(j,i+n)
    B(j,i) = tF(j+n,i+n)
  end do
end do
call XDR_dmatinv(A,n)
call dmxma(n,'N','N',B,A,X,One)

! Apply decoupling transformation to the Fock matrix

call dmxma(n,'C','N',X,OS,A,One)
call dmxma(n,'C','N',X,ES,B,One)
call dmxma(n,'N','N',B,X,ES,One)
call dmxma(n,'N','N',OL,X,B,One)
EL(:,:) = EL(:,:)+A(:,:)+B(:,:)+ES(:,:)
call dmxma(n,'C','N',X,X,A,One)
do i=1,n
  A(i,i) = A(i,i)+One
end do
! renormalization matrix
call XDR_dmatsqrt(A,n)
! decoupled electron Fock matrix in moment space (eigenfunction of T matrix)
call dmxma(n,'C','N',A,EL,B,One)
call dmxma(n,'N','N',B,A,v,One)

! Back transform to non-orthogonal basis picture

call dmxma(n,'C','N',Bk,v,B,One)
call dmxma(n,'N','N',B,Bk,v,One)

! Calculate transform matrices in non-orthogonal basis space

call dmxma(n,'N','N',X,A,B,One)
! A/B is the upper/lower part of transformation matrix in fpFW picture
call mma_allocate(M1,n,n,4,label='TmpM') !IFG
call XDR_mkutls(n,A,B,Tr,Bk,KC(:,1),KC(:,2),KC(:,3),ul,us,M1(:,:,1),M1(:,:,2),M1(:,:,3),M1(:,:,4))
call mma_deallocate(M1)

! Free temp memories

call mma_deallocate(Tr)
call mma_deallocate(Bk)
call mma_deallocate(EL)
call mma_deallocate(ES)
call mma_deallocate(OL)
call mma_deallocate(OS)
call mma_deallocate(Ep)
call mma_deallocate(E0)
call mma_deallocate(KC)
call mma_deallocate(tF)
call mma_deallocate(A)
call mma_deallocate(B)
call mma_deallocate(X)

return

end subroutine bss_ts1e

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  CIWEIGHT  := Chirgwin-Couson/Lowdin/inverse-overlap weights of   *
c  *            := full CASSCF vector and residual.                    *
c  *                                                                   *
c  *********************************************************************
      subroutine ciweight_cvb(civec,civbs,civb,citmp,vec5,
     >  orbs,sorbs,orbinv,owrk,gjorb,gjorb2,gjorb3)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension orbs(norb,norb),sorbs(norb,norb)
      dimension orbinv(norb,norb),owrk(norb,norb)
      dimension gjorb(*),gjorb2(*),gjorb3(*),civec(*),civbs(*),
     > civb(*),citmp(*),vec5(*)

      ionmin=max(nel-norb,0)
      ionmax=nbet
      mxrem=norb-ionmin
      mxsng=nel-2*ionmin
      mxasg=nalf-ionmin
      call icomb_cvb(mxsng,mxasg,mxdetcas)
c  Work out number of configurations in CASSCF vector :
      ncnfcas=0
      do 100 ion=ionmin,ionmax
      call icomb_cvb(norb,ion,iretval1)
      call icomb_cvb(norb-ion,nel-2*ion,iretval2)
      ncnfcas=ncnfcas+iretval1*iretval2
100   continue

      k1 = mstackr_cvb(ionmax-ionmin+1)
      k2 = mstackr_cvb(ionmax-ionmin+1)
      k3 = mstackr_cvb(ionmax-ionmin+1)
      k4 = mstackr_cvb(ionmax-ionmin+1)
      k5 = mstackr_cvb(ionmax-ionmin+1)
      k6 = mstackr_cvb(ionmax-ionmin+1)
      k7 = mstacki_cvb(norb+1)
      k8 = mstacki_cvb(norb+1)
      k9 = mstacki_cvb((norb+1)*(nalf+1))
      k10= mstacki_cvb((norb+1)*(nbet+1))
      k11= mstacki_cvb(norb)
      k12= mstacki_cvb(norb)
      k13= mstacki_cvb(norb+1)
      k14= mstacki_cvb(norb+1)
      k15= mstacki_cvb(norb+1)
      k16= mstacki_cvb((norb+1)*(ionmax+1))
      k17= mstacki_cvb(norb)
      k18= mstacki_cvb(norb)
      k19= mstacki_cvb(norb+1)
      k20= mstacki_cvb(norb+1)
      k21= mstacki_cvb(norb+1)
      k22= mstacki_cvb((mxrem+1)*(mxsng+1))
      k23= mstacki_cvb(norb)
      k24= mstacki_cvb(norb)
      k25= mstacki_cvb(norb+1)
      k26= mstacki_cvb(norb+1)
      k27= mstacki_cvb(norb+1)
      k28= mstacki_cvb((mxsng+1)*(mxasg+1))
      k29= mstacki_cvb(norb)
      k30= mstacki_cvb(norb)
      if(mod(iciweights,8).gt.3)then
        k31= mstackr_cvb(ncnfcas)
        k32= mstackr_cvb(ncnfcas)
        k33= mstacki_cvb(mxdetcas)
        k34= mstacki_cvb(mxdetcas)
      else
        k31= 0
        k32= 0
        k33= 0
        k34= 0
      endif
      icivec=nint(civec(1))
      icivbs=nint(civbs(1))
      icivb=nint(civb(1))
      icitmp=nint(citmp(1))
      ivec5=nint(vec5(1))
      call ciweight2_cvb(civec,civbs,civb,citmp,vec5,
     >  orbs,sorbs,orbinv,owrk,gjorb,gjorb2,gjorb3,
     >  w(iaddr_ci(icitmp)),w(iaddr_ci(icivbs)),w(iaddr_ci(icivec)),
     >  w(iaddr_ci(icivb)),w(iaddr_ci(ivec5)),
     >  w(k1),w(k2),w(k3),w(k4),w(k5),w(k6),
     >  iw(k7),iw(k8),iw(k9),iw(k10),iw(k11),iw(k12),
     >  iw(k13),iw(k14),iw(k15),iw(k16),iw(k17),iw(k18),
     >  iw(k19),iw(k20),iw(k21),iw(k22),iw(k23),iw(k24),
     >  iw(k25),iw(k26),iw(k27),iw(k28),iw(k29),iw(k30),
     >  w(k31),w(k32),iw(k33),iw(k34),
     >  ionmin,ionmax,mxrem,mxsng,mxasg,ncnfcas,mxdetcas)
      call mfreer_cvb(k1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine SlStatus(kIter,Energy,rGrad,Ex,nLines,delE,HUpMet,Step_Trunc,Print_Status)
!***********************************************************************
!                                                                      *
! Object:                                                              *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             May '91                                                  *
!***********************************************************************

use Slapaf_Info, only: GrdLbl, GrdMax, iNeg, StpLbl, StpMax, UpMeth
use PrintLevel, only: nPrint
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: kIter, nLines
real(kind=wp), intent(in) :: Energy, rGrad, Ex, delE
character(len=8), intent(in) :: HUpMet
character, intent(in) :: Step_Trunc
logical(kind=iwp), intent(in) :: Print_Status
integer(kind=iwp) :: i, iPrint, iRout, iter, ivv, Lu_file, Lu_out, nvv
character(len=8) :: lNeg
character(len=128), allocatable :: Lines(:)
integer(kind=iwp), external :: isfreeunit

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 52
iPrint = nPrint(iRout)

call mma_allocate(Lines,[-1,nLines],Label='Lines')

! Pick up previous energy

if (kIter == 1) then
  Lines(:) = ' '
  iter = 1
  write(Lines(-1),'(A)') '                       Energy     Grad      Grad              Step                 Estimated   '// &
                         'Geom       Hessian'
  write(Lines(0),'(A)') 'Iter      Energy       Change     Norm      Max    Element    Max     Element     Final Energy Update '// &
                        'Update   Index'
else
  call Get_cArray('Slapaf Info 3',Lines,(nLines+2)*128)
  ! Find first blank line
  iter = kIter
end if

if (iter > nLines) then
  call WarningMessage(2,'Status: iter > nLines')
  write(u6,*) 'iter,nLines=',iter,nLines
  call abend()
else if (iter < 1) then
  call WarningMessage(2,'Status: iter < 1')
  call abend()
end if

write(lNeg,'(I3)') iNeg(1)
if (iNeg(2) /= iNeg(1)) then
  if (iNeg(2) > 99) then
    write(lNeg(4:8),'("(",I3,")")') iNeg(2)
  else if (iNeg(2) > 9) then
    write(lNeg(4:7),'("(",I2,")")') iNeg(2)
  else
    write(lNeg(4:6),'("(",I1,")")') iNeg(2)
  end if
end if
write(Lines(iter),100) iter,Energy,delE,rGrad,GrdMax,GrdLbl,StpMax,Step_Trunc,StpLbl,Ex,UpMeth,HUpMet,lNeg
!                                                                      *
!***********************************************************************
!                                                                      *
Lu_file = isfreeunit(8)

! Turn off updating the structure file during numerical integrations steps.

nvv = 1
if (Print_Status) nvv = 2
do ivv=1,nvv
  if (ivv == 1) then
    Lu_out = u6
  else
    call Molcas_Open(Lu_File,'STRUCTURE')
    Lu_out = Lu_file
  end if

  if ((ivv == 2) .or. (iPrint >= 5)) then
    write(Lu_out,*)
    write(Lu_out,'(A)') '******************************************************************************************************'// &
                        '****************'
    write(Lu_out,'(A)') '*                                    Energy Statistics for Geometry Optimization                      '// &
                        '               *'
    write(Lu_out,'(A)') '******************************************************************************************************'// &
                        '****************'
    do i=-1,iter
      write(Lu_out,'(A118)') Lines(i)
    end do
    write(Lu_out,*)
  end if
  if (ivv == 2) close(Lu_file)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call Put_cArray('Slapaf Info 3',Lines(-1),(nLines+2)*128)
call mma_deallocate(Lines)

return

100 format(I3,F16.8,F12.8,2(F9.6,1X),A8,F9.6,A1,1X,A8,F16.8,1X,A,1X,A,1X,A)

end subroutine SlStatus

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  ExpKap
!
!> @brief Compute an orbital rotation matrix from the rotation parameters
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Computes the orbital rotation matrix corresponding to the parametrized
!> form as an antisymmetric matrix, i.e. its exponential.
!> The input parameters \p kapOV are the unique elements of the occupied-virtual
!> block of each symmetry.
!>
!> @param[in]  kapOV  Parameters of the antisymmetric matrix
!> @param[in]  nkapOV number of elements in kapOV
!> @param[out] U      Unitary matrix to transform old CMOs
!> @param[in]  nOcc   Number of occupied orbitals (not including frozen) in each symmetry
!***********************************************************************

#define EXP_QNEXT 1
#define EXP_SERIES 2
#define EXP_SVD 3
#define EXP_FULL 4
#define _EXP_ EXP_SVD
subroutine ExpKap(kapOV,nKapOV,U,nOcc)

use InfSCF, only: nFro, nOFs, nOrb, nSym, TimFld
use Constants, only: Zero, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nKapOV, nOcc(8)
real(kind=wp), intent(in) :: kapOV(nkapOV)
real(kind=wp), intent(out) :: U(nOFS)
integer(kind=iwp) :: iKap, iSym, iU, j, jU, mOrb, mVir
logical(kind=iwp) :: use_svd
real(kind=wp) :: Cpu1, Cpu2, theta, Tim1, Tim2, Tim3
real(kind=wp), parameter :: Thrs = 1.0e-14_wp

theta = Pi
#if ( _EXP_ == EXP_QNEXT || _EXP_ == EXP_SERIES )
! If using an expansion, fall back to SVD for large displacements
use_svd = .false.
do j=1,nKapOV
  if (abs(KapOV(j)) > Pi) then
    use_svd = .true.
    exit
  end if
end do
#elif ( _EXP_ == EXP_FULL )
use_svd = .false.
#elif ( _EXP_ == EXP_SVD )
use_svd = .true.
#endif
call Timing(Cpu1,Tim1,Tim2,Tim3)

iU = 1
iKap = 1
U(:) = Zero

do iSym=1,nSym
  mOrb = nOrb(iSym)-nFro(iSym)
  mVir = mOrb-nOcc(iSym)

  if (mVir*nOcc(iSym) == 0) cycle

  jU = iU+nOcc(iSym)

  do j=1,nOcc(iSym)
    U(jU:jU+mVir-1) = kapOV(iKap:iKap+mVir-1)
    iKap = iKap+mVir
    jU = jU+mOrb
  end do

  if (use_svd) then
    call Exp_SVD(mOrb,nOcc(iSym),U(iU:iU+mOrb**2-1),theta)
  else
#   if ( _EXP_ == EXP_QNEXT )
    call Exp_series(mOrb,nOcc(iSym),U(iU:iU+mOrb**2-1))
#   elif ( _EXP_ == EXP_SERIES )
    call Exp_series2(mOrb,nOcc(iSym),U(iU:iU+mOrb**2-1))
#   elif ( _EXP_ == EXP_FULL )
    call Exp_eig(mOrb,U(iU:iU+mOrb**2-1),theta)
#   endif
  end if

  iU = iU+mOrb**2
end do

do j=1,nOFS
  if (abs(U(j)) < Thrs) U(j) = Zero
end do

call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(10) = TimFld(10)+(Cpu2-Cpu1)

return

end subroutine ExpKap

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!               2000, Valera Veryazov                                  *
!               2014, Thomas Dresselhaus                               *
!***********************************************************************

subroutine MOEvalDer(MOValue,iDir,nMOs,nCoor,CCoor,CMOs,nCMO,DoIt)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer, parameter :: nDrv = 1, mAO = 4
integer(kind=iwp), intent(in) :: iDir, nMOs, nCoor, nCMO, DoIt(nMOs)
real(kind=wp), intent(out) :: MOValue(nCoor*nMOs)
real(kind=wp), intent(in) :: CCoor(3,nCoor), CMOs(nCMO)
integer(kind=iwp) :: I
real(kind=wp), allocatable :: MOTmp(:,:)

call mma_allocate(MOTmp,4,nCoor*nMOs)

call MOEval(MOTmp,nMOs,nCoor,CCoor,CMOs,nCMO,DoIt,nDrv,mAO)

! iDir = 1 then do dX
! iDir = 2 then do dY
! iDir = 3 then do dZ
!write(u6,*) 'iDir:',iDir
if ((iDir > 0) .and. (iDir < 4)) then
  MOValue(:) = MOTmp(iDir,:)
else ! do gradient
  do I=1,nCoor*nMOs
    MOValue(I) = MOTmp(2,I)+MOTmp(3,I)+MOTmp(4,I)
  end do
end if
call mma_deallocate(MOTmp)

return

end subroutine MOEvalDer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine BornMayerBK(iQ_Atoms,BoMaH,BoMaO)
! With the Brdarski-Karlstrom scheme, construct the Born-Mayer parameters.

use qmstat_global, only: CharDi, CharDiQ, iPrint, QuaDi, QuaDiQ
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms
real(kind=wp), intent(out) :: BoMaH(iQ_Atoms), BoMaO(iQ_Atoms)
integer(kind=iwp) :: i, j
real(kind=wp) :: rBdi(2), rdi2
real(kind=wp), allocatable :: rBdiQ(:)
real(kind=wp), parameter :: cjhr = 0.1734_wp ! What is this number?

! The solvent part.

do i=1,2
  rdi2 = Zero
  do j=1,3
    rdi2 = rdi2+QuaDi(j,i)
  end do
  rBdi(i) = sqrt(rdi2/CharDi(i))
end do

! The solute part.

call mma_allocate(rBdiQ,iQ_Atoms,label='rBdiQ')
do i=1,iQ_Atoms
  rdi2 = Zero
  do j=1,3
    rdi2 = rdi2+QuaDiQ(j,i)
  end do
  rBdiQ(i) = sqrt(rdi2/CharDiQ(i))
end do

! Put together.

BoMaH(:) = One/(cjhr*(RBdiQ(:)+rbdi(1)))
BoMaO(:) = One/(cjhr*(RBdiQ(:)+rbdi(2)))
if (iPrint >= 8) then
  write(6,*) '   Born-Mayer parameters.'
  do i=1,iQ_Atoms
    write(6,'(A,i2,A,2(f12.4))') '    Atom ',i,' (H/O):',BoMaH(i),BoMaO(i)
  end do
end if
call mma_deallocate(rBdiQ)

return

end subroutine BornMayerBK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine sortindxi_cvb(n,arrin,indx)
! -- purpose: indexing arrin so that arrin(indx(j)), j=1..n is in
!    ascending numerical order.
!    method is heapsort, see also subroutine hpsort.
! -- taken from numerical recipes, p 233.

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n, arrin(n)
integer(kind=iwp), intent(out) :: indx(n)
integer(kind=iwp) :: i, indxt, ir, j, l, q

do j=1,n
  indx(j) = j
end do
if (n <= 1) return
l = n/2+1
ir = n
do
  if (l > 1) then
    l = l-1
    indxt = indx(l)
    q = arrin(indxt)
  else
    indxt = indx(ir)
    q = arrin(indxt)
    indx(ir) = indx(1)
    ir = ir-1
    if (ir == 1) then
      indx(1) = indxt
      exit
    end if
  end if
  i = l
  j = 2*l
  do while (j <= ir)
    if (j < ir) then
      if (arrin(indx(j)) < arrin(indx(j+1))) j = j+1
    end if
    if (q < arrin(indx(j))) then
      indx(i) = indx(j)
      i = j
      j = 2*j
    else
      j = ir+1
    end if
  end do
  indx(i) = indxt
end do

return

end subroutine sortindxi_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CSFTRA(KEY,CI,AREF)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*4 KEY
      DIMENSION CI(NCONF),AREF(NREF,NREF)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION TMP(MXREF)
      IF(NREF.EQ.1) RETURN
      IF(KEY.EQ.' CSF') THEN
        DO 20 I=1,NREF
          SUM=0.0D00
          DO 10 J=1,NREF
            SUM=SUM+AREF(I,J)*CI(IREFX(J))
10        CONTINUE
          TMP(I)=SUM
20      CONTINUE
      ELSE
        DO 50 I=1,NREF
          SUM=0.0D00
          DO 40 J=1,NREF
            SUM=SUM+AREF(J,I)*CI(IREFX(J))
40        CONTINUE
          TMP(I)=SUM
50      CONTINUE
      END IF
      DO 60 I=1,NREF
        CI(IREFX(I))=TMP(I)
60    CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine contt147 (wrk,wrksize,
     & lunt2o1,lunt2o2,lunt2o3)
c
c     this routine do contributions T14 and T17
c     T14: t1n(a,i) <- sum(me) [ T2o(ae,im) . FIII(e,m)]
c     T17: t1n(a,i) <- sum(e,m>n) [ T2o(ae,mn) . <ie||mn> ]
c
c     1. T1n(a,i)aa <- sum(m,e-aa) [ T2o(a,e,i,m)aaaa . FIII(e,m)aa ]
c     2. T1n(a,i)aa <- sum(m,e-bb) [ T2o(a,e,i,m)abab . FIII(e,m)bb ]
c     3. T1n(a,i)bb <- sum(m,e-bb) [ T2o(a,e,i,m)bbbb . FIII(e,m)bb ]
c     4. T1n(a,i)bb <- sum(m,e-aa) [ T2o(e,a,m,i)abab . FIII(e,m)aa ]
c     5. T1n(a,i)aa <- - sum(e,m>n-aaa) [ T2o(a,e,mn)aaaa  . <mn||ie>aaaa ]
c     6. T1n(a,i)aa <- - sum(e,m,n-bab) [ T2o(a,e,m,n)abab . <mn||ie>abab ]
c     7. T1n(a,i)bb <- - sum(e,m>n-bbb) [ T2o(a,e,mn)bbbb  . <mn||ie>bbbb ]
c     8. T1n(a,i)bb <- + sum(e,m,n-aab) [ T2o(e,a,m,n)abab . <mn||ie>abba ]
c
c     N.B. use and destroy : V1,V2,V3,M1
c     N.B. # of read : 3

       use Para_Info, only: MyRank
#include "ccsd2.fh"
#include "parallel.fh"
#include "wrk.fh"
       integer lunt2o1,lunt2o2,lunt2o3
c
c     help variables
c
       integer posst,rc,ssc
c
c
cpar
      if ((myRank.eq.idbaab).or.(myRank.eq.idaabb).or.
     &    (myRank.eq.idfin)) then
c15.1 read V1(cd,kl) <= T2o(cd,kl)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv10,mapdv1,mapiv1,rc)
      end if
c
c
c
c1    T1n(a,i)aa <- sum(m,e-aa) [ T2o(a,e,i,m)aaaa . FIII(e,m)aa ]
c
cpar
      if (myRank.eq.idbaab) then
c
c1.1  expand V2(a,e,i,m) <= V1(ae,im)
       call expand (wrk,wrksize,
     & 4,4,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c1.2  map V3(a,i,e,m) <= V2(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
c
c1.3  mult M1(a,i) <= V3(a,i,e,m) . FIII(e,m)aa
       call mult (wrk,wrksize,
     & 4,2,2,2,mapdv3,mapiv3,1,mapdf31,mapif31,1,mapdm1,
     &            mapim1,ssc,possm10,rc)
c
c1.4  add t1n(a,i)aa <- M1(a,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdt13,mapit13,1,rc)
c
        end if
c
c
c5    T1n(a,i)aa <-  - sum(e,m>n-aaa) [ T2o(a,e,mn)aaaa  . <mn||ie>aaaa ]
c
cpar
      if (myRank.eq.idfin) then
c
c5.1  expand V2(a,e,mn) <= V1(ae,mn)
       call expand (wrk,wrksize,
     & 4,5,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c5.2  map V3(e,mn,i) <= <ie||mn>aaaa
       call map (wrk,wrksize,
     & 4,4,1,2,3,mapdw11,mapiw11,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
c
c5.3  mult M1(a,i) <= V2(a,e,mn) . V3(e,mn,i)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c5.4  add t1n(a,i)aa <-  - M1(a,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,-1.0d0,mapdm1,1,mapdt13,mapit13,1,rc)
c
        end if
c
c
c
cpar
      if ((myRank.eq.idbaab).or.(myRank.eq.idaabb).or.
     &    (myRank.eq.idfin)) then
c37.1 read V1(cd,kl) <= T2o(cd,kl)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv10,mapdv1,mapiv1,rc)
       end if
c
c
c
c3    T1n(a,i)bb <- sum(m,e-bb) [ T2o(a,e,i,m)bbbb . FIII(e,m)bb ]
c
cpar
      if (myRank.eq.idaabb) then
c
c3.1  expand V2(a,e,i,m) <= V1(ae,im)
       call expand (wrk,wrksize,
     & 4,4,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c3.2  map V3(a,i,e,m) <= V2(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
c
c3.3  mult M1(a,i) <= V3(a,i,e,m) . FIII(e,m)bb
       call mult (wrk,wrksize,
     & 4,2,2,2,mapdv3,mapiv3,1,mapdf32,mapif32,1,mapdm1,
     &            mapim1,ssc,possm10,rc)
c
c3.4  add t1n(a,i)bb <- M1(a,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdt14,mapit14,1,rc)
c
        end if
c
c
c7    T1n(a,i)bb <-  - sum(e,m>n-bbb) [ T2o(a,e,mn)bbbb  . <mn||ie>bbbb ]
c
cpar
      if (myRank.eq.idfin) then
c
c7.1  expand V2(a,e,mn) <= V1(ae,mn)
       call expand (wrk,wrksize,
     & 4,5,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c7.2  map V3(e,mn,i) <= <ie||mn>bbbb
       call map (wrk,wrksize,
     & 4,4,1,2,3,mapdw12,mapiw12,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
c
c7.3  mult M1(a,i) <= V2(a,e,mn) . V3(e,mn,i)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c7.4  add t1n(a,i)bb <- - M1(a,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,-1.0d0,mapdm1,1,mapdt14,mapit14,1,rc)
c
        end if
c
c
c
cpar
      if ((myRank.eq.idbaab).or.(myRank.eq.idaabb).or.
     &    (myRank.eq.idfin)) then
c2468.1 read V1(c,d,k,l) <= T2o(c,d,k,l)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv10,mapdv1,mapiv1,rc)
      end if
c
c
c
c2    T1n(a,i)aa <- sum(m,e-bb) [ T2o(a,e,i,m)abab . FIII(e,m)bb ]
c
cpar
      if (myRank.eq.idaabb) then
c
c2.1  map V3(a,i,e,m) <= V1(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv1,mapiv1,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
c
c2.2  mult M1(a,i) <= V3(a,i,e,m) . FIII(e,m)bb
       call mult (wrk,wrksize,
     & 4,2,2,2,mapdv3,mapiv3,1,mapdf32,mapif32,1,mapdm1,
     &            mapim1,ssc,possm10,rc)
c
c2.3  add t1n(a,i)aa <- M1(a,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdt13,mapit13,1,rc)
c
        end if
c
c
c4    T1n(a,i)bb <- sum(m,e-aa) [ T2o(e,a,m,i)abab . FIII(e,m)aa ]
c
cpar
      if (myRank.eq.idbaab) then
c
c4.1  map V3(a,i,e,m) <= V1(e,a,m,i)
       call map (wrk,wrksize,
     & 4,3,1,4,2,mapdv1,mapiv1,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
c
c4.2  mult M1(a,i) <= V3(a,i,e,m) . FIII(e,m)aa
       call mult (wrk,wrksize,
     & 4,2,2,2,mapdv3,mapiv3,1,mapdf31,mapif31,1,mapdm1,
     &            mapim1,ssc,possm10,rc)
c
c4.3  add t1n(a,i)bb <- M1(a,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdt14,mapit14,1,rc)
c
        end if
c
c
cpar
      if (myRank.eq.idfin) then
c
c6    T1n(a,i)aa <-  - sum(e,m,n-bab) [ T2o(a,e,m,n)abab . <mn||ie>abab ]
c
c6.1  map V3(e,m,n,i) <= <ie||mn>abab
       call map (wrk,wrksize,
     & 4,4,1,2,3,mapdw13,mapiw13,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
c
c6.2  mult M1(a,i) <= V1(a,e,m,n) . V3(e,m,n,i)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv1,mapiv1,1,mapdv3,mapiv3,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c6.3  add t1n(a,i)aa <- - M1(a,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,-1.0d0,mapdm1,1,mapdt13,mapit13,1,rc)
c
c
c
c8    T1n(a,i)bb <- + sum(e,m,n-aab) [ T2o(e,a,m,n)abab . <mn||ie>abba ]
c
c8.1  map V2(a,e,m,n) <= V1(e,a,m,n)
       call map (wrk,wrksize,
     & 4,2,1,3,4,mapdv1,mapiv1,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
c
c8.2  map V3(e,m,n,i) <= <ie||mn>baab
       call map (wrk,wrksize,
     & 4,4,1,2,3,mapdw14,mapiw14,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
c
c8.3  mult M1(a,i) <= V2(a,e,m,n) . V3(e,m,n,i)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c8.4  add t1n(a,i)bb <-  M1(a,i)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdt14,mapit14,1,rc)
c
cpar
        end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 2006  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine SPECIAL(G1,G2,G3,F1,F2,F3,idxG3,nLev,mG3)
! SPECIAL-CASE ROUTINE. DELIVERS G AND F MATRICES FOR A HIGH-SPIN
! OR CLOSED-SHELL SCF CASE.

use sguga, only: LEVEL
use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
use caspt2_module, only: ETA, iSCF, NG3
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: nLev, mG3
real(kind=wp), intent(out) :: G1(nLev,nLev), G2(nLev,nLev,nLev,nLev), G3(mG3), F1(nLev,nLev), F2(nLev,nLev,nLev,nLev), F3(mG3)
integer(kind=byte), intent(out) :: idxG3(6,mG3)
integer(kind=iwp) :: ID, IG3, IND1, IND2, IND3, IT, IT1, IT2, IT3, ITASK, IU, IU1, IU2, IU3, LT, LU, LU1, LU2, LU3, NLEV2, NLEV4, &
                     NTASK
real(kind=wp) :: ESUM, Occ, Val

G1(:,:) = Zero
G2(:,:,:,:) = Zero
G3(:) = Zero
F1(:,:) = Zero
F2(:,:,:,:) = Zero
F3(:) = Zero

ESUM = sum(ETA(1:NLEV))
! ISCF=1 for closed-shell, =2 for hispin
OCC = Two
if (ISCF == 2) OCC = One
do IT=1,nLev
  G1(IT,IT) = OCC
  LT = LEVEL(IT)
  F1(IT,IT) = (ESUM*OCC-ETA(LT))*G1(IT,IT)
end do

! This code can be activated once the subsequent code can handle it.
! As it is now the code process G3 regardless of the setting here.
! If nG3=0 this results in NAN processing. Until this is explicitly
! taken case of this code should remain commented out.
!if (NACTEL == 1) then
!  NG3 = 0
!  return
!end if

do IT=1,nLev
  LT = LEVEL(IT)
  do IU=1,nLev
    LU = LEVEL(IU)
    G2(IT,IT,IU,IU) = G1(IT,IT)*G1(IU,IU)
    if (IU == IT) then
      G2(IT,IT,IU,IU) = G2(IT,IT,IU,IU)-G1(IT,IU)
    else
      G2(IT,IU,IU,IT) = -G1(IT,IT)
    end if
    F2(IT,IT,IU,IU) = (ESUM*OCC-ETA(LT)-ETA(LU))*G2(IT,IT,IU,IU)
    F2(IT,IU,IU,IT) = (ESUM*OCC-ETA(LT)-ETA(LU))*G2(IT,IU,IU,IT)
  end do
end do

!if (NACTEL == 2) then
!  NG3 = 0
!  return
!end if

NLEV2 = NLEV**2
NLEV4 = NLEV**4

iG3 = 0
nTask = NLEV4
! SVC20100908 initialize the series of tasks
call Init_Tsk(ID,nTask)

Outer: do
# ifdef _MOLCAS_MPP_
  if ((NG3-iG3) < NLEV2) exit Outer
# endif

  Inner: do
    if (.not. Rsv_Tsk(ID,iTask)) exit Outer
    IND1 = mod(iTask-1,NLEV2)+1
    IND2 = ((iTask-IND1)/(NLEV2))+1
    if (IND2 <= IND1) exit Inner
  end do Inner

  IT1 = mod(IND1-1,nLev)+1
  IU1 = (IND1-IT1)/nLev+1
  LU1 = LEVEL(IU1)
  IT2 = mod(IND2-1,nLev)+1
  IU2 = (IND2-IT2)/nLev+1
  LU2 = LEVEL(IU2)

  do IT3=1,NLEV
    do IU3=1,NLEV
      IND3 = IT3+nLev*(IU3-1)
      if (IND3 > IND2) cycle
      LU3 = LEVEL(IU3)
      VAL = G1(IT1,IU1)*G1(IT2,IU2)*G1(IT3,IU3)

      ! Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
      ! Add here the necessary Kronecker deltas times 2-body matrix
      ! elements and lower, so we get a true normal-ordered density matrix
      ! element.

      ! <PSI1|E(T1,U1,T2,U2,T3,U3)|PSI2>
      ! = <PSI1|E(T1,U1)E(T2,U2)E(T3,U3)|PSI2>
      ! -D(T3,U2)*(G2(T1,U1,T2,U3)+D(T2,U1)*G1(T1,U3))
      ! -D(T2,U1)*G2(T1,U2,T3,U3)
      ! -D(T3,U1)*G2(T2,U2,T1,U3)

      if (IT3 == IU2) then
        VAL = VAL-G2(IT1,IU1,IT2,IU3)
        if (IT2 == IU1) VAL = VAL-G1(IT1,IU3)
      end if
      if (IT2 == IU1) VAL = VAL-G2(IT1,IU2,IT3,IU3)
      if (IT3 == IU1) VAL = VAL-G2(IT2,IU2,IT1,IU3)

      ! VAL is now =<PSI1|E(IT1,IU1,IT2,IU2,IT3,IU3)|PSI2>
      iG3 = iG3+1
      idxG3(1,iG3) = int(iT1,kind=byte)
      idxG3(2,iG3) = int(iU1,kind=byte)
      idxG3(3,iG3) = int(iT2,kind=byte)
      idxG3(4,iG3) = int(iU2,kind=byte)
      idxG3(5,iG3) = int(iT3,kind=byte)
      idxG3(6,iG3) = int(iU3,kind=byte)
      G3(iG3) = VAL
      F3(iG3) = (ESUM*OCC-ETA(LU1)-ETA(LU2)-ETA(LU3))*VAL

    end do
  end do

  !SVC: The master node now continues to only handle task scheduling,
  !     needed to achieve better load balancing. So it exits from the task
  !     list.  It has to do it here since each process gets at least one
  !     task.

end do Outer

! SVC2010: no more tasks, wait here for the others.
call Free_Tsk(ID)

NG3 = iG3

end subroutine SPECIAL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine unpckhelp8(a,b,dimp,dimef,eadd,noe,bb,dimb)
! this routine does:
! b(ef,_Bb) = a(pe,qf)-a(qf,pe) for symp=symq

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimef, eadd, noe, bb, dimb
real(kind=wp), intent(in) :: a(dimp,dimp)
real(kind=wp), intent(inout) :: b(dimef,dimb)
integer(kind=iwp) :: e, ef

ef = 0
do e=2,noe
  b(ef+1:ef+e-1,bb) = a(eadd+e,eadd+1:eadd+e-1)-a(eadd+1:eadd+e-1,eadd+e)
  ef = ef+e-1
end do

return

end subroutine unpckhelp8

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine gasprwf(isel,NORB,NEL,IREFSM,
     &                  ICONF,ISPIN,CICOEF,kcnf)
************************************************************************
*                                                                      *
*     PURPOSE: PRINT THE WAVEFUNCTION FOR GAS                          *
*                                                                      *
************************************************************************
*                                                                      *
*     calling arguments:                                               *
*     nOrb    : integer                                                *
*               total number of active orbitals                        *
*     nEl     : integer                                                *
*               total number of active electrons                       *
*     iRefSm  : integer                                                *
*               state symmetry                                         *
*     iConf   : array of integer                                       *
*               string information                                     *
*     iSpin   : array of integer                                       *
*               spin coupling information                              *
*     nSm     : array of integer                                       *
*               symmetry per active orbital                            *
*     CiCoef   : array of real*8                                       *
*               incoming CI vector                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*     - updated for integral direct and reaction field calculations    *
*       M.P. Fuelscher, University of Lund, Sweden, 1996               *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)


#include "rasdim.fh"
#include "rasscf.fh"
#include "strnum.fh"
#include "ciinfo.fh"
#include "spinfo.fh"
#include "gugx.fh"
#include "gas.fh"
#include "WrkSpc.fh"
#include "output_ras.fh"
C
      DIMENSION ICONF(*),ISPIN(*)
      DIMENSION CICOEF(*)
      DIMENSION KCNF(NEL)
C
      DIMENSION IWALK(mxAct)
      integer   iSel(*)
      character*120 Line
C
C     print headline
C
      Line(1:16)='      Conf/sym  '
      iOff=16
      iSym=nSm(1)
      Do iorb=1,norb
         if ( nsm(iorb).ne.isym) ioff=ioff+1
         write(line(ioff+iorb:),'(I1)') nsm(iorb)
         if (nsm(iorb).ne.isym) isym=nsm(iorb)
      End do
      iOff=iOff+norb+3
      Line(iOff:iOff+15)='   Coeff Weight'
      Write(LF,'(A)') Line(1:iOff+15)
      Line=' '
C
C     Loop over configuration types
C
      ICSFJP = 0
      ICNBS0 = 0
      IPBAS = 0
      DO 1000 ITYP = 1, NTYP
        IOPEN = ITYP + MINOP - 1
        ICL = (NEL - IOPEN) / 2
C      BASE ADRESS FOR CONFIGURATION OF THIS TYPE
        IF( ITYP .EQ. 1 ) THEN
          ICNBS0 = 1
        ELSE
          ICNBS0 = ICNBS0 + NCNFTP(ITYP-1,IREFSM)*(NEL+IOPEN-1)/2
        END IF
C      BASE ADRESS FOR PROTOTYPE SPIN COUPLINGS
        IF( ITYP .EQ. 1 ) THEN
          IPBAS = 1
        ELSE
          IPBAS = IPBAS + NCSFTP(ITYP-1)*(IOPEN-1)
        END IF
C
C     LOOP OVER NUMBER OF CONFIGURATIONS OF TYPE ITYP AND PROTOTYPE
C     SPIN COUPLINGS
C
        DO 900  IC = 1, NCNFTP(ITYP,IREFSM)
          ICNBS = ICNBS0 + (IC-1)*(IOPEN+ICL)
          DO 800 IICSF = 1,NCSFTP(ITYP)
            ICSFJP = ICSFJP + 1
            ICSBAS = IPBAS + (IICSF-1)*IOPEN
*. Obtain configuration in standard RASSCF form
            IIBOP = 1
            IIBCL = 1
            JOCC  = ICL + IOPEN
            DO KOCC = 0, JOCC-1
              KORB = ICONF(ICNBS+KOCC)
              IF(KORB.LT.0) THEN
*. Doubly occupied orbitals
                KCNF(IIBCL) = ABS(KORB)
                IIBCL = IIBCL + 1
              ELSE
*. Singly occupied orbital
                KCNF(ICL+IIBOP) = KORB
                IIBOP = IIBOP + 1
              END IF
            END DO
*
C     COMPUTE STEP VECTOR
            CALL STEPVEC(KCNF(1),KCNF(ICL+1),ICL,IOPEN,
     &                   ISPIN(ICSBAS),NORB,IWALK)
C     SKIP IT OR PRINT IT?
            COEF=CICOEF(ICSFJP)
            IF(ABS(COEF).LT.PRWTHR) GOTO 800
C     PRINT IT
              iSel(icsfjp) = 1
              Write(Line(1:),'(I8)') icsfjp
              iOff=10
              iSym=nSm(1)
              Do iorb=1,norb
                 If ( nSm(iorb).ne.iSym ) iOff=iOff+1
                 If ( iwalk(iorb).eq.3 ) then
                    Write(Line(iOff+iorb:),'(A1)') '2'
                 Else If (iwalk(iorb).eq.2) then
                    Write(Line(iOff+iorb:),'(A1)') 'd'
                 Else If (iwalk(iorb).eq.1) then
                    Write(Line(iOff+iorb:),'(A1)') 'u'
                 Else If (iwalk(iorb).eq.0) then
                    Write(Line(iOff+iorb:),'(A1)') '0'
                 End If
                 If ( nSm(iorb).ne.iSym ) iSym=nSm(iorb)
              End Do
              iOff=iOff+norb+3
              Write(Line(iOff:),'(2F8.5)') COEF,COEF**2
              Write(LF,'(6X,A)') Line(1:iOff+15)
              Line=' '

800       CONTINUE
900     CONTINUE
1000  CONTINUE

      goto 2000
2000  continue
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Ben Swerts                                             *
************************************************************************
      SubRoutine FragPGrd(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &                    Final,nZeta,la,lb,A,RB,nRys,
     &                    Array,nArr,Ccoor,nOrdOp,Grad,nGrad,
     &                    IfGrad,IndGrd,DAO,mdc,ndc,kOp,lOper,nComp,
     &                    iStabM,nStabM)
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of FAIEMP Projection      *
*         operator integrals.                                          *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolemoment *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by FragMMG                *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Ben Swerts                                               *
*                                                                      *
*     based on PrjGrd                                                  *
************************************************************************
      use Her_RW
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: iOper
      Implicit None
#include "Molcas.fh"
#include "real.fh"
#include "print.fh"
#include "disp.fh"
#include "nsd.fh"
#include "setup.fh"
      Integer  nAlpha,nBeta,nZeta,la,lb,nRys,nArr,nOrdOp,nGrad,mdc,ndc,
     &         nComp,nStabM
      Real*8   Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6),
     &         Zeta(nZeta), ZInv(nZeta), Alpha(nAlpha), Beta(nBeta),
     &         rKappa(nZeta), P(nZeta,3), A(3), RB(3), Grad(nGrad),
     &         Array(nZeta*nArr), Ccoor(3), C(3), TC(3), B(3), TB(3),
     &         DAO(nZeta,(la+1)*(la+2)/2*(lb+1)*(lb+2)/2)
      Integer  iStabM(0:nStabM-1), iDCRT(0:7), lOper(nComp),
     &         iuvwx(4), kOp(2), lOp(4),
     &         IndGrd(3,2), JndGrd(3,4)
      Character*80 Label
      Logical  IfGrad(3,2), JfGrad(3,4), ABeq(3), EQ
      Logical  EnergyWeight
      Integer  i,j,iIrrep,iComp,nElem,ia,ib,iAng,iAO,iBas
      Integer  iRout,iPrint,nSkal,iCar
      Integer  iCent,iCmp,iCnttp,iCurCenter,iCurCnttp,iCurMdc
      Integer  iGamma,iLoc,ip,ipA,ipAxyz,ipB,ipBxyz,ipCxyz,ipF1,ipF2
      Integer  ipF1a,ipF2a,ipIJ,ipK1,ipK2,ipP1,ipP2,ipQ1,iPrim,ipRxyz
      Integer  ipTmp,ipZ1,ipZ2,ipZI1,ipZI2,iS,iSbasis,iSEnd,iShell,iShll
      Integer  iSize,iSlocal,iSstart,iStemp,iStrt,iVec,jAng,jBas
      Integer  jCmp,jCnttp,jPrim,jS,jSbasis,jShell,jShll,jSize
      Integer  jSlocal,ld,lDCRT,LmbdT,mdci,mdcj,mGrad,mVec,mVecAC
      Integer  mVecCB,nac,ncb,nDAO,nDCRT,nDisp,nHer,jAO,maxDensSize
      Integer  nVecAC,nVecCB,iTri,iCnt, jCnt
      Real*8   Fact,DNrm2_
      External DNrm2_
*
*     Statement function for Cartesian index
*
      nElem(i) = (i+1)*(i+2)/2
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*
      iRout = 202
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In FragPGrd: Grad',' ',Grad,1,nGrad)
         Call RecPrt(' In FragPGrd: A',' ',A,1,3)
         Call RecPrt(' In FragPGrd: RB',' ',RB,1,3)
         Call RecPrt(' In FragPGrd: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In FragPGrd: P',' ',P,nZeta,3)
         Call RecPrt(' In FragPGrd: Alpha',' ',Alpha,nAlpha,1)
         Call RecPrt(' In FragPGrd: Beta',' ',Beta,nBeta,1)
         Write (6,*) ' In FragPGrd: la,lb=',' ',la,lb
      End If
*                                                                      *
************************************************************************
*                                                                      *
* Setup the fragment shells
*
      Call Set_Basis_Mode('Fragments')
      Call SetUp_iSD
      Call Nr_Shells(nSkal)
      If(iPrint.ge.99) Then
        write(6,*) 'looping over ',nSkal,' shells'
        write(6,*) 'Shells()%Frag = ',(Shells(i)%Frag,i=1,10)
      End If

*                                                                      *
************************************************************************
*                                                                      *
* Reserve space for the largest possible fragment energy weighted
* density matrix
      maxDensSize = 0
      Do iCnttp = 1, nCnttp
        If(dbsc(iCnttp)%nFragType.gt.0) maxDensSize = Max(maxDensSize,
     &      dbsc(iCnttp)%nFragDens*(dbsc(iCnttp)%nFragDens+1)/2)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
* Loop over all shells belonging to the fragments
*
      nDAO = nElem(la)*nElem(lb)
      iIrrep = 0
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      lOp(1) = iOper(kOp(1))
      lOp(2) = iOper(kOp(2))
*
      iComp = 1
      iCurMdc = 0
c      ! The mdc value of the current fragment placeholder
      iCurCnttp = 0
c      ! The Cnttp of the fragment placeholder
      iCurCenter = 999999
c      ! The index of the fragment in the fragment placeholder list of centers
      iSstart = 0
c      ! The index into the full shells list for the first shell of a fragment
      iSbasis = 0
c      ! The basis function index relative to the start of the fragment
      iSEnd = -1
c      ! Dummy initialize
      Do 1965 iS = 1, nSkal
        iShll  = iSD( 0,iS)
        iAng   = iSD( 1,iS)
        iCmp   = iSD( 2,iS)
        iBas   = iSD( 3,iS)
        iPrim  = iSD( 5,iS)
        iAO    = iSD( 7,iS)
        mdci   = iSD(10,iS)
        iShell = iSD(11,iS)
        iCnttp = iSD(13,iS)
        iCnt   = iSD(14,iS)
        C(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

        iSize = nElem(iAng)
        if(Shells(iShll)%Transf.and.
     &     Shells(iShll)%Prjct ) iSize = 2*iAng+1
        If(Abs(dbsc(iCnttp)%nFragCoor).ne.iCurMdc) Then
* update fragment related quantities
          iCurMdc = Abs(dbsc(iCnttp)%nFragCoor)
          iSstart = iS
          iSend = nSkal
          Do iStemp = iSstart + 1,nSkal
            If(Abs(dbsc(iSD(13,iStemp))%nFragCoor).ne.iCurMdc) Then
              iSend = iStemp - 1
              goto 101
            End If
          End Do
 101      Continue
          iSbasis= 1
          iCurCenter = iCurCenter + 1
          If(iCurCenter.gt.dbsc(iCurCnttp)%nCntr) Then
            iCurCenter = 1
            Do jCnttp = iCurCnttp+1, nCnttp
              If(dbsc(jCnttp)%nFragType.gt.0) Then
                iCurCnttp = jCnttp
                goto 102
              End If
            End Do
 102        Continue
* update the energy weighted density matrix of the current fragment
            EnergyWeight = .true.
            Call MakeDens(dbsc(iCurCnttp)%nFragDens,
     &                    dbsc(iCurCnttp)%nFragEner,
     &                    dbsc(iCurCnttp)%FragCoef,
     &                    dbsc(iCurCnttp)%FragEner,
     &                    EnergyWeight,Array)
           If(iPrint.ge.49) Call TriPrt('Energy weighted fragment dens',
     &        ' ',Array,dbsc(iCurCnttp)%nFragDens)
* include the minus sign of -2eta_i
           Call DScal_(dbsc(iCurCnttp)%nFragDens
     &               *(dbsc(iCurCnttp)%nFragDens+1)/2,
     &                -One,Array,1)
           If(maxDensSize.lt.dbsc(iCurCnttp)%nFragDens*
     &        (dbsc(iCurCnttp)%nFragDens+1)/2) Stop 'maxIJSize'
          End If
        End If
c        write(*,*) '  iShll,iAng,mdci,iShell,iCnttp,iCurMdc,iCurCnttp',
c     &              iShll,iAng,mdci,iShell,iCnttp,iCurMdc,iCurCnttp
c        write(*,*) '  iPrim,iBas =',iPrim,iBas
*
* extra derivative stuff
            iuvwx(3) = dc(mdci)%nStab
            iuvwx(4) = dc(mdci)%nStab
            Call ICopy(6,IndGrd,1,JndGrd,1)
            Do i = 1, 3
               Do j = 1, 2
                 JfGrad(i,j) = IfGrad(i,j)
               End Do
            End Do
*
            nDisp = IndDsp(mdci,iIrrep)
            Do iCar = 0, 2
              JfGrad(iCar+1,3) = .False.
              iCmp = 2**iCar
* always equivalent of pChrg's
              JndGrd(iCar+1,3) = 0
            End Do
            Call ICopy(3,[0],0,JndGrd(1,4),1)
            JfGrad(1,4) = .False.
            JfGrad(2,4) = .False.
            JfGrad(3,4) = .False.
            mGrad = 0
            Do iCar = 1, 3
               Do i = 1, 2
                  If (JfGrad(iCar,i)) mGrad = mGrad + 1
               End Do
            End Do
            If (iPrint.ge.99) Write (6,*) ' mGrad=',mGrad
            If (mGrad.eq.0) Go To 1965
*                                                                      *
************************************************************************
*                                                                      *
* Loop over all other shells belonging to the same fragment
        jSbasis = 1
        Do jS = iSstart, iSend
          jShll  = iSD( 0,jS)
          jAng   = iSD( 1,jS)
          jCmp   = iSD( 2,jS)
          jBas   = iSD( 3,jS)
          jPrim  = iSD( 5,jS)
          jAO    = iSD( 7,iS)
          mdcj   = iSD(10,jS)
          jShell = iSD(11,jS)
          jCnttp = iSD(13,jS)
          jCnt   = iSD(14,jS)
          jSize = nElem(jAng)
          If(Shells(jShll)%Transf.and.
     &       Shells(jShll)%Prjct ) jSize = 2*jAng+1
          B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
c         write(*,*) '    jShll,jAng,mdcj,jShell,jCnttp =',
c    &                    jShll,jAng,mdcj,jShell,jCnttp
c         write(*,*) '    jPrim,jBas =',jPrim,jBas
*                                                                      *
************************************************************************
*                                                                      *
* Create a rectangular matrix sized (iBas*nElem(iAng),jBas*nElem(jAng))
* from the energy weighted density matrix (desymmetrized)
* contains values from iSbasis to iSbasis + iBas*nElem(iAng) - 1
*             and from jSbasis to jSbasis + jBas*nElem(jAng) - 1
           ipIJ = 1 + maxDensSize
c          write(*,*) '    extracting values from',iSbasis,' to',iSbasis
c    &                + iBas*iSize - 1,', and from',jSbasis,' to',
c    &                jSbasis + jBas*jSize - 1
           Do iSlocal = iSbasis, iSbasis + iBas*iSize - 1
             Do jSlocal = jSbasis, jSbasis + jBas*jSize - 1
               iLoc = ipIJ + (jSlocal-jSbasis)*iBas*iSize + iSlocal
     &                - iSbasis
               Array(iLoc) = Array(iTri(iSlocal,jSlocal))
               If(iSlocal.ne.jSlocal) Array(iLoc) = Array(iLoc)/Two
c              write(*,*) 'Filling (',iSlocal-iSbasis+1,',',
c    &           jSlocal-jSbasis+1,') from (',iSlocal,',',jSlocal,')'
             End Do
           End Do
           If(iPrint.ge.99) Call RecPrt('W(KC,LD)',
     &        ' ',Array(ipIJ),iBas*iSize,jBas*jSize)
*                                                                      *
************************************************************************
*                                                                      *
* DCR stuff (iS and jS have always the same symmetry character)
*
          Call DCR(LmbdT,iStabM,nStabM,
     &                   dc(mdci)%iStab,dc(mdci)%nStab,iDCRT,nDCRT)
          Fact = DBLE(nStabM) / DBLE(LmbdT)
*                                                                      *
************************************************************************
*                                                                      *
* Loop over symmetry operations acting on the basis.
*
          Do 1967 lDCRT = 0, nDCRT-1
            lOp(3) = iDCRT(lDCRT)
            lOp(4) = lOp(3)
            Call OA(iDCRT(lDCRT),C,TC)
            Call OA(iDCRT(lDCRT),B,TB)
            If (EQ(A,RB).and.EQ(A,TC)) Go To 1967
*                                                                      *
************************************************************************
*                                                                      *
* Calculate the overlap integral < alpha | is > and its derivative
*
**** Storage
*
            ip = ipIJ + maxDensSize
            ipF1 = ip
            nac = nElem(la)*nElem(iAng)*4
            ip = ip + nAlpha*nac*iPrim
            ipP1 = ip
            ip = ip + 3 * nAlpha*iPrim
            ipZ1 = ip
            ip = ip + nAlpha*iPrim
            ipK1 = ip
            ip = ip + nAlpha*iPrim
            ipZI1 = ip
            ip = ip + nAlpha*iPrim
            If (ip-1.gt.nArr*nZeta) Then
               Write (6,*) '  ip-1.gt.nArr*nZeta(1) in FragPGrd'
               Call Abend()
            End If
*
**** Effective center and exponent
*
            Call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,iPrim,
     &                Alpha,Shells(iShll)%Exp)
            Call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,iPrim,
     &                  A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))
*
**** Overlap and derivative
*
            nHer = ((la+1)+iAng+2)/2
            ipAxyz = ip
            ip = ip + nAlpha*iPrim*3*nHer*(la+2)
            ipCxyz = ip
            ip = ip + nAlpha*iPrim*3*nHer*(iAng+1)
            ipRxyz = ip
            ip = ip + nAlpha*iPrim*3*nHer*(nOrdOp+1)
            ipQ1 = ip
            ip = ip + nAlpha*iPrim*3*(la+2)*(iAng+1)*(nOrdOp+1)
            ipA = ip
            ip = ip + nAlpha*iPrim
            If (ip-1.gt.nArr*nZeta) Then
               Write (6,*) '  ip-1.gt.nArr*nZeta(1b) in FragPGrd'
               Call Abend()
            End If
            ABeq(1) = A(1).eq.TC(1)
            ABeq(2) = A(2).eq.TC(2)
            ABeq(3) = A(3).eq.TC(3)
            Call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*iPrim,
     &                  A,Array(ipAxyz),la+1,HerR(iHerR(nHer)),
     &                  nHer,ABeq)
            Call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*iPrim,
     &                  TC,Array(ipCxyz),iAng,HerR(iHerR(nHer)),
     &                  nHer,ABeq)
            ABeq(1) = .False.
            ABeq(2) = .False.
            ABeq(3) = .False.
            Call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*iPrim,
     &                  Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),
     &                  nHer,ABeq)
            If (iPrint.ge.49) Then
               Write (6,*) ' Array(ipAxyz)=',
     &           DNrm2_(nAlpha*iPrim*3*nHer*(la+2),Array(ipAxyz),1)
               Write (6,*) ' Array(ipCxyz)=',
     &           DNrm2_(nAlpha*iPrim*3*nHer*(iAng+1),Array(ipCxyz),1)
               Write (6,*) ' Array(ipRxyz)=',
     &           DNrm2_(nAlpha*iPrim*3*nHer*(nOrdOp+1),Array(ipRxyz),1)
            End If
            Call Assmbl(Array(ipQ1),
     &                  Array(ipAxyz),la+1,
     &                  Array(ipRxyz),nOrdOp,
     &                  Array(ipCxyz),iAng,
     &                  nAlpha*iPrim,HerW(iHerW(nHer)),nHer)
            iStrt = ipA
            Do iGamma = 1, iPrim
              call dcopy_(nAlpha,Alpha,1,Array(iStrt),1)
              iStrt = iStrt + nAlpha
            End Do
            If (iPrint.ge.49) Write (6,*) ' Array(ipA)=',
     &        DNrm2_(nAlpha*iPrim,Array(ipA),1)
            Call rKappa_Zeta(Array(ipK1),Array(ipZ1),iPrim*nAlpha)
            ld=1
            Call CmbnAC(Array(ipQ1),nAlpha*iPrim,la,iAng,
     &                  Array(ipK1),Array(ipF1),
     &                  Array(ipA),JfGrad(1,1),ld,nVecAC)
            If (iPrint.ge.49) Then
              Write (6,*) ' Array(ipQ1)=',
     &          DNrm2_(nAlpha*iPrim*3*(la+2)*(iAng+1)*(nOrdOp+1),
     &                Array(ipQ1),1)
              Write (6,*) ' Array(ipA)=',
     &          DNrm2_(nAlpha*iPrim,Array(ipA),1)
            End If
            ip = ip - nAlpha*iPrim
     &            * ( 6 + 3*nHer*(la+2) + 3*nHer*(iAng+1)
     &            + 3*nHer*(nOrdOp+1) + 3*(la+2)*(iAng+1)*(nOrdOp+1) +1)
*                                                                      *
************************************************************************
*                                                                      *
* Calculate the overlap integral < js | beta > and its derivative
*
**** Storage
*
            ipF2 = ip
            ncb = nElem(jAng)*nElem(lb)*4
            ip = ip + jPrim*nBeta*ncb
            ipP2 = ip
            ip = ip + 3 * jPrim*nBeta
            ipZ2 = ip
            ip = ip + jPrim*nBeta
            ipK2 = ip
            ip = ip + jPrim*nBeta
            ipZI2 = ip
            ip = ip + jPrim*nBeta
            If (ip-1.gt.nArr*nZeta) Then
              Write (6,*) '  ip-1.gt.nArr*nZeta(2) in FragPGrd'
              Call Abend()
            End If
*
**** Effective center and exponent
*
            Call ZXia(Array(ipZ2),Array(ipZI2),jPrim,nBeta,
     &                Shells(jShll)%Exp,Beta)
            Call SetUp1(Shells(jShll)%Exp,jPrim,Beta,nBeta,
     &                  TB,RB,Array(ipK2),Array(ipP2),Array(ipZI2))
*
**** Overlap and derivative
*
            nHer = (jAng+(lb+1)+2)/2
            ipCxyz = ip
            ip = ip + nBeta*jPrim*3*nHer*(jAng+1)
            ipBxyz = ip
            ip = ip + nBeta*jPrim*3*nHer*(lb+2)
            ipRxyz = ip
            ip = ip + nBeta*jPrim*3*nHer*(nOrdOp+1)
            ipQ1 = ip
            ip = ip + nBeta*jPrim*3*(jAng+1)*(lb+2)*(nOrdOp+1)
            ipB = ip
            ip = ip + nBeta*jPrim
            If (ip-1.gt.nArr*nZeta) Then
              Write (6,*) '  ip-1.gt.nArr*nZeta(2b) in FragPGrd'
              Call Abend()
            End If
            ABeq(1) = TB(1).eq.RB(1)
            ABeq(2) = TB(2).eq.RB(2)
            ABeq(3) = TB(3).eq.RB(3)
            Call CrtCmp(Array(ipZ2),Array(ipP2),jPrim*nBeta,
     &                  TB,Array(ipCxyz),jAng,HerR(iHerR(nHer)),
     &                  nHer,ABeq)
            Call CrtCmp(Array(ipZ2),Array(ipP2),jPrim*nBeta,
     &                  RB,Array(ipBxyz),lb+1,HerR(iHerR(nHer)),
     &                  nHer,ABeq)
            ABeq(1) = .False.
            ABeq(2) = .False.
            ABeq(3) = .False.
            Call CrtCmp(Array(ipZ2),Array(ipP2),jPrim*nBeta,
     &                  Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),
     &                  nHer,ABeq)
            If (iPrint.ge.49) Then
              Write (6,*) ' Array(ipCxyz)=',
     &          DNrm2_(nBeta*jPrim*3*nHer*(jAng+1),Array(ipCxyz),1)
              Write (6,*) ' Array(ipBxyz)=',
     &          DNrm2_(nBeta*jPrim*3*nHer*(lb+2),Array(ipBxyz),1)
              Write (6,*) ' Array(ipRxyz)=',
     &          DNrm2_(nBeta*jPrim*3*nHer*(nOrdOp+1),Array(ipRxyz),1)
            End If
            Call Assmbl(Array(ipQ1),
     &                  Array(ipCxyz),jAng,
     &                  Array(ipRxyz),nOrdOp,
     &                  Array(ipBxyz),lb+1,
     &                  jPrim*nBeta,HerW(iHerW(nHer)),nHer)
            iStrt = ipB
            Do iGamma = 1, jPrim
              call dcopy_(nBeta,Beta,1,Array(iStrt),jPrim)
              iStrt = iStrt + 1
            End Do
            If (iPrint.ge.49) Write (6,*) ' Array(ipB)=',
     &        DNrm2_(jPrim*nBeta,Array(ipB),1)
            Call rKappa_Zeta(Array(ipK2),Array(ipZ2),jPrim*nBeta)
            ld=1
            Call CmbnCB(Array(ipQ1),jPrim*nBeta,jAng,lb,
     &                  Array(ipK2),Array(ipF2),
     &                  Array(ipB),JfGrad(1,2),ld,nVecCB)
            If (iPrint.ge.49) Then
              Write (6,*) ' Array(ipQ1)=',
     &          DNrm2_(jPrim*nBeta*3*(la+2)*(jAng+1)*(nOrdOp+1),
     &                Array(ipQ1),1)
              Write (6,*)' Array(ipB)=',DNrm2_(JPrim*nBeta,Array(ipB),1)
            End If
            ip = ip - nBeta*jPrim
     &            * ( 6 + 3*nHer*(lb+2) + 3*nHer*(jAng+1)
     &            + 3*nHer*(nOrdOp+1) + 3*(lb+2)*(jAng+1)*(nOrdOp+1) +1)
            nac = nElem(la)*nElem(iAng)*nVecAC
            ncb = nElem(jAng)*nElem(lb)*nVecCB
            ipTmp = ip
            ip = ip + Max(nAlpha*Max(iPrim,jBas)*nac,nBeta*ncb*jBas)
            If (ip-1.gt.nArr*nZeta) Then
              Write (6,*) '  ip-1.gt.nArr*nZeta(3) in FragPGrd'
              Call Abend()
            End If
            nac = nElem(la)*nElem(iAng)
            ncb = nElem(jAng)*nElem(lb)
*                                                                      *
************************************************************************
*                                                                      *
* Assemble the calculated quantities and contract
*
* Calculate Contraction over components of the fragment
* orbitals of type <A|iS>coef<jS|B> where we now have in
* Array(ipF1) the cartesian components of <A|iS>, and
* similarily, in Array(ipF2), we have stored the cartesian
* components of <jS|B>. Observe that the fragment orbitals are
* orthonomal atomic orbitals. Hence, the transformation
* to the spherical harmonics has to be for normalized
* spherical harmonics.
*
* nAlpha = i               nElem(la) = a
* nBeta  = j               nElem(lb) = b
* iPrim = k (iBas = K)     nElem(iAng) = c (iSize = C)
* jPrim = l (jBas = l)     nElem(jAng) = d (jSize = D)
*
*-----------From the lefthandside overlap, form iKaC from ikac by
*           1) i,kac -> k,aci
*
            Call DgeTMo(Array(ipF1),nAlpha,nAlpha,
     &                  iPrim*nac*nVecAC,Array(ipTmp),
     &                  iPrim*nac*nVecAC)
*
*-----------2) aciK =  k,aci * k,K (Contract over core orbital)
*
            Call DGEMM_('T','N',
     &                  nac*nVecAC*nAlpha,iBas,iPrim,
     &                  1.0d0,Array(ipTmp),iPrim,
     &                  Shells(iShll)%pCff,iPrim,
     &                  0.0d0,Array(ipF1),nac*nVecAC*nAlpha)
*
*-----------3) a,ciK -> ciKa
*
            Call DgeTMo(Array(ipF1),nElem(la),nElem(la),
     &                  nElem(iAng)*nVecAC*nAlpha*iBas,
     &                  Array(ipTmp),
     &                  nElem(iAng)*nVecAC*nAlpha*iBas)
*
*-----------4) iKa,C = c,iKa * c,C
*
            If(Shells(iShll)%Transf.and.
     &         Shells(iShll)%Prjct ) Then
              Call DGEMM_('T','N',
     &                    nVecAC*nAlpha*iBas*nElem(la),iSize,
     &                    nElem(iAng),
     &                    1.0d0,Array(ipTmp),nElem(iAng),
     &                    RSph(ipSph(iAng)),nElem(iAng),
     &                    0.0d0,Array(ipF1),
     &                    nVecAC*nAlpha*iBas*nElem(la))
            Else
              Call DgeTMo(Array(ipTmp),nElem(iAng),nElem(iAng),
     &                    nVecAC*iBas*nElem(la)*nAlpha,
     &                    Array(ipF1),
     &                    nVecAC*iBas*nElem(la)*nAlpha)
            End If
C what does this do and is it needed? (from PrjGrd)
            Call DgeTMo(Array(ipF1),nVecAC,nVecAC,
     &                  nAlpha*iBas*nElem(la)*iSize,
     &                  Array(ipTmp),
     &                  nAlpha*iBas*nElem(la)*iSize)
            call dcopy_(nVecAC*nAlpha*iBas*nElem(la)*iSize,Array(ipTmp),
     &                 1,Array(ipF1),1)
*
*-----------And (almost) the same thing for the righthand side, form
*           LjDb from ljdb
*           1) jdb,L = l,jdb * l,L
*
            Call DGEMM_('T','N',
     &                  nBeta*ncb*nVecCB,jBas,jPrim,
     &                  1.0d0,Array(ipF2),jPrim,
     &                  Shells(jShll)%pCff,jPrim,
     &                  0.0d0,Array(ipTmp),nBeta*ncb*nVecCB)
*
*-----------2)  j,dbL -> dbL,j
*
            Call DgeTMo(Array(ipTmp),nBeta,nBeta,
     &                  ncb*nVecCB*jBas,Array(ipF2),
     &                  ncb*nVecCB*jBas)
*
*-----------3) bLj,D = d,bLj * d,D
*
            If(Shells(jShll)%Transf.and.
     &         Shells(jShll)%Prjct ) Then
              Call DGEMM_('T','N',
     &                    nElem(lb)*nVecCB*jBas*nBeta,jSize,nElem(jAng),
     &                    1.0d0,Array(ipF2),nElem(jAng),
     &                    RSph(ipSph(jAng)),nElem(jAng),
     &                   0.0d0,Array(ipTmp),nElem(lb)*nVecCB*jBas*nBeta)
            Else
              Call DgeTMo(Array(ipF2),nElem(jAng),nElem(jAng),
     &                    nVecCB*jBas*nElem(lb)*nBeta,
     &                    Array(ipTmp),
     &                    nVecCB*jBas*nElem(lb)*nBeta)
            End If
*
*-----------4) b,LjD -> LjD,b
*
            Call DgeTMo(Array(ipTmp),nElem(lb)*nVecCB,
     &                  nElem(lb)*nVecCB,
     &                  jBas*nBeta*jSize,Array(ipF2),
     &                  jBas*nBeta*jSize)
*
*-----------Next Contract (iKaC)*W(KLCD)*(LjDb) producing ijab
*
            call dcopy_(nZeta*nElem(la)*nElem(lb)*6,[Zero],0,Final,1)
*
            If(iPrint.ge.99) Then
              Call RecPrt('ipF1 (nVecAC x X)',' ',Array(ipF1),
     &          nVecAC,iBas*nAlpha*iSize)
              Call RecPrt('ipF2 (nVecCB x Y)',' ',Array(ipF2),
     &          nVecCB,jBas*nBeta*jSize)
            End If
*
            mVec = 0
            mVecAC = 1
            mVecCB = 1
            Do iCar = 1, 3
              Do iCent = 1, 2
c               write(*,*) 'iCar, iCent = ',iCar,iCent
                If (JfGrad(iCar,iCent)) Then
                  mVec = mVec + 1
                  If (iCent.eq.1) Then
                    mVecAC = mVecAC+1
                    ipF1a = ipF1 + (mVecAC-1) *
     &              nAlpha*jBas*nElem(la)*iSize
                    ipF2a = ipF2
                  Else
                    ipF1a = ipF1
                    mVecCB = mVecCB+1
                    ipF2a = ipF2 + (mVecCB-1) *
     &                      jBas*nBeta*jSize*nElem(lb)
                  End If
            If(iPrint.ge.99) Then
              write(6,*) 'mVecAC, mVecCB = ',mVecAC,mVecCB
              Call RecPrt('ipF1a (nAlpha*aAng x iBas*iSize)',' ',
     &          Array(ipF1a),nAlpha*nElem(la),iBas*iSize)
              Call RecPrt('ipF2a (nBeta*bAng x jBas*jSize)',' ',
     &          Array(ipF2a),nBeta*nElem(lb),jBas*jSize)
            End If
*
               Call FragPCont(Array(ipF1a), nAlpha,iBas,nElem(la),iSize,
     &                        Array(ipF2a), jBas,nBeta,jSize,nElem(lb),
c     &                        Array(ipIJ), Final(1,1,1,mVec), Fact*Half)
     &                        Array(ipIJ), Final(:,:,:,mVec), Fact*Half)
                End If
              End Do !iCent
            End Do !iCar
*
            If (iPrint.ge.49) Then
              Do iVec = 1, mVec
                Write (6,*) iVec,
     &            Sqrt(DNrm2_(nZeta*nElem(la)*nElem(lb),
     &            Final(1,1,1,iVec),1))
              End Do
            End If
            If (iPrint.ge.99) Then
              Write (6,*) ' Result in FragPGrd'
              Do ia = 1, nElem(la)
                Do ib = 1, nElem(lb)
                  Do iVec = 1, mVec
      Write (Label,'(A,I2,A,I2,A,I2,A)')' Final(',ia,',',ib,',',iVec,')'
                    Call RecPrt(Label,' ',Final(1,ia,ib,iVec),
     &                          nAlpha,nBeta)
                  End Do
                End Do
              End Do
            End If
*
*-----------Distribute contributions to the gradient
*
            Call Distg1X(Final,DAO,nZeta,nDAO,mVec,Grad,nGrad,
     &                   JfGrad,JndGrd,iuvwx,lOp)
*
 1967     Continue !lDCRT
          jSbasis = jSbasis + jBas * jSize
        End Do !jS
        iSbasis = iSbasis + iBas * iSize
 1965 Continue !iS
*
* Revert to the valence shells
*
      Call Free_iSD()
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(Zeta)
        Call Unused_real_array(ZInv)
        Call Unused_real_array(rKappa)
        Call Unused_integer(nRys)
        Call Unused_integer_array(lOper)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine OLDFCM(Hess,nQQ,RunOld)
!***********************************************************************
!                                                                      *
!     Object : To read in a force constant matrix from another         *
!              interphase.                                             *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), allocatable, intent(out) :: Hess(:)
integer(kind=iwp), intent(out) :: nQQ
character(len=*), intent(in) :: RunOld
integer(kind=iwp) :: iInter, lHess, nHess
real(kind=wp) :: Energy
character(len=8) :: Method
logical(kind=iwp) :: Found

! Prologue

! Set runfile to be the one according to the character string RUNOLD
call NameRun(RunOld)

! Get the method used in the old calculation
call Get_cArray('Relax Method',Method,8)

! Get the final energy obtained by the last calculation
!call Get_Energy(Energy)
call Get_dScalar('Last energy',Energy)

! Get the number of internal coordinates
call Get_iScalar('No of Internal coordinates',iInter)
if (iInter <= 0) then
  call WarningMessage(2,'OldFCM: iInter <= 0')
  write(u6,*) 'iInter=',iInter
  call Abend()
end if

! Get the force constant matrix
call qpg_dArray('Hess',Found,nHess)
if ((.not. Found) .or. (nHess == 0)) call SysAbendmsg('OldFcm','Did not find:','Hess')

call mma_Allocate(Hess,nHess,Label='Hess')
call get_dArray('Hess',Hess,nHess)

lHess = iInter**2
if (nHess /= lHess) then
  call WarningMessage(2,'OldFCM: nHess /= lHess')
  write(u6,*) 'nHess,lHess=',nHess,lHess
  call Abend()
end if

! Reset runfile to be RUNFILE
call NameRun('#Pop')

! Echo the input information
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,'(6X,A)') 'SLAPAF has been supplied with an old force constant matrix.'
write(u6,'(6X,3A)') 'It is based on ',Method,' calculations.'
write(u6,'(6X,A,F18.10)') 'The final energy was',Energy
call RecPrt(' OldFcm',' ',Hess,iInter,iInter)
#endif

nQQ = iINter

! Epilogue, end
return

end subroutine OLDFCM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Dissoc(xyz,nCntr,mCntr,rMss,Dist,B,lWrite,
     &                  Label,dB,ldB)
      Implicit Real*8 (A-H,O-Z)
************************************************************************
*                                                                      *
*     Object: To evaluate the B matrix elements of an internal         *
*             coordinate corresponding to a dissociation of two        *
*             parts of a molecule.                                     *
*                                                                      *
************************************************************************
#include "real.fh"
      Real*8 rMss(nCntr+mCntr), B(3,nCntr+mCntr), xyz(3,nCntr+mCntr),
     &       dB(3,nCntr+mCntr,3,nCntr+mCntr)
      Logical lWrite, ldB
      Real*8 R(3,2), RM(2)
      Character*8 Label
#include "angstr.fh"
*
*
      call dcopy_(2,[Zero],0,RM,1)
      call dcopy_(6,[Zero],0,R,1)
*
#ifdef _DEBUGPRINT_
      Write (6,*) ' nCntr,mCntr=',nCntr,mCntr
      Call RecPrt(' Masses',' ',rMss,nCntr+mCntr,1)
      Call RecPrt(' xyz',' ',xyz,3,nCntr+mCntr)
#endif
      Do iCntr = 1, nCntr+mCntr
         i=1
         If (iCntr.gt.nCntr) i=2
*        Sum up mass of fragment
         RM(i) = RM(i) + rMss(iCntr)
*        Compute center of mass of the fragment
         Do ix = 1, 3
            R(ix,i) = R(ix,i) + rMss(iCntr) * xyz(ix,iCntr)
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('RM',' ',RM,1,2)
#endif
*
*     Evaluate center of mass of the two parts and the distance between
*
      Dist = Zero
      Do ix=1,3
         R(ix,1) = R(ix,1)/RM(1)
         R(ix,2) = R(ix,2)/RM(2)
         Dist = Dist + (R(ix,1)-R(ix,2))**2
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt(' Center of mass of fragments',' ',R,3,2)
#endif
*
      Dist = Sqrt(Dist)
*
      If (lWrite) Write (6,'(1X,A,A,2(F10.6,A))') Label,
     &   ' : Dissociation distance=',Dist,'/bohr',
     &       Dist*angstr,'/Angstrom'
*
*     Compute the B-matrix
*
      Do iCntr = 1, nCntr+mCntr
         If (iCntr.le.nCntr) Then
            Sign=1.0D0
            i=1
         Else
            Sign=-1.0D0
            i=2
         End If
         Do ix = 1, 3
            If (xyz(ix,iCntr).ne.Zero) Then
               Fact=Sign*rMss(iCntr)/RM(i)
            Else
               Fact=Zero
            End If
            B(ix,iCntr)= Fact* (R(ix,1)-R(ix,2)) / Dist
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('B',' ',B,3,nCntr+mCntr)
#endif
*
*     Compute the Cartesian derivative of the B-Matrix
*
      If (ldB) Then
         Call FZero(dB,(3*(nCntr+mCntr))**2)
         Do iCntr = 1, nCntr+mCntr
            If (iCntr.le.nCntr) Then
               Signi=1.0D0
               i=1
            Else
               Signi=-1.0D0
               i=2
            End If
            Facti=Signi*rMss(iCntr)/RM(i)
*
            Do jCntr = 1, nCntr+mCntr
               If (jCntr.le.nCntr) Then
                  Signj=1.0D0
                  j=1
               Else
                  Signj=-1.0D0
                  j=2
               End If
               Factj=Signj*rMss(jCntr)/RM(j)
*
               Do ix = 1, 3
                  If (xyz(ix,iCntr).ne.Zero) Then
                     dRdri=Facti
                  Else
                     dRdri=Zero
                  End If
                  Do jx = 1, 3
                     If (xyz(jx,jCntr).ne.Zero) Then
                        dRdrj=Factj
                     Else
                        dRdrj=Zero
                     End If
*
                     If (ix.eq.jx) Then
                        dB(ix,iCntr,jx,jCntr)=(dRdri*dRdrj
     &                                    -B(ix,iCntr)*B(jx,jCntr))/Dist
                     Else
                        dB(ix,iCntr,jx,jCntr)=(
     &                                    -B(ix,iCntr)*B(jx,jCntr))/Dist
                     End If
                  End Do
               End Do
*
            End Do
         End Do
#ifdef _DEBUGPRINT_
         Call RecPrt('dB',' ',dB,3*(nCntr+mCntr),3*(nCntr+mCntr))
#endif
      End If
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GETCNF(KCNF,KTYP,K,ICONF,IREFSM,NEL,NTEST)
*
* Obtain configuration number K .
* Occupation in KCNF
* Type in KTYP
*
* Jeppe Olsen , summer of 89
*
      IMPLICIT REAL*8 (A-H,O-Z)
#include "detdim.fh"
#include "spinfo_mclr.fh"
*. General input
      DIMENSION KCNF(*)
*. Output
      INTEGER ICONF(*)
*
*
      ICNFB1 = 1
      ICNFB2 = 1
      KTYP   = 0
      DO 100 JTYP = 1, NTYP
        JOP = JTYP - 1 + MINOP
        JCL = (NEL-JOP)/2
        JOCC = JOP + JCL
*
        NJCNF = NCNATS(JTYP,IREFSM)
        IF(K.GE.ICNFB1.AND.K.LE.ICNFB1+NJCNF-1) THEN
          KREL = K - ICNFB1 + 1
          KADD = (KREL-1)*JOCC
          KTYP = JTYP
          CALL ICOPVE(ICONF(ICNFB2+KADD),KCNF,JOCC)
        END IF
*
        ICNFB1 = ICNFB1 + NJCNF
        ICNFB2 = ICNFB2 + NJCNF*JOCC
  100 CONTINUE
*
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NTEST)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Roland Lindh                                     *
!***********************************************************************

subroutine dens2file(array1,array2,array3,adim,lu,adr,iEmpty,iOpt,iGo,iState,jState)
!***********************************************************************
!   This is the generalized disk interface for TDMs.
!   Some of the parameters and variables are explained here.
!
!   AO_Mode: true if TDMs are in the AO basis, otherwise the TDMs are
!            stored in the basis of the active orbitals only (no sym).
!   iEmpty: the three lowest bits are set if the TDMAB, TSDMAB, and
!           WDMAB, are stored on disk, respectively. That is, for
!           example, if iEmpty=5 the code will write only the first
!           and the last matrix. On read of the second matrix the
!           routine will generate a zero matrix.
!   iOpt: values are 1, or 2, for write and read, respectively.
!   iGo: the three lowest bits are set to tell which matrices are
!        requested. For example, iGo=2, means that only spin-densities
!        are requested.
!
!***********************************************************************

use rassi_aux, only: AO_Mode, CMO1, CMO2, DMAB, Job_Index, mTRA, nasht_save
use stdalloc, only: mma_Allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: adim, lu, iEmpty, iOpt, iGo, iState, jState
real(kind=wp), intent(inout) :: array1(adim), array2(adim), array3(adim)
integer(kind=iwp), intent(inout) :: adr
integer(kind=iwp) :: bdim, IRC, J1, J2, JOB1, JOB1_Old = -1, JOB2, JOB2_Old = -1
real(kind=wp), allocatable :: TRA1(:), TRA2(:)

bdim = adim
if ((.not. AO_Mode) .and. (iOpt == 2)) bdim = nasht_save**2+1
if (bdim > adim) then
  write(u6,*) 'Dens2file: bdim > adim'
  call Abend()
end if

!write(u6,*) 'iState,jState=',iState,jState
if (btest(iGo,0)) then
  if (btest(iEmpty,0)) then
    !if (iOpt == 1) write(u6,*) 'array1=',DDot_(bdim-1,Array1,1,Array1,1),Array1(bdim)
    call ddafile(lu,iOpt,array1,bdim,adr)
  else if (iOpt == 2) then
    array1(:) = Zero
  end if
else if (btest(iEmpty,0)) then
  call ddafile(lu,0,array1,bdim,adr)
end if
if (btest(iGo,1)) then
  if (btest(iEmpty,1)) then
    !if (iOpt == 1) write(u6,*) 'array2=',DDot_(bdim-1,Array2,1,Array2,1),Array2(bdim)
    call ddafile(lu,iOpt,array2,bdim,adr)
  else if (iOpt == 2) then
    array2(:) = Zero
  end if
else if (btest(iEmpty,1)) then
  call ddafile(lu,0,array2,bdim,adr)
end if
if (btest(iGo,2)) then
  if (btest(iEmpty,2)) then
    !if (iOpt == 1) write(u6,*) 'array3=',DDot_(bdim-1,Array3,1,Array3,1),Array3(bdim)
    call ddafile(lu,iOpt,array3,bdim,adr)
  else if (iOpt == 2) then
    array3(:) = Zero
  end if
end if

if ((.not. AO_Mode) .and. (iOpt == 2)) then

  ! Expand the TDMs to AO basis.

  JOB1 = JOB_Index(iState)
  JOB2 = JOB_Index(jState)
  J1 = max(JOB1,JOB2)
  J2 = min(JOB1,JOB2)
  if ((J1 /= JOB1_Old) .or. (J2 /= JOB2_Old)) then
    call RDCMO_RASSI(J1,CMO1)
    call RDCMO_RASSI(J2,CMO2)
    JOB1_OLD = J1
    JOB2_OLD = J2
    call mma_Allocate(TRA1,mTra,Label='TRA1')
    call mma_Allocate(TRA2,mTra,Label='TRA2')
    call FINDT(CMO1,CMO2,TRA1,TRA2)
    call mma_deallocate(TRA2)
    call mma_deallocate(TRA1)
  end if

  if (btest(iGo,0) .and. btest(iEmpty,0)) then
    !write(u6,*) 'array1=',DDot_(nasht_save**2,Array1,1,Array1,1),Array1(bdim)
    call MKTDAB(array1(bdim),array1,DMAB,iRC)
    call MKTDZZ(CMO1,CMO2,DMAB,array1,iRC)
  end if

  if (btest(iGo,1) .and. btest(iEmpty,1)) then
    !write(u6,*) 'array2=',DDot_(nasht_save**2,Array2,1,Array2,1),Array2(bdim)
    call MKTDAB(array2(bdim),array2,DMAB,iRC)
    call MKTDZZ(CMO1,CMO2,DMAB,array2,iRC)
  end if

  if (btest(iGo,2) .and. btest(iEmpty,2)) then
    !write(u6,*) 'array3=',DDot_(nasht_save**2,Array3,1,Array3,1),Array3(bdim)
    call MKTDAB(array3(bdim),array3,DMAB,iRC)
    call MKTDZZ(CMO1,CMO2,DMAB,array3,iRC)
  end if

end if

end subroutine dens2file

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_RestoreDiagonal(iAtomPair)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: restore original diagonal for atom pair iAtomPair.
C
      Implicit None
      Integer iAtomPair
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_AtomPair_DiagDim
      External LDF_AtomPair_DiagDim

      Integer l, ip1, ip2

      l=LDF_AtomPair_DiagDim(iAtomPair)
      ip1=iWork(ip_AP_DiagBak-1+iAtomPair)
      ip2=iWork(ip_AP_Diag-1+iAtomPair)
      Call dCopy_(l,Work(ip1),1,Work(ip2),1)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cortab_molcas(binom,dfac,eps,flmtx,hpt,
     &  hwt,lmf,lml,lmx,lmy,
     &  lmz,lmax,lmn1u,lproju,mc,mr,ndfac,zlm)
c     # tables for core potential and spin-orbit integrals.
      implicit real*8 (a-h,o-z)
      parameter (a0=0.0d0, a1=1.0d0, a3=3.0d0)
      dimension binom(*),dfac(*),flmtx(3,*),hpt(*),hwt(*),lmf(*),
     &  lml(*),lmx(*),lmy(*),lmz(*),mc(3,*),mr(3,*),zlm(*)
c
c     # compute gauss-hermite points and weights for c, z integrals.
      igh =1
      nn = 5
      do 120 i = 1, 3
        call hermit_molcas(nn,hpt(igh),hwt(igh),eps)
        igh = igh + nn
        nn = 2*nn
  120 continue
c     # compute double factorials.
      dfac(1)=a1
      dfac(2)=a1
      fi=a0
      do 130 i=1,ndfac-2
        fi=fi+a1
        dfac(i+2)=fi * dfac(i)
  130 continue
c     # compute binomial coefficients.
      inew=1
      binom(1)=a1
      do 150 j=1,lmn1u-1
        inew=inew+1
        binom(inew)=a1
        do 140 i=1,j-1
          inew=inew+1
          binom(inew)=(dble(j-i+1)*binom(inew-1))/dble(i)
  140   continue
        inew=inew+1
        binom(inew)=a1
  150 continue
c     # compute tables by recursion for real spherical harmonics.  they
c     # are indexed by l, m and sigma.  the sequence number of the
c     # harmonic with quantum numbers l, m and sigma is given by
c     #            l**2+2*m+1-sigma
c     # lmf(index) and lml(index) hold the positions of the first and
c     # last terms of the harmonic in the lmx, lmy, lmz, and zlm arrays.
c     # the harmonics with angular momentum l are generated from those
c     # with angular momenta l-1 and l-2.
c     # for m = 0,1,2,...,l-1, the recursion relation
c     z*Z(l-1,m,s) = sqrt(((l-m)*(l+m))/((2*l-1)*(2*l+1)))*Z(l,m,s)+
c                  sqrt(((l+m-1)*(l-m-1))/((2*l-3)*(2*l-1)))*Z(l-2,m,s)
c     # is used.
c     # for m = l, the recursion relation
c     x*Z(l-1,l-1,s)+(-1)**(1-s)*y*Z(l-1,l-1,1-s) =
c                  sqrt((2*l))/((2*l+1)))*Z(l,l,s)
c     # is used.
c     # l=0
      lmf(1) = 1
      lml(1) = 1
      lmx(1) = 0
      lmy(1) = 0
      lmz(1) = 0
      zlm(1) = a1
c     # l=1
      lmf(2) = 2
      lml(2) = 2
      lmx(2) = 0
      lmy(2) = 0
      lmz(2) = 1
      zlm(2) = sqrt(a3)
      lmf(3) = 3
      lml(3) = 3
      lmx(3) = 0
      lmy(3) = 1
      lmz(3) = 0
      zlm(3) = zlm(2)
      lmf(4) = 4
      lml(4) = 4
      lmx(4) = 1
      lmy(4) = 0
      lmz(4) = 0
      zlm(4) = zlm(2)
      nterm=4
      do 270 lang=2,lmax
        do 240 mang=0,lang-1
          anum = dble((2*lang-1)*(2*lang+1))
          aden = dble((lang-mang)*(lang+mang))
          coef1 = sqrt(anum/aden)
          anum = dble((lang+mang-1)*(lang-mang-1)*(2*lang+1))
          aden = dble(2*lang-3)*aden
          coef2 = sqrt(anum/aden)
          nsigma=min(1,mang)
          do 230 isigma=nsigma,0,-1
            indexh=lang**2+2*mang+1-isigma
            lone=lang-1
            ltwo=lang-2
            ione=lone**2+2*mang+1-isigma
            itwo=ltwo**2+2*mang+1-isigma
            lmf(indexh)=lml(indexh-1)+1
            lml(indexh)=lml(indexh-1)
            nxy=(mang-isigma+2)/2
            iu=lmf(ione)+nxy-1
            do 200 i=lmf(ione),iu
              lml(indexh)=lml(indexh)+1
              j=lml(indexh)
              lmx(j)=lmx(i)
              lmy(j)=lmy(i)
              lmz(j)=lmz(i)+1
              zlm(j)=zlm(i)*coef1
              nterm=nterm+1
  200       end do
            if(ltwo.ge.mang) then
              il=iu+1
              do 210 i=il,lml(ione)
                lml(indexh)=lml(indexh)+1
                j=lml(indexh)
                k=lmf(itwo)+i-il
                lmx(j)=lmx(k)
                lmy(j)=lmy(k)
                lmz(j)=lmz(k)
                zlm(j)=zlm(i)*coef1-zlm(k)*coef2
                nterm=nterm+1
  210         enddo
              il=lml(itwo)-nxy+1
              if(mod(lang-mang,2).eq.0) then
                do 220 i=il,lml(itwo)
                  lml(indexh)=lml(indexh)+1
                  j=lml(indexh)
                  lmx(j)=lmx(i)
                  lmy(j)=lmy(i)
                  lmz(j)=lmz(i)
                  zlm(j)=-zlm(i)*coef2
                  nterm=nterm+1
  220           end do
              endif
            endif
  230     end do
  240   end do
        anum = dble(2*lang+1)
        aden = dble(2*lang)
        coef = sqrt(anum/aden)
        mang=lang
        isigma=1
        indexh=lang**2+2*mang+1-isigma
        lmf(indexh)=lml(indexh-1)+1
        lml(indexh)=lml(indexh-1)
c       # isig:  index of the harmonic (l-1),(m-1),sigma
c       # isigm: index of the harmonic (l-1),(m-1),(1-sigma)
        isig=(lang-1)**2+2*(mang-1)+1-isigma
        isigm=(lang-1)**2+2*(mang-1)+isigma
        k=lmf(isigm)
        do 250 i=lmf(isig),lml(isig)
          lml(indexh)=lml(indexh)+1
          j=lml(indexh)
          lmx(j)=lmx(i)+1
          lmy(j)=lmy(i)
          lmz(j)=lmz(i)
          zlm(j)=(zlm(i)+zlm(k))*coef
          k=k+1
          nterm=nterm+1
  250   enddo
        if(mod(mang,2).eq.1) then
          lml(indexh)=lml(indexh)+1
          j=lml(indexh)
          lmx(j)=lmx(k)
          lmy(j)=lmy(k)+1
          lmz(j)=lmz(k)
          zlm(j)=zlm(k)*coef
          nterm=nterm+1
        endif
        isigma=0
        indexh=lang**2+2*mang+1-isigma
c       # isig:  index of the harmonic (l-1),(m-1),sigma
c       # isigm: index of the harmonuc (l-1),(m-1),(1-sigma)
        isig=(lang-1)**2+2*(mang-1)+1-isigma
        isigm=(lang-1)**2+2*(mang-1)+isigma
        lmf(indexh)=lml(indexh-1)+1
        lml(indexh)=lmf(indexh)
        j=lml(indexh)
        i=lmf(isig)
        lmx(j)=lmx(i)+1
        lmy(j)=lmy(i)
        lmz(j)=lmz(i)
        zlm(j)=zlm(i)*coef
        nterm=nterm+1
        k=lmf(isigm)
        do 260 i=lmf(isig)+1,lml(isig)
          lml(indexh)=lml(indexh)+1
          j=lml(indexh)
          lmx(j)=lmx(i)+1
          lmy(j)=lmy(i)
          lmz(j)=lmz(i)
          zlm(j)=(zlm(i)-zlm(k))*coef
          k=k+1
          nterm=nterm+1
  260   enddo
        if(mod(mang,2).eq.0) then
          lml(indexh)=lml(indexh)+1
          j=lml(indexh)
          k=lml(isigm)
          lmx(j)=lmx(k)
          lmy(j)=lmy(k)+1
          lmz(j)=lmz(k)
          zlm(j)=-zlm(k)*coef
          nterm=nterm+1
        endif
  270 end do
      ixy = 0
      iz = 0
      do 300 lang=1,lproju
        do 290 mang=0,lang-1
          nsigma=min(1,mang)
          ndelta=max(0,1-mang)
          anum = dble((lang-mang)*(lang+mang+1))
          aden = dble(2*(2-ndelta))
          coef=sqrt(anum/aden)
          do 280 isigma=nsigma,0,-1
            isign=2*isigma-1
            ixy = ixy+1
            flmtx(1,ixy) = dble((isign))*coef
            flmtx(2,ixy) = coef
            if(mang.ne.0) then
              iz=iz+1
              flmtx(3,iz) = -dble(mang*isigma)
            endif
  280     enddo
  290   enddo
        iz=iz+1
        flmtx(3,iz) = -dble(lang)
  300 enddo
c     # column and row indices for angular momentum matrix elements.
      iadd = 1
      do 310 i=1,2*lproju-1
        mc(1,i) = i
        mc(2,i) = i
        mc(3,i) = i+1
        mr(1,i) = i+iadd
        mr(2,i) = i+2
        mr(3,i) = i+2
        iadd = 4-iadd
  310 continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE UPKVEC(NITEM,ICVEC,CVEC)
C***********************************************************************
C
C     PURPOSE:
C     DECODE THE CI-VECTOR BY CHANGING THE NUMBER REPRESENTATION FROM
C     INTEGER*4 ==> REAL*8
C
C**** M.P. FUELSCHER, UNIVERSITY OF LUND, SWEDEN, NOV. 1990 ************
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CVEC(NITEM),ICVEC(NITEM)
      PARAMETER (SCALE=1.0D0/2147483647.0D0)
C
      DO 10 ITEM=1,NITEM
        CVEC(ITEM)=SCALE*DBLE(ICVEC(ITEM))
10    CONTINUE
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine setretvals_cvb(esym,n_iter)

use rasscf_global, only: Emy, Ener, Iter, iterci, lRoots, NAC
use general_data, only: STSYM
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n_iter
real(kind=wp), intent(in) :: esym(*)

if (nac == 0) then
  ener(1,iter) = emy
else
  ener(1:lroots,iter) = esym(stsym)
end if
iterci = n_iter

return

end subroutine setretvals_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine compl_cvb(a,nvec,n)
c  Creates orthogonal complement.
c  On entry : A is square (NxN) and contains NVEC vectors.
c  On exit  : A is a full matrix, NVEC first vectors are untouched,
c  remaining orthonormal vectors span the orthogonal complement.
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension a(n,n)

      i1 = mstackr_cvb(n*(nvec+n))
      i2 = mstackr_cvb(n*n)
      i3 = mstackr_cvb(n)
      call compl2_cvb(a,nvec,n,w(i1),w(i2),w(i3))
      call mfreer_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrintLine(unt,line,length,isBinLuscus)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use grid_it_globals, only: iBinary, isLuscus
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: unt, length
logical(kind=iwp), intent(in) :: isBinLuscus
character(len=128) :: line
integer(kind=iwp) :: ll, li
interface
  subroutine prt_lusc(lid,line,len_,isBin) bind(C,name='prt_lusc_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: lid, len_, isBin
    character(kind=c_char) :: line(*)
  end subroutine prt_lusc
end interface

if (isLuscus) then
  ll = length
  li = merge(1,0,isBinLuscus)
  !write(u6,*) 'before pl ',line,' ',ll,li
  call prt_lusc(unt,line,ll,li)
else
  if (iBinary == 1) then
    write(unt) line(1:length)
  else
    write(unt,'(A)') line(1:length)
  end if
end if

return

end subroutine PrintLine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Log_SVD
!
!> @brief Compute the antisymmetric matrix corresponding to a rotation matrix
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Computes the antisymmetric blocked matrix \f$ A \f$ such that \f$ \exp(A) \f$ produces an equivalent rotation
!> to the input rotation matrix (equivalent in the sense that the occupied and virtual orbitals will span the same space,
!> but the full rotation will not be identical). It also returns the redundant occupied-occupied and virtual-virtual
!> rotations to make them identical.
!>
!> @param[in]     N        Size of the square matrix
!> @param[in]     no       Size of the first diagonal zero block (number of occupied orbitals)
!> @param[in,out] A        Rotation matrix, it is replaced by the antisymmetric matrix with nonzero off-diagonal block,
!>                         and with the redundant rotations in the diagonal blocks
!***********************************************************************

subroutine Log_SVD(N,no,A)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, no
real(kind=wp), intent(inout) :: A(N,N)
integer(kind=iwp) :: i, nv
real(kind=wp), allocatable :: B(:,:), s(:), tmp(:), V(:,:), W(:,:)
real(kind=wp), parameter :: thrs = sqrt(epsilon(thrs))

! At the end we will get a matrix:
!
!   ( Uo -- )
!   ( X  Uv )
!
! such that the original A is equal to
!
!        ( 0  -X^T ) ( Uo 0  )
! A = exp( X    0  ) ( 0  Uv )

nv = N-no
if (no*nv < 1) return

! Pick up the occupied-occupied block
call mma_allocate(B,no,no,label='B')
B(:,:) = A(1:no,1:no)

call mma_allocate(V,no,no,label='V')
call mma_allocate(W,no,no,label='W')
call mma_allocate(s,no,label='s')

! Do the SVD, note the W matrix is already transposed
!   A(oo) = V s W^T
call large_svd(no,no,B,V,W,s)

! Redundant occupied-occupied rotation
!   U(o) = V W^T
call dgemm_('N','N',no,no,no,One,V,no,W,no,Zero,A(1,1),N)

! Redundant virtual-virtual rotation
!   U(v) = A(vv) - A(vo) W (1/(s+1)) V^T A(ov)
call mma_allocate(tmp,no*max(no,nv),label='tmp')
do i=1,no
  tmp((i-1)*no+1:i*no) = V(:,i)/(s(i)+One)
end do
! B = V (1/(s+1)) W^T
call dgemm_('N','N',no,no,no,One,tmp,no,W,no,Zero,B,no)
! U(v) = A(vv) - A(vo) B^T A(ov)
call dgemm_('T','N',no,nv,no,One,B,no,A(1,no+1),N,Zero,tmp,no)
call dgemm_('N','N',nv,nv,no,-One,A(no+1,1),N,tmp,no,One,A(no+1,no+1),N)

! pick up the virtual-occupied block
tmp(1:no*nv) = pack(A(no+1:,1:no),.true.)

! X = A(vo) (V scos(s) W^T)^T
! scos(x) = acos(x)/sqrt(1-x^2) ; scos(1) = 1
do i=1,no
  if (One-s(i) > thrs) V(:,i) = acos(s(i))/sqrt(One-s(i)**2)*V(:,i)
end do
call dgemm_('N','N',no,no,no,One,V,no,W,no,Zero,B,no)
call dgemm_('N','T',nv,no,no,One,tmp,nv,B,no,Zero,A(no+1,1),N)

call mma_deallocate(B)
call mma_deallocate(V)
call mma_deallocate(W)
call mma_deallocate(s)
call mma_deallocate(tmp)

end subroutine Log_SVD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine Rysg1(iAnga,nRys,nT,Alpha,Beta,Gmma,Delta,Zeta,ZInv,nZeta,Eta,EInv,nEta,P,lP,Q,lQ,Coori,Coora,CoorAC,Array,nArray, &
                 Tvalue,ModU2,Cff2D,PAO,nPAO,Grad,nGrad,IfGrad,IndGrd,kOp,iuvwx)
!***********************************************************************
!                                                                      *
! Object: to compute the gradient of the two-electron integrals.       *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Modified to 1st order derivatives October '91            *
!***********************************************************************

use vRys_RW, only: nMxRys
use Symmetry_Info, only: iOper
use Gateway_Info, only: ChiI2
use Gateway_global, only: IsChi, NoTab
use Definitions, only: wp, iwp
#if defined(_DEBUGPRINT_) || defined (_CHECK_)
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iAnga(4), nRys, nT, nZeta, nEta, lP, lQ, nArray, nPAO, nGrad, IndGrd(3,4), kOp(4), iuvwx(4)
real(kind=wp), intent(in) :: Alpha(nZeta), Beta(nZeta), Gmma(nEta), Delta(nEta), Zeta(nZeta), ZInv(nZeta), Eta(nEta), EInv(nEta), &
                             P(lP,3), Q(lQ,3), Coori(3,4), Coora(3,4), CoorAC(3,2), PAO(nT,nPAO)
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Array(nArray)
external :: Tvalue, ModU2, Cff2D
logical(kind=iwp), intent(in) :: IfGrad(3,4)
integer(kind=iwp) :: iEta, Indx(3,4), iOff, ip, ip2D0, ip2D1, ipB00, ipB01, ipB10, ipDiv, ipEInv, ipEta, ipP, ipPAQP, ipQ, ipQCPQ, &
                     ipScr, ipTmp, ipTv, ipU2, ipWgh, ipZeta, ipZInv, iZeta, JndGrd(3,4), la, lab, labMax, lb, lB00, lB01, lB10, &
                     lc, lcd, ld, lla, llb, llc, lld, lOp(4), mVec, n2D0, n2D1, nabMax, ncdMax, nTR
real(kind=wp) :: Temp(9)
logical(kind=iwp) :: JfGrad(3,4)
external :: Exp_1, Exp_2

lOp(1) = iOper(kOp(1))
lOp(2) = iOper(kOp(2))
lOp(3) = iOper(kOp(3))
lOp(4) = iOper(kOp(4))
#ifdef _DEBUGPRINT_
call RecPrt(' In Rysg1:P',' ',P(1:nZeta,:),nZeta,3)
call RecPrt(' In Rysg1:Q',' ',Q(1:nEta,:),nEta,3)
call RecPrt(' In Rysg1:Zeta',' ',Zeta,nZeta,1)
call RecPrt(' In Rysg1:ZInv',' ',ZInv,nZeta,1)
call RecPrt(' In Rysg1:Eta',' ',Eta,nEta,1)
call RecPrt(' In Rysg1:EInv',' ',EInv,nEta,1)
call RecPrt(' In Rysg1:Alpha',' ',Alpha,nZeta,1)
call RecPrt(' In Rysg1:Beta ',' ',Beta,nZeta,1)
call RecPrt(' In Rysg1:Gamma',' ',Gmma,nEta,1)
call RecPrt(' In Rysg1:Delta',' ',Delta,nEta,1)
call RecPrt(' In Rysg1:Coora',' ',Coora,3,4)
call RecPrt(' In Rysg1:Coori',' ',Coori,3,4)
call RecPrt(' In Rysg1:CoorAC',' ',CoorAC,3,2)
write(u6,*) ' In Rysg1: iAnga=',iAnga
#endif
la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)
lla = 0
llb = 0
llc = 0
lld = 0
if (any(IfGrad(:,1))) lla = 1
if (any(IfGrad(:,2))) llb = 1
if (any(IfGrad(:,3))) llc = 1
if (any(IfGrad(:,4))) lld = 1
lab = max(lla,llb)
lcd = max(llc,lld)
nabMax = la+lb+lab
ncdMax = lc+ld+lcd

! Allocate memory for the integral gradients.

ip = 1
!ipAC = ip
!ip = ip+nT*nPAO*9

! Allocate memory for the 2D-integrals.

ip2D0 = ip
n2D0 = max((nabMax+1)*(ncdMax+1),(la+2)*(lb+2)*(ncdMax+1),(la+2)*(lb+2)*(lc+2)*(ld+2))
ip = ip+n2D0*3*nT*nRys

! Allocate memory for the 1st order derivatives of the 2D-integrals.

ip2D1 = ip
n2D1 = max((nabMax+1)*(ncdMax+1),(la+2)*(lb+2)*(ncdMax+1),(la+1)*(lb+1)*(lc+1)*(ld+1)*3)
ip = ip+n2D1*3*nT*nRys

! Allocate memory for the coefficients in the recurrence relation
! of the 2D-integrals.

nTR = nT*nRys
ipPAQP = ip
ip = ip+nTR*3
ipQCPQ = ip
ip = ip+nTR*3
ipB10 = ip
lB10 = max(min(nabMax-1,1),0)
ip = ip+nTR*3*lB10
labMax = min(nabMax,ncdMax)
ipB00 = ip
lB00 = max(min(labMax,1),0)
ip = ip+nTR*3*lB00
ipB01 = ip
lB01 = max(min(ncdMax-1,1),0)
ip = ip+nTR*3*lB01
! Allocate memory for the roots.
ipU2 = ip
ip = ip+nT*nRys
! Allocate memory for Zeta, ZInv, Eta, EInv
ipZeta = ip
ip = ip+nT
ipEta = ip
ip = ip+nT
ipZInv = ip
ip = ip+nT
ipEInv = ip
ip = ip+nT
! Allocate memory for P and Q
ipP = ip
ip = ip+3*nT
ipQ = ip
ip = ip+3*nT
! Allocate memory for the inverse.
ipDiv = ip
ip = ip+nT
! Allocate memory for the arguments.
ipTv = ip
ip = ip+nT
!define _CHECK_
#ifdef _CHECK_
if (ip-1 > nArray) then
  call WarningMessage(2,'Rysg1: ip-1 =/= nArray (pos.1)')
  write(u6,*) ' nArray=',nArray
  write(u6,*) ' ip-1  =',ip-1
  write(u6,*) ' nRys  =',nRys
  write(u6,*) ' nZeta =',nZeta
  write(u6,*) ' nEta  =',nEta
  call Abend()
end if
#endif

! Expand Zeta, ZInv, Eta, EInv, P, and Q

do iEta=1,nEta
  iOff = (iEta-1)*nZeta
  call dcopy_(nZeta,Zeta,1,Array(iOff+ipZeta),1)
  call dcopy_(nZeta,ZInv,1,Array(iOff+ipZInv),1)
  call dcopy_(nZeta,P(1,1),1,Array(iOff+ipP),1)
  iOff = iOff+nZeta*nEta
  call dcopy_(nZeta,P(1,2),1,Array(iOff+ipP),1)
  iOff = iOff+nZeta*nEta
  call dcopy_(nZeta,P(1,3),1,Array(iOff+ipP),1)
end do
do iZeta=1,nZeta
  iOff = iZeta-1
  call dcopy_(nEta,Eta,1,Array(iOff+ipEta),nZeta)
  call dcopy_(nEta,EInv,1,Array(iOff+ipEInv),nZeta)
  call dcopy_(nEta,Q(1,1),1,Array(iOff+ipQ),nZeta)
  iOff = iOff+nZeta*nEta
  call dcopy_(nEta,Q(1,2),1,Array(iOff+ipQ),nZeta)
  iOff = iOff+nZeta*nEta
  call dcopy_(nEta,Q(1,3),1,Array(iOff+ipQ),nZeta)
end do

! Compute the arguments for which we will compute the roots and the weights.

call Tvalue(Array(ipZeta),Array(ipEta),Array(ipP),Array(ipQ),nT,Array(ipTv),Array(ipDiv),IsChi,ChiI2)

! Compute roots and weights. Make sure that the weights ends up in
! the array where the z component of the 2D integrals will be.
! Call vRysRW if roots and weights are tabulated in various Taylor
! expansions. If not tabulated call RtsWgh.

! Pointer to z-component of 2D-integrals where the weights will be
! put directly. This corresponds to xyz2D(1,1,3,0,0).
ipWgh = ip2D0+2*nT*nRys
if ((nRys > nMxRys) .or. NoTab) then
# ifdef _CHECK_
  if (ip-1 > nArray) then
    call WarningMessage(2,'Rysg1: ip-1 =/= nArray (pos.2)')
    write(u6,*) ' nArray=',nArray
    write(u6,*) ' ip-1  =',ip-1
    call Abend()
  end if
# endif
  call RtsWgh(Array(ipTv),nT,Array(ipU2),Array(ipWgh),nRys)
else
# ifdef _CHECK_
  if (ip-1 > nArray) then
    call WarningMessage(2,'Rysg1: ip-1 =/= nArray (pos.3)')
    write(u6,*) ' nArray=',nArray
    write(u6,*) ' ip-1  =',ip-1
    call Abend()
  end if
# endif
  call vRysRW(la+1,lb,lc,ld,Array(ipTv),Array(ipU2),Array(ipWgh),nT,nRys)
end if
! Drop ipTv
ip = ip-nT

! Modify the roots.

call ModU2(Array(ipU2),nT,nRys,Array(ipDiv))
! Drop ipDiv
ip = ip-nT

! Compute coefficients for the recurrence relations of the 2D-integrals

call Cff2D(max(nabMax-1,0),max(ncdMax-1,0),nRys,Array(ipZeta),Array(ipZInv),Array(ipEta),Array(ipEInv),nT,Coori,CoorAC,Array(ipP), &
           Array(ipQ),la+lab,lb,lc+lcd,ld,Array(ipU2),Array(ipPAQP),Array(ipQCPQ),Array(ipB10),Array(ipB00),labMax,Array(ipB01))
! Drop ipU2
ip = ip-nT*nRys
! Let go of Zeta, ZInv, Eta, and EInv
ip = ip-nT*4
! Let go of P and Q
ip = ip-6*nT

! Compute the intermediate 2D-integrals from the roots and weights.

call vRys2Dm(Array(ip2D0),nT,nRys,nabMax,ncdMax,Array(ipPAQP),Array(ipQCPQ),Array(ipB10),Array(ipB00),Array(ipB01),la,lb,lc,ld, &
             IfGrad)
! Drop ipB01
ip = ip-nTR*3*lB01
! Drop ipB00
ip = ip-nTR*3*lB00
! Drop ipB10
ip = ip-nTR*3*lB10
! Drop ipQCPQ
ip = ip-nTR*3
! Drop ipPAQP
ip = ip-nTR*3

! Apply the transfer equation to the intermediate 2D-integrals.

call HrrCtl(Array(ip2D0),n2D0,Array(ip2D1),n2D1,la,lb,lc,ld,nabmax,ncdmax,nTR,Coora(1,1),Coora(1,2),Coora(1,3),Coora(1,4),IfGrad)

! Compute the gradients of the 2D-integrals. Copy some information
! which will be modified. This has to be done in order to facilitate
! partitioning.

ipScr = ip
ip = ip+nT*nRys
ipTmp = ip
ip = ip+nT
JndGrd(:,:) = IndGrd
JfGrad(:,:) = IfGrad
call Rys2Dg(Array(ip2D0),nT,nRys,la,lb,lc,ld,Array(ip2D1),JfGrad,JndGrd,Coora,Alpha,Beta,Gmma,Delta,nZeta,nEta,Array(ipScr), &
            Array(ipTmp),Indx,Exp_1,Exp_2,nZeta,nEta)
! Drop ipScr
ip = ip-nTR
! Drop ipTmp
ip = ip-nT

! Assemble the gradients of the ERI's

call Assg1(Temp,PAO,nT,nRys,la,lb,lc,ld,Array(ip2D0),Array(ip2D1),JfGrad,Indx,mVec)
! Drop ip2D1
ip = ip-nTR*3*n2D1
! Drop ip2D0
ip = ip-nTR*3*n2D0

! Distribute the contributions to the molecular gradient

call Distg1(Temp,Grad,nGrad,JfGrad,JndGrd,iuvwx,lOp)
! Drop ipAC
!ip = ip-nT*nPAO*9
#ifdef _CHECK_
if (ip /= 1) then
  call WarningMessage(2,'Rysg1: ip=/=1')
  call Abend()
end if
#endif

return

end subroutine Rysg1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETSTOR(VCSTOR)
!
! Purpose: get total vector storage (in words).

use Cholesky, only: LuPri, MaxVec, nSym, NumCho
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: VCSTOR(nSym)
integer(kind=iwp) :: ISYM
character(len=*), parameter :: SECNAM = 'CHO_GETSTOR'

do ISYM=1,NSYM
  if (NUMCHO(ISYM) > MAXVEC) then
    write(LUPRI,*) SECNAM,': too many Cholesky vectors in symmetry ',ISYM,': ',NUMCHO(ISYM)
    call CHO_QUIT('Error in '//SECNAM,103)
    VCSTOR(ISYM) = Zero
  else if (NUMCHO(ISYM) < 0) then
    write(LUPRI,*) SECNAM,': negative #Cholesky vectors in symmetry ',ISYM,': ',NUMCHO(ISYM)
    call CHO_QUIT('Error in '//SECNAM,103)
    VCSTOR(ISYM) = Zero
  else
    call CHO_GETSTOR_S(VCSTOR(ISYM),ISYM)
  end if
end do

end subroutine CHO_GETSTOR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE STEPVECTOR_NEXT(MV,IDWN,IUP,
     &                           STEPVECTOR)
      IMPLICIT NONE
      INTEGER :: MV, IDWN, IUP, STEPVECTOR(*)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      PARAMETER(ROUTINE='STEPVECTOR_NEXT')
#include "gugx.fh"
#include "WrkSpc.fh"

C stop when MV is zero
      IF (MV.EQ.0) THEN
        WRITE(6,'(1X,A)') 'stepvector_next has been depleted'
      END IF

      CALL GETSTEPVECTOR(IWORK(LNOW),IWORK(LIOW),
     &                   MV,IDWN,IUP,
     &                   STEPVECTOR)

      END

      SUBROUTINE GETSTEPVECTOR(NOW,IOW,
     &                         MV,IDWN,IUP,
     &                         ICS)
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      PARAMETER(ROUTINE='GETSTEPVECTOR')
#include "gugx.fh"
#include "WrkSpc.fh"

      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)

      DIMENSION ICS(mxact)
C
C     RECONSTRUCT THE CASE LIST
C
      NSCR=3*(NLEV+1)
      NICASE=NWALK*NIPWLK
*     CALL GETMEM('SCR1','ALLO','INTEG',LSCR,NSCR)
*     CALL GETMEM('CASE','ALLO','INTEG',LICASE,NICASE)
*     CALL MKCLIST(NSM,IWORK(LDOWN),IWORK(LNOW),IWORK(LIOW),
*    &             IWORK(LICASE),IWORK(LSCR))
*     CALL GETMEM('SCR1','FREE','INTEG',LSCR,NSCR)

C
C     ENTER THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
C     WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.
C
!     DO MV=1,NMIDV
!       DO ISYUP=1,NSYM
          NUP=NOW(1,1,MV)
          NDWN=NOW(2,1,MV)
          IUW0=LICASE-NIPWLK+IOW(1,1,MV)
          IDW0=LICASE-NIPWLK+IOW(2,1,MV)
*         IDWNSV=0
!         DO IDWN=1,NDWN
!           DO IUP=1,NUP
              ! determine the stepvector
*             IF(IDWNSV.NE.IDWN) THEN
                ICDPOS=IDW0+IDWN*NIPWLK
                ICDWN=IWORK(ICDPOS)
                ! unpack lower walk
                NNN=0
                DO LEV=1,MIDLEV
                  NNN=NNN+1
                  IF(NNN.EQ.16) THEN
                    NNN=1
                    ICDPOS=ICDPOS+1
                    ICDWN=IWORK(ICDPOS)
                  END IF
                  IC1=ICDWN/4
                  ICS(LEV)=ICDWN-4*IC1
                  ICDWN=IC1
                END DO
*               IDWNSV=IDWN
*             END IF
              ICUPOS=IUW0+NIPWLK*IUP
              ICUP=IWORK(ICUPOS)
              ! unpack upper walk
              NNN=0
              DO LEV=MIDLEV+1,NLEV
                NNN=NNN+1
                IF(NNN.EQ.16) THEN
                  NNN=1
                  ICUPOS=ICUPOS+1
                  ICUP=IWORK(ICUPOS)
                END IF
                IC1=ICUP/4
                ICS(LEV)=ICUP-4*IC1
                ICUP=IC1
              END DO
!           END DO
!         END DO
!       END DO
!     END DO

C compute the next set of indices
      IF (IUP.EQ.NUP) THEN
        IF (IDWN.EQ.NDWN) THEN
          IF (MV.EQ.NMIDV) THEN
            MV=0
          ELSE
            MV=MV+1
          END IF
          IDWN=1
        ELSE
          IDWN=IDWN+1
        END IF
        IUP=1
      ELSE
        IUP=IUP+1
      END IF

*     CALL GETMEM('CASE','FREE','INTEG',LICASE,NICASE)
      RETURN
      END SUBROUTINE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ADAST_GASSM(NSTB,NSTA,IOFFK,IOFFI,IOFFISP,
     &              IOFFKSP,ICREORB,ICRESTR,
     &              IORBTSF,IORBTF,NORBTS,NSTAK,NSTAKT,NSTAI,
     &              NSTAKTS,ISTAKTS,NELB,NACGSOB,
     *              ISTMAP,SGNMAP,SCLFAC,IAC,LROW_IN,IEC)
*
* Annihilation/Creation mappings from K-strings of given sym in each gasspace
*
* Input
* NSTB : Number of strings before active gasspace
* NSTA : Number of strings after accive gasspace
* IOFFK : Offset for K group of strings in active gasspace, i.e. start of
*         this symmetry of active K group strings
* IOFFI : Offset for I group of strings in active gasspace, i.e. start of
*         this symmetry of active I group strings
* IOFFISP: Offset for this symmetrydistribution of active I supergroup strings
* IOFFKSP: Offset for this symmetrydistribution of active K supergroup strings
* ICREORB : Orbital part of creation map for active K groupstrings
* ICRESTR : String  part of creation map for active K groupstrings
* IORBTSF   : First active orbital ( first orbital in in active GASspace
*           with required sym)
* IORBTF   : First orbital in active gas space, (can have any sym)
* NORBTS  : Number of orbitals of given symmetry and type
* NSTAK : Number of K groupstrings with given correct symmetry
* NSTAKT: Total Number of K groupstrings in active group (all symmetries)
* NSTAKTS: Total Number of K supergroup strings with correct symmetry
* ISTAKTS: Offset for K supergroup strings with hiven symmetrydistribution
* NSTAI : Number of I groupstrings in active gasspace
*
      IMPLICIT REAL*8(A,H,O-Z)
*. Input
      DIMENSION ICREORB(LROW_IN,*), ICRESTR(LROW_IN,*)
*. Output
      DIMENSION ISTMAP(NSTAKTS,*),SGNMAP(NSTAKTS,*)
* Some dummy initializations
      SIGN = 0.0D0 ! jwk-cleanup
      ISTR = 0 ! jwk-cleanup
*
C?    WRITE(6,*) ' ICRESTR '
C?    CALL IWRTMA(ICRESTR,LROW_IN,NSTAK,LROW_IN,NSTAK)
C?    WRITE(6,*) ' IOFFI = ', IOFFI
*PAM2009      SIGN0 = DBLE((-1)**NELB) * SCLFAC
      IF(MOD(NELB,2).EQ.0) THEN
        SIGN0=SCLFAC
      ELSE
        SIGN0=-SCLFAC
      END IF
      DO KSTR = IOFFK, NSTAK+IOFFK-1
        DO IORB = IORBTSF, IORBTSF-1+NORBTS
*. Relative to Type-symmetry start
          IORBRTS = IORB-IORBTSF+1
*. Relative to type start
          IORBRT = IORB-IORBTF+1
C?        write(6,*) ' IORBRTS IORBRT', IORBRTS,IORBRT
*. Change of active group
          I_AM_ACTIVE = 0
          IF(IAC.EQ.2) THEN
C?          WRITE(6,*) ' ICREORB = ', ICREORB(IORBRT,KSTR)
C?          WRITE(6,*) ' ICRESTR = ', ICRESTR(IORBRT,KSTR)
            IF(ICREORB(IORBRT,KSTR) .GT. 0 ) THEN
*. Creation is nonvanishing
              I_AM_ACTIVE = 1
              IF(ICRESTR(IORBRT,KSTR) .GT. 0 ) THEN
                SIGN = SIGN0
                ISTR = ICRESTR(IORBRT,KSTR)
              ELSE
                SIGN = -SIGN0
                ISTR = -ICRESTR(IORBRT,KSTR)
              END IF
            END IF
          ELSE IF(IAC.EQ.1) THEN
             IF(IEC.EQ.1) THEN
*. Expanded map
               IF(ICREORB(IORBRT,KSTR) .LT. 0 ) THEN
*. Annihilation is non-vanishing
                 I_AM_ACTIVE = 1
                 IF(ICRESTR(IORBRT,KSTR) .GT. 0 ) THEN
                   SIGN = SIGN0
                   ISTR = ICRESTR(IORBRT,KSTR)
                 ELSE
                   SIGN = -SIGN0
                   ISTR = -ICRESTR(IORBRT,KSTR)
                 END IF
               END IF
             ELSE
*. Compressed map
               DO IROW = 1, LROW_IN
C?              write(6,*) ' IROW, ICREORB(IROW,KSTR)' ,
C?   &                       IROW, ICREORB(IROW,KSTR)
COLD             IF(ICREORB(IROW,KSTR) .EQ. -IORBRT ) THEN
                 IF(ICREORB(IROW,KSTR) .EQ. -IORB   ) THEN
*. Annihilation is non-vanishing
                   I_AM_ACTIVE = 1
                   IF(ICRESTR(IROW,KSTR) .GT. 0 ) THEN
                     SIGN = SIGN0
                     ISTR = ICRESTR(IROW,KSTR)
                   ELSE
                     SIGN = -SIGN0
                     ISTR = -ICRESTR(IROW,KSTR)
                   END IF
                 END IF
               END DO
             END IF
*            ^ End of expanded/compact switch
           END IF
*          ^ End of Creation/annihilation switch

          IF(I_AM_ACTIVE .EQ. 1  ) THEN
*. Excitation is open, corresponding active I string
* Relative to start of given symmetry for this group
            ISTR = ISTR - IOFFI+ 1
C?          WRITE(6,*) ' ISTR, relative = ', ISTR
*. This Creation is active for all choices of strings in supergroup
*. before and after the active type. Store the corrsponding mappings
            IADRK0 = (KSTR-IOFFK)*NSTA +IOFFKSP-1
            IADRI0 = (ISTR-1)*NSTA     +IOFFISP-1
C?          WRITE(6,*) ' IADRK0 IOFFK IOFFKSP ',
C?   &                   IADRK0,IOFFK,IOFFKSP
C?          WRITE(6,*) ' IADRI0, IOFFISP ',
C?   &                   IADRI0, IOFFISP
*
            NSTAINSTA = NSTAI*NSTA
            NSTAKNSTA = NSTAK*NSTA
*
C?          WRITE(6,*) ' ISTR NSTA NSTB ',ISTR,NSTA,NSTB
C?          WRITE(6,*) ' NSTAI,NSTAK',NSTAI,NSTAK
            DO IB = 1, NSTB
              DO IA = 1, NSTA
C               IBKA = IADRI0 + (IB-1)*NSTAI*NSTA+IA
C               KBKA = IADRK0 + (IB-1)*NSTAK*NSTA+IA
                ISTMAP(IADRK0+IA,IORBRTS) = IADRI0 + IA
                SGNMAP(IADRK0+IA,IORBRTS) = SIGN
              END DO
              IADRI0 = IADRI0 +  NSTAINSTA
              IADRK0 = IADRK0 +  NSTAKNSTA
            END DO
          END IF
        END DO
      END DO
*
      NTEST = 000
      IF(NTEST.GT.0) THEN
        WRITE(6,*) ' Output from ADAST_GASSM '
        WRITE(6,*) ' ======================== '
        NK = NSTB*NSTAK*NSTA
        WRITE(6,*) ' Number of K strings accessed ', NK
        IF(NK.NE.0) THEN
          DO IORB = IORBTSF,IORBTSF + NORBTS  - 1
            IORBR = IORB-IORBTSF+1
            WRITE(6,*) ' Update Info for orbital ', IORB
            WRITE(6,*) ' Mapped strings and sign '
            CALL IWRTMA(ISTMAP(1,IORBR),1,NK,1,NK)
            CALL WRTMAT(SGNMAP(1,IORBR),1,NK,1,NK)
          END DO
        END IF
      END IF

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NSTAKT)
        CALL Unused_integer(ISTAKTS)
        CALL Unused_integer(NACGSOB)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT_T15(Tp,T2,T11,T12,dimbe,dima,no)
! this routine does:
! Tp(be',u,a',i) <- 2 t2(be,a,u,i)
!                 - t2(be,a,i,u)+t12(a,u).t11(be,i)/2
! N.B. mozno sa to da este vylepsit

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimbe, dima, no
real(kind=wp), intent(out) :: Tp(dimbe,no,dima,no)
real(kind=wp), intent(in) :: T2(dimbe,dima,no,no), T11(dimbe,no), T12(dima,no)
integer(kind=iwp) :: a, u

do a=1,dima
  do u=1,no
    Tp(:,u,a,:) = Two*T2(:,a,u,:)-T2(:,a,:,u)+T11(:,:)*T12(a,u)
  end do
end do

return

end subroutine MkT_T15

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine readin_single(iprint,nmult,ndim,ndimcf,ldimcf,nlanth,axisoption,poly_file,Ifrestart,input_to_read,nk,mg,zmagn, &
                         Do_structure_abc,cryst,coord,encut_definition,compute_g_tensors,compute_CF,nDirTot,nss,nstate, &
                         compute_magnetization,compute_torque,smagn,tinput,hinput,compute_Mdir_vector,zeeman_energy,LUZee,doplot, &
                         encut_rate,ncut,nTempMagn,TempMagn,m_paranoid,compute_barrier,nBlock,AngPoints,input_file_name,nT,nH, &
                         texp,chit_exp,zJ,hexp,magn_exp,hmin,hmax,nDir,nDirZee,dirX,dirY,dirZ,dir_weight,xfield,tmin,tmax,thrs, &
                         H_torq,T_torq,nsymm,ngrid)
! THIS ROUTINE READS THE FILE "SINGLE_ANISO.INPUT".

use Lebedev_quadrature, only: order_table
use Constants, only: Zero, One, Two, Five, Six, Ten
use Definitions, only: wp, iwp, u5, u6

implicit none
integer(kind=iwp), intent(inout) :: nmult, ntempmagn, nt, nh, nDir, nDirZee
integer(kind=iwp), intent(out) :: iprint, ndim(nMult), ndimcf, ldimcf, nlanth, axisoption, input_to_read, nk, mg, &
                                  encut_definition, ndirtot, LUZee(nDirZee), ncut, nBlock, AngPoints, nsymm, ngrid
logical(kind=iwp), intent(out) :: poly_file, Ifrestart, Do_structure_abc, compute_g_tensors, compute_cf, compute_magnetization, &
                                  compute_torque, smagn, tinput, hinput, compute_Mdir_vector, zeeman_energy, doplot, m_paranoid, &
                                  compute_barrier
real(kind=wp), intent(out) :: zmagn(3,3), cryst(6), coord(3), encut_rate, tempmagn(nTempMagn), texp(nT), chit_exp(nT), zj, &
                              hexp(nH), magn_exp(nH,ntempmagn), hmin, hmax, dirX(nDir), dirY(nDir), dirZ(nDir), &
                              dir_weight(nDirZee,3), Xfield, tmin, tmax, thrs, H_torq, T_torq
integer(kind=iwp), intent(in) :: nss, nstate
character(len=180), intent(inout) :: input_file_name
integer(kind=iwp) :: I, i_OxStat, istatus, j, jEnd, l, LINENR
real(kind=wp) :: check_dir_weight, column_check(3,3), det_zmagn, row_check(3,3), rsum, t1, t2, tmp, zr(3,3)
logical(kind=iwp) :: checktmag, encut_check, hcheck, tcheck
character(len=280) :: LINE
character(len=180) :: err_msg, tmpline
character(len=21) :: namefile_energy
character(len=2) :: cME, uME
integer(kind=iwp), parameter :: ngrid_map(32) = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,17,20,23,26,29,32,35,38,41,44,47,50,53,56,59, &
                                                 62,65]
character(len=*), parameter :: clanth(37) = ['CE','PR','ND','PM','SM','EU','GD','TB','DY','HO','ER','TM','YB','LU', & ! lanthanides
                                             'TH','PA','U ','NP','PU','AM','CM','BK','CF','ES','FM','MD','NO','LR', & ! actinides
                                             'SC','TI','V ','CR','MN','FE','CO','NI','CU'] ! transition metals
integer(kind=iwp), external :: IsFreeUnit
real(kind=wp), external :: FindDetR

!========== Initializations of arrays ==================================
DirX(:) = Zero
DirY(:) = Zero
DirZ(:) = Zero
dir_weight(:,:) = Zero
TempMagn(:) = Zero
!============ Initializations of constants =============================

nsymm = 1
ngrid = 15
IPRINT = 2
ndim(:) = 0
Ifrestart = .false.
nDirTot = 0
LuZee(:) = 0
nBlock = 0
texp(:) = Zero
chit_exp(:) = Zero
hexp(:) = Zero
magn_exp(:,:) = Zero
H_torq = 0.1_wp ! in tesla
T_torq = Two    ! in K

thrs = 1.0e-10_wp
ncut = 1
TMIN = Zero
TMAX = 300.0_wp
XFIELD = Zero
!NT = 301
HMIN = Zero
HMAX = Ten
!NH = 21
NK = 200
MG = 200
!NDIR = 0
!nDirZee = 0
!nTempMagn = 1
if (nTempMagn > 0) TempMagn(1) = Two
T1 = Five
T2 = Six
ZJ = Zero
m_paranoid = .true.
checkTMAG = .false.
compute_g_tensors = .false.
compute_magnetization = .false.
compute_Mdir_vector = .false.
compute_CF = .false.
compute_barrier = .false.
compute_torque = .false.
smagn = .false.
TINPUT = .false.
HINPUT = .false.
TCHECK = .false.
HCHECK = .false.
POLY_FILE = .false.
Do_structure_abc = .false.
zeeman_energy = .false.
ENCUT_check = .false.
doplot = .false.
nlanth = 0
nDIMcf = 0
lDIMcf = 0
cME = '  '

cryst(:) = Zero
coord(:) = Zero
axisoption = 1
input_to_read = 0
encut_definition = 2
encut_rate = 1
zmagn(:,:) = Zero
AngPoints = 46

!=========== End of default settings====================================
rewind(u5)
do
  read(u5,'(A280)',iostat=istatus) LINE
  if (istatus < 0) call Error(1)
# ifdef _DEBUGPRINT_
  write(u6,'(A)') trim(LINE)
# endif
  call NORMAL(LINE)
  if (LINE(1:7) == '&SINGLE') exit
end do
LINENR = 0
do
  read(u5,'(A280)',iostat=istatus) LINE
  if (istatus < 0) call Error(1)
# ifdef _DEBUGPRINT_
  write(u6,'(A)') trim(LINE)
# endif
  LINENR = LINENR+1
  call NORMAL(LINE)
  if ((LINE(1:1) == '*') .or. (LINE == ' ')) cycle

  select case (LINE(1:4))
    case ('END ','    ')
      exit
    !------------------------------------------
    !case ('TYPE')
    !  read(u5,*,iostat=istatus) ICALC
    !  if (istatus < 0) call Error(2)
    !  if (icalc == 1) then
    !    compute_g_tensors = .true.
    !  else if (icalc == 2) then
    !    compute_chiT = .true.
    !  else if (icalc == 3) then
    !    compute_magnetization = .true.
    !  else if (icalc == 4) then
    !    compute_g_tensors = .true.
    !    compute_chiT = .true.
    !  else if (icalc == 5) then
    !    compute_g_tensors = .true.
    !    compute_magnetization = .true.
    !  else if (icalc == 6) then
    !    compute_chiT = .true.
    !    compute_magnetization = .true.
    !  else if (icalc == 7) then
    !    compute_g_tensors = .true.
    !    compute_chiT = .true.
    !    compute_magnetization = .true.
    !  else
    !    write(u6,'(A)') 'ICALC: the maximum value is 7. However, the calculation will continue by computing the magnetism.'
    !    compute_g_tensors = .true.
    !    compute_chiT = .true.
    !    compute_magnetization = .true.
    !  end if
    !  LINENR = LINENR+1
    !------------------------------------------
    case ('MLTP')
      read(u5,*,iostat=istatus) NMULT
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'MLTP:  NMULT=',NMULT
#     endif
      compute_g_tensors = .true.
      read(u5,*,iostat=istatus) (NDIM(i),i=1,NMULT)
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'MLTP: NDIM()=',(NDIM(i),i=1,NMULT)
#     endif
      LINENR = LINENR+2
    !------------------------------------------
    case ('REST')
      Ifrestart = .true.
      read(u5,*,iostat=istatus) input_to_read
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'REST: input_to_read=',input_to_read
#     endif
      if ((input_to_read == 2) .or. (input_to_read == 3) .or. (input_to_read == 4)) then
        backspace(u5)
        read(u5,*) input_to_read,tmpline
        input_file_name = trim(tmpline)
      end if
      if (input_to_read == 1) then
        write(u6,*) 'RESTART: -- The SINGLE_ANISO will take all ab initio information from the binary "$Project.aniso" file.'
      else if (input_to_read == 2) then
        write(u6,*) 'RESTART: -- The SINGLE_ANISO will take all ab initio information from the ASCII '//trim(input_file_name)// &
                    ' file.'
      else if (input_to_read == 3) then
        write(u6,*) 'RESTART: -- The SINGLE_ANISO will take all ab initio information from the RASSI-HDF5 binary file.'
      else if (input_to_read == 4) then
        write(u6,*) 'RESTART: -- The SINGLE_ANISO will take all ab initio information from the ASCII '//trim(input_file_name)// &
                    ' file -- molcas-8.0 format.'
      else
        call WarningMessage(2,'SINGLE_ANISO:: RESTART  option is not known.')
        call Quit_OnUserError()
      end if
    !-------------------------------------------
    case ('DATA')
      Ifrestart = .true.
      read(u5,*) tmpline
      input_file_name = trim(tmpline)
      input_to_read = 6
#     ifdef _DEBUGPRINT_
      write(u6,*) 'restart_check: DATA, input_file_name='
      write(u6,*) input_file_name
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('TINT')
      if (.not. TINPUT) then
        TCHECK = .true.

        read(u5,*,iostat=istatus) t1,t2,nT
        if (istatus < 0) call Error(2)

        if ((t1 < 0) .or. (t2 < 0)) then
          call WarningMessage(2,'TINT: negative temperature requested! ')
          call Quit_OnUserError()
        end if
        if ((t1-t2) > Zero) then
          Tmin = t2
          Tmax = t1
        else if ((t1-t2) < Zero) then
          Tmin = t1
          Tmax = t2
        else ! t1==t2
          call WarningMessage(2,'TINT: temperature interval == 0! ')
          call Quit_OnUserError()
        end if

#       ifdef _DEBUGPRINT_
        write(u6,*) 'TINT: Tmin, Tmax, nT=',Tmin,Tmax,nT
#       endif
      else
        write(u6,*) 'READIN_SINGLE: the TINT command is incompatible with TEXP'
        call ABEnd()
      end if
      LINENR = LINENR+1
    !-------------------------------------------
    case ('XFIE')
      read(u5,*,iostat=istatus) Xfield
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'XFIE: Xfield=',Xfield
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('HINT')
      if (.not. HINPUT) then
        HCHECK = .true.
        compute_magnetization = .true.

        read(u5,*,iostat=istatus) t1,t2,nH
        if (istatus < 0) call Error(2)

        if ((t1 < 0) .or. (t2 < 0)) then
          call WarningMessage(2,'HINT: negative field requested! ')
          call Quit_OnUserError()
        end if

        if ((t1-t2) > Zero) then
          Hmin = t2
          Hmax = t1
        else if ((t1-t2) < Zero) then
          Hmin = t1
          Hmax = t2
        else ! t1 == t2
          call WarningMessage(2,'HINT: temperature interval == 0! ')
          call Quit_OnUserError()
        end if

#       ifdef _DEBUGPRINT_
        write(u6,*) 'HINT: Hmin, Hmax, nH=',Hmin,Hmax,nH
#       endif
      else
        write(u6,*) 'READIN_SINGLE: the HINT command is incompatible with HEXP'
        call ABEnd()
      end if
      LINENR = LINENR+1
    !-------------------------------------------
    case ('NCUT')
      if (ENCUT_check) then
        write(u6,*) 'READIN_SINGLE: NCUT, ERAT and ENCU are mutually exclusive.'
        call ABEnd()
      end if
      ENCUT_check = .true.
      compute_magnetization = .true. ! request for computation of M(H)
      encut_definition = 1

      read(u5,*,iostat=istatus) NCUT  ! E_cut=ESO(Ncut)
      if (istatus < 0) call Error(2)

      if (NCUT < 0) then
        call WarningMessage(2,'NCUT: negative NCUT requested! ')
        call Quit_OnUserError()
      else if (NCUT == 0) then
        call WarningMessage(2,'NCUT: zero NCUT requested! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'NCUT: NCUT=',NCUT
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('ENCU')
      if (ENCUT_check) then
        write(u6,*) 'READIN_SINGLE: NCUT, ERAT and ENCU are mutually exclusive.'
        call ABEnd()
      end if
      ENCUT_check = .true.
      compute_magnetization = .true.
      encut_definition = 2

      read(u5,*,iostat=istatus) NK,MG
      if (istatus < 0) call Error(2)

      if ((NK <= 0) .or. (MG <= 0)) then
        call WarningMessage(2,'ENCU: zero or negative NK,MG requested! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'ENCU: NK, MG=',NK,MG
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('ERAT')
      if (ENCUT_check) then
        write(u6,*) 'READIN_SINGLE: NCUT, ERAT and ENCU are mutually exclusive.'
        call ABEnd()
      end if
      ENCUT_check = .true.
      compute_magnetization = .true.
      encut_definition = 3
      ! Ncut = INT(nss*encut_rate)
      ! E_cut = E(Ncut)

      read(u5,*,iostat=istatus) encut_rate
      if (istatus < 0) call Error(2)

      if (encut_rate <= Zero) then
        call WarningMessage(2,'ERAT: zero or negative encut rate requested! ')
        call Quit_OnUserError()
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) 'ERAT: encut_rate=',encut_rate
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('MVEC')
      compute_magnetization = .true.   ! request for computation of M(H)
      compute_Mdir_vector = .true.
      read(u5,*,iostat=istatus) nDir
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'MVEC: nDir=',nDir
#     endif
      do i=1,nDir
        read(u5,*,iostat=istatus) DirX(i),DirY(i),DirZ(i)
        if (istatus < 0) call Error(2)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'MVEC: DirX,DirY,DirZ=',DirX(i),DirY(i),DirZ(i)
#       endif
      end do
      ! some processing:
      do i=1,nDir
        rsum = DirX(i)*DirX(i)+DirY(i)*DirY(i)+DirZ(i)*DirZ(i)
        if (rsum == Zero) then
          write(err_msg,'(a,i3,a)') 'error: MVEC  vector ',i,'has the modulus = 0.0.'
          call WarningMessage(2,err_msg)
          call Quit_OnUserError()
        end if
        if (rsum /= One) then
          write(u6,'(a,i3,a)') 'the vector',i,'was re-normalized.'
          tmp = dirX(i)/sqrt(rsum)
          dirX(i) = tmp
          tmp = dirY(i)/sqrt(rsum)
          dirY(i) = tmp
          tmp = dirZ(i)/sqrt(rsum)
          dirZ(i) = tmp
        end if
      end do

      LINENR = LINENR+NDIR+1
    !-------------------------------------------
    case ('MAVE')
      compute_magnetization = .true.

      read(u5,*,iostat=istatus) nsymm,ngrid
      if (istatus < 0) call Error(2)

#     ifdef _DEBUGPRINT_
      write(u6,*) 'MAVE: nsymm, ngrid=',nsymm,ngrid
#     endif
      if ((nsymm < 1) .or. (nsymm > 3)) then
        write(u6,'(A)') '"nsymm" must take Integer values 1, 2 or 3.'
        write(u6,'(A,i5)') '"nsymm" = ',nsymm
        call Quit_OnUserError()
      end if
      if ((ngrid < 1) .or. (ngrid > 32)) then
        write(u6,'(A)') '"ngrid" must take Integer values 1, 2, ... 32.'
        write(u6,'(A,i5)') '"ngrid" = ',ngrid
        call Quit_OnUserError()
      end if
      LINENR = LINENR+1
    !-------------------------------------------
    !case ('TLIN')
    !  read(u5,*,iostat=istatus) T1,T2
    !  if (istatus < 0) call Error(2)
    !  LINENR = LINENR+1
    !-------------------------------------------
    case ('SMAG')
      smagn = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'SMAG: =',smagn
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('PLOT')
      doplot = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'PLOT: =',doplot
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('TEXP')
      if (.not. TCHECK) then
        TINPUT = .true.
        read(u5,*,iostat=istatus) NT
        if (istatus < 0) call Error(2)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'TEXP: nT=',nT
#       endif
        do i=1,NT
          read(5,*,iostat=istatus) texp(i),chit_exp(i)
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'TEXP: texp(i), chit_exp(i)=',texp(i),chit_exp(i)
#         endif
          ! check and clean negative values:
          if (texp(i) < Zero) texp(i) = abs(texp(i))
          if (chit_exp(i) < Zero) chit_exp(i) = abs(chit_exp(i))
        end do
        tmin = texp(1)
        tmax = texp(nT)
      else
        write(u6,*) 'READIN_SINGLE: the TINT command is incompatible with TEXP'
        call ABEnd()
      end if
      LINENR = LINENR+NT+1
    !-------------------------------------------
    case ('HEXP')
      compute_magnetization = .true.
      if (checkTMAG) write(u6,'(A)') 'The data provided in TMAG will be ignored.'
      if (.not. HCHECK) then
        HINPUT = .true.
        read(u5,*) nTempMagn,(TempMagn(i),i=1,nTempMagn)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'HEXP: nTempMagn =',nTempMagn
        write(u6,*) 'HEXP: TempMagn()=',(TempMagn(i),i=1,nTempMagn)
#       endif
        read(u5,*) nH
#       ifdef _DEBUGPRINT_
        write(u6,*) 'HEXP: nH =',nH
#       endif
        if (nH < 0) nH = abs(nH)
        if (nH == 0) call Quit_OnUserError()
        do i=1,nH
          read(u5,*,iostat=istatus) Hexp(i),(magn_exp(i,j),j=1,nTempMagn)
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'HEXP: Hexp(i),  magn_exp(i,j)=',Hexp(i),(magn_exp(i,j),j=1,nTempMagn)
#         endif
          ! check and clean negative values:
          if (hexp(i) < Zero) hexp(i) = abs(hexp(i))
          do j=1,nTempMagn
            if (magn_exp(i,j) < Zero) magn_exp(i,j) = abs(magn_exp(i,j))
          end do
        end do
        hmin = hexp(1)
        hmax = hexp(nH)
      else
        write(u6,*) 'READIN_SINGLE: the HINT command is incompatible with HEXP'
        call ABEnd()
      end if
      LINENR = LINENR+NH+2
    !-------------------------------------------
    case ('ZJPR')
      read(u5,*,iostat=istatus) ZJ
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'ZJPR: zJ =',zJ
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('TORQ')
      compute_torque = .true.
      read(u5,*,iostat=istatus) AngPoints,H_torq,T_torq
      if (istatus < 0) call Error(2)
      LINENR = LINENR+1
    !-------------------------------------------
    case ('TMAG')
      if (.not. HINPUT) then
        compute_magnetization = .true.
        checkTMAG = .true.

        read(u5,*,iostat=istatus) nTempMagn,(TempMagn(i),i=1,nTempMagn)
        if (istatus < 0) call Error(2)

        do i=1,nTempMagn
          if (TempMagn(i) <= Zero) then
            call WarningMessage(2,'TMAG: zero or negative temperature requested! ')
            if (TempMagn(i) < Zero) TempMagn(i) = abs(TempMagn(i))
            if (TempMagn(i) == Zero) TempMagn(i) = 0.0001_wp
          end if
        end do

#       ifdef _DEBUGPRINT_
        write(u6,*) 'TMAG: nTempMagn =',nTempMagn
        write(u6,*) 'TMAG: TempMagn()=',(TempMagn(i),i=1,nTempMagn)
#       endif
        ! check and clean negative values:
      else
        write(u6,'(A)') 'TMAG data is taken from HEXP.'
      end if
      LINENR = LINENR+1
    !-------------------------------------------
    case ('PRLV')
      read(u5,*,iostat=istatus) IPRINT
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'PRLV: IPRINT =',iPrint
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('POLY')
#     ifdef _DEBUGPRINT_
      write(u6,*) 'POLY:'
#     endif
      POLY_FILE = .true.
    !-------------------------------------------
    case ('CRYS')
      compute_CF = .true.
      read(u5,*,iostat=istatus) cME
      uME = cME
      call UpCase(uME)
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'CRYS: cME =',cME
#     endif

      select case (uME)
        ! LANTHANIDES
        case (clanth(1)) ! Ce
          nlanth = 1
          nDIMcf = 6  ! f1; multiplet J=L-S=3-1/2=5/2  =>  J = 2F_5/2
          lDIMCF = 7  ! (L=3)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(2)) ! Pr
          nlanth = 2
          nDIMcf = 9  ! f2; multiplet J=L-S=5-1=4  => J = 3H_4
          lDIMCF = 11 ! (L=5)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(3)) ! Nd
          nlanth = 3
          nDIMcf = 10 ! f3; multiplet J=L-S=6-3/2=9/2  => J = 4I_9/2
          lDIMCF = 13 ! (L=6)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(4)) ! Pm
          nlanth = 4
          nDIMcf = 9  ! f4; multiplet J=L-S=6-2=4  => J = 5I_4
          lDIMCF = 13 ! (L=6)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(5)) ! Sm
          nlanth = 5
          nDIMcf = 6  ! f5; multiplet J=L-S=5-5/2=5/2  => J = 6H_5/2
          lDIMCF = 11 ! (L=5)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(6)) ! Eu
          nlanth = 6
          nDIMcf = 1  ! f6; multiplet J=L-S=3-3=0  => J = 3F_0
          lDIMCF = 7  ! (L=3)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(7)) !Gd
          nlanth = 7
          nDIMcf = 8  ! f7; multiplet J=L+S=0+7/2=0  => J = 8S_7/2
          lDIMCF = 1  ! (L=0)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(8)) !Tb
          nlanth = 8
          nDIMcf = 13 ! f8; multiplet J=L+S=3+3=0  => J = 7F_6
          lDIMCF = 7  ! (L=3)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(9)) ! Dy
          nlanth = 9
          nDIMcf = 16 ! f9; multiplet J=L+S=5+5/2=15/2  => J = 6H_15/2
          lDIMCF = 11 ! (L=5)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(10)) ! Ho
          nlanth = 10
          nDIMcf = 17 ! f10; multiplet J=L+S=6+2=8  => J = 5I_8
          lDIMCF = 13 ! (L=6)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(11)) ! Er
          nlanth = 11
          nDIMcf = 16 ! f11; multiplet J=L+S=6+3/2=15/2  => J = 4I_15/2
          lDIMCF = 13 ! (L=6)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(12)) ! Tm
          nlanth = 12
          nDIMcf = 13 ! f12; multiplet J=L+S=5+1=6  => J = 3H_6
          lDIMCF = 11 ! (L=5)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(13)) ! Yb
          nlanth = 13
          nDIMcf = 8  ! f13; multiplet J=L+S=3+1/2=7/2  => J = 2F_7/2
          lDIMCF = 7  ! (L=3)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(14)) !Lu
          nlanth = 14
          nDIMcf = 1  ! f14; multiplet J=L+S=0+0=0  => J = 1S_0
          lDIMCF = 1  ! (L=0)
        !- - - - - - - - - - - - - - - - - - - -
        ! ACTINIDES
        case (clanth(15)) ! Th
          nlanth = 15
          nDIMcf = 6  ! f1; multiplet J=L-S=3-1/2=5/2  =>  J = 2F_5/2
          lDIMCF = 7  ! (L=3)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(16)) ! Pa
          nlanth = 16
          nDIMcf = 9  ! f2; multiplet J=L-S=5-1=4  => J = 3H_4
          lDIMCF = 11 ! (L=5)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(17)) ! U
          nlanth = 17
          nDIMcf = 10 ! f3; multiplet J=L-S=6-3/2=9/2  => J = 4I_9/2
          lDIMCF = 13 ! (L=6)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(18)) ! Np
          nlanth = 18
          nDIMcf = 9  ! f4; multiplet J=L-S=6-2=4  => J = 5I_4
          lDIMCF = 13 ! (L=6)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(19)) ! Pu
          nlanth = 19
          nDIMcf = 6  ! f5; multiplet J=L-S=5-5/2=5/2  => J = 6H_5/2
          lDIMCF = 11 ! (L=5)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(20)) ! An
          nlanth = 20
          nDIMcf = 1  ! f6; multiplet J=L-S=3-3=0  => J = 3F_0
          lDIMCF = 7  ! (L=3)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(21)) ! Cm
          nlanth = 21
          nDIMcf = 8  ! f7; multiplet J=L+S=0+7/2=0  => J = 8S_7/2
          lDIMCF = 1  ! (L=0)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(22)) ! Bk
          nlanth = 22
          nDIMcf = 13 ! f8; multiplet J=L+S=3+3=0  => J = 7F_6
          lDIMCF = 7  ! (L=3)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(23)) ! Cf
          nlanth = 23
          nDIMcf = 16 ! f9; multiplet J=L+S=5+5/2=15/2  => J = 6H_15/2
          lDIMCF = 11 ! (L=5)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(24)) ! Es
          nlanth = 24
          nDIMcf = 17 ! f10; multiplet J=L+S=6+2=8  => J = 5I_8
          lDIMCF = 13 ! (L=6)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(25)) ! Fm
          nlanth = 25
          nDIMcf = 16 ! f11; multiplet J=L+S=6+3/2=15/2  => J = 4I_15/2
          lDIMCF = 13 ! (L=6)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(26)) ! Md
          nlanth = 26
          nDIMcf = 13 ! f12; multiplet J=L+S=5+1=6  => J = 3H_6
          lDIMCF = 11 ! (L=5)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(27)) ! No
          nlanth = 27
          nDIMcf = 8  ! f13; multiplet J=L+S=3+1/2=7/2  => J = 2F_7/2
          lDIMCF = 7  ! (L=3)
        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(28)) ! Lr
          nlanth = 28
          nDIMcf = 1  ! f14; multiplet J=L+S=0+0=0  => J = 1S_0
          lDIMCF = 1  ! (L=0)

        !------------------- transition metals ------------------------!
        case (clanth(29)) ! Sc

          nlanth = 29
          ! Sc2+ -- d^1
          read(u5,*,iostat=istatus) i_OxStat
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth
#         endif

          if (i_OxStat < 0) then
            write(u6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',i_OxStat
            write(u6,'(A)') 'It was re-set to positive.'
            i_OxStat = abs(i_OxStat)
          end if
          if (i_OxStat < 2) then
            lDIMCF = 1 ! (L=0)
            write(u6,'(A)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else if (i_OxStat == 2) then
            lDIMCF = 5 ! (L=2) d^1
          else
            lDIMCF = 1 ! (L=0)
            write(u6,'(A)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          end if

        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(30)) ! Ti

          nlanth = 30
          ! Ti2+ -- d^2
          ! Ti3+ -- d^1
          ! Ti4+ -- d^0
          read(u5,*,iostat=istatus) i_OxStat
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth
#         endif

          if (i_OxStat < 0) then
            write(u6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',i_OxStat
            write(u6,'(A)') 'It was re-set to positive.'
            i_OxStat = abs(i_OxStat)
          end if
          if (i_OxStat < 2) then
            lDIMCF = 1 ! (L=0)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else if (i_OxStat == 2) then
            lDIMCF = 7 ! (L=3) d^2  3F
          else if (i_OxStat == 3) then
            lDIMCF = 5 ! (L=2) d^1  2D
          else
            lDIMCF = 1 ! (L=0) d^4
            write(u6,'(A)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          end if

        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(31)) ! V

          nlanth = 31
          ! V2+ -- d^3
          ! V3+ -- d^2
          ! V4+ -- d^1
          read(u5,*,iostat=istatus) i_OxStat
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth
#         endif

          if (i_OxStat < 0) then
            write(u6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',i_OxStat
            write(u6,'(A)') 'It was re-set to positive.'
            i_OxStat = abs(i_OxStat)
          end if
          if (i_OxStat < 2) then
            lDIMCF = 1 ! (L=0)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else if (i_OxStat == 2) then
            lDIMCF = 7 ! (L=3) d^3
          else if (i_OxStat == 3) then
            lDIMCF = 7 ! (L=3) d^2
          else if (i_OxStat == 4) then
            lDIMCF = 5 ! (L=2) d^1
          else
            lDIMCF = 1 ! (L=0) d^4
            write(u6,'(A)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          end if

        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(32)) ! Cr

          nlanth = 32
          ! Cr3+ -- d^4
          read(u5,*,iostat=istatus) i_OxStat
          if (istatus < 0) call Error(2)

          if (i_OxStat < 0) then
            write(u6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',i_OxStat
            write(u6,'(A)') 'It was re-set to positive.'
            i_OxStat = abs(i_OxStat)
          end if
          if (i_OxStat == 2) then
            lDIMCF = 5 ! (L=2) d^4
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
          else if (i_OxStat == 3) then
            lDIMCF = 7 ! (L=3) d^3
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
          else if (i_OxStat == 4) then
            lDIMCF = 7 ! (L=3) d^2
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
          else if (i_OxStat == 5) then
            lDIMCF = 5 ! (L=2) d^1
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
          else
            lDIMCF = 1 ! (L=0)
            write(u6,'(A)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          end if
          write(u6,'(A)') 'Crystal field will not be computed'

        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(33)) ! Mn

          nlanth = 33
          ! Mn3+ -- d^4
          read(u5,*,iostat=istatus) i_OxStat
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth
#         endif

          if (i_OxStat < 0) then
            write(u6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',i_OxStat
            write(u6,'(A)') 'It was re-set to positive.'
            i_OxStat = abs(i_OxStat)
          end if
          if (i_OxStat < 3) then
            lDIMCF = 1 ! (L=0)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else if (i_OxStat == 3) then
            lDIMCF = 5 ! (L=2) d^4
          else
            lDIMCF = 1 ! (L=0)
            write(u6,'(A)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          end if

        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(34)) ! Fe

          nlanth = 34
          ! Co2+ -- d^6 or d^4
          read(u5,*,iostat=istatus) i_OxStat
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth
#         endif

          if (i_OxStat < 0) then
            write(u6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',i_OxStat
            write(u6,'(A)') 'It was re-set to positive.'
            i_OxStat = abs(i_OxStat)
          end if
          if (i_OxStat < 2) then
            lDIMCF = 1 ! (L=0)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else if (i_OxStat == 2) then
            lDIMCF = 5 ! (L=2)  d^6  or  d^4
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
          else if (i_OxStat == 3) then
            lDIMCF = 1 ! (L=2)  d^5
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else if (i_OxStat == 4) then
            lDIMCF = 1 ! (L=2)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else
            lDIMCF = 1 ! (L=0)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          end if

        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(35)) ! Co

          nlanth = 35
          ! Co2+ -- d^7
          read(u5,*,iostat=istatus) i_OxStat
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth
#         endif

          if (i_OxStat < 0) then
            write(u6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',i_OxStat
            write(u6,'(A)') 'It was re-set to positive.'
            i_OxStat = abs(i_OxStat)
          end if
          if (i_OxStat < 2) then
            lDIMCF = 1 ! (L=0)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else if (i_OxStat == 2) then
            lDIMCF = 7 ! (L=3) d^7
          else
            lDIMCF = 1 ! (L=0)
            write(u6,'(A)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          end if

        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(36)) ! Ni

          nlanth = 36
          ! Ni2+ -- d^8
          read(u5,*,iostat=istatus) i_OxStat
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth
#         endif

          if (i_OxStat < 0) then
            write(u6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',i_OxStat
            write(u6,'(A)') 'It was re-set to positive.'
            i_OxStat = abs(i_OxStat)
          end if
          if (i_OxStat < 2) then
            lDIMCF = 1 ! (L=0)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else if (i_OxStat == 2) then
            lDIMCF = 7 ! (L=2) d^8
          else
            lDIMCF = 1 ! (L=0)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          end if

        !- - - - - - - - - - - - - - - - - - - -
        case (clanth(37)) ! Cu

          nlanth = 37
          ! Cu2+ -- d^9
          read(u5,*,iostat=istatus) i_OxStat
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'CRYS: i_OxStat =',i_OxStat,'nlanth=',nlanth
#         endif

          if (i_OxStat < 0) then
            write(u6,'(3A,i5)') 'Oxidation state of',cME,'is negative:',i_OxStat
            write(u6,'(A)') 'It was re-set to positive.'
            i_OxStat = abs(i_OxStat)
          end if
          if (i_OxStat < 2) then
            lDIMCF = 1 ! (L=0)
            write(u6,'(3A,i5)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          else if (i_OxStat == 2) then
            lDIMCF = 5 ! (L=2) d^9
          else
            lDIMCF = 1 ! (L=0) d^4
            write(u6,'(A)') 'Oxidation state of ',cME,' is:',i_OxStat
            write(u6,'(A)') 'Crystal field will not be computed'
          end if

        !- - - - - - - - - - - - - - - - - - - -
        case default
          write(u6,'(A)') 'Label of the metal is not understood.'
          write(u6,'(A)') 'Crystal field will not be computed'
      end select

      if (IPRINT > 2) then
        write(u6,'(5x,3A)') 'SINGLE_ANISO will calculate the parameters of the crystal field for Ln = ',clanth(nlanth),','
        write(u6,'(5x,A,I2,a)') 'for the ground multiplet J. Multiplicity of J = ',nDIMcf,' and'
        write(u6,'(5x,A,I2)') 'for the ground LS term. Multiplicity of L = ',lDIMcf
      end if
      LINENR = LINENR+1
    !-------------------------------------------
    case ('QUAX')
      !if (check_CRYS) then
      read(u5,*,iostat=istatus) axisoption
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'QUAX: axisoption =',axisoption
#     endif
      LINENR = LINENR+1

      if ((axisoption < 1) .or. (axisoption > 3)) &
        call WarningMessage(2,'QUAX: axisoption out of range! Calculation will continue by employing the default option.')
      if (axisoption == 3) then
        do j=1,3
          read(u5,*,iostat=istatus) (zmagn(i,j),i=1,3)
          if (istatus < 0) call Error(2)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'QUAX: zmagn(i,j) =',(zmagn(i,j),i=1,3)
#         endif
        end do
        LINENR = LINENR+3
      end if
      !else
      !  write(u6,'(A)') 'The CRYS keyword must be declared above QUAX in the input!'
      !end if
    !-------------------------------------------
    case ('PREX')
      LINENR = LINENR+1
    !-------------------------------------------
    case ('UBAR')
      compute_barrier = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'UBAR:'
#     endif
      LINENR = LINENR+1
    !-------------------------------------------
    case ('ABCC')
      Do_structure_abc = .true.
      read(u5,*,iostat=istatus) (cryst(i),i=1,6)
      if (istatus < 0) call Error(2)

      do i=1,6
        if (cryst(i) <= 0) then
          call WarningMessage(2,'ABCC: zero or negative crystallographic parameters requested! ')
          call Quit_OnUserError()
        end if
      end do

#     ifdef _DEBUGPRINT_
      write(u6,*) 'ABCC: (cryst(i),i=1,6)=',(cryst(i),i=1,6)
#     endif
      read(u5,*,iostat=istatus) (coord(i),i=1,3)
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'ABCC: (coord(i),i=1,3)=',(coord(i),i=1,3)
#     endif
      LINENR = LINENR+2
      ! array "cryst" collects the crystallographic data:
      !  cryst(1)= a
      !  cryst(2)= b
      !  cryst(3)= c
      !  cryst(4)= alpha
      !  cryst(5)= beta
      !  cryst(6)= gamma
      !  coord(i) =the coordinates of the magnetic center in "abc" axes
      !  logical variable 'Do_structure_abc' will make the program compute
      !  the magnetic and anisotropy axes in the "abc" coordinate system
    !-------------------------------------------
    case ('ZEEM')
      zeeman_energy = .true.
      compute_magnetization = .true.

      read(u5,*,iostat=istatus) nDirZee
      if (istatus < 0) call Error(2)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'ZEEM: nDirZee=',nDirZee
#     endif

      do i=1,nDirZee
        ! open the zeeman_energy_xxx.txt file where Zeeman eigenstates will
        ! be further written in mangetization() subroutine
        write(namefile_energy,'(5A)') 'zeeman_energy_',char(48+mod(i/100,10)),char(48+mod(i/10,10)),char(48+mod(i,10)),'.txt'
        !print *, 'namefile_energy: ', namefile_energy
        LUZee(i) = IsFreeUnit(30+i)
        call molcas_open(LUZee(i),namefile_energy)
        !open(30+i,file=namefile_energy)

        read(u5,*,iostat=istatus) (dir_weight(i,l),l=1,3)
        if (istatus < 0) call Error(2)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'ZEEM: (dir_weight(i,l),l=1,3)=',(dir_weight(i,l),l=1,3)
#       endif

        check_dir_weight = sqrt(dir_weight(i,1)**2+dir_weight(i,2)**2+dir_weight(i,3)**2)

        if (abs(check_dir_weight-One) > 0.005_wp) then
          write(u6,'(A)') 'The directions for the magnetic field for the computation of the Zeeman splitting are wrong.'
          write(u6,'(A)') '( px^2 + py^2 + pz^2 ) must give 1.!'
          write(u6,'(A,I3,2x,A,F9.5)') 'In the present case for direction Nr.',i,' the dir_weight = px^2 + py^2 + pz^2 = ', &
                                       check_dir_weight**2
          LINENR = LINENR+2+i
          write(u6,*) ' READIN_SINGLE: Error reading standard input.'
          write(u6,*) ' SINGLE_ANISO input near line nr.',LINENR+1
          call ABEnd()
        end if

      end do
      LINENR = LINENR+nDirZee+1
    !-------------------------------------------
  end select
end do

if (IPRINT > 2) write(u6,'(5X,A)') 'NO ERROR WAS LOCATED WHILE READING INPUT'

if (compute_CF) then
  if (axisoption == 3) then
    ! check the determinant of the ZMAGN
    ZR(:,:) = zmagn(:,:)
    Det_zmagn = FindDetR(ZR,3)
    if (Det_zmagn < Zero) then
      write(u6,'(A)') 'QUAX: The determinant of the rotation matrix provided in the input is NEGATIVE.'
      write(u6,'(A,F22.14)') 'Determinant = ',Det_zmagn
      write(u6,'(A)') 'This means that the matrix you have provided can be decomposed in a product of two '
      write(u6,'(A)') 'matrices: Rotation*Inversion'
      write(u6,'(A)') 'The determinant of the Rotation matrix must be POSITIVE.'
      write(u6,'(A)') 'The program will stop.'
      return
    end if

    ! check the orthogonality of the ZMAGN:
    column_check(:,:) = Zero
    row_check(:,:) = Zero
    do j=1,3
      do L=1,3
        column_check(:,j) = column_check(:,j)+zmagn(:,L)*zmagn(j,L)
        row_check(:,j) = row_check(:,j)+zmagn(L,:)*zmagn(L,j)
      end do
    end do

    do i=1,3
      do j=i+1,3
        if (i == j) cycle
        if ((abs(column_check(1,2)) > 0.0001_wp) .or. (abs(column_check(1,3)) > 0.0001_wp) .or. &
            (abs(column_check(2,3)) > 0.0001_wp) .or. (abs(row_check(1,2)) > 0.0001_wp) .or. &
            (abs(row_check(1,3)) > 0.0001_wp) .or. (abs(row_check(2,3)) > 0.0001_wp)) then
          write(u6,'(A)') 'QUAX: The rotation matrix is not UNITARY.'
          write(u6,'(A,F19.14)') 'column_check(1,2) = ',column_check(1,2)
          write(u6,'(A,F19.14)') 'column_check(1,3) = ',column_check(1,3)
          write(u6,'(A,F19.14)') 'column_check(2,3) = ',column_check(2,3)
          write(u6,'(A,F19.14)') '   row_check(1,2) = ',row_check(1,2)
          write(u6,'(A,F19.14)') '   row_check(1,3) = ',row_check(1,3)
          write(u6,'(A,F19.14)') '   row_check(2,3) = ',row_check(2,3)
          write(u6,'(A)') 'All above values must be exact 0.0.'
          write(u6,'(A)') 'Or at least less than than 0.0001.'
          write(u6,'(A)') 'Did you employ enough digits for the rotation matrix?'
          write(u6,'(A)') 'The program will stop.'
          return
        end if
      end do
    end do
  end if ! axisoption
end if ! compute_CF

! preparing the info for computation of molar magnetization
ngrid = ngrid_map(ngrid)
if (compute_magnetization) then
  ! calculate the total number of directions for the average procedure
  nDirTot = order_table(nsymm,ngrid)
  if (zeeman_energy) nDirTot = nDirTot+nDirZee
  if (compute_Mdir_vector) nDirTot = nDirTot+nDir
end if

!------ CHECK the data from INPUT ------------------------------
!if (iprint > 10) then

# ifdef _DEBUGPRINT_
write(u6,'(A,  F9.5)') 'ZJPR :         = ',zJ
write(u6,'(A,  I3  )') 'PRLV :         = ',iprint
# endif

!if (.not. compute_g_tensors) then
!  !generate an array of 10 low-lying groups of states
!
!  ndim(:) = 0
!  nmult_try = 10
!  j = 0
!  ndim(i) = 1
!  do i=1,nss
!    etmp = eso(i)
!    do k=i+1,nss
!      if (abs(eso(k)-etmp) < 0.01_wp) ndim(i) = ndim(i)+1
!    end do
!  end do
!end if

if (compute_g_tensors) then
  if (NMULT > 0) then
    write(u6,'(A,I3)') 'MLTP :         = ',NMULT
    if (NMULT <= 20) then
      write(u6,'(A,20I3)') '               = ',(NDIM(i),i=1,NMULT)
    else
      write(u6,'(A,20I3)') '               = ',(NDIM(i),i=1,20)
      do j=21,NMULT,20
        jEnd = min(NMULT,J+19)
        write(u6,'(A,20I3)') '                 ',(NDIM(i),i=j,jEnd)
      end do
    end if
  else
    write(u6,'(A)') 'MLTP :         =  No pseudospin Hamiltonians will be computed. Is MLTP defined?'
  end if
end if

if (compute_CF .and. (nDIMcf <= nss) .and. (lDIMcf <= nstate)) then
  if (nlanth < 15) then
    write(u6,'(3A)') 'The Crystal-Field acting on the ground atomic multiplet of Ln = ',clanth(nlanth),' is computed.'
  else if ((nlanth >= 15) .and. (nlanth < 29)) then
    write(u6,'(3A)') 'The Crystal-Field acting on the ground atomic multiplet of Ac = ',clanth(nlanth),' is computed.'
  else if (nlanth >= 29) then
    write(u6,'(3A)') 'The Crystal-Field acting on the ground atomic |L,ML> multiplet of TM = ',clanth(nlanth),' is computed.'
  end if

  write(u6,'(A,A )') 'CHIT :         = ',' molar magnetic susceptibility is computed'
  if (TINPUT) write(u6,'(A)') 'TEXP :         = the experimental temperature interval is read from the file "chitexp.input"'
  write(u6,'(A, I3)') 'TINT :      nT = ',nT
  write(u6,'(A,F7.3)') '          Tmin = ',Tmin
  write(u6,'(A,F7.3)') '          Tmax = ',Tmax

end if
!--------------------------------------------------------------------
if (compute_magnetization) then

  write(u6,'(A,A )') 'MAGN :         = ',' molar magnetization is computed'
  write(u6,'(A, I3)') 'NDIRTOT        = ',nDirTot
  write(u6,'(A, I3)') 'TMAG :         = ',nTempMagn
  write(u6,'(6x,A,20F7.3)') 'TempMagn = ',(TempMagn(i),i=1,nTempMagn)
  write(u6,'(A, I3)') 'HINT :      nH = ',nH
  write(u6,'(A,F7.3)') '          Hmin = ',Hmin
  write(u6,'(A,F7.3)') '          Hmax = ',Hmax
  write(u6,'(A, I3)') 'MAVE :   nDir = ',order_table(nsymm,ngrid)

  if (HINPUT) write(u6,'(A)') 'HEXP :         = the experimental field interval is read from the file "mexp.input"'
  if (encut_definition == 1) then
    write(u6,'(A, I3)') 'NCUT :         = ',ncut
  else if (encut_definition == 2) then
    write(u6,'(A,I4,a,i4)') 'ECUT :         = ',nk,', ',mg
  else if (encut_definition == 3) then
    write(u6,'(A,F7.3)') 'ERAT :         = ',encut_rate
  end if

  if (compute_Mdir_vector) then
    write(u6,'(A,20I3)') 'MVEC :         = ',nDir
    if (nDir > 0) then
      do i=1,nDir
        write(u6,'(A,I2,A,3F11.6)') '   Dir :',i,' : ',dirX(i),dirY(i),dirZ(i)
      end do
    end if
  end if
  if (zeeman_energy) then
    if (nDirZee == 1) then
      write(u6,'(2A,I2,1x,A)') 'ZEEM :         = ',' Zeeman splitting for the following direction of the '
      write(u6,'(18x,A)') 'applied magnetic field is given in the "zeeman_energy_xxx.txt" file in $WorkDir/'
    else if (nDirZee > 1) then
      write(u6,'(2A,I2,1x,A)') 'ZEEM :         = ',' Zeeman splitting for the following',nDirZee,' directions of the '
      write(u6,'(18x,A)') 'applied magnetic field are given in the "zeeman_energy_xxx.txt" files in $WorkDir/.'
    else
      write(u6,'(A)') 'Error in input processing. nDirZee<0!'
      call Quit_OnUserError()
    end if
    do i=1,nDirZee
      write(u6,'(17x,3F11.6)') (dir_weight(i,l),l=1,3)
    end do
  end if
end if ! magnetization
!--------------------------------------------------------------------

if (compute_torque) write(u6,'(A,A )') 'TORQ :         = ',' torque magnetization is computed'

if (doplot) write(u6,'(A,A )') 'PLOT :         = ',' GNUPLOT scripts and corresponding XT, M and UBAR plots will be generated'

if (Do_structure_abc) then
  write(u6,'(2A)') 'ABCC :         = ','the main magnetic axes for the computed pseudospins are written also in the '
  write(u6,'( A)') 'crystallographic "abc" axes'
  write(u6,'(10x,A,F9.4)') 'a       = ',cryst(1)
  write(u6,'(10x,A,F9.4)') 'b       = ',cryst(2)
  write(u6,'(10x,A,F9.4)') 'c       = ',cryst(3)
  write(u6,'(10x,A,F9.4)') 'alpha   = ',cryst(4)
  write(u6,'(10x,A,F9.4)') 'beta    = ',cryst(5)
  write(u6,'(10x,A,F9.4)') 'gamma   = ',cryst(6)
  write(u6,'(10x,a,3F9.4)') 'coords: = ',(coord(i),i=1,3)
end if

if (compute_g_tensors .and. compute_barrier) then
  Nblock = sum(ndim(1:nMult))
  write(u6,'(A,i4)') 'nBlock = ',nBlock
end if

return

contains

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  select case (code)
    case (1)
      write(u6,*) ' READIN_SINGLE: Unexpected End of input file.'
    case (2)
      write(u6,*) ' READIN_SINGLE: Error reading standard input.'
      write(u6,*) ' SINGLE_ANISO input near line nr.',LINENR+1
  end select
  call ABEnd()

end subroutine Error

end subroutine readin_single

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine creates a model fock operator based on atomic orbital   *
! energies.                                                            *
!                                                                      *
! This is a very preliminary routine for testing purposes. It relies   *
! on the basis set being of ANO type.                                  *
!                                                                      *
! Absolutely NOT to be used for production!!!!                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: Oct 2004                                                    *
!                                                                      *
!***********************************************************************

subroutine FockOper(RC,Fock)

#include "intent.fh"

use GuessOrb_Global, only: Label, MxAtom, AtName, nBas, nNuc, nSym, xCharge
use Constants, only: Zero, One, Three, Six, Seven, Eight
use Definitions, only: wp, iwp, u6

implicit none
!----------------------------------------------------------------------*
! Dummy arguments                                                      *
!----------------------------------------------------------------------*
integer(kind=iwp), intent(out) :: RC
real(kind=wp), intent(_OUT_) :: Fock(*)
!----------------------------------------------------------------------*
! Local variables                                                      *
!----------------------------------------------------------------------*
integer(kind=iwp), parameter :: MxComp = 4
logical(kind=iwp) :: Debug, Trace, Found
integer(kind=iwp) :: iSym, iBas, iOff, iNuc, nBasTot, iUse(MxAtom,MxComp), nData, i, k, lenName
real(kind=wp) :: energy
!----------------------------------------------------------------------*
! Some setup                                                           *
!----------------------------------------------------------------------*
Debug = .false.
Trace = .false.
lenName = len(AtName)
if (Trace) write(u6,*) '>>> Entering fockoper'
RC = 0
!----------------------------------------------------------------------*
! Setup various counters.                                              *
!----------------------------------------------------------------------*
nBasTot = 0
do iSym=1,nSym
  nBasTot = nBasTot+nBas(iSym)
end do
!----------------------------------------------------------------------*
! Is Fock operator on disk?                                            *
!----------------------------------------------------------------------*
call Qpg_dArray('Eorb',Found,nData)
if (Found) then
  call Get_dArray('Eorb',Fock,nData)
  if (Debug) then
    write(u6,*)
    write(u6,*) 'Found Eorb'
    write(u6,'(10f12.6)') (Fock(i),i=1,nData)
    write(u6,*)
  end if
  if (.true.) return
end if
if (.true.) then
  RC = 1
  return
end if
write(u6,*) '***'
write(u6,*) '*** Warning: using built-in fock operator'
write(u6,*) '***'
!----------------------------------------------------------------------*
! Create model Fock operator.                                          *
!----------------------------------------------------------------------*
iOff = 0
do iSym=1,nSym
  if (Debug) then
    write(u6,*) '***'
    write(u6,*) '*** Symmetry',iSym
    write(u6,*) '***'
  end if
  do i=1,MxAtom
    do k=1,MxComp
      iUse(i,k) = 0
    end do
  end do
  do iBas=1,nBas(iSym)
    iNuc = 0
    do i=1,nNuc
      if (AtName(i) == Label(iBas+iOff)(1:lenName)) iNuc = i
    end do
    if (Debug) then
      write(u6,'(2(a,i3),3a,i3,f6.2)') 'iSym:',iSym,' iBas:',iBas,' = ',Label(iBas+iOff)(1:lenName),Label(iBas+iOff)(lenName+1:), &
                                       iNuc,xCharge(iNuc)
    end if
    if (iNuc == 0) then
      call SysAbendMsg('fockoper','Fatal','001')
    end if
    energy = Zero
    if (abs(xCharge(iNuc)-One) < 1.0e-3_wp) then
      if (Label(iBas+iOff)(lenName+1:) == '01s     ') then
        iUse(iNuc,1) = iUse(iNuc,1)+1
        if (iUse(iNuc,1) == 1) energy = -0.50000_wp
      end if
    else if (abs(xCharge(iNuc)-Three) < 1.0e-3_wp) then
      if (Label(iBas+iOff)(lenName+1:) == '01s     ') then
        iUse(iNuc,1) = iUse(iNuc,1)+1
        if (iUse(iNuc,1) == 1) energy = -2.47773_wp
        if (iUse(iNuc,1) == 2) energy = -0.19632_wp
      end if
    else if (abs(xCharge(iNuc)-Six) < 1.0e-3_wp) then
      if (Label(iBas+iOff)(lenName+1:) == '01s     ') then
        iUse(iNuc,1) = iUse(iNuc,1)+1
        if (iUse(iNuc,1) == 1) energy = -11.32554_wp
        if (iUse(iNuc,1) == 2) energy = -0.70563_wp
      else if (Label(iBas+iOff)(lenName+1:) == '02px    ') then
        iUse(iNuc,2) = iUse(iNuc,2)+1
        if (iUse(iNuc,2) == 1) energy = -0.43335_wp
      else if (Label(iBas+iOff)(lenName+1:) == '02py    ') then
        iUse(iNuc,3) = iUse(iNuc,3)+1
        if (iUse(iNuc,3) == 1) energy = -0.43335_wp
      else if (Label(iBas+iOff)(lenName+1:) == '02pz    ') then
        iUse(iNuc,4) = iUse(iNuc,4)+1
        if (iUse(iNuc,4) == 1) energy = -0.43335_wp
      end if
    else if (abs(xCharge(iNuc)-Seven) < 1.0e-3_wp) then
      if (Label(iBas+iOff)(lenName+1:) == '01s ') then
        iUse(iNuc,1) = iUse(iNuc,1)+1
        if (iUse(iNuc,1) == 1) energy = -15.62909_wp
        if (iUse(iNuc,1) == 2) energy = -0.94531_wp
      else if (Label(iBas+iOff)(lenName+1:) == '02px    ') then
        iUse(iNuc,2) = iUse(iNuc,2)+1
        if (iUse(iNuc,2) == 1) energy = -0.56758_wp
      else if (Label(iBas+iOff)(lenName+1:) == '02py    ') then
        iUse(iNuc,3) = iUse(iNuc,3)+1
        if (iUse(iNuc,3) == 1) energy = -0.56758_wp
      else if (Label(iBas+iOff)(lenName+1:) == '02pz    ') then
        iUse(iNuc,4) = iUse(iNuc,4)+1
        if (iUse(iNuc,4) == 1) energy = -0.56758_wp
      end if
    else if (abs(xCharge(iNuc)-Eight) < 1.0e-3_wp) then
      if (Label(iBas+iOff)(lenName+1:) == '01s ') then
        iUse(iNuc,1) = iUse(iNuc,1)+1
        if (iUse(iNuc,1) == 1) energy = -20.66866_wp
        if (iUse(iNuc,1) == 2) energy = -1.24433_wp
      else if (Label(iBas+iOff)(lenName+1:) == '02px    ') then
        iUse(iNuc,2) = iUse(iNuc,2)+1
        if (iUse(iNuc,2) == 1) energy = -0.63192_wp
      else if (Label(iBas+iOff)(lenName+1:) == '02py    ') then
        iUse(iNuc,3) = iUse(iNuc,3)+1
        if (iUse(iNuc,3) == 1) energy = -0.63192_wp
      else if (Label(iBas+iOff)(lenName+1:) == '02pz    ') then
        iUse(iNuc,4) = iUse(iNuc,4)+1
        if (iUse(iNuc,4) == 1) energy = -0.63192_wp
      end if
    else
      call SysAbendMsg('fockoper','Fatal','002')
    end if
    Fock(iOff+iBas) = energy
  end do
  iOff = iOff+nBas(iSym)
end do
!----------------------------------------------------------------------*
! Done, deallocate the rest.                                           *
!----------------------------------------------------------------------*
if (trace) write(u6,*) '<<< Exiting fockoper'

return

end subroutine FockOper

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine PotInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of potential integrals    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, January '91                             *
************************************************************************
      use Phase_Info
      Implicit Real*8 (A-H,O-Z)
*     Used for normal nuclear attraction integrals
      External TNAI, Fake, XCff2D, XRys2D
#include "real.fh"
#include "oneswi.fh"
#include "print.fh"

#include "int_interface.fh"

*-----Local variables
      Integer iStabO(0:7), iPh(3), iAnga(4), iDCRT(0:7)
      Real*8 TC(3), Coora(3,4), Coori(3,4), CoorAC(3,2)
      Logical EQ, NoSpecial
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      Call fzero(final,nZeta*nElem(la)*nElem(lb)*nIC)
      len=nZeta*nElem(la)*nElem(lb)*nIC
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = 0
      iAnga(4) = 0
      call dcopy_(3,A,1,Coora(1,1),1)
      call dcopy_(3,RB,1,Coora(1,2),1)
      call dcopy_(2*3,Coora,1,Coori,1)
      mabMin = nabSz(Max(la,lb)-1)+1
      mabMax = nabSz(la+lb)
      If (EQ(A,RB)) mabMin=nabSz(la+lb-1)+1
*
*     Compute FLOP's and size of work array which Hrr will use.
*
      Call mHrr(la,lb,nFLOP,nMem)
*
*     Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
         call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
         call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
      llOper = lOper(1)
*
*     Loop over grid
*
*-----------Find the DCR for M and S
*
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
c     Fact = DBLE(nStabM) / DBLE(LmbdT)
      FACT=1.D0

      nT = nZeta
      Chrg=-1.d0
      NoSpecial=.True.
*
      Do lDCRT = 0, nDCRT-1

         Do i = 1, 3
            iph(i) = iPhase(i,iDCRT(lDCRT))
         End Do
         nOp = NrOpr(iDCRT(lDCRT))

         Do 100 iGrid = 1, nGrid
            If (iAddPot.ne.0) Chrg=ptchrg(iGrid)
            If (Chrg.eq.Zero) Go To 100
*
               Do i = 1, 3
                  TC(i)=DBLE(iPh(i))*CCoor(i,iGrid)
                  CoorAC(i,2)=TC(i)
                  Coori(i,3)=TC(i)
                  Coori(i,4)=TC(i)
                  Coora(i,3)=TC(i)
                  Coora(i,4)=TC(i)
               End Do
*
*              Compute integrals with the Rys quadrature.
*
               Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &                  [One],[One],1,P,nZeta,
     &                  TC,1,rKappa,[One],Coori,Coora,CoorAC,
     &                  mabmin,mabmax,0,0,Array,nArr*nZeta,
     &                  TNAI,Fake,XCff2D,XRys2D,NoSpecial)
*
*--------------Use the HRR to compute the required primitive integrals.
*
               Call HRR(la,lb,A,RB,Array,nZeta,nMem,ipIn)
*
*--------------Accumulate contributions to the symmetry adapted operator
*
               Call SymAdO(Array(ipIn),nZeta,la,lb,nComp,Final,nIC,
     &                     nOp,lOper,iChO,-Fact*Chrg)
 100        Continue
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_integer(nHer)
         Call Unused_integer(nOrdOp)
      End If
      End
      SubRoutine Pot_nuc(CCoor,pot,nGrid)
      use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8  CCoor(3,nGrid),pot(nGrid)
      Real*8 C(3), TC(3)
      Integer iStabM(0:7),iDCRT(0:7)
*
*  compute nuclear contribution to potential
*
      kdc = 0
      Do iGrid=1,nGrid
         pot(iGrid)=0d0
      End Do
*
chjw is this always correct?
      istabm(0)=0
      nstabm=1
*
      Do 100 kCnttp = 1, nCnttp
         If (dbsc(kCnttp)%Charge.eq.Zero) Go To 111
*
         Do 101 kCnt = 1, dbsc(kCnttp)%nCntr
*
            C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab ,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
            Do lDCRT = 0, nDCRT-1
               Call OA(iDCRT(lDCRT),C,TC)
*
               Do iGrid=1,nGrid
                 r12=sqrt((TC(1)-CCoor(1,iGrid))**2
     &                   +(TC(2)-CCoor(2,iGrid))**2
     &                   +(TC(3)-CCoor(3,iGrid))**2)
                 if(r12.gt.1.d-8)
     &            pot(iGrid)=pot(iGrid)+dbsc(kCnttp)%Charge*fact/r12
               End Do
*
            End Do
 101     Continue
 111     kdc = kdc + dbsc(kCnttp)%nCntr
 100  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************

subroutine Mk_EOrb()

use InfSCF, only: CMO, EOrb, FockAO, nBas, nD, nOrb, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iD, nCMO, nEOrb, nFck

nFck = size(FockAO,1)
nEOrb = size(EOrb,1)
nCMO = size(CMO,1)

do iD=1,nD
  call MkEorb_Inner(FockAO(:,iD),nFck,CMO(:,iD),nCMO,EOrb(:,iD),nEorb,nSym,nBas,nOrb)
  if (iD == 1) then
    call Put_darray('OrbE',Eorb(:,iD),size(EOrb,1))
  else
    call Put_darray('OrbE_ab',Eorb(:,iD),size(EOrb,1))
  end if
end do

return

end subroutine Mk_EOrb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SubWorkDir()

use subdirs, only: f_setsubdir, Sub, OldWorkDir, NewWorkDir
use filesystem, only: getcwd_, chdir_, mkdir_
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, Length, iErr
integer(kind=iwp), parameter :: nFiles = 22
character(len=1024) :: Names(nFiles), OldFile(nFiles), NewFile(nFiles)
logical(kind=iwp) :: Found

! Define name of subdirectory and files that must be copied over
Sub = 'NG'
Names(:) = [character(len=len(Names)) :: &
            'RUNFILE', &
            'SEWARINP', &
            'SCFINP', &
            'RASSCINP', &
            'CASPTINP', &
            'MBPT2INP', &
            'RASSIINP', &
            'MOTRAINP', &
            'CCSDTINP', &
            'CHCCINP', &
            'CHT3INP', &
            'ESPFINP', &
            'FALSEINP', &
            'JOBIPH', &
            'ESPF.SAV', &
            'TINKER.XYZ', &
            'TINKER.KEY', &
            'MCPDFINP', &
            'CHEMNATFIE', &
            'CHEMCANFIE', &
            'CHEMNATMPS0', &
            'CHEMCANMPS0']

! Get real filenames to copy
do i=1,nFiles
  call prgmtranslate(Names(i),OldFile(i),Length)
end do

! Create the new directory and switch to it
call getcwd_(OldWorkDir)
NewWorkDir = trim(OldWorkDir)//'/'//trim(Sub)
call mkdir_(NewWorkDir)
call chdir_(NewWorkDir)
call f_setsubdir(Sub)

! Get real target filenames
do i=1,nFiles
  call prgmtranslate(Names(i),NewFile(i),Length)
  ! ESPF.SAV is copied to ESPF.DATA
  if (Names(i) == 'ESPF.SAV') then
    call prgmtranslate('ESPF.DATA',NewFile(i),Length)
  end if
end do

! Copy the files from the old directory to the new
do i=1,nFiles
  call f_inquire(OldFile(i),Found)
  if (Found) call fcopy(OldFile(i),NewFile(i),iErr)
end do

! The INPORB file is special...
call f_inquire('../INPORB',Found)
if (Found) call fcopy('../INPORB','./INPORB',iErr)

return

end subroutine SubWorkDir

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_VecBuf_Maintain(irc,iRed,DoTime,DoStat)
C
C     Purpose: maintain Cholesky vector buffer:
C
C              1) reorder vectors in buffer to current reduced set
C                 storage (defined by location 2),
C
C              2) if possible, read in new vectors and store in current
C                 reduced set storage (defined by location 2).
C
C              It is assumed that all vectors in the buffer are stored
C              according to the reduced set identified by iRed.
C
C     DoTime: time as vector I/O.
C     DoStat: update statistics info (#calls to system for I/O).
C
C     Return code:  irc  = 0 : success
C                   irc != 0 : failure
C
C     Index arrays from chovecbuf.fh modified by this routine:
C
C     NVEC_IN_BUF() -- #vectors stored in buffer in each symmetry
C
#include "implicit.fh"
      Logical DoTime, DoStat
#include "cholesky.fh"
#include "chovecbuf.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Character*19 SecNam
      Parameter (SecNam = 'Cho_VecBuf_Maintain')

      Logical LocDbg
#if defined (_DEBUGPRINT_)
      Parameter (LocDbg = .true.)
#else
      Parameter (LocDbg = .false.)
#endif

      Parameter (N2 = InfVec_N2)

      iRS3(i)=iWork(ip_iScr-1+i)
      InfVec(i,j,k)=iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)

C     Debug print.
C     ------------

      If (LocDbg) Then
         Write(Lupri,*) '>>>>> Enter ',SecNam,' <<<<<'
         Write(Lupri,*) 'iRed = ',iRed
         Write(Lupri,*) 'l_ChVBuf  = ',l_ChVBuf,
     &                  '   ip_ChVBuf = ',ip_ChVBuf
         Write(Lupri,'(A,8I8)') 'l_ChVBuf_Sym : ',
     &                          (l_ChVBuf_Sym(iSym),iSym=1,nSym)
         Write(Lupri,'(A,8I8)') 'ip_ChVBuf_Sym: ',
     &                          (ip_ChVBuf_Sym(iSym),iSym=1,nSym)
         Write(Lupri,'(A,8I8)') 'nVec_in_Buf  : ',
     &                          (nVec_in_Buf(iSym),iSym=1,nSym)
      End If

C     Set return code.
C     ----------------

      irc = 0

C     Return if there is no buffer to maintain.
C     -----------------------------------------

      If (l_ChVBuf .lt. 1) Then
         If (LocDbg) Then
            Write(Lupri,*) SecNam,': returning: no buffer to maintain!'
            Write(Lupri,*) SecNam,': l_ChVBuf = ',l_ChVBuf
         End If
         Return
      End If

C     If there are no vectors yet, return.
C     ------------------------------------

      If (NumChT .lt. 1) Then
         If (LocDbg) Then
            Write(Lupri,*) SecNam,': returning: no vectors!'
            Write(Lupri,*) SecNam,': NumChT = ',NumChT
         End If
         Return
      End If

C     Check that iScr array has been allocated.
C     -----------------------------------------

      If (l_iScr .lt. 1) Then
         Write(Lupri,*) SecNam,': iScr array not allocated!'
         irc = 102
         Return
      End If

C     Start timing.
C     -------------

      If (DoTime) Call Cho_Timer(C1,W1)

C     Set index arrays for reduced set iRed at location 3.
C     ----------------------------------------------------

      If (iRed .lt. 1) Then
         nErr = 0
         Do iSym = 1,nSym
            If (nVec_in_Buf(iSym) .ne. 0) Then
               Write(Lupri,*) SecNam,': sym. block ',iSym,':'
               Write(Lupri,*) '   iRed = ',iRed,
     &                        '   #vectors in buffer: ',
     &                        nVec_in_Buf(iSym),' (should be 0)'
               nErr = nErr + 1
            End If
         End Do
         If (nErr .ne. 0) Then
            irc = 103
            Return
         End If
         iRedC = 1
      Else
         iRedC = iRed
      End If

      Call Cho_X_SetRed(irc,3,iRedC)
      If (irc .ne. 0) Then
         Write(Lupri,*) SecNam,': Cho_X_SetRed returned ',irc
         irc = 104
         Return
      End If

C     Reordering.
C     ===========

      Do iSym = 1,nSym
         If (nnBstR(iSym,2).gt.0 .and. nVec_in_Buf(iSym).gt.0) Then

C           Check reduced set dimensions.
C           -----------------------------

            If (nnBstR(iSym,2) .gt. nnBstR(iSym,3)) Then
               Write(Lupri,*) SecNam,': dimension of reduced set at 2 ',
     &                        ' is larger than that at 3'
               Write(Lupri,*) 'Symmetry: ',iSym,'  ID of 3: ',iRedC
               Write(Lupri,*) 'Dimension of reduced set 2: ',
     &                        nnBstR(iSym,2)
               Write(Lupri,*) 'Dimension of reduced set 3: ',
     &                        nnBstR(iSym,3)
               Write(Lupri,*) 'Unable to continue...'
               irc = 104
               Return
            End If

C           Define mapping from reduced set at location 2 to that at
C           location 3.
C           --------------------------------------------------------

            Call Cho_RS2RS(iWork(ip_iScr),l_iScr,2,3,iRedC,iSym)

C           Reorder vectors.
C           ----------------

            Do iVec = 1,nVec_in_Buf(iSym)
               iOff2 = ip_ChVBuf_Sym(iSym) + nnBstR(iSym,2)*(iVec-1) - 1
               iOff3 = ip_ChVBuf_Sym(iSym) + nnBstR(iSym,3)*(iVec-1) - 1
               Do iRS2 = 1,nnBstR(iSym,2)
#if defined (_DEBUGPRINT_)
                  jRS3 = iRS3(iRS2)
                  If (jRS3.lt.1 .or. jRS3.gt.nnBstR(iSym,3)) Then
                     Call Cho_Quit('RS-2-RS map error in '//SecNam,104)
                  End If
#endif
                  Work(iOff2+iRS2) = Work(iOff3+iRS3(iRS2))
               End Do
            End Do

         End If
      End Do

C     Read in more vectors.
C     =====================

      nSys = 0 ! #calls to reading routine (counter)

      Call Cho_Mem('CHVB.Read','MAX ','Real',ip_VRd,l_VRd)
      Do iSym = 1,nSym
         nDisk = NumCho(iSym) - nVec_in_Buf(iSym)
#if defined (_DEBUGPRINT_)
         If (nDisk .lt. 0) Then
            Call Cho_Quit('nDisk < 0 in '//SecNam,103)
         End If
#endif
         iMapC = -1
         If (nnBstR(iSym,2).gt.0 .and. nDisk.gt.0) Then

C           Compute how many more vectors can be stored in buffer taking
C           into account the number of vectors on disk.
C           ------------------------------------------------------------

            Left = l_ChVBuf_Sym(iSym) - nnBstR(iSym,2)*nVec_in_Buf(iSym)
            If (Left .ge. 0) Then
               nVec = min(Left/nnBstR(iSym,2),nDisk)
            Else
               Call Cho_Quit('Left < 0 in '//SecNam,103)
               nVec = 0
            End If
            iVec1 = nVec_in_Buf(iSym) + 1
            iVec2 = iVec1 + nVec - 1

C           Read and reorder vectors.
C           -------------------------

            iVec = iVec1
            Do While (iVec .le. iVec2)

C              Read vectors.
C              -------------

               nVRd  = 0
               mUsed = 0
               Call Cho_VecRd(Work(ip_VRd),l_VRd,iVec,iVec2,iSym,nVRd,
     &                        iRedC,mUsed)
               If (nVRd .lt. 1) Then
                  Call Cho_Quit('Insufficient memory for read in '
     &                          //SecNam,101)
               End If
               nSys = nSys + 1

C              Reorder the vectors and store in buffer in current
C              reduced set.
C              --------------------------------------------------

               iOff2 = ip_ChVBuf_Sym(iSym)
     &               + nnBstR(iSym,2)*nVec_in_Buf(iSym) - 1
               iOff3 = ip_VRd - 1
               Do kVec = 1,nVRd

                  jVec = iVec + kVec - 1
                  jRed = InfVec(jVec,2,iSym)
                  If (jRed .ne. iRedC) Then
                     Call Cho_X_SetRed(irc,3,jRed)
                     If (irc .ne. 0) Then
                        Write(Lupri,*)
     &                  SecNam,': Cho_X_SetRed [2] returned ',irc
                        irc = 104
                        Return
                     End If
                     iRedC = jRed
                  End If

                  If (jRed .ne. iMapC) Then
                     Call Cho_RS2RS(iWork(ip_iScr),l_iScr,2,3,jRed,iSym)
                     iMapC = jRed
                  End If

                  Do iRS2 = 1,nnBstR(iSym,2)
#if defined (_DEBUGPRINT_)
                     jRS3 = iRS3(iRS2)
                     If (jRS3.lt.1 .or. jRS3.gt.nnBstR(iSym,3)) Then
                        Call Cho_Quit('RS-2-RS map error [2] in '
     &                                //SecNam,104)
                     End If
#endif
                     Work(iOff2+iRS2) = Work(iOff3+iRS3(iRS2))
                  End Do

                  iOff2 = iOff2 + nnBstR(iSym,2)
                  iOff3 = iOff3 + nnBstR(iSym,3)

               End Do

C              Update counters.
C              ----------------

               iVec = iVec + nVRd
               nVec_in_Buf(iSym) = nVec_in_Buf(iSym) + nVRd

            End Do

         End If
      End Do
      Call Cho_Mem('CHVB.Read','Free','Real',ip_VRd,l_VRd)

C     Update global timing.
C     ---------------------

      If (DoStat) nSys_Call = nSys_Call + nSys

C     Update global timing.
C     ---------------------

      If (DoTime) Then
         Call Cho_Timer(C2,W2)
         tDecom(1,2) = tDecom(1,2) + C2 - C1
         tDecom(2,2) = tDecom(2,2) + W2 - W1
      End If

C     Debug print.
C     ------------

      If (LocDbg) Then
         Write(Lupri,*) 'After updating: '
         Write(Lupri,'(A,8I8)') 'nVec_in_Buf  : ',
     &                          (nVec_in_Buf(iSym),iSym=1,nSym)
         Write(Lupri,*) '>>>>> Exit  ',SecNam,' <<<<<'
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Input_Grid_It(iRun,INPORB,iReturn)
************************************************************************
* Adapted from SAGIT to work with OpenMolcas (October 2020)            *
************************************************************************
*                                                                      *
* Object: input module for grid code                                   *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "grid.fh"

      Character Key*80
      Character INPORB*(*)
      Integer iTemp(3)
      Dimension dTemp(4)
      Character AllKeys*265
      Character SelectStr*120
      Character FileStr*256, FileIn*256
      Character MULLprt*80
      Character Slash
      Logical debug
      Integer LineNr
      External LineNr
      Slash='/'
*
      AllKeys=
     *'PRIN BINA ASCI NPOI DENS '//
     *'SPAR ORBI REGI ONE  TITL '//
     *'GAP  END  NODE TOTA NAME '//
     *'VB   ALL  ATOM CUBE GRID '//
     *'PACK PKLI PKBI NOOR LINE '//
     *'ORAN ERAN DEBU CUTO NOPA '//
     *'GORI SELE NOSO FILE SPHR '//
     *'COLO VIRT MULL SUBB XDER '//
     *'YDER ZDER GDER CURD CRXJ '//
     *'UMAX NOLU XFIE LUS1 LUS2 '//
     *'PLUS MINU XFMI'
*
      debug = .False.
c      Do 108 i = 1, nRout
c         nPrint(i) = 5
c 108  Continue
      isBinary=3
      isAuto=1
      isNet=0
      isReadNet=0
      isTheOne=0
      Title1=' '
      TheName=' '
      TheGap=4.0d0
      nMOmin=0
      nGrid=5
      nReq=-1
      isDensity=1
      isDerivative=0
      isCurDens=0
      isRxJ=0
      iuseMaxes=0
      isAuMO=-1
      isAtom=0
      isTotal=0
c      isVB=0
      isAll=0
      isUserGrid=0
      iGauss=0
      NoOrb=0
      iMaxUp=7
      iMaxDown=7
      isLine=0
      itRange=1
      isDebug=0
      isCutOff=0
      CutOff=2.5D0
      iCustOrig=0
      NoSort=0
      isFileOrb=0
      isSphere=0
      isColor=0
      isVirt=0
      isMULL=0
      isLONGPRT=0
      isWDW=0
      iSubBlock=0
      isLuscus=1
c      isLusMath=0
c      aLusMath=-1
!not preparing the GRIDCHARGE file as external source for XFIELD input
      isXField=0
      XFminCh=0.d0
c Default values for packing
      imoPack=0
      isBinPack=0
      xLeft=0.005d0
      xRight=0.7d0
c   (really, half range:)
      iyRange=128
      nBytesPackedVal=1
      iMinYLeft=4
      xLoErr=0.10D0
      xHiErr=0.25D0
      INPORB='INPORB'
      if(iRun.eq.0) then
c make defaults for a fast run via call from other module
        isNet=1  ! set sparse
c        isBinary=0 ! temporary set Ascii output
c       iMaxUp=1
c       iMaxDown=5
c        imoPack=0 ! packed grids not working with 64bit (?)
c        isCutOff=1
c        goto 500
      endif

*
*     KeyWord directed input
*
      InUnit=5
*      Function MyGetKey
*     * (InUnit, What, IValue, RValue, SValue, N, IArray, RArray)

      Call RdNLst(InUnit,'GRID_IT')
 998  if(MyGetKey(InUnit,'S',iD,rD,Key,iD,[iD],[rD]).ne.0) goto 997
      iKey=index(AllKeys,Key(1:4))
      if(iKey.eq.0.or.(iKey-1)/5*5.ne.(iKey-1)) then
      write(6,'(a,a)') 'Unrecognized keyword in input file:', Key(1:4)
        Call Quit_OnUserError()
      endif
      iKey=(iKey-1)/5+1
*
      if(iKey.eq.1) then
* PRIN
      if(MyGetKey(InUnit,'I',n,rD,Key,iD,[iD],[rD]).ne.0) goto 666
      Do j = 1, n
      if(MyGetKey(InUnit,'A',iD,rD,Key,2,iTemp,[rD]).ne.0) goto 666
c      print *,'debug'
c         nPrint(iTemp(1))=iTemp(2)
      enddo
      endif
      if(iKey.eq.2) then
* BINARY = default
        isBinary=1
      endif
      if(iKey.eq.3) then
* ASCII = for debug
c       Write(6,*) ' Keyword ASCII is obsolete'
c       Write(6,*) ' It can be used only for debugging purpose'
c       Write(6,*) ' Note that .lus files produced with this option '
c       Write(6,*) '      can not be visualised'
        isBinary=0
      endif
      if(iKey.eq.4) then
* NPOI
      if(MyGetKey(InUnit,'A',iD,rD,Key,3,iGridNpt,[rD]).ne.0) goto 666
      isNet=-1
      isReadNet=isReadNet+1
      endif
      if(iKey.eq.5) then
* DENSE - dense grid network..
        isNet=2
        isReadNet=isReadNet+1
      endif
      if(iKey.eq.6) then
* SPARSE - rare grid network..
        isNet=1
        isReadNet=isReadNet+1
      endif
      if(iKey.eq.7) then
* ORBI Orbitals
      if(nReq.gt.0) then
        write(6,*) 'ORBI keyword can not be used together with SELEct'
        call Quit_OnUserError()
      endif
      if(MyGetKey(InUnit,'I',nReq,rD,Key,iD,[iD],[rD]).ne.0) goto 666

      if(nReq.gt.MAXGRID) then
      write(6,'(a,i5,a,i5)')
     *      'Too many requested orbitals ',nReq,'>',MAXGRID
      Call Quit_OnUserError()
        endif
       read(inUnit,*, err=666, end=666) (iReq(i),i=1,nReq*2)
cc      if(MyGetKey(InUnit,'A',iD,rD,Key,nReq*2,iReq,[rD]).ne.0) goto 666
      isAuMO=0
      endif
      if(iKey.eq.8) then
* REGION
      if(MyGetKey(InUnit,'D',iD,rD,Key,2,[iD],Region).ne.0) goto 666
      itRange=1
      isAuMO=1
      write(6,*) ' *** Warning keyword REGION is obsolete'
      write(6,*) ' ***         assumimg Energy range '
      endif
      if(iKey.eq.9) then
* ONE - debug option
      if(MyGetKey(InUnit,'D',iD,rD,Key,7,[iD],OneCoor).ne.0) goto 666
      isTheOne=1
      isBinary=0
      endif
      if(iKey.eq.10) then
* TITLE
* NOTE: Title can be only ONE line here!!!
      if(MyGetKey(InUnit,'S',iD,rD,Title1,iD,[iD],[rD]).ne.0) goto 666
      endif
      if(iKey.eq.11) then
* GAP
      if(MyGetKey(InUnit,'R',iD,TheGap,Key,iD,[iD],[rD]).ne.0) goto 666
      endif

      if(iKey.eq.12) then
* END
      goto 997
      endif
      if(iKey.eq.13) then
* NODENSITY
      isDensity=0
      endif
      if(iKey.eq.14) then
* TOTAL
      isTotal=1
      endif
      if(iKey.eq.15) then
* NAME
      read(InUnit,'(a)') TheName
c      if(MyGetKey(InUnit,'S',iD,rD,TheName,iD,[iD],[rD]).ne.0) goto 666
c unfortunately MyGetKey uppercases strings!
      endif
      if(iKey.eq.16) then
* VB
c      isVB=1
      call Quit_OnUserError()
      endif
      if(iKey.eq.17) then
* All
      isAll=1
      endif

      if(iKey.eq.18) then
* Atom
      isAtom=1
      isNet=-1
      iGridNpt(1)=0
      iGridNpt(2)=0
      iGridNpt(3)=0
      endif
      if(iKey.eq.19) then
* CUBE
      iGauss=1
      isBinary=0
      write(6,*) 'Cube option is moved to grid2cube'
      call Quit_OnUserError()
      endif
* Grid
      if(iKey.eq.20) then
      isUserGrid=1
      isBinary=0
      isNet=-1
      iGridNpt(1)=0
      iGridNpt(2)=0
      iGridNpt(3)=0
      if(MyGetKey(InUnit,'I',nGridPoints,rD,Key,iD,[iD],[rD]).ne.0)
     *      goto 666
        Call GetMem('Grid','ALLO','REAL',ipGrid,nGridPoints*3)
       Read(InUnit,*,Err=666, end=666)
     *      (Work(ipGrid+i-1),i=1,nGridPoints*3)
      endif
* Pack
      if (iKey .eq. 21) then
c        imoPack=1
      endif
* PkLims
      if (iKey .eq. 22) then
        if (MyGetKey(InUnit,'D',iD,rD,Key,4,[iD],dTemp).ne.0) goto 666
        xLeft=dTemp(1)
        xRight=dTemp(2)
        xLoErr=dTemp(3)
        xHiErr=dTemp(4)
      endif
* PkBits
      if (iKey .eq. 23) then
        if (MyGetKey(InUnit,'I',ibits,rD,Key,iD,[iD],[rD]).ne.0)
     *      goto 666
        if (ibits .eq. 16) then
          iyRange=32768
          nBytesPackedVal=2
        endif
      endif
* NoOrbitals
      if (iKey .eq. 24) then
        NoOrb=1
      endif
* LINE - density on line
      if (iKey .eq. 25) then
      if(MyGetKey(InUnit,'D',iD,rD,Key,7,[iD],OneCoor).ne.0) goto 666
      isTheOne=1
      isTotal=1
      isBinary=0
      isLine=1
      endif
      if(iKey.eq.26) then
* ORANGE
      if(MyGetKey(InUnit,'D',iD,rD,Key,2,[iD],Region).ne.0) goto 666
      itRange=0
      isAuMO=1
      NoSort=1
      endif
      if(iKey.eq.27) then
* ERANGE
      if(MyGetKey(InUnit,'D',iD,rD,Key,2,[iD],Region).ne.0) goto 666
      itRange=1
      isAuMO=1
      endif
* DEBUG
      if(iKey.eq.28) then
      isBinary=0
      isDebug=1
      endif
      if(iKey.eq.29) then
* CUTOFF
      if(MyGetKey(InUnit,'R',iD,CutOff,Key,iD,[iD],[rD]).ne.0) goto 666
      isCutOff=1
      endif
      if(iKey.eq.30) then
* NOPACK
c      imoPack=0
      endif
      if(iKey.eq.31) then
* GORI
      iCustOrig=1
      if(MyGetKey(InUnit,'D',iD,rD,Key,3,[iD],GridOrigin).ne.0) goto 666
      if(MyGetKey(InUnit,'D',iD,rD,Key,3,[iD],GridAxis1).ne.0) goto 666
      if(MyGetKey(InUnit,'D',iD,rD,Key,3,[iD],GridAxis2).ne.0) goto 666
      if(MyGetKey(InUnit,'D',iD,rD,Key,3,[iD],GridAxis3).ne.0) goto 666
      endif
      if(iKey.eq.32) then
* SELEct
      if(MyGetKey(InUnit,'S',iD,rD,SelectStr,iD,[iD],[rD]).ne.0) then
         goto 666
      endif
      if(nReq.gt.0) then
      write(6,*) 'SELEct keyword can not be used together with ORBItals'
        call Quit_OnUserError()
      endif
      call gridExpandSelect(SelectStr)
       isAuMO=0
      endif
      if(iKey.eq.33) then
* NOSOrt
       NoSort=1
      endif
      if(iKey.eq.34) then
* FILE
      read(InUnit,'(A)') FileIn
      isFileOrb=1
      call fileorb(FileIn,FileStr)
      write(6,*) 'INPORB file: ',FileStr(:mylen(FileStr))
      endif
      if(iKey.eq.35) then
* SPHR
      isSphere=1
      endif
      if(iKey.eq.36) then
* COLOr
      isColor=1
      endif
      if(iKey.eq.37) then
* VIRT
      isVirt=1
      if(MyGetKey(InUnit,'R',iD,Virt,Key,iD,[iD],[rD]).ne.0) goto 666
      endif
      if(iKey.eq.38) then
* MULLiken charges per MO
      isMULL=1
      read(InUnit,'(A)') MULLPRT
      Call upCASE(MULLPRT)
      Call LeftAd(MULLPRT)
      If (MULLPRT(1:4).eq.'LONG') isLONGPRT=1
      endif
* SUBBLOCK
      if(iKey.eq.39) then
      if(MyGetKey(InUnit,'D',iD,rD,Key,3,[iD],SubBlock).ne.0) goto 666
      if(MyGetKey(InUnit,'R',iD,rSubBlock,Key,iD,[iD],[rD]).ne.0)
     *      goto 666
      iSubBlock=1
      endif
* XDER,YDER,ZDER,GDER
      if(iKey.eq.40) then
         isDerivative=1
         call Quit_OnUserError()
         endif
      if(iKey.eq.41) then
         isDerivative=2
         call Quit_OnUserError()
         endif
      if(iKey.eq.42) then
         isDerivative=3
         call Quit_OnUserError()
         endif
      if(iKey.eq.43) then
         isDerivative=4
         call Quit_OnUserError()
         endif

* CURD (current density)
      if(iKey.eq.44) then
         isCurDens=1
         call Quit_OnUserError()
         endif

* CRXJ (current density, rxj)
      if(iKey.eq.45) then
        isCurDens=1
        isRxJ=1
        call Quit_OnUserError()
      endif
* UMAX (use magnetic axes)
      if(iKey.eq.46) iuseMaxes=1
* NOLUSCUS
      if(iKey.eq.47) then
        isLuscus=0
        isBinary=0
      endif
* XFIEld - ask Grid_It to compute electronic density on a DFT integration grid
      if(iKey.eq.48) then
        isXField=1
        isReadNet=isReadNet+1 !make the grid definition exclusive
      endif
* LUS1
      if(iKey.eq.49) then
      write(6,*) 'Not implemented'
c      isLusMath=1
c      read(InUnit,'(a)') LUS1
      endif
* LUS2
      if(iKey.eq.50) then
      write(6,*) 'Not implemented'
c      isLusMath=1
c      read(InUnit,'(a)') LUS2
      endif
* PLUS
      if(iKey.eq.51) then
      write(6,*) 'Not implemented'
c      aLusMath=1
      endif
* MINUS
      if(iKey.eq.52) then
      write(6,*) 'Not implemented'
c      aLusMath=-1
      endif
* XFMI xfield minimum charge of each grid point to be stored
      if(iKey.eq.53) then
         if(MyGetKey(InUnit,'R',iD,XFminCh,Key,iD,[iD],[rD]).ne.0)
     *     goto 666
      endif
      goto 998

 666  write(6,'(a,a,a)')
     *     'Error during reading ', Key(1:20), 'section in input file'
      Call Quit_OnUserError()

************************************************************************
*                                                                      *
*                       End of input section.                          *
*                                                                      *
************************************************************************
 997  Continue
c      if(isLusMath.eq.1) return
      if(isLuscus.eq.1.and.isBinary.eq.0) then
        write(6,*) 'ASCII keyword is set, but NoLUSCUS is not'
        write(6,*) 'calling abend as the best option available'
        call Quit_OnUserError()
      endif
      close(InUnit)
      IF (isLuscus .EQ. 1) THEN
        IF (isLine .NE. 0) THEN
          WRITE(6,*) 'LUSCUS and LINE options are not compatible'
          Call Quit_OnUserError()
        END IF
      END IF
*
      if(isReadNet.GT.1) write(6,'(a)')
     *    'Warning: Double definition of GRID net'

*
*  Well, there is something to do!
*
       if(isFileOrb.eq.1) then
       INPORB=FileStr
       endif
       Call OpenGrid(INPORB)
*
*  try to generate grid position automatically
*

          magicValue=0
          if(isNet.ge.0) then
              magicValue=GridNormal
              if(isNet.eq.1) magicValue=GridSparse
              if(isNet.eq.2) magicValue=GridDense
          endif
          if(iCustOrig.eq.1) then
            if(isNet.ne.-1) then
              write(6,*) 'GORI can be used only with NPOI'
              call Quit_OnUserError()
            endif
          endif
          Call MyCoor(isAuto,
     &       GridOrigin(1),GridOrigin(2),GridOrigin(3),
     &       GridAxis1(1),GridAxis2(2),GridAxis3(3),
     &       iGridNpt(1),iGridNpt(2),iGridNpt(3), magicValue,
     &       iCustOrig)

          if(iSubBlock.eq.1) then
          do i=1,3
          GridOrigin(i)=SubBlock(i)-rSubBlock
          enddo
          GridAxis1(1)=rSubBlock*2
          GridAxis2(2)=rSubBlock*2
          GridAxis3(3)=rSubBlock*2
          iGridNpt(1)=40
          iGridNpt(2)=40
          iGridNpt(3)=40
          endif


      Return
* Avoid unused argument warnings
      If (.False.) Call Unused_integer(iReturn)
      End
      Subroutine gridExpandSelect(SelectStr)
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "grid.fh"
      Character SelectStr*120, tmp*120
       ifirst=0
       ilen=0
       tmp=' '
       do i=1,120
         if(ifirst.eq.0.and.SelectStr(i:i).ne.' ') then
           ilen=ilen+1
           tmp(ilen:ilen)=SelectStr(i:i)
           ifirst=1
           goto 10
         endif
         if(ifirst.eq.1.and.SelectStr(i:i).ne.' ') then
           ilen=ilen+1
           tmp(ilen:ilen)=SelectStr(i:i)
         endif
         if(ifirst.eq.1.and.SelectStr(i:i).eq.' ') then
           ilen=ilen+1
           tmp(ilen:ilen)=SelectStr(i:i)
           ifirst=0
         endif
10     continue
       enddo
      if(ilen.lt.2) then
         write(6,*) 'SELEct section is incomplete'
         call Quit_OnUserError()
      endif
c      print *,'current',tmp
      nReq=0
1     istart=1
      iend=index(tmp(istart:),' ')
       ibr=index(tmp(istart:iend),':')
       if(ibr.eq.0) then
         write(6,*) 'Wrong format in SELEct section'
         write(6,*) 'Expecting : sign in >',tmp(istart:iend),'<'
         call Quit_OnUserError()
       endif
c       print *,'v01 >',tmp(istart:istart+ibr-2),'<'
       read(tmp(istart:istart+ibr-2),*,err=20,end=20) isymm
       ibrm=index(tmp(istart+ibr+1:iend),'-')
       if(ibrm.eq.0) then
c the only number
c       print *,'v02 >',tmp(istart+ibr:iend),'<'
         read(tmp(istart+ibr:iend),*,err=20,end=20) iibeg
         iReq(2*nReq+1)=isymm
         iReq(2*nReq+2)=iibeg
         nReq=nReq+1
         if(nReq.gt.MAXGRID) goto 30
       else
c         print *,'v03 >',tmp(istart+ibr:istart+ibr+ibrm-1),'<'
         read(tmp(istart+ibr:istart+ibr+ibrm-1),*,err=20,end=20) iibeg
c        print *,'v04 >',tmp(istart+ibr+ibrm+1:iend),'<'
         read(tmp(istart+ibr+ibrm+1:iend),*,err=20,end=20) iiend
         if(iiend.lt.iibeg) then
          write(6,*) 'Wrong data in SELEct section'
          call Quit_OnUserError()
         endif
        do i=iibeg,iiend
         iReq(2*nReq+1)=isymm
         iReq(2*nReq+2)=i
         nReq=nReq+1
         if(nReq.gt.MAXGRID) goto 30
        enddo
       endif
c      print *,'current',tmp(iend+1:)
      tmp=tmp(iend+1:)
      if(tmp.ne.' ') goto 1
      Return
20    write(6,*) 'Error in analyzing SELECT section'
      call Quit_OnUserError()
30    write(6,*) 'Too many Grids requested'
      call Quit_OnUserError()
      end

      integer function LineNr(Lu)
      implicit none
      integer Lu, ios
      real*8 foo
      LineNr=0
      do while(.true.)
      read(Lu,*,iostat=ios) foo, foo, foo, foo
        if( ios > 0 ) then
           call Abend() !'problem somewhere'
        else if( ios < 0 ) then ! end of file is reached
           return
        else
           LineNr = LineNr + 1
        end if
      end do
      return
      end function LineNr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine KnEGrd( &
#                 define _CALLING_
#                 include "grd_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: to compute the kinetic energy integrals with the Gauss-      *
!         Hermite quadrature.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!             Modified to multipole moments November '90               *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified to gradients October '91.                       *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW
use Center_Info, only: dc
use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: iAlpha, iBeta, ipA, ipAOff, ipAxyz, ipB, ipBOff, ipBxyz, iPrint, ipRnxyz, ipRxyz, ipTxyz, iRout, nip
logical(kind=iwp) :: ABeq(3)
#include "print.fh"

#include "macros.fh"
unused_var(ZInv)
unused_var(iStabM)
unused_var(nStabM)

iRout = 150
iPrint = nPrint(iRout)
ABeq(:) = A == RB

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+3)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+3)
ipRxyz = nip
nip = nip+nZeta*3*nHer*(nOrdOp+1)
ipRnxyz = nip
nip = nip+nZeta*3*(la+3)*(lb+3)*(nOrdOp+1)
ipTxyz = nip
nip = nip+nZeta*3*(la+2)*(lb+2)
ipA = nip
nip = nip+nZeta
ipB = nip
nip = nip+nZeta
if (nip-1 > nArr*nZeta) then
  write(u6,*) ' nArr is Wrong! ',nip-1,' > ',nArr*nZeta
  call ErrTra()
  write(u6,*) ' Abend in KnEGrd'
  call Abend()
end if

if (iPrint >= 49) then
  call RecPrt(' In KnEGrd: A',' ',A,1,3)
  call RecPrt(' In KnEGrd: RB',' ',RB,1,3)
  call RecPrt(' In KnEGrd: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In KnEGrd: P',' ',P,nZeta,3)
  write(u6,*) ' In KnEGrd: la,lb=',la,lb
end if

! Compute the cartesian values of the basis functions angular part

call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),la+2,HerR(iHerR(nHer)),nHer,ABeq)
call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),lb+2,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the contribution from the multipole moment operator

ABeq(:) = .false.
call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the cartesian components for the multipole moment
! integrals. The integrals are factorized into components.

call Assmbl(Array(ipRnxyz),Array(ipAxyz),la+2,Array(ipRxyz),nOrdOp,Array(ipBxyz),lb+2,nZeta,HerW(iHerW(nHer)),nHer)

! Compute the cartesian components for the kinetic energy integrals.
! The kinetic energy components are linear combinations of overlap
! components.

ipAOff = ipA
do iBeta=1,nBeta
  call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB
do iAlpha=1,nAlpha
  call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
  ipBOff = ipBOff+1
end do

call Kntc(Array(ipTxyz),Array(ipRnxyz),la+1,lb+1,Array(ipA),Array(ipB),nZeta)

! Combine the cartesian components to the gradient of the kinetic
! energy integral and trace with the variational density matrix.

call CmbnT1(Array(ipRnxyz),nZeta,la,lb,Zeta,rKappa,rFinal,Array(ipTxyz),Array(ipA),Array(ipB),Grad,nGrad,DAO,IfGrad,IndGrd, &
            dc(mdc)%nStab,dc(ndc)%nStab,kOp)

return

end subroutine KnEGrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Put_NucAttr()

      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Character*8 Label
      Integer nSym, nBas(8)
*
#include "embpcharg.fh"
*
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)

      nLT=nBas(1)*(nBas(1)+1)/2
      Do i=2,nSym
         nLT=nLT+nBas(i)*(nBas(i)+1)/2
      End Do
      nLT_=nLT
      If (DoEMPC) nLT=2*nLT
      Call Getmem('tempAtr','Allo','Real',ipAttr,nLT)
      ipXFdInt=ipAttr+nLT_

      irc    = -1
      iOpt   = 6
      iComp  = 1
      iSyLbl = 1
      Label  = 'Attract '
      Call RdOne(irc,iOpt,Label,iComp,Work(ipAttr),iSyLbl)
      If (irc .ne. 0) Then
         Write(6,*) 'Put_NucAttr: RdOne returned ',irc
         Write(6,*) 'Label = ',Label,'  iSyLbl = ',iSyLbl
         Call SysAbendMsg('Put_NucAttr','I/O error in RdOne',' ')
      End If

      If (DoEMPC) Then
         irc    = -1
         iOpt   = 2
         iComp  = 1
         iSyLbl = 1
         Label  = 'XFdInt  '
         Call RdOne(irc,iOpt,Label,iComp,Work(ipXFdInt),iSyLbl)
         If (irc .ne. 0) Then
            Write(6,*) 'Put_NucAttr: RdOne returned ',irc
            Write(6,*) 'Label = ',Label,'  iSyLbl = ',iSyLbl
            Call SysAbendMsg('Put_NucAttr','I/O error in RdOne',' ')
         End If
         Call daxpy_(nLT_,1.0d0,Work(ipXFdInt),1,Work(ipAttr),1)
      End If
*
      Call Put_dArray('Nuc Potential',Work(ipAttr),nLT_)
*
#ifdef _DEBUGPRINT_
      iAttr=ipAttr
      Do i=1,nSym
         Call TriPrt('Attr Inte','',Work(iAttr),nBas(i))
         iAttr=iAttr+nBas(i)*(nBas(i)+1)/2
      End Do
#endif
*
      Call Getmem('tempAtr','Free','Real',ipAttr,nLT)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Ignacio Fdez. Galvan                             *
!***********************************************************************
Subroutine SortDiag(HH,EigVec,nVec,nDim)

Implicit None
Integer, Intent(In) :: nVec, nDim
Real*8, Intent(InOut) :: HH(*), EigVec(nDim,nVec)
Integer :: i, iMax, ii, jj
Integer, External :: idAMax_

Do i=1,nVec-1
  iMax = idAMax_(nVec-i+1,EigVec(i,i),nDim)
  If (iMax > 1) Then
    iMax = iMax+i-1
    ii = (i*(i+1))/2
    jj = (iMax*(iMax+1))/2
    Call dSwap_(1,HH(ii),1,HH(jj),1)
    Call dSwap_(nDim,EigVec(1,i),1,EigVec(1,iMax),1)
  End If
End Do

End Subroutine SortDiag

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ParentWorkDir
      use subdirs, only : f_setsubdir, Sub, OldWorkDir, NewWorkDir
      use filesystem, only : remove_, chdir_
      Implicit None
      Integer :: i

      Sub=''
      Call f_setsubdir(Sub)
      Call chdir_(OldWorkDir)

*     Remove the subdirectory,
*     try to make sure it is indeed a subdirectory
      If (Index(NewWorkDir,Trim(OldWorkDir)) .eq. 1) Then
        i = Len_Trim(OldWorkDir)
        If ((Len_Trim(NewWorkDir) .ge. i+2) .and.
     &      (NewWorkDir(i+1:i+1) .eq. '/') .and.
     &      (NewWorkDir(i+2:i+2) .ne. '/')) Then
          Call remove_(NewWorkDir)
        End If
      End If

      End Subroutine ParentWorkDir

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_INT_1_DBG(DIAG,LEVEL)
C
C     Purpose: debug seward interface routine CHO_MCA_INT_1.
C
C     LEVEL =  1: test diagonal, reduced set 1 (i.e. initial).
C              2: test diagonal, reduced set 2 (i.e. current).
C              3: test symmetry of integral matrix (shell quadruple-based)
C
#include "implicit.fh"
      DIMENSION DIAG(*)
#include "cholesky.fh"

      CHARACTER*17 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_INT_1_DBG')

      LOGICAL LOCDIAG, LOCSYM

      CALL CHO_HEAD('Debugging CHO_MCA_INT_1','=',80,LUPRI)
      WRITE(LUPRI,'(A,I2)') 'Debug level',LEVEL

      IF (LEVEL .EQ. 1) THEN
         LOCDIAG = .TRUE.
         LOCSYM  = .FALSE.
         IRED    = 1
      ELSE IF (LEVEL .EQ. 2) THEN
         LOCDIAG = .TRUE.
         LOCSYM  = .FALSE.
         IRED    = 2
      ELSE IF (LEVEL .EQ. 3) THEN
         LOCDIAG = .FALSE.
         LOCSYM  = .TRUE.
      ELSE
         LOCDIAG = .FALSE.
         LOCSYM  = .FALSE.
         WRITE(LUPRI,'(A)') 'Debug level not recognized ---',
     &                      ' debug cancelled!'
      END IF

      IF (LOCDIAG) THEN
         CALL CHO_MCA_INT_1_DBG1(DIAG,IRED)
      END IF

      IF (LOCSYM) THEN
         CALL CHO_MCA_INT_1_DBG2()
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_NMode_All(Vectors,nVectors,nFreq,nUnique_Atoms,Vectors_All,nAll_Atoms,mDisp)

use Symmetry_Info, only: iChTbl, iOper, nIrrep, Symmetry_Info_Get
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nVectors, nFreq, nUnique_Atoms, nAll_Atoms, mDisp(0:7)
real(kind=wp), intent(in) :: Vectors(nVectors)
real(kind=wp), intent(_OUT_) :: Vectors_All(3*nAll_Atoms*nFreq)
integer(kind=iwp) :: Active = 0, iC, iCar, iChAtom, iChCar(3), iCo, iComp, iCoSet(0:7,0:7), iFreq, iGen(3), iIrrep, iMode, &
                     iStab(0:7), iUnique_Atom, iVec, iVector, iVector_all, kOp, MaxDCR, mUnique_Atoms, nCoSet, nDisp(0:7), nGen, &
                     nStab
real(kind=wp) :: Vec, XR, XY
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
logical(kind=iwp) :: Temp
#endif
real(kind=wp), allocatable :: Coor(:,:)
integer(kind=iwp), external :: iChxyz, iPrmt, NrOpr

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt('Vectors',' ',Vectors,1,nVectors)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
if (Active == 0) then
  call Symmetry_Info_Get()
  Active = 1
end if
!                                                                      *
!***********************************************************************
!                                                                      *
nGen = 0
if (nIrrep == 2) nGen = 1
if (nIrrep == 4) nGen = 2
if (nIrrep == 8) nGen = 3
if (nGen >= 1) iGen(1) = iOper(1)
if (nGen >= 2) iGen(2) = iOper(2)
if (nGen == 3) iGen(3) = iOper(4)
#ifdef _DEBUGPRINT_
write(u6,*) 'nGen=',nGen
write(u6,*) 'iGen=',(iGen(i),i=1,nGen)
#endif
call ChCar(iChCar,iGen,nGen)
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of symmetry adapted displacements

call Get_iScalar('Unique atoms',mUnique_Atoms)
if (mUnique_Atoms /= nUnique_Atoms) then
  write(u6,*) 'Get_NMode_All: mUnique_Atoms /= nUnique_Atoms'
  call Abend()
end if
call mma_allocate(Coor,3,mUnique_Atoms,label='Coor')
call Get_dArray('Unique Coordinates',Coor,3*mUnique_Atoms)
#ifdef _DEBUGPRINT_
write(u6,*) 'nVectors,nAll_Atoms,nFreq=',nVectors,nAll_Atoms,nFreq
write(u6,*)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Find the number of displacements in each irrep

MaxDCR = 0
do iIrrep=0,nIrrep-1
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'iIrrep=',iIrrep
  write(u6,*)
# endif
  nDisp(iIrrep) = 0
  iC = 1
  do iUnique_Atom=1,nUnique_Atoms
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iUnique_Atom=',iUnique_Atom
#   endif
    iChAtom = iChxyz(Coor(:,iC),iGen,nGen)
    iC = iC+1
    call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
    nCoSet = nIrrep/nStab
#   ifdef _DEBUGPRINT_
    write(u6,*) 'nCoSet=',nCoSet
    write(u6,*) 'iCoSet=',(iCoSet(i,0),i=0,nCoset-1)
    write(u6,*) 'iChAtom=',iChAtom
#   endif
    do iCar=0,2
      iComp = 2**iCar
#     ifdef _DEBUGPRINT_
      write(u6,*) 'iComp=',iComp
      Temp = TF(iIrrep,iComp)
      write(u6,*) 'TF(iIrrep,iComp)=',Temp
#     endif
      if (TF(iIrrep,iComp)) nDisp(iIrrep) = nDisp(iIrrep)+1
    end do
  end do
end do
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'Grand Total'
write(u6,*) 'nDisp=',(nDisp(i),i=0,nIrrep-1)
write(u6,*)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop Irreps

iVector = 0
iVector_all = 0
iFreq = 0
outer: do iIrrep=0,nIrrep-1
# ifdef _DEBUGPRINT_
  write(u6,*) 'iIrrep,nDisp(iIrrep)=',iIrrep,nDisp(iIrrep)
# endif

  do iMode=1,mDisp(iIrrep)
    iFreq = iFreq+1
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iMode=',iMode
#   endif

    ! Loop over symmetry unique centers

    iC = 1
    do iUnique_Atom=1,nUnique_Atoms

#     ifdef _DEBUGPRINT_
      write(u6,*) 'iUnique_Atom=',iUnique_Atom
#     endif
      ! Get permutational character of the center

#     ifdef _DEBUGPRINT_
      write(u6,*) Coor(:,iC)
#     endif
      iChAtom = iChxyz(Coor(:,iC),iGen,nGen)
      iC = iC+1
      call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
      nCoSet = nIrrep/nStab
#     ifdef _DEBUGPRINT_
      write(u6,*) 'nCoSet=',nCoSet
      write(u6,*) 'iCoSet=',(iCoSet(i,0),i=0,nCoset-1)
      write(u6,*) 'iChAtom=',iChAtom
#     endif

      iVec = 0 ! dummy initialize
      do iCo=0,nCoSet-1
        kOp = iCoSet(iCo,0)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'iVector_All=',iVector_All
        write(u6,*) 'iVector=',iVector
        write(u6,*) 'iCo,kOp=',iCo,kOp
#       endif
        iVec = 0
        do iCar=0,2
          iComp = 2**iCar
          iVector_All = iVector_All+1
#         ifdef _DEBUGPRINT_
          write(u6,*) 'iCar=',iCar
          write(u6,*) 'iVector_All=',iVector_All
          write(u6,*) 'iComp=',iComp
          Temp = TF(iIrrep,iComp)
          !write(u6,*) 'TF(iIrrep,iComp)=',Temp
#         endif
          if (TF(iIrrep,iComp)) then
            !write(u6,*) 'Belong!'
            iVec = iVec+1

            ! In some cases we only want the normal modes of the first irrep!
            ! In that case branch out.

            if (iVector+iVec > nVectors) exit outer
            Vec = Vectors(iVector+iVec)
            XR = real(iPrmt(NrOpr(kOp),iComp),kind=wp)
            XY = real(iChTbl(iIrrep,NrOpr(kOp)),kind=wp)
            Vectors_All(iVector_All) = Vec*XR*XY
          else
            !write(u6,*) 'Doesn''t belong!'
            Vectors_All(iVector_All) = Zero
          end if
#         ifdef _DEBUGPRINT_
          write(u6,*) 'iVec=',iVec
#         endif
        end do  ! iCar
      end do  ! iCo
      iVector = iVector+iVec

    end do ! iUnique_Atom

#   ifdef _DEBUGPRINT_
    call RecPrt('Normal mode',' ',Vectors_All((iFreq-1)*3*nAll_Atoms+1),3,nAll_Atoms)
#   endif
  end do  ! iMode
end do outer  ! iIrrep
call mma_deallocate(Coor)
#ifdef _DEBUGPRINT_
call RecPrt('Normal mode',' ',Vectors_All,3*nAll_Atoms,nFreq)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

contains

function TF(iIrrep,iComp)

  logical(kind=iwp) :: TF
  integer(kind=iwp), intent(in) :: iIrrep, iComp
  logical(kind=iwp), external :: TstFnc

  TF = TstFnc(iCoSet,iIrrep,iComp,nIrrep/nCoSet)

end function TF

end subroutine Get_NMode_All

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018, Andrew M. Sand                                   *
*               2019, Thais R. Scott                                   *
*               2021, Jie J. Bao                                       *
************************************************************************
      Subroutine SaveFock_PDFT(CMO,IFockI,IFockA,iD1Act,LFock,
     &                         LP,NQ,LQ,LPUVX,ip2d,istate)
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Jan. 04, 2021, created this file.               *
* ****************************************************************

      Use KSDFT_Info, Only: ifav, ifiv

* Notes: Two references will be referred to in the comments.
* Ref1:  Sand, et al. JCTC, 2018, 14,  126.
* Ref2: Scott, et al. JCP,  2020, 153, 014106.
      Implicit Real*8 (A-H,O-Z)
      DIMENSION CMO(*)
#include "rasdim.fh"
#include "general.fh"
#include "input_ras_mcpdft.fh"
#include "output_ras.fh"
#include "rasscf.fh"
#include "WrkSpc.fh"
#include "rctfld.fh"
#include "pamint.fh"
#include "timers.fh"
#include "SysDef.fh"
#include "gugx.fh"
#include "casvb.fh"
#include "wadr.fh"
#include "rasscf_lucia.fh"
#include "mspdft.fh"
!      Logical TraOnly



      INTEGER IFockI,IFockA,iD1Act,LP,NQ,LQ,LPUVX,ip2d,istate,LFock


******Auxiliary Variables
      INTEGER i_off1,ifone,isym,ipTmpLTEOTP,ipTmpLOEOTP
      INTEGER ittTUVX,ifat
      INTEGER iPrLev
      External isfreeunit
      CHARACTER(len=64) FILENAME
      CHARACTER(len=8) STATENAME


      write(6,'(2X,A)')
     &'Calculating potentials for analytic gradients for MS-PDFT'

      IPRLEV=IPRLOC(3)

      write(StateName,'(I3)') ISTATE
      write (FILENAME,fmt='(a,a)')
     &"TmpFock",trim(adjustl(STATENAME))


******ioading one-electron potential and two-electron potential
******Used as F1 and F2 in equations 58 and 59 in Ref1.


      Call GetMem('ONTOPT','ALLO','Real',ipTmpLTEOTP,nfint)
      Call GetMem('ONTOPO','ALLO','Real',ipTmpLOEOTP,ntot1)
      Call FZero(Work(iptmplteotp),Nfint)
      Call FZero(Work(iptmploeotp),ntot1)

      Call Get_dArray('ONTOPT',work(ipTmpLTEOTP),NFINT)
      Call Get_dArray('ONTOPO',work(ipTmpLOEOTP),NTOT1)


      If (IPRLEV.ge.DEBUG ) THEN
        write(6,*) 'One-electron potentials'
        do i=1,ntot1
          write(6,*) Work(iptmploeotp-1+i)
        end do
        write(6,*) 'Two-electron potentials'
        DO i=1,nfint
         if (abs(work(lpuvx-1+i)).ge.1d-10)then
           write(6,*) Work(iptmplteotp-1+i),work(lpuvx-1+i)
         else
           write(6,*)Work(iptmplteotp-1+i),0.0d0
         end if
        END DO
       END IF

      Call GetMem('F_ONE','ALLO','Real',iFone,NTOT1)
      CALL DCOPY_(NTOT1,[0.0D0],0,WORK(iFone),1)

      CALL GETMEM('FI_V','ALLO','REAL',ifiv,Ntot1)
      Call Get_dArray('FI_V',work(ifiv),NTOT1)

*     Focka=fiv+tmploeotp
      Call daxpy_(ntot1,1.0d0,Work(ifiv),1,Work(iFocka),1)
      Call daxpy_(ntot1,1.0d0,Work(iptmploeotp),1,Work(iFocka),1)

      i_off1=0

*     F1=fiv+tmploeotp
      DO iSym = 1,nSym
       iBas = nBas(iSym)
       !FI + FA + V_oe
       Do i=1,iBas
        do j=1,i
         Work(iFone+i_off1) = Work(ifone+i_off1) +
     &   Work(ifocka+i_off1)
         i_off1 = i_off1 + 1
        end do
       End Do
      END DO

      IF ( IPRLEV.ge.DEBUG ) then
       write(6,*) 'F1 to send'
       DO i=1,NTOT1
         write(6,*) work(iFone-1+i)
       END DO
      END IF

      CALL DCopy_(nTot1,Work(iFone),1,WORK(iF1MS+(iIntS-1)*nTot1),1)
      Call GetMem('ttTUVX','Allo','Real',ittTUVX,NACPR2)
      CALL DCOPY_(nacpr2,[0.0D0],0,WORK(ittTUVX),1)
      Call Get_TUVX(Work(ipTmpLTEOTP),Work(ittTUVX))

      CALL DCopy_(NACPR2,Work(ittTUVX),1,WORK(iF2MS+(iIntS-1)*NACPR2),1)
      Call GetMem('F_ONE','Free','Real',iFone,NTOT1)
      Call GetMem('ttTUVX','Free','Real',ittTUVX,NACPR2)

!____________________________________________________________
!This next part is to generate the MC-PDFT generalized fock operator.

      CALL DCOPY_(ntot1,[0.0D0],0,WORK(iFocka),1)
      CALL DCOPY_(ntot1,[0.0D0],0,WORK(iFocki),1)

!The corrections (from the potentials) to FI and FA are built in the NQ
!part of the code, for efficiency's sake.  It still needs to be
!debugged.
      CALL GETMEM('FA_V','ALLO','REAL',ifav,Ntot1)
      Call Get_dArray('FA_V',work(ifav),NTOT1)

      IF ( IPRLEV.GE.DEBUG ) THEN
       write(6,*) "extra terms to update FI"
       DO i=1,ntot1
        write(6,*) Work(ifiv-1+i)
       END DO
       write(6,*) "extra terms to update FA"
       DO i=1,ntot1
        write(6,*) Work(ifav-1+i)
       END DO
       CALL GETMEM('FA_t','ALLO','REAL',ifat,Ntot1)
       Call dcopy_(ntot1,[0.0d0],0,work(ifat),1)
       Call DaXpY_(NTOT1,1.0D0,Work(ipTmpLOEOTP),1,Work(ifat),1)
       Call Daxpy_(NTOT1,1.0D0,Work(ifiv),1,Work(ifat),1)
       Call Daxpy_(NTOT1,1.0D0,Work(ifav),1,Work(ifat),1)
       write(6,*) "Total F additions:"
       Call TriPrt(' ','(5G18.10)',Work(ifat),norb(1))
       CALL GETMEM('FA_t','free','REAL',ifat,Ntot1)
      END IF

      Call DaXpY_(NTOT1,1.0D0,Work(ipTmpLOEOTP),1,Work(ifocki),1)
      Call Daxpy_(NTOT1,1.0D0,Work(ifiv),1,Work(ifocki),1)
      Call Daxpy_(NTOT1,1.0D0,Work(ifav),1,Work(ifocka),1)

      IF ( IPRLEV.GE.DEBUG ) THEN
       write(6,*) "new FI"
       Call TriPrt(' ','(5G18.10)',Work(ifocki),norb(1))
       write(6,*) "new FA"
       Call TriPrt(' ','(5G18.10)',Work(ifocka),norb(1))
      END IF

      CALL GETMEM('FI_V','Free','REAL',ifiv,Ntot1)
      CALL GETMEM('FA_V','Free','REAL',ifav,Ntot1)

!Reordering of the two-body density matrix.
      IF(ISTORP(NSYM+1).GT.0) THEN
       CALL DCOPY_(ISTORP(NSYM+1),[0.0D0],0,WORK(LP),1)
       CALL PMAT_RASSCF_M(Work(iP2d),WORK(LP))
      END IF
!Must add to existing FOCK operator (occ/act). FOCK is not empty.
      CALL GETMEM('SXBM','ALLO','REAL',LBM,NSXS)
      CALL GETMEM('SXLQ','ALLO','REAL',LQ,NQ) ! q-matrix(1symmblock)
      CALL FOCK_update(WORK(LFOCK),WORK(LBM),Work(iFockI),
     &     Work(iFockA),Work(iD1Act),WORK(LP),
     &     WORK(LQ),WORK(ipTmpLTEOTP),IFINAL,CMO)

      CALL DCopy_(nTot1,Work(ipFocc),1,WORK(iFocMS+(iIntS-1)*nTot1),1)
      IF ( IPRLEV.GE.DEBUG ) THEN
       write(6,*) 'FOCC_OCC'
       call wrtmat(Work(ipFocc),1,ntot1,1,ntot1)
       write(6,*) 'DONE WITH NEW FOCK OPERATOR'
      END IF

      CALL GETMEM('SXBM','Free','REAL',LBM,NSXS)
      CALL GETMEM('SXLQ','Free','REAL',LQ,NQ) ! q-matrix(1symmblock)
      Call GetMem('ONTOPO','FREE','Real',ipTmpLOEOTP,ntot1)
      Call GetMem('ONTOPT','FREE','Real',ipTmpLTEOTP,nfint)

      iSA = 1
      Call Put_iScalar('SA ready',iSA)

      RETURN
      End Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This is a very preliminary routine for testing purposes. It relies   *
! on the basis set being of ANO type.                                  *
!                                                                      *
!                                                                      *
! Absolutely NOT to be used for production!!!!                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: Oct 2004                                                    *
!                                                                      *
!***********************************************************************

subroutine Fmod1n(StandAlone)

use GuessOrb_Global, only: Label, MxBasis, MxSym, nBas, nSym, PrintMOs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
!----------------------------------------------------------------------*
! Dummy arguments                                                      *
!----------------------------------------------------------------------*
logical(kind=iwp), intent(in) :: StandAlone
!----------------------------------------------------------------------*
! Local variables                                                      *
!----------------------------------------------------------------------*
logical(kind=iwp) :: Debug, Trace
integer(kind=iwp) :: iSym, iBas, jBas, kBas, iOff, ipCMO(MxSym), ipFock(MxSym), ipX, ipY, iSymlb, iRc, nBasMax, nBasTot, nTriTot, &
                     nSqrTot, i, k, Lu, iDummy(7,8), RC
!---
real(kind=wp) :: orbene(MxBasis), Sik, Sjk, eps, dsum
real(kind=wp), allocatable :: CMO(:), Fock(:), EVec(:), Ovl(:), Nrm(:), SFk(:), Hlf(:), TFk(:), Aux1(:)
character(len=80) :: Title
!character(len=4) AtName(MxAtom)
!character(len=4) Label(2,MxBasis)
!----------------------------------------------------------------------*
! Some setup                                                           *
!----------------------------------------------------------------------*
if (StandAlone) then
  Debug = .false.
  Trace = .false.
else
  Debug = .false.
  Trace = .false.
end if
if (Trace) write(u6,*) '>>> Entering fmod1n'
!----------------------------------------------------------------------*
! Setup various counters.                                              *
!----------------------------------------------------------------------*
nBasMax = 0
nBasTot = 0
nTriTot = 0
nSqrTot = 0
do iSym=1,nSym
  if (nBasMax < nBas(iSym)) nBasMax = nBas(iSym)
  nTriTot = nTriTot+nBas(iSym)*(nBas(iSym)+1)/2
  nSqrTot = nSqrTot+nBas(iSym)*nBas(iSym)
  nBasTot = nBasTot+nBas(iSym)
end do
!----------------------------------------------------------------------*
! Make symmetric orthonormal orbital basis.                            *
!----------------------------------------------------------------------*
call mma_allocate(CMO,nSqrTot)
ipCMO(1) = 1
do iSym=1,nSym-1
  ipCMO(iSym+1) = ipCMO(iSym)+nBas(iSym)*nBas(iSym)
end do
call goLowdin(CMO)
!----------------------------------------------------------------------*
! Allocate Fock matrix.                                                *
!----------------------------------------------------------------------*
call mma_allocate(Fock,nTriTot)
ipFock(1) = 1
call mma_allocate(EVec,nBasTot)
do iSym=1,nSym-1
  ipFock(iSym+1) = ipFock(iSym)+nBas(iSym)*(nBas(iSym)+1)/2
end do
call dCopy_(nTriTot,[Zero],0,Fock,1)
!----------------------------------------------------------------------*
! Create model Fock operator.                                          *
!----------------------------------------------------------------------*
call FockOper(RC,EVec)
if (RC /= 0) then
  call mma_deallocate(EVec)
  call mma_deallocate(Fock)
  call mma_deallocate(CMO)
  return
end if
!----------------------------------------------------------------------*
! Get overlap matrix and make normalization.                           *
!----------------------------------------------------------------------*
call mma_allocate(Ovl,nTriTot+4)
call mma_allocate(Nrm,nBasTot)
iSymlb = 1
call RdOne(irc,2,'Mltpl  0',1,Ovl,iSymlb)

ipX = 1
ipY = 1
do iSym=1,nSym
  call goPickup(Ovl(ipX),Nrm(ipY),nBas(iSym))
  do iBas=1,nBas(iSym)
    Nrm(ipY-1+iBas) = One/sqrt(Nrm(ipY-1+iBas))
  end do
  ipX = ipX+nBas(iSym)*(nBas(iSym)+1)/2
  ipY = ipY+nBas(iSym)
end do
!----------------------------------------------------------------------*
! Build Fock matrix.                                                   *
!----------------------------------------------------------------------*
ipX = 1
ipY = 1
iOff = 0
do iSym=1,nSym
  do iBas=1,nBas(iSym)
    do jBas=1,iBas
      dsum = Zero
      do kBas=1,nBas(iSym)
        eps = EVec(iOff+kBas)
        i = max(iBas,kBas)
        k = min(iBas,kBas)
        Sik = Ovl(ipX-1+i*(i-1)/2+k)*Nrm(ipY-1+iBas)*Nrm(ipY-1+kBas)
        i = max(jBas,kBas)
        k = min(jBas,kBas)
        Sjk = Ovl(ipX-1+i*(i-1)/2+k)*Nrm(ipY-1+jBas)*Nrm(ipY-1+kBas)
        dsum = dsum+eps*Sik*Sjk
      end do
      Fock(ipFock(iSym)-1+iBas*(iBas-1)/2+jBas) = dsum
    end do
  end do
  if (Debug) then
    call TriPrt('Modified atomic Fock matrix','(12f12.6)',Fock(ipFock(iSym)),nBas(iSym))
  end if
  ipX = ipX+nBas(iSym)*(nBas(iSym)+1)/2
  ipY = ipY+nBas(iSym)
  iOff = iOff+nBas(iSym)
end do
!----------------------------------------------------------------------*
! Scale Fock matrix.                                                   *
!----------------------------------------------------------------------*
ipX = 1
do iSym=1,nSym
  if (Debug) then
    write(u6,*) '***'
    write(u6,*) '*** Symmetry',iSym
    write(u6,*) '***'
  end if
  do iBas=1,nBas(iSym)
    do jBas=1,iBas
      Fock(ipFock(iSym)-1+iBas*(iBas-1)/2+jBas) = Fock(ipFock(iSym)-1+iBas*(iBas-1)/2+jBas)*sqrt(Ovl(ipX-1+iBas*(iBas+1)/2))* &
                                                  sqrt(Ovl(ipX-1+jBas*(jBas+1)/2))
    end do
  end do
  if (Debug) then
    call TriPrt('Scaled atomic Fock matrix','(12f12.6)',Fock(ipFock(iSym)),nBas(iSym))
  end if
  ipX = ipX+nBas(iSym)*(nBas(iSym)+1)/2
end do
!----------------------------------------------------------------------*
! Release overlap and norm arrays.                                     *
!----------------------------------------------------------------------*
call mma_deallocate(Nrm)
call mma_deallocate(Ovl)
!----------------------------------------------------------------------*
! Diagonalize Fock matrix.                                             *
!----------------------------------------------------------------------*
call mma_allocate(SFk,nBasMax*nBasMax)
call mma_allocate(Hlf,nBasMax*nBasMax)
call mma_allocate(TFk,nBasMax*(nBasMax+1)/2)
iOff = 0
do iSym=1,nSym
  if (Debug) then
    write(u6,*) '***'
    write(u6,*) '*** Symmetry',iSym
    write(u6,*) '***'
  end if
  if (nBas(iSym) > 0) then
    call Square(Fock(ipFock(iSym)),SFk,1,nBas(iSym),nBas(iSym))
    call DGEMM_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One,SFk,nBas(iSym),CMO(ipCMO(iSym)),nBas(iSym),Zero,Hlf,nBas(iSym))
    call DGEMM_Tri('T','N',nBas(iSym),nBas(iSym),nBas(iSym),One,CMO(ipCMO(iSym)),nBas(iSym),Hlf,nBas(iSym),Zero,TFk,nBas(iSym))
    if (Debug) then
      call TriPrt('Transformed Fock matrix','(12f12.6)',TFk,nBas(iSym))
    end if
  end if

  !call Jacob(TFk,CMO(ipCMO(iSym)),nbas(iSym),nbas(iSym))
  call NIdiag(TFk,CMO(ipCMO(iSym)),nbas(iSym),nbas(iSym))
  if (Debug) then
    call TriPrt('Diagonalized atomic Fock matrix','(12f12.6)',TFk,nBas(iSym))
  end if
  call goPickup(TFk,orbene(iOff+1),nBas(iSym))
  call goSort(orbene(iOff+1),CMO(ipCMO(iSym)),nBas(iSym),nBas(iSym))
  iOff = iOff+nBas(iSym)
end do
call mma_deallocate(TFk)
call mma_deallocate(Hlf)
call mma_deallocate(SFk)
!----------------------------------------------------------------------*
! Present data.                                                        *
!----------------------------------------------------------------------*
if (PrintMOs) then
  call PriMO('Start orbitals',.false.,.true.,Zero,1.0e6_wp,nSym,nBas,nBas,Label,orbene,orbene,CMO(ipCMO(1)),3)
end if
call put_darray('Guessorb',CMO(ipCMO(1)),nSqrTot)
call put_darray('Guessorb energies',orbene,nBasTot)
call Put_iArray('nOrb',nBas,nSym)
call mma_allocate(Aux1,nBasTot)
Aux1(:) = Zero
Lu = 20
Title = 'Guess orbitals'
call WrVec('GSSORB',Lu,'COE',NSYM,NBAS,NBAS,CMO(ipCMO(1)),Aux1,orbene,iDummy,Title)
call mma_deallocate(Aux1)
!----------------------------------------------------------------------*
! Done, deallocate the rest.                                           *
!----------------------------------------------------------------------*
call mma_deallocate(Evec)
call mma_deallocate(Fock)
call mma_deallocate(CMO)
if (trace) write(u6,*) '<<< Exiting fmod1n'

return

end subroutine Fmod1n

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine initfrac(nprimit1,nprimit2,nprimit3,nprimit4,quot1,quot2,expo1,expo2,expo3,expo4)
!bs initialize some arrays with factors  needed for cfunct(x)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nprimit1, nprimit2, nprimit3, nprimit4
real(kind=wp), intent(out) :: quot1(nprimit1,nprimit2,nprimit3,nprimit4), quot2(nprimit1,nprimit2,nprimit3,nprimit4)
real(kind=wp), intent(in) :: expo1(*), expo2(*), expo3(*), expo4(*)
integer(kind=iwp) :: irun2, irun3, irun4
real(kind=wp) :: sum24

do irun4=1,nprimit4
  do irun3=1,nprimit3
    do irun2=1,nprimit2
      sum24 = expo2(irun2)+expo4(irun4)
      quot1(1:nprimit1,irun2,irun3,irun4) = One/(One+(expo1(1:nprimit1)+expo3(irun3))/sum24)
    end do
  end do
end do
do irun4=1,nprimit4
  do irun3=1,nprimit3
    do irun2=1,nprimit2
      sum24 = expo2(irun2)+expo4(irun4)
      quot2(1:nprimit1,irun2,irun3,irun4) = One/(One+sum24/(expo1(1:nprimit1)+expo3(irun3)))
    end do
  end do
end do

return

end subroutine initfrac

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PrintResult(iUnit,FMT,STR,iCount,STR2,Value,iRank)
c routine to print result in the form:
c      Write(iUnit,FMT) STR,iCount,STR2,(Value(i),i=1,iRank)
c  or, if iCount=0
c      Write(iUnit,FMT) STR, (Value(i),i=1,iRank)
c
      character*(*) STR
      character*(*) STR2
      character*(*) FMT
      character*120 TMP
      character*2 Marker
      real*8 Value(iRank)
      Common /icolorize/icolorize
      if(icolorize.eq.1) then
        Marker='::'
        if(iCount.eq.0) then
          write(TMP,FMT) STR,(Value(i),i=1,iRank)
        else
          Write(TMP,FMT) STR,iCount,STR2,(Value(i),i=1,iRank)
        endif
        init=1
        if(TMP(1:3).eq.'   ') init=3
        Write(iUnit,'(a,a)') Marker,TMP(init:mylen(TMP))
      else
        if(iCount.eq.0) then
          Write(iUnit,FMT) STR,(Value(i),i=1,iRank)
        else
          Write(iUnit,FMT) STR,iCount,STR2,(Value(i),i=1,iRank)
        endif
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ReplicateData(LuC_Local,irc)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: replicate all local DF data on all nodes in a real
C     parallel run. Do nothing in serial runs.
C
#if defined (_MOLCAS_MPP_)
      Use Para_Info, Only: nProcs, Is_Real_Par
#endif
      Implicit None
      Integer LuC_Local
      Integer irc
#if defined (_MOLCAS_MPP_)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C PARALLEL CODE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_print.fh"

#if defined (_DEBUGPRINT_)
      Character*17 SecNam
      Parameter (SecNam='LDF_ReplicateData')
#endif

      Integer  LDF_DiskAddressOfC, LDF_AtomPair_DiagDim
      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_DiskAddressOfC, LDF_AtomPair_DiagDim
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Character*8 Label

      Integer n(1)

      Integer iAtomPair
      Integer ip, l
      Integer iAddr, jAddr
      Integer LuC
      Integer ip_C, l_C

      Logical Timing
      Real*8 tC0, tC1, tW0, tW1
      Real*8 tC2, tC3, tW2, tW3
      Real*8 tCIO, tWIO

      Integer i, j
      Integer ip_D
      Integer AP_Atoms, AP_1CLinDep, AP_2CFunctions
      Logical isUnique
      ip_D(i)=iWork(ip_AP_Diag-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      isUnique(i)=iWork(ip_AP_Unique-1+i).eq.i

      ! Init return code
      irc=0

      ! Only replicate data in truly parallel runs
      If (nProcs.gt.1 .and. Is_Real_Par()) Then
         ! Set timing flag
         Timing=iPrint.ge.Inf_DetailedTiming
C==========================
C        Replicate 1CLinDep
C==========================
         If (Timing) Call CWTime(tC0,tW0)
         Do iAtomPair=1,NumberOfAtomPairs
            If (isUnique(iAtomPair)) Then
               n(1)=AP_1CLinDep(1,iAtomPair)
               Call GAiGOp_SCAL(n(1),'max')
               If (n(1).gt.0) Then
                  l=3*n(1)
                  If (AP_1CLinDep(1,iAtomPair).gt.0) Then
#if defined (_DEBUGPRINT_)
                     If (LDF_DiskAddressOfC(iAtomPair).lt.0) Then
                        Call WarningMessage(1,
     &                            SecNam//': Parallelization error [1]')
                        irc=1
                        Return
                     End If
#endif
                     ip=AP_1CLinDep(2,iAtomPair)
#if defined (_DEBUGPRINT_)
                     If (ip.lt.1) Then
                        Call WarningMessage(1,
     &                            SecNam//': Parallelization error [2]')
                        irc=1
                        Return
                     End If
#endif
                  Else
                     Write(Label,'(A,I5.5)') '1CL',iAtomPair-1
                     Call GetMem(Label,'Allo','Inte',ip,l)
                     iWork(ip_AP_1CLinDep+2*(iAtomPair-1))=n(1)
                     iWork(ip_AP_1CLinDep+2*(iAtomPair-1)+1)=ip
                     Call iZero(iWork(ip),l)
                  End If
                  Call GAiGOp(iWork(ip),l,'+')
               End If
            End If
         End Do
         If (Timing) Then
            Call CWTime(tC1,tW1)
            Write(6,'(A,2F15.2,A)')
     &      'Time for 1CLinDep replication........',
     &      tC1-tC0,tW1-tW0,' seconds'
            tC0=tC1
            tW0=tW1
         End If
C=============================
C        Replicate 2CFunctions
C=============================
         Do iAtomPair=1,NumberOfAtomPairs
            If (isUnique(iAtomPair)) Then
               n(1)=AP_2CFunctions(1,iAtomPair)
               Call GAiGOp_SCAL(n(1),'max')
               If (n(1).gt.0) Then
                  l=4*n(1)
                  If (AP_2CFunctions(1,iAtomPair).gt.0) Then
#if defined (_DEBUGPRINT_)
                     If (LDF_DiskAddressOfC(iAtomPair).lt.0) Then
                        Call WarningMessage(1,
     &                            SecNam//': Parallelization error [3]')
                        irc=1
                        Return
                     End If
#endif
                     ip=AP_2CFunctions(2,iAtomPair)
#if defined (_DEBUGPRINT_)
                     If (ip.lt.1) Then
                        Call WarningMessage(1,
     &                            SecNam//': Parallelization error [4]')
                        irc=1
                        Return
                     End If
#endif
                  Else
                     Write(Label,'(A,I5.5)') '2CF',iAtomPair-1
                     Call GetMem(Label,'Allo','Inte',ip,l)
                     iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=n(1)
                     iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=ip
                     Call iZero(iWork(ip),l)
                  End If
                  Call GAiGOp(iWork(ip),l,'+')
               End If
            End If
         End Do
         If (Timing) Then
            Call CWTime(tC1,tW1)
            Write(6,'(A,2F15.2,A)')
     &      'Time for 2CFunctions replication.....',
     &      tC1-tC0,tW1-tW0,' seconds'
            tC0=tC1
            tW0=tW1
         End If
C=========================================
C        Replicate updated diagonal blocks
C=========================================
         Do iAtomPair=1,NumberOfAtompairs
            If (isUnique(iAtomPair)) Then
               l=LDF_AtomPair_DiagDim(iAtomPair)
               ip=ip_D(iAtomPair)
               If (LDF_DiskAddressOfC(iAtomPair).lt.0) Then
                  Call FZero(Work(ip),l)
               End If
               Call GAdGOp(Work(ip),l,'+')
            End If
         End Do
         If (Timing) Then
            Call CWTime(tC1,tW1)
            Write(6,'(A,2F15.2,A)')
     &      'Time for diagonal replication........',
     &      tC1-tC0,tW1-tW0,' seconds'
            tC0=tC1
            tW0=tW1
         End If
C======================================
C        Replicate fitting coefficients
C======================================
         ! Open full coefficient file
         LuC=7
         Call DAName_MF_WA(LuC,'LDFC')
         ! Allocate memory for coefficients
         l_C=0
         Do iAtomPair=1,NumberOfAtomPairs
            If (isUnique(iAtomPair)) Then
               l_C=max(l_C,LDF_nBas_Atom(AP_Atoms(1,iAtomPair))
     &                    *LDF_nBas_Atom(AP_Atoms(2,iAtomPair))
     &                    *LDF_nBasAux_Pair(iAtomPair))
            End If
         End Do
         Call GetMem('RPL_C','Allo','Real',ip_C,l_C)
         ! Init disk address for coefficients
         iAddr=0
         ! Init I/O timing
         tCIO=0.0d0
         tWIO=0.0d0
         ! Replicate data one atom pair at a time
         Do iAtomPair=1,NumberOfAtomPairs
            If (isUnique(iAtomPair)) Then
               l=LDF_nBas_Atom(AP_Atoms(1,iAtomPair))
     &          *LDF_nBas_Atom(AP_Atoms(2,iAtomPair))
     &          *LDF_nBasAux_Pair(iAtomPair)
               jAddr=LDF_DiskAddressOfC(iAtomPair)
               If (jAddr.ge.0) Then
                  Call CWTime(tC2,tW2)
                  Call dDAFile(LuC_Local,2,Work(ip_C),l,jAddr)
                  Call CWTime(tC3,tW3)
                  tCIO=tCIO+(tC3-tC2)
                  tWIO=tWIO+(tW3-tW2)
               Else
                  Call FZero(Work(ip_C),l)
               End If
               Call GAdGOp(Work(ip_C),l,'+')
               iWork(ip_AP_DiskC-1+iAtomPair)=iAddr
               Call CWTime(tC2,tW2)
               Call dDAFile(LuC,1,Work(ip_C),l,iAddr)
               Call CWTime(tC3,tW3)
               tCIO=tCIO+(tC3-tC2)
               tWIO=tWIO+(tW3-tW2)
            End If
         End Do
         ! Deallocate coefficient memory
         Call GetMem('RPL_C','Free','Real',ip_C,l_C)
         ! Close full coefficient file
         Call DAClos(LuC)
         If (Timing) Then
            Call CWTime(tC1,tW1)
            Write(6,'(A,2F15.2,A)')
     &      'Time for coefficient replication.....',
     &      tC1-tC0,tW1-tW0,' seconds'
            Write(6,'(A,2F15.2,A)')
     &      '   (of which I/O required............',
     &      tCIO,tWIO,' seconds)'
            Call xFlush(6)
         End If
      End If
#else
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C SERIAL CODE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      irc=0
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(LuC_Local)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Integer Function LDF_CloseC(LuC)
      Implicit None
      Integer LuC
#include "para_info.fh"
      If (LuC.lt.1) Then
         LDF_CloseC=-1
         Return
      End If
#if defined (_MOLCAS_MPP_)
      If (nProcs.gt.1 .and. Is_Real_Par()) Then
         Call DAEras(LuC)
      Else
         Call DAClos(LuC)
      End If
#else
      Call DAClos(LuC)
#endif
      LDF_CloseC=0
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_CALCINT_3(XINT,LINT,ISHLAB)
C
C     Purpose: calculate qualified integral columns from
C              shell pair distribution (**|ISHLA ISHLB).
C
C     Version 3: avoid storage of full shell quadruple in interface to
C                seward; get qualified directly as in Version 2!
C                Changes from Version 2:
C                - addressing of qualified columns
C                - integrals returned in core (no I/O)
C
#include "implicit.fh"
      DIMENSION XINT(LINT)
#include "cholesky.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*17 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_CALCINT_3')

      INTEGER NAB(8)
      INTEGER CHO_ISUMELM

      LOGICAL   DOINTS, LOCDBG
      PARAMETER (LOCDBG = .FALSE.)
      PARAMETER (INFINT = INF_INT, INFIN2 = INF_IN2)

      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NBSTSH(I)=IWORK(ip_NBSTSH-1+I)
      ISP2F(I)=IWORK(ip_iSP2F-1+I)

C     Initializations.
C     ----------------

      CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.TRUE.)

      XXSHL = DBLE(NNSHL)
      XSKIP = 0.0D0

      IF (IPRINT .GE. INFINT) WRITE(LUPRI,*)

C     Set mapping from shell pair AB to qualified columns.
C     ----------------------------------------------------

      IRC  = 0
      ILOC = 2
      CALL CHO_SETSHP2Q_2(IRC,ILOC,ISHLAB,NAB)
      IF (IRC .NE. 0) THEN
         WRITE(LUPRI,*) SECNAM,': CHO_SETSHP2Q_2 returned ',IRC
         CALL CHO_QUIT('Error termination in '//SECNAM,IRC)
      END IF

C     Print.
C     ------

      IF (IPRINT .GE. INF_IN2) THEN
         NCOLAB = CHO_ISUMELM(NAB,NSYM)
         WRITE(LUPRI,'(/,A,I5,1X,I5,A,I9,A)')
     &   'Calculating shell pair (**|',ISHLA,ISHLB,
     &   '):',NCOLAB,' columns have been qualified'
         WRITE(LUPRI,'(80A)') ('=',i=1,77)
      END IF

C     Loop over shell quadruples.
C     ---------------------------

      DO ISHLCD = 1,NNSHL

C        Set left shell pair index.
C        --------------------------

         CALL CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.TRUE.)
         IF (ISHLC .EQ. ISHLD) THEN
            NUMCD = NBSTSH(ISHLC)*(NBSTSH(ISHLC) + 1)/2
         ELSE
            NUMCD = NBSTSH(ISHLC)*NBSTSH(ISHLD)
         END IF

C        Find out if this shell pair (CD) contributes to
C        current reduced set.
C        -----------------------------------------------

         ISYM   = 1
         DOINTS = (NAB(ISYM).GT.0) .AND.
     &            (NNBSTRSH(ISYM,ISHLCD,2).GT.0)
         DO WHILE ((ISYM.LT.NSYM) .AND. (.NOT.DOINTS))
            ISYM   = ISYM + 1
            DOINTS = (NAB(ISYM).GT.0) .AND.
     &               (NNBSTRSH(ISYM,ISHLCD,2).GT.0)
         END DO

         IF (DOINTS) THEN

C           Print message.
C           --------------

            IF (IPRINT .GE. INFINT) THEN
                WRITE(LUPRI,'(A,I5,1X,I5,A,I5,1X,I5,A)')
     &          'Invoking Seward for shell quadruple (',ISHLC,ISHLD,
     &          '|',ISHLA,ISHLB,')'
            END IF

C           Set mapping from shell pair CD to reduced set.
C           ----------------------------------------------

            IRC  = 0
            ILOC = 2
            CALL CHO_SETSHP2RS(IRC,ILOC,ISHLCD,NAB)
            IF (IRC .NE. 0) THEN
               WRITE(LUPRI,*) SECNAM,': CHO_SETSHP2RS returned ',IRC
               CALL CHO_QUIT('Error termination in '//SECNAM,IRC)
            END IF

C           Calculate integrals.
C           --------------------

            CALL CHO_TIMER(C1,W1)
            CALL CHO_MCA_INT_1(ISHLCD,ISHLAB,
     &                         XINT,LINT,
     &                         LOCDBG.OR.(IPRINT.GE.100))
            CALL CHO_TIMER(C2,W2)
            TINTEG(1,1) = TINTEG(1,1) + C2 - C1
            TINTEG(2,1) = TINTEG(2,1) + W2 - W1

         ELSE

C           Update skip counter.
C           --------------------

            XSKIP = XSKIP + 1.0D0

C           Print message.
C           --------------

            IF (IPRINT .GE. INFINT) THEN
                WRITE(LUPRI,'(A,I5,1X,I5,A,I5,1X,I5,A)')
     &          'NOTICE: skipping shell quadruple    (',ISHLC,ISHLD,
     &          '|',ISHLA,ISHLB,')'
            END IF

         END IF

      END DO

C     Print skip statistics.
C     ----------------------

      IF (IPRINT .GE. INFIN2) THEN
         PCT = 1.0D2*XSKIP/XXSHL
         WRITE(LUPRI,'(A,F7.2,A)')
     &   'Skipped',PCT,'% of rows (shell pairs) in this distribution'
         CALL CHO_FLUSH(LUPRI)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine H0INTSPC(IH0SPC,NPTSPC,NOCTPA,NOCTPB,IOCA,IOCB,NGAS,MXPNGAS,INTH0SPC,NELFTP)
! Set up INTH0SPC : Division of CI space, so only determinants
!                   belonging to the same space  have nonvanishing
!                   matrix elements of H0
!
! =====
! Input
! =====
!
! IH0SPC : /= 0 : Interacting subspaces have been defined
!          == 0 : Interacting subspaces not defined, let
!                 everything interact
! NPTSPC : Number of subspaces defined
! NOCTPA :  Number of alpha occupation types
! NOCTPB : Number of beta occupation types
! IOCA : Occupation  of alpha string
! IOCB : Occupation  of beta string
!
! Jeppe Olsen, January 1996

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: IH0SPC, NPTSPC, MXPNGAS, NOCTPA, NOCTPB, IOCA(MXPNGAS,NOCTPA), IOCB(MXPNGAS,NOCTPB), NGAS, &
                                 NELFTP(*)
integer(kind=iwp), intent(out) :: INTH0SPC(NOCTPA,NOCTPB)
integer(kind=iwp) :: IAMOKAY, IATP, IBTP, IEL, IGAS, ISPC

if (IH0SPC == 0) then
  ! All interactions allowed
  INTH0SPC(:,:) = 1
else
  ! Explicit construction of matrix giving partitionning of subspaces
  INTH0SPC(:,:) = 0

  do ISPC=1,NPTSPC
    do IATP=1,NOCTPA
      do IBTP=1,NOCTPB
        IAMOKAY = 1
        IEL = 0
        !write(u6,*) ' ISPC IATP IBTP ',ISPC,IATP,IBTP
        do IGAS=1,NGAS
          IEL = IEL+NELFTP(IOCA(IGAS,IATP))+NELFTP(IOCB(IGAS,IBTP))
          !write(u6,*) ' IGAS IEL ',IGAS,IEL
          !write(u6,*) ' Limits :',IOCPTSPC(1,IGAS,ISPC),IOCPTSPC(2,IGAS,ISPC)
          !if ((IEL < IOCPTSPC(1,IGAS,ISPC)) .or. (IEL > IOCPTSPC(2,IGAS,ISPC))) IAMOKAY = 0
          if (IEL /= 0) IAMOKAY = 0
        end do
        !write(u6,*) ' IAMOKAY = ',IAMOKAY
        ! Allowed
        if ((IAMOKAY == 1) .and. (INTH0SPC(IATP,IBTP) == 0)) INTH0SPC(IATP,IBTP) = ISPC
      end do
    end do
  end do
end if

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ====================='
write(u6,*) ' Output from  H0INTSPC'
write(u6,*) ' ====================='
write(u6,*)
call IWRTMA(INTH0SPC,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
#endif

end subroutine H0INTSPC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ComputeZVec(iAtomPair,ip_V,l_V,ip_G,l_G,ip_Z,l_Z,
     &                           irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: Compute Z vectors by CD of the G matrix:
C
C        G[JK] = (J|K) = sum(I) Z(J,I)*Z(K,I)
C
C     The Z vectors are ordered according to auxiliary shells (plus
C     shell pairs if 2-center functions are included), as specified
C     through the atom pair list.
C
C     Linear dependence and 2-center functions may be redefined by this
C     routine (if linear dependence is detected). In that case, M may be
C     changed on exit from this routine.
C
C     The array V may be used as work space (it serves no other purpose)
C
C     irc is a return code (0 if succesful).
C
      Implicit None
      Integer iAtomPair
      Integer ip_V, l_V
      Integer ip_G, l_G
      Integer ip_Z, l_Z
      Integer irc
#include "WrkSpc.fh"

      Character*15 SecNam
      Parameter (SecNam='LDF_ComputeZVec')

      Integer  LDF_nBasAux_Pair
      External LDF_nBasAux_Pair
#if defined (_DEBUGPRINT_)
      Logical  isSymmetric, hasNonnegativeDiagonal, obeysCauchySchwarz
      External isSymmetric, hasNonnegativeDiagonal, obeysCauchySchwarz
#endif

      Real*8  Thr

      Integer M
      Integer ip_ID, l_ID
      Integer ip_Z_, l_Z_
      Integer ipG0, ipZ0
      Integer nZ

      Integer i, j
      Integer iTri
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      ! Init
      irc=0
      ip_Z=0
      l_Z=0

      ! Get number of auxiliary functions
      M=LDF_nBasAux_Pair(iAtomPair)
      If (M.lt.1) Return

#if defined (_DEBUGPRINT_)
      If (l_G.ne.M*M) Then
         Write(6,'(A,A,2I8)') SecNam,': l_G,M:',l_G,M
         irc=-1
         Return
      End If
      ! Check G matrix for symmetry and non-negative diagonals
      ! and Cauchy-Schwarz inequality
      irc=0
      If (.not.isSymmetric(Work(ip_G),M,1.0d-15)) Then
         Write(6,'(A,A)')
     &   SecNam,': G matrix is not symmetric!'
         irc=irc+1
      End If
      If (.not.hasNonnegativeDiagonal(Work(ip_G),M)) Then
         Write(6,'(A,A)')
     &   SecNam,': G matrix has negative diagonals!'
         irc=irc+1
      End If
      If (.not.obeysCauchySchwarz(Work(ip_G),M,1.0d-14)) Then
         Write(6,'(A,A)')
     &   SecNam,
     &   ': G matrix does not obey the Cauchy-Schwarz inequality!'
         irc=irc+1
      End If
      If (irc.ne.0) Then
         Write(6,'(A,A)')
     &   SecNam,': => G matrix not PSD!!'
         Call LDF_Quit(1)
      End If
#endif

      ! Incomplete CD of G matrix
      Thr=1.0d-14
      l_ID=M
      Call GetMem('CD_ID','Allo','Inte',ip_ID,l_ID)
      l_Z_=M*M
      If (l_V.ge.l_Z_) Then
         ip_Z_=ip_V
      Else
         Call GetMem('Z_','Allo','Real',ip_Z_,l_Z_)
      End If
      nZ=0
      Call CD_InCore_P(Work(ip_G),M,Work(ip_Z_),M,
     &                 iWork(ip_ID),nZ,Thr,irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': CD_InCore_P returned code',irc
         irc=1
         Call GetMem('CD_ID','Free','Inte',ip_ID,l_ID)
         If (ip_Z_.ne.ip_V) Then
            Call GetMem('Z_','Free','Real',ip_Z_,l_Z_)
         End If
         Return
      End If

      ! Handle linear dependence
      Call LDF_RemoveLinDep(iAtomPair,Work(ip_Z_),iWork(ip_ID),M,nZ)

      ! Compute linearly independent G matrix
      Call dGeMM_('N','T',nZ,nZ,nZ,
     &            1.0d0,Work(ip_Z_),M,Work(ip_Z_),M,
     &            0.0d0,Work(ip_G),nZ)

      ! Deallocate ID and Z_ arrays
      Call GetMem('CD_ID','Free','Inte',ip_ID,l_ID)
      If (ip_Z_.ne.ip_V) Then
         Call GetMem('Z_','Free','Real',ip_Z_,l_Z_)
      End If

      ! Compute Z vectors without pivoting by complete CD of G (with
      ! linear dependence removed!)
      Call CCD_InCore(Work(ip_G),nZ,irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': CCD_InCore returned code',irc
         irc=1
         Return
      End If

      ! Allocate memory for Z vectors
      l_Z=nZ*(nZ+1)/2
      Call GetMem('ZVec','Allo','Real',ip_Z,l_Z)

      ! Copy Z vectors from G
      ipZ0=ip_Z-1
      Do J=1,nZ
         ipG0=ip_G-1+nZ*(J-1)
         Do I=J,nZ
            Work(ipZ0+iTri(I,J))=Work(ipG0+I)
         End Do
      End Do

#ifndef _DEBUGPRINT_
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(l_G)
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Roland Lindh                                           *
!***********************************************************************
!  Get_Coord_New
!
!> @brief
!>   Get the updated/new symmetry-unique Cartesian coordinates of the basis set centers
!> @author R. Lindh
!>
!> @details
!> The utility will read the updated/new symmetry-unique Cartesian coordinates of the basis set centers from the runfile.
!>
!> @param[out] CN     Array of the symmetry-unique Cartesian coordinates of the basis set centers
!> @param[out] nAtoms Number of symmetry-unique basis set centers
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Get_Coord_New(CN,nAtoms)

use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), allocatable, intent(out) :: CN(:,:)
integer(kind=iwp), intent(out) :: nAtoms
integer(kind=iwp) :: nAtoms3
logical(kind=iwp) :: Found
character(len=*), parameter :: Label = 'GeoNew'

call qpg_dArray(Label,Found,nAtoms3)
nAtoms = nAtoms3/3
if ((.not. Found) .or. (nAtoms3 == 0)) return
call mma_allocate(CN,3,nAtoms)
call Get_dArray(Label,CN,nAtoms3)

return

end subroutine Get_Coord_New

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Per-Olof Widmark                                 *
*               1993, Markus P. Fuelscher                              *
*               1995, Anders Bernhardsson                              *
************************************************************************
      Subroutine RdMCK(rc,Option,InLab,iComp,Data,iSymLab)
************************************************************************
*                                                                      *
*     Purpose: Read data from one-electron integral file               *
*                                                                      *
*     Calling parameters:                                              *
*     rc      : Return code                                            *
*     Option  : Switch to set options                                  *
*     InLab   : Identifier for the data to read                        *
*     Comp    : Composite identifier to select components              *
*     Data    : contains on output the requested data                  *
*     SymLab  : symmetry label of the requested data                   *
*                                                                      *
*     Global data declarations (Include file):                         *
*     Parm    : Table of paramaters                                    *
*     rcParm  : Table of return codes                                  *
*     Switch  : Table of options                                       *
*     Common  : Common block containing ToC                            *
*     Data    : Data definitions                                       *
*                                                                      *
*     Local data declarations:                                         *
*     Label   : character*8, used to covert incoming names             *
*     TmpBuf  : I/O buffer                                             *
*     HldBuf  : I/O buffer                                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark and M.P. Fuelscher                                  *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*     Modified by:                                                     *
*     Anders Bernhardsson                                              *
*     University of Lund, Sweden, 1995                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
#include "MckRc.fh"
#include "MckFlags.fh"
#include "SysDef.fh"
#include "MckDat.fh"
      Character*(*) InLab
      Dimension Data(*)
*
      Logical Debug
      Character*8 TmpLab,Label
*     Dimension LabTmp(2)
*     Equivalence (TmpLab,LabTmp)
      Dimension TmpBuf(nBuf),HldBuf(1)
      Character*16 TheName
      Data TheName/'RdMck'/
      Data CurrOp/1/
      Data Debug/.false./
*----------------------------------------------------------------------*
*     Start procedure:                                                 *
*     Define inline function (symmetry multiplication)                 *
*----------------------------------------------------------------------*
      MulTab(i,j)=iEor(i-1,j-1)+1
*----------------------------------------------------------------------*
*     Pick up the file definitions                                     *
*----------------------------------------------------------------------*
      icpi=itob
      Length=rc
      rc    = rc0000
      LuMck = AuxMck(pLu  )
      Open  = AuxMck(pOpen)
*----------------------------------------------------------------------*
*     Check the file status                                            *
*----------------------------------------------------------------------*
      If(Open.ne.1) Then
          Call SysFileMsg(TheName,'MSG: open',LuMck,' ')
      End If
*----------------------------------------------------------------------*
*     Truncate the label to 8 characters and convert it to upper case  *
*----------------------------------------------------------------------*
*     Call StdFmt(InLab,Label)
      Label=InLab
      Call UpCase(Label)
      TmpLab=Label
      Comp=icomp
      Symlab=isymlab
      If ((label.eq.'STATHESS').or.
     &    (label.eq.'RESPHESS').or.
     &    (label.eq.'CONNHESS').or.
     &    (label.eq.'HESS').or.
     &    (label.eq.'NUCGRAD').or.
     &    (label.eq.'TWOGRAD')) Then
       Comp=1
       Symlab=1
      End If
*----------------------------------------------------------------------*
*     Print debugging information                                      *
*----------------------------------------------------------------------*
      If(iAnd(option,1024).ne.0) debug=.true.
      If(Debug) Then
         Write(6,*) '<<< Entering RdMck  >>>'
         Write(6,'(a,z8)') ' rc on entry:     ',rc
         Write(6,'(a,a)')  ' Label on entry:  ',Label
         Write(6,'(a,z8)') ' Comp on entry:   ',Comp
         Write(6,'(a,z8)') ' SymLab on entry: ',SymLab
         Write(6,'(a,z8)') ' Option on entry: ',Option
      End If
*----------------------------------------------------------------------*
*     Check reading mode                                               *
*----------------------------------------------------------------------*
      If(iAnd(iAnd(option,sRdFst),sRdNxt).ne.0) Then
         Call SysWarnMsg(TheName,'Invalid value',' ')
         Call SysCondMsg('iAnd(iAnd(option,sRdFst),sRdNxt).eq.0',
     &           iAnd(iAnd(option,sRdFst),sRdNxt),'<>',0)
      Else If(iAnd(iAnd(option,sRdFst),sRdCur).ne.0) Then
         Call SysWarnMsg(TheName,'Invalid value',' ')
         Call SysCondMsg('iAnd(iAnd(option,sRdFst),sRdCur).eq.0',
     &           iAnd(iAnd(option,sRdFst),sRdCur),'<>',0)
      Else If(iAnd(iAnd(option,sRdNxt),sRdCur).ne.0) Then
         Call SysWarnMsg(TheName,'Invalid value',' ')
         Call SysCondMsg('iAnd(iAnd(option,sRdNxt),sRdCur).eq.0',
     &           iAnd(iAnd(option,sRdNxt),sRdCur),'<>',0)
      End If
*----------------------------------------------------------------------*
*     Read data from ToC                                               *
*----------------------------------------------------------------------*
      NoGo=sRdFst+sRdNxt+sRdCur
      If(Label.eq.'TITLE' .and. iAnd(option,NoGo).eq.0) Then
         If(TocOne(pTitle).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)

         End If
         If(iAnd(option,sOpSiz).eq.0) Then
            Call iCopy(nTitle,TocOne(pTitle+1),1,Data(1),1)
            If(debug) Then
               Write(6,'(a,z8)') ' Reading Title:'
               Write(6,'(8(1x,z8))') (Data(k),k=1,nTitle)
            End If
         Else
            Data(1)=nTitle
            If(debug) Then
               Write(6,'(a,z8)') ' Reading Title:',Data(1)
            End If
         End If
      else If(Label.eq.'CHDISP' .and. iAnd(option,NoGo).eq.0) Then
         If(TocOne(pCHDISP).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         If(iAnd(option,sOpSiz).eq.0) Then
            Len=TocOne(pnDisp)*30/icpi+1
            Call iCopy(Len,TocOne(pchdisp),1,Data(1),1)
            If(debug) Then
               Write(6,'(a,z8)') ' Reading perturbations:'
               Write(6,'(8(1x,z8))') (Data(k),k=1,nTitle)
            End If
         Else
            Data(1)=TocOne(pnDisp)*30/icpi+1
            If(debug) Then
               Write(6,'(a,z8)') ' Reading perturbations:',Data(1)
            End If
         End If
      Else If(Label.eq.'NDISP' .and. iAnd(option,NoGo).eq.0) Then
         If(TocOne(pndisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         If(iAnd(option,sOpSiz).eq.0) Then
            Data(1)=TocOne(pndisp)
         Else
            Data(1)=1
         End If
         If(debug) Then
            Write(6,'(a,z8)') ' Reading nSym: ',Data(1)
         End If
      Else If(Label.eq.'NSYM' .and. iAnd(option,NoGo).eq.0) Then
         If(TocOne(pSym).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         If(iAnd(option,sOpSiz).eq.0) Then
            Data(1)=TocOne(pSym)
         Else
            Data(1)=1
         End If
         If(debug) Then
            Write(6,'(a,z8)') ' Reading nSym: ',Data(1)
         End If
      Else If(Label.eq.'NBAS' .and. iAnd(option,NoGo).eq.0) Then
         If(TocOne(pBas).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         If(iAnd(option,sOpSiz).eq.0) Then
            Len=TocOne(pSym)
            Call iCopy(Len,TocOne(pBas),1,Data,1)
            If(debug) Then
               Write(6,'(a,8z8)') ' Reading nBas: ',(Data(k),k=1,Len)
            End If
         Else
            Data(1)=TocOne(pSym)
            If(debug) Then
               Write(6,'(a,z8)') ' Reading nBas: ',Data(1)
            End If
         End If
      Else If(Label.eq.'LDISP' .and. iAnd(option,NoGo).eq.0) Then
         If(TocOne(pldisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         If(iAnd(option,sOpSiz).eq.0) Then
            Len=TocOne(psym)
            Call iCopy(Len,TocOne(pldisp),1,Data,1)
            If(debug) Then
               Write(6,'(a,8z8)') ' Reading ldisp: ',(Data(k),k=1,Len)
            End If
         Else
            Data(1)=TocOne(pSym)
            If(debug) Then
               Write(6,'(a,z8)') ' Reading ldisp: ',Data(1)
            End If
         End If
         Else If(Label.eq.'TDISP' .and. iAnd(option,NoGo).eq.0) Then
          If(TocOne(ptdisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
          End If
          If(iAnd(option,sOpSiz).eq.0) Then
             Len=TocOne(pndisp)
             Call iCopy(Len,TocOne(ptdisp),1,Data,1)
             If(debug) Then
                Write(6,'(a,8z8)') ' Reading nBas: ',(Data(k),k=1,Len)
             End If
          Else
             Data(1)=TocOne(pSym)
             If(debug) Then
                Write(6,'(a,z8)') ' Reading nBas: ',Data(1)
             End If
          End If
      Else If(Label.eq.'NASH' .and. iAnd(option,NoGo).eq.0) Then
         If(TocOne(pASH).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         If(iAnd(option,sOpSiz).eq.0) Then
            Len=TocOne(pSYM)
            Call iCopy(Len,TocOne(pASH),1,Data,1)
            If(debug) Then
               Write(6,'(a,8z8)') ' Reading nASH: ',(Data(k),k=1,Len)
            End If
         Else
            Data(1)=TocOne(pSym)
            If(debug) Then
               Write(6,'(a,z8)') ' Reading nASH: ',Data(1)
            End If
         End If
      Else If (label.eq.'PERT') Then
         Call icopy(16/icpi,TocOne(pPert),1,Data,1)
      Else If (label.eq.'NRCTDISP') THEN
*
         If(TocOne(pndisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pndisp)
         Call iCOPY(Len,TocOne(pnrdisp),1,Data,1)
*
      Else If(Label.eq.'SYMOP' .and. iAnd(option,NoGo).eq.0) Then
         If (TocOne(pSym).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         If(iAnd(option,sOpSiz).eq.0) Then
*           Len=(3*TocOne(pSym)-1)/icpi+1
            Len=(3*TocOne(pSym)+ItoB-1)/ItoB
            Call iCopy(Len,TocOne(pSymOp),1,Data,1)
            If(debug) Then
               Write(6,'(a)') ' Reading symmetry operators:'
               Write(6,'(8(1x,z8))') (Data(k),k=1,Len)
            End If
         Else
            Data(1)=TocOne(pSym)
            If(debug) Then
               Write(6,'(a,z8)') ' Reading symmetry operators:',Data(1)
            End If
         End If
      Else If (label.eq.'DEGDISP ') THEN
*
         If(TocOne(pndisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pndisp)
         Call iCOPY(Len,TocOne(pdegdisp),1,Data,1)
*
      Else
*----------------------------------------------------------------------*
*     Read operators from integral records                             *
*----------------------------------------------------------------------*
         If(iAnd(option,sRdNxt).ne.0) Then
            If(debug) Then
               Write(6,'(a)') ' Reading next item'
            End If
            CurrOp=CurrOp+1
            If(CurrOp.gt.MxOp) Then
               CurrOp=0
            Else If(TocOne(pOp+LenOp*(CurrOp-1)+oLabel).eq.Nan) Then
               CurrOp=0
            Else
               i=CurrOp
*               LabTmp(1)=TocOne(pOp+LenOp*(i-1)+oLabel  )
*#ifndef _I8_
*               LabTmp(2)=TocOne(pOp+LenOp*(i-1)+oLabel+1)
*#endif
               Call ByteCopy(TocOne(pOp+LenOp*(i-1)+oLabel),TmpLab,8)
               Label=TmpLab
               InLab=Label
               SymLab=TocOne(pOp+LenOp*(i-1)+oSymLb)
               Comp=TocOne(pOp+LenOp*(i-1)+oComp   )
            End If
         Else If(iAnd(option,sRdFst).ne.0) Then
            If(debug) Then
               Write(6,'(a)') ' Reading first item'
            End If
            CurrOp=1
            If(TocOne(pOp+LenOp*(CurrOp-1)+oLabel).eq.Nan) Then
               CurrOp=0
            Else
               i=CurrOp
*               LabTmp(1)=TocOne(pOp+LenOp*(i-1)+oLabel  )
*#ifndef _I8_
*               LabTmp(2)=TocOne(pOp+LenOp*(i-1)+oLabel+1)
*#endif
               Call ByteCopy(TocOne(pOp+LenOp*(i-1)+oLabel),TmpLab,8)
               Label=TmpLab
               InLab=Label
               SymLab=TocOne(pOp+LenOp*(i-1)+oSymLb)
               Comp=TocOne(pOp+LenOp*(i-1)+oComp   )
            End If
         Else If(iAnd(option,sRdCur).ne.0) Then
            If(debug) Then
               Write(6,'(a)') ' Reading current item'
            End If
            If(CurrOp.lt.1 .or. CurrOp.gt.MxOp) Then
               CurrOp=0
            Else If(TocOne(pOp+LenOp*(CurrOp-1)+oLabel).eq.Nan) Then
               CurrOp=0
            Else
               i=CurrOp
*               LabTmp(1)=TocOne(pOp+LenOp*(i-1)+oLabel  )
*#ifndef _I8_
*               LabTmp(2)=TocOne(pOp+LenOp*(i-1)+oLabel+1)
*#endif
               Call ByteCopy(TocOne(pOp+LenOp*(i-1)+oLabel),TmpLab,8)
               Label=TmpLab
               InLab=Label
               SymLab=TocOne(pOp+LenOp*(i-1)+oSymLb)
               Comp=TocOne(pOp+LenOp*(i-1)+oComp   )
            End If
         Else
            CurrOp=0
            Do 500 i=MxOp,1,-1
*               LabTmp(1)=TocOne(pOp+LenOp*(i-1)+oLabel  )
*#ifndef _I8_
*               LabTmp(2)=TocOne(pOp+LenOp*(i-1)+oLabel+1)
*#endif
               Call ByteCopy(TocOne(pOp+LenOp*(i-1)+oLabel),TmpLab,8)
               CmpTmp=TocOne(pOp+LenOp*(i-1)+oComp   )
               TmpCmp=Comp
               If(TmpLab.eq.Label .and. CmpTmp.eq.TmpCmp) CurrOp=i
500         Continue
         End If
         If(CurrOp.eq.0) Then
         Call SysAbendMsg(TheName,'Current Operation .eq. 0',' ')
         End If
         SymLab=TocOne(pOp+LenOp*(CurrOp-1)+oSymLb)
*
         If (Label.eq.'MOPERT') Then
            iTmp=SymLab
            Do iIrr=1,TocOne(pSym)
             If (iTmp.eq.1) iIrrep=iIrr
             iTmp=iTmp/2
            End Do
            na=0
            Do i=0,TocOne(psym)-1
             na=TocOne(pAsh+i)+na
            End Do
            Len=na*(na+1)/2
            Len=len*(len+1)/2
         Else If (label.eq.'NUCGRAD') Then
             Comp=1
             SymLab=1
             If(TocOne(pldisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
             End If
             Len=TocOne(pldisp)
         Else If (label.eq.'TWOGRAD') Then
             Comp=1
             SymLab=1
             If(TocOne(pldisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
             End If
             Len=TocOne(pldisp)
         Else If ((label.eq.'STATHESS').or.
     &            (label.eq.'RESPHESS').or.
     &            (label.eq.'CONNHESS').or.
     &            (label.eq.'HESS')) Then
             Comp=1
             SymLab=1
             If(TocOne(pndisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
             End If
             Len=0
             Do iSym=0,TocOne(pSym)-1
               Len=Len+TocOne(pldisp+isym)*
     &                (TocOne(pldisp+isym)+1)/2
             End Do
*
         Else If (label.eq.'INACTIVE') THEN
             Len=0
             Do iS=1,TocOne(pSym)
              Do jS=1,TocOne(pSym)
               ijS=MulTab(iS,jS)
               If(iAnd(2**(ijS-1),SymLab).ne.0) Then
                 jBas=TocOne(pbas+jS-1)
                 iBas=TocOne(pbas+iS-1)
           If (jBas.eq.NaN)
     * Call SysAbendMsg(TheName,'jBas.eq.NaN at label',Label)
           If (iBas.eq.NaN)
     * Call SysAbendMsg(TheName,'iBas.eq.NaN at label',Label)
                 Len=len+iBas*jBas
               End If
              End Do
             End Do

         Else If (label.eq.'TOTAL') THEN
             Len=0
             Do iS=1,TocOne(pSym)
              Do jS=1,TocOne(pSym)
               ijS=MulTab(iS,jS)
               If(iAnd(2**(ijS-1),SymLab).ne.0) Then
                 jBas=TocOne(pbas+jS-1)
                 iBas=TocOne(pbas+iS-1)
           If (jBas.eq.NaN)
     * Call SysAbendMsg(TheName,'jBas.eq.NaN at label',Label)
           If (iBas.eq.NaN)
     * Call SysAbendMsg(TheName,'iBas.eq.NaN at label',Label)
                 Len=len+iBas*jBas
               End If
              End Do
             End Do
          Else
*
            Len=0
            Do 510 i=1,TocOne(pSym)
            Do 511 j=1,i
              ij=MulTab(i,j)-1
              If(iAnd(2**ij,SymLab).ne.0) Then
                 If(i.eq.j) Then
                    Len=Len+TocOne(pBas-1+i)*(TocOne(pBas-1+i)+1)/2
                 Else
                    Len=Len+TocOne(pBas-1+i)*TocOne(pBas-1+j)
                 End If
              End If
511         Continue
510         Continue
            If (iAnd(Option,slength).ne.0) Len=Length
         End If

         Data(1)=Len
         If ( IAND(option,sOpSiz).eq.0 ) Then
           Len=rtoi*Len
           IndDta=1
           IndHld=1
           iDisk=TocOne(pOp+LenOp*(CurrOp-1)+oAddr   )
           Do 550 k=0,Len+nAuxDt-1,nBuf
              iBuf=Max(0,Min(nBuf,Len+nAuxDt-k))
              tBuf=Max(0,Min(nBuf,Len-k))
              eBuf=iBuf-tBuf
              Call iDaFile(LuMCK,2,TmpBuf,iBuf,iDisk)
              IndTmp=1
              Call iCopy(tBuf,TmpBuf(IndTmp),1,Data(IndDta),1)
              If(debug) Then
                 Write(6,'(a,z8)') ' Reading buffer to: ',IndDta
                 Write(6,'(8(1x,z8))') (Data(IndDta+m),m=0,tBuf-1)
              End If
              IndTmp=IndTmp+tBuf
              IndDta=IndDta+tBuf
              If(tBuf.lt.iBuf) Then
                 Call iCopy(eBuf,TmpBuf(IndTmp),1,HldBuf(IndHld),1)
                 IndTmp=IndTmp+eBuf
                 IndHld=IndHld+eBuf
              End If
550        Continue
*          If(iAnd(sNoOri,option).eq.0) Then
*             Call iCopy(6,HldBuf(1),1,Data(IndDta),1)
*             If(debug) Then
*                Write(*,'(a,z8)') ' Reading buffer to: ',IndDta
*                Write(*,'(8(1x,z8))') (Data(IndDta+m),m=0,5)
*             End If
*          End If
           IndDta=IndDta+6
*          If(iAnd(sNoNuc,option).eq.0) Then
*             Call iCopy(2,HldBuf(7),1,Data(IndDta),1)
*             If(debug) Then
*                Write(*,'(a,z8)') ' Reading buffer to: ',IndDta
*                Write(*,'(8(1x,z8))') (Data(IndDta+m),m=0,1)
*             End If
*          End If
*          IndDta=IndDta+2
        End If
      End If
*----------------------------------------------------------------------*
*     Print debugging information                                      *
*----------------------------------------------------------------------*
      If(Debug) Then
         Write(6,*) '<<< Exiting RdMck >>>'
         Write(6,'(a,z8)') ' rc on exit:     ',rc
         Write(6,'(a,a)')  ' Label on exit:  ',Label
         Write(6,'(a,z8)') ' Comp on exit:    ',Comp
         Write(6,'(a,z8)') ' SymLab on exit: ',SymLab
         Write(6,'(a,z8)') ' Option on exit: ',Option
      End If
*----------------------------------------------------------------------*
*     Terminate procedure                                              *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  CIWEIGHT  := Chirgwin-Couson/Lowdin/inverse-overlap weights of     *
!*            := full CASSCF vector and residual.                      *
!*                                                                     *
!***********************************************************************
subroutine ciweight_cvb(civec,civbs,civb,citmp,vec5,orbs,sorbs,orbinv,owrk)

use casvb_global, only: nalf, nbet, ndet, nel, norb
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: civec(0:ndet), civbs(0:ndet), civb(0:ndet), citmp(0:ndet), vec5(0:ndet)
real(kind=wp), intent(in) :: orbs(norb,norb)
real(kind=wp), intent(out) :: sorbs(norb,norb), orbinv(norb,norb), owrk(norb,norb)
integer(kind=iwp) :: ion, ionmax, ionmin, iretval1, iretval2, mxasg, mxdetcas, mxrem, mxsng, ncnfcas

ionmin = max(nel-norb,0)
ionmax = nbet
mxrem = norb-ionmin
mxsng = nel-2*ionmin
mxasg = nalf-ionmin
call icomb_cvb(mxsng,mxasg,mxdetcas)
! Work out number of configurations in CASSCF vector:
ncnfcas = 0
do ion=ionmin,ionmax
  call icomb_cvb(norb,ion,iretval1)
  call icomb_cvb(norb-ion,nel-2*ion,iretval2)
  ncnfcas = ncnfcas+iretval1*iretval2
end do

call ciweight2_cvb(civec,civbs,civb,citmp,vec5,orbs,sorbs,orbinv,owrk,ionmin,ionmax,mxrem,mxsng,mxasg,ncnfcas,mxdetcas)

return

end subroutine ciweight_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SHTOOB(NSHPIR,NIRREP,MXPOBS,NSMOB,NOSPIR,IOSPIR,NOBPS,NOB)
! Number of shells per irrep => Number of orbitals per symmetry
!
! =====
! Input
! =====
!  NSHPIR : Number of shells per irrep
!  NIRREP : Number of irreps
!  MXPOBS : Largest allowed number of orbitals symmetries
!  NSMOB  : Number of orbital symmetries
!  NOSPIR : Number of orbital symmetries per irrep
!  IOSPIR : Orbital symmetries per irrep
!
! ======
! Output
! ======
!  NOBPS  : Number of orbitals per symmetry
!  NOB    : Number of orbitals
!
! Jeppe Olsen, Winter of 1991

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NIRREP, NSHPIR(NIRREP), MXPOBS, NSMOB, NOSPIR(NIRREP), IOSPIR(MXPOBS,NIRREP)
integer(kind=iwp), intent(out) :: NOBPS(NSMOB), NOB
integer(kind=iwp) :: IISM, IRREP, ISM

NOBPS(1:NSMOB) = 0
NOB = 0
do IRREP=1,NIRREP
  do ISM=1,NOSPIR(IRREP)
    IISM = IOSPIR(ISM,IRREP)
    NOBPS(IISM) = NOBPS(IISM)+NSHPIR(IRREP)
    NOB = NOB+NSHPIR(IRREP)
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' SHTOOB Speaking'
write(u6,*) ' ==============='
write(u6,*) ' Number of orbitals obtained ',NOB
write(u6,*) ' Number of orbitals per symmetry'
call IWRTMA(NOBPS,1,NSMOB,1,NSMOB)
#endif

end subroutine SHTOOB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE IPO(IPOA,NVIR,MUL,NSYM,KLS,IFT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IPOA(*),NVIR(*),MUL(8,8)
      NSUM=0
      IF(IFT.LT.0) THEN
        DO 10 N=1,NSYM
          IPOA(N)=NSUM
          M=MUL(N,KLS)
          NSUM=NSUM+NVIR(N)*NVIR(M)
10      CONTINUE
      ELSE
        IF (KLS.EQ.1) THEN
          DO 20 N=1,NSYM
            IPOA(N)=NSUM
            NSUM=NSUM+(NVIR(N)*(NVIR(N)+1))/2
20        CONTINUE
        ELSE
          DO 30 N=1,NSYM
            IPOA(N)=NSUM
            M=MUL(N,KLS)
            IF(N.GT.M) THEN
              NSUM=NSUM+NVIR(N)*NVIR(M)
            END IF
30        CONTINUE
        END IF
      END IF
      IPOA(NSYM+1)=NSUM
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000-2016, Valera Veryazov                             *
!***********************************************************************

subroutine MolcasControlInit(label)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: Label
character(len=512) :: tmp
character(len=32) :: My
integer(kind=iwp) :: i, ic, islast, Lu
integer(kind=iwp), parameter :: nLines = 20
character(len=*), parameter :: filename = 'molcas.control'
integer(kind=iwp), external :: StrnLn

iC = 0
tmp = Label(1:len(Label))
Lu = 1
call molcas_open(Lu,filename)
write(Lu,'(a)') '# Molcas control file: change # to ! to activate.'
islast = 0

do
  i = index(tmp,',')
  My = ' '
  if (i > 0) then
    My(1:i-1) = tmp(1:i-1)
    tmp = tmp(i+1:)
  else
    My = trim(tmp)
    islast = 1
  end if
  iC = iC+1
  if (ic > nLines) call abend()
  i = StrnLn(My)
  if (index(My,'=') == 0) then
    i = i+1
    My(i:i) = '='
  end if
  write(Lu,'(a,a)') '#',My(1:i)
  if (islast /= 0) exit
end do
close(Lu)

return

end subroutine MolcasControlInit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION GTH1ES_MCLR(IREOTS,IPNT,H,IBSO,
     &           IBTSOB,IORB,ITP,ISM,JORB,JTP,JSM)
* ireots
* ipnt
* H
* ibso
* ibtsob
*
* This is a fantastic solution of the problem hehehehe!!
*  EAW
*
* one electron integral between orbitals (iorb,itp,ism,jorb,jsm,jtp)
*
* correct combination of row and column symmetry is assumed
      IMPLICIT REAL*8(A-H,O-Z)

#include "Input.fh"
*.Input
      INTEGER IREOTS(*),IPNT(*),IBTSOB(3,*),IBSO(*)
      DIMENSION H(*)
*
      IABS = IORB+IBTSOB(ITP,ISM)-1
      IREO = IREOTS(IABS)
      JABS = JORB+IBTSOB(JTP,JSM)-1
      JREO = IREOTS(JABS)
      I1=IREO-IBSO(ISM)+1+nISH(ISM)
      J1=JREO-IBSO(JSM)+1+nISH(jSM)
      IJ=IPNT(ISM)-1+(J1-1)*NORB(ISM)+I1
      GTH1ES_MCLR = H(IJ)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SUBROUTINE REORD_Pmat(ipDA2,ipPmat,ipDSA2)

      Implicit Real*8 (a-h,o-z)

      Integer  ipDA2,ipPmat
      Integer  nnA(8,8),ipDSA2(8,8,8)
      Integer  iAorb(8),cho_irange
      External cho_irange
#include "rasdim.fh"
#include "general.fh"
#include "WrkSpc.fh"

C ************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
C ************************************************
      iTri(i,j) = Max(i,j)*(Max(i,j)-3)/2 + i + j
C ************************************************


      Call set_nnA(nSym,nAsh,nnA)

C --------------------------------------------------
C --- P[tw],xy :  stored as squared in [tw] and
C ---             lower triangular (packed) in (xy)
C ---             and blocked by symmetry
C --------------------------------------------------
      nPmat=0
      Do JSYM=1,nSym
         Do iSymy=1,nSym
            iSymx=MulD2h(iSymy,JSYM)
            if (iSymx.le.iSymy) then
            Do iSymw=1,nSym
               iSymt=MulD2h(iSymw,JSYM)
               ipDSA2(iSymw,iSymy,JSYM) = ipPmat + nPmat
               nPmat = nPmat
     &               + nAsh(iSymt)*nAsh(iSymw)*nnA(iSymx,iSymy)
            End Do
            endif
         End do
      End Do

      iAorb(1)= 0
      Do iSym = 2,nSym
         iAorb(iSym) = iAorb(iSym-1) + nAsh(iSym-1)
      End Do

      nAcOrb = iAorb(nSym) + nAsh(nSym)

C --- Copy out elements in the reorder 2-el density matrix
C --- From Canonical storage ( t>=w, x>=y, (tw)>=(xy) )
C --- to the cholesky storage P[tw],xy
C --- Diagonal (xy) elements are already scaled by a factor 1/2
C --------------------------------------------------------------

      Do iyG=1,nAcOrb    ! global index in total # of active orbitals

         iSymy = CHO_IRANGE(iyG,iAorb,nSym,.FALSE.)
         iy = iyG - iAorb(iSymy)

         Do ixG=iyG,nAcOrb

            ixyG = ixG*(ixG-1)/2 + iyG
            iSymx = CHO_IRANGE(ixG,iAorb,nSym,.FALSE.)
            ix = ixG - iAorb(iSymx)
            if (iSymx.eq.iSymy) then
               ixy = iTri(ix,iy)
            else
               ixy  = nAsh(iSymx)*(iy-1) + ix
            endif

            Do iwG=1,nAcOrb

               iSymw = CHO_IRANGE(iwG,iAorb,nSym,.FALSE.)
               iw = iwG - iAorb(iSymw)

               Do itG=iwG,nAcOrb

                  iSymt = CHO_IRANGE(itG,iAorb,nSym,.FALSE.)
                  it = itG - iAorb(iSymt)

                  iSymTW = MulD2h(iSymt,iSymw)
                  iSymXY = MulD2h(iSymx,iSymy)

                  itwG = itG*(itG-1)/2 + iwG

                  If (iSymTW.eq.iSymXY .and. itwG.ge.ixyG) Then

                     kfrom = ipDA2 + iTri(itwG,ixyG) - 1

                     Ntw = nAsh(iSymt)*nAsh(iSymw)
                     itw1 = nAsh(iSymt)*(iw-1) + it

                     kto1 = ipDSA2(iSymw,iSymy,iSymXY) - 1
     &                    + Ntw*(ixy-1) + itw1

                     Work(kto1) = Work(kfrom)

                     itw2 = nAsh(iSymw)*(it-1) + iw

                     kto2 = ipDSA2(iSymt,iSymy,iSymXY) - 1
     &                    + Ntw*(ixy-1) + itw2

                     Work(kto2) = Work(kfrom)

                     if (iSymt.eq.iSymw) then
                        itw = iTri(it,iw)
                     else
                        itw  = nAsh(iSymt)*(iw-1) + it
                     endif
                     Nxy = nAsh(iSymx)*nAsh(iSymy)
                     ixy1 = nAsh(iSymx)*(iy-1) + ix

                     kto3 = ipDSA2(iSymy,iSymw,iSymXY) - 1
     &                    + Nxy*(itw-1) + ixy1

                     Work(kto3) = Work(kfrom)

                     ixy2 = nAsh(iSymy)*(ix-1) + iy

                     kto4 = ipDSA2(iSymx,iSymw,iSymXY) - 1
     &                    + Nxy*(itw-1) + ixy2

                     Work(kto4) = Work(kfrom)

                  End If

               End Do

            End Do

         End Do

      End Do


      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine CD_Diag(CD_Vec,Restart,Converged,Thr,ThrNeg,ThrFail,DiaInp,Diag,Buf,nDim,lBuf,ErrStat,NumCho,irc)
!
! Thomas Bondo Pedersen, October 2004.
!
! Purpose: set up diagonal for general Cholesky decomposition.
!
! NB!! ThrNeg and ThrFail are supposed to be negative with
!      ThrFail < ThrNeg. Diagonals less than ThrNeg are zeroed,
!      while diagonals less than ThrFail is taken as a sign of
!      a non-positive definite matrix (i.e., decomposition will
!      fail).
!
! Error codes, irc:
!    0 : all OK
!  201 : inconsistent input: Restart but NumCho < 0.
!        (NumCho >= 0 is allowed with Restart.)
!  202 : insufficient buffer size, lBuf.
!  203 : too negative diagonal element found (i.e., matrix
!        is non-positive definite).
!
! CD_Vec : external routine for vectors

use Cho_interfaces, only: cdvec_kernel
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
procedure(cdvec_kernel) :: CD_Vec
logical(kind=iwp), intent(in) :: Restart
logical(kind=iwp), intent(out) :: Converged
integer(kind=iwp), intent(in) :: nDim, lBuf, NumCho
real(kind=wp), intent(in) :: Thr, ThrNeg, ThrFail, DiaInp(nDim)
real(kind=wp), intent(out) :: Diag(nDim), ErrStat(3)
real(kind=wp), intent(inout) :: Buf(lBuf)
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: i, iBatch, ij, iOpt, iVec1, jVec, kOff, nBatch, NumV, nVec
real(kind=wp) :: xDim

! Set variables.
! --------------

irc = 0
if (nDim < 1) then
  Converged = .true. ! in a sense, at least
  return ! exit (nothing to do)
else
  Converged = .false.
end if

! Set up diagonal.
! ----------------

Diag(:) = DiaInp(:)

if (Restart) then ! subtract previous vectors
  if (NumCho > 0) then

    nVec = min(NumCho,lBuf/nDim)
    if (nVec < 1) then
      irc = 202
      return ! exit (insufficient buffer size)
    else
      nBatch = (NumCho-1)/nVec+1
    end if

    do iBatch=1,nBatch

      if (iBatch == nBatch) then
        NumV = NumCho-nVec*(nBatch-1)
      else
        NumV = nVec
      end if

      iVec1 = nVec*(iBatch-1)+1
      iOpt = 2
      call CD_Vec(iVec1,NumV,Buf,lBuf,nDim,iOpt)

      do jVec=1,NumV
        kOff = nDim*(jVec-1)
        do i=1,nDim
          ij = kOff+i
          Diag(i) = Diag(i)-Buf(ij)*Buf(ij)
        end do
      end do

    end do

  else if (NumCho < 0) then

    irc = 201
    return ! exit (inconsistent input)

  end if
end if

! Zero negative diagonals (fail if too negative),
! get error statistics (min, max, and rms error),
! check convergence based on max diagonal.
! -----------------------------------------------

if (Diag(1) < ThrNeg) then
  if (Diag(1) < ThrFail) then
    irc = 203
    return ! exit (too negative diagonal)
  else
    Diag(1) = Zero
  end if
end if
ErrStat(1) = Diag(1)
ErrStat(2) = Diag(1)
ErrStat(3) = Diag(1)*Diag(1)
do i=2,nDim
  if (Diag(1) < ThrNeg) then
    if (Diag(1) < ThrFail) then
      irc = 203
      return ! exit (too negative diagonal)
    else
      Diag(1) = Zero
    end if
  end if
  ErrStat(1) = min(ErrStat(1),Diag(i))
  ErrStat(2) = max(ErrStat(2),Diag(i))
  ErrStat(3) = ErrStat(3)+Diag(i)*Diag(i)
end do
xDim = real(nDim,kind=wp)
ErrStat(3) = sqrt(ErrStat(3))/xDim

Converged = ErrStat(2) <= Thr

end subroutine CD_Diag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRPGen(nDim,nAtom,Coor,mTR,CofM,TRVec)

use Index_Functions, only: nTri_Elem
use Slapaf_Info, only: Degen, Smmtrc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, nAtom
real(kind=wp), intent(in) :: Coor(3,nAtom)
integer(kind=iwp), intent(out) :: mTR
logical(kind=iwp), intent(in) :: CofM
real(kind=wp), intent(out) :: TRVec(6*3*nAtom)
integer(kind=iwp) :: i, iAtom, ixyz, nTR
real(kind=wp), allocatable :: EVal(:), EVec(:), G(:), Scrt(:), TR(:), U(:)
real(kind=wp), parameter :: Thr_ElRed = 1.0e-12_wp
logical(kind=iwp), parameter :: g12K = .true.

call mma_allocate(TR,6*3*nAtom,Label='TR')

! Compute the symmetric translations and rotations
!
! B    (nTR x nDim)
!  tr

call TRMake(TR,Coor,nAtom,nTR,Degen,nDim,CofM)

TRVec(1:nTR*nDim) = TR(1:nTR*nDim)

call mma_allocate(Scrt,(3*nAtom)*nTR,Label='Scrt')
call mma_allocate(G,nTR**2,Label='G')
call mma_allocate(EVal,nTri_Elem(nTR),Label='EVal')
call mma_allocate(EVec,nTR**2,Label='EVec')

! Eliminate redundancy and produce an orthogonal representation.
!
!    -1/2
! K g        (nTR x mTR)

call mma_allocate(U,nDim,Label='U')
U(:) = One
i = 0
do iAtom=1,nAtom
  do ixyz=1,3
    if (Smmtrc(ixyz,iAtom)) then
      i = i+1
      TRVec((i-1)*nTR+1:i*nTR) = sqrt(Degen(ixyz,iAtom))*TRVec((i-1)*nTR+1:i*nTR)
    end if
  end do
end do

call ElRed(TRVec,nTR,nDim,G,EVal,EVec,mTR,U,Scrt,g12K,Thr_ElRed)

if (mTR > 0) call DGEMM_('T','N',nDim,mTR,nTR,One,TR,nTR,EVec,nTR,Zero,TRVec,nDim)

call mma_deallocate(U)
call mma_deallocate(EVec)
call mma_deallocate(EVal)
call mma_deallocate(G)
call mma_deallocate(Scrt)
call mma_deallocate(TR)

return

end subroutine TRPGen

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,2000, Markus P. Fuelscher                         *
*               1993, Per-Olof Widmark                                 *
************************************************************************
      Subroutine UPKR8(iOpt,nData,nByte,InBuf,OutBuf)
************************************************************************
*                                                                      *
*     purpose: decode pack double precision floating point numbers     *
*                                                                      *
*    Calling parameters:                                               *
*    iOpt  : Bit switch                                                *
*            bits 0-3 used for packing algorithm                       *
*    nData : number of unpacked double precision floating point numbers*
*    nByte : length of pack array in bytes                             *
*    OutBuf: contains on output unpacked numbers                       *
*    InBuf : contains packed integral on input                         *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    PkCtl : Packing table                                             *
*                                                                      *
*    Local data declarations: none                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and P. O. Widmark                                 *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     replacement of packing routines                                  *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 2000                                 *
*                                                                      *
************************************************************************

#include "PkCtl.fh"

      Integer iOpt,nData,nByte
      Real*8  InBuf(*)
      Real*8  OutBuf(*)
      Interface
        Subroutine rld_r8(in_,n_in,out_,n_out,thr)
     &             bind(C,name='rld_r8_')
          Use Definitions, only: MOLCAS_C_INT, MOLCAS_C_REAL
          Real(kind=MOLCAS_C_REAL) :: in_(*), out_(*), thr
          Integer(kind=MOLCAS_C_INT) :: n_in, n_out
        End Subroutine rld_r8
      End Interface
*
*----------------------------------------------------------------------*
*     If data have not been packed copy them from                      *
*     the input buffer to the output buffer                            *
*----------------------------------------------------------------------*
*
      If (.not.Pack) Then
        call dcopy_(nData,InBuf,1,OutBuf,1)
        nByte=8*nData
        Return
      End If
*
*----------------------------------------------------------------------*
*     Unpack the data and transfer the result from                     *
*     the input buffer to the output buffer                            *
*----------------------------------------------------------------------*
*
*     Call upkERI(nData,PkThrs,nByte,InBuf,OutBuf)
      Kase=iAnd(iOpt,15)
      If(Kase.eq.0) Then
         Call tcd_r8_wrapper(InBuf,nComp, OutBuf,nData, PkThrs,
     &                       Init_do_setup_d)
         Init_do_setup_d=0
         nByte=nComp
      Else
         Call rld_r8(InBuf,nComp, OutBuf,nData, PkThrs)
         nByte=8*nComp
      End If

*
*----------------------------------------------------------------------*
*
      Return

      Contains

      Subroutine tcd_r8_wrapper(in_,n_in,out_,n_out,thr,Init_do_setup_e)

      Use, Intrinsic :: iso_c_binding, only: c_loc

      Real*8, Target :: in_(*)
      Integer :: n_in, n_out, Init_do_setup_e
      Real*8 :: out_(*), thr
      Interface
        Subroutine tcd_r8(in_,n_in,out_,n_out,thr,Init_do_setup_d)
     &             bind(C,name='tcd_r8_')
          Use, Intrinsic :: iso_c_binding, only: c_ptr
          Use Definitions, only: MOLCAS_C_INT, MOLCAS_C_REAL
          Type(c_ptr), Value :: in_
          Integer(kind=MOLCAS_C_INT) :: n_in, n_out, Init_do_setup_d
          Real(kind=MOLCAS_C_REAL) :: out_(*), thr
        End Subroutine
      End Interface

      Call tcd_r8(c_loc(in_),n_in,out_,n_out,thr,Init_do_setup_e)

      End Subroutine tcd_r8_wrapper

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Giovanni Li Manni                                      *
!***********************************************************************
! History:                                                             *
!   2018 S Dong - added print outs related to scaling                  *
!***********************************************************************

subroutine print_MCPDFT_2(e_nuc,e_cas,e_ot,state,e_mcscf)

use KSDFT_Info, only: CoefR, CoefX, Funcaa, Funcbb, Funccc
use nq_Info, only: Dens_a1, Dens_a2, Dens_b1, Dens_b2, Dens_I, Tau_a1, Tau_a2, Tau_b1, Tau_b2
use mspdft, only: mspdftmethod
use PrintLevel, only: USUAL
use mcpdft_output, only: iPrGlb
use mcpdft_input, only: mcpdft_options
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: e_nuc, e_cas, e_ot, e_mcscf
integer(kind=iwp), intent(in) :: state
real(kind=wp) :: CASDFT_E_1, E_ot_1, e_pdft, e_state, Funcaa1, Funcbb1, Funccc1
character(len=120) :: Line
character(len=6) :: Fmt2

e_state = e_cas+e_ot
e_pdft = e_state
if (mcpdft_options%otfnal%is_hybrid()) e_state = mcpdft_options%otfnal%lambda*e_mcscf+(One-mcpdft_options%otfnal%lambda)*e_state

if (iPrGlb >= USUAL) then
  write(Fmt2,'(A,I3.3,A)') '(6X,'
  Line = ''
  if (mcpdft_options%mspdft) then
    write(Line(4:),'(2A,1X,I4.4)') MSpdftMethod,' INTERMEDIATE STATE',state
  else
    write(Line(4:),'(A,1X,I4.4)') 'MC-PDFT RESULTS, STATE',state
  end if
  write(u6,*)
  call CollapseOutput(1,Line)
  write(u6,Fmt2//'A)') repeat('-',len_trim(Line)-3)
  write(u6,*)

  write(u6,'(6X,A,40X,F18.8)') 'MCSCF reference energy',e_mcscf
  write(u6,*)
  write(u6,'(6X,A,45X,F10.3)') 'Integrated total density:',Dens_I
  write(u6,'(6X,A,12X,F10.3)') 'Integrated alpha density before functional transformation:',Dens_a1
  write(u6,'(6X,A,12X,F10.3)') 'Integrated  beta density before functional transformation:',Dens_b1
  write(u6,'(6X,A,12X,F10.3)') 'Integrated alpha density  after functional transformation:',Dens_a2
  write(u6,'(6X,A,12X,F10.3)') 'Integrated  beta density  after functional transformation:',Dens_b2
  write(u6,'(6X,A,4X,F18.3)') 'Integrated alpha tau     before functional transformation:',Tau_a1
  write(u6,'(6X,A,4X,F18.3)') 'Integrated  beta tau     before functional transformation:',Tau_b1
  write(u6,'(6X,A,4X,F18.3)') 'Integrated alpha tau      after functional transformation:',Tau_a2
  write(u6,'(6X,A,4X,F18.3)') 'Integrated  beta tau      after functional transformation:',Tau_b2
  write(u6,'(6X,A)') 'NOTE:'
  write(u6,'(6X,2A)') 'Densities after transformation are ','intermediate quantities'
  write(u6,'(6X,2A)') 'and should not be interpreted as ','real spin densities'
  write(u6,*)
  write(u6,'(6X,A,32X,F18.6)') 'Exchange energy scaling factor',CoefX
  write(u6,'(6X,A,29X,F18.6)') 'Correlation energy scaling factor',CoefR
  write(u6,*)
  write(u6,'(6X,A,30X,F18.6)') 'Integrated alpha exchange energy',Funcaa
  write(u6,'(6X,A,30X,F18.6)') 'Integrated beta  exchange energy',Funcbb
  write(u6,'(6X,A,30X,F18.6)') 'Integrated  correlation   energy',Funccc
  write(u6,*)

  write(u6,'(6X,A,38X,F18.8)') 'Nuclear Repulsion energy',E_nuc
  write(u6,'(6X,A,36X,F18.8)') 'CASSCF contribution energy',E_cas
  write(u6,'(6X,A,49X,F18.8)') 'On-top energy',E_ot
  write(u6,*)
  if (mcpdft_options%otfnal%is_hybrid()) then
    write(u6,'(6X,A)') 'Information for hybrid PDFT:'
    write(u6,'(6X,A,37X,F6.2)') 'Wave function percentage (Lambda*100)',mcpdft_options%otfnal%lambda*1.0e2_wp
    write(u6,'(6X,A,42X,F18.8)') 'Wave function energy',mcpdft_options%otfnal%lambda*e_mcscf
    write(u6,'(6X,A,51X,F18.8)') 'PDFT energy',(One-mcpdft_options%otfnal%lambda)*e_pdft
    write(u6,*)
  end if

  if ((CoefX*CoefR /= Zero) .and. (CoefX /= One .or. CoefR /= One)) then
    Funcaa1 = Funcaa/CoefX
    Funcbb1 = Funcbb/CoefX
    Funccc1 = Funccc/CoefR
    E_ot_1 = E_ot-Funcaa-Funcbb-Funccc+Funcaa1+Funcbb1+Funccc1
    CASDFT_E_1 = e_state-E_ot+E_ot_1
    write(u6,*)
    write(u6,*)
    write(u6,'(6X,A,19X,F18.6)') 'Integrated alpha exchange energy (unscaled)',Funcaa1
    write(u6,'(6X,A,19X,F18.6)') 'Integrated beta  exchange energy (unscaled)',Funcbb1
    write(u6,'(6X,A,19X,F18.6)') 'Integrated  correlation   energy (unscaled)',Funccc1
    write(u6,'(6X,A,38X,F18.8)') 'On-top energy (unscaled)',E_ot_1
    write(u6,'(6X,A,31X,F18.8)') 'Total MC-PDFT energy (unscaled)',CASDFT_E_1
  end if

  write(u6,'(6X,A,I3,29X,F18.8)') 'Total MCPDFT energy for state ',state,e_state

  call CollapseOutput(0,Line)
  write(u6,*)
end if

call Add_Info('dens_tt',[Dens_I],1,6)
call Add_Info('dens_a1',[Dens_a1],1,6)
call Add_Info('dens_b1',[Dens_b1],1,6)
call Add_Info('dens_a2',[Dens_a2],1,6)
call Add_Info('dens_b2',[Dens_b2],1,6)
call Add_Info('exch_f',[CoefX],1,6)
call Add_Info('corr_f',[CoefR],1,6)
call Add_Info('excha_a',[Funcaa],1,6)
call Add_Info('excha_b',[Funcbb],1,6)
call Add_Info('corr_e',[Funccc],1,6)
call Add_Info('CASDFTE',[e_state],1,8)

end subroutine print_MCPDFT_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Ignacio Fdez. Galvan                             *
************************************************************************
*  Name_to_lm
*
*> @brief
*>   Get \f$ l \f$ and \f$ m \f$ numbers from a basis function name.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Given a basis function name as a character string, extract the \f$ l
*> \f$ and \f$ m \f$ quantum numbers.
*>
*> Spherical harmonics functions are expected with the format `nnLmms`,
*> where `nn` is the shell number, `L` is a letter denoting angular
*> momentum, `mm` is the absolute value of the \f$ m \f$ number, and `s`
*> is the sign of \f$ m \f$.
*>
*> Cartesian functions are expected with the format `Lxxyyzz`, where `L`
*> is a letter denoting angular momentum, and `xx`, `yy`, `zz` are the
*> powers of \f$ x \f$, \f$ y \f$ and \f$ z \f$ (\f$ m_x,m_y,m_z \f$).
*> in this case, the numbers returned are \f$ -l \f$ and
*> \f$ ((m_y+m_z)^2+m_z-m_y)/2-m_x \f$.
*>
*> @param[in]  BName Basis function name
*> @param[out] l     \f$ l \f$ number (\f$ -l \f$ for Cartesians)
*> @param[out] m     \f$ m \f$ number (see details for Cartesians)
************************************************************************
      Subroutine Name_to_lm(BName,l,m)
      Implicit None
      Character(Len=*), Intent(In) :: BName
      Integer, Intent(Out) :: l, m
      Character :: Letter
      Integer :: i, lx, ly, lz
#include "angtp.fh"
*
      Letter = BName(3:3)
      Call LoCase(Letter)
      l = 0
      m = 0
      If (Letter .eq. 's') Then
*     Default is s
        Return
      Else if (Letter .eq. 'p') Then
*       p usually appear as px, py, pz, except when they are contaminants
        l = 1
        If (BName(4:4) .ne. '0') Then
          Letter = BName(4:4)
          Call LoCase(Letter)
          If (Letter .eq. 'x') Then
            m = 1
          Else If (Letter .eq. 'y') Then
            m = -1
          Else If (Letter .eq. 'z') Then
            m = 0
          End If
          Return
        End If
      End If
*     Parse the label for other cases
      l = -1
*     Find if there is an angular label
      Do i=Sum(LBound(AngTp)),Sum(UBound(AngTp))
        If (Letter .eq. AngTp(i)) Then
          l = i
          Exit
        End If
      End Do
      If (l .ge. 0) Then
*       If a label is found it is a spherical shell, just read m
        Read(BName(4:5),*) m
        If (BName(6:6) .eq. '-') m = -m
      Else
*       If no label, this is a Cartesian shell, return -l and some convention for m.
*       We use m=T(ly+lz)-(lx+ly), where T(n) is the nth triangular number: n*(n+1)/2).
*       From here, ly+lz can be recovered as the (int) triangular root of m+l: (sqrt(8*(m+l)+1)-1)/2,
*       lz is m+l-T(ly+lz) and lx is l-(ly+lz). This has the property that all
*       possible combinations of lx,ly,lz are encoded in -l plus a number from -l to l*(l+1)/2,
*       in descending order with priority lx>ly>lz: (3,0,0), (2,1,0), (2,0,1), (1,2,0),
*       (1,1,1), (1,0,2), (0,3,0), (0,2,1), (0,1,2), (0,0,3)
        Read(BName(2:3),*) lx
        Read(BName(4:5),*) ly
        Read(BName(6:7),*) lz
        l = -lx-ly-lz
        m = (ly+lz)*(ly+lz+1)/2-(lx+ly)
      End If
      Return
*
      End Subroutine Name_to_lm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Print_Isotopes()

use Basis_Info, only: dbsc, nCnttp
use Constants, only: UtoAU
use Definitions, only: wp, iwp, u6

implicit none
#include "print.fh"
integer(kind=iwp) :: i, iAtom, iPrint, iRout
real(kind=wp) :: act_Mass, def_Mass
logical(kind=iwp) :: Changed
real(kind=wp), external :: rMass

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 2
iPrint = nPrint(iRout)
if (iPrint == 0) return
!                                                                      *
!***********************************************************************
!                                                                      *
! Determine whether any mass is different from default

Changed = .false.
do i=1,nCnttp
  if (dbsc(i)%Aux .or. dbsc(i)%Frag) cycle
  iAtom = dbsc(i)%AtmNr
  if (dbsc(i)%CntMass /= rMass(iAtom)) then
    Changed = .true.
    exit
  end if
end do
if ((.not. Changed) .and. (iPrint <= 5)) return
!                                                                      *
!***********************************************************************
!                                                                      *
write(u6,*)
call CollapseOutput(1,'   Isotope specification:')
write(u6,'(3X,A)') '   ----------------------'
write(u6,*)
if (Changed) then
  write(u6,10) 'Center                     [     Default     ]'
  write(u6,10) 'Type   Z    A    mass (Da) [   A    mass (Da)]'
  write(u6,10) '---------------------------------------------'
else
  write(u6,10) 'Center'
  write(u6,10) 'Type   Z    A    mass (Da)'
  write(u6,10) '--------------------------'
end if
do i=1,nCnttp
  if (dbsc(i)%Aux .or. dbsc(i)%Frag) cycle
  iAtom = dbsc(i)%AtmNr
  act_Mass = dbsc(i)%CntMass/UToAU
  def_Mass = rmass(iAtom)/UToAU
  if (act_Mass /= def_Mass) then
    write(u6,101) i,iAtom,nint(act_Mass),act_Mass,nint(def_Mass),def_Mass
  else
    write(u6,100) i,iAtom,nint(act_Mass),act_Mass
  end if
end do
call CollapseOutput(0,'   Isotope specification:')
write(u6,*)
!                                                                      *
!***********************************************************************
!                                                                      *

return

10 format(1X,A)
100 format(I5,1X,I3,1X,I4,1X,F12.6)
101 format(I5,1X,I3,1X,I4,1X,F12.6,1X,'[',I4,1X,F12.6,']')

end subroutine Print_Isotopes

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  RdVec_HDF5
!
!> @brief
!>   Read orbital data from an HDF5 file
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Similar to ::RdVec, but for HDF5 files. The \p Label argument can
!>  contain a `B` if one wants the data for beta orbitals.
!>
!> @param[in]  fileid   Identifier of the open HDF5 file
!> @param[in]  Label    Properties to read from the file
!> @param[in]  nSym     Number of irreps
!> @param[in]  nBas     Number of basis functions per irrep
!> @param[out] CMO      Orbital coefficients
!> @param[out] Occ      Orbital occupations
!> @param[out] Ene      Orbital energies
!> @param[out] Ind      Orbital type indices
!***********************************************************************

subroutine RdVec_HDF5(fileid,Label,nSym,nBas,CMO,Occ,Ene,Ind)

use Definitions, only: wp, iwp
#ifdef _HDF5_
use mh5, only: mh5_exists_dset, mh5_fetch_dset
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: fileid, nSym, nBas(nSym)
character(len=*), intent(in) :: Label
real(kind=wp), intent(_OUT_) :: CMO(*), Occ(*), Ene(*)
integer(kind=iwp), intent(_OUT_) :: Ind(*)
#ifdef _HDF5_
integer(kind=iwp) :: Beta, nB
character(len=128) :: DataSet, su, sl
character(len=1), allocatable :: typestring(:)

Beta = 0
su = ''
sl = ''
if (index(Label,'A') > 0) then
  Beta = -1
  su = 'ALPHA_'
  sl = 'alpha '
end if
if (index(Label,'B') > 0) then
  if (Beta /= 0) then
    write(u6,*)
    call AbEnd()
  end if
  Beta = 1
  su = 'BETA_'
  sl = 'beta '
end if

if (index(Label,'E') > 0) then
  DataSet = 'MO_'//trim(su)//'ENERGIES'
  if (mh5_exists_dset(fileid,DataSet)) then
    call mh5_fetch_dset(fileid,DataSet,Ene)
  else
    write(u6,*) 'The HDF5 file does not contain '//trim(sl)//'MO energies.'
    call AbEnd()
  end if
end if

if (index(Label,'O') > 0) then
  DataSet = 'MO_'//trim(su)//'OCCUPATIONS'
  if (mh5_exists_dset(fileid,DataSet)) then
    call mh5_fetch_dset(fileid,DataSet,Occ)
  else
    write(u6,*) 'The HDF5 file does not contain '//trim(sl)//'MO occupations.'
    call AbEnd()
  end if
end if

if (index(Label,'C') > 0) then
  DataSet = 'MO_'//trim(su)//'VECTORS'
  if (mh5_exists_dset(fileid,DataSet)) then
    call mh5_fetch_dset(fileid,DataSet,CMO)
  else
    write(u6,*) 'The HDF5 file does not contain '//trim(sl)//'MO coefficients.'
    call AbEnd()
  end if
end if

if (index(Label,'I') > 0) then
  nB = sum(nBas)
  call mma_allocate(typestring,nB)
  DataSet = 'MO_'//trim(su)//'TYPEINDICES'
  if (mh5_exists_dset(fileid,DataSet)) then
    call mh5_fetch_dset(fileid,DataSet,typestring)
    call tpstr2tpidx(typestring,Ind,nB)
  end if
  call mma_deallocate(typestring)
end if

#else

#include "macros.fh"
unused_var(fileid)
unused_var(Label)
unused_var(nSym)
unused_var(nBas)
unused_var(CMO(1))
unused_var(Occ(1))
unused_var(Ene(1))
unused_var(Ind(1))
call WarningMessage(2,'Calling RdVec_HDF5, but HDF5 is disabled')
call AbEnd()

return
#endif

end subroutine RdVec_HDF5

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine hrecur(pn,dpn,pn1,x,nn)

use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: pn, dpn, pn1
real(kind=wp), intent(in) :: x
integer(kind=iwp), intent(in) :: nn
integer(kind=iwp) :: j
real(kind=wp) :: dp, dp1, dq, fj, fj2, p, p1, q

p1 = One
p = x
dp1 = Zero
dp = One
do j=2,nn
  fj = (j)
  fj2 = Half*(fj-One)
  q = x*p-fj2*p1
  dq = x*dp+p-fj2*dp1
  p1 = p
  p = q
  dp1 = dp
  dp = dq
end do
pn = p
dpn = dp
pn1 = p1

return

end subroutine hrecur

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_OCOF(nPrim,nBas,Work,nVec_p,OCOF)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nPrim, nBas, nVec_p
real(kind=wp), intent(in) :: Work(nVec_p)
real(kind=wp), intent(out) :: oCof(nBas,nPrim)
integer(kind=iwp) :: i, iStdOut, iVec_p, j

iStdOut = u6 ! Added by EB
iVec_p = 0
do i=1,nBas
  do j=1,nPrim
    OCOF(i,j) = Work((i-1)*nPrim+j)
    iVec_p = iVec_p+1
    if (iVec_p > nVec_p) then
      write(iStdOut,*) 'iVec_p > nVec_p'
      write(iStdOut,*) iVec_p,' > ',nVec_p
      write(iStdOut,*) 'nPrim=',nPrim
      call Abend()
    end if
  end do
end do

return

end subroutine Get_OCOF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995,1999, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE IAIBCM(ICISPC,IAIB)
*
* obtain allowed combinbation of alpha- and beta- supergroups
* for CI space ICISPC
*
* Master for IAIBCM_GAS
*
*      Jeppe Olsen, august 1995
*                   I_RE_MS2 added, May 99
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "cprnt.fh"
#include "stinf.fh"
#include "strinp.fh"
#include "crun.fh"
*. Output
      INTEGER IAIB(*)
*
      IATP = 1
      IBTP = 2
*
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
*
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
*
C?    write(6,*) ' IAIB ::::::'
C?    write(6,*) ' LCMBSPC, ICISPC, ICMBSPC '
C?    WRITE(6,*) ICISPC,  LCMBSPC(ICISPC)
C?    WRITE(6,*) (ICMBSPC(II,ICISPC),II=1, LCMBSPC(ICISPC))

      CALL IAIBCM_GAS(LCMBSPC(ICISPC),
     &                ICMBSPC(1,ICISPC),
     &                  IGSOCCX,
     &                   NOCTPA,
     &                   NOCTPB,
*
     &                ISPGPFTP(1,IOCTPA),
     &                ISPGPFTP(1,IOCTPB),NELFGP,MXPNGAS, NGAS, IAIB,
     &                   IPRDIA,I_RE_MS2_SPACE,I_RE_MS2_VALUE)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_PrtMaxMem(Location)
!
! Purpose: print max. available memory block.

use Cholesky, only: LuPri
use stdalloc, only: mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: Location
integer(kind=iwp) :: l, lMax
real(kind=wp) :: dlMax
character(len=2) :: Unt

l = len(Location)
if (l < 1) then
  write(Lupri,'(/,A)') 'Largest memory block available @<UNKNOWN>:'
else
  write(Lupri,'(/,A,A,A)') 'Largest memory block available @',Location(1:l),':'
end if
call mma_maxDBLE(lMax)
call Cho_Word2Byte(lMax,8,dlMax,Unt)
write(Lupri,'(3X,I10,A,F10.3,A,A)') lMax,' 8-byte words; ',dlMax,' ',Unt

end subroutine Cho_PrtMaxMem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      Subroutine DesymP(iAng, iCmp, jCmp, kCmp, lCmp, Shijij, iShll,
     &                  iShell, iAO, kOp, ijkl,Aux,nAux,PAO,PSO,nPSO)
************************************************************************
*                                                                      *
*  Object: to transform the integrals in AO basis to symmetry adapted  *
*          orbitals , SO. This is done by accumulating the AO inte-    *
*          grals onto the SO integrals.                                *
*          Observe that one of the operator is the Unit operation      *
*          performed on center A. However, since we scramble the order *
*          we do not really know which center is which. However, the   *
*          Unit operator will always give a factor of one. Hence, this *
*          is a convenient way to do the symmetry transformation with- *
*          out having to know the order.                               *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified to desymmetrization of the second order density *
*             matrix, January '92.                                     *
************************************************************************
      use Basis_Info
      use Symmetry_Info, only: iChBas, iChTbl, iOper, nIrrep, Prmt
      use SOAO_Info, only: iAOtSO
      use Real_Spherical, only: iSphCr
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 PAO(ijkl,iCmp,jCmp,kCmp,lCmp), PSO(ijkl,nPSO), Aux(nAux)
      Logical Shij, Shkl, Shijij
      Integer iAng(4), iShell(4), kOp(4), iShll(4), iAO(4)
*     Local Array
      Integer iSym(0:7), jSym(0:7), kSym(0:7), lSym(0:7)
*
#ifdef _DEBUGPRINT_
      iRout = 38
      iPrint = nPrint(iRout)
#endif
      Shij = iShell(1).eq.iShell(2)
      Shkl = iShell(3).eq.iShell(4)
      MemSO2 = 1
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' In DesymP: PSO ',' ',PSO,ijkl,nPSO)
         Call WrCheck(' In DesymP: PSO ',PSO,ijkl*nPSO)
         Write (6,*) 'iCmp,jCmp,kCmp,lCmp,nPSO=',
     &                iCmp,jCmp,kCmp,lCmp,nPSO
         Write (6,*) Shij, Shkl, Shijij
         Write (6,*) 'kOp=',kOp
      End If
#endif
      Fact=Eight
      If (Shij)   Fact=Fact*Half
      If (Shkl)   Fact=Fact*Half
      If (Shijij) Fact=Fact*Half
*
*-----Initialize second order density matrix in AO basis
*
      call dcopy_(ijkl*iCmp*jCmp*kCmp*lCmp,[Zero],0,PAO,1)
*
*
*     Quadruple loop over elements of the basis functions angular
*     description. Loops are reduced to just produce unique SO integrals
*     Observe that we will walk through the memory in PAO in a
*     sequential way.
*
      ii = iAng(1)*(iAng(1)+1)*(iAng(1)+2)/6
      jj = iAng(2)*(iAng(2)+1)*(iAng(2)+2)/6
      kk = iAng(3)*(iAng(3)+1)*(iAng(3)+2)/6
      ll = iAng(4)*(iAng(4)+1)*(iAng(4)+2)/6
      Do 100 i1 = 1, iCmp
         iChBs = iChBas(ii+i1)
         If (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+i1))
         pa = Prmt(iOper(kOp(1)),iChBs)
         niSym=0
         Do 101 j = 0, nIrrep-1
            If (iAOtSO(iAO(1)+i1,j)>0) Then
               iSym(niSym)=j
               niSym=niSym+1
            End If
101      Continue
         Do 200 i2 = 1, jCmp
            jChBs = iChBas(jj+i2)
            If (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+i2))
            pb = Prmt(iOper(kOp(2)),jChBs)
            njSym=0
            Do 201 j = 0, nIrrep-1
               If (iAOtSO(iAO(2)+i2,j)>0) Then
                  jSym(njSym) = j
                  njSym=njSym+1
               End If
201         Continue
            Do 300 i3 = 1, kCmp
               kChBs = iChBas(kk+i3)
               If (Shells(iShll(3))%Transf)
     &            kChBs = iChBas(iSphCr(kk+i3))
               pc = Prmt(iOper(kOp(3)),kChBs)
               nkSym=0
               Do 301 j = 0, nIrrep-1
                  If (iAOtSO(iAO(3)+i3,j)>0) Then
                     kSym(nkSym) = j
                     nkSym=nkSym+1
                   End If
301            Continue
               Do 400 i4 = 1, lCmp
                  lChBs = iChBas(ll+i4)
                  If (Shells(iShll(4))%Transf)
     &               lChBs = iChBas(iSphCr(ll+i4))
*-----------------Parity factor due to symmetry operations applied to the
*                 angular part of the basis functions.
                  FactNs = pa*pb*pc * Prmt(iOper(kOp(4)),lChBs)
                  nlSym=0
                  Do 401 j = 0, nIrrep-1
                     If (iAOtSO(iAO(4)+i4,j)>0) Then
                        lSym(nlSym)=j
                        nlSym=nlSym+1
                     End If
401               Continue
*
*------Loop over irreps which are spanned by the basis functions.
*      Again, the loop structure is restricted to ensure unique
*      integrals.
*
*
      If (nIrrep.eq.1) Then
*--------FactNs=1
         Call DYaX(ijkl,Fact,PSO(1,MemSO2),1,PAO(1,i1,i2,i3,i4),1)
         MemSO2 = MemSO2 + 1
         Go To 400
      End If
*
      iAux = 0
      Do 110 is = 0, niSym-1
         j1=iSym(is)
         Xa = DBLE(iChTbl(j1,kOp(1))) * FactNs
         Do 210 js = 0, njSym-1
            j2=jSym(js)
            Xb = DBLE(iChTbl(j2,kOp(2))) * Xa
            j12 = iEor(j1,j2)
            Do 310 ks = 0, nkSym-1
               j3=kSym(ks)
               Xg = DBLE(iChTbl(j3,kOp(3))) * Xb
               j123=iEor(j12,j3)
               Do 320 ls = 0, nlSym-1
                  j4=lSym(ls)
                  If (j123.ne.j4) Go To 320
*
                  iAux = iAux + 1
                  Aux(iAux) = DBLE(iChTbl(j4,kOp(4))) * Xg *
     &                        Fact
                  Go To 310
*
 320           Continue
 310        Continue
 210     Continue
 110  Continue
*
      If (iAux.ne.0) Then
#ifdef _DEBUGPRINT_
         If (iPrint.ge.99) Call RecPrt(' Aux',' ',Aux,iAux,1)
#endif
         If (iAux.ne.1) Then
            Call DNaXpY(iAux,ijkl,Aux,1,PSO(1,MemSO2),1,ijkl,
     &                  PAO(1,i1,i2,i3,i4),1,0)
         Else
            Call DaXpY_(ijkl,Aux(1),PSO(1,MemSO2),1,
     &                 PAO(1,i1,i2,i3,i4),1)
         End If
         MemSO2 = MemSO2 + iAux
      End If
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' On exit from DesymP: PAO ',' ', PAO,
     &            ijkl,iCmp*jCmp*kCmp*lCmp)
         Do 3333 i = 1, ijkl
            Write (6,*) DDot_(iCmp*jCmp*kCmp*lCmp,
     &                  PAO(i,1,1,1,1),ijkl,
     &                  PAO(i,1,1,1,1),ijkl)
 3333    Continue
        Call WrCheck('DesymP: PAO ',PAO,ijkl*iCmp*jCmp*kCmp*lCmp)
        write (6,*) ddot_(ijkl*iCmp*jCmp*kCmp*lCmp,PAO,1,[One],0)
        write (6,*) ddot_(ijkl*iCmp*jCmp*kCmp*lCmp,PAO,1,PAO,1)
      End If
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RdJobIph
************************************************************************
*                                                                      *
*     Read the contents of the JOBIPH file.                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Files_mclr.fh"
#include "glbbas_mclr.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "sa.fh"
#include "dmrginfo_mclr.fh"
      Character*72 Line
      Character*8 Method
      real*8 dv_ci2  ! yma added
      Logical Found
      Dimension rdum(1)
*                                                                      *
************************************************************************
*                                                                      *
*     itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
      debug=.FALSE.
#ifdef _DEBUGPRINT_
      debug=.TRUE.
#endif

*                                                                      *
************************************************************************
*                                                                      *
*     Save the ROOT input parameter                                    *
*----------------------------------------------------------------------*
      kRoots=lRoots
*----------------------------------------------------------------------*
*     Read the table of disk adresses                                  *
*----------------------------------------------------------------------*
      Call DaName(LuJob,FnJob)
      iDisk=0
      Call iDaFile(LuJob,2,iToc,iTOCIPH,iDisk)
*----------------------------------------------------------------------*
*     Read the the system description                                  *
*----------------------------------------------------------------------*
      ndum=lenin8*mxorb
      Call Getmem('TMP','ALLO','CHAR',ipdum,ndum)
      iDisk=iToc(1)

!      write(*,*)"if dmrg, it should be something else "
      Call WR_RASSCF_Info(LuJob,2,iDisk,
     &                    nActEl,iSpin,nSym,State_sym,nFro,
     &                    nIsh,nAsh,nDel,
     &                    nBas,MxSym,cwork(ipdum),LENIN8*mxorb,
     &                    nConf,HeaderJP,144,
     &                    TitleJP,4*18*mxTit,PotNuc0,lRoots,
     &                    nRoots,iRoot,mxRoot,
     &                    nRs1,nRs2,nRs3,
     &                    nHole1,nElec3,iPt2,Weight)

      if(doDMRG)then ! yma
        call dmrg_spc_change_mclr(LRras2(1:8),nash)
        call dmrg_spc_change_mclr(LRras2(1:8),nrs2)
      end if
!      do i=1,8
!        write(*,*)i,"-irrep",nIsh(i),nAsh(i),nRs1(i),nRs2(i),nRs3(i)
!        call xflush(6)
!      end do

      Call Getmem('TMP','FREE','CHAR',ipdum,ndum)
*----------------------------------------------------------------------*
*     Overwrite the variable lroots if approriate, i.e if lroot        *
*     was set by input.                                                *
*----------------------------------------------------------------------*
      If ( kRoots.ne.-1 ) then
         If ( iPt2.ne.0 ) then
            Write (6,*) 'RdJobiph: kRoots.ne.-1 .and. iPt2.ne.0'
            Call Abend()
         Else if ( kRoots.gt.lRoots ) then
            Write (6,*) 'RdJobiph: kRoots.ne.-1 .and. kRoots.gt.lRoots'
            Call Abend()
         End If
         lRoots=kRoots
         nRoots=1
      End If
*----------------------------------------------------------------------*
*     Precompute the total sum of variables and size of matrices       *
*----------------------------------------------------------------------*
      ntIsh=0
      ntItri=0
      ntIsqr=0
      ntAsh=0
      ntAtri=0
      ntAsqr=0
      ntBas=0
      ntBtri=0
      ntBsqr=0
      nna=0
      Length=0
      Do 10 iSym=1,nSym
         norb(isym)=nbas(isym)-ndel(isym)
         ntIsh=ntIsh+nIsh(iSym)
         ntItri=ntItri+nIsh(iSym)*(nIsh(iSym)+1)/2
         ntIsqr=ntIsqr+nIsh(iSym)*nIsh(iSym)
         ntAsh=ntAsh+nAsh(iSym)
         ntAtri=ntAtri+nAsh(iSym)*(nAsh(iSym)+1)/2
         ntAsqr=ntAsqr+nAsh(iSym)*nAsh(iSym)
         ntBas=ntBas+nBas(iSym)
         ntBtri=ntBtri+nBas(iSym)*(nBas(iSym)+1)/2
         ntBsqr=ntBsqr+nBas(iSym)*nBas(iSym)
         nA(iSym)=nna
         nnA=nnA+nAsh(isym)
         Length=Length+nbas(isym)*norb(isym)
10    Continue


!>  Generate the nr. of csf in each sub-sym, used in geom-opt with SA DMRG-SCF
      if(doDMRG)then  ! yma
        Call GugaCtl_dmrg()   ! generate the Nr. of csfs in each sym
!        do isym=1,8
!          write(*,*)"isym_ncsf in rdjobiph ",ncsf(isym)
!        end do
      end if

*
*----------------------------------------------------------------------*
*     Load the orbitals used in the last macro iteration               *
*----------------------------------------------------------------------*
*
      Call GetMem('CMO','Allo','Real',ipCMO,Length)
      Call Get_CMO(Work(ipCMO),Length)
C
C     Read state for geo opt
C
      Call Get_iScalar('Relax CASSCF root',irlxroot)
      Call Get_cArray('Relax Method',Method,8)
      iMCPD=.False.
      if(Method.eq.'MCPDFT  ') then
        iMCPD=.True.
        Do i=1,lroots
          if(iroot(i).eq.irlxroot)istate=i
        end do
      end if
      If (Method.eq.'CASSCFSA') Then
         Call Get_iScalar('SA ready',iGo)
         If (iGO.eq.-1) Then
            Write (6,*) 'MCLR not implemented for SA-CASSCF'//
     &                  ' with non-equivalent weights!'
            Call Abend()
         Else
            If (iGo.ne.2) SA=.true.
            Found=.true.
            If (override) Then
               If (isNAC) Then
                  Do j=1,2
                    NSSA(j)=0
                    Do i=1,lroots
                       If (iroot(i).eq.NACStates(j)) NSSA(j)=i
                    End Do
                    If (NSSA(j).eq.0) Found=.false.
                  End Do
               Else
                  irlxroot=iroot(istate)
               End If
            Else
               istate=0
               Do i=1,lroots
                  If (iroot(i).eq.irlxroot) istate=i
               End Do
               If (istate.eq.0) Found=.false.
            End If
            If (.not.Found) Then
               Call WarningMessage(2,
     &              'Cannot relax a root not included in the SA')
            End If
         End If
      Else If (irlxroot.eq.1.and..Not.(McKinley.or.PT2.or.iMCPD)) Then
         Write (6,*)
         Write (6,*) 'W A R N I N G !'
         Write (6,*)
         Write (6,*) 'Redundant rlxroot input in RASSCF!'
         Write (6,*) 'I''ll sign off here without a clean termination!'
         Write (6,*) 'However, I have to fix the epilogue file.'
         Write (6,*)
         irc=-1
         iopt=1
         Call OPNMCK(irc,iopt,FNMCK,LUMCK)
         Call WrMck(iRC,iOpt,'nSym',1,nBas,iDummer)
         Call ClsFls_MCLR()
         Call Finish(0)
      End if
C
*     iDisk=iToc(9)
*     IF(IPT2.EQ.0) iDisk=iToc(2)
*     Call dDaFile(LuJob,2,Work(ipCMO),ntBsqr,iDisk)
      If( .false. ) then
         jpCMO=ipCMO
         Do 15 iSym=1,nSym
            call dcopy_(nbas(isym)*ndel(isym),[0d0],0,
     *                 Work(jpCMO+norb(isym)*nbas(isym)),1)
            Write(Line,'(A,i2.2)') 'MO coefficients, iSym = ',iSym
            Call RecPrt(Line,' ',Work(jpCMO),nBas(iSym),nBas(iSym))
            jpCMO=jpCMO+nBas(iSym)*nBas(iSym)
15       Continue
      End If
*----------------------------------------------------------------------*
*     Load the CI vectors for the SA roots                             *
*----------------------------------------------------------------------*

! If doDMRG, introducing CI coeffieients later :
!    1) only coefficients of importants DETs using MPS2CI
!    2) and together with DET numbers from GUGA generation part

      if(doDMRG)then  ! yma
        !ipCI=1
        ! need to be deleted the 1000 yma
        Call GetMem('OCIvec','Allo','Real',ipCI,nConf*nroots+1000)
      ! So, nothing need to be done here ...
      else
        Call GetMem('OCIvec','Allo','Real',ipCI,nConf*nroots)
        Do i=1,nroots
          j=iroot(i)
          iDisk=iToc(4)
          Do k=1,j-1
            Call dDaFile(LuJob,0,rdum,nConf,iDisk)
          End Do
          Call dDaFile(LuJob,2,Work(ipCI+(i-1)*nconf),nConf,iDisk)
        End Do
!#ifdef _DEBUGPRINT_           ! yma umcomment
        Do i=0,nroots-1            !yma
          inum=0
          dv_ci2=0.0d0
          do j=1,nconf
!yma        CI-threshold
            if(abs(Work(ipCI+nconf*i+j-1)).lt.0.0d0)then
              inum=inum+1
              Work(ipCI+nconf*i+j-1)=0.0d0
            else
              dv_ci2=dv_ci2+Work(ipCI+nconf*i+j-1)**2
            end if
          end do
!          Call DVcPrt('CI coefficients',' ',Work(ipCI+nconf*i),nConf)!yma
!          write(*,*)"dismissed dets num", inum
!          write(*,*)"absolutely CI^2",dv_ci2
        End DO
      End If

!#endif
*----------------------------------------------------------------------*
*     Load state energy                                                *
*----------------------------------------------------------------------*
      Call GetMem('Temp2','Allo','Real',ipTmp2,mxRoot*mxIter)
      iDisk=iToc(6)
#ifdef _DEBUGPRINT_
      If (debug) Then
         Write(6,*) 'NROOTS: ',nroots
         Write(6,*) 'iROOTS: ',(iroot(i),i=1,nroots)
         Write(6,*) 'lROOTS: ',lroots
      End If
#endif
      Call dDaFile(LuJob,2,Work(ipTmp2),mxRoot*mxIter,iDisk)

      Do  iter=0,mxIter-1
        Do i=1,nroots
          j=iroot(i)
          ! It should be 0.0d0 in DMRG case
          Temp=Work(ipTmp2+iter*mxRoot+j-1)
          If ( Temp.ne.0.0D0 ) ERASSCF(i)=Temp
*          If (debug) Write(*,*) ERASSCF(i),i
         End Do
      End Do

#ifdef _DEBUGPRINT_
      If (debug) Then
          Write(6,*) (Work(ipTmp2+i),i=0,lroots)
          Write(6,*)'RASSCF energies=',(ERASSCF(i),i=1,nroots)
      End If
#endif
      Call GetMem('Temp2','Free','Real',ipTmp2,mxRoot*100)
*
      nAct  = 0    ! 1/2

      if(doDMRG)then  ! yma
        call dmrg_dim_change_mclr(RGras2(1:8),ntash,0)
        call dmrg_spc_change_mclr(RGras2(1:8),nash)
        call dmrg_spc_change_mclr(RGras2(1:8),nrs2)
      end if

      nAct2 = 0
      nAct4 = 0
      Do iSym = 1, nSym
         nAct = nAct + nAsh(iSym)
        nAct2=nAct2+nAsh(iSym)**2
      End Do
      Do iS = 1, nSym
         Do jS = 1, nSym
            Do kS = 1, nSym
              lS=iEOr(iEOr(is-1,js-1),ks-1)+1
              nAct4=nAct4+nAsh(iS)*nAsh(jS)*nAsh(kS)*nAsh(lS)
            End Do
         End Do
      End Do
*     Call GetMem(' G1sq','Allo','Real',ipG1,nAct2)

      nG1 = nAct*(nAct+1)/2
      Call GetMem(' G1 ','Allo','Real',ipG1t,nG1)
      nG2=nG1*(nG1+1)/2
      Call GetMem(' G2 ','Allo','Real',ipG2t,nG2)
      Call RDDENS(Work(ipG1t),ng1,Work(ipG2t),ng2)
      ipg1=ipg1t
      ipG2=ipG2t
      ipg2tmm=ipg2
      ipg2tpp=ipg2

#ifdef _DEBUGPRINT_
      Call Triprt('G1',' ',Work(ipG1t),ntash)
      Call Triprt('G2',' ',Work(ipG2),ng1)
#endif

      nG1 = nAct*(nAct+1)/2
      nG2=nG1*(nG1+1)/2

!      Call Triprt('G1',' ',Work(ipG1t),ntash)
!      Call Triprt('G2',' ',Work(ipG2),ng1)

      if(doDMRG)then ! yma
        call dmrg_dim_change_mclr(LRras2(1:8),nact,0)
        call dmrg_spc_change_mclr(LRras2(1:8),nash)
        call dmrg_spc_change_mclr(LRras2(1:8),nrs2)
      end if

*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine DfineK(K_Lap,R,InitR,Demand)
!-----------------------------------------------------------------------
! Function : Define optimal K value
!
! Demand : Select the accuracy which you want
!        = MILLI ... 10E-03 accuracy (K = 2-)
!        = MICRO ... 10E-06 accuracy (K = 4-)
!        = NANO  ... 10E-09 accuracy (K = 7-)
!        = PICO  ... 10E-12 accuracy (K =11-)
!-----------------------------------------------------------------------

use ReMez_mod, only: IW
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: K_Lap
real(kind=wp), intent(in) :: R
integer(kind=iwp), intent(in) :: InitR
character(len=8), intent(in) :: Demand
integer(kind=iwp) :: IdxR, IVal
real(kind=wp) :: ErrVal, R_Val
logical(kind=iwp) :: Trial
integer(kind=iwp), parameter :: IdxMin(20) = [1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,4,6,7,8], &
                                KList1(31) = [2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3], &
                                KList2(31) = [3,4,5,6,6,7,7,7,7,7,7,7,8,8,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,10], &
                                KList3(31) = [5,7,8,9,10,10,11,11,11,11,12,12,13,14,14,14,15,15,15,15,15,16,17,17,17,18,18,18,18, &
                                              18,18], &
                                KList4(31) = [6,10,10,12,13,14,14,15,15,16,16,16,18,19,19,20,20,20,20,20,20,20,20,20,20,20,20,20, &
                                              20,20,20]
real(kind=wp), parameter :: ErLst1(20) = [Zero,8.752e-3_wp,5.052e-3_wp,1.700e-3_wp,6.428e-4_wp,2.646e-4_wp,1.163e-4_wp, &
                                          5.392e-5_wp,2.611e-5_wp,1.312e-5_wp,6.807e-6_wp,3.630e-6_wp,1.984e-6_wp,1.108e-6_wp, &
                                          6.311e-7_wp,3.659e-7_wp,2.155e-7_wp,1.289e-7_wp,7.811e-8_wp,4.794e-8_wp], &
                            ErLst2(20) = [Zero,Zero,Zero,6.258e-6_wp,4.243e-6_wp,7.379e-6_wp,9.841e-6_wp,8.724e-6_wp,7.468e-6_wp, &
                                          9.296e-6_wp,3.844e-6_wp,1.582e-6_wp,6.481e-7_wp,2.648e-7_wp,1.079e-7_wp,4.388e-8_wp, &
                                          1.780e-8_wp,7.213e-9_wp,2.918e-9_wp,1.179e-9_wp], &
                            ErLst3(20) = [Zero,Zero,Zero,Zero,Zero,7.741e-9_wp,1.716e-9_wp,4.045e-9_wp,6.822e-9_wp,9.323e-9_wp, &
                                          3.357e-9_wp,4.301e-9_wp,7.587e-9_wp,7.555e-9_wp,7.134e-9_wp,8.484e-9_wp,7.213e-9_wp, &
                                          8.602e-9_wp,8.602e-9_wp,9.700e-9_wp], &
                            ErLst4(20) = [Zero,Zero,Zero,Zero,Zero,Zero,Zero,Zero,Zero,9.021e-12_wp,6.492e-13_wp,5.389e-12_wp, &
                                          5.735e-12_wp,9.405e-12_wp,6.723e-12_wp,5.298e-12_wp,1.050e-12_wp,3.128e-12_wp, &
                                          7.099e-12_wp,9.371e-12_wp], &
                            ErLst5(20) = [8.556e-2_wp,1.785e-2_wp,5.052e-3_wp,1.700e-3_wp,6.428e-4_wp,2.646e-4_wp,1.163e-4_wp, &
                                          5.392e-5_wp,2.611e-5_wp,1.312e-5_wp,6.807e-6_wp,3.630e-6_wp,1.984e-6_wp,1.108e-6_wp, &
                                          6.311e-7_wp,3.659e-7_wp,2.155e-7_wp,1.289e-7_wp,7.811e-8_wp,4.794e-8_wp], &
                            RList(30) = [2.0e0_wp,5.0e0_wp,1.0e1_wp,2.0e1_wp,3.0e1_wp,4.0e1_wp,5.0e1_wp,6.0e1_wp,7.0e1_wp, &
                                         8.0e1_wp,9.0e1_wp,1.0e2_wp,2.0e2_wp,3.0e2_wp,4.0e2_wp,5.0e2_wp,6.0e2_wp,7.0e2_wp, &
                                         8.0e2_wp,9.0e2_wp,1.0e3_wp,2.0e3_wp,3.0e3_wp,4.0e3_wp,5.0e3_wp,6.0e3_wp,7.0e3_wp, &
                                         8.0e3_wp,9.0e3_wp,1.0e4_wp]
character(len=*), parameter :: Micro = 'MICRO   ', Milli = 'MILLI   ', Nano = 'NANO    ', Pico = 'PICO    '

! ===== Check a larger R value =====

Trial = .false.

write(IW,'(A,A8,A)') 'Demanded accuracy is ',Demand,'.'

if (InitR == 31) then
  if (Demand == Milli) then
    K_Lap = 3
    ErrVal = ErLst5(K_Lap)
    write(IW,'(/A,ES11.4E2)') ' This K guarantees the error less than ',ErrVal
  else if (Demand == Micro) then
    K_Lap = 11
    ErrVal = ErLst5(K_Lap)
    write(IW,'(/A,ES11.4E2)') ' This K guarantees the error less than ',ErrVal
  else
    K_Lap = 20
    ErrVal = ErLst5(K_Lap)
    if (Demand == Nano) then
      if (R <= 3.0e4_wp) then
        K_Lap = 19
        ErrVal = ErLst3(14)
        write(IW,'(/A,ES11.4E2)') ' This K guarantees the error less than ',ErrVal
        return
      else if (R <= 1.0e5_wp) then
        ErrVal = ErLst3(15)
        write(IW,'(/A,ES11.4E2)') ' This K guarantees the error less than ',ErrVal
        return
      end if
    end if
    write(IW,'(/A)') '!!! Caution !!!'
    write(IW,'(A,ES11.4E2,A)') 'In this R value, we can only guarantee',ErrVal,' accuracy.'
  end if
  return
end if

if (InitR <= 8) Trial = .true.

IVal = InitR+1

if (Demand == Milli) then
  K_Lap = KList1(IVal)
  if (Trial) then
    IdxR = IdxMin(K_Lap)
    R_Val = RList(IdxR)
    if ((R-R_Val) < Zero) IVal = IdxR
  end if
  ErrVal = ErLst1(K_Lap)
  write(IW,'(/A,ES11.4E2,A)') ' This K guarantees the error less than ',ErLst1(K_Lap),' .'
else if (Demand == Micro) then
  K_Lap = KList2(IVal)
  if (Trial) then
    IdxR = IdxMin(K_Lap)
    R_Val = RList(IdxR)
    if ((R-R_Val) < Zero) IVal = IdxR
  end if
  ErrVal = ErLst2(K_Lap)
  write(IW,'(/A,ES11.4E2,A)') ' This K guarantees the error less than ',ErLst2(K_Lap),' .'
else if (Demand == Nano) then
  K_Lap = KList3(IVal)
  if (Trial) then
    IdxR = IdxMin(K_Lap)
    R_Val = RList(IdxR)
    if ((R-R_Val) < Zero) IVal = IdxR
  end if
  ErrVal = ErLst3(K_Lap)
  write(IW,'(/A,ES11.4E2,A)') ' This K guarantees the error less than ',ErLst3(K_Lap),' .'
else if (Demand == Pico) then
  K_Lap = KList4(IVal)
  if (Trial) then
    IdxR = IdxMin(K_Lap)
    R_Val = RList(IdxR)
    if ((R-R_Val) < Zero) IVal = IdxR
  end if
  ErrVal = ErLst4(K_Lap)
  write(IW,'(/A,ES11.4E2,A)') ' This K guarantees the error less than ',ErLst4(K_Lap),' .'
end if

return

end subroutine DfineK

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Francesco Aquilante                              *
************************************************************************
      Real*8 Function Fexp(rho,drho)
************************************************************************
************************************************************************
***                                                                  ***
*** Switching function of the NDSD potential:                        ***
***     J.-M. Garcia Lastra, J. W. Kaminski, T. A. Wesolowski,       ***
***                               J. Chem. Phys.  129 (2008) 074107. ***
***                                                                  ***
*** Author: F. Aquilante, Geneva July 2010                           ***
***                                                                  ***
************************************************************************
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Real*8 lambda, rho, drho(3)
#include "real.fh"
      Parameter ( One3 = One/Three )
      Parameter ( sBmin = 0.3d0 )
      Parameter ( sBmax = 0.9d0 )
      Parameter ( rBmin = 0.7d0 )
      Parameter ( lambda= 5.0d2 )


      rhoinv= One/rho
      rhoinv13= rhoinv**One3
      fact= Two*(Three*Pi**2)**One3
      factinv= One/fact
      xnorm = drho(1)**2 + drho(2)**2 + drho(3)**2
      xnorm_= sqrt(xnorm)
      sB = factinv*rhoinv*rhoinv13*xnorm_

      es_sBmin = exp(lambda*(sBmin-sB))
      es_sBmax = exp(lambda*(sBmax-sB))
      er_rBmin = exp(lambda*(rBmin-rho))

      eis_sBmin= One/(es_sBmin+One)
      eis_sBmax= One/(es_sBmax+One)
      eir_rBmin= One/(er_rBmin+One)

      Fexp = eis_sBmin*(One-eis_sBmax)*eir_rBmin

      End
*                                                                      *
************************************************************************
*                                                                      *
      Real*8 Function Vt_lim(rho,drho,ddrho)

      Implicit Real*8 (a-h,o-z)
      Real*8 rho, drho(3), ddrho
#include "real.fh"
      Parameter ( One8 = One/Eight )
      Parameter ( One4 = One/Four  )


      rhoinv= One/rho
      rhoinv2= rhoinv**Two
      xnorm = drho(1)**2 + drho(2)**2 + drho(3)**2

      Vt_lim = One8*xnorm*rhoinv2 - One4*ddrho*rhoinv

      End
*                                                                      *
************************************************************************
*                                                                      *

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Per-Olof Widmark                                 *
!               1993,1996,1997, Markus P. Fuelscher                    *
!               1996, Luis Serrano-Andres                              *
!               2002, Roland Lindh                                     *
!               2012, Victor P. Vysotskiy                              *
!***********************************************************************

subroutine FastIO(String)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Manage all I/O operations within the MOLCAS programs.            *
!                                                                      *
!     calling arguments:                                               *
!     String  : Character string                                       *
!               Command liner. Known commands are                      *
!               TRACE  : enable/disable trace output                   *
!               QUERY  : enable/disable updating of the calling tree   *
!               STATUS : print I/O statistics                          *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, IBM Sweden, 1991                                   *
!     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
!     L. Serrano-Andres, University of Lund, Sweden, 1996              *
!                                                                      *
!     Modified to MB, by RL June, 2002, in Tokyo, Japan.               *
!     New I/O Stat, V.P. Vysotskiy, University of Lund, Sweden, 2012   *
!                                                                      *
!***********************************************************************

use Fast_IO, only: FlsSize, LuNameProf, NProfFiles, ProfData, Query, Trace
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: String
integer(kind=iwp) :: i, lString
real(kind=wp) :: file_size, rrd, rwr, tot_MB_in, tot_MB_out, tot_Rec_in, tot_Rec_out, tot_Time_in, tot_Time_out
character(len=100) :: Frmt
integer(kind=iwp), external :: iPrintLevel

lString = len(String)
if (lString >= 8) then
  ! Enable/disable tracing output
  if (String(1:8) == 'TRACE=ON') Trace = .true.
  if (String(1:9) == 'TRACE=OFF') Trace = .false.

  ! Enable/disable updating of the calling tree
  ! (This option may become very expensive in production runs!)
  if (String(1:8) == 'QUERY=ON') Query = .true.
  if (String(1:9) == 'QUERY=OFF') Query = .false.
end if
! Print I/O statistics
if ((String(1:6) == 'STATUS') .and. (iPrintLevel(-1) >= 3)) then
  tot_Rec_in = Zero
  tot_Rec_out = Zero
  tot_MB_in = Zero
  tot_MB_out = Zero
  tot_Time_in = Zero
  tot_Time_out = Zero
  file_size = Zero
  call CollapseOutput(1,'I/O STATISTICS')

  ! Part I: general I/O information
  write(u6,*) ''
  write(u6,'(1X,A)') ' I. General I/O information'
  write(u6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,'(1X,A)') ' Unit  Name          Flsize      Write/Read            MBytes           Write/Read'
  write(u6,'(1X,A)') '                     (MBytes)       Calls              In/Out           Time, sec.'
  write(u6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'

  do i=1,NProfFiles

    tot_Rec_in = tot_Rec_in+PRofData(1,i)
    tot_Rec_out = tot_Rec_out+PRofData(4,i)
    tot_MB_in = tot_MB_in+PRofData(2,i)
    tot_MB_out = tot_MB_out+PRofData(5,i)
    tot_Time_in = tot_Time_in+PRofData(3,i)
    tot_Time_out = tot_Time_out+PRofData(6,i)
    file_size = file_size+FlsSize(i)

    Frmt = '(2X,I2,2X,A8,3X,F11.2,A2,I8,A1,I8,A2,F9.1,A1,F9.1,A2,I8,A1,I8)'
    write(u6,Frmt) i,LuNameProf(i),FlsSize(i)/1024.d0/1024.d0,' .',int(PRofData(1,i)),'/',int(PRofData(4,i)),' .', &
                   PRofData(2,i)/1024**2,'/',PRofData(5,i)/1024**2,' .',int(PRofData(3,i)),'/',int(PRofData(6,i))
  end do
  write(u6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'

  Frmt = '(2X,A10,5X,F11.2,A2,I8,A1,I8,A2,F9.1,A1,F9.1,A2,I8,A1,I8)'
  write(u6,Frmt) '*  TOTAL ',file_size/(1024.0_wp**2),' .',int(tot_Rec_in),'/',int(tot_Rec_out),' .',tot_MB_in/1024**2,'/', &
                 tot_MB_out/1024**2,' .',int(tot_Time_in),'/',int(tot_Time_out)
  write(u6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'

  !Part II: a little bit more about I/O Access Patterns
  ! Percentage of write/read activity that was random writes/reads.
  write(u6,*) ''
  write(u6,'(1X,A)') ' II. I/O Access Patterns'
  write(u6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - -'
  write(u6,'(1X,A)') ' Unit  Name               % of random'
  write(u6,'(1X,A)') '                        Write/Read calls'
  write(u6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - -'
  do i=1,NProfFiles

    if (PRofData(1,i) > 0) then
      rwr = 100.0_wp*PRofData(7,i)/PRofData(1,i)
    else
      rwr = Zero
    end if

    if (PRofData(4,i) > 0) then
      rrd = 100.0_wp*PRofData(8,i)/PRofData(4,i)
    else
      rrd = Zero
    end if

    write(u6,'(2X,I2,2X,A8,7X,F9.1,A1,F6.1)') i,LuNameProf(i),rwr,'/',rrd

  end do
  write(u6,'(1X,A)') ' - - - - - - - - - - - - - - - - - - - -'
  call CollapseOutput(0,'I/O STATISTICS')
end if

return

end subroutine FastIO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine Desym1(lOper,iAng,jAng,iCmp,jCmp,iShell,jShell,
     &                  iShll,jShll,iAO,jAO,DAO,iBas,jBas,
     &                  DSO,nDSO,nOp,FactNd,Scrt)
************************************************************************
*                                                                      *
* Object: desymmetrize the first order density matrix.                 *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChTbl
      use SOAO_Info, only: iAOtSO
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 DAO(iBas*jBas,iCmp,jCmp), DSO(iBas*jBas,nDSO),
     &       Scrt(iBas*jBas)
      Integer nOp(2)
*
      iRout = 133
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Write (6,*) ' lOper=',lOper
         Call RecPrt(' In Desym1: DSO',' ',DSO,iBas*jBas,nDSO)
      End If
*
      call dcopy_(iBas*jBas*iCmp*jCmp,[Zero],0,DAO,1)
*
*     D(P,Q)_ij = Sum(iSym,jSym) X(iSym,P) X(jSym,Q) D(iSym,jSym)_ij
*
*     Loop over DSO, iSym>=jSym
*
      lSO = 0
      Do 100 j1 = 0, nIrrep-1
         Xa= DBLE(iChTbl(j1,nOp(1)))
         Do 200 i1 = 1, iCmp
            If (iAOtSO(iAO+i1,j1)<0) Cycle
*
            Do 300 j2 = 0, j1
               j12 = iEor(j1,j2)
               If (iAnd(lOper,2**j12).eq.0) Go To 300
               Xb = DBLE(iChTbl(j2,nOp(2)))
               jMx = jCmp
               If (iShell.eq.jShell .and. j1.eq.j2) jMx = i1
               Do 400 i2 = 1, jMx
                  If (iAOtSO(jAO+i2,j2)<0) Cycle
                  lSO = lSO + 1
*
                  Deg=Two
                  If (j1.eq.j2) Deg=One
*
*-----------------Parity factor due to symmetry operations applied to
*                 angular part of the basis function.
*
                  Call DaXpY_(iBas*jBas,Deg*Xa*Xb,
     &                       DSO(1,lSO),1,
     &                       DAO(1,i1,i2),1)
*
                  If (iShell.eq.jShell .and. j1.eq.j2 .and.
     &                i1.ne.i2) Then
                     Call DGeTMO(DSO(1,lSO),iBas,iBas,jBas,Scrt,jBas)
                     Call DaXpY_(iBas*jBas,Deg*Xa*Xb,
     &                          Scrt,1,
     &                          DAO(1,i2,i1),1)
                  End If
 400           Continue
 300        Continue
*
 200     Continue
 100  Continue
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In Desym1: DAO',' ',DAO,iBas*jBas,iCmp*jCmp)
      End If
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iAng)
         Call Unused_integer(jAng)
         Call Unused_integer(iShll)
         Call Unused_integer(jShll)
         Call Unused_real(FactNd)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine StartLight(ModuleName)

#ifndef _HAVE_EXTRA_
use Prgm, only: prgmfree
#endif
use Definitions, only: u5

implicit none
character(len=*), intent(in) :: ModuleName
character(len=100) :: SuperName
character(len=100), external :: Get_SuperName
#include "timtra.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
! Statistics

nfld_tim = 0
nfld_stat = 0
!                                                                      *
!***********************************************************************
!                                                                      *
call prgmfree()
call prgminit(ModuleName)
!                                                                      *
!***********************************************************************
!                                                                      *
! Unix-related information must be set or checked here or later,
! PID and master/slave status may not have been set before now.
! (DO NOT MOVE FROM HERE)

SuperName = Get_SuperName()
call UnixInfo(SuperName,ModuleName)

close(u5)
call molcas_open(u5,'stdin')
!                                                                      *
!***********************************************************************
!                                                                      *
! Initiate I/O

call FIOInit()
!                                                                      *
!***********************************************************************
!                                                                      *
! Statistics, release old fields

call IniTim()
call IniStat()

return

end subroutine StartLight

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Set_Basis_Mode_Atomic(i,j)

use Basis_Info, only: dbsc
use BasisMode, only: Atomic, Auxiliary_Mode, Basis_Mode, kCnttp, lCnttp, Valence_Mode
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: i, j
integer(kind=iwp) :: k

if (dbsc(i)%Aux) then
  Basis_Mode = Auxiliary_Mode
else
  Basis_Mode = Valence_Mode
end if

do k=i+1,j
  if (dbsc(i)%Aux .neqv. dbsc(k)%Aux) then
    call WarningMessage(2,'dbsc(i)%Aux /= dbsc(k)%Aux')
    call Abend()
  end if
end do

Atomic = .true.
kCnttp = i
lCnttp = j

end subroutine Set_Basis_Mode_Atomic

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Giovanni Li Manni                                *
!               2019, Oskar Weser                                      *
!***********************************************************************

module fcidump_tables

use index_symmetry, only: one_el_idx, two_el_idx
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
private

type :: FockTable
  real(kind=wp), allocatable :: values(:)    ! <i| F | j>
  integer(kind=iwp), allocatable :: idx(:,:) ! i, j
  real(kind=wp) :: cutoff
  integer(kind=iwp) :: length
end type FockTable

type :: TwoElIntTable
  real(kind=wp), allocatable :: values(:)    ! <ij| 1/r_{12} |kl>
  integer(kind=iwp), allocatable :: idx(:,:) ! i, j, k, l
  real(kind=wp) :: cutoff
  integer(kind=iwp) :: length
end type TwoElIntTable

type :: OrbitalTable
  real(kind=wp), allocatable :: values(:)  ! <i| F |i>
  integer(kind=iwp), allocatable :: idx(:) ! i
end type OrbitalTable

real(kind=wp), parameter :: cutoff_default = 1.0e-11_wp

interface mma_allocate
  module procedure :: FockTable_allocate, TwoElIntTable_allocate, OrbitalTable_allocate
end interface mma_allocate

interface mma_deallocate
  module procedure :: FockTable_deallocate, TwoElIntTable_deallocate, OrbitalTable_deallocate
end interface mma_deallocate

interface length
  module procedure :: FockTable_length, TwoElIntTable_length, OrbitalTable_length
end interface length

interface print_table
  module procedure :: FockTable_print, TwoElIntTable_print, OrbitalTable_print
end interface print_table

public :: cutoff_default, fill_2ElInt, fill_fock, fill_orbitals, FockTable, length, mma_allocate, mma_deallocate, OrbitalTable, &
          print_table, TwoElIntTable

contains

subroutine OrbitalTable_allocate(orbital_table,n)

  type(OrbitalTable), intent(inout) :: orbital_table
  integer(kind=iwp), intent(in) :: n

  call mma_allocate(orbital_table%values,n)
  call mma_allocate(orbital_table%idx,n)

end subroutine OrbitalTable_allocate

subroutine OrbitalTable_deallocate(orbital_table)

  type(OrbitalTable), intent(inout) :: orbital_table

  call mma_deallocate(orbital_table%values)
  call mma_deallocate(orbital_table%idx)

end subroutine OrbitalTable_deallocate

!>  @brief
!>    Fill in orbital energies
!>
!>  @author Oskar Weser
!>
!>  @details
!>  The orbitals table gets filled with the orbital energies from orbital_energies.
!>
!>  @param[in,out] table
!>  @param[in] orbital_energies
subroutine fill_orbitals(table,orbital_energies)

  use general_data, only: nAsh, nBas, nFro, nIsh, nSym

  type(OrbitalTable), intent(inout) :: table
  real(kind=wp), intent(in) :: orbital_energies(:)
  integer(kind=iwp) :: i, iOff, iSym, n

  iOff = 0
  n = 1
  do iSym=1,nSym
    if (nAsh(iSym) > 0) then
      do i=1,nAsh(isym)
        table%idx(n) = n
        table%values(n) = orbital_energies(ioff+nFro(iSym)+nIsh(iSym)+i)
        n = n+1
      end do
    end if
    iOff = iOff+nBas(iSym)
  end do

end subroutine fill_orbitals

pure function OrbitalTable_length(table)

  integer(kind=iwp) :: OrbitalTable_length
  type(OrbitalTable), intent(in) :: table

  OrbitalTable_length = size(table%values)

end function OrbitalTable_length

subroutine OrbitalTable_print(table)

  type(OrbitalTable), intent(in) :: table
  integer(kind=iwp) :: i

  do i=1,length(table)
    write(u6,'(ES15.7, I7)') table%values(i),table%idx(i)
  end do

end subroutine OrbitalTable_print

subroutine FockTable_allocate(fock_table,n)

  type(FockTable), intent(inout) :: fock_table
  integer(kind=iwp), intent(in) :: n

  call mma_allocate(fock_table%values,n)
  call mma_allocate(fock_table%idx,2,n)

end subroutine FockTable_allocate

subroutine FockTable_deallocate(fock_table)

  type(FockTable), intent(inout) :: fock_table

  call mma_deallocate(fock_table%values)
  call mma_deallocate(fock_table%idx)

end subroutine FockTable_deallocate

!>  @brief
!>    Fill in fock matrix elements.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  The fock_table gets filled with the Fock matrix elements
!>  whose absolute value is larger than cutoff.
!>  The values are given by
!>  \f[ < i | F | j > \f]
!>  The index is given by i and j.
!>
!>  @param[in,out] fock_table
!>  @param[in] Fock
!>    \f[\sum_{\sigma\rho} {In}^D_{\sigma\rho} (g_{\mu\nu\sigma\rho})  \f]
!>  @param[in] cutoff Optional parameter that is set by default to
!>    fciqmc_tables::cutoff_default.
subroutine fill_fock(fock_table,Fock,cutoff)

  type(FockTable), intent(inout) :: fock_table
  real(kind=wp), intent(in) :: Fock(:)
  real(kind=wp), optional, intent(in) :: cutoff
  integer(kind=iwp) :: i, n
  real(kind=wp) :: cutoff_

  cutoff_ = cutoff_default
  if (present(cutoff)) cutoff_ = cutoff

  n = 0
  do i=1,size(Fock)
    if (abs(Fock(i)) >= cutoff_) then
      n = n+1
      call one_el_idx(i,fock_table%idx(:,n))
      fock_table%values(n) = Fock(i)
    end if
  end do
  fock_table%length = n
  fock_table%cutoff = cutoff_

end subroutine fill_fock

pure function FockTable_length(table)

  integer(kind=iwp) :: FockTable_length
  type(FockTable), intent(in) :: table

  FockTable_length = table%length

end function FockTable_length

subroutine FockTable_print(table)

  type(FockTable), intent(in) :: table
  integer(kind=iwp) :: i, j

  do j=1,length(table)
    write(u6,'(ES15.7, I7, I7)') table%values(j),(table%idx(i,j),i=1,2)
  end do

end subroutine FockTable_print

subroutine TwoElIntTable_allocate(table,n)

  type(TwoElIntTable), intent(inout) :: table
  integer(kind=iwp), intent(in) :: n

  call mma_allocate(table%values,n)
  call mma_allocate(table%idx,4,n)

end subroutine TwoElIntTable_allocate

subroutine TwoElIntTable_deallocate(table)

  type(TwoElIntTable), intent(inout) :: table

  call mma_deallocate(table%values)
  call mma_deallocate(table%idx)

end subroutine TwoElIntTable_deallocate

!>  @brief
!>    Fill in two electron integrals
!>
!>  @author Oskar Weser
!>
!>  @details
!>  The two_el_table gets filled with those two electron integrals
!>  whose absolute value is larger than cutoff.
!>  The values are given by
!>  \f[ < i, j | \frac{1}{r_{1,2}} | k, l > \f]
!>  The index is given by i, j, k, and l.
!>
!>  @param[in,out] two_el_table
!>  @param[in] TUVX
!>  @param[in] cutoff Optional parameter that is set by default to
!>    fciqmc_tables::cutoff_default.
subroutine fill_2ElInt(two_el_table,TUVX,cutoff)

  type(TwoElIntTable), intent(inout) :: two_el_table
  real(kind=wp), intent(in) :: TUVX(:)
  real(kind=wp), optional :: cutoff
  integer(kind=iwp) :: i, l_twoel_test, n
  real(kind=wp) :: cutoff_
  integer(kind=iwp), parameter :: max_test = 20

  cutoff_ = cutoff_default
  if (present(cutoff)) cutoff_ = cutoff

  n = 0
  do i=1,size(TUVX)
    if (abs(TUVX(i)) >= cutoff_) then
      n = n+1
      call two_el_idx(i,two_el_table%idx(:,n))
      two_el_table%values(n) = TUVX(i)
    end if
  end do
  two_el_table%length = n
  two_el_table%cutoff = cutoff_

  ! ========== For testing purposes FROM HERE =============
  l_twoel_test = min(max_test,length(two_el_table))
  call Add_Info('TwoEl Integral element Input',TUVX(:l_twoel_test),l_twoel_test,8)
  ! ========== For testing purposes TO HERE ===============

end subroutine fill_2ElInt

pure function TwoElIntTable_length(table)

  integer(kind=iwp) :: TwoElIntTable_length
  type(TwoElIntTable), intent(in) :: table

  TwoElIntTable_length = table%length

end function TwoElIntTable_length

subroutine TwoElIntTable_print(table)

  type(TwoElIntTable), intent(in) :: table
  integer(kind=iwp) :: i, j

  do j=1,length(table)
    write(u6,'(ES15.7, I7, I7, I7, I7)') table%values(j),(table%idx(i,j),i=1,4)
  end do

end subroutine TwoElIntTable_print

end module fcidump_tables

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine makeT2ptHlp2 (T2p,Tau,aGrp,bGrp,aSGrp,bSGrp,key,
     c                          dimi,dimij,dimapp,dimbpp,dimap,dimabp)
c
c       this routine do:
c       define T2(+-)((ab)",ij) = Tau((ab)',i,j) +- Tau((ab)',j,i)
c       for the case: aGrp=bGrp but aSGrp>bSGrp
c
c       parameter description:
c       T2p     - array for T2+ (O)
c       Tau     - array for Tau (I)
c       xGrp    - Groups of a',b' (I)
c       xSGrp   - SubGroups of a",b" (I)
c       key     - 0 - T2+; 1 = T2- will be produced
c       dimx    - Dimension of i,(i>=j),a",b",a',(a>=b)' (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,bGrp,aSGrp,bSGrp,key
        integer dimi,dimij,dimapp,dimbpp,dimap,dimabp
        real*8 T2p(1:dimapp,1:dimbpp,1:dimij)
        real*8 Tau(1:dimabp,1:dimi,1:dimi)
c
c
c       help variables
        integer i,j,ij,app,bpp,ap,abp,appAdd,bppAdd
c
c
c1      def appAdd,bppAdd
c
        appAdd=0
        if (aSGrp.ne.Grpalow(aGrp)) then
          do i=Grpalow(aGrp),aSGrp-1
          appAdd=appAdd+DimSGrpa(i)
          end do
        end if
c
        bppAdd=0
        if (bSGrp.ne.Grpalow(bGrp)) then
          do i=Grpalow(bGrp),bSGrp-1
          bppAdd=bppAdd+DimSGrpa(i)
          end do
        end if
c
c
c2      define T2(+,-)
c
        if (key.eq.0) then
c
c2.1    define T2+
        ij=0
        do i=1,dimi
        do j=1,i
        ij=ij+1
          do app=1,dimapp
          ap=appAdd+app
          abp=ap*(ap-1)/2+bppAdd
          do bpp=1,dimbpp
          abp=abp+1
            T2p(app,bpp,ij)=Tau(abp,i,j)+Tau(abp,j,i)
          end do
          end do
        end do
        end do
c
        else
c
c2.2    define T2-
        ij=0
        do i=2,dimi
        do j=1,i-1
        ij=ij+1
          do app=1,dimapp
          ap=appAdd+app
          abp=ap*(ap-1)/2+bppAdd
          do bpp=1,dimbpp
          abp=abp+1
            T2p(app,bpp,ij)=Tau(abp,i,j)-Tau(abp,j,i)
          end do
          end do
        end do
        end do
c
        end if
c
        call mv0sv (dimij*dimapp*dimbpp,dimij*dimapp*dimbpp,
     c              T2p(1,1,1),0.5d0)
c
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_integer(dimap)
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Int2Car(dSS,rInt,nInter,ip_qInt,Coor,nAtom,nBVct,
     &                  ipBMx,dMass,nLines,DFC,
     &                  nDim,Lbl,Name,iSym,
     &                  Smmtrc,Degen,iter,
     &                  ip_dqInt,Gx,Cx,mTtAtm,iANr,iOptH,
     &                  User_Def,nStab,jStab,Curvilinear,
     &                  Numerical,DDV_Schlegel,HWRS,
     &                  Analytic_Hessian,iOptC,PrQ,mxdc,
     &                  iCoSet,rHidden,Error,ipRef,Redundant,nqInt,
     &                  MaxItr,iRef)
      Implicit Real*8 (a-h,o-z)
************************************************************************
*                                                                      *
*     Object: To compute the new symm. distinct Cartesian coordinates  *
*             from the suggested shift of the internal coordinates.    *
*                                                                      *
************************************************************************
#include "real.fh"
#include "WrkSpc.fh"
#include "weighting.fh"
#include "sbs.fh"
#include "print.fh"
#include "Molcas.fh"
#include "warnings.fh"
      Parameter(NRHS=1)
      Real*8 dSS(nInter,NRHS), rInt(nInter), dMass(nAtom),
     &       DFC(3*nAtom,NRHS),
     &       Coor(3,nAtom), Degen(3*nAtom),
     &       Gx(3*nAtom,iter), Cx(3*nAtom,iter+1),
     &       cMass(3)
      Character Lbl(nInter)*8, Name(nAtom)*(LENIN)
      Integer   iSym(3), iANr(nAtom),
     &          nStab(nAtom), jStab(0:7,nAtom), iCoSet(0:7,nAtom)
      Logical Smmtrc(3,nAtom), BSet, HSet, User_Def,
     &        Curvilinear, Numerical, DDV_Schlegel, Redundant,
     &        HWRS, Analytic_Hessian, PrQ, lOld, Invar
      Save        BSet, HSet, lOld
*
C     Data Error/1.0D-06/, BSet/.False./, HSet/.False./,
      Data                 BSet/.False./, HSet/.False./,
     &     lOld/.False./
*                                                                      *
************************************************************************
*                                                                      *
      Lu=6
      iRout = 33
      iPrint=nPrint(iRout)
      If (iPrint.ge.11) Then
         Write (Lu,*)
         Write (Lu,*) ' *** Transforming internal coordinates'
     &             //' to Cartesian ***'
         Write (Lu,*)
         Write (Lu,*) ' Iter  Internal  Error'
      End If
*
      If (iPrint.ge.99) Then
         Write (Lu,*)
         Write (Lu,*) ' In Int2Car: Shifts'
         Write (Lu,*)
         Write (Lu,'(1X,A,2X,F10.4)') (Lbl(iInter),dss(iInter,1),
     &          iInter=1,nInter)
         Call RecPrt(' In Int2Car: qInt',' ',Work(ip_qInt),nInter,
     &               Iter+1)
      End If
*
*     Compute the final internal coordinates, plus sign due to the use
*     of forces and not gradients.
*
      rMax = Zero
      iMax = 0
      jter = 0
      Do i = 1, nInter
         If (Abs(dss(i,1)) .gt. Abs(rMax)) Then
            rMax = dss(i,1)
            iMax = i
         End If
      End Do
      If (iPrint.ge.11) Then
         If (iMax.ne.0) Then
            Write (Lu,300) jter,Lbl(iMax),rMax
         Else
            Write (Lu,300) jter,'N/A     ',rMax
         End If
      End If
 300  Format (1X,'Iter:',I5,2X,A,1X,E11.4)
*
      If (iPrint.ge.19) Then
         Write (Lu,*)
         Write (Lu,*)' Internal coordinates of the next macro iteration'
         Write (Lu,*)
         Write (Lu,'(1X,A,2X,F10.4)') (Lbl(iInter),rInt(iInter),
     &          iInter=1,nInter)
      End If
      nPrint_33=nPrint(33)
      nPrint_31=nPrint(31)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the new Cartesian coordinates.
*
      iterMx = 50
      Do jter = 1, iterMx
*
*--------Compute the Cartesian shift, solve dq = B^T dx!
*
         M = 3*nAtom
         N = nInter
         Call Eq_Solver('T',M,N,NRHS,Work(ipBMx),Curvilinear,Degen,dSS,
     &                  DFC)
         Call Free_Work(ipBmx)
*
         If (iPrint.ge.99)
     &     Call PrList('Symmetry Distinct Nuclear Displacements',
     &                 Name,nAtom,DFC,3,nAtom)
*
*        Compute the RMS in Cartesian Coordinates.
*
         dx2=Zero
         denom=Zero
         Do ix = 1, 3*nAtom
            dx2 = dx2 + Degen(ix)*DFC(ix,1)**2
            denom=denom+Degen(ix)
         End Do
         dx_RMS = Sqrt(dx2/denom)
*
*--------Update the symmetry distinct Cartesian coordinates.
*
         Call DaXpY_(3*nAtom,One,DFC,1,Coor,1)
*
*        Dirty fix of zeros
*
         Do iAtom = 1, nAtom
            If (Cx((iAtom-1)*3+1,Iter).eq.Zero .and.
     &          Abs(Coor(1,iAtom)).lt.1.0D-13) Coor(1,iAtom)=Zero
            If (Cx((iAtom-1)*3+2,Iter).eq.Zero .and.
     &          Abs(Coor(2,iAtom)).lt.1.0D-13) Coor(2,iAtom)=Zero
            If (Cx((iAtom-1)*3+3,Iter).eq.Zero .and.
     &          Abs(Coor(3,iAtom)).lt.1.0D-13) Coor(3,iAtom)=Zero
         End Do
*
         Call CofMss(Coor,dMass,nAtom,.False.,cMass,iSym)
         call dcopy_(3*nAtom,Coor,1,Cx(1,Iter+1),1)
         If (iPrint.ge.99)
     &      Call PrList('Symmetry Distinct Nuclear Coordinates / Bohr',
     &                   Name,nAtom,Coor,3,nAtom)
*
*--------Compute new values q and the Wilson B-matrix for the new
*        geometry with the current new set of Cartesian coordinates.
*
         nFix=0
         nWndw=1
         Call BMtrx(nLines,nBVct,ipBMx,nAtom,nInter,
     &              ip_qInt,Lbl,Coor,nDim,dMass,
     &              Name,Smmtrc,
     &              Degen,BSet,HSet,iter+1,ip_dqInt,
     &              ipShift,Gx,Cx,mTtAtm,iANr,iOptH,User_Def,
     &              nStab,jStab,Curvilinear,Numerical,
     &              DDV_Schlegel,HWRS,Analytic_Hessian,iOptC,
     &              PrQ,mxdc,iCoSet,lOld,rHidden,
     &              nFix,nQQ,iRef,Redundant,nqInt,MaxItr,nWndw)
*
*--------Check if the final structure is reached and get the
*        difference between the present structure and the final.
*
         rOld = rMax
         iMax_Old = iMax
         iMax = 1
         ip = ip_qInt + Iter*nInter -1
         rMax = Zero
         Do i = 1, nInter
            dSS(i,1) = rInt(i)-Work(ip+i)
            If (Abs(dSS(i,1)) .gt. Abs(rMax)) Then
               rMax = dSS(i,1)
               iMax = i
            End If
         End Do
*
*        Convergence based on the RMS of the Cartesian displacements.
*
         If (dx_RMS.lt.1.0D-6) Go To 998
*
         If (iPrint.ge.99) Then
            Write (Lu,*)
            Write (Lu,*) ' Displacement of internal coordinates'
            Write (Lu,*)
            Write (Lu,'(1X,A,2X,F10.4)') (Lbl(iInter),dss(iInter,1),
     &             iInter=1,nInter)
         End If
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call WarningMessage(2,'Error in Int2Car')
      Write (Lu,*)
      Write (Lu,*) '***********************************************'
      Write (Lu,*) ' ERROR: No convergence in Int2Car !            '
      Write (Lu,*) ' Strong linear dependency among Coordinates.   '
      Write (Lu,*) ' Hint: Try to change the Internal Coordinates. '
      Write (Lu,*) '***********************************************'
      If (.NOT.User_Def) Call RecPrt('Int2Car: rInt  ','(10F15.10)',
     &                               rInt,nInter,1)
      ip = ip_qInt + Iter*nInter
      If (.NOT.User_Def) Call RecPrt('Int2Car: qInt','(10F15.10)',
     &                               Work(ip),nInter,1)
      Write (Lu,*)
      Call Quit(_RC_NOT_CONVERGED_)
*                                                                      *
************************************************************************
*                                                                      *
 998  Continue
*
      If (iPrint.ge.6) Then
         Write (Lu,*)
         Write (Lu,'(A,i2,A)')
     &         ' New Cartesian coordinates were found in',
     &         jter,' Newton-Raphson iterations.'
         Write (Lu,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     In case the internal coordinates where nonvalid we now take the
*     final internal coordinates at the converged Cartesian structure
*     as the internal coordinates.
*
      ip = ip_qInt + Iter*nInter
      call dcopy_(nInter,rInt,1,Work(ip),1)
*                                                                      *
************************************************************************
*                                                                      *
*     Finally, just to be safe align the new Cartesian structure with
*     the reference structure (see init2.f)
*
      Invar=(iAnd(iSBS,2**7).eq.0).and.(iAnd(iSBS,2**8).eq.0)
      If (WeightedConstraints.and.Invar)
     &   Call Align(Cx(1,iter+1),Work(ipRef),nAtom)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(Error)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
*               Francesco Aquilante                                    *
************************************************************************
      SubRoutine ChoMP2_Energy_Contr_T1(EMP2,EOcc,EVir,Xaibj,
     &                                       LnT2am,LiT2am,
     &                                       iBatch,jBatch)
C
C     Thomas Bondo Pedersen, Dec. 2004 / Feb. 2005.
C
C     Purpose: compute (MINUS the) energy contribution from a
C              batch of (ai|bj) integrals.
C
C     Modified by F. Aquilante to add contributions from T1 amplitudes
C                              determined from Thouless formula
C
      use ChoMP2, only: iFirstS, LnOcc, LnT1am, LiT1am, LiMatij
#include "implicit.fh"
      Real*8  EOcc(*), EVir(*), Xaibj(LnT2am)
      Integer LiT2am(8)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"

      Integer a, b, aibj, biaj, abij, baij

      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      Call Cho_GAdGOp(Xaibj,LnT2am,'+')

      If (iBatch .eq. jBatch) Then

         If (ChoAlg .eq. 2) Then ! M(ab,ij)=(ai|bj) with i<=j.
            Do iSymj = 1,nSym
               iSymi = iSymj
               Do Lj = 1,LnOcc(iSymj,jBatch)
                  j = iFirstS(iSymj,jBatch) + Lj - 1
                  Do Li = 1,LnOcc(iSymi,iBatch)
                     i = iFirstS(iSymi,iBatch) + Li - 1
                     ij = LiMatij(iSymi,iSymj,iBatch) + iTri(Li,Lj)
                     Do iSymb = 1,nSym
                        iSyma = iSymb
                        If (iSymj.eq.iSymb) Then
                         Do b = 1,nVir(iSymb)
                           abij = LiT2am(1)
     &                          + nMatab(1)*(ij-1)
     &                          + iMatab(iSyma,iSymb)
     &                          + nVir(iSyma)*(b-1)
                           baij = LiT2am(1)
     &                          + nMatab(1)*(ij-1)
     &                          + iMatab(iSymb,iSyma)
     &                          - nVir(iSymb) + b
                           Do a = 1,nVir(iSyma)
                              abij = abij+1
                              baij = baij+nVir(iSymb)
                              Dnom = EVir(iVir(iSyma)+a)
     &                             - EOcc(iOcc(iSymi)+i)
     &                             + EVir(iVir(iSymb)+b)
     &                             - EOcc(iOcc(iSymj)+j)
                              ia = iOffT1(iSymi) + nOcc(iSymi)*(a-1) + i
                              jb = iOffT1(iSymj) + nOcc(iSymj)*(b-1) + j
                              Xtmp  = Xaibj(abij)
                              Taibj = Xtmp/Dnom - Work(ia)*Work(jb)
                              Waibj = 2.0D0*Xtmp
                              EOSMP2= EOSMP2 + Taibj*Waibj
                              Waibj = Waibj - Xaibj(baij)
                              Eaibj = Taibj*Waibj
                              EMP2  = EMP2 + Eaibj
                              WREF  = WREF + Eaibj/Dnom
                           End Do
                         End Do
                        Else
                         Do b = 1,nVir(iSymb)
                           abij = LiT2am(1)
     &                          + nMatab(1)*(ij-1)
     &                          + iMatab(iSyma,iSymb)
     &                          + nVir(iSyma)*(b-1)
                           baij = LiT2am(1)
     &                          + nMatab(1)*(ij-1)
     &                          + iMatab(iSymb,iSyma)
     &                          - nVir(iSymb) + b
                           Do a = 1,nVir(iSyma)
                              abij = abij+1
                              baij = baij+nVir(iSymb)
                              Dnom = EVir(iVir(iSyma)+a)
     &                             - EOcc(iOcc(iSymi)+i)
     &                             + EVir(iVir(iSymb)+b)
     &                             - EOcc(iOcc(iSymj)+j)
                              Xtmp  = Xaibj(abij)
                              Taibj = Xtmp/Dnom
                              Waibj = 2.0D0*Xtmp
                              EOSMP2= EOSMP2 + Taibj*Waibj
                              Waibj = Waibj - Xaibj(baij)
                              Eaibj = Taibj*Waibj
                              EMP2  = EMP2 + Eaibj
                              WREF  = WREF + Eaibj/Dnom
                           End Do
                         End Do
                        EndIf
                     End Do
                  End Do
               End Do
            End Do
            Do iSymij = 2,nSym
               iSymab = iSymij
               Do iSym2 = 1,nSym
                  iSym1 = MulD2h(iSym2,iSymij)
                  iSymj = max(iSym1,iSym2)
                  iSymi = min(iSym1,iSym2)
                  Do Lj = 1,LnOcc(iSymj,jBatch)
                     j = iFirstS(iSymj,jBatch) + Lj - 1
                     Do Li = 1,LnOcc(iSymi,iBatch)
                        i = iFirstS(iSymi,iBatch) + Li - 1
                        ij = LiMatij(iSymi,iSymj,iBatch)
     &                     + LnOcc(iSymi,iBatch)*(Lj-1) + Li
                        Do iSymb = 1,nSym
                           iSyma = MulD2h(iSymb,iSymab)
                           If(iSymi.eq.iSyma .and. iSymj.eq.iSymb)Then
                            Do b = 1,nVir(iSymb)
                              abij = LiT2am(iSymij)
     &                             + nMatab(iSymab)*(ij-1)
     &                             + iMatab(iSyma,iSymb)
     &                             + nVir(iSyma)*(b-1)
                              baij = LiT2am(iSymij)
     &                             + nMatab(iSymab)*(ij-1)
     &                             + iMatab(iSymb,iSyma)
     &                             - nVir(iSymb) + b
                              Do a = 1,nVir(iSyma)
                                 abij = abij+1
                                 baij = baij+nVir(iSymb)
                                 Dnom = EVir(iVir(iSyma)+a)
     &                                - EOcc(iOcc(iSymi)+i)
     &                                + EVir(iVir(iSymb)+b)
     &                                - EOcc(iOcc(iSymj)+j)
                                 ia = iOffT1(iSymi)+nOcc(iSymi)*(a-1) +i
                                 jb = iOffT1(iSymj)+nOcc(iSymj)*(b-1) +j
                                 Xtmp  = Xaibj(abij)
                                 Taibj = Xtmp/Dnom - Work(ia)*Work(jb)
                                 Waibj = 2.0D0*Xtmp
                                 EOSMP2= EOSMP2 + Taibj*Waibj
                                 Waibj = Waibj - Xaibj(baij)
                                 Eaibj = Taibj*Waibj
                                 EMP2  = EMP2 + Eaibj
                                 WREF  = WREF + Eaibj/Dnom
                              End Do
                            End Do
                           Else
                            Do b = 1,nVir(iSymb)
                              abij = LiT2am(iSymij)
     &                             + nMatab(iSymab)*(ij-1)
     &                             + iMatab(iSyma,iSymb)
     &                             + nVir(iSyma)*(b-1)
                              baij = LiT2am(iSymij)
     &                             + nMatab(iSymab)*(ij-1)
     &                             + iMatab(iSymb,iSyma)
     &                             - nVir(iSymb) + b
                              Do a = 1,nVir(iSyma)
                                 abij = abij+1
                                 baij = baij+nVir(iSymb)
                                 Dnom = EVir(iVir(iSyma)+a)
     &                                - EOcc(iOcc(iSymi)+i)
     &                                + EVir(iVir(iSymb)+b)
     &                                - EOcc(iOcc(iSymj)+j)
                                 Xtmp  = Xaibj(abij)
                                 Taibj = Xtmp/Dnom
                                 Waibj = 2.0D0*Xtmp
                                 EOSMP2= EOSMP2 + Taibj*Waibj
                                 Waibj = Waibj - Xaibj(baij)
                                 Eaibj = Taibj*Waibj
                                 EMP2  = EMP2 + Eaibj
                                 WREF  = WREF + Eaibj/Dnom
                              End Do
                            End Do
                           EndIf
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         Else ! triangular storage, (ai|bj) with ai<=bj.
            Do iSymbj = 1,nSym
               iSymai = iSymbj
               Do iSymj = 1,nSym
                  iSymb = MulD2h(iSymj,iSymbj)
                  Do Lj = 1,LnOcc(iSymj,jBatch)
                     j = iFirstS(iSymj,jBatch) + Lj - 1
                     Do b = 1,nVir(iSymb)
                        Lbj = LiT1am(iSymb,iSymj,jBatch)
     &                      + nVir(iSymb)*(Lj - 1) + b
                        Do iSymi = 1,nSym
                           iSyma  = MulD2h(iSymi,iSymai)
                           iSymaj = MulD2h(iSyma,iSymj)
                           iSymbi = iSymaj
                           If(iSymi.eq.iSyma .and. iSymj.eq.iSymb)Then
                            Do Li = 1,LnOcc(iSymi,iBatch)
                              i   = iFirstS(iSymi,iBatch) + Li - 1
                              Lbi = LiT1am(iSymb,iSymi,iBatch)
     &                            + nVir(iSymb)*(Li - 1) + b
                              Do a = 1,nVir(iSyma)
                                 Lai = LiT1am(iSyma,iSymi,iBatch)
     &                               + nVir(iSyma)*(Li - 1) + a
                                 Laj = LiT1am(iSyma,iSymj,jBatch)
     &                               + nVir(iSyma)*(Lj - 1) + a
                                 aibj = LiT2am(iSymai) + iTri(Lai,Lbj)
                                 biaj = LiT2am(iSymbi) + iTri(Lbi,Laj)
                                 Dnom = EVir(iVir(iSyma)+a)
     &                                - EOcc(iOcc(iSymi)+i)
     &                                + EVir(iVir(iSymb)+b)
     &                                - EOcc(iOcc(iSymj)+j)
                                 ia = iOffT1(iSymi)+nOcc(iSymi)*(a-1) +i
                                 jb = iOffT1(iSymj)+nOcc(iSymj)*(b-1) +j
                                 Xtmp  = Xaibj(aibj)
                                 Taibj = Xtmp/Dnom - Work(ia)*Work(jb)
                                 Waibj = 2.0D0*Xtmp
                                 EOSMP2= EOSMP2 + Taibj*Waibj
                                 Waibj = Waibj - Xaibj(biaj)
                                 Eaibj = Taibj*Waibj
                                 EMP2  = EMP2 + Eaibj
                                 WREF  = WREF + Eaibj/Dnom
                              End Do
                            End Do
                           Else
                            Do Li = 1,LnOcc(iSymi,iBatch)
                              i   = iFirstS(iSymi,iBatch) + Li - 1
                              Lbi = LiT1am(iSymb,iSymi,iBatch)
     &                            + nVir(iSymb)*(Li - 1) + b
                              Do a = 1,nVir(iSyma)
                                 Lai = LiT1am(iSyma,iSymi,iBatch)
     &                               + nVir(iSyma)*(Li - 1) + a
                                 Laj = LiT1am(iSyma,iSymj,jBatch)
     &                               + nVir(iSyma)*(Lj - 1) + a
                                 aibj = LiT2am(iSymai) + iTri(Lai,Lbj)
                                 biaj = LiT2am(iSymbi) + iTri(Lbi,Laj)
                                 Dnom = EVir(iVir(iSyma)+a)
     &                                - EOcc(iOcc(iSymi)+i)
     &                                + EVir(iVir(iSymb)+b)
     &                                - EOcc(iOcc(iSymj)+j)
                                 Xtmp  = Xaibj(aibj)
                                 Taibj = Xtmp/Dnom
                                 Waibj = 2.0D0*Xtmp
                                 EOSMP2= EOSMP2 + Taibj*Waibj
                                 Waibj = Waibj - Xaibj(biaj)
                                 Eaibj = Taibj*Waibj
                                 EMP2  = EMP2 + Eaibj
                                 WREF  = WREF + Eaibj/Dnom
                              End Do
                            End Do
                           EndIf
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End If

      Else ! rectangular storage (ai|bj) with ai<bj.

         EMP2_sav = EMP2
         EMP2     = 0.0D0
         WREF_sav = WREF
         WREF     = 0.0D0
         EOSMP2_sav = EOSMP2
         EOSMP2     = 0.0D0
         Do iSymbj = 1,nSym
            iSymai = iSymbj
            Do iSymj = 1,nSym
               iSymb = MulD2h(iSymj,iSymbj)
               Do Lj = 1,LnOcc(iSymj,jBatch)
                  j = iFirstS(iSymj,jBatch) + Lj - 1
                  Do b = 1,nVir(iSymb)
                     Lbj = LiT1am(iSymb,iSymj,jBatch)
     &                   + nVir(iSymb)*(Lj - 1) + b
                     Do iSymi = 1,nSym
                        iSyma  = MulD2h(iSymi,iSymai)
                        iSymaj = MulD2h(iSyma,iSymj)
                        iSymbi = iSymaj
                        If(iSymi.eq.iSyma .and. iSymj.eq.iSymb)Then
                         Do Li = 1,LnOcc(iSymi,iBatch)
                           i   = iFirstS(iSymi,iBatch) + Li - 1
                           Lbi = LiT1am(iSymb,iSymi,iBatch)
     &                         + nVir(iSymb)*(Li - 1) + b
                           Do a = 1,nVir(iSyma)
                              Lai = LiT1am(iSyma,iSymi,iBatch)
     &                            + nVir(iSyma)*(Li - 1) + a
                              Laj = LiT1am(iSyma,iSymj,jBatch)
     &                            + nVir(iSyma)*(Lj - 1) + a
                              aibj = LiT2am(iSymai)
     &                             + LnT1am(iSymai,iBatch)*(Lbj-1) + Lai
                              biaj = LiT2am(iSymbi)
     &                             + LnT1am(iSymbi,iBatch)*(Laj-1) + Lbi
                              Dnom = EVir(iVir(iSyma)+a)
     &                             - EOcc(iOcc(iSymi)+i)
     &                             + EVir(iVir(iSymb)+b)
     &                             - EOcc(iOcc(iSymj)+j)
                              ia = iOffT1(iSymi)+nOcc(iSymi)*(a-1) +i
                              jb = iOffT1(iSymj)+nOcc(iSymj)*(b-1) +j
                              Xtmp  = Xaibj(aibj)
                              Taibj = Xtmp/Dnom - Work(ia)*Work(jb)
                              Waibj = 2.0D0*Xtmp
                              EOSMP2= EOSMP2 + Taibj*Waibj
                              Waibj = Waibj - Xaibj(biaj)
                              Eaibj = Taibj*Waibj
                              EMP2  = EMP2 + Eaibj
                              WREF  = WREF + Eaibj/Dnom
                           End Do
                         End Do
                        Else
                         Do Li = 1,LnOcc(iSymi,iBatch)
                           i   = iFirstS(iSymi,iBatch) + Li - 1
                           Lbi = LiT1am(iSymb,iSymi,iBatch)
     &                         + nVir(iSymb)*(Li - 1) + b
                           Do a = 1,nVir(iSyma)
                              Lai = LiT1am(iSyma,iSymi,iBatch)
     &                            + nVir(iSyma)*(Li - 1) + a
                              Laj = LiT1am(iSyma,iSymj,jBatch)
     &                            + nVir(iSyma)*(Lj - 1) + a
                              aibj = LiT2am(iSymai)
     &                             + LnT1am(iSymai,iBatch)*(Lbj-1) + Lai
                              biaj = LiT2am(iSymbi)
     &                             + LnT1am(iSymbi,iBatch)*(Laj-1) + Lbi
                              Dnom = EVir(iVir(iSyma)+a)
     &                             - EOcc(iOcc(iSymi)+i)
     &                             + EVir(iVir(iSymb)+b)
     &                             - EOcc(iOcc(iSymj)+j)
                              Xtmp  = Xaibj(aibj)
                              Taibj = Xtmp/Dnom
                              Waibj = 2.0D0*Xtmp
                              EOSMP2= EOSMP2 + Taibj*Waibj
                              Waibj = Waibj - Xaibj(biaj)
                              Eaibj = Taibj*Waibj
                              EMP2  = EMP2 + Eaibj
                              WREF  = WREF + Eaibj/Dnom
                           End Do
                         End Do
                        EndIf
                     End Do
                  End Do
               End Do
            End Do
         End Do
         EMP2 = EMP2_sav + 2.0D0*EMP2
         EOSMP2 = EOSMP2_sav + 2.0D0*EOSMP2
         WREF = WREF_sav + 2.0D0*WREF

      End If

      EOSMP2 = 0.5D0*EOSMP2

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine test_rho(densityt_time,time)
!***********************************************************************
! Purpose: test density matrix on hermicity and positivity (?)
!***********************************************************************

use rhodyn_data, only: Nstate, threshold
use Constants, only: Zero, auToFs
use Definitions, only: wp, iwp, u6

implicit none
complex(kind=wp), intent(in) :: densityt_time(:,:)
real(kind=wp), intent(in) :: time
integer(kind=iwp) :: i, j
real(kind=wp) :: abserror

abserror = Zero
do i=1,Nstate
  do j=(i+1),Nstate
    if ((abs(real(densityt_time(i,j))-real(densityt_time(j,i))) >= threshold) .and. &
        (abs(real(densityt_time(i,j))-real(densityt_time(j,i))) >= abserror)) then
      abserror = abs(real(densityt_time(i,j))-real(densityt_time(j,i)))
    end if
    if ((abs(aimag(densityt_time(i,j))+aimag(densityt_time(j,i))) >= threshold) .and. &
        (abs(aimag(densityt_time(i,j))+aimag(densityt_time(j,i))) >= abserror)) then
      abserror = abs(aimag(densityt_time(i,j))+aimag(densityt_time(j,i)))
    end if
  end do
end do
if (abserror >= threshold) then
  write(u6,'(2(a,1x,g28.16,1x))') 'time=',time*auToFs,'error=',abserror
end if

end subroutine test_rho

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PolPrep(iDist,iDistIm,xx,yy,zz,rr3,xxi,yyi,zzi,Gri
     &                  ,iCNum,nSize)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "WrkSpc.fh"

      Dimension xx(nSize,nSize),yy(nSize,nSize),zz(nSize,nSize)
      Dimension rr3(nSize,nSize),xxi(nSize,nSize),yyi(nSize,nSize)
      Dimension zzi(nSize,nSize),Gri(nSize,nSize)
*----------------------------------------------------------------------*
* Simply compute some vectors etc. for the ensuing polarization        *
* calculation.                                                         *
*----------------------------------------------------------------------*
      ncParm=ncent*npart-ncent*icNum
      Do 711, i=nPol*iCNum+1,nPol*nPart  !Loop over solvent polar-
        Do 712, j=nPol*iCNum+1,nPol*nPart  !ization sites.
          rr3(i,j)=0
712     Continue
711   Continue
      IndTr1=0
      !If (iCNum+1).eq.nPart this loop will not be run, but that is
      !okey since then we only have one solvent and thus it can not
      !experience any field from other solvent molecules.
      Do 721, i=1,nPol
        Indp1=i+iCnum*nPol
        Indco1=i+iCNum*nCent
        Do 722, j=iCnum+2,nPart
          IndP1=IndP1+nPol
          IndCo1=IndCo1+nCent
          IndTr=((j-(iCnum+2))*(j-(iCNum+1)))/2*nCent**2+(i-1)*nCent
          Do 723, k=1,nPol
            IndP2=k+(iCnum-1)*nPol
            IndCo2=k+(iCNum-1)*nCent
            Do 724, l=iCnum+1,j-1
              IndTr1=Indtr1+1
              Indp2=Indp2+nPol
              Indco2=Indco2+nCent
              IndTri=IndTr+(l-(iCnum+1))*nCent**2+k
              xx(Indp1,Indp2)=(Cordst(indco1,1)-Cordst(indco2,1))
     &                       *Work(iDist+indtri-1)
              yy(Indp1,Indp2)=(Cordst(indco1,2)-Cordst(indco2,2))
     &                       *Work(iDist+indtri-1)
              zz(Indp1,Indp2)=(Cordst(indco1,3)-Cordst(indco2,3))
     &                       *Work(iDist+indtri-1)
              rr3(IndP1,IndP2)=Work(iDist+Indtri-1)**3
       !Why should xx(indp2,indp1)=xx(indp1,indp2), you wonder, should
       !they not be of different sign? The answer is, it does not
       !matter. Recall that the formula for the field from an ideal
       !dipole change sign two times, thus no time in effect, when
       !the sign of the r-vector is changed.
              xx(Indp2,Indp1)=xx(Indp1,Indp2)
              yy(Indp2,Indp1)=yy(Indp1,Indp2)
              zz(Indp2,Indp1)=zz(Indp1,Indp2)
              rr3(Indp2,Indp1)=rr3(Indp1,Indp2)
724         Continue
723       Continue
722     Continue
721   Continue
      Do 725, ii=1,nSize
        Do 726, jj=1,nSize
          Gri(ii,jj)=0
726     Continue
725   Continue
      Do 731, i=1,nPol
        k=i+(iCnum-1)*nCent
        Do 732, i1=iCnum+1,nPart
          k=k+nCent
          imd=(i1-1)*nPol+i
          Do 733, j=1,nPol
            l=j+(iCnum-1)*nCent
            jnd=((i1-(iCnum+1))*nCent+i-1)*ncparm+j-nCent
            Do 734, j1=iCnum+1,nPart
              l=l+nCent
              ild=(j1-1)*nPol+j
              jnd=jnd+nCent
              Gri(imd,ild)=Work(iDistIm+jnd-1)
          xxi(imd,ild)=(Cordim(k,1)-Cordst(l,1))*Work(iDistIm+jnd-1)
          yyi(imd,ild)=(Cordim(k,2)-Cordst(l,2))*Work(iDistIm+jnd-1)
          zzi(imd,ild)=(Cordim(k,3)-Cordst(l,3))*Work(iDistIm+jnd-1)
734         Continue
733       Continue
732     Continue
731   Continue

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE MFAIBJ(JSY,INDEX,C,S,ABIJ,AIBJ,AJBI,BUFIN,IBUFIN,A,B,
     &                  F,FSEC,W,THET,ENP,EPP,NII)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION JSY(*),INDEX(*),C(*),S(*),ABIJ(*),AIBJ(*),AJBI(*)
      DIMENSION BUFIN(*),IBUFIN(*),A(*),B(*),F(*),FSEC(*),W(*)
      DIMENSION THET(NII,NII),ENP(*),EPP(*)
      DIMENSION IPOF(9),IPOA(9),IPOB(9)
      PARAMETER (IPOW5=2**5,IPOW13=2**13,IPOW18=2**18)
      PARAMETER (IPOW10=2**10)
*
      JSYM(L)=JSUNP_CPF(JSY,L)
*
      ITYP   = 0 ! dummy initialize
      ICOUP  = 0 ! dummy initialize
      ICOUP1 = 0 ! dummy initialize
      INUM=IRC(4)-IRC(3)
      CALL MPSQ2(C,S,W,MUL,INDEX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)
      NVT=IROW(NVIRT+1)
      ICHK=0
      IFAB=0
      NOVST=LN*NVIRT+1+NVT
      LBUF0=RTOI*LBUF
      LBUF1=LBUF0+LBUF+1
      LBUF2=LBUF1+1
      NOT2=IROW(LN+1)
      IADD10=IAD10(6)
300   CALL dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
      CALL iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 300
      IF(LEN.LT.0)GO TO 350
      DO 260 II=1,LEN
      IND=ICOP1(II)
      IF(ICHK.NE.0)GO TO 460
      IF(IND.NE.0)GO TO 371
      ICHK=1
      GO TO 260
460   ICHK=0
      INDI=IND
*      NI=MOD(INDI,IPOW10)
*      NJ=MOD(INDI/IPOW10,IPOW10)
      NI=IBITS(INDI,0,10)
      NJ=IBITS(INDI,10,10)
      NSIJ=MUL(NSM(NI),NSM(NJ))
      CALL IPO_CPF(IPOF,NVIR,MUL,NSYM,NSIJ,-1)
      IJ1=IROW(NI)+NJ
      ILIM=IPOF(NSYM+1)
      CALL FZERO(ABIJ,ILIM)
      CALL FZERO(AIBJ,ILIM)
      CALL FZERO(AJBI,ILIM)
      IF(ITER.EQ.1)GO TO 207
C     READ (AB/IJ) INTEGRALS
      IADR=LASTAD(NOVST+IJ1)
      JTURN=0
201   CALL iDAFILE(Lu_TiABIJ,2,IBUFIN,LBUF2,IADR)
      LENGTH=IBUFIN(LBUF1)
      IADR=IBUFIN(LBUF2)
      IF(LENGTH.EQ.0)GO TO 209
      IF(JTURN.EQ.1)GO TO 203
      CALL SCATTER(LENGTH,ABIJ,IBUFIN(LBUF0+1),BUFIN)
      GO TO 209
203   CALL SCATTER(LENGTH,AIBJ,IBUFIN(LBUF0+1),BUFIN)
209   IF(IADR.EQ.-1) GO TO 206
      GO TO 201
206   IF(JTURN.EQ.1)GO TO 360
C     READ (AI/BJ) INTEGRALS
207   IADR=LASTAD(NOVST+NOT2+IJ1)
      JTURN=1
      GO TO 201
C     CONSTRUCT FIRST ORDER MATRICES
360   FAC=D1/D2
      IF(NI.NE.NJ)FAC=D2*FAC
      IN=0
      IFT=0
      CALL IPO_CPF(IPOA,NVIR,MUL,NSYM,NSIJ,IFT)
852   DO 170 IASYM=1,NSYM
      IBSYM=MUL(NSIJ,IASYM)
      IF(IBSYM.GT.IASYM)GO TO 170
      IAB=IPOA(IASYM+1)-IPOA(IASYM)
      IF(IAB.EQ.0)GO TO 170
      CALL SECORD(AIBJ(IPOF(IASYM)+1),AIBJ(IPOF(IBSYM)+1),
     *FSEC(IN+1),FAC,NVIR(IASYM),NVIR(IBSYM),NSIJ,IFT)
      IN=IN+IAB
170   CONTINUE
      IF(IFT.EQ.1)GO TO 853
      INS=IN
      IFT=1
      FAC=D0
      GO TO 852
C     SQARE ABIJ
853   IF(ITER.EQ.1)GO TO 260
      DO 370 IASYM=1,NSYM
      IF(NVIR(IASYM).EQ.0)GO TO 370
      IBSYM=MUL(NSIJ,IASYM)
      IF(NVIR(IBSYM).EQ.0)GO TO 370
      IPF=IPOF(IASYM)+1
      IPF1=IPOF(IBSYM)+1
      IF(IASYM.GT.IBSYM)GO TO 369
      IF(NSIJ.NE.1)GO TO 361
      CALL SQUAR2_CPF(ABIJ(IPF),NVIR(IASYM))
      IF(NI.NE.NJ)GO TO 368
      CALL SQUAR2_CPF(AIBJ(IPF),NVIR(IASYM))
368   CALL MTRANS_CPF(AIBJ(IPF),AJBI(IPF),NVIR(IASYM),NVIR(IBSYM))
      GO TO 370
361   CALL MTRANS_CPF(ABIJ(IPF1),ABIJ(IPF),NVIR(IASYM),NVIR(IBSYM))
369   CALL MTRANS_CPF(AIBJ(IPF1),AJBI(IPF),NVIR(IASYM),NVIR(IBSYM))
370   CONTINUE
      GO TO 260
371   IF(IFAB.EQ.1)GO TO 262
CPAM97      IFAB=IAND(IND,1)
CPAM97      ITURN=IAND(ISHFT(IND,-1),1)
CPAM97      ITYP=IAND(ISHFT(IND,-2),7)
CPAM97      ICOUP=IAND(ISHFT(IND,-5),8191)
CPAM97      ICOUP1=IAND(ISHFT(IND,-18),8191)
*      IFAB=MOD(IND,2)
*      ITURN=MOD(IND/2,2)
*      ITYP=MOD(IND/4,8)
*      ICOUP=MOD(IND/IPOW5,IPOW13)
*      ICOUP1=MOD(IND/IPOW18,IPOW13)
      IFAB=IBITS(IND, 0,1)
      ITURN=IBITS(IND,1,1)
      ITYP=IBITS(IND,2,3)
      ICOUP=IBITS(IND,5,13)
      ICOUP1=IBITS(IND,18,13)
      CPL=COP(II)
      CPLA=D0
      IF(IFAB.NE.0)GO TO 260
      IF(ITURN.EQ.0)GO TO 263
      GO TO 100
262   CPLA=COP(II)
      IFAB=0
      GO TO 100
C     FIRST ORDER INTERACTION
263   INDA=ICOUP
      INDB=IRC(ITYP+1)+ICOUP1
      ISTAR=1
      IF(ITYP.EQ.1)ISTAR=INS+1
      IF(INS.EQ.0)GO TO 260
      IF(INDA.NE.IREF0)GO TO 342
      CPLL=CPL/SQRT(ENP(INDB))
      CALL DAXPY_(INS,CPLL,FSEC(ISTAR),1,S(INDEX(INDB)+1),1)
      IF(ITER.EQ.1)GO TO 260
      TERM=DDOT_(INS,C(INDEX(INDB)+1),1,FSEC(ISTAR),1)
      EPP(INDB)=EPP(INDB)+CPLL*TERM
      GO TO 260
342   ENPQ=(D1-THET(INDA,INDB)/D2)*(ENP(INDA)+ENP(INDB)-D1)+
     *THET(INDA,INDB)/D2
      FACS=SQRT(ENP(INDA))*SQRT(ENP(INDB))/ENPQ
      FACW=FACS*(D2-THET(INDA,INDB))/ENPQ
      FACWA=FACW*ENP(INDA)-FACS
      FACWB=FACW*ENP(INDB)-FACS
      COPI=CPL*C(INDA)
      CALL DAXPY_(INS,COPI*FACS,FSEC(ISTAR),1,S(INDEX(INDB)+1),1)
      CALL DAXPY_(INS,COPI*FACWB,FSEC(ISTAR),1,W(INDEX(INDB)+1),1)
      TERM=DDOT_(INS,FSEC(ISTAR),1,C(INDEX(INDB)+1),1)
      S(INDA)=S(INDA)+CPL*FACS*TERM
      W(INDA)=W(INDA)+CPL*FACWA*TERM
      GO TO 260
C     INTERACTIONS BETWEEN DOUBLES AND
C     INTERACTIONS BETWEEN SINGLES
100   IF(ITER.EQ.1)GO TO 260
C     CALL JTIME(IST)
      IFTA=0
      IFTB=0
      GO TO (109,110,111,112,113),ITYP
109   INDA=IRC(2)+ICOUP1
      INDB=IRC(2)+ICOUP
      IFTA=1
      IFTB=1
      GO TO 115
110   INDA=IRC(3)+ICOUP1
      INDB=IRC(3)+ICOUP
      GO TO 115
111   INDA=IRC(2)+ICOUP1
      INDB=IRC(3)+ICOUP
      IFTA=1
      GO TO 115
112   INDA=IRC(3)+ICOUP1
      INDB=IRC(2)+ICOUP
      IFTB=1
      GO TO 115
113   INDA=IRC(1)+ICOUP1
      INDB=IRC(1)+ICOUP
115   MYSYM=JSYM(INDA)
      NYSYM=MUL(MYSYM,NSIJ)
      MYL=MUL(MYSYM,LSYM)
      NYL=MUL(NYSYM,LSYM)
      ENPQ=(D1-THET(INDA,INDB)/D2)*(ENP(INDA)+ENP(INDB)-D1)+
     *THET(INDA,INDB)/D2
      FACS=SQRT(ENP(INDA))*SQRT(ENP(INDB))/ENPQ
      FACW=FACS*(D2-THET(INDA,INDB))/ENPQ
      FACWA=FACW*ENP(INDA)-FACS
      FACWB=FACW*ENP(INDB)-FACS
      CALL IPO_CPF(IPOA,NVIR,MUL,NSYM,MYL,IFTA)
      CALL IPO_CPF(IPOB,NVIR,MUL,NSYM,NYL,IFTB)
      INMY=INDEX(INDA)+1
      INNY=INDEX(INDB)+1
      IF(ITYP.NE.5)GO TO 71
C     DOUBLET-DOUBLET INTERACTIONS
      IN=IPOF(MYL+1)-IPOF(MYL)
      IF(IN.EQ.0)GO TO 260
      IPF=IPOF(MYL)+1
      CALL SETZ(F,IN)
      CALL DAXPY_(IN,CPL,AIBJ(IPF),1,F,1)
      CALL DAXPY_(IN,CPLA,ABIJ(IPF),1,F,1)
      IF(INDA.EQ.INDB)CALL SETZZ_CPF(F,NVIR(MYL))
      CALL SETZ(A,NVIR(NYL))
      CALL FMMM(C(INMY),F,A,1,NVIR(NYL),NVIR(MYL))
      CALL DAXPY_(NVIR(NYL),FACS,A,1,S(INNY),1)
      CALL DAXPY_(NVIR(NYL),FACWB,A,1,W(INNY),1)
      IF(INDA.EQ.INDB)GO TO 260
      CALL SETZ(A,NVIR(MYL))
      CALL FMMM(F,C(INNY),A,NVIR(MYL),1,NVIR(NYL))
      CALL DAXPY_(NVIR(MYL),FACS,A,1,S(INMY),1)
      CALL DAXPY_(NVIR(MYL),FACWA,A,1,W(INMY),1)
      GO TO 260
C     TRIPLET-SINGLET , SINGLET-TRIPLET ,
C     TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
71    DO 70 IASYM=1,NSYM
      IAB=IPOF(IASYM+1)-IPOF(IASYM)
      IF(IAB.EQ.0)GO TO 70
      ICSYM=MUL(MYL,IASYM)
      IBSYM=MUL(NYL,ICSYM)
      IF(INDA.EQ.INDB.AND.IBSYM.GT.IASYM)GO TO 70
      IF(NVIR(ICSYM).EQ.0)GO TO 70
      NAC=NVIR(IASYM)*NVIR(ICSYM)
      NBC=NVIR(IBSYM)*NVIR(ICSYM)
      IF(ICSYM.GE.IASYM)GO TO 31
      IF(ICSYM.GE.IBSYM)GO TO 32
C     CASE 1 , IASYM > ICSYM AND IBSYM > ICSYM
      IPF=IPOF(IASYM)+1
      CALL SETZ(F,IAB)
      CALL DAXPY_(IAB,CPL,AIBJ(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      IF(INDA.EQ.INDB)CALL SETZZ_CPF(F,NVIR(IASYM))
      CALL SETZ(A,NBC)
      CALL FMMM(C(INMY+IPOA(IASYM)),F,A,NVIR(ICSYM),
     *NVIR(IBSYM),NVIR(IASYM))
      CALL DAXPY_(NBC,FACS,A,1,S(INNY+IPOB(IBSYM)),1)
      CALL DAXPY_(NBC,FACWB,A,1,W(INNY+IPOB(IBSYM)),1)
      IF(INDA.EQ.INDB)GO TO 70
      IPF=IPOF(IBSYM)+1
      CALL SETZ(F,IAB)
      CALL DAXPY_(IAB,CPL,AJBI(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      CALL SETZ(A,NAC)
      CALL FMMM(C(INNY+IPOB(IBSYM)),F,A,NVIR(ICSYM),
     *NVIR(IASYM),NVIR(IBSYM))
      CALL DAXPY_(NAC,FACS,A,1,S(INMY+IPOA(IASYM)),1)
      CALL DAXPY_(NAC,FACWA,A,1,W(INMY+IPOA(IASYM)),1)
      GO TO 70
C     CASE 2 , IASYM > ICSYM AND ICSYM > OR = IBSYM
32    IPF=IPOF(IBSYM)+1
      CALL SETZ(F,IAB)
      CALL DAXPY_(IAB,CPL,AJBI(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      CALL MTRANS_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM),NVIR(ICSYM))
      CALL SETZ(B,NBC)
      CALL FMMM(F,A,B,NVIR(IBSYM),NVIR(ICSYM),NVIR(IASYM))
      IF(NYL.NE.1)GO TO 35
      CALL SETZ(A,NBC)
      CALL DAXPY_(NBC,FACS,B,1,A,1)
      IF(IFTB.EQ.1)GO TO 134
      CALL SIADD_CPF(A,S(INNY+IPOB(ICSYM)),NVIR(IBSYM))
      CALL SETZ(A,NBC)
      CALL DAXPY_(NBC,FACWB,B,1,A,1)
      CALL SIADD_CPF(A,W(INNY+IPOB(ICSYM)),NVIR(IBSYM))
      CALL SQUAR_CPF(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM))
      GO TO 36
134   CALL TRADD_CPF(A,S(INNY+IPOB(ICSYM)),NVIR(IBSYM))
      CALL SETZ(A,NBC)
      CALL DAXPY_(NBC,FACWB,B,1,A,1)
      CALL TRADD_CPF(A,W(INNY+IPOB(ICSYM)),NVIR(IBSYM))
      CALL SQUARN_CPF(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM))
      GO TO 36
35    IF(IFTB.EQ.1)GO TO 135
      CALL DAXPY_(NBC,FACS,B,1,S(INNY+IPOB(ICSYM)),1)
      CALL DAXPY_(NBC,FACWB,B,1,W(INNY+IPOB(ICSYM)),1)
      GO TO 136
135   CALL DAXPY_(NBC,-FACS,B,1,S(INNY+IPOB(ICSYM)),1)
      CALL DAXPY_(NBC,-FACWB,B,1,W(INNY+IPOB(ICSYM)),1)
136   CALL MTRANS_CPF(C(INNY+IPOB(ICSYM)),A,NVIR(ICSYM),NVIR(IBSYM))
      IF(IFTB.EQ.1)CALL VNEG_CPF(A,1,A,1,NBC)
36    CALL SETZ(B,NAC)
      CALL FMMM(A,F,B,NVIR(ICSYM),NVIR(IASYM),NVIR(IBSYM))
      CALL DAXPY_(NAC,FACS,B,1,S(INMY+IPOA(IASYM)),1)
      CALL DAXPY_(NAC,FACWA,B,1,W(INMY+IPOA(IASYM)),1)
      GO TO 70
31    IF(ICSYM.GE.IBSYM)GO TO 33
C     CASE 3 , ICSYM > OR = IASYM AND IBSYM > ICSYM
      IPF=IPOF(IASYM)+1
      CALL SETZ(F,IAB)
      CALL DAXPY_(IAB,CPL,AIBJ(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      IF(MYL.NE.1)GO TO 39
      IF(IFTA.EQ.0)CALL SQUAR_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      IF(IFTA.EQ.1)CALL SQUARN_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      GO TO 40
39    CALL MTRANS_CPF(C(INMY+IPOA(ICSYM)),A,NVIR(ICSYM),NVIR(IASYM))
      IF(IFTA.EQ.1)CALL VNEG_CPF(A,1,A,1,NAC)
40    CALL SETZ(B,NBC)
      CALL FMMM(A,F,B,NVIR(ICSYM),NVIR(IBSYM),NVIR(IASYM))
      CALL DAXPY_(NBC,FACS,B,1,S(INNY+IPOB(IBSYM)),1)
      CALL DAXPY_(NBC,FACWB,B,1,W(INNY+IPOB(IBSYM)),1)
      CALL MTRANS_CPF(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM),NVIR(ICSYM))
      CALL SETZ(B,NAC)
      CALL FMMM(F,A,B,NVIR(IASYM),NVIR(ICSYM),NVIR(IBSYM))
      IF(MYL.NE.1)GO TO 46
      CALL SETZ(A,NAC)
      CALL DAXPY_(NAC,FACS,B,1,A,1)
      IF(IFTA.EQ.1)GO TO 146
      CALL SIADD_CPF(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
      CALL SETZ(A,NAC)
      CALL DAXPY_(NAC,FACWA,B,1,A,1)
      CALL SIADD_CPF(A,W(INMY+IPOA(IASYM)),NVIR(IASYM))
      GO TO 70
146   CALL TRADD_CPF(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
      CALL SETZ(A,NAC)
      CALL DAXPY_(NAC,FACWA,B,1,A,1)
      CALL TRADD_CPF(A,W(INMY+IPOA(IASYM)),NVIR(IASYM))
      GO TO 70
46    IF(IFTA.EQ.1)GO TO 1146
      CALL DAXPY_(NAC,FACS,B,1,S(INMY+IPOA(ICSYM)),1)
      CALL DAXPY_(NAC,FACWA,B,1,W(INMY+IPOA(ICSYM)),1)
      GO TO 70
1146  CALL DAXPY_(NAC,-FACS,B,1,S(INMY+IPOA(ICSYM)),1)
      CALL DAXPY_(NAC,-FACWA,B,1,W(INMY+IPOA(ICSYM)),1)
      GO TO 70
C     CASE 4 , ICSYM > OR = IASYM AND ICSYM > OR = IBSYM
33    IPF=IPOF(IBSYM)+1
      CALL SETZ(F,IAB)
      CALL DAXPY_(IAB,CPL,AJBI(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      IF(INDA.EQ.INDB)CALL SETZZ_CPF(F,NVIR(IASYM))
      IF(MYL.NE.1)GO TO 41
      IF(IFTA.EQ.0)CALL SQUAR_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      IF(IFTA.EQ.1)CALL SQUARM_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      GO TO 42
41    IF(IFTA.EQ.0)CALL DCOPY_(NAC,C(INMY+IPOA(ICSYM)),1,A,1)
      IF(IFTA.EQ.1)CALL VNEG_CPF(C(INMY+IPOA(ICSYM)),1,A,1,NAC)
42    CALL SETZ(B,NBC)
      CALL FMMM(F,A,B,NVIR(IBSYM),NVIR(ICSYM),NVIR(IASYM))
      IF(NYL.NE.1)GO TO 43
      CALL SETZ(A,NBC)
      CALL DAXPY_(NBC,FACS,B,1,A,1)
      IF(IFTB.EQ.1)GO TO 143
      CALL SIADD_CPF(A,S(INNY+IPOB(ICSYM)),NVIR(IBSYM))
      CALL SETZ(A,NBC)
      CALL DAXPY_(NBC,FACWB,B,1,A,1)
      CALL SIADD_CPF(A,W(INNY+IPOB(ICSYM)),NVIR(IBSYM))
      GO TO 44
143   CALL TRADD_CPF(A,S(INNY+IPOB(ICSYM)),NVIR(IBSYM))
      CALL SETZ(A,NBC)
      CALL DAXPY_(NBC,FACWB,B,1,A,1)
      CALL TRADD_CPF(A,W(INNY+IPOB(ICSYM)),NVIR(IBSYM))
      GO TO 44
43    IF(IFTB.EQ.1)GO TO 144
      CALL DAXPY_(NBC,FACS,B,1,S(INNY+IPOB(ICSYM)),1)
      CALL DAXPY_(NBC,FACWB,B,1,W(INNY+IPOB(ICSYM)),1)
      GO TO 44
144   CALL DAXPY_(NBC,-FACS,B,1,S(INNY+IPOB(ICSYM)),1)
      CALL DAXPY_(NBC,-FACWB,B,1,W(INNY+IPOB(ICSYM)),1)
44    IF(INDA.EQ.INDB)GO TO 70
      IPF=IPOF(IASYM)+1
      CALL SETZ(F,IAB)
      CALL DAXPY_(IAB,CPL,AIBJ(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      IF(NYL.NE.1)GO TO 37
      IF(IFTB.EQ.0)CALL SQUAR_CPF(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM))
      IF(IFTB.EQ.1)CALL SQUARM_CPF(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM))
      GO TO 38
37    IF(IFTB.EQ.0)CALL DCOPY_(NBC,C(INNY+IPOB(ICSYM)),1,A,1)
      IF(IFTB.EQ.1)CALL VNEG_CPF(C(INNY+IPOB(ICSYM)),1,A,1,NBC)
38    CALL SETZ(B,NAC)
      CALL FMMM(F,A,B,NVIR(IASYM),NVIR(ICSYM),NVIR(IBSYM))
      IF(MYL.NE.1)GO TO 45
      CALL SETZ(A,NAC)
      CALL DAXPY_(NAC,FACS,B,1,A,1)
      IF(IFTA.EQ.1)GO TO 145
      CALL SIADD_CPF(A,S(INMY+IPOA(ICSYM)),NVIR(IASYM))
      CALL SETZ(A,NAC)
      CALL DAXPY_(NAC,FACWA,B,1,A,1)
      CALL SIADD_CPF(A,W(INMY+IPOA(ICSYM)),NVIR(IASYM))
      GO TO 70
145   CALL TRADD_CPF(A,S(INMY+IPOA(ICSYM)),NVIR(IASYM))
      CALL SETZ(A,NAC)
      CALL DAXPY_(NAC,FACWA,B,1,A,1)
      CALL TRADD_CPF(A,W(INMY+IPOA(ICSYM)),NVIR(IASYM))
      GO TO 70
45    IF(IFTA.EQ.1)GO TO 147
      CALL DAXPY_(NAC,FACS,B,1,S(INMY+IPOA(ICSYM)),1)
      CALL DAXPY_(NAC,FACWA,B,1,W(INMY+IPOA(ICSYM)),1)
      GO TO 70
147   CALL DAXPY_(NAC,-FACS,B,1,S(INMY+IPOA(ICSYM)),1)
      CALL DAXPY_(NAC,-FACWA,B,1,W(INMY+IPOA(ICSYM)),1)
70    CONTINUE
260   CONTINUE
      GO TO 300
350   CALL MDSQ2(C,S,W,MUL,INDEX,JSY,NDIAG,INUM,IRC(3),
     *LSYM,NVIRT,SQ2)
C      NCONF=JSC(4)
C      WRITE(6,787)(S(I),I=1,NCONF)
C  787 FORMAT(1X,'S,FAIBJ',5F10.6)
C      WRITE(6,786)(W(I),I=1,NCONF)
C  786 FORMAT(1X,'W,FAIBJ',5F10.6)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine setjobiph_cvb(iorcore_c,iorclos_c,iorocc_c,mxirrep,
     >  nstsym_c,weight_c,istnel_c,istsy_c,istms2_c,nstats_c,
     >  mxstt_ci,mxstsy_ci,nel_c,norb_c,i2s_c,isym_c,mcore_c,neltot_c)
      implicit real*8 (a-h,o-z)
#include "rasdim.fh"
#include "jobiph_j.fh"
      dimension iorcore_c(mxirrep),iorclos_c(mxirrep),iorocc_c(mxirrep)
      dimension weight_c(mxstt_ci,mxstsy_ci)
      dimension istnel_c(mxstsy_ci),istsy_c(mxstsy_ci)
      dimension istms2_c(mxstsy_ci),nstats_c(mxstsy_ci)

c  Orbitals  --  OCC, CLOSED and CORE cards
      call imove_cvb(nfro_j,iorcore_c,mxirrep)
      call imove_cvb(nish_j,iorclos_c,mxirrep)
      call imove_cvb(nrs2_j,iorocc_c,mxirrep)
c  States  --  WF, STATE and WEIGHT cards
      nstsym_c=1
      call fzero(weight_c,mxstt_ci*mxstsy_ci)
      do i=1,lroots_j
      wgt=0.0d0
      do j=1,nroots_j
      if (iroot_j(j).eq.i) wgt=weight_j(j)
      end do
      if(wgt.ne.0d0)then
        if(i.gt.mxstt_ci)then
        write(6,*)' Root number too large in casrecov_cvb :',i,mxstt_ci
          call abend_cvb()
        endif
      endif
      weight_c(i,1)=wgt
      enddo

      istnel_c(1)=nactel_j
      istsy_c(1)=lsym_j
      istms2_c(1)=ispin_j-1
      nstats_c(1)=lroots_j
c  Set derived info
      nel_c=nactel_j
      i2s_c=ispin_j-1
      isym_c=lsym_j
      norb_c=0
      mcore_c=0
      do i=1,mxstsy_ci
      norb_c=norb_c+nrs2_j(i)
      mcore_c=mcore_c+nfro_j(i)+nish_j(i)
      enddo
      neltot_c=nel_c+2*mcore_c
c  MO common block :
      call setmocom_cvb()
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Read_v(lunit,work,istrt,iend,inc,ierr)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lUnit, iStrt, iEnd, Inc
real(kind=wp), intent(inout) :: work(iend)
integer(kind=iwp), intent(out) :: iErr
integer(kind=iwp) :: i, istatus

ierr = 0
read(lunit,*,iostat=istatus) (work(istrt+i),i=0,iend-istrt,inc)
if (istatus > 0) ierr = 1

return

end subroutine Read_v

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine f02agf(a,ia,n,rr,ri,vr,ivr,vi,ivi,intger,ifail)

use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ia, n, ivr, ivi, ifail
real(kind=wp), intent(inout) :: a(ia,*)
real(kind=wp), intent(_OUT_) :: rr(*), ri(*), vr(ivr,*), vi(ivi,*)
integer(kind=iwp), intent(_OUT_) :: intger(*)
integer(kind=iwp) :: info, k
logical(kind=iwp) :: pair
real(kind=wp), parameter :: thresh = 1.0e-8_wp

if (ifail /= 0) call SysHalt('ifail f02agf')

if ((ia /= ivr) .or. (ia /= ivi)) call SysHalt('f02agf dim')
call rg(ia,n,a,rr,ri,1,vr,intger,vi,info)
if (info /= 0) call SysHalt('info f02agf')
vi(:,1:n) = Zero
pair = .false.
do k=1,n-1
  if ((ri(k) /= Zero) .and. (.not. pair)) then
    if (rr(k) /= rr(k+1)) call SysHalt('rr trouble')
    if (abs(ri(k)+ri(k+1)) > 1.0e-12_wp) call SysHalt('ri trouble')
    pair = .true.
    ! If eig value almost real: return real value & vectors:
    if (abs(ri(k)) <= thresh) then
      ri(k) = Zero
      ri(k+1) = Zero
    else
      vi(1:n,k) = vr(1:n,k+1)
      vi(1:n,k+1) = -vr(1:n,k+1)
      vr(1:n,k+1) = vr(1:n,k)
    end if
  else
    pair = .false.
  end if
end do

end subroutine f02agf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
#include "compiler_features.h"

#ifdef _EFP_

! File from the EFP submodule
#include "efp.f90"

#elif !defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
module EFP
contains
dummy_empty_procedure(efp_mod)
end module EFP

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      CHARACTER*40 FUNCTION RDNAME (LUT,KEYW)
C
C...  reads a character item up wherever it is in a file in the form
C     ITEM_NAME  value
C
C     Returns ' ' when it fails to read the item up.
C
C       LUT       logical unit to be searched
C                 LUT>0 for formatted files, LUT<0 for unformatted files
C       KEYW         keyword
C
      INTEGER      LU,LUT
      CHARACTER*40 KEYW,VALUE,PIKNAM
      CHARACTER*80 LINE,BLANK
      LOGICAL      UNFORM
      EXTERNAL     PIKNAM
      BLANK =            '                                        '
      BLANK =BLANK(:40)//'                                        '
C
      IF (LUT.GT.0) THEN
        UNFORM=.FALSE.
        LU=LUT
      ELSE IF (LUT.LT.0) THEN
        UNFORM=.TRUE.
        LU=-LUT
C       if not IBM: no error messages for reading short records
      Else
        LU=0
        UNFORM=.TRUE.
        Write (6,*) 'RdName: LUT=0!'
        Call Abend
      ENDIF
C
      REWIND LU
1     CONTINUE
        IF (UNFORM) THEN
C...      unformatted files
          LINE=BLANK
          READ (LU,END=999)          LINE
          NOFB=MYLEN(LINE)
          IF (NOFB.EQ.0) NOFB=1
          IF (NOFB.LT.80) LINE=LINE(1:NOFB)
        ELSE
C...      formatted files
          READ (LU,'(A80)',END=999) LINE
        ENDIF
        VALUE=PIKNAM(LINE,KEYW)
        IF (VALUE.EQ.' ') GO TO 1
C
C...  the item has been found
      RDNAME=VALUE
      RETURN
C
C...  the item has not been found in the file
999   CONTINUE
      RDNAME=VALUE
      RETURN
C
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Jonas Bostrom                                    *
************************************************************************
      SubRoutine ChoMP2_Dens_Setup(ip_CMO_Reord,CMO,EOcc,EVir)
C
C     Jonas Bostrom, May. 2008.
C
C     Purpose: Allocate memory and setup pointers and prepare to calculate
C              mp2-densities
C
#include "implicit.fh"
      Dimension CMO(*), EOcc(*), EVir(*)
#include "WrkSpc.fh"
#include "chomp2.fh"
#include "cholesky.fh"
#include "choorb.fh"
*
      Character*17 SecNam
      Parameter (SECNAM = 'ChoMP2_Dens_Setup')
*
      lCMO = 0
      Do iSym = 1, nSym
         lCMO = lCMO + nBas(iSym)*(nOrb(iSym) + nDel(iSym))
      End Do
*
      MaxVO = 0
      Do iSym = 1, nSym
         MaxVO = max(MaxVO,nFro(iSym) + nOcc(iSym))
         MaxVO = max(MaxVO,nVir(iSym) + nDel(iSym))
      End Do
      lTmpLvec = MaxVO*MaxVo
      Call GetMem('TmpLvec','Allo','Real',ip_tmpL,lTmpLvec)
*
      Call GetMem('CMO_reord','Allo','Real',ip_CMO_reord,lCMO)
      Call FZero(Work(ip_CMO_reord),lCMO)
*     Reordering of CMO, step 1 - cut occupied and virtual orbitals
*                                 into the matrix
      iSym_offset1 = 0
      iSym_offset2 = 0
      Do iSym = 1, nSym
         iOrb_offset = 0
         Do iOrb = 1, nOrb(iSym) + nDel(iSym)
            Call dCopy_(nBas(iSym),
     &                 CMO(iSym_offset1+iOrb_offset+1),1,
     &                 Work(ip_CMO_reord+iOrb-1+iSym_offset2),
     &                 nOrb(iSym)+nDel(iSym))
            iOrb_offset = iOrb_offset + nOrb(iSym) + nDel(iSym)
         End Do
         iSym_offset1 = iSym_offset1 + nBas(iSym)*
     &                 (nOrb(iSym)+nDel(iSym))
         iSym_offset2 = iSym_offset2 + nBas(iSym)*
     &                  (nOrb(iSym)+nDel(iSym))
      End Do
*
*
      l_Density = 0
      l_Mp2Lagr = 0
      l_DiaA    = 0
      Do iSym = 1, nSym
         l_Density = l_Density + (nOrb(iSym)+nDel(iSym))
     &                         * (nOrb(iSym)+nDel(iSym))
         l_Mp2Lagr = l_Mp2Lagr + (nFro(iSym) + nOcc(iSym))
     &                         * (nVir(iSym) + nDel(iSym))
         l_DiaA    = l_DiaA    + (nFro(iSym) + nOcc(iSym))
     &                         * (nVir(iSym) + nDel(iSym))
      End Do
      Call GetMem('MP2Density','Allo','Real',ip_First_Density,
     &            l_Density)
      Call GetMem('MP2WDensity','Allo','Real',ip_First_WDensity,
     &            l_Density)
      Call GetMem('MP2Lagr','Allo','Real',
     &            ip_First_Mp2Lagr, l_Mp2Lagr)
      Call GetMem('MP2DiaA','Allo','Real',
     &            ip_First_DiaA, l_DiaA)

      Call FZero(Work(ip_First_Density),    l_Density)
      Call FZero(Work(ip_First_WDensity),   l_Density)
      Call FZero(Work(ip_First_Mp2Lagr),    l_Mp2Lagr)
      Call FZero(Work(ip_First_DiaA),       l_DiaA)
*
      ip_Density(1)    = ip_First_Density
      ip_WDensity(1)   = ip_First_WDensity
      ip_Mp2Lagr(1)    = ip_First_Mp2Lagr
      ip_DiaA(1)       = ip_First_DiaA
      Do i = 1, nSym-1
         ip_Density(i+1)    = ip_Density(i)    + (nOrb(i)+nDel(i))
     &                                         * (nOrb(i)+nDel(i))
         ip_WDensity(i+i)   = ip_WDensity(i)   + (nOrb(i)+nDel(i))
     &                                         * (nOrb(i)+nDel(i))
         ip_Mp2Lagr(i+1)    = ip_Mp2Lagr(i)    + (nFro(i) +nOcc(i))
     &                                         * (nVir(i) +nDel(i))
         ip_DiaA(i+1)       = ip_DiaA(i)       + (nFro(i)+nOcc(i))
     &                                         * (nVir(i)+nDel(i))
      End Do
*
*    Allocate a vector for the orbital energies of frozen and virtual
*     frozen molecules.
      Call GetMem('EFro','Allo','Real',ip_EFroz,nFroT)
      Call GetMem('EOcc','Allo','Real',ip_EOccu,nOccT)
      Call GetMem('EVir','Allo','Real',ip_EVirt,nVirT)
      Call GetMem('EDel','Allo','Real',ip_EDele,nDelT)
*     Fill them with the right things
      Do iSym = 1, nSym
         Do i = 0, nFro(iSym)-1
            Work(ip_EFroz + iFro(iSym)+i) =
     &                    EOcc(iFro(iSym)+iOcc(iSym)+nOcc(iSym) +i+1)
         End Do
         Do i = 0, nOcc(iSym)-1
            Work(ip_EOccu + iOcc(iSym)+i) =
     &                    EOcc(iFro(iSym)+iOcc(iSym) + i+1)
         End Do
         Do i = 0, nVir(iSym)-1
            Work(ip_EVirt + iVir(iSym)+i) =
     &                    EVir(iVir(iSym)+iDel(iSym)+ i+1)
         End Do
         Do i=0, nDel(iSym)-1
            Work(ip_EDele + iDel(iSym)+i) =
     &                    EVir(iVir(iSym) + iDel(iSym) + nVir(iSym)+i+1)
         End Do
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GETINT(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,IXCHNG,IKSM,JLSM,ICOUL)
! Obtain integrals
!
!     ICOUL = 0 :
!                  XINT(IK,JL) = (IJ!KL)         for IXCHNG = 0
!                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
!
!     ICOUL = 1 :
!                  XINT(IJ,KL) = (IJ!KL)         for IXCHNG = 0
!                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
!
!     ICOUL = 2 :  XINT(IL,JK) = (IJ!KL)         for IXCHNG = 0
!                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
!
! Storing for ICOUL = 1 not working if IKSM or JLSM /= 0
!
! Version for integrals stored in TUVX
!
! If type equals zero, all integrals of given type are fetched
! (added aug 8, 98)

use Index_Functions, only: iTri
use lucia_data, only: IBSO, NOBPTS, NTOOBS
use wadr, only: TUVX
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Index_Functions, only: nTri_Elem
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: XINT(*)
integer(kind=iwp), intent(in) :: ITP, ISM, JTP, JSM, KTP, KSM, LTP, LSM, IXCHNG, IKSM, JLSM, ICOUL
integer(kind=iwp) :: I, IINT, IJKL, ILKJ, IMIN, IOFF, IORB, J, JMIN, JOFF, JORB, K, KOFF, KORB, L, LOFF, LORB
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: NI, NIK, NJ, NJL, NK, NL

!write(u6,*) ' I_USE_SIMTRH in GETINT =',I_USE_SIMTRH
write(u6,*) ' GETINT : ICOUL = ',ICOUL
write(u6,*) 'ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM :'
write(u6,'(8I4)') ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM
#endif
! Read integrals in in RASSCF format

if (ITP >= 1) then
  iOrb = NOBPTS(ITP,ISM)
else
  IORB = NTOOBS(ISM)
end if

if (JTP >= 1) then
  jOrb = NOBPTS(JTP,JSM)
else
  JORB = NTOOBS(JSM)
end if

if (KTP >= 1) then
  kOrb = NOBPTS(KTP,KSM)
else
  KORB = NTOOBS(KSM)
end if

if (LTP >= 1) then
  lOrb = NOBPTS(LTP,LSM)
else
  LORB = NTOOBS(LSM)
end if
! Offsets relative to start of all orbitals, symmetry ordered
IOFF = IBSO(ISM)+sum(NOBPTS(1:ITP-1,ISM))

JOFF = IBSO(JSM)+sum(NOBPTS(1:JTP-1,JSM))

KOFF = IBSO(KSM)+sum(NOBPTS(1:KTP-1,KSM))

LOFF = IBSO(LSM)+sum(NOBPTS(1:LTP-1,LSM))

! Collect Coulomb terms

iInt = 0
do l=lOff,lOff+lOrb-1
  jMin = jOff
  if (JLSM /= 0) jMin = l
  do j=jMin,jOff+jOrb-1
    do k=kOff,kOff+kOrb-1
      iMin = iOff
      if (IKSM /= 0) iMin = k
      if (ICOUL == 1) then
        ! Address before integral (1,j!k,l)
        IINT = (L-LOFF)*Jorb*Korb*Iorb+(K-KOFF)*Jorb*Iorb+(J-JOFF)*Iorb
      else if (ICOUL == 2) then
        ! Address before (1L,JK)
        IINT = (K-KOFF)*JORB*LORB*IORB+(J-JOFF)*LORB*IORB+(L-LOFF)*IORB
      end if

      do i=iMin,iOff+iOrb-1
        IJKL = iTri(iTri(I,J),iTri(K,L))
        ! Next line inserted by Jesper: "I don't think iInt should be the same
        ! for all i"
        iInt = iInt+1
        Xint(iInt) = TUVX(ijkl)
      end do
    end do
  end do
end do

! Collect Exchange terms

if (IXCHNG /= 0) then

  iInt = 0
  do l=lOff,lOff+lOrb-1
    jMin = jOff
    if (JLSM /= 0) jMin = l
    do j=jMin,jOff+jOrb-1
      do k=kOff,kOff+kOrb-1
        iMin = iOff
        if (IKSM /= 0) iMin = k
        if (ICOUL == 1) then
          ! Address before integral (1,j!k,l)
          IINT = (L-LOFF)*Jorb*Korb*Iorb+(K-KOFF)*Jorb*Iorb+(J-JOFF)*Iorb
        else if (ICOUL == 2) then
          ! Address before (1L,JK)
          IINT = (K-KOFF)*JORB*LORB*IORB+(J-JOFF)*LORB*IORB+(L-LOFF)*IORB
        end if

        do i=iMin,iOff+iOrb-1
          ILKJ = iTri(iTri(I,L),iTri(K,J))
          iInt = iInt+1
          XInt(iInt) = XInt(iInt)-TUVX(ilkj)
        end do
      end do
    end do
  end do
end if

#ifdef _DEBUGPRINT_
if (ITP == 0) then
  NI = NTOOBS(ISM)
else
  NI = NOBPTS(ITP,ISM)
end if

if (KTP == 0) then
  NK = NTOOBS(KSM)
else
  NK = NOBPTS(KTP,KSM)
end if

if (IKSM == 0) then
  NIK = NI*NK
else
  NIK = nTri_Elem(NI)
end if

if (JTP == 0) then
  NJ = NTOOBS(JSM)
else
  NJ = NOBPTS(JTP,JSM)
end if

if (LTP == 0) then
  NL = NTOOBS(LSM)
else
  NL = NOBPTS(LTP,LSM)
end if

if (JLSM == 0) then
  NJL = NJ*NL
else
  NJL = nTri_Elem(NJ)
end if
write(u6,*) ' 2 electron integral block for TS blocks'
write(u6,*) ' Ixchng :',IXCHNG
write(u6,*) ' After GETINC'
write(u6,'(1X,4(A,I2,A,I2,A))') '(',ITP,',',ISM,')','(',JTP,',',JSM,')','(',KTP,',',KSM,')','(',LTP,',',LSM,')'
call WRTMAT(XINT,NIK,NJL,NIK,NJL)
#endif

end subroutine GETINT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*
! SVC-20120305: This is a new parallel version of the SGM subroutine.
! Instead of the full array Y, distributed array indices lg_Y is passed,
! which refer to distributed arrays.

! Currently, only case H will be passed as a distributed array, since
! this is the largest array (about a factor of NI larger than case G)
! and it avoids communications of this array: if it is updated, we use
! only the local chunk. If is is used to update another case, that case
! is partially updated and then communicated.  The special routines are
! called MLTR1_GH, MLTR1_EH and MLTSCA_DH.

! The distributed arrays are (currently) layed out as 2-dimensional
! distributed arrays, with NAS rows and NIS columns (see subroutine
! RHS_ALLO in file par_rhs). The chunks are along the column indices,
! so each chunk has all the row indices (full columns).

subroutine SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,X1,nX1,X2,nX2,lg_Y,LIST,mList)

use Symmetry_Info, only: Mul
use Fockof, only: FAI, FAT, FIA, FIT, FTA, FTI, IOFFIA
use EQSOLV, only: IfCoup, LList, nList
use Sigma_data, only: INCF1, INCF2, INCX1, INCX2, INCX3, INCY1, INCY2, INCY3, LEN1, LEN2, nLst1, nLst2, Val1, Val2
use fake_GA, only: GA_Arrays
use caspt2_module, only: nAGEB, nAGTB, nAsh, nASUP, nIGEJ, nIGTJ, nIsh, nISUP, nSSh, nSym, nTGEU, nTGEU, nTGTU, nTUV
#ifdef _DEBUGPRINT_
use caspt2_module, only: Cases
#endif
use Constants, only: One, Two, Three, Six, Half, OneHalf
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IMLTOP, ISYM1, ICASE1, ISYM2, ICASE2, nX1, nX2, mList, LIST(mLIST)
real(kind=wp), intent(inout) :: X1(nX1), X2(nX2)
integer(kind=iwp) :: ICD, ICEM, ICEP, ICGM, ICGP, IJSYM, IOFCD(8,8), IOFCEM(8,8), IOFCEP(8,8), IOFCGM(8,8), IOFCGP(8,8), ISYM, &
                     ISYM12, ISYMA, ISYMAB, ISYMB, ISYMI, ISYMIJ, ISYMJ, IX, IXIA, IXTA, IXTI, IY, JSYM, JXOFF, KOD, lg_Y, LLST1, &
                     LLST2, NA, NAS1, NAS2, NB, NFA, NFI, NFT, NI, NIS1, NIS2, NJ, NT, NU
real(kind=wp), parameter :: SQR2 = sqrt(Two), SQR3 = sqrt(Three), SQR32 = sqrt(OneHalf), SQRI2 = sqrt(Half), SQRI6 = One/sqrt(Six)

! Compute a contribution from a single block (ISYM2,ICASE2)
! of expansion vector to a single block (ISYM1,ICASE1)
! of a sigma vector, if IMLTOP=0. If IMLTOP=1, the role of the
! two blocks are reversed. It is assumed that ICASE2 is
! greater than ICASE1, hence the reverse option.

!FUE if (((ICASE1 == 1) .and. (ICASE2 == 2)) .and. ((ISYM1 == 1) .and. (ISYM2 == 1))) IFTEST = 1
!PAM if ((ICASE1 == 5) .and. (ICASE2 > 11)) IFTEST = 1
#ifdef _DEBUGPRINT_
write(u6,'(A,10I5)') ' ENTERING SGM.'
write(u6,'(A,10I5)') '       IMLTOP:',IMLTOP
write(u6,'(A,10I5)') ' ISYM1,ICASE1:',ISYM1,ICASE1
write(u6,'(A,10I5)') ' ISYM2,ICASE2:',ISYM2,ICASE2
write(u6,'(A,A,A)') ' CASES: ',CASES(ICASE1),CASES(ICASE2)
#endif

if ((IMLTOP < 0) .or. (IMLTOP > 2)) then
  write(u6,*) 'Error in SGM: IMLTOP = ',IMLTOP
  call AbEnd()
end if

! SVC: IFCOUP is set in SIGMA_CASPT2
KOD = IFCOUP(ICASE2,ICASE1)
if (KOD == 0) return

ISYM12 = Mul(ISYM1,ISYM2)
NAS1 = NASUP(ISYM1,ICASE1)
NIS1 = NISUP(ISYM1,ICASE1)
NAS2 = NASUP(ISYM2,ICASE2)
NIS2 = NISUP(ISYM2,ICASE2)
do ISYM=1,NSYM
  ICD = 0
  ICEP = 0
  ICEM = 0
  ICGP = 0
  ICGM = 0
  do JSYM=1,NSYM
    IJSYM = Mul(ISYM,JSYM)
    IOFCD(ISYM,JSYM) = ICD
    IOFCEP(ISYM,JSYM) = ICEP
    IOFCEM(ISYM,JSYM) = ICEM
    IOFCGP(ISYM,JSYM) = ICGP
    IOFCGM(ISYM,JSYM) = ICGM
    ICD = ICD+NSSH(JSYM)*NISH(IJSYM)
    ICEP = ICEP+NSSH(JSYM)*NIGEJ(IJSYM)
    ICEM = ICEM+NSSH(JSYM)*NIGTJ(IJSYM)
    ICGP = ICGP+NISH(JSYM)*NAGEB(IJSYM)
    ICGM = ICGM+NISH(JSYM)*NAGTB(IJSYM)
  end do
end do

! SVC: this is an extra check, since coupling cases that are 0 should
! not have entered the sgm subroutine

select case (KOD)
  ! -----------------------------------------------
  case (1)
    !ICASE1 = 1
    !ICASE2 = 2

    ! A&BP One-el
    NLST1 = NLIST(ISYM1,ISYM2,12)
    NLST2 = NLIST(ISYM1,ISYM2,14)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,12)
      VAL1(1) = One
      VAL1(2) = Two
      LLST2 = LLIST(ISYM1,ISYM2,14)
      VAL2(1) = One
      VAL2(2) = SQR2
      IXTI = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      INCF1 = NISH(ISYM12)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NTGEU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXTI),size(X1(IXTI:)),FIT(ISYM12)%A,size(FIT(ISYM12)%A), &
                  GA_Arrays(lg_Y)%A(IY),size(GA_Arrays(lg_Y)%A(IY:)))
    end if

    ! A&BP Two-el
    NLST1 = NLIST(ISYM1,ISYM2,3)
    NLST2 = NLIST(ISYM1,ISYM2,14)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,3)
      VAL1(1) = -One
      VAL1(2) = -Two
      LLST2 = LLIST(ISYM1,ISYM2,14)
      VAL2(1) = One
      VAL2(2) = SQR2
      IX = 1
      INCX1 = 1
      INCX2 = NTUV(ISYM1)
      INCF1 = NISH(ISYM12)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NTGEU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X2(IX),size(X2(IX:)),FIT(ISYM12)%A,size(FIT(ISYM12)%A), &
                  GA_Arrays(lg_Y)%A(IY),size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (2)
    !ICASE1 = 1
    !ICASE2 = 3

    ! A&BM One-el
    NLST1 = NLIST(ISYM1,ISYM2,13)
    NLST2 = NLIST(ISYM1,ISYM2,15)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,13)
      VAL1(1) = Three
      VAL1(2) = -Three
      LLST2 = LLIST(ISYM1,ISYM2,15)
      ! Original:
      !VAL2(1) = -One
      !VAL2(2) = One
      ! Fix for sign error noted by Takeshi, May 2015:
      VAL2(1) = One
      VAL2(2) = -One
      IXTI = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      INCF1 = NISH(ISYM12)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NTGTU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXTI),size(X1(IXTI:)),FIT(ISYM12)%A,size(FIT(ISYM12)%A), &
                  GA_Arrays(lg_Y)%A(IY),size(GA_Arrays(lg_Y)%A(IY:)))
    end if

    ! A&BM Two-el
    NLST1 = NLIST(ISYM1,ISYM2,4)
    NLST2 = NLIST(ISYM1,ISYM2,15)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,4)
      VAL1(1) = -One
      VAL1(2) = One
      LLST2 = LLIST(ISYM1,ISYM2,15)
      ! Original:
      !VAL2(1) = -One
      !VAL2(2) = One
      ! Fix for sign error noted by Takeshi, May 2015:
      VAL2(1) = One
      VAL2(2) = -One
      IX = 1
      INCX1 = 1
      INCX2 = NTUV(ISYM1)
      INCF1 = NISH(ISYM12)
      INCF2 = 1
      IY = 1
      INCY1 = 1
      INCY2 = NTGTU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X2(IX),size(X2(IX:)),FIT(ISYM12)%A,size(FIT(ISYM12)%A), &
                  GA_Arrays(lg_Y)%A(IY),size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (3)
    !ICASE1 = 1
    !ICASE2 = 5

    ! A&D  Two-el
    NLST1 = NLIST(ISYM1,ISYM2,1)
    if (NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,1)
      VAL1(1) = One
      VAL1(2) = One
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      INCF1 = NSSH(ISYM12)
      INCF2 = 1
      IY = 1+NAS2*IOFCD(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2
      INCY3 = NAS2*NISH(ISYM1)
      LEN1 = NISH(ISYM1)
      LEN2 = NSSH(ISYM12)
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),FAT(ISYM12)%A,size(FAT(ISYM12)%A),GA_Arrays(lg_Y)%A(IY), &
                 size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (4)
    !ICASE1 = 1
    !ICASE2 = 6

    ! A&EP One-el
    if (ISYM2 == ISYM1) then
      NT = NASH(ISYM1)
      if (NT /= 0) then
        do ISYMIJ=1,NSYM
          ISYMA = Mul(ISYMIJ,ISYM1)
          NA = NSSH(ISYMA)
          NLST1 = NLIST(ISYM1,ISYMIJ,14)
          if (NA*NLST1 /= 0) then
            LLST1 = LLIST(ISYM1,ISYMIJ,14)
            VAL1(1) = One
            VAL1(2) = SQR2
            IXTI = 1
            INCX1 = NT
            INCX2 = 1
            INCF1 = NSSH(ISYMA)
            INCF2 = 1
            IY = 1+NAS2*IOFCEP(ISYM2,ISYMA)
            INCY1 = NT*NA
            INCY2 = 1
            INCY3 = NT
            LEN1 = NT
            LEN2 = NA
            call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTI),size(X1(IXTI:)),FAI(ISYMA)%A,size(FAI(ISYMA)%A),GA_Arrays(lg_Y)%A(IY), &
                       size(GA_Arrays(lg_Y)%A(IY:)))
          end if
        end do
      end if
    end if
    ! -----------------------------------------------
  case (5)
    !ICASE1 = 1
    !ICASE2 = 7

    ! A&EM One-el
    if (ISYM2 == ISYM1) then
      NT = NASH(ISYM1)
      if (NT /= 0) then
        do ISYMIJ=1,NSYM
          ISYMA = Mul(ISYMIJ,ISYM1)
          NA = NSSH(ISYMA)
          NLST1 = NLIST(ISYM1,ISYMIJ,15)
          if (NA*NLST1 /= 0) then
            LLST1 = LLIST(ISYM1,ISYMIJ,15)
            VAL1(1) = -SQR3
            VAL1(2) = SQR3
            IXTI = 1
            INCX1 = NT
            INCX2 = 1
            INCF1 = NSSH(ISYMA)
            INCF2 = 1
            IY = 1+NAS2*IOFCEM(ISYM2,ISYMA)
            INCY1 = NT*NA
            INCY2 = 1
            INCY3 = NT
            LEN1 = NT
            LEN2 = NA
            call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTI),size(X1(IXTI:)),FAI(ISYMA)%A,size(FAI(ISYMA)%A),GA_Arrays(lg_Y)%A(IY), &
                       size(GA_Arrays(lg_Y)%A(IY:)))
          end if
        end do
      end if
    end if
    ! -----------------------------------------------
  case (6)
    !ICASE1 = 2
    !ICASE2 = 6

    ! BP&EP Two-el
    NA = NSSH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,9)
    if (NA*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,9)
      VAL1(1) = SQRI2
      VAL1(2) = SQRI2
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      INCF1 = NSSH(ISYM12)
      INCF2 = 1
      IY = 1+NAS2*IOFCEP(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2*NA
      INCY3 = NAS2
      LEN1 = NIS1
      LEN2 = NA
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),FAT(ISYM12)%A,size(FAT(ISYM12)%A),GA_Arrays(lg_Y)%A(IY), &
                 size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (7)
    !ICASE1 = 3
    !ICASE2 = 7

    ! BM&EM Two-el
    NA = NSSH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,10)
    if (NA*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,10)
      ! Original:
      !VAL1(1) = -SQRI6
      !VAL1(2) = SQRI6
      ! Fix for sign error noted by Takeshi, May 2015:
      VAL1(1) = SQRI6
      VAL1(2) = -SQRI6
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      INCF1 = NSSH(ISYM12)
      INCF2 = 1
      IY = 1+NAS2*IOFCEM(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2*NA
      INCY3 = NAS2
      LEN1 = NIS1
      LEN2 = NA
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),FAT(ISYM12)%A,size(FAT(ISYM12)%A),GA_Arrays(lg_Y)%A(IY), &
                 size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (8)
    !ICASE1 = 4
    !ICASE2 = 5

    ! C&D  One-el
    NI = NISH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,11)
    if (NI*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,11)
      VAL1(1) = Two
      VAL1(2) = One
      IXTA = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      INCF1 = NI
      INCF2 = 1
      IY = 1+NAS2*IOFCD(ISYM2,ISYM1)
      INCY1 = 1
      INCY2 = NAS2*NI
      INCY3 = NAS2
      LEN1 = NSSH(ISYM1)
      LEN2 = NI
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTA),size(X1(IXTA:)),FIT(ISYM12)%A,size(FIT(ISYM12)%A),GA_Arrays(lg_Y)%A(IY), &
                 size(GA_Arrays(lg_Y)%A(IY:)))
    end if

    ! C&D  Two-el
    NI = NISH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,2)
    if (NI*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,2)
      VAL1(1) = -One
      VAL1(2) = -One
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      INCF1 = NI
      INCF2 = 1
      IY = 1+NAS2*IOFCD(ISYM2,ISYM1)
      INCY1 = 1
      INCY2 = NAS2*NI
      INCY3 = NAS2
      LEN1 = NSSH(ISYM1)
      LEN2 = NI
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),FIT(ISYM12)%A,size(FIT(ISYM12)%A),GA_Arrays(lg_Y)%A(IY), &
                 size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (9)
    !ICASE1 = 4
    !ICASE2 = 8

    ! C&FP One-el
    NLST1 = NLIST(ISYM1,ISYM2,12)
    NLST2 = NLIST(ISYM1,ISYM2,16)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,12)
      VAL1(1) = -One
      VAL1(2) = -Two
      LLST2 = LLIST(ISYM1,ISYM2,16)
      VAL2(1) = One
      VAL2(2) = SQR2
      IXTA = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      INCF1 = 1
      INCF2 = NASH(ISYM12)
      IY = 1
      INCY1 = 1
      INCY2 = NTGEU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXTA),size(X1(IXTA:)),FTA(ISYM12)%A,size(FTA(ISYM12)%A), &
                  GA_Arrays(lg_Y)%A(IY),size(GA_Arrays(lg_Y)%A(IY:)))
    end if

    ! C&FP Two-el
    NLST1 = NLIST(ISYM1,ISYM2,5)
    NLST2 = NLIST(ISYM1,ISYM2,16)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,5)
      VAL1(1) = One
      VAL1(2) = Two
      LLST2 = LLIST(ISYM1,ISYM2,16)
      VAL2(1) = One
      VAL2(2) = SQR2
      IX = 1
      INCX1 = 1
      INCX2 = NTUV(ISYM1)
      INCF1 = 1
      INCF2 = NASH(ISYM12)
      IY = 1
      INCY1 = 1
      INCY2 = NTGEU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X2(IX),size(X2(IX:)),FTA(ISYM12)%A,size(FTA(ISYM12)%A), &
                  GA_Arrays(lg_Y)%A(IY),size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (10)
    !ICASE1 = 4
    !ICASE2 = 9

    ! C&FM One-el
    NLST1 = NLIST(ISYM1,ISYM2,13)
    NLST2 = NLIST(ISYM1,ISYM2,17)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,13)
      VAL1(1) = -One
      VAL1(2) = One
      LLST2 = LLIST(ISYM1,ISYM2,17)
      VAL2(1) = One
      VAL2(2) = -One
      IXTA = 1
      INCX1 = 1
      INCX2 = NASH(ISYM1)
      INCF1 = 1
      INCF2 = NASH(ISYM12)
      IY = 1
      INCY1 = 1
      INCY2 = NTGTU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X1(IXTA),size(X1(IXTA:)),FTA(ISYM12)%A,size(FTA(ISYM12)%A), &
                  GA_Arrays(lg_Y)%A(IY),size(GA_Arrays(lg_Y)%A(IY:)))
    end if

    ! C&FM Two-el
    NLST1 = NLIST(ISYM1,ISYM2,6)
    NLST2 = NLIST(ISYM1,ISYM2,17)
    if (NLST1*NLST2 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,6)
      VAL1(1) = -One
      VAL1(2) = One
      LLST2 = LLIST(ISYM1,ISYM2,17)
      VAL2(1) = One
      VAL2(2) = -One
      IX = 1
      INCX1 = 1
      INCX2 = NTUV(ISYM1)
      INCF1 = 1
      INCF2 = NASH(ISYM12)
      IY = 1
      INCY1 = 1
      INCY2 = NTGTU(ISYM2)
      call MLTSCA(IMLTOP,LIST(LLST1),NLST1,LIST(LLST2),NLST2,X2(IX),size(X2(IX:)),FTA(ISYM12)%A,size(FTA(ISYM12)%A), &
                  GA_Arrays(lg_Y)%A(IY),size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (11)
    !ICASE1 = 4
    !ICASE2 = 10

    ! C&GP One-el
    NT = NASH(ISYM1)
    if ((ISYM2 == ISYM1) .and. (NT /= 0)) then
      do ISYMAB=1,NSYM
        ISYMI = Mul(ISYMAB,ISYM1)
        NI = NISH(ISYMI)
        NLST1 = NLIST(ISYM1,ISYMAB,16)
        if (NI*NLST1 /= 0) then
          LLST1 = LLIST(ISYM1,ISYMAB,16)
          VAL1(1) = SQRI2
          VAL1(2) = One
          IXTA = 1
          INCX1 = NT
          INCX2 = 1
          INCF1 = NI
          INCF2 = 1
          IY = 1+NAS2*IOFCGP(ISYM2,ISYMI)
          INCY1 = NT*NI
          INCY2 = 1
          INCY3 = NT
          LEN1 = NT
          LEN2 = NI
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTA),size(X1(IXTA:)),FIA(ISYMI)%A,size(FIA(ISYMI)%A),GA_Arrays(lg_Y)%A(IY), &
                     size(GA_Arrays(lg_Y)%A(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (12)
    !ICASE1 = 4
    !ICASE2 = 11

    ! C&GM One-el
    NT = NASH(ISYM1)
    if ((ISYM2 == ISYM1) .and. (NT /= 0)) then
      do ISYMAB=1,NSYM
        ISYMI = Mul(ISYMAB,ISYM1)
        NI = NISH(ISYMI)
        NLST1 = NLIST(ISYM1,ISYMAB,17)
        if (NI*NLST1 /= 0) then
          LLST1 = LLIST(ISYM1,ISYMAB,17)
          VAL1(1) = SQR32
          VAL1(2) = -SQR32
          IXTA = 1
          INCX1 = NT
          INCX2 = 1
          INCF1 = NI
          INCF2 = 1
          IY = 1+NAS2*IOFCGM(ISYM2,ISYMI)
          INCY1 = NT*NI
          INCY2 = 1
          INCY3 = NT
          LEN1 = NT
          LEN2 = NI
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXTA),size(X1(IXTA:)),FIA(ISYMI)%A,size(FIA(ISYMI)%A),GA_Arrays(lg_Y)%A(IY), &
                     size(GA_Arrays(lg_Y)%A(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (13)
    !ICASE1 = 5
    !ICASE2 = 6

    ! D&EP One-el
    NT = NASH(ISYM2)
    if ((ISYM1 == 1) .and. (NT /= 0)) then
      do ISYMI=1,NSYM
        NI = NISH(ISYMI)
        NA = NSSH(ISYMI)
        ISYMIJ = Mul(ISYMI,ISYM2)
        NLST1 = NLIST(ISYMI,ISYMIJ,14)
        if (NI*NA*NLST1 /= 0) then
          LLST1 = LLIST(ISYMI,ISYMIJ,14)
          VAL1(1) = SQRI2
          VAL1(2) = One
          IXIA = 1+IOFFIA(ISYMI)
          INCX1 = 1
          INCX2 = NI
          INCF1 = NASH(ISYM2)
          INCF2 = 1
          IY = 1+NAS2*IOFCEP(ISYM2,ISYMI)
          INCY1 = NT*NA
          INCY2 = NT
          INCY3 = 1
          LEN1 = NA
          LEN2 = NT
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXIA),size(X1(IXIA:)),FTI(ISYM2)%A,size(FTI(ISYM2)%A),GA_Arrays(lg_Y)%A(IY), &
                     size(GA_Arrays(lg_Y)%A(IY:)))
        end if
      end do
    end if

    ! D&EP Two-el
    LLST1 = LLIST(ISYM1,ISYM2,7)
    NLST1 = NLIST(ISYM1,ISYM2,7)
    NU = NASH(ISYM2)
    if (NLST1*NU /= 0) then
      VAL1(1) = -One
      VAL1(2) = -One
      do ISYMA=1,NSYM
        NA = NSSH(ISYMA)
        ISYMI = Mul(ISYMA,ISYM1)
        NI = NISH(ISYMI)
        ISYMIJ = Mul(ISYMI,ISYM12)
        NLST2 = NLIST(ISYMI,ISYMIJ,14)
        if (NA*NI*NLST2 /= 0) then
          LLST2 = LLIST(ISYMI,ISYMIJ,14)
          VAL2(1) = SQRI2
          VAL2(2) = One
          IX = 1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1 = 1
          INCX2 = NAS1
          INCX3 = NAS1*NI
          INCF1 = NISH(ISYM12)
          INCF2 = 1
          IY = 1+NU*IOFCEP(ISYM2,ISYMA)
          INCY1 = 1
          INCY2 = NU*NA
          INCY3 = NU
          LEN1 = NA
          call MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),X2(IX:),size(X2(IX:)),FIT(ISYM12)%A(:),size(FIT(ISYM12)%A(:)), &
                      GA_Arrays(lg_Y)%A(IY:),size(GA_Arrays(lg_Y)%A(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (14)
    !ICASE1 = 5
    !ICASE2 = 7

    ! D&EM One-el
    NT = NASH(ISYM2)
    if ((ISYM1 == 1) .and. (NT /= 0)) then
      do ISYMI=1,NSYM
        NI = NISH(ISYMI)
        NA = NSSH(ISYMI)
        ISYMIJ = Mul(ISYMI,ISYM2)
        NLST1 = NLIST(ISYMI,ISYMIJ,15)
        if (NI*NA*NLST1 /= 0) then
          LLST1 = LLIST(ISYMI,ISYMIJ,15)
          VAL1(1) = SQR32
          VAL1(2) = -SQR32
          IXIA = 1+IOFFIA(ISYMI)
          INCX1 = 1
          INCX2 = NI
          INCF1 = NASH(ISYM2)
          INCF2 = 1
          IY = 1+NAS2*IOFCEM(ISYM2,ISYMI)
          INCY1 = NT*NA
          INCY2 = NT
          INCY3 = 1
          LEN1 = NA
          LEN2 = NT
          call MLTMV(IMLTOP,LIST(LLST1),NLST1,X1(IXIA),size(X1(IXIA:)),FTI(ISYM2)%A,size(FTI(ISYM12)%A),GA_Arrays(lg_Y)%A(IY), &
                     size(GA_Arrays(lg_Y)%A(IY:)))
        end if
      end do
    end if

    ! D&EM Two-el
    NLST1 = NLIST(ISYM1,ISYM2,7)
    NU = NASH(ISYM2)
    if (NLST1*NU /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,7)
      VAL1(1) = -One
      VAL1(2) = One
      do ISYMA=1,NSYM
        NA = NSSH(ISYMA)
        ISYMI = Mul(ISYMA,ISYM1)
        NI = NISH(ISYMI)
        ISYMIJ = Mul(ISYMI,ISYM12)
        NLST2 = NLIST(ISYMI,ISYMIJ,15)
        if (NA*NI*NLST2 /= 0) then
          LLST2 = LLIST(ISYMI,ISYMIJ,15)
          VAL2(1) = SQRI6
          VAL2(2) = -SQRI6
          IX = 1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1 = 1
          INCX2 = NAS1
          INCX3 = NAS1*NI
          INCF1 = NISH(ISYM12)
          INCF2 = 1
          IY = 1+NU*IOFCEM(ISYM2,ISYMA)
          INCY1 = 1
          INCY2 = NU*NA
          INCY3 = NU
          LEN1 = NA
          call MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),X2(IX:),size(X2(IX:)),FIT(ISYM12)%A(:),size(FIT(ISYM12)%A(:)), &
                      GA_Arrays(lg_Y)%A(IY:),size(GA_Arrays(lg_Y)%A(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (15)
    !ICASE1 = 5
    !ICASE2 = 10

    ! D&GP Two-el
    NLST1 = NLIST(ISYM1,ISYM2,8)
    NU = NASH(ISYM2)
    if (NLST1*NU /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,8)
      VAL1(1) = One
      VAL1(2) = One
      do ISYMA=1,NSYM
        ISYMI = Mul(ISYMA,ISYM1)
        NI = NISH(ISYMI)
        ISYMAB = Mul(ISYMA,ISYM12)
        NLST2 = NLIST(ISYMA,ISYMAB,16)
        if (NI*NLST2 /= 0) then
          LLST2 = LLIST(ISYMA,ISYMAB,16)
          VAL2(1) = SQRI2
          VAL2(2) = One
          IX = 1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1 = 1
          INCX2 = NAS1*NI
          INCX3 = NAS1
          INCF1 = 1
          INCF2 = NASH(ISYM12)
          IY = 1+NU*IOFCGP(ISYM2,ISYMI)
          INCY1 = 1
          INCY2 = NU*NI
          INCY3 = NU
          LEN1 = NI
          call MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),X2(IX:),size(X2(IX:)),FTA(ISYM12)%A(:),size(FTA(ISYM12)%A(:)), &
                      GA_Arrays(lg_Y)%A(IY:),size(GA_Arrays(lg_Y)%A(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (16)
    !ICASE1 = 5
    !ICASE2 = 11

    ! D&GM Two-el
    NLST1 = NLIST(ISYM1,ISYM2,8)
    NU = NASH(ISYM2)
    if (NLST1*NU /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,8)
      VAL1(1) = -One
      VAL1(2) = One
      do ISYMA=1,NSYM
        ISYMI = Mul(ISYMA,ISYM1)
        NI = NISH(ISYMI)
        ISYMAB = Mul(ISYMA,ISYM12)
        NLST2 = NLIST(ISYMA,ISYMAB,17)
        if (NI*NLST2 /= 0) then
          LLST2 = LLIST(ISYMA,ISYMAB,17)
          VAL2(1) = SQRI6
          VAL2(2) = -SQRI6
          IX = 1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1 = 1
          INCX2 = NAS1*NI
          INCX3 = NAS1
          INCF1 = 1
          INCF2 = NASH(ISYM12)
          IY = 1+NU*IOFCGM(ISYM2,ISYMI)
          INCY1 = 1
          INCY2 = NU*NI
          INCY3 = NU
          LEN1 = NI
          call MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),X2(IX:),size(X2(IX:)),FTA(ISYM12)%A(:),size(FTA(ISYM12)%A(:)), &
                      GA_Arrays(lg_Y)%A(IY:),size(GA_Arrays(lg_Y)%A(IY:)))
        end if
      end do
    end if
    ! -----------------------------------------------
  case (17)
    !ICASE1 = 6
    !ICASE2 = 12

    ! EP&HP Two-el
    NA = NSSH(ISYM12)
    NLST1 = NLIST(ISYM12,ISYM2,16)
    if (NA*NLST1 /= 0) then
      LLST1 = LLIST(ISYM12,ISYM2,16)
      VAL1(1) = SQRI2
      VAL1(2) = One
      JXOFF = IOFCEP(ISYM1,ISYM12)
      INCX3 = NAS1*NA
      NFT = NASH(ISYM1)
      NFA = NSSH(ISYM1)
      call PMLTR1(KOD,IMLTOP,LIST(LLST1),X2(:),size(X2(:)),NAS1,NIS1,JXOFF,FTA(ISYM1)%A(:),NFT,NFA,lg_Y,NAS2,NIS2)
    end if
    ! -----------------------------------------------
  case (18)
    !ICASE1 = 7
    !ICASE2 = 13

    ! EM&HM Two-el
    NA = NSSH(ISYM12)
    NLST1 = NLIST(ISYM12,ISYM2,17)
    if (NA*NLST1 /= 0) then
      LLST1 = LLIST(ISYM12,ISYM2,17)
      VAL1(1) = SQRI2
      VAL1(2) = -SQRI2
      JXOFF = IOFCEM(ISYM1,ISYM12)
      INCX3 = NAS1*NA
      NFT = NASH(ISYM1)
      NFA = NSSH(ISYM1)
      call PMLTR1(KOD,IMLTOP,LIST(LLST1),X2(:),size(X2(:)),NAS1,NIS1,JXOFF,FTA(ISYM1)%A(:),NFT,NFA,lg_Y,NAS2,NIS2)
    end if
    ! -----------------------------------------------
  case (19)
    !ICASE1 = 8
    !ICASE2 = 10

    ! FP&GP Two-el
    NI = NISH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,9)
    if (NI*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,9)
      VAL1(1) = -SQRI2
      VAL1(2) = -SQRI2
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      INCF1 = NI
      INCF2 = 1
      IY = 1+NAS2*IOFCGP(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2*NI
      INCY3 = NAS2
      LEN1 = NIS1
      LEN2 = NI
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),FIT(ISYM12)%A,size(FIT(ISYM12)%A),GA_Arrays(lg_Y)%A(IY), &
                 size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (20)
    !ICASE1 = 9
    !ICASE2 = 11

    ! FM&GM Two-el
    NI = NISH(ISYM12)
    NLST1 = NLIST(ISYM1,ISYM2,10)
    if (NI*NLST1 /= 0) then
      LLST1 = LLIST(ISYM1,ISYM2,10)
      VAL1(1) = -SQRI6
      VAL1(2) = SQRI6
      IX = 1
      INCX1 = 1
      INCX2 = NAS1
      INCF1 = NI
      INCF2 = 1
      IY = 1+NAS2*IOFCGM(ISYM2,ISYM12)
      INCY1 = 1
      INCY2 = NAS2*NI
      INCY3 = NAS2
      LEN1 = NIS1
      LEN2 = NI
      call MLTMV(IMLTOP,LIST(LLST1),NLST1,X2(IX),size(X2(IX:)),FIT(ISYM12)%A,size(FIT(ISYM12)%A),GA_Arrays(lg_Y)%A(IY), &
                 size(GA_Arrays(lg_Y)%A(IY:)))
    end if
    ! -----------------------------------------------
  case (21)
    !ICASE1 = 10
    !ICASE2 = 12

    ! GP&HP Two-el
    NLST1 = NLIST(ISYM12,ISYM2,14)
    if (NLST1 /= 0) then
      LLST1 = LLIST(ISYM12,ISYM2,14)
      VAL1(1) = -SQRI2
      VAL1(2) = -One
      JXOFF = IOFCGP(ISYM1,ISYM12)
      INCX3 = NAS1*NISH(ISYM12)
      NFT = NASH(ISYM1)
      NFI = NISH(ISYM1)
      call PMLTR1(KOD,IMLTOP,LIST(LLST1),X2(:),size(X2(:)),NAS1,NIS1,JXOFF,FTI(ISYM1)%A(:),NFT,NFI,lg_Y,NAS2,NIS2)
    end if
    ! -----------------------------------------------
  case (22)
    !ICASE1 = 11
    !ICASE2 = 13

    ! GM&HM Two-el
    NLST1 = NLIST(ISYM12,ISYM2,15)
    if (NLST1 /= 0) then
      LLST1 = LLIST(ISYM12,ISYM2,15)
      VAL1(1) = SQRI2
      VAL1(2) = -SQRI2
      JXOFF = IOFCGM(ISYM1,ISYM12)
      INCX3 = NAS1*NISH(ISYM12)
      NFT = NASH(ISYM1)
      NFI = NISH(ISYM1)
      call PMLTR1(KOD,IMLTOP,LIST(LLST1),X2(:),size(X2(:)),NAS1,NIS1,JXOFF,FTI(ISYM1)%A(:),NFT,NFI,lg_Y,NAS2,NIS2)
    end if
    ! -----------------------------------------------
  case (23)
    !ICASE1 = 5
    !ICASE2 = 12

    ! D&HP One-el
    if (ISYM1 == 1) then
      do ISYMI=1,NSYM
        NI = NISH(ISYMI)
        ISYMA = ISYMI
        NA = NSSH(ISYMA)
        ISYMJ = Mul(ISYMI,ISYM2)
        NJ = NISH(ISYMJ)
        ISYMB = ISYMJ
        NB = NSSH(ISYMB)
        NLST1 = NLIST(ISYMI,ISYM2,14)
        NLST2 = NLIST(ISYMA,ISYM2,16)
        if (NI*NA*NJ*NB*NLST1*NLST2 /= 0) then
          LLST1 = LLIST(ISYMI,ISYM2,14)
          VAL1(1) = SQRI2
          VAL1(2) = One
          LLST2 = LLIST(ISYMA,ISYM2,16)
          VAL2(1) = SQRI2
          VAL2(2) = One
          IXIA = 1+IOFFIA(ISYMI)
          INCX1 = 1
          INCX2 = NI
          call PMLTSCA(KOD,IMLTOP,LIST(LLST1),LIST(LLST2),X1(IXIA),NI,NA,FIA(ISYMB)%A,NJ,NB,lg_Y,NAS2,NIS2)
        end if
      end do
    end if
    !---------------------------
  case (24)
    !ICASE1 = 5
    !ICASE2 = 13

    ! D&HM One-el
    if (ISYM1 == 1) then
      do ISYMI=1,NSYM
        NI = NISH(ISYMI)
        ISYMA = ISYMI
        NA = NSSH(ISYMA)
        ISYMJ = Mul(ISYMI,ISYM2)
        NJ = NISH(ISYMJ)
        ISYMB = ISYMJ
        NB = NSSH(ISYMB)
        NLST1 = NLIST(ISYMI,ISYM2,15)
        NLST2 = NLIST(ISYMA,ISYM2,17)
        if (NI*NA*NJ*NB*NLST1*NLST2 /= 0) then
          LLST1 = LLIST(ISYMI,ISYM2,15)
          VAL1(1) = SQR3*Half
          VAL1(2) = -VAL1(1)
          LLST2 = LLIST(ISYMA,ISYM2,17)
          VAL2(1) = One
          VAL2(2) = -One
          IXIA = 1+IOFFIA(ISYMI)
          INCX1 = 1
          INCX2 = NI
          call PMLTSCA(KOD,IMLTOP,LIST(LLST1),LIST(LLST2),X1(IXIA),NI,NA,FIA(ISYMB)%A,NJ,NB,lg_Y,NAS2,NIS2)
        end if
      end do
    end if
    !---------------------------
  case default
    write(u6,*) ' INTERNAL ERROR: SGM reached invalid KOD=',KOD
    call Abend()
end select

end subroutine SGM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
*               2002, Roland Lindh                                     *
************************************************************************
      SubRoutine WfCtl_Hess(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,
     &                      iRHSDisp,iRHSCIDISP,converged)
************************************************************************
*                                                                      *
*                                                                      *
*     called from: MCLR                                                *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*     Parallelization of perturbations, RL 2002.                       *
*                                                                      *
************************************************************************
      use Exp, only: Exp_Close
      use Arrays, only: CMO, Int2, FIMO
      use ipPage, only: W
      use Para_Info, only: myRank, nProcs
#ifdef _MOLCAS_MPP_
      use Para_Info, only: Is_Real_Par
#endif
      Implicit Real*8 (a-h,o-z)
      External Rsv_Tsk
*
#include "standard_iounits.fh"
#include "real.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "stdalloc.fh"
#include "dmrginfo_mclr.fh"
*
#ifdef _MOLCAS_MPP_
#  include "global.fh"
#  include "mafdecls.fh"
#endif
      Logical Orb,CI,Response
      Parameter (iTimeCC = 1 )
      Parameter (iTimeKK = 2 )
      Parameter (iTimeKC = 3 )
      Parameter (iTimeCK = 4 )
#include "crun_mclr.fh"
      Character*8   Fmt2
      Character*132 Line
      Integer iKapDisp(nDisp),isigDisp(nDisp)
      Integer iRHSDisp(nDisp),iRHSCIDisp(nDisp)
      Integer iCIDisp(nDisp),iCIsigDisp(nDisp)
      Integer pstate_sym,opout
      Logical lPrint,converged(8), Rsv_Tsk
      Real*8 Clock(4)
      Character*72 SLine
      Real*8 res_tmp
      Real*8 rdum(1)
      Real*8, Allocatable:: Kappa(:), dKappa(:), Sigma(:),
     &                      Temp1(:), Temp2(:), Temp3(:), Temp4(:),
     &                      Sc1(:), Sc2(:), Sc3(:),
     &                      Dens(:), Pens(:), rmoaa(:)
      Integer, Allocatable:: List(:,:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      SubRoutine CISigma(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,
     &                   Int2a,nInt2a,ipCI1,ipCI2, Have_2_el)
       Integer iispin, iCsym, iSSym
       Integer nInt1, nInt2s, nInt2a
       Real*8, Target:: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
       Integer ipCI1, ipCI2
       Logical Have_2_el
      End SubRoutine CISigma
      End Interface
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*define _DEBUGPRINT_
*----------------------------------------------------------------------*
      SLine=' Solving CP(CAS)HF equations'
      Call StatusLine(' MCLR:',SLine)
*
*----------------------------------------------------------------------*
*     Initialize blank and header lines                                *
*----------------------------------------------------------------------*
      TIM2=Zero
      TIM3=Zero
      TIM4=Zero
*
      CLOCK(:)=Zero
      lPaper=132
      lLine =120
      left=(lPaper-lLine)/2
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
*----------------------------------------------------------------------*

      iDis=0
*
      fail=.false.
      Converged(:)=.true.
      lprint=.false.
*     If (SAVE) CALL DANAME(50,'RESIDUALS')
      If (SAVE) Then
         Write (LuWr,*) 'WfCtl: SAVE option not implemented'
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Start loop over the symmetry of the perturbations
*
      If (iAnd(kprint,2).eq.2) lprint=.true.
#ifdef _DEBUGPRINT_
      lprint=.true.
#endif
      kksym=1
      kkksym=nsym
      If (PT2) kkkSym=1
*
*     Set up parallelization over the loop over perturbations
*
      Call mma_allocate(List,2,nDisp,Label='List')
      iDisp=0
      Do iSym=kksym,kkksym
        iDEnd=lDisp(iSym)
        Do jDisp=1,iDEnd
           iDisp=iDisp+1
           List(1,iDisp)=iSym
           List(2,iDisp)=jDisp
        End Do
      End Do
*
*     Change output unit
*
      LuWr_save=LuWr
      If (MyRank.ne.0) Then
         LuWr=55
         LuWr=isFreeUnit(LuWr)
         call molcas_open(luwr,'Temp_OutPut')
      End If
*
      Call Init_Tsk(id,nDisp)
#ifdef _MOLCAS_MPP_
*     iglfail is global "array", a flag used to communicate to all processes
*     if any of them failed, the communication need not be synchronous,
      If (Is_Real_Par()) Then
         If (.Not.GA_Create(MT_DBL,1,1,'GlFail',0,0,iglfail)) Then
           Call SysAbendMsg ('wfctl_hess',
     &                       'failed to create global failed flag',' ')

         End If
         Call GA_Zero(iglfail)
         dfail=Zero
      End If
#endif
*
      ipdia=0
      ipPre2=0
      iSym_Old=0
 888  If (.Not.Rsv_Tsk(id,iDisp)) Go To 999
#ifdef _MOLCAS_MPP_
*       Check if some other process failed
        If (Is_Real_Par()) Then
           Call GA_Get(iglfail,1,1,1,1,dfail,1)
           If (dfail.gt.Zero) Then
              fail=.true.
              Go To 999
           End If
        End If
#endif
        iSym =List(1,iDisp)
        jDisp=List(2,iDisp)
*
        Write (SLine,'(A,I3,A)')
     &        ' Solving CP(CAS)HF equations for perturbation ',
     &        iDisp,'.'
        Call StatusLine(' MCLR:',SLine)
*
C     Do iSym=kksym,kkksym
*
*       Execute setup for symmetry block if a new one!
*
        If (iSym.ne.iSym_Old) Then
*
           If (iSym_Old.ne.0) Then
*
*             If a previous symmetry block as processed
*             free all memory and remove from disk all data
*             related to this symmetry
*
              If (CI) Then
                 irc=ipclose(ipdia)
              Else
                 irc=ipclose(ipPre2)
              End If
*
              Call Exp_Close()
*
           End If
           iSym_Old=iSym
*
        PState_SYM=iEor(State_Sym-1,iSym-1)+1
        nconf1=ncsf(PState_Sym)
        CI=.false.
        If (iMethod.eq.2.and.nconf1.gt.0) CI=.true.

        If (CI.and.nconf1.eq.1.and.isym.eq.1) CI=.false.
*          Initiate CSF <-> SD
        If (CI) Call InCSFSD(iEor(iSym-1,State_Sym-1)+1,
     &                       State_sym,.false.)
*
*
*          Calculate length of the density, Fock and Kappa matrix etc
*          notice that this matrixes not necessary are symmetric.
*          Store pointers.
*
*          Input:
*                 iSym : Symmetry of perturbation
*
*          Output: Commonblocks (Pointers.fh)
*
        PState_SYM=iEor(State_Sym-1,iSym-1)+1
*       nConf2=nint(xispsm(PState_SYM,1))
*       nConf2=ndtasm(PState_SYM)
        nconf3=nint(Max(xispsm(PState_SYM,1),xispsm(State_SYM,1)))
*       nconf3=Max(ndtasm(PState_SYM),ndtasm(State_SYM))

        if(doDMRG)then  ! yma
          call dmrg_spc_change_mclr(RGras2(1:8),nash)
          call dmrg_spc_change_mclr(RGras2(1:8),nrs2)
        end if

        Call Setup_MCLR(iSym)
*                                                                      *
************************************************************************
*                                                                      *
*       Determine if we should page CI vectors
*
*                                    [2]
*         Calculate the diagonal of E    and store in core/disc
*
        If (CI) Then
            Call CIDia(PState_Sym,rCHC)
            irc=ipout(ipdia)
*
*       Allocate disk/memory space
*
*
*       This areas should be addressed through ipin
*       ipout will page them out to disk and free the memory area
*       if page mode is used
*
*       opout will release the memory area without update the disk
*
           ips1 =ipget(nconf3)
           ips2 =ipget(nconf3)
           ipst =ipget(nconf3)
           ipcit=ipget(nconf1)
           ipcid=ipget(nconf1)
*
        Else
           ips1=0
           ips2=0
           ipst=0
           ipcit=0
           ipcid=0
        End If
*
        npre2=Max(npre(isym),1) ! "Max" just there to make sure that
!                                 W(ipPre2) is allocated even if
!                                 npre2(isym) is zero.
        ipPre2=ipget(npre2)
        irc=ipin(ipPre2)
        call Prec(W(ipPre2)%Vec,isym)
        irc=ipout(ippre2)
*                                                                      *
************************************************************************
*                                                                      *
*      OK START WORKING, looping over the perturbations of the
*      current symmetry
*
        iDEND=lDisp(iSym)
*       If (SewLab.eq.'NONE    '.and.(.not.mckinley)) iDEND=1
*
        End If
*
C       Do jDisp=1,iDEnd
C         iDisp=iDisp+1
          jspin=0
          If (iAnd(nTPert(idisp),1).eq.1) jSpin=1
          If (jspin.eq.0) Then
              nconf1=ncsf(PState_Sym)
          Else
              nConf1=nint(xispsm(Pstate_Sym,1))
          End If
*
*    Allocate areas for scratch and state variables
*
          Call mma_allocate(Kappa,nDens2+6,Label='Kappa')
          Call mma_allocate(dKappa,nDens2+6,Label='dKappa')
          Call mma_allocate(Sigma,nDens2+6,Label='Sigma')
          Call mma_allocate(Temp1,nDens2+6,Label='Temp1')
          Call mma_allocate(Temp2,nDens2+6,Label='Temp2')
          Call mma_allocate(Temp3,nDens2+6,Label='Temp3')
          Call mma_allocate(Temp4,nDens2+6,Label='Temp4')
          Call mma_allocate(Sc1,nDens2+6,Label='Sc1')
          Call mma_allocate(Sc2,nDens2+6,Label='Sc2')
          Call mma_allocate(Sc3,nDens2+6,Label='Sc3')
          Temp1(1:nDens2)=Zero
          Kappa(1:nDens2)=Zero
          dKappa(1:nDens2)=Zero
          Sigma(1:nDens2)=Zero
          If (CI) Then
             Call mma_allocate(Dens,n1dens,Label='Dens')
             Call mma_allocate(Pens,n2dens,Label='Pens')
*
             Dens(:)=Zero
             Pens(:)=Zero
          End If
          If (iMethod.eq.2) Then
             Call mma_allocate(rmoaa,n2dens,Label='rmoaa')
          Else
             Call mma_allocate(rmoaa,1,Label='rmoaa')
          End If
          rmoaa(:)=Zero
*                                                                      *
************************************************************************
*                                                                      *
*         Calculate RHS for the perturbation
*                                                                      *
************************************************************************
*                                                                      *
*         (T1,T2,T3,T4,T5,T6,T7,Kappa1,CI1)
*
          If (PT2) then
             Call RHS_PT2(Temp4,ipST)
          Else
             Call RHS(Sigma,Kappa,Temp1,
     &                Temp3,Sc2,dKappa,
     &                Sc3,
     &                Temp4,ipST,
     &                iDisp,iSym-1,CMO,jdisp,jspin,CI)
#ifdef _DEBUGPRINT_
             Write (LuWr,*) 'After RHS'
             Write (LuWr,*) 'Sigma=',DDot_(nDens,Sigma,1,Sigma,1)
             Write (LuWr,*) 'Kappa=',DDot_(nDens,Kappa,1,Kappa,1)
             Write (LuWr,*) 'Sc2=',DDot_(nDens,Sc2,1,Sc2,1)
             Write (LuWr,*) 'dKap=',DDot_(nDens,dKappa,1,dKappa,1)
             Write (LuWr,*) 'CMO=',DDot_(nCMO,CMO,1,CMO,1)
#endif
          End If
          irc=opout(ipci)
*
          Write (LuWr,*) 'Process perturbation number ',iDisp
          If (lprint) Write(LuWr,*)
     &      '       Iteration         Delta     Res(kappa) Res(CI)'
*                                                                      *
************************************************************************
*                                                                      *
*         Write RHS to disk                                            *
*                                                                      *
************************************************************************
*                                                                      *
          iLen=nDensC
          iRHSDisp(iDisp)=iDis
          Call Compress(Temp4,Sigma,iSym)
          r1=ddot_(ndensc,sigma,1,sigma,1)
          Call UnCompress(Sigma,Temp4,iSym)
          Call dDaFile(LuTemp,1,Sigma,iLen,iDis)
          If (CI) Then
             irc=ipin(ipCIT)
             W(ipCIT)%Vec(1:nConf1)=Zero
          End If
          irc=ipout(ipCIT)
          If (CI) Then
             ilen=nconf1
             iRHSCIDisp(iDisp)=iDis
             irc=ipin(ipST)
             Call dDaFile(LuTemp,1,W(ipST)%Vec,iLen,iDis)
             Call DSCAL_(nConf1,-One,W(ipST)%Vec,1)
          End If
*
          Call DSCAL_(nDensC,-One,Sigma,1)
*
#ifdef _DEBUGPRINT_
          irc=ipin(ipST)
          Write (LuWr,*) 'ST=',DDot_(nConf1,W(ipST)%Vec,1,W(ipST)%Vec,1)
          Write (LuWr,*) 'Sigma=',DDot_(nDensC,Sigma,1,Sigma,1)
          Write (LuWr,*) 'Kappa=',DDot_(nDens2,Kappa,1,Kappa,1)
          Write (LuWr,*) 'End RHS!'
#endif
*
          iter=1
          irc=ipin(ipPre2)
          Call DMInvKap(W(ipPre2)%Vec,Sigma,nDens2+6,
     &                  Kappa,nDens2+6,Temp3,nDens2+6,
     &                  isym,iter)
          irc=opout(ippre2)
          r2=ddot_(ndensc,Kappa,1,Kappa,1)
#ifdef _DEBUGPRINT_
          Write (LuWr,*) 'DMinvKap'
          Write (LuWr,*) 'Kap=',DDot_(nDens2,Kappa,1,Kappa,1)
          Write (LuWr,*) 'End DMinvKap'
#endif
          If (r2.gt.r1) Write(LuWr,Fmt2//'A,I3,A)')
     &         'Warning  perturbation number ',idisp,' might diverge!'
          Call UnCompress(Kappa,dKappa,iSym)
*
          If (CI) Then
             irc=ipin(ipCId)
             Call DMinvCI(ipST,W(ipCId)%Vec, rCHC,isym)
             irc=ipin(ipST)
             deltaC=ddot_(nConf1,W(ipST)%Vec,1,W(ipCId)%Vec,1)
             irc=ipout(ipcid)
          Else
             deltaC=Zero
          End If
          deltaK=ddot_(nDensC,Kappa,1,Sigma,1)
          Kappa(1:nDens)=Zero
          delta=deltac+deltaK
#ifdef _DEBUGPRINT_
          If (Abs(DeltaC).lt.1.0D-12) DeltaC=Zero
          Write (LuWr,*)'DeltaK, DeltaC, Delta=',DeltaK, DeltaC, Delta
#endif

          If (delta.eq.Zero) Goto 300
          delta0=delta
#ifdef _DEBUGPRINT_
          Write (LuWr,*) 'Delta0=',Delta0
          Write (LuWr,*) 'Start ITERATIONS'
          Write (LuWr,*) 'Orb,CI=',ORB,CI
#endif
          Orb=.true.
          TimeDep=.false.
          ReCo=-One
*                                                                      *
************************************************************************
*          I   T   E   R   A   T   I   O   N   S                       *
************************************************************************
*                                                                      *
200       Continue

          if(doDMRG)then  ! It can be deleted
            call dmrg_spc_change_mclr(RGras2(1:8),nash)
            call dmrg_spc_change_mclr(RGras2(1:8),nrs2)
          end if

*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*       O R B I T A L    P A R T
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
           If (orb) Then
*                                                                      *
************************************************************************
*                                                                      *
*                      ~    ~
*            Construct F,(ij|kl)
*                                                                      *
************************************************************************
*                                                                      *

             irc=ipnout(-1)
             Call RInt_generic(dKappa,rmoaa,rdum,
     &                         Sc2,Temp3,Temp4,
     &                         Sc3,isym,reco,jspin)
             Clock(iTimeKK)=Clock(iTimeKK)+Tim2

*                                                                      *
************************************************************************
*                                                                      *
*            kappa->CI
*
*            H(kappa)|0>
*
*                [2]
*            S1=E   k ( kappa TO CI )
*                                                                      *
************************************************************************
*                                                                      *
             If (CI) Then
                Call CISigma(jspin,State_Sym,pstate_sym,
     &                       Temp4,nDens2,rmoaa,SIZE(rmoaa),rdum,1,
     &                       ipCI,ipS1,.True.)
                Clock(iTimeKC)=Clock(iTimeKC)+Tim3
#ifdef _DEBUGPRINT_
                irc=ipin(ipCI )
                irc=ipin(ipS1 )
                Write (LuWr,*) 'CISigma'
                Call RecPrt('CI ','(3F10.4)',W(ipCI )%Vec,1,nConf1)
                Call RecPrt('S1 ','(3F10.4)',W(ipS1 )%Vec,1,nConf1)
                Write (LuWr,*) 'CI=',DDot_(nConf1,W(ipCI)%Vec,1,
     &                                            W(ipCI)%Vec,1)
                Write (LuWr,*) 'S1=',DDot_(nConf1,W(ipS1)%Vec,1,
     &                                            W(ipS1)%Vec,1)
                Write (LuWr,*) 'End CISigma'
#endif
*
*               This will give us a better
*               convergence in the PCG. Notice that
*
*               ~Inactive     ~
*               E        + <0|H|0> = 0
*
*               when the wavefunction is converged.
*
                irc=ipin(ipS1)
                If (isym.eq.1) Then
                   irc=ipin(ipCI)
                   rGrad=DDot_(nconf1,W(ipCI)%Vec,1,W(ipS1)%Vec,1)
                   call daxpy_(nConf1,-rgrad,W(ipCI)%Vec,1,
     &                                       W(ipS1)%Vec,1)
                End IF
                call dscal_(nconf1,Two,W(ipS1)%Vec,1)
*
                irc=opout(ipCI)
             End If
*                                                                      *
************************************************************************
*                                                                      *
           End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*       C I    P A R T
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
           If (CI) Then
*                                                                      *
************************************************************************
*                                                                      *
*                  [2]
*            S2 = E   CID  ( CI TO CI ) = <i|H|d> -E<i|d>
*                                                                      *
************************************************************************
*                                                                      *
              irc=ipnout(-1)
              Call CISigma(0,PState_Sym,Pstate_sym,
     &                     FIMO,SIZE(FIMO),Int2,SIZE(Int2),rdum,1,ipCId,
     &                     ipS2,.True.)
              EC=rin_ene+potnuc-ERASSCF(1)

              irc=ipin(ipCId)
              irc=ipin(ipS2)
              Call DaXpY_(nConf1,EC,W(ipCId)%Vec,1,W(ipS2)%Vec,1)
              Call DSCAL_(nConf1,Two,W(ipS2)%Vec,1)
              Clock(iTimeCC)=Clock(iTimeCC)+Tim4
              irc=ipout(ipS2)
              irc=opout(ipCId)
              irc=opout(ipCI)
*                                                                      *
************************************************************************
*                                                                      *
*             CI -> Kappa
*
*                  [2]
*             SC3=E   CID   (SC3=F(<d|E|0>+<0|E|d>)
*                                                                      *
************************************************************************
*                                                                      *
              Response=.true.
              irc=ipnout(-1)
#ifdef _DEBUGPRINT_
              irc=ipin(ipCI )
              irc=ipin(ipCId)
              Call RecPrt('CI ','(3F10.4)',W(ipCI )%Vec,1,nConf1)
              Call RecPrt('CId','(3F10.4)',W(ipCId)%Vec,1,nConf1)
#endif
              Call CIDens(Response,ipCI,ipCId,
     &                    State_sym,
     &                    PState_Sym,jspin,
     &                    Pens,Dens)     ! Jeppes

#ifdef _DEBUGPRINT_
              Write (LuWr,*) 'After CIDens'
              Write (LuWr,*) 'P=',DDot_(n2dens,Pens,1,Pens,1)
              Write (LuWr,*) 'De=',DDot_(n1dens,Dens,1,Dens,1)
#endif
*
*             density for inactive= 2(<d|0>+<0|d>)
*
              d_0=Zero
*
*             This is just for debugging purpose.
*             When we use it for actual calculations d_0 == 0
*
              If (isym.eq.1) Then
                 irc=ipin(ipCI)
                 irc=ipin(ipCid)
                 d_0=ddot_(nconf1,W(ipCid)%Vec,1,W(ipCI)%Vec,1)
              End If
              If (Response) d_0=d_0*Two
*

              Call FockGen(d_0,Dens,Pens,Sc1,Sc3,isym)    ! Made
*                                                                      *
************************************************************************
*                                                                      *
           End If
*                                                                      *
************************************************************************
*                                                                      *
*        Sc1  kappa-> kappa
*        Sc3  CI -> kappa
*        S1   kappa -> CI
*        S2   CI -> CI
*        dKap present step
*        Kap  kappaX
*        CIT  CIX
*        CId  present step
*                                                                      *
************************************************************************
*                                                                      *
*        Add together
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
           Write (LuWr,*) 'Add together!'
           Write (LuWr,*) 'dKap=',DDot_(nDens,dKappa,1,dKappa,1)
           Write (LuWr,*) 'Sc2=',DDot_(nDens,Sc2,1,Sc2,1)
           If (CI) Then
              Write (LuWr,*) 'Sc3=',DDot_(nDens,Sc3,1,Sc3,1)
              irc=pin1(ipS2,nconf1)
              Write(LuWr,*)'S2=',DDot_(nConf1,W(ipS2)%Vec,1,
     &                                        W(ipS2)%Vec,1)
              irc=pin1(ipS1,nconf1)
              Write(LuWr,*)'S1=',DDot_(nConf1,W(ipS1)%Vec,1,
     &                                        W(ipS1)%Vec,1)
           End If
           Write (LuWr,*)
#endif
           irc=ipnout(-1)
           if (CI) then
              Call DZaXpY(nDens,One,Sc2,1,Sc3,1,Sc1,1)
           Else
              call dcopy_(nDens,Sc2,1,Sc1,1)
           End If
           Call Compress(Sc1,Temp4,isym)   ! ds
           Call Compress(dKappa,Temp2,isym)  ! DX
           If (CI) Then
              irc=ipin1(ipS1,nconf1)
              irc=ipin1(ipS2,nconf1)
              Call DaXpY_(nConf1,One,W(ipS2)%Vec,1,W(ipS1)%Vec,1)
              irc=opout(ipS2)
           End If
*                                                                      *
************************************************************************
*                                                                      *
*                ######   #####   #####
*                #     # #     # #     #
*                #     # #       #
*                ######  #       #  ####
*                #       #       #     #
*                #       #     # #     #
*                #        #####   #####
*                                                                      *
************************************************************************
*                                                                      *
*                     delta
*          rAlpha=------------
*                 dKappa:dSigma
*
           rAlphaC=Zero
           rAlphaK=Zero
           irc=ipin(ipS1)
           irc=ipin(ipCId)
           If (orb) rAlphaK=DDot_(nDensC,Temp4,1,Temp2,1)
           If (CI)  rAlphaC=DDot_(nConf1,W(ipS1)%Vec,1,
     &                                   W(ipCId)%Vec,1)
           rAlpha=delta/(rAlphaK+rAlphaC)
#ifdef _DEBUGPRINT_
           Write (LuWr,*) 'At PCG'
           Write (LuWr,*) 'S1=',
     &                      DDot_(nConf1,W(ipS1 )%Vec,1,
     &                                   W(ipS1 )%Vec,1)
           Write (LuWr,*) 'CId=',
     &                      DDot_(nConf1,W(ipCId)%Vec,1,
     &                                   W(ipCId)%Vec,1)
           Write (LuWr,*) 'rAlphaK, rAlphaC, rAlpha=',
     &                     rAlphaK, rAlphaC, rAlpha
#endif
*                                                                      *
************************************************************************
*                                                                      *
*          Kappa=Kappa+rAlpha*dKappa
*          Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa
*
           If (orb) Then
             Call DaxPy_(nDensC,ralpha,Temp2,1,Kappa,1)
             Call DaxPy_(nDensC,-ralpha,Temp4,1,Sigma,1)
              resk=sqrt(ddot_(nDensC,Sigma,1,Sigma,1))
           End If
           resci=Zero
           If (CI) Then
              irc=ipin(ipCIT)
              Call DaXpY_(nConf1,ralpha,W(ipCId)%Vec,1,W(ipCIT)%Vec,1)
              irc=ipout(ipCIT)
              irc=ipin1(ipST,nconf1)
              irc=ipin(ipS1)
              Call DaXpY_(nConf1,-ralpha,W(ipS1)%Vec,1,W(ipST)%Vec,1)
              irc=opout(ipS1)
              irc=ipin(ipST)
              resci=sqrt(ddot_(nconf1,W(ipST)%Vec,1,W(ipST)%Vec,1))
           End If
*                                                                      *
************************************************************************
*                                                                      *
*          Precondition......
*             -1
*          S=M  Sigma
*
          irc=opout(ipCID)
          irc=ipin(ipS2)
          If (CI) Call DMinvCI(ipST,W(ipS2)%Vec,rCHC,isym)
          irc=opout(ipCI)
          irc=opout(ipdia)
*
          irc=ipin(ipPre2)
          Call DMInvKap(W(ipPre2)%Vec,Sigma,nDens2+6,
     &                  Sc2,nDens2+6,Sc1,nDens2+6,iSym,iter)
          irc=opout(ippre2)
*                                                                      *
************************************************************************
*                                                                      *
*               s:Sigma
*          Beta=-------
*                delta
*
*          delta=s:sigma
*
*          dKappa=s+Beta*dKappa
*
           If (CI) Then
              irc=ipin(ipS2)
              irc=ipin(ipST)
              deltaC=ddot_(nConf1,W(ipST)%Vec,1,W(ipS2)%Vec,1)
              irc=ipout(ipST)
           Else
              deltaC=Zero
           End If
*
           deltaK=ddot_(nDensC,Sigma,1,Sc2,1)
           If (.not.CI) Then
              rBeta=deltaK/delta
              delta=deltaK
              Call DScal_(nDensC,rBeta,Temp2,1)
              Call DaXpY_(nDensC,One,Sc2,1,Temp2,1)
           Else
              rbeta=(deltac+deltaK)/delta
              delta=deltac+deltaK
              irc=ipin(ipCID)
              Call DScal_(nConf1,rBeta,W(ipCID)%Vec,1)
              Call DScal_(nDensC,rBeta,Temp2,1)
              irc=ipin(ipS2)
              Call DaXpY_(nConf1,One,W(ipS2)%Vec,1,W(ipCID)%Vec,1)
              Call DaXpY_(nDensC,One,Sc2,1,Temp2,1)
              irc=opout(ipS2)
              irc=ipout(ipCID)
           End If
#ifdef _DEBUGPRINT_
           Write (LuWr,*) 'rBeta, DeltaK, DeltaC=',
     &                     rBeta, DeltaK, DeltaC
#endif
*                                                                      *
************************************************************************
*                                                                      *
*    ######  #    #  #####        #####    ####    ####
*    #       ##   #  #    #       #    #  #    #  #    #
*    #####   # #  #  #    #       #    #  #       #
*    #       #  # #  #    #       #####   #       #  ###
*    #       #   ##  #    #       #       #    #  #    #
*    ######  #    #  #####        #        ####    ####
*                                                                      *
************************************************************************
*                                                                      *
           Call UnCompress(Temp2,dKappa,isym)
*
           res=Zero ! dummy initialize
           res_tmp=-One
           If (iBreak.eq.1) Then
              If (abs(delta).lt.abs(Epsilon**2*delta0)) Goto 300
           Else If (ibreak.eq.2) Then
              res=sqrt(resk**2+resci**2)
              if (doDMRG) then ! yma
!                write(*,*)"resk**2, resci**2",resk**2,resci**2
                res=sqrt(resk**2+resci**2)
                ! And a bit loose in DMRG case
                If (res.lt.abs(epsilon)) Goto 300
                if (sqrt(resk**2).lt.abs(epsilon))then
                  if (abs(res_tmp-sqrt(resci**2)).lt.1.0e-06)then
                    goto 300
                  end if
                end if
                res_tmp=sqrt(resci**2)
              else
                If (res.lt.abs(epsilon)) Goto 300
              end if
           Else
              If (abs(delta).lt.abs(Epsilon**2*delta0).and.
     &            res.lt.abs(epsilon))  Goto 300
           End If
           If (iter.ge.niter) goto 210
           If (lprint)
     &     Write(LuWr,Fmt2//'A,i2,A,F12.7,F12.7,F12.7,F12.7,F12.7)')
     &            '     ',
     &            iter,'       ',delta/delta0,resk,resci,deltac,deltak

           iter=iter+1

          Goto 200
*                                                                      *
************************************************************************
*                                                                      *
 210      Continue
          Write(LuWr,Fmt2//'A,I4,A)')
     &    'No convergence for perturbation no: ',
     &                      idisp,'. Increase Iter.'
          converged(isym)=.false.
          fail=.true.
#ifdef _MOLCAS_MPP_
*         Set the global flag to signal a process failed
          If (Is_Real_Par()) Then
             dfail=One
             Call GA_Acc(iglfail,1,1,1,1,dfail,1,One)
          End If
#endif
*
C         Goto 310
          Go To 999
*
 300      Write(LuWr,Fmt2//'A,I4,A,I4,A)')
     &           'Perturbation no: ',idisp,' converged in ',
     &             iter-1,' steps.'
          irc=ipnout(-1)
*310      Continue
*                                                                      *
************************************************************************
*                                                                      *
*         Write response to disk                                       *
*                                                                      *
************************************************************************
*                                                                      *
*
C         Write(LuWr,Fmt2//'A)')'Writing response to one-file.'
          Write(LuWr,*)
          iLen=ndensC
          iKapDisp(iDisp)=iDis
          Call dDaFile(LuTemp,1,Kappa,iLen,iDis)
          iSigDisp(iDisp)=iDis
          Call dDaFile(LuTemp,1,Sigma,iLen,iDis)
          If (CI) Then
             ilen=nconf1
             iCIDisp(iDisp)=iDis
             irc=ipin(ipCIT)
             Call dDaFile(LuTemp,1,W(ipCIT)%Vec,iLen,iDis)
             iCISigDisp(iDisp)=iDis
             irc=ipin(ipST)
             Call dDaFile(LuTemp,1,W(ipST)%Vec,iLen,iDis)
          End If
*
          If (CI) Then
          End If

          Call mma_deallocate(Temp4)
          Call mma_deallocate(Temp3)
          Call mma_deallocate(Temp2)
          Call mma_deallocate(Temp1)
          Call mma_deallocate(Sigma)
          Call mma_deallocate(dKappa)
          Call mma_deallocate(Kappa)
          Call mma_deallocate(Sc3)
          Call mma_deallocate(Sc2)
          Call mma_deallocate(Sc1)
          If (allocated(rmoaa)) Call mma_deallocate(rmoaa)
          If (CI) Then
             Call mma_deallocate(Pens)
             Call mma_deallocate(Dens)
          End If
      Go To 888
 999  Continue
      If(nProcs.ge.2) Then
       Write (LuWr,*)
       Write (LuWr,*) ' Perturbations were printed only by master node'
       Write (LuWr,*)
      End If

      Call Free_Tsk(id)
      Call mma_deallocate(List)
*                                                                      *
************************************************************************
*                                                                      *
*      Free all memory and remove from disk all data
*      related to the last symmetry
*
      If (CI) Then
         irc=ipclose(ipdia)
      Else
         irc=ipclose(ipPre2)
      End If
*
      Call Exp_Close()
*                                                                      *
************************************************************************
*                                                                      *
*     Flush the output from the other nodes.
*
      Do iRank = 1, nProcs-1
         Call GASync()
         If (iRank.eq.MyRank) Then
            ReWind(LuWr)
 777        Read(LuWr,'(A)',END=778) Line
            Write (LuWr_Save,*) Line
            Go To 777
 778        Continue
         End If
         Call GASync()
      End Do
      If (MyRank.ne.0) Then
         Close(LuWr)
         LuWr=LuWr_save
      End If
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write(LuWr,*)  '****************************************',
     &               '****************************************'
      Write(LuWr,*)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Final synchronization of the fail flag
#ifdef _MOLCAS_MPP_
      If (Is_Real_Par()) Then
         Call GAdGOp_Scal(dfail,'max')
         Fail=Fail.or.(dfail.gt.0.0d0)
      End If
#endif
      If (Fail) Call Quit_OnConvError()
*                                                                      *
************************************************************************
*                                                                      *
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ZBLTP(ISM,MAXSYM,IDC,ICBLTP,IMMLST)
! Generate vector ICBLTP giving type of each block
!
! ICBLTP gives type of symmetry block :
! = 0 : symmetry block is not included
! = 1 : symmetry block is included, all OO types
! = 2 : symmetry block is included, lower OO types

use Symmetry_Info, only: Mul
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ISM, MAXSYM, IDC, IMMLST(MAXSYM)
integer(kind=iwp), intent(out) :: ICBLTP(MAXSYM)
integer(kind=iwp) :: IASYM, IBSYM

! Changed to simplify structure for IDC <= 2
if (IDC <= 2) then
  ! No spatial degeneracy
  do IASYM=1,MAXSYM
    IBSYM = Mul(IASYM,ISM)
    if ((IDC == 2) .and. (IBSYM > IASYM)) then
      ! Symmetry block excluded
      ICBLTP(IASYM) = 0
    else if (((IDC == 2) .and. (IASYM > IBSYM)) .or. (IDC == 1)) then
      ! Complete symmetry block included
      ICBLTP(IASYM) = 1
    else
      ! Lower half  symmetry block included
      ICBLTP(IASYM) = 2
    end if
  end do
else
  ! Also spatial degeneracy
  do IASYM=1,MAXSYM
    IBSYM = Mul(IASYM,ISM)
    if (IBSYM == 0) cycle
    if ((((IDC == 2) .or. (IDC == 4)) .and. (IBSYM > IASYM)) .or. ((IDC == 3) .and. (IMMLST(IASYM) > IASYM))) then
      ! Symmetry block excluded
      ICBLTP(IASYM) = 0
    else if (((IDC == 2) .and. (IASYM > IBSYM)) .or. (IDC == 1) .or. ((IDC == 3) .and. (IASYM >= IMMLST(IASYM)))) then
      ! Complete symmetry block included
      ICBLTP(IASYM) = 1
    else
      ! Lower half  symmetry block included
      ICBLTP(IASYM) = 2
    end if
  end do
end if
! End of IDC switch

#ifdef _DEBUGPRINT_
write(u6,*) ' Block type of symmetry blocks'
call IWRTMA(ICBLTP,1,MAXSYM,1,MAXSYM)
#endif

end subroutine ZBLTP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Markus P. Fuelscher                              *
************************************************************************
      Subroutine DVcPrt(Title,FmtIn,X,N)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Print a vector of double precision real numbers                  *
*                                                                      *
*     calling arguments                                                *
*     Title  : character string containing a title                     *
*              If the string is empty now title will be printed        *
*     X      : vector of double precision reals                        *
*     N      : dimension of vector X                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher                                                  *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Character*(*) Title
      Character*(*) FmtIn
      Dimension X(N)
      Integer StrnLn
      Parameter (lPaper=120)
      Character*(lPaper) Line
      Character*20 FMT
*----------------------------------------------------------------------*
*     print the title                                                  *
*----------------------------------------------------------------------*
      lTitle=StrnLn(Title)
      If ( lTitle.gt.0 ) then
         Do 10 i=1,lPaper
             Line(i:i)=' '
10       Continue
         lLeft=1
         Do 20 i=lTitle,1,-1
            If ( Title(i:i).ne.' ' ) lLeft=i
20       Continue
         lLeft=lLeft-1
         Do 25 i=1,lPaper
            If ( i+lLeft.le.lTitle ) Line(i:i)=Title(i+lLeft:i+lLeft)
25       Continue
         Write(6,*)
         Write(6,'(2X,A)') Line
         Do 30 i=1,StrnLn(Line)
            Line(i:i)='-'
30       Continue
         Write(6,'(2X,A)') Line
         Write(6,'(2X,A,I6)') 'vec. size = ',N
      End If
*----------------------------------------------------------------------*
*     determine the printing format                                    *
*----------------------------------------------------------------------*
      lFmt=StrnLn(FmtIn)
      If ( lFmt.ne.0 ) then
         FMT=FmtIn
      Else
         Xmax=X(1)
         Xmin=X(1)
         Do 40 i=1,N
            Xmax=Max(Xmax,X(i))
            Xmin=Min(Xmin,X(i))
40       Continue
         Pmax=0
         If ( Abs(Xmax).gt.1.0D-72 ) Pmax=Log10(Abs(Xmax))
         iPmax=1+Int(Pmax)
         iPmax=Max(1,iPmax)
         Pmin=0
         If ( Abs(Xmin).gt.1.0D-72 ) Pmin=Log10(Abs(Xmin))
         iPmin=1+Int(Pmin)
         iPmin=Max(1,iPmin)
         nDigit=14
         nDecim=Min(8,nDigit-Max(iPmin,iPmax))
         If ( Xmax.lt.0 ) iPmax=iPmax+1
         If ( Xmin.lt.0 ) iPmin=iPmin+1
         lNumbr=Max(iPmin,iPmax)+nDecim+1
         nCols=10
         lLine=nCols*lNumbr
         If ( lLine.gt.lPaper ) then
            If ( lLine.le.lPaper+nCols .and. nDecim.gt.1 ) then
               nDecim=nDecim-1
               lNumbr=Max(iPmin,iPmax)+nDecim
               lItem=Max(lNumbr,lPaper/nCols)
            Else
               nCols=5
               lItem=Max(lNumbr,lPaper/nCols)
            End If
         Else
            lItem=lNumbr
         End If
         Write(FMT,'(A,   I2.2,  A, I2.2,  A, I2.2,   A)')
     &             '(2X,',nCols,'F',lItem,'.',nDecim,')'
      End if
*----------------------------------------------------------------------*
*     print the data                                                   *
*----------------------------------------------------------------------*
      Write(6,*)
      Write(6,FMT)(X(i),i=1,N)
*----------------------------------------------------------------------*
*     End procedure                                                    *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RdDens(d1,nd1,d2,nd2)
      Implicit Real*8(a-h,o-z)

#include "Input.fh"

#include "SysDef.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
#include "Files_mclr.fh"
      Real*8 D1(nd1),d2(nd2)
      Dimension rdum(1)
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      call dcopy_(nd1,[0.0d0],0,d1,1)
      Call Getmem('TDEND','ALLO','REAL',ipG2tt,nd2)
      Call Getmem('TDEND','ALLO','REAL',ipD2,nd2)
      Call Getmem('TDEND','ALLO','REAL',ipD1,nd1)
      call dcopy_(nd2,[0.0d0],0,Work(ipg2tt),1)
      jDisk = ITOC(3)
      Do i=1,lroots
         W=0.0d0
         Do j=1,nroots
            If (iroot(j).eq.i) W=Weight(j)
         End Do
         Call dDaFile(LUJOB ,2,Work(ipD1),nd1,jDisk)
         Call dDaFile(LUJOB ,0,rdum,nd1,jDisk)
         Call dDaFile(LUJOB ,2,Work(ipD2),ND2,jDisk)
         Call dDaFile(LUJOB ,0,rdum,ND2,jDisk)
         If (W.ne.0.0d0) Then
            call daxpy_(nd2,w,Work(ipD2),1,Work(ipG2tt),1)
            call daxpy_(nd1,w,Work(ipD1),1,D1,1)
         End If
!         Write(*,*) i,w,"LUJOB",LUJOB
!        Call Triprt('D',' ',D1,ntash)
      End Do
      Call Put_D2AV(Work(ipG2tt),nd2)
      Call Put_D1AV(D1,nd1)
*
      Do iB=1,ntash
       Do jB=1,iB
        iDij=iTri(ib,jB)
        Do kB=1,ib
         Do lB=1,kB
          iDkl=iTri(kB,lB)
          fact=1.0d00
          if(iDij.ge.iDkl .and. kB.eq.lB) fact=2.0d00
          if(iDij.lt.iDkl .and. iB.eq.jB) fact=2.0d00
          iijkl=itri(iDij,iDkl)
          D2(iijkl)=Fact*Work(ipG2tt+iijkl-1)
         End Do
        End Do
       End Do
      End Do
c
      Call Getmem('TDEND','FREE','REAL',ipG2tt,nd2)
      Call Getmem('TDEND','FREE','REAL',ipD2,nd2)
      Call Getmem('TDEND','FREE','REAL',ipD1,nd1)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Aniso_Lines_Exchange3(Jex,N1,N2,S1,S2,HAM)
! this Subroutine calculates the Lines exchange interaction between
! two sites, of the one interacting pair

use Constants, only: Zero, cZero, cOne
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Jex(3)
integer(kind=iwp), intent(in) :: N1, N2
complex(kind=wp), intent(in) :: S1(3,N1,N1), S2(3,N2,N2)
complex(kind=wp), intent(out) :: HAM(N1,N1,N2,N2)
integer(kind=iwp) :: i2, j2, l
complex(kind=wp) :: Jc(3)
real(kind=wp), external :: dnrm2_

if ((N1 <= 0) .or. (N2 <= 0)) return
Ham(:,:,:,:) = cZero
if (dnrm2_(3,Jex,1) == Zero) return

Jc(:) = -Jex(:)*cOne

do i2=1,N2
  do j2=1,N2

    do l=1,3
      HAM(:,:,i2,j2) = HAM(:,:,i2,j2)+Jc(l)*S1(l,:,:)*S2(l,i2,j2)
    end do

  end do
end do

return

end subroutine Aniso_Lines_Exchange3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE CONFIG(NREF,IOCR,nIOCR,L0,L1,L2,L3,JSYM,JSY,INTNUM,
     &                  LSYM,JJS,ISO,LV,IFCORE,ICOR,NONE,JONE,JREFX,
     &                  NFREF)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IOCR(nIOCR),L0(*),L1(*),L2(*),L3(*),JSYM(*),JSY(*),
     &          JJS(*),ISO(*),ICOR(*),JONE(*),JREFX(*)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      COMMON/D/JNDX(500 000)
      DIMENSION IOC(55),ISP(55)
*
      JSYL=30000
      JSYLL=3000
      JRX=9000
      IBS=0
      IEL=2
      LSYM=1
      NFREF=0
      LNS=NIORB+LV+1
* Compute wave function symmetry
      IRR=0
      DO 5 I=LNS,LN
        IRR=IRR+1
        IF(IOCR(IRR).EQ.1)LSYM=MUL(LSYM,NSM(I))
5     CONTINUE
      WRITE(IW,'(6X,A,I3)') 'WAVE-FUNCTION SYMMETRY LABEL:', LSYM

* Initialize arrays JJS, JNDX, ICASE, JSY
      DO 3 I=1,18
        JJS(I)=0
3     CONTINUE
C CONSTRUCT JNDX
* ILIM=2 or ILIM=4 was set by input: Normally 4, but 2 if keyword FIRST
* has been given. ILIM is in integ.fh
      INTOT=IRC(ILIM)
      DO 1 I=1,INTOT
        JNDX(I)=0
1     CONTINUE
      DO 2 J=1,MXCASE
        ICASE(J)=0
2     CONTINUE
      DO 4 I=1,JSYLL
        JSY(I)=0
4     CONTINUE
      JND=0
      LMN=0

      DO 10 IIJ=1,ILIM
* Special cases:
      JRC(IIJ)=LMN
      IF(N.eq.0 .and. IIJ.gt.1) goto 10
      IF(N.eq.1 .and. IIJ.gt.2) goto 10
      IF(N.eq.2 .and. ISPIN.eq.1 .and. IIJ.eq.3) goto 10
      IF(N.eq.2 .and. ISPIN.eq.3 .and. IIJ.eq.4) goto 10
* ISTA is actually an offset, not a start point.
      ISTA=(IIJ-1)*MXVERT
* Element in row IJJ=IV0+1-IIJ of the tables is the top vertex, for
* IIJ=1 (Valence), 2 (Singles), 3 (Doubles T), 4 (Doubles S).
* It is found as element ISTA+IJJ of arrays L0, L1 etc.
      IJJ=IV0+1-IIJ
      KM=1
      J2(KM)=IJJ
11    KM=KM+1
      IWAY(KM)=0
12    KM1=KM-1
* At KM, trying for a way down.
      IF(L0(ISTA+J2(KM1)).EQ.0.OR.IWAY(KM).GE.1)GO TO 14
* IWAY is 0, and the next vertex L0(ISTA+J2(KM1)) is actually there:
      J2(KM)=L0(ISTA+J2(KM1))
      IWAY(KM)=1
      IOC(KM1)=0
      ISP(KM1)=0
      GO TO 20

14    IF(L1(ISTA+J2(KM1)).EQ.0.OR.IWAY(KM).GE.2)GO TO 15
* IWAY is 1, and the next vertex is actually there:
      J2(KM)=L1(ISTA+J2(KM1))
      IWAY(KM)=2
      IOC(KM1)=1
      ISP(KM1)=1
      GO TO 20

15    IF(L2(ISTA+J2(KM1)).EQ.0.OR.IWAY(KM).GE.3)GO TO 16
* IWAY is 2, and the next vertex is actually there:
      J2(KM)=L2(ISTA+J2(KM1))
      IWAY(KM)=3
      IOC(KM1)=1
      ISP(KM1)=2
      GO TO 20

16    IF(L3(ISTA+J2(KM1)).EQ.0.OR.IWAY(KM).GE.4)GO TO 17
* IWAY is 3, and the next vertex is actually there:
      J2(KM)=L3(ISTA+J2(KM1))
      IWAY(KM)=4
      IOC(KM1)=2
      ISP(KM1)=3
      GO TO 20

17    KM=KM-1
* No more ways to try from this vertex. Up to higher vertex:
      IF(KM.EQ.1)GO TO 10
* If KM was 1, then finish this IIJ value and do next one.
* Else, goto 12, to take new route from the higher vertex.
      GO TO 12

20    CONTINUE
* While trying to find a new wav through the graph, we found
* a feasible edge from a vertex J2(KM) to a vertex at level KM1.
      IF(KM1.EQ.NIORB+LV)IBS=IB(J2(KM))
      IF(KM.NE.LN+1)GO TO 11
* KM has reached top of the graph.

      JND=JND+1
* A formally legal way was found. Should it be accepted?
      NSJ=1
      INHOLE=0
      DO 110 I=1,LN
       IF(IOC(I).EQ.1)NSJ=MUL(NSJ,NSM(I))
       IF(I.LE.NIORB+LV.AND.I.GT.LV)INHOLE=INHOLE+2-IOC(I)
110   CONTINUE
C     STRIKE OUT INTERNAL CONFIGURATIONS
      IPART=0
      IF(JND.GT.IRC(1))IPART=IPART+1
      IF(JND.GT.IRC(2))IPART=IPART+1
      IF(IPART.EQ.0.AND.NSJ.NE.LSYM)GO TO 12
C     TEST IF TO HIGHLY EXCITED
C     TEST ALSO IF REFERENCE STATE
      IFEXC=0
      IFREF=0
      JJ1=0
      DO 111 IREF=1,NREF
      JHOLE=0
      JPART=IPART
      DO 112 I=1,LN
      IF(I.GT.LV)GO TO 250
      IDIF=IOC(I)
      GO TO 251
250   IF(I.GT.NIORB+LV)GO TO 252
      IDIF=IOC(I)-2
      GO TO 251
252   JJ1=JJ1+1
      IF(IOC(I).EQ.IOCR(JJ1))GO TO 112
      IDIF=IOC(I)-IOCR(JJ1)
251   IF(IDIF.GT.0)GO TO 114
      JHOLE=JHOLE-IDIF
      GO TO 112
114   JPART=JPART+IDIF
112   CONTINUE
      If (JPART.NE.JHOLE) Then
         Write (6,*) 'Config: JPART.NE.JHOLE'
         Write (6,*) 'JPART,JHOLE=',JPART,JHOLE
         Call Abend
      End If
      IF(JPART.LE.IEL)IFEXC=1
      IF(JPART.EQ.0)IFREF=1
111   CONTINUE
      IF(IFEXC.EQ.0)GO TO 12
      IF(IPART.NE.2.OR.INTNUM.EQ.0)GO TO 115
C     INTERACTING SPACE
      IF(INHOLE.EQ.2.AND.IBS.NE.0)GO TO 12
C     NO CORE-CORE CORRELATION
115   IF(IFCORE.EQ.0)GO TO 116
      NCORR=0
      DO 117 I=1,LN
      IF(ICOR(I).EQ.0)GO TO 117
      NCORR=NCORR+2-IOC(I)
117   CONTINUE
      IF(NCORR.GT.1)GO TO 12
C     SINGLY OCCUPIED ORBITALS
116   IF(NONE.EQ.0)GO TO 118
      DO 119 I=1,NONE
      IF(IOC(JONE(I)).NE.1)GO TO 12
119   CONTINUE
118   LMN=LMN+1
      L=JND
      IND=LMN
      JNDX(L)=IND
      IF(IIJ.EQ.1) THEN
C CONSTRUCT INDEX LIST FOR REFERENCE STATES
        If (LMN.GT.JRX) Then
           Write (6,*) 'Config: LMN.GT.JRX'
           Write (6,*) 'LMN,JRX=',LMN,JRX
           Write (6,*) 'This error is almost certainly that the problem'
           Write (6,*) ' at hand requires larger arrays than GUGA is'
           Write (6,*) ' compiled for. Please check your input against'
           Write (6,*) ' the manual. If you are certain that this'
           Write (6,*) ' calculation should be possible, please report'
           Write (6,*) ' this as a bug to the Molcas developers. Use'
           Write (6,*) ' the link ''http://www.teokem.lu.se/molcas'' '
           Write (6,*) ' and then ''Entry for Users'' and'
           Write (6,*) ' ''Report a new bug''.'
           Call Abend
        End If
        JREFX(LMN)=0
        IF(IFREF.EQ.0)GO TO 210
        NFREF=NFREF+1
        JREFX(LMN)=NFREF
      END IF

 210  CONTINUE
      JRC(IIJ)=LMN
      IF(LMN.GT.JSYL)GO TO 985
      JSYM(LMN)=NSJ
      IF(IIJ.LE.2)GO TO 985
      NSJ1=NSJ+1
      IF(IIJ.EQ.3)JJS(NSJ1)=JJS(NSJ1)+1
      IF(IIJ.EQ.4)JJS(NSJ1+9)=JJS(NSJ1+9)+1

 985  CONTINUE
      M=(LMN-1)*LN
      If (M+LN.GT.ISPA) Then
         Write (6,*) 'Config: M+LN.GT.ISPA'
         Write (6,*) 'M,LN,ISPA=',M,LN,ISPA
         Write (6,*) 'This error may be due to a bug.'
         Write (6,*) ' Please check your input against the manual.'
         Write (6,*) ' If there is no input errors, please report'
         Write (6,*) ' this as a bug to the Molcas developers. Use'
         Write (6,*) ' the link ''http://www.teokem.lu.se/molcas'' '
         Write (6,*) ' and then ''Entry for Users'' and'
         Write (6,*) ' ''Report a new bug''.'
         Call Abend
      End If
      DO 130 K=1,LN
      ISO(M+K)=ISP(K)
130   CONTINUE
      GO TO 12
 10   CONTINUE

      JRC(ILIM)=LMN
      WRITE(IW,214)
214   FORMAT(//,6X,'INTERNAL CONFIGURATIONS (REAL)')
      IX1=JRC(1)
      IX2=JRC(2)-JRC(1)
      IF(IFIRST.NE.0)GO TO 205

*      IF(N.EQ.2) JRC(3)=JRC(2)

      IX3=JRC(3)-JRC(2)
      IX4=JRC(4)-JRC(3)
      WRITE(IW,215)IX1,IX2,IX3,IX4
215   FORMAT(/,6X,'NUMBER OF VALENCE STATES',I16,
     */,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7,
     */,6X,'NUMBER OF TRIPLET COUPLED DOUBLES',I7,
     */,6X,'NUMBER OF SINGLET COUPLED DOUBLES',I7)
      If (LMN.GT.JSYL) Then
         Write (6,*) 'Config: LMN.GT.JSYL'
         Write (6,*) 'LMN,JSYL=',LMN,JSYL
         Call Abend()
      End If
      If (IX1.GE.8192.OR.IX2.GE.8192.OR.
     &    IX3.GE.8192.OR.IX4.GE.8192) Then
         Write (6,*) 'Config: IX?.GE.8192'
         Write (6,*) 'IX1,IX2,IX3,IX4=',IX1,IX2,IX3,IX4
         Write (6,*) 'This error is almost certainly that the problem'
         Write (6,*) ' at hand requires larger arrays than GUGA is'
         Write (6,*) ' compiled for. Please check your input against'
         Write (6,*) ' the manual. If you are certain that this'
         Write (6,*) ' calculation should be possible, please report'
         Write (6,*) ' this as a bug to the Molcas developers. Use'
         Write (6,*) ' the link ''http://www.teokem.lu.se/molcas'' '
         Write (6,*) ' and then ''Entry for Users'' and'
         Write (6,*) ' ''Report a new bug''.'
         Call Abend()
      End If
C     SORT BY SYMMETRY
      IF(NSYM.EQ.1)GO TO 410
      ITU=2
400   IRC1=IRC(ITU)+1
      IRC2=IRC(ITU+1)
      JRC1=JRC(ITU)+1
      JRC2=JRC(ITU+1)
      JRC21=JRC2-1
      IF(JRC21.LT.JRC1)GO TO 401
      DO 402 I=JRC1,JRC21
      I1=I+1
      DO 403 J=I1,JRC2
      IF(JSYM(J).GE.JSYM(I))GO TO 403
      ITEMP=JSYM(I)
      JSYM(I)=JSYM(J)
      JSYM(J)=ITEMP
      M1=(I-1)*LN
      M2=(J-1)*LN
      DO 404 K=1,LN
      ITEMP=ISO(M1+K)
      ISO(M1+K)=ISO(M2+K)
      ISO(M2+K)=ITEMP
404   CONTINUE
      DO 420 K=IRC1,IRC2
      IF(JNDX(K).NE.I)GO TO 421
      JNDX(K)=J
      GO TO 420
421   IF(JNDX(K).NE.J)GO TO 420
      JNDX(K)=I
420   CONTINUE
403   CONTINUE
402   CONTINUE
401   IF(ITU.EQ.3)GO TO 406
      ITU=3
      GO TO 400

406   CONTINUE
* JJS(2..9): JJS(I+1)=Nr of internal triplet states per symmetry I.
* JJS(11..18): JJS(I+10)=Nr of internal singlet states per symmetry I.
      WRITE(IW,407)(JJS(I+1),I=1,NSYM)
407   FORMAT(/6X,'INTERNAL TRIPLET STATES PER SYMMETRY:',6X,8I5)
      WRITE(IW,408)(JJS(I+10),I=1,NSYM)
408   FORMAT( 6X,'INTERNAL SINGLET STATES PER SYMMETRY:',6X,8I5)
      DO 405 I=2,NSYM
       I1=I+1
       JJS(I1)=JJS(I)+JJS(I1)
       JJS(I1+9)=JJS(I+9)+JJS(I1+9)
405   CONTINUE
* Now, JJS is changed to contain instead the corresponding cumulative sum
* summed over the symmetries.
      GO TO 410

205   WRITE(IW,216)IX1,IX2
216   FORMAT(/,6X,'NUMBER OF VALENCE STATES',I16,
     */,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7)
      If (IX1.GE.8192.OR.IX2.GE.8192) Then
         Write (6,*) 'Config: IX?.GE.8192'
         Write (6,*) 'IX1,IX2=',IX1,IX2
         Call Abend()
      End If

C     PACK OCCUPATION AND SYMMETRY VECTORS FOR CI
410   LMN0=JRC(ILIM)*LN
CPAM97      M1=(LMN0+29)/30
      M1=(LMN0+14)/15
      If (M1.GT.MXCASE) Then
         Write (6,*) 'Config: M1.GT.MXCASE'
         Write (6,*) 'M1,MXCASE=',M1,MXCASE
         Call Abend()
      End If
      M=0
      DO 411 L=1,LMN
      DO 412 K=1,LN
      M=M+1
      MND=ISO(M)
C     IOCC((M+29)/30)=OR(IOCC((M+29)/30),
C    1SHIFT(MND,2*((M+29)/30*30-M)))
CPAM97      QOCC((M+29)/30)=PACK(QOCC((M+29)/30), MND, 2*M-(2*M-1)/60*60, 2)
      CALL ICPCK(ICASE,M,MND)
412   CONTINUE
CPAM97      NSJ=JSYM(L)-1
CPAM97      JSY((L+9)/10)=IOR(JSY((L+9)/10),ISHFT(NSJ,29-3*MOD(L-1,10)))
      CALL JSPCK(JSY,L,JSYM(L))
411   CONTINUE
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Wr_Cord(nAtoms)

use MPProp_globals, only: Cor, iAtomType, iAtomPar, Labe, Qnuc
use Constants, only: Angstrom
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms
integer(kind=iwp) :: i, iStdOut

iStdOut = u6

write(iStdOut,*)
write(iStdOut,'(10X,A)') ' ************************************************ '
write(iStdOut,'(10X,A)') ' **** Cartesian Coordinates / Bohr, Angstrom **** '
write(iStdOut,'(10X,A)') ' ************************************************ '
write(iStdOut,*)
write(iStdOut,'(A11,A7,A)') 'Center','Label', &
                            '              X              Y              Z                     X              Y              Z'
do i=1,nAtoms
  !Jose write(iStdOut,'(6X,I3,5X,A4,3(5X,F10.6),7X,3(5X,F10.6))')
  write(iStdOut,'(6X,I3,5X,A6,3(5X,F10.6),7X,3(5X,F10.6))') i,Labe(i),Cor(:,i,i),Cor(:,i,i)*Angstrom
end do
write(iStdOut,*)
write(iStdOut,*)
write(iStdOut,'(A11,A7,A13,A25,A20)') 'Center','Label','Atomtype','Effective core charge','Atomic Parameter'
write(iStdOut,*)
do i=1,nAtoms
  !Jose write(iStdOut,'(6X,I3,5X,A4,10X,I3,19X,F6.1,10X,I10)') i,Labe(i),
  write(iStdOut,'(6X,I3,5X,A6,10X,I3,19X,F6.1,10X,I10)') i,Labe(i),iAtomType(i),Qnuc(i),iAtomPar(i)
end do
write(iStdOut,*)

return

end subroutine Wr_Cord

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,2005, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine PLF_RI_2(AOint,ijkl,jCmp,lCmp,iAO,iAOst,jBas,lBas,kOp,TInt,nTInt,iSO2Ind,iOffA,nSOs)
!***********************************************************************
!                                                                      *
!  object: to sift and index the petite list format integrals.         *
!                                                                      *
!          the indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          May '90                                                     *
!          Modified to 2-center RI June '05                            *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use SOAO_Info, only: iAOtSO
use Basis_Info, only: nBas
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Constants, only: One
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ijkl, jCmp, lCmp, iAO(4), iAOst(4), jBas, lBas, kOp(4), nTInt, nSOs, iSO2Ind(nSOs), iOffA(4)
real(kind=wp), intent(in) :: AOint(ijkl,jCmp,lCmp)
real(kind=wp), intent(_OUT_) :: TInt(nTInt)
integer(kind=iwp) :: i2, i4, iAOj, iAOl, iAOstj, iAOstl, ij, iOff, iOffA_, iSO, jSO, jSOj, lSO, lSOl, mm_, mx, nijkl, nn
#ifdef _DEBUGPRINT_
real(kind=wp) :: r1, r2
real(kind=wp), external :: ddot_
#endif

! Note on the ordering of the basis functions (valence or auxiliary).
!
! 1) The basis functions are first ordered according to the order in which the basis sets appear in the input.
!    Hence, for example, for a heterodiatomic molecule the order of the basis sets for the centers A and B occurs
!    according to which center is first in the input.
! 2) For each basis set the basis functions are ordered in shells with fixed total angular momentum.
!    These shells are given running shell indices, which are used to identify a particular angular shell, iS.
! 3) For a given total angular momentum, iAng, the basis sets are ordered with respect to the elements of the
!    shell. For example, for l=2, we have the basis functions ordered as m=2,1,0,-1,-2.
! 4) For each component the basis functions finally runs over all contracted basis functions of this particular shell.

! For the 2-center integrals shell 1 and 3 are dummy shells.

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
r1 = DDot_(ijkl*jCmp*lCmp,AOInt,1,[One],0)
r2 = DDot_(ijkl*jCmp*lCmp,AOInt,1,AOInt,1)
write(u6,*) ' Sum=',r1
write(u6,*) ' Dot=',r2
call RecPrt(' In Plf_RI_2: AOInt',' ',AOInt,ijkl,jCmp*lCmp)
#endif

! If the code cannot handle all the contracted functions at the same time the loop over them is partitioned.
! iAOst(:) list the starting index -- if no partitioning the value is 0.
iAOstj = iAOst(2)
iAOstl = iAOst(4)

! This is an index to be used in iAOtSO(:,:). This table lists the canonical index of the first basis function with a
! particular angular momentum element. As the basis is ordered the next contracted basis function with the same m
! value simply increment this value by one.
!
! NOTE: the auxiliary functions have canonical indices starting after the valence functions!

iAOj = iAO(2)
iAOl = iAO(4)

iOff = nBas(0) ! Number of valence functions.

iOffA_ = iOffA(1)  ! Offset to where the subsection of the A matrix for the jS shell starts
mm_ = iOffA(4)     ! mm_ (iOffA(4)): is the number of basis functions up to and including shell jS
nn = mm_-iOffA(2)  ! nn:  the number of basis functions before shell jS
                   ! iOffA(2) is the number of basis functions of shell jS
mx = nTri_Elem(nn) ! mx: is the number of elements in A before the block belonging to shell jS

#ifdef _DEBUGPRINT_
write(u6,*) 'nn,mx,mm_=',nn,mx,mm_
write(u6,*) 'mx-iOffA_=',mx-iOffA_
write(u6,*) 'iOff=',iOff
write(u6,*) 'lBas,jBas=',lBas,jBas
write(u6,*) 'lCmp,jCmp=',lCmp,jCmp
#endif

do i2=1,jCmp
  jSO = iAOtSO(iAOj+i2,kOp(2))+iAOstj-iOff ! starting canonical index for shell jS
  do i4=1,lCmp
    lSO = iAOtSO(iAOl+i4,kOp(4))+iAOstl-iOff ! starting canonical index for shell lS

    nijkl = 0
    do lSOl=lSO,lSO+lBas-1

      do jSOj=jSO,jSO+jBas-1

        iSO = iSO2Ind(jSOj)+nn
        ij = iTri(iSO,lSOl)-mx+iOffA_

        nijkl = nijkl+1
        TInt(ij) = AOint(nijkl,i2,i4)

      end do
    end do

  end do
end do

end subroutine PLF_RI_2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function recinpcmp_cvb(ifield)

use casvb_global, only: recinp, recinp_old
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: recinpcmp_cvb
integer(kind=iwp), intent(in) :: ifield
integer(kind=iwp) :: i, ioff1, ioff2, joff1, joff2
logical(kind=iwp) :: done
real(kind=wp), allocatable :: tmp1(:), tmp2(:)
logical(kind=iwp), external :: valid_cvb ! ... Files/Hamiltonian available ...

if (.not. valid_cvb(recinp_old)) then
  recinpcmp_cvb = .true.
else
  call rdioff_cvb(ifield,recinp,ioff1)
  call rdioff_cvb(ifield+1,recinp,ioff2)
  call rdioff_cvb(ifield,recinp_old,joff1)
  call rdioff_cvb(ifield+1,recinp_old,joff2)
  if (ioff2-ioff1 /= joff2-joff1) then
    recinpcmp_cvb = .true.
  else
    call mma_allocate(tmp1,ioff2-ioff1,label='tmp1')
    call mma_allocate(tmp2,joff2-joff1,label='tmp2')
    call rdlow_cvb(tmp1,ioff2-ioff1,recinp,ioff1)
    call rdlow_cvb(tmp2,joff2-joff1,recinp_old,joff1)
    done = .false.
    do i=1,ioff2-ioff1
      if (tmp1(i) /= tmp2(i)) then
        recinpcmp_cvb = .true.
        done = .true.
        exit
      end if
    end do
    if (.not. done) recinpcmp_cvb = .false.
    call mma_deallocate(tmp1)
    call mma_deallocate(tmp2)
  end if
end if

return

end function recinpcmp_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine get_maxelem (isize,array,pos,maxelem)
c
************************************************************************
c
c   This SR belongs to the test suite 'parser2'
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
      integer isize,pos,i
      real*8 array(isize),maxelem
      intrinsic ABS
c
      pos=0
      maxelem=0.0d0
      do 10 i=1,isize
        if (abs(array(i)).gt.maxelem) then
          pos=i
          maxelem=abs(array(i))
        endif
  10  continue
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!subroutine fmm_call_car_to_sph(CarMoms,SphMoms,ndim,LMAX)
!
!  use fmm_global_paras, only: INTK, REALK
!  use fmm_car_to_sph, only: fmm_init_car_to_sph, &
!                            fmm_free_car_to_sph, &
!                            fmm_transform_car_to_sph
!
!  implicit none
!  integer(INTK), intent(in) :: ndim, LMAX
!  real(REALK), intent(in)   :: CarMoms(ndim,(LMAX+1)*(LMAX+2)/2,0:LMAX)
!  real(REALK), intent(out)  :: SphMoms(ndim,2*LMAX+1,0:LMAX)
!
!  call fmm_init_car_to_sph(LMAX)
!  call fmm_transform_car_to_sph(CarMoms,SphMoms,ndim,LMAX)
!  call fmm_free_car_to_sph()
!
!end subroutine fmm_call_car_to_sph

!------------------------------------------------------------------------------

subroutine fmm_call_get_J_matrix(ndim,nBas,dens,Fock)

#include "macros.fh"

use fmm_global_paras, only: INTK, REALK
!use fmm_interface, only: fmm_get_J_matrix

implicit none
integer(INTK), intent(in)  :: ndim, nBas
real(REALK), intent(in)    :: dens(ndim)
real(REALK), intent(inout) :: Fock(ndim)

unused_var(nBas)
unused_var(dens)
unused_var(Fock)

!print *, 'Calling FMM code...'
!call fmm_get_J_matrix(1,dens(1),Fock(1))
!call fmm_get_J_matrix(nbas,dens,Fock)
!print *, 'Returning from FMM code...'

end subroutine fmm_call_get_J_matrix

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LBend(Cent,nCent,Fir,Bf,lWrite,lWarn,Label,dBf,ldB,
     &                  Axis,Perp_Axis1,Force)
      Implicit Real*8  (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8  Bf(3,nCent), xxx(3,3), dBf(3,nCent,3,nCent),
     &        BRij(3,2), dBRij(3,2,3,2),
     &        BRjk(3,2), dBRjk(3,2,3,2), Fir,
     &        uMtrx(3,3), uVec(3,3), Scr1(3,3), Scr2(3,3),
     &        Axis(3),Perp_Axis1(3), Cent(3,3)
      Logical lWrite, ldB, lWarn, Linear, Force
      Character*8 Label
*
      iRout=220
      iPrint=nPrint(iRout)
*
      Lu=6
*
*
      If (iPrint.ge.99) Then
         Write(6,*) 'LBend: Force ',Force
         Call RecPrt('LBend: Axis',' ',Axis,3,1)
         Call RecPrt('LBend: Perp_Axis1',' ',Perp_Axis1,3,1)
      End If
*
      call dcopy_(3,Axis,      1,uVec(1,1),1)
      call dcopy_(3,Perp_Axis1,1,uVec(1,2),1)
      call dcopy_(3,[Zero],0,uVec(1,3),1)
*
*---- Project the coordinates to the plane
*
      Call DGEMM_('T','N',
     &            3,3,3,
     &            1.0d0,uVec,3,
     &            Cent,3,
     &            0.0d0,xxx,3)
      xxx(3,1)=Zero
      xxx(3,2)=Zero
      xxx(3,3)=Zero
      If (iPrint.ge.99) Then
         Call RecPrt('Original coordinates','(3F24.12)',Cent,3,3)
         Call RecPrt('uVec',' ',uVec,3,3)
         Call RecPrt('Projected coordinates','(3F24.12)',xxx,3,3)
      End If
*
*.... Swap atoms to ensure the complementary angle is always Pi
*
      Middle=2
      If (Force) Then
         R1=(xxx(1,1)-xxx(1,2))**2+(xxx(2,1)-xxx(2,2))**2
         R2=(xxx(1,2)-xxx(1,3))**2+(xxx(2,2)-xxx(2,3))**2
         R3=(xxx(1,3)-xxx(1,1))**2+(xxx(2,3)-xxx(2,1))**2
         If ((R1.ge.R3).and.(R1.ge.R2)) Then
           Middle=3
         Else If (R2.ge.R3) Then
           Middle=1
         End If
      End If
      If (Middle.ne.2) Then
         Call DSwap_(3,xxx(1,2),1,xxx(1,Middle),1)
         If (iPrint.ge.99) Then
            Call RecPrt('Swapped coordinates','(3F24.12)',xxx,3,3)
         End If
      End If
*
      mCent=2
      Call Strtch(xxx(1,1),mCent,Rij1,BRij,.False.,Label,dBRij,ldB)
      Call Strtch(xxx(1,2),mCent,Rjk1,BRjk,.False.,Label,dBRjk,ldB)
*
*---- We better be very careful here in order not to lose accuracy!
*
      Co=Zero
      Crap=Zero
      Do i = 1, 3
         Co=Co+BRij(i,1)*BRjk(i,2)
      End Do
      Do i = 1, 3
         Crap = Crap + (BRjk(i,2)-Sign(One,Co)*BRij(i,1))**2
      End Do
      Crap = Sqrt(Crap)
      Linear=.True.
      If (iPrint.ge.99) Then
         Call RecPrt('BRij','(3F24.12)',BRij,3,2)
         Call RecPrt('BRjk','(3F24.12)',BRjk,3,2)
         Write (6,*) ' Rij1=',Rij1
         Write (6,*) ' Rjk1=',Rjk1
         Write (6,*) ' Diff=',Abs(ArCos(Co)-Pi)
         Write (6,'(A,F24.16)') ' Co=',Co
         Write (6,'(A,F24.16)') ' Crap=',Crap
      End If
*
*.... Special care for cases close to linearity
*
      If (Crap.lt.1.0D-4) Then
         Si=Crap
         If (Co.lt.Zero) Then
            Fir=Pi-ArSin(Si)
         Else
            Fir=ArSin(Si)
         End If
      Else
         If (Abs(Co).gt.One) Co=Sign(One,Co)
         Fir=ArCos(Co)
         Si=Sqrt(One-Co**2)
      End If
*
*     If (Abs(Fir-Pi).gt.1.0D-13) Then
      If (Abs(Si).gt.1.0D-13) Then
         If (iPrint.ge.99)
     &      Write (Lu,*) ' LBend: Use nonlinear formulae'
         Linear=.False.
      Else
         If (iPrint.ge.99) Write (Lu,*) ' LBend: Use linear formulae'
      End If
*
      dFir=180.0D0*Fir/Pi
      If (lWrite) Then
         Write (Lu,'(1X,A,A,F10.6,A,F12.8,A)') Label,
     &            ' : Projected Angle=', dFir,'/degree, ',Fir,'/rad'
      End If
*
      call dcopy_(9,[Zero],0,uMtrx,1)
      If (Linear) Then
         uMtrx(2,1)=-Sign(One,Co)/Rij1
      Else
         Do i = 1, 3
            uMtrx(i,1)=(Co*BRij(i,1)-BRjk(i,2))/(Si*Rij1)
         End Do
      End If
      Call DGEMM_('N','N',
     &            3,1,3,
     &            1.0d0,uVec,3,
     &            uMtrx,3,
     &            0.0d0,Scr2,3)
      Bf(1,1)=Scr2(1,1)
      Bf(2,1)=Scr2(2,1)
      Bf(3,1)=Scr2(3,1)
*
      call dcopy_(9,[Zero],0,uMtrx,1)
      If (Linear) Then
         uMtrx(2,1)=One/Rjk1
      Else
         Do i = 1, 3
            uMtrx(i,1)=(Co*BRjk(i,2)-BRij(i,1))/(Si*Rjk1)
         End Do
      End If
      Call DGEMM_('N','N',
     &            3,1,3,
     &            1.0d0,uVec,3,
     &            uMtrx,3,
     &            0.0d0,Scr2,3)
      Bf(1,3)=Scr2(1,1)
      Bf(2,3)=Scr2(2,1)
      Bf(3,3)=Scr2(3,1)
*
      Do i = 1, 3
*....... Utilize translational invariance.
         Bf(i,2)=-(Bf(i,1)+Bf(i,3))
      End Do
*
*---- Compute the cartesian derivative of the B-Matrix.
*
      If (ldB) Then
*
*....... 1,1 Block
*
         call dcopy_(9,[Zero],0,uMtrx,1)
         If (Linear) Then
            If (Co.gt.Zero) Then
               uMtrx(1,2)=One/Rij1**2
               If (Rij1.lt.Rjk1) uMtrx(1,2)=Two*uMtrx(1,2)
            Else
               uMtrx(1,2)=Two/Rij1**2-One/(Rij1**2+Rij1*Rjk1)
            End If
            uMtrx(2,1)=uMtrx(1,2)
         Else
            Do i = 1, 2
               Bfi1=(Co*BRij(i,1)-BRjk(i,2))/(Si*Rij1)
               Do j = 1, 2
                  Bfj1=(Co*BRij(j,1)-BRjk(j,2))/(Si*Rij1)
                  uMtrx(i,j)=( -Si*Bfi1*BRij(j,1)
     &                      +Co*dBRij(i,1,j,1)
     &                      -Bfj1*(Co*Bfi1*Rij1
     &                      +Si*BRij(i,1)) ) / (Si*Rij1)
               End Do
            End Do
         End If
         Call DGEMM_('N','T',
     &               3,3,3,
     &               1.0d0,uMtrx,3,
     &               uVec,3,
     &               0.0d0,Scr1,3)
         Call DGEMM_('N','N',
     &               3,3,3,
     &               1.0d0,uVec,3,
     &               Scr1,3,
     &               0.0d0,Scr2,3)
         dBf(1,1,1,1)=Scr2(1,1)
         dBf(2,1,1,1)=Scr2(2,1)
         dBf(2,1,2,1)=Scr2(2,2)
         dBf(3,1,1,1)=Scr2(3,1)
         dBf(3,1,2,1)=Scr2(3,2)
         dBf(3,1,3,1)=Scr2(3,3)
*
*....... 1,3 Block
*
         call dcopy_(9,[Zero],0,uMtrx,1)
         If (Linear) Then
            If (Co.gt.Zero) Then
               If (Rij1.lt.Rjk1) Then
                  uMtrx(1,2)=-One/(Rij1*Rjk1)
                  uMtrx(2,1)=Zero
               Else
                  uMtrx(1,2)=Zero
                  uMtrx(2,1)=One/(Rij1*Rjk1)
               End If
            Else
               uMtrx(1,2)=One/(Rij1**2+Rij1*Rjk1)
               uMtrx(2,1)=-One/(Rjk1**2+Rjk1*Rij1)
            End If
         Else
            Do i = 1, 2
               Bfi1=(Co*BRij(i,1)-BRjk(i,2))/(Si*Rij1)
               Do j = 1, 2
                  Bfj3= (Co*BRjk(j,2)-BRij(j,1))/(Si*Rjk1)
                  uMtrx(i,j)=(-Si*Bfi1*BRjk(j,2)
     &                      +dBRij(i,1,j,2)
     &                      -Bfj3*Co*Bfi1*Rjk1)
     &                      / (Si*Rjk1)
               End Do
            End Do
         End If
         Call DGEMM_('N','T',
     &               3,3,3,
     &               1.0d0,uMtrx,3,
     &               uVec,3,
     &               0.0d0,Scr1,3)
         Call DGEMM_('N','N',
     &               3,3,3,
     &               1.0d0,uVec,3,
     &               Scr1,3,
     &               0.0d0,Scr2,3)
         dBf(1,1,1,3)=Scr2(1,1)
         dBf(2,1,1,3)=Scr2(2,1)
         dBf(2,1,2,3)=Scr2(2,2)
         dBf(3,1,1,3)=Scr2(3,1)
         dBf(3,1,2,3)=Scr2(3,2)
         dBf(3,1,3,3)=Scr2(3,3)
*
*....... 3,1 Block
*
         call dcopy_(9,[Zero],0,uMtrx,1)
         If (Linear) Then
            If (Co.gt.Zero) Then
               If (Rjk1.lt.Rij1) Then
                  uMtrx(1,2)=One/(Rjk1*Rij1)
                  uMtrx(2,1)=Zero
               Else
                  uMtrx(1,2)=Zero
                  uMtrx(2,1)=-One/(Rjk1*Rij1)
               End If
            Else
               uMtrx(1,2)=-One/(Rjk1**2+Rjk1*Rij1)
               uMtrx(2,1)=One/(Rij1**2+Rij1*Rjk1)
            End If
         Else
            Do i = 1, 2
               Bfi3= (Co*BRjk(i,2)-BRij(i,1))/(Si*Rjk1)
               Do j = 1, 2
                  Bfj1=(Co*BRij(j,1)-BRjk(j,2))/(Si*Rij1)
                  uMtrx(i,j)=(-Si*Bfi3*BRij(j,1)
     &                      +dBRjk(i,2,j,1)
     &                      -Bfj1*Co*Bfi3*Rij1)
     &                      / (Si*Rij1)
               End Do
            End Do
         End If
         Call DGEMM_('N','T',
     &               3,3,3,
     &               1.0d0,uMtrx,3,
     &               uVec,3,
     &               0.0d0,Scr1,3)
         Call DGEMM_('N','N',
     &               3,3,3,
     &               1.0d0,uVec,3,
     &               Scr1,3,
     &               0.0d0,Scr2,3)
         dBf(1,3,1,1)=Scr2(1,1)
         dBf(2,3,1,1)=Scr2(2,1)
         dBf(2,3,2,1)=Scr2(2,2)
         dBf(3,3,1,1)=Scr2(3,1)
         dBf(3,3,2,1)=Scr2(3,2)
         dBf(3,3,3,1)=Scr2(3,3)
*
*....... 3,3 Block
*
         call dcopy_(9,[Zero],0,uMtrx,1)
         If (Linear) Then
            If (Co.gt.Zero) Then
               uMtrx(1,2)=-One/Rjk1**2
               If (Rjk1.lt.Rij1) uMtrx(1,2)=Two*uMtrx(1,2)
            Else
               uMtrx(1,2)=-Two/Rjk1**2+One/(Rjk1**2+Rjk1*Rij1)
            End If
            uMtrx(2,1)= uMtrx(1,2)
         Else
            Do i = 1, 2
               Bfi3= (Co*BRjk(i,2)-BRij(i,1))/(Si*Rjk1)
               Do j = 1, 2
                  Bfj3= (Co*BRjk(j,2)-BRij(j,1))/(Si*Rjk1)
                  uMtrx(i,j)=( -Si*Bfi3*BRjk(j,2)
     &                      +Co*dBRjk(i,2,j,2)
     &                      -Bfj3*(Co*Bfi3*Rjk1
     &                      +Si*BRjk(i,2)) ) / (Si*Rjk1)
               End Do
            End Do
         End If
         Call DGEMM_('N','T',
     &               3,3,3,
     &               1.0d0,uMtrx,3,
     &               uVec,3,
     &               0.0d0,Scr1,3)
         Call DGEMM_('N','N',
     &               3,3,3,
     &               1.0d0,uVec,3,
     &               Scr1,3,
     &               0.0d0,Scr2,3)
         dBf(1,3,1,3)=Scr2(1,1)
         dBf(2,3,1,3)=Scr2(2,1)
         dBf(2,3,2,3)=Scr2(2,2)
         dBf(3,3,1,3)=Scr2(3,1)
         dBf(3,3,2,3)=Scr2(3,2)
         dBf(3,3,3,3)=Scr2(3,3)
*
         Do i = 1, 3
            Do j = 1, i
*
               dBf(j,1,i,1)=dBf(i,1,j,1)
               dBf(j,3,i,1)=dBf(i,1,j,3)
               dBf(j,1,i,3)=dBf(i,3,j,1)
               dBf(j,3,i,3)=dBf(i,3,j,3)
*
               dBf(i,1,j,2)=-(dBf(i,1,j,1)+dBf(i,1,j,3))
               dBf(j,2,i,1)=dBf(i,1,j,2)
               dBf(j,1,i,2)=-(dBf(j,1,i,1)+dBf(j,1,i,3))
               dBf(i,2,j,1)=dBf(j,1,i,2)
               dBf(i,3,j,2)=-(dBf(i,3,j,1)+dBf(i,3,j,3))
               dBf(j,2,i,3)=dBf(i,3,j,2)
               dBf(j,3,i,2)=-(dBf(j,3,i,1)+dBf(j,3,i,3))
               dBf(i,2,j,3)=dBf(j,3,i,2)
*
               dBf(i,2,j,2)=-(dBf(i,2,j,1)+dBf(i,2,j,3))
               dBf(j,2,i,2)=dBf(i,2,j,2)
*
            End Do
         End Do
*
      End If
*
*.... Swap atoms back
*
      If (Middle.ne.2) Then
         Call DSwap_(3,Bf(1,2),1,Bf(1,Middle),1)
         If (ldB) Then
           Call DSwap_(3*nCent*3,dBf(1,1,1,2),1,dBf(1,1,1,Middle),1)
           Call DSwap_(3*nCent,dBf(1,2,1,1),3*nCent,
     &                         dBf(1,Middle,1,1),3*nCent)
           Call DSwap_(3*nCent,dBf(2,2,1,1),3*nCent,
     &                         dBf(2,Middle,1,1),3*nCent)
           Call DSwap_(3*nCent,dBf(3,2,1,1),3*nCent,
     &                         dBf(3,Middle,1,1),3*nCent)
         End If
      End If
*
      If (iPrint.ge.99) Then
         Call RecPrt('Bf',' ',Bf,3,nCent)
         If (ldB) Then
            Call RecPrt('dBf',' ',dBf,3*nCent,3*nCent)
         End If
      End If
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(lWarn)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine o12eb_cvb(nparm1,
     >  dxnrm,grdnrm,close2conv)
      implicit real*8 (a-h,o-z)
      logical close2conv
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "opt2_cvb.fh"
#include "WrkSpc.fh"

      call o12eb2_cvb(work(lv(1)),work(lv(2)),nparm1,nvb,
     >  nfrorb,
     >  work(lw(4)),work(lw(5)),work(lw(6)),
     >  work(ix(1)),
     >  dxnrm,grdnrm,close2conv,strucopt)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C     Inverts a square matrix
C
      Subroutine MatInvert(A,n)
      Implicit None
#include "stdalloc.fh"
      Real*8 :: A(*)
      Integer :: n,err,nw
      Integer, Dimension(:), Allocatable :: ipiv
      Real*8, Dimension(:), Allocatable :: wrk
      Real*8 :: dum(1)
      Call mma_allocate(ipiv,n)
      Call dGeTRF_(n,n,A,n,ipiv,       err)
      Call dGeTRI_(n,  A,n,ipiv,dum,-1,err)
      nw=Int(dum(1))
      Call mma_allocate(wrk,nw)
      Call dGeTRI_(n,  A,n,ipiv,wrk,nw,err)
      Call mma_deallocate(ipiv)
      Call mma_deallocate(wrk)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_Allo_iScr(DoDummy)
!
! Purpose: allocate iScr array for reading and reordering vectors.
!          If (DoDummy): make dummy (length 1) allocation.

use Cholesky, only: iScr, nnBstR, nSym
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: DoDummy
integer(kind=iwp) :: iSym, l_iScr

if (DoDummy) then
  l_iScr = 1
else
  l_iScr = nnBstR(1,1)
  do iSym=2,nSym
    l_iScr = max(l_iScr,nnBstR(iSym,1))
  end do
end if
call mma_allocate(iScr,l_iScr,Label='iScr')

end subroutine Cho_Allo_iScr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1992, Roland Lindh                                *
************************************************************************
      SubRoutine Inputg(LuSpool)
************************************************************************
*                                                                      *
* Object: input module for the gradient code                           *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             September '91                                            *
*                                                                      *
*             Modified to complement GetInf, January '92.              *
************************************************************************
      use Alaska_Info, only: Am
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iChTbl, iOper, lIrrep, lBsFnc
      use Temporary_Parameters
      use Real_Info, only: CutInt
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "Molcas.fh"
#include "print.fh"
#include "real.fh"
#include "disp.fh"
#include "iavec.fh"
#include "stdalloc.fh"
#include "columbus_gamma.fh"
#include "exterm.fh"
#include "nac.fh"
#include "alaska_root.fh"
      Logical TstFnc, Type, Slct, T_Only, No_Input_OK
      Real*8, Allocatable:: Tmp(:), C(:,:), Scr(:,:), Temp(:,:)
      Integer, Allocatable:: IndCar(:)

      Character(LEN=1) :: xyz(0:2)=['x','y','z']
      Character(LEN=80) KWord, Key
      Integer iSym(3), iTemp(3*MxAtom)
      Logical timings,Reduce_Prt
      External Reduce_Prt
      COMMON /CHOTIME / timings

      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first

      COMMON  / OFembed_R1/ Xsigma
      COMMON  / OFembed_R2/ dFMD
      Character*16  OFE_KSDFT
      COMMON  / OFembed_C / OFE_KSDFT
*
      iRout = 99
      iPrint = nPrint(iRout)
      Do i = 1, nRout
         nPrint(i) = 5
      End Do
      If (ForceNAC) isNAC = .True.
      DoCSF  = .True.
      isCSF  = .False.
      Auto   = .False.
      Test   = .False.
      T_Only = .False.
      TRSymm = .False.
      lEq    = .False.
      Slct   = .False.
      l2DI   = .True.
      HF_Force=.False.
      NO_NUC = .False.
      State  =  0d0
      Timings_default = Timings
      Xsigma=1.0d4
      dFMD=0.0d0
      Do_OFemb=.false.
      KEonly=.false.
      OFE_first=.true.
      Show=.True.
      LuWr=6
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=iPL-1
      If (iPL.eq.0) Then
         jPrint=0
      Else If (iPL.eq.1) Then
         jPrint=0
      Else If (iPL.eq.2) Then
         jPrint=6
      Else If (iPL.eq.3) Then
         jPrint=6
      Else If (iPL.eq.4) Then
         jPrint=49
      Else
*     Else If (iPL.eq.5) Then
         jPrint=98
      End If
*
      Do i = 1, nRout
         nPrint(i) = jPrint
      End Do
*
*     First CutGrd can not be more accurate than CutInt!
      CutGrd = Max(1.0D-07,CutInt)
*     Second CutInt should now locally for Alaska be reset to the value
*     of CutInt/100!
      CutInt=CutGrd*1.0D-2
      Do 109 i = 1, 3*MxAtom
         IndxEq(i) = i
 109  Continue
      Do 1500 ldsp = 1, 3*MxAtom
         Direct(ldsp) = .True.
 1500 Continue
*                                                                      *
************************************************************************
*                                                                      *
*     KeyWord directed input
*
      Rewind(LuSpool)
      No_Input_OK=.True.
      Call RdNLst_(LuSpool,'ALASKA',No_Input_OK)
      KWord=' &ALASKA'
 998  Read (LuSpool,'(A72)',END=997,ERR=988) Key
      KWord = Key
      Call UpCase(KWord)
      If (KWord(1:1).eq.'*')    Go To 998
      If (KWord.eq.'')       Go To 998
      If (KWord(1:4).eq.'VERB') Go To 912
      If (KWord(1:4).eq.'PRIN') Go To 930
      If (KWord(1:4).eq.'EQUI') Go To 935
      If (KWord(1:4).eq.'CUTO') Go To 942
      If (KWord(1:4).eq.'HF-F') Go To 993
      If (KWord(1:4).eq.'NOIN') Go To 953
      If (KWord(1:4).eq.'SELE') Go To 960
      If (KWord(1:4).eq.'2DOP') Go To 965
      If (KWord(1:4).eq.'2DIP') Go To 966
      If (KWord(1:4).eq.'ONEO') Go To 990
      If (KWord(1:4).eq.'TEST') Go To 991
      If (KWord(1:4).eq.'SHOW') Go To 992
      If (KWord(1:4).eq.'PNEW') Go To 994
      If (KWord(1:4).eq.'POLD') Go To 995
      If (KWord(1:4).eq.'NONU') Go To 996
      If (KWord(1:4).eq.'EXTR') Go To 971
      If (KWord(1:4).eq.'CHOI') Go To 972
      If (KWord(1:4).eq.'OFEM') Go To 973
      If (KWord(1:4).eq.'KEON') Go To 974
      If (KWord(1:4).eq.'DFMD') Go To 975
* Keyword 'NUMErical' checked earlier - forces numerical gradients
* Keyword 'DELTa' selects the scaling factor for the displacements
*                 in the numerical_gradient module
* Keyword 'KEEP' does not remove the old gradient
* Keyword 'INVErt' inverts the treatment of constraints
* Here it's only included for consistency
      If (KWord(1:4).eq.'NUME') Go To 998
      If (KWord(1:4).eq.'DELT') Go To 998
      If (KWord(1:4).eq.'KEEP') Go To 998
      If (KWord(1:4).eq.'INVE') Go To 998
      If (KWord(1:4).eq.'ROOT') Go To 976
      If (KWord(1:4).eq.'NAC ') Go To 977
      If (KWord(1:4).eq.'NOCS') Go To 978
      If (KWord(1:4).eq.'AUTO') Go To 979
      If (KWord(1:4).eq.'END ') Go To 997
      Call WarningMessage(2,'Error in InputG')
      Write (LuWr,*) 'Inputg: Illegal keyword'
      Write (LuWr,'(A,A)') 'KWord=',KWord
      Call Quit_OnUserError()
*
 988  Call WarningMessage(2,'Error in InputG')
      Write (LuWr,*) 'Inputg: Error reading the input'
      Write (LuWr,'(A,A)') 'Last read line=',KWord
      Call Quit_OnUserError()
*                                                                      *
************************************************************************
*                                                                      *
*     Print level
*
 930  Read(LuSpool,'(A)',Err=988) KWord
      If (KWord(1:1).eq.'*') Go To 930
      If (KWord.eq.'')    Go To 930
      Read(KWord,*,Err=988) n
      Do 931 i = 1, n
 9301    Read(LuSpool,'(A)',Err=988) KWord
         If (KWord(1:1).eq.'*') Go To 9301
         If (KWord.eq.'')    Go To 9301
         Read(KWord,*,Err=988) jRout, iPrint
         nPrint(jRout)=iPrint
 931  Continue
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*     Equivalence option
*
 935  Continue
      If (T_Only) Then
         Call WarningMessage(2,'Error in InputG')
         Write (LuWr,*)'EQUI option does not ork with RF calculations!'
         Call Quit_OnUserError()
      End If
      lEq=.True.
 936  Read(LuSpool,'(A)',Err=988) KWord
      If (KWord(1:1).eq.'*') Go To 936
      If (KWord.eq.'')    Go To 936
      Read(KWord,*) nGroup
      Do 937 iGroup = 1, nGroup
 938     Read(LuSpool,'(A)',Err=988) KWord
         If (KWord(1:1).eq.'*') Go To 938
         If (KWord.eq.'')    Go To 938
         Read(KWord,*) nElem,(iTemp(iElem),iElem=1,nElem)
         Do 939 iElem=2,nElem
            IndxEq(iTemp(iElem)) = iTemp(1)
            Direct(iTemp(iElem)) = .False.
939      Continue
937   Continue
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*     Cutoff for computing primitive gradients
*
 942  Read(LuSpool,'(A)',Err=988) KWord
      If (KWord(1:1).eq.'*') Go To 942
      If (KWord.eq.'')    Go To 942
      Read(KWord,*,Err=988) CutGrd
      CutGrd = Abs(CutGrd)
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*     Disable the utilization of translational and
*     rotational invariance of the energy in the
*     computation of the molecular gradient.
*
 953  TRSymm=.False.
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*
*     selection option
*
 960  Continue
      If (T_Only) Then
         Call WarningMessage(2,'Error in InputG')
         Write (LuWr,*)'SELE option does not work with RF calculations!'
         Call Quit_OnUserError()
      End If
      Slct = .True.
      If (lEq) Then
         Call WarningMessage(2,'Error in InputG')
         Write (LuWr,*) ' The Selection option must preceed the',
     &                  ' Equivalence option to work together.'
         Call Quit_OnUserError()
      End If
      Do 961 i = 1, 3*MxAtom
         Direct(i) = .False.
 961  Continue
 962  Read(LuSpool,'(A)',Err=988) KWord
      If (KWord(1:1).eq.'*') Go To 962
      If (KWord.eq.'')    Go To 962
      Read(KWord,*) nSlct
*
 963  Read(LuSpool,'(A)',Err=988) KWord
      If (KWord(1:1).eq.'*') Go To 963
      If (KWord.eq.'')    Go To 963
      Read(KWord,*) (iTemp(iElem),iElem=1,nSlct)
      Do 964 iElem=1,nSlct
         Direct(iTemp(iElem)) = .True.
964   Continue
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*
*     Change default for the prescreening.
*
 965  l2DI  = .False.
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*
*     Change default for the prescreening.
*
 966  l2DI  = .True.
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*
*     Do not compute two electron integrals.
*
 990  Onenly = .TRUE.
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*
*     Process only the input.
*
 991  Test = .TRUE.
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Raise the printlevel to show gradient contributions
*
 992  Continue
      If (iPL.ge.2) Then
         nPrint(112) = 15
         nPrint(1)   = 15
         nPrint(33)  = 15
      End If
      Go To 998
*                                                                      *
****** PNEW ************************************************************
*                                                                      *
*
*-----Print gradient in NEW human-readable format
*
 994  Continue
      nPrint(1)   =  4
      Go To 998
*                                                                      *
****** POLD ************************************************************
*                                                                      *
*
*-----Print gradient in OLD format
*
 995  Continue
      nPrint(1)   =  5
      Go To 998
*                                                                      *
****** VERB ************************************************************
*                                                                      *
*
*----- Verbose mode.
*
 912  Continue
      nPrint(80)  =  6
      nPrint( 1)  =  6
      nPrint( 9)  =  6
      nPrint(99)  =  6
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*
*     Compute Hellmann-Feynman forces
*
 993  HF_Force = .TRUE.
      Go To 998
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*
*     Do not compute the nuclear charge contribution
*
 996  NO_NUC = .TRUE.
      Go To 998

************************************************************************
*                                                                      *
*
*     Put the program name and the time stamp onto the extract file
*
971   Write (LuWr,*)'InputG: EXTRACT option is redundant and is',
     &              ' ignored!'
      Go To 998
*                                                                      *
************************************************************************
*
*     Cholesky input section
*
 972  Continue
      Call Cho_alaska_rdInp(LuSpool)
      Go To 998
*                                                                      *
************************************************************************
*
*     Orbital-Free Embedding (OFE) input section
*
 973  Read(LuSpool,'(A)',Err=988) KWord
      If (KWord(1:1).eq.'*') Go To 973
      If (KWord.eq.'')    Go To 973
      Call UpCase(KWord)
      Call LeftAd(KWord)
      Read(KWord,'(A)') OFE_KSDFT
      Do_OFemb=.true.
      Go To 998
*                                                                      *
************************************************************************
*
*     Mode "Kinetic Energy Only" for OFE input section
*
 974  Continue
      KEonly=.true.
      Go To 998
*                                                                      *
************************************************************************
*
*     Mode "Kinetic Energy Only" for OFE input section
*
 975  Read(LuSpool,'(A)',Err=988) KWord
      If (KWord(1:1).eq.'*') Go To 975
      If (KWord.eq.'')    Go To 975
      Read(KWord,*) dFMD, Xsigma
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*     Root keyword, now also for analytical gradient
*     This is a dummy, the keyword is already read in chk_numerical
*
 976  Read(LuSpool,'(A)',Err=988) KWord
      If (KWord(1:1).eq.'*') Go To 976
      If (KWord.eq.'')    Go To 976
      Read(KWord,*) iRoot
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*     NAC keyword: compute non-adiabatic couplings between 2 states
*     The keyword is already read in chk_numerical
*
 977  Read(LuSpool,'(A)',Err=988) KWord
      isNAC=.True.
      If (KWord(1:1).eq.'*') Go To 977
      If (KWord.eq.'')    Go To 977
      Read(KWord,*) NACstates(1),NACstates(2)
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*     NOCSF keyword, to neglect the CSF contribution to the NAC,
*     which is the cause for translational variance
*
 978  DoCSF=.False.
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*     AUTO keyword, used by SLAPAF, to signal this is an automated
*     call to ALASKA
*
 979  Auto=.True.
      Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*                          End of input section.                       *
*                                                                      *
************************************************************************
 997  Continue
*
* NAC could have been activated through explicit input or through
* a previous MCLR
*
      If (isNAC) Then
         No_Nuc=.True.
*Get the state energies
         Call Get_iScalar('Number of roots',nRoots)
         Call mma_Allocate(Tmp,nRoots,Label='Tmp')
         Call Get_dArray('Last energies',Tmp,nRoots)
         Ediff=Tmp(NACstates(1))-Tmp(NACstates(2))
         Call mma_deallocate(Tmp)
      End If
*
      nCnttp_Valence=0
      Do iCnttp = 1, nCnttp
         If (dbsc(iCnttp)%Aux) Exit
         nCnttp_Valence = nCnttp_Valence+1
      End Do
*
      If (lEq)  TRSymm=.False.
      If (Slct) TRSymm=.False.
      iPrint=nPrint(iRout)
*
      TRsymm=(TRsymm.or.T_Only) .and. .Not.Test
*
*---- Compute number of centers and displacements. Ignore pseudo centers.
*     If any pseudo centers disable use of translational and rotational
*     invariance.
*
      mDisp = 0
      mdc = 0
      Do 10 iCnttp = 1, nCnttp_Valence
         If (dbsc(iCnttp)%pChrg) Then
             TRSymm=.False.
             mdc = mdc + dbsc(iCnttp)%nCntr
             Go To 10
         Else If(dbsc(iCnttp)%nFragType.gt.0.or.dbsc(iCnttp)%Frag) Then
           TRSymm = .false.
         End If
         Do 20 iCnt = 1, dbsc(iCnttp)%nCntr
            mdc = mdc + 1
            mDisp = mDisp + 3*(nIrrep/dc(mdc)%nStab)
 20      Continue
 10   Continue
*
      If (HF_Force.and.Show.and.iPrint.ge.6) Then
         Write (LuWr,*)
         Write (LuWr,'(A)') '            O B S E R V E ! '
         Write (LuWr,'(A)') '            Option for computation of '//
     &                   'interstate couling vector or'
         Write (LuWr,'(A)') '            Hellmann-Feynman gradient '//
     &                   'is active.'

         Write (LuWr,*)
      End If
      If (Show.and.iPrint.ge.6) Then
         Write (LuWr,*)
         Write (LuWr,'(20X,A,E10.3)')
     &     ' Threshold for contributions to the gradient:',CutGrd
         Write (LuWr,*)
      End If
*
*     Generate symmetry adapted cartesian displacements
*
      If (Show.and.iPrint.ge.6) Then
         Write (LuWr,*)
         Write (LuWr,'(20X,A)')
     &              '********************************************'
         Write (LuWr,'(20X,A)')
     &              '* Symmetry Adapted Cartesian Displacements *'
         Write (LuWr,'(20X,A)')
     &           '********************************************'
         Write (LuWr,*)
      End If
*
      Call ICopy(MxAtom*8,[0],0,IndDsp,1)
      Call ICopy(MxAtom*3,[0],0,InxDsp,1)
      call dcopy_(3*MxSym*MxAtom,[One],0,Disp_Fac,1)
      Call ICopy(3*MxAtom,[1],0,mult_Disp,1)
      nDisp = 0
      Do iIrrep = 0, nIrrep-1
         lDisp(iIrrep) = 0
         Type = .True.
*        Loop over basis function definitions
         mdc = 0
         mc = 1
         Do iCnttp = 1, nCnttp_Valence
*           Loop over unique centers associated with this basis set.
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = mdc + 1
               IndDsp(mdc,iIrrep) = nDisp
*              Loop over the cartesian components
               Do iCar = 0, 2
                  iComp = 2**iCar
                  If ( TstFnc(dc(mdc)%iCoSet,
     &                iIrrep,iComp,dc(mdc)%nStab) .and.
     &                .Not.dbsc(iCnttp)%pChrg ) Then
                      nDisp = nDisp + 1
                      If (iIrrep.eq.0) InxDsp(mdc,iCar+1) = nDisp
                      lDisp(iIrrep) = lDisp(iIrrep) + 1
                      mult_Disp(nDisp)=nIrrep/dc(mdc)%nStab
                      If (Type) Then
      If (Show.and.iPrint.ge.6) then
                         Write (LuWr,*)
                         Write (LuWr,'(10X,A,A)')
     &                    ' Irreducible representation : ',
     &                      lIrrep(iIrrep)
                         Write (LuWr,'(10X,2A)')
     &                      ' Basis function(s) of irrep: ',
     &                       lBsFnc(iIrrep)
                         Write (LuWr,*)
                         Write (LuWr,'(A)')
     &                   ' Basis Label        Type   Center Phase'
      End If
                         Type = .False.
                      End If
                      If (iIrrep.eq.0) Then
                         Do jOper = 0, nIrrep-1
                            Disp_Fac(iCar+1,jOper,mdc)=
     &                        DBLE(iPrmt( jOper ,iComp) *
     &                             iChTbl(iIrrep,jOper))
                         End Do
                      End If
      If (Show.and.iPrint.ge.6) Then
                      Write (LuWr,'(I4,3X,A8,5X,A1,7X,8(I3,4X,I2,4X))')
     &                      nDisp,dc(mdc)%LblCnt,xyz(iCar),
     &                      (mc+iCo,iPrmt(
     &                      NrOpr(dc(mdc)%iCoSet(iCo,0)),iComp)*
     &                      iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0))),
     &                      iCo=0,nIrrep/dc(mdc)%nStab-1 )
      End If
      Write (ChDisp(nDisp),'(A,1X,A1)')
     &      dc(mdc)%LblCnt,xyz(iCar)
                  End If
*
               End Do
               mc = mc + nIrrep/dc(mdc)%nStab
            End Do
         End Do
*
      End Do
*
      If (nDisp.ne.mDisp) Then
         Call WarningMessage(2,'Error in InputG')
         Write (LuWr,*)
     &      ' Wrong number of symmetry adapted displacements',
     &       nDisp,'=/=',mDisp
         Call Abend()
      End If
*
*     Set up data for the utilization of the translational
*     and rotational invariance of the energy.
*
      If (TRSymm) Then
         iSym(1) = 0
         iSym(2) = 0
         iSym(3) = 0
         Do i = 1, Min(nIrrep-1,5)
            j = i
            If (i.eq.3) j = 4
            Do k = 1, 3
               If (iAnd(iOper(j),2**(k-1)).ne.0) iSym(k) = 2**(k-1)
            End Do
         End Do
         nTR = 0
*--------Translational equations
         Do i = 1, 3
            If (iSym(i).eq.0) nTR = nTR + 1
         End Do
         If (iPrint.ge.99) Write (LuWr,*) ' nTR=',nTR
*--------Rotational equations
         If (.Not.T_Only) Then
            Do i = 1,3
               j = i+1
               If (j.gt.3) j = j-3
               k = i+2
               If (k.gt.3) k = k-3
               ijSym = iEor(iSym(j),iSym(k))
               If (ijSym.eq.0) nTR = nTR + 1
            End Do
         End If
         If (nTR.eq.0) Then
            TRSymm = .False.
            Go To 9876
         End If
         If (iPrint.ge.99) Write (LuWr,*) ' nTR=',nTR
         Call mma_allocate(Am,nTR,lDisp(0),Label='Am')
         Call mma_allocate(Temp,nTR,nTR,Label='Temp')
         Call mma_allocate(C,4,lDisp(0),Label='C')
         Call mma_allocate(IndCar,lDisp(0),Label='IndCar')
*
         Am(:,:)=Zero
         C(:,:)=Zero
*
*        Generate temporary information of the symmetrical
*        displacements.
*
         ldsp = 0
         mdc = 0
         iIrrep = 0
         Do 2100 iCnttp = 1, nCnttp_Valence
            Do 2200 iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = mdc + 1
*              Call RecPrt(' Coordinates',' ',
*    &                     dbsc(iCnttp)%Coor(1,iCnt),1,3)
               Fact = Zero
               iComp = 0
               If (dbsc(iCnttp)%Coor(1,iCnt).ne.Zero)
     &             iComp = iOr(iComp,1)
               If (dbsc(iCnttp)%Coor(2,iCnt).ne.Zero)
     &             iComp = iOr(iComp,2)
               If (dbsc(iCnttp)%Coor(3,iCnt).ne.Zero)
     &             iComp = iOr(iComp,4)
               Do jIrrep = 0, nIrrep-1
                  If ( TstFnc(dc(mdc)%iCoSet,
     &                  jIrrep,iComp,dc(mdc)%nStab) ) Then
                     Fact = Fact + One
                  End If
               End Do
               Do iCar = 1, 3
                  iComp = 2**(iCar-1)
                  If ( TstFnc(dc(mdc)%iCoSet,
     &                  iIrrep,iComp,dc(mdc)%nStab) ) Then
                     ldsp = ldsp + 1
                     Direct(lDsp)=.True.
*--------------------Transfer the coordinates
                     call dcopy_(3,dbsc(iCnttp)%Coor(1:3,iCnt),1,
     &                           C(1,ldsp),1)
*--------------------Transfer the multiplicity factor
                     C(4,ldsp)= Fact
                     IndCar(ldsp) = iCar
                  End If
                End Do
 2200       Continue
 2100    Continue
         If (iPrint.ge.99) Then
            Call RecPrt(' Information',' ',C,4,lDisp(0))
            Write (LuWr,*) (IndCar(i),i=1,lDisp(0))
         End If
*
*--------Set up coefficient for the translational equations
*
         iTR = 0
         Do i = 1,3
            If (iSym(i).eq.0) Then
               iTR = iTR + 1
               Do ldsp = 1, lDisp(0)
                  If (IndCar(ldsp).eq.i) Then
                     Am(iTR,ldsp) = C(4,ldsp)
                  End If
               End Do
            End If
         End Do
*
*--------Set up coefficient for the rotational invariance
*
         If (.Not.T_Only) Then
            Do i = 1, 3
               j = i + 1
               If (j.gt.3) j = j - 3
               k = i + 2
               If (k.gt.3) k = k - 3
               ijSym = iEor(iSym(j),iSym(k))
               If (ijSym.ne.0) Go To 1210
               iTR = iTR + 1
               Do ldsp = 1, lDisp(0)
                  If (IndCar(ldsp).eq.j) Then
                     Fact = C(4,ldsp) * C(k,ldsp)
                     Am(iTR,ldsp) = Fact
                  Else If (IndCar(ldsp).eq.k) Then
                     Fact =-C(4,ldsp) * C(j,ldsp)
                     Am(iTR,ldsp) = Fact
                  End If
               End Do
 1210          Continue
            End Do
         End If
         If (iPrint.ge.99)
     &      Call RecPrt(' The A matrix',' ',Am,nTR,lDisp(0))
*
*--------Now, transfer the coefficient of those gradients which will
*        not be computed directly.
*        The matrix to compute the inverse of is determined via
*        a Gram-Schmidt procedure.
*
*--------Pick up the other vectors
         Do iTR = 1, nTR
*           Write (LuWr,*) ' Looking for vector #',iTR
            ovlp = Zero
            kTR = 0
*-----------Check all the remaining vectors
            Do 1231 ldsp = 1, lDisp(0)
               Do jTR = 1, iTR-1
                  If (iTemp(jTR).eq.ldsp) Go To 1231
               End Do
*              Write (LuWr,*) ' Checking vector #', ldsp
               call dcopy_(nTR,Am(1,ldsp),1,Temp(1,iTR),1)
*              Call RecPrt(' Vector',' ',Temp(1,iTR),nTR,1)
*--------------Gram-Schmidt orthonormalize against accepted vectors
               Do lTR = 1, iTR-1
                  alpha = DDot_(nTR,Temp(1,iTR),1,Temp(1,lTR),1)
*                 Write (LuWr,*) ' <x|y> =', alpha
                  Call DaXpY_(nTR,-alpha,Temp(1,lTR),1,Temp(1,iTR),1)
               End Do
*              Call RecPrt(' Remainings',' ',Temp(1,iTR),nTR,1)
               alpha = DDot_(nTR,Temp(1,iTR),1,Temp(1,iTR),1)
*              Write (LuWr,*) ' Remaining overlap =', alpha
*--------------Check the remaining magnitude of vector after Gram-Schmidt
               If (alpha.gt.ovlp) Then
                  kTR = ldsp
                  ovlp = alpha
               End If
               If (.Not.Direct(ldsp).and.alpha.gt.1.0D-2) Then
                  kTR = ldsp
                  ovlp = 1.0D99
               End If
 1231       Continue
            If (kTR.eq.0) Then
               Call WarningMessage(2,'Error in InputG')
               Write (LuWr,*) ' No Vector found!'
               Call Abend()
            End If
*           Write (LuWr,*) ' Selecting vector #', kTR
*-----------Pick up the "best" vector
            call dcopy_(nTR,Am(1,kTR),1,Temp(1,iTR),1)
            Do lTR = 1, iTR-1
               alpha = DDot_(nTR,Temp(1,iTR),1,Temp(1,lTR),1)
               Call DaXpY_(nTR,-alpha,Temp(1,lTR),1,Temp(1,iTR),1)
            End Do
            alpha = DDot_(nTR,Temp(1,iTR),1,Temp(1,iTR),1)
            Call DScal_(nTR,One/Sqrt(alpha),Temp(1,iTR),1)
            iTemp(iTR) = kTR
         End Do
         Do iTR = 1, nTR
            call dcopy_(nTR,Am(1,iTemp(iTR)),1,Temp(1,iTR),1)
            Am(:,iTemp(iTR))=Zero
         End Do
         If (iPrint.ge.99) Then
            Call RecPrt(' The A matrix',' ',Am,nTR,lDisp(0))
            Call RecPrt(' The T matrix',' ',Temp,nTR,nTR)
            Write (LuWr,*) (iTemp(iTR),iTR=1,nTR)
         End If
*
*        Compute the inverse of the T matrix
*
         Call MatInvert(Temp,nTR)
         If (IPrint.ge.99)
     &      Call RecPrt(' The T-1 matrix',' ',Temp,nTR,nTR)
         Call DScal_(nTR**2,-One,Temp,1)
*
*        Generate the complete matrix
*
         Call mma_allocate(Scr,nTR,lDisp(0),Label='Scr')
         Call DGEMM_('N','N',
     &               nTR,lDisp(0),nTR,
     &               1.0d0,Temp,nTR,
     &               Am,nTR,
     &               0.0d0,Scr,nTR)
         If (IPrint.ge.99) Call RecPrt(' A-1*A',' ',Scr,nTR,lDisp(0))
         Call mma_deallocate(Am)
         Call mma_allocate(Am,lDisp(0),lDisp(0),Label='Am')
         Am(:,:)=Zero
         Do i = 1, lDisp(0)
            Am(i,i)=One
         End Do
         Do 1250 iTR = 1, nTR
            ldsp = iTemp(iTR)
            call dcopy_(lDisp(0),Scr(1,iTR),nTR,Am(1,lDisp),lDisp(0))
 1250    Continue
         If (iPrint.ge.99)
     &      Call RecPrt('Final A matrix',' ',Am,lDisp(0),lDisp(0))
*
*
         Call mma_deallocate(Scr)
         Call mma_deallocate(IndCar)
         Call mma_deallocate(C)
         Call mma_deallocate(Temp)
         Do 1501 iTR = 1, nTR
            ldsp = iTemp(iTR)
            Direct(ldsp)=.False.
 1501    Continue
*
         Write (LuWr,*)
         Write (LuWr,'(20X,A,A)')
     &      ' Automatic utilization of translational and',
     &      ' rotational invariance of the energy is employed.'
         Write (LuWr,*)
         Do 7000 i = 1, lDisp(0)
            If (Direct(i)) Then
               Write (LuWr,'(25X,A,A)') Chdisp(i), ' is independent'
            Else
               Write (LuWr,'(25X,A,A)') Chdisp(i), ' is dependent'
            End If
 7000    Continue
         Write (LuWr,*)
*
      Else
         nTR = 0
         If (Show.and.iPrint.ge.6) Then
            Write (LuWr,*)
            Write (LuWr,'(20X,A,A)')
     &         ' No automatic utilization of translational and',
     &         ' rotational invariance of the energy is employed.'
            Write (LuWr,*)
         End If
      End If
*
      If (Slct) Then
         Write (LuWr,*)
         Write (LuWr,'(20X,A)') ' The Selection option is used'
         Write (LuWr,*)
         Do 7100 i = 1, lDisp(0)
            If (Direct(i)) Then
               Write (LuWr,'(25X,A,A)') Chdisp(i), ' is computed'
            Else
               Write (LuWr,'(25X,A,A)') Chdisp(i), ' is set to zero'
            End If
 7100    Continue
         Write (LuWr,*)
      End If
*
 9876 Continue
*
*     Set up the angular index vector
*
      i = 0
      Do 1000 iR = 0, iTabMx
         Do 2000 ix = iR, 0, -1
            Do 3000 iy = iR-ix, 0, -1
               iz = iR-ix-iy
               i = i + 1
               ixyz(1,i) = ix
               ixyz(2,i) = iy
               ixyz(3,i) = iz
 3000       Continue
 2000    Continue
 1000 Continue
*
      Onenly = HF_Force
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine prep_mom_exchange(n,R,S,M,mg,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: R(3,3)
complex(kind=wp), intent(inout) :: S(3,n,n), M(3,n,n)
real(kind=wp), intent(out) :: mg(3,3)
logical(kind=iwp), intent(in) :: dbg
!real(kind=wp) :: g(3)
complex(kind=wp), allocatable :: Mt(:,:,:), St(:,:,:) !, Z(:,:)

!-----------------------------------------------------------------------
call mma_allocate(Mt,3,n,n,'Mt')
call mma_allocate(St,3,n,n,'St')
!call mma_allocate(Z,n,n,'Z')

! make a local backup of the data:
Mt(:,:,:) = M(:,:,:)
St(:,:,:) = S(:,:,:)
call unitmat(mg,3)

if (dbg) then
  call prMom('PA_prep_mom_exch, input S',St,n)
  call prMom('PA_prep_mom_exch, input M',Mt,n)
end if

! rotate the momentum using the R rotation matrix --
! to the local axes for a symmetric compound:
call rotmom2(St,n,R,S)
call rotmom2(Mt,n,R,M)
! back-up again:
!Mt(:,:,:) = M(:,:,:)
!St(:,:,:) = S(:,:,:)

!-----------------------------------------------------------------------
! experimental:
!! find local magnetic axes:
!call atens(M,n,g,mg,2)
!! rotate the momentum using the  mg  rotation matrix --
!! to the local magnetic axes:
!call rotmom2(St,n,mg,S)
!call rotmom2(Mt,n,mg,M)
!
!! find local pseudospin:
!call pseudospin(M,n,Z,3,1,1)
!if (dbg) call pa_prmat('PA_prep_mom_exch, Z:',Z,n)
!
!! Transform the moment into their local pseudospins
!call UTMU2(n,n,Z,S)
!call UTMU2(n,n,Z,M)
!if (dbg) then
!  call prMom('PA_prep_mom_exch, S:',S,n)
!  call prMom('PA_prep_mom_exch, M:',M,n)
!end if
!! back-up again:
!Mt(:,:,:) = M(:,:,:)
!St(:,:,:) = S(:,:,:)
!
!! rotate back the moment, so that we preserve the
!! original coordinate system of the computed molecule
!call rotmom(St,n,mg,S)
!call rotmom(Mt,n,mg,M)
!-----------------------------------------------------------------------

call mma_deallocate(Mt)
call mma_deallocate(St)
!call mma_deallocate(Z)

!-----------------------------------------------------------------------
! old preparation of the data for Lines exchange
!! rotate the moments to the general coordinate system
!
!SM_tmp(:,:,:) = SM(i1,:,1:n1,1:n1)
!r1(:,:) = rot(i1,j1,:,:)
!call rotmom2(SM_tmp,n1,r1,S1_tmp)
!SM_tmp(:,:,:) = SM(i2,:,1:n2,1:n2)
!r2(:,:) = rot(i2,j2,:,:)
!call rotmom2(SM_tmp,n2,r2,S2_tmp)
!call Lines_Exchange(Jex(lp),n1,n2,S1_tmp,S2_tmp,HTMP)
!HLIN1(lp,1:n1,1:n1,1:n2,1:n2) = HTMP(:,:,:,:)
!S1(:,1:n1,1:n1) = S1_tmp(:,:)
!S2(:,1:n2,1:n2) = S2_tmp(:,:)
!-----------------------------------------------------------------------

return

end subroutine prep_mom_exchange

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FetchTDM(nB,nS,TDMchar)

use qmstat_global, only: BigT, nState
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nB, nS
character(len=*), intent(in) :: TDMchar
integer(kind=iwp) :: iDisk, iS1, iS2, kaunter, Lu, nSize
integer(kind=iwp), allocatable :: iTocBig(:)
integer(kind=iwp), external :: IsFreeUnit

iDisk = 0
kaunter = 0
nSize = nTri_Elem(nB)
Lu = IsFreeUnit(72)
call DaName(Lu,TDMchar)
call mma_allocate(iTocBig,nTri_Elem(nState),label='iTocBig')
call iDaFile(Lu,2,iTocBig,nTri_Elem(nState),iDisk)
do iS1=1,nS
  do iS2=1,iS1
    kaunter = kaunter+1
    iDisk = iTocBig(kaunter)
    call dDaFile(Lu,2,BigT(:,kaunter),nSize,iDisk)
  end do
end do
call mma_deallocate(iTocBig)
call DaClos(Lu)

return

end subroutine FetchTDM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function ISGNUM(IDOWN,IUP,IDAW,IRAW,IUSGNUM,ILSGNUM,IWALK)
! PURPOSE: FOR ANY GIVEN WALK (STEP VECTOR) COMPUTE THE
!          LEXICAL NUMBER IN THE SPLIT GUGA REPRESENTATION

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ISGNUM
#include "gugx.fh"
integer(kind=iwp), intent(in) :: IDOWN(NVERT,0:3), IUP(NVERT,0:3), IDAW(NVERT,0:4), IRAW(NVERT,0:4), IUSGNUM(MXUP,NMIDV), &
                                 ILSGNUM(MXDWN,NMIDV), IWALK(NLEV)
integer(kind=iwp) :: IC, ICASE, ICONF, IDAWSUM, IRAWSUM, IUW, LEV, LV, MIDV

! FIND THE MIDVERTEX AND THE COMBINED WALK SYMMETRY

MIDV = 1
do LEV=NLEV,(MIDLEV+1),-1
  ICASE = IWALK(LEV)
  MIDV = IDOWN(MIDV,ICASE)
end do
MIDV = MIDV-MIDV1+1

! FIND REVERSE ARC WEIGHT FOR THE UPPER WALK

IRAWSUM = 1
LV = 1
do LEV=NLEV,(MIDLEV+1),-1
  IC = IWALK(LEV)
  LV = IDOWN(LV,IC)
  IRAWSUM = IRAWSUM+IRAW(LV,IC)
end do
IUW = IUSGNUM(IRAWSUM,MIDV)

! FIND DIRECT ARC WEIGHT FOR THE LOWER WALK

IDAWSUM = 1
LV = NVERT
do LEV=1,MIDLEV
  IC = IWALK(LEV)
  LV = IUP(LV,IC)
  IDAWSUM = IDAWSUM+IDAW(LV,IC)
end do
ICONF = ILSGNUM(IDAWSUM,MIDV)

! COMPUTE LEXICAL ORDERING NUMBER

ISGNUM = IUW+ICONF

! EXIT

return

end function ISGNUM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Oskar Weser                                      *
!***********************************************************************

#include "molcastypes.fh"

module fortran_strings
    use, intrinsic :: iso_c_binding, only: c_ptr, MOLCAS_C_INT, c_f_pointer
    implicit none
    save
    private
    public :: str, to_lower, to_upper, operator(.in.), split, &
        count_char, StringWrapper_t, Cptr_to_str, char_array

    ! This type exists to have an array of string pointers
    ! and to allow unequally sized strings.
    ! NOTE: Due to old compilers this had to be
    ! character(len=1), dimension(:), allocatable
    ! if possible change it to
    ! character(len=:), allocatable
    type :: StringWrapper_t
        character(len=1), allocatable :: str(:)
    end type


    !>  @brief
    !>    Convert to Fortran string
    !>
    !>  @author Oskar Weser
    !>
    !>  @details
    !>  It is a generic procedure that accepts Fortran integer,
    !>  Fortran real, and Fortran arrays with single character elements.
    !>
    !>  @param[in] A Fortran integer or real, or character array.
    interface str
        module procedure I_to_str, R_to_str, character_array_to_str
    end interface

    interface
        pure function strlen_c(c_string) bind(C, name='strlen_wrapper')
            import :: c_ptr, MOLCAS_C_INT
            type(c_ptr), intent(in) :: c_string
            integer(MOLCAS_C_INT) :: strlen_c
        end function
    end interface

    interface operator(.in.)
        module procedure substr_in_str
    end interface

    character(len=*), parameter :: &
        UPPERCASE_chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', &
        lowercase_chars = 'abcdefghijklmnopqrstuvwxyz'

    contains

    pure function I_to_str(i) result(str)
        character(len=:), allocatable :: str
        integer, intent(in) :: i
        character(len=range(i) + 2) :: tmp
        write(tmp, '(I0)') I
        str = trim(tmp)
    end function

    pure function R_to_str(x) result(str)
        character(len=:), allocatable :: str
        real*8, intent(in) :: x
        character(len=range(x) + 2) :: tmp
        write(tmp, '(I0)') x
        str = trim(tmp)
    end function

    pure function character_array_to_str(array) result(res)
        character(len=1), intent(in) :: array(:)
        character(len=:), allocatable :: res
        integer :: i, L

        L = size(array)
        allocate(character(len=L) :: res)
        do i = 1, L
            res(i:i) = array(i)
        end do
    end function

    !> Convert C string pointer to Fortran string.
    function Cptr_to_str(c_string) result(res)
        type(c_ptr), intent(in) :: c_string
        character(len=:), allocatable :: res
        character, pointer, dimension(:) :: string
        integer :: i, L
        L = int(strlen_c(c_string))
        allocate(character(len=L) :: res)
        call c_f_pointer(c_string, string, [L])
        do i = 1, L
            res(i:i) = string(i)
        end do
    end function

    !> Changes a string to upper case
    pure function to_upper (in_str) result (string)
        character(len=*), intent(in) :: in_str
        character(len=len(in_str)) :: string
        integer :: ic, i, L

        L = len_trim(in_str)
        do i = 1, L
            ic = index(lowercase_chars, in_str(i:i))
            if (ic > 0) then
                string(i:i) = UPPERCASE_chars(ic:ic)
            else
                string(i:i) = in_str(i:i)
            end if
        end do
        string(L + 1: ) = ' '
    end function to_upper

    !> Changes a string to lower case
    pure function to_lower (in_str) result (string)
        character(len=*), intent(in) :: in_str
        character(len=len(in_str)) :: string
        integer :: ic, i, L

        L = len_trim(in_str)
        do i = 1, L
            ic = index(UPPERCASE_chars, in_str(i:i))
            if (ic > 0) then
                string(i:i) = lowercase_chars(ic:ic)
            else
                string(i:i) = in_str(i:i)
            end if
        end do
        string(L + 1: ) = ' '
    end function to_lower

    logical pure function substr_in_str(substring, string)
        character(len=*), intent(in) :: string, substring

        substr_in_str = index(string, substring) /= 0
    end function

    !> @brief
    !> Split a string at delimiter.
    subroutine split(string, delimiter, res)
        character(len=*), intent(in) :: string
        character(len=1), intent(in) :: delimiter
        type(StringWrapper_t), allocatable, intent(out) :: res(:)

        integer :: i, n, low

        allocate(res(count_char(string, delimiter) + 1))

        ! NOTE: this function is unnecessarily complicated,
        ! because StringWrapper_t cannot have character(len=:), allocatable
        ! components. (Old compilers)

        low = 1; n = 1
        do i = 1, len(string)
            if (string(i : i) == delimiter) then
                allocate(character(len=1) :: res(n)%str(i - low))
                res(n)%str(:) = char_array(string(low : i - 1))
                n = n + 1
                low = i + 1
            end if
        end do

        if (n == size(res)) then
            allocate(character(len=1) :: res(n)%str(len(string(low : ))))
            res(n)%str(:) = char_array(string(low : ))
        end if
    end subroutine

    pure function char_array(string) result(res)
        character(len=*), intent(in) :: string
        character(len=1) :: res(len(string))
        integer :: i
        do i = 1, len(string)
            res(i) = string(i : i)
        end do
    end function


    !> @brief
    !> Count the occurence of a character in a string.
    pure function count_char(str, char) result(c)
        character(len=*), intent(in) :: str
        character(len=1), intent(in) :: char
        integer :: c
        integer :: i

        c = 0
        do i = 1, len(str)
            if (str(i : i) == char) c = c + 1
        end do
    end function
end module

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016, Morgane Vacher                                   *
*               2017,2018, Ignacio Fdez. Galvan                        *
************************************************************************

* Module to handle the COORD keyword in gateway/seward

#include "compiler_features.h"
#define MAXLEN 180
#define iX 1
#define iY 2
#define iZ 4
#define iXY iX+iY
#define iXZ iX+iZ
#define iYZ iY+iZ
#define iXYZ iX+iY+iZ

      Module XYZ
      Implicit None
      Private
      Type XYZAtom
        Character (Len=MAXLEN) :: Lab
        Real*8, Dimension(3) :: Coord
        Integer :: FileNum
      End Type XYZAtom
      Type(XYZAtom), Dimension(:), Allocatable :: Geom
      Character (Len=256) :: BasisAll, Symmetry
      Character (Len=256), Dimension(:,:), Allocatable :: BasisSets
      Integer, Dimension(7) :: Oper
      Integer :: FileNum=0

      Public :: Read_XYZ, Write_SewInp, Clear_XYZ, Out_Raw,
     &          Parse_Basis, Parse_Group, Symmetry

      Contains

! Read an XYZ file with molcas extensions
! Rot and Trans are transformations to apply to all coordinates in this file
! If Replace=.T., the coordinates will replace existing ones, but labels will not be changed
      Subroutine Read_XYZ(Lu,Rot,Trans,Replace)
      Integer, Intent(In) :: Lu
      Real*8, Dimension(:,:,:), Allocatable, Intent(In) :: Rot
      Real*8, Dimension(:,:), Allocatable, Intent(In) :: Trans
      Logical, Optional, Intent(In) :: Replace
      Character (Len=MAXLEN) :: Line, FName, CurrDir, Dum
      Integer :: Error, NumAt, i, Lxyz, Idx
      Logical :: Found, Rep
      Integer, External :: IsFreeUnit
      Type(XYZAtom), Dimension(:), Allocatable :: ThisGeom, TmpGeom
      Real*8, Dimension(3,5) :: Mat
      Real*8 :: Factor
#include "real.fh"
#include "constants2.fh"
#ifdef _HDF5_
#  include "mh5.fh"
#  include "Molcas.fh"
      Logical :: isH5
      Integer :: Coord_id, Attr_id, nSym, j, c
      Character (Len=LenIn), Dimension(:), Allocatable :: Labels
      Character (Len=LenIn4), Dimension(:), Allocatable :: Labels4
      Real*8, Dimension(:,:), Allocatable :: Coords
      isH5 = .False.
#endif

      Factor = One
      Read(Lu,'(A)') Line
      Line = AdjustL(Line)

!     Try to read a number, if it fails, try to open a file
!     Note that the slash means end-of-line in list-directed input
      NumAt = -1
      Read(Line,*,IOStat=Error) NumAt
!     And make sure there's nothing but numbers in the first word
!     (the above is not 100% reliable in some compilers)
      Do i=1,Len(Line)
        If (Line(i:i) .eq. ' ') Exit
        Idx = IChar(Line(i:i))
        If ((Idx .lt. IChar('0')) .or. (Idx .gt. IChar('9'))) Then
          Error = -1
          Exit
        End If
      End Do
      If (NumAt .lt. 1) Error = -1
      If (Index(Line, '/') .gt. 0) Error = -1
      Lxyz = Lu
      If (Error .ne. 0) Then
        Read(Line,'(A)') FName
        Found = .False.
        If (Index(Line, '/') .eq. 0) Then
          Call GetEnvF('CurrDir', CurrDir)
          CurrDir = Trim(CurrDir)//'/'//FName
          Call F_Inquire(CurrDir, Found)
          If (Found) FName = CurrDir
        End If
        If (.Not. Found) Call F_Inquire(FName, Found)
        If (Found) Then
#ifdef _HDF5_
          If (mh5_is_hdf5(Trim(FName))) Then
            isH5 = .True.
          Else
#endif
            Lxyz = IsFreeUnit(Lxyz)
            Call Molcas_Open(Lxyz, FName)
            Read(Lxyz,'(A)') Line
            Read(Line,*,IOStat=Error) NumAt
            If (Error .ne. 0) Then
              Write(6,*) 'Error reading file ',Trim(FName)
              Call Quit_OnUserError()
            End If
#ifdef _HDF5_
          End If
#endif
        Else
          Write(6,*) 'File ',Trim(FName),' not found!'
          Call Quit_OnUserError()
        End If
      End If
!     Each atom has a field indicating the sequential number of the
!     file it belongs to
      FileNum = FileNum+1

#ifdef _HDF5_
************************************************************************
* For HDF5 formatted file
************************************************************************
      If (isH5) Then
        Write(6,*) 'Reading xyz coordinates from h5 file '//Trim(FName)
        Coord_id = mh5_open_file_r(Trim(FName))
!       check if symmetry was used
        Call mh5_fetch_attr(Coord_id,'NSYM',nSym)
!       read numbers of atoms
        If (nSym .gt. 1) Then
          Attr_id = mh5_open_attr(Coord_id,'NATOMS_ALL')
        Else
          Attr_id = mh5_open_attr(Coord_id,'NATOMS_UNIQUE')
        End If
        Call mh5_get_attr_scalar_int(Attr_id,NumAt)
        Allocate(ThisGeom(NumAt))
        Allocate(Labels(NumAt),Coords(3,NumAt))
!       read atom labels
        If (nSym .gt. 1) then
          Allocate(Labels4(NumAt))
          Call mh5_fetch_dset_array_str(Coord_id,'DESYM_CENTER_LABELS',
     &                                   Labels4)
          Do i=1,NumAt
            Labels(i) = Labels4(i)(1:LenIn)
          End Do
          Deallocate(Labels4)
        Else
          Call mh5_fetch_dset_array_str(Coord_id,'CENTER_LABELS',
     &                                   Labels)
        End If
!       remove numbers from labels
!       (otherwise there will be problems when symmetric structures
!       are used without symmetry)
        Do i=1,NumAt
          Do j=1,LenIn
            c = IChar(Labels(i)(j:j))
            If ((c .ge. IChar('0')) .and. (c .le. IChar('9'))) Then
              Labels(i)(j:j) = ' '
            End If
          End Do
        End Do
!       read atom coordinates
        If (nSym .gt. 1) then
          Call mh5_fetch_dset_array_real(Coord_id,
     &         'DESYM_CENTER_COORDINATES',Coords)
        Else
          Call mh5_fetch_dset_array_real(Coord_id,
     &         'CENTER_COORDINATES',Coords)
        End If
        Call mh5_close_file(Coord_id)
!       store data
        Do i=1,NumAt
          ThisGeom(i)%Lab = Labels(i)
          ThisGeom(i)%Coord(:) = Coords(:,i)
          ThisGeom(i)%FileNum = FileNum
        End Do
        Deallocate(Labels,Coords)
      Else
#endif
************************************************************************
* For .xyz format file
************************************************************************
        Allocate(ThisGeom(NumAt))
        Read(Lxyz,'(A)',IOStat=Error) Line
        If (Error .ne. 0) Then
          Write(6,*) 'Error reading geometry'
          Call Quit_OnUserError()
        End If
        Call UpCase(Line)
!       Units of the coordinates (default angstrom)
        If (Max(Index(Line,'BOHR'),Index(Line,'A.U.')) .le. 0) Then
          Factor = One/Angstrom
        End If
        Do i=1,NumAt
          Read(Lxyz,*,IOStat=Error) ThisGeom(i)%Lab,ThisGeom(i)%Coord(:)
          If (Error .ne. 0) Then
            Write(6,*) 'Error reading geometry'
            Call Quit_OnUserError()
          End If
          ThisGeom(i)%Coord(:) = ThisGeom(i)%Coord(:)*Factor
          ThisGeom(i)%FileNum = FileNum
        End Do
        If (Lxyz .ne. Lu) Close(Lxyz)
#ifdef _HDF5_
      End If
#endif

!     Obtain/read transformation matrix and transform the geometry in this file
      Mat = Reshape([One, One,  One,
     &               One, Zero, Zero,
     &               Zero, One, Zero,
     &               Zero, Zero, One,
     &               Zero, Zero, Zero],
     &              Shape(Mat))
      Idx = Index(' '//Line, ' SCALE ')
      If (Idx .gt. 0) Then
        Read(Line(Idx:),*,IOStat=Error) Dum, Mat(1,1)
        Mat(2,1) = Mat(1,1)
        Mat(3,1) = Mat(1,1)
      End If
      Idx = Index(' '//Line, ' SCALEX ')
      If (Idx .gt. 0) Read(Line(Idx:),*,IOStat=Error) Dum, Mat(1,1)
      Idx = Index(' '//Line, ' SCALEY ')
      If (Idx .gt. 0) Read(Line(Idx:),*,IOStat=Error) Dum, Mat(2,1)
      Idx = Index(' '//Line, ' SCALEZ ')
      If (Idx .gt. 0) Read(Line(Idx:),*,IOStat=Error) Dum, Mat(3,1)
      Idx = Index(' '//Line, ' ROT ')
      If (Idx .gt. 0) Read(Line(Idx:),*,IOStat=Error) Dum, Mat(:,2:4)
      Idx = Index(' '//Line, ' TRANS ')
      If (Idx .gt. 0) Read(Line(Idx:),*,IOStat=Error) Dum, Mat(:,5)
!     If Rot and Trans are given in the input, they override
!     the inline transformations
      If (Allocated(Rot)) Then
        Mat(:,2:4) = Rot(:,:,FileNum)
      End If
      Mat(:,2:4) = Transpose(Mat(:,2:4))
      If (Allocated(Trans)) Then
        Mat(:,5) = Trans(:,FileNum)
      End If
      Mat(:,5) = Mat(:,5)*Factor
      Call TransformGeom(ThisGeom,Mat)

      Rep = .False.
      If (Present(Replace)) Rep = Replace

      If (Allocated(Geom)) Then
        If (Rep) Then
          If (Size(ThisGeom) .ne. Size(Geom)) Then
            Write(6,*) 'New system size does not match previous one'
            Call Quit_OnUserError()
          End If
          Do i=1,Size(Geom)
            Geom(i)%Coord = ThisGeom(i)%Coord
          End Do
        Else
!         Append the just read geometry to the general one
          Call Move_Alloc(Geom, TmpGeom)
          NumAt = Size(TmpGeom)+Size(ThisGeom)
          Allocate(Geom(NumAt))
          Geom(1:Size(TmpGeom)) = TmpGeom(:)
          Geom(Size(TmpGeom)+1:) = ThisGeom(:)
          Deallocate(TmpGeom)
          Deallocate(ThisGeom)
        End If
      Else
        Call Move_Alloc(ThisGeom, Geom)
      End If

      End Subroutine Read_XYZ

! Clear allocations
      Subroutine Clear_XYZ

      If (Allocated(Geom)) Deallocate(Geom)
      If (Allocated(BasisSets)) Deallocate(BasisSets)
      FileNum = 0

      End Subroutine Clear_XYZ

! Write an input file for seward
! Atoms belonging to GhostFiles have no charge
      Subroutine Write_SewInp(FName,GhostFiles)
      Character (Len=*), Intent(In) :: FName
      Integer, Dimension(:), Intent(In) :: GhostFiles
      Integer :: Lu, Num, i, j
      Integer, External :: IsFreeUnit
      Character (Len=MAXLEN) :: New, Old, Sym, Lab, Bas
      Logical :: Ghost

      Lu = 10
      Lu = IsFreeUnit(Lu)
      Call Molcas_Open(Lu, FName)
!     Write symmetry
      If (Symmetry .ne. '') Write(Lu,40) 'Symmetry', Trim(Symmetry)
!     Write the atoms, skipping symmetry-superfluous atoms
      Old = ''
      j = 0
      Do i=1,Size(Geom)
        If (Geom(i)%FileNum .eq. 0) Cycle
        j = j+1
        Call SplitLabel(Geom(i)%Lab, Sym, Num, Lab, Bas)
!       Build an identifier for the basis
        New = Trim(Sym)//Trim(Lab)//Bas
        Ghost = Any(GhostFiles .eq. Geom(i)%FileNum)
        If (Ghost) New = Trim(New)//' *'
!       If there is a change of basis, write the basis
        If (New .ne. Old) Then
          If (i .gt. 1) Write(Lu,10) 'End of Basis'
          Write(Lu,10) 'Basis Set'
          Write(Lu,10) FindBasis(Sym, Lab, Bas)
          If (Ghost) Write(Lu,30) 'Charge', 0.0
          Old = New
        End If
!       Add a sequential number if the label had none
        If (Num .eq. 0) Num = j
        Write(Lu,20) Trim(Sym), Num, Geom(i)%Coord(:)
      End Do
      Write(Lu,10) 'End of Basis'
      Write(Lu,10) 'End of Coord'
      Close(Lu)
10    Format(A)
20    Format(A,I0,3(1X,ES30.20E3))
30    Format(A,/,F4.1)
40    Format(A,/,A)

      End Subroutine Write_SewInp

! Store symmetry-unique atom coordinates in an array
! Output is the number of saved coordinates
      Function Out_Raw(Array)
      Real*8, Dimension(*), Intent(InOut) :: Array
      Integer :: Out_Raw
      Integer :: i, j

      j = 0
      Do i=1,Size(Geom)
        If (Geom(i)%FileNum .eq. 0) Cycle
        Array(j+1:j+3) = Geom(i)%Coord
        j = j+3
      End Do
      Out_Raw = j

      End Function Out_Raw

! Parse the BASIS keyword to store the basis set corresponding to
! each atom + label
      Subroutine Parse_Basis(Basis)
      Character (Len=*), Intent(In) :: Basis
      Integer :: Num, Idx, IdxDot, Next, i

!     Count number of commas
      Num = Count(Transfer(Basis, 'x', Len_Trim(Basis)) .eq. ",") + 1
      BasisAll = ''
      If (Allocated(BasisSets)) Deallocate(BasisSets)
      Allocate(BasisSets(2,Num))
!     For each comma-separated word, split it at the first dot
!     If the first part is empty, use it as a general basis set
      Idx = 0
      Do i=1,Num
        Next = Idx+Index(Basis(Idx+1:), ',')
        If (Next .eq. Idx) Next = Len_Trim(Basis)+1
        BasisSets(2,i) = Basis(Idx+1:Next-1)
        IdxDot = Index(BasisSets(2,i), '.')
        If (IdxDot .eq. 0) Then
          BasisSets(1,i) = ''
        Else
          BasisSets(1,i) = AdjustL(BasisSets(2,i)(1:IdxDot-1))
          BasisSets(2,i)(1:IdxDot) = ''
        End If
        Call UpCase(BasisSets(1,i))
        BasisSets(2,i) = AdjustL(BasisSets(2,i))
        If (BasisSets(1,i) .eq. '') BasisAll = BasisSets(2,i)
        Idx = Next
      End Do
      If (BasisAll .eq. '') BasisAll = 'ANO-S-MB'

      End Subroutine Parse_Basis

! Parse the GROUP keyword, detecting the symmetry,
! generating all symmetry operations and adapting
! the symmetry
      Subroutine Parse_Group(Group,Thr)
      Character (Len=*), Intent(In) :: Group
      Real*8, Intent(In) :: Thr
      Character (Len=3), Dimension(3) :: Gen
      Integer :: Error, i, j, k

      Symmetry = Group
      Call UpCase(Symmetry)
      If (Symmetry .eq. 'FULL') Then
        Call DetectSym(Thr)
      Else If ((Symmetry(1:5) .eq. 'NOSYM') .or.
     &         (Symmetry .eq. 'E') .or.
     &         (Symmetry .eq. 'C1')) Then
        Symmetry = ''
      End If
      Gen = ''
      Read(Symmetry,*,IOStat=Error) Gen
!     Encode generators
      Oper = 0
      Do i=1,3
        If (Index(Gen(i),'X') .gt. 0) Oper(i)=Oper(i)+iX
        If (Index(Gen(i),'Y') .gt. 0) Oper(i)=Oper(i)+iY
        If (Index(Gen(i),'Z') .gt. 0) Oper(i)=Oper(i)+iZ
      End Do
!     Create all combinations
      Oper(4) = iEOR(Oper(1),Oper(2))
      Oper(5) = iEOR(Oper(1),Oper(3))
      Oper(6) = iEOR(Oper(2),Oper(3))
      Oper(7) = iEOR(Oper(3),Oper(4))
!     Remove duplicates
      Do i=1,7
        Do j=i+1,7
          If (Oper(j) .eq. Oper(i)) Oper(j) = 0
        End Do
      End Do
!     Sort descending
      Do i=1,7
        Do j=i+1,7
          If (Oper(j) .ge. Oper(i)) Then
            k = Oper(j)
            Oper(j) = Oper(i)
            Oper(i) = k
          End If
        End Do
      End Do
!     Check and adapt the symmetry
      Call AdaptSym(Thr)

      End Subroutine Parse_Group

! Private procedures follow

! Subroutine to detect the symmetry elements of the system
! The system is *not* translated or rotated
! Only elements of D2h group are tested (i.e. sign inversions of one, two or three axes)
! The result is stored in Symmetry (compatible with molcas-extra)
      Subroutine DetectSym(Thr)
      Real*8, Intent(In) :: Thr
      Logical, Dimension(7) :: Op
      Op = .False.
      Op(iX) = CheckOp(iX, Thr)
      Op(iY) = CheckOp(iY, Thr)
      Op(iZ) = CheckOp(iZ, Thr)
      Symmetry = ''
      Select Case (Count(Op))
!       Two or three reflections: all is known
        Case (3, 2)
          Op(iXY) = Op(iX) .And. Op(iY)
          Op(iXZ) = Op(iX) .And. Op(iZ)
          Op(iYZ) = Op(iY) .And. Op(iZ)
          Op(iXYZ) = Op(iX) .And. Op(iY) .And. Op(iZ)
          If (Op(iXYZ)) Then
            Symmetry = 'x y z'
          Else
            If (Op(iXY)) Symmetry = 'xy y'
            If (Op(iXZ)) Symmetry = 'xz z'
            If (Op(iYZ)) Symmetry = 'yz z'
          End If
!       One reflection: possibly inversion and complementary rotation
        Case (1)
          Op(iXYZ) = CheckOp(iXYZ, Thr)
          If (Op(iXYZ)) Then
            Op(iXY) = Op(iZ)
            Op(iXZ) = Op(iY)
            Op(iYZ) = Op(iX)
            If (Op(iXY)) Symmetry = 'xy xyz'
            If (Op(iXZ)) Symmetry = 'xz xyz'
            If (Op(iYZ)) Symmetry = 'yz xyz'
          Else
            If (Op(iX)) Symmetry = 'x'
            If (Op(iY)) Symmetry = 'y'
            If (Op(iZ)) Symmetry = 'z'
          End If
!       No reflection: check rotations (only two initially)
        Case (0)
          Op(iXY) = CheckOp(iXY, Thr)
          Op(iXZ) = CheckOp(iXZ, Thr)
          If (Op(iXY)) Symmetry = 'xy'
          If (Op(iXZ)) Symmetry = Trim(Symmetry)//' xz'
          Select Case (Count(Op))
!           Two or one rotation: the third is known
            Case (2, 1)
              Op(iYZ) = Op(iXY) .And. Op(iXZ)
!           No rotation: check the third, and inversion if necessary
            Case (0)
              Op(iYZ) = CheckOp(iYZ, Thr)
              If (.Not. Op(iYZ)) Op(iXYZ) = CheckOp(iXYZ, Thr)
              If (Op(iXY)) Symmetry = 'yz'
              If (Op(iXYZ)) Symmetry = 'xyz'
          End Select
      End Select
      Symmetry = AdjustL(Symmetry)
      If (Symmetry .ne. '') Write(6,10) Trim(Symmetry)
      Call UpCase(Symmetry)
10    Format(6X,'Found SYMMETRY generators: ',A)
      End Subroutine DetectSym

! Function to check if a symmetry operation conserves the geometry
      Function CheckOp(Op,Thr)
      Integer, Intent(In) :: Op
      Real*8, Intent(In) :: Thr
      Logical :: CheckOp, Found
      Logical, Dimension(Size(Geom)) :: Done
      Real*8, Dimension(3) :: New
      Real*8 :: Dist
      Character (Len=MAXLEN) :: Sym, SymA, SymB, Lab, Bas
      Integer :: Num, i, j
#include "constants2.fh"
      Done = .False.
!     For each atom, check if any of the following atoms (including itself)
!     matches the result of the symmetry operation
      Do i=1,Size(Geom)
        If (Done(i)) Cycle
        Call SplitLabel(Geom(i)%Lab, Sym, Num, Lab, Bas)
        SymA = Trim(Sym)//Trim(Lab)
        Call UpCase(SymA)
        New = ApplySym(Op, Geom(i)%Coord)
        Found = .False.
        Do j=i,Size(Geom)
          Call SplitLabel(Geom(j)%Lab, Sym, Num, Lab, Bas)
          SymB = Trim(Sym)//Trim(Lab)
          Call UpCase(SymB)
          If (SymB .ne. SymA) Cycle
          Dist = (New(1)-Geom(j)%Coord(1))**2 +
     &           (New(2)-Geom(j)%Coord(2))**2 +
     &           (New(3)-Geom(j)%Coord(3))**2
          If (Dist*Angstrom**2 .le. Thr**2) Then
            Done(j) = .True.
            Found = .True.
            Exit
          End If
        End Do
        If (.Not. Found) Then
          CheckOp = .False.
          Return
        End If
      End Do
      CheckOp = .True.
      End Function CheckOp

! Subroutine to "fix" the symmetry, according to the threshold
! Coordinates of the atoms that are close enough are averaged
! Symmetry-superfluous atoms are marked with FileNum=0
      Subroutine AdaptSym(Thr)
      Real*8, Intent(In) :: Thr
      Real*8, Dimension(3) :: Aver, New
      Real*8 :: Dist
      Integer :: Op, nOp, Num, i, j
      Character (Len=MAXLEN) :: Sym, SymA, SymB, Lab, Bas
      Logical :: Found, Moved
#include "constants2.fh"
#include "real.fh"
      Moved = .False.
!     Count the non-trivial operations
      nOp = Count(Oper .ne. 0)+1
!     For each atom, find all symmetric images to average
      Do i=1,Size(Geom)
        If (Geom(i)%FileNum .eq. 0) Cycle
        Call SplitLabel(Geom(i)%Lab, Sym, Num, Lab, Bas)
        SymA = Trim(Sym)//Trim(Lab)
        Call UpCase(SymA)
        Aver = Geom(i)%Coord
        Do Op=1,7
          If (Oper(Op) .eq. 0) Exit
          Found = .False.
          Do j=i,Size(Geom)
            Call SplitLabel(Geom(j)%Lab, SymB, Num, Lab, Bas)
            SymB = Trim(Sym)//Trim(Lab)
            Call UpCase(SymB)
            If (SymB .ne. SymA) Cycle
            New = ApplySym(Oper(Op), Geom(j)%Coord)
            Dist = (New(1)-Geom(i)%Coord(1))**2 +
     &             (New(2)-Geom(i)%Coord(2))**2 +
     &             (New(3)-Geom(i)%Coord(3))**2
            If (Dist*Angstrom**2 .le. Thr**2) Then
              Found = .True.
              Aver = Aver+New
              If (j .ne. i) Geom(j)%FileNum = 0
              If (Dist .gt. Zero) Moved = .True.
              Exit
            End If
          End Do
          If (.Not. Found) Then
            Write(6,*) 'Symmetry operators do not match the geometry'
            Call Quit_OnUserError()
          End If
        End Do
        Geom(i)%Coord = Aver/Dble(nOp)
      End Do
      If (Moved)
     &  Call WarningMessage(0,
     &   'Warning! XYZ coordinates will be modified to match '//
     &   'the specified/detected symmetry. Use SYMT = 0.0 if '//
     &   'this is not desired.')
      End Subroutine AdaptSym

! Function to apply a symmetry operation to a 3D-point
! The operation is simply a possible change of sign of each axis
      Function ApplySym(Op,Coord)
      Integer, Intent(In) :: Op
      Real*8, Dimension(3), Intent(In) :: Coord
      Real*8, Dimension(3) :: ApplySym
      ApplySym = Coord
      If (iAnd(Op, iX) .gt. 0) ApplySym(1) = -ApplySym(1)
      If (iAnd(Op, iY) .gt. 0) ApplySym(2) = -ApplySym(2)
      If (iAnd(Op, iZ) .gt. 0) ApplySym(3) = -ApplySym(3)
      End Function ApplySym

! Subroutine to obtain the different components, of an atom's label
! <Sym><Num>_<Lab>.<Bas>
! Lab and Bas include the _ or .
      Subroutine SplitLabel(At,Sym,Num,Lab,Bas)
      Character (Len=*), Intent(In) :: At
      Character (Len=*), Intent(Out) :: Sym, Lab, Bas
      Integer, Intent(Out) :: Num
      Character (Len=Len(At)) :: String
      Character :: c
      Integer :: Idx, i, j, k
      String = At
!     Get the Bas part
      Idx = Index(String, '.')
      If (Idx .eq. 0) Then
        Idx = Len_Trim(String)+1
        Bas = ''
      Else
        Bas = String(Idx:)
      End If
      String = String(1:Idx-1)
!     Get the Lab part
      Idx = Index(String, '_')
      If (Idx .eq. 0) Then
        Idx = Len_Trim(String)+1
        Lab = ''
      Else
        Lab = String(Idx:)
      End If
      Sym = String(1:Idx-1)
      Num = 0
      k = 0
!     Remove digits and compute Num
      Do i = Len_Trim(Sym),1,-1
        c = Sym(i:i)
        If ((IChar(c) .ge. IChar('0')) .and.
     &      (IChar(c) .le. IChar('9'))) Then
          Read(c,*) j
          Num = Num + j*10**k
          k = k+1
          Sym(i:i) = ' '
        End If
      End Do
      End Subroutine SplitLabel

! Function to find the basis set that applies to a given atom
      Function FindBasis(AtSym,AtLab,AtBas)
      Character (Len=*), Intent(In) :: AtSym, AtLab, AtBas
#ifdef ALLOC_ASSIGN
      Character (Len=:), Allocatable :: FindBasis
#else
      Character (Len=MAXLEN) :: FindBasis
#endif
      Character (Len=Len(AtSym)) :: UpSym
      Character (Len=Len(AtLab)) :: UpLab
      Integer :: i
!     Prepare for case-insensitive comparisons
      UpSym = AtSym
      Call UpCase(UpSym)
      UpLab = AtLab
      Call UpCase(UpLab)
!     Special case: if the Label is "MM", no basis
      If (UpLab .eq. '_MM') Then
        FindBasis = Trim(AtSym)//'...... / MM'
        Return
      End If
!     If the atoms has a basis specified, nothing else to do
      If (AtBas .ne.  '') Then
        FindBasis = Trim(AtSym)//Trim(AtBas)
        Return
      End If
!     Otherwise, find the basis set that matches the symbol and label
      Do i=1,Size(BasisSets,2)
        If (Trim(UpSym)//UpLab .eq. BasisSets(1,i)) Then
          FindBasis = Trim(AtSym)//'.'//Trim(BasisSets(2,i))
          Return
        End If
      End Do
!     If none found, use the general basis
      If (BasisAll .eq. '') Then
        Write(6,*) 'No basis found for '//Trim(AtSym)//Trim(AtLab)
        Call Quit_OnUserError()
      End If
      FindBasis = Trim(AtSym)//'.'//Trim(BasisAll)
      End Function FindBasis

! Subroutine to transform a geometry according to the matrix M
      Subroutine TransformGeom(G,M)
      Type(XYZAtom), Dimension(:), Intent(InOut) :: G
      Real*8, Dimension(3,5), Intent(In) :: M
      Real*8, Dimension(3) :: Old
      Real*8, External :: DDot_
      Integer :: i, j
!     The matrix has 5 colums: scale (1), rotate (2-4), translate (5)
      Do i=1,Size(G)
        Old(:) = M(:,1)*G(i)%Coord(:)
        Do j=1,3
          G(i)%Coord(j) = DDot_(3,Old,1,M(:,j+1),1)
        End Do
        G(i)%Coord(:) = G(i)%Coord(:)+M(:,5)
      End Do
      End Subroutine TransformGeom

      End Module XYZ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! This file from SLATEC:                                               *
!   http://www.netlib.org/slatec                                       *
!                                                                      *
! To the best of our knowledge, the routines in SLATEC are public      *
! domain or freely distributable and modifiable.                       *
!***********************************************************************

!******************************
!** Random number generation **
!******************************
function rand_cvb(r)
!***BEGIN PROLOGUE  RAND
!***DATE WRITTEN   770401   (YYMMDD)
!***REVISION DATE  820801   (YYMMDD)
!***CATEGORY NO.  L6A21
!***KEYWORDS  RANDOM NUMBER,SPECIAL FUNCTION,UNIFORM
!***AUTHOR  FULLERTON, W., (LANL)
!***PURPOSE  Generates a uniformly distributed random number.
!***DESCRIPTION
!
!      This pseudo-random number generator is portable among a wide
! variety of computers.  RAND(R) undoubtedly is not as good as many
! readily available installation dependent versions, and so this
! routine is not recommended for widespread usage.  Its redeeming
! feature is that the exact same random numbers (to within final round-
! off error) can be generated from machine to machine.  Thus, programs
! that make use of random numbers can be easily transported to and
! checked in a new environment.
!      The random numbers are generated by the linear congruential
! method described, e.g., by Knuth in Seminumerical Methods (p.9),
! Addison-Wesley, 1969.  Given the I-th number of a pseudo-random
! sequence, the I+1 -st number is generated from
!             X(I+1) = (A*X(I) + C) MOD M,
! where here M = 2**22 = 4194304, C = 1731 and several suitable values
! of the multiplier A are discussed below.  Both the multiplier A and
! random number X are represented in REAL(kind=wp) as two 11-bit
! words.  The constants are chosen so that the period is the maximum
! possible, 4194304.
!      In order that the same numbers be generated from machine to
! machine, it is necessary that 23-bit integers be reducible modulo
! 2**11 exactly, that 23-bit integers be added exactly, and that 11-bit
! integers be multiplied exactly.  Furthermore, if the restart option
! is used (where R is between 0 and 1), then the product R*2**22 =
! R*4194304 must be correct to the nearest integer.
!      The first four random numbers should be .0004127026,
! .6750836372, .1614754200, and .9086198807.  The tenth random number
! is .5527787209, and the hundredth is .3600893021 .  The thousandth
! number should be .2176990509 .
!      In order to generate several effectively independent sequences
! with the same generator, it is necessary to know the random number
! for several widely spaced calls.  The I-th random number times 2**22,
! where I=K*P/8 and P is the period of the sequence (P = 2**22), is
! still of the form L*P/8.  In particular we find the I-th random
! number multiplied by 2**22 is given by
! I   =  0  1*P/8  2*P/8  3*P/8  4*P/8  5*P/8  6*P/8  7*P/8  8*P/8
! RAND=  0  5*P/8  2*P/8  7*P/8  4*P/8  1*P/8  6*P/8  3*P/8  0
! Thus the 4*P/8 = 2097152 random number is 2097152/2**22.
!      Several multipliers have been subjected to the spectral test
! (see Knuth, p. 82).  Four suitable multipliers roughly in order of
! goodness according to the spectral test are
!    3146757 = 1536*2048 + 1029 = 2**21 + 2**20 + 2**10 + 5
!    2098181 = 1024*2048 + 1029 = 2**21 + 2**10 + 5
!    3146245 = 1536*2048 +  517 = 2**21 + 2**20 + 2**9 + 5
!    2776669 = 1355*2048 + 1629 = 5**9 + 7**7 + 1
!
!      In the table below LOG10(NU(I)) gives roughly the number of
! random decimal digits in the random numbers considered I at a time.
! C is the primary measure of goodness.  In both cases bigger is better.
!
!                   LOG10 NU(I)              C(I)
!       A       I=2  I=3  I=4  I=5    I=2  I=3  I=4  I=5
!
!    3146757    3.3  2.0  1.6  1.3    3.1  1.3  4.6  2.6
!    2098181    3.3  2.0  1.6  1.2    3.2  1.3  4.6  1.7
!    3146245    3.3  2.2  1.5  1.1    3.2  4.2  1.1  0.4
!    2776669    3.3  2.1  1.6  1.3    2.5  2.0  1.9  2.6
!   Best
!    Possible   3.3  2.3  1.7  1.4    3.6  5.9  9.7  14.9
!
!             Input Argument --
! R      If R = 0., the next random number of the sequence is generated.
!        If R < 0., the last generated number will be returned for
!          possible use in a restart procedure.
!        If R > 0., the sequence of random numbers will start with
!          the seed R mod 1.  This seed is also returned as the value of
!          RAND provided the arithmetic is done exactly.
!
!             Output Value --
! RAND   a pseudo-random number between 0. and 1.
!***REFERENCES  (NONE)
!***ROUTINES CALLED  (NONE)
!***END PROLOGUE  RAND

use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: rand_cvb
real(kind=wp), intent(in) :: r
integer(kind=iwp) :: ix0 = 0, ix1 = 0, iy0, iy1
real(kind=wp) :: rand
integer(kind=iwp), parameter :: ia0 = 1029, ia1 = 1536, ia1ma0 = ia1-ia0, ic = 1731, sc = 2048
real(kind=wp), parameter :: xx = 4194304.0_wp

!***FIRST EXECUTABLE STATEMENT  RAND
if (r > Zero) then

  ix1 = int(mod(r,One)*xx+Half)
  ix0 = mod(ix1,sc)
  ix1 = (ix1-ix0)/sc

else if (r == Zero) then

  ! A*X = 2**22*IA1*IX1 + 2**11*(IA1*IX1 + (IA1-IA0)*(IX0-IX1) + IA0*IX0) + IA0*IX0

  iy0 = ia0*ix0
  iy1 = ia1*ix1+ia1ma0*(ix0-ix1)+iy0
  iy0 = iy0+ic
  ix0 = mod(iy0,sc)
  iy1 = iy1+(iy0-ix0)/sc
  ix1 = mod(iy1,sc)

end if

rand = real(ix1*sc+ix0,kind=wp)
rand_cvb = rand/xx

return

end function rand_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_CALCINT_4(XINT,LINT,ISHLCD,ISHLAB)
C
C     Purpose: calculate qualified integral columns from
C              shell quadruple (ISHLC ISHLD|ISHLA ISHLB).
C
C     Version 4: avoid storage of full shell quadruple in interface to
C                seward; get qualified directly as in Version 2 and 3!
C                Changes from Version 3:
C                - only one shell quadruple is computed (not an entire
C                  column).
C
#include "implicit.fh"
      DIMENSION XINT(LINT)
#include "cholesky.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*17 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_CALCINT_4')

      INTEGER  CHO_ISUMELM
      EXTERNAL CHO_ISUMELM

      INTEGER NAB(8)

      LOGICAL   LOCDBG
      PARAMETER (LOCDBG = .FALSE.)
      PARAMETER (INFINT = INF_INT, INFIN2 = INF_IN2)

      ISP2F(I)=IWORK(ip_iSP2F-1+I)

C     Set mapping from shell pair AB to qualified columns.
C     ----------------------------------------------------

      IRC  = 0
      ILOC = 2
      CALL CHO_SETSHP2Q_2(IRC,ILOC,ISHLAB,NAB)
      IF (IRC .NE. 0) THEN
         WRITE(LUPRI,*) SECNAM,': CHO_SETSHP2Q_2 returned ',IRC
         CALL CHO_QUIT('Error termination in '//SECNAM,IRC)
      END IF

C     Print.
C     ------

      IF (IPRINT .GE. INF_IN2) THEN
         CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.TRUE.)
         CALL CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.TRUE.)
         NCOLAB = CHO_ISUMELM(NAB,NSYM)
         WRITE(LUPRI,'(/,A,I5,1X,I5,A,I5,1X,I5,A,I9,A)')
     &   'Calculating shell quadruple (',ISHLC,ISHLD,'|',ISHLA,ISHLB,
     &   '):',NCOLAB,' columns have been qualified'
         WRITE(LUPRI,'(89A)') ('=',i=1,89)
      END IF

C     Set mapping from shell pair CD to reduced set.
C     ----------------------------------------------

      IRC  = 0
      ILOC = 2
      CALL CHO_SETSHP2RS_2(IRC,ILOC,ISHLCD,NAB)
      IF (IRC .NE. 0) THEN
         WRITE(LUPRI,*) SECNAM,': CHO_SETSHP2RS_2 returned ',IRC
         CALL CHO_QUIT('Error termination in '//SECNAM,IRC)
      END IF

C     Calculate integrals.
C     --------------------

      CALL CHO_TIMER(C1,W1)
      CALL CHO_MCA_INT_1(ISHLCD,ISHLAB,
     &                   XINT,LINT,
     &                   LOCDBG.OR.(IPRINT.GE.100))
      CALL CHO_TIMER(C2,W2)
      TINTEG(1,1) = TINTEG(1,1) + C2 - C1
      TINTEG(2,1) = TINTEG(2,1) + W2 - W1

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! New VECTOR UTILITIES, written by Steven Vancoillie, May 2011
! A set of subroutines that can transform RHS arrays using the parallel
! aware subroutines
!***********************************************************************

subroutine POVLVEC(IVEC,JVEC,OVLAPS)
! Compute overlaps of vectors nr IVEC and JVEC in SR format!, for each
! individual case and symmetry block, in OVLAPS(ISYM,ICASE), summed over
! symmetry in OVLAPS(0,ICASE), summed over case in OVLAPS(ISYM,0), total
! sum in OVLAPS(0,0).

use caspt2_module, only: CPUOVL, MxCase, nCASES, NINDEP, NISUP, nSym, TIOOVL
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iVec, jVec
real(kind=wp), intent(out) :: OVLAPS(0:8,0:MXCASE)
integer(kind=iwp) :: iCase, iSym, lg_v1, lg_v2, NIN, NIS
real(kind=wp) :: CPU, CPU0, CPU1, OVL, OVLSUM, OVLTOT, TIO, TIO0, TIO1
real(kind=wp), external :: RHS_DDOT

call TIMING(CPU0,CPU,TIO0,TIO)

OVLTOT = Zero
OVLAPS(:,0) = Zero

do ICASE=1,NCASES
  OVLSUM = Zero
  do ISYM=1,NSYM
    OVL = Zero
    NIN = NINDEP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (NIN*NIS /= 0) then
      call RHS_ALLO(NIN,NIS,lg_V1)
      call RHS_READ(NIN,NIS,lg_V1,ICASE,ISYM,IVEC)
      if (IVEC /= JVEC) then
        call RHS_ALLO(NIN,NIS,lg_V2)
        call RHS_READ(NIN,NIS,lg_V2,ICASE,ISYM,JVEC)
      else
        lg_V2 = lg_V1
      end if
      OVL = RHS_DDOT(NIN,NIS,lg_V1,lg_V2)
      call RHS_FREE(lg_V1)
      if (IVEC /= JVEC) call RHS_FREE(lg_V2)
    end if
    OVLAPS(ISYM,ICASE) = OVL
    OVLAPS(ISYM,0) = OVLAPS(ISYM,0)+OVL
    OVLSUM = OVLSUM+OVL
  end do
  OVLAPS(0,ICASE) = OVLSUM
  OVLTOT = OVLTOT+OVLSUM
end do
OVLAPS(0,0) = OVLTOT

call TIMING(CPU1,CPU,TIO1,TIO)
CPUOVL = CPUOVL+(CPU1-CPU0)
TIOOVL = TIOOVL+(TIO1-TIO0)

end subroutine POVLVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************
subroutine CalcP2MOCube(P2MOCube,P2MOCubex,P2MOCubey,P2MOCubez,nPMO3p,MOs,MOx,MOy,MOz,TabMO,P2Unzip,mAO,mGrid,nMOs,do_grad)

use nq_pdft, only: lft, lGGA
use nq_Info, only: IOff_Ash, IOff_BasAct, mIrrep, nAsh, NASHT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nPMO3p, mAO, mGrid, nMOs
real(kind=wp), intent(out) :: P2MOCube(NASHT,mGrid), P2MOCubex(NASHT,nPMO3p), P2MOCubey(NASHT,nPMO3p), P2MOCubez(NASHT,nPMO3p), &
                              MOs(NASHT,mGrid), MOx(NASHT,mGrid), MOy(NASHT,mGrid), MOz(NASHT,mGrid)
real(kind=wp), intent(in) :: TabMO(mAO,mGrid,nMOs), P2Unzip(NASHT,NASHT,NASHT,NASHT)
logical(kind=iwp), intent(in) :: do_grad
integer(kind=iwp) :: IIrrep, iGrid, IOff1, IOff2, NASHT2, NASHT3
logical(kind=iwp) :: lftGGA
real(kind=wp), allocatable :: P2MO1(:), P2MOSquare(:)

lftGGA = .false.
if (lft .and. lGGA) lftGGA = .true.
do iGrid=1,mGrid
  do iIrrep=0,mIrrep-1
    IOff1 = IOff_Ash(iIrrep)
    IOff2 = IOff_BasAct(iIrrep)
    MOs(IOff1+1:IOff1+nAsh(iIrrep),iGrid) = TabMO(1,iGrid,IOff2+1:IOff2+nAsh(iIrrep))
  end do
end do

if (lGGA) then
  do iGrid=1,mGrid
    do iIrrep=0,mIrrep-1
      IOff1 = IOff_Ash(iIrrep)
      IOff2 = IOff_BasAct(iIrrep)
      MOx(IOff1+1:IOff1+nAsh(iIrrep),iGrid) = TabMO(2,iGrid,IOff2+1:IOff2+nAsh(iIrrep))
      MOy(IOff1+1:IOff1+nAsh(iIrrep),iGrid) = TabMO(3,iGrid,IOff2+1:IOff2+nAsh(iIrrep))
      MOz(IOff1+1:IOff1+nAsh(iIrrep),iGrid) = TabMO(4,iGrid,IOff2+1:IOff2+nAsh(iIrrep))
    end do
  end do
end if

NASHT2 = NASHT**2
NASHT3 = NASHT2*NASHT
call mma_allocate(P2MO1,NASHT3,label='P2MO1')
call mma_allocate(P2MOSquare,NASHT2,label='P2MOSquare')
do iGrid=1,mGrid

  !call RecPrt('MOs array','(10(F9.5,1X))',MOs(:,iGrid),1,NASHT)

  !call RecPrt('2RDM array','(10(F9.5,1X))',P2Unzip,NASHT3,NASHT)

  call DGEMM_('T','N',NASHT3,1,NASHT,One,P2UnZip,NASHT,MOs(:,iGrid),NASHT,Zero,P2MO1,NASHT3)

  !call RecPrt('P2MO1 array','(10(F9.5,1X))',P2MO1,NASHT2,NASHT)

  call DGEMM_('T','N',NASHT2,1,NASHT,One,P2MO1,NASHT,MOs(:,iGrid),NASHT,Zero,P2MOSquare,NASHT2)

  !call RecPrt('P2MOSquare array','(10(F9.5,1X))',P2MOSquare,NASHT,NASHT)

  call DGEMM_('T','N',NASHT,1,NASHT,One,P2MOSquare,NASHT,MOs(:,iGrid),NASHT,Zero,P2MOCube(:,iGrid),NASHT)

  if (lftGGA .and. Do_Grad) then
    call DGEMM_('T','N',NASHT,1,NASHT,One,P2MOSquare,NASHT,MOx(:,iGrid),NASHT,Zero,P2MOCubex(:,iGrid),NASHT)
    call DGEMM_('T','N',NASHT,1,NASHT,One,P2MOSquare,NASHT,MOy(:,iGrid),NASHT,Zero,P2MOCubey(:,iGrid),NASHT)
    call DGEMM_('T','N',NASHT,1,NASHT,One,P2MOSquare,NASHT,MOz(:,iGrid),NASHT,Zero,P2MOCubez(:,iGrid),NASHT)

    call DGEMM_('T','N',NASHT2,1,NASHT,One,P2MO1,NASHT,MOx(:,iGrid),NASHT,Zero,P2MOSquare,NASHT2)
    call DGEMM_('T','N',NASHT,1,NASHT,Two,P2MOSquare,NASHT,MOs(:,iGrid),NASHT,One,P2MOCubex(:,iGrid),NASHT)

    call DGEMM_('T','N',NASHT2,1,NASHT,One,P2MO1,NASHT,MOy(:,iGrid),NASHT,Zero,P2MOSquare,NASHT2)
    call DGEMM_('T','N',NASHT,1,NASHT,Two,P2MOSquare,NASHT,MOs(:,iGrid),NASHT,One,P2MOCubey(:,iGrid),NASHT)

    call DGEMM_('T','N',NASHT2,1,NASHT,One,P2MO1,NASHT,MOz(:,iGrid),NASHT,Zero,P2MOSquare,NASHT2)
    call DGEMM_('T','N',NASHT,1,NASHT,Two,P2MOSquare,NASHT,MOs(:,iGrid),NASHT,One,P2MOCubez(:,iGrid),NASHT)
  end if

  !call RecPrt('P2MOCube','(10(F9.5,1X))',P2MOCube(:,iGrid),1,NASHT)
end do
call mma_deallocate(P2MO1)
call mma_deallocate(P2MOSquare)

return

end subroutine CalcP2MOCube

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Igor Schapiro                                    *
************************************************************************
C
C *********************************************************************
C *                                                                   *
C * First part of the velocity Verlet algorithm, which calculates the *
C * new positions for the next time step and the new velocities for   *
C * a half time step. The algorithm is based on the example F4 from   *
C * molecular dynamics bible of Allen and Tildesley.                  *
C *                                                                   *
C * 15/10/2006                                                        *
C * Igor Schapiro                                                     *
C *                                                                   *
C *********************************************************************

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8

      SUBROUTINE VelVer_First(irc)
#include "prgm.fh"
#include "warnings.fh"
#include "Molcas.fh"
      PARAMETER   (ROUTINE='VV_First')
#include "MD.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "dyn.fh"
#include "constants2.fh"
      EXTERNAL    IsFreeUnit
      INTEGER     natom,i,j,irc,file,IsFreeUnit,ipCoord
      REAL*8      DT2,DTSQ2,Ekin,time,totimpl,RMS

      CHARACTER  caption*15, lastline*80, filname*80
      LOGICAL    hybrid,qmmm
*
      INTEGER    natom2
*
      REAL*8, ALLOCATABLE ::      vel(:),xyz(:),force(:)
      REAL*8, ALLOCATABLE ::      Mass(:),tstxyz(:)
      CHARACTER, ALLOCATABLE ::  atom(:)*2, atom2(:)*2
      REAL*8, ALLOCATABLE ::     force2(:),xyz2(:)
*
      IF(IPRINT.EQ.INSANE) WRITE(6,*)' Entering ',ROUTINE

      WRITE(6,*)'*** First step of the Velocity Verlet algorithm ***'
C
C     Check for QM/MM calculation
C
      filname = 'comqum.dat'
      CALL F_INQUIRE(filname,hybrid)
      hybrid=.False.
C
C     Read atom, their coordinates and forces
C
      IF (hybrid) THEN
         WRITE(6,'(/,5X,A)') 'Perform QM/MM Molecular Dynamics'
         CALL DxRdNAtomHbrd(natom)
      ELSE
         CALL DxRdNAtomStnd(natom)
      END IF

      CALL mma_allocate(vel,natom*3)
      CALL mma_allocate(xyz,natom*3)
      CALL mma_allocate(force,natom*3)
      CALL mma_allocate(tstxyz,natom*3)
      CALL mma_allocate(Mass,natom)
      CALL mma_allocate(atom,natom)

      IF (hybrid) THEN
         CALL DxRdHbrd(natom,atom,xyz,force)
      ELSE
         CALL DxRdStnd(natom,atom,xyz,force)
      END IF
      CALL Get_dScalar('MD_time',time)
C
C     Read the velocities
C
      CALL Get_Velocity(vel,3*natom)
C
C     Initialize the Mass variable
      CALL GetMassDx(Mass,natom)
C
C Check if reduced dimensionality
      IF (POUT .NE. 0) THEN
        CALL project_out_for(force,natom)
      ELSEIF (PIN .NE. natom*3) THEN
        CALL project_in_for(force,natom)
      ENDIF
C--------------------------------------------------------------------C
C CANONICAL ENSEMBLE
C--------------------------------------------------------------------C
      IF (THERMO.eq.2) THEN
         call NhcThermo(vel)
      ENDIF
C--------------------------------------------------------------------C

C     Write out the old coordinates
C
      CALL DxRdNAtomStnd(natom2)
      CALL mma_allocate(xyz2,natom*3)
      CALL mma_allocate(force2,natom*3)
      CALL mma_allocate(atom2,natom)
      CALL DxRdStnd(natom2,atom2,xyz2,force2)
**      IF (iPrint.ge.VERBOSE) THEN
         caption = 'Old Coordinates'
         lastline = ''
         CALL DxPtTableCo(caption,time,natom2,atom2,xyz2,lastline,
     &        Mass,force)
**      END IF
C
C     Definition of the time step
C
      DT2   = DT / 2.0D0
      DTSQ2 = DT * DT2
*
      Ekin = 0.0D0
      RMS = 0.0D0
      totimpl = 0.0D0
*
      DO i=1, natom
        DO j=1, 3
*** Root mean square deviation ****************************
          tstxyz(3*(i-1)+j) = xyz(3*(i-1)+j)
***********************************************************
          xyz(3*(i-1)+j) = xyz(3*(i-1)+j) + DT *
     &    vel(3*(i-1)+j) + DTSQ2 * force(3*(i-1)+j) / Mass(i)
***********************************************************
          RMS=RMS+(tstxyz(3*(i-1)+j)-xyz(3*(i-1)+j))**2
***********************************************************
          Ekin = Ekin + 5.0D-01 * Mass(i) * (vel(3*(i-1)+j) ** 2)
          vel(3*(i-1)+j) = vel(3*(i-1)+j) + DT2 * force(3*(i-1)+j) /
     &       Mass(i)
          totimpl = totimpl + vel(3*(i-1)+j) * Mass(i)
        END DO
      END DO

C Check if reduced dimensionality (should not be needed)
      IF (POUT .NE. 0) THEN
        CALL project_out_vel(vel,natom)
      ELSEIF (PIN .NE. natom*3) THEN
        CALL project_in_vel(vel,natom)
      ENDIF

      Call Add_Info('EKin',[EKin],1,6)

      RMS=SQRT(RMS/natom)
C
C     Update the Link-Atom position
C     (Temporary solution uses ipCoord instead of xyz)
C
      qmmm = .False.
         Call DecideOnESPF(qmmm)
         If (qmmm) Then
            Call GetMem('Coordinates','ALLO','REAL',ipCoord,3*natom)
            call dcopy_(3*natom,xyz,1,Work(ipCoord),1)
            Call LA_Morok(natom,Work(ipCoord),2)
            call dcopy_(3*natom,Work(ipCoord),1,xyz,1)
            Call Free_Work(ipCoord)
         End If
C
C     Output
C
      IF (iPrint.ge.USUAL) THEN
        WRITE(6,400) 'Molecular Dynamics specifications (time = ',
     &                   time,' a.u.)'
        WRITE(6,'(5X,A,/)') '=========================================='
        WRITE(6,402) 'Kinetic energy',Ekin,'a.u.'
        WRITE(6,405) 'Total linear momentum ',totimpl,'a.u.'
        WRITE(6,402) 'RMS deviation ',RMS,'Bohr'
      END IF

      time = time + DT
C
C     Set the initialization flag and save the current time-value
C
      CALL Put_dScalar('MD_Time',time)
#ifdef _HDF5_
      call mh5_put_dset(dyn_time,time)
#endif
C
C     Write out the new coordinates
C
      caption = 'New Coordinates'
      lastline = ''
      CALL DxPtTableCo(caption,time,natom,atom,xyz,lastline,Mass,force)
C
C     Write coordinates to output file
C
*#ifdef _DEBUGPRINT_
*      WRITE(6,*)' Dynamix calls 2 DxCoord.'
*#endif
      CALL DxCoord(natom,atom,xyz,hybrid)
*#ifdef _DEBUGPRINT_
*      WRITE(6,*)' Dynamix back from 2 DxCoord.'
*#endif
C
C     Save the new coordinates
C
      IF (hybrid) THEN
          call dscal_(natom*3,Angstrom,xyz,1)
          file=IsFreeUnit(81)
          filname='prmcrd2'
          Call Molcas_Open(file,filname)
          WRITE(file,403)natom
          WRITE(file,404)(xyz(i),i=1,natom*3)
          CLOSE(file)
      ELSE
          CALL Put_Coord_Full(xyz,natom)
#ifdef _HDF5_
          call mh5_put_dset(dyn_geom,xyz)
#endif
      END IF

      CALL Put_Velocity(vel,3*natom)
#ifdef _HDF5_
      call mh5_put_dset(dyn_vel,vel)
#endif

      CALL mma_deallocate(vel)
      CALL mma_deallocate(xyz)
      CALL mma_deallocate(force)
      CALL mma_deallocate(tstxyz)
      CALL mma_deallocate(Mass)
      CALL mma_deallocate(atom)
      CALL mma_deallocate(xyz2)
      CALL mma_deallocate(force2)
      CALL mma_deallocate(atom2)
C
C     The return code is set in order to continue the loop
C
      irc=_RC_ALL_IS_WELL_
C
 400  FORMAT(5X,A,F8.1,A)
 402  FORMAT(5X,A14,8X,D11.4,1X,A)
 403  FORMAT(/,I5)
 404  FORMAT(6F12.7)
 405  FORMAT(5X,A22,D11.4,1X,A)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contf14(wrk,wrksize,lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,lunt2o3)
! this routine does:
! 2)  FI4   f1(a,e) <- -sum(m>n,f) [Tap(af,mn) . <ef||mn>]
!
! N.B. use and destroy : V1,V2,V3,V4,M1
! N.B. # of get v2o2 : 6
! N.B. possible fusion with f24 graph

use ccsd_global, only: f11, f12, idaabb, idbaab, m1, t11, t12, v1, v2, v3, v4
use Para_Info, only: MyRank
use Constants, only: One, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp), intent(_IN_) :: lunabij1, lunabij2, lunabij3, lunt2o1, lunt2o2, lunt2o3
integer(kind=iwp) :: post, rc, ssc

!1 f1(a,e)aa <- -sum(m>n,f-aaa) [ Tap(a,f,mn)aaaa . <ef||mn>aaaa ]

!par
if (myRank == idbaab) then

  !1.1 read V1(af,mn) <= T2o(af,mn)aaaa
  call filemanager(2,lunt2o1,rc)
  call getmediate(wrk,wrksize,lunt2o1,v1,rc)

  !1.2 make Tap V1(af,mn) from V1(af,mn)
  call mktau(wrk,wrksize,v1,t11,t12,Half,rc)

  !1.3 expand V2(a,f,mn) <= V1(af,mn)
  call expand(wrk,wrksize,4,5,v1,1,v2,rc)

  !1.4 read V1(ef,mn) <= <ef||mn>aaaa
  call filemanager(2,lunabij1,rc)
  call getmediate(wrk,wrksize,lunabij1,v1,rc)

  !1.5 expand V3(e,f,mn) <= V1(ef,mn)
  call expand(wrk,wrksize,4,5,v1,1,v3,rc)

  !1.6 map V1(f,mn,e) <= V3(e,f,mn)
  call map(wrk,wrksize,4,4,1,2,3,v3,1,v1,post,rc)

  !1.7 mult M1(a,e) <= V2(a,f,mn) . V1(f,mn,e)
  call ccmult(wrk,wrksize,4,4,2,3,v2,1,v1,1,m1,ssc,rc)

  !1.8 add f1(a,e)aa <- M1(a,e)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,-One,m1,1,f11,1,rc)

end if

!2 f1(a,e)bb <- -sum(m>n,f-bbb) [ Tap(a,f,mn)bbbb . <ef||mn>bbbb ]

!par
if (myRank == idaabb) then

  !2.1 read V1(af,mn) <= T2o(af,mn)bbbb
  call filemanager(2,lunt2o2,rc)
  call getmediate(wrk,wrksize,lunt2o2,v1,rc)

  !2.2 make Tap V1(af,mn) from V1(af,mn)
  call mktau(wrk,wrksize,v1,t11,t12,Half,rc)

  !2.3 expand V2(a,f,mn) <= V1(af,mn)
  call expand(wrk,wrksize,4,5,v1,1,v2,rc)

  !2.4 read V1(ef,mn) <= <ef||mn>bbbb
  call filemanager(2,lunabij2,rc)
  call getmediate(wrk,wrksize,lunabij2,v1,rc)

  !2.5 expand V3(e,f,mn) <= V1(ef,mn)
  call expand(wrk,wrksize,4,5,v1,1,v3,rc)

  !2.6 map V1(f,mn,e) <= V3(e,f,mn)
  call map(wrk,wrksize,4,4,1,2,3,v3,1,v1,post,rc)

  !2.7 mult M1(a,e) <= V2(a,f,mn) . V1(f,mn,e)
  call ccmult(wrk,wrksize,4,4,2,3,v2,1,v1,1,m1,ssc,rc)

  !2.8 add f1(a,e)bb <- M1(a,e)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,-One,m1,1,f12,1,rc)

end if

!3 f1(a,e)aa <- -sum(m,n,f-abb) [ Tap(a,f,m,n)abab . <ef||mn>abab
!4 f1(a,e)bb <- -sum(m,n,f-aba) [ Tap(f,a,m,n)abab . <fe||mn>abab

!par
if ((myRank == idbaab) .or. (myRank == idaabb)) then

  !34.1 read V1(c,d,m,n) <= T2o(c,d,m,n)abab
  call filemanager(2,lunt2o3,rc)
  call getmediate(wrk,wrksize,lunt2o3,v1,rc)

  !34.2 read V2(c,d,m,n) <= <cd||mn>abab
  call filemanager(2,lunabij3,rc)
  call getmediate(wrk,wrksize,lunabij3,v2,rc)

  !34.3 make Tap V1(c,d,m,n) from V1(c,d,m,n)
  call mktau(wrk,wrksize,v1,t11,t12,Half,rc)

  !3.1 map V3(f,m,n,e) <= V2(e,f,m,n)
  call map(wrk,wrksize,4,4,1,2,3,v2,1,v3,post,rc)

end if

!par
if (myRank == idbaab) then

  !3.2 mult M1(a,e) <= V1(a,f,m,n) . V3(f,m,n,e)
  call ccmult(wrk,wrksize,4,4,2,3,v1,1,v3,1,m1,ssc,rc)

  !3.3 add f1(a,e))aa <- - M1(a,e)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,-One,m1,1,f11,1,rc)
end if

!par
if (myRank == idaabb) then

  !4.1 map V4(a,f,m,n) <= V1(f,a,m,n)
  call map(wrk,wrksize,4,2,1,3,4,v1,1,v4,post,rc)

  !4.2 map V3(f,m,n,e) <= V2 (f,e,m,n)
  call map(wrk,wrksize,4,1,4,2,3,v2,1,v3,post,rc)

  !4.3 mult M1(a,e) <= V4(a,f,m,n) . V3(f,m,n,e)
  call ccmult(wrk,wrksize,4,4,2,3,v4,1,v3,1,m1,ssc,rc)

  !4.4 add f1(a,e))bb <- - M1(a,e)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,-One,m1,1,f12,1,rc)

end if

return

end subroutine contf14

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SphInt(xyz,nCent,iOfRef,RR0,Bf,l_Write,lWarn,Label,
     &                  dBf,ldB)
      Implicit Real*8  (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "weighting.fh"
#include "info_slapaf.fh"
      Real*8   Bf(3,nCent), xyz(3,nCent), dBf(3,nCent,3,nCent)
      Logical l_Write, ldB, lWarn
      Character*8 Label
*
      xyz0(i,j)=Work(ipRef_+(j-1)*3+i-1)
*
*
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the radius of the hypersphere
*
      If (iOfRef.eq.ip_Dummy) Then
         ipRef_=ipRef
      Else
         ipRef_=iOfRef
      End If
C     Call RecPrt('SphInt: xyz',' ',xyz,3,nCent)
C     Call RecPrt('Ref: xyz0',' ',Work(ipRef_),3,nCent)
      RR0=Zero
      TWeight=Zero
      Do iCent = 1, nCent
         Fact=DBLE(iDeg(xyz(1,iCent)))
         xWeight=Fact*Work(ipWeights+iCent-1)
         TWeight=TWeight+xWeight
C        Write (*,*) 'xWeight=',xWeight
         Do ixyz = 1, 3
C           Write (*,*)xyz(ixyz,iCent),xyz0(ixyz,iCent)
            temp=xyz(ixyz,iCent)-xyz0(ixyz,iCent)
            RR0=RR0 + xWeight*temp**2
         End Do
      End Do
      RR0_unscaled=Sqrt(RR0)
*
*     RR0_unscaled is the real (weighthed) distance,
*     RR0 is scaled by 1/Sqrt(TWeight) and so are the derivatives
*
      SqInvTWeight=One/Sqrt(TWeight)
      RR0=RR0_unscaled*SqInvTWeight
*
      If (l_Write) Then
         Write (6,'(2A,F18.8,A)') Label,' : Radius of h-sphere= ',
     &                            RR0,
     &                            ' au (weighted/sqrt(total weight))'
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the WDC B-matrix
*
*FIXME: revise the symmetry
      Do iCent = 1, nCent
         Fact=DBLE(iDeg(xyz(1,iCent)))
         xWeight=Fact*Work(ipWeights+iCent-1)
         Do iCar = 1, 3
            temp=xyz(iCar,iCent)-xyz0(iCar,iCent)
            If (RR0_unscaled.ne.Zero) Then
               temp=xyz(iCar,iCent)-xyz0(iCar,iCent)
               Bf(iCar,iCent)=xWeight*temp/RR0_unscaled*SqInvTWeight
            Else
*
*              If we are standing on the reference point the gradient
*              is not well defined.
*
               Bf(iCar,iCent)=Zero
            End If
         End Do
      End Do
c     Call RecPrt('Bf',' ',Bf,3,nCent)
*                                                                      *
************************************************************************
*                                                                      *
*
*---- Compute the cartesian derivative of the B-Matrix.
*
*FIXME: revise the symmetry
      If (ldB) Then
         Call FZero(dBf,(3*nCent)**2)
         If (RR0.eq.Zero) Go To 99
         Do iCent = 1, nCent
            Fact=DBLE(iDeg(xyz(1,iCent)))
            xWeight=Fact*Work(ipWeights+iCent-1)
            Do ixyz = 1, 3
               tempi=xyz(ixyz,iCent)-xyz0(ixyz,iCent)
               Do jCent = 1, nCent
                  Fact=DBLE(iDeg(xyz(1,jCent)))
                  yWeight=Fact*Work(ipWeights+jCent-1)
                  Do jxyz = 1, 3
                     tempj=xyz(jxyz,jCent)-xyz0(jxyz,jCent)
                     temp=Zero
                     If (ixyz.eq.jxyz.and.iCent.eq.jCent)
     &                  temp=RR0_unscaled
                     temp=temp-yWeight*tempi*tempj/RR0_unscaled
                     temp=(xWeight*temp)/RR0_unscaled**2
                     dBf(ixyz,iCent,jxyz,jCent) = temp*SqInvTWeight
                  End Do
               End Do
            End Do
         End Do
 99      Continue
C        Call RecPrt('dBf',' ',dBf,3*nCent,3*nCent)
*
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(lWarn)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_XCV_RdVec_(irc,Vec,myRankSP,n_myRankSP,NVT,J1,J2,iSym)
!
! Read the vector blocks.

use Cholesky, only: LuTmp, nnBstRSh
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(_OUT_) :: Vec(*)
integer(kind=iwp), intent(in) :: n_myRankSP, myRankSP(n_myRankSP), NVT, J1, J2, iSym
integer(kind=iwp) :: i, iAdr, iAdr0, iSP, kV, lTot, n
integer(kind=iwp), parameter :: iOpt = 2

irc = 0

n = J2-J1+1
iAdr0 = 0
kV = 1
do i=1,n_myRankSP
  iSP = myRankSP(i)
  lTot = nnBstRSh(iSym,iSP,2)*n
  if (lTot > 0) then
    iAdr = iAdr0+nnBstRSh(iSym,iSP,2)*(J1-1)
    call DDAFile(LuTmp(iSym),iOpt,Vec(kV),lTot,iAdr)
    kV = kV+lTot
  end if
  iAdr0 = iAdr0+nnBstRSh(iSym,iSP,2)*NVT
end do

end subroutine Cho_XCV_RdVec_

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine ssibfn(nmax,x,ssi)
c
c  scaled spherical i bessel functions
c
      implicit real*8 (a-h,o-z)
      parameter (a0=0.0d0, a1=1.0d0, a3s2=1.5d0, a2=2.0d0, a3=3.0d0,
     1  a20=20.0d0)
      dimension ssi(*)
c
      x2=x*x
      xmin=(abs(3*nmax-1))
      if(x.gt.xmin) go to 5
      n=nmax
      f2np1=(n+n+1)
      f2kp3=f2np1
      pkm1=a0
      pk=a1
      qkm1=a1
      qk=a1
      aprod=a1
    1 f2kp1=f2kp3
      f2kp3=f2kp3+a2
      ak=x2/(f2kp1*f2kp3)
      akpkm2=ak*pkm1
      pkm1=pk
      pk=pkm1+akpkm2
      akqkm2=ak*qkm1
      qkm1=qk
      qk=qkm1+akqkm2
      aprod=ak*aprod
      if(((pk*qkm1)+aprod).ne.(pk*qkm1)) go to 1
      ssi(n+1)=pk/qk
    2 if(n.eq.0) go to 3
      n=n-1
      f2np3=f2np1
      f2np1=f2np1-a2
      ssi(n+1)=(f2np1*f2np3)/((f2np1*f2np3)+x2*ssi(n+2))
      go to 2
    3 ssi(1)=ssi(1)/(a1+x*ssi(1))
      do 4 n=1,nmax
        ssi(n+1)=ssi(n+1)*ssi(n)
    4 continue
      return
c
    5 if(x.ge.a20) then
        ex=a0
      else
        ex=exp(-(x+x))
      endif
      ssi(1)=(a1-ex)/(x+x)
      if(nmax.eq.0) return
      ssi(2)=a3s2*(a1+ex+(ex-a1)/x)/x2
      if(nmax.eq.1) return
      f2np1=a3
      do 8 n=2,nmax
        f2nm1=f2np1
        f2np1=f2np1+a2
        ssi(n+1)=(ssi(n-1)-ssi(n))*(f2nm1*f2np1)/x2
    8 continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RdCtl_Seward(LuRd_,lOPTO,Do_OneEl)

use AMFI_Info, only: No_AMFI
use Basis_Info, only: dbsc, Gaussian_Type, Max_Shells, mGaussian_Type, MolWgh, nCnttp, Nuclear_Model, Point_Charge, Shells
use Center_Info, only: dc, n_dc
use Her_RW, only: nPrp
use Period, only: AdCell, Cell_l, lthCell, ispread, VCell
use MpmC, only: Coor_MPM
use EFP_Module, only: ABC, Coor_Type, EFP_COORS, FRAG_TYPE, lEFP, nEFP_Coor, nEFP_fragments, POINTS_TYPE, ROTMAT_type, XYZABC_type
use Real_Spherical, only: Sphere
use fortran_strings, only: str
use External_Centers, only: AMP_Center, DMS_Centers, Dxyz, EF_Centers, iXPolType, nData_XF, nDMS, nEF, nOrd_XF, nOrdEF, nRP, nWel, &
                            nXF, nXMolnr, OAM_Center, OMQ_Center, RP_Centers, Wel_Info, XEle, XF, XMolnr
use Symmetry_Info, only: iSkip, nIrrep, Symmetry_Info_Setup, VarR, VarT
use Sizes_of_Seward, only: S
use Gateway_Info, only: Align_Only, CoM, CutInt, Do_Align, Do_FckInt, Do_GuessOrb, DoFMM, E1, E2, EMFR, FNMC, GIAO, kVector, &
                        lAMFI, lDOWNONLY, lMXTC, lRel, lRP, lSchw, lUPONLY, NEMO, PkAcc, RPQMin, Rtrnc, SadStep, Shake, ThrInt, &
                        Thrs, UnNorm, Vlct
use DKH_Info, only: iCtrLD, BSS, cLightAU, DKroll, IRELAE, LDKRoll, nCtrlD, radiLD
use RICD_Info, only: Cholesky, DiagCheck, Do_acCD_Basis, Do_RI, iRI_Type, LDF, LocalDF, Skip_High_AC, Thrshld_CD
use Gateway_global, only: DirInt, Expert, Fake_ERIs, Force_Out_of_Core, force_part_c, force_part_p, G_Mode, ifallorb, iPack, &
                          iWRopt, NoTab, Onenly, Prprt, Run_Mode, S_Mode, Short, SW_FileOrb, Test
#ifdef _FDE_
use Embedding_Global, only: embOutDensPath, embOutEspPath, embOutGradPath, embOutHessPath, embPot, embPotInBasis, embPotPath, &
                            embWriteDens, embWriteEsp, embWriteGrad, embWriteHess, outGridPath, outGridPathGiven
#endif
#ifndef _HAVE_EXTRA_
use XYZ, only: Clear_XYZ, Parse_Basis, Parse_Group, Read_XYZ, Write_SewInp
#endif
use Para_Info, only: MyRank
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Four, Ten, Pi, Angstrom, mu2elmass, UtoAU
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LuRd_
logical(kind=iwp), intent(inout) :: lOPTO
logical(kind=iwp), intent(out) :: Do_OneEl
#include "Molcas.fh"
#include "angtp.fh"
#include "rctfld.fh"
#include "rmat.fh"
#include "print.fh"
#include "embpcharg.fh"
#include "cgetl.fh"
#ifdef _HAVE_EXTRA_
#include "hyper.fh"
#endif
integer(kind=iwp), parameter :: MAX_XBAS = 20
integer(kind=iwp) :: BasisTypes(4), BasisTypes_Save(4), i, i1, i2, iAng, iAt, iAtom_Number, ib, ibla, iBSSE, iChk_CH, iChk_DC, &
                     iChk_RI, iChrct, iChxyz, iCLDF, iCnt, iCnttp, iCoord, idk_ord, iDMS, iDNG, iDummy_basis, iEF, ierr, ifile, &
                     ifnr, iFound_Label, iFrag, iFrst, iGeoInfo(2), iglobal, ign, ii, iIso, ik, imix, iMltpl, Indx, iOff, iOff0, &
                     iOpt_XYZ, iOptimType, iPrint, iprop_ord, iRout, iShll, ist, istatus, isxbas, isXfield, iTemp, ITkQMMM, iTtl, &
                     itype, iUnique, iWel, ix, j, jAtmNr, jDim, jend, jRout, jShll, jTmp, k, lAng, Last, lAW, lSTDINP, Lu_UDC, &
                     LuFS, LuIn, LuRd, LuRd_saved, LuRdSave, LuRP, mdc, n, nAtom, nc, nc2, nCnt, nCnt0, nDataRead, nDiff, nDone, &
                     nFragment, nIsotopes, nMass, nOper, nReadEle, nRP_prev, nTemp, nTtl, nxbas, RC
real(kind=wp) :: APThr, CholeskyThr, dm, dMass, Fact, gradLim, HypParam(3), Lambda, OAMt(3), OMQt(3), RandVect(3), ScaleFactor, &
                 sDel, spanCD, stepFac1, SymThr, Target_Accuracy, tDel, Temp, v

logical(kind=iwp) :: AnyMode, APThr_UsrDef, Basis_test, BasisSet, CholeskyWasSet, Convert, CoordSet, CSPF = .false., &
                     CutInt_UsrDef, do1CCD, DoGromacs, DoneCoord, DoRys, DoTinker, EFgiven, Exists, ForceZMAT, FOUND, FragSet, &
                     GroupSet, GWInput, HyperParSet, Invert, isnumber, lDMS = .false., lECP, lFAIEMP = .false., lMltpl, &
                     lOAM = .false., lOMQ = .false., lPP, lSkip, lTtl, lXF = .false., MolWgh_UsrDef, nmwarn, NoAMFI, NoDKroll, &
                     NoZMAT, OrigInput, OriginSet, RF_read, RPSet, Skip1, Skip2, SymmSet, ThrInt_UsrDef, Vlct_, Write_BasLib, &
                     WriteZMat
character(len=LenIn) :: CtrLDK(10), dbas
character(len=512) :: Align_Weights = 'MASS'
character(len=256) :: BasLib, Basis_lib, Directory, ExtBasDir, Fname, GeoDir, KeepBasis, Message, Project, temp1, temp2
character(len=180) :: filename, KeepGroup, Key, KWord, Ref(2)
character(len=80) :: BSLbl, ChSkip, Title(10) = ''
character(len=72) :: Header(2) = ''
character(len=14) :: Vrsn = 'Gateway/Seward'
character(len=12) :: Previous_Command
character(len=4) :: CHAR4
character(len=3) :: Oper(3)
character :: AngTyp(0:iTabMx)
integer(kind=iwp), allocatable :: ITmp(:), iScratch(:), nIsot(:,:)
real(kind=wp), allocatable :: Buffer(:), DMSt(:,:), EFt(:,:), Isotopes(:), mIsot(:), OrigRot(:,:,:), OrigTrans(:,:), RTmp(:,:)
character(len=180), allocatable :: STDINP(:)
character(len=128), allocatable :: xb_bas(:)
character(len=12), allocatable :: xb_label(:)
#ifdef _HAVE_EXTRA_
logical(kind=iwp) :: geoInput, oldZmat, zConstraints
#endif
#ifdef _GROMACS_
integer(kind=iwp) :: iCastMM, iLA, LuXYZ, nCastMM, nLA
integer(kind=iwp), allocatable :: CastMM(:), DefLA(:,:)
real(kind=wp), allocatable :: FactLA(:)
#endif
#ifdef _DEBUGPRINT_
#define _TEST_ .true.
#else
#define _TEST_ .false.
#endif
integer(kind=iwp), parameter :: Cho_MolWgh = 2, nBuff = 10000
real(kind=wp), parameter :: Cho_CutInt = 1.0e-40_wp, Cho_ThrInt = 1.0e-40_wp, &
                            WellCff(3) = [0.35_wp,0.25_wp,5.2_wp], &
                            WellExp(3) = [Four,Three,Two], &
                            WellRad(3) = [-1.22_wp,-3.20_wp,-6.20_wp]
logical(kind=iwp), parameter :: IfTest = _TEST_
character(len=*), parameter :: DefNm = 'basis_library'
! Note: blank keywords have been removed and can be reused
character(len=*), parameter :: KeyW(188) = ['END ','EMBE','SYMM','FILE','VECT','ORBC','THRS','UNNO','RADI','TITL','ECPS','AUXS', &
                                            'BSSH','VERB','ORBA','ZMAT','XBAS','XYZ ','COOR','GROU','BSSE','MOVE','NOMO','SYMT', &
                                            'NODE','SDEL','TDEL','BASD','BASI','PRIN','OPTO','THRE','CUTO','RTRN','DIRE','CSPF', &
                                            'EXPE','MOLC','DCRN','MOLP','MOLE','RELI','JMAX','MULT','CENT','EMPC','XFIE','DOUG', &
                                            'DK1H','DK2H','DK3H','DK3F','RESC','RA0H','RA0F','RAIH','RX2C','RBSS','    ','BSSM', &
                                            'AMFI','AMF1','AMF2','AMF3','FAKE','FINI','MGAU','PART','FPCO','FPPR','NOTA','WELL', &
                                            'NODK','ONEO','TEST','SDIP','EPOT','EFLD','FLDG','ANGM','UPON','DOWN','OMQI','AMPR', &
                                            'DSHD','NOPA','STDO','PKTH','SKIP','EXTR','RF-I','GRID','CLIG','NEMO','RMAT','RMEA', &
                                            'RMER','RMQC','RMDI','RMEQ','RMBP','GIAO','NOCH','CHOL','FCD ','THRC','1CCD','1C-C', &
                                            'CHOI','RP-C','SADD','CELL','SPAN','SPRE','LOW ','MEDI','HIGH','DIAG','RIC ','RIJ ', &
                                            'RIJK','RICD','XRIC','NOGU','RELA','RLOC','FOOC','CDTH','SHAC','KHAC','ACD ','FAT-', &
                                            'ACCD','SLIM','    ','DOFM','NOAM','RPQM','CONS','NGEX','LOCA','LDF ','LDF1','LDF2', &
                                            'TARG','THRL','APTH','CHEC','VERI','OVER','CLDF','UNCO','WRUC','UNIQ','NOUN','RLDF', &
                                            'NOAL','WEIG','ALIG','TINK','ORIG','HYPE','ZCON','SCAL','DOAN','GEOE','OLDZ','OPTH', &
                                            'NOON','GEO ','MXTC','FRGM','TRAN','ROT ','ZONL','BASL','NUME','VART','VARR','SHAK', &
                                            'PAMF','GROM','LINK','EMFR','NOCD','FNMC','ISOT','EFP ']
integer(kind=iwp), external :: iCFrst, iChAtm, IsFreeUnit
real(kind=wp), external :: NucExp, rMass, rMassx
character(len=180), external :: Get_Ln

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 3
iPrint = nPrint(iRout)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(Buffer,nBuff,Label='Buffer')
!                                                                      *
!***********************************************************************
!                                                                      *
do i=0,iTabMx
  AngTyp(i) = Angtp(i)
  call UpCase(AngTyp(i))
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call WhichMolcas(Basis_lib)
if (Basis_lib(1:1) /= ' ') then
  ib = index(Basis_lib,' ')-1
  if (ib < 1) call SysAbendMsg('rdCtl','Too long PATH to MOLCAS',' ')
  BasLib = Basis_lib(1:ib)//'/basis_library'
else
  BasLib = DefNm
end if
Write_BasLib = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
call Qpg_cArray('Align_Weights',Found,lAW)
if (Found) call Get_cArray('Align_Weights',Align_Weights,512)
!                                                                      *
!***********************************************************************
!                                                                      *
CutInt_UsrDef = .false.
ThrInt_UsrDef = .false.
MolWgh_UsrDef = .false.
APThr_UsrDef = .false.
NoAMFI = .false.

iChk_RI = 0
iChk_CH = 0
iChk_DC = 0
iOpt_XYZ = -1

isXfield = 0
CholeskyThr = -huge(CholeskyThr)

Basis_Test = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
LuRd = LuRd_
LuFS = -1
LuRdSave = -1

nTemp = 0
lMltpl = .false.

CholeskyWasSet = .false.
do1CCD = .false.
spanCD = -huge(spanCD)
lTtl = .false.
RF_read = .false.
lSkip = .false.
NoDKroll = .false.
SymmSet = .false.
BasisSet = .false.
GroupSet = .false.
RPSet = .false.
CoordSet = .false.
DoneCoord = .false.
KeepGroup = 'FULL'
NoZMAT = .false.
ForceZMAT = .false.
DoTinker = .false.
DoGromacs = .false.
OrigInput = .false.
#ifdef _HAVE_EXTRA_
origin_input = .false.
geoInput = .false.
OldZmat = .false.
isHold = -1
nCoord = 0
ZConstraints = .false.
#endif
WriteZMat = .false.
nFragment = 0
iFrag = 0
FragSet = .false.
OriginSet = .false.
HyperParSet = .false.
stepFac1 = 60.0_wp
iOptimType = 1
gradLim = Zero
Do_OneEl = .true.
Vlct_ = .false.
#ifdef _FDE_
! Embedding
embPot = .false.
embPotInBasis = .false.
embPotPath = 'EMBPOT'
outGridPathGiven = .false.
embWriteDens = .false.
embWriteEsp = .false.
embWriteGrad = .false.
embWriteHess = .false.
call Put_iScalar('embpot',0)
#endif
DoEmPC = .false.
EFgiven = .false.
Invert = .false.
call Put_iScalar('agrad',0)

ScaleFactor = One
lSTDINP = 0
iCoord = 0
iBSSE = -1
SymThr = 0.01_wp
nTtl = 0

imix = 0
ifnr = -1
ign = 0
itype = 0
ExtBasDir = ' '
isxbas = 0
nmwarn = .true.

call mma_allocate(xb_bas,MAX_XBAS,label='xb_bas')
call mma_allocate(xb_label,MAX_XBAS,label='xb_label')

! Selective initialization

if (Run_Mode == S_Mode) then
  iShll = S%Mx_Shll
  mdc = S%Mx_mdc
else
  iShll = 0
  mdc = 0

  ChSkip = ' '
  do i=1,3
    Oper(i) = ' '
  end do
  nOper = 0
end if

iDNG = 0
BasisTypes(:) = 0
KeepBasis = ' '
! period
lthCell = 0
Cell_l = .false.
ispread(:) = 0
VCell(:,:) = Zero
! Set local DF variables (dummy)
call LDF_SetInc()
rewind(LuRd)
! Count the number of calls to coord to set the number of fragments
! for a geo/hyper-calculation
do
  Key = Get_Ln(LuRd)
  KWord = Key
  call UpCase(KWord)
  select case (KWord(1:4))
    case (KeyW(19)) ! COOR
      nFragment = nFragment+1
    case (KeyW(162),KeyW(170)) ! HYPE, GEO
      call getenvf('Project',Project)
      call getenvf('GeoDir',GeoDir)
      temp1 = Project(1:index(Project,' ')-1)//'.Gateway.Input'
      temp2 = GeoDir(1:index(GeoDir,' ')-1)//'/'//Project(1:index(Project,' ')-1)//'.gwcopy.input'
      call fCopy(temp1,temp2,ierr)
      if (ierr /= 0) then
        write(u6,*) '*** Detect Hyper input, but no GEO loop'
        call Quit_OnUserError()
      end if
    case (KeyW(1)) ! END
      exit
  end select
end do
call Put_iScalar('nCoordFiles',nFragment)
rewind(LuRd)
!                                                                      *
!***********************************************************************
!                                                                      *
if (Run_Mode == G_Mode) then
  call RdNLst(LuRd,'GATEWAY')
  Previous_Command = '&Gateway'
else
  call RdNLst(LuRd,'SEWARD')
  Previous_Command = '&Seward'
end if

! Default setting of GWInput

AnyMode = Run_Mode == G_Mode

! GWInput is a logical flag which tells if a keyword is Gateway or
! Seward specific. This is done down below for each keyword:
!
!   GWInput = .true.    ! keyword is Gateway specific
!   GWInput = .false.   ! keyword is Seward specific
!   GWInput = AnyMode   ! keyword is not specific
!
! in the section of the particular keyword
!                                                                      *
!***********************************************************************
!                                                                      *

! KeyWord directed input

call mma_allocate(STDINP,MxAtom*2,label='STDINP')

GWInput = AnyMode

nDone = 0
Skip1 = .false.
Skip2 = .false.
! This loop is here because if the COORD keyword is given, we will need
! to read the generated native BASIS input, and rather than rewrite
! a reduced version of the input parsing code, we just process the file
! as a full input
do
  do
    if (Skip2) then
      Skip2 = .false.
    else
      if (Skip1) then
        Skip1 = .false.
      else
        lTtl = .false.
        if (Basis_Test .and. (nDone == 1)) then
          nDone = 0
          Basis_Test = .false.
        end if
      end if
      Key = Get_Ln(LuRd)
    end if

    if ((Run_Mode == G_Mode) .and. (.not. GWInput)) then
      call WarningMessage(2,'Gateway input error!')
      write(u6,*) 'The keyword : "',Previous_Command,'" is not allowed in the Gateway input!'
      write(u6,*) 'This keyword most likely belongs in the Seward input section!.'
      write(u6,*)
      call Quit_OnUserError()
    else if ((Run_Mode == S_Mode) .and. GWInput) then
      call WarningMessage(2,'Seward input error!')
      write(u6,*) 'The keyword : "',Previous_Command,'" is not allowed in the Seward input when the Gateway is used!'
      write(u6,*) ' Try putting the keyword in the Gateway input section!'
      write(u6,*)
      call Quit_OnUserError()
    end if
    GWInput = .false.

    if (IfTest) write(u6,*) ' RdCtl: Processing:',Key
    KWord = Key
    call UpCase(KWord)
    Previous_Command = KWord(1:4)
    if (KWord(1:1) == '*') cycle
    if (KWord == '') cycle
    if (Basis_Test) nDone = 1

    select case (KWord(1:4))
      case (KeyW(1))
        !                                                              *
        !***** END  ****************************************************
        !                                                              *
        exit

#     ifdef _FDE_
      case (KeyW(2))
        !                                                              *
        !***** EMBE ****************************************************
        !                                                              *
        ! Read in the name of a file for an embedding potential on a grid

        embPot = .true.
        call Put_iScalar('embpot',1)
        do
          KWord = Get_Ln(LuRd)
          select case (KWord(1:4))
            case ('ENDE')
              ! Sanity check
              if (embPotInBasis .and. (.not. outGridPathGiven) .and. &
                  (embWriteDens .or. embWriteESP .or. embWriteGrad .or. embWriteHess)) then
                call WarningMessage(2,' No grid to write output in embedding.')
                call Quit_OnUserError()
              end if
              ! Write the embpot runfile
              call EmbPotWrRun()
              exit
            case ('BASI')
              ! Switch whether the potential is given in basis set
              ! representation instead of grid representation
              embPotInBasis = .true.
              write(u6,*) 'Set embPotInBasis to ',embPotInBasis
            case ('EMBI')
              ! Get the EMBInfile path containing an embedding pot. on a grid
              KWord = Get_Ln(LuRd)
              call Get_S(1,embPotPath,1)
            case ('OUTG')
              ! If the output grid is different from the input grid a path to
              ! a grid file is specified here
              KWord = Get_Ln(LuRd)
              call Get_S(1,outGridPath,1)
              outGridPathGiven = .true.
            case ('WRDE')
              ! If given, the final density is written out on a grid, the path
              ! to the file where to write it to must be given as well.
              embWriteDens = .true.
              KWord = Get_Ln(LuRd)
              call Get_S(1,embOutDensPath,1)
            case ('WREP')
              ! If given, the final electrostatic potential is written out on a
              ! grid, the path to the file where to write it to must be given as well.
              KWord = Get_Ln(LuRd)
              call Get_S(1,embOutEspPath,1)
              embWriteESP = .true.
            case ('WRGR')
              ! If given, the density gradient is written out on a grid, the
              ! path to the file where to write it to must be given as well.
              KWord = Get_Ln(LuRd)
              call Get_S(1,embOutGradPath,1)
              embWriteGrad = .true.
            case ('WRHE')
              ! If given, the Hessian of the density is written out on a grid,
              ! the path to the file where to write it to must be given as well.
              embWriteHess = .true.
              KWord = Get_Ln(LuRd)
              call Get_S(1,embOutHessPath,1)
            case default
              ! Should not be reached.
              call WarningMessage(2,'Error in input of EMBEdding block!')
              call Quit_OnUserError()
          end select
        end do
#     endif

      case (KeyW(3))
        !                                                              *
        !***** SYMM ****************************************************
        !                                                              *
        ! Read distinct symmetry operators apart for the unity operator

        SymmSet = .true.
        KWord = Get_Ln(LuRd)
        GWInput = .true.
        if ((.not. DoneCoord) .and. (iCoord /= 0)) then
          call WarningMessage(2,'SYMMETRY keyword is not compatible with COORD')
          call Quit_OnUserError()
        end if
        if (Run_Mode == S_Mode) then
          call WarningMessage(2,'Seward input error!')
          write(u6,'(A,A,A)') 'The command : "',Previous_Command,'" is not allowed in Seward input when Gateway is used!'
          write(u6,*)
          call Quit_OnUserError()
        end if
        call UpCase(KWord)
        iChrct = len(KWord)
        do
          Last = len_trim(KWord)
          iFrst = iCFrst(KWord,iChrct)
          if (iFrst > Last) exit
          nOper = nOper+1
          Oper(nOper)(1:1) = KWord(iFrst:iFrst)
          KWord(iFrst:iFrst) = ' '
          iFrst = iFrst+1
          if (KWord(iFrst:iFrst) == ' ') cycle
          Oper(nOper)(2:2) = KWord(iFrst:iFrst)
          KWord(iFrst:iFrst) = ' '
          iFrst = iFrst+1
          if (KWord(iFrst:iFrst) == ' ') cycle
          Oper(nOper)(3:3) = KWord(iFrst:iFrst)
          KWord(iFrst:iFrst) = ' '
        end do

      case (KeyW(4))
        !                                                              *
        !***** FILE ****************************************************
        !                                                              *
        ! Specify filename for input orbitals

        Line = Get_Ln(LuRd)
        call FileOrb(Line,SW_FileOrb)

      case (KeyW(5))
        !                                                              *
        !***** VECT ****************************************************
        !                                                              *
        ! Change mode of Seward to property calculations.

        Prprt = .true.

      case (KeyW(6))
        !                                                              *
        !***** ORBC ****************************************************
        !                                                              *
        ! Request property output with explicit listing of orbital contributions.

        Short = .false.

      case (KeyW(7))
        !                                                              *
        !***** THRS ****************************************************
        !                                                              *
        ! Change default for non-zero occupation numbers

        KWord = Get_Ln(LuRd)
        call Get_F1(1,Thrs)
        Thrs = abs(Thrs)

      case (KeyW(8))
        !                                                              *
        !***** UNNO ****************************************************
        !                                                              *
        ! Change default to unnormalized integrals

        UnNorm = .true.

      case (KeyW(9))
        !                                                              *
        !***** RADI ****************************************************
        !                                                              *
        ! Integral cutoff to be based on radial overlap integrals

        lSchw = .false.

      case (KeyW(10))
        !                                                              *
        !***** TITL ****************************************************
        !                                                              *
        ! Read the Title card

        Key = Get_Ln(LuRd)
        call ProcessTitle()

      case (KeyW(11),KeyW(12))
        !                                                              *
        !***** ECPS or AUXS ********************************************
        !                                                              *
        ! Allow printing of ECP data

        nPrint(2) = max(10,nPrint(2))
        GWInput = .true.

      case (KeyW(13))
        !                                                              *
        !***** BSSH ****************************************************
        !                                                              *
        ! Allow printing of basis set data

        nPrint(2) = max(6,nPrint(2))
        GWInput = .true.

      case (KeyW(14))
        !                                                              *
        !***** VERB ****************************************************
        !                                                              *
        ! Verbose printing

        nPrint(2) = max(10,nPrint(2))
        nPrint(117) = 6
        nPrint(80) = 6
        nPrint(1) = 6
        GWInput = AnyMode

      case (KeyW(15))
        !                                                              *
        !***** ORBA ****************************************************
        !                                                              *
        ! Request property output with explicit listing of properties of
        ! all orbitals, including all unoccupied (ignoring THRS), and not
        ! weighted by occupation numbers. (S.S.Dong, 2018)

        ifallorb = .true.

      case (KeyW(16))
        !                                                              *
        !***** ZMAT ****************************************************
        !                                                              *
        ! Read Basis Sets & Coordinates in Z-Matrix format

        if (isxbas == 0) call Quit_OnUserError()
        call ZMatrixConverter(LuRd,u6,mxAtom,STDINP,lSTDINP,iglobal,nxbas,xb_label,xb_bas,iErr)
        if (iErr /= 0) call Quit_OnUserError()
        GWInput = .true.
        call StdSewInput(LuRd,ifnr,mdc,iShll,BasisTypes,STDINP,lSTDINP,iErr)
        if (iErr /= 0) call Quit_OnUserError()

      case (KeyW(17))
        !                                                              *
        !***** XBAS ****************************************************
        !                                                              *

        call read_xbas(LuRd,iglobal,nxbas,xb_label,xb_bas,ierr)
        GWInput = .true.
        isxbas = 1
        if (ierr == 1) call Quit_OnUserError()

      case (KeyW(18))
        !                                                              *
        !***** XYZ  ****************************************************
        !                                                              *

        if (isxbas == 0) call Quit_OnUserError()
        call XMatrixConverter(LuRd,u6,mxAtom,STDINP,lSTDINP,iglobal,nxbas,xb_label,xb_bas,iErr)
        if (iErr /= 0) call Quit_OnUserError()
        GWInput = .true.
        call StdSewInput(LuRd,ifnr,mdc,iShll,BasisTypes,STDINP,lSTDINP,iErr)
        if (iErr /= 0) call Quit_OnUserError()
        !if (SymmSet) then
        !  call WarningMessage(2,'SYMMETRY keyword is not compatible with XYZ')
        !  call Quit_OnUserError()
        !end if
        if (GroupSet) then
          call WarningMessage(2,'GROUP keyword is not compatible with XYZ')
          call Quit_OnUserError()
        end if

      case (KeyW(19))
        !                                                              *
        !***** COOR ****************************************************
        !                                                              *
        ! Read Basis Sets & Coordinates in xyz format

        if (SymmSet) then
          call WarningMessage(2,'SYMMETRY keyword is not compatible with COORD')
          call Quit_OnUserError()
        end if
        if (iOpt_XYZ == 0) then
          call WarningMessage(2,'COORD keyword is not compatible with non-XYZ format')
          call Quit_OnUserError()
        end if
        !if (CoordSet) then
        !  call WarningMessage(2,'There is more than one COORD keyword!')
        !  ! Should this be an error and stop? Only if no HYPER or GEO?
        !end if
        if (isxbas == 1) call Quit_OnUserError()
        iCoord = iCoord+1

        CoordSet = .true.
        GWInput = .true.
#       ifdef _HAVE_EXTRA_
        call XYZread(LuRd,ForceZMAT,nCoord,iErr)
        if (iErr /= 0) call Quit_OnUserError()
        call XYZcollect(iCoord,nCoord,OrigTrans,OrigRot,nFragment)
#       else
        call Read_XYZ(LuRd,OrigRot,OrigTrans)
#       endif

      case (KeyW(20))
        !                                                              *
        !***** GROUP ***************************************************
        !                                                              *
        ! Read information for a group

        if (SymmSet) then
          call WarningMessage(2,'SYMMETRY keyword is not compatible with GROUP')
          call Quit_OnUserError()
        end if
        if (.not. CoordSet) then
          call WarningMessage(2,'COORD keyword is not found')
          call Quit_OnUserError()
        end if
        KeepGroup = Get_Ln(LuRd)
        ! Simplistic validity check for value
        temp1 = KeepGroup
        call UpCase(temp1)
        if ((temp1(1:4) /= 'FULL') .and. (temp1(1:1) /= 'E') .and. (temp1(1:2) /= 'C1') .and. (temp1(1:5) /= 'NOSYM')) then
          do i=1,len_trim(temp1)
            if ((temp1(i:i) /= 'X') .and. (temp1(i:i) /= 'Y') .and. (temp1(i:i) /= 'Z') .and. (temp1(i:i) /= ' ')) then
              call WarningMessage(2,'Illegal symmetry group or operator: '//trim(temp1))
              call Quit_OnUserError()
            end if
          end do
        end if
        GroupSet = .true.
        GWInput = .true.
        DoneCoord = .true.

      case (KeyW(21))
        !                                                              *
        !***** BSSE ****************************************************
        !                                                              *
        ! Read information for BSSE

        if (.not. CoordSet) then
          call WarningMessage(2,'COORD keyword is not found')
          call Quit_OnUserError()
        end if
        KWord = Get_Ln(LuRd)
        read(Kword,*,iostat=istatus) iBSSE
        if (istatus /= 0) call Error(1)
        GWInput = .true.

      case (KeyW(22))
        !                                                              *
        !***** MOVE ****************************************************
        !                                                              *
        ! allow to MOVE coordinates

        if (.not. CoordSet) then
          call WarningMessage(2,'COORD keyword is not found')
          call Quit_OnUserError()
        end if
#       ifdef _HAVE_EXTRA_
        isHold = 0
#       endif
        GWInput = .true.

      case (KeyW(23))
        !                                                              *
        !***** NOMOVE **************************************************
        !                                                              *
        ! Do NOT allow to MOVE coordinates

        if (.not. CoordSet) then
          call WarningMessage(2,'COORD keyword is not found')
          call Quit_OnUserError()
        end if
#       ifdef _HAVE_EXTRA_
        isHold = 1
#       endif
        GWInput = .true.

      case (KeyW(24))
        !                                                              *
        !***** SYMT ****************************************************
        !                                                              *
        ! Threshold for findsym

        if (.not. CoordSet) then
          call WarningMessage(2,'COORD keyword is not found')
          call Quit_OnUserError()
        end if
        KWord = Get_Ln(LuRd)
        read(Kword,*,iostat=istatus) SymThr
        if (istatus /= 0) call Error(1)
        GWInput = .true.

      case (KeyW(25))
        !                                                              *
        !***** NODE ****************************************************
        !                                                              *
        ! Set global delete parameters to disable orbital deleting
        ! See also: SDELete, TDELete

        call Put_dScalar('S delete thr',Zero)
        call Put_dScalar('T delete thr',1.0e15_wp)

      case (KeyW(26))
        !                                                              *
        !***** SDEL ****************************************************
        !                                                              *

        KWord = Get_Ln(LuRd)
        call Get_F1(1,sDel)
        call Put_dScalar('S delete thr',sDel)

      case (KeyW(27))
        !                                                              *
        !***** TDEL ****************************************************
        !                                                              *

        KWord = Get_Ln(LuRd)
        call Get_F1(1,tDel)
        call Put_dScalar('T delete thr',tDel)

      case (KeyW(28))
        !                                                              *
        !***** BASD ****************************************************
        !                                                              *

        KWord = Get_Ln(LuRd)
        ExtBasDir = KWord
        GWInput = .true.

      case (KeyW(29))
        !                                                              *
        !***** BASI ****************************************************
        !                                                              *
        ! Read information for a basis set

        ! Check if the format is old or new style. Damn the person who used
        ! the same keword for two different styles of input and making the
        ! input require a specific order of the keyword. Comrade 55?

        Basis_Test = .true.

        GWInput = .true.
        Key = Get_Ln(LuRd)
        BSLbl = Key(1:80)
        if (BasisSet) then
          KeepBasis = KeepBasis(1:index(KeepBasis,' '))//','//BSLbl
        else
          KeepBasis = BSLbl
          BasisSet = .true.
        end if
        temp1 = KeepBasis
        call UpCase(temp1)
        !if (INDEX(temp1,'INLINE') /= 0) then
        !  write(u6,*) 'XYZ input and Inline basis set are not compatible'
        !  write(u6,*) 'Consult the manual how to change inline basis set'
        !  write(u6,*) ' into basis set library'
        !  call Quit_OnUserError()
        !end if
        iOpt_XYZ = 1

      case (KeyW(30))
        !                                                              *
        !***** PRIN ****************************************************
        !                                                              *
        ! Print level

        KWord = Get_Ln(LuRd)
        GWInput = AnyMode
        call Get_I1(1,n)
        do i=1,n
          KWord = Get_Ln(LuRd)
          call Get_I1(1,jRout)
          call Get_I1(2,iPrint)
          nPrint(jRout) = iPrint
        end do

      case (KeyW(31))
        !                                                              *
        !***** OPTO ****************************************************
        !                                                              *
        ! Reduce the output for optimizations

        lOPTO = .true.

      case (KeyW(32))
        !                                                              *
        !***** THRE ****************************************************
        !                                                              *
        ! Threshold for writing integrals to disk

        KWord = Get_Ln(LuRd)
        call Get_F1(1,ThrInt)
        ThrInt = abs(ThrInt)
        ThrInt_UsrDef = .true.

      case (KeyW(33))
        !                                                              *
        !***** CUTO ****************************************************
        !                                                              *
        ! Cutoff for computing primitive integrals [a0|c0]

        KWord = Get_Ln(LuRd)
        call Get_F1(1,CutInt)
        CutInt = abs(CutInt)
        CutInt_UsrDef = .true.

      case (KeyW(34))
        !                                                              *
        !***** RTRN ****************************************************
        !                                                              *
        ! Defining max bond distance for bonds, angles and dihedrals
        ! Define max number of atoms to list for

        KWord = Get_Ln(LuRd)
        call Upcase(KWord)
        call Get_I1(1,S%Max_Center)
        call Get_F1(2,rtrnc)
        if (index(KWord,'ANGSTROM') /= 0) Rtrnc = Rtrnc/Angstrom
        GWInput = .true.

      case (KeyW(35))
        !                                                              *
        !***** DIRE ****************************************************
        !                                                              *
        ! Force direct calculations & disable two-electron integrals

        DirInt = .true.
        Onenly = .true.
        iChk_DC = 1
        if ((iChk_RI+iChk_CH) > 0) then
          call WarningMessage(2,'Direct is incompatible with RI and Cholesky keywords')
          call Quit_OnUserError()
        end if
        Do_RI = .false.

      case (KeyW(36))
        !                                                              *
        !***** CSPF ****************************************************
        !                                                              *
        ! Turn on the use of Condon-Shortley phase factors

        CSPF = .true.
        GWInput = AnyMode

      case (KeyW(37))
        !                                                              *
        !***** EXPE ****************************************************
        !                                                              *
        ! Expert mode

        Expert = .true.
        GWInput = AnyMode
        call WarningMessage(1,' EXPERT option is ON!')

      case (KeyW(38),KeyW(39))
        !                                                              *
        !***** MOLC or DCRN ********************************************
        !                                                              *
        ! Weight for DCR summation (this is the default for conventional
        ! calculations)

        MolWgh = 0
        MolWgh_UsrDef = .true.

      case (KeyW(40))
        !                                                              *
        !***** MOLP ****************************************************
        !                                                              *
        ! Weight for DCR summation modified to MOLPRO format

        MolWgh = 2
        MolWgh_UsrDef = .true.

      case (KeyW(41))
        !                                                              *
        !***** MOLE ****************************************************
        !                                                              *
        ! Weight for DCR summation modified to MOLECULE format

        MolWgh = 1
        MolWgh_UsrDef = .true.

      case (KeyW(42))
        !                                                              *
        !***** RELI ****************************************************
        !                                                              *
        ! Compute integrals for first order relativistic corrections
        ! of the energy, i.e. the mass-velocity integrals and the
        ! one-electron Darwin contract term integrals.

        lRel = .true.

      case (KeyW(43))
        !                                                              *
        !***** JMAX ****************************************************
        !                                                              *
        ! Change max j quantum number for the rigid rotor analysis

        KWord = Get_Ln(LuRd)
        call Get_I1(1,S%jMax)

      case (KeyW(44))
        !                                                              *
        !***** MULT ****************************************************
        !                                                              *
        ! Read order of highest multipole to be computed

        KWord = Get_Ln(LuRd)
        call Get_I1(1,S%nMltpl)

      case (KeyW(45))
        !                                                              *
        !***** CENT ****************************************************
        !                                                              *
        ! User specified centers of multipole moment operators.

        KWord = Get_Ln(LuRd)
        call Get_I1(1,nTemp)
        if (lMltpl) then
          call WarningMessage(2,' Abend: User specified centers already defined; Abend: Correct input error!')
          call Quit_OnUserError()
        else
          lMltpl = .true.
        end if
        ! Allocate temporary memory for user defined centers
        call mma_allocate(RTmp,3,nTemp,label='RTmp')
        call mma_allocate(ITmp,nTemp,label='ITmp')
        do i=1,nTemp
          KWord = Get_Ln(LuRd)
          call Upcase(KWord)
          call Get_I1(1,iMltpl)
          call Get_F(2,RTmp(:,i),3)
          if (index(KWord,'ANGSTROM') /= 0) RTmp(:,i) = RTmp(:,i)/Angstrom
          ITmp(i) = iMltpl
        end do

      case (KeyW(46))
        !                                                              *
        !***** EMPC ****************************************************
        !                                                              *
        ! Compute Orbital-Free Embedding integrals from Point Charges
        ! specified in XFIEld

        DoEmPC = .true.
#       ifdef _HAVE_EXTRA_
        isHold = 1 ! avoid coordinate moving
#       endif
        GWInput = .true.

      case (KeyW(47))
        !                                                              *
        !***** XFIE ****************************************************
        !                                                              *
        ! User specified external field

        lXF = .true.
        GWInput = .true.
        KWord = Get_Ln(LuRd)
        ! Open external file if the line does not start with an integer
        ! Note that the "iostat" value cannot be completely trusted, since
        ! a slash (i.e., an absolute path) marks end of input and gives
        ! no error
        LuRd_saved = LuRd
        ibla = -1
        read(KWord,*,iostat=istatus) ibla
        if ((ibla < 0) .or. (istatus > 0)) then
          LuRd = 1
          call Get_S(1,filename,1)
          call OpnFl(filename(1:(index(filename,' ')-1)),LuRd,Exists)
          if (.not. Exists) then
            call WarningMessage(2,'Error! File not found: '//filename(1:(index(filename,' ')-1)))
            call Quit_OnUserError()
          end if
          write(u6,*) 'Reading external field from file: ',filename(1:(index(filename,' ')-1))
          KWord = Get_Ln(LuRd)
        end if
        call ProcessXF()

      case (KeyW(48))
        !                                                              *
        !***** DOUG ****************************************************
        !                                                              *
        ! Full Douglas-Kroll operator

        IRELAE = 0
        DKroll = .true.
        GWInput = .true.

      case (KeyW(49))
        !                                                              *
        !***** DK1H ****************************************************
        !                                                              *
        ! Full Douglas-Kroll (DK1) operator

        IRELAE = 1
        DKroll = .true.
        GWInput = .true.

      case (KeyW(50))
        !                                                              *
        !***** DK2H ****************************************************
        !                                                              *
        ! Full Douglas-Kroll (DK2) operator

        IRELAE = 2
        DKroll = .true.
        GWInput = .true.

      case (KeyW(51))
        !                                                              *
        !***** DK3H ****************************************************
        !                                                              *
        ! Douglas-Kroll (DK3) operator

        IRELAE = 3
        DKroll = .true.
        GWInput = .true.

      case (KeyW(52))
        !                                                              *
        !***** DK3F ****************************************************
        !                                                              *
        ! Full Douglas-Kroll (DK3) operator

        IRELAE = 4
        DKroll = .true.
        GWInput = .true.

      case (KeyW(53))
        !                                                              *
        !***** RESC ****************************************************
        !                                                              *
        ! Full RESC operator

        IRELAE = 11
        DKroll = .true.
        GWInput = .true.

      case (KeyW(54))
        !                                                              *
        !***** RA0H ****************************************************
        !                                                              *
        ! Full ZORA

        IRELAE = 21
        DKroll = .true.
        GWInput = .true.

      case (KeyW(55))
        !                                                              *
        !***** RA0F ****************************************************
        !                                                              *
        ! Full ZORA-FP

        IRELAE = 22
        DKroll = .true.
        GWInput = .true.

      case (KeyW(56))
        !                                                              *
        !***** RAIH ****************************************************
        !                                                              *
        ! Full IORA

        IRELAE = 23
        DKroll = .true.
        GWInput = .true.

      case (KeyW(57))
        !                                                              *
        !***** RX2C ****************************************************
        !                                                              *
        ! Exact decoupling X2C method

        IRELAE = 101
        DKroll = .true.
        GWInput = .true.

      case (KeyW(58))
        !                                                              *
        !***** RBSS ****************************************************
        !                                                              *
        ! Exact decoupling BSS method

        IRELAE = 102
        DKroll = .true.
        GWInput = .true.

      case (KeyW(60))
        !                                                              *
        !***** BSSM ****************************************************
        !                                                              *
        ! BSS method

        IRELAE = 0
        DKroll = .true.
        BSS = .true.
        GWInput = .true.

      case (KeyW(61))
        !                                                              *
        !***** AMFI ****************************************************
        !                                                              *
        ! AMFI integrals

        lAMFI = .true.
        GWInput = .true.

      case (KeyW(62))
        !                                                              *
        !***** AMF1 ****************************************************
        !                                                              *
        ! AMFI integrals

        lAMFI = .true.
        GWInput = .true.

      case (KeyW(63))
        !                                                              *
        !***** AMF2 ****************************************************
        !                                                              *
        ! AMFI integrals (including 2nd-order)

        lAMFI = .true.
        GWInput = .true.

      case (KeyW(64))
        !                                                              *
        !***** AMF3 ****************************************************
        !                                                              *
        ! AMFI integrals (including 3rd-order)

        lAMFI = .true.
        GWInput = .true.

      case (KeyW(65))
        !                                                              *
        !***** FAKE ****************************************************
        !                                                              *
        ! Fake run : conventional, RI or CD ERIs not computed
        !            but some info is set to runfile (e.g. CD thrs)
        !            Not the same as ONEOnly !!

        Fake_ERIs = .true.

      case (KeyW(66))
        !                                                              *
        !***** FINI ****************************************************
        !                                                              *
        ! Finite nuclei - Gaussian type

        Nuclear_Model = Gaussian_Type
        GWInput = .true.

      case (KeyW(67))
        !                                                              *
        !***** MGAU ****************************************************
        !                                                              *
        ! Finite nuclei - modified Gaussian type

        Nuclear_Model = mGaussian_Type
        GWInput = .true.

      case (KeyW(68))
        !                                                              *
        !***** PART ****************************************************
        !                                                              *
        ! Show partitioning statistics

        nPrint(10) = 6

      case (KeyW(69))
        !                                                              *
        !***** FPCO ****************************************************
        !                                                              *
        ! Force partitioning for contracted functions

        force_part_c = .true.

      case (KeyW(70))
        !                                                              *
        !***** FPPR ****************************************************
        !                                                              *
        ! Force partitioning for primitive functions

        force_part_p = .true.

      case (KeyW(71))
        !                                                              *
        !***** NOTA ****************************************************
        !                                                              *
        ! Do not use tables for the roots and weights of the Rys polynomials.

        NoTab = .true.

      case (KeyW(72))
        !                                                              *
        !***** WELL ****************************************************
        !                                                              *
        ! Read radius and exponents for spherical well integrals and coefficient

        KWord = Get_Ln(LuRd)
        GWInput = .true.
        call Get_I1(1,nWel)
        if (nWel <= 0) then
          ! Use automatic set up for well integrals
          nWel = 3
          call mma_allocate(Wel_Info,3,nWel,Label='Wel_Info')
          do iWel=1,nWel
            Wel_Info(3,iWel) = WellCff(iWel)
            Wel_Info(2,iWel) = WellExp(iWel)
            Wel_Info(1,iWel) = WellRad(iWel)
          end do
        else
          call mma_allocate(Wel_Info,3,nWel,Label='Wel_Info')
          do iWel=1,nWel
            ! Read the Coefficient, Exponent, and Radius
            KWord = Get_Ln(LuRd)
            call Get_F1(1,Wel_Info(3,iWel))
            call Get_F1(2,Wel_Info(2,iWel))
            call Get_F1(3,Wel_Info(1,iWel))
            call Upcase(KWord)
            if (index(KWord,'ANGSTROM') /= 0) then
              Wel_Info(1,iWel) = Wel_Info(1,iWel)/Angstrom
              Wel_Info(2,iWel) = Wel_Info(2,iWel)*Angstrom
            end if
          end do
        end if

      case (KeyW(73))
        !                                                              *
        !***** NODK ****************************************************
        !                                                              *
        ! Do not compute Douglas-Kroll integrals.

        NoDKroll = .true.

      case (KeyW(74))
        !                                                              *
        !***** ONEO ****************************************************
        !                                                              *
        ! Do not compute two electron integrals.

        Onenly = .true.

      case (KeyW(75))
        !                                                              *
        !***** TEST ****************************************************
        !                                                              *
        ! Process only the input.

        Test = .true.
        GWInput = AnyMode

      case (KeyW(76))
        !                                                              *
        !***** SDIP ****************************************************
        !                                                              *
        ! Compute integrals for transition dipole moment

        Vlct_ = .true.
        GWInput = .true.

      case (KeyW(77))
        !                                                              *
        !***** EPOT ****************************************************
        !                                                              *
        ! Compute the electric potential for a number of points.  If nEF is
        ! set to 0 this will cause the points to coincide with the unique
        ! centers.

        nOrdEF = max(nOrdEF,0)
        GWInput = .true.
        if (EFgiven) then
          call WarningMessage(2,'Only one of EPOT,EFLD,FLDG may be given')
          call Quit_OnUserError()
        end if
        EFgiven = .true.
        call ProcessEF(KWord(1:4))

      case (KeyW(78))
        !                                                              *
        !***** EFLD ****************************************************
        !                                                              *
        ! Compute the electric potential and electric field for a number of
        ! points. If nEF is set to 0 this will cause the points to coincide
        ! with the unique centers.

        nOrdEF = max(nOrdEF,1)
        GWInput = .true.
        if (EFgiven) then
          call WarningMessage(2,'Only one of EPOT,EFLD,FLDG may be given')
          call Quit_OnUserError()
        end if
        EFgiven = .true.
        call ProcessEF(KWord(1:4))

      case (KeyW(79))
        !                                                              *
        !***** FLDG ****************************************************
        !                                                              *
        ! Compute the electric potential, electric field, and electric field
        ! gradient for a number of points. If nEF is set to 0 this will
        ! cause the points to coincide with the Unique centers.

        nOrdEF = max(nOrdEF,2)
        GWInput = .true.
        if (EFgiven) then
          call WarningMessage(2,'Only one of EPOT,EFLD,FLDG may be given')
          call Quit_OnUserError()
        end if
        EFgiven = .true.
        call ProcessEF(KWord(1:4))

      case (KeyW(80))
        !                                                              *
        !***** ANGM ****************************************************
        !                                                              *
        ! Orbital angular momentum

        lOAM = .true.
        GWInput = .true.
        KWord = Get_Ln(LuRd)
        call Upcase(KWord)
        call Get_F(1,OAMt,3)
        if (index(KWord,'ANGSTROM') /= 0) OAMt(:) = OAMt/Angstrom

      case (KeyW(81))
        !                                                              *
        !***** UPON ****************************************************
        !                                                              *
        ! Orbital angular momentum restriction

        lUPONLY = .true.

      case (KeyW(82))
        !                                                              *
        !***** DOWN ****************************************************
        !                                                              *
        ! Orbital angular momentum restriction

        lDOWNONLY = .true.

      case (KeyW(83))
        !                                                              *
        !***** OMQI ****************************************************
        !                                                              *
        ! Orbital magnetic quadrupole

        lOMQ = .true.
        GWInput = .true.
        KWord = Get_Ln(LuRd)
        call Upcase(KWord)
        call Get_F(1,OMQt,3)
        if (index(KWord,'ANGSTROM') /= 0) OMQt(:) = OMQt/Angstrom

      case (KeyW(84))
        !                                                              *
        !***** AMPR ****************************************************
        !                                                              *
        ! Angular momentum products

        GWInput = .true.
        if (Run_Mode == S_Mode) then
          Skip2 = .true.
        else
          call mma_allocate(AMP_Center,3,Label='AMP_Center')
          KWord = Get_Ln(LuRd)
          call Upcase(KWord)
          call Get_F(1,AMP_Center,3)
          if (index(KWord,'ANGSTROM') /= 0) AMP_Center(:) = (One/Angstrom)*AMP_Center(:)
        end if

      case (KeyW(85))
        !                                                              *
        !***** DSHD ****************************************************
        !                                                              *
        ! Compute the diamagnetic shielding for a number of points. If nDMS
        ! is set to 0 this will cause the points to coincide with the
        ! unique centers.

        lDMS = .true.
        GWInput = .true.
        KWord = Get_Ln(LuRd)
        call Get_F(1,Dxyz,3)
        KWord = Get_Ln(LuRd)
        call Get_I1(1,nDMS)
        if (nDMS < 0) nDMS = 0
        if (nDMS /= 0) then
          call mma_allocate(DMSt,3,nDMS,label='DMSt')
          do iDMS=1,nDMS
            KWord = Get_Ln(LuRd)
            call Upcase(KWord)
            call Get_F(1,DMSt(1,iDMS),3)
            if (index(KWord,'ANGSTROM') /= 0) DMSt(:,iDMS) = DMSt(:,iDMS)/Angstrom
          end do
        end if

      case (KeyW(86))
        !                                                              *
        !***** NOPA ****************************************************
        !                                                              *
        ! Set integral packing flag
        ! Note      : this flag is only active if iWRopt=0
        ! iPack=0   : pack 2el integrals (= Default)
        ! iPack=1   : do not pack 2el integrals

        iPack = 1

      case (KeyW(87))
        !                                                              *
        !***** STDO ****************************************************
        !                                                              *
        ! Set integral write option for 2 el integrals
        ! iWRopt=0  : 2 el integrals are written in the MOLCAS2 format,
        !             i.e., in canonical order, no labels and packed format
        !             (= Default)
        ! iWRopt=1  : 2 el integrals are written in a format identical
        !             to MOLECULE, i.e., values and labels

        iWRopt = 1

      case (KeyW(88))
        !                                                              *
        !***** PKTH ****************************************************
        !                                                              *
        ! Read desired packing accuracy ( Default = 1.0e-14 )
        ! Note      : this flag is only active if iWRopt=0

        KWord = Get_Ln(LuRd)
        call Get_F1(1,PkAcc)
        PkAcc = abs(PkAcc)

      case (KeyW(89))
        !                                                              *
        !***** SKIP ****************************************************
        !                                                              *
        ! Read skip parameters,i.e.,
        ! if 2el integral symmetry blocks containing a given symmetry
        ! will not be needed in subsequent calculations their computation
        ! ans storage can be omitted.
        ! ( Default = 0,0,0,0,0,0,0,0 )
        ! Note      : this flag is only activ if iWRopt=0

        KWord = Get_Ln(LuRd)
        lSkip = .true.
        ChSkip = KWord(1:80)

      case (KeyW(90))
        !                                                              *
        !***** EXTR ****************************************************
        !                                                              *
        ! Put the program name and the time stamp onto the extract file

        write(u6,*) 'RdCtl: keyword EXTRACT is obsolete and is ignored!'

      case (KeyW(91))
        !                                                              *
        !***** RF-I ****************************************************
        !                                                              *
        ! Read reaction field input.

        GWInput = .true.
        if (.not. RF_read) then
          call InpRct(LuRd)
          if (.not. (lLangevin .or. PCM)) then

            ! Add a center corresponding to the center of the RF cavity.

            RF_read = .true.
          end if
        else
          call WarningMessage(2,'RdCtl: A second RF-input block discovered!')
          call Quit_OnUserError()
        end if

      case (KeyW(92))
        !                                                              *
        !**** GRID *****************************************************
        !                                                              *

        call Funi_input(LuRd)

      case (KeyW(93))
        !                                                              *
        !***** CLIG ****************************************************
        !                                                              *
        ! Speed of light (in au)

        KWord = Get_Ln(LuRd)
        call Get_F1(1,cLightAU)
        cLightAU = abs(cLightAU)
        write(u6,*) 'The speed of light in this calculation =',cLightAU

      case (KeyW(94))
        !                                                              *
        !**** NEMO *****************************************************
        !                                                              *

        NEMO = .true.

      case (KeyW(95))
        !                                                              *
        !**** RMAT *****************************************************
        !                                                              *
        ! RmatR    : radius of the R-matrix sphere (bohr)

        KWord = Get_Ln(LuRd)
        call Get_F1(1,RMatR)

      case (KeyW(96))
        !                                                              *
        !**** RMEA *****************************************************
        !                                                              *
        ! Epsabs   : absolute precision of numerical radial integration

        KWord = Get_Ln(LuRd)
        call Get_F1(1,Epsabs)

      case (KeyW(97))
        !                                                              *
        !**** RMER *****************************************************
        !                                                              *
        ! Epsrel   : relative precision of numerical radial integration

        KWord = Get_Ln(LuRd)
        call Get_F1(1,Epsrel)

      case (KeyW(98))
        !                                                              *
        !**** RMQC *****************************************************
        !                                                              *
        ! qCoul    : effective charge of the target molecule

        KWord = Get_Ln(LuRd)
        call Get_F1(1,qCoul)

      case (KeyW(99))
        !                                                              *
        !**** RMDI *****************************************************
        !                                                              *
        ! dipol(3) : effective dipole moment of the target molecule

        KWord = Get_Ln(LuRd)
        call Get_F(1,dipol,3)
        dipol1 = abs(dipol(1))+abs(dipol(2))+abs(dipol(3))

      case (KeyW(100))
        !                                                              *
        !**** RMEQ *****************************************************
        !                                                              *
        ! epsq     : minimal value of qCoul and/or dipol1 to be considered

        KWord = Get_Ln(LuRd)
        call Get_F1(1,epsq)

      case (KeyW(101))
        !                                                              *
        !**** RMBP *****************************************************
        !                                                              *
        ! bParm    : Bloch term parameter

        KWord = Get_Ln(LuRd)
        call Get_F1(1,bParm)

      case (KeyW(102))
        !                                                              *
        !**** GIAO *****************************************************
        !                                                              *
        ! Enable GIAO integrals.

        GIAO = .true.

      case (KeyW(103))
        !                                                              *
        !**** NOCH *****************************************************
        !                                                              *
        ! Deactivate Cholesky decomposition.

        Cholesky = .false.
        CholeskyWasSet = .true.
        Do_RI = .false.

      case (KeyW(104),KeyW(105))
        !                                                              *
        !**** CHOL *****************************************************
        !                                                              *
        ! Activate Cholesky decomposition with default settings.
        ! This section can only be executed once.

        Do_RI = .false.
        if (.not. CholeskyWasSet) then
          CholeskyWasSet = .true.
          Cholesky = .true.
          Do_RI = .false.
          DirInt = .true.
          call Cho_Inp(.true.,-1,u6)
          iChk_CH = 1
        end if
        if ((iChk_RI+iChk_DC) > 0) then
          call WarningMessage(2,'Cholesky is incompatible with RI and Direct keywords')
          call Quit_OnUserError()
        end if
        GWInput = .false.

      case (KeyW(106))
        !                                                              *
        !**** THRC *****************************************************
        !                                                              *
        ! Set Cholesky decomposition threshold to specified value.

        KWord = Get_Ln(LuRd)
        call Get_F1(1,CholeskyThr)

      case (KeyW(107),KeyW(108))
        !                                                              *
        !**** 1CCD or 1C-C *********************************************
        !                                                              *
        ! Use one-center Cholesky.

        do1CCD = .true.
        Do_RI = .false.
        iChk_Ch = 1
        if ((iChk_RI+iChk_DC) > 0) then
          call WarningMessage(2,'Cholesky is incompatible with RI and Direct keywords')
          call Quit_OnUserError()
        end if

      case (KeyW(109))
        !                                                              *
        !**** CHOI *****************************************************
        !                                                              *
        ! Activate Cholesky decomposition with user-defined settings.
        ! This section can be executed any number of times.
        ! User-defined settings will be preferred to defaults also if the
        ! keywords appear in "wrong" order,
        !
        ! ChoInput
        ! ...
        ! End ChoInput
        ! Cholesky

        Do_RI = .false.
        CholeskyWasSet = .true.
        Cholesky = .true.
        DirInt = .true.
        call Cho_Inp(.false.,LuRd,u6)
        iChk_CH = 1
        if ((iChk_RI+iChk_DC) > 0) then
          call WarningMessage(2,'Cholesky is incompatible with RI and Direct keywords')
          call Quit_OnUserError()
        end if

      case (KeyW(110))
        !                                                              *
        !**** RP-C *****************************************************
        !                                                              *

        lRP = .true.
        KWord = Get_Ln(LuRd)
        nRP_prev = -1
        read(KWord,*,iostat=istatus) nRP
        if (istatus > 0) then
          isnumber = .false.
        else
          isnumber = .true.
          ifile = index(KWord,' ')
          do i=1,ifile
            ii = index(' 0123456789',KWord(i:i))
            if (ii == 0) then
              isnumber = .false.
            end if
          end do
        end if

        if (isnumber) then
          nRP = 3*nRP
          call mma_allocate(RP_Centers,3,nRP/3,2,Label='RP_Centers')

          ! Inline input

          call UpCase(KWord)
          if (index(KWord,'ANGSTROM') /= 0) then
            Fact = One/Angstrom
          else
            Fact = One
          end if

          KWord = Get_Ln(LuRd)
          call Get_F1(1,E1)
          call Read_v(LuRd,RP_Centers(1,1,1),1,nRP,1,iErr)
          KWord = Get_Ln(LuRd)
          call Get_F1(1,E2)
          call Read_v(LuRd,RP_Centers(1,1,2),1,nRP,1,iErr)
          RP_Centers(:,:,:) = Fact*RP_Centers(:,:,:)
          GWInput = .true.
        else

          ! Files

          do jTmp=1,2
            RPSet = .true.
            ifile = index(KWord,' ')
            if (KWord(1:1) == '/') then
              call f_inquire(KWord(1:ifile-1),Exists)
              Key = KWord
            else
              call getenvf('MOLCAS_SUBMIT_DIR',Directory)
              if (Directory(1:1) /= ' ') then
                i = index(Directory,' ')
                Key = Directory(1:i-1)//'/'//KWord(1:ifile-1)
                ifile = i+ifile
                call f_inquire(Key(1:iFile-1),Exists)
              else
                Exists = .false.
              end if
              if (.not. Exists) then
                Key = Key(i+1:iFile-1)
                ifile = ifile-i
                call f_inquire(Key(1:iFile-1),Exists)
              end if
            end if
            if (.not. Exists) then
              call WarningMessage(2,'File '//Key(1:ifile)//' is not found')
              call Quit_OnUserError()
            end if
            LuIn = isFreeUnit(8)
            call molcas_open(LuIn,Key(1:iFile-1))

            KWord = Get_Ln(LuIn)
            read(KWord,*,iostat=istatus) nRP
            if (istatus > 0) call Error(2)
            if ((nRP_prev >= 0) .and. (nRP /= nRP_prev)) then
              call WarningMessage(2,'The numbers of atoms in the two RP structures do not match.')
              call Quit_OnUserError()
            end if
            nRP_prev = nRP
            nRP = 3*nRP
            if (.not. allocated(RP_Centers)) call mma_allocate(RP_Centers,3,nRP/3,2,Label='RP_Centers')
            KWord = Get_Ln(LuIn)
            call UpCase(KWord)
            if (index(KWord,'BOHR') /= 0) then
              Fact = One
            else
              Fact = One/Angstrom
            end if
            LuRP = isFreeUnit(10)
            if (jTmp == 1) then
              call molcas_open(LuRP,'findsym.RP1')
              read(KWord,*,iostat=istatus) E1
            else
              call molcas_open(LuRP,'findsym.RP2')
              read(KWord,*,iostat=istatus) E2
            end if
            if (istatus > 0) call Error(2)

            ! write a separate file for findsym

            write(LuRP,*) nRP/3
#          ifdef _HAVE_EXTRA_
            write(LuRP,'(a)')
#          else
            write(LuRP,'(a)') 'bohr'
#          endif
            do i=1,nRP/3
              KWord = Get_Ln(LuIn)
              read(KWord,*,iostat=istatus) Key,(RP_Centers(j,i,jTmp),j=1,3)
              if (istatus > 0) call Error(2)
              write(LuRP,'(A,3F20.12)') Key(1:LenIn),(RP_Centers(j,i,jTmp)*Fact,j=1,3)
            end do
            close(LuRP)
            if (jTmp == 1) then
              KWord = Get_Ln(LuRd)
              close(LuIn)
            end if
          end do
          RP_Centers(:,:,:) = Fact*RP_Centers(:,:,:)

          close(LuIn)
          GWInput = AnyMode
        end if

      case (KeyW(111))
        !                                                              *
        !**** SADD *****************************************************
        !                                                              *
        ! Saddle options

        Key = Get_Ln(LuRd)
        call Get_F1(1,SadStep)
        GWInput = .true.

      case (KeyW(112))
        !                                                              *
        !**** CELL *****************************************************
        !                                                              *
        ! VCell(3,3)    : the vectors of the cell

        Key = Get_Ln(LuRd)
        call Upcase(Key)
        if (index(Key,'ANGSTROM') /= 0) KWord = Get_Ln(LuRd)
        call Get_F(1,VCell(1,1),3)
        KWord = Get_Ln(LuRd)
        call Get_F(1,VCell(1,2),3)
        KWord = Get_Ln(LuRd)
        call Get_F(1,VCell(1,3),3)
        if (index(Key,'ANGSTROM') /= 0) VCell(:,:) = VCell/Angstrom
        Cell_l = .true.
        call mma_allocate(AdCell,MxAtom)

      case (KeyW(113))
        !                                                              *
        !**** SPAN *****************************************************
        !                                                              *
        ! Set span factor in Cholesky decomposition (0 < span < 1).
        ! The span decides the smallest diagonal element that can be
        ! treated as span*max(Diag). Span=1 thus implies full pivoting.

        KWord = Get_Ln(LuRd)
        call Get_F1(1,spanCD)
        spanCD = abs(spanCD)

      case (KeyW(114))
        !                                                              *
        !**** SPREAD ***************************************************
        !                                                              *
        ! ispread(3)    : the number of cells to spread in different directions

        KWord = Get_Ln(LuRd)
        call Get_I(1,ispread,3)

      case (KeyW(115))
        !                                                              *
        !**** LOW  *****************************************************
        !                                                              *
        ! Activate low-accuracy Cholesky decomposition.

        Do_RI = .false.
        if (.not. CholeskyWasSet) then
          CholeskyWasSet = .true.
          Cholesky = .true.
          DirInt = .true.
          call Cho_Inp(.true.,-1,u6)
          call Cho_InpMod('LOW ')
          Thrshld_CD = 1.0e-4_wp
        end if

      case (KeyW(116))
        !                                                              *
        !**** MEDI *****************************************************
        !                                                              *
        ! Activate medium-accuracy Cholesky decomposition.

        Do_RI = .false.
        if (.not. CholeskyWasSet) then
          CholeskyWasSet = .true.
          Cholesky = .true.
          DirInt = .true.
          call Cho_Inp(.true.,-1,u6)
          call Cho_InpMod('MEDI')
          Thrshld_CD = 1.0e-6_wp
        end if

      case (KeyW(117))
        !                                                              *
        !**** HIGH *****************************************************
        !                                                              *
        ! Activate high-accuracy Cholesky decomposition.

        Do_RI = .false.
        if (.not. CholeskyWasSet) then
          CholeskyWasSet = .true.
          Cholesky = .true.
          DirInt = .true.
          call Cho_Inp(.true.,-1,u6)
          call Cho_InpMod('HIGH')
          Thrshld_CD = 1.0e-8_wp
        end if

      case (KeyW(118))
        !                                                              *
        !**** DIAG *****************************************************
        !                                                              *

        DiagCheck = .true.

      case (KeyW(119))
        !                                                              *
        !**** RIC  *****************************************************
        !                                                              *
        ! Activate RI approach

        Do_RI = .true.
        GWInput = .true.
        iRI_Type = 3
        iChk_RI = 1
        if ((iChk_DC+iChk_CH) > 0) then
          call WarningMessage(2,'RI is incompatible with Direct and Cholesky keywords')
          call Quit_OnUserError()
        end if

      case (KeyW(120))
        !                                                              *
        !**** RIJ  *****************************************************
        !                                                              *

        Do_RI = .true.
        GWInput = .true.
        iRI_Type = 1
        iChk_RI = 1
        if ((iChk_DC+iChk_CH) > 0) then
          call WarningMessage(2,'RI is incompatible with Direct and Cholesky keywords')
          call Quit_OnUserError()
        end if

      case (KeyW(121))
        !                                                              *
        !**** RIJK *****************************************************
        !                                                              *
        Do_RI = .true.
        GWInput = .true.
        iRI_Type = 2
        iChk_RI = 1
        if ((iChk_DC+iChk_CH) > 0) then
          call WarningMessage(2,'RI is incompatible with Direct and Cholesky keywords')
          call Quit_OnUserError()
        end if

      case (KeyW(122))
        !                                                              *
        !**** RICD *****************************************************
        !                                                              *
        Do_RI = .true.
        GWInput = .true.
        iRI_Type = 4
        iChk_RI = 1
        if ((iChk_DC+iChk_CH) > 0) then
          call WarningMessage(2,'RI is incompatible with Direct and Cholesky keywords')
          call Quit_OnUserError()
        end if

      case (KeyW(123))
        !                                                              *
        !**** XRIC *****************************************************
        !                                                              *
        Do_RI = .true.
        GWInput = .true.
        iRI_Type = 5
        iChk_RI = 1
        if ((iChk_DC+iChk_CH) > 0) then
          call WarningMessage(2,'RI is incompatible with Direct and Cholesky keywords')
          call Quit_OnUserError()
        end if

      case (KeyW(124))
        !                                                              *
        !**** NOGU *****************************************************
        !                                                              *
        ! Disable automatic execution of GuessOrb

        Do_GuessOrb = .false.

      case (KeyW(125))
        !                                                              *
        !**** RELA *****************************************************
        !                                                              *
        ! DKH option: order and parameterization.
        ! xx: order of Hamiltonian
        !  y: parameterization
        ! zz: order of properties

        kWord = Get_Ln(LuRd)
        if ((KWord(1:1) == 'R') .and. &
            ((KWord(2:2) >= '0') .and. (KWord(2:2) <= '9')) .and. ((KWord(3:3) >= '0') .and. (KWord(3:3) <= '9')) .and. &
            ((KWord(4:4) == 'O') .or. (KWord(4:4) == 'E') .or. (KWord(4:4) == 'S') .or. (KWord(4:4) == 'M') .or. &
             (KWord(4:4) == 'C'))) then
        else
          call WarningMessage(2,'Error in RELA keyword')
          call Quit_OnUserError()
        end if
        DKroll = .true.

        ! DKH order in the Hamiltonian

        read(KWord(2:3),*) idk_ord
        IRELAE = 1000+idk_ord*10

        ! Method of parametrization

        if (kWord(4:4) == 'O') IRELAE = IRELAE+1
        if (kWord(4:4) == 'E') IRELAE = IRELAE+2
        if (kWord(4:4) == 'S') IRELAE = IRELAE+3
        if (kWord(4:4) == 'M') IRELAE = IRELAE+4
        if (kWord(4:4) == 'C') IRELAE = IRELAE+5

        ! DKH order in the property integrals

        if ((KWord(5:5) >= '0') .and. (KWord(5:5) <= '9') .and. (KWord(6:6) >= '0') .and. (KWord(6:6) <= '9')) then
          read(KWord(5:6),*) iprop_ord
          IRELAE = IRELAE+iprop_ord*10000
        else
          IRELAE = IRELAE+idk_ord*10000
        end if

      case (KeyW(126))
        !                                                              *
        !**** RLOC *****************************************************
        !                                                              *
        ! Local Douglas-Kroll-Hess/X2C/BSS

        LDKroll = .true.
        !GWInput = .True.
        nCtrLD = 0
        radiLD = 5.5_wp

        KWord = Get_Ln(LuRd)
        call Upcase(KWord)
        if (KWord(1:3) == 'DLU') then
          !continue
        else if (KWord(1:3) == 'DLH') then
          radiLD = Zero
        else
          read(KWord,*,iostat=istatus) nCtrLD,radiLD
          if (istatus == 0) then
            if (nCtrLD > 10) then
              call WarningMessage(2,'The number of centers for LDKH is limited to 10')
              call Quit_OnUserError()
            end if
            if (index(KWord,'ANGSTROM') /= 0) then
              radiLD = radiLD/Angstrom
            end if

            KWord = Get_Ln(LuRd)
            call Upcase(KWord)
            read(KWord,*,iostat=istatus) (iCtrLD(i),i=1,nCtrLD)
            if (istatus < 0) then
              call Error(1)
            else if (istatus > 0) then
              read(Kword,*,iostat=istatus) (CtrLDK(i),i=1,nCtrLD)
              if (istatus /= 0) call Error(1)
              call Get_nAtoms_all(nAtom)
              k = 0
              do i=1,nAtom
                do j=1,nCtrLD
                  if (CtrLDK(j) == dc(i)%LblCnt(1:LenIn)) then
                    iCtrLD(j) = i
                    k = k+1
                  end if
                end do
              end do
              if (k /= nCtrLD) then
                call WarningMessage(2,'Error in LDKH Centers definitions')
                call Quit_OnUserError()
              end if
            end if
          else

            ! Automatic choice: all heavy elements (from K 19)

            !DP if (nCtrLD == 0) radiLD = Zero
            Key = KWord
            Skip2 = .true.
          end if
        end if

      case (KeyW(127))
        !                                                              *
        !**** FOOC *****************************************************
        !                                                              *
        ! Force the use of the out-of-core RI algorithm.

        Force_Out_of_Core = .true.

      case (KeyW(128))
        !                                                              *
        !**** CDTH *****************************************************
        !                                                              *
        ! Threshold for CD to generate RICD auxiliary basis sets

        Key = Get_Ln(LuRd)
        call Get_F1(1,Thrshld_CD)
        GWInput = .true.

      case (KeyW(129))
        !                                                              *
        !**** SHAC *****************************************************
        !                                                              *
        ! Skip high angular combinations when constructing RICD aux basis.

        Skip_High_AC = .true.
        GWInput = .true.

      case (KeyW(130))
        !                                                              *
        !**** KHAC *****************************************************
        !                                                              *
        ! Keep high angular combinations when constructing RICD aux basis.

        Skip_High_AC = .false.
        GWInput = .true.

      case (KeyW(131),KeyW(132))
        !                                                              *
        !**** ACD  or FAT- *********************************************
        !                                                              *
        ! Generate a aCD basis.

        Do_acCD_Basis = .false.
        GWInput = .true.

      case (KeyW(133),KeyW(134))
        !                                                              *
        !**** ACCD or SLIM *********************************************
        !                                                              *
        ! Generate a acCD basis.

        Do_acCD_Basis = .true.
        GWInput = .true.

      case (KeyW(136))
        !                                                              *
        !**** DOFM *****************************************************
        !                                                              *
        ! DoFMM: activate FMM option

        DoFMM = .true.

      case (KeyW(137))
        !                                                              *
        !**** NOAM *****************************************************
        !                                                              *
        ! No computation of AMFI integrals

        NoAMFI = .true.
        GWInput = .true.

      case (KeyW(138))
        !                                                              *
        !**** RPQM *****************************************************
        !                                                              *
        ! Set RPQMin for FMM option

        Key = Get_Ln(LuRd)
        call Get_F1(1,RPQMin)

      case (KeyW(139))
        !                                                              *
        !**** CONS *****************************************************
        !                                                              *
        ! Have the Gateway read the constraints for Slapaf

        GWInput = .true.
        Lu_UDC = 97
        Lu_UDC = IsFreeUnit(Lu_UDC)
        call Molcas_Open(Lu_UDC,'UDC.Gateway')
        do
          Key = Get_Ln(LuRd)
          call UpCase(Key)
          write(Lu_UDC,'(A)') trim(Key)
          if (Key(1:4) == 'END ') exit
        end do
        ! This rather obscure feature seems to be needed to to make Intel
        ! compilers behave like the others when detecting EOF
        endfile(Lu_UDC)
        close(Lu_UDC)

      case (KeyW(140))
        !                                                              *
        !**** NGEX *****************************************************
        !                                                              *
        ! Have the Gateway read the constraints for Numerical_gradient

        GWInput = .true.
        Lu_UDC = 97
        Lu_UDC = IsFreeUnit(Lu_UDC)
        call Molcas_Open(Lu_UDC,'UDC.NG')
        do
          Key = Get_Ln(LuRd)
          call UpCase(Key)
          if (adjustl(Key) == 'INVERT') then
            Invert = .true.
          else
            write(Lu_UDC,'(A)') trim(Key)
            if (Key(1:4) == 'END ') exit
          end if
        end do
        ! This rather obscure feature seems to be needed to to make Intel
        ! compilers behave like the others when detecting EOF
        endfile(Lu_UDC)
        close(Lu_UDC)

      case (KeyW(141),KeyW(142),KeyW(143))
        !                                                              *
        !**** LOCA or LDF1 or LDF  *************************************
        !                                                              *
        ! Activate Local Density Fitting.

        LocalDF = .true.
        GWInput = .false. ! Only in Seward

      case (KeyW(144))
        !                                                              *
        !**** LDF2 *****************************************************
        !                                                              *
        ! Activate Local Density Fitting with 2-center functions included
        ! when needed to achieve target accuracy.

        LocalDF = .true.
        call LDF_SetLDF2(.true.)
        GWInput = .false. ! Only in Seward

      case (KeyW(145),KeyW(146))
        !                                                              *
        !**** TARG or THRL *********************************************
        !                                                              *
        ! Set target accuracy for Local Density Fitting.
        ! This implies inclusion of 2-center functions (the only way we can
        ! affect accuracy).

        Key = Get_Ln(LuRd)
        call Get_F1(1,Target_Accuracy)
        call LDF_SetThrs(Target_Accuracy)
        LocalDF = .true.
        call LDF_SetLDF2(.true.)
        GWInput = .false. ! Only in Seward

      case (KeyW(147))
        !                                                              *
        !**** APTH *****************************************************
        !                                                              *
        ! Set screening threshold for LDF - i.e. threshold for defining
        ! significant atom pairs.

        Key = Get_Ln(LuRd)
        call Get_F1(1,APThr)
        call LDF_SetPrescreen(APThr)
        LocalDF = .true.
        APThr_UsrDef = .true.
        GWInput = .false. ! Only in Seward

      case (KeyW(148))
        !                                                              *
        !**** CHEC *****************************************************
        !                                                              *
        ! LDF debug option: check pair integrals.

        call LDF_SetOptionFlag('CHEC',.true.)
        GWInput = .false. ! Only in Seward

      case (KeyW(149))
        !                                                              *
        !**** VERI *****************************************************
        !                                                              *
        ! LDF debug option: verify fit for each atom pair.

        call LDF_SetOptionFlag('VERI',.true.)
        GWInput = .false. ! Only in Seward

      case (KeyW(150))
        !                                                              *
        !**** OVER *****************************************************
        !                                                              *
        ! LDF debug option: check overlap integrals (i.e. charge)

        call LDF_SetOptionFlag('OVER',.true.)
        GWInput = .false. ! Only in Seward

      case (KeyW(151))
        !                                                              *
        !**** CLDF *****************************************************
        !                                                              *
        ! Constrained LDF - read constraint order
        ! order=-1 --- unconstrained
        ! order=0  --- charge (i.e. overlap)

        Key = Get_Ln(LuRd)
        call Get_I1(1,iCLDF)
        call LDF_AddConstraint(iCLDF)
        GWInput = .false. ! Only in Seward

      case (KeyW(152))
        !                                                              *
        !**** UNCO *****************************************************
        !                                                              *
        ! Unconstrained LDF (same as CLDF=-1)

        call LDF_AddConstraint(-1)
        GWInput = .false. ! Only in Seward

      case (KeyW(153))
        !                                                              *
        !**** WRUC *****************************************************
        !                                                              *
        ! Write unconstrained coefficients to disk.
        ! Only meaningful along with constrained fitting.
        ! For debugging purposes: enables constrained fit verification in
        ! modules other than Seward.

        call LDF_SetOptionFlag('WRUC',.true.)
        GWInput = .false. ! Only in Seward

      case (KeyW(154))
        !                                                              *
        !**** UNIQ *****************************************************
        !                                                              *
        ! LDF: use unique atom pairs.

        call LDF_SetOptionFlag('UNIQ',.true.)
        GWInput = .false. ! Only in Seward

      case (KeyW(155))
        !                                                              *
        !**** NOUN *****************************************************
        !                                                              *
        ! LDF: do not use unique atom pairs.

        call LDF_SetOptionFlag('UNIQ',.false.)
        GWInput = .false. ! Only in Seward

      case (KeyW(156))
        !                                                              *
        !**** RLDF *****************************************************
        !                                                              *
        ! Activate local DF/RI, Roland's original LDF test implementation

        LDF = .true.
        GWInput = .true.

      case (KeyW(157))
        !                                                              *
        !**** NOAL *****************************************************
        !                                                              *
        ! Do not align reactants and products

        Do_Align = .false.
        if (Align_Only) then
          call WarningMessage(2,'Keywords ALIG and NOAL are not compatible')
          call Quit_OnUserError()
        end if
        GWInput = .true.

      case (KeyW(158))
        !                                                              *
        !**** WEIG *****************************************************
        !                                                              *
        ! Weights for alignment of reactants and products

        Align_Weights = Get_Ln(LuRd)
        call UpCase(Align_Weights)
        GWInput = .true.

      case (KeyW(159))
        !                                                              *
        !**** ALIG *****************************************************
        !                                                              *
        ! Align reactants and products

        Align_Only = .true.
        if (.not. Do_Align) then
          call WarningMessage(2,'Keywords ALIG and NOAL are not compatible')
          call Quit_OnUserError()
        end if
        GWInput = .true.

      case (KeyW(160))
        !                                                              *
        !***** TINK ****************************************************
        !                                                              *
        ! Read Coordinates in Tinker's xyz format

        if (SymmSet) then
          call WarningMessage(2,'SYMMETRY keyword is not compatible with TINKER')
          call Quit_OnUserError()
        end if
        DoTinker = .true.
        ITkQMMM = 1
        if (MyRank == 0) then
          ITkQMMM = IsFreeUnit(ITkQMMM)
          call Molcas_Open(ITkQMMM,'QMMM')
          write(ITkQMMM,'(A)') 'Molcas -1 0'
          close(ITkQMMM)

          call Getenvf('TINKER ',Key)
          if (Key == '') then
            call Getenvf('MOLCAS',Key)
            Key = trim(Key)//'/tinker/bin'
          end if
          call Getenvf('Project',Project)
          Project = Project(1:index(Project,' ')-1)
          Key = trim(Key)//'/tkr2qm_s '//trim(Project)//'.xyz>'//trim(Project)//'.Tinker.log'
          write(u6,*) 'TINKER keyword found, run ',trim(Key)
          call StatusLine(' Gateway:',' Read input from Tinker')
          RC = 0
          call Systemf(trim(Key),RC)
          if (RC /= 0) then
            Key = 'RdCtl_Seward: Tinker call terminated abnormally'
            call WarningMessage(2,Key)
            call Abend()
          end if
        end if
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          call GA_Sync()
          call PFGet_ASCII('QMMM')
          call GA_Sync()
        end if
#       endif
        iCoord = iCoord+1
        CoordSet = .true.
        ITkQMMM = IsFreeUnit(ITkQMMM)
        call Molcas_Open(ITkQMMM,'QMMM')
#       ifdef _HAVE_EXTRA_
        if (Expert) then
          if (iCoord > 1) then
            call WarningMessage(1,'TINKER and COORD keywords cannot be combined with molcas_extra')
          end if
        end if
        call XYZread(ITkQMMM,ForceZMAT,nCoord,iErr)
        if (iErr /= 0) then
          Key = 'RdCtl_Seward: Tinker+XYZread failed: check Tinker input files'
          call WarningMessage(2,Key)
          call Abend()
        end if
        call XYZcollect(iCoord,nCoord,OrigTrans,OrigRot,nFragment)
#       else
        if (Expert) then
          if (iCoord > 1) then
            call WarningMessage(1,'TINKER coordinates replacing COORD')
          end if
          call Read_XYZ(ITkQMMM,OrigRot,OrigTrans,Replace=(iCoord > 1))
        else
          call Read_XYZ(ITkQMMM,OrigRot,OrigTrans)
        end if
#       endif
        close(ITkQMMM)
        GWInput = .true.

      case (KeyW(161))
        !                                                              *
        !**** ORIG *****************************************************
        !                                                              *
        ! Defines translation and rotation for each xyz-file

        OrigInput = .true.
#       ifdef _HAVE_EXTRA_
        Origin_input = .true.
#       endif
        if (FragSet) then
          write(u6,*) 'Keywords FRGM and ORIG are mutually exclusive!'
          call Quit_OnUserError()
        end if
        if (.not. OriginSet) then
          call mma_allocate(OrigTrans,3,nFragment,label='OrigTrans')
          call mma_allocate(OrigRot,3,3,nFragment,label='OrigRot')
          OriginSet = .true.
        end if
        do iFrag=1,nFragment
          KWord = Get_Ln(LuRd)
          call Get_F(1,OrigTrans(1,iFrag),3)
          KWord = Get_Ln(LuRd)
          call Get_F(1,OrigRot(1,1,iFrag),9)
        end do
        GWinput = .true.

      case (KeyW(162))
        !                                                              *
        !**** HYPE *****************************************************
        !                                                              *

        KWord = Get_Ln(LuRd)
#       ifdef _HAVE_EXTRA_
        geoInput = .true.
#       endif
        writeZmat = .true.
        call Get_F(1,HypParam,3)
        GWinput = .true.
        HyperParSet = .true.

      case (KeyW(163))
        !                                                              *
        !**** ZCON *****************************************************
        !                                                              *

        writeZMat = .true.
#       ifdef _HAVE_EXTRA_
        ZConstraints = .true.
#       endif
        GWinput = .true.

      case (KeyW(164))
        !                                                              *
        !**** SCAL *****************************************************
        !                                                              *

        KWord = Get_Ln(LuRd)
        call Get_F1(1,ScaleFactor)
        GWinput = .true.
        if (.not. CoordSet) then
          call WarningMessage(2,'Scale can be used only with xyz input')
          call Quit_OnUserError()
        end if

      case (KeyW(165))
        !                                                              *
        !**** DOAN *****************************************************
        !                                                              *

        call Put_iScalar('agrad',1)

      case (KeyW(166))
        !                                                              *
        !**** GEOE *****************************************************
        !                                                              *

        Kword = Get_Ln(LuRd)
        call Get_I1(1,iGeoInfo(2))
        GWinput = .true.
        iGeoInfo(1) = 1
        call Put_iArray('GeoInfo',iGeoInfo,2)

      case (KeyW(167))
        !                                                              *
        !**** OLDZ *****************************************************
        !                                                              *

        GWinput = .true.
#       ifdef _HAVE_EXTRA_
        oldZmat = .true.
#       endif

      case (KeyW(168))
        !                                                              *
        !**** OPTH *****************************************************
        !                                                              *

        GWinput = .true.
        Kword = Get_Ln(LuRd)
        call Get_I1(1,iOptimType)
        Kword = Get_Ln(LuRd)
        call Get_F1(1,StepFac1)
        if (iOptimType == 2) then
          KWord = Get_Ln(LuRd)
          call Get_F1(1,gradLim)
        end if

      case (KeyW(169))
        !                                                              *
        !**** NOON *****************************************************
        !                                                              *

        Do_OneEl = .false.

      case (KeyW(170))
        !                                                              *
        !**** GEO  *****************************************************
        !                                                              *

#       ifdef _HAVE_EXTRA_
        geoInput = .true.
#       endif
        writeZMat = .true.
        ! Parameters for the gridsize is set to default-values if geo is
        ! used instead of hyper
        if (.not. HyperParSet) then
          HypParam(1) = 0.15_wp
          HypParam(2) = 2.5_wp
          HypParam(3) = 2.5_wp
        end if
        GWinput = .true.

      case (KeyW(171))
        !                                                              *
        !**** MXTC *****************************************************
        !                                                              *
        ! GEN1INT integrals

        if (IRELAE == 101) then
          lMXTC = .true.
        else
          write(u6,*) 'Keyword MXTC must be preceded by keyword RX2C!'
          call Quit_OnUserError()
        end if

      case (KeyW(172))
        !                                                              *
        !**** FRGM *****************************************************
        !                                                              *

        OrigInput = .true.
#       ifdef _HAVE_EXTRA_
        Origin_input = .true.
#       endif
        GWinput = .true.
        if (OriginSet) then
          write(u6,*) 'Keywords FRGM and ORIG are mutually exclusive!'
          call Quit_OnUserError()
        end if
        if (.not. FragSet) then
          call mma_allocate(OrigTrans,3,nFragment,label='OrigTrans')
          call mma_allocate(OrigRot,3,3,nFragment,label='OrogRot')
          ! Set up no translation and no rotation as default
          OrigTrans(:,:) = Zero
          OrigRot(:,:,:) = Zero
          OrigRot(1,1,:) = One
          OrigRot(2,2,:) = One
          OrigRot(3,3,:) = One
          FragSet = .true.
        end if
        Kword = Get_Ln(LuRd)
        call Get_I1(1,iFrag)

      case (KeyW(173))
        !                                                              *
        !**** TRAN *****************************************************
        !                                                              *

        if (.not. FragSet) then
          write(u6,*) 'Keyword TRANS must be preceded by keyword FRAG!'
          call Quit_OnUserError()
        end if
        GWinput = .true.
        Kword = Get_Ln(LuRd)
        call Get_F(1,OrigTrans(1,iFrag),3)

      case (KeyW(174))
        !                                                              *
        !***** ROT  ****************************************************
        !                                                              *

        if (.not. FragSet) then
          write(u6,*) 'Keyword ROT must be preceded by keyword FRAG!'
          call Quit_OnUserError()
        end if
        GWinput = .true.
        Kword = Get_Ln(LuRd)
        call Get_F(1,OrigRot(1,1,iFrag),9)

      case (KeyW(175))
        !                                                              *
        !****** ZONL ***************************************************
        !                                                              *

        GWinput = .true.
        WriteZMat = .true.

      case (KeyW(176))
        !                                                              *
        !****** BASL ***************************************************
        !                                                              *

        GWinput = .true.
        BasLib = Get_Ln(LuRd)
        Write_BasLib = .true.

      case (KeyW(177))
        !                                                              *
        !****** NUME ***************************************************
        !                                                              *

        GWinput = .true.
        iDNG = 1

      case (KeyW(178))
        !                                                              *
        !****** VART ***************************************************
        !                                                              *

        GWinput = .true.
        VarT = .true.

      case (KeyW(179))
        !                                                              *
        !****** VARR ***************************************************
        !                                                              *

        GWinput = .true.
        VarR = .true.

      case (KeyW(180))
        !                                                              *
        !****** SHAK ***************************************************
        !                                                              *

        GWinput = .true.
        KWord = Get_Ln(LuRd)
        call Upcase(KWord)
        call Get_F1(1,Shake)
        if (index(KWord,'ANGSTROM') /= 0) Shake = Shake/Angstrom

      case (KeyW(181))
        !                                                              *
        !***** PAMF ****************************************************
        !                                                              *
        ! Disable AMFI for an atom type

        KWord = Get_Ln(LuRd)
        call Get_I1(1,iAtom_Number)
        No_AMFI(iAtom_Number) = .true.

      case (KeyW(182))
        !                                                              *
        !****** GROM ***************************************************
        !                                                              *
        ! Import definition of QMMM system from Gromacs

#       ifdef _GROMACS_
        if (SymmSet) then
          Message = 'SYMMETRY keyword is not compatible with GROMACS'
          call WarningMessage(2,Message)
          call Quit_OnUserError()
        end if
        DoGromacs = .true.
        GWInput = .true.
        VarT = .true.
        VarR = .true.

        ! Check for options
        KWord = Get_Ln(LuRd)
        call UpCase(KWord)
        select case (KWord(1:4))
          case ('SIMP')
            nCastMM = 0
            call mma_allocate(CastMM,nCastMM)
          case ('CAST')
            KWord = Get_Ln(LuRd)
            call Get_I1(1,nCastMM)
            if (nCastMM <= 0) then
              Message = 'nCastMM is zero or negative'
              call WarningMessage(2,Message)
              call Quit_OnUserError()
            end if
            call mma_allocate(CastMM,nCastMM)
            KWord = Get_Ln(LuRd)
            call Get_I(1,CastMM,nCastMM)
            do iCastMM=1,nCastMM
              if (CastMM(iCastMM) <= 0) then
                Message = 'Impossible, MM index < 1'
                call WarningMessage(2,Message)
                call Quit_OnUserError()
              end if
            end do
          case default
            Message = 'GROMACS keyword found, but no valid option'
            call WarningMessage(2,Message)
            call Quit_OnUserError()
        end select

        ! After the call to Fetch_QMMM, the inner subsystem is in a temporary
        ! xyz file and the outer subsystem is on the runfile
        call Fetch_QMMM(CastMM,nCastMM)

        call mma_deallocate(CastMM)

        ! Let Molcas read the xyz file
        iCoord = iCoord+1
        CoordSet = .true.
        LuXYZ = 1
        LuXYZ = isFreeUnit(LuXYZ)
        call molcas_open(LuXYZ,'GMX.XYZ')
#       ifdef _HAVE_EXTRA_
        if (Expert) then
          if (iCoord > 1) then
            call WarningMessage(1,'GROMACS and COORD keywords cannot be combined with molcas_extra')
          end if
        end if
        call XYZread(LuXYZ,ForceZMAT,nCoord,iErr)
        if (iErr /= 0) then
          Message = 'RdCtl_Seward: XYZread returned non-zero error code'
          call WarningMessage(2,Message)
          call Abend()
        end if
        call XYZcollect(iCoord,nCoord,OrigTrans,OrigRot,nFragment)
#       else
        if (Expert) then
          if (iCoord > 1) then
            call WarningMessage(1,'TINKER coordinates replacing COORD')
          end if
          call Read_XYZ(LuXYZ,OrigRot,OrigTrans,Replace=(iCoord > 1))
        else
          call Read_XYZ(LuXYZ,OrigRot,OrigTrans)
        end if
#       endif
        close(LuXYZ)
#       else
        Message = 'Interface to Gromacs not installed'
        call WarningMessage(2,Message)
        call Quit_OnUserError()
#       endif

      case (KeyW(183))
        !                                                              *
        !****** LINK ***************************************************
        !                                                              *
        ! Define link atoms for a Molcas/Gromacs run

#       ifdef _GROMACS_
        GWInput = .true.
        KWord = Get_Ln(LuRd)
        call Get_I1(1,nLA)
        if (nLA <= 0) then
          Message = 'LA definition: nLA is zero or negative'
          call WarningMessage(2,Message)
          call Quit_OnUserError()
        end if
#       ifdef _DEBUGPRINT_
        write(u6,'(/,a)') ' Link atoms (Gromacs numbering):'
        write(u6,'(/,a)') '      LA     QM     MM     Scaling factor'
#       endif
        call mma_allocate(DefLA,3,nLA)
        call mma_allocate(FactLA,nLA)
        do iLA=1,nLA
          KWord = Get_Ln(LuRd)
          call Get_I(1,DefLA(1,iLA),3)
          call Get_F(4,FactLA(iLA),1)
#        ifdef _DEBUGPRINT_
          write(u6,'(i8,2i7,F19.8)') (DefLA(i,iLA),i=1,3),FactLA(iLA)
#        endif
          if (DefLA(1,iLA) <= 0) then
            call WarningMessage(2,'LA definition: index of LA atom < 1')
            call Quit_OnUserError()
          else if (DefLA(2,iLA) <= 0) then
            call WarningMessage(2,'LA definition: index of QM atom < 1')
            call Quit_OnUserError()
          else if (DefLA(3,iLA) <= 0) then
            call WarningMessage(2,'LA definition: index of MM atom < 1')
            call Quit_OnUserError()
          else if ((FactLA(iLA) <= Zero) .or. (FactLA(iLA) >= One)) then
            call WarningMessage(2,'LA definition: bad scaling factor')
            call Quit_OnUserError()
          end if
        end do
        call Put_iArray('LA Def',DefLA,3*nLA)
        call Put_dArray('LA Fact',FactLA,nLA)
        call mma_deallocate(DefLA)
        call mma_deallocate(FactLA)
#       else
        Message = 'Interface to Gromacs not installed'
        call WarningMessage(2,Message)
        call Quit_OnUserError()
#       endif

      case (KeyW(184))
        !                                                              *
        !***** EMFR ****************************************************
        !                                                              *

        GWinput = .true.
        Kword = Get_Ln(LuRd)
        call Upcase(KWord)
        EMFR = .true.
        call Get_F(1,KVector,3)
        Temp = sqrt(KVector(1)**2+KVector(2)**2+KVector(3)**2)
        KVector(1) = KVector(1)/Temp
        KVector(2) = KVector(2)/Temp
        KVector(3) = KVector(3)/Temp
        ! Get the wavelength in atomic units.
        call Get_F1(4,Lambda)
        if (index(KWord,'ANGSTROM') /= 0) Lambda = Lambda/Angstrom
        if (index(KWord,'NANOMETER') /= 0) then
          Lambda = Ten*Lambda/Angstrom
        end if
        KVector(1) = ((Two*Pi)/Lambda)*KVector(1)
        KVector(2) = ((Two*Pi)/Lambda)*KVector(2)
        KVector(3) = ((Two*Pi)/Lambda)*KVector(3)

      case (KeyW(185))
        !                                                              *
        !***** NOCD ****************************************************
        !                                                              *

        GWinput = .true.
        if (.not. CholeskyWasSet) then
          Do_RI = .false.
          iRI_Type = 0
          Cholesky = .false.
          CholeskyWasSet = .true.
        end if

      case (KeyW(186))
        !                                                              *
        !***** FNMC ****************************************************
        !                                                              *

        GWinput = .true.
        FNMC = .true.

      case (KeyW(187))
        !                                                              *
        !***** ISOT ****************************************************
        !                                                              *

        GWinput = .true.
        KWord = Get_Ln(LuRd)
        call Upcase(KWord)
        call Get_I1(1,nIsotopes)
        call mma_allocate(nIsot,nIsotopes,2)
        call mma_allocate(mIsot,nIsotopes)
        do i=1,nIsotopes
          KWord = Get_Ln(LuRd)
          call Upcase(KWord)
          call Get_I1(1,iAt)
          nIsot(i,1) = iAt
          if (index(KWord,'DALTON') /= 0) then
            call Get_F1(2,dMass)
            nIsot(i,2) = -1
            mIsot(i) = dMass*UToAU
          else
            call Get_I1(2,iIso)
            nIsot(i,2) = iIso
            mIsot(i) = -One
          end if
        end do

      case (KeyW(188))
        !                                                              *
        !***** EFP  ****************************************************
        !                                                              *

        GWinput = .true.
        Kword = Get_Ln(LuRd)
        call Get_I1(1,nEFP_fragments)
        allocate(FRAG_TYPE(nEFP_fragments))
        allocate(ABC(3,nEFP_fragments))
        Kword = Get_Ln(LuRd)
        call Upcase(kWord)
        if (KWord == 'XYZABC') then
          Coor_Type = XYZABC_type
          nEFP_Coor = 6
          allocate(EFP_COORS(nEFP_Coor,nEFP_fragments))
          write(u6,*) 'XYZABC option to be implemented'
          call Abend()
        else if (KWord == 'POINTS') then
          Coor_Type = POINTS_type
          nEFP_Coor = 9
          allocate(EFP_COORS(nEFP_Coor,nEFP_fragments))
          do iFrag=1,nEFP_fragments
            KWord = Get_Ln(LuRd)
            FRAG_Type(iFrag) = KWord
            do i=1,3
              KWord = Get_Ln(LuRd)
              jend = index(KWord,' ')
              if (jEnd > LenIn+1) then
                write(u6,*) 'Warning: the label ',KWord(1:jEnd),' will be truncated to ',LenIn,' characters!'
              end if
              ABC(i,iFrag) = KWord(1:min(LenIn,jend-1))
              call Get_F(2,EFP_COORS((i-1)*3+1,iFrag),3)
            end do
          end do
        else if (KWord == 'ROTMAT') then
          Coor_Type = ROTMAT_type
          nEFP_Coor = 12
          allocate(EFP_COORS(nEFP_Coor,nEFP_fragments))
          write(u6,*) 'ROTMAT option to be implemented'
          call Abend()
        else
          write(u6,*) 'Illegal EFP format :',KWord
          write(u6,*)
          write(u6,*) 'Allowed format: XYZABC,'
          write(u6,*) '                POINTS, and'
          write(u6,*) '                ROTMAT'
        end if
        lEFP = .true.

      case default
        if (lTtl) then
          call ProcessTitle()
        else if (Basis_test) then
          ! So the Basis keyword was in the native format.
          ! We have to back step until we find the command line!

          backspace(LuRd)
          backspace(LuRd)
          read(LuRd,'(A)') Key
          call UpCase(Key)
          do while (index(Key(1:4),KeyW(29)) == 0) ! BASI
            backspace(LuRd)
            backspace(LuRd)
            read(LuRd,'(A)') Key
            call UpCase(Key)
          end do
          Basis_test = .false.
          nDone = 0
          call ProcessBasis()
        else
          Last = len_trim(KWord)
          write(u6,*)
          call WarningMessage(2,KWord(1:Last)//' is not a keyword!, Error in keyword.')
          call Quit_OnUserError()

          !call WarningMessage(2,' Premature end of input file.')
          !call Quit_OnUserError()
          exit
        end if
    end select
  end do

  ! Postprocessing for COORD
  !ik = index(KeepBasis,'....')
  !if (ik /= 0) then
  !    KeepBasis = KeepBasis(1:ik-1)
  !end if
  if (CoordSet) then
    do ik=len(KeepBasis),1,-1
      if ((KeepBasis(ik:ik) /= ' ') .and. (KeepBasis(ik:ik) /= '.')) exit
    end do
    KeepBasis = KeepBasis(1:ik)
#   ifdef _HAVE_EXTRA_
    call ProcessXYZ(BasisSet,KeepBasis,KeepGroup,iBSSE,SymThr,isHold,ScaleFactor,HyperParSet,isXfield)
#   else
    call Parse_Basis(KeepBasis)
    call Parse_Group(KeepGroup,SymThr)
    call Write_SewInp('COORD',[iBSSE])
#   endif
    if (writeZmat) then
#     ifdef _HAVE_EXTRA_
      stepFactor = stepFac1/(hypParam(1)*hypParam(1))
      call Geo_Setup_Drv(ishold,oldZMat,zConstraints,geoInput,hypParam,nFragment,iOptimType,stepFactor,gradLim)
#     else
      call WarningMessage(2,'molcas-extra not installed')
      call Quit_OnUserError()
#     endif
    end if
    DoneCoord = .true.
    if (isXfield == 1) then
      LuRd_saved = LuRd
      filename = 'findsym.xfield'
      lXF = .true.
      call OpnFl(filename(1:(index(filename,' ')-1)),LuRd,Exists)
      if (.not. Exists) then
        call WarningMessage(2,'Error! File not found: '//filename(1:(index(filename,' ')-1)))
        call Quit_OnUserError()
      end if
      write(u6,*) 'Reading external field from file: ',filename(1:(index(filename,' ')-1))
      KWord = Get_Ln(LuRd)
      call ProcessXF()
    end if

    CoordSet = .false.
    LuRdSave = LuRd
    LuFS = IsFreeUnit(1)
#   ifdef _HAVE_EXTRA_
    call Molcas_Open(LuFS,'FS.std')
#   else
    call Molcas_Open(LuFS,'COORD')
#   endif
    LuRd = LuFS
    GWInput = .true.
  else
    if (DoneCoord) then
      close(LuFS)
      LuRd = LuRdSave
#     ifndef _HAVE_EXTRA_
      call Clear_XYZ()
#     endif
    end if
    exit
  end if
end do

!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     P O S T   P R O C E S S I N G                                    *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
call Put_lScalar('CSPF',CSPF)
call Put_cArray('Align_Weights',Align_Weights,512)
!                                                                      *
!***********************************************************************
!                                                                      *
! Isotopic specifications

if (.not. allocated(nIsot)) call mma_allocate(nIsot,0,2)

if (Run_Mode /= S_Mode) then
  ! Loop over unique centers
  iUnique = 0
  call mma_allocate(Isotopes,nCnttp,Label='Isotopes')
  do iCnttp=1,nCnttp
    nCnt = dbsc(iCnttp)%nCntr
    do iCnt=1,nCnt
      iUnique = iUnique+1
      ! Get the mass for this center
      dm = rMass(dbsc(iCnttp)%AtmNr)
      do j=1,size(nIsot,1)
        if (nIsot(j,1) == iUnique) then
          if (nIsot(j,2) >= 0) then
            dm = rMassx(dbsc(iCnttp)%AtmNr,nIsot(j,2))
          else
            dm = mIsot(j)
          end if
          exit
        end if
      end do
      if (iCnt == 1) then
        dbsc(iCnttp)%CntMass = dm
      else
        if (dm /= dbsc(iCnttp)%CntMass) then
          call WarningMessage(2,'Error: All centers of the same type must have the same mass')
          call Quit_OnUserError()
        end if
      end if
    end do
    Isotopes(iCnttp) = dbsc(iCnttp)%CntMass
  end do ! iCnttp
  call Put_dArray('Isotopes',Isotopes,nCnttp)
  call mma_deallocate(Isotopes)

  ! Find errors
  do j=1,size(nIsot,1)
    if (nIsot(j,1) > iUnique) then
      call WarningMessage(2,'Error: Isotope specification index larger than the number of unique centers')
      call Quit_OnUserError()
    end if
  end do
end if

! Deallocate
if (allocated(nIsot)) call mma_deallocate(nIsot)
if (allocated(mIsot)) call mma_deallocate(mIsot)
!                                                                      *
!***********************************************************************
!                                                                      *
! post-processing for RP-Coord

if (lRP .and. RPset) call processRP(KeepGroup,SymThr)

lAMFI = lAMFI .and. (.not. NoAMFI)

! Disable the RI flag if only one-electron integrals are requested

Do_RI = (.not. Onenly) .and. Do_RI
if (Do_RI) then
  if (LDF .and. LocalDF) then
    call WarningMessage(2,'LDF and LocalDF are incompatible')
    call Quit_OnUserError()
  end if
end if

iPrint = nPrint(iRout)

S%Mx_Shll = iShll+1
Max_Shells = S%Mx_Shll

if (nCnttp == 0) then
  call WarningMessage(2,'Input does not contain any basis sets')
  call Quit_OnUserError()
end if
if (mdc == 0) then
  call WarningMessage(2,'Input does not contain coordinates')
  call Quit_OnUserError()
end if
if (S%iAngMx < 0) then
  call WarningMessage(2,' There is an error somewhere in the input!;S%iAngMx < 0')
  call Quit_OnUserError()
end if
if (S%iAngMx > iTabMx) then
  call WarningMessage(2,' Too High angular momentum !!!')
  call Quit_OnUserError()
end if
if (DoTinker .and. DoGromacs) then
  call WarningMessage(2,'TINKER and GROMACS keywords cannot be used together')
  call Quit_OnUserError()
end if
if (DoTinker .and. (iCoord > 1)) then
  if (.not. Expert) then
    call WarningMessage(2,'TINKER and COORD keywords cannot be used together')
    call Quit_OnUserError()
  end if
end if
if (DoGromacs .and. (iCoord > 1)) then
  if (.not. Expert) then
    call WarningMessage(2,'GROMACS and COORD keywords cannot be used together')
    call Quit_OnUserError()
  end if
end if

if (Test) then
  Do_GuessOrb = .false.
  Do_FckInt = .false.
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Automatic DK and AMFI option for relativistic basis sets
!                                                                      *
!***********************************************************************
!                                                                      *
if (BSS .and. (.not. DKroll)) then
  call WarningMessage(2,';BSSM GOES ALWAYS WITH DOUGLAS. THE OPPOSITE IS NOT TRUE')
  call Abend()
end if

lECP = .false.
lPP = .false.
do i=1,nCnttp
  lECP = lECP .or. dbsc(i)%ECP
  lPP = lPP .or. (dbsc(i)%nPP /= 0)
end do
if ((lECP .or. lPP) .and. DKroll .and. (.not. Expert)) then
  call WarningMessage(2,' ECP option not compatible with Douglas-Kroll!')
  call Quit_OnUserError()
end if

if (imix == 1) then
  if (Expert) then
    call WarningMessage(1,' input is inconsistent!;SEWARD found basis sets of mixed relativistic (or non-relativistic) types!;'// &
                        'No relativistic option will be automatically enabled')
  else
    call WarningMessage(2,' input is inconsistent!;SEWARD found basis sets of mixed relativistic (or non-relativistic) types!')
    call Quit_OnUserError()
  end if
end if
if ((ifnr == 1) .and. (.not. Expert)) then
  if (DKroll) then
    call WarningMessage(1,';you requested the DK-option for;a non-relativistic basis.;This request will be ignored')
  end if
  DKroll = .false.
else if (ifnr == 0) then
  lAMFI = .not. NoAMFI
  if (.not. DKroll) then
    DKroll = .true.
    !if (iRELAE == -1) IRELAE = 201022
    if (iRELAE == -1) then
      if (itype == 2) then
        IRELAE = 1022
      else if (itype == 14) then
        IRELAE = 101
      end if
    end if
  end if
  if ((MolWgh /= 0) .and. (MolWgh /= 2)) MolWgh = 2
end if

if (NoDKroll) DKroll = .false.
#ifdef _HAVE_EXTRA_
if (DoEMPC) isHold = 1
#endif

if ((lECP .or. lPP) .and. lAMFI .and. (.not. Expert)) then
  call WarningMessage(2,' ECP option not compatible with AMFI!')
  call Quit_OnUserError()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Activate Finite Nucleus parameters

if (Nuclear_Model == Point_Charge) then
  if (ign == 2) Nuclear_Model = Gaussian_Type
  if (ign == 3) Nuclear_Model = mGaussian_Type
end if

do iCnttp=1,nCnttp
  if (Nuclear_Model == Gaussian_Type) then

    ! If ExpNuc not explicitly defined use default value.

    nMass = nint(dbsc(iCnttp)%CntMass/UToAU)
    if (dbsc(iCnttp)%ExpNuc < Zero) dbsc(iCnttp)%ExpNuc = NucExp(nMass)
  else if (Nuclear_Model == mGaussian_Type) then

    ! Get parameters for the Modified Gaussian Nuclear
    ! charge distribution.

    jAtmNr = dbsc(iCnttp)%AtmNr
    nMass = nint(dbsc(iCnttp)%CntMass/UToAU)
    call ModGauss(real(jAtmNr,kind=wp),nMass,dbsc(iCnttp)%ExpNuc,dbsc(iCnttp)%w_mGauss)

  else

    ! Nothing to do for point charges!

  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Cholesky-specific postprocessing:
! 0) if 1C-CD is requested, do it.
! 1) reset integral prescreening thresholds (if not user-defined).
! 2) use default Cholesky normalization (if not user-defined);
!    for AMFI or Douglas-Kroll, use Molcas normalization (again,
!    if not user-defined).
! 3) Turn off Onenly flag, which might be set through the Direct
!    keyword. Thus, specifying Cholesky will force 2-el. int.
!    processing even with Direct specifed as well!
! 4) Turn off Dist flag (makes no sense with Cholesky).
! 5) Integral format on disk is irrelevant, except that Aces II is
!    not allowed. So, reset iWrOpt or quit (for Aces II).
! 6) if Cholesky threshold is specified, use it.
! 7) if span factor is specified, use it.

if (do1CCD) then
  if (.not. Cholesky) then
    DirInt = .true.
    call Cho_Inp(.true.,-1,u6)
  end if
  Cholesky = .true.
  call Cho_InpMod('1CCD')
end if
if (Cholesky) then
  if (Onenly) then
    Cholesky = .false. ! we gotta be lazy in such cases
  else
    if (.not. CutInt_UsrDef) CutInt = Cho_CutInt
    if (.not. ThrInt_UsrDef) ThrInt = Cho_ThrInt
    if (.not. MolWgh_UsrDef) then
      if (lAMFI .or. DKroll) then
        MolWgh = 2
      else
        MolWgh = Cho_MolWgh
      end if
    end if
    if (iWrOpt == 2) then
      write(u6,*) 'Acess II format not allowed with Cholesky!!'
      call Quit_OnUserError()
    else if ((iWrOpt /= 0) .and. (iWrOpt /= 3)) then
      iWrOpt = 0
    end if
    if (CholeskyThr >= Zero) then
      Thrshld_CD = CholeskyThr
      call Cho_SetDecompositionThreshold(Thrshld_CD)
      call Put_Thr_Cho(Thrshld_CD)
    end if
    if (spanCD >= Zero) then
      v = min(spanCD,One)
      call Cho_SetSpan(v)
    end if
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (Prprt) then
  Onenly = .true.
  Vlct = .false.
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Post processing for FAIEMP fragment data

if (lFAIEMP .and. (Run_Mode /= S_Mode)) call FragExpand(LuRd)
!                                                                      *
!***********************************************************************
!                                                                      *
! Post processing for RI and RI/CD option

if (Do_RI .and. (Run_Mode /= S_Mode)) then
  if (iRI_Type == 4) then

    ! Generate on-the-fly aCD or aTrue.cCD auxiliary basis sets.

    call Mk_RICD_Shells()

  else

    ! Pick up an externally defined auxiliary basis set.

    call Mk_RI_Shells(LuRd)

  end if
end if
if (Do_RI .and. LocalDF .and. (Run_Mode == S_Mode)) then
  call SetTargetAccuracy_LDF()
  if (CutInt_UsrDef .and. (.not. APThr_UsrDef)) then
    call LDF_SetPrescreen(CutInt)
    call LDF_CheckThrs()
  end if
  call LDF_CheckConfig()
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Post processing for Well integrals

do iWel=1,nWel
  if (Wel_Info(1,iWel) < Zero) then
    if (.not. lRF) then
      call WarningMessage(2,'; Input inconsistency!; ;Relative positions of well integrals can only be used if the cavity '// &
                          'radius has been specified!')
      call Quit_OnUserError()
    end if
    Wel_Info(1,iWel) = rds+abs(Wel_Info(1,iWel))
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Put up list for point at which the electric field will be
! evaluated. If nEF=0 the default points will be the unique
! centers.

if ((nOrdEF >= 0) .and. (Run_Mode /= S_Mode)) then
  if (nEF /= 0) then
    call mma_allocate(EF_Centers,3,nEF,Label='EF_Centers')
    EF_Centers(:,:) = EFt(:,:)
    call mma_deallocate(EFt)
  else
    nEF = 0
    do iCnttp=1,nCnttp
      if (.not. (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag)) nEF = nEF+dbsc(iCnttp)%nCntr
    end do
    call mma_allocate(EF_Centers,3,nEF,Label='EF_Centers')

    iEF = 1
    do iCnttp=1,nCnttp
      if (.not. (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag)) then
        call dcopy_(3*dbsc(iCnttp)%nCntr,dbsc(iCnttp)%Coor,1,EF_Centers(1,iEF),1)
        iEF = iEF+dbsc(iCnttp)%nCntr
      end if
    end do
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Put up list for point at which the diamagnetic shielding will
! be evaluated. If nDMS=0 the default points will be the unique
! centers.

if (lDMS .and. (Run_Mode /= S_Mode)) then
  if (nDMS /= 0) then
    call mma_allocate(DMS_Centers,3,nDMS,Label='DMS_Centers')
    DMS_Centers(:,:) = DMSt(:,:)
    call mma_deallocate(DMSt)
  else
    nDMS = 0
    do iCnttp=1,nCnttp
      nDMS = nDMS+dbsc(iCnttp)%nCntr
    end do
    call mma_allocate(DMS_Centers,3,nDMS,Label='DMS_Centers')
    iDMS = 1
    do iCnttp=1,nCnttp
      call dcopy_(3*dbsc(iCnttp)%nCntr,dbsc(iCnttp)%Coor,1,DMS_Centers(1,iDMS),1)
      iDMS = iDMS+dbsc(iCnttp)%nCntr
    end do
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! If no multipole moment integrals are requested turn also of the
! computation of the velocity integrals.

if (S%nMltpl == 0) Vlct = .false.

! But turn it on again if explicitly requested

if (Vlct_) Vlct = .true.

! This is the highest order of any property operator.
! The default value of 4 is due to the mass-velocity operator
! which is computed by default.

nPrp = max(4,S%nMltpl)

! Setup of tables for coefficients of the Rys roots and weights.

nDiff = 0
if (S%iAngMx == 0) nDiff = 2
DoRys = .true.
if (DKroll .and. (nOrdEF > 0)) nDiff = nDiff+nOrdEF
if ((.not. Test) .and. (Run_Mode /= S_Mode)) call SetUp_RW(DoRys,nDiff)
!                                                                      *
!***********************************************************************
!                                                                      *
! Store information for the Douglas-Kroll code.

if (DKroll .or. NEMO) call Fill_rInfo1()
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute kOffAO and lOffAO

call Setup_OffAO()
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate labels for Cartesian and spherical basis sets.
! Generate the transformation matrix for cartesian to sphericals
! and contaminants. This has to be done after adding auxiliary or
! fragment basis sets.

call Sphere(S%iAngMx)
!                                                                      *
!***********************************************************************
!***********************************************************************
!***********************************************************************
!                                                                      *
! Set up Symmetry_Info

call Symmetry_Info_Setup(nOper,Oper,max(S%iAngMx,3))

if (lSkip) then
  call Put_Ln(ChSkip)
  call Get_I(1,iSkip,nIrrep)
  Do_GuessOrb = .false.
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!***********************************************************************
!                                                                      *
! Generate list of Stabilizers , Stabilizer Index and distinct cosets

S%mCentr = 0
S%mCentr_Aux = 0
S%mCentr_Frag = 0
do iCnttp=1,nCnttp
  nCnt = dbsc(iCnttp)%nCntr
  do iCnt=1,nCnt
    mdc = iCnt+dbsc(iCnttp)%mdci
    S%Mx_mdc = max(S%Mx_mdc,mdc)
    n_dc = max(mdc,n_dc)
    if (mdc > MxAtom) then
      call WarningMessage(2,' mdc > MxAtom!; Increase MxAtom in Molcas.fh.')
      write(u6,*) ' MxAtom=',MxAtom
      call Abend()
    end if

    ! The symmetry operators of the fragment's atoms should
    ! always be identical to that of the fragment's
    ! pseudocenter/placeholder

    if (dbsc(iCnttp)%Frag) then
      !  Check the FragExpand routine!
      if (abs(dbsc(iCnttp)%nFragCoor) > mdc) then
        write(u6,*) 'rdctl_seward: incorrect mdc index'
        call Abend()
      end if
      iChxyz = dc(abs(dbsc(iCnttp)%nFragCoor))%iChCnt
    else

      ! To assign the character of a center we need to find
      ! the cartesian components that are permutable. We
      ! will only need to loop over the generators of the
      ! group. We will use the three first bits to indicate if
      ! the cartesian component is affected by any symmetry
      ! operation.

      iChxyz = iChAtm(dbsc(iCnttp)%Coor(:,iCnt))
    end if
    dc(mdc)%iChCnt = iChxyz
    call Stblz(iChxyz,dc(mdc)%nStab,dc(mdc)%iStab,nIrrep,dc(mdc)%iCoSet)

    ! Perturb the initial geometry if the SHAKE keyword was given,
    ! but maintain the symmetry

    if ((Shake > Zero) .and. (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux))) then
      jTmp = 0
      do j=1,dc(mdc)%nStab-1
        jTmp = ior(jTmp,dc(mdc)%iStab(j))
      end do
      S%nDim = 0
      do j=0,2
        if (.not. btest(jTmp,j)) S%nDim = S%nDim+1
      end do
      if (S%nDim > 0) then
        call Random_Vector(S%nDim,RandVect(1:S%nDim),.false.)
        jDim = 0
        do j=0,2
          if (.not. btest(jTmp,j)) then
            jDim = jDim+1
            dbsc(iCnttp)%Coor(j+1,iCnt) = dbsc(iCnttp)%Coor(j+1,iCnt)+Shake*RandVect(jDim)
          end if
        end do
      end if
    end if
    if (dbsc(iCnttp)%Frag) then
      S%mCentr_Frag = S%mCentr_Frag+nIrrep/dc(mdc)%nStab
    else if (dbsc(iCnttp)%Aux) then
      S%mCentr_Aux = S%mCentr_Aux+nIrrep/dc(mdc)%nStab
    else
      S%mCentr = S%mCentr+nIrrep/dc(mdc)%nStab
    end if
  end do
end do
if (S%mCentr > MxAtom) then
  call WarningMessage(2,'RdCtl: S%mCentr > MxAtom')
  write(u6,*) 'S%mCentr=',S%mCentr
  write(u6,*) 'Edit src/Include/Molcas.fh'
  write(u6,*) 'Set MxAtom to the value of S%mCentr.'
  write(u6,*) 'Recompile MOLCAS and try again!'
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if ((SymmSet .or. (nIrrep > 1)) .and. LDKroll) then
  call WarningMessage(2,'Local DKH approach is not yet implemented with SYMMETRY')
  call Quit_OnUserError()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (Do_GuessOrb .and. (Run_Mode /= S_Mode)) call Fix_FockOp(LuRd)
!                                                                      *
!***********************************************************************
!                                                                      *
if ((iXPolType /= 0) .and. (nIrrep /= 1)) then
  call WarningMessage(2,'Polarizabilities are not compatible with symmetry.')
  call Quit_OnUserError()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if ((nTtl /= 0) .and. (Run_Mode == G_Mode)) then
  if (iPrint >= 6) then
    write(u6,*)
    write(u6,'(15X,88A)') ('*',i=1,88)
    write(u6,'(15X,88A)') '*',(' ',i=1,86),'*'
    do iTtl=1,nTtl
      write(u6,'(15X,A,A,A)') '*   ',Title(iTtl),'   *'
    end do
    write(u6,'(15X,88A)') '*',(' ',i=1,86),'*'
    write(u6,'(15X,88A)') ('*',i=1,88)
  else
    write(u6,*)
    write(u6,'(A)') ' Title:'
    do iTtl=1,nTtl
      write(u6,'(8X,A)') Title(iTtl)
    end do
    write(u6,*)
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Process the weights used for alignment and distance measurement

call Process_Weights(iPrint)
!                                                                      *
!***********************************************************************
!                                                                      *
! Set structures for TS optimization according to the Saddle method.

if (Run_Mode /= G_Mode) then
  call Saddle()
!                                                                      *
!***********************************************************************
!                                                                      *
! Read coordinates from run file (if any), ditto for external field.
! Do not do this in the Gateway!

  call GeoNew(Show)
  if (lXF) call GeoNew_PC()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call Gen_GeoList()
call mma_deallocate(xb_bas)
call mma_deallocate(xb_label)
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of centers for multipole operators

call SetMltplCenters()

! Put in user specified centers if any

if (lMltpl) then
  do i=1,nTemp
    iMltpl = ITmp(i)
    if (iMltpl <= S%nMltpl) Coor_MPM(:,iMltpl+1) = RTmp(:,i)
  end do
  call mma_deallocate(RTmp)
  call mma_deallocate(ITmp)
end if
#ifdef _DEBUGPRINT_
call RecPrt(' Multipole centers',' ',Coor_MPM,3,S%nMltpl+1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Put up list for point at which the orbital angular momentum
! will be computed.

if (lOAM .and. (Run_Mode /= S_Mode)) then
  call mma_allocate(OAM_Center,3,Label='OAM_Center')
  OAM_Center(:) = OAMt
else if (.not. allocated(OAM_Center)) then
  call mma_allocate(OAM_Center,3,Label='OAM_Center')
  OAM_Center(:) = CoM
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Put up list for point at which the orbital magnetic quadrupole
! will be computed.

if (lOMQ .and. (Run_Mode /= S_Mode)) then
  call mma_allocate(OMQ_Center,3,Label='OMQ_Center')
  OMQ_Center(:) = OMQt
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate fields from keyword ORIGIN

if (OrigInput) then
  call mma_deallocate(OrigRot)
  call mma_deallocate(OrigTrans)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (NoZMAT .and. (.not. ForceZMAT)) call Put_iScalar('N ZMAT',0)
if (Run_Mode /= S_Mode) call Put_iArray('BasType',BasisTypes,4)
!                                                                      *
!***********************************************************************
!                                                                      *
if (Run_Mode == G_Mode) call Put_lScalar('Invert constraints',Invert)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Buffer)
!                                                                      *
!***********************************************************************
!                                                                      *
call Datimx(KWord)
Header(1) = Title(1)(5:76)
write(Header(2),'(4A)') ' Integrals generated by ',Vrsn,', ',KWord(1:24)
call Put_cArray('Seward Title',Header(1),144)
if (nTtl > 0) call Put_cArray('SewardXTitle',Title(1),nTtl*80)
!                                                                      *
!***********************************************************************
!                                                                      *
if (Run_Mode == G_Mode) call Put_iScalar('DNG',iDNG)
!                                                                      *
!***********************************************************************
!                                                                      *

call mma_deallocate(STDINP)

return

contains

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  select case (code)
    case (1)
      call WarningMessage(2,'Unable to read data from '//KWord)
    case (2)
      write(u6,'(a,a)') 'Error reading from file ',Key(1:iFile-1)
      write(u6,'(a,a)') 'unable to process line: ',KWord
  end select
  call Quit_OnUserError()

end subroutine Error

subroutine ProcessTitle()

  GWInput = AnyMode
  lTtl = .true.
  nTtl = nTtl+1
  if (nTtl > 10) then
    call WarningMessage(2,' Too many title cards')
    call Quit_OnUserError()
  end if
  i1 = iCFrst(Key,80)
  i2 = len_trim(Key(1:len(Title)))
  nc = 80-(i2-i1+1)
  nc2 = nc/2
  Title(nTtl) = ''
  Title(nTtl)(nc2+1:nc2+i2-i1+1) = Key(i1:i2)
  Skip1 = .true.

end subroutine ProcessTitle

subroutine ProcessBasis()

  integer(kind=iwp) :: i, iSh, n1, n2, n3

  iOpt_XYZ = 0
  GWInput = .true.
  nCnttp = nCnttp+1
  if (Run_Mode == S_Mode) then
    call WarningMessage(2,'Seward input error!')
    write(u6,*) 'The command : "',Previous_Command,'" is not allowed in the Seward input when the Gateway is used!'
    write(u6,*)
    call Quit_OnUserError()
  end if
  if (nCnttp > Mxdbsc) then
    call WarningMessage(2,' Increase Mxdbsc')
    call Quit_OnUserError()
  end if
  NoZMAT = .true.

  ! Read the basis set label

  Key = Get_Ln(LuRd)
  BSLbl = Key(1:80)

  ! If dummy atom point at the ANO-RCC set where the specification is.

  call UpCase(BSLbl)
  iDummy_basis = 0
  BasisTypes_save(:) = BasisTypes
  if ((BSLbl(1:2) == 'X.') .and. (index(BSLbl,'INLINE') == 0) .and. (index(BSLbl,'RYDBERG') == 0)) then
    BSLbl = 'X.ANO-RCC.'
    do i=11,80
      BSLbl(i:i) = '.'
    end do
    iDummy_basis = 1
  end if
  !call UpCase(BSLbl)
  Last = len_trim(BSLbl)
  GWInput = .true.
  Indx = index(BSLbl,'/')
  if (Indx == 0) then
    Fname = BasLib
    Indx = Last+1
    dbsc(nCnttp)%Bsl = BSLbl
  else
    Fname = BSLbl(Indx+2:Last)
    if (Fname == ' ') then
      call WarningMessage(2,' No basis set library specified for BSLbl='//BSLbl(1:Indx-1)//' Fname='//Fname)
      call Quit_OnUserError()
    end if
    Fname = adjustl(Fname)
    dbsc(nCnttp)%Bsl = BSLbl(1:Indx-1)
  end if

  n = index(dbsc(nCnttp)%Bsl,' ')
  if (n == 0) n = 81
  do i=n,80
    dbsc(nCnttp)%Bsl(i:i) = '.'
  end do

  if ((Show .and. (nPrint(2) >= 6)) .or. Write_BasLib) then
    write(u6,*)
    write(u6,*)
    write(u6,'(1X,A,I5,A,A)') 'Basis Set ',nCnttp,' Label: ',BSLbl(1:Indx-1)
    write(u6,'(1X,A,A)') 'Basis set is read from library:',Fname(1:index(Fname,' '))
  end if

  jShll = iShll
  dbsc(nCnttp)%Bsl_old = dbsc(nCnttp)%Bsl
  dbsc(nCnttp)%mdci = mdc
  call GetBS(Fname,dbsc(nCnttp)%Bsl,iShll,Ref,UnNorm,LuRd,BasisTypes,STDINP,lSTDINP,.false.,Expert,ExtBasDir)

  Do_FckInt = Do_FckInt .and. dbsc(nCnttp)%FOp .and. (dbsc(nCnttp)%AtmNr <= 96)
# ifdef _DEMO_
  Do_GuessOrb = .false.
# else
  Do_GuessOrb = Do_GuessOrb .and. (dbsc(nCnttp)%AtmNr <= 96)
# endif

  if (iDummy_Basis == 1) BasisTypes(:) = BasisTypes_save
  if (itype == 0) then
    if ((BasisTypes(3) == 1) .or. (BasisTypes(3) == 2) .or. (BasisTypes(3) == 14)) iType = BasisTypes(3)
  else
    if ((BasisTypes(3) == 1) .or. (BasisTypes(3) == 2) .or. (BasisTypes(3) == 14)) then
      if (BasisTypes(3) /= iType) then
        imix = 1
        BasisTypes(3) = -1
      end if
      iType = BasisTypes(3)
    end if
  end if
  if (itype == 1) ifnr = 1
  if ((itype == 2) .or. (itype == 14)) ifnr = 0

  if (ign == 0) then
    ign = BasisTypes(4)
  else if (abs(BasisTypes(4)) /= abs(ign)) then
    if (nmwarn) then
      call WarningMessage(1,'SEWARD found basis sets of mixed nuclear charge model. The most advanced one will be used.')
    end if
    nmwarn = .false.
    ign = max(ign,BasisTypes(4))
    BasisTypes(4) = ign
  end if

  if (Show .and. (nPrint(2) >= 6) .and. (Ref(1) /= '') .and. (Ref(2) /= '')) then
    write(u6,'(1x,a)') 'Basis Set Reference(s):'
    if (Ref(1) /= '') write(u6,'(5x,a)') trim(Ref(1))
    if (Ref(2) /= '') write(u6,'(5x,a)') trim(Ref(2))
    write(u6,*)
    write(u6,*)
  end if
  dbsc(nCnttp)%ECP = (dbsc(nCnttp)%nPP+dbsc(nCnttp)%nPrj+dbsc(nCnttp)%nSRO+dbsc(nCnttp)%nSOC+dbsc(nCnttp)%nM1+dbsc(nCnttp)%nM2) /= 0

  lAng = max(dbsc(nCnttp)%nVal,dbsc(nCnttp)%nSRO,dbsc(nCnttp)%nPrj)-1
  S%iAngMx = max(S%iAngMx,lAng)
  ! No transformation needed for s and p shells
  Shells(jShll+1)%Transf = .false.
  Shells(jShll+1)%Prjct = .false.
  Shells(jShll+2)%Transf = .false.
  Shells(jShll+2)%Prjct = .false.
  dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal+dbsc(nCnttp)%nPrj+dbsc(nCnttp)%nSRO+dbsc(nCnttp)%nSOC+dbsc(nCnttp)%nPP
  nCnt = 0
  if (dbsc(nCnttp)%Aux) then
    do iSh=jShll+1,iShll
      Shells(iSh)%Aux = .true.
    end do
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Set Cartesian functions if specified by the basis type

  if (BasisTypes(1) == 9) then
    do iSh=jShll+3,iShll
      Shells(iSh)%Transf = .false.
      Shells(iSh)%Prjct = .false.
    end do
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Automatic onset of muonic charge if the basis type is muonic.
  ! This will also automatically activate finite nuclear mass correction.

  KWord = ''
  KWord(1:Indx-1) = BSLbl(1:Indx-1)
  call UpCase(KWord)
  if (index(KWord,'MUONIC') /= 0) then
    dbsc(nCnttp)%fMass = mu2elmass
    FNMC = .true.
    tDel = 1.0e50_wp
    call Put_dScalar('T delete thr',tDel)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Update BasisTypes

  do i=1,4
    if (BasisTypes_save(i) == 0) cycle
    if (BasisTypes(i) /= BasisTypes_save(i)) BasisTypes(i) = -1
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *

  do
    KWord = Get_Ln(LuRd)
    call UpCase(KWord)
    KWord = adjustl(KWord)
    select case (KWord(1:4))
      case ('PSEU')
        dbsc(nCnttp)%pChrg = .true.
        dbsc(nCnttp)%Fixed = .true.
      case ('ACDT')
        KWord = Get_Ln(LuRd)
        call Get_F1(1,dbsc(nCnttp)%aCD_Thr)
      case ('MUON')
        dbsc(nCnttp)%fMass = mu2elmass
      case ('NUCL')
        KWord = Get_Ln(LuRd)
        call Get_F1(1,dbsc(nCnttp)%ExpNuc)
      case ('FIXE')
        dbsc(nCnttp)%Fixed = .true.
      case ('SPHE')
        if (index(KWord,'ALL') /= 0) then
          do iSh=jShll+3,iShll
            Shells(iSh)%Transf = .true.
            Shells(iSh)%Prjct = .true.
          end do
        else
          ist = index(KWord,' ')
          iAng = 2
          do iSh=jShll+3,iShll
            if (index(KWord(ist:80),AngTyp(iAng)) /= 0) then
              Shells(iSh)%Transf = .true.
              Shells(iSh)%Prjct = .true.
            end if
            iAng = iAng+1
          end do
        end if
      case ('CART')
        if (index(KWord,'ALL') /= 0) then
          do iSh=jShll+1,iShll
            Shells(iSh)%Transf = .false.
            Shells(iSh)%Prjct = .false.
          end do
        else
          ist = index(KWord,' ')
          iAng = 0
          do iSh=jShll+1,iShll
            if (index(KWord(ist:80),AngTyp(iAng)) /= 0) then
              Shells(iSh)%Transf = .false.
              Shells(iSh)%Prjct = .false.
            end if
            iAng = iAng+1
          end do
        end if
      case ('CONT')
        if (index(KWord,'ALL') /= 0) then
          do iSh=jShll+1,iShll
            Shells(iSh)%Prjct = .false.
          end do
        else
          ist = index(KWord,' ')
          iAng = 0
          do iSh=jShll+1,iShll
            if (index(KWord(ist:80),AngTyp(iAng)) /= 0) Shells(iSh)%Prjct = .false.
            iAng = iAng+1
          end do
        end if
      case ('CHAR')
        KWord = Get_Ln(LuRd)
        call UpCase(KWord)
        call Get_F1(1,dbsc(nCnttp)%Charge)
        ist = index(KWord,' ')
        if (dbsc(nCnttp)%IsMM /= 0) then
          call WarningMessage(1,' Found a charge associated with a MM atom. Ignore it')
          dbsc(nCnttp)%Charge = Zero
        end if
      case ('FRAG')
        dbsc(nCnttp)%pChrg = .true.
        dbsc(nCnttp)%Fixed = .true.
        lFAIEMP = .true.
      case ('END ')
        if (nCnt == 0) then
          call WarningMessage(2,' Input error, no center specified!')
          call Quit_OnUserError()
        end if
        dbsc(nCnttp)%nCntr = nCnt
        mdc = mdc+nCnt
        ! Now allocate the array for the coordinates and copy them over.
        ! Call Allocate(dbsc(nCnttp)%Coor(1:3,1:nCnt)
        call mma_Allocate(dbsc(nCnttp)%Coor_Hidden,3,nCnt,Label='dbsc:C')
        dbsc(nCnttp)%Coor => dbsc(nCnttp)%Coor_Hidden(:,:)
        call DCopy_(3*nCnt,Buffer,1,dbsc(nCnttp)%Coor,1)
        exit
      case default
        ! Read Coordinates

        nCnt = nCnt+1
        n_dc = max(mdc+nCnt,n_dc)
        if (mdc+nCnt > MxAtom) then
          call WarningMessage(2,' RdCtl: Increase MxAtom')
          write(u6,*) '        MxAtom=',MxAtom
          call Quit_OnUserError()
        end if
        jend = index(KWord,' ')
        if (jEnd > LenIn+1) then
          write(u6,*) 'Warning: the label ',KWord(1:jEnd),' will be truncated to ',LenIn,' characters!'
        end if
        dc(mdc+nCnt)%LblCnt = KWord(1:min(LenIn,jend-1))
        dbas = dc(mdc+nCnt)%LblCnt(1:LenIn)
        call Upcase(dbas)
        if (dbas == 'DBAS') then
          RMat_On = .true.
        end if
        if (mdc+nCnt > 1) then
          call Chk_LblCnt(dc(mdc+nCnt)%LblCnt,mdc+nCnt-1)
        end if
        iOff = 1+(nCnt-1)*3
        call Get_F(2,Buffer(iOff),3)
        if (index(KWord,'ANGSTROM') /= 0) then
          do i=0,2
            Buffer(iOff+i) = Buffer(iOff+i)/Angstrom
          end do
        end if

        if (Cell_l) then
          nCnt0 = nCnt
          iOff0 = iOff
          lthCell = lthCell+1
          AdCell(lthCell) = mdc+nCnt0  ! the sequence atom No
          ii = 0
          do n1=-ispread(1),ispread(1)
            do n2=-ispread(2),ispread(2)
              do n3=-ispread(3),ispread(3)
                if ((n1 == 0) .and. (n2 == 0) .and. (n3 == 0)) cycle

                ii = ii+1

                if (ii >= 10000) then
                  call WarningMessage(2,' Too many atoms in Seward')
                  call Quit_OnUserError()
                else
                  if (ii < 1000) then
                    CHAR4 = '_'//str(ii)
                  else
                    CHAR4 = str(ii)
                  end if
                end if

                nCnt = nCnt+1

                n_dc = max(mdc+nCnt,n_dc)
                if (mdc+nCnt > MxAtom) then
                  call WarningMessage(2,' RdCtl: Increase MxAtom')
                  write(u6,*) '        MxAtom=',MxAtom
                  call Quit_OnUserError()
                end if

                jend = index(KWord,' ')
                if (jEnd > 5) then
                  write(u6,*) 'Warning: the label ',KWord(1:jEnd),' will be truncated to ',LenIn,' characters!'
                end if
                dc(mdc+nCnt)%LblCnt = KWord(1:min(LenIn,jend-1))//CHAR4

                call Chk_LblCnt(dc(mdc+nCnt)%LblCnt,mdc+nCnt-1)

                iOff = 1+(nCnt-1)*3

                ! Copy old coordinate  first
                Buffer(iOff:iOff+2) = Buffer(iOff0:iOff0+2)+n1*VCell(:,1)+n2*VCell(:,2)+n3*VCell(:,3)

              end do
            end do
          end do
        end if
    end select
  end do

end subroutine ProcessBasis

subroutine ProcessEF(KWName)

  character(len=4), intent(in) :: KWName
  integer(kind=iwp) :: iCnt, iCnttp, iEF

  KWord = Get_Ln(LuRd)
  call Get_I1(1,nEF)
  if (nEF < 0) nEF = 0
  if (nEF /= 0) then
    call mma_allocate(EFt,3,nEF,label='nEF')
    do iEF=1,nEF
      KWord = Get_Ln(LuRd)
      ! Check whether a label is specified instead of a coordinate
      call Get_S(1,Key,1)
      call Upcase(Key)
      Key = adjustl(Key)
      jTmp = ichar(Key(1:1))
      if ((jTmp >= 65) .and. (jTmp <= 90)) then
        jEnd = index(Key,' ')-1
        iOff = 0
        iFound_Label = 0
        do iCnttp=1,nCnttp
          do iCnt=iOff+1,iOff+dbsc(iCnttp)%nCntr
            if (Key(1:jEnd) == dc(iCnt)%LblCnt(1:jEnd)) then
              iFound_Label = 1
              EFt(1:3,iEF) = dbsc(iCnttp)%Coor(1:3,iCnt-iOff)
            end if
          end do
          iOff = iOff+dbsc(iCnttp)%nCntr
        end do
        if (iFound_Label == 0) then
          call WarningMessage(2,'; Error in processing the keyword '//KWName//'.;'// &
                              'The label "'//Key(1:jEnd)//'" could not be found among the centers.;'// &
                              'Remember to specify the atom center before specifying the '//KWName//' keyword.')
          call Quit_OnUserError()
        end if
      else
        call Get_F(1,EFt(:,iEF),3)
        call Upcase(KWord)
        if (index(KWord,'ANGSTROM') /= 0) EFt(:,i) = EFt(:,i)/Angstrom
      end if
    end do
  end if

end subroutine ProcessEF

subroutine ProcessXF()

  integer(kind=iwp) :: i, iOrd_XF, iXF, k

  call Get_I1(1,nXF)
  Convert = .false.
  call Upcase(KWord)
  if (index(KWord,'ANGSTROM') /= 0) then
    Convert = .true.
    ix = index(KWord,'ANGSTROM')
    KWord(ix:ix+7) = '        '
  end if

  KWord(170:180) = '-2 -2 -2 -2'
  call Put_Ln(KWord)
  call Get_I1(2,nOrd_XF)
  call Get_I1(3,iXPolType)
  call Get_I1(4,nXMolnr)
  call Get_I1(5,nReadEle)

  ! Set defaults: ch+dip, no polarisabilities,
  !               exclude only its own multipole,
  !               no element read

  if (nOrd_XF == -2) nOrd_XF = 1
  if (iXPolType == -2) iXPolType = 0
  if (nXMolnr == -2) nXMolnr = 0
  if (nReadEle == -2) nReadEle = 0

  if ((nOrd_XF > 2) .or. (nOrd_XF < -1)) then
    call WarningMessage(2,'Error! Illegal value of nOrd_XF')
    write(u6,*) 'nOrd_XF= ',nOrd_XF
    call Quit_OnUserError()
  end if
  if ((iXPolType > 2) .or. (iXPolType < 0)) then
    call WarningMessage(2,'Error! Illegal value of iXPolType')
    write(u6,*) 'iXPolType= ',iXPolType
    call Quit_OnUserError()
  end if
  if ((nXMolnr > 100) .or. (nXMolnr < 0)) then
    call WarningMessage(2,'Error! Illegal value of nXMolnr')
    write(u6,*) 'nXMolnr= ',nXMolnr
    call Quit_OnUserError()
  end if
  if ((nReadEle > 1) .or. (nReadEle < 0)) then
    call WarningMessage(2,'Error! Illegal value of nReadEle')
    write(u6,*) 'nReadEle= ',nReadEle
    call Quit_OnUserError()
  end if

  nData_XF = 3
  do iOrd_XF=0,nOrd_XF
    nData_XF = nData_XF+(iOrd_XF+1)*(iOrd_XF+2)/2
  end do

  if (iXPolType > 0) then
    nData_XF = nData_XF+6
    lRF = .true.  ! Polarisabilities treated as Langevin
  end if

  if (iXPolType == 1) then
    nDataRead = nData_XF-5 ! Read only one pol value
  else
    nDataRead = nData_XF
  end if

  call mma_allocate(XF,nData_XF,nXF,Label='XF')
  call mma_allocate(XMolnr,nXMolnr,nXF,Label='XMolnr')
  call mma_allocate(XEle,nXF,Label='XEle')

  call Upcase(KWord)

  do iXF=1,nXF
    XEle(iXF) = 0  ! default: no element spec.

    ! If reading from external file, use free format to allow
    ! long lines of input. On the other hand, comments are
    ! not allowed in external files.

    if (LuRd /= LuRd_saved) then
      call mma_Allocate(iScratch,nXMolnr+nReadEle,Label='iScratch')
      read(LuRd,*) (iScratch(k),k=1,nXMolnr),(iScratch(nXMolnr+k),k=1,nReadEle),(XF(k,iXF),k=1,nDataRead)
      do i=1,nXMolnr
        XMolnr(i,iXF) = iScratch(i)
      end do
      do i=1,nReadEle
        XEle(iXF+(i-1)) = iScratch(nXMolnr+i)
      end do
      call mma_deallocate(iScratch)
    else
      KWord = Get_Ln(LuRd)
      KWord(170:180) = ' 0.0 0.0 0.0'
      call Put_Ln(KWord)

      do i=1,nXMolnr
        call Get_I1(i,iTemp)
        XMolnr(i,iXF) = iTemp
      end do
      do i=1,nReadEle
        call Get_I1(nXMolnr+i,iTemp)
        XEle(iXF+(i-1)) = iTemp
      end do
      call Get_F(nXMolnr+nReadEle+1,XF(1,iXF),nDataRead)
    end if

    XF(1:3,iXF) = XF(1:3,iXF)*ScaleFactor
    if (Convert) XF(1:3,iXF) = XF(1:3,iXF)/Angstrom

  end do

  ! Close file and reset LuRd if external file was used
  if (LuRd /= LuRd_saved) then
    close(LuRd)
    LuRd = LuRd_saved
  end if

end subroutine ProcessXF

end subroutine RdCtl_Seward

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_OPENVR(IOPT,ID)
!
! Purpose: open (IOPT=1) or close (IOPT=2) files for vector
!          and reduced set storage as well as restart files.
!          ID=1: open local files (for parallel run)
!          ID=2: open global files (as in serial run)

use Cholesky, only: Cho_AdrVec, LuCho, LuMap, LuPri, LuRed, LuRst, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IOPT, ID
integer(kind=iwp) :: ISYM
character(len=6) :: FMAP, FNVEC(8), FRST
character(len=5) :: FNRED
character(len=*), parameter :: SECNAM = 'CHO_OPENVR'

if (IOPT == 1) then
  FMAP = 'CHOMAP'
  if (ID == 1) then
    FNRED = 'CHRDL'
    do ISYM=1,NSYM
      write(FNVEC(ISYM),'(A5,I1)') 'CHVCL',ISYM
    end do
    FRST = 'CHRSTL'
  else
    FNRED = 'CHRED'
    do ISYM=1,NSYM
      write(FNVEC(ISYM),'(A5,I1)') 'CHVEC',ISYM
    end do
    FRST = 'CHORST'
  end if
  LURED = 7
  call DANAME_MF_WA(LURED,FNRED)
  if (CHO_ADRVEC == 1) then
    do ISYM=1,NSYM
      LUCHO(ISYM) = 7
      call DANAME_MF_WA(LUCHO(ISYM),FNVEC(ISYM))
    end do
  else if (CHO_ADRVEC == 2) then
    do ISYM=1,NSYM
      LUCHO(ISYM) = 7
      call DANAME_MF(LUCHO(ISYM),FNVEC(ISYM))
    end do
  else
    call CHO_QUIT('CHO_ADRVEC out of bounds in '//SECNAM//'. Perhaps the NOCHO keyword is needed?',102)
  end if
  LURST = 7
  call DANAME_MF_WA(LURST,FRST)
  LUMAP = 7
  call DANAME(LUMAP,FMAP)
else if (IOPT == 2) then
  if (LURED > 0) then
    call DACLOS(LURED)
    LURED = 0
  end if
  do ISYM=1,NSYM
    if (LUCHO(ISYM) > 0) then
      call DACLOS(LUCHO(ISYM))
      LUCHO(ISYM) = 0
    end if
  end do
  if (LURST > 0) then
    call DACLOS(LURST)
    LURST = 0
  end if
  if (LUMAP > 0) then
    call DACLOS(LUMAP)
    LUMAP = 0
  end if
else
  write(LUPRI,*) SECNAM,': IOPT out of bounds: ',IOPT
  call CHO_QUIT('Error in '//SECNAM,104)
end if

end subroutine CHO_OPENVR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SOAO_g(iSD4,nSD,nSO,MemPrm,MemMax,iBsInc,jBsInc,kBsInc,lBsInc,iPrInc,jPrInc,kPrInc,lPrInc,ipMem1,ipMem2,Mem1,Mem2,iFnc, &
                  MemPSO)

use Basis_Info, only: Shells
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nSD, iSD4(0:nSD,4), nSO, MemPrm, MemMax, ipMem1
integer(kind=iwp), intent(out) :: iBsInc, jBsInc, kBsInc, lBsInc, iPrInc, jPrInc, kPrInc, lPrInc, ipMem2, Mem1, Mem2, iFnc(4), &
                                  MemPSO
integer(kind=iwp) :: iAnga(4), iAO(4), iBasi, iCmpa(4), iPrimi, iQuad, jBasj, jPrimj, kBask, kPrimk, lBasl, lPriml

iPrimi = Shells(iSD4(0,1))%nExp
jPrimj = Shells(iSD4(0,2))%nExp
kPrimk = Shells(iSD4(0,3))%nExp
lPriml = Shells(iSD4(0,4))%nExp
iBasi = Shells(iSD4(0,1))%nBasis
jBasj = Shells(iSD4(0,2))%nBasis
kBask = Shells(iSD4(0,3))%nBasis
lBasl = Shells(iSD4(0,4))%nBasis
do iQuad=1,4
  iAnga(iQuad) = iSD4(1,iQuad)
  iCmpa(iQuad) = iSD4(2,iQuad)
  iAO(iQuad) = iSD4(7,iQuad)
end do

call PSOAO1(nSO,MemPrm,MemMax,iAnga,iCmpa,iAO,iFnc,iBasi,iBsInc,jBasj,jBsInc,kBask,kBsInc,lBasl,lBsInc,iPrimi,iPrInc,jPrimj, &
            jPrInc,kPrimk,kPrInc,lPriml,lPrInc,ipMem1,ipMem2,Mem1,Mem2,MemPSO)
#ifdef _DEBUGPRINT_
write(u6,*) ' ************** Memory partioning **************'
write(u6,*) ' ipMem1=',ipMem1
write(u6,*) ' Mem1=',Mem1
write(u6,*) ' Mem2=',Mem2
write(u6,*) ' Mem3=',Mem3
write(u6,*) ' MemPSO=',MemPSO
write(u6,*) ' MemScr=',MemScr
write(u6,*) ' Mend=',Mend

write(u6,*) ' iBasi,iBsInc=',iBasi,iBsInc
write(u6,*) ' jBasj,jBsInc=',jBasj,jBsInc
write(u6,*) ' kBasi,kBsInc=',kBask,kBsInc
write(u6,*) ' lBasl,lBsInc=',lBasl,lBsInc
write(u6,*) ' iPrimi,iPrInc=',iPrimi,iPrInc
write(u6,*) ' jPrimj,jPrInc=',jPrimj,jPrInc
write(u6,*) ' kPrimk,kPrInc=',kPrimk,kPrInc
write(u6,*) ' lPriml,lPrInc=',lPriml,lPrInc
write(u6,*) ' ***********************************************'
#endif

return

end subroutine SOAO_g

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Naoki Nakatani                                   *
************************************************************************
#ifdef _ENABLE_BLOCK_DMRG_
      Subroutine MKFG3CU4(IFF,G1,F1,G2,F2,G3,F3,idxG3,W3)
*
* Load 1-el, 2-el, and 3-el density matrices to resp. G1, G2, and G3
* and compute 1-el to 4-el contractions of Fock operator F1, F2, and F3.
* For F3, use cumulant reconstruction from 1-el, 2-el, and 3-el density matrices.
*
* Written by N. Nakatani, Oct. 2014
*
      IMPLICIT NONE
*
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "SysDef.fh"
#include "WrkSpc.fh"
#include "pt2_guga.fh"
*
      INTEGER, INTENT(IN) :: IFF
      REAL*8, INTENT(OUT) :: G1(NLEV,NLEV),G2(NLEV,NLEV,NLEV,NLEV)
      REAL*8, INTENT(OUT) :: F1(NLEV,NLEV),F2(NLEV,NLEV,NLEV,NLEV)
      REAL*8, INTENT(OUT) :: G3(*), F3(*)
      INTEGER*1, INTENT(IN) :: idxG3(6,*)
      REAL*8, INTENT(IN) :: W3(NLEV,NLEV,NLEV,NLEV)
*
      REAL*8  G1SUM
      INTEGER IT,IU,IV,IX,IY,IZ,IW
      INTEGER JT,JU,JV,JX,JY,JZ
      INTEGER IZSYM,IYZSYM,IXYZSYM,IVXYZSYM
      INTEGER IG3

      REAL*8, EXTERNAL :: CU4F3H
*
*
      If(NACTEL.GT.1) Then
* load 2-el density matrix
        Call block_load2pdm(nlev,G2,jstate,jstate)
* compute 1-el density matrix from 2-el density matrix
        Do iu=1,nlev
          Do it=1,nlev
            G1sum=0.0D0
            If(ism(it).EQ.ism(iu)) Then
              Do iw=1,nlev
                G1sum=G1sum+G2(iw,iw,it,iu)
              End Do
              G1(it,iu)=G1sum/(NACTEL-1)
            End If
          End Do
        End Do
      Else
* special case for NACTEL = 1
        Call block_load1pdm(nlev,G1,jstate,jstate)
      End If
*
      Do iz=1,nlev
        izSym=ism(iz)
        Do iy=1,nlev
          iyzSym=Mul(ism(iy),izSym)
          If(IFF.NE.0.AND.iyzSym.EQ.1) Then
            Do iw=1,nlev
              F1(iy,iz)=F1(iy,iz)+G2(iw,iw,iy,iz)*EPSA(iw)
            End Do
          End If
        End Do
      End Do

* skip 3RDM part if NACTEL <= 2
      If(NACTEL.LE.2) GoTo 999

      Do iz=1,nlev
        izSym=ism(iz)
        Do iy=1,nlev
          iyzSym=Mul(ism(iy),izSym)
* load 3PDM of which is G3(:,:,:,:,iy,iz)
          Call block_load3pdm2f(nlev,W3,jstate,jstate,iy,iz)
          If(IFF.NE.0) Then
            Do ix=1,nlev
              ixyzSym=Mul(ism(ix),iyzSym)
              Do iv=1,nlev
                ivxyzSym=Mul(ism(iv),ixyzSym)
                If(ivxyzSym.EQ.1) Then
                  Do iw=1,nlev
                    F2(iv,ix,iy,iz)=F2(iv,ix,iy,iz)
     &                             +W3(iw,iw,iv,ix)*EPSA(iw)
                  End Do
                End If
              End Do
            End Do
          End If

          Do iG3=1,NG3
            jt=idxG3(1,iG3)
            ju=idxG3(2,iG3)
            jv=idxG3(3,iG3)
            jx=idxG3(4,iG3)
            jy=idxG3(5,iG3)
            jz=idxG3(6,iG3)
            If(iy.EQ.jy.AND.iz.EQ.jz) Then
              G3(iG3)=W3(jt,ju,jv,jx)
              If(IFF.NE.0) Then
* CU4F3 Contrib. :: + G1(lT,lT)*G3(iP,iQ,jP,jQ,kP,kQ)
                F3(iG3)=F3(iG3)+EASUM*G3(iG3)
                Do iw=1,nlev
                  F3(iG3)=F3(iG3)
* CU4F3 Contrib. :: - 0.5D0*G1(iP,lT)*G3(lT,iQ,jP,jQ,kP,kQ)
     &                   -0.5D0*G1(jt,iw)*W3(iw,ju,jv,jx)*EPSA(iw)
* CU4F3 Contrib. :: - 0.5D0*G1(lT,iQ)*G3(iP,lT,jP,jQ,kP,kQ)
     &                   -0.5D0*G1(iw,ju)*W3(jt,iw,jv,jx)*EPSA(iw)
                End Do
              End If
            End If

            If(IFF.NE.0.AND.iy.EQ.jy.AND.iz.EQ.jz) Then
              Do iw=1,nlev
                F3(iG3)=F3(iG3)
* CU4F3 Contrib. :: - 0.5D0*G1(jP,lT)*G3(lT,jQ,iP,iQ,kP,kQ)
     &                 -0.5D0*G1(jv,iw)*W3(iw,jx,jt,ju)*EPSA(iw)
* CU4F3 Contrib. :: - 0.5D0*G1(lT,jQ)*G3(jP,lT,iP,iQ,kP,kQ)
     &                 -0.5D0*G1(iw,jx)*W3(jv,iw,jt,ju)*EPSA(iw)
              End Do
            End If

            If(IFF.NE.0.AND.iy.EQ.jv.AND.iz.EQ.jx) Then
              Do iw=1,nlev
                F3(iG3)=F3(iG3)
* CU4F3 Contrib. :: - 0.5D0*G1(kP,lT)*G3(lT,kQ,iP,iQ,jP,jQ)
     &                 -0.5D0*G1(jy,iw)*W3(iw,jz,jt,ju)*EPSA(iw)
* CU4F3 Contrib. :: - 0.5D0*G1(lT,kQ)*G3(kP,lT,iP,iQ,jP,jQ)
     &                 -0.5D0*G1(iw,jz)*W3(jy,iw,jt,ju)*EPSA(iw)
              End Do
            End If
          End Do
        End Do
      End Do
*
      If(IFF.NE.0) Then
        Do iG3=1,NG3
          it=idxG3(1,iG3)
          iu=idxG3(2,iG3)
          iv=idxG3(3,iG3)
          ix=idxG3(4,iG3)
          iy=idxG3(5,iG3)
          iz=idxG3(6,iG3)
          F3(iG3)=F3(iG3)+CU4F3H(nlev,EPSA,EASUM,
     &                    G1,G2,F1,F2,it,iu,iv,ix,iy,iz)
        End Do
      End If

 999  Return
      End
#elif defined (NAGFOR)
c Some compilers do not like empty files
      Subroutine empty_MKFG3CU4()
      End
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine OvlDel(Ovlp,nOvlp,TrMat,nTrMat)
************************************************************************
*                                                                      *
*     purpose: Remove near linear dependencies from basis set          *
*                                                                      *
*     input:                                                           *
*       Ovlp    : overlap in AO basis of length nOvlp                  *
*       TrMat   : unit matrix or matrix transforming from AO's to      *
*                 cartesian functions (dependently on input) of        *
*                 length nTrMat                                        *
*                                                                      *
*     output:                                                          *
*       TrMat   : input matrix modified such, that near linear de-     *
*                 pendencies (if exist) are removed                    *
*                                                                      *
*     called from: TrGen                                               *
*                                                                      *
*     calls to: PickUp                                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 Ovlp(nOvlp),TrMat(nTrMat)
*
      Real*8, Dimension(:), Allocatable:: OvlT, OvlH, OvlS, EVec, EVal,
     &                                    NewB, Scratch


*---- Allocate memory for transformed overlap matrix
      Call mma_allocate(OvlT,MaxOrF*(MaxOrF+1)/2,Label='OvlT')
*
*---- Allocate memory for half-transformed overlap matrix
      Call mma_allocate(OvlH,MaxBOF,Label='OvlH')
*
*---- Allocate memory for squared overlap matrix
      Call mma_allocate(OvlS,MaxBas**2,Label='OvlS')
*
*---- Allocate memory for eigenvectors of overlap
      Call mma_allocate(EVec,MaxOrF**2,Label='EVec')
*
*---- Allocate memory for eigenvalues of overlap
      Call mma_allocate(EVal,MaxOrF,Label='EVal')
*
*---- Allocate memory for 'basis' that diagonalizes overlap
      Call mma_allocate(NewB,MaxBOF,Label='NewB')
*
      ij   = 1
      iOld = 1
      iNew = 1
      Do iSym = 1, nSym
*
         iiBT = nBas(iSym)*(nBas(iSym) + 1)/2
         nOF  = nOrb(iSym) - nFro(iSym)
*
*------- Copy frozen vectors to the right position
         If(nFro(iSym)*nBas(iSym).gt.0) Then
*           Write(6,'(a,i2)') 'Copying symmetry block',iSym
*           Write(6,'(i8,a,i8)') iOld,' ->',iNew
*           Write(6,'(a,i8)') 'nTrMat =',nTrMat
            call dcopy_(nFro(iSym)*nBas(iSym),
     &                 TrMat(iOld),1,TrMat(iNew),1)
*        Else
*           Write(6,'(a,i2)') 'No copying of symmetry block',iSym
         End If
*...+....1....+....2....+....3....+....4....+....5....+....6....+....7.>..+....8
*
         iOld = iOld + nFro(iSym)*nBas(iSym)
         iNew = iNew + nFro(iSym)*nBas(iSym)
*
         If (nOF.gt.0) Then
*
*---------- Square overlap and transform to basis given by TrMat
            Call Square(Ovlp(ij),OvlS,1,nBas(iSym),nBas(iSym))
            Call DGEMM_('N','N',
     &                  nBas(iSym),nOF,nBas(iSym),
     &                  1.0d0,OvlS,nBas(iSym),
     &                        TrMat(iOld),nBas(iSym),
     &                  0.0d0,OvlH,nBas(iSym))
            Call MxMt(TrMat(iOld),nBas(iSym),1,
     &                OvlH,1,nBas(iSym),
     &                OvlT,
     &                nOF,nBas(iSym))
*
*---------- Diagonalize overlap and form eigenvalues vector
            Call mma_allocate(Scratch,nOF**2,Label='Scrtach')
            Dummy=0.0D0
            iDum=0
            Call Diag_Driver('V','A','L',nOF,OvlT,
     &                       Scratch,nOF,Dummy,Dummy,iDum,iDum,
     &                       EVal,EVec,nOF,1,0,'J',
     &                       nFound,iErr)
            Call mma_deallocate(Scratch)
C??         Call dCopy_(nOF*(nOF+1)/2,Zero,0,OvlT,1)
C??         iDiag=0
C??         Do i = 1, nOF
C??            OvlT(i+iDiag) = EVal(i)
C??            iDiag = iDiag + i
C??         End Do
*
*---------- Transform to basis that diagonalizes overlap
            Call DGEMM_('N','N',
     &                  nBas(iSym),nOF,nOF,
     &                  1.0d0,TrMat(iOld),nBas(iSym),
     &                        EVec,nOF,
     &                  0.0d0,NewB,nBas(iSym))
*
*---------- Remove linear dependencies
            nOrbi = nFro(iSym)
            ind   = 1
            Do iOrb = 1, nOF
               If (EVal(iOrb).gt.DelThr) Then
                  If(EVal(iOrb).lt.1.0d-5) MiniDn=.False.
                  call dcopy_(nBas(iSym),NewB(ind),1,TrMat(iNew),1)
                  iNew  = iNew  + nBas(iSym)
                  nOrbi = nOrbi + 1
               End If
               ind = ind + nBas(iSym)
            End Do
*
            iOld       = iOld + nOF*nBas(iSym)
            nDel(iSym) = nOrb(iSym) - nOrbi
            nOrb(iSym) = nOrbi
*
         End If
*
         ij = ij + iiBT
*
      End Do
      Call Put_iArray('nDel',nDel,nSym)
*
*---- Deallocate memory
      Call mma_deallocate(NewB)
      Call mma_deallocate(EVal)
      Call mma_deallocate(EVec)
      Call mma_deallocate(OvlS)
      Call mma_deallocate(OvlH)
      Call mma_deallocate(OvlT)

      End subroutine OvlDel

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_L1 (L1,dima,adda)
c
c        this routine test L1
c
        implicit none
#include "chcc1.fh"
        integer dima,adda
         real*8 L1(1:nc,1:dima,1:no)
c
c        help var
        integer m,a,bad,i,ntot
        real*8 s
c
        bad=0
        ntot=0
c
        do i=1,no
        do a=adda+1,adda+dima
        do m=1,nc
c
           s=L1k(m,i,a)
c
           if (abs(L1(m,a-adda,i)-s).gt.1.0d-10) then
            bad=bad+1
            L1(m,a-adda,i)=s
          end if
          ntot=ntot+1

        end do
        end do
        end do
c
        write (6,*) ' L1   ',bad,ntot
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Giovanni Ghigo                              *
************************************************************************
      Subroutine ChoMP2_TraA(iSymL, iSym,jSym, NumV, CMO,NCMO,
     &                               lUCHFV, iStrtVec_AB, nFVec,nFBatch)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden                                    *
* Written:  October 2004                                               *
* Modified for Cholesky-MP2 May 2005                                   *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)

#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Dimension CMO(NCMO)
      Logical TCVC,TCVCt

* --- Memory to allocate & Nr. of Cholesky vectors transformable
*     A=Alpha(AO);  B=Beta(AO)
      TCVC = .False.
      TCVCt= .False.

      NFAB = 0
      Naj = 0  ! C
      Nbi = 0  ! C"
      Len_FAB = 0
      Len_aj = 0  ! C
      Len_bi = 0  ! C"
      Len_XAj = 0   ! C
      Len_XBi = 0   ! C"
      iStrt_aj = 0  ! C
      iStrt_bi = 0  ! C"
      iStrt0_aj = 0  ! C
      iStrt0_bi = 0  ! C"
      NFAB = nBas(iSym) * nBas(jSym)

*     Allocate memory for Transformed Cholesky Vectors - TCVx
* TCV-C :
      If (TCVXist(3,iSym,jSym)) Then
        TCVC = .True.
        Len_XAj = nBas(iSym) * nIsh(jSym)
        Naj = nSsh(iSym) * nIsh(jSym)
        Len_aj = Naj * NumV
        Call GetMem('aj','ALLO','REAL',iStrt00_aj,Len_aj)
        iMemTCVX(3,iSym,jSym,1)=iStrt00_aj
        iMemTCVX(3,iSym,jSym,2)=Len_aj
      EndIf
* TCV-Ct:
      If (TCVXist(3,jSym,iSym)) Then
        TCVCt= .True.
        Len_XBi = nBas(jSym) * nIsh(iSym)
        Nbi = nSsh(jSym) * nIsh(iSym)
        Len_bi = Nbi * NumV
        Call GetMem('bi','ALLO','REAL',iStrt00_bi,Len_bi)
        iMemTCVX(3,jSym,iSym,1)=iStrt00_bi
        iMemTCVX(3,jSym,iSym,2)=Len_bi
      EndIf

* --- START LOOP iFBatch -----------------------------------------------
      DO iFBatch=1,nFBatch
        If (iFBatch.EQ.nFBatch) then
         NumFV = NumV - nFVec * (nFBatch-1)
        Else
         NumFV = nFVec
        EndIf
        If ( TCVC  ) iStrt0_aj = iStrt00_aj + (iFBatch-1) * nFVec * Naj
        If ( TCVCt ) iStrt0_bi = iStrt00_bi + (iFBatch-1) * nFVec * Nbi

*       Allocate memory & Load Full Cholesky Vectors - CHFV
        Len_FAB = NFAB * NumFV
        iStrtVec_FAB = iStrtVec_AB + nFVec * (iFBatch-1)
        Call GetMem('FAB','Allo','Real',iStrt0_FAB,Len_FAB)
        Call RdChoVec(Work(iStrt0_FAB),NFAB,NumFV,iStrtVec_FAB,lUCHFV)

*  ---  Start Loop  iVec  ---
        Do iVec=1,NumFV   ! Loop  iVec
          iStrt_FAB = iStrt0_FAB + (iVec-1) * NFAB
          If ( TCVC  ) iStrt_aj = iStrt0_aj + (iVec-1) * Naj
          If ( TCVCt ) iStrt_bi = iStrt0_bi + (iVec-1) * Nbi

*     --- 1st Half-Transformation  iBeta(AO) -> q(MO) only occupied
C         From CHFV A(Alpha,Beta) to XAj(Alpha,jMO)
          If ( TCVC ) then
            jStrt0MO = 1
            Do j=1,jSym-1
              jStrt0MO = jStrt0MO + nBas(j) * nBas(j)
            EndDo
            jStrt0MO = jStrt0MO + nFro(jSym) * nBas(jSym)
            Call GetMem('XAj','ALLO','REAL',iStrt0_XAj,Len_XAj)
            Call ProdsA_2(Work(iStrt_FAB), nBas(iSym),nBas(jSym),
     &                  CMO(jStrt0MO),nIsh(jSym), Work(iStrt0_XAj))
          EndIf
C         From CHFV A(Alpha,Beta) to XBi(Beta,iMO)
          If ( TCVCt ) then
            iStrt0MO = 1
            Do i=1,iSym-1
              iStrt0MO = iStrt0MO + nBas(i) * nBas(i)
            EndDo
            iStrt0MO = iStrt0MO + nFro(iSym) * nBas(iSym)
            Call GetMem('XBi','ALLO','REAL',iStrt0_XBi,Len_XBi)
            Call ProdsA_2t(Work(iStrt_FAB), nBas(iSym),nBas(jSym),
     &                  CMO(iStrt0MO),nIsh(iSym), Work(iStrt0_XBi))
          EndIf

*     --- 2nd Half-Transformation  iAlpha(AO) -> p(MO)
C         From XAj(Alpha,jMO) to aj(a,j)
          If ( TCVC ) then
            iStrt0MO = 1
            Do i=1,iSym-1
              iStrt0MO = iStrt0MO + nBas(i) * nBas(i)
            EndDo
            iStrt0MO = iStrt0MO + (nFro(iSym)+nIsh(iSym)) * nBas(iSym)
            Call ProdsA_1(Work(iStrt0_XAj), nBas(iSym),nIsh(jSym),
     &                  CMO(iStrt0MO),nSsh(iSym), Work(iStrt_aj))
          EndIf

C         From XBi(Beta,jMO) to bi(b,i)
          If ( TCVCt ) then
            jStrt0MO = 1
            Do j=1,jSym-1
              jStrt0MO = jStrt0MO + nBas(j) * nBas(j)
            EndDo
            jStrt0MO = jStrt0MO + (nFro(jSym)+nIsh(jSym)) * nBas(jSym)
            Call ProdsA_1(Work(iStrt0_XBi), nBas(jSym),nIsh(iSym),
     &                  CMO(jStrt0MO),nSsh(jSym), Work(iStrt_bi))
          EndIf

*     --- End of Transformations

          If ( TCVC ) then
            Call GetMem('XAj','FREE','REAL',iStrt0_XAj,Len_XAj)
          EndIf
          If ( TCVCt ) then
            Call GetMem('XBi','FREE','REAL',iStrt0_XBi,Len_XBi)
          EndIf

        EndDo
*  ---  End Loop  iVec  ---

        Call GetMem('FAB','Free','Real',iStrt0_FAB,Len_FAB)
      ENDDO
* --- END LOOP iFBatch -------------------------------------------------

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iSymL)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKCLIST(SGS,CIS)
! PURPOSE: CONSTRUCT THE COMPRESSED CASE-LIST, I.E.,
!          STORE THE STEP VECTOR FOR ALL POSSIBLE WALKS
!          IN THE ARRAY ICASE. GROUPS OF 15 CASES ARE PACKED
!          INTO ONE INTEGER WORD.

use Symmetry_Info, only: Mul
use gugx, only: CIStruct, SGStruct
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
type(SGStruct), intent(inout) :: SGS
type(CIStruct), intent(inout) :: CIS
integer(kind=iwp) :: IC, IHALF, ILND, IPOS, ISML, ISTP, IVB, IVT, IVTEND, IVTOP, IVTSTA, IWSYM, L, LEV, LEV1, LEV2, LL, MV
logical(kind=iwp) :: Found
integer(kind=iwp), parameter :: IVERT = 1, ISYM = 2, ISTEP = 3

call mma_allocate(CIS%ICase,CIS%nWalk*CIS%nIpWlk,Label='CIS%ICase',safe='*')
call mma_allocate(SGS%Scr,[1,3],[0,SGS%nLev],Label='SGS%Scr',safe='*')

! CLEAR ARRAY NOW. IT WILL BE RESTORED FINALLY

CIS%NOW(:,:,:) = 0

! START MAIN LOOP OVER UPPER AND LOWER WALKS, RESPECTIVELY.

do IHALF=1,2
  if (IHALF == 1) then
    IVTSTA = 1
    IVTEND = 1
    LEV1 = SGS%nLev
    LEV2 = SGS%MidLev
  else
    IVTSTA = SGS%MVSta
    IVTEND = SGS%MVEnd
    LEV1 = SGS%MidLev
    LEV2 = 0
  end if

  ! LOOP OVER VERTICES STARTING AT TOP OF SUBGRAPH

  do IVTOP=IVTSTA,IVTEND
    ! SET CURRENT LEVEL=TOP LEVEL OF SUBGRAPH:
    LEV = LEV1
    SGS%Scr(IVERT,LEV) = IVTOP
    SGS%Scr(ISYM,LEV) = 1
    SGS%Scr(ISTEP,LEV) = -1
    do while (LEV <= LEV1)
      ! FIND FIRST POSSIBLE UNTRIED ARC DOWN FROM CURRENT VERTEX:
      IVT = SGS%Scr(IVERT,LEV)
      Found = .false.
      do ISTP=SGS%Scr(ISTEP,LEV)+1,3
        IVB = SGS%Down(IVT,ISTP)
        if (IVB /= 0) then
          Found = .true.
          exit
        end if
      end do
      if (Found) then
        ! ALT A -- SUCH AN ARC WAS FOUND. WALK DOWN:
        SGS%Scr(ISTEP,LEV) = ISTP
        ISML = 1
        if ((ISTP == 1) .or. (ISTP == 2)) ISML = SGS%ISm(LEV)
        LEV = LEV-1
        SGS%Scr(ISYM,LEV) = Mul(ISML,SGS%Scr(ISYM,LEV+1))
        SGS%Scr(IVERT,LEV) = IVB
        SGS%Scr(ISTEP,LEV) = -1
        if (LEV > LEV2) cycle
        ! WE HAVE REACHED THE LOWER LEVEL. THE WALK IS COMPLETE.
        ! MIDVERTEX NUMBER:
        MV = SGS%Scr(IVERT,SGS%MidLev)+1-SGS%MVSta
        ! SYMMETRY LABEL OF THIS WALK:
        IWSYM = SGS%Scr(ISYM,LEV2)
        ! ITS ORDERING NUMBER WITHIN THE SAME BATCH OF (IHALF,IWSYM,MV):
        ILND = 1+CIS%NOW(IHALF,IWSYM,MV)
        CIS%NOW(IHALF,IWSYM,MV) = ILND
        ! CONSEQUENTLY, THE POSITION IMMEDIATELY BEFORE THIS COMPRESSED WALK:
        IPOS = CIS%IOW(IHALF,IWSYM,MV)+(ILND-1)*CIS%nIpWlk
        ! PACK THE STEPS IN GROUPS OF 15 LEVELS PER INTEGER:
        do LL=LEV2+1,LEV1,15
          IC = 0
          do L=min(LL+14,LEV1),LL,-1
            IC = 4*IC+SGS%Scr(ISTEP,L)
          end do
          IPOS = IPOS+1
          CIS%ICase(IPOS) = IC
        end do
        ! FINISHED WITH THIS WALK. BACK UP ONE LEVEL AND TRY AGAIN:
        LEV = LEV+1
      else
        ! ALT B -- NO SUCH ARC WAS POSSIBLE. GO UP ONE STEP AND TRY AGAIN.
        SGS%Scr(ISTEP,LEV) = -1
        LEV = LEV+1
      end if
    end do
  end do
end do

call mma_deallocate(SGS%Scr)

end subroutine MKCLIST

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine citrans_free

use citrans, only: ndet_group, ncsf_group, ndoc_group, nsoc_group, spintabs, spintabs_free
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i

call mma_deallocate(ndoc_group)
call mma_deallocate(nsoc_group)
call mma_deallocate(ndet_group)
call mma_deallocate(ncsf_group)
do i=lbound(spintabs,1),ubound(spintabs,1)
  call mma_deallocate(spintabs(i)%coef)
end do
call spintabs_free()

end subroutine citrans_free

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine Reorder_GW(A,B,k,l,n,m)
       Implicit Real*8 (a-h,o-z)
       Real*8 A(k,l,n,m), B(k,n,l,m)
*
       Do ik = 1, k
          Do il = 1, l
             Do in = 1, n
                Do im = 1, m
*
                    B(ik,in,il,im) = A(ik,il,in,im)
*
                End Do
             End Do
          End Do
       End Do
*
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Orb_Select(irc,CMO,XMO,Eorb,Smat,Saa,BName,NamAct,nSym,nActa,mOrb,nBas,ortho,ThrSel,n_OK)

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nSym, nActa, mOrb(nSym), nBas(nSym)
integer(kind=iwp), intent(out) :: irc, n_OK(nSym)
real(kind=wp), intent(inout) :: CMO(*), Eorb(*)
real(kind=wp), intent(in) :: XMO(*), Smat(*), Saa(*), ThrSel
character(len=LenIn8), intent(in) :: BName(*)
character(len=LenIn), intent(in) :: NamAct(nActa)
logical(kind=iwp), intent(in) :: ortho
integer(kind=iwp) :: i, ia, iOff, iSym, j, ja, km, lOff, mOx, n_KO, nBa, nBax, nBmx, nBx, nORbmx, nOx
real(kind=wp) :: ThrS
type(DSBA_Type) :: C, S, X
integer(kind=iwp), allocatable :: iD(:)
real(kind=wp), allocatable :: Fock(:,:), Q(:), U(:,:)
real(kind=wp), allocatable, target :: Scr1(:,:), SQt(:)
real(kind=wp), pointer :: C2(:,:), CC(:,:), Scr(:,:), SQ(:,:), X2(:,:), Z(:,:)
character(len=LenIn) :: tmp
real(kind=r8), external :: ddot_

irc = 0

nBmx = 0
nOrbmx = 0
do iSym=1,nSym
  nBmx = max(nBmx,nBas(iSym))
  nOrbmx = max(nOrbmx,mOrb(iSym))
end do
call mma_allocate(iD,2*nOrbmx+nBmx,label='iD')
call mma_allocate(SQt,nBmx**2,label='Smx')
call mma_allocate(Scr1,nBmx*nOrbmx,5,label='Scr1')
call mma_allocate(U,nOrbmx,nOrbmx,label='U')
call mma_allocate(Q,nOrbmx,label='Q')
call mma_allocate(Fock,nOrbmx,2,label='Fock')
Q(:) = Zero

call Allocate_DT(C,nBas,mOrb,nSym,label='C',Ref=CMO)
call Allocate_DT(X,nBas,mOrb,nSym,label='X',Ref=XMO)
call Allocate_DT(S,nBas,nBas,nSym,label='S',Ref=Smat)

iOff = 0
lOff = 0
do iSym=1,nSym

  nBa = 0
  do ia=1,nBas(iSym)
    ja = iOff+ia
    tmp = BName(ja)(1:LenIn)
    do j=1,nActa
      if (NamAct(j) == tmp) then
        nBa = nBa+1
        iD(nBa) = ia
      end if
    end do
  end do
  SQ(1:nBas(iSym),1:nBas(iSym)) => SQt(1:nBas(iSym)**2)
  C2(1:nBa,1:mOrb(iSym)) => Scr1(1:nBa*mOrb(iSym),1)
  CC(1:mOrb(iSym),1:nBas(iSym)) => Scr1(1:mOrb(iSym)*nBas(iSym),2)
  X2(1:nBas(iSym),1:mOrb(iSym)) => Scr1(1:nBas(iSym)*mOrb(iSym),3)
  Z(1:nBa,1:mOrb(iSym)) => Scr1(1:nBa*mOrb(iSym),4)
  Scr(1:nBas(iSym),1:mOrb(iSym)) => Scr1(1:nBas(iSym)*mOrb(iSym),5)
  do ia=1,nBa
    C2(ia,:) = X%SB(iSym)%A2(iD(ia),:)
  end do
  do ia=1,nBa
    SQ(:,ia) = S%SB(iSym)%A2(:,iD(ia))
  end do
  nBx = max(1,nBas(iSym))
  nBax = max(1,nBa)
  call DGEMM_('T','N',nBa,mOrb(iSym),nBas(iSym),One,SQ,nBx,X%SB(iSym)%A2,nBx,Zero,Z,nBax)
  do i=1,mOrb(iSym)
    Q(i) = ddot_(nBa,C2(:,i),1,Z(:,i),1)**2
  end do
  Z(1:nBas(iSym),1:mOrb(iSym)) => Scr1(1:nBas(iSym)*mOrb(iSym),4)
  n_OK(iSym) = 0
  n_KO = 0
  do i=1,mOrb(iSym)
    ThrS = ThrSel*Saa(lOff+i)
    if (sqrt(Q(i)) >= ThrS) then
      n_OK(iSym) = n_OK(iSym)+1
      X2(:,n_OK(iSym)) = X%SB(iSym)%A2(:,i)
      iD(nBmx+n_OK(iSym)) = i
    else
      n_KO = n_KO+1
      Z(:,n_KO) = X%SB(iSym)%A2(:,i)
      iD(nBmx+nOrbmx+n_KO) = i
    end if
  end do

  mOx = max(1,mOrb(iSym))

  if (.not. ortho) then

    call Ortho_orb(X2,S%SB(iSym)%A2,nBas(iSym),n_OK(iSym),2,.false.)
    call Ortho_orb(Z,S%SB(iSym)%A2,nBas(iSym),n_KO,2,.false.)
  end if

  call DGEMM_('T','N',mOrb(iSym),nBas(iSym),nBas(iSym),One,C%SB(iSym)%A2,nBx,S%SB(iSym)%A2,nBx,Zero,CC,mOx)

  if (n_KO > 0) then
    call DGEMM_('N','N',mOrb(iSym),n_KO,nBas(iSym),One,CC,mOx,Z,nBx,Zero,U,mOx)

    call Get_Can_Lorb(Eorb(lOff+1),Fock(:,1),n_KO,mOrb(iSym),iD(nBmx+nOrbmx+1:),U)

    call DGEMM_('N','N',nBas(iSym),n_KO,n_KO,One,Z,nBx,U,n_KO,Zero,Scr,nBx)

    ! Reorder the final MOs such that those of the active site come first
    km = n_OK(iSym)+1
    C%SB(iSym)%A2(:,km:km+n_KO-1) = Scr(:,1:n_KO)
    Fock(:,2) = Fock(:,1)
  end if

  call DGEMM_('N','N',mOrb(iSym),n_OK(iSym),nBas(iSym),One,CC,mOx,X2,nBx,Zero,U,mOx)

  call Get_Can_Lorb(Eorb(lOff+1),Fock(:,1),n_OK(iSym),mOrb(iSym),iD(nBmx+1:),U)

  nOx = max(1,n_OK(iSym))
  call DGEMM_('N','N',nBas(iSym),n_OK(iSym),n_OK(iSym),One,X2,nBx,U,nOx,Zero,Scr,nBx)

  do i=1,n_OK(iSym)
    Eorb(lOff+i) = Fock(iD(nBmx+i),1)
  end do
  C%SB(iSym)%A2(:,1:n_OK(iSym)) = Scr(:,1:n_OK(iSym))

  do i=1,n_KO
    Eorb(lOff+n_OK(iSym)+i) = Fock(iD(nBmx+nOrbmx+i),2)
  end do

  iOff = iOff+nBas(iSym)
  lOff = lOff+mOrb(iSym)
end do

nullify(SQ)
nullify(C2)
nullify(CC)
nullify(X2)
nullify(Z)
nullify(Scr)

call mma_deallocate(iD)
call mma_deallocate(SQt)
call mma_deallocate(Scr1)
call mma_deallocate(U)
call mma_deallocate(Q)
call mma_deallocate(Fock)
call Deallocate_DT(C)
call Deallocate_DT(X)
call Deallocate_DT(S)

return

end subroutine Get_Orb_Select

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ConInt(xyz,nCent,dE,Bf,lWrite_,Label,dBf,ldB,lIter)

use Slapaf_Info, only: ApproxNADC, Energy, Energy0, Gx0, NADC
use Constants, only: Zero, One, Two, auTokJmol
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCent, lIter
real(kind=wp), intent(in) :: xyz(3,nCent)
real(kind=wp), intent(out) :: dE, Bf(3,nCent)
logical(kind=iwp), intent(in) :: lWrite_, ldB
character(len=8), intent(in) :: Label
real(kind=wp), intent(inout) :: dBf(3*nCent,3*nCent)
integer(kind=iwp) :: i, iCar, iCent, iOpt, ix, iy, j, jCent
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: nAtoms
#endif
real(kind=wp) :: E0, E1, Fact, XX
integer(kind=iwp), external :: iDeg
real(kind=wp), external :: DDot_

E1 = Energy(lIter)
E0 = Energy0(lIter)
#ifdef _DEBUGPRINT_
nAtoms = size(Gx0,2)
write(u6,*) 'ConInt: lIter=',lIter
write(u6,*) 'ConInt: E1, E0=',E1,E0
call RecPrt('ConInt: Gx0',' ',Gx0(:,:,lIter),3,nAtoms)
#endif

! iOpt=1 -> Linear
! iOpt=2 -> Quadratic
! iOpt=3 -> Absolute value
if (NADC) then
  if (ApproxNADC) then
    iOpt = 2
  else
    iOpt = 3
  end if
else
  iOpt = 1
end if

! Observe that the program is storing the forces rather than the
! gradients!
!
! The average energy is stored in E1 and the energy difference in
! E0. Ditto for the gradients (see process_gradients).

dE = Zero
if (iOpt == 1) then
  ! Linear
  dE = E0
else if (iOpt == 2) then
  ! Quadratic
  dE = E0**2
else if (iOpt == 3) then
  ! Absolute value
  dE = abs(E0)
end if
if (lWrite_) then
  write(u6,'(2A,F18.8,A,F18.8,A)') Label,' : Energy difference = ',E0,' hartree, ',E0*auTokJmol,' kJ/mol'
  write(u6,'( A,F18.8,A)') '           Average energy    = ',E1,' hartree'
# ifdef _DEBUGPRINT_
  select case (iOpt)
    case (1)
      write(u6,*) 'Option: Linear'
    case (2)
      write(u6,*) 'Option: Quadratic'
    case (3)
      write(u6,*) 'Option: Absolute value'
  end select
# endif
end if

! Compute the WDC B-matrix

Bf(:,:) = Zero
do iCent=1,nCent
  Fact = real(iDeg(xyz(1,iCent)),kind=wp)
  !write(u6,*) 'Fact=',Fact
  do iCar=1,3
    if (iOpt == 1) then
      ! Linear
      Bf(iCar,iCent) = -Gx0(iCar,iCent,lIter)
    else if (iOpt == 2) then
      ! Quadratic

      ! When the energy difference becomes small, the true derivative vanishes.
      ! In such case use simply a scaled-down energy difference gradient

      if (abs(E0) > 1.0e-5_wp) then
        Bf(iCar,iCent) = -Two*E0*Gx0(iCar,iCent,lIter)
      else
        Bf(iCar,iCent) = -Two*1.0e-5_wp*Gx0(iCar,iCent,lIter)
      end if
    else if (iOpt == 3) then
      ! Absolute value
      Bf(iCar,iCent) = -sign(One,E0)*Gx0(iCar,iCent,lIter)
    end if

    Bf(iCar,iCent) = Fact*Bf(iCar,iCent)
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('ConInt: Bf',' ',Bf,3,nCent)
#endif
if (lWrite_ .and. (iOpt == 1)) then
  XX = sqrt(DDot_(3*nCent,Bf,1,Bf,1))
  if (XX <= 1.0e-3_wp) then
    write(u6,*)
    write(u6,*) '    Warning: PESs might be parallel!'
    write(u6,*)
  end if
end if

! Compute the cartesian derivative of the B-Matrix.

if (ldB) then
  dBf(:,:) = Zero
  if (iOpt == 1) then
    ! Linear

  else if (iOpt == 2) then
    ! Quadratic

    ix = 0
    do iCent=1,nCent
      do i=1,3
        ix = ix+1

        iy = 0
        do jCent=1,nCent
          do j=1,3
            iy = iy+1
            dBf(ix,iy) = -Two*Gx0(i,iCent,lIter)*Gx0(j,jCent,lIter)
          end do
        end do
      end do
    end do

  else if (iOpt == 3) then
    ! Absolute value

  end if
  !call RecPrt('dBf','(9F9.1)',dBf,3*nCent,3*nCent)

end if

return

end subroutine ConInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine RdInp_MCLR
************************************************************************
*                                                                      *
*     Locate input stream and read commands                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Use Basis_Info, only: Basis_Info_Get
      Use Center_Info, only: Center_Info_Get
      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "Files_mclr.fh"
#include "disp_mclr.fh"
#include "WrkSpc.fh"
#include "negpre.fh"
#include "sa.fh"
      Parameter ( nCom=38 )
      Character*72 Line
      Character*4 Command,ComTab(nCom)
      Character*8 Label
      Character*2 Element(MxAtom)
      Logical     Epsilon_Undef
#include "chomclr.fh"
      Data ComTab/'TITL','DEBU','ROOT','EXTR','PRCI',
     &            'PROR','ITER','THRE','END ','TIME',
     &            'CALC','NOFI','SEWA','NOCO','NOTW',
     %            'SPIN','PRIN','PCGD','RESI','NOTO',
     &            'EXPD','NEGP','LOWM','ELHE','SAVE',
     &            'RASS','DISO','CASI','SALA','NODE',
     &            'ESTE','MOUT','MASS','NAC ','$$$$',
     &            'THER','NEWC','TWOS'/
      Integer iDum(1)
*----------------------------------------------------------------------*
*     Locate "start of input"                                          *
*----------------------------------------------------------------------*
      Call RdNLst(5,'MCLR')
*----------------------------------------------------------------------*
*     Define default values                                            *
*----------------------------------------------------------------------*
      debug=.False.
      Epsilon_Undef=.True.
      Call Basis_Info_Get()
      Call Center_Info_Get()
      Call Get_info_Static()
      istate=1     ! State for which the Lagrangian is calc.
      override=.false.
      If (debug) write(6,*) 'Got info.fh'
      lRoots=-1
      kprint=0
      ngp=.false.
      NoFile=.false.
      mTit=0
      Omega=0.0d0
      elechess=.false.
      TimeDep=.false.
      PrCI=.false.
      nexp_max=100
      CIthrs=0.05d0
      PrOrb=.false.
      SewLab='NONE    '
      Page=.false.
      OEthrs=1.0d0
      ibreak=2
      nIter=200
      RASSI=.false.
      spinpol=.false.
      SA=.false.
      esterr=.false.
      FANCY_PRECONDITIONER=.true.
      newpre=.true.
      save=.false.
      isotop=.true.
      Call lCopy(mxAtm*3+3,[.true.],0,lCalc,1)
      Do i=1,nDisp
       DspVec(i)=i
      End Do
      nmode = 0
      lmass = .false.
      CASINT=.true.
      NACstates(1)=0
      NACstates(2)=0
      NSSA(1)=0
      NSSA(2)=0
      isNAC=.false.
      NewCho=.false.
*Cholesky. Cannot modify it in the input (yet?)
      dmpk=1.0d-2
      Nscreen=10
      Deco=.true.
      Update=.true.
      Estimate=.false.
      TwoStep=.false.
      StepType='xxxx'
*----------------------------------------------------------------------*
*     Read the input stream line by line and identify key command      *
*----------------------------------------------------------------------*
100   Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 100
      Call StdFmt(Line,Command)
      jCom=0
      Do iCom=1,nCom
        If ( Command.eq.ComTab(iCom) ) jCom=iCom
      End Do
      If ( jCom.eq.0 ) Then
         Write (6,'(A,A)') 'RdInp: illegal command:',Command
         Call Abend()
      End If
*----------------------------------------------------------------------*
*     Branch to the processing of the command sections                 *
*----------------------------------------------------------------------*
110   Select Case (jCom)
        Case (1)
          Go to 10
        Case (2)
          Go to 16
        Case (3)
          Go to 20
        Case (4)
          Go to 30
        Case (5)
          Go to 40
        Case (6)
          Go to 50
        Case (7)
          Go to 60
        Case (8)
          Go to 70
        Case (9)
          Go to 99
        Case (10)
          Go to 80
        Case (11)
          Go to 55
        Case (12)
          Go to 175
        Case (13)
          Go to 185
        Case (14)
          Go to 165
        Case (15)
          Go to 166
        Case (16)
          Go to 177
        Case (17)
          Go to 178
        Case (18)
          Go to 179
        Case (19)
          Go to 180
        Case (20)
          Go to 191
        Case (21)
          Go to 192
        Case (22)
          Go to 193
        Case (23)
          Go to 194
        Case (24)
          Go to 195
        Case (25)
          Go to 196
        Case (26)
          Go to 788
        Case (27)
          Go to 789
        Case (28)
          Go to 198
        Case (29)
          Go to 199
        Case (30)
          Go to 200
        Case (31)
          Go to 201
        Case (32)
          Go to 202
        Case (33)
          Go to 203
        Case (34)
          Go to 204
        Case (35)
          Go to 205
        Case (36)
          Go to 206
        Case (37)
          Go to 210
        Case (38)
          Go to 220
      End Select
*---  TITL ------------------------------------------------------------*
10    Continue
15    Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.'*' ) Goto 15
      Call StdFmt(Line,Command)
      jCom=0
      Do iCom=1,nCom
        If ( Command.eq.ComTab(iCom) ) jCom=iCom
      End Do
      If ( jCom.ne.0 ) Goto 110
      mTit=mTit+1
      If ( mTit.le.mxTit ) then
         Read(Line,'(18A4)') (TitleIN(iTit),iTit=(mTit-1)*18+1,mTit*18)
         Goto 15
      End If
      Goto 100
*
*----      ------------------------------------------------------------
788   RASSI=.true.
      If (debug) Write(6,*) 'Output for RASSI'
      goto 100
*----      ------------------------------------------------------------
789   double=.true.    ! Make double isotope substitutions
      goto 100
*---- DEBU ------------------------------------------------------------
16    debug=.true.
      Goto 100
*----      ------------------------------------------------------------
195   elechess=.true.
      If (debug) Write(6,*) 'Electric response'
      goto 100
*---- LOWM ------------------------------------------------------------
194   page=.true.
      If (debug) Write(6,*) 'Page memory'
      goto 100
*----      ------------------------------------------------------------
191   newpre=.false.
      If (debug) Write(6,*) 'New conditioner'
      goto 100
*----      ------------------------------------------------------------
196   SAVE=.TRUE.
      If (debug) Write(6,*) 'old integrals, not supported'
      goto 100
*----      ------------------------------------------------------------
198   CASINT=.true.
      If (debug) Write(6,*) 'CASPT2 integrals'
      goto 100
*---- EXPD ------------------------------------------------------------
192   Read(5,*) nexp_max
      If (debug) Write(6,*) 'Maximum explicit preconditioner',
     &           nexp_max
      goto 100
*----      ------------------------------------------------------------
179   iBreak=1
      Read(5,*) epsilon
      Epsilon_Undef=.False.
      If (debug) Write(6,*) 'Threshold:',epsilon
      Goto 100
*----      ------------------------------------------------------------
180   iBreak=2
      Read(5,*) epsilon
      Epsilon_Undef=.False.
      If (debug) Write(6,*) 'Threshold:',epsilon
      Goto 100
*----      ------------------------------------------------------------
178   Read(5,*) kprint
      If (debug) Write(6,*) 'Print level: ',kprint
      goto 100
*----      ------------------------------------------------------------
193   NGP=.true.
      If (debug) Write (6,*) 'NGP set to true'
      goto 100
*---- SALA ------------------------------------------------------------
199   SA=.true.
      Read(5,*) istate
      override=.true.
      If (debug) Write(6,*) 'Lagrangian for state: ',istate
      goto 100
*----      ------------------------------------------------------------
201   esterr=.true.
      goto 100
*---- NODE ------------------------------------------------------------
200   FANCY_PRECONDITIONER=.false.
      If (debug) Write(6,*) 'Turned of the fancy pcg'
      goto 100
*----      ------------------------------------------------------------
177   SPINPOL=.true.
      ispop=1
      If (debug) Write(6,*) 'RHF lagrangian, not supported'
      goto 100
*----      ------------------------------------------------------------
166   Do i=1,nDisp
       NTPert(i)=iAnd(nTPert(i),247)
      End Do
      Goto 100
*----      ------------------------------------------------------------
165   Do i=1,nDisp
       NTPert(i)=iAnd(nTPert(i),251)
      End Do
      Goto 100
*----      ------------------------------------------------------------

 185  Continue
 186  Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      Call StdFmt(Line,Command)
      If ( Command(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 186
      If (debug) Write(6,*) 'SEWARD INPUT'
      If ( Command(1:4).eq.'END '.or.Command(1:4).eq.'ENDS' ) Goto 100
      Read(Line,'(A8,I2,I2)',Err=998,End=999) SewLab,isym,ip
      iRc=-1
      iOpt=1
      iComp=ip
      iSyLbl=2**isym
      Label=SewLab
      Call iRdOne(iRc,iOpt,Label,iComp,idum,iSyLbl)
      If ( iRc.ne.0 ) Then
         Write (6,*) 'RdInp: Error reading ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend()
      End If
*
*---  read number of symm. species ------------------------------------*
*
      ipp=0
      Do is=isym+1,nsym
       ipp=ipp+ldisp(is)
      end do
      DO id=nDisp,ndisp-ipp+1,-1
       DspVec(id+1)=dspVec(id)
       ntpert(id+1)=ntpert(id)
       lcalc(id+1)=lcalc(id)
      End Do
      id=ndisp-ipp+1
      DspVec(id)=ip
      ldisp(isym)=ldisp(isym)+1
      ndisp=ndisp+1
      ntpert(id)=2
      lcalc(id)=.true.
      SwLbl(id)=SewLab
      goto 185

 175  Nofile=.true.
      If (debug) Write(6,*) 'NOFILE      '
      Goto 100

*---  Process the "root" input card -----------------------------------*
20    Continue
25    Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 25
      Read(Line,*,Err=998,End=999) lRoots
      If (debug) Write(6,*) 'LROOT'
      Goto 100
*
*---  CALC ------------------------------------------------------------*
55    Continue
      Write (6,*) 'CALC is disabled!'
      Goto 100
*---  Process the "extract" input card --------------------------------*
30    Write (6,*) 'RdInp: EXTRACT option is redundant and is ignored!'
      Goto 100
*---  Process the "PrCI" input card -----------------------------------*
40    Continue
      PrCI=.true.
45    Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 45
      Read(Line,*,Err=998,End=999) CIthrs
      Goto 100
*---  Process the "PrOr" input card -----------------------------------*
50    Continue
      PrOrb=.true.
      Goto 100
*---  Process the "ITER" input card -----------------------------------*
60     Continue
65    Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 65
      Read(Line,*,Err=998,End=999) nIter
      Goto 100
*---  Process the "THRE" input card -----------------------------------*
70    Continue
75    Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 75
      Read(Line,*,Err=998,End=999) epsilon
      Epsilon_Undef=.False.
      Goto 100
*---  Process the "TIME" input card -----------------------------------*
80    Continue
      Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 80
      Read(Line,*,Err=998,End=999) Omega
      TimeDep=.true.
      nIter=100
      Goto 100
*---  Process the "MOUT" input card -----------------------------------*
202   Continue
      Write (6,*) 'MOUT is disabled!'
      Goto 100
*---  Process the "MASS" input card -----------------------------------*
203   Continue
      lmass = .true.
      iMass = 0
      Call Get_Name_All(Element)
*
*     Find out how many different elements are present in the molecule.
*
      Do i = 1, nAtoms
         If (Element(i).ne.'  ') iMass = iMass + 1
         Do j = i+1, nAtoms
            If (Element(j).eq.Element(i)) Element(j)='  '
         End Do
      End Do
      Do i=1,iMass
         Read(5,'(A3)')    cmass(i)
         Read(5,'(F15.8)') umass(i)
      End Do
*
*     Put the Info on the run file.

      Call Put_iScalar('iMass',iMass)
      Call Put_cArray('cmass',cmass(1),3*iMass)
      Call Put_dArray('umass',umass,iMass)
*
      Goto 100
*---  Process the "NAC " input card -----------------------------------*
204   Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If ( Line(1:1).eq.' ' .or. Line(1:1).eq.'*' ) Goto 25
      Read(Line,*,Err=998,End=999) NACstates(1),NACstates(2)
      isNAC=.true.
      override=.true.
      If (debug) Write(6,*) 'Non-adiabatic couplings for states: ',
     &           NACstates(1),NACstates(2)
      Goto 100
*---  Process the "$$$$" input card -----------------------------------*
205   continue
*     not used
      Goto 100
*---  Process the "THERmochemistry input card -------------------------*
206   Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If (Line(1:1).eq.'*' ) Goto 206
      Read(Line,*,Err=998,End=999) nsRot
2060  Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If (Line(1:1).eq.'*' ) Goto 2060
      Read(Line,*,Err=998,End=999) UserP
2061  Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      If (Line(1:1).eq.'*' ) Goto 2061
      Call UpCase(Line)
      If (Line(1:4).eq.'END ') then
         If (nUserPT.EQ.0) then
           nUserPT=1
           UserT(1)=298.15d0
         EndIf
         GoTo 100
      EndIf
      nUserPT=nUserPT+1
      Read(Line,*,Err=998,End=999) UserT(nUserPT)
      Goto 2061
*---  Process the "NEWCho input card ----------------------------------*
210   NewCho=.True.
      Goto 100
*---  Process the "TWOStep" input card --------------------------------*
220   Read(5,'(A)',Err=998,End=999) Line
      Call LeftAd(Line)
      Call UpCase(Line)
      If (Line(1:1).eq.'*' ) Goto 220
      Read(Line,*,Err=998,End=999) StepType
      If (debug) Write(6,*) 'TWOSTEP kind: '//StepType
      If((StepType(1:4).ne.'FIRS').and.(StepType(1:4).ne.'SECO').and.
     &   (StepType(1:4).ne.'RUN1').and.(StepType(1:4).ne.'RUN2')) Then
         Call WarningMessage(2,'TWOStep: input error!')
         Call Quit_OnUserError()
      End If
      If (StepType(1:4).eq.'FIRS') then
        StepType(1:4)='RUN1'
      End If
      If (StepType(1:4).eq.'SECO') then
        StepType(1:4)='RUN2'
      End If
      TwoStep=.true.
      If (debug) Write(6,*) 'TWOSTEP kind: '//StepType
      Goto 100
*----------------------------------------------------------------------*
*     "End of input"                                                   *
*----------------------------------------------------------------------*
99    Continue
      Do i=1,3
         isym=irrfnc(2**(i-1))+1
         ipp=0
         Do is=isym+1,nsym
            ipp=ipp+ldisp(is)
         End Do
         Do id=nDisp,ndisp-ipp+1,-1
            DspVec(id+1)=dspVec(id)
            ntpert(id+1)=ntpert(id)
*           lcalc(id+1)=lcalc(id)
            Swlbl(id+1)=Swlbl(id)
         End Do
         id=ndisp-ipp+1
         DspVec(id)=i
         ldisp(isym)=ldisp(isym)+1
         ndisp=ndisp+1
         ntpert(id)=2
*        lcalc(id)=.true.
         write (Swlbl(id),'(a,i2)') 'MLTPL ',1
         iRc=-1
         iOpt=1
         Call iRdOne(iRc,iOpt,swlbl(id),dspvec(id),idum,iSyLbl)
      End Do
*
      If (Timedep) Then
         Do i=1,ndisp
            ntpert(i) = ior(ntpert(i),32)
         End Do
      End if
*
      If (Epsilon_Undef) Then
*        If (SA) Then
*           Epsilon=1.0D-6
*        Else
            Epsilon=1.0D-4
!        This I need to change back
*        End If
      End If
*
      If (debug) Write(6,*) 'FINITO'
*----------------------------------------------------------------------*
*     Normal termination                                               *
*----------------------------------------------------------------------*
*
      Return
*----------------------------------------------------------------------*
*     Error Exit                                                       *
*----------------------------------------------------------------------*
 998  Write (6,*) 'RdInp: Error while reading input'
      Write (6,'(A,A)') 'Last command:',Line
      Call Abend()
999   Write (6,*) 'RdInp: Premature end of input file'
      Write (6,'(A,A)') 'Last command:',Line
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine generate_isotrop_site(nss,nsfs,nexch,gtens_input,riso,D,EoverD,E,M,S)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Three, cZero, cOne
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(inout) :: nss, nsfs, nexch
real(kind=wp), intent(in) :: gtens_input(3), riso(3,3), D, EoverD ! ZFS factors
real(kind=wp), intent(out) :: E(nExch) ! spin-orbit energy states, starting from 0
complex(kind=wp), intent(out) :: M(3,nExch,nExch), S(3,nExch,nExch)
integer(kind=iwp) :: info, l
real(kind=wp) :: RM, RS
complex(kind=wp) :: redme
real(kind=wp), allocatable :: W(:)
complex(kind=wp), allocatable :: HZFS(:,:), MTMP(:,:,:), S2(:,:), STMP(:,:,:), SX2(:,:), SY2(:,:), SZ2(:,:), tmp(:,:), tmp2(:,:), &
                                 Z(:,:)
real(kind=wp), external :: dznrm2_
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, j
real(kind=wp) :: g(3), gtens(3), ma(3,3), maxes(3,3)
real(kind=wp), external :: dnrm2_
#endif
!----------------------------------------------------------------------|

nsfs = 1
nss = nexch

#ifdef _DEBUGPRINT_
write(u6,*) 'GENERATE_SITE:  nss   = ',nss
write(u6,*) 'GENERATE_SITE:  nsfs  = ',nsfs
write(u6,*) 'GENERATE_SITE:  gfact = ',(gtens_input(l),l=1,3)
write(u6,*) 'GENERATE_SITE:  EoverD= ',EoverD
write(u6,*) 'GENERATE_SITE:  D     = ',D
write(u6,*) 'GENERATE_SITE:  riso  = ',((riso(i,j),i=1,3),j=1,3)
#endif

E(:) = Zero
S(:,:,:) = cZero
M(:,:,:) = cZero

if (nss >= 2) then
  call mma_allocate(tmp,nss,nss,'tmp')
  call mma_allocate(tmp2,nss,nss,'tmp2')
  call ESO(nss,1,1,tmp,tmp2,redME)
  S(1,:,:) = tmp(:,:)
  S(2,:,:) = tmp2(:,:)
  call ESO(nss,1,0,tmp,tmp2,redME)
  S(3,:,:) = tmp(:,:)
  call mma_deallocate(tmp2)
  M(1,:,:) = -gtens_input(1)*S(1,:,:)
  M(2,:,:) = -gtens_input(2)*S(2,:,:)
  M(3,:,:) = -gtens_input(3)*S(3,:,:)

# ifdef _DEBUGPRINT_
  call prmom('GENERATE_SITE:     SPIN MOMENT:',S,nss)
  call prmom('GENERATE_SITE: MAGNETIC MOMENT:',M,nss)
# endif

  RM = dznrm2_(3*nss*nss,M,1)
  RS = dznrm2_(3*nss*nss,S,1)
# ifdef _DEBUGPRINT_
  write(u6,'(A,2ES22.14)') 'Norms of M and S:',RM,RS
# endif

  if ((RM > Zero) .and. (RS > Zero)) then
    ! rotate the spin and magnetic moment to the general coordinate system:
    call mma_allocate(MTMP,3,nExch,nExch,'MTMP')
    call mma_allocate(STMP,3,nExch,nExch,'STMP')
    call mma_allocate(Z,nExch,nExch,'Z')

    MTMP(:,:,:) = M(:,:,:)
    STMP(:,:,:) = S(:,:,:)
    Z(:,:) = Zero

#   ifdef _DEBUGPRINT_
    write(u6,'(A,ES20.10)') 'GENERATE_SITE: Norm of riso:',dnrm2_(9,riso,1)
#   endif

    call rotmom(STMP,nExch,riso,S)
    call rotmom(MTMP,nExch,riso,M)

#   ifdef _DEBUGPRINT_
    gtens(:) = Zero
    maxes(:,:) = Zero
    call atens(M,nExch,gtens,maxes,2)
#   endif

    if (abs(D) > Zero) then
      ! compute the ZFS
      call mma_allocate(HZFS,nExch,nExch,'HZFS')
      call mma_allocate(SX2,nExch,nExch,'SX2')
      call mma_allocate(SY2,nExch,nExch,'SY2')
      call mma_allocate(SZ2,nExch,nExch,'SZ2')
      call mma_allocate(S2,nExch,nExch,'S2')
      call mma_allocate(W,nExch,'W')

      W(:) = Zero

      call mma_allocate(tmp2,nEXCH,nEXCH,label='tmp2')
      tmp2(:,:) = S(1,:,:)
      call zgemm_('C','N',nEXCH,nEXCH,nEXCH,cOne,tmp2,nEXCH,tmp2,nEXCH,cZero,SX2,nEXCH)
      tmp2(:,:) = S(2,:,:)
      call zgemm_('C','N',nEXCH,nEXCH,nEXCH,cOne,tmp2,nEXCH,tmp2,nEXCH,cZero,SY2,nEXCH)
      tmp2(:,:) = S(3,:,:)
      call zgemm_('C','N',nEXCH,nEXCH,nEXCH,cOne,tmp2,nEXCH,tmp2,nEXCH,cZero,SZ2,nEXCH)

      S2(:,:) = SX2(:,:)+SY2(:,:)+SZ2(:,:)

#     ifdef _DEBUGPRINT_
      call pa_prMat('GENERATE_SITE: SX2',SX2,nexch)
      call pa_prMat('GENERATE_SITE: SY2',SY2,nexch)
      call pa_prMat('GENERATE_SITE: SZ2',SZ2,nexch)
      call pa_prMat('GENERATE_SITE: S2 ',S2,nexch)
#     endif

      HZFS(:,:) = D*(SZ2(:,:)-S2(:,:)/Three)+D*EoverD*(SX2(:,:)-SY2(:,:))

#     ifdef _DEBUGPRINT_
      call print_ZFS('GENERATE_SITE: ZFS matrix:',HZFS,nExch)
#     endif

      info = 0
      call diag_c2(HZFS,nExch,info,W,Z)

      E(:) = W(:)-W(1)
#     ifdef _DEBUGPRINT_
      do i=1,nExch
        write(u6,'(A,i2,A,F14.8)') 'ZFS  E(',i,') = ',E(i)
      end do
#     endif
      ! rotate the spin and magnetic moment:

      do L=1,3
        tmp2(:,:) = M(L,:,:)
        call zgemm_('C','N',nEXCH,nEXCH,nEXCH,cOne,Z,nEXCH,tmp2,nEXCH,cZero,TMP,nEXCH)
        call zgemm_('N','N',nEXCH,nEXCH,nEXCH,cOne,TMP,nEXCH,Z,nEXCH,cZero,tmp2,nEXCH)
        M(L,:,:) = tmp2(:,:)

        tmp2(:,:) = S(L,:,:)
        call zgemm_('C','N',nEXCH,nEXCH,nEXCH,cOne,Z,nEXCH,tmp2,nEXCH,cZero,TMP,nEXCH)
        call zgemm_('N','N',nEXCH,nEXCH,nEXCH,cOne,TMP,nEXCH,Z,nEXCH,cZero,tmp2,nEXCH)
        S(L,:,:) = tmp2(:,:)
      end do  ! L

      call mma_deallocate(SX2)
      call mma_deallocate(SY2)
      call mma_deallocate(SZ2)
      call mma_deallocate(S2)
      call mma_deallocate(W)
      call mma_deallocate(HZFS)
      call mma_deallocate(tmp2)
    end if ! ZFS is defined

    call mma_deallocate(MTMP)
    call mma_deallocate(STMP)
    call mma_deallocate(Z)
  end if ! dznrm2_ M and S
  call mma_deallocate(tmp)

# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'g tensor at the end of GENERATE_SPIN'
  g(:) = Zero
  ma(:,:) = Zero
  call atens(M,nExch,g,ma,2)
# endif
end if ! nss>=2

return

end subroutine generate_isotrop_site

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Christian Ander                                  *
************************************************************************
      Subroutine ts_bfgs(dq,y,gi,H,nH)
      Implicit None
*     Hessian update method; TS-BFGS ; Bofill - "Remarks on the
*     Updated Hessian Matrix Methods" 2003.
*
*     Vectors in the article are column vectors.
*
*     Implemented by Christian Ander, 2005, christian@eximius.se
*                                                                      *
************************************************************************
*                                                                      *
*     gi    :  gradient                   (nH)
*     dq    :  Perturbation Geometry      (nH)
*     y     :  Difference in Gradient     (nH)
*     WorkM :  Temporary working matrix   (nH,nH)
*     WorkV :  Temporary working vector   (nH)
*     WorkR :  Temporary working variable (real*8)
*     H     :  Hessian                    (nH,nH)
*     nH    :  Hessian size               (integer)
*     f,a,b :  Multi-used variables       (real*8)
*     v,u   :  Multi-used vectors         (nH)
*
#include "real.fh"
#include "stdalloc.fh"
      Integer nH, i, j
      Real*8 H(nH,nH), dq(nH), y(nH), gi(nH)
      Real*8 a, b, f, WorkR, ddot_
      Real*8, Dimension(:,:), Allocatable :: WorkM
      Real*8, Dimension(:), Allocatable :: WorkV, v, u
*
      Call mma_allocate(WorkM,nH,nH,label="WorkM")
      Call mma_allocate(WorkV,nH,label="WorkV")
      Call mma_allocate(v,nH,label="v")
      Call mma_allocate(u,nH,label="u")
*                                                                      *
************************************************************************
*                                                                      *
*     Equation 23 calculates the new Hessian, some simplifications :
*
*     H_k+1 = H_k + 1/f (v*u^T + u*v^T - (y^T*dq - dq^T*B*dq)/f * u*u^T)
*
*     Where f = (y^T*dq)^2 + (dq^T|B|dq)^2 = a^2 + b^2
*     ,     u = y^T*dq*y + (dq^T|B|dq)|B|dq = a*y + b|B|dq
*     and   v = y - B*dq (quasi-Newton condition)
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
*     Make a comment in logfile
      write(6,*) 'hello from ts_bfgs.f'
#endif
*
*---- Calculation of u = y^T*dq*y + (dq^T|B|dq)|B|dq
*
*     a = y^T * dq
*
      a = DDot_(nH,y,1,dq,1)
*
*     u = y^T*dq*y = a * y
*
      call dcopy_(nH,y,1,u,1)
      Call DScal_(nH,a,u,1)
*
*     WorkM = |B|
*
      Do j = 1,nH
         Do i = 1,nH
            WorkM(i,j) = Abs(H(i,j))
         End Do
      End Do
*
*     WorkV = |B|dq
*
      Call dGeMV_('N',nH,nH,
     &           One,WorkM,nH,
     &           dq,1,
     &           Zero,WorkV,1)
*
*     b = (dq^T|B|dq) = dq^T * WorkV
*
      b = DDot_(nH,dq,1,WorkV,1)
*
*     u = y^T*dq*y + (dq^T|B|dq)|B|dq = u + b * WorkV
*
      Call DaxPy_(nH,b,WorkV,1,u,1)
*
*---- Calculation of f = (y^T*dq)^2 + (dq^T|B|dq)^2 = a^2 + b^2
*
      f = a**2 + b**2
*
*---- Calculation of v = y - B * dq (quasi-Newton condition)
*
      call dcopy_(nH,y,1,v,1)
      Call dGeMV_('N',nH,nH,
     &           -One,H,nH,
     &           dq,1,
     &           One,v,1)
*
*---- Calculation of equation 23, the new Hessian
*
*     H_k+1 = H_k + 1/f (v*u^T + u*v^T - (a - dq^T*B*dq)/f * u*u^T)
*
*     WorkM = u*u^T
*
      Call DGEMM_('N','N',
     &            nH,nH,1,
     &            One,u,nH,
     &            u,1,
     &            Zero,WorkM,nH)
*
*     WorkV = dq^T*B
*
      Call DGEMM_('N','N',
     &            1,nH,nH,
     &            One,dq,1,
     &            H,nH,
     &            Zero,WorkV,1)
*
*     WorkR = (a - dq^T*B*dq)/f = (a - WorkV * dq) / f
*
      WorkR = (a - DDot_(nH,WorkV,1,dq,1)) / f
*
*     H_k+1 = H_k + 1/f ( v*u^T + u*v^T - (a - dq^T*B*dq)/f * u*u^T ) =
*             H_k + 1/f ( v*u^T + u*v^T - WorkR * WorkM )
*
      Do j = 1,nH
         Do i = 1,nH
            H(i,j) = H(i,j) + One/f * ( v(j)*u(i) + u(j)*v(i) -
     &               WorkR * WorkM(i,j) )
         End Do
      End Do
#ifdef _DEBUGPRINT_
*
*     Checking the quasi-Newton condition.
*
*     WorkV = H * dq
*
      Call dGeMV_('N',nH,nH,
     &           One,H,nH,
     &           dq,1,
     &           Zero,WorkV,1)
*
*     WorkV = WorkV - y = 0.00
*
      Call DaxPy_(nH,-One,y,1,WorkV,1)
      Call RecPrt('quasi-Newton',' ',WorkV,1,nH)
*
      write(6,*) 'good-bye from ts_bfgs.f'
#endif
*
      Call mma_deallocate(WorkM)
      Call mma_deallocate(WorkV)
      Call mma_deallocate(v)
      Call mma_deallocate(u)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(gi)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! p-p (pi), normal case.
function CoulTN_5(RA,RB,C,dSepInv,ExpA,ExpB)

use Constants, only: One, Two, Three, Five, Eight, Nine
use Definitions, only: wp

implicit none
real(kind=wp) :: CoulTN_5
real(kind=wp), intent(in) :: RA, RB, C, dSepInv, ExpA, ExpB
real(kind=wp) :: T1, T2, T3, TA, TB

T1 = (One/16.0_wp)*(Eight+Nine*C+Three*C**2)*(One+Two*RA)
T2 = (One/Eight)*(Five+Three*C)*RA**2
T3 = (One/Eight)*RA**3
TA = (One-C)**3*(T1+T2+T3)*ExpA
T1 = (One/16.0_wp)*(Eight-Nine*C+Three*C**2)*(One+Two*RB)
T2 = (One/Eight)*(Five-Three*C)*RB**2
T3 = (One/Eight)*RB**3
TB = (One+C)**3*(T1+T2+T3)*ExpB
CoulTN_5 = dSepInv**3*(One-TA-TB)

return

end function CoulTN_5

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_mv0v1a3u(rowa,cola,ddx,ddy,nopi,nopj,incx,incy,a,x,y)
! Y(iy) = Y(iy) + A * X(ix)

use CCT3_global, only: mhkey
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: rowa, cola, ddx, ddy, nopi, nopj, incx, incy
real(kind=wp), intent(in) :: a(rowa,cola), x(ddx)
real(kind=wp), intent(inout) :: y(ddy)
integer(kind=iwp) :: i, ix, iy, j

if (mhkey == 1) then
  ! ESSL
  !call dgemx(nopi,nopj,One,a,rowa,x,incx,y,incy)
  call dgemv_('N',nopi,nopj,One,a,rowa,x,incx,One,y,incy)

else
  ! Fortran matrix handling

  if ((incx == 1) .and. (incy == 1)) then

    ! Inc's = 1

    do j=1,nopj
      y(1:nopi) = y(1:nopi)+a(1:nopi,j)*x(j)
    end do

  else

    ! Other type inc's

    ix = 1
    do j=1,nopj
      iy = 1
      do i=1,nopi
        y(iy) = y(iy)+a(i,j)*x(ix)
        iy = iy+incy
      end do
      ix = ix+incx
    end do

  end if

end if

return

end subroutine cct3_mv0v1a3u

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine o123b_cvb(nparm,
     >  dxnrm,grdnrm,close2conv)
      implicit real*8 (a-h,o-z)
      logical close2conv
#include "malloc_cvb.fh"
#include "opt2_cvb.fh"

      call o123b2_cvb(nparm,
     >  w(ix(1)),w(ix(3)),w(ix(4)),w(ix(5)),w(ix(6)),w(ix(7)),
     >  dxnrm)
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real(grdnrm)
        call Unused_logical(close2conv)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine COMP(I,LJ,ITYP,L,IT1,IT2)

use guga_global, only: COUP, IADD10, ICASE, ICOUP, ICOUP1, IOUT, IRC, IV0, IWAY, IX, J2, JNDX, JRC, LN, Lu_10, NBUF, NMAT
use guga_util_global, only: COP, ICOP1, nCOP
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: I, LJ, ITYP, L, IT1, IT2
integer(kind=iwp) :: IC1, IC2, II1, IN_, IND, ISTOP, ITAIL, IVL, IVL0, IVV, JJ, JJD, JND1, JND2, JOJ, KM
real(kind=wp) :: FAC
logical(kind=iwp) :: first
integer(kind=iwp), external :: ICUNP

if (IT1 /= IT2) then
  write(u6,*) 'Comp: IT1 /= IT2'
  write(u6,*) 'IT1,IT2=',IT1,IT2
  write(u6,*) 'ITYP,L=',ITYP,L
  call Abend()
end if
FAC = One
KM = I
first = .true.
do
  if (first) then
    KM = KM-1
    if (KM /= 0) IWAY(KM) = 1
    first = .false.
  end if
  if (KM /= 0) then
    call PATH(KM,ISTOP,IT1,IT2)
    if (ISTOP == 0) then
      first = .true.
      cycle
    end if
    KM = KM+1
    if (KM == I) exit
  else
    IVL = J2(1)
    ITAIL = IX(IT1+LJ)
    IVV = IV0-IVL
    if (IVV == 0) then
      JJ = 0
      JJD = 0
    else
      JJ = IRC(IVV)
      JJD = JRC(IVV)
    end if
    do IN_=1,ITAIL
      IC1 = ICOUP(1)+IN_
      IC2 = ICOUP1(1)+IN_
      JND1 = JNDX(JJ+IC1)
      if (JND1 == 0) cycle
      if (ITYP == 1) then
        II1 = (JND1-1)*LN+L
        JOJ = ICUNP(ICASE,II1)
        if (JOJ > 1) JOJ = JOJ-1
        FAC = JOJ
        if (JOJ == 0) cycle
      end if
      IC1 = JND1-JJD
      JND2 = JNDX(JJ+IC2)
      if (JND2 == 0) cycle
      IC2 = JND2-JJD
      IOUT = IOUT+1
      IVL0 = IV0-IVL
      !IND = IVL0+2**6*IC2
      !ICOP1(IOUT) = IND+2**19*IC1
      IND = ior(IVL0,ishft(IC2,6))
      ICOP1(IOUT) = ior(IND,ishft(IC1,19))

      COP(IOUT) = FAC*COUP(I)
      if (IOUT < NBUF) cycle
      ICOP1(nCOP+1) = NBUF
      call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT = NMAT+NBUF
      IOUT = 0
    end do
    if (I == 1) exit
    KM = 1
  end if
end do

return

end subroutine COMP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SXTYP(NSXTP,ITP,JTP,LEL1,LEL3,REL1,REL3)
! Types of creation and annihilation  operators so
! <L!a+ a!R> is nonvanishing
!
! L is defined by LEL1,LEL3
! R is defined by REL1,REL3

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(out) :: NSXTP, ITP(3), JTP(3)
integer(kind=iwp), intent(in) :: LEL1, LEL3, REL1, REL3
integer(kind=iwp) :: I1, I123, I3, IJ1, IJ3, J123
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I
#endif

NSXTP = 0

! To get rid of annoying and incorrect compiler warnings
I1 = 0
I3 = 0
IJ1 = 0
IJ3 = 0

do I123=1,3
  if (I123 == 1) then
    I1 = 1
    I3 = 0
  else if (I123 == 2) then
    I1 = 0
    I3 = 0
  else if (I123 == 3) then
    I1 = 0
    I3 = 1
  end if
  if (LEL1-I1 < 0) cycle
  if (LEL3-I3 < 0) cycle
  do J123=1,3
    if (J123 == 1) then
      IJ1 = I1-1
      IJ3 = I3
    else if (J123 == 2) then
      IJ1 = I1
      IJ3 = I3
    else if (J123 == 3) then
      IJ1 = I1
      IJ3 = I3-1
    end if
    if ((REL1+IJ1 == LEL1) .and. (REL3+IJ3 == LEL3)) then
      NSXTP = NSXTP+1
      ITP(NSXTP) = I123
      JTP(NSXTP) = J123
    end if
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,'(A,4I4)') ' SX  connecting LEL1,LEL3,REL1,REL3 ',LEL1,LEL3,REL1,REL3
write(u6,*) ' Number of connections obtained ',NSXTP
write(u6,*) ' ITYPE JTYPE'
write(u6,*) ' ==========='
do I=1,NSXTP
  write(u6,'(2I5)') ITP(I),JTP(I)
end do
#endif

return

end subroutine SXTYP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine make_cvb(chr)
      implicit real*8 (a-h,o-z)
      character*(*) chr
#include "make_cvb.fh"

50    iobj=0
      do 100 i=1,nobj
      if(charobj(i).eq.chr)iobj=i
100   continue
      if(iobj.eq.0)then
        if(mustdeclare)then
          write(6,*)' Make object not found :',chr
          call abend_cvb()
        endif
        call decl_cvb(chr)
        goto 50
      endif

c  Make sure all "parent" objects are up-to-date :
200   mkobj=iobj
300   continue
      do 400 i=ioffs(mkobj)+1,ioffs(mkobj+1)
      if(.not.up2date(i_dep_on_j(i)))then
        mkobj=i_dep_on_j(i)
        goto 300
      endif
400   continue
      if(.not.up2date(mkobj))then
        if(iprint.ge.1)
     >    write(6,'(/,a,i3,2a)')' Making object no.',mkobj,', name : ',
     >    charobj(mkobj)
        call rules_cvb(charobj(mkobj))
        up2date(mkobj)=.true.
      endif
      if(mkobj.ne.iobj)goto 200
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_VecBuf_Init_X(Frac,LocDbg)
!
! Purpose: allocate and initialize vector buffer.
!          (External run mode.)

use Cholesky, only: CHVBUF, ip_CHVBUF_SYM, l_CHVBUF_SYM, LuPri, nSym, NumCho
use stdalloc, only: mma_allocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Frac
logical(kind=iwp), intent(in) :: LocDbg
integer(kind=iwp), parameter :: lScr = 1
integer(kind=iwp) :: i, iRedC, iSym, jNum, l_ChVBuf = 0, l_Max, Left, mUsed, nErr
real(kind=wp) :: Byte, Diff, Scr(lScr)
logical(kind=iwp) :: DoRead
character(len=2) :: Unt
real(kind=wp), parameter :: Scr_Check = 1.23456789_wp, Tol = 1.0e-15_wp
character(len=*), parameter :: SecNam = 'Cho_VecBuf_Init_X'

if (LocDbg) then
  Scr(:) = Scr_Check
  write(Lupri,*) '>>>>> Enter ',SecNam,' <<<<<'
  write(Lupri,*) 'Memory fraction requested for buffer: ',Frac
  write(Lupri,'(A,I8)') 'nSym: ',nSym
  call XFlush(Lupri)
end if

if ((nSym < 1) .or. (nSym > 8)) call Cho_Quit('nSym out of bounds in '//SecNam,102)

if ((Frac <= Zero) .or. (Frac > One)) then
  l_ChvBuf_Sym(1:nSym) = 0
  ip_ChvBuf_Sym(1:nSym) = 0
else
  call mma_maxDBLE(l_max)
  Left = int(Frac*real(l_Max,kind=wp))
  iRedC = -1
  DoRead = .false.
  do iSym=1,nSym
    jNum = 0
    mUsed = 0
    call Cho_VecRd1(Scr,Left,1,NumCho(iSym),iSym,jNum,iRedC,mUsed,DoRead)
    Left = Left-mUsed
    l_ChVBuf_Sym(iSym) = mUsed
  end do
  l_ChVBuf = sum(l_ChVBuf_Sym(1:nSym))
  if (l_ChVBuf < 1) then
    l_ChVBuf = 0
    l_ChvBuf_Sym(1:nSym) = 0
    ip_ChvBuf_Sym(1:nSym) = 0
  else
    call mma_allocate(CHVBUF,l_ChVBuf,Label='CHVBUF')

    ip_ChVBuf_Sym(1) = 1
    do iSym=2,nSym
      ip_ChVBuf_Sym(iSym) = ip_ChVBuf_Sym(iSym-1)+l_ChVBuf_Sym(iSym-1)
    end do
  end if
end if

if (LocDbg) then
  nErr = 0
  do i=1,lScr
    Diff = Scr(i)-Scr_Check
    if (abs(Diff) > Tol) nErr = nErr+1
  end do
  if (nErr /= 0) call Cho_Quit('Memory boundary error in '//SecNam,101)
  call Cho_Word2Byte(l_ChVBuf,8,Byte,Unt)
  write(Lupri,*) 'Memory allocated for buffer: ',l_ChVBuf,'(',Byte,Unt,')  at ',1
  write(Lupri,'(A,8I8)') 'l_ChVBuf_Sym : ',(l_ChVBuf_Sym(iSym),iSym=1,nSym)
  write(Lupri,'(A,8I8)') 'ip_ChVBuf_Sym: ',(ip_ChVBuf_Sym(iSym),iSym=1,nSym)
  write(Lupri,*) '>>>>> Exit  ',SecNam,' <<<<<'
  call XFlush(Lupri)
end if

end subroutine Cho_VecBuf_Init_X

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine espf_init (natom,nAtQM,ipCord,ipIsMM,ipExt)
      Implicit Real*8 (A-H,O-Z)
*
*     ESPF initialization:
*       natom: number of atoms
*       ipCord: pointer to the atom coordinates
*       ipIsMM: pointer to the "logical" MM or QM array
*       ipExt: pointer to the external potential array
*
#include "espf.fh"
*
*
      Call Get_iScalar('Unique atoms',natom)
      Call GetMem('AtomCoord','Allo','Real',ipCord,3*natom)
      Call Get_dArray('Unique Coordinates',Work(ipCord),3*natom)
      Call GetMem('IsMM for atoms','Allo','Inte',ipIsMM,natom)
      Call MMCount(natom,nAtMM,iWork(ipIsMM))
      nAtQM = natom - nAtMM
      Call GetMem('ExtPot','ALLO','REAL',ipExt,natom*MxExtPotComp)
      call dcopy_(MxExtPotComp*natom,[Zero],0,Work(ipExt),1)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CIDens_TD(iCI,iS,rP,rD)

use ipPage, only: ipin, ipnout, W
use MCLR_Data, only: ipCI, n1Dens, n2Dens, nConf1, NOCSF, XISPSM
use CandS, only: ICSM, ISSM
use input_mclr, only: nCSF, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Index_Functions, only: iTri
use input_mclr, only: ntAsh
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iCI, iS
real(kind=wp), intent(_OUT_) :: rP(*), rD(*)
integer(kind=iwp) :: nC, nConfL, nConfR
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, ijkl, j, k, l
#endif
real(kind=wp), allocatable :: CIL(:), CIR(:), De(:), Pe(:)

! LS = CI
!
! Ok we once more want to hide Jeppe's routines from
! the eyes of the world, so everyone belives that I have done
! all the work.
! If we have spin dependent Hamiltonian we will work with
! SD in all parts of the program, no CSF is necessary,
! otherwise we will do the optimazation in CSF's to increase
! convergence.
!
! Input:
!
! response: true if the density should be used for response
!           calculations
! LS : CI Coeff for left state
! RS : CI Coeff for right state
! iL : Symmetry of left state
! iR : Symmetry of right state
!
!           +       +
! iS=1 E  =a  a  + a  a     ! Singlet operator
!       pq  ap aq   Bp Bq
!
!            +       +
! iS=-1 T  =a  a  - a a     ! Triplet operator
!        pq  ap aq   Bp Bq
!
! Output:
!
!  rP : Two Electron Density
!  rD : One Electron Density

!call ipin(iCI)
!write(u6,*) 'iCI*iCI',ddot_(2*nConf1,W(iCI)%A,1,W(iCI)%A,1)

if (nconf1 == 0) return

call mma_allocate(De,n1Dens,Label='De')
call mma_allocate(Pe,n2Dens,Label='Pe')
rD(1:n1Dens) = Zero
rP(1:n2Dens) = Zero

if (nocsf == 0) then
  nConfL = max(ncsf(iS),nint(xispsm(iS,1)))
  nConfR = max(ncsf(State_SYM),nint(xispsm(STATE_SYM,1)))
  nC = max(nconfL,nconfR)
  call mma_allocate(CIL,nC,Label='CIL')
  call mma_allocate(CIR,nC,Label='CIR')

  ! iCI is as long as ipcid for the timedep case!

  call ipin(iCI)
  call ipin(ipCI)
  call CSF2SD(W(iCI)%A,CIR,iS)
  call CSF2SD(W(ipCI)%A,CIL,State_SYM)

  !write(u6,*) 'ipL*ipL',ddot_(nConfL,CIL,1,CIL,1)
  !write(u6,*) 'ipR*ipR',ddot_(nConfR,CIR,1,CIR,1)
  !call RecPrt('CIL',' ',CIL,nConfL,1)
  !call RecPrt('CIR',' ',CIR,nConfR,1)

  call ipnout(-1)
  icsm = iS
  issm = STATE_SYM

  ! <P|E_pq|0> & <P|e_pqrs|0> -> ipDe & ipP
  ! ipL is the bra side vector
  De(:) = Zero
  Pe(:) = Zero
  call Densi2_mclr(2,De,Pe,CIL,CIR,0,0,0,n1Dens,n2Dens)

  !write(u6,*) 'De*De',ddot_(n1Dens,De,1,De,1)
  !call RecPrt('De',' ',De,n1Dens,1)

  rp(1:n2Dens) = Pe(:)
  rD(1:n1Dens) = De(:)

  !write(u6,*) 'rD*rD',ddot_(n1Dens,rD,1,rD,1)
  !call RecPrt('rD',' ',rD,n1Dens,1)

  call ipin(iCI)
  call ipin(ipCI)
  call CSF2SD(W(iCI)%A(1+nconf1),CIL,iS)
  call CSF2SD(W(ipci)%A,CIR,State_SYM)

  !write(u6,*) 'CIL*CIL',ddot_(nConfL,CIL,1,CIL,1)
  !write(u6,*) 'CIR*CIR',ddot_(nConfR,CIR,1,CIR,1)
  !call RecPrt('CIL',' ',CIL,nConfL,1)
  !call RecPrt('CIR',' ',CIR,nConfR,1)

  call ipnout(-1)
  issm = iS
  icsm = STATE_SYM
  De(:) = Zero
  Pe(:) = Zero
  call Densi2_mclr(2,De,Pe,CIL,CIR,0,0,0,n1Dens,n2Dens)

  !write(u6,*) 'De*De',ddot_(n1Dens,De,1,De,1)
  !Call RecPrt('De',' ',De,n1Dens,1)

  rp(1:n2Dens) = rp(1:n2Dens)-Pe(:)
  rD(1:n1Dens) = rD(1:n1Dens)-De(:)

  !rP(1:n2Dens) = -rP(1:n2Dens)
  !rD(1:n1Dens) = -rD(1:n1Dens)

  !write(u6,*) 'rD*rD',ddot_(n1Dens,rD,1,rD,1)
  !call RecPrt('rD',' ',rD,n1Dens,1)

  call mma_deallocate(CIL)
  call mma_deallocate(CIR)

# ifdef _DEBUGPRINT_
  do i=1,ntash
    do j=1,ntash
      do k=1,ntash
        do l=1,ntash
          ijkl = iTri(ntash*(j-1)+i,k+(l-1)*ntash)
          write(u6,'(I1,I1,I1,I1,F12.6)') i,j,k,l,rp(ijkl)
        end do
      end do
    end do
  end do
# endif
end if

call mma_deallocate(Pe)
call mma_deallocate(De)

end subroutine CIDens_TD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018, Ignacio Fdez. Galvan                             *
************************************************************************
*  Clean_BName
*
*> @brief
*>   Clean a basis function name for printing.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Clean up a basis function name for printing purposes, by removing
*> unneeded zeros and padding.
*>
*> @param[in] BName  Basis function name
*> @param[in] Offset Initial characters not to be touched
*>
*> @return Cleaned basis function name
************************************************************************
      Function Clean_BName(BName,Offset)
      Implicit None
#include "Molcas.fh"
      Character(Len=*), Intent(In) :: BName
      Integer, Intent(In) :: Offset
      Character(Len=LENIN8) :: Clean_BName
      Character(Len=8) :: Clean
      Integer :: i,Err
      Logical :: Cart
*
      Clean=BName(Offset+1:)
* For spherical functions, the 3rd character is a letter
*   (counting s and p as spherical),
* for Cartesian functions, it is a number
      Read(Clean(3:3),'(I1)',IOStat=Err) i
      Cart=(Err.eq.0)
*
      If (Cart) Then
* For Cartesian functions, remove zeros if all indices are below 10,
* and shift everything one space to the right
        If ((Clean(2:2).eq.'0').And.
     &      (Clean(4:4).eq.'0').And.
     &      (Clean(6:6).eq.'0'))
     &     Clean(2:)=Clean(3:3)//Clean(5:5)//Clean(7:7)
        Clean(2:)=Clean(1:)
        Clean(1:1)=' '
      Else
* For spherical functions, remove leading zero in m number,
* replace leading zero in shell number with space,
* replace "*0" tag with a single *
        If (Clean(1:1).eq.'0') Clean(1:1)=' '
        If (Clean(1:2).eq.'*0') Clean(1:2)=' *'
        If (Clean(4:4).eq.'0') Clean(4:)=Clean(5:)
      End If
*
      Clean_BName=BName(1:Offset)//Clean
      Return
*
      End Function Clean_BName

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Roland Lindh                                     *
************************************************************************
      SubRoutine ClsBuf(nDisc,nCore)
************************************************************************
*                                                                      *
*  Object: Close I/O buffer fro semi-direct SCF                        *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*     Author: Roland Lindh, Dept. of Chemical Physics,                 *
*             University of Lund, Sweden. October '98                  *
************************************************************************
      use IOBUF
      Implicit Real*8 (A-H,O-Z)
#include "stdalloc.fh"
*
      If (OnDisk) Call EAFClose(LuTmp)
      If (nCore.ne.0) Call mma_deallocate(Buffer)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nDisc)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine h1_espf(h1,RepNuc,nh1,First,Do_DFT)
! Driver for computing the ESPF one-electron modification
! of the core hamiltonian

use espf_global, only: MxExtPotComp
use Index_Functions, only: nTri_Elem1
use Basis_Info, only: nBas
use Data_Structures, only: Alloc2DArray_Type, Alloc4DArray_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nh1
real(kind=wp), intent(inout) :: h1(nh1), RepNuc
logical(kind=iwp), intent(in) :: First, Do_DFT
integer(kind=iwp) :: iAt, ibla, iGrdTyp, ii, iMlt, iMode, iPL, IPotFl, iQMchg, iRMax, ITkQMMM, jAt, MltOrd, nAtMM, natom, nAtQM, &
                     nChg, nGrdPt, nMult, nSym
real(kind=wp) :: DeltaR, RealDummy, rms2, rms3, rms4, sum1, sum2, sum3, sum4
logical(kind=iwp) :: DoDirect, DoGromacs, DoTinker, DynExtPot, Exists, lMorok, StandAlone, UpdateVMM
character(len=180) :: Line
character(len=10) :: ESPFKey
type(Alloc2DArray_Type) :: Grid
type(Alloc4DArray_Type) :: DGrid
integer(kind=iwp), allocatable :: IsMM(:)
real(kind=wp), allocatable :: B(:), Cord(:,:), Ext(:,:), Mltp(:), OldMltp(:), T(:,:), TT(:,:), TTT(:,:)
integer(kind=iwp), external :: iPrintLevel, IsFreeUnit
character(len=180), external :: Get_Ln

!                                                                      *
!***********************************************************************
!                                                                      *
iPL = iPrintLevel(-1)

RealDummy = Zero

! Recover some ESPF data

StandAlone = .false.
DoTinker = .false.
DoGromacs = .false.
lMorok = .false.
DoDirect = .false.
call F_Inquire('ESPF.DATA',Exists)
if (Exists) then
  IPotFl = IsFreeUnit(1)
  call Molcas_Open(IPotFl,'ESPF.DATA')
  do
    Line = Get_Ln(IPotFl)
    ESPFKey = Line(1:10)
    if (ESPFKey == 'MLTORD    ') then
      call Get_I1(2,MltOrd)
      ibla = 0
      do ii=0,MltOrd
        ibla = ibla+nTri_Elem1(ii)
      end do
      MltOrd = ibla
    else if (ESPFKey == 'IRMAX     ') then
      call Get_I1(2,iRMax)
    else if (ESPFKey == 'DELTAR    ') then
      call Get_F1(2,DeltaR)
    else if (ESPFKey == 'GRIDTYPE  ') then
      call Get_I1(2,iGrdTyp)
    else if (ESPFKey == 'TINKER    ') then
      DoTinker = .true.
    else if (ESPFKey == 'GROMACS   ') then
      DoGromacs = .true.
    else if (ESPFKey == 'LA_MOROK  ') then
      lMorok = .true.
    else if (ESPFKey == 'DIRECT    ') then
      DoDirect = .true.
    else if (ESPFKey == 'MULTIPOLE ') then
      call Get_I1(2,nMult)
      call mma_allocate(OldMltp,nMult,label='OldMltp')
      do iMlt=1,nMult,MltOrd
        Line = Get_Ln(IPotFl)
        call Get_I1(1,iAt)
        call Get_F(2,OldMltp(iMlt),MltOrd)
      end do
    else if (ESPFKey == 'ENDOFESPF ') then
      exit
    end if
  end do
  close(IPotFl)
else
  write(u6,*) 'No ESPF.DATA file. Abort'
  call Quit_OnUserError()
end if

! Is this a fully coupled QM/MM calculation?

DynExtPot = .false.
iMode = 0
if (DoTinker) then
  ITkQMMM = IsFreeUnit(30)
  call Molcas_Open(ITkQMMM,'QMMM')
  Line = ' '
  do while (index(Line,'TheEnd ') == 0)
    Line = Get_Ln(ITkQMMM)
    if (index(Line,'FullCoupling') /= 0) then
      DynExtPot = .true.
      iMode = max(iMode,1)
    else if (index(Line,'MMPolar') /= 0) then
      DynExtPot = .true.
      iMode = max(iMode,2)
    end if
  end do
  close(ITkQMMM)
end if
if (.not. DynExtPot) then
  call mma_deallocate(OldMltp,safe='*')
  return
end if

call Get_iScalar('Unique atoms',natom)
call mma_allocate(Cord,3,natom,label='AtomCoord')
call Get_dArray('Unique Coordinates',Cord,3*natom)
call mma_allocate(IsMM,natom,label='IsMM for atoms')
call mma_allocate(Ext,MxExtPotComp,natom,label='ExtPot')
Ext(:,:) = Zero
call MMCount(natom,nAtMM,IsMM)
nAtQM = natom-nAtMM
nMult = MltOrd*nAtQM

! Compute the grid around the molecule

nGrdPt = 0
call StatusLine('espf: ','Making the grid')
if (iGrdTyp == 1) call MkGrid(natom,Cord,Grid,nGrdPt,iRMax,DeltaR,.false.,IsMM,-iGrdTyp,DGrid,nAtQM)
call MkGrid(natom,Cord,Grid,nGrdPt,iRMax,DeltaR,.false.,IsMM,iGrdTyp,DGrid,nAtQM)

! Compute the cartesian tensor T, TtT^-1, [TtT^-1]Tt
! and B=ExtPot[TtT^-1]Tt
! Tt means the transpose of T

! Warning, at this point ExtPot is not filled (only TTT is needed)

call mma_allocate(T,nMult,nGrdPt,label='CartTensor')
call mma_allocate(TT,nMult,nMult,label='TT')
call mma_allocate(TTT,nGrdPt,nMult,label='TTT')
call mma_allocate(B,nGrdPt,label='ExtPot*TTT')
call InitB(nMult,natom,nAtQM,nGrdPt,Cord,Grid%A,T,TT,TTT,Ext,B,IsMM)

! Read the old MM electrostatic potential (and derivatives) from PotFile

IPotFl = IsFreeUnit(IPotFl)
call Molcas_Open(IPotFl,'ESPF.EXTPOT')
Line = Get_Ln(IPotFl)
call Get_I1(1,nChg)
if (nChg /= 0) then
  write(u6,*) 'ESPF: nChg ne 0 in h1_espf'
  call Abend()
end if
do iAt=1,natom
  Line = Get_Ln(IPotFl)
  call Get_I1(1,jAt)
  call Get_F(2,Ext(:,jAt),MxExtPotComp)
end do
close(IPotFl)

! Compute the quantum atomic multipoles

call mma_allocate(Mltp,nMult,label='ESPFMltp')
call espf_mltp(natom,MltOrd,nMult,nGrdPt,TTT,Mltp,Grid%A,IsMM,Ext,iPL-1,Cord)

! Run Tinker

UpdateVMM = .false.
if (allocated(OldMltp)) then
  sum1 = Zero
  sum2 = Zero
  sum3 = Zero
  sum4 = Zero
  do iMlt=1,nMult,MltOrd
    sum1 = abs(Mltp(iMlt)-OldMltp(iMlt))
    UpdateVMM = UpdateVMM .or. (sum1 > 1.0e-3_wp)
    if (MltOrd == 4) then
      sum2 = sum2+(Mltp(iMlt+1)-OldMltp(iMlt+1))**2
      sum3 = sum3+(Mltp(iMlt+2)-OldMltp(iMlt+2))**2
      sum4 = sum4+(Mltp(iMlt+3)-OldMltp(iMlt+3))**2
    end if
  end do
  rms2 = sqrt(sum2/nMult)
  rms3 = sqrt(sum3/nMult)
  rms4 = sqrt(sum4/nMult)
  if (MltOrd == 4) then
    UpdateVMM = UpdateVMM .or. (rms2 > -1.0e-2_wp)
    UpdateVMM = UpdateVMM .or. (rms3 > -1.0e-2_wp)
    UpdateVMM = UpdateVMM .or. (rms4 > -1.0e-2_wp)
  end if
  call mma_deallocate(OldMltp)
else
  UpdateVMM = .true.
end if
iQMchg = 1
if (First .and. Do_DFT) UpdateVMM = .true.
if (UpdateVMM) call RunTinker(natom,Cord,Mltp,.false.,IsMM,MltOrd,DynExtPot,iQMchg,nAtMM,StandAlone,DoDirect)

! Read the MM electrostatic potential (and derivatives) from PotFile

IPotFl = IsFreeUnit(IPotFl)
call Molcas_Open(IPotFl,'ESPF.EXTPOT')
Line = Get_Ln(IPotFl)
call Get_I1(1,nChg)
if (nChg /= 0) then
  write(u6,*) 'ESPF: nChg ne 0 in h1_espf'
  call Abend()
end if
do iAt=1,natom
  Line = Get_Ln(IPotFl)
  call Get_I1(1,jAt)
  call Get_F(2,Ext(:,jAt),MxExtPotComp)
end do
close(IPotFl)

! Recompute the B matrix

call InitB(nMult,natom,nAtQM,nGrdPt,Cord,Grid%A,T,TT,TTT,Ext,B,IsMM)

! Compute the modification of the core hamiltonian

call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
call StatusLine('espf: ','Computing energy components')
call espf_energy(nBas(0),natom,nGrdPt,Ext,Grid%A,B,h1,nh1,RepNuc,RealDummy,DoTinker,DoGromacs,DynExtPot)

! Save the modified h1 matrix

call Put_Temp('h1    XX',h1,nh1)
call Put_Temp('PotNucXX',[RepNuc],1)
if (.not. DynExtPot) then
  call Put_Temp('h1_raw  ',h1,nh1)
  call Put_Temp('PotNuc00',[RepNuc],1)
end if

! Save data in the ESPF.DATA file

call espf_write(MltOrd,iRMax,DeltaR,iGrdTyp,nGrdPt,DoTinker,DoGromacs,lMorok,Mltp,nMult,IsMM,natom,.false.,.false.,DoDirect)

! The end

call mma_deallocate(T)
call mma_deallocate(TT)
call mma_deallocate(TTT)
call mma_deallocate(B)
call mma_deallocate(Cord)
call mma_deallocate(IsMM)
call mma_deallocate(Ext)
call mma_deallocate(Mltp)
call mma_deallocate(Grid%A)
call mma_deallocate(DGrid%A,safe='*')

return

end subroutine h1_espf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine XT_dMoverdH_single(nss,nTempMagn,nT,nM,Tmin,Tmax,XTexp,eso,T,zJ,Xfield,dM,sM,XT_no_field,tinput,smagn,mem,DoPlot)
! chi*t ----------- the units are cgsemu: [ cm^3*k/mol ]

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Nine, Ten, mBohr, rNAVO
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: nss, nTempMagn, nT, NM, mem
real(kind=wp), intent(in) :: Tmin, Tmax, XTexp(nT+nTempMagn), eso(nss), T(nT+nTempMagn), zJ, Xfield, XT_no_field(nT+nTempMagn)
complex(kind=wp), intent(in) :: dM(3,nss,nss), sM(3,nss,nss)
logical(kind=iwp), intent(in) :: tinput, smagn, doplot
integer(kind=iwp) :: iM, Info, iT, j, jT, mem_local, nDirX, nTempTotal
real(kind=wp) :: dHX(3), dHY(3), dHZ(3), hp, WT(3), Xfield_1, Xfield_2, Xfield_3, Xfield_4, Xfield_5, Xfield_6, Xfield_7, ZT(3,3)
character(len=50) :: label
real(kind=wp), allocatable :: MT1(:,:), MT2(:,:), MT3(:,:), MT4(:,:), MT5(:,:), MT6(:,:), MT7(:,:), ST1(:,:), ST2(:,:), ST3(:,:), &
                              ST4(:,:), ST5(:,:), ST6(:,:), ST7(:,:), WM1(:), WM2(:), WM3(:), WM4(:), WM5(:), WM6(:), WM7(:), &
                              XTM_dMdH(:), XTM_MH(:), XTtens_dMdH(:,:,:), XTtens_MH(:,:,:), ZT1(:), ZT2(:), ZT3(:), ZT4(:), &
                              ZT5(:), ZT6(:), ZT7(:)
real(kind=wp), parameter :: cm3tomB = rNAVO*mBohr/Ten, & ! in cm3 * mol-1 * T
                            THRS = 1.0e-13_wp
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, l
#  define _DBG_ .true.
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: DBG = _DBG_, m_paranoid = .true.
real(kind=wp), external :: dev

#ifndef _DEBUGPRINT_
#include "macros.fh"
unused_var(mem)
#endif

! threshold for convergence of average spin, in case (zJ /= 0)
mem_local = 0

!ccc-------------------------------------------------------cccc
#ifdef _DEBUGPRINT_
write(u6,'(A, 10I5)') '       nss =',nss
write(u6,'(A,   I5)') ' nTempMagn =',nTempMagn
write(u6,'(A,   I5)') '        nT =',nT
write(u6,'(A,   I5)') '        nM =',nM
write(u6,'(A,F12.5)') '      Tmin =',Tmin
write(u6,'(A,F12.5)') '      Tmax =',Tmax
write(u6,'(A,F12.5)') '        zJ =',zJ
write(u6,'(A,F12.5)') '    Xfield =',Xfield
write(u6,'(A,ES12.5)') '      THRS =',THRS
write(u6,*) '     smagn =',smagn
write(u6,*) '    tinput =',tinput
if (tinput) then
  do iT=1,nTempMagn
    write(u6,'(2(A,i3,A,F12.6,2x))') 'T(',iT,')=',T(iT)
  end do
  do iT=1,nT
    jT = iT+nTempMagn
    write(u6,'(2(A,i3,A,F12.6,2x))') 'T(',jT,')=',T(jT),' chiT_exp(',iT,')=',XTexp(jT)
  end do

else
  do iT=1,nT+nTempMagn
    write(u6,'(2(A,i3,A,F12.6,2x))') 'T(',iT,')=',T(iT)
  end do
end if
write(u6,'(A)') 'SPIN-ORBIT ENERGY'
write(u6,'(10F12.5)') (ESO(i),i=1,NSS)
call xFlush(u6)
#endif
!ccc-------------------------------------------------------cccc
write(u6,*)
write(u6,'(A)') repeat('%',95)
write(u6,'(16X,A)') 'CALCULATION OF THE FIELD-DEPENDENT MAGNETIC SUSCEPTIBILITY'
write(u6,'(18X,A)') 'within true (dM/dH) and "experimentalists" (M/H) models'
write(u6,'(A)') repeat('%',95)
write(u6,*)
write(u6,'(2x,A,F10.6,A)') 'Magnetic field strength:',Xfield,' tesla.'
write(u6,'(2x,A,F10.6,A)') 'dM/dH is computed numerically using 7 point stencil formula, with h=0.00001'

if (tinput) then
  write(u6,'(2x,a)') 'Temperature dependence of the magnetic susceptibility and'
  write(u6,'(2x,a)') 'high-field magnetization will be calculated according to '
  write(u6,'(2x,a)') 'experimental values provided by the user in file "chitexp.input".'
else
  write(u6,'(2x,a,i3,a)') 'Temperature dependence of the magnetic susceptibility will be calculated in',nT,' points, '
  write(u6,'(2x,a,f4.1,a,f6.1,a)') 'equally distributed in temperature range ',tmin,' ---',tmax,' K.'
end if
! allocate memory:
call mma_allocate(WM1,nM,'WM1')
call mma_allocate(WM2,nM,'WM2')
call mma_allocate(WM3,nM,'WM3')
call mma_allocate(WM4,nM,'WM4')
call mma_allocate(WM5,nM,'WM5')
call mma_allocate(WM6,nM,'WM6')
call mma_allocate(WM7,nM,'WM7')
mem_local = mem_local+size(WM1)*RtoB
mem_local = mem_local+size(WM2)*RtoB
mem_local = mem_local+size(WM3)*RtoB
mem_local = mem_local+size(WM4)*RtoB
mem_local = mem_local+size(WM5)*RtoB
mem_local = mem_local+size(WM6)*RtoB
mem_local = mem_local+size(WM7)*RtoB

call mma_allocate(ZT1,nT+nTempMagn,'ZT1')
call mma_allocate(ZT2,nT+nTempMagn,'ZT2')
call mma_allocate(ZT3,nT+nTempMagn,'ZT3')
call mma_allocate(ZT4,nT+nTempMagn,'ZT4')
call mma_allocate(ZT5,nT+nTempMagn,'ZT5')
call mma_allocate(ZT6,nT+nTempMagn,'ZT6')
call mma_allocate(ZT7,nT+nTempMagn,'ZT7')
mem_local = mem_local+size(ZT1)*RtoB
mem_local = mem_local+size(ZT2)*RtoB
mem_local = mem_local+size(ZT3)*RtoB
mem_local = mem_local+size(ZT4)*RtoB
mem_local = mem_local+size(ZT5)*RtoB
mem_local = mem_local+size(ZT6)*RtoB
mem_local = mem_local+size(ZT7)*RtoB

call mma_allocate(MT1,3,nT+nTempMagn,'MT0')
call mma_allocate(MT2,3,nT+nTempMagn,'MT1')
call mma_allocate(MT3,3,nT+nTempMagn,'MT3')
call mma_allocate(MT4,3,nT+nTempMagn,'MT4')
call mma_allocate(MT5,3,nT+nTempMagn,'MT5')
call mma_allocate(MT6,3,nT+nTempMagn,'MT6')
call mma_allocate(MT7,3,nT+nTempMagn,'MT7')
mem_local = mem_local+size(MT1)*RtoB
mem_local = mem_local+size(MT2)*RtoB
mem_local = mem_local+size(MT3)*RtoB
mem_local = mem_local+size(MT4)*RtoB
mem_local = mem_local+size(MT5)*RtoB
mem_local = mem_local+size(MT6)*RtoB
mem_local = mem_local+size(MT7)*RtoB

call mma_allocate(ST1,3,nT+nTempMagn,'ST1')
call mma_allocate(ST2,3,nT+nTempMagn,'ST2')
call mma_allocate(ST3,3,nT+nTempMagn,'ST3')
call mma_allocate(ST4,3,nT+nTempMagn,'ST4')
call mma_allocate(ST5,3,nT+nTempMagn,'ST5')
call mma_allocate(ST6,3,nT+nTempMagn,'ST6')
call mma_allocate(ST7,3,nT+nTempMagn,'ST7')
mem_local = mem_local+size(ST1)*RtoB
mem_local = mem_local+size(ST2)*RtoB
mem_local = mem_local+size(ST3)*RtoB
mem_local = mem_local+size(ST4)*RtoB
mem_local = mem_local+size(ST5)*RtoB
mem_local = mem_local+size(ST6)*RtoB
mem_local = mem_local+size(ST7)*RtoB

call mma_allocate(XTM_MH,nT+nTempMagn,'XTM_MH')
call mma_allocate(XTM_dMdH,nT+nTempMagn,'XTM_dMdH')
call mma_allocate(XTtens_MH,3,3,nT+nTempMagn,'XTtens_MH')
call mma_allocate(XTtens_dMdH,3,3,nT+nTempMagn,'XTtens_dMdH')
mem_local = mem_local+size(XTM_MH)*RtoB
mem_local = mem_local+size(XTM_dMdH)*RtoB
mem_local = mem_local+size(XTtens_MH)*RtoB
mem_local = mem_local+size(XTtens_dMdH)*RtoB
#ifdef _DEBUGPRINT_
write(u6,*) 'XTMG:  memory allocated (local):'
write(u6,*) 'mem_local=',mem_local
write(u6,*) 'XTMG:  memory allocated (total):'
write(u6,*) 'mem_total=',mem+mem_local
#endif

nDirX = 3

! field along X
dHX(1) = One
dHY(1) = Zero
dHZ(1) = Zero
! field along Y
dHX(2) = Zero
dHY(2) = One
dHZ(2) = Zero
! field along Z
dHX(3) = Zero
dHY(3) = Zero
dHZ(3) = One

XTtens_MH(:,:,:) = Zero
XTtens_dMdH(:,:,:) = Zero

hp = 0.0001_wp
Xfield_1 = Xfield-Three*hp
Xfield_2 = Xfield-Two*hp
Xfield_3 = Xfield-hp
Xfield_4 = xField
Xfield_5 = Xfield+hp
Xfield_6 = Xfield+Two*hp
Xfield_7 = Xfield+Three*hp
#ifdef _DEBUGPRINT_
write(u6,*) 'XTMG:  Xfield: ',Xfield_1,Xfield_2,Xfield_3,Xfield_4,Xfield_5,Xfield_6,Xfield_7
#endif

nTempTotal = nT+nTempMagn

! ///  opening the loop over different directions of the magnetic field
do iM=1,nDirX

  ! compute magnetization:
  ! seven points numerical field perturbation:
  ! Xfield =XF -3h
  call MAGN(NSS,NM,dHX(iM),dHY(iM),dHZ(iM),XField_1,ESO,zJ,THRS,DM,SM,nTempTotal,T,smagn,WM1,ZT1,ST1,MT1,m_paranoid,DBG)
  ! Xfield =XF -2h
  call MAGN(NSS,NM,dHX(iM),dHY(iM),dHZ(iM),XField_2,ESO,zJ,THRS,DM,SM,nTempTotal,T,smagn,WM2,ZT2,ST2,MT2,m_paranoid,DBG)
  ! Xfield =XF -h
  call MAGN(NSS,NM,dHX(iM),dHY(iM),dHZ(iM),XField_3,ESO,zJ,THRS,DM,SM,nTempTotal,T,smagn,WM3,ZT3,ST3,MT3,m_paranoid,DBG)
  ! Xfield =XF
  call MAGN(NSS,NM,dHX(iM),dHY(iM),dHZ(iM),XField_4,ESO,zJ,THRS,DM,SM,nTempTotal,T,smagn,WM4,ZT4,ST4,MT4,m_paranoid,DBG)
  ! Xfield =XF +h
  call MAGN(NSS,NM,dHX(iM),dHY(iM),dHZ(iM),XField_5,ESO,zJ,THRS,DM,SM,nTempTotal,T,smagn,WM5,ZT5,ST5,MT5,m_paranoid,DBG)
  ! Xfield =XF +2h
  call MAGN(NSS,NM,dHX(iM),dHY(iM),dHZ(iM),XField_6,ESO,zJ,THRS,DM,SM,nTempTotal,T,smagn,WM6,ZT6,ST6,MT6,m_paranoid,DBG)
  ! Xfield =XF +3h
  call MAGN(NSS,NM,dHX(iM),dHY(iM),dHZ(iM),XField_7,ESO,zJ,THRS,DM,SM,nTempTotal,T,smagn,WM7,ZT7,ST7,MT7,m_paranoid,DBG)

# ifdef _DEBUGPRINT_
  do iT=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex1(',iT,')=',(MT1(l,iT),l=1,3)
  end do
  do iT=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex2(',iT,')=',(MT2(l,iT),l=1,3)
  end do
  do iT=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex3(',iT,')=',(MT3(l,iT),l=1,3)
  end do
  do iT=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex4(',iT,')=',(MT4(l,iT),l=1,3)
  end do
  do iT=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex5(',iT,')=',(MT5(l,iT),l=1,3)
  end do
  do iT=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex6(',iT,')=',(MT6(l,iT),l=1,3)
  end do
  do iT=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex7(',iT,')=',(MT7(l,iT),l=1,3)
  end do
  do iT=1,nTempTotal
    write(u6,'(A,i3,A,9ES22.14)') 'Mex 7-1 (',iT,')=',(MT7(l,iT)-MT1(l,iT),l=1,3)
  end do
# endif
  ! computing the AVERAGE MOMENTS calculated at different temperatures (T(i))
  do iT=1,nTempTotal

    ! dM/dH model
    if (iM == 1) then
      XTtens_dMdH(iM,1,iT) = (-MT1(1,iT)+Nine*MT2(1,iT)-45.0_wp*MT3(1,iT)+45.0_wp*MT5(1,iT)-Nine*MT6(1,iT)+MT7(1,iT))*T(iT)* &
                             cm3tomB/(60.0_wp*hp)
    else if (iM == 2) then
      XTtens_dMdH(iM,2,iT) = (-MT1(2,iT)+Nine*MT2(2,iT)-45.0_wp*MT3(2,iT)+45.0_wp*MT5(2,iT)-Nine*MT6(2,iT)+MT7(2,iT))*T(iT)* &
                             cm3tomB/(60.0_wp*hp)
    else if (iM == 3) then
      XTtens_dMdH(iM,3,iT) = (-MT1(3,iT)+Nine*MT2(3,iT)-45.0_wp*MT3(3,iT)+45.0_wp*MT5(3,iT)-Nine*MT6(3,iT)+MT7(3,iT))*T(iT)* &
                             cm3tomB/(60.0_wp*hp)
    end if

    ! M/H model
    if (iM == 1) then
      XTtens_MH(iM,1,iT) = MT4(1,iT)*T(iT)*cm3tomB/Xfield
    else if (iM == 2) then
      XTtens_MH(iM,2,iT) = MT4(2,iT)*T(iT)*cm3tomB/Xfield
    else if (iM == 3) then
      XTtens_MH(iM,3,iT) = MT4(3,iT)*T(iT)*cm3tomB/Xfield
    end if
  end do
! ///  closing the loops over field directions
end do ! iM (nDirX)

! computing the XT as tensor's average:
XTM_dMdH(:) = (XTtens_dMdH(1,1,:)+XTtens_dMdH(2,2,:)+XTtens_dMdH(3,3,:))/Three
XTM_MH(:) = (XTtens_MH(1,1,:)+XTtens_MH(2,2,:)+XTtens_MH(3,3,:))/Three
call Add_Info('T_dMdH            ',T,nTempTotal,5)
call Add_Info('XTM_dMdH          ',XTM_dMdH,nTempTotal,5)
call Add_Info('XTM_MH            ',XTM_MH,nTempTotal,5)

!-----------------------------------------------------------------------
! WRITING SOME OF THE OUTPUT....
!-----------------------------------------------------------------------
write(u6,*)
call xFlush(u6)
write(u6,'(A)') '--------------------------------------------------------------------------|'
write(u6,'(A)') '     |     T      | Statistical |   CHI*T     |   CHI*T     |   CHI*T     |'
write(u6,'(A,F6.3,A,F6.3,A)') '     |            |  Sum (Z)    | H = 0.000 T | H =',Xfield,' T | H =',XField,' T |'
write(u6,'(A)') '     |            |             |             | X = dM/dH   | X = M/H     |'
write(u6,'(A)') '-----|--------------------------------------------------------------------|'
write(u6,'(A)') 'Units|   kelvin   |    ---      |  cm3*K/mol  |  cm3*K/mol  |  cm3*K/mol  |'
write(u6,'(A)') '-----|--------------------------------------------------------------------|'

call xFlush(u6)
do iT=1,nT
  jT = iT+nTempMagn
  write(u6,'(A,F11.6,A,ES12.5,A,F12.8,A,F12.8,A,F12.7,A)') '     |',T(jT),' |',ZT3(jT),' |',XT_no_field(jT),' |',XTM_dMdH(jT), &
                                                           ' |',XTM_MH(jT),' |'
end do
write(u6,'(A)') '-----|--------------------------------------------------------------------|'
call xFlush(u6)

! calcualtion of the standard deviation:
if (tinput) then
  write(u6,'(a,5x, f20.14)') 'ST.DEV: X= dM/dH:',dev(nT,XTM_dMdH(1+nTempMagn:),XTexp(1+nTempMagn:))
  write(u6,'(a,5x, f20.14)') 'ST.DEV: X= M/H:',dev(nT,XTM_MH(1+nTempMagn:),XTexp(1+nTempMagn:))
  write(u6,'(A)') '-----|--------------------------------------------------------------------|'
end if !tinput

!-------------------------  PLOTs -------------------------------------!
write(label,'(A)') 'with_field_M_over_H'
call xFlush(u6)
if (DoPlot) then
  if (tinput) then
    call plot_XT_with_Exp(label,nT,T(1+nTempMagn:),XTM_MH(1+nTempMagn:),XTexp(1+nTempMagn:))
  else
    call plot_XT_no_Exp(label,nT,T(1+nTempMagn:),XTM_MH(nTempMagn:))
  end if
end if

write(label,'(A)') 'with_field_dM_over_dH'
call xFlush(u6)
if (DoPlot) then
  if (tinput) then
    call plot_XT_with_Exp(label,nT,T(1+nTempMagn:),XTM_dMdH(1+nTempMagn:),XTexp(1+nTempMagn:))
  else
    call plot_XT_no_Exp(label,nT,T(1+nTempMagn:),XTM_dMdH(1+nTempMagn:))
  end if
end if
!---------------------- END PLOTs -------------------------------------!

! print out the main VAN VLECK SUSCEPTIBILITY TENSOR, its main values and main axes:
write(u6,'(/)')
write(u6,'(2A)') repeat('-',110),'|'
write(u6,'(25X,A,15x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR FOR the  X=dM/dH  model,  in cm3*K/mol','|'
write(u6,'(2A)') repeat('-',110),'|'
write(u6,'(A)') '     T(K)   |   |          Susceptibility Tensor      |    Main Values  |               Main Axes             |'
do iT=1,nT
  jT = iT+nTempMagn
  info = 0
  call DIAG_R2(XTtens_dMdH(:,:,jT),3,info,wt,zt)
  write(u6,'(A)') '------------|---|------- x --------- y --------- z ---|-----------------|------ x --------- y --------- z ----|'
  write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | x |',(XTtens_dMdH(1,j,jT),j=1,3),' |  X:',wt(1),'|', &
                                                  (zt(j,1),j=1,3),'|'
  write(u6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),'| y |',(XTtens_dMdH(2,j,jT),j=1,3),' |  Y:',wt(2),'|', &
                                                           (zt(j,2),j=1,3),'|'
  write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | z |',(XTtens_dMdH(3,j,jT),j=1,3),' |  Z:',wt(3),'|', &
                                                  (zt(j,3),j=1,3),'|'
end do
write(u6,'(2A)') repeat('-',110),'|'

write(u6,'(/)')
write(u6,'(2A)') repeat('-',110),'|'

write(u6,'(25X,A,15x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR FOR the  X = M/H  model,  in cm3*K/mol','|'
write(u6,'(2A)') repeat('-',110),'|'
write(u6,'(A)') '     T(K)   |   |          Susceptibility Tensor      |    Main Values  |               Main Axes             |'
do iT=1,nT
  jT = iT+nTempMagn
  info = 0
  call DIAG_R2(XTtens_MH(:,:,jT),3,info,wt,zt)
  write(u6,'(A)') '------------|---|------- x --------- y --------- z ---|-----------------|------ x --------- y --------- z ----|'
  write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | x |',(XTtens_MH(1,j,jT),j=1,3),' |  X:',wt(1),'|', &
                                                  (zt(j,1),j=1,3),'|'
  write(u6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),'| y |',(XTtens_MH(2,j,jT),j=1,3),' |  Y:',wt(2),'|', &
                                                           (zt(j,2),j=1,3),'|'
  write(u6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') '            | z |',(XTtens_MH(3,j,jT),j=1,3),' |  Z:',wt(3),'|', &
                                                  (zt(j,3),j=1,3),'|'
end do
write(u6,'(2A)') repeat('-',110),'|'

call mma_deallocate(WM1)
call mma_deallocate(WM2)
call mma_deallocate(WM3)
call mma_deallocate(WM4)
call mma_deallocate(WM5)
call mma_deallocate(WM6)
call mma_deallocate(WM7)

call mma_deallocate(ZT1)
call mma_deallocate(ZT2)
call mma_deallocate(ZT3)
call mma_deallocate(ZT4)
call mma_deallocate(ZT5)
call mma_deallocate(ZT6)
call mma_deallocate(ZT7)

call mma_deallocate(MT1)
call mma_deallocate(MT2)
call mma_deallocate(MT3)
call mma_deallocate(MT4)
call mma_deallocate(MT5)
call mma_deallocate(MT6)
call mma_deallocate(MT7)

call mma_deallocate(ST1)
call mma_deallocate(ST2)
call mma_deallocate(ST3)
call mma_deallocate(ST4)
call mma_deallocate(ST5)
call mma_deallocate(ST6)
call mma_deallocate(ST7)

call mma_deallocate(XTM_MH)
call mma_deallocate(XTM_dMdH)
call mma_deallocate(XTtens_MH)
call mma_deallocate(XTtens_dMdH)

return

end subroutine XT_dMoverdH_single

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

function iDeg(Coor)
!***********************************************************************
!                                                                      *
! Object: to compute the degeneracy of a coordinate.                   *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             March '91                                                *
!***********************************************************************

use Symmetry_Info, only: iOper, nIrrep
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iDeg
real(kind=wp), intent(in) :: Coor(3)
integer(kind=iwp) :: i, j
real(kind=wp) :: Cx(3,8), r(3), x, y, z
logical(kind=iwp) :: New

iDeg = 1
Cx(:,1) = Coor(:)
do i=1,nIrrep-1
  r(:) = One
  if (btest(iOper(i),0)) r(1) = -One
  if (btest(iOper(i),1)) r(2) = -One
  if (btest(iOper(i),2)) r(3) = -One
  x = r(1)*Coor(1)
  y = r(2)*Coor(2)
  z = r(3)*Coor(3)
  New = .true.
  do j=1,iDeg
    if (New .and. (x == Cx(1,j)) .and. (y == Cx(2,j)) .and. (z == Cx(3,j))) New = .false.
  end do
  if (New) then
    iDeg = iDeg+1
    Cx(1,iDeg) = x
    Cx(2,iDeg) = y
    Cx(3,iDeg) = z
  end if
end do

return

end function iDeg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dkh_ham(n,dkord,xord,vord,EL,ES,OL,OS,Ep,E0,dkcof,cc,wr,rw,t1,t2,t3,t4,or,ro,e,rer,or_,ro_,e_,rer_,s1,s2,wsav)
! Evaluate DKH Hamiltonian in moment space

#include "intent.fh"

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
! Input :
!   n       dimension of matrix
!   dkord   order of DKH Hamiltonian
!   xord    order for property integrals
!   vord    actual calculated order satisfy both dkord and xord
!   ( EL OL )
!   ( OS ES ) potential matrix in fpFW space
!   Ep,E0   diagonal kinetic matrix, E0=Ep-c^{2}
!   dkcof   expansion coefficient of unitary transformation in terms of anti-Hermitian matrix W
! Output :
!   EL      overwritten by the transformed Hamiltonian
!   wsav    store W matrices
integer(kind=iwp), intent(in) :: n, dkord, xord, vord
real(kind=wp), intent(inout) :: EL(n,n)
real(kind=wp), intent(in) :: ES(n,n), OL(n,n), OS(n,n), Ep(n), E0(n), dkcof(*)
real(kind=wp), intent(_OUT_) :: cc(*), or(n,n,*), ro(n,n,*), e(n,n,*), rer(n,n,*), or_(n,n,*), ro_(n,n,*), e_(n,n,*), rer_(n,n,*), &
                                s1(n,n,*), s2(n,n,*), wsav(n,n,*)
real(kind=wp), intent(out) :: wr(n,n), rw(n,n), t1(n,n), t2(n,n), t3(n,n), t4(n,n)
integer(kind=iwp) :: i, j, k, ord, cou, ks, ioe
logical(kind=iwp) :: ifodd

! Copy initial matrices

e(:,:,1) = EL(:,:)
rer(:,:,1) = ES(:,:)
or(:,:,1) = OL(:,:)
ro(:,:,1) = OS(:,:)
! counter of total number of matrix multiplications
cou = 0
do ord=1,vord/2
  or_(:,:,1:vord) = Zero
  ro_(:,:,1:vord) = Zero
  e_(:,:,1:vord) = Zero
  rer_(:,:,1:vord) = Zero

  ! Set up W(ord) matrix

  do i=1,n
    do j=1,n
      wr(j,i) = or(j,i,ord)/(Ep(j)+Ep(i))
      rw(j,i) = -ro(j,i,ord)/(Ep(j)+Ep(i))
    end do
  end do
  if (ord <= xord) then
    ! Save W matrix
    wsav(:,:,ord*2-1) = wr(:,:)
    wsav(:,:,ord*2) = rw(:,:)
  end if

  ! Calculate [W(ord)->O(ord)], the terms of W(ord) apply on O(ord)
  !   also include the contributions from [W(ord)->E(0)] via recalculated coefficients

  k = ord
  ifodd = .true.
  t1(:,:) = or(:,:,k)
  t2(:,:) = ro(:,:,k)
  call dkh_wspec(n,ord,vord,ifodd,dkcof,wr,rw,t1,t2,e_,rer_,or_,ro_,cou,s1,s2,t3,t4,cc)

  ! Calculate [W(ord)->E(1-...)/O(ord+1-...)]

  do ks=1,vord
    ! W1 only apply to E1
    !DP if ((ord == 1) .and. (ks >= 2)) cycle
    if ((ord > 1) .or. (ks < 2)) then
      do ioe=1,2
        ! only even operator for k<=ord survived, odd terms were eliminated
        !DP if ((ioe == 1) .and. (ks <= ord)) cycle
        if ((ioe == 2) .or. (ks > ord)) then
          k = ks
          if (ioe == 1) then
            ifodd = .true.
          else
            ifodd = .false.
          end if
          ! copy initial matrix
          if (ifodd) then
            t1(:,:) = or(:,:,k)
            t2(:,:) = ro(:,:,k)
            or_(:,:,k) = or_(:,:,k)+t1(:,:)
            ro_(:,:,k) = ro_(:,:,k)+t2(:,:)
          else
            t1(:,:) = e(:,:,k)
            t2(:,:) = rer(:,:,k)
            e_(:,:,k) = e_(:,:,k)+t1(:,:)
            rer_(:,:,k) = rer_(:,:,k)+t2(:,:)
          end if
          call dkh_wgene(n,ord,k,vord,ifodd,dkcof,wr,rw,t1,t2,e_,rer_,or_,ro_,cou,s1,s2,t3,t4)
        end if
        ! cycle for odd/even operator
      end do
    end if
    ! cycle for ks
  end do
  ! copy
  or(:,:,1:vord) = or_(:,:,1:vord)
  ro(:,:,1:vord) = ro_(:,:,1:vord)
  e(:,:,1:vord) = e_(:,:,1:vord)
  rer(:,:,1:vord) = rer_(:,:,1:vord)
! cycle for ord
end do

! Sum over all k<=dkord terms

EL(:,:) = zERO
do i=1,n
  EL(i,i) = E0(i)
end do
do k=1,dkord
  EL(:,:) = EL(:,:)+e(:,:,k)
end do
!write(u6,*) 'DKH',vord,' Total matmul',cou

return

end subroutine dkh_ham

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_T21(T21,beSGrp,gaSGrp)
! test T2n+

use Index_Functions, only: nTri_Elem
use chcc_global, only: no, nv, Q4, T2c
use Constants, only: Zero, Half, Quart
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: beSGrp, gaSGrp
real(kind=wp), intent(inout) :: T21(nTri_Elem(nv/2-1),nTri_Elem(no-1))
integer(kind=iwp) :: a, b, bad, be, bega, bep, ga, gap, u, uv, v
real(kind=wp) :: s

if (beSGrp == 2) then
  bep = nv/2
else
  bep = 0
end if

if (gaSGrp == 2) then
  gap = nv/2
else
  gap = 0
end if

bad = 0

uv = 0
do u=2,no
  do v=1,u-1
    uv = uv+1

    bega = 0
    do be=2,nv/2
      do ga=1,be-1
        bega = bega+1

        s = Zero
        do a=1,nv
          b = a
          s = s+(Q4(b,gap+ga,a,bep+be)+Q4(b,bep+be,a,gap+ga))*(T2c(b,a,v,u)+T2c(b,a,u,v))*Quart
        end do

        s = Zero
        do a=2,nv
          do b=1,a-1
            s = s+(Q4(b,gap+ga,a,bep+be)-Q4(b,bep+be,a,gap+ga))*(T2c(b,a,v,u)-T2c(b,a,u,v))*Half
          end do
        end do

        if (abs(T21(bega,uv)-s) > 1.0e-10_wp) then
          bad = bad+1
          !write(u6,99) be,ga,u,v
          !99 format(4(i3,1x))
        end if
        T21(bega,uv) = s

      end do
    end do

  end do
end do

if (bad == 0) then
  write(u6,*) ' Chck T2 OK ',bad
else
  write(u6,*) ' Chck T2 Bug !!!!!!! ',bad
end if

return

end subroutine Chck_T21

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine rotorb(cmoo,cmon,c,x,x2,y,thmax,FA)
! RASSCF program: version IBM-3090: SX section
!
! PURPOSE: Calculation of the rotation matrix X from the super-CI
!          coefficient matrix C, formation of exp(x), and rotation
!          of the orbitals with this matrix.
!          These orbitals are used in the next
!          RASSCF iteration as starting orbitals.
!          Called from SXCTL
!
!      ********** IBM-3090 MOLCAS Release: 90 02 22 **********

use Index_Functions, only: nTri_Elem
use gas_data, only: iDoGAS, NGAS, NGSSH
use rasscf_global, only: CMAX, iXSym, PURIFY, ROTMAX
use PrintLevel, only: DEBUG, TERSE, VERBOSE
use output_ras, only: IPRLOC
use general_data, only: NASH, NBAS, NDEL, NFRO, NISH, NORB, NRS1, NRS2, NSSH, NSYM, NTOT2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: cmoo(NTOT2), FA(*)
real(kind=wp), intent(out) :: cmon(NTOT2), THMAX
real(kind=wp), intent(in) :: c(*)
real(kind=wp), intent(_OUT_) :: x(*), x2(*), y(*)
integer(kind=iwp) :: I, IB, ICORE, ICOREGAS(0:4,0:4), IDAMP, IDAMPGAS(0:4,0:4), IGAS, II, IJ, IO, iOff, iOrb, iPrLev, iSpace, IST, &
                     ISTBM, ISTMO, ISTMO1, ISUM, ISYM, jPr, jSPace, MOType, NACI, NACJ, NAE, NAO, NB, NBO, ND, NDB, NEO, NF, NFB, &
                     NI, NIO, NIO1, NJ, NO, NOC, NOC1, NP, NR
real(kind=wp) :: COREGAS(10), DAMPGAS(10), TERM, THM, Xn, XX
logical(kind=iwp) :: iFrzAct
real(kind=wp), allocatable :: SqFA(:), Unt(:)
real(kind=wp), parameter :: ACC = 1.0e-13_wp, Thrs = 1.0e-14_wp

IPRLEV = IPRLOC(4)
if (IPRLEV >= DEBUG) then
  write(u6,*) ' Entering ROTORB'

  write(u6,*)
  write(u6,*) 'FI+FA in RotOrb by Unitary transform'
  write(u6,*) ' --------------'
  write(u6,*)
  iOff = 1
  do iSym=1,nSym
    iOrb = nOrb(iSym)
    call TriPrt(' ',' ',FA(iOff),iOrb)
    iOff = iOff+nTri_Elem(iOrb)
  end do

end if

istbm = 1
istmo1 = 0
ib = 0
rotmax = Zero
cmax = Zero
thmax = Zero
iOff = 1
! A long loop over symmetry
do isym=1,nsym
  no = norb(isym)
  nb = nbas(isym)
  nf = nfro(isym)
  io = ib+nf
  nio = nish(isym)
  nao = nash(isym)
  noc = nio+nao
  neo = nssh(isym)
  nae = nao+neo
  if ((noc == 0) .or. (nae == 0) .or. (nio+neo == 0)) then

    if (IPRLEV >= VERBOSE) write(u6,*) 'No rotations active for symmetry=',isym
    !No rotations active in this symmetry
    !Move orbitals from old to new set

    cmon(istmo1+1:istmo1+nb**2) = cmoo(istmo1+1:istmo1+nb**2)
  else
    istmo = istmo1+nf*nb

    ! Form the quadratic matrix X from the coefficients C

    x(1:no**2) = Zero
    do nr=1,noc
      do np=max(nr+1,nio+1),no
        jpr = no*(nr-1)+np
        !jrp = no*(np-1)+nr
        xx = c(istbm+nr+noc*(np-nio-1))

        ! Any numerical information smaller than Acc is considered
        ! numerical noise and is ignored.

        if (abs(xx) < Acc) cycle

        x(jpr) = xx
        !x(jrp) = -xx
      end do
    end do

    ! Set zero to matrix elements corresponding to orbitals
    ! not allowed to rotate into each other.

    ij = 0
    do ni=1,no
      do nj=1,no
        ij = ij+1
        if (ixsym(ni+io) /= ixsym(nj+io)) x(ij) = Zero
      end do
    end do

    ! Freeze Active orbitals for difficult orbital optimization
    ! This is activated by FRAC keyword in RASSCF module

    iFrzAct = .false.
    if (iFrzAct) then
      ij = 0
      do ni=1,no
        do nj=1,no
          ij = ij+1
          !io = ib+nf ! offset counting all nbas of previous sym and nfro of current sym.
          if ((ni > nio) .and. (ni < nio+nao) .or. (nj > nio) .and. (nj < nio+nao)) x(ij) = Zero
        end do
      end do
    end if

    ! For optimization of the core-hole we want to damp/eliminate
    ! certain rotations to find the local minimum.

    ! Damp/eliminate certain rotations inside RAS/GAS.

    ! Only loop over the active spaces

    IDAMP = 0
    IDAMPGAS = 0
    DAMPGAS = Zero
    ICORE = 0
    ICOREGAS = 0
    COREGAS = 0.1_wp
    !COREGAS(1) = Zero
    !COREGAS(2) = Zero
    ICOREGAS(0,1) = 1
    ICOREGAS(1,0) = 2
    !ICOREGAS(0,2) = 1
    !ICOREGAS(2,0) = 2
    ICOREGAS(2,1) = 3
    ICOREGAS(1,2) = 4
    ICOREGAS(3,1) = 5
    ICOREGAS(1,3) = 6
    ICOREGAS(1,4) = 1
    ICOREGAS(4,1) = 2
    !write(u6,*) 'NOC,NO',NOC,NO
    if ((ICORE == 1) .or. (IDAMP == 1)) then ! New keywords

      IJ = 0
      do NACI=1,NO ! Notice only loop over inactive and active
        if (IDOGAS) then ! Find which GAS this index belong to
          ISPACE = 0
          if (NACI <= NIO) then
            ISPACE = 0
          else if (NACI > NOC) then
            ISPACE = NGAS+1
          else
            ISUM = 0
            do IGAS=1,NGAS
              if ((NGSSH(IGAS,ISYM)+NIO+ISUM) >= NACI) then
                ISPACE = IGAS
                exit
              else
                ISUM = ISUM+NGSSH(IGAS,ISYM)
              end if
            end do
          end if
        else ! Find which RAS this index belong to
          if (NACI <= NIO) then
            ISPACE = 0
          else if (NACI > NOC) then
            ISPACE = 4
          else if ((NRS1(ISYM)+NIO) >= NACI) then
            ISPACE = 1
          else if ((NRS1(ISYM)+NRS2(ISYM)+NIO) >= NACI) then
            ISPACE = 2
          else
            ISPACE = 3
          end if
        end if

        do NACJ=1,NO ! Over all orbitals due to counting
          !write(u6,*) 'NACI,NACJ',NACI,NACJ
          if (IDOGAS) then ! Find which GAS this index belong to
            JSPACE = 0
            if (NACJ <= NIO) then
              JSPACE = 0
            else if (NACJ > NOC) then
              JSPACE = NGAS+1
              !IJ = IJ+1
              !cycle
            else
              ISUM = 0
              do IGAS=1,NGAS
                if ((NGSSH(IGAS,ISYM)+NIO+ISUM) >= NACJ) then
                  JSPACE = IGAS
                  exit
                else
                  ISUM = ISUM+NGSSH(IGAS,ISYM)
                end if
              end do
            end if
          else ! Find which RAS this index belong to
            JSPACE = 0
            if (NACJ <= NIO) then
              JSPACE = 0
            else if (NACJ > NOC) then
              JSPACE = 4
              !IJ = IJ+1
              !write(u6,*) 'IJ',IJ
              !cycle
            else if ((NRS1(ISYM)+NIO) >= NACJ) then
              JSPACE = 1
            else if ((NRS1(ISYM)+NRS2(ISYM)+NIO) >= NACJ) then
              JSPACE = 2
            else
              JSPACE = 3
            end if
          end if
          IJ = IJ+1
          write(u6,*) 'NACI,NACJ',NACI,NACJ
          write(u6,*) 'ISPACE,JSPACE',ISPACE,JSPACE
          write(u6,*) 'IJ',IJ
          if (IDAMP == 1) then
            if (IDAMPGAS(ISPACE,JSPACE) > 0) X(IJ) = X(IJ)*DAMPGAS(IDAMPGAS(ISPACE,JSPACE))
          else if (ICORE == 1) then
            if (ICOREGAS(ISPACE,JSPACE) > 0) then
              write(u6,*) ' damping'
              write(u6,*) 'ICOREGAS(ISPACE,JSPACE)',ICOREGAS(ISPACE,JSPACE)
              write(u6,*) 'fac',COREGAS(ICOREGAS(ISPACE,JSPACE))
              X(IJ) = X(IJ)*COREGAS(ICOREGAS(ISPACE,JSPACE))
            end if
          end if
        end do

      end do
      ! temp print
      ij = 0
      do ni=1,no
        do nj=1,no
          ij = ij+1
          write(u6,*) 'ij,x(ij)',ij,x(ij)
        end do
      end do

    end if

    ! Now form the unitary matrix exp(X)

    call exp_eig(no,x,thm)
    thmax = max(thmax,thm)

    ! Check for largest non diagonal element

    ij = 0
    do ni=1,no
      do nj=1,no
        ij = ij+1
        if (abs(x(ij)) < Thrs) then
          x(ij) = Zero
          cycle
        end if
        if (ni == nj) cycle
        if (abs(x(ij)) > abs(rotmax)) rotmax = x(ij)
      end do
    end do

    ! Check for large rotations and phase of new orbital

    ii = 1
    ist = 0
    do ni=1,no
      if (ni <= nio) then
        motype = 1
        xn = sum(x(ist+1:ist+nio)**2)
        if (IPRLEV >= TERSE) then
          if (xn < Half) then
            call WarningMessage(1,'Large orbital rotation.')
            write(u6,1010) ni,isym,motype,xn
          end if
        end if
      end if
      if ((ni > nio) .and. (ni <= noc)) then
        motype = 2
        nio1 = nio+1
        xn = sum(x(ist+nio1:ist+noc)**2)
        if (IPRLEV >= TERSE) then
          if (xn < Half) then
            call WarningMessage(1,'Large orbital rotation.')
            write(u6,1010) ni,isym,motype,xn
          end if
        end if
      end if
      if (ni > noc) then
        motype = 3
        noc1 = noc+1
        xn = sum(x(ist+noc1:ist+no)**2)
        if (IPRLEV >= TERSE) then
          if (xn < Half) then
            call WarningMessage(1,'Large orbital rotation.')
            write(u6,1010) ni,isym,motype,xn
          end if
        end if
      end if
      ii = ii+no+1
      ist = ist+no
    end do

    ! Transformation of the Fock matrix according to the orbital rotation matrix.
    ! This step is not required other than for FCIQMC as orbital energies could be
    ! used for choosing the reference determinant.

    if (iprlev >= debug) then
      call recprt('X in RotOrb',' ',x,no,no)
      write(u6,*) 'FA for sym = ',iSym
      write(u6,*) 'iOff is set to = ',iOff
      call TriPrt(' ',' ',FA(iOff),no)
    end if

    call mma_allocate(Unt,no*no,Label='Unt')
    call mma_allocate(SqFA,no*no,Label='SqFA')
    Unt(:) = Zero
    SqFA(:) = Zero
    call Square(FA(iOff),SqFA,1,no,no)
    if (iprlev >= debug) call recprt('Square FA in RotOrb',' ',SqFA,no,no)
    call DGEMM_('N','N',no,no,no,One,x,no,SqFA,no,Zero,Unt,no)

    call DGEMM_('N','T',no,no,no,One,Unt,no,x,no,Zero,SqFA,no)

    call Fold_Mat(1,[no],SqFA,FA(iOff))

    iOff = iOff+nTri_Elem(no)

    call mma_deallocate(Unt)
    call mma_deallocate(SqFA)

    ! Print output in MO-basis

    ! Transform new orbitals to AO-basis

    call DGEMM_('N','N',nb,no,no,One,cmoo(istmo+1),nb,x,no,Zero,cmon(istmo+1),nb)

    ! Calculate max change in occupied molecular orbital coefficient

    nbo = noc*nb
    do i=1,nbo
      term = cmon(istmo+i)-cmoo(istmo+i)
      if (abs(term) > abs(cmax)) cmax = term
    end do

  end if

  ! Move frozen orbitals from old to new set of orbitals

  if (nf /= 0) then
    nfb = nf*nb
    cmon(istmo1+1:istmo1+nfb) = cmoo(istmo1+1:istmo1+nfb)
  end if

  ! MOVE DELETED ORBITALS.

  nd = ndel(isym)
  if (nd /= 0) then
    ist = istmo1+nb*(nf+no)+1
    ndb = nd*nb
    cmon(ist:ist+ndb-1) = cmoo(ist:ist+ndb-1)
  end if

  istbm = istbm+noc*nae
  istmo1 = istmo1+nb*nb
  ib = ib+nb
end do
!^ End of the long loop over symmetry

if (PURIFY(1:4) == 'ATOM') call SPHPUR(CMON)
if (PURIFY(1:6) == 'LINEAR') call LINPUR(CMON)

! Orthogonalize new MO's and move them back to CMOO

call supsch(x2,cmoo,cmon)
! PAM07: In ortho, cmoo is scratch and will be destroyed.
call ortho_rasscf(x2,cmoo,cmon,y)
cmoo(1:ntot2) = cmon(1:ntot2)

if (iprlev >= debug) then
  write(u6,*)
  write(u6,*) ' >>> Exit RotOrb <<< '
  write(u6,*)
end if

1010 format(6x,'Molecular orbital',i4,' of symmetry',i2,' MO space',i2,'  weight is',f12.6)

end subroutine rotorb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Compute_dOdx(ZA,RA,nAtoms,T,O,EVal,Rot_Corr,
     &                        iAtom,iCar,dTdRAi,dMdx,dOdx,Px)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 ZA(nAtoms), RA(3,nAtoms), T(3), O(3,3), EVal(3),
     &       dOdx(3,3), dMdx(3,3), Px(3,3)
      Logical Rot_Corr
*---- Local arrays
      Real*8 OtMx(3,3), OtMxO(3,3)
*                                                                      *
************************************************************************
*                                                                      *
      If (.Not.Rot_Corr) Then
         Call FZero(dOdx,9)
         Return
      End If
*
*---- Differentiate the nuclear charge moment tensor, M.
*
      Call Compute_dMdx(ZA,RA,nAtoms,T,iAtom,iCar,dTdRAi,dMdx)
*
*
*     Form O(t) dMdRAi O
*
      Call DGEMM_('T','N',
     &            3,3,3,
     &            1.0d0,O,3,
     &            dMdx,3,
     &            0.0d0,OtMx,3)
      Call DGEMM_('N','N',
     &            3,3,3,
     &            1.0d0,OtMx,3,
     &            O,3,
     &            0.0d0,OtMxO,3)
*
*     Compute the off diagonal elements in Px
*
      If (Abs(OtMxO(2,3)+OtMxO(3,2)).lt.1.0D-14) Then
         If (abs(EVal(2)-EVal(3)).lt.1.0D-14) Then
             Alpha=One
         Else
             Alpha=Zero
         End If
      Else
         If (abs(EVal(2)-EVal(3)).lt.1.0D-14) Then
            Alpha=1.0D99
         Else
            Alpha =
     &        -(OtMxO(2,3)+OtMxO(3,2))/(Two*(EVal(2)-EVal(3)))
         End If
      End If
*
      If (Abs(OtMxO(1,3)+OtMxO(3,1)).lt.1.0D-14) Then
         If (abs(EVal(3)-EVal(1)).lt.1.0D-14) Then
            Beta=One
         Else
            Beta=Zero
         End If
      Else
         If (abs(EVal(3)-EVal(1)).lt.1.0D-14) Then
            Beta=1.0D99
         Else
            Beta  =
     &        -(OtMxO(1,3)+OtMxO(3,1))/(Two*(EVal(3)-EVal(1)))
         End If
      End If
      If (Abs(OtMxO(1,2)+OtMxO(2,1)).lt.1.0D-14) Then
         If (abs(EVal(1)-EVal(2)).lt.1.0D-14) Then
            Gamma = One
         Else
            Gamma = Zero
         End If
      Else
         If (abs(EVal(1)-EVal(2)).lt.1.0D-14) Then
            Gamma=1.0D99
         Else
            Gamma =
     &        -(OtMxO(1,2)+OtMxO(2,1))/(Two*(EVal(1)-EVal(2)))
         End If
      End If
*
      Call FZero(Px,9)
      Px(1,2)= Gamma
      Px(2,1)=-Gamma
      Px(1,3)=-Beta
      Px(3,1)= Beta
      Px(2,3)= Alpha
      Px(3,2)=-Alpha
*
*     Finally evaluate dO/dRAi
*
      Call DGEMM_('N','N',
     &            3,3,3,
     &            1.0d0,O,3,
     &            Px,3,
     &            0.0d0,dOdx(1,1),3)
#ifdef _DEBUGPRINT_
C     Call RecPrt('M','(3G20.10)',M,3,3)
C     Call RecPrt('RotGrd: O','(3G20.10)',O,3,3)
C     Call RecPrt('RotGrd: EVal',' ',EVal,3,1)
C     Call RecPrt('RotGrd: dMdx','(3G20.10)',dMdx,3,3)
C     Call RecPrt('RotGrd: OtMxO','(3G20.10)',OtMxO,3,3)
C     Write (*,*) 'A,B,G=',Alpha,Beta,Gamma
C     Call RecPrt('RotGrd: Px','(3G20.10)',Px,3,3)
C     Call RecPrt('dOdx','(3G20.10)',dOdx,3,3)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LevMarquart(Potte,nPick,Pick,EPCo,Coo,dMullig,lMax,A,iAtom,jAtom,chP,Thrs1,Thrs2,nThrs,Chi2B,iPrint,AboveMul)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Ten, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nPick, Pick(nPick), lMax, iAtom, jAtom, nThrs, iPrint
real(kind=wp), intent(in) :: Potte(nPick), EPCo(3,*), Coo(3), dMullig((lMax+1)*(lMax+2)*(lMax+3)/6), chP, Thrs1, Thrs2
real(kind=wp), intent(out) :: A(2), Chi2B
logical(kind=iwp), intent(inout) :: AboveMul(2)
integer(kind=iwp) :: i, ind, iP, Iter, j, nStep
real(kind=wp) :: AlfMat(4), AlfMatI(4), ARaw(2,2), B(2), BRaw(2), Chi2, dA(2), ddLower, ddUpper, Der1, Der2, DerMax, Diffo, &
                 dLambda, dLower, dUpper, r, rinv, x, y, z
logical(kind=iwp) :: lScreen1, lScreen2, lScreen3, lScreen4, lStop1, lStop2, lStop3, lStop4
character(len=60) :: UtChar
real(kind=wp), allocatable :: Pout(:), rinvStore(:), rStore(:), xStore(:), yStore(:), zStore(:)
real(kind=wp), external :: ElPot
#include "warnings.h"

! Set iteration count to zero here at the top of the
! Levenberg-Marquart thing. Initiate lambda and the exponents.
! The exponents are not God-given, but these rather low values
! have been found to work nicely in most cases. Set highest
! and lowest allowed values of exponents. Set highest and lowest
! allowed values of exponent steps.

Iter = 0
nStep = 0
dLambda = 1.0e-3_wp
A(:) = Half
dUpper = Three
dLower = 0.1_wp
ddUpper = 0.7_wp
ddLower = -0.7_wp

! Start loop, set zeros.

do
  Iter = Iter+1
  Chi2 = Zero
  Chi2B = Zero
  do i=1,2
    BRaw(i) = Zero
    dA(i) = Zero
    do j=1,2
      ARaw(i,j) = Zero
    end do
  end do

  ! Compute distances and store them.

  call mma_allocate(xStore,nPick,label='xStore')
  call mma_allocate(yStore,nPick,label='yStore')
  call mma_allocate(zStore,nPick,label='zStore')
  call mma_allocate(rStore,nPick,label='rStore')
  call mma_allocate(rinvStore,nPick,label='rinvStore')
  do iP=1,nPick
    ind = Pick(iP)
    x = EPCo(1,ind)-Coo(1)
    y = EPCo(2,ind)-Coo(2)
    z = EPCo(3,ind)-Coo(3)
    xStore(iP) = x
    yStore(iP) = y
    zStore(iP) = z
    rStore(iP) = sqrt(x**2+y**2+z**2)
    rinvStore(iP) = One/rStore(iP)
  end do

  ! Compute the electric potential and the difference between true and
  ! modelled potential. Also compute first derivatives. Formaly, there
  ! are second derivatives as well, but they are neglected for
  ! stability reasons. For this relatively simple non-linear problem,
  ! it is probably not meaningful to code a more intelligent
  ! routine that includes the second derivatives with some
  ! stabalizing modifications.

  DerMax = Zero
  do iP=1,nPick
    r = rStore(iP)
    rinv = rinvStore(iP)
    x = xStore(iP)
    y = yStore(iP)
    z = zStore(iP)
    Diffo = Potte(iP)-ElPot(r,rinv,x,y,z,dMullig,lMax,A,chP,.true.,.true.)
    Der1 = dMullig(1)*(One+Two*A(1)*r)*exp(-Two*A(1)*r)
    Der2 = (dMullig(2)*x+dMullig(3)*y+dMullig(4)*z)*(A(2)**2+Two*A(2)**3*r)*exp(-Two*A(2)*r)
    if (abs(Der1) > DerMax) Dermax = abs(Der1)
    if (abs(Der2) > DerMax) Dermax = abs(Der2)

    ! Assemble the alpha-matrix, the beta-vector and the chi2 scalar.

    Chi2 = Chi2+Diffo**2
    BRaw(1) = BRaw(1)+Diffo*Der1
    BRaw(2) = BRaw(2)+Diffo*Der2
    ARaw(1,1) = ARaw(1,1)+Der1*Der1
    ARaw(2,1) = ARaw(2,1)+Der2*Der1
    ARaw(2,2) = ARaw(2,2)+Der2*Der2
  end do
  Chi2 = Chi2/real(nPick,kind=wp)

  ! Check if numerical and statistical well-behaved calculations are
  ! expected or not.

  if (nPick < 5) then
    write(u6,*)
    write(u6,'(A)') ' Error in numerical fit for exponent!'
    write(u6,'(A)') '    Too few electric potential points have'
    write(u6,'(A,2I4)') '    been sampled for (At1,At2):',iAtom,jAtom
    write(u6,*)
    call Quit(_RC_GENERAL_ERROR_)
  end if
  if (DerMax < 1.0e-4_wp) then
    write(u6,*)
    write(u6,'(A)') ' Error in numerical fit for exponent!'
    write(u6,'(A)') '    To small derivative for parameter'
    write(u6,'(A,2I4)') '    in centre (At1,At2):',iAtom,jAtom
    write(u6,'(A,E12.4)') '    Maximal derivative:',DerMax
    write(u6,*)
    write(u6,'(A)') '    Either include closer points, give a'
    write(u6,'(A)') '    better initial estimate, or increase'
    write(u6,'(A)') '    multipole magnitude threshold.'
    write(u6,*)
    call Quit(_RC_GENERAL_ERROR_)
  end if

  ! Solve the linear system to get step, dA.

  call SolveA(AlfMat,AlfMatI,dLambda,ARaw,BRaw,dA,iPrint,AboveMul,ddUpper,ddLower)

  ! Make a screening of dA: if the maximal or minimal exponent
  ! has been reached, but the optimization still pushes on, screen
  ! them by putting them as zero, and modifying AboveMul.

  do i=1,2
    if (AboveMul(i)) then
      lScreen1 = (A(i)+1.0e-8_wp) > dUpper
      lScreen2 = (dA(i)+1.0e-8_wp) > ddUpper
      lScreen3 = (A(i)-1.0e-8_wp) < dLower
      lScreen4 = (dA(i)-1.0e-8_wp) < ddLower
      if ((lScreen1 .and. lScreen2) .or. (lScreen3 .and. lScreen4)) then
        dA(i) = Zero
        AboveMul(i) = .false.
      end if
    end if
  end do
  if (iPrint >= 7) then
    call RecPrt('deltaA',' ',dA,2,1)
  end if

  ! Construct trial parameters and compute the chi2-scalar for
  ! the trial parameters. To keep things within reasonable bounds
  ! do not exceed certain values.

  B(1) = A(1)+dA(1)
  B(2) = A(2)+dA(2)
  if (B(1) < dLower) B(1) = dLower
  if (B(2) < dLower) B(2) = dLower
  if (B(1) > dUpper) B(1) = dUpper
  if (B(2) > dUpper) B(2) = dUpper
  do iP=1,nPick
    r = rStore(iP)
    rinv = rinvStore(iP)
    x = xStore(iP)
    y = yStore(iP)
    z = zStore(iP)
    Diffo = Potte(iP)-ElPot(r,rinv,x,y,z,dMullig,lMax,B,chP,.true.,.true.)
    Chi2B = Chi2B+Diffo**2
  end do
  Chi2B = Chi2B/real(nPick,kind=wp)

  ! Take appropriate action given the different Stop-criterion. They
  ! measure the following: (1) The error should not change too much
  ! between steps; observe that it is not meaningful to have too
  ! tight a threshold in this regard due to the statistical nature of
  ! the problem. (2) The modifier parameter has to stabalize and not
  ! be far out in the linear region, rather in the second order regime.
  ! (3) The last step should be a decrease. (4) A certain number of
  ! steps should preceed that decreases the error; this threshold
  ! 'overlaps' some with second threshold. Halt the optimization if
  ! no convergence is reached after 40 iterations. This is by far
  ! a generous limit.

  lStop1 = abs(Chi2-Chi2B) < Thrs1
  lStop2 = dLambda < Thrs2
  lStop3 = Chi2 > Chi2B
  lStop4 = nStep >= nThrs
  if (iPrint >= 6) then
    write(u6,*)
    write(u6,790) Iter
    write(u6,794) 'Chi2','Chi2, trial','Lambda'
    write(u6,791) Chi2,Chi2B,dLambda
    write(u6,795) 'Exponents:','Charge','Dipole'
    write(u6,792) A(1),A(2)
  end if
  if (lStop1 .and. lStop2 .and. lStop3 .and. lStop4) then
    A(1) = B(1)
    A(2) = B(2)
    exit
  end if
  if (Iter > 40) then
    write(u6,*)
    write(u6,*) 'No convergence in the Levenberg-Marquart section.'
    call Quit(_RC_NOT_CONVERGED_)
  end if
  if (Chi2B >= Chi2) then
    dLambda = dLambda*Ten
  else
    dLambda = dLambda/Ten
    nStep = nStep+1
    A(1) = B(1)
    A(2) = B(2)
  end if
end do

! Optional printing when convergence is reached.

if (iPrint >= 5) then
  write(u6,*)
  write(u6,*)
  write(u6,793) Iter
  write(u6,794) 'Chi2','Chi2, trial','Lambda'
  write(u6,791) Chi2,Chi2B,dLambda
  write(u6,795) 'Exponents:','Charge','Dipole'
  write(u6,792) A(1),A(2)
  call mma_allocate(Pout,nPick,label='Pout')
  do iP=1,nPick
    r = rStore(iP)
    rinv = rinvStore(iP)
    x = xStore(iP)
    y = yStore(iP)
    z = zStore(iP)
    Pout(iP) = ElPot(r,rinv,x,y,z,dMullig,lMax,A,chP,.true.,.true.)
  end do
  write(UtChar,'(A,2I3)') 'Approximate partial density potential, centre',iAtom,jAtom
  call RecPrt(UtChar,' ',Pout,nPick,1)
  call RecPrt('Distance to points',' ',rStore,nPick,1)
  call mma_deallocate(Pout)
end if

call mma_deallocate(xStore)
call mma_deallocate(yStore)
call mma_deallocate(zStore)
call mma_deallocate(rStore)
call mma_deallocate(rinvStore)

! And yes, there is an end here as well.

return

790 format('Levenberg-Marquart optimization. Iteration:',I3)
794 format('   ',A,'          ',A,'   ',A)
791 format(3(E13.6,' '))
795 format(' ',A,' ',A,'      ',A)
792 format('       ',2F12.6)
793 format('Convergence reached in iteration ',I2)

end subroutine LevMarquart

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_IndxSwp()
C
C     Purpose: swap global and local reduced set index arrays.
C              Note that arrays InfRed and InfVec are swapped as well.
C
C     NB: this procedure is inexpensive, as we are merely swapping
C         pointers, not actual data (except for the statically allocated
C         index arrays which amount to swapping 51 integers in total).
C
      use ChoSwp, only: nnBstRSh, nnBstRSh_G, pTemp3
      use ChoSwp, only: iiBstRSh, iiBstRSh_G
      use ChoSwp, only: IndRSh, IndRSh_G, pTemp1
      use ChoSwp, only: InfRed, InfRed_G
      use ChoSwp, only: InfVec, InfVec_G
      use ChoSwp, only: IndRed, IndRed_G, pTemp
      Implicit None
#include "cholesky.fh"
#include "choglob.fh"

      Integer iTmp, N

      iTmp = nnShl_G
      nnShl_G = nnShl
      nnShl = iTmp

      iTmp = mmBstRT_G
      mmBstRT_G = mmBstRT
      mmBstRT = iTmp

      N = 8*3
      Call iSwap(N,iiBstR_G,1,iiBstR,1)
      Call iSwap(N,nnBstR_G,1,nnBstR,1)
      Call iSwap(3,nnBstRT_G,1,nnBstRT,1)

      pTemp1 => InfRed_G
      InfRed_G => InfRed
      InfRed => pTemp1

      pTemp3 => InfVec_G
      InfVec_G => InfVec
      InfVec => pTemp3

      pTemp3 => iiBstRSh_G
      iiBstRSh_G => iiBstRSh
      iiBstRSh => pTemp3

      pTemp3 => nnBstRSh_G
      nnBstRSh_G => nnBstRSh
      nnBstRSh => pTemp3

      pTemp => IndRed_G
      IndRed_G => IndRed
      IndRed => pTemp

      pTemp1 => IndRSh_G
      IndRSh_G => IndRSh
      IndRSh => pTemp1

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RMVERT(SGS)
! Purpose: Remove vertices from a DRT table.

use gugx, only: SGStruct
use RasDef, only: nRas, nRsPrt, nRasEl
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
type(SGStruct), intent(inout) :: SGS
integer(kind=iwp) :: IC, ID, iRO, iSy, IV, L, Lev, N, NCHANGES, NLD, NV
logical(kind=iwp) :: Test
integer(kind=iwp), allocatable :: CONN(:), Lim(:)
integer(kind=iwp), parameter :: LTAB = 1, NTAB = 2

! Construct a restricted graph.
call mma_allocate(Lim,SGS%nLev,Label='Lim')
Lim(:) = 0
! Fill in the occupation limit table:
Lev = 0
do iRO=1,nRsPrt
  do iSy=1,SGS%nSym
    Lev = Lev+nRas(iSy,iRO)
  end do
  if (Lev > 0) Lim(Lev) = nRasEl(iRO)
end do

call mma_allocate(SGS%Ver,SGS%nVert0,Label='SGS%Ver')
call mma_allocate(CONN,SGS%nVert,Label='CONN')

! KILL VERTICES THAT DO NOT OBEY RESTRICTIONS.
do IV=1,SGS%nVert-1
  SGS%Ver(IV) = 1
  L = SGS%DRT0(IV,LTAB)
  N = SGS%DRT0(IV,NTAB)
  if (N < Lim(L)) SGS%Ver(IV) = 0
end do
SGS%Ver(SGS%nVert) = 1

NCHANGES = 1 ! Initiate first loop
do while (NCHANGES > 0)
  ! REMOVE ARCS HAVING A DEAD UPPER OR LOWER VERTEX.
  ! COUNT THE NUMBER OF ARCS REMOVED OR VERTICES KILLED.
  NCHANGES = 0
  do IV=1,SGS%nVert-1
    if (SGS%Ver(IV) == 0) then
      do IC=0,3
        ID = SGS%Down0(IV,IC)
        if (ID > 0) then
          SGS%Down0(IV,IC) = 0
          NCHANGES = NCHANGES+1
        end if
      end do
    else
      NLD = 0
      do IC=0,3
        ID = SGS%Down0(IV,IC)
        if (ID > 0) then
          if (SGS%Ver(ID) == 0) then
            SGS%Down0(IV,IC) = 0
            NCHANGES = NCHANGES+1
          else
            NLD = NLD+1
          end if
        end if
      end do
      if (NLD == 0) then
        SGS%Ver(IV) = 0
        NCHANGES = NCHANGES+1
      end if
    end if
  end do
  ! ALSO CHECK ON CONNECTIONS FROM ABOVE:
  CONN(:) = 0
  CONN(1) = SGS%Ver(1)
  do IV=1,SGS%nVert-1
    if (SGS%Ver(IV) == 1) then
      do IC=0,3
        ID = SGS%Down0(IV,IC)
        Test = ID > 0
        if (Test) Test = SGS%Ver(ID) == 1
        if (Test) CONN(ID) = 1
      end do
    end if
  end do
  do IV=1,SGS%nVert
    if ((SGS%Ver(IV) == 1) .and. (CONN(IV) == 0)) then
      SGS%Ver(IV) = 0
      NCHANGES = NCHANGES+1
    end if
  end do

end do

! IF NO CHANGES, THE REMAINING GRAPH IS VALID.
! EVERY VERTEX OBEYS THE RESTRICTIONS. EVERY VERTEX IS
! CONNECTED ABOVE AND BELOW (EXCEPTING THE TOP AND BOTTOM)
! TO OTHER CONFORMING VERTICES.
! THE PROCEDURE IS GUARANTEED TO FIND A STABLE SOLUTIONS,
! SINCE EACH ITERATION REMOVES ARCS AND/OR VERTICES FROM THE
! FINITE NUMBER WE STARTED WITH.

if (SGS%Ver(1) == 0) then
  write(u6,*) 'RASSI/RMVERT: Too severe restrictions.'
  write(u6,*) 'Not one single configuration is left.'
  call ABEND()
end if

NV = 0
do IV=1,SGS%nVert
  if (SGS%Ver(IV) == 1) then
    NV = NV+1
    SGS%Ver(IV) = NV
  end if
end do
SGS%nVert = NV

call mma_deallocate(CONN)
call mma_deallocate(Lim)

end subroutine RMVERT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine frankie_drv(NChHere)

use chcc_global, only: nfr, no, nv, printkey
use Cholesky, only: NumCho
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: NChHere

! ----------------------------------------------------------------------

! - transform AO Cholesky vectors to MO basis locally on each node
!   with fragmented cholesky index. _AI1 -> _CDtmp1

call frankie(nfr,no,nv,printkey)

! take local # of Cholesky Vectors on this node
NChHere = NumCho(1)

return

end subroutine frankie_drv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine dRdMCK(rc,Option,InLab,iComp,dData,iSymLab)
      Implicit Integer (A-Z)
      Character*(*) InLab
      Real*8 dData(*)
      Call dRdMCK_Internal(dData)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine dRdMCK_Internal(dData)
      Use Iso_C_Binding
      Real*8, Target :: dData(*)
      Integer, Pointer :: iData(:)
      Call C_F_Pointer(C_Loc(dData),iData,[1])
      Call RdMCK(rc,Option,InLab,iComp,iData,iSymLab)
      Nullify(iData)
      Return
      End Subroutine dRdMCK_Internal
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Markus P. Fuelscher                              *
************************************************************************
      Subroutine RdInp_Motra
************************************************************************
*                                                                      *
*     Subroutine RdInp                                                 *
*                                                                      *
*     Purpose: Read input from inputstream                             *
*                                                                      *
***** M.P. Fuelscher, University of Lund, Sweden, 1991 *****************
*
      Implicit Real*8 (A-H,O-Z)

      Parameter ( nCmd   = 16    )
      Parameter ( lCmd   = 4     )
      Character*4 CmdTab(nCmd)
#include "motra_global.fh"
#include "trafo_motra.fh"
#include "files_motra.fh"
      Character*180 Line,Blank
      Integer nDel2(8)
      character*(180) Get_Ln
      External Get_Ln
      Data CmdTab/'TITL','FROZ','DELE','PRIN','MOLO',
     &            'LUMO','JOBI','ONEL','FILE','AUTO',
     &            'EXTR','RFPE','CTON','DIAG','HDF5',
     &            'END '/
*
      COMMON / CHO_Minp / iCTonly, iDoInt
      Character*3 tv2disk
      COMMON / CHOTRAW / tv2disk
*


      iCTonly=0
      iDoInt =0
      ihdf5  =0
      tv2disk='PQK'
*----------------------------------------------------------------------*
*     Initialize some arrays                                           *
*----------------------------------------------------------------------*
      Do iSym=1,mxSym
        nDel(iSym)=0
        nOrb(iSym)=0
        CutThrs(iSym)=0.0D0
      End Do
      Call Get_iArray('Non valence orbitals',nFro,nSym)
      Do i=1,72
        Blank(i:i)=' '
      End Do
*----------------------------------------------------------------------*
*     Locate "start of input"                                          *
*----------------------------------------------------------------------*
      LuSpool = 17
      Call SpoolInp(LuSpool)
      Rewind(LuSpool)
      Call RdNLst(LuSpool,'MOTRA')
*----------------------------------------------------------------------*
*     Read the input stream line by line and identify key command      *
*----------------------------------------------------------------------*
100   Read(LuSpool,'(A)') Line
      If ( Line(1:72).eq.Blank(1:72) .or. Line(1:1).eq.'*' ) Goto 100
      Call UpCase(Line)
110   jCmd=0
      Do iCmd=1,nCmd
        If ( Line(1:lCmd).eq.CmdTab(iCmd)(1:lCmd) ) jCmd=iCmd
      End Do
      If ( jCmd.eq.0 ) Then
         Write (6,*) 'RdInp: Unknown command at line: ', trim(Line)
         Call Abend()
      End If
*----------------------------------------------------------------------*
*     Branch to the processing of the command sections                 *
*----------------------------------------------------------------------*
      Goto (1010,1020,1030,1040,1050,1060,1070,1080,1090,1100,
     &      1110,1120,1130,1140,1150,2000),jCmd
*---  Process the "TITLe" command -------------------------------------*
1010  nTit=0
15    Read(LuSpool,'(A)') Line
      If ( Line(1:72).eq.Blank(1:72) .or. Line(1:1).eq.'*' ) Goto 15
      Call UpCase(Line)
      if(nTit.gt.0) Then
       Do iCmd=1,nCmd
         If ( Line(1:lCmd).eq.CmdTab(iCmd)(1:lCmd) ) Goto 110
       End Do
      End If
      nTit=nTit+1
      If ( nTit.le.mxTit ) Title(nTit)=Trim(Line)
      Goto 15
*---  Process the "FROZen orbitals" command ---------------------------*
1020  Continue
*
      If (iPrint.GE.0) then
         Write(6,*)
         Write(6,'(6X,A)')'*** WARNING: Default frozen orbitals is '//
     &                    'overwritten by user input.'
         Write(6,'(6X,A,8I4)')
     &                    '*** Default values:',(nFro(iSym),iSym=1,nSym)
      EndIf
*
25    Read(LuSpool,'(A)') Line
      If ( Line(1:72).eq.Blank(1:72) .or. Line(1:1).eq.'*' ) Goto 25
      Read(Line,*,Err=994) (nFro(iSym),iSym=1,nSym)
      Goto 100
*---  Process the "DELEted orbitals" command --------------------------*
1030  Continue
35    Read(LuSpool,'(A)') Line
      If ( Line(1:72).eq.Blank(1:72) .or. Line(1:1).eq.'*' ) Goto 35
      Read(Line,*,Err=994) (nDel(iSym),iSym=1,nSym)
      Goto 100
*---  Process the "PRINt level" command -------------------------------*
1040  Continue
45    Read(LuSpool,'(A)') Line
      If ( Line(1:72).eq.Blank(1:72) .or. Line(1:1).eq.'*' ) Goto 45
      Read(Line,*,Err=994) iPrint
      Goto 100
*---  Process the "MOLOrb" command ------------------------------------*
1050  Continue
      iVecTyp=1
      Goto 100
*---  Process the "LUMOrb" command ------------------------------------*
1060  Continue
      iVecTyp=2
      Goto 100
*---  Process the "JOBIph" command ------------------------------------*
1070  Continue
      iVecTyp=3
      Goto 100
*---  Process the "ONEL only" command ---------------------------------*
1080  Continue
      iOneOnly=1
      Goto 100
*---  Process the "FILEORB" command------------------------------------*
1090  Continue
      iVecTyp=2
      Line=Get_Ln(LuSpool)
      write(6,*)' RdInp_Motra before calling fileorb.'
      write(6,*)' Line:'//line(1:60)
      write(6,*)'   Calling fileorb now...'
      call fileorb(Line,FnInpOrb)
      write(6,*)'   Back from fileorb.'
      write(6,*)' Line:'//line(1:60)
      write(6,*) FnInpOrb
      Goto 100
*---  Process the "AUTO delete" command--------------------------------*
1100  Continue
      iAutoCut=1
105   Read(LuSpool,'(A)') Line
      If ( Line(1:72).eq.Blank(1:72) .or. Line(1:1).eq.'*' ) Goto 105
      Read(Line,*,Err=994) (CutThrs(iSym),iSym=1,nSym)
      Goto 100
*---  Process the "EXTRact" command------------------------------------*
1110  Write (6,*) 'The EXTRACT option is redundant and is ignored!'
      Goto 100
*---  Process the "RFperturbation" command ----------------------------*
1120  Continue
      iRFpert=1
      Goto 100
*---  Process the "CTonly" to perform exclusively CD vectors transform-*
1130  Continue
      Line=Get_Ln(LuSpool)
      Call UpCase(Line)
      Call LeftAd(Line)
      tv2disk=Line(1:3)
      If (tv2disk.ne.'PQK' .and. tv2disk.ne.'KPQ') tv2disk='PQK' !def
      iCTonly=1
      Goto 100
*---  Process the "DIAGonal ERI evaluation" command -------------------*
1140  Continue
      iDoInt=1
      Goto 100
*---  Process the "HDF5 output file" command --------------------------*
1150  Continue
      ihdf5 = 1
      Goto 100
*---  Process the "END of input" command ------------------------------*
2000  Continue

* New rules for title lines...warning needed?
      If ( nTit.gt.mxTit) Then
       Write(6,*)' NOTE: New input specifications says TITLE keyword'
       Write(6,*)' must be followed by exactly one title line.'
       nTit=mxTit
      End If
*
*---- Check for deleted orbitals
*
      Call Get_iArray('nDel',nDel2,nSym)
      Do iSym = 1, nSym
         If (nDel2(iSym).gt.nDel(iSym)) Then
            Write (6,*)
            Write (6,*) 'Orbitals deleted at an earlier stage.'
            Write (6,*) 'iSym=',iSym
            Write (6,*) 'Input value  :',nDel(iSym)
            Write (6,*) 'Earlier value:',nDel2(iSym)
            Write (6,*)
            Write (6,*) 'Input value is now updated to earlier value!'
            Write (6,*)
            nDel(iSym)=nDel2(iSym)
         End If
      End Do
*----------------------------------------------------------------------*
*     Normal termination                                               *
*----------------------------------------------------------------------*
      nOrbt=0
      nOrbtt=0
      Do iSym=1,nSym
        nOrb(iSym)=nBas(iSym)-nFro(iSym)-nDel(iSym)
        nOrbt=nOrbt+nOrb(iSym)
        nOrbtt=nOrbtt+nOrb(iSym)*(nOrb(iSym)+1)/2
      End Do
      Call Put_iArray('nFro',nFro,nSym)
      close(LuSpool)
      Return
*----------------------------------------------------------------------*
*     Error Exit                                                       *
*----------------------------------------------------------------------*
994   Write (6,*) 'RdInp: error readin input file!'
      Write (6,*) 'Command=',CmdTab(jCmd)
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombUpperBoundNorm_Full(PrintNorm,PackedD,nD,FactC,ip_D,UBFNorm)
! Thomas Bondo Pedersen, January 2011.
!
! Purpose: compute norm of the upper bound to the Coulomb Fock
!          matrix error in LDF.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: PrintNorm, PackedD
integer(kind=iwp), intent(in) :: nD, ip_D(nD)
real(kind=wp), intent(in) :: FactC(nD)
real(kind=wp), intent(out) :: UBFNorm(nD)
integer(kind=iwp) :: l_DBlkP, iD
integer(kind=iwp), allocatable :: DBlkP(:)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

if (nD < 1) return
if (NumberOfAtomPairs < 1) return

l_DBlkP = nD
call mma_allocate(DBlkP,l_DBlkP,label='CUBDBP')
do iD=1,nD
  call LDF_AllocateBlockMatrix('UBD',DBlkP(iD))
  call LDF_Full2Blocked(Work(ip_D(iD)),PackedD,DBlkP(iD))
  call LDF_ScaleOffDiagonalMatrixBlocks(DBlkP(iD),Two)
end do
call LDF_Fock_CoulombUpperBoundNorm(PrintNorm,nD,FactC,DBlkP,UBFNorm)
do iD=1,nD
  call LDF_DeallocateBlockMatrix('UBD',DBlkP(iD))
end do
call mma_deallocate(DBlkP)

end subroutine LDF_Fock_CoulombUpperBoundNorm_Full

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  PrintGeom
*
*> @brief
*>   Print the geometry
*> @author Y. Carissan
*>
*> @details
*> Print the geometry.
*>
*> @param[in] iLU   Logic unit number
*> @param[in] Nat   number of atoms
*> @param[in] title title to be printed
*> @param[in] Geom  XYZ coordinates
*> @param[in] lbl   Atom labels
************************************************************************
      subroutine PrintGeom(iLU,Nat,title,Geom,lbl)
      implicit none
#include "debug.fh"
      integer nat,iat,icomp,iLU
      Real*8 Geom(3,nat)
      character*20 title
      character*20 lbl(nat)

      Write(6,'(a8i1)') '--- GEOM'
      Write(6,'(i4)') nat
      Write(6,*) title
      Do iat=1,nat
        if (debug) then
*        lbl is not defined. I'll comment out this statement
*        until some one needs it and replace it with the
*        the standard print out.
*        Write(6,'(i3,5x,a10,8x,3f16.8)') iat,lbl(iat),
*    &             (Geom(icomp,iat),icomp=1,3)
         Write(6,'(i3,5x,3f16.8)') iat,
     &             (Geom(icomp,iat),icomp=1,3)
        else
*        Write(6,   '(5x,a10,8x,3f16.8)')   lbl(iat),
*    &             (Geom(icomp,iat),icomp=1,3)
         Write(6,'(i3,5x,3f16.8)') iat,
     &             (Geom(icomp,iat),icomp=1,3)
        end if
      End Do
      Write(6,'(a8i1)') '--- GEOM'

      if (iLU.ne.-1) then
        Write(iLU,'(i4)') nat
        Write(iLU,*) title
        Do iat=1,nat
*          Write(iLU,   '(a10,8x,3f16.8)')   lbl(iat),
*    &               (Geom(icomp,iat),icomp=1,3)
         Write(6,'(i3,5x,3f16.8)') iat,
     &             (Geom(icomp,iat),icomp=1,3)
        End Do
      End If
      return
c Avoid unused argument warnings
      If (.False.) Call Unused_character(lbl)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PrSSTab(SSTAB)
      use cntrl, only: MORSBITS
      IMPLICIT NONE
      INTEGER SSTAB(*)

      INTEGER LPOS
      INTEGER NSSTP,ISSTP,KSSTP,NSBS,NPOP,ISYM,MS2,ISPART
      INTEGER KSSTANN,KSSTCRE,KSBSMRS,KMRSSBS,KSBSANN,KSBSCRE
      INTEGER I,ISBS,NSBSTOT,NMORS,IMRS,NASPRT
      INTEGER NRSBST,ISBSSTA,ISBSEND,IMRSSTA,IMRSEND
      WRITE(6,*)
      WRITE(6,*)'============================================='
      WRITE(6,*)' Substring table printout.'
      WRITE(6,*)' (A) Header and TOC:'
      WRITE(6,'(a,i16)')'            Table size:',SSTAB(1)
      WRITE(6,'(a,i16)')'       Table type code:',SSTAB(2)
      WRITE(6,'(a,i16)')' Orbital Table        :',SSTAB(3)
      WRITE(6,'(a,i16)')' Nr of symmetry labels:',SSTAB(4)
      WRITE(6,'(a,i16)')' Nr of active subpart :',SSTAB(5)
      WRITE(6,'(a,i16)')' Nr of bits/morsel    :',SSTAB(6)
      WRITE(6,'(a,i16)')' Nr of Substring Types:',SSTAB(7)
      WRITE(6,'(a,i16)')' Nr of Substrings     :',SSTAB(8)
      WRITE(6,'(a,i16)')' Substr Type Ann Table:',SSTAB(9)
      WRITE(6,'(a,i16)')' Substr Type Cre Table:',SSTAB(10)
      WRITE(6,'(a,i16)')' Substr/Morsel Table  :',SSTAB(11)
      WRITE(6,'(a,i16)')' Morsel/Substr Table  :',SSTAB(12)
      WRITE(6,'(a,i16)')' Substring Annih Table:',SSTAB(13)
      WRITE(6,'(a,i16)')' Substring Creat Table:',SSTAB(14)
      WRITE(6,*)'---------------------------------------------'
      WRITE(6,*)' (B) Substring Types:'
      WRITE(6,*)' NSBS  = Nr of substrings of each type.'
      WRITE(6,*)' NPOP  = Electron population of each type.'
      WRITE(6,*)' ISYM  = Combined symmetry of each type.'
      WRITE(6,*)' MS2   = Twice spin proj of each type.'
      WRITE(6,*)' ISPART= Subpartition of each type.'
      WRITE(6,*)'---------------------------------------------'
      WRITE(6,*)'           NSBS   NPOP   ISYM    MS2  ISBPRT'
      NSSTP=SSTAB(7)
      NSBSTOT =SSTAB(8)
      KSSTP  =15
      DO ISSTP=1,NSSTP
        NSBS   = SSTAB(KSSTP+0+5*(ISSTP-1))
        NPOP   = SSTAB(KSSTP+1+5*(ISSTP-1))
        ISYM   = SSTAB(KSSTP+2+5*(ISSTP-1))
        MS2    = SSTAB(KSSTP+3+5*(ISSTP-1))
        ISPART = SSTAB(KSSTP+4+5*(ISSTP-1))
        WRITE(6,'(1x,6I7)') ISSTP,NSBS,NPOP,ISYM,MS2,ISPART
      END DO
      WRITE(6,*)'---------------------------------------------'
      WRITE(6,*)' (C1) Morsels to Substrings:'
      NASPRT=SSTAB(5)
      KSBSMRS=SSTAB(11)
      KMRSSBS=SSTAB(12)
      NMORS=2**MORSBITS
      DO IMRSSTA=0,NMORS-1,15
        IMRSEND=MIN(NMORS-1,IMRSSTA+14)
        WRITE(6,*)
        WRITE(6,'(1x,a,3x,15I5)')'MRS:',(IMRS,IMRS=IMRSSTA,IMRSEND)
        DO ISPART=1,NASPRT
        WRITE(6,'(1x,a,i3,15I5)')'SBS:',ISPART,(SSTAB(KMRSSBS
     &        +2*(IMRS+NMORS*(ISPART-1))),IMRS=IMRSSTA,IMRSEND)
        END DO
      END DO

      NRSBST=SSTAB(8)
      WRITE(6,*)' (C2) Substrings to Morsels:'
      DO ISBSSTA=1,NRSBST,15
        ISBSEND=MIN(NRSBST,ISBSSTA+14)
        WRITE(6,*)
        WRITE(6,'(1x,a,15I5)')'SBS:',(ISBS,ISBS=ISBSSTA,ISBSEND)
        WRITE(6,'(1x,a,15I5)')'MRS:',(SSTAB(KSBSMRS
     &                +2*(ISBS-1)),ISBS=ISBSSTA,ISBSEND)
      END DO
      WRITE(6,*)'---------------------------------------------'
      WRITE(6,*)' (D1) Substring Type Annihilation Table:'
      KSSTANN=SSTAB(9)
      KSSTCRE=SSTAB(10)
      DO ISSTP=1,NSSTP
       LPOS=KSSTANN+MORSBITS*(ISSTP-1)
       WRITE(6,'(1x,I8,5X,8I8)')
     &                      ISSTP,(SSTAB(LPOS-1+I),I=1,MORSBITS)
      END DO
      WRITE(6,*)' (D2) Substring Type Creation Table:'
      DO ISSTP=1,NSSTP
       LPOS=KSSTCRE+MORSBITS*(ISSTP-1)
       WRITE(6,'(1x,I8,5X,8I8)')
     &                      ISSTP,(SSTAB(LPOS-1+I),I=1,MORSBITS)
      END DO
      WRITE(6,*)'---------------------------------------------'
      WRITE(6,*)' (E1) Substring Annihilation Table:'
      KSBSANN=SSTAB(13)
      KSBSCRE=SSTAB(14)
      DO ISBS=1,NSBSTOT
       LPOS=KSBSANN+MORSBITS*(ISBS-1)
       WRITE(6,'(1x,I8,5X,8I8)')
     &                      ISBS,(SSTAB(LPOS-1+I),I=1,MORSBITS)
      END DO
      WRITE(6,*)'---------------------------------------------'
      WRITE(6,*)' (E2) Substring Creation Table:'
      DO ISBS=1,NSBSTOT
       LPOS=KSBSCRE+MORSBITS*(ISBS-1)
       WRITE(6,'(1x,I8,5X,8I8)')
     &                      ISBS,(SSTAB(LPOS-1+I),I=1,MORSBITS)
      END DO
      WRITE(6,*)'============================================='

      END SUBROUTINE PrSSTab

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Create_Chunk(LenVec,NumVec,IncVec)

use RI_glob, only: Chunk
#ifdef _MOLCAS_MPP_
use RI_glob, only: iMap, ip_Chunk
use Para_Info, only: Is_Real_Par, MyRank, nProcs
use Constants, only: Zero
use Definitions, only: wp, u6
#endif
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LenVec, NumVec
integer(kind=iwp), intent(out) :: IncVec
#ifdef _MOLCAS_MPP_
#include "mafdecls.fh"
integer(kind=iwp) :: i, IncVec0, iNode, iNode0, iStart, itmp, myMap(2), nBlocks
real(kind=wp) :: FullSize, TotalMemory
logical(kind=iwp) :: ok
logical(kind=iwp), external :: ga_create_irreg
#endif
integer(kind=iwp) :: MaxMem

#ifdef _MOLCAS_MPP_
if (NumVec <= 0) then
  call WarningMessage(2,'Create_Chunk: Failure NumVec <= 0')
  write(u6,*) 'NumVec=',NumVec
  call Abend()
end if

if (Is_Real_Par()) then
  call mma_allocate(iMap,nProcs+1,Label='iMap')
  iMap(:) = 0

  FullSize = real(LenVec*NumVec,kind=wp)
  call mma_maxDBLE(MaxMem)
  iMap(1+MyRank) = MaxMem
  call GAIGOP(iMap,nProcs,'+')
  TotalMemory = Zero
  itmp = iMap(1)

  ! Find the smallest possible memory allocation!

  do i=1,nProcs-1
    itmp = min(itmp,iMap(1+i))
  end do
  TotalMemory = real(itmp,kind=wp)*real(nProcs,kind=wp)

  ! Compute the number of vectors to handle at the time

  if (TotalMemory > FullSize) then

    IncVec = NumVec

  else

    IncVec = int(real(NumVec,kind=wp)*(TotalMemory/FullSize))

  end if
  if (IncVec <= 0) then
    call WarningMessage(2,'Create_Chunk: Failure IncVec <= 0')
    write(u6,*) 'FullSize=',FullSize
    write(u6,*) 'NumVec=',NumVec
    write(u6,*) 'LenVec=',LenVec
    write(u6,*) 'TotalMemory=',TotalMemory
    write(u6,*) 'Local size of memory'
    write(u6,*) (iMap(i),i=1,nProcs)
    write(u6,*) 'iTmp=',iTmp
    call Abend()
  end if

  ! Compute the number of vectors per node, This also defines the Map array.

  iNode0 = 0
  iStart = 1
  do iNode=0,nProcs-1
    if (iStart == 1) iNode0 = iNode
    iMap(1+iNode) = iStart
    iStart = iStart+max((IncVec+iNode)/nProcs,1)
  end do
  iMap(1+nProcs) = iStart
  IncVec0 = iStart

  !call Put_iArray('DistVec',iMap,nProcs+1)

  nBlocks = nProcs-iNode0
  myMap(1) = 1
  Ok = GA_Create_Irreg(mt_dbl,LenVec,IncVec0,'Chunk',myMap,1,iMap(1+iNode0),nBlocks,ip_Chunk)
  if (.not. Ok) then
    call WarningMessage(2,'Error in GA_Create_Irreg')
    call Abend()
  end if
else
  call mma_maxDBLE(MaxMem)
  IncVec = min(NumVec,MaxMem/LenVec)
  call mma_allocate(Chunk,LenVec*IncVec,Label='Chunk')
end if

!                                                                      *
!***********************************************************************
!                                                                      *
#else
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_maxDBLE(MaxMem)
IncVec = min(NumVec,MaxMem/LenVec)
call mma_allocate(Chunk,LenVec*IncVec,Label='Chunk')

#endif

return

end subroutine Create_Chunk

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine INPCTL_RASSI()

#ifdef _DMRG_
use qcmaquis_interface_cfg, only: qcmaquis_param
use qcmaquis_info, only: qcmaquis_info_init, qcm_prefixes
use qcmaquis_interface_mpssi, only: qcmaquis_mpssi_init
use rasscf_global, only: doDMRG
use rassi_data, only: NASH
use Cntrl, only: NACTE
use Definitions, only: u6
#endif
use mspt2_eigenvectors, only: init_mspt2_eigenvectors
use Symmetry_Info, only: nIrrep
use rassi_global_arrays, only: ESHFT, HAM, HDIAG, JBNUM, LROOT
use rassi_data, only: ENUC, NBASF
use Cntrl, only: BINA, HEff, IBINA, IfHDia, IFHEXT, IFShft, ISTAT, MLTPLT, MXJOB, NATO, nAtoms, NBINA, NJOB, NRNATO, NSTAT, &
                 NSTATE, RefEne
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: READ_STATES
integer(kind=iwp) :: i, JOB

! get basic info from runfile
call Get_iArray('nBas',nBasF,nIrrep)
call Get_dscalar('PotNuc',ENUC)

! Read data from the ONEINT file:
call GETCNT(NATOMS)

NSTATE = 0
! Read (and do some checking) the standard input.
call READIN_RASSI()
! if there have been no states selected at this point, we need to read
! the states later from the job files.
if (NSTATE == 0) then
  READ_STATES = .true.
  do JOB=1,NJOB
    call rdjob_nstates(JOB)
  end do
  ! store the root IDs of each state
  call mma_allocate(JBNUM,nState,Label='JBNUM')
  call mma_allocate(LROOT,nState,Label='LROOT')
  LROOT(:) = 0
  do JOB=1,NJOB
    JBNUM(ISTAT(JOB):ISTAT(JOB)+NSTAT(JOB)-1) = JOB
  end do
else
  READ_STATES = .false.
end if

if (NATO) then
  if (NRNATO > NSTATE) NRNATO = NSTATE
end if
if (BINA) then
  do I=1,NBINA
    if (maxval(IBINA(:,I)) > NSTATE) then
      call WarningMessage(2,'State number too high in NBINA')
      call Quit_OnUserError()
    end if
  end do
end if

#ifdef _DMRG_
!> initialize DMRG interface
if (doDMRG) then
  !> initialize only the qcm file name array (one for each job) and initialize the DMRG interface later
  call qcmaquis_info_init(njob,-1,0)
end if
#endif

!> initialize eigenvector array for mspt2 hamiltonians
call init_mspt2_eigenvectors(njob,-1,0)
! Allocate a bunch of stuff
call mma_allocate(REFENE,NSTATE,Label='RefEne')
call mma_allocate(HEFF,NSTATE,NSTATE,Label='HEff')
HEff(:,:) = Zero
if (.not. IFHEXT) then
  call mma_allocate(HAM,nState,nState,Label='HAM')
  HAM(:,:) = Zero
end if
if (.not. IFSHFT) then
  call mma_allocate(ESHFT,nSTATE,Label='ESHFT')
  ESHFT(:) = Zero
end if
if (.not. IFHDIA) call mma_Allocate(HDIAG,nState,Label='HDIAG')

! Read information on the job files and check for consistency
do JOB=1,NJOB
  call RDJOB(JOB,READ_STATES)
end do

! Number of active orbitals is taken from the first JobIph. MPS-SI cannot
! handle different active spaces per JobIph, but this is checked elsewhere
#ifdef _DMRG_
if (doDMRG) then
  !> stupid info.h defines "sum", so I cannot use the intrinsic sum function here...
  qcmaquis_param%L = 0
  do i=1,nIrrep
    qcmaquis_param%L = qcmaquis_param%L+nash(i)
  end do

  ! Initialise the new MPSSI interface
  call qcmaquis_mpssi_init(qcm_prefixes,LROOT,NSTAT(1),NJOB)

  ! Check if number of active electrons is the same for all job files
  ! Otherwise, quit on error, as Dyson orbitals are not supported yet with DMRG
  if (NJOB > 1) then
    JOB = NACTE(1)
    do i=2,NJOB
      if (NACTE(i) /= JOB) then
        call WarningMessage(2,'Number of active electrons')
        write(u6,*) ' is not the same in different JOBIPH files'
        write(u6,*) ' Dyson orbitals are not yet supported in MPSSI.'
        call Quit_OnUserError()
      end if
    end do
  end if

end if
#endif

! set orbital partitioning data
call WFNSIZES_RASSI()

! Added by Ungur Liviu on 04.11.2009
! Addition of NJOB,MSJOB and MLTPLT on RunFile.

call Put_iscalar('NJOB_SINGLE',NJOB)
call Put_iscalar('MXJOB_SINGLE',MXJOB)
call Put_iArray('MLTP_SINGLE',MLTPLT,MXJOB)

call Put_iArray('NSTAT_SINGLE',NSTAT,MXJOB)
!call Put_iArray('ISTAT_SINGLE',ISTAT,MXJOB)

! .. and print it out

! Additional input processing. Start writing report.
call INPPRC()

call mma_deallocate(REFENE)
call mma_deallocate(HEff)

end subroutine INPCTL_RASSI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Rs2Dgh(xyz2D0,nT,nRys,la,lb,lc,ld,xyz2D1,xyz2D2,
     &                  IfHss,IndHss,IfGrad,IndGrd,IfG,
     &                  Coora,Alpha,Beta,Gamma,Delta,nZeta,
     &                  nEta,Scrtch,Scrtch2,Temp,Index1,Index2,
     &                  Index3,Index4,ng,nh,
     &                  ExpX,ExpY,mZeta,mEta,nIrrep,Tr)
************************************************************************
*                                                                      *
* Object:To compute the gradients and the Hessians of the 2D-integrals.*
*                                                                      *
*     Author: Anders Bernhardsson & Roland Lindh,                      *
*             Dept. of Theoretical Chemistry,                          *
*             University of Lund, SWEDEN                               *
*             Februar '95                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      External ExpX, ExpY
#include "real.fh"
      Real*8 xyz2D0(nRys*nT,0:la+2,0:lb+2,0:lc+2,0:ld+2,3),
     &       xyz2D1(nRys*nT,0:la  ,0:lb  ,0:lc  ,0:ld  ,3,3),
     &       xyz2D2(nRys*nT,0:la  ,0:lb  ,0:lc  ,0:ld  ,3,6),
     &       Coora(3,4),
     &       Alpha(nZeta), Beta(nZeta), Gamma(nEta), Delta(nEta),
     &       Scrtch2(nRys*nT),Scrtch(nRys*nT), Temp(nT)
      Logical IfGrad(3,4),IfHss(4,3,4,3),IfG(4), EQ, Tr(4)
      Integer IndGrd(3,4,0:nIrrep-1), Ind1(3),
     &        Ind2(3),Ind3(3),Ind4(3),
     &        Index2(3,4,4),Index1(3,4),
     &        Index3(3,3),Index4(2,6,3),ng(3),nh(3),
     &        IndHss(4,3,4,3,0:nIrrep-1)
#ifdef NAGFOR
      Save Ind1, Ind2, Ind3, Ind4
#endif
*
      nx = 0
      ny = 0
      nz = 0
      mx=0
      my=0
      mz=0
      Call ICopy(12,[0],0,Index1,1)
      Call ICopy(48,[0],0,Index2,1)
*
*     Differentiate with respect to the first center
*
      If (IfG(1)) Then
        Call ExpX(Temp  ,mZeta,mEta,Alpha,Sqrt(Two))
        Call Exp_2(Scrtch,nRys,nT,Temp,Sqrt(Two))
        nVec = 0
        If (IfGrad(1,1)) Then
           nx = nx + 1
           nVec = nVec + 1
           Ind1(nVec) = nx
           Ind2(nVec) = 1
           Index1(1,1) =nx
           Index3(nx,1)=1
        End If
        If (IfGrad(2,1)) Then
           ny = ny + 1
           nVec = nVec + 1
           Ind1(nVec) = ny
           Ind2(nVec) = 2
           Index1(2,1) = ny
           Index3(ny,2)=1
        End If
        If (IfGrad(3,1)) Then
           nz = nz + 1
           nVec = nVec + 1
           Ind1(nVec) = nz
           Ind2(nVec) = 3
           Index1(3,1) = nz
           Index3(nz,3)=1
        End If
        Do i=nvec+1,3
         Ind1(i)=0
        End Do
*
        mvec=0
        If (IfHss(1,1,1,1)) Then
         mx=mx+1
         mvec=mvec+1
         Ind3(mVec) = mx
         Ind4(mVec) = 1
         Index2(1,1,1) = mx
         Index4(1,mx,1)=1
         Index4(2,mx,1)=1
        End If
        If (IfHss(1,2,1,2)) Then
         my=my+1
         mvec=mvec+1
         Ind3(mVec) = my
         Ind4(mVec) = 2
         Index2(2,1,1) = my
         Index4(1,my,2)=1
         Index4(2,my,2)=1
        End If
        If (IfHss(1,3,1,3)) Then
         mz=mz+1
         mvec=mvec+1
         Ind3(mVec) = mz
         Ind4(mVec) = 3
         Index2(3,1,1) = mz
         Index4(1,mz,3)=1
         Index4(2,mz,3)=1
        End If
        Do i=mvec+1,3
         Ind3(i)=0
        End Do
        nvecx=max(nvec,mvec)
        If (nVecx.ne.0) Then
*
*    Here we go with center 1
*
        Do n=1,nvec
         Do  id = 0, ld
          Do  ic = 0, lc
           Do  ib = 0, lb
            ra=-One
            Do  ia=0,la
             ra=ra+Two
             Do  iVec = 1, nRys*nT
              xyz2D1(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &                    Scrtch(iVec) *
     &                   xyz2D0(iVec,ia+1,ib,ic,id,Ind2(n))
             End Do
            End Do
           End Do
          End Do
         End Do
        End Do
        Do n=1,mvec
         Do  id = 0, ld
          Do  ic = 0, lc
           Do  ib = 0, lb
            ra=-One
            Do  ia=0,la
             ra=ra+Two
             Do  iVec = 1, nRys*nT
              xyz2D2(iVec,ia,ib,ic,id,Ind4(n),Ind3(n))=
     &                 Scrtch(iVec)**2*
     &               xyz2D0(iVec,ia+2,ib,ic,id,Ind4(n))-
     &                   ra*  Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,ic,id,Ind4(n))
             End Do
            End Do
           End Do
          End Do
         End Do
        End Do
        If (la.ge.1) Then
         Do n=1,nvec
          Do  id=0,ld
           Do  ic=0,lc
            Do  ib=0,lb
             ra=Zero
             Do  ia=1,la
              ra=ra+One
              Call DaXpY_inline(nRys*nT,-ra,
     &                   xyz2D0(1,ia-1,ib,ic,id,Ind2(n)),1,
     &                   xyz2D1(1,ia,ib,ic,id,Ind2(n),Ind1(n)),1)
             End Do
            End Do
           End Do
          End Do
         End Do
        End If
        If (la.ge.2) Then
          Do n=1,mvec
              Do  id=0,ld
             Do  ic=0,lc
            Do  ib=0,lb
           ra=One
           Do  ia=2,la
            ra=ra+One
               Fact=ra*ra-ra
               Call Daxpy_inline(nRys*nT,Fact,
     &                    xyz2D0(1,ia-2,ib,ic,id,Ind4(n)),1,
     &                    xyz2D2(1,ia,ib,ic,id,Ind4(n),Ind3(n)),1)
              End Do
             End Do
            End Do
           End Do
          End Do
        End If
        End If
      End If

*
*    Cross term center 1 and center 2
*
      If (IfG(2)) Then
         Call ExpX(Temp  ,mZeta,mEta,Beta,Sqrt(Two))
         Call Exp_2(Scrtch2,nRys,nT,Temp,Sqrt(Two))
      End If
      If (IfG(2).and.Ifg(1)) Then
        nVec=0
        If (ifHss(2,1,1,1)) Then
           mx=mx+1
           nVec = nVec + 1
           Ind1(nvec)=mx
           Ind2(nVec)=1
           Index2(1,2,1)=mx
           Index4(1,mx,1)=2
           Index4(2,mx,1)=1
        End If
        If (ifHss(2,2,1,2)) Then
           my=my+1
           nVec = nVec + 1
           Ind1(nvec)=my
           Ind2(nVec)=2
           Index2(2,2,1)=my
           Index4(1,my,2)=2
           Index4(2,my,2)=1
        End If
        If (ifHss(2,3,1,3)) Then
           mz=mz+1
           nVec = nVec + 1
           Ind1(nvec)=mz
           Ind2(nVec)=3
           Index2(3,2,1)=mz
           Index4(1,mz,3)=2
           Index4(2,mz,3)=1
        End If
        Do i=nVec+1,3
          Ind1(i)=0
        End Do
        If (nvec.ne.0) Then
        Do n=1,nvec
         Do  id = 0, ld
          Do   ic = 0, lc
           Do  ib=0,lb
            Do  ia=0,la
             Do  iVec = 1, nRys*nT
              xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               Scrtch(iVec)  *  Scrtch2(iVec)*
     &               xyz2D0(iVec,ia+1,ib+1,ic,id,Ind2(n))
             End DO
            End DO
           End DO
          End DO
         End DO
        End DO
        If (la.ge.1) Then
         Do n=1,nvec
          Do  id = 0, ld
           Do  ic = 0, lc
            Do  ib=0,lb
             ra=Zero
             Do  ia=1,la
              ra=ra+One
              Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  ra  *  Scrtch2(iVec)*
     &                  xyz2D0(iVec,ia-1,ib+1,ic,id,Ind2(n))
              End Do
             End Do
            End Do
           End Do
          End Do
         End Do
        End If
        If (lb.ge.1) Then
         Do n=1,nvec
          Do   id = 0, ld
           Do  ic = 0, lc
            rb=Zero
            Do  ib=1,lb
             rb=rb+One
             Do  ia=0,la
              Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  rb  *  Scrtch(iVec)*
     &                  xyz2D0(iVec,ia+1,ib-1,ic,id,Ind2(n))
              End Do
             End Do
            End Do
           End Do
          End Do
         End Do
        End If
        If ((la.ge.1).and.(lb.ge.1)) Then
         Do n=1,nvec
          Do  id = 0, ld
           Do  ic = 0, lc
            rb=Zero
            Do  ib=1,lb
             rb=rb+One
             ra=Zero
             Do  ia=1,la
              ra=ra+One
              Fact=ra*rb
              Call DaXpY_inline(nRys*nT,Fact,
     &                   xyz2D0(1,ia-1,ib-1,ic,id,Ind2(n)),1,
     &                   xyz2D2(1,ia,ib,ic,id,Ind2(n),Ind1(n)),1)
             End Do
            End Do
           End Do
          End Do
         End Do
        End If
        End If
      End If
*
*     Differentiate with respect to the second center
*
*
      If (IfG(2) ) Then
         Call ExpX(Temp  ,mZeta,mEta,Beta,Sqrt(Two))
         Call Exp_2(Scrtch2,nRys,nT,Temp,Sqrt(Two))
        nVec = 0
        If (IfGrad(1,2)) Then
         nx = nx + 1
         nVec = nVec + 1
         Ind1(nVec) = nx
         Ind2(nVec) = 1
         Index1(1,2) = nx
         Index3(nx,1)=2
        End If
        If (IfGrad(2,2)) Then
         ny = ny + 1
         nVec = nVec + 1
         Ind1(nVec) = ny
         Ind2(nVec) = 2
         Index3(ny,2)=2
         Index1(2,2) = ny
        End If
        If (IfGrad(3,2)) Then
         nz = nz + 1
         nVec = nVec + 1
         Ind1(nVec) = nz
         Ind2(nVec) = 3
         Index1(3,2) = nz
         Index3(nz,3)=2
        End If
        Do i=nvec+1,3
         Ind1(i)=0
        End Do
*
        mvec=0
        If (IfHss(2,1,2,1)) Then
          mx=mx+1
          mvec=mvec+1
          Ind3(mVec) = mx
          Ind4(mVec) = 1
          Index2(1,2,2) = mx
          Index4(1,mx,1)=2
          Index4(2,mx,1)=2
        End If
        If (IfHss(2,2,2,2)) Then
          my=my+1
          mvec=mvec+1
          Ind3(mVec) = my
          Ind4(mvec)=2
          Index2(2,2,2) = my
          Index4(1,my,2)=2
          Index4(2,my,2)=2
        End If
        If (IfHss(2,3,2,3)) Then
          mz=mz+1
          mvec=mvec+1
          Ind3(mVec) = mz
          Ind4(mVec) = 3
          Index2(3,2,2) = mz
          Index4(1,mz,3)=2
          Index4(2,mz,3)=2
        End If
        Do i=mvec+1,3
         Ind3(i)=0
        End Do
        nvecx=max(nvec,mvec)
        If (nVecx.ne.0) Then
*
        Do n=1,nVec
         Do  id = 0, ld
          Do  ic = 0, lc
           rb=-One
           Do  ib=0,lb
            rb=rb+Two
            Do  ia = 0, la
             Do  iVec = 1, nRys*nT
              xyz2D1(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &                   Scrtch2(iVec) *
     &                 xyz2D0(iVec,ia,ib+1,ic,id,Ind2(n))
             End Do
            End Do
           End Do
          End Do
         End Do
        End Do
        Do n=1,mVec
         Do  id = 0, ld
          Do  ic = 0, lc
           rb=-One
           Do  ib=0,lb
            rb=rb+Two
            Do  ia = 0, la
             Do  iVec = 1, nRys*nT
              xyz2D2(iVec,ia,ib,ic,id,Ind4(n),Ind3(n))=
     &                 Scrtch2(iVec)**2*
     &               xyz2D0(iVec,ia,ib+2,ic,id,Ind4(n))-
     &               rb * Scrtch2(iVec) *
     &               xyz2D0(iVec,ia,ib,ic,id,Ind4(n))
             End Do
            End Do
           End Do
          End Do
         End Do
        End Do

        If (lb.ge.1) Then
         Do n=1,nvec
             Do  id=0,ld
            Do  ic=0,lc
           rb=Zero
           Do  ib=1,lb
            rb=rb+One
          Do  ia=0,la
              Call DaXpy_inline(nRys*nT,-rb,
     &                   xyz2D0(1,ia,ib-1,ic,id,Ind2(n)),1,
     &                   xyz2D1(1,ia,ib,ic,id,Ind2(n),Ind1(n)),1)
             End Do
            End Do
           End Do
          End Do
         End Do
        End If
        If (lb.ge.2) Then
         Do n=1,mvec
             Do  id=0,ld
            Do  ic=0,lc
           rb=One
           Do  ib=2,lb
            rb=rb+One
              Fact=rb*rb-rb
          Do  ia=0,la
              Call DaXpy_inline(nRys*nT,Fact,
     &                   xyz2D0(1,ia,ib-2,ic,id,Ind4(n)),1,
     &                   xyz2D2(1,ia,ib,ic,id,Ind4(n),Ind3(n)),1)
             End Do
            End Do
           End Do
          End Do
         End Do
        End If
        End If
      End If
*   Cross Term center 2 and 3
*
      If (IfG(2).and.IfG(3)) Then
         Call ExpX(Temp  ,mZeta,mEta,Beta,Sqrt(Two))
         Call Exp_2(Scrtch2,nRys,nT,Temp,Sqrt(Two))
         Call ExpY(Temp  ,mZeta,mEta,Gamma,Sqrt(Two))
         Call Exp_2(Scrtch,nRys,nT,Temp,Sqrt(Two))
         nVec=0
       If (ifHss(3,1,2,1)) Then
         mx=mx+1
         nVec = nVec + 1
         Ind1(nvec)=mx
         Ind2(nVec)=1
         Index2(1,3,2)=mx
         Index4(1,mx,1)=3
         Index4(2,mx,1)=2
       End If
       If (ifHss(3,2,2,2)) Then
         my=my+1
         nVec = nVec + 1
         Ind1(nvec)=my
         Ind2(nVec)=2
         Index2(2,3,2)=my
         Index4(1,my,2)=3
         Index4(2,my,2)=2
       End If
       If (ifHss(3,3,2,3)) Then
         mz=mz+1
         nVec = nVec + 1
         Ind1(nvec)=mz
         Ind2(nVec)=3
         Index2(3,3,2)=mz
         Index4(1,mz,3)=3
         Index4(2,mz,3)=2
       End If
       Do i=nVec+1,3
        Ind1(i)=0
       End Do
       If (nvec.ne.0) Then

       Do n=1,nvec
        Do  id = 0, ld
         Do  ic = 0, lc
          Do  ib = 0, lb
           Do  ia = 0, la
            Do  iVec = 1, nRys*nT
              xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               Scrtch(iVec)  *  Scrtch2(iVec)*
     &               xyz2D0(iVec,ia,ib+1,ic+1,id,Ind2(n))
            End Do
           End Do
          End Do
         End Do
        End Do
       End Do
       If (lb.ge.1) Then
        Do n=1,nvec
         Do  id = 0, ld
          Do ic = 0, lc
           rb=Zero
           Do ib=1,lb
            rb=rb+One
            Do  ia=0,la
             Do  iVec = 1, nRys*nT
              xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &        xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                rb  *  Scrtch(iVec)*
     &                xyz2D0(iVec,ia,ib-1,ic+1,id,Ind2(n))
             End DO
            End DO
           End DO
          End DO
         End DO
        End DO
       End If
       If (lc.ge.1) Then
        Do n=1,nvec
         Do   id = 0, ld
          rc=Zero
          Do  ic = 1, lc
           rc=rc+One
           Do  ib=0,lb
            Do  ia=0,la
             Do  iVec = 1, nRys*nT
               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &                xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                rc  * Scrtch2(iVec)*
     &                xyz2D0(iVec,ia,ib+1,ic-1,id,Ind2(n))
             End Do
            End Do
           End Do
          End Do
         End Do
        End Do
       End If
       If ((lb.ge.1).and.(lc.ge.1)) Then
        Do n=1,nvec
         Do  id = 0, ld
          rc=Zero
          Do  ic = 1, lc
           rc=rc+One
           rb=Zero
           Do  ib=1,lb
            rb=rb+One
            Fact=rb*rc
            Do  ia=0,la
             Call DaxPy_inline(nRys*nT,Fact,
     &                  xyz2D0(1,ia,ib-1,ic-1,id,Ind2(n)),1,
     &                  xyz2D2(1,ia,ib,ic,id,Ind2(n),Ind1(n)),1)
            End Do
           End Do
          End Do
         End Do
        End Do
       End If
       End If
      End If
*
*
*     Differentiate with respect to the third center
*
      If (IfG(3)) Then
         Call ExpY(Temp  ,mZeta,mEta,Gamma,Sqrt(Two))
         Call Exp_2(Scrtch,nRys,nT,Temp,Sqrt(Two))
       nvec=0
       If (IfGrad(1,3)) Then
         nx = nx + 1
         nVec = nVec + 1
         Ind1(nVec) = nx
         Ind2(nVec) = 1
         Index1(1,3) = nx
         Index3(nx,1)=3
       End If
       If (IfGrad(2,3)) Then
         ny = ny + 1
         nVec = nVec + 1
         Ind1(nVec) = ny
         Ind2(nVec) = 2
         Index1(2,3) = ny
         Index3(ny,2)=3
       End If
       If (IfGrad(3,3)) Then
         nz = nz + 1
         nVec = nVec + 1
         Ind1(nVec) = nz
         Ind2(nVec) = 3
         Index1(3,3) = nz
         Index3(nz,3)=3
       End If
       Do i=nvec+1,3
        Ind1(i)=0
       End Do
*
       mvec=0
       If (IfHss(3,1,3,1)) Then
        mx=mx+1
        mvec=mvec+1
        Ind3(mVec) = mx
        Ind4(mVec) = 1
        Index2(1,3,3) = mx
        Index4(1,mx,1)=3
        Index4(2,mx,1)=3
       End If
       If (IfHss(3,2,3,2)) Then
        my=my+1
        mvec=mvec+1
        Ind3(mVec) = my
        Ind4(mVec) = 2
        Index2(2,3,3) = my
        Index4(1,my,2)=3
        Index4(2,my,2)=3
       End If
       If (IfHss(3,3,3,3)) Then
        mz=mz+1
        mvec=mvec+1
        Ind3(mVec) = mz
        Ind4(mVec) = 3
        Index2(3,3,3) = mz
        Index4(1,mz,3)=3
        Index4(2,mz,3)=3
       End If
       Do i=mvec+1,3
        Ind3(i)=0
       End Do
       nvecx=max(nvec,mvec)
       If (nVecx.ne.0) Then
       Do n=1,nvec
        Do  id = 0, ld
         rc=-One
         Do  ic = 0, lc
          rc=rc+Two
          Do  ib=0,lb
           Do  ia = 0, la
            Do  iVec = 1, nRys*nT
             xyz2D1(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &            Scrtch(iVec) *
     &            xyz2D0(iVec,ia,ib,ic+1,id,Ind2(n))
            End Do
           End Do
          End Do
         End Do
        End Do
       End Do
       Do n=1,mvec
        Do  id = 0, ld
         rc=-One
         Do  ic = 0, lc
          rc=rc+Two
          Do  ib=0,lb
           Do  ia = 0, la
            Do  iVec = 1, nRys*nT
                      xyz2D2(iVec,ia,ib,ic,id,Ind4(n),Ind3(n))=
     &                    Scrtch(iVec)**2*
     &                    xyz2D0(iVec,ia,ib,ic+2,id,Ind4(n))-
     &                    Rc* Scrtch(iVec) *
     &                    xyz2D0(iVec,ia,ib,ic,id,Ind4(n))
            End Do
           End Do
          End Do
         End Do
        End Do
       End Do

       If (lc.ge.1) Then
        Do n=1,nvec
            Do  id=0,ld
           rc=Zero
           Do ic=1,lc
            rc=rc+One
          Do  ib=0,lb
         Do  ia=0,la
             Call DaXpY_inline(nRys*nT,-rc,
     &                  xyz2D0(1,ia,ib,ic-1,id,Ind2(n)),1,
     &                  xyz2D1(1,ia,ib,ic,id,Ind2(n),Ind1(n)),1)
            End Do
           End Do
          End Do
         End Do
        End Do
       End If
       If (lc.ge.2) Then
        Do n=1,mvec
            Do id=0,ld
           rc=One
           Do ic=2,lc
            rc=rc+One
            Fact=rc*rc-rc
          Do  ib=0,lb
         Do  ia=0,la
             Call DaXpY_inline(nt*nrys,Fact,
     &                  xyz2D0(1,ia,ib,ic-2,id,Ind4(n)),1,
     &                  xyz2D2(1,ia,ib,ic,id,Ind4(n),Ind3(n)) ,1)
            End Do
           End Do
          End Do
         End Do
        End Do
       End If
       End If
      End If
*
*         Cross term 1 3
*
      If (IfG(1).and.IfG(3)) Then
         Call ExpX(Temp  ,mZeta,mEta,Alpha,Sqrt(Two))
         Call Exp_2(Scrtch2,nRys,nT,Temp,Sqrt(Two))
         Call ExpY(Temp  ,mZeta,mEta,Gamma,Sqrt(Two))
         Call Exp_2(Scrtch,nRys,nT,Temp,Sqrt(Two))
         nVec = 0
         If (ifHss(3,1,1,1)) Then
           mx=mx+1
           nVec = nVec + 1
           Ind1(nvec)=mx
           Ind2(nVec)=1
           Index4(1,mx,1)=3
           Index4(2,mx,1)=1
           Index2(1,3,1)=mx
         End If
         If (ifHss(3,2,1,2)) Then
           my=my+1
           nVec = nVec + 1
           Ind1(nvec)=my
           Ind2(nVec)=2
           Index4(1,my,2)=3
           Index4(2,my,2)=1
           Index2(2,3,1)=my
         End If
         If (ifHss(3,3,1,3)) Then
           mz=mz+1
           nVec = nVec + 1
           Ind1(nvec)=mz
           Ind2(nVec)=3
           Index4(1,mz,3)=3
           Index4(2,mz,3)=1
           Index2(3,3,1)=mz
         End If
         Do i=nVec+1,3
           Ind1(i)=0
         End Do
         If (nVec.ne.0) Then
         Do n=1,nvec
          Do  id = 0, ld
           Do  ic = 0, lc
            Do  ib = 0, lb
             Do  ia = 0, la
              Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &                   Scrtch(iVec)  *  Scrtch2(iVec)*
     &                  xyz2D0(iVec,ia+1,ib,ic+1,id,Ind2(n))
              End Do
             End Do
            End Do
           End Do
          End Do
         End Do
         If (la.ge.1) Then
          Do n=1,nvec
           Do  id = 0, ld
            Do  ic = 0, lc
             Do  ib=0,lb
              ra=Zero
              Do  ia=1,la
                ra=ra+One
                Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  ra  *  Scrtch(iVec)*
     &                  xyz2D0(iVec,ia-1,ib,ic+1,id,Ind2(n))
                End Do
              End Do
             End Do
            End Do
           End Do
          End Do
         End If
         If (lc.ge.1) Then
          Do n=1,nVec
           Do  id = 0, ld
            rc=Zero
            Do  ic = 1, lc
             rc=rc+One
             Do  ib=0,lb
              Do  ia=0,la
                Do  iVec = 1, nRys*nT
                   xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  rc  *  Scrtch2(iVec)*
     &                  xyz2D0(iVec,ia+1,ib,ic-1,id,Ind2(n))
                End Do
              End Do
             End Do
            End Do
           End Do
          End Do
         End If
         If ((la.ge.1).and.(lc.ge.1)) Then
          Do n=1,nvec
           Do  id = 0, ld
            rc=Zero
            Do  ic = 1, lc
             rc=rc+One
             Do  ib=0,lb
              ra=Zero
              Do  ia=1,la
               ra=ra+One
               Fact=rc*ra
               Call DaXpy_inline(nt*nrys,Fact,
     &                    xyz2D0(1,ia-1,ib,ic-1,id,Ind2(n)),1,
     &               xyz2D2(1,ia,ib,ic,id,Ind2(n),Ind1(n)) ,1)
              End Do
             End Do
            End Do
           End Do
          End Do
         End If
         End If
      End If
*                 1 4

      If (IfG(4)) Then
       Call ExpY(Temp  ,mZeta,mEta,Delta,Sqrt(Two))
       Call Exp_2(Scrtch,nRys,nT,Temp,Sqrt(Two))
       If (IfG(1)) Then
         Call ExpX(Temp  ,mZeta,mEta,Alpha,Sqrt(Two))
         Call Exp_2(Scrtch2,nRys,nT,Temp,Sqrt(Two))
         nVec=0
         If (ifHss(4,1,1,1)) Then
          mx=mx+1
          nVec = nVec + 1
          Ind1(nvec)=mx
          Ind2(nVec)=1
          Index2(1,4,1)=mx
          Index4(1,mx,1)=4
          Index4(2,mx,1)=1
         End If
         If (ifHss(4,2,1,2)) Then
          my=my+1
          nVec = nVec + 1
          Ind1(nvec)=my
          Ind2(nVec)=2
          Index2(2,4,1)=my
          Index4(1,my,2)=4
          Index4(2,my,2)=1
         End If
         If (ifHss(4,3,1,3)) Then
          mz=mz+1
          nVec = nVec + 1
          Ind1(nvec)=mz
          Ind2(nVec)=3
          Index2(3,4,1)=mz
          Index4(1,mz,3)=4
          Index4(2,mz,3)=1
         End If
         Do i=nVec+1,3
          Ind1(i)=0
         End Do
*
         If (nVec.ne.0) Then
*
         Do n=1,nvec
          Do  id = 0, ld
           Do  ic = 0, lc
            Do  ib = 0, lb
             Do  ia = 0, la
              Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &                   Scrtch(iVec)  *  Scrtch2(iVec)*
     &                  xyz2D0(iVec,ia+1,ib,ic,id+1,Ind2(n))
              End Do
             End Do
            End Do
           End Do
          End Do
         End Do

         If (la.ge.1) Then
          Do n=1,nvec
           Do  id = 0, ld
            Do  ic = 0, lc
             Do  ib=0,lb
              ra=Zero
              Do  ia=1,la
               ra=ra+One
               Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  ra  *  Scrtch(iVec)*
     &                  xyz2D0(iVec,ia-1,ib,ic,id+1,Ind2(n))
               End Do
              End Do
             End Do
            End Do
           End Do
          End Do
         End If


         If (ld.ge.1) Then
           Do n=1,nvec
           rd=Zero
            Do  id = 1, ld
             rd=rd+One
             Do  ic = 0, lc
              Do  ib=0,lb
               Do ia=0,la
                Do iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  rd  *  Scrtch2(iVec)*
     &                  xyz2D0(iVec,ia+1,ib,ic,id-1,Ind2(n))
                End Do
               End Do
              End Do
             End Do
            End Do
           End Do
         End If
         If ((la.ge.1).and.(ld.ge.1)) Then
          Do n=1,nvec
           rd=Zero
           Do  id = 1, ld
            rd=rd+One
            Do  ic = 0, lc
             Do  ib=0,lb
              ra=Zero
              Do  ia=1,la
                ra=ra+One
                Fact=rd*ra
                      Call DaxPy_inline( nRys*nT,Fact,
     &                  xyz2D0(1,ia-1,ib,ic,id-1,Ind2(n)),1,
     &                  xyz2D2(1,ia,ib,ic,id,Ind2(n),Ind1(n)),1)
              End Do
             End Do
            End Do
           End Do
          End Do
         End If
         End If
        End If
*
*        Cross terms between 2 4
*
        If (IfG(2).and.Ifg(4)) Then
         Call ExpX(Temp  ,mZeta,mEta,Beta,Sqrt(Two))
         Call Exp_2(Scrtch2,nRys,nT,Temp,Sqrt(Two))
         nVec=0
         If (ifHss(4,1,2,1)) Then
            mx=mx+1
            nVec = nVec + 1
            Ind1(nvec)=mx
            Ind2(nVec)=1
            Index2(1,4,2)=mx
            Index4(1,mx,1)=4
            Index4(2,mx,1)=2
         End If
         If (ifHss(4,2,2,2)) Then
            my=my+1
            nVec = nVec + 1
            Ind1(nvec)=my
            Ind2(nVec)=2
            Index2(2,4,2)=my
            Index4(1,my,2)=4
            Index4(2,my,2)=2
         End If
         If (ifHss(4,3,2,3)) Then
            mz=mz+1
            nVec = nVec + 1
            Ind1(nvec)=mz
            Ind2(nVec)=3
            Index2(3,4,2)=mz
            Index4(1,mz,3)=4
            Index4(2,mz,3)=2
         End If
         Do i=nVec+1,3
           Ind1(i)=0
         End Do
*
         If (nvec.ne.0) Then
*

         Do n=1,nvec
          Do  id = 0, ld
           Do  ic = 0, lc
            Do  ib = 0, lb
             Do  ia = 0, la
                Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &                   Scrtch(iVec)  *  Scrtch2(iVec)*
     &                  xyz2D0(iVec,ia,ib+1,ic,id+1,Ind2(n))
                End Do
             End Do
            End Do
           End Do
          End Do
         End Do

         If (lb.ge.1) Then
          Do n=1,nvec
           Do  id = 0, ld
            Do  ic = 0, lc
             rb=Zero
             Do  ib=1,lb
              rb=rb+One
              Do  ia=0,la
                Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  rb  *  Scrtch(iVec)*
     &                  xyz2D0(iVec,ia,ib-1,ic,id+1,Ind2(n))
                End Do
              End Do
             End Do
            End Do
           End Do
          End Do
         End If


         If (ld.ge.1) Then
          Do n=1,nvec
           rd=Zero
           Do   id = 1, ld
            rd=rd+One
            Do  ic = 0, lc
             Do  ib=0,lb
              Do  ia=0,la
                Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  rd  *  Scrtch2(iVec)*
     &                  xyz2D0(iVec,ia,ib+1,ic,id-1,Ind2(n))
                End do
              End do
             End do
            End do
           End do
          End do
         End If
         If ((lb.ge.1).and.(ld.ge.1)) Then
          Do n=1,nvec
           rd=Zero
           Do  id = 1, ld
            rd=rd+One
            Do  ic = 0, lc
             rb=Zero
             Do ib=1,lb
              rb=rb+One
              Do ia=0,la
                Fact=rb*rd
                     Call DaxPy_inline(nt*nrys,Fact,
     &                  xyz2D0(1,ia,ib-1,ic,id-1,Ind2(n)),1,
     &               xyz2D2(1,ia,ib,ic,id,Ind2(n),Ind1(n)),1)
              End Do
             End Do
            End Do
           End Do
          End Do
         End If
         End If
        End If
*
*       Cross Term 3 4
*
        If (IfG(3).and.IfG(4)) Then
         Call ExpY(Temp  ,mZeta,mEta,Gamma,Sqrt(Two))
         Call Exp_2(Scrtch2,nRys,nT,Temp,Sqrt(Two))
         nVec=0
         If (ifHss(4,1,3,1)) Then
           mx=mx+1
           nVec = nVec + 1
           Ind1(nvec)=mx
           Ind2(nVec)=1
           Index2(1,4,3)=mx
           Index4(1,mx,1)=4
           Index4(2,mx,1)=3
         End If
         If (ifHss(4,2,3,2)) Then
           my=my+1
           nVec = nVec + 1
           Ind1(nvec)=my
           Ind2(nVec)=2
           Index2(2,4,3)=my
           Index4(1,my,2)=4
           Index4(2,my,2)=3

         End If
         If (ifHss(4,3,3,3)) Then
           mz=mz+1
           nVec = nVec + 1
           Ind1(nvec)=mz
           Ind2(nVec)=3
           Index2(3,4,3)=mz
           Index4(1,mz,3)=4
           Index4(2,mz,3)=3
         End If
         Do i=nVec+1,3
          Ind1(i)=0
         End Do
*
         If (nvec.ne.0) Then
*
         Do n=1,nvec
          Do  id = 0, ld
           Do  ic = 0, lc
            Do  ib = 0, lb
             Do  ia = 0, la
              Do iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &                   Scrtch(iVec)  *  Scrtch2(iVec)*
     &                  xyz2D0(iVec,ia,ib,ic+1,id+1,Ind2(n))
              End Do
             End Do
            End Do
           End Do
          End Do
         End Do

         If (lc.ge.1) Then
          Do n=1,nvec
           Do  id = 0, ld
            rc=Zero
            Do  ic = 1, lc
             rc=rc+One
             Do  ib=0,lb
              Do  ia=0,la
                Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  rc  *  Scrtch(iVec)*
     &                  xyz2D0(iVec,ia,ib,ic-1,id+1,Ind2(n))
                 End Do
              End Do
             End Do
            End Do
           End Do
          End Do
         End If
         If (ld.ge.1) Then
          Do n=1,nvec
           rd=Zero
           Do   id = 1, ld
            rd=rd+One
            Do  ic = 0, lc
             Do  ib=0,lb
              Do  ia=0,la
                Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &               xyz2D2(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) -
     &                  rd  *  Scrtch2(iVec)*
     &                  xyz2D0(iVec,ia,ib,ic+1,id-1,Ind2(n))
                End DO
              End DO
             End DO
            End DO
           End DO
          End DO
         End If
         If ((lc.ge.1).and.(ld.ge.1)) Then
          Do n=1,nvec
           rd=Zero
           Do  id = 1, ld
            rd=rd+One
            rc=Zero
            Do  ic = 1, lc
             rc=rc+One
             Do  ib=0,lb
              Do ia=0,la
                Fact=rc*rd
                Call DaxPy_inline(nt*nRys,fact,
     &                  xyz2D0(1,ia,ib,ic-1,id-1,Ind2(n)),1,
     &               xyz2D2(1,ia,ib,ic,id,Ind2(n),Ind1(n)),1)
              End Do
             End Do
            End Do
           End Do
          End Do
         End If
         End If
        End If
*
*     Differentiate with respect to the fourth center
*
          nvec=0
          If (IfGrad(1,4)) Then
            nx = nx + 1
            nVec = nVec + 1
            Ind1(nVec) = nx
            Ind2(nVec) = 1
            Index1(1,4) = nx
            Index3(nx,1)=4
          End If
          If (IfGrad(2,4)) Then
             ny = ny + 1
             nVec = nVec + 1
             Ind1(nVec) = ny
             Ind2(nVec) = 2
             Index1(2,4) = ny
             Index3(ny,2)=4
          End If
          If (IfGrad(3,4)) Then
             nz = nz + 1
             nVec = nVec + 1
             Ind1(nVec) = nz
             Ind2(nVec) = 3
             Index1(3,4) = nz
             Index3(nz,3)=4
          End If
          Do i=nvec+1,3
           Ind1(i)=0
          End Do
*
          mvec=0
          If (IfHss(4,1,4,1)) Then
           mx=mx+1
           mvec=mvec+1
           Ind3(mVec) = mx
           Ind4(mVec) = 1
           Index2(1,4,4) = mx
           Index4(1,mx,1)=4
           Index4(2,mx,1)=4
          End If
          If (IfHss(4,2,4,2)) Then
            my=my+1
            mvec=mvec+1
            Ind3(mVec) = my
            Ind4(mVec) = 2
            Index2(2,4,4) = my
            Index4(1,my,2)=4
            Index4(2,my,2)=4
          End If
          If (IfHss(4,3,4,3)) Then
            mz=mz+1
            mvec=mvec+1
            Ind3(mVec) = mz
            Ind4(mVec) = 3
            Index2(3,4,4) = mz
            Index4(1,mz,3)=4
            Index4(2,mz,3)=4
          End If
          Do i=mvec+1,3
           Ind3(i)=0
          End Do
          nvecx=max(nvec,mvec)
*
          If (nVecx.ne.0) Then
*
          Do n=1,nvec
           rd=-One
           Do  id = 0, ld
            rd=rd+Two
            Do  ic = 0, lc
             Do ib=0,lb
              Do  ia = 0, la
               Do  iVec = 1, nRys*nT
                xyz2D1(iVec,ia,ib,ic,id,Ind2(n),Ind1(n)) =
     &                   Scrtch(iVec) *
     &                 xyz2D0(iVec,ia,ib,ic,id+1,Ind2(n))
               End do
              End do
             End do
            End do
           End do
          End do
          Do n=1,mvec
           rd=-One
           Do  id = 0, ld
            rd=rd+Two
            Do  ic = 0, lc
             Do ib=0,lb
              Do  ia = 0, la
               Do  iVec = 1, nRys*nT
                     xyz2D2(iVec,ia,ib,ic,id,Ind4(n),Ind3(n))=
     &                   Scrtch(iVec)**2*
     &                   xyz2D0(iVec,ia,ib,ic,id+2,Ind4(n))-
     &                   rd* Scrtch(iVec) *
     &                   xyz2D0(iVec,ia,ib,ic,id,Ind4(n))
               End do
              End do
             End do
            End do
           End do
          End do
          If (ld.ge.1) Then
            Do n=1,nvec
                rd=Zero
                Do  id=1,ld
                 rd=rd+One
               Do  ic=0,lc
              Do  ib=0,lb
             Do  ia=0,la
                 Call Daxpy_inline(nt*nrys,-rd,
     &                      xyz2D0(1,ia,ib,ic,id-1,Ind2(n)),1,
     &                      xyz2D1(1,ia,ib,ic,id,Ind2(n),Ind1(n)),1)
                End DO
               End DO
              End DO
             End DO
            End DO
           End If
           If (ld.ge.2) Then
            Do n=1,mvec
                rd=One
                Do  id=2,ld
                 rd=rd+One
                 Fact=rd*rd-rd
               Do  ic=0,lc
              Do ib=0,lb
             Do ia=0,la
                 Call Daxpy_inline(nt*nrys,Fact,
     &                      xyz2D0(1,ia,ib,ic,id-2,Ind4(n)),1,
     &                      xyz2D2(1,ia,ib,ic,id,Ind4(n),Ind3(n)),1)
                End Do
               End Do
              End Do
             End Do
            End Do
           End If

           End If
      End If
*
*-----Sum over common centers
*
      Do iCent = 1, 3
         If (IfG(iCent)) Then
         Do jCent =  iCent+1, 4
            If (EQ(Coora(1,iCent),Coora(1,jCent))) Then
              If  (IfG(jCent)) Then
               Do iCar = 1, 3
                     i1 = Index2(iCar,iCent,iCent)
                     i2 = Index2(iCar,jCent,jCent)
                     i3 = Index2(iCar,jCent,iCent)
                     j4=Index1(iCar,jCent)
                     j5=Index1(iCar,iCent)
                     If (IfHss(jCent,iCar,jCent,iCar).and.
     &                   IfHss(iCent,iCar,iCent,iCar)) Then
                       Call DaXpY_inline(
     &                          nRys*nT*(la+1)*(lb+1)*(lc+1)*(ld+1),
     &                          One,xyz2D2(1,0,0,0,0,iCar,i2),1,
     &                          xyz2D2(1,0,0,0,0,iCar,i1),1)
                     End If
                     If (IfHss(jCent,iCar,iCent,iCar).and.
     &                   IfHss(iCent,iCar,iCent,iCar)) Then
                        Call DaXpY_inline(
     &                          nRys*nT*(la+1)*(lb+1)*(lc+1)*(ld+1),
     &                          Two,xyz2D2(1,0,0,0,0,iCar,i3),1,
     &                          xyz2D2(1,0,0,0,0,iCar,i1),1)
                     End If
                     If ((j4.ne.0).and.(j5.ne.0).and.
     &               (ifgrad(iCar,iCent).and.ifgrad(iCar,jCent)))
     &               Call DaXpY_inline(
     &                          nRys*nT*(la+1)*(lb+1)*
     &                          (lc+1)*(ld+1),
     &                          One,xyz2D1(1,0,0,0,0,iCar,j4),1,
     &                          xyz2D1(1,0,0,0,0,iCar,j5),1)
                     Do kCent=1,4
                      If (IfG(kCent)) Then
                       If ((kcent.ne.iCent).and.(kcent.ne.jcent))
     &                 Then
                        If (ifHss(kCent,iCar,jCent,iCar).or.
     &                       ifHss(jCent,iCar,kCent,iCar)) Then
                          i4=Index2(iCar,Max(kCent,jCent),
     &                                    Min(jCent,kCent))
                          i5=Index2(iCar,Max(kCent,iCent),
     &                                    Min(iCent,kCent))
                          Call DaXpY_inline(
     &                          nRys*nT*(la+1)*(lb+1)*(lc+1)*(ld+1),
     &                          One,xyz2D2(1,0,0,0,0,iCar,i4),1,
     &                          xyz2D2(1,0,0,0,0,iCar,i5),1)
                        End If
                       End If
                      End If
               End Do ! kCent
               End Do ! iCar
*
               IfG(jCent)=.false.
               Tr(jCent)=.false.
               Do jCar=1,3
               IfGrad(jcar,jCent)=.false.
                Do iIrrep=0,nIrrep-1
                   IndGrd(jCar,jcent,iIrrep)=0
                End Do
                Do kCent=1,4
                 Do kCar=1,3
                  IfHss(jCent,jCar,kCent,kCar)=.false.
                  IfHss(kCent,kCar,jCent,jCar)=.false.
                  Do iIrrep=0,nIrrep-1
                   IndHss(jCent,jCar,kCent,kCar,iIrrep)=0
                   IndHss(kCent,kCar,jCent,jCar,iIrrep)=0
                  End Do
                 End Do
                End Do
               End Do
*
              End If
         End If ! end eq
         End Do    ! jCent
         End If
      End Do       ! iCent
*
      nh(1)=mx
      nh(2)=my
      nh(3)=mz
      ng(1)=nx
      ng(2)=ny
      ng(3)=nz

      Return
      End
      Subroutine Daxpy_inline(nt,r,A,inca,B,incB)
      Implicit Real*8 (A-H,O-Z)
      Real*8 A(*),B(*)
      Do i=1,nt
       B(i)=B(i)+r*A(i)
      end do
      return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(inca)
         Call Unused_integer(incB)
      End If
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine optize2_cvb(fx,nparm,ioptc,
     >  dx,grad,iter_is_1,
     >  opta,optb)
      implicit real*8 (a-h,o-z)
      logical opth,skipupd,first_time
      logical iter_is_1,close2conv_begin
      logical close2conv,converged,wrongstat,scalesmall1
#include "opt_cvb.fh"
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

#include "formats_cvb.fh"
      external opta,optb
      dimension dx(nparm),grad(nparm)
      save zero,close2conv,converged
      data zero/0.d0/

      converged=.false.
      if(iter_is_1)close2conv=.false.

c  << Initialization >>
      call grad_cvb(grad)
      call ddproj_cvb(grad,nparm)
      grdnrm=dnrm2_(nparm,grad,1)
      call opta(nparm)

      if(ip.ge.2)write(6,'(/a)')' *****   2. order optimizer   *****'

c  << Now trust region control >>
      exp_tc=exp
      first_time=.true.
      opth=.false.
      iopth=0
100   call trust_cvb(iopth,opth,maxize,fx,fxbest,exp,
     >  hh,dxnrm,ioptc,scalesmall1,close2conv,converged,skipupd)
      if(ioptc.eq.-2)return

c    << Make update >>
      if(.not.(skipupd.or.hh.eq.zero))then

200     close2conv_begin=close2conv

        call optb(nparm,dxnrm,grdnrm,close2conv)

        if(first_time)then
          first_time=.false.

          call testconv_cvb(fx,nparm,
     >      dx,grad,exp_tc,
     >      close2conv,converged,wrongstat)

          if(close2conv.and..not.close2conv_begin)goto 200
        endif
        if((ip.eq.2.and..not.opth).or.ip.ge.3)then
          s11=ddot_(nparm,dx,1,dx,1)
          s22=ddot_(nparm,grad,1,grad,1)
          s12=ddot_(nparm,dx,1,grad,1)
          write(6,formAD)
     >      ' Overlap between normalized vectors <DX|GRAD> :',
     >      s12/sqrt(s11*s22)
        endif
        call fxdx_cvb(fx,.false.,dx)
      endif
      if(opth)goto 100

      if(ioptc.ge.-1.and.hh.ne.zero)then
        if(ip.ge.2)then
          write(6,'(a)')' '
          write(6,formAF)' HH & norm of update :',hh,dxnrm
        endif
        call update_cvb(dx)
      endif
      if(converged)then
        ioptc=0
      elseif(close2conv.and.endifclose)then
        ioptc=-3
      else
        ioptc=1
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Roland Lindh                                     *
!***********************************************************************

module RASSI_GLOBAL_ARRAYS

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), allocatable :: FSBARR(:), JBNUM(:), LROOT(:), OrbTab(:), PART(:), SSTAB(:)
integer(kind=iwp), allocatable, target :: CNFTAB1(:), CNFTAB2(:), FSBANN1(:), FSBANN2(:), FSBANN3(:), FSBANN4(:), FSBTAB1(:), &
                                          FSBTAB2(:), REST1(:), REST2(:), SPNTAB1(:), SPNTAB2(:)
real(kind=wp), allocatable :: EIGVEC(:,:), ESHFT(:), HAM(:,:), HDIAG(:), SFDYS(:,:,:), SODYSAMPS(:,:), SODYSAMPSI(:,:), &
                              SODYSAMPSR(:,:)
real(kind=wp), allocatable, target :: TRANS1(:), TRANS2(:)

public :: CNFTAB1, CNFTAB2, EIGVEC, ESHFT, FSBANN1, FSBANN2, FSBANN3, FSBANN4, FSBARR, FSBTAB1, FSBTAB2, HAM, HDIAG, JBNUM, LROOT, &
          OrbTab, PART, REST1, REST2, SFDYS, SODYSAMPS, SODYSAMPSI, SODYSAMPSR, SPNTAB1, SPNTAB2, SSTAB, TRANS1, TRANS2

end module RASSI_GLOBAL_ARRAYS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FIXIC(nFix,SS,mInt,B,NDIM,F,Label,u)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nFix, mInt, NDIM
real(kind=wp), intent(inout) :: SS(mInt)
real(kind=wp), intent(in) :: B(nDim*mInt), u(nDim)
real(kind=wp), intent(out) :: F(nDim)
character(len=8), intent(in) :: Label(mInt)
integer(kind=iwp) :: I
real(kind=wp), allocatable :: uB(:,:), uInv(:,:)

! write out the internal coordinates which will be fixed

write(u6,*)
write(u6,*) ' Following internal coordinates are fixed'
write(u6,*)

! loop over all internal coordinates to be fixed

do I=mInt-nFix+1,mInt
  write(u6,'(A,A,ES10.3,A)') Label(i),' with a gradient of ',SS(I),' is frozen and the gradient is annihilated'
  SS(i) = Zero
end do

! now transform remaining internal coordinates back to cartesian ba
!                      -1 +
!                fx = u  B  fq

call mma_allocate(uInv,nDim,nDim,Label='uInv')
uInv(:,:) = Zero
do i=1,nDim
  uInv(i,i) = One/u(i)
end do
!call RecPrt('uInv',' ',uInv,nDim,nDim)

call mma_allocate(uB,mInt,nDim,Label='uB')
uB(:,:) = Zero

call DGEMM_('N','N',nDim,mInt,nDim,One,uInv,nDim,B,nDim,Zero,uB,nDim)
!call RecPrt('uInvB',' ',uB,nDim,mInt)
call DGEMM_('N','N',nDim,1,mInt,One,uB,nDim,SS,mInt,Zero,F,nDim)
!call RecPrt('F',' ',F,mInt,1)

call mma_deallocate(uB)
call mma_deallocate(uInv)

return

end subroutine FIXIC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRACI_RPT2(ISTART,NDIM,XMAT,STSYM,NCI,CI)
      use definitions, only: iwp, wp
      use constants, only: Zero, Half, One, OneHalf
      use gugx, only: LEVEL, SGS, CIS, EXS
      use stdalloc, only: mma_allocate, mma_deallocate
      IMPLICIT None
      integer(kind=iwp), intent(in):: ISTART, NDIM, STSym, NCI
      real(kind=wp), intent(inout):: XMAT(NDIM,NDIM)
      real(kind=wp), intent(inout):: CI(NCI)

      real(kind=wp), ALLOCATABLE:: XSAV(:,:), TVEC(:), SGM(:)
      real(kind=wp) Fact, SCL, XJM
      integer(kind=iwp) I, IORB, J, JORB, LI, LJ, M

      IF (NDIM.LE.0) RETURN

      CALL mma_allocate(XSAV,NDIM,NDIM,Label='XSAV')
      XSAV(:,:)=XMAT(:,:)
      CALL mma_allocate(TVEC,NDIM,LABEL='TVEC')
      CALL mma_allocate(SGM,NCI,LABEL='SGM')
      SGM(:)=Zero

      DO J=1,NDIM
        FACT=One/XMAT(J,J)
        DO I=1,NDIM
          TVEC(I)=-FACT*XMAT(I,J)
          XMAT(I,J)=Zero
        END DO
        TVEC(J)=FACT
        XMAT(J,J)=One
C Array T now contains a factor of XMAT of the form
C (e(1),..e(k-1),T,..,e(n)), where e(i) is the standard
C unit column vector, with elements Kronecker(l,i).
C Apply its inverse to XMAT.
        DO M=J+1,NDIM
          XJM=XMAT(J,M)
          DO I=1,NDIM
            XMAT(I,M)=XMAT(I,M)+TVEC(I)*XJM
          END DO
          XMAT(J,M)=TVEC(J)*XJM
        END DO
C Transform CI array:
C CI:=( 1 + Sum(U(I)E(IJ)) + (1/2)Sum(U(I)U(M)E(IJ,MJ)) ) CI,
C where U(I) = T(I)-Kronecker(I,J).
        JORB=ISTART-1+J
        LJ=LEVEL(JORB)
        CALL DYAX(NCI,(OneHalf-Half*TVEC(J)),CI,1,SGM,1)
        DO I=1,NDIM
          IORB=ISTART-1+I
          LI=LEVEL(IORB)
          SCL=Half*TVEC(I)
          IF(I.EQ.J) SCL=SCL-Half
          CALL SIGMA1(SGS,CIS,EXS,LI,LJ,SCL,STSYM,CI,SGM)
        END DO
        DO I=1,NDIM
          IORB=ISTART-1+I
          LI=LEVEL(IORB)
          SCL=TVEC(I)
          IF(I.EQ.J) SCL=SCL-One
          CALL SIGMA1(SGS,CIS,EXS,LI,LJ,SCL,STSYM,SGM,CI)
        END DO

      End Do

      CALL mma_deallocate(SGM)
      CALL mma_deallocate(TVEC)
      XMAT(:,:)=XSAV(:,:)
      CALL mma_deallocate(XSAV)

      END SUBROUTINE TRACI_RPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SUBROUTINE GATVCS(VECO,VECI,INDEX,NDIM)
* Gather vector allowing for sign change
*
* VECO(I) = VECI(INDEX(I))
*
      IMPLICIT REAL*8           (A-H,O-Z)
      DIMENSION VECI(*),VECO(*),INDEX(*)
      INTRINSIC SIGN
*
      DO 100 I = 1, NDIM
      VECO(I) = VECI(ABS(INDEX(I)))*DBLE(SIGN(1,INDEX(I)))
  100 CONTINUE
*
      RETURN
      END
      SUBROUTINE SCAVCS(VECO,VECI,INDEX,NDIM)
*
* Scatter vector with sign change
*
* vecO(abs(index(i))) = veci(i)*sign(index(i))
*
      IMPLICIT REAL*8           (A-H,O-Z)
      DIMENSION VECI(*),VECO(*),INDEX(*)
      INTRINSIC SIGN
C
      DO 100 I = 1, NDIM
      VECO(ABS(INDEX(I))) = VECI(I)*DBLE(SIGN(1,INDEX(I)))
  100 CONTINUE
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  DEV2B  := calculate two-electron Hessian                           *
!*                                                                     *
!***********************************************************************
subroutine dev2b_2_cvb(v1,v2,cfrom,hessorb,hesst,oaa2,aa1,gx,grad2)
! Calculates V1 EijEkl CFROM and V2 EijEkl CFROM

use casvb_global, only: absym, i1alf, i1bet, iafrm, iapr, iato, ibfrm, ibpr, ibto, ixapr, ixbpr, n1a, n1b, nda, ndb, norb, nprorb, &
                        phato, phbto, projcas, sc
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: v1(nda,ndb), v2(nda,ndb), cfrom(nda,ndb), oaa2, aa1, gx(norb,norb), grad2(nprorb)
real(kind=wp), intent(inout) :: hessorb(nprorb,nprorb)
real(kind=wp), intent(out) :: hesst(norb*norb,norb*norb)
integer(kind=iwp) :: ia, iax, iaxtmp, ib, ibx, ibxtmp, iorb, ip1, ip2, itmp, ixa, ixb, jax, jbx, ji, jorb, kax, kbx, korb, lax, &
                     lbx, li, lk, lorb
real(kind=wp) :: phase, res1, res2, t1, t2, tcof, term

do ip1=1,norb*norb
  iorb = (ip1-1)/norb+1
  jorb = ip1-(iorb-1)*norb
  do ip2=1,ip1
    korb = (ip2-1)/norb+1
    lorb = ip2-(korb-1)*norb
    res1 = Zero
    res2 = Zero
    if (projcas .and. (.not. sc)) then
      ! 1) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          ! I -> J
          do ixa=ixapr(iax),ixapr(iax+1)-1
            ibx = iapr(ixa)
            ! 2. alpha k -> l
            itmp = iafrm(korb,jax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(kax,ibx)*term
              res2 = res2+v2(kax,ibx)*term
            end if
            ! 2. alpha l -> k
            itmp = iafrm(lorb,iax)
            lax = iato(korb,itmp)
            if (lax /= 0) then
              phase = phato(lorb,itmp)*phato(korb,itmp)
              term = tcof*phase*cfrom(lax,ibx)
              res1 = res1-v1(jax,ibx)*term
              res2 = res2-v2(jax,ibx)*term
            end if
            ! 2. beta  k -> l
            itmp = ibfrm(korb,ibx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(jax,kbx)*term
              res2 = res2+v2(jax,kbx)*term
            end if
            ! 2. beta  l -> k
            itmp = ibfrm(lorb,ibx)
            lbx = ibto(korb,itmp)
            if (lbx /= 0) then
              phase = phbto(lorb,itmp)*phbto(korb,itmp)
              term = tcof*phase*cfrom(iax,lbx)
              res1 = res1-v1(jax,ibx)*term
              res2 = res2-v2(jax,ibx)*term
            end if
          end do
          ! J -> I
          do ixa=ixapr(jax),ixapr(jax+1)-1
            ibx = iapr(ixa)
            ! 2. alpha k -> l
            itmp = iafrm(korb,jax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1-v1(kax,ibx)*term
              res2 = res2-v2(kax,ibx)*term
            end if
            ! 2. alpha l -> k
            itmp = iafrm(lorb,iax)
            lax = iato(korb,itmp)
            if (lax /= 0) then
              phase = phato(lorb,itmp)*phato(korb,itmp)
              term = tcof*phase*cfrom(lax,ibx)
              res1 = res1+v1(jax,ibx)*term
              res2 = res2+v2(jax,ibx)*term
            end if
            ! 2. beta  k -> l
            itmp = ibfrm(korb,ibx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1-v1(jax,kbx)*term
              res2 = res2-v2(jax,kbx)*term
            end if
            ! 2. beta  l -> k
            itmp = ibfrm(lorb,ibx)
            lbx = ibto(korb,itmp)
            if (lbx /= 0) then
              phase = phbto(lorb,itmp)*phbto(korb,itmp)
              term = tcof*phase*cfrom(iax,lbx)
              res1 = res1+v1(jax,ibx)*term
              res2 = res2+v2(jax,ibx)*term
            end if
          end do
        end if
      end do

      if (absym(3)) then
        res1 = Two*res1
        res2 = Two*res2
      else
        ! 2) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            ! I -> J
            do ixb=ixbpr(ibx),ixbpr(ibx+1)-1
              iax = ibpr(ixb)
              ! 2. beta  k -> l
              itmp = ibfrm(korb,jbx)
              kbx = ibto(lorb,itmp)
              if (kbx /= 0) then
                phase = phbto(korb,itmp)*phbto(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1+v1(iax,kbx)*term
                res2 = res2+v2(iax,kbx)*term
              end if
              ! 2. beta  l -> k
              itmp = ibfrm(lorb,ibx)
              lbx = ibto(korb,itmp)
              if (lbx /= 0) then
                phase = phbto(lorb,itmp)*phbto(korb,itmp)
                term = tcof*phase*cfrom(iax,lbx)
                res1 = res1-v1(iax,jbx)*term
                res2 = res2-v2(iax,jbx)*term
              end if
              ! 2. alpha k -> l
              itmp = iafrm(korb,iax)
              kax = iato(lorb,itmp)
              if (kax /= 0) then
                phase = phato(korb,itmp)*phato(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1+v1(kax,jbx)*term
                res2 = res2+v2(kax,jbx)*term
              end if
              ! 2. alpha l -> k
              itmp = iafrm(lorb,iax)
              lax = iato(korb,itmp)
              if (lax /= 0) then
                phase = phato(lorb,itmp)*phato(korb,itmp)
                term = tcof*phase*cfrom(lax,ibx)
                res1 = res1-v1(iax,jbx)*term
                res2 = res2-v2(iax,jbx)*term
              end if
            end do
            ! J -> I
            do ixb=ixbpr(jbx),ixbpr(jbx+1)-1
              iax = ibpr(ixb)
              ! 2. beta  k -> l
              itmp = ibfrm(korb,jbx)
              kbx = ibto(lorb,itmp)
              if (kbx /= 0) then
                phase = phbto(korb,itmp)*phbto(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1-v1(iax,kbx)*term
                res2 = res2-v2(iax,kbx)*term
              end if
              ! 2. beta  l -> k
              itmp = ibfrm(lorb,ibx)
              lbx = ibto(korb,itmp)
              if (lbx /= 0) then
                phase = phbto(lorb,itmp)*phbto(korb,itmp)
                term = tcof*phase*cfrom(iax,lbx)
                res1 = res1+v1(iax,jbx)*term
                res2 = res2+v2(iax,jbx)*term
              end if
              ! 2. alpha k -> l
              itmp = iafrm(korb,iax)
              kax = iato(lorb,itmp)
              if (kax /= 0) then
                phase = phato(korb,itmp)*phato(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1-v1(kax,jbx)*term
                res2 = res2-v2(kax,jbx)*term
              end if
              ! 2. alpha l -> k
              itmp = iafrm(lorb,iax)
              lax = iato(korb,itmp)
              if (lax /= 0) then
                phase = phato(lorb,itmp)*phato(korb,itmp)
                term = tcof*phase*cfrom(lax,ibx)
                res1 = res1+v1(iax,jbx)*term
                res2 = res2+v2(iax,jbx)*term
              end if
            end do
          end if
        end do
      end if
    else if ((.not. projcas) .and. (.not. sc)) then
      ! 1) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          ! I -> J
          do ixa=ixapr(iax),ixapr(iax+1)-1
            ibx = iapr(ixa)
            ! 2. alpha k -> l
            itmp = iafrm(korb,jax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(kax,ibx)*term
              res2 = res2+v2(kax,ibx)*term
            end if
            ! 2. beta  k -> l
            itmp = ibfrm(korb,ibx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(jax,kbx)*term
              res2 = res2+v2(jax,kbx)*term
            end if
          end do
        end if
      end do

      if (absym(3)) then
        res1 = Two*res1
        res2 = Two*res2
      else
        ! 2) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            ! I -> J
            do ixb=ixbpr(ibx),ixbpr(ibx+1)-1
              iax = ibpr(ixb)
              ! 2. beta  k -> l
              itmp = ibfrm(korb,jbx)
              kbx = ibto(lorb,itmp)
              if (kbx /= 0) then
                phase = phbto(korb,itmp)*phbto(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1+v1(iax,kbx)*term
                res2 = res2+v2(iax,kbx)*term
              end if
              ! 2. alpha k -> l
              itmp = iafrm(korb,iax)
              kax = iato(lorb,itmp)
              if (kax /= 0) then
                phase = phato(korb,itmp)*phato(lorb,itmp)
                term = tcof*phase*cfrom(iax,ibx)
                res1 = res1+v1(kax,jbx)*term
                res2 = res2+v2(kax,jbx)*term
              end if
            end do
          end if
        end do
      end if
    else if (projcas .and. sc) then
      ! 1) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          ! I -> J
          ibx = ndb-iax+1
          ! 2. alpha k -> l
          itmp = iafrm(korb,jax)
          kax = iato(lorb,itmp)
          if (kax /= 0) then
            phase = phato(korb,itmp)*phato(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1+v1(kax,ibx)*term
            res2 = res2+v2(kax,ibx)*term
          end if
          ! 2. alpha l -> k
          itmp = iafrm(lorb,iax)
          lax = iato(korb,itmp)
          if (lax /= 0) then
            phase = phato(lorb,itmp)*phato(korb,itmp)
            term = tcof*phase*cfrom(lax,ibx)
            res1 = res1-v1(jax,ibx)*term
            res2 = res2-v2(jax,ibx)*term
          end if
          ! 2. beta  k -> l
          itmp = ibfrm(korb,ibx)
          kbx = ibto(lorb,itmp)
          if (kbx /= 0) then
            phase = phbto(korb,itmp)*phbto(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1+v1(jax,kbx)*term
            res2 = res2+v2(jax,kbx)*term
          end if
          ! 2. beta  l -> k
          itmp = ibfrm(lorb,ibx)
          lbx = ibto(korb,itmp)
          if (lbx /= 0) then
            phase = phbto(lorb,itmp)*phbto(korb,itmp)
            term = tcof*phase*cfrom(iax,lbx)
            res1 = res1-v1(jax,ibx)*term
            res2 = res2-v2(jax,ibx)*term
          end if
          ! J -> I
          ibx = ndb-jax+1
          ! 2. alpha k -> l
          itmp = iafrm(korb,jax)
          kax = iato(lorb,itmp)
          if (kax /= 0) then
            phase = phato(korb,itmp)*phato(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1-v1(kax,ibx)*term
            res2 = res2-v2(kax,ibx)*term
          end if
          ! 2. alpha l -> k
          itmp = iafrm(lorb,iax)
          lax = iato(korb,itmp)
          if (lax /= 0) then
            phase = phato(lorb,itmp)*phato(korb,itmp)
            term = tcof*phase*cfrom(lax,ibx)
            res1 = res1+v1(jax,ibx)*term
            res2 = res2+v2(jax,ibx)*term
          end if
          ! 2. beta  k -> l
          itmp = ibfrm(korb,ibx)
          kbx = ibto(lorb,itmp)
          if (kbx /= 0) then
            phase = phbto(korb,itmp)*phbto(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1-v1(jax,kbx)*term
            res2 = res2-v2(jax,kbx)*term
          end if
          ! 2. beta  l -> k
          itmp = ibfrm(lorb,ibx)
          lbx = ibto(korb,itmp)
          if (lbx /= 0) then
            phase = phbto(lorb,itmp)*phbto(korb,itmp)
            term = tcof*phase*cfrom(iax,lbx)
            res1 = res1+v1(jax,ibx)*term
            res2 = res2+v2(jax,ibx)*term
          end if
        end if
      end do

      if (absym(3)) then
        res1 = Two*res1
        res2 = Two*res2
      else
        ! 2) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            ! I -> J
            iax = nda-ibx+1
            ! 2. beta  k -> l
            itmp = ibfrm(korb,jbx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(iax,kbx)*term
              res2 = res2+v2(iax,kbx)*term
            end if
            ! 2. beta  l -> k
            itmp = ibfrm(lorb,ibx)
            lbx = ibto(korb,itmp)
            if (lbx /= 0) then
              phase = phbto(lorb,itmp)*phbto(korb,itmp)
              term = tcof*phase*cfrom(iax,lbx)
              res1 = res1-v1(iax,jbx)*term
              res2 = res2-v2(iax,jbx)*term
            end if
            ! 2. alpha k -> l
            itmp = iafrm(korb,iax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(kax,jbx)*term
              res2 = res2+v2(kax,jbx)*term
            end if
            ! 2. alpha l -> k
            itmp = iafrm(lorb,iax)
            lax = iato(korb,itmp)
            if (lax /= 0) then
              phase = phato(lorb,itmp)*phato(korb,itmp)
              term = tcof*phase*cfrom(lax,ibx)
              res1 = res1-v1(iax,jbx)*term
              res2 = res2-v2(iax,jbx)*term
            end if
            ! J -> I
            iax = nda-jbx+1
            ! 2. beta  k -> l
            itmp = ibfrm(korb,jbx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1-v1(iax,kbx)*term
              res2 = res2-v2(iax,kbx)*term
            end if
            ! 2. beta  l -> k
            itmp = ibfrm(lorb,ibx)
            lbx = ibto(korb,itmp)
            if (lbx /= 0) then
              phase = phbto(lorb,itmp)*phbto(korb,itmp)
              term = tcof*phase*cfrom(iax,lbx)
              res1 = res1+v1(iax,jbx)*term
              res2 = res2+v2(iax,jbx)*term
            end if
            ! 2. alpha k -> l
            itmp = iafrm(korb,iax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1-v1(kax,jbx)*term
              res2 = res2-v2(kax,jbx)*term
            end if
            ! 2. alpha l -> k
            itmp = iafrm(lorb,iax)
            lax = iato(korb,itmp)
            if (lax /= 0) then
              phase = phato(lorb,itmp)*phato(korb,itmp)
              term = tcof*phase*cfrom(lax,ibx)
              res1 = res1+v1(iax,jbx)*term
              res2 = res2+v2(iax,jbx)*term
            end if
          end if
        end do
      end if
    else if ((.not. projcas) .and. sc) then
      ! 1) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          ! I -> J
          ibx = ndb-iax+1
          ! 2. alpha k -> l
          itmp = iafrm(korb,jax)
          kax = iato(lorb,itmp)
          if (kax /= 0) then
            phase = phato(korb,itmp)*phato(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1+v1(kax,ibx)*term
            res2 = res2+v2(kax,ibx)*term
          end if
          ! 2. beta  k -> l
          itmp = ibfrm(korb,ibx)
          kbx = ibto(lorb,itmp)
          if (kbx /= 0) then
            phase = phbto(korb,itmp)*phbto(lorb,itmp)
            term = tcof*phase*cfrom(iax,ibx)
            res1 = res1+v1(jax,kbx)*term
            res2 = res2+v2(jax,kbx)*term
          end if
        end if
      end do

      if (absym(3)) then
        res1 = Two*res1
        res2 = Two*res2
      else
        ! 2) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            ! I -> J
            iax = nda-ibx+1
            ! 2. beta  k -> l
            itmp = ibfrm(korb,jbx)
            kbx = ibto(lorb,itmp)
            if (kbx /= 0) then
              phase = phbto(korb,itmp)*phbto(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(iax,kbx)*term
              res2 = res2+v2(iax,kbx)*term
            end if
            ! 2. alpha k -> l
            itmp = iafrm(korb,iax)
            kax = iato(lorb,itmp)
            if (kax /= 0) then
              phase = phato(korb,itmp)*phato(lorb,itmp)
              term = tcof*phase*cfrom(iax,ibx)
              res1 = res1+v1(kax,jbx)*term
              res2 = res2+v2(kax,jbx)*term
            end if
          end if
        end do
      end if
    end if
    hesst(ip2,ip1) = res1
    if (ip1 /= ip2) then
      ! E_ji E_lk = E_lk E_ji - \delta_kj E_li + \delta_il E_jk
      hesst(ip1,ip2) = res1
      if (korb == jorb) hesst(ip1,ip2) = hesst(ip1,ip2)-gx(lorb,iorb)
      if (iorb == lorb) hesst(ip1,ip2) = hesst(ip1,ip2)+gx(jorb,korb)
    end if
    if ((iorb /= jorb) .and. (korb /= lorb)) then
      t1 = res1
      t2 = res2
      if ((jorb == korb) .and. (iorb /= lorb)) then
        t1 = t1-gx(lorb,iorb)
        li = lorb+(iorb-1)*(norb-1)
        if (lorb > iorb) li = li-1
        t2 = t2-grad2(li)
      end if
      ji = jorb+(iorb-1)*(norb-1)
      if (jorb > iorb) ji = ji-1
      lk = lorb+(korb-1)*(norb-1)
      if (lorb > korb) lk = lk-1
      hessorb(ji,lk) = hessorb(ji,lk)+oaa2*t1+aa1*t2
      hessorb(lk,ji) = hessorb(ji,lk)
    end if
  end do
end do

return

end subroutine dev2b_2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1994,1995, Jeppe Olsen                            *
************************************************************************
      SUBROUTINE FREESTR()
      Use Str_Info
*
* Free pointers for saving information about strings and
* their mappings
*
*========
* Input :
*========
* Number and types of strings defined by /STRINP/
* Symmetry information stored in         /CSM/
* String information stored in           /STINF/
*=========
* Output
*=========
* Pointers stored in common block /STRBAS/
*
* Jeppe Olsen , Winter of 1990
*
* Last Revision , Dec 24 1990 , Almaden
*
* Updated with iuniqtp, dec 11, 1994
* Modified for deallocation, Sept. 25, 2005.
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "detdim.fh"
#include "stdalloc.fh"
#include "orbinp_mclr.fh"
#include "csm.fh"
*. Start of string information
* =====================================================================
*
* 1 : String information
*
* =====================================================================
*
      DO ITYP = 1, NSTTYP
        IF(IUNIQTP(ITYP).EQ.ITYP) THEN
*.  Offsets for occupation of strings and reordering array
          Str(ITYP)%OCSTR => Null()
          Call mma_deallocate(Str(ITYP)%OCSTR_Hidden)
          Str(ITYP)%STREO => Null()
          Call mma_deallocate(Str(ITYP)%STREO_Hidden)
*. Symmetry and class of each string
          Str(ITYP)%STSM => Null()
          Call mma_deallocate(Str(ITYP)%STSM_Hidden)
          Str(ITYP)%STCL => Null()
          Call mma_deallocate(Str(ITYP)%STCL_Hidden)
        ELSE
          Str(ITYP)%OCSTR => Null()
          Str(ITYP)%STREO => Null()
          Str(ITYP)%STSM => Null()
          Str(ITYP)%STCL => Null()
        END IF
      END DO

*. Number of strings per symmetry and occupation
      DO ITYP = 1, NSTTYP
        IF(IUNIQTP(ITYP).EQ.ITYP) THEN
          Str(ITYP)%NSTSO=> Null()
          Call mma_deallocate(Str(ITYP)%NSTSO_Hidden)
*. Offset of strings per symmetry and occupation
          Str(ITYP)%ISTSO=> Null()
          Call mma_deallocate(Str(ITYP)%ISTSO_Hidden)
*. Number of electrons in RAS1 and RAS3 per sub type, is sub-type active
          Str(ITYP)%EL1  => Null()
          Call mma_deallocate(Str(ITYP)%EL1_Hidden)
          Str(ITYP)%EL3  => Null()
          Call mma_deallocate(Str(ITYP)%EL3_Hidden)
          Str(ITYP)%ACTP => Null()
          Call mma_deallocate(Str(ITYP)%ACTP_Hidden)
CMS: New array introduced according to Jeppes new strinfo representation
          Str(ITYP)%EL123=> Null()
          Call mma_deallocate(Str(ITYP)%EL123_Hidden)
**. Lexical adressing of arrays: NB! Not allocated here in Jeppes new version!
          Str(ITYP)%Z    => Null()
          Call mma_deallocate(Str(ITYP)%Z_Hidden)
        ELSE
*. redirect
          IITYP = - IUNIQTP(ITYP)
          Str(ITYP)%NSTSO => Null()
          Str(ITYP)%ISTSO => Null()
          Str(ITYP)%EL1   => Null()
          Str(ITYP)%EL3   => Null()
          Str(ITYP)%ACTP  => Null()
          Str(ITYP)%EL123 => Null()
          Str(ITYP)%Z     => Null()
        END IF
      END DO

*. Mappings between different string types
      DO ITYP = 1, NSTTYP
          IF(ISTAC(ITYP,2).NE.0.AND.ISTAC(ITYP,1).NE.0) THEN
*.creation on string allowed , use full orbital notation
             Call mma_deallocate(Str(ITYP)%STSTMI)
             Call mma_deallocate(Str(ITYP)%STSTMN)
          ELSE IF(ISTAC(ITYP,1).NE.0.AND.ISTAC(ITYP,2).EQ.0) THEN

*. only annihilation allowed, use compact scheme
             Call mma_deallocate(Str(ITYP)%STSTMI)
             Call mma_deallocate(Str(ITYP)%STSTMN)
CMS: New else block
          ELSE IF (ISTAC(ITYP,1).EQ.0.AND.ISTAC(ITYP,2).NE.0) THEN
*. Only creation allowed, use compact scheme with offsets
*
*. Explicit offsets and lengths
             Call mma_deallocate(Str(ITYP)%STSTMI)
             Call mma_deallocate(Str(ITYP)%STSTMN)
          END IF
*. has this map been constructed before ?
          IIIITEST = 0
          IF(IUNIQTP(ITYP).EQ.ITYP.OR.IIIITEST.EQ.1) THEN
            IMNEW = 1
            IUNIQMP(ITYP) = ITYP
          ELSE
*. check type of previous map
            DO JJTYP = 1, ITYP-1
            IITYP = -IUNIQTP(ITYP)
            IF(ABS(IUNIQTP(JJTYP)).EQ.IITYP.AND.
     &          IUNIQMP(JJTYP).EQ.JJTYP) THEN
            IF((ISTAC(ITYP,1).EQ.0.AND.ISTAC(JJTYP,1).EQ.0).OR.
     &         (ISTAC(ITYP,1).NE.0.AND.ISTAC(JJTYP,1).NE.0.AND.
     &          ABS(IUNIQTP(ISTAC(ITYP,1))).EQ.
     &          ABS(IUNIQTP(ISTAC(JJTYP,1)))) ) THEN
                IANEQ = 1
            ELSE
                IANEQ = 0
            END IF
            IF((ISTAC(ITYP,2).EQ.0.AND.ISTAC(JJTYP,2).EQ.0).OR.
     &         (ISTAC(ITYP,2).NE.0.AND.ISTAC(JJTYP,2).NE.0.AND.
     &          ABS(IUNIQTP(ISTAC(ITYP,2))).EQ.
     &          ABS(IUNIQTP(ISTAC(JJTYP,2)))) ) THEN
                ICREQ = 1
            ELSE
                ICREQ = 0
            END IF
            IF(IANEQ.EQ.1.AND.ICREQ.EQ.1) THEN
              IMNEW = 0
              IUNIQMP(ITYP) = -JJTYP
              GOTO 1211
            END IF
*
            END IF
            END DO
*. Normal exit from DO loop only if no identical map was found
            IMNEW = 1
            IUNIQMP(ITYP) = ITYP
 1211       CONTINUE
          END IF
          IF(IMNEW.EQ.1) THEN
            Call mma_deallocate(Str(ITYP)%STSTM_Hidden)
            Str(ITYP)%STSTM => Null()
          ELSE
            Str(ITYP)%STSTM => Null()
          END IF
      END DO
*. Symmetry of conjugated orbitals and orbital excitations
*     COBSM,NIFSJ,IFSJ,IFSJO
!     Call mma_deallocate(COBSM)
!     Call mma_deallocate(NIFSJ)
!     Call mma_deallocate(IFSJ)
!     Call mma_deallocate(IFSJO)
*. Symmetry of excitation connecting  strings of given symmetry
!     Call mma_deallocate(STSTX)
*
**. Up and down mappings of strings containing the same number of electrons
*
      DO 70 ITYP = 1, NSTTYP
       IF(INUMAP(ITYP).NE.0) Call mma_deallocate(Str(ITYP)%NUMAP)
       IF(INDMAP(ITYP).NE.0) Call mma_deallocate(Str(ITYP)%NDMAP)
   70 CONTINUE
*
*
*     Some dummy dallocations
*
      ITYP=ITYP_Dummy
      Str(ITYP)%NSTSO => Null()
      Call mma_deallocate(Str(ITYP)%NSTSO_Hidden)
      Str(ITYP)%EL1  => Null()
      Call mma_deallocate(Str(ITYP)%EL1_Hidden)
      Str(ITYP)%EL3  => Null()
      Call mma_deallocate(Str(ITYP)%EL3_Hidden)


      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MxLbls(GrdMax,StpMax,GrdLbl,StpLbl,nInter,Grad,Shift,
     &                  Lbl)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
      Real*8 Shift(nInter), Grad(nInter)
      Character Lbl(nInter)*8,  GrdLbl*8, StpLbl*8
*
*     Call RecPrt('MxLbls:Shift',' ',Shift,nInter,1)
*     Call RecPrt('MxLbls:Grad',' ',Grad,nInter,1)
*
      GrdMax=Zero
      StpMax=Zero
      Do i = 1, nInter
         If(Abs(Grad(i)).gt.Abs(GrdMax)) Then
           GrdMax=Grad(i)
           GrdLbl=Lbl(i)
         End If
         If(Abs(Shift(i)).gt.Abs(StpMax)) Then
           StpMax=Shift(i)
           StpLbl=Lbl(i)
         End If
      End Do
*     Write (*,*) ' Tmp output in MxLbls'
*     Write (*,*) GrdLbl,' ',GrdMax
*     Write (*,*) StpLbl,' ',StpMax
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_W_buffer

use fmm_global_paras, only: T_pair_single, scheme_paras, SKIP_W_BUFFER, NULL_W_BUFFER, TREE_W_BUFFER, TREE_LENGTH
use fmm_utils, only: fmm_quit

implicit none
private
! Public procedures
public :: fmm_add_to_W_buffer, &
          fmm_open_W_buffer, &
          fmm_close_W_buffer

! diagnostic flag
character(len=4), save :: W_buffer_stat

contains

!-------------------------------------------------------------------------------

subroutine fmm_add_to_W_buffer(W_pair)

  implicit none
  type(T_pair_single), intent(in) :: W_pair
  external :: fmm_selected_w_buffer
  external :: fmm_selected_w_contractor

  call fmm_selected_w_buffer(fmm_selected_w_contractor,W_pair)

end subroutine fmm_add_to_W_buffer

!-------------------------------------------------------------------------------

subroutine fmm_close_W_buffer(scheme)

  use fmm_W_contractors, only: fmm_lock_W_con
  use fmm_tree_buffer, only: fmm_tree_buffer_finish

  implicit none
  type(scheme_paras), intent(in) :: scheme
  external :: fmm_selected_w_contractor

  if (W_buffer_stat /= 'OPEN') call fmm_quit('W_buffer already closed!')
  select case (scheme%W_con%W_buffer)
    case (SKIP_W_BUFFER)
      ! do nothing
    case (NULL_W_BUFFER)
      ! do nothing
    case (TREE_W_BUFFER)
      call fmm_tree_buffer_finish(fmm_selected_w_contractor)
    case default
      call fmm_quit('cannot reconcile list type in fmm_close_W_buffer')
  end select
  W_buffer_stat = 'FREE'
  fmm_lock_W_con = .false.

end subroutine fmm_close_W_buffer

!-------------------------------------------------------------------------------

subroutine fmm_null_W_buffer(W_contractor,W_pair)

  implicit none
  type(T_pair_single), intent(in) :: W_pair
  external                        :: W_contractor

  call W_contractor(W_pair)

end subroutine fmm_null_W_buffer

!-------------------------------------------------------------------------------
! for diagnostic use only

subroutine fmm_skip_W_buffer(W_contractor,W_pair)

# include "macros.fh"

  implicit none
  type(T_pair_single), intent(in) :: W_pair
  external                        :: W_contractor

  unused_proc(W_contractor(W_pair))

  return

end subroutine fmm_skip_W_buffer

!-------------------------------------------------------------------------------

subroutine fmm_open_W_buffer(scheme)

  use fmm_W_contractors, only: fmm_lock_W_con
  use fmm_tree_buffer, only: fmm_tree_buffer_init, &
                             fmm_tree_buffer_add

  implicit none
  type(scheme_paras), intent(in) :: scheme
  external :: fmm_store_w_buffer

  if (W_buffer_stat == 'OPEN') call fmm_quit('cannot reopen W_buffer')

  select case (scheme%W_con%W_buffer)
    case (SKIP_W_BUFFER)
      ! all W-contractions will be skipped by this choice of buffer
      call fmm_store_w_buffer(fmm_skip_W_buffer)
    case (NULL_W_BUFFER)
      call fmm_store_w_buffer(fmm_null_W_buffer)
    case (TREE_W_BUFFER)
      ! use tree-based sorting/evaluating module
      call fmm_store_w_buffer(fmm_tree_buffer_add)
      call fmm_tree_buffer_init(TREE_LENGTH,scheme%W_con%sort_para)
    case default
      call fmm_quit('cannot reconcile list type in fmm_open_W_buffer')
  end select

  W_buffer_stat = 'OPEN'
  fmm_lock_W_con = .true.

end subroutine fmm_open_W_buffer

!-------------------------------------------------------------------------------

end module fmm_W_buffer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_PUTRED1(INFRED,NNBSTRSH,INDRED,INDRSH,ISP2F,MRED,MSYM,MMSHL,LMMBSTRT,IPASS,ILOC)
!
! Purpose: write index arrays for current reduced set (reduced set
!          IPASS).

use Cholesky, only: LuPri, LuRed, MaxRed, nnBstRT, nnShl, nSym
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: MRED, INFRED(MRED), MSYM, MMSHL, LMMBSTRT, IPASS, ILOC
integer(kind=iwp), intent(_IN_) :: NNBSTRSH(MSYM,MMSHL), INDRED(LMMBSTRT), INDRSH(LMMBSTRT), ISP2F(MMSHL)
integer(kind=iwp) :: IADR, IADR1, IOPT, LTOT
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_PUTRED1'

! Test dimensions.
! ----------------

if ((ILOC < 1) .or. (ILOC > 3)) call CHO_QUIT('ILOC error in '//SECNAM,104)

if (MSYM /= NSYM) call CHO_QUIT('NSYM error in '//SECNAM,104)

if (MMSHL /= NNSHL) call CHO_QUIT('NNSHL error in '//SECNAM,104)

if (LMMBSTRT /= NNBSTRT(1)) call CHO_QUIT('NNBSTRT(1) error in '//SECNAM,104)

if (LMMBSTRT < NNBSTRT(ILOC)) call CHO_QUIT('NNBSTRT(ILOC) error in '//SECNAM,104)

if ((IPASS < 1) .or. (IPASS > MAXRED)) call CHO_QUIT('IPASS error in '//SECNAM,104)

! Get first address.
! ------------------

IADR1 = INFRED(IPASS)
if (IADR1 < 0) then
  write(LUPRI,*) SECNAM,': negative address for reduced set ',IPASS,': ',IADR1
  call CHO_QUIT('Error in '//SECNAM,104)
end if

if (LOCDBG) write(LUPRI,*) SECNAM,': putting reduced set ',IPASS,' at addr: ',IADR1

! Write index arrays.
! -------------------

IOPT = 1
IADR = IADR1
LTOT = NSYM*NNSHL
call IDAFILE(LURED,IOPT,NNBSTRSH,LTOT,IADR)
IOPT = 1
IADR = IADR1+NSYM*NNSHL
LTOT = NNBSTRT(ILOC)
call IDAFILE(LURED,IOPT,INDRED,LTOT,IADR)
if (IPASS == 1) then
  IOPT = 1
  IADR = IADR1+NSYM*NNSHL+NNBSTRT(1)
  LTOT = NNBSTRT(1)
  call IDAFILE(LURED,IOPT,INDRSH,LTOT,IADR)
  IOPT = 1
  IADR = IADR1+NSYM*NNSHL+2*NNBSTRT(1)
  LTOT = NNSHL
  call IDAFILE(LURED,IOPT,ISP2F,LTOT,IADR)
end if

end subroutine CHO_PUTRED1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Anders Bernhardsson                              *
************************************************************************
      Subroutine ExpHinvv(rdia,v,u,alpha,beta)
      use Exp, only: H0S, H0F, SBIDT, nExp
*
*     Preconditioning of the state transfer part
*     of the  electronic hessian with an subunit
*     described with the Explicit hessian and
*     the rest with the diagonal
*
*                              -1
*  |u> = alpha|u> + beta  (H-E ) |v>
*                           0 0
*
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
#include "stdalloc.fh"
#include "incdia.fh"
      Real*8 v(*),u(*),rdia(*)
      Real*8, Allocatable:: Tmp1(:), Tmp4(:)
*
      If (nExp.ne.0) Then
      Call mma_allocate(Tmp1,nExp,Label='Tmp1')
      Call mma_allocate(Tmp4,nExp,Label='Tmp4')
*
      Do i=1,nExp
       j=SBIDT(i)
       Tmp1(i)=v(j)
       Tmp4(i)=u(j)
      End Do
*
      irc=0
      call dgetrs_('N',NEXP,1,H0S,nexp,H0F,Tmp1,nexp,irc)
      If (irc.ne.0) then
       write(6,*) 'Error in DGETRS called from exphinvv'
       Call Abend
      endif
*
      If (alpha.eq.0.0d0.and.beta.eq.1.0d0) Then
      Call DVEM(nConf1,v,1,rdia,1,u,1)
      Else If (alpha.eq.0.0d0) Then
      Do i=1,nConf1
        u(i)=beta*rDia(i)*v(i)
      End Do
      Else If (alpha.eq.1.0d0) Then
      Do i=1,nConf1
        u(i)=u(i)+beta*rDia(i)*v(i)
      End Do
      else
      Do i=1,nConf1
        u(i)=alpha*u(i)+beta*rDia(i)*v(i)
      End Do
      End If
*
      Do i=1,nExp
       j=SBIDT(i)
       u(j)=alpha*Tmp4(i)+beta*Tmp1(i)
      End Do
      Call mma_deallocate(Tmp1)
      Call mma_deallocate(Tmp4)

      Else
      If (alpha.eq.0.0d0.and.beta.eq.1.0d0) Then
      Call DVEM(nConf1,v,1,rdia,1,u,1)
      Else If (alpha.eq.0.0d0) Then
      Do i=1,nConf1
        u(i)=beta*rDia(i)*v(i)
      End Do
      Else If (alpha.eq.1.0d0) Then
      Do i=1,nConf1
        u(i)=u(i)+beta*rDia(i)*v(i)
      End Do
      else
      Do i=1,nConf1
        u(i)=alpha*u(i)+beta*rDia(i)*v(i)
      End Do
      End If

      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine map(wrk,wrksize,nind,p,q,r,s,a,ssa,b,post,rc)
! this routine realizes mappings
!
! B(indb) <-- A(inda)
! where inda are order of indices in mtx A and indb = Perm(inda)
!
! nind - number of indices in matrix A (and B)  (Input)
! p    - position of 1st index of mtx A in mtx B  (Input)
! q    - position of 2nd index of mtx A in mtx B  (Input)
! r    - position of 3rd index of mtx A in mtx B  (Input)
! s    - position of 4th index of mtx A in mtx B  (Input)
! a    - map type corresponding to A  (Input)
! ssa  - overall symmetry state of matrix A  (Input)
! b    - map type corresponding to B  (Output)
! post - final position of matrix B in WRK (Output, not used yet)
! rc   - return (error) code  (Output)
!
! The table of implemented permutations
!
! ninda  typA   p  q  r  s            Operation                 Implemented
!
! 4     0     all 24 comb.    A(1,2,3,4) -> B(p,q,r,s)             Yes
!
! 4     1     1  2  3  4      A(12,3,4)  -> B(12,3,4)              Yes
! 4     1     1  2  4  3      A(12,3,4)  -> B(12,4,3)              Yes
! 4     1     2  3  1  4      A(12,3,4)  -> B(3,12,4)              Yes
! 4     1           4  1      A(12,3,4)  -> B(4,12,3)              Yes
! 4     1     3  4  1  2      A(12,3,4)  -> B(3,4,12)              Yes
! 4     1           2  1      A(12,3,4)  -> B(4,3,12)              Yes
! 4     1     other comb.                                          No
!
! 4     2     1  2  3  4      A(1,23,4)  -> B(1,23,4)              Yes
! 4     2     4  2  3  1      A(1,23,4)  -> B(4,23,1)              Yes
! 4     2     3  1  2  4      A(1,23,4)  -> B(23,1,4)              Yes
! 4     2     4        3      A(1,23,4)  -> B(23,4,1)              Yes
! 4     2     1  3  4  2      A(1,23,4)  -> B(1,4,23)              Yes
! 4     2     2        1      A(1,23,4)  -> B(4,1,23)              Yes
! 4     2     other comb.                                          No
!
! 4     3     1  2  3  4      A(1,2,34)  -> B(1,2,34)              Yes
! 4     3     2  1  3  4      A(1,2,34)  -> B(2,1,34)              Yes
! 4     3     3  4  1  2      A(1,2,34)  -> B(34,1,2)              Yes
! 4     3     4  4            A(1,2,34)  -> B(34,2,1)              Yes
! 4     3     1  4  2  3      A(1,2,34)  -> B(1,34,2)              Yes
! 4     3     4  1            A(1,2,34)  -> B(2,34,1)              Yes
! 4     3     other comb.                                          No
!
! 4     4     1  2  3  4      A(12,34)   -> B(12,34)               Yes
! 4     4     3  4  1  2      A(12,34)   -> B(32,12)               Yes
! 4     4     other comb.                                          No
!
! 3     0     all 6 comb.     A(1,2,3)   -> B(p,q,r)               Yes
!
! 3     1     1  2  3  -      A(12,3)    -> B(12,3)                Yes
! 3     1     2  3  1  -      A(12,3)    -> B(3,12)                Yes
! 3     1     other comb.                                          No
!
! 3     2     1  2  3         A(1,23)    -> B(1,23)                Yes
! 3     2     3  1  2         A(1,23)    -> B(23,1)                Yes
! 3     2     other comb.                                          No
!
! 2     0     all 2 comb.     A(1,2)     -> B(p,q)                 Yes
!
! 2     1     1  2  -  -      A(12)      -> B(12)                  Yes
! 2     1     other comb.                                          No

use ccsd_global, only: dimm, Map_Type
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, nind, p, q, r, s, ssa
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: a
type(Map_Type), intent(inout) :: b
integer(kind=iwp), intent(out) :: post, rc
integer(kind=iwp) :: dl(4), ia, ib, newtyp, nhelp1, nhelp2, nhelp3, nhelp4, nhelp5, nhelp6, nhelp7, sa(4), typ, type_(4)

rc = 0

! some test of correctness

nhelp1 = p+q+r+s
if ((nind == 1) .and. (nhelp1 == 1)) then
else if ((nind == 2) .and. (nhelp1 == 3)) then
else if ((nind == 3) .and. (nhelp1 == 6)) then
else if ((nind == 4) .and. (nhelp1 == 10)) then
else
  ! RC=1 - incorrect indices
  rc = 1
  return
end if

! ******** No permutation *******

if (nind == 1) then
  call noperm(wrk,wrksize,a,b,post)
  return
end if

if ((nind == 2) .and. (p == 1) .and. (q == 2)) then
  call noperm(wrk,wrksize,a,b,post)
  return
end if

if ((nind == 3) .and. (p == 1) .and. (q == 2) .and. (r == 3)) then
  call noperm(wrk,wrksize,a,b,post)
  return
end if

if ((nind == 4) .and. (p == 1) .and. (q == 2) .and. (r == 3) .and. (s == 4)) then
  call noperm(wrk,wrksize,a,b,post)
  return
end if

if (nind == 2) then

! *********** 2 index ***********

  typ = a%d(0,6)

  if (typ == 0) then

    !2.1 map A(p,q) -> B(q,p)

    ! get b%d,b%i

    type_(p) = a%d(0,1)
    type_(q) = a%d(0,2)
    call grc0(nind,0,type_(1),type_(2),0,0,ssa,post,b)

    do ia=1,a%d(0,5)
      if (a%d(ia,2) == 0) cycle

      sa(p) = a%d(ia,3)
      sa(q) = a%d(ia,4)
      ib = b%i(sa(1),1,1)

      ! positions of A,B
      nhelp1 = a%d(ia,1)
      nhelp2 = b%d(ib,1)

      ! dimp,dimq
      nhelp3 = dimm(a%d(0,1),sa(p))
      nhelp4 = dimm(a%d(0,2),sa(q))
      call map21(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,p,q,1)

    end do

  else
    ! RC=2 - bad typ for: nind=2
    rc = 2
  end if

else if (nind == 3) then

  ! *********** 3 index ***********

  typ = a%d(0,6)

  if (typ == 0) then

    !3.1 map A(p,q,r) -> B(p1,q1,r1)

    ! get b%d,b%i

    type_(p) = a%d(0,1)
    type_(q) = a%d(0,2)
    type_(r) = a%d(0,3)
    call grc0(nind,0,type_(1),type_(2),type_(3),0,ssa,post,b)

    do ia=1,a%d(0,5)
      if (a%d(ia,2) == 0) cycle

      sa(p) = a%d(ia,3)
      sa(q) = a%d(ia,4)
      sa(r) = a%d(ia,5)
      ib = b%i(sa(1),sa(2),1)

      ! positions of A,B
      nhelp1 = a%d(ia,1)
      nhelp2 = b%d(ib,1)

      ! dimp,dimq,r
      nhelp3 = dimm(a%d(0,1),sa(p))
      nhelp4 = dimm(a%d(0,2),sa(q))
      nhelp5 = dimm(a%d(0,3),sa(r))
      call map31(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,p,q,r,1)

    end do

  else if (typ == 1) then

    !3.2 map A(pq,r)
    !    => only sophystical order of p,q,r is 2,3,1 i.e. B(r,pq)
    !    => newtyp=2

    if ((p == 2) .and. (q == 3) .and. (r == 1)) then

      ! get b%d,b%i

      type_(p) = a%d(0,1)
      type_(q) = a%d(0,2)
      type_(r) = a%d(0,3)
      call grc0(nind,2,type_(1),type_(2),type_(3),0,ssa,post,b)

      do ia=1,a%d(0,5)
        if (a%d(ia,2) == 0) cycle

        sa(p) = a%d(ia,3)
        sa(q) = a%d(ia,4)
        sa(r) = a%d(ia,5)
        ib = b%i(sa(1),sa(2),1)

        ! positions of A,B
        nhelp1 = a%d(ia,1)
        nhelp2 = b%d(ib,1)

        ! dimp,dimq,dimr
        nhelp3 = dimm(a%d(0,1),sa(p))
        nhelp4 = dimm(a%d(0,2),sa(q))
        nhelp5 = dimm(a%d(0,3),sa(r))

        ! dimpq
        if (sa(1) == sa(2)) then
          nhelp7 = nhelp3*(nhelp3-1)/2
        else
          nhelp7 = nhelp3*nhelp4
        end if
        call map21(wrk(nhelp1),wrk(nhelp2),nhelp7,nhelp5,2,1,1)

      end do

    else
      ! RC=3 - bad order of p,q,r for: nind=3,typ=1
      rc = 3
    end if

  else if (typ == 2) then

    !3.3 map A(p,qr)
    !    => only sophystical order of p,q,r is 3,1,2 i.e. B(qr,p)
    !    => typb=1

    if ((p == 3) .and. (q == 1) .and. (r == 2)) then

      ! get b%d,b%i

      type_(p) = a%d(0,1)
      type_(q) = a%d(0,2)
      type_(r) = a%d(0,3)
      call grc0(nind,1,type_(1),type_(2),type_(3),0,ssa,post,b)

      do ia=1,a%d(0,5)
        if (a%d(ia,2) == 0) cycle

        sa(p) = a%d(ia,3)
        sa(q) = a%d(ia,4)
        sa(r) = a%d(ia,5)
        ib = b%i(sa(1),sa(2),1)

        ! positions of A,B
        nhelp1 = a%d(ia,1)
        nhelp2 = b%d(ib,1)

        ! dimp,dimq,dimr
        nhelp3 = dimm(a%d(0,1),sa(p))
        nhelp4 = dimm(a%d(0,2),sa(q))
        nhelp5 = dimm(a%d(0,3),sa(r))

        ! dimpq
        if (sa(1) == sa(2)) then
          nhelp7 = nhelp4*(nhelp4-1)/2
        else
          nhelp7 = nhelp4*nhelp5
        end if
        call map21(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp7,2,1,1)

      end do

    else
      ! RC=4 - bad order of p,q,r for: nind=3,typ=2
      rc = 4
    end if

  else
    ! RC=5 - bad type for: nind=3
    rc = 5
  end if

else if (nind == 4) then

  ! *********** 4 index ***********

  typ = a%d(0,6)

  if (typ == 0) then

    !4.1 map A(p,q,r,s)

    ! get b%d,b%i

    type_(p) = a%d(0,1)
    type_(q) = a%d(0,2)
    type_(r) = a%d(0,3)
    type_(s) = a%d(0,4)
    call grc0(nind,0,type_(1),type_(2),type_(3),type_(4),ssa,post,b)

    do ia=1,a%d(0,5)
      if (a%d(ia,2) == 0) cycle

      sa(p) = a%d(ia,3)
      sa(q) = a%d(ia,4)
      sa(r) = a%d(ia,5)
      sa(s) = a%d(ia,6)
      ib = b%i(sa(1),sa(2),sa(3))

      ! positions of A,B
      nhelp1 = a%d(ia,1)
      nhelp2 = b%d(ib,1)

      ! dimp,dimq,dimr,dims
      nhelp3 = dimm(a%d(0,1),sa(p))
      nhelp4 = dimm(a%d(0,2),sa(q))
      nhelp5 = dimm(a%d(0,3),sa(r))
      nhelp6 = dimm(a%d(0,4),sa(s))
      call map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,p,q,r,s,1)

    end do

  else if ((typ > 0) .and. (typ < 4)) then

    !4.2 map A(p,q,r,s) with one limitation

    ! def newtype and do corresponding tests

    if (typ == 1) then
      if ((p > 3) .or. ((q-p) /= 1)) then
        ! RC=6 bad order of p,q,r,s, for: nind=4,typ=1
        rc = 6
        return
      else
        nhelp1 = p
      end if
    else if (typ == 2) then
      if ((q > 3) .or. ((r-q) /= 1)) then
        ! RC=7 bad order of p,q,r,s, for: nind=4,typ=2
        rc = 7
        return
      else
        nhelp1 = q
      end if
    else if (typ == 3) then
      if ((r > 3) .or. ((s-r) /= 1)) then
        ! RC=8 bad order of p,q,r,s, for: nind=4,typ=3
        rc = 8
        return
      else
        nhelp1 = r
      end if
    end if
    newtyp = nhelp1

    ! get b%d,b%i

    type_(p) = a%d(0,1)
    type_(q) = a%d(0,2)
    type_(r) = a%d(0,3)
    type_(s) = a%d(0,4)
    call grc0(nind,newtyp,type_(1),type_(2),type_(3),type_(4),ssa,post,b)

    do ia=1,a%d(0,5)
      if (a%d(ia,2) == 0) cycle

      sa(p) = a%d(ia,3)
      sa(q) = a%d(ia,4)
      sa(r) = a%d(ia,5)
      sa(s) = a%d(ia,6)
      ib = b%i(sa(1),sa(2),sa(3))

      ! positions of A,B
      nhelp1 = a%d(ia,1)
      nhelp2 = b%d(ib,1)

      ! dimp,dimq,dimr,dims
      dl(p) = dimm(a%d(0,1),sa(p))
      dl(q) = dimm(a%d(0,2),sa(q))
      dl(r) = dimm(a%d(0,3),sa(r))
      dl(s) = dimm(a%d(0,4),sa(s))

      if ((newtyp == 1) .and. (sa(1) == sa(2))) then
        ! B(p1q1,r1,s1) case => oldtyp can be 2,3
        nhelp7 = dl(1)*(dl(1)-1)/2

        if (typ == 1) then
          ! A(pq,r,s) case
          ! A(pq,r,s) -> A(pq,s,r)
          call map31(wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),1,3,2,1)
        else if (typ == 2) then
          ! A(p,qr,s) case
          if (p == 3) then
            ! A (p,qr,s) -> B(qr,p,s)
            call map31(wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),2,1,3,1)
          else
            ! A (p,qr,s) -> B(qr,s,p)
            call map31(wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),3,1,2,1)
          end if
        else
          ! A(p,q,rs) case
          if (p == 3) then
            ! A (p,q,rs) -> B(rs,p,q)
            call map31(wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,2,3,1,1)
          else
            ! A (p,q,rs) -> B(rs,q,p)
            call map31(wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,3,2,1,1)
          end if
        end if

      else if ((newtyp == 2) .and. (sa(2) == sa(3))) then
        ! B(p1,q1r1,s1) case => oldtyp can be 1,3
        nhelp7 = dl(2)*(dl(2)-1)/2
        if (typ == 1) then
          ! A(pq,r,s) case
          if (r == 1) then
            ! A (pq,r,s) -> B(r,pq,s)
            call map31(wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),2,1,3,1)
          else
            ! A (pq,r,s) -> B(s,pq,p)
            call map31(wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),2,3,1,1)
          end if
        else if (typ == 2) then
          ! A(p,qr,s) case
          ! A(p,qr,s) -> B(s,qr,p)
          call map31(wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),3,2,1,1)
        else
          ! A(p,q,rs) case
          if (p == 1) then
            ! A (p,q,rs) -> B(p,rs,q)
            call map31(wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,1,3,2,1)
          else
            ! A (p,q,rs) -> B(q,rs,p)
            call map31(wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,3,1,2,1)
          end if
        end if

      else if ((newtyp == 3) .and. (sa(3) == sa(4))) then
        ! B(p1,q1,r1s1) case => oldtyp can be 1,2
        nhelp7 = dl(3)*(dl(3)-1)/2
        if (typ == 1) then
          ! A(pq,r,s) case
          if (r == 2) then
            ! A (pq,r,s) -> B(r,s,pq)
            call map31(wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),3,1,2,1)
          else
            ! A (pq,r,s) -> B(s,r,pq)
            call map31(wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),3,2,1,1)
          end if
        else if (typ == 2) then
          ! A(p,qr,s) case
          if (p == 1) then
            ! A (p,qr,s) -> B(p,s,qr)
            call map31(wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),1,3,2,1)
          else
            ! A (p,qr,s) -> B(s,p,qr)
            call map31(wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),2,3,1,1)
          end if
        else
          ! A(p,q,rs) case
          ! A(p,q,rs) -> A(q,p,rs)
          call map31(wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,2,1,3,1)
        end if

      else
        ! B(p1,q1,r1,s1) case
        call map41(wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),dl(r),dl(s),p,q,r,s,1)
      end if

    end do

  else if (typ == 4) then

    !4.2 map A(pq,rs) -> B(rs,pq)

    ! tests

    if ((p /= 3) .and. (q /= 4) .and. (r /= 1) .and. (s /= 2)) then
      ! RC=9 : nind=4, typA=4 (bad order of p,q,r,s, Stup)
      rc = 9
      return
    end if

    ! get b%d,b%i

    type_(p) = a%d(0,1)
    type_(q) = a%d(0,2)
    type_(r) = a%d(0,3)
    type_(s) = a%d(0,4)
    call grc0(nind,4,type_(1),type_(2),type_(3),type_(4),ssa,post,b)

    do ia=1,a%d(0,5)
      if (a%d(ia,2) == 0) cycle

      sa(p) = a%d(ia,3)
      sa(q) = a%d(ia,4)
      sa(r) = a%d(ia,5)
      sa(s) = a%d(ia,6)
      ib = b%i(sa(1),sa(2),sa(3))

      ! positions of A,B
      nhelp1 = a%d(ia,1)
      nhelp2 = b%d(ib,1)

      ! dimp,dimq,dimr,dims
      nhelp3 = dimm(a%d(0,1),sa(p))
      nhelp4 = dimm(a%d(0,2),sa(q))
      nhelp5 = dimm(a%d(0,3),sa(r))
      nhelp6 = dimm(a%d(0,4),sa(s))

      if ((sa(p) == sa(q)) .and. (sa(r) == sa(s))) then
        ! A(pq,rs) -> B(rs,pq)
        nhelp3 = nhelp3*(nhelp3-1)/2
        nhelp5 = nhelp5*(nhelp5-1)/2
        call map21(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5,2,1,1)

      else if (sa(p) == sa(q)) then
        ! A(pq,r,s) -> B(r,s,pq)
        nhelp3 = nhelp3*(nhelp3-1)/2
        call map31(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5,nhelp6,3,1,2,1)

      else if (sa(r) == sa(s)) then
        ! A(p,q,rs) -> B(rs,p,q)
        nhelp5 = nhelp5*(nhelp5-1)/2
        call map31(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,2,3,1,1)

      else
        ! A(p,q,r,s) -> B(r,s,p,q)
        call map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,3,4,1,2,1)
      end if

    end do

  else
    ! RC=10 bad type for: nind=4
    rc = 10
  end if

else

  ! *********  more than 4 indices

  ! RC=11 bad number of indices
  rc = 11
end if

return

end subroutine map

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dWBuf(Array,nArray)

use dEAF, only: dEAFAWrite
use IOBUF, only: Buffer, Disk, Disk_1, Disk_2, DiskMx_Byte, iBuf, iD, InCore, IODone, iPos, lBuf, LuTmp, OnDisk
use Definitions, only: wp, iwp, RtoB, RtoI

implicit none
integer(kind=iwp), intent(in) :: nArray
real(kind=wp), intent(in) :: Array(nArray)
integer(kind=iwp) :: iArray, Left, mArray
real(kind=wp) :: Temp

!write(u6,*) 'Enter WBuf: iPos @',iPos,' iBuf,lBuf=',iBuf,lBuf
if (InCore .and. (iBuf == 2)) then
  call WarningMessage(2,'Error in in-core semi-direct implementation')
  call Abend()
end if
IODone = .true.
iArray = 1
mArray = nArray
do
  Left = lBuf-iPos+1
  if (mArray > Left) then
    Buffer(iPos:,iBuf) = Array(iArray:iArray+Left-1)
    iArray = iArray+Left
    mArray = mArray-Left
    iPos = 1

    ! Wait for previous buffer to complete I/O.
    ! Disk=32 after writing the control!

    !write(u6,*) 'In dwbuf'
    if ((Disk /= 32.0_wp) .and. OnDisk) call EAFWait(LuTmp,id)

    ! Put current buffer on disk and change buffer.

    temp = Disk+real(lBuf*RtoB,kind=wp)
    !write(u6,*) 'temp=',temp
    if (temp <= DiskMx_Byte) then
      Disk_2 = Disk_1
      Disk_1 = Disk
      !write(u6,*) 'WBuf write on disk @',Disk,'iBuf=',iBuf
      if (OnDisk) call dEAFAWrite(LuTmp,Buffer(1,iBuf),lBuf*RtoI,Disk,id)
      if (iBuf == 1) then
        iBuf = 2
      else
        iBuf = 1
      end if
    else
      call WarningMessage(2,'WBuf: Disc is full!!')
      call Abend()
    end if
  else
    !write(u6,*) ' Add ',mArray,'elements to buffer',iPos,ibuf
    Buffer(iPos:iPos+mArray-1,iBuf) = Array(iArray:iArray+mArray-1)
    iPos = iPos+mArray
    mArray = 0
  end if
  if (mArray <= 0) exit
end do

!write(u6,*) 'Exit WBuf: iPos @',iPos,'iBuf=',iBuf

return

end subroutine dWBuf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine Clr2(rIn,rOut,ibas,icmp,jbas,jcmp,
     &                iaoi,iaoj,naco,ishell,
     &                temp1,temp2,temp3,temp4,temp5,temp6)
*
      use pso_stuff
      use SOAO_Info, only: iAOtSO
      use Symmetry_Info, only: nIrrep, iOper
      use Basis_Info, only: nBas
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "etwas.fh"
#include "buffer.fh"
#include "disp.fh"
#include "disp2.fh"
#include "WrkSpc.fh"
*
      Real*8 rIn(ibas*icmp*jbas*jcmp,0:nIrrep-1,
     &       nAco*(1+naco)/2,*)
      real*8 rout(*)
      Real*8 Temp1(ibas,icmp,*)
      Real*8 Temp2(*)
      Real*8 Temp4(ibas,icmp,nACO)
      Real*8 Temp5(jbas,jcmp,nACO)
      Real*8 Temp3(jbas,jcmp,*),Temp6(*)
      integer ishell(4),na(0:7),ipp(0:7)
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)

      call dcopy_(Naco**4,[0.0d0],0,Temp2,1)
      call dcopy_(nACO*ICMP*IBAS,[0.0d0],0,Temp4,1)
      call dcopy_(nACO*JCMP*JBAS,[0.0d0],0,Temp5,1)
      nnA=0
      Do iS=0,nIrrep-1
       nA(iS)=nNA
       nna=nna+nAsh(is)
      End Do
      n=0
      Do i=1,nirrep
       n=n+ldisp(i-1)
      end do
      n=ibas*icmp*jbas*jcmp*nIrrep*nAco*(1+naco)/2*n
*
      ni=iCmp*iBas
      nj=jCmp*jBas
      ipi=1


      ipj=ipi+naco*ibas*icmp

      Call PckMo2(temp6(ipi),nAcO,icmp,iBas,jcmp,jBas,iaoi,iaoj)
      id=0
      Do mIrr=0,nIrrep-1
       iiii=0
       Do iS=0,nIrrep-1
        js=nrOpr(ieor(ioper(is),iOper(mIrr)))
        ipp(is)=iiii
        iiii=nbas(is)*nash(js)+iiii
       End Do
       Do iDisp=1,lDisp(mIrr)
        iD=id+1
        ia=1
        Do iIrr=0,nIrrep-1
         kl=0
         k=0
         Do kIrr=0,nIrrep-1
          Do kAsh=1,nAsh(kIrr)
           k=k+1
           l=0
           Do lIrr=0,kIrr
            kls=iEOR(iOper(kIrr),iOper(lIrr))
            jIrr=nropr(ieor(iEOR(iOper(iIrr),iOper(mIrr)),kls))
            ja=1
            Do j=0,jirr-1
             ja=ja+nAsh(j)
            End Do
*
*           Symmetry of Q matrix
*
            iis=nropr(ieor(iOper(jIrr),ioper(mIrr)))
            jis=nropr(ieor(iOper(iIrr),ioper(mIrr)))
*
            lMax=nAsh(lIrr)
            If (lIrr.eq.kirr) lmax=kash
            Do lAsh=1,lMax
             l=lash+nA(lIrr)
             kl=itri(k,l)
*
*            id,iirr,jirr,kA,lA
*
             If (nash(jirr).ne.0)
     &       Call DGEMM_('N','N',
     &                   ni,nAsh(jIrr),nj,
     &                   1.0d0,rin(1,iIrr,kl,id),ni,
     &                   Temp6(ipj+(ja-1)*jcmp*jBas),nj,
     &                   0.0d0,Temp1,ni)
            If (nash(iirr).ne.0)
     &       Call DGEMM_('T','N',
     &                   nash(iIrr),nAsh(jIrr),ni,
     &                   1.0d0,Temp6(ipi+(ia-1)*icmp*ibas),ni,
     &                   Temp1,ni,
     &                   0.0d0,Temp2,nash(iirr))
*
*
             Do iC=1,iCmp
              Do iB=1,iBas
               Do i=1,nAsh(jis)
                ih=i+na(jis)
                Temp4(iB,ic,i)=0.0d0
                Do iAsh=1,nAsh(jirr)
                 jh=iash+na(jirr)
                 fact=1.0d00
                 iij=itri(ih,jh)
                 if(iij.ge.kl .and. k.eq.l) fact=2.0d00
                 if(iij.lt.kl .and. ih.eq.jh) fact=2.0d00
                  If (k.ne.l) FacT=fact*2.0d0
                 rd=G2(itri(iij,kl),1)*fact
                 Temp4(iB,ic,i)=Temp4(ib,ic,i)+
     &                 Temp1(ib,ic,iash)*rd
                End Do
               End Do
              End Do
             End Do
*
             ipF=ipDisp3(id)-1+ipp(iirr)
             Do jAsh=1,nAsh(jis)
              Do iC=1,iCmp
               lSO=iAOtSO(iAOi+iC,iIrr)
               If (lso.gt.0) Then
                Do iB=1,iBas
                 lsl=lSO+ib-1
                 ipFKL=ipF+(jAsh-1)*nBas(iIrr)+lsl
                 rout(ipFKL)=rout(ipFKL)+Temp4(ib,ic,jash)
                End Do
               End If
              End Do
             End DO
*
             If (iShell(1).ne.ishell(2)) Then
              If (nash(jirr).ne.0)
     &        Call DGEMM_('T','N',
     &                    nj,nAsh(jIrr),ni,
     &                    1.0d0,rin(1,jIrr,kl,id),ni,
     &                    Temp6(ipi+(ja-1)*icmp*ibas),ni,
     &                    0.0d0,Temp3,nj)
              If (nash(iirr).ne.0)

     &        Call DGEMM_('T','N',nAsh(iirr),nAsh(jirr),nj,
     &                  One,Temp6(ipj+(ia-1)*jcmp*jBas),nj,
     &                  Temp3,nj,
     &                  one,Temp2,nAsh(iirr))
*
              Do jC=1,jCmp
               Do jB=1,jBas
                Do i=1,nAsh(jis)
                 ih=i+na(jis)
                 Temp5(jB,jc,i)=0.0d0
                 Do iAsh=1,nAsh(jirr)
                  jh=iash+na(jirr)
                  fact=1.0d00
                  iij=itri(ih,jh)
                  if(iij.ge.kl .and. k.eq.l) fact=2.0d00
                  if(iij.lt.kl .and. ih.eq.jh) fact=2.0d00
                  If (k.ne.l) FacT=fact*2.0d0
                  rd=G2(itri(iij,kl),1)*fact
                  Temp5(jB,jc,i)=Temp5(jb,jc,i)+Temp3(jb,jc,iash)*rd
                 End Do
                End Do
               End Do
              End Do
*
              ipf=ipDisp3(id)-1+ipp(iirr)
              Do iAsh=1,nAsh(jis)
               Do jC=1,jCmp
                iSO=iAOtSO(iAOj+jC,iIrr)
                If (iso.gt.0) Then
                 Do jB=1,jBas
                  i=iSO+jb-1
                  ipFKL=ipF+(iAsh-1)*nBas(iIrr)+i
                  rout(ipFKL)=rout(ipFKL)+Temp5(jb,jc,iash)
                 End Do
                End If
               End Do
              End DO
             End If
*
* Distribute integrals
*
             if (iirr.ge.jirr) then
             klt=itri(k,l)
             Do iAsh=1,nash(iirr)
              ij1=iAsh+na(iirr)
              Do jAsh=1,nash(jirr)
               ij2=jAsh+na(jirr)
               If (ij1.ge.ij2) Then
               ij12=itri(ij1,ij2)
               If (ij12.le.klt) Then
               ipM=ipMO(iD,1)+iTri(ij12,klt)-1
               ipm2=iash+(jash-1)*nash(iirr)
               rOut(ipm)=rout(ipm)+Temp2(ipm2)
               End If
               End If
              End Do
             End Do
             end if
            End DO ! lash
           End DO ! lirr
          End DO ! kash
         End DO ! kirr
         ia=ia+nAsh(iIrr)
        End DO ! iirr
       End DO ! ndisp
      End DO ! msym
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1995,1998, Jeppe Olsen                            *
************************************************************************
      SUBROUTINE GSBBD1_LUCIA(   RHO1,  NACOB,  ISCSM,  ISCTP,  ICCSM,
     &                          ICCTP,   IGRP,   NROW,   NGAS,   ISEL,
     &                           ICEL,     SB,     CB,  ADSXA, SXSTST,
     &                         STSTSX,MXPNGAS, NOBPTS, IOBPTS,  ITSOB,
     &                           MAXI,   MAXK,   SSCR,   CSCR,     I1,
*
     &                           XI1S,     I2,   XI2S,      H,  NSMOB,
     &                          NSMST,  NSMSX, MXPOBS,  RHO1S, SCLFAC,
     &                        IUSE_PH, IPHGAS,IDOSRHO1, SRHO1,   IAB)
*
* SUBROUTINE GSBBD1_LUCIA --> 40
*
*
* Contributions to one electron density matrix from column excitations
*
* GAS version, August 95 , Jeppe Olsen
* Particle-Hole version of Jan. 98
*
*
* =====
* Input
* =====
* RHO1  : One body density matrix to be updated
* NACOB : Number of active orbitals
* ISCSM,ISCTP : Symmetry and type of sigma columns
* ICCSM,ICCTP : Symmetry and type of C     columns
* IGRP : String group of columns
* NROW : Number of rows in S and C block
* NGAS : Number of active spaces
* ISEL : Number of electrons per AS for S block
* ICEL : Number of electrons per AS for C block
* CB   : Input C block
* ADASX : sym of a+, a => sym of a+a
* ADSXA : sym of a+, a+a => sym of a
* SXSTST : Sym of sx,!st> => sym of sx !st>
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
* MXPNGAS : Max number of AS spaces ( program parameter )
* NOBPTS  : Number of orbitals per type and symmetry
* IOBPTS : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* NSMOB,NSMST,NSMSX,NSMDX : Number of symmetries of orbitals,strings,
*       single excitations, double excitations
* MAXI   : Largest Number of ' spectator strings 'treated simultaneously
* MAXK   : Largest number of inner resolution strings treated at simult.
*
* ======
* Output
* ======
* RHO1 : Updated density block
*
* =======
* Scratch
* =======
*
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S   : MAXK*Max number of orbitals of given type and symmetry
* I2, XI2S   : MAXK*Max number of orbitals of given type and symmetry
*              type and symmetry
* RHO1S : Space for one electron density
*
* Jeppe Olsen, Winter of 1991
* Updated for GAS , August '95
*
      USE Para_Info, ONLY: MyRank, nProcs
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
      INTEGER ADSXA(MXPOBS,2*MXPOBS),SXSTST(NSMSX,NSMST),
     &        STSTSX(NSMST,NSMST)
      INTEGER NOBPTS(MXPNGAS,*), IOBPTS(MXPNGAS,*), ITSOB(*)
      INTEGER IPHGAS(*)
*.Input
      INTEGER ISEL(NGAS),ICEL(NGAS)
      DIMENSION CB(*),SB(*)
*.Output
      DIMENSION RHO1(*), SRHO1(*)
*.Scratch
      DIMENSION SSCR(*),CSCR(*),RHO1S(*)
      DIMENSION I1(*),XI1S(*)
      DIMENSION I2(*),XI2S(*)
*.Local arrays ( assume MPNGAS = 16 ) !!!
      DIMENSION ITP(16*16),JTP(16*16)
*
      DIMENSION IJ_REO(2),IJ_DIM(2),IJ_SM(2),IJ_TP(2),IJ_AC(2)
      DIMENSION IJ_OFF(2)
c     DIMENSION ISCR(2)
      DIMENSION ICGRP(16),ISGRP(16)
      DIMENSION H(*)
*. Add or subtract for spindensity
      IF(IAB.EQ.1) THEN
        XAB = 1.0D0
      ELSE
        XAB = -1.0D0
      END IF
*.Local arrays
      NTEST = 000
      IF(NTEST.GE.1000) THEN
        WRITE(6,*)
        WRITE(6,*) ' ================='
        WRITE(6,*) ' GSBBD1 in action '
        WRITE(6,*) ' ================='
        WRITE(6,*)
        WRITE(6,*) ' Occupation of active left strings '
        CALL IWRTMA(ISEL,1,NGAS,1,NGAS)
        WRITE(6,*) ' Occupation of active Right strings '
        CALL IWRTMA(ICEL,1,NGAS,1,NGAS)
        WRITE(6,*) ' ISCSM, ICCSM = ', ISCSM, ICCSM
*
        WRITE(6,*) ' GSBBD1, sclfac ',SCLFAC
      END IF
*
      IFRST = 1
*. Number of partitionings over column strings
CSVC: determine optimum number of partions as the lowest multiple of
C     NPROCS that satisfies a block size smaller than MAXI:
      NIPART=0
      DO
        NIPART=NIPART+NPROCS
        NIPARTSZ=MAX(NROW-1,0)/NIPART+1
        IF (NIPARTSZ.LE.MAXI) EXIT
      END DO

*. Groups defining supergroups
C          GET_SPGP_INF(ISPGP,ITP,IGRP)
      CALL GET_SPGP_INF(ICCTP,IGRP,ICGRP)
      CALL GET_SPGP_INF(ISCTP,IGRP,ISGRP)

* Type of single excitations that connects the two column strings
      CALL SXTYP2_GAS(    NSXTP,      ITP,      JTP,     NGAS,     ISEL,
     &                     ICEL,   IPHGAS)
*.Symmetry of single excitation that connects IBSM and JBSM
      IJSM = STSTSX(ISCSM,ICCSM)
      IF(NTEST.GE.1000)
     &WRITE(6,*) ' ISCSM,ICCSM IJSM ', ISCSM,ICCSM,IJSM
      IF(IJSM.EQ.0) GOTO 1001
      DO 900 IJTP=  1, NSXTP
        ITYP = ITP(IJTP)
        JTYP = JTP(IJTP)
        IF(NTEST.GE.1000) write(6,*) ' ITYP JTYP ', ITYP,JTYP
*. Hvilken vej skal vi valge,
*. Mi pojdem drugim putem (C)
*. VV: the code below confuses Absoft compiler and was rewritten.
c       NOP = 2
        IJ_AC(1) = 2
        IJ_AC(2) = 1
        IJ_TP(1) = ITYP
        IJ_TP(2) = JTYP
c        IF(IUSE_PH.EQ.1) THEN
c          CALL ALG_ROUTERX(IAOC,JAOC,NOP,IJ_TP,IJ_AC,IJ_REO,SIGNIJ)
c        ELSE
          IJ_REO(1) = 1
          IJ_REO(2) = 2
          SIGNIJ = 1.0D0
c        END IF
*
        if (IJ_REO(1).eq.1) THEN

*
        IJ_TP(1) = ITYP
        IJ_TP(2) = JTYP
        else
        IXXX = IJ_AC(1)
        IJ_AC(1) = IJ_AC(2)
        IJ_AC(2) = IXXX
*
c       ISCR(1) = ITYP
c       ISCR(2) = JTYP
        IJ_TP(1) = JTYP
        IJ_TP(2) = ITYP
        endif

c        ISCR(1) = IJ_AC(1)
c        ISCR(2) = IJ_AC(2)
c        IJ_AC(1) = ISCR(IJ_REO(1))
c        IJ_AC(2) = ISCR(IJ_REO(2))
*
c nasty code to avoid optimization
c        if(iscr(1).eq.-1000) print *,IJ_TP,IJ_REO
c        ISCR(1) = ITYP
c        ISCR(2) = JTYP
c        IJ_TP(1) = ISCR(IJ_REO(1))
c        IJ_TP(2) = ISCR(IJ_REO(2))

        DO 800 ISM = 1, NSMOB
*. new i and j so new intermediate strings
          KFRST = 1
*
          JSM = ADSXA(ISM,IJSM)
          IF(JSM.EQ.0) GOTO 800
          IF(NTEST.GE.1000) write(6,*) ' ISM JSM ', ISM,JSM
          NIORB = NOBPTS(ITYP,ISM)
          NJORB = NOBPTS(JTYP,JSM)
          IBIORB = IOBPTS(ITYP,ISM)
          IBJORB = IOBPTS(JTYP,JSM)
*. Reorder
*          ISCR(1) = ISM
*          ISCR(2) = JSM
*          IJ_SM(1) = ISCR(IJ_REO(1))
*          IJ_SM(2) = ISCR(IJ_REO(2))
**
*          ISCR(1) = NIORB
*          ISCR(2) = NJORB
*          IJ_DIM(1) = ISCR(IJ_REO(1))
*          IJ_DIM(2) = ISCR(IJ_REO(2))
**
*          ISCR(1) = IBIORB
*          ISCR(2) = IBJORB
*          IJ_OFF(1) = ISCR(IJ_REO(1))
*          IJ_OFF(2) = ISCR(IJ_REO(2))
**
**
      IF(IJ_REO(1).EQ.1) THEN
        IJ_SM(1)=ISM
        IJ_SM(2)=JSM
        IJ_DIM(1)=NIORB
        IJ_DIM(2)=NJORB
        IJ_OFF(1)=IBIORB
        IJ_OFF(2)=IBJORB
      ELSE
        IJ_SM(1)=JSM
        IJ_SM(2)=ISM
        IJ_DIM(1)=NJORB
        IJ_DIM(2)=NIORB
        IJ_OFF(1)=IBJORB
        IJ_OFF(2)=IBIORB
      END IF

          IF(NTEST.GE.2000)
     &    WRITE(6,*) ' NIORB NJORB ', NIORB,NJORB
          IF(NIORB.EQ.0.OR.NJORB.EQ.0) GOTO 800
*
*. For operator connecting to |Ka> and |Ja> i.e. operator 2
          SCLFACS = SCLFAC*SIGNIJ
          IF(NTEST.GE.1000)
     &    WRITE(6,*) ' IJ_SM,IJ_TP,IJ_AC',IJ_SM(2),IJ_TP(2),IJ_AC(2)
          CALL ADAST_GAS(IJ_SM(2),IJ_TP(2),    NGAS,   ICGRP,   ICCSM,
     &                         I1,    XI1S,  NKASTR,    IEND,   IFRST,
     &                      KFRST,    KACT, SCLFACS,IJ_AC(1))
*. For operator connecting |Ka> and |Ia>, i.e. operator 1
      IF (NKASTR.EQ.0) GOTO 800
          ONE = 1.0D0
          CALL ADAST_GAS(IJ_SM(1),IJ_TP(1),    NGAS,   ISGRP,   ISCSM,
     &                         I2,    XI2S,  NKASTR,    IEND,   IFRST,
     &                      KFRST,    KACT,     ONE,IJ_AC(1))
      IF (NKASTR.EQ.0) GOTO 800
*. Compress list to common nonvanishing elements
          IDOCOMP = 1
          IF(IDOCOMP.EQ.1) THEN
              CALL COMPRS2LST(     I1,   XI1S,IJ_DIM(2),   I2, XI2S,
     &                        IJ_DIM(1),NKASTR,NKAEFF)
          ELSE
              NKAEFF = NKASTR
          END IF
C         WRITE(6,*) ' NKAEFF NKASTR', NKAEFF,NKASTR

*. Loop over partitionings of N-1 strings
            KBOT = 1-MAXK
            KTOP = 0
  700       CONTINUE
              KBOT = KBOT + MAXK
              KTOP = MIN(KTOP + MAXK,NKAEFF)
              IF(KTOP.EQ.NKAEFF) THEN
                KEND = 1
              ELSE
                KEND = 0
              END IF
              LKABTC = KTOP - KBOT +1

*. This is the place to start over partitioning of I strings
              DO 701 IIPART = 1+MYRANK, NIPART, NPROCS
                IBOT = (IIPART-1)*NIPARTSZ+1
                ITOP = MIN(IBOT+NIPARTSZ-1,NROW)
                NIBTC = ITOP - IBOT + 1
                IF (NIBTC.LE.0) EXIT
* Obtain CSCR(I,K,JORB) = SUM(J)<K!A JORB!J>C(I,J)
                DO JJORB = 1,IJ_DIM(2)
                  ICGOFF = 1 + (JJORB-1)*LKABTC*NIBTC
                  CALL MATCG(     CB,CSCR(ICGOFF),NROW,NIBTC, IBOT,
     &                        LKABTC,
     &                       I1(KBOT+(JJORB-1)*NKASTR),
     &                       XI1S(KBOT+(JJORB-1)*NKASTR) )
                END DO
* Obtain SSCR(I,K,IORB) = SUM(I)<K!A IORB!J>S(I,J)
                DO IIORB = 1,IJ_DIM(1)
*.Gather S Block
                  ISGOFF = 1 + (IIORB-1)*LKABTC*NIBTC
                  CALL MATCG(     SB,SSCR(ISGOFF),NROW,NIBTC, IBOT,
     &                        LKABTC,
     &                       I2(KBOT+(IIORB-1)*NKASTR),
     &                       XI2S(KBOT+(IIORB-1)*NKASTR) )
                END DO
*
                IF(NTEST.GE.1000) THEN
                 WRITE(6,*) ' CSCR and SSCR '
                 CALL WRTMAT(CSCR,IJ_DIM(2),NKI,IJ_DIM(2),NKI)
                 CALL WRTMAT(SSCR,IJ_DIM(1),NKI,IJ_DIM(1),NKI)
                END IF
*
*. And then the hard work
                NKI = LKABTC*NIBTC
                FACTORC = 0.0D0
                FACTORAB = 1.0D0
                CALL MATML7(  RHO1S,   SSCR,   CSCR,IJ_DIM(1),IJ_DIM(2),
     &                          NKI,IJ_DIM(1),  NKI,IJ_DIM(2),FACTORC,
     &                      FACTORAB,     1)
*
                IF(NTEST.GE.100) THEN
                  WRITE(6,*) ' Block to one-body density '
                  CALL WRTMAT(RHO1S,IJ_DIM(1),IJ_DIM(2),
     &                              IJ_DIM(1),IJ_DIM(2))
                END IF
*. Scatter out to complete matrix
                DO JJORB = 1, IJ_DIM(2)
                  JORB = IJ_OFF(2)-1+JJORB
                  DO IIORB = 1, IJ_DIM(1)
                    IORB = IJ_OFF(1)-1+IIORB
                    RHO1((JORB-1)*NACOB+IORB) =
     &              RHO1((JORB-1)*NACOB+IORB) +
     &              RHO1S((JJORB-1)*IJ_DIM(1)+IIORB)
                    IF(IDOSRHO1.EQ.1) THEN
                      SRHO1((JORB-1)*NACOB+IORB) =
     &                SRHO1((JORB-1)*NACOB+IORB) +
     &                XAB*RHO1S((JJORB-1)*IJ_DIM(1)+IIORB)
                    END IF
                  END DO
                END DO
*               /\ End of hard work

  701     CONTINUE
*. /\ end of this I partitioning
*.end of this K partitioning
            IF(KEND.EQ.0) GOTO 700
*. End of loop over I partitionings
  800   CONTINUE
*.(end of loop over symmetries)
  900 CONTINUE
 1001 CONTINUE
*
C!    stop ' enforced stop in RSBBD1 '
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(SXSTST)
        CALL Unused_integer_array(ITSOB)
        CALL Unused_real_array(H)
        CALL Unused_integer(IUSE_PH)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992,1999, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NewPK(A,B,P,mZeta,nZeta,rKappa,Alpha,Beta)
!***********************************************************************
!                                                                      *
! Object : to compute P and kappa.                                     *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!             May '90, modified for integral cutoff.                   *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN.                              *
!             June '91, modified for k2 loop.                          *
!             January '92, modified for gradient calculations.         *
!***********************************************************************

use Constants, only: Zero, One, TwoP54
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mZeta, nZeta
real(kind=wp), intent(in) :: A(3), B(3), Alpha(nZeta), Beta(nZeta)
real(kind=wp), intent(out) :: P(nZeta,3), rKappa(nZeta)
integer(kind=iwp) :: iZeta
real(kind=wp) :: AB2, Tmp0, Tmp1

#ifdef _DEBUGPRINT_
call RecPrt(' In NewPK:Alpha',' ',Alpha,mZeta,1)
call RecPrt(' In NewPK:Beta',' ',Beta,mZeta,1)
#endif
AB2 = (A(1)-B(1))**2+(A(2)-B(2))**2+(A(3)-B(3))**2
do iZeta=1,mZeta
  Tmp0 = One/(Alpha(iZeta)+Beta(iZeta))
  Tmp1 = TwoP54*exp(-Alpha(iZeta)*Beta(iZeta)*AB2*Tmp0)*Tmp0
  if (Tmp1 < 1.0e-99_wp) Tmp1 = 1.0e-99_wp
  rKappa(iZeta) = Tmp1
  P(iZeta,:) = (Alpha(iZeta)*A(:)+Beta(iZeta)*B(:))*Tmp0
end do
rKappa(mZeta+1:) = Zero
P(mZeta+1:,:) = Zero

#ifdef _DEBUGPRINT_
call RecPrt(' In NewPK: Kappa',' ',rKappa,mZeta,1)
call RecPrt(' In NewPK: Px',' ',P(1,1),mZeta,1)
call RecPrt(' In NewPK: Py',' ',P(1,2),mZeta,1)
call RecPrt(' In NewPK: Px',' ',P(1,3),mZeta,1)
#endif

return

end subroutine NewPK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mult_Vk_Qv_s(V_k,nV_k,Qv,nQv,V_kQ,nV_kQ,nBas_Aux,nVec,nIrrep,QMode)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nV_k, nQv, nV_kQ, nIrrep, nBas_Aux(0:nIrrep-1), nVec(0:nIrrep-1)
real(kind=wp), intent(in) :: V_k(nV_k)
real(kind=wp), intent(out) :: Qv(nQv), V_kQ(nV_kQ)
character, intent(in) :: QMode
integer(kind=iwp) :: iAddr, iIrrep, iOffA, iOffB, iSeed, kp_V_k, lQv, lstepA, lstepB, Lu_Q, mQv, nI, nJ, nK, nMuNu
logical(kind=iwp) :: Out_of_Core
character(len=6) :: Name_Q
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
nMuNu = 1
kp_V_k = 1
lstepA = 0
lstepB = 1
if (Qmode == 'T') then
  V_kQ(:) = Zero
  lstepA = 1
  lstepB = 0
end if

do iIrrep=0,0  ! loop is wisely restricted to tot. symm. irrep
  iSeed = 55+iIrrep
  Lu_Q = IsFreeUnit(iSeed)
  write(Name_Q,'(A4,I2.2)') 'QVEC',iIrrep
  call DaName_MF_WA(Lu_Q,Name_Q)
  iAddr = 0

  nI = nBas_Aux(iIrrep)
  if (iIrrep == 0) nI = nI-1
  nJ = nVec(iIrrep)
  mQv = nI*nJ
  Out_of_Core = mQv > nQv
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (.not. Out_of_Core) then

    ! in-core case

    call dDaFile(Lu_Q,2,Qv,mQv,iAddr)

    call A_3C_Qv_s(V_k(kp_V_k),Qv,V_kQ,nMuNu,nI,nJ,QMode)

  else

    ! Out-of-core case

    iOffA = kp_V_k
    iOffB = iOffA
    do while (mQv >= nI)

      nK = min(mQv,nQv)/nI
      lQv = nI*nK
      call dDaFile(Lu_Q,2,Qv,lQv,iAddr)

      call A_3C_Qv_s(V_k(iOffA),Qv,V_kQ(iOffB),nMuNu,nI,nK,QMode)
      mQv = mQv-lQv
      iOffA = iOffA+lstepA*nK
      iOffB = iOffB+lstepB*nK
    end do

  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call DaClos(Lu_Q)

  kp_V_k = kp_V_k+nBas_Aux(iIrrep)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Mult_Vk_Qv_s

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Calc_Bc()
! this routine calcs Bc
! Bc(a,b,be,ga) =        (a,be|b,ga)
!               - S(i)   (a,be,|b,i).t1(ga,i)
!               - S(i)   (a,i,|b,ga).t1(be,i)
!               + S(i,j) (a,i|b,j).t1(be,i).t1(ga,j)

use chcc_global, only: Bc, no, nv, Q3, Q4, T1c
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: a, b, be, ga, i
real(kind=wp) :: s

call mma_allocate(Bc,nv,nv,nv,nv,label='Bc')

do ga=1,nv
  do be=1,nv
    do b=1,nv
      do a=1,nv

        !1 (a,be|b,ga)
        s = Q4(be,a,ga,b)

        !2,3 - S(i)   (a,be,|b,i).t1(ga,i)
        !    - S(i)   (a,i,|b,ga).t1(be,i)
        do i=1,no
          s = s-Q3(a,be,b,i)*T1c(ga,i)
          s = s-Q3(b,ga,a,i)*T1c(be,i)
        end do

        !4 + S(i,j) (a,i|b,j).t1(be,i).t1(ga,j)
        !do j=1,no
        !  do i=1,no
        !    s = s+Q21(a,i,b,j)*T1c(be,i)*T1c(ga,j)
        !  end do
        !end do

        Bc(a,b,be,ga) = s

      end do
    end do
  end do
end do

return

end subroutine Calc_Bc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine StdSewInput(LuRd,ifnr,mdc,iShll,BasisTypes,STDINP,lSTDINP,iErr)
!***********************************************************************
! This is a simplified copy of the BASI section of RdCtl_Seward that   *
! reads the string vector STDINP with the standard seward input        *
! generated by ZMatrixConverter.                                       *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc, n_dc
use Sizes_of_Seward, only: S
use Gateway_Info, only: UnNorm, Do_FckInt
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Angstrom
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: LuRd, lSTDINP
integer(kind=iwp), intent(inout) :: ifnr, mdc, iShll
integer(kind=iwp), intent(out) :: BasisTypes(4), iErr
character(len=180), intent(in) :: STDINP(mxAtom*2)
#include "print.fh"
integer(kind=iwp) :: i, ib, iend, Indx, iOff, iSh, iSTDINP, itype, jShll, lAng, Last, LenBSL, LuWr, n, nCnt
character(len=256) :: Basis_lib, Fname
character(len=180) :: Key, KWord, Line
character(len=80) :: BsLbl
character(len=180) :: Ref(2)
character(len=4) :: dbas
character(len=*), parameter :: DefNm = 'basis_library' !CGGd
integer(kind=iwp), parameter :: nBuff = 10000
real(kind=wp), allocatable :: Buffer(:)
integer(kind=iwp), external :: iCLast

!                                                                      *
!***********************************************************************
!                                                                      *
iErr = 0
!                                                                      *
!***********************************************************************
!                                                                      *
LuWr = u6

itype = 0

BasisTypes(:) = 0
!                                                                      *
!***** BASI ************************************************************
!                                                                      *
iSTDINP = 2

call mma_allocate(Buffer,nBuff,Label='Buffer')

do
  nCnttp = nCnttp+1
  if (nCnttp > Mxdbsc) then
    write(LuWr,*) ' Increase Mxdbsc'
    iErr = 1
    return
  end if

  ! Read the basis set label

  Key = STDINP(iSTDINP)
  BSLbl = Key(1:80)
  !call UpCase(BSLbl)
  LenBSL = len(BSLbl)
  Last = iCLast(BSLbl,LenBSL)
  Indx = index(BSLbl,'/')
  if (Indx == 0) then
    call WhichMolcas(Basis_lib)
    if (Basis_lib(1:1) /= ' ') then
      ib = index(Basis_lib,' ')-1
      if (ib < 1) call SysAbendMsg('rdCtl','Too long PATH to MOLCAS',' ')
      Fname = Basis_lib(1:ib)//'/basis_library'
    else
      Fname = DefNm
    end if
    Indx = Last+1
    dbsc(nCnttp)%Bsl = BSLbl
  else
    Fname = BSLbl(Indx+2:Last)
    if (Fname == ' ') then
      call WarningMessage(2,' No basis set library specified for;BSLbl='//BSLbl//';Fname='//Fname)
      call Quit_OnUserError()
    end if
    Fname = adjustl(Fname)
    dbsc(nCnttp)%Bsl = BSLbl(1:Indx-1)
  end if

  n = index(dbsc(nCnttp)%Bsl,' ')
  dbsc(nCnttp)%Bsl(n:n+5) = '.....'

  if (Show .and. (nPrint(2) >= 6)) then
    write(LuWr,*)
    write(LuWr,*)
    write(LuWr,'(1X,A,I5,A,A)') 'Basis Set ',nCnttp,' Label: ',BSLbl(1:Indx-1)
    write(LuWr,'(1X,A,A)') 'Basis set is read from library:',Fname(1:index(Fname,' '))
  end if

  jShll = iShll
  dbsc(nCnttp)%Bsl_old = dbsc(nCnttp)%Bsl
  dbsc(nCnttp)%mdci = mdc
  call GetBS(Fname,dbsc(nCnttp)%Bsl,iShll,Ref,UnNorm,LuRd,BasisTypes,STDINP,iSTDINP,.true.,.true.,' ')

  Do_FckInt = Do_FckInt .and. dbsc(nCnttp)%FOp
  if (itype == 0) then
    if ((BasisTypes(3) == 1) .or. (BasisTypes(3) == 2)) iType = BasisTypes(3)
  else
    if ((BasisTypes(3) == 1) .or. (BasisTypes(3) == 2)) then
      if (BasisTypes(3) /= iType) then
        BasisTypes(3) = -1
      end if
      iType = BasisTypes(3)
    end if
  end if
  if (itype == 1) ifnr = 1
  if (itype == 2) ifnr = 0

  if (Show .and. (nPrint(2) >= 6) .and. (Ref(1) /= '') .and. (Ref(2) /= '')) then
    write(LuWr,'(1x,a)') 'Basis Set Reference(s):'
    if (Ref(1) /= '') write(LuWr,'(5x,a)') Trim(Ref(1))
    if (Ref(2) /= '') write(LuWr,'(5x,a)') Trim(Ref(2))
    write(LuWr,*)
    write(LuWr,*)
  end if
  dbsc(nCnttp)%ECP = dbsc(nCnttp)%nPrj+dbsc(nCnttp)%nSRO+dbsc(nCnttp)%nSOC+dbsc(nCnttp)%nPP+dbsc(nCnttp)%nM1+dbsc(nCnttp)%nM2 /= 0
  dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal+dbsc(nCnttp)%nPrj+dbsc(nCnttp)%nSRO+dbsc(nCnttp)%nSOC+dbsc(nCnttp)%nPP

  lAng = max(dbsc(nCnttp)%nVal,dbsc(nCnttp)%nSRO,dbsc(nCnttp)%nPrj)-1
  S%iAngMx = max(S%iAngMx,lAng)
  ! No transformation needed for s and p shells
  Shells(jShll+1)%Transf = .false.
  Shells(jShll+1)%Prjct = .false.
  Shells(jShll+2)%Transf = .false.
  Shells(jShll+2)%Prjct = .false.
  nCnt = 0
  if (dbsc(nCnttp)%Aux) then
    do iSh=jShll+1,iShll
      Shells(iSh)%Aux = .true.
    end do
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Here we will have to fix that the 6-31G family of basis sets
  ! should by default be used with 6 d-functions rather than 5.

  KWord = ''
  KWord(1:Indx-1) = BSLbl(1:Indx-1)
  call UpCase(KWord)
  if (index(KWord,'6-31G') /= 0) then
    iSh=jShll+3
    if (iSh.le.iShll) then
      Shells(iSh)%Transf = .false.
      Shells(iSh)%Prjct = .false.
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do
    iSTDINP = iSTDINP+1
    Line = STDINP(iSTDINP)
    KWord = Line
    call UpCase(KWord)
    if (KWord(1:4) == 'END ') then
      if (nCnt == 0) then
        call WarningMessage(2,' Input error, no center specified!')
        call Quit_OnUserError()
      end if
      dbsc(nCnttp)%nCntr = nCnt
      call mma_allocate(dbsc(nCnttp)%Coor_Hidden,3,nCnt,Label='dbsc:C')
      dbsc(nCnttp)%Coor => dbsc(nCnttp)%Coor_Hidden(:,:)
      call DCopy_(3*nCnt,Buffer,1,dbsc(nCnttp)%Coor,1)
      mdc = mdc+nCnt
      exit
    end if

    ! Read Coordinates

    nCnt = nCnt+1
    n_dc = max(mdc+nCnt,n_dc)
    if (mdc+nCnt > MxAtom) then
      call WarningMessage(2,' RdCtl: Increase MxAtom')
      write(LuWr,*) '        MxAtom=',MxAtom
      call Quit_OnUserError()
    end if
    iend = index(KWord,' ')
    if (iEnd > LENIN+1) then
      write(u6,*) 'Warning: the label ',KWord(1:iEnd),' will be truncated to ',LENIN,' characters!'
    end if
    dc(mdc+nCnt)%LblCnt = KWord(1:min(LENIN,iend-1))
    dbas = trim(dc(mdc+nCnt)%LblCnt(1:LENIN))
    call Upcase(dbas)
    if (dbas == 'DBAS') then
      call WarningMessage(2,' RdCtl: ZMAT does not work with DBAS')
      call Quit_OnUserError()
    end if
    if (mdc+nCnt > 1) call Chk_LblCnt(dc(mdc+nCnt)%LblCnt,mdc+nCnt-1)
    iOff = 1+(nCnt-1)*3
    !write(u6,*) line
    read(Line,*)
    read(Line(6:),*)(Buffer(iOff+i),i=0,2) ! CGGn
    if (index(KWord,'ANGSTROM') /= 0) then
      do i=0,2
        Buffer(iOff+i) = Buffer(iOff+i)/Angstrom
      end do
    end if
  end do

  iSTDINP = iSTDINP+2
  if (iSTDINP >= lSTDINP) exit
end do

call mma_deallocate(Buffer)

if (S%iAngMx < 0) then
  write(u6,*) ' There is an error somewhere in the input!'
  write(u6,*) 'S%iAngMx < 0'
  iErr = 1
  return
end if

return

end subroutine StdSewInput

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1997, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE RSBB1E_LUCIA(  ISCSM,  ISCTP,  ICCSM,  ICCTP,   IGRP,
     &                           NROW,   NGAS,   ISEL,   ICEL,     SB,
     &                             CB,  ADSXA, STSTSX, NOBPTS,   MAXI,
     &                           MAXK,   SSCR,   CSCR,     I1,   XI1S,
     &                             I2,   XI2S,      H,  NSMOB,  NSMST,
*
     &                          NSMSX,    MOC, MXSXST, IH2TRM, SCLFAC,
     &                        IUSE_PH, IPHGAS, NTESTG)
*
* SUBROUTINE RSBB1E_LUCIA --> 33
*
*
* One electron excitations on column strings
*. If IH2TRM .ne. 0 then the diagonal and one-electron
*  excitations arising from the two body operator is also
* included
*
* =====
* Input
* =====
*
* ISCSM,ISCTP : Symmetry and type of sigma columns
* ISBCTP : Base for sigma column types
* ICCSM,ICCTP : Symmetry and type of C     columns
* ICBCTP : Base for C     column types
* IGRP : String group of columns
* NROW : Number of rows in S and C block
* NGAS : Number of active sets
* ISEL : Occupation in each active set for sigma block
* ICEL : Occupation in each active set for C     block
* CB   : Input C block
* ADASX : sym of a+, a => sym of a+a
* ADSXA : sym of a+, a+a => sym of a
* SXSTST : Sym of sx,!st> => sym of sx !st>
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
* NTSOB  : Number of orbitals per type and symmetry
* IBTSOB : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* NSMOB,NSMST,NSMSX,NSMDX : Number of symmetries of orbitals,strings,
*       single excitations, double excitations
* MAXI   : Largest Number of ' spectator strings 'treated simultaneously
* MAXK   : Largest number of inner resolution strings treated at simult.
*
* MOC  : Use MOC method ( instead of N-1 resolution method )
*
*
* ======
* Output
* ======
* SB : updated sigma block
*
* =======
* Scratch
* =======
*
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* H : Space for one electron integrals
*
* Jeppe Olsen, Winter of 1991
*              IUSE_PH added winter of 97
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "para_info.fh"
COLD      REAL*8 INPROD
*. MAX dimensions
#include "mxpdim.fh"
*. General input
      INTEGER ADSXA(MXPOBS,2*MXPOBS),
     &        STSTSX(NSMST,NSMST)
      INTEGER NOBPTS(MXPNGAS,*)
      INTEGER IPHGAS(NGAS)
*.Specific Input
      INTEGER ISEL(NGAS),ICEL(NGAS)
      DIMENSION CB(*)
*.Output
      DIMENSION SB(*)
*.Scatch
      DIMENSION SSCR(*),CSCR(*),I1(*),XI1S(*),H(*)
      DIMENSION I2(*),XI2S(*)
*.Local arrays ( assume MPNGAS = 16 ) !!!
      DIMENSION ITP(16),JTP(16)
      DIMENSION ISGRP(16),ICGRP(16)
*. For transposing integral block
      DIMENSION HSCR(MXPTSOB*MXPTSOB)
*
      DIMENSION IJ_REO(2),IJ_DIM(2),IJ_SM(2),IJ_TP(2),IJ_AC(2)
      DIMENSION ISCR(2)
* Type of single excitations that connects the two column strings
C     MOC = 1
      NTESTL = 000
      NTEST = MAX(NTESTL,NTESTG)
      IF(NTEST.GE.500)THEN
        WRITE(6,*)
        WRITE(6,*) ' ======================= '
        WRITE(6,*) ' Information from RSBB1E '
        WRITE(6,*) ' ======================= '
        WRITE(6,*)
        WRITE(6,*) ' RSBB1E : MOC,IH2TRM,IUSE_PH ', MOC,IH2TRM,IUSE_PH
        WRITE(6,*) ' ISEL : '
        CALL IWRTMA(ISEL,1,NGAS,1,NGAS)
        WRITE(6,*) ' ICEL : '
        CALL IWRTMA(ICEL,1,NGAS,1,NGAS)
      END IF

*. Number of partitionings over column strings
CSVC: determine optimum number of partions as the lowest multiple of
C     NPROCS that satisfies a block size smaller than MAXI:
      NIPART=0
      DO
        NIPART=NIPART+NPROCS
        NIPARTSZ=MAX(NROW-1,0)/NIPART+1
        IF (NIPARTSZ.LE.MAXI) EXIT
      END DO

*. Obtain groups
C     GET_SPGP_INF(ISPGP,ITP,IGRP)
      CALL GET_SPGP_INF(ICCTP,IGRP,ICGRP)
      CALL GET_SPGP_INF(ISCTP,IGRP,ISGRP)
*
      IFRST = 1
      JFRST = 1
*. Types of single excitations that connect ISEL and ICEL
      CALL SXTYP2_GAS(    NSXTP,      ITP,      JTP,     NGAS,     ISEL,
     &                     ICEL,   IPHGAS)
*.Symmetry of single excitation that connects IBSM and JBSM
      IJSM = STSTSX(ISCSM,ICCSM)
      IF(IJSM.EQ.0) GOTO 1001
      DO 900 IJTP=  1, NSXTP
        ITYP = ITP(IJTP)
        JTYP = JTP(IJTP)
        IF(NTEST.GE.2000)
     &  write(6,*) ' ITYP JTYP ', ITYP,JTYP
*. Is this combination of types allowed
        IJ_ACT = 1
c        IF(IJ_ACT.EQ.0) GOTO 900
*. Hvilken vej skal vi valge,
        NOP = 2
        IJ_AC(1) = 2
        IJ_AC(2) = 1
        IJ_TP(1) = ITYP
        IJ_TP(2) = JTYP
c        IF(IUSE_PH.EQ.1) THEN
c          CALL ALG_ROUTERX(IAOC,JAOC,NOP,IJ_TP,IJ_AC,IJ_REO,SIGNIJ)
c        ELSE
          IJ_REO(1) = 1
          IJ_REO(2) = 2
          SIGNIJ = 1.0D0
c        END IF
*
        if (IJ_REO(1).eq.1) THEN

*
        IJ_TP(1) = ITYP
        IJ_TP(2) = JTYP
        else
        IXXX = IJ_AC(1)
        IJ_AC(1) = IJ_AC(2)
        IJ_AC(2) = IXXX
*
        ISCR(1) = ITYP
        ISCR(2) = JTYP
        IJ_TP(1) = JTYP
        IJ_TP(2) = ITYP
        endif


c        ISCR(1) = IJ_AC(1)
c        ISCR(2) = IJ_AC(2)
c        IJ_AC(1) = ISCR(IJ_REO(1))
c        IJ_AC(2) = ISCR(IJ_REO(2))
*
c nasty code to avoid optimization
c        if(iscr(1).eq.-1000) print *,IJ_TP,IJ_REO
*
c        ISCR(1) = ITYP
c        ISCR(2) = JTYP
c        IJ_TP(1) = ISCR(IJ_REO(1))
c        IJ_TP(2) = ISCR(IJ_REO(2))
*
        DO 800 ISM = 1, NSMOB
          JSM = ADSXA(ISM,IJSM)
*. New intermediate strings will be accessed so
          KFRST = 1
          IF(JSM.EQ.0) GOTO 800
          IF(NTEST.GE.2000)
     &    write(6,*) ' ISM JSM ', ISM,JSM
          NIORB = NOBPTS(ITYP,ISM)
          NJORB = NOBPTS(JTYP,JSM)
*. Reorder
*
*          ISCR(1) = ISM
*          ISCR(2) = JSM
*          IJ_SM(1) = ISCR(IJ_REO(1))
*          IJ_SM(2) = ISCR(IJ_REO(2))
*
*          ISCR(1) = NIORB
*          ISCR(2) = NJORB
*          IJ_DIM(1) = ISCR(IJ_REO(1))
*          IJ_DIM(2) = ISCR(IJ_REO(2))
*
      IF(IJ_REO(1).EQ.1) THEN
        IJ_SM(1)=ISM
        IJ_SM(2)=JSM
        IJ_DIM(1)=NIORB
        IJ_DIM(2)=NJORB
      ELSE
        IJ_SM(1)=JSM
        IJ_SM(2)=ISM
        IJ_DIM(1)=NJORB
        IJ_DIM(2)=NIORB
      END IF

          IF(NIORB.EQ.0.OR.NJORB.EQ.0) GOTO 800
*. Fetch integrals : For CI-transformations using RSBB1E
*. most of the blocks vanishes
*.Obtain one electron integrals (ISM,ITP,JSM,JTP) transposed
           IF(IJ_REO(1).EQ.1) THEN
*. obtain integrals h(j,i)
             CALL GETH1(HSCR,IJ_SM(1),IJ_TP(1),IJ_SM(2),IJ_TP(2))
             CALL TRPMAT(HSCR,IJ_DIM(1),IJ_DIM(2),H)
           ELSE
*. Obtain integrals h(i,j)
             CALL GETH1(H,IJ_SM(2),IJ_TP(2),IJ_SM(1),IJ_TP(1))
           END IF
COLD       XNORM = INPROD(H,H,IJ_DIM(1)*IJ_DIM(2))
COLD       IF(XNORM.EQ.0) GOTO 800
          IF(MOC.EQ.0) THEN
*
*
* ======================================================================
*.                   Use N-1 resolution method
* ======================================================================
*
*
*. Obtain annihilation/creation maps for all K strings
*
*. For operator connecting to |Ka> and |Ja> i.e. operator 2
          SCLFACS = SIGNIJ*SCLFAC
          IF(NTEST.GE.1000)
     &    WRITE(6,*) ' IJ_SM,IJ_TP,IJ_AC',IJ_SM(2),IJ_TP(2),IJ_AC(2)
          CALL ADAST_GAS(IJ_SM(2),IJ_TP(2),    NGAS,   ICGRP,   ICCSM,
     &                         I1,    XI1S,  NKASTR,    IEND,   IFRST,
     &                      KFRST,    KACT, SCLFACS,IJ_AC(1))
*. For operator connecting |Ka> and |Ia>, i.e. operator 1
          ONE = 1.0D0
          CALL ADAST_GAS(IJ_SM(1),IJ_TP(1),    NGAS,   ISGRP,   ISCSM,
     &                         I2,    XI2S,  NKASTR,    IEND,   IFRST,
     &                      KFRST,    KACT,     ONE,IJ_AC(1))
*. Compress list to common nonvanishing elements
          IDOCOMP = 1
          IF(IDOCOMP.EQ.1) THEN
              CALL COMPRS2LST(     I1,   XI1S,IJ_DIM(2),   I2, XI2S,
     &                        IJ_DIM(1),NKASTR,NKAEFF)
          ELSE
              NKAEFF = NKASTR
          END IF
*. Loop over partitionings of the row strings
*. Loop over partitionings of N-1 strings
            KBOT = 1-MAXK
            KTOP = 0
  700       CONTINUE
              KBOT = KBOT + MAXK
              KTOP = MIN(KTOP + MAXK,NKAEFF)
              IF(KTOP.EQ.NKAEFF) THEN
                KEND = 1
              ELSE
                KEND = 0
              END IF
              LKABTC = KTOP - KBOT +1
*. This is the place to start over partitioning of I strings
              DO 701 IIPART = 1+MYRANK, NIPART, NPROCS
                IBOT = (IIPART-1)*MAXI+1
                ITOP = MIN(IBOT+MAXI-1,NROW)
                NIBTC = ITOP - IBOT + 1
                IF (NIBTC.LE.0) EXIT
* Obtain CSCR(I,K,JORB) = SUM(J)<K!A JORB!J>C(I,J)
                DO JJORB = 1,IJ_DIM(2)
                  ICGOFF = 1 + (JJORB-1)*LKABTC*NIBTC
                  CALL MATCG(     CB,CSCR(ICGOFF),NROW,NIBTC, IBOT,
     &                        LKABTC,
     &                       I1(KBOT+(JJORB-1)*NKASTR),
     &                       XI1S(KBOT+(JJORB-1)*NKASTR) )
                END DO
*.Obtain one electron integrals (ISM,ITP,JSM,JTP) transposed
C               CALL GETH1(HSCR,IJ_SM(1),IJ_TP(1),IJ_SM(2),IJ_TP(2))
C               CALL TRPMAT(HSCR,IJ_DIM(1),IJ_DIM(2),H)
*. Problems when HOLE switches blocks around ?
C               CALL GETH1(H,IJ_SM(2),IJ_TP(2),IJ_SM(1),IJ_TP(1))
                IF(NTEST.GE.1000) THEN
                  WRITE(6,*) ' RSBB1E H BLOCK '
                  CALL WRTMAT(H,IJ_DIM(2),IJ_DIM(1),IJ_DIM(2),IJ_DIM(1))
                END IF
*.Sscr(I,K,i) = CSCR(I,K,j)*h(j,i)
                NIK = NIBTC*LKABTC
                FACTORC = 0.0D0
                FACTORAB = 1.0D0
                IF(NTEST.GE.2000) THEN
                  WRITE(6,*) ' CSCR array,NIK X NJORB array '
                  CALL WRTMAT(CSCR,NIK,IJ_DIM(2),NIK,IJ_DIM(2))
                END IF
                CALL MATML7(   SSCR,   CSCR,      H,    NIK,IJ_DIM(1),
     &                        NIK,IJ_DIM(2),IJ_DIM(2),IJ_DIM(1),FACTORC,
     &                      FACTORAB,     0)
                IF(NTEST.GE.2000) THEN
                  WRITE(6,*) ' SSCR array,NIK X NIORB array '
                  CALL WRTMAT(SSCR,NIK,IJ_DIM(1),NIK,IJ_DIM(1))
                END IF
*.S(I,a+ K) =  S(I, a+ K) + sgn*Sscr(I,K,i)
                DO IIORB = 1,IJ_DIM(1)
                  ISBOFF = 1+(IIORB-1)*LKABTC*NIBTC
                  CALL MATCAS(SSCR(ISBOFF),SB,NIBTC,NROW,IBOT,
     &                         LKABTC,
     &                        I2(KBOT+(IIORB-1)*NKASTR),
     &                        XI2S(KBOT+(IIORB-1)*NKASTR))
                END DO
*
  701       CONTINUE
*.end of this K partitioning
            IF(KEND.EQ.0) GOTO 700
*. End of loop over I partitioninigs
          END IF
*.(End of algorithm switch)
  800   CONTINUE
*.(end of loop over symmetries)
  900 CONTINUE
 1001 CONTINUE
*
C!    WRITE(6,*) ' Enforced stop in RSBB1E '
C!    STOP' Enforced stop in RSBB1E '
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NSMSX)
        CALL Unused_integer(MXSXST)
      END IF
      END
cvv      SUBROUTINE PR_MATML_STAT
c*
c* Print statistics from matriw multiplier
c      IMPLICIT REAL*8(A-H,O-Z)
c      COMMON/MATMLST/XNFLOP,XNCALL,XLCROW,XLCCOL,XLCROWCOL,TMULT
c      COMMON/COPVECST/XNCALL_COPVEC,XNMOVE_COPVEC
c*
c      WRITE(6,*) ' Information about COPVEC calls '
c      WRITE(6,*) ' =============================='
c      WRITE(6,*) ' Number of calls ', XNCALL_COPVEC
c      WRITE(6,*) ' Number of R*8 words copied ', XNMOVE_COPVEC
c*
c      WRITE(6,*)
c      WRITE(6,*) ' Information about MATML7 calls : '
c      WRITE(6,*) ' ================================'
c      WRITE(6,*)
c      WRITE(6,*) ' Number of calls ', XNCALL
c      WRITE(6,*) ' Number of flops executed ', XNFLOP
c      WRITE(6,*) ' Average row length of C ',
c     &           XLCROWCOL/XLCCOL
c      WRITE(6,*) ' Average column  length of C ',
c     &           XLCROWCOL/XLCROW
c      WRITE(6,*) ' Average number of operations per element of  C ',
c     &           XNFLOP/XLCROWCOL
c      WRITE(6,*) ' Average number of operations per per call ',
c     &           XNFLOP/XNCALL
c      WRITE(6,*) ' Number of seconds spent in MATML7', TMULT
c*
c      WRITE(6,*) ' Average MFLOPS ',XNFLOP/TMULT/1000000.0D0
c      RETURN
c      END
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PROPER(PROP,ISTATE,JSTATE,TDMZZ,WDMZZ)

use Index_Functions, only: nTri_Elem
use rassi_global_arrays, only: JBNUM
use RASSI_AUX, only: TocM
use Cntrl, only: FnTOM, IRREP, lSym1, lSym2, LuTOM, NPROP, NSTATE, PNAME, PTYPE, ToFile
use Symmetry_Info, only: Mul, nIrrep
use rassi_data, only: NBASF, NBST, NTDMZZ
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: PROP(NSTATE,NSTATE,NPROP)
integer(kind=iwp), intent(in) :: ISTATE, JSTATE
real(kind=wp), intent(in) :: TDMZZ(NTDMZZ), WDMZZ(NTDMZZ)
integer(kind=iwp) :: I, ICALL = 0, iDisk, iDIskSav = 0, IndCall, IOFF(8), iProp, iSy12, iType, J, JOB1, JOB2, Mask, NIP, nScr
character(len=8) :: LABEL
real(kind=wp), allocatable :: IP(:), SCR(:,:)

! COMBINED SYMMETRY OF STATES:
JOB1 = JBNUM(ISTATE)
JOB2 = JBNUM(JSTATE)
LSYM1 = IRREP(JOB1)
LSYM2 = IRREP(JOB2)
ISY12 = MUL(LSYM1,LSYM2)
! THE SYMMETRY CHECK MASK:
MASK = 2**(ISY12-1)
! ALLOCATE A BUFFER FOR READING ONE-ELECTRON INTEGRALS
NIP = 4+nTri_Elem(NBST)
call mma_allocate(IP,NIP,Label='IP')
! FIRST SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS OF TDMSCR
call mk_IOFF(IOFF,nIrrep,NBASF,ISY12)
! CALCULATE THE SYMMETRIC AND ANTISYMMETRIC FOLDED TRANS D MATRICES
! AND SIMILAR WE-REDUCED SPIN DENSITY MATRICES
NSCR = nTri_Elem(NBST)
call mma_allocate(SCR,nSCR,4,LABEL='SCR')
SCR(:,:) = Zero
call MK_TWDM(nIrrep,TDMZZ,WDMZZ,nTDMZZ,SCR,nSCR,iOFF,NBASF,ISY12)

! AT THIS POINT, THE SYMMETRICALLY AND ANTISYMMETRICALLY FOLDED
! DENSITY MATRICES, AND WE-REDUCED SPIN DENSITY MATRICES, HAVE BEEN
! CALCULATED BEGINNING IN SCR.
! LOOP OVER ALL REQUIRED ONE-ELECTRON OPERATORS:

!-------------------------------------------
!If requested by user, put SCR in an unformatted file for later
!use by another program. (A.Ohrn)
if (ToFile) then
  call DaName(LuToM,FnToM)
  if (iCall == 0) then  !Make room for table-of-contents
    iDisk = 0
    TocM(1:nTri_Elem(nState)) = -1
    call iDaFile(LuToM,1,TocM,nTri_Elem(nState),iDisk)
    TocM(1) = iDisk
    iDiskSav = iDisk
    iCall = 1
  end if
  if (iState < jState) then

    ! For the rest of the code to work this cannot be violated.

    write(u6,*) 'Proper: iState < jState'
    call Abend()
  end if
  i = iState
  j = jState
  indCall = nTri_Elem(i-1)+j  !Which call this is
  ToCM(indCall) = iDiskSav
  iDisk = iDiskSav
  !write(u6,*) 'IndCall,iDisk=',IndCall,iDisk
  call dDaFile(LuToM,1,SCR,4*nSCR,iDisk) !The THING.
  iDiskSav = iDisk  !Save diskaddress.
  iDisk = 0
  call iDaFile(LuToM,1,TocM,nTri_Elem(nState),iDisk)
  !Put table of contents.
  call DaClos(LuToM)
end if
!End of ToFile
!write(u6,*) 'ISTATE,JSTATE=',ISTATE,JSTATE
do IPROP=1,NPROP
  PROP(ISTATE,JSTATE,IPROP) = Zero
  LABEL = PNAME(IPROP)

  call UPCASE(LABEL)

  ! If the user wants the ASD term, it is the same as
  ! the EF2 term without the nuclear contribution
  ! the new magnetic integrals are calculated from X2C
  ! the old spin-dependent part is thus denoted as ASDO
  ! O for old
  if (LABEL(1:4) == 'ASDO') then
    LABEL(1:4) = 'EF2 '
    !write(u6,*) 'EF2---->ASD Here'
  end if
  if (LABEL(1:4) == 'TMOM') cycle

  if (LABEL(1:4) == 'PSOP') then
    LABEL(1:4) = 'PSOI'
    !write(u6,*) 'PSOI---->PSOP Here'
  end if

  if (LABEL(1:6) == 'DMP   ') LABEL(1:6) = 'DMS  1'

  ITYPE = 0
  if (PTYPE(IPROP) == 'HERMSING') ITYPE = 1
  if (PTYPE(IPROP) == 'ANTISING') ITYPE = 2
  if (PTYPE(IPROP) == 'HERMTRIP') ITYPE = 3
  if (PTYPE(IPROP) == 'ANTITRIP') ITYPE = 4
  if (ITYPE == 0) then
    write(u6,*) 'RASSI/PROPER internal error.'
    write(u6,*) 'Erroneous property type.'
    write(u6,*) 'PTYPE(IPROP)=',PTYPE(IPROP)
    call ABEND()
  end if

  call MK_PROP(PROP,IPROP,ISTATE,JSTATE,LABEL,ITYPE,IP,NIP,SCR,NSCR,MASK,ISY12,IOFF)

end do
call mma_deallocate(SCR)
call mma_deallocate(IP)

end subroutine PROPER

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine exchctl(exch,nneq,neqv,neq,nexch,nmax,lmax,npair,i_pair,MxRank1,MxRank2,imaxrank,Jex,JAex,JAex9,JDMex,JITOexR,JITOexI, &
                   eso,SM,MM,coord,rot,rlg,riso,tpar,upar,lant,itype,Dipol,AnisoLines1,AnisoLines3,AnisoLines9,KE,KEOPT, &
                   DM_exchange,JITO_exchange,W,Z,S,M,iPrint,mem)
! this Subroutine is a control Subroutine for the exchange interaction,
! diagonalization of total hamiltonian and computation of matrix elements
! of magnetic and spin moment
! neqv : max of neq(nneq)
! lant : (takes values from 1-7 for Gd-Yb respectively)
! mem  : memory allocated so far

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, cZero, cOne
use Definitions, only: wp, iwp, u6, CtoB, ItoB, RtoB

implicit none
integer(kind=iwp), intent(in) :: exch, nneq, neqv, neq(nneq), nexch(nneq), nmax, lmax, npair, i_pair(npair,2), MxRank1, MxRank2, &
                                 imaxrank(npair,2), lant, KEOPT, iPrint, mem
real(kind=wp), intent(in) :: Jex(npair), JAex(npair,3), JAex9(npair,3,3), JDMex(npair,3), &
                             JITOexR(nPair,MxRank1,-MxRank1:MxRank1,MxRank2,-MxRank2:MxRank2), &
                             JITOexI(nPair,MxRank1,-MxRank1:MxRank1,MxRank2,-MxRank2:MxRank2), eso(nneq,nmax), coord(nneq,3), &
                             rot(nneq,neqv,3,3), rlg(nneq,neqv,3,3), riso(3,3,nneq), tpar, upar
complex(kind=wp), intent(inout) :: SM(nneq,3,nmax,nmax), MM(nneq,3,nmax,nmax)
character, intent(in) :: itype(nneq)
logical(kind=iwp), intent(in) :: Dipol, AnisoLines1, AnisoLines3, AnisoLines9, KE, DM_exchange, JITO_exchange
real(kind=wp), intent(out) :: W(exch)
complex(kind=wp), intent(out) :: Z(exch,exch), S(3,exch,exch), M(3,exch,exch)
integer(kind=iwp) :: i, i1, i2, is1, isite, j, j1, j2, js1, l, lb1, lb2, lp, mem_local, n1, n2, nb, nb1, nb2, NmaxPop, nmaxR, nsta
real(kind=wp) :: dist, JAex_tmp(3), mg1(3,3), mg2(3,3), p1(3), p2(3), r1(3,3), r2(3,3), vect(3)
integer(kind=iwp), allocatable :: ibas(:,:), ibasR(:,:), icoord(:), intc(:), intcR(:), nexchR(:), nind(:,:)
real(kind=wp), allocatable :: eso_tmp(:,:), rotR(:,:,:,:), rotR_tmp(:,:,:,:), wdip(:), wdmo(:), wito(:), wkex(:), wlin(:), &
                              wlin1(:), wlin3(:), wlin9(:), WR(:)
complex(kind=wp), allocatable :: HDIP(:,:,:,:,:), HDIP_tmp(:,:,:,:,:), HDMO(:,:,:,:,:), HDMO_tmp(:,:,:,:,:), HITO(:,:,:,:,:), &
                                 HITO_tmp(:,:,:,:,:), HKEX(:,:,:,:,:), HKEXR(:,:,:,:,:), HKEXR_tmp(:,:,:,:,:), HLIN1(:,:,:,:,:), &
                                 HLIN1_tmp(:,:,:,:,:), HLIN3(:,:,:,:,:), HLIN3_tmp(:,:,:,:,:), HLIN9(:,:,:,:,:), &
                                 HLIN9_tmp(:,:,:,:,:), HTMP(:,:,:,:), M1(:,:,:), M2(:,:,:), MM_tmp1(:,:,:), MM_tmp2(:,:,:), &
                                 MM1(:,:,:), MM2(:,:,:), MMR(:,:,:,:), MR(:,:,:), S1(:,:,:), S2(:,:,:), SM_tmp1(:,:,:), &
                                 SM_tmp2(:,:,:), SM1(:,:,:), SM2(:,:,:), SMR(:,:,:,:), SR(:,:,:), tmp(:,:), tmp2(:,:), &
                                 tmp3(:,:,:,:,:), ZR(:,:)
integer(kind=iwp), parameter :: exchR = 8
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
integer(kind=iwp) :: k, k1, k2, q1, q2
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: dbg = _DBG_
integer(kind=iwp), external :: norder
real(kind=wp), external :: dnrm2_

#ifndef _DEBUGPRINT_
#include "macros.fh"
unused_var(riso)
unused_var(mem)
#endif

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#ifdef _DEBUGPRINT_
write(u6,'(A)') 'Enter EXCHCTL'
write(u6,'(A,  i8)') 'exch   = ',exch
write(u6,'(A,  i8)') 'nneq   = ',nneq
write(u6,'(A,  i8)') 'neqv   = ',neqv
write(u6,'(A,  i8)') 'nmax   = ',nmax
write(u6,'(A,  i8)') 'lmax   = ',lmax
write(u6,'(A,  i8)') 'nPair  = ',nPair
write(u6,'(A,  i8)') 'nPair  = ',nPair
write(u6,'(A,  i8)') 'MxRank1= ',MxRank1
write(u6,'(A,  i8)') 'MxRank2= ',MxRank2
write(u6,'(A,10i4)') 'neq()  = ',(neq(i),i=1,nneq)
write(u6,'(A,10i4)') 'nexch()= ',(nexch(i),i=1,nneq)
write(u6,'(A,  L2)') 'AnisoLines1  = ',AnisoLines1
write(u6,'(A,  L2)') 'AnisoLines3  = ',AnisoLines3
write(u6,'(A,  L2)') 'AnisoLines9  = ',AnisoLines9
write(u6,'(A,  L2)') 'DM_exchange  = ',DM_exchange
write(u6,'(A,  L2)') 'Dipol        = ',Dipol
write(u6,'(A,  L2)') 'JITO_exchange= ',JITO_exchange
if (AnisoLines1) then
  do i=1,nPair
    write(u6,'(A,2I4,F10.5)') 'LIN1',i_pair(i,1),i_pair(i,2),Jex(i)
  end do
end if

if (AnisoLines3) then
  do i=1,nPair
    write(u6,'(A,2I4,3F10.5)') 'LIN3',i_pair(i,1),i_pair(i,2),(JAex(i,j),j=1,3)
  end do
end if

if (AnisoLines9) then
  do i=1,nPair
    write(u6,'(A,2I4,9F10.5)') 'LIN9',i_pair(i,1),i_pair(i,2),((JAex9(i,j,k),j=1,3),k=1,3)
  end do
end if

if (DM_exchange) then
  do i=1,nPair
    write(u6,'(A,2I4,3F10.5)') 'DMEX',i_pair(i,1),i_pair(i,2),(JDMex(i,j),j=1,3)
  end do
end if

if (Dipol) then
  write(u6,'(A)') 'COORD(i):'
  do i=1,nneq
    write(u6,'(i3,3F14.8)') i,(coord(i,j),j=1,3)
  end do
end if

if (JITO_exchange) then
  do i=1,nPair
    write(u6,'(A,4I4,3F10.5)') 'ITOJ',i_pair(i,1),i_pair(i,2),imaxrank(i,1),imaxrank(i,2)
    do k1=1,imaxrank(i,1),2
      do q1=-k1,k1
        do k2=1,imaxrank(i,2),2
          do q2=-k2,k2
            write(u6,'(4I3,2x,2ES21.14)') k1,q1,k2,q2,JITOexR(i,k1,q1,k2,q2),JITOexI(i,k1,q1,k2,q2)
          end do
        end do
      end do
    end do
  end do ! ipair
end if

write(u6,'(A)') 'ESO(i):'
do i=1,nneq
  write(u6,'(i3,90F14.8)') i,(eso(i,j),j=1,nmax)
end do
write(u6,'(90A)') 'itype()=',(itype(i),' ',i=1,nneq)

write(u6,'(A,  i8)') 'neqv   = ',neqv
do i=1,nneq
  write(u6,'(A,  i8)') 'riso( site=',i,'):'
  do j=1,3
    write(u6,'(3ES22.14)') (riso(j,k,i),k=1,3)
  end do
end do
#endif
!-----------------------------------------------------------------------
! allocate memory for this function:
mem_local = 0
if (lmax >= 0) then
  ! exchange energy spectrum
  call mma_allocate(intc,lmax,'intc')
  call mma_allocate(icoord,lmax,'icoord')
  call mma_allocate(nind,lmax,2,'nind')
  mem_local = mem_local+size(intc)*ItoB
  mem_local = mem_local+size(icoord)*ItoB
  mem_local = mem_local+size(nind)*ItoB
  if (exch >= 0) then
    call mma_allocate(ibas,exch,lmax,'ibas')
    mem_local = mem_local+size(ibas)*ItoB
  end if
end if
if (exch >= 0) then
  call mma_allocate(wlin,exch,'wlin ')
  call mma_allocate(wlin1,exch,'wlin1')
  call mma_allocate(wlin3,exch,'wlin3')
  call mma_allocate(wlin9,exch,'wlin9')
  call mma_allocate(wdip,exch,'wdip ')
  call mma_allocate(wkex,exch,'wkex ')
  call mma_allocate(wdmo,exch,'wdmo ')
  call mma_allocate(wito,exch,'wito ')
  mem_local = mem_local+size(wlin)*RtoB
  mem_local = mem_local+size(wlin1)*RtoB
  mem_local = mem_local+size(wlin3)*RtoB
  mem_local = mem_local+size(wlin9)*RtoB
  mem_local = mem_local+size(wdip)*RtoB
  mem_local = mem_local+size(wkex)*RtoB
  mem_local = mem_local+size(wdmo)*RtoB
  mem_local = mem_local+size(wito)*RtoB
end if
if (nmax >= 0) then
  call mma_allocate(S1,3,nmax,nmax,' S1')
  call mma_allocate(M1,3,nmax,nmax,' M1')
  call mma_allocate(S2,3,nmax,nmax,' S2')
  call mma_allocate(M2,3,nmax,nmax,' M2')
  call mma_allocate(SM1,3,nmax,nmax,'SM1')
  call mma_allocate(SM2,3,nmax,nmax,'SM2')
  call mma_allocate(MM1,3,nmax,nmax,'MM1')
  call mma_allocate(MM2,3,nmax,nmax,'MM2')
  mem_local = mem_local+size(S1)*CtoB
  mem_local = mem_local+size(M1)*CtoB
  mem_local = mem_local+size(S2)*CtoB
  mem_local = mem_local+size(M2)*CtoB
  mem_local = mem_local+size(SM1)*CtoB
  mem_local = mem_local+size(SM2)*CtoB
  mem_local = mem_local+size(MM1)*CtoB
  mem_local = mem_local+size(MM2)*CtoB

  if (npair >= 0) then
    call mma_allocate(HLIN1,npair,nmax,nmax,nmax,nmax,'HLIN1')
    call mma_allocate(HLIN3,npair,nmax,nmax,nmax,nmax,'HLIN3')
    call mma_allocate(HLIN9,npair,nmax,nmax,nmax,nmax,'HLIN9')
    call mma_allocate(HDIP,npair,nmax,nmax,nmax,nmax,'HDIP')
    call mma_allocate(HKEX,npair,nmax,nmax,nmax,nmax,'HKEX')
    call mma_allocate(HDMO,npair,nmax,nmax,nmax,nmax,'HDMO')
    call mma_allocate(HITO,npair,nmax,nmax,nmax,nmax,'HITO')
    HLIN1(:,:,:,:,:) = cZero
    HLIN3(:,:,:,:,:) = cZero
    HLIN9(:,:,:,:,:) = cZero
    HDIP(:,:,:,:,:) = cZero
    HKEX(:,:,:,:,:) = cZero
    HDMO(:,:,:,:,:) = cZero
    HITO(:,:,:,:,:) = cZero
    mem_local = mem_local+size(HLIN1)*CtoB
    mem_local = mem_local+size(HLIN3)*CtoB
    mem_local = mem_local+size(HLIN9)*CtoB
    mem_local = mem_local+size(HDIP)*CtoB
    mem_local = mem_local+size(HKEX)*CtoB
    mem_local = mem_local+size(HDMO)*CtoB
    mem_local = mem_local+size(HITO)*CtoB
  end if
end if

if (exch >= 0) then
  call mma_allocate(tmp,exch,exch,'tmp')
  mem_local = mem_local+size(tmp)*CtoB
end if

if (nneq >= 0) then
  call mma_allocate(nexchR,nneq,'nexchR')
  mem_local = mem_local+size(nexchR)*ItoB

  call mma_allocate(SMR,nneq,3,2,2,'SMR')
  call mma_allocate(MMR,nneq,3,2,2,'MMR')
  mem_local = mem_local+size(SMR)*CtoB
  mem_local = mem_local+size(MMR)*CtoB

  if (neqv >= 0) then
    call mma_allocate(rotR,nneq,neqv,3,3,'rotR')
    mem_local = mem_local+size(rotR)*RtoB
  end if
end if

if (exchR >= 0) then
  if (lmax >= 0) then
    call mma_allocate(ibasR,nneq,lmax,'ibasR')
    mem_local = mem_local+size(ibasR)*ItoB
  end if
  call mma_allocate(WR,exchR,'WR')
  call mma_allocate(ZR,exchR,exchR,'ZR')
  call mma_allocate(MR,3,exchR,exchR,'MR')
  call mma_allocate(SR,3,exchR,exchR,'SR')
  mem_local = mem_local+size(WR)*RtoB
  mem_local = mem_local+size(ZR)*CtoB
  mem_local = mem_local+size(MR)*CtoB
  mem_local = mem_local+size(SR)*CtoB
end if

if (npair >= 0) then
  call mma_allocate(HKEXR,npair,2,2,2,2,'HKEXR')
  mem_local = mem_local+size(HKEXR)*CtoB
end if

if (lmax >= 0) then
  call mma_allocate(intcR,lmax,'intcR')
  mem_local = mem_local+size(intcR)*ItoB
end if
#ifdef _DEBUGPRINT_
write(u6,*) 'EXCHCTL:  memory allocated (local):'
write(u6,*) 'mem_local=',mem_local
write(u6,*) 'EXCHCTL:  memory allocated (total):'
write(u6,*) 'mem_total=',mem+mem_local
#endif
!-----------------------------------------------------------------------
l = 0
do i=1,nneq
  do j=1,neq(i)
    l = l+1
    nind(l,1) = i
    nind(l,2) = j
  end do
end do
nind(l+1:,:) = 0
intc(1) = 1
if (lmax > 1) then
  do i=2,lmax
    isite = nind(i-1,1)
    intc(i) = intc(i-1)*nexch(isite)
  end do
end if
do nb=1,exch
  nb1 = nb-1
  do i=1,lmax
    ibas(nb,lmax-i+1) = nb1/intc(lmax-i+1)
    nb1 = nb1-ibas(nb,lmax-i+1)*intc(lmax-i+1)
  end do
end do
#ifdef _DEBUGPRINT_
write(u6,'(34x,A,1x,20i3)') 'site Nr.',(i,i=1,lmax)
do nb=1,exch
  write(u6,'(A,i5,A,20i3)') 'COUPLING: basis set:  ibas(',nb,' ,isite) = ',(ibas(nb,i)+1,i=1,lmax)
end do
#endif

!-----------------------------------------------------------------------
! Lines model of magnetic couping  -- 1 parameter
if (AnisoLines1) then
  if (nPair > 0) then
    do lp=1,npair
      lb1 = i_pair(lp,1)
      lb2 = i_pair(lp,2)
      i1 = nind(lb1,1) ! indices of non-equivalent sites
      i2 = nind(lb2,1) ! indices of non-equivalent sites
      j1 = nind(lb1,2) ! indices of equivalent sites
      j2 = nind(lb2,2) ! indices of equivalent sites

      n1 = nexch(i1)
      n2 = nexch(i2)

      call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
      call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
      call mma_allocate(MM_tmp1,3,n1,n1,label='MM_tmp1')
      call mma_allocate(MM_tmp2,3,n2,n2,label='MM_tmp2')
      SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
      SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
      MM_tmp1(:,:,:) = MM(i1,:,1:n1,1:n1)
      MM_tmp2(:,:,:) = MM(i2,:,1:n2,1:n2)

      ! find local pseudospin and rotate the spin and magnetic moment
      ! to the local pseudospin basis
      if (itype(i1) == 'A') then
        r1(:,:) = rot(i1,j1,:,:)
        call prep_mom_exchange(n1,r1,SM_tmp1,MM_tmp1,mg1,.true.)
        SM(i1,:,1:n1,1:n1) = SM_tmp1(:,:,:)
        MM(i1,:,1:n1,1:n1) = MM_tmp1(:,:,:)
      end if
      if (itype(i2) == 'A') then
        r2(:,:) = rot(i2,j2,:,:)
        call prep_mom_exchange(n2,r2,SM_tmp2,MM_tmp2,mg2,.true.)
        SM(i2,:,1:n2,1:n2) = SM_tmp2(:,:,:)
        MM(i2,:,1:n2,1:n2) = MM_tmp2(:,:,:)
      end if

      call prMom('SM(i1) bf Lines1',SM_tmp1,n1)
      call prMom('SM(i2) bf Lines1',SM_tmp2,n2)

      ! build the Lines exchange matrix:
      call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
      call Lines_Exchange(Jex(lp),n1,n2,SM_tmp1,SM_tmp2,HTMP)
      HLIN1(lp,1:n1,1:n1,1:n2,1:n2) = HTMP(:,:,:,:)
      call mma_deallocate(HTMP)

#     ifdef _DEBUGPRINT_
      call prMom('SM(i1) af Lines1',SM_tmp1,n1)
      call prMom('SM(i2) af Lines1',SM_tmp2,n2)
      write(u6,'(A,i2)') 'Exchange matrix for pair = ',lp
      write(u6,'(A,i2)') 'in local pseudospin basis'
      do i=1,n1
        do j=1,n1
          do k=1,n2
            do l=1,n2
              write(u6,'(4(a,i2),a,2ES24.14)') 'HLIN1(',i,',',j,',',k,',',l,') = ',HLIN1(lp,i,j,k,l)
            end do
          end do
        end do
      end do
#     endif

      call mma_deallocate(SM_tmp1)
      call mma_deallocate(SM_tmp2)
      call mma_deallocate(MM_tmp1)
      call mma_deallocate(MM_tmp2)

    end do
  end if ! nPair
end if
!-----------------------------------------------------------------------

! Anisotropic Lines model of magnetic couping -- 3 parameters)
! Jxx, Jyy, Jzz
if (AnisoLines3) then
  if (nPair > 0) then
    do lp=1,npair
      lb1 = i_pair(lp,1)
      lb2 = i_pair(lp,2)
      i1 = nind(lb1,1) ! indices of non-equivalent sites
      i2 = nind(lb2,1) ! indices of non-equivalent sites
      j1 = nind(lb1,2) ! indices of equivalent sites
      j2 = nind(lb2,2) ! indices of equivalent sites

      n1 = nexch(i1)
      n2 = nexch(i2)

      call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
      call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
      call mma_allocate(MM_tmp1,3,n1,n1,label='MM_tmp1')
      call mma_allocate(MM_tmp2,3,n2,n2,label='MM_tmp2')
      SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
      SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
      MM_tmp1(:,:,:) = MM(i1,:,1:n1,1:n1)
      MM_tmp2(:,:,:) = MM(i2,:,1:n2,1:n2)

      ! find local pseudospin and rotate the spin and magnetic moment
      ! to the local pseudospin basis
      if (itype(i1) == 'A') then
        r1(:,:) = rot(i1,j1,:,:)
        call prep_mom_exchange(n1,r1,SM_tmp1,MM_tmp1,mg1,dbg)
        SM(i1,:,1:n1,1:n1) = SM_tmp1(:,:,:)
        MM(i1,:,1:n1,1:n1) = MM_tmp1(:,:,:)
      end if
      if (itype(i2) == 'A') then
        r2(:,:) = rot(i2,j2,:,:)
        call prep_mom_exchange(n2,r2,SM_tmp2,MM_tmp2,mg2,dbg)
        SM(i2,:,1:n2,1:n2) = SM_tmp2(:,:,:)
        MM(i2,:,1:n2,1:n2) = MM_tmp2(:,:,:)
      end if

      call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
      JAex_tmp(:) = JAex(lp,:)
      call Aniso_Lines_Exchange3(JAex_tmp,n1,n2,SM_tmp1,SM_tmp2,HTMP)
      HLIN3(lp,1:n1,1:n1,1:n2,1:n2) = HTMP(:,:,:,:)
      call mma_deallocate(HTMP)

#     ifdef _DEBUGPRINT_
      write(u6,'(A,i2)') 'Exchange matrix for pair = ',lp
      do i=1,n1
        do j=1,n1
          do k=1,n2
            do l=1,n2
              write(u6,'(4(a,i2),a,2ES24.14)') 'HLIN3(',i,',',j,',',k,',',l,') = ',HLIN3(lp,i,j,k,l)
            end do
          end do
        end do
      end do
#     endif

      call mma_deallocate(SM_tmp1)
      call mma_deallocate(SM_tmp2)
      call mma_deallocate(MM_tmp1)
      call mma_deallocate(MM_tmp2)

    end do ! lp
  end if ! nPair
end if
!-----------------------------------------------------------------------

! Anisotropic Lines model of magnetic couping -- 9 parameters)
! Jxx, Jxy, Jxz, Jyx, Jyy, Jyz, Jzx, Jzy, Jzz
if (AnisoLines9) then
  if (nPair > 0) then
    do lp=1,npair
      lb1 = i_pair(lp,1)
      lb2 = i_pair(lp,2)
      i1 = nind(lb1,1) ! indices of non-equivalent sites
      i2 = nind(lb2,1) ! indices of non-equivalent sites
      j1 = nind(lb1,2) ! indices of equivalent sites
      j2 = nind(lb2,2) ! indices of equivalent sites

      n1 = nexch(i1)
      n2 = nexch(i2)

      call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
      call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
      call mma_allocate(MM_tmp1,3,n1,n1,label='MM_tmp1')
      call mma_allocate(MM_tmp2,3,n2,n2,label='MM_tmp2')
      SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
      SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
      MM_tmp1(:,:,:) = MM(i1,:,1:n1,1:n1)
      MM_tmp2(:,:,:) = MM(i2,:,1:n2,1:n2)

      ! find local pseudospin and rotate the spin and magnetic moment
      ! to the local pseudospin basis
      if (itype(i1) == 'A') then
        r1(:,:) = rot(i1,j1,:,:)
        call prep_mom_exchange(n1,r1,SM_tmp1,MM_tmp1,mg1,dbg)
        SM(i1,:,1:n1,1:n1) = SM_tmp1(:,:,:)
        MM(i1,:,1:n1,1:n1) = MM_tmp1(:,:,:)
      end if
      if (itype(i2) == 'A') then
        r2(:,:) = rot(i2,j2,:,:)
        call prep_mom_exchange(n2,r2,SM_tmp2,MM_tmp2,mg2,dbg)
        SM(i2,:,1:n2,1:n2) = SM_tmp2(:,:,:)
        MM(i2,:,1:n2,1:n2) = MM_tmp2(:,:,:)
      end if

      ! rotate the input J matrix by the mg1 and mg2
#     ifdef _DEBUGPRINT_
      call prMom('SM(i1) bf Lines9',SM_tmp1,n1)
      call prMom('SM(i2) bf Lines9',SM_tmp2,n2)
#     endif

      call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
      call Aniso_Lines_Exchange9(JAex9(lp,:,:),n1,n2,SM_tmp1,SM_tmp2,HTMP)
      HLIN9(lp,1:n1,1:n1,1:n2,1:n2) = HTMP(:,:,:,:)
      call mma_deallocate(HTMP)

#     ifdef _DEBUGPRINT_
      call prMom('SM(i1) af Lines9',SM_tmp1,n1)
      call prMom('SM(i2) af Lines9',SM_tmp2,n2)
      write(u6,'(A,i2)') 'Exchange matrix for pair = ',lp
      do i=1,n1
        do j=1,n1
          do k=1,n2
            do l=1,n2
              write(u6,'(4(a,i2),a,2ES24.14)') 'HLIN9(',i,',',j,',',k,',',l,') = ',HLIN9(lp,i,j,k,l)
            end do
          end do
        end do
      end do
#     endif

      call mma_deallocate(SM_tmp1)
      call mma_deallocate(SM_tmp2)
      call mma_deallocate(MM_tmp1)
      call mma_deallocate(MM_tmp2)

    end do
  end if ! nPair
end if

!-----------------------------------------------------------------------
! dipolar couping
if (Dipol) then
  if (nPair > 0) then
    do lp=1,npair
      lb1 = i_pair(lp,1)
      lb2 = i_pair(lp,2)
      i1 = nind(lb1,1) ! indices of non-equivalent sites
      i2 = nind(lb2,1) ! indices of non-equivalent sites
      j1 = nind(lb1,2) ! indices of equivalent sites
      j2 = nind(lb2,2) ! indices of equivalent sites

      n1 = nexch(i1)
      n2 = nexch(i2)

      p1(:) = coord(i1,:)
      p2(:) = coord(i2,:)
      r1(:,:) = rlg(i1,j1,:,:)
      r2(:,:) = rlg(i2,j2,:,:)
      call dirvect(p1,r1,p2,r2,vect,dist)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i3,3ES20.12,2x,ES20.12)') 'EXCHCTL: DIPOL: lp, vect, R:',lp,(vect(i),i=1,3),dist
#     endif

      call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
      call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
      call mma_allocate(MM_tmp1,3,n1,n1,label='MM_tmp1')
      call mma_allocate(MM_tmp2,3,n2,n2,label='MM_tmp2')
      SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
      SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
      MM_tmp1(:,:,:) = MM(i1,:,1:n1,1:n1)
      MM_tmp2(:,:,:) = MM(i2,:,1:n2,1:n2)

      ! find local pseudospin and rotate the spin and magnetic moment
      ! to the local pseudospin basis
      if (itype(i1) == 'A') then
        r1(:,:) = rot(i1,j1,:,:)
        call prep_mom_exchange(n1,r1,SM_tmp1,MM_tmp1,mg1,dbg)
        SM(i1,:,1:n1,1:n1) = SM_tmp1(:,:,:)
        MM(i1,:,1:n1,1:n1) = MM_tmp1(:,:,:)
      end if
      if (itype(i2) == 'A') then
        r2(:,:) = rot(i2,j2,:,:)
        call prep_mom_exchange(n2,r2,SM_tmp2,MM_tmp2,mg2,dbg)
        SM(i2,:,1:n2,1:n2) = SM_tmp2(:,:,:)
        MM(i2,:,1:n2,1:n2) = MM_tmp2(:,:,:)
      end if

      call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
      call Dipol_Exchange(n1,n2,vect,dist,MM_tmp1,MM_tmp2,HTMP)
      HDIP(lp,1:n1,1:n1,1:n2,1:n2) = HTMP(:,:,:,:)
      call mma_deallocate(HTMP)

#     ifdef _DEBUGPRINT_
      write(u6,'(A,i2)') 'Exchange matrix for pair = ',lp
      do i=1,n1
        do j=1,n1
          do k=1,n2
            do l=1,n2
              write(u6,'(4(a,i2),a,2ES24.14)') 'HDIP (',i,',',j,',',k,',',l,') = ',HDIP(lp,i,j,k,l)
            end do
          end do
        end do
      end do
#     endif

      call mma_deallocate(SM_tmp1)
      call mma_deallocate(SM_tmp2)
      call mma_deallocate(MM_tmp1)
      call mma_deallocate(MM_tmp2)

    end do ! lp
  end if
end if
!-----------------------------------------------------------------------

! Dzyaloshinsky-Morya antisymmetric couping
if (DM_exchange) then
  if (nPair > 0) then
    do lp=1,npair
      lb1 = i_pair(lp,1)
      lb2 = i_pair(lp,2)
      i1 = nind(lb1,1) ! indices of non-equivalent sites
      i2 = nind(lb2,1) ! indices of non-equivalent sites
      j1 = nind(lb1,2) ! indices of equivalent sites
      j2 = nind(lb2,2) ! indices of equivalent sites

      n1 = nexch(i1)
      n2 = nexch(i2)

      call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
      call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
      call mma_allocate(MM_tmp1,3,n1,n1,label='MM_tmp1')
      call mma_allocate(MM_tmp2,3,n2,n2,label='MM_tmp2')
      SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
      SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
      MM_tmp1(:,:,:) = MM(i1,:,1:n1,1:n1)
      MM_tmp2(:,:,:) = MM(i2,:,1:n2,1:n2)

      ! find local pseudospin and rotate the spin and magnetic moment
      ! to the local pseudospin basis
      if (itype(i1) == 'A') then
        r1(:,:) = rot(i1,j1,:,:)
        call prep_mom_exchange(n1,r1,SM_tmp1,MM_tmp1,mg1,dbg)
        SM(i1,:,1:n1,1:n1) = SM_tmp1(:,:,:)
        MM(i1,:,1:n1,1:n1) = MM_tmp1(:,:,:)
      end if
      if (itype(i2) == 'A') then
        r2(:,:) = rot(i2,j2,:,:)
        call prep_mom_exchange(n2,r2,SM_tmp2,MM_tmp2,mg2,dbg)
        SM(i2,:,1:n2,1:n2) = SM_tmp2(:,:,:)
        MM(i2,:,1:n2,1:n2) = MM_tmp2(:,:,:)
      end if

      call Dzyaloshinsky_Morya_Exchange(JDMex(lp,:),n1,n2,SM_tmp1,SM_tmp2,HDMO(lp,1:n1,1:n1,1:n2,1:n2))
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i2)') 'Exchange matrix for pair = ',lp
      do i=1,n1
        do j=1,n1
          do k=1,n2
            do l=1,n2
              write(u6,'(4(a,i2),a,2ES24.14)') 'HDMO (',i,',',j,',',k,',',l,') = ',HDMO(lp,i,j,k,l)
            end do
          end do
        end do
      end do
#     endif

      call mma_deallocate(SM_tmp1)
      call mma_deallocate(SM_tmp2)
      call mma_deallocate(MM_tmp1)
      call mma_deallocate(MM_tmp2)

    end do
  end if ! nPair
end if
!-----------------------------------------------------------------------

! JITO exchange interaction
if (JITO_exchange) then
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'EXCHCTL:  Entering  JITO_exchange'
# endif
  if (nPair > 0) then
    do lp=1,npair
      lb1 = i_pair(lp,1)
      lb2 = i_pair(lp,2)
      i1 = nind(lb1,1) ! indices of non-equivalent sites
      i2 = nind(lb2,1) ! indices of non-equivalent sites
      j1 = nind(lb1,2) ! indices of equivalent sites
      j2 = nind(lb2,2) ! indices of equivalent sites

      n1 = nexch(i1)
      n2 = nexch(i2)

      call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
      call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
      call mma_allocate(MM_tmp1,3,n1,n1,label='MM_tmp1')
      call mma_allocate(MM_tmp2,3,n2,n2,label='MM_tmp2')
      SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
      SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
      MM_tmp1(:,:,:) = MM(i1,:,1:n1,1:n1)
      MM_tmp2(:,:,:) = MM(i2,:,1:n2,1:n2)

      ! find local pseudospin and rotate the spin and magnetic moment
      ! to the local pseudospin basis
      if (itype(i1) == 'A') then
        r1(:,:) = rot(i1,j1,:,:)
        call prep_mom_exchange(n1,r1,SM_tmp1,MM_tmp1,mg1,dbg)
        SM(i1,:,1:n1,1:n1) = SM_tmp1(:,:,:)
        MM(i1,:,1:n1,1:n1) = MM_tmp1(:,:,:)
      end if
      if (itype(i2) == 'A') then
        r2(:,:) = rot(i2,j2,:,:)
        call prep_mom_exchange(n2,r2,SM_tmp2,MM_tmp2,mg2,dbg)
        SM(i2,:,1:n2,1:n2) = SM_tmp2(:,:,:)
        MM(i2,:,1:n2,1:n2) = MM_tmp2(:,:,:)
      end if

      ! using Naoya's ITO:, in general coordinate system
      call JITO_Exchange_Int(MxRank1,MxRank2,imaxrank(lp,:),n1,n2,JITOexR(lp,:,:,:,:),JITOexI(lp,:,:,:,:), &
                             HITO(lp,1:n1,1:n1,1:n2,1:n2))
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i2)') 'Exchange matrix for pair = ',lp
      do i=1,n1
        do j=1,n1
          do k=1,n2
            do l=1,n2
              write(u6,'(4(a,i2),a,2ES24.14)') 'HITO (',i,',',j,',',k,',',l,') = ',HITO(lp,i,j,k,l)
            end do
          end do
        end do
      end do
#     endif

      call mma_deallocate(SM_tmp1)
      call mma_deallocate(SM_tmp2)
      call mma_deallocate(MM_tmp1)
      call mma_deallocate(MM_tmp2)

    end do
  end if ! nPair
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'EXCHCTL:  Exiting JITO_exchange'
# endif
end if
!-----------------------------------------------------------------------

if (KE) then
  if (nPair > 0) then
    HKEX(:,:,:,:,:) = cZero
    HKEXR(:,:,:,:,:) = cZero
    MMR(:,:,:,:) = cZero
    SMR(:,:,:,:) = cZero
    do lp=1,npair
      lb1 = i_pair(lp,1)
      lb2 = i_pair(lp,2)
      i1 = nind(lb1,1) ! indices of non-equivalent sites
      i2 = nind(lb2,1) ! indices of non-equivalent sites
      j1 = nind(lb1,2) ! indices of equivalent sites
      j2 = nind(lb2,2) ! indices of equivalent sites

      n1 = nexch(i1)
      n2 = nexch(i2)

      call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
      call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
      call mma_allocate(MM_tmp1,3,n1,n1,label='MM_tmp1')
      call mma_allocate(MM_tmp2,3,n2,n2,label='MM_tmp2')
      SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
      SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
      MM_tmp1(:,:,:) = MM(i1,:,1:n1,1:n1)
      MM_tmp2(:,:,:) = MM(i2,:,1:n2,1:n2)

      r1(:,:) = rot(i1,j1,:,:)
      call mma_allocate(tmp3,3,n1,n1,1,1,label='tmp3')
      call rotmom2(MM_tmp1,n1,r1,tmp3)
      M1(:,1:n1,1:n1) = tmp3(:,:,:,1,1)
      call rotmom2(SM_tmp1,n1,r1,tmp3)
      S1(:,1:n1,1:n1) = tmp3(:,:,:,1,1)
      call mma_deallocate(tmp3)
      r2(:,:) = rot(i2,j2,:,:)
      call mma_allocate(tmp3,3,n2,n2,1,1,label='tmp3')
      call rotmom2(MM_tmp2,n2,r2,tmp3)
      M2(:,1:n2,1:n2) = tmp3(:,:,:,1,1)
      call rotmom2(SM_tmp2,n2,r2,tmp3)
      S2(:,1:n2,1:n2) = tmp3(:,:,:,1,1)
      call mma_deallocate(tmp3)

      call mma_deallocate(SM_tmp1)
      call mma_deallocate(SM_tmp2)
      call mma_deallocate(MM_tmp1)
      call mma_deallocate(MM_tmp2)

      ! KEOPT=1 ! FULL
      ! KEOPT=2 ! Full, 1/U
      ! KEOPT=3 ! FULL  + reduced form
      ! KEOPT=4 ! Full, 1/U + reduced form
      MM1(:,:,:) = cZero
      SM1(:,:,:) = cZero
      MM2(:,:,:) = cZero
      SM2(:,:,:) = cZero
      !FIXME: this call to KE_Exchange does not match at all its definition, please fix (and avoid passing non-contiguous arrays)
      call WarningMessage(2,'There is surely a bug here')
#     include "macros.fh"
      unused_var(tpar)
      unused_var(upar)
      unused_var(lant)
      !call KE_Exchange(n1,n2,M1(:,1:n1,1:n1),S1(:,1:n1,1:n1),M2(:,1:n2,1:n2),S2(:,1:n2,1:n2),eso(i1,1:n1),eso(i2,1:n2),tpar,upar, &
      !                 lant,KEOPT,HKEX(lp,1:n1,1:n1,1:n2,1:n2),MM1(:,1:n1,1:n1),SM1(:,1:n1,1:n1),MM2(:,1:n2,1:n2), &
      !                 SM2(1:3,1:n2,1:n2)

      if ((KEOPT == 1) .or. (KEOPT == 2)) then
        HKEXR(lp,1,1,:,:) = HKEX(lp,1,1,1:n2,1:n2)
        HKEXR(lp,1,2,:,:) = HKEX(lp,1,2,1:n2,1:n2)
        HKEXR(lp,2,1,:,:) = HKEX(lp,2,1,1:n2,1:n2)
        HKEXR(lp,2,2,:,:) = HKEX(lp,2,2,1:n2,1:n2)
        MMR(i1,:,:,:) = MM1(:,1:2,1:2)
        MMR(i2,:,:,:) = MM2(:,1:2,1:2)
        SMR(i1,:,:,:) = SM1(:,1:2,1:2)
        SMR(i2,:,:,:) = SM2(:,1:2,1:2)

      else if ((KEOPT == 3) .or. (KEOPT == 4)) then
        HKEXR(lp,1,1,:,:) = HKEX(lp,1,1,1:n2,1:n2)
        HKEXR(lp,1,2,:,:) = HKEX(lp,1,n1,1:n2,1:n2)
        HKEXR(lp,2,1,:,:) = HKEX(lp,n1,1,1:n2,1:n2)
        HKEXR(lp,2,2,:,:) = HKEX(lp,n1,n1,1:n2,1:n2)

        MMR(i1,:,1,1) = MM1(:,1,1)
        MMR(i1,:,1,2) = MM1(:,1,n1)
        MMR(i1,:,2,1) = MM1(:,n1,1)
        MMR(i1,:,2,2) = MM1(:,n1,n1)

        MMR(i2,:,1,1) = MM2(:,1,1)
        MMR(i2,:,1,2) = MM2(:,1,n2)
        MMR(i2,:,2,1) = MM2(:,n2,1)
        MMR(i2,:,2,2) = MM2(:,n2,n2)

        SMR(i1,:,1,1) = SM1(:,1,1)
        SMR(i1,:,1,2) = SM1(:,1,n1)
        SMR(i1,:,2,1) = SM1(:,n1,1)
        SMR(i1,:,2,2) = SM1(:,n1,n1)

        SMR(i2,:,1,1) = SM2(:,1,1)
        SMR(i2,:,1,2) = SM2(:,1,n2)
        SMR(i2,:,2,1) = SM2(:,n2,1)
        SMR(i2,:,2,2) = SM2(:,n2,n2)

#       ifdef _DEBUGPRINT_
        write(u6,'(A)') 'site Ln'
        do i=1,2
          do j=1,2
            write(u6,'(3(A,i1),A,3(2F20.14,2x))') 'MMR(',i1,',L,',i,',',j,')= ',(MMR(i1,l,i,j),l=1,3)
          end do
        end do
        write(u6,'(/)')
        do i=1,2
          do j=1,2
            write(u6,'(3(A,i1),A,3(2F20.14,2x))') 'SMR(',i1,',L,',i,',',j,')= ',(SMR(i1,l,i,j),l=1,3)
          end do
        end do
        write(u6,'(/)')
        write(u6,'(A)') 'site Radical'
        do i=1,2
          do j=1,2
            write(u6,'(3(A,i1),A,3(2F20.14,2x))') 'MMR(',i2,',L,',i,',',j,')= ',(MMR(i2,l,i,j),l=1,3)
          end do
        end do
        write(u6,'(/)')
        do i=1,2
          do j=1,2
            write(u6,'(3(A,i1),A,3(2F20.14,2x))') 'SMR(',i2,',L,',i,',',j,')= ',(SMR(i2,l,i,j),l=1,3)
          end do
        end do
#       endif

      end if ! KEOPT

    end do ! lp

    ! in case of KEOPT=3 or KEOPT=4 Then we need to compute the spectrum and the properties
    ! in the reduced form, where nexch(i1)=2 ( ground doublet only).
    ! exchnew=8:
    if (KEOPT <= 4) then
      nmaxR = 2
      nexchR(:) = 2
      ibasR(:,:) = 0
      intcR(1) = 1
      if (lmax > 1) then
        do i=2,lmax
          isite = nind(i-1,1)
          intcR(i) = intcR(i-1)*nexchR(isite)
        end do
      end if
      do nb=1,exchR
        nb1 = nb-1
        do i=1,lmax
          ibasR(nb,lmax-i+1) = nb1/intcR(lmax-i+1)
          nb1 = nb1-ibasR(nb,lmax-i+1)*intcR(lmax-i+1)
        end do
      end do
      !-----------------------------------------------------------------
      HLIN1(:,:,:,:,:) = cZero
      HLIN3(:,:,:,:,:) = cZero
      HLIN9(:,:,:,:,:) = cZero
      HDIP(:,:,:,:,:) = cZero
      WLIN(:) = Zero
      WLIN1(:) = Zero
      WLIN3(:) = Zero
      WLIN9(:) = Zero
      WDIP(:) = Zero
      WKEX(:) = Zero
      call mma_allocate(eso_tmp,nneq,nmaxR,label='eso_tmp')
      call mma_allocate(HLIN1_tmp,npair,nmaxR,nmaxR,nmaxR,nmaxR,label='HLIN1_tmp')
      call mma_allocate(HLIN3_tmp,npair,nmaxR,nmaxR,nmaxR,nmaxR,label='HLIN3_tmp')
      call mma_allocate(HLIN9_tmp,npair,nmaxR,nmaxR,nmaxR,nmaxR,label='HLIN9_tmp')
      call mma_allocate(HDIP_tmp,npair,nmaxR,nmaxR,nmaxR,nmaxR,label='HDIP_tmp')
      call mma_allocate(HKEXR_tmp,npair,nmaxR,nmaxR,nmaxR,nmaxR,label='HKEXR_tmp')
      call mma_allocate(HDMO_tmp,npair,nmaxR,nmaxR,nmaxR,nmaxR,label='HDMO_tmp')
      call mma_allocate(HITO_tmp,npair,nmaxR,nmaxR,nmaxR,nmaxR,label='HITO_tmp')
      eso_tmp(:,:) = eso(:,1:nmaxR)
      HLIN1_tmp(:,:,:,:,:) = HLIN1(:,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR)
      HLIN3_tmp(:,:,:,:,:) = HLIN3(:,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR)
      HLIN9_tmp(:,:,:,:,:) = HLIN9(:,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR)
      HDIP_tmp(:,:,:,:,:) = HDIP(:,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR)
      HKEXR_tmp(:,:,:,:,:) = HKEXR(:,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR)
      HDMO_tmp(:,:,:,:,:) = HDMO(:,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR)
      HITO_tmp(:,:,:,:,:) = HITO(:,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR)
      ! print the Exchange Hamiltonian:
      call pa_prham(exchR,npair,i_pair,nneq,neq,nexchR,nmaxR,lmax,eso_tmp,HLIN1_tmp,HLIN3_tmp,HLIN9_tmp,HDIP_tmp,HKEXR_tmp, &
                    HDMO_tmp,HITO_tmp,Dipol,AnisoLines1,AnisoLines3,AnisoLines9,KE,DM_exchange,.false.)
      ! diagonalize the Hamiltonian:
      call pa_diagham(exchR,npair,i_pair,nneq,neq,nexchR,nmaxR,lmax,eso_tmp,HLIN1_tmp,HLIN3_tmp,HLIN9_tmp,HDIP_tmp,HKEXR_tmp, &
                      HDMO_tmp,HITO_tmp,Dipol,.false.,AnisoLines1,AnisoLines3,AnisoLines9,KE,.false.,WLIN1(1:exchR), &
                      WLIN3(1:exchR),WLIN9(1:exchR),WLIN(1:exchR),WDIP(1:exchR),WKEX(1:exchR),WDMO(1:exchR),WITO(1:exchR), &
                      WR,ZR)
      ! print the resulting eigenstates:
      call pa_preigen(exchR,lmax,ibasR,Dipol,AnisoLines1,AnisoLines3,AnisoLines9,KE,.false.,WLIN(1:exchR),WDIP(1:exchR), &
                      WKEX(1:exchR),WITO(1:exchR),WR,ZR,0)
      ! compute the moments:
      rotR(:,:,:,:) = Zero
      rotR(1,1,1,1) = One
      rotR(1,1,2,2) = One
      rotR(1,1,3,3) = One
      rotR(1,2,1,1) = One
      rotR(1,2,2,2) = One
      rotR(1,2,3,3) = One
      rotR(2,1,1,1) = One
      rotR(2,1,2,2) = One
      rotR(2,1,3,3) = One
      MR(:,:,:) = cZero
      SR(:,:,:) = cZero
      call mma_allocate(tmp2,EXCHR,EXCHR,label='tmp2')
      do L=1,3
        do isite=1,lmax
          do nb1=1,exchR
            icoord(:) = ibasR(nb1,:)
            i1 = nind(isite,1)
            j1 = nind(isite,2)
            is1 = ibasR(nb1,isite)+1

            do js1=1,nexchR(i1)
              icoord(isite) = js1-1
              nb2 = norder(icoord,intcR,lmax)
              MR(l,nb1,nb2) = MR(l,nb1,nb2)+rotR(i1,j1,l,1)*MMR(i1,1,is1,js1)+rotR(i1,j1,l,2)*MMR(i1,2,is1,js1)+ &
                              rotR(i1,j1,l,3)*MMR(i1,3,is1,js1)
              SR(l,nb1,nb2) = SR(l,nb1,nb2)+rotR(i1,j1,l,1)*SMR(i1,1,is1,js1)+rotR(i1,j1,l,2)*SMR(i1,2,is1,js1)+ &
                              rotR(i1,j1,l,3)*SMR(i1,3,is1,js1)

            end do  ! js1
          end do  ! nb1
        end do  ! isite
        tmp2(:,:) = MR(L,:,:)
        call ZGEMM_('C','N',EXCHR,EXCHR,EXCHR,cOne,ZR,EXCHR,tmp2,EXCHR,cZero,TMP,EXCHR)
        call ZGEMM_('N','N',EXCHR,EXCHR,EXCHR,cOne,TMP,EXCHR,ZR,EXCHR,cZero,tmp2,EXCHR)
        MR(L,:,:) = tmp2(:,:)
        tmp2(:,:) = SR(L,:,:)
        call ZGEMM_('C','N',EXCHR,EXCHR,EXCHR,cOne,ZR,EXCHR,tmp2,EXCHR,cZero,TMP,EXCHR)
        call ZGEMM_('N','N',EXCHR,EXCHR,EXCHR,cOne,TMP,EXCHR,ZR,EXCHR,cZero,tmp2,EXCHR)
        SR(L,:,:) = tmp2(:,:)
        do is1=1,8
          do js1=1,8
            write(u6,'(3(A,i1),A,2F20.14)') 'MR(',l,',',is1,',',js1,') = ',MR(l,is1,js1)
          end do
        end do
      end do  ! L
      call mma_deallocate(tmp2)
      ! print the localized moments on sites:
      nsta = exchR
      ! assuming max 10 equivalent magnetic sites
      call mma_allocate(MM_tmp1,3,nsta,nsta,label='MM_tmp1')
      call mma_allocate(SM_tmp1,3,nsta,nsta,label='SM_tmp1')
      call mma_allocate(rotR_tmp,nneq,10,3,3,'rotR_tmp')
      call mma_allocate(tmp2,nsta,nsta,label='tmp2')
      call mma_allocate(tmp3,nneq,3,2,2,2,label='tmp3')
      MM_tmp1(:,:,:) = MR(:,1:nsta,1:nsta)
      SM_tmp1(:,:,:) = SR(:,1:nsta,1:nsta)
      rotR_tmp(:,:,:,:) = rotR(:,1:10,:,:)
      tmp2(:,:) = zR(1:nsta,1:nsta)
      tmp3(:,:,:,:,1) = MMR(:,:,1:nmaxR,1:nmaxR)
      tmp3(:,:,:,:,2) = SMR(:,:,1:nmaxR,1:nmaxR)
      call momloc2(nsta,nmaxR,nneq,neq,neqv,rotR_tmp,lmax,nexchR,wR(1:nsta),tmp2,MM_tmp1,SM_tmp1,tmp3(:,:,:,:,1),tmp3(:,:,:,:,2))
      call mma_deallocate(MM_tmp1)
      call mma_deallocate(SM_tmp1)
      call mma_deallocate(rotR_tmp)
      call mma_deallocate(tmp2)
      call mma_deallocate(tmp3)

      call WarningMessage(2,'Wrong code in poly_aniso/exchctl.f')
      ! FIXME: This call is missing 3 arguments
      !call barrier(exchR,MR,WR,1,2)
      call Abend()
    end if !KEOPT

  end if ! npair>0, index lp
end if !KE

!-----------------------------------------------------------------------
! ALL exchange couplings for all pairs are now known.
! printout the Hamiltonians:
#ifdef _DEBUGPRINT_
write(u6,'(A,i5)') 'exch  = ',exch
write(u6,'(A,i5)') 'npair = ',npair
write(u6,'(A,i5)') 'nneq  = ',nneq
write(u6,'(A,i5)') 'nmax  = ',nmax
write(u6,'(A,i5)') 'lmax  = ',lmax
write(u6,'(A,i5)') 'iPrint= ',iPrint
write(u6,*) 'AnisoLines1 = ',AnisoLines1
write(u6,*) 'AnisoLines3 = ',AnisoLines3
write(u6,*) 'AnisoLines9 = ',AnisoLines9
write(u6,*) 'Dipol = ',Dipol
write(u6,*) 'JITO  = ',JITO_exchange
write(u6,*) 'KE    = ',KE
do i=1,npair
  write(u6,'(A,i2,A,i3,3x,A,i2,A,i3)') 'i_pair(',i,',1) = ',i_pair(i,1),'i_pair(',i,',2) = ',i_pair(i,2)
end do
do i=1,nneq
  write(u6,'(A,i2,A,i3)') '   neq(',i,') = ',neq(i)
end do
do i=1,nneq
  write(u6,'(A,i2,A,i3)') ' nexch(',i,') = ',neq(i)
end do
do i=1,nneq
  write(u6,'(A,i2,A,100F10.3)') '   eso(',i,') = ',(eso(i,j),j=1,nexch(i))
end do
call xFlush(u6)
#endif

! print the Exchange Hamiltonian:
#ifndef _DEBUGPRINT_
if (iPrint > 2) then
#endif
  call pa_prham(exch,npair,i_pair,nneq,neq,nexch,nmax,lmax,eso,HLIN1,HLIN3,HLIN9,HDIP,HKEX,HDMO,HITO,Dipol,AnisoLines1, &
                AnisoLines3,AnisoLines9,KE,DM_exchange,JITO_exchange)
#ifndef _DEBUGPRINT_
end if
#endif

! diagonalize the Hamiltonian:
call pa_diagham(exch,npair,i_pair,nneq,neq,nexch,nmax,lmax,eso,HLIN1,HLIN3,HLIN9,HDIP,HKEX,HDMO,HITO,Dipol,DM_exchange, &
                AnisoLines1,AnisoLines3,AnisoLines9,KE,JITO_exchange,WLIN1,WLIN3,WLIN9,WLIN,WDIP,WKEX,WDMO,WITO,W,Z)

! printout the resulting eigenstates:
call pa_preigen(exch,lmax,ibas,Dipol,AnisoLines1,AnisoLines3,AnisoLines9,KE,JITO_exchange,WLIN,WDIP,WKEX,WITO,W,Z,iPrint)
!Z =  exchange eigenstates:
NmaxPop = 500
if (NmaxPop > exch) NmaxPop = exch
call PopAnalysis(nneq,neq,exch,nexch,nmax,lmax,NmaxPop,Z)
w(:) = w(:)-w(1)

! some verification
if (dnrm2_(exch,WLIN,1) > 1.0e-13_wp) call Add_Info('EXCHCTL::  WLIN',[dnrm2_(exch,WLIN,1)],1,8)
if (dnrm2_(exch,WDIP,1) > 1.0e-13_wp) call Add_Info('EXCHCTL::  WDIP',[dnrm2_(exch,WDIP,1)],1,8)
if (dnrm2_(exch,WKEX,1) > 1.0e-13_wp) call Add_Info('EXCHCTL::  WKEX',[dnrm2_(exch,WKEX,1)],1,8)
if (dnrm2_(exch,W,1) > 1.0e-13_wp) call Add_Info('EXCHCTL::     W',[dnrm2_(exch,W,1)],1,8)
! compute the moments:
M(:,:,:) = cZero
S(:,:,:) = cZero
#ifdef _DEBUGPRINT_
write(u6,'(A)') 'Magnetic moments before the build of coupled M and S matrices'
if (nPair > 0) then
  do lp=1,npair
    lb1 = i_pair(lp,1)
    lb2 = i_pair(lp,2)
    i1 = nind(lb1,1) ! indices of non-equivalent sites
    i2 = nind(lb2,1) ! indices of non-equivalent sites
    n1 = nexch(i1)
    n2 = nexch(i2)
    call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
    call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
    SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
    SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
    call prMom('EXCHCTL,Before M ans S, SM(i1):',SM_tmp1,n1)
    call prMom('EXCHCTL,Before M ans S, SM(i2):',SM_tmp2,n2)
    call prMom('EXCHCTL,Before M ans S, MM(i1):',MM_tmp1,n1)
    call prMom('EXCHCTL,Before M ans S, MM(i2):',MM_tmp2,n2)
    call mma_deallocate(SM_tmp1)
    call mma_deallocate(SM_tmp2)
  end do
end if
#endif

call mma_allocate(tmp2,EXCH,EXCH,label='tmp2')
do L=1,3
  do isite=1,lmax
    do nb1=1,exch
      icoord(:) = ibas(nb1,:)
      i1 = nind(isite,1)
      j1 = nind(isite,2)
      is1 = ibas(nb1,isite)+1

      do js1=1,nexch(i1)
        icoord(isite) = js1-1
        nb2 = norder(icoord,intc,lmax)
        M(l,nb1,nb2) = M(l,nb1,nb2)+rot(i1,j1,l,1)*MM(i1,1,is1,js1)+rot(i1,j1,l,2)*MM(i1,2,is1,js1)+rot(i1,j1,l,3)*MM(i1,3,is1,js1)
        S(l,nb1,nb2) = S(l,nb1,nb2)+rot(i1,j1,l,1)*SM(i1,1,is1,js1)+rot(i1,j1,l,2)*SM(i1,2,is1,js1)+rot(i1,j1,l,3)*SM(i1,3,is1,js1)

      end do  ! js1
    end do  ! nb1
  end do  ! isite

  ! magnetic moment
  tmp2(:,:) = M(L,:,:)
  call zgemm_('C','N',EXCH,EXCH,EXCH,cOne,Z,EXCH,tmp2,EXCH,cZero,TMP,EXCH)
  call zgemm_('N','N',EXCH,EXCH,EXCH,cOne,TMP,EXCH,Z,EXCH,cZero,tmp2,EXCH)
  M(L,:,:) = tmp2(:,:)
  ! spin moment
  tmp2(:,:) = S(L,:,:)
  call zgemm_('C','N',EXCH,EXCH,EXCH,cOne,Z,EXCH,tmp2,EXCH,cZero,TMP,EXCH)
  call zgemm_('N','N',EXCH,EXCH,EXCH,cOne,TMP,EXCH,Z,EXCH,cZero,tmp2,EXCH)
  S(L,:,:) = tmp2(:,:)
end do  ! L
call mma_deallocate(tmp2)

! ITO decomposition of the exchange and dipolar interactions:
if (npair > 0) &
  call pr_ito_int(npair,i_pair,lmax,nexch,nneq,neqv,itype,neq,nmax,eso,MM,SM,rot,Dipol,AnisoLines1,AnisoLines3,AnisoLines9, &
                  DM_exchange,JITO_exchange,HLIN1,HLIN3,HLIN9,HDIP,HDMO,HITO)

! projection on the Ising Hamiltonian
! accessible format
!write(u6,'(/)')
!write(u6,'(A)') 'Complete decomposition of the exchange interaction'
!write(u6,'(A)')

!-----------------------------------------------------------------------
! deallocate memory for this function:
if (lmax >= 0) then
  ! exchange energy spectrum
  call mma_deallocate(intc)
  call mma_deallocate(icoord)
  call mma_deallocate(nind)
  if (exch >= 0) call mma_deallocate(ibas)
end if
if (exch >= 0) then
  call mma_deallocate(wlin)
  call mma_deallocate(wlin1)
  call mma_deallocate(wlin3)
  call mma_deallocate(wlin9)
  call mma_deallocate(wdip)
  call mma_deallocate(wkex)
  call mma_deallocate(wdmo)
  call mma_deallocate(wito)
end if
if (nmax >= 0) then
  call mma_deallocate(S1)
  call mma_deallocate(M1)
  call mma_deallocate(S2)
  call mma_deallocate(M2)
  call mma_deallocate(SM1)
  call mma_deallocate(SM2)
  call mma_deallocate(MM1)
  call mma_deallocate(MM2)
  if (npair >= 0) then
    call mma_deallocate(HLIN1)
    call mma_deallocate(HLIN3)
    call mma_deallocate(HLIN9)
    call mma_deallocate(HDIP)
    call mma_deallocate(HKEX)
    call mma_deallocate(HDMO)
    call mma_deallocate(HITO)
  end if
end if

if (exch >= 0) call mma_deallocate(tmp)

if (nneq >= 0) then
  call mma_deallocate(nexchR)
  call mma_deallocate(SMR)
  call mma_deallocate(MMR)
  if (neqv >= 0) call mma_deallocate(rotR)
end if

if (exchR >= 0) then
  if (lmax >= 0) call mma_deallocate(ibasR)
  call mma_deallocate(WR)
  call mma_deallocate(ZR)
  call mma_deallocate(MR)
  call mma_deallocate(SR)
end if

if (npair >= 0) call mma_deallocate(HKEXR)

if (lmax >= 0) call mma_deallocate(intcR)

! results of projection of the exchange interaction on the Ising Hamiltonian:

!open(76,file='eigenstates.txt')
!do i=1,EXCH
!  do j=1,EXCH
!    write(76,'(2ES24.14)') Z(i,j)
!  end do
!end do
!close(76)
!
!open(77,file='eigenstates_full.txt')
!do i=1,EXCH
!  do j=1,EXCH
!    read(77,'(2ES24.14)') ZZR(i,j),ZZI(i,j)
!  end do
!end do
!close(77)
!ZF(:,:) = cmplx(ZZR(:,:),ZZI(:,:),kind=wp)
!call ZGEMM_('C','N',EXCH,EXCH,EXCH,cOne,Z,EXCH,ZF,EXCH,cZero,OVLP,EXCH)
!do i=1,1
!  do j=1,EXCH
!    if (ABS(OVLP(j,i)) > 1.0e-7_wp) &
!      write(u6,'(A,i3,A,i3,A,2F18.14,3x,A,F18.14,3x,A,F18.14)') 'OVLP-1(',j,',',i,') = ',OVLP(j,i),'ABS = ',ABS(OVLP(j,i)), &
!                                                               'ABS^2 = ',ABS(OVLP(j,i))*ABS(OVLP(j,i))
!  end do
!end do
!call ZGEMM_('C','N',EXCH,EXCH,EXCH,cOne,ZF,EXCH,Z,EXCH,cZero,OVLP,EXCH)
!do i=1,1
!  do j=1,EXCH
!    if (ABS(OVLP(j,i)) > 1.0e-7_wp) &
!      write(u6,'(A,i3,A,i3,A,2F18.14,3x,A,F18.14,3x,A,F18.14)') 'OVLP-2(',i,',',j,') = ',OVLP(i,j),'ABS = ',ABS(OVLP(i,j)), &
!                                                                'ABS^2 = ',ABS(OVLP(i,j))*ABS(OVLP(i,j))
!    end if
!  end do
!end do
!199 continue

return

end subroutine exchctl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FormNumHess(nIter,nInter,Delta,nAtom,iNeg,DipM)
      use Slapaf_Info, only: qInt, Shift, dqInt, Degen, Smmtrc
      use Slapaf_Parameters, only: Curvilinear, mTROld, Cubic
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
      Real*8 DipM(3,nIter)
      Logical Found
      Real*8 rDum(1)
      Real*8, Allocatable:: FEq(:), dDipM(:), KtB(:), HB(:), Hx(:),
     &                      Degen2(:), H(:), IRInt(:)
*                                                                      *
************************************************************************
*                                                                      *
      mTR = mTROld
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 182
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(dDipM,3*(nInter+mTR),Label='dDipM')
      dDipM(:)=Zero
*                                                                      *
************************************************************************
*                                                                      *
*-----Form the Hessian matrix via a 2-point numerical differentiation.
*
      Call mma_allocate(H,nInter**2,Label='H')
      If (Cubic) Then
         Call mma_allocate(FEq,nInter**3,Label='FEq')
      Else
         Call mma_allocate(FEq,1,Label='FEq')
      End If

      Call NmHess(Shift,nInter,dqInt,nIter,H,Delta,qInt,FEq,Cubic,DipM,
     &            dDipM)

      Write (6,*)
      Write (6,*) ' Numerical differentiation is finished!'
      If (iPrint.GE.98) Call RecPrt(' Numerical force constant matrix',
     &     ' ',H,nInter,nInter)
*
      Call Add_Info('Numerical Hessian',H,nInter**2,2)
      Call Put_dArray('Hss_Q',H,nInter**2)
      Call Put_dArray('Hss_upd',rDum,0)
*
*-----That is in internal coordinates, now transform it to Cartesians
*     d^2E/dx^2 = dQ/dx d^2E/dQ^2 dQ/dx + d^2Q/dx^2 dE/dQ
*
      Call Qpg_dArray('KtB',Found,nKtB)
      If (.Not.Found) Call Abend()
      nDim=nKtB/nInter
      Call mma_allocate(KtB,nDim*nInter,Label='KtB')
      Call mma_allocate(HB,nDim*nInter,Label='HB')
      Call mma_allocate(Hx,nDim**2,Label='Hx')
      Call mma_allocate(Degen2,nDim,Label='Degen2')
      Call Get_dArray('KtB',KtB,nKtB)
      Call DGeMM_('N','T',nInter,nDim,nInter,One,H,nInter,
     &                    KtB,nDim,Zero,HB,nInter)
      Call DGeMM_('T','T',nDim,nDim,nInter,One,HB,nInter,
     &                    KtB,nDim,Zero,Hx,nDim)
      i=0
      Do ii=1,nAtom
         Do ij=1,3
            If (Smmtrc(ij,ii)) Then
               i=i+1
               Degen2(i) = Degen(ij,ii)
            End If
         End Do
      End Do
*
      If (Curvilinear) Then
*        Compute and add the d^2Q/dx^2 dE/dQ part
         Call dBuu(Degen2,nInter,nDim,dqInt(1,1),Hx,.True.)
      End If
*
      Call Put_dArray('Hss_X',Hx,nDim**2)
      Call mma_deallocate(KtB)
      Call mma_deallocate(HB)
      Call mma_deallocate(Hx)
      Call mma_deallocate(Degen2)
      Call mma_deallocate(H)
*
      If (Cubic) Then
         Call RecPrt(' Numerical cubic force constant matrix',' ',
     &               FEq,nInter**2,nInter)
         Call Add_Info('Numerical anharm. cons.',FEq,nInter**3,2)
      End If
      Call mma_deallocate(FEq)
*                                                                      *
************************************************************************
*                                                                      *
*---- Do an harmonic frequency analysis
*
      Call mma_allocate(IRInt,nInter+mTR,Label='IRInt')

      Call HrmFrq(nAtom,nInter,iNeg,dDipM,mTR,DipM,IRInt)

      Call Add_Info('Numerical IR Intensities',IRInt,nInter,2)
      Call mma_deallocate(IRInt)
      Write (6,*)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(dDipM)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contcasb2SO(l1,l2,l3,l4,nstart,primints,scratch1,scratch2,cont4SO)
!bs contraction for powers (0)  with alpha3
!bs this is one of the cases b in the documentation

use AMFI_global, only: contrarray, ncontrac, nprimit
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: l1, l2, l3, l4, nstart
real(kind=wp), intent(in) :: primints(*)
real(kind=wp), intent(_OUT_) :: scratch1(*), scratch2(*), cont4SO(*)
integer(kind=iwp) :: ilength, ncont(4), nprim(4), nprod

ncont(1) = ncontrac(l1)
ncont(2) = ncontrac(l2)
ncont(3) = ncontrac(l3)
ncont(4) = ncontrac(l4)
nprod = ncont(1)*ncont(2)*ncont(3)*ncont(4)
nprim(1) = nprimit(l1)
nprim(2) = nprimit(l2)
nprim(3) = nprimit(l3)
nprim(4) = nprimit(l4)
ilength = nprim(1)*nprim(2)*nprim(3)*nprim(4)

!bs copy primitive integrals to scratch1
scratch1(1:ilength) = primints(1:ilength)
!ncont : i-th element is number of contracted functions i. index
!nprim : i-th element is number of primitive functions  i. index
call contract(contrarray(:,3,l1),contrarray(:,1,l2),contrarray(:,4,l3),contrarray(:,1,l4),ncont,nprim,scratch1,scratch2)
cont4SO(nstart:nstart+nprod-1) = scratch1(1:nprod)

return

end subroutine contcasb2SO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine MltGrd(
#define _CALLING_
#include "grd_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: to compute the gradients of the Multipole operator           *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Modified to multipole moments November '90               *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified to gradients of the overlap matrix. October     *
*             '91.                                                     *
************************************************************************
      use Her_RW
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#ifdef _DEBUGPRINT_
#include "print.fh"
#endif

#include "grd_interface.fh"

*     Local variables
      Logical ABeq(3)
      parameter (lforce=20)
      real*8 Force(lforce)
      common /finfld/Force
*                                                                      *
************************************************************************
*
#ifdef _DEBUGPRINT_
      iRout = 122
      iPrint = nPrint(iRout)
#endif
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+2)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+2)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp+1)
      ipRnxyz = nip
      nip = nip + nZeta*3*(la+2)*(lb+2)*(nOrdOp+1)
      ipAlph = nip
      nip = nip + nZeta
      ipBeta = nip
      nip = nip + nZeta
      If (nip-1.gt.nArr*nZeta) Then
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Call ErrTra
         Write (6,*) ' Abend in MltGrd'
         Call Abend
      End If
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.49) Then
         Call RecPrt(' In MltGrd: RKappa',' ',rKappa,1,nZeta)
         Call RecPrt(' In MltGrd: A',' ',A,1,3)
         Call RecPrt(' In MltGrd: RB',' ',RB,1,3)
         Call RecPrt(' In MltGrd: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In MltGrd: P',' ',P,nZeta,3)
         Write (6,*) ' In MltGrd: la,lb=',la,lb
      End If
#endif
*
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la+1,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb+1,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the contribution from the multipole moment operator
*
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),
     &            nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the cartesian components for the multipole moment
*     integrals. The integrals are factorized into components.
*
       Call Assmbl(Array(ipRnxyz),
     &             Array(ipAxyz),la+1,
     &             Array(ipRxyz),nOrdOp,
     &             Array(ipBxyz),lb+1,
     &             nZeta,HerW(iHerW(nHer)),nHer)
*
*     Combine the cartesian components to the gradient of the one
*     electron integral and contract with the Fock matrix.
*
      ip = ipAlph
      Do 20 iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ip),1)
         ip = ip + nAlpha
 20   Continue
      ip = ipBeta
      Do 21 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ip),nAlpha)
         ip = ip + 1
 21   Continue
      Call CmbnMlt1(Array(ipRnxyz),nZeta,la,lb,Zeta,rKappa,Final,
     &            Array(ipAlph),Array(ipBeta),Grad,nGrad,DAO,
     &            IfGrad,IndGrd,dc(mdc)%nStab,dc(ndc)%nStab,
     &            kOp,nOrdOp,Force)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iStabM)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MXRESC(IAB,IACLS,IBCLS,NOCTPA,NOCTPB,NSM,NSSOA,NSSOB,KSSOA,KOCTPA,KSSOB,KOCTPB,NTSOB,MXPKA,K2SSOA,K2OCTPA,K2SSOB, &
                  K2OCTPB,NAEL123,NBEL123,MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL,MXIJST,MXIJSTF)
! Find largest dimension of matrix C(Ka,Ib,J)
! Find largest dimension of matrix C(ij,Ka,Ib)
! Find largest dimension of matrix C(ij,Ia,Kb)
! Find largest dimension of matrix C(ij,Ka,Kb)
! Find largest dimension of a+ia+j!k> MXIJST, MXIJSTF
!
! Largest block of single excitations MXSXBL
!
! Input:
!    iab
!    iacls,ibcls
!    noctpa,noctpb
!    nsm
!    nssoa,nssob
!    kssoa
!    koctps,koctpb
!    ntsob
!    mxpka
!    k2ssoa,k2ssob
!    k2octpb
!    nael123,nbel123
! Output
!    mxcj,mxcija,mxcijb,mxcijab,mxsxbl,MXIJST,MXIJSTF

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NOCTPA, NOCTPB, IAB(NOCTPA,NOCTPB), IACLS, IBCLS, NSM, NSSOA(NOCTPA,NSM), NSSOB(NOCTPB,NSM), &
                                 KOCTPA, KSSOA(KOCTPA,NSM), KOCTPB, KSSOB(KOCTPB,NSM), NTSOB(3,NSM), MXPKA, K2OCTPA, &
                                 K2SSOA(K2OCTPA,NSM), K2OCTPB, K2SSOB(K2OCTPB,NSM), NAEL123(3,*), NBEL123(3,*)
integer(kind=iwp), intent(out) :: MXCJ, MXCIJA, MXCIJB, MXCIJAB, MXSXBL, MXIJST, MXIJSTF
integer(kind=iwp) :: IATP, IBTP, IOBTP, JACLS, JATP, JBCLS, JBTP, JOBTP, K1ACLS, K1ATP, K1BCLS, K1BTP, KACLS, KATP, KBCLS, KBTP, &
                     LBLK, LCJBLK, MXA, MXB, MXIA, MXIB, MXIJSTA, MXIJSTAF, MXIJSTB, MXIJSTBF, MXIOB, MXISOB, MXJOB, MXJSOB, MXKA, &
                     MXKAF, MXKB, MXKBF, MXSOB

! matrix C(j,Ka,Ib)

MXCJ = 0
do IATP=1,NOCTPA
  do IBTP=1,NOCTPB
    if (IAB(IATP,IBTP) /= 0) then
      MXB = max(0,maxval(NSSOB(IBTP,:)))
      do IOBTP=1,3
        ! type of K string obtained by removing one elec of type IOPBTP from IATP
        call NEWTYP_MCLR(IACLS,IATP,[1],[IOBTP],1,KACLS,KATP)
        if (KATP > 0) then
          MXKA = max(0,maxval(KSSOA(KATP,:)))
          if ((MXPKA > 0) .and. (MXKA > MXPKA)) MXKA = MXPKA
          MXSOB = max(0,maxval(NTSOB(IOBTP,:)))

          LCJBLK = MXSOB*MXKA*MXB
          MXCJ = max(MXCJ,LCJBLK)

        end if
      end do
    end if
  end do
end do

! matrix C(j,Ia,Kb)

do IATP=1,NOCTPA
  do IBTP=1,NOCTPB
    if (IAB(IATP,IBTP) /= 0) then
      MXA = max(0,maxval(NSSOA(IATP,:)))
      do IOBTP=1,3
        ! type of K string obtained by removing one elec of type IOPBTP from IBTP
        call NEWTYP_MCLR(IBCLS,IBTP,[1],[IOBTP],1,KBCLS,KBTP)
        if (KBTP > 0) then
          MXKB = max(0,maxval(KSSOB(KBTP,:)))
          if ((MXPKA > 0) .and. (MXKB > MXPKA)) MXKB = MXPKA
          MXSOB = max(0,maxval(NTSOB(IOBTP,:)))

          LCJBLK = MXSOB*MXKB*MXA
          MXCJ = max(MXCJ,LCJBLK)

        end if
      end do
    end if
  end do
end do

! matrix C(ij,Ka,Ib)
! both Ka and Ib blocked

MXCIJA = 0
MXIJSTA = 0
MXIJSTAF = 0
do IATP=1,NOCTPA
  do IBTP=1,NOCTPB

    if (IAB(IATP,IBTP) /= 0) then
      MXIB = max(0,maxval(NSSOB(IBTP,:)))
      if ((MXIB > MXPKA) .and. (MXPKA > 0)) MXIB = MXPKA
      do IOBTP=1,3
        ! type of K string obtained by removing one elec of type IOPBTP from IATP
        call NEWTYP_MCLR(IACLS,IATP,[1],[IOBTP],1,K1ACLS,K1ATP)
        if (K1ATP > 0) then
          MXISOB = max(0,maxval(NTSOB(IOBTP,:)))
          do JOBTP=1,3
            ! type of K string obtained by removing one elec of type JOPBTP from K1ATP
            call NEWTYP_MCLR(K1ACLS,K1ATP,[1],[JOBTP],1,KACLS,KATP)
            if (KATP > 0) then
              MXKA = max(0,maxval(K2SSOA(KATP,:)))
              MXKAF = MXKA
              if ((MXPKA > 0) .and. (MXKA > MXPKA)) MXKA = MXPKA
              MXJSOB = max(0,maxval(NTSOB(JOBTP,:)))

              MXIJSTA = max(MXIJSTA,MXISOB*MXJSOB*MXKA)
              MXIJSTAF = max(MXIJSTAF,MXISOB*MXJSOB*MXKAF)
              LBLK = MXISOB*MXJSOB*MXKA*MXIB
              MXCIJA = max(MXCIJA,LBLK)
            end if
          end do
        end if
      end do
    end if
  end do
end do

! matrix C(ij,Ia,kb)
! both Ka and Ib blocked

MXCIJB = 0
MXIJSTB = 0
MXIJSTBF = 0
MXIA = 0 ! dummy initialize
do IATP=1,NOCTPA
  do IBTP=1,NOCTPB
    if (IAB(IATP,IBTP) /= 0) then
      MXIA = max(0,maxval(NSSOA(IATP,:)))
      if ((MXIA > MXPKA) .and. (MXPKA > 0)) MXIA = MXPKA
      do IOBTP=1,3
        ! type of K string obtained by removing one elec of type IOPBTP from IBTP
        call NEWTYP_MCLR(IBCLS,IBTP,[1],[IOBTP],1,K1BCLS,K1BTP)
        if (K1BTP > 0) then
          MXISOB = max(0,maxval(NTSOB(IOBTP,:)))
          do JOBTP=1,3
            ! type of K string obtained by removing one elec of type JOPBTP from K1ATP
            call NEWTYP_MCLR(K1BCLS,K1BTP,[1],[JOBTP],1,KBCLS,KBTP)
            if (KBTP > 0) then
              MXKB = max(0,maxval(K2SSOB(KBTP,:)))
              MXKBF = MXKB
              if ((MXPKA > 0) .and. (MXKB > MXPKA)) MXKB = MXPKA
              MXJSOB = max(0,maxval(NTSOB(JOBTP,:)))

              MXIJSTB = max(MXIJSTB,MXISOB*MXJSOB*MXKB)
              MXIJSTBF = max(MXIJSTBF,MXISOB*MXJSOB*MXKBF)
              LBLK = MXISOB*MXJSOB*MXKB*MXIA
              MXCIJB = max(MXCIJB,LBLK)
            end if
          end do
        end if
      end do
    end if
  end do
end do

! matrix C(ij,Ka,kb)
! both Ka and Kb blocked

MXCIJAB = 0
do IATP=1,NOCTPA
  do IBTP=1,NOCTPB

    if (IAB(IATP,IBTP) /= 0) then
      do IOBTP=1,3
        ! type of Ka string obtained by removing one elec of type IOPBTP from IATP
        call NEWTYP_MCLR(IACLS,IATP,[1],[IOBTP],1,KACLS,KATP)
        if (KATP > 0) then
          MXKA = max(0,maxval(KSSOA(KATP,:)))
          if ((MXPKA > 0) .and. (MXKA > MXPKA)) MXKA = MXPKA
          MXISOB = max(0,maxval(NTSOB(IOBTP,:)))
          do JOBTP=1,3
            ! type of K string obtained by removing one elec of type JOPBTP from IBTP
            call NEWTYP_MCLR(IBCLS,IBTP,[1],[JOBTP],1,KBCLS,KBTP)
            if (KBTP > 0) then
              MXKB = max(0,maxval(KSSOB(KBTP,:)))
              if ((MXPKA > 0) .and. (MXKB > MXPKA)) MXKB = MXPKA
              MXJSOB = max(0,maxval(NTSOB(JOBTP,:)))

              LBLK = MXISOB*MXJSOB*MXKB*MXKA
              MXCIJAB = max(MXCIJAB,LBLK)
            end if
          end do
        end if
      end do
    end if
  end do
end do

! Largest block of single excitations :
! Strings of given type and sym, orbitals of given type and sym

MXSXBL = 0
! For alpha strings:
do IATP=1,NOCTPA
  MXIA = max(0,maxval(NSSOA(IATP,:)))
  ! Orbitals to be removed
  do JOBTP=1,3
    ! Is this removal allowed ??
    call NEWTYP_MCLR(IACLS,IATP,[1],[JOBTP],1,KACLS,KATP)
    if (KATP > 0) then
      ! Number of possible choices of J orbitals
      MXJOB = max(0,maxval(NTSOB(JOBTP,:)))
      MXJOB = min(MXJOB,NAEL123(JOBTP,IATP))
      ! Then  : add an electron
      do IOBTP=1,3
        ! Allowed ?
        call NEWTYP_MCLR(KACLS,KATP,[2],[IOBTP],1,JACLS,JATP)
        if (JATP > 0) then
          MXIOB = max(0,maxval(NTSOB(IOBTP,:)))

          MXSXBL = max(MXSXBL,MXIOB*MXJOB*MXIA)
        end if
      end do
    end if
  end do
end do

! For beta strings:
do IBTP=1,NOCTPB
  MXIB = max(0,maxval(NSSOB(IBTP,:)))
  ! Orbitals to be removed
  do JOBTP=1,3
    ! Is this removal allowed ??
    call NEWTYP_MCLR(IBCLS,IBTP,[1],[JOBTP],1,KBCLS,KBTP)
    if (KBTP > 0) then
      ! Number of possible choices of J orbitals
      MXJOB = max(0,maxval(NTSOB(JOBTP,:)))
      MXJOB = min(MXJOB,NBEL123(JOBTP,IBTP))
      ! Then  : add an electron
      do IOBTP=1,3
        ! Allowed ?
        call NEWTYP_MCLR(KBCLS,KBTP,[2],[IOBTP],1,JBCLS,JBTP)
        if (JATP > 0) then
          MXIOB = max(0,maxval(NTSOB(IOBTP,:)))

          MXSXBL = max(MXSXBL,MXIOB*MXJOB*MXIA)
        end if
      end do
    end if
  end do
end do

MXIJST = max(MXIJSTA,MXIJSTB)
MXIJSTF = max(MXIJSTAF,MXIJSTBF)

end subroutine MXRESC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKCOT(SGS,CIS)
! PURPOSE: SET UP COUNTER AND OFFSET TABLES FOR WALKS AND CSFS
! NOTE:    TO GET GET VARIOUS COUNTER AND OFFSET TABLES
!          THE DOWN-CHAIN TABLE IS SCANNED TO PRODUCE ALL POSSIBLE
!          WALKS. POSSIBLY, THERE ARE MORE EFFICIENT WAYS, BUT
!          SINCE ONLY UPPER AND LOWER WALKS ARE REQUIRED
!          THEIR NUMBER IS VERY LIMITTED, EVEN FOR LARGE CASES.

use Symmetry_Info, only: Mul
use gugx, only: CIStruct, SGStruct
use stdalloc, only: mma_allocate
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
type(SGStruct), intent(inout) :: SGS
type(CIStruct), intent(inout) :: CIS
integer(kind=iwp) :: IHALF, ILND, ISML, ISTP, IVB, IVT, IVTEND, IVTOP, IVTSTA, IWSYM, LEV, LEV1, LEV2, MV, NUW
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IS
#endif
integer(kind=iwp), parameter :: IVERT = 1, ISYM = 2, ISTEP = 3

CIS%nIpWlk = 1+(SGS%MidLev-1)/15
CIS%nIpWlk = max(CIS%nIpWlk,1+(SGS%nLev-SGS%MidLev-1)/15)
call mma_allocate(CIS%NOW,2,SGS%nSym,CIS%nMidV,Label='CIS%NOW')
call mma_allocate(CIS%IOW,2,SGS%nSym,CIS%nMidV,Label='CIS%IOW')
call mma_allocate(CIS%NOCSF,SGS%nSym,CIS%nMidV,SGS%nSym,Label='CIS%NOCSF')
call mma_allocate(CIS%IOCSF,SGS%nSym,CIS%nMidV,SGS%nSym,Label='CIS%IOCSF')
call mma_allocate(CIS%NCSF,SGS%nSym,Label='CIS%NCSF')
call mma_allocate(SGS%Scr,[1,3],[0,SGS%nLev],Label='SGS%Scr')

! CLEAR ARRAYS IOW AND NOW

CIS%NOW(:,:,:) = 0
CIS%IOW(:,:,:) = 0

! CLEAR ARRAYS IOCSF AND NOCSF

CIS%IOCSF(:,:,:) = 0
CIS%NOCSF(:,:,:) = 0

! START MAIN LOOP OVER UPPER AND LOWER WALKS, RESPECTIVELY.

do IHALF=1,2
  if (IHALF == 1) then
    IVTSTA = 1
    IVTEND = 1
    LEV1 = SGS%nLev
    LEV2 = SGS%MidLev
  else
    IVTSTA = SGS%MVSta
    IVTEND = SGS%MVEnd
    LEV1 = SGS%MidLev
    LEV2 = 0
  end if

  ! LOOP OVER VERTICES STARTING AT TOP OF SUBGRAPH

  do IVTOP=IVTSTA,IVTEND
    ! SET CURRENT LEVEL=TOP LEVEL OF SUBGRAPH
    LEV = LEV1
    SGS%Scr(IVERT,LEV) = IVTOP
    SGS%Scr(ISYM,LEV) = 1
    SGS%Scr(ISTEP,LEV) = -1
    do while (LEV <= LEV1)
      ! FIND FIRST POSSIBLE UNTRIED ARC DOWN FROM CURRENT VERTEX
      IVT = SGS%Scr(IVERT,LEV)
      do ISTP=SGS%Scr(ISTEP,LEV)+1,3
        IVB = SGS%Down(IVT,ISTP)
        if (IVB /= 0) exit
      end do
      ! NO SUCH ARC WAS POSSIBLE. GO UP ONE STEP AND TRY AGAIN.
      if (ISTP > 3) then
        SGS%Scr(ISTEP,LEV) = -1
        LEV = LEV+1
        cycle
      end if
      ! SUCH AN ARC WAS FOUND. WALK DOWN:
      SGS%Scr(ISTEP,LEV) = ISTP
      ISML = 1
      if ((ISTP == 1) .or. (ISTP == 2)) ISML = SGS%ISm(LEV)
      LEV = LEV-1
      SGS%Scr(ISYM,LEV) = Mul(ISML,SGS%Scr(ISYM,LEV+1))
      SGS%Scr(IVERT,LEV) = IVB
      SGS%Scr(ISTEP,LEV) = -1
      if (LEV > LEV2) cycle
      ! WE HAVE REACHED THE BOTTOM LEVEL. THE WALK IS COMPLETE.
      ! FIND MIDVERTEX NUMBER ORDERING NUMBER AND SYMMETRY OF THIS WALK
      MV = SGS%Scr(IVERT,SGS%MidLev)+1-SGS%MVSta
      IWSYM = SGS%Scr(ISYM,LEV2)
      ILND = 1+CIS%NOW(IHALF,IWSYM,MV)
      ! SAVE THE MAX WALK NUMBER FOR GIVEN SYMMETRY AND MIDVERTEX
      CIS%NOW(IHALF,IWSYM,MV) = ILND
      ! BACK UP ONE LEVEL AND TRY AGAIN:
      LEV = LEV+1
    end do
  end do
end do

call CSFCOUNT(CIS,SGS%nSym,NUW)

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' TOTAL NR OF WALKS: UPPER ',NUW
write(u6,*) '                    LOWER ',CIS%nWalk-NUW
write(u6,*) '                     SUM  ',CIS%nWalk
write(u6,*)
write(u6,*) ' NR OF CONFIGURATIONS/SYMM:'
write(u6,'(8(1X,I8))') (CIS%NCSF(IS),IS=1,SGS%nSym)
write(u6,*)
write(u6,*)
write(u6,*) ' NR OF WALKS AND CONFIGURATIONS IN NRCOUP'
write(u6,*) ' BY MIDVERTEX AND SYMMETRY.'
do MV=1,CIS%nMidV
  write(u6,'(A,I2,A,8I6)') '  MV=',MV,'    UPPER WALKS:',(CIS%NOW(1,IS,MV),IS=1,SGS%nSym)
  write(u6,'(A,8I6)') '           LOWER WALKS:',(CIS%NOW(2,IS,MV),IS=1,SGS%nSym)
  do ISTP=1,SGS%nSym
    write(u6,'(A,I2,A,8I6)') ' ISTP=',ISTP,'  CONFIGURATIONS:',(CIS%NOCSF(IS,MV,ISTP),IS=1,SGS%nSym)
  end do
end do
#endif

end subroutine MKCOT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Assemble_mGauss(As,Ad,nAs)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAs
real(kind=wp), intent(inout) :: As(nAs)
real(kind=wp), intent(in) :: Ad(nAs,6)

As(:) = As+Ad(:,1)+Ad(:,4)+Ad(:,6)

return

end subroutine Assemble_mGauss

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001-2005, Valera Veryazov                             *
************************************************************************

        subroutine molcas_open_ext2(Lu,f_Name,f_access,
     &   f_form,f_iostat,is_recl,f_recl,f_status,is_error)
        Integer Lu,f_recl,f_iostat,strnln
        External StrnLn
        Character*(*) f_Name
        Character*4096 RealName
        Character*(*) f_access,f_form,f_status
        Logical is_recl,is_error
        is_error=.false.
       Call prgmtranslate(f_Name, RealName, lRealName)
       if(index(RealName,'UNK_VAR').ne.0) then
         write(6,*) '*** attempt to open ',RealName(1:lRealName)
         RealName=f_Name
         lRealName=index(RealName,' ')
       endif

        if(is_recl) then
                   open(Unit=Lu,File=Realname(1:lRealName),
     &              status=f_status,err=100,
     &             access=f_access,  form=f_form, iostat=f_iostat,
     &             recl=f_recl)
        else

                   open(Unit=Lu,File=RealName(1:lRealName),
     &                   status=f_status,err=100,
     &             access=f_access,  form=f_form, iostat=f_iostat)
        endif
c        print *,'DEBUG open ',RealName(1:lRealName)
c        print *,'Unit ', Lu

        return
100     is_error=.true.
        end

        subroutine molcas_binaryopen_vanilla(Lu,f_name)
        integer Lu
        Integer StrnLn
        External StrnLn
        Character*(*) f_name
        Character*4096 RealName
c        RealName=f_Name
        Call PrgmTranslate(f_Name, RealName,lRealName)
c        print *,'DEBUG binopen ',RealName(1:lRealName)
        open(Unit=Lu,File=RealName(1:lRealName), form='unformatted')
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqagie(f,bound,inf,epsabs,epsrel,limit,reslt,abserr,neval,ier,alist,blist,rlist,elist,iord,last)
!***begin prologue  dqagie
!***date written   800101   (yymmdd)
!***revision date  830518   (yymmdd)
!***category no.  h2a3a1,h2a4a1
!***keywords  automatic integrator, infinite intervals,
!             general-purpose, transformation, extrapolation,
!             globally adaptive
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  the routine calculates an approximation result to a given
!            integral   i = integral of f over (bound,+infinity)
!            or i = integral of f over (-infinity,bound)
!            or i = integral of f over (-infinity,+infinity),
!            hopefully satisfying following claim for accuracy
!            abs(i-reslt) <= max(epsabs,epsrel*abs(i))
!***description
!
! integration over infinite intervals
! standard fortran subroutine
!
!            f      - real*8
!                     function subprogram defining the integrand
!                     function f(x). the actual name for f needs to be
!                     declared e x t e r n a l in the driver program.
!
!            bound  - real*8
!                     finite bound of integration range
!                     (has no meaning if interval is doubly-infinite)
!
!            inf    - real*8
!                     indicating the kind of integration range involved
!                     inf = 1 corresponds to  (bound,+infinity),
!                     inf = -1            to  (-infinity,bound),
!                     inf = 2             to (-infinity,+infinity).
!
!            epsabs - real*8
!                     absolute accuracy requested
!            epsrel - real*8
!                     relative accuracy requested
!                     if  epsabs <= 0
!                     and epsrel < max(50*rel.mach.acc.,0.5d-28),
!                     the routine will end with ier = 6.
!
!            limit  - integer
!                     gives an upper bound on the number of subintervals
!                     in the partition of (a,b), limit >= 1
!
!         on return
!            reslt  - real*8
!                     approximation to the integral
!
!            abserr - real*8
!                     estimate of the modulus of the absolute error,
!                     which should equal or exceed abs(i-reslt)
!
!            neval  - integer
!                     number of integrand evaluations
!
!            ier    - integer
!                     ier = 0 normal and reliable termination of the
!                             routine. it is assumed that the requested
!                             accuracy has been achieved.
!                   - ier > 0 abnormal termination of the routine. the
!                             estimates for result and error are less
!                             reliable. it is assumed that the requested
!                             accuracy has not been achieved.
!            error messages
!                     ier = 1 maximum number of subdivisions allowed
!                             has been achieved. one can allow more
!                             subdivisions by increasing the value of
!                             limit (and taking the according dimension
!                             adjustments into account). however,if
!                             this yields no improvement it is advised
!                             to analyze the integrand in order to
!                             determine the integration difficulties.
!                             if the position of a local difficulty can
!                             be determined (e.g. singularity,
!                             discontinuity within the interval) one
!                             will probably gain from splitting up the
!                             interval at this point and calling the
!                             integrator on the subranges. if possible,
!                             an appropriate special-purpose integrator
!                             should be used, which is designed for
!                             handling the type of difficulty involved.
!                         = 2 the occurrence of roundoff error is
!                             detected, which prevents the requested
!                             tolerance from being achieved.
!                             the error may be under-estimated.
!                         = 3 extremely bad integrand behaviour occurs
!                             at some points of the integration
!                             interval.
!                         = 4 the algorithm does not converge.
!                             roundoff error is detected in the
!                             extrapolation table.
!                             it is assumed that the requested tolerance
!                             cannot be achieved, and that the returned
!                             result is the best which can be obtained.
!                         = 5 the integral is probably divergent, or
!                             slowly convergent. it must be noted that
!                             divergence can occur with any other value
!                             of ier.
!                         = 6 the input is invalid, because
!                             (epsabs <= 0 and
!                              epsrel < max(50*rel.mach.acc.,0.5d-28),
!                             reslt, abserr, neval, last, rlist(1),
!                             elist(1) and iord(1) are set to zero.
!                             alist(1) and blist(1) are set to 0
!                             and 1 respectively.
!
!            alist  - real*8
!                     vector of dimension at least limit, the first
!                      last  elements of which are the left
!                     end points of the subintervals in the partition
!                     of the transformed integration range (0,1).
!
!            blist  - real*8
!                     vector of dimension at least limit, the first
!                      last  elements of which are the right
!                     end points of the subintervals in the partition
!                     of the transformed integration range (0,1).
!
!            rlist  - real*8
!                     vector of dimension at least limit, the first
!                      last  elements of which are the integral
!                     approximations on the subintervals
!
!            elist  - real*8
!                     vector of dimension at least limit,  the first
!                     last elements of which are the moduli of the
!                     absolute error estimates on the subintervals
!
!            iord   - integer
!                     vector of dimension limit, the first k
!                     elements of which are pointers to the
!                     error estimates over the subintervals,
!                     such that elist(iord(1)), ..., elist(iord(k))
!                     form a decreasing sequence, with k = last
!                     if last <= (limit/2+2), and k = limit+1-last
!                     otherwise
!
!            last   - integer
!                     number of subintervals actually produced
!                     in the subdivision process
!
!***references  (none)
!***routines called  d1mach,dqelg,dqk15i,dqpsrt
!***end prologue  dqagie

use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
interface
  function f(x)
    import :: wp
    real(kind=wp) :: f
    real(kind=wp), intent(in) :: x
  end function f
end interface
real(kind=wp), intent(in) :: bound, epsabs, epsrel
integer(kind=iwp), intent(in) :: inf, limit
real(kind=wp), intent(out) :: reslt, abserr, alist(limit), blist(limit), rlist(limit), elist(limit)
integer(kind=iwp), intent(out) :: neval, ier, iord(limit), last
real(kind=wp) :: abseps, area, area1, area12, area2, a1, a2, boun, b1, b2, correc, defabs, defab1, defab2, dres, epmach, erlarg, &
                 erlast, errbnd, errmax, error1, error2, erro12, errsum, ertest, oflow, resabs, reseps, res3la(3), rlist2(52), &
                 small, uflow
integer(kind=iwp) :: id, ierro, iroff1, iroff2, iroff3, jupbnd, k, ksgn, ktmin, maxerr, nres, nrmax, numrl2
logical(kind=iwp) :: extrap, noext
real(kind=wp), external :: d1mach

!  the dimension of rlist2 is determined by the value of
!  limexp in subroutine dqelg.
!
!
!  list of major variables
!  -----------------------
!
! alist     - list of left end points of all subintervals
!             considered up to now
! blist     - list of right end points of all subintervals
!             considered up to now
! rlist(i)  - approximation to the integral over
!             (alist(i),blist(i))
! rlist2    - array of dimension at least (limexp+2),
!             containing the part of the epsilon table
!             wich is still needed for further computations
! elist(i)  - error estimate applying to rlist(i)
! maxerr    - pointer to the interval with largest error
!             estimate
! errmax    - elist(maxerr)
! erlast    - error on the interval currently subdivided
!             (before that subdivision has taken place)
! area      - sum of the integrals over the subintervals
! errsum    - sum of the errors over the subintervals
! errbnd    - requested accuracy max(epsabs,epsrel*
!             abs(reslt))
! *****1    - variable for the left subinterval
! *****2    - variable for the right subinterval
! last      - index for subdivision
! nres      - number of calls to the extrapolation routine
! numrl2    - number of elements currently in rlist2. if an
!             appropriate approximation to the compounded
!             integral has been obtained, it is put in
!             rlist2(numrl2) after numrl2 has been increased
!             by one.
! small     - length of the smallest interval considered up
!             to now, multiplied by 1.5
! erlarg    - sum of the errors over the intervals larger
!             than the smallest interval considered up to now
! extrap    - logical variable denoting that the routine
!             is attempting to perform extrapolation. i.e.
!             before subdividing the smallest interval we
!             try to decrease the value of erlarg.
! noext     - logical variable denoting that extrapolation
!             is no longer allowed (true-value)
!
!  machine dependent constants
!  ---------------------------
!
! epmach is the largest relative spacing.
! uflow is the smallest positive magnitude.
! oflow is the largest positive magnitude.

!***first executable statement  dqagie

epmach = d1mach(4)

! test on validity of parameters
! -----------------------------

ier = 0
neval = 0
last = 0
reslt = Zero
abserr = Zero
alist(1) = Zero
blist(1) = One
rlist(1) = Zero
elist(1) = Zero
iord(1) = 0

correc = Zero ! dummy initialize
erlarg = Zero ! dummy initialize
ertest = Zero ! dummy initialize
small = Zero ! dummy initialize

if ((epsabs <= Zero) .and. (epsrel < max(50.0_wp*epmach,0.5e-28_wp))) ier = 6
if (ier == 6) return

! first approximation to the integral
! -----------------------------------
!
! determine the interval to be mapped onto (0,1).
! if inf = 2 the integral is computed as i = i1+i2, where
! i1 = integral of f over (-infinity,0),
! i2 = integral of f over (0,+infinity).

boun = bound
if (inf == 2) boun = Zero
call dqk15i(f,boun,inf,Zero,One,reslt,abserr,defabs,resabs)

! test on accuracy

last = 1
rlist(1) = reslt
elist(1) = abserr
iord(1) = 1
dres = abs(reslt)
errbnd = max(epsabs,epsrel*dres)
if ((abserr <= 100.0_wp*epmach*defabs) .and. (abserr > errbnd)) ier = 2
if (limit == 1) ier = 1
if ((ier /= 0) .or. ((abserr <= errbnd) .and. (abserr /= resabs)) .or. (abserr == Zero)) then
  call finish(compute=.false.)
  return
end if

! initialization
! --------------

uflow = d1mach(1)
oflow = d1mach(2)
rlist2(1) = reslt
errmax = abserr
maxerr = 1
area = reslt
errsum = abserr
abserr = oflow
nrmax = 1
nres = 0
ktmin = 0
numrl2 = 2
extrap = .false.
noext = .false.
ierro = 0
iroff1 = 0
iroff2 = 0
iroff3 = 0
ksgn = -1
if (dres >= (One-50.0_wp*epmach)*defabs) ksgn = 1

! main do-loop
! ------------

main: do last=2,limit

  ! bisect the subinterval with nrmax-th largest error estimate.

  a1 = alist(maxerr)
  b1 = Half*(alist(maxerr)+blist(maxerr))
  a2 = b1
  b2 = blist(maxerr)
  erlast = errmax
  call dqk15i(f,boun,inf,a1,b1,area1,error1,resabs,defab1)
  call dqk15i(f,boun,inf,a2,b2,area2,error2,resabs,defab2)

  ! improve previous approximations to integral
  ! and error and test for accuracy.

  area12 = area1+area2
  erro12 = error1+error2
  errsum = errsum+erro12-errmax
  area = area+area12-rlist(maxerr)
  if ((defab1 /= error1) .and. (defab2 /= error2)) then
    if ((abs(rlist(maxerr)-area12) <= 0.1e-4_wp*abs(area12)) .and. (erro12 >= 0.99_wp*errmax)) then
      if (extrap) iroff2 = iroff2+1
      if (.not. extrap) iroff1 = iroff1+1
    end if
    if ((last > 10) .and. (erro12 > errmax)) iroff3 = iroff3+1
  end if
  rlist(maxerr) = area1
  rlist(last) = area2
  errbnd = max(epsabs,epsrel*abs(area))

  ! test for roundoff error and eventually set error flag.

  if ((iroff1+iroff2 >= 10) .or. (iroff3 >= 20)) ier = 2
  if (iroff2 >= 5) ierro = 3

  ! set error flag in the case that the number of
  ! subintervals equals limit.

  if (last == limit) ier = 1

  ! set error flag in the case of bad integrand behaviour
  ! at some points of the integration range.

  if (max(abs(a1),abs(b2)) <= (One+100.0_wp*epmach)*(abs(a2)+1000.0_wp*uflow)) ier = 4

  ! append the newly-created intervals to the list.

  if (error2 <= error1) then
    alist(last) = a2
    blist(maxerr) = b1
    blist(last) = b2
    elist(maxerr) = error1
    elist(last) = error2
  else
    alist(maxerr) = a2
    alist(last) = a1
    blist(last) = b1
    rlist(maxerr) = area2
    rlist(last) = area1
    elist(maxerr) = error2
    elist(last) = error1
  end if

  ! call subroutine dqpsrt to maintain the descending ordering
  ! in the list of error estimates and select the subinterval
  ! with nrmax-th largest error estimate (to be bisected next).

  call dqpsrt(limit,last,maxerr,errmax,elist,iord,nrmax)
  if (errsum <= errbnd) then
    call finish(compute=.true.)
    return
  end if
  if (ier /= 0) exit main
  if (last == 2) then
    small = 0.375_wp
    erlarg = errsum
    ertest = errbnd
    rlist2(2) = area
    cycle main
  end if
  if (noext) cycle main
  erlarg = erlarg-erlast
  if (abs(b1-a1) > small) erlarg = erlarg+erro12
  if (.not. extrap) then

    ! test whether the interval to be bisected next is the
    ! smallest interval.

    if (abs(blist(maxerr)-alist(maxerr)) > small) cycle main
    extrap = .true.
    nrmax = 2
  end if
  if ((ierro /= 3) .and. (erlarg > ertest)) then

    ! the smallest interval has the largest error.
    ! before bisecting decrease the sum of the errors over the
    ! larger intervals (erlarg) and perform extrapolation.

    id = nrmax
    jupbnd = last
    if (last > (2+limit/2)) jupbnd = limit+3-last
    do k=id,jupbnd
      maxerr = iord(nrmax)
      errmax = elist(maxerr)
      if (abs(blist(maxerr)-alist(maxerr)) > small) cycle main
      nrmax = nrmax+1
    end do
  end if

  ! perform extrapolation.

  numrl2 = numrl2+1
  rlist2(numrl2) = area
  call dqelg(numrl2,rlist2,reseps,abseps,res3la,nres)
  ktmin = ktmin+1
  if ((ktmin > 5) .and. (abserr < 1.0e-3_wp*errsum)) ier = 5
  if (abseps < abserr) then
    ktmin = 0
    abserr = abseps
    reslt = reseps
    correc = erlarg
    ertest = max(epsabs,epsrel*abs(reseps))
    if (abserr <= ertest) exit main
  end if

  ! prepare bisection of the smallest interval.

  if (numrl2 == 1) noext = .true.
  if (ier == 5) exit main
  maxerr = iord(1)
  errmax = elist(maxerr)
  nrmax = 1
  extrap = .false.
  small = small*Half
  erlarg = errsum
end do main

! set final result and error estimate.
! ------------------------------------

if (abserr == oflow) then
  call finish(compute=.true.)
  return
end if
if ((ier+ierro) /= 0) then
  if (ierro == 3) abserr = abserr+correc
  if (ier == 0) ier = 3
  if ((reslt == Zero) .or. (area == Zero)) then
    if (abserr > errsum) then
      call finish(compute=.true.)
      return
    end if
    if (area == Zero) then
      call finish(compute=.false.)
      return
    end if
  else
    if (abserr/abs(reslt) > errsum/abs(area)) then
      call finish(compute=.true.)
      return
    end if
  end if
end if

! test on divergence

if ((ksgn /= -1) .or. (max(abs(reslt),abs(area)) > defabs*1.0e-2_wp)) then
  if ((1.0e-2_wp > reslt/area) .or. (reslt/area > 100.0_wp) .or. (errsum > abs(area))) ier = 6
end if
call finish(compute=.false.)

return

contains

subroutine finish(compute)

  logical(kind=iwp), intent(in) :: compute
  integer(kind=iwp) :: i

  if (compute) then

    ! compute global integral sum.

    reslt = Zero
    do i=1,last
      reslt = reslt+rlist(i)
    end do
    abserr = errsum

  end if

  neval = 30*last-15
  if (inf == 2) neval = 2*neval
  if (ier > 2) ier = ier-1

end subroutine finish

end subroutine dqagie

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SINGLE_ANISO_OPEN(IReturn)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iReturn
integer(kind=iwp) :: input_to_read, nDir, nDirZee, nH, nMult, NSS, NSTATE, nT, nTempMagn
logical(kind=iwp) :: GRAD, ifrestart
character(len=180) :: input_file_name

!-----------------------------------------------------------------------
!* initializations
ireturn = 0

! check for the "restart" option:
#ifdef _DEBUGPRINT_
write(u6,*) 'Enter restart_check'
#endif
call restart_check(ifrestart,input_to_read,input_file_name,nT,nH,nTempMagn,nDir,nDirZee,nMult,GRAD)
#ifdef _DEBUGPRINT_
write(u6,*) 'Exit restart_check'
#endif

if (ifrestart) then
  call restart_sa(input_to_read,input_file_name,nss,nstate)
else ! not a restart job -- take all data form RUNFILE
  call fetch_data_RunFile_init(nss,nstate)
end if !Ifrestart

write(u6,'(A)') repeat('@',95)
write(u6,'(A)') '   SINGLE_ANISO (OPEN)'
write(u6,'(A)') '(last updated on 12-March-2018)'
write(u6,'(A)') '   New features: '
write(u6,*)
write(u6,'(A)') '1.  Calculation of the SIGN of the product gX * gY * gZ for any moment;'
write(u6,'(A)') '2.  Calculation of the parameters of the Crystal-Field for lanthanides (CRYS).'
write(u6,'(A)') '3.  Automatic generation of various plot: (PLOT)'
write(u6,'(A)') '     -- Powder magnetic susceptibilty:  XT=f(T)'
write(u6,'(A)') '     -- Powder molar magnetization:  M=f(H,T)'
write(u6,'(A)') '4.  Support for various restart options: (REST)'
write(u6,'(A)') '     -- from  $Project.rassi.h5 file.'
write(u6,'(A)') '     -- from  $Project.aniso (binary) file.'
write(u6,'(A)') '     -- from  ANISOINPUT (ascii) file.'
write(u6,'(A)') '     -- from  $Project.RunFile file.'
write(u6,'(A)') '5.  RASSI was adjusted to provide more accurate tunnelling gaps between near-degenerate states'
write(u6,'(A)') 'Check the MOLCAS manual for details and input examples.'
write(u6,*)
write(u6,'(A)') repeat('@',95)
call xFlush(u6)

call SINGLE_ANISO2(nH,nT,nTempMagn,nDir,nDirZee,nss,nstate,nMult,input_file_name,Ifrestart,IReturn,GRAD)

return

end subroutine SINGLE_ANISO_OPEN

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine utmu2(exch,n,z,m)
! the same as utmu, except being that the input m is being transformed.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: exch, n
complex(kind=wp), intent(in) :: z(n,n)
complex(kind=wp), intent(inout) :: m(3,exch,exch)
integer(kind=iwp) :: i, i1, j, j1, l
real(kind=wp) :: r1, r2
complex(kind=wp), allocatable :: mtmp(:,:,:), tmp(:,:), tmp2(:,:)
real(kind=wp), external :: dznrm2_

if ((n <= 0) .or. (exch <= 0)) then
  write(u6,'(a)') 'in utmu2:   exch or n<=0 !!!'
  write(u6,*) 'exch=',exch
  write(u6,*) 'n   =',n
  call xFlush(u6)
  call abend()
end if

if (n > exch) then
  write(u6,'(a)') 'in utmu2:   exch < n !!!'
  write(u6,*) 'exch=',exch
  write(u6,*) 'n   =',n
  write(u6,'(a)') 'nothing is to be done >> return'
  call xFlush(u6)
  call abend()
end if

r1 = dznrm2_(3*exch*exch,m,1)
r2 = dznrm2_(n*n,z,1)
if ((r1 < 1.0e-25_wp) .or. (r2 < 1.0e-25_wp)) then
  write(u6,'(a)') 'in utmu2:   m or z are empty!!!'
  write(u6,*) 'norm(m)=',r1
  write(u6,*) 'norm(z)=',r2
  return
end if

#ifdef _DEBUGPRINT_
write(u6,'(a)') 'utmu2 :: input moment'
do i=1,exch
  do j=1,exch
    write(u6,'(a,i3,a,i3,a,3(2es16.8,2x))') '<',i,'|m_l|',j,'>',(m(l,i,j),l=1,3)
  end do
end do
#endif

call mma_allocate(tmp,n,exch,'tmp')
call mma_allocate(tmp2,n,exch,'tmp2')
if (n /= exch) then
  call mma_allocate(mtmp,3,(exch-n),(exch-n),'mtmp')
  ! save the part which is not altered
  do i=n+1,exch
    do j=n+1,exch
      i1 = i-n
      j1 = j-n
      mtmp(:,i1,j1) = m(:,i,j)
    end do
  end do
end if

if (n == exch) then

  do l=1,3
    tmp2(:,:) = m(l,:,:)
    call zgemm_('c','n',exch,exch,exch,cOne,z,exch,tmp2,exch,cZero,tmp,exch)
    call zgemm_('n','n',exch,exch,exch,cOne,tmp,exch,z,exch,cZero,tmp2,exch)
    m(l,:,:) = tmp2(:,:)
  end do !l

else

  do l=1,3
    tmp2(:,:) = m(l,1:n,:)
    call zgemm_('c','n',n,n,n,cOne,z,n,tmp2(:,1:n),n,cZero,tmp(:,1:n),n)
    call zgemm_('n','n',n,n,n,cOne,tmp(:,1:n),n,z,n,cZero,tmp2(:,1:n),n)
    m(l,1:n,1:n) = tmp2(:,1:n)
    call zgemm_('c','n',n,exch,n,cOne,z,n,tmp2,n,cZero,tmp,n)

    do i=1,n
      m(l,i,n+1:) = tmp(i,n+1:)
      m(l,n+1:,i) = conjg(tmp(i,n+1:))
    end do
    m(l,n+1:,n+1:) = mtmp(l,1:exch-n,1:exch-n)
  end do !l
end if !n == exch

#ifdef _DEBUGPRINT_
write(u6,'(a)') 'utmu2 :: unitary transformtion matrix'
do i=1,n
  do j=1,n
    write(u6,'(a,i3,a,i3,a,3(2es16.8,2x))') '<',i,'| u |',j,'>',z(i,j)
  end do
end do
write(u6,'(a)') 'utmu2 :: output moment'
do i=1,exch
  do j=1,exch
    write(u6,'(a,i3,a,i3,a,3(2es16.8,2x))') '<',i,'|m_l|',j,'>',(m(l,i,j),l=1,3)
  end do
end do
#endif

if (n < exch) call mma_deallocate(mtmp)
call mma_deallocate(tmp)
call mma_deallocate(tmp2)

#ifdef _DEBUGPRINT_
write(u6,*) 'at the end of utmu2'
call prmom('utmu2, moment',m,n)
#endif

return

end subroutine utmu2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_DecChk_Int(irc,lUnit,Col,Nai,Nbj,ibj1,NumVec,Work,lWork,Fac)
!
! Thomas Bondo Pedersen, Jan. 2005.
!
! Purpose: compute consecutive columns of (ai|bj) matrix from
!          vectors on file (unit: lUnit)
!          vectors from MP2 decomposition).

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: lUnit, Nai, Nbj, ibj1, NumVec, lWork
real(kind=wp), intent(inout) :: Col(Nai,Nbj)
real(kind=wp), intent(out) :: Work(lWork)
real(kind=wp), intent(in) :: Fac
integer(kind=iwp) :: iAdr, iBat, ibj2, iOpt, iVec1, lTot, nBat, NumV, nVec

irc = 0

! Check dimensions.
! -----------------

if ((Nai < 1) .or. (Nbj < 1) .or. (Nbj > Nai)) then
  irc = -1
  return
end if
ibj2 = ibj1+Nbj-1
if ((ibj1 < 1) .or. (ibj2 > Nai)) then
  irc = -2
  return
end if

! Scale result array.
! -------------------

Col(:,:) = Fac*Col(:,:)
if (NumVec < 1) return

! Set up batch.
! -------------
nVec = min(lWork/Nai,NumVec)
if (nVec < 1) then
  irc = 1
  return
end if
nBat = (NumVec-1)/nVec+1

! Start batch loop.
! -----------------

do iBat=1,nBat

  ! Set batch info.
  ! ---------------

  if (iBat == nBat) then
    NumV = NumVec-nVec*(nBat-1)
  else
    NumV = nVec
  end if
  iVec1 = nVec*(iBat-1)+1

  ! Read vectors.
  ! -------------

  iOpt = 2
  lTot = Nai*NumV
  iAdr = Nai*(iVec1-1)+1
  call ddaFile(lUnit,iOpt,Work,lTot,iAdr)

  ! Compute integrals.
  ! ------------------

  call DGEMM_('N','T',Nai,Nbj,NumV,One,Work,Nai,Work(ibj1),Nai,One,Col,Nai)

end do

end subroutine ChoMP2_DecChk_Int

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Square_A(Lu,nB,MaxMem_,Force_out_of_Core)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lu, nB, MaxMem_
logical(kind=iwp), intent(in) :: Force_out_of_Core
integer(kind=iwp) :: iAddr, iAddr1, iAddr2, iAddrs, iB, Inc, jB, kB, MaxMem, mB, nBuff, nMem
real(kind=wp), allocatable :: Buf(:,:)

if (nB == 0) return
MaxMem = MaxMem_
nMem = nB**2
if (Force_Out_of_Core) MaxMem = nMem/3

if (nMem <= MaxMem) then

  ! In-core case

  call mma_allocate(Buf,nMem,1,Label='Buf')
  iAddr = 0
  call dDaFile(Lu,2,Buf(:,1),nMem,iAddr)
  call In_place_Square(Buf(:,1),nB)
  iAddr = 0
  call dDaFile(Lu,1,Buf(:,1),nMem,iAddr)

else

  ! Out-of-core case

  nBuff = MaxMem/2
  call mma_allocate(Buf,nBuff,2,Label='Buf')

  Inc = nBuff/nB
  iAddr1 = 0
  do iB=1,nB,Inc
    mB = min(Inc,nB-iB+1)
    iAddrs = iAddr1
    call dDaFile(Lu,2,Buf(:,1),nB*mB,iAddr1)

    iAddr2 = iAddr1
    do jB=iB,nB,Inc
      kB = min(Inc,nB-jB+1)

      if (jB == iB) then
        call In_place_Diag(Buf(:,1),nB,iB,iB+mB-1)
      else
        call dDaFile(Lu,2,Buf(:,2),nB*kB,iAddr2)
        call Off_Diagonal(Buf(:,1),nB,iB,iB+mB-1,Buf(:,2),jB,jB+kB-1)
      end if
    end do

    iAddr1 = iAddrs
    call dDaFile(Lu,1,Buf(:,1),nB*mB,iAddr1)

  end do
end if
call mma_deallocate(Buf)

return

end subroutine Square_A

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine cimol2vb_cvb(vec,civec)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
#include "casinfo_cvb.fh"
      dimension vec(*)
      dimension ncix(mxirrep),civec(*)

      iwr=0
      icivec=nint(civec(1))

      if(iwr.eq.0)call fzero(w(iaddr_ci(icivec)),ndet)

      icioffs=0
      do 1000 istsym_d=1,nstsym_d
      isyml=istsy_d(istsym_d)
      if(isymv(isyml).ne.1)goto 1000
      call getnci_cvb(ncix,istnel_d(istsym_d),istms2_d(istsym_d),
     >  istsy_d(istsym_d))
      nci=ncix(1)
      lcim=mstackr_cvb(nci)
      if(iwr.eq.0)then
        do 1100 istate=1,nstats_d(istsym_d)
        if(abs(weight_d(istate,istsym_d)).gt.1.d-20)then
          call fmove_cvb(vec(1+icioffs),w(lcim),nci)
          icioffs=icioffs+nci
          fac=sqrt(weight_d(istate,istsym_d))
          call mol2vbma_cvb(w(iaddr_ci(icivec)),w(lcim),isyml,fac)
        endif
1100    continue
      elseif(iwr.eq.1)then
        do 1200 istate=1,nstats_d(istsym_d)
        if(abs(weight_d(istate,istsym_d)).gt.1.d-20)then
          call vb2mol_cvb(w(iaddr_ci(icivec)),w(lcim),isyml)
          call fmove_cvb(w(lcim),vec(1+icioffs),nci)
          icioffs=icioffs+nci
        endif
1200    continue
      endif
      call mfreer_cvb(lcim)
1000  continue
      return
      end
      subroutine civb2mol_cvb(civec,vec)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
#include "casinfo_cvb.fh"
      dimension vec(*),civec(*)
      dimension ncix(mxirrep)
      iwr=1
      icivec=nint(civec(1))

      if(iwr.eq.0)call fzero(w(iaddr_ci(icivec)),ndet)

      icioffs=0
      do 1000 istsym_d=1,nstsym_d
      isyml=istsy_d(istsym_d)
      if(isymv(isyml).ne.1)goto 1000
      call getnci_cvb(ncix,istnel_d(istsym_d),istms2_d(istsym_d),
     >  istsy_d(istsym_d))
      nci=ncix(1)
      lcim=mstackr_cvb(nci)
      if(iwr.eq.0)then
        do 1100 istate=1,nstats_d(istsym_d)
        if(abs(weight_d(istate,istsym_d)).gt.1.d-20)then
          call fmove_cvb(vec(1+icioffs),w(lcim),nci)
          icioffs=icioffs+nci
          fac=sqrt(weight_d(istate,istsym_d))
          call mol2vbma_cvb(w(iaddr_ci(icivec)),w(lcim),isyml,fac)
        endif
1100    continue
      elseif(iwr.eq.1)then
        do 1200 istate=1,nstats_d(istsym_d)
        if(abs(weight_d(istate,istsym_d)).gt.1.d-20)then
          call vb2mol_cvb(w(iaddr_ci(icivec)),w(lcim),isyml)
          call fmove_cvb(w(lcim),vec(1+icioffs),nci)
          icioffs=icioffs+nci
        endif
1200    continue
      endif
      call mfreer_cvb(lcim)
1000  continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine NPSET(JSY,INDX,C,TPQ,ENP,T,S,W,EPP,ICASE)

use cpf_global, only: IADDP, ICPF, IDENS, INCPF, IPRINT, IRC, ISDCI, ITPUL, JSC, LSYM, Lu_CI, NCONF, NNS, NVIR
use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JSY(*), INDX(*), ICASE(*)
real(kind=wp), intent(inout) :: C(*), ENP(*)
real(kind=wp), intent(_OUT_) :: TPQ(*), T(*), S(*), W(*), EPP(*)
integer(kind=iwp) :: I, IAD, IIN, IND, INUM, IP, IQ, IST, NS1, NSIL
real(kind=wp) :: EMPI
integer(kind=iwp), external :: JSUNP
real(kind=r8), external :: DDOT_

if (IDENS /= 1) then

  if (ITPUL == 1) then
    IAD = 0
    IADDP(1) = 0
    call dDAFILE(Lu_CI,1,C,NCONF,IAD)
    IADDP(2) = IAD
  end if

  ! VALENCE

  IQ = IRC(1)
  T(1:IQ) = C(1:IQ)**2

  ! SINGLES

  IQ = IRC(2)-IRC(1)
  IND = IRC(1)
  IIN = IRC(1)
  do I=1,IQ
    IND = IND+1
    NS1 = JSUNP(JSY,IIN+I)
    NSIL = MUL(NS1,LSYM)
    INUM = NVIR(NSIL)
    IST = INDX(IIN+I)+1
    T(IND) = DDOT_(INUM,C(IST),1,C(IST),1)
  end do

  ! DOUBLES

  IQ = IRC(4)-IRC(2)
  IIN = IRC(2)
  do I=1,IQ
    IND = IND+1
    NS1 = JSUNP(JSY,IIN+I)
    NSIL = MUL(NS1,LSYM)
    INUM = NNS(NSIL)
    IST = INDX(IIN+I)+1
    T(IND) = DDOT_(INUM,C(IST),1,C(IST),1)
  end do
  IP = IRC(4)
  do I=1,IP
    call TPQSET(ICASE,TPQ,I)
    ENP(I) = DDOT_(IP,TPQ,1,T,1)+One
  end do
  IP = IRC(4)
  if (IPRINT > 5) write(u6,12) (ENP(I),I=1,IP)

end if

! VALENCE

IQ = IRC(1)
do I=1,IQ
  if (IDENS == 0) then
    EMPI = One/sqrt(ENP(I))
  else
    EMPI = sqrt(ENP(I))
  end if
  C(I) = C(I)*EMPI
end do

! SINGLES

IQ = IRC(2)-IRC(1)
IIN = IRC(1)
do I=1,IQ
  NS1 = JSUNP(JSY,IIN+I)
  NSIL = MUL(NS1,LSYM)
  INUM = NVIR(NSIL)
  IST = INDX(IIN+I)+1
  if (IDENS == 0) then
    EMPI = One/sqrt(ENP(IIN+I))
  else
    EMPI = sqrt(ENP(IIN+I))
  end if
  C(IST:IST+INUM-1) = EMPI*C(IST:IST+INUM-1)
end do

! DOUBLES

IQ = IRC(4)-IRC(2)
IIN = IRC(2)
do I=1,IQ
  NS1 = JSUNP(JSY,IIN+I)
  NSIL = MUL(NS1,LSYM)
  INUM = NNS(NSIL)
  IST = INDX(IIN+I)+1
  if (IDENS == 0) then
    EMPI = One/sqrt(ENP(IIN+I))
  else
    EMPI = sqrt(ENP(IIN+I))
  end if
  C(IST:IST+INUM-1) = EMPI*C(IST:IST+INUM-1)
end do
if (IPRINT >= 15) write(u6,13) (C(I),I=1,NCONF)

if (IDENS /= 1) then
  EPP(1:IRC(4)) = Zero
  S(1:JSC(4)) = Zero
  if ((ICPF /= 1) .and. (ISDCI /= 1) .and. (INCPF /= 1)) W(1:JSC(4)) = Zero
end if

return

12 format(6X,'ENP ',5F14.8)
13 format(6X,'C(NP)',5F10.6)

end subroutine NPSET

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ciweight2_cvb(civec,civbs,civb,citmp,civec5,orbs,sorbs,orbinv,owrk,ionmin,ionmax,mxrem,mxsng,mxasg,ncnfcas,mxdetcas)

use casvb_global, only: form2AD, formAD, gjorb, gjorb2, gjorb3, iciweights, iprec, nalf, nbet, nda, ndet, nel, norb, npcf, svb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: civec(0:ndet), civbs(0:ndet), civb(0:ndet), citmp(0:ndet), civec5(0:ndet)
real(kind=wp), intent(in) :: orbs(norb,norb)
real(kind=wp), intent(out) :: sorbs(norb,norb), orbinv(norb,norb), owrk(norb,norb)
integer(kind=iwp), intent(in) :: ionmin, ionmax, mxrem, mxsng, mxasg, ncnfcas, mxdetcas
integer(kind=iwp) :: i, ia, iaorb, ib, ibeg, ibegt, iborb, ic, idet, ilin, inda, indab, indasg, indb, indion, indsng, ion, iorb, &
                     ix1, lenfld, mp, mrem, nalfsng, nbetsng, nc, nindasg, nprint, nsing, rc
real(kind=wp) :: c1, c2, c3, c4, cnrm, cprint(6), fac, fac1, fac2, s11, s12, s22, sm1, sm2, sum1, sum2, total1, total2, total3, &
                 total4, total5, total6
character(len=240) :: line
integer(kind=iwp), allocatable :: iaocc(:), ibocc(:), indavec(:), indbvec(:), locasg(:), locion(:), locsng(:), lunasg(:), &
                                  lunion(:), lunsng(:), maxgasg(:), maxgion(:), maxgrph(:), maxgsng(:), mingasg(:), mingion(:), &
                                  mingrph(:), mingsng(:), nkasg(:), nkion(:), nksng(:), xalf(:,:), xasg(:), xbet(:,:), xion(:), &
                                  xsng(:)
real(kind=wp), allocatable :: gal1(:), gal2(:), wghtion1(:), wghtion2(:), wghtion3(:), wghtion4(:), wghtion5(:), wghtion6(:)
integer(kind=iwp), external :: indget_cvb

call cidot_cvb(civb,civbs,cnrm)
fac = svb/sqrt(cnrm)

call cicopy_cvb(civec,citmp)
orbinv(:,:) = orbs(:,:)
call mxinv_cvb(orbinv,norb)
call gaussj_cvb(orbinv,gjorb)
call applyt_cvb(civec,gjorb)
! Chirgwin-Coulson weights
if (btest(iciweights,0)) then
  call trnsps(norb,norb,orbs,owrk)
  call gaussj_cvb(owrk,gjorb2)
  call applyt_cvb(citmp,gjorb2)
  do idet=1,ndet
    civbs(idet) = (citmp(idet)-fac*civbs(idet))*(civec(idet)-fac*civb(idet))
  end do
  do idet=1,ndet
    citmp(idet) = citmp(idet)*civec(idet)
  end do
end if
do idet=1,ndet
  civb(idet) = civec(idet)-fac*civb(idet)
end do

call mma_allocate(mingrph,[0,norb],label='mingrph')
call mma_allocate(maxgrph,[0,norb],label='maxgrph')
call mma_allocate(xalf,[0,nel],[0,nalf],label='xalf')
call mma_allocate(xbet,[0,nel],[0,nbet],label='xbet')
call mma_allocate(iaocc,norb,label='iaocc')
call mma_allocate(ibocc,norb,label='ibocc')
call mma_allocate(mingion,[0,norb],label='mingion')
call mma_allocate(maxgion,[0,norb],label='maxgion')
call mma_allocate(nkion,[0,norb],label='nkion')
call mma_allocate(xion,(norb+1)*(ionmax+1),label='xion')
call mma_allocate(locion,norb,label='locion')
call mma_allocate(lunion,norb,label='lunion')
call mma_allocate(mingsng,[0,norb],label='mingsng')
call mma_allocate(maxgsng,[0,norb],label='maxgsng')
call mma_allocate(nksng,[0,norb],label='nksng')
call mma_allocate(xsng,(mxrem+1)*(mxsng+1),label='xsng')
call mma_allocate(locsng,norb,label='locsng')
call mma_allocate(lunsng,norb,label='lunsng')
call mma_allocate(mingasg,[0,norb],label='mingasg')
call mma_allocate(maxgasg,[0,norb],label='maxgasg')
call mma_allocate(nkasg,[0,norb],label='nkasg')
call mma_allocate(xasg,(mxsng+1)*(mxasg+1),label='xasg')
call mma_allocate(locasg,norb,label='locasg')
call mma_allocate(lunasg,norb,label='lunasg')

! Inverse-overlap weights
if (btest(iciweights,2)) then
  call mma_allocate(gal1,ncnfcas,label='gal1')
  call mma_allocate(gal2,ncnfcas,label='gal2')
  call mma_allocate(indavec,mxdetcas,label='indavec')
  call mma_allocate(indbvec,mxdetcas,label='indbvec')
  call mxattb_cvb(orbs,orbs,norb,norb,norb,sorbs)
  orbinv(:,:) = sorbs(:,:)
  call mxinv_cvb(orbinv,norb)
  call gaussj_cvb(orbinv,gjorb)
  ! Alpha weight array:
  do iorb=0,norb
    mingrph(iorb) = max(iorb-norb+nalf,0)
    maxgrph(iorb) = min(iorb,nalf)
  end do
  call weight_cvb(xalf,mingrph,maxgrph,nalf,norb)
  ! Beta weight array:
  do iorb=0,norb
    mingrph(iorb) = max(iorb-norb+nbet,0)
    maxgrph(iorb) = min(iorb,nbet)
  end do
  call weight_cvb(xbet,mingrph,maxgrph,nbet,norb)

  nc = 0
  do ion=ionmin,ionmax
    nsing = nel-2*ion
    mrem = norb-ion
    nalfsng = nalf-ion
    nbetsng = nbet-ion
    ! Initialise loop for ionic orbitals
    do iorb=0,norb
      mingion(iorb) = max(iorb-norb+ion,0)
      maxgion(iorb) = min(iorb,ion)
    end do
    call weight_cvb(xion,mingion,maxgion,ion,norb)
    nkion(:) = maxgion(:)
    call occupy_cvb(nkion,norb,locion,lunion)
    ! Initialise loop for singly occupied orbitals
    do iorb=0,mrem
      mingsng(iorb) = max(iorb-mrem+nsing,0)
      maxgsng(iorb) = min(iorb,nsing)
    end do
    call weight_cvb(xsng,mingsng,maxgsng,nsing,mrem)
    nksng(:) = maxgsng(:)
    call occupy_cvb(nksng,mrem,locsng,lunsng)
    ! Initialise loop for singly occupied alpha orbitals
    do iorb=0,nsing
      mingasg(iorb) = max(iorb-nsing+nalfsng,0)
      maxgasg(iorb) = min(iorb,nalfsng)
    end do
    call weight_cvb(xasg,mingasg,maxgasg,nalfsng,nsing)
    nkasg(:) = maxgasg(:)
    call occupy_cvb(nkasg,nsing,locasg,lunasg)

    ! Loop ionic
    indion = 1
    do
      ! Loop singly occupied
      indsng = 1
      do
        civec5(1:) = Zero
        s11 = Zero
        s22 = Zero
        s12 = Zero
        ! Loop singly occupied alpha
        indasg = 1

        do
          iaocc(:) = 0
          ibocc(:) = 0
          do i=1,ion
            iaocc(locion(i)) = 1
            ibocc(locion(i)) = 1
          end do
          do ia=1,nalfsng
            iaorb = lunion(locsng(locasg(ia)))
            iaocc(iaorb) = 1
          end do
          do ib=1,nbetsng
            iborb = lunion(locsng(lunasg(ib)))
            ibocc(iborb) = 1
          end do
          inda = indget_cvb(iaocc,nalf,norb,xalf)
          indb = indget_cvb(ibocc,nbet,norb,xbet)
          indavec(indasg) = inda
          indbvec(indasg) = indb

          indab = (indb-1)*nda+inda
          civec5(indab) = civec(indab)
          s11 = s11+civec(indab)*civec(indab)
          s22 = s22+civb(indab)*civb(indab)
          s12 = s12+civec(indab)*civb(indab)

          call loind_cvb(nsing,nalfsng,nkasg,mingasg,maxgasg,locasg,lunasg,indasg,xasg,rc)
          if (rc == 0) exit
        end do

        call applyt_cvb(civec5,gjorb)

        call icomb_cvb(nsing,nalfsng,nindasg)
        sm1 = Zero
        do indasg=1,nindasg
          inda = indavec(indasg)
          indb = indbvec(indasg)
          indab = (indb-1)*nda+inda
          sm1 = sm1+civec(indab)*civec5(indab)
        end do

        if (abs(sm1) > 1.0e-20_wp) then
          sm1 = s11*s11/sm1
        else if (abs(sm1) <= 1.0e-20_wp) then
          sm1 = Zero
        end if

        civec5(1:) = Zero
        do indasg=1,nindasg
          inda = indavec(indasg)
          indb = indbvec(indasg)
          indab = (indb-1)*nda+inda
          civec5(indab) = civb(indab)
        end do

        call applyt_cvb(civec5,gjorb)

        sm2 = Zero
        do indasg=1,nindasg
          inda = indavec(indasg)
          indb = indbvec(indasg)
          indab = (indb-1)*nda+inda
          sm2 = sm2+civb(indab)*civec5(indab)
        end do

        if (abs(sm2) > 1.0e-20_wp) then
          sm2 = s22*s22/sm2
        else if (abs(sm2) <= 1.0e-20_wp) then
          sm2 = Zero
        end if

        nc = nc+1
        gal1(nc) = sm1
        gal2(nc) = sm2

        call loind_cvb(mrem,nsing,nksng,mingsng,maxgsng,locsng,lunsng,indsng,xsng,rc)
        if (rc == 0) exit
      end do
      call loind_cvb(norb,ion,nkion,mingion,maxgion,locion,lunion,indion,xion,rc)
      if (rc == 0) exit
    end do
  end do
  sum1 = Zero
  sum2 = Zero
  do ic=1,ncnfcas
    sum1 = sum1+gal1(ic)
    sum2 = sum2+gal2(ic)
  end do
  fac1 = One/sum1
  if ((abs(One-svb*svb) < 1.0e-20_wp) .and. (abs(sum2) < 1.0e-20_wp)) then
    fac2 = One
  else
    fac2 = (One-svb*svb)/sum2
  end if
  do ic=1,ncnfcas
    gal1(ic) = fac1*gal1(ic)
    gal2(ic) = fac2*gal2(ic)
  end do
end if

! Weights of Lowdin orthonormalized structures
if (btest(iciweights,1)) then
  call mxattb_cvb(orbs,orbs,norb,norb,norb,sorbs)
  call mxsqrt_cvb(sorbs,norb,1)
  call gaussj_cvb(sorbs,gjorb3)
  call applyt_cvb(civec,gjorb3)
  call applyt_cvb(civb,gjorb3)
  call cidot_cvb(civb,civb,cnrm)
  fac = svb/sqrt(cnrm)
  civb(1:) = civb(1:)**2
  civec(1:) = civec(1:)**2
end if

write(u6,'(/,2a)') ' Weights of CASSCF configurations in VB basis (c_res=c_cas-Svb*c_vb) :'
write(u6,'(2a)') ' ---------------------------------------------------------------------'
if (btest(iciweights,2)) then
  write(u6,'(a)') ' Sum of inverse-overlap weights :'
  write(u6,form2AD) ' c_cas :',sum1,' expected :',One
  write(u6,form2AD) ' c_res :',sum2,' expected :',One-svb*svb
  write(u6,'(a)') ' '
end if
lenfld = 8+iprec
ix1 = max(0,min(3,2*lenfld-16))
line = ''
if ((npcf > 0) .or. (npcf == -1)) then
  line(1:21) = '  Conf. =>  Orbitals '
  ibeg = max(14+3*nel,22)
  ibegt = ibeg
  if (btest(iciweights,0)) then
    line(ibegt+ix1:ibegt+2*lenfld-1) = 'Chirgwin-Coulson'
    ibegt = ibegt+2*lenfld
  end if
  if (btest(iciweights,1)) then
    line(ibegt+ix1:ibegt+2*lenfld-1) = 'Lowdin'
    ibegt = ibegt+2*lenfld
  end if
  if (btest(iciweights,2)) then
    line(ibegt+ix1:ibegt+2*lenfld-1) = 'Inverse'
    ibegt = ibegt+2*lenfld
  end if
  write(u6,'(a)') trim(line)
  line = ''
  if (btest(iciweights,0)) then
    line(ibeg+ix1:ibeg+lenfld-1) = 'c_cas'
    ibeg = ibeg+lenfld
    line(ibeg+ix1:ibeg+lenfld-1) = 'c_res'
    ibeg = ibeg+lenfld
  end if
  if (btest(iciweights,1)) then
    line(ibeg+ix1:ibeg+lenfld-1) = 'c_cas'
    ibeg = ibeg+lenfld
    line(ibeg+ix1:ibeg+lenfld-1) = 'c_res'
    ibeg = ibeg+lenfld
  end if
  if (btest(iciweights,2)) then
    line(ibeg+ix1:ibeg+lenfld-1) = 'c_cas'
    ibeg = ibeg+lenfld
    line(ibeg+ix1:ibeg+lenfld-1) = 'c_res'
    ibeg = ibeg+lenfld
  end if
  write(u6,'(a)') trim(line)
end if
line = ''

! Alpha weight array:
do iorb=0,norb
  mingrph(iorb) = max(iorb-norb+nalf,0)
  maxgrph(iorb) = min(iorb,nalf)
end do
call weight_cvb(xalf,mingrph,maxgrph,nalf,norb)
! Beta weight array:
do iorb=0,norb
  mingrph(iorb) = max(iorb-norb+nbet,0)
  maxgrph(iorb) = min(iorb,nbet)
end do
call weight_cvb(xbet,mingrph,maxgrph,nbet,norb)

call mma_deallocate(mingrph)
call mma_deallocate(maxgrph)

nc = 0
call mma_allocate(wghtion1,[ionmin,ionmax],label='wghtion1')
call mma_allocate(wghtion2,[ionmin,ionmax],label='wghtion2')
call mma_allocate(wghtion3,[ionmin,ionmax],label='wghtion3')
call mma_allocate(wghtion4,[ionmin,ionmax],label='wghtion4')
call mma_allocate(wghtion5,[ionmin,ionmax],label='wghtion5')
call mma_allocate(wghtion6,[ionmin,ionmax],label='wghtion6')
wghtion1(:) = Zero
wghtion2(:) = Zero
wghtion3(:) = Zero
wghtion4(:) = Zero
wghtion5(:) = Zero
wghtion6(:) = Zero
do ion=ionmin,ionmax
  nsing = nel-2*ion
  mrem = norb-ion
  nalfsng = nalf-ion
  nbetsng = nbet-ion
  ! Initialise loop for ionic orbitals
  do iorb=0,norb
    mingion(iorb) = max(iorb-norb+ion,0)
    maxgion(iorb) = min(iorb,ion)
  end do
  call weight_cvb(xion,mingion,maxgion,ion,norb)
  nkion(:) = maxgion(:)
  call occupy_cvb(nkion,norb,locion,lunion)
  ! Initialise loop for singly occupied orbitals
  do iorb=0,mrem
    mingsng(iorb) = max(iorb-mrem+nsing,0)
    maxgsng(iorb) = min(iorb,nsing)
  end do
  call weight_cvb(xsng,mingsng,maxgsng,nsing,mrem)
  nksng(:) = maxgsng(:)
  call occupy_cvb(nksng,mrem,locsng,lunsng)
  ! Initialise loop for singly occupied alpha orbitals
  do iorb=0,nsing
    mingasg(iorb) = max(iorb-nsing+nalfsng,0)
    maxgasg(iorb) = min(iorb,nalfsng)
  end do
  call weight_cvb(xasg,mingasg,maxgasg,nalfsng,nsing)
  nkasg(:) = maxgasg(:)
  call occupy_cvb(nkasg,nsing,locasg,lunasg)

  ! Loop ionic
  indion = 1
  do
    ! Loop singly occupied
    indsng = 1
    do
      c1 = Zero
      c2 = Zero
      c3 = Zero
      c4 = Zero
      ! Loop singly occupied alpha
      indasg = 1

      do
        iaocc(:) = 0
        ibocc(:) = 0
        do i=1,ion
          iaocc(locion(i)) = 1
          ibocc(locion(i)) = 1
        end do
        do ia=1,nalfsng
          iaorb = lunion(locsng(locasg(ia)))
          iaocc(iaorb) = 1
        end do
        do ib=1,nbetsng
          iborb = lunion(locsng(lunasg(ib)))
          ibocc(iborb) = 1
        end do
        inda = indget_cvb(iaocc,nalf,norb,xalf)
        indb = indget_cvb(ibocc,nbet,norb,xbet)

        indab = (indb-1)*nda+inda
        c1 = c1+citmp(indab)
        c2 = c2+civbs(indab)
        c3 = c3+civec(indab)
        c4 = c4+civb(indab)

        call loind_cvb(nsing,nalfsng,nkasg,mingasg,maxgasg,locasg,lunasg,indasg,xasg,rc)
        if (rc == 0) exit
      end do
      nc = nc+1
      wghtion1(ion) = wghtion1(ion)+c1
      wghtion2(ion) = wghtion2(ion)+c2
      wghtion3(ion) = wghtion3(ion)+c3
      wghtion4(ion) = wghtion4(ion)+c4
      wghtion5(ion) = wghtion5(ion)+gal1(nc)
      wghtion6(ion) = wghtion6(ion)+gal2(nc)
      if ((nc <= npcf) .or. (npcf == -1)) then
        call int2char_cvb(line,nc,7)
        line(9:10) = '=>'
        ilin = 11
        do i=1,ion
          call int2char_cvb(line(ilin:ilin+2),locion(i),3)
          ilin = ilin+3
          call int2char_cvb(line(ilin:ilin+2),locion(i),3)
          ilin = ilin+3
        end do
        do i=1,nsing
          call int2char_cvb(line(ilin:ilin+2),lunion(locsng(i)),3)
          ilin = ilin+3
        end do
        ilin = max(ilin,19)
        nprint = 0
        if (btest(iciweights,0)) then
          cprint(nprint+1) = c1
          cprint(nprint+2) = c2
          nprint = nprint+2
        end if
        if (btest(iciweights,1)) then
          cprint(nprint+1) = c3
          cprint(nprint+2) = c4
          nprint = nprint+2
        end if
        if (btest(iciweights,2)) then
          cprint(nprint+1) = gal1(nc)
          cprint(nprint+2) = gal2(nc)
          nprint = nprint+2
        end if
        write(u6,formAD) line(1:ilin),(cprint(mp),mp=1,nprint)
      end if
      call loind_cvb(mrem,nsing,nksng,mingsng,maxgsng,locsng,lunsng,indsng,xsng,rc)
      if (rc == 0) exit
    end do
    call loind_cvb(norb,ion,nkion,mingion,maxgion,locion,lunion,indion,xion,rc)
    if (rc == 0) exit
  end do
end do

call mma_deallocate(xalf)
call mma_deallocate(xbet)
call mma_deallocate(iaocc)
call mma_deallocate(ibocc)
call mma_deallocate(mingion)
call mma_deallocate(maxgion)
call mma_deallocate(nkion)
call mma_deallocate(xion)
call mma_deallocate(locion)
call mma_deallocate(lunion)
call mma_deallocate(mingsng)
call mma_deallocate(maxgsng)
call mma_deallocate(nksng)
call mma_deallocate(xsng)
call mma_deallocate(locsng)
call mma_deallocate(lunsng)
call mma_deallocate(mingasg)
call mma_deallocate(maxgasg)
call mma_deallocate(nkasg)
call mma_deallocate(xasg)
call mma_deallocate(locasg)
call mma_deallocate(lunasg)
call mma_deallocate(gal1)
call mma_deallocate(gal2)
call mma_deallocate(indavec)
call mma_deallocate(indbvec)

line = ' Accumulated weights:'
ibeg = 22
if (btest(iciweights,0)) then
  line(ibeg+ix1:ibeg+2*lenfld-1) = 'Chirgwin-Coulson'
  ibeg = ibeg+2*lenfld
end if
if (btest(iciweights,1)) then
  line(ibeg+ix1:ibeg+2*lenfld-1) = 'Lowdin'
  ibeg = ibeg+2*lenfld
end if
if (btest(iciweights,2)) then
  line(ibeg+ix1:ibeg+2*lenfld-1) = 'Inverse'
  ibeg = ibeg+2*lenfld
end if
write(u6,'(/,a)') trim(line)
line = ''
ibeg = 22
if (btest(iciweights,0)) then
  line(ibeg+ix1:ibeg+lenfld-1) = 'c_cas'
  ibeg = ibeg+lenfld
  line(ibeg+ix1:ibeg+lenfld-1) = 'c_res'
  ibeg = ibeg+lenfld
end if
if (btest(iciweights,1)) then
  line(ibeg+ix1:ibeg+lenfld-1) = 'c_cas'
  ibeg = ibeg+lenfld
  line(ibeg+ix1:ibeg+lenfld-1) = 'c_res'
  ibeg = ibeg+lenfld
end if
if (btest(iciweights,2)) then
  line(ibeg+ix1:ibeg+lenfld-1) = 'c_cas'
  ibeg = ibeg+lenfld
  line(ibeg+ix1:ibeg+lenfld-1) = 'c_res'
  ibeg = ibeg+lenfld
end if
write(u6,'(a)') trim(line)
line = ''
total1 = Zero
total2 = Zero
total3 = Zero
total4 = Zero
total5 = Zero
total6 = Zero
do ion=ionmin,ionmax
  total1 = total1+wghtion1(ion)
  total2 = total2+wghtion2(ion)
  total3 = total3+wghtion3(ion)
  total4 = total4+wghtion4(ion)
  total5 = total5+wghtion5(ion)
  total6 = total6+wghtion6(ion)
  line(1:19) = ' For ionicity    : '
  call int2char_cvb(line(14:16),ion,3)
  nprint = 0
  if (btest(iciweights,0)) then
    cprint(nprint+1) = wghtion1(ion)
    cprint(nprint+2) = wghtion2(ion)
    nprint = nprint+2
  end if
  if (btest(iciweights,1)) then
    cprint(nprint+1) = wghtion3(ion)
    cprint(nprint+2) = wghtion4(ion)
    nprint = nprint+2
  end if
  if (btest(iciweights,2)) then
    cprint(nprint+1) = wghtion5(ion)
    cprint(nprint+2) = wghtion6(ion)
    nprint = nprint+2
  end if
  write(u6,formAD) line(1:19),(cprint(mp),mp=1,nprint)
end do
nprint = 0
if (btest(iciweights,0)) then
  cprint(nprint+1) = total1
  cprint(nprint+2) = total2
  nprint = nprint+2
end if
if (btest(iciweights,1)) then
  cprint(nprint+1) = total3
  cprint(nprint+2) = total4
  nprint = nprint+2
end if
if (btest(iciweights,2)) then
  cprint(nprint+1) = total5
  cprint(nprint+2) = total6
  nprint = nprint+2
end if
write(u6,formAD) ' Total all       : ',(cprint(mp),mp=1,nprint)
write(u6,'(a)') ' '

call mma_deallocate(wghtion1)
call mma_deallocate(wghtion2)
call mma_deallocate(wghtion3)
call mma_deallocate(wghtion4)
call mma_deallocate(wghtion5)
call mma_deallocate(wghtion6)

return

end subroutine ciweight2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_VecBuf_Init_I(Frac,lVec,LocDbg)
!
! Purpose: allocate and initialize vector buffer.
!          (Internal run mode.)

use Cholesky, only: CHVBUF, ip_CHVBUF_SYM, l_CHVBUF_SYM, LuPri, MaxVec, nSym, nVec_in_Buf
use stdalloc, only: mma_allocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Frac
integer(kind=iwp), intent(in) :: lVec(*)
logical(kind=iwp), intent(in) :: LocDbg
integer(kind=iwp) :: iSym, l_ChVBuf = 0, l_Max, lVecTot, MemEach, MemLeft
real(kind=wp) :: x, xMemMax(8)
logical(kind=iwp) :: Enough
character(len=2) :: Unt
character(len=*), parameter :: SecNam = 'Cho_VecBuf_Init_I'

if (LocDbg) then
  write(Lupri,*) '>>>>> Enter ',SecNam,' <<<<<'
  write(Lupri,*) 'Memory fraction requested for buffer: ',Frac
  write(Lupri,'(A,I8)') 'nSym: ',nSym
  write(Lupri,'(A,8I8)') 'lVec: ',(lVec(iSym),iSym=1,nSym)
  call XFlush(Lupri)
end if

if ((nSym < 1) .or. (nSym > 8)) call Cho_Quit('nSym out of bounds in '//SecNam,102)

x = real(MaxVec,kind=wp)
lVecTot = lVec(1)
xMemMax(1) = real(lVec(1),kind=wp)*x
do iSym=2,nSym
  lVecTot = max(lVecTot,lVec(iSym))
  xMemMax(iSym) = real(lVec(iSym),kind=wp)*x
end do

if ((Frac <= Zero) .or. (Frac > One) .or. (lVecTot < 1)) then
  ip_ChVBuf_Sym(1:nSym) = 0
  l_ChVBuf_Sym(1:nSym) = 0
else
  call mma_MaxDBLE(l_Max)
  l_ChVBuf = int(Frac*real(l_Max,kind=wp))
  if ((l_ChVBuf < nSym) .or. (l_ChVBuf < lVecTot)) then
    l_ChVBuf = 0
    ip_ChVBuf_Sym(1:nSym) = 0
    l_ChVBuf_Sym(1:nSym) = 0
  else
    MemEach = l_ChVBuf/nSym
    Enough = all(MemEach > lVec(1:nSym))
    if (.not. Enough) then ! whole buffer for sym. 1
      l_ChVBuf_Sym(1) = l_ChVBuf
      l_ChVBuf_Sym(2:nSym) = 0
    else
      MemLeft = l_ChVBuf-nSym*MemEach
      l_ChVBuf_Sym(1) = MemEach+MemLeft
      if (real(l_ChVBuf_Sym(1),kind=wp) > xMemMax(1)) l_ChVBuf_Sym(1) = int(xMemMax(1))
      do iSym=2,nSym
        l_ChVBuf_Sym(iSym) = MemEach
        if (real(l_ChVBuf_Sym(iSym),kind=wp) > xMemMax(iSym)) l_ChVBuf_Sym(iSym) = int(xMemMax(iSym))
      end do
    end if
    l_ChVBuf = sum(l_ChVBuf_Sym(1:nSym))

    call mma_allocate(CHVBUF,l_ChVBuf,Label='CHVBUF')

    ip_ChVBuf_Sym(1) = 1
    do iSym=2,nSym
      ip_ChVBuf_Sym(iSym) = ip_ChVBuf_Sym(iSym-1)+l_ChVBuf_Sym(iSym-1)
    end do
  end if
end if

nVec_in_Buf(1:nSym) = 0

if (LocDbg) then
  call Cho_Word2Byte(l_ChVBuf,8,x,Unt)
  write(Lupri,*) 'Memory allocated for buffer: ',l_ChVBuf,'(',x,Unt,') at ',1
  write(Lupri,'(A,8I8)') 'l_ChVBuf_Sym : ',(l_ChVBuf_Sym(iSym),iSym=1,nSym)
  write(Lupri,'(A,8I8)') 'ip_ChVBuf_Sym: ',(ip_ChVBuf_Sym(iSym),iSym=1,nSym)
  write(Lupri,*) '>>>>> Exit  ',SecNam,' <<<<<'
  call XFlush(Lupri)
end if

end subroutine Cho_VecBuf_Init_I

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Period
! mAdCell, lthCell - information on atoms in the unit cell
! If iAt = 1..lthCell, then
!    iWork(mAdCell+(iAt-1)) - total sequence # of the cell's atom in the full list
! VCell   - unit cell vectors
! ispread - how many steps to spread the unit cell along each unit cell vector

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: ispread(3), lthCell, mAdCell
real(kind=wp) :: VCell(3,3)
logical(kind=iwp) :: Cell_l
integer(kind=iwp), allocatable :: AdCell(:)

public :: AdCell, Cell_l, ispread, lthCell, mAdCell, VCell

end module Period

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dCdC(JJ,ICOORD,NESFJ,DC,Sphere,NewSph)

use Constants, only: One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: JJ, ICOORD, NESFJ, NewSph(2)
real(kind=wp), intent(out) :: DC
real(kind=wp), intent(in) :: Sphere(4,*)
integer(kind=iwp) :: K, NSK
real(kind=wp) :: COORDJ(3), COORDK(3), D, D2

! Trova la derivata della coordinata JJ del centro della sfera
! NewSph rispetto alla coordinata ICOORD di NSJ, che interseca NewSph.
!
! La sfera NewSph (che appartiene alle sfere "aggiunte" da PEDRA)
! dipende dalle due sfere "precedenti" NESFJ e NSK
!
! Se NESFJ o NSK sono negativi, la sfera aggiunta e' di tipo C
! e la generatrice "principale" corrisponde al label negativo
! (cfr. JCC 11, 1047 (1990))

if ((NEWSPH(1) < 0) .or. (NEWSPH(2) < 0)) then
  NSK = NEWSPH(1)
  if (abs(NSK) == NESFJ) NSK = NEWSPH(2)
  COORDJ(:) = Sphere(1:3,NESFJ)
  COORDK(:) = Sphere(1:3,abs(NSK))
  D2 = (COORDJ(1)-COORDK(1))**2+(COORDJ(2)-COORDK(2))**2+(COORDJ(3)-COORDK(3))**2
  D = sqrt(D2)
  if (NSK > 0) then
    DC = Sphere(4,NESFJ)*(COORDJ(JJ)-COORDK(JJ))*(COORDJ(ICOORD)-COORDK(ICOORD))/D**3
    if (ICOORD == JJ) DC = DC+One-Sphere(4,NESFJ)/D
  else
    DC = -Sphere(4,abs(NSK))*(COORDK(JJ)-COORDJ(JJ))*(COORDK(ICOORD)-COORDJ(ICOORD))/D**3
    if (ICOORD == JJ) DC = DC+Sphere(4,abs(NSK))/D
  end if
else
  K = NEWSPH(1)
  if (K == NESFJ) K = NEWSPH(2)
  COORDJ(:) = Sphere(1:3,NESFJ)
  COORDK(:) = Sphere(1:3,K)
  D2 = (COORDJ(1)-COORDK(1))**2+(COORDJ(2)-COORDK(2))**2+(COORDJ(3)-COORDK(3))**2
  D = sqrt(D2)
  DC = (Sphere(4,NESFJ)-Sphere(4,K))*(COORDJ(ICOORD)-COORDK(ICOORD))*(COORDJ(JJ)-COORDK(JJ))/(Two*D**3)
  if (JJ == ICOORD) DC = DC+Half-(Sphere(4,NESFJ)-Sphere(4,K))/(Two*D)
end if

return

end subroutine dCdC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Step2(iMatrix,SMatrix,nDim,TMatrix,iType,
     &                 SMatrix_Save,Temp)
*                                                                      *
************************************************************************
*                                                                      *
*     Step 2. LO S0 ->S1
*     occupied virtual on the same center
*     and orthonormalization of the original AO basis
*     The call to lowdin gives me a transforation A1, and a transformed
*     S matrix
*
      Implicit ReaL*8 (A-H,O-Z)
      Real*8 SMatrix(nDim*nDim),TMatrix(nDim*nDim),
     &       Temp(nDim*nDim), SMatrix_Save(nDim*nDim)
      Integer iMatrix(nDim),iType(nDim)
#include "real.fh"
*
clg     write (*,*) 'Step 2', nDim
clg     Call RecPrt('Save before LW 2',' ',SMatrix_Save,nDim,nDim)
clg     write (*,*)
         k=0
      Do i=1,nDim
         Do j=1,nDim
             k=k+1
c               write (*,*) iMatrix(i),iMatrix(j), SMatrix(k)
             if ((iMatrix(i).ne.iMatrix(j)) .and.
     &        (iType(i).ne.iType(j)))  then
                SMatrix(k)=Zero
            endif
         End Do
      End Do
clg   Call RecPrt('SMatrix before LW 2',' ',SMatrix,nDim,nDim)
clg   Call RecPrt('SMatrix_Save before LW 2',' ',SMatrix_Save,nDim,nDim)


      call dcopy_(nDim**2,[Zero],0,TMatrix,1)
      call dcopy_(nDim,[One],0,TMatrix,nDim+1)
      Call Lowdin(SMatrix,TMatrix,nDim)
*     Pick up S2
clg   Call RecPrt('SMatrix after LW 2',' ',SMatrix,nDim,nDim)
clg   Call RecPrt('TMatrix after LW 2',' ',TMatrix,nDim,nDim)
      call dcopy_(nDim**2,SMatrix_Save,1,SMatrix,1)
*
*     Now apply T2 to S2:  S3=T2(T)*S2*T2
*
      Call FZero(Temp,nDim**2)
      Call DGEMM_('N','N',
     &            nDim,nDim,nDim,
     &            1.0d0,SMatrix,nDim,
     &            TMatrix,nDim,
     &            0.0d0,Temp,nDim)
      Call DGEMM_('T','N',
     &            nDim,nDim,nDim,
     &            1.0d0,TMatrix,nDim,
     &            Temp,nDim,
     &            0.0d0,SMatrix,nDim)
C     Call RecPrt('S3',' ',Work(ip_s),nBas(1),nBas(1))
      call dcopy_(nDim**2,SMatrix,1,SMatrix_Save,1)


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE  SYMCM2(i1,i2,i3,i4,i5)
      Call SysAbendMsg('syscm2',
     & ' Entering dummy SYMCM2 is fatal for me',' ')
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(i1)
         Call Unused_integer(i2)
         Call Unused_integer(i3)
         Call Unused_integer(i4)
         Call Unused_integer(i5)
      End If
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Free_Tsk2(id)

use RI_glob, only: iOpt, nTask, TskList
use stdalloc, only: mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: id

if (iOpt == 0) then
  call Free_Tsk(id)
else if (iOpt == 1) then
  call mma_deallocate(TskList)
  nTask = 0
else
  call WarningMessage(2,'Error in Free_Tsk2')
  write(u6,*) 'Free_Tsk2: illegal iOpt value!'
  call Abend()
end if
iOpt = -1

return

end subroutine Free_Tsk2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pa_pseudo(M,S,d,iopt,zfin,MF,SF,coord,iprint)
! d - dimension of the pseudospin
! M(3,d,d) -- magnetic moment in the initial basis
! S(3,d,d) -- spin moment in the initial basis
! iopt - option for choosing the quantization axis
!       = 1 : quantization axis is the main magnetic axis of the entire manifold (d)
!       = 2 : quantization axis is the main magnetic axis of the ground doublet (low-lying two states)
!       = 3 : quantization axis is provided by the user by means of coord
!       = 4 : quantization axis is the unit matrix, i.e. the original Z axis
!  coord(3,3): matrix specifying the rotation of initial coordinate system to the
!              coordinate system of used for determination of the quantization axis
!              by diagonalizing the Zeeman hamiltonian
! zfin - pseudospin eigenfunctions
! MF(3,d,d) -- magnetic moment in the pseudospin basis
! SF(3,d,d) -- spin moment in the pseudospin basis

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: d, iopt, iprint
complex(kind=wp), intent(in) :: M(3,d,d), S(3,d,d)
complex(kind=wp), intent(out) :: zfin(d,d), MF(3,d,d), SF(3,d,d)
real(kind=wp), intent(inout) :: coord(3,3)
integer(kind=iwp) :: i, i1, i2, info, j, k
real(kind=wp) :: coord2(3,3), det, gtens(3), maxes(3,3)
complex(kind=wp) :: MM(3,2,2)
real(kind=wp), allocatable :: w(:)
complex(kind=wp), allocatable :: dipso2(:,:,:), hzee(:,:), s_so2(:,:,:), z(:,:)
real(kind=wp), external :: FindDetR
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

call mma_allocate(w,d,label='w')
call mma_allocate(dipso2,3,d,d,label='dipso2')
call mma_allocate(hzee,d,d,label='hzee')
call mma_allocate(s_so2,3,d,d,label='s_so2')
call mma_allocate(z,d,d,label='z')

! set to zero important variables:
! choose the quantization axis:
if (iopt == 1) then
  call atens(M,d,gtens,maxes,2)

else if (iopt == 2) then
  MM(:,:,:) = M(:,1:2,1:2)
  call atens(MM,2,gtens,maxes,2)

else if (iopt == 3) then
  write(u6,'(A)') 'User provided the COORD to the PA_PSEUDo:'

else if (iopt == 4) then
  write(u6,'(A)') 'COORD is set to unity'
  call unitmat(coord,3)
else
  write(u6,'(A)') 'check the iopt parameter to PA_PSEUDo!!!'
  !call Abort()
end if
!ccccccccccccccccccccccccccccccccccc
write(u6,'(A)') 'input "coord" matrix to PA_PSEUDo'
do i=1,3
  write(u6,'(3F20.14)') (coord(j,i),j=1,3)
end do
! check If "coord" is empty:
coord2(:,:) = coord(:,:)
det = FindDetR(coord2,3)
write(u6,'(A, f20.13)') 'det = ',det
if (abs(det-One) < 1.0e-4_wp) then  ! 'coord is not empty'
  maxes(:,:) = coord(:,:)
else                                ! 'coord is empty'
  coord(:,:) = maxes(:,:)
end if
write(u6,'(A)') 'Employed  axes for diagonalization of the Zeeman Hamiltonian:'
do i=1,3
  write(u6,'(3F20.14)') (maxes(j,i),j=1,3)
end do

do i=1,d
  do j=1,d
    do k=1,3
      dipso2(:,i,j) = dipso2(:,i,j)+M(k,i,j)*(maxes(k,:)*cOne)
      s_so2(:,i,j) = s_so2(:,i,j)+S(k,i,j)*(maxes(k,:)*cOne)
    end do
  end do
end do

hzee(:,:) = hzee(:,:)-dipso2(3,:,:)
info = 0
w(:) = Zero
z(:,:) = cZero
call diag_c2(hzee,d,info,w,z)
if (info /= 0) then
  write(u6,'(5x,a)') 'diagonalization of the zeeman hamiltonian failed.'
else

  call spin_phase(dipso2,d,z,zfin)

  if (iprint > 2) then
    write(u6,'(5X,A)') 'MAIN VALUES OF THE ZEEMAN HAMILTONIAN:'
    write(u6,*)
    if (mod(d,2) == 1) then
      do I=1,d
        write(u6,'(3X,A,I3,A,F17.3)') '|',(d-1)/2+(1-I),'> = ',W(i)
      end do
    else
      do I=1,d
        write(u6,'(3X,A,I3,A,F17.3)') '|',(d-1)-2*(I-1),'/2 > = ',W(i)
      end do
    end if
    write(u6,*)
    write(u6,'(1X,A)') 'EIGENFUNCTIONS OF THE EFFECTIVE SPIN:'
    write(u6,*)
    if (mod(d,2) == 1) then
      do i=1,d
        write(u6,'(10x,a,i2,a,10x,20(2f16.12,2x))') 'eigenvector of |',(d-1)/2+(1-i),' > :',(zfin(j,i),j=1,d)
      end do
    else
      do i=1,d
        write(u6,'(10x,a,i2,a,10x,20(2f16.12,2x))') 'eigenvector of |',(d-1)-2*(i-1),'/2 > :',(zfin(j,i),j=1,d)
      end do
    end if
  end if ! printing of eigenfunctions with identical phase.

  MF(:,:,:) = Zero
  SF(:,:,:) = Zero
  do i=1,d
    do j=1,d
      do i1=1,d
        do i2=1,d
          MF(:,i,j) = MF(:,i,j)+dipso2(:,i1,i2)*conjg(zfin(i1,i))*zfin(i2,j)
          SF(:,i,j) = SF(:,i,j)+s_so2(:,i1,i2)*conjg(zfin(i1,i))*zfin(i2,j)
        end do
      end do
    end do
  end do

  if (IPRINT > 2) then
    call prMom('PseudoSpin basis:  MAGNETIC MOMENT: MF :',MF,d)
    call prMom('PseudoSpin basis:      SPIN MOMENT: SF :',SF,d)
  end if
end if

call mma_deallocate(w)
call mma_deallocate(dipso2)
call mma_deallocate(hzee)
call mma_deallocate(s_so2)
call mma_deallocate(z)

return

end subroutine pa_pseudo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE IIJJ_CPF(ICASE,JSY,HDIAG,FC,FIJ,FJI)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION JSY(*),HDIAG(*),FC(*),FIJ(*),FJI(*)
      DIMENSION ICASE(*)
      DIMENSION IOC(55)
*
      JO(L)=ICUNP(ICASE,L)
      JSYM(L)=JSUNP_CPF(JSY,L)
*
      IAD27=0
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      IRL=IRC(ILIM)

      DO 100 IR=1,IRL
        DO I=1,LN
          JOJ=JO(I+LN*(IR-1))
          IOC(I)=(JOJ+1)/2
        END DO
        NSS=MUL(JSYM(IR),LSYM)

        SUM=0.0D0
        DO I=1,LN
          IF(IOC(I).NE.0) THEN
            DO J=1,I-1
              IJ=(I*(I-1))/2+J
              IF(IOC(J).NE.0) THEN
                TERM=IOC(I)*(IOC(J)*FIJ(IJ)-FJI(IJ))
                SUM=SUM+TERM
              END IF
            END DO
            II=(I*(I+1))/2
            TERM=(IOC(I)-1)*FIJ(II)+IOC(I)*FC(II)
            SUM=SUM+TERM
          END IF
        END DO

        IF(IR.GT.IRC(1))GO TO 120
C IR=1..IRC(1), HDIAG(IR)=SUM
        HDIAG(IR)=SUM
        IF(IR.EQ.IRC(1))CALL dDAFILE(Lu_27,1,HDIAG,IRC(1),IAD27)
        GO TO 100

120     CONTINUE
        IF(IR.GT.IRC(2))GO TO 130
C IR=IRC(1)+1 ... IRC(2)
        IND=0
        NA1=NSYS(NSS)+1
        NA2=NSYS(NSS+1)
        IF(NA2.LT.NA1)GO TO 100
        DO NA=NA1,NA2
          IND=IND+1
          IA=IROW(LN+NA)
          SUM1=SUM+FC(IA+LN+NA)
          DO I=1,LN
          IF(IOC(I).NE.0) SUM1=SUM1+
     &                  IOC(I)*FIJ(IA+I)-FJI(IA+I)
          END DO
          HDIAG(IND)=SUM1
        END DO
        CALL dDAFILE(Lu_27,1,HDIAG,IND,IAD27)
        GO TO 100

130     CONTINUE
C IR=IRC(2)+1 ... IRC(ILIM)
        IND=0
        DO NA=1,NVIRT
          NSA=MUL(NSS,NSM(LN+NA))
          NB1=NSYS(NSA)+1
          NB2=NSYS(NSA+1)
          IF(NB2.GT.NA)NB2=NA
          IF(NB2.LT.NB1)GO TO 141
          IA=IROW(LN+NA)
          IAV=IA+LN
          DO NB=NB1,NB2
            IND=IND+1
            IB=IROW(LN+NB)
            IBV=IB+LN
            TERM=SUM+FIJ(IAV+NB)+FC(IAV+NA)+FC(IBV+NB)
            IF(IR.LE.IRC(3))SUM1=TERM-FJI(IAV+NB)
            IF(IR.GT.IRC(3))SUM1=TERM+FJI(IAV+NB)
            DO I=1,LN
              IF(IOC(I).NE.0) THEN
                TERM=IOC(I)*(FIJ(IA+I)+FIJ(IB+I))-FJI(IA+I)-FJI(IB+I)
                SUM1=SUM1+TERM
              END IF
            END DO
            HDIAG(IND)=SUM1
          END DO
141       CONTINUE
        END DO
        IF(IND.GT.0)CALL dDAFILE(Lu_27,1,HDIAG,IND,IAD27)
100   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine m1Grd_mck( &
#                    define _CALLING_
#                    include "grd_mck_interface.fh"
                    )
!***********************************************************************
!                                                                      *
! Object: to compute the gradient of the nuclear attraction integrals. *
!          Something is wrong here                                     *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             October 1991                                             *
!              Anders Bernhardsson 1995                                *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_mck_interface.fh"
integer(kind=iwp) :: iAng(4), iBeta, iCnt, iDCRT(0:7), inddum(3,4,3,4,8), ipA, ipAOff, ipB, ipBOff, iuvwx(4), JndGrd(3,4,0:7), &
                     mOp(4), kCnt, kCnttp, kdc, kndgrd(3,4,0:7), lDCRT, LmbdT, nDCRT, nip, nRys
logical(kind=iwp) :: DiffCnt, ifdum(3,4,3,4), jfg(4), JfGrd(3,4), kfgrd(3,4), Tr(4)
real(kind=wp) :: C(3), CoorAC(3,2), Coori(3,4), Dum(1), Fact, TC(3)
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(ZInv)
unused_var(Ccoor)
unused_var(nOrdOp)
unused_var(Trans)

!if (iPrint >= 99) then
!  write(u6,*) ' In NAGrd: nArr=',nArr
!end if
inddum(:,:,:,:,:) = 0
ifdum(:,:,:,:) = .false.

nRys = nHer

nip = 1
ipA = nip
nip = nip+nAlpha*nBeta
ipB = nip
nip = nip+nAlpha*nBeta
if (nip-1 > nArr) write(u6,*) ' nip-1 > nArr'

iAng(1) = la
iAng(2) = lb
iAng(3) = 0
iAng(4) = 0
! Dummies

Coori(:,1) = A
Coori(:,2) = RB
if (la >= lb) then
  CoorAC(:,1) = A
else
  CoorAC(:,1) = RB
end if
iuvwx(1) = iu
iuvwx(2) = iv
mOp(1) = nOp(1)
mOp(2) = nOp(2)

ipAOff = ipA
do iBeta=1,nBeta
  Array(ipAOff:ipAOff+nAlpha-1) = Alpha
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB
do iBeta=1,nBeta
  Array(ipBOff:ipBOff+nAlpha-1) = Beta(iBeta)
  ipBOff = ipBOff+nAlpha
end do

! Loop over nuclear centers

kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (.not. dbsc(kCnttp)%ECP) cycle
  if (dbsc(kCnttp)%nM1 == 0) cycle

  do kCnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
    DiffCnt = (IfGrad(iDCar,1) .or. IfGrad(iDCar,2))
    if ((.not. DiffCnt) .and. (kdc+kCnt /= iDCnt)) cycle

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    !Fact = -dbsc(kCnttp)%Charge*real(nStabM*nIrrep,kind=wp)/real(LmbdT*dc(kdc+kCnt)%nStab,kind=wp)
    Fact = -dbsc(kCnttp)%Charge*real(nStabM,kind=wp)/real(LmbdT,kind=wp)
    !if (iPrint >= 99) then
    !   write(u6,*) ' Charge=',dbsc(kCnttp)%Charge
    !   write(u6,*) 'NZeta=',nzeta
    !   write(u6,*) 'NrOp=',nrop
    !   write(u6,*) ' Fact=',Fact
    !end if
    iuvwx(3) = dc(kdc+kCnt)%nStab
    iuvwx(4) = dc(kdc+kCnt)%nStab
    JfGrd(:,:) = .false.
    JndGrd(:,:,0:nIrrep-1) = 0
    JfGrd(iDCar,1:2) = IfGrad(iDCar,1:2)
    do ICnt=1,2
      if (IfGrad(iDCar,iCnt)) JndGrd(iDCar,iCnt,0:nIrrep-1) = IndGrd(0:nIrrep-1)
    end do

    Tr(1) = .false.
    Tr(2) = .false.
    Tr(3) = .false.
    Tr(4) = .false.
    if ((kdc+kCnt) == iDCnt) then
      Tr(3) = .true.
      JfGrd(iDCar,1:2) = .true.
      JndGrd(iDCar,3,0:nIrrep-1) = -IndGrd(0:nIrrep-1)
    end if

    do lDCRT=0,nDCRT-1
      kfGrd(:,:) = JfGrd
      kndgrd(:,:,0:nIrrep-1) = JndGrd(:,:,0:nIrrep-1)
      mOp(3) = NrOpr(iDCRT(lDCRT))
      mOp(4) = mOp(3)
      call OA(iDCRT(lDCRT),C,TC)
      CoorAC(:,2) = TC
      Coori(:,3) = TC
      Coori(:,4) = TC
      if (Eq(A,RB) .and. EQ(A,TC)) cycle
      if (EQ(A,TC)) then
        kfGrd(iDCar,1) = .false.
        kndGrd(iDCar,1,0:nIrrep-1) = 0
      end if
      if (EQ(RB,TC)) then
        kfGrd(iDCar,2) = .false.
        kndGrd(iDCar,2,0:nIrrep-1) = 0
      end if

      if (kfGrd(idcar,1)) then
        JFG(1) = .true.
      else
        JFG(1) = .false.
      end if
      if (kfGrd(idcar,2)) then
        JFG(2) = .true.
      else
        JFG(2) = .false.
      end if
      JFG(3) = .false.
      JFG(4) = .false.

      call M1Kernel(rFinal,Dum,0,Dum,0,iAng,nRys,nZeta,Array(ipA),Array(ipB),Zeta,rKappa,P,TC,Coori,Coorac,Array(nip),nArr-nip+1, &
                    kfgrd,kndgrd,ifdum,inddum,jfg,tr,mop,iuvwx,kCnttp,fact,loper,idcar)

    end do
  end do
end do

return

end subroutine m1Grd_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Fock_CoulombErrorAnalysis(ComputeF,
     &                                         Mode,PackedD,PackedF,
     &                                         nD,FactC,ip_D,ip_F)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: analyze Coulomb error
C
C              F(uv)-Ftilde(uv)= FactC * sum_kl { (uv|kl)
C                                                -[uv|kl] } * D(kl)
C
C              where [uv|kl] are the LDF integrals, and compare to
C              the upper bound.
C
C     If ComputF: the LDF Fock matrix is computed here
C     Else: on input, ip_F should point to the Fock matrix computed from
C     LDF integrals (replaced with the error on exit)!
C
      Implicit None
      Logical ComputeF
      Integer Mode
      Logical PackedD
      Logical PackedF
      Integer nD
      Real*8  FactC(nD)
      Integer ip_D(nD)
      Integer ip_F(nD)
#include "WrkSpc.fh"
#include "localdf_bas.fh"

      Character*29 SecNam
      Parameter (SecNam='LDF_Fock_CoulombErrorAnalysis')

      real*8 ddot_
      external ddot_

      Logical PrintNorm
      Parameter (PrintNorm=.False.)

      Real*8 Stat(7,3)
      Real*8 RMS1, RMS2, RMS3

      Logical Add
      Logical Packed_myF

      Integer ip_myF, l_myF
      Integer ipF, lF
      Integer iD
      Integer i

      If (nD.lt.1) Return

      ! Compute error
      Call LDF_Fock_CoulombError(PrintNorm,ComputeF,
     &                           Mode,PackedD,PackedF,
     &                           nD,FactC,ip_D,ip_F)

      ! Compute upper bound
      Add=.False.
      Packed_myF=PackedF
      l_myF=nD
      Call GetMem('CEAmyFP','Allo','Inte',ip_myF,l_myF)
      If (Packed_myF) Then
         lF=nBas_Valence*(nBas_Valence+1)/2
      Else
         lF=nBas_Valence**2
      End If
      Do iD=1,nD
         Call GetMem('CEAmyF','Allo','Real',ipF,lF)
         iWork(ip_myF-1+iD)=ipF
      End Do
      Call LDF_Fock_CoulombUpperBound_Full(PrintNorm,
     &                                     Add,PackedD,Packed_myF,
     &                                     nD,FactC,ip_D,iWork(ip_myF))

      ! Analysis
      Call Cho_Head('Coulomb Error','-',80,6)
      Do iD=1,nD
         Call Statistics(Work(iWork(ip_myF-1+iD)),lF,Stat(1,1),
     &                   1,2,3,4,5,6,7)
         RMS1=dDot_(lF,Work(iWork(ip_myF-1+iD)),1,
     &                Work(iWork(ip_myF-1+iD)),1)
         Call Statistics(Work(ip_F(iD)),lF,Stat(1,2),1,2,3,4,5,6,7)
         RMS2=dDot_(lF,Work(ip_F(iD)),1,
     &                Work(ip_F(iD)),1)
         Do i=1,lF
            Work(iWork(ip_myF-1+iD)-1+i)=Work(iWork(ip_myF-1+iD)-1+i)
     &                                  -abs(Work(ip_F(iD)-1+i))
         End Do
         Call Statistics(Work(iWork(ip_myF-1+iD)),lF,Stat(1,3),
     &                   1,2,3,4,5,6,7)
         RMS3=dDot_(lF,Work(iWork(ip_myF-1+iD)),1,
     &                Work(iWork(ip_myF-1+iD)),1)
         Write(6,'(/,2X,A,I10,A)')
     &   'Coulomb error for density',iD,' (Upper bound,Actual,Diff):'
         Write(6,'(2X,A,1P,3D20.10)')
     &   'Average error......',Stat(1,1),Stat(1,2),Stat(1,3)
         Write(6,'(2X,A,1P,3D20.10)')
     &   'Abs average error..',Stat(2,1),Stat(2,2),Stat(2,3)
         Write(6,'(2X,A,1P,3D20.10)')
     &   'Min error..........',Stat(3,1),Stat(3,2),Stat(3,3)
         Write(6,'(2X,A,1P,3D20.10)')
     &   'Max error..........',Stat(4,1),Stat(4,2),Stat(4,3)
         Write(6,'(2X,A,1P,3D20.10)')
     &   'Max abs error......',Stat(5,1),Stat(5,2),Stat(5,3)
         Write(6,'(2X,A,1P,3D20.10)')
     &   'Variance...........',Stat(6,1),Stat(6,2),Stat(6,3)
         Write(6,'(2X,A,1P,3D20.10)')
     &   'Norm...............',sqrt(RMS1),sqrt(RMS2),sqrt(RMS3)
         If (lF.gt.0) Then
            RMS1=sqrt(RMS1/dble(lF))
            RMS2=sqrt(RMS2/dble(lF))
            RMS3=sqrt(RMS3/dble(lF))
         Else
            RMS1=0.0d0
            RMS2=0.0d0
            RMS3=0.0d0
         End If
         Write(6,'(2X,A,1P,3D20.10)')
     &   'RMS error..........',RMS1,RMS2,RMS3
         Call xFlush(6)
         If ((Stat(5,1)-Stat(5,2)).lt.0.0d0) Then
            If (abs(Stat(5,1)-Stat(5,2)).gt.1.0d-6) Then
               Call WarningMessage(2,
     &           SecNam//': max abs error is greater than upper bound!')
               Call LDF_Quit(1)
            End If
         End If
      End Do

      ! Deallocations
      Do iD=1,nD
         ipF=iWork(ip_myF-1+iD)
         Call GetMem('CEAmyF','Free','Real',ipF,lF)
      End Do
      Call GetMem('CEAmyFP','Free','Inte',ip_myF,l_myF)

      End
      Subroutine LDF_Fock_CoulombError(PrintNorm,ComputeF,
     &                                 Mode,PackedD,PackedF,
     &                                 nD,FactC,ip_D,ip_F)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: compute Coulomb error
C
C              F(uv)-Ftilde(uv)= FactC * sum_kl { (uv|kl)
C                                                -[uv|kl] } * D(kl)
C
C              where [uv|kl] are the LDF integrals.
C
C     If ComputF: the LDF Fock matrix is computed here
C     Else: on input, ip_F should point to the Fock matrix computed from
C     LDF integrals (replaced with the error on exit)!
C
      Implicit None
      Logical PrintNorm
      Logical ComputeF
      Integer Mode
      Logical PackedD
      Logical PackedF
      Integer nD
      Real*8  FactC(nD)
      Integer ip_D(nD)
      Integer ip_F(nD)
#include "WrkSpc.fh"
#include "localdf_bas.fh"

      real*8 ddot_
      external ddot_

      Logical Timing
      Logical Add

      Integer IntegralOption
      Integer ip_myF, l_myF
      Integer ipF, lF
      Integer iD

      Real*8  ThrPS(2)

      If (ComputeF) Then
         IntegralOption=0
         Timing=.False.
         ThrPS(1)=0.0d0
         ThrPS(2)=0.0d0
         Add=.False.
         Call LDF_Fock_CoulombOnly(IntegralOption,
     &                             Timing,Mode,ThrPS,
     &                             Add,PackedD,PackedF,
     &                             nD,FactC,ip_D,ip_F)
      End If

      If (PackedF) Then
         lF=nBas_Valence*(nBas_Valence+1)/2
      Else
         lF=nBas_Valence**2
      End If
      l_myF=nD
      Call GetMem('myFPtr','Allo','Inte',ip_myF,l_myF)
      Do iD=1,nD
         Call GetMem('myF','Allo','Real',ipF,lF)
         iWork(ip_myF-1+iD)=ipF
      End Do
      IntegralOption=222 ! use conventional integrals
      Timing=.False.
      ThrPS(1)=0.0d0
      ThrPS(2)=0.0d0
      Add=.False.
      Call LDF_Fock_CoulombOnly(IntegralOption,
     &                          Timing,Mode,ThrPS,
     &                          Add,PackedD,PackedF,
     &                          nD,FactC,ip_D,iWork(ip_myF))
      Do iD=1,nD
         ipF=iWork(ip_myF-1+iD)
         Call dAXPY_(lF,-1.0d0,Work(ipF),1,Work(ip_F(iD)),1)
         Call dScal_(lF,-1.0d0,Work(ip_F(iD)),1)
      End Do
      Do iD=1,nD
         ipF=iWork(ip_myF-1+iD)
         Call GetMem('myF','Free','Real',ipF,lF)
      End Do
      Call GetMem('myFPtr','Free','Inte',ip_myF,l_myF)

      If (PrintNorm) Then
         Do iD=1,nD
            Write(6,'(A,I10,A,1P,D20.10)')
     &      'Norm of Coulomb error for density',iD,':',
     &      sqrt(dDot_(lF,Work(ip_F(iD)),1,Work(ip_F(iD)),1))
         End Do
         Call xFlush(6)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Stefano Battaglia                                *
************************************************************************
      subroutine wgtinit(H)
      implicit real(8) (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

      real(8) H(Nstate,Nstate)


      if (IPRGLB.GE.DEBUG) then
        write(6,*)' Entered wgtinit.'
      end if

* Initialize array of weights with all zeros
      call dcopy_(Nstate**2,[0.0D0],0,WORK(LDWGT),1)

* Main loop over all states to compute the weights
      do I=1,Nstate

* If it is an XDW-CASPT2 calculation, the weights are computed
        if (IFDW.and.zeta.ge.0.0d0) then
          Ebeta = H(I,I)
* Compute normalization factor
          do J=1,Nstate
            Ealpha = H(J,J)
            factor = 0.0D0
            do K=1,Nstate
              Egamma = H(K,K)
              factor = factor + exp(-zeta*(Ealpha - Egamma)**2)
            end do
            IJ = (I-1) + Nstate*(J-1)
* Compute weight according to XDW prescription
            WORK(LDWGT+IJ) = exp(-zeta*(Ealpha - Ebeta)**2)/factor
          end do

* If it is an XMS-CASPT2 calculation, all the weights are equal,
* i.e. they all are 1/Nstate
        else if (IFXMS.and.(.not.IFDW)) then
          call dcopy_(Nstate**2,[1.0D0/Nstate],0,WORK(LDWGT),1)

* If it is a normal MS-CASPT2 or a (X)DW-CASPT2 with zeta->infinity
* the weight vectors are the standard unit vectors e_1, e_2, ...
        else
          WORK(LDWGT + (Nstate*(I-1)) + (I-1)) = 1.0d0
        end if

* End of loop over states
      end do

* In case it is a XDW calculation, print out the weights
      if (IFDW.and.(IPRGLB.ge.VERBOSE)) then
        if (IFEFOCK) then
          write(6,*)' Weights calculated with <I|H0|I>:'
        else
          write(6,*)' Weights calculated with <I|H|I>:'
        end if
        call prettyprint(WORK(LDWGT),Nstate,Nstate)
      end if


      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Compute_Tr_Dab(nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &                          CMO,OrbE,TrD)
      use definitions, only: iwp, wp
      use constants, only: Zero, One
      use stdalloc, only: mma_allocate, mma_deallocate
      Implicit None
      integer(kind=iwp), intent(in):: nSym, nBas(nSym), nFro(nSym),
     &                                nIsh(nSym), nAsh(nSym),
     &                                nSsh(nSym), nDel(nSym)
      real(kind=wp), intent(in)::  CMO(*), OrbE(*)
      real(kind=wp), intent(out):: TrD(nSym)

      integer(kind=iwp) nAct(8), lnOrb(8), lnOcc(8), lnFro(8), lnDel(8),
     &                           lnVir(8)
      real(kind=wp), Allocatable:: EOrb(:), DMat(:), CMON(:)
      real(kind=wp) Dummy
      integer(kind=iwp) iE, ifr, ioff, ip_Y, irc, iSkip, iSym, ito, iV,
     &                  joff, k, kEOcc, kEVir, kfr, koff, kto, nBB, nOA,
     &                  nOrb, nVV
      real(kind=wp), external:: DDot_
*
      nAct(:)=0
      nVV=0
      nOrb=0
      Do iSym=1,nSym
         iE=1+nOrb+nFro(iSym)+nIsh(iSym)
         Do k=0,nAsh(iSym)-1
            If (OrbE(iE+k).lt.Zero) nAct(iSym)=nAct(iSym)+1
         End Do
         nVV=nVV+nSsh(iSym)**2
         nOrb=nOrb+nBas(iSym)
      End Do
*
      nBB=0
      nOA=0
      Do iSym=1,nSym  ! setup info
         lnOrb(iSym)=nBas(iSym)
         lnFro(iSym)=nFro(iSym)
         lnOcc(iSym)=nIsh(iSym)+nAct(iSym)
         lnVir(iSym)=nSsh(iSym)
         lnDel(iSym)=nDel(iSym)
         nBB=nBB+nBas(iSym)**2
         nOA=nOA+lnOcc(iSym)
      End Do
*
      Call mma_allocate(Eorb,2*nOrb,Label='EOrb')
      kEOcc=1
      kEVir=kEOcc+nOrb
      ioff=0
      joff=0
      koff=0
      Do iSym=1,nSym
         ifr=1+ioff+nFro(iSym)
         ito=kEOcc+joff
         call dcopy_(lnOcc(iSym),OrbE(ifr),1,EORb(ito),1)
         ifr=1+ioff+nFro(iSym)+nIsh(iSym)+nAsh(iSym)
         ito=kEVir+koff
         call dcopy_(nSsh(iSym),OrbE(ifr),1,EORb(ito),1)
         ioff=ioff+nBas(iSym)
         joff=joff+lnOcc(iSym)
         koff=koff+nSsh(iSym)
      End Do

      Call mma_allocate(Dmat,nVV+nOA,Label='DMat')
      ip_Y=1+nVV
      DMAT(:)=Zero
*
      Call LovCASPT2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,.true.)
      Call mma_allocate(CMON,nBB,Label='CMON')
      CMON(:)=Zero
      iOff=0
      Do iSym=1,nSym
         kfr=1+iOff+nBas(iSym)*nFro(iSym)
         kto=1+iOff+nBas(iSym)*lnFro(iSym)
         call dcopy_(nBas(iSym)*lnOcc(iSym),CMO(kfr),1,CMON(kto),1)
         kfr=1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
         kto=kto+nBas(iSym)*lnOcc(iSym)
         call dcopy_(nBas(iSym)*lnVir(iSym),CMO(kfr),1,CMON(kto),1)
         iOff=iOff+nBas(iSym)**2
      End Do
*
      Call Check_Amp(nSym,lnOcc,lnVir,iSkip)
      If (iSkip.gt.0) Then
         Call ChoMP2_Drv(irc,Dummy,CMON,EOrb(kEOcc),Eorb(kEVir),
     &                   DMAT(1:nVV),DMAT(ip_Y:))
         If(irc.ne.0) then
           write(6,*) 'MP2 pseudodensity calculation failed !'
           Call Abend
         Endif
      Else
         write(6,*)
         write(6,*)'There are ZERO amplitudes T(ai,bj) with the given '
         write(6,*)'combinations of inactive and virtual orbitals !! '
         write(6,*)'Check your input and rerun the calculation! Bye!!'
         Call Abend
      Endif
      Call mma_deallocate(CMON)
*
      iV=1
      Do iSym=1,nSym
        TrD(iSym)=ddot_(lnVir(iSym),DMat(iV:),1+lnVir(iSym),[One],0)
        iV=iV+lnVir(iSym)**2
      End Do
      Call mma_deallocate(Dmat)
      Call mma_deallocate(Eorb)
*
      End Subroutine Compute_Tr_Dab

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_Hvo (Hvo)
c
c        check Hvo
c
        implicit none
#include "chcc1.fh"
        real*8 Hvo(1:nv,1:no)
c
c        help var
        integer i,a,j,b,bad,tot
        real*8 s
c
        bad=0
        tot=0
c
        do i=1,no
        do a=1,nv
c
          s=0.0d0
c
          do j=1,no
          do b=1,nv
          s=s+(2.0d0*Q21(b,j,a,i)-Q21(b,i,a,j))*T1c(b,j)
          end do
          end do
c
          Hvoc(a,i)=s
c
          if (abs(Hvo(a,i)-s).gt.1.0d-10) then
          bad=bad+1
          end if
          tot=tot+1
c
        end do
        end do
c
        write (6,*) ' Hvo Chck :',bad
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 07, 2022, created this file.               *
!*****************************************************************

subroutine UpdateRotMat(RMat,ExpX,X,lRoots,nSPair)

use Index_Functions, only: iTri
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lRoots, nSPair
real(kind=wp), intent(inout) :: RMat(lRoots**2)
real(kind=wp), intent(out) :: ExpX(lRoots,lRoots)
real(kind=wp), intent(in) :: X(nSPair)
integer(kind=iwp) :: I, iIJ, J
real(kind=wp) :: maxtheta
real(kind=wp), allocatable :: RScr(:)

call mma_allocate(RScr,lRoots**2,Label='RScr')

ExpX(1,1) = Zero
do I=2,lRoots
  ExpX(I,I) = Zero
  do J=1,I-1
    iIJ = iTri(I-1,J)
    ExpX(J,I) = X(iIJ)
    ExpX(I,J) = -X(iIJ)
  end do
end do
call Exp_eig(lRoots,ExpX,maxtheta)
call DGEMM_('n','n',lRoots,lRoots,lRoots,One,RMat,lRoots,ExpX,lRoots,Zero,RScr,lRoots)
RMat(:) = RScr(:)

call mma_deallocate(RScr)

return

end subroutine UpdateRotMat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CiSelector(nEqState,nState,STC,nCIRef,iCIInd,dCIRef)

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: nEqState
integer(kind=iwp), intent(in) :: nState, nCIRef, iCIInd(nCIRef)
real(kind=wp), intent(in) :: STC(nState,nState), dCIRef(nCIRef)
integer(kind=iwp) :: indMAX, iRef, iState
real(kind=wp) :: dScal, dScalMAX

! Initial stuff

dScalMAX = Zero
indMAX = 1

! Compute relevant scalar products

do iState=1,nState
  dScal = Zero
  do iRef=1,nCIRef
    dScal = dScal+STC(iCIInd(iRef),iState)*dCIRef(iRef)
  end do
  dScal = abs(dScal)

  ! Test if largest

  if (dScal > dScalMAX) then
    dScalMAX = dScal
    indMAX = iState
  end if
end do

! If maximum overlap is small, scream!

if (dScalMAX < sqrt(Half)) then
  write(6,*)
  write(6,*) '   WARNING! Less than 50% of CISElect reference found. Consider to redefine reference!'
end if

! Now set nEqState

nEqState = indMAX

! Auf Wiedersehen

return

end subroutine CiSelector

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine EFNuc(CoOP,Chrg,Coor,nAtm,ESIT,nOrdOp)
!***********************************************************************
!                                                                      *
! Object: to compute the electricstatic interaction tensor contribution*
!         from the nuclei. In the case that the test charge coincide   *
!         with a nucleau we will remove that center.                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, April '95.                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtm, nOrdOp
real(kind=wp), intent(in) :: CoOp(3), Chrg(nAtm), Coor(3,nAtm)
real(kind=wp), intent(out) :: ESIT(nTri_Elem1(nOrdOp))
integer(kind=iwp) :: iAtom, iPowr, ix, iy, iz, nTot
real(kind=wp) :: eix, eiy, eiz, Fact, r, r2, temp, x, y, z
integer(kind=iwp), allocatable :: C_ESIT(:)
real(kind=wp), parameter :: Thr = 1.0e-12_wp

! Compute the nuclear contribution to the electrostatic interation
! tensor, ESIT.

ESIT(:) = Zero

nTot = (nOrdOp+1)**6
call mma_allocate(C_ESIT,nTot,Label='ESIT')
call InitIA(C_ESIT,nOrdOp)

iPowR = 2*nOrdOp+1
Fact = One
if (nOrdOp >= 1) Fact = -One
do iAtom=1,nAtm
  x = CoOp(1)-Coor(1,iAtom)
  y = CoOp(2)-Coor(2,iAtom)
  z = CoOp(3)-Coor(3,iAtom)
  r2 = x**2+y**2+z**2
  if (r2 > Thr) then
    r = Chrg(iAtom)/sqrt(r2)**iPowR
    do ix=nOrdOp,0,-1
      do iy=nOrdOp-ix,0,-1
        iz = nOrdOp-ix-iy
        if (ix == 0) then
          EIx = One
        else
          EIx = x**ix
        end if
        if (iy == 0) then
          EIy = One
        else
          EIy = y**iy
        end if
        if (iz == 0) then
          EIz = One
        else
          EIz = z**iz
        end if
        temp = Fact*EIx*EIy*EIz*r

        call ContEI(C_ESIT,nOrdOp,ESIT,ix,iy,iz,temp)

      end do
    end do       ! End loop over cartesian combinations
  end if
end do           ! End loop over atoms

call mma_deallocate(C_ESIT)

#ifdef _DEBUGPRINT_
call RecPrt(' The Electrostatic Interaction Tensor',' ',ESIT,nTri_Elem1(nOrdOp),1)
#endif

return

end subroutine EFNuc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine orb2tpstr(NSYM,NB,NF,NI,N1,N2,N3,NS,ND,TYPESTRING)

use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NSYM, NB(NSYM), NF(*), NI(*), N1(*), N2(*), N3(*), NS(*), ND(*)
character, intent(_OUT_) :: typestring(*)
integer(kind=iwp) :: iSym, iStart

iStart = 1
do isym=1,nsym
  call orb2tpstr_sym(NF(iSym),NI(iSym),N1(iSym),N2(iSym),N3(iSym),NS(iSym),ND(iSym),TYPESTRING(iStart))
  iStart = iStart+nB(iSym)
end do

end subroutine orb2tpstr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Sort_Localisation(CMO,nBas,nOcc,nFro,nSym)
! Thomas Bondo Pedersen, November 2005.
!
! Purpose: sort CMOs according to Cholesky orbital ordering.

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOcc(nSym), nFro(nSym)
real(kind=wp), intent(inout) :: CMO(*)
integer(kind=iwp) :: iComp, iOpt, irc, iSyLbl, iSym, kC
real(kind=wp) :: xNrm
character(len=80) :: Txt
character(len=8) :: Label
type(DSBA_Type) :: C, Oaux, Ovlp, X
real(kind=wp), allocatable :: Den(:,:), Scr(:,:), U(:,:)
real(kind=wp), parameter :: ThrCho = 1.0e-12_wp ! Static setting of decomposition threshold
character(len=*), parameter :: SecNam = 'Sort_Localisation'

! Get a copy of the occupied orbitals: X=CMO.
! -------------------------------------------

call Allocate_DT(X,nBas,nOcc,nSym,label='XCho')
call Allocate_DT(C,nBas,nBas,nSym,label='C',Ref=CMO)
do iSym=1,nSym
  kC = nFro(iSym)+1
  X%SB(iSym)%A2(:,:) = C%SB(iSym)%A2(:,kC:kC+nOcc(iSym)-1)
end do

! Get the overlap matrix.
! -----------------------

call Allocate_DT(Ovlp,nBas,nBas,nSym,label='Ovlp')
call Allocate_DT(Oaux,nBas,nBas,nSym,aCase='TRI',label='Ovlp')

irc = -1
iOpt = 6
iComp = 1
iSyLbl = 1
Label = 'Mltpl  0'
call RdOne(irc,iOpt,Label,iComp,Oaux%A0,iSyLbl)
if (irc /= 0) then
  write(u6,*) SecNam,': RdOne returned ',irc
  write(u6,*) 'Label = ',Label,'  iSyLbl = ',iSyLbl
  call SysAbendMsg(SecNam,'I/O error in RdOne',' ')
end if

do iSym=1,nSym
  call Tri2Rec(Oaux%SB(iSym)%A1,Ovlp%SB(iSym)%A2,nBas(iSym),.false.)
end do
call Deallocate_DT(Oaux)

! Sort each symmetry block.
! -------------------------

do iSym=1,nSym

  ! Cycle loop for empty symmetry blocks.
  ! -------------------------------------

  if ((nBas(iSym) < 1) .or. (nOcc(iSym) < 1)) cycle

  ! Allocations.
  ! ------------

  call mma_allocate(Den,nBas(iSym),nBas(iSym),label='SrtDen')
  call mma_allocate(U,nOcc(iSym),nOcc(iSym),label='SrtU')
  call mma_allocate(Scr,nBas(iSym),nOcc(iSym),label='SrtScr')

  ! Cholesky decompose D=C^TC and thus define the ordering.
  ! At this stage, X contains the original MOs (CMO).
  ! After the decomposition, X contains the Cholesky MOs.
  ! -------------------------------------------------------

  call GetDens_Localisation(Den,X%SB(iSym)%A2,nBas(iSym),nOcc(iSym))
  irc = -1
  call ChoLoc(irc,Den,X%SB(iSym)%A2,ThrCho,xNrm,nBas(iSym),nOcc(iSym))
  if (irc /= 0) then
    write(u6,*) SecNam,': ChoLoc returned ',irc
    write(u6,*) 'Symmetry block: ',iSym
    write(u6,*) 'Unable to continue...'
    write(Txt,'(A,I6)') 'ChoLoc return code:',irc
    call SysAbendMsg(SecNam,'Density Cholesky decomposition failed!',Txt)
  end if

  ! Compute address in CMO, skipping frozen orbitals.
  ! -------------------------------------------------

  kC = nFro(iSym)+1

  ! Compute U = X^TSC.
  ! ------------------

  call GetUmat_Localisation(U,X%SB(iSym)%A2,Ovlp%SB(iSym)%A2,C%SB(iSym)%A2(:,kC:),Scr,nBas(iSym),nOcc(iSym))

  ! Sort.
  ! -----

  call Sort_Localisation_1(C%SB(iSym)%A2(:,kC:),U,nBas(iSym),nOcc(iSym))

  ! De-allocations.
  ! ---------------

  call mma_deallocate(Den)
  call mma_deallocate(U)
  call mma_deallocate(Scr)

end do

! De-allocations.
! ---------------

call Deallocate_DT(X)
call Deallocate_DT(C)
call Deallocate_DT(Ovlp)

end subroutine Sort_Localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE DENS(IVEC,DMAT,UEFF,U0)
      USE CHOVEC_IO, only: nvloc_chobatch
      use caspt2_global, only: iPrGlb
      use caspt2_global, only: real_shift, imag_shift, sigma_p_epsilon
      use caspt2_global, only: do_grad, do_csf, if_invar, iRoot1,
     &                           iRoot2, if_invaria, if_SSDM,
     &                           CLag,CLagFull,OLag,SLag,
     &                           DPT2_tot,DPT2C_tot,DPT2_AO_tot,
     &                           DPT2C_AO_tot,DPT2Canti_tot,FIMO_all,
     &                           FIFA_all,OMGDER,jStLag,Weight
      use caspt2_global, only: FIMO, FIFA
      use caspt2_global, only: DREF, DMIX, CMOPT2, TORB, NDREF
      use caspt2_global, only: IDCIEX, IDTCEX
      use PrintLevel, only: DEBUG, VERBOSE
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
      use caspt2_global, only: nCLag
#endif
      use EQSOLV, only: IVECX, IVECR, IVECC2
      use ChoCASPT2, only: NumCho_PT2, iALGO, MaxVec_PT2
      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: IfChol, IFDENS, IFMSCOUP, IFDW, IFSADREF,
     &                         MAXIT, NSYM, NCONF, NFROT, NISH, NRAS1T,
     &                         NRAS2T, NRAS3T, NASH, NAES, NASHT, NORB,
     &                         NBAS, NBAST, NOSQT, NBSQT, iRlxRoot,
     &                         NSTATE, JSTATE, DENORM, ZETA, ORBIN
      use Constants, only: Zero, One, Two, Half

      implicit none

      integer(kind=iwp), intent(in) :: IVEC
      real(kind=wp), intent(inout) :: DMAT(*)
      real(kind=wp), intent(in) :: UEFF(nState,nState),U0(nState,nState)

      real(kind=wp) :: VECROT(nState)

      real(kind=wp),allocatable :: DPT(:),DSUM(:),DPT2(:),DPT2_AO(:),
     &  DPT2C_AO(:),FPT2(:),FPT2C(:),FPT2_AO(:),FPT2C_AO(:),Trf(:),
     &  WRK1(:),WRK2(:),RDMSA(:,:),RDMEIG(:,:),DEPSA(:,:),
     &  DEPSA_diag(:),DIA(:),DI(:),A_PT2(:),T2AO(:),CLagT(:,:),
     &  EigT(:,:),OMGT(:,:),CI1(:)
      real(kind=wp),allocatable,target :: DPT2Canti_(:),DPT2C(:)
      real(kind=wp),pointer :: DPT2Canti(:)

      integer(kind=iwp) :: NDMAT, NDPT, nDPTAO, ISYM, NO, nAO, IDMOFF,
     &  NI, NA, II, IDM, IT, ITABS, ITTOT, IU, IUTOT, IDRF, IUABS, I, J,
     &  nch, iState, JJ, iStLag, ibk, NumChoTot, nOcc, lT2AO, iSQ, iTR,
     &  nOrbI, ISAV, iBasTr, iBasSq, liBasTr, liBasSq, jBasI, IDSOFF,
     &  IP, IQ, IDSUM, nBasI, iBasI
      real(kind=wp) :: wgt, val, Scal, X
      real(kind=wp) :: CPTF0, CPE, TIOTF0, TIOE, CPTF10, TIOTF10, CPUT,
     &  WALLT

      IF (do_grad) THEN
        !! Set indices for densities and partial derivatives
        Call GradPrep(UEFF,VECROT)
!
! Compute total density matrix as symmetry-blocked array of
! triangular matrices in DMAT. Size of a triangular submatrix is
!  (NORB(ISYM)*(NORB(ISYM)+1))/2.
        NDMAT=0
        NDPT=0
        nDPTAO=0
        DO ISYM=1,NSYM
          NO=NORB(ISYM)
          nAO = nBas(iSym)
          NDPT=NDPT+NO**2
          NDMAT=NDMAT+(NO*(NO+1))/2
          nDPTAO = nDPTAO + nAO**2
        END DO
        ! shouldn't be necessary, is already done outside
        DMAT(1:NDMAT) = Zero
! First, put in the reference density matrix.
        IDMOFF=0
        DO ISYM=1,NSYM
          NI=NISH(ISYM)
          NA=NASH(ISYM)
          NO=NORB(ISYM)
          DO II=1,NI
            IDM=IDMOFF+(II*(II+1))/2
            DMAT(IDM)=Two
          END DO
          DO IT=1,NA
            ITABS=NAES(ISYM)+IT
            ITTOT=NI+IT
            DO IU=1,IT
              IUABS=NAES(ISYM)+IU
              IUTOT=NI+IU
              IDRF=(ITABS*(ITABS-1))/2+IUABS
              IDM=IDMOFF+((ITTOT*(ITTOT-1))/2+IUTOT)
              DMAT(IDM)=DREF(IDRF)
            END DO
          END DO
           IDMOFF=IDMOFF+(NO*(NO+1))/2
        END DO
*       write(u6,*)' DENS. Initial DMAT:'
*       WRITE(u6,'(1x,8f16.8)')(dmat(i),i=1,ndmat)
! Add the 1st and 2nd order density matrices:
        call mma_allocate(DPT,NDPT,Label='DPT')
        call mma_allocate(DSUM,NDPT,Label='DSUM')
        DPT(:) = Zero
        DSUM(:) = Zero



        !! Modify the solution (T; amplitude), if the real- or
        !! imaginary- shift is utilized. We need both the unmodified (T)
        !! and modified (T+\lambda) amplitudes. \lambda can be obtained
        !! by solving the CASPT2 equation, but it can alternatively
        !! obtained by a direct summation only if CASPT2-D.
        !! iVecX remains unchanged (iVecX = T)
        !! iVecR will be 2\lambda

        !! For MS-CASPT2, calling this subroutine is required.
        !! The lambda-equation is solved without iteration only when
        !! MS-CASPT2-D (shift?). Otherwise, solved iteratively.
        !! After this subroutine, iVecR has multi-state weighted (?)
        !! contributions.
        CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
        Call CASPT2_Res(VECROT)
        CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
        IF (IPRGLB >= VERBOSE) THEN
          CPUT =CPTF10-CPTF0
          WALLT=TIOTF10-TIOTF0
          write(u6,'(a,2f10.2)')' Lambda  : CPU/WALL TIME=', cput,wallt
        END IF



        CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
        !! Diagonal part
        CALL TRDNS2D(iVecX,iVecR,DPT,NDPT,VECROT(JSTATE))
        if (.not.if_invaria) then
          do i = 1, norb(1)
            do j = i+1, norb(1)
              dpt(i+norb(1)*(j-1)) = Zero
              dpt(j+norb(1)*(i-1)) = Zero
            end do
          end do
        end if
        DSUM(:) = DSUM(:) + DPT(:)
*       write(u6,*)' DPT after TRDNS2D.'
*       WRITE(u6,'(1x,8f16.8)')(dpt(i),i=1,ndpt)
        !! Off-diagonal part, if full-CASPT2
        IF (MAXIT /= 0) THEN
          !! off-diagonal are ignored for CASPT2-D
          DPT(:) = Zero
          CALL TRDNS2O(iVecX,iVecR,DPT,NDPT,VECROT(JSTATE))
          DSUM(:) = DSUM(:) + DPT(:)
        END IF
*       write(u6,*)' DPT after TRDNS2O.'
*       WRITE(u6,'(1x,8f16.8)')(dpt(i),i=1,ndpt)
        CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
        IF (IPRGLB >= VERBOSE) THEN
          CPUT =CPTF10-CPTF0
          WALLT=TIOTF10-TIOTF0
          write(u6,'(a,2f10.2)')' TRDNS2DO: CPU/WALL TIME=', cput,wallt
        END IF

        !! D^PT2 in MO
        call mma_allocate(DPT2,NBSQT,Label='DPT2')
        !! D^PT2(C) in MO
        call mma_allocate(DPT2C,NBSQT,Label='DPT2C')
        !! DPTAO1 (D^PT in AO, but not DPTA-01) couples with
        !! the CASSCF density (assume state-averaged) through ERIs.
        !! This density corresponds to the eigenvalue derivative.
        !! This is sometimes referred to as DPT2(AO) else where.
        call mma_allocate(DPT2_AO,NBSQT,Label='DPT2_AO')
        !! DPTAO2 couples with the inactive density.
        !! This density comes from derivative of the generalized
        !! Fock matrix (see for instance Eq. (24) in the 1990 paper).
        !! This is sometimes referred to as DPT2C(AO) else where.
        call mma_allocate(DPT2C_AO,NBSQT,Label='DPT2C_AO')
        !! DPTAO,DPTCAO,FPTAO,FPTCAO are in a block-squared form
        call mma_allocate(FPT2,NBSQT,Label='FPT2')
        call mma_allocate(FPT2C,NBSQT,Label='FPT2C')
        call mma_allocate(FPT2_AO,NBSQT,Label='FPT2_AO')
        call mma_allocate(FPT2C_AO,NBSQT,Label='FPT2C_AO')
        !! Transformation matrix
        call mma_allocate(Trf,NBSQT,Label='TRFMAT')
        nch=0
        If (IfChol) nch=nvloc_chobatch(1)
        call mma_allocate(WRK1,Max(nBasT**2,nch),Label='WRK1')
        call mma_allocate(WRK2,Max(nBasT**2,nch),Label='WRK2')
        !! state-averaged density
        call mma_allocate(RDMSA,nAshT,nAshT,Label='RDMSA')
        !! Derivative of state-averaged density
        call mma_allocate(RDMEIG,nAshT,nAshT,Label='RDMEIG')
!       write(u6,*) 'olag before'
!       call sqprt(olag,nbast)

        DPT2(:) = Zero
        DPT2C(:) = Zero
        DPT2_AO(:) = Zero
        DPT2C_AO(:) = Zero
        FPT2(:) = Zero
        FPT2C(:) = Zero
        FPT2_AO(:) = Zero
        FPT2C_AO(:) = Zero
        If (.not.IfChol) Then
          FIMO_all(:) = Zero
          FIFA_all(:) = Zero
        End If
        RDMSA(:,:) = Zero
        RDMEIG(:,:) = Zero

        CLag(:,:) = Zero
        OLag(:) = Zero

        If (nFroT /= 0 .or. .not.if_invaria) Then
          call mma_allocate(DIA,NBSQT,Label='DIA')
          call mma_allocate(DI ,NBSQT,Label='DI')
        Else
          call mma_allocate(DIA,1,Label='DIA')
          call mma_allocate(DI ,1,Label='DI')
        End If

        If (do_csf) Then
          call mma_allocate(DPT2Canti_,NBSQT,Label='DPT2Canti')
          DPT2Canti_(:) = Zero
          DPT2Canti => DPT2Canti_
        Else
          DPT2Canti => DPT2C
        End If

        !! DPT -> DPT2
        !! Note that DPT2 has the index of frozen orbitals.
        !! Note also that unrelaxed (w/o Z-vector) dipole moments with
        !! frozen orbitals must be wrong.
!       call dcopy_(ndpt,[Zero],0,dpt,1)
        If (nFroT == 0 .and. if_invaria) Then
          DPT2(1:nOsqT) = DSUM(1:nOsqT)
        Else
          Call OLagFro0(DSUM,DPT2)
        End If

        !! Construct the transformation matrix
        !! It seems that we have to transform quasi-canonical
        !! to CASSCF orbitals. The forward transformation has been
        !! done in ORBCTL.
        !!   C(PT2) = C(CAS)*X    ->    C(CAS) = C(PT2)*X^T
        !!   -> L(CAS) = X*L(PT2)*X^T
        !! inactive and virtual orbitals are not affected.
        Trf(:) = Zero
        Call CnstTrf(TOrb,Trf)
!       call sqprt(trf,nbast)

        !! Construct the density matrix used in the Fock operator
        If (IFSADREF) Then
          WRK1(1:nDRef) = Zero
          Do iState = 1, nState
            wgt = Weight(iState)
            WRK1(1:nDRef) = WRK1(1:nDRef) + Wgt*DMix(1:nDRef,iState)
          End Do
        Else
          WRK1(1:nDRef) = DMix(1:nDRef,jState)
        End If
        Call SQUARE(WRK1,RDMSA,1,nAshT,nAshT)
!       write(u6,*) 'state-averaged density matrix'
!       call sqprt(rdmsa,nasht)
!
!       ----- Construct configuration Lagrangian -----
!
        !! For CI coefficient derivatives (CLag)
        !! Calculate the configuration Lagrangian
        !! This is done in the quasi-canonical basis
        call mma_allocate(DEPSA,nAshT,nAshT,Label='DEPSA')
        DEPSA(:,:) = Zero
        !! Derivative of off-diagonal H0 of <Psi1|H0|Psi1>
        IF (MAXIT /= 0) then
          CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
          Call SIGDER(iVecX,iVecR,VECROT(jState))
          CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
          IF (IPRGLB >= VERBOSE) THEN
            CPUT =CPTF10-CPTF0
            WALLT=TIOTF10-TIOTF0
            write(u6,'(a,2f10.2)')
     &        ' SIGDER  : CPU/WALL TIME=', cput,wallt
          END IF
        end if
        Call CLagX(1,CLag,DEPSA,VECROT)
!       call test3_dens(clag)
#ifdef _MOLCAS_MPP_
        If (Is_Real_Par()) CALL GADSUM (DEPSA,nAshT**2)
#endif
!       write(u6,*) 'original depsa'
!       call sqprt(depsa,nasht)
!       write(u6,*) 'original depsa (sym)'
        do i = 1, nasht
          do j = 1, i-1
            val = (DEPSA(i,j)+DEPSA(j,i))*Half
            DEPSA(i,j) = val
            DEPSA(j,i) = val
          end do
        end do
!       call sqprt(depsa,nasht)

        If (NRAS1T+NRAS3T /= 0) Then
          !! The density of the independent pairs (off-diagonal blocks)
          !! should be determined by solving Z-vector, so these blocks
          !! should be removed...?
!         write(u6,*) 'removing DEPSA of off-diagonal blocks'
!         write(u6,*) 'before'
!         call sqprt(depsa,nasht)
            Do II = 1, nRAS1T
              Do JJ = nRAS1T+1, nAshT
                DEPSA(II,JJ) = Zero
                DEPSA(JJ,II) = Zero
              End Do
            End Do
            Do II = nRAS1T+1, nRAS1T+nRAS2T
              Do JJ = nRAS1T+nRAS2T+1, nAshT
                DEPSA(II,JJ) = Zero
                DEPSA(JJ,II) = Zero
              End Do
            End Do
!         write(u6,*) 'after'
!         call sqprt(depsa,nasht)
          IF (IPRGLB >= DEBUG)
     &      write(u6,*) 'depsa (sym) after removing off-diagonal blocks'
        Else
          IF (IPRGLB >= DEBUG)
     &      write(u6,*) 'depsa (sym)'
        End If
        IF (IPRGLB >= VERBOSE) call sqprt(depsa,nasht)

        !! Configuration Lagrangian for MS-CASPT2
        !! This is the partial derivative of the transition reduced
        !! density matrices
        If (IFMSCOUP) Then
          CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
          Call DerHEff(CLag,VECROT)
          CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
          IF (IPRGLB >= VERBOSE) THEN
            CPUT =CPTF10-CPTF0
            WALLT=TIOTF10-TIOTF0
            write(u6,'(a,2f10.2)')
     &        ' DerHEff : CPU/WALL TIME=', cput,wallt
            write(u6,*)
          END IF
        End If

        !! I need to add the derivative of the effective Hamiltonian
        !! for MS-CASPT2, but this is done after orbital Lagrangian.
        !! I just have to have IVECC = T + lambda.

        !! If CASPT2 energy is not invariant to rotations in active
        !! orbitals, off-diagonal elements of the density obtained
        !! as DEPSA is incorrect, so remove them. The true density
        !! is computed after everything.
        If (.not.if_invar) Then
          !! But, save the diagonal elements
          call mma_allocate(DEPSA_diag,nAshT,Label='DEPSA_diag')
          Call DCopy_(nAshT,DEPSA,nAshT+1,DEPSA_diag,1)
          !! Clear
          DEPSA(:,:) = Zero
        End If
!       write(u6,*) 'depsad'
!       call sqprt(depsa,nasht)

        !! Transform the quasi-variational amplitude (T+\lambda/2?)
        !! in SR (iVecX) to C (iVecC2)
        !! Note that the contribution is multiplied by two
        !! somewhere else (maybe in olagns?)
        If (real_shift /= Zero .or. imag_shift /= Zero
     &      .OR. sigma_p_epsilon /= Zero .OR. IFMSCOUP) Then
          !! Have to weight the T-amplitude for MS-CASPT2
          IF (IFMSCOUP) THEN
            !! add lambda
            CALL PLCVEC(VECROT(jState),Half,IVECX,IVECR)
            CALL PTRTOC(1,IVECR,IVECC2)
            !! T-amplitude
            Do iStLag = 1, nState
              If (iStLag == jState) Cycle
              Scal = VECROT(iStLag)
              If (ABS(Scal) <= 1.0e-12_wp) Cycle
              Call MS_Res(2,jStLag,iStLag,Scal*Half)
            End Do
            If (do_csf) Then
              !! Prepare for something <\Phi_K^{(1)}|Ers|L>
              ibk = IVECC2
              IVECC2 = 7
              Call RHS_ZERO(IVECC2)
              Do iStLag = 1, nState
                If (iStLag == jState) Cycle
                Scal = UEFF(iStLag,iRoot1)*UEFF(jStLag,iRoot2)
     &               - UEFF(jStLag,iRoot1)*UEFF(iStLag,iRoot2)
                Scal = Scal*Half
                If (ABS(Scal) <= 1.0e-12_wp) Cycle
                Call MS_Res(2,jStLag,iStLag,Scal)
              End Do
              IVECC2 = ibk
            End If
          ELSE
            !! Add lambda to the T-amplitude
            CALL PLCVEC(Half,One,IVECR,IVECX)
            CALL PTRTOC(1,IVECX,IVECC2)
          END IF
        End If

!         ipTrfL = 1+nAshT*nBasT+nAshT
!         Call DGemm_('n','N',nAshT,nAshT,nAshT,
!    *                One,Trf(ipTrfL),nBasT,DEPSA,nAshT,
!    *                Zero,dpt2c_ao,nAshT)
!         Call DGemm_('N','t',nAshT,nAshT,nAshT,
!    *                One,dpt2c_ao,nAshT,Trf(ipTrfL),nBasT,
!    *                Zero,DEPSA,nAshT)
!
!       !! Just add DEPSA to DPT2
        Call AddDEPSA(DPT2,DEPSA)
        !! Just transform the density in MO to AO
        CALL DPT2_Trf(DPT,DPT2_AO,CMOPT2,DEPSA,DSUM)
!       call mma_deallocate(DEPSA)
        !! Save the AO density
        !! ... write
!
!       ----- Construct orbital Lagrangian -----
!
        If (nFroT /= 0 .or. .not.if_invaria) Then
          !! If frozen orbitals exist, we need to obtain
          !! electron-repulsion integrals with frozen orbitals to
          !! construct the orbital Lagrangian.
          If (.not.IfChol) Call TRAFRO(1)

          !! Get density matrix (DIA) and inactive density
          !! matrix (DI) to compute FIFA and FIMO.
          Call OLagFroD(DIA,DI,RDMSA,Trf)
        End If

        !! Construct orbital Lagrangian that comes from the derivative
        !! of ERIs. Also, do the Fock transformation of the DPT2 and
        !! DPT2C densities.
        NumChoTot = 0
        If (IfChol) Then
          Do iSym = 1, nSym
            NumChoTot = NumChoTot + NumCho_PT2(iSym)
          End Do
          call mma_allocate(A_PT2,MaxVec_PT2**2,Label='A_PT2')
          A_PT2(:) = Zero
        Else
          call mma_allocate(A_PT2,1,Label='A_PT2')
        End If
        Do iSym = 1, nSym
          nOcc = nIsh(iSym)+nAsh(iSym)
          If (.not.IfChol .or. iALGO /= 1) Then
            lT2AO = nOcc*nOcc*nBasT*nBasT
            call mma_allocate(T2AO,lT2AO,Label='T2AO')
            T2AO(:) = Zero
          Else
            CALL mma_allocate(T2AO,1,Label='T2AO')
          End If

          !! Orbital Lagrangian that comes from the derivative of ERIs.
          !! OLagNS computes only the particle orbitals.
!         write(u6,*) 'ialgo = ', ialgo
          CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
          If (IfChol .and. iALGO == 1) Then
            CALL OLagNS_RI(iSym,DPT2C,DPT2Canti,A_PT2)
          Else
            CALL OLagNS2(iSym,DPT2C,T2AO)
          End If
          CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
          IF (IPRGLB >= VERBOSE) THEN
            CPUT =CPTF10-CPTF0
            WALLT=TIOTF10-TIOTF0
            write(u6,'(a,2f10.2)')
     &        ' OLagNS  : CPU/WALL TIME=', cput,wallt
          END IF
!         write(u6,*) 'DPT2C'
!         call sqprt(dpt2c,nbast)

          !! MO -> AO transformations for DPT2 and DPT2C
          If ((.not.IfChol .or. iALGO /= 1)
     &       .or.(nFroT == 0 .and. if_invaria)) Then
            Call OLagTrf(1,iSym,CMOPT2,DPT2,DPT2_AO,WRK1)
            Call OLagTrf(1,iSym,CMOPT2,DPT2C,DPT2C_AO,WRK1)
!           write(u6,*) 'dpt2'
!           call sqprt(dpt2,nbast)
!           write(u6,*) 'dpt2ao'
!           call sqprt(dpt2_ao,nbast)
          End If

          !! Do some transformations relevant to avoiding (VV|VO)
          !! integrals. Orbital Lagrangian for the hole orbitals are
          !! computed. At the same time, F = G(D) transformations are
          !! also performed for D = DPT2 and DPT2C
          !! The way implemented (what?) is just a shit. I cannot find
          !! FIFA and FIMO for frozen orbitals, so I have to construct
          !! them. Here is the transformation of G(D^inact) and G(D).
          !! FIFA_all and FIMO_all computed in this subroutine
          !! is not yet correct. They are just two-electron after this
          !! subroutine.
          CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
          CALL OLagVVVO(iSym,DPT2_AO,DPT2C_AO,
     &                  FPT2_AO,FPT2C_AO,T2AO,
     &                  DIA,DI,FIFA_all,FIMO_all,
     &                  A_PT2,MaxVec_PT2)
        !   write(u6,*) 'olag after vvvo'
        !   call sqprt(olag,nbast)
          CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
          IF (IPRGLB >= VERBOSE) THEN
            CPUT =CPTF10-CPTF0
            WALLT=TIOTF10-TIOTF0
            write(u6,'(a,2f10.2)')
     &        ' OLagVVVO: CPU/WALL TIME=', cput,wallt
          END IF
!     write(u6,*) 'OLag'
!     do i = 1, 144
!       write(u6,'(i3,f20.10)') i,olag(i)
!     end do
!      write(u6,*) 'fpt2ao'
!     call sqprt(fpt2_ao,12)
!     call abend()

          !! AO -> MO transformations for FPT2AO and FPT2CAO
          If ((.not.IfChol .or. iALGO /= 1)
     &        .or.(nFroT == 0 .and. if_invaria)) Then
            Call OLagTrf(2,iSym,CMOPT2,FPT2,FPT2_AO,WRK1)
            Call OLagTrf(2,iSym,CMOPT2,FPT2C,FPT2C_AO,WRK1)
          End If

          call mma_deallocate(T2AO)
        End Do
        call mma_deallocate(A_PT2)
        !! Add DPTC to DSUM for the correct unrelaxed density
        !! Also, symmetrize DSUM
        Call AddDPTC(DPT2C,DSUM)
!
!       write(u6,*) 'fptao after olagns'
!       call sqprt(fpt2_ao,nbast)
!       write(u6,*) 'fptcao after olagns'
!       call sqprt(fpt2c_ao,nbast)
!       write(u6,*) 'olag after olagns'
!       call sqprt(olag,nbast)
!
        !! If frozen orbitals exist, frozen-inactive part of the
        !! unrelaxed PT2 density matrix is computed using the orbital
        !! Lagrangian. Additionally, Fock transformation is also
        !! required.
        If (nFroT /= 0 .or. .not.if_invaria) Then
          !! Compute DPT2 density for frozen-inactive
!         write(u6,*) 'dpt2 before frozen'
!         call sqprt(dpt2,nbast)
          if (.not.ifchol) then
            !! Construct FIFA and FIMO
            Call OLagFro3(FIFA_all,FIMO_all,WRK1,WRK2)
            !! if possible, canonicalize frozen orbitals, and update
            !! FIMO and Trf
          end if
          !! Save DPT in order to subtract later
          WRK1(1:nDPTAO) = DPT2(1:nDPTAO)
          !! Add explicit FIMO and FIFA contributions. Implicit
          !! contributions are all symmetric in frozen + inactive
          !! orbitals, so they do not contribute to frozen density
          CALL DGEMM_('N','T',nBasT,nBasT,nBasT,
     &                One,FIMO_all,nBasT,DPT2C,nBasT,
     &                One,OLAG,nBasT)
          CALL DGEMM_('T','N',nBasT,nBasT,nBasT,
     &                One,FIMO_all,nBasT,DPT2C,nBasT,
     &                One,OLAG,nBasT)
          CALL DGEMM_('N','T',nBasT,nBasT,nBasT,
     &                One,FIFA_all,nBasT,DPT2,nBasT,
     &                One,OLAG,nBasT)
          CALL DGEMM_('T','N',nBasT,nBasT,nBasT,
     &                One,FIFA_all,nBasT,DPT2,nBasT,
     &                One,OLAG,nBasT)

          !! non-invariant in inactive and secondary
          if(.not.if_invaria) then
            !! Construct the density from orbital Lagrangian
            call caspt2_grad_invaria2(DPT2,OLag)
            !! FIFA contributions from the non-invariant density
            DPT2(1:nDPTAO) = DPT2(1:nDPTAO) - WRK1(1:nDPTAO)
            !! Add the non-invariant contribution to unrelaxed density
            Call AddDPTC(DPT2,DSUM)
            CALL DGEMM_('N','T',nBasT,nBasT,nBasT,
     &                  One,FIFA_all,nBasT,DPT2,nBasT,
     &                  One,OLAG,nBasT)
            CALL DGEMM_('T','N',nBasT,nBasT,nBasT,
     &                  One,FIFA_all,nBasT,DPT2,nBasT,
     &                  One,OLAG,nBasT)
            !! Restore the second-order correlated density
            DPT2(1:nDPTAO) = DPT2(1:nDPTAO) + WRK1(1:nDPTAO)
            DPT2(1:nDPTAO) = WRK1(1:nDPTAO)
          end if
          !! Now, compute pseudo-density using orbital Lagrangian
          !! DSUM does not contain frozen orbitals,
          !! so the properties using this density may be inaccurate
          If(nFroT /= 0) Call OLagFro1(DPT2,OLag)

          !! Subtract the orbital Lagrangian added above.
          !! It is computed again in EigDer
          CALL DGEMM_('N','T',nBasT,nBasT,nBasT,
     &               -One,FIMO_all,nBasT,DPT2C,nBasT,
     &                One,OLAG,nBasT)
          CALL DGEMM_('T','N',nBasT,nBasT,nBasT,
     &               -One,FIMO_all,nBasT,DPT2C,nBasT,
     &                One,OLAG,nBasT)
          CALL DGEMM_('N','T',nBasT,nBasT,nBasT,
     &               -One,FIFA_all,nBasT,WRK1,nBasT,
     &                One,OLAG,nBasT)
          CALL DGEMM_('T','N',nBasT,nBasT,nBasT,
     &               -One,FIFA_all,nBasT,WRK1,nBasT,
     &                One,OLAG,nBasT)
!         write(u6,*) 'dpt after frozen'
!         call sqprt(dpt2,nbast)

          !! Fock transformation for frozen-inactive density
          If (IfChol) Then
            iSym=1
            !! MO -> AO transformations for DPT2 and DPT2C
            Call OLagTrf(1,iSym,CMOPT2,DPT2,DPT2_AO,WRK1)
            Call OLagTrf(1,iSym,CMOPT2,DPT2C,DPT2C_AO,WRK1)
            !! For DF-CASPT2, Fock transformation of DPT2, DPT2C, DIA,
            !! DA is done here, but not OLagVVVO
            !! It seems that it is not possible to do this
            !! transformation in OLagVVVO, because the frozen-part of
            !! the DPT2 is obtained after OLagVVVO.
            FPT2_AO(:) = Zero
            FPT2C_AO(:) = Zero
            Call OLagFro4(1,1,1,1,1,
     &                    DPT2_AO,DPT2C_AO,FPT2_AO,FPT2C_AO,WRK1)
            !! AO -> MO transformations for FPT2AO and FPT2CAO
            Call OLagTrf(2,iSym,CMOPT2,FPT2,FPT2_AO,WRK1)
            Call OLagTrf(2,iSym,CMOPT2,FPT2C,FPT2C_AO,WRK1)
          Else
!           write(u6,*) 'dpt'
!           call sqprt(dpt2,nbast)
            Call OLagFro2(DPT2,FPT2,WRK1,WRK2)
!         write(u6,*) 'fpt'
!           call sqprt(dpt2,nbast)
          End If
!         write(u6,*) 'fifa_all'
!         call sqprt(fifa_all,12)
!         write(u6,*) 'fimo_all'
!         call sqprt(fimo_all,12)
      !   !! Construct FIFA and FIMO
      !   Call OLagFro3(FIFA_all,FIMO_all,WRK1,WRK2)
        Else ! there are no frozen orbitals
          iSQ = 0
          iTR = 0
          Do iSym = 1, nSym
            nOrbI = nOrb(iSym)
            Call SQUARE(FIFA(1+iTR),FIFA_all(1+iSQ),1,nOrbI,nOrbI)
            Call SQUARE(FIMO(1+iTR),FIMO_all(1+iSQ),1,nOrbI,nOrbI)
            iSQ = iSQ + nOrbI*nOrbI
            iTR = iTR + nOrbI*(nOrbI+1)/2
          End Do
        End If
        call mma_deallocate(DIA)
        call mma_deallocate(DI)
!         write(u6,*) 'fifa_all in dens'
!         call sqprt(fifa_all,nbast)
!         write(u6,*) 'fimo_all in dens'
!         call sqprt(fimo_all,nbast)
!        write(u6,*) 'FIFA in natural'
!         Call DGemm_('N','N',nBasT,nBasT,nBasT,
!    *                One,Trf,nBasT,fifa_all,nBasT,
!    *                Zero,WRK1,nBasT)
!         Call DGemm_('N','T',nBasT,nBasT,nBasT,
!    *                One,WRK1,nBasT,Trf,nBasT,
!    *                Zero,WRK2,nBasT)
!         call sqprt(wrk2,12)

        !! Do some post-process for the contributions that comes from
        !! the above two densities.
!       write(u6,*) 'olag before eigder'
!       call sqprt(olag,nbast)
!       write(u6,*) 'fpt2'
!       call sqprt(fpt2,nbast)
        CALL EigDer(DPT2,DPT2C,FPT2_AO,FPT2C_AO,RDMEIG,CMOPT2,
     &              Trf,FPT2,FPT2C,FIFA_all,FIMO_all,RDMSA)
!          call test2_dens(olag,depsa)
!       write(u6,*) 'olag after eigder'
!       call sqprt(olag,nbast)
!       write(u6,*) 'Wlag after eigder'
!       call sqprt(wlag,nbast)
!       write(u6,*) 'rdmeig'
!       call sqprt(rdmeig,nasht)
!       call abend()

        !! Calculate the configuration Lagrangian again.
        !! The contribution comes from the derivative of eigenvalues.
        !! It seems that TRACI_RPT2 uses CI coefficients of RASSCF,
        !! so canonical -> natural transformation is required.
!       ipTrfL = 1+nAshT*nBasT+nAshT
!       Call DGemm_('N','N',nAshT,nAshT,nAshT,
!    *              One,Trf(ipTrfL),nBasT,RDMEIG,nAshT,
!    *              Zero,WRK1,nAshT)
!       Call DGemm_('N','T',nAshT,nAshT,nAshT,
!    *              One,WRK1,nAshT,Trf(ipTrfL),nBasT,
!    *              Zero,RDMEIG,nAshT)
        If (.not.if_invar) Then !test
          call mma_allocate(CLagT,nConf,nState,Label='CLagT')
          call mma_allocate(EigT,nAshT,nAshT,Label='EigT')
          CLagT(:,:) = CLag(:,:)
          EigT(:,:) = RDMEIG(:,:)
          If (IFDW .and. zeta >= Zero) then
            call mma_allocate(OMGT,nState,nState,Label='OMGT')
            OMGT(:,:) = OMGDER(:,:)
          end if
        End If
        !! Use canonical CSFs rather than natural CSFs in CLagEig
        ISAV = IDCIEX
        IDCIEX = IDTCEX
        !! Now, compute the configuration Lagrangian
        Call CLagEig(if_SSDM,.false.,CLag,RDMEIG,nAshT)
#ifdef _MOLCAS_MPP_
        If (Is_Real_Par()) CALL GADSUM (CLag,nCLag)
#endif

        !! Now, here is the best place to compute the true off-diagonal
        !! active density for non-invariant CASPT2
        If (.not.if_invar) Then
          SLag(:,:) = Zero
          !! Add the density that comes from CI Lagrangian
          Call DEPSAOffC(CLag,DEPSA,FIFA_all,FIMO_all,
     &                   WRK1,WRK2,U0)
          !! Add the density that comes from orbital Lagrangian
          Call DEPSAOffO(OLag,DEPSA,FIFA_all)
          !! Restore the diagonal elements
          Call DCopy_(nAshT,DEPSA_diag,1,DEPSA,nAshT+1)
          call mma_deallocate(DEPSA_diag)
          IF (IPRGLB >= VERBOSE) THEN
            write(u6,*) 'DEPSA computed again'
            call sqprt(depsa,nasht)
          END IF
          If (NRAS1T+NRAS3T /= 0) Then
            !! Remove the off-diagonal blocks for RASPT2
            Do II = 1, nRAS1T
              Do JJ = nRAS1T+1, nAshT
                DEPSA(II,JJ) = Zero
                DEPSA(JJ,II) = Zero
              End Do
            End Do
            Do II = nRAS1T+1, nRAS1T+nRAS2T
              Do JJ = nRAS1T+nRAS2T+1, nAshT
                DEPSA(II,JJ) = Zero
                DEPSA(JJ,II) = Zero
              End Do
            End Do
          End If
!         call dcopy_(nasht**2,[Zero],0,depsa,1)

          !! We have to do many things again...
          !! Just add DEPSA to DPT2
          Call AddDEPSA(DPT2,DEPSA)
          !! Just transform the density in MO to AO
          CALL DPT2_Trf(DPT,DPT2_AO,CMOPT2,DEPSA,DSUM)
          !! For IPEA shift with state-dependent density
          If (if_SSDM .and. (jState == iRlxRoot .or. IFMSCOUP)) Then
            iSym = 1
            Call OLagTrf(1,iSym,CMOPT2,DPT2,DPT2_AO,WRK1)
          End If
          !! Some transformations similar to EigDer
          Call EigDer2(RDMEIG,Trf,FIFA_all,RDMSA,DEPSA,WRK1,WRK2)

          CLag(:,:) = CLagT(:,:) !test
         !test
          RDMEIG(:,:) = RDMEIG(:,:) + EigT(:,:)
          SLag(:,:) = Zero
          call mma_deallocate(CLagT)
          call mma_deallocate(EigT)
          if (IFDW .and. zeta >= Zero) then
            OMGDER(:,:) = OMGT(:,:)
            call mma_deallocate(OMGT)
          end if
          !! RDMEIG contributions
          !! Use canonical CSFs rather than natural CSFs
          !! Now, compute the configuration Lagrangian
          Call CLagEig(if_SSDM,.false.,CLag,RDMEIG,nAshT)
#ifdef _MOLCAS_MPP_
          If (Is_Real_Par()) CALL GADSUM (CLag,nCLag)
#endif
          !! Now, compute the state Lagrangian and do some projections
!         Call CLagFinal(CLag,SLag)
        End If

        !! Restore integrals without frozen orbitals, although not sure
        !! this operation is required.
        If ((nFroT /= 0 .or. .not.if_invaria) .and. .not.IfChol)
     &    Call TRAFRO(2)

        IDCIEX = ISAV
        !! Canonical -> natural transformation
        IF(ORBIN == 'TRANSFOR') Then
          Do iState = 1, nState
!           Call CLagX_TrfCI(CLag(1+nConf*(iState-1)))
            Call CLagX_TrfCI(CLag(1,iState))
          End Do
        End If
        ! accumulate configuration Lagrangian only for MS,XMS,XDW,RMS,
        ! but not for SS-CASPT2
        if (jState == iRlxRoot .or. IFMSCOUP) then
          CLagFull(1:nConf,1:nState) = CLagFull(1:nConf,1:nState)
     &      + CLag(1:nConf,1:nState)
        end if
!       Call CLagFinal(CLag,SLag)

        !! Transformations of DPT2 in quasi-canonical to natural orbital
        !! basis and store the transformed density so that the MCLR
        !! module can use them.
        ! accumulate only if MS,XMS,XDW or RMS calculation
        ! call RecPrt('DPT2 before', '', DPT2_tot, nBast, nBast)
        if (jState == iRlxRoot .or. IFMSCOUP) then
          Call DPT2_TrfStore(One,DPT2,DPT2_tot,Trf,WRK1)
          Call DPT2_TrfStore(Two,DPT2C,DPT2C_tot,Trf,WRK1)
          If (do_csf) Then
            Call DPT2_TrfStore(One,DPT2Canti,DPT2Canti_tot,Trf,WRK1)
          End If
        end if
        ! call RecPrt('DPT2 after', '', DPT2_tot, nBast, nBast)
!       !! Save MO densities for post MCLR
!       Call DGemm_('N','N',nBasT,nBasT,nBasT,
!    *              One,Trf,nBasT,DPT,nBasT,
!    *              Zero,WRK1,nBasT)
!       Call DGemm_('N','T',nBasT,nBasT,nBasT,
!    *              One,WRK1,nBasT,Trf,nBasT,
!    *              Zero,WRK2,nBasT)
!       iSQ = 0
!       Do iSym = 1, nSym
!         nOrbI = nBas(iSym)-nDel(iSym)
!         nSQ = nOrbI*nOrbI
!         Call DaXpY_(nSQ,One,WRK2(1+iSQ),1,DPT2_tot(1+iSQ),1)
!         iSQ = iSQ + nSQ
!       End Do

!       !! Do the same for DPT2C Save MO densities for post MCLR
!       Call DGemm_('N','N',nBasT,nBasT,nBasT,
!    *              One,Trf,nBasT,DPT2C,nBasT,
!    *              Zero,WRK1,nBasT)
!       Call DGemm_('N','T',nBasT,nBasT,nBasT,
!    *              One,WRK1,nBasT,Trf,nBasT,
!    *              Zero,WRK2,nBasT)
!       iSQ = 0
!       Do iSym = 1, nSym
!         nOrbI = nBas(iSym)-nDel(iSym)
!         nSQ = nOrbI*nOrbI
!        Call DaXpY_(nSQ,Two,WRK2(1+iSQ),1,DPT2C_tot(1+iSQ),1)
!         iSQ = iSQ + nSQ
!       End Do
!       call abend()
!       call sqprt(RDMEIG,nAshT)

        !! square -> triangle so that the MCLR module can use the AO
        !! densities. Do this for DPT2AO and DPT2CAO (defined in
        !! caspt2_grad.f and caspt2_grad.h).
        ! accumulate only if MS,XMS,XDW or RMS calculation
        if (jState == iRlxRoot .or. IFMSCOUP) then
          iBasTr = 1
          iBasSq = 1
          Do iSym = 1, nSym
            nBasI = nBas(iSym)
            liBasTr = iBasTr
            liBasSq = iBasSq
            Do iBasI = 1, nBasI
              Do jBasI = 1, iBasI
                liBasSq = iBasSq + iBasI-1 + nBasI*(jBasI-1)
                If (iBasI == jBasI) Then
                  DPT2_AO_tot(liBasTr)  = DPT2_AO(liBasSq)
                  DPT2C_AO_tot(liBasTr) = DPT2C_AO(liBasSq)
                Else
                  DPT2_AO_tot(liBasTr) = DPT2_AO(liBasSq)*Two
                  DPT2C_AO_tot(liBasTr) = DPT2C_AO(liBasSq)*Two
                End If
                liBasTr = liBasTr + 1
              End Do
            End Do
            iBasTr = iBasTr + nBasI*(nBasI+1)/2
            iBasSq = iBasSq + nBasI*nBasI
          End Do
        end if

        !! If the density matrix used in the Fock operator is different
        !! from the averaged density in the SCF calculation, we need an
        !! additional term for electron-repulsion integral.
        !! Here prepares such densities.
        !! The first one is just DPT2AO, while the second one is the
        !! difference between the SS and SA density matrix. because the
        !! SA density-contribution will be added and should be
        !! subtracted
        ! This should be done only for iRlxRoot
        If (if_SSDM .and. (jState == iRlxRoot .or. IFMSCOUP)) Then
          CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
!         If (.not.if_invar) Then
!           write(u6,*) 'SS density matrix with IPEA not implemented'
!           Call abend()
!         End If

          !! Construct the SCF density
          !! We first need to construct the density averaged over all
          !! roots involved in SCF.
          WRK1(1:nDRef) = Zero
          call mma_allocate(CI1,nConf,Label='CI1')
          Do iState = 1, nState
            Call LoadCI_XMS('N',1,CI1,iState,U0)
            call POLY1(CI1,nConf)
            call GETDREF(WRK2,nDRef)
            wgt = Weight(iState)
            WRK1(1:nDRef) = WRK1(1:nDRef) + Wgt*WRK2(1:nDRef)
          End Do
          call mma_deallocate(CI1)
          !! WRK2 is the SCF density (for nstate=nroots)
          Call SQUARE(WRK1,WRK2,1,nAshT,nAshT)
          Call DaXpY_(nAshT**2,-One,WRK2,1,RDMSA,1)
          !! Construct the SS minus SA density matrix in WRK1
          Call OLagFroD(WRK1,WRK2,RDMSA,Trf)
          !! Subtract the inactive part
          WRK1(1:nBasT**2) = WRK1(1:nBasT**2) - WRK2(1:nBasT**2)
          !! Here we should use DPT2_AO??
          !! Save
          If (IfChol) Then
            Call CnstAB_SSDM(DPT2_AO,WRK1)
          Else
            !! Well, it is not working any more. I need to use
            !! Position='APPEND', but it is not possible if I need to
            !! use molcas_open or molcas_open_ext2
            write(u6,*) 'It is not possible to perform this calculation'
            write(u6,*) '(non-state averaged density without'
            write(u6,*) 'density-fitting or Cholesky decomposition)'
            write(u6,*) 'Please use DF or CD'
            call abend()
          End If
          CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
          IF (IPRGLB >= VERBOSE) THEN
            CPUT =CPTF10-CPTF0
            WALLT=TIOTF10-TIOTF0
            write(u6,'(a,2f10.2)')
     &        ' SSDM    : CPU/WALL TIME=', cput,wallt
          END IF
        End If
!       write(u6,*) 'pt2ao'
!       call sqprt(DPT2_AO,12)
        call mma_deallocate(DEPSA)

        call mma_deallocate(DPT2)
        call mma_deallocate(DPT2C)
        call mma_deallocate(DPT2_AO)
        call mma_deallocate(DPT2C_AO)
        call mma_deallocate(FPT2)
        call mma_deallocate(FPT2C)
        call mma_deallocate(FPT2_AO)
        call mma_deallocate(FPT2C_AO)
        If (do_csf) call mma_deallocate(DPT2Canti_)
        DPT2Canti => null()

        !! Finalize OLag (anti-symmetrize) and construct WLag
        Call OLagFinal(OLag,Trf)

        call mma_deallocate(TRF)
        call mma_deallocate(WRK1)
        call mma_deallocate(WRK2)
        call mma_deallocate(RDMSA)
        call mma_deallocate(RDMEIG)
        DENORM = One
        !! end of with gradient
      ELSE
        !! without gradient
! Compute total density matrix as symmetry-blocked array of
! triangular matrices in DMAT. Size of a triangular submatrix is
!  (NORB(ISYM)*(NORB(ISYM)+1))/2.
        NDMAT=0
        NDPT=0
        DO ISYM=1,NSYM
          NO=NORB(ISYM)
          NDPT=NDPT+NO**2
          NDMAT=NDMAT+(NO*(NO+1))/2
        END DO
        DMAT(1:NDMAT) = Zero
! First, put in the reference density matrix.
        IDMOFF=0
        DO ISYM=1,NSYM
          NI=NISH(ISYM)
          NA=NASH(ISYM)
          NO=NORB(ISYM)
          DO II=1,NI
            IDM=IDMOFF+(II*(II+1))/2
            DMAT(IDM)=Two
          END DO
          DO IT=1,NA
            ITABS=NAES(ISYM)+IT
            ITTOT=NI+IT
            DO IU=1,IT
              IUABS=NAES(ISYM)+IU
              IUTOT=NI+IU
              IDRF=(ITABS*(ITABS-1))/2+IUABS
              IDM=IDMOFF+((ITTOT*(ITTOT-1))/2+IUTOT)
              DMAT(IDM)=DREF(IDRF)
            END DO
          END DO
           IDMOFF=IDMOFF+(NO*(NO+1))/2
        END DO
*       WRITE(u6,*)' DENS. Initial DMAT:'
*       WRITE(u6,'(1x,8f16.8)')(dmat(i),i=1,ndmat)
! Add the 1st and 2nd order density matrices:
        call mma_allocate(DPT,NDPT,Label='DPT')
        call mma_allocate(DSUM,NDPT,Label='DSUM')
        DSUM(1:NDPT) = Zero

! The 1st order contribution to the density matrix
        DPT(1:NDPT) = Zero
        CALL TRDNS1(IVEC,DPT,NDPT)
        DSUM(1:NDPT) = DSUM(1:NDPT) + DPT(1:NDPT)
*       WRITE(u6,*)' DPT after TRDNS1.'
*       WRITE(u6,'(1x,8f16.8)')(dpt(i),i=1,ndpt)
        DPT(1:NDPT) = Zero
        CALL TRDNS2D(IVEC,IVEC,DPT,NDPT,One)
        IF(IFDENS) THEN
! The exact density matrix evaluation:
          CALL TRDTMP(DPT,NDPT)
        ELSE
! The approximate density matrix evaluation:
          CALL TRDNS2A(IVEC,IVEC,DPT,NDPT)
        END IF
        DSUM(1:NDPT) = DSUM(1:NDPT) + DPT(1:NDPT)
*       WRITE(u6,*)' DPT after TRDNS2D.'
*       WRITE(u6,'(1x,8f16.8)')(dpt(i),i=1,ndpt)
        DPT(1:NDPT) = Zero
        CALL TRDNS2O(IVEC,IVEC,DPT,NDPT,One)
        DSUM(1:NDPT) = DSUM(1:NDPT) + DPT(1:NDPT)
        ! WRITE(u6,*)' DPT after TRDNS2O.'
        ! WRITE(u6,'(1x,8f16.8)')(dpt(i),i=1,ndpt)
      END IF
!
      call mma_deallocate(DPT)
      IDMOFF=0
      IDSOFF=0
      DO ISYM=1,NSYM
        NO=NORB(ISYM)
        DO IP=1,NO
          DO IQ=1,IP
            IDM=IDMOFF+(IP*(IP-1))/2+IQ
            IDSUM=IDSOFF+IP+NO*(IQ-1)
            DMAT(IDM)=DMAT(IDM)+DSUM(IDSUM)
          END DO
        END DO
        IDMOFF=IDMOFF+(NO*(NO+1))/2
        IDSOFF=IDSOFF+NO**2
      END DO
      call mma_deallocate(DSUM)
! Scale with 1/DENORM to normalize
      X=One/DENORM
      If (do_grad) X=One
      DMAT(1:NDMAT) = X*DMAT(1:NDMAT)

!SVC: For true parallel calculations, replicate the DMAT array
! so that the slaves have the same density matrix as the master.
#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        IF (.NOT.KING()) THEN
          DMAT(1:NDMAT) = Zero
        END IF
        CALL GADSUM(DMAT,NDMAT)
      END IF
#endif

      END SUBROUTINE DENS
!
!-----------------------------------------------------------------------
!
      Subroutine CnstTrf(Trf0,Trf)

      use caspt2_global, only: TraFro
      use caspt2_module, only: IfChol, NSYM, NFRO, NISH, NRAS1, NRAS2,
     &                         NRAS3, NASH, NSSH, NDEL, NBAS
      use definitions, only: wp, iwp
      use Constants, only: One

      implicit none

#include "intent.fh"

      real(kind=wp), intent(in) :: Trf0(*)
      real(kind=wp), intent(_OUT_) :: Trf(*)

      integer(kind=iwp) :: iSQ, iTOrb, ipTrfL, iSym, nBasI, nFroI,
     &  nIshI, nAshI, nSshI, nDelI, NR1, NR2, NR3, nCor, nVir, I, J,
     &  iIsh, jIsh, IJ, iAsh, jAsh, iSsh, jSsh

      iSQ = 0
      iTOrb = 1 ! LTOrb
      ipTrfL = 0
      Do iSym = 1, nSym
        nBasI = nBas(iSym)
        nFroI = nFro(iSym)
        nIshI = nIsh(iSym)
        nAshI = nAsh(iSym)
        nSshI = nSsh(iSym)
        nDelI = nDel(iSym)
        NR1   = nRAS1(iSym)
        NR2   = nRAS2(iSym)
        NR3   = nRAS3(iSym)
        nCor  = nFroI + nIshI
        nVir  = nSshI + nDelI
        ipTrfL = ipTrfL + iSQ
        !! frozen + inactive
!       Do iIsh = 1, nFroI + nIshI
!         Trf(ipTrfL+iIsh+nBasI*(iIsh-1)) = One
!       End Do
        !! frozen
        If (IfChol) Then
          Do I = 1, nFroI
            Do J = 1, nFroI
              Trf(ipTrfL+I+nBasI*(J-1))
     &          = TraFro(I+nFroI*(J-1))
            End Do
          End Do
        else
          Do iIsh = 1, nFroI
            Trf(ipTrfL+iIsh+nBasI*(iIsh-1)) = One
          End Do
        End If
        !! inactive
        Do I = 1, nIshI
          iIsh = nFroI + I
          Do J = 1, nIshI
            jIsh = nFroI + J
            IJ=I-1+nIshI*(J-1)
            Trf(ipTrfL+iIsh+nBasI*(jIsh-1))
     &        = Trf0(iTOrb+IJ)
          End Do
        End Do
        iTOrb = iTOrb + nIshI*nIshI
        !! RAS1 space
        Do I = 1, NR1
          iAsh = nCor + I
          Do J = 1, NR1
            jAsh = nCor + J
            IJ=I-1+NR1*(J-1)
            Trf(ipTrfL+iAsh+nBasI*(jAsh-1))
     &        = Trf0(iTOrb+IJ)
          End Do
        End Do
        iTOrb = iTOrb + NR1*NR1
        !! RAS2 space
        Do I = 1, NR2
          iAsh = nCor + NR1 + I
          Do J = 1, NR2
            jAsh = nCor + NR1 + J
            IJ=I-1+NR2*(J-1)
            Trf(ipTrfL+iAsh+nBasI*(jAsh-1))
     &        = Trf0(iTOrb+IJ)
          End Do
        End Do
        iTOrb = iTOrb + NR2*NR2
        !! RAS3 space
        Do I = 1, NR3
          iAsh = nCor + NR1 + NR2 + I
          Do J = 1, NR3
            jAsh = nCor + NR1 + NR2 + J
            IJ=I-1+NR3*(J-1)
            Trf(ipTrfL+iAsh+nBasI*(jAsh-1))
     &        = Trf0(iTOrb+IJ)
          End Do
        End Do
        iTOrb = iTOrb + NR3*NR3
!       call sqprt(trf,12)
      ! !! Active
      ! Do iAsh0 = 1, nAshI
      !   iAsh = nCor + iAsh0
      !   Do jAsh0 = 1, nAshI
      !     jAsh = nCor + jAsh0
!     !     Work(ipTrfL+iAsh-1+nBasI*(jAsh-1))
!    *!       = Work(iTOrb+nIshI*nIshI+iAsh0-1+nAshI*(jAsh0-1))
      !     Trf(ipTrfL+iAsh+nBasI*(jAsh-1))
     &!       = Trf0(iTOrb+iAsh0-1+nAshI*(jAsh0-1))
      !   End Do
      ! End Do
!       call sqprt(trf,12)
        !! virtual + deleted (deleted is not needed, though)
!       Do iSsh = nOcc+1, nOcc+nVir
!         Trf(ipTrfL+iSsh+nBasI*(iSsh-1)) = One
!       End Do
        Do I = 1, nVir
          iSsh = nCor + nAshI + I
          Do J = 1, nVir
            jSsh = nCor + nAshI + J
            IJ=I-1+nVir*(J-1)
            Trf(ipTrfL+iSsh+nBasI*(jSsh-1))
     &        = Trf0(iTOrb+IJ)
          End Do
        End Do
        iTOrb = iTOrb + nSshI*nSshI
!       call sqprt(trf,12)
        iSQ = iSQ + nBasI*nBasI

!       n123 = nAshI*nAshI !! just for CAS at present
!       iTOrb = iTOrb + n123 + nSshI*nSshI
!     write(u6,*) 'transformation matrix'
!     call sqprt(trf,nbasi)
      End Do

      Return

      End Subroutine CnstTrf
!
!-----------------------------------------------------------------------
!
      SUBROUTINE AddDEPSA(DPT2,DEPSA)

      use caspt2_module, only: NSYM, NFRO, NISH, NASH, NASHT, NORB,
     &                         NDEL, NBAS
      use Constants, only: Half
      use definitions, only: wp, iwp

      implicit none

      real(kind=wp), intent(inout) :: DPT2(*)
      real(kind=wp), intent(in) :: DEPSA(nAshT,nAshT)

      integer(kind=iwp) :: iMO1, iMO2, iSym, nOrbI1, nOrbI2, iOrb0,
     &  iOrb2, jOrb0, jOrb2, iOrb, jOrb
      real(kind=wp) :: Val

      iMO1 = 1
      iMO2 = 1
      DO iSym = 1, nSym
        nOrbI1 = nOrb(iSym)
        nOrbI2 = nBas(iSym)-nDel(iSym)
        If (nOrbI2 > 0) Then
          !! Add active orbital density
          !! Probably incorrect if symmetry
          Do iOrb0 = 1, nAsh(iSym)
            ! iOrb1 = nIsh(iSym)+iOrb0
            iOrb2 = nFro(iSym)+nIsh(iSym)+iOrb0
            Do jOrb0 = 1, nAsh(iSym)
              ! jOrb1 = nIsh(iSym)+jOrb0
              jOrb2 = nFro(iSym)+nIsh(iSym)+jOrb0
              DPT2(iMO2+iOrb2-1+nOrbI2*(jOrb2-1))
     &          = DPT2(iMO2+iOrb2-1+nOrbI2*(jOrb2-1))
     &          + DEPSA(iOrb0,jOrb0)
            End Do
          End Do
          !! Symmetrize DPT2 (for shift)
          Do iOrb = 1, nBas(iSym)-nDel(iSym)
            Do jOrb = 1, iOrb-1
              Val =(DPT2(iMO2+iOrb-1+nOrbI2*(jOrb-1))
     &             +DPT2(iMO2+jOrb-1+nOrbI2*(iOrb-1)))*Half
              DPT2(iMO2+iOrb-1+nOrbI2*(jOrb-1)) = Val
              DPT2(iMO2+jOrb-1+nOrbI2*(iOrb-1)) = Val
            End Do
          End Do
        END IF
        iMO1 = iMO1 + nOrbI1*nOrbI1
        iMO2 = iMO2 + nOrbI2*nOrbI2
      End Do

      End Subroutine AddDEPSA
!
!-----------------------------------------------------------------------
!
      SUBROUTINE AddDPTC(DPTC,DSUM)

      use caspt2_module, only: NSYM, NFRO, NORB, NBAS
      use Constants, only: Half
      use definitions, only: wp, iwp

      implicit none

      real(kind=wp), intent(in) :: DPTC(*)
      real(kind=wp), intent(inout) :: DSUM(*)

      integer(kind=iwp) :: iMO1, iMO2, iSym, nOrbI1, nOrbI2, iOrb0,
     &  iOrb1, jOrb0, jOrb1, iOrb, jOrb
      real(kind=wp) :: Val

      iMO1 = 1
      iMO2 = 1
      DO iSym = 1, nSym
        nOrbI1 = nOrb(iSym)
        nOrbI2 = nBas(iSym)!-nDel(iSym)
        If (nOrbI2 > 0) Then
          !! Add active orbital density
          !! Probably incorrect if symmetry
          Do iOrb0 = 1, nOrb(iSym)
            iOrb1 = nFro(iSym) + iOrb0
            Do jOrb0 = 1, nOrb(iSym)
              jOrb1 = nFro(iSym) + jOrb0
              DSUM(iMO1+iOrb0-1+nOrbI1*(jOrb0-1))
     &          = DSUM(iMO1+iOrb0-1+nOrbI1*(jOrb0-1))
     &          + DPTC(iMO2+iOrb1-1+nOrbI2*(jOrb1-1))
            End Do
          End Do
          !! Symmetrize DSUM
          Do iOrb = 1, nOrb(iSym)
            Do jOrb = 1, iOrb-1
              Val =(DSUM(iMO1+iOrb-1+nOrbI1*(jOrb-1))
     &             +DSUM(iMO1+jOrb-1+nOrbI1*(iOrb-1)))*Half
              DSUM(iMO1+iOrb-1+nOrbI1*(jOrb-1)) = Val
              DSUM(iMO1+jOrb-1+nOrbI1*(iOrb-1)) = Val
            End Do
          End Do
        END IF
        iMO1 = iMO1 + nOrbI1*nOrbI1
        iMO2 = iMO2 + nOrbI2*nOrbI2
      End Do

      End Subroutine AddDPTC
!
!-----------------------------------------------------------------------
!
      Subroutine TRAFRO(MODE)

      use caspt2_global, only: CMO, CMO_Internal, CMOPT2, NCMO
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: IfChol, NSYM, NFRO, NISH, NASH, NOSH,
     &                         NSSH, NORB
      use definitions, only: iwp

      implicit none

      integer(kind=iwp), intent(in) :: MODE

      integer(kind=iwp) :: nFroTmp(8), nOshTmp(8), nOrbTmp(8)
      integer(kind=iwp) :: jSym

      If (Mode == 1) Then
        Do jSym = 1, nSym
          nFroTmp(jSym) = nFro(jSym)
          nOshTmp(jSym) = nOsh(jSym)
          nOrbTmp(jSym) = nOrb(jSym)
          nOsh(jSym) = nFro(jSym)+nIsh(jSym)+nAsh(jSym)
          nOrb(jSym) = nOsh(jSym)+nSsh(jSym)
          nFro(jSym) = 0
        End Do
      End If

      Call mma_allocate(CMO_Internal,NCMO,Label='CMO_Internal')
      CMO=>CMO_Internal
      CMO(:)=CMOPT2(:)
      if (IfChol) then
        call TRACHO3(CMO,NCMO)
      else
        call TRACTL(0)
      end if
      Call mma_deallocate(CMO_Internal)
      nullify(CMO)

      If (Mode == 1) Then
        Do jSym = 1, nSym
          nFro(jSym) = nFroTmp(jSym)
          nOsh(jSym) = nOshTmp(jSym)
          nOrb(jSym) = nOrbTmp(jSym)
        End Do
      End If

      Return

      End Subroutine TRAFRO
!
!-----------------------------------------------------------------------
!
      Subroutine DPT2_TrfStore(Scal,DPT2q,DPT2n,Trf,WRK)

      use caspt2_module, only: NSYM, NORB, NDEL, NBAS
      use Constants, only: Zero, One
      use definitions, only: wp, iwp

      implicit none

#include "intent.fh"

      real(kind=wp), intent(in) :: Scal, DPT2q(*), Trf(*)
      real(kind=wp), intent(inout) :: DPT2n(*)
      real(kind=wp), intent(_OUT_) :: WRK(*)

      integer(kind=iwp) :: iMO, iSym, nOrbI

      iMO = 1
      Do iSym = 1, nSym
        If (nOrb(iSym) > 0) Then
          nOrbI = nBas(iSym)-nDel(iSym)
          !! Quasi-canonical -> natural transformation of DPT2
          Call DGemm_('N','N',nOrbI,nOrbI,nOrbI,
     &                One,Trf(iMO),nOrbI,DPT2q(iMO),nOrbI,
     &                Zero,WRK,nOrbI)
          Call DGemm_('N','T',nOrbI,nOrbI,nOrbI,
     &                Scal,WRK,nOrbI,Trf(iMO),nOrbI,
     &                One,DPT2n(iMO),nOrbI)
        End If
        iMO  = iMO  + nOrbI*nOrbI
      End Do

      Return

      End Subroutine DPT2_TrfStore
!
!-----------------------------------------------------------------------
!
      SUBROUTINE DPT2_Trf(DPT2,DPT2AO,CMO,DEPSA,DSUM)

      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp
      use Constants, only: Zero, One, Half
      use caspt2_module, only: NSYM, NFRO, NISH, NASH, NASHT, NORB,
     &                         NDEL, NBAS, NBSQT

      implicit none

      real(kind=wp), intent(inout) :: DPT2(*), DPT2AO(*), DSUM(*)
      real(kind=wp), intent(in) :: CMO(*), DEPSA(nAshT,nAshT)

      real(kind=wp), allocatable :: WRK(:)
      real(kind=wp) :: Val
      integer(kind=iwp) :: iCMO, iAO, iMO, iSym, nBasI, nOrbI, iOrb0,
     &  iOrb, jOrb0, jOrb

      !! DPT2 transformation
      !! Just transform DPT2 (in MO, block-squared) to DPT2AO (in AO,
      !! block-squared). Also, for DPT2C which couples with the inactive
      !! density matrix.
      call mma_allocate(WRK,NBSQT,Label='WRK')

      !! MO -> AO back transformation
      iCMO =1
      iAO = 1
      iMO = 1
      DO iSym = 1, nSym
        iCMO = iCMO  + nBas(iSym)*nFro(iSym)
        If (nORB(ISYM) > 0) Then
          nBasI = nBas(iSym)
          nOrbI = nOrb(iSym)
          !! Add active orbital density
          Do iOrb0 = 1, nAsh(iSym)
            iOrb = nIsh(iSym)+iOrb0
            ! iOrb2= nFro(iSym)+nIsh(iSym)+iOrb0
            Do jOrb0 = 1, nAsh(iSym)
              jOrb = nIsh(iSym)+jOrb0
              ! jOrb2= nFro(iSym)+nIsh(iSym)+jOrb0
              DPT2(iMO+iOrb-1+nOrbI*(jOrb-1))
     &          = DPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) + DEPSA(iOrb0,jOrb0)
              DSUM(iMO+iOrb-1+nOrbI*(jOrb-1))
     &          = DSUM(iMO+iOrb-1+nOrbI*(jOrb-1)) + DEPSA(iOrb0,jOrb0)
            End Do
          End Do
          !! Symmetrize DPT2 (for shift)
          Do iOrb = 1, nOrb(iSym)
            Do jOrb = 1, iOrb
              Val =(DPT2(iMO+iOrb-1+nOrbI*(jOrb-1))
     &             +DPT2(iMO+jOrb-1+nOrbI*(iOrb-1)))*Half
              DPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) = Val
              DPT2(iMO+jOrb-1+nOrbI*(iOrb-1)) = Val
            End Do
          End Do
          !! First, DPT2 -> DPT2AO
          CALL DGEMM_('N','N',nBasI,nOrbI,nOrbI,
     &                 One,CMO(iCMO),nBasI,DPT2(iMO),nOrbI,
     &                 Zero,WRK,nBasI)
          CALL DGEMM_('N','T',nBasI,nBasI,nOrbI,
     &                 One,WRK,nBasI,CMO(iCMO),nBasI,
     &                 Zero,DPT2AO(iAO),nBasI)
        END IF
        iCMO = iCMO + nBas(iSym)*(nOrb(iSym)+nDel(iSym))
        iAO  = iAO  + nBasI*nBasI
        iMO  = iMO  + nBasI*nBasI
      End Do

      call mma_deallocate(WRK)

      END SUBROUTINE DPT2_Trf
!
!-----------------------------------------------------------------------
!
      SUBROUTINE EigDer(DPT2,DPT2C,FPT2AO,FPT2CAO,RDMEIG,CMO,Trf,
     &                  FPT2,FPT2C,FIFA,FIMO,RDMSA)

      use caspt2_global, only: OLag
      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: NSYM, NFRO, NFROT, NISH, NASH, NASHT,
     &                         NORB, NDEL, NBAS, NBAST, NBSQT
      use Constants, only: Zero, One, Two

      implicit none

      real(kind=wp), intent(in) :: DPT2(*), DPT2C(*), FPT2AO(*),
     &  FPT2CAO(*), CMO(*), Trf(*), FPT2(*), FPT2C(*), FIFA(*), FIMO(*),
     &  RDMSA(*)
      real(kind=wp), intent(inout) :: RDMEIG(*)

      real(kind=wp),allocatable :: WRK1(:),FPT2_loc(:),FPT2C_loc(:),
     &                             RDMqc(:)

      integer(kind=iwp) :: iCMO, iAO, iSym, nBasI, nOrbI, iSQ, nFroI,
     &  nIshI, nAshI, nCor, iSQA, iT, iTabs, iU, iUabs, iTU, iTUA

      call mma_allocate(WRK1,NBSQT,Label='WRK1')
      call mma_allocate(FPT2_loc,NBSQT,Label='FPT2_loc')
      call mma_allocate(FPT2C_loc,NBSQT,Label='FPT2C_loc')

      !! AO -> MO transformation
      iCMO =1
      iAO = 1
      if (nfrot /= 0) then
        FPT2_loc(1:NBSQT) = FPT2(1:NBSQT)
        FPT2C_loc(1:NBSQT) = FPT2C(1:NBSQT)
      else
        DO iSym = 1, nSym
          iCMO = iCMO  + nBas(iSym)*nFro(iSym)
!         iOFF = iWTMP + nBas(iSym)*nBas(iSym)
          If (nOrb(iSym) > 0) Then
            nBasI = nBas(iSym)
            nOrbI = nOrb(iSym)
            !! First, FPT2(AO) -> FPT2(MO)
            CALL DGEMM_('T','N',nOrbI,nBasI,nBasI,
     &                   One,CMO(iCMO),nBasI,FPT2AO(iAO),nBasI,
     &                   Zero,WRK1,nOrbI)
            CALL DGEMM_('N','N',nOrbI,nOrbI,nBasI,
     &                   One,WRK1,nOrbI,CMO(iCMO),nBasI,
     &                   Zero,FPT2_loc(iAO),nOrbI)
            !! Second, FPT2C(AO) -> FPT2C(MO)
            CALL DGEMM_('T','N',nOrbI,nBasI,nBasI,
     &                   One,CMO(iCMO),nBasI,FPT2CAO(iAO),nBasI,
     &                   Zero,WRK1,nOrbI)
            CALL DGEMM_('N','N',nOrbI,nOrbI,nBasI,
     &                   One,WRK1,nOrbI,CMO(iCMO),nBasI,
     &                   Zero,FPT2C_loc(iAO),nOrbI)
          END IF
          iCMO = iCMO + nBas(iSym)*(nOrb(iSym)+nDel(iSym))
          iAO  = iAO  + nBasI*nBasI
!         iMO  = iMO  + nBasI*nBasI
        End Do
      end if

      FPT2_loc(:)  = Two*FPT2_loc(:)
      FPT2C_loc(:) = Two*FPT2C_loc(:)
      !! construct Fock in MO

      iSQ = 1
      Do iSym = 1, nSym
        nOrbI = nBas(iSym)-nDel(iSym) !! nOrb(iSym)
        nFroI = nFro(iSym)
        nIshI = nIsh(iSym)
        nAshI = nAsh(iSym)
        ! nSshI = nSsh(iSym)
        ! nDelI = nDel(iSym)
        nCor  = nFroI + nIshI
        !! Inactive orbital contributions: (p,q) = (all,inact)
        OLAG(iSQ:iSQ+nOrbI*nCor-1) = OLAG(iSQ:iSQ+nOrbI*nCor-1)
     &    + Two*FPT2_loc(iSQ:iSQ+nOrbI*nCor-1)
        !! Active orbital contributions: (p,q) = (all,act)
        call mma_allocate(RDMqc,nAshI**2,Label='RDMqc')
        !  Construct the active density of the orbital energy
        !  Assume the state-averaged density (SS- and XMS-CASPT2)
!       nSeq = 0
!       Call DCopy_(nAshI*nAshI,[Zero],0,WRK1,1)
!       Do iState = 1, nState
!         Wgt  = DWgt(iState,iState)
!         Wgt  = One/nState
!         Call DaXpY_(nDRef,Wgt,DMIX(:,iState),1,WRK1,1)
!       End Do
        !  RDM of CASSCF
        !  RDMSA is defined by a set of natural orbitals.
        !  Here, we have to transform to a set of quasi-canonical
        !  orbitals (RDMqc), so forward transformation is appropriate.
!       Call SQUARE(WRK1,RDMqc,1,nAshI,nAshI)
        RDMqc(1:nAshI**2) = RDMSA(1:nAshI**2)
        !! nbast?
        Call DGemm_('T','N',nAshT,nAshT,nAshT,
     &              One,Trf(iSQ+nBasT*nCor+nCor),nBasT,RDMqc,nAshT,
     &              Zero,WRK1,nAshT)
        Call DGemm_('N','N',nAshT,nAshT,nAshT,
     &              One,WRK1,nAshT,Trf(iSQ+nBasT*nCor+nCor),nBasT,
     &              Zero,RDMqc,nAshT)
        !  Then just multiply with G(DPT2)
        CALL DGEMM_('N','N',nOrbI,nAshI,nAshI,
     &              One,FPT2_loc(iSQ+nOrbI*nCor),nOrbI,RDMqc,nAshI,
     &              One,OLAG(iSQ+nOrbI*nCor),nOrbI)
        call mma_deallocate(RDMqc)
        !! From the third term of U_{ij}
        !  FIFA is already in quasi-canonical basis
!       If (nFroI == 0) Then
!         Call SQUARE(FIFA(iSQ),WRK1,1,nOrbI,nOrbI)
!       Else
!         Call OLagFroSq(iSym,FIFA(iSQ),WRK1)
!       End If
        CALL DGEMM_('N','T',nOrbI,nOrbI,nOrbI,
!    *              Two,WRK1,nOrbI,DPT2(iSQ),nOrbI,
     &              Two,FIFA(iSQ),nOrbI,DPT2(iSQ),nOrbI,
     &              One,OLAG,nOrbI)

        !! explicit derivative of the effective Hamiltonian
        !! dfpq/da = d/da(C_{mu p} C_{nu q} f_{mu nu})
        !!         = f_{mu nu}^a + (C_{mu m} U_{mp} C_{nu q}
        !!                       + C_{mu p} C_{nu m} U_{mq}) * f_{mu nu}
        !!         = f_{mu nu}^a + U_{mp} f_{mq} + U_{mq} f_{pm}
        !! U_{pq}  = f_{pm} df_{qm} + f_{mp} df_{mq}
        CALL DGEMM_('N','T',nOrbI,nOrbI,nOrbI,
!    *              One,WRK1,nOrbI,DPT2C(iSQ),nOrbI,
     &              One,FIMO(iSQ),nOrbI,DPT2C(iSQ),nOrbI,
     &              One,OLAG,nOrbI)
        CALL DGEMM_('T','N',nOrbI,nOrbI,nOrbI,
!    *              One,WRK1,nOrbI,DPT2C(iSQ),nOrbI,
     &              One,FIMO(iSQ),nOrbI,DPT2C(iSQ),nOrbI,
     &              One,OLAG,nOrbI)
!       End If
        !! Implicit derivative of inactive orbitals (DPT2C)
        OLAG(iSQ:iSQ+nOrbI*nCor-1) = OLAG(iSQ:iSQ+nOrbI*nCor-1)
     &    + Two*FPT2C_loc(iSQ:iSQ+nOrbI*nCor-1)
        iSQ = iSQ + nOrbI*nOrbI
      End Do
!
!     ----- CASSCF density derivative contribution in active space
!
      iSQ = 1
      iSQA= 1
      Do iSym = 1, nSym
        nOrbI = nBas(iSym)-nDel(iSym) !! nOrb(iSym)
        nFroI = nFro(iSym)
        nIshI = nIsh(iSym)
        nAshI = nAsh(iSym)
        nCor  = nFroI + nIshI
        Do iT = 1, nAshI
          iTabs = nCor + iT
          Do iU = 1, nAshI
            iUabs = nCor + iU
            iTU = iTabs-1 + nOrbI*(iUabs-1)
            iTUA= iT   -1 + nAshI*(iU   -1)
            RDMEIG(iSQA+iTUA)
     &        = RDMEIG(iSQA+iTUA) + FPT2_loc(iSq+iTU)
!           write(u6,'(2i3,f20.10)') it,iu,FPT2(iSq+iTU)
          End Do
        End Do
        iSQ = iSQ + nOrbI*nOrbI
        iSQA= iSQA+ nAshI*nAshI
      End Do

      call mma_deallocate(WRK1)
      call mma_deallocate(FPT2_loc)
      call mma_deallocate(FPT2C_loc)

      END SUBROUTINE EigDer
!
!-----------------------------------------------------------------------
!
      SUBROUTINE EigDer2(RDMEIG,Trf,FIFA,RDMSA,DEPSA,WRK1,WRK2)

      use caspt2_global, only: OLag
      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: NSYM, NFRO, NISH, NASH, NASHT,
     &                         NDEL, NBAS, NBAST, NBSQT
      use Constants, only: Zero, One, Two

      implicit none

#include "intent.fh"

      real(kind=wp), intent(_OUT_) :: RDMEIG(*), WRK1(*), WRK2(*)
      real(kind=wp), intent(in) :: Trf(*), FIFA(*), RDMSA(*), DEPSA(*)

      real(kind=wp),allocatable :: FPT2_loc(:),RDMqc(:)
      integer(kind=iwp) :: iSQ, iSym, nOrbI, nFroI, nIshI, nAshI, nCor,
     &  iSQA, iT, iTabs, iU, iUabs, iTU, iTUA

      call mma_allocate(FPT2_loc,NBSQT,Label='FPT2_loc')

      !! Compute G(D), where D=DEPSA
      Call DEPSATrf(DEPSA,FPT2_loc,WRK1,WRK2)
      FPT2_loc(:) = Two*FPT2_loc(:)

      iSQ = 1
      Do iSym = 1, nSym
        nOrbI = nBas(iSym)-nDel(iSym) !! nOrb(iSym)
        nFroI = nFro(iSym)
        nIshI = nIsh(iSym)
        nAshI = nAsh(iSym)
        ! nSshI = nSsh(iSym)
        ! nDelI = nDel(iSym)
        nCor  = nFroI + nIshI
        !! Inactive orbital contributions: (p,q) = (all,inact)
        OLAG(iSQ:iSQ+nOrbI*nCor-1) = OLAG(iSQ:iSQ+nOrbI*nCor-1)
     &    + Two*FPT2_loc(iSQ:iSQ+nOrbI*nCor-1)
        !! Active orbital contributions: (p,q) = (all,act)
        call mma_allocate(RDMqc,nAshI**2,Label='RDMqc')
        RDMqc(1:nAshT**2) = RDMSA(1:nAshT**2)
        Call DGemm_('T','N',nAshT,nAshT,nAshT,
     &              One,Trf(iSQ+nBasT*nCor+nCor),nBasT,RDMqc,nAshT,
     &              Zero,WRK1,nAshT)
        Call DGemm_('N','N',nAshT,nAshT,nAshT,
     &              One,WRK1,nAshT,Trf(iSQ+nBasT*nCor+nCor),nBasT,
     &              Zero,RDMqc,nAshT)
        !  Then just multiply with G(DPT2)
        CALL DGEMM_('N','N',nOrbI,nAshI,nAshI,
     &              One,FPT2_loc(iSQ+nOrbI*nCor),nOrbI,RDMqc,nAshI,
     &              One,OLAG(iSQ+nOrbI*nCor),nOrbI)
        call mma_deallocate(RDMqc)
        !! From the third term of U_{ij}
        !  FIFA is already in quasi-canonical basis
        CALL DGEMM_('N','T',nOrbI,nAshI,nAshI,
     &              Two,FIFA(1+nOrbI*nCor),nOrbI,DEPSA,nAshI,
     &              One,OLAG(iSQ+nOrbI*nCor),nOrbI)
        iSQ = iSQ + nOrbI*nOrbI
      End Do
!
!     ----- CASSCF density derivative contribution in active space
!
      iSQ = 1
      iSQA= 1
      Do iSym = 1, nSym
        nOrbI = nBas(iSym)-nDel(iSym) !! nOrb(iSym)
        nFroI = nFro(iSym)
        nIshI = nIsh(iSym)
        nAshI = nAsh(iSym)
        nCor  = nFroI + nIshI
        Do iT = 1, nAshI
          iTabs = nCor + iT
          Do iU = 1, nAshI
            iUabs = nCor + iU
            iTU = iTabs-1 + nOrbI*(iUabs-1)
            iTUA= iT   -1 + nAshI*(iU   -1)
            RDMEIG(iSQA+iTUA) = FPT2_loc(iSq+iTU)
          End Do
        End Do
        iSQ = iSQ + nOrbI*nOrbI
        iSQA= iSQA+ nAshI*nAshI
      End Do

      call mma_deallocate(FPT2_loc)

      END SUBROUTINE EigDer2
!
!-----------------------------------------------------------------------
!
      Subroutine DEPSATrf(DEPSA,FPT2,WRK1,WRK2)

      use caspt2_global, only: CMOPT2
      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: IfChol, NSYM, NFRO, NISH, NASH, NASHT,
     &                         NBAS, NBAST, NBSQT
      use Constants, only: Zero, Half

      implicit none

#include "intent.fh"

      real(kind=wp), intent(in) :: DEPSA(nAshT,nAshT)
      real(kind=wp), intent(_OUT_) :: FPT2(*), WRK1(*), WRK2(*)

      real(kind=wp),allocatable :: DAO(:),DMO(:)
      integer(kind=iwp) :: iSym, iSymA, iSymI, iSymB, iSymJ,
     &  nCorI, nBasI, iAsh, jAsh, iAshI, iOrb, jAshI, jOrb

      FPT2(1:nBasT**2) = Zero

      iSym = 1
      iSymA= 1
      iSymI= 1
      iSymB= 1
      iSymJ= 1

!     If (nFroT /= 0.and.IfChol) Then
      If (IfChol) Then
        !! DEPSA(MO) -> DEPSA(AO) -> G(D) in AO -> G(D) in MO
        !! The Cholesky vectors do not contain frozen orbitals...
        call mma_allocate(DAO,NBSQT,Label='DAO')
        call mma_allocate(DMO,NBSQT,Label='DMO')
        !! First, MO-> AO transformation of DEPSA
        Do iSym = 1, nSym
          DMO(:) = Zero
          nCorI = nFro(iSym)+nIsh(iSym)
          nBasI = nBas(iSym)
          Do iAsh = 1, nAsh(iSym)
            Do jAsh = 1, nAsh(iSym)
              DMO(nCorI+iAsh+nBasI*(nCorI+jAsh-1)) = DEPSA(iAsh,jAsh)
            End Do
          End Do
          Call OLagTrf(1,iSym,CMOPT2,DMO,DAO,WRK1)
        End Do
        !! Compute G(D)
        WRK1(1:NBSQT) = Zero
        DMO(:) = Zero
        !! it's very inefficient
        Call OLagFro4(1,1,1,1,1,
     &                DAO,WRK1,DMO,WRK1,WRK2)
        !! G(D) in AO -> G(D) in MO
        Do iSym = 1, nSym
          Call OLagTrf(2,iSym,CMOPT2,FPT2,DMO,WRK1)
        End Do
        call mma_deallocate(DAO)
        call mma_deallocate(DMO)
      Else
        nCorI = nFro(iSym)+nIsh(iSym)
        Do iAshI = 1, nAsh(iSym)
          iOrb = nCorI+iAshI
          Do jAshI = 1, nAsh(iSym)
            jOrb = nCorI+jAshI

            Call Coul(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,WRK1,WRK2)
            FPT2(1:nBasT**2) = FPT2(1:nBasT**2)
     &        + DEPSA(iAshI,jAshI)*WRK1(1:nBasT**2)

            Call Exch(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,WRK1,WRK2)
            FPT2(1:nBasT**2) = FPT2(1:nBasT**2)
     &        - Half*DEPSA(iAshI,jAshI)*WRK1(1:nBasT**2)
          End Do
        End Do
      End If

      Return

      End Subroutine DEPSATrf
!
!-----------------------------------------------------------------------
!
      Subroutine CnstAB_SSDM(DPT2AO,SSDM)

      use ChoVec_io, only: NVLOC_CHOBATCH
      use Cholesky, only: InfVec, nDimRS
      use caspt2_global, only: LuGAMMA,LuAPT2
      use ChoCASPT2, only: NumCho_PT2, MaxVec_PT2, NCHSPC, MXNVC
      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: NSYM, NBAS, NBAST, NBSQT, NBTCHES
      use Constants, only: Zero, One, Two
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, nProcs, myRank
#endif

      implicit none

#include "warnings.h"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      real(kind=wp), intent(in) :: DPT2AO(*),SSDM(*)

      integer(kind=iwp) :: iSkip(8), ipWRK(8), nnbstr(8,3)
      character(len=4096) :: RealName
      logical(kind=iwp) :: is_error
      real(kind=wp),allocatable :: A_PT2(:),CHSPC(:),HTVec(:),WRK(:),
     &  V1(:),V2(:),B_SSDM(:)

      integer(kind=iwp) :: maxvec, n2, iSym, NumChoTot, jSym, nBasI, id,
     &  lRealName, iost, JRED1, JRED2, ipV1, ipV2, IBATCH_TOT, JRED,
     &  JSTART, NVECS_RED, ILOC, IRC, NBATCH, JV1, IBATCH, JNUM,
     &  JV2, JREDC, NUMV, ipVecL, iVec, lscr, JREDL, MUSED, NUMVI, KV1,
     &  JBATCH_TOT, JBATCH, KNUM, KV2, NUMVJ
      real(kind=wp), external :: ddot_
      integer(kind=iwp), external :: isFreeUnit

#ifdef _MOLCAS_MPP_
      logical(kind=iwp) :: bStat
      integer(kind=iwp), allocatable :: map2(:)
      integer(kind=iwp) :: i, lg_V1, ILOV1, IHIV1, JLOV1, JHIV1, MV1,
     &  NDIM1, JVG, iRank
#endif

      ! INFVEC(I,J,K)=IWORK(ip_INFVEC-1+MAXVEC*N2*(K-1)+MAXVEC*(J-1)+I)
      call getritrfinfo(nnbstr,maxvec,n2)
      iSym = 1 !! iSym0

      NumChoTot = 0
      Do jSym = 1, nSym
        NumChoTot = NumChoTot + NumCho_PT2(jSym)
      End Do
      Do jSym = 1, nSym
        iSkip(jSym) = 1
#ifdef _MOLCAS_MPP_
        !! I do not know why this is necessary
        If (is_real_par()) then
          ipWRK(jSym) = 1
        else
#endif
          ipWRK(jSym) = 1
#ifdef _MOLCAS_MPP_
        end if
#endif
      End Do

      nBasI  = nBas(iSym)

      call mma_allocate(A_PT2,MaxVec_PT2**2,Label='A_PT2')

      ! Read A_PT2 from LUAPT2
      id = 0
      call ddafile(LUAPT2, 2, A_PT2, MaxVec_PT2**2, id)

      !! Open B_PT2
      Call PrgmTranslate('GAMMA',RealName,lRealName)
      LuGAMMA = isFreeUnit(LuGAMMA)
      Call MOLCAS_Open_Ext2(LuGamma,RealName(1:lRealName),
     &                     'DIRECT','UNFORMATTED',
     &                      iost,.TRUE.,
     &                      nBas(iSym)**2*8,'OLD',is_error)

      call mma_allocate(CHSPC,NCHSPC,Label='CHSPC')
      call mma_allocate(HTVec,nBasT*nBasT,Label='HTVec')
      call mma_allocate(WRK,nBasT**2,Label='WRK')
      !! V(P) = (mu nu|P)*D_{mu nu}
      call mma_allocate(V1,MaxVec_PT2,Label='V1')
      call mma_allocate(V2,MaxVec_PT2,Label='V2')
      !! B_SSDM(mu,nu,P) = D_{mu rho}*D_{nu sigma}*(rho sigma|P)
      !! Add one more vector
      call mma_allocate(B_SSDM,NCHSPC+NBSQT,Label='B_SSDM')

      IF(NUMCHO_PT2(iSym) == 0) Return

      ! ipnt=ip_InfVec+MaxVec_PT2*(1+InfVec_N2_PT2*(iSym-1))
      ! JRED1=iWork(ipnt)
      ! JRED2=iWork(ipnt-1+NumCho_PT2(iSym))
      JRED1=InfVec(1,2,iSym)
      JRED2=InfVec(NumCho_PT2(iSym),2,iSym)

#ifdef _MOLCAS_MPP_
      If (is_real_par()) then
        call mma_allocate(MAP2,nProcs,Label='MAP2')
        MAP2(:) = 0
        MAP2(myRank+1) = NumChoTot ! MJRED2-JRED1+1
        call GAIGOP(MAP2,NPROCS,'+')
!       ndim2 = sum(map2)

        do i = nprocs, 2, -1
          map2(i) = sum(map2(1:i-1))+1
        end do
        map2(1) = 1
        ipV1 = map2(myRank+1)
        ipV2 = map2(myRank+1)
        V1(:) = Zero
        V2(:) = Zero

        bStat = GA_CREATE_IRREG(MT_DBL,nBasT**2,MaxVec_PT2,'WRK',
     &                          1,1,MAP2,NPROCS,lg_V1)
        CALL GA_DISTRIBUTION(LG_V1,MYRANK,ILOV1,IHIV1,JLOV1,JHIV1)
        CALL GA_ACCESS(LG_V1,ILOV1,IHIV1,JLOV1,JHIV1,MV1,NDIM1)
      else
#endif
        ipV1 = 1
        ipV2 = 1
#ifdef _MOLCAS_MPP_
      end if
#endif

      !! Prepare density matrix
      !! subtract the state-averaged density matrix

      IBATCH_TOT=NBTCHES(iSym)

* Loop over JRED
      DO JRED=JRED1,JRED2

        CALL Cho_X_nVecRS(JRED,iSym,JSTART,NVECS_RED)
        IF(NVECS_RED == 0) Cycle

        ILOC=3
        CALL CHO_X_SETRED(IRC,ILOC,JRED)
* For a reduced set, the structure is known, including
* the mapping between reduced index and basis set pairs.
* The reduced set is divided into suitable batches.
* First vector is JSTART. Nr of vectors in r.s. is NVECS_RED.

* Determine batch length for this reduced set.
* Make sure to use the same formula as in the creation of disk
* address tables, etc, above:
        NBATCH=1+(NVECS_RED-1)/MXNVC

* Loop over IBATCH
        JV1=JSTART
        DO IBATCH=1,NBATCH
!         write(u6,*) 'ibatch,nbatch = ', ibatch,nbatch
          IBATCH_TOT=IBATCH_TOT+1

          JNUM=NVLOC_CHOBATCH(IBATCH_TOT)
          JV2=JV1+JNUM-1

          JREDC=JRED
* Read a batch of reduced vectors
          CALL CHO_VECRD(CHSPC,NCHSPC,JV1,JV2,iSym,
     &                            NUMV,JREDC,MUSED)
          IF(NUMV /= JNUM) THEN
            write(u6,*)' Rats! CHO_VECRD was called, assuming it to'
            write(u6,*)' read JNUM vectors. Instead it returned NUMV'
            write(u6,*)' vectors: JNUM, NUMV=',JNUM,NUMV
            write(u6,*)' Back to the drawing board?'
            CALL QUIT(_RC_INTERNAL_ERROR_)
          END IF
          IF(JREDC /= JRED) THEN
            write(u6,*)' Rats! It was assumed that the Cholesky vectors'
            write(u6,*)' in HALFTRNSF all belonged to a given reduced'
            write(u6,*)' set, but they don''t!'
            write(u6,*)' JRED, JREDC:',JRED,JREDC
            write(u6,*)' Back to the drawing board?'
            write(u6,*)' Let the program continue and see what happens.'
          END IF

          ipVecL = 1
          Do iVec = 1, NUMV

            !! reduced form -> squared AO vector (mu nu|iVec)
            ! If (l_NDIMRS < 1) Then
            If (size(nDimRS) < 1) Then
              lscr  = NNBSTR(iSym,3)
            Else
              JREDL = INFVEC(iVec,2,iSym)
              ! lscr  = iWork(ip_nDimRS+iSym-1+nSym*(JREDL-1)) !! JRED?
              lscr  = nDimRS(iSym,JREDL)
            End If
            WRK(:) = Zero
            Call Cho_ReOrdr(irc,CHSPC(ipVecL),lscr,1,
     &                      1,1,1,iSym,JREDC,2,ipWRK,WRK,
     &                      iSkip)
            ipVecL = ipVecL + lscr

            V1(ipV1+JV1+iVec-2) = DDot_(nBasI**2,DPT2AO,1,WRK,1)
            V2(ipV2+JV1+iVec-2) = DDot_(nBasI**2,SSDM  ,1,WRK,1)

            Call DGemm_('N','N',nBasI,nBasI,nBasI,
     &                  One,DPT2AO,nBasI,WRK,nBasI,
     &                  Zero,HTVec,nBasI)
            Call DGemm_('N','N',nBasI,nBasI,nBasI,
     &                  One,HTVec,nBasI,SSDM,nBasI,
     &                  Zero,B_SSDM(1+nBasT**2*(iVec-1)),nBasI)
          End Do
          NUMVI = NUMV

#ifdef _MOLCAS_MPP_
          If (is_real_par()) then
            Call DCopy_(nBasT**2*NUMV,B_SSDM,1,
     &                  DBL_MB(mV1+NDIM1*(JV1-1)),1)
          else
#endif
            KV1=JSTART
            JBATCH_TOT=NBTCHES(iSym)
            DO JBATCH=1,NBATCH
              JBATCH_TOT=JBATCH_TOT+1

              KNUM=NVLOC_CHOBATCH(JBATCH_TOT)
              KV2=KV1+KNUM-1

              JREDC=JRED
              CALL CHO_VECRD(CHSPC,NCHSPC,KV1,KV2,iSym,
     &                              NUMV,JREDC,MUSED)
              Call R2FIP(CHSPC,WRK,ipWRK,NUMV,
     &                   size(nDimRS),infVec,nDimRS,
     &                   nBasT,nSym,iSym,iSkip,irc,JREDC)

              !! Exchange part of A_PT2
              NUMVJ = NUMV
              CALL DGEMM_('T','N',NUMVI,NUMVJ,nBasT**2,
     &                   -One,B_SSDM,nBasT**2,CHSPC,nBasT**2,
     &                    One,A_PT2(JV1+MaxVec_PT2*(KV1-1)),
     &                        MaxVec_PT2)
              KV1=KV1+KNUM
            END DO
#ifdef _MOLCAS_MPP_
          end if
#endif

          !! Read, add, and save the B_PT2 contribution
          Do iVec = 1, NUMVI
            Read  (Unit=LuGAMMA,Rec=JV1+iVec-1) WRK(1:nBasT**2)
            !! The contributions are doubled,
            !! because halved in PGet1_RI3?
            !! Coulomb
            WRK(1:nBasT**2) = WRK(1:nBasT**2)
     &        + V2(ipV2+iVec-1)*DPT2AO(1:nBasT**2)
     &        + V1(ipV1+iVec-1)*SSDM(1:nBasT**2)
            !! Exchange
            WRK(1:nBasT**2) = WRK(1:nBasT**2)
     &        - B_SSDM(1+nBasT**2*(iVec-1):nBasT**2*iVec)
            Write (Unit=LuGAMMA,Rec=JV1+iVec-1) WRK(1:nBasT**2)
          End Do
          JV1=JV1+JNUM
        End Do
      End Do

#ifdef _MOLCAS_MPP_
      If (is_real_par()) then
        !! Parallel for the exchange part of A_PT2
        A_PT2(:) = A_PT2/real(NPROCS,kind=wp)
        IBATCH_TOT=NBTCHES(iSym)
        DO JRED=JRED1,JRED2
          CALL Cho_X_nVecRS(JRED,iSym,JSTART,NVECS_RED)
          IF(NVECS_RED == 0) Cycle
          ILOC=3
          CALL CHO_X_SETRED(IRC,ILOC,JRED)
          NBATCH=1+(NVECS_RED-1)/MXNVC
* Loop over IBATCH
          JV1=JSTART
          DO IBATCH=1,NBATCH
!           write(u6,*) 'ibatch,nbatch = ', ibatch,nbatch
            IBATCH_TOT=IBATCH_TOT+1

            JNUM=NVLOC_CHOBATCH(IBATCH_TOT)
            JV2=JV1+JNUM-1

            JREDC=JRED
* Read a batch of reduced vectors
            CALL CHO_VECRD(CHSPC,NCHSPC,JV1,JV2,iSym,NUMV,JREDC,MUSED)
            Call R2FIP(CHSPC,WRK,ipWRK,NUMV,size(nDimRS),infVec,nDimRS,
     &                 nBasT,nSym,iSym,iSkip,irc,JREDC)
            NUMVJ = NUMV

            !! Exchange part of A_PT2
            JVG   = JV1+MAP2(myRank+1)-1
            Do iRank = 0, NPROCS-1
              CALL GA_DISTRIBUTION(LG_V1,iRank,ILOV1,IHIV1,JLOV1,JHIV1)
              CALL GA_GET(LG_V1,ILOV1,IHIV1,JLOV1,JHIV1,B_SSDM,
     &                    NDIM1)
              NUMVI = JHIV1-JLOV1+1
              CALL DGEMM_('T','N',NUMVI,NUMVJ,nBasT**2,
     &                   -One,B_SSDM,nBasT**2,CHSPC,nBasT**2,
     &                    One,A_PT2(JLOV1+MaxVec_PT2*(JVG-1)),
     &                        MaxVec_PT2)
            end do
            JV1=JV1+JNUM
          End Do
        End Do
        CALL GADSUM (A_PT2,MaxVec_PT2**2)
        bStat = GA_Destroy(lg_V1)

        CALL GADSUM (V1,MaxVec_PT2)
        CALL GADSUM (V2,MaxVec_PT2)
        call mma_deallocate(MAP2)
      end if
#endif

      !! Coulomb for A_PT2
      !! Consider using DGER?
      Call DGEMM_('N','T',MaxVec_PT2,MaxVec_PT2,1,
     &            Two,V1,MaxVec_PT2,V2,MaxVec_PT2,
     &            One,A_PT2,MaxVec_PT2)

      ! write to A_PT2 in LUAPT2
      id = 0
      call ddafile(LUAPT2, 1, A_PT2, MaxVec_PT2**2, id)

      !! close B_PT2
      Close (LuGAMMA)

      call mma_deallocate(A_PT2)

      call mma_deallocate(CHSPC)
      call mma_deallocate(HTVec)
      call mma_deallocate(WRK)
      call mma_deallocate(V1)
      call mma_deallocate(V2)
      call mma_deallocate(B_SSDM)

      End Subroutine CnstAB_SSDM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Tri2Rec(OvlTri,OvlRec,nBas,Debug)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBas
real(kind=wp), intent(in) :: OvlTri(*)
real(kind=wp), intent(out) :: OvlRec(nBas,nBas)
logical(kind=iwp), intent(in) :: Debug
integer(kind=iwp) :: iBas, ifr, ito, jBas, nlig

ifr = 1
do nlig=1,nBas
  ito = ifr+nlig-1
  OvlRec(1:nlig,nlig) = OvlTri(ifr:ito)
  ifr = ito+1
end do

do iBas=1,nBas
  do jBas=nBas,iBas,-1
    OvlRec(jBas,iBas) = OvlRec(iBas,jBas)
  end do
end do

if (Debug) call RecPrt('OvlRec ',' ',OvlRec,nBas,nBas)

return

end subroutine Tri2Rec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine RHS_ALLO(NAS,NIS,lg_W)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use fake_GA, only: Allocate_GA_Array
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NAS, NIS
integer(kind=iwp), intent(out) :: lg_W
integer(kind=iwp) :: NW

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  call GA_CREATE_STRIPED('V',NAS,NIS,'RHS',LG_W)
else
#endif
  NW = NAS*NIS
  lg_W = Allocate_GA_Array(NW,'RHS')
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine RHS_ALLO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_DECDRV(DIAG)
C
C     Purpose: driver for the decomposition of the two-electron integral
C              matrix based on the reduced diagonal.
C
#include "implicit.fh"
      DIMENSION DIAG(*)
#include "cholesky.fh"
#include "chovecbuf.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      INTEGER ISYLST(8)
      REAL*8  DIAMAX_SIMP(8)

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_DECDRV')

      CHARACTER*7 FILSEL

      CHARACTER*20 STRING

      LOGICAL CONV, SYNC, LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

      INTEGER  CHO_P_GETMPASS
      EXTERNAL CHO_P_GETMPASS

      INFRED(I)=IWORK(ip_INFRED-1+I)


C     Start timing.
C     -------------

      CALL CHO_TIMER(TCPU1,TWALL1)

C     Initializations and static settings.
C     IRED=2: points to current reduced set in index arrays.
C     ------------------------------------------------------

      IRED  = 2
      CONV  = .FALSE.

C     Initialize Cholesky vector buffer.
C     ----------------------------------

      CALL CHO_VECBUF_INIT(FRAC_CHVBUF,NNBSTR(1,1))
      IF (LOCDBG .OR. IPRINT.GE.INF_VECBUF) THEN
         CALL CHO_VECBUF_PRINT(LUPRI,NSYM)
      END IF

C     Allocate memory for shell pair based diagonal.
C     It is important that the DIASH allocation is first, as memory is
C     released by flushing back to and including this allocation.
C     ----------------------------------------------------------------

      CALL CHO_P_GETGSP(NGSP)
      CALL CHO_MEM('DIASH','ALLO','REAL',KDIASH,NGSP)
      CALL CHO_MEM('ISYSH','ALLO','INTE',KISYSH,NGSP)

C     Set first integral pass.
C     ------------------------

      SYNC = .FALSE.
      NPOTSH = 0
      CALL CHO_P_SETPASS(DIAG,SYNC,WORK(KDIASH),IWORK(KISYSH),IRED,CONV,
     &                   NPOTSH)
      IF (NPOTSH .GT. 0) THEN
         IF (CONV) THEN
            CALL CHO_QUIT('Logical error [0.1] in '//SECNAM,103)
         END IF
      ELSE
         IF (.NOT. CONV) THEN
            CALL CHO_QUIT('Logical error [0.2] in '//SECNAM,103)
         END IF
      END IF

C     Allocate shell pair list.
C     -------------------------

      l_LSTQSP = MAX(NPOTSH,1)
      CALL CHO_MEM('LSTQSP','ALLO','INTE',ip_LSTQSP,l_LSTQSP)

C     Loop over integral passes. Continue until convergence or
C     until the max. number of integral passes has been reached.
C     To each integral pass there is associated a reduced set,
C     so the IPASS counter is also used as identifier of reduced
C     set during I/O.
C     ----------------------------------------------------------

      IPASS = XNPASS
      JPASS = 0
      MPASS = CHO_P_GETMPASS(IRED)
      DO WHILE ((.NOT.CONV) .AND. (JPASS.LT.MPASS))

C        Update integral pass counter.
C        -----------------------------

         JPASS = JPASS + 1
         IPASS = IPASS + 1

C        Print.
C        ------

         IF (IPRINT .GE. INF_PASS) THEN
             CALL CHO_TIMER(TLTOT1,WLTOT1)
             WRITE(STRING,'(A13,I7)') 'Integral Pass',IPASS
             CALL CHO_HEAD(STRING,'*',80,LUPRI)
         END IF

C        Update idle proc info.
C        ----------------------

         If (Trace_Idle) Then
            nDim_Now=nnBstR(1,2)
            Do iSym=2,nSym
               nDim_Now=nDim_Now+nnBstR(iSym,2)
            End Do
            Call Cho_TrcIdl_Update(nDim_Now.lt.1)
         End If

C        Debug: print diagonal.
C        ----------------------

         IF (LOCDBG) THEN
            WRITE(LUPRI,*) SECNAM,': debug: diagonal before pass ',
     &                     IPASS
            DO ISYM = 1,NSYM
               ISYLST(ISYM) = ISYM
            END DO
            SYNC = .FALSE.
            CALL CHO_P_PRTDIA(DIAG,SYNC,ISYLST,NSYM,IRED)
            WRITE(LUPRI,*)
            WRITE(LUPRI,*) SECNAM,': INFRED before pass ',IPASS
            WRITE(LUPRI,'(10I8)') (INFRED(I),I=1,MIN(IPASS,MAXRED))
         END IF

C        Write index arrays for reduced set to disk
C        and update disk address.
C        ------------------------------------------

         CALL CHO_P_PUTRED(IPASS,IRED)

C        Maintain Cholesky vector buffer.
C        The logicals request that statistics informations are updated
C        in the maintainance routine.
C        -------------------------------------------------------------

         IRC = 0
         IPASS_PREV = IPASS - 1
         CALL CHO_VECBUF_MAINTAIN(IRC,IPASS_PREV,.TRUE.,.TRUE.)
         IF (IRC .NE. 0) THEN
            WRITE(LUPRI,*) SECNAM,': CHO_VECBUF_MAINTAIN returned ',IRC
            CALL CHO_QUIT('Error detected in '//SECNAM,IRC)
         END IF

C        Open scratch files for qualified integral columns.
C        --------------------------------------------------

         DO ISYM = 1,NSYM
            IF (NNBSTR(ISYM,2) .GT. 0) THEN
               LUSEL(ISYM) = 7
               WRITE(FILSEL,'(A6,I1)') 'CHOSEL',ISYM
               CALL DANAME_WA(LUSEL(ISYM),FILSEL)
            ELSE
               LUSEL(ISYM) = -1
            END IF
         END DO

C        Get integral columns on disk stored in current reduced set.
C        -----------------------------------------------------------

         IF (IPRINT .GE. INF_PASS) CALL CHO_TIMER(TLINT1,WLINT1)
         NUM = 0
         CALL CHO_GETINT(DIAG,WORK(KDIASH),IWORK(KISYSH),
     &                   IWORK(ip_LSTQSP),NPOTSH,NUM)
         CALL CHO_FLUSH(LUPRI)
         IF (IPRINT .GE. INF_PASS) CALL CHO_TIMER(TLINT2,WLINT2)

C        Decompose the qualified integral columns.
C        -----------------------------------------

         IF (IPRINT .GE. INF_PASS) CALL CHO_TIMER(TLDEC1,WLDEC1)
         IF (CHO_DECALG.EQ.4 .OR. CHO_DECALG.EQ.5 .OR. CHO_DECALG.EQ.6)
     &   THEN
            CALL CHO_DECOM_A4(DIAG,IWORK(ip_LSTQSP),NUM,IPASS)
         ELSE
            IF (CHO_SIMP) THEN
               CALL CHO_MAXDX(DIAG,DIAMAX_SIMP)
               DO ISYM = 1,NSYM
                  DIAMIN(ISYM) = MAX(THRCOM,DIAMAX_SIMP(ISYM)*SPAN)
               END DO
            END IF
            CALL CHO_MEM('MaxMem','MAX ','REAL',KWRK,LWRK)
            CALL CHO_DECOM(DIAG,WORK(KWRK),LWRK,IPASS,NUM)
            CALL CHO_MEM('MaxMem','FREE','REAL',KWRK,LWRK)
         END IF
         CALL CHO_FLUSH(LUPRI)
         IF (IPRINT .GE. INF_PASS) CALL CHO_TIMER(TLDEC2,WLDEC2)

C        Sync global vector counter.
C        ---------------------------

         CALL CHO_P_SYNCNUMCHO(NUMCHO,NSYM)

C        Write restart info to disk.
C        ---------------------------

         CALL CHO_P_WRRSTC(IPASS)

C        Close scratch files for qualified integral columns.
C        ---------------------------------------------------

         DO ISYM = 1,NSYM
            IF (LUSEL(ISYM) .GT. 0) THEN
               CALL DACLOS(LUSEL(ISYM))
            END IF
         END DO

C        Sync diagonal.
C        --------------

         CALL CHO_P_SYNCDIAG(DIAG,2)

C        Analyze diagonal.
C        -----------------

         IF (IPRINT .GE. INF_PASS) THEN
            BIN1 = 1.0D2
            STEP = 1.0D-1
            NBIN = 18
            SYNC = .FALSE.
            CALL CHO_P_ANADIA(DIAG,SYNC,BIN1,STEP,NBIN,.FALSE.)
         END IF

C        Get next reduced set.
C        ---------------------

         SYNC = .FALSE.
         CALL CHO_P_SETRED(DIAG,SYNC)
         KRED = IPASS + 1
         CALL CHO_SETRSDIM(IWORK(ip_NDIMRS),NSYM,MAXRED,KRED,IRED)
         IF (IPRINT .GE. INF_PASS) THEN
            CALL CHO_P_PRTRED(2)
            CALL CHO_FLUSH(LUPRI)
         END IF

C        Check convergence and, if not converged, set next integral
C        pass.
C        ----------------------------------------------------------

         SYNC = .FALSE.
         NPOTSH = 0
         CALL CHO_P_SETPASS(DIAG,SYNC,WORK(KDIASH),IWORK(KISYSH),IRED,
     &                      CONV,NPOTSH)
         IF (NPOTSH .GT. 0) THEN
            IF (CONV) THEN
               CALL CHO_QUIT('Logical error [1.1] in '//SECNAM,103)
            END IF
         ELSE
            IF (.NOT. CONV) THEN
               CALL CHO_QUIT('Logical error [1.2] in '//SECNAM,103)
            END IF
         END IF

C        Update bookmarks: store largest diagonal (integral accuracy)
C        and number of Cholesky vectors.
C        ------------------------------------------------------------

         Call Cho_P_UpdateBookmarks(iPass)

C        Print idle report.
C        ------------------

         If (Trace_Idle) Then
            Call Cho_TrcIdl_Report()
         End If

C        Print timing for this pass.
C        ---------------------------

         IF (IPRINT .GE. INF_PASS) THEN
            TLINT = TLINT2 - TLINT1
            WLINT = WLINT2 - WLINT1
            TLDEC = TLDEC2 - TLDEC1
            WLDEC = WLDEC2 - WLDEC1
            CALL CHO_TIMER(TLTOT2,WLTOT2)
            TLTOT = TLTOT2 - TLTOT1
            WLTOT = WLTOT2 - WLTOT1
            WRITE(LUPRI,'(/,A,I7,A)')
     &      'Overall timings for integral pass',IPASS,
     &      ' (CPU/Wall in seconds):'
            WRITE(LUPRI,'(A,F12.2,1X,F12.2)')
     &      'Integrals (incl. qualified I/O etc.): ',TLINT,WLINT
            WRITE(LUPRI,'(A,F12.2,1X,F12.2)')
     &      'Decomposition of qualified columns  : ',TLDEC,WLDEC
            WRITE(LUPRI,'(A,F12.2,1X,F12.2)')
     &      'Total (incl. restart info I/O etc.) : ',TLTOT,WLTOT
         END IF

      END DO

C     Free memory for shell pair based diagonal.
C     ------------------------------------------

      CALL CHO_MEM('DIASH','FLUSH','REAL',KDIASH,NNSHL)

C     Shut down the Cholesky vector buffer.
C     -------------------------------------

      CALL CHO_VECBUF_FINAL()

C     Set stuff for statistics.
C     -------------------------

      DID_DECDRV = .TRUE.
      XNPASS     = IPASS

C     Timing.
C     -------

      CALL CHO_TIMER(TCPU2,TWALL2)
      TDECDRV(1) = TCPU2  - TCPU1
      TDECDRV(2) = TWALL2 - TWALL1


      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine cnfcheck2_cvb(iconfs,nconf1,nel1)

use casvb_global, only: noe, norb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: nconf1, iconfs(noe,nconf1)
integer(kind=iwp), intent(in) :: nel1
integer(kind=iwp) :: i, iconf, ii, iorb, jconf, nsum
logical(kind=iwp) :: found, locc, locc_only, lorbs, lorbs_only
integer(kind=iwp), allocatable :: iocc(:)

if (nconf1 == 0) then
  ! Special case -- iconfs will be ok and adhere to occ no definition.
  nconf1 = 1
  return
end if

! Perform basic checks of configurations:
! First determine if a consistent definition (orb list or
! occ numbers) has been used for the configurations.
!
! We do this in two parses. locc_only/lorbs_only are set in
! first run through if *any* iconf unamiguously adheres to
! one of the definitions.
!
! Second run through if necessary we check again in case iconfs
! contains *both* types of definitions.

call mma_allocate(iocc,noe,label='iocc')

locc_only = .false.
lorbs_only = .false.
do iconf=1,nconf1
  ! Consistency with occ no definition?
  locc = .true.
  do i=norb+1,noe
    if (iconfs(i,iconf) /= 0) then
      locc = .false.
      exit
    end if
  end do
  nsum = 0
  do i=1,norb
    if ((iconfs(i,iconf) < 0) .or. (iconfs(i,iconf) > 2)) locc = .false.
    nsum = nsum+iconfs(i,iconf)
  end do
  if (nsum /= nel1) locc = .false.
  ! Consistency with orb list definition?
  lorbs = .true.
  do i=nel1+1,noe
    if (iconfs(i,iconf) /= 0) then
      lorbs = .false.
      exit
    end if
  end do
  iocc(1:norb) = 0
  do i=1,nel1
    if ((iconfs(i,iconf) >= 1) .and. (iconfs(i,iconf) <= norb)) then
      iocc(iconfs(i,iconf)) = iocc(iconfs(i,iconf))+1
    else
      lorbs = .false.
    end if
  end do
  do i=1,norb
    if (iocc(i) > 2) then
      lorbs = .false.
      exit
    end if
  end do

  if (locc .and. (.not. lorbs)) then
    locc_only = .true.
  else if (lorbs .and. (.not. locc)) then
    lorbs_only = .true.
  else if ((.not. lorbs) .and. (.not. locc)) then
    write(u6,*) ' Illegal configuration read ',iconf
    write(u6,*) iconfs(1:noe,iconf)
    call abend_cvb()
  end if
end do

locc = locc_only
lorbs = lorbs_only
do iconf=1,nconf1
  if (locc_only .and. lorbs_only) then
    ! Check again ...
    ! Consistency with occ no definition?
    locc = .true.
    do i=norb+1,noe
      if (iconfs(i,iconf) /= 0) then
        locc = .false.
        exit
      end if
    end do
    nsum = 0
    do i=1,norb
      if ((iconfs(i,iconf) < 0) .or. (iconfs(i,iconf) > 2)) locc = .false.
      nsum = nsum+iconfs(i,iconf)
    end do
    if (nsum /= nel1) locc = .false.
    ! Consistency with orb list definition?
    lorbs = .true.
    do i=nel1+1,noe
      if (iconfs(i,iconf) /= 0) then
        lorbs = .false.
        exit
      end if
    end do
    iocc(1:norb) = 0
    do i=1,nel1
      if ((iconfs(i,iconf) >= 1) .and. (iconfs(i,iconf) <= norb)) then
        iocc(iconfs(i,iconf)) = iocc(iconfs(i,iconf))+1
      else
        lorbs = .false.
      end if
    end do
    do i=1,norb
      if (iocc(i) > 2) then
        lorbs = .false.
        exit
      end if
    end do
  end if
  if (locc .and. lorbs) then
    ! Comment out following 5 lines if default should be occ no definition:
    iocc(1:norb) = 0
    do i=1,nel1
      iocc(iconfs(i,iconf)) = iocc(iconfs(i,iconf))+1
    end do
    iconfs(1:norb,iconf) = iocc(1:norb)
    if (noe-norb > 0) iconfs(norb+1:,iconf) = 0
  else if (lorbs) then
    iocc(1:norb) = 0
    do i=1,nel1
      iocc(iconfs(i,iconf)) = iocc(iconfs(i,iconf))+1
    end do
    iconfs(1:norb,iconf) = iocc(1:norb)
    if (noe-norb > 0) iconfs(norb+1:,iconf) = 0
  end if
  if (iconf <= 500) then
    ! Test for repeated configurations:
    do jconf=1,iconf-1
      found = .false.
      do iorb=1,norb
        if (iconfs(iorb,iconf) /= iconfs(iorb,jconf)) then
          found = .true.
          exit
        end if
      end do
      if (.not. found) then
        write(u6,'(/,a,2i4)') ' Fatal error - spatial VB configuration repeated :',jconf,iconf
        write(u6,'(i8,a,20i3)') jconf,'   =>  ',(iocc(ii),ii=1,norb)
        write(u6,'(i8,a,20i3)') iconf,'   =>  ',(iocc(ii),ii=1,norb)
        call abend_cvb()
      end if
    end do
  end if
end do

call mma_deallocate(iocc)

return

end subroutine cnfcheck2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_W_worker

   USE fmm_global_paras

   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_get_ltsqr_W_matrix,       &
             fmm_get_boundary_W_matrix,    &
             fmm_contract_Wq

CONTAINS

!-------------------------------------------------------------------------------
! Routine to build the lower-triangular elements of a square W_matrix.
! Only the non-zero elements of the full square matrix are written.
! LMAX is the order of translation:
!  W_lm,jk is built for all l and j <= LMAX
! r_ab is the translation vector (final-initial).
! (note to translate a potential -r_ab should be passed, and W' used)

   SUBROUTINE fmm_get_ltsqr_W_matrix(LMAX,JMAX,r_ab,W_matrix)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX, JMAX
      REAL(REALK),   INTENT(IN)  :: r_ab(3)
      REAL(REALK),   INTENT(OUT) :: W_matrix(:,:)
      INTEGER(INTK) :: n,m

      n = MAX(LMAX,JMAX)
      m = MIN(LMAX,JMAX)
      CALL fmm_build_ltsqr_W_matrix

   CONTAINS

      SUBROUTINE fmm_build_ltsqr_W_matrix
         IMPLICIT NONE
         REAL(REALK) :: R_sh(-n:n,0:n)

         CALL fmm_generate_R(n,-r_ab,R_sh)
          ! note minus sign above - see TUH eqn.(9.13.58)
         CALL fmm_generate_W(n,m,R_sh,W_matrix)

      END SUBROUTINE fmm_build_ltsqr_W_matrix

   END SUBROUTINE fmm_get_ltsqr_W_matrix

!-------------------------------------------------------------------------------
! Get single-column W-matrix for getting boundary potential only

   SUBROUTINE fmm_get_boundary_W_matrix(LMAX,r_ab,W_matrix)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: r_ab(3)
      REAL(REALK),   INTENT(OUT) :: W_matrix(:,:)

      REAL(REALK) :: R_sh(-LMAX:LMAX,0:LMAX)

      CALL fmm_generate_R(LMAX,-r_ab,R_sh)
       ! note minus sign above - see TUH eqn.(9.13.58)
      CALL fmm_generate_boundary_W(LMAX,R_sh,W_matrix)

   END SUBROUTINE fmm_get_boundary_W_matrix

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_generate_R(LMAX,point,R_sh)

   ! Subroutine to generate scaled regular solid harmonics
   ! See page 416, "Molecular Electronic Structure Theory"
   !-------------------------------------------------------
   ! R_sh(M,L)  == COS component of R_sh(M,L)
   ! R_sh(-M,L) == SIN component of R_sh(-M,L)
   ! where L and M are positive
   ! Note that R_sh(0,L) == COS component of R_sh(0,L) !
   !-------------------------------------------------------

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: point(3)
      REAL(REALK),   INTENT(OUT) :: R_sh(-LMAX:LMAX,0:LMAX)

      REAL(REALK)   :: x,y,z, r_2,r_minus2
      REAL(REALK)   :: A(6)
      INTEGER(INTK) :: signl, l,m

      A(:) = zero
      x = point(1)
      y = point(2)
      z = point(3)
      r_2 = DOT_PRODUCT(point,point)
      r_minus2 = one/(r_2)

      IF (r_2 < ZERO_VECT_TOL*ZERO_VECT_TOL) THEN
         WRITE(6,'(3E25.15)') point
         CALL fmm_quit('ERROR: Why do we try to do zero W-vector.')
      END IF

      IF (LMAX==0) THEN
         R_sh(0,0) = one
         RETURN
      END IF

      ! Start with initialization of lowest order terms

      R_sh( 0,0) = one       ! cannot assign "sin" terms for m==0
      R_sh(-1,1) = -half*y
      R_sh( 0,1) = z         ! cannot assign "sin" terms for m==0
      R_sh( 1,1) = -half*x

      ! Now iterate higher order terms

      signl = -1
      lloop: DO l = 2, LMAX
         signl = -signl
         A(1) = one/(2*l)
         A(2) = A(1)*x
         A(3) = A(1)*y*signl

         ! cos terms:
         R_sh( l,l) = A(3)*R_sh(1-l,l-1) - A(2)*R_sh(l-1,l-1)
         ! sin terms:
         R_sh(-l,l) = A(3)*R_sh(l-1,l-1) + A(2)*R_sh(1-l,l-1)

         A(5) = (2*l-1)*(z)*(r_minus2)
         DO m = 0, (l-2)
            A(6) = (r_2)/(l*l-m*m)
            ! cos terms:
            R_sh( m,l) = A(6)*( A(5)*R_sh(m,l-1) - R_sh(m,l-2) )
            ! sin terms:
            R_sh(-m,l) = A(6)*( A(5)*R_sh(-m,l-1) - R_sh(-m,l-2) )
         END DO

         ! Now do (l,l-1) terms to avoid calling elements that do not exist
         m = l-1
         ! cos terms:
         R_sh( m,l) = z*R_sh(m,l-1)
         ! sin terms:
         R_sh(-m,l) = z*R_sh(-m,l-1)

      END DO lloop

   END SUBROUTINE fmm_generate_R

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_generate_W(LMAX,JMAX,R_sh,W_matrix)

   ! Subroutine to generate Real Translation Matrix for
   ! given point from the Regular Solid Harmonics R_sh(m,l)
   ! cf Helgaker et. al. pp 413
   ! Note that W-matrix is lower triangular wrt W(lm,jk) and that
   ! only NON-ZERO elements are added here.
   ! We must therefore zero W_matrix initially, or use a special contractor
   !------------------------------------------------------------------------

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX, JMAX
      REAL(REALK),   INTENT(IN)  :: R_sh(-LMAX:LMAX,0:LMAX)
      REAL(REALK),   INTENT(OUT) :: W_matrix(:,:)

      INTEGER(INTK) :: l,m,j,k, a,b, q, pp,qq, lm_min,lm_max
      INTEGER(INTK) :: signk, phase

      ! l==j case first:
      ! diagonal = one
      ! all other off-diagonal elements identically zero
      DO j = 0, JMAX
         qq = j*(j+1) +1
         DO k = -j, j
            q = qq+k
            W_matrix(q,q) = one
         END DO
      END DO

      IF (LMAX==0) RETURN
      IF (JMAX > LMAX) CALL fmm_quit('error in fmm_generate_W')

      ! remaining l:
      jloop: DO j = 0, JMAX
         qq = j*(j+1) +1

         ! loop over positive k
         signk = -1
         kloop1: DO k = 0, j
            signk = -signk
            q = qq+k

            lloop1: DO l = (j+1), LMAX
               a = (l-j)
               pp = l*(l+1) +1

               ! cos-cos terms
               !--------------

               ! (m-k) terms
               phase = 1
               DO m = (k-1), MAX((k-a),0), -1     ! reverse order
                  ! (m-k)<0
                  phase = -phase
                  b = -(m-k)
                  W_matrix(pp+m,q) = phase*R_sh(b,a)
               END DO
               DO m = k, (a+k)      ! (a+k)<l
                  ! (m-k)>=0
                  b = (m-k)
                  W_matrix(pp+m,q) = R_sh(b,a)
               END DO
               ! (m+k) terms
               DO m = 0, (a-k)   ! always overlaps (m-k) terms
                  ! (m+k)>=0
                  b = (m+k)
                  W_matrix(pp+m,q) = W_matrix(pp+m,q) + signk*R_sh(b,a)
               END DO

               ! sin-cos terms
               !--------------

               ! m==-k first
               m = MIN(-k,-1)
               W_matrix(pp+m,q) = zero
               ! (m+k) terms
               DO m = -(k+a), -(k+1)
                  ! (m+k)<0
                  b = (m+k)
                  W_matrix(pp+m,q) = signk*R_sh(b,a)
               END DO
               phase = -signk
               DO m = -k+1, MIN(-1,(a-k))
                  ! (m+k)>0
                  phase = -phase
                  b = -(m+k)
                  W_matrix(pp+m,q) = phase*R_sh(b,a)
               END DO
               ! (m-k) terms
               DO m = (k-a), -1   ! always overlap (m+k) terms
                  ! (m-k)<0
                  b = (m-k)
                  W_matrix(pp+m,q) = W_matrix(pp+m,q) + R_sh(b,a)
               END DO

            END DO lloop1
         END DO kloop1

         ! (half)**(delta(0,k)) correction:
         lm_min = j*(j+2) +2
         lm_max = LMAX*(LMAX+2) +1
         W_matrix(lm_min:lm_max,qq) = half*W_matrix(lm_min:lm_max,qq)   !k==0

         ! loop over negative k
         signk = 1
         kloop2: DO k = -1, -j, -1     ! reverse order
            signk = -signk
            q = qq+k

            lloop2: DO l = (j+1), LMAX
               a = (l-j)
               pp = l*(l+1) +1

               ! cos-sin terms
               !--------------
               ! (m+k) terms
               DO m = MAX(0,-(a+k)), (-k-1)
                  ! (m+k)<0
                  b = (m+k)
                  W_matrix(pp+m,q) = signk*R_sh(b,a)
               END DO
               m = -k
               W_matrix(pp+m,q) = zero
               phase = -signk
               DO m = -k+1, (a-k)  !<=l
                  ! (m+k)>=0
                  phase = -phase
                  b = -(m+k)
                  W_matrix(pp+m,q) = phase*R_sh(b,a)
               END DO
               ! (m-k) terms
               phase = signk
               DO m = 0, (a+k)    ! always overlap (m+k) terms
                  ! (m-k)>0
                  phase = -phase
                  b = -(m-k)
                  W_matrix(pp+m,q) = W_matrix(pp+m,q) - phase*R_sh(b,a)
               END DO

               ! sin-sin terms
               !--------------

               ! (m-k) terms
               phase = 1
               DO m = (k-1), (k-a), -1    ! reverse order
                  ! (m-k)<0
                  phase = -phase
                  b = -(m-k)
                  W_matrix(pp+m,q) = phase*R_sh(b,a)
               END DO
               DO m = k, MIN(-1,(a+k))
                  ! (m-k)>=0
                  b = (m-k)
                  W_matrix(pp+m,q) = R_sh(b,a)
               END DO
               ! (m+k) terms
               phase = 1
               DO m = -1, -(a+k), -1     ! reverse order
                  ! (m+k)<0              ! always overlap (m-k) terms
                  phase = -phase
                  b = -(m+k)
                  W_matrix(pp+m,q) = W_matrix(pp+m,q) - phase*R_sh(b,a)
               END DO

            END DO lloop2
         END DO kloop2
      END DO jloop

   END SUBROUTINE fmm_generate_W

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_generate_boundary_W(LMAX,R_sh,W_matrix)

! This is a simplified version of fmm_generate_W_matrix when building
! only the boundary potential, when only one column of the W-matrix
! is required.

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: R_sh(-LMAX:LMAX,0:LMAX)
      REAL(REALK),   INTENT(OUT) :: W_matrix(:,:)

      INTEGER(INTK) :: l,m,pp

      W_matrix(1,1) = one
      DO l = 1, LMAX
         pp = l*(l+1) +1
         DO m = -l, l
            W_matrix(pp+m,1) = R_sh(m,l)
         END DO
      END DO

   END SUBROUTINE fmm_generate_boundary_W

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_contract_Wq(N_or_T,W_mat,WLDA,vec_in,n,vec_out,m)

      IMPLICIT NONE
      CHARACTER(LEN=1),  INTENT(IN):: N_or_T
      INTEGER(INTK), INTENT(IN)    :: n,m,WLDA
      REAL(REALK),   INTENT(IN)    :: W_mat(WLDA,WLDA)
      REAL(REALK),   INTENT(IN)    :: vec_in(n)
      REAL(REALK),   INTENT(INOUT) :: vec_out(m)

      INTEGER(INTK) :: q

      IF (N_or_T == 'N') THEN
         DO q = 1, n
            vec_out(q:m) = vec_out(q:m) + W_mat(q:m,q)*vec_in(q)
         END DO
      ELSE
         ! Perform transpose contraction
         DO q = 1, m
            vec_out(q) = vec_out(q) + DOT_PRODUCT(W_mat(q:n,q),vec_in(q:n))
         END DO
      END IF

   END SUBROUTINE fmm_contract_Wq

!-------------------------------------------------------------------------------

END MODULE fmm_W_worker

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_RI_SwapVecUnit(iSym)
      Implicit None
      Integer iSym
#include "cholesky.fh"
#include "choglob.fh"
      Logical doSwap
      Integer iTmp
#if defined (_MOLCAS_MPP_)
#include "para_info.fh"
      doSwap = nProcs.gt.1 .and. Is_Real_Par()
#else
      doSwap = .False.
#endif

      If (doSwap) Then
         iTmp = LuCho(iSym)
         LuCho(iSym) = LuCho_G(iSym)
         LuCho_G(iSym) = iTmp
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine dirvect( P1, R1, P2, R2,  vec, dist )
c this Subroutine computes the directional vector of the origins of two points P1 and P2
      Implicit None
      Integer, parameter         :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Real(kind=8), intent(in)  :: P1(3) ! coords of the first point
      Real(kind=8), intent(in)  :: P2(3) ! coords of the second point
!     rot. matrix of the  first point to the general coordinate system
      Real(kind=8), intent(in)  :: R1(3,3)
!     rot. matrix of the second point to the general coordinate system
      Real(kind=8), intent(in)  :: R2(3,3)
      Real(kind=8), intent(out) :: vec(3)
      Real(kind=8), intent(out) :: dist
c local variables
      Integer       :: i, j
      Real(kind=8) :: C1(3), C2(3)
      Real(kind=8) :: distance
      External      :: distance

      vec=0.0_wp
      dist=0.0_wp
      C1=0.0_wp
      C2=0.0_wp

      Do i=1,3
         Do j=1,3
            C1(i) = C1(i) + P1(j)*R1(i,j)
            C2(i) = C2(i) + P2(j)*R2(i,j)
         End Do
      End Do
      dist=distance(3, C1, C2 )
      Do i=1,3
        vec(i)=( C1(i)-C2(i) ) / dist
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! generate and print csfs
subroutine found_a_config(ndl,de,npr)

use gugaci_global, only: ipae, iseg_downwei, iw_downwei, iw_sta, jd, jpad, jpad_upwei, jpae, js, jt, jv, map_orb_order, mxnode, &
                         ndim, ndr, ng_sm, nlsm_frz, noidx, norb_act, norb_all, norb_dz, norb_ext, nu_ad, nu_ae, nwalk
                         !, lsmorb, norb_frz
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndl, npr
real(kind=wp), intent(in) :: de
integer(kind=iwp) :: i, im, iwupwei, j, jaedownwei, jpad_, l, ndimsum, ne, no_dz, noi, ns, nst
real(kind=wp) :: sqde
integer(kind=iwp), allocatable :: norbindex(:), norbsymm(:), norbwalk(:), nwalk_gamess(:)
character(len=18) :: form1

ndr = ndl
nst = norb_all
do l=1,norb_ext+norb_act
  nwalk(l) = 0
end do
no_dz = nst-norb_dz+1
do l=no_dz,nst
  nwalk(l) = 3
end do
ndimsum = 0
if ((npr == 1) .or. (npr == 0)) then
  jpae = jv
  ipae = 1
  jaedownwei = iseg_downwei(ipae)
  jpad = 1
  iw_sta(jpad,ipae) = ndimsum
  call seg_drt()                             !   jpad_upwei(*)        = jp
  iwupwei = jpad_upwei(jpad)                 !   iw_sta(jpad,jpae)
  iw_downwei(jpad,ipae) = ndim               !   iw_downwei(jpad,jpae)
  ndimsum = ndimsum+ndim*jaedownwei*iwupwei  !   iseg_dim(jpae)    =
  call config_act()                          !   jpae_upwei(jpae)  =
else

  jpae = jv
  ipae = 1
  jaedownwei = iseg_downwei(ipae)
  do jpad_=1,mxnode
    jpad = jpad_ ! jpad is in global module, is this necessary?
    iw_sta(jpad,ipae) = ndimsum
    if (nu_ad(jpad) == 0) cycle
    call seg_drt()                             !   jpad_upwei(*)        = jp
    iwupwei = jpad_upwei(jpad)                 !   iw_sta(jpad,jpae)
    iw_downwei(jpad,ipae) = ndim               !   iw_downwei(jpad,jpae)
    ndimsum = ndimsum+ndim*jaedownwei*iwupwei  !   iseg_dim(jpae)    =
    if (ndim == 0) cycle                       !   jpae_sta(jpae)    = jpa
    call config_act()                          !   jpae_upwei(jpae)  =
  end do
  do im=1,8
    jpae = jd(im)
    ipae = 1+im
    iw_sta(1:mxnode,ipae) = ndimsum
    if (nu_ae(ipae) == 0) cycle
    jaedownwei = iseg_downwei(ipae)
    do jpad_=1,mxnode
      jpad = jpad_ ! jpad is in global module, is this necessary?
      iw_sta(jpad,ipae) = ndimsum
      if (nu_ad(jpad) == 0) cycle
      call seg_drt()
      iwupwei = jpad_upwei(jpad)
      iw_downwei(jpad,ipae) = ndim
      ndimsum = ndimsum+ndim*jaedownwei*iwupwei
      if (ndim == 0) cycle
      call config_act()
    end do
  end do
  do im=1,8
    jpae = jt(im)
    ipae = 9+im
    iw_sta(1:mxnode,ipae) = ndimsum
    if (nu_ae(ipae) == 0) cycle
    jaedownwei = iseg_downwei(ipae)
    do jpad_=1,mxnode
      jpad = jpad_ ! jpad is in global module, is this necessary?
      iw_sta(jpad,ipae) = ndimsum
      if (nu_ad(jpad) == 0) cycle
      call seg_drt()
      iwupwei = jpad_upwei(jpad)
      iw_downwei(jpad,ipae) = ndim
      ndimsum = ndimsum+ndim*jaedownwei*iwupwei
      if (ndim == 0) cycle
      call config_act()
    end do
  end do
  do im=1,8
    jpae = js(im)
    ipae = 17+im
    if (nu_ae(ipae) == 0) cycle
    do jpad_=1,mxnode
      jpad = jpad_ ! jpad is in global module, is this necessary?
      if (nu_ad(jpad) == 0) cycle
      call seg_drt()
      if (ndim == 0) cycle
      call config_act()
    end do
  end do
  call config_dbl()
  call config_ext()

end if

if (npr == 0) return

call mma_allocate(norbindex,norb_all,label='norbindex')
call mma_allocate(norbsymm,norb_all,label='norbsymm')
call mma_allocate(norbwalk,norb_all,label='norbwalk')
call mma_allocate(nwalk_gamess,norb_all,label='nwalk_gamess')

nwalk_gamess(1:norb_all) = 0
do i=1,nst
  nwalk_gamess(i) = nwalk(nst-i+1)
end do
if (npr == 1) then
  write(u6,1000) ndr,de
else
  sqde = de*de
  write(u6,1001) ndr,de,sqde
end if

!if (intgen == 1) then
!  ! gamess integral
!  i = 0
!  j = 0
!  do i=norb_frz+1,nst
!    if (nwalk_gamess(map_orb_order(i)) > 0) then
!      j = j+1
!      norbindex(j) = i
!      norbsymm(j) = lsmorb(i)
!      norbwalk(j) = nwalk_gamess(map_orb_order(i))
!    end if
!  end do
!
!  !write(form1,2010) '(4x,i4,1x,',ng_sm,'(1x','i'
!  write(form1,1010) '(4x,a4,',j,'(1x,i3))'
!  write(u6,form1) 'norb',(norbindex(i),i=1,j)
!  write(u6,form1) 'sym ',(norbsymm(i),i=1,j)
!  write(u6,form1) 'walk',(norbwalk(i),i=1,j)
!else
i = 0
j = 0
do im=1,ng_sm
  ns = noidx(im)+nlsm_frz(im)+1
  if (im == ng_sm) then
    ne = norb_all
  else
    ne = noidx(im+1)
  end if
  do i=ns,ne
    if (nwalk_gamess(map_orb_order(i)) > 0) then
      j = j+1
      noi = i-noidx(im)
      norbindex(j) = noi
      norbsymm(j) = im
      norbwalk(j) = nwalk_gamess(map_orb_order(i))
    end if
  end do
end do

write(form1,1010) '(4x,a4,',j,'(1x,i3))'
write(u6,form1) 'norb',(norbindex(i),i=1,j)
write(u6,form1) 'sym ',(norbsymm(i),i=1,j)
write(u6,form1) 'walk',(norbwalk(i),i=1,j)
!end if
call mma_deallocate(norbindex)
call mma_deallocate(norbsymm)
call mma_deallocate(norbwalk)
call mma_deallocate(nwalk_gamess)

return

1000 format(/4x,'csf',i8,6x,'scf energy',f18.8,/)
1001 format(/4x,'csf',i8,2x,'coef',f10.6,2x,'weight',1x,f8.6/)
1010 format(a7,i3,a8)

end subroutine found_a_config

subroutine config_act()

use gugaci_global, only: iy, jj_sub, no, norb_dz, norb_inn
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: idl, jp, jp0, jp1, jw, lr, lr0, mpe

!write(u6,*) '               ***** start h-diaelm *****'
!write(u6,*) '   diagonal_act_d:',jpad,ipae
do lr=norb_dz+1,norb_inn
  jp0 = no(lr-1)+1
  jp1 = no(lr)
  lr0 = lr
  do jp=jp0,jp1
    if (iy(1,jp) == 0) cycle
    ! 800
    do idl=2,3
      mpe = jj_sub(idl,jp)
      if (mpe == 0) cycle
      !wt = voint(lr0,lr0)    ! hnil=1
      jw = iy(idl,jp)
      !call prodel(3,wt,jp,mpe,jw)
      call prodel_conf(3,jp,mpe,jw,lr0,0,idl-1)
    end do
    mpe = jj_sub(4,jp)
    if (mpe /= 0) then
      !wt = vdint(lr0,lr0)+Two*voint(lr0,lr0)     !idl=4 hnil=2
      jw = iy(4,jp)
      !call prodel(3,wt,jp,mpe,jw)
      call prodel_conf(3,jp,mpe,jw,lr0,0,3)
    end if
  end do
end do

return

end subroutine config_act

subroutine config_dbl()

use gugaci_global, only: ipae, iw_downwei, jb_sys, jpad, jud, just, lsm_inn, norb_dbl, norb_dz, norb_frz, ns_sm, nu_ae
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ipae_, iwa, iwad, iwd, iwdownv, iws, iws1, iwt, jpad1, jpas, jpat, jpat1, lr, lr0, mr, mr0
integer(kind=iwp), external :: iwalk_ad

if (norb_dbl == 0) return
do ipae_=1,25
  ipae = ipae_ ! ipae is in global module, is this necessary?
  if (nu_ae(ipae) == 0) cycle
  iwdownv = iw_downwei(1,ipae)
  do iwa=0,iwdownv-1
    !zz = ' doub_800_v'
    iwad = iwalk_ad(1,ipae,iwa,0)
    !call prodel(1,wt0,0,ipae,iwad)
    call prodel_conf(1,0,ipae,iwad,0,0,1)
  end do
end do
!jps = js(1)
do lr0=norb_frz+1,norb_dz
  mr0 = Mul(lsm_inn(lr0),ns_sm)
  iwd = jud(lr0)
  jpad = 1+mr0
  jpad1 = jpad+24
  !wld = wt0-voint(lr0,lr0)-vdint(lr0,lr0)
  !wls = wld-voint(lr0,lr0)
  do ipae_=1,25
    ipae = ipae_ ! ipae is in global module, is this necessary?
    if (nu_ae(ipae) == 0) cycle
    iwdownv = iw_downwei(jpad,ipae)
    do iwa=0,iwdownv-1
      iwad = iwalk_ad(jpad,ipae,iwa,iwd)
      !call prodel(1,wld,0,ipae,iwad)
      call prodel_conf(1,0,ipae,iwad,lr0,0,2)     !d
    end do
  end do

  if (jb_sys > 0) then
    do ipae_=1,25
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdownv = iw_downwei(jpad1,ipae)
      do iwa=0,iwdownv-1
        iwad = iwalk_ad(jpad1,ipae,iwa,iwd)
        !call prodel(1,wld,0,ipae,iwad)
        call prodel_conf(1,0,ipae,iwad,lr0,0,5)     !dd
      end do
    end do
  end if
  jpad = 17+ns_sm
  iwd = just(lr0,lr0)
  do ipae_=1,25
    ipae = ipae_ ! ipae is in global module, is this necessary?
    if (nu_ae(ipae) == 0) cycle
    iwdownv = iw_downwei(jpad,ipae)
    do iwa=0,iwdownv-1
      iwad = iwalk_ad(jpad,ipae,iwa,iwd)
      !call prodel(1,wls,0,ipae,iwad)
      call prodel_conf(1,0,ipae,iwad,lr0,0,4)     !s
    end do
  end do

  if (lr0 == norb_dz) cycle
  !wld0 = wld

  do lr=lr0+1,norb_dz
    mr = Mul(mr0,lsm_inn(lr))
    jpat = 9+mr
    jpas = 17+mr
    jpat1 = jpat+24
    iws = just(lr0,lr)
    iwt = iws
    !wld = wld0-voint(lr,lr)-vdint(lr,lr)
    do ipae_=1,25
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdownv = iw_downwei(jpat,ipae)
      do iwa=0,iwdownv-1
        iwad = iwalk_ad(jpat,ipae,iwa,iwt)
        !call prodel(1,wld,0,ipae,iwad)
        call prodel_conf(1,0,ipae,iwad,lr0,lr,3)   !t
      end do
      if (jb_sys > 1) then
        iwdownv = iw_downwei(jpat1,ipae)
        do iwa=0,iwdownv-1
          iwad = iwalk_ad(jpat1,ipae,iwa,iwt)         !tt
          !call prodel(1,wld,0,ipae,iwad)
          call prodel_conf(1,0,ipae,iwad,lr0,lr,6)
        end do
      end if
      iwdownv = iw_downwei(jpas,ipae)
      do iwa=0,iwdownv-1
        iwad = iwalk_ad(jpas,ipae,iwa,iws)
        !call prodel(1,wld,0,ipae,iwad)
        call prodel_conf(1,0,ipae,iwad,lr0,lr,4)   !s
      end do
      if (jb_sys > 0) then
        iws1 = just(lr,lr0)
        do iwa=0,iwdownv-1
          iwad = iwalk_ad(jpas,ipae,iwa,iws1)
          !call prodel(1,wld,0,ipae,iwad)
          call prodel_conf(1,0,ipae,iwad,lr0,lr,7)      !ss
        end do
      end if
    end do
  end do
end do

return

end subroutine config_dbl

subroutine config_ext()

use gugaci_global, only: ibsm_ext, iesm_ext, ipae, lsm, norb_ext
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: im, ima, imb, ipas, ipat, jw, jweis, jws, jws0, jwt, la, laend, lasta, lb, lrzz, mr, mra

jws0 = 0
do mra=1,8
  ipae = 1+mra
  lasta = ibsm_ext(mra)
  laend = iesm_ext(mra)
  lrzz = laend-lasta+1
  lrzz = lrzz*(lrzz-1)/2
  jws0 = jws0+lrzz
  jw = 0
  do la=lasta,laend
    !jpd = jd(mra)
    jw = jw+1
    !lra = norb_all-la+1
    !wld = voint(lra,lra)
    !call prodel(2,wld,0,ipae,jw)
    call prodel_conf(2,0,ipae,jw,la,0,2)      !d
  end do
end do

!zz = ' out_800_s'
!jps = js(1)

jweis = jws0
do la=1,norb_ext
  !jpd = jd(mra)
  !lra = norb_all-la+1
  jweis = jweis+1
  !wls = Two*voint(lra,lra)+vdint(lra,lra)
  !call prodel(2,wls,0,18,jweis)
  call prodel_conf(2,0,18,jweis,la,0,4)      !s
end do
do im=1,8
  jws = 0
  jwt = 0
  ipat = 9+im
  ipas = 17+im
  do la=2,norb_ext
    !lra = norb_all-la+1
    ima = lsm(la)
    do lb=1,la-1
      !lrbi = norb_all-lb+1
      imb = lsm(lb)
      mr = Mul(ima,imb)
      if (mr /= im) cycle
      !jps = js(mr)
      !jpt = jt(mr)
      jws = jws+1
      jwt = jwt+1
      !wls = voint(lra,lra)+voint(lrb,lrb)
      !wlt = wls
      !wls = wls+voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=-3/2
      !wlt = wlt-voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=1/2

      !call prodel(2,wls,0,ipas,jws)
      !call prodel(2,wlt,0,ipat,jwt)
      call prodel_conf(2,0,ipas,jws,la,lb,4)      !s
      call prodel_conf(2,0,ipat,jwt,la,lb,3)      !t
    end do
  end do
end do

return

end subroutine config_ext

! idb=1  in dbl_space      ity_up=0-5             jd_type,jd_im,iwd
! idb=2  in ext_space      ity_down=0-3           je_type,je_im,iwe
! idb=3  in act_space      ity_up=0-5,itdown=0,3  jp,     mpe,  iwa
subroutine prodel_conf(idb,mg1,mg2,mg3,lr01,lr02,jpty)

use gugaci_global, only: ihy, ipae, iseg_downwei, iw_downwei, iy, jpad, jpad_upwei, jphy, mxnode, ndr, norb_all, nu_ad, nwalk
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, lr01, lr02, jpty
integer(kind=iwp) :: in_, isegdownwei, iw, iwa, iwad, iwd, iwe, iwupwei, jdbl, jp, jph, jw, jwd, jwu, lr1, lr2, lwnu, mm, mpe
integer(kind=iwp), external :: iwalk_ad

select case (idb)
  case default ! (1)
    ! in dbl_space
    ! jpty=  1,  2,  3,  4,  5,  6,  7
    !        v   d   t   s  dd  tt  ss
    ipae = mg2
    iwad = mg3
    lr1 = norb_all-lr01+1
    lr2 = norb_all-lr02+1
    isegdownwei = iseg_downwei(ipae)
    do mm=iwad+1,iwad+isegdownwei
      if (mm == ndr) then
        select case (jpty)
          case default ! (1)
          case (2)
            nwalk(lr1) = 2
          case (3)
            nwalk(lr1) = 2
            nwalk(lr2) = 2
          case (4)
            nwalk(lr1) = 2
            nwalk(lr2) = 1
            if (lr02 == 0) nwalk(lr1) = 0
            if (lr01 == 0) nwalk(lr2) = 0
          case (5)
            nwalk(lr1) = 1
          case (6)
            nwalk(lr1) = 1
            nwalk(lr2) = 1
          case (7)
            nwalk(lr1) = 1
            nwalk(lr2) = 2
        end select
        exit
      end if
    end do

  case (2)
    ! in ext_space
    ! jpty=  1,  2,  3,  4
    !        v   d   t   s
    ipae = mg2
    iwe = mg3
    lr1 = lr01
    lr2 = lr02
    outer1: do jdbl=1,mxnode
      if (nu_ad(jdbl) == 0) cycle
      iw = iw_downwei(jdbl,ipae)
      iwupwei = jpad_upwei(jdbl)
      do iwa=0,iw-1
        do iwd=0,iwupwei-1
          mm = iwalk_ad(jdbl,ipae,iwa,iwd)+iwe
          if (mm == ndr) then
            select case (jpty)
              case default ! (1)
              case (2)
                nwalk(lr1) = 1
              case (3)
                nwalk(lr1) = 1
                nwalk(lr2) = 1
              case (4)
                nwalk(lr1) = 2
                nwalk(lr2) = 1
                if (lr02 == 0) nwalk(lr1) = 3
            end select
            exit outer1
          end if
        end do
      end do
    end do outer1

  case (3)
    ! in act_space
    jp = mg1
    mpe = mg2
    jw = mg3
    iwupwei = jpad_upwei(jpad)
    isegdownwei = iseg_downwei(ipae)
    jph = jphy(jp)
    in_ = ihy(jph)
    lwnu = iy(1,mpe)
    lr1 = norb_all-lr01+1
    outer2: do jwu=jph+1,jph+in_
      iwa = jw+ihy(jwu)-1
      do jwd=1,lwnu
        iwa = iwa+1
        do iwd=0,iwupwei-1
          iwad = iwalk_ad(jpad,ipae,iwa,iwd)
          do iwe=1,isegdownwei
            mm = iwe+iwad
            if (mm == ndr) then
              nwalk(lr1) = jpty
              exit outer2
            end if
          end do
        end do
      end do
    end do outer2
end select

return

end subroutine prodel_conf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************
!  RDVEC
!
!> @brief
!>   A routine to read MO coefficients, occupation numbers, one-electron energies and type index information from ``INPORB`` file
!> @author V. Veryazov
!>
!> @details
!> New version of ::rdvec routine.
!> ::RDVEC is a wrapper to ::RDVEC_, which read UHF
!> information from ``INPORB`` file.
!>
!> \p Label defines the type of information to read from ``INPORB`` file
!> Valid targets are: ``C``---CMO, ``O``---OCC, ``E``---EORB, ``I``---INDT
!> ``A``---alpha values, ``B``---beta values
!>
!> ::RdVec checks that \p NBAS / \p NORB information is consistent,
!> and reacts according to \p iWarn. ``0``: No checks for \p NBAS / \p NORB;
!> ``1``: Print error message; ``2``: ::Abend.
!>
!> Example: Get CMO coeff. and OCC for RHF:
!>
!> \code
!> Call RdVec('INPORB',Lu,'CO',NSYM,NBAS,NBAS,CMO,OCC,Dummy,iDummy,Title,0,iErr)
!> \endcode
!>
!> @param[in]  FName File name
!> @param[in]  LU_   Unit number
!> @param[in]  LABEL Task
!> @param[in]  NSYM  N symmetries
!> @param[in]  NBAS  N basis functions
!> @param[in]  NORB  N orbitals
!> @param[out] CMO   MO coefficients
!> @param[out] OCC   Occupations
!> @param[out] EORB  One electron energies
!> @param[out] INDT  Type Index information
!> @param[out] TITLE Title of orbitals
!> @param[in]  IWARN Warning level
!> @param[out] IERR  Return code
!***********************************************************************

subroutine RDVEC(FName,LU_,LABEL,NSYM,NBAS,NORB,CMO,OCC,EORB,INDT,TITLE,iWarn,iErr)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
character(len=*), intent(in) :: FName, LABEL
integer(kind=iwp), intent(in) :: LU_, NSYM, NBAS(NSYM), NORB(NSYM), iWarn
real(kind=wp), intent(_OUT_) :: CMO(*), OCC(*), EORB(*)
integer(kind=iwp), intent(_OUT_) :: INDT(*)
character(len=*), intent(out) :: TITLE
integer(kind=iwp), intent(out) :: iErr
integer(kind=iwp) :: iWFType
real(kind=wp) :: vDum(2)

call RdVec_(FName,LU_,LABEL,0,NSYM,NBAS,NORB,CMO,vDum,OCC,vDum,EORB,vDum,INDT,TITLE,iWarn,iErr,iWFtype)

return

end subroutine RDVEC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
*  CHO_GET_OED_cd
*
*> @brief
*>   Computes the Cholesky vectors of the 2nd-rank orbital energy denominators according to Eq. (7) of \cite Koc2000-JCP-113-508
*> @author F. Aquilante
*>
*> @details
*> Computes the Cholesky vectors of the 2nd-rank orbital energy denominators
*> according to Eq. (7) of \cite Koc2000-JCP-113-508
*>
*> @param[in]     incore Boolean for in or out of core decomposition
*> @param[in]     nOV    Number of (occ,vir) pairs matching a given compound symmetry
*> @param[in]     W      Array (\p nOV) of the orbital energy differences \p W(bj) = ``e(b)-e(j)``
*> @param[in]     NVec   Number of Cholesky vectors requested
*> @param[in]     ID_bj  Index array (\p NVec) of the decomposition pattern
*> @param[in]     JVec   Starting Cholesky vector
*> @param[in,out] Y      Matrix (\p nOV,\p NVec) of the Cholesky vectors for the decomposition of the orbital energy denominators
*> @param[in,out] R      Matrix (\p nOV) of the previous products, to be used for out of core decomposition.
*>                       Note: in case of out of core, in the first call this array *must* be initialized to ``1.0d0``.
*>                       For the in core case, it *must* also coincide with the first column of \p Y and *must* still be initialized in input.
************************************************************************
      SUBROUTINE CHO_GET_OED_cd(incore,nOV,W,NVec,ID_bj,JVec,Y,R)
      Implicit Real*8 (a-h,o-z)

      Logical incore
      Integer nOV, NVec, JVec, ID_bj(*)
      Real*8  W(*), Y(*), R(*)

#include "warnings.h"
*******************************************************************

      If (NVec.lt.1) Then
         Write(6,*)'Error in CHO_GET_OED_cd : in input NVec < 1 .'
         Call quit(_RC_CHO_LOG_)
      EndIf

      xtwo = sqrt(2.0d0)

* Compute  R(p,k) = R(p,k-1) * (W(p) - W(J[k-1]))/(W(p) + W(J[k-1]))
* ------------------------------------------------------------------
      If (incore) Then

         If (JVec.ne.1) Then
            Write(6,*)'CHO_GET_OED_cd : JVec must be 1 if incore .'
            Call quit(_RC_CHO_LOG_)
         EndIf
         Do Jk=2,NVec
            kp = NOV*(Jk-1)
            np = kp - NOV
            Jm = ID_bj(Jk-1)
            Do ip=1,NOV
               Y(kp+ip) = Y(np+ip)*(W(ip)-W(Jm))/(W(ip)+W(Jm))
            End Do
          End Do

      Else

         Jm = ID_bj(JVec-1)
         Do ip=1,NOV
            Y(ip) = R(ip)*(W(ip)-W(Jm))/(W(ip)+W(Jm))
         End Do
         Do Jk=2,NVec
            kp = NOV*(Jk-1)
            np = kp - NOV
            Jm = ID_bj(JVec+Jk-3)
            Do ip=1,NOV
               Y(kp+ip) = Y(np+ip)*(W(ip)-W(Jm))/(W(ip)+W(Jm))
            End Do
          End Do
          call dcopy_(NOV,Y(1+NOV*(NVec-1)),1,R,1)

      EndIf

* Compute  Y(p,k) = R(p,k) * sqrt(2*W(J[k]))/(W(p) + W(J[k]))
* -----------------------------------------------------------
      Do Jk=1,NVec
         kp = NOV*(Jk-1)
         Jm = ID_bj(JVec+Jk-1)
         Do ip=1,NOV
            Y(kp+ip) = Y(kp+ip)*xtwo*sqrt(W(Jm))/(W(ip)+W(Jm))
         End Do
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Naoki Nakatani                                         *
!***********************************************************************
!  DMRGCtl
!
!> @brief
!>   DMRG Control
!> @author N. Nakatani
!>
!> @details
!> Many functionality is same as ::CICtl (copy most part of ::CICtl to here)
!> To use DMRG as CAS-CI solver.
!> \p IRst = ``0`` is used for the first and the last (DMRG-) CI calculations
!> to fully optimize the DMRG wavefunction.
!> \p IRst = ``1`` enables to restart DMRG calculation from last iteration
!>
!> @param[in]     CMO    MO coefficients
!> @param[out]    D      Average 1-dens matrix
!> @param[out]    DS     Average spin 1-dens matrix
!> @param[out]    P      Average symm. 2-dens matrix
!> @param[out]    PA     Average antisymm. 2-dens matrix
!> @param[in,out] FI     Fock matrix from inactive density
!> @param[in]     D1I    Inactive 1-dens matrix
!> @param[in]     D1A    Active 1-dens matrix
!> @param[in]     TUVX   Active 2-el integrals
!> @param[in]     IFINAL Calculation status switch
!> @param[in]     IRst   DMRG restart status switch
!***********************************************************************

#include "compiler_features.h"

#if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_) || defined (_ENABLE_DICE_SHCI_)
subroutine DMRGCtl(CMO,D,DS,P,PA,FI,D1I,D1A,TUVX,IFINAL,IRst)

use wadr, only: FMO
use rctfld_module, only: lRF
use casvb_global, only: ifvb
use timers, only: TimeDens
use lucia_data, only: DStmp, Dtmp, PAtmp, Pscr, Ptmp
use gas_data, only: iDoGAS
use rasscf_global, only: DFTFOCK, ExFac, iAdr15, iPCMRoot, iRoot, ITER, KSDFT, lRoots, n_Det, NAC, NACPAR, NACPR2, nFint, nRoots, &
                         S, Weight
use PrintLevel, only: DEBUG, INSANE
use output_ras, only: IPRLOC
use general_data, only: ISPIN, jobiph, nactel, nash, ntot2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CMO(*), D1I(*), D1A(*), TUVX(*)
real(kind=wp), intent(inout) :: D(NACPAR), DS(NACPAR), P(NACPR2), PA(NACPR2), FI(*)
integer(kind=iwp), intent(in) :: iFinal, IRst
integer(kind=iwp) :: i, iPrLev, jDisk, jRoot, kRoot, NACT4, nTmpPUVX
real(kind=wp) :: dum1, dum2, dum3, rdum(1), Scal, Time(2)
logical(kind=iwp) :: Do_ESPF
real(kind=wp), allocatable :: P2MO(:), RCT(:), RCT_F(:), RCT_FS(:), RCT_S(:), TmpD1S(:), TmpDS(:), TmpPUVX(:), TmpTUVX(:)

IPRLEV = IPRLOC(3)
if (IPRLEV >= DEBUG) write(u6,*) ' Entering DMRGCTL'

! set up flag 'IFCAS' for GAS option, which is set up in gugatcl originally.
! IFCAS = 0: This is a CAS calculation
! IFCAS = 1: This is a RAS calculation - This might cause an error in DMRG-CASSCF.

if (iDoGas) call setsxci()
if (IPRLEV > DEBUG) then
  write(u6,*)
  write(u6,*) ' Enter DMRG section'
  write(u6,*) ' =================='
  write(u6,*)
  write(u6,*) ' iteration count =',ITER
end if

! SOME DIRTY SETUPS

S = Half*real(ISPIN-1,kind=wp)

! COMPUTE ONE ELECTRON INTEGRALS IN MO BASIS
! AND ADD CORE INTERACTION

! FMO FOCK MATRIX IN MO-BASIS
! LW2: 1-PARTICLE DENSITY MATRIX ALSO USED IN MO/AO TRANSFORMATION

call mma_allocate(FMO,NACPAR,Label='FMO')
call DecideOnESPF(Do_ESPF)
if (lRF .or. (KSDFT /= 'SCF') .or. Do_ESPF) then

  ! In case of a reaction field in combination with an average CAS
  ! select the potential of the appropriate state.

  jDisk = IADR15(3)
  do i=1,IPCMROOT-1
    call DDafile(JOBIPH,0,rdum,NACPAR,jDisk)
    call DDafile(JOBIPH,0,rdum,NACPAR,jDisk)
    call DDafile(JOBIPH,0,rdum,NACPR2,jDisk)
    call DDafile(JOBIPH,0,rdum,NACPR2,jDisk)
  end do

  call mma_allocate(RCT_F,NTOT2,Label='RCT_F')
  call mma_allocate(RCT_FS,NTOT2,Label='RCT_FS')
  if (IFINAL == 0) then

    ! Use normal MOs

    call mma_allocate(RCT,NACPAR,Label='RCT')
    call mma_allocate(P2MO,NACPR2,Label='P2MO')

    ! Get the total density in MOs

    call DDafile(JOBIPH,2,RCT,NACPAR,jDisk)
    call Put_dArray('D1mo',RCT,NACPAR)  ! Put it on the RUNFILE
    if (NASH(1) /= NAC) call DBLOCK(RCT)
    ! Transform to AOs
    call Get_D1A_RASSCF(CMO,RCT,RCT_F)

    ! Get the spin density in MOs

    if (NACTEL == 0) then
      RCT_FS(:) = Zero
    else
      call mma_allocate(RCT_S,NACPAR,Label='RCT_S')
      call DDafile(JOBIPH,2,RCT_S,NACPAR,jDisk)
      if (NASH(1) /= NAC) call DBLOCK(RCT_S)
      ! Transform to AOs
      call Get_D1A_RASSCF(CMO,RCT_S,RCT_FS)
      call mma_deallocate(RCT_S)
    end if

    ! Get the 2-particle density in MO

    call DDafile(JOBIPH,2,P2MO,NACPR2,jDisk)
    call Put_dArray('P2mo',P2MO,NACPR2) ! Put it on the RUNFILE

    call SGFCIN(CMO,FMO,FI,D1I,RCT_F,RCT_FS)

    call mma_deallocate(P2MO)
    call mma_deallocate(RCT)

  else

    ! Here the pseudo-natural orbitals are in CMO and we need to
    ! get the D1A of the selected state in this basis.

    ! Compute the density of the particular state

    call mma_allocate(Dtmp,NAC**2,Label='Dtmp')
    call mma_allocate(DStmp,NAC**2,Label='DStmp')
    call mma_allocate(Ptmp,NACPR2,Label='Ptmp')
    if (NAC >= 1) then
      if (NACTEL == 0) then
        Dtmp(:) = Zero
        DStmp(:) = Zero
        Ptmp(:) = Zero
      else
        ! load back 1- and 2-RDMs from previous DMRG run
        NACT4 = NAC**4
        call mma_allocate(PAtmp,NACPR2,Label='PAtmp')
        call mma_allocate(Pscr,NACT4,Label='Pscr')
#       ifdef _ENABLE_BLOCK_DMRG_
        call block_densi_rasscf(IPCMRoot,Dtmp,DStmp,Ptmp,PAtmp,Pscr)
#       elif _ENABLE_CHEMPS2_DMRG_
        call chemps2_densi_rasscf(IPCMRoot,Dtmp,DStmp,Ptmp,PAtmp,Pscr)
#       elif _ENABLE_DICE_SHCI_
        call dice_densi_rasscf(IPCMRoot,Dtmp,DStmp,Ptmp,PAtmp,Pscr)
#       endif

        ! NN.14 NOTE: IFCAS must be 0 for DMRG-CASSCF
        !if (IFCAS > 2) call CISX(IDXSX,Dtmp,DStmp,Ptmp,PAtmp,Pscr)
        call mma_deallocate(Pscr)
        call mma_deallocate(PAtmp)
      end if

    else
      Dtmp(:) = Zero
      DStmp(:) = Zero
      Ptmp(:) = Zero
    end if
    ! Modify the symmetric 2-particle density if only partial
    ! "exact exchange" is included.
    !n_Det = 2
    !n_unpaired_elec = iSpin-1
    !n_paired_elec = nActEl-n_unpaired_elec
    !if (n_unpaired_elec+n_paired_elec/2 == nac) n_Det = 1
    if (ExFac /= One) call Mod_P2(Ptmp,NACPR2,Dtmp,NACPAR,DStmp,ExFac,n_Det)

    call Put_dArray('P2mo',Ptmp,NACPR2) ! Put it on the RUNFILE

    call mma_deallocate(Ptmp)

    call Put_dArray('D1mo',Dtmp,NACPAR) ! Put it on the RUNFILE
    if (NASH(1) /= NAC) call DBLOCK(Dtmp)
    call Get_D1A_RASSCF(CMO,Dtmp,RCT_F)

    if (NASH(1) /= NAC) call DBLOCK(DStmp)
    call Get_D1A_RASSCF(CMO,DStmp,RCT_FS)

    call mma_deallocate(Dtmp)
    call mma_deallocate(DStmp)

    call SGFCIN(CMO,FMO,FI,D1I,RCT_F,RCT_FS)

  end if
  call mma_deallocate(RCT_FS)
  call mma_deallocate(RCT_F)

else
  ! Normal case

  call mma_allocate(TmpDS,NACPAR,Label='TmpDS')
  call mma_allocate(TmpD1S,NTOT2,Label='TmpD1S')
  TmpDS(:) = DS(:)
  if (NASH(1) /= NAC) call DBLOCK(TmpDS)
  call Get_D1A_RASSCF(CMO,TmpDS,TmpD1S)
  call mma_deallocate(TmpDS)

  call SGFCIN(CMO,FMO,FI,D1I,D1A,TmpD1S)
  call mma_deallocate(TmpD1S)

end if

if (IfVB /= 2) then

  ! SOLVE DMRG WAVEFUNCTION

  if (IfVB == 1) then
    ! NN.14 FIXME: I'm not sure whether this option should work?
    call cvbmn_rvb(max(ifinal,1))
  else
    if ((KSDFT(1:3) /= 'SCF') .and. (DFTFOCK(1:4) == 'DIFF') .and. (nac /= 0)) then
      nTmpPUVX = nFint
      call mma_allocate(TmpPUVX,nTmpPUVX,Label='TmpPUVX')
      call mma_allocate(TmpTUVX,NACPR2,Label='TmpTUVX')
      TmpTUVX(:) = Zero
      call Get_dArray('DFT_TwoEl',TmpPUVX,nTmpPUVX)
      call Get_TUVX(TmpPUVX,TmpTUVX)
      TmpTUVX(:) = TMPTUVX(:)+TUVX(1:NACPR2)
#     ifdef _ENABLE_BLOCK_DMRG_
      call BlockCtl(FMO,TmpTUVX,IFINAL,IRst)
#     elif _ENABLE_CHEMPS2_DMRG_
      call Chemps2Ctl(FMO,TmpTUVX,IFINAL,IRst)
#     elif _ENABLE_DICE_SHCI_
      call DiceCtl(FMO,TmpTUVX,IFINAL,IRst)
#     endif

      call mma_deallocate(TmpTUVX)
      call mma_deallocate(TmpPUVX)
    else
#     ifdef _ENABLE_BLOCK_DMRG_
      call BlockCtl(FMO,TUVX,IFINAL,IRst)
#     elif _ENABLE_CHEMPS2_DMRG_
      call Chemps2Ctl(FMO,TUVX,IFINAL,IRst)
#     elif _ENABLE_DICE_SHCI_
      call DiceCtl(FMO,TUVX,IFINAL,IRst)
#     endif
    end if
  end if

  ! CALCULATE DENSITY MATRICES
  ! SAVE DENSITY MATRICES ON FILE
  ! COMPUTE AVERAGE DENSITY MATRICES

  ! Dtmp: ONE-BODY DENSITY
  ! DStmp: ONE-BODY SPIN DENSITY
  ! Ptmp: SYMMETRIC TWO-BODY DENSITY
  ! PAtmp: ANTISYMMETRIC TWO-BODY DENSITY

  call Timing(Time(1),dum1,dum2,dum3)
  D(:) = Zero
  DS(:) = Zero
  P(:) = Zero
  PA(:) = Zero
  call mma_allocate(Dtmp,NACPAR,Label='Dtmp')
  call mma_allocate(DStmp,NACPAR,Label='DStmp')
  call mma_allocate(Ptmp,NACPR2,Label='Ptmp')
  call mma_allocate(PAtmp,NACPR2,Label='PAtmp')
  jDisk = IADR15(3)

  do jRoot=1,lRoots
    ! load density matrices from DMRG run
    if (NAC >= 1) then
      NACT4 = NAC**4
      call mma_allocate(Pscr,NACT4,Label='Pscr')
#     ifdef _ENABLE_BLOCK_DMRG_
      call block_densi_rasscf(jRoot,Dtmp,DStmp,Ptmp,PAtmp,Pscr)
#     elif _ENABLE_CHEMPS2_DMRG_
      call chemps2_densi_rasscf(jRoot,Dtmp,DStmp,Ptmp,PAtmp,Pscr)
#     elif _ENABLE_DICE_SHCI_
      call dice_densi_rasscf(jRoot,Dtmp,DStmp,Ptmp,PAtmp,Pscr)
#     endif
      call mma_deallocate(Pscr)
    end if
    ! Modify the symmetric 2-particle density if only partial
    ! "exact exchange" is included.
    !n_Det = 2
    !n_unpaired_elec = iSpin-1
    !n_paired_elec = nActEl-n_unpaired_elec
    !if (n_unpaired_elec+n_paired_elec/2 == nac) n_Det = 1
    !  write(u6,*) ' iSpin=',iSpin
    !  write(u6,*) ' n_unpaired_elec',n_unpaired_elec
    !  write(u6,*) ' n_paired_elec',n_paired_elec
    !  write(u6,*) ' n_unpaired_elec+n_paired_elec/2',n_unpaired_elec+n_paired_elec/2
    !  write(u6,*) ' n_Det=',n_Det
    !end if

    if (ExFac /= One) call Mod_P2(Ptmp,NACPR2,Dtmp,NACPAR,DStmp,ExFac,n_Det)

    ! update average density matrices
    Scal = Zero
    do kRoot=1,nRoots
      if (iRoot(kRoot) == jRoot) then
        Scal = Weight(kRoot)
        exit
      end if
    end do
    D(:) = D(:)+Scal*Dtmp(:)
    DS(:) = DS(:)+Scal*DStmp(:)
    P(:) = P(:)+Scal*Ptmp(:)
    PA(:) = PA(:)+Scal*PAtmp(:)
    ! save density matrices on disk
    call DDafile(JOBIPH,1,Dtmp,NACPAR,jDisk)
    call DDafile(JOBIPH,1,DStmp,NACPAR,jDisk)
    call DDafile(JOBIPH,1,Ptmp,NACPR2,jDisk)
    call DDafile(JOBIPH,1,PAtmp,NACPR2,jDisk)
  end do

  call mma_deallocate(PAtmp)
  call mma_deallocate(Ptmp)
  call mma_deallocate(DStmp)
  call mma_deallocate(Dtmp)

  ! PREPARE DENSITY MATRICES AS USED BY THE SUPER CI SECTION

  ! print matrices
  if (IPRLEV >= INSANE) then
    call TRIPRT('Averaged one-body density matrix, D',' ',D,NAC)
    call TRIPRT('Averaged one-body spin density matrix, DS',' ',DS,NAC)
    call TRIPRT('Averaged two-body density matrix, P',' ',P,NACPAR)
    call TRIPRT('Averaged antisymmetric two-body density matrix,PA',' ',PA,NACPAR)
  end if
  if (NASH(1) /= NAC) call DBLOCK(D)
  call Timing(Time(2),dum1,dum2,dum3)
  TimeDens = TimeDens+Time(2)-Time(1)

  call mma_deallocate(FMO)

end if

! For RF calculations make sure that the we are following the
! correct root.

! In the current implementation the overlap between the CI vectors
! of different macro iterations is used. This criterion stricktly
! only hold if the orbitals are not changed in between the
! interations, to make sure that this approximately holds the
! comparision is only to be considered to be valid if the rotmax
! parameter is below an empirical threshold. In the future the
! procedure for indentifying root flipping has to be made more
! robust.
!
!SVC: if CISElect is used, roots should be traced regardless of orbital
!     rotation, so in that case ignore the automatic tracing and follow
!     the relative CISE root given in the input by the 'CIRF' keyword.

! ======================================================================
! NN.14 FIXME:
!     The overlap b/w the DMRG wave of different macro iterations
!     hasn't yet been implemented. Eventually this must be fixed to
!     chose the correct root for RF calculation with DMRG-CASSCF.
!     For the time, just skip following.
! ======================================================================

!if (lRF .and. KeyCISE .and. KeyCIRF) then
!  JPCMROOT = IPCMROOT
!  IPCMROOT = IROOT(ICIRFROOT)
!  call Put_iScalar('RF CASSCF root',IPCMROOT)
!  if (JPCMROOT /= IPCMROOT) write(u6,'(1X,A,I3,A,I3)') 'RF Root has flipped from ',JPCMROOT,' to ',IPCMROOT
!else if (lRF) then
!  call Qpg_iScalar('RF CASSCF root',Exist)
!  if (.not. Exist) then
!
!    ! We are here since we are using the default values.
!
!    call Put_iScalar('RF CASSCF root',IPCMROOT)
!    call Put_iScalar('RF0CASSCF root',IPCMROOT)
!  end if
!
!  call mma_allocate(RF,nConf)
!  call Qpg_dArray('RF CASSCF Vector',Exist,mConf)
!  write(u6,*) 'Exist=',Exist
!  if (Exist .and. (mConf == nConf) .and. (iFinal /= 2) .and. ((abs(RotMax) < 1.0e-3_wp) .or. KeyCISE)) then
!    call Get_dArray('RF CASSCF Vector',RF,nConf)
!    rNorm = sqrt(DDot_(nConf,RF,1,RF,1))
!    write(u6,*) 'rNorm=',rNorm
!    JPCMROOT = IPCMROOT
!    if (rNorm > 1.0e-10_wp) then
!      call mma_allocate(Temp,nConf,Label='Temp')
!      rMax = Zero
!      jDisk = IADR15(4)
!      do i=1,lRoots
!        call DDafile(JOBIPH,2,Temp,nConf,jDisk)
!        qMax = abs(DDot_(nConf,Temp,1,RF,1))
!        write(u6,*) 'qMax=',qMax
!        if ((qMax > rMax) .and. (qMax > Half)) then
!          rMax = qMax
!          JPCMROOT = i
!        end if
!      end Do
!      call mma_deallocate(Temp)
!    end if
!  else
!    JPCMROOT = IPCMROOT
!  end if
!
!  if (JPCMROOT /= IPCMROOT) then
!    write(u6,*) ' RF Root has flipped from ',IPCMROOT,' to ',JPCMROOT
!    IPCMROOT = JPCMROOT
!    call Put_iScalar('RF CASSCF root',IPCMROOT)
!  end if
!
!  jDisk = IADR15(4)
!  do i=1,IPCMROOT-1
!    call DDafile(JOBIPH,0,rdum,nConf,jDisk)
!  end do
!  call DDafile(JOBIPH,2,RF,nConf,jDisk)
!  call Put_dArray('RF CASSCF Vector',RF,nConf)
!  call mma_deallocate(RF)
!end if

end subroutine DMRGCtl

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(DMRGCtl)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine RHS_ACCESS(NAS,NIS,lg_W,iLo,iHi,jLo,jHi,MW)
!SVC: this routine gives a pointer to the process-local part of the RHS
!     If there is no valid local block, then the routine returns 0 for
!     iLo and jLo, and -1 for iHi and jHi. This way, loops from lower

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: GA_NodeId
use Definitions, only: u6
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NAS, NIS, lg_W
integer(kind=iwp), intent(out) :: iLo, iHi, jLo, jHi, MW
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: LDW, myRank

if (Is_Real_Par()) then
  ! get the superindex ranges of this process's block
  myRank = GA_NodeID()
  call GA_Distribution(lg_W,myRank,iLo,iHi,jLo,jHi)

  if ((iLo /= 0) .and. (iHi-iLo+1 /= NAS)) then
    write(u6,*) 'RHS_ACCESS: mismatch in range of the superindices'
    call AbEnd()
  end if

  ! if the block is non-empty, get access to the block
  if ((iLo > 0) .and. (jLo > 0)) then
    if (iHi-iLo+1 /= NAS) then
      write(u6,*) 'RHS_ACCESS: Error: NAS mismatch, abort...'
      call ABEND()
    end if
    call GA_Access(lg_W,iLo,iHi,jLo,jHi,MW,LDW)
    if (LDW /= NAS) then
      write(u6,*) 'RHS_ACCESS: assert NAS=LDW failed, abort'
      call AbEnd()
    end if
  end if
else
#endif
  iLo = 1
  iHi = NAS
  jLo = 1
  jHi = NIS
  MW = lg_W
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine RHS_ACCESS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3_bt_abc(nug,ka,kb,kc,la,lb,lc,adim,bdim,cdim,N,noab,nnoab,lu,iasblock,nga,ngb,ngc,oeh,oepa,oepb,oepc,enx,voa,vob,voc, &
                     t1aa,t1ba,t1ab,t1bb,t1ac,t1bc,t3a,t3b,ifvo)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nug, adim, bdim, cdim, N, noab, nnoab, lu(2), iasblock(3), nga, ngb, ngc
real(kind=wp), intent(_OUT_) :: ka(adim*bdim,N,*), kb(bdim*cdim,N,*), kc(adim*cdim,N,*), voa(adim*bdim,*), vob(bdim*cdim,*), &
                                voc(adim*cdim,*), t3a(*), t3b(*)
real(kind=wp), intent(out) :: la(N*adim,nnoab), lb(N*bdim,nnoab), lc(N*cdim,nnoab)
real(kind=wp), intent(in) :: oeh(noab), oepa(adim), oepb(bdim), oepc(cdim)
real(kind=wp), intent(inout) :: enx, t1aa(noab,*), t1ba(noab,*), t1ab(noab,*), t1bb(noab,*), t1ac(noab,*), t1bc(noab,*)
logical(kind=iwp), intent(in) :: ifvo
integer(kind=iwp) :: a, ac, b, c, ca, i, ias, iasai, iasbi, iasci, ij, ik, j, jk, k, nadim, nbdim, ncdim, nga_offset, ngb_offset, &
                     ngc_offset, nug_offset
real(kind=wp) :: den, dena, denb, denc
real(kind=r8), external :: ddot_

!!write(u6,*) 'enter_abc enx,nga,ngb,ngc',nga,ngb,ngc,enx
nadim = adim*bdim
nbdim = bdim*cdim
ncdim = adim*cdim
nug_offset = iasblock(1)*nTri_Elem(nug)
! reads la's
ias = iasblock(2)*(nga-1)+1
call multi_readir(la,nnoab*adim*N,lu(2),ias)
ias = iasblock(2)*(ngb-1)+1
call multi_readir(lb,nnoab*bdim*N,lu(2),ias)
ias = iasblock(2)*(ngc-1)+1
call multi_readir(lc,nnoab*cdim*N,lu(2),ias)
! reads vvoo
nga_offset = iasblock(3)*(nTri_Elem(nga-1)+ngb-1)+1
ngb_offset = iasblock(3)*(nTri_Elem(ngb-1)+ngc-1)+1
ngc_offset = iasblock(3)*(nTri_Elem(nga-1)+ngc-1)+1
ias = iasblock(2)*nug+nga_offset
call multi_readir(voa,nnoab*nadim,lu(2),ias)
ias = iasblock(2)*nug+ngb_offset
call multi_readir(vob,nnoab*nbdim,lu(2),ias)
ias = iasblock(2)*nug+ngc_offset
call multi_readir(voc,nnoab*ncdim,lu(2),ias)

nga_offset = iasblock(1)*(nTri_Elem(nga-1)+ngb-1)+1
ngb_offset = iasblock(1)*(nTri_Elem(ngb-1)+ngc-1)+1
ngc_offset = iasblock(1)*(nTri_Elem(nga-1)+ngc-1)+1
do i=1,noab
  iasci = (i-1)*nug_offset+ngc_offset
  call multi_readir(kc(:,:,i),N*ncdim,lu(1),iasci)
  iasbi = (i-1)*nug_offset+ngb_offset
  call multi_readir(kb(:,:,i),N*nbdim,lu(1),iasbi)
  iasai = (i-1)*nug_offset+nga_offset
  call multi_readir(ka(:,:,i),N*nadim,lu(1),iasai)
end do
do i=3,noab
  jk = 0
  do j=2,i-1
    ij = nTri_Elem(i-2)+j
    ik = nTri_Elem(i-2)
    do k=1,j-1
      jk = jk+1
      ik = ik+1
      ! K_ba^ir x L_rc^jk
      call DGEMM_('N','N',nadim,cdim,N,one,ka(:,:,i),nadim,lc(:,jk),N,zero,t3a,nadim)
      ! K_ba^kr x L_rc^ij
      call DGEMM_('N','N',nadim,cdim,N,one,ka(:,:,k),nadim,lc(:,ij),N,one,t3a,nadim)
      ! -K_ba^jr x L_rc^ik
      call DGEMM_('N','N',nadim,cdim,N,-one,ka(:,:,j),nadim,lc(:,ik),N,one,t3a,nadim)
      ! -K_ca^ir x L_rb^jk   ! in the matrix as b,c,a
      call DGEMM_('T','T',bdim,ncdim,N,-one,lb(:,jk),N,kc(:,:,i),ncdim,zero,t3b,bdim)
      ! -K_ca^kr x L_rb^ij
      call DGEMM_('T','T',bdim,ncdim,N,-one,lb(:,ij),N,kc(:,:,k),ncdim,one,t3b,bdim)
      ! K_ca^jr x L_rb^ik
      call DGEMM_('T','T',bdim,ncdim,N,one,lb(:,ik),N,kc(:,:,j),ncdim,one,t3b,bdim)

      ac = 1-bdim
      do a=1,adim
        ca = (a-1)*bdim+1-nadim
        do c=1,cdim
          ac = ac+bdim
          ca = ca+nadim
          t3b(ac:ac+bdim-1) = t3b(ac:ac+bdim-1)+t3a(ca:ca+bdim-1)
        end do
      end do
      ! K_cb^ir x L_ra^jk   ! in the matrix as b,c,a
      call DGEMM_('N','N',nbdim,adim,N,one,kb(:,:,i),nbdim,la(:,jk),N,zero,t3a,nbdim)
      ! K_cb^kr x L_ra^ij
      call DGEMM_('N','N',nbdim,adim,N,one,kb(:,:,k),nbdim,la(:,ij),N,one,t3a,nbdim)
      ! -K_cb^jr x L_ra^ik
      call DGEMM_('N','N',nbdim,adim,N,-one,kb(:,:,j),nbdim,la(:,ik),N,one,t3a,nbdim)
      den = oeh(i)+oeh(j)+oeh(k)
      ac = 1
      do a=1,adim
        ca = (a-1)*nbdim+1
        do c=1,cdim
          call daxpy_(bdim,One,t3a(ca),cdim,t3b(ac),1)
          ac = ac+bdim
          ca = ca+1
        end do
      end do
      t3a(1:cdim*bdim*adim) = t3b(1:cdim*bdim*adim)
      ac = 0
      do a=1,adim
        dena = den-oepa(a)
        do c=1,cdim
          denc = dena-oepc(c)
          do b=1,bdim
            denb = denc-oepb(b)
            ac = ac+1
            t3b(ac) = t3b(ac)/denb
          end do
        end do
      end do
      enx = enx+ddot_(cdim*bdim*adim,t3b,1,t3a,1)
      call ex23(t3b,t3a,bdim,cdim,adim,1)
      ! t3a  bac
      ! blok1   voa ka
      call DGEMM_('N','N',1,cdim,nadim,one,voa(:,ij),1,t3a,nadim,one,t1ac(k,1),noab)
      call DGEMM_('N','N',1,cdim,nadim,one,voa(:,jk),1,t3a,nadim,one,t1ac(i,1),noab)
      call DGEMM_('N','N',1,cdim,nadim,-one,voa(:,ik),1,t3a,nadim,one,t1ac(j,1),noab)
      ! blok 2 t3b bca
      call DGEMM_('N','T',1,bdim,ncdim,-one,voc(:,ij),1,t3b,bdim,one,t1ab(k,1),noab)
      call DGEMM_('N','T',1,bdim,ncdim,-one,voc(:,jk),1,t3b,bdim,one,t1ab(i,1),noab)
      call DGEMM_('N','T',1,bdim,ncdim,one,voc(:,ik),1,t3b,bdim,one,t1ab(j,1),noab)
      if (ifvo) then
        call DGEMM_('N','N',1,cdim,nadim,one,ka(:,i,j),1,t3a,nadim,one,t1bc(k,1),noab)
        call DGEMM_('N','N',1,cdim,nadim,one,ka(:,j,k),1,t3a,nadim,one,t1bc(i,1),noab)
        call DGEMM_('N','N',1,cdim,nadim,-one,ka(:,i,k),1,t3a,nadim,one,t1bc(j,1),noab)
        call DGEMM_('N','T',1,bdim,ncdim,-one,kc(:,i,j),1,t3b,bdim,one,t1bb(k,1),noab)
        call DGEMM_('N','T',1,bdim,ncdim,-one,kc(:,j,k),1,t3b,bdim,one,t1bb(i,1),noab)
        call DGEMM_('N','T',1,bdim,ncdim,one,kc(:,i,k),1,t3b,bdim,one,t1bb(j,1),noab)
      end if
      ! part 3 acb in t3b
      call map2_21_t3(t3a,t3b,bdim,ncdim)
      call DGEMM_('N','T',1,adim,nbdim,one,vob(:,ij),1,t3b,adim,one,t1aa(k,1),noab)
      call DGEMM_('N','T',1,adim,nbdim,one,vob(:,jk),1,t3b,adim,one,t1aa(i,1),noab)
      call DGEMM_('N','T',1,adim,nbdim,-one,vob(:,ik),1,t3b,adim,one,t1aa(j,1),noab)
      if (ifvo) then
        call DGEMM_('N','T',1,adim,nbdim,one,kb(:,i,j),1,t3b,adim,one,t1ba(k,1),noab)
        call DGEMM_('N','T',1,adim,nbdim,one,kb(:,j,k),1,t3b,adim,one,t1ba(i,1),noab)
        call DGEMM_('N','T',1,adim,nbdim,-one,kb(:,i,k),1,t3b,adim,one,t1ba(j,1),noab)
      end if
    end do !k
  end do !j
end do !i

return

end subroutine t3_bt_abc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE DIELMV(ICASE,JCASE,NUP,NDWN,EMU)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ICASE(*),JCASE(*)
      DIMENSION EMU(NUP,NDWN)
#include "pt2_guga.fh"

      DO I=1,NUP
        II=NIPWLK*(I-1)
        SUM=0.0D0
        DO LV1=MIDLEV+1,NLEV,15
          II=II+1
          IC=ICASE(II)
          DO LEV=LV1,MIN(LV1+14,NLEV)
            IC1=IC/4
            ISTEP=IC-4*IC1
            IOC=(ISTEP+1)/2
            SUM=SUM+DBLE(IOC)*ETA(LEV)
            IC=IC1
          END DO
        END DO
        DO J=1,NDWN
          EMU(I,J)=EMU(I,J)+SUM
        END DO
      END DO
C THEN THE LOWER HALF:
      DO I=1,NDWN
        II=NIPWLK*(I-1)
        SUM=0.0D0
        DO LV1=1,MIDLEV,15
        II=II+1
        IC=JCASE(II)
        DO LEV=LV1,MIN(LV1+14,MIDLEV)
          IC1=IC/4
          ISTEP=IC-4*IC1
          IOC=(ISTEP+1)/2
          SUM=SUM+DBLE(IOC)*ETA(LEV)
          IC=IC1
          END DO
        END DO
        DO J=1,NUP
          EMU(J,I)=EMU(J,I)+SUM
        END DO
      END DO

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine setfn_cvb(fileid,fn)
      implicit real*8(a-h,o-z)
#include "io_cvb.fh"
      character*(*) fn
      logical debug
      data debug/.false./

      lenfn=len_trim_cvb(fn)
      do 100 i=1,nrec
      if(fn(1:lenfn).eq.filename(i))then
        fileid=fileids(i)
        return
      endif
100   continue
      itry=0
200   itry=itry+1
      fileid_try=DBLE(itry)
      do 300 i=1,nrec
      if(fileid_try.eq.fileids(i))goto 200
300   continue
      nrec=nrec+1
      if(nrec.gt.max_rec)then
        write(6,*)' nrec > max_rec in setfn :',nrec,max_rec
        call abend_cvb()
      endif
c  set file name
      filename(nrec)=fn
      fileids(nrec)=fileid_try
      ifilio(nrec)=0
      if(debug)then
        write(6,*)' IO information for identifier :',fileids(nrec)
        write(6,*)' IBF is :',nrec
        write(6,*)' File name is :',filename(nrec)
      endif
      fileid=fileids(nrec)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  PVB    := Zero parts of CI vector not in VB wfn.                 *
c  *                                                                   *
c  *********************************************************************
      subroutine ci2vb2_cvb(civec,cvbdet,
     >  iapr,ixapr,ret,ic)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension civec(nda,ndb),cvbdet(ndetvb)
      dimension iapr(ndetvb),ixapr(nda+1)

      if(ic.eq.0)then
        idetvb=0
        do 100 ia=1,nda
        do 101 ixa=ixapr(ia),ixapr(ia+1)-1
        idetvb=idetvb+1
        ib=iapr(ixa)
        cvbdet(idetvb)=civec(ia,ib)
101     continue
100     continue
      elseif(ic.eq.1)then
        call fzero(civec,nda*ndb)
        idetvb=0
        do 200 ia=1,nda
        do 201 ixa=ixapr(ia),ixapr(ia+1)-1
        idetvb=idetvb+1
        ib=iapr(ixa)
        civec(ia,ib)=cvbdet(idetvb)
201     continue
200     continue
      elseif(ic.eq.2)then
        idetvb=0
        do 300 ia=1,nda
        do 301 ixa=ixapr(ia),ixapr(ia+1)-1
        idetvb=idetvb+1
        ib=iapr(ixa)
        civec(ia,ib)=civec(ia,ib)+cvbdet(idetvb)
301     continue
300     continue
      elseif(ic.eq.3)then
        ret=zero
        idetvb=0
        do 400 ia=1,nda
        do 401 ixa=ixapr(ia),ixapr(ia+1)-1
        idetvb=idetvb+1
        ib=iapr(ixa)
        ret=ret+civec(ia,ib)*cvbdet(idetvb)
401     continue
400     continue
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! WRAPPER FOR PARALLEL S AND B MATRIX ROUTINES
subroutine PSBMAT_WRITE(cNAME,iCase,iSym,lg_M,nSize)
!SVC20100902: write the global array lg_M to disk using DRA interface,
! or if replicate or serial, write WORK(lg_M) to LUSBT

use Index_Functions, only: nTri_Elem
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
use caspt2_global, only: LUH0T
#endif
use caspt2_global, only: LUSBT
use EQSOLV, only: IDBMAT, IDSMAT, IDSTMAT, IDTMAT
use fake_ga, only: GA_arrays
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: cNAME
integer(kind=iwp), intent(in) :: iCase, iSym, lg_M, nSize
integer(kind=iwp) :: IDISK, nBlock
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: IEND, ISTA, JEND, JSTA, LDM, LU, mpt_M, myRank
#endif

select case (CNAME)
  case ('S')
#   ifdef _MOLCAS_MPP_
    LU = LUH0T(1)
#   endif
    IDISK = IDSMAT(iSym,iCase)
    nBlock = nTri_Elem(nSize)
  case ('B')
#   ifdef _MOLCAS_MPP_
    LU = LUH0T(2)
#   endif
    IDISK = IDBMAT(iSym,iCase)
    nBlock = nTri_Elem(nSize)
  case ('T')
#   ifdef _MOLCAS_MPP_
    LU = LUH0T(3)
#   endif
    IDISK = IDTMAT(iSym,iCase)
    nBlock = nSize
  case ('M')
#   ifdef _MOLCAS_MPP_
    LU = LUH0T(4)
#   endif
    IDISK = IDSTMAT(iSym,iCase)
    nBlock = nSize
end select

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  call GA_Sync()
  myRank = GA_NodeID()
  call GA_Distribution(lg_M,myRank,ISTA,IEND,JSTA,JEND)
  if ((ISTA > 0) .and. (JSTA > 0)) then
    call GA_Access(lg_M,ISTA,IEND,JSTA,JEND,mpt_M,LDM)
    NBLOCK = LDM*(JEND-JSTA+1)
    call DDAFILE(LU,1,DBL_MB(mpt_M),NBLOCK,IDISK)
    call GA_Release(lg_M,ISTA,IEND,JSTA,JEND)
  end if
  call GA_Sync()
else
#endif
  call DDAFILE(LUSBT,1,GA_Arrays(lg_M)%A(:),nBlock,IDISK)
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine PSBMAT_WRITE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Sebastian Wouters                                *
!               2016, Quan Phung                                       *
!***********************************************************************
! Subroutine to load 2RDM
! Written by Quan Phung and Sebastian Wouters, Leuven, Aug 2016

subroutine chemps2_load2pdm( NAC, PT, CHEMROOT )

  USE HDF5
  USE ISO_C_BINDING
#ifdef _MOLCAS_MPP_
  USE MPI
#endif

  IMPLICIT NONE
  INTEGER, INTENT(IN) :: NAC, CHEMROOT
  REAL*8, INTENT(OUT) :: PT( NAC, NAC, NAC, NAC )

  CHARACTER(LEN=30) :: file_2rdm

  INTEGER( HID_T )   :: file_h5, group_h5, space_h5, dset_h5 ! Handles
  INTEGER(4)         :: hdferr
  TYPE( C_PTR )      :: f_ptr
  LOGICAL            :: irdm

  INTEGER :: i,j,k,l,idx
  character(len=10) :: rootindex
#ifdef _MOLCAS_MPP_
  EXTERNAL Is_Real_Par, KING
  Logical KING
  Logical Is_Real_Par
#endif

  REAL*8, DIMENSION( 1 : NAC * NAC * NAC * NAC ), TARGET :: two_rdm

  write(rootindex,"(I2)") chemroot-1
  file_2rdm="molcas_2rdm.h5.r"//trim(adjustl(rootindex))
  file_2rdm=trim(adjustl(file_2rdm))
  call f_inquire(file_2rdm, irdm)
  if (.NOT. irdm) then
     write(6,'(1X,A15,I3,A16)') 'CHEMPS2> Root: ',CHEMROOT,' :: No 2RDM file'
     call abend()
  endif


!#ifdef _MOLCAS_MPP_
!  if ( MPP().AND.KING() ) then
!#endif

  CALL h5open_f( hdferr )
  CALL h5fopen_f( file_2rdm, H5F_ACC_RDONLY_F, file_h5, hdferr )
  CALL h5gopen_f( file_h5, "2-RDM", group_h5, hdferr )
  CALL h5dopen_f( group_h5, "elements", dset_h5, hdferr )
  CALL h5dget_space_f( dset_h5, space_h5, hdferr )
  f_ptr = C_LOC( two_rdm( 1 ) )
  CALL h5dread_f( dset_h5, H5T_NATIVE_DOUBLE, f_ptr, hdferr )
  CALL h5dclose_f( dset_h5 , hdferr )
  CALL h5sclose_f( space_h5, hdferr )
  CALL h5gclose_f( group_h5, hdferr )
  CALL h5fclose_f( file_h5,  hdferr )
!#ifdef _MOLCAS_MPP_
!  end if
!  call MPI_Bcast( two_rdm, NAC * NAC * NAC * NAC, MPI_DOUBLE_PRECISION, 0,     MPI_COMM_WORLD, IERROR4 )
!#endif


  do i=1,NAC
     do j=1,NAC
       do k=1,NAC
         do l=1,NAC
           idx = i + NAC * ( k - 1 + NAC * ( j - 1 + NAC * ( l - 1 )))
           PT( i, j, k, l ) = two_rdm( idx )
         enddo
       enddo
     enddo
  enddo

end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_get_MO(iOK,nDen,nSym,nBas,nIsh,CM,MSQ)

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use Constants, only: Zero, One
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: iOK
integer(kind=iwp), intent(in) :: nDen, nSym, nBas(nSym), nIsh(nSym)
type(DSBA_Type), intent(in) :: CM(nDen)
type(DSBA_Type), intent(_OUT_) :: MSQ(nDen)
integer(kind=iwp) :: i, iComp, ikc, iOpt, irc, iSyLbl, iSym, ja, nBm, NumV
real(kind=wp) :: Thr, Ymax
type(DSBA_Type) :: SMat
real(kind=wp), allocatable :: SXMat(:)
real(kind=wp), allocatable, target :: Dmat0(:)
real(kind=wp), pointer :: Dmat(:,:) => null()

!***********************************************************************
irc = 0
ikc = 0

nBm = nBas(1)
do iSym=2,nSym
  nBm = max(nBm,nBas(iSym))
end do
call mma_allocate(Dmat0,nBm**2,Label='Dmat')

iSym = 1
do while (iSym <= nSym)

  DMat(1:nBas(iSym),1:nBas(iSym)) => DMat0(1:nBas(iSym)**2)

  if ((nBas(iSym) > 0) .and. (nIsh(iSym) > 0)) then

    ! Inactive D(a,b) = sum_i C(a,i)*C(b,i)

    call DGEMM_('N','T',nBas(iSym),nBas(iSym),nIsh(iSym),One,CM(1)%SB(iSYm)%A2,nBas(iSym),CM(1)%SB(iSYm)%A2,nBas(iSym),Zero,DMat, &
                nBas(iSym))

    Ymax = Zero
    do ja=1,nBas(iSym)
      Ymax = max(Ymax,DMat(ja,ja))
    end do
    Thr = 1.0e-13_wp*Ymax

    call CD_InCore(DMat,nBas(iSym),MSQ(1)%SB(iSym)%A2,nBas(iSym),NumV,Thr,irc)

    if (NumV /= nIsh(iSym)) ikc = 1

  end if

  if ((irc /= 0) .or. (ikc /= 0)) iSym = nSym

  iSym = iSym+1

  DMat => null()

end do

if ((nDen == 2) .and. (irc == 0) .and. (ikc == 0)) then

  call Allocate_DT(SMat,nBas,nBas,nSym,aCase='TRI')
  call mma_allocate(SXMat,nBm**2,Label='SXMat')

  ! Read overlap integrals (LT-storage) and get Square-storage
  iRc = -1
  iOpt = 2
  iComp = 1
  iSyLbl = 1
  call RdOne(iRc,iOpt,'Mltpl  0',iComp,SMat%A0,iSyLbl)

  ! Compute  X_b[a] = C_b U_a   where  U_a = C_a^T S X_a
  ! ----------------------------------------------------
  do i=1,nSym

    DMat(1:nBas(iSym),1:nBas(iSym)) => DMat0(1:nBas(iSym)**2)

    if ((nBas(i) > 0) .and. (nIsh(i) > 0)) then

      call SQUARE(SMat%SB(i)%A1,DMat,1,NBas(i),NBas(i))

      call DGEMM_('N','N',nBas(i),nIsh(i),nBas(i),One,DMat,nBas(i),MSQ(1)%SB(i)%A2,nBas(i),Zero,SXMat,nBas(i))

      DMat(1:nIsh(iSym),1:nIsh(iSym)) => DMat0(1:nIsh(iSym)**2)

      call DGEMM_('T','N',nIsh(i),nIsh(i),nBas(i),One,CM(1)%SB(i)%A2,nBas(i),SXMat,nBas(i),Zero,DMat,nIsh(i))

      !write(u6,*) ' U_a = C_a^T S X_a   for symmetry block: ',i
      !call cho_output(DMat,1,nIsh(i),1,nIsh(i),nIsh(i),nIsh(i),1,u6)

      call DGEMM_('N','N',nBas(i),nIsh(i),nIsh(i),One,CM(2)%SB(i)%A2,nBas(i),DMat,nIsh(i),Zero,MSQ(2)%SB(i)%A2,nBas(i))

    end if

    DMat => null()

  end do

  call mma_deallocate(SXMat)
  call Deallocate_DT(SMat)

end if

call mma_deallocate(DMat0)

iOK = 0
if ((irc /= 0) .or. (ikc /= 0)) iOK = 1

return

end subroutine CHO_get_MO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OneOverR(Fil,Ax,Ay,Az,BoMaH,BoMaO,EEDisp,iCNum,Eint,iQ_Atoms,outxyz)

use qmstat_global, only: CAFieldG, CBFieldG, CFexp, Cordst, FieldDamp, nCent, nPart, nPol, Qsta
use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One, Two, Three, Five
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms, iCNum
real(kind=wp), intent(out) :: Fil(nPol*nPart,3,nTri_Elem(iQ_Atoms),10), EEDisp
real(kind=wp), intent(in) :: Ax, Ay, Az, BoMaH(iQ_Atoms), BoMaO(iQ_Atoms), outxyz(3,nTri_Elem(iQ_Atoms))
real(kind=wp), intent(inout) :: Eint(nTri_Elem(iQ_Atoms),10)
integer(kind=iwp) :: i, ip, j, k
real(kind=wp) :: G(3), R2(5), Rab3i(5), Rab(3,5), Rg(5), Se(5), U(3,5)

EEdisp = Zero
!----------------------------------------------------------------------*
! Compute some distances and inverted distances etc. The potential,    *
! the field and etc. and when we already have the numbers, we also do  *
! the dispersion interaction.                                          *
!----------------------------------------------------------------------*
do k=1,nTri_Elem(iQ_Atoms)
  G(1) = outxyz(1,k)+Ax
  G(2) = outxyz(2,k)+Ay
  G(3) = outxyz(3,k)+Az
  do j=iCnum+1,nPart
    i = (j-1)*nCent
    ip = (j-1)*nPol
    !Below follow a lot of distances to and fro.
    Rab(:,1) = Cordst(:,i+1)-G
    Rab(:,2) = Cordst(:,i+2)-G
    Rab(:,3) = Cordst(:,i+3)-G
    Rab(:,4) = Cordst(:,i+4)-G
    Rab(:,5) = Cordst(:,i+5)-G
    R2(:) = Rab(1,:)**2+Rab(2,:)**2+Rab(3,:)**2
    Rg(:) = sqrt(R2)
    Se(:) = One/Rg
    ! This term will below turn into the interaction between
    ! charges on water and the MME-charges on the QM-molecule.
    Eint(k,1) = Eint(k,1)-Qsta(1)*Se(2)-Qsta(2)*Se(3)-Qsta(3)*Se(4)-Qsta(4)*Se(5)
    Rab3i(:) = Se/R2
    !------------------------------------------------------------------*
    ! The dispersion interaction between QM-atoms and solvent is       *
    ! computed, with or without damping. The initial if-clause sees to *
    ! that only atom-centers are included, while bonds and virtual     *
    ! centers are ignored.                                             *
    !------------------------------------------------------------------*
    if (k <= iQ_atoms) call DispEnergy(EEDisp,BoMah(k),BoMaO(k),Rg(1),Rg(2),Rg(3),Rab3i(1),Rab3i(2),Rab3i(3),k)
    !------------------------------------------------------------------*
    ! Now we wrap up the electrostatics.                               *
    !------------------------------------------------------------------*
    U(1,:) = Rab(1,:)*Se
    U(2,:) = Rab(2,:)*Se
    U(3,:) = Rab(3,:)*Se
    ! These three terms will below turn into the interaction
    ! between water charges and the MME-dipoles on the QM-mol.
    ! Change sign of charge, change sign of vector and then we
    ! should also change sign since when a dipole interacts with
    ! a field we have a minus sign, but this minus sign we have
    ! omitted in hel; therefore this calculation gives the right
    ! number eventually.
    Eint(k,2) = -Qsta(1)*Rab(1,2)*Rab3i(2)-Qsta(2)*Rab(1,3)*Rab3i(3)-Qsta(3)*Rab(1,4)*Rab3i(4)-Qsta(4)*Rab(1,5)*Rab3i(5)+Eint(k,2)
    Eint(k,3) = -Qsta(1)*Rab(2,2)*Rab3i(2)-Qsta(2)*Rab(2,3)*Rab3i(3)-Qsta(3)*Rab(2,4)*Rab3i(4)-Qsta(4)*Rab(2,5)*Rab3i(5)+Eint(k,3)
    Eint(k,4) = -Qsta(1)*Rab(3,2)*Rab3i(2)-Qsta(2)*Rab(3,3)*Rab3i(3)-Qsta(3)*Rab(3,4)*Rab3i(4)-Qsta(4)*Rab(3,5)*Rab3i(5)+Eint(k,4)
    ! And here it is the MME-quadrupoles that are prepared.
    ! Change sign of charges, change sign two times of the
    ! vector (in effect, zero times then) and then in the
    ! energy expression for the interaction between the field
    ! vector from a charge and a quarupole there is a plus
    ! sign, so a minus is the right sign below.
    Eint(k,5) = Eint(k,5)-Qsta(1)*U(1,2)**2*Rab3i(2)-Qsta(2)*U(1,3)**2*Rab3i(3)-Qsta(3)*U(1,4)**2*Rab3i(4)- &
                Qsta(4)*U(1,5)**2*Rab3i(5)
    Eint(k,7) = Eint(k,7)-Qsta(1)*U(2,2)**2*Rab3i(2)-Qsta(2)*U(2,3)**2*Rab3i(3)-Qsta(3)*U(2,4)**2*Rab3i(4)- &
                Qsta(4)*U(2,5)**2*Rab3i(5)
    Eint(k,10) = Eint(k,10)-Qsta(1)*U(3,2)**2*Rab3i(2)-Qsta(2)*U(3,3)**2*Rab3i(3)-Qsta(3)*U(3,4)**2*Rab3i(4)- &
                 Qsta(4)*U(3,5)**2*Rab3i(5)
    Eint(k,6) = Eint(k,6)-Qsta(1)*U(1,2)*U(2,2)*Rab3i(2)-Qsta(2)*U(1,3)*U(2,3)*Rab3i(3)-Qsta(3)*U(1,4)*Rab3i(4)*U(2,4)- &
                Qsta(4)*U(1,5)*Rab3i(5)*U(2,5)
    Eint(k,8) = Eint(k,8)-Qsta(1)*U(1,2)*U(3,2)*Rab3i(2)-Qsta(2)*U(1,3)*U(3,3)*Rab3i(3)-Qsta(3)*U(1,4)*Rab3i(4)*U(3,4)- &
                Qsta(4)*U(1,5)*Rab3i(5)*U(3,5)
    Eint(k,9) = Eint(k,9)-Qsta(1)*U(3,2)*U(2,2)*Rab3i(2)-Qsta(2)*U(3,3)*U(2,3)*Rab3i(3)-Qsta(3)*U(3,4)*Rab3i(4)*U(2,4)- &
                Qsta(4)*U(3,5)*Rab3i(5)*U(2,5)

    !------------------------------------------------------------------*
    ! And now a whole lot of grad(1/r) and higher...                   *
    !------------------------------------------------------------------*
    ! Monopoles.
    Fil(ip+1:ip+3,1,k,1) = Rab(1,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,2,k,1) = Rab(2,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,3,k,1) = Rab(3,1:3)*Rab3i(1:3)
    ! Dipole -- x-component.
    Fil(ip+1:ip+3,1,k,2) = (Three*U(1,1:3)**2-One)*Rab3i(1:3)
    Fil(ip+1:ip+3,2,k,2) = Three*U(2,1:3)*U(1,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,3,k,2) = Three*U(3,1:3)*U(1,1:3)*Rab3i(1:3)
    ! Dipole -- y-component.
    Fil(ip+1:ip+3,1,k,3) = Three*U(2,1:3)*U(1,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,2,k,3) = (Three*U(2,1:3)**2-One)*Rab3i(1:3)
    Fil(ip+1:ip+3,3,k,3) = Three*U(3,1:3)*U(2,1:3)*Rab3i(1:3)
    ! Dipole -- z-component.
    Fil(ip+1:ip+3,1,k,4) = Three*U(3,1:3)*U(1,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,2,k,4) = Three*U(3,1:3)*U(2,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,3,k,4) = (Three*U(3,1:3)**2-One)*Rab3i(1:3)
    ! Quadrupole -- xx-component.
    Fil(ip+1:ip+3,1,k,5) = U(1,1:3)*(Five*U(1,1:3)**2-Two)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,5) = Five*U(2,1:3)*U(1,1:3)**2*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,5) = Five*U(3,1:3)*U(1,1:3)**2*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- yy-component.
    Fil(ip+1:ip+3,1,k,7) = Five*U(2,1:3)**2*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,7) = U(2,1:3)*(Five*U(2,1:3)**2-Two)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,7) = Five*U(3,1:3)*U(2,1:3)**2*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- zz-component.
    Fil(ip+1:ip+3,1,k,10) = Five*U(3,1:3)**2*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,10) = Five*U(3,1:3)**2*U(2,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,10) = U(3,1:3)*(Five*U(3,1:3)**2-Two)*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- xy-component.
    Fil(ip+1:ip+3,1,k,6) = U(2,1:3)*(Five*U(1,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,6) = U(1,1:3)*(Five*U(2,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,6) = Five*U(3,1:3)*U(2,1:3)*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- xz-component.
    Fil(ip+1:ip+3,1,k,8) = U(3,1:3)*(Five*U(1,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,8) = Five*U(3,1:3)*U(2,1:3)*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,8) = U(1,1:3)*(Five*U(3,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- yz-component.
    Fil(ip+1:ip+3,1,k,9) = Five*U(3,1:3)*U(2,1:3)*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,9) = U(3,1:3)*(Five*U(2,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,9) = U(2,1:3)*(Five*U(3,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    !------------------------------------------------------------------*
    ! If damping of the field is requested, then do it.                *
    !------------------------------------------------------------------*
    if (FieldDamp) then
      Fil(ip+1,:,k,:) = Fil(ip+1,:,k,:)*(One-exp(CAFieldG*Rg(1)))**CFexp
      Fil(ip+2,:,k,:) = Fil(ip+2,:,k,:)*(One-exp(CBFieldG*Rg(2)))**CFexp
      Fil(ip+3,:,k,:) = Fil(ip+3,:,k,:)*(One-exp(CBFieldG*Rg(3)))**CFexp
    end if
  end do
end do

return

end subroutine OneOverR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Jeppe Olsen                                      *
*               1989, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE IWRTMA(IMAT,NROW,NCOL,MAXROW,MAXCOL)
C
C     AUTHOR: J. OLSEN, UNIV. OF LUND, SWEDEN, APRIL 1987
C     MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
C                    M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
C
C     WRITE A MATRIX OF INTEGER VALUES
C
      DIMENSION IMAT(MAXROW,MAXCOL)
C
      DO 100 I = 1, NROW
        Write(6,1110) (IMAT(I,J),J= 1,NCOL)
100   CONTINUE
1110  FORMAT(/,1X,8I10,/,(1X,8I10))
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function iTabRow(i)
      Implicit Integer (a-z)
*
      iTabRow=0
      iTabRow=1
      If (i.gt. 0 .and. i.le. 2) Then
         iTabRow=1
      Else If (i.gt. 2 .and. i.le.10) Then
         iTabRow=2
      Else If (i.gt.10 .and. i.le.18) Then
         iTabRow=3
      Else If (i.gt.18 .and. i.le.36) Then
         iTabRow=4
      Else If (i.gt.36 .and. i.le.54) Then
         iTabRow=5
      Else If (i.gt.54 .and. i.le.86) Then
         iTabRow=6
      Else If (i.gt.86) Then
         iTabRow=7
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine expandbas(Bas1,nBas1,Bas2,nBas2,Orb1,Orb2,occ1,eorb1,indt1,occ2,eorb2,indt2)
! This subroutine expands the MOs for a given symmetry
! Orb1 are the input orbitals of dimension nBas1*bas1 (file INPORB)
! Orb2 are the output orbitals of dimension nBas2*bas2 (file EXPORB)
! Bas1 and Bas2 are the basis set specifications for the old and
! new basis, respectively. They have dimensions nBas1 and nBas2.

#include "intent.fh"

use info_expbas_mod, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
character(len=LenIn+8), intent(in) :: Bas1(*), Bas2(*)
integer(kind=iwp), intent(in) :: nBas1, nBas2, indt1(*)
integer(kind=iwp), intent(_OUT_) :: indt2(*)
real(kind=wp), intent(in) :: Orb1(*), occ1(*), eorb1(*)
real(kind=wp), intent(_OUT_) :: Orb2(*), occ2(*), eorb2(*)
integer(kind=iwp) :: i, Ibas1, Ibas2, imo, lmo1, lmo2, Nzero
integer(kind=iwp), allocatable :: Izero(:)

! Loop through the new basis labels and compare with the old.
! If they are equal copy orbital coefficients
! If not, add zeros until they fit again

call mma_allocate(Izero,nBas2,label='Izero')

Nzero = 0
Ibas2 = 1
Ibas1 = 1
do while (Ibas1 <= nBas1)
  if (Bas2(Ibas2) == Bas1(Ibas1)) then
    lmo1 = 0
    lmo2 = 0
    do imo=1,nBas1
      Orb2(lmo2+Ibas2) = Orb1(lmo1+Ibas1)
      lmo1 = lmo1+nBas1
      lmo2 = lmo2+nBas2
    end do
    Ibas1 = Ibas1+1
    Ibas2 = Ibas2+1
  else
    Nzero = Nzero+1
    Izero(Nzero) = Ibas2
    lmo2 = 0
    do imo=1,nBas1
      Orb2(lmo2+Ibas2) = Zero
      lmo2 = lmo2+nBas2
    end do
    Ibas2 = Ibas2+1
  end if
end do

! Add zeros at the end of each basis function

if (Ibas2 <= nBas2) then
  do i=Ibas2,nBas2
    Nzero = Nzero+1
    Izero(Nzero) = i
    lmo2 = 0
    do imo=1,nBas1
      Orb2(lmo2+i) = Zero
      lmo2 = lmo2+nBas2
    end do
  end do
end if

! Add new basis functions at the end and expand occ, eorb, and indt

if (nBas1 /= 0) then
  do imo=1,nBas1
    occ2(imo) = occ1(imo)
    eorb2(imo) = eorb1(imo)
    indt2(imo) = indt1(imo)
  end do
end if

if (nBas1 < nBas2) then
  Nzero = 0
  do imo=nBas1+1,nBas2
    Nzero = Nzero+1
    do Ibas2=1,nBas2
      Orb2(nBas2*(imo-1)+Ibas2) = Zero
    end do
    Orb2(nBas2*(imo-1)+Izero(Nzero)) = One
    occ2(imo) = Zero
    eorb2(imo) = Zero
    indt2(imo) = 6
  end do
end if

call mma_deallocate(Izero)

return

end subroutine expandbas

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine diis(wrk,wrksize,diispointt,diispointr,key)
! 1) increment key
! 2) if key >=firstext do:
! Tn = DIIS (previous cycext)
! Tn=(T21,T22,T23,T13,T14)
! if key < firstext
! Tn=Tn(prev)
!
! diispointt - pointer of T stack (I)
! diispointr - pointer of R stack (I)
! key        - manipulation key (I/O)

use ccsd_global, only: cycext, firstext, fullprint, t13, t14, t21, t22, t23, v1, v2, v3, v4
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, diispointt(4), diispointr(4)
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp), intent(inout) :: key
integer(kind=iwp) :: lun1, nhelp, rc
real(kind=wp) :: cdiis(4), rdiis1(4,4)

!ulf
cdiis(:) = Zero
rdiis1(:,:) = Zero
!1 increment key
key = key+1

if (key < firstext) then

  ! get Tn from last position

  ! get lun number
  lun1 = diispointt(1)
  ! rewind lun1
  call filemanager(2,lun1,rc)
  ! T2aaaa
  call getmediate(wrk,wrksize,lun1,t21,rc)
  ! T2bbbb
  call getmediate(wrk,wrksize,lun1,t22,rc)
  ! T2abab
  call getmediate(wrk,wrksize,lun1,t23,rc)
  ! T1aa
  call getmediate(wrk,wrksize,lun1,t13,rc)
  ! T1bb
  call getmediate(wrk,wrksize,lun1,t14,rc)
  ! rewind lun1
  call filemanager(2,lun1,rc)

  return
end if

!2.1 make overlap matrix

!2.1.1 rewind R-files
call diisrf(diispointr,cycext)

!2.1.2.1 read R-T21
call diisra(wrk,wrksize,diispointr,cycext,v1,v2,v3,v4)

!2.1.2.2 add overlap mtx
call diish1(wrk,wrksize,4,rdiis1,v1,v2,v3,v4,cycext,1)

!2.1.3.1 read R-T22
call diisra(wrk,wrksize,diispointr,cycext,v1,v2,v3,v4)

!2.1.3.2 add overlap mtx
call diish1(wrk,wrksize,4,rdiis1,v1,v2,v3,v4,cycext,0)

!2.1.4.1 read R-T23
call diisra(wrk,wrksize,diispointr,cycext,v1,v2,v3,v4)

!2.1.4.2 add overlap mtx
call diish1(wrk,wrksize,4,rdiis1,v1,v2,v3,v4,cycext,0)

!2.1.5.1 read R-T13
call diisra(wrk,wrksize,diispointr,cycext,v1,v2,v3,v4)

!2.1.5.2 add overlap mtx
call diish1(wrk,wrksize,2,rdiis1,v1,v2,v3,v4,cycext,0)

!2.1.6.1 read R-T14
call diisra(wrk,wrksize,diispointr,cycext,v1,v2,v3,v4)

!2.1.6.2 add overlap mtx
call diish1(wrk,wrksize,2,rdiis1,v1,v2,v3,v4,cycext,0)

!2.2.1 calc DIIS coefficients
call diish2(rdiis1,cycext,cdiis)

!2.2.2 write DIIS coefficients
if (fullprint > 1) write(u6,'(6X,A,4(F9.5,2X))') 'DIIS coefficients   :',(cdiis(nhelp),nhelp=1,cycext)

!2.3 make new vector

!2.3.1 rewind T-files
call diisrf(diispointt,cycext)

!2.3.2.1 read T21
call diisra(wrk,wrksize,diispointt,cycext,v1,v2,v3,v4)

!2.3.2.2 make new T21
call diish3(wrk,wrksize,t21,v1,v2,v3,v4,cdiis,cycext)

!2.3.3.1 read T22
call diisra(wrk,wrksize,diispointt,cycext,v1,v2,v3,v4)

!2.3.3.2 make new T22
call diish3(wrk,wrksize,t22,v1,v2,v3,v4,cdiis,cycext)

!2.3.4.1 read T23
call diisra(wrk,wrksize,diispointt,cycext,v1,v2,v3,v4)

!2.3.4.2 make new T23
call diish3(wrk,wrksize,t23,v1,v2,v3,v4,cdiis,cycext)

!2.3.5.1 read T13
call diisra(wrk,wrksize,diispointt,cycext,v1,v2,v3,v4)

!2.3.5.2 make new T13
call diish3(wrk,wrksize,t13,v1,v2,v3,v4,cdiis,cycext)

!2.3.6.1 read T14
call diisra(wrk,wrksize,diispointt,cycext,v1,v2,v3,v4)

!2.3.6.2 make new T14
call diish3(wrk,wrksize,t14,v1,v2,v3,v4,cdiis,cycext)

return

end subroutine diis

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ReClose()
      Use Para_Info, Only: nProcs
      Implicit None
#include "WrkSpc.fh"
#include "timtra.fh"
*                                                                      *
************************************************************************
* Deallocate the arrays allocated by StartLight                        *
************************************************************************
*                                                                      *
      If (nfld_tim.ne.0)
     &  Call GetMem('iGATim','Free','Real',iGATim,nProcs*nfld_tim*2)
      If (nfld_stat.ne.0)
     &  Call GetMem('iGAStat','Free','Real',iGAStat,nProcs*nfld_stat)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine Picky_inner(Din,n,m,nijPrm,nijCmp,nDCR,nSt,nEnd,mSt,mEnd,Dout)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, m, nijPrm, nijCmp, nDCR, nSt, nEnd, mSt, mEnd
real(kind=wp), intent(in) :: Din(((n*m+1)*nijCmp)+nijPrm+1,nDCR)
real(kind=wp), intent(out) :: Dout((((nEnd-nSt+1)*(mEnd-mSt+1)+1)*nijCmp)+nijPrm+1,nDCR)
integer(kind=iwp) :: i_n, iDCR, iIn, ijCmp, im, iOut, jIn, jm, jn, jOut, nl, ml

if ((nSt == 1) .and. (nEnd == n) .and. (mSt == 1) .and. (mEnd == m)) then
  ! Copy the whole block
  Dout(:,:) = Din(:,:)
else
  nl = nEnd-nSt+1
  ml = mEnd-mSt+1
  iIn = (n*m+1)*nijCmp
  iOut = (nl*ml+1)*nijCmp
  ! Loop over desymmetrized density blocks
  do iDCR=1,nDCR
    ! Loop over angular combinations
    do ijCmp=1,nijCmp
      jm = 0
      ! Loop over subset of contracted basis
      do im=mSt,mEnd
        jm = jm+1
        jn = 0
        ! Loop over subset of contracted basis
        do i_n=nSt,nEnd
          jn = jn+1
          Dout(ij(jn,jm,ijCmp,nl,ml),iDCR) = Din(ij(i_n,im,ijCmp,n,m),iDCR)
        end do
      end do
      ! Move the largest density matrix element for
      ! this angular combination
      jIn = ij(n,m,ijCmp,n,m)+1
      jOut = ij(nl,ml,ijCmp,nl,ml)+1
      Dout(jOut,iDCR) = Din(jIn,iDCR)
    end do
    ! Move the largest density matrix element for
    ! each pair plus the overall largest element
    Dout(iOut+1:iOut+nijPrm+1,iDCR) = Din(iIn+1:iIn+nijPrm+1,iDCR)
  end do
end if

return

contains

pure function ij(i,j,k,nn,mm)

  integer(kind=iwp) :: ij
  integer(kind=iwp), intent(in) :: i, j, k, nn, mm

  ij = (k-1)*(nn*mm+1)+(j-1)*nn+i

end function ij

end subroutine Picky_inner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Per-Olof Widmark                                 *
!               1993,1996,1997, Markus P. Fuelscher                    *
!               1996, Luis Serrano-Andres                              *
!               2012, Victor P. Vysotskiy                              *
!***********************************************************************

subroutine DaName_Main(Lu,String,mf,wa)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Open unit Lu for direct access I/O and link the data stream to   *
!     the logical file name Name.                                      *
!                                                                      *
!     calling arguments:                                               *
!     Lu      : integer, input                                         *
!               logical unit number                                    *
!     LuName  : character string, input                                *
!               logical file name                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, IBM Sweden, 1991                                   *
!     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
!     L. Serrano-Andres, University of Lund, Sweden, 1996              *
!----------------------------------------------------------------------*
!                                                                      *
! History:                                                             *
!          V.P. Vysotskiy, University of Lund, Sweden, 2012            *
!                                                                      *
!***********************************************************************

#if defined(_I8_) || defined(_OPENMP)
#define NO_SPLITTING
#endif

#ifndef _GA_
use Prgm, only: isInMem
use Fast_IO, only: eFiMFo, isFiM
#endif
use Fast_IO, only: Addr, FSCB, isOpen, LuName, LuNameProf, MBL, MBl_nwa, MBl_wa, MPUnit, Multi_File, MxFile, NProfFiles, Trace
use Definitions, only: iwp, u6
#ifndef NO_SPLITTING
use Fast_IO, only: Max_File_Length, MaxFileSize, MaxSplitFile
use Definitions, only: wp
#endif

implicit none
integer(kind=iwp), intent(inout) :: Lu
character(len=*), intent(in) :: String
logical(kind=iwp), intent(in) :: mf, wa
integer(kind=iwp) :: i, inUse, iRc, temp, tmp
character(len=80) :: Text
character(len=8) :: StdNam
character(len=*), parameter :: TheName = 'DaName_Main'
integer(kind=iwp), external :: AixErr, AixOpn, isFreeUnit
#ifndef NO_SPLITTING
integer(kind=iwp) :: lName, MFMB
integer(kind=iwp), external :: AllocDisk, StrnLn
#endif

if (Trace) then
  write(u6,*) ' >>> Enter DaName_Main <<<'
  write(u6,*) ' unit :',Lu
  write(u6,*) ' name :',String,mf,wa
end if

tmp = Lu
Lu = isfreeunit(tmp)
! Check calling arguments
if ((Lu <= 0) .or. (Lu > MxFile)) call SysFileMsg(TheName,'MSG: unit',Lu,String)

! Check for consistency
if (isOpen(Lu) /= 0) call SysFileMsg(TheName,'MSG: used',Lu,String)

! Reformat file name to standard notation
! (capital letters, no leading blank)
call StdFmt(String,StdNam)

! If no file name has been given link it to the default name
if (StdNam == '        ') write(StdNam,'(A,I2.2,A)') 'FT',Lu,'F001'

! Check the storage scheme
#ifndef _GA_
isFiM(Lu) = 0
isFiM(Lu) = isinmem(StdNam)
#ifdef _DEBUGPRINT_IO_
if (isFiM(Lu) > 0) write(u6,*) 'The file ',StdNam,' will be kept in memory'
#endif
! Open file
temp = isFiM(Lu)
#else
temp = 0
#endif
iRc = AixOpn(temp,StdNam,.true.)
#ifndef _GA_
if (iRc == eFiMFo) then
# ifdef _DEBUGPRINT_IO_
  write(u6,*) 'Failed to open file in memory'
# endif
  isFiM(Lu) = 0
  iRc = 0
end if
#endif
if (iRc /= 0) then
  iRc = AixErr(Text)
  call SysFileMsg(TheName,'MSG: open',Lu,Text)
end if
isOpen(Lu) = 1
FSCB(Lu) = temp
LuName(Lu) = StdNam
inUse = 0
do i=1,NProfFiles
  if (LuNameProf(i) == StdNam) then
    inUse = 1
  end if
end do

if (inUse == 0) then
  if (NProfFiles+1 <= MxFile) then
    NProfFiles = NProfFiles+1
    LuNameProf(NProfFiles) = StdNam
  else
    write(u6,*) 'IO error: NProfFiles+1.gt.MxFile'
    write(u6,*) 'Increase MxFile in module Fast_IO'
    call Abend()
  end if
end if
Addr(Lu) = 0
MPUnit(0,Lu) = Lu
Multi_File(Lu) = .false.
MBL(Lu) = merge(MBl_wa,MBl_nwa,wa)
#ifndef NO_SPLITTING
if (mf) then
  Multi_File(Lu) = .true.
  MaxFileSize = AllocDisk()
  MFMB = int(real(Max_File_Length,kind=wp)/(1024.0_wp**2))
  if (MaxFileSize > MFMB) then
    write(u6,*)
    write(u6,*) 'DANAME_MF: Requested MaxFileSize is too large!'
    write(u6,*) ' Requested value of ',MaxFileSize
    MaxFileSize = MFMB
    write(u6,*) ' has been reset to  ',MaxFileSize
  else if (MaxFileSize /= 0) then
    if (Trace) write(u6,*) ' This is a partitioned data set'
    lName = StrnLn(String)
    if ((lName == 0) .or. (lName == 8)) &
      call SysFileMsg(TheName,'Invalid file name.\n File names used in multiple unit files must be less than 8 characters.', &
                      Lu,String)
    do i=1,MaxSplitFile-1
      MPUnit(i,Lu) = -99
    end do
  end if
end if
#endif
if (Trace) then
  write(u6,*) ' >>> Exit DaName_Main <<<'
end if

return

end subroutine DaName_Main

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! Molcas BLAS wrappers
! These wrappers handle lp64/ilp64 interfaces and various other
! requirements related to e.g. matrix size on GPUs. Any BLAS call in
! Molcas should use these wrappers.

! List of BLAS wrappers currently implemented:
! drot_
! dswap_
! dscal_
! zscal_
! zdscal_
! dcopy_
! zcopy_
! scopy_
! daxpy_
! zaxpy_
! ddot_
! dnrm2_
! dasum_
! idamax_
! dgemm_
! dspmv_
! dgemv_
! dznrm2_
! zgemm_

! Set the appropriate integer size of the library interface:
#ifdef LINALG_I4
#  define BLASINT INTEGER*4
#  ifdef _I8_
#    define MOLCAS_TO_BLAS_INT
#  endif
#else
#  define BLASINT INTEGER*8
#endif


subroutine drot_(n_,dx,incx_,dy,incy_,c,s)
  implicit none
  integer n_, incx_, incy_
  real*8 dx(*),dy(*),c,s
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx,  incy
  n=n_
  incx=incx_
  incy=incy_
  call drot(n,dx,incx,dy,incy,c,s)
#else
  call drot(n_,dx,incx_,dy,incy_,c,s)
#endif
end subroutine

subroutine dswap_(n_,dx,incx_,dy,incy_)
  implicit none
  integer n_, incx_, incy_
  real*8 dx(*), dy(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx,  incy
  n=n_
  incx=incx_
  incy=incy_
  call dswap(n,dx,incx,dy,incy)
#else
  call dswap(n_,dx,incx_,dy,incy_)
#endif
end subroutine

subroutine dscal_(n_,da,dx,incx_)
  implicit none
  integer n_, incx_
  real*8 da, dx(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx
  n=n_
  incx=incx_
  call dscal(n,da,dx,incx)
#else
  call dscal(n_,da,dx,incx_)
#endif
end subroutine

subroutine zscal_(n_,da,dx,incx_)
  implicit none
  integer n_, incx_
  complex*16 da, dx(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx
  n=n_
  incx=incx_
  call zscal(n,da,dx,incx)
#else
  call zscal(n_,da,dx,incx_)
#endif
end subroutine

subroutine zdscal_(n_,da,dx,incx_)
  implicit none
  integer n_, incx_
  real*8 da
  complex*16 dx(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx
  n=n_
  incx=incx_
  call zdscal(n,da,dx,incx)
#else
  call zdscal(n_,da,dx,incx_)
#endif
end subroutine

subroutine dcopy_(n_,dx,incx_,dy,incy_)
  implicit none
  integer n_, incx_, incy_
  real*8 dx(*), dy(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx,  incy
  n=n_
  incx=incx_
  incy=incy_
  call dcopy(n,dx,incx,dy,incy)
#else
  call dcopy(n_,dx,incx_,dy,incy_)
#endif
end subroutine

subroutine zcopy_(n_,dx,incx_,dy,incy_)
  implicit none
  integer n_, incx_, incy_
  complex*16 dx(*), dy(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx,  incy
  n=n_
  incx=incx_
  incy=incy_
  call zcopy(n,dx,incx,dy,incy)
#else
  call zcopy(n_,dx,incx_,dy,incy_)
#endif
end subroutine

subroutine scopy_(n_,sx,incx_,sy,incy_)
  implicit none
  integer n_, incx_, incy_
  real sx(*), sy(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx,  incy
  n=n_
  incx=incx_
  incy=incy_
  call scopy(n,sx,incx,sy,incy)
#else
  call scopy(n_,sx,incx_,sy,incy_)
#endif
end subroutine

subroutine daxpy_(n_,da,dx,incx_,dy,incy_)
  implicit none
  integer n_, incx_, incy_
  real*8 da, dx(*), dy(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx,  incy
  n=n_
  incx=incx_
  incy=incy_
  call daxpy(n,da,dx,incx,dy,incy)
#else
  call daxpy(n_,da,dx,incx_,dy,incy_)
#endif
end subroutine

subroutine zaxpy_(n_,da,dx,incx_,dy,incy_)
  implicit none
  integer n_, incx_, incy_
  complex*16 da, dx(*), dy(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx,  incy
  n=n_
  incx=incx_
  incy=incy_
  call zaxpy(n,da,dx,incx,dy,incy)
#else
  call zaxpy(n_,da,dx,incx_,dy,incy_)
#endif
end subroutine

real*8 function ddot_(n_,dx,incx_,dy,incy_)
  implicit none
  integer n_, incx_, incy_
  real*8 dx(*), dy(*)
  real*8 ddot
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx,  incy
  n=n_
  incx=incx_
  incy=incy_
  ddot_ = ddot(n,dx,incx,dy,incy)
#else
  ddot_ = ddot(n_,dx,incx_,dy,incy_)
#endif
end function

real*8 function dnrm2_(n_,x,incx_)
  implicit none
  integer n_, incx_
  real*8 x(*)
  real*8, external :: dnrm2
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx
  n=n_
  incx=incx_
  dnrm2_ = dnrm2(n,x,incx)
#else
  dnrm2_ = dnrm2(n_,x,incx_)
#endif
end function


real*8 function dznrm2_(n_,x,incx_)
  implicit none
  integer n_, incx_
  complex*16 x(*)
  real*8, external :: dznrm2
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx
  n=n_
  incx=incx_
  dznrm2_ = dznrm2(n,x,incx)
#else
  dznrm2_ = dznrm2(n_,x,incx_)
#endif
end function



real*8 function dasum_(n_,dx,incx_)
  implicit none
  integer n_, incx_
  real*8 dx(*)
  real*8 dasum
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx
  n=n_
  incx=incx_
  dasum_ = dasum(n,dx,incx)
#else
  dasum_ = dasum(n_,dx,incx_)
#endif
end function

integer function idamax_(n_,dx,incx_)
  implicit none
  integer n_, incx_
  real*8 dx(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT n,  incx
  BLASINT, external :: idamax
  n=n_
  incx=incx_
  idamax_ = idamax(n,dx,incx)
#else
  integer, external :: idamax
  idamax_ = idamax(n_,dx,incx_)
#endif
end function

subroutine dgemm_(transa,transb,m_,n_,k_, &
      &           alpha,a,lda_,b,ldb_,beta,c,ldc_)
  implicit none
  character        transa, transb
  real*8           alpha, beta
  integer          k_, lda_, ldb_, ldc_, m_, n_
  real*8           a(lda_,*), b(ldb_,*), c(ldc_,*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT          k,  lda,  ldb,  ldc,  m,  n
#endif
#ifdef _CUDA_BLAS_
  integer          ncuda
  parameter (ncuda=128*128)
  integer*4        k4,lda4,ldb4,ldc4,m4,n4
#endif

  if(m_.eq.0.and.n_.eq.0) return

#ifdef _CUDA_BLAS_
  if(n_*m_.gt.ncuda) then
    k4=k_
    lda4=lda_
    ldb4=ldb_
    ldc4=ldc_
    m4=m_
    n4=n_
    call cublas_dgemm(transa,transb, &
      &               m4,n4,k4,alpha,a,lda4,b,ldb4,beta,c,ldc4)
  else
#endif

#ifdef MOLCAS_TO_BLAS_INT
    m=m_
    n=n_
    k=k_
    lda=lda_
    ldb=ldb_
    ldc=ldc_
    call dgemm(transa,transb, &
      &        m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
#else
    call dgemm(transa,transb,m_,n_,k_, &
      &        alpha,a,lda_,b,ldb_,beta,c,ldc_)
#endif

#ifdef _CUDA_BLAS_
  endif
#endif
end subroutine


subroutine zgemm_(transa,transb,m_,n_,k_, &
      &           alpha,a,lda_,b,ldb_,beta,c,ldc_)
  implicit none
  character        transa, transb
  complex*16       alpha, beta
  integer          k_, lda_, ldb_, ldc_, m_, n_
  complex*16       a(lda_,*), b(ldb_,*), c(ldc_,*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT          k,  lda,  ldb,  ldc,  m,  n
#endif
#ifdef _CUDA_BLAS_
  integer          ncuda
  parameter (ncuda=128*128)
  integer*4        k4,lda4,ldb4,ldc4,m4,n4
#endif

  if(m_.eq.0.and.n_.eq.0) return

#ifdef _CUDA_BLAS_
  if(n_*m_.gt.ncuda) then
    k4=k_
    lda4=lda_
    ldb4=ldb_
    ldc4=ldc_
    m4=m_
    n4=n_
    call cublas_zgemm(transa,transb, &
      &               m4,n4,k4,alpha,a,lda4,b,ldb4,beta,c,ldc4)
  else
#endif

#ifdef MOLCAS_TO_BLAS_INT
    m=m_
    n=n_
    k=k_
    lda=lda_
    ldb=ldb_
    ldc=ldc_
    call zgemm(transa,transb, &
      &        m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
#else
    call zgemm(transa,transb,m_,n_,k_, &
      &        alpha,a,lda_,b,ldb_,beta,c,ldc_)
#endif

#ifdef _CUDA_BLAS_
  endif
#endif
end subroutine


subroutine dspmv_ ( uplo,n_,alpha,ap,x,incx_,beta,y,incy_)
  implicit none
  character          uplo
  integer            n_, incx_, incy_
  real*8             alpha, beta
  real*8             ap( * ), x( * ), y( * )
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT            n,  incx,  incy
#endif
#ifdef _CUDA_BLAS_
  integer            ncuda
  parameter (ncuda=128)
  integer*4          n4, incx4, incy4
#endif

#ifdef _CUDA_BLAS_
  if(n_.gt.ncuda) then
    n4=n_
    incx4=incx_
    incy4=incy_
    call cublas_dspmv (uplo,n4,alpha,ap,x,incx4,beta,y,incy4)
  else
#endif

#ifdef MOLCAS_TO_BLAS_INT
    n=n_
    incx=incx_
    incy=incy_
    call dspmv ( uplo, n, alpha, ap, x, incx, beta, y, incy )
#else
    call dspmv ( uplo,n_,alpha,ap,x,incx_,beta,y,incy_)
#endif

#ifdef _CUDA_BLAS_
  endif
#endif
end subroutine

subroutine dgemv_(trans,m_,n_,alpha,a,lda_,x,incx_,beta,y,incy_)
  implicit none
  character        trans
  real*8           alpha,beta
  integer          incx_,incy_,lda_,m_,n_
  real*8           a(lda_,*),x(*),y(*)
#ifdef MOLCAS_TO_BLAS_INT
  BLASINT          incx, incy, lda, m, n
#endif
#ifdef _CUDA_BLAS_
  integer          ncuda
  parameter (ncuda=128*128)
  integer*4        lda4,m4,n4,incx4,incy4
#endif

#ifdef _CUDA_BLAS_
  if(n_*m_.gt.ncuda) then
    m4=m_
    n4=n_
    lda4=lda_
    incx4=incx_
    incy4=incy_
    call cublas_dgemv(trans,m4,n4,alpha,a,lda4,x,incx4,beta,y,incy4)
  else
#endif

#ifdef MOLCAS_TO_BLAS_INT
    m=m_
    n=n_
    lda=lda_
    incx=incx_
    incy=incy_
    call dgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
#else
    call dgemv(trans,m_,n_,alpha,a,lda_,x,incx_,beta,y,incy_)
#endif

#ifdef _CUDA_BLAS_
  endif
#endif
end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine hess_evb1_cvb(orbs,civbh,citmp,civb,sorbs,owrk,dvbdet,grad1,grad2,hessorb,vec1,iorts,hessinp,hessout)

use casvb_global, only: f1, f2, f3, f4, n_cihess, n_orbhess, ndet, ndetvb, nfrag, norb, nort, npr, nprorb, nprvb, nvb, strucopt
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: orbs(norb,norb), civb(0:ndet), grad1(npr), grad2(npr), hessorb(nprorb,nprorb)
real(kind=wp), intent(inout) :: civbh(0:ndet), citmp(0:ndet), dvbdet(ndetvb), hessinp(npr)
real(kind=wp), intent(out) :: sorbs(norb,norb), owrk(norb,norb), hessout(npr)
! VEC1 dimension is MAX(NPRORB,NDETVB)
real(kind=wp), intent(_OUT_) :: vec1(*)
integer(kind=iwp), intent(in) :: iorts(2,nort)
integer(kind=iwp) :: iorb, iort, jorb, ki, kj, korb, lj, lorb
real(kind=wp) :: corr1, fac1, fac2, g1f, g2f, hess_ci_nrm, hess_orb_nrm
logical(kind=iwp) :: orbopt2, strucopt2
real(kind=wp), allocatable :: cvb(:), cvbdet(:)
real(kind=wp), external :: ddot_, dnrm2_

hess_orb_nrm = dnrm2_(nprorb,hessinp,1)
orbopt2 = hess_orb_nrm > 1.0e-10_wp
if (nprvb > 0) then
  hess_ci_nrm = dnrm2_(nprvb,hessinp(nprorb+1),1)
else
  hess_ci_nrm = Zero
end if
strucopt2 = strucopt .and. (hess_ci_nrm > 1.0e-10_wp)
if (orbopt2 .and. (.not. strucopt2)) n_orbhess = n_orbhess+1
if (strucopt2 .and. (.not. orbopt2)) n_cihess = n_cihess+1

call trnsps(norb,norb,orbs,owrk)
call mxattb_cvb(orbs,orbs,norb,norb,norb,sorbs)

hessout(:) = Zero
if (orbopt2) call mxatb_cvb(hessorb,hessinp,nprorb,nprorb,1,hessout)

! Combinations of gradients:
g1f = ddot_(npr,grad1,1,hessinp,1)
g2f = ddot_(npr,grad2,1,hessinp,1)
fac1 = g1f*f4+g2f*f3
fac2 = g1f*f3
hessout(:) = hessout(:)+fac1*grad1(:)+fac2*grad2(:)

if (orbopt2 .and. strucopt) then
  call mxunfold_cvb(hessinp,owrk,norb)
  call dgetmi(owrk,norb,norb)
  call cizero_cvb(citmp)
  call oneexc_cvb(civbh,citmp,owrk,.true.,2)
  call mkgrd_cvb(civb,citmp,vec1,dvbdet,npr,.false.)
  hessout(nprorb+1:nprorb+nprvb) = hessout(nprorb+1:nprorb+nprvb)+f1*vec1(nprorb+1:nprorb+nprvb)
end if
if (strucopt2) then
  call str2vbc_cvb(hessinp(1+nprorb:),dvbdet)
  call vb2cif_cvb(dvbdet,citmp)
  call mkgrd_cvb(citmp,civbh,vec1,dvbdet,nprorb,.true.)
  hessout(1:nprorb) = hessout(1:nprorb)+f1*vec1(1:nprorb)
  call oneexc_cvb(civb,citmp,hessinp,.false.,1)
  ! 2nd-order term for structure coefficients
  if (nfrag > 1) then
    call str2vbc_cvb(hessinp(1+nprorb:),dvbdet)
    call mma_allocate(cvbdet,ndetvb,label='cvbdet')
    call mma_allocate(cvb,nvb,label='cvb')
    call ci2ordr_cvb(civbh,dvbdet,cvbdet)
    call vb2strg_cvb(cvbdet,cvb)
    hessout(nprorb+1:nprorb+nvb) = hessout(nprorb+1:nprorb+nvb)+f1*cvb(:)
    call mma_deallocate(cvbdet)
    call mma_deallocate(cvb)
  end if
else
  call cizero_cvb(citmp)
  call oneexc_cvb(civb,citmp,hessinp,.false.,1)
end if
call applythmes_cvb(citmp,orbs)
call mkgrd_cvb(civb,citmp,vec1,dvbdet,npr,.true.)
hessout(:) = hessout(:)+f1*vec1(1:npr)

if (orbopt2 .and. (nort > 0)) then
  ! Non-linear correction for orthogonality constraints:
  owrk(:,:) = sorbs(:,:)
  call mxinv_cvb(owrk,norb)
  do iort=1,nort
    iorb = iorts(1,iort)
    jorb = iorts(2,iort)
    corr1 = Zero
    do korb=1,norb
      ki = korb+(iorb-1)*(norb-1)
      if (korb > iorb) ki = ki-1
      kj = korb+(jorb-1)*(norb-1)
      if (korb > jorb) kj = kj-1
      if (korb /= iorb) corr1 = corr1+owrk(jorb,korb)*(f1*grad2(ki)+f2*grad1(ki))
      if (korb /= jorb) corr1 = corr1+owrk(iorb,korb)*(f1*grad2(kj)+f2*grad1(kj))
    end do
    corr1 = -Half*corr1
    do korb=1,norb
      if (korb == iorb) cycle
      ki = korb+(iorb-1)*(norb-1)
      if (korb > iorb) ki = ki-1
      do lorb=1,norb
        if (lorb == jorb) cycle
        lj = lorb+(jorb-1)*(norb-1)
        if (lorb > jorb) lj = lj-1
        hessout(ki) = hessout(ki)+sorbs(korb,lorb)*corr1*hessinp(lj)
        hessout(lj) = hessout(lj)+sorbs(korb,lorb)*corr1*hessinp(ki)
      end do
    end do
  end do
end if

return

end subroutine hess_evb1_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine calcmagn1(N,E,M,T,MT,Z)
!----------------------------------------------------------------------
!   Input data:
!     N =  number of the states to be considered, scalar integer, input
!     E =  Zeeman energy of these states, array(N), real, input
!     M =  momentum of these states ( diagonal), complex array (N,N), input
!          ( only diagonal elements are used )
!     T =  scalar real number denoting temperature in K, real, input
!   Output data:
!     MT=  computed momentum at temperature T, scalar real, output
!     Z =  Boltzmann statistical sum, real scalar
!----------------------------------------------------------------------
      Implicit None
      Integer, parameter          :: wp=kind(0.d0)
      Integer, intent(in)         :: N
      Real(kind=8),intent(in)    :: E(N), T
      Complex(kind=8),intent(in) :: M(N,N)

      Real(kind=8),intent(out)   :: Z, MT
!-- local variables:
      Integer                 :: im,mp1,i
      Real(kind=8)           :: kB
!----------------------------------------------------------------------
      kB=0.6950356000_wp !   in cm^-1*K-1
      Z =0.0_wp
      MT=0.0_wp
      im=0
      mp1=0
      im=MOD(N,11)

      If (im.ne.0) Then
        Do i = 1,im !N   ! im
          Z = Z + EXP( -(E(i)-E(1))/kB/T )
          MT=MT + EXP( -(E(i)-E(1))/kB/T ) * DBLE( M(I,I) )
        End Do
        If ( N < 11 ) Then
          MT=MT/Z
        Return
        End If
      End If

      mp1 = im + 1
      Do i = mp1, N, 11
        Z = Z + EXP( -(E(i   )-E(1))/kB/T )
     &        + EXP( -(E(i+ 1)-E(1))/kB/T )
     &        + EXP( -(E(i+ 2)-E(1))/kB/T )
     &        + EXP( -(E(i+ 3)-E(1))/kB/T )
     &        + EXP( -(E(i+ 4)-E(1))/kB/T )
     &        + EXP( -(E(i+ 5)-E(1))/kB/T )
     &        + EXP( -(E(i+ 6)-E(1))/kB/T )
     &        + EXP( -(E(i+ 7)-E(1))/kB/T )
     &        + EXP( -(E(i+ 8)-E(1))/kB/T )
     &        + EXP( -(E(i+ 9)-E(1))/kB/T )
     &        + EXP( -(E(i+10)-E(1))/kB/T )

        MT=MT + EXP( -(E(i   )-E(1))/kB/T ) * DBLE( M(i   ,i   ) )
     &        + EXP( -(E(i+ 1)-E(1))/kB/T ) * DBLE( M(i+ 1,i+ 1) )
     &        + EXP( -(E(i+ 2)-E(1))/kB/T ) * DBLE( M(i+ 2,i+ 2) )
     &        + EXP( -(E(i+ 3)-E(1))/kB/T ) * DBLE( M(i+ 3,i+ 3) )
     &        + EXP( -(E(i+ 4)-E(1))/kB/T ) * DBLE( M(i+ 4,i+ 4) )
     &        + EXP( -(E(i+ 5)-E(1))/kB/T ) * DBLE( M(i+ 5,i+ 5) )
     &        + EXP( -(E(i+ 6)-E(1))/kB/T ) * DBLE( M(i+ 6,i+ 6) )
     &        + EXP( -(E(i+ 7)-E(1))/kB/T ) * DBLE( M(i+ 7,i+ 7) )
     &        + EXP( -(E(i+ 8)-E(1))/kB/T ) * DBLE( M(i+ 8,i+ 8) )
     &        + EXP( -(E(i+ 9)-E(1))/kB/T ) * DBLE( M(i+ 9,i+ 9) )
     &        + EXP( -(E(i+10)-E(1))/kB/T ) * DBLE( M(i+10,i+10) )
      End Do

      MT=MT/Z

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
*  Cho_X_GetTol
*
*> @brief
*>   Set tolerance integer for use with ::Add_Info (for verification).
*> @author Thomas Bondo Pedersen
*> @modified_by Thomas Bondo Pedersen, October 2010: LDF support.
*>
*> @details
*> The tolerance in verification might depend on the
*> threshold of the Cholesky decomposition. The integer
*> used to specify tolerance in ::Add_Info is computed
*> here according to the formula:
*>
*> \f[ \text{iTol} = -\log(\text{Thr}) \f]
*>
*> where \p Thr is the threshold and \f$ \log \f$ is the logarithm
*> (base 10).
*>
*> If LDF (local DF) is used, \p Thr is the LDF target
*> accuracy.
*> If the integrals have not been Cholesky decomposed
*> (or represented with DF or LDF), this function simply
*> returns \p iTolDef.
*>
*> @param[in] iTolDef Default tolerance
*>
*> @return Tolerance integer for use with ::Add_Info
************************************************************************
      Integer Function Cho_X_GetTol(iTolDef)
      Implicit None
      Integer iTolDef
#include "cholesky.fh"
#include "choini.fh"

      Real*8   Get_LDFAccuracy
      External Get_LDFAccuracy

      Logical DidCholesky, DidLDF
      Real*8  ThrAbs, d
      Integer ChoIsIni

      Call DecideOnCholesky(DidCholesky)
      If (DidCholesky) Then
         Call DecideOnLocalDF(DidLDF)
         If (DidLDF) Then
            ThrAbs = Abs(Get_LDFAccuracy())
         Else
            Call Get_iScalar('ChoIni',ChoIsIni)
            If (ChoIsIni .ne. ChoIniCheck) Then ! not initialized
               Call Get_dScalar('Cholesky Threshold',ThrCom)
            End If
            ThrAbs = Abs(ThrCom)
         End If
         d = -log(ThrAbs)/log(1.0d1)
         Cho_X_GetTol = nint(d)
      Else
         Cho_X_GetTol = iTolDef
      End If

      End
      Real*8 Function Get_LDFAccuracy()
      Implicit None
#include "localdf.fh"
      Logical  LDF_X_IsSet
      External LDF_X_IsSet
      If (.not.LDF_X_IsSet()) Then
         Call Get_dScalar('LDF Accuracy',Thr_Accuracy)
      End If
      Get_LDFAccuracy=Thr_Accuracy
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

function MltLbl(Lbl1,Lbl2)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             February '91                                             *
!***********************************************************************

use Symmetry_Info, only: Mul, nIrrep
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: MltLbl
integer(kind=iwp), intent(in) :: Lbl1, Lbl2
integer(kind=iwp) :: iIrrep, ijSym, jIrrep

MltLbl = 0
do iIrrep=1,nIrrep
  if (.not. btest(Lbl1,iIrrep-1)) cycle
  do jIrrep=1,nIrrep
    if (.not. btest(Lbl2,jIrrep-1)) cycle
    ijSym = Mul(iIrrep,jIrrep)
    if (.not. btest(MltLbl,ijSym-1)) MltLbl = MltLbl+2**(ijSym-1)
  end do
end do

return

end function MltLbl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine par_range(n,i,j)
      ! Distribute 'n' evenly over processes and return
      ! the range (i,j) of this particular process.
      ! If there is no valid range, then j<i will be returned,
      ! so it is possible to use it consistently for looping.
#include "para_info.fh"
      nqot = n / nprocs
      nrem = n - nqot * nprocs
      if (myrank .lt. nrem) then
        i = myrank * (nqot + 1) + 1
        j = i + nqot
      else
        i = nrem * (nqot + 1) + (myrank - nrem) * nqot + 1
        j = i + nqot - 1
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function find_Lu(filename)
! find the unit number assigned to an opened file (not translated)
! returns -1 if not found

use Fast_IO, only: isOpen, LuName, MxFile
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: find_Lu
character(len=*), intent(in) :: filename
integer(kind=iwp) :: n

find_Lu = -1
do n=1,MxFile
  if (isOpen(n) == 0) cycle
  if (LuName(n) == filename) then
    find_Lu = n
    exit
  end if
end do

return

end function find_Lu

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function GTIJKL_MCLR(I,J,K,L)
! Obtain  integral (I J ! K L)
! where I,J,K and l refers to active orbitals in type ordering

use Index_Functions, only: iTri
use MCLR_Data, only: Int2, IREOTS
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: GTIJKL_MCLR
integer(kind=iwp), intent(in) :: I, J, K, L
integer(kind=iwp) :: i_Abs, ij, j_Abs, k_Abs, kl, l_Abs

I_ABS = IREOTS(I)

J_ABS = IREOTS(J)

K_ABS = IREOTS(K)

L_ABS = IREOTS(L)

IJ = iTri(I_ABS,J_ABS)
KL = iTri(K_ABS,L_ABS)

GTIJKL_MCLR = INT2(iTri(IJ,KL))

end function GTIJKL_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Bjorn O. Roos                                    *
*               1991, Roland Lindh                                     *
*               Valera Veryazov                                        *
************************************************************************
      Subroutine Rdbsl(BasDir,BSLbl,Type,nCGTO,mCGTO,lAng,lCGTO,lUnit,
     &                 iAtmNr,BasisTypes,ExtBasDir)
************************************************************************
* Object: Decode the basis set label and read the basis set            *
*         from the library                                             *
*                                                                      *
* Called from: GetBS                                                   *
* Subroutines called: Decode                                           *
*                                                                      *
* Author: Bjoern Roos, Theoretical Chemistry, Chemical Centre          *
*         University of Lund, Lund, Sweden                             *
*         February 1991                                                *
* Patched: Valera Veryazov                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Logical Quit_On_Error
      common /getlnQOE/ Quit_On_Error
      Dimension nCGTO(0:lCGTO),mCGTO(0:lCGTO)
      Character*80 BSLBl,BSLB*180,string,atom,type,author,basis,blank,
     &            CGTO,CGTOm,atomb, aux,
     &            Get_Ln_Quit*180
      Character *(*) BasDir, ExtBasDir
* In case anyone would wonder: basis set path fixed to 100 char max,
* (but no problem in increasing this later on) JR 2005
      Character*256 BasLoc
#include "angtp.fh"
      Character*1 kAng(0:iTabMx),Str16*16, FileName*256, TmpString*256
      Integer StrnLn
      External StrnLn
      Logical lStop, Hit, IfTest, Exist,is_error
      Integer irecl
      Integer iLast_JR,iLast1
      Integer BasisTypes(4)
      Data IfTest/.False./
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif
      If (iTabMx.lt.lCGTO) Then
         Call WarningMessage(2,'RdBsL: iTabMx.lt.lCGTO;'//
     &                         'Update the code!')
         Call Abend()
      Else
         Do i=0,iTabMx
           kAng(i)=Angtp(i)
           Call UpCase(kAng(i))
         End Do
      End If
      If (IfTest) Then
         Write (6,*) ' Enter Rdbsl'
         Write (6,'(2a)') ' BsLbl=',BsLbl
         Write (6,'(2a)') ' BasDir=',BasDir
         Write (6,'(2a)') ' ExtDir=',ExtBasDir
      End If
      Call ResetErrorLine
      Call UpCase(BSLBl)

      iLast1=StrnLn(BasDir)
      BasLoc=BasDir
      if(ExtBasDir.ne.' ') then
      Hit=.True.
      Call Decode(BSLBl(1:80),type,2,Hit)
      endif
      call find_basis_set(BasLoc,ExtBasDir,type)
      iLast_JR=StrnLn(BasLoc)
      If (Index(BasDir,'c_Basis').ne.0) Then
         BasLoc(iLast_JR+1:iLast_JR+8) = '/c_Basis'
         iLast_JR=iLast_JR+8
      Else If (Index(BasDir,'j_Basis').ne.0) Then
         BasLoc(iLast_JR+1:iLast_JR+8) = '/j_Basis'
         iLast_JR=iLast_JR+8
      Else If (Index(BasDir,'jk_Basis').ne.0) Then
         BasLoc(iLast_JR+1:iLast_JR+9) = '/jk_Basis'
         iLast_JR=iLast_JR+9
      End If
      Call BasisTbl(BSLBl,BasLoc(1:iLast_JR))
*
      Hit=.True.
      Call Decode(BSLBl(1:80),atom,1,Hit)
      If (IfTest) write(6,'(1x,a,a)') 'Atom=',atom
      iAtmNr=Lbl2Nr(atom)
*
      Hit=.True.
      Call Decode(BSLBl(1:80),type,2,Hit)
      If (IfTest) write(6,'(1x,a,a)') 'Type=',type
*
      Hit=.True.
      Call Decode(BSLBl(1:80),author,3,Hit)
      If (IfTest) write(6,'(1x,a,a)') 'Author=',author
*
      Hit=.True.
      Call Decode(BSLBl(1:80),basis,4,Hit)
      If (IfTest) write(6,'(1x,a,a)') 'Basis=',basis
*
      Hit=.True.
      Call Decode(BSLBl(1:80),CGTO,5,Hit)
      If (IfTest) write(6,'(1x,a,a)') 'CGTO=',CGTO
*
      Hit=.False.
      Call Decode(BSLBl(1:80),Aux,6,Hit)
      If (.Not.Hit) Aux = ' '
      If (IfTest) write(6,'(1x,a,a)') 'Aux=',Aux
*
      blank=' '
      If(CGTO.eq.blank .and.
     &   (type.eq.'ECP'.or.
     &    type.eq.'PSD'.or.
     &    type.eq.'ANO')) Then
         If (IfTest) Write (6,*) ' Early exit'
         Call WarningMessage(2,
     &     'Abend in RdBsl:No CGTO basis set provided in basis label')
         Call Quit_OnUserError()
      End If
*
*     We do not need more than 10 dots
*
      j=0
      Do i=1,10
         j=j+Index(BsLbl(j+1:80),'.')
         If (j.eq.0) Exit
      End Do
      If (j.gt.0) BsLbl=BsLbl(1:j)
*
*     Open basis library
*
      TmpString=Type
      Call Upcase(TmpString)
      Call LeftAd(BasDir)
      Call LeftAd(TmpString)
      iLast1=StrnLn(BasDir)
      iLast2=StrnLn(TmpString)
      If (IfTest) Then
         Write (6,'(I3,A)') iLast1, BasDir
         Write (6,'(I3,A)') iLast2, TmpString
      End If
      Filename=BasLoc(1:iLast_JR)//'/'//TmpString(1:iLast2)
      TmpString=Author
      Call Upcase(TmpString)
      iLast4=StrnLn(Filename)
      iLast2=StrnLn(TmpString)
      TmpString=Filename(1:iLast4)//'.'//TmpString(1:iLast2)
      Call f_Inquire(TmpString,Exist)
      If (Exist) Filename=TmpString
      iLast3=StrnLn(Filename)
      If (IfTest) Write (6,'(A,A)') 'Filename=',Filename
      Call f_Inquire(Filename,Exist)
      If (.not.Exist) then
c Try to find name in trans.tbl file
        Call TransTbl(Filename)
        Call f_Inquire(Filename,Exist)
        If (.not.Exist) then
         iLast3=StrnLn(Filename)
         Call WarningMessage(2,'Basis set file '//
     &         Filename(1:iLast3)// ' does not exist!;;'//
     &         '(1) For a valence basis set: check the'//
     &         ' spelling of the basis set label'//
     &         ' and that the basis set file is present in the'//
     &         ' basis set library directory.;;'//
     &         '(2) For an external auxiliary basis set: check that '//
     &         'the basis set file is present in the appropiate '//
     &         'basis set library subdirectory.')
         Call Quit_OnUserError()
        End If
      endif
c check basistype
      Call BasisType(Filename,0,BasisTypes)
      call molcas_open_ext2(lUnit,FileName,'sequential','formatted',
     & iostat,.false.,irecl,'unknown',is_error)
c      Open(Unit=lUnit,File=Filename,
c     &        Form='FORMATTED',IOSTAT=IOStat)
      If (IOStat.ne.0) Then
         iLast3=StrnLn(Filename)
         Call WarningMessage(2,
     &         ' Problems opening basis set file '//
     &         Filename(1:iLast3))
         Call Quit_OnUserError()
       End If
       ReWind (lUnit)
*
*     loop over the basis set library to find the correct label
*
      If (IfTest) Write (6,*) ' Locate basis set label in library'
   10 BSLB = Get_Ln_Quit(lUnit,0)
      If (Quit_On_Error) Then
         iLast3=StrnLn(BsLbl)
         Call WarningMessage(2,
     &          'The requested basis set label: '//
     &          BsLbl(:iLast3)//';'//
     &          'was not found in basis library: '//Filename)
         Call Abend()
      End If
      Call UpCase(BSLB)
      If (BSLB(1:1).ne.'/') Go To 10
      n=Index(BSLB,' ')
      Do i=n,80
        BSLB(i:i)='.'
      End Do
      Hit=.True.
      Call Decode(BSLB(2:80),atomb,1,Hit)
      If (atomb.ne.atom) Go To 10
*
      If (type.ne.blank) then
         Hit=.True.
         Call Decode(BSLB(2:80),string,2,Hit)
         If (string.ne.type) Go To 10
      Endif
*
      If (author.ne.blank) then
         Hit=.True.
         Call Decode(BSLB(2:80),string,3,Hit)
         If (string.ne.author) Go To 10
      Endif
*
      If (basis.ne.blank) then
         Hit=.True.
         Call Decode(BSLB(2:80),string,4,Hit)
         If (string.ne.basis) Go To 10
      Endif
*
*     If a contraction sequence has been specified it must be identical
*     to what is in the library file if the basis set type does not
*     not allow any other contraction sequence.
*
      If (CGTO.ne.blank .and.
     &    type(1:3).ne.'ANO'.and.type.ne.'ECP'.and.type.ne.'PSD'.and.
     &    type.ne.'RYDBERG' ) Then
         Hit=.True.
         Call Decode(BSLB(2:80),string,5,Hit)
         If (string.ne.CGTO) Go To 10
      End If
*
      If (Aux.ne.blank) Then
         Hit=.True.
         Call Decode(BSLB(2:80),string,6,Hit)
         If (string.ne.aux) Go To 10
      End If
*
      If (IfTest) Write (6,*) ' Process library label'
      Hit=.True.
      Call Decode(BSLB(2:80),CGTOm,5,Hit)
      If (CGTO.eq.blank) CGTO=CGTOm
*
*     Here when the basis set label has been identified on the file
*     Now decode the CGTO label
*
      lAng=-1
      i1=1
      Do 20 i=1,80
         If(CGTO(i:i).eq.blank) go to 21
         Do k=0,lCGTO
            If (CGTO(i:i).eq.kAng(k)) then
*              Read(CGTO(i1:i-1),*) nCGTO(k)
               Str16 = CGTO(i1:i-1)
               Read(Str16,'(F16.0)') cg
               nCGTO(k)=nint(cg)
               i1=i+1
               If (k.ne.lAng+1) Then
                  Call WarningMessage(2,
     &                     'RdBsl: Error in contraction label')
                  Write (6,*) 'Conflict for ',kAng(k),' shell'
                  Write (6,*) 'Erroneous label:',CGTO
                  Call Abend()
               End If
               lAng=max(lAng,k)
               Go To 20
            End If
         End Do
   20 Continue
   21 Continue
#ifdef _DEMO_
       If (lAng.gt.1) Then
          Call WarningMessage(2,
     &             'Demo version can handle only '//
     &             's and p basis functions')
          Call Quit_OnUserError()
       End If
#endif
*     Write (*,*) ' lAng=',lAng
*
*     Check for size of contracted basis set
*
      lAngm=0
      i1=1
      Do 30 i=1,80
       If(CGTOm(i:i).eq.blank) go to 31
       Do 25 k=0,lCGTO
        If(CGTOm(i:i).eq.kAng(k)) then
*        Read(CGTOm(i1:i-1),*) mCGTO(k)
         Str16 = CGTOm(i1:i-1)
         Read(Str16,'(F16.0)') cg
         mCGTO(k)=nint(cg)
         i1=i+1
         lAngM=Max(lAngM,k)
         go to 30
        Endif
   25  Continue
   30 Continue
   31 Continue
      If (IfTest) Then
         Write (6,'(2a)') 'Type=',type
         Write (6,*) 'nCGTO=',(nCGTO(k),k=0,lCGTO)
         Write (6,*) 'mCGTO=',(mCGTO(k),k=0,lCGTO)
      End If
*     Write (*,*) ' lAngm=',lAngm
      If (lAngM.lt.lAng) Then
         Call WarningMessage(2,
     &    'Abend in RdBsl:Too high angular momentum in basis set input')
         Call Quit_OnUserError()
      End If
      lStop = .False.
      If(type.eq.'ANO') then
*       Gen.cont.: never more contracted functions than available
        Do 40 i=0,lang
           If (IfTest) Write (6,*) 'i,nCGTO(i),mCGTO(i)=',
     &                             i,nCGTO(i),mCGTO(i)
         If(nCGTO(i).gt.mCGTO(i)) then
          Write(6,4000) kAng(i),nCGTO(i),mCGTO(i)
 4000     Format(/1x,'Too many CGTOs of ',a,'-type ',I3,' Max=',I3)
          lStop = .True.
         Endif
   40   Continue
      Else If(type.eq.'ECP') then
*       Segmented basis set: never more functions than primitives
*       (to be checked later (getbs.f)) and never less functions
*       than available
        Do 41 i=0,lang
           If (IfTest) Write (6,*) 'i,nCGTO(i),mCGTO(i)=',
     &                             i,nCGTO(i),mCGTO(i)
         If(nCGTO(i).lt.mCGTO(i)) then
          Write(6,4100) kAng(i),nCGTO(i),mCGTO(i)
 4100     Format(/1x,'Too few segmented CGTOs of ',a,'-type ',I3
     &           ,' Min=',I3)
          lStop = .True.
         Endif
   41   Continue
      Endif
      If (lStop) Then
         Call WarningMessage(2,
     &     'Abend in RdBsl:Requested basis inconsistent with library')
         Call Quit_OnUserError()
      End If
      Return
      End
c
      Function Lbl2Nr(Atom)
      Integer Lbl2Nr, StrnLn
      Character*80 Atom
      Character*2 TmpLbl(2)
#include "periodic_table.fh"
*
      If (StrnLn(Atom).gt.2.or.StrnLn(Atom).le.0) Then
         Call WarningMessage(2,'The atom label;'//
     &                '-->'//Atom(1:4)//'<--;'//
     &                ' is not a proper string to define an element.')
         Call Quit_OnUserError()
      End If
*
      Lbl2Nr=-1
*
      lAtom=0
      Do i = 1, 80
         If (atom(i:i).ne.' ') Then
            lAtom=lAtom+1
         Else
            Go To 99
         End If
      End Do
 99   Continue
      If (lAtom.gt.2) lAtom=2
      TmpLbl(1)='  '
      If (lAtom.eq.1) Then
         TmpLbl(1)(2:2)=atom(1:1)
      Else If (lAtom.eq.2) Then
         TmpLbl(1)=atom(1:2)
      Else
         Go To 98
      End If
      Call UpCase(TmpLbl(1))
      Do i = 0, Num_Elem
         TmpLbl(2)=PTab(i)
        Call UpCase(TmpLbl(2))
         If (TmpLbl(2).eq.TmpLbl(1)) Then
            Lbl2Nr=i
            Go To 98
         End If
      End Do
98    Continue
      If (Lbl2Nr.eq.-1) Then
         Call WarningMessage(2,'The atom label;'//
     &               '-->'//Atom(1:4)//'<--;'//
     &               ' does not define an element.')
         Call Quit_OnUserError()
      End If
      Return
      End
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mktauhelp1 (t2,t11,t12,dima,dimb,dimi,dimj,shifta,
     &                        shiftb,fact)
c
c     this routine do
c     t2(a,b,i,j) = t2(a,b,i,j) + fact [T11(a,i).T12(b,j)]
c
c     t2        - T2 matrix (I/O)
c     t11     - T1 amplitudes corresponding to spin ia (I)
c     t12     - T1 amplitudes corresponding to spin jb (I)
c     dima    - 1 dimension of T2 (I)
c     dimb    - 2 dimension of T2 (I)
c     dimi    - 3 domension of T2 (I)
c     dimj    - 4 domension of T2 (I)
c     shifta        - number off occ orbitals in spin and symmetry of a (I)
c     shiftb        - number off occ orbitals in spin and symmetry of b (I)
c     fact    - numerical factor (I)
c
c     N.B. symi must be syma and symj must be symb
c
c
       integer dima,dimb,dimi,dimj,shifta,shiftb
       real*8 fact
       real*8 t2(1:dima,1:dimb,1:dimi,1:dimj)
       real*8 t11(1:dima,1:dimi)
       real*8 t12(1:dimb,1:dimj)
c
c     help variables
c
       integer i,j,a,b
c
       do 100 j=1,dimj
       do 101 i=1,dimi
       do 102 b=1,dimb
       do 103 a=1,dima
       t2(a,b,i,j)=t2(a,b,i,j)+fact*(t11(a,i)*t12(b,j))
 103    continue
 102    continue
 101    continue
 100    continue
c
       return
c Avoid unused argument warnings
       if (.false.) then
         call Unused_integer(shifta)
         call Unused_integer(shiftb)
       end if
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine Precabb_2(ib,is,js,nd,no,rout,Temp1,ntemp,Scr,Temp2,fockti,focki,Sgn)
!***********************************************************************
!                                        [2]
!   Calculates the diagonal submatrix of E    that couple
!
!   kappa           with   kappa                for a
!        kactive,virtual        kactive,virtual
!
!   single active index.
!   Used for preconditioner.
!
!   See Olsen,Yeager, Joergensen:
!    "Optimization and characterization of an MCSCF state"
!
!   Called by prec
!
!   ib,is       :       active index for the submatrix
!   js          :       symmetry of virtual,virtual
!   rOut        :       Submatrix
!
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: G1t, G2t, nA, nB
use input_mclr, only: nAsh, nIsh, nOrb, nSym
use Constants, only: Zero, Two, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ib, is, js, nd, no, nTemp
real(kind=wp), intent(inout) :: rout(*)
real(kind=wp), intent(out) :: Temp1(no,no), Scr(nTemp), Temp2(nO,nO)
real(kind=wp), intent(in) :: Fockti, Focki(no,no), Sgn
integer(kind=iwp) :: ii, iib, ijkl, ip, jB, jVert, kBB, kCC, kkB, kkC, kS, lB
real(kind=wp) :: rDens1, rDens2, rf, Rho

!                                                                      *
!***********************************************************************
!                                                                      *
iib = ib+nA(is)
jVert = nOrb(js)-nAsh(js)-nIsh(js)
if (jvert == 0) return

rF = Sgn*Fockti
Temp2(:,:) = Zero

do kS=1,nSym
  if (nOrb(js)*nash(ks) > 0) then

    do kBB=nish(ks)+1,nB(kS)
      do kCC=nish(ks)+1,kBB
        call COUL(jS,jS,kS,kS,kbb,kcc,Temp1,Scr)

        if ((kBB > nish(ks)) .and. (kCC > nish(ks))) then
          kkB = kBB+nA(ks)-nish(ks)
          kkC = kCC+nA(ks)-Nish(ks)
          rDens1 = Sgn*Two*G2t(iTri(nTri_Elem(iib),iTri(kkb,kkc)))

          if (kbb /= kcc) rdens1 = rdens1*Two

          Temp2(:,:) = Temp2(:,:)+rdens1*Temp1(:,:)

        end if
      end do
    end do
  end if
end do

do Ks=1,nsym
  ijkl = nOrb(js)*nash(ks)
  if (ijkl /= 0) then

    do LB=nish(ks)+1,nB(KS)
      kkc = nA(ks)+lb-nish(ks)
      do JB=nish(ks)+1,nB(KS)
        kkb = nA(ks)+jb-nish(ks)
        call EXCH(js,ks,js,ks,jb,lb,Temp1,Scr)
        if ((LB > nISH(ks)) .and. (jb > nish(ks))) then
          rDens2 = Sgn*Four*G2t(iTri(iTri(iib,kkc),iTri(kkb,iib)))
          Temp2(:,:) = Temp2(:,:)+rDens2*Temp1(:,:)
        end if
      end do
    end do
  end if
end do

ip = nTri_Elem(nd)-nTri_Elem(jVert)+1
rho = Sgn*Two*G1t(nTri_Elem(iib))
do iI=nAsh(js)+nIsh(js)+1,nOrb(js)
  rOut(ip) = rout(ip)-Two*rF+Rho*FockI(iI,ii)+Temp2(ii,ii)
  rOut(ip+1:ip+nOrb(jS)-iI) = Rho*FockI(iI,iI+1:nOrb(jS))+Temp2(iI,iI+1:nOrb(jS))
  ip = ip+nOrb(jS)-iI+1
end do

end subroutine Precabb_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Min_Mult_Error(EC,A,B,Ci,Cj,rMP,xrMP,xxrMP,xnrMP,lMax,
     &                          nij,nElem,iAtom,jAtom,nAtoms,nPert,
     &                          C_o_C,Scratch_New,Scratch_Org,iPlot,
     &                          T_Values,iWarnings,Num_Warnings)
      Implicit Real*8 (A-H, O-Z)
#include "real.fh"
      Dimension EC(3,nij),C_o_C(3),A(3,nij),B(3,nij),Ci(3),Cj(3),R_ij(3)
      Dimension rMP(nij,0:nElem-1,0:nPert-1),xnrMP(nij,nElem)
      Dimension xrMP(nij,nElem),xxrMP(nij,nElem),T_Values(nij)
      Dimension Scratch_Org(nij*(2+lMax+1)),Scratch_New(nij*(2+lMax+1))
      Dimension iWarnings(nij)
      Parameter (Error_Threshold = 1.0D-12, Delta_Threshold = 1.0D-12)
      External Error_for_t,Golden
*
      iDim = nij*nElem
      ij = iAtom*(iAtom-1)/2+jAtom
      iPrint_Errors   = 0
      l = lMax - 1
      Do i = 1,3
         R_ij(i) = Cj(i) - Ci(i)
      End Do
*
      t_min       = Zero
      t_max       = Zero
      Do i = 1,3
         If (R_ij(i) .ne. 0.0D0) Then
            t_min       = (Ci(i)-EC(i,ij))/R_ij(i)
            t_max       = (Cj(i)-EC(i,ij))/R_ij(i)
         End If
      End Do
      Delta_Orig  = 0.1D0
      Delta       = Delta_Orig
*
* Check the range of possible t-values for minima
*
      num_min     = 0
      iSlope      = 0
      If (iPlot .eq. 1) Then
         Write(6,*)
         Write(6,*) 'iAtom, jAtom = ',iAtom,jAtom
      End If
      t_temp = t_min
      Error_Best = -1.0D0
      Error_Old  = Zero
      t_best = 0.0D0
  50  Continue
         Error = Error_for_t(t_temp,rMP,xrMP,xxrMP,xnrMP,EC,A,R_ij,
     &                       C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,
     &                       Scratch_New,Scratch_Org,iPrint_Errors)
         If (iPlot .eq. 1) Then
            Write(6,'(1X,A,F5.2,F16.12)') 't, Error = ',t_temp,Error
            Call xFlush(6)
         End If
         Delta_Error = Error - Error_Old
         Error_Old   = Error
         iSlope_Old  = iSlope
         If (Abs(Delta_Error) .lt. Error_Threshold) Then
            iSlope = 0
         Else If (Delta_Error .lt. Zero) Then
            iSlope = -1
         Else
            iSlope = 1
         End If
         If (iSlope_Old .lt. 0 .And. iSlope .ge. 0) Then
            num_min = num_min + 1
         End If
         If (Error .lt. Error_Best .OR. Error_Best .lt. Zero) Then
            Error_Best = Error
            t_best     = t_temp
         End If
         t_temp = t_temp + Delta/10.0D0
      If (t_temp .le. t_max+Delta/100.0D0) Goto 50
*
* Any warnings from scan?
*
      If (num_min .gt. 1) Then
         iWarnings(ij) = 1
         Num_Warnings  = Num_Warnings + 1
      End If
*
* Find minima with Golden Section Search
*
* (It's assumed that the error function is either constant or has at
* least one minima somewhere, although not necessarily within the
* allowed range).
*
      ax = t_best
      bx = t_best + Delta
* First make an initial bracketing of the minima
      Call mnBrak(ax,bx,cx,fa,fb,fc,Error_for_t,rMP,xrMP,xxrMP,
     &           xnrMP,EC,A,R_ij,C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,
     &           Scratch_New,Scratch_Org,iPrint_Errors)
*
      If (abs(fa-fc) .lt. Error_Threshold) Then
         iWarnings(ij) = 4
         Num_Warnings = Num_Warnings + 1
         t_final = Zero
      Else
         Error = Golden(ax,bx,cx,Error_for_t,Delta_Threshold,
     &           Error_Threshold,t_final,rMP,xrMP,xxrMP,
     &           xnrMP,EC,A,R_ij,C_o_C,ij,l,nij,lMax,nElem,nAtoms,nPert,
     &           Scratch_New,Scratch_Org,iPrint_Errors)
      End If
*
* Check that the minima is within the allowed range
*
      If (t_final .gt. t_max) Then
         t_final = t_max
         iWarnings(ij) = 2
         Num_Warnings  = Num_Warnings + 1
      Else If (t_final .lt. t_min) Then
         t_final = t_min
         iWarnings(ij) = 2
         Num_Warnings  = Num_Warnings + 1
      End If
*
      T_values(ij) = t_final
      B(1,ij) = EC(1,ij) + t_final*R_ij(1)
      B(2,ij) = EC(2,ij) + t_final*R_ij(2)
      B(3,ij) = EC(3,ij) + t_final*R_ij(3)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetChVHlp4(H,T1,dima,adda)
! this routine does:
! Extract H(i,a') <- T1(a,i) for given aGrp
!
! parameter description:
! H       - Output file (O)
! T1      - T1 amplitudes (I)
! dima    - dimension of given Group (I)
! adda    - shift of a' in full a set (I)
!
! N.B. Kvajt odflaknute, je to ExtT1 len transponovane

use chcc_global, only: no, nv
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, adda
real(kind=wp), intent(out) :: H(no,dima)
real(kind=wp), intent(in) :: T1(nv,no)
integer(kind=iwp) :: a

do a=1,dima
  H(:,a) = T1(adda+a,:)
end do

return

end subroutine GetChVHlp4

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!**********************************************************************

subroutine caxpy(n,ca,cx,incx,cy,incy)
  use link_blas
  implicit none
  complex :: ca
  integer :: incx,incy,n
  complex :: cx(*),cy(*)
  call lb_caxpy(n,ca,cx,incx,cy,incy)
end subroutine caxpy

subroutine cgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
  use link_blas
  implicit none
  complex :: alpha,beta
  integer :: k,lda,ldb,ldc,m,n
  character :: transa,transb
  complex :: a(lda,*),b(ldb,*),c(ldc,*)
  call lb_cgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine cgemm

function dasum(n,dx,incx)
  use link_blas
  implicit none
  integer :: incx,n
  real*8 :: dx(*)
  real*8 :: dasum
  dasum=lb_dasum(n,dx,incx)
end function dasum

subroutine daxpy(n,da,dx,incx,dy,incy)
  use link_blas
  implicit none
  real*8 :: da
  integer :: incx,incy,n
  real*8 :: dx(*),dy(*)
  call lb_daxpy(n,da,dx,incx,dy,incy)
end subroutine daxpy

function dcabs1(z)
  use link_blas
  implicit none
  complex*16 :: z
  real*8 :: dcabs1
  dcabs1=lb_dcabs1(z)
end function dcabs1

subroutine dcopy(n,dx,incx,dy,incy)
  use link_blas
  implicit none
  integer :: incx,incy,n
  real*8 :: dx(*),dy(*)
  call lb_dcopy(n,dx,incx,dy,incy)
end subroutine dcopy

function ddot(n,x,dx,y,dy)
  use link_blas
  implicit none
  integer :: n,dx,dy
  real*8 :: x(*),y(*)
  real*8 :: ddot
  ddot=lb_ddot(n,x,dx,y,dy)
end function ddot

subroutine dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
  use link_blas
  implicit none
  real*8 :: alpha,beta
  integer :: k,lda,ldb,ldc,m,n
  character :: transa,transb
  real*8 :: a(lda,*),b(ldb,*),c(ldc,*)
  call lb_dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine dgemm

subroutine dgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
  use link_blas
  implicit none
  real*8 :: alpha,beta
  integer :: incx,incy,lda,m,n
  character :: trans
  real*8 :: a(lda,*),x(*),y(*)
  call lb_dgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
end subroutine dgemv

subroutine dger(m,n,alpha,x,incx,y,incy,a,lda)
  use link_blas
  implicit none
  real*8 :: alpha
  integer :: incx,incy,lda,m,n
  real*8 :: a(lda,*),x(*),y(*)
  call lb_dger(m,n,alpha,x,incx,y,incy,a,lda)
end subroutine dger

function dnrm2(n,x,incx)
  use link_blas
  implicit none
  integer :: incx,n
  real*8 :: x(*)
  real*8 :: dnrm2
  dnrm2=lb_dnrm2(n,x,incx)
end function dnrm2

subroutine drot(n,dx,incx,dy,incy,c,s)
  use link_blas
  implicit none
  real*8 :: c,s
  integer :: incx,incy,n
  real*8 :: dx(*),dy(*)
  call lb_drot(n,dx,incx,dy,incy,c,s)
end subroutine drot

subroutine dscal(n,da,dx,incx)
  use link_blas
  implicit none
  real*8 :: da
  integer :: incx,n
  real*8 :: dx(*)
  call lb_dscal(n,da,dx,incx)
end subroutine dscal

subroutine dspmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
  use link_blas
  implicit none
  real*8 :: alpha,beta
  integer :: incx,incy,n
  character :: uplo
  real*8 :: ap(*),x(*),y(*)
  call lb_dspmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
end subroutine dspmv

subroutine dspr(uplo,n,alpha,x,incx,ap)
  use link_blas
  implicit none
  real*8 :: alpha
  integer :: incx,n
  character :: uplo
  real*8 :: ap(*),x(*)
  call lb_dspr(uplo,n,alpha,x,incx,ap)
end subroutine dspr

subroutine dspr2(uplo,n,alpha,x,incx,y,incy,ap)
  use link_blas
  implicit none
  real*8 :: alpha
  integer :: incx,incy,n
  character :: uplo
  real*8 :: ap(*),x(*),y(*)
  call lb_dspr2(uplo,n,alpha,x,incx,y,incy,ap)
end subroutine dspr2

subroutine dswap(n,dx,incx,dy,incy)
  use link_blas
  implicit none
  integer :: incx,incy,n
  real*8 :: dx(*),dy(*)
  call lb_dswap(n,dx,incx,dy,incy)
end subroutine dswap

subroutine dsymm(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
  use link_blas
  implicit none
  real*8 :: alpha,beta
  integer :: lda,ldb,ldc,m,n
  character :: side,uplo
  real*8 :: a(lda,*),b(ldb,*),c(ldc,*)
  call lb_dsymm(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine dsymm

subroutine dsymv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
  use link_blas
  implicit none
  real*8 :: alpha,beta
  integer :: incx,incy,lda,n
  character :: uplo
  real*8 :: a(lda,*),x(*),y(*)
  call lb_dsymv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
end subroutine dsymv

subroutine dsyr2(uplo,n,alpha,x,incx,y,incy,a,lda)
  use link_blas
  implicit none
  real*8 :: alpha
  integer :: incx,incy,lda,n
  character :: uplo
  real*8 :: a(lda,*),x(*),y(*)
  call lb_dsyr2(uplo,n,alpha,x,incx,y,incy,a,lda)
end subroutine dsyr2

subroutine dsyr2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
  use link_blas
  implicit none
  real*8 :: alpha,beta
  integer :: k,lda,ldb,ldc,n
  character :: trans,uplo
  real*8 :: a(lda,*),b(ldb,*),c(ldc,*)
  call lb_dsyr2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine dsyr2k

subroutine dsyrk(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
  use link_blas
  implicit none
  real*8 :: alpha,beta
  integer :: k,lda,ldc,n
  character :: trans,uplo
  real*8 :: a(lda,*),c(ldc,*)
  call lb_dsyrk(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
end subroutine dsyrk

subroutine dtpmv(uplo,trans,diag,n,ap,x,incx)
  use link_blas
  implicit none
  integer :: incx,n
  character :: diag,trans,uplo
  real*8 :: ap(*),x(*)
  call lb_dtpmv(uplo,trans,diag,n,ap,x,incx)
end subroutine dtpmv

subroutine dtpsv(uplo,trans,diag,n,ap,x,incx)
  use link_blas
  implicit none
  integer :: incx,n
  character :: diag,trans,uplo
  real*8 :: ap(*),x(*)
  call lb_dtpsv(uplo,trans,diag,n,ap,x,incx)
end subroutine dtpsv

subroutine dtrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
  use link_blas
  implicit none
  real*8 :: alpha
  integer :: lda,ldb,m,n
  character :: diag,side,transa,uplo
  real*8 :: a(lda,*),b(ldb,*)
  call lb_dtrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
end subroutine dtrmm

subroutine dtrmv(uplo,trans,diag,n,a,lda,x,incx)
  use link_blas
  implicit none
  integer :: incx,lda,n
  character :: diag,trans,uplo
  real*8 :: a(lda,*),x(*)
  call lb_dtrmv(uplo,trans,diag,n,a,lda,x,incx)
end subroutine dtrmv

subroutine dtrsm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
  use link_blas
  implicit none
  real*8 :: alpha
  integer :: lda,ldb,m,n
  character :: diag,side,transa,uplo
  real*8 :: a(lda,*),b(ldb,*)
  call lb_dtrsm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
end subroutine dtrsm

subroutine dtrsv(uplo,trans,diag,n,a,lda,x,incx)
  use link_blas
  implicit none
  integer :: incx,lda,n
  character :: diag,trans,uplo
  real*8 :: a(lda,*),x(*)
  call lb_dtrsv(uplo,trans,diag,n,a,lda,x,incx)
end subroutine dtrsv

function dznrm2(n,x,incx)
  use link_blas
  implicit none
  integer :: incx,n
  complex*16 :: x(*)
  real*8 :: dznrm2
  dznrm2=lb_dznrm2(n,x,incx)
end function dznrm2

function idamax(n,dx,incx)
  use link_blas
  implicit none
  integer :: incx,n
  real*8 :: dx(*)
  integer :: idamax
  idamax=lb_idamax(n,dx,incx)
end function idamax

function lsame(ca,cb)
  use link_blas
  implicit none
  character :: ca,cb
  logical :: lsame
  lsame=lb_lsame(ca,cb)
end function lsame

subroutine saxpy(n,sa,sx,incx,sy,incy)
  use link_blas
  implicit none
  real :: sa
  integer :: incx,incy,n
  real :: sx(*),sy(*)
  call lb_saxpy(n,sa,sx,incx,sy,incy)
end subroutine saxpy

function scabs1(z)
  use link_blas
  implicit none
  complex :: z
  real :: scabs1
  scabs1=lb_scabs1(z)
end function scabs1

subroutine scopy(n,sx,incx,sy,incy)
  use link_blas
  implicit none
  integer :: incx,incy,n
  real :: sx(*),sy(*)
  call lb_scopy(n,sx,incx,sy,incy)
end subroutine scopy

subroutine sgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
  use link_blas
  implicit none
  real :: alpha,beta
  integer :: k,lda,ldb,ldc,m,n
  character :: transa,transb
  real :: a(lda,*),b(ldb,*),c(ldc,*)
  call lb_sgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine sgemm

subroutine xerbla(srname,info)
  use link_blas
  implicit none
  character(len=*) :: srname
  integer :: info
  call lb_xerbla(srname,info)
end subroutine xerbla

subroutine zaxpy(n,za,zx,incx,zy,incy)
  use link_blas
  implicit none
  complex*16 :: za
  integer :: incx,incy,n
  complex*16 :: zx(*),zy(*)
  call lb_zaxpy(n,za,zx,incx,zy,incy)
end subroutine zaxpy

subroutine zcopy(n,zx,incx,zy,incy)
  use link_blas
  implicit none
  integer :: incx,incy,n
  complex*16 :: zx(*),zy(*)
  call lb_zcopy(n,zx,incx,zy,incy)
end subroutine zcopy

function zdotc(n,zx,incx,zy,incy)
  use link_blas
  implicit none
  integer :: incx,incy,n
  complex*16 :: zx(*),zy(*)
  complex*16 :: zdotc
  zdotc=lb_zdotc(n,zx,incx,zy,incy)
end function zdotc

subroutine zdscal(n,da,zx,incx)
  use link_blas
  implicit none
  real*8 :: da
  integer :: incx,n
  complex*16 :: zx(*)
  call lb_zdscal(n,da,zx,incx)
end subroutine zdscal

subroutine zgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
  use link_blas
  implicit none
  complex*16 :: alpha,beta
  integer :: k,lda,ldb,ldc,m,n
  character :: transa,transb
  complex*16 :: a(lda,*),b(ldb,*),c(ldc,*)
  call lb_zgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine zgemm

subroutine zgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
  use link_blas
  implicit none
  complex*16 :: alpha,beta
  integer :: incx,incy,lda,m,n
  character :: trans
  complex*16 :: a(lda,*),x(*),y(*)
  call lb_zgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
end subroutine zgemv

subroutine zgerc(m,n,alpha,x,incx,y,incy,a,lda)
  use link_blas
  implicit none
  complex*16 :: alpha
  integer :: incx,incy,lda,m,n
  complex*16 :: a(lda,*),x(*),y(*)
  call lb_zgerc(m,n,alpha,x,incx,y,incy,a,lda)
end subroutine zgerc

subroutine zhemv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
  use link_blas
  implicit none
  complex*16 :: alpha,beta
  integer :: incx,incy,lda,n
  character :: uplo
  complex*16 :: a(lda,*),x(*),y(*)
  call lb_zhemv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
end subroutine zhemv

subroutine zher2(uplo,n,alpha,x,incx,y,incy,a,lda)
  use link_blas
  implicit none
  complex*16 :: alpha
  integer :: incx,incy,lda,n
  character :: uplo
  complex*16 :: a(lda,*),x(*),y(*)
  call lb_zher2(uplo,n,alpha,x,incx,y,incy,a,lda)
end subroutine zher2

subroutine zher2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
  use link_blas
  implicit none
  complex*16 :: alpha
  real*8 :: beta
  integer :: k,lda,ldb,ldc,n
  character :: trans,uplo
  complex*16 :: a(lda,*),b(ldb,*),c(ldc,*)
  call lb_zher2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine zher2k

subroutine zhpmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
  use link_blas
  implicit none
  complex*16 :: alpha,beta
  integer :: incx,incy,n
  character :: uplo
  complex*16 :: ap(*),x(*),y(*)
  call lb_zhpmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
end subroutine zhpmv

subroutine zhpr2(uplo,n,alpha,x,incx,y,incy,ap)
  use link_blas
  implicit none
  complex*16 :: alpha
  integer :: incx,incy,n
  character :: uplo
  complex*16 :: ap(*),x(*),y(*)
  call lb_zhpr2(uplo,n,alpha,x,incx,y,incy,ap)
end subroutine zhpr2

subroutine zscal(n,za,zx,incx)
  use link_blas
  implicit none
  complex*16 :: za
  integer :: incx,n
  complex*16 :: zx(*)
  call lb_zscal(n,za,zx,incx)
end subroutine zscal

subroutine zswap(n,zx,incx,zy,incy)
  use link_blas
  implicit none
  integer :: incx,incy,n
  complex*16 :: zx(*),zy(*)
  call lb_zswap(n,zx,incx,zy,incy)
end subroutine zswap

subroutine ztrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
  use link_blas
  implicit none
  complex*16 :: alpha
  integer :: lda,ldb,m,n
  character :: diag,side,transa,uplo
  complex*16 :: a(lda,*),b(ldb,*)
  call lb_ztrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
end subroutine ztrmm

subroutine ztrmv(uplo,trans,diag,n,a,lda,x,incx)
  use link_blas
  implicit none
  integer :: incx,lda,n
  character :: diag,trans,uplo
  complex*16 :: a(lda,*),x(*)
  call lb_ztrmv(uplo,trans,diag,n,a,lda,x,incx)
end subroutine ztrmv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1997, Roland Lindh                                *
************************************************************************
      SubRoutine Cllct2(Strng,Vector,dVector,Value,nAtom,
     &                  nCntr,mCntr,xyz,Grad,Ind,Type,qMss,Lbl,
     &                  lWrite,Deg,Hess,lIter)
************************************************************************
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             May '91                                                  *
*                                                                      *
*             Modified to be used in optimizations with constraints,   *
*             June '97 (R. Lindh)                                      *
************************************************************************
      use Symmetry_Info, only: nIrrep, iOper
      use Slapaf_Info, only: Cx, dMass, AtomLbl
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "Molcas.fh"
      Character(LEN=*) Strng
      Character(LEN=LENIN5)Label
      Character(LEN=LENIN) Name
      Character(LEN=8) Lbl
      Character Oper*3, Type*6
      Real*8 Vector(3,nAtom), xyz(3,nCntr+mCntr),
     &       Grad(3,nCntr+mCntr), dVector(3,nAtom,3,nAtom),
     &       Axis(3),
     &       Perp_Axis(3,2), qMss(nCntr+mCntr),
     &       Hess(3,nCntr+mCntr,3,nCntr+mCntr)
      Integer   Ind(nCntr+mCntr,2), iDCR(MxAtom)
      Logical lWrite, ldB, lWarn
      Real*8, Allocatable:: Not_Allocated(:,:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      Subroutine SphInt(xyz,nCent,OfRef,RR0,Bf,l_Write,Label,dBf,ldB)
      Integer nCent
      Real*8  xyz(3,nCent)
      Real*8, Allocatable, Target:: OfRef(:,:)
      Real*8  RR0
      Real*8  Bf(3,nCent)
      Logical l_Write
      Character(LEN=8) Label
      Real*8  dBf(3,nCent,3,nCent)
      Logical ldB
      End Subroutine SphInt
      End Interface
*                                                                      *
************************************************************************
*                                                                      *

*
      iRout = 50
      iPrint = nPrint(iRout)
      ldB=.True.
      lWarn  = lWrite
      If (iPrint.gt.20) lWrite = .True.
#ifdef _DEBUGPRINT_
      Call RecPrt(' In Cllct2: Coor',' ',Cx(:,:,lIter),3,nAtom)
      Call RecPrt('dMass',' ',dMass,1,nAtom)
#endif
*
      iFrst = 1
      iEnd  = 1
      lStrng=LEN(Strng)
*
*     Pick up cartesian coordinates associated with the
*     internal coordinate
*
      nCent=nCntr+mCntr
      Do ixyz = 1, nCent
         Call NxtWrd(Strng,iFrst,iEnd)
         If (iEnd.ge.iFrst) Then
            Label = Strng(iFrst:iEnd)
            nPar1 = Index(Label,'(')
            nPar2 = Index(Label,')')
         Else
            Label = ' '
            nPar1 = 0
            nPar2 = 0
         End If
         iPhase = 0
         If (nPar1.ne.0 .and. nPar2.ne.0) Then
            Name = '    '
            Name = Label(1:nPar1-1)
            Oper = Label(nPar1+1:nPar2-1)
            Call UpCase(Oper)
            If (Index(Oper,'X').ne.0) iPhase=iEor(iPhase,1)
            If (Index(Oper,'Y').ne.0) iPhase=iEor(iPhase,2)
            If (Index(Oper,'Z').ne.0) iPhase=iEor(iPhase,4)

*
*---------- Check if operator belongs to the current point group
*
            i = 0
            Do j = 1, nIrrep-1
               If (iPhase.eq.iOper(j)) i = j
            End Do
            iDCR(ixyz)=iOper(i)
            If (i.eq.0) Then
               Call WarningMessage(2,' Undefined symmetry operator')
               Write (6,'(A)') Oper
               Call Quit_OnUserError()
            End If
            iFrst = iEnd + 1
         Else If (nPar1.eq.0 .and. nPar2.eq.0) Then
            Name = '    '
            Oper = ' '
            If (iEnd.ge.iFrst) Then
               Name = Strng(iFrst:iEnd)
               If (iEnd.ge.1.and.iEnd.lt.lStrng) iFrst = iEnd + 1
            End If
            iDCR(ixyz)=iOper(0)
         Else
            Call WarningMessage(2,' Syntax error in:'//Label)
            Call Quit_OnUserError()
         End If
*
*------- Find corresponding coordinate
*
         If (Type(1:5).ne.'EDIFF'   .and.
     &       Type(1:3).ne.'NAC'     .and.
     &       Type(1:6).ne.'SPHERE'  .and.
     &       Type(1:6).ne.'TRANSV'        ) Then
            jsAtom = 0
            Do isAtom = 1, nAtom
               If (Name.eq.AtomLbl(isAtom)) jsAtom = isAtom
            End Do
            If (jsAtom.eq.0) Then
               Call WarningMessage(2,
     &                 ' Unrecognizable atom label '//Name)
               Call Quit_OnUserError()
            End If
         Else
            jsAtom=ixyz
         End If
*
*--------Store away the unique center index and the operator
*
         Ind(ixyz,1) = jsAtom
         Ind(ixyz,2) = iPhase
         call dcopy_(3,Cx(:,jsAtom,lIter),1,xyz(1,ixyz),1)
*--------Generate actual coordinate
         If (iAnd(iPhase,1).ne.0) xyz(1,ixyz) = - xyz(1,ixyz)
         If (iAnd(iPhase,2).ne.0) xyz(2,ixyz) = - xyz(2,ixyz)
         If (iAnd(iPhase,4).ne.0) xyz(3,ixyz) = - xyz(3,ixyz)
         If (Type.eq.'DISSOC') qMss(ixyz) = dMass(jsAtom)
*
      End Do  ! Do ixyz = 1, nCntr+mCntr
*
      If (iPrint.ge.99) Then
         Call RecPrt(' Coordinates',' ',
     &                              xyz,3,nCntr+mCntr)
         Call RecPrt('qMss',' ',qMss,1,nCntr+mCntr)
       End If
*                                                                      *
************************************************************************
*                                                                      *
*
*---- Process the internal coordinate
*
      If (Type.eq.'X     ') Then
         Value = xyz(1,1)
         call dcopy_(3,[Zero],0,Grad,1)
         call dcopy_(9,[Zero],0,Hess,1)
         Grad(1,1) = One
         If (lWrite) Write (6,'(1X,A,A,2X,F10.4,A)') Lbl,
     &          ' : x-component=',Value,'/ bohr'
         Deg=D_Cart(Ind(1,1),nIrrep)
      Else If (Type.eq.'Y     ') Then
         Value = xyz(2,1)
         call dcopy_(3,[Zero],0,Grad,1)
         call dcopy_(9,[Zero],0,Hess,1)
         Grad(2,1) = One
         If (lWrite) Write (6,'(1X,A,A,2X,F10.4,A)') Lbl,
     &          ' : y-component=',Value,'/ bohr'
         Deg=D_Cart(Ind(1,1),nIrrep)
      Else If (Type.eq.'Z     ') Then
         Value = xyz(3,1)
         call dcopy_(3,[Zero],0,Grad,1)
         call dcopy_(9,[Zero],0,Hess,1)
         Grad(3,1) = One
         If (lWrite) Write (6,'(1X,A,A,2X,F10.4,A)') Lbl,
     &          ' : z-component=',Value,'/ bohr'
         Deg=D_Cart(Ind(1,1),nIrrep)
      Else If (Type.eq.'STRTCH') Then
         Call Strtch(xyz,nCntr,Value,Grad,lWrite,Lbl,Hess,ldB)
         Deg=D_Bond(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'LBEND1')Then
         Call CoSys(xyz,Axis,Perp_Axis)
         Call LBend(xyz,nCntr,Value,Grad,lWrite,Lbl,Hess,ldB,
     &              Axis,Perp_Axis(1,1),.False.)
         Deg=D_Bend(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'LBEND2')Then
         Call CoSys(xyz,Axis,Perp_Axis)
         Call LBend(xyz,nCntr,Value,Grad,lWrite,Lbl,Hess,ldB,
     &              Axis,Perp_Axis(1,2),.True.)
         Deg=D_Bend(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'BEND  ')Then
         Call Bend(xyz,nCntr,Value,Grad,lWrite,lWarn,Lbl,Hess,ldB)
         Deg=D_Bend(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'TRSN  ')Then
         Call Trsn(xyz,nCntr,Value,Grad,lWrite,lWarn,Lbl,Hess,ldB)
         Deg=D_Trsn(Ind,Ind(1,2),nIrrep)
      Else If (Type.eq.'OUTOFP')Then
         Call OutOfP(xyz,nCntr,Value,Grad,lWrite,lWarn,Lbl,Hess,ldB)
         Deg=D_Trsn(Ind,Ind(1,2),nIrrep)
      Else If (Type(1:3).eq.'NAC')Then
         Call NACInt(xyz,nCntr,Value,Grad,lWrite,Lbl,Hess,ldB)
         Deg=One
      Else If (Type(1:5).eq.'EDIFF')Then
         Call ConInt(xyz,nCntr,Value,Grad,lWrite,Lbl,Hess,ldB,lIter)
         Deg=One
      Else If (Type(1:6).eq.'SPHERE')Then
         Call SphInt(xyz,nCntr,Not_Allocated,Value,Grad,lWrite,Lbl,Hess,
     &               ldB)
         Deg=One
      Else If (Type(1:6).eq.'TRANSV')Then
         Call Transverse(xyz,nCntr,Value,Grad,lWrite,Lbl,Hess,ldB)
         Deg=One
      Else If (Type.eq.'DISSOC')Then
         Call Dissoc(xyz,nCntr,mCntr,qMss,Value,Grad,lWrite,
     &               Lbl,Hess,ldB)
         Deg=One
      Else
         Call WarningMessage(2,
     &                     ' Type declaration is not supported:'//Type)
         Call Quit_OnUserError()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Deg=Sqrt(Deg)
*
      Call ProjSym2(nAtom,nCent,Ind,xyz,iDCR,Grad,Vector,Hess,dVector)
      If (iPrint.ge.99) Then
         Call RecPrt(' symmetry adapted vector',
     &                              ' ',Vector,3,nAtom)
         Call RecPrt(' symmetry adapted dvector',
     &                              ' ',dVector,3*nAtom,3*nAtom)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ElRed(Bmtrx,nq,nx,Gmtrx,EVal,EVec,nK,uMtrx,Scrt,g12K,
     &                 Thr)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 Bmtrx(nq,nx), Gmtrx(nq,nq), EVec(nq,nq),
     &       EVal(nq*(nq+1)/2), uMtrx(nX), Scrt(nq,nX)
      Logical g12K, Diagonal
      Real*8, Parameter:: Zero_Approx=0.1D-9
      Real*8, Allocatable:: Work(:), W(:)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*
      Do i = 1, nq
         Do j = 1, nx
            If (Abs(Bmtrx(i,j)).lt.1.0D-10) Bmtrx(i,j)=Zero
         End Do
      End Do
*
#ifdef _DEBUGPRINT_
      Call RecPrt('ElRed: The B matrix','(5e21.12)',Bmtrx,nq,nx)
      Call RecPrt('ElRed: The u matrix','(5e21.12)',umtrx,nx,1)
#endif
      If (nq.eq.0) Then
         nK=0
         Go To 99
      End If
*                             T
*---- Form the G matrix, G=BuB
*
      Do j = 1, nX
         Do i = 1, nq
            Scrt(i,j) = BMtrx(i,j) * umtrx(j)
         End Do
      End Do
      Call DGEMM_('N','T',
     &            nq,nq,nX,
     &            1.0d0,Scrt,nq,
     &            Bmtrx,nq,
     &            0.0d0,Gmtrx,nq)
*
      Diagonal = .True.
      Do i = 1, nq
         Sum = 0.0D0
         Do j = 1, nq
            If (Abs(Gmtrx(i,j)).lt.1.0D-10) Gmtrx(i,j)=Zero
            If (j.ne.i) Sum = Sum + GMtrx(i,j)
         End Do
         Diagonal = Diagonal .and. Sum.eq.0.0D0
      End Do
*
#ifdef _DEBUGPRINT_
      Call RecPrt('ElRed: The G Matrix (nq x nq)',
     &            '(5e21.12)',Gmtrx,nq,nq)
      Write (6,*) 'Diagonal=',Diagonal
#endif
*
*---- Set up a unit matrix
*
      call dcopy_(nq*nq,[Zero],0,EVec,1)
      call dcopy_(nq,[One],0,EVec,nq+1)
*
*---- Set up the Hessian in lower triangular form, the elements
*     are symmetrized.
*
      Do i = 1, nQ
         Do j = 1, i
            ijTri = i*(i-1)/2 + j
            EVal(ijTri) = Half*(Gmtrx(i,j)+Gmtrx(j,i))
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call TriPrt('Eval prediagonalization',' ',EVal,nQ)
#endif
*
*                                                        |g 0|
*---- Compute eigenvalues and eigenvectors G(K L) = (K L)|0 0|
*     K: nonredundant vectors with eigenvalues g
*     L: redundant vectors
*
      If (.NOT.Diagonal) Then
         N=nQ
         LDZ=Max(1,N)
         Call mma_allocate(Work,3*N,Label='Work')
         Work(:)=Zero
         Call mma_allocate(W,N,Label='W')
         W(:)=Zero
         Info=0
        call dspev_('V','U',N,Eval,W,EVec,LDZ,Work,Info)
         If (Info.ne.0) Then
            Write (6,*) 'Info.ne.0'
            Write (6,*) 'Info=',Info
            Call Abend()
         End If
         Call FZero(EVal,N*(N+1)/2)
         Do i = 1, N
            ii = i*(i+1)/2
            EVal(ii)=W(i)
         End Do
         Call mma_deallocate(W)
         Call mma_deallocate(Work)
      End If
      Call DScal_(nQ*(nQ+1)/2,-1.0D0,EVal,1)
      Call JacOrd(EVal,EVec,nQ,nQ)
*     Fix standard direction.
      Do iQ = 1, nQ
         call VecPhase(EVec(1,iQ),nQ)
      End Do
      Call DScal_(nQ*(nQ+1)/2,-1.0D0,EVal,1)
#ifdef _DEBUGPRINT_
      Call RecPrt('ElRed: Eigenvectors',' ',EVec,nQ,nQ)
      Call TriPrt('ElRed: Eigenvalues',' ',EVal,nQ)
#endif
*
*                                        -1/2
*---- Remove redundant vectors and form g     K
*
      nK = 0
      Do i = 1, nQ
         ii=i*(i+1)/2
         If (EVal(ii).gt.Thr) Then
            nK = nK + 1
         End If
         EVal(i) = EVal(ii)
c        If (g12K .and. Abs(EVal(i)).gt.Zero)
         If (g12K .and. Abs(EVal(i)).gt.Zero_Approx)
     &      Call DScal_(nQ,One/Sqrt(EVal(i)),EVec(1,i),1)
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('ElRed: The NonRedundant eigenvectors',
     &            '(5e21.12)',EVec,nQ,nK)
      Call RecPrt('ElRed: eigenvalues ','(8E12.4)',
     &            EVal,1,nK)
#endif
*
 99   Continue
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine ElRed2(nq,nx,Gmtrx,EVal,EVec,nK,uMtrx,g12K,
     &                 Thr,BM,iBM,nB_Tot,nqB)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 Gmtrx(nq,nq), EVec(nq,nq),
     &       EVal(nq*(nq+1)/2), uMtrx(nX), BM(nB_Tot)
      Integer iBM(nB_Tot), nqB(nq)
      Logical g12K, Diagonal
      Real*8, Parameter:: Zero_Approx=0.1D-9
      Real*8, Allocatable:: Work(:), W(:)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*
#ifdef _DEBUGPRINT_
      Call RecPrt('ElRed2: The u matrix','(5e21.12)',umtrx,nx,1)
#endif
      If (nq.eq.0) Then
         nK=0
         Go To 99
      End If
*                             T
*---- Form the G matrix, G=BuB
*
      Call FZero(GMtrx,nq**2)
      iB = 0
      Do i = 1, nq
         nB = nqB(i)
         Do k = 1, nB
            iB = iB + 1
            ik = iBM(iB)
            B_ik=BM(iB)
*
            jB = 0
            Do j = 1, nq
               mB = nqB(j)
               Do l = 1, mB
                  jB = jB + 1
                  jl = iBM(jB)
                  If (ik.eq.jl) Then
                     B_jl=BM(jB)
                     GMtrx(i,j) = GMtrx(i,j)
     &                          + B_ik*umtrx(ik)*B_jl
                  End If
               End Do
            End Do
*
         End Do
      End Do
*
      Diagonal = .True.
      Do i = 1, nq
         Sum = 0.0D0
         Do j = 1, nq
            If (Abs(Gmtrx(i,j)).lt.1.0D-10) Gmtrx(i,j)=Zero
            If (j.ne.i) Sum = Sum + GMtrx(i,j)
         End Do
         Diagonal = Diagonal .and. Sum.eq.0.0D0
      End Do
*
#ifdef _DEBUGPRINT_
      Call RecPrt('ElRed2: The G Matrix (nq x nq)',
     &            '(5e21.12)',Gmtrx,nq,nq)
      Write (6,*) 'Diagonal=',Diagonal
#endif
*
*---- Set up a unit matrix
*
      call dcopy_(nq*nq,[Zero],0,EVec,1)
      call dcopy_(nq,[One],0,EVec,nq+1)
*
*---- Set up the Hessian in lower triangular form, the elements
*     are symmetrized.
*
      Do i = 1, nQ
         Do j = 1, i
            ijTri = i*(i-1)/2 + j
            EVal(ijTri) = Half*(Gmtrx(i,j)+Gmtrx(j,i))
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call TriPrt('Eval prediagonalization',' ',EVal,nQ)
#endif
*
*                                                        |g 0|
*---- Compute eigenvalues and eigenvectors G(K L) = (K L)|0 0|
*     K: nonredundant vectors with eigenvalues g
*     L: redundant vectors
*
      If (.NOT.Diagonal) Then
         N=nQ
         LDZ=Max(1,N)
         Call mma_allocate(Work,3*N,Label='Work')
         Work(:)=Zero
         Call mma_allocate(W,N,Label='W')
         W(:)=Zero
         Info=0
         call dspev_('V','U',N,Eval,W,EVec,LDZ,Work,Info)
         If (Info.ne.0) Then
            Write (6,*) 'Info.ne.0'
            Write (6,*) 'Info=',Info
            Call Abend()
         End If
         Call FZero(EVal,N*(N+1)/2)
         Do i = 1, N
            ii = i*(i+1)/2
            EVal(ii)=W(i)
         End Do
         Call mma_deallocate(W)
         Call mma_deallocate(Work)
      End If
      Call DScal_(nQ*(nQ+1)/2,-1.0D0,EVal,1)
      Call JacOrd(EVal,EVec,nQ,nQ)
*     Fix standard direction.
      Do iQ = 1, nQ
         call VecPhase(EVec(1,iQ),nQ)
      End Do
      Call DScal_(nQ*(nQ+1)/2,-1.0D0,EVal,1)
#ifdef _DEBUGPRINT_
      Call RecPrt('ElRed2: Eigenvectors',' ',EVec,nQ,nQ)
      Call TriPrt('ElRed2: Eigenvalues',' ',EVal,nQ)
#endif
*
*                                        -1/2
*---- Remove redundant vectors and form g     K
*
      nK = 0
      Do i = 1, nQ
         ii=i*(i+1)/2
         If (EVal(ii).gt.Thr) Then
            nK = nK + 1
         End If
         EVal(i) = EVal(ii)
c        If (g12K .and. Abs(EVal(i)).gt.Zero)
         If (g12K .and. Abs(EVal(i)).gt.Zero_Approx)
     &      Call DScal_(nQ,One/Sqrt(EVal(i)),EVec(1,i),1)
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('ElRed2: The NonRedundant eigenvectors',
     &            '(5e21.12)',EVec,nQ,nK)
       Call RecPrt('ElRed2: eigenvalues ','(8E12.4)',
     &            EVal,1,nK)
#endif
*
 99   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine hini_cvb()

use casvb_global, only: icnt, inputmode, joptstep, loopstep, ncnt, recn, recn_tmp03

implicit none

loopstep = 0
joptstep = 0
if (inputmode == 1) then
  ncnt = 0
  recn = recn_tmp03
  call bufio_init_cvb(recn)
else if (inputmode == 2) then
  icnt = 0
  call bufio_init_cvb(recn)
end if

return

end subroutine hini_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE INTCTL1(CMO)
      use output_caspt2, only:iPrGlb,debug
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "pt2_guga.fh"
#include "intgrl.fh"

      DIMENSION CMO(NCMO)

* Compute using conventional integral file:
      IF(IPRGLB.GE.DEBUG) THEN
        WRITE(6,*)' INTCTL1 calling TRACTL...'
        CALL XFLUSH(6)
      END IF
      Call TRACTL(0)
      CALL TRAONE(CMO)
      IF (IPRGLB.GE.DEBUG) THEN
        WRITE(6,*)' INTCTL1 back from TRAONE.'
        CALL XFLUSH(6)
      END IF
c Compute FIMO, FAMO, ...  to workspace:
      CALL FOCK_RPT2

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine FindAM(n,X,XMax,IMax)
!-----------------------------------------------------------------------
! Function : Find Absolute Maximum in X(n)    XMax = X(IMax)
!-----------------------------------------------------------------------

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: X(n)
real(kind=wp), intent(out) :: XMax
integer(kind=iwp), intent(out) :: IMax
integer(kind=iwp) :: I
real(kind=wp) :: XVal

IMax = 1
XMax = Zero

do I=1,n
  XVal = abs(X(I))
  if (XMax < XVal) then
    XMax = XVal
    IMax = I
  end if
end do

return

end subroutine FindAM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine ChoSCF_Drv(nBSQT,nD,nSym,nBas,DSQ,DLT,DSQ_ab,DLT_ab,
     &                FLT,FLT_ab,nFLT,ExFac,FSQ,nOcc,nOcc_ab)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     This routine calls the original ChoSCF_Drv routine (now
C     ChoSCF_Drv_) in case of Cholesky or full DF. A new driver routine
C     is called in case of local DF (LDF).
C
      Implicit None
      Integer nBSQT, nD, nSym, nFLT
      Integer nBas(nSym), nOcc(nSym), nOcc_ab(nSym)
      Real*8  DSQ(*), DLT(*)
      Real*8  DSQ_ab(*), DLT_ab(*)
      Real*8  FLT(*), FLT_ab(*)
      Real*8  FSQ(nBSQT,nD)
      Real*8  ExFac

      Logical DoLDF
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      SUBROUTINE CHOSCF_DRV_Internal(nD,nSym,nBas,W_DSQ,W_DLT,
     &                               W_DSQ_ab,W_DLT_ab,W_FLT,
     &                               W_FLT_ab,nFLT,ExFac,
     &                               W_FSQ,W_FSQ_ab,
     &                               nOcc,nOcc_ab)
      Integer nD, nSym
      Integer nBas(nSym)
      Real*8 W_FLT(*),W_FLT_ab(*)
      Real*8 W_FSQ(*),W_FSQ_ab(*)
      Real*8 W_DSQ(*),W_DSQ_ab(*)
      Real*8 W_DLT(*),W_DLT_ab(*)
      Real*8 ExFac
      Integer, Target :: nOcc(nSym),nOcc_ab(nSym)
      End SUBROUTINE CHOSCF_DRV_Internal

      End Interface
*                                                                      *
************************************************************************
*                                                                      *

      Call DecideOnLocalDF(DoLDF)
      If (DoLDF) Then
         Call LDFSCF_Drv(nD,nSym,nBas,DSQ,DLT,DSQ_ab,DLT_ab,
     &                FLT,FLT_ab,nFLT,ExFac,nOcc,nOcc_ab)
      Else
         Call ChoSCF_Drv_Internal(nD,nSym,nBas,DSQ,DLT,
     &                            DSQ_ab,DLT_ab,FLT,
     &                            FLT_ab,nFLT,ExFac,
     &                            FSQ(:,1),FSQ(:,2),
     &                            nOcc,nOcc_ab)
      End If

      End
      SUBROUTINE CHOSCF_DRV_Internal(nD,nSym,nBas,W_DSQ,W_DLT,
     &                               W_DSQ_ab,W_DLT_ab,W_FLT,
     &                               W_FLT_ab,nFLT,ExFac,
     &                               W_FSQ,W_FSQ_ab,
     &                               nOcc,nOcc_ab)

      use Scf_Arrays, only: CMO
      Use Fock_util_global, only: Deco, Lunit
      use Data_Structures, only: Allocate_DT, Deallocate_DT
      use Data_Structures, only: DSBA_Type, Integer_Pointer
      use SpinAV, only: Do_SpinAV
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Integer nD, nSym
      Integer nBas(nSym), MinMem(nSym),rc
      Parameter (MaxDs = 3)
      Logical DoCoulomb(MaxDs),DoExchange(MaxDs)
      Real*8 FactC(MaxDs),FactX(MaxDs),ExFac
      Integer, Target :: nOcc(nSym),nOcc_ab(nSym)
      Integer nnBSF(8,8),n2BSF(8,8)
      Integer nForb(8,2),nIorb(8,2)
      Real*8 W_FLT(*),W_FLT_ab(*)
      Real*8 W_FSQ(*),W_FSQ_ab(*)
      Real*8 W_DSQ(*),W_DSQ_ab(*)
      Real*8 W_DLT(*),W_DLT_ab(*)
      character ww*512

#include "choscf.fh"
#include "choauf.fh"

      Type (Integer_Pointer) :: pNocc(3)

      Integer, Allocatable, Target:: nVec(:,:)

      Type (DSBA_Type) Cka(2), FLT(2), KLT(2), MSQ(3), DLT, FSQ(3),
     &                 DSQ(3), DDec(2), Vec(2)
*
C  **************************************************
        iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
C  **************************************************

      rc=0
      Lunit(:) = -1
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      IF(nD==1) THEN
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
         Call mma_allocate(nVec,nSym,1,Label='nVec')
         nDen = 1
         DoCoulomb(1)  = .true.
         DoExchange(1) = ExFac.ne.0.0d0 ! no SCF-exchange in pure DFT
         FactC(1)      = 1.0D0
         FactX(1)      = 1.0D0*ExFac ! ExFac used for hybrid functionals

         xFac = ExFac

         Call Allocate_DT(DLT,nBas,nBas,nSym,aCase='TRI',Ref=W_DLT)
         Call Allocate_DT(DSQ(1),nBas,nBas,nSym,Ref=W_DSQ)
         Call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FLT)
         ! trick to use already allocated memory
         Call Allocate_DT(KLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FSQ)
         Call Allocate_DT(FSQ(1),nBas,nBas,nSym,            Ref=W_FSQ)

         If (ExFac.eq.0.0d0) Then
            CALL CHO_FOCK_DFT_RED(rc,DLT,FLT(1))
            If (rc.ne.0) Go To 999
            goto 997
         EndIf

      IF (DECO) THEN !use decomposed density

       xFac = ExFac*0.5d0

       CALL set_nnBSF(nSym,nBas,nnBSF,n2BSF)

       Call Allocate_DT(Vec(1),nBas,nBas,nSym)
       Call Allocate_DT(DDec(1),nBas,nBas,nSym)
       DDec(1)%A0(:) = DSQ(1)%A0(:)

       Do i=1,nSym
          if(nBas(i).gt.0)then
            Ymax=0.0d0
            do ja=1,nBas(i)
               Ymax=Max(Ymax,DDec(1)%SB(i)%A2(ja,ja))
            end do
            Thr = 1.0d-8*Ymax
            CALL CD_InCore(DDec(1)%SB(i)%A2,nBas(i),Vec(1)%SB(i)%A2,
     &                     nBas(i),NumV,Thr,rc)
            If (rc.ne.0) GOTO 999
            nVec(i,1) = NumV
            if ( NumV .ne. nOcc(i) .and. .not.Do_SpinAV
     &                             .and. .not.Cho_Aufb ) then
            write(ww,'(a,i6,a,i6,a,i6,a,i6,a,f6.4)')
     &        'Warning! The number of occupied from the '//
     &        'decomposition of the density matrix is ',numV,
     &        ' in symm. ',i, '; Expected value = ',nOcc(i),
     &        '; Max diagonal of the density in symm. ',i,
     &        ' is equal to ',Ymax
            call WarningMessage(1,ww)
            endif
          else
            nVec(i,1) = 0
          endif
       End Do
       Call Deallocate_DT(DDec(1))

       pNocc(1)%I1(1:) => nVec(1:,1) ! occup. numbers

       Call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=Vec(1)%A0)

       FactX(1) = 0.5D0*ExFac ! ExFac used for hybrid functionals

      ELSE

         pNocc(1)%I1(1:) => nOcc(1:) ! occup. numbers

         Call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=CMO(:,1))

      ENDIF

      Call CHOSCF_MEM(nSym,nBas,nD,DoExchange,pNocc,ALGO,REORD,
     &                MinMem,loff1)
*                                                                      *
************************************************************************
*                                                                      *
      if (ALGO.eq.1 .and. REORD) then
*                                                                      *
************************************************************************
*                                                                      *
        FactX(1)=0.5d0*ExFac

      Call CHO_FOCKTWO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,FactC,
     &                 FactX,[DLT],DSQ,FLT,FSQ,pNocc,MinMem)
*                                                                      *
************************************************************************
*                                                                      *
      elseif (ALGO.eq.1 .and. .not.REORD) then
*                                                                      *
************************************************************************
*                                                                      *
        FactX(1)=0.5d0*ExFac

        CALL CHO_FOCKTWO_RED(rc,nBas,nDen,DoCoulomb,DoExchange,
     &                       FactC,FactX,[DLT],DSQ,FLT,FSQ,pNocc,MinMem)
*                                                                      *
************************************************************************
*                                                                      *
      elseif  (ALGO.eq.2 .and. DECO) then  !use decomposed density
*                                                                      *
************************************************************************
*                                                                      *
       FactX(1) = 0.5D0*ExFac ! vectors are scaled by construction

       if (REORD)then
          Call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,lOff1,
     &                     FactC,FactX,[DLT],DSQ,FLT,FSQ,
     &                     MinMem,MSQ,pNocc)
       else
            CALL CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,lOff1,
     &                       FactC,FactX,[DLT],DSQ,FLT,FSQ,
     &                       MinMem,MSQ,pNocc)
       endif
*                                                                      *
************************************************************************
*                                                                      *
      elseif  (ALGO.eq.2 .and. REORD) then
*                                                                      *
************************************************************************
*                                                                      *
      FactX(1) = 1.0D0*ExFac ! MOs coeff. are not scaled

      Call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,lOff1,
     &                 FactC,FactX,[DLT],DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
*                                                                      *
************************************************************************
*                                                                      *
      elseif  (ALGO.eq.2 .and. .not. REORD) then

      FactX(1) = 1.0D0*ExFac ! MOs coeff. are not scaled

            CALL CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,
     &                       lOff1,FactC,FactX,[DLT],DSQ,FLT,FSQ,
     &                       MinMem,MSQ,pNocc)
*                                                                      *
************************************************************************
*                                                                      *
      elseif (ALGO.eq.3) then

          Do iSym=1,nSym
             nIorb(iSym,1) = pNocc(1)%I1(iSym)
          End Do
          Call Allocate_DT(Cka(1),nIorb(:,1),nBas,nSym)

          Do iSym=1,nSym
           If (nBas(iSym)*nIorb(iSym,1).ne.0) Then
             do ikk=1,nIorb(iSym,1)
                Cka(1)%SB(iSym)%A2(ikk,:) =
     &             MSQ(1)%SB(iSym)%A2(:,ikk)
             end do
           EndIf
           nForb(iSym,1) = 0
          End Do

          CALL CHO_FSCF(rc,nDen,FLT,nForb,nIorb,Cka(1),[DLT],xFac)

          Call Deallocate_DT(Cka(1))
*                                                                      *
************************************************************************
*                                                                      *
      elseif (ALGO.eq.4) then

             Do iSym=1,nSym
                nForb(iSym,1) = 0
                nIorb(iSym,1) = pNocc(1)%I1(iSym)
             End Do

             CALL CHO_LK_SCF(rc,nDen,FLT,KLT,nForb,nIorb,
     &                       MSQ,[DLT],FactX(1),nSCReen,dmpk,dFKmat)

*                                                                      *
************************************************************************
*                                                                      *
      else
*                                                                      *
************************************************************************
*                                                                      *
          rc=99
          write(6,*)'Illegal Input. Specified Cholesky Algorithm= ',ALGO
          CALL QUIT(rc)
*                                                                      *
************************************************************************
*                                                                      *
      endif
*                                                                      *
************************************************************************
*                                                                      *
      If (rc.ne.0) GOTO 999

      IF (DECO) CALL Deallocate_DT(Vec(1))

      If (ALGO.lt.3.and.ExFac.ne.0.0d0) Then

         CALL CHO_SUM(rc,nSym,nBas,nD,DoExchange,FLT,FSQ)

      EndIf
C----------------------------------------------------
 997  Continue
      Call GADSum(FLT(1)%A0,nFLT)

      pNocc(1)%I1=>Null()
      Call Deallocate_DT(MSQ(1))
      Call Deallocate_DT(FSQ(1))
      Call Deallocate_DT(DSQ(1))
      Call Deallocate_DT(KLT(1))
      Call Deallocate_DT(FLT(1))
      Call Deallocate_DT(DLT)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      ELSE   !  UHF calculation
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
         Call mma_allocate(nVec,nSym,2,Label='nVec')
         nDen = 3
C ========== Assign a truth table ==================

C --- Density(1) is Dalpha + Dbeta in a LT storage
         DoCoulomb(1)  = .true.
         DoExchange(1) = .false.
         FactC(1)      = 1.0D0

C --- Density(2) is Dalpha in a SQ storage
         DoCoulomb(2)  = .false.
         DoExchange(2) = ExFac.ne.0.0d0

C --- Density(3) is Dbeta in a SQ storage
         DoCoulomb(3)  = .false.
         DoExchange(3) = ExFac.ne.0.0d0

C --- Occupation numbers
c      call get_iarray('nIsh',nOcc,nSym)
c      call get_iarray('nIsh beta',nOcc_ab,nSym)


C Compute the total density Dalpha + Dbeta
      CALL DAXPY_(nFLT,1.0D0,W_DLT(1),1,W_DLT_ab(1),1)

      Call Allocate_DT(DLT,nBas,nBas,nSym,aCase='TRI',Ref=W_DLT_ab)
      ! alpha density SQ
      Call Allocate_DT(DSQ(2),nBas,nBas,nSym,Ref=W_DSQ)
      ! beta  density SQ
      Call Allocate_DT(DSQ(3),nBas,nBas,nSym,Ref=W_DSQ_ab)

      ! Coulomb (... Falpha LT)
      Call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FLT)
      ! (... Fbeta LT)
      Call Allocate_DT(FLT(2),nBas,nBas,nSym,aCase='TRI',Ref=W_FLT_ab)

      ! alpha exchange (... Falpha SQ)
      Call Allocate_DT(FSQ(2),nBas,nBas,nSym,Ref=W_FSQ)
      ! beta exchange (... Fbeta SQ)
      Call Allocate_DT(FSQ(3),nBas,nBas,nSym,Ref=W_FSQ_ab)

      ! trick to use already allocated work
      Call Allocate_DT(KLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FSQ)
      Call Allocate_DT(KLT(2),nBas,nBas,nSym,aCase='TRI',Ref=W_FSQ_ab)

      FactX(2) = 1.0D0*ExFac ! UHF SQ-density is not scaled
      FactX(3) = 1.0D0*ExFac

      If (ExFac.eq.0.0d0) Then
         CALL CHO_FOCK_DFT_RED(rc,DLT,FLT(1))
         If (rc.ne.0) Go To 999
         goto 998
      EndIf

      IF (DECO) THEN !use decomposed density

       CALL set_nnBSF(nSym,nBas,nnBSF,n2BSF)

       Call Allocate_DT(Vec(1),nBas,nBas,nSym)
       Call Allocate_DT(Vec(2),nBas,nBas,nSym)

       Call Allocate_DT(DDec(1),nBas,nBas,nSym)
       Call Allocate_DT(DDec(2),nBas,nBas,nSym)
       DDec(1)%A0(:)=DSQ(2)%A0(:)
       DDec(2)%A0(:)=DSQ(3)%A0(:)

       Do i=1,nSym
          if(nBas(i).gt.0)then
              Ymax=0.0d0
              do ja=1,nBas(i)
                 Ymax=Max(Ymax,DDec(1)%SB(i)%A2(ja,ja))
              end do
              Thr = 1.0d-8*Ymax
              CALL CD_InCore(DDec(1)%SB(i)%A2,nBas(i),Vec(1)%SB(i)%A2,
     &                       nBas(i),NumV1,Thr,rc)
                   If (rc.ne.0) GOTO 999
                   nVec(i,1) = NumV1
                   if ( NumV1 .ne. nOcc(i) .and. .not.Do_SpinAV
     &                                     .and. .not.Cho_Aufb) then
               write(ww,'(a,i6,a,i6,a,i6,a,i6,a,f6.4)')
     &           'Warning! The number of occupied from the '//
     &           'decomposition of the ALPHA dens. matrix is ',numV1,
     &           ' in symm. ',i,
     &           ';Expected value = ',nOcc(i),
     &           ';Max diagonal of the alpha density in symmetry ',
     &           i,' is equal to ',Ymax
              call WarningMessage(1,ww)
                   endif
              Ymax=0.0d0
              do ja=1,nBas(i)
                 Ymax=Max(Ymax,DDec(2)%SB(i)%A2(ja,ja))
              end do
              Thr = 1.0d-8*Ymax
              CALL CD_InCore(DDec(2)%SB(i)%A2,nBas(i),Vec(2)%SB(i)%A2,
     %                       nBas(i),NumV2,Thr,rc)
                   If (rc.ne.0) GOTO 999
                   nVec(i,2) = NumV2
                   if ( NumV2 .ne. nOcc_ab(i) .and. .not.Do_SpinAV
     &                                        .and. .not.Cho_Aufb) then
               write(ww,'(a,i6,a,i6,a,i6,a,i6,a,f6.4)')
     &           'Warning! The number of occupied from the '//
     &           'decomposition of the BETA dens. matrix is ',numV2,
     &           ' in symm. ',i,
     &           ';Expected value = ',nOcc_ab(i),
     &           ';Max diagonal of the beta density in symmetry ',
     &           i,' is equal to ',Ymax
              call WarningMessage(1,ww)
                   endif
          else
            nVec(i,1) = 0
            nVec(i,2) = 0
          endif
       End Do

       Call deallocate_DT(DDec(2))
       Call deallocate_DT(DDec(1))

       pNocc(1)%I1(1:) => nVec(1:,1) ! dummy
       pNocc(2)%I1(1:) => nVec(1:,1) ! alpha occup. numbers
       pNocc(3)%I1(1:) => nVec(1:,2) ! beta occup. numbers

       Call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=Vec(1)%A0)
       Call Allocate_DT(MSQ(2),nBas,nBas,nSym,Ref=Vec(1)%A0)
       Call Allocate_DT(MSQ(3),nBas,nBas,nSym,Ref=Vec(2)%A0)
      ELSE
       pNocc(1)%I1(1:) => nOcc(1:) ! dummy assignement
       pNocc(2)%I1(1:) => nOcc(1:) ! occup. numbers alpha MOs
       pNocc(3)%I1(1:) => nOcc_ab(1:) ! occup. numbers beta MOs

       Call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=CMO(:,1))
       Call Allocate_DT(MSQ(2),nBas,nBas,nSym,Ref=CMO(:,1))
       Call Allocate_DT(MSQ(3),nBas,nBas,nSym,Ref=CMO(:,2))

      ENDIF

      Call CHOSCF_MEM(nSym,nBas,nD,DoExchange,pNocc,
     &                ALGO,REORD,MinMem,loff1)


      if (ALGO.eq.1.and.REORD) then

      Call CHO_FOCKTWO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,FactC,
     &                FactX,[DLT],DSQ,FLT,FSQ,pNocc,MinMem)

            If (rc.ne.0) GOTO 999

      elseif (ALGO.eq.1 .and. .not.REORD) then

        CALL CHO_FOCKTWO_RED(rc,nBas,nDen,DoCoulomb,DoExchange,
     &           FactC,FactX,[DLT],DSQ,FLT,FSQ,pNocc,MinMem)

            If (rc.ne.0) GOTO 999

      elseif  (ALGO.eq.2 .and. DECO) then !use decomposed density

       if (REORD)then

          Call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,lOff1,
     &     FactC,FactX,[DLT],DSQ,FLT,FSQ,MinMem,MSQ,pNocc)

            If (rc.ne.0) GOTO 999
       else

          CALL CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,
     &                       lOff1,FactC,FactX,[DLT],DSQ,FLT,FSQ,
     &                       MinMem,MSQ,pNocc)

            If (rc.ne.0) GOTO 999
       endif

      elseif  (ALGO.eq.2 .and. REORD) then

      Call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,lOff1,
     &     FactC,FactX,[DLT],DSQ,FLT,FSQ,MinMem,MSQ,pNocc)

           If (rc.ne.0) GOTO 999

      elseif  (ALGO.eq.2 .and. .not. REORD) then

            CALL CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,
     &                       lOff1,FactC,FactX,[DLT],DSQ,FLT,FSQ,
     &                       MinMem,MSQ,pNocc)

           If (rc.ne.0) GOTO 999

      elseif (ALGO.eq.3) then

          Do iSym=1,nSym
             nIorb(iSym,1) = pNocc(2)%I1(iSym)
             nIorb(iSym,2) = pNocc(3)%I1(iSym)
          End Do
          Call Allocate_DT(Cka(1),nIorb(:,1),nBas,nSym)
          Call Allocate_DT(Cka(2),nIorb(:,2),nBas,nSym)

          Do iSym=1,nSym
           If (nBas(iSym)*nIorb(iSym,1).ne.0) Then
             do ikk=1,nIorb(iSym,1)
                Cka(1)%SB(iSym)%A2(ikk,:) =
     &           MSQ(2)%SB(iSym)%A2(:,ikk)
             end do
           EndIf
           If (nBas(iSym)*nIorb(iSym,2).ne.0) Then
             do ikk=1,nIorb(iSym,2)
                Cka(2)%SB(iSym)%A2(ikk,:) =
     &           MSQ(3)%SB(iSym)%A2(:,ikk)
             end do
           EndIf
           nForb(iSym,1) = 0
           nForb(iSym,2) = 0
          End Do

          nMat=2  ! alpha and beta Fock matrices

          CALL CHO_FSCF(rc,nMat,FLT,nForb,nIorb,Cka,[DLT],ExFac)


          Call Deallocate_DT(Cka(2))
          Call Deallocate_DT(Cka(1))

          If (rc.ne.0) GOTO 999


      elseif (ALGO.eq.4) then

             nMat=2  ! alpha and beta Fock matrices

             Do iSym=1,nSym
                nForb(iSym,1) = 0
                nForb(iSym,2) = 0
                nIorb(iSym,1) = pNocc(2)%I1(iSym)
                nIorb(iSym,2) = pNocc(3)%I1(iSym)
             End Do

             CALL CHO_LK_SCF(rc,nMat,FLT,KLT,nForb,nIorb,MSQ(2:3),
     &                       [DLT],FactX(2),nSCReen,dmpk,dFKmat)


          If (rc.ne.0) GOTO 999

      else
          rc=99
          write(6,*)'Illegal Input. Specified Cholesky Algorithm= ',ALGO
          CALL QUIT(rc)
      endif

      IF(DECO) CALL deallocate_DT(Vec(2))
      IF(DECO) CALL deallocate_DT(Vec(1))

998   Continue

C --- To get the Fbeta in LT storage ----

      If (ALGO.lt.3 .or. ExFac.eq.0.0d0) then

        FLT(2)%A0(:) = FLT(1)%A0(:)

      EndIf


C --- Accumulates Coulomb and Exchange contributions
      If (ALGO.lt.3.and.ExFac.ne.0.0d0) then
         CALL CHO_SUM(rc,nSym,nBas,nD,DoExchange,FLT,FSQ)
      Endif

C----------------------------------------------------
      Call GADSum(FLT(1)%A0,nFLT)
      Call GADSum(FLT(2)%A0,nFLT)


C --- Restore the Beta-density matrix ----
C --- Copy the lower triangular of DSQ(3))
C --- and pack the off-diagonal elements

        do isym=1,nsym
           do j=1,nBas(isym)
              do k=j,nBas(isym)
               kj =  iTri(k,j)
               if (j.eq.k) then
                DLT%SB(iSym)%A1(kj) =     DSQ(3)%SB(iSym)%A2(k,j)
               else ! packing of the matrix
                DLT%SB(iSym)%A1(kj) = Two*DSQ(3)%SB(iSym)%A2(k,j)
               endif
              end do
           end do
        end do

         pNocc(1)%I1 => Null()
         pNocc(2)%I1 => Null()
         pNocc(3)%I1 => Null()
         Call Deallocate_DT(MSQ(3))
         Call Deallocate_DT(MSQ(2))
         Call Deallocate_DT(MSQ(1))
         Call Deallocate_DT(DSQ(3))
         Call Deallocate_DT(DSQ(2))
         Call Deallocate_DT(FSQ(3))
         Call Deallocate_DT(FSQ(2))
         Call Deallocate_DT(KLT(2))
         Call Deallocate_DT(KLT(1))
         Call Deallocate_DT(FLT(2))
         Call Deallocate_DT(FLT(1))
         Call Deallocate_DT(DLT)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      ENDIF
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *

999   If (rc.ne.0) then
         write(6,*)'CHOSCF_DRV. Non-zero return code.'
         CALL QUIT(rc)
      endif

      Call mma_deallocate(nVec)


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

function MemSO2_P(nSD,iSD4)
!***********************************************************************
!  Object: to compile the number of SO block which will be generated   *
!          by the current shell quadruplet.                            *
!                                                                      *
!          Observe that the indices are canonically ordered at the     *
!          time of calling this routine!                               *
!                                                                      *
! Called from: Drv2El                                                  *
!                                                                      *
! Calling    : None                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             February '90                                             *
!***********************************************************************

use SOAO_Info, only: iAOtSO
use Symmetry_Info, only: nIrrep
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: MemSO2_P
integer(kind=iwp), intent(in) :: nSD, iSD4(0:nSD,4)
integer(kind=iwp) :: i1, i2, i3, i4, iAO, iCmp, j1, j12, j2, j3, j4, jAO, jCmp, kAO, kCmp, lAO, lCmp

! Quadruple loop over elements of the basis functions angular
! description. Loops are reduced to just produce unique SO integrals
! Observe that we will walk through the memory in AOInt in a
! sequential way.

iAO = iSD4(7,1)
jAO = iSD4(7,2)
kAO = iSD4(7,3)
lAO = iSD4(7,4)

iCmp = iSD4(2,1)
jCmp = iSD4(2,2)
kCmp = iSD4(2,3)
lCmp = iSD4(2,4)

if (nIrrep == 1) then

  MemSO2_P = iCmp*jCmp*kCmp*lCmp

else

  MemSO2_P = 0

  do i1=1,iCmp
    do i2=1,jCmp
      do i3=1,kCmp
        do i4=1,lCmp

          ! Loop over irreps which are spanned by the basis function.
          ! Again, the loop structure is restricted to ensure unique
          ! integrals.

          do j1=0,nIrrep-1
            if (iAOtSO(iAO+i1,j1) < 0) cycle
            do j2=0,nIrrep-1
              if (iAOtSO(jAO+i2,j2) < 0) cycle
              j12 = ieor(j1,j2)
              do j3=0,nIrrep-1
                if (iAOtSO(kAO+i3,j3) < 0) cycle
                j4 = ieor(j12,j3)
                if (iAOtSO(lAO+i4,j4) < 0) cycle
                MemSO2_P = MemSO2_P+1

              end do
            end do
          end do

        end do
      end do
    end do
  end do

end if

return

end function MemSO2_P

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine par_range(n,i,j)
! Distribute 'n' evenly over processes and return
! the range (i,j) of this particular process.
! If there is no valid range, then j<i will be returned,
! so it is possible to use it consistently for looping.

use Para_Info, only: MyRank, nProcs
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n
integer(kind=iwp), intent(out) :: i, j
integer(kind=iwp) :: nqot, nrem

nqot = n/nprocs
nrem = n-nqot*nprocs
if (myrank < nrem) then
  i = myrank*(nqot+1)+1
  j = i+nqot
else
  i = nrem*(nqot+1)+(myrank-nrem)*nqot+1
  j = i+nqot-1
end if

end subroutine par_range

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine GetGrad_Boys(nOrb2Loc,ipLbl,nComp,Rmat,GradNorm,Debug)
C
C     Thomas Bondo Pedersen, December 2005.
C
C     Purpose: compute R-matrix and gradient norm for Boys functional.
C
      Implicit Real*8 (a-h,o-z)
      Integer ipLbl(nComp)
      Real*8  Rmat(nOrb2Loc,nOrb2Loc)
      Logical Debug
#include "WrkSpc.fh"

      Call FZero(Rmat,nOrb2Loc**2)
      Do iComp = 1,nComp
         ip0 = ipLbl(iComp) - 1
         Do j = 1,nOrb2Loc
            Rjj = Work(ip0+nOrb2Loc*(j-1)+j)
            Do i = 1,nOrb2Loc
               Rmat(i,j) = Rmat(i,j) +
     &                     Work(ip0+nOrb2Loc*(j-1)+i)*Rjj
            End Do
         End Do
      End Do

      GradNorm = 0.0d0
      Do i = 1,nOrb2Loc-1
         Do j = i+1,nOrb2Loc
            GradNorm = GradNorm
     &               + (Rmat(i,j)-Rmat(j,i))**2
         End Do
      End Do
      GradNorm = 4.0d0*sqrt(GradNorm)

      If (Debug) Then
         Fun = 0.0d0
         Do i = 1,nOrb2Loc
            Fun = Fun + Rmat(i,i)
         End Do
         Write(6,*) 'GetGrad_Boys: functional = Tr(R) = ',Fun
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989,1993, Jeppe Olsen                                 *
!***********************************************************************

subroutine DIHDJ2_MCLR(IASTR,IBSTR,NIDET,JASTR,JBSTR,NJDET,NAEL,NBEL,jWORK,NORB,HAMIL,ISYM,ECORE,ICOMBI,PSIGN,IASTRM,IBSTRM, &
                       JASTRM,JBSTRM,LIA,LIB,NDIF0,NDIF1,NDIF2)
! A set of left hand side determinants defined by string numbers
! IASTR and IBSTR and a set of right hand side determinants
! defined by JASTR and JBSTR are given.
!
! Obtain Hamiltonian matrix  < IA IB ! H ! JA JB >
!
! If Icombi /= 0 Spin combinations are assumed  for alpha and
! beta strings with different orbital configurations
!   1/SQRT(2) * (!I1A I2B! + PSIGN * !I2A I1B!)
!
! If ISYM == 0 FULL Hamiltonian is constructed
! If ISYM /= 0 LOWER half of hamiltonian is constructed
!
! JEPPE OLSEN JANUARY 1989
!
! Modifed to work with string numbers instead of strings
! March 93

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IASTR(*), IBSTR(*), NIDET, JASTR(*), JBSTR(*), NJDET, NAEL, NBEL, NORB, ISYM, ICOMBI, &
                                 IASTRM(NAEL,*), IBSTRM(NBEL,*), JASTRM(NAEL,*), JBSTRM(NBEL,*)
integer(kind=iwp), intent(out) :: jWORK(NORB,4), LIA(max(NAEL,NBEL)), LIB(max(NAEL,NBEL)), NDIF0, NDIF1, NDIF2
real(kind=wp), intent(out) :: HAMIL(*)
real(kind=wp), intent(in) :: ECORE, PSIGN
integer(kind=iwp) :: I1, I2, IA, IAB, IAEL, IAEQIB, IASTAC, IB, IBEL, IBSTAC, IDET, IDIFF, IEL, IEL1, ILOOP, IORB, IPERM, J1, J2, &
                     JA, JAB, JAEL, JAEQJB, JASTAC, JB, JBEL, JBSTAC, JDET, JDIFF, JEL, JEL1, JORB, JPERM, LHAMIL, MINI, NACM, &
                     NADIF, NBCM, NBDIF, NIABEL, NJABEL, NLOOP, NTERMS
real(kind=wp) :: CONST, SGN, SIGNA, SIGNB, XVAL
real(kind=wp), external :: GETH1I_MCLR, GTIJKL_MCLR

if (ISYM == 0) then
  LHAMIL = NIDET*NJDET
else
  LHAMIL = nTri_Elem(NIDET)
end if
HAMIL(1:LHAMIL) = Zero

NTERMS = 0
NDIF0 = 0
NDIF1 = 0
NDIF2 = 0

! Loop over J determinants

! dummy initialize
JAEQJB = -1
CONST = Zero
IEL1 = -1
JEL1 = -1
SIGNA = Zero
SIGNB = Zero
IPERM = 0
JPERM = 0
SGN = Zero
XVAL = Zero
do JDET=1,NJDET
  ! Expand JDET
  JASTAC = JASTR(JDET)
  JBSTAC = JBSTR(JDET)

  jWORK(:,3:4) = 0
  do IAEL=1,NAEL
    jWORK(JASTRM(IAEL,JASTAC),3) = 1
  end do

  do IBEL=1,NBEL
    jWORK(JBSTRM(IBEL,JBSTAC),4) = 1
  end do

  if (ICOMBI /= 0) then
    if (JASTAC == JBSTAC) then
      JAEQJB = 1
    else
      JAEQJB = 0
    end if
  end if

  if (ISYM == 0) then
    MINI = 1
  else
    MINI = JDET
  end if

  ! Loop over I determinants

  do IDET=MINI,NIDET
    IASTAC = IASTR(IDET)
    IBSTAC = IBSTR(IDET)

    if (IASTAC == IBSTAC) then
      IAEQIB = 1
    else
      IAEQIB = 0
    end if

    if ((ICOMBI == 1) .and. (IAEQIB+JAEQJB == 0)) then
      NLOOP = 2
    else
      NLOOP = 1
    end if
    do ILOOP=1,NLOOP
      NTERMS = NTERMS+1
      ! For second part of spin combinations strings should be swapped
      if (ILOOP == 1) then
        LIA(1:NAEL) = IASTRM(:,IASTAC)
        LIB(1:NBEL) = IBSTRM(:,IBSTAC)
      else if (ILOOP == 2) then
        LIB(1:NAEL) = IASTRM(:,IBSTAC)
        LIA(1:NBEL) = IBSTRM(:,IASTAC)
      end if

      ! =============================
      ! Number of orbital differences
      ! =============================

      NACM = 0
      do IAEL=1,NAEL
        NACM = NACM+jWORK(LIA(IAEL),3)
      end do
      NBCM = 0
      do IBEL=1,NBEL
        NBCM = NBCM+jWORK(LIB(IBEL),4)
      end do
      NADIF = NAEL-NACM
      NBDIF = NBEL-NBCM

      if (NADIF+NBDIF > 2) cycle
      ! Factor for combinations
      if (ICOMBI == 0) then
        CONST = One
      else
        if ((JAEQJB+IAEQIB) == 2) then
          CONST = One
        else if ((JAEQJB+IAEQIB) == 1) then
          CONST = sqrt(Half)*(One+PSIGN)
        else if ((JAEQJB+IAEQIB) == 0) then
          if (ILOOP == 1) then
            CONST = One
          else
            CONST = PSIGN
          end if
        end if
      end if
      ! External sign factor
      !if (IXSGN*JXSGN == -1) CONST = -CONST

      ! ================================================
      ! Find differing orbitals and sign for permutation
      ! ================================================

      ! Expand idet
      jWORK(:,1:2) = 0

      do IAEL=1,NAEL
        jWORK(LIA(IAEL),1) = 1
      end do

      do IBEL=1,NBEL
        jWORK(LIB(IBEL),2) = 1
      end do

      ! One pair of differing alpha electrons

      if (NADIF == 1) then
        do IAEL=1,NAEL
          if (jWORK(LIA(IAEL),3) == 0) then
            IA = LIA(IAEL)
            IEL1 = IAEL
            exit
          end if
        end do

        do JAEL=1,NAEL
          if (jWORK(JASTRM(JAEL,JASTAC),1) == 0) then
            JA = JASTRM(JAEL,JASTAC)
            JEL1 = JAEL
            exit
          end if
        end do
        SIGNA = (-One)**(JEL1+IEL1)
      end if

      ! One pair of differing beta electrons

      if (NBDIF == 1) then
        do IBEL=1,NBEL
          if (jWORK(LIB(IBEL),4) == 0) then
            IB = LIB(IBEL)
            IEL1 = IBEL
            exit
          end if
        end do
        do JBEL=1,NBEL
          if (jWORK(JBSTRM(JBEL,JBSTAC),2) == 0) then
            JB = JBSTRM(JBEL,JBSTAC)
            JEL1 = JBEL
            exit
          end if
        end do
        SIGNB = (-One)**(JEL1+IEL1)
      end if

      ! Two pairs of differing alpha electrons

      if (NADIF == 2) then
        IDIFF = 0
        do IAEL=1,NAEL
          if (jWORK(LIA(IAEL),3) == 0) then
            if (IDIFF == 0) then
              IDIFF = 1
              I1 = LIA(IAEL)
              IPERM = IAEL
            else
              I2 = LIA(IAEL)
              IPERM = IAEL+IPERM
              exit
            end if
          end if
        end do

        JDIFF = 0
        do JAEL=1,NAEL
          if (jWORK(JASTRM(JAEL,JASTAC),1) == 0) then
            if (JDIFF == 0) then
              JDIFF = 1
              J1 = JASTRM(JAEL,JASTAC)
              JPERM = JAEL
            else
              J2 = JASTRM(JAEL,JASTAC)
              JPERM = JAEL+JPERM
              exit
            end if
          end if
        end do
        SGN = (-One)**(IPERM+JPERM)
      end if

      ! Two pairs of differing beta electrons

      if (NBDIF == 2) then
        IDIFF = 0
        do IBEL=1,NBEL
          if (jWORK(LIB(IBEL),4) == 0) then
            if (IDIFF == 0) then
              IDIFF = 1
              I1 = LIB(IBEL)
              IPERM = IBEL
            else
              I2 = LIB(IBEL)
              IPERM = IBEL+IPERM
              exit
            end if
          end if
        end do

        JDIFF = 0
        do JBEL=1,NBEL
          if (jWORK(JBSTRM(JBEL,JBSTAC),2) == 0) then
            if (JDIFF == 0) then
              JDIFF = 1
              J1 = JBSTRM(JBEL,JBSTAC)
              JPERM = JBEL
            else
              J2 = JBSTRM(JBEL,JBSTAC)
              JPERM = JBEL+JPERM
              exit
            end if
          end if
        end do
        SGN = (-One)**(IPERM+JPERM)
      end if

      ! =======================
      ! Value of matrix element
      ! =======================

      if ((NADIF == 2) .or. (NBDIF == 2)) then
        ! 2 differences in alpha or beta strings
        NDIF2 = NDIF2+1
        ! SGN * (I1 J1 ! I2 J2) - (I1 J2 ! I2 J1)
        XVAL = SGN*(GTIJKL_MCLR(I1,J1,I2,J2)-GTIJKL_MCLR(I1,J2,I2,J1))
      else if ((NADIF == 1) .and. (NBDIF == 1)) then
        ! 1 difference in alpha strings and one difference in beta string
        NDIF2 = NDIF2+1
        ! SGN * (IA JA ! IB JB)
        XVAL = SIGNA*SIGNB*GTIJKL_MCLR(IA,JA,IB,JB)
        ! 1 differences in alpha or beta strings
      else if ((NADIF == 1) .and. (NBDIF == 0) .or. (NADIF == 0) .and. (NBDIF == 1)) then
        NDIF1 = NDIF1+1
        ! SGN *(H(I1 J1) +
        !  (SUM OVER ORBITALS OF BOTH      SPIN TYPES  (I1 J1 ! JORB JORB)
        ! -(SUM OVER ORBITALS OF DIFFERING SPIN TYPE   (I1 JORB ! JORB J1)
        if (NADIF == 1) then
          I1 = IA
          J1 = JA
          SGN = SIGNA
        else
          I1 = IB
          J1 = JB
          SGN = SIGNB
        end if

        XVAL = GETH1I_MCLR(I1,J1)
        do JAEL=1,NAEL
          JORB = JASTRM(JAEL,JASTAC)
          XVAL = XVAL+GTIJKL_MCLR(I1,J1,JORB,JORB)
        end do
        do JBEL=1,NBEL
          JORB = JBSTRM(JBEL,JBSTAC)
          XVAL = XVAL+GTIJKL_MCLR(I1,J1,JORB,JORB)
        end do
        if (NADIF == 1) then
          do JAEL=1,NAEL
            JORB = JASTRM(JAEL,JASTAC)
            XVAL = XVAL-GTIJKL_MCLR(I1,JORB,JORB,J1)
          end do
        else
          do JBEL=1,NBEL
            JORB = JBSTRM(JBEL,JBSTAC)
            XVAL = XVAL-GTIJKL_MCLR(I1,JORB,JORB,J1)
          end do
        end if
        XVAL = XVAL*SGN
      else if ((NADIF == 0) .and. (NBDIF == 0)) then
        ! Diagonal elements
        NDIF0 = NDIF0+1
        XVAL = ECORE
        do IAB=1,2
          if (IAB == 1) then
            NIABEL = NAEL
          else
            NIABEL = NBEL
          end if
          do JAB=1,2
            if (JAB == 1) then
              NJABEL = NAEL
            else
              NJABEL = NBEL
            end if
            do IEL=1,NIABEL
              if (IAB == 1) then
                IORB = LIA(IEL)
              else
                IORB = LIB(IEL)
              end if
              if (IAB == JAB) XVAL = XVAL+GETH1I_MCLR(IORB,IORB)
              do JEL=1,NJABEL
                if (JAB == 1) then
                  JORB = LIA(JEL)
                else
                  JORB = LIB(JEL)
                end if
                XVAL = XVAL+Half*GTIJKL_MCLR(IORB,IORB,JORB,JORB)
                ! test

                if (IAB == JAB) XVAL = XVAL-Half*GTIJKL_MCLR(IORB,JORB,JORB,IORB)
                ! test
              end do
            end do
          end do
        end do
      end if

      if (ISYM == 0) then
        HAMIL((JDET-1)*NIDET+IDET) = HAMIL((JDET-1)*NIDET+IDET)+CONST*XVAL
      else
        HAMIL(nTri_Elem(IDET-1)+JDET) = HAMIL(nTri_Elem(IDET-1)+JDET)+CONST*XVAL
      end if
    end do
  end do
end do

end subroutine DIHDJ2_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkT20p (T2,V,oe,dima,adda,no)
c
c       this routine do:
c       T2(a'b',i,j)=(a'i|b'j)/Dija'b'
c        for aGrp.eq.bGrp
c       N.B.2 qvajt odflaknute, neurobene
c
        implicit none
        integer dima,adda,no
        real*8 V(1:dima,1:no,1:dima,1:no)
        real*8 T2(1:dima*(dima+1)/2,1:no,1:no)
        real*8 oe(*)
c
c       help variables
        integer i,j,a,b,ab
        real*8 dijab
c
c
        do j=1,no
          do i=1,no
            ab=0
            do a=1,dima
            do b=1,a
              ab=ab+1
              dijab=oe(i)+oe(j)-oe(adda+a)-oe(adda+b)
              T2(ab,i,j)=V(a,i,b,j)/dijab
            end do
            end do
          end do
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_OPEN(LUNIT,FNAME)
C
C     Purpose: open sequential unformatted fortran file.
C
      IMPLICIT NONE
      INTEGER  LUNIT
      CHARACTER*(*) FNAME

      INTEGER  LOCUNT, ISEED

      INTEGER ISFREEUNIT

      IF ((LUNIT.LT.1) .OR. (LUNIT.GT.99)) THEN
         LOCUNT = 7
      ELSE
         LOCUNT = LUNIT
      END IF

      ISEED  = LOCUNT
      LOCUNT = ISFREEUNIT(ISEED)
      call molcas_binaryopen_vanilla(Locunt, Fname)
c      OPEN(LOCUNT,FILE=FNAME,STATUS='UNKNOWN',FORM='UNFORMATTED')
      LUNIT = LOCUNT

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DFP(B,nDim,Bd,Delta,Gamma)
      Implicit Real*8 (a-h,o-z)
      Real*8 B(nDim,nDim), Bd(nDim),Gamma(nDim),Delta(nDim)
      Real*8, Parameter :: Thr=1.0D-8
*                                                                      *
************************************************************************
*                                                                      *
!#define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*
#ifdef _DEBUGPRINT_
      Call RecPrt('DFP: B',' ',B,nDim,nDim)
*     Call RecPrt('DFP: Bd',' ',Bd,1,nDim)
      Call RecPrt('DFP: Gamma',' ',Gamma,1,nDim)
      Call RecPrt('DFP: Delta',' ',Delta,1,nDim)
#endif
      Call DGEMM_('N','N',
     &            nDim,1,nDim,
     &            1.0d0,B,nDim,
     &                  Delta,nDim,
     &            0.0d0,Bd,nDim)
      gd=DDot_(nDim,Gamma,1,Delta,1)
      dBd=DDot_(nDim,Delta,1,Bd,1)
#ifdef _DEBUGPRINT_
      Call RecPrt('DFP: Bd',' ',Bd,1,nDim)
      Write (6,*) 'gd=',gd
      Write (6,*) 'dBd=',dBd
      Write (6,*) 'Thr=',Thr
#endif
      If (gd<0.0D0) Then
         Call MSP(B,Gamma,Delta,nDim)
      Else
*
         Do i = 1, nDim
            Do j = 1, nDim
               B(i,j) = B(i,j) + (Gamma(i)*Gamma(j))/gd
     &                         - (Bd(i)*Bd(j))/dBd
            End Do
         End Do
      End If
*
#ifdef _DEBUGPRINT_
      Call RecPrt('DFP: B',' ',B,nDim,nDim)
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FndSph(NAt,ICharg,ToAng,C,IAt,ITypRad,NSphInp,
     $                  Alpha,XSph,YSph,ZSph,Rad,NOrd,iPrint)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "rctfld.fh"
      Parameter (ISAX=1000)
      Dimension C(3,*),IAt(*)
      Dimension XSph(*),YSph(*),ZSph(*),Rad(*),NOrd(*)
      Data IOut /6/, Zero /0.0d0/
*
* Assign GEPOL sphere positions and radii according to solute atoms
* nature
*
      If(ITypRad.eq.1) then
* United Atom Topological Model (UATM) radii:
        Call GetMem('Chg','Allo','Real',ip_Chg,NAt)
        call dcopy_(NAt,[Zero],0,Work(ip_chg),1)
        Call UATM(IOut,ICharg,NAt,NSinit,ToAng,Rad,Alpha,C,IAt,NOrd,
     &            Work(ip_Chg),iPrint)
        Call GetMem('Chg','Free','Real',ip_Chg,NAt)
      ElseIf(ITypRad.eq.2) then
* Pauling radii on each atom:
        Do 100 I = 1, NAt
          NOrd(I) = I
          Rad(I) = Pauling(IAt(I))
          Alpha = 1.2
          NSinit = NAt
 100    Continue
      ElseIf(ITypRad.eq.3) then
* Sphere radii given in the input
        Do 200 I = 1, NSphInp
          NOrd(I) = NOrdInp(I)
          Rad(I) = RadInp(I)
          Alpha = 1.2
          NSinit = NSphInp
 200    Continue
      Else
        write(6,'(''Unrecognized radii type !'')')
        Call Abend()
      EndIf
      If((ITypRad.eq.2.or.ITypRad.eq.3).and.iPrint.gt.5)
     &  Call PrtCav(IOut,ITypRad,NSinit,NOrd,Alpha,Rad)

      Do 300 I = 1, NSinit
        XSph(I) = C(1,NOrd(I))
        YSph(I) = C(2,NOrd(I))
        ZSph(I) = C(3,NOrd(I))
        Rad(I) = Rad(I) * Alpha
 300  Continue

      Return
      End
      Subroutine PrtCav(IOut,ITyp,NS,NOrd,Alpha,Rad)
      Implicit real*8 (A-H,O-Z)
*
* Print out sphere radii for Pauling or input cavitites
*
      Dimension NOrd(*),Rad(*)
*
      Write(iOut,*)
      Write(iOut,*)
      Write(iOut,'(6X,A)') 'Polarized Continuum Model Cavity'
      Write(iOut,'(6X,A)') '================================'
      If(ITyp.eq.2) Write(iOut,'(6X,A)') 'Pauling radii'
      If(ITyp.eq.3) Write(iOut,'(6X,A)') 'Sphere radii from input'
      Write(iOut,*)
      Write(IOut,'(6X,'' Nord  Alpha  Radius'')')
      Do 100 IS = 1, NS
        Write(IOut,'(6X,1X,I3,3X,F4.2,3X,F5.3)')
     &   NOrd(IS),Alpha,Rad(IS)
 100  Continue
      Write(IOut,'(6X,1X,78(''-''))')
      Write(IOut,*)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE COMPRS2LST(     I1,    XI1,     N1,     I2,    XI2,
     &                           N2,   NKIN,  NKOUT)
*
* Two lists of excitations/annihilations/creations are given.
* COmpress to common nonvanishing entries
*
* Jeppe Olsen, November 1996
*
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION I1(NKIN,N1),XI1(NKIN,N1)
      DIMENSION I2(NKIN,N2),XI2(NKIN,N2)
*
      NKOUT = 0
      DO K = 1, NKIN
        I1ACT  = 0
        DO I = 1, N1
          IF(I1(K,I).NE.0) I1ACT = 1
        END DO
        I2ACT = 0
        DO I = 1, N2
          IF(I2(K,I).NE.0) I2ACT = 1
        END DO
        IF(I1ACT.EQ.1.AND.I2ACT.EQ.1) THEN
          NKOUT = NKOUT + 1
          IF(NKOUT.NE.K) THEN
            DO I = 1, N1
               I1(NKOUT,I) = I1(K,I)
              XI1(NKOUT,I) =XI1(K,I)
            END DO
            DO I = 1, N2
               I2(NKOUT,I) = I2(K,I)
              XI2(NKOUT,I) =XI2(K,I)
            END DO
          END IF
        END IF
      END DO
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine detsort2_cvb(
     >  xalf,norb,nalf,nfrag,nda_fr,nalf_fr,
     >  nalf_acc,ia12ind,iphase,nc_fac,ncombindex,
     >  iastr,iastr_off,iastr_acc,istack,mxstack)
      implicit real*8 (a-h,o-w,y-z),integer(x)
      dimension xalf(0:norb,0:nalf)
      dimension istack(mxstack)
      dimension nalf_fr(nfrag)
      dimension nalf_acc(nfrag)
      dimension nda_fr(nfrag)
      dimension iastr(*),iastr_off(nfrag)
      dimension iastr_acc(norb,nfrag)
      dimension ncombindex(0:nfrag)
      dimension iphase(nfrag),nc_fac(nfrag)
      dimension ia12ind(*)

      call weightfl_cvb(xalf,nalf,norb)

      ncombindex(0)=1
      do i=1,nfrag
      if(i.eq.1)then
        nalf_acc(i)=nalf_fr(i)
        nc_fac(i)=1
      else
        nalf_acc(i)=nalf_acc(i-1)+nalf_fr(i)
        nc_fac(i)=nc_fac(i-1)*nda_fr(i-1)
      endif
      enddo

      nloop=nfrag
c  MXITERS -> NDA_FR

c  Following is code for a set of nested loops. To deal with the
c  complication that the number of nested loops is not known at
c  compile time, a simple integer stack is used.
c  NESTLEVEL=1 signifies we are doing outermost loop and so on.

      nestlevel=0
      call istkinit_cvb(istack,mxstack)

c  Here we go to the beginning of the next loop in the sequence :
1000  continue
      if(nestlevel.lt.nloop)then
        nestlevel=nestlevel+1
        iter=0
        mxiter=nda_fr(nestlevel)
        call istkpush_cvb(istack,iter)
        call istkpush_cvb(istack,mxiter)
      endif

c  Here we do the next loop iteration of the current loop :
2000  if(nestlevel.eq.0)goto 3000
      call istkpop_cvb(istack,mxiter)
      call istkpop_cvb(istack,iter)
      iter=iter+1
      if(iter.gt.mxiter)then
        nestlevel=nestlevel-1
        goto 2000
      else
        call istkpush_cvb(istack,iter)
        call istkpush_cvb(istack,mxiter)
      endif

c  Here goes the code specific to this loop level.
      if(nestlevel.eq.1)then
        call imove_cvb(
     >    iastr(1+nalf_fr(nestlevel)*(iter-1)+iastr_off(nestlevel)-1),
     >    iastr_acc(1,nestlevel),nalf_fr(nestlevel))
        iphase(nestlevel)=1
      else
        iphase(nestlevel)=iphase(nestlevel-1)*
     >    ioemrg2_cvb(iastr_acc(1,nestlevel-1),nalf_acc(nestlevel-1),
     >    iastr(1+nalf_fr(nestlevel)*(iter-1)+iastr_off(nestlevel)-1),
     >    nalf_fr(nestlevel),iastr_acc(1,nestlevel))
        if(iphase(nestlevel).eq.0)goto 1000
      endif
      ncombindex(nestlevel)=ncombindex(nestlevel-1)
     >  +nc_fac(nestlevel)*(iter-1)
      if(nestlevel.eq.nfrag)then
        iatotindx=minind_cvb(iastr_acc(1,nestlevel),nalf,norb,xalf)
        ia12ind(ncombindex(nestlevel))=iatotindx*iphase(nestlevel)
      endif

      goto 1000

c  This is the end ...
3000  continue

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine GENINT(LNPT,NPP,XX,YY,NUSE,IR2,NTP,XI,YI,VLIM,ILR,NCN,CNN)
!** GENINT produces a smooth function YY(i) at the NPP input distances
!  XX(i) by performing numerical interpolation over the range of the
!  NTP input function values YI(j) at the distances XI(j), and using
!  analytic functions to extrapolate beyond their range to with an
!  exponential at short range and a form specified by ILR, NCN & CNN
!** ILR specifies how to extrapolate beyond largest given turning pts
!   If ILR < 0 , fit last 3 points to:  VLIM - A*exp(-b*(R-R0)**2)
!   If ILR = 0 , fit last 3 points to:  VLIM - A*R**p *exp(-b*R)
!   If ILR = 1 : fit last two points to:  VLIM - A/R**B .
!* If(ILR >= 2) fit last turning points to:  VLIM - sum(of ILR
!  inverse-power terms beginning with  1/R**NCN). *** If CNN /= 0 ,
!  leading coefficient fixed at  CNN ; otherwise get it from points too.
!* Assume read-in CNN value has units:  ((cm-1)(angstroms)**'NCN').
!  If ILR = 2 or 3 , successive higher power terms differ by  1/R**2
!  If ILR > 3 : this factor is  1/R .
!=== Calls subroutines PLYINTRP, SPLINT & SPLINE ==================
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LNPT, NPP, NUSE, IR2, NTP
real(kind=wp), intent(in) :: XX(NPP), XI(NTP), YI(NTP), VLIM
real(kind=wp), intent(out) :: YY(NPP)
integer(kind=iwp), intent(inout) :: ILR, NCN
real(kind=wp), intent(inout) :: CNN
integer(kind=iwp) :: I, IDER, IFXCN, J, MBEG, MF(10), MFIN, MI(10), MINNER, NCN2, NCN4, NN, NORD, NUST
real(kind=wp) :: ADCSR, DCSR, DUMM(20), DX1, DX2, DX3, EX1, EX2, EX3, PDCSR, VRAT, X1, X2, X3, XJ(20), Y1, Y2, Y3, YJ(20)
logical(kind=iwp) :: DoPrint
integer(kind=iwp), save :: IMX1, ISR, JMAX, JR2, NMX
real(kind=wp), save :: ALR, ASR, BLR, BSR, CLR, CSR

Y3 = 0
Y2 = 0
Y1 = 0
X3 = 0
X1 = 0
NUST = NUSE/2
if (NUSE <= 0) NUST = 2
IDER = 0
! Determine if/where need to begin extrapolation beyond input data
! XX(MI(J))  is the 1-st mesh point past turning point  XI(J) .
! XX(MF(J))  is the last mesh point before turning point  XI(NTP+1-J)
outer: do J=1,NUST
  MI(J) = 1
  MF(J) = 0
  do I=1,NPP
    if (XX(I) <= XI(J)) MI(J) = I+1
    if (XX(I) >= XI(NTP+1-J)) exit outer
    MF(J) = I
  end do
end do outer
if (NUST < 2) then
  MFIN = MI(1)-1
else
  MFIN = MI(2)-1
end if
if (LNPT > 0) then
  !-----------------------------------------------------------------------
  ! For a new case determine analytic functions for extrapolating beyond
  ! the range of the input points (if necessary) on this or later calls.
  ! Try to fit three innermost turning points to  V(R)=A+B*EXP(-C*R).
  ! If unsatisfactory, extrapolate inward with inverse power function
  if (IR2 <= 0) then
    YJ(1:4) = YI(1:4)
  else
    YJ(1:4) = YI(1:4)/XI(1:4)**2
  end if
  X1 = XI(1)
  X2 = XI(2)
  X3 = XI(3)
  Y1 = YJ(1)
  Y2 = YJ(2)
  Y3 = YJ(3)
  if ((Y1-Y2)*(Y2-Y3) <= Zero) then
    ! If 3 innermost points not monotonic, use A+B/X inward extrapoln.
    ISR = 0
    write(u6,600)
  else
    ! Use cubic through innermost points to get initial trial exponent
    ! from ratio of derivatives,  Y''/Y'
    IDER = 2
    ISR = 4
    call PLYINTRP(XI,YJ,ISR,X2,XJ,ISR,IDER)
    CSR = XJ(3)/XJ(2)
    DCSR = abs(CSR*X2)
    if (DCSR > 1.5e2_wp) then
      ! If exponential causes overflows, use inverse power inward extrapoln.
      ISR = 0
      write(u6,602) CSR
    else
      ! Prepare parameters for inward exponential extrapolation
      VRAT = (Y3-Y2)/(Y1-Y2)
      DX1 = X1-X2
      DX3 = X3-X2
      EX2 = One
      ADCSR = 1.0e99_wp
      ! Now iterate (with actual point) to get exact exponent coefficient
      DoPrint = .true.
      do J=1,15
        PDCSR = ADCSR
        EX1 = exp(CSR*DX1)
        EX3 = exp(CSR*DX3)
        DCSR = (VRAT-(EX3-EX2)/(EX1-EX2))/((X3*EX3-X2-(X1*EX1-X2)*(EX3-EX2)/(EX1-EX2))/(EX1-EX2))
        ADCSR = abs(DCSR)
        if (((ADCSR > PDCSR) .and. (ADCSR < 1.0e-8_wp)) .or. (ADCSR < 1.0e-12_wp)) then
          DoPrint = .false.
          exit
        end if
        CSR = CSR+DCSR
      end do
      if (DoPrint) write(u6,604) DCSR
      BSR = (Y1-Y2)/(EX1-EX2)
      ASR = Y2-BSR*EX2
      BSR = BSR*exp(-CSR*X2)
      write(u6,606) X2,ASR,BSR,CSR
    end if
  end if
  if (ISR <= 0) then
    if ((X1*X2) <= Zero) then
      ! If 1'st two mesh points of opposite sign, extrapolate linearly
      ISR = -1
      ASR = Y2
      BSR = (Y2-Y1)/(X2-X1)
      CSR = X2
      write(u6,608) X2,ASR,BSR,CSR
    else
      ! For inward extrapolation as inverse power through 1'st two points ..
      BSR = (Y1-Y2)*X1*X2/(X2-X1)
      ASR = Y1-BSR/X1
      CSR = X2
      write(u6,610) X2,ASR,BSR
    end if
  end if
end if
600 format('  ** CAUTION ** Exponential inward extrapolation fails'/16x,'since first 3 points not monotonic, ... so ...')
602 format(' *** CAUTION ** inward extrapolation exponent coefficient C=',ES12.4/10x,'could cause overflows, ... so ...')
604 format(' *** CAUTION ** after 15 tries inward extrap. exponent coefft change is',ES9.1)
606 format(' Extrapolate to   X <=',F7.4,'  with'/'   Y=',F13.3,SP,ES15.6,' * exp(',SS,ES13.6,'*X)')
608 format(' Extrapolate to   X <=',F8.4,'   with'/'   Y=',F13.3,SP,ES16.7,' * [X - (',SS,F8.4,')]')
610 format(' Extrapolate to  X <=',F8.4,'   with   Y=',F12.3,SP,ES15.6,')/X**1')

if (MFIN > 0) then
  ! If needed, calculate function in inner extrapolation region
  if (ISR > 0) then
    ! ... either as an exponential
    do I=1,MFIN
      EX1 = CSR*XX(I)
      if (abs(EX1) > 1.0e2_wp) EX1 = 1.0e2_wp*sign(One,EX1)
      YY(I) = ASR+BSR*exp(EX1)
    end do
  else if (ISR == 0) then
    ! ... or if that fails, as an inverse power
    YY(1:MFIN) = ASR+BSR/XX(1:MFIN)
  else if (ISR < 0) then
    ! ... or if X changes sign, extrapolate inward linearly
    YY(1:MFIN) = ASR+BSR*(XX(1:MFIN)-CSR)
  end if
end if
! End of inward extrapolation procedure
!-----------------------------------------------------------------------
MINNER = MFIN
if (NUST > 2) then
  ! If(NUSE > 5) minimize spurious behaviour by interpolating with
  ! order less than NUSE on intervals near inner end of range
  do J=3,NUST
    NORD = 2*(J-1)
    MBEG = MI(J-1)
    MFIN = MI(J)-1
    do I=MBEG,MFIN
      call PLYINTRP(XI,YI,NTP,XX(I),DUMM,NORD,IDER)
      YY(I) = DUMM(1)
    end do
  end do
end if
! Main interpolation step begins here
!=======================================================================
MBEG = MI(NUST)
MFIN = MF(NUST)
if (MFIN >= MBEG) then
  if (NUSE <= 0) then
    ! Either ... use cubic spline for main interpolation step
    call SPLINT(LNPT,NTP,XI,YI,MBEG,MFIN,XX,YY)
  else
    ! ... or use piecewise polynomials for main interpolation step
    do I=MBEG,MFIN
      call PLYINTRP(XI,YI,NTP,XX(I),DUMM,NUSE,IDER)
      YY(I) = DUMM(1)
    end do
  end if
end if
if (MFIN < NPP) then
  if (NUST <= 2) then
    ! If(NUSE > 5) minimize spurious behaviour by interpolating with
    ! order less than NUSE on intervals near outer end of range
    MBEG = MF(NUST)+1
  else
    NN = NUST-2
    do J=1,NN
      NORD = 2*(NUST-J)
      MBEG = MF(NUST-J+1)+1
      MFIN = MF(NUST-J)
      if (MFIN >= MBEG) then
        do I=MBEG,MFIN
          call PLYINTRP(XI,YI,NTP,XX(I),DUMM,NORD,IDER)
          YY(I) = DUMM(1)
        end do
      end if
    end do
  end if
end if
MBEG = MFIN+1
! In (IR2 > 0) option, now remove X**2 from the interpolated function
if (IR2 > 0) YY(MINNER+1:MFIN) = YY(MINNER+1:MFIN)/XX(MINNER+1:MFIN)**2
! Print test of smoothness at join with analytic inward extrapolation
!if (LNPT > 0) then
!  MST = max(MINNER-4,1)
!  MFN = MST+8
!  if (MFN > NPP) MFN = NPP
!  if (MFN > MFIN) MFN = MFIN
!  if (MINNER > 0) write(u6,611) X2,((XX(I),YY(I),I=J,MFN,3),J=MST,MST+2)
!  611 format('     Verify smoothness of inner join at   X=',F9.5/(3X,3(F10.5,G15.7)))
!end if
!-----------------------------------------------------------------------
! To extrapolate potential beyond range of given turning points ...
if (LNPT > 0) then
  ! On first entry, calculate things needed for extrapolation constants
  Y1 = YI(NTP)
  Y2 = YI(NTP-1)
  Y3 = YI(NTP-2)
  X1 = XI(NTP)
  X2 = XI(NTP-1)
  X3 = XI(NTP-2)
  if (IR2 > 0) then
    Y1 = Y1/X1**2
    Y2 = Y2/X2**2
    Y3 = Y3/X3**2
  end if
end if
! Check inverse-power tail power ...
if (NCN <= 0) NCN = 6
if (ILR < 0) then
  if (LNPT > 0) then
    ! For  ILR < 0  use  Y = VLIM - ALR * exp[-CLR*(X - BLR)**2]
    EX1 = log((VLIM-Y1)/(VLIM-Y2))/(X1-X2)
    EX2 = log((VLIM-Y2)/(VLIM-Y3))/(X2-X3)
    BLR = (X1+X2-(X2+X3)*EX1/EX2)/(Two-Two*EX1/EX2)
    CLR = -EX1/(X1+X2-Two*BLR)
    ALR = (VLIM-Y1)*exp(CLR*(X1-BLR)**2)
    write(u6,614) X2,VLIM,ALR,CLR,BLR
    if (CLR < Zero) then
      ! ... but replace it by an inverse power of exponent constant negative
      write(u6,612)
      ILR = 1
    end if
  end if
  if (ILR /= 1) YY(MBEG:NPP) = VLIM-ALR*exp(-CLR*(XX(MBEG:NPP)-BLR)**2)
else if (ILR == 0) then
  ! For ILR <= 0  use  Y = VLIM - ALR * X**p * exp(-CLR*X)
  if (LNPT > 0) then
    EX1 = log((VLIM-Y1)/(VLIM-Y2))/(X1-X2)
    EX2 = log((VLIM-Y2)/(VLIM-Y3))/(X2-X3)
    DX1 = log(X1/X2)/(X1-X2)
    DX2 = log(X2/X3)/(X2-X3)
    BLR = (EX1-EX2)/(DX1-DX2)
    CLR = BLR*DX1-EX1
    ALR = (VLIM-Y1)*exp(CLR*X1)/X1**BLR
    write(u6,616) X2,VLIM,ALR,BLR,CLR
    if (CLR < Zero) then
      ! ... but replace it by an inverse power of exponent constant negative
      write(u6,612)
      ILR = 1
    end if
  end if
  if (ILR /= 1) YY(MBEG:NPP) = VLIM-ALR*XX(MBEG:NPP)**BLR*exp(-CLR*XX(MBEG:NPP))
end if
if (ILR == 1) then
  ! For  ILR=1 ,  use     Y = VLIM + ALR/X**BLR
  if (LNPT > 0) then
    BLR = log((VLIM-Y2)/(VLIM-Y1))/log(X1/X2)
    ALR = (Y1-VLIM)*X1**BLR
    NCN = nint(BLR)
    write(u6,618) X2,VLIM,ALR,BLR,NCN
  end if
  YY(MBEG:NPP) = VLIM+ALR/XX(MBEG:NPP)**BLR
else
  ! Set constants for long-range extrapolation
  IFXCN = 0
  if ((CNN > Zero) .or. (CNN < Zero)) IFXCN = 1
  NCN2 = NCN+2
  select case (ILR)
    case (2)
      ! For ILR=2 ,  use   Y = VLIM - CNN/X**NCN - BSR/X**(NCN+2)
      ! If CNN held fixed need ILR > 2  to prevent discontinuity
      if (LNPT > 0) then
        if (IFXCN <= 0) CNN = ((VLIM-Y1)*X1**NCN2-(VLIM-Y2)*X2**NCN2)/(X1**2-X2**2)
        ALR = CNN
        BLR = (VLIM-Y1)*X1**NCN2-CNN*X1**2
        write(u6,620) X2,VLIM,CNN,NCN,BLR,NCN2
      end if
      YY(MBEG:NPP) = VLIM-(ALR+BLR/XX(MBEG:NPP)**2)/XX(MBEG:NPP)**NCN
    case (3)
      ! For ILR=3 , use   Y = VLIM - (CN + CN2/X**2 + CN4/X**4)/X**NCN
      if (LNPT > 0) then
        NCN4 = NCN+4
        if (IFXCN > 0) then
          ALR = CNN
          BLR = (((VLIM-Y1)*X1**NCN-ALR)*X1**4-((VLIM-Y2)*X2**NCN-ALR)*X2**4)/(X1**2-X2**2)
          CLR = ((VLIM-Y1)*X1**NCN-ALR-BLR/X1**2)*X1**4
        else
          EX1 = X1**2
          EX2 = X2**2
          EX3 = X3**2
          DX1 = (VLIM-Y1)*X1**NCN4
          DX2 = (VLIM-Y2)*X2**NCN4
          DX3 = (VLIM-Y3)*X3**NCN4
          BLR = (DX1-DX2)/(EX1-EX2)
          ALR = (BLR-(DX2-DX3)/(EX2-EX3))/(EX1-EX3)
          BLR = BLR-ALR*(EX1+EX2)
          CLR = DX1-(ALR*EX1+BLR)*EX1
        end if
        write(u6,622) X2,VLIM,ALR,NCN,BLR,NCN2,CLR,NCN4
      end if
      YY(MBEG:NPP) = VLIM-(ALR+(BLR/XX(MBEG:NPP)**2+CLR/XX(MBEG:NPP)**4))/XX(MBEG:NPP)**NCN
    case (4)
      ! For ILR >= 4,   Y = VLIM-SUM(BB(K)/X**K) , (K=NCN,NMX=NCN+ILR-1)
      if (LNPT > 0) then
        if (NCN <= 0) NCN = 1
        IMX1 = ILR-1
        NMX = NCN+IMX1
        JR2 = 0
        if (IR2 > 0) JR2 = 2
        IDER = 0
        JMAX = ILR
        if (IFXCN > 0) JMAX = IMX1
        write(u6,624) X2,ILR,NCN,VLIM
        if (IFXCN > 0) write(u6,626) NCN,CNN
      end if
      ! Actually extrapolate with polynomial fitted to the last JMAX
      ! values of  (VLIM - YI(I))*XI(I)**NMX  , & then convert back to  YY(I).
      if (MBEG <= NPP) then
        J = NTP-JMAX
        do I=1,JMAX
          J = J+1
          XJ(I) = XI(J)
          YJ(I) = (VLIM-YI(J)/XI(J)**JR2)*XI(J)**NMX
          if (IFXCN > 0) YJ(I) = YJ(I)-CNN*XI(J)**IMX1
        end do
        do I=MBEG,NPP
          call PLYINTRP(XJ,YJ,JMAX,XX(I),DUMM,JMAX,IDER)
          YY(I) = DUMM(1)
          if (IFXCN > 0) YY(I) = YY(I)+CNN*XX(I)**IMX1
          YY(I) = VLIM-YY(I)/XX(I)**NMX
        end do
      end if
  end select
end if
! Finished extrapolation section.

! Test smoothness at outer join to analytic extrapolation function
!if ((LNPT > 0) .and. (MBEG <= NPP)) then
!  MST = MBEG-5
!  IF (MST < 1) MST = 1
!  MFN = MST+8
!  if (MFN > NPP) MFN = NPP
!  write(u6,627) X2,((XX(I),YY(I),I=J,MFN,3),J=MST,MST+2)
!  627 format('     Verify smoothness of outer join at   X=',F9.5/(3X,3(F10.5,G15.7)))
!end if

return

612 format('  *** BUT *** since exponent has positive coefficient, switch form ...')
614 format(' Function for  X >=',F8.4,'   generated as'/'   Y=',F12.4,' - (',ES13.6,') * exp{-',F10.6,' * (r -',F9.6,')**2}')
616 format(' Function for  X >=',F8.4,'   generated as'/'   Y=',F12.4,' - (',ES13.6,') * r**',F10.6,'  * exp{-(',F11.6,'*r)}')
618 format(' Extrapolate to  X >=',F8.4,'  using'/'   Y=',F12.4,SP,ES15.6,'/X**(',SS,ES13.6,')] ,  yielding   NCN=',I3)
620 format(' Extrapolate to  X >=',F8.4,'  using'/'   Y=',F12.4,' - [',ES13.6,'/X**',I1,SP,ES14.6,'/X**',SS,I1,']')
622 format(' Extrapolate to  X >=',F8.4,'  using'/'   Y=',F12.4,' - [',ES13.6,'/X**',I1,SP,ES14.6,'/X**',SS,I1,SP,ES14.6,'/X**', &
           SS,I2,']')
624 format(' Function for  X >=',F7.3,'  generated by',I3,'-point inverse-power interpolation'/'   with leading term  1/r**',I1, &
           '  relative to dissociation limit   YLIM=',F11.3)
626 format('   and (dimensionless) leading coefficient fixed as   C',I1,'=',G15.8)

end subroutine GENINT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#ifdef _HDF5_

      subroutine one2h5_ovlmat(fileid, nsym, nbas)
*     IFG: read atomic overlap matrix from the 1-electron integral file
*     and write it to the HDF5 file specified with fileid.
*     This routine does nothing if HDF5 is not supported.
*
*     Datasets:
*       AO_OVERLAP_MATRIX

      implicit none
      integer :: fileid
      integer :: nsym, nbas(*)
#  include "Molcas.fh"
#  include "stdalloc.fh"
#  include "mh5.fh"

      integer :: isym
      integer :: nb, nbast, nbast1, nbast2

      real*8, allocatable :: SAO(:), Scr(:)

      integer :: iRc, iOpt, iComp, iSyLbl
      character(len=8) :: Label

      integer :: iOff1, iOff2

      integer :: dsetid

      nbast=0
      nbast1=0
      nbast2=0
      do isym=1,nsym
        nb=nbas(isym)
        nbast=nbast+nb
        nbast1=nbast1+(nb*(nb+1))/2
        nbast2=nbast2+nb**2
      end do

*     atomic orbital overlap matrix
      dsetid = mh5_create_dset_real(fileid,
     $        'AO_OVERLAP_MATRIX', 1, [NBAST2])
      call mh5_init_attr(dsetid, 'description',
     $        'Overlap matrix of the atomic orbitals, '//
     $        'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')

      call mma_allocate(SAO,NBAST1)
      iRc=-1
      iOpt=6
      iComp=1
      iSyLbl=1
      Label='Mltpl  0'
      Call RdOne(iRc,iOpt,Label,iComp,SAO,iSyLbl)
      iOff1 = 0
      iOff2 = 0
      Do iSym = 1,nSym
        nB = nBas(iSym)
        If ( nb.gt.0 ) then
          call mma_allocate(scr,nb*nb)
          Call Square(SAO(1+iOff1),Scr,1,nb,nb)
          call mh5_put_dset(dsetid,
     $            Scr,[nb*nb],[iOff2])
          call mma_deallocate(scr)
        end if
        iOff1 = iOff1 + (nb*nb+nb)/2
        iOff2 = iOff2 + (nb*nb)
      end do
      call mma_deallocate(SAO)

      call mh5_close_dset(dsetid)

      end

      subroutine one2h5_fckint(fileid, nsym, nbas)
*     IFG: read atomic Fock matrix from the 1-electron integral file
*     and write it to the HDF5 file specified with fileid.
*     This routine does nothing if HDF5 is not supported.
*
*     Datasets:
*       AO_FOCKINT_MATRIX

      implicit none
      integer :: fileid
      integer :: nsym, nbas(*)
#  include "Molcas.fh"
#  include "stdalloc.fh"
#  include "mh5.fh"

      integer :: isym
      integer :: nb, nbast, nbast1, nbast2

      real*8, allocatable :: SAO(:), Scr(:)

      integer :: iRc, iOpt, iComp, iSyLbl
      character(len=8) :: Label

      integer :: iOff1, iOff2

      integer :: dsetid

      nbast=0
      nbast1=0
      nbast2=0
      do isym=1,nsym
        nb=nbas(isym)
        nbast=nbast+nb
        nbast1=nbast1+(nb*(nb+1))/2
        nbast2=nbast2+nb**2
      end do

*     atomic orbital Fock matrix
      dsetid = mh5_create_dset_real(fileid,
     $        'AO_FOCKINT_MATRIX', 1, [NBAST2])
      call mh5_init_attr(dsetid, 'description',
     $        'Fock matrix of the atomic orbitals, '//
     $        'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')

      call mma_allocate(SAO,NBAST1)
      iRc=-1
      iOpt=6
      iComp=1
      iSyLbl=1
      Label='FckInt  '
      Call RdOne(iRc,iOpt,Label,iComp,SAO,iSyLbl)
      iOff1 = 0
      iOff2 = 0
      Do iSym = 1,nSym
        nB = nBas(iSym)
        If ( nb.gt.0 ) then
          call mma_allocate(scr,nb*nb)
          Call Square(SAO(1+iOff1),Scr,1,nb,nb)
          call mh5_put_dset(dsetid,
     $            Scr,[nb*nb],[iOff2])
          call mma_deallocate(scr)
        end if
        iOff1 = iOff1 + (nb*nb+nb)/2
        iOff2 = iOff2 + (nb*nb)
      end do
      call mma_deallocate(SAO)

      call mh5_close_dset(dsetid)

      end

      subroutine one2h5_crtmom(fileid, nsym, nbas)
*     SVC: read cartesian moments from the 1-electron integral file
*     and write it to the HDF5 file specified with fileid.
*     This routine does nothing if HDF5 is not supported.
*     FP: also include the origins used for the operators
*
*     Datasets:
*       MLTPL_X, MLTPL_Y, MLTPL_Z
*       MLTPL_XX, MLTPL_YY, MLTPL_ZZ, MLTPL_XY, MLTPL_YZ, MLTPL_XZ
*       MLTPL_ORIG

      implicit none
      integer :: fileid
      integer :: nsym, nbas(*)
#  include "Molcas.fh"
#  include "stdalloc.fh"
#  include "mh5.fh"

      integer :: isym, jsym, msym
      integer :: nb, nbast, nB1, nB2

      real*8, allocatable :: MLTPL(:,:), Scratch(:)
      real*8, dimension(3,3) :: mp_orig

      integer :: iRc, iOpt, iComp, iSyMsk
      character(len=8) :: Label

      character(len=1)::mltpl1_comp(3) = ['X','Y','Z']
      character(len=2)::mltpl2_comp(6) = ['XX','XY','XZ','YY','YZ','ZZ']

      integer :: i, j, iOff, jOff, iScrOff, iBas, jBas

      integer :: dsetid

      integer, external :: symmetry

      nbast=0
      do isym=1,nsym
        nb=nbas(isym)
        nbast=nbast+nb
      end do

      mp_orig(:,:) = 0.

      call mma_allocate(MLTPL,NBAST,NBAST)
      call mma_allocate(Scratch,NBAST**2+3)

      do icomp=1,3
      MLTPL=0.0D0
      iRc=-1
      iOpt=4
      iSyMsk=0
      Label='Mltpl  1'
      Call RdOne(iRc,iOpt,Label,iComp,Scratch,iSyMsk)
* iSyMsk tells us which symmetry combination is valid
      iScrOff = 0
      iOff = 0
      Do iSym = 1,nSym
        jOff = 0
        nB1 = nBas(iSym)
        Do jSym = 1,iSym
          mSym = symmetry(iSym,jSym)
          nB2 = nBas(jSym)
          If (IAND(2**(mSym-1),iSyMsk).ne.0) Then
            If (iSym.eq.jSym) Then
              Do j=1,nB2
                jBas = jOff + j
                Do i=1,j
                  iBas = iOff + i
                  MLTPL(iBas,jBas) = Scratch(1+iScrOff)
                  iScrOff = iScrOff + 1
                End Do
              End Do
            Else
              Do j=1,nB2
                jBas = jOff + j
                Do i=1,nB1
                  iBas = iOff + i
                  MLTPL(iBas,jBas) = Scratch(1+iScrOff)
                  iScrOff = iScrOff + 1
                End Do
              End Do
            End If
          End If
          jOff = jOff + nB2
        End Do
        iOff = iOff + nB1
      End Do
      Do j=1,nBasT
        Do i=1,j-1
          MLTPL(j,i)=MLTPL(i,j)
        End Do
      End Do
      dsetid = mh5_create_dset_real(fileid,
     $        'AO_MLTPL_'//mltpl1_comp(icomp), 2, [NBAST,NBAST])
      call mh5_init_attr(dsetid, 'description',
     $        '1st-order multipole matrix of the atomic orbitals, '//
     $        'arranged as matrix of size [NBAST,NBAST]')
      call mh5_put_dset_array_real(dsetid,MLTPL)
      call mh5_close_dset(dsetid)
      end do

      mp_orig(1:3,2) = Scratch(iScrOff+1:iScrOff+3)

      do icomp=1,6
      MLTPL=0.0D0
      iRc=-1
      iOpt=4
      iSyMsk=0
      Label='Mltpl  2'
      Call RdOne(iRc,iOpt,Label,iComp,Scratch,iSyMsk)
* iSyMsk tells us which symmetry combination is valid
      iScrOff = 0
      iOff = 0
      Do iSym = 1,nSym
        jOff = 0
        nB1 = nBas(iSym)
        Do jSym = 1,iSym
          mSym = symmetry(iSym,jSym)
          nB2 = nBas(jSym)
          If (IAND(2**(mSym-1),iSyMsk).ne.0) Then
            If (iSym.eq.jSym) Then
              Do j=1,nB2
                jBas = jOff + j
                Do i=1,j
                  iBas = iOff + i
                  MLTPL(iBas,jBas) = Scratch(1+iScrOff)
                  iScrOff = iScrOff + 1
                End Do
              End Do
            Else
              Do j=1,nB2
                jBas = jOff + j
                Do i=1,nB1
                  iBas = iOff + i
                  MLTPL(iBas,jBas) = Scratch(1+iScrOff)
                  iScrOff = iScrOff + 1
                End Do
              End Do
            End If
          End If
          jOff = jOff + nB2
        End Do
        iOff = iOff + nB1
      End Do
      Do j=1,nBasT
        Do i=1,j-1
          MLTPL(j,i)=MLTPL(i,j)
        End Do
      End Do
      dsetid = mh5_create_dset_real(fileid,
     $        'AO_MLTPL_'//mltpl2_comp(icomp), 2, [NBAST,NBAST])
      call mh5_init_attr(dsetid, 'description',
     $        '2nd-order multipole matrix of the atomic orbitals, '//
     $        'arranged as matrix of size [NBAST,NBAST]')
      call mh5_put_dset_array_real(dsetid,MLTPL)
      call mh5_close_dset(dsetid)
      end do

      mp_orig(1:3,3) = Scratch(iScrOff+1:iScrOff+3)

      call mma_deallocate(MLTPL)
      call mma_deallocate(Scratch)

      dsetid = mh5_create_dset_real(fileid,
     $        'MLTPL_ORIG', 2, [3,3])
      call mh5_init_attr(dsetid, 'description',
     $        'Origin used for the multipole moment operators: '//
     $        'arranged as overlap, dipole, quadrupole')
      call mh5_put_dset_array_real(dsetid,mp_orig,[3,3],[0,0])
      call mh5_close_dset(dsetid)

      end

#elif defined (NAGFOR)
c Some compilers do not like empty files
      Subroutine empty_one2h5_ovlmat()
      End
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine DMinvCI(ipSigma,rout,rC_HE_C,idsym)
      use Exp, only: NewPre
      use ipPage, only: W
      use negpre
      Implicit Real*8(a-h,o-z)

#include "real.fh"
#include "Input.fh"
#include "Pointers.fh"
#include "incdia.fh"

      Real*8 rout(*)
      integer opout
*
*                                    -1           -1
*                               (H -E) |0><0|(H -E)|Sigma>
*                  -1             0            0
*     |rNew>=(H - E) |Sigma> - ----------------------------
*              0                               -1
*                                      <0|(H -E) |0>
*                                           0
*
      If (nconf1.gt.1) Then

         irc=ipin(ipdia)
         irc=ipin(ipSigma)
         Call exphinvv(W(ipdia)%Vec,W(ipsigma)%Vec,rout,Zero,One)
         irc=ipout(ipsigma)
         irc=opout(ipdia)
*
*        OBS <0|(H-E)|Sigma>=0 if idsym=/=1

         If (NewPre.and.idsym.eq.1) Then
*                    -1
*           rcoeff=<0|(H -E) |Sigma>
*                       0
*                 -------------------
*                            -1
*                    <0|(H -E) |0>
*                         0
*
            If (.not.ngp) Then
               irc=ipin(ipCI)
               rcoeff=ddot_(nconf1,rout,1,W(ipCI)%Vec,1)/rC_HE_C
*
*                                     -1
*              rout=rout-rocoeff*(H -E) |0>
*                                  0
               irc=ipin(ipdia)
               Call exphinvv(W(ipdia)%Vec,W(ipci)%Vec,rOUT,One,-rcoeff)
               irc=opout(ipCI)
            Else
               Call NEGP(ipdia,ipSigma,rout)
            End If

         End If

         Call DSCAL_(nconf1,Half,rout,1)

      Else

         irc=ipin(ipsigma)
         rout(1:nConf1)=W(ipSigma)%Vec(:)

      End if

      return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine CHO_SUBTR1(XINT,WRK,LWRK,ISYM,FXDMEM)
!
! Purpose: subtract contributions from previous vectors
!          from the qualified integrals (in XINT).
!          This version is I/O-driven.
!
! Screening in subtraction introduced Jan. 2006, TBP.

use Cholesky, only: Cho_SScreen, DSPNm, DSubScr, iiBstR, iiBstRSh, INF_SUBTR1, InfVec, IPRINT, iQuAB, iScr, LQ, LuPri, MaxQual, &
                    N1_Qual, N2_Qual, N1_VecRd, N2_VecRd, N_Subtr, nDGM_call, nnBstR, nnBstRSh, nnShl, nQual, nSys_call, NumCho, &
                    nVec_in_Buf, SSNorm, SSTau, SubScrStat, TDECOM
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LWRK, ISYM
real(kind=wp), intent(inout) :: XINT(*), WRK(LWRK)
logical(kind=iwp) :: FXDMEM
integer(kind=iwp) :: IAB, IBATCH, ILOC, IMAPC, IOFF(0:1), IREDC, ISHGD, IVEC1, IVEC1_1, IVSTAT(2,2), J, JAB, JRED, JRED1, JRED2, &
                     JVEC1, JVEC2, KCHO1, KCHO2, KEND0, KEND1, KEND2, KJUNK, KOFB0, KOFF1, KOFF2, KOFF3, KOFFA, KOFFB, KREAD, &
                     KVEC, KVEC1, LEFT, LNUM, LREAD, LRED, LVEC, LVEC1, LWRK0, LWRK1, LWRK2, MINLFT, MMEM, MUSED, MUST, NBATCH, &
                     NGD, NUMBAT, NUMRD, NUMSMN, NUMSUB, NUMV, NVEC, NVEC_TO_READ, NVRD
real(kind=wp) :: C1, C2, SCRPCT, TIMLOC(2,3), TST, W1, W2, X1, X2, XAVERD, XAVEVC, XDON, XM, XREAD, XTOT
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_SUBTR1'
integer(kind=iwp), external :: CHO_X_NUMRD

! Return if nothing to do.
! ------------------------

if (NUMCHO(ISYM) < 1) return

NVEC_TO_READ = NUMCHO(ISYM)-NVEC_IN_BUF(ISYM)
if (NVEC_TO_READ == 0) return
if (NVEC_TO_READ < 0) call CHO_QUIT('Vector buffer error in '//SECNAM,104)

! Allocate "junk yard".
! ---------------------

KJUNK = 1
KEND0 = KJUNK+1
LWRK0 = LWRK-KEND0+1

MUST = NNBSTR(ISYM,1)+NNBSTR(ISYM,2)+NQUAL(ISYM)
if (LWRK0 < MUST) then
  write(LUPRI,*)
  write(LUPRI,*)
  write(LUPRI,*) SECNAM,': insufficient memory:'
  write(LUPRI,*) 'Need at least: ',MUST+KEND0-1
  write(LUPRI,*) 'Available    : ',LWRK
  write(LUPRI,*) '(A significant increase of memory is needed for efficient execution.)'
  write(LUPRI,*)
  write(LUPRI,*) 'Memory available in ',SECNAM,' may also be increased by reducing:'
  write(LUPRI,*) '1) max. #qualified per symmetry, currently: ',MAXQUAL,'   to less than than ',NQUAL(ISYM)
  write(LUPRI,*) '2) max. memory fraction used by qualified,  currently: ',N1_QUAL,'/',N2_QUAL
  call CHO_QUIT('Insufficient memory in '//SECNAM//' [0]',101)
end if

WRK(KJUNK) = Zero
IOFF(0) = KJUNK

! Split memory for subtraction of previous vectors:
! {Read buffer},{L(cd,#J),L({ab},#J)}
! Initially, the fraction N1_VECRD/N2_VECRD of total memory is
! reserved for reading. Then, the split aims at
!          1<=#J<=MAX(NQUAL(ISYM),N_SUBTR)
! I.e., the number of vectors in the read buffer is at least #J.
! Obviously, if MAX(NQUAL(ISYM),N_SUBTR) > NVEC_TO_READ then
! 1<=#J<=NVEC_TO_READ. (Keeping #J within bounds is the role of
! NUMSMN).
! N1_VECRD, N2_VECRD, and N_SUBTR can be user-defined (input)
! and should have been checked as part of configuration check
! (CHO_CHKCONF) during initialization.
! --------------------------------------------------------------

KREAD = KEND0 ! pointer to read buffer
IREDC = -1    ! id of red. set index array at location 3

X1 = real(N1_VECRD,kind=wp)
X2 = real(N2_VECRD,kind=wp)
XM = real(LWRK0,kind=wp)
XREAD = XM*X1/X2  ! initial guess for buffer size (from input)
LREAD = int(XREAD)
LEFT = LWRK0-LREAD
MINLFT = NNBSTR(ISYM,2)+NQUAL(ISYM)

if (FXDMEM) then ! fixed-size read buffer

  if (LEFT < MINLFT) then
    LEFT = MINLFT
    LREAD = LWRK0-LEFT
  end if

else ! attempt to optimize the split

  NUMSMN = min(max(NQUAL(ISYM),N_SUBTR),NVEC_TO_READ)
  NUMSUB = max(min(NUMSMN,LEFT/MINLFT),1) ! 1<=NUMSUB<=NUMSMN
  LREAD = LWRK0-NUMSUB*MINLFT

  NUMRD = CHO_X_NUMRD(1,ISYM,IREDC,LREAD) ! # that can be read
  if (NUMRD < 0) call CHO_QUIT('NUMRD error in '//SECNAM,104)
  do while (NUMRD < NUMSUB) ! reduce NUMSUB until NUMRD=NUMSUB
    NUMSUB = NUMSUB-1
    if (NUMSUB < 1) call CHO_QUIT('Insufficient memory for split in '//SECNAM,101) ! should never occur (checked above)
    LREAD = LWRK0-NUMSUB*MINLFT
    NUMRD = CHO_X_NUMRD(1,ISYM,IREDC,LREAD)
    if (NUMRD < 0) call CHO_QUIT('NUMRD error in '//SECNAM,104)
  end do

end if

! Initializations.
! ----------------

NUMRD = 0
NUMBAT = 0
XTOT = Zero
XDON = Zero
IVSTAT(:,:) = 0
TIMLOC(:,:) = 0

! Start buffer batch loop.
! ------------------------

IVEC1 = NVEC_IN_BUF(ISYM)+1
IMAPC = -1
do while (IVEC1 <= NUMCHO(ISYM))

  ! Read as many vectors as possible into buffer.
  ! ---------------------------------------------

  call CWTIME(C1,W1)
  NVRD = 0
  MUSED = 0
  call CHO_VECRD(WRK(KREAD),LREAD,IVEC1,NUMCHO(ISYM),ISYM,NVRD,IREDC,MUSED)
  NUMRD = NUMRD+1
  call CWTIME(C2,W2)
  TIMLOC(1,1) = TIMLOC(1,1)+C2-C1
  TIMLOC(2,1) = TIMLOC(2,1)+W2-W1

  ! Quit if no vectors were read.
  ! -----------------------------

  if (NVRD < 1) call CHO_QUIT('Insufficient scratch space for read in '//SECNAM,101)

  ! Compute memory available for subtraction batching.
  ! --------------------------------------------------

  KEND1 = KREAD+MUSED
  LWRK1 = LWRK-KEND1+1

  if (LWRK1 < 1) call CHO_QUIT('Insufficient memory in '//SECNAM//' [1]',101)

  ! Set up batch.
  ! -------------

  MMEM = NNBSTR(ISYM,2)+NQUAL(ISYM)
  if (MMEM < 1) then
    call CHO_QUIT('Batch setup corrupted in '//SECNAM,104)
    NVEC = -999999
  else
    NVEC = min(LWRK1/MMEM,NVRD)
  end if
  if (NVEC < 1) then
    call CHO_QUIT('Batch failure in '//SECNAM,101)
    NBATCH = -999999
  else
    NBATCH = (NVRD-1)/NVEC+1
  end if

  ! Set local statistics info.
  ! --------------------------

  NUMBAT = NUMBAT+NBATCH
  if (NUMRD == 1) then
    IVSTAT(:,1) = NVRD
    IVSTAT(:,2) = NVEC
  else
    IVSTAT(1,1) = min(IVSTAT(1,1),NVRD)
    IVSTAT(2,1) = max(IVSTAT(2,1),NVRD)
    IVSTAT(1,2) = min(IVSTAT(1,2),NVEC)
    IVSTAT(2,2) = max(IVSTAT(2,2),NVEC)
  end if

  ! Start batch loop.
  ! -----------------

  IOFF(1) = KREAD-1
  do IBATCH=1,NBATCH

    if (IBATCH == NBATCH) then
      NUMV = NVRD-NVEC*(NBATCH-1)
    else
      NUMV = NVEC
    end if
    IVEC1_1 = IVEC1+NVEC*(IBATCH-1)

    ! Set memory pointers for this batch.
    ! -----------------------------------

    KCHO1 = KEND1
    KCHO2 = KCHO1+NNBSTR(ISYM,2)*NUMV
    KEND2 = KCHO2+NQUAL(ISYM)*NUMV
    LWRK2 = LWRK-KEND2+1
    if (LWRK2 < 0) call CHO_QUIT('Batch error in '//SECNAM,104)

    ! Get the next NUMV vectors sorted according to current
    ! reduced set (originally, this section was part of the
    ! I/O; hence, it is timed as if it was I/O for
    ! compatibility).
    ! -----------------------------------------------------

    call CWTIME(C1,W1)

    JVEC1 = NVEC*(IBATCH-1)+1
    JVEC2 = JVEC1+NUMV-1
    JRED1 = INFVEC(IVEC1+JVEC1-1,2,ISYM)
    JRED2 = INFVEC(IVEC1+JVEC2-1,2,ISYM)
    LVEC1 = JVEC1
    KVEC1 = 1
    do JRED=JRED1,JRED2

      LNUM = 0
      LVEC = LVEC1-1
      do while (LVEC < JVEC2)
        LVEC = LVEC+1
        LRED = INFVEC(IVEC1+LVEC-1,2,ISYM)
        if (LRED == JRED) then
          LNUM = LNUM+1
        else
          LVEC = JVEC2
        end if
      end do

      if (LNUM > 0) then

        if (JRED /= IREDC) then
          ILOC = 3
          call CHO_GETRED(JRED,ILOC,.false.)
          call CHO_SETREDIND(ILOC)
          IREDC = JRED
        end if

        if (JRED /= IMAPC) then
          call CHO_RS2RS(ISCR,size(ISCR),2,3,JRED,ISYM)
          IMAPC = JRED
        end if

        do LVEC=1,LNUM
          KVEC = KVEC1+LVEC-1
          do IAB=1,NNBSTR(ISYM,2)
            KOFF1 = KCHO1+NNBSTR(ISYM,2)*(KVEC-1)+IAB-1
            KOFF2 = IOFF(min(ISCR(IAB),1))+ISCR(IAB)
            WRK(KOFF1) = WRK(KOFF2)
          end do
          IOFF(1) = IOFF(1)+NNBSTR(ISYM,3)
        end do

        LVEC1 = LVEC1+LNUM
        KVEC1 = KVEC1+LNUM

      end if

    end do

    call CWTIME(C2,W2)
    TIMLOC(1,2) = TIMLOC(1,2)+C2-C1
    TIMLOC(2,2) = TIMLOC(2,2)+W2-W1

    ! Screened or unscreened subtraction section.
    ! The screened version uses level 2 blas, while the unscreened
    ! one employs level 3 blas.
    ! ------------------------------------------------------------

    call CWTIME(C1,W1)

    if (CHO_SSCREEN) then ! screened subtraction

      ! Copy out sub-blocks corresponding to qualified diagonals:
      ! L(#J,{ab})
      ! ---------------------------------------------------------

      KOFB0 = KCHO1-1-IIBSTR(ISYM,2)
      do J=1,NUMV
        KOFFA = KCHO2+J-1
        KOFFB = KOFB0+NNBSTR(ISYM,2)*(J-1)
        do IAB=1,NQUAL(ISYM)
          WRK(KOFFA+NUMV*(IAB-1)) = WRK(KOFFB+IQUAB(IAB,ISYM))
        end do
      end do

      ! Subtract:
      ! (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L(#J,{ab})
      ! for each ab in {ab}.
      ! ----------------------------------------------------

      call CHO_SUBSCR_DIA(WRK(KCHO1),NUMV,ISYM,2,SSNORM)
      do IAB=1,NQUAL(ISYM)
        do ISHGD=1,NNSHL
          NGD = NNBSTRSH(ISYM,ISHGD,2)
          if (NGD > 0) then
            XTOT = XTOT+One
            JAB = IQUAB(IAB,ISYM)-IIBSTR(ISYM,2)
            TST = sqrt(DSPNM(ISHGD)*DSUBSCR(JAB))
            if (TST > SSTAU) then
              XDON = XDON+One
              KOFF1 = KCHO1+IIBSTRSH(ISYM,ISHGD,2)
              KOFF2 = KCHO2+NUMV*(IAB-1)
              KOFF3 = NNBSTR(ISYM,2)*(IAB-1)+IIBSTRSH(ISYM,ISHGD,2)+1
              call DGEMV_('N',NGD,NUMV,-One,WRK(KOFF1),NNBSTR(ISYM,2),WRK(KOFF2),1,One,XINT(KOFF3),1)
            end if
          end if
        end do
      end do

    else ! unscreened subtraction

      if (associated(LQ(ISYM)%A)) then

        ! If the qualified block, L({ab},#J), is already in
        ! core, use this block.
        ! -------------------------------------------------

        call DGEMM_('N','T',NNBSTR(ISYM,2),NQUAL(ISYM),NUMV,-One,WRK(KCHO1),NNBSTR(ISYM,2),LQ(ISYM)%A(:,IVEC1_1), &
                    size(LQ(ISYM)%A,1),One,XINT,NNBSTR(ISYM,2))

      else

        ! Copy out sub-blocks corresponding to qualified
        ! diagonals: L({ab},#J)
        ! ----------------------------------------------

        KOFB0 = KCHO1-1-IIBSTR(ISYM,2)
        do J=1,NUMV
          KOFFA = KCHO2+NQUAL(ISYM)*(J-1)-1
          KOFFB = KOFB0+NNBSTR(ISYM,2)*(J-1)
          do IAB=1,NQUAL(ISYM)
            WRK(KOFFA+IAB) = WRK(KOFFB+IQUAB(IAB,ISYM))
          end do
        end do

        ! Subtract:
        ! (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L({ab},#J)
        ! ----------------------------------------------------

        call DGEMM_('N','T',NNBSTR(ISYM,2),NQUAL(ISYM),NUMV,-One,WRK(KCHO1),NNBSTR(ISYM,2),WRK(KCHO2),NQUAL(ISYM),One,XINT, &
                    NNBSTR(ISYM,2))

      end if

    end if

    call CWTIME(C2,W2)
    TIMLOC(1,3) = TIMLOC(1,3)+C2-C1
    TIMLOC(2,3) = TIMLOC(2,3)+W2-W1

  end do

  ! Update counter.
  ! ---------------

  IVEC1 = IVEC1+NVRD

end do

! Update global statistics info.
! ------------------------------

NSYS_CALL = NSYS_CALL+NUMRD
NDGM_CALL = NDGM_CALL+NUMBAT
TDECOM(1,2) = TDECOM(1,2)+TIMLOC(1,1)+TIMLOC(1,2)
TDECOM(2,2) = TDECOM(2,2)+TIMLOC(2,1)+TIMLOC(2,2)
TDECOM(1,3) = TDECOM(1,3)+TIMLOC(1,3)
TDECOM(2,3) = TDECOM(2,3)+TIMLOC(2,3)
if (CHO_SSCREEN) then
  SUBSCRSTAT(1) = SUBSCRSTAT(1)+XTOT
  SUBSCRSTAT(2) = SUBSCRSTAT(2)+XDON
end if

! Print statistics.
! -----------------

if (LOCDBG .or. (IPRINT >= INF_SUBTR1)) then
  if (NUMRD == 0) then
    XAVERD = -9.99999e5_wp
  else
    XAVERD = real(NUMCHO(ISYM),kind=wp)/real(NUMRD,kind=wp)
  end if
  if (NUMBAT == 0) then
    XAVEVC = -9.99999e5_wp
  else
    XAVEVC = real(NUMCHO(ISYM),kind=wp)/real(NUMBAT,kind=wp)
  end if
  write(LUPRI,'(A)') '*****'
  write(LUPRI,'(A,A,I2,A)') SECNAM,' statistics, symmetry',ISYM,':'
  write(LUPRI,'(A,I12)') 'Number of previous vectors                           : ',NUMCHO(ISYM)
  write(LUPRI,'(A,I12)') 'Number of vectors in buffer                          : ',NVEC_IN_BUF(ISYM)
  write(LUPRI,'(A,I12)') 'Memory available for subtraction of previous vectors : ',LWRK
  write(LUPRI,'(A,I12)') 'Memory reserved for buffered vector read             : ',LREAD
  write(LUPRI,'(A,I12)') 'Number of batches needed for reading vectors         : ',NUMRD
  if (CHO_SSCREEN) then
    write(LUPRI,'(A,F12.2)') 'Number of calls to DGEMV                             : ',XDON
    write(LUPRI,'(A,ES12.2)') 'Screening threshold                                  : ',SSTAU
    if (XTOT > Zero) then
      SCRPCT = 1.0e2_wp*(XTOT-XDON)/XTOT
    else
      SCRPCT = 1.0e15_wp
    end if
    write(LUPRI,'(A,F12.2,A)') 'Screening percent                                    : ',SCRPCT,'%'
  else
    write(LUPRI,'(A,I12)') 'Number of calls to DGEMM                             : ',NUMBAT
  end if
  write(LUPRI,'(A,I12,I12,F12.2)') 'Minimum, maximum, and average #vectors read          : ',IVSTAT(1,1),IVSTAT(2,1),XAVERD
  write(LUPRI,'(A,I12,I12,F12.2)') 'Minimum, maximum, and average #vecs per call to BLAS : ',IVSTAT(1,2),IVSTAT(2,2),XAVEVC
  write(LUPRI,'(A,2F12.2)') 'Time for reading vectors into buffer (CPU/Wall; sec.): ',TIMLOC(1,1),TIMLOC(2,1)
  write(LUPRI,'(A,2F12.2)') 'Time for reduced set vector reorder  (CPU/Wall; sec.): ',TIMLOC(1,2),TIMLOC(2,2)
  write(LUPRI,'(A,2F12.2)') 'Time for qual. copy + subtraction    (CPU/Wall; sec.): ',TIMLOC(1,3),TIMLOC(2,3)
  write(LUPRI,'(A)') '*****'
end if

end subroutine CHO_SUBTR1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_InpMod(Mode)
C
C     Thomas Bondo Pedersen, Jan. 2005.
C
C     Purpose: modifiy Cholesky settings for
C              Mode = 'LOW ' : low-accuracy decomposition
C              Mode = 'MEDI' : medium-accuracy decomposition
C              Mode = 'HIGH' : high-accuracy decomposition
C              Mode = '1CCD' : set one-center approximation
C              (All other Mode-values are ignored.)
C
      Implicit None
      Character*4 Mode

      Character*4 Mod2

      Mod2 = Mode
      Call Upcase(Mod2)

      If (Mod2(1:3) .eq. 'LOW') Then
         Call Cho_SetDecompositionThreshold(1.0d-4)
      Else If (Mod2(1:4) .eq. 'MEDI') Then
         Call Cho_SetDecompositionThreshold(1.0d-6)
      Else If (Mod2(1:4) .eq. 'HIGH') Then
         Call Cho_SetDecompositionThreshold(1.0d-8)
      Else If (Mod2(1:4) .eq. '1CCD') Then
         Call Cho_Set1CCD(.True.)
      End If

      End
      Subroutine Cho_SetDecompositionThreshold(Thr)
      Implicit None
      Real*8 Thr
#include "cholesky.fh"

      ThrCom=Thr

      End
      Subroutine Cho_Set1CCD(do1CCD)
      Implicit None
      Logical do1CCD
#include "cholesky.fh"

      Cho_1Center=do1CCD

      End
      Subroutine Cho_SetSpan(val)
      Implicit None
      Real*8 val
#include "cholesky.fh"

      Span=val

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!               Thomas Bondo Pedersen                                  *
!               2026, Lila Zapp (split subroutine for initialisation)  *
!***********************************************************************

subroutine localisation_init()
use Localisation_globals, only: nSym, nOrb2Loc, nFro, nConstr, Skip, LocOrb, Thrs_UsrDef, nOrb2Loc_UsrDef, nFro_UsrDef, Freeze,&
                                Maximisation, ChoStart, LocModel, OptMeth, ChargeType, LocModel_UsrDef,Test_Localisation, &
                                NMxIter, Thrs, ThrRot, ThrGrad, Analysis, AnaAtom, AnaNrm, PrintMOs, Timing, EvalER, Order,&
                                LocPAO, AnaPAO, AnaPAO_Save, DoDomain, AnaDomain, ThrDomain, ThrPairDomain, LocNatOrb, &
                                LocCanOrb, Wave, iWave, DoCNOs
use definitions, only: iwp, wp
use constants, only: Ten

implicit none
integer(kind=iwp) :: iSym
integer(kind=iwp), parameter :: Occupied = 0
real(kind=wp), parameter :: ThrsDef=1.0e-6_wp, ThrRotDef=1.0e-10_wp, ThrGradDef=1.0e-2_wp

do iSym=1,nSym
  nOrb2Loc(iSym) = 0
  nFro(iSym) = 0
  nConstr(iSym) = 0
end do
Skip = .false.
LocOrb = Occupied
Thrs_UsrDef = .false.
nOrb2Loc_UsrDef = .false.
nFro_UsrDef = .false.
Freeze = .false.
Maximisation = .true.
ChoStart = .false.
LocModel = 1  ! Pipek-Mezey localisation
OptMeth = 1 ! PM localisation done with Jacobi Sweeps
ChargeType = 1 ! PM localisation done within the Mulliken population framework
if (nSym > 1) LocModel = 3  ! Cholesky localisation
LocModel_UsrDef = .false.
Test_Localisation = .false.
NMxIter = 300
Thrs = ThrsDef
ThrRot = ThrRotDef
ThrGrad = ThrGradDef
Analysis = .false.
AnaAtom = nSym == 1
AnaNrm = 'Fro'
PrintMOs = .true.
Timing = .true.
EvalER = .false.
Order = .false.
LocPAO = .false.
AnaPAO = .false.
AnaPAO_Save = AnaPAO
DoDomain = .false.
AnaDomain = .false.
ThrDomain(1) = 0.9_wp
ThrDomain(2) = 2.0e-2_wp
ThrPairDomain(1) = 1.0e-10_wp
ThrPairDomain(2) = Ten
ThrPairDomain(3) = 15.0_wp
LocNatOrb = .false.
LocCanOrb = .false.
Wave = .false.
iWave = 0
DoCNOs = .false.
end subroutine localisation_init

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_Vec(iVec1,nVec,Buf,lBuf,nDim,iOpt)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: write (iOpt=1) or read (iOpt=2) "new" vectors to buffer.
C
#include "implicit.fh"
      Real*8  Buf(lBuf)
#include "chomp2_dec.fh"
#include "chomp2.fh"

      Character*3  ThisNm
      Character*10 SecNam
      Parameter (SecNam = 'ChoMP2_Vec', ThisNm = 'Vec')

      Logical DoClose

      iSym = NowSym
      DoClose = .false.

      If (iOpt .eq. 1) Then

         If (lUnit_F(iSym,2) .lt. 1) Then
            Call ChoMP2_OpenF(1,2,iSym)
            DoClose = .true.
         End If

         iJob = 1
         lTot = nDim*nVec
         iAdr = nDim*(iVec1 - 1) + 1
         Call ddaFile(lUnit_F(iSym,2),iJob,Buf,lTot,iAdr)

      Else If (iOpt .eq. 2) Then

         If (lUnit_F(iSym,2) .lt. 1) Then
            Call ChoMP2_OpenF(1,2,iSym)
            DoClose = .true.
         End If

         iJob = 2
         lTot = nDim*nVec
         iAdr = nDim*(iVec1 - 1) + 1
         Call ddaFile(lUnit_F(iSym,2),iJob,Buf,lTot,iAdr)

      Else

         Write(6,*) SecNam,': illegal option: iOpt = ',iOpt
         Call ChoMP2_Quit(SecNam,'illegal option',' ')

      End If

      If (DoClose) Then
         Call ChoMP2_OpenF(2,2,iSym)
         DoClose = .false.
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine REVERSE(A_dir,A_inv,det)
C
C THIS ROUTINE CALCULATES THE INVERSE OF A SQUARE 3x3 MATRIX, AND ITS DETERMINANT.
C

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Real(kind=8)  :: A_dir(3,3)
      Real(kind=8)  :: A_inv(3,3)
      Real(kind=8)  :: A(3,3)
      Real(kind=8)  :: B(3,3)
      Real(kind=8)  :: det
      Real(kind=8)  :: FindDetR
      External       :: FindDetR

      det=0.0_wp
      Call dcopy_(3*3,[0.0_wp],0,A,1)
      Call dcopy_(3*3,[0.0_wp],0,B,1)
      Call dcopy_(3*3,[0.0_wp],0,A_inv,1)
      Call dcopy_(3*3,A_dir,1,A,1)

      det=FindDetR(A,3)

      B(1,1)= A(2,2)*A(3,3)-A(3,2)*A(2,3)
      B(1,2)=-A(1,2)*A(3,3)+A(3,2)*A(1,3)
      B(1,3)= A(1,2)*A(2,3)-A(2,2)*A(1,3)
      B(2,1)=-A(2,1)*A(3,3)+A(3,1)*A(2,3)
      B(2,2)= A(1,1)*A(3,3)-A(3,1)*A(1,3)
      B(2,3)=-A(1,1)*A(2,3)+A(2,1)*A(1,3)
      B(3,1)= A(2,1)*A(3,2)-A(3,1)*A(2,2)
      B(3,2)=-A(1,1)*A(3,2)+A(3,1)*A(1,2)
      B(3,3)= A(1,1)*A(2,2)-A(2,1)*A(1,2)

      Call dscal_(3*3, 1.0_wp/det, B, 1 )
      Call dcopy_(3*3, B,1,A_inv,1)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine add44(a,b,r,dimp,dimqr,dimq,fact)
! this routine does:
! B(p,qr) <-- fact * A(p,q) for given r

use ccsd_global, only: nshf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: r, dimp, dimqr, dimq
real(kind=wp), intent(in) :: a(dimp,dimq), fact
real(kind=wp), intent(inout) :: b(dimp,dimqr)
integer(kind=iwp) :: q, qr, rq

if (r /= 1) then

  rq = nshf(r)
  b(:,rq+1:rq+r-1) = b(:,rq+1:rq+r-1)-fact*a(:,1:r-1)

end if

if (r /= dimq) then

  do q=r+1,dimq
    qr = nshf(q)+r
    b(:,qr) = b(:,qr)+fact*a(:,q)
  end do

end if

return

end subroutine add44

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CASPT2_ResD2(Mode,nRow,nCol,W1,W2,LDW,DIN,DIS)

use caspt2_global, only: imag_shift, real_shift, sigma_p_epsilon, sigma_p_exponent
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Mode, nRow, nCol, LDW
real(kind=wp), intent(inout) :: W1(LDW,nCol), W2(LDW,nCol)
real(kind=wp), intent(in) :: dIn(nRow), dIs(nCol)
integer(kind=iwp) :: i, j, p
real(kind=wp) :: delta, delta_inv, delta_ps, eps, expscal, scal, sigma

! See Eqs.(16), (17), and (22) in Stefano's sigma-regularization
! Eshift is the inverse of f(Delta;eps)
! real : Eshift = delta + epsilon
! imag : Eshift = delta + epsilon(^2)/delta
! sigma: Eshift = delta/(1-exp(-|delta/epsilon|^P))
! For sigma^P
! d(Eshift)/d(delta) = 1/(1-exp...) - delta/(1-...)
! 1st and 2nd terms are the ders of numerator and denominator
! The numerator   contribution is mode = 3
! The denominator contribution is mode = 2
! Note that Lagrangian is something like (scaling factors can be
! case-dependent)
! 2<1|V|0> + <1|H0-E0|1> + <lambda|V|0> + <lambda|H0-E0+Eshift|1>
! The correlated density comes from the 2nd and 4th terms
eps = Zero
if (sigma_p_epsilon /= Zero) eps = sigma_p_epsilon

do j=1,nCol
  do i=1,nRow
    scal = Zero
    select case (mode)
      case (1)
        ! energy denominator plus real shift
        delta = dIn(i)+dIs(j)+real_shift
        ! inverse denominator plus imaginary shift
        delta_inv = delta/(delta**2+imag_shift**2)
        ! multiply by (inverse) sigma-p regularizer
        eps = sigma_p_epsilon
        p = sigma_p_exponent
        if (eps > Zero) then
          sigma = One/eps**p
          delta_inv = delta_inv*(One-exp(-sigma*abs(delta)**p))
        end if
            !! The following SCAL is the actual residual
        scal = One-(dIn(i)+dIs(j))*delta_inv
            !! Another scaling is required for lambda
        scal = -scal*delta_inv

        W1(i,j) = scal*W1(i,j)
        W2(i,j) = scal*W2(i,j)
      case (2)
        if (imag_shift /= Zero) then
          scal = imag_shift/(dIn(i)+dIs(j))
          W1(i,j) = scal*W1(i,j)
          W2(i,j) = scal*W2(i,j)
        else if (eps /= Zero) then
          ! derivative of the denominator of sigma-p CASPT2
          ! always real_shift = imag_shift = 0
          delta = dIn(i)+dIs(j)
          ! multiply by (inverse) sigma-p regularizer
          p = sigma_p_exponent
          sigma = One/eps**p
          delta_ps = (delta**p)*sigma
          expscal = exp(-abs(delta_ps))
          delta_inv = One/(One-expscal)
          ! Correct only for diagonal elements
          ! Use the canonical constraint for off-diagonal elements
          W1(i,j) = delta_inv*W1(i,j)*expscal*delta/eps*abs(delta/eps)**real(p-1,kind=wp)*real(p,kind=wp)
          W2(i,j) = delta_inv*W2(i,j)
        end if
      case (3)
        ! derivative of the numerator of sigma-p CASPT2
        ! called only for sigma-p CASPT2
        ! always real_shift = imag_shift = 0
        delta = dIn(i)+dIs(j)
        ! multiply by (inverse) sigma-p regularizer
        p = sigma_p_exponent
        sigma = One/eps**p
        expscal = exp(-sigma*abs(delta)**p)
        delta_inv = One/(One-expscal)
        ! The relevant terms are:
        ! <1|H0-E0|1> + <lambda|H0-E0+Eshift|1>
        ! This subroutine modifies the lambda for <lambda|Eshift|1>
        ! so scaling only the lambda is correct.
        W1(i,j) = delta_inv*W1(i,j)
    end select
  end do
end do

end subroutine CASPT2_ResD2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine CiSelect(S1,S2)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Select CI_vector which matches best the test vectors             *
!                                                                      *
!     calling arguments:                                               *
!     S1      : array of real*8, input/output                          *
!               overlap matrix with test vectors                       *
!     S2      : array of real*8, input                                 *
!               norm of the test configurations in the CI vector       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
#include "rasdim.fh"
#include "rasscf.fh"
real(kind=wp), intent(inout) :: S1(lRoots,lRoots)
real(kind=wp), intent(in) :: S2(lRoots,lRoots)
integer(kind=iwp) :: i, istop, jRoot, kRoot, maxS1
integer(kind=iwp), allocatable :: iTemp(:)
real(kind=wp) :: S1jk, S1max, S2jk

if (ITER == 1) return

! make a local copy of the present selection vector of weights
call mma_allocate(iTemp,mxRoot,label='iTemp')
iTemp(:) = 0

! make a new choice using the overlap ov the etst vector with
! the CI vector in the subspace of the test vector
do kRoot=1,nRoots
  ! search for the element of largest overlap
  maxS1 = 1
  S1max = S1(1,kRoot)
  do jRoot=1,lRoots
    if (S1(jRoot,kRoot) > S1max) then
      maxS1 = jRoot
      S1max = S1(jRoot,kRoot)
    end if
  end do
  iTemp(kRoot) = maxS1
  ! cleanup,to ensure that we don't pick the same root twice
  do jRoot=1,nRoots
    S1(maxS1,jRoot) = S1(maxS1,jRoot)-999999.0_wp
  end do
end do

! Restore S1
do kRoot=1,nRoots
  do jRoot=1,nRoots
    S1(iTemp(kRoot),jRoot) = S1(iTemp(kRoot),jRoot)+999999.0_wp
  end do
end do

! print
if (nRoots == 1) then
  write(u6,'(6X,A,T45,10I6)') 'new root selected:',iTemp(1:kRoot)
  write(u6,'(6X,A,T45,10F6.3)') 'overlap           ',(S1(iTemp(kRoot),kRoot),kRoot=1,nRoots)
else
  write(u6,'(6X,A,T45,10I6)') 'new roots selected:',iTemp(1:kRoot)
  write(u6,'(6X,A,T45,10F6.3)') 'overlap           ',(S1(iTemp(kRoot),kRoot),kRoot=1,nRoots)
end if

! Compare the overlap elemets <1|2> and <1|1> where
! |1> is the CI vector in the subspace of the test vector and
! |2> is the test vector.
! The program breaks execution if the following roules apply:
! If <1|2> is less than 0.5*<1|1>
! If the weight of <1|2> or <1|1> is less than 0.3
istop = 0
do kRoot=1,nRoots
  S1jk = S1(iTemp(kRoot),kRoot)
  S2jk = S2(iTemp(kRoot),kRoot)
  if (S1jk < Half*S2jk) istop = ibset(istop,0)
  if (sqrt(S1jk) < 0.316_wp) istop = ibset(istop,1)
  if (sqrt(S2jk) < 0.3_wp) istop = ibset(istop,2)
end do

! If the stop flag has been set write an appropriate message
! and to stop execution change the iteration counter.
if (istop >= 1) then
  write(u6,*)
  write(u6,'(6X,120A1)') ('=',i=1,120)
  if (btest(istop,0)) then
    write(u6,'(6X,A)') 'The projection of the CI vector(s) onto the model vector(s)'
    write(u6,'(6X,A)') 'is smaller than half the norm of the subspace.'
  end if
  if (btest(istop,1)) then
    write(u6,'(6X,A)') 'The overlap of the projected CI vector(s) and the model vector(s) is smaller than 0.1'
  end if
  if (btest(istop,2)) then
    write(u6,'(6X,A)') 'The weight(s) of the subspace is(are) smaller than 30% of the total wave function(s)'
  end if
  write(u6,'(6X,A)') 'Please, check your model space'
  write(u6,'(6X,A)') 'The program stops after the next iteration'
  write(u6,'(6X,120A1)') ('=',i=1,120)
  write(u6,*)
  write(u6,*)
  MAXIT = ITER
else
  iRoot(:) = iTemp(:)
end if

call mma_deallocate(iTemp)

return

end subroutine CiSelect

!**********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Roland Lindh                                     *
!***********************************************************************

subroutine DrvNQ_Inner(Kernel,Func,Maps2p,nSym,list_s,list_exp,list_bas,nShell,list_p,nNQ,FckInt,nFckDim,Density,nFckInt,nD,mGrid, &
                       nP2_ontop,Do_Mo,nTmpPUVX,Do_Grad,Grad,nGrad,mAO,mdRho_dR)
!***********************************************************************
!                                                                      *
! Object: Driver for numerical quadrature.                             *
!                                                                      *
!     Author: Roland Lindh,                                            *
!             Dept of Chemical Physics,                                *
!             University of Lund, Sweden                               *
!             August 1999                                              *
!***********************************************************************

use Symmetry_Info, only: nIrrep, iOper
use KSDFT_Info, only: do_pdftpot, FA_time, FI_time, Funcaa, Funcbb, Funccc, PUVX_time, sp_time
use nq_Grid, only: l_casdft, D1UnZip, P2UnZip
use nq_MO, only: D1MO, P2MO
use nq_Structure, only: Close_Info_Ang
use nq_Info, only: Dens_a1, Dens_a2, Dens_b1, Dens_b2, Dens_I, Dens_t1, Dens_t2, Grad_I, iOpt_Angular, NASHT, nPot1, nPot2, &
                   number_of_subblocks, nx, ny, nz, Tau_I
use Grid_On_Disk, only: Grid_Status, GridInfo, Regenerate
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half, Quart
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Basis_Info, only: nBas
use KSDFT_Info, only: KSDFA, LuMC, LuMT
use Definitions, only: u6
#endif

implicit none
external :: Kernel
integer(kind=iwp), intent(in) :: nShell, nSym, Maps2p(nShell,0:nSym-1), nNQ, nFckDim, nFckInt, nD, mGrid, nP2_ontop, nTmpPUVX, &
                                 nGrad, mAO, mdRho_dR
integer(kind=iwp), intent(out) :: list_s(nSym*nShell), list_exp(nSym*nShell), list_bas(2,nSym*nShell), list_p(nNQ)
real(kind=wp), intent(inout) :: Func, FckInt(nFckInt,nFckDim), Grad(nGrad)
real(kind=wp), intent(in) :: Density(nFckInt,nD)
logical(kind=iwp), intent(in) :: Do_Mo, Do_Grad
integer(kind=iwp) :: id, iIrrep, iSB, ix, iy, iyz, iz, jx, jxyz, jy, jyz, jz
logical(kind=iwp) :: l_tgga
real(kind=wp), allocatable :: EG_OT(:), FA_V(:), FI_V(:), OE_OT(:), PDFTFocA(:), PDFTFocI(:), PDFTPot1(:)
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: Exists
#endif
logical(kind=iwp), external :: Rsv_Tsk

!***********************************************************************
! Initializations for MC-PDFT                                          *
!***********************************************************************
!***********************************************************************
! Open file for MC-PDFT to store density, pair density and ratio:      *
!                   ratio = 4pi/rho^2                                  *
!***********************************************************************
if (l_casdft) then

  PUVX_Time = Zero
  FA_Time = Zero
  sp_time = Zero
  FI_time = Zero

# ifdef _DEBUGPRINT_
  LuMC = 37
  call OpnFl('MCPDFT',LuMC,Exists)
  !call append_file(LuMC)
  write(LuMC,'(A)') ' Here densities are MCPDFT modified ones.'
  write(LuMC,*) ' Used by translated functional: ',KSDFA(1:8)
  write(LuMC,'(A)') '     X    ,     Y    ,     Z    ,       d_a*W     ,       d_b*W     ,       dTot*W    ,       Weights   ,'// &
                    '          dTot   ,       P2        ,   ratio'
  LuMT = 37
  call OpnFl('MCTRUD',LuMT,Exists)
  !call append_file(LuMT)
  write(LuMT,'(A)') ' Here densities are original ones.'
  write(LuMT,*) ' Used by translated functional: ',KSDFA(1:8)
  write(LuMT,'(A)') '     X    ,     Y    ,     Z    ,       d_a*W     ,       d_b*W     ,       dTot*W    ,       Weights   ,'// &
                    '          dTot '
# endif

  call CalcOrbOff()
  call mma_allocate(P2Unzip,NASHT,NASHT,NASHT,NASHT)
  call mma_allocate(D1Unzip,NASHT,NASHT)
  call UnzipD1(D1Unzip,D1MO,size(D1MO))
  call UnzipP2(P2Unzip,P2MO,size(P2MO))
end if
!***********************************************************************
!
! Desymmetrize the 1-particle density matrix

call Allok2_Funi(nD)
call DeDe_Funi(Density,nFckInt,nD)

if (l_casdft .and. do_pdftPot) then
  call mma_allocate(PDFTPot1,nPot1)
  call mma_allocate(PDFTFocI,nPot1)
  call mma_allocate(PDFTFocA,nPot1)
  call mma_allocate(OE_OT,nFckInt,Label='OE_OT')
  call mma_allocate(EG_OT,nTmpPUVX,Label='EG_OT')
  call mma_allocate(FI_V,nFckInt,Label='FI_V')
  call mma_allocate(FA_V,nFckInt,Label='FA_V')

  OE_OT(:) = Zero
  EG_OT(:) = Zero
  FI_V(:) = Zero
  FA_V(:) = Zero
  PDFTPot1(:) = Zero
  PDFTFocI(:) = Zero
  PDFTFocA(:) = Zero
  call CalcPUVXOff()
else
  nPot1 = 1
  call mma_allocate(OE_OT,nPot1,Label='OE_OT')
  call mma_allocate(EG_OT,nPot1,Label='EG_OT')
  call mma_allocate(FI_V,nPot1,Label='FI_V')
  call mma_allocate(FA_V,nPot1,Label='FA_V')
  call mma_allocate(PDFTPot1,nPot1)
  call mma_allocate(PDFTFocI,nPot1)
  call mma_allocate(PDFTFocA,nPot1)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! For a parallel implementation the iterations over
! subblocks are parallelized.

call Init_Tsk(id,number_of_subblocks) ! Initialize parallelization

! Loop over subblocks

iSB = 0
!do iSB=1,number_of_subblocks

! Start of parallelized loop here!

outer: do
  if (Grid_Status == Regenerate) then
    ! Try to get an iSB to execute. If fail: done and branch out!
    if (.not. Rsv_Tsk(id,iSB)) exit outer
  else
    ! Try to find a subblock which was generated by this processor.
    iSB = iSB+1
    if (iSB > number_of_subblocks) exit outer
    if (GridInfo(2,iSB) == 0) cycle outer
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Eliminate redundant subblocks in case of symmetry.
  ! This is only done for the Lebedev grids!

  if ((nIrrep /= 1) .and. btest(iOpt_Angular,2)) then

    ! Resolve triplet index

    iyz = 1+(iSB-1)/nx
    ix = iSB-(iyz-1)*nx
    iz = 1+(iyz-1)/ny
    iy = iyz-(iz-1)*ny

    ! Do symmetry by procrastination.

    do iIrrep=1,nIrrep-1
      jx = ix
      if (btest(iOper(iIrrep),0)) jx = nx-jx+1
      jy = iy
      if (btest(iOper(iIrrep),1)) jy = ny-jy+1
      jz = iz
      if (btest(iOper(iIrrep),2)) jz = nz-jz+1

      jyz = (jz-1)*ny+jy
      jxyz = (jyz-1)*nx+jx
      !if (jxyz > iSB) exit outer
      if (jxyz > iSB) cycle outer ! go for the next task.
    end do

  end if
# ifdef _DEBUGPRINT_
  write(u6,*) 'DrvNQ_Inner: iSB=',iSB
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Here the List_S is the list of all the complete shells for
  ! the whole system.

  call Get_Subblock(Kernel,Func,iSB,Maps2p,list_s,list_exp,list_bas,nShell,nSym,list_p,nNQ,FckInt,nFckDim,nFckInt,nD,mGrid, &
                    nP2_ontop,Do_Mo,Do_Grad,Grad,nGrad,mAO,mdRho_dR,EG_OT,nTmpPUVX,PDFTPot1,PDFTFocI,PDFTFocA)
  ! go back and try to do another task
end do outer
!end do ! number_of_subblocks
!                                                                      *
!***********************************************************************
!                                                                      *
call Free_Tsk(id)

!                                                                      *
!***********************************************************************
!                                                                      *
! Scale result with respect to the degeneracy of the grid points

if ((nIrrep /= 1) .and. btest(iOpt_Angular,2)) then

  Func = real(nIrrep,kind=wp)*Func
  Funcaa = real(nIrrep,kind=wp)*Funcaa
  Funcbb = real(nIrrep,kind=wp)*Funcbb
  Funccc = real(nIrrep,kind=wp)*Funccc
  Dens_I = real(nIrrep,kind=wp)*Dens_I
  Dens_a1 = real(nIrrep,kind=wp)*Dens_a1
  Dens_b1 = real(nIrrep,kind=wp)*Dens_b1
  Dens_a2 = real(nIrrep,kind=wp)*Dens_a2
  Dens_b2 = real(nIrrep,kind=wp)*Dens_b2
  Dens_t1 = real(nIrrep,kind=wp)*Dens_t1
  Dens_t2 = real(nIrrep,kind=wp)*Dens_t2
  Grad_I = real(nIrrep,kind=wp)*Grad_I
  Tau_I = real(nIrrep,kind=wp)*Tau_I

  FckInt(:,:) = real(nIrrep,kind=wp)*FckInt(:,:)

end if

!                                                                      *
!***********************************************************************
!                                                                      *
! Free memory associated with the density

call Free_DeDe_Funi()

! Free memory for angular grids

call Close_Info_Ang()
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
if (.not. Do_Grad) then
  write(u6,*) 'Func=',Func
  iOff = 1
  do iIrrep=0,nIrrep-1
    nB = nBas(iIrrep)
    if (nB > 0) then
      call TriPrt('Final FckInt(Alpha)',' ',FckInt(iOff,1),nB)
      lB = nB*(nB+1)/2
      iOff = iOff+lB
    end if
  end do
  if (nD /= 1) then
    iOff = 1
    do iIrrep=0,nIrrep-1
      nB = nBas(iIrrep)
      if (nB > 0) then
        call TriPrt('Final FckInt(Beta)',' ',FckInt(iOff,2),nB)
        lB = nB*(nB+1)/2
        iOff = iOff+lB
      end if
    end do
  end if
end if
#endif

if (l_casdft) then
  call mma_deallocate(D1Unzip)
  call mma_deallocate(P2Unzip)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! For parallel implementation synchronize here!
!
! Data to be synchronized: FckInt, Func, Dens,  and Grad.

l_tgga = .true.
if (Do_Grad) then
  call GADSum(Grad,nGrad)
else
  call GADSum_SCAL(Func)
  call GADSum_SCAL(Funcaa)
  call GADSum_SCAL(Funcbb)
  call GADSum_SCAL(Funccc)
  call GADSum_SCAL(Dens_I)
  call GADSum_SCAL(Dens_t1)
  call GADSum_SCAL(Dens_t2)
  call GADSum_SCAL(Dens_a1)
  call GADSum_SCAL(Dens_a2)
  call GADSum_SCAL(Dens_b1)
  call GADSum_SCAL(Dens_b2)
  call GADSum_SCAL(Grad_I)
  call GADSum_SCAL(Tau_I)
  call GADSum(FckInt,nFckInt*nD)
  if (l_casdft .and. do_pdftPot) then
    call GADSum(OE_OT,nFckInt)
    call GADSum(EG_OT,nTmpPUVX)
    call GADSum(FI_V,nFckInt)
    call GADSum(FA_V,nFckInt)
    if (l_tgga) then
      call GADSum(PDFTPot1,nPot1)
      call GADSum(PDFTFocI,nPot1)
      call GADSum(PDFTFocA,nPot1)
    end if
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (l_casdft .and. do_pdftPot) then

  if (l_tgga) then
    call PackPot1(OE_OT,PDFTPot1,nFckInt,real(nIrrep,kind=wp)*Half)
    EG_OT(1:nPot2) = real(nIrrep,kind=wp)*EG_OT(1:nPot2)
    call PackPot1(FI_V,PDFTFocI,nFckInt,real(nIrrep,kind=wp)*Quart)
    call PackPot1(FA_V,PDFTFocA,nFckInt,real(nIrrep,kind=wp)*Half)
  end if
  call Put_dArray('ONTOPO',OE_OT,nFckInt)
  call Put_dArray('ONTOPT',EG_OT,nTmpPUVX)
  call Put_dArray('FI_V',FI_V,nFckInt)
  call Put_dArray('FA_V',FA_V,nFckInt)

end if
call mma_deallocate(OE_OT)
call mma_deallocate(EG_OT)
call mma_deallocate(FA_V)
call mma_deallocate(FI_V)
call mma_deallocate(PDFTPot1)
call mma_deallocate(PDFTFocI)
call mma_deallocate(PDFTFocA)

#ifdef _DEBUGPRINT_
if (l_casdft) then
  write(u6,*) 'Dens_I in DrvNQ_Inner :',Dens_I
  write(u6,*) 'Dens_a1 in DrvNQ_Inner :',Dens_a1
  write(u6,*) 'Dens_b1 in DrvNQ_Inner :',Dens_b1
  write(u6,*) 'Dens_a2 in DrvNQ_Inner :',Dens_a2
  write(u6,*) 'Dens_b2 in DrvNQ_Inner :',Dens_b2
  write(u6,*) 'Dens_t1 in DrvNQ_Inner :',Dens_t1
  write(u6,*) 'Dens_t2 in DrvNQ_Inner :',Dens_t2
  write(u6,*) 'Func in DrvNQ_Inner :',Func
  write(u6,*) 'Funcaa in DrvNQ_Inner :',Funcaa
  write(u6,*) 'Funcbb in DrvNQ_Inner :',Funcbb
  write(u6,*) 'Funccc in DrvNQ_Inner :',Funccc

  ! Close these files...
  close(LuMC)
  close(LuMT)
end if
#endif

return

end subroutine DrvNQ_Inner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine rules_cvb(chr)

implicit none
character(len=*), intent(in) :: chr

select case (chr)
  case ('MEM1')
    call chop1_cvb()
  case ('MEM2')
    call chop2_cvb()
  case ('MEM3')
    call chop3_cvb()
  case ('MEM4')
    call chop4_cvb()
  case ('MEM5')
    call chop5_cvb()
  case ('MEM6')
    call chop6_cvb()
  case ('MEM7')
    call chop7_cvb()
  case ('ORBFREE')
    call mkorbfree_cvb()
  case ('CIFREE')
    call mkcifree_cvb()
  case ('ICONFS')
    call mkiconfs_cvb()
  case ('GENDET')
    call mkciinfo_cvb()
    call mkvbinfo_cvb()
  case ('SYMELM')
    call mksymelm_cvb()
  case ('SYMINIT')
    call mksyminit_cvb()
  case ('CONSTRUC')
    call mkconstruc_cvb()
  case ('RDINT')
    ! do nothing
  case ('RDCAS')
    call mkrdcas_cvb()
  case ('SYMORBS')
    call mksymorbs_cvb()
  case ('SYMCVB')
    call mksymcvb_cvb()
  case ('GUESS')
    call mkguess_cvb()
  case ('ORBPERM')
    call mkorbperm_cvb()
  case ('TRNSPN')
    call mktrnspn_cvb()
  case ('STAT')
    call stat_cvb()
end select

return

end subroutine rules_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Ext_Aex(Aex,VV,no)
! this routine defs:
! VV(i,u,v,j) <- Aex(ij,u,v)
! for Aex(i,j,u,v) = Aex(j,i,v,u), Aex stored only for i>=j

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: no
real(kind=wp), intent(in) :: Aex(nTri_Elem(no),no,no)
real(kind=wp), intent(out) :: VV(no,no,no,no)
integer(kind=iwp) :: i, ij, u, v

do u=1,no
  do v=1,no
    ij = 0
    do i=1,no

      VV(i,u,v,:) = Aex(ij+1:ij+no,u,v)
      VV(:,v,u,i) = Aex(ij+1:ij+no,u,v)

      ij = ij+i
    end do
  end do
end do

return

end subroutine Ext_Aex

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine momloc2( N, NL, nneq,  neq, neqv, r_rot, nsites,
     &                    nexch, W, Z, dipexch, s_exch, dipso, s_so )
      Implicit None
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer          :: N
      Integer          :: NL
      Integer          :: nneq
      Integer          :: neq(nneq)
      Integer          :: neqv  ! neqv = MAXVAL(neq(:))
      Integer          :: nsites
      Integer          :: nexch(nneq)
      Real(kind=8)    :: W(N)
!     assuming 10 equivalent magnetic sites, which is too much for many cases
      Real(kind=8)    :: R_rot(NNEQ,neqv,3,3)
      Complex(kind=8) :: dipexch(3,N,N)
      Complex(kind=8) ::  s_exch(3,N,N)
      Complex(kind=8) :: dipso(nneq,3,NL,NL)
      Complex(kind=8) ::  s_so(nneq,3,NL,NL)
      Complex(kind=8) :: Z(N,N)
#include "stdalloc.fh"
c local variables:
      Integer          :: L, i, j, m, k
      Integer          :: nmult, isite
      Integer          :: icod(nsites)
      Integer          :: ib(N,nsites)
      Integer          :: nind(nsites,2)
      Integer          :: l_exch, jEnd
      Integer          :: i1,j1,iss1,jss1,nb1,nb2,iss
      Integer          :: icoord(nsites)
      Integer          :: norder
      Real(kind=8)    :: gtens(3)
      Real(kind=8)    :: maxes(3,3)
      Real(kind=8)    :: st(3)
      Real(kind=8)    :: H
      Real(kind=8)    :: E_thres
      Real(kind=8)    :: zJ
      Real(kind=8)    :: g_e
      Character(Len=60)    :: fmtline
      logical          :: DBG
      Real(kind=8),allocatable     :: WM(:)     ! WM(N)
      Real(kind=8), allocatable    :: MM(:,:,:) ! MM(nsites,3,N)
      Real(kind=8), allocatable    :: LM(:,:,:) ! LM(nsites,3,N)
      Real(kind=8), allocatable    :: SM(:,:,:) ! SM(nsites,3,N)
      Real(kind=8), allocatable    :: JM(:,:,:) ! JM(nsites,3,N)
      Complex(kind=8), allocatable :: ZM(:,:)  ! ZM(N,N)
      Complex(kind=8), allocatable :: VL(:,:)  ! VL(N,N)
      Complex(kind=8), allocatable :: TMP(:,:) ! TMP(N,N)
      ! temporary data for ZEEM:
      Real(kind=8), allocatable :: RWORK(:)
      Complex(kind=8), allocatable :: HZEE(:), WORK(:), W_c(:)
c
      DBG=.false.
      g_e=2.0023193043718_wp

      Call mma_allocate(WM,N,'WM')
      Call mma_allocate(MM,nsites,3,N,'MM')
      Call mma_allocate(LM,nsites,3,N,'LM')
      Call mma_allocate(SM,nsites,3,N,'SM')
      Call mma_allocate(JM,nsites,3,N,'JM')
      Call mma_allocate(ZM,N,N,'ZM')
      Call mma_allocate(VL,N,N,'VL')
      Call mma_allocate(TMP,N,N,'TMP')
      ! temporary arrays used in ZEEM_SA:
      Call mma_allocate(RWORK,(3*N-2),'ZEEM_RWORK')
      Call mma_allocate(HZEE,(N*(N+1)/2),'ZEEM_HZEE')
      Call mma_allocate(WORK,(2*N-1),'ZEEM_WORK')
      Call mma_allocate(W_c,N,'ZEEM_W_c')

      ! zero everything:
      Call dcopy_(N,[0.0_wp],0,WM,1)
      Call dcopy_(nsites*3*N,[0.0_wp],0,MM,1)
      Call dcopy_(nsites*3*N,[0.0_wp],0,LM,1)
      Call dcopy_(nsites*3*N,[0.0_wp],0,SM,1)
      Call dcopy_(nsites*3*N,[0.0_wp],0,JM,1)
      Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,ZM,1)
      Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,VL,1)
      Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,TMP,1)

      Call dcopy_(3*N-2,[0.0_wp],0,RWORK,1)
      Call zcopy_(N*(N+1)/2,[(0.0_wp,0.0_wp)],0,HZEE,1)
      Call zcopy_(2*N-1,[(0.0_wp,0.0_wp)],0,WORK,1)
      Call zcopy_(N,[(0.0_wp,0.0_wp)],0,W_c,1)


      If (N==1) goto 199
c  initialisations:
      isite=0
      nind=0
      Do i=1,nneq
         Do j=1,neq(i)
            isite=isite+1
            nind(isite,1)=i
            nind(isite,2)=j
         End Do
      End Do
      isite=0
      icod=0
      icod(1)=1
      Do i=2,nsites
         isite=nind(i-1,1)
         icod(i) = icod(i-1)*nexch(isite)
      End Do
      ib=0
      Do i=1,N
         j=i-1
         Do isite=1,nsites
            k=nsites-isite+1
            ib(i,k) = j/icod(k)
            j = j - ib(i,k) * icod(k)
         End Do
      End Do
c  find the multiplicity of the low-lying group of states,
c  energy threshold E_thres = 1.d-2 cm-1;
      nmult=0
      E_thres=1.d-3
      Do i=1,N
        If( ABS(W(i)-W(1)).lt.E_thres) Then
           nmult=nmult+1
        End If
      End Do
      If(nmult<2) nmult=2 !minimum value needed to compute g-tensor
c  find the main magnetic axes of this manIfold:
      gtens=0.0_wp
      maxes=0.0_wp
      Call atens( dipexch(1:3,1:nmult,1:nmult), nmult, gtens, maxes, 1)
      If(DBG) Then
      Write(6,'(A)') 'MOMLOC2:  g tensor of the ground manIfold:'
      Write(6,*)
      Write(6,'((A,F12.6,A,3F12.7))') 'gX=',gtens(1),
     & ' axis X: ',(maxes(j,1),j=1,3)
      Write(6,'((A,F12.6,A,3F12.7))') 'gY=',gtens(2),
     & ' axis Y: ',(maxes(j,2),j=1,3)
      Write(6,'((A,F12.6,A,3F12.7))') 'gZ=',gtens(3),
     & ' axis Z: ',(maxes(j,3),j=1,3)
      End If
c  construct the Zeeman matrix in the lowest N exchange states  and diagonalize it
      st=0.0_wp
      H=1.d-4 ! Tesla
      zJ=0.0_wp !absence of intermolecular interaction
      Call zeem_sa( N, H, maxes(1,3),maxes(2,3),maxes(3,3),
     &           W(1:N), dipexch(1:3,1:N,1:N),
     &                    s_exch(1:3,1:N,1:N),
     &           ST, zJ,  WM(1:N), ZM(1:N,1:N),
     &           DBG, RWORK, HZEE, WORK, W_c )
ccc  eigenvectors
      If (DBG) Then
         Write(6,*)
         Write(6,'(100a)') (('%'),i=1,96)
         Write(6,'(10x,a)') 'MOMLOC2:  '//
     &       'EigenVectors of the Total Magnetic Interaction'
         Write(6,'(100a)') (('%'),i=1,96)

         Write(6,'(A,16A)') '-',('---',m=1,nsites),'|',
     &       ('---------------------------|',i=1,4)
         Write(fmtline,'(A,i2,A)') '(1x,',nsites,'A,39x,A,38x,A)'
         Write(6,fmtline) ('   ',m=1,nsites),
     &        'eigenvectors of the exchange matrix','|'
         Do J=1,N,4
            jEnd=MIN(N,J+3)
            Write(6,'(A,16A)') '-',('---',m=1,nsites),'|',
     &       ('---------------------------|',i=j,jEnd)

            Write(6,'(A,5A)') 'Exch.  |',
     &       ('      exchange state       |',i=j,jEnd)

            Write(6,'(A,6A)') 'basis  |',
     &       ('                           |',i=j,jEnd)
            Write(6,'(A,6(a,i5,a))') 'on site|',
     &       ('         ',i,'             |',i=j,jEnd)
              Write(fmtline,'(A,i2,A)')
     &              '(A,',nsites,'i3,a,6(a,f19.12,2x,a))'
            Write(6,fmtline) ' ',(i,i=1,nsites),'|',
     &       ('  E =',wm(i)-wm(1),' |',i=j,jEnd)

            Write(6,'(A,16A)') '-',('---',m=1,nsites),'|',
     &       ('----- Real ------- Imag ---|',i=j,jEnd)

               Write(fmtline,'(A,i2,A)')
     &              '(A,',nsites,'i3,A,5(2F13.9,1x,a))'
            Do iss=1,N
               Write(6,fmtline) '<',
     &              ( ib(iss,m)+1,m=1,nsites),'|',
     &              ( ZM(iss,i),'|',i=j,jEnd)
            End Do  !iss
            Write(6,'(A,16A)') '-',('---',m=1,nsites),'|',
     &          ('---------------------------|',i=j,jEnd)
            Write(6,*)
         End Do ! j
      End If !DBG


c  generate the exchange basis:
      Do isite=1,nsites
         Do L=1,3
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,VL,1)
            Do nb1=1,N
                Do l_exch=1,nsites
                icoord(l_exch)=ib(nb1,l_exch)
                End Do
            i1=nind(isite,1)
            j1=nind(isite,2)
          iss1=ib(nb1,isite)+1

               Do jss1=1,nexch(i1)
               icoord(isite)=jss1-1
               nb2=norder(icoord,icod,nsites)
               VL(nb1, nb2) = VL(nb1, nb2) +
     &               r_rot( i1, j1, l, 1 ) * dipso( i1, 1, iss1, jss1 )
     &              +r_rot( i1, j1, l, 2 ) * dipso( i1, 2, iss1, jss1 )
     &              +r_rot( i1, j1, l, 3 ) * dipso( i1, 3, iss1, jss1 )
               End Do  ! jss1
            End Do  ! nb1
c rotate this matrix to exchange basis:
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,TMP,1)
            Call ZGEMM_('C','N',N,N,N,
     &                   (1.0_wp,0.0_wp),   Z, N,
     &                                     VL, N,
     &                   (0.0_wp,0.0_wp), TMP, N )
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,VL,1)
            Call ZGEMM_('N','N',N,N,N,
     &                   (1.0_wp,0.0_wp),TMP, N,
     &                                     Z, N,
     &                   (0.0_wp,0.0_wp), VL, N )
c rotate this matrix to Zeeman basis:
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,TMP,1)
            Call ZGEMM_('C','N',N,N,N,(1.0_wp,0.0_wp),
     &                 ZM(1:N,1:N), N,
     &                 VL(1:N,1:N), N, (0.0_wp,0.0_wp),
     &                TMP(1:N,1:N), N )
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,VL,1)
            Call ZGEMM_('N','N',N,N,N, (1.0_wp,0.0_wp),
     &                TMP(1:N,1:N), N,
     &                 ZM(1:N,1:N), N, (0.0_wp,0.0_wp),
     &                 VL(1:N,1:N), N )
            Do i=1,N
               MM(isite,L,i)=dble(VL(i,i))
            End Do
c spin moment
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,VL,1)
            Do nb1=1,N
                Do l_exch=1,nsites
                icoord(l_exch)=ib(nb1,l_exch)
                End Do
            i1=nind(isite,1)
            j1=nind(isite,2)
          iss1=ib(nb1,isite)+1

               Do jss1=1,nexch(i1)
               icoord(isite)=jss1-1
               nb2=norder(icoord,icod,nsites)
               VL(nb1, nb2) = VL(nb1, nb2) +
     &               r_rot( i1, j1, l, 1 ) *  s_so( i1, 1, iss1, jss1 )
     &              +r_rot( i1, j1, l, 2 ) *  s_so( i1, 2, iss1, jss1 )
     &              +r_rot( i1, j1, l, 3 ) *  s_so( i1, 3, iss1, jss1 )
               End Do  ! jss1
            End Do  ! nb1
c rotate this matrix to exchange basis and to Zeeman basis
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,TMP,1)
            Call ZGEMM_('C','N',N,N,N,  (1.0_wp,0.0_wp),
     &                  Z(1:N,1:N), N,
     &                 VL(1:N,1:N), N, (0.0_wp,0.0_wp),
     &                TMP(1:N,1:N), N )
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,VL,1)
            Call ZGEMM_('N','N',N,N,N,  (1.0_wp,0.0_wp),
     &                TMP(1:N,1:N), N,
     &                  Z(1:N,1:N), N, (0.0_wp,0.0_wp),
     &                 VL(1:N,1:N), N )
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,TMP,1)
            Call ZGEMM_('C','N',N,N,N,  (1.0_wp,0.0_wp),
     &                 ZM(1:N,1:N), N,
     &                 VL(1:N,1:N), N, (0.0_wp,0.0_wp),
     &                TMP(1:N,1:N), N )
            Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,VL,1)
            Call ZGEMM_('N','N',N,N,N,  (1.0_wp,0.0_wp),
     &                TMP(1:N,1:N), N,
     &                 ZM(1:N,1:N), N, (0.0_wp,0.0_wp),
     &                 VL(1:N,1:N), N )
            Do i=1,N
               SM(isite,L,i)=dble(VL(i,i))
            End Do
         End Do  ! L
      End Do  ! isite
c compute and print the calculated expectation values:
      Write(6,*)
      Write(6,'(A)') 'EXPECTATION VALUES'
      Write(6,'(5A)') '--------|----|',
     & ('------------------------------|',i=1,4)
      Write(6,'(5A)') 'Exchange|Site|',
     & '   MAGNETIC MOMENT (M=-L-2S)  |',
     & '        SPIN MOMENT (S)       |',
     & '      ORBITAL MOMENT (L)      |',
     & '     TOTAL MOMENT (J=L+S)     |'
      Write(6,'(5A)') ' state  | Nr.|',
     & ('     X         Y         Z    |',i=1,4)
      Write(6,'(5A)') '--------|----|',
     & ('------------------------------|',i=1,4)
      Do i=1,N
c  we proceed to compute expectation values for this nb1 exchange state
         Do isite=1,nsites
            Do L=1,3
               LM(isite,L,i)=-MM(isite,L,i)-g_e*SM(isite,L,i)
               JM(isite,L,i)= LM(isite,L,i)+    SM(isite,L,i)
            End Do
         End Do

         Do isite=1,nsites
         If(isite.eq.int((nsites+1)/2)) Then
      Write(6,'(i5,3x,A,1x,i2,1x,A,4(3(F9.5,1x),A))')
     & i,'|',isite,'|',
     & MM(isite,1,i),MM(isite,2,i),MM(isite,3,i),'|',
     & SM(isite,1,i),SM(isite,2,i),SM(isite,3,i),'|',
     & LM(isite,1,i),LM(isite,2,i),LM(isite,3,i),'|',
     & JM(isite,1,i),JM(isite,2,i),JM(isite,3,i),'|'
         Else
      Write(6,'(8x,A,1x,i2,1x,A,4(3(F9.5,1x),A))')
     & '|',isite,'|',
     & MM(isite,1,i),MM(isite,2,i),MM(isite,3,i),'|',
     & SM(isite,1,i),SM(isite,2,i),SM(isite,3,i),'|',
     & LM(isite,1,i),LM(isite,2,i),LM(isite,3,i),'|',
     & JM(isite,1,i),JM(isite,2,i),JM(isite,3,i),'|'
         End If
         End Do
      Write(6,'(5A)') '--------|----|',
     & ('------------------------------|',i1=1,4)
      End Do

199   CONTINUE

      ! deallocate temporary arrays:
      Call mma_deallocate(WM)
      Call mma_deallocate(MM)
      Call mma_deallocate(LM)
      Call mma_deallocate(SM)
      Call mma_deallocate(JM)
      Call mma_deallocate(ZM)
      Call mma_deallocate(VL)
      Call mma_deallocate(TMP)
      Call mma_deallocate(RWORK)
      Call mma_deallocate(HZEE)
      Call mma_deallocate(WORK)
      Call mma_deallocate(W_c)


      Return
      End Subroutine momloc2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************
Module ChoSwp
Implicit none
Private
Public:: iQuAB, iQuAB_L, iQuAB_Hidden, iQuAB_L_Hidden, pTemp, iQuAB_here, &
         nnBstRSh, nnBstRSh_Hidden, nnBstRSh_G, nnBstRSh_L_Hidden, pTemp3, &
         iiBstRSh, iiBstRSh_Hidden, iiBstRSh_G, iiBstRSh_L_Hidden, &
         IndRSh, IndRSh_Hidden, IndRSh_G, IndRSh_G_Hidden, pTemp1, &
         InfRed, InfRed_Hidden, InfRed_G, InfRed_G_Hidden, &
         InfVec, InfVec_Hidden, InfVec_G, InfVec_G_Hidden, InfVec_Bak, &
         IndRed, IndRed_Hidden, IndRed_G, IndRed_G_Hidden, &
         Diag, Diag_Hidden, Diag_G, Diag_G_Hidden


Integer, Allocatable, Target:: iQuAB_Hidden(:,:), iQuAB_L_Hidden(:,:), iQuAB_here(:,:)
Integer, Pointer:: iQuAB(:,:)=>Null() , iQuAB_L(:,:)=>Null(), pTemp(:,:)=>Null()

Integer, Allocatable, Target:: nnBstRSh_Hidden(:,:,:), nnBstRSh_L_Hidden(:,:,:)
Integer, Allocatable, Target:: iiBstRSh_Hidden(:,:,:), iiBstRSh_L_Hidden(:,:,:)
Integer, Pointer:: nnBstRSh(:,:,:)=>Null(), nnBstRSh_G(:,:,:)=>Null(), pTemp3(:,:,:)=>Null()
Integer, Pointer:: iiBstRSh(:,:,:)=>Null(), iiBstRSh_G(:,:,:)=>Null()
Integer, Pointer:: IndRSh(:)=>Null(), IndRSh_G(:)=>Null(), pTemp1(:)=>Null()
Integer, Allocatable, Target:: IndRSh_Hidden(:), IndRSh_G_Hidden(:)
Integer, Pointer:: InfRed(:)=>Null(), InfRed_G(:)=>Null()
Integer, Allocatable, Target:: InfRed_Hidden(:), InfRed_G_Hidden(:)
Integer, Pointer:: InfVec(:,:,:)=>Null(), InfVec_G(:,:,:)=>Null()
Integer, Allocatable, Target:: InfVec_Hidden(:,:,:), InfVec_G_Hidden(:,:,:)
Integer, Allocatable, Target:: InfVec_Bak(:,:,:)
Integer, Pointer:: IndRed(:,:)=>Null(), IndRed_G(:,:)=>Null()
Integer, Allocatable, Target:: IndRed_Hidden(:,:), IndRed_G_Hidden(:,:)
Real*8, Pointer:: Diag(:)=>Null(), Diag_G(:)=>Null()
Real*8, Allocatable, Target:: Diag_Hidden(:), Diag_G_Hidden(:)
End Module ChoSwp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2002, Roland Lindh                                     *
!***********************************************************************

subroutine Cmbn_EF_DPnt(EF,nTs,DPnt,MxAto,DCntr,nS,iSph,Q,Grad,nGrad)
!***********************************************************************
!                                                                      *
!  Combine EF with DPnt array.                                         *
!                                                                      *
!  Roland Lindh                                                        *
!  020117                                                              *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nTs, MxAto, nS, iSph(nTs), nGrad
real(kind=wp), intent(in) :: EF(3,2,nTs), DPnt(nTs,MxAto,3,3), DCntr(nS,MxAto,3,3), Q(2,nTs)
real(kind=wp), intent(inout) :: Grad(nGrad)
integer(kind=iwp) :: iCar, iCen, iCnt, iCnttp, iComp, iIrrep, iTs, jSph, mdc, nDispS
real(kind=wp) :: QTot
real(kind=wp), parameter :: tol = 1.0e-8_wp
logical(kind=iwp), external :: TF
#include "Molcas.fh"
#include "disp.fh"

iIrrep = 0

mdc = 0
iCen = 1
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux) cycle
  do iCnt=1,dbsc(iCnttp)%nCntr
    mdc = mdc+1
    nDispS = IndDsp(mdc,iIrrep)

    do iCar=0,2
      iComp = 2**iCar
      if (TF(mdc,iIrrep,iComp)) then
        nDispS = nDispS+1
        do iTs=1,nTs
          jSph = iSph(iTs)
          QTot = Q(1,iTs)+Q(2,iTs)
          Grad(nDispS) = Grad(nDispS)+QTot*((EF(1,1,iTs)-EF(1,2,iTs))*(DPnt(iTs,iCen,iCar+1,1)+DCntr(jSph,iCen,iCar+1,1))+ &
                                            (EF(2,1,iTs)-EF(2,2,iTs))*(DPnt(iTs,iCen,iCar+1,2)+DCntr(jSph,iCen,iCar+1,2))+ &
                                            (EF(3,1,iTs)-EF(3,2,iTs))*(DPnt(iTs,iCen,iCar+1,3)+DCntr(jSph,iCen,iCar+1,3)))
        end do
      end if
    end do
    iCen = iCen+nIrrep/dc(mdc)%nStab
  end do
end do

return

end subroutine Cmbn_EF_DPnt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
*               2002, Roland Lindh                                     *
************************************************************************
      SubRoutine GrdTr_Alaska(GradIn,MxAto,GradOut,nGrad)
********************************************************************
*                                                                  *
*      The inverse of                                              *
*      Transforms a symmetry adapted gradient to unsymmetric  form *
*                                                                  *
*       Written by Anders Bernhardsson                             *
*       960427                                                     *
*       Modified by Roland Lindh                                   *
*       020115                                                     *
*                                                                  *
********************************************************************
      Use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8(a-h,o-z)
      parameter (tol=1d-8)
#include "Molcas.fh"
#include "disp.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 GradIn(3,MxAto), GradOut(nGrad)
      Logical TF,TstFnc
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*
      iIrrep=0
*
      mdc=0
      iCen=1
      Do iCnttp=1,nCnttp
         If (dbsc(iCnttp)%Aux) Return
         Do iCnt=1,dbsc(iCnttp)%nCntr
            mdc=mdc+1
            nDispS = IndDsp(mdc,iIrrep)

            Do iCar=0,2
               iComp = 2**iCar
               If ( TF(mdc,iIrrep,iComp)) Then
                  nDispS = nDispS + 1
                  GradOut(nDispS)=GradIn(iCar+1,iCen)
               End If
            End Do
            iCen = iCen + nIrrep/dc(mdc)%nStab
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine str2vb2_cvb(bikcof,cvb,cvbdet,iway,idetvb,i2s,nS,nalf1,nMs,absym,ndetvb,nvb,kbasis,nel,nconfion)

use casvb_global, only: ifnss1, ifnss2, ikcoff, ndetvbs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: bikcof(*)
integer(kind=iwp), intent(in) :: iway, ndetvb, idetvb(ndetvb), nS, i2S(nS), nMs, nalf1(nMs), nvb, kbasis, nel, nconfion(0:*)
real(kind=wp), intent(inout) :: cvb(nvb), cvbdet(ndetvb)
logical(kind=iwp), intent(in) :: absym
integer(kind=iwp) :: i2s_keep, i_det, i_spin, iconfadd, idadd, idet, iMs, ioff, ioff_bikcof, ion, iS, isadd, j_spin, n_det, &
                     n_det_values, n_spin, n_spin_values, nalfsing, nalfsing_det, nalfsing_keep, nelsing
integer(kind=iwp), pointer :: ifnss(:,:)
real(kind=wp), allocatable :: tmp(:,:), w(:)
real(kind=wp), parameter :: sq2 = sqrt(Two), sqp5 = sqrt(Half)

if (kbasis == 6) then
  ifnss => ifnss2
else
  ifnss => ifnss1
end if

i2s_keep = 0 ! dummy initialize
nalfsing_keep = 0 ! dummy initialize
! Determinant to structure transformation
call mma_allocate(w,ndetvb,label='w')
if (iway == 1) then
  cvb(:) = Zero
  do idet=1,ndetvb
    w(idet) = cvbdet(idetvb(idet))
  end do
else if (iway == 2) then
  w(:) = Zero
end if
idadd = 0
isadd = 0
iconfadd = 0
do ion=0,nel/2
  if (nconfion(ion) == 0) cycle
  nelsing = nel-2*ion
  ! Investigate different S and Ms possibilities and
  ! prepare to collect different BIKCOF matrices if necessary:
  n_spin = 0
  n_spin_values = 0
  do iS=1,nS
    if (i2s(iS) <= nelsing) then
      n_spin = n_spin+ifnss(nelsing,i2s(iS))
      n_spin_values = n_spin_values+1
      i2s_keep = i2s(iS)
    end if
  end do
  n_det = 0
  n_det_values = 0
  do iMs=1,nMs
    nalfsing = nalf1(iMs)-ion
    if (nalfsing >= 0) then
      n_det = n_det+ndetvbs(nelsing,nalfsing)
      n_det_values = n_det_values+1
      nalfsing_keep = nalfsing
    end if
  end do
  if (kbasis == 6) then
    do iS=1,nS
      nalfsing_det = (nelsing+i2s(iS))/2
      if (i2s(iS) <= nelsing) then
        do iMs=1,nMs
          nalfsing = nalf1(iMs)-ion
          if (nalfsing >= 0) then
            if (nalfsing /= nalfsing_det) cycle
            if (iway == 1) then
              do idet=1,ifnss(nelsing,i2s(iS))
                if ((i2s(iS) == 0) .and. absym .and. (ndetvbs(nelsing,nalfsing) /= 1)) then
                  call daxpy_(nconfion(ion),sq2,w(idet+idadd),n_det,cvb(idet+isadd),n_spin)
                else
                  call daxpy_(nconfion(ion),One,w(idet+idadd),n_det,cvb(idet+isadd),n_spin)
                end if
              end do
            else if (iway == 2) then
              do idet=1,ifnss(nelsing,i2s(iS))
                if ((i2s(iS) == 0) .and. absym .and. (ndetvbs(nelsing,nalfsing) /= 1)) then
                  call daxpy_(nconfion(ion),sqp5,cvb(idet+isadd),n_spin,w(idet+idadd),n_det)
                  call daxpy_(nconfion(ion),sqp5,cvb(idet+isadd),n_spin,w(ndetvbs(nelsing,nalfsing)-idet+1+idadd),n_det)
                else
                  call daxpy_(nconfion(ion),One,cvb(idet+isadd),n_spin,w(idet+idadd),n_det)
                end if
              end do
            end if
          end if
        end do
      end if
    end do
    ! Skip collection if not necessary ...
  else if ((n_spin_values == 1) .and. (n_det_values == 1)) then
    if (iway == 1) then
      call mxattbp_cvb(bikcof(1+ikcoff(nelsing,nalfsing_keep,i2s_keep)),w(1+idadd),n_spin,n_det,nconfion(ion),cvb(1+isadd))
    else if (iway == 2) then
      call mxatbp_cvb(bikcof(1+ikcoff(nelsing,nalfsing_keep,i2s_keep)),cvb(1+isadd),n_det,n_spin,nconfion(ion),w(1+idadd))
    end if
  else
    call mma_allocate(tmp,n_det,n_spin,label='tmp')
    tmp(:,:) = Zero
    i_spin = 1
    do iS=1,nS
      if (i2s(iS) <= nelsing) then
        i_det = 1
        do iMs=1,nMs
          nalfsing = nalf1(iMs)-ion
          if (nalfsing >= 0) then
            if (ikcoff(nelsing,nalfsing,i2s(iS)) /= -1) then
              ioff_bikcof = 1+ikcoff(nelsing,nalfsing,i2s(iS))
              ioff = i_spin
              do j_spin=1,ifnss(nelsing,i2s(iS))
                tmp(i_det:idet+ndetvbs(nelsing,nalfsing)-1,ioff) = bikcof(ioff_bikcof:ioff_bikcof+ndetvbs(nelsing,nalfsing)-1)
                ioff_bikcof = ioff_bikcof+ndetvbs(nelsing,nalfsing)
                ioff = ioff+1
              end do
            end if
            i_det = i_det+ndetvbs(nelsing,nalfsing)
          end if
        end do
        i_spin = i_spin+ifnss(nelsing,i2s(iS))
      end if
    end do

    if (iway == 1) then
      call mxattbp_cvb(tmp,w(1+idadd),n_spin,n_det,nconfion(ion),cvb(1+isadd))
    else if (iway == 2) then
      call mxatbp_cvb(tmp,cvb(1+isadd),n_det,n_spin,nconfion(ion),w(1+idadd))
    end if
    call mma_deallocate(tmp)
  end if
  isadd = isadd+nconfion(ion)*n_spin
  idadd = idadd+nconfion(ion)*n_det
  iconfadd = iconfadd+nconfion(ion)
end do
if (iway == 2) then
  do idet=1,ndetvb
    cvbdet(idetvb(idet)) = w(idet)
  end do
end if
call mma_deallocate(w)
nullify(ifnss)

return

end subroutine str2vb2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine PrIte(QNR,CMO,mBB,nD,Ovrlp,mBT,OccNo,mmB)
!***********************************************************************
!                                                                      *
!     purpose: Print out informations in every iteration               *
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!***********************************************************************

use InfSCF, only: AccCon, CPUItr, DltNrm, DltNTh, DMOMax, DNorm, DThr, E1V, E2V, EDiff, EneV, EThr, FMOMax, FThr, Iter, IterPrLv, &
                  jPrint, TNorm
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: QNR
integer(kind=iwp), intent(in) :: mBB, nD, mBT, mmB
real(kind=wp), intent(in) :: CMO(mBB,nD), Ovrlp(mBT), OccNo(mmB,nD)
real(kind=wp) :: Shift = Zero
logical(kind=iwp) :: Set_Shift = .false.
character :: cDltNrm, cDMOMax, cEDiff, cFMOMax

if (iterprlv > 0) then
  write(u6,*)
  write(u6,'(a)') '*******************'
  write(u6,'(a,i3,a)') '** Iteration ',iter,' **'
  write(u6,'(a)') '*******************'
  write(u6,*)
  write(u6,'(a,f10.2)') 'Cpu time [sec]        ',CpuItr

  select case (AccCon)
    case ('None','NoneDa')
      write(u6,'(a)') 'No convergence acceleration'
    case ('EDIIS','ADIIS')
      write(u6,'(a)') 'Convergence is accelerated by damping'
    case ('QNRc1D')
      write(u6,'(2a)') 'Convergence is accelerated by QNR with ','c1-DIIS'
    case ('QNRc2D')
      write(u6,'(2a)') 'Convergence is accelerated by QNR with ','c2-DIIS'
    case default
      write(u6,'(2a)') 'Convergence accelerations is ',AccCon
  end select

  write(u6,*)
  write(u6,'(a,f16.8)') 'Total energy          ',EneV
  write(u6,'(a,f16.8)') 'One electron energy   ',E1V
  write(u6,'(a,f16.8)') 'Two electron energy   ',E2V

  if ((abs(Ediff) > Ethr) .or. (iter <= 1)) then
    write(u6,'(a,f16.8)') 'Energy difference     ',Ediff
  else
    write(u6,'(a,f16.8,a)') 'Energy difference     ',Ediff,' is converged'
  end if

  if (QNR) then
    if (DltNrm > DltNth) then
      write(u6,'(a,f16.8)') 'Delta norm            ',DltNrm
    else
      write(u6,'(a,f16.8,a)') 'Delta norm            ',DltNrm,' is converged'
    end if
  else
    if (abs(DMOMax) > Dthr) then
      write(u6,'(a,f16.8)') 'Max offdiagonal Dij   ',DMOmax
    else
      write(u6,'(a,f16.8,a)') 'Max offdiagonal Dij   ',DMOmax,' is converged'
    end if
  end if

  if (abs(FMOMax) > Fthr) then
    write(u6,'(a,f16.8)') 'Max offdiagonal Fij   ',FMOmax
  else
    write(u6,'(a,f16.8,a)') 'Max offdiagonal Fij   ',FMOmax,' is converged'
  end if

  write(u6,'(a,f16.8)') 'D-norm                ',sqrt(Dnorm)
  write(u6,'(a,f16.8)') 'T-norm                ',sqrt(Tnorm)
  if (iterprlv >= 2) call MulPop(CMO,mBB,nD,Ovrlp,mBT,OccNo,mmB)

else if (jPrint >= 2) then

  if (.not. Set_Shift) then
    if (abs(EneV) > 1.0e3_wp) then
      Shift = abs(EneV)*1.0e-3_wp
      Shift = real(int(Shift),kind=wp)*1.0e3_wp
      write(u6,*)
      write(u6,'(1X,A,f10.0,A)') 'The total and one-electron energies are shifted by a value of ',Shift,' a.u.'
      write(u6,*)
    end if
    Set_Shift = .true.
  end if
  cEDiff = ' '
  if ((abs(Ediff) > Ethr) .or. (EDiff > Zero)) cEDiff = '*'
  cFMOMax = ' '
  if (abs(FMOMax) > Fthr) cFMOMax = '*'

  if (QNR) then
    cDltNrm = ' '
    if (DltNrm > DltNth) cDltNrm = '*'
    write(u6,'(1X,i3,3f16.9,1x,3(es10.2,a1,1x),2es11.2,3x,A,f6.0)') &
      Iter,EneV+Shift,E1V+Shift,E2V,EDiff,cEDiff,DltNrm,cDltNrm,FMOMax,cFMOMax,sqrt(DNorm),sqrt(TNorm),AccCon,CpuItr
  else
    cDMOMax = ' '
    if (abs(DMOMax) > Dthr) cDMOMax = '*'
    write(u6,'(1X,i3,3f16.9,1x,3(es10.2,a1,1x),2es11.2,3x,A,f6.0)') &
      Iter,EneV+Shift,E1V+Shift,E2V,EDiff,cEDiff,DMOMax,cDMOMax,FMOMax,cFMOMax,sqrt(DNorm),sqrt(TNorm),AccCon,CpuItr

  end if
end if
call XFlush(u6)

end subroutine prite

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
FUNCTION OVERLAP_RASSI(IFSBTAB1,IFSBTAB2,PSI1,PSI2)
! Purpose: Compute the overlap of two wave functions
! The FS blocks of the two wave functions:
use Constants, only: Zero
IMPLICIT NONE
REAL*8 OVERLAP_RASSI
REAL*8 PSI1(*),PSI2(*)
INTEGER IFSBTAB1(*),IFSBTAB2(*)
INTEGER ISSTARR(50)
INTEGER NFSB1,NASPRT1,NDETS1,KSTARR1
INTEGER NFSB2,NASPRT2,NDETS2,NHSH2,KHSH2,KSTARR2
INTEGER IFSB1,KPOS1,ISPART
INTEGER IFSB2,KPOS2
INTEGER IBLKPOS1,NBLKSIZ1
INTEGER IBLKPOS2,NBLKSIZ2
real*8 ddot_

NFSB1  =IFSBTAB1(3)
NASPRT1=IFSBTAB1(4)
NDETS1 =IFSBTAB1(5)
KSTARR1=8
NFSB2  =IFSBTAB2(3)
NASPRT2=IFSBTAB2(4)
NDETS2 =IFSBTAB2(5)
NHSH2  =IFSBTAB2(6)
KHSH2  =IFSBTAB2(7)
KSTARR2=8
OVERLAP_RASSI=Zero
IF (NFSB1.EQ.0) RETURN
IF (NFSB2.EQ.0) RETURN
IF (NASPRT1.NE.NASPRT2) then
  WRITE(6,*)' OVERLAP Error: The two wave function structures'
  WRITE(6,*)' have different nr of subpartitions!'
  CALL ABEND()
end if
IF (NDETS1.EQ.0) RETURN
IF (NDETS2.EQ.0) RETURN

! Loop over FS blocks of the PSI1 wave function
DO IFSB1=1,NFSB1
  KPOS1=KSTARR1+(NASPRT1+2)*(IFSB1-1)
  DO ISPART=1,NASPRT1
    ISSTARR(ISPART)=IFSBTAB1(KPOS1-1+ISPART)
  END DO
  NBLKSIZ1 =IFSBTAB1(KPOS1+NASPRT1  )
  IBLKPOS1 =IFSBTAB1(KPOS1+NASPRT1+1)
! Find this block in the PSI2 structure.
  CALL HSHGET(ISSTARR,NASPRT2,NASPRT2+2,IFSBTAB2(KSTARR2),NHSH2,IFSBTAB2(KHSH2),IFSB2)
  IF(IFSB2.EQ.0) cycle
  KPOS2=KSTARR2+(NASPRT2+2)*(IFSB2-1)
  NBLKSIZ2 =IFSBTAB2(KPOS2+NASPRT2  )
  IF(NBLKSIZ1.NE.NBLKSIZ2) THEN
    WRITE(6,*)' OVERLAP Error: The same FS block has not'
    WRITE(6,*)' the same size in PSI1 and PSI2.'
    CALL ABEND()
  END IF
  IBLKPOS2 =IFSBTAB2(KPOS2+NASPRT2+1)
  OVERLAP_RASSI=OVERLAP_RASSI+DDOT_(NBLKSIZ1,PSI1(IBLKPOS1),1,PSI2(IBLKPOS2),1)
END DO

END FUNCTION OVERLAP_RASSI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------
! 1998  PER-AAKE MALMQUIST
! DEPARTMENT OF THEORETICAL CHEMISTRY
! UNIVERSITY OF LUND
! SWEDEN
!--------------------------------------------

subroutine MKRHSD(IVEC,FIMO,NFIMO,ERI1,nERI1,ERI2,nERI2,SCR,nSCR)
! Set up RHS vector of PT2 Linear Equation System, in vector
! number IVEC of LUSOLV, for case 5, AIVX.

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use SUPERINDEX, only: KTU
use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array, GA_Arrays
use caspt2_module, only: NACTEL, NAES, NASH, NINDEP, NISH, NISUP, NORB, NSSH, NSYM, NTU, NTUES
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, NFIMO, nERI1, nERI2, nSCR
real(kind=wp), intent(inout) :: FIMO(NFIMO), ERI1(nERI1), ERI2(nERI2), SCR(nSCR)
integer(kind=iwp) :: IA, IATOT, IBUF1, IBUF2, ICASE, II, IO, IOFF(8), ISYM, ISYMA, ISYMI, ISYMT, ISYMU, IT, ITABS, ITTOT, IU, &
                     IUABS, IUTOT, IW1, IW2, IWA, IWI, LW, NAS, NAS1, NFIMOES, NFSUM, NIS, NV
real(kind=wp) :: FAI, ONEADD, WAITU

do ISYM=1,NSYM
  if (NINDEP(ISYM,5) == 0) cycle
  ! Set up offset table:
  IO = 0
  do ISYMA=1,NSYM
    IOFF(ISYMA) = IO
    ISYMI = Mul(ISYMA,ISYM)
    IO = IO+NSSH(ISYMA)*NISH(ISYMI)
  end do
  ! Allocate W; W subdivided into W1,W2.
  NAS1 = NTU(ISYM)
  NAS = 2*NAS1
  NIS = NISUP(ISYM,5)
  NV = NAS*NIS
  if (NV == 0) cycle
  ! Compute W1(tu,ai)=(ai,tu) + FIMO(a,i)*delta(t,u)/NACTEL
  ! Compute W2(tu,ai)=(ti,au)
  LW = Allocate_GA_Array(NV,'WD')
  NFSUM = 0
  do ISYMI=1,NSYM
    NFIMOES = NFSUM
    NFSUM = NFSUM+nTri_Elem(NORB(ISYMI))
    ISYMA = Mul(ISYMI,ISYM)
    do ISYMU=1,NSYM
      ISYMT = Mul(ISYMU,ISYM)
      do II=1,NISH(ISYMI)
        do IU=1,NASH(ISYMU)
          IUABS = IU+NAES(ISYMU)
          IUTOT = IU+NISH(ISYMU)
          call EXCH(ISYMA,ISYMI,ISYMT,ISYMU,II,IUTOT,ERI1,SCR)
          call EXCH(ISYMT,ISYMI,ISYMA,ISYMU,II,IUTOT,ERI2,SCR)
          do IA=1,NSSH(ISYMA)
            IATOT = IA+NISH(ISYMA)+NASH(ISYMA)
            ONEADD = Zero
            if (ISYM == 1) then
              FAI = FIMO(NFIMOES+iTri(IATOT,II))
              ONEADD = FAI/real(max(1,NACTEL),kind=wp)
            end if
            do IT=1,NASH(ISYMT)
              ITABS = IT+NAES(ISYMT)
              ITTOT = IT+NISH(ISYMT)
              IWA = KTU(ITABS,IUABS)-NTUES(ISYM)
              IWI = II+NISH(ISYMI)*(IA-1)+IOFF(ISYMA)
              IW1 = IWA+NAS*(IWI-1)
              IW2 = IW1+NAS1
              IBUF1 = IATOT+NORB(ISYMA)*(ITTOT-1)
              IBUF2 = ITTOT+NORB(ISYMT)*(IATOT-1)
              WAITU = ERI1(IBUF1)
              if (ITABS == IUABS) WAITU = WAITU+ONEADD
              GA_Arrays(LW)%A(IW1) = WAITU
              GA_Arrays(LW)%A(IW2) = ERI2(IBUF2)
            end do
          end do
        end do
      end do
    end do
  end do
  ! Put W on disk.
  ICASE = 5
  call MKRHS_SAVE(ICASE,ISYM,IVEC,LW)
  call Deallocate_GA_Array(LW)
end do

end subroutine MKRHSD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************

subroutine Hessian_Kriging(x0_,ddy_,ndimx)

use kriging_mod, only: hpred, x0
use Definitions, only: wp, iwp

!#define _Hess_Test
#ifdef _Hess_Test
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ndimx
real(kind=wp), intent(in) :: x0_(ndimx)
real(kind=wp), intent(out) :: ddy_(ndimx,ndimx)
#ifdef _Hess_Test
integer(kind=iwp) :: i, j
real(kind=wp) :: Delta, Fact, tmp
real(kind=wp), allocatable :: tgrad(:), thgrad(:)
real(kind=wp), parameter :: HessT = 1.0e-3_wp
#endif

!nx is the n-dimensional vector of the last iteration computed in update_sl
! subroutine
x0(:) = x0_(:)

call covarvector(2) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
call predict(2)
ddy_(:,:) = hpred(:,:)

#ifdef _Hess_Test
! Numerical Hessian of GEK
write(u6,*) 'Begining Numerical Hessian'

call mma_allocate(tgrad,ndimx,label='tgrad')
call mma_allocate(thgrad,ndimx,label='thgrad')

hpred(:,:) = Zero
write(u6,*) 'Hess Threshold',HessT

do i=1,nInter
  tmp = x0(i)

  Delta = 1.0e-5_wp !max(abs(x_(i,1)),1.0e-5_wp)*Scale

  x0(i) = tmp+Delta
  call covarvector(1) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
  call predict(1)
  tgrad = gpred(:)

  x0(i) = tmp-Delta
  call covarvector(1) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
  call predict(1)
  thgrad = gpred(:)

  do j=1,nInter
    hpred(i,j) = (tgrad(j)-thgrad(j))/(Two*Delta)
  end do
  x0(i) = tmp
end do
! Comparing Analytical solution with Numerical
do i=1,nInter
  do j=1,nInter
    write(u6,*) 'i,j',i,j
    write(u6,*) 'hpred, ddy_',hpred(i,j),ddy_(i,j)
    if (abs(ddy_(i,j)-hpred(i,j)) > HessT) then
      write(u6,*) 'Error in entry',i,',',j,'of the hessian matrix'
      call RecPrt('Anal Hess',' ',ddy_,nInter,nInter)
      call RecPrt('Num Hess',' ',hpred,nInter,nInter)
      write(u6,*) 'abs(ddy_(i,j)+ HessT)',abs(ddy_(i,j)+HessT)
      write(u6,*) 'abs(ddy_(i,j)- HessT)',abs(ddy_(i,j)-HessT)
      write(u6,*) 'abs(hpred(i,j))',abs(hpred(i,j))
      call Abend()
    end if
  end do
end do

call mma_deallocate(tgrad)
call mma_deallocate(thgrad)
#endif

return

end subroutine Hessian_Kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine TwoEl_g(Coor,iAnga,iCmp,iShell,iShll,iAO,
     &                   iStb,jStb,kStb,lStb,nRys,
     &                   Data1,nab,nHmab,nData1,Data2,ncd,nHmcd,nData2,
     &                   Pren,Prem,
     &                   nAlpha,iPrInc, nBeta,jPrInc,
     &                   nGamma,kPrInc,nDelta,lPrInc,
     &                   Coeff1,iBasi,Coeff2,jBasj,
     &                   Coeff3,kBask,Coeff4,lBasl,
     &                   Zeta,ZInv,P,nZeta,Eta,EInv,Q,nEta,
     &                   xA,xB,xG,xD,Grad,nGrad,IfGrad,IndGrd,
     &                   PSO,nPSO,Wrk2,nWrk2,Aux,nAux,Shijij)
************************************************************************
*                                                                      *
* Object: to generate the SO integrals for four fixed centers and      *
*         fixed basis set types.                                       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*          Roland Lindh, Dept. of Theoretical Chemistry, University of *
*          Lund, SWEDEN. Modified to gradients, January '92.           *
************************************************************************
      use Real_Spherical
      use Basis_Info
      use Center_Info
      use Phase_Info
      use Real_Info, only: ChiI2
      use Temporary_Parameters, only: IsChi
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External TERI1, ModU2, vCff2D
#include "Molcas.fh"
#include "ndarray.fh"
#include "real.fh"
#include "print.fh"
#include "disp.fh"
      Real*8 Data1(nZeta*(nDArray+2*nab)+nDScalar+nHmab,nData1),
     &       Data2(nEta *(nDArray+2*ncd)+nDScalar+nHmcd,nData2)
      Real*8 Coor(3,4), CoorM(3,4), CoorAC(3,2),
     &       xA(nZeta),xB(nZeta), xG(nEta), xD(nEta), Grad(nGrad),
     &       Zeta(nZeta), ZInv(nZeta), P(nZeta,3),
     &       Eta (nEta),  EInv(nEta ), Q(nEta, 3),
     &       Coeff1(nAlpha,iBasi), Coeff2(nBeta,jBasj),
     &       Coeff3(nGamma,kBask), Coeff4(nDelta,lBasl),
     &       PSO(iBasi*jBasj*kBask*lBasl,nPSO), Wrk2(nWrk2),
     &       Aux(nAux)
      Integer iDCRR(0:7), iDCRS(0:7), iDCRT(0:7), iStabN(0:7),
     &        iStabM(0:7), IndGrd(3,4), iAO(4),
     &        iAnga(4), iCmp(4), iShell(4), iShll(4),
     &        nOp(4), kOp(4), JndGrd(3,4), iuvwx(4)
      Logical Shijij, AeqB, CeqD, AeqC, ABeqCD,
     &        IfGrad(3,4), JfGrad(3,4), PreScr
#ifdef _DEBUGPRINT_
      Character ChOper(0:7)*3
      Data ChOper/' E ',' x ',' y ',' xy',' z ',' xz',' yz','xyz'/
#endif

      Call TwoEl_g_Internal(Data1,Data2)

      Contains
      Subroutine TwoEl_g_Internal(Data1,Data2)
      Use Iso_C_Binding
      Real*8, Target ::
     &       Data1(nZeta*(nDArray+2*nab)+nDScalar+nHmab,nData1),
     &       Data2(nEta *(nDArray+2*ncd)+nDScalar+nHmcd,nData2)
      Integer, Pointer :: iData1(:), iData2(:)
      Integer :: lZeta=0, lEta=0
      Logical EQ, lEmpty
      External EQ, lEmpty
#ifdef _WARNING_WORKAROUND_
*Bug in gcc 7: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=94270
      Interface
      SubRoutine Rysg1(iAnga,nRys,nT,
     &                 Alpha,Beta,Gamma,Delta,
     &                 Zeta,ZInv,nZeta,Eta,EInv,nEta,
     &                 P,lP,Q,lQ,Coori,Coora,CoorAC,
     &                 Array,nArray,
     &                 Tvalue,ModU2,Cff2D,
     &                 PAO,nPAO,Grad,nGrad,IfGrad,IndGrd,kOp,iuvwx)
      Integer :: iAnga(4),nRys,nT,nZeta,nEta,lP,lQ,nArray,nPAO,
     &           nGrad,IndGrd(3,4),kOp(4),iuvwx(4)
      Real*8 :: Alpha(nZeta),Beta(nZeta),Gamma(nEta),Delta(nEta),
     &          Zeta(nZeta),ZInv(nZeta),Eta(nEta),EInv(nEta),P(lP,3),
     &          Q(lQ,3),Coori(3,4),Coora(3,4),CoorAC(3,2),Array(nArray),
     &          PAO(nT,nPAO),Grad(nGrad)
      Logical :: IfGrad(3,4)
      External :: Tvalue, ModU2, Cff2D
      End Subroutine Rysg1
      End Interface
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function to compute canonical index
*
      nElem(i) = (i+1)*(i+2)/2
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 12
      iPrint = nPrint(iRout)
*
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      iCmpa = iCmp(1)
      jCmpb = iCmp(2)
      kCmpc = iCmp(3)
      lCmpd = iCmp(4)
      iShlla = iShll(1)
      jShllb = iShll(2)
      kShllc = iShll(3)
      lShlld = iShll(4)
      IncZet=nAlpha*jPrInc
      IncEta=nGamma*lPrInc
      LmbdT=0
      nijkl = iBasi*jBasj*kBask*lBasl
      iuvwx(1) = dc(iStb)%nStab
      iuvwx(2) = dc(jStb)%nStab
      iuvwx(3) = dc(kStb)%nStab
      iuvwx(4) = dc(lStb)%nStab
      mab = nElem(la)*nElem(lb)
      mcd = nElem(lc)*nElem(ld)
      iW4 = 1
      If (jPrInc.ne.nBeta .or. lPrInc.ne.nDelta) Then
         iW2 = 1 + mab*mcd*nijkl
      Else
         iW2 = 1
      End If
*
      If (l2DI) Then
         iffab = ip_abG(nZeta,nHmab)-1
         iffabG= ip_abG(nZeta,nHmab)+nab*nZeta-1
         iffcd = ip_abG( nEta,nHmcd)-1
         iffcdG= ip_abG( nEta,nHmcd) +ncd*nEta-1
      Else
*--------Dummy pointer to assure that we will not be out
*        off bounds.
         iffab = ip_abG(nZeta,nHmab)-nZeta-1
         iffabG= ip_abG(nZeta,nHmab)-nZeta-1
         iffcd = ip_abG( nEta,nHmcd)-nZeta-1
         iffcdG= ip_abG( nEta,nHmcd)-nZeta-1
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Find the Double Coset Representatives for center A and B
*
      If (nIrrep.eq.1) Then
         nDCRR=1
         iDCRR(0)=0
         LmbdR=1
      Else
         Call DCR(LmbdR,dc(iStb)%iStab,dc(iStb)%nStab,
     &                  dc(jStb)%iStab,dc(jStb)%nStab,iDCRR,nDCRR)
      End If
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Write (6,'(20A)') ' {R}=(',
     &      (ChOper(iDCRR(i)),',',i=0,nDCRR-1),')'
#endif
      u = DBLE(dc(iStb)%nStab)
      v = DBLE(dc(jStb)%nStab)
*
*-----Find stabilizer for center A and B
*
      If (nIrrep.eq.1) Then
         lStabM=1
         iStabM(0)=0
      Else
         Call Inter(dc(iStb)%iStab,dc(iStb)%nStab,
     &              dc(jStb)%iStab,dc(jStb)%nStab,iStabM,lStabM)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Find the Double Coset Representatives for center C and D.
*     Take care of redundancy if {f(aA)f(bB)}={f(cC)f(dD)}. Hence
*     we will only use unique combinations of operators from the
*     double coset representatives {R} and {S}.
*
      If (nIrrep.eq.1) Then
         nDCRS=1
         iDCRS(0)=0
         LmbdS=1
      Else
         Call DCR(LmbdS,dc(kStb)%iStab,dc(kStb)%nStab,
     &                  dc(lStb)%iStab,dc(lStb)%nStab,
     &                               iDCRS,nDCRS)
      End If
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Write (6,'(20A)') ' {S}=(',
     &      (ChOper(iDCRS(i)),',',i=0,nDCRS-1),')'
#endif
      w = DBLE(dc(kStb)%nStab)
      x = DBLE(dc(lStb)%nStab)
*
*-----Find stabilizer for center C and D
*
      If (nIrrep.eq.1) Then
         lStabN=1
         iStabN(0)=0
      Else
         Call Inter(dc(kStb)%iStab,dc(kStb)%nStab,
     &              dc(lStb)%iStab,dc(lStb)%nStab,iStabN,lStabN)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Find the Double Coset Representatives for the two charge
*     distributions.
*
      If (nIrrep.eq.1) Then
         nDCRT=1
         iDCRT(0)=0
         LmbdT=1
      Else
         Call DCR(LmbdT,iStabM,lStabM,iStabN,lStabN,iDCRT,nDCRT)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----------Factor due to summation over DCR
*
            If (MolWgh.eq.1) Then
               Fact = DBLE(nIrrep) / DBLE(LmbdT)
            Else If (MolWgh.eq.0) Then
               Fact = u*v*w*x / DBLE(nIrrep**3 * LmbdT)
            Else
               Fact = Sqrt(u*v*w*x)/DBLE(nIrrep*LmbdT)
            End If
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
      nOp(1)=NrOpr(0)
      CoorM(:,1)=Coor(:,1)
      Do 100 lDCRR = 0, nDCRR-1
         nOp(2)=NrOpr(iDCRR(lDCRR))
         Call OA(iDCRR(lDCRR),Coor(:,2),CoorM(:,2))
         AeqB = EQ(CoorM(:,1),CoorM(:,2))
*
         MxDCRS = nDCRS-1
         Do 200 lDCRS = 0, MxDCRS
            CoorM(:,3)=Coor(:,3)
            Call OA(iDCRS(lDCRS),Coor(1:3,4),CoorM(1:3,4))
            CeqD = EQ(Coor(:,3),CoorM(:,4))
*
            Do 300 lDCRT = nDCRT-1, 0, -1
#ifdef _DEBUGPRINT_
               If (iPrint.ge.99) Write (6,'(6A)')
     &         ' R=',ChOper(iDCRR(lDCRR)),
     &         ', S=',ChOper(iDCRS(lDCRS)),
     &         ', T=',ChOper(iDCRT(lDCRT))
#endif
*
               nOp(3) = NrOpr(iDCRT(lDCRT))
               iDCRTS=iEor(iDCRT(lDCRT),iDCRS(lDCRS))
               nOp(4) = NrOpr(iDCRTS)
*
               Call OA(iDCRTS,Coor(:,4),CoorM(:,4))
               Call OA(iDCRT(lDCRT),Coor(:,3),CoorM(:,3))
*
#ifdef _DEBUGPRINT_
               If (iPrint.ge.59)
     &            Call RecPrt(' CoorM in TwoEl',' ',CoorM,3,4)
#endif
               AeqC = EQ(CoorM(:,1),CoorM(:,3))
               ABeqCD = AeqB .and. CeqD .and. AeqC
*--------------No contribution to gradient from one-center integrals
               If (ABeqCD) Go To 301
*
*--------------Modify which center we will differetiate with
*              respect to using the translational invariance.
*
               mGrad = 0
               Do 3333 iCar = 1, 3
*-----------------Copy to temporary arrays
                  JfGrad(iCar,:)=IfGrad(iCar,:)
                  JndGrd(iCar,:)=IndGrd(iCar,:)
*-----------------In case of four differentiations use
*                 the translational invariance to remove
*                 one or several of them.
                  If (IfGrad(iCar,1) .and.
     &                IfGrad(iCar,2) .and.
     &                IfGrad(iCar,3) .and.
     &                IfGrad(iCar,4) ) Then
*
                     nIdent=0
                     kCent=0
                     lCent=0
                     Do iCent = 1, 3
                        Do jCent = iCent+1, 4
                           If (EQ(CoorM(1,iCent),
     &                            CoorM(1,jCent))) Then
                              nIdent=nIdent+1
                              kCent=iCent
                              lCent=jCent
                           End If
                        End Do
                     End Do
*
*--------------------Remove a center which is unique and if possible
*                    if it occurs several times.
*
                     If (nIdent.eq.0) Then
*---------------------- Four center case, remove a center
                        jCent=1
                        Do iCent = 1, 4
                           If (iAnga(iCent).ne.0) jCent=iCent
                        End Do
                        JndGrd(iCar,jCent) = -JndGrd(iCar,jCent)
                        JfGrad(iCar,jCent) = .False.
                     Else If (nIdent.eq.1) Then
*---------------------- Three center case
                        iiCent=kCent
                        jjCent=lCent
                        JndGrd(iCar,iiCent) = 0
                        JfGrad(iCar,iiCent) = .False.
                        JndGrd(iCar,jjCent) = -JndGrd(iCar,jjCent)
                        JfGrad(iCar,jjCent) = .False.
                     Else If (nIdent.eq.2) Then
*---------------------- Two center case
                        iiCent=kCent
                        jjCent=lCent
                        ikl=2**(kCent-1)+2**(lCent-1)
                        Do iC = 1, 4
                           If (iAnd(ikl,2**(iC-1)).eq.0) Then
                              iCent=iC
                           End If
                        End Do
                        ikl=ikl+2**(iCent-1)
                        Do iC = 1, 4
                           If (iAnd(ikl,2**(iC-1)).eq.0) Then
                              jCent=iC
                           End If
                        End Do
                        ijMax=Max(iAnga(iCent),iAnga(jCent))
                        ijMin=Min(iAnga(iCent),iAnga(jCent))
                        klMax=Max(iAnga(kCent),iAnga(lCent))
                        klMin=Min(iAnga(kCent),iAnga(lCent))
                        If (klMin.gt.0) Then
                           iiCent=kCent
                           jjCent=lCent
                        Else If (ijMin.gt.0) Then
                           iiCent=iCent
                           jjCent=jCent
                        Else If (klMax.gt.0) Then
                           iiCent=kCent
                           jjCent=lCent
                        Else If (ijMax.gt.0) Then
                           iiCent=iCent
                           jjCent=jCent
                        End If
                        JndGrd(iCar,iiCent) = 0
                        JfGrad(iCar,iiCent) = .False.
                        JndGrd(iCar,jjCent) = -JndGrd(iCar,jjCent)
                        JfGrad(iCar,jjCent) = .False.
                     Else If (nIdent.eq.3) Then
*---------------------- Two center case
                        If (lCent.ne.4) Then
                           mCent=1
                        Else If (kCent.ne.3) Then
                           mCent=1
                        Else If (EQ(CoorM(1,1),CoorM(1,4))) Then
                           mCent=1
                        Else
                           mCent=2
                        End If
                        JndGrd(iCar,mCent) = 0
                        JfGrad(iCar,mCent) = .False.
                        JndGrd(iCar,kCent) = 0
                        JfGrad(iCar,kCent) = .False.
                        JndGrd(iCar,lCent) = -JndGrd(iCar,lCent)
                        JfGrad(iCar,lCent) = .False.
                     Else
                        Call WarningMessage(2,'Error in Twoel_g')
                        Write (6,*) ' Twoel: nIdent too large!'
                        Call Abend()
                     End If
                  End If
                  Do 4444 ixSh = 1, 4
                     If (JfGrad(iCar,ixSh)) mGrad=mGrad+1
 4444             Continue
 3333          Continue
               If (mGrad.eq.0) Go To 301
*
*--------------Find the proper centers to start of with the angular
*              momentum on. If la.eq.lb there will excist an
*              ambiguity to which center that angular momentum should
*              be accumulated on. In that case we will use A and C of
*              the order as defined by the basis functions types.
*
               If (iAnga(1).ge.iAnga(2)) Then
                  CoorAC(:,1)=CoorM(:,1)
               Else
                  CoorAC(:,1)=CoorM(:,2)
               End If
               If (iAnga(3).ge.iAnga(4)) Then
                  CoorAC(:,2)=CoorM(:,3)
               Else
                  CoorAC(:,2)=CoorM(:,4)
               End If
               kOp(:) = nOp(:)

*
*--------------Desymmetrize the second order density matrix
*
*--------------(faA fbR(B) | fcT(C) fdTS(D))ijkl
*
               Call DesymP(iAnga,iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &                     Shijij,iShll,iShell,iAO,kOp,nijkl,
     &                     Aux,nAux,Wrk2(iW2),PSO,nPSO)
*
               If (Fact.ne.One) Call DScal_(nijkl*
     &             iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4),
     &             Fact,Wrk2(iW2),1)
*
*--------------Backtransform 2nd order density matrix from spherical
*              harmonic gaussians to cartesian gaussians.
*
               ijklab = nijkl * iCmp(1)*iCmp(2)
               nW2 = ijklab*Max(kCmpc*lCmpd,mcd)
               iW3_ = iW2 + nW2
               nWrk3_ = nWrk2 - ((iW2-iW4) + nW2)
               Call SphCr1(Wrk2(iW2),ijklab,
     &                     Wrk2(iW3_),nWrk3_,
     &                     RSph(ipSph(lc)),nElem(lc),kCmpc,
     &                     Shells(kShllc)%Transf,
     &                     Shells(kShllc)%Prjct,
     &                     RSph(ipSph(ld)),nElem(ld),lCmpd,
     &                     Shells(lShlld)%Transf,
     &                     Shells(lShlld)%Prjct,
     &                     Wrk2(iW2),mcd)
               If (iW2.eq.iW4) Then
                  nW2 = nijkl*mcd*Max(iCmpa*jCmpb,mab)
                  nW4 = 0
               Else
                  nW2 = nijkl*mcd*iCmpa*jCmpb
                  nW4 = nijkl*mcd*mab
               End If
               iW3_=iW2 + nW2
               nWrk3_ = nWrk2 - (nW2 + nW4)
               Call SphCr2(Wrk2(iW2),nijkl,mcd,
     &                     Wrk2(iW3_),nWrk3_,
     &                     RSph(ipSph(la)),nElem(la),iCmpa,
     &                     Shells(iShlla)%Transf,
     &                     Shells(iShlla)%Prjct,
     &                     RSph(ipSph(lb)),nElem(lb),jCmpb,
     &                     Shells(jShllb)%Transf,
     &                     Shells(jShllb)%Prjct,
     &                     Wrk2(iW4),mab)
*
*--------------Transpose the 2nd order density matrix
*
               If (mab*mcd.ne.1) Then
                  iW3_ = iW4 + nijkl*mab*mcd
                  Call DGetMO(Wrk2(iW4),nijkl,nijkl,mab*mcd,Wrk2(iW3_),
     &                        mab*mcd)
                  call dcopy_(mab*mcd*nijkl,Wrk2(iW3_),1,Wrk2(iW4),1)
               End If
*
               lDCR1=NrOpr(iDCRR(lDCRR))+1
               lDCR2=NrOpr(iDCRS(lDCRS))+1
               ix1 = 1
               iy1 = 1
               iz1 = 1
               ix2 = iPhase(1,iDCRT(lDCRT))
               iy2 = iPhase(2,iDCRT(lDCRT))
               iz2 = iPhase(3,iDCRT(lDCRT))
*
               Call C_F_Pointer(C_Loc(Data1(ip_IndZ(1,nZeta),lDCR1)),
     &                         iData1,[nZeta+1])
               Call C_F_Pointer(C_Loc(Data2(ip_IndZ(1,nEta ),lDCR2)),
     &                         iData2,[nEta +1])
               nZeta_Tot=iData1(nZeta+1)
               nEta_Tot =iData2(nEta +1)
*
*--------------Loops to partion the primitives
*
               Do 400 iZeta = 1, nZeta_Tot, IncZet
                  mZeta=Min(IncZet,nZeta_Tot-iZeta+1)
                  If (lEmpty(Coeff2,nBeta, nBeta ,jBasj)) Go To 400
*
               Do 410 iEta  = 1, nEta_Tot,  IncEta
                  mEta=Min(IncEta,nEta_Tot-iEta+1)
                  If (lEmpty(Coeff4,nDelta,nDelta,lBasl)) Go To 410
*
                  Pren = Pren + DBLE(mab*mcd*mZeta*mEta)
*
*-----------------Preprescreen
*
                  Call PrePre_g(nZeta,nEta,mZeta,mEta,lZeta,lEta,
     &                          Data1(ip_Z   (iZeta,nZeta),lDCR1),
     &                          Data2(ip_Z   (iEta, nEta), lDCR2),
     &                          PreScr,CutGrd)
                  If (lZeta*lEta.eq.0) Go To 410
*
*-----------------Decontract the 2nd order density matrix
*
                  If (iW4.eq.iW2) Then
                     nW4=0
                     nW2=Max(nijkl,mZeta*mEta)*mab*mcd
                  Else
                     nW4=nijkl*mab*mcd
                     nW2=mZeta*mEta*mab*mcd
                  End If
                  iW3_ = iW2 + nW2
                  nWrk3_ = nWrk2 - (nW4+nW2)
                  Call Tcrtnc(Coeff1,nAlpha,iBasi,
     &                        Coeff2,nBeta,jBasj,
     &                        Coeff3,nGamma,kBask,
     &                        Coeff4,nDelta,lBasl,
     &                        Wrk2(iW4),mab*mcd,Wrk2(iW3_),nWrk3_,
     &                        Wrk2(iW2),
     &                        iData1(iZeta:iZeta+mZeta-1),mZeta,
     &                        iData2(iEta: iEta +mEta -1),mEta)
*
*-----------------Transfer k2 data and prescreen
*
                  iW3_ = iW2 + mZeta*mEta*mab*mcd
                  nWrk3_ = nWrk2 - mZeta*mEta*mab*mcd
                  Call Screen_g(Wrk2(iW2),Wrk2(iW3_),mab*mcd,nZeta,nEta,
     &                        mZeta,mEta,lZeta,lEta,
     &                        Zeta,ZInv,P,xA,xB,
     &                        Data1(iZeta,lDCR1),
     &                        nAlpha,jPrim,
     &                        iData1(iZeta:iZeta+mZeta-1),
     &                        Eta, EInv,Q,xG,xD,
     &                        Data2(iEta ,lDCR2),
     &                        nGamma,lPrim,
     &                        iData2(iEta :iEta +mEta -1),
     &                        ix1,iy1,iz1,ix2,iy2,iz2,
     &                        CutGrd,l2DI,
     &                        Data1(iZeta+iffab ,lDCR1),
     &                        Data1(iZeta+iffabG,lDCR1),nab,
     &                        Data2(iEta +iffcd ,lDCR2),
     &                        Data2(iEta +iffcdG,lDCR2),ncd,
     &                        PreScr,nWrk3_,IsChi,ChiI2)
                  Prem = Prem + DBLE(mab*mcd*lZeta*lEta)
c                 Write (*,*) 'Prem=',Prem
                  If (lZeta*lEta.eq.0) Go To 410
*
*-----------------Compute integral derivative and accumulate
*                 contribution to the molecular gradient. Note that
*                 the PSO matrix now is stored in Wrk2(iW2).
*
                  iW3_ = iW2 + lZeta*lEta*mab*mcd
                  Call Rysg1(iAnga,nRys,lZeta*lEta,
     &                       xA,xB,xG,xD,
     &                       Zeta,ZInv,lZeta,
     &                       Eta,EInv,lEta,
     &                       P,nZeta,Q,nEta,
     &                       CoorM,CoorM,CoorAC,Wrk2(iW3_),nWrk3_,
     &                       TERI1,ModU2,vCff2D,
     &                       Wrk2(iW2),mab*mcd,
     &                       Grad,nGrad,JfGrad,JndGrd,kOp,iuvwx)
                  Aha=Sqrt(DDot_(nGrad,Grad,1,Grad,1))
                  If (Aha.gt.1.0D+5) Then
                      Write (6,*)
     &                      'Norm of gradient contribution is huge!'
                      Write (6,*) 'Probably due to wrong coordinates.'
                  End If
*
 410           Continue
 400           Continue
               Nullify(iData1,iData2)
*
#ifdef _DEBUGPRINT_
               If (iPrint.ge.19) Call PrGrad(' In TwoEl',
     &                     Grad,nGrad,ChDisp,5)
#endif
*
 301          Continue
 300        Continue
 200     Continue
 100  Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(iAO)
         Call Unused_integer(iPrInc)
         Call Unused_integer(kPrInc)
      End If
      End Subroutine TwoEl_g_Internal
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Roland Lindh                                     *
*               2012, Andy May                                         *
************************************************************************
************************************************************************
*                                                                      *
*----- Statement functions to access the k2 data in the k2 data        *
*      memory block                                                    *
*                                                                      *
*      These functions should eventually be used globally for any      *
*      seward utility, be it integrals, gradients, direct Fock,        *
*      direct integrals, and second order derivatives.                 *
*                                                                      *
*                          W A R N I N G !                             *
*                                                                      *
*                                                                      *
*      Observe that the index array (IndZ) should always be placed     *
*      after all arrays with real!                                     *
*                                                                      *
*      Real Arrays:                                                    *
*      alpha  : alpha Gaussian exponent                                *
*      beta   : beta  Gaussian exponent                                *
*      Z      : alpha+beta Gaussian exponent                           *
*      Kappa  : Common factor from Gaussian product theorem            *
*      Pcoor  : Coordinates of Gaussian product                        *
*      ab     : Max(|(ab|ab)|^{1/2})    (primitive basis)              *
*               over all angular components                            *
*      abCon  : Max(|(ab|ab)|^{1/2})* C ("contracted basis")           *
*               over all angular components                            *
*                                                                      *
*      Integer Arrays:                                                 *
*      IndZ   : Pair index (rectangular indexation), the last          *
*               entry in the array contains the effective number       *
*               of elements                                            *
*                                                                      *
*      Scalars:                                                        *
*      EstI   : Estimated largest contracted integral |(ab|ab)|^{1/2}  *
*      ZtMax  : Z of the largest abCon                                 *
*      abMax  : largest abCon                                          *
*      ZetaM  : largest Zeta value                                     *
*      ZtMaxD : Z of the largest ab * D                                *
*      abMaxD : largest ab * D                                         *
*                                                                      *
*      Auxiliary arrays:                                               *
*      HrrMtrx: matrices to use for transformation from intermediate   *
*               integrals to real spherical harmonics                  *
*                                                                      *
*      Author: R. Lindh                                                *
*              Dept. of Chemical Physics                               *
*              University of Lund, Sweden                              *
*              April 1999                                              *
*                                                                      *
*      Converted from statement functions by A. May June 2012          *
************************************************************************
*                                                                      *
      Integer Function ip_Z(iZeta,nZeta)
      Implicit None
      Integer iZeta,nZeta
      ip_Z = iZeta
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nZeta)
      End

      Integer Function ip_Kappa(iZeta,nZeta)
      Implicit None
      Integer iZeta,nZeta
      ip_Kappa = iZeta + nZeta
      Return
      End

      Integer Function ip_Pcoor(iZeta,nZeta)
      Implicit None
      Integer iZeta,nZeta
      ip_Pcoor = iZeta + 2*nZeta
      Return
      End

      Integer Function ip_ZInv(iZeta,nZeta)
      Implicit None
      Integer iZeta,nZeta
      ip_ZInv = iZeta + 5*nZeta
      Return
      End

      Integer Function ip_ab(iZeta,nZeta)
      Implicit None
      Integer iZeta,nZeta
      ip_ab = iZeta + 6*nZeta
      Return
      End

      Integer Function ip_abCon(iZeta,nZeta)
      Implicit None
      Integer iZeta,nZeta
      ip_abCon = iZeta + 7*nZeta
      Return
      End

      Integer Function ip_Alpha(iZeta,nZeta,iAB)
      Implicit None
      Integer iZeta,nZeta,iAB
      ip_Alpha = iZeta + (8+iAB-1)*nZeta
      Return
      End

      Integer Function ip_Beta(iZeta,nZeta,iAB)
      Implicit None
      Integer iZeta,nZeta,iAB
      ip_Beta = iZeta + (8+iAB-1)*nZeta
      Return
      End

      Integer Function ip_IndZ(iZeta,nZeta)
      Implicit None
      Integer iZeta,nZeta
      ip_IndZ = iZeta + 10*nZeta
      Return
      End

      Integer Function ip_EstI(nZeta)
      Implicit None
      Integer nZeta
      ip_EstI = 1 + 11*nZeta + 1
      Return
      End

      Integer Function ip_ZtMax(nZeta)
      Implicit None
      Integer nZeta
      ip_ZtMax = 2 + 11*nZeta + 1
      Return
      End

      Integer Function ip_abMax(nZeta)
      Implicit None
      Integer nZeta
      ip_abMax = 3 + 11*nZeta + 1
      Return
      End

      Integer Function ip_ZetaM(nZeta)
      Implicit None
      Integer nZeta
      ip_ZetaM = 4 + 11*nZeta + 1
      Return
      End

      Integer Function ip_ZtMaxD(nZeta)
      Implicit None
      Integer nZeta
      ip_ZtMaxD = 5 + 11*nZeta + 1
      Return
      End

      Integer Function ip_abMaxD(nZeta)
      Implicit None
      Integer nZeta
      ip_abMaxD = 6 + 11*nZeta + 1
      Return
      End

      Integer Function ip_nHm(nZeta)
      Implicit None
      Integer nZeta
      ip_nHm = 7 + 11*nZeta + 1
      Return
      End

      Integer Function ip_HrrMtrx(nZeta)
      Implicit None
      Integer nZeta
      ip_HrrMtrx = 8 + 11*nZeta + 1
      Return
      End

      Integer Function ip_abG(nZeta,nHm)
      Implicit None
      Integer nZeta,nHm
      ip_abG = 8+nHm + 11*nZeta + 1
      Return
      End
*                                                                      *
************************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2000, Roland Lindh                                *
!***********************************************************************

subroutine PrRF(DSCF,NonEq,iCharge,jPrint)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!                                                                      *
!             Modified for Langevin polarizabilities, Marsk 2000 (RL)  *
!***********************************************************************

use External_Centers, only: iXPolType, nXF
use rctfld_module, only: aFac, cLim, Conductor, CordSI, DieDel, DipSI, Eps, EpsInf, gAtom, latato, lLangevin, lMax, lRF, lRFCav, &
                         nExpo, PCM, PolSI, PreFac, RadLat, rds, RslPar, ScaAA, ScalA, ScalB, ScalC, Solvent, TK
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: DSCF, NonEq
integer(kind=iwp), intent(inout) :: iCharge
integer(kind=iwp), intent(in) :: jPrint
integer(kind=iwp) :: StrnLn, i, j, nSolvent
real(kind=wp) :: AArea, R_Min_Sphere

if (jPrint >= 2) then
  if (lRF .and. (.not. PCM) .and. lRFCav) then
    write(u6,*)
    write(u6,'(5X,A)') 'Reaction Field calculation: the Kirkwood model'
    write(u6,'(5X,A,ES10.3)') ' Dielectric Constant :',Eps
    write(u6,'(5X,A,ES10.3)') ' Eps_opt             :',EpsInf
    write(u6,'(5X,A,ES10.3)') ' Radius of Cavity(au):',rds
    write(u6,'(5X,A,I2)') ' l_Max               :',lMax
    if (NonEq) then
      write(u6,'(5X,A)') ' Calculation type    : non-equilibrium'
    else
      write(u6,'(5X,A)') ' Calculation type    : equilibrium'
    end if
    write(u6,*)
  end if
  if (iXPolType > 0) then
    write(u6,*)
    write(u6,'(5X,A)') ' Explicit polarisabilities activated'
    write(u6,'(5X,A)') ' -----------------------------------'
    write(u6,'(5X,A,I2)') ' Number of points    :',nXF
    if (iXPolType == 1) then
      write(u6,'(5X,A)') ' Polarisabilities are isotropic'
    else if (iXPolType == 2) then
      write(u6,'(5X,A)') ' Polarisabilities are anisotropic'
    end if
    write(u6,*)
  end if
  if (lLangevin) then
    write(u6,'(5X,A)') 'Langevin dipole moments activated'
    write(u6,'(5X,A,I2)') ' Gitter type         :',latato
    write(u6,'(5X,A)') ' Gitter centers'
    do i=1,latato
      write(u6,'(3(5x,F10.4))') (Cordsi(j,i),j=1,3)
    end do
    write(u6,'(5X,A,ES10.3)') ' Max. Latt. Extn(au) :',radlat
    write(u6,'(5X,A,F10.4)') ' Cell dimensions     :',scala
    write(u6,'(5X,A,F10.4)') '                      ',scalb
    write(u6,'(5X,A,F10.4)') '                      ',scalc
    write(u6,'(5X,A,F10.4)') ' Overal scaling      :',scaaa
    write(u6,'(5X,A,F10.4)') ' Site polarizability :',polsi
    write(u6,'(5X,A,F10.4)') ' Site dipole moment  :',dipsi
    write(u6,'(5X,A,F10.4)') ' Atoms in the latt.  :',gAtom
    write(u6,'(5X,A,F10.4)') ' Diel. delete param. :',diedel
    write(u6,'(5X,A,F10.4)') ' Inverse Boltzman f. :',tK
    write(u6,'(5X,A,ES10.1)') ' clim                :',clim
    write(u6,'(5X,A,F10.4)') ' afac                :',afac
    write(u6,'(5X,A,I10  )') ' nexp                :',nexpo
    write(u6,'(5X,A,F10.4)') ' prefac              :',prefac
    write(u6,*)
  end if
  if (PCM) then
    aArea = RSlPar(7)
    r_min_Sphere = RSlPar(3)
    write(u6,*)
    write(u6,'(5X,A)') ' Polarizable Continuum Model (PCM) activated'
    nSolvent = StrnLn(Solvent)
    write(u6,'(5X,A,A)') ' Solvent: ',Solvent(1:nSolvent)
    if (.not. Conductor) then
      write(u6,'(5X,A)') ' Version: Dielectric'
    else
      write(u6,'(5X,A)') ' Version: Conductor'
    end if
    write(u6,'(5X,A,F6.4,A)') ' Average area for surface element on the cavity boundary: ',aArea,' angstrom^2'
    write(u6,'(5X,A,F6.4,A)') ' Minimum radius for added spheres: ',r_min_Sphere,' angstrom'
    if (NonEq) then
      write(u6,'(5X,A)') ' Calculation type: non-equilibrium (slow component from JobOld)'
    else
      write(u6,'(5X,A)') ' Calculation type: equilibrium'
    end if
    write(u6,*)
  end if
end if

if (lRF) call Init_RctFld(NonEq,iCharge)
if (DSCF) call Allok2()

return

end subroutine PrRF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine Localise_Noniterative(irc,Model,xNrm)
C
C     Author: T.B. Pedersen
C
C     Purpose: Non-iterative localisation of orbitals.
C              Models implemented:
C                Cholesky [MODEL='CHOL']
C                PAO      [MODEL='PAO ']
C
      Implicit Real*8 (a-h,o-z)
      Character*4 Model
#include "Molcas.fh"
#include "inflocal.fh"
#include "WrkSpc.fh"

      Character*21 SecNam
      Parameter (SecNam = 'Localise_Noniterative')

      Character*4  myModel
      Character*6  Namefile
      Character*80 Txt

      Logical Test_OrthoPAO, Normalize
      Parameter (Test_OrthoPAO = .False.)

      Dimension dum(1),idum(1)

      irc = 0
      xNrm = 0.0d0

      myModel = Model
      Call UpCase(myModel)
      If (myModel .eq. 'CHOL') Then
*        If (.not.Silent) Then
            Write(6,'(/,1X,A)') 'Cholesky localisation'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Convergence threshold:',Thrs,' (decomposition)'
            Write(6,'(1X,A,8(1X,I6))')
     &      'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
            Write(6,'(1X,A,8(1X,I6))')
     &      'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
*        End If
         l_Dens = nBas(1)**2
         Do iSym = 2,nSym
            l_Dens = max(l_Dens,nBas(iSym)**2)
         End Do
         Call GetMem('Density','Allo','Real',ip_Dens,l_Dens)
         kOffC = ipCMO
         Do iSym = 1,nSym
            If (nOrb2Loc(iSym) .gt. 0) Then
               kOff1 = kOffC + nBas(iSym)*nFro(iSym)
               Call GetDens_Localisation(Work(ip_Dens),Work(kOff1),
     &                                   nBas(iSym),nOrb2Loc(iSym))
               Call ChoLoc(irc,Work(ip_Dens),Work(kOff1),Thrs,yNrm,
     &                     nBas(iSym),nOrb2Loc(iSym))
               xNrm = xNrm + yNrm*yNrm
               If (irc .ne. 0) Then
                  Call GetMem('Density','Free','Real',ip_Dens,l_Dens)
                  irc  = 1
                  xNrm = -9.9d9
                  Return
               End If
            End If
            kOffC = kOffC + nBas(iSym)**2
         End Do
         xNrm = sqrt(xNrm)
         Call GetMem('Density','Free','Real',ip_Dens,l_Dens)
      Else If (myModel .eq. 'PAO ') Then
*        If (.not.Silent) Then
            Write(6,'(/,1X,A)') 'PAO Cholesky localisation'
            Write(6,'(1X,A,1X,D12.4,A)')
     &      'Convergence threshold:',Thrs,' (decomposition)'
            Write(6,'(1X,A,8(1X,I6))')
     &      'Frozen orbitals      :',(nFro(iSym),iSym=1,nSym)
            Write(6,'(1X,A,8(1X,I6))')
     &      'Orbitals to localise :',(nOrb2Loc(iSym),iSym=1,nSym)
*        End If
         l_Dv = nBas(1)**2
         l_R = nBas(1)**2
         Do iSym = 2,nSym
            l_R = l_R + nBas(iSym)**2
            l_Dv = max(l_Dv,nBas(iSym)**2)
         End Do
         Call GetMem('R','Allo','Real',ip_R,l_R)
         Call GetMem('Dv','Allo','Real',ip_Dv,l_Dv)
         Normalize = .True.
         Call GetRawPAOs(Work(ip_R),Work(ipCMO),nBas,nOrb,nFro,nOrb2Loc,
     &                   nSym,Normalize)
         kSav = 0
         If (AnaPAO) Then
            l_DvSav = l_R
            Call GetMem('DvSav','Allo','Real',ip_DvSav,l_DvSav)
            kSav = ip_DvSav
         End If
         kOffR = ip_R
         kOffC = ipCMO
         Do iSym = 1,nSym
            If (nOrb2Loc(iSym) .gt. 0) Then
               Call GetDens_Localisation(Work(ip_Dv),Work(kOffR),
     &                                   nBas(iSym),nBas(iSym))
               If (AnaPAO) Then
                  Call dCopy_(nBas(iSym)**2,Work(ip_Dv),1,Work(kSav),1)
                  kSav = kSav + nBas(iSym)**2
               End If
               kOff1 = kOffC + nBas(iSym)*nFro(iSym)
               Call ChoLoc(irc,Work(ip_Dv),Work(kOff1),Thrs,yNrm,
     &                     nBas(iSym),nOrb2Loc(iSym))
               xNrm = xNrm + yNrm*yNrm
               If (irc .ne. 0) Then
                  If (AnaPAO) Then
                     Call GetMem('DvSav','Free','Real',ip_DvSav,l_DvSav)
                  End If
                  Call GetMem('Dv','Free','Real',ip_Dv,l_Dv)
                  Call GetMem('R','Free','Real',ip_R,l_R)
                  irc  = 1
                  xNrm = -9.9d9
                  Return
               End If
            End If
            kOffR = kOffR + nBas(iSym)**2
            kOffC = kOffC + nBas(iSym)**2
         End Do
         xNrm = sqrt(xNrm)
         If (AnaPAO) Then
            Call PAO_Analysis(Work(ip_DvSav),Work(ip_R),Work(ipCMO))
            Call GetMem('DvSav','Free','Real',ip_DvSav,l_DvSav)
         End If
         Write(Namefile,'(A)') 'DPAORB'
         Write(Txt,'(80X)')
         Write(Txt,'(A)') 'Linearly dependent PAOs'
         Lu_=isFreeUnit(11)
         Call WrVec_Localisation(Namefile,Lu_,'CO',nSym,nBas,nBas,
     &                           Work(ip_R),Work(ipOcc),dum,idum,Txt)
*        If (.not.Silent) Then
            Write(6,'(1X,A)') 'The DPAORB file has been written.'
*        End If
         Write(Namefile,'(A)') 'IPAORB'
         Write(Txt,'(80X)')
         Write(Txt,'(A)') 'Linearly independent PAOs'
         Lu_=isFreeUnit(11)
         Call WrVec_Localisation(Namefile,Lu_,'CO',nSym,nBas,nBas,
     &                           Work(ipCMO),Work(ipOcc),dum,idum,Txt)
*        If (.not.Silent) Then
            Write(6,'(1X,A)') 'The IPAORB file has been written.'
*        End If
         Call GetMem('Dv','Free','Real',ip_Dv,l_Dv)
         Call GetMem('R','Free','Real',ip_R,l_R)
         nOrPs = 2 ! use 2 orthonorm. passes for num. accuracy
         Call OrthoPAO_Localisation(Work(ipCMO),nBas,nFro,nOrb2Loc,nSym,
     &                              nOrPs,Test_OrthoPAO)
      Else
         Write(Txt,'(A,A4)') 'Model = ',Model
         Call SysAbendMsg(SecNam,'Unknown model',Txt)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2016,2017, Roland Lindh                                *
!***********************************************************************

subroutine GMFree()

use InfSCF, only: CMO, CMO_ref, Darwin, Dens, EDFT, EOrb, FockAO, FockMO, HDiag, KntE, MssVlc, OccNo, OneHam, OrbType, Ovrlp, TrM, &
                  TwoHam, Vxc
#ifdef _FDE_
use Embedding_Global, only: embInt
#endif
use stdalloc, only: mma_deallocate

implicit none

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Deallocate memory
call mma_deallocate(Darwin)
call mma_deallocate(MssVlc)
call mma_deallocate(KntE)
call mma_deallocate(EDFT)
call mma_deallocate(TwoHam)
call mma_deallocate(Vxc)
call mma_deallocate(Dens)
call mma_deallocate(OrbType)
call mma_deallocate(EOrb)
call mma_deallocate(OccNo)
call mma_deallocate(FockMO)
call mma_deallocate(FockAO)
call mma_deallocate(CMO_ref)
call mma_deallocate(CMO)
call mma_deallocate(TrM)

call mma_deallocate(Ovrlp)
call mma_deallocate(OneHam)
call mma_deallocate(HDiag)
#ifdef _FDE_
call mma_deallocate(embInt,safe='*')
#endif

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine GMFree

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine axbres_cvb(dum,sxc,rhs,res,
     >  solp_res,maxdav,n,itdav,eig_res,
     >  is_converged)
      implicit real*8 (a-h,o-z)
      logical is_converged
#include "direct_cvb.fh"
      dimension sxc(n,maxdav),rhs(n),res(n)
      dimension solp_res(maxdav)

      call mxatb_cvb(sxc,solp_res,n,itdav,1,res)
      call dscal_(n,-eig_res,res,1)
      call addvec(res,res,rhs,n)

      is_converged=.true.
      return
c Avoid unused argument warnings
      if (.false.) call Unused_real(dum)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine PCM_EF_grd(Grad,nGrad)
      use Basis_Info
      use Center_Info
      use PCM_arrays
      use Temporary_Parameters, only: PrPrt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      Real*8 Grad(nGrad)
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      Logical Save_tmp, Found
      Real*8 EF_Temp(3)
      Real*8, Allocatable :: Cord(:,:), Chrg(:), FactOp(:)
      Integer, Allocatable :: lOper(:)
      Real*8, Allocatable:: D1ao(:)
*
      iRout = 1
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
*                                                                      *
************************************************************************
*                                                                      *
      Save_tmp=PrPrt
      PrPrt=.True.
      nOrdOp=1
      nComp=(nOrdOp+1)*(nOrdOp+2)/2
      Call GetMem('EF','Allo','Real',ip_EF,nComp*2*nTs)
      ip_EF_nuclear   =ip_EF
      ip_EF_electronic=ip_EF + nComp
*                                                                      *
************************************************************************
*                                                                      *
      Call Get_nAtoms_All(MaxAto)
*
      Call mma_allocate(Cord,3,MaxAto)
      Call mma_allocate(Chrg,MaxAto)
*
      ndc = 0
      nc = 1
      Do jCnttp = 1, nCnttp
         If (dbsc(jCnttp)%Aux) Cycle
         Z = dbsc(jCnttp)%Charge
         mCnt = dbsc(jCnttp)%nCntr
         Do jCnt = 1, mCnt
            ndc = ndc + 1
            Do i = 0, nIrrep/dc(ndc)%nStab - 1
               Call OA(dc(ndc)%iCoSet(i,0),dbsc(jCnttp)%Coor(1:3,jCnt),
     &                 Cord(1:3,nc))
               Chrg(nc) = Z
               nc = nc + 1
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the the electric field on the tiles
*
*     1) The nuclear contribution
*
      ip_EF_n=ip_EF_nuclear
      ip_EF_e=ip_EF_electronic
      Do iTile = 1, nTs
         Call EFNuc(PCMTess(1,iTile),Chrg,Cord,MaxAto,EF_temp,nOrdOp)
         Work(ip_EF_n  )=EF_Temp(1)
         Work(ip_EF_n+1)=EF_Temp(2)
         Work(ip_EF_n+2)=EF_Temp(3)
         Work(ip_EF_e  )=Zero
         Work(ip_EF_e+1)=Zero
         Work(ip_EF_e+2)=Zero
         ip_EF_n = ip_EF_n + 2*nComp
         ip_EF_e = ip_EF_e + 2*nComp
      End Do
*
      Call mma_deallocate(Cord)
      Call mma_deallocate(Chrg)
*
*     2) The electronic contribution
*
*
*     Get the total 1st order AO density matrix
*
      Call Qpg_dArray('D1ao',Found,nDens)
      If (Found .and. nDens/=0) Then
         Call mma_allocate(D1ao,nDens,Label='D1ao')
      Else
         Write (6,*) 'pcm_ef_grd: D1ao not found.'
         Call Abend()
      End If
      Call Get_D1ao(D1ao,nDens)
*
      Call mma_allocate(FactOp,nTs)
      Call mma_allocate(lOper,nTs)
      Call DCopy_(nTs,[One],0,FactOp,1)
      Call ICopy(nTs,[255],0,lOper,1)
*
      Call Drv1_PCM(FactOp,nTs,D1ao,nDens,
     &              PCMTess,lOper,Work(ip_EF),nOrdOp)
*
      Call mma_deallocate(lOper)
      Call mma_deallocate(FactOp)
      Call mma_deallocate(D1ao)
*                                                                      *
************************************************************************
*                                                                      *
*     Now form the correct combinations
*
      Call Cmbn_EF_DPnt(Work(ip_EF),nTs,dPnt,MaxAto,
     &                  dCntr,nS,PCMiSph,PCM_SQ,Grad,nGrad)
*
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('EF','Free','Real',ip_EF,nComp*2*nTs)
      PrPrt=Save_tmp
      Call Free_iSD()
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHO_X_GET_PARDIAG(jSym,iSO_ab)
!***********************************************************************
! Returns an array of the "a" and "b" indices that give rise to the
! parent diagonal from which a given J-index has been originated
! by the (molecular) Cholesky decomposition procedure
!
!   ia=iSO_ab(1,numcho(jSym))  contains the index of the basis "a"
!                              within its symm. block.
!                              (Note: there is an integer function
!                              "cho_isao(ia)" that returns the
!                              irrep to which "a" belongs)
!
!   "Location 2" of iSO_ab returns the same kind of info for "b"
!
!
! Author: F. Aquilante
!
!***********************************************************************

#ifdef _MOLCAS_MPP_
use Para_Info, only: MyRank, nProcs
use stdalloc, only: mma_allocate, mma_deallocate
#endif
use Cholesky, only: iiBstR, InfVec, iRS2F, NumCho
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: jSym
integer(kind=iwp), intent(_OUT_) :: iSO_ab(2,*)
integer(kind=iwp) :: iOff, jRab, jv, kRab
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iRank, kv, nTot
integer(kind=iwp), allocatable :: ip_List(:), ip_Aux(:,:)
#endif

iOff = 0

#ifdef _MOLCAS_MPP_
call mma_allocate(ip_List,[0,nProcs-1],Label='ip_List')
ip_List(:) = 0
ip_List(MyRank) = NumCho(jSym)
call Cho_GAIGOP(ip_List,nProcs,'+')
nTot = 0
do iRank=1,nProcs
  nTot = nTot+ip_List(iRank-1)
  if (iRank == MyRank) iOff = nTot
end do
call mma_deallocate(ip_List)
#endif

do jv=1,NumCho(jSym)

  jRab = InfVec(jv,1,jSym) ! addr. 1st red set within jSym

  kRab = iiBstr(jSym,1)+jRab ! global addr. 1st red set

  iSO_ab(1,jv+iOff) = iRS2F(1,kRab) !global addr. of a in SO list
  iSO_ab(2,jv+iOff) = iRS2F(2,kRab) !same for b, always (a >= b)
end do

#ifdef _MOLCAS_MPP_
call mma_allocate(ip_Aux,2,nTot,Label='ip_Aux')
ip_Aux(:,:) = 0
do jv=1,NumCho(jSym)
  kv = InfVec(jv,5,jSym)
  ip_Aux(1,kv) = iSO_ab(1,jv+iOff)
  ip_Aux(2,kv) = iSO_ab(2,jv+iOff)
end do
iSO_ab(:,1:nTot) = ip_Aux(:,1:nTot)
call mma_deallocate(ip_Aux)
call Cho_GAIGOP(iSO_ab,2*nTot,'+')
#endif

return

end subroutine CHO_X_GET_PARDIAG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Logical Function R_Stab_A(R,S,nS)
      Integer S(nS), R
*
      R_Stab_A = .False.
      Do iS = 1, nS
         If (R.eq.S(iS)) Then
            R_Stab_A = .True.
            Return
         End If
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Stblz(iChxyz,nStab,jStab,MaxDCR,iCoSet)
      use Symmetry_Info, only: iOper, nIrrep
      Implicit Real*8 (a-h,o-z)
      Integer jStab(0:7), iCoSet(0:7,0:7)
*                                                                      *
************************************************************************
*                                                                      *
*     Find the Stabilizers of this center
*                                                                      *
************************************************************************
*                                                                      *
      iStab = 0
      Do i = 0, nIrrep-1
         If (iAnd(iChxyz,iOper(i)).eq.0) Then
            iStab = iStab + 1
            jStab(iStab-1) = iOper(i)
         End If
      End Do
      nStab = iStab
      MaxDCR = Max(MaxDCR,iStab)
*                                                                      *
************************************************************************
*                                                                      *
*     Generate all possible (left) CoSet
*                                                                      *
************************************************************************
*                                                                      *
      Do i = 0, nIrrep-1
         Do j = 0, iStab-1
            iCoSet(i,j) = iEor(iOper(i),jStab(j))
         End Do
      End Do
      If (iStab.eq.1) Go To 39 ! skip if all are unique
*
*     Order the Coset so we will have the unique ones first
*
      nMax = 1
      If (nMax.eq.nIrrep/iStab) Go To 39 ! skip if there is only one
      iTest=iStab-1 ! Test on the last element
      Do 35 j = 1, nIrrep-1 !
*        Check uniqueness
         Do i = 0, nMax-1
            Do ielem = 0, iStab-1
               If (iCoSet(i,iTest).eq.iCoSet(j,ielem)) Go To 35
            End Do
         End Do
*        Move unique CoSet to nMax+1
         nMax = nMax + 1
         Do ielem = 0, iStab-1
            iTmp = iCoSet(nMax-1,ielem)
            iCoSet(nMax-1,ielem) = iCoSet(j,ielem)
            iCoSet(j,ielem) = iTmp
         End Do
         If (nMax.eq.nIrrep/iStab) Go To 39
 35   Continue
 39   Continue
*                                                                      *
************************************************************************
*                                                                      *
      Do i = 0, nIrrep/iStab-1
         iOpMn=iCoSet(i,0)
         Do j = 1, iStab-1
            iOpMn=iAnd(iOpMn,iCoset(i,j))
         End Do
         ip=0
         Do j = 0, iStab-1
            If (iOpMn.eq.iCoSet(i,j)) ip = j
         End Do
         iTmp=iCoSet(i,0)
         iCoSet(i,0)=iCoSet(i,ip)
         iCoSet(i,ip)=iTmp
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function D_Bend(Ind,iOp_,nSym)
      use Slapaf_Info, only: jStab, nStab
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Integer Ind(3), iOp_(3)
      Real*8 D_Bend
*                                                                      *
************************************************************************
*                                                                      *
*---- B E N D  (iAtom,mAtom,jAtom)
*
      D_Bend=Zero
*
      iAtom=Ind(1)
      mAtom=Ind(2)
      jAtom=Ind(3)
      iOp_E=iOp_(1)
      iOp_R=iOp_(2)
      iOp_T=iOp_(3)
*
*     Pick up the dimension of the stabilizer and store the operator
*     indices in iU_*
*
      nU_A=nStab(iAtom)
      iU_A=iU(jStab(0,iAtom),nU_A)
*
      nU_B=nStab(mAtom)
      iU_B=iU(jStab(0,mAtom),nU_B)
*
      nU_C=nStab(jAtom)
      iU_C=iU(jStab(0,jAtom),nU_C)
*
*     Write (*,*) ' U_A',iU_A,nU_A
*     Write (*,*) ' U_B',iU_B,nU_B
*     Write (*,*) ' U_C',iU_C,nU_C
*
*---- Form the stabilizer for ((iAtom,mAtom),jAtom)
*
      If (iAtom.eq.mAtom.and.iAtom.eq.jAtom) Then
*
*        A-R(A)-T(A)
*
         iOp_ER=iEor(iOp_E,iOp_R)
         iU_AB=iOr(iU_A,iUR(iOp_ER,iU_A))
         iOp_ET=iEor(iOp_E,iOp_T)
         iU_ABC=iOr(iU_AB,iUR(iOp_ET,iU_C))
      Else If (iAtom.eq.jAtom) Then
*
*        A-R(B)-T(A)
*
         iOp_ET=iEor(iOp_E,iOp_T)
         iU_AC=iOr(iU_A,iUR(iOp_ET,iU_C))
         iU_ABC=iAnd(iU_AC,iU_B)
      Else If (mAtom.eq.jAtom) Then
*
*        A-R(B)-T(B)
*
         iU_ABC=iAnd(iU_A,iU_C)
      Else If (iAtom.eq.mAtom) Then
*
*        A-R(A)-T(C)
*
         iU_ABC=iAnd(iU_A,iU_C)
      Else
*
*        A-R(B)-T(C)
*
         iU_AB=iAnd(iU_A,iU_B)
         iU_ABC=iAnd(iU_AB,iU_C)
      End If
      nU_ABC=nU(iU_ABC)
*
*---- Compute the degeneracy of the angle
*
      ideg=nSym/nU_ABC
      D_Bend=DBLE(iDeg)
*
C     Write (*,*) ' D_Bend=',D_Bend
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine CiOvlp(jRoot,S1,S2,CI_vec)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Compute the overlap of the CI_vector, CI_vec, with the           *
*     a set of test vectors.                                           *
*                                                                      *
*     calling arguments:                                               *
*     jRoot   : integer                                                *
*               root identifier                                        *
*     S1      : array of real*8, input/output                          *
*               overlap matrix with test vectors                       *
*     S2      : array of real*8, input/output                          *
*               norm of the test configurations in the CI vector       *
*     CI_vec  : array of real*8, input                                 *
*               CI_vector                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)


#include "rasdim.fh"
#include "general.fh"
#include "rasscf.fh"

      Dimension S1(lRoots,lRoots)
      Dimension S2(lRoots,lRoots)
      Dimension CI_vec(nConf)

      If ( ITER.eq.1 ) Return

      Do kRoot = 1,nRoots
        Sum1 = 0.0d0
        Sum2 = 0.0d0
        Do kRef = 1,mxRef
          iConf = jCj(kRoot,kRef)
          If ( iConf.ne.0 ) then
            Sum1 = Sum1 + cCI(kRoot,kRef)*CI_vec(iConf)
            Sum2 = Sum2 + CI_vec(iConf)*CI_vec(iConf)
          End If
        End Do
        S1(jRoot,kRoot) = Abs(Sum1)
        S2(jRoot,kRoot) = Sum2
      End Do

      Return
      End

      Subroutine CiSelect(S1,S2)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Select CI_vector which matches best the test vectors             *
*                                                                      *
*     calling arguments:                                               *
*     S1      : array of real*8, input/output                          *
*               overlap matrix with test vectors                       *
*     S2      : array of real*8, input/output                          *
*               norm of the test configurations in the CI vector       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)


#include "rasdim.fh"
#include "general.fh"
#include "rasscf.fh"

      Dimension S1(lRoots,lRoots)
      Dimension S2(lRoots,lRoots)

      Dimension iTemp(mxRoot)

      If ( ITER.eq.1 ) Return

*     make a local copy of the present selection vector of weights
      Call iCopy(mxRoot,[0],1,iTemp,1)

*     make a new choice using the overlap ov the etst vector with
*     the CI vector in the subspace of the test vector
      Do kRoot = 1,nRoots
*...    search for the element of largest overlap
        maxS1  = 1
        S1max  = S1(1,kRoot)
        Do jRoot = 1,lRoots
          If( S1(jRoot,kRoot).gt.S1max ) then
            maxS1 = jRoot
            S1max = S1(jRoot,kRoot)
          End If
        End Do
        iTemp(kRoot) = maxS1
*...    cleanup,to ensure that we don't pick the same root twice
        Do jRoot = 1,nRoots
          S1(maxS1,jRoot) = S1(maxS1,jRoot)-999999.0d0
        End Do
      End Do

*     Restore S1
      Do kRoot = 1,nRoots
        Do jRoot = 1,nRoots
          S1(iTemp(kRoot),jRoot) = S1(iTemp(kRoot),jRoot)+999999.0d0
        End Do
      End Do

*     print
      If ( nRoots.eq.1 ) then
        Write (6,'(6X,A,T45,10I6)')
     &   'new root selected:',(iTemp(kRoot),kRoot=1,nRoots)
        Write (6,'(6X,A,T45,10F6.3)')
     &   'overlap           ',(S1(iTemp(kRoot),kRoot),kRoot=1,nRoots)
      Else
        Write (6,'(6X,A,T45,10I6)')
     &   'new roots selected:',(iTemp(kRoot),kRoot=1,nRoots)
        Write (6,'(6X,A,T45,10F6.3)')
     &   'overlap           ',(S1(iTemp(kRoot),kRoot),kRoot=1,nRoots)
      End If

*     Compare the overlap elemets <1|2> and <1|1> where
*     |1> is the CI vector in the subspace of the test vector and
*     |2> is the test vector.
*     The program breaks execution if the following roules apply:
*     If <1|2> is less than 0.5*<1|1>
*     If the weight of <1|2> or <1|1> is less than 0.3
      istop = 0
      icase1 = 1
      icase2 = 2
      icase3 = 4
      Do kRoot = 1,nRoots
        S1jk = S1(iTemp(kRoot),kRoot)
        S2jk = S2(iTemp(kRoot),kRoot)
        If ( S1jk.lt.0.5d0*S2jk ) istop = IOR(istop,icase1)
        If ( Sqrt(S1jk).lt.0.316d0 ) istop = IOR(istop,icase2)
        If ( Sqrt(S2jk).lt.0.3d0 ) istop = IOR(istop,icase3)
      End Do

*     If the stop flag has been set write an approriate message
*     and to stop execution change the iteration counter.
      If ( istop.ge.1 ) then
        Write (6,*)
        Write (6,'(6X,120A1)') ('=',i=1,120)
        If ( IAND(istop,icase1).ne.0 ) then
          Write (6,'(6X,A)')
     &    'The projection of the CI vector(s) onto the model vector(s)'
          Write (6,'(6X,A)')
     &    'is smaller than half the norm of the subspace.'
        End If
        If ( IAND(istop,icase2).ne.0 ) then
          Write (6,'(6X,A)')
     &    'The overlap of the projected CI vector(s) and the model '//
     &    'vector(s) is smaller than 0.1'
        End If
        If ( IAND(istop,icase3).ne.0 ) then
          Write (6,'(6X,A)')
     &    'The weight(s) of the subspace is(are) smaller than 30% '//
     &    'of the total wave function(s)'
        End If
        Write (6,'(6X,A)')
     &  'Please, check your model space'
        Write (6,'(6X,A)')
     &  'The program stops after the next iteration'
        Write (6,'(6X,120A1)') ('=',i=1,120)
        Write (6,*)
        Write (6,*)
        MAXIT=ITER
      Else
        Call iCopy(nRoots,iTemp,1,iRoot,1)
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
************************************************************************
      Subroutine Cnthlf(Coeff1,nCntr1,nPrm1,Coeff2,nCntr2,nPrm2,
     &                  lZeta,nVec,First,IncVec,A1,A2,A3,
     &                  Indij)
************************************************************************
*                                                                      *
* Object: to do a half transformation. The loop over the two matrix-   *
*         matrix multiplications is segmented such that the end of the *
*         intermediate matrix will not push the start of the same out  *
*         from the cache.                                              *
*                                                                      *
* Author:     Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 Coeff1(nPrm1,nCntr1), Coeff2(nPrm2,nCntr2),
     &       A1(lZeta,nVec), A2(IncVec,nprm2),
     &       A3(nVec,nCntr1,nCntr2)
      Parameter (mxnprm=1000)   ! be aware of aCD(fat) basis sets.
      Integer Indij(lZeta),idone(mxnprm),nnz2(mxnprm),
     &        ifirst(mxnprm),last(mxnprm)
      Logical First
*
      If (nPrm1.gt.mxnprm .or.
     &    nPrm2.gt.mxnprm) Then
          Call WarningMessage(2,'CntHlf: nPrm.gt.mxnprm')
          Call Abend()
      End If
*
*     Sparsity check
*
      iz2=0
      nz2=0
      minva=max(4,(nPrm2+1)/2)
      Do iCntr2 = 1,nCntr2
         nnz2(icntr2)=0
         ifirst(icntr2)=nPrm2+1
         last(icntr2)=0
         Do iPrm2 = 1,nPrm2
            If (Coeff2(iPrm2,iCntr2).ne.Zero) Then
               ifirst(icntr2)=min(ifirst(icntr2),iprm2)
               last(icntr2)=max(last(icntr2),iprm2)
               nnz2(icntr2)=nnz2(icntr2)+1
             End If
         End Do
         If (nnz2(icntr2).ge.minva.and.nz2.eq.iCntr2-1) nz2=iCntr2
      End Do
*
*-----Loop sectioning
*
      Do iiVec = 1, nVec, IncVec
         mVec = Min(IncVec,nVec-iiVec+1)
*                                                                      *
************************************************************************
*                                                                      *
*--------First quarter transformation
*
         Do iCntr1 = 1, nCntr1
            Do iprm2=1,nprm2
               idone(iprm2)=0
            End Do
*
            Do iZeta = 1, lZeta
               iPrm2 = (Indij(iZeta)-1)/nPrm1 + 1
               iPrm1 = Indij(iZeta) - (iPrm2-1)*nPrm1
               C1=Coeff1(iPrm1,iCntr1)
               If (Abs(C1).gt.Zero) Then
                  If (idone(iprm2).gt.0) Then
                     Call DaXpY_(mVec,C1,A1(iZeta,iiVec),lZeta,
     &                                  A2(1,iPrm2),1)
                  Else
                     Call DYaX(mVec,C1,A1(iZeta,iiVec),lZeta,
     &                                 A2(1,iPrm2),1)
                     idone(iprm2)=1
                  End If
               End If
            End Do ! iZeta
*                                                                      *
************************************************************************
*                                                                      *
*-----------Second quarter transformation
*
            Do iprm2=1,nprm2
               If (idone(iprm2).eq.0) Call FZero(a2(1,iprm2),mvec)
            End Do
*
            ic1=1
            If (nz2.gt.1) Then
               If (first) Then
                  Call DGEMM_('n','n',mVec,nz2,nprm2,
     &                       1.0d0,A2,IncVec,Coeff2,nprm2,
     &                       0.0d0,A3(iivec,iCntr1,1),nvec*ncntr1)
               Else
C                  Call mxmb(A2,1,IncVec, Coeff2,1,nprm2,
C     &                      A3(iivec,iCntr1,1),1,nvec*ncntr1,
C     &                       mVec,nPrm2,nz2)
                  Call DGEMM_('N','N',mVec,nz2,nPrm2,
     &                         1.0d0,A2,IncVec,Coeff2,nprm2,
     &                         1.0d0,A3(iivec,iCntr1,1),nvec*ncntr1)
               End If
               ic1=nz2+1
            End If
*
            Do iCntr2=ic1,nCntr2
               If (first) Then
                  If (nnz2(icntr2).ge.minva) Then
C                     Call mxva(A2,1,IncVec, Coeff2(1,icntr2),1,
C     &                         A3(iivec,iCntr1,icntr2),1,mVec,nPrm2)
                      Call dGeMV_('N',mVec,nPrm2,1.d0,A2,IncVec,
     &                            Coeff2(1,icntr2),1,0.d0,
     &                            A3(iivec,iCntr1,icntr2),1)
                  Else
                     iprm2=ifirst(icntr2)
                     c2=coeff2(iprm2,icntr2)
                     Call DYaX(mVec,C2,A2(1,iPrm2),1,
     &                                 A3(iiVec,iCntr1,iCntr2),1)
*
                     iPrm2=ifirst(icntr2)+1
                     mPrm2=last(iCntr2)-iPrm2+1
                     If (mPrm2.gt.0)
     &                  Call DNaXpY(mPrm2,mVec,Coeff2(iPrm2,iCntr2),1,
     &                              A2(1,iPrm2),1,IncVec,
     &                              A3(iiVec,iCntr1,iCntr2),1,0)
*
                  End If
               Else
                  If (nnz2(icntr2).ge.minva) Then
C                     Call mxvb(A2,1,IncVec, Coeff2(1,icntr2),1,
C     &                         A3(iivec,iCntr1,icntr2),1,mVec,nPrm2)
                      Call dGeMV_('N',mVec,nPrm2,1.d0,A2,IncVec,
     &                            Coeff2(1,icntr2),1,1.d0,
     &                            A3(iivec,iCntr1,icntr2),1)
                  Else
                     iPrm2=ifirst(icntr2)
                     mPrm2=last(icntr2)-iPrm2+1
                     Call DNaXpY(mPrm2,mVec,Coeff2(iPrm2,iCntr2),1,
     &                           A2(1,iPrm2),1,IncVec,
     &                           A3(iiVec,iCntr1,iCntr2),1,0)
                  End If
               End If
            End Do ! iCntr2
         End Do    ! iCntr1
*
*-----End of loop sectioning
*
      End Do    ! iiVec
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine divthelp2(t2,dima,dimb,dimi,dimj,dpa,dpb,dpi,dpj,shift_a,shift_b)
! this routine does:
! t2(a,b,i,j) = t2(a,b,i,j)/(dpi(i)+dpj(j)-dpa(a)-dpb(b))
!
! t2      - T2 matrix (I/O)
! dima    - 1 dimension of T2 (I)
! dimb    - 2 dimension of T2 (I)
! dimi    - 3 dimension of T2 (I)
! dimj    - 4 dimension of T2 (I)
! dpa     - diagonal part of Fok corresponding to irrep of a (I)
! dpb     - diagonal part of Fok corresponding to irrep of b (I)
! dpi     - diagonal part of Fok corresponding to irrep of i (I)
! dpj     - diagonal part of Fok corresponding to irrep of j (I)
! shift_a - number off occ orbitals in spin and symmetry of a (I)
! shift_b - number off occ orbitals in spin and symmetry of b (I)
!
! N.B. Since for T1 i and a are of the same spin, there is no reason
! to specify spin of dp. It must be automatically the same spin as i and a.

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimi, dimj, shift_a, shift_b
real(kind=wp), intent(inout) :: t2(dima,dimb,dimi,dimj)
real(kind=wp), intent(in) :: dpa(*), dpb(*), dpi(*), dpj(*)
integer(kind=iwp) :: a, b, i, j
real(kind=wp) :: den, denij, denijb, denj

do j=1,dimj
  denj = dpj(j)
  do i=1,dimi
    denij = denj+dpi(i)
    do b=1,dimb
      denijb = denij-dpb(shift_b+b)
      do a=1,dima
        ! t2(a,b,i,j)=t2(a,b,i,j)/(denijb-dpa(shift_a+a))

        den = denijb-dpa(shift_a+a)
        if ((abs(den) >= 1.0e-7_wp) .or. (abs(t2(a,b,i,j)) > 1.0e-10_wp)) t2(a,b,i,j) = t2(a,b,i,j)/den

      end do
    end do
  end do
end do

return

end subroutine divthelp2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine rm_AuxShell(iCnttp)
!***********************************************************************
!                                                                      *
!     Remove an auxiliary basis set by making it empty.                *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, Shells
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iCnttp
integer(kind=iwp) :: iShll, k

!                                                                      *
!***********************************************************************
!                                                                      *
do k=0,dbsc(iCnttp)%nShells-1
  iShll = dbsc(iCnttp)%iVal+k

  Shells(iShll)%nExp = 0
  Shells(iShll)%nBasis = 0
  Shells(iShll)%nBasis_c = 0

end do
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine rm_AuxShell

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine map (wrk,wrksize,
     & nind,p,q,r,s,
     & mapda,mapia,ssa,mapdb,mapib,possb0,posst,rc)
c
c     this routine realize mappings
c
c     B(indb) <-- A(inda)
c     where inda are order of indexes in mtx A and indb = Perm(inda)
c
c     nind   - number of indexes in matrix A (and B)  (Input)
c     p      - possition of 1-st index od mtx A in mtx B  (Input)
c     q      - possition of 2-nd index od mtx A in mtx B  (Input)
c     r      - possition of 3-rd index od mtx A in mtx B  (Input)
c     s      - possition of 4-th index od mtx A in mtx B  (Input)
c     mapda  - direct map matrix corresponding to A  (Input)
c     mapia  - inverse map matrix corresponding to A  (Input)
c     ssa    - overall symetry state  of matrix A  (Input)
c     mapdb  - direct map matrix corresponding to B  (Output)
c     mapib  - inverse map matrix corresponding to B  (Output)
c     possb0 - initial possition of matrix B in WRK  (Input)
c     posst  - final possition of matrix B in WRK (Output, not used yet)
c     rc     - return (error) code  (Output)
c
c
c     The table of implemented permutations
c
c     ninda  typA   p  q  r  s            Operation                 Implemented
c
c     4     0     all 24 comb.    A(1,2,3,4) -> B(p,q,r,s)             Yes
c
c     4     1     1  2  3  4      A(12,3,4)  -> B(12,3,4)              Yes
c     4     1     1  2  4  3      A(12,3,4)  -> B(12,4,3)              Yes
c     4     1     2  3  1  4      A(12,3,4)  -> B(3,12,4)              Yes
c     4     1           4  1      A(12,3,4)  -> B(4,12,3)              Yes
c     4     1     3  4  1  2      A(12,3,4)  -> B(3,4,12)              Yes
c     4     1           2  1      A(12,3,4)  -> B(4,3,12)              Yes
c     4     1     other comb.                                          No
c
c     4     2     1  2  3  4      A(1,23,4)  -> B(1,23,4)              Yes
c     4     2     4  2  3  1      A(1,23,4)  -> B(4,23,1)              Yes
c     4     2     3  1  2  4      A(1,23,4)  -> B(23,1,4)              Yes
c     4     2     4        3      A(1,23,4)  -> B(23,4,1)              Yes
c     4     2     1  3  4  2      A(1,23,4)  -> B(1,4,23)              Yes
c     4     2     2        1      A(1,23,4)  -> B(4,1,23)              Yes
c     4     2     other comb.                                          No
c
c     4     3     1  2  3  4      A(1,2,34)  -> B(1,2,34)              Yes
c     4     3     2  1  3  4      A(1,2,34)  -> B(2,1,34)              Yes
c     4     3     3  4  1  2      A(1,2,34)  -> B(34,1,2)              Yes
c     4     3     4  4            A(1,2,34)  -> B(34,2,1)              Yes
c     4     3     1  4  2  3      A(1,2,34)  -> B(1,34,2)              Yes
c     4     3     4  1            A(1,2,34)  -> B(2,34,1)              Yes
c     4     3     other comb.                                          No
c
c     4     4     1  2  3  4      A(12,34)   -> B(12,34)               Yes
c     4     4     3  4  1  2      A(12,34)   -> B(32,12)               Yes
c     4     4     other comb.                                          No
c
c     3     0     all 6 comb.     A(1,2,3)   -> B(p,q,r)               Yes
c
c     3     1     1  2  3  -      A(12,3)    -> B(12,3)                Yes
c     3     1     2  3  1  -      A(12,3)    -> B(3,12)                Yes
c     3     1     other comb.                                          No
c
c     3     2     1  2  3         A(1,23)    -> B(1,23)                Yes
c     3     2     3  1  2         A(1,23)    -> B(23,1)                Yes
c     3     2     other comb.                                          No
c
c     2     0     all 2 comb.     A(1,2)     -> B(p,q)                 Yes
c
c     2     1     1  2  -  -      A(12)      -> B(12)                  Yes
c     2     1     other comb.                                          No
c
c
#include "ccsd1.fh"
#include "wrk.fh"

c
       integer nind,p,q,r,s,ssa,possb0,posst,rc
       integer mapda(0:512,1:6),mapdb(0:512,1:6)
       integer mapia(1:8,1:8,1:8),mapib(1:8,1:8,1:8)
c
       integer type(1:4),dl(1:4),sa(1:4)
       integer nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6,nhelp7
       integer ia,ib,typ,newtyp
c
       rc=0
c
c     some test of correctness
c
       nhelp1=p+q+r+s
       if ((nind.eq.1).and.(nhelp1.eq.1)) then
       else if ((nind.eq.2).and.(nhelp1.eq.3)) then
       else if ((nind.eq.3).and.(nhelp1.eq.6)) then
       else if ((nind.eq.4).and.(nhelp1.eq.10)) then
       else
c     RC=1 - uncorrect indexes
       rc=1
       return
       end if
c
c     ******** No permutation *******
c
       if (nind.eq.1) then
       call noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,possb0,posst)
       return
       end if
c
       if ((nind.eq.2).and.(p.eq.1).and.(q.eq.2)) then
       call noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,possb0,posst)
       return
       end if
c
       if ((nind.eq.3).and.(p.eq.1).and.(q.eq.2).and.(r.eq.3)) then
       call noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,possb0,posst)
       return
       end if
c
       if ((nind.eq.4).and.(p.eq.1).and.(q.eq.2).and.(r.eq.3)
     &     .and.(s.eq.4)) then
       call noperm (wrk,wrksize,
     & mapda,mapia,mapdb,mapib,possb0,posst)
       return
       end if
c
       if (nind.eq.2) then
c
c     *********** 2 index ***********
c
       typ=mapda(0,6)
c
       if (typ.eq.0) then
c
c2.1  map A(p,q) -> B(q,p)
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       call grc0 (nind,0,type(1),type(2),0,0,ssa,
     & possb0,posst,mapdb,mapib)
c
       do 210 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 210
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       ib=mapib(sa(1),1,1)
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       call map21 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,p,q,1)
c
 210    continue
c
       else
c     RC=2 - bad typ for: nind=2
       rc=2
       end if
c
       else if (nind.eq.3) then
c
c     *********** 3 index ***********
c
       typ=mapda(0,6)
c
       if (typ.eq.0) then
c
c3.1  map A(p,q,r) -> B(p1,q1,r1)
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       call grc0 (nind,0,type(1),type(2),type(3),0,ssa,
     & possb0,posst,mapdb,mapib)
c
       do 310 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 310
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       ib=mapib(sa(1),sa(2),1)
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,r
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,p,q,r,1)
c
 310    continue
c
       else if (typ.eq.1) then
c
c3.2  map A(pq,r)
c     => only sophystical order of p,q,r is 2,3,1 i.e. B(r,pq)
c     => newtyp=2
c
       if ((p.eq.2).and.(q.eq.3).and.(r.eq.1)) then
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       call grc0 (nind,2,type(1),type(2),type(3),0,ssa,
     & possb0,posst,mapdb,mapib)
c
       do 320 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 320
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       ib=mapib(sa(1),sa(2),1)
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
c
c     dimpq
       if (sa(1).eq.sa(2)) then
       nhelp7=nhelp3*(nhelp3-1)/2
       else
       nhelp7=nhelp3*nhelp4
       end if
       call map21 (wrk(nhelp1),wrk(nhelp2),nhelp7,nhelp5,2,1,1)
c
 320    continue
c
       else
c     RC=3 - bad order of p,q,r for: nind=3,typ=1
       rc=3
       end if
c
       else if (typ.eq.2) then
c
c3.3  map A(p,qr)
c     => only sophystical order of p,q,r is 3,1,2 i.e. B(qr,p)
c     => typb=1
c
       if ((p.eq.3).and.(q.eq.1).and.(r.eq.2)) then
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       call grc0 (nind,1,type(1),type(2),type(3),0,ssa,
     & possb0,posst,mapdb,mapib)
c
       do 330 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 330
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       ib=mapib(sa(1),sa(2),1)
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
c
c     dimpq
       if (sa(1).eq.sa(2)) then
       nhelp7=nhelp4*(nhelp4-1)/2
       else
       nhelp7=nhelp4*nhelp5
       end if
       call map21 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp7,2,1,1)
c
 330    continue
c
       else
c     RC=4 - bad order of p,q,r for: nind=3,typ=2
       rc=4
       end if
c
       else
c     RC=5 - bad type for: nind=3
       rc=5
       end if
c
       else if (nind.eq.4) then
c
c     *********** 4 index ***********
c
       typ=mapda(0,6)
c
       if (typ.eq.0) then
c
c4.1  map A(p,q,r,s)
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       type(s)=mapda(0,4)
       call grc0 (nind,0,type(1),type(2),type(3),type(4),ssa,
     & possb0,posst,mapdb,mapib)
c
       do 410 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 410
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       sa(s)=mapda(ia,6)
       ib=mapib(sa(1),sa(2),sa(3))
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
       nhelp6=dimm(mapda(0,4),sa(s))
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             p,q,r,s,1)
c
 410    continue
c
       else if ((typ.gt.0).and.(typ.lt.4)) then
c
c4.2  map A(p,q,r,s) with one limitation
c
c     def newtype and do corresponding tests
c
       if (typ.eq.1) then
       if ((p.gt.3).or.((q-p).ne.1)) then
c     RC=6 bad order of p,q,r,s, for: nind=4,typ=1
       rc=6
       return
       else
       nhelp1=p
       end if
       else if (typ.eq.2) then
       if ((q.gt.3).or.((r-q).ne.1)) then
c     RC=7 bad order of p,q,r,s, for: nind=4,typ=2
       rc=7
       return
       else
       nhelp1=q
       end if
       else if (typ.eq.3) then
       if ((r.gt.3).or.((s-r).ne.1)) then
c     RC=8 bad order of p,q,r,s, for: nind=4,typ=3
       rc=8
       return
       else
       nhelp1=r
       end if
       end if
       newtyp=nhelp1
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       type(s)=mapda(0,4)
       call grc0 (nind,newtyp,type(1),type(2),type(3),type(4),ssa,
     & possb0,posst,mapdb,mapib)

       do 420 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 420
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       sa(s)=mapda(ia,6)
       ib=mapib(sa(1),sa(2),sa(3))
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr,dims
       dl(p)=dimm(mapda(0,1),sa(p))
       dl(q)=dimm(mapda(0,2),sa(q))
       dl(r)=dimm(mapda(0,3),sa(r))
       dl(s)=dimm(mapda(0,4),sa(s))
c
       if ((newtyp.eq.1).and.(sa(1).eq.sa(2))) then
c     B(p1q1,r1,s1) case => oldtyp can be 2,3
       nhelp7=dl(1)*(dl(1)-1)/2
c
       if (typ.eq.1) then
c     A(pq,r,s) case
c     A(pq,r,s) -> A(pq,s,r)
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),1,3,2,1)
       else if (typ.eq.2) then
c     A(p,qr,s) case
       if (p.eq.3) then
c     A (p,qr,s) -> B(qr,p,s)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),2,1,3,1)
       else
c     A (p,qr,s) -> B(qr,s,p)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),3,1,2,1)
       end if
       else
c     A(p,q,rs) case
       if (p.eq.3) then
c     A (p,q,rs) -> B(rs,p,q)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,2,3,1,1)
       else
c     A (p,q,rs) -> B(rs,q,p)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,3,2,1,1)
       end if
       end if
c
       else if ((newtyp.eq.2).and.(sa(2).eq.sa(3))) then
c     B(p1,q1r1,s1) case => oldtyp can be 1,3
       nhelp7=dl(2)*(dl(2)-1)/2
       if (typ.eq.1) then
c     A(pq,r,s) case
       if (r.eq.1) then
c     A (pq,r,s) -> B(r,pq,s)
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),2,1,3,1)
       else
c     A (pq,r,s) -> B(s,pq,p)
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),2,3,1,1)
       end if
       else if (typ.eq.2) then
c     A(p,qr,s) case
c     A(p,qr,s) -> B(s,qr,p)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),3,2,1,1)
       else
c     A(p,q,rs) case
       if (p.eq.1) then
c     A (p,q,rs) -> B(p,rs,q)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,1,3,2,1)
       else
c     A (p,q,rs) -> B(q,rs,p)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,3,1,2,1)
       end if
       end if
c
       else if ((newtyp.eq.3).and.(sa(3).eq.sa(4))) then
c     B(p1,q1,r1s1) case => oldtyp can be 1,2
       nhelp7=dl(3)*(dl(3)-1)/2
       if (typ.eq.1) then
c     A(pq,r,s) case
       if (r.eq.2) then
c     A (pq,r,s) -> B(r,s,pq)
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),3,1,2,1)
       else
c     A (pq,r,s) -> B(s,r,pq)
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp7,dl(r),dl(s),3,2,1,1)
       end if
       else if (typ.eq.2) then
c     A(p,qr,s) case
       if (p.eq.1) then
c     A (p,qr,s) -> B(p,s,qr)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),1,3,2,1)
       else
c     A (p,qr,s) -> B(s,p,qr)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),nhelp7,dl(s),2,3,1,1)
       end if
       else
c     A(p,q,rs) case
c     A(p,q,rs) -> A(q,p,rs)
       call map31 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),nhelp7,2,1,3,1)
       end if
c
       else
c     B(p1,q1,r1,s1) case
       call map41 (wrk(nhelp1),wrk(nhelp2),dl(p),dl(q),dl(r),dl(s),p,q,
     &             r,s,1)
       end if
c
 420    continue
c
c
       else if (typ.eq.4) then
c
c4.2  map A(pq,rs) -> B(rs,pq)
c
c     tests
c
       if ((p.ne.3).and.(q.ne.4).and.(r.ne.1).and.(s.ne.2)) then
c     RC=9 : nind=4, typA=4 (bad order of p,q,r,s, Stup)
       rc=9
       return
       end if
c
c     get mapdb,mapib
c
       type(p)=mapda(0,1)
       type(q)=mapda(0,2)
       type(r)=mapda(0,3)
       type(s)=mapda(0,4)
       call grc0 (nind,4,type(1),type(2),type(3),type(4),ssa,
     & possb0,posst,mapdb,mapib)
c
       do 430 ia=1,mapda(0,5)
       if (mapda(ia,2).eq.0) goto 430
c
       sa(p)=mapda(ia,3)
       sa(q)=mapda(ia,4)
       sa(r)=mapda(ia,5)
       sa(s)=mapda(ia,6)
       ib=mapib(sa(1),sa(2),sa(3))
c
c     possitions of A,B
       nhelp1=mapda(ia,1)
       nhelp2=mapdb(ib,1)
c
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa(p))
       nhelp4=dimm(mapda(0,2),sa(q))
       nhelp5=dimm(mapda(0,3),sa(r))
       nhelp6=dimm(mapda(0,4),sa(s))
c
       if ((sa(p).eq.sa(q)).and.(sa(r).eq.sa(s))) then
c     A(pq,rs) -> B(rs,pq)
       nhelp3=nhelp3*(nhelp3-1)/2
       nhelp5=nhelp5*(nhelp5-1)/2
       call map21 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5,2,1,1)
c
       else if (sa(p).eq.sa(q)) then
c     A(pq,r,s) -> B(r,s,pq)
       nhelp3=nhelp3*(nhelp3-1)/2
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5,nhelp6,3,1,2,1)
c
       else if (sa(r).eq.sa(s)) then
c     A(p,q,rs) -> B(rs,p,q)
       nhelp5=nhelp5*(nhelp5-1)/2
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,2,3,1,1)
c
       else
c     A(p,q,r,s) -> B(r,s,p,q)
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             3,4,1,2,1)
       end if
c
 430    continue
c
       else
c     RC=10 bad type for: nind=4
       rc=10
       end if
c
       else
c
c     *********  more than 4 indexes
c
c     RC=11 bad number of indexes
       rc=11
       end if
c
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Johan Lorentzon                                  *
*               1993, Jeppe Olsen                                      *
*               1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Rd2Int(iPL)
************************************************************************
*                                                                      *
*     Read header of the two-electron integral file                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     J. Lorentzon, J. Olsen and M.P. Fuelscher                        *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)

#include "Input.fh"
      Integer nSymX,nBasX(mxSym)
      Logical SqSym
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
      iRc=-1
      Call GetOrd(iRc,SqSym,nSymX,nBasX,nSkip)
      If ( iRc.ne.0 ) Then
         Write (6,*) 'Rd2Int: Error reading ORDINT'
         Call Abend()
      End If
      If (iPL.ge.2) Then
      If(SqSym)write(6,*)'OrdInt status: squared'
      If(.not.SqSym)write(6,*)'OrdInt status: non-squared'
      End If
      If ( nSymX.ne.nSym ) Then
         Write (6,*) 'Rd2Int: nSymX.ne.nSym'
         Write (6,*) 'nSymX,nSym=',nSymX,nSym
         Call Abend()
      End If
      Do 10 iSym=1,nSym
         If ( nBas(iSym).ne.nBasX(iSym) ) Then
            Write (6,*) 'Rd2Int: nBas(iSym).ne.nBasX(iSym)'
            Write (6,*) 'nBas(iSym),nBasX(iSym)=',
     &                   nBas(iSym),nBasX(iSym)
            Call Abend()
         End If
10    Continue
      ntSkip=0
      Do 20 iSym=1,nSym
         ntSkip=ntSkip+nSkip(iSym)
20    Continue
      If ( ntSkip.ne.0 ) Then
         Write (6,*) 'Rd2Int: ntSkip.ne.0'
         Write (6,*) 'ntSkip=',ntSkip
         Call Abend()
      End If
      If (.not.SqSym.and..not.TimeDep) Then
         CASINT=.true.
      Else
         CASINT=.False.
      End If
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Dens_Info(ijS,ipDij,ipDSij,mDCRij,ipDDij,ipTmp,nr_of_Densities,nMethod,ipTmp2,ipDij2,ipDDij2)

use k2_arrays, only: ipOffD, ipOffDA
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ijS, nr_of_Densities, nMethod
integer(kind=iwp), intent(out) :: ipDij, ipDSij, mDCRij, ipDDij, ipDij2, ipDDij2
integer(kind=iwp), intent(inout) :: ipTmp, ipTmp2
integer(kind=iwp) :: nDij
integer(kind=iwp), parameter :: SCF = 1, RASSCF = 2

ipDij = ipOffD(1,ijS)
mDCRij = ipOffD(2,ijS)
nDij = ipOffD(3,ijS)
if (nMethod == RASSCF) ipDij2 = ipOffDA(1,ijS)

if (nr_of_Densities == 2) then
  ipDSij = ipOffD(4,ijS)
else
  ipDSij = 1
end if

if (mDCRij*nDij /= 0) then
  ipDDij = ipTmp
  ipTmp = ipTmp+nDij*mDCRij
  if (nMethod == RASSCF) then
    ipDDij2 = ipTmp2
    ipTmp2 = ipTmp2+nDij*mDCRij
  end if

else
  ipDDij = 1
end if

end subroutine Dens_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994,2004,2014,2017, Roland Lindh                      *
!               2014,2018,2024, Ignacio Fdez. Galvan                   *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RS_RFO_SCF(g,nInter,dq,UpMeth,dqdq,dqHdq,StepMax_Seed,Step_Trunc,ValMin)
!***********************************************************************
!                                                                      *
!     Object: Automatic restricted-step rational functional            *
!             optimization.                                            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             December '94                                             *
!                                                                      *
!     Modified to the restricted-step RFO method of Besalu and Bofill. *
!     Ref: E. Besalu and J. M. Bofill, TCA, 100, 265-274 (1998), by    *
!     R. Lindh, Gyeongju, Korea.                                       *
!     Removed full diagonalizations, Ignacio Fdez. Galvan, Uppsala     *
!     Remove references to work, Roland Lindh, Harvard, Cambridge      *
!     Modified for SCF, Roland Lindh, Harvard, Cambridge               *
!***********************************************************************

use InfSCF, only: IterSO, kOptim
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half, One, Two, Three, Pi
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nInter, ValMin
real(kind=wp), intent(in) :: g(nInter), StepMax_Seed
real(kind=wp), intent(out) :: dq(nInter), dqdq
character(len=6), intent(out) :: UpMeth
real(kind=wp), intent(inout) :: dqHdq
character, intent(out) :: Step_Trunc
integer(kind=iwp) :: I, iRoot, iStatus, Iter_i, NumVal
real(kind=wp) :: A_RFO, A_RFO_Long, A_RFO_Short, DqDq_Long, DqDq_Short, EigVal, Fact, GG, Step_Lasttime = Pi, StepMax = One, Test, &
                 ZZ
logical(kind=iwp) :: Iterate, Restart, Unreliable
real(kind=wp), allocatable :: Tmp(:), Val(:), Vec(:,:)
integer(kind=iwp), parameter :: IterMx = 20
real(kind=wp), parameter :: Step_Factor = Three, StepMax_Min = 1.0e-2_wp, Thr = 1.0e-4_wp
real(kind=wp), external :: DDot_

UpMeth = 'RS-RFO'
Step_Trunc = ' '
gg = sqrt(DDot_(nInter,g,1,g,1))
#ifdef _DEBUGPRINT_
write(u6,*) 'StepMax_Seed=',StepMax_Seed
write(u6,*) 'Sqrt(gg)=',gg
#endif

if (Step_Lasttime == Pi) Step_Lasttime = Step_Lasttime/(gg*Step_Factor)

StepMax = min(Pi,StepMax_Seed*gg,Step_Lasttime*Step_Factor*gg)

! Make sure that step restriction is not too tight.
if (StepMax < StepMax_Min) StepMax = StepMax_Min
#ifdef _DEBUGPRINT_
write(u6,*) 'StepMax=',StepMax
#endif

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) '***************************************************'
write(u6,*) '********* S T A R T  O F  R S - R F O SCF *********'
write(u6,*) '***************************************************'
call NrmClc(g,nInter,'RS-RFO','g(n)')
write(u6,*) 'Trust radius=',StepMax

write(u6,*)
write(u6,*) 'RS-RF Optimization'
write(u6,*) ' Iter    alpha    Sqrt(dqdq)  StepMax    EigVal'
#endif

A_RFO = One   ! Initial seed of alpha
Iter_i = 0
Iterate = .false.
Restart = .false.
Unreliable = .false.
NumVal = min(ValMin,nInter+1)
!NumVal = nInter+1
call mma_allocate(Vec,nInter+1,NumVal,Label='Vec')
call mma_allocate(Val,NumVal,Label='Val')
call mma_allocate(Tmp,nInter+1,Label='Tmp')

Vec(:,:) = Zero
Tmp(:) = Zero
do
  Iter_i = Iter_i+1
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !        Execute step 1 of page 266                                  *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Restore the vector from the previous iteration, if any
  Vec(:,1) = Tmp(:)

  ! Call special Davidson routine which do not require the
  ! augmented Hessian to be explicitly expressed but rather will
  ! handle the gradient and Hessian part separated. The gradient
  ! will be explicit, while the Hessian part will use an approach
  ! which computes Hc, where c is a trial vector, from an initial
  ! Hessian based on a diagonal approximation and a BFGS update.

  call Davidson_SCF(g,nInter,NumVal,A_RFO,Val,Vec,iStatus)
  if (iStatus > 0) then
#   ifdef _DEBUGPRINT_
    write(u6,*) 'rs_rfo_SCF: Davidson procedure did not converge.'
#   endif
    call resetBFGS()
  end if
  !write(u6,*) 'Val(:)=',Val(:)
  !write(u6,*) 'Vec(:,1)=',Vec(:,1)
  !write(u6,*) 'Vec(nInter+1,1)=',Vec(nInter+1,1)

  ! Select a root with a negative value close to the current point

  iRoot = 1
  dqdq = 1.0e10_wp
  do i=1,NumVal
    if (Val(i) < Zero) then
      Tmp(:) = Vec(:,i)/sqrt(A_RFO)
      ZZ = DDot_(nInter+1,Tmp(:),1,Tmp(:),1)
      Tmp(:) = Tmp(:)/sqrt(ZZ)
      Tmp(:nInter) = Tmp(:nInter)/Tmp(nInter+1)
      Test = DDot_(nInter,Tmp,1,Tmp,1)
      !write(u6,*) 'Test=',Test
      if (Test < dqdq) then
        iRoot = i
        dqdq = Test
      end if
    end if
  end do
  !write(u6,*) 'iRoot,dqdq=',iRoot,dqdq
  if (iRoot /= 1) Vec(:,1) = Vec(:,iRoot)
  Tmp(:) = Vec(:,1)
  Vec(1:nInter,1) = Vec(1:nInter,1)/sqrt(A_RFO)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !        Execute step 2 on page 266                                  *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !write(u6,*) ' RF eigenvalue=',Val
  ZZ = DDot_(nInter+1,Vec(:,1),1,Vec(:,1),1)
  Vec(:,1) = Vec(:,1)/sqrt(ZZ)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !       Execute step 3 of page 266                                   *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Copy v^k_{n,i}

  dq(:) = Vec(1:nInter,1)

  ! Pick v^k_{1,i}

  Fact = Vec(nInter+1,1)
  !write(u6,*) 'v^k_{1,i}=',Fact

  ! Normalize according to Eq. (5)

  dq(:) = dq(:)/Fact

  ! Compute lambda_i according to Eq. (8a)

  EigVal = -DDot_(nInter,dq,1,g,1) ! note sign

  ! Compute R^2 according to Eq. (8c)

  dqdq = DDot_(nInter,dq,1,dq,1)

# ifdef _DEBUGPRINT_
  write(u6,'(I5,4ES11.3)') Iter_i,A_RFO,sqrt(dqdq),StepMax,EigVal
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Initialize data for iterative scheme (only at first iteration)

  if ((.not. Iterate) .or. Restart) then
    A_RFO_long = A_RFO
    dqdq_long = sqrt(dqdq)
    A_RFO_short = Zero
    dqdq_short = dqdq_long+One
  end if
  !write(u6,*) 'dqdq_long=',dqdq_long
  !write(u6,*) 'dqdq_short=',dqdq_short
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! RF with constraints. Start iteration scheme if computed step
  ! is too long.

  if (((Iter_i == 1) .or. Restart) .and. (dqdq > StepMax**2)) then
    Iterate = .true.
    Restart = .false.
  end if

  if (sqrt(dqdq) > Two*max(StepMax,Pi)) then
    !if ((sqrt(dqdq) > Pi) .or. (sqrt(dqdq) > StepMax) .and. (kOptim > 1)) then
#   ifdef _DEBUGPRINT_
    write(u6,*) 'rs_rfo_SCF: Total displacement is too large.'
#   endif
    call resetBFGS()
    if (Restart) cycle
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Procedure if the step length is not equal to the trust radius

  Step_Trunc = '*'
  !write(u6,*) 'StepMax-Sqrt(dqdq)=',StepMax-Sqrt(dqdq)

  ! Converge if small interval

  if (dqdq < StepMax**2) then
    ! Converge if we can't trust this
    if (Unreliable) exit
    ! Converge if small interval
    if (abs(A_RFO_long-A_RFO_short) < Thr) exit
  end if

  call Find_RFO_Root(A_RFO_long,dqdq_long,A_RFO_short,dqdq_short,A_RFO,sqrt(dqdq),StepMax)
  !write(u6,*) 'A_RFO_Short,A_RFO_Long,A_RFO=',A_RFO_Short,A_RFO_Long,A_RFO
  !write(u6,*) 'dqdq_short,dqdq_long,StepMax=',dqdq_short,dqdq_long,StepMax
  if (A_RFO == -One) then
    A_RFO = One
    Step_Trunc = ' '
    Restart = .true.
    Iterate = .false.
  end if

  !if (abs(StepMax-sqrt(dqdq)) <= Thr) write(6,*) 'Converged'
  if ((.not. Iterate) .or. (abs(StepMax-sqrt(dqdq)) <= Thr)) exit
  if (Iter_i > IterMx) exit

end do

! Safety net: truncate if the step was still too large
if (sqrt(dqdq)-StepMax > Thr) then
# ifdef _DEBUGPRINT_
  write(u6,*) ' Too many iterations in RS'
# endif
  dq(:) = dq(:)/sqrt(dqdq)
  dqdq = DDot_(nInter,dq,1,dq,1)
end if

call mma_deallocate(Tmp)
dqHdq = dqHdq+EigVal*Half
Step_Lasttime = sqrt(dqdq)/gg
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'Rational Function Optimization, Lambda=',EigVal
write(u6,*)
write(u6,*) 'EigVal,dqHdq=',EigVal,dqHdq
call NrmClc(g,nInter,'RS-RFO','g(n)')
call NrmClc(dq,nInter,'RS-RFO','dX(n)')
write(u6,*) '***************************************************'
write(u6,*) '************* E N D  O F  R S - R F O SCF *********'
write(u6,*) '***************************************************'
write(u6,*)
#endif
call mma_deallocate(Vec)
call mma_deallocate(Val)

contains

subroutine resetBFGS()

  if (kOptim /= 1) then
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Reset update depth in BFGS, redo the RS-RFO'
#   endif
    kOptim = 1
    IterSO = 1
    A_RFO = One
    Restart = .true.
    Iterate = .false.
  else
    ! Something bad is going on
    Unreliable = .true.
  end if

end subroutine

end subroutine RS_RFO_SCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine sethfs_cvb(istring)
      implicit real*8(a-h,o-z)

      call seth_cvb([istring],1)
      return
      end

      subroutine gethfs_cvb(istring)
      implicit real*8(a-h,o-z)
      dimension istr(1)
      call geth_cvb(istr,1)
      istring=istr(1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHO_COUL_RED(irc,nDen,ipDLT,ipFLT)

C*********************************************************
C
C Author:  F. Aquilante
C
C Coulomb fock matrix  (level 2 BLAS)
C
C --- F(ab) = 2 * sum_J  Lab,J * sum_gd  D(gd) * Lgd,J
C
C
C          Purpose:  computes the Coulomb Fock matrix
C                    corresponding to each of the
C                    densities (nDen) sent in input
C
C         ipDLT(nDen) : pointers to the (folded) D-mat
C         ipFLT(nDen) : pointers to the computed F-mat
C
C         note: the memory reserved for the Fock matrices
C               must be already initialized at this stage.
C               Moreover, beware that any meaningful
C               content in those chunks of memory will
C               be overwritten!
C*********************************************************
      Implicit Real*8 (a-h,o-z)
      Logical Debug,add,timings
      Real*8  tread(2),tcoul(2)
      Integer ISLT(8),ipDLT(nDen),ipFLT(nDen)
      Character*12  SECNAM
      Character*6   mode
      Character*50 CFmt
      COMMON    /CHOTIME /timings

      parameter (SECNAM = 'CHO_COUL_RED')
      parameter (zero = 0.0d0, one = 1.0d0)

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )

************************************************************************
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
******
      ipDr(i) = iWork(ipDab+i-1)
******
      ipFr(i) = iWork(ipFab+i-1)
************************************************************************

#ifdef _DEBUGPRINT_
      Debug=.true.
#else
      Debug=.false.
#endif


      FactC = one

      IREDC = -1

C --- For Coulomb only, the vectors symmetry is restricted to 1
      JSYM=1
      If (NumCho(JSYM).lt.1) Then
         Write(6,*)SECNAM//'No total symmetric vectors present'
         irc = 77
         Return
      EndIf

        CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        do i=1,2            ! 1 --> CPU   2 --> Wall
           tread(i) = zero  !time for reading the vectors
           tcoul(i) = zero  !time for computing Coulomb
        end do

c Offsets to symmetry block in the LT matrix
      ISLT(1)=0
      DO ISYM=2,NSYM
         ISLT(ISYM) = ISLT(ISYM-1)
     &              + NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
      END DO

      Call GetMem('ipRedM','Allo','Inte',ipDab,2*nDen)
      ipFab = ipDab + nDen - 1

      iLoc = 3 ! use scratch location in reduced index arrays

      JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
      JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

      Do JRED=JRED1,JRED2

C --- Memory management section -----------------------------
C ---
      CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

      if (nVrs.eq.0) goto 999

      if (nVrs.lt.0) then
         Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs < 0. STOP!!'
         call abend()
      endif

      Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
      if(irc.ne.0)then
        Write(6,*)SECNAM//'cho_X_setred non-zero return code. rc= ',irc
        call abend()
      endif

      IREDC=JRED

      nRS = nDimRS(JSYM,JRED)

      Do jDen=1,nDen
         Call GetMem('rsD','Allo','Real',iWork(ipDab+jDen-1),nRS)
         Call GetMem('rsF','Allo','Real',iWork(ipFab+jDen-1),nRS)
         Call Fzero(Work(ipDr(jDen)),nRS)
         Call Fzero(Work(ipFr(jDen)),nRS)
      End Do

      Call GetMem('MaxM','Max','Real',KDUM,LWORK)

      nVec  = Min(LWORK/(nRS+1),nVrs)

      If (nVec.lt.1) Then
         WRITE(6,*) SECNAM//': Insufficient memory for batch'
         WRITE(6,*) 'LWORK= ',LWORK
         WRITE(6,*) 'min. mem. need= ',nRS+1
         irc = 33
         CALL Abend()
         nBatch = -9999  ! dummy assignment
      End If

      LREAD = nRS*nVec

      Call GetMem('rsL','Allo','Real',ipLab,LREAD)
      Call GetMem('VJ','Allo','Real',ipVJ,nVec)

C --- Transform the density to reduced storage
      mode = 'toreds'
      add  = .false.
      Call swap_rs2full(irc,iLoc,nDen,JSYM,ISLT,
     &                       ipDLT,iWork(ipDab),mode,add)


C --- BATCH over the vectors in JSYM=1 ----------------------------

      nBatch = (nVrs-1)/nVec + 1

      DO iBatch=1,nBatch

         If (iBatch.eq.nBatch) Then
            JNUM = nVrs - nVec*(nBatch-1)
         else
            JNUM = nVec
         endif

         JVEC = nVec*(iBatch-1) + iVrs
         IVEC2 = JVEC - 1 + JNUM

         CALL CWTIME(TCR1,TWR1)

         CALL CHO_VECRD(Work(ipLab),LREAD,JVEC,IVEC2,JSYM,
     &                  NUMV,JRED,MUSED)

         If (NUMV.le.0 .or. NUMV.ne.JNUM) then
            irc=77
            RETURN
         End If

         CALL CWTIME(TCR2,TWR2)
         tread(1) = tread(1) + (TCR2 - TCR1)
         tread(2) = tread(2) + (TWR2 - TWR1)


         CALL CWTIME(TCC1,TWC1)

         Do jDen=1,nDen

C ************ BEGIN COULOMB CONTRIBUTION  ****************
C
C---- Computing the intermediate vector V(J)
C
C --- Contraction with the density matrix
C ---------------------------------------
C --- V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * D(rs)
C==========================================================
C

            CALL DGEMV_('T',nRS,JNUM,
     &                 ONE,Work(ipLab),nRS,
     &                 Work(ipDr(jDen)),1,ZERO,Work(ipVJ),1)


C --- Frs{#J} <- Frs{#J} + sum_J L(rs,{#J})*V{#J}
C==========================================================

            xfac = dble(min(jVec-iVrs,1))

            CALL DGEMV_('N',nRS,JNUM,
     &                 FactC,Work(ipLab),nRS,
     &                 Work(ipVJ),1,xfac,Work(ipFr(jDen)),1)


         End Do

         CALL CWTIME(TCC2,TWC2)
         tcoul(1) = tcoul(1) + (TCC2 - TCC1)
         tcoul(2) = tcoul(2) + (TWC2 - TWC1)


      END DO  !end batch loop

      if (nVrs.gt.0) then
c --- backtransform fock matrix in full storage
         mode = 'tofull'
         add  = JRED.gt.JRED1
         Call swap_rs2full(irc,iLoc,nDen,JSYM,ISLT,
     &                          ipFLT,iWork(ipFab),mode,add)
      endif

C --- free memory
      Call GetMem('VJ','Free','Real',ipVJ,nVec)
      Call GetMem('rsL','Free','Real',ipLab,LREAD)
      Do jDen=1,nDen
         Call GetMem('rsD','Free','Real',iWork(ipDab+jDen-1),nRS)
         Call GetMem('rsF','Free','Real',iWork(ipFab+jDen-1),nRS)
      End Do


999   Continue

      END DO   ! loop over red sets

      Call GetMem('ipRedM','Free','Inte',ipDab,2*nDen)

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1

*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky SCF timing from '//SECNAM
      Write(6,CFmt)'-----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ VECTORS                     '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB                          '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


c Print the Fock-matrix
#ifdef _DEBUGPRINT_
      if(Debug) then !to avoid double printing in SCF-debug

      WRITE(6,'(6X,A)')'TEST PRINT FROM '//SECNAM
      WRITE(6,'(6X,A)')

      Do jDen=1,nDen
        write(6,*)' '
        write(6,*)'*************************************'
        write(6,*)'******* Density  # ',jDen,' *********'
        ioff=0
        DO ISYM=1,NSYM
          ISFI= ipFLT(jDen) + ioff + 1
          NB=NBAS(ISYM)
          IF ( NB.GT.0 ) THEN
            WRITE(6,'(6X,A,I2)')'Symmetry species:',ISYM
            CALL TRIPRT('Coulomb Fmat',' ',Work(ISFI),NB)
          END IF
          ioff = ioff + NB*(NB+1)/2
        END DO
        write(6,*)'*** End Density  # ',jDen,' *********'
      End Do

      endif

#endif


      irc=0

      Return
      End




      SUBROUTINE swap_rs2full(irc,iLoc,nDen,JSYM,ISLT,
     &                             ipXLT,ipXab,mode,add)

      Implicit Real*8 (a-h,o-z)
      Integer  ISLT(8),cho_isao,nDen
      External cho_isao
      Integer ipXLT(nDen),ipXab(nDen)
      Logical add
      Character*6 mode

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

************************************************************************
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      iRS2F(i,j)  = iWork(ip_iRS2F-1+2*(j-1)+i)
************************************************************************




      xf=0.0d0
      if (add) xf=1.0d0 !accumulate contributions

      If (mode.eq.'toreds'.and.JSYM.eq.1) then ! TOTAL SYMMETRIC

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            Do jDen=1,nDen

               kfrom = ipXLT(jDen) + isLT(iSyma) + iab - 1

               Work(ipXab(jDen)+jRab-1) = xf*Work(ipXab(jDen)+jRab-1)
     &                                  +    Work(kfrom)

            End Do

         End Do  ! jRab loop


      ElseIf (mode.eq.'tofull'.and.JSYM.eq.1) then  ! TOTAL SYMMETRIC

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            Do jDen=1,nDen

               kto = ipXLT(jDen) + isLT(iSyma) + iab - 1

               Work(kto) = xf*Work(kto)
     &                   +    Work(ipXab(jDen)+jRab-1)

            End Do

         End Do  ! jRab loop


      Else

         write(6,*)'Wrong input parameters. JSYM,mode = ',JSYM,mode
         irc = 66
         Call abend()

      EndIf

      irc = 0

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKSGNUM(IDOWN,IUP,IDAW,IRAW,NOW,IOW,
     *                   IUSGNUM,ILSGNUM,ICASE,IPRINT)
C     PURPOSE: FOR ALL UPPER AND LOWER WALKS
C              COMPUTE THE DIRECT ARC WEIGHT SUM AND THE
C              REVERSE ARC WEIGHT SUM, RESPECTIVELY.
C              STORE THE DATA IN THE TABLES IUSGNUM AND ILSGNUM
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "general_mul.fh"
#include "gugx.fh"
#include "WrkSpc.fh"
#include "output_ras.fh"
C
      DIMENSION IDOWN(NVERT,0:3),IUP(NVERT,0:3)
      DIMENSION IDAW(NVERT,0:4),IRAW(NVERT,0:4)
      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)
      DIMENSION IUSGNUM(MXUP,NMIDV),ILSGNUM(MXDWN,NMIDV)
      DIMENSION ICASE(NICASE)
      DIMENSION ISTEPVEC(mxact)

C
C     INITIALIZE NUMBERING TABLES
C
      DO MIDV=1,NMIDV
        DO IUW=1,MXUP
           IUSGNUM(IUW,MIDV)=0
        END DO
        DO ILW=1,MXDWN
           ILSGNUM(ILW,MIDV)=0
        END DO
      END DO
C
C     MAIN LOOP RUNS OVER MIDVERTICES AND SYMMETRIES
C
      ICONF=0
      DO MIDV=1,NMIDV
        DO ISYM=1,NSYM
          IUOFF=1+IOW(1,ISYM,MIDV)
          NUW=NOW(1,ISYM,MIDV)
          JSYM=MUL(ISYM,STSYM)
          ILOFF=1+IOW(2,JSYM,MIDV)
          NLW=NOW(2,JSYM,MIDV)
          IF( NUW.EQ.0 .OR. NLW.EQ.0 ) GOTO 110
C
C         LOOP OVER ALL UPPER WALKS
C
          DO IUW=1,NUW
            IPOS=IUOFF+NIPWLK*(IUW-1)
C     UNPACK THE UPPER WALK STEP VECTOR
            ICODE=ICASE(IPOS)
            JPOS=0
            DO LEV=(MIDLEV+1),NLEV
              JPOS=JPOS+1
              IF( JPOS.EQ.16 ) THEN
                JPOS=1
                IPOS=IPOS+1
                ICODE=ICASE(IPOS)
              ENDIF
              ISTEP=MOD(ICODE,4)
              ISTEPVEC(LEV)=ISTEP
              ICODE=ICODE/4
            END DO
C     GET REVERSE ARC WEIGHT FOR UPPER WALK
            IRAWSUM=1
            LV=1
            DO LEV=NLEV,(MIDLEV+1),-1
              IC=ISTEPVEC(LEV)
              LV=IDOWN(LV,IC)
              IRAWSUM=IRAWSUM+IRAW(LV,IC)
            END DO
            IUSGNUM(IRAWSUM,MIDV)=IUW
          END DO
C
C         LOOP OVER ALL LOWER WALKS
C
          DO ILW=1,NLW
            IPOS=ILOFF+NIPWLK*(ILW-1)
C     UNPACK WALK STEP VECTOR
            ICODE=ICASE(IPOS)
            JPOS=0
            DO LEV=1,MIDLEV
              JPOS=JPOS+1
              IF( JPOS.EQ.16 ) THEN
                JPOS=1
                IPOS=IPOS+1
                ICODE=ICASE(IPOS)
              ENDIF
              ISTEP=MOD(ICODE,4)
              ISTEPVEC(LEV)=ISTEP
              ICODE=ICODE/4
            END DO
C     GET DIRECT ARC WEIGHT FOR THE LOWER WALK
            IDAWSUM=1
            LV=NVERT
            DO LEV=1,MIDLEV
              IC=ISTEPVEC(LEV)
              LV=IUP(LV,IC)
              IDAWSUM=IDAWSUM+IDAW(LV,IC)
            END DO
            ILSGNUM(IDAWSUM,MIDV)=ICONF
            ICONF=ICONF+NUW
          END DO
C
110       CONTINUE
        END DO
      END DO
      IF( IPRINT.GT.5 ) THEN
        Write(LF,*)
        Write(LF,*)' ILSGNUM IN SUBROUTINE MKSGNUM'
        DO MIDV=1,NMIDV
          Write(LF,'(1X,''MIDV='',I3,/,(20I6))')MIDV,
     *         (ILSGNUM(J,MIDV),J=1,MXDWN)
        END DO
        Write(LF,*)
        Write(LF,*)' IUSGNUM IN SUBROUTINE MKSGNUM'
        DO MIDV=1,NMIDV
          Write(LF,'(1X,''MIDV='',I3,/,(20I6))')MIDV,
     *          (IUSGNUM(J,MIDV),J=1,MXUP)
        END DO
        Write(LF,*)
      ENDIF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Exp_eig
!
!> @brief Compute the exponential of an antisymmetric matrix
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Computes the exponential of an antisymmetric real matrix \f$ X \f$ through the eigenvalue decomposition of \f$ P = X X^T \f$
!> The exponential of \f$ X \f$ is an orthogonal matrix.
!> The product \f$ P = -X^2 \f$ is symmetric and positive (semi-)definite. Its eigenvalues are the squares of the eigenvalues
!> of \f$ X \f$. The exponential series can be split in two subseries for the odd and even elements, which correspond to
!> \f$ \cos(\sqrt(P)) \f$ and \f$ P \sin(\sqrt(P))/P \f$.
!>
!> @see ::exp_schur, ::exp_series, ::exp_series2, ::exp_svd
!>
!> @param[in]     N        Size of the square matrix
!> @param[in,out] X        Antisymmetric real matrix, it is replaced by its exponential
!> @param[out]    maxtheta Maximum rotation angle
!***********************************************************************

subroutine Exp_eig(N,X,maxtheta)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(inout) :: X(N,N)
real(kind=wp), intent(out) :: maxtheta
integer(kind=iwp) :: i, j, k
real(kind=wp), allocatable :: P(:,:), Ptri(:), tmp(:,:)
real(kind=wp), parameter :: thrs = sqrt(epsilon(thrs))

maxtheta = Zero
if (N < 1) return

call mma_allocate(P,N,N,label='P')
call mma_allocate(Ptri,nTri_Elem(N),label='Ptri')

! Ensure the matrix is antisymmetric
do i=1,N
  do j=i+1,N
    X(i,j) = -X(j,i)
  end do
end do
! P = X X^T = -X X
call dgemm_('N','T',N,N,N,One,X,N,X,N,Zero,P,N)
k = 0
do j=1,N
  do i=1,j
    k = k+1
    Ptri(k) = P(i,j)
  end do
end do

! Eigenvalue decomposition of P
!   P = U s U^T
! Eigenvectors returned in P
call NIdiag_New(Ptri,P,N,N)
! Put sqrt(s) in the first N elements of Ptri
do i=1,N
  Ptri(i) = sqrt(max(Zero,Ptri(nTri_Elem(i))))
  maxtheta = max(maxtheta,Ptri(i))
end do

! exp(X) = [X U sinc(sqrt(s)) + U cos(sqrt(s))] U^T
call mma_allocate(tmp,N,N,label='tmp')
call dgemm_('N','N',N,N,N,One,X,N,P,N,Zero,tmp,N)
do i=1,N
  if (Ptri(i) < thrs) then
    tmp(:,i) = tmp(:,i)+P(:,i)
  else
    tmp(:,i) = sin(Ptri(i))/Ptri(i)*tmp(:,i)+cos(Ptri(i))*P(:,i)
  end if
end do
call dgemm_('N','T',N,N,N,One,tmp,N,P,N,Zero,X,N)

call mma_deallocate(P)
call mma_deallocate(Ptri)
call mma_deallocate(tmp)

end subroutine Exp_eig

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994,2004,2014,2017,2019,2020, Roland Lindh            *
!               2014,2018, Ignacio Fdez. Galvan                        *
!***********************************************************************

subroutine RS_RFO(H,g,nInter,dq,UpMeth,dqHdq,StepMax,Step_Trunc,Thr_RS)
!***********************************************************************
!                                                                      *
!     Object: Automatic restricted-step rational functional            *
!             optimization.                                            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             December '94                                             *
!                                                                      *
!     Modified to the restricted-step RFO method of Besalu and Bofill. *
!     Ref: E. Besalu and J. M. Bofill, TCA, 100, 265-274 (1998), by    *
!     R. Lindh, Gyeongju, Korea.                                       *
!     Removed full diagonalizations, Ignacio Fdez. Galvan, Uppsala     *
!     Remove references to work, Roland Lindh                          *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nInter
real(kind=wp), intent(in) :: H(nInter,nInter), g(nInter), StepMax, Thr_RS
real(kind=wp), intent(out) :: dq(nInter)
character(len=6), intent(out) :: UpMeth
real(kind=wp), intent(inout) :: dqHdq
character, intent(out) :: Step_Trunc
integer(kind=iwp) :: i, ij, iRoot, iStatus, Iter, IterMx, iVal, j, NumVal
real(kind=wp) :: A_RFO, A_RFO_long, A_RFO_short, Dist, dqdq, dqdq_long, dqdq_short, EigVal, Fact, VV, ZZ
logical(kind=iwp) :: Iterate, Restart
real(kind=wp), allocatable :: Matrix(:), Val(:), Vec(:,:), Tmp(:)
#define _CHECK_UPDATE_
#ifdef _CHECK_UPDATE_
real(kind=wp), parameter :: Thr_Check = 1.0e2_wp
#endif
real(kind=wp), external :: DDot_

UpMeth = 'RS-RFO'
!#define _DEBUGPRINT_
!#define _DEBUG2_
#ifdef _DEBUGPRINT_
call RecPrt(' In RS_RFO: H',' ',H,nInter,nInter)
call RecPrt(' In RS_RFO: g',' ',g,nInter,1)
write(u6,*) 'Trust radius=',StepMax

write(u6,*)
write(u6,*) 'RS-RF Optimization'
write(u6,*) ' Iter   alpha          dqdq    StepMax     EigVal'
#endif

A_RFO = One   ! Initial seed of alpha
IterMx = 25
Iter = 0
Iterate = .false.
Restart = .false.
NumVal = min(6,nInter)+1
call mma_allocate(Vec,nInter+1,NumVal,Label='Vec')
call mma_allocate(Val,NumVal,Label='Val')
call mma_allocate(Matrix,nTri_Elem(nInter+1),Label='Matrix')
call mma_allocate(Tmp,nInter+1,Label='Tmp')

Vec(:,:) = Zero
Tmp(:) = Zero
do
  Iter = Iter+1
# ifdef _DEBUG2_
  write(u6,*) 'Iter=',Iter
  write(u6,*) 'A_RFO=',A_RFO
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !      Execute step 1 of page 266                                    *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Set up the augmented Hessian of Eq. (2)

  ! Assume that the S-matrix is trivially diagonal

  do i=1,nInter
    do j=1,i
      ij = nTri_Elem(i-1)+j
      Matrix(ij) = Half*(H(i,j)+H(j,i))/A_RFO
    end do
  end do
  j = nInter+1
  do i=1,nInter
    ij = nTri_Elem(j-1)+i
    Matrix(ij) = -g(i)/sqrt(A_RFO) ! note sign
  end do
  Matrix(nTri_Elem(j)) = Zero
# ifdef _DEBUG2_
  call TriPrt('R_Tri',' ',Matrix,nInter+1)
# endif

  ! Restore the vector from the previous iteration, if any
  Vec(:,1) = Tmp(:)
  call Davidson(Matrix,nInter+1,NumVal,Val,Vec,iStatus)
  if (iStatus > 0) call SysWarnMsg('RS_RFO','Davidson procedure did not converge','')

  ! Pick up the root which represents the shortest displacement.

# ifdef _DEBUGPRINT_
  call RecPrt('Val',' ',Val,1,NumVal)
  call RecPrt('Vec',' ',Vec,nInter+1,NumVal)
# endif
  iRoot = -1
  Dist = 1.0e99_wp
  do iVal=1,NumVal
    if (Vec(nInter+1,iVal) == Zero) cycle
    VV = DDot_(nInter,Vec(1,iVal),1,Vec(1,iVal),1)
    ZZ = VV/A_RFO+Vec(nInter+1,iVal)**2
    Fact = Vec(nInter+1,iVal)/sqrt(ZZ)
    dqdq = VV/(A_RFO*Fact**2*ZZ)
#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) 'iVal,A_RFO=',iVal,A_RFO
    write(u6,*) 'ZZ=',ZZ
    write(u6,*) 'Fact=',Fact
    write(u6,*) 'dqdq=',dqdq
#   endif
    if (dqdq < Dist) then
      iRoot = iVal
      Dist = dqdq
    end if
  end do
  if (iRoot == -1) then
    write(u6,*)
    write(u6,*) 'RS-RFO: Illegal iroot value!'
    call Abend()
  end if
  Tmp(:) = Vec(:,iRoot)
  Vec(1:nInter,iRoot) = Vec(1:nInter,iRoot)/sqrt(A_RFO)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !      Execute step 2 on page 266                                    *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
# ifdef _DEBUG2_
  write(u6,*) ' RF eigenvalue=',Val
# endif
  ZZ = DDot_(nInter+1,Vec(1,iRoot),1,Vec(1,iRoot),1)
  Vec(:,iRoot) = Vec(:,iRoot)/sqrt(ZZ)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !      Execute step 3 of page 266                                    *
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Copy v^k_{n,i}

  dq(:) = Vec(1:nInter,iRoot)

  ! Pick v^k_{1,i}

  Fact = Vec(nInter+1,iRoot)
# ifdef _DEBUG2_
  write(u6,*) 'v^k_{1,i}=',Fact
# endif

  ! Normalize according to Eq. (5)

  dq(:) = dq(:)/Fact
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'iRoot=',iRoot
  write(u6,*) 'ZZ=',ZZ
  write(u6,*) 'Fact=',Fact
# endif

  ! Compute lambda_i according to Eq. (8a)

  EigVal = -DDot_(nInter,dq,1,g,1) ! note sign

  ! Compute R^2 according to Eq. (8c)

  dqdq = sqrt(DDot_(nInter,dq,1,dq,1))
# ifdef _DEBUGPRINT_
  write(u6,'(I5,5(ES12.5,1x))') Iter,A_RFO,dqdq,StepMax,EigVal
  !write(u6,*) 'StepMax-dqdq=',StepMax-dqdq
  !write(u6,*) 'Thr_RS=',Thr_RS
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Initialize data for iterative scheme (only at first iteration)

  if ((.not. Iterate) .or. Restart) then
    A_RFO_long = A_RFO
    dqdq_long = dqdq
    A_RFO_short = Zero
    dqdq_short = dqdq_long+One
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! RF with constraints. Start iteration scheme if computed step is too long.

  if (((Iter == 1) .or. Restart) .and. (dqdq > StepMax)) then
    Iterate = .true.
    Restart = .false.
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Procedure if the step length is not equal to the trust radius

  if ((.not. Iterate) .or. (abs(StepMax-dqdq) <= Thr_RS)) exit
  Step_Trunc = '*'
# ifdef _DEBUG2_
  write(u6,*) 'StepMax-dqdq=',StepMax-dqdq
# endif

  ! Converge if small interval

  if ((dqdq < StepMax) .and. (abs(A_RFO_long-A_RFO_short) < Thr_RS)) exit
  call Find_RFO_Root(A_RFO_long,dqdq_long,A_RFO_short,dqdq_short,A_RFO,dqdq,StepMax)
  if (A_RFO == -One) then
    !write(u6,*) 'reset Step_Trunc'
    A_RFO = One
    Step_Trunc = ' '
    Restart = .true.
    Iterate = .false.
  end if
  if (Iter > IterMx) then
    write(u6,*) ' Too many iterations in RS'
    exit
  end if
end do

call mma_deallocate(Tmp)
dqHdq = dqHdq+EigVal*Half
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'Rational Function Optimization, Lambda=',EigVal
write(u6,*)
write(u6,*) 'EigVal,dqHdq=',EigVal,dqHdq
call RecPrt(' In RS_RFO: g',' ',g,nInter,1)
call RecPrt(' In RS_RFO:dq',' ',dq,nInter,1)
#endif
#define _CHECK_UPDATE_
#ifdef _CHECK_UPDATE_
do i=1,nInter
  if (abs(dq(i)) > Thr_Check) then
    write(u6,*) 'RS_RFO: ABS(dq(i)) > Thr_Check'
    write(u6,*) '        Probably an error.'
    call Abend()
  end if
end do
#endif

call mma_deallocate(Vec)
call mma_deallocate(Val)
call mma_deallocate(Matrix)
!write(u6,*) 'dqdq=',dqdq,dqdq**2
!write(u6,*) 'StepMax=',StepMax,StepMax**2
!write(u6,*) 'StepMax-dqdq=',StepMax-dqdq
!write(u6,*) dqdq < StepMax

return

end subroutine RS_RFO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine rea1 (lun,length,A)
c
c       nacitane bloku dat z Sekvencneho suboru, ak koniec tak
c       rewind a citanie znova od zaciatku
c       Toto je ozaj ditry
c
        implicit none
        integer lun,length
        real*8 A(1:length)
c
        read (lun,end=99) A
        return
c
99      rewind(lun)
        read (lun) A
c
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Roland Lindh                                     *
!***********************************************************************

subroutine Print_Basis(lOPTO)
!***********************************************************************
!                                                                      *
!     Object: to print the basis set                                   *
!                                                                      *
!     Author: Roland Lindh, Dept Chem. Phys., Lund University, Sweden  *
!             September 2006                                           *
!***********************************************************************

use Basis_Info, only: dbsc, Gaussian_type, iCnttp_Dummy, mGaussian_type, nCnttp, Nuclear_Model, Point_Charge, Shells
use Center_Info, only: dc
use RICD_Info, only: Thrshld_CD
use DKH_Info, only: iRELMP
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: lOPTO
#include "angtp.fh"
#include "print.fh"
integer(kind=iwp) :: iCnt, iCnttp, iPrint, iRout, kSh, kShEnd, kShStr, lSh, mdc, nBasisk, nExpk
character(len=4) :: DBas
character :: ChCa, ChCo, ChSph
logical(kind=iwp) :: Output, type(0:7)

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 2
iPrint = nPrint(iRout)
if (iPrint == 0) return
!                                                                      *
!***********************************************************************
!                                                                      *
if (Show) then
  write(u6,*)
  call CollapseOutput(1,'   Basis set information:')
  write(u6,'(3X,A)') '   ----------------------'
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out basis set information
!                                                                      *
!***********************************************************************
!                                                                      *
! Valence basis set

do iCnttp=1,nCnttp
  mdc = dbsc(iCnttp)%mdci
  lSh = 0
  output = Show
  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag) output = output .and. (iPrint >= 10) .and. (iCnttp /= iCnttp_Dummy)
  if (output) then
    write(u6,*)
    write(u6,*)
    write(u6,'(6X,A,1X,A)') 'Basis set label:',trim(dbsc(iCnttp)%Bsl)
    if (.not. lOPTO) then
      write(u6,*)
      dbas = dc(mdc+1)%LblCnt(1:4)
      call Upcase(dbas)
      if (dbas == 'DBAS') then
        write(u6,'(6X,A)') 'Diffuse basis set for R-matrix:'
        write(u6,'(6X,A)') '==============================='
        if (dbsc(iCnttp)%nCntr /= 1) then
          call WarningMessage(2,'Too many centers, should only be one!')
          call Quit_OnUserError()
        end if
      else
        if (dbsc(iCnttp)%Aux) then
          write(u6,'(6X,A)') 'Auxiliary basis set:'
          write(u6,'(6X,A)') '=================='
          if (dbsc(iCnttp)%aCD_Thr /= One) then
            write(u6,'(6X,A,G9.2)') 'Threshold in the auxiliary basis set generation is modified to ', &
                                    dbsc(iCnttp)%aCD_Thr*Thrshld_CD
          end if
        else if (dbsc(iCnttp)%Frag) then
          write(u6,'(6X,A)') 'Fragment basis set:'
          write(u6,'(6X,A)') '=================='
        else
          if (dbsc(iCnttp)%fMass == One) then
            write(u6,'(6X,A)') 'Electronic valence basis set:'
            write(u6,'(6X,A)') '------------------'
          else
            write(u6,'(6X,A)') 'Muonic valence basis set:'
            write(u6,'(6X,A)') '------------------'
          end if
        end if
      end if
      if (dbsc(iCnttp)%Fixed) write(u6,'(6X,A)') 'Centers of this basis set are frozen!'
      if (dbsc(iCnttp)%IsMM == 1) then
        write(u6,'(6X,A)') 'This is a MM atom: no basis set'
      else
        if (dbsc(iCnttp)%pChrg) then
          write(u6,'(6X,A,F10.6,A)') 'Associated Effective Charge ',dbsc(iCnttp)%Charge,' au (this is a pseudo charge)'
        else
          write(u6,'(6X,A,F10.6,A)') 'Associated Effective Charge ',dbsc(iCnttp)%Charge,' au'
        end if
        write(u6,'(6X,A,F10.6,A)') 'Associated Actual Charge    ',max(Zero,real(dbsc(iCnttp)%AtmNr,kind=wp)),' au'

        if (Nuclear_Model == Point_Charge) then
          write(u6,'(6X,A)') 'Nuclear Model: Point charge'
        else if (Nuclear_Model == Gaussian_type) then
          write(u6,'(6X,A)') 'Nuclear Model: Finite nucleus - Gaussian distribution'
          write(u6,'(6X,A,E12.5)') '  Gaussian exponent, Xi/bohr**(-2): ',dbsc(iCnttp)%ExpNuc
        else if (Nuclear_Model == mGaussian_type) then
          write(u6,'(6X,A)') 'Nuclear Model: Finite nucleus - Modified Gaussian distribution'
          write(u6,'(6X,A,E12.5,A,E12.5)') '  Parameters, Xi/bohr**(-2), w/bohr**(-2): ',dbsc(iCnttp)%ExpNuc,', ', &
                                           dbsc(iCnttp)%w_mGauss
        else
          call WarningMessage(2,'Illegal Nuclear Model!')
          call Abend()
        end if
      end if
      write(u6,*)
    end if

  end if
  kShStr = dbsc(iCnttp)%iVal
  kShEnd = dbsc(iCnttp)%iVal+dbsc(iCnttp)%nVal-1
  type(0) = .false.
  do kSh=kShStr,kShEnd
    nExpk = Shells(kSh)%nExp
    type(0) = type(0) .or. (nExpk*Shells(kSh)%nBasis /= 0)
  end do
  if (output .and. type(0) .and. (.not. lOPTO)) then
    write(u6,'(6X,A)') 'Shell  nPrim  nBasis  Cartesian Spherical Contaminant'
  end if
  do kSh=kShStr,kShEnd
    nExpk = Shells(kSh)%nExp
    ChCa = ' '
    ChSph = 'X'
    ChCo = ' '
    if (.not. Shells(kSh)%Transf) then
      ChCa = 'X'
      ChSph = ' '
    end if
    if (Shells(kSh)%Transf .and. (.not. Shells(kSh)%Prjct)) ChCo = 'X'
    if (output .and. (nExpk*Shells(kSh)%nBasis /= 0) .and. (.not. lOPTO)) &
      write(u6,'(9X,A,5X,I3,5X,I3,8X,A,8X,A,8X,A)') AngTp(lSh),nExpk,Shells(kSh)%nBasis,ChCa,ChSph,ChCo
    lSh = lSh+1
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Process PP part, if any.

  kShStr = dbsc(iCnttp)%iPP
  kShEnd = kShStr+dbsc(iCnttp)%nPP-1
  if (output .and. (dbsc(iCnttp)%nPP /= 0) .and. (.not. lOPTO)) then
    write(u6,*)
    write(u6,'(6X,A)') 'Pseudo Potential specification:'
    write(u6,'(6X,A)') '======================================='
    type(0) = .false.
    do kSh=kShStr,kShEnd
      nExpk = Shells(kSh)%nExp/3
      type(0) = type(0) .or. (nExpk /= 0)
    end do
    if (type(0)) then
      write(u6,*)
      write(u6,'(6X,A)') 'Potential  nTerms    '
    end if
  end if
  lSh = 0
  do kSh=kShStr,kShEnd
    nExpk = Shells(kSh)%nExp/3
    !write(u6,*) 'kSh,lSh=',kSh,lSh
    if (output .and. (nExpk /= 0) .and. (.not. lOPTO)) then
      if (lSh == 0) then
        write(u6,'(9X,A,6X,I2)') '  H',nExpk
      else
        write(u6,'(9X,A,6X,I2)') AngTp(lSh-1)//'-H',nExpk
      end if
    end if
    lSh = lSh+1
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Process ECP part, if any.

  kShStr = dbsc(iCnttp)%iPrj
  kShEnd = kShStr+dbsc(iCnttp)%nPrj-1
  if (output .and. dbsc(iCnttp)%ECP .and. (.not. lOPTO)) then
    write(u6,*)
    write(u6,'(6X,A)') 'Effective Core Potential specification:'
    write(u6,'(6X,A)') '======================================='
    if (dbsc(iCnttp)%nM1 > 0) then
      write(u6,*)
      write(u6,'(6X,A,I5)') ' Number of M1 terms:',dbsc(iCnttp)%nM1
    end if
    if (dbsc(iCnttp)%nM2 > 0) then
      write(u6,*)
      write(u6,'(6X,A,I5)') ' Number of M2 terms:',dbsc(iCnttp)%nM2
    end if
    type(0) = .false.
    do kSh=kShStr,kShEnd
      nExpk = Shells(kSh)%nExp
      nBasisk = Shells(kSh)%nBasis
      type(0) = type(0) .or. (nExpk*nBasisk /= 0)
    end do
    if (type(0)) then
      write(u6,*)
      write(u6,'(6X,A)') 'Projection basis set '
      write(u6,'(6X,A)') 'Shell  nPrim  nBasis '
    end if
  end if
  lSh = 0
  do kSh=kShStr,kShEnd
    nExpk = Shells(kSh)%nExp
    nBasisk = Shells(kSh)%nBasis
    if (output .and. (nExpk*nBasisk /= 0) .and. (.not. lOPTO)) write(u6,'(9X,A,6X,I2,6X,I2)') AngTp(lSh),nExpk,nBasisk
    lSh = lSh+1
  end do
  ! Spectral resolution basis set
  kShStr = dbsc(iCnttp)%iSRO
  kShEnd = kShStr+dbsc(iCnttp)%nSRO-1
  if (output .and. dbsc(iCnttp)%ECP .and. (.not. lOPTO)) then
    type(0) = .false.
    do kSh=kShStr,kShEnd
      nExpk = Shells(kSh)%nExp
      type(0) = type(0) .or. (nExpk /= 0)
    end do
    if (type(0)) then
      if (dbsc(iCnttp)%nOpt /= 0) then
        write(u6,*)
        write(u6,'(6X,A)') 'Spectral Resolvent Operators :'
        if (btest(dbsc(iCnttp)%nOpt,0)) write(u6,'(8X,A)') ' Exchange'
        if (btest(dbsc(iCnttp)%nOpt,1)) write(u6,'(8X,A)') ' Mass-Velocity'
        if (btest(dbsc(iCnttp)%nOpt,2)) write(u6,'(8X,A)') ' Darwin 1-electron contact term'
        if (btest(dbsc(iCnttp)%nOpt,3)) then
          select case (IRELMP)
            case (0)
              write(u6,'(8X,A)') ' No-Pair approximation'
            case (1)
              write(u6,'(8X,A)') ' No-Pair approximation (DK1)'
            case (2)
              write(u6,'(8X,A)') ' No-Pair approximation (DK2)'
            case (3)
              write(u6,'(8X,A)') ' No-Pair approximation (DK3)'
            case (4)
              write(u6,'(8X,A)') ' No-Pair approximation (DK3)'
            case (11)
              write(u6,'(8X,A)') ' RESC approximation'
            case (21)
              write(u6,'(8X,A)') ' ZORA approximation'
            case (22)
              write(u6,'(8X,A)') ' ZORA-FP approximation'
            case (23)
              write(u6,'(8X,A)') ' IORA approximation'
          end select
        end if
      end if
      write(u6,*)
      write(u6,'(6X,A)') 'Spectral Resolvent basis set '
      write(u6,'(6X,A)') 'Shell  nPrim '
    end if
  end if
  lSh = 0
  do kSh=kShStr,kShEnd
    nExpk = Shells(kSh)%nExp
    if (output .and. (nExpk /= 0) .and. (.not. lOPTO)) write(u6,'(9X,A,6X,I2)') AngTp(lSh),nExpk
    lSh = lSh+1
  end do

  ! Auxiliary SO core

  kShStr = dbsc(iCnttp)%iSOC
  kShEnd = kShStr+dbsc(iCnttp)%nSOC-1
  if (output .and. dbsc(iCnttp)%ECP .and. (.not. lOPTO)) then
    type(0) = .false.
    do kSh=kShStr,kShEnd
      nExpk = Shells(kSh)%nExp
      type(0) = type(0) .or. (nExpk /= 0)
    end do
    if (type(0)) then
      if (dbsc(iCnttp)%nOpt /= 0) then
        write(u6,*)
        write(u6,'(6X,A)') 'Auxiliary core basis'
      end if
      write(u6,*)
      write(u6,'(6X,A)') 'SOC basis set '
      write(u6,'(6X,A)') 'Shell  nPrim '
    end if
  end if
  lSh = 0
  do kSh=kShStr,kShEnd
    nExpk = Shells(kSh)%nExp
    if (output .and. (nExpk /= 0)) write(u6,'(9X,A,6X,I2)') AngTp(lSh),nExpk
    lSh = lSh+1
  end do

  if (output .and. (iPrint >= 6)) then
    write(u6,*)
    write(u6,'(6X,A)') ' Label   Cartesian Coordinates / Bohr'
    write(u6,*)
    do iCnt=1,dbsc(iCnttp)%nCntr
      write(u6,'(1X,A,1X,3F20.10)') dc(mdc+iCnt)%LblCnt,dbsc(iCnttp)%Coor(1:3,iCnt)
    end do
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (Show) then
  call CollapseOutput(0,'   Basis set information:')
  write(u6,*)
end if

return

end subroutine Print_Basis

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SetPos(LUnit,KeyIn,Line,iRc)

use PrintLevel, only: TERSE
use output_ras, only: IPRLOC
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LUNIT
character(len=*), intent(in) :: KeyIn
character(len=*), intent(out) :: Line
integer(kind=iwp), intent(out) :: iRC
integer(kind=iwp) :: IPRLEV, istatus, KLen
character(len=16) :: Command, Key
#include "warnings.h"

! Read until, and including, a line beginning with a particular
! string in an ASCII file, assumed already opened, with unit
! number LUnit. That line is returned.
! Key lengths up to 16 bytes can be used, it is determined by
! the size of the input variable.

IPRLEV = IPRLOC(1)
iRc = _RC_ALL_IS_WELL_
KLen = min(len(Key),len(KeyIn))
Key = ' '
Command = ' '
rewind(LUnit)

Key = KeyIn(1:KLen)
call upcase(Key)
do
  read(LUnit,'(A)',iostat=istatus) Line
  if (istatus /= 0) then
    if (IPRLEV >= TERSE) then
      if (istatus < 0) then
        write(u6,*) ' SETPOS: Attempt to find an input line beginning'
      else
        write(u6,*) ' SETPOS: Attempt to find an input line beginning'
      end if
      write(u6,*) ' with the keyword "',KeyIn,'" failed.'
    end if
    !call Quit(_RC_INPUT_ERROR_)
    iRc = _RC_INPUT_ERROR_
    exit
  end if
  Command(1:KLen) = Line(1:KLen)
  call upcase(Command)
  if (Command == Key) exit
end do

end subroutine SetPos

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ADS1(NK,I1,XI1S,LI1,IORB,LORB,
     &                ICLS,ISM,IMAPO,IMAPS,IMPL,IMPO,IMPF,LMAP,
     &                IEL1,IEL3,
     &                I1EL1,I1EL3,ISSO,NSSO,I1SSO,N1SSO,NOCTP,N1OCTP,
     &                NORB1,NORB2,NORB3,ORBSM,NORB,KMAX,KMIN,IEND)
*
* Obtain I1(KSTR) = +/- A+ IORB !KSTR>
*
* KSTR is restricted to strings with relative numbers in the
* range KMAX to KMIN
* =====
* Input
* =====
* IORB : Firat orbital to be added
* LORB : Number of orbitals to be added : IORB to IORB-1+LORB
*        are used. They must all be in the same TS group
* ICLS,ISM : Class and symmetry of string with added electron
* IMAPO,IMAPS : map from Kstrings to Istrings
* IEL1(3) : Number of electrons in RAS1(3) for I strings
* I1EL1(3) : Number of electrons in RAS1(3) for K strings
* ISSO : TS symmetry offset for I strings
* NSSO : Number of TS strings for I strings
* I1SSO : TS symmetry offset for K strings
* N1SSO : Number of TS strings for K strings
* NOCTP : Number of occupation types for I strings
* N1OCTP : Number of occupation types for K strings
* NORB1(2,3) : Number of RAS1(2,3) orbitals
* IORBSM : Orbital symmety array
* NORB : Number of active  orbitals
* KMAX : Largest allowed relative number for K strings
*        If Kmax is set to -1 all strings are searched
* KMIN : Smallest allowed relative number for K strings
*
* ======
* Output
* ======
*
* NK      : Number of K strings
* I1(KSTR,JORB) : ne. 0 => a + JORB !KSTR> = +/-!ISTR>
* XI1S(KSTR,JORB) : above +/-
*          : eq. 0    a + JORB !KSTR> = 0
* Offset is KMIN
*
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
      INTEGER IEL1(*),IEL3(*),I1EL1(*),I1EL3(*)
      INTEGER ISSO(NOCTP,*),NSSO(NOCTP,*)
      INTEGER I1SSO(N1OCTP,*),N1SSO(N1OCTP,*)
      INTEGER ORBSM(*)
C     INTEGER IMAPO(NORB,*),IMAPS(NORB,*)
      INTEGER IMAPO(*),IMAPS(*)
      INTEGER IMPL(*),IMPO(*)
*.Output
      INTEGER I1(*)
      DIMENSION XI1S(*)
*
      LDIM = 0 ! dummy initilize
      NTEST = 000
      IF(NTEST.NE.0) THEN
       WRITE(6,*) ' ============== '
       WRITE(6,*) ' ADSTS speaking '
       WRITE(6,*) ' ============== '
       WRITE(6,*) ' IORB,ISM,ICLS',IORB,ISM,ICLS
       WRITE(6,*) ' IMPF, LMAP ', IMPF, LMAP
       WRITE(6,*) ' N1SSO : '
       CALL IWRTMA(N1SSO,N1OCTP,8,N1OCTP,8)
      END IF
      NK = KMAX - KMIN + 1
*. Type of kstrings
      IF(IORB.LE.NORB1) THEN
        KEL1 = IEL1(ICLS) - 1
        KEL3 = IEL3(ICLS)
      ELSE IF(IORB.LE.NORB1+NORB2) THEN
        KEL1 = IEL1(ICLS)
        KEL3 = IEL3(ICLS)
      ELSE
        KEL1 = IEL1(ICLS)
        KEL3 = IEL3(ICLS) - 1
      END IF
      KTYPE = 0
C      write(6,*) ' N1OCTP ', N1OCTP
      DO 10 KKTYPE = 1, N1OCTP
       IF(I1EL1(KKTYPE).EQ.KEL1.AND.
     &    I1EL3(KKTYPE).EQ.KEL3) KTYPE = KKTYPE
   10 CONTINUE
C      write(6,*) ' kel1 kel3 ktype ',KEL1,KEL3,KTYPE
      IF(KTYPE.EQ.0) THEN
        NK = 0
        IEND = 1
        GOTO 101
      END IF
*. Symmetry of K strings
C          SYMCOM(ITASK,IOBJ,I1,I2,I12)
      CALL SYMCOM_MCLR(2,4,ORBSM(IORB),KSM,ISM)
      IF(KSM.EQ.0) THEN
        NK = 0
        IEND = 1
        GOTO 101
      END IF
      KOFF = I1SSO(KTYPE,KSM)
C?    WRITE(6,*) ' KTYPE KSM ', KTYPE,KSM
      IF(KMAX.EQ.-1) THEN
        KEND = N1SSO(KTYPE,KSM)
      ELSE
        KEND = MIN(N1SSO(KTYPE,KSM),KMAX)
      END IF
      IF(KEND.LT.N1SSO(KTYPE,KSM)) THEN
        IEND = 0
      ELSE
        IEND = 1
      END IF
      NK = KEND-KMIN+1
      IF(KMAX.EQ.-1) THEN
       LDIM = NK
      ELSE
       LDIM = LI1
      END IF
C?    IF(KMAX.EQ.-1) WRITE(6,*) ' KMAX = -1, LDIM=',LDIM
      IOFF = ISSO(ICLS,ISM)
      KSUB = KOFF+KMIN-2
      DO 110 IIORB = IORB,IORB+LORB-1
      IORBR = IIORB-IORB+1
      DO 100 KSTR = KOFF+KMIN-1 , KOFF+KEND-1
C        write(6,*) ' KSTR = ',KSTR
        KREL = KSTR - KSUB
*
        ISTR = 0
        IF(IMPF.EQ.1) THEN
          IF(IMAPO((KSTR-1)*LMAP+IIORB).EQ.IIORB)
     &    ISTR = IMAPS((KSTR-1)*LMAP+IIORB)
        ELSE
C          write(6,*) ' IMPL = ',IMPL(KSTR)
C          write(6,*) ' IMPO = ',IMPO(KSTR)
          DO IIIORB = 1, IMPL(KSTR)
           IF(IMAPO(IMPO(KSTR)-1+IIIORB).EQ.IIORB)
     &     ISTR = IMAPS(IMPO(KSTR)-1+IIIORB)
          END DO
        END IF
        IF(ISTR.GT.0 ) THEN
          I1(KREL+(IORBR-1)*LDIM) = ISTR - IOFF + 1
          XI1S(KREL+(IORBR-1)*LDIM) = 1.0D0
        ELSE IF (ISTR.LT.0 ) THEN
          I1(KREL+(IORBR-1)*LDIM) = -ISTR - IOFF + 1
          XI1S(KREL+(IORBR-1)*LDIM) = -1.0D0
        ELSE  IF( ISTR.EQ.0) THEN
          I1(KREL+(IORBR-1)*LDIM) = 0
          XI1S(KREL+(IORBR-1)*LDIM) = 0.0D0
        END IF
  100 CONTINUE
  110 CONTINUE
  101 CONTINUE
*
      IF(NTEST.GT.0) THEN
        WRITE(6,*) ' Output from ASTR '
        WRITE(6,*) ' ================ '
        WRITE(6,*) ' Number of K strings accessed ', NK
        IF(NK.NE.0) THEN
          DO 200 IIORB = IORB,IORB+LORB-1
            IIORBR = IIORB-IORB+1
            WRITE(6,*) ' Info for orbital ', IIORB
            WRITE(6,*) ' Excited strings and sign '
            CALL IWRTMA(I1  (1+(IIORBR-1)*LDIM),1,NK,1,NK)
            CALL WRTMAT(XI1S(1+(IIORBR-1)*LDIM),1,NK,1,NK)
  200     CONTINUE
        END IF
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(NSSO)
        CALL Unused_integer(NORB3)
        CALL Unused_integer(NORB)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drvk2(Cmpct,DoFock,DoGrad)
************************************************************************
*                                                                      *
*  Object: to precompute all pair entites as zeta, kappa, P and the    *
*          integral prescreening vector to be used with the Schwartz   *
*          inequlity.                                                  *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN.                              *
*             June '91, modified for k2 loop.                          *
*             Modified for direct SCF, January '93                     *
************************************************************************
      use Real_Spherical
      use k2_setup
      use iSD_data
      use k2_arrays
      use Basis_Info
      use Symmetry_Info, only: nIrrep, iOper
      use Gateway_global, only: force_part_c
      use Sizes_of_Seward, only: S
      use Gateway_Info, only: lSchw
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
      External Cmpct
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "nsd.fh"
#include "setup.fh"
#include "status.fh"
*     Local arrays
      Real*8  Coor(3,4)
      Integer   iAngV(4), iCmpV(4), iDCRR(0:7), iShllV(2)
      Logical DoFock, force_part_save, DoGrad, ReOrder, Rls
      Character*100 Get_ProgName, ProgName
      Character*8 Method
      Real*8, Allocatable:: HRRMtrx(:,:), Scr(:,:)
      Real*8, Allocatable:: Knew(:), Lnew(:), Pnew(:), Qnew(:)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      nElem(i)=(i+1)*(i+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      If (k2_Status.eq.Produced) Return
*
      ReOrder=.False.
      ProgName=Get_ProgName()
      If (Index(ProgName,'scf').ne.0) Then
         Call Get_cArray('Relax Method',Method,8)
         ReOrder=Method.eq.'KS-DFT'
      End If
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 240
      iPrint = nPrint(iRout)
*     iPrint = 99
      Call CWTime(TCpu1,TWall1)
*                                                                      *
************************************************************************
*                                                                      *
      DoGrad_=DoGrad
      DoHess_=.False.
      la_=S%iAngMx
      mabMin_=nabSz(Max(la_,la_)-1)+1
      mabMax_=nabSz(la_+la_)
      ne_=(mabMax_-mabMin_+1)
      nHrrMtrx=ne_*nElem(la_)*nElem(la_)
      call mma_allocate(HRRMtrx,nHRRMtrx,2,Label='HRRMatrix')
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate memory for k2 data. Observe that the call to Allok2
*     can be done elsewhere and then this call will simply result in
*     a return.
*
      Call Allok2()
*                                                                      *
************************************************************************
*                                                                      *
      nScree = 0
      mScree = 0
      jpk2 = 1
      nk2 = 0
      mk2 = 0
*
*     Allocate memory for zeta, kappa, and P.
      ipZInv = ipZeta + S%m2Max
      ipKab  = ipZInv + S%m2Max
      ipP    = ipKab  + S%m2Max
      ipCon  = ipP    + S%m2Max*3
      ipAlpha= ipCon  + S%m2Max
      ipBeta = ipAlpha+ S%m2Max
      ipInd  = ipiZet
*                                                                      *
************************************************************************
*                                                                      *
      MemTmp=0
      Do iAng = 0, S%iAngMx
         MemTmp=Max(MemTmp,(S%MaxPrm(iAng)*nElem(iAng))**2)
      End Do
      Call mma_allocate(Scr,MemTmp,3,Label='Scr')
      Call mma_allocate(Knew,S%m2Max,Label='Knew')
      Call mma_allocate(Lnew,S%m2Max,Label='Lnew')
      Call mma_allocate(Pnew,S%m2Max*3,Label='Pnew')
      Call mma_allocate(Qnew,S%m2Max*3,Label='Qnew')
*                                                                      *
************************************************************************
*                                                                      *
      If (Allocated(Sew_Scr)) Then
         Rls=.False.
         MemMax=SIZE(Sew_Scr)
C        Write (*,*) 'Drvk2: Memory already allocated:',MemMax
      Else
         Rls=.True.
         Call mma_maxDBLE(MemMax)
         If (MemMax.gt.1000) MemMax=MemMax-1000
         Call mma_allocate(Sew_Scr,MemMax,Label='Sew_Scr')
C        Write (*,*) 'Drvk2: Memory allocated:',MemMax
      End If
      ipMem1=1
*                                                                      *
************************************************************************
*                                                                      *
*-----Canonical double loop over shells.
*
      Do iS = 1, mSkal
         iShll  = iSD( 0,iS)
         If (Shells(iShll)%Aux.and.iS.ne.mSkal) Go To 100
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         Coor(1:3,1)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
         If (ReOrder) Call OrdExpD2C(iPrim,Shells(iShll)%Exp,iBas,
     &                                     Shells(iShll)%pCff)
*
         iAngV(1) = iAng
         iShllV(1) = iShll
         iCmpV(1) = iCmp
         Do jS = 1, iS
            jShll  = iSD( 0,jS)
            If (Shells(iShll)%Aux.and..Not.Shells(jShll)%Aux) Go To 200
            If (Shells(jShll)%Aux.and.jS.eq.mSkal) Go To 200
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
            Coor(1:3,2)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
            iAngV(2) = jAng
            iShllV(2) = jShll
            iCmpV(2) = jCmp
*
*           Fix for the dummy basis set
            If (Shells(iShll)%Aux) Coor(1:3,1)=Coor(1:3,2)
*
            Call iCopy(2,iAngV(1),1,iAngV(3),1)
            Call ICopy(2,iCmpV(1),1,iCmpV(3),1)
*
            iPrimi   = iPrim
            jPrimj   = jPrim
            nBasi    = iBas
            nBasj    = jBas
*
            iBasi = iPrimi
            jBasj = jPrimj
            kPrimk = 1
            lPriml = 1
            kBask = 1
            lBasl = 1
*
            nZeta = iPrimi * jPrimj
*
            Call ConMax(Mem_DBLE(ipCon),iPrimi,jPrimj,
     &                  Shells(iShll)%pCff,nBasi,
     &                  Shells(jShll)%pCff,nBasj)
*
            call dcopy_(6,Coor(1,1),1,Coor(1,3),1)
            If (iPrint.ge.99) Call RecPrt(' Sym. Dist. Centers',' ',
     &                                    Coor,3,4)
*
            ijS=iTri(iShell,jShell)
            If (DoFock) Then
               ipDij =ipOffD(1,ijS)
               nDCR  =ipOffD(2,ijS)
               nDij  =ipOffD(3,ijS)
            Else
               ipDij= -1
               nDCR  =1
               nDij=1
            End If
*
            nSO = 1
*
*           Compute memory request for the primitives, i.e. how much
*           memory is needed up to the transfer equation.
*
            Call MemRys(iAngV,MemPrm)
*
*           Decide on the partioning of the shells based on
*           on the available memory and the requested memory
*
*-----------Now do a dirty trick to avoid splitting of the first
*           contracted index. Move all over on the second index.
*
            iPrims=iPrimi
            jPrims=jPrimj
            iBasi = 1
            jBasj = nZeta
            iPrimi = 1
            jPrimj = nZeta
            force_part_save=force_part_c
            force_part_c=.False.
            Call PSOAO0(nSO,MemPrm, MemMax,
     &                  iAngV, iCmpV,
     &                  iBasi,iBsInc, jBasj,jBsInc,
     &                  kBask,kBsInc, lBasl,lBsInc,
     &                  iPrimi,iPrInc,jPrimj,jPrInc,
     &                  kPrimk,kPrInc,lPriml,lPrInc,
     &                  ipMem1,ipMem2,
     &                  Mem1,  Mem2,.FALSE.)
            force_part_c=force_part_save
            ijInc = Min(jBsInc,jPrInc)
            iPrimi = iPrims
            jPrimj = jPrims
            If (iPrint.ge.59) Then
               Write (6,*) ' ************** Memory',
     &                     ' partioning **************'
               Write (6,*) ' ipMem1=',ipMem1
               Write (6,*) ' ipMem2=',ipMem2
               Write (6,*) ' Mem1=',Mem1
               Write (6,*) ' Mem2=',Mem2
               Write (6,*) ' *********************',
     &                     '**************************'
            End If
*
*           Find the Double Coset Representatives for center A and B.
*
            iDCRR(0:nIrrep-1)=iOper(0:nIrrep-1)
            nDCRR=nIrrep
*
*           Compute all pair entities (zeta, kappa, P, and [nm|nm],
*           total of six types) for all possible unique pairs of
*           centers generated for the symmetry unique centers A and B.
*
*           Write (*,*) ' Generating batches:', mk2+1,' -',
*    &                  mk2+nDCRR
*           Write (*,*) ' Shell index =', ijS, iShell, jShell
*           Write (*,*) ' jpk2=',jpk2
            nHm=iCmp*jCmp*(nabSz(iAng+jAng)-nabSz(Max(iAng,jAng)-1))
            nHm=nHm*nIrrep
            ijCmp=nElem(iAng)*nElem(jAng)
            If (.Not.DoGrad_) ijCmp=0
            Call k2Loop(Coor,
     &                  iAngV,iCmpV,iShllV,
     &                  iDCRR,nDCRR,Data_k2(jpk2),
     &                  Shells(iShll)%Exp,iPrimi,
     &                  Shells(jShll)%Exp,jPrimj,
     &                  Mem_DBLE(ipAlpha),Mem_DBLE(ipBeta),
     &                  Shells(iShll)%pCff,nBasi,
     &                  Shells(jShll)%pCff,nBasj,
     &                  Mem_DBLE(ipZeta),Mem_DBLE(ipZInv),
     &                  Mem_DBLE(ipKab),Mem_DBLE(ipP),Mem_INT(ipInd),
     &                  nZeta,ijInc,Mem_DBLE(ipCon),
     &                  Sew_Scr(ipMem2),Mem2,Cmpct,
     &                  nScree,mScree,mdci,mdcj,
     &                  DeDe(ipDij),nDij,nDCR  ,nHm,ijCmp,DoFock,
     &                  Scr, MemTmp,
     &                  Knew,Lnew,Pnew,Qnew,S%m2Max,DoGrad,
     &                  HrrMtrx,nHrrMtrx)
*
            Indk2(1,ijS) = jpk2
            Indk2(2,ijS) = nDCRR
            nData=nZeta*(nDArray+2*ijCmp)+nDScalar+nHm
            nk2 = nk2 + nData*nDCRR
            mk2 = mk2 + nDCRR
            jpk2 = 1 + nk2
*
 200        Continue
         End Do
 100     Continue
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (Rls) Then
C        Write (6,*) 'Drvk2: Release Sew_Scr'
         Call mma_deallocate(Sew_Scr)
      End If
      Call mma_deallocate(Qnew)
      Call mma_deallocate(Pnew)
      Call mma_deallocate(Lnew)
      Call mma_deallocate(Knew)
      Call mma_deallocate(Scr)
      Call mma_deallocate(HRRMtrx)
*                                                                      *
************************************************************************
*                                                                      *
*     rScree = One -(One*mScree)/(One*nScree)
      If (iPrint.ge.19) Then
      Write (6,*)
      Write (6,*) ' *** The k2 entities has been precomputed ***'
      Write (6,'(I7,A)') mk2,' blocks of k2 data were computed and'
      Write (6,'(I7,A)') nk2,' Word(*8) of memory is used for storage.'
      If (lSchw) Then
         Write (6,*) ' Prescreening based on primitive integrals.'
      Else
         Write (6,*) ' Prescreening based on radial overlap.'
      End If
*     Write (*,'(1X,A,F7.5)') 'Pair screening ratio:',rScree
      Write (6,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
      Call CWTime(TCpu2,TWall2)
      Call SavTim(2,TCpu2-TCpu1,TWall2-TWall1)
      k2_Status=Produced
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine rhs_sa(Fock,SLag,ipS2)

use Index_Functions, only: iTri, nTri_Elem
use ipPage, only: W
use MCLR_Data, only: Int1, ipCI, ipCM, ipMat, ISTATE, LuJob, n1Dens, n2Dens, nA, nConf1, nDens, nNA, XISPSM
use input_mclr, only: Debug, iRoot, iTOC, nAsh, nBas, nConf, nCSF, nIsh, nOrb, nRoots, nSym, ntAsh, PT2
use PCM_grad, only: do_RF, DSSAO, DSSMO, PCMSSAO, PCMSSMO, PCM_grad_CLag, PrepPCM2
use ISRotation, only: InvEne, InvSCF
use dmrginfo, only: DoDMRG, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half, Quart
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Fock(nDens)
real(kind=wp), intent(in) :: SLag(nRoots,nRoots)
integer(kind=iwp), intent(in) :: ipS2
integer(kind=iwp) :: i, iB, iDij, iDkl, ii, iiB, iIJ, iIJKL, ij, ij2, ijB, ijkl, iR, iRij, iRijkl, iRkl, iS, j, jB, jDisk, jj, jR, &
                     k, kB, kl, kl2, kR, l, lB, nConfL, nConfR, nG1, nG2
real(kind=wp) :: Fact, Factor, rCoreA, rCoreI, rdum(1), rEnergy, vSLag
real(kind=wp), allocatable :: CIL(:), CIR(:), F(:), G1q(:), G1r(:), G2q(:), G2r(:), T(:)

!                                                                      *
!***********************************************************************
!                                                                      *

if (doDMRG) call dmrg_dim_change_mclr(RGras2,ntash,0)  ! yma

ng1 = nTri_Elem(ntash)
ng2 = nTri_Elem(ng1)

call mma_allocate(T,nDens,Label='T')
call mma_allocate(F,nDens,Label='F')
call mma_allocate(G1q,ng1,Label='G1q')
call mma_allocate(G2q,ng2,Label='G2q')
call mma_allocate(G1r,ntash**2,Label='G1r')
call mma_allocate(G2r,nTri_Elem(ntash**2),Label='G2r')

! Pick up densities from JobIph file

iR = iroot(istate)
jdisk = itoc(3)
do ii=1,iR-1
  call dDaFile(LUJOB,0,rdum,ng1,jDisk)
  call dDaFile(LUJOB,0,rdum,ng1,jDisk)
  call dDaFile(LUJOB,0,rdum,Ng2,jDisk)
  call dDaFile(LUJOB,0,rdum,Ng2,jDisk)
end do
call dDaFile(LUJOB,2,G1q,ng1,jDisk)
call dDaFile(LUJOB,0,rdum,ng1,jDisk)
call dDaFile(LUJOB,2,G2q,Ng2,jDisk)
call dDaFile(LUJOB,0,rdum,Ng2,jDisk)

! Add SLag (rotations of states) contributions from the partial
! derivative of the CASPT2 energy. G1q and G2q are modified.
! The modified density will be used in out_pt2.f and ptrans_sa.f
! If the target energy is not invariant, rotations that are in
! the SLag array is evaluated here (even if everything zero).
if (PT2 .or. (InvSCF .and. (.not. InvEne))) then
  do iB=1,ntash
    do jB=1,ntash
      G1r(ib+(jb-1)*ntash) = G1q(iTri(ib,jb))
    end do
  end do

  nConfL = max(nconf1,nint(xispsm(1,1)))
  nConfR = max(nconf1,nint(xispsm(1,1)))
  call mma_allocate(CIL,nConfL,Label='CIL')
  call mma_allocate(CIR,nConfR,Label='CIR')
  !iR = iRLXRoot
  do jR=1,nRoots
    call CSF2SD(W(ipCI)%A(1+(jR-1)*nconf1),CIL,1)
    do kR=1,jR ! jR-1
      vSLag = SLag(jR,kR)
      if (abs(vSLag) <= 1.0e-10_wp) cycle

      call CSF2SD(W(ipCI)%A(1+(jR-1)*nconf1),CIL,1)
      !call opout(ipCI)
      call CSF2SD(W(ipCI)%A(1+(kR-1)*nconf1),CIR,1)
      !call opout(ipCI)
      !call ipnout(-1)
      !icsm = 1
      !issm = 1
      call Densi2_mclr(2,G1r,G2r,CIL,CIR,0,0,0,n1Dens,n2Dens)
      ! For RDM1
      ij = 0
      do i=0,ntAsh-1
        do j=0,i-1
          ij = ij+1
          G1q(ij) = G1q(ij)+(G1r(1+i*ntAsh+j)+G1r(1+j*ntAsh+i))*Half*vSLag
        end do
        ij = ij+1
        G1q(ij) = G1q(ij)+G1r(1+i*ntAsh+i)*vSLag
      end do
      ! For RDM2
      do i=1,ntAsh**2
        j = nTri_Elem(i)
        G2r(j) = Half*G2r(j)
      end do
      do i=0,ntAsh-1
        do j=0,i-1
          ij = nTri_Elem(i)+j
          do k=0,ntAsh-1
            do l=0,k
              kl = nTri_Elem(k)+l
              if (ij >= kl) then
                factor = Quart*vSLag
                if (ij == kl) factor = Half*vSLag
                ijkl = nTri_Elem(ij)+kl
                ij2 = i*ntAsh+j
                kl2 = k*ntAsh+l
                G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
                ij2 = max(j*ntAsh+i,l*ntAsh+k)
                kl2 = min(j*ntAsh+i,l*ntAsh+k)
                G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
                if (k /= l) then
                  ij2 = i*ntAsh+j
                  kl2 = l*ntAsh+k
                  G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
                  if (ij /= kl) then
                    ij2 = max(j*ntAsh+i,k*ntAsh+l)
                    kl2 = min(j*ntAsh+i,k*ntAsh+l)
                    G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
                  end if
                end if
              end if
            end do
          end do
        end do
        ij = nTri_Elem(i+1)-1
        do k=0,ntAsh-1
          do l=0,k
            kl = nTri_Elem(k)+l
            if (ij >= kl) then
              factor = Half*vSLag
              if (ij == kl) factor = One*vSLag
              ijkl = nTri_Elem(ij)+kl
              ij2 = i*ntAsh+i
              kl2 = k*ntAsh+l
              G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
              if (k /= l) then
                kl2 = l*ntAsh+k
                G2q(1+ijkl) = G2q(1+ijkl)+factor*G2r(1+nTri_Elem(ij2)+kl2)
              end if
            end if
          end do
        end do
      end do
    end do
  end do
  call mma_deallocate(CIL)
  call mma_deallocate(CIR)
  nConf = ncsf(1)
end if

call Put_dArray('P2mo',G2q,ng2)
call Put_dArray('D1mo',G1q,ng1)

do iB=1,ntash
  do jB=1,ntash
    G1r(iB+(jB-1)*ntash) = G1q(iTri(iB,jB))
  end do
end do

do iB=1,ntash
  do jB=1,ntash
    iDij = iTri(ib,jB)
    iRij = jb+(ib-1)*ntash
    do kB=1,ntash
      do lB=1,ntash
        iDkl = iTri(kB,lB)
        iRkl = lb+(kb-1)*ntash
        fact = One
        if ((iDij >= iDkl) .and. (kB == lB)) fact = Two
        if ((iDij < iDkl) .and. (iB == jB)) fact = Two
        iijkl = iTri(iDij,iDkl)
        iRijkl = iTri(iRij,iRkl)
        G2r(iRijkl) = Fact*G2q(iijkl)
      end do
    end do
  end do
end do

if (do_RF) then
  ! Update state-specific quantities using rotated G1r
  DSSMO(1:ntAsh,1:ntAsh) = reshape(G1r(1:ntAsh**2),[ntAsh,ntAsh])
  call PrepPCM2(1,DSSMO,DSSAO,PCMSSAO,PCMSSMO)
  ! compute CLag again with the rotated SS density
  ! There is no need to construct the derivative twice, but
  ! we anyway have to evaluate the derivatives of energy and
  ! Lagrangian separately, so there is no much benefit to change
  call PCM_grad_CLag(2,ipCI,ipS2)
end if

if (doDMRG) call dmrg_dim_change_mclr(RGras2,nna,0)  ! yma

call FockGen(One,G1r,G2r,T,Fock,1)
!do iS=1,nsym
!  call RecPrt(' ',' ',fock(ipMat(is,is)),nbas(is),nbas(is))
!end do

if (.not. debug) then !yma debug ??
  renergy = Zero
  do ii=1,nsym
    do jj=1,nbas(ii)
      renergy = renergy+T(ipmat(ii,ii)+jj-1+nbas(ii)*(jj-1))
    end do
  end do

  rcorei = Zero
  rcorea = Zero
  do iS=1,nSym
    do iB=1,nIsh(is)
      rcorei = rcorei+Two*Int1(ipCM(iS)+nOrb(iS)*(iB-1)+iB-1)
    end do

    do iB=1,nAsh(iS)
      do jB=1,nAsh(iS)
        iiB = nA(iS)+ib
        ijB = nA(iS)+jb
        iij = iTri(iib,ijb)
        iiB = nIsh(iS)+ib
        ijB = nIsh(iS)+jb
        rcorea = rcorea+G1q(iij)*Int1(ipCM(is)+nOrb(is)*(iib-1)+ijB-1)
      end do
    end do
  end do
  !rcore = rCorei+rcoreA
  !write(u6,*) 'In rhs_sa'
  !write(u6,*) 'Checking energy',Half*renergy+potnuc+Half*rcore !yma
  !write(u6,*) 'Checking energy',Half*renergy,potnuc,rcore      !yma
  !write(u6,*)
end if
!do iS=1,nsym
!  call RecPrt(' ',' ',fock(ipMat(is,is)),nbas(is),nbas(is))
!end do

call mma_deallocate(G1q)
call mma_deallocate(G2q)

call TCMO(T,1,-2)
ijb = 0
do is=1,nsym
  do ib=1,nbas(is)
    do jb=1,ib-1
      ijb = ijb+1
      F(ijb) = T(ipmat(is,is)+nbas(is)*(JB-1)+IB-1)+T(ipmat(is,is)+nbas(is)*(IB-1)+JB-1)
    end do
    ijb = ijb+1
    F(ijb) = T(ipmat(is,is)+nbas(is)*(iB-1)+IB-1)
  end do
end do
F(ijb+1:) = Zero
call Put_dArray('FockOcc',F,nDens)

!call recprt('RHS',' ',fock,nDens,1)

call mma_deallocate(G1r)
call mma_deallocate(G2r)
call mma_deallocate(T)
call mma_deallocate(F)

end subroutine rhs_sa

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Xprop(short,ifallorb,nirrep,nbas,ntotv,vec,ntoto,occ,ntotd,opel,dout)
!***********************************************************************
!                                                                      *
!     Purpose: the calculation of the average value of an operator,    *
!              whose matrix elements are supplied in the array opel,   *
!              for a set of eigenvectors supplied in vec with occupa-  *
!              tion numbers supplied in occ                            *
!                                                                      *
!     Parameters                                                       *
!                                                                      *
!       short          logical, if (short) then only the total average *
!                      value is calculated and transferred in dout(1)  *
!       ifallorb       logical, if (ifallorb) then print the property  *
!                      of all orbitals (including virtuals) and none is*
!                      weighted by occupation number (S.S.Dong, 2018)  *
!       nirrep         number of irreps                                *
!       nbas(0:nirrep) dimension for each irrep                        *
!       ntotv          the total number of elemnts for all eigenvectors*
!       vec(ntotv)     if (short) then vec stores all lower triangles  *
!                      for all diagonal blocks of the density matrix   *
!                      size: sum(i,i=0,nirrep-1)(nbas(i)*(nbas(i)+1)/2)*
!                      else                                            *
!                      vec stores the eigenvectors                     *
!                      size: sum(i,i=0,nirrep-1)(nbas(i)*nbas(i))      *
!       ntoto          the total number of vectors for all represen-   *
!                      tations=the number of basis functions           *
!       occ(ntoto)     if (short) the occ array is a dummy             *
!                      else                                            *
!                      occ stores the occupation numbers               *
!                      size: sum(i,i=0,nirrep-1)(nbas(i))              *
!       ntotd          the total number of elements in lower triangles *
!                      of all diagonal blocks                          *
!       opel(ntotd)    a storage area for transferring all lower       *
!                      triangles of diagonal blocks of the operator    *
!                      matrix                                          *
!                      size: sum(i,i=0,nirrep-1)(nbas(i)*(nbas(i)+1)/2)*
!       dout           on return if (short) dout(1) contains the total *
!                      average value                                   *
!                      else                                            *
!                      dout(i), i=1,sum(k,k=0,nirrep-1)(nbas(i))       *
!                      contains the orbital contributions (multiplied  *
!                      by the corresponding occupation numbers)        *
!                                                                      *
! Modified by S.S.Dong, 2018, Univ. of Minnesota                       *
! - Enable properties to be printed for all orbitals                   *
! (including virtuals) and not weighted by occupation numbers          *
!***********************************************************************

use Constants, only: Zero, Two
use Definitions, only: wp, iwp, r8

implicit none
logical(kind=iwp), intent(in) :: short, ifallorb
integer(kind=iwp), intent(in) :: nirrep, nbas(0:nirrep-1), ntotv, ntoto, ntotd
real(kind=wp), intent(in) :: vec(ntotv), occ(ntoto), opel(ntotd)
real(kind=wp), intent(inout) :: dout(ntoto)
integer(kind=iwp) :: i, iado, iadout, iadv, icount, iv, iv1, iv2, jCount, nDim2
real(kind=wp) :: dsum
real(kind=r8), external :: DDOT_

if (short) then
  icount = 1
  dsum = DDOT_(ntotd,vec,1,opel,1)
  dout(1) = dsum
else if (.not. ifallorb) then
  ndim2 = 0
  do i=0,nirrep-1
    ndim2 = ndim2+nbas(i)**2
  end do

  iadv = 0
  iado = 0
  iadout = 0
  jCount = 1
  do i=0,nirrep-1
    do iv=1,nbas(i)
      iado = iado+1
      iadout = iadout+1
      dsum = Zero
      icount = jCount
      do iv1=1,nbas(i)
        do iv2=1,iv1-1
          dsum = dsum+Two*vec(iadv+iv1)*vec(iadv+iv2)*opel(icount)
          icount = icount+1
        end do
        dsum = dsum+vec(iadv+iv1)*vec(iadv+iv1)*opel(icount)
        icount = icount+1
      end do
      dout(iadout) = occ(iado)*dsum
      iadv = iadv+nbas(i)
    end do
    jCount = jCount+nBas(i)*(nBas(i)+1)/2
  end do
else if (ifallorb) then
  ndim2 = 0
  do i=0,nirrep-1
    ndim2 = ndim2+nbas(i)**2
  end do

  iadv = 0
  iado = 0
  iadout = 0
  jCount = 1
  do i=0,nirrep-1
    do iv=1,nbas(i)
      iado = iado+1
      iadout = iadout+1
      dsum = Zero
      icount = jCount
      do iv1=1,nbas(i)
        do iv2=1,iv1-1
          dsum = dsum+Two*vec(iadv+iv1)*vec(iadv+iv2)*opel(icount)
          icount = icount+1
        end do
        dsum = dsum+vec(iadv+iv1)*vec(iadv+iv1)*opel(icount)
        icount = icount+1
      end do
      dout(iadout) = dsum
      iadv = iadv+nbas(i)
    end do
    jCount = jCount+nBas(i)*(nBas(i)+1)/2
  end do
end if

!if (short) then
!  write(u6,'(3x,a,f18.10)') 'Total = ',dout(1)
!else
!  ii = 0
!  do i=0,nirrep-1
!    write(u6,'(1x,a,i2)') 'Irrep No.',i
!    write(u6,'(5(3x,i3,i3,f18.10))') (j,dout(ii+j),j=1,nbas(i))
!    ii = ii+nbas(i)
!  end do
!end if

return

end subroutine Xprop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine SymAdO_mck(ArrIn,nB,ArrOut,nrOp,nop,
     &                  lOper,IndGrd,iu,iv,ifgrd,idCar,trans)
      use Symmetry_Info, only: nIrrep, iChTbl, iChBas
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 ArrIn (nB,2), ArrOut(nB,nrOp)
      Integer IndGrd(0:7),nop(2)
      Logical IfGrd(3,2),trans(2)
*
*--------Accumulate contributions
*
      n=0
      Do  iIrrep=0,nIrrep-1
       If (Indgrd(iIrrep).ne.0) Then
        n=n+1
        Do iCn=1,2
          If ((Trans(iCn).or.IfGrd(idCar,iCn)).and.
     &          (IndGrd(iIrrep).ne.0)) Then
*
*              Accumulate contribution to the gradient
*
            If (iCn.eq.1) Then
                   ps = DBLE( iPrmt( nOp(1),iChBas(1+idCar) ) )
                   Fact = DBLE(iu)/DBLE(nIrrep)
                   If (trans(1)) Then
                     Fact=-Fact
                   End If
            Else
                   ps=DBLE(iChTbl(iIrrep,nOp(2)))
                   ps = ps*DBLE( iPrmt( nOp(2),iChBas(1+idCar) ) )
                   Fact = ps * DBLE(iv)/DBLE(nIrrep)
                   If (trans(2)) Then
                    Fact=-Fact
                   End If
            End if
            Call DaXpY_(nB,Fact,ArrIn(1,1),1,ArrOut(1,n),1)
          End If
        End Do
       End If
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lOper)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Ignacio Fdez. Galvan                             *
************************************************************************
!  ExpKap
!
!> @brief Compute an orbital rotation matrix from the rotation parameters
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Computes the orbital rotation matrix corresponding to the parametrized
!> form as an antisymmetric matrix, i.e. its exponential.
!> The input parameters \p kapOV are the unique elements of the occupied-virtual
!> block of each symmetry.
!>
!> @param[in]  kapOV  Parameters of the antisymmetric matrix
!> @param[out] U      Unitary matrix to transform old CMOs
!> @param[in]  mynOcc Number of occupied orbitals (including frozen) in each symmetry
!***********************************************************************

      SubRoutine ExpKap(kapOV,U,mynOcc)
*
      Implicit None

#define  qnext
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
*
*     Declaration subroutine parameters
      Real*8 kapOV(nOV),U(nOFS)
      Integer mynOcc(8)
*
      Integer iKap,iSym,iU,j,jU,mOcc,mOrb,mVir
      Real*8 Cpu1,Cpu2,Tim1,Tim2,Tim3

#ifndef qnext
      Real*8 theta
#endif

      Real*8, Parameter :: Thrs = 1.0D-14

      Call Timing(Cpu1,Tim1,Tim2,Tim3)
*
      iU = 1
      iKap = 1
      U(:) = Zero

      Do iSym=1,nSym
        mOrb = nOrb(iSym)-nFro(iSym)
        mOcc = mynOcc(iSym)-nFro(iSym)
        mVir = mOrb-mOcc

        If (mVir*mOcc == 0) Cycle

        jU = iU+mOcc

        Do j=1,mOcc
          U(jU:jU+mVir-1) = kapOV(iKap:iKap+mVir-1)
          iKap = iKap+mVir
          jU = jU+mOrb
        End Do

#ifdef  qnext
        Call matexp(mOrb,mOcc,U(iU:iU+mOrb**2))
#else
        Call Exp_Schur(mOrb,U(iU:iU+mOrb**2),theta)
#endif

        iU = iU+mOrb**2
      End Do
*
      Do j=1,nOFS
        If (abs(U(j)).lt.Thrs) U(j) = Zero
      End do
*
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld(10) = TimFld(10) + (Cpu2 - Cpu1)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995,1997, Jeppe Olsen                                 *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GETSTR2_TOTSM_SPGP(IGRP,NIGRP,ISPGRPSM,NEL,NSTR,ISTR,NORBT,IDOREO,IZ,IREO)
! Obtain all super-strings of given total symmetry and given
! occupation in each GAS space
!
! If IDOREO /= 0 THEN reordering array : lexical => actual order is obtained
!
! Nomenclature of the day : superstring : string in complete
!                           orbital space, product of strings in
!                           each GAS space
!
! Compared to GETSTR2_TOTSM_SPGP : Based upon IGRP(NIGRP)
!                                  (Just a few changes in the beginning)
!
! =====
! Input
! =====
!
! IGRP :  supergroup, here as an array of GAS space
! NIGRP : Number of active groups
! ISPGRPSM : Total symmetry of superstrings
! NEL : Number of electrons
! IZ  : Reverse lexical ordering array for this supergroup (IF IDOREO /= 0)
!
! ======
! Output
! ======
!
! NSTR : Number of superstrings generated
! ISTR : Occupation of superstring
! IREO : Reorder array (if IDOREO /= 0)
!
! Jeppe Olsen, Written  July 1995
!              Version of Dec 1997

use Symmetry_Info, only: Mul
use lucia_data, only: ISTSGP, MXPNGAS, MXPNSMST, NELFGP, NGAS, NIRREP, NSTSGP
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NIGRP, IGRP(NIGRP), ISPGRPSM, NEL, NORBT, IDOREO, IZ(NORBT,NEL)
integer(kind=iwp), intent(out) :: NSTR
integer(kind=iwp), intent(inout) :: ISTR(*)
integer(kind=iwp), intent(_OUT_) :: IREO(*)
integer(kind=iwp) :: IEL, IFIRST, IGAS, IISTSGP(MXPNSMST,MXPNGAS), ISMFGS(MXPNGAS), ISMST, ISTRBS, ISTSMM1, ITPFGS(MXPNGAS), JSTR, &
                     LEX, MAXLEX, MNVAL(MXPNGAS), MXVAL(MXPNGAS), NELFGS(MXPNGAS), NGASL, NNSTSGP(MXPNSMST,MXPNGAS), NONEW
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I

write(u6,*)
write(u6,*) ' ============================'
write(u6,*) ' Welcome to GETSTR_TOTSM_SPGP'
write(u6,*) ' ============================'
write(u6,*)
write(u6,'(A)') ' Strings to be obtained :'
write(u6,'(A)') ' ************************'
write(u6,'(A)')
write(u6,'(A,I2)') '   Symmetry : ',ISPGRPSM
write(u6,'(A,16I3)') ' Groups : ',(IGRP(I),I=1,NIGRP)
write(u6,*) ' NEL = ',NEL
if (IDOREO /= 0) then
  write(u6,*)
  write(u6,*) ' ============='
  write(u6,*) ' The Z array :'
  write(u6,*) ' ============='
  write(u6,*)
  write(u6,*) ' NORBT,NEL = ',NORBT,NEL
  call IWRTMA(IZ,NORBT,NEL,NORBT,NEL)
end if
#endif
! Absolute number of this supergroup
! Occupation per gasspace
! Largest occupied space
NGASL = 0
! Largest and lowest symmetries active in each GAS space
do IGAS=1,NGAS
  ITPFGS(IGAS) = IGRP(IGAS)
  NELFGS(IGAS) = NELFGP(IGRP(IGAS))
  if (NELFGS(IGAS) > 0) NGASL = IGAS
end do
if (NGASL == 0) NGASL = 1
! Number of strings per GAS space and offsets for strings of given sym
do IGAS=1,NGAS
  IISTSGP(1:NIRREP,IGAS) = ISTSGP((ITPFGS(IGAS)-1)*NIRREP+1:ITPFGS(IGAS)*NIRREP)
  NNSTSGP(1:NIRREP,IGAS) = NSTSGP((ITPFGS(IGAS)-1)*NIRREP+1:ITPFGS(IGAS)*NIRREP)
end do

do IGAS=1,NGAS
  do ISMST=1,NIRREP
    if (NNSTSGP(ISMST,IGAS) > 0) MXVAL(IGAS) = ISMST
  end do
  do ISMST=NIRREP,1,-1
    if (NNSTSGP(ISMST,IGAS) > 0) MNVAL(IGAS) = ISMST
  end do
end do
! Largest and lowest active symmetries for each GAS space
#ifdef _DEBUGPRINT_
write(u6,*) ' Type of each GAS space'
call IWRTMA(ITPFGS,1,NGAS,1,NGAS)
write(u6,*) ' Number of elecs per GAS space'
call IWRTMA(NELFGS,1,NGAS,1,NGAS)
#endif

! Loop over symmetries of each GAS

MAXLEX = 0
IFIRST = 1
ISTRBS = 1
do
  if (IFIRST == 1) then
    ISMFGS(1:NGASL-1) = MNVAL(1:NGASL-1)
  else
    ! Next distribution of symmetries in NGAS -1
    call NXTNUM3(ISMFGS,NGASL-1,MNVAL,MXVAL,NONEW)
    if (NONEW /= 0) exit
  end if
  IFIRST = 0
# ifdef _DEBUGPRINT_
  write(u6,*) ' next symmetry of NGASL-1 spaces'
  call IWRTMA(ISMFGS,NGASL-1,1,NGASL-1,1)
# endif
  ! Symmetry of NGASL -1 spaces given, symmetry of total space
  ISTSMM1 = 1
  do IGAS=1,NGASL-1
    ISTSMM1 = Mul(ISTSMM1,ISMFGS(IGAS))
  end do
  ! required sym of SPACE NGASL
  ISMFGS(NGASL) = Mul(ISTSMM1,ISPGRPSM)

  ISMFGS(NGASL+1:NGAS) = 1
# ifdef _DEBUGPRINT_
  write(u6,*) ' Next symmetry distribution'
  call IWRTMA(ISMFGS,1,NGAS,1,NGAS)
# endif
  ! Obtain all strings of this symmetry
  !call GETSTRN_GASSM_SPGP(ISMFGS,ITPFGS,ISTR(1,ISTRBS),NSTR,NEL,NNSTSGP,IISTSGP)
  call GETSTRN_GASSM_SPGP(ISMFGS,ITPFGS,ISTR(1+NEL*(ISTRBS-1)),NSTR,NEL,NNSTSGP,IISTSGP)
  ! Reorder Info : Lexical => actual number
  if (IDOREO /= 0) then
    ! Lexical number of NEL electrons
    ! Can be made smart by using common factor for first NGAS-1 spaces
    do JSTR=ISTRBS,ISTRBS+NSTR-1
      LEX = 1
      do IEL=1,NEL
        !LEX = LEX+IZ(ISTR(IEL,JSTR)),IEL)
        LEX = LEX+IZ(ISTR(IEL+NEL*(JSTR-1)),IEL)
      end do
      !write(u6,*) ' string'
      !call IWRTMA(ISTR(1,JSTR),1,NEL,1,NEL)
      !write(u6,*) ' JSTR and LEX ',JSTR,LEX

      MAXLEX = max(MAXLEX,LEX)
      IREO(LEX) = JSTR
    end do
  end if

  ISTRBS = ISTRBS+NSTR
  ! ready for next symmetry distribution
  if (NGAS == 1) exit
end do
! End of loop over symmetry distributions
NSTR = ISTRBS-1

#ifdef _DEBUGPRINT_
write(u6,*) ' NEL(b) = ',NEL
write(u6,*) ' Number of strings generated ',NSTR
write(u6,*)
write(u6,*) ' Strings :'
write(u6,*)
call PRTSTR(ISTR,NEL,NSTR)

if (IDOREO /= 0) then
  write(u6,*) 'Largest Lexical number obtained ',MAXLEX
  write(u6,*) ' Reorder array'
  call IWRTMA(IREO,1,NSTR,1,NSTR)
end if
#endif

end subroutine GETSTR2_TOTSM_SPGP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      Real*8 Function Clebsch_Gordan(j1,m1,j2,m2,j,m)
*
*     Calculates the Clebsch-Gordan coefficients
*
      implicit Real*8(a-z)
*
      integer z,zmax,zmin
      If (j1.lt.0.0d0.or.j2.lt.0.0d0.or.j.lt.0.0d0)
     &Then
         Write(6,*) 'Error J is lower than 0'
         Call Abend()
      End If
      r=abs(2.0d0*j1-dint(2.0d0*j1))+abs(2.0d0*j2-dint(2.0d0*j2))
     & +abs(2.0d0*j -dint(2.0d0*j ))+abs(2.0d0*m1-dint(2.0d0*m1))
     & +abs(2.0d0*m2-dint(2.0d0*m2))+abs(2.0d0*m -dint(2.0d0*m))
      If (r.gt.1.0d-6)
     &Then
        Write(6,*) 'CG provided with not half integer'
         Call Abend()
      End If
      If (m1+m2.eq.m) Then
       Fct1=(2.0D0*j+1.0D0)*Fact(j1+j2-j)*Fact(j1-j2+j)*Fact(-j1+j2+j)
       Fct2=Fact(j1+j2+j+1.0D0)
       Fct=sqrt(Fct1/fct2)
       Fct=Fct*sqrt(Fact(j1+m1)*Fact(j1-m1)*Fact(j2+m2)
     &             *Fact(j2-m2)*Fact(j+m)*FacT(j-m))
       zmax=nint(Min(j1+j2-j,j1-m1,j2+m2))
       zmin=-nint(Min(j-j2+m1,j-j1-m2))
       sum=0.0d0
       zmin=Max(0,zmin)
       Do z=zmin,zmax
        T=DBLE((-1)**z)
        N=Facti(z)*FacT(j1+j2-j-DBLE(z))*fact(j1-m1-DBLE(z))
     &   *fact(j2+m2-DBLE(z))*
     &    fact(j-j2+m1+DBLE(z))*fact(j-j1-m2+DBLE(z))
        sum=sum+T/N
       End do
       Clebsch_Gordan=sum*fct
      else
       Clebsch_Gordan=0.0d0
      End If
      return
      end
*
      Function Facti(R)
      integer n,i,j,R
      Real*8 Facti
      n=R
      i=1
      If (n.eq.0) Then
        Facti=1.0d0
        return
      end if
      Do j=1,n
      i=i*j
      end do
      Facti=DBLE(i)
      return
      end
      Function Fact(R)
      Real*8 R,Fact
      integer n,i,j
      n=nint(R)
      i=1
      If (n.eq.0) Then
        Fact=1.0d0
        return
      end if
      Do j=1,n
      i=i*j
      end do
      Fact=DBLE(i)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

subroutine IAIB_TO_OCCLS(IAGRP,IATP,IBGRP,IBTP,IOC)
! Find address of the occupation class corresponding to given types
! of alpha and beta strings
!
! Jeppe Olsen, December 2001

use lucia_data, only: IBSPGPFTP, IOCLS, MXPNGAS, NELFSPGP, NGAS, NMXOCCLS
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IAGRP, IATP, IBGRP, IBTP
integer(kind=iwp), intent(out) :: IOC
integer(kind=iwp) :: IABOCC(MXPNGAS), IATP_ABS, IBTP_ABS, INUM

IATP_ABS = IATP+IBSPGPFTP(IAGRP)-1
IBTP_ABS = IBTP+IBSPGPFTP(IBGRP)-1
!write(u6,*) ' IATP, IBTP, IAGRP, IBGRP = ',ATP,IBTP,IAGRP,IBGRP
!write(u6,*) ' IATP_ABS, IBTP_ABS ',IATP_ABS,IBTP_ABS

IABOCC(1:NGAS) = NELFSPGP(1:NGAS,IATP_ABS)+NELFSPGP(1:NGAS,IBTP_ABS)
! And the address of this occupation class
call CMP_IVEC_ILIST(IABOCC,IOCLS,NGAS,NMXOCCLS,INUM)

IOC = INUM

if (INUM == 0) then
  write(u6,*) ' Combination of alpha and beta string not found as occ-class'
  write(u6,*) ' Occ of alpha, Occ of beta, Occ of alpha+beta'
  call IWRTMA(NELFSPGP(1,IATP_ABS),1,NGAS,1,NGAS)
  call IWRTMA(NELFSPGP(1,IBTP_ABS),1,NGAS,1,NGAS)
  call IWRTMA(IABOCC,1,NGAS,1,NGAS)
  !stop ' Combination of alpha and beta string not found as occ-class'
  call SYSABENDMSG('lucia_util/iaib_to_occls','Internal error','')
end if

end subroutine IAIB_TO_OCCLS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,2004,2014,2017, Roland Lindh                      *
*               2014,2018, Ignacio Fdez. Galvan                        *
************************************************************************
      Subroutine RS_RFO_SCF(HDiag,g,nInter,dq,UpMeth,dqdq,dqHdq,StepMax,
     &                      Step_Trunc,MemRsv)
************************************************************************
*                                                                      *
*     Object: Automatic restricted-step rational functional            *
*             optimization.                                            *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             December '94                                             *
*                                                                      *
*     Modified to the restricted-step RFO method of Besalu and Bofill. *
*     Ref: E. Besalu and J. M. Bofill, TCA, 100, 265-274 (1998), by    *
*     R. Lindh, Gyeongju, Korea.                                       *
*     Removed full diagonalizations, Ignacio Fdez. Galvan, Uppsala     *
*     Remove references to work, Roland Lindh, Harvard, Cambridge      *
*     Modified for SCF, Roland Lindh, Harvard, Cambridge               *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Integer nInter
      Real*8 HDiag(nInter), g(nInter), dq(nInter)
      Character UpMeth*6, Step_Trunc*1
      Real*8 dqdq, dqHdq, StepMax
*     Local variables
      Real*8, Dimension(:), Allocatable:: Tmp, Val, Vec
      Logical Iterate, Restart
      Real*8 Lambda
*
      UpMeth='RS-RFO'
      Step_Trunc=' '
      Lu=6
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
*     Call RecPrt('rs-rfo: HDiag',' ',HDiag,1,nInter)
*     Call RecPrt('rs-rfo: g',' ',g,1,nInter)
      Write (Lu,*)
      Write (Lu,*) '***************************************************'
      Write (Lu,*) '********* S T A R T  O F  R S - R F O *************'
      Write (Lu,*) '***************************************************'
      Call NrmClc(g,nInter,'RS-RFO','g(n)')
      Write (Lu,*) 'Trust radius=',StepMax
*
      Write (Lu,*)
      Write (Lu,*) 'RS-RF Optimization'
      Write (Lu,*) ' Iter    alpha    Sqrt(dqdq)  StepMax    EigVal'
#endif
*
      A_RFO=One   ! Initial seed of alpha
      IterMx=25
      Iter=0
      Iterate=.False.
      Restart=.False.
      Thr=1.0D-3
      NumVal=1
      Call mma_allocate(Vec,(nInter+1)*NumVal,Label='Vec')
      Call mma_allocate(Val,NumVal,Label='Val')
      Call mma_allocate(Tmp,nInter+1,Label='Tmp')
*
      Call DZero(Vec,(nInter+1)*NumVal)
      Call DZero(Tmp,nInter+1)
 998  Continue
         Iter=Iter+1
#ifdef _DEBUGPRINT_
*        Write (Lu,*) 'Iter=',Iter
*        Write (Lu,*) 'A_RFO=',A_RFO
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        Execute step 1 of page 266                                    *
*                                                                      *
************************************************************************
*                                                                      *
*        Restore the vector from the previous iteration, if any
         call dcopy_(nInter+1,Tmp,1,Vec,1)
*
*        Call special Davidson routine which do not require the
*        augmented Hessian to be explicitly expressed by rather will
*        handle the gradient and Hessian part separated. The gradient
*        will be explicit, while the Hessian part will use an approach
*        which computes Hc, where c is a trial vector, from an initial
*        Hessian based on a diagonal approximation and a BFGS update.
*
         Call Davidson_SCF(HDiag,g,nInter,NumVal,A_RFO,Val,Vec,MemRsv,
     &                     iStatus)
         If (iStatus.gt.0) Then
            Call SysWarnMsg('RS_RFO',
     &       'Davidson procedure did not converge','')
         End If
         call dcopy_(nInter+1,Vec,1,Tmp,1)
         Call DScal_(nInter,One/Sqrt(A_RFO),Vec,1)
*                                                                      *
************************************************************************
*                                                                      *
*        Execute step 2 on page 266                                    *
*                                                                      *
************************************************************************
*                                                                      *
*        Write (Lu,*) ' RF eigenvalue=',Val
         ZZ=DDot_(nInter+1,Vec,1,Vec,1)
         Call DScal_(nInter+1,One/Sqrt(ZZ),Vec,1)
*                                                                      *
************************************************************************
*                                                                      *
*       Execute step 3 of page 266                                     *
*                                                                      *
************************************************************************
*                                                                      *
*        Copy v^k_{n,i}
*
         call dcopy_(nInter,Vec,1,dq,1)
*
*        Pick v^k_{1,i}
*
         Fact=Vec(nInter+1)
*        Write (Lu,*) 'v^k_{1,i}=',Fact
*
*        Normalize according to Eq. (5)
*
         Call DScal_(nInter,One/Fact,dq,1)
*
*        Compute lambda_i according to Eq. (8a)
*
         EigVal=-DDot_(nInter,dq,1,g,1) ! note sign
         Lambda = EigVal
*
*        Compute R^2 according to Eq. (8c)
*
         dqdq=DDot_(nInter,dq,1,dq,1)
#ifdef _DEBUGPRINT_
         Write (Lu,'(I5,4E11.3)') Iter,A_RFO,Sqrt(dqdq),StepMax,EigVal
#endif
*                                                                      *
************************************************************************
*                                                                      *
*------- Initialize data for iterative scheme (only at first iteration)
*
         If (.Not.Iterate.Or.Restart) Then
            A_RFO_long=A_RFO
            dqdq_long=Sqrt(dqdq)
            A_RFO_short=Zero
            dqdq_short=dqdq_long+One
         End If
*                                                                      *
************************************************************************
*                                                                      *
*------- RF with constraints. Start iteration scheme if computed step
*        is too long.
*
         If ((Iter.eq.1.or.Restart).and.dqdq.gt.StepMax**2) Then
            Iterate=.True.
            Restart=.False.
         End If
*                                                                      *
************************************************************************
*                                                                      *
*        Procedure if the step length is not equal to the trust radius
*
         If (Iterate.and.Abs(StepMax-Sqrt(dqdq)).gt.Thr) Then
            Step_Trunc='*'
*           Write (Lu,*) 'StepMax-Sqrt(dqdq)=',StepMax-Sqrt(dqdq)
*
*           Converge if small interval
*
            If ((dqdq.lt.StepMax**2).and.
     &          (Abs(A_RFO_long-A_RFO_short).lt.Thr)) Go To 997
            Call Find_RFO_Root(A_RFO_long,dqdq_long,
     &                         A_RFO_short,dqdq_short,
     &                         A_RFO,Sqrt(dqdq),StepMax)
            If (A_RFO.eq.-One) Then
               A_RFO=One
               Step_Trunc=' '
               Restart=.True.
               Iterate=.False.
            End If
            If (Iter.gt.IterMx) Then
               Write (Lu,*) ' Too many iterations in RF'
               Go To 997
            End If
            Go To 998
         End If
*
 997  Continue
      Call mma_deallocate(Tmp)
      dqHdq=dqHdq+EigVal*Half
#ifdef _DEBUGPRINT_
      Write (Lu,*)
      Write (Lu,*) 'Rational Function Optimization, Lambda=',EigVal
      Write (Lu,*)
      Write (Lu,*) 'EigVal,dqHdq=',EigVal,dqHdq
      Call NrmClc(g,nInter,'RS-RFO','g(n)')
      Call NrmClc(dq,nInter,'RS-RFO','dX(n)')
      Write (Lu,*) '***************************************************'
      Write (Lu,*) '************* E N D  O F  R S - R F O *************'
      Write (Lu,*) '***************************************************'
      Write (Lu,*)
#endif
*
      Call mma_deallocate(Vec)
      Call mma_deallocate(Val)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine InpOne()

use Index_Functions, only: nTri_Elem
use OneDat, only: sOpSiz
use rctfld_module, only: Conductor, lRF
use MCLR_Data, only: CMO, Int1, KAIN1, nDens, SA
use input_mclr, only: iSpin, nActEl, nAtoms, nBas, nFro, nIsh, nOrb, nSym, PotNuc, PT2
use PCM_grad, only: DSCFAO, DSCFMO, iCharge_PCM, iStpPCM, PCM_grad_dens, PCM_grad_dens2, potnuc_pcm, RFPERT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: iCharge, iComp, idum(1), iiSym, iOpt, ip, ip2, iRC, iS, Leng
real(kind=wp) :: ERFX, ExFac, potnucsav, Tot_Charge, Tot_El_Charge, Tot_Nuc_Charge
logical(kind=iwp) :: Dff, Do_DFT, Do_ESPF, First, Found, NonEq
character(len=8) :: Label
real(kind=wp), allocatable :: D1ao(:), GTmp(:), HTmp(:), Nuc(:), Temp1(:), Temp2(:), Temp3(:)
logical(kind=iwp), external :: RF_On

iRc = -1
iOpt = ibset(0,sOpSiz)
nDens = sum(nBas(1:nSym)**2)
Label = 'ONEHAM'
iComp = 1
iisym = ibset(0,0)
call iRdOne(iRc,iOpt,Label,iComp,idum,iisym)
leng = idum(1)
if (iRC /= 0) then
  write(u6,*) 'InpOne: Error reading ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
iRc = -1
iOpt = 0
call mma_allocate(Int1,nDens,Label='Int1')
kain1 => Int1

call mma_allocate(Temp1,leng+10,Label='Temp1')
call mma_allocate(Temp2,nDens,Label='Temp2')
call mma_allocate(Temp3,nDens,Label='Temp3')

call RdOne(iRc,iOpt,Label,iComp,Temp1,iisym)
if (iRC /= 0) then
  write(u6,*) 'InpOne: Error reading ONEINT'
  write(u6,'(A,A)') 'Label=',Label
  call Abend()
end if
!nf

! Modify the one electron Hamiltonian for reaction
! field and ESPF calculations

call mma_allocate(Nuc,nAtoms,Label='Nuc')
call Get_dArray('Effective nuclear Charge',Nuc,nAtoms)
Tot_Nuc_Charge = sum(Nuc(1:nAtoms))
call mma_deallocate(Nuc)
Tot_El_Charge = -Two*sum(real(nFro(1:nSym)+nIsh(1:nSym),kind=wp))-real(nActEl,kind=wp)
Tot_Charge = Tot_Nuc_Charge+Tot_El_Charge
iCharge = int(Tot_Charge)
call DecideOnESPF(Do_ESPF)
if (RF_On()) iCharge_PCM = iCharge
if (Do_ESPF .or. (lRF .and. (iStpPCM == 1))) then
  if (lRF .and. (.not. (SA .or. PT2))) then
    write(u6,*) 'Sorry, MCLR+RF NYI'
    call Quit_OnUserError()
  end if
  if ((.not. Do_ESPF) .and. (.not. Conductor)) then
    write(u6,*) 'CPCM must be used for analytical gradients'
    write(u6,*) 'Please add CONDuctor in RF-Input'
    call Quit_OnUserError()
  end if

  ! Scratch for one- and two-electron type contributions
  ! + variational density-matrix
  if (RFPERT) then

    ! Read the reaction field from RunFile or RunOld

    call f_Inquire('RUNOLD',Found)
    if (Found) call NameRun('RUNOLD')
    call mma_allocate(Htmp,leng,Label='RCTFLD')
    call Get_dScalar('RF Self Energy',ERFX)
    potnuc = potnuc+ERFX
    call Get_dArray('Reaction field',Htmp,leng)
    Temp1(:) = Temp1(:)+Htmp(:)
    call mma_deallocate(Htmp)
    if (Found) call NameRun('#Pop')
  else
    call mma_allocate(Htmp,leng,Label='Htmp')
    call mma_allocate(Gtmp,leng,Label='Gtmp')
    Htmp(:) = Zero
    Gtmp(:) = Zero
    call mma_allocate(D1ao,leng,Label='D1ao')
    call Get_dArray_chk('D1ao',D1ao,leng)
    if (lRF) then
      !! D1ao above is the state-specific (RlxRoot) density,
      !! but we need the density used for polarizing ASCs in SCF.
      call PCM_grad_dens(1) ! SCF
      call PCM_grad_dens2(1,DSCFMO,DSCFAO)
      call fold(nSym,nBas,DSCFAO,D1ao)
      !! save the density for ALASKA
      call Put_dArray('D1ao_PCM',D1ao,leng)
    end if

    NonEq = .false.
    First = .true.
    Dff = .false.
    Do_DFT = .true.
    ExFac = Zero
    call Get_dScalar('PotNuc',PotNuc)
    potnucsav = potnuc

    ! Don't care about the last arguments: no (CAS-)DFT here I guess)

    call DrvXV(Htmp,Gtmp,D1ao,PotNuc,leng,First,Dff,NonEq,lRF,'SCF',ExFac,iCharge,iSpin,'1234',Do_DFT)
    potnuc_pcm = potnuc-potnucsav
    Temp1(1:leng) = Temp1(1:leng)+Htmp(:)+Gtmp(:)

    ! Hum, where the hell is FI (Fock Inactive) ???

    !FI(:) = FI(:)+Gtmp(:)
    call mma_deallocate(Gtmp)
    call mma_deallocate(Htmp)
    call mma_deallocate(D1ao)
  end if
end if
!nf
ip = 1
ip2 = 1
do iS=1,nSym
  if ((nBas(is) /= 0) .and. (nOrb(iS) /= 0)) then
    call Square(Temp1(ip),Temp2,1,nBas(is),nBas(is))
    ip = ip+nTri_Elem(nBas(is))
    call DGEMM_('T','N',nOrb(iS),nBas(iS),nBas(iS),One,CMO(ip2),nBas(iS),Temp2,nBas(iS),Zero,Temp3,nOrb(iS))
    call DGEMM_('N','N',nOrb(is),nOrb(iS),nBas(iS),One,Temp3,nOrb(iS),CMO(ip2),nBas(iS),Zero,Int1(ip2),nOrb(iS))
    ip2 = ip2+nBas(is)**2
  end if
end do
call mma_deallocate(Temp1)
call mma_deallocate(Temp2)
call mma_deallocate(Temp3)

end subroutine InpOne

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine saamp (wrk,wrksize,
     & key)
c
c     this routine rearrange amplitudes to be spin adapted
c     key - 0 - no adaptation
c     1 - T2 DDVV adaptation
c     2 - T2 DDVV + T1 DV adaptation
c     3 - full T1 and T2 adaptation (only for doublets)
c     4 - full T2 without SDVS (only for doublets)
c
c     amplitudes T1 are in t13 - aa, t14 - bb
c     T2 are in t21 - aaaa, t22 - bbbb, t23 - abab
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer key
c
c     help variables
c
       integer symi,symj,syma,symb,syms,symij
       integer poss1,poss2,poss3,poss4,poss5,poss6,ii
c
c0    skip this routine if SA in not turn on
       if (key.eq.0) then
       return
       end if
c
c
cI    T1 adaptation
       if ((key.eq.2).or.(key.eq.3)) then
c
cI.1  def symmetry, where S orbital is situated (only for doublet states)
       syms=0
       do 10 symi=1,nsym
       if (dimm(1,symi).ne.dimm(2,symi)) then
       syms=symi
       end if
 10     continue
       if ((key.eq.2).and.(syms.eq.0)) then
       syms=1
       end if
       if (syms.eq.0) then
       write(6,*) ' Full SA is turn on and there is no S orbitals'
       Call Abend
       end if
c
cI.2  loop over symi
       do 100 symi=1,nsym
       syma=symi
c
       ii=mapit13(syma,1,1)
       poss1=mapdt13(ii,1)
       ii=mapit14(syma,1,1)
       poss2=mapdt14(ii,1)
       ii=mapit23(syma,syms,syms)
       poss3=mapdt23(ii,1)
       call saamphlp3 (wrk(poss1),wrk(poss2),wrk(poss3),
     & dimm(1,symi),dimm(2,symi),dimm(3,symi),dimm(4,symi),
     & dimm(1,syms),dimm(4,syms),key)
c
 100    continue
       end if
c
c
cII   T2 adaptation
c
       do 200 symi=1,nsym
       do 201 symj=1,symi
       symij=mmul(symi,symj)
c
       do 202 syma=1,nsym
       symb=mmul(symij,syma)
c
       if (symb.gt.syma) then
c     Meggie out
       goto 202
       end if
c
       if (symi.eq.symj) then
c     case si=sj, sa=sb
c
       ii=mapit21(syma,symb,symi)
       poss1=mapdt21(ii,1)
       ii=mapit22(syma,symb,symi)
       poss2=mapdt22(ii,1)
       ii=mapit23(syma,symb,symi)
       poss3=mapdt23(ii,1)
       call saamphlp1 (wrk(poss1),wrk(poss2),wrk(poss3),
     & dimm(1,symi),dimm(2,symi),dimm(3,syma),dimm(4,syma),key)
c
       else
c     case si>sj, sa>sb
c
       ii=mapit21(syma,symb,symi)
       poss1=mapdt21(ii,1)
       ii=mapit22(syma,symb,symi)
       poss2=mapdt22(ii,1)
       ii=mapit23(syma,symb,symi)
       poss3=mapdt23(ii,1)
       ii=mapit23(symb,syma,symj)
       poss4=mapdt23(ii,1)

       ii=mapit23(symb,syma,symi)
       poss5=mapdt23(ii,1)
       ii=mapit23(syma,symb,symj)
       poss6=mapdt23(ii,1)
       call saamphlp2 (wrk(poss1),wrk(poss2),wrk(poss3),
     & wrk(poss4),wrk(poss5),wrk(poss6),
     & dimm(1,symi),dimm(1,symj),dimm(2,symi),dimm(2,symj),
     & dimm(3,syma),dimm(3,symb),dimm(4,syma),dimm(4,symb),
     & key)
c
       end if
c
 202    continue
 201    continue
 200    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_PLMO(PLMO,nPLMO)
      Implicit Real*8 (A-H,O-Z)
      Character*24 Label
      Logical      Found
      Real*8 PLMO(nPLMO)

      Label='PLMO'
      Call qpg_dArray(Label,Found,mPLMO)
      If(.not.Found .or. mPLMO.eq.0) Then
         Call SysAbendMsg('get_plmo','Did not find:',Label)
      End If
      If (nPLMO/=mPLMO) Then
         Write (6,*) 'Get_PLMO: nPLMO/=mPLMO'
         Write (6,*) 'nPLMO=',nPLMO
         Write (6,*) 'mPLMO=',mPLMO
         Call Abend()
      End If
      Call get_dArray(Label,PLMO,nPLMO)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Martin Schuetz                                   *
!***********************************************************************

subroutine ChkTrD(nSym,nBas,nOrb,Occ,nOcc,Dlt,nDlt)
!***********************************************************************
!                                                                      *
!     purpose: Compute trace of density matrix and compare with sum    *
!              over occupation numbers...                              *
!                                                                      *
!     input:                                                           *
!       nSym    : number of symmetries                                 *
!       nBas(i) : number of basis functions (i = 1, nSym)              *
!       Occ     : occupation numbers                                   *
!       Dlt     : density matrix in triangular storage                 *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: Ovrlp
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym), nOcc, nDlt
real(kind=wp), intent(in) :: Occ(nOcc), Dlt(nDlt)
integer(kind=iwp) :: ipDlt, ipOcc, ipOvl, iSym, lth, nBs, nOr
real(kind=wp) :: Scal, SumOcc, TrDns
real(kind=wp), parameter :: ThrDif = 1.0e-7_wp
real(kind=wp), external :: DDot_

ipDlt = 1
ipOvl = 1
ipOcc = 0
Scal = One
do iSym=1,nSym
  nBs = nBas(iSym)
  if (nBs < 1) cycle
  nOr = nOrb(iSym)
  lth = nTri_Elem(nBs)
  ! count occupation number...
  SumOcc = sum(Occ(ipOcc+1:ipOcc+nOr))*Scal
  ! do trace of PS for symmetry block...
  TrDns = DDOT_(lth,Dlt(ipDlt),1,Ovrlp(ipOvl),1)
  ipDlt = ipDlt+lth
  ipOvl = ipOvl+lth
  ipOcc = ipOcc+nOr
  if (abs(SumOcc-TrDns) > ThrDif) then
    write(u6,*) abs(SumOcc-TrDns)
    ! print Warning...
    call WarningMessage(1,'WARNING: trace of density is inconsistent with occupation !')
    write(u6,'(A,I1,A,3F12.7)') 'SymBlock: ',iSym,' deviation: ',SumOcc-TrDns,SumOcc,TrDns
  end if
end do

end subroutine ChkTrD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Stblzr(iU,nU,iV,nV,iR,iM,nM)
************************************************************************
*                                                                      *
*  Object: to form the proper stabilizer for a pair of entities        *
*          given the respective stabilizers and the operator acting    *
*          on the second entity.                                       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             June '90                                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Integer iU(nU), iV(nV), iM(8)
      Logical UeqV, RinT_
*
*     See if U and V are the same
*
      UeqV = .True.
      Do 10 i = 1, nV
         If (.Not.RinT_(iU,nU,iV(i))) UeqV=.False.
 10   Continue
      Do 11 i = 1, nU
         If (.Not.RinT_(iV,nV,iU(i))) UeqV=.False.
 11   Continue
*
      If (UeqV) Then
*
*        M is formed as U union RU
*
         Call iCopy(nU,iU,1,iM,1)
         nM = nU
         Do 20 i = 1, nU
            iRU = iEor(iR,iU(i))
            If (.Not.RinT_(iM,nM,iRU)) Then
               nM = nM + 1
               iM(nM) = iRU
            End If
 20      Continue
      Else
*
*        M is formed as U intersection V
*
         Call Inter(iU,nU,iV,nV,iM,nM)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE HZLP1(CBUF,SBUF,DBUF,ARR,CSECT,RSECT,XI1,XI2,ICI)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (ONE=1.0D00)
      PARAMETER (IX1F=1,IX2F=2,IRR=3,IX1R=4,IX2R=5,IX1X1=6,IX2X1=7,
     *           IX2X2=8,IFDF=9,IFDR=10,IRDR=11)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION CBUF(MBUF,MXVEC),SBUF(MBUF,MXVEC),DBUF(MBUF),ICI(MBUF)
      DIMENSION CSECT(NSECT,MXVEC),RSECT(NSECT,MXVEC)
      DIMENSION XI1(NSECT,NRROOT),XI2(NSECT,NRROOT)
      DIMENSION ARR(NRROOT,NRROOT,11)
      DIMENSION IDCOPY(MXVEC),IDC(MXVEC),IDS(MXVEC)
C THIS SUBROUTINE LOOPS OVER SECTIONS OF PSI AND SIGMA ARRAYS
C ON DISK, AND ACCUMULATES OVERLAP MATRICES AND A COUPLE OF
C HAMILTONIAN MATRICES IN THE BASIS SET PSI, RHO, XI1 AND XI2.
C THE 11 MATRICES X1F,..,RDR ARE STORED CONSECUTIVELY IN THE
C SINGLE ARRAY ARR.
      NRR2=NRROOT**2
      CALL DCOPY_(11*NRR2,[0.0D00],0,ARR,1)
      DO 10 K=1,NVEC
        IDC(K)= IDISKC(K)
        IDS(K)= IDISKS(K)
10    CONTINUE
      IDD= IDISKD
C LOOP OVER BUFFERS FOR READING PSI, SIGMA AND DBUF:
      DO 2000 ISTA=1,NCONF,MBUF
        IEND=MIN(NCONF,ISTA+MBUF-1)
        IBUF=1+IEND-ISTA
        CALL dDAFILE(LUEIG,2,DBUF,IBUF,IDD)
        DO 20 K=1,NVEC
          IDCOPY(K)=IDC(K)
          CALL iDAFILE(LUEIG,2,ICI,IBUF,IDC(K))
          CALL UPKVEC(IBUF,ICI,CBUF(1,K))
          CALL dDAFILE(LUEIG,2,SBUF(1,K),IBUF,IDS(K))
20      CONTINUE
C LOOP OVER VECTOR SECTIONS, LENGTH AT MOST NSECT:
        DO 1000 JSTA=1,IBUF,NSECT
          JEND=MIN(IBUF,JSTA+NSECT-1)
          ISECT=1+JEND-JSTA
C TRANSFORM TO EIGENFUNCTIONS OF HSMALL: FIRST, CI SECTION.
        CALL DGEMM_('N','N',
     &              ISECT,NRROOT,NVEC,
     &              1.0d0,CBUF(JSTA,1),MBUF,
     &              VSMALL,MXVEC,
     &              0.0d0,CSECT,NSECT)
C THEN, SIGMA SECTION INTO RSECT.
        CALL DGEMM_('N','N',
     &              ISECT,NRROOT,NVEC,
     &              1.0d0,SBUF(JSTA,1),MBUF,
     &              VSMALL,MXVEC,
     &              0.0d0,RSECT,NSECT)
C AND THEN FORM RSECT=SECTION OF RESIDUAL ARRAY, AND XI1 AND XI2:
        DO 30 I=1,ISECT
          DO 31 K=1,NRROOT
            RSECT(I,K)=RSECT(I,K)-ESMALL(K)*CSECT(I,K)
            XI1(I,K)=CSECT(I,K)/(DBUF(I+JSTA-1)-ESMALL(K))
            XI2(I,K)=RSECT(I,K)/(DBUF(I+JSTA-1)-ESMALL(K))
31        CONTINUE
30      CONTINUE
C ACCUMULATE OVERLAP MATRICES:
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI1,NSECT,
     *           CSECT,NSECT,ONE,ARR(1,1,IX1F),NRROOT)
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI2,NSECT,
     *           CSECT,NSECT,ONE,ARR(1,1,IX2F),NRROOT)
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,RSECT,NSECT,
     *           RSECT,NSECT,ONE,ARR(1,1,IRR),NRROOT)
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI1,NSECT,
     *           RSECT,NSECT,ONE,ARR(1,1,IX1R),NRROOT)
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI2,NSECT,
     *           RSECT,NSECT,ONE,ARR(1,1,IX2R),NRROOT)
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI1,NSECT,
     *           XI1  ,NSECT,ONE,ARR(1,1,IX1X1),NRROOT)
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI2,NSECT,
     *           XI1  ,NSECT,ONE,ARR(1,1,IX2X1),NRROOT)
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI2,NSECT,
     *           XI2  ,NSECT,ONE,ARR(1,1,IX2X2),NRROOT)
C PUT D*CSECT INTO XI1, AND D*RSECT INTO XI2:
        DO 40 I=1,ISECT
          DO 41 K=1,NRROOT
            XI1(I,K)=DBUF(I+JSTA-1)*CSECT(I,K)
            XI2(I,K)=DBUF(I+JSTA-1)*RSECT(I,K)
41        CONTINUE
40      CONTINUE
C ACCUMULATE ARRAYS FDF, FDR, AND RDR:
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI1,NSECT,
     *           CSECT,NSECT,ONE,ARR(1,1,IFDF),NRROOT)
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI1,NSECT,
     *           RSECT,NSECT,ONE,ARR(1,1,IFDR),NRROOT)
        CALL DGEMM_('T','N',NRROOT,NRROOT,ISECT,ONE,XI2,NSECT,
     *           RSECT,NSECT,ONE,ARR(1,1,IRDR),NRROOT)
C CONTINUE, NEXT SECTION.
1000    CONTINUE
C CONTINUE, NEXT BUFFER.
2000  CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine makecivb_cvb(civec,civb,cvbdet,orbs,cvb,ic)
! Construct CIVB and CVBDET:
! IC=0 : CIVB will contain full set of structures (if PROJCAS).
! IC=1 : CIVB will contain only VB structures.

use casvb_global, only: gjorb_type, icnt_ci, memplenty, ndet, ndetvb, norb, nvb, projcas
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: civec(0:ndet), civb(0:ndet), cvb(nvb)
real(kind=wp), intent(out) :: cvbdet(ndetvb)
real(kind=wp), intent(in) :: orbs(norb,norb)
integer(kind=iwp), intent(in) :: ic
integer(kind=iwp) :: icivb
type(gjorb_type) :: gjorb
real(kind=wp), allocatable :: orbinv(:,:)

icivb = nint(civb(0))
if (icnt_ci(icivb) == 3-ic) return

if (.not. projcas) then
  call str2vbc_cvb(cvb,cvbdet)
  call vb2cic_cvb(cvbdet,civb)
else if (projcas) then
  call mma_allocate(orbinv,norb,norb,label='orbinv')
  call mma_allocate(gjorb%r,norb,norb,label='gjorb%r')
  call mma_allocate(gjorb%i1,norb,label='gjorb%i1')
  call mma_allocate(gjorb%i2,2,norb*norb,label='gjorb%i2')

  if (memplenty) then
    call getci_cvb(civec)
    call cicopy_cvb(civec,civb)
  else
    call cird_cvb(civb,61001.2_wp)
  end if
  orbinv(:,:) = orbs(:,:)
  call mxinv_cvb(orbinv,norb)
  call gaussj_cvb(orbinv,gjorb)
  call applyt_cvb(civb,gjorb)
  call ci2vbc_cvb(civb,cvbdet)
  call vb2strc_cvb(cvbdet,cvb)
  if (ic == 1) call vb2cic_cvb(cvbdet,civb)

  call mma_deallocate(orbinv)
  call mma_deallocate(gjorb%r)
  call mma_deallocate(gjorb%i1)
  call mma_deallocate(gjorb%i2)
end if
icnt_ci(icivb) = 3-ic

return

end subroutine makecivb_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c        files checkeroo
c        MakeChckData
c          MkL0
c          MkL2_chcc
c          MkQ0
c          MkQ1
c          MkQ22
c          MkQ4
c          MkQ3
c          MkOE
c          MkT1T2
c        SaveChckData
c        GetChckData
c        DistMemChck
c
c        ------------------------
c
        subroutine MakeChckData (wrk,wrksize,LunAux)
c
c        this routine generate checkeroo data
c        Use id possible only when NaGrp=NaSGRp=1
c
c        assumption nc>=nv>=no (inac preverit dimenzovanie)
c        dimensions: V1    - no*nv*nv2, nv2*nv2
c                    V2    - nc*nv2
c                    V3    - nc*nv*no
c
        implicit none
#include "wrk.fh"
#include "chcc1.fh"
#include "chcc_files.fh"
c
        integer LunAux
c
c        help variables
        integer dim1
        character*6 LunName
        integer PossV1,PossV2,PossV3,PossT
c
        call DistMemChck (PossV1,PossV2,PossV3,PossT)
c
c1        make Q0
        LunName=I0name
        dim1=no*(no+1)*no*(no+1)/4
        call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
        call MkQ0 (wrk(PossV1))
c
c2        make Q1
        LunName=I1name(1)
        dim1=no*(no+1)*no*nv/2
        call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
        call MkQ1 (wrk(PossV1))
c
c3        Read Q21
        LunName=I2name(1,1)
        dim1=no*no*nv*nv
        call GetX (Q21(1,1,1,1),dim1,LunAux,LunName,1,1)
c
c
c4        make Q22
        LunName=I3name(1,1)
        dim1=no*(no+1)*nv*(nv+1)/4
        call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
        call MkQ22 (wrk(PossV1))
c
c5        make Q4, L2k
        LunName=L2name(1,1)
        dim1=nc*nv*(nv+1)/2
        call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
         call MkL2_chcc (wrk(PossV2))
        dim1=nv*(nv+1)*nv*(nv+1)/4
        call mv0zero (dim1,dim1,wrk(PossV1))
        dim1=nv*(nv+1)/2
        call mc0c1at3b (nc,dim1,nc,dim1,dim1,dim1,
     c                 dim1,nc,dim1,
     c                 wrk(PossV2),wrk(PossV2),wrk(PossV1))
        call MkQ4 (wrk(PossV1))

c
c        make Q3, L1k
        LunName=L1name(1)
        dim1=nc*no*nv
        call GetX (wrk(PossV3),dim1,LunAux,LunName,1,1)
         call mv0u (dim1,wrk(PossV3),1,L1k(1,1,1),1)
        dim1=no*nv*nv*(nv+1)/2
        call mv0zero (dim1,dim1,wrk(PossV1))
        dim1=nv*(nv+1)/2
        call mc0c1at3b (nc,dim1,nc,no*nv,dim1,no*nv,dim1,nc,no*nv,
     c                 wrk(PossV2),wrk(PossV3),wrk(PossV1))
        call MkQ3 (wrk(PossV1))
c
c
c        make L0
         LunName=L0name
         dim1=nc*no*(no+1)/2
         call GetX (wrk(PossV3),dim1,LunAux,LunName,1,1)
         call MkL0 (wrk(PossV3))
c
c
c        make OEo,OEv
         call MkOE (wrk(PossOE))
c
        call MkT1T2
c
        return
        end
c
c        --------------------
c
        subroutine MkL0 (V)
c
c        L0(m,i,j) <- V(m,ij)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:nc,1:no*(no+1)/2)
c
c        help var
        integer i,j,ij,m
c
        ij=0
        do i=1,no
        do j=1,i
        ij=ij+1
          do m=1,nc
             L0k(m,i,j)=V(m,ij)
             L0k(m,j,i)=V(m,ij)
          end do
        end do
        end do
c
        return
        end
c
c        --------------------
c
        subroutine MkL2_chcc (V)
c
c        L2(m,a,b) <- V(m,ab)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:nc,1:nv*(nv+1)/2)
c
c        help var
        integer a,b,ab,m
c
        ab=0
        do a=1,nv
        do b=1,a
        ab=ab+1
          do m=1,nc
             L2k(m,a,b)=V(m,ab)
             L2k(m,b,a)=V(m,ab)
          end do
        end do
        end do
c
        return
        end
c
c        --------------------
c
        subroutine MkQ0 (V)
c
c        Q0(i,j,k,l) <- V(ij,kl)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:no*(no+1)/2,1:no*(no+1)/2)
c
c        help variables
        integer i,j,k,l,ij,kl
c
        kl=0
        do k=1,no
        do l=1,k
        kl=kl+1
          ij=0
          do i=1,no
          do j=1,i
          ij=ij+1
            Q0(i,j,k,l)=V(ij,kl)
            Q0(i,j,l,k)=V(ij,kl)
            Q0(j,i,k,l)=V(ij,kl)
            Q0(j,i,l,k)=V(ij,kl)
          end do
          end do
        end do
        end do
c
        return
        end
c
c        --------------------
c
        subroutine MkQ1 (V)
c
c        Q1(a,j,k,l) <- V(aj,kl)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:nv,1:no,1:no*(no+1)/2)
c
c        help variables
        integer a,j,k,l,kl
c
        kl=0
        do k=1,no
        do l=1,k
        kl=kl+1
          do j=1,no
          do a=1,nv
            Q1(a,j,k,l)=V(a,j,kl)
            Q1(a,j,l,k)=V(a,j,kl)
          end do
          end do
        end do
        end do
c
        return
        end
c
c        --------------------
c
        subroutine MkQ22 (V)
c
c        Q22(a,b,k,l) <- V(ij,kl)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:nv*(nv+1)/2,1:no*(no+1)/2)
c
c        help variables
        integer a,b,k,l,ab,kl
c
        kl=0
        do k=1,no
        do l=1,k
        kl=kl+1
          ab=0
          do a=1,nv
          do b=1,a
          ab=ab+1
            Q22(a,b,k,l)=V(ab,kl)
            Q22(a,b,l,k)=V(ab,kl)
            Q22(b,a,k,l)=V(ab,kl)
            Q22(b,a,l,k)=V(ab,kl)
          end do
          end do
        end do
        end do
c
        return
        end
c
c        --------------------
c
        subroutine MkQ4 (V)
c
c        Q4(a,b,c,d) <- V(ab,cd)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:nv*(nv+1)/2,1:nv*(nv+1)/2)
c
c        help variables
        integer a,b,c,d,ab,cd
c
        cd=0
        do c=1,nv
        do d=1,c
        cd=cd+1
          ab=0
          do a=1,nv
          do b=1,a
          ab=ab+1
            Q4(a,b,c,d)=V(ab,cd)
            Q4(a,b,d,c)=V(ab,cd)
            Q4(b,a,c,d)=V(ab,cd)
            Q4(b,a,d,c)=V(ab,cd)
          end do
          end do
        end do
        end do
c
        return
        end
c
c        --------------------
c
        subroutine MkQ3 (V)
c
c        Q1(a,b,c,l) <- V(ab,cl)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:nv*(nv+1)/2,1:no,1:nv)
c
c        help variables
        integer a,b,ab,c,l
c
        do l=1,no
        do c=1,nv
          ab=0
          do a=1,nv
          do b=1,a
          ab=ab+1
            Q3(a,b,c,l)=V(ab,l,c)
            Q3(b,a,c,l)=V(ab,l,c)
          end do
          end do
        end do
        end do
c
        return
        end
c
c        --------------------
c
        subroutine MkOE (OE)
c
c        OEo(i) <- OE(i)
c        OEv(a) <- OE(a)
c
        implicit none
#include "chcc1.fh"
        real*8 OE(1:(nv+no))
c
c        help variables
        integer a,i
c
        do i=1,no
          OEo(i)=OE(i)
        end do
c
        do a=1,nv
          OEv(a)=OE(no+a)
        end do
c
        return
        end
c
c        --------------------
c
        subroutine MkT1T2
c
c        T1(a,i) = 0 (mozno neskor ine)
c        T2(a,b,i,j) = (ai|bj)/Dabij
c
        implicit none
#include "chcc1.fh"
c
c        help variables
        integer a,b,i,j
c
        do i=1,no
        do a=1,nv
          T1c(a,i)=0.0d0
        end do
        end do
c
        do j=1,no
        do i=1,no
          do b=1,nv
          do a=1,nv
            T2c(a,b,i,j)=Q21(a,i,b,j)/(OEo(i)+OEo(j)-OEv(a)-OEv(b))
          end do
          end do
        end do
        end do
c
        return
        end
c
c        --------------------
c
        subroutine SaveChckData (LunAux)
c
c        this routine do:
c        Save Chck Data to ChkDat file
c
        implicit none
#include "chcc1.fh"
        integer LunAux
c
C       open (unit=LunAux,file='ChKDat',form='unformatted')
        Call Molcas_BinaryOpen_Vanilla(LunAux,'ChKDat')
          write(LunAux) T1c,T2c,OEo,OEv,Q0,Q1,Q21,Q22,Q3,Q4
     c                 ,L0k,L1k,L2k
        close (LunAux)
c
        return
        end
c
c        --------------------
c
        subroutine GetChckData (LunAux)
c
c        this routine do:
c        Get Chck Data from ChkDat file
c
        implicit none
#include "chcc1.fh"
        integer LunAux
c
*       open (unit=LunAux,file='ChKDat',form='unformatted')
        Call Molcas_BinaryOpen_Vanilla(LunAux,'ChKDat')
          read(LunAux) T1c,T2c,OEo,OEv,Q0,Q1,Q21,Q22,Q3,Q4
     c                 ,L0k,L1k,L2k
        close (LunAux)
c
        return
        end
c
c        --------------------
c
        subroutine  DistMemChck (PossV1,PossV2,PossV3,PossT)
c
c        Dimensions for DistMemCheck
c        dimensions: V1    - no*nv*nv2, nv2*nv2
c                    V2    - nc*nv2
c                    V3    - nc*nv*no

        implicit none
#include "chcc1.fh"
        integer PossV1,PossV2,PossV3,PossT
c
c        help variables
        integer len
c
        PossT=PossFree
c
        PossV1=PossT
        len=no*nv*nv*(nv+1)/2
        if ((nv*(nv+1)*nv*(nv+1)/4).gt.len) then
        len=nv*(nv+1)*nv*(nv+1)/4
        end if
        PossT=PossT+len
c
        PossV2=PossT
        len=nc*nv*(nv+1)/2
        PossT=PossT+len
c
        PossV3=PossT
        len=nc*no*nv
c
        PossT=PossT+len
c
        write (6,*) ' Poss ChCk',PossV1,PossV2,PossV3,PossT
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989,1991,1993, Jeppe Olsen                            *
!***********************************************************************

subroutine CNFSTR_MCLR(ICONF,ITYP,IASTR,IBSTR,NORB,NAEL,NBEL,IDET,IPRODT,IAGRP,IBGRP,ISCR,SGN)
! An orbital configuration ICONF is given,
! Obtain the corresponding alpha strings, IASTR
!        the corresponding beta  strings, IBSTR
!        the corresponding sign array,    SIGN
!
! Jeppe Olsen, Summer of 89
!
! Ninob added, October 1991
!
! Modified September 1993 for LUCIA

use Str_Info, only: NELEC, Str
use MCLR_Data, only: MINOP, NACOB, NDPCNT
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NAEL, NBEL, ICONF(NAEL+NBEL), ITYP, NORB, IDET, IPRODT(*), IAGRP, IBGRP
integer(kind=iwp), intent(out) :: IASTR(IDET), IBSTR(IDET), ISCR((IDET+2)*(NAEL+NBEL))
real(kind=wp), intent(out) :: SGN(IDET)
integer(kind=iwp) :: ICLOS, IOPEN, IP, ISGN, JDET, JTYP, KLDET, KLDETS, KLFREE, KLIA, KLIB, NEL
integer(kind=iwp), external :: ISTRNM

! Scratch (ISCR) : required length : IDET * (NAEL+NBEL) + 2(NAEL+NBEL)
! (this includes NAEL+NBEL words needed in DETSTR)

NEL = NAEL+NBEL
IOPEN = ITYP-1+MINOP
ICLOS = (NAEL+NBEL-IOPEN)/2

! Spin orbital occupations of determinants of configuration

KLFREE = 1

KLDETS = KLFREE
KLFREE = KLDETS+IDET*(NAEL+NBEL)

KLIA = KLFREE
KLFREE = KLFREE+NAEL

KLIB = KLFREE
KLFREE = KLFREE+NBEL

KLDET = KLFREE
KLFREE = KLFREE+NAEL+NBEL

! Pointer for determinants of prototype ITYP

IP = 1
do JTYP=1,ITYP-1
  IP = IP+NDPCNT(JTYP)*(JTYP-1+MINOP)
end do
! Expand into determinants

call CNDET_MCLR(ICONF,IPRODT(IP),IDET,NAEL+NBEL,NORB,IOPEN,ICLOS,ISCR(KLDETS))

! Separate determinants into strings and determine sign change

do JDET=1,IDET
  call DETSTR_MCLR(ISCR(KLDETS+(JDET-1)*NEL),ISCR(KLIA),ISCR(KLIB),NEL,NAEL,NBEL,ISGN,ISCR(KLDET))
  ! Actual numbers of alpha and beta string
  IASTR(JDET) = ISTRNM(ISCR(KLIA),NACOB,NELEC(IAGRP),Str(IAGRP)%Z,Str(IAGRP)%STREO,1)
  IBSTR(JDET) = ISTRNM(ISCR(KLIB),NACOB,NELEC(IBGRP),Str(IBGRP)%Z,Str(IBGRP)%STREO,1)
  SGN(JDET) = real(ISGN,kind=wp)
end do

end subroutine CNFSTR_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1992,2000,2007, Roland Lindh                 *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drvg1_3Center_RI(Grad,Temp,nGrad,ip_ij3,nij_Eff)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals. The four outermost loops *
*          will controll the type of the two-electron integral, eg.    *
*          (ss|ss), (sd|pp), etc. The next four loops will generate    *
*          list of symmetry distinct centers that do have basis func-  *
*          tions of the requested type.                                *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
* For RI-HF gradients read:                                            *
* "Analytical Gradients of Hartee-Fock Exchange with Density Fitting   *
* Approximations", J. Bostrom, F. Aquilante, T. B. Pedersen and R.     *
* Lindh, JCTC,  9:204-212 (2013).                                      *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August '91                         *
*             Modified for gradient calculation. January '92           *
*             Modified for SetUp_Ints. January '00                     *
*             Modified for 3-center RI gradients, March '07            *
************************************************************************
      use k2_setup
      use iSD_data
      use pso_stuff
      use k2_arrays, only: ipZeta, ipiZet, Mem_DBLE, Aux, Sew_Scr
      use Basis_Info
      use Sizes_of_Seward, only:S
      use Real_Info, only: CutInt
      use RICD_Info, only: Do_RI
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Rsv_Tsk2
#include "Molcas.fh"
#include "itmax.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "disp.fh"
#include "nsd.fh"
#include "cholesky.fh"
#include "setup.fh"
#include "exterm.fh"
#include "chomp2g_alaska.fh"
*#define _CD_TIMING_
#ifdef _CD_TIMING_
#include "temptime.fh"
#endif
      Integer iBDsh(MxShll*8)
      Common /BDshell/ iBDsh
      Integer  Cho_irange
      External Cho_irange
*     Local arrays
      Real*8  Coor(3,4), Grad(nGrad), Temp(nGrad)
      Integer iAnga(4), iCmpa(4), iShela(4),iShlla(4),
     &        iAOV(4), istabs(4), iAOst(4), JndGrd(3,4), iFnc(4),
     &        nAct(0:7)
      Integer ipXmi(5)
      Integer nHrrTb(0:iTabMx,0:iTabMx,2)
      Logical EQ, Shijij, AeqB, CeqD, DoGrad, DoFock, Indexation,
     &        JfGrad(3,4), ABCDeq, No_Batch, Rsv_Tsk2, Found,
     &        FreeK2, Verbose
      Character Format*72, Method*8, KSDFT*16
      Character*50 CFmt
      Character*16 SECNAM
      Parameter (SECNAM = 'drvg1_3center_ri')
*
      Integer iSD4(0:nSD,4)
      save MemPrm
      Logical Timings,FlipFlop
      COMMON /CHOTIME / timings
#include "ymnij.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      TMax_Valence(i,j)=Work(ipTMax-1+(j-1)*nSkal_Valence+i)
      TMax_Auxiliary(i)=Work(ipTMax-1+nSkal_Valence**2+i)
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 9
      iPrint = nPrint(iRout)
#ifdef _CD_TIMING_
      Twoel3_CPU = 0.0d0
      Twoel3_Wall = 0.0d0
      Pget3_CPU = 0.0d0
      Pget3_Wall = 0.0d0
#endif
      iFnc(1)=0
      iFnc(2)=0
      iFnc(3)=0
      iFnc(4)=0
      PMax=Zero
      idum=0
      idum1=0
      call dcopy_(nGrad,[Zero],0,Temp,1)
*                                                                      *
************************************************************************
*                                                                      *
      xfk=1.0D-3 ! changing this parameter tunes LK-type screening thr
*     xfk=1.0D-12! Debugging
*     xfk=0.0D-12! Debugging
*                                                                      *
************************************************************************
*                                                                      *
      Call Get_dScalar('Cholesky Threshold',ThrCom)
      ThrCom=Max(ThrCom,1.0d-6) ! not to sacrify efficiency too much
*                                                                      *
************************************************************************
*                                                                      *
*     Handle mixed basis set
*
      If (Do_RI) Then
         Call Set_Basis_Mode('Auxiliary')
         Call Nr_Shells(nSkal_Auxiliary)
         Call Set_Basis_Mode('WithAuxiliary')
      Else
         Call Set_Basis_Mode('Valence')
         nSkal_Auxiliary=0
      End If
      Call SetUp_iSD()
*                                                                      *
************************************************************************
*                                                                      *
*-----Precompute k2 entities.
*
      Indexation=.False.
      DoFock=.False.
      DoGrad=.True.
      ThrAO=Zero
      Call SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
      nSkal_Valence=nSkal-nSkal_Auxiliary
      mSkal=nSkal
      nPairs=nSkal*(nSkal+1)/2
      nQuad =nPairs*(nPairs+1)/2
      Pren = Zero
      Prem = Zero
*                                                                      *
************************************************************************
*                                                                      *
      MxPrm = 0
      Do iAng = 0, S%iAngMx
         MxPrm = Max(MxPrm,S%MaxPrm(iAng))
      End Do
      nZeta = MxPrm * MxPrm
      nEta  = MxPrm * MxPrm
*                                                                      *
************************************************************************
*                                                                      *
      maxnAct=0
      If (lPSO) Then
         Call Get_iArray('nAsh',nAct,nIrrep)
         maxnnP=nnP(0)
         maxnAct=nAct(0)
         Do i=1,nIrrep-1
           maxnnP=max(maxnnP,nnP(i))
           maxnAct=max(maxnAct,nAct(i))
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      nTMax=nSkal_Valence**2+nSkal_Auxiliary
      If (Do_RI) nTMax = nTMax-1
      Call GetMem('TMax','Allo','Real',ipTMax,nTMax)
*
      Call Allocate_Work(ip_Tmp,nSkal**2)
      Call Shell_MxSchwz(nSkal,Work(ip_Tmp))
      TMax_all=Zero
      Do iS = 1, nSkal_Valence
         Do jS = 1, iS
            ip_Out=ip_Tmp + (jS-1)*nSkal + iS -1
            ip_In =ipTMax + (jS-1)*nSkal_Valence + iS -1
            Work(ip_In)=Work(ip_Out)
            ip_In =ipTMax + (iS-1)*nSkal_Valence + jS -1
            Work(ip_In)=Work(ip_Out)
            TMax_all=Max(TMax_all,Work(ip_Out))
         End Do
      End Do
      If (Do_RI) Then
         Do iS = 1, nSkal_Auxiliary-1
            iS_ = iS + nSkal_Valence
            jS_ = nSkal_Valence + nSkal_Auxiliary
            ip_Out = ip_Tmp + (iS_-1)*nSkal + jS_ -1
            ip_In  = ipTMax + nSkal_Valence**2 + iS -1
            Work(ip_In)=Work(ip_Out)
         End Do
      End If
*
      Call Free_Work(ip_Tmp)

*                                                                      *
************************************************************************
*                                                                      *
      MxInShl = 1
      Do i = 1, nSkal_Valence
         MxInShl = max(MxInShl,iSD(3,i)*iSD(2,i))
      End Do
*
*     Calculate maximum density value for each shellpair
*
      lMaxDens = nSkal_Valence*(nSkal_Valence+1)/2
      Call GetMem('MaxDensity','Allo','Real',ip_MaxDens,lMaxDens)
      Call FZero(Work(ip_MaxDens),lMaxDens)
*
      iOff=0
      Do iSym = 0, nSym-1
         iDlt=ipDMLT(1)+iOff-1
         kS=1+nSkal_Valence*iSym ! note diff wrt declaration of iBDsh
         Do j=1,nBas(iSym)
            jsh=Cho_Irange(j,iBDsh(kS),nSkal_Valence,.true.)
            Do i=1,j
               ish=Cho_Irange(i,iBDsh(kS),nSkal_Valence,.true.)
               ijS=ip_MaxDens-1+jsh*(jsh-1)/2+ish
               Do iSO=1,nJDens
                 ij=ipDMLT(iSO)+iOff-1+j*(j-1)/2+i
                 Dm_ij=abs(Work(ij))
                 Work(ijS)=Max(Work(ijS),Dm_ij)
               End Do
            End Do
         End Do
         iOff=iOff+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
*
      Call Free_Work(ipDMLT(1))
      If (nKdens.eq.2) Call Free_Work(ipDMLT(2))
*
*     Create list of non-vanishing pairs
*
*1)   For the valence basis set
*
*
      Call GetMem('ip_ij','Allo','Inte',ip_ij,
     &            nSkal_Valence*(nSkal_Valence+1))
      nSkal2=0
      Do iS = 1, nSkal_Valence
         iiQ = iS*(iS+1)/2
         XDm_ii = Work(ip_MaxDens+iiQ-1)
         Do jS = 1, iS
            jjQ = jS*(jS+1)/2
            XDm_jj = Work(ip_MaxDens+jjQ-1)
            ijQ=iS*(iS-1)/2+jS
            XDm_ij = Work(ip_MaxDens+ijQ-1)
            XDm_max = Max(XDm_ij,XDm_ii,XDm_jj)
            Aint_ij=TMax_Valence(iS,jS)
            If (TMax_All*Aint_ij .ge. CutInt) Then
*
* --- FAQ: more aggressive screening to discard shprs formed
*          by AOs contributing mainly to the virtual MO space.
*
               If (Aint_ij*XDm_max .ge. CutInt) Then
                  nSkal2 = nSkal2 + 1
                  iWork((nSkal2-1)*2+ip_ij  )=iS
                  iWork((nSkal2-1)*2+ip_ij+1)=jS
               End If
*
            End If
         End Do
      End Do
*
*2)   For the auxiliary basis set
*
      If (Do_RI) Then
         mij = nSkal_Auxiliary*2
         Call GetMem('ip_ij','Allo','Inte',ip_ij2,mij)
         nij=0
         Do jS = nSkal_Valence+1, nSkal-1
            If (TMax_All*TMax_Auxiliary(jS-nSkal_Valence).ge.CutInt)
     &         Then
               nij = nij + 1
               iWork((nij-1)*2+ip_ij2  )=nSkal
               iWork((nij-1)*2+ip_ij2+1)=jS
            End If
         End Do
      Else
         mij = 2*nij_Eff
         Call GetMem('ip_ij','Allo','Inte',ip_ij2,mij)
         nij=0
         Do ij = 1, nij_Eff
            iS = iWork(ip_ij3-1 + (ij-1)*2 +1)
            jS = iWork(ip_ij3-1 + (ij-1)*2 +2)
            If (TMax_All*TMax_Valence(iS,jS).ge.CutInt) Then
               nij = nij + 1
               iWork((nij-1)*2+ip_ij2  )=iS
               iWork((nij-1)*2+ip_ij2+1)=jS
            End If
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (DoCholExch) Then
*
*        Find the largest number of contractions in any given shell of
*        auxiliary functions.
*
         MxChVInShl = 1
         If(Do_RI) Then
            Do i = nSkal_Valence+1, nSkal_Valence+nSkal_Auxiliary
               MxChVInShl = max(MxChVInShl,iSD(3,i))
            End Do
         Else
            Write (6,*) 'Not implemented for Cholesky yet!'
            Call Abend()
         End If
*
*        Find the largest set of ij. The i and j basis are due to the CD
*        of the one-particle density matrix.
*
*        nIJ1: diagonal blocks are triangularized.
*        nIJR: diagonal blocks are square.
*        nIMax: largest number of i basis in any irrep.
*
         nIJ1Max = 0
         nIJRMax = 0
         nIMax = 0
         Do iSym = 1, nIrrep
            Do iSO=1,nKDens
               nIMax = max(nIMax,nChOrb(iSym-1,iSO))
            End Do
            Do jSym = 1, nIrrep
               Do iSO=1,nKVec
                 nIJ1Max = max(nIJ1Max,nIJ1(iSym,jSym,iSO))
                 nIJRMax = max(nIJRMax,nIJR(iSym,jSym,iSO))
               End Do
            End Do
         End Do
*
*        Allocate scratch memory for step 4 (Eq. 16). This is done
*        in two steps.
*
*        First step: Sum(j) X_lj C_ij^K = C_il^K; (l=valence basis)
*        Second step: Sum(i) C_il^K X_ki = B_kl^K
*
         lCijK = nIJRMax*MxChVInShl
         lCilK = MxInShl*nIMax*MxChVInShl
         lCilK = Max(lCilK,lCijK) ! it is used as scratch in pget
         Call GetMem('CijK','Allo','Real',ip_CijK,lCilK)
         If (lPSO) lCilK=Max(lCilK,maxnAct) ! used as scratch
         Call GetMem('CilK','Allo','Real',ip_CilK,lCilK)
         lBklK = MxInShl**2*MxChVInShl
         Call GetMem('BklK','Allo','Real',ip_BklK,lBklK)
*
         If(iMp2prpt .eq. 2) Then
            lB_mp2 = mxChVInShl*nBas(0)*nBas(0)
            Do i = 1, 2
               Call GetMem('B_mp2','Allo','Real',ip_B_mp2(i),lB_mp2)
            End Do
         End If
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*        The C_ij^K vectors are stored in triangular form. We now
*        change this to stricked rectangular/square form. Diagonal
*        elements are rescaled. In case of symmetry this is only
*        done for the blocks with isym=jSym, i.e. kSym=1
*
         kSym = 1
         nK = NumAuxVec(kSym)
*
         lCVec  = nIJ1Max*nK
         lCVec2 = nIJRMax*nK
         Call GetMem('C_Vector','Allo','Real',ip_CVec,  lCVec )
         Call GetMem('C_Vector2','Allo','Real',ip_CVec2,lCVec2)
*
         Do iSO=1,nKVec
           If (lSA) Go to 15
           Do iSym = 1, nSym
              jSym = iSym
*             jSym = iEor(kSym-1,jSym-1)+1
*
*             Read a whole block of C_ij^K
*
              iAdrC = iAdrCVec(kSym,iSym,iSO)
              Call dDaFile(LuCVector(kSym,iSO),2,Work(ip_CVec),
     &                     nIJ1(iSym,jSym,iSO)*nK,iAdrC)
*
              ni = nChOrb(iSym-1,iSO)
*             nj=ni
              index1 = ip_CVec
              Do KAux = 1, nK
                 index_aux = ip_CVec2+(KAux-1)*(ni*ni)
*
                 Do i = 1, ni
                    Do j = 1, i-1
                       index2 = index_aux + i-1 + (j-1)*ni
                       index3 = index_aux + j-1 + (i-1)*ni
                       Work(index2) = Work(index1)
                       Work(index3) = Work(index1)
                       index1 = index1 + 1
                    End Do
                    index2 = index_aux + i-1 + (j-1)*ni
                    Work(index2) = Work(index1)*Sqrt(Two)
                    index1 = index1 + 1
                 End Do
*
              End Do
*
*             Write back to disk. Note that the file is prepared for
*             rectangular/square storage so that one can safely write
*             back the expanded set to disk without any overwrite
*             problems.
*
              iAdrC = iAdrCVec(kSym,iSym,iSO)
              Call dDaFile(LuCVector(kSym,iSO),1,Work(ip_CVec2),
     &                     nIJR(iSym,jSym,iSO)*nK,iAdrC)
*
           End Do
 15        Continue
         End Do
*
         Call GetMem('C_Vector','Free','Real',ip_CVec,  lCVec )
         Call GetMem('C_Vector2','Free','Real',ip_CVec2,lCVec2)
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*        Stuff used in the prescreening!
*
         MumOrb=0
         NumOrb=0
         Do iSO=1,nKDens
            Do jSym = 1, nSym
               NumOrb = NumOrb + nChOrb(jSym-1,iSO)
               MumOrb = Max( MumOrb, nChOrb(jSym-1,iSO) )
            End Do
            If (iSO.lt.nKDens) ipYmnij(iSO+1)=NumOrb
         End Do
*
*        Scratch store the index of the MOs which finds the estimate
*        according to Eq. 18 to be larger than the threshold.
*
         Call GetMem('Ymnij','Allo','Inte',ipYmnij(1),NumOrb)
         Call IZero(iWork(ipYmnij(1)),NumOrb)
         Do i=2,nKDens
           ipYmnij(i)=ipYmnij(1)+ipYmnij(i)
         End Do
*
*        Make a list for each shell-pair over the largest element
*        SQRT(ABS( (mu,nu|mu,nu) ))
*
         nnSkal = nSkal_valence*(nSkal_valence+1)/2
         Call GetMem('MaxDG','Allo','Real',ipSDG,nnSkal)
         Call get_maxDG(Work(ipSDG),nnSkal,MxBasSh)
*
*        Scratch for reduced lists of X_mi. Used in pget.
*
         nXki=MumOrb*MxBasSh*nSym
         Call GetMem('MOs_Yij','Allo','Real',jr_Xki(1),2*nKDens*nXki)
         jr_Xli(1)=jr_Xki(1)+nXki
         Do i=2,nKDens
           jr_Xki(i)=jr_Xki(i-1)+2*nXki
           jr_Xli(i)=jr_Xki(i)+nXki
         End Do
*
*        Make a list the largest element X_mu,i for each valence shell
*        and a fixed i. X_mu,i defined in Eq. 13.
*
         l_MaxXi=MumOrb*nSkal_valence*nIrrep ! X_i,ishell,isym
         Call GetMem('MaxXi','Allo','Real',ipXmi(1),l_MaxXi*nKDens)
         Do i=2,nKDens
           ipXmi(i)=ipXmi(i-1)+l_MaxXi
         End Do
         l_MaxXi=l_MaxXi*nKDens
*
         Do iSO=1,nKDens
            Call get_mXOs(iSO,Work(ipXmi(iSO)),MumOrb,nSkal_valence,
     &                 nIrrep,nChOrb(0,iSO))
         End Do
*
      Else
*
         nXki=0
         NumOrb=0
         MumOrb=0
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     For CASSCF process the active space contribution.
*
      If (lPSO) Then
         nBas_Aux(0)=nBas_Aux(0)-1
         Call GetMem('Thhalf','Allo','Real',ip_Thhalf,maxnnP)
         nThpkl=MxChVInShl*MxInShl**2
         Call mma_allocate(Thpkl,nThpkl,Label='Thpkl')
*
         Call contract_Zpk_Tpxy(Z_p_k ,nZ_p_k,
     &                          Txy   ,n_Txy,
     &                          Work(ip_Thhalf),maxnnP,
     &                          DMdiag ,nG1,
     &                          nnP,nBas_Aux,
     &                          nADens,nAvec,nAct,nIrrep)
*
         Call GetMem('Thhalf','Free','Real',ip_Thhalf,maxnnP)
         nBas_Aux(0)=nBas_Aux(0)+1
      Else
         nThpkl=1
         Call mma_allocate(Thpkl,nThpkl,Label='Thpkl')
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-------Compute FLOP's for the transfer equation.
*
      Do iAng = 0, S%iAngMx
         Do jAng = 0, iAng
            nHrrab = 0
            Do i = 0, iAng+1
               Do j = 0, jAng+1
                  If (i+j.le.iAng+jAng+1) Then
                     ijMax = Min(iAng,jAng)+1
                     nHrrab = nHrrab + ijMax*2+1
                  End If
               End Do
            End Do
            nHrrTb(iAng,jAng,1)=nHrrab
            nHrrTb(jAng,iAng,1)=nHrrab
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     For a parallel implementation the iterations over shell-pairs
*     are parallelized.
*
*     If only Coulombic terms are to be processed use dynamic setup.
*     Otherwise do batches exactly in the same order as Seward did the
*     2-center terms.
*
      Call Get_cArray('Relax Method',Method,8)
      If (Method.ne.'KS-DFT  ') Then
         iOpt=1
      Else
         Call Get_cArray('DFT functional',KSDFT,16)
         ExFac=Get_ExFac(KSDFT)
         iOpt=0
         If (ExFac.ne.Zero) iOpt=1
      End If
      If(.not. Do_RI) iOpt=0
*
      ip_LB=ip_iDummy
      If (iOpt.eq.1) Then
         Call qpg_iArray('LBList',Found,nSkal2_)
         If (Found) Then
            Call Allocate_iWork(ip_LB,nSkal2_)
            Call Get_iArray('LBList',iWork(ip_LB),nSkal2_)
         Else
            Call WarningMessage(2,'LBList not found!')
            Call Abend()
         End If
      End If
      Call Init_Tsk2(id,nSkal2,iOpt,iWork(ip_LB))
      If (iOpt.eq.1) Call Free_iWork(ip_LB)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_MaxDBLE(MemMax)
      Call mma_allocate(Sew_Scr,MemMax,Label='Sew_Scr')
      ipMem1=1
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Do klS = 1, nSkal2
   10    Continue
         If (.Not.Rsv_Tsk2(id,klS)) Go To 11
*
         kS = iWork((klS-1)*2+ip_ij  )
         lS = iWork((klS-1)*2+ip_ij+1)
*
         AInt_kl = TMax_Valence(kS,lS)
*
         klS_=iTri(kS,lS)
*                                                                      *
************************************************************************
*                                                                      *
*        Prescreening stuff for exchange
*
         If (DoCholExch) Then
*
*
*           For the shell-pair, (kS,lS), pick up the largest element
*           Sqrt(Abs(  (kappa,lambda|kappa,lambda) ))
*
            SDGmn=Work(ipSDG+klS_-1)
*
*
*           Loop over the MO basis, jb and ib and approximate Y_ij
*           (Eq. 18)
*
            Do iSO=1,nKVec
              FlipFlop=.True.
              iMOleft=iSO
              iMOright=iSO
              If (lSA) iMOright=iSO+2
 20           Continue
              nj=0
              Do jSym = 1, nSym
                NumOrb_j  = nChOrb(jSym-1,iMOleft)-1
*
                mj=0
                Do jb=0,NumOrb_j
                  ip_Xmi=ipXmi(iMOleft) + MumOrb*nSkal_valence*(jSym-1)
                  Xjk=Work(ip_Xmi+MumOrb*(kS-1)+jb)
                  Xjl=Work(ip_Xmi+MumOrb*(lS-1)+jb)
*
                  jSym_s = jSym
                  if (ks.ne.ls.or.iMOright.ne.iMOleft) jSym_s=1
                  Do iSym = jsym_s, nSym
                     NumOrb_i  = nChOrb(iSym-1,iMOright)-1
                     If (iSym.eq.jSym.and.ks.eq.ls
     &                    .and.iMOright.eq.iMOleft) NumOrb_i = jb
*
                     Do ib = NumOrb_i, 0, -1
                       jp_Xmi=ipXmi(iMOright)+
     &                        MumOrb*nSkal_valence*(iSym-1)
                       Xik=Work(jp_Xmi+MumOrb*(kS-1)+ib)
                       Xil=Work(jp_Xmi+MumOrb*(lS-1)+ib)
*
* ---                  Yij[mn] = (1+Pij) Xim * (mn|mn)^1/2 * Xjn
*
                       PZmnij=(Xik*Xjl+Xil*Xjk)*SDGmn
*
*                      If larger than the threshold put j in the
*                      list and exit the loop.
*
                       If ( PZmnij.ge.xfk*ThrCom ) Then
!                        orbital in the list
                         iWork(ipYmnij(iMOleft)+mj+nj)=jb+1
                         mj=mj+1
                         Go To 666
                       End If
                     End Do ! ib
                  End Do    ! iSym
 666              Continue
                End Do
*
*               Trick used in pget to skip
*               If (mj.eq.NumOrb_j .and. xfk.gt.zero) mj=-mj
*
*               The first element is to keep track on how many elements
*               that were saved.
*
!               nOrbs in the list ==> dim(ij)=nOrbs**2
                nYmnij(jSym,iMOleft)=mj
                iOff_Ymnij(jSym,iMOleft) = nj
                nj = nj + mj
*
              End Do ! jSym
              If (lSA.and.FlipFlop) Then
                FlipFlop=.False.
                itmp=iMOleft
                iMOleft=iMOright
                iMOright=itmp
                Go To 20
              EndIf
            End Do
*
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Do ijS = 1, nij
         iS = iWork((ijS-1)*2+ip_ij2  )
         jS = iWork((ijS-1)*2+ip_ij2+1)
*
         If (Do_RI) Then
            Aint=AInt_kl*TMax_Auxiliary(jS-nSkal_Valence)
         Else
            Aint=AInt_kl*TMax_Valence(iS,jS)
         End If
         If (AInt.lt.CutInt) Go To 14
         If (iPrint.ge.15) Write (6,*) 'iS,jS,kS,lS=',iS,jS,kS,lS
*                                                                      *
************************************************************************
*                                                                      *
         Call Gen_iSD4(iS, jS, kS, lS,iSD,nSD,iSD4)
         Call Size_SO_block_g(iSD4,nSD,nSO,No_batch)
         If (No_batch) Go To 140
*
         Call Int_Prep_g(iSD4,nSD,Coor,Shijij,iAOV,iStabs)
*
*                                                                      *
************************************************************************
*                                                                      *
*       --------> Memory Managment <--------
*
*        Compute memory request for the primitives, i.e.
*        how much memory is needed up to the transfer
*        equation.
*
         Call MemRys_g(iSD4,nSD,nRys,MemPrm)
*                                                                      *
************************************************************************
*                                                                      *
         ABCDeq=EQ(Coor(1,1),Coor(1,2)) .and.
     &          EQ(Coor(1,1),Coor(1,3)) .and.
     &          EQ(Coor(1,1),Coor(1,4))
         ijklA=iSD4(1,1)+iSD4(1,2)
     &        +iSD4(1,3)+iSD4(1,4)
         If (nIrrep.eq.1.and.ABCDeq.and.Mod(ijklA,2).eq.1)
     &      Go To 140
*                                                                      *
************************************************************************
*                                                                      *
*        Decide on the partioning of the shells based on the
*        available memory and the requested memory.
*
*        Now check if all blocks can be computed and stored at
*        once.
*
         Call SOAO_g(iSD4,nSD,nSO,
     &               MemPrm, MemMax,
     &               iBsInc,jBsInc,kBsInc,lBsInc,
     &               iPrInc,jPrInc,kPrInc,lPrInc,
     &               ipMem1,ipMem2, Mem1,  Mem2,
     &               iPrint,iFnc, MemPSO)
         iBasi    = iSD4(3,1)
         jBasj    = iSD4(3,2)
         kBask    = iSD4(3,3)
         lBasl    = iSD4(3,4)
*                                                                      *
************************************************************************
*                                                                      *
         Call Int_Parm_g(iSD4,nSD,iAnga,
     &                 iCmpa,iShlla,iShela,
     &                 iPrimi,jPrimj,kPrimk,lPriml,
     &                 indij,k2ij,nDCRR,k2kl,nDCRS,
     &                 mdci,mdcj,mdck,mdcl,AeqB,CeqD,
     &                 nZeta,nEta,ipZeta,ipZI,
     &                 ipP,ipEta,ipEI,ipQ,ipiZet,ipiEta,
     &                 ipxA,ipxB,ipxG,ipxD,l2DI,nab,nHmab,ncd,nHmcd,
     &                 nIrrep)
*                                                                      *
************************************************************************
*                                                                      *
*        Scramble arrays (follow angular index)
*
         Do iCar = 1, 3
            Do iSh = 1, 4
               JndGrd(iCar,iSh) = iSD4(15+iCar,iSh)
               If (iSh.eq.1.and.Do_RI) Then
                  JfGrad(iCar,iSh) = .False.
                  JndGrd(iCar,iSh) = 0
               Else If (iAnd(iSD4(15,iSh),2**(iCar-1)) .eq.
     &             2**(iCar-1)) Then
                  JfGrad(iCar,iSh) = .True.
               Else
                  JfGrad(iCar,iSh) = .False.
               End If
            End Do
         End Do
*
         Do 400 iBasAO = 1, iBasi, iBsInc
           iBasn=Min(iBsInc,iBasi-iBasAO+1)
           iAOst(1) = iBasAO-1
         Do 410 jBasAO = 1, jBasj, jBsInc
           jBasn=Min(jBsInc,jBasj-jBasAO+1)
           iAOst(2) = jBasAO-1
*
         Do 420 kBasAO = 1, kBask, kBsInc
           kBasn=Min(kBsInc,kBask-kBasAO+1)
           iAOst(3) = kBasAO-1
         Do 430 lBasAO = 1, lBasl, lBsInc
           lBasn=Min(lBsInc,lBasl-lBasAO+1)
           iAOst(4) = lBasAO-1
*
*----------Get the 2nd order density matrix in SO basis.
*
           nijkl = iBasn*jBasn*kBasn*lBasn
#ifdef _CD_TIMING_
           CALL CWTIME(Pget0CPU1,Pget0WALL1)
#endif
           Call PGet0(iCmpa,
     &                iBasn,jBasn,kBasn,lBasn,Shijij,
     &                iAOV,iAOst,nijkl,Sew_Scr(ipMem1),nSO,
     &                iFnc(1)*iBasn,iFnc(2)*jBasn,
     &                iFnc(3)*kBasn,iFnc(4)*lBasn,MemPSO,
     &                Sew_Scr(ipMem2),Mem2,iS,jS,kS,lS,nQuad,PMax)
#ifdef _CD_TIMING_
           CALL CWTIME(Pget0CPU2,Pget0WALL2)
           Pget3_CPU = Pget3_CPU + Pget0CPU2-Pget0CPU1
           Pget3_Wall = Pget3_Wall + Pget0WALL2-Pget0WALL1
#endif
            If (AInt*PMax.lt.CutInt) Then
               Go To 430
            End If
*
*----------Compute gradients of shell quadruplet
*
#ifdef _CD_TIMING_
           Call CWTIME(TwoelCPU1,TwoelWall1)
#endif
           Call TwoEl_g(Coor,
     &          iAnga,iCmpa,iShela,iShlla,iAOV,
     &          mdci,mdcj,mdck,mdcl,nRys,
     &          Data_k2(k2ij),nab,nHmab,nDCRR,
     &          Data_k2(k2kl),ncd,nHmcd,nDCRS,Pren,Prem,
     &          iPrimi,iPrInc,jPrimj,jPrInc,
     &          kPrimk,kPrInc,lPriml,lPrInc,
     &          Shells(iSD4(0,1))%pCff(1,iBasAO),iBasn,
     &          Shells(iSD4(0,2))%pCff(1,jBasAO),jBasn,
     &          Shells(iSD4(0,3))%pCff(1,kBasAO),kBasn,
     &          Shells(iSD4(0,4))%pCff(1,lBasAO),lBasn,
     &          Mem_DBLE(ipZeta),Mem_DBLE(ipZI),Mem_DBLE(ipP),nZeta,
     &          Mem_DBLE(ipEta), Mem_DBLE(ipEI),Mem_DBLE(ipQ),nEta,
     &          Mem_DBLE(ipxA),Mem_DBLE(ipxB),
     &          Mem_DBLE(ipxG),Mem_DBLE(ipxD),Temp,nGrad,
     &          JfGrad,JndGrd,Sew_Scr(ipMem1), nSO,Sew_Scr(ipMem2),Mem2,
     &          Aux,nAux,Shijij)
#ifdef _CD_TIMING_
           Call CWTIME(TwoelCPU2,TwoelWall2)
           Twoel3_CPU = Twoel3_CPU + TwoelCPU2-TwoelCPU1
           Twoel3_Wall = Twoel3_Wall + TwoelWall2-TwoelWall1
#endif
*
            If (iPrint.ge.15)
     &         Call PrGrad(' In Drvg1_3Center_RI: Grad',
     &                  Temp,nGrad,ChDisp,iPrint)
*
 430     Continue
 420     Continue
*
 410     Continue
 400     Continue
*
 140     Continue
*
 14      Continue
         End Do
*
         Go To 10
 11   Continue
*     End of big task loop
*                                                                      *
************************************************************************
*                                                                      *
*     Write Timings:
*
      If(Timings) Then
       TotCPU = tbvec(1) + tavec(1)
       TotWall = tbvec(2) + tavec(2)
       CFmt='(2x,A)'
       Write(6,*)
       Write(6,CFmt)'Cholesky Gradients timing from A and B vectors:'
       Write(6,CFmt)'-----------------------------------------------'
       Write(6,*)
       Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
       Write(6,CFmt)'                                CPU       WALL   '
       Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

       Write(6,'(2x,A26,2f10.2)')'Density (2-center):               '
     &                           //'         ',tavec(1),tavec(2)
       Write(6,'(2x,A26,2f10.2)')'Density (3-center):               '
     &                           //'         ',tbvec(1),tbvec(2)
       Write(6,*)
       Write(6,'(2x,A26,2f10.2)')'TOTAL                             '
     &                           //'         ',TotCPU,TotWall
       Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
       Write(6,*)
*
      End If
      timings = timings_default
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*                                                                      *
*     Deallocate scratch for exchange term
*
      If (DoCholExch) Then
         Call GetMem('MaxXi','Free','Real',ipXmi(1),l_MaxXi)
         Call GetMem('MOs_Yij','Free','Real',jr_Xki(1),2*nKVec*nXki)
         Call GetMem('MaxDG','Free','Real',ipSDG,nnSkal)
         Call GetMem('Ymnij','Free','Inte',ipYmnij(1),NumOrb)
         Call GetMem('CijK','Free','Real',ip_CijK,lCijK)
         Call GetMem('CilK','Free','Real',ip_CilK,lCilK)
         Call GetMem('BklK','Free','Real',ip_BklK,lBklK)
         Call GetMem('ijList','Free','Inte',ipijList,lijList)
         Call GetMem('ijListTri','Free','Inte',ipijListTri,lijList)
         Call GetMem('JKVEC','Free','Real',ip_VJ,ljkVec)
         Do i=1,nKDens
           If (lCMOi(i).gt.0) Then
              Call GetMem('CMO_inv','FREE','Real',ip_CMOi(i), lCMOi(i))
           End If
         End DO
      End If
      Call GetMem('MaxDensity','Free','Real',ip_MaxDens,lMaxDens)
*
      If(iMp2prpt .eq. 2) Then
         Do i = 1, 2
            Call GetMem('B_mp2','Free','Real',ip_B_mp2(i),lB_mp2)
         End Do
      End If
*
      If (Allocated(Thpkl)) Call mma_deallocate(Thpkl)
*
      Call mma_deallocate(Sew_Scr)
      Call Free_Tsk2(id)
      Call GetMem('ip_ij','Free','Inte',ip_ij2,mij)
      Call GetMem('ip_ij','Free','Inte',ip_ij,nSkal*(nSkal+1))
      Call GetMem('TMax','Free','Real',ipTMax,nSkal**2)
*                                                                      *
************************************************************************
*                                                                      *
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*                                                                      *
************************************************************************
*                                                                      *
      Call Sync_Data(Pren,Prem,nBtch,mBtch,kBtch)
*
      iPren=3+Max(1,Int(Log10(Pren+0.001D+00)))
      iPrem=3+Max(1,Int(Log10(Prem+0.001D+00)))
      Write (Format,'(A,I2,A,I2,A)') '(A,F',iPren,
     &           '.0,A,F',iPrem,'.0,A)'
      If (iPrint.ge.6) Then
      Write (6,Format)
     &   ' A total of', Pren,' entities were prescreened and',
     &                  Prem,' were kept.'
      End If
*
      Call Free_iSD()
*
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Grad)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkmapampq(syma)
! this routine prepares mapd,mapi
! for <am|pq> for given syma, m, p,q to mapd2,mapi2

use ccsort_global, only: mapd2, mapi2, noa, NORB, NSYM, pos20
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: syma
integer(kind=iwp) :: length, nhelp, pos, symm, symmp, symp, symq

! set mapi1 to zero

mapi2(1:nsym,1:nsym,1:nsym) = 0

! def zero-th row

mapd2(0,1) = 1
mapd2(0,2) = 5
mapd2(0,3) = 5
mapd2(0,4) = 0
mapd2(0,6) = 0

nhelp = 0
pos = pos20
do symm=1,nsym
  do symp=1,nsym
    symmp = mul(symm,symp)
    symq = mul(syma,symmp)
    nhelp = nhelp+1

    ! calc. length
    length = noa(symm)*NORB(symp)*NORB(symq)

    mapd2(nhelp,1) = pos
    mapd2(nhelp,2) = length
    mapd2(nhelp,3) = symm
    mapd2(nhelp,4) = symp
    mapd2(nhelp,5) = symq
    mapd2(nhelp,6) = 1
    pos = pos+length

    mapi2(symm,symp,1) = nhelp

  end do
end do

mapd2(0,5) = nhelp

return

end subroutine mkmapampq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PtQuad(H0,Ovlp,RR,nSize,Temp,nTemp)
*
************************************************************************
*                                                                      *
*     Objective: Construct the modified Hamiltonian,                   *
*                i.e., add quadrupole perturbation operator            *
*                                                                      *
************************************************************************
*
      Implicit Real*8 ( A-H,O-Z )
*

#include "input.fh"
*
      Real*8 H0(nSize), Ovlp(nSize), RR(nSize), Temp(nTemp)
      Character*8 Label
      Character*20 PriLbl
      Dimension Cntr(3)
      Integer DiComp(3)
      Data    DiComp/1,4,6/
      Logical Debug,Exec,Orig,Diag
      Data    Debug/.false./
      Dimension idum(1)
*
*----------------------------------------------------------------------*
*                                                                      *
*     Start procedure                                                  *
*     Check if the command has been specified on input                 *
*                                                                      *
*----------------------------------------------------------------------*
*
*
      Exec=.false.
      Exec=Exec.or.ComStk(2,2,1,1)
      Exec=Exec.or.ComStk(2,2,1,2)
      Exec=Exec.or.ComStk(2,2,1,3)
      Exec=Exec.or.ComStk(2,2,1,4)
      Exec=Exec.or.ComStk(2,2,1,5)
      Exec=Exec.or.ComStk(2,2,1,6)
      Exec=Exec.or.ComStk(2,2,1,7)
      If ( .not.Exec ) then
         Return
      End If
*
*----------------------------------------------------------------------*
*     Check if a origin has been specified                             *
*     The unspecified components of the origin are set to 0.0 !        *
*     If no origin has been given pick the center of mass!             *
*----------------------------------------------------------------------*
*
c        Do i=1,nAtoms
c          Print *,i,(Coor(j,i),j=1,3)
c        End Do

      Orig=.false.
      Orig=Orig.or.ComStk(2,2,2,1)
      Orig=Orig.or.ComStk(2,2,2,2)
      Orig=Orig.or.ComStk(2,2,2,3)
      Orig=Orig.or.ComStk(2,2,2,4)
*
      If ( Orig ) Then
        XOrig=0.0
        YOrig=0.0
        ZOrig=0.0
        If ( ComStk(2,2,2,1) ) XOrig=ComVal(2,2,2,1)
        If ( ComStk(2,2,2,2) ) YOrig=ComVal(2,2,2,2)
        If ( ComStk(2,2,2,3) ) ZOrig=ComVal(2,2,2,3)
        If ( ComStk(2,2,2,4) ) Then
          iAtm=INT(ComVal(2,2,2,4))
          If ( Debug )
     *      Write(6,'(6X,A,I2)')'Origin of perturbation is centered '//
     *                          'at atom ',iAtm
          If ( iAtm.lt.0 .or. iAtm.gt.nAtoms ) Then
             Write (6,*) 'PtOkt0: You specified a invalid atom number'
     &                 //' as the origin of the perturbation operator.'
             Call Abend()
          End If
          XOrig=Coor(1,iAtm)
          YOrig=Coor(2,iAtm)
          ZOrig=Coor(3,iAtm)
        End If
      Else
        Call Get_dArray('Center of Mass',Cntr,3)
        XOrig=Cntr(1)
        YOrig=Cntr(2)
        ZOrig=Cntr(3)
      End If
      If ( Debug )
     *  Write(6,'(6X,A,3F12.6)')'Origin of the perturbation operator =',
     *  XOrig,YOrig,ZOrig
*
*----------------------------------------------------------------------*
*     Check if a diagonal component has been specified.                *
*     If so, compute R**2 first.                                       *
*----------------------------------------------------------------------*
*
      Diag=.false.
      Do iDiag=1,3
        Diag=Diag.or.ComStk(2,2,1,DiComp(iDiag))
      End Do
*-----or if RR option is used
      Diag=Diag.or.ComStk(2,2,1,7)
*
      If ( Diag ) Then
        Do iDiag=1,3
          Label='MltPl  2'
          iRc=-1
          iOpt1=1
          iOpt2=0
          iSyLbl=0
          iComp=DiComp(iDiag)
          Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
          nInts=idum(1)
          If ( iRc.ne.0 ) Goto 991
          Call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
          Call CmpInt(Temp,nInts,nBas,nSym,iSyLbl)
          X=Temp(nInts+1)
          Y=Temp(nInts+2)
          Z=Temp(nInts+3)
          If ( X.ne.XOrig .or. Y.ne.YOrig .or. Z.ne.ZOrig ) Then
             Write (6,*) 'PtOkt0: Input error, no matching center'
     &                 //' is found.'
             Call Abend()
          End If
          If ( iComp.eq.1 ) Then
             call dcopy_(nInts,[0.0D0],0,RR,1)
             RR(nInts+4)=0.0D0
          End If
          Alpha=-0.5D0
          call daxpy_(nInts,Alpha,Temp,1,RR,1)
          RR(nInts+4)=RR(nInts+4)+Alpha*Temp(nInts+4)
          If ( Debug ) Then
            Write (6,'(6X,A,F8.6)') 'weight =',ComVal(2,2,1,iComp)
            PriLbl='MltPl  2; Comp =    '
            Write(PriLbl(19:20),'(I2)') iComp
            Call PrDiOp(PriLbl,nSym,nBas,Temp)
          End If
        End Do
        If ( Debug ) Then
          PriLbl='MltPl  2; Comp =R**2'
          Call PrDiOp(PriLbl,nSym,nBas,RR)
        End If
      End If
*
*----------------------------------------------------------------------*
*     Loop over components                                             *
*----------------------------------------------------------------------*
*
      jDiag=1
      iDiag=DiComp(jDiag)
      Do iComp=1,6
        If ( ComStk(2,2,1,iComp) ) Then
          Label='MltPl  2'
          iRc=-1
          iOpt1=1
          iOpt2=0
          iSyLbl=0
          Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
          nInts=idum(1)
          If ( iRc.ne.0 ) Goto 991
          Call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
          Call CmpInt(Temp,nInts,nBas,nSym,iSyLbl)
          X=Temp(nInts+1)
          Y=Temp(nInts+2)
          Z=Temp(nInts+3)
          If ( X.ne.XOrig .or. Y.ne.YOrig .or. Z.ne.ZOrig ) Then
             Write (6,*) 'PtOkt0: Input error, no matching center'
     &                 //' is found.'
             Call Abend()
          End If
          If ( iComp.eq.iDiag ) Then
            Alpha=-ComVal(2,2,1,iComp)
            call daxpy_(nInts,Alpha,RR,1,H0,1)
            H0(nInts+4)=H0(nInts+4)-Alpha*RR(nInts+4)
            Alpha=1.5*Alpha
            call daxpy_(nInts,Alpha,Temp,1,H0,1)
            H0(nInts+4)=H0(nInts+4)-Alpha*Temp(nInts+4)
          Else
            Alpha=-1.5D0*ComVal(2,2,1,iComp)
            call daxpy_(nInts,Alpha,Temp,1,H0,1)
            H0(nInts+4)=H0(nInts+4)-Alpha*Temp(nInts+4)
            If ( Debug ) Then
              Write (6,'(6X,A,F8.6)') 'weight =',ComVal(2,2,1,iComp)
              PriLbl='MltPl  2; Comp =    '
              Write(PriLbl(19:20),'(I2)') iComp
              Call PrDiOp(PriLbl,nSym,nBas,Temp)
            End If
          End If
        End If
        If ( iComp.eq.iDiag .and. iComp.ne.DiComp(3)) Then
          jDiag=jDiag+1
          iDiag=DiComp(jDiag)
        End If
      End Do
*-----RR option
      If ( ComStk(2,2,1,7) ) Then
         Alpha=2.0D0*(ComVal(2,2,1,7))
         CALL DAXPY_(nInts,Alpha,RR,1,H0,1)
         H0(nInts+4)=H0(nInts+4)-Alpha*RR(nInts+4)
      End If
*
*----------------------------------------------------------------------*
*     Normal Exit                                                      *
*----------------------------------------------------------------------*
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Ovlp)
*
*----------------------------------------------------------------------*
*     Error Exit                                                       *
*----------------------------------------------------------------------*
*
991   Write (6,*) 'PtQuad: Error reading ONEINT'
      Write (6,'(A,A)') 'Label=',Label
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_Drv_ParTwoStep(irc)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: Parallel two-step decomposition of two-electron
!          integrals.

use Index_Functions, only: iTri, nTri_Elem
use Cholesky, only: BlockSize, ChkOnly, Cho_1Center, Cho_DecAlg, Cho_DecAlg_Def, Cho_DiaChk, Cho_Fake_Par, Cho_IntChk, Cho_IOVec, &
                    Cho_MinChk, Cho_No2Center, Cho_PreScreen, Cho_ReOrd, Cho_SimP, Cho_SimRI, Cho_SScreen, Cho_TrcNeg, &
                    Cho_TstScreen, CHo_UseAbs, Diag, Diag_G, Diag_G_Hidden, Diag_Hidden, Did_DecDrv, Frac_ChvBuf, HaltIt, iAlQua, &
                    iAtomShl, Idle, IFCSew, INF_PASS, INF_TIMING, IPRINT, iShP2Q, iShP2RS, LuPri, MaxQual, MinQual, Mode_Screen, &
                    ModRst, Mx2Sh, MxShPr, N1_Qual, N1_VecRd, N2_Qual, N2_VecRd, N_Subtr, nDecom, nDGM_call, nInteg, nMisc, &
                    nSection, nShell, nSym, nSys_call, RstCho, RstDia, ScDiag, SSTau, tDecDrv, tDecom, Thr_PreScreen, Thr_SimRI, &
                    ThrCom, ThrDiag, TimSec, tInteg, tMisc, Tol_DiaChk, Trace_Idle
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: BlockSize_Bak, Cho_DecAlg_Bak, Cho_DecAlg_Def_Bak, Cho_IOVec_Bak, i1, iAlQua_Bak, iBlock, ijBlock, &
                     iPrint_Bak, iSec, iSym, jBlock, l_Z, MaxQual_Bak, MinQual_Bak, Mode_Screen_Bak, ModRst_Bak, MxShPr_Bak, n, &
                     N1_Qual_Bak, N1_VecRD_Bak, N2_Qual_Bak, N2_VecRd_Bak, N_Subtr_Bak, nB, nB_Max, nDGM_Call_Bak, ni, nj, &
                     nnBlock, nSys_Call_Bak
real(kind=wp) :: Byte, C0, C1, Frac_ChVBuf_Bak, SSTau_Bak, tC0, tC1, tCPU0, tCPU1, tDecom_Bak(2,nDecom), Thr_PreScreen_Bak, &
                 Thr_SimRI_Bak, ThrDiag_Bak, TimSec_Bak(4,nSection), tInteg_Bak(2,nInteg), tMisc_Bak(2,nMisc), Tol_DiaChk_Bak, &
                 tW0, tW1, tWall0, tWall1, W0, W1
logical(kind=iwp) :: ChkOnly_Bak, Cho_1Center_Bak, Cho_DiaChk_Bak, Cho_Fake_Par_Bak, Cho_IntChk_Bak, Cho_MinChk_Bak, &
                     Cho_No2Center_Bak, Cho_PreScreen_Bak, Cho_ReOrd_Bak, Cho_SimP_Bak, Cho_SimRI_Bak, Cho_SScreen_Bak, &
                     Cho_TrcNeg_Bak, Cho_TstScreen_Bak, Cho_UseAbs_Bak, Did_DecDrv_Bak, Free_Z, HaltIt_Bak, lConv, RstCho_Bak, &
                     RstDia_Bak, ScDiag_Bak, Trace_Idle_Bak
character(len=2) :: Unt
integer(kind=iwp), allocatable :: iV1Block(:,:), nBlock(:), nVBlock(:,:), NVT(:), ZBlock(:,:)
real(kind=wp), allocatable :: Check(:), Err(:), Z(:)
real(kind=wp), parameter :: DumTst = 0.123456789_wp, DumTol = 1.0e-15_wp
character(len=*), parameter :: myName = 'DPTS', SecNam = 'Cho_Drv_ParTwoStep'

! Preliminaries.
! ==============

#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem('Start of '//SecNam)
#endif

! Start overall timing
if (iPrint >= Inf_Timing) call CWTime(tCPU0,tWall0)

! Init return code
irc = 0

! make a dummy allocation
call mma_allocate(Check,1,Label='Check')
Check(1) = DumTst

lConv = .false.

! Initialization.
! ===============

iSec = 1
if (iPrint >= Inf_Timing) call CWTime(TimSec(1,iSec),TimSec(3,iSec))
call Cho_Init(.false.,.true.)
call GASync()
if (iPrint >= Inf_Timing) then
  call CWTime(TimSec(2,iSec),TimSec(4,iSec))
  call Cho_PrtTim('Cholesky initialization',TimSec(2,iSec),TimSec(1,iSec),TimSec(4,iSec),TimSec(3,iSec),1)
end if
#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem(SecNam//': After init')
#endif

! Get diagonal.
! =============

iSec = 2
if (iPrint >= Inf_Timing) then
  call CWTime(TimSec(1,iSec),TimSec(3,iSec))
  write(LuPri,'(/,A)') '***** Starting Cholesky diagonal setup *****'
  call XFlush(LuPri)
end if
call Cho_GetDiag(lConv)
call GASync()
if (lConv) then
  ! restart is not possible, so it cannot be converged!!
  write(LuPri,'(A,A)') SecNam,': logical error: converged but not restart?!?!'
  call Cho_Quit('Error in '//SecNam,103)
end if
if (iPrint >= Inf_Timing) then
  call CWTime(TimSec(2,iSec),TimSec(4,iSec))
  call Cho_PrtTim('Cholesky diagonal setup',TimSec(2,iSec),TimSec(1,iSec),TimSec(4,iSec),TimSec(3,iSec),1)
end if
#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem(SecNam//': After diagonal')
#endif

! Cholesky decomposition in two steps.
! ====================================

! Time the rest as "decomposition driver"
call CWTime(C0,W0)

iSec = 3
if (iPrint >= Inf_Timing) then
  call CWTime(TimSec(1,iSec),TimSec(3,iSec))
  write(LuPri,'(/,A)') '***** Starting Cholesky decomposition *****'
  call XFlush(LuPri)
end if

! Perform first CD step: get parent diagonals and Z vectors.
! Z vectors contain more elements than needed at this stage!
! (more elements than vectors). The final Z vectors are obtained
! below (Cho_GetZ).
call Cho_P_SetAddr()
call Cho_DecDrv(Diag)
call GASync()
if (iPrint >= Inf_Timing) then
  call CWTime(tC1,tW1)
  call Cho_PrtTim('Cholesky map generation',tC1,TimSec(1,iSec),tW1,TimSec(3,iSec),2)
end if
#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem(SecNam//': After 1st step')
#endif

! Shut down and re-initialize.
! This is done to get rid of the vast amount of different data
! generated by the parallel decomposition in particular.
! In addition, it will make it easier to use the vector calculator
! externally (i.e. after seward execution)
if (iPrint >= Inf_Timing) call CWTime(tC0,tW0)
TimSec_Bak(:,:) = TimSec(:,:)
tInteg_Bak(:,:) = tInteg(:,:)
tDecom_Bak(:,:) = tDecom(:,:)
tMisc_Bak(:,:) = tMisc(:,:)
Trace_Idle_Bak = Trace_Idle
Cho_UseAbs_Bak = Cho_UseAbs
Cho_DiaChk_Bak = Cho_DiaChk
Cho_Fake_Par_Bak = Cho_Fake_Par
Cho_SimP_Bak = Cho_SimP
Cho_ReOrd_Bak = Cho_ReOrd
ChkOnly_Bak = ChkOnly
Cho_IntChk_Bak = Cho_IntChk
Cho_MinChk_Bak = Cho_MinChk
Cho_TrcNeg_Bak = Cho_TrcNeg
Cho_TstScreen_Bak = Cho_TstScreen
RstDia_Bak = RstDia
RstCho_Bak = RstCho
Mode_Screen_Bak = Mode_Screen
Cho_DecAlg_Def_Bak = Cho_DecAlg_Def
ModRst_Bak = ModRst
N_Subtr_Bak = N_Subtr
Did_DecDrv_Bak = Did_DecDrv
HaltIt_Bak = HaltIt
Tol_DiaChk_Bak = Tol_DiaChk
Cho_1Center_Bak = Cho_1Center
Cho_No2Center_Bak = Cho_No2Center
Cho_PreScreen_Bak = Cho_PreScreen
Thr_PreScreen_Bak = Thr_PreScreen
ThrDiag_Bak = ThrDiag
ScDiag_Bak = ScDiag
MinQual_Bak = MinQual
MaxQual_Bak = MaxQual
N1_Qual_Bak = N1_Qual
N2_Qual_Bak = N2_Qual
MxShPr_Bak = MxShPr
iAlQua_Bak = iAlQua
Cho_IOVec_Bak = Cho_IOVec
Frac_ChVBuf_Bak = Frac_ChVBuf
Cho_SScreen_Bak = Cho_SScreen
SStau_Bak = SStau
Cho_SimRI_Bak = Cho_SimRI
Thr_SimRI_Bak = Thr_SimRI
Cho_DecAlg_Bak = Cho_DecAlg
BlockSize_Bak = BlockSize
iPrint_Bak = iPrint
Cho_IOVec_Bak = Cho_IOVec
N1_VecRd_Bak = N1_VecRd
N2_VecRd_Bak = N2_VecRd
nSys_Call_Bak = nSys_Call
nDGM_Call_Bak = nDGM_Call
call Cho_P_WrDiag()
call Cho_Final(.true.)
call Cho_P_OpenVR(2)
call Cho_X_Init(irc,Zero)
if (irc /= 0) then
  write(LuPri,*) SecNam,': Cho_X_Init returned code ',irc
  irc = 1
  ! clear memory and return
  call Finish_this()
  return
end if
if (Cho_1Center) then
  if (.not. allocated(iAtomShl)) then
    call mma_allocate(iAtomShl,nShell,Label='iAtomShl')
    call Cho_SetAtomShl(irc,iAtomShl,size(iAtomShl))
    if (irc /= 0) then
      write(LuPri,'(A,A,I8)') SecNam,': Cho_SetAtomShl returned code',irc
      irc = 1
      ! clear memory and return
      call Finish_this()
      return
    end if
  end if
end if
TimSec(:,:) = TimSec_Bak(:,:)
tInteg(:,:) = tInteg_Bak(:,:)
tDecom(:,:) = tDecom_Bak(:,:)
tMisc(:,:) = tMisc_Bak(:,:)
Trace_Idle = Trace_Idle_Bak
Cho_UseAbs = Cho_UseAbs_Bak
Cho_DiaChk = Cho_DiaChk_Bak
Cho_Fake_Par = Cho_Fake_Par_Bak
Cho_SimP = Cho_SimP_Bak
Cho_ReOrd = Cho_ReOrd_Bak
ChkOnly = ChkOnly_Bak
Cho_IntChk = Cho_IntChk_Bak
Cho_MinChk = Cho_MinChk_Bak
Cho_TrcNeg = Cho_TrcNeg_Bak
Cho_TstScreen = Cho_TstScreen_Bak
RstDia = RstDia_Bak
RstCho = RstCho_Bak
Mode_Screen = Mode_Screen_Bak
Cho_DecAlg_Def = Cho_DecAlg_Def_Bak
ModRst = ModRst_Bak
N_Subtr = N_Subtr_Bak
Did_DecDrv = Did_DecDrv_Bak
HaltIt = HaltIt_Bak
Tol_DiaChk = Tol_DiaChk_Bak
Cho_1Center = Cho_1Center_Bak
Cho_No2Center = Cho_No2Center_Bak
Cho_PreScreen = Cho_PreScreen_Bak
Thr_PreScreen = Thr_PreScreen_Bak
ThrDiag = ThrDiag_Bak
ScDiag = ScDiag_Bak
MinQual = MinQual_Bak
MaxQual = MaxQual_Bak
N1_Qual = N1_Qual_Bak
N2_Qual = N2_Qual_Bak
N1_VecRd = N1_VecRd_Bak
N2_VecRd = N2_VecRd_Bak
MxShPr = MxShPr_Bak
iAlQua = iAlQua_Bak
Cho_IOVec = Cho_IOVec_Bak
Frac_ChVBuf = Frac_ChVBuf_Bak
Cho_SScreen = Cho_SScreen_Bak
SStau = SStau_Bak
Cho_SimRI = Cho_SimRI_Bak
Thr_SimRI = Thr_SimRI_Bak
Cho_DecAlg = Cho_DecAlg_Bak
BlockSize = BlockSize_Bak
iPrint = iPrint_Bak
Cho_IOVec = Cho_IOVec_Bak
N1_VecRd = N1_VecRd_Bak
N2_VecRd = N2_VecRd_Bak
nSys_Call = nSys_Call_Bak
nDGM_Call = nDGM_Call_Bak
! Allocate memory for extracting integral columns directly in
! reduced set from Seward. Set Seward interface to 3 (to treat
! columns shell pair-wise).
IFCSEW = 3
call mma_allocate(iShP2RS,2,Mx2Sh,Label='iShP2RS')
call mma_allocate(iShP2Q,2,Mx2Sh,Label='iShP2Q ')
if (iPrint >= Inf_Timing) then
  call CWTime(tC1,tW1)
  call Cho_PrtTim('Cholesky reinitialization',tC1,tC0,tW1,tW0,2)
end if
#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem(SecNam//': After re-init')
#endif

! Get Z vectors in core
if (iPrint >= Inf_Timing) call CWTime(tC0,tW0)
call mma_allocate(NVT,nSym,Label='NVT')
call Cho_X_GetTotV(NVT,size(NVT))
call Cho_ZMem(irc,l_Z,NVT,size(NVT),iPrint >= Inf_Timing,.true.)
if (irc /= 0) then
  write(LuPri,'(A,A,I6)') SecNam,': Cho_ZMem returned code',irc
  if (irc == 999) then
    if (iPrint < Inf_Timing) call Cho_ZMem(irc,l_Z,NVT,size(NVT),.true.,.false.)
    call mma_maxDBLE(l_Z)
    call Cho_Word2Byte(l_Z,8,Byte,Unt)
    write(LuPri,'(A,I12,A,F7.3,1X,A,A)') 'Largest available memory block:',l_Z,' words (',Byte,Unt,')'
    write(LuPri,'(A)') '=> INSUFFICIENT MEMORY FOR STORING Z VECTORS!'
    write(LuPri,'(/,A,/,A)') 'You have the following options:','(a) Increase available memory (MOLCAS_MEM),'
    write(LuPri,'(A)') 'and/or'
    write(LuPri,'(A,/,A,/,A,/,A,/,A,/,A)') '(b) -SERIAL EXECUTION:', &
                                           '       Use the serial two-step algorithm by specifying the keywords', &
                                           '          ChoInput','          TwoStep','          EndChoInput', &
                                           '       in Seward input.'
    write(LuPri,'(A,/,A,/,A,/,A,/,A,/,A,/,A)') '    -PARALLEL EXECUTION:', &
                                               '       Use the parallel one-step algorithm by specifying the keywords', &
                                               '          ChoInput','          OneStep','          Parallel', &
                                               '          EndChoInput','       in Seward input.'
    call Cho_Quit(SecNam//': Insufficient memory for Z vectors',101)
  end if
  irc = 1
  ! clear memory and return
  call Finish_this()
  return
end if
call mma_allocate(Z,l_Z,Label='Z')
call mma_allocate(nBlock,nSym,Label='nBlock')
nB_Max = 0
do iSym=1,nSym
  nB = (NVT(iSym)-1)/BlockSize+1
  nB_Max = max(nB_Max,nB)
  nBlock(iSym) = nB
end do
call mma_allocate(nVBlock,nB_Max,nSym,Label='nVBlock')
call mma_allocate(iV1Block,nB_Max,nSym,Label='iV1Block')
nVBlock(:,:) = 0
iV1Block(:,:) = 0

do iSym=1,nSym
  i1 = 1
  do iBlock=1,nBlock(iSym)-1
    nVBlock(iBlock,iSym) = BlockSize
    iV1Block(iBlock,iSym) = i1
    i1 = i1+BlockSize
  end do
  nVBlock(nBlock(iSym),iSym) = NVT(iSym)-BlockSize*(nBlock(iSym)-1)
  iV1Block(nBlock(iSym),iSym) = i1
end do
nnBlock = nTri_Elem(nB_Max)
call mma_allocate(ZBlock,nnBlock,nSym,Label='ZBlock')
ZBlock(:,:) = 0

n = 1
do iSym=1,nSym
  do jBlock=1,nBlock(iSym)
    nj = nVBlock(jBlock,iSym)
    ijBlock = iTri(jBlock,jBlock)
    ZBlock(ijBlock,iSym) = n
    n = n+nTri_Elem(nj)
    do iBlock=jBlock+1,nBlock(iSym)
      ni = nVBlock(iBlock,iSym)
      ijBlock = iTri(iBlock,jBlock)
      ZBlock(ijBlock,iSym) = n
      n = n+ni*nj
    end do
  end do
end do
call Cho_GetZ(irc,NVT,size(NVT),nBlock,size(nBlock),nVBlock,nB_Max,nSym,iV1Block,nB_Max,nSym,ZBlock,nnBlock,nSym,Z,l_Z)
if (irc /= 0) then
  write(LuPri,*) SecNam,': Cho_GetZ returned code ',irc
  irc = 1
  ! clear memory and return
  call Finish_this()
  return
end if
if (iPrint >= Inf_Timing) then
  call CWTime(tC1,tW1)
  call Cho_PrtTim('Cholesky Z vector fetching',tC1,tC0,tW1,tW0,2)
end if
#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem(SecNam//': After GetZ')
#endif

! Perform second step: calculation of Cholesky vectors from Z
! vectors and integrals.
if (iPrint >= Inf_Timing) then
  call CWTime(tC0,tW0)
end if
Free_Z = .true.
call Cho_X_CompVec(irc,NVT,size(NVT),nBlock,size(nBlock),nVBlock,nB_Max,nSym,iV1Block,nB_Max,nSym,ZBlock,nnBlock,nSym,Z,l_Z,Free_Z)
if (Free_Z) call mma_deallocate(Z)
if (irc /= 0) then
  write(LuPri,*) SecNam,': Cho_X_CompVec returned code ',irc
  irc = 1
  ! clear memory and return
  call Finish_this()
  return
end if
! Write restart files
call Cho_PTS_WrRst(irc,NVT,size(NVT))
if (irc /= 0) then
  write(LuPri,*) SecNam,': Cho_PTS_WrRst returned code ',irc
  irc = 1
  ! clear memory and return
  call Finish_this()
  return
end if
if (iPrint >= Inf_Timing) then
  call CWTime(tC1,tW1)
  call Cho_PrtTim('Cholesky vector generation',tC1,tC0,tW1,tW0,2)
end if

! Final timing of decomposition section
if (iPrint >= Inf_Timing) then
  call CWTime(TimSec(2,iSec),TimSec(4,iSec))
  call Cho_PrtTim('Cholesky decomposition',TimSec(2,iSec),TimSec(1,iSec),TimSec(4,iSec),TimSec(3,iSec),1)
end if

! time as "decomposition driver"
call CWTime(C1,W1)
tDecDrv(1) = C1-C0
tDecDrv(2) = W1-W0
#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem(SecNam//': After 2nd step.')
#endif

! Check diagonal.
! ===============

iSec = 4
if (iPrint >= Inf_Timing) then
  call CWTime(TimSec(1,iSec),TimSec(3,iSec))
  write(LuPri,'(/,A)') '***** Starting Cholesky diagonal check *****'
  call XFlush(LuPri)
end if
call mma_allocate(Err,4,Label='Err')
iPrint_Bak = iPrint
if (iPrint < Inf_Pass) iPrint = -99999999 ! suppress printing in Cho_X_CheckDiag
call Cho_X_CheckDiag(irc,Err)
iPrint = iPrint_Bak
if (irc /= 0) then
  write(LuPri,*) SecNam,': Cho_X_CheckDiag returned code ',irc
  irc = 1
  ! release memory and return
  call Finish_this()
  return
end if
if (Err(2) > ThrCom) then
  write(LuPri,'(/,A)') 'Cholesky decomposition failed!'
  write(LuPri,'(3X,A,ES15.6)') 'Largest integral diagonal..',Err(2)
  write(LuPri,'(3X,A,ES15.6)') 'Decomposition threshold....',ThrCom
  irc = 1
  ! release memory and return
  call Finish_this()
  return
end if
call mma_deallocate(Err)
if (iPrint >= Inf_Timing) then
  call CWTime(TimSec(2,iSec),TimSec(4,iSec))
  call Cho_PrtTim('Cholesky diagonal check',TimSec(2,iSec),TimSec(1,iSec),TimSec(4,iSec),TimSec(3,iSec),1)
end if
#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem(SecNam//': After diagonal check.')
#endif

! Finalization.
! =============

iSec = 8
if (iPrint >= Inf_Timing) then
  call CWTime(TimSec(1,iSec),TimSec(3,iSec))
  write(LuPri,'(/,A)') '***** Starting Cholesky finalization *****'
  call XFlush(LuPri)
end if
call mma_deallocate(Idle,safe='*')
call Cho_PTS_Final(NVT,size(NVT))
if (iPrint >= Inf_Timing) then
  call CWTime(TimSec(2,iSec),TimSec(4,iSec))
  call Cho_PrtTim('Cholesky finalization',TimSec(2,iSec),TimSec(1,iSec),TimSec(4,iSec),TimSec(3,iSec),1)
end if
#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem(SecNam//': After finalization')
#endif

! Statistics.
! ===========

if (iPrint >= 1) then
  iSec = 9
  if (iPrint >= Inf_Timing) then
    call CWTime(TimSec(1,iSec),TimSec(3,iSec))
    write(LuPri,'(/,A)') '***** Starting Cholesky statistics *****'
    call XFlush(LUPRI)
  end if
  call Cho_PTS_Stat()
  call GASync()
  if (iPrint >= Inf_Timing) then
    call CWTime(TimSec(2,iSec),TimSec(4,iSec))
    call Cho_PrtTim('Cholesky statistics',TimSec(2,iSec),TimSec(1,iSec),TimSec(4,iSec),TimSec(3,iSec),1)
  end if
end if
#ifdef _DEBUGPRINT_
call Cho_PrtMaxMem(SecNam//': After statistics')
#endif

! Wrap it up and return.
! ======================

call mma_deallocate(iV1Block)
call mma_deallocate(nVBlock)
call mma_deallocate(ZBlock)
call mma_deallocate(nBlock)
call mma_deallocate(NVT)

! Close vector and restart files
call Cho_OpenVR(2,2)

call Finish_this()

contains

! error termination point
subroutine Finish_this()

  ! check memory
  if (abs(DumTst-Check(1)) > DumTol) then
    write(LuPri,*) SecNam,': memory has been out of bounds [2]'
    irc = 2
  end if

  call mma_deallocate(Diag_Hidden,safe='*')
  call mma_deallocate(Diag_G_Hidden,safe='*')
  nullify(Diag,Diag_G)
  call mma_deallocate(Check)

  ! Print total timing
  if ((iPrint >= Inf_Timing) .and. (irc == 0)) then
    call CWTime(tCPU1,tWall1)
    call Cho_PrtTim('Cholesky Procedure',tCPU1,tCPU0,tWall1,tWall0,1)
  end if

  call XFlush(LuPri)
# ifdef _DEBUGPRINT_
  call Cho_PrtMaxMem('End of '//SecNam)
# endif

end subroutine Finish_this

end subroutine Cho_Drv_ParTwoStep

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cavitation(DoDeriv,nAt,nS,nTs,GCavP,VMol,TAbs,RSolv,Sphere,Tessera,iSphe)
! Compute cavitation energy given the cavity.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Four, Pi, Angstrom, rNAVO, Rgas, cal_to_J
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: DoDeriv
real(kind=wp), intent(in) :: VMol, TAbs, RSolv
integer(kind=iwp), intent(in) :: nAt, nS, nTs, iSphe(nTs)
real(kind=wp), intent(out) :: GCavP
real(kind=wp), intent(in) :: Sphere(4,nS), Tessera(4,nTs)
integer(kind=iwp) :: iS, ISph, iTs
real(kind=wp) :: AExpsd, ATotal, DENum, Fact, Frac, G, R, RSph, RT, YM, YP
real(kind=wp), allocatable :: CavS(:), dCav(:,:), dEA(:,:,:), EA(:)
real(kind=wp), parameter :: Avgdr = rNAVO*1.0e-24_wp, FPI = Four*Pi, GC = Rgas/cal_to_J

call mma_allocate(CavS,nS,label='CavSph')
call mma_allocate(dCav,3,nAt,label='dCav')
call mma_allocate(EA,nS,label='ExpArea')
call mma_allocate(dEA,3,nAt,nS,label='dExpArea')
CavS(:) = Zero
dCav(:,:) = Zero
EA(:) = Zero
dEA(:,:,:) = Zero

! Compute the exposed area for each sphere
do iTs=1,nTs
  iS = iSphe(iTs)
  EA(iS) = EA(iS)+Angstrom**2*Tessera(4,iTs)
end do

! Cavitation Energy:  R.A. Pierotti, Chem.Rev. 76,717,(1976).
!
! The cavitation energy is now computed for each sphere of the
! cavity. The values are scaled for the exposed surface of each
! sphere and summed irrespective of the number of cavities.
! The derivative of the cavitation energy wrt nuclear coordinates
! is also computed. To this end the Pierotti cavitation energy for
! each sphere is stored in the array CavS(ISph).

DENum = Avgdr/VMol
RT = GC*TAbs*0.001_wp
YP = DENum*FPI*RSolv**3/Three
YM = YP/(One-YP)

! Loop on spheres.

GCavP = Zero
do ISph=1,nS
  RSph = Angstrom*Sphere(4,ISph)
  R = RSph/RSolv

  ! Pierotti's cavitation free energy for the single sphere.

  G = -log(One-YP)+4.5_wp*YM**2*R**2+Three*YM*R*(R+One)
  G = RT*G
  CavS(ISph) = G
  AExpsd = EA(ISph)
  ATotal = FPI*RSph*RSph
  Frac = AExpsd/ATotal
  GCavP = GCavP+G*Frac
end do

! Computation of derivatives wrt nuclear coordinates according to
! the modification of Claverie to the Pierotti approach.

! Loop on atoms, coordinates, tesserae and then spheres.

if (DoDeriv) then
  do ISph=1,nS
    RSph = Angstrom*Sphere(4,ISph)
    Fact = CavS(ISph)/(FPI*RSph*RSph)
    dCav(:,:) = dCav(:,:)+Fact*dEA(:,:,ISph)
  end do
end if

call mma_deallocate(CavS)
call mma_deallocate(dCav)
call mma_deallocate(EA)
call mma_deallocate(dEA)

return

end subroutine Cavitation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SMDFGP_GEN(NGRP,NSMST,MXPNS,NSTFSMGP,NACTSYM,ISMDFGP)
*
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER ISMDFGP(NSMST,NGRP)
      INTEGER NSTFSMGP(MXPNS,NGRP)
      INTEGER NACTSYM(NGRP)
      INTEGER IOFF
*
      NTEST = 00
*
      IF(NTEST.ge.1000) Then
        write(6,*) 'Entering  SMDFGP_GEN   '
        write(6,*) 'NGRP : ', NGRP
        write(6,*) 'NSMST: ', NSMST
        write(6,*) 'MXPNS', MXPNS
        write(6,*) 'INPUT: NSTFSMGP'
        Do ISYM = 1,NSMST
          write(6,'(40I5)') (NSTFSMGP(ISYM,IGRP),IGRP=1,NGRP)
        End Do
      End IF
*
      Do IGRP = 1,NGRP
        IOFF = 0
        NACTSYM(IGRP) = IOFF
        Do ISYM = 1,NSMST
          ISMDFGP(ISYM,IGRP) = 0
          If(NSTFSMGP(ISYM,IGRP).ne.0) Then
            IOFF = IOFF+1
            ISMDFGP(IOFF,IGRP) = ISYM
          End If
        End Do
        NACTSYM(IGRP) = IOFF
      End Do
*
      IF(NTEST.ge.100) Then
        write(6,*) 'Number of Active Symm per GRP:'
        write(6,*) (NACTSYM(IGRP),IGRP=1,NGRP)
        write(6,*) 'Symmetries allowed by each group:'
        Do ISYM = 1,NSMST
          write(6,'(40I2)') (ISMDFGP(ISYM,IGRP),IGRP=1,NGRP)
        End Do
      End IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  isConstant
*
*> @brief
*>   Return ``.True.`` if all elements of \p M are identical to \p Const within tolerance \p Tol
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Test if array \p M is constant. If \f$ \forall i \; |M_i - \text{Const}| \le \text{Tol} \f$
*> return ``.True.``.
*>
*> @param[in] M     Array to test
*> @param[in] n     Dimension of \p M
*> @param[in] Const Constant
*> @param[in] Tol   Tolerance
*>
*> @return ``.True.`` if all elements of \p M are identical to \p Const within tolerance \p Tol
************************************************************************
      Logical Function isConstant(M,n,Const,Tol)
      Implicit None
      Integer n
      Real*8  M(n)
      Real*8  Const
      Real*8  Tol

      Integer i

      isConstant=.True.
      i=0
      Do While (i.lt.n .and. isConstant)
         i=i+1
         isConstant=abs(M(i)-Const).le.Tol
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_GETKEY(LUNIT,OPTION,LOPTION,NOPTION,IDKEY,
     &                          LUPRI)
C
C     Purpose: get next keyword and convert it to internal IDKEY.
C
#include "implicit.fh"
      CHARACTER*(*) OPTION(NOPTION)  ! <-- character*(loption)

      CHARACTER*14 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_GETKEY')

      PARAMETER (LBLINE = 180, LKWORD = 180)
      CHARACTER*(LBLINE) BLINE
      CHARACTER*(LKWORD) KWORD, KEY

      CHARACTER*(LKWORD) GET_LN
      EXTERNAL GET_LN

      CHARACTER*1 COMMENT
      PARAMETER (COMMENT = '*')

      INTEGER  CHO_TABIND
      EXTERNAL CHO_TABIND

      LOGICAL USE_OBS, USE_ALI

      PARAMETER (NTABLE = 58, LKEY = 4, NEOINP = 1)
      CHARACTER*(LKEY) TABLE(NTABLE)
      CHARACTER*(LKEY) EOINP(NEOINP)

      PARAMETER (NOBSOL = 1, NALIAS = 12)
      CHARACTER*(LKEY) OBSOL(NOBSOL)
      CHARACTER*(LKEY) ALIAS(NALIAS,2)

      DATA TABLE /'THRC','PRIN','BUFF','THRD','DMP1',
     &            'DMP2','SPAN','MINQ','MXSH','SCRE',
     &            'NOSC','QUAL','THRN','WARN','TOON',
     &            'CHEC','CHKA','RSTD','RSTC','RSTM',
     &            'MAXQ','CHOM','REDM','CHKS','CHKM',
     &            'ABSO','NOAB','TRCN','IOVE','REOR',
     &            'HALT','FRAC','QFRA','MXSU','ADDR',
     &            'IFCS','ONES','TWOS','NAIV','VBUF',
     &            'DIAC','TSTS','SSCR','NOSS','SSTH',
     &            'SSNO','1-CE','NO2-','NOPR','PRES',
     &            'PRET','PARA','SIMP','SIMR','FAKE',
     &            'TRUE','BLOC','IDLE'/
      DATA EOINP /'ENDC'/
      DATA OBSOL /'XXXX'/
      DATA ALIAS /'PREC','THSI','THSU','STOP','MEMQ',
     &            'IOMO','DYNA','1CEN','NO2C','THRP',
     &            '1CCD','1C-C',
     &            'THRC','DMP1','DMP2','HALT','QFRA',
     &            'ADDR','VBUF','1-CE','NO2-','PRET',
     &            '1-CE','1-CE'/

C Set flags for using obsolete/alias keywords:
      PARAMETER (USE_OBS = .FALSE., USE_ALI = .TRUE.)

C     Check that we are in sync with caller.
C     --------------------------------------

      IF (NOPTION .NE. NTABLE) THEN
         WRITE(LUPRI,*) SECNAM,': NOPTION = ',NOPTION,
     &                          ' NTABLE = ',NTABLE
         IDKEY = -5
         GO TO 2000
      END IF

C     Other internal checks.
C     ----------------------

      IF (LKEY .GT. LKWORD) THEN
         WRITE(LUPRI,*) SECNAM,': LKEY = ',LKEY,
     &                          ' LKWORD = ',LKWORD
         IDKEY = -5
         GO TO 2000
      END IF

C     Set blank line.
C     ---------------

      DO I = 1,LBLINE
         BLINE(I:I) = ' '
      END DO

C     Read keyword (the check for comment/blank line should be
C     obsolete).
C     --------------------------------------------------------

    1 KEY = GET_LN(LUNIT)
      KWORD = KEY
      CALL UPCASE(KWORD)
      KWORD = ADJUSTL(KWORD)
      DO WHILE (KWORD(1:1).EQ.COMMENT .OR. KWORD.EQ.BLINE)
         KEY = GET_LN(LUNIT)
         KWORD = KEY
         CALL UPCASE(KWORD)
         KWORD = ADJUSTL(KWORD)
      END DO

      LAST = ICLAST(KWORD,LEN(KWORD))
      DO I = LAST+1,LKEY
         KWORD(I:I) = ' '
      END DO

C     Check for obsolete keyword.
C     ---------------------------

      IF (USE_OBS) THEN
         IOBSOL = CHO_TABIND(OBSOL,LKEY,NOBSOL,' ',0,0,KWORD(1:LKEY))
         IF (IOBSOL.GT.0 .AND. IOBSOL.LE.NOBSOL) THEN
            WRITE(LUPRI,*) '*** NOTICE: Cholesky keyword "',
     &      KWORD(1:LKEY),'" is obsolete and will be disregarded.'
            GO TO 1
         END IF
      END IF

C     Check for alias.
C     ----------------

      IALIAS = 0
      IF (USE_ALI) THEN
         IALIAS = CHO_TABIND(ALIAS(1,1),LKEY,NALIAS,' ',0,0,
     &                       KWORD(1:LKEY))
         IF (IALIAS.GT.0 .AND. IALIAS.LE.NALIAS) THEN
            KWORD(1:LKEY) = ALIAS(IALIAS,2)
         ELSE
            IALIAS = 0
         END IF
      END IF

C     Table lookup.
C     -------------

      IDKEY = CHO_TABIND(TABLE,LKEY,NTABLE,EOINP,LKEY,NEOINP,
     &                   KWORD(1:LKEY))
      IF (IDKEY .EQ. -1) THEN
         WRITE(LUPRI,*) SECNAM,': keyword not recognized:'
         IF (IALIAS .GT. 0) THEN
            WRITE(LUPRI,*) 'Internal  key: ',KWORD(1:LAST),
     &                     ' (significant part: ',KWORD(1:LKEY),')'
            WRITE(LUPRI,*) 'Aliasing used: ',ALIAS(IALIAS,1),
     &                     ' <-> ',ALIAS(IALIAS,2)
         ELSE
            WRITE(LUPRI,*) 'Internal  key: ',KWORD(1:LAST),
     &                     ' (significant part: ',KWORD(1:LKEY),')'
         END IF
         WRITE(LUPRI,*)
         IF (LOPTION .GT. 0) THEN
            WRITE(LUPRI,*) 'Available keywords and short explanations:'
            DO IOPTION = 1,NOPTION
               IF (TABLE(IOPTION) .NE. 'XXXX') THEN
                  WRITE(LUPRI,*) TABLE(IOPTION),': ',
     &                           OPTION(IOPTION)
               END IF
            END DO
         ELSE
            WRITE(LUPRI,*) 'Available keywords:'
            DO IOPTION = 1,NOPTION
               IF (TABLE(IOPTION) .NE. 'XXXX') THEN
                  WRITE(LUPRI,*) TABLE(IOPTION)
               END IF
            END DO
         END IF
         WRITE(LUPRI,*)
      END IF

C     Normal exit point.
C     ------------------

 2000 RETURN

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Mk_Coeffs(CoeffA,nPrimA,nConA,CoeffB,nPrimB,nConB,
     &                     Coeff,nTheta_Full,nPhi,iD,NumCho,
     &                     List2,mData,nPhi_All,
     &                     Indkl,nkl,nk,nl,iAng,jAng,
     &                     CoeffAP,CoeffBP)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 CoeffA(nPrimA,nConA), CoeffB(nPrimB,nConB),
     &       Coeff(nTheta_Full,nPhi),
     &       CoeffAP(nPrimA,nPrimA), CoeffBP(nPrimB,nPrimB)
      Integer List2(mData,nPhi_All), iD(NumCho), Indkl(nkl)
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('CoeffA',' ',CoeffA,nPrimA,nConA)
      Call RecPrt('CoeffB',' ',CoeffB,nPrimB,nConB)
      Call iVcPrt('Indkl',' ',Indkl,nkl)
      Call iVcPrt('Mk_Coeffs: iD',' ',iD,NumCho)
      Write (6,*) 'iAng,jAng=',iAng,jAng
#endif
      Do iCho = 1, NumCho
         iPhi_All = iD(iCho)
         If (List2(1,iPhi_All).eq.iAng .and.
     &       List2(2,iPhi_All).eq.jAng) Then
            ik=List2(5,iPhi_All)
            il=List2(6,iPhi_All)
*
            If (iAng.eq.jAng) Then
               iPhi_Full = iTri(ik,il)
               iPhi=Indkl(iPhi_Full)
               If (iPhi.eq.0) Go To 101
               Do iPrimA = 1, nPrimA
                  Do iPrimB = 1, iPrimA
                     Cff =(CoeffA(iPrimA,ik)*CoeffB(iPrimB,il)
     &                   + CoeffA(iPrimA,il)*CoeffB(iPrimB,ik))/
     &                    (CoeffAP(iPrimA,iPrimA)*
     &                     CoeffBP(iPrimB,iPrimB))
                     If (iPrimA.eq.iPrimB) Cff = Half * Cff
                     iTheta_Full=iPrimA*(iPrimA-1)/2 + iPrimB
                     Coeff(iTheta_Full,iPhi) = Cff
                  End Do
               End Do
            Else
               iPhi_Full = (il-1)*nk + ik
               iPhi=Indkl(iPhi_Full)
               If (iPhi.eq.0) Go To 101
               Do iPrimA = 1, nPrimA
                  Do iPrimB = 1, nPrimB
                     Cff = CoeffA(iPrimA,ik)*CoeffB(iPrimB,il)/
     &                    (CoeffAP(iPrimA,iPrimA)*
     &                     CoeffBP(iPrimB,iPrimB))
                     iTheta_Full=(iPrimB-1)*nPrimA + iPrimA
                     Coeff(iTheta_Full,iPhi) = Cff
                  End Do
               End Do
            End If
 101        Continue
*
         End If
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Coeff',' ',Coeff,nTheta_Full,nPhi)
#endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nl)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine fcopy(In,Ut,iErr)
       character*(*) In, Ut
       character*1024 myIn,myUt
       Integer c_open, c_copy, c_openw, c_close
       Integer rcIn, rcUt, rc
       iErr=0
       if(len(In).gt.1024.or. len(Ut).gt.1024) then
        Write(6,*) 'Error in fcopy: long filenames'
        iErr=1
        return
       endif
       Call PrgmTranslate(In,myIn,lIn)
       myIn(1+lIn:1+lIn)=Char(0)
       Call PrgmTranslate(Ut,myUt,lUt)
       myUt(1+lUt:1+lUt)=Char(0)
       rcIn=c_open(myIn)
       if(rcIn.lt.0) then
         Write(6,*) 'Can not open file ',myIn(1:lIn)
         iErr=1
         return
       endif
       rcUt=c_openw(myUt)
       if(rcUt.lt.0) then
         Write(6,*) 'Can not open file ',myUt(1:lUt)
         iErr=1
         return
       endif
       rc=c_copy(rcIn,rcUt)
       if(rc.lt.0) then
         Write(6,*) 'Can not copy file ',myIn(1:lIn)
         iErr=1
         return
       endif
       rc=c_close(rcIn)
       if(rc.lt.0) then
         Write(6,*) 'Can not close file ',myIn(1:lIn)
         iErr=1
         return
       endif
       rc=c_close(rcUt)
       if(rc.lt.0) then
         Write(6,*) 'Can not close file ',myUt(1:lUt)
         iErr=1
         return
       endif

       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine dkh_prop(n,s,t,v,w,X,pXp,clight,dkord,xord,dkparam)
C
C Apply the arbitrary order DKH transformation to property integral
C
      implicit none
#include "WrkSpc.fh"
C Input
C X     matrix of property operator
C pXp   matrix representation of <pxXpx>+<pyXpy>+<pzXpz>
C w     aka pVp
      integer n,dkord,xord,dkparam
      Real*8 s(n,n),t(n,n),v(n,n),w(n,n),clight
      Real*8 X(n,n),pXp(n,n)
C Output : X store the transformed property integral
C Temp
      integer nn,vord,nz,m
      integer iTr,iBk,iEL,iES,iOL,iOS,iEp,iE0,iKC,iCo,iSco
      integer iM,iZ,iW
C
C Transform to free-particle FW picture
C
      nn=n*n+4
      call getmem('Tr  ','ALLOC','REAL',iTr ,nn)
      call getmem('Back','ALLOC','REAL',iBk ,nn)
      call getmem('mEL ','ALLOC','REAL',iEL ,nn)
      call getmem('mES ','ALLOC','REAL',iES ,nn)
      call getmem('mOL ','ALLOC','REAL',iOL ,nn)
      call getmem('mOS ','ALLOC','REAL',iOS ,nn)
      call getmem('Ep  ','ALLOC','REAL',iEp ,n+4)
      call getmem('E0  ','ALLOC','REAL',iE0 ,n+4)
      call getmem('KC  ','ALLOC','REAL',iKC ,n*3+4)
      call XDR_fpFW(n,s,t,v,w,Work(iTr),Work(iBk),Work(iEL),Work(iES),
     &              Work(iOL),Work(iOS),Work(iEp),work(iE0),Work(iKC),
     &              Work(iKC+n),Work(iKC+2*n),clight)
C
C Calculate the DKH unitary transformation ( in terms of a series of W matrices 1..xord )
C
      vord = xord * 2
      m = n*n
      nz = m*vord
      call getmem('Wsav','ALLOC','REAL', iW, m*xord*2+4)
      call getmem('Cof ','ALLOC','REAL',iCo, vord+8)
      call dkh_cofu(vord,dkparam,Work(iCo))
C
      call getmem('Cof2','ALLOC','REAL',iSCo,vord+8)
      call getmem('Mat ','ALLOC','REAL', iM, m*6+4)
      call getmem('Mat2','ALLOC','REAL', iZ, nz*10+4)
      call dkh_ham(n,vord,xord,vord,Work(iEL),Work(iES),Work(iOL),
     &             Work(iOS),Work(iEp),Work(iE0),Work(iCo),Work(iSco),
     &             Work(iM),Work(iM+m),Work(iM+m*2),Work(iM+m*3),
     &             Work(iM+m*4),Work(iM+m*5),
     &             Work(iZ),Work(iZ+nz),Work(iZ+nz*2),Work(iZ+nz*3),
     &             Work(iZ+nz*4),Work(iZ+nz*5),Work(iZ+nz*6),
     &             Work(iZ+nz*7),Work(iZ+nz*8),Work(iZ+nz*9),
     &             Work(iW) )
C
C Apply W[1..xord] determined transformation to property operator X
C
C     ! convert X to fpFW picture
      call XDR_fpFWprop(n,Work(iTr),X,pXp,Work(iKC),Work(iKC+n),
     &                  Work(iKC+2*n),Work(iEL),Work(iES),Work(iOL),
     &                  Work(iOS),Work(iM) )
      call dkh_xpx(n,vord,xord,vord,Work(iEL),Work(iES),Work(iOL),
     &             Work(iOS),Work(iEp),Work(iE0),Work(iCo),Work(iSco),
     &             Work(iM),Work(iM+m),Work(iM+m*2),Work(iM+m*3),
     &             Work(iM+m*4),Work(iM+m*5),
     &             Work(iZ),Work(iZ+nz),Work(iZ+nz*2),Work(iZ+nz*3),
     &             Work(iZ+nz*4),Work(iZ+nz*5),Work(iZ+nz*6),
     &             Work(iZ+nz*7),Work(iZ+nz*8),Work(iZ+nz*9),
     &             Work(iW) )
      call getmem('Cof2','FREE','REAL',iSCo,vord+8)
      call getmem('Mat ','FREE','REAL',iM, m*6+4)
      call getmem('Mat2','FREE','REAL',iZ, nz*10+4)
C
C Back transform to original non-orthogonal basis picture
C
      call dmxma(n,'C','N',Work(iBk),Work(iEL),Work(iES),1.d0)
      call dmxma(n,'N','N',Work(iES),Work(iBk),X,1.d0)
C
C Free temp memories
C
      call getmem('Cof ','FREE','REAL',iCo, vord+8)
      call getmem('Wsav','FREE','REAL',iW, m*xord*2+4)
      call getmem('Tr  ','FREE','REAL',iTr ,nn)
      call getmem('Back','FREE','REAL',iBk ,nn)
      call getmem('mEL ','FREE','REAL',iEL ,nn)
      call getmem('mES ','FREE','REAL',iES ,nn)
      call getmem('mOL ','FREE','REAL',iOL ,nn)
      call getmem('mOS ','FREE','REAL',iOS ,nn)
      call getmem('Ep  ','FREE','REAL',iEP ,n+4)
      call getmem('E0  ','FREE','REAL',iE0 ,n+4)
      call getmem('KC  ','FREE','REAL',iKC ,n*3+4)
C
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dkord)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module RMat

use Definitions, only: wp, iwp

implicit none
private

!                                                                      *
!***********************************************************************
!                                                                      *
! RmatR    : radius of the R-matrix sphere (bohr)
! Epsabs   : absolute precision of numerical radial integration
! Epsrel   : relative precision of numerical radial integration
! qCoul    : effective charge of the target molecule
! dipol(3) : effective dipole moment of the target molecule
! dipol1   : abs sum of dipol(i)
! epsq     : minimal value of qCoul and/or dipol1 to be considered
! bParm    : Bloch term parameter
!
! keyr: option to the dqag quadpack routine
!
! Quadpack: logical flag to indicate use of QUADPACK routines
! NagInt  : logical flag to indicate use of NAG routines
! testint : logical flag to indicate use of both QUADPACK and NAG routines
! RMat_On : Logical flag to signal that R-matrix type integrals are to be computed.
!
! K.P.
! Dieses File enthaelt Feld fuer die theta/phi  Integration der
! Ein-Elektronen-Integrale fuer die R-Matrix.
! lgamma, n_gam, m_gam, lgammax, gammath, gammaph
!
! Dieses File enthaelt Inputdaten fuer die Modifikation der
! Ein-Elektronen-Integrale fuer die R-Matrix.
! expsum, l, lcost, lsint, lcosf, lsinf
!                                                                      *
!***********************************************************************
!                                                                      *
! The following section should be activated if a NAG library is
! present. At that point I suggest that it gets its own include
! file. -RL-
!
!integer(kind=iwp), parameter :: INTparm = 200
!integer(kind=iwp) :: Iwrk1(INTparm)
!real(kind=wp) :: wrk1(4*INTparm)

integer(kind=iwp), parameter :: lgammax = 15
integer(kind=iwp) :: keyr, l, lgamma
real(kind=wp) :: bParm, dipol(3), Dipol1, Epsabs, Epsq, Epsrel, expsum, gammaph(-2:2*lgammax+3,-2:2*lgammax+4), &
                 gammath(-2:2*lgammax+3,-2:2*lgammax+4), qCoul, RmatR
logical(kind=iwp) :: nagint, Quadpack, RMat_On, RMat_Type_Integrals, testint

public :: bParm, dipol, Dipol1, Epsabs, Epsq, Epsrel, expsum, gammaph, gammath, keyr, l, lgamma, nagint, qCoul, Quadpack, RMat_On, &
          RMat_Type_Integrals, RmatR, testint

end module RMat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Roland Lindh                                     *
!               2019, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Info2Runfile()
!***********************************************************************
!                                                                      *
!     Object: dump misc. information to the runfile.                   *
!                                                                      *
!     Author: Roland Lindh, Dept Chem. Phys., Lund University, Sweden  *
!             October 2006                                             *
!***********************************************************************

use Period, only: AdCell, Cell_l, ispread, lthCell, VCell
use Basis_Info, only: dbsc, nBas, nCnttp
use Center_Info, only: dc
use External_Centers, only: iXPolType, XF, nXF
use Gateway_global, only: Expert, DirInt
use Sizes_of_Seward, only: S
use RICD_Info, only: Do_RI, Cholesky, Cho_OneCenter, LocalDF
use Gateway_Info, only: CoC, CoM, DoFMM
use Symmetry_Info, only: nIrrep, VarR, VarT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
#include "Molcas.fh"
#include "cholesky.fh"
#include "rctfld.fh"
#include "embpcharg.fh"
#include "localdf.fh"
integer(kind=iwp) :: i, iCnt, iCnttp, iFMM, iGO, iLocalDF, iNTC, iNuc, iOption, iter_S, mdc, nData, nNuc, nDel(8)
logical(kind=iwp) :: Found, Pseudo
integer(kind=iwp), allocatable :: ICh(:), IsMM(:), nStab(:), NTC(:)
real(kind=wp), allocatable :: DCh(:), DCh_Eff(:), DCo(:,:)
character(len=LenIn), allocatable :: xLblCnt(:)

!                                                                      *
!***********************************************************************
!                                                                      *
nDel(:) = 0
call Put_iArray('nFro',nDel,nIrrep) ! put to 0
call qpg_iArray('nDel',Found,nData)
if (.not. Found) then
  call Put_iArray('nDel',nDel,nIrrep)
end if
do i=1,nIrrep ! note that in Basis_Info is nBas(0:7)
  nDel(i) = nBas(i-1)-nDel(i)
end do
call Put_iArray('nOrb',nDel,nIrrep) ! nDel is corrupted here!

! VarR and VarT

if (lRF .and. (.not. PCM)) VarT = .true.
Pseudo = .false.
do iCnttp=1,nCnttp
  Pseudo = Pseudo .or. (dbsc(iCnttp)%pChrg .and. dbsc(iCnttp)%Fixed)
end do
if (.not. DoEMPC) then
  if (allocated(XF) .or. Pseudo) then
    VarR = .true.
    VarT = .true.
  end if
end if

! Manipulate the option flag

iOption = 0
if (DirInt) iOption = ibset(iOption,0)
if (Expert) iOption = ibset(iOption,1)
if (lRF) iOption = ibset(iOption,2)
if (lLangevin .or. (iXPolType > 0)) iOption = ibset(iOption,3)
if (PCM) then
  iOption = ibset(iOption,4)
  nPCM_Info = 0
  call Put_iScalar('PCM info length',nPCM_Info)
end if
iOption = ibset(iOption,5)
! 2el-integrals from the Cholesky vectors
if (Cholesky .or. Do_RI) iOption = ibset(iOption,9)
! RI-Option
if (Do_RI) then
  iOption = ibset(iOption,10)
  ! Local or non-local
  if (LocalDF) then
    call Put_dScalar('LDF Accuracy',Thr_Accuracy)
    call Put_iScalar('LDF Constraint',LDF_Constraint)
    iLocalDF = 1
  else
    iLocalDF = 0
  end if
  call Put_iScalar('DF Mode',iLocalDF)
end if
! 1C-CD
if (Cholesky .and. Cho_1Center) iOption = ibset(iOption,12)
Cho_OneCenter = Cho_1Center
call Put_iScalar('System BitSwitch',iOption)

call Put_iScalar('Highest Mltpl',S%nMltpl)
iGO = 0
call Put_iScalar('Grad ready',iGO)
iFMM = 0
if (DoFMM) iFMM = 1
call Put_iScalar('FMM',iFMM)

call qpg_iScalar('Saddle Iter',Found)
if (.not. Found) then
  iter_S = 0
  call Put_iScalar('Saddle Iter',iter_S)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of unique centers (atoms+pseudo)

nNuc = 0
do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) nNuc = nNuc+dbsc(iCnttp)%nCntr
end do

call mma_allocate(DCo,3,nNuc,label='DCo')
call mma_allocate(ICh,nNuc,label='ICh')
call mma_allocate(DCh_Eff,nNuc,label='DCh_Eff')
call mma_allocate(xLblCnt,MxAtom,label='xLblCnt')
mdc = 0
iNuc = 0
do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      iNuc = iNuc+1
      DCo(1:3,iNuc) = dbsc(iCnttp)%Coor(1:3,iCnt)
      DCh_Eff(iNuc) = dbsc(iCnttp)%Charge
      ICh(iNuc) = dbsc(iCnttp)%AtmNr
      xLblCnt(iNuc) = dc(mdc)%LblCnt(1:LenIn)
    end do
  else
    mdc = mdc+dbsc(iCnttp)%nCntr
  end if
end do

call Put_iScalar('Unique centers',nNuc)
call Put_dArray('Un_cen Coordinates',DCo,3*nNuc)
call Put_iArray('Un_cen charge',ICh,nNuc)
call Put_dArray('Un_cen effective charge',DCh_Eff,nNuc)
call Put_cArray('Un_cen Names',xLblCnt(1),LenIn*nNuc)

call mma_deallocate(DCh_Eff)
call mma_deallocate(ICh)
call mma_deallocate(DCo)
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of unique atoms

nNuc = 0
do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) nNuc = nNuc+dbsc(iCnttp)%nCntr
end do

call mma_allocate(DCo,3,nNuc,label='DCo')
call mma_allocate(DCh,nNuc,label='DCh')
call mma_allocate(DCh_Eff,nNuc,label='DCh_Eff')
call mma_allocate(nStab,nNuc,label='nStab')
mdc = 0
iNuc = 0
do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      iNuc = iNuc+1
      DCo(1:3,iNuc) = dbsc(iCnttp)%Coor(1:3,iCnt)
      DCh_Eff(iNuc) = dbsc(iCnttp)%Charge
      DCh(iNuc) = real(dbsc(iCnttp)%AtmNr,kind=wp)
      xLblCnt(iNuc) = dc(mdc)%LblCnt(1:LenIn)
      nStab(iNuc) = dc(mdc)%nStab
    end do
  else
    mdc = mdc+dbsc(iCnttp)%nCntr
  end if
end do

call Put_iScalar('Unique atoms',nNuc)

call mma_allocate(IsMM,size(dbsc),Label='IsMM')
do i=1,size(dbsc)
  IsMM(i) = dbsc(i)%IsMM
end do
call Put_iArray('IsMM',IsMM,size(dbsc))
call mma_deallocate(IsMM)

call Put_dArray('Unique Coordinates',DCo,3*nNuc)
call Put_dArray('Center of Mass',CoM,3)
call Put_dArray('Center of Charge',CoC,3)
call Put_dArray('Nuclear charge',DCh,nNuc)
call Put_dArray('Effective nuclear Charge',DCh_Eff,nNuc)
call Put_cArray('Unique Atom Names',xLblCnt(1),LenIn*nNuc)
call Put_iArray('nStab',nStab,nNuc)
if (allocated(XF)) call Put_iScalar('nXF',nXF)
if (Cell_l) then
  call Put_dArray('Unit Cell Vector',VCell,9)
  call Put_iArray('Spread of Coord.',ispread,3)
  call Put_iScalar('Unit Cell NAtoms',lthCell)
  call Put_iArray('Unit Cell Atoms',AdCell,lthCell)
end if

! Initiate entry to zero.
DCh_Eff(:) = Zero
call Put_dArray('Mulliken Charge',DCh_Eff,nNuc)

call mma_deallocate(xLblCnt)
call mma_deallocate(nStab)
call mma_deallocate(DCh_Eff)
call mma_deallocate(DCh)
call mma_deallocate(DCo)
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate a translation array iNuc -> iCnttp (for espf)

call mma_allocate(NTC,nNuc,label='NTC')

iNTC = 0
do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
    do iNuc=1,dbsc(iCnttp)%nCntr
      NTC(iNTC+iNuc) = iCnttp
    end do
    iNTC = iNTC+dbsc(iCnttp)%nCntr
  end if
end do

call Put_iArray('Atom -> Basis',NTC,nNuc)
call mma_deallocate(NTC)
!                                                                      *
!***********************************************************************
!                                                                      *
! Coordinate list as above but for all centers with proper basis
! functions.

nNuc = 0
do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) nNuc = nNuc+dbsc(iCnttp)%nCntr
end do

call mma_allocate(DCo,3,nNuc,label='DCo')
iNuc = 0
do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
    do iCnt=1,dbsc(iCnttp)%nCntr
      iNuc = iNuc+1
      DCo(1:3,iNuc) = dbsc(iCnttp)%Coor(1:3,iCnt)
    end do
  end if
end do

call Put_iScalar('Bfn atoms',nNuc)
call Put_dArray('Bfn Coordinates',DCo,3*nNuc)

call mma_deallocate(DCo)
!                                                                      *
!***********************************************************************
!                                                                      *
! Coordinate list as above but for only pseudo centers

nNuc = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%pChrg) nNuc = nNuc+dbsc(iCnttp)%nCntr
end do

call mma_allocate(DCo,3,nNuc,label='DCo')
call mma_allocate(DCh,nNuc,label='DCh')
iNuc = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%pChrg) then
    do iCnt=1,dbsc(iCnttp)%nCntr
      iNuc = iNuc+1
      DCo(1:3,iNuc) = dbsc(iCnttp)%Coor(1:3,iCnt)
      DCh(iNuc) = real(dbsc(iCnttp)%AtmNr,kind=wp)
    end do
  else
  end if
end do

call Put_iScalar('Pseudo atoms',nNuc)
call Put_dArray('Pseudo Coordinates',DCo,3*nNuc)
call Put_dArray('Pseudo charge',DCh,nNuc)

call mma_deallocate(DCh)
call mma_deallocate(DCo)
!                                                                      *
!***********************************************************************
!                                                                      *
call Mk_ChDisp()
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Info2Runfile

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RPA(rc)
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Driver routine for the calculation of correlation energies in the
C     random-phase approximation (RPA) using Cholesky/DF integrals.
C
C     NOTE: conventional integrals are not implemented!
C
      Implicit None
      Integer rc
#include "warnings.fh"

      Character*3 SecNam
      Parameter (SecNam='RPA')
      Character*80 string

      Integer irc

C=======================================================================
C     Enter
C=======================================================================

      rc=_RC_ALL_IS_WELL_ ! init return code
      irc=0 ! init internal return code

C=======================================================================
C     Setup: initialize data, read reference orbitals and process input
C=======================================================================

      Call StatusLine('RPA: ','Setup')
      Call RPA_Setup()

C=======================================================================
C     Exit after cleanup
C=======================================================================

*100  Continue ! failures jump to this point
      Call StatusLine('RPA: ','Cleanup')
      Call RPA_Cleanup(irc)
      If (irc.ne.0) Then
         Write(string,'(A,A,I4)')
     *   SecNam,': Cleanup failed! rc=',irc
         Call WarningMessage(2,string)
         If (rc.eq._RC_ALL_IS_WELL_) rc=_RC_INTERNAL_ERROR_
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ITO(N,k,q,C0,Cp,Cm)
! This soubroutine implements the core ITO generation
! using the following ITO convention:
!                               S,M2
!                             CG
!                               S,M1,k,q
!  < S,M1 | O_k_q | S,M2 > = -------------
!                               S,S
!                             CG
!                               S,S,k,0
!
!  The denominator is computed using a simpler formula:
!  Varshalovich, p252, formula (42):
!
!  N = 2S+1, dimension   (input)
!  k = rank of ITO       (input)
!  q = projection of ITO (input)
!  Cp = O+ operator (output), complex
!  Cm = O- operator (output), complex
!  C0 = CG0  (output), real number, positive

      Implicit none
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)          :: n,k,q
      Real(kind=8), intent(out)   :: C0
      Complex(kind=8), intent(out):: Cp(n,n), Cm(n,n)
      ! local
      Integer       :: m1, m2
      Real(kind=8) :: rm1, rm2, rS, rK, rQ, CGp, CGm, fct
      External      :: fct

      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,Cp,1)
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,Cm,1)

      rS=dble(n-1)/2.0_wp
      rK=dble(k)
      rQ=dble(q)
      C0=fct(n-1)*sqrt(dble(n)/(fct(n-k-1)*fct(n+k)))
      ! M1 and M2 go from max value to min value
      Do m1=1,n
       Do m2=1,n
        rm1=rS-dble(m1-1)
        rm2=rS-dble(m2-1)
        Call Clebsh_Gordan( rS,rm2,  rK, rQ,  rS,rm1,  CGp )
        Call Clebsh_Gordan( rS,rm2,  rK,-rQ,  rS,rm1,  CGm )
        Cp(m1,m2)=cmplx( CGp/C0, 0.0_wp, wp )
        Cm(m1,m2)=cmplx( CGm/C0, 0.0_wp, wp )
       End Do
      End Do

      Return
      End subroutine ITO


      Subroutine Liviu_ITO(n,k,q,O,W,redME)
! generate O, W as in previous Stewens_matrixel function:
! redME =  ratio between Naoya's and Liviu operators
      Implicit none
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)          :: n,k,q
      Complex(kind=8), intent(out):: O(n,n), W(n,n), redME
      ! local
      Real(kind=8) :: CR, C0

      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,O,1)
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,W,1)
      CR=0.0_wp
      C0=0.0_wp
      redME=(0.0_wp,0.0_wp)
      Call coeff_redus_sub(n,k,CR)
      Call ITO(n,k,q,C0,O,W)
      redME=cmplx(C0*CR,0.0_wp,wp)
      Call zscal_(n*n,redME,W,1)
      Call zscal_(n*n,redME,O,1)
      Return
      End subroutine Liviu_ITO



      Subroutine Stev_ITO(n,k,q,O,W,redME)
! generate O, W as in previous Stewens_matrixel function:
! redME =  ratio between Naoya's and Liviu operators
! scaled as for Stevens Operators by knm
      Implicit none
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)          :: n,k,q
      Complex(kind=8), intent(out):: O(n,n), W(n,n), redME
      ! local
      Real(kind=8) :: F, knm(12,0:12)

      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,O,1)
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,W,1)
      redME=(0.0_wp,0.0_wp)
      If((k>12).or.(q>12)) Return

      Call set_knm( knm )
      Call Liviu_ITO(n,k,q,O,W,redME)
      F=1.0_wp/knm(k,q)
      redME=cmplx(F,0.0_wp,wp)
      Call zscal_(n*n,redME,W,1)
      Call zscal_(n*n,redME,O,1)
      Return
      End subroutine Stev_ITO


      Subroutine ESO(n,k,q,O,W,redME)
!  generate Hermitian ESO operators, as in MATLAB EasySpin(stev) function
!  only for q >= 0
      Implicit none
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      Integer, intent(in)          :: n,k,q
      Complex(kind=8), intent(out):: O(n,n), W(n,n), redME
      ! local
      Integer                      :: m1, m2
      Real(kind=8)                :: CR, C0, knm(12,0:12), F
      Complex(kind=8)             :: mQ, HALF_R, FALF_I
      Complex(kind=8), allocatable:: Cp(:,:), Cm(:,:)

      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,O,1)
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,W,1)
      redME=(0.0_wp,0.0_wp)
      If((k>12).OR.(q>12)) Return ! not available in MATLAB

      Call mma_allocate(Cp,n,n,'Cp')
      Call mma_allocate(Cm,n,n,'Cm')
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,Cp,1)
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,Cm,1)

      Call set_knm( knm )
      Call coeff_redus_sub(n,k,CR)
      Call ITO(n,k,q,C0,Cp,Cm)

      F=C0*CR/knm(k,q)
      redME=cmplx( F, 0.0_wp, wp )
      mQ   =cmplx( (-1)**q, 0.0_wp, wp )
      HALF_R=(0.5_wp,0.0_wp)
      FALF_I=(0.0_wp,0.5_wp)
      Do m1=1,n
        Do m2=1,n
          O(m1,m2)=HALF_R * redME*( Cm(m1,m2) + mQ*Cp(m1,m2) )
          W(m1,m2)=FALF_I * redME*( Cm(m1,m2) - mQ*Cp(m1,m2) )
        End Do
      End Do
      Call mma_deallocate(Cp)
      Call mma_deallocate(Cm)
      Return
      End subroutine ESO


      Subroutine Liviu_ESO(n,k,q,O,W,redME)
!  generate Hermitian ESO operators, as in MATLAB EasySpin(stev) function
!  only for q >= 0
!  Om = Ok-q
!  Op = Ok+q
! the only difference with MATLAB's ESO are scaling factor Knm
      Implicit none
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      Integer, intent(in)          :: n,k,q
      Complex(kind=8), intent(out):: O(n,n), W(n,n), redME
      ! local
      Integer                      :: m1, m2
      Real(kind=8)                :: CR, C0
      Complex(kind=8)             :: Om, Op, mQ
      Complex(kind=8), allocatable:: Cp(:,:), Cm(:,:)

      Call mma_allocate(Cp,n,n,'Cp')
      Call mma_allocate(Cm,n,n,'Cm')
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,Cp,1)
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,Cm,1)

      Call coeff_redus_sub(n,k,CR)
      Call ITO(n,k,q,C0,Cp,Cm)
      redME=cmplx( C0*CR, 0.0_wp, wp )
      mQ   =cmplx( dble((-1)**q), 0.0_wp, wp )
      Do m1=1,n
        Do m2=1,n
          Om = Cm(m1,m2) * redME
          Op = Cp(m1,m2) * redME
          O(m1,m2)=(0.5_wp,0.0_wp) * ( Om + mQ*Op )
          W(m1,m2)=(0.0_wp,0.5_wp) * ( Om - mQ*Op )
        End Do
      End Do
      Call mma_deallocate(Cp)
      Call mma_deallocate(Cm)
      Return
      End subroutine Liviu_ESO



      Subroutine Stewens_matrixel( N, M, dim, ITO_O, ITO_W, IPRINT )
C
C  This Subroutine calculates the matrix elements of the ITO  (On)
C  on the basis of the eigenfunctions of the effective spin.
C
C
C    N -- the rank of the ITO (On)
C    dim -- the multiplicity of the effective spin
C    Dip_Stewens(N, L, dim, dim) -- the matrix elements of the ITO tensor
C                  operators in the basis of effective spin eigenfunctions
C
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer,intent(in)            :: N, M, dim, IPRINT
      Complex(kind=8), intent(out) :: ITO_O(dim,dim),
     &                                 ITO_W(dim,dim)
      Integer                       :: npar,i,j,ms1,ms2
      Real(kind=8)                 :: a,al,b,bt,c,gm, COEFF_REDUS,
     &                                 coeffCG
      Complex(kind=8)              ::
     &                             ITO_PLUS(-dim:dim,-dim:dim),
     &                            ITO_MINUS(-dim:dim,-dim:dim)
!***********************************************************************

      NPAR=MOD(dim,2)
      COEFF_REDUS=0.0_wp
      ITO_PLUS( -dim:dim,-dim:dim)=(0.0_wp,0.0_wp)
      ITO_MINUS(-dim:dim,-dim:dim)=(0.0_wp,0.0_wp)
      ITO_O(1:dim,1:dim)=(0.0_wp,0.0_wp)
      ITO_W(1:dim,1:dim)=(0.0_wp,0.0_wp)


      Call COEFF_REDUS_SUB(dim,N,COEFF_REDUS)
      !COEFF_REDUS=1.0_wp
      a = DBLE(N)
      al= DBLE(M)
      c = (DBLE(dim)-1.0_wp)/2.0_wp
      b = (DBLE(dim)-1.0_wp)/2.0_wp
      Do ms1=-(dim-NPAR)/2,(dim-NPAR)/2
      If((ms1==0).AND.(NPAR==0)) Go To 160
        If(NPAR==0) Then
          If(ms1<0) Then
             gm=DBLE(ms1)+0.5_wp
          Else
             gm=DBLE(ms1)-0.5_wp
          End If
        Else
          gm=DBLE(ms1)
        End If

        Do ms2=-(dim-NPAR)/2,(dim-NPAR)/2
          If((ms2==0).AND.(NPAR==0)) Go To 150
          If(NPAR==0) Then
            If(ms2<0) Then
              bt=DBLE(ms2)+0.5_wp
            Else
              bt=DBLE(ms2)-0.5_wp
            End If
          Else
            bt=DBLE(ms2)
          End If
          coeffCG=0.0_wp

          Call Clebsh_Gordan(a,al,b,bt,c,gm, coeffCG)

          ITO_PLUS(ms1,ms2)=CMPLX(coeffCG*COEFF_REDUS,0.0_wp,wp)

          If(iprint>5) Then
            Write(6,'(5x,2(a,i3,2x),6(a,f4.1,2x),2(a,f14.10,2x))')
     &              'ms1=',ms1,'ms2=',ms2,
     &              'a=',a,'al=',al,
     &              'b=',b,'bt=',bt,
     &              'c=',c,'gm=',gm,
     &              'coeffCG=',coeffCG, 'coeffCG^2=',coeffCG**2
          End If
  150     Continue
        End Do !ms2
  160   Continue
      End Do !ms1

      al=-DBLE(M)

      Do ms1=-(dim-NPAR)/2,(dim-NPAR)/2
        If((ms1==0).AND.(NPAR==0)) Go To 161
        If(NPAR==0) Then
          If(ms1<0) Then
            gm=DBLE(ms1)+0.5_wp
          Else
            gm=DBLE(ms1)-0.5_wp
          End If
        Else
          gm=DBLE(ms1)
        End If

        Do ms2=-(dim-NPAR)/2,(dim-NPAR)/2
          If((ms2==0).AND.(NPAR==0)) Go To 151

          If(NPAR==0) Then
            If(ms2<0) Then
              bt=DBLE(ms2)+0.5_wp
            Else
              bt=DBLE(ms2)-0.5_wp
            End If
          Else
            bt=DBLE(ms2)
          End If
          coeffCG=0.0_wp

          Call Clebsh_Gordan(a,al,b,bt,c,gm, coeffCG)

          ITO_MINUS(ms1,ms2)=CMPLX(coeffCG*COEFF_REDUS,0.0_wp,wp)

          If(iprint>5) Then
            Write(6,'(5x,2(a,i3,2x),6(a,f4.1,2x),2(a,f14.10,2x))')
     &              'ms1=',ms1,'ms2=',ms2,
     &              'a=',a,'al=',al,
     &              'b=',b,'bt=',bt,
     &              'c=',c,'gm=',gm,
     &              'coeffCG=',coeffCG, 'coeffCG^2=',coeffCG**2
          End If
  151     Continue
        End Do
  161   Continue
      End Do

      i=0
      Do ms1=-(dim-NPAR)/2,(dim-NPAR)/2
        If((ms1==0).AND.(NPAR==0)) Go To 180
        i=i+1
        j=0

        Do ms2=-(dim-NPAR)/2,(dim-NPAR)/2
          If((ms2==0).AND.(NPAR==0)) Go To 170
          j=j+1
          ITO_O(i,j)=ITO_PLUS( ms1,ms2)
          ITO_W(i,j)=ITO_MINUS(ms1,ms2)
  170     Continue
        End Do
  180   Continue
      End Do

      If(IPRINT>3) Then
        Write(6,'(/)')
        Write(6,'(5X,A,2I3)') 'Operator ITO_PLUS',N,M
        Write(6,*)
        Do ms1=-(dim-NPAR)/2,(dim-NPAR)/2
          If((ms1==0).AND.(NPAR==0)) Go To 158
          If(NPAR==1)
     &      Write(6,'(16(2X,2E12.3))') (ITO_PLUS(ms1,ms2),
     &                            ms2=-(dim-NPAR)/2,(dim-NPAR)/2)
          If(NPAR==0)
     &      Write(6,'(16(2X,2E12.3))')
     &                    (ITO_PLUS(ms1,ms2),ms2=-dim/2,    -1),
     &                    (ITO_PLUS(ms1,ms2),ms2=     1, dim/2)
  158     Continue
        End Do   ! ms1

        Write(6,'(/)')
        Write(6,'(5X,A,2I3)') 'Operator ITO_MINUS',N,M
        Write(6,*)
        Do ms1=-(dim-NPAR)/2,(dim-NPAR)/2
          If((ms1==0).AND.(NPAR==0)) Go To 159
          If(NPAR==1)
     &      Write(6,'(16(2X,2E12.3))') (ITO_MINUS(ms1,ms2),
     &                            ms2=-(dim-NPAR)/2,(dim-NPAR)/2)
          If(NPAR==0)
     &      Write(6,'(16(2X,2E12.3))')
     &                    (ITO_MINUS(ms1,ms2),ms2=-dim/2,   -1),
     &                    (ITO_MINUS(ms1,ms2),ms2=     1,dim/2)
  159     Continue
        End Do   ! ms1


        Write(6,'(/////)')
        Write(6,'(5X,A,2I3)') 'ITO_O',N,M
        Write(6,*)
        Do i=1,dim
          Write(6,'(16(2X,2E12.3))') (ITO_O(i,j),j=1,dim)
        End Do   ! i
        Write(6,'(/)')
        Write(6,'(5X,A,2I3)') 'ITO_W',N,M
        Write(6,*)
        Do i=1,dim
          Write(6,'(16(2X,2E12.3))') (ITO_W(i,j),j=1,dim)
        End Do   ! i
      End If ! iPrint


      Return
      End


      Real*8 Function fct(n)
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in) :: n
      Integer             :: i
      Real(kind=8)       :: xct
      ! this function provides correct answer till n=169 only

      xct=1.0_wp
      fct=1.0_wp
      If ( n<0 ) Then
        Write(6,'(A,i0)') 'FCT:  N<0 !'
        Write(6,'(A,i0)') 'N = ', N
        Write(6,'(A   )') 'It is an impossible case.'
        fct=-9.d99
        Return

      Else If ( n==0 ) Then
        Return

      Else If ( (n>0) .AND. (n.le.169) ) Then
        Do i=1,n
          xct=xct*DBLE(i)
        End Do

      Else
        Write(6,'(A,i0)') 'FCT:   N = ',N
        Write(6,'(A)') 'Factorial of N>169 overflows on x86_64'
        Write(6,'(A)') 'Use higher numerical precision, ' //
     &                 'or rethink your algorithm.'
      End If

      fct=xct

      Return
      End function fct

cCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine COEFF_REDUS_SUB(dim,N,COEFF_REDUS)
!
!    THIS Subroutine ReturnS THE VALUE OF THE REDUCED MATRIX ELEMENT  <S|| On ||S>
!   WHERE S-EFFECTIVE SPIN, On -- THE HIGHER ORDER SPIN OPERATORS
!
!     The convention is to follow the paper:
!     C. Rudowicz and C.Y. Chung
!     J. Phys.: Condens. Matter, 2004, 16, pp. 5825
!     doi:10.1088/0953-8984/16/32/018
!
!     with a minor addition of the Norm(N) factor which depends on the operator rank
!     This norm makes the matrix elements of ESO identical to those of the
!     operators from EasySpin (stev).

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)        :: N, dim
      Real(kind=8), intent(out) :: COEFF_REDUS
      Integer                    :: i
      Real(kind=8)              :: FCT, Norm(100), s1, s2
      external                   :: fct

      COEFF_REDUS=0.0_wp
      Do i=1,100
        Norm(i)=0.0_wp
      End Do
      Norm(1) = 1.0_wp
      Norm(2) = 2.0_wp
      Norm(3) = 2.0_wp
      Norm(4) = 8.0_wp
      Norm(5) = 8.0_wp
      Norm(6) = 16.0_wp
      Norm(7) = 16.0_wp
      Norm(8) = 128.0_wp
      Norm(9) = 128.0_wp
      Norm(10)= 256.0_wp
      Norm(11)= 256.0_wp
      Norm(12)= 1024.0_wp
      Norm(13)= 1024.0_wp
      Norm(14)= 2048.0_wp
      Norm(15)= 2048.0_wp
      Norm(16)= 32768.0_wp
      Norm(17)= 32768.0_wp
      Norm(18)= 65536.0_wp
      Norm(19)= 65536.0_wp
      Norm(20)= 262144.0_wp
      Norm(21)= 262144.0_wp
      Norm(22)= 524288.0_wp
      Norm(23)= 524288.0_wp
      Norm(24)= 4194304.0_wp
      Norm(25)= 4194304.0_wp
      Norm(26)= 8388608.0_wp
      Norm(27)= 8388608.0_wp
      Norm(28)= 33554432.0_wp
      Norm(29)= 33554432.0_wp
      Norm(30)= 67108867.0_wp
      Norm(31)= 67108867.0_wp
      Norm(32)= 2147483648.0_wp
      Norm(33)= 2147483648.0_wp
      Norm(34)= 4294967296.0_wp
      Norm(35)= 4294967296.0_wp
      Norm(36)= 17179869184.0_wp
      Norm(37)= 17179869184.0_wp
      Norm(38)= 34359738368.0_wp
      Norm(39)= 34359738368.0_wp
      Norm(40)= 274877906944.0_wp
      Norm(41)= 274877906944.0_wp
      Norm(42)= 549755813888.0_wp
      Norm(43)= 549755813888.0_wp
      Norm(44)= 2199023255552.0_wp
      Norm(45)= 2199023255552.0_wp
      Norm(46)= 4398046511104.0_wp
      Norm(47)= 4398046511104.0_wp
      Norm(48)= 70368744177664.0_wp
      Norm(49)= 70368744177664.0_wp
      Norm(50)= 140737488355328.0_wp
      Norm(51)= 140737488355328.0_wp
      Norm(52)= 562949953421312.0_wp
      Norm(53)= 562949953421312.0_wp
      Norm(54)= 1125899906842624.0_wp
      Norm(55)= 1125899906842624.0_wp
      Norm(56)= 9007199254740992.0_wp
      Norm(57)= 9007199254740992.0_wp
      Norm(58)= 18014398509481984.0_wp
      Norm(59)= 18014398509481984.0_wp
      Norm(60)= 72057594037927936.0_wp
      Norm(61)= 72057594037927936.0_wp
      Norm(62)= 144115188075855872.0_wp
      Norm(63)= 144115188075855872.0_wp
      Norm(64)= 9223372036854775808.0_wp
      Norm(65)= 9223372036854775808.0_wp
      Norm(66)= 18446744073709551616.0_wp
      Norm(67)= 18446744073709551616.0_wp
      Norm(68)= 73786976294838206464.0_wp
      Norm(69)= 73786976294838206464.0_wp
      Norm(70)= 147573952589676412928.0_wp
      Norm(71)= 147573952589676412928.0_wp
      Norm(72)= 1180591620717411303424.0_wp
      Norm(73)= 1180591620717411303424.0_wp
      Norm(74)= 2361183241434822606848.0_wp
      Norm(75)= 2361183241434822606848.0_wp
      Norm(76)= 9444732965739290427392.0_wp
      Norm(77)= 9444732965739290427392.0_wp
      Norm(78)= 18889465931478580854784.0_wp
      Norm(79)= 18889465931478580854784.0_wp
      Norm(80)= 302231454903657293676544.0_wp
      Norm(81)= 302231454903657293676544.0_wp
C  new method
      s1=0.0_wp
      s2=0.0_wp
      s1=SQRT( fct(dim+N)/fct(dim-N-1) )
      s2=dble(2**N)*SQRT(DBLE(dim))

      COEFF_REDUS= Norm(N) * s1 / s2

      Return
      End



      Subroutine Clebsh_Gordan(a,al,b,bt,c,gm,coeffCG)
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Real(kind=8),intent(in)  :: a, al, b, bt, c, gm
      Real(kind=8),intent(out) :: coeffCG
      Real(kind=8)             :: u, fct, s1, s2
      Integer                   :: lb1, lb2, i
      External                  :: fct
c exclude the cases for which CG coefficients are exactly zero
      coeffCG=0.0_wp
      If((al+bt).ne.gm) Return
      If(a<0.0_wp) Return
      If(b<0.0_wp) Return
      If(c<0.0_wp) Return
      If(ABS(al)>a) Return
      If(ABS(bt)>b) Return
      If(ABS(gm)>c) Return
      If((ABS(a-b)>c).or.((a+b)<c)) Return
      If((ABS(b-c)>a).or.((b+c)<a)) Return
      If((ABS(c-a)>b).or.((c+a)<b)) Return
      If(MOD(nint(2.0_wp*a),2) .ne. MOD(nint(2.0_wp*ABS(al)),2)) Return
      If(MOD(nint(2.0_wp*b),2) .ne. MOD(nint(2.0_wp*ABS(bt)),2)) Return
      If(MOD(nint(2.0_wp*c),2) .ne. MOD(nint(2.0_wp*ABS(gm)),2)) Return
      u=0.0_wp
      lb1=INT(MIN(c-b+al,c-a-bt))
      lb2=INT(MIN(a+b-c,a-al,b+bt))
      If(lb1<0) Then
        If(-lb1>lb2) Then
          coeffCG=0.0_wp
          Return
        Else

          Do i=-lb1,lb2
            u = u+DBLE( (-1)**i )/
     &            DBLE(fct(i)*fct(NINT( a-al -i ))
     &                       *fct(NINT( b+bt -i ))
     &                       *fct(NINT( a+b-c-i ))
     &                       *fct(NINT( c-b+al+i))
     &                       *fct(NINT( c-a-bt+i)) )
          End Do
        End If
      Else
        Do i =0,lb2
          u = u+DBLE( (-1)**i )/
     &          DBLE(fct(i)*fct(NINT( a-al -i ))
     &                     *fct(NINT( b+bt -i ))
     &                     *fct(NINT( a+b-c-i ))
     &                     *fct(NINT( c-b+al+i))
     &                     *fct(NINT( c-a-bt+i)) )
        End Do
      End If

      s1=0.0_wp
      s2=0.0_wp
      s1=SQRT( DBLE( fct(NINT( a+b-c  ))
     &              *fct(NINT( a-b+c  ))
     &              *fct(NINT(-a+b+c  )) )
     &        /DBLE( fct(NINT( a+b+c+1)) )  )

      s2=SQRT( DBLE( fct(NINT( a+al ))
     &              *fct(NINT( a-al ))
     &              *fct(NINT( b+bt ))
     &              *fct(NINT( b-bt ))
     &              *fct(NINT( c+gm ))
     &              *fct(NINT( c-gm ))
     &              *(2*c+1)             )  )

      coeffCG = u*s1*s2

      Return
      End


      Real*8 function W9J(a,b,c, d,e,f, g,h,j)
c Calculates a Wigner 9-j symbol. Argument a-j are Integer and are
c twice the true value of the 9-j's arguments, in the form
c { a b c }
c { d e f }
c { g h j }
c this is the implementation the formula 10.2.4. (20) from:
c   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
c   "Quantum Theory of Angular Momentum", World ScientIfic, 1988.
c
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in) :: a,b,c,d,e,f,g,h,j
      Integer             :: n,nlow,nhig
      Real(kind=8)       :: W6J
      Logical             :: check_triangle
      External            :: W6J,check_triangle

      W9j =0.0_wp
      If(MOD(a+b,2) .ne. MOD(c,2)) Return
      If(MOD(d+e,2) .ne. MOD(f,2)) Return
      If(MOD(g+h,2) .ne. MOD(j,2)) Return
      If(MOD(a+d,2) .ne. MOD(g,2)) Return
      If(MOD(b+e,2) .ne. MOD(h,2)) Return
      If(MOD(c+f,2) .ne. MOD(j,2)) Return
      If((ABS(a-b) > c) .or. (a+b < c)) Return
      If((ABS(d-e) > f) .or. (d+e < f)) Return
      If((ABS(g-h) > j) .or. (g+h < j)) Return
      If((ABS(a-d) > g) .or. (a+d < g)) Return
      If((ABS(b-e) > h) .or. (b+e < h)) Return
      If((ABS(c-f) > j) .or. (c+f < j)) Return
      If(check_triangle(a,b,c) .eqv. .false.) Return
      If(check_triangle(d,e,f) .eqv. .false.) Return
      If(check_triangle(g,h,j) .eqv. .false.) Return
      If(check_triangle(a,d,g) .eqv. .false.) Return
      If(check_triangle(b,e,h) .eqv. .false.) Return
      If(check_triangle(c,f,j) .eqv. .false.) Return

      nlow=MAX( ABS(a-j)/2, ABS(d-h)/2, ABS(b-f)/2  )
      nhig=MIN(    (a+j)/2,    (d+h)/2,    (b+f)/2  )

      Do n=nlow,nhig
      W9j=W9j + DBLE(2*n+1)*DBLE((-1)**(2*n))
     &        * W6J(a,b,c,  f,  j,2*n )
     &        * W6J(d,e,f,  b,2*n,  h )
     &        * W6J(g,h,j,2*n,  a,  d )
      End Do
      Return
      End function W9J


      Real*8 function W6J(a,b,c,d,e,f)
c Calculates a Wigner 6-j symbol. Argument a-f are positive Integer
c and are twice the true value of the 6-j's arguments, in the form
c { a b c }
c { d e f }
c
c this is the implementation the formula 9.2.1. (1) from:
c   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
c   "Quantum Theory of Angular Momentum", World ScientIfic, 1988.

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in) :: a,b,c,d,e,f
      Integer             :: n,nlow,nhig
      Real(kind=8)       :: dlt,sum,fct,isum
      Logical             :: check_triangle
      External            :: fct,dlt,check_triangle

      W6J=0.0_wp
      If(MOD(a+b,2) .ne. MOD(c,2)) Return
      If(MOD(c+d,2) .ne. MOD(e,2)) Return
      If(MOD(a+e,2) .ne. MOD(f,2)) Return
      If(MOD(b+d,2) .ne. MOD(f,2)) Return
      If((ABS(a-b) > c) .or. (a+b < c)) Return
      If((ABS(c-d) > e) .or. (c+d < e)) Return
      If((ABS(a-e) > f) .or. (a+e < f)) Return
      If((ABS(b-d) > f) .or. (b+d < f)) Return

      If(check_triangle(a,b,c).eqv. .false.) Return
      If(check_triangle(c,d,e).eqv. .false.) Return
      If(check_triangle(a,e,f).eqv. .false.) Return
      If(check_triangle(b,d,f).eqv. .false.) Return

      nlow=0
      nhig=0
      nlow = MAX( (a+b+c)/2, (c+d+e)/2, (b+d+f)/2, (a+e+f)/2 )
      nhig = MIN( (a+b+d+e)/2, (b+c+e+f)/2, (a+c+d+f)/2)

      sum =0.0_wp
      Do n=nlow,nhig
      isum=DBLE((-1)**n)*fct(n+1)
     & /fct(  ( a+c+d+f)/2-n)
     & /fct(  ( b+c+e+f)/2-n)
     & /fct(n-( a+b+c  )/2  )
     & /fct(n-( c+d+e  )/2  )
     & /fct(n-( a+e+f  )/2  )
     & /fct(n-( b+d+f  )/2  )
     & /fct(  ( a+b+d+e)/2-n)
      sum=sum+isum
      End Do
      W6J=dlt(a,b,c)*dlt(c,d,e)*dlt(a,e,f)*dlt(b,d,f)*sum
      Return
      End function W6J


      Real*8 function W3J(j1,j2,j3,m1,m2,m3)
c Calculates a Wigner 3-j symbol. Argument j1,j2,j3 are positive Integer
c and are twice the true value of the 3-j's arguments, in the form
c { j1 j2 j3 }
c { m1 m2 m3 }
c
c this is the implementation the formula 8.1.2. (11) from:
c   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
c   "Quantum Theory of Angular Momentum", World ScientIfic, 1988.

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in) :: j1, j2, j3, m1, m2, m3
      Real(kind=8)       :: coeffCG

      W3J=0.0_wp
      coeffCG=0.0_wp
      Call Clebsh_Gordan(DBLE(j1)/2.0_wp, DBLE(m1)/2.0_wp,
     &                   DBLE(j2)/2.0_wp, DBLE(m2)/2.0_wp,
     &                   DBLE(j3)/2.0_wp,-DBLE(m3)/2.0_wp, coeffCG )
      If(coeffCG==0.0_wp) Return
      W3J=DBLE((-1)**((j1-j2-m3)/2))*coeffCG/SQRT(DBLE(j3+1))
      Return
      End function W3J


      Real*8 function WCG(a, al, b, bt, c, gm)
c Calculates a Clebsch-Gordan Coefficient. Argument a, al, b, bt, c, gm are Integer,
c Double their actual value.
c (   c/2, gm/2            )
c ( C                      )
c (   a/2, al/2, b/2, bt/2 )
c this is the implementation the formula 8.2.1. (3) from:
c   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
c   "Quantum Theory of Angular Momentum", World ScientIfic, 1988.

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in) :: a, al, b, bt, c, gm
      Integer             :: lb1,lb2,i
      Real(kind=8)       :: u,fct,dlt
      External            :: fct,dlt

      WCG=0.0_wp

      If((al+bt).ne.gm) Return
      If(a<0) Return
      If(b<0) Return
      If(c<0) Return
      If(ABS(al)>a) Return
      If(ABS(bt)>b) Return
      If(ABS(gm)>c) Return
      If((ABS(a-b)>c).or.((a+b)<c)) Return
      If((ABS(b-c)>a).or.((b+c)<a)) Return
      If((ABS(c-a)>b).or.((c+a)<b)) Return
      If(MOD(a,2) .ne. MOD(ABS(al),2)) Return
      If(MOD(b,2) .ne. MOD(ABS(bt),2)) Return
      If(MOD(c,2) .ne. MOD(ABS(gm),2)) Return
      u=0.0_wp
      lb1=MIN( (c-b+al)/2,(c-a-bt)/2 )
      lb2=MIN( (a+b-c)/2 , (a-al)/2 , (b+bt)/2 )
      If(lb1<0) Then
        If(-lb1>lb2) Then
          WCG=0.0_wp
          Return
        Else
          Do i=-lb1,lb2
            u = u + DBLE( (-1)**i )/( fct(i) * fct( (a+b-c -2*i)/2)
     &                                       * fct( (c-b+al+2*i)/2)
     &                                       * fct( (c-a-bt+2*i)/2)
     &                                       * fct( (a-al  -2*i)/2)
     &                                       * fct( (b+bt  -2*i)/2) )
          End Do
        End If
      Else
        Do i=0,lb2
          u = u + DBLE( (-1)**i )/( fct(i) * fct( (a+b-c -2*i)/2)
     &                                     * fct( (c-b+al+2*i)/2)
     &                                     * fct( (c-a-bt+2*i)/2)
     &                                     * fct( (a-al  -2*i)/2)
     &                                     * fct( (b+bt  -2*i)/2)  )
        End Do
      End If
      WCG=u*dlt(a,b,c)*SQRT( fct(( a+al)/2) * fct(( a-al)/2)
     &                     * fct(( b+bt)/2) * fct(( b-bt)/2)
     &                     * fct(( c+gm)/2) * fct(( c-gm)/2)
     &                     * (c+1)
     &                     )

c      Write(6,'(A)') 'a,  al,  b,  bt,  c,  gm'
c      Write(6,'(6(F4.1,2x),F20.14)')
c     & DBLE(a)/2.0_wp, DBLE(al)/2.0_wp,DBLE(b)/2.0_wp,
c     & DBLE(bt)/2.0_wp, DBLE(c)/2.0_wp, DBLE(gm)/2.0_wp, WCG
      Return
      End function WCG



      Real*8 function dlt(a,b,c)
c  calculates the delta(a,b,c) function using the formula 8.2.1. from:
c    D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
c    "Quantum Theory of Angular Momentum", World ScientIfic, 1988.
c
c  a,b,c are positive Integer numbers,
c  their values are DoUBLE than their original value
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in) :: a,b,c
      Real(kind=8)       :: fct
      Logical             :: check_triangle
      External            :: check_triangle, fct

      dlt=0.0_wp
      If((ABS(a-b)>c).or.(a+b<c)) Return
      If((ABS(b-c)>a).or.(b+c<a)) Return
      If((ABS(c-a)>b).or.(c+a<b)) Return
      If(MOD(( a+b-c),2) == 1) Return
      If(MOD(( a-b+c),2) == 1) Return
      If(MOD((-a+b+c),2) == 1) Return
      If(MOD(( a+b+c),2) == 1) Return
      If(check_triangle(a,b,c).eqv. .false.) Return
      ! special cases:
      If(a==0) Then
        dlt=1.0_wp/SQRT(DBLE(b+1))
      End If
      If(b==0) Then
        dlt=1.0_wp/SQRT(DBLE(a+1))
      End If
      If(c==0) Then
        dlt=1.0_wp/SQRT(DBLE(a+1))
      End If

      dlt=SQRT(fct((a+b-c)/2)*fct((a-b+c)/2)*fct((-a+b+c)/2)
     &         /fct((a+b+c)/2+1))
      Return
      End function dlt



      Logical function check_triangle(a,b,c)
c  checks If the values a,b,c comply with the triangle rule
      Implicit None
      Integer, intent(in) :: a, b, c

      check_triangle=.false.

      If ( (a<=0) .OR. (b<=0) .OR. (c<=0) ) then
        Write(6,'(A)') 'a=',a
        Write(6,'(A)') 'b=',b
        Write(6,'(A)') 'c=',c
        Write(6,'(A)') 'The rule is: a>0, b>0 and c>0!'
        Write(6,'(A)') 'Please check this issue, or report a bug!'
        Return
      End If

      If( ((a+b)>=c) .and. ((b+c)>=a) .and. ((c+a)>=b) ) then
        check_triangle=.true.
      End If
      Return
      End function check_triangle



      Complex*16 function WignerD(J,M1,M2,al,bt,gm)
c the function Returns the Wigner-D function specIfying the rotation
c of the |J,M1,M2> around three  angles(alpha,beta,gamma).
c The rotation is either active (ik=1) or passive (ik=2).
c   J, M1, M2 are specIfied as Integer numbers, with a value DoUBLE than their actual size;
c   i.e. J = 2*J (Real); M1= 2*M1(Real); M2=2*M2(Real);
c   alpha, beta, gamma are specIfied as Double precision (Real(kind=8) ::). These values must be defined in
c   radians ( i.e. in units of Pi)
c
c
c  This is the implementation of the formula 4.3.(1) from
c    D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
c    "Quantum Theory of Angular Momentum", World ScientIfic, 1988.

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)       :: J, M1, M2
      Real(kind=8), intent(in) :: al, bt, gm
      Complex(kind=8)          :: m1_fact, m2_fact, wig_fac
      Real(kind=8)             :: wigner_d
      External                  :: wigner_d

c  check correctness
      WignerD=(0.0_wp,0.0_wp)
      wig_fac=(0.0_wp,0.0_wp)
      m1_fact=(0.0_wp,0.0_wp)
      m2_fact=(0.0_wp,0.0_wp)
      If(ABS(M1)>J) Return
      If(ABS(M2)>J) Return
      If(ABS(J )<0) Return

      m1_fact=EXP( (0.0_wp,-1.0_wp)**(DBLE(al*M1)/2.0_wp) )
      m2_fact=EXP( (0.0_wp,-1.0_wp)**(DBLE(gm*M2)/2.0_wp) )
      wig_fac=CMPLX( wigner_d(J,M1,M2,bt), 0.0_wp, wp )
      WignerD=m1_fact*m2_fact*wig_fac
      Return
      End function WignerD

      Real*8 function wigner_d(J,M1,M2,bt)
c  This is the implementation of the formula 4.3.1 (2) from
c    D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
c    "Quantum Theory of Angular Momentum", World ScientIfic, 1988.

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)       :: J, M1, M2
      Real(kind=8), intent(in) :: bt
      Real(kind=8)             :: ksum, fct
      Integer                   :: kmin, kmax, i
      External                  :: fct

      wigner_d=0.0_wp
      ksum=0.0_wp
      kmax=MIN((J -M1)/2,(J -M2)/2)
      kmin=MAX(0,-(M1+M2)/2)
      Do i=kmin,kmax
        ksum=DBLE((-1)**(i))*(COS(bt/2.0_wp)**DBLE(  M1/2+M2/2+2*i))
     &                      *(SIN(bt/2.0_wp)**DBLE(J-M1/2-M2/2-2*i))
     &                     /fct(            i )
     &                     /fct( (J -M1)/2 -i )
     &                     /fct( (J -M2)/2 -i )
     &                     /fct( (M1+M2)/2 +i )
        wigner_d=wigner_d+ksum
      End Do
      wigner_d=wigner_d*DBLE( (-1)**((J-M2)/2) )*
     &         SQRT( fct((J+M1)/2)*fct((J-M1)/2)*
     &               fct((J+M2)/2)*fct((J-M2)/2)  )
      Return
      End function wigner_d

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      Real*8 function RedME( La,Sa,  LaP,SaP,  L,S )
c function evaluates the reduced matrix elements of the ground atomic J multipet
c
c  the function evaluates the formula:
c <L_A, S_A || Operator ( iL_T, iS_T)  || L_A, S_A >>   formula (S.20) derived by Naoya Iwahara
c
c iL, iS, iL_T, iS_T, Jp, Sp and Lp  are defined as Integers with a value DoUBLE of their true value
c
c the formula is valid for Tb, Dy, Ho, Er, Tm and Yb only

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in) :: La, Sa, LaP, SaP, L, S
      Integer             :: JaP, jm, js, s_orb, l_orb
      Real(kind=8)       :: WCG, temp, factor
      external            :: WCG

      RedME=0.0_wp
      temp=0.0_wp
      l_orb=6  ! Double of true value l_orb = 3
      s_orb=1  ! Double of true value s_orb = 1/2
      JaP  = LaP + SaP
      If(WCG(La, La, L, 0, La, La)==0.0_wp) Return
      If(WCG(Sa, Sa, S, 0, Sa, Sa)==0.0_wp) Return
      If(WCG(La, La, l_orb, LaP-La, LaP, LaP)==0.0_wp) Return
      If(WCG(Sa, Sa, s_orb, SaP-Sa, SaP, SaP)==0.0_wp) Return

      factor=SQRT( DBLE((La+1)*(Sa+1)) ) / WCG(La, La, L, 0, La, La)
     &                                   / WCG(Sa, Sa, S, 0, Sa, Sa)

      Do jm = -l_orb, l_orb
        Do js = -s_orb, s_orb
          temp = temp + DBLE( (-1)**((l_orb+jm+s_orb+js)/2) )
     &                 * WCG(l_orb, -jm, l_orb, jm, L, 0)
     &                 * WCG(s_orb, -js, s_orb, js, S, 0)
     &                 * WCG(LaP, La+jm, SaP, Sa+js, JaP, La+jm+Sa+js)
     &                 * WCG(LaP, La+jm, SaP, Sa+js, JaP, La+jm+Sa+js)
     &                 * WCG(La, La, l_orb, jm, LaP, La+jm)
     &                 * WCG(La, La, l_orb, jm, LaP, La+jm)
     &                 * WCG(Sa, Sa, s_orb, js, SaP, Sa+js)
     &                 * WCG(Sa, Sa, s_orb, js, SaP, Sa+js)
     &                 / WCG(La, La, l_orb, LaP-La, LaP, LaP)
     &                 / WCG(La, La, l_orb, LaP-La, LaP, LaP)
     &                 / WCG(Sa, Sa, s_orb, SaP-Sa, SaP, SaP)
     &                 / WCG(Sa, Sa, s_orb, SaP-Sa, SaP, SaP)
        End Do !is
      End Do !im

      RedME=temp*factor

      Return
      End function RedME


      Real*8 function jot1( t, L, ML, S, MS,  La, Sa,  LaP, SaP )
c function evaluates the J1 exchange matrix element ( formula S.19)
c
c iL_T,iL_TM,iS_T,iS_TM,iL,iS,Sp,Lp are defined as Integers with a value DoUBLE of their true value
c the formula is valid for Tb, Dy, Ho, Er, Tm and Yb only
c    Substitutions:

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)       :: L,ML, S,MS, La,Sa, LaP,SaP
      Integer                   :: Ja, l_orb
      Real(kind=8), intent(in) :: t
      Real(kind=8)             :: W9J, WCG, RedME, txt
      External                  :: W9J, WCG, RedME

      jot1 = 0.0_wp
      txt=0.0_wp
      l_orb=6  ! Double of true value l_orb = 3
c      s_orb=1  ! Double of true value s_orb = 1/2
      If (MOD(L,2)==0) Then
        If (ML == 0) Then
          txt =        DBLE((-1)**(l_orb/2))*WCG(l_orb,-4,l_orb,4,L,0)
        Else If (ML == 8) Then
          txt = -0.5_wp*DBLE((-1)**(l_orb/2))*WCG(l_orb, 4,l_orb,4,L,8)
        Else If (ML ==-8) Then
          txt = -0.5_wp*DBLE((-1)**(l_orb/2))*WCG(l_orb, 4,l_orb,4,L,8)
        End If
      End If
      Ja  = La  + Sa

      jot1= t * txt * SQRT( DBLE( (Ja+1)*(L+s+1) ))
     &              * W9J(Ja,La,Sa, Ja,La,Sa,L+s,L,2)
     &              * WCG(L,ML,2,MS,L+s,ML+MS)
     &              * WCG(Ja,Ja,L+s,0,Ja,Ja)
     &              * RedME( La, Sa, LaP, SaP, L, 2  )/SQRT(2.0_wp)

      Return
      End function jot1




      Real*8 function jot0( t,  L, ML,   La, Sa,  LaP, SaP )
c function evaluates the J1 exchange matrix element ( formula S.19)
c
c iL_T,iL_TM,iS_T,iS_TM,iL,iS,Sp,Lp are defined as Integers with a value DoUBLE of their true value
c the formula is valid for Tb, Dy, Ho, Er, Tm and Yb only
c    Substitutions:

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)       :: L, ML, La, Sa, LaP, SaP
      Integer                   :: Ja, l_orb
      Real(kind=8), intent(in) :: t
      Real(kind=8)             :: W6J, WCG, RedME, txt, W9Jl
      External                  :: W6J, WCG, RedME

      jot0 = 0.0_wp
      l_orb=6  ! Double of true value l_orb = 3
c     s_orb=1  ! Double of true value s_orb = 1/2
      txt=0.0_wp
      If (MOD(L,4)==0) Then
              If (ML == 0) Then
              txt = DBLE((-1)**(l_orb/2))*WCG(l_orb,-4,l_orb,4,L,0)
          Else If (ML == 8) Then
              txt = -0.5_wp*DBLE((-1)**(l_orb/2))*
     &                                       WCG(l_orb,4,l_orb,4,L,8)
          Else If (ML ==-8) Then
              txt = -0.5_wp*DBLE((-1)**(l_orb/2))*
     &                                       WCG(l_orb,4,l_orb,4,L,8)
           End If
      End If
       Ja  = La  + Sa
      W9Jl=0.0_wp
      W9Jl=DBLE((-1)**( (La+Ja+Sa+L)/2 ))
     & *SQRT(DBLE( (Sa+1)*(L+1) ))
     & *W6J(Ja,La,Sa, La,Ja, L )

      jot0= -t * txt * SQRT( DBLE( (Ja+1)*(L+1) ))
     & * W9Jl
     & * WCG(Ja,Ja,L,0,Ja,Ja)
     & * RedME( La,Sa,  LaP,SaP,  L,0 )/SQRT(2.0_wp)

      Return
      End function jot0


      Subroutine verify_CG(N)
      Implicit none
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      integer :: n,k,q,m1,m2
      real(wp) :: rJ,rK,rQ,mf,rM1,rM2,rfE,rfG
      real(wp) :: CG_A,CG_B,CG_C,CG_D,CG_E,CG_F,CG_G,CG_H
      logical  :: prn

      !2J=n-1
      rJ=dble(n-1)/2.0_wp

      Do k=1,n-1
       Do q=0,k
        rK=dble(k)
        rQ=dble(q)

        Do m1=1,n
         Do m2=1,n
          ! real value for the projections:
          rM1=-rJ+dble(m1-1)
          rM2=-rJ+dble(m2-1)

          CG_A=0.0_wp
          CG_B=0.0_wp
          CG_C=0.0_wp
          CG_D=0.0_wp
          CG_E=0.0_wp
          CG_F=0.0_wp
          CG_G=0.0_wp
          CG_H=0.0_wp
          mf=(-1)**nint(rK)
                            !(a , alpha, b, beta,    c,  gamma)
          Call Clebsh_Gordan(rJ,  rM2,   rK,    rQ,   rJ,  rM1, CG_A)
          Call Clebsh_Gordan(rK,   rQ,   rJ,   rM2,   rJ,  rM1, CG_B)
          Call Clebsh_Gordan(rJ, -rM2,   rK,   -rQ,   rJ, -rM1, CG_C)
          Call Clebsh_Gordan(rK,  -rQ,   rJ,  -rM2,   rJ, -rM1, CG_D)


          rfE=((-1)**(rJ-rM2))*(sqrt( dble(n)/(2.0_wp*rK+1.0_wp) ))
          Call Clebsh_Gordan(rJ,  rM2,   rJ,  -rM1,   rK,  -rQ, CG_E)
          Call Clebsh_Gordan(rJ,  rM1,   rJ,  -rM2,   rK,   rQ, CG_F)

          rfG=(-1)**(rK+rQ)
          Call Clebsh_Gordan(rJ, -rM1,   rK,    rQ,   rJ, -rM2, CG_G)
          Call Clebsh_Gordan(rK,  -rQ,   rJ,   rM1,   rJ,  rM2, CG_H)

          prn=(CG_A.ne.0.0_wp).OR.(CG_B.ne.0.0_wp).OR.(CG_C.ne.0.0_wp)
     &    .OR.(CG_D.ne.0.0_wp).OR.(CG_E.ne.0.0_wp).OR.(CG_F.ne.0.0_wp)
     &    .OR.(CG_G.ne.0.0_wp).OR.(CG_H.ne.0.0_wp)

         If(prn)
     &     print '(A,1x,8F12.6)','n,k,q,CG:',CG_A,mf*CG_B,mf*CG_C,CG_D,
     &            rfE*CG_E, rfE*CG_F, rfG*CG_G, rfG*CG_H

         End Do
        End Do

       End Do
      End Do
      Return
      End subroutine verify_CG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE IJIJ_CPF(JSY,HDIAG,FJI)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION JSY(*),HDIAG(*),FJI(*)
      DIMENSION HCOUT(nCOP)
      JSYM(L)=JSUNP_CPF(JSY,L)
*
*
      ICOUP = 0 ! dummy initialize
      IVL   = 0 ! dummy initialize
      NSS   = 0 ! dummy initialize
*
      IADD25=IAD25S
      IAD27=0
      IF(IREF0.GT.nCOP) THEN
        WRITE(6,*)'IJIJ_CPF Error: IREF0>nCOP (See code.)'
      END IF
      CALL dDAFILE(Lu_27,2,HDIAG,IRC(1),IAD27)

      IFS=0
      TERM=0.0d0
      IVSAVE=0
      ICOUPS=0
      IOUT=0
      ICHK=0
      IADD10=IAD10(3)

300   CONTINUE
C Read a new COP buffer:
 301  CONTINUE
      CALL dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
      CALL iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
      LENGTH=ICOP1(nCOP+1)
      IF(LENGTH.EQ.0)GO TO 301
      IF(LENGTH.LT.0)GO TO 350
C A long loop over the COP buffer:
      DO 360 II=1,LENGTH
      IND=ICOP1(II)
      IF(ICHK.EQ.0) THEN
        IF(IND.NE.0)GO TO 361
        ICHK=1
        GO TO 360
      END IF

C Here, if ICHK is 1.
      ICHK=0
      INDI=IND
CPAM97      ICOUP=IAND(INDI,65535)
CPAM97      IVL=IAND(ISHFT(INDI,-16),255)
*      ICOUP=MOD(INDI,65536)
*      IVL=MOD(INDI/65536,256)
      ICOUP=IBITS(INDI,0,16)
      IVL=IBITS(INDI,16,8)
      ICHK=0
      INS=1
      IF(IVSAVE.EQ.IV0) THEN
        INS=ICOUPS
        INB=ICOUPS
      END IF

      IF(INB.GT.0) THEN
C Transfer HDIAG via buffer HCOUT, write it to unit 25:
      DO  J=INS,INB
        IOUT=IOUT+1
        HCOUT(IOUT)=HDIAG(J)
        IF(IOUT.GE.nCOP) THEN
C Write out the filled HCOUT buffer:
          IF(IFS.NE.1) THEN
            POTNUC=HCOUT(IREF0)
            IFS=1
          END IF
          DO KK=1,nCOP
            HCOUT(KK)=HCOUT(KK)-POTNUC
          END DO
          CALL dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
          IOUT=0
        END IF
      END DO
      END IF

      IF(IVL.NE.IV0) THEN
        JJ=IRC(IVL)+ICOUP
        NSS=MUL(JSYM(JJ),LSYM)
        IF(IVL.EQ.1)INB=NVIR(NSS)
        IF(IVL.GT.1)INB=NNS(NSS)
        IF(INB.GT.0)CALL dDAFILE(Lu_27,2,HDIAG,INB,IAD27)
      END IF
      IVSAVE=IVL
      ICOUPS=ICOUP
      GO TO 360

361   CONTINUE
C Here, if ICHK.EQ.0 and IND.NE.0
CPAM97      ITYP=IAND(IND,1)
CPAM97      IJJ=IAND(ISHFT(IND,-1),2047)
*      ITYP=MOD(IND,2)
*      IJJ=MOD(IND/2,2048)
      ITYP=IBITS(IND, 0,1)
      IJJ=IBITS(IND,1,11)
      IF(ITYP.EQ.0)TERM=COP(II)*FJI(IJJ)
      IF(IVL.NE.IV0)GO TO 362

C IVL.EQ.IV0, Valence:
      INB=ICOUP
      HDIAG(INB)=HDIAG(INB)+TERM
      GO TO 360

362   IF(IVL.NE.IV1)GO TO 363
C IVL.EQ.IV1, Singles:
      INB=0
      NA1=NSYS(NSS)+1
      NA2=NSYS(NSS+1)
      IF(NA2.LT.NA1)GO TO 360
      DO NA=NA1,NA2
        INB=INB+1
        IF(ITYP.NE.0) THEN
          IIJ=IROW(LN+NA)+IJJ
          TERM=COP(II)*FJI(IIJ)
        END IF
        HDIAG(INB)=HDIAG(INB)+TERM
      END DO
      GO TO 360

363   INB=0
C Doubles:
      DO NA=1,NVIRT
        NSA=MUL(NSS,NSM(LN+NA))
        NB1=NSYS(NSA)+1
        NB2=NSYS(NSA+1)
        IF(NB2.GT.NA)NB2=NA
        IF(NB2.GE.NB1) THEN
          IIJ1=IROW(LN+NA)+IJJ
          DO NB=NB1,NB2
            INB=INB+1
            IF(ITYP.NE.0) THEN
              IIJ2=IROW(LN+NB)+IJJ
              TERM=COP(II)*(FJI(IIJ1)+FJI(IIJ2))
            END IF
            HDIAG(INB)=HDIAG(INB)+TERM
          END DO
        END IF
      END DO

360   CONTINUE
      GO TO 300

C Transfer remaining HDIAG elements to 25 via buffer HCOUT:
350   IF(INB.EQ.0)GO TO 21

      DO J=1,INB
        IOUT=IOUT+1
        HCOUT(IOUT)=HDIAG(J)
        IF(IOUT.GE.nCOP) THEN
C Write out the filled HCOUT buffer:
          IF(IFS.NE.1) THEN
            POTNUC=HCOUT(IREF0)
            IFS=1
          END IF
          DO  KK=1,nCOP
            HCOUT(KK)=HCOUT(KK)-POTNUC
          END DO
          CALL dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
          IOUT=0
        END IF
      END DO

21    CONTINUE
C One last write of the HCOUT buffer:
      IF(IFS.NE.1) THEN
        POTNUC=HCOUT(IREF0)
        IFS=1
      END IF
      DO KK=1,IOUT
        HCOUT(KK)=HCOUT(KK)-POTNUC
      END DO
      CALL dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
       WRITE(6,50)POTNUC
      CALL XFLUSH(6)
50    FORMAT(/,6X,'REFERENCE ENERGY',F18.8)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module loprop_arrays

use Definitions, only: wp, iwp

implicit none
private

! Encapsulating all these allocatable arrays in a derived type allows
! passing the type as an argument without an explicit interface, and
! allocating in the inner subroutine. It also allows having several
! simultaneous contexts with independent arrays (e.g. in a recursive
! calling sequence)

type LP_context_type
  integer(kind=iwp), allocatable :: ANr(:), center(:), otype(:)
  real(kind=wp), allocatable :: C(:,:), P(:,:), PInv(:,:), Q_Nuc(:)
end type LP_context_type

public :: LP_context_type

end module loprop_arrays

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1992, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine SphCr1(Win,ijkla,Scrt,nScrt,Coeff3,kCar,kSph,Tr3,Pr3,Coeff4,lCar,lSph,Tr4,Pr4,Wout,mcd)
!***********************************************************************
!                                                                      *
! Object : to transform the two-electron integrals from cartesian      *
!          gaussians to real spherical harmonic gaussians.             *
!                                                                      *
!          Observe that most of the time Win and Wout will overlap.    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified to back projection to cartesian gaussians,      *
!             January '92.                                             *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ijkla, nScrt, kCar, kSph, lCar, lSph, mcd
real(kind=wp), intent(in) :: Win(ijkla*kSph*lSph), Coeff3(kCar,kCar), Coeff4(lCar,lCar)
real(kind=wp), intent(out) :: Scrt(nScrt)
real(kind=wp), intent(inout) :: Wout(mcd*ijkla)
logical(kind=iwp), intent(in) :: Tr3, Pr3, Tr4, Pr4

#include "macros.fh"
unused_var(Pr3)
unused_var(Pr4)

!call RecPrt(' In SphCr1: P(AB|CD) ',' ',Win,ijkla,kSph*lSph)
if (Tr3 .and. Tr4) then
  !call RecPrt(' Right contraction',' ',Coeff4,lCar,lSph)
  ! Starting with IJKL,AB,CD transforming to d,IJKL,AB,C
  !call xxDGeMul(Coeff4,lCar,'N',Win,ijkla*kSph,'T',Scrt,lCar,lCar,lSph,ijkla*kSph)
  call NTMul(Coeff4,Win,Scrt,lCar,lSph,ijkla*kSph)

  !call RecPrt(' In SphCr: P(AB|Cd) ',' ',Scrt,lCar*ijkla,kSph)
  !call RecPrt(' Left contraction',' ',Coeff3,kCar,kSph)
  ! Transform d,IJKL,AB,C to cd,IJKL,AB
  !call xxDGeMul(Coeff3,kCar,'N',Scrt,lCar*ijkla,'T',Wout,kCar,kCar,kSph,lCar*ijkla)
  call NTMul(Coeff3,Scrt,Wout,kCar,kSph,lCar*ijkla)
else if (Tr4) then
  !call RecPrt(' Right contraction',' ',Coeff4,lCar,lSph)
  ! Starting with IJKL,AB,cD transforming to d,IJKL,AB,c
  !call xxDGeMul(Coeff4,lCar,'N',Win,ijkla*kCar,'T',Scrt,lCar,lCar,lSph,ijkla*kCar)
  call NTMul(Coeff4,Win,Scrt,lCar,lSph,ijkla*kCar)
  ! Transpose d,IJKL,AB,c to cd,IJKL,AB
  call DGeTMO(Scrt,lCar*ijkla,lCar*ijkla,kCar,Wout,kCar)
else if (Tr3) then
  ! Transpose IJKL,AB,C,d to d,IJKL,AB,C
  call DGeTMO(Win,ijkla*kSph,ijkla*kSph,lCar,Scrt,lCar)

  !call RecPrt(' Left contraction',' ',Coeff3,kCar,kSph)
  ! Transform d,IJKL,AB,c to cd,IJKL,AB
  !call xxDGeMul(Coeff3,kCar,'N',Scrt,lCar*ijkla,'T',Wout,kCar,kCar,kSph,lCar*ijkla)
  call NTMul(Coeff3,Scrt,Wout,kCar,kSph,lCar*ijkla)
else
  ! Transpose IJKL,AB,cd to cd,IJKL,AB
  Scrt(1:ijkla*kCar*lCar) = Win(1:ijkla*kCar*lCar)
  if (kCar*lCar /= 1) then
    call DGeTMO(Scrt,ijkla,ijkla,kCar*lCar,Wout,kCar*lCar)
  else
    Wout(1:ijkla*kCar*lCar) = Scrt(1:ijkla*kCar*lCar)
  end if
end if

!call RecPrt(' In SphCr1: P(AB|cd)  ',' ',Wout,mcd,ijkla)

return

end subroutine SphCr1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE NPSET(JSY,INDEX,C,TPQ,ENP,T,S,W,EPP,ICASE)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION JSY(*),INDEX(*),C(*),TPQ(*),ENP(*),T(*),S(*)
      DIMENSION W(*),EPP(*),ICASE(*)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
*
      JSYM(L)=JSUNP_CPF(JSY,L)
C
      IF(IDENS.EQ.1)GO TO 65
      IF(ITPUL.NE.1)GO TO 60
      IAD=0
      IADDP(1)=0
      CALL dDAFILE(Lu_CI,1,C,NCONF,IAD)
      IADDP(2)=IAD
C
C     VALENCE
C
60    IQ=IRC(1)
      DO 30 I=1,IQ
        T(I)=C(I)*C(I)
30    CONTINUE
C
C     SINGLES
C
      IQ=IRC(2)-IRC(1)
      IND=IRC(1)
      IN=IRC(1)
      DO 5 I=1,IQ
        IND=IND+1
        NS1=JSYM(IN+I)
        NSIL=MUL(NS1,LSYM)
        INUM=NVIR(NSIL)
        IST=INDEX(IN+I)+1
        T(IND)=DDOT_(INUM,C(IST),1,C(IST),1)
5     CONTINUE
C
C     DOUBLES
C
      IQ=IRC(4)-IRC(2)
      IN=IRC(2)
      DO 10 I=1,IQ
        IND=IND+1
        NS1=JSYM(IN+I)
        NSIL=MUL(NS1,LSYM)
        INUM=NNS(NSIL)
        IST=INDEX(IN+I)+1
        T(IND)=DDOT_(INUM,C(IST),1,C(IST),1)
10    CONTINUE
      IP=IRC(4)
      DO 15 I=1,IP
        CALL TPQSET(ICASE,TPQ,I)
        ENP(I)=DDOT_(IP,TPQ,1,T,1)
        ENP(I)=ENP(I)+D1
15    CONTINUE
      IP=IRC(4)
      IF(IPRINT.GT.5)WRITE(6,12)(ENP(I),I=1,IP)
12    FORMAT(6X,'ENP ',5F14.8)
C
C     VALENCE
C
65    IQ=IRC(1)
      DO 6 I=1,IQ
        IF(IDENS.EQ.0)EMPI=D1/SQRT(ENP(I))
        IF(IDENS.EQ.1)EMPI=SQRT(ENP(I))
        C(I)=C(I)*EMPI
6     CONTINUE
C
C     SINGLES
C
      IQ=IRC(2)-IRC(1)
      IN=IRC(1)
      DO 16 I=1,IQ
        NS1=JSYM(IN+I)
        NSIL=MUL(NS1,LSYM)
        INUM=NVIR(NSIL)
        IST=INDEX(IN+I)+1
        IF(IDENS.EQ.0)EMPI=D1/SQRT(ENP(IN+I))
        IF(IDENS.EQ.1)EMPI=SQRT(ENP(IN+I))
        CALL VSMUL(C(IST),1,EMPI,C(IST),1,INUM)
16    CONTINUE
C
C     DOUBLES
C
      IQ=IRC(4)-IRC(2)
      IN=IRC(2)
      DO 11 I=1,IQ
        NS1=JSYM(IN+I)
        NSIL=MUL(NS1,LSYM)
        INUM=NNS(NSIL)
        IST=INDEX(IN+I)+1
        IF(IDENS.EQ.0)EMPI=D1/SQRT(ENP(IN+I))
        IF(IDENS.EQ.1)EMPI=SQRT(ENP(IN+I))
        CALL VSMUL(C(IST),1,EMPI,C(IST),1,INUM)
11    CONTINUE
      IF(IPRINT.GE.15)WRITE(6,13)(C(I),I=1,NCONF)
13    FORMAT(6X,'C(NP)',5F10.6)
      IF(IDENS.EQ.1)RETURN
C
      CALL SETZ(EPP,IRC(4))
      CALL SETZ(S,JSC(4))
      IF(ICPF.NE.1.AND.ISDCI.NE.1.AND.INCPF.NE.1)CALL SETZ(W,JSC(4))
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MQCT(AREF,EREF,CI,SGM,ICI)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "mrci.fh"
#include "WrkSpc.fh"
      DIMENSION AREF(NREF,NREF),EREF(NREF)
      DIMENSION ICI(MBUF),SGM(NCONF),CI(NCONF)
*      LCBUF =LMQ
*      LSBUF =LCBUF +MXVEC*MBUF
*      LDBUF =LSBUF +MXVEC*MBUF
*      LCSECT=LDBUF +MBUF
*      LRSECT=LCSECT+NSECT*MXVEC
*      LXI1  =LRSECT+NSECT*MXVEC
*      LXI2  =LXI1  +NSECT*NRROOT
*      LCNEW =LXI2  +NSECT*NRROOT
*      LSCR  =LCNEW +NSECT*NRROOT
      CALL GETMEM('CBUF','ALLO','REAL',LCBUF,MXVEC*MBUF)
      CALL GETMEM('SBUF','ALLO','REAL',LSBUF,MXVEC*MBUF)
      CALL GETMEM('DBUF','ALLO','REAL',LDBUF,MBUF)
      CALL GETMEM('CSECT','ALLO','REAL',LCSECT,NSECT*MXVEC)
      CALL GETMEM('RSECT','ALLO','REAL',LRSECT,NSECT*MXVEC)
      CALL GETMEM('XI1','ALLO','REAL',LXI1,NSECT*NRROOT)
      CALL GETMEM('XI2','ALLO','REAL',LXI2,NSECT*NRROOT)
      CALL GETMEM('CNEW','ALLO','REAL',LCNEW,NSECT*NRROOT)
      CALL GETMEM('SCR','ALLO','REAL',LSCR,MXVEC*MBUF)
      CALL DIAGRO(CI,SGM,Work(LCBUF),
     *            Work(LSBUF),Work(LDBUF),
     *            AREF,EREF,
     *            Work(LCSECT),Work(LRSECT),
     *            Work(LXI1),Work(LXI2),Work(LCNEW),
     *            Work(LSCR),ICI)
      CALL GETMEM('CBUF','FREE','REAL',LCBUF,MXVEC*MBUF)
      CALL GETMEM('SBUF','FREE','REAL',LSBUF,MXVEC*MBUF)
      CALL GETMEM('DBUF','FREE','REAL',LDBUF,MBUF)
      CALL GETMEM('CSECT','FREE','REAL',LCSECT,NSECT*MXVEC)
      CALL GETMEM('RSECT','FREE','REAL',LRSECT,NSECT*MXVEC)
      CALL GETMEM('XI1','FREE','REAL',LXI1,NSECT*NRROOT)
      CALL GETMEM('XI2','FREE','REAL',LXI2,NSECT*NRROOT)
      CALL GETMEM('CNEW','FREE','REAL',LCNEW,NSECT*NRROOT)
      CALL GETMEM('SCR','FREE','REAL',LSCR,MXVEC*MBUF)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine update_cvb(dx)

use casvb_global, only: cvb, iorts, norb, nort, npr, nprorb, nvb, orbopt, orbs, sorbs, strucopt, sym, vbdet
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: dx(*)
integer(kind=iwp) :: ic
real(kind=wp), allocatable :: orbs1(:,:), cvb1(:)
logical(kind=iwp), external :: up2date_cvb ! ... Make: up to date? ...

if (orbopt) call touch_cvb('ORBS')
if (strucopt) call touch_cvb('CVB')
call make_cvb('WFN')
! TRY quantities only up2date if SVB/EVB ok:
if (up2date_cvb('SVBTRY')) call make_cvb('SVB')
if (up2date_cvb('EVBTRY')) call make_cvb('EVB')

ic = 1
call mma_allocate(orbs1,norb,norb,label='orbs1')
call mma_allocate(cvb1,nvb,label='cvb1')
call update2_cvb(orbs1,cvb1,orbs,cvb,sorbs,dx,ic,norb,nvb,nprorb,npr,orbopt,strucopt,sym,iorts,nort)
orbs(:,:) = orbs1(:,:)
cvb(1:nvb) = cvb1(:)
call str2vbc_cvb(cvb,vbdet)
call mma_deallocate(orbs1)
call mma_deallocate(cvb1)

return

end subroutine update_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE IAIBCM_MCLR(MNRS1,MXRS3,NOCTPA,NOCTPB,NEL1A,NEL3A,
     *                  NEL1B,NEL3B,IOCOC,IPRNT)
*
* RAS allowed combinations of alpha and beta types
*
      Implicit integer (a-z)
*
* =====
*.Input
* =====
*
* NOCTPA : Number of alpha types
* NEL1A  : Number of electrons in RAS 1 for each alpha type
* NEL3A  : Number of electrons in RAS 3 for each alpha type
*
* NOCTPB : Number of beta types
* NEL1B  : Number of electrons in RAS 1 for each beta type
* NEL3B  : Number of electrons in RAS 3 for each beta type
*
* ======
*.Output
* ======
* IOCOC(IATP,IBTP)  = 1 =>      allowed combination
* IOCOC(IATP,IBTP)  = 0 => not allowed combination
*
*.Input
      INTEGER NEL1A(*),NEL3A(*),NEL1B(*),NEL3B(*)
*.Output
      INTEGER IOCOC(NOCTPA,NOCTPB)
*
*
      NTEST = 0000
      NTEST = MAX(NTEST,IPRNT)
*
      Call iCopy(nOctPA*nOctPB,[0],0,iococ,1)
      DO 100 IATP = 1,NOCTPA
         IAEL1 = NEL1A(IATP)
         IAEL3 = NEL3A(IATP)
         DO 90 IBTP = 1,NOCTPB
            IBEL1 = NEL1B(IBTP)
            IBEL3 = NEL3B(IBTP)
            IF( (IAEL1+IBEL1).GE.MNRS1 .AND.
     &          (IAEL3+IBEL3).LE.MXRS3       )
     &          IOCOC(IATP,IBTP) = 1
90       CONTINUE
100   CONTINUE
*
      IF ( NTEST .GE. 10 ) THEN
        WRITE(6,*)
        WRITE(6,*) ' Matrix giving allowed combinations of types '
        WRITE(6,*)
        CALL IWRTMA(IOCOC,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
      END IF

*
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function ExtNuc (ipExt,natom)
      Implicit Real*8 (A-H,O-Z)
*
* Compute Z - ExtPot interactions
*
#include "espf.fh"
#include "stdalloc.fh"
*
      Real*8 E,ExtNuc
      Real*8, Allocatable:: Charge(:)
      Logical Found
      Integer Len
*
      iPL = iPL_espf()
*
      Call qpg_dArray('Effective nuclear Charge',Found,Len)

      If (Found) Then
         Call mma_allocate(Charge,Len,Label='Charge')
         If (Len.ne.nAtom) Then
            Write (6,*) 'ExtNuc: Len.ne.nAtom'
            Call Abend()
         End If
      Else
         Write (6,*) 'ExtNuc: Effective nuclear Charges not found.'
         Call Abend()
      End If
      Call Get_dArray('Effective nuclear Charge',Charge,nAtom)
*
      E = Zero
      Do INuc = 1, natom
         E = E + Charge(iNuc)*Work(ipExt+(INuc-1)*10)
      End Do
      If (E.ne.zero .and. iPL.ge.3) Then
         Write(6,*) ' '
         Write(6,1000) E
1000     Format(' Ext Pot/(QM nuclei and MM charges) energy =',
     &          F16.10,' hartrees')
      End If
      ExtNuc = E
*
      Call mma_deallocate(Charge)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Add_Vector
!
!> @brief
!>   Add (or not) a vector to an orthonormal set
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Adds a given vector to an existing set of orthonormal vectors.
!> The vector is orthogonalized against the existing set and, if the remainder
!> is large enough, it will be normalized and added to the set.
!> The input matrix with the initial set must have size at least \p n (\p m+1).
!> On output, \p m will be increased by 1 if the vector was added, and unchanged
!> otherwise.
!>
!> @param[in]     n   Size of the vectors
!> @param[in,out] m   Number of vectors in the subspace
!> @param[in,out] Sub Subspace of vectors
!> @param[in,out] Vec Vector to be added
!> @param[in]     Thr Threshold for linear dependence check
!***********************************************************************

subroutine Add_Vector(n,m,Sub,Vec,Thr)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
integer(kind=iwp), intent(inout) :: m
real(kind=wp), intent(inout) :: Sub(n,m+1), Vec(n)
real(kind=wp), intent(in) :: Thr
integer(kind=iwp) :: i
real(kind=wp) :: Aux
real(kind=wp), external :: DDot_

do i=1,m
  Vec(:) = Vec(:)-DDot_(n,Sub(:,i),1,Vec,1)*Sub(:,i)
end do
Aux = DDot_(n,Vec,1,Vec,1)
if (abs(Aux) > Thr) then
  ! Safety net: orthonormalize again before adding it
  Vec(:) = Vec(:)/sqrt(Aux)
  do i=1,m
    Vec(:) = Vec(:)-DDot_(n,Sub(:,i),1,Vec,1)*Sub(:,i)
  end do
  Aux = DDot_(n,Vec,1,Vec,1)
  m = m+1
  Sub(:,m) = Vec(:)/sqrt(Aux)
end if

end subroutine Add_Vector

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SMMAT_MASKED(PROP,PRMAT,NSS,ISONUM,ISPINCMP,ISS_INDEX,
     &                        IST,INUM,JST,JNUM)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PRMAT(NSS,NSS)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='SMMAT_MASKED')
      Integer INUM, JNUM
      Integer ISS_INDEX(NSTATE+1), IST(INUM), JST(JNUM)
#include "SysDef.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "rassi.fh"
#include "symmul.fh"
#include "Files.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      DIMENSION PROP(NSTATE,NSTATE,NPROP)
      REAL*8, EXTERNAL :: DCLEBS
*
      IPRNUM=-1
      IPRCMP=0
      PRMAT(:,:)=0.0D0
C IFSPIN takes values the values 0,1,2
C 0 = spin free property
C 1 = spin operator (S)
C 2 = spin dependent property, triplet operator
      IFSPIN=0

      IF (ISONUM.EQ.0) THEN
         IPRNUM=0
         IFSPIN=1
         IPRCMP=ISPINCMP
      ELSE
         DO IPROP=1,NPROP
            IF ((PNAME(IPROP).EQ.SOPRNM(ISONUM)).AND.
     &          (PTYPE(IPROP).EQ.SOPRTP(ISONUM)).AND.
     &          (ICOMP(IPROP).EQ.ISOCMP(ISONUM))) THEN
               IPRNUM=IPROP
               IF (PNAME(IPRNUM)(1:5).EQ.'TMOM0') THEN
                  IFSPIN=2
                  IPRCMP=ISPINCMP
               END IF
               EXIT
            END IF
         END DO
      END IF
      IF (IPRNUM.EQ.-1) THEN
         Write (6,*) TRIM(ROUTINE),', Abend IPRNUM.EQ.-1'
         Write (6,*) TRIM(ROUTINE),', PRLBL=','>',PNAME(ISONUM),'<'
         Call Abend()
      ENDIF

C Mapping from spin states to spin-free state and to spin:
      DO I=1,INUM
         ISTATE=IST(I)
         ISS=ISS_INDEX(ISTATE)
         MPLET1=ISS_INDEX(ISTATE+1)-ISS_INDEX(ISTATE)
         S1=0.5D0*(MPLET1-1)
         DO MSPROJ1=-MPLET1+1,MPLET1-1,2
            SM1=0.5D0*MSPROJ1
            ISS=ISS+1

            DO J=1,JNUM
               JSTATE=JST(J)
               JSS=ISS_INDEX(JSTATE)
               MPLET2=ISS_INDEX(JSTATE+1)-ISS_INDEX(JSTATE)
               S2=0.5D0*(MPLET2-1)
               DO MSPROJ2=-MPLET2+1,MPLET2-1,2
                  SM2=0.5D0*MSPROJ2
                  JSS=JSS+1

                  IF (IFSPIN.EQ.0 .AND. IPRNUM.NE.0) THEN
                     IF (MPLET1.EQ.MPLET2 .AND. MSPROJ1.EQ.MSPROJ2) THEN
                        PRMAT(ISS,JSS)=PROP(ISTATE,JSTATE,IPRNUM)
                     ELSE
                        PRMAT(ISS,JSS)=0.0D0
                     END IF
                  ELSE IF (IFSPIN.EQ.1 .AND. IPRNUM.EQ.0) THEN
                     SXMER=0.0D0
                     SYMEI=0.0D0
                     SZMER=0.0D0
                     SMINUS=0.0D0
                     SPLUS=0.0D0
                     IF((ISTATE.EQ.JSTATE).AND.(MPLET1.eq.MPLET2)) THEN
                        IF (MSPROJ1.eq.MSPROJ2-2) THEN
                           SMINUS=SQRT((S1+SM2)*(S1-SM1))
                           SXMER= 0.5D0*SMINUS
                           SYMEI= 0.5D0*SMINUS
                        ELSE IF (MSPROJ1.eq.MSPROJ2) THEN
                           SZMER=SM1
                        ELSE IF (MSPROJ1.eq.MSPROJ2+2) THEN
                           SPLUS=SQRT((S1+SM1)*(S1-SM2))
                           SXMER= 0.5D0*SPLUS
                           SYMEI=-0.5D0*SPLUS
                        END IF
                        IF (IPRCMP.EQ.1) THEN
                           PRMAT(ISS,JSS)=SXMER
                        ELSE IF (IPRCMP.EQ.2) THEN
                           PRMAT(ISS,JSS)=SYMEI
                        ELSE IF (IPRCMP.EQ.3) THEN
                           PRMAT(ISS,JSS)=SZMER
                        END IF
                     ELSE
                        PRMAT(ISS,JSS)=0.0D0
                     END IF
                  ELSE IF (IFSPIN.EQ.2) THEN
C
C                 The code here is a replica from smmat.f. Look in
C                 that source for comments.
C
                     FACT=1.0D0/SQRT(DBLE(MPLET1))
                     IF(MPLET1.EQ.MPLET2-2) FACT=-FACT
                     CGM=FACT*DCLEBS(S2,1.0D0,S1,SM2,-1.0D0,SM1)
                     CG0=FACT*DCLEBS(S2,1.0D0,S1,SM2, 0.0D0,SM1)
                     CGP=FACT*DCLEBS(S2,1.0D0,S1,SM2,+1.0D0,SM1)
                     CGX= SQRT(0.5D0)*(CGM-CGP)
                     CGY=-SQRT(0.5D0)*(CGM+CGP)
*
                     EXPKR=PROP(ISTATE,JSTATE,IPRNUM)
*
                     IF (IPRCMP.EQ.1) THEN
                        EXPKR=EXPKR*CGX
                     ELSE IF (IPRCMP.EQ.2) THEN
                        EXPKR=EXPKR*CGY
                     ELSE IF (IPRCMP.EQ.3) THEN
                        EXPKR=EXPKR*CG0
                     END IF
                     PRMAT(ISS,JSS)= EXPKR
                  END IF

               END DO !MSPROJ2
            END DO !JSTATE
         END DO !MSPROJ1
      END DO !ISTATE

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mkfn_cvb(fileid,ibf)
      implicit real*8(a-h,o-z)
#include "io_cvb.fh"
      character*20 fn_tmp
      logical debug
      data debug/.false./

      do 100 i=1,nrec
      if(abs(fileid-fileids(i)).lt.thresh_io)then
        ibf=i
        goto 200
      endif
100   continue
      nrec=nrec+1
      if(nrec.gt.max_rec)then
        write(6,*)' nrec > max_rec in mkfn :',nrec,max_rec
        call abend_cvb()
      endif
      ibf=nrec
c  generate new file name
c  -> must be at most 8 characters to use daname
      fn_tmp=' '
      irec=int(fileid)
      ifile=nint(10*(fileid-irec))
      call appendint_cvb(fn_tmp,irec,0)
      call appendint_cvb(fn_tmp,ifile,0)
      filename(ibf)=fn_tmp(1:len_trim_cvb(fn_tmp))
      fileids(ibf)=fileid
      ifilio(ibf)=0
200   continue
      if(debug)then
        write(6,*)' IO information for identifier :',fileid
        write(6,*)' IBF is :',ibf
        write(6,*)' File name is :',filename(ibf)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Thorstein Thorsteinsson                          *
!***********************************************************************

subroutine Real2Int(RealArg,IntArg)
!***********************************************************************
!                                                                      *
!    Purpose: Convert Real argument to integer                         *
!                                                                      *
!    Calling parameters:                                               *
!    RealArg: contains real to be converted                            *
!    IntArg : contains on return the corresponding integer array       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     T. Thorsteinsson                                                 *
!     University of Lund, Sweden, 1999                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Definitions, only: wp, iwp, RtoI

implicit none
real(kind=wp), intent(in) :: RealArg
integer(kind=iwp), intent(out) :: IntArg(RtoI)

IntArg(:) = transfer(RealArg,IntArg)

return

end subroutine Real2Int

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine touch_cvb(chr)
      implicit real*8 (a-h,o-z)
      character*(*) chr
#include "make_cvb.fh"

50    iobj=0
      do 100 i=1,nobj
      if(charobj(i).eq.chr)iobj=i
100   continue
      if(iobj.eq.0)then
        if(mustdeclare)then
          write(6,*)' Make object not found :',chr
          call abend_cvb()
        endif
        call decl_cvb(chr)
        goto 50
      endif
      up2date(iobj)=.false.
      if(iprint.ge.1)
     >  write(6,'(/,a,i3,2a)')' Touch (1) of object no.',iobj,
     >  ', name : ',charobj(iobj)

c  Mark all "child" objects as out-of-date :
200   n_touched=0
      do 300 iobj=1,nobj
      if(.not.up2date(iobj))then
        do 400 i=joffs(iobj)+1,joffs(iobj+1)
        call touchrules_cvb(charobj(j_dep_on_i(i)))
        if(up2date(j_dep_on_i(i)))then
          up2date(j_dep_on_i(i))=.false.
          if(iprint.ge.1)
     >      write(6,'(/,a,i3,2a)')' Touch (2) of object no.',
     >      j_dep_on_i(i),', name : ',charobj(j_dep_on_i(i))
          n_touched=n_touched+1
        endif
400     continue
      endif
300   continue
      if(n_touched.ne.0)goto 200

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     mv0zero
c     mc0c1a3b
c     mc0c2a3b
c     mv0v1a3u
c     mr0u3wt
c     mc0c1at3b
c     mv0u
c     mv0v1u
c     mv0sv
c
c     ---------------
c
       subroutine mc0c2a3b
     & (rowa,cola,rowb,colb,rowc,colc,
     & row,sum,col,a,b,c)
C
C     C = C + A*B
C
       implicit none
#include "chcc1.fh"
       integer rowa,cola,rowb,colb,rowc,colc
       integer row,sum,col
       real*8  A(1:rowa,1:cola)
       real*8  B(1:rowb,1:colb)
       real*8  C(1:rowc,1:colc)
C
C      help variables
C
       integer i,j,k
c
       if (mhkey.eq.1) then
c      ESSL
       call DGEMM_('N','N',row,col,sum,-1.0d0,a,rowa,b,rowb,
     & 1.0d0,c,rowc)
C
       else
c      Fortran matrix handling
C
       do 50 j=1, col
       do 40 k=1, sum
       do 30 i=1, row
       c(i,j) = c(i,j) - a(i,k)*b(k,j)
 30    continue
 40    continue
 50    continue
C
       end if
c
       return
       end
C
C---------------------------------------
C
       subroutine mv0u (length,X,incX,Y,incY)
C
C      Y = X
C
       implicit none
#include "chcc1.fh"
c
       integer length,incx,incy
       real*8  X(*)
       real*8  Y(*)
C
C      help variables
C
       integer i
C
        if (mhkey.eq.1) then
c      ESSL
       call dcopy_(length,X(1),incx,Y(1),incY)
C
       else
c      Fotran
C
       if (incx*incy.eq.1) then
c
         do 10 i=1, length
         y(i) = x(i)
 10      continue
       else
         do 20 i=0, length-1
         y(1+i*incy) = x(1+i*incx)
 20      continue
       end if
C
       end if
c
       return
       end
C
C---------------------------------------
C
       subroutine mv0v1u (length,X,incX,Y,incY,f)
C
C      Y = Y + f . X
C
       implicit none
#include "chcc1.fh"
c
       integer length,incx,incy
       real*8  f
       real*8  X(*)
       real*8  Y(*)
C
C      help variables
C
       integer i
C
       if (mhkey.eq.1) then
c      ESSL
       call daxpy_(length,f,X(1),incx,Y(1),incY)
C
       else
c      Fotran
C
       if (incx*incy.eq.1) then
c
         do 10 i=1, length
         y(i) = y(i)+f*x(i)
 10      continue
       else
         do 20 i=0, length-1
         y(1+i*incy) = y(1+i*incy)+f*x(1+i*incx)
 20      continue
       end if
C
       end if
c
       return
       end
c
c     ---------------
c
       subroutine mv0sv (dd,length,mat,f)
C
c      A = A .f
c
#include "chcc1.fh"
       integer dd
       integer length
       real*8  mat(1:dd)
       real*8 f
C
C      help variables
C
       integer init
C
C
       if (mhkey.eq.1) then
c      ESSL
c
       do  5 init=1,length
       mat(init) = mat(init)*f
  5    continue
c
       else
c      Fortran matrix handling
C
       do 10 init=1,length
       mat(init) = mat(init)*f
 10    continue
c
       end if
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1992, Roland Lindh                                *
!***********************************************************************

subroutine Hrr2Db_mck(Arr1,nVec,ncdMax,Arr2,C,D,la,lb,lc,ld,IfHss,IfGrd)
!***********************************************************************
!                                                                      *
! Object: to apply the transfer equation to the 2D-integrals.          *
!         The transformation is in place and the recursion             *
!         is replaced with the indentity when applicable.              *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             September '91                                            *
!             Modified to recurrence algorithm, February '92           *
!             Improved algorithm, June '92.                            *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nVec, ncdMax, la, lb, lc, ld
real(kind=wp), intent(in) :: Arr1(nVec,0:la+2,0:lb+2,0:ncdMax,3), C(3), D(3)
real(kind=wp), intent(out) :: Arr2(nVec,0:la+2,0:lb+2,0:lc+2,0:ld+2,3)
logical(kind=iwp), intent(in) :: IfHss(4,3,4,3), ifGrd(3,4)
integer(kind=iwp) :: ia, ib, ic, iCar, icd, id, jc, jd, kc, kd, lla, llb, llc, lld, mc, md
real(kind=wp) :: CD

!iRout = 233
!iPrint = nPrint(iRout)

do iCar=1,3
  llc = 0
  lld = 0
  lla = 0
  llb = 0
  if (IfGrd(iCar,3)) llc = max(llc,1)
  if (IfHss(3,iCar,3,iCar)) llc = 2
  if (IfGrd(iCar,4)) lld = max(1,lld)
  if (IfHss(4,iCar,4,iCar)) lld = 2
  if (IfGrd(iCar,1)) lla = max(1,lla)
  if (IfHss(1,iCar,1,iCar)) lla = 2
  if (IfGrd(iCar,2)) llb = max(llb,1)
  if (IfHss(2,iCar,2,iCar)) llb = 2
  CD = C(iCar)-D(iCar)
  if (CD == Zero) then
    do ia=0,la+lla
      do ib=0,lb+llb
        if (ia+ib > la+lb+max(lla,llb)) cycle
        ! Using the identity
        do ic=0,lc+llc
          do id=0,ld+lld
            icd = ic+id
            if (icd > lc+ld+max(llc,lld)) cycle
            Arr2(:,ia,ib,ic,id,iCar) = Arr1(:,ia,ib,icd,iCar)
          end do
        end do
      end do
    end do
  else if (lc >= ld) then
    do ia=0,la+lla
      do ib=0,lb+llb
        if (ia+ib > la+lb+max(lla,llb)) cycle
        ! Move the first row I(ic,0)
        do ic=0,lc+ld+max(llc,lld)
          jc = ic
          jd = 0
          if (jc > lc+2) then
            jc = jc-(lc+3)
            jd = 1
          end if
          Arr2(:,ia,ib,jc,jd,iCar) = Arr1(:,ia,ib,ic,iCar)
        end do
        ! Generate I(ic,id) for fixed id
        do id=1,ld+lld
          do ic=lc+ld+max(llc,lld)-id,0,-1
            jc = ic
            jd = id
            md = id-1
            if (jc > lc+2) then
              jc = jc-(lc+3)
              jd = jd+1
              md = md+1
            end if
            mc = jc
            kc = ic+1
            kd = id-1
            if (kc > lc+2) then
              kc = kc-(lc+3)
              kd = kd+1
            end if
            Arr2(:,ia,ib,jc,jd,iCar) = CD*Arr2(:,ia,ib,mc,md,iCar)+Arr2(:,ia,ib,kc,kd,iCar)
          end do
        end do
      end do
    end do
  else
    CD = -CD
    do ia=0,la+lla
      do ib=0,lb+llb
        if (ia+ib > la+lb+max(lla,llb)) cycle
        ! Move the first row I(0,id)
        do id=0,lc+ld+max(llc,lld)
          jd = id
          jc = 0
          if (jd > ld+2) then
            jd = jd-(ld+3)
            jc = 1
          end if
          Arr2(:,ia,ib,jc,jd,iCar) = Arr1(:,ia,ib,id,iCar)
        end do
        ! Generate I(ic,id) for fixed ic
        do ic=1,lc+llc
          do id=lc+ld+max(llc,lld)-ic,0,-1
            jd = id
            jc = ic
            mc = ic-1
            if (jd > ld+2) then
              jd = jd-(ld+3)
              jc = jc+1
              mc = mc+1
            end if
            md = jd
            kd = id+1
            kc = ic-1
            if (kd > ld+2) then
              kd = kd-(ld+3)
              kc = kc+1
            end if
            Arr2(:,ia,ib,jc,jd,iCar) = CD*Arr2(:,ia,ib,mc,md,iCar)+Arr2(:,ia,ib,kc,kd,iCar)
          end do
        end do
      end do
    end do
  end if
end do

return

end subroutine Hrr2Db_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE NEXT_CONF_FOR_OCCLS            (ICONF,
     &                                           IOCCLS,
     &                                           NGAS,
     &                                           NOBPT,
     &                                           INI,
*
     &                                           NONEW)
*
* Obtain next configuration for occupation class
*
* Jeppe Olsen, Nov. 2001
*
#include "implicit.fh"
#include "mxpdim.fh"
*
*. Input
*
*. Number of electrons per gas space
      INTEGER IOCCLS(NGAS)
*. Number of orbitals per gasspace
      INTEGER NOBPT(NGAS)
*. Input and output
      INTEGER ICONF(*)
*. Local scratch
      INTEGER IBORB(MXPNGAS), ICONF_GAS(MXPORB)
      INTEGER IBEL(MXPNGAS)
*
      NTEST = 000
*. Total number of electrons
      NEL = IELSUM(IOCCLS,NGAS)
C?    WRITE(6,*) ' NEXT_CONF ... NEL, NGAS = ', NEL, NGAS
*. Offset for orbitals and electrons
      DO IGAS = 1, NGAS
        IF(IGAS.EQ.1) THEN
          IBORB(IGAS) = 1
          IBEL(IGAS)  = 1
        ELSE
          IBORB(IGAS) = IBORB(IGAS-1)+NOBPT(IGAS-1)
          IBEL(IGAS)  = IBEL(IGAS-1) + IOCCLS(IGAS-1)
        END IF
      END DO
*
      NONEW = 1

      IF(INI.EQ.1) THEN
*
*. Initial configuration
*
        NONEW = 0
        INI_L = 1
        NONEW_L = 0
        DO IGAS = 1, NGAS
*. Initial configuration for this GASSPACE
          NEL_GAS = IOCCLS(IGAS)
          NORB_GAS = NOBPT(IGAS)
C?        WRITE(6,*) ' IGAS, NEL_GAS, NORB_GAS = ',
C?   &                 IGAS, NEL_GAS, NORB_GAS
          CALL NXT_CONF(ICONF_GAS,NEL_GAS,NORB_GAS,INI_L,NONEW_L)
          IF(NONEW_L.EQ.1) THEN
             NONEW = 1
             GOTO 1001
          ELSE
             JBEL   = IBEL(IGAS)
             JBORB  = IBORB(IGAS)
             JEL = IOCCLS(IGAS)
             JORB  = NOBPT(IGAS)
             CALL REFORM_CONF_FOR_GAS             (ICONF_GAS,
     &                                             ICONF,
     &                                             JBORB,
     &                                             JBEL,MXPORB,JEL,2)
C    &            (ICONF_GAS,ICONF,JBORB,JBEL,JORB,JEL,2)
C                 (ICONF_GAS,ICONF,IBORB,IBEL,NORB,NEL,IWAY)
          END IF
        END DO
*
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' Initial configuration '
          CALL IWRTMA(ICONF,1,NEL,1,NEL)
        END IF
*
      ELSE
*
*. Next configuration
*
*. Loop over GAS spaces and find first GASspace where a new configuration
*. could be obtained
        DO IGAS = 1, NGAS
C?        WRITE(6,*) ' IGAS = ', IGAS
*. Remove the offsets for this space
          JBEL   = IBEL(IGAS)
          JBORB  = IBORB(IGAS)
          JEL = IOCCLS(IGAS)
          JORB = NOBPT(IGAS)
C?        WRITE(6,*) ' JBEL, JBORB, JEL, JORB = ',
C?   &                 JBEL, JBORB, JEL, JORB
          CALL REFORM_CONF_FOR_GAS          (ICONF_GAS,
     &                                       ICONF,
     &                                       JBORB,JBEL,MXPORB,JEL, 1)
C    &         (ICONF_GAS,ICONF,JBORB,JBEL,JORB,JEL,1)
*. Generate next configuration for this space
          INI_L = 0
          CALL NXT_CONF(ICONF_GAS,JEL,JORB,INI_L,NONEW_L)
          IF(NONEW_L.EQ.0) THEN
            NONEW = 0
*. Configuration in space IGAS, was increased. Copy this and reset configurations
*. in previous gasspaces to initial form
            CALL REFORM_CONF_FOR_GAS            (ICONF_GAS,
     &                                           ICONF,
     &                                           JBORB,
     &                                           JBEL,
     &                                           MXPORB,
*
     &                                           JEL,
     &                                             2)
C    &           (ICONF_GAS,ICONF,JBORB,JBEL,JORB,JEL,2)
*
            DO JGAS = 1, IGAS-1
              JBEL   = IBEL(JGAS)
              JBORB  = IBORB(JGAS)
              JEL = IOCCLS(JGAS)
              JORB = NOBPT(JGAS)
              CALL REFORM_CONF_FOR_GAS              (ICONF_GAS,
     &                                               ICONF,
     &                                               JBORB,
     &                                               JBEL,MXPORB,JEL,1)
C    &             (ICONF_GAS,ICONF,JBORB,JBEL,JORB,JEL,1)
              INI_L = 1
              CALL NXT_CONF(ICONF_GAS,JEL,JORB,INI_L,NONEW_L)
C                                     NEL_GAS,NORB_GAS,INI_L,NONEW_L)
              CALL REFORM_CONF_FOR_GAS              (ICONF_GAS,
     &                                               ICONF,
     &                                               JBORB,
     &                                               JBEL,MXPORB,JEL,2)
C    &             (ICONF_GAS,ICONF,JBORB,JBEL,JORB,JEL,2)
            END DO
*. Get out of the loop
            GOTO 1001
          END IF
        END DO
*       ^ End of loop over gasspaces
      END IF
*     ^ End if swith between initialization/next
 1001 CONTINUE
*
      IF(NTEST.GE.100) THEN
        IF(NONEW.EQ.1) THEN
          WRITE(6,*) ' No new configuration '
        ELSE
          WRITE(6,*) ' New configuration '
          CALL IWRTMA(ICONF,1,NEL,1,NEL)
        END IF
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989,2003, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE DIHDJ_MOLCAS(IASTR,IBSTR,NIDET,JASTR,JBSTR,NJDET,
     &     NAEL,NBEL,
     &     IWORK,NORB,ONEBOD,HAMIL,ISYM,NINOB,ECORE,ICOMBI,PSIGN,
     &     IPRINT,TUVX,ExFac,IREOTS)
C
C A SET OF DETERMINANTS IA DEFINED BY ALPHA AND BETASTRINGS
C IASTR,IBSTR AND ANOTHER SET OF DETERMINATS DEFINED BY STRINGS
C JASTR AND JBSTR ARE GIVEN . OBTAIN CORRESPONDING HAMILTONIAN MATRIX
C
C IF ICOMBI .NE. 0 COMBINATIONS ARE USED FOR ALPHA AND BETA STRING
C THAT DIFFERS :
C   1/SQRT(2) * ( |I1A I2B| + PSIGN * |I2A I1B| )
C
C IF ISYM .EQ. 0 FULL HAMILTONIAN IS CONSTRUCTED
C IF ISYM .NE. 0 LOWER HALF OF HAMILTONIAN IS CONSTRUCTED
C
C JEPPE OLSEN JANUARY 1989
*             IREOTS added for new Molcas compatibility, August 2003
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IASTR(NAEL,*),IBSTR(NBEL,*)
      DIMENSION JASTR(NAEL,*),JBSTR(NBEL,*)
C
      DIMENSION IWORK(*), HAMIL(*), ONEBOD(NORB,NORB)
      DIMENSION TUVX(*), IREOTS(*)
C
      NTEST = 0
C  Initialization
      KLIAB = 0
      IAEQIB = 0
      JAEQJB = 0
      CONST  = 0.0D0
      IEL1   = 0
      JEL1   = 0
      IPERM  = 0
      JPERM  = 0
      SIGN   = 0.0D0
      SIGNA  = 0.0D0
      SIGNB  = 0.0D0
      XVAL   = 0.0D0
      IA     = 0
      IB     = 0
      JA     = 0
      JB     = 0
      I1     = 0
      I2     = 0
      J1     = 0
      J2     = 0
C SCATCH SPACE
C
C .. 1 : EXPANSION OF ALPHA AND BETA STRINGS OF TYPE I
C
      KLFREE = 1
      KLIAE  = KLFREE
      KLFREE = KLIAE + NORB
      KLIBE  = KLFREE
      KLFREE = KLIBE + NORB
C
      KLJAE = KLFREE
      KLFREE = KLJAE + NORB
      KLJBE = KLFREE
      KLFREE = KLJBE + NORB
      IF( ICOMBI .NE. 0 ) THEN
        KLIAB  = KLFREE
        KLFREE = KLFREE + NIDET
      END IF
C
      IF( ICOMBI .NE. 0 ) THEN
C SET UP ARRAY COMBARING ALPHA AND BETA STRINGS IN IDET LIST
        DO 13 IDET = 1, NIDET
          IAEQIB = 1
          DO 14 IEL = 1, NAEL
            IF(IASTR(IEL,IDET) .NE. IBSTR(IEL,IDET))IAEQIB = 0
14        CONTINUE
          IWORK(KLIAB-1+IDET) = IAEQIB
13      CONTINUE
      END IF
C
      IF( ISYM .EQ. 0 ) THEN
        LHAMIL = NIDET*NJDET
      ELSE
        LHAMIL = NIDET*(NIDET+1) / 2
      END IF
      CALL DCOPY_(LHAMIL,[0.0D0],0,HAMIL,1)
C
      NTERMS= 0
      NDIF0 = 0
      NDIF1 = 0
      NDIF2 = 0
C.. LOOP OVER J DETERMINANTS
C
      DO 1000 JDET = 1,NJDET
C
C EXPAND JDET
        CALL ICOPY(NORB,[0],0,IWORK(KLJAE),1)
        CALL ICOPY(NORB,[0],0,IWORK(KLJBE),1)
C
        IF( ICOMBI .NE. 0 ) THEN
          JAEQJB = 1
          DO 32 IEL = 1, NAEL
            IF(JASTR(IEL,JDET) .NE. JBSTR(IEL,JDET))JAEQJB = 0
32        CONTINUE
        END IF
C
        DO 40 IAEL = 1, NAEL
          IWORK(KLJAE-1+JASTR(IAEL,JDET) ) = 1
40      CONTINUE
C
        DO 50 IBEL = 1, NBEL
          IWORK(KLJBE-1+JBSTR(IBEL,JDET) ) = 1
50      CONTINUE
C
        IF( NTEST .GE. 10 ) THEN
          WRITE(6,*) ' LOOP 1000 JDET =  ',JDET
          WRITE(6,*) ' JASTR AND JBSTR '
          CALL IWRTMA(JASTR(1,JDET),1,NAEL,1,NAEL)
          CALL IWRTMA(JBSTR(1,JDET),1,NBEL,1,NBEL)
          WRITE(6,*) ' EXPANDED ALPHA AND BETA STRING '
          CALL IWRTMA(IWORK(KLJAE),1,NORB,1,NORB)
          CALL IWRTMA(IWORK(KLJBE),1,NORB,1,NORB)
        END IF
C
        IF( ISYM .EQ. 0 ) THEN
          MINI = 1
        ELSE
          MINI = JDET
        END IF
        DO 900 IDET = MINI, NIDET
        IF( ICOMBI .EQ. 0 ) THEN
            NLOOP = 1
        ELSE
          IAEQIB = IWORK(KLIAB-1+IDET)
          IF(IAEQIB+JAEQJB .EQ. 0 ) THEN
            NLOOP = 2
          ELSE
            NLOOP = 1
          END IF
        END IF
C
        DO 899 ILOOP = 1, NLOOP
         NTERMS = NTERMS + 1
C
C.. COMPARE DETERMINANTS
C
C SWAP IA AND IB FOR SECOND PART OF COMBINATIONS
        If ( ILOOP.eq.2 ) then
          Do iii = 1,NAEL
            jjj = IASTR(iii,IDET)
            IASTR(iii,IDET) = IBSTR(iii,IDET)
            IBSTR(iii,IDET) = jjj
          End Do
        End If
C
        NACM = 0
        DO 61 IAEL = 1, NAEL
          NACM = NACM + IWORK(KLJAE-1+IASTR(IAEL,IDET))
61      CONTINUE
C
        NBCM = 0
        DO 62 IBEL = 1, NBEL
          NBCM = NBCM + IWORK(KLJBE-1+IBSTR(IBEL,IDET))
62      CONTINUE
C
        NADIF = NAEL-NACM
        NBDIF = NBEL-NBCM
        IF( NTEST .GE. 10 ) THEN
          WRITE(6,*) '  LOOP 900 IDET ',IDET
          WRITE(6,*) ' COMPARISON , NADIF , NBDIF ', NADIF,NBDIF
        END IF
C
        IF(NADIF+NBDIF .GT. 2 ) GOTO 899
C
C
C  FACTOR FOR COMBINATIONS
       IF( ICOMBI .EQ. 0 ) THEN
         CONST = 1.0D0
       ELSE
         IF((JAEQJB +IAEQIB) .EQ.2 ) THEN
           CONST = 1.0D0
         ELSE IF( (JAEQJB+IAEQIB) .EQ. 1 ) THEN
           CONST = 1.0D0/SQRT(2.0D0)*(1.0D0+PSIGN)
          ELSE IF( (JAEQJB+IAEQIB) .EQ. 0 ) THEN
           IF( ILOOP .EQ. 1)  THEN
             CONST = 1.0D0
           ELSE
             CONST = PSIGN
           END IF
          END IF
        END IF
C
C.. FIND DIFFERING ORBITALS AND SIGN FOR PERMUTATION
C
C EXPAND IDET
        CALL ICOPY(NORB,[0],0,IWORK(KLIAE),1)
        CALL ICOPY(NORB,[0],0,IWORK(KLIBE),1)
C
          DO 42 IAEL = 1, NAEL
            IWORK(KLIAE-1+IASTR(IAEL,IDET) ) = 1
42        CONTINUE
C
          DO 52 IBEL = 1, NBEL
            IWORK(KLIBE-1+IBSTR(IBEL,IDET) ) = 1
52        CONTINUE
C
        IF(NADIF .EQ. 1 ) THEN
          DO 120 IAEL = 1,NAEL
            IF(IWORK(KLJAE-1+IASTR(IAEL,IDET)).EQ.0) THEN
              IA = IASTR(IAEL,IDET)
              IEL1 = IAEL
              GOTO 121
             END IF
120       CONTINUE
121       CONTINUE
C
          DO 130 JAEL = 1,NAEL
            IF(IWORK(KLIAE-1+JASTR(JAEL,JDET)).EQ.0) THEN
              JA = JASTR(JAEL,JDET)
              JEL1 = JAEL
              GOTO 131
             END IF
130       CONTINUE
131       CONTINUE
          SIGNA = DBLE((-1)**(JEL1+IEL1))
        END IF
        IF(NBDIF .EQ. 1 ) THEN
          DO 220 IBEL = 1,NBEL
            IF(IWORK(KLJBE-1+IBSTR(IBEL,IDET)).EQ.0) THEN
              IB = IBSTR(IBEL,IDET)
              IEL1 = IBEL
              GOTO 221
             END IF
220       CONTINUE
221       CONTINUE
C
          DO 230 JBEL = 1,NBEL
            IF(IWORK(KLIBE-1+JBSTR(JBEL,JDET)).EQ.0) THEN
              JB = JBSTR(JBEL,JDET)
              JEL1 = JBEL
              GOTO 231
             END IF
230       CONTINUE
231       CONTINUE
          SIGNB = DBLE((-1)**(JEL1+IEL1))
        END IF
        IF(NADIF .EQ. 2 ) THEN
          IDIFF = 0
          DO 320 IAEL = 1,NAEL
            IF(IWORK(KLJAE-1+IASTR(IAEL,IDET)).EQ.0) THEN
              IF( IDIFF .EQ. 0 ) THEN
                IDIFF = 1
                I1 = IASTR(IAEL,IDET)
                IPERM = IAEL
              ELSE
                I2 = IASTR(IAEL,IDET)
                IPERM = IAEL + IPERM
                GOTO 321
              END IF
            END IF
320       CONTINUE
321       CONTINUE
C
          JDIFF = 0
          DO 330 JAEL = 1,NAEL
            IF(IWORK(KLIAE-1+JASTR(JAEL,JDET)).EQ.0) THEN
              IF( JDIFF .EQ. 0 ) THEN
                JDIFF = 1
                J1 = JASTR(JAEL,JDET)
                JPERM = JAEL
              ELSE
                J2 = JASTR(JAEL,JDET)
                JPERM = JAEL + JPERM
                GOTO 331
              END IF
            END IF
330       CONTINUE
331       CONTINUE
          SIGN = DBLE((-1)**(IPERM+JPERM))
        END IF
C
        IF(NBDIF .EQ. 2 ) THEN
          IDIFF = 0
          DO 420 IBEL = 1,NBEL
            IF(IWORK(KLJBE-1+IBSTR(IBEL,IDET)).EQ.0) THEN
              IF( IDIFF .EQ. 0 ) THEN
                IDIFF = 1
                I1 = IBSTR(IBEL,IDET)
                IPERM = IBEL
              ELSE
                I2 = IBSTR(IBEL,IDET)
                IPERM = IBEL + IPERM
                GOTO 421
               END IF
            END IF
420       CONTINUE
421       CONTINUE
C
          JDIFF = 0
          DO 430 JBEL = 1,NBEL
            IF(IWORK(KLIBE-1+JBSTR(JBEL,JDET)).EQ.0) THEN
              IF( JDIFF .EQ. 0 ) THEN
                JDIFF = 1
                J1 = JBSTR(JBEL,JDET)
                JPERM = JBEL
              ELSE
                J2 = JBSTR(JBEL,JDET)
                JPERM = JBEL + JPERM
                GOTO 431
              END IF
            END IF
430       CONTINUE
431       CONTINUE
          SIGN = DBLE((-1)**(IPERM+JPERM))
        END IF
C
C OBTAIN VALUE OF HAMILTONIAN ELEMENT
C
        IF( NADIF .EQ. 2 .OR. NBDIF .EQ. 2 ) THEN
          NDIF2 = NDIF2 + 1
C SIGN * (I1 J1 | I2 J2 ) - ( I1 J2 | I2 J1 )
          I1 = I1 + NINOB
          I2 = I2 + NINOB
          J1 = J1 + NINOB
          J2 = J2 + NINOB
*. Well, there is no reordering in integrals any more. so
          I1_REO = IREOTS(I1)
          J1_REO = IREOTS(J1)
          I2_REO = IREOTS(I2)
          J2_REO = IREOTS(J2)
          XVAL = SIGN*( GETH2A(I1_REO,J1_REO,I2_REO,J2_REO,TUVX)
     *                 -GETH2A(I1_REO,J2_REO,I2_REO,J1_REO,TUVX) )
        ELSE IF( NADIF .EQ. 1 .AND. NBDIF .EQ. 1 ) THEN
          NDIF2 = NDIF2 + 1
C SIGN * (IA JA | IB JB )
          IA = IA + NINOB
          IB = IB + NINOB
          JA = JA + NINOB
          JB = JB + NINOB
*
          IA_REO = IREOTS(IA)
          IB_REO = IREOTS(IB)
          JA_REO = IREOTS(JA)
          JB_REO = IREOTS(JB)
          XVAL = SIGNA*SIGNB* GETH2A(IA_REO,JA_REO,IB_REO,JB_REO,TUVX)
        ELSE IF( NADIF .EQ. 1 .AND. NBDIF .EQ. 0 .OR.
     *           NADIF .EQ. 0 .AND. NBDIF .EQ. 1 )THEN
          NDIF1 = NDIF1 + 1
C SIGN *
C(  H(I1 J1 ) +
C  (SUM OVER ORBITALS OF BOTH      SPIN TYPES  ( I1 J1 | JORB JORB )
C -(SUM OVER ORBITALS OF DIFFERING SPIN TYPE   ( I1 JORB | JORB J1 ) )
          IF( NADIF .EQ. 1 ) THEN
            I1 = IA + NINOB
            J1 = JA + NINOB
            SIGN = SIGNA
          ELSE
            I1 = IB + NINOB
            J1 = JB + NINOB
            SIGN = SIGNB
          END IF
C
          I1_REO = IREOTS(I1)
          J1_REO = IREOTS(J1)
          XVAL = ONEBOD(IREOTS(I1-NINOB),IREOTS(J1-NINOB))
          DO 520 JAEL = 1, NAEL
            JORB = JASTR(JAEL,JDET)+NINOB
            JORB_REO = IREOTS(JORB)
            XVAL = XVAL + GETH2A(I1_REO,J1_REO,JORB_REO,JORB_REO,TUVX)
520       CONTINUE
          DO 521 JBEL = 1, NBEL
            JORB = JBSTR(JBEL,JDET)+NINOB
            JORB_REO = IREOTS(JORB)
            XVAL = XVAL + GETH2A(I1_REO,J1_REO,JORB_REO,JORB_REO,TUVX)
521       CONTINUE
          IF( NADIF .EQ. 1 ) THEN
            DO 522 JAEL = 1, NAEL
              JORB = JASTR(JAEL,JDET)+NINOB
              JORB_REO = IREOTS(JORB)
              XVAL = XVAL-GETH2A(I1_REO,JORB_REO,JORB_REO,J1_REO,TUVX)
522         CONTINUE
          ELSE
            DO 523 JBEL = 1, NBEL
              JORB = JBSTR(JBEL,JDET)+NINOB
              JORB_REO = IREOTS(JORB)
              XVAL = XVAL-GETH2A(I1_REO,JORB_REO,JORB_REO,J1_REO,TUVX)
523         CONTINUE
          END IF
          XVAL = XVAL * SIGN
        ELSE IF( NADIF .EQ. 0 .AND. NBDIF .EQ. 0 ) THEN
          NDIF0 = NDIF0 + 1
C SUM(I,J OF JDET) H(I,J) + (I I | J J ) - (I J | J I )
C
          XVAL = ECORE
          DO 650 IAB = 1, 2
            IF(IAB .EQ. 1 ) THEN
              NIABEL = NAEL
            ELSE
              NIABEL = NBEL
            END IF
            DO 640 JAB = 1, 2
              IF(JAB .EQ. 1 ) THEN
                NJABEL = NAEL
              ELSE
                NJABEL = NBEL
              END IF
              DO 630 IEL = 1, NIABEL
                IF( IAB .EQ. 1 ) THEN
                  IORB = IASTR(IEL,IDET)
                ELSE
                  IORB = IBSTR(IEL,IDET)
                END IF
                IORB_REO = IREOTS(IORB)
                IF(IAB .EQ. JAB ) XVAL = XVAL+ONEBOD(IORB_REO,IORB_REO)
                IORB = IORB + NINOB
                DO 620 JEL = 1, NJABEL
                  IF( JAB .EQ. 1 ) THEN
                    JORB = IASTR(JEL,IDET)+NINOB
                  ELSE
                    JORB = IBSTR(JEL,IDET)+NINOB
                  END IF
                  JORB_REO = IREOTS(JORB)
                  XVAL = XVAL
     &          + 0.5D0*GETH2A(IORB_REO,IORB_REO,JORB_REO,JORB_REO,TUVX)
                  IF ( IAB . EQ. JAB ) XVAL =
     &               XVAL - ExFac * 0.5D0 *
     &               GETH2A(IORB_REO,JORB_REO,JORB_REO,IORB_REO,TUVX)
620             CONTINUE
630           CONTINUE
640         CONTINUE
650       CONTINUE
        END IF
C
        IF( ISYM .EQ. 0 ) THEN
          HAMIL((JDET-1)*NIDET+IDET) =
     *    HAMIL((JDET-1)*NIDET+IDET) + CONST * XVAL
        ELSE
          HAMIL((IDET-1)*IDET/2 + JDET ) =
     *    HAMIL((IDET-1)*IDET/2 + JDET ) + CONST * XVAL
        END IF
C RESTORE ORDER |||
        If ( ILOOP.eq.2 ) then
          Do iii = 1,NAEL
            jjj = IASTR(iii,IDET)
            IASTR(iii,IDET) = IBSTR(iii,IDET)
            IBSTR(iii,IDET) = jjj
          End Do
        End If
899   CONTINUE
900   CONTINUE
1000  CONTINUE
C
      IF( IPRINT .GE. 2 ) THEN
        WRITE(6,*) '  HAMILTONIAN MATRIX '
        IF( ISYM .EQ. 0 ) THEN
          CALL WRTMAT(HAMIL,NIDET,NJDET,NIDET,NJDET)
        ELSE
          CALL PRSYM(HAMIL,NIDET)
        END IF
      END IF
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine creates start orbitals from model fock matrix elements  *
* generated by SEWARD.                                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: Oct 2004                                                    *
*                                                                      *
************************************************************************
      Subroutine FckByInt(iReturncode,StandAlone)
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
#include "Molcas.fh"
#include "commgo.fh"
#include "gsswfn.fh"
      Real*8, Dimension(:), Allocatable :: Fck, CMO, Ovl,
     &                                     T1, T2, T3, Eps
*----------------------------------------------------------------------*
* Dummy arguments                                                      *
*----------------------------------------------------------------------*
      Integer iReturncode, nOrb(8)
      Logical StandAlone
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Character*180 Line
      Logical Debug
      Logical Trace
      Character*80 Title
      Logical Verify
*----------------------------------------------------------------------*
      Integer IndType(7,8)
      Integer nTmp(8)
      Integer nBasTot
      Integer nBasMax
      Integer nTriTot
      Integer nSqrTot
      Integer iSym
      Integer iBas
      Integer jBas
      Integer kBas
*----------------------------------------------------------------------*
      Integer inFck
      Integer inCMO
      Integer inOvl
      Integer inEps
      Integer inT1
      Integer inT2
      Integer inT3
*----------------------------------------------------------------------*
      Integer Lu
      Integer irc
      Integer iSymlb
      Integer ij,ijS,ijT,ijL
      Integer nB
      Integer nC
      Integer nS
      Integer nD
      Integer nActEl
      Real*8  dActEl
      Integer nIsh(8)
      Integer nAsh(8)
#ifdef _HDF5_
      Character(Len=1), Allocatable :: typestring(:)
      Integer nZero(MxSym)
#endif
*----------------------------------------------------------------------*
* Some setup                                                           *
*----------------------------------------------------------------------*
      If(StandAlone) Then
         Debug=.false.
         Trace=.false.
      Else
         Debug=.false.
         Trace=.false.
      End If
      If(Trace) Then
         Write(6,*) '>>> Entering fckbyint'
         Call xflush(6)
      End If
      iReturncode=0
      Call getenvf('MOLCAS_TEST',Line)
      Verify = LINE(1:5).EQ.'CHECK' .or. LINE(1:4).EQ.'GENE'
      Verify = .True.
*----------------------------------------------------------------------*
* Do some counting                                                     *
*----------------------------------------------------------------------*
      nBasTot=0
      nBasMax=0
      nTriTot=0
      nSqrTot=0
      Do iSym=1,nSym
         nBasTot=nBasTot+nbas(iSym)
         nBasMax=Max(nbasmax,nBas(iSym))
         nTriTot=nTriTot+nBas(iSym)*(nBas(iSym)+1)/2
         nSqrTot=nSqrTot+nBas(iSym)*nBas(iSym)
      End Do
*----------------------------------------------------------------------*
* Get model Fock matrix.                                               *
*----------------------------------------------------------------------*
      inFck=nTriTot+6
      Call mma_allocate(Fck,inFck)
      iRc=-1
      iSymlb=1
      Call RdOne(irc,6,'FckInt  ',1,Fck,iSymlb)
      If (iRc.ne.0) Then
         iReturncode=1
         Call mma_deallocate(Fck)
         Write(6,*) '***'
         Write(6,*) '*** WARNING:'
         Write(6,*) '*** Guessorb did not produce start orbitals!!!'
         Write(6,*) '***'
         Return
      End If
      If(Debug) Then
         ij=1
         Do iSym=1,nSym
*           Call TriPrt('FckInt','(12f12.6)',Fck(ij),nBas(iSym))
            Call NrmClc(Fck(ij),nBas(iSym)*(nBas(iSym)+1)/2,'FckbyInt',
     &                  'Fck(ij)')
            ij=ij+nBas(iSym)*(nBas(iSym)+1)/2
         End Do
      End If
*----------------------------------------------------------------------*
* Make symmetric orthonormal orbital basis.                            *
*----------------------------------------------------------------------*
      inCMO=nSqrTot
      Call mma_allocate(CMO,inCMO)
      Call goLowdin(CMO)
      If (Debug) Then
         ij=1
         Do iSym=1,nSym
            nB=nBas(iSym)
*           Call RecPrt('CMO','(12f12.6)',CMO(ij),nB,nB)
            Call NrmClC(CMO(ij),nB**2,'FckbyInt','CMO(ij)')
            ij=ij+nB*nB
         End Do
      End If
*----------------------------------------------------------------------*
* Get overlap matrix                                                   *
*----------------------------------------------------------------------*
      inOvl=nTriTot+6
      Call mma_allocate(Ovl,inOvl)
      iSymlb=1
      Call RdOne(irc,6,'Mltpl  0',1,Ovl,iSymlb)
      If(Debug) Then
         ipT1=1
         Do iSym=1,nSym
*           Call TriPrt('Ovlp','(12f12.6)',Ovl(ipT1),nBas(iSym))
            Call NrmClc(Ovl(ipT1),nBas(iSym)*(nBas(iSym)+1)/2,
     &                  'FckbyInt','Ovl(ipT1)')
            ipT1=ipT1+nBas(iSym)*(nBas(iSym)+1)/2
         End Do
      End If
*----------------------------------------------------------------------*
* Transform: F = S eps S                                               *
*----------------------------------------------------------------------*
      inT1=nBasMax*nBasMax
      inT2=nBasMax*nBasMax
      inT3=nBasMax*nBasMax
      Call mma_allocate(T1,inT1)
      Call mma_allocate(T2,inT2)
      Call mma_allocate(T3,inT3)
      ijT=1
      ijS=1
      ijL=1
      Do iSym=1,nSym
         nB=nBas(iSym)
         If(nB.gt.0) Then
            Call Square(Fck(ijT),T1,1,nB,nB)
            Call Square(Ovl(ijT),T2,1,nB,nB)
            Call DGEMM_('N','N',
     &                  nB,nB,nB,
     &                  1.0d0,T1,nB,
     &                        T2,nB,
     &                  0.0d0,T3,nB)
            Call MxMt(T2,nB,1,
     &                T3,1,nB,
     &                Fck(ijT), nB,nB)
            If(Debug) Then
*              Call TriPrt('Fock matrix with metric','(12f12.6)',
*    &                     Fck(ijT),nB)
               Call NrmClc(Fck(ijT),nB*(nB+1)/2,'FckbyInt','Fck(ijT)')
            End If
         End If
         ijT=ijT+nB*(nB+1)/2
         ijS=ijS+nB*nB
         ijL=ijL+nB
      End Do
      Call mma_deallocate(T3)
      Call mma_deallocate(T2)
      Call mma_deallocate(T1)
*----------------------------------------------------------------------*
* Diagonalize the model Fock matrix                                    *
*----------------------------------------------------------------------*
      inEps=nBasTot
      Call mma_allocate(Eps,inEps)
      inT1=nBasMax*nBasMax
      inT2=nBasMax*nBasMax
      inT3=nBasMax*nBasMax
      Call mma_allocate(T1,inT1)
      Call mma_allocate(T2,inT2)
      Call mma_allocate(T3,inT3)
      ijT=1
      ijS=1
      ijL=1
      Do iSym=1,nSym
         nB=nBas(iSym)
         nS=nBas(iSym)-nDel(iSym)
         If(nB.gt.0) Then
            Call Square(Fck(ijT),T1,1,nB,nB)
            Call DGEMM_('N','N',
     &                  nB,nS,nB,
     &                  1.0d0,T1,nB,
     &                        CMO(ijS),nB,
     &                  0.0d0,T2,nB)
            Call MxMt(CMO(ijS),nB,1,
     &                T2,1,nB,
     &                T3, nS,nB)
            If(Debug) Then
*              Call TriPrt('Transformed Fock matrix','(12f12.6)',T3,nB)
               Call NrmClc(T3,nB*(nB+1)/2,'FckbyInt','Transformed Fck')
            End If
            Call NIdiag(T3,CMO(ijS),nS,nB,0)
            Call goPickup(T3,Eps(ijL),nS)
            Call goSort(Eps(ijL),CMO(ijS),nS,nB)
*
            Do i = 1, nS
               tmp = OrbPhase(CMO(ijS+(i-1)*nB),nB)
            End Do
         End If
         ijT=ijT+nB*(nB+1)/2
         ijS=ijS+nB*nB
         ijL=ijL+nB
      End Do
      If (Debug) Then
         ij=1
         Do iSym=1,nSym
            nB=nBas(iSym)
*           Call RecPrt('CMO','(12f12.6)',CMO(ij),nB,nB)
            Call NrmClC(CMO(ij),nB**2,'FckbyInt','CMO(ij)')
            ij=ij+nB*nB
         End Do
      End If
      Call mma_deallocate(T3)
      Call mma_deallocate(T2)
      Call mma_deallocate(T1)
*----------------------------------------------------------------------*
* Diagonalize T in virtual space.                                      *
*----------------------------------------------------------------------*
      If(.false.) Goto 900
      iRc=-1
      iSymlb=1
      Call RdOne(irc,6,'Kinetic ',1,Fck,iSymlb)
      If (iRc.ne.0) Goto 900
      inT1=nBasMax*nBasMax
      inT2=nBasMax*nBasMax
      inT3=nBasMax*nBasMax
      Call mma_allocate(T1,inT1)
      Call mma_allocate(T2,inT2)
      Call mma_allocate(T3,inT3)
      ijT=1
      ijS=1
      ijL=1
      Do iSym=1,nSym
         nB=nBas(iSym)
         nD=nDel(iSym)
         nC=0
         Do iBas=1,nB-nD
            If(Eps(ijL+iBas-1).lt.-1.0d-3) nC=nC+1
         End Do
         nS=nB-nC-nD
         If(nS.gt.0) Then
*
*           Generate standardized virtual orbitals before we proceed.
*           The virtual orbitals generated previously are not well
*           defined and might differ substantially with different
*           hardware/software and compiler options. To be able to
*           compare we will need these standardized virtual orbitals.
*           In real production calculations this step could for all
*           practical purposes be skipped.
*
            If (Verify)
     &      Call Virt_Space(CMO(ijS),CMO(ijS+nB*nC),Ovl(ijT),nB,nC,nS)
*
            Call Square(Fck(ijT),T1,1,nB,nB)
            Call DGEMM_('N','N',
     &                  nB,nS,nB,
     &                  1.0d0,T1,nB,
     &                        CMO(ijS+nB*nC),nB,
     &                  0.0d0,T2,nB)

            Call MxMt(CMO(ijS+nB*nC),nB,1,
     &                T2,1,nB,
     &                T3, nS,nB)
            If(Debug) Then
               Call TriPrt('Virtual space','(12f12.6)',T3,nS)
            End If
            Call NIdiag(T3,CMO(ijS+nB*nC),nS,nB,0)
            Call goPickup(T3,Eps(ijL+nC),nS)
            Call goSort(Eps(ijL+nC),CMO(ijS+nB*nC),nS,nB)
            If(Debug) Then
               Call RecPrt('Eps',' ',Eps(ijL+nC),nS,1)
               Call RecPrt('Virtual Orbitals',' ',
     &                     CMO(ijS+nB*nC),nB,nS)
            End If
*
*           Now order degenerate orbitals. This is only important for
*           verification runs.
*
            Do iBas = nC+1, nB-nD-1
               ei = Eps(ijL+iBas-1)
               tmp1 = 0.0d0
               Do kBas = 1, nB
                  ik = ijS+ (iBas-1)*nB + kBas -1
                  tmp1 = tmp1 + Abs(CMO(ik)*DBLE(kBas))
               End Do
               Do jBas = iBas+1, nB-nD
                  ej = Eps(ijL+jBas-1)
                  If (Abs(ei-ej).lt.1.0D-12) Then
                     tmp2 = 0.0d0
                     Do kBas = 1, nB
                        jk = ijS+ (jBas-1)*nB + kBas -1
                        tmp2 = tmp2 + Abs(CMO(jk)*DBLE(kBas))
                     End Do
                     If (tmp2.gt.tmp1) Then
                        tmp=tmp2
                        tmp2=tmp1
                        tmp1=tmp
                        Eps(ijL+iBas-1) = ej
                        Eps(ijL+jBas-1) = ei
                        ei = ej
                        i1 = ijS+ (iBas-1)*nB
                        j1 = ijS+ (jBas-1)*nB
                        Call DSwap_(nB,CMO(i1),1,CMO(j1),1)
                     End If
                  End If

               End Do
            End Do
*
*           Introduce "standard" phase.
*
            Do iBas = 1, nB
               tmp = OrbPhase(CMO(ijS+(iBas-1)*nB),nB)
            End Do
*
            If(Debug) Then
               Call RecPrt('Eps',' ',Eps(ijL+nC),nS,1)
               Call RecPrt('Virtual Orbitals',' ',
     &                     CMO(ijS+nB*nC),nB,nS)
            End If
            Do iBas=nC+1,nB-nD
               Eps(ijL+iBas-1)=Eps(ijL+iBas-1)+3.0d0
            End Do
            Do iBas=nB-nD+1,nB
               Eps(ijL+iBas-1)=999.0d0
            End Do
            Do iBas=1,nB-nD
               If(Eps(ijL+iBas-1).gt.TThr)
     &            nDel(iSym)=nDel(iSym)+1
            End Do
         End If
         ijT=ijT+nB*(nB+1)/2
         ijS=ijS+nB*nB
         ijL=ijL+nB
      End Do
      Call mma_deallocate(T3)
      Call mma_deallocate(T2)
      Call mma_deallocate(T1)
*----------------------------------------------------------------------*
* Print orbital space data.                                            *
*----------------------------------------------------------------------*
      If (StandAlone) Then
         Write(6,'(a,e10.3)')
     &         'Threshold for linear dependence due to S:',SThr
         Write(6,'(a,e10.3)')
     &         'Threshold for linear dependence due to T:',TThr
         Write(6,*)
         Write(6,'(a,8i5)')   'Total number of basis functions',
     &      (nBas(iSym),iSym=1,nSym)
         Write(6,'(a,8i5)')   'Deleted orbitals               ',
     &      (nDel(iSym),iSym=1,nSym)
         Write(6,*)
      End If
*----------------------------------------------------------------------*
* Present data.                                                        *
*----------------------------------------------------------------------*
900   Continue
      inT1=nBasTot
      inT2=nBasTot
      Call mma_allocate(T1,inT1)
      Call mma_allocate(T2,inT2)
      Do iBas=1,nBasTot
         T1(iBas)=0.0d0
      End Do
      Call GoPop(Eps,T1,T2,nBasTot,PrintEor,PrThr,GapThr)
      iBas=0
      dActEl=0.0d0
      Do iSym=1,nSym
         IndType(1,iSym)=0
         IndType(2,iSym)=0
         IndType(3,iSym)=0
         IndType(4,iSym)=0
         IndType(5,iSym)=0
         IndType(6,iSym)=nBas(iSym)-nDel(iSym)
         IndType(7,iSym)=nDel(iSym)
         Do kBas=1,nBas(iSym)-nDel(iSym)
            iBas=iBas+1
            If(T1(iBas).gt.1.99d0) Then
               IndType(2,iSym)=IndType(2,iSym)+1
               IndType(6,iSym)=IndType(6,iSym)-1
            Else If(T1(iBas).gt.0.01d0) Then
               IndType(4,iSym)=IndType(4,iSym)+1
               IndType(6,iSym)=IndType(6,iSym)-1
               dActEl=dActEl+T1(iBas)
            End If
         End Do
      End Do
      nActEl=Int(dActEl+0.5d0)
      If(PrintMOs) then
         Call PriMO('Start orbitals (virtuals shifted)',
     &              .true.,.true.,0.0d0,PrThr,
     &              nSym,nBas,nBas,Label,Eps,T1,
     &              CMO,iPrFmt)
         Call xflush(6)
      End If
      If(PrintPop) Then
         Call Charge(nSym,nBas,Label,CMO,T1,
     &               Ovl,2,.true.,.true.)
      End If
      Call put_darray('Guessorb',CMO,nSqrTot)
      Call put_darray('Guessorb energies',Eps,nBasTot)
      Do iSym=1,nSym
         nOrb(iSym)=nBas(iSym)-nDel(iSym)
      End Do
      Call Put_iArray('nOrb',nOrb,nSym)
      Call Put_iArray('nDel_go',nDel,nSym)
      Call Put_iArray('nDel',nDel,nSym)
      Do iSym=1,nSym
         nTmp(iSym)=IndType(2,iSym)
         nIsh(iSym)=nTmp(iSym)
      End Do
      Call Put_iArray('nIsh',nTmp,nSym)
      Do iSym=1,nSym
         nTmp(iSym)=IndType(4,iSym)
         nAsh(iSym)=nTmp(iSym)
      End Do
      Call Put_iArray('nAsh',nTmp,nSym)
      Call Put_iScalar('nActel',nActEl)
      kSpin=1 ! always same alpha and beta orbs
      Call Put_iScalar('Multiplicity',kSpin)
      Enr_go=0.0d0
      ipEE0=1
      ipOk0=1
      Do iSym=1,nSym
         Do i=0,nIsh(iSym)+nAsh(iSym)-1
            ipEE=ipEE0+i
            ipOk=ipOk0+i
            Enr_go=Enr_go+T1(ipOk)*Eps(ipEE)
         End Do
         ipEE0=ipEE0+nBas(iSym)
         ipOk0=ipOk0+nBas(iSym)
      End Do
      Call Put_dScalar('Last energy',Enr_go)
#ifdef _HDF5_
      call mh5_put_dset(wfn_energy,Enr_go)
#endif
      Lu=20
      Title='Guess orbitals'
      Call WrVec('GSSORB',Lu,'COEI',nSym,nBas,nBas,CMO,
     &           T1,Eps,IndType,Title)
#ifdef _HDF5_
      nZero=0
      call mma_allocate(typestring, nBasTot)
      call orb2tpstr(nSym,nBas,
     &        IndType(1,:),IndType(2,:),
     &        IndType(3,:),IndType(4,:),IndType(5,:),
     &        IndType(6,:),IndType(7,:),
     &        typestring)
      call mh5_put_dset(wfn_tpidx,typestring)
      call mma_deallocate(typestring)
      call mh5_put_dset(wfn_mocoef,CMO)
      call mh5_put_dset(wfn_occnum,T1)
      call mh5_put_dset(wfn_orbene,Eps)
#endif
*
* Compute density matrix (re-use memory allocated in Ovl)
      iOff=1
      jOff=1
      kOff=1
      Do iSym=1,nSym
         ipOkk=iOff
         nOkk=nIsh(iSym)+nAsh(iSym)
         ipCOk=jOff
         Do k=0,nOkk-1
            xocc=sqrt(T1(k+ipOkk))
            call dscal_(nBas(iSym),xocc,CMO(ipCOk),1)
            ipCOk=ipCOk+nBas(iSym)
         End Do
         Call DGEMM_Tri('N','T',nBas(iSym),nBas(iSym),nOkk,
     &                    1.0d0,CMO(jOff),Max(1,nBas(iSym)),
     &                          CMO(jOff),Max(1,nBas(iSym)),
     &                    0.0d0,Ovl(kOff),Max(1,nBas(iSym)))
         iOff=iOff+nBas(iSym)
         jOff=jOff+nBas(iSym)**2
         kOff=kOff+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
      Call Fold_tMat(nSym,nBas,Ovl,Ovl)
      Call Put_D1ao(Ovl,nTriTot)
*
      Call mma_deallocate(T2)
      Call mma_deallocate(T1)
*----------------------------------------------------------------------*
* Done, deallocate the rest.                                           *
*----------------------------------------------------------------------*
      Call mma_deallocate(Eps)
      Call mma_deallocate(Ovl)
      Call mma_deallocate(CMO)
      Call mma_deallocate(Fck)
      If(Trace) Then
         Write(6,*) '<<< Exiting fckbyint'
         Call xflush(6)
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoRPA_MOTra_ReorderCMO(nSym,nBas,nOrb,CMOinp,CMOout)

#include "intent.fh"

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym)
real(kind=wp), intent(in) :: CMOinp(*)
real(kind=wp), intent(_OUT_) :: CMOout(*)
integer(kind=iwp) :: iSym, ip1, ip2, l

ip1 = 1
ip2 = 1
do iSym=1,nSym
  l = nBas(iSym)*nOrb(iSym)
  call dCopy_(l,CMOinp(ip1),1,CMOout(ip2),1)
  call fZero(CMOout(ip2+l),nBas(iSym)*nBas(iSym)-l)
  ip1 = ip1+l
  ip2 = ip2+nBas(iSym)*nBas(iSym)
end do

end subroutine ChoRPA_MOTra_ReorderCMO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExH_T13(V,Hvv,dimbe,addbe,nv)
! this routine does:
! Extract V1(a,be') <- Hvv(a,be)
! Hvv(a,be') <- Fvv(a,be)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimbe, addbe, nv
real(kind=wp), intent(out) :: V(nv,dimbe)
real(kind=wp), intent(in) :: Hvv(nv,nv)

V(:,:) = Hvv(:,addbe+1:addbe+dimbe)

return

end subroutine ExH_T13

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ComputeFittingCoefficients(irc)
C
C     Thomas Bondo Pedersen, June/July 2010.
C
C     Driver of the Local Density Fitting.
C
C     Atom and Atom Pair data must have been set up before calling this
C     routine.
C
      Implicit None
      Integer irc
#include "localdf.fh"
#include "localdf_print.fh"
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"
#include "para_info.fh"

      Character*30 SecNam
      Parameter (SecNam='LDF_ComputeFittingCoefficients')

#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomInfoIsSet, LDF_AtomPairInfoIsSet
      External LDF_AtomInfoIsSet, LDF_AtomPairInfoIsSet
#endif
      Logical  Rsv_Tsk
      External Rsv_Tsk

      Integer  LDF_OpenC, LDF_CloseC
      External LDF_OpenC, LDF_CloseC

      Logical Modified
      Logical Timing

      Integer nTask
      Parameter (nTask=7)

      Real*8 Tol2C
      Parameter (Tol2C=1.0d-14)

      Integer ID
      Integer iAtomPair
      Integer ip_C, l_C
      Integer ip_Z, l_Z
      Integer iAddr, LuC
      Integer ip_T, l_T
      Integer iTask
      Integer AB_MAE, AB_MRNrm

      Real*8 tC0, tW0, tC1, tW1
      Real*8 totC0, totW0, totC1, totW1
      Real*8 tC_Replicate, tC_Copy, tC_Constraint
      Real*8 tW_Replicate, tW_Copy, tW_Constraint
      Real*8 MAE, MRNrm

      Integer i, j, k
      Logical isUnique
      Integer iTime
      isUnique(i)=iWork(ip_AP_Unique-1+i).eq.i
      iTime(i,j,k)=ip_T-1+2*nTask*(k-1)+2*(j-1)+i

      ! Init return code
      irc=0

#if defined (_DEBUGPRINT_)
      If (.not.LDF_AtomInfoIsSet() .or.
     &    .not.LDF_AtomPairInfoIsSet()) Then
         irc=-1
         Return
      End If
#endif

      ! Init timing
      Timing=iPrint.ge.Inf_DetailedTiming
      If (Timing) Then
         l_T=2*nTask*NumberOfAtomPairs
         Call GetMem('LDFCFCT','Allo','Real',ip_T,l_T)
         Call Cho_dZero(Work(ip_T),l_T)
      Else
         ip_T=0
         l_T=0
      End If

      ! Open coefficient file
      LuC=LDF_OpenC()
      ! Set unit number in ldf_cio.fh (to allow usage of LDF_CIO_ReadC)
      Call LDF_CIO_SetUnit(LuC)
      ! Init disk address for coefficients
      iAddr=0

      ! Set info for constraints
      If (Timing) Call CWTime(tC0,tW0)
      Call LDF_SetConstraint(LDF_Constraint)
      If (Timing) Then
         Call CWTime(tC1,tW1)
         tC_Constraint=tC1-tC0
         tW_Constraint=tW1-tW0
      End If

      ! Compute fitting coefficients for each unique atom pair
      Call Init_Tsk(ID,NumberOfAtomPairs)
      Do While (Rsv_Tsk(ID,iAtomPair))
         If (isUnique(iAtomPair)) Then

            If (Timing) Call CWTime(totC0,totW0)

            ! Compute CBar and Z vectors (lower triangle):
            ! Cbar[uv,J]={(uv|J)-sum(I=1,J-1)CBar[uv,I]*Z[J,I]}/Z[J,J]
            ! where
            ! (J|K)=sum(I) Z[J,I]*Z[K,I]
            If (Timing) Call CWTime(tC0,tW0)
            Call LDF_ComputeCBar(iAtomPair,ip_C,l_C,ip_Z,l_Z,irc)
            If (irc.ne.0) Then
               Write(6,'(A,A,I8)')
     &         SecNam,': LDF_ComputeCBar returned code',irc
               irc=1
               Return
            End If
            If (iPrint.ge.Inf_AuxBas) Then
               Call Cho_Head('Auxiliary Basis Info after Initial Fit',
     &                       '-',80,6)
               Call LDF_PrintAuxBasInfo(iAtomPair)
            End If
            If (Timing) Then
               Call CWTime(tC1,tW1)
               iTask=1
               Work(iTime(1,iTask,iAtomPair))=tC1-tC0
               Work(iTime(2,iTask,iAtomPair))=tW1-tW0
            End If

            ! Update diagonal integrals
            If (Timing) Call CWTime(tC0,tW0)
            Call LDF_UpdateDiagonal(iAtomPair,l_C,Work(ip_C),irc)
            If (irc.ne.0) Then
               Write(6,'(A,A)')
     &         SecNam,
     &         ': LDF_UpdateDiagonal found too negative diagonals!'
               Write(6,'(A,I10)')
     &         'Number of too negative diagonals:',irc
               Call LDF_PrintAtomPairDiagonal(iAtomPair)
               Call WarningMessage(2,'Too negative diagonals')
               irc=1
               Return
            End If
            If (Timing) Then
               Call CWTime(tC1,tW1)
               iTask=2
               Work(iTime(1,iTask,iAtomPair))=tC1-tC0
               Work(iTime(2,iTask,iAtomPair))=tW1-tW0
            End If
            ! Print diagonal information
            If (iPrint.ge.Inf_AP) Then
               Call Cho_Head('Atom Pair Diagonal Info (1-Center Only)',
     &                       '-',80,6)
               Call LDF_PrintAtomPairDiagonal(iAtomPair)
            End If

            ! Check accuracy and include 2-center functions if needed
            ! (and requested). This is based on the updated diagonal and
            ! new CBar and Z arrays are computed.
            If (LDF2) Then
               If (Timing) Call CWTime(tC0,tW0)
               Modified=.False.
               Call LDF_Add2CenterFunctions(iAtomPair,ip_C,l_C,ip_Z,l_Z,
     &                                      Modified,irc)
               If (irc.ne.0) Then
                  Write(6,'(A,A,I8)')
     &            SecNam,': LDF_Add2CenterFunctions returned code',irc
                  irc=1
                  Return
               End If
               If (Timing) Then
                  Call CWTime(tC1,tW1)
                  iTask=3
                  Work(iTime(1,iTask,iAtomPair))=tC1-tC0
                  Work(iTime(2,iTask,iAtomPair))=tW1-tW0
               End If
               ! Update diagonal info (if aux bas was modified)
               If (Modified) Then
                  ! Restore diagonal
                  If (Timing) Call CWTime(tC0,tW0)
                  Call LDF_RestoreDiagonal(iAtomPair)
                  ! Update diagonal
                  Call LDF_UpdateDiagonal(iAtomPair,l_C,Work(ip_C),irc)
                  If (irc.ne.0) Then
                     Write(6,'(A,A)')
     &               SecNam,
     &              ': LDF_UpdateDiagonal found too negative diagonals!'
                     Write(6,'(A,I10)')
     &               'Number of too negative diagonals:',irc
                     Call LDF_PrintAtomPairDiagonal(iAtomPair)
                     Call WarningMessage(2,'Too negative diagonals')
                     irc=1
                     Return
                  End If
                  If (Timing) Then
                     Call CWTime(tC1,tW1)
                     iTask=4
                     Work(iTime(1,iTask,iAtomPair))=tC1-tC0
                     Work(iTime(2,iTask,iAtomPair))=tW1-tW0
                  End If
                  ! Print diagonal information
                  If (iPrint.ge.Inf_AP) Then
                     Call Cho_Head(
     &                    'Atom Pair Diagonal Info (2-Center Included)',
     &                    '-',80,6)
                     Call LDF_PrintAtomPairDiagonal(iAtomPair)
                  End If
               End If
            End If

            ! Compute C from CBar and Z vectors:
            ! C[uv,J]={CBar[uv,J]-sum(I=J+1,M)C[uv,I]*Z[I,J]}/Z[J,J]
            If (Timing) Call CWTime(tC0,tW0)
            Call LDF_ComputeC(iAtomPair,ip_C,l_C,ip_Z,l_Z,irc)
            If (irc.ne.0) Then
               Write(6,'(A,A,I8)')
     &         SecNam,': LDF_ComputeC returned code',irc
               irc=1
               Return
            End If
            If (iPrint.ge.Inf_AuxBas) Then
               Call Cho_Head('Auxiliary Basis Info after Final Fit',
     &                       '-',80,6)
               Call LDF_PrintAuxBasInfo(iAtomPair)
            End If
            If (Timing) Then
               Call CWTime(tC1,tW1)
               iTask=5
               Work(iTime(1,iTask,iAtomPair))=tC1-tC0
               Work(iTime(2,iTask,iAtomPair))=tW1-tW0
            End If

            ! Debug option: write unconstrained coefficients to disk
            If (WriteUnconstrainedC) Then
               Call LDF_WriteUnconstrainedCoefficients(iAtomPair,l_C,
     &                                                 Work(ip_C),irc)
               If (irc.ne.0) Then
                  Call WarningMessage(2,
     &                           SecNam//': unconstrained write failed')
                  Write(6,'(A,I10)') 'irc=',irc
                  Call LDF_Quit(1)
               End If
            End If

            ! Add constraint correction to coefficients
            If (Timing) Call CWTime(tC0,tW0)
            Call LDF_AddConstraintCorrection(LDF_Constraint,iAtomPair,
     &                                       l_C,Work(ip_C))
            If (Timing) Then
               Call CWTime(tC1,tW1)
               tC_Constraint=tC_Constraint+(tC1-tC0)
               tW_Constraint=tW_Constraint+(tW1-tW0)
            End If

            ! Update diagonal from coefficients
            If (Timing) Call CWTime(tC0,tW0)
            Call LDF_RestoreDiagonal(iAtomPair)
            Call LDF_UpdateDiagonalFromC(LDF_Constraint,iAtomPair,
     &                                   l_C,Work(ip_C),irc)
            If (irc.ne.0) Then
               Write(6,'(A,A)')
     &         SecNam,
     &         ': LDF_UpdateDiagonalFromC found too negative diagonals!'
               Write(6,'(A,I10)')
     &         'Number of too negative diagonals:',irc
               Call LDF_PrintAtomPairDiagonal(iAtomPair)
               Call WarningMessage(2,'Too negative diagonals')
               irc=1
               Return
            End If
            If (Timing) Then
               Call CWTime(tC1,tW1)
               iTask=4
               Work(iTime(1,iTask,iAtomPair))=
     &                          Work(iTime(1,iTask,iAtomPair))+(tC1-tC0)
               Work(iTime(2,iTask,iAtomPair))=
     &                          Work(iTime(2,iTask,iAtomPair))+(tW1-tW0)
            End If
            ! Print diagonal information
            If (iPrint.ge.Inf_AP) Then
               Call Cho_Head('Atom Pair Diagonal Info (Final)','-',80,6)
               Call LDF_PrintAtomPairDiagonal(iAtomPair)
            End If

            ! Debug: check integrals for this atom pair
            If (CheckPairIntegrals) Then
               If (LDF_Constraint.eq.-1) Then
                  ! unconstrained LDF, use nonrobust LDF integrals
                  Call LDF_CheckPairIntegrals(2,iAtomPair,
     &                                        l_C,Work(ip_C),irc)
               Else
                  ! constrained LDF, use robust LDF integrals
                  Call LDF_CheckPairIntegrals(1,iAtomPair,
     &                                        l_C,Work(ip_C),irc)
               End If
               If (irc.ne.0) Then
                  Write(6,'(A,A,I8)')
     &            SecNam,': LDF_CheckPairIntegrals returned code',irc
                  irc=1
                  Return
               End If
            End If

            ! Zero negative diagonals
            Call LDF_CleanDiagonal(iAtomPair)

            ! Debug: verify fit for this atom pair
            If (VerifyFit) Then
               Call LDF_VerifyFit(.True.,iPrint.lt.3,LDF_Constraint,
     &                            1.0d-10,iAtomPair,l_C,Work(ip_C),irc)
               If (irc.ne.0) Then
                  Write(6,'(A,A,I8)')
     &            SecNam,': LDF_VerifyFit returned code',irc
                  irc=1
                  Return
               End If
            End If

            ! Save fitting coefficients on disk, and save disk address
            If (Timing) Call CWTime(tC0,tW0)
            Call LDF_WriteC(iAtomPair,l_C,Work(ip_C),LuC,iAddr)
            If (Timing) Then
               Call CWTime(tC1,tW1)
               iTask=6
               Work(iTime(1,iTask,iAtomPair))=tC1-tC0
               Work(iTime(2,iTask,iAtomPair))=tW1-tW0
            End If

            ! Deallocate C and Z
            Call GetMem('LDFC','Free','Real',ip_C,l_C)
            Call GetMem('ZVec','Free','Real',ip_Z,l_Z)

            If (Timing) Then
               Call CWTime(totC1,totW1)
               iTask=7
               Work(iTime(1,iTask,iAtomPair))=totC1-totC0
               Work(iTime(2,iTask,iAtomPair))=totW1-totW0
            End If

         End If
      End Do
      Call Free_Tsk(ID)

      ! Parallel: replicate data on all nodes.
      If (Timing) Call CWTime(tC0,tW0)
      Call LDF_ReplicateData(LuC,irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': LDF_ReplicateData returned code',irc
         irc=1
         Return
      End If
      If (Timing) Then
         Call CWTime(tC1,tW1)
         tC_Replicate=tC1-tC0
         tW_Replicate=tW1-tW0
      End If

      ! Copy unique atom pair info
      If (Timing) Call CWTime(tC0,tW0)
      Call LDF_CopyUniqueAtomPairs(irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': LDF_CopyUniqueAtomPairs returned code',irc
         irc=1
         Return
      End If
      If (Timing) Then
         Call CWTime(tC1,tW1)
         tC_Copy=tC1-tC0
         tW_Copy=tW1-tW0
      End If

      ! Print atom pair info
      If (iPrint.ge.Inf_AP) Then
         Call LDF_PrintAtomPairInfo()
      End If

      ! Check overlap integrals
      If (CheckOverlapIntegrals) Then
#if defined (_MOLCAS_MPP_)
         If (nProcs.gt.1 .and. Is_Real_Par()) Then
            ! Start coefficient IO utility
            Call LDF_CIO_SetUnit(0)
            Call LDF_CIO_Init(0.0d0,irc)
            If (irc.ne.0) Then
               Call WarningMessage(2,SecNam//' LDF_CIO_Init failed')
               Write(6,'(A,I10)') 'Return code=',irc
               Call LDF_Quit(1)
            End If
         End If
#endif
         Call LDF_CheckAllOverlapIntegrals(iPrint.ge.3,Tol2C,
     &                                     MAE,AB_MAE,MRNrm,AB_MRNrm)
         If (iPrint.lt.3) Then
            Call Cho_Head('Results from overlap integral check','-',80,
     &                    6)
            Write(6,'(/,2X,A,1P,D20.10,2X,A)')
     &      'Tolerance for 2C errors..',Tol2C,'(all 2C passed)'
            Write(6,'(2X,A,1P,D20.10,2X,A,I10)')
     &      'Max abs error............',MAE,'@AB=',AB_MAE
            Write(6,'(2X,A,1P,D20.10,2X,A,I10)')
     &      'Max relative norm error..',MRNrm,'@AB=',AB_MRNrm
            Call xFlush(6)
         End If
         If (LDF_Constraint.eq.0) Then ! charge constraint => ovlp exact
            If (MAE.gt.1.0d-12) Then
               Call WarningMessage(2,
     &          SecNam//': MAE too large with Charge Constraint active')
               Call LDF_Quit(1)
            End If
         End If
#if defined (_MOLCAS_MPP_)
         If (nProcs.gt.1 .and. Is_Real_Par()) Then
            ! Shut down coefficient IO utility
            Call LDF_CIO_Final()
            Call LDF_CIO_SetUnit(LuC)
         End If
#endif
      End If

      ! Unset info for constraints
      If (Timing) Call CWTime(tC0,tW0)
      Call LDF_UnsetConstraint(LDF_Constraint)
      If (Timing) Then
         Call CWTime(tC1,tW1)
         tC_Constraint=tC_Constraint+(tC1-tC0)
         tW_Constraint=tW_Constraint+(tW1-tW0)
      End If

      ! Close coefficient file
      irc=LDF_CloseC(LuC)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': LDF_CloseC returned code',irc
         irc=1
         Return
      End If
      Call LDF_CIO_SetUnit(0)

      ! Print timing
      If (Timing) Then
         Write(6,'(/,A)')
     &   'Detailed Timing of LDF Fitting Coefficient Computation:'
         Write(6,'(/,A,3X,A,3X,A,4X,A,3X,A,7X,A,9X,A,3X,A)')
     &   'Atom Pair','Compute CBar','Upd. Diagonal','Add 2C Func.',
     &   '2C Upd. Diag.','Compute C','Write C','Total AP Time'
         Write(6,'(8X,7A16)') ('     CPU    Wall',i=1,7)
         Write(6,'(120A1)') ('-',i=1,120)
         Do iAtomPair=1,NumberOfAtomPairs
            Write(6,'(I8,14(1X,F7.1))')
     &      iAtomPair,(Work(ip_T+2*nTask*(iAtomPair-1)+i),i=0,2*nTask-1)
         End Do
         Write(6,'(120A1)') ('-',i=1,120)
         Do iAtomPair=2,NumberOfAtomPairs
            Do iTask=1,nTask
               Work(iTime(1,iTask,1))=Work(iTime(1,iTask,1))
     &                               +Work(iTime(1,iTask,iAtomPair))
               Work(iTime(2,iTask,1))=Work(iTime(2,iTask,1))
     &                               +Work(iTime(2,iTask,iAtomPair))
            End Do
         End Do
         Write(6,'(A,14F8.1)') 'Sum     ',(Work(ip_T+i),i=0,2*nTask-1)
         Write(6,'(120A1)') ('-',i=1,120)
         Write(6,'(A,2(1X,F7.1))')
     &   'Constraints (CPU,Wall in s).........',
     &   tC_Constraint,tW_Constraint
         Write(6,'(A,2(1X,F7.1))')
     &   'Data Replication (CPU,Wall in s)....',
     &   tC_Replicate,tW_Replicate
         Write(6,'(A,2(1X,F7.1))')
     &   'Copy Unique Pairs (CPU,Wall in s)...',
     &   tC_Copy,tW_Copy
         Call xFlush(6)
         Call GetMem('LDFCFCT','Free','Real',ip_T,l_T)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!               Luca De Vico                                           *
!***********************************************************************

subroutine CHARGE(NSYM,NBAS,BNAME,CMO,OCCN,SMAT,iCase,FullMlk,lSave)

use SpinAV, only: Do_SpinAV, DSc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6, r8

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: NSYM, NBAS(NSYM), iCase
character(len=LenIn8), intent(in) :: BNAME(*)
real(kind=wp), intent(in) :: CMO(*), OCCN(*), SMAT(*)
logical(kind=iwp), intent(in) :: FullMlk, lSave
integer(kind=iwp) :: AtomA, AtomB, i0, iAB, iAng, iB, iBlo, i, iEnd, iix, iixx, ik, ikk, iM, iMN, IMO, IO, iPair, iPL, IS, ISING, &
                     ISMO, IST, iStart, iSum, iSwap, iSyLbl, ISYM, IT, ix, J, jAng, jEnd, jM, jx, k, l, lqSwap, MY, MYNUC, MYTYP, &
                     NB, nBas2, NBAST, nNuc, NPBonds, nScr, NXTYP, NY, NYNUC, NYTYP, tNUC
real(kind=wp) :: BO, BOThrs, DET, DMN, TCh, TERM, xsg
#ifdef _DEBUGPRINT_
real(kind=wp) :: E
#endif
logical(kind=iwp) :: DMN_SpinAV, DoBond
character(len=100) :: ProgName
character(len=8) :: TMP
integer(kind=iwp), allocatable :: center(:), ICNT(:), ITYP(:), nStab(:)
real(kind=wp), allocatable, save :: Bonds(:), Chrg(:), D(:,:), D_blo(:), D_tmp(:,:), DS(:,:), DSswap(:,:), Fac(:), P(:,:), &
                                    PInv(:,:), Q2(:), QQ(:,:), QSUM(:), QSUM_TOT(:), qSwap(:), S(:,:), S_blo(:), S_tmp(:,:), Scr(:)
character(len=LenIn4), allocatable :: LblCnt4(:)
character(len=LenIn), allocatable :: CNAME(:)
character(len=8), allocatable :: TNAME(:), TSwap(:)
character(len=*), parameter :: AufBau(19) = ['01s', &
                                             '02s','02p', &
                                             '03s','03p', &
                                             '04s','03d','04p', &
                                             '05s','04d','05p', &
                                             '06s','04f','05d','06p', &
                                             '07s','05f','06d','07p']
integer(kind=iwp), external :: iPrintLevel
real(kind=r8), external :: DDot_
logical(kind=iwp), external :: Reduce_Prt
character(len=LenIn8), external :: Clean_BName
character(len=100), external :: Get_ProgName
!character(len=4), allocatable :: TLbl(:)
!character(len=LenIn), allocatable :: LblCnt(:)
#include "angtp.fh"
#include "WrkSpc.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0

if (iCase /= 0) then
  if (iPL >= 2) then
    write(u6,*)
    call CollapseOutput(1,'   Molecular charges:')
    write(u6,'(3X,A)') '   ------------------'
    write(u6,*)
  end if
end if

xsg = -One
DMN_SpinAV = .false.
if ((iCase == 0) .or. (iCase == 1)) then
  if (Do_SpinAV) DMN_SpinAV = .true.
  if (iCase == 1) xsg = One
end if
!                                                                      *
!***********************************************************************
!                                                                      *

!----------------------------------------------------------------------*
! Get the name of the calling module.                                  *
! If CPFMCPF no bond analysis is done.                                 *
!----------------------------------------------------------------------*

ProgName = Get_ProgName()
call Upcase(ProgName)
ProgName = adjustl(ProgName)
iEnd = 1
do
  if (ProgName(iEnd:iEnd) == ' ') exit
  iEnd = iEnd+1
end do

DoBond = .true.
if (ProgName(1:iEnd) == 'CPF') DoBond = .false.

!----------------------------------------------------------------------*
! Set the Mulliken Bond Order threshold for printout                   *
!----------------------------------------------------------------------*

BOThrs = Half

!----------------------------------------------------------------------*
! GET THE TOTAL NUMBER OF BASIS FUNCTIONS                              *
!----------------------------------------------------------------------*

NBAST = 0
do I=1,NSYM
  NBAST = NBAST+NBAS(I)
end do

!----------------------------------------------------------------------*
! Find the list of unique center labels                                *
!----------------------------------------------------------------------*

call Get_iScalar('Unique atoms',nNuc)
call mma_allocate(CNAME,nNuc,label='CNAME')
call mma_allocate(nStab,nNuc,label='nStab')
call Get_cArray('Unique Atom Names',CNAME,LenIn*nNuc)
call Get_iArray('nStab',nStab,nNuc)

!----------------------------------------------------------------------*
! Find the center label for each basis function                        *
!----------------------------------------------------------------------*

call mma_allocate(ICNT,NBAST,label='ICNT')
ICNT(:) = -1
do I=1,NBAST
  do J=1,NNUC
    if (BNAME(I)(1:LenIn) == CNAME(J)) then
      ICNT(I) = J
      exit
    end if
  end do
end do

!----------------------------------------------------------------------*
! Find the type label for each basis function                          *
!----------------------------------------------------------------------*

call mma_allocate(ITYP,nBAST,label='ITYP')
ITYP(:) = 0
NXTYP = 0
outer: do I=1,NBAST
  if (ICNT(I) < 0) cycle outer  ! skip pseudo center
  do J=1,I-1
    if (BNAME(I)(LenIn1:LenIn8) == BNAME(J)(LenIn1:LenIn8)) then
      ITYP(I) = ITYP(J)
      cycle outer
    end if
  end do
  NXTYP = NXTYP+1
  ITYP(I) = NXTYP
end do outer
call mma_allocate(TNAME,NXTYP,label='TNAME')
TNAME(:) = ''
do I=1,NBAST
  J = ITYP(I)
  if (J == 0) cycle
  if (TNAME(J) /= '') cycle
  TNAME(J) = BNAME(I)(LenIn1:LenIn8)
end do

lqSwap = NNUC+NNUC*NXTYP

if (iCase == 0) then
  ! instead of printing charges we dump everything into a memory
  ! same with DS matrix

  call mma_allocate(qSwap,lqSwap,label='CHRG_SWP')

  if (DoBond) then
    call mma_allocate(DSswap,NBAST,NBAST,label='DSswap')
  end if

end if

!----------------------------------------------------------------------*
! Do some trivial sorting of the type labels                           *
!----------------------------------------------------------------------*
!
! Sort with respect to radial index

ix = 0
jx = 0
do i=1,NxTyp-1
  ix = ichar(TNAME(i)(1:1))-ichar('1')+1
  ix = 10*ix+ichar(TNAME(i)(2:2))-ichar('1')+1
  ! Put polarization and diffuse functions last
  if (tName(i)(1:1) == '*') ix = 100
  do j=i+1,NxTyp
    jx = ichar(TNAME(j)(1:1))-ichar('1')+1
    jx = 10*jx+ichar(TNAME(j)(2:2))-ichar('1')+1
    if (tName(j)(1:1) == '*') jx = 100
    if (ix > jx) then
      iSwap = ix
      ix = jx
      jx = iSwap
      TMP = TNAME(i)
      TNAME(i) = TNAME(j)
      TNAME(j) = TMP
    end if
  end do
end do

! Sort with respect to angular index

iAng = 0
jAng = 0
ix = 1
do
  iix = ichar(tName(ix)(1:1))
  iixx = ichar(tName(ix)(2:2))
  jx = ix
  do i=min(ix+1,NxTyp),NxTyp
    if ((ichar(tName(i)(1:1)) == iix) .and. (ichar(tName(i)(2:2)) == iixx)) jx = i
  end do

  do i=ix,jx-1
    do k=0,iTabMx
      if (AngTp(k) == tName(i)(3:3)) iAng = k
    end do
    do j=i+1,jx
      do l=0,iTabMx
        if (AngTp(l) == tName(j)(3:3)) jAng = l
      end do
      if (iAng > jAng) then
        iSwap = iAng
        iAng = jAng
        jAng = iSwap
        TMP = TNAME(i)
        TNAME(i) = TNAME(j)
        TNAME(j) = TMP
      end if
    end do
  end do
  !write(u6,*) ' Sorted n subrange'
  !do i=ix,jx
  !  write(u6,*) TName(i)
  !end do

  ! Now sort with respect to the magnetic index

  iEnd = jx
  iStart = ix
  do
    do k=0,iTabMx
      if (AngTp(k) == tName(iStart)(3:3)) iAng = k
    end do
    jEnd = iStart
    do i=min(iStart+1,iEnd),iEnd
      if (tName(i)(3:3) == AngTp(iAng)) jEnd = i
    end do

    i0 = ichar('1')-1

    iM = 0
    jM = 0
    if (iAng == 1) then
      do i=iStart,jEnd-1
        if (tName(i)(4:4) == 'x') iM = 1
        if (tName(i)(4:4) == 'z') iM = 0
        if (tName(i)(4:4) == 'y') iM = -1
        do j=i+1,jEnd
          if (tName(j)(4:4) == 'x') jM = 1
          if (tName(j)(4:4) == 'z') jM = 0
          if (tName(j)(4:4) == 'y') jM = -1
          if (jM > iM) then
            iSwap = iM
            iM = jM
            jM = iSwap
            TMP = TNAME(i)
            TNAME(i) = TNAME(j)
            TNAME(j) = TMP
          end if
        end do
      end do
    else if (iAng >= 2) then
      do i=iStart,jEnd-1
        iM = ichar(tName(i)(4:4))-i0
        iM = 10*iM+ichar(tName(i)(5:5))-i0
        if (tName(i)(6:6) == '-') iM = -iM
        do j=i+1,jEnd
          jM = ichar(tName(j)(4:4))-i0
          jM = 10*jM+ichar(tName(j)(5:5))-i0
          if (tName(j)(6:6) == '-') jM = -jM
          if (jM > iM) then
            iSwap = iM
            iM = jM
            jM = iSwap
            TMP = TNAME(i)
            TNAME(i) = TNAME(j)
            TNAME(j) = TMP
          end if
        end do
      end do
    end if

    if (jEnd == iEnd) exit
    iStart = jEnd+1
  end do

  if (jx == NxTyp) exit
  ix = jx+1
end do

! Sort according to AufBau

call mma_allocate(TSwap,NxTyp,label='TSwap')
iStart = 1
do iAB=1,19
  do i=1,NxTyp
    if (TName(i)(1:3) == AufBau(iAB)) then
      TSwap(iStart) = TName(i)
      TName(i) = '        '
      iStart = iStart+1
    end if
  end do
end do
do i=1,NxTyp
  if (TName(i) /= '        ') then
    TSwap(iStart) = TName(i)
    TName(i) = '        '
    iStart = iStart+1
  end if
end do
TName(:) = TSwap(:)
call mma_deallocate(TSwap)

do I=1,NBAST
  if (ICNT(I) < 0) cycle  ! skip pseudo center
  do J=1,NXTYP
    if (BNAME(I)(LenIn1:LenIn8) == TNAME(J)) then
      ITYP(I) = J
      exit
    end if
  end do
end do

!----------------------------------------------------------------------*
! Get the total number of atoms tNUC, regardless of symmetry           *
!----------------------------------------------------------------------*

call Get_iScalar('LP_nCenter',tNUC)

!----------------------------------------------------------------------*
! Bond analysis initialization                                         *
!----------------------------------------------------------------------*

if (DoBond) then

!----------------------------------------------------------------------*
! In case of symmetry we need the desymmetrization matrix,             *
! for the bond order calculation only.                                 *
!----------------------------------------------------------------------*

  if (nSym > 1) then

    call mma_allocate(P,NBAST,NBAST,label='P')
    call mma_allocate(PInv,NBAST,NBAST,label='PInv')
    call Get_dArray('SM',P,NBAST**2)
#ifdef _DEBUGPRINT_
    call RecPrt('SM',' ',P,NBAST,NBAST)
#endif
    call MINV(P,PInv,ISING,DET,NBAST)
#ifdef _DEBUGPRINT_
    call RecPrt('SMInv',' ',PInv,NBAST,NBAST)
#endif
    call DGeTMi(PInv,NBAST,NBAST)
  end if

  ! Pick up index array of which center a basis function belongs to.
  ! If no symmetry, it is the same as ICNT(I).

  call mma_allocate(center,NBAST,label='center')
  call Get_iArray('Center Index',center,NBAST)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !--------------------------------------------------------------------*
  ! Initialize symmetric density D_tmp and overlap S_tmp matrices,     *
  ! block D_blo and S_blo matrices (if symmetry)                       *
  ! plus asymmetric D, S and DS matrices                               *
  !--------------------------------------------------------------------*

  call mma_allocate(D_tmp,NBAST,NBAST,label='D_tmp')
  call mma_allocate(S_tmp,NBAST,NBAST,label='S_tmp')
  call mma_allocate(D,NBAST,NBAST,label='D')
  call mma_allocate(S,NBAST,NBAST,label='S')
  call mma_allocate(DS,NBAST,NBAST,label='DS')
  D_tmp(:,:) = Zero
  S_tmp(:,:) = Zero
  D(:,:) = Zero
  S(:,:) = Zero
  DS(:,:) = Zero

  if (nSym > 1) then
    nBas2 = 0
    do I=1,nsym
      nBas2 = nBas2+nBas(i)*nBas(i)
    end do
    call mma_allocate(D_blo,nBas2,label='D_blo')
    call mma_allocate(S_blo,nBas2,label='S_blo')
    D_blo(:) = Zero
    S_blo(:) = Zero
  end if

  !--------------------------------------------------------------------*
  !   Find the center label for each atom, regardless of symmetry      *
  !--------------------------------------------------------------------*

  ! Just atom label. It's a double of the next one,
  ! but someone could find it usefull in future

  !call Get_LblCnt_All(TLbl)

  ! Atom labels plus symmetry generator

  call mma_allocate(LblCnt4,tNUC,label='LblCnt4')
  call Get_cArray('LP_L',LblCnt4,LenIn4*tNUC)
  !do i=1,tNUC
  !  LblCnt(i)(1:LenIn) = LblCnt4(i)(1:LenIn)
  !end do

  !--------------------------------------------------------------------*
  ! Initialize bond order vector                                       *
  !--------------------------------------------------------------------*

  NPBonds = tNUC*(tNUC-1)/2
  call mma_allocate(Bonds,NPBonds,label='Bonds')
  Bonds(:) = Zero

  !--------------------------------------------------------------------*
  ! End of Bond analysis initialization                                *
  !--------------------------------------------------------------------*

end if

!----------------------------------------------------------------------*
! Compute Mulliken atomic charges for each center and basis            *
! function type                                                        *
!----------------------------------------------------------------------*

call mma_allocate(QQ,NXTYP,NNUC,label='QQ')
QQ(:,:) = Zero
IB = 0
IS = 0
IMO = 0
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  if (NB /= 0) then
    IMN = 0
    do MY=1,NB
      do NY=1,MY
        IMN = IMN+1
        DMN = Zero
        ISMO = IMO
        do IO=1,NB
          DMN = DMN+OCCN(IO+IB)*CMO(ISMO+MY)*CMO(ISMO+NY)
          ISMO = ISMO+NB
        end do

        if (DMN_SpinAV) then
          DMN = DMN+xsg*DSc((NY-1)*NB+MY+IMO)
        end if

        if (DoBond) then
          ! Save the Density matrix element (my,ny) and (ny,my) in D_tmp
          ! Save the Overlap matrix element (my,ny) and (ny,my) in S_tmp
          D_tmp(MY+IB,NY+IB) = DMN
          D_tmp(NY+IB,MY+IB) = DMN
          S_tmp(MY+IB,NY+IB) = SMAT(IMN+IS)
          S_tmp(NY+IB,MY+IB) = SMAT(IMN+IS)
        end if

        if (MY /= NY) DMN = Two*DMN
        MYNUC = ICNT(MY+IB)
        NYNUC = ICNT(NY+IB)
        MYTYP = ITYP(MY+IB)
        NYTYP = ITYP(NY+IB)
        if (MY == NY) then
          TERM = SMAT(IMN+IS)*DMN
          if (MYNUC > 0) QQ(MYTYP,MYNUC) = QQ(MYTYP,MYNUC)+TERM
        else
          TERM = Half*SMAT(IMN+IS)*DMN
          if (MYNUC > 0) QQ(MYTYP,MYNUC) = QQ(MYTYP,MYNUC)+TERM
          if (NYNUC > 0) QQ(NYTYP,NYNUC) = QQ(NYTYP,NYNUC)+TERM
        end if
      end do
    end do
    IB = IB+NB
    IS = IS+(NB+NB**2)/2
    IMO = IMO+NB**2
  end if
end do

!----------------------------------------------------------------------*
! Density and overlap matrix handling for bond order                   *
!----------------------------------------------------------------------*

if (DoBond) then

# ifdef _DEBUGPRINT_
  call RecPrt('Density Matrix = ',' ',D_tmp,NBAST,NBAST)
  call RecPrt('Overlap Matrix = ',' ',S_tmp,NBAST,NBAST)
  E = Zero
  do I=1,NBAST
    do J=1,NBAST
      E = E+D_tmp(I,J)*S_tmp(I,J)
    end do
  end do
  write(u6,*)
  write(u6,*) 'Number of electrons as sum of D and S elements = ',E
# endif

  ! In case of symmetry, we desymmetrize D and S through D_blo and S_blo

  if (nSym > 1) then
    iBlo = 1
    iSum = 0
    do i=1,NSYM
      if (nbas(i) /= 0) then
        do j=1,nbas(i)
          do k=1,nbas(i)
            D_blo(iBlo) = D_tmp(iSum+k,iSum+j)
            S_blo(iBlo) = S_tmp(iSum+k,iSum+j)
            iBlo = iBlo+1
          end do
        end do
        iSum = iSum+nbas(i)
      end if
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*) 'D_blo = '
    do i=1,nBas2
      write(u6,*) D_blo(I)
    end do
    write(u6,*) 'S_blo = '
    do i=1,nBas2
      write(u6,*) S_blo(I)
    end do
#   endif

    nScr = NBAST**2
    iSyLbl = 1
    call mma_allocate(Scr,nScr,label='Scr')
    call Desymmetrize(D_blo,nBas2,Scr,nScr,D,nBas,NBAST,P,nSym,iSyLbl)
    call Desymmetrize(S_blo,nBas2,Scr,nScr,S,nBas,NBAST,PInv,nSym,iSyLbl)
    call mma_deallocate(Scr)

    ! Otherwise we simply copy D and S tmp into D and S

  else
    D(:,:) = D_tmp(:,:)
    S(:,:) = S_tmp(:,:)
  end if

# ifdef _DEBUGPRINT_
  write(u6,*) 'After Desymmetrization'
  !call RecPrt('Density Matrix = ',' ',D,NBAST,NBAST)
  !call RecPrt('Overlap Matrix = ',' ',S,NBAST,NBAST)
  write(u6,*) 'Dens=',DDot_(nBast**2,D,1,D,1),DDot_(nBast**2,D,1,[One],0)
  write(u6,*) 'Ovrl=',DDot_(nBast**2,S,1,S,1),DDot_(nBast**2,S,1,[One],0)
  write(u6,*) 'DO  =',DDot_(nBast**2,S,1,D,1)
  E = Zero
  do I=1,NBAST
    do J=1,NBAST
      E = E+D(I,J)*S(I,J)
    end do
  end do
  write(u6,*)
  write(u6,*) 'Number of electrons as sum of D by S elements = ',E
# endif

  ! Finally, we compute the DS matrix as product of D and S

  call DGEMM_('N','N',NBAST,NBAST,NBAST,One,D,NBAST,S,NBAST,Zero,DS,NBAST)

# ifdef _DEBUGPRINT_
  call RecPrt('DS Matrix = ',' ',DS,NBAST,NBAST)
  E = Zero
  do I=1,NBAST
    E = E+DS(I,I)
  end do
  write(u6,*)
  write(u6,*) 'Number of electrons as sum of the DS diagonal = ',E
# endif

  ! in case of first call for UHF we dump everything only

  if (iCase == 0) then
    DSswap(:,:) = DS(:,:)
  end if

  ! in case of second call for UHF we add what dumped before
  ! and release swap memory

  if (iCase == 1) then
    DS(:,:) = DS(:,:)+DSswap(:,:)
    call mma_deallocate(DSswap)

#   ifdef _DEBUGPRINT_
    call RecPrt('DS Matrix = ',' ',DS,NBAST,NBAST)
    E = Zero
    do I=1,NBAST
      E = E+DS(I,I)
    end do
    write(u6,*)
    write(u6,*) 'Number of electrons as sum of the DS diagonal = ',E
#   endif

  end if

end if

!----------------------------------------------------------------------*
! Compute gross atomic charges                                         *
!----------------------------------------------------------------------*

call mma_allocate(QSUM,nNuc,label='QSUM')
call mma_allocate(QSUM_TOT,nNuc,label='QSUM_TOT')
QSUM(:) = Zero
do I=1,NNUC
  do J=1,NXTYP
    QSUM(I) = QSUM(I)+QQ(J,I)
  end do
end do
! if iCase=0, or 1 we need to put/get QSUM
if (iCase == 0) then
  qSwap(1:NNUC) = QSUM(:)
else if (iCase == 1) then
  QSUM_TOT(:) = QSUM(:)+qSwap(1:NNUC)
else if (iCase >= 2) then
  QSUM_TOT(:) = QSUM(:)
end if

!----------------------------------------------------------------------*
! Pick up the nuclear charge                                           *
!----------------------------------------------------------------------*

if (iCase /= 0) then
  call mma_allocate(Chrg,nNuc,label='Chrg')
  call Get_dArray('Effective nuclear charge',Chrg,nNuc)
  Chrg(:) = Chrg(:)*real(nSym/nStab(:),kind=wp)-QSUM_TOT(:)
  if (lSave) call Put_dArray('Mulliken Charge',Chrg,nNuc)
end if

!----------------------------------------------------------------------*
! Compute the 'Mulliken' Bond Order                                    *
!----------------------------------------------------------------------*

if (DoBond .and. (tNUC > 1) .and. (iCase >= 1)) then

# ifdef _DEBUGPRINT_
  write(u6,*) 'nPBonds,tNuc=',nPBonds,tNuc
  do MY=1,NBAST
    AtomA = center(MY)
    write(u6,*) 'AtomA,My=',AtomA,My
  end do
# endif
  do MY=1,NBAST
    AtomA = center(MY)
    if (ICNT(MY) <= 0) cycle    ! skip pseudo center
    do NY=1,MY
      AtomB = center(NY)
      if (ICNT(NY) <= 0) cycle  ! skip pseudo center
      if (AtomA == AtomB) cycle ! same atom

      iPair = (max(AtomA,AtomB)-1)*(max(AtomA,AtomB)-2)/2+min(AtomA,AtomB)

      Bonds(iPair) = Bonds(iPair)+DS(MY,NY)*DS(NY,MY)

#     ifdef _DEBUGPRINT_
      write(u6,*) 'Bond Number=',iPair
      write(u6,*) 'Atom numbers = ',AtomA,AtomB
      write(u6,*) 'Bond number = ',iPair,'bond order = ',Bonds(iPair)
      write(u6,*) 'DS(MY,NY) =',DS(MY,NY)
      write(u6,*) 'DS(NY,MY) =',DS(NY,MY)
#     endif
    end do
  end do

  ! distant atoms could have negative bond order, set to zero

  do I=1,NPBonds
    if (Bonds(I) < Zero) Bonds(I) = Zero
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) 'Bond order vector'
  call TriPrt('Bonds','(10F10.5)',Bonds,tNUC-1)
# endif

end if

!----------------------------------------------------------------------*
! Printout section                                                     *
!----------------------------------------------------------------------*

call mma_allocate(Fac,nNuc,label='Fac')
Fac(:) = real(nStab(:),kind=wp)/real(nSym,kind=wp)

if (iCase == 0) then
  ! first call for UHF, so just dump numbers to swap
  IEND = 0
  ik = 1
  do IST=1,NNUC,6
    IEND = min(IEND+6,NNUC)
    do IT=1,NXTYP
      do j=IST,IEND
        qSwap(NNUC+ik) = QQ(IT,J)
        ik = ik+1
      end do
    end do
  end do
end if

if ((iCase == 1) .and. (iPL >= 2)) then
  ! second call, make a real print out
  if (FullMlk) then
    write(u6,'(6X,A)') 'Mulliken charges per centre and basis function type'
    write(u6,'(6X,A)') '---------------------------------------------------'
  else
    write(u6,'(6X,A)') 'Mulliken charges per centre'
    write(u6,'(6X,A)') '---------------------------'
  end if
  IEND = 0
  ik = 1
  ikk = 1
  call mma_allocate(Q2,nNuc,label='Q2')
  do IST=1,nNuc,6
    IEND = min(IEND+6,nNuc)
    write(u6,*)
    write(u6,'(14X,6(14X,A,4X))') (CNAME(I),I=IST,IEND)
    write(u6,'(14X,6(A12,A12))') (' alpha','  beta',I=IST,IEND)
    do IT=1,NXTYP
      do J=IST,IEND
        Q2(J) = qSwap(NNUC+ik)
        ik = ik+1
      end do
      if (FullMlk) then
        write(u6,'(5X,A8,12F12.4)') Clean_BName(TNAME(IT),0),(Fac(j)*Q2(J),Fac(j)*QQ(IT,J),J=IST,IEND)
      end if
    end do

    do J=IST,IEND
      Q2(J) = qSwap(ikk)
      ikk = ikk+1
    end do

    write(u6,'(6X,A,12F12.4)') 'Total  ',(Fac(i)*Q2(I),Fac(i)*QSUM(I),I=IST,IEND)
    write(u6,'(6X,A,6(6X,F12.4,6X))') 'Total  ',(Fac(i)*(Q2(I)+QSUM(I)),I=IST,IEND)
    write(u6,*)
    write(u6,'(6X,A,6(5X,F12.4,7X))') 'Charge ',(Fac(i)*Chrg(I),I=IST,IEND)
  end do
  call mma_deallocate(Q2)
  write(u6,*)
  write(u6,'(6X,A,F12.6)') 'Total electronic charge=',DDot_(nNuc,[One],0,QSum_TOT,1)
  write(u6,*)
  write(u6,'(6X,A,F12.6)') 'Total            charge=',DDot_(nNuc,[One],0,Chrg,1)

end if
if (iCase == 1) then
  call mma_deallocate(Chrg)
  call mma_deallocate(qSwap)
end if

if (((iCase == 2) .and. (iPL >= 2)) .or. ((iCase == 3) .and. (iPL >= 2))) then
  ! icase=2 for usual mulliken, =2 for spin population.

  if (FullMlk) then
    if (iCase == 2) then
      write(u6,'(6X,A)') 'Mulliken charges per centre and basis function type'
    else
      write(u6,'(6X,A)') 'Mulliken spin population per centre and basis function type'
    end if
    write(u6,'(6X,A)') '---------------------------------------------------'
  else
    if (iCase == 2) then
      write(u6,'(6X,A)') 'Mulliken charges per centre'
    else
      write(u6,'(6X,A)') 'Mulliken spin population per centre'
    end if
    write(u6,'(6X,A)') '---------------------------'
  end if

  IEND = 0
  do IST=1,nNuc,12
    IEND = min(IEND+12,nNuc)
    write(u6,*)
    write(u6,'(14X,12(2X,A))') (CNAME(I),I=IST,IEND)
    if (FullMlk) then
      do IT=1,NXTYP
        write(u6,'(5X,A8,12F8.4)') Clean_BName(TNAME(IT),0),(Fac(j)*QQ(IT,J),J=IST,IEND)
      end do
    end if
    write(u6,'(6X,A,12F8.4)') 'Total  ',(Fac(i)*QSUM(I),I=IST,IEND)
    if (iCase /= 3) then
      write(u6,*)
      write(u6,'(6X,A,12F8.4)') 'N-E    ',(Fac(i)*Chrg(I),I=IST,IEND)
    end if
  end do
  if (iCase == 3) then
    write(u6,*)
    write(u6,'(6X,A,F12.6)') 'Total electronic spin=',DDot_(nNuc,[One],0,QSum,1)
  else
    write(u6,*)
    write(u6,'(6X,A,F12.6)') 'Total electronic charge=',DDot_(nNuc,[One],0,QSum,1)
    write(u6,*)
    TCh = DDot_(nNuc,[One],0,Chrg,1)
    write(u6,'(6X,A,F12.6)') 'Total            charge=',DDot_(nNuc,[One],0,Chrg,1)
    call xml_dDump('FormalCharge','Total charge','a.u',0,[TCh],1,1)
  end if
end if
if (iCase >= 2) then
  call mma_deallocate(Chrg)
end if

! Mulliken bond order print

if (iPL > 2) then
  if ((iCase >= 1) .and. (iCase <= 2) .and. (tNUC > 1) .and. DoBond) then
    write(u6,*)
    write(u6,'(6X,A)') 'Mulliken Bond Order analysis'
    write(u6,'(6X,A)') '----------------------------'
    write(u6,'(6X,A,F5.3,A)') 'Only bonds with order larger than ',BOThrs,' are printed'
    write(u6,*)
    if (nSym > 1) then
      write(u6,'(8X,A)') 'Atom A:Gen.   Atom B:Gen.   Bond Order'
    else
      write(u6,'(8X,A)') 'Atom A        Atom B        Bond Order'
    end if
    do I=1,tNUC-1
      do J=I+1,tNUC
        iPair = (J-1)*(J-2)/2+I
        BO = Bonds(iPair)
        if (BO >= BOThrs) then
          write(u6,'(8X,2(A,4X),F7.3)') LblCnt4(I),LblCnt4(J),BO
        end if
      end do
    end do
    write(u6,*)
  end if
end if

if (iCase /= 0) then
  if (iPL >= 2) then
    call CollapseOutput(0,'   Molecular charges:')
    write(u6,*)
  end if
end if

if (DoBond) then
  if (nSym > 1) then
    call mma_deallocate(P)
    call mma_deallocate(PInv)
    call mma_deallocate(D_blo)
    call mma_deallocate(S_blo)
  end if
  call mma_deallocate(LblCnt4)
  call mma_deallocate(center)
  call mma_deallocate(D_tmp)
  call mma_deallocate(S_tmp)
  call mma_deallocate(D)
  call mma_deallocate(S)
  call mma_deallocate(DS)
  call mma_deallocate(bonds)
end if
call mma_deallocate(CNAME)
call mma_deallocate(nStab)
call mma_deallocate(ICNT)
call mma_deallocate(ITYP)
call mma_deallocate(TNAME)
call mma_deallocate(QQ)
call mma_deallocate(QSUM)
call mma_deallocate(QSUM_TOT)
call mma_deallocate(Fac)

return

end subroutine CHARGE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2006  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MKRPTORB(FIFA,NFIFA,TORB,NTORB,CMO,NCMO)
      use fciqmc_interface, only: DoFCIQMC, NonDiagonal
      use caspt2_global, only: LUCIEX, IDCIEX, IDTCEX
      use stdalloc, only: mma_allocate, mma_deallocate
#if defined(_DMRG_)
      use qcmaquis_interface, only: c_bool, c_int,
     &                              qcmaquis_interface_rotate_rdms
      use caspt2_module, only: DMRG
#endif
#if defined (_ENABLE_BLOCK_DMRG_) || defined (_DMRG_)
      use caspt2_module, only: jState, nAshT
#endif
      use caspt2_module, only: iSCF, nConf, nOMx,
     &                         nState, nSym, STSym, nIsh, nAsh, nRas1,
     &                         nRas2, nRas3, nSsh, nOrb, nBas, nFro,
     &                         EPS, EPSI, EPSA, nDel, nAES,
     &                         EPSE
#if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_)
      use caspt2_module, only: DoCumulant
#endif
      IMPLICIT NONE
C Transform to orbitals that diagonalize the diagonal
C blocks of FIFA. Affected data sets are CMO,
C EPS, EPSI, EPSA, and EPSE. Also, the CI arrays are
C transformed on file LUCIEX. Note: FIFA is unchanged
C and is not valid for the new orbitals. It will be
C recomputed later.
C The transformation matrices are returned in TORB.
      INTEGER, INTENT(IN) :: NFIFA,NTORB,NCMO
      REAL*8, INTENT(IN) :: FIFA(NFIFA)
* -------------------------------------------
      REAL*8, INTENT(OUT) :: TORB(NTORB)
      REAL*8, INTENT(INOUT) :: CMO(NCMO)

C     indices
      INTEGER I,II,IST,ISYM,ISTART
      INTEGER ITO,ITOSTA,ITOEND
      INTEGER ICMOSTA,ICMOEND
      INTEGER IDR,IDW
      INTEGER IEPS,IEPSI,IEPSA,IEPSE
      INTEGER IOSTA,IOEND
      INTEGER NFOCK,NFES
#if defined(_ENABLE_BLOCK_DMRG_) || defined(_DMRG_)
      INTEGER NXMAT
      REAL*8, ALLOCATABLE:: XMAT(:)
#endif
C     #orbitals per symmetry
      INTEGER NI,NA,NR1,NR2,NR3,NS,NO,NB
      INTEGER NSCT,NCMOSCT
C     work-arrays
      REAL*8, ALLOCATABLE:: FOCK(:), CMO2(:), CI(:)


* Allocate space for temporary square Fock matrix in each symmetry:
* NBMX=Max number of basis functions in any symmetry, in common in caspt2_module.F90
      NFOCK=NOMX**2
      CALL mma_allocate(FOCK,NFOCK,LABEL='FOCK')
* Allocate space for new CMO coefficients:
      CALL mma_allocate(CMO2,NCMO,LABEL='CMO2')

* In the loop over symmetries, NFES is the nr of Fock matrix
* elements processed in earlier symmetries.
      NFES=0
      IEPS=0
      IEPSI=0
      IEPSA=0
      IEPSE=0
* The transformation matrices for each symmetry
* will be collected into TORB and returned. This is
* necessary for later backtransformation to original
* MO basis.
* ITOSTA,ITOEND: Section of TORB for each subspace.
      ITOEND=0
* ICMOSTA,ICMOEND: Section of CMO for each subspace.
      ICMOEND=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NR1=NRAS1(ISYM)
        NR2=NRAS2(ISYM)
        NR3=NRAS3(ISYM)
        NS=NSSH(ISYM)
        NO=NORB(ISYM)
        NB=NBAS(ISYM)
* Put Fock matrix in square format in FOCK
        IF(NO.GT.0) THEN
        CALL SQUARE(FIFA(NFES+1),FOCK,NO,1,NO)
        END IF
        ! the zero-ing out of the off-diagonal blocks happens here
        ! diafck is not structured like rasscf/fckpt2.f
* Number of orbitals processed so far in this symmetry:
        IOEND=0
* Frozen orbitals: Just copy frozen CMO coefficients.
        NSCT=NFRO(ISYM)
        IF(NSCT.GT.0) THEN
         NCMOSCT=NBAS(ISYM)*NSCT
         ICMOSTA=ICMOEND+1
         ICMOEND=ICMOEND+NCMOSCT
         CALL DCOPY_(NCMOSCT,CMO(ICMOSTA),1,CMO2(ICMOSTA),1)
        END IF
* Inactive block: Section length NSCT=NISH(ISYM)
        NSCT=NISH(ISYM)
        IF(NSCT.GT.0) THEN
         IOSTA=IOEND+1
         IOEND=IOEND+NSCT
         NCMOSCT=NBAS(ISYM)*NSCT
         ICMOSTA=ICMOEND+1
         ICMOEND=ICMOEND+NCMOSCT
         ITOSTA=ITOEND+1
         ITOEND=ITOEND+NSCT**2
         CALL DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),
     &               NB,CMO(ICMOSTA),CMO2(ICMOSTA))
         DO I=1,NSCT
          II=IOSTA-1+I
          IEPS=IEPS+1
          EPS(IEPS)=FOCK(II+NO*(II-1))
          IEPSI=IEPSI+1
          EPSI(IEPSI)=EPS(IEPS)
         END DO
        END IF
* RAS1 block: Section length NSCT=NRAS1(ISYM)
        NSCT=NRAS1(ISYM)
        IF(NSCT.GT.0) THEN
         IOSTA=IOEND+1
         IOEND=IOEND+NSCT
         NCMOSCT=NBAS(ISYM)*NSCT
         ICMOSTA=ICMOEND+1
         ICMOEND=ICMOEND+NCMOSCT
         ITOSTA=ITOEND+1
         ITOEND=ITOEND+NSCT**2
         CALL DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),
     &               NB,CMO(ICMOSTA),CMO2(ICMOSTA))
         DO I=1,NSCT
          II=IOSTA-1+I
          IEPS=IEPS+1
          EPS(IEPS)=FOCK(II+NO*(II-1))
          IEPSA=IEPSA+1
          EPSA(IEPSA)=EPS(IEPS)
         END DO
        END IF
* RAS2 block: Section length NSCT=NRAS2(ISYM)
        NSCT=NRAS2(ISYM)
        IF(NSCT.GT.0) THEN
         IOSTA=IOEND+1
         IOEND=IOEND+NSCT
         NCMOSCT=NBAS(ISYM)*NSCT
         ICMOSTA=ICMOEND+1
         ICMOEND=ICMOEND+NCMOSCT
         ITOSTA=ITOEND+1
         ITOEND=ITOEND+NSCT**2
         CALL DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),
     &               NB,CMO(ICMOSTA),CMO2(ICMOSTA))
         DO I=1,NSCT
          II=IOSTA-1+I
          IEPS=IEPS+1
          EPS(IEPS)=FOCK(II+NO*(II-1))
          IEPSA=IEPSA+1
          EPSA(IEPSA)=EPS(IEPS)
         END DO
        END IF
* RAS3 block: Section length NSCT=NRAS3(ISYM)
        NSCT=NRAS3(ISYM)
        IF(NSCT.GT.0) THEN
         IOSTA=IOEND+1
         IOEND=IOEND+NSCT
         NCMOSCT=NBAS(ISYM)*NSCT
         ICMOSTA=ICMOEND+1
         ICMOEND=ICMOEND+NCMOSCT
         ITOSTA=ITOEND+1
         ITOEND=ITOEND+NSCT**2
         CALL DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),
     &               NB,CMO(ICMOSTA),CMO2(ICMOSTA))
         DO I=1,NSCT
          II=IOSTA-1+I
          IEPS=IEPS+1
          EPS(IEPS)=FOCK(II+NO*(II-1))
          IEPSA=IEPSA+1
          EPSA(IEPSA)=EPS(IEPS)
         END DO
        END IF
* Secondary (virtual) block: Section length NSCT=NSSH(ISYM)
        NSCT=NSSH(ISYM)
        IF(NSCT.GT.0) THEN
         IOSTA=IOEND+1
         IOEND=IOEND+NSCT
         NCMOSCT=NBAS(ISYM)*NSCT
         ICMOSTA=ICMOEND+1
         ICMOEND=ICMOEND+NCMOSCT
         ITOSTA=ITOEND+1
         ITOEND=ITOEND+NSCT**2
         CALL DIAFCK(NO,FOCK,IOSTA,IOEND,TORB(ITOSTA),
     &               NB,CMO(ICMOSTA),CMO2(ICMOSTA))
         DO I=1,NSCT
          II=IOSTA-1+I
          IEPS=IEPS+1
          EPS(IEPS)=FOCK(II+NO*(II-1))
          IEPSE=IEPSE+1
          EPSE(IEPSE)=EPS(IEPS)
         END DO
        END IF
* Deleted orbitals: Just copy deleted CMO coefficients.
        NSCT=NDEL(ISYM)
        IF(NSCT.GT.0) THEN
         NCMOSCT=NBAS(ISYM)*NSCT
         ICMOSTA=ICMOEND+1
         ICMOEND=ICMOEND+NCMOSCT
         CALL DCOPY_(NCMOSCT,CMO(ICMOSTA),1,CMO2(ICMOSTA),1)
        END IF

        NFES=NFES+(NO*(NO+1))/2

      END DO

* Actually, we will not use the old CMO array any more, so just
* overwrite it with the new ones and get rid of the allocated array.
      CALL DCOPY_(NCMO,CMO2,1,CMO,1)
      CALL mma_deallocate(CMO2)
* We will not use the Fock matrix either. It was just used temporarily
* for each turn of the symmetry loop. Skip it.
      CALL mma_deallocate(FOCK)

C Finally, loop again over symmetries, transforming the CI:
      IF(ISCF.EQ.0) THEN
#ifdef _DMRG_
        if (DMRG) then
          NXMAT=NASHT**2
          CALL mma_allocate(XMAT,NXMAT,LABEL='XMAT')
          XMAT(:)=0.0D0
          CALL MKXMAT(TORB,XMAT)

          CALL qcmaquis_interface_rotate_rdms(int(JSTATE-1, c_int),
     &      int(JSTATE-1, c_int), int(0, c_int), XMAT,
     &      logical(.false., c_bool))
          do I=1,NSTATE
            if (JSTATE .ne. I) then
              write(6,*) "QCMaquis> Rotating tRDMs", JSTATE-1, I-1
            CALL qcmaquis_interface_rotate_rdms(int(JSTATE-1, c_int),
     &          int(I-1, c_int), int(0, c_int), XMAT,
     &          logical(.false., c_bool))
            end if
          end do
          CALL mma_deallocate(XMAT)
          end if
#endif

        if (DoFCIQMC) then
          if (NonDiagonal) then
           write(6,*)'Transforming CASPT2 intermediates to '//
     &               'pseudo-canonical orbitals.'
          else
            write(6,*)'FCIQMC-CASPT2 assumes pseudo-canonical orbitals.'
          end if
        else
#if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_)
          IF(.NOT.DoCumulant) THEN
#endif
            CALL mma_allocate(CI,NCONF,Label='CI')
            IDR=IDCIEX
            IDW=IDTCEX
            DO IST=1,NSTATE
             CALL DDAFILE(LUCIEX,2,CI,NCONF,IDR)
             ITOEND=0
             DO ISYM=1,NSYM
              NI=NISH(ISYM)
              NA=NASH(ISYM)
              NR1=NRAS1(ISYM)
              NR2=NRAS2(ISYM)
              NR3=NRAS3(ISYM)
              NS=NSSH(ISYM)
              NO=NORB(ISYM)
              NB=NBAS(ISYM)
              ITOSTA=ITOEND+1
              ITOEND=ITOEND+NI**2+NR1**2+NR2**2+NR3**2+NS**2

              ITO=ITOSTA+NI**2
              IF(NA.GT.0) THEN
                IF(NR1.GT.0) THEN
                  ISTART=NAES(ISYM)+1
                  CALL TRACI_RPT2(ISTART,NR1,TORB(ITO),STSYM,NCONF,CI)
                END IF
                ITO=ITO+NR1**2
                IF(NR2.GT.0) THEN
                  ISTART=NAES(ISYM)+NR1+1
                  CALL TRACI_RPT2(ISTART,NR2,TORB(ITO),STSYM,NCONF,CI)
                END IF
                ITO=ITO+NR2**2
                IF(NR3.GT.0) THEN
                  ISTART=NAES(ISYM)+NR1+NR2+1
                  CALL TRACI_RPT2(ISTART,NR3,TORB(ITO),STSYM,NCONF,CI)
                END IF
              END IF
             END DO
             CALL DDAFILE(LUCIEX,1,CI,NCONF,IDW)
            END DO
            CALL mma_deallocate(CI)
#ifdef _ENABLE_BLOCK_DMRG_
          ELSE
* Transforming 2,3-RDMs from Block DMRG (1-RDM is computed from 2-RDM)
* NN.14 : For the time, Block's dump files of RDMs are directly loaded,
*         but those should be stored in JobIph file eventually.
          NXMAT=NASHT**2
* Workspace for transformation matrix
            CALL mma_allocate(XMAT,NXMAT,LABEL='XMAT')
            XMAT(:)=0.0D0
            CALL MKXMAT(TORB,XMAT)

            CALL block_tran2pdm(NASHT,XMAT,JSTATE,JSTATE)
            CALL block_tran3pdm(NASHT,XMAT,JSTATE,JSTATE)

            CALL mma_deallocate(XMAT)
          END IF
#elif _ENABLE_CHEMPS2_DMRG_
          ELSE
            write(6,*) 'CHEMPS2> MKRPTORB assumes '//
     &    'PSEUDOCANONICAL orbitals!'
          END IF
#endif
        end if
      END IF

      END SUBROUTINE MKRPTORB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1997, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE INTIM
*
* Interface to external integrals
*
* If NOINT .ne. 0, only pointers are constructed
* Jeppe Olsen, Winter of 1991
*
* Version : Fall 97
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "crun.fh"
#include "glbbas.fh"
#include "clunit.fh"
#include "lucinp.fh"
#include "csm.fh"
#include "orbinp.fh"
#include "cintfo.fh"
#include "oper.fh"
#include "cecore.fh"
*
*. : Pointers for symmetry blocks of integrals
*
      CALL INTPNT(iWORK(KPINT1),iWORK(KLSM1),
     &            iWORK(KPINT2),iWORK(KLSM2))
*
*. Pointer for orbital indices for symmetry blocked matrices
      CALL ORBINH1(iWORK(KINH1),iWORK(KINH1_NOCCSYM),NTOOBS,NTOOB,NSMOB)
*
*. Change one-electron integrals to inactive fock matrix
      IF(NOINT.EQ.0) THEN
C?      WRITE(6,*) ' INTIM : IUSE_PH', IUSE_PH
        CALL COPVEC(WORK(KINT1),WORK(KINT1O),NINT1)
c        IF(IUSE_PH.EQ.1) THEN
c           IF (ENVIRO(1:6) .EQ. 'RASSCF') THEN
c              ECORE_HEX = 0.0D0
cc           ELSE
cc              CALL FI(WORK(KINT1),ECORE_HEX,1)
c           END IF
c        ELSE
           ECORE_HEX = 0.0D0
c        END IF
      END IF
      ECORE_ORIG = ECORE
      ECORE = ECORE + ECORE_HEX
c      IF (ENVIRO(1:6) .NE. 'RASSCF')
c     &   WRITE(6,*) ' Updated core energy ',ECORE
*
C?    WRITE(6,*) ' IDMPIN ', IDMPIN
c      IF (IDMPIN.EQ.1 ) THEN
c        WRITE(6,*)
c     &   ' Integrals written formatted (E22.15) on unit 90'
c        LU90 = 90
c        REWIND LU90
c*.1 : One-electron integrals
c        WRITE(LU90,'(E22.15)')
c     &   (WORK(KINT1O-1+INT1),INT1=1,NINT1)
c*.2 : Two-electron integrals
c        WRITE(LU90,'(E22.15)')
c     &   (WORK(KINT2-1+INT2),INT2=1,NINT2)
c*.3. Core energy
c        WRITE(LU90,'(E22.15)')ECORE_ORIG
c*.4  Rewind to empty buffer
c        REWIND LU90
c*.   Symmetry info etc two LU91
c        LU91 = 91
c        CALL DUMP_1EL_INFO(LU91)
c      END IF
*
c      IF (ENVIRO(1:6) .NE. 'RASSCF' .OR. IPRNT .GE. 20)
c     &       WRITE(6,*) ' INTIM : First integrals in WORK(KINT1) '
c      LLL = MIN(10,NINT1)
c      LLL = NINT1
c      IF (ENVIRO(1:6) .NE. 'RASSCF' .OR. IPRNT .GE. 20) THEN
c         WRITE(6,*) ' NINT1 = ',NINT1
c         CALL WRTMAT(WORK(KINT1),1,LLL,1,LLL)
c         WRITE(6,*) ' INTIM : First integrals in WORK(KINT2) '
c      ENDIF
c      LLL = MIN(10,NINT2)
c      LLL = NINT2
c      IF (ENVIRO(1:6) .NE. 'RASSCF' .OR. IPRNT .GE. 20) THEN
c         WRITE(6,*) ' NINT2 = ',NINT2
c         CALL WRTMAT(WORK(KINT2),1,LLL,1,LLL)
c      ENDIF

C!    stop ' Jeppe forced my to stop in INTIM '
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine tmltpl(inp,lpole,maxlab,labs,ndim,prvec,t,temp)
!***********************************************************************
!
!     Purpose: transformation of maxlab cartesian l-th
!              moments into the corresponding l-pole cartesian
!              moments; l=lpole
!
!
!     inp                    if inp == 0 the t matrix will be
!                            calculated. Otherwise the t matrix
!                            is transferred from the previous
!                            call
!     lpole                  l value for the l-pole moment
!     maxlab                 is the number of cartesian components
!                            of the l-pole moment
!     labs(maxlab)           labels for components of the l-pole
!                            moment
!     ndim                   defines the number of rows which will
!                            be transformed in the table
!                            prvec(ndim,maxlab)
!     t(maxlab,maxlab)       is the transformation matrix generated
!                            in this program for lpole=2,3,4
!     temp(maxlab)           is a temporary strorage area
!
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, Two, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: inp, lpole, maxlab, ndim
character(len=16), intent(in) :: labs(maxlab)
real(kind=wp), intent(inout) :: prvec(ndim,maxlab), t(maxlab,maxlab)
real(kind=wp), intent(out) :: temp(maxlab)
integer(kind=iwp) :: i, icount, ilab(6,3), ind, irr(3,3), irrrr(6,3), j, k, l
real(kind=wp) :: f, rsum
character :: l1, l2, l3, l4

k = 0 ! dummy initialize
l = 0 ! dummy initialize

! building of transformation matrices for the transformation
! from cartesian l-th moments to cartesian l-pole moments
! limited to l=2,3, and 4

if (inp /= 1) then

  select case (lpole)

    case (2)
      ! quadrupole moments

      t(:,:) = Zero
      do i=1,maxlab
        t(i,i) = OneHalf
        read(labs(i),'(14x,2a1)') l1,l2
        if (l1 == l2) then
          t(i,1) = t(i,1)-Half
          t(i,4) = t(i,4)-Half
          t(i,6) = t(i,6)-Half
        end if
      end do

    case (3)
      ! octupole moments

      irr(:,:) = 0
      do i=1,3
        irr(i,i) = 2
      end do

      t(:,:) = Zero
      do i=1,maxlab
        t(i,i) = 2.5_wp
        read(labs(i),'(13x,3a1)') l1,l2,l3
        if (l1 == l2) then
          ilab(1:3,:) = irr
          k = 0
          if (l3 == 'X') k = 1
          if (l3 == 'Y') k = 2
          if (l3 == 'Z') k = 3
          ilab(1:3,k) = ilab(1:3,k)+1
          do j=1,3
            ind = nTri_Elem(3-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)-Half
          end do
        end if
        if (l2 == l3) then
          ilab(1:3,:) = irr
          k = 0
          if (l1 == 'X') k = 1
          if (l1 == 'Y') k = 2
          if (l1 == 'Z') k = 3
          ilab(1:3,k) = ilab(1:3,k)+1
          do j=1,3
            ind = nTri_Elem(3-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)-Half
          end do
        end if
        if (l1 == l3) then
          ilab(1:3,:) = irr
          k = 0
          if (l2 == 'X') k = 1
          if (l2 == 'Y') k = 2
          if (l2 == 'Z') k = 3
          ilab(1:3,k) = ilab(1:3,k)+1
          do j=1,3
            ind = nTri_Elem(3-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)-Half
          end do
        end if
      end do

    case (4)
      ! hexadecapole moments

      irr(:,:) = 0
      do i=1,3
        irr(i,i) = 2
      end do
      irrrr(:,:) = 0
      irrrr(1,1) = 4
      irrrr(2,1) = 2
      irrrr(2,2) = 2
      irrrr(3,1) = 2
      irrrr(3,3) = 2
      irrrr(4,2) = 4
      irrrr(5,2) = 2
      irrrr(5,3) = 2
      irrrr(6,3) = 4

      t(:,:) = Zero
      do i=1,maxlab
        t(i,i) = 4.375_wp
        read(labs(i),'(12x,4a1)') l1,l2,l3,l4
        if (l1 == l2) then
          ilab(1:3,:) = irr
          k = 0
          l = 0
          if (l3 == 'X') k = 1
          if (l3 == 'Y') k = 2
          if (l3 == 'Z') k = 3
          if (l4 == 'X') l = 1
          if (l4 == 'Y') l = 2
          if (l4 == 'Z') l = 3
          ilab(1:3,k) = ilab(1:3,k)+1
          ilab(1:3,l) = ilab(1:3,l)+1
          do j=1,3
            ind = nTri_Elem(4-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)-0.625_wp
          end do
        end if
        if (l1 == l3) then
          ilab(1:3,:) = irr
          k = 0
          l = 0
          if (l2 == 'X') k = 1
          if (l2 == 'Y') k = 2
          if (l2 == 'Z') k = 3
          if (l4 == 'X') l = 1
          if (l4 == 'Y') l = 2
          if (l4 == 'Z') l = 3
          ilab(1:3,k) = ilab(1:3,k)+1
          ilab(1:3,l) = ilab(1:3,l)+1
          do j=1,3
            ind = nTri_Elem(4-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)-0.625_wp
          end do
        end if
        if (l1 == l4) then
          ilab(1:3,:) = irr
          k = 0
          l = 0
          if (l2 == 'X') k = 1
          if (l2 == 'Y') k = 2
          if (l2 == 'Z') k = 3
          if (l3 == 'X') l = 1
          if (l3 == 'Y') l = 2
          if (l3 == 'Z') l = 3
          ilab(1:3,k) = ilab(1:3,k)+1
          ilab(1:3,l) = ilab(1:3,l)+1
          do j=1,3
            ind = nTri_Elem(4-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)-0.625_wp
          end do
        end if
        if (l2 == l3) then
          ilab(1:3,:) = irr
          k = 0
          l = 0
          if (l1 == 'X') k = 1
          if (l1 == 'Y') k = 2
          if (l1 == 'Z') k = 3
          if (l4 == 'X') l = 1
          if (l4 == 'Y') l = 2
          if (l4 == 'Z') l = 3
          ilab(1:3,k) = ilab(1:3,k)+1
          ilab(1:3,l) = ilab(1:3,l)+1
          do j=1,3
            ind = nTri_Elem(4-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)-0.625_wp
          end do
        end if
        if (l2 == l4) then
          ilab(1:3,:) = irr
          k = 0
          l = 0
          if (l1 == 'X') k = 1
          if (l1 == 'Y') k = 2
          if (l1 == 'Z') k = 3
          if (l3 == 'X') l = 1
          if (l3 == 'Y') l = 2
          if (l3 == 'Z') l = 3
          ilab(1:3,k) = ilab(1:3,k)+1
          ilab(1:3,l) = ilab(1:3,l)+1
          do j=1,3
            ind = nTri_Elem(4-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)-0.625_wp
          end do
        end if
        if (l3 == l4) then
          ilab(1:3,:) = irr
          k = 0
          l = 0
          if (l1 == 'X') k = 1
          if (l1 == 'Y') k = 2
          if (l1 == 'Z') k = 3
          if (l2 == 'X') l = 1
          if (l2 == 'Y') l = 2
          if (l2 == 'Z') l = 3
          ilab(1:3,k) = ilab(1:3,k)+1
          ilab(1:3,l) = ilab(1:3,l)+1
          do j=1,3
            ind = nTri_Elem(4-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)-0.625_wp
          end do
        end if
        ilab(:,:) = irrrr
        if ((l1 == l2) .and. (l3 == l4)) then
          do j=1,6
            f = 0.125_wp
            if ((j == 2) .or. (j == 3) .or. (j == 5)) f = Two*f
            ind = nTri_Elem(4-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)+f
          end do
        end if
        if ((l1 == l3) .and. (l2 == l4)) then
          do j=1,6
            f = 0.125_wp
            if ((j == 2) .or. (j == 3) .or. (j == 5)) f = Two*f
            ind = nTri_Elem(4-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)+f
          end do
        end if
        if ((l2 == l3) .and. (l1 == l4)) then
          do j=1,6
            f = 0.125_wp
            if ((j == 2) .or. (j == 3) .or. (j == 5)) f = Two*f
            ind = nTri_Elem(4-ilab(j,1))+ilab(j,3)+1
            T(i,ind) = T(i,ind)+f
          end do
        end if
      end do

    case default
      call Abend()

  end select

  ! print the transformation matrix

  !write(u6,'(//1x,a,i2/)') 'transformation matrix:  lpole=',lpole
  !do i=1,maxlab
  !  write(u6,'(15f7.3)') t(i,:)
  !end do

end if

! transform cartesian moment to multipole moments

do icount=1,ndim
  temp(:) = prvec(icount,:)
  do k=1,maxlab
    rsum = Zero
    do l=1,maxlab
      rsum = rsum+t(k,l)*temp(l)
    end do
    prvec(icount,k) = rsum
  end do
end do

return

end subroutine tmltpl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Roland Lindh                                     *
************************************************************************
      Subroutine DrvNQ_Internal(
     &                  Kernel,Func,
     &                  Maps2p,nSym,list_s,list_exp,list_bas,
     &                  nShell,list_p,R2_trial,nNQ,
     &                  AOInt,nAOInt,FckInt,nFckDim,
     &                  Density,nFckInt,nD,
     &                  SOTemp,nSOTemp,
     &                  Grid,Weights,Rho,mGrid,nRho,
     &                  ndF_dRho,nP2_ontop,ndF_dP2ontop,
     &                  Do_Mo,Do_TwoEl,l_Xhol,
     &                  TmpPUVX,nTmpPUVX,
     &                  nMOs,
     &                  CMOs,nCMO,DoIt,P2mo,np2act,D1mo,nd1mo,P2_ontop,
     &                  Do_Grad,Grad,nGrad,list_g,IndGrd,iTab,Temp,
     &                  mGrad,F_xc,dF_dRho,dF_dP2ontop,
     &                  DFTFOCK,mAO,mdRho_dR)
************************************************************************
*                                                                      *
* Object: Driver for numerical quadrature.                             *
*                                                                      *
*     Author: Roland Lindh,                                            *
*             Dept of Chemical Physics,                                *
*             University of Lund, Sweden                               *
*             August 1999                                              *
************************************************************************
#ifdef _DEBUGPRINT_
      use Basis_Info, only: nBas
#endif
      use Real_Spherical
      use Symmetry_Info, only: nIrrep, iOper
      use KSDFT_Info, only: KSDFA, LuMC, LuMT, Funcaa, Funcbb, Funccc
      Implicit Real*8 (A-H,O-Z)
      External Kernel, Rsv_Tsk
#include "real.fh"
#include "WrkSpc.fh"
#include "nsd.fh"
#include "setup.fh"
#include "status.fh"
#include "nq_info.fh"
#include "grid_on_disk.fh"
#include "debug.fh"
#include "ksdft.fh"
      Integer Maps2p(nShell,0:nSym-1),
     &        list_s(nSym*nShell), list_exp(nSym*nShell),
     &        list_p(nNQ), DoIt(nMOs), List_g(3,nSym*nShell),
     &        IndGrd(mGrad), iTab(4,mGrad), list_bas(2,nSym*nShell)
      Real*8 AOInt(nAOInt,nAOInt,nD), FckInt(nFckInt,nFckDim),
     &       Density(nFckInt,nD),
     &       SOTemp(nSOTemp,nD), Grid(3,mGrid), Weights(mGrid),
     &       Rho(nRho,mGrid), R2_trial(nNQ),
     &       CMOs(nCMO),P2mo(np2act),D1mo(nd1mo), Temp(mGrad),
     &       P2_ontop(nP2_ontop,mGrid), Grad(nGrad),
     &       F_xc(mGrid),dF_dRho(ndF_dRho,mGrid),
     &       dF_dP2ontop(ndF_dp2ontop,mGrid)
      Real*8 TmpPUVX(nTmpPUVX)
      Logical Check, Do_Grad, Rsv_Tsk
      Logical Do_Mo,Do_TwoEl,l_Xhol,l_casdft,Exist
      Character*4 DFTFOCK
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      Check(i,j)=iAnd(i,2**(j-1)).ne.0
      iGridInfo(i,iNQ)=iWork(ip_GridInfo+(iNQ-1)*2+i-1)
*                                                                      *
************************************************************************
*                                                                      *
************************************************************************
* Initializations for MC-PDFT                                          *
************************************************************************
      l_casdft = .false.
      l_casdft = KSDFA(1:5).eq.'TLSDA'   .or.
     &           KSDFA(1:6).eq.'TLSDA5'  .or.
     &           KSDFA(1:5).eq.'TBLYP'   .or.
     &           KSDFA(1:6).eq.'TSSBSW'  .or.
     &           KSDFA(1:5).eq.'TSSBD'   .or.
     &           KSDFA(1:5).eq.'TS12G'   .or.
     &           KSDFA(1:4).eq.'TPBE'    .or.
     &           KSDFA(1:5).eq.'FTPBE'   .or.
     &           KSDFA(1:5).eq.'TOPBE'   .or.
     &           KSDFA(1:6).eq.'FTOPBE'  .or.
     &           KSDFA(1:7).eq.'TREVPBE' .or.
     &           KSDFA(1:8).eq.'FTREVPBE'.or.
     &           KSDFA(1:6).eq.'FTLSDA'  .or.
     &           KSDFA(1:6).eq.'FTBLYP'
************************************************************************
* Open file for MC-PDFT to store density, pair density and ratio:      *
*                   ratio = 4pi/rho^2                                  *
************************************************************************
      IF(l_casdft) then
!
        PUVX_Time= 0d0
        FA_Time = 0d0
        sp_time = 0d0
        FI_time = 0d0
!
        LuMC=37
        call OpnFl('MCPDFT',LuMC,Exist)
c        Call append_file(LuMC)
        write(LuMC,'(A)') ' Here densities are MCPDFT modified ones.'
        write(LuMC,*)     ' Used by translated functional: ', KSDFA(1:8)
        write(LuMC,'(A)') '     X    ,     Y    ,     Z    ,'//
     &                    '       d_a*W     ,       d_b*W     ,'//
     &                    '       dTot*W    ,       Weights   ,'//
     &                    '          dTot   ,       P2        ,   ratio'
        LuMT=37
        call OpnFl('MCTRUD',LuMT,Exist)
c        Call append_file(LuMT)
        write(LuMT,'(A)') ' Here densities are original ones.'
        write(LuMT,*)     ' Used by translated functional: ', KSDFA(1:8)
        write(LuMT,'(A)') '     X    ,     Y    ,     Z    ,'//
     &                    '       d_a*W     ,       d_b*W     ,'//
     &                    '       dTot*W    ,       Weights   ,'//
     &                    '       dTot '
      END IF
************************************************************************
*
*----- Desymmetrize the 1-particle density matrix
*
      Call Allok2_Funi(nD)
      Call DeDe_Funi(Density,nFckInt,nD)
*
      If(l_casdft.and.do_pdftPot) then
        CALL GETMEM('OE_OT','ALLO','REAL',LOE_DB,nFckInt)
        CALL GETMEM('TEG_OT','ALLO','REAL',LTEG_DB,nTmpPUVX)
        Call GETMEM('FI_V','ALLO','REAL',ifiv,nFckInt)
        Call GETMEM('FI_A','ALLO','REAL',ifav,nFckInt)
!        Call GETMEM('FI_V','ALLO','REAL',ifiv_n,nFckInt)
!        Call GETMEM('FI_A','ALLO','REAL',ifav_n,nFckInt)

        CALL DCOPY_(nFckInt,[0.0D0],0,WORK(LOE_DB),1)!NTOT1
        CALL DCOPY_(nTmpPUVX,[0.0D0],0,WORK(LTEG_DB),1)
        CALL DCOPY_(nFckInt,[0.0D0],0,WORK(ifiv),1)
        CALL DCOPY_(nFckInt,[0.0D0],0,WORK(ifav),1)
!        CALL DCOPY_(nFckInt,[0.0D0],0,WORK(ifiv_n),1)
!        CALL DCOPY_(nFckInt,[0.0D0],0,WORK(ifav_n),1)
      Else
        LOE_DB = ip_dummy
        LTEG_DB = ip_dummy
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     For a parallel implementation the iterations over
*     subblocks are parallelized.
*
      Call Init_Tsk(id,number_of_subblocks) ! Initialize parallelization
*
*-----Loop over subblocks
*
      Flop=Zero
      iSB = 0
C     Do iSB = 1, number_of_subblocks
*
*------- Start of parallelized loop here!
*
 100     Continue
         If (Grid_Status.eq.Regenerate) Then
*           Try to get an iSB to execute. If fail: done and branch out!
            If (.Not.Rsv_Tsk(id,iSB)) Go To 200
         Else
*           Try to find a subblock which was generated by this processor.
            iSB = iSB + 1
            If (iSB.gt.number_of_subblocks) Go To 200
            If (iGridInfo(2,iSB).eq.0) Go To 100
         End If
*                                                                      *
************************************************************************
*                                                                      *
*------- Eliminate redundant subblocks in case of symmetry.
*        This is only done for the Lebedev grids!
*
         If (nIrrep.ne.1.and.Check(iOpt_Angular,3)) Then
*
*---------- Resolve triplet index
*
            iyz = 1 + (iSB-1)/nx
            ix  = iSB - (iyz-1)*nx
            iz  = 1 + (iyz-1)/ny
            iy  = iyz - (iz-1)*ny
*
*---------- Do symmetry by procastination.
*
            Do iIrrep = 1, nIrrep-1
               jx=ix
               If (iAnd(iOper(iIrrep),1).ne.0) jx=nx-jx+1
               jy=iy
               If (iAnd(iOper(iIrrep),2).ne.0) jy=ny-jy+1
               jz=iz
               If (iAnd(iOper(iIrrep),4).ne.0) jz=nz-jz+1
*
               jyz = (jz -1)*ny    + jy
               jxyz= (jyz-1)*nx    + jx
C              If (jxyz.gt.iSB) Go To 777
               If (jxyz.gt.iSB) Go To 100 ! go for the next task.
            End Do
*
         End If
         Debug=.False.
C        If (iSB.eq.58) Debug=.True.
C        Debug=.True.
         If (Debug) Write (6,*) 'DrvNQ_: iSB=',iSB
*                                                                      *
************************************************************************
*                                                                      *
*-----Here the List_S is the list of all the complete shells for
*     the whole system.
*
         Call Get_Subblock(Kernel,Func,iSB,
     &                     Maps2p,list_s,list_exp,list_bas,nShell,nSym,
     &                     list_p,R2_trial,nNQ,
     &                     AOInt,nAOInt,FckInt,nFckDim,nFckInt,
     &                     SOTemp,nSOTemp,
     &                     Density,nFckInt,nD,
     &                     Grid,Weights,Rho,mGrid,nRho,
     &                     ndF_dRho,nP2_ontop,ndF_dP2ontop,
     &                     Do_Mo,Do_TwoEl,l_Xhol,
     &                     TmpPUVX,nTmpPUVX,nMOs,CMOs,nCMO,DoIt,
     &                     P2mo,np2act,D1mo,nd1mo,P2_ontop,
     &                     Do_Grad,Grad,nGrad,List_G,IndGrd,iTab,Temp,
cGLM     &                     mGrad,F_xc,F_xca,F_xcb,dF_dRho,dF_dP2ontop,
     &                     mGrad,F_xc,dF_dRho,dF_dP2ontop,
     &                     DFTFOCK,mAO,mdRho_dR,
     &                     LOE_DB,LTEG_DB)
*                                                                      *
************************************************************************
*                                                                      *
         Go To 100  ! go back and try to do another task
C777     Continue
C     End Do ! number_of_subblocks
 200  Continue ! Done!
      Call Free_Tsk(id)
      Flop=Flop/DBLE(nFckInt)


*                                                                      *
************************************************************************
*                                                                      *
*---- Scale result with respect to the degeneracy of the grid points
*
      If (nIrrep.ne.1.and.Check(iOpt_Angular,3)) Then
*
         Func   = DBLE(nIrrep)*Func
         Funcaa  = DBLE(nIrrep)*Funcaa
         Funcbb  = DBLE(nIrrep)*Funcbb
         Funccc  = DBLE(nIrrep)*Funccc
         Dens_I = DBLE(nIrrep)*Dens_I
         Dens_a1 = DBLE(nIrrep)*Dens_a1
         Dens_b1 = DBLE(nIrrep)*Dens_b1
         Dens_a2 = DBLE(nIrrep)*Dens_a2
         Dens_b2 = DBLE(nIrrep)*Dens_b2
         Dens_t1 = DBLE(nIrrep)*Dens_t1
         Dens_t2 = DBLE(nIrrep)*Dens_t2
         Grad_I = DBLE(nIrrep)*Grad_I
         Tau_I  = DBLE(nIrrep)*Tau_I
*
         Call DScal_(nFckInt*nFckDim,DBLE(nIrrep),FckInt,1)
         If (Do_TwoEl)
     &   Call DScal_(nTmpPUVX,DBLE(nIrrep),TmpPUVX,1)
*
      End If

*                                                                      *
************************************************************************
*                                                                      *
*---- Free memory associated with the density
*
      Call Free_DeDe_Funi()
*
*---- Free memory for angular grids
*
      Do iSet = 1, nAngularGrids
         Call GetMem('AngRW','Free','Real',Info_Ang(3,iSet),nDum)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Debug=.True.
      If (Debug.and..Not.Do_Grad) Then
         Write (6,*) 'Func=',Func
         iOff=1
         Do iIrrep=0,nIrrep-1
            nB=nBas(iIrrep)
            If (nB.gt.0) Then
               Call TriPrt('Final FckInt(Alpha)',' ',FckInt(iOff,1),nB)
               lB=nB*(nB+1)/2
               iOff = iOff + lB
            End If
         End Do
         If (nD.eq.1) Go To 98
         iOff=1
         Do iIrrep=0,nIrrep-1
            nB=nBas(iIrrep)
            If (nB.gt.0) Then
               Call TriPrt('Final FckInt(Beta)',' ',FckInt(iOff,2),nB)
               lB=nB*(nB+1)/2
               iOff = iOff + lB
            End If
         End Do
 98      Continue
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     For parallel implementation syncronize here!
*
*     Data to be syncronized: FckInt, Func, Dens,  and Grad.
*
*
      If (Do_Grad) Then
         Call GADSum(Grad,nGrad)
      Else
         Call GADSum_SCAL(Func)
         Call GADSum_SCAL(Funcaa)
         Call GADSum_SCAL(Funcbb)
         Call GADSum_SCAL(Funccc)
         Call GADSum_SCAL(Dens_I)
         Call GADSum_SCAL(Dens_t1)
         Call GADSum_SCAL(Dens_t2)
         Call GADSum_SCAL(Dens_a1)
         Call GADSum_SCAL(Dens_a2)
         Call GADSum_SCAL(Dens_b1)
         Call GADSum_SCAL(Dens_b2)
         Call GADSum_SCAL(Grad_I)
         Call GADSum_SCAL(Tau_I)
         Call GADSum(FckInt,nFckInt*nD)
        If(l_casdft.and.do_pdftPot) then
          Call GADSum(Work(LOE_DB),nFckInt)
          Call GADSum(Work(LTEG_DB),nTmpPUVX)
          Call GADSum(Work(ifiv),nFckInt)
          Call GADSum(Work(ifav),nFckInt)
        End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If(l_casdft.and.do_pdftPot) then


!        CALL DCOPY_(nFckInt,Work(ifav_n),1,WORK(ifav),1)
!        CALL DCOPY_(nFckInt,Work(ifiv_n),1,WORK(ifiv),1)

        Call Put_dArray('ONTOPO',work(LOE_DB),nFckInt)
        Call Put_dArray('ONTOPT',work(LTEG_DB),nTmpPUVX)
        Call Put_dArray('FI_V',Work(ifiv),nFckInt)
        Call Put_dArray('FA_V',Work(ifav),nFckInt)


        CALL GETMEM('OE_OT','Free','REAL',LOE_DB,nFckInt)
        CALL GETMEM('TEG_OT','Free','REAL',LTEG_DB,nTmpPUVX)
        CALL GETMEM('FI_V','FREE','REAL',ifiv,nFckInt)
!        CALL GETMEM('FI_V','FREE','REAL',ifiv_n,nFckInt)
        CALL GETMEM('FA_V','FREE','REAL',ifav,nFckInt)
!        CALL GETMEM('FA_V','FREE','REAL',ifav_n,nFckInt)

!      write(*,*) 'Potential timings:'
!      write(*,*) 'PUVX time: ',PUVX_Time
!      write(*,*) 'FA time: ',FA_Time
!      write(*,*) 'FI time: ',FI_Time
!      write(*,*) 'SP time: ',SP_Time
!        PUVX_Time= 0d0
!        FA_Time = 0d0
!        FI_time = 0d0
!        sp_time = 0d0
      End If

      IF(debug. and. l_casdft) THEN
        write(6,*) 'Dens_I in drvnq_ :', Dens_I
        write(6,*) 'Dens_a1 in drvnq_ :', Dens_a1
        write(6,*) 'Dens_b1 in drvnq_ :', Dens_b1
        write(6,*) 'Dens_a2 in drvnq_ :', Dens_a2
        write(6,*) 'Dens_b2 in drvnq_ :', Dens_b2
        write(6,*) 'Dens_t1 in drvnq_ :', Dens_t1
        write(6,*) 'Dens_t2 in drvnq_ :', Dens_t2
        write(6,*) 'Func in drvnq_ :', Func
        write(6,*) 'Funcaa in drvnq_ :', Funcaa
        write(6,*) 'Funcbb in drvnq_ :', Funcbb
        write(6,*) 'Funccc in drvnq_ :', Funccc
      END IF
*
* Close these files...
      If(l_casdft) then
        Close(LuMC)
        Close(LuMT)
      End if

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Bingbing Suo                                     *
************************************************************************
c  16 apr 2007 - bsuo - revised to use molcas intergrals
#ifdef MOLPRO
      subroutine intrd
      use file_qininit, only : maxrecord
#include "drt_h.fh"
#include "intsort_h.fh"
#include "files_gugaci.fh"
      integer :: noffset(maxrecord)
      common /mcorb/ lsmorb(max_orb),noidx(8)
      REAL*8, pointer :: x(:)
      dimension xfock(max_orb*(max_orb+1)/2)
      dimension itratoc(ntratoc)


      nintone=0
      nmob=0
      nidx=0
      ni=0
      do i=1,ng_sm
        nism   = nlsm_all(i)
        nsmint = nism*(nism+1)/2
        itratoc(i)=nism*nism
        nmob=nmob+nlsm_bas(i)*nlsm_bas(i)
        noidx(i)=nidx
        nidx=nidx+nism
        nintone=nintone+nsmint
        lsmorb(ni+1:nidx)=i
        ni=nidx
      enddo

      noffset=0
      ni=0
      call idafile(Lutwomo,2,noffset,maxrecord,ni)
      ! 2th record in file traint, nuclear repulesive energy
      call ddafile(Lutwomo,2,vpotnuc,1,ni)
      ! 3rd record, ecore
      call ddafile(Lutwomo,2,ecor, 1,ni)  ! effective core energy
      write(6,"(a,1x,f14.8)") " Nuclear repulsive energy:",vpotnuc
      write(6,"(a,1x,f14.8)") " Frozen  core energy:     ",ecor
      vpotnuc=vpotnuc+ecor
      ! 4th record, 1e int
      call ddafile(Lutwomo,2,xfock,nintone,ni) ! 1e integrals

c write one electron fock matrix into voint
      nidx=0
      do i=1,ng_sm
        nism  = nlsm_all(i)
        idx   = noidx(i)
        nsmint = nism*(nism+1)/2
        nc=0
        do lri=1,nism
          do lrj=1,lri
            nc=nc+1
            lrcii=map_orb_order(lri+idx)
            lrcij=map_orb_order(lrj+idx)
            if(lrcii.gt.lrcij) then
              lrt=lrcij
              lrcij=lrcii
              lrcii=lrt
            endif
            voint(lrcii,lrcij)=xfock(nc+nidx)
!           write(6,'(1x,i3,1x,i3,1x,f18.9)') lrcii,lrcij,xfock(nc+nidx)
          enddo
        enddo
        nidx=nidx+nsmint
      enddo
      call readtwoeint(lutwomo,maxrecord,noffset,nlsm_all,ng_sm,mul_tab,
     *                 map_orb_order,noidx)

      !write(6,*)
      !write(6,*) "MRCI integrals"
      !do lri=1,406
      !  write(55,"(i8,f16.8)") lri,vector1(lri)
      !enddo

      return
c...end of intrd_molcas
      end

      subroutine readtwoeint(nft,maxrecord,noffset,norb,
     *                       ngsm,multab,maporb,noidx)
      implicit REAL*8 (a-h,o-z)
#include "ci_parameter.fh"
      integer :: noffset(maxrecord)
      parameter ( kbuf = ntrabuf )
      dimension norb(8),multab(8,8),maporb(max_orb),noidx(8)
      dimension itratoc(ntratoc)
      dimension buff(kbuf)

      idisk=noffset(5)
      write(6,2000)
2000  format(/7x,'symmetry',6x,' orbitals',8x,'integrals')
      do nsp=1,ngsm
        nop=norb(nsp)
        do nsq=1,nsp
          noq=norb(nsq)
          nspq=multab(nsp,nsq)
          do nsr=1,nsp
            nor=norb(nsr)
            nspqr=multab(nspq,nsr)
            nssm=nsr
            if(nsr.eq.nsp) nssm=nsq
            do nss=1,nssm
              if(nspqr.ne.nss) cycle
              nos=norb(nss)

              ityp=0
              if(nsr.eq.nss) then
                nbpq=(nop+nop**2)/2
                nbrs=(nos+nos**2)/2
                if(nsp.eq.nsr) then
c  (ii|ii) type 1 int
                  nintb=(nbpq+nbpq**2)/2
                  ityp=1
                else
c  (ii|jj) type 3 int
                  nintb=nbpq*nbrs
                  ityp=3
                endif
              else
                nbpq=nop*noq
                nbrs=nor*nos
                if(nsp.eq.nsr) then
c (ij|ij) type 2 int
                  nintb=(nbpq+nbpq**2)/2
                  ityp=2
                else
c (ij|kl) type 4 int
                  nintb=nbpq*nbrs
                  ityp=4
                endif
              endif

              if(nintb.eq.0) goto 10
              write(6,2100) nsp,nsq,nsr,nss,nop,noq,nor,nos,
     *                      nintb
2100          format(7x,4i2,1x,4i4,2x,3x,i9)

              idx=0
              iout=0
c              call ddatard(nft,buff,kbuf,idisk)
              if(nintb.gt.kbuf) then
                call ddafile(nft,2,buff,kbuf, idisk)
              else
                call ddafile(nft,2,buff,nintb,idisk)
              endif

              do li=1,nos
                ntj=nor
                if(ityp.eq.1.or.ityp.eq.3) ntj=li
                do lj=1,ntj
                  ntk=noq
                  if(ityp.eq.1.or.ityp.eq.2) ntk=li
                  do lk=1,ntk
                    ntl=nop
                    if(ityp.eq.1.or.ityp.eq.3) ntl=lk
                    if(ityp.eq.1.and.li.eq.lk) ntl=lj
                    if(ityp.eq.2.and.li.eq.lk) ntl=lj
                    do ll=1,ntl
                      iout=iout+1
                      if(iout.gt.kbuf) then
                         if(nintb-idx.lt.kbuf) then
                           call ddafile(nft,2,buff,nintb-idx,idisk)
                         else
                           call ddafile(nft,2,buff,kbuf,idisk)
                         endif
                         iout=1
                      endif
                      idx=idx+1
                      val=buff(iout)
                      lri=maporb(li+noidx(nss))
                      lrj=maporb(lj+noidx(nsr))
                      lrk=maporb(lk+noidx(nsq))
                      lrl=maporb(ll+noidx(nsp))
                      !if(ityp.ne.2) cycle
!                      write(6,"(9(1x,i2),1x,f18.9)") li,lj,lk,ll,
!     *                                               lri,lrj,lrk,lrl,
!     *                                               iout,val
                      call intrw_mol(lri,lrj,lrk,lrl,val)
                    enddo
                  enddo
                enddo
              enddo

10          continue
            enddo
          enddo
        enddo
      enddo

      return
c....end of readtwoeint
      end

#else
      subroutine intrd_molcas
#include "drt_h.fh"
#include "intsort_h.fh"
#include "files_gugaci.fh"
      common /mcorb/ lsmorb(max_orb),noidx(8)
      REAL*8, pointer :: x(:)
      dimension xfock(max_orb*(max_orb+1)/2)
      dimension itratoc(ntratoc)

      nintone=0
      nmob=0
      nidx=0
      ni=0
      do i=1,ng_sm
        nism   = nlsm_all(i)
        nsmint = nism*(nism+1)/2
        itratoc(i)=nism*nism
        nmob=nmob+nlsm_bas(i)*nlsm_bas(i)
        noidx(i)=nidx
        nidx=nidx+nism
        nintone=nintone+nsmint
        lsmorb(ni+1:nidx)=i
        ni=nidx
      enddo
      allocate(x(nmob))
      call daname(luonemo,fnonemo)
      call readtraonehead(luonemo,ecor,idisk)
      vpotnuc=ecor

c  read mo coeff, need debug, if frozen and delete orbitals are not zero
c      call ddatard(nft,x,nmob,idisk)
      call ddafile(luonemo,2,x,nmob,idisk)

c  read one electron fock matrix
      call ddafile(luonemo,2,xfock,nintone,idisk)
c      call ddatard(nft,xfock,nintone,idisk)
      call daclos(luonemo)
c  read one elctron kenetic intergrals
c      call ddatard(nft,x1e,nintone,idisk)
c      call cclose_molcas(nft)
c write one electron fock matrix into voint
      nidx=0
      do i=1,ng_sm
        nism  = nlsm_all(i)
        idx   = noidx(i)
        nsmint = nism*(nism+1)/2
        nc=0
        do lri=1,nism
          do lrj=1,lri
            nc=nc+1
            lrcii=map_orb_order(lri+idx)
            lrcij=map_orb_order(lrj+idx)
            if(lrcii.gt.lrcij) then
              lrt=lrcij
              lrcij=lrcii
              lrcii=lrt
            endif
            voint(lrcii,lrcij)=xfock(nc+nidx)
!           write(6,'(1x,i3,1x,i3,1x,f18.9)') lrcii,lrcij,xfock(nc+nidx)
          enddo
        enddo
        nidx=nidx+nsmint
      enddo

      call daname(lutwomo,fntwomo)
      call readtwoeint(lutwomo,nlsm_all,ng_sm,mul_tab,
     *                 map_orb_order,noidx)
      call daclos(lutwomo)
      write(6,*)
      deallocate(x)

      return
c...end of intrd_molcas
      end

      subroutine readtwoeint(nft,norb,ngsm,multab,maporb,noidx)
      implicit REAL*8 (a-h,o-z)
#include "ci_parameter.fh"
      parameter ( kbuf = ntrabuf )
      dimension norb(8),multab(8,8),maporb(max_orb),noidx(8)
      dimension itratoc(ntratoc)
      dimension buff(kbuf)

      idisk=0
      lenrd=ntratoc*lenintegral
      write(6,*) lenrd
c      call idatard(nft,itratoc,lenrd,idisk)
      call idafile(nft,2,itratoc,ntratoc,idisk)
c      write(6,"(10(1x,i8))") itratoc(1:10)
      write(6,2000)
2000  format(/7x,'symmetry',6x,' orbitals',8x,'integrals')
      do nsp=1,ngsm
        nop=norb(nsp)
        do nsq=1,nsp
          noq=norb(nsq)
          nspq=multab(nsp,nsq)
          do nsr=1,nsp
            nor=norb(nsr)
            nspqr=multab(nspq,nsr)
            nssm=nsr
            if(nsr.eq.nsp) nssm=nsq
            do nss=1,nssm
              if(nspqr.ne.nss) cycle
              nos=norb(nss)

              ityp=0
              if(nsr.eq.nss) then
                nbpq=(nop+nop**2)/2
                nbrs=(nos+nos**2)/2
                if(nsp.eq.nsr) then
c  (ii|ii) type 1 int
                  nintb=(nbpq+nbpq**2)/2
                  ityp=1
                else
c  (ii|jj) type 3 int
                  nintb=nbpq*nbrs
                  ityp=3
                endif
              else
                nbpq=nop*noq
                nbrs=nor*nos
                if(nsp.eq.nsr) then
c (ij|ij) type 2 int
                  nintb=(nbpq+nbpq**2)/2
                  ityp=2
                else
c (ij|kl) type 4 int
                  nintb=nbpq*nbrs
                  ityp=4
                endif
              endif

              if(nintb.eq.0) goto 10
              write(6,2100) nsp,nsq,nsr,nss,nop,noq,nor,nos,
     *                      nintb
2100          format(7x,4i2,1x,4i4,2x,3x,i9)

              idx=0
              iout=0
c              call ddatard(nft,buff,kbuf,idisk)
              call ddafile(nft,2,buff,kbuf,idisk)

              do li=1,nor
                ntj=nos
                if(nsr.eq.nss) ntj=li
                do lj=1,ntj
                  ntk=1
                  if(nsp.eq.nsr) ntk=li
                  do lk=ntk,nop
                    numin=1
                    if(nsp.eq.nsr.and.lk.eq.li)numin=lj
                    numax=noq
                    if(nsp.eq.nsq) numax=lk
                    do ll=numin,numax
                      iout=iout+1
                      if(iout.gt.kbuf) then
c                        call ddatard(nft,buff,kbuf,idisk)
                         call ddafile(nft,2,buff,kbuf,idisk)
                         iout=1
                      endif
                      idx=idx+1
                      val=buff(iout)
                      lri=maporb(lk+noidx(nsp))
                      lrj=maporb(ll+noidx(nsq))
                      lrk=maporb(li+noidx(nsr))
                      lrl=maporb(lj+noidx(nss))
!                      write(6,"(9(1x,i2),1x,f18.9)") li,lj,lk,ll,
!     *                                               lri,lrj,lrk,lrl,
!     *                                               iout,val
                      call intrw_mol(lri,lrj,lrk,lrl,val)
                    enddo
                  enddo
                enddo
              enddo

10          continue
            enddo
          enddo
        enddo
      enddo

      return
c....end of readtwoeint
      end

      subroutine readtraonehead(nft,ecor,idisk)
#include "ci_parameter.fh"
      implicit REAL*8 (a-h,o-z)
#include "maxbfn.fh"
      parameter (maxmolcasorb=maxbfn)
      parameter (lenin8=6+8)
      dimension ncone(64),nbas(8),norb(8),nfro(8),
     *          ndel(8)
      dimension indx_idisk(64)
      character bsbl(maxmolcasorb)*(lenin8)
      dimension dum(1),idum(1)

      indx_idisk=0
      idisk=0
      call idafile(nft,2,ncone,64,idisk)
      call ddafile(nft,2,dum,1,idisk)
      ecor=dum(1)
      call idafile(nft,2,idum,1,idisk)
      nsym=idum(1)
      call idafile(nft,2,nbas,8,idisk)
      call idafile(nft,2,norb,8,idisk)
      call idafile(nft,2,nfro,8,idisk)
      call idafile(nft,2,ndel,8,idisk)
      lenrd=lenin8*maxmolcasorb
      call cdafile(nft,2,bsbl,lenrd,idisk)

c#ifdef debug
c      write(6,"(a4,1x,8(2x,i8))") "ncon",ncone(1:8)
c      write(6,*) "idisk : ", idisk
c      write(6,"(a4,1x,f18.9)") "ecor",ecor
c      write(6,"(a4,1x,i8)") "nsym",nsym
c      write(6,"(a4,1x,8(2x,i8))") "nbas",nbas(1:8)
c      write(6,"(a4,1x,8(2x,i8))") "norb",norb(1:8)
c      write(6,"(a4,1x,8(2x,i8))") "nfro",nfro(1:8)
c      write(6,"(a4,1x,8(2x,i8))") "ndel",ndel(1:8)
c#endif

      return
c...end of readtraonehead
      end


#endif


c      subroutine ddatard(nft,xbuff,lend,idisk)
c      implicit REAL*8 (a-h,o-z)

c      dimension ncone(64),nbas(mxsym),norb(mxsym),nfro(mxsym),
c     *          ndel(mxsym)
c      dimension xbuff(lend)
c
c      lenrd=lend*lendbl
c      call idatard(nft,xbuff,lenrd,idisk)
c
c      return
cc...end of readtraonehead
c      end


c*************************************
c      subroutine idatard(nft,ibuf,lbuf,idisk)
cc   write by suo bing, read molcas file
cc   imul = 0, the file readed is not a multifile
cc   imul = 1, the file readed is a multifile
cc
c      implicit REAL*8 (a-h,o-z)
c      parameter (min_block_length=512)
c      character ibuf(lbuf)*1
c
c      noff=idisk*min_block_length
c      call clseek(nft,noff,nr)
c      if(nr.ne.noff) then
c        write(6,*) "error seek file : ",idisk
c        stop 888
c      endif
c      call cread_molcas(nft,ibuf,lbuf,nr)
c      if(nr.ne.lbuf) then
c        write(6,*) "error read file ",nr
c        write(6,*) "nft : ",nft
c        write(6,*) "lbuf  : ",lbuf
c        write(6,*) "idisk : ",idisk
c        stop 888
c      else
c        imo=mod(lbuf,min_block_length)
c        if(imo.eq.0) then
c          ioff=lbuf/min_block_length
c        else
c          ioff=1+lbuf/min_block_length
c        endif
c        idisk=idisk+ioff
cc        write(6,*) "ioff ",ioff
c      endif

c      return
cc...end of idatard
c      end

      subroutine intrw_mol(ik,jk,kk,lk,val)
#include "drt_h.fh"
#include "intsort_h.fh"
      dimension ind(4)
      list=0
      i=ik
      j=jk
      k=kk
      l=lk
      lri=min(i,j)
      lrj=max(i,j)
      lrk=min(k,l)
      lrl=max(k,l)
      if(lri.gt.lrk) then
        lrn=lrk
        lrk=lri
        lri=lrn
        lrn=lrl
        lrl=lrj
        lrj=lrn
      endif

      ind(1)=lri
      ind(2)=lrj
      ind(3)=lrk
      ind(4)=lrl
      do i=1,4
        do j=i+1,4
          if(ind(i).gt.ind(j)) then
            nt=ind(i)
            ind(i)=ind(j)
            ind(j)=nt
          endif
        enddo
      enddo

!      write(6,*) ind(1),ind(2),ind(3),ind(4)
!      goto 10
      if(ind(1).eq.ind(4)) then   !(iiii)
        vdint(lri,lri)=val
        goto 10
      endif

      if(lri.eq.lrj.and.lrk.eq.lrl) then   !(iikk)
        vdint(lrk,lri)=val
        goto 10
      endif

      if(lri.eq.lrk.and.lrj.eq.lrl) then   !(ijij)
!              if(lri.eq.1.and.lrj.eq.2) stop 888
        voint(lrj,lri)=val
        goto 10
      endif

      if(lri.ne.lrl.and.lrj.eq.lrk) then !(ijjl)
        list=list3_all(lri,lrl,lrj)
        vector1(list)=val
        if(lrj.eq.lrl) then
          vector1(list+1)=val
        endif
        if(lri.eq.lrj) then
          vector1(list+1)=val
        endif
        goto 10
      endif

      if(lri.ne.lrj.and.lrk.eq.lrl) then  !(ijkk)
        list=list3_all(lri,lrj,lrk)
        vector1(list+1)=val
        if(lrj.eq.lrk) then
          vector1(list)=val
        endif
        goto 10
      endif

      if(lri.eq.lrj.and.lrk.ne.lrl) then  !(iikl)
        list=list3_all(lrk,lrl,lri)
        vector1(list+1)=val
        goto 10
      endif

      if(lri.eq.lrk.and.lrj.ne.lrl) then      !(ijil)
        if(lrj.lt.lrl) then
          list=list3_all(lrj,lrl,lri)
        else
          list=list3_all(lrl,lrj,lri)
        endif
        vector1(list)=val
        goto 10
      endif

      if(lri.ne.lrk.and.lrj.eq.lrl) then   !(ijkj)
        list=list3_all(lri,lrk,lrj)
        vector1(list)=val
        if(lrj.eq.lrk) then
          vector1(list+1)=val
        endif
        goto 10
      endif

      if(lri.ne.lrj.and.lri.ne.lrk.and.
     *   lri.ne.lrl.and.lrj.ne.lrk.and.lrj.ne.lrl.and.lrk.ne.lrl) then
        list=list4_all(ind(1),ind(2),ind(3),ind(4))       !(ijkl)
        if(lrj.gt.lrk.and.lrj.gt.lrl) then
          vector1(list+2)=val
        endif
        if(lrj.gt.lrk.and.lrj.lt.lrl) then
          vector1(list)=val
        endif
        if(lrj.lt.lrk.and.lrj.lt.lrl) then
          vector1(list+1)=val
        endif

        goto 10
      endif

!10    write(6,*) "list=",list
10     return
      end

      subroutine int_index(numb)
#include "drt_h.fh"
#include "intsort_h.fh"
      dimension msob(8)

      msob=0
      do 12 la=norb_all,1,-1
        lra=norb_all-la+1
        ms = lsm(lra)
        msob(ms)=msob(ms)+1
        ncibl_all(la) = msob(ms)
12    continue

!      write(6,*)
c=======================================================================
c      write(6,'(1x,14i3)')(ncibl(i),i=1,14)

      numb = 1
      do 10  i = 1,norb_all-1
        do 11  j = i+1,norb_all
          lri=norb_number(i)
          lrj=norb_number(j)
          if(lsm(lri).ne.lsm(lrj)) goto 11
!          write(6,*) "lri=",lri,"lrj=",lrj
!          write(6,*) "lsm(lri)",lsm(lri),"lsm(lrj)",lsm(lrj)

          nij=i+ngw2(j)
c       write(6,*)'i,j,mij,nij   ',i,j,mij,nij
          loij_all(nij)=numb
!          do 20  k = 1,norb_all
!            vint_ci(numb)=vfutei(j,k,i,k)
!            vint_ci(numb+1)=vfutei(j,i,k,k)
c     write(10,'(2x,4i6,i8,3f16.8)')i,j,k,k, numb,
c    *        vint_ci(numb),vint_ci(numb+1)
            numb=numb+2*norb_all
!20        continue

11      continue
10    continue
!      write(6,*) "number 3 index",numb
!      stop 777
c=======================================================================
c      la<lb<lc<ld
      do 30 ld = 1,norb_all-3
        do 31 lc = ld+1,norb_all-2
          lrd=norb_all-ld+1
          lrc=norb_all-lc+1
          msd  = lsm(lrd)
          msc  = lsm(lrc)
          mscd = mul_tab(msd,msc)
          do 32 lb = lc+1,norb_all-1
            lrb=norb_all-lb+1
            msb = lsm(lrb)
            msa = mul_tab(mscd,msb)

            njkl=ld+ngw2(lc)+ngw3(lb)
            loijk_all(njkl) = numb

            nolra=0
            do 40 la = norb_all,lb+1,-1
              lra=norb_all-la+1
              if(lsm(lra).ne.msa) cycle
!              nolra=nolra+1
!              list = loijk_all(njkl)+3*(nolra-1)
!              write(6,*) "ld,lc,lb,la",ld,lc,lb,la,list

c        write(6,'(2x,4i3,2i7)')  la,lb,lc,ld,list,numb

!             vint_ci(numb)=vfutei(la,lc,lb,ld)        !tmp stop
!             vint_ci(numb+1)=vfutei(la,lb,lc,ld)
!             vint_ci(numb+2)=vfutei(la,ld,lc,lb)
c     write(10,'(2x,4i6,i8,3f16.8)')la,lb,lc,ld, numb,
c    *        vint_ci(numb),vint_ci(numb+1),vint_ci(numb+2)
              numb=numb+3
40         continue
32        continue
31      continue
30    continue
!              stop 777
      return
c=======================================================================
      end

      REAL*8 function vfutei(ix,jx,kx,lx)
#include "drt_h.fh"
#include "intsort_h.fh"
      dimension ind(4)
      lri=min(ix,jx)
      lrj=max(ix,jx)
      lrk=min(kx,lx)
      lrl=max(kx,lx)
      if(lri.gt.lrk) then
        lrn=lrk
        lrk=lri
        lri=lrn
        lrn=lrl
        lrl=lrj
        lrj=lrn
      endif
      val=0.d0
!      write(6,*) ind(1),ind(2),ind(3),ind(4)
      if(lri.ne.lrl.and.lrj.eq.lrk) then !(ijjl)
        list=list3_all(lri,lrl,lrj)
        val=vector1(list)
        goto 10
      endif

      if(lri.ne.lrj.and.lrk.eq.lrl) then  !(ijkk)
        list=list3_all(lri,lrj,lrk)
        val=vector1(list+1)
        goto 10
      endif

      if(lri.eq.lrj.and.lrk.ne.lrl) then  !(iikl)
        list=list3_all(lrk,lrl,lri)
        val=vector1(list+1)
        goto 10
      endif

      if(lri.eq.lrk.and.lrj.ne.lrl) then      !(ijil)
        if(lrj.lt.lrl) then
          list=list3_all(lrj,lrl,lri)
        else
          list=list3_all(lrl,lrj,lri)
        endif
        val=vector1(list)
        goto 10
      endif

      if(lri.ne.lrk.and.lrj.eq.lrl) then   !(ijkj)
        list=list3_all(lri,lrk,lrj)
        val=vector1(list)
        goto 10
      endif

      if(lri.ne.lrj.and.lri.ne.lrk.and.
     *   lri.ne.lrl.and.lrj.ne.lrk.and.lrj.ne.lrl.and.lrk.ne.lrl) then
        ind(1)=lri
        ind(2)=lrj
        ind(3)=lrk
        ind(4)=lrl
        do i=1,4
          do j=i+1,4
            if(ind(i).gt.ind(j)) then
              nt=ind(i)
              ind(i)=ind(j)
              ind(j)=nt
            endif
          enddo
        enddo

        list=list4_all(ind(1),ind(2),ind(3),ind(4))       !(ijkl)
        if(lrj.gt.lrk.and.lrj.gt.lrl) then
          val=vector1(list+2)
        endif
        if(lrj.gt.lrk.and.lrj.lt.lrl) then
          val=vector1(list)
        endif
        if(lrj.lt.lrk.and.lrj.lt.lrl) then
          val=vector1(list+1)
        endif
        goto 10
      endif

10    vfutei=val
      end

      function list3_all(i,j,k)
#include "drt_h.fh"
#include "intsort_h.fh"
c            *****************
      nij   = i+ngw2(j)
      list3_all = loij_all(nij)+2*(k-1)
c            *****************
      return
      end
c
c***********************************************************************
      function list4_all(ld,lc,lb,la)
#include "drt_h.fh"
#include "intsort_h.fh"
c                    ***************
!      write(6,*) "ld,lc,lb,la",ld,lc,lb,la
        lra  = ncibl_all(la)
        njkl = ld+ngw2(lc)+ngw3(lb)
        list4_all= loijk_all(njkl)+3*(lra-1)
c                    ***************
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine AltErr(K_Lap,Coeff,T,VV,Eps)
!-----------------------------------------------------------------------
! Function : Calculate errors in each points of alternant
!-----------------------------------------------------------------------

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: K_Lap
real(kind=wp), intent(in) :: Coeff(40), T(40)
real(kind=wp), intent(out) :: VV(40), Eps
integer(kind=iwp) :: I, I_Dim, J
real(kind=wp) :: X
real(kind=wp), external :: QuadErr

I_Dim = 2*K_Lap
Eps = Zero
J = I_Dim
do I=1,I_Dim
  X = T(J)
  VV(I) = QuadErr(K_Lap,X,Coeff)
  Eps = max(Eps,abs(VV(I)))
  J = J-1
end do

return

end subroutine AltErr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Per Ake Malmqvist                                *
*               2018, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine Print_CI_Mix(EigVec)
      Use RefWfn, Only: refwfn_active, refwfn_is_h5, refwfn_id,
     &                  refwfn_filename, refwfn_close, iadr15
#ifdef _HDF5_
      Use mh5, Only: mh5_open_file_r, mh5_fetch_dset
#endif
      Implicit None
#include "stdalloc.fh"
#include "rasdim.fh"
#include "caspt2.fh"
#include "pt2_guga.fh"
      Real*8 :: EigVec(nState,nState)
      Integer :: iState, iiState, jSNum, iDisk
      Real*8, Allocatable, Dimension(:) :: cCI, mCI
      Logical :: Close_refwfn


      Call mma_allocate(mCI, nConf, Label='MixCICoeff')
      Call mma_allocate(cCI, nConf, Label='CICoeff')

      Close_refwfn = .False.
      If (.Not.refwfn_active) Then
        ! bypass refwfn_open, because we don't want to set global stuff
        If (refwfn_is_h5) Then
#ifdef _HDF5_
          refwfn_id = mh5_open_file_r(refwfn_filename)
#else
* This should never happen
          Call AbEnd()
#endif
        Else
          refwfn_id=15
          Call DAName(refwfn_id,refwfn_filename)
        End If
        Close_refwfn = .True.
      End If

      Call CollapseOutput(1,'Mixed CI coefficients:')

      Write(6,*)
      Write(6,*)' The original CI arrays are now mixed as linear'
      Write(6,*)' combinations, given by the eigenvectors.'
      Write(6,*)

      Do iState=1,nState
        Call FZero(mCI, nConf)
        iDisk=iAdr15(4)
        Do iiState=1,nState
          jSNum=mState(iiState)
          If (refwfn_is_h5) Then
#ifdef _HDF5_
            Call mh5_fetch_dset(
     &           refwfn_id,'CI_VECTORS',cCI,[nConf,1],[0,jSNum-1])
#else
* This should never happen
            Call AbEnd()
#endif
          Else
            Call dDAFile(refwfn_id,2,cCI,nConf,iDisk)
          End If
          Call daXpY_(nConf,EigVec(iiState,iState),cCI,1,mCI,1)
        End Do
        Write(6,'(1X,A,I3)')
     &     ' The CI coefficients for the MIXED state nr. ',iState
        Call PrWf_CP2(stSym,nConf,mCI,CITHR)
      End Do

      Call CollapseOutput(0,'Mixed CI coefficients:')
      Write(6,*)

      If (Close_refwfn) Call refwfn_close()

      Call mma_deallocate(mCI)
      Call mma_deallocate(cCI)


      End Subroutine Print_CI_Mix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Bernd Schimmelpfennig                            *
!***********************************************************************

function LMdepang(L,M,l1,l2,l3,l4,m1,m2,m3,m4,cheater)
!bs   l1-l4 and m1-m4 are already shifted !!
!bs   purpose: calculates the angular part of the
!bs   coulomb-type integrals. See documentation for details...
!bs   LMdepang= LM dependent angular factors
!bs   cheater included for a correcting signs, as there were some
!bs   signs (only signs!!!!) missing when compared to HERMIT
!bs                                        B.S.  08.10.96

use Constants, only: Zero, One, Four, Pi
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: LMdepang
integer(kind=iwp), intent(in) :: L, M, l1, l2, l3, l4, m1, m2, m3, m4
real(kind=wp), intent(in) :: cheater
integer(kind=iwp) :: isum
real(kind=wp) :: fact1, fact2, fact3, sgn
real(kind=wp), external :: couple3J

LMdepang = Zero
!bs some quick checks
if (L < abs(M)) return
if (l1 < abs(m1)) return
if (l2 < abs(m2)) return
if (l3 < abs(m3)) return
if (l4 < abs(m4)) return
!bs prefactor
fact1 = Four*Pi/real(L+L+1,wp)
!bs determining the sign
isum = -l3-l1-l4-l2+2*(M+m3+m4)   !???? I am not sure
if (mod(isum,4) == 0) then
  sgn = One
else if (abs(mod(isum,4)) == 2) then
  sgn = -One
else
  sgn = Zero
  write(u6,*) 'L,l1,l2,l3,l4,M,m1,m2,m3,m4'
  write(u6,'(10I3)') L,l1,l2,l3,l4,M,m1,m2,m3,m4
  write(u6,*) 'isum= ',isum,' mod = ',mod(isum,4)
  call SysHalt('lmdepang')
end if
fact2 = couple3J(L,l3,l1,-M,m3,-m1)
fact3 = couple3J(L,l4,l2,M,m4,-m2)
!write(6,*) 'fact2,fact3 ',fact2,fact3
LMdepang = cheater*sgn*fact1*fact2*fact3

return

end function LMdepang

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine PCG_RES(ICONV)

use PrintLevel, only: TERSE, USUAL
use EQSOLV, only: iRHS, iVecc, iVecc2, iVecR, iVecX
use caspt2_global, only: iPrGlb
use caspt2_module, only: HZERO, MaxIt, MxCase, rNorm, ThrConv
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ICONV
integer(kind=iwp) :: ITER, IVECP, IVECT, IVECU
real(kind=wp) :: ALPHA, BETA, DSCALE, E2NONV, EAIVX, EATVX, EBJAI, EBJAT, EBVAT, ECORR(0:8,0:MXCASE), EVJAI, EVJTI, EVJTU, &
                 OVLAPS(0:8,0:MXCASE), PR, PT, UR
logical(kind=iwp) :: converged

! Flag to tell wether convergence was obtained
ICONV = 0
converged = .false.

! Mnemonic names for vectors stored on LUSOLV, see EQCTL.
! Here, we use the local names IVECP, IVECT, IVECU which are thus
! to be seen as overlayed areas. The true vectors IVECC and IVECC2
! are computed on return from this routine, so for a while we use them
! for temporaries.
IVECP = IVECC
IVECT = IVECC2
IVECU = IVECC2

ITER = 0
RNORM = Zero

! Solve equations for the diagonal case, in eigenbasis:
! Current solution vector X, Current residual vector R
call PSCAVEC(-One,IRHS,IVECR)
call PRESDIA(IVECR,IVECX,OVLAPS)
if (MAXIT == 0) then
  if (HZERO /= 'DYALL') then
    if (IPRGLB >= TERSE) then
      write(u6,*)
      write(u6,'(A)') repeat('-',115)
      write(u6,*) ' DIAGONAL CASPT2 APPROXIMATION:'
    end if
  end if
  converged = .true.
else

  ! Pre-conditioned conjugate gradient:
  ! R <- R - (H0-E0)*X
  call SIGMA_CASPT2(-One,One,IVECX,IVECR)
  call POVLVEC(IVECR,IVECR,OVLAPS)
  RNORM = sqrt(OVLAPS(0,0))
  if (RNORM < THRCONV) then
    converged = .true.
  else

    if (IPRGLB >= USUAL) then
      write(u6,*)
      write(u6,*) 'Solving the Lambda equation for analytic gradients'
      write(u6,'(A)') repeat('-',125)
      write(u6,'(2X,A)') 'IT.      VJTU        VJTI        ATVX        AIVX        VJAI        BVAT        BJAT        BJAI'// &
                         '        TOTAL       RNORM  '
      write(u6,'(A)') repeat('-',125)
    end if
    call PRESDIA(IVECR,IVECP,OVLAPS)
    ! PCG iteration loops:
    !---------------------
    do
      call POVLVEC(IVECP,IVECP,OVLAPS)
      DSCALE = One/sqrt(OVLAPS(0,0))
      call PSCAVEC(DSCALE,IVECP,IVECP)
      call POVLVEC(IVECP,IVECR,OVLAPS)
      PR = OVLAPS(0,0)
      call SIGMA_CASPT2(One,Zero,IVECP,IVECT)
      call POVLVEC(IVECP,IVECT,OVLAPS)
      PT = OVLAPS(0,0)
      ALPHA = PR/PT
      call PLCVEC(ALPHA,One,IVECP,IVECX)
      call PLCVEC(-ALPHA,One,IVECT,IVECR)
      call POVLVEC(IVECR,IVECR,OVLAPS)
      RNORM = sqrt(OVLAPS(0,0))
      if (RNORM < THRCONV) then
        converged = .true.
        exit
      end if
      ITER = ITER+1
      call POVLVEC(IRHS,IVECX,ECORR)
      EVJTU = ECORR(0,1)
      EVJTI = ECORR(0,2)+ECORR(0,3)
      EATVX = ECORR(0,4)
      EAIVX = ECORR(0,5)
      EVJAI = ECORR(0,6)+ECORR(0,7)
      EBVAT = ECORR(0,8)+ECORR(0,9)
      EBJAT = ECORR(0,10)+ECORR(0,11)
      EBJAI = ECORR(0,12)+ECORR(0,13)
      E2NONV = ECORR(0,0)
      if (IPRGLB >= USUAL) then
        write(u6,'(1X,I3,1X,10F12.6)') ITER,EVJTU,EVJTI,EATVX,EAIVX,EVJAI,EBVAT,EBJAT,EBJAI,E2NONV,RNORM
        call XFLUSH(u6)
      end if
      if (ITER >= MAXIT) exit
      call PRESDIA(IVECR,IVECU,OVLAPS)
      UR = OVLAPS(0,0)
      BETA = PR/UR
      call PLCVEC(BETA,One,IVECU,IVECP)
    end do
  end if
  !---------------------

  if (.not. converged) then
    if (IPRGLB >= TERSE) then
      write(u6,*)
      write(u6,*) ' NOT CONVERGED AFTER MAX ITERATIONS.'
    end if
    ICONV = 16
  end if
end if

if (IPRGLB >= TERSE) then
  write(u6,'(A)') repeat('-',125)
  write(u6,*)
end if

end subroutine PCG_RES

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine EPEMem( &
#                 define _CALLING_
#                 include "mem_interface.fh"
                 )

use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: iAngV(4), MemHrr, nFlop

#include "macros.fh"
unused_var(lr)

call mHrr(la,lb,nFlop,MemHrr)

nHer = (la+lb+2)/2
iAngV(1) = la
iAngV(2) = lb
iAngV(3) = 0
iAngV(4) = 0
call MemRys(iAngV,Mem)

Mem = max(Mem,MemHrr)

return

end subroutine EPEMem

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MINV(ARRAY,ARRINV,DET,NDIM)
!subroutine Dool(NDIM,MDIM,N,M,A,B,DET,IPIV,JPIV,BUF)
! SOLVES THE MATRIX EQUATION AX=B BY DOOLITTLE'S METHOD
! ACTUAL DIMENSIONS ARE N*N AND N*M
! ALLOCATED DIMENSIONS ARE NDIM*NDIM AND NDIM*MDIM
! A AND B ARE DESTROYED, AND X IS RETURNED AS MATRIX B
!                                   (MALMQUIST 82-11-12)
!                                    (UPDATE 83-09-28)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDIM
real(kind=wp), intent(in) :: ARRAY(NDIM,NDIM)
real(kind=wp), intent(out) :: ARRINV(NDIM,NDIM), DET
integer(kind=iwp) :: I, IDUM, ip, J, jp, K, KP, L, LP, M, N
real(kind=wp) :: AM, AMAX, C, DIAG, RSUM
integer(kind=iwp), allocatable :: IPIV(:), JPIV(:)
real(kind=wp), allocatable :: A(:,:), B(:,:), BUF(:)

call mma_allocate(A,NDIM,NDIM,label='A')
call mma_allocate(B,NDIM,NDIM,label='B')
call mma_allocate(BUF,NDIM,label='BUF')
call mma_allocate(IPIV,NDIM,label='IPIV')
call mma_allocate(JPIV,NDIM,label='JPIV')

! EQUATION IS SOLVED BY FACTORIZING A=L*R IN SAME SPACE AS A.
! PIVOTING IS ACHIEVED BY INDIRECT INDEXING.
! FIRST PIVOTING INDICES ARE ASSIGNED START VALUES.

! set N and M to NDIM since this subroutine is modified to only
! deal with square matrices.

N = NDIM
M = NDIM
!MDIM = NDIM

! Move ARRAY to allocation A and set the B matrix equal to the
! unity matrix

A(:,:) = ARRAY
call unitmat(B,NDIM)

! Let's go!!

ip = -1
jp = -1
do I=1,N
  IPIV(I) = I
  JPIV(I) = I
end do
DET = One
do I=1,N

  ! NOW FIND BETTER PIVOT ELEMENT:

  AMAX = -One
  do K=I,N
    do L=I,N
      AM = abs(A(IPIV(K),JPIV(L)))
      if (AMAX > AM) cycle
      AMAX = AM
      IP = K
      JP = L
    end do
  end do
  if (IP /= I) then
    DET = -DET
    IDUM = IPIV(I)
    IPIV(I) = IPIV(IP)
    IPIV(IP) = IDUM
  end if
  if (JP /= I) then
    DET = -DET
    IDUM = JPIV(I)
    JPIV(I) = JPIV(JP)
    JPIV(JP) = IDUM
  end if
  IP = IPIV(I)
  JP = JPIV(I)
  DIAG = A(IP,JP)
  BUF(I) = DIAG
  DET = DET*DIAG
  do K=I+1,N
    KP = IPIV(K)
    C = A(KP,JP)
    if (DIAG /= Zero) C = C/DIAG
    A(KP,JP) = C
    do L=I+1,N
      LP = JPIV(L)
      A(KP,LP) = A(KP,LP)-C*A(IP,LP)
    end do
  end do
end do

! FIRST RESUBSTITUTION STEP:

do J=1,M
  do I=2,N
    IP = IPIV(I)
    RSUM = B(IP,J)
    do K=1,I-1
      RSUM = RSUM-A(IP,JPIV(K))*B(IPIV(K),J)
    end do
    B(IP,J) = RSUM
  end do
end do

! SECOND RESUBSTITUTION STEP:

do J=1,M
  do I=N,1,-1
    IP = IPIV(I)
    RSUM = B(IP,J)
    do K=I+1,N
      RSUM = RSUM-A(IP,JPIV(K))*B(IPIV(K),J)
    end do
    if (BUF(I) /= Zero) RSUM = RSUM/BUF(I)
    B(IP,J) = RSUM
  end do
end do

! REORGANIZATION PART:

do J=1,M
  do I=1,N
    BUF(I) = B(IPIV(I),J)
  end do
  do I=1,N
    B(JPIV(I),J) = BUF(I)
  end do
end do

! Move the result to location ARRINV

ARRINV(:,:) = B

call mma_deallocate(A)
call mma_deallocate(B)
call mma_deallocate(BUF)
call mma_deallocate(IPIV)
call mma_deallocate(JPIV)

return

end subroutine MINV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine o12sa_cvb( &
#                    define _CALLING_
#                    include "opta_interface.fh"
                    )

use casvb_global, only: civb1, civb2, civb3, civb4, civb5, civb6, civb7, civb8, cvb, cvbdet, have_solved_it, icnt_ci, nprorb, nv, &
                        nvb, nvguess, nvrestart, nvrhs, odx, orbs, strucopt
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
#include "opta_interface.fh"
real(kind=wp), pointer :: vuse(:), vuse2(:)
integer(kind=iwp) :: icivb

nvrestart = 0
nvguess = 0
nvrhs = 0
have_solved_it = .false.

! Find CIVBS:
nullify(vuse)
vuse2 => civb3
if (nv >= 1) then
  icivb = nint(civb1(0))
  if (icnt_ci(icivb) == 4) vuse => civb1
end if
if (nv >= 2) then
  icivb = nint(civb2(0))
  if (icnt_ci(icivb) == 4) vuse => civb2
end if
if (nv >= 3) then
  icivb = nint(civb3(0))
  if (icnt_ci(icivb) == 4) vuse => civb3
end if
if (nv >= 4) then
  icivb = nint(civb4(0))
  if (icnt_ci(icivb) == 4) vuse => civb4
end if
if (nv >= 5) then
  icivb = nint(civb5(0))
  if (icnt_ci(icivb) == 4) vuse => civb5
end if
if (nv >= 6) then
  icivb = nint(civb6(0))
  if (icnt_ci(icivb) == 4) vuse => civb6
end if
if (nv >= 7) then
  icivb = nint(civb7(0))
  if (icnt_ci(icivb) == 4) vuse => civb7
end if
if (nv >= 8) then
  icivb = nint(civb8(0))
  if (icnt_ci(icivb) == 4) vuse => civb8
end if
if (associated(vuse)) then
  if (associated(vuse,civb3)) vuse2 => civb2
  call o12sa2_cvb(nparam,vuse2,vuse,cvbdet,cvb)
else
  if (strucopt) then
    call ddguess_cvb(cvb,nvb,nprorb)
  else
    call ddguess_cvb([One],1,0)
  end if
end if

call o12sa3_cvb(odx,cvb,orbs,civb1,civb2,civb3,cvbdet,nparam)

return

end subroutine o12sa_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      Subroutine ReadIn_CPF(H,iH)
      Implicit Real*8 (A-H,O-Z)
C Read input and allocate memory
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
#include "niocr.fh"
      Dimension IOCR(nIOCR)
      Dimension H(*), iH(*)
      Logical LWSP
      Common /SPIN/ LWSP
      Parameter ( nCmd=18 )
      Parameter ( mxTit=10 )
      Character*4 Command,Cmd(nCmd)
      Character*72  Line,Title(mxTit)
      Character*88  ModLine
      Data Cmd/'TITL','MAXP','LEVS','THRP','PRIN',
     *         'FROZ','DELE','MAXI','ECON','ETRS',
     *         'REST','MCPF','CPF ','SDCI','ACPF',
     *         'LOW ','EXTR','END '/
*
*---- convert a pointer in H to a pointer for iH
      ipointer(i)=(i-1)*RtoI+1
*
*---  Initialize arrays and variables ---------------------------------*
      KBUFF1=2*9600
      D0=0.0D0
      D1=1.0D0
      D2=2.0D0
      LWSP=.FALSE.
      SQ2=SQRT(D2)
      ETHRE=1.0D-06
      CTRSH=5.0D-02
      IPRINT=5
      MAXIT=20
      IREST=0
CPAM97      IRHP=0
      ICPF=0
      ISDCI=0
      INCPF=0
      ICONV=0
      MAXITP=6
      WLEV=0.3D0
      ETOT=0.0D0
      DO I=1,8
        NPFRO(I)=0
        NFRO(I)=0
        NDEL(I)=0
        NPDEL(I)=0
        NISH(I)=0
        NASH(I)=0
        NVAL(I)=0
        NVIR(I)=0
        NORB(I)=0
        NBAS(I)=0
      END DO
      NPFROT=0
      NFROT=0
      NDELT=0
      NPDELT=0
      NISHT=0
      NASHT=0
      NVALT=0
      NVIRT=0
      NORBT=0
      NBAST=0
      DO I=1,MXORB+1
        IROW(I)=I*(I-1)/2
      END DO
      DO I=1,99
        LW(I)=0
      END DO
      nTit=0
*
*---  read the header of TRAONE ---------------------------------------*
C Note: NORB(i)=NBAS(i)-NPFRO(i)-NPDEL(i)
      NAMSIZ=LENIN8*MXORB
      IDISK=0
      CALL WR_MOTRA_Info(Lu_TraOne,2,iDisk,
     &                   ITOC17,64, POTNUC,NSYM,
     *                   NBAS,NORB,NPFRO,NPDEL,8,NAME,NAMSIZ)
*
*---  Read input from standard input ----------------------------------*
      Call RdNLst(5,'CPF')
10    Read(5,'(A)',End=991) Line
      Command=Line(1:4)
      Call UpCase(Command)
      If ( Command(1:1).eq.'*' ) Goto 10
      jCmd=0
      Do iCmd=1,nCmd
         If ( Command.eq.Cmd(iCmd) ) jCmd=iCmd
      End Do
20    Goto ( 100, 200, 300, 400, 500, 600, 700 ,800, 900,1000,
     &      1100,1200,1300,1400,1500,1600,1700,1800           ) jCmd
      WRITE(6,*)'READIN Error: Command not recognized.'
      WRITE(6,*)'The command is:'//''''//Command//''''
      CALL QUIT_OnUserError()
*
*---  process TITL command --------------------------------------------*
100   Continue
      Read(5,'(A)',End=991) Line
      Command=Line(1:4)
      Call UpCase(Command)
      If ( Command(1:1).eq.'*' ) Goto 100
      jCmd=0
      Do iCmd=1,nCmd
         If ( Command.eq.Cmd(iCmd) ) jCmd=iCmd
      End Do
      If ( jCmd.ne.0 ) Goto 20
      nTit=nTit+1
      If ( nTit.le.mxTit ) Title(nTit)=Line
      Goto 100
*
*---  process MAXP command --------------------------------------------*
200   Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 200
      Read(Line,*,Err=992) MaxItP
      Goto 10
*
*---  process LEVS command --------------------------------------------*
300   Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 300
      Read(Line,*,Err=992) WLev
      Goto 10
*
*---  process THRP command --------------------------------------------*
400   Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 400
      Read(Line,*,Err=992) CTrsh
      Goto 10
*
*---  process PRIN command --------------------------------------------*
500   Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 500
      Read(Line,*,Err=992) iPrint
      Goto 10
*
*---  process FROZ command --------------------------------------------*
600   Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 600
      ModLine=Line//' 0 0 0 0 0 0 0 0'
      Read(ModLine,*,Err=992) (nFro(i),i=1,8)
      Goto 10
*
*---  process DELE command --------------------------------------------*
700   Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 700
      ModLine=Line//' 0 0 0 0 0 0 0 0'
      Read(ModLine,*,Err=992) (NDEL(i),i=1,8)
      Goto 10
*
*---  process MAXI command --------------------------------------------*
800   Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 800
      Read(Line,*,Err=992) MaxIt
      MaxIt=Min(MaxIt,75)
      Goto 10
*
*---  process ECON command --------------------------------------------*
900   Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 900
      Read(Line,*,Err=992) EThre
      Goto 10
*
*---  process ETRS command --------------------------------------------*
1000  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1000
CPAM97      Read(Line,*,Err=992) ETrsh
      Read(Line,*,Err=992) DUMMY
      WRITE(6,*)' WARNING: The obsolete ETRS command is ignored.'
      Goto 10
*
*---  process REST command --------------------------------------------*
1100  Continue
      iRest=1
      Goto 10
*
*---  process MCPF command --------------------------------------------*
1200  Continue
      iCPF=0
      iSDCI=0
      iNCPF=0
      Goto 10
*
*---  process CPF  command --------------------------------------------*
1300  Continue
      iCPF=1
      iSDCI=0
      iNCPF=0
      Goto 10
*
*---  process SDCI command --------------------------------------------*
1400  Continue
      iSDCI=1
      iCPF=0
      iNCPF=0
      Goto 10
*
*---  process ACPF command --------------------------------------------*
1500  Continue
      iNCPF=1
      iCPF=0
      iSDCI=0
      Goto 10
*
*---  process LOW  command --------------------------------------------*
1600  Continue
      LWSP=.true.
      Goto 10
*
*---  process EXTR command --------------------------------------------*
1700  WRITE(6,*) 'The EXTRACT option is redundant and is ignored!'
      Goto 10
*
*---  The end of the input is reached, print the title ----------------*
1800  Continue
      if(ntit.eq.0) then
        ntit=1
        title(1)=' ( No title was given )'
      end if
      WRITE(6,*)
      WRITE(6,'(6X,120A1)') ('*',i=1,120)
      WRITE(6,'(6X,120A1)') '*',(' ',i=1,118),'*'
      WRITE(6,'(6X,57A1,A6,57A1)')
     &        '*',(' ',i=1,56),'Title:',(' ',i=1,56),'*'
      Do i=1,nTit
         Call Center(Title(i))
         WRITE(6,'(6X,24A1,A72,24A1)')
     &        '*',(' ',j=1,23),Title(i),(' ',j=1,23),'*'
      End Do
      WRITE(6,'(6X,120A1)') '*',(' ',i=1,118),'*'
      WRITE(6,'(6X,120A1)') ('*',i=1,120)
      WRITE(6,*)
*
*---  print the coordinates of the system -----------------------------*
      Call PrCoor
*
*---  print the method used -------------------------------------------*
       WRITE(6,*)
      If ( iSDCI.eq.1 ) then
         WRITE(6,'(6X,A)') 'This is an  S D C I  calculation'
      Else If ( iCPF.eq.1 ) then
         WRITE(6,'(6X,A)') 'This is a  C P F  calculation'
      Else If( INCPF.eq.1 ) then
         WRITE(6,'(6X,A)') 'This is an  A C P F calculation'
      Else
         WRITE(6,'(6X,A)') 'This is an  M C P F  calculation'
      End If
      If ( LWSP ) WRITE(6,'(6X,A)') 'This is a LOW SPIN calculation'
      CALL XFLUSH(6)
*
*---  read the header of CIGUGA ---------------------------------------*
      IADD10=0
      CALL iDAFILE(Lu_CIGuga,2,IAD10,9,IADD10)
      iOpt=2
      nMUL=64
      nJJS=18
      nIRC=4
      Call WR_GUGA(Lu_CIGuga,iOpt,IADD10,
     &             NFREF,S,N,LN,NSYM,IR1,IRJ,IFIRST,INTNUM,
     &             LSYM,NREF,LN1,NRLN1,MUL,nMUL,NASH,NISH,8,
     &             IRC,nIRC,JJS,nJJS,NVAL,IOCR,nIOCR)
      If ( LN.ge.MXORB ) THEN
        WRITE(6,*)'READIN Error: Too many orbitals.'
        WRITE(6,'(1X,A,2I5)')'LN,MXORB:',LN,MXORB
        CALL QUIT_OnUserError()
      END IF
      LW(1)=1
      CALL iDAFILE(Lu_CIGuga,2,iH(iPointer(LW(1))),IR1,IADD10)
      LW(2)=LW(1)+(IR1+(RTOI-1))/RTOI
      CALL iDAFILE(Lu_CIGuga,2,iH(iPointer(LW(2))),IRJ,IADD10)
*
*---  update orbital specifications -----------------------------------*
      IV0=0
      IV1=1
      IV2=2
      IV3=3
      DO 811 I=1,NSYM
        NVIR(I)=NORB(I)-NFRO(I)-NISH(I)-NASH(I)
     &                 -NVAL(I)-NDEL(I)
        NPFROT=NPFROT+NPFRO(I)
        NFROT=NFROT+NFRO(I)
        NISHT=NISHT+NISH(I)
        NASHT=NASHT+NASH(I)
        NVALT=NVALT+NVAL(I)
        NVIRT=NVIRT+NVIR(I)
        NDELT=NDELT+NDEL(I)
        NPDELT=NPDELT+NPDEL(I)
        NORBT=NORBT+NORB(I)
        NBAST=NBAST+NBAS(I)
811   CONTINUE
      IN=0
      IR=0
      IVA=0
      IU=NISHT+NVALT
      IT=NVALT
      IV=LN
      NVIRT=0
      DO 7 I=1,NSYM
        NFROI=NFRO(I)
        NISHI=NISH(I)
        NASHI=NASH(I)
        NVALI=NVAL(I)
        NDELI=NDEL(I)
CPAM97      NVIRDI=NORB(I)-NFROI-NASHI-NISHI-NVALI
CPAM97      NVIR(I)=NVIRDI-NDEL(I)
        NVIRI=NVIR(I)
        NVIRT=NVIRT+NVIRI
        DO J=1,NFROI
          IN=IN+1
          IR=IR-1
          ICH(IN)=IR
        END DO
        DO J=1,NISHI
          IN=IN+1
          IT=IT+1
          ICH(IN)=IT
          NSM(IT)=I
        END DO
        DO J=1,NASHI
          IN=IN+1
          IU=IU+1
          ICH(IN)=IU
          NSM(IU)=I
        END DO
        DO J=1,NVALI
          IN=IN+1
          IVA=IVA+1
          ICH(IN)=IVA
          NSM(IVA)=I
        END DO
        DO J=1,NVIRI
          IN=IN+1
          IV=IV+1
          ICH(IN)=IV
          NSM(IV)=I
        END DO
        DO J=1,NDELI
          IN=IN+1
          ICH(IN)=0
        END DO
 7    CONTINUE
      NVT=IROW(NVIRT+1)
      NVT2=IROW(NVIRT)
*
*---  report input specifications -------------------------------------*
      WRITE(6,*)
      WRITE(6,'(6X,A)') 'ONE-ELECTRON BASIS:'
      WRITE(6,'(6X,A)') '----------------------------'
      WRITE(6,*)
      WRITE(6,'(6X,A,T47,4X,4X,8I4)') 'Symmetry species',
     &     (iSym,iSym=1,nSym)
      WRITE(6,*)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Orbitals pre-frozen in MOTRA',
     &     nPFroT,(nPFro(iSym),iSym=1,nSym)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Orbitals used by this program',
     &     norbT,(nOrb(iSym),iSym=1,nSym)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Pre-deleted in MOTRA',
     &     nPDelT,(nPDel(iSym),iSym=1,nSym)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Sum: No. of basis functions',
     &     nBasT,(nBas(iSym),iSym=1,nSym)
      CALL XFLUSH(6)
      WRITE(6,*)
      WRITE(6,'(6X,A)') 'ORBITAL SPECIFICATION:'
      WRITE(6,'(6X,A)') '-------------------------------'
      WRITE(6,*)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Orbitals frozen here',
     &     nFroT,(nFro(iSym),iSym=1,nSym)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Inactive orbitals',
     &     nIShT,(nISh(iSym),iSym=1,nSym)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Active orbitals',
     &     nAShT,(nASh(iSym),iSym=1,nSym)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Additional valence orbitals',
     &     nValT,(nVal(iSym),iSym=1,nSym)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Virtual orbitals',
     &     nVirT,(nVir(iSym),iSym=1,nSym)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Orbitals deleted here',
     &     nDelT,(nDel(iSym),iSym=1,nSym)
      WRITE(6,'(6X,A,T47,I4,4x,8I4)') 'Sum: Total no. of orbitals',
     &     norbT,(nOrb(iSym),iSym=1,nSym)
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,*)
      WRITE(6,'(6X,A)') 'WAVE FUNCTION SPECIFICATION:'
      WRITE(6,'(6X,A)') '----------------------------'
      WRITE(6,*)
      WRITE(6,'(6X,A,T47,I4)') 'Number of electrons in CI',N
      WRITE(6,'(6X,A,T47,I4)') 'Internal orbitals in CI',LN
      WRITE(6,'(6X,A,T47,I4)') 'External orbitals in CI',NVIRT
      WRITE(6,'(6X,A,T47,I4)') 'Number of irreps',NSYM
      WRITE(6,'(6X,A,T47,F4.1)') 'Spin quantum number',S
      WRITE(6,'(6X,A,T47,I4)') 'State symmetry',LSYM
      CALL XFLUSH(6)
      WRITE(6,*)
      WRITE(6,'(6X,A)') 'REFERENCE STATE:'
      WRITE(6,'(6X,A)') '------------------------------'
      WRITE(6,*)
      WRITE(6,'(6X,A,T47,I4)') 'Number of reference states',NREF
      LN2=MIN(16,LN1)
      If ( LN1.eq.0 ) then
         WRITE(6,'(6X,A,T47)') 'One closed shell reference state'
      Else
         WRITE(6,'(6X,A,T47)') 'Occupation of active orbitals in'
     &                       //' the reference state:'
         Write(6,'(6X,A,T25,16I4)')'Active orbital nr.',(I,I=1,LN2)
         jEnd=0
         Do iRef=1,nRef
            jStart=jEnd+1
            jEnd=jEnd+LN1
            Write(6,'(6X,A,I3,T25,16I4)')'Ref nr',IREF,
     &                                      (IOCR(j),j=jStart,jEnd)
         End Do
      End If
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,'(6X,A)') 'OPTIONS:'
      WRITE(6,'(6X,A)') '--------'
      WRITE(6,*)
      WRITE(6,'(6X,A,T47,I4)') 'Print parameter',iPrint
      WRITE(6,'(6X,A,T47)') 'Pulay diagonalization'
      If ( INTNUM.ne.0 ) WRITE(6,'(6X,A,T47)')
     &                        'First order interacting space'
CPAM97      If ( IRHP.ne.0 ) WRITE(6,'(6X,A,T47)') 'Root homing'
      IX1=IRC(1)
      IX2=IRC(2)-IRC(1)
      ISC(1)=IX1
      ISC(2)=ISC(1)+IX2*NVIRT
      IY1=ISC(1)
      IY2=ISC(2)-ISC(1)
      WRITE(6,214)
      CALL XFLUSH(6)
214   FORMAT(//,6X,'INTERNAL CONFIGURATIONS')
      IF(IFIRST.NE.0)GO TO 205
      IX3=IRC(3)-IRC(2)
      IX4=IRC(4)-IRC(3)
      ISC(3)=ISC(2)+IX3*NVT2
      ISC(4)=ISC(3)+IX4*NVT
      IY3=ISC(3)-ISC(2)
      IY4=ISC(4)-ISC(3)
      WRITE(6,215)IX1,IX2,IX3,IX4
      CALL XFLUSH(6)
215   FORMAT(/,6X,'NUMBER OF VALENCE STATES',I16,
     */,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7,
     */,6X,'NUMBER OF TRIPLET COUPLED DOUBLES',I7,
     */,6X,'NUMBER OF SINGLET COUPLED DOUBLES',I7)
      WRITE(6,213)
      CALL XFLUSH(6)
213   FORMAT(//,6X,'FULL-SPACE CONFIGURATIONS (FORMAL)')
      WRITE(6,215)IY1,IY2,IY3,IY4
      CALL XFLUSH(6)
      GO TO 206
205   WRITE(6,216)IX1,IX2
      CALL XFLUSH(6)
216   FORMAT(/,6X,'NUMBER OF VALENCE STATES',I16,
     */,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7)
      WRITE(6,213)
      CALL XFLUSH(6)
      WRITE(6,216)IY1,IY2
      CALL XFLUSH(6)
206   ILIM=4
      IF(IFIRST.NE.0)ILIM=2
C ERROR CONDITIONS:
C     IF(LN.NE.NISHT+NASHT+NVALT) THEN
C       WRITE(6,*)' ERROR: Orbital specifications do not match'
C       WRITE(6,*)' input to GUGA. The number of internal'
C       WRITE(6,*)' orbitals must equal the number of inactive,'
C       WRITE(6,*)' active, and additional valence orbitals.'
C       CALL QUIT(20)
C     END IF
C ALLOCATION FOR INDEX VECTORS
C THESE VECTORS ARE PERMANENTLY IN CORE
C -- INDEX
CPAM97      LW(3)=LW(2)+IRJ
      LW(3)=LW(2)+(IRJ+(RTOI-1))/RTOI
C -- ISAB
      LW(4)=LW(3)+IRC(ILIM)
      NVIR2=NVIRT*NVIRT
C -- JREFX
      LW(5)=LW(4)+NVIR2
      IADD10=IAD10(2)
      CALL iDAFILE(Lu_CIGuga,2,iH(iPointer(LW(5))),ISC(1),IADD10)
C -- ADDRESSES NOT USED
      LW(6)=LW(5)+ISC(1)
      LW(7)=LW(6)
      LW(8)=LW(7)
      LW(9)=LW(8)
      LW(10)=LW(9)
C -- LIMIT FOR PERMANENT VECTORS
      LPERMA=LW(10)
      CALL dINDMAT(H)
      CALL ALLOC_CPF(ISMAX,LPERMA)
      RETURN
*
991   Continue
      WRITE(6,*)'READIN Error: Premature end of file while reading.'
      Call Quit_OnUserError()
992   Continue
      WRITE(6,*)'READIN Error: I/O error during internal read.'
      WRITE(6,*)'The line that could not be read is:'
      WRITE(6,*) Line
      Call Quit_OnUserError()
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE dINDMAT(H)
      USE ISO_C_BINDING
      REAL*8, TARGET :: H(*)
      INTEGER, POINTER :: iH2(:),iH3(:),iH4(:),iH5(:)
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL C_F_POINTER(C_LOC(H(LW(4))),iH4,[1])
      CALL C_F_POINTER(C_LOC(H(LW(5))),iH5,[1])
      CALL INDMAT_CPF(iH2,iH3,iH4,ISMAX,iH5)
      NULLIFY(iH2,iH3,iH4,iH5)
      END SUBROUTINE dINDMAT
*
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKMAW(NLEV,NVERT,IDOWN,IDAW,IUP,IRAW,IMAW,
     &                 LTV,MIDLEV)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='MKMAW')
      DIMENSION IDOWN(NVERT,0:3),IDAW(NVERT,0:4)
      DIMENSION IUP(NVERT,0:3),IRAW(NVERT,0:4)
      DIMENSION IMAW(NVERT,0:3),LTV(-1:NLEV)
C Purpose: Construct the Modified Arc Weights




C BEGIN BY CONSTRUCTING THE UPCHAIN TABLE IUP:
      DO IV=1,NVERT
        DO IC=0,3
          IUP(IV,IC)=0
        END DO
      END DO
      DO IU=1,NVERT-1
        DO IC=0,3
          IDWN=IDOWN(IU,IC)
          IF(IDWN.NE.0) IUP(IDWN,IC)=IU
        END DO
      END DO
C USE UPCHAIN TABLE TO CALCULATE THE REVERSE ARC WEIGHT TABLE:
      DO IC=0,3
        IRAW(1,IC)=0
      END DO
      IRAW(1,4)=1
      DO IV=2,NVERT
        ISUM=0
        DO IC=0,3
          IRAW(IV,IC)=0
          IU=IUP(IV,IC)
          IF(IU.NE.0) THEN
            IRAW(IV,IC)=ISUM
            ISUM=ISUM+IRAW(IU,4)
          END IF
        END DO
        IRAW(IV,4)=ISUM
      END DO
C USE IDAW,IRAW TABLES TO DETERMINE MIDLEV.
C ASSUMPTION IS THAT A BALANCED NUMBER OF UPPER/LOWER WALKS
C IS THE BEST CHOICE.
      MIDLEV=1
      MINW=1000000
      DO IL=1,NLEV-1
        NW=0
        DO IV=LTV(IL),LTV(IL-1)-1
          NW=NW+IRAW(IV,4)-IDAW(IV,4)
        END DO
        NW=ABS(NW)
        IF(NW.LT.MINW) THEN
          MIDLEV=IL
          MINW=NW
        END IF
      END DO
      MIDV1=LTV(MIDLEV)
      MIDV2=LTV(MIDLEV-1)-1
C COPY LOWER PART OF DIRECT ARC WEIGHT TABLE INTO IMAW:
      DO IV=MIDV1,NVERT
        DO IC=0,3
          IMAW(IV,IC)=IDAW(IV,IC)
        END DO
      END DO
C COPY UPPER PART OF REVERSE ARC WEIGHT TABLE INTO IMAW. HOWEVER,
C    NOTE THAT THE IMAW TABLE IS ACCESSED BY THE UPPER VERTEX.
      DO IU=1,MIDV1-1
        DO IC=0,3
          ID=IDOWN(IU,IC)
          IMAW(IU,IC)=0
          IF(ID.NE.0) IMAW(IU,IC)=IRAW(ID,IC)
        END DO
      END DO
C COPY UPPER PART OF REVERSE ARC WEIGHT TABLE INTO IMAW. HOWEVER,
C FINALLY, ADD AN OFFSET TO ARCS LEADING TO MIDLEVELS:
      ISUM=1
      DO IV=MIDV1,MIDV2
        DO IC=0,3
          IU=IUP(IV,IC)
          IF(IU.NE.0) IMAW(IU,IC)=ISUM+IMAW(IU,IC)
        END DO
        ISUM=ISUM+IRAW(IV,4)
      END DO
      DO IV=MIDV1,MIDV2
        DO IC=0,3
          IF(IDOWN(IV,IC).NE.0) IMAW(IV,IC)=ISUM+IMAW(IV,IC)
        END DO
        ISUM=ISUM+IDAW(IV,4)
      END DO

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module iSD_data

use Definitions, only: iwp

implicit none
private

! nSh2BF   - field with dim. nIrrep,nShlls
!            # SO functions in irrep for shell iShell
! iShOff   - field with dim. nIrrep,nShlls
!            position of 1st component of iShell in irrep
! iSh2Sh   - field with dim. nShlls*nIrrep
!            pseudo shell index of iShell in irrep
!            (not any iShell contributes to all irreps)
! nShIrp(0:nIrrep-1)
!          - # of shells contributing to each irrep
! nShBFMx  - largest shell size (of all irrep, all shells)
! iSO2Sh   - field with dim. nDim
!            shell the SO index iSO in irp belongs to
! icntr  - field holding center number for each shell

integer(kind=iwp), parameter :: nSD = 20
integer(kind=iwp) :: nShBFMx, nShIrp(0:7), nSkal_iSD
integer(kind=iwp), allocatable :: iCntr(:), iSD(:,:), iSh2Sh(:,:), iShOff(:,:), iSO2Sh(:), nShBF(:,:)

public :: iCntr, iSD, iSh2Sh, iShOff, iSO2Sh, nSD, nShBF, nShBFMx, nShIrp, nSkal_iSD

end module iSD_data

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jeppe Olsen                                            *
************************************************************************
      SUBROUTINE GTSTTP(ICLS,IEL1,IEL3,ITYPE,IWAY)
*
*
* Relation between number of electrons in RAS1, RAS3 and string type
*
* IWAY = 1 :
* Get ITYPE : type of strings belonging to class ICLS
*             with IEL1,IEL3 electrons
* IWAY = 2 :
* GET IEL1,IEL3 : Number of electrons of classs ICLS of type ITYPE
*
*
* Jeppe Olsen, Another lonely night in Lund
*
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "detdim.fh"
#include "WrkSpc.fh"
#include "strbas_mclr.fh"
#include "stinf_mclr.fh"
*
      CALL GTSTTPS(IEL1,IEL3,iWORK(KEL1(ICLS)),iWORK(KEL3(ICLS)),
     &             NOCTYP(ICLS),ITYPE,IWAY)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1995, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine XRys2D(xyz2D,nArg,lRys,nabMax,ncdMax,PAWP,QCWQ,B10,B00,B01)
!***********************************************************************
!                                                                      *
! Object: to compute the 2-dimensional integrals of the Rys            *
!         quadrature. The z components are assumed to be pre-          *
!         conditioned with the weights of the roots of the             *
!         Rys polynomial.                                              *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
! Modified loop structure for RISC 1991 R. Lindh Dept. of Theoretical  *
! Chemistry, University of Lund, Sweden.                               *
! Modified for external field version, Feb '95.                        *
! VV: improve loop structure                                           *
!***********************************************************************

use Constants, only: One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nArg, lRys, nabMax, ncdMax
real(kind=wp), intent(inout) :: xyz2D(nArg*lRys,3,0:nabMax,0:ncdMax)
real(kind=wp), intent(in) :: PAWP(nArg*lRys,3), QCWQ(nArg*lRys,3), B10(nArg*lRys,3), B00(nArg*lRys,3), B01(nArg*lRys,3)
integer(kind=iwp) :: iab, in_
#ifdef _DEBUGPRINT_
character(len=30) :: Label
#endif

#ifdef _DEBUGPRINT_
iRout = 15
iPrint = nPrint(iRout)
if (iPrint >= 59) then
  if (nabMax > 0) call RecPrt('PAWP',' ',PAWP,nArg,lRys*3)
  if (ncdMax > 0) call RecPrt('QCWQ',' ',QCWQ,nArg,lRys*3)
  call RecPrt(' B10',' ',B10,nArg*lRys,3)
  call RecPrt(' B00',' ',B00,nArg*lRys,3)
  call RecPrt(' B01',' ',B01,nArg*lRys,3)
end if
#endif

! Compute 2D integrals with index (0,0). Observe that the z
! component already contains the weight factor.

xyz2D(:,1:2,0,0) = One

! Span first I(i,0)

if (nabMax >= 1) then
  xyz2D(:,:,1,0) = PAWP(:,:)*xyz2D(:,:,0,0)
  do iab=1,nabMax-1
    xyz2D(:,:,iab+1,0) = PAWP(:,:)*xyz2D(:,:,iab,0)+real(iab,kind=wp)*B10(:,:)*xyz2D(:,:,iab-1,0)
  end do
end if

! Now do the rest!

if (ncdMax >= 1) then
  xyz2D(:,:,0,1) = QCWQ(:,:)*xyz2D(:,:,0,0)
  do iab=1,nabMax
    xyz2D(:,:,iab,1) = QCWQ(:,:)*xyz2D(:,:,iab,0)+real(iab,kind=wp)*B00(:,:)*xyz2D(:,:,iab-1,0)
  end do
end if
do in_=1,ncdMax-1
  xyz2D(:,:,0,in_+1) = QCWQ(:,:)*xyz2D(:,:,0,in_)-real(in_,kind=wp)*B01(:,:)*xyz2D(:,:,0,in_-1)
  do iab=1,nabMax
    xyz2D(:,:,iab,in_+1) = QCWQ(:,:)*xyz2D(:,:,iab,in_)+real(iab,kind=wp)*B00(:,:)*xyz2D(:,:,iab-1,in_)- &
                           real(in_,kind=wp)*B01(:,:)*xyz2D(:,:,iab,in_-1)
  end do
end do

#ifdef _DEBUGPRINT_
if (iPrint >= 99) then
  write(u6,*) ' 2D-integral computed in XRys2D'
  do iab=0,nabMax
    do icd=0,ncdMax
      write(Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(x)'
      call RecPrt(Label,' ',xyz2D(:,1,iab,icd),nArg,lRys)
      write(Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(y)'
      call RecPrt(Label,' ',xyz2D(:,2,iab,icd),nArg,lRys)
      write(Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(z)'
      call RecPrt(Label,' ',xyz2D(:,3,iab,icd),nArg,lRys)
    end do
  end do
end if
#endif

return

end subroutine XRys2D

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module OutPut_RAS
!------------------------------------------------------
! Used by any rasscf subroutine that writes output
! LF = Logfile unit number, usually = 6 for standard out
!------------------------------------------------------
!***********************************************************************
!                                                                      *
!      Termination codes of the different program sections             *
!                                                                      *
!***********************************************************************
!
! Rc_CI   =  0 : CI-vectors are converged
!         = 16 : No convergence in the CI-section
!
! Rc_SX   =  0 : Super-CI method converged
!         = 16 : No convergence in the SX-section

use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: IPRGLB, IPRLOC(7), LF, Rc_CI, Rc_SX

public :: IPRGLB, IPRLOC, LF, Rc_CI, Rc_SX

end module OutPut_RAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2002, Pawel Salek                                      *
!               2002, Mark A. Watson                                   *
!***********************************************************************
MODULE fmm_tree_buffer
   ! Pawel Salek
   ! approx. 2002.05.13
   ! Mark Watson : Sep. 2002.
   ! Generalised to allow for translation pairs too.
   ! i.e. can store and evaluate on the fly W-pairs
   ! Also included field for dynamic LMAX
   !
   ! fmm_tree_buffer packs together interaction pairs having same R vector
   ! to reduce the cost of generating interactions matrices T - the matrix
   ! is constructed only once for entire set.
   ! This module needs a routine that will evaluate entire set corresponding
   ! to same R vector.
   !
   ! One limitation cast on the implementation is to use possibly
   ! large but limited memory resources. This requires an ability to evaluate
   ! and expunge occasionally the interaction sets as they are created.
   !
   ! The pack_inter_tree is used to find out unique translation vectors.
   ! This is done by sorting all translation vectors first into
   ! surfaces, then into lines within surfaces, and finally into
   ! unique points.

   USE fmm_global_paras
   USE fmm_stats

   ! Public functions:
   PUBLIC :: fmm_tree_buffer_init,     &
             fmm_tree_buffer_finish,   &
             fmm_tree_buffer_add

   ! Public types:
   PUBLIC :: PointNode

   PRIVATE
   INTEGER(INTK), SAVE :: pack_sort_order

   ! PointNode: private structure used
   ! for on-the-fly packing of the interactions.
   !
   TYPE PointNode
      INTEGER(INTK)            :: level !for debugging:1-plane, 2-line, etc
      REAL(REALK)              :: coord ! normalized, the vector scale==1
      TYPE(PointNode), POINTER :: left, right
      ! the one below used by non-leaves only
      TYPE(PointNode), POINTER :: this ! for level==1: this plane,
      !     level==2: this line
      !     level==3: self (for consistency)
      ! the three below used by leaves only (i.e. ones with level==3)
      TYPE(T_paras), POINTER :: abl1l2(:)
      ! largest LMAX in each abl1l2 set stored here
      INTEGER(INTK)          :: entries_used
      INTEGER(INTK)          :: LHS_LMAX, RHS_LMAX, LMAX
     ! For translations must know if qlm or Vff translation
      CHARACTER(LEN=1)       :: N_or_T
   END TYPE PointNode

   ! PRIVATE DATA
   ! pack_inter_tree is a pack-on-the-fly, evaluate-when-needed structure for
   ! efficient, memory-adapted, R-vector packed evaluation of the
   ! interaction pairs.
   TYPE(PointNode), ALLOCATABLE,TARGET,SAVE :: pack_inter_tree(:)
   INTEGER(INTK), SAVE                      :: pack_inter_tree_used
   INTEGER(INTK),SAVE                       :: pack_total_in_current_chunk

CONTAINS
   !---------------------------------------------------------------------------
   ! fmm_tree_buffer_init:
   ! initialize data structures and counters when starting packing the tree.
   ! interaction sorting depends on whether the contraction scheme is
   ! T-matrix driven or U-matrix driven.  Here we initialise a
   ! module-wide logical to determine this for all schemes
   !
   SUBROUTINE fmm_tree_buffer_init(t_size, sort_order)
      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: t_size
      INTEGER(INTK), INTENT(IN) :: sort_order

      ALLOCATE(pack_inter_tree(t_size))
      pack_inter_tree_used = 0
      pack_sort_order      = sort_order
      pack_total_in_current_chunk = 0
   END SUBROUTINE fmm_tree_buffer_init

   !---------------------------------------------------------------------------

   SUBROUTINE fmm_tree_buffer_finish(pack_ev)
      IMPLICIT NONE
      TYPE(PointNode), POINTER :: root
      EXTERNAL pack_ev

      IF(pack_inter_tree_used>0) THEN
         root => pack_inter_tree(1)
         CALL fmm_tpack_process(root, pack_ev)
         pack_inter_tree_used = 0
         pack_total_in_current_chunk = 0
      END IF
      IF (ALLOCATED(pack_inter_tree)) DEALLOCATE(pack_inter_tree)
   END SUBROUTINE fmm_tree_buffer_finish

   !---------------------------------------------------------------------------

   SUBROUTINE fmm_tpack_process(root, pack_ev)
      IMPLICIT NONE
      TYPE(PointNode), POINTER :: root
      EXTERNAL pack_ev

      INTEGER(INTK) :: i

      CALL node_evaluator(root, 1_INTK, pack_ev)

      DO i=1, pack_inter_tree_used
         IF(ASSOCIATED(pack_inter_tree(i)%abl1l2))&
              & DEALLOCATE(pack_inter_tree(i)%abl1l2)
         NULLIFY(pack_inter_tree(i)%abl1l2) ! not strictly neccesary
      END DO
      pack_inter_tree_used = 0
      pack_total_in_current_chunk = 0
      NULLIFY(root)
   END SUBROUTINE fmm_tpack_process

   ! ===================================================================
   ! point_node_new:
   ! NOTE: we choose for conveninence that:
   ! a). non-leaves have abl1l2 not associated.
   ! b). leaves have leaf%this => leaf
   RECURSIVE SUBROUTINE point_node_new(node,level,r,ll,lr,lm,NT,T_pair)
      IMPLICIT NONE
      TYPE(PointNode), POINTER    :: node
      TYPE(T_paras),   INTENT(IN) :: T_pair
      REAL(REALK),     INTENT(IN) :: r(3)
      INTEGER(INTK),   INTENT(IN) :: level
      ! put these variables in a TYPE ??
      INTEGER(INTK),   INTENT(IN) :: ll,lr,lm
     ! For translations must know if qlm or Vff translation
      CHARACTER(LEN=1),INTENT(IN) :: NT

      pack_inter_tree_used = pack_inter_tree_used + 1
      node => pack_inter_tree(pack_inter_tree_used)
      node%level = level
      node%coord = r(level)
      NULLIFY(node%left); NULLIFY(node%right)
      IF(level<3) THEN
         NULLIFY(node%abl1l2)
         CALL point_node_new(node%this, level+1_INTK, r,ll,lr,lm,NT, T_pair)
      ELSE
         stat_tpack_unique = stat_tpack_unique + 1
         node%this => node
         node%entries_used = 1
         node%LMAX     = lm
         node%LHS_LMAX = ll
         node%RHS_LMAX = lr
         node%N_or_T   = NT
         ALLOCATE(node%abl1l2(START_LEN))
         node%abl1l2(1) = T_pair
      END IF
   END SUBROUTINE point_node_new

   !---------------------------------------------------------------------------
   ! node_evaluator:
   ! walks over the tree and evaluates the interaction pairs.
   !
   RECURSIVE SUBROUTINE node_evaluator(node, level, pack_ev)
      IMPLICIT NONE
      TYPE(PointNode), POINTER  :: node
      INTEGER(INTK), INTENT(IN) :: level
      EXTERNAL pack_ev   ! pair evaluator

      REAL(REALK), SAVE :: r(3)

      IF(.NOT.ASSOCIATED(node)) RETURN
      IF(ASSOCIATED(node%left)) CALL node_evaluator(node%left, level,pack_ev)
      IF(ASSOCIATED(node%right))CALL node_evaluator(node%right,level,pack_ev)
      r(level) = node%coord
      IF(level<3) THEN
         CALL node_evaluator(node%this, level+1_INTK, pack_ev)
      ELSE
         ! evaluate current point using provided evaluator.
         ! We sort node%ratio node%abl1l2 wrt to abl1l2(:)%RHS_id first.
         IF(node%entries_used>1) THEN
            CALL momentsort(node%abl1l2, node%entries_used)
         ENDIF
         CALL fmm_interface_T_pair_out(pack_ev,r,node)
      END IF

   END SUBROUTINE node_evaluator

   !---------------------------------------------------------------------------

   SUBROUTINE momentsort(abl1l2, N)
      IMPLICIT NONE
      TYPE(T_paras), INTENT(INOUT) :: abl1l2(:)
      INTEGER(INTK), INTENT(IN)    :: N
      TYPE(T_paras) :: idxs
      INTEGER(INTK) :: i

      DO i = N/2, 1, -1
         CALL downheap(abl1l2, i, N)
      END DO

      ! abl1l2[1..N] is a heap now

      DO i=N,1,-1
         idxs      = abl1l2(i)
         abl1l2(i) = abl1l2(1)
         abl1l2(1) = idxs
         CALL downheap(abl1l2,1_INTK,i-1_INTK) ! restore a[1..i-1] heap
      END DO
   END SUBROUTINE momentsort

   !---------------------------------------------------------------------------

   SUBROUTINE downheap(abl1l2, lo, hi)
      IMPLICIT NONE
      TYPE(T_paras), INTENT(INOUT) :: abl1l2(:)
      INTEGER(INTK), INTENT(IN)    :: lo, hi

      !  PRE: a[lo+1..hi] is a heap
      ! POST:  a[lo..hi]  is a heap
      TYPE(T_paras) :: idxs
      INTEGER(INTK) :: idx, child

      idxs  = abl1l2(lo)

      idx = lo
      makeheap: DO WHILE(idx <= hi/2) ! while k has child(s)
         child = 2*idx
         ! pick larger child...
         IF(child<hi) THEN ! exists right branch
            IF (pack_sort_order==SORT_BY_RHS_MMS) THEN
               IF(abl1l2(child)%RHS_id<abl1l2(child+1)%RHS_id .OR. &
                    & ((abl1l2(child)%RHS_id==abl1l2(child+1)%RHS_id &
                    & .AND. abl1l2(child)%ratio<abl1l2(child+1)%ratio)))&
                    &          child = child+1
            ELSE
               IF(abl1l2(child)%ratio<abl1l2(child+1)%ratio .OR. &
                 (ABS(abl1l2(child)%ratio-abl1l2(child+1)%ratio)&
                      <DISTINCT_T_TOL .AND. &
                  abl1l2(child)%RHS_id<abl1l2(child+1)%RHS_id)) child = child+1
            END IF
         END IF
         IF (pack_sort_order==SORT_BY_RHS_MMS) THEN
            IF(idxs%RHS_id >= abl1l2(child)%RHS_id) EXIT makeheap
         ELSE
            IF(idxs%ratio >= abl1l2(child)%ratio) EXIT makeheap
         END IF
         abl1l2(idx) = abl1l2(child)
         idx = child
      END DO makeheap

      abl1l2(idx) = idxs
   END SUBROUTINE downheap

   !---------------------------------------------------------------------------
   ! fmm_tree_buffer_add:
   ! creates packed list of interactions corresponding to the same R.
   ! packing is done as-you-go, without creation of the intermediate
   ! unpacked list. Tree structure is used for sorting.
   ! Appends given data to specified tree.
   ! direction is a normalized r_pq with positive x component.
   SUBROUTINE fmm_tree_buffer_add(pack_ev,T_pair_in)
      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: T_pair_in
      EXTERNAL pack_ev ! packed pair evaluator

      ! Local variables.
      TYPE(PointNode), POINTER :: node
      TYPE(T_paras),   POINTER :: newblock(:)
      TYPE(T_paras)            :: new_T_pair
      INTEGER(INTK)            :: level
      REAL(REALK)              :: r_pq(3)
      REAL(REALK)              :: direction(3), r_pq_scale
      ! orders of multipole expanions per node
      INTEGER(INTK)            :: ll,lr,lm
      ! for translations must know if qlm or Vff translation per node
      CHARACTER(LEN=1)         :: NT

      r_pq = T_pair_in%r_ab
      new_T_pair = T_pair_in%paras
      NT = T_pair_in%N_or_T
      ll = T_pair_in%paras%LHS_LMAX
      lr = T_pair_in%paras%RHS_LMAX
      lm = T_pair_in%LMAX

      node => pack_inter_tree(1) ! root is the first element of pack_inter_tree
      IF(pack_inter_tree_used+3 > SIZE(pack_inter_tree).OR.&
         pack_total_in_current_chunk>MAX_AVG_PER_NODE*SIZE(pack_inter_tree))&
         THEN
         stat_tpack_chunks = stat_tpack_chunks + one
         CALL fmm_tpack_process(node, pack_ev)
      END IF

      ! do the job
      stat_tpack_total = stat_tpack_total + 1
      pack_total_in_current_chunk = pack_total_in_current_chunk+1
      r_pq_scale = SQRT(SUM(r_pq*r_pq))
      IF(r_pq(1).LT.0.0) r_pq_scale = -r_pq_scale
      direction = r_pq/r_pq_scale
      ! update ratio (r_ab is now the normalised vector)
      new_T_pair%ratio = r_pq_scale

      IF(pack_inter_tree_used==0) THEN
         CALL point_node_new(node,1_INTK,direction,ll,lr,lm,NT,new_T_pair)
         RETURN
      END IF

      ! level = 1 - searching for plane, 2 - searching for line, 3 - for point
      DO level = 1, 3
         nodesearch: DO WHILE(ABS(direction(level)-node%coord)>DISTINCT_T_TOL)
            IF(direction(level)<node%coord) THEN
               IF(.NOT.ASSOCIATED(node%left)) THEN
                  CALL point_node_new(node%left,level,direction,&
                                      ll,lr,lm,NT,new_T_pair)
                  RETURN
               ELSE
                  node => node%left
               ENDIF
            ELSE
               IF(.NOT.ASSOCIATED(node%right)) THEN
                  CALL point_node_new(node%right,level,direction,&
                                      ll,lr,lm,NT,new_T_pair)
                  RETURN
               ELSE
                  node => node%right
               ENDIF
            END IF
         END DO nodesearch
         node => node%this ! node%this points to node for leaves
      END DO

      ! append to the current point. It is guaranteed to be the final point
      ! expand first data block if needed.
      IF(node%entries_used==SIZE(node%abl1l2)) THEN
         ALLOCATE(newblock(node%entries_used*2))
         !node%abl1l2(1:node%entries_used): index removed to avoid crash on IBM
         newblock(1:node%entries_used) = node%abl1l2
         DEALLOCATE(node%abl1l2)
         node%abl1l2 => newblock
      END IF
      node%entries_used = node%entries_used +1
      IF (node%N_or_T /= NT) CALL fmm_quit('inconsistent data in buffer node!')
      node%N_or_T = NT
      node%LHS_LMAX = MAX(node%LHS_LMAX, ll)
      node%RHS_LMAX = MAX(node%RHS_LMAX, lr)
      node%LMAX = MAX(node%LMAX, lm)
      node%abl1l2(node%entries_used) = new_T_pair

   END SUBROUTINE fmm_tree_buffer_add

   !---------------------------------------------------------------------------
   ! Here we transform the data of this packer (old) into the new format

   SUBROUTINE fmm_interface_T_pair_out(pack_ev,r,node)

      IMPLICIT NONE
      TYPE(PointNode), INTENT(IN) :: node
      REAL(REALK),     INTENT(IN) :: r(3)
      EXTERNAL pack_ev

      TYPE(T_pair_list) :: T_pairs_out

      T_pairs_out%N_or_T = node%N_or_T
      T_pairs_out%r_ab = r  ! normalised vector
      T_pairs_out%paras => node%abl1l2(1:node%entries_used)

      T_pairs_out%LMAX = node%LMAX
      T_pairs_out%lm_max = (1+node%LMAX)**2
      T_pairs_out%LHS_LMAX = node%LHS_LMAX
      T_pairs_out%RHS_LMAX = node%RHS_LMAX

      CALL pack_ev(T_pairs_out)

   END SUBROUTINE fmm_interface_T_pair_out

   !---------------------------------------------------------------------------

END MODULE fmm_tree_buffer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Giovanni Ghigo                                   *
************************************************************************
*  Cho_GenE
*
*> @brief
*>   Routine for the generation of the ``A,B`` block of exchange integrals (in symmetries \p iSymA, \p iSymB)
*>   for occupied MO \p iI, \p iJ in symmetries \p iSymI, \p iSymJ
*> @author Giovanni Ghigo
*>
*> @details
*> The routine generates the ``A,B`` block of integrals gathering 9
*> sub-blocks. These are combination of inactive, active, and
*> secondary ``A,B`` MO.
*>
*> @param[in] iSymI,iSymJ,iSymA,iSymB Symmetry block of the two-electrons integrals
*> @param[in] NumV                    Number of Cholesky vectors to transform in the current batch
*> @param[in] iAddEx                  Memory pointer of the ``A,B`` integrals block
*> @param[in] LenEx                   Length of the ``A,B`` integrals block
************************************************************************
      Subroutine Cho_GenE(iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV,
     &                      iAddEx,LenEx)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden & Torino University, Italy         *
*           Jannuary-June 2005                                         *
*----------------------------------------------------------------------*
* This is the routine that really generates the A,B block of exchange  *
* integrals (in symmetries iSymA,iSymB) for occupied MO iI,iJ in       *
* symmetries iSymI,iSymJ. The 3 x 3 A,B block is built gathering 9     *
* sub-blocks. These are combination of inactive, active, and secondary *
* A,B MO                                                               *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Dimension iAddSB(3,3), LenSB(3,3)

      Do iSB_A = 1, 3
        Do iSB_B = 1, 3
          iAddSB(iSB_A,iSB_B)= 0  ! Mem Address of the SubBlocks
          LenSB (iSB_A,iSB_B)= 0  ! Length of the SubBlocks
        EndDo
      EndDo

* --- GENERATION of SubBlocks
      If (SubBlocks(1,1)) Call MkExSB11(iAddSB(1,1),LenSB(1,1),
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
      If (SubBlocks(1,2)) Call MkExSB12(iAddSB(1,2),LenSB(1,2),
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
      If (SubBlocks(1,3)) Call MkExSB13(iAddSB(1,3),LenSB(1,3),
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
      If (SubBlocks(2,1)) Call MkExSB21(iAddSB(2,1),LenSB(2,1),
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV, iAddSB(1,2),LenSB(1,2))
      If (SubBlocks(2,2)) Call MkExSB22(iAddSB(2,2),LenSB(2,2),
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
      If (SubBlocks(2,3)) Call MkExSB23(iAddSB(2,3),LenSB(2,3),
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
      If (SubBlocks(3,1)) Call MkExSB31(iAddSB(3,1),LenSB(3,1),
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV, iAddSB(1,3),LenSB(1,3))
      If (SubBlocks(3,2)) Call MkExSB32(iAddSB(3,2),LenSB(3,2),
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV, iAddSB(2,3),LenSB(2,3))
      If(SubBlocks(3,3)) Call MkExSB33(iAddSB(3,3),LenSB(3,3),
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
* --- END GENERATION of SubBlocks

* --- GATERING of SubBlocks
      iAddExSB = iAddEx
      IF (DoTCVA) THEN

       If (iSymA.NE.iSymB) then
         iLenBj = nIsh(iSymB)
         iLenBu = nAsh(iSymB)
         iLenBb = nSsh(iSymB)
         Do iSB_A = 1, 3
           iLenA = 0
           If (iSB_A.EQ.1) iLenA = nIsh(iSymA)
           If (iSB_A.EQ.2) iLenA = nAsh(iSymA)
           If (iSB_A.EQ.3) iLenA = nSsh(iSymA)
           Do iA = 1,iLenA
             If (iLenBj.GT.0) then                        ! SB(1,iSB_A)
               iAddSBi = iAddSB(iSB_A,1) + iLenBj * (iA-1)
              call daxpy_(iLenBj,1.0d0,Work(iAddSBi),1,Work(iAddExSB),1)
               iAddExSB = iAddExSB + iLenBj
             EndIf
             If (iLenBu.GT.0) then                        ! SB(2,iSB_A)
               iAddSBi = iAddSB(iSB_A,2) + iLenBu * (iA-1)
              call daxpy_(iLenBu,1.0d0,Work(iAddSBi),1,Work(iAddExSB),1)
               iAddExSB = iAddExSB + iLenBu
             EndIf
             If (iLenBb.GT.0) then                        ! SB(3,iSB_A)
               iAddSBi = iAddSB(iSB_A,3) + iLenBb * (iA-1)
              call daxpy_(iLenBb,1.0d0,Work(iAddSBi),1,Work(iAddExSB),1)
               iAddExSB = iAddExSB + iLenBb
             EndIf
           EndDo  ! iA
         EndDo ! iSB_A
       else
         iLenAi = nIsh(iSymA)
         iLenAt = nAsh(iSymA)
         iLenAa = nSsh(iSymA)
         Do iSB_B = 1, 3
           iLenB = 0
           If (iSB_B.EQ.1) iLenB = nIsh(iSymB)
           If (iSB_B.EQ.2) iLenB = nAsh(iSymB)
           If (iSB_B.EQ.3) iLenB = nSsh(iSymB)
           Do iB = 1,iLenB
             If (iLenAi.GT.0) then                        ! SB(1,iSB_B)
               iAddSBi = iAddSB(iSB_B,1) + iLenAi * (iB-1)
              call daxpy_(iLenAi,1.0d0,Work(iAddSBi),1,Work(iAddExSB),1)
               iAddExSB = iAddExSB + iLenAi
             EndIf
             If (iLenAt.GT.0) then                        ! SB(2,iSB_B)
               iAddSBi = iAddSB(iSB_B,2) + iLenAt * (iB-1)
              call daxpy_(iLenAt,1.0d0,Work(iAddSBi),1,Work(iAddExSB),1)
               iAddExSB = iAddExSB + iLenAt
             EndIf
             If (iLenAa.GT.0) then                        ! SB(3,iSB_B)
               iAddSBi = iAddSB(iSB_B,3) + iLenAa * (iB-1)
              call daxpy_(iLenAa,1.0d0,Work(iAddSBi),1,Work(iAddExSB),1)
               iAddExSB = iAddExSB + iLenAa
             EndIf
           EndDo  ! iB
         EndDo ! iSB_B
       EndIf

      ELSE

       If (iSymA.NE.iSymB) then
         iLenBb = nSsh(iSymB)
         If (iLenBb.GT.0) then                          ! SB(3,3)
           iLenA = nSsh(iSymA)
           Do iA = 1,iLenA
             iAddSBi = iAddSB(3,3) + iLenBb * (iA-1)
             call daxpy_(iLenBb,1.0d0,Work(iAddSBi),1,Work(iAddExSB),1)
             iAddExSB = iAddExSB + iLenBb
           EndDo  ! iA
         EndIf
       else
         iLenAa = nSsh(iSymA)
         If (iLenAa.GT.0) then                          ! SB(3,3)
           iLenB = nSsh(iSymB)
           Do iB = 1,iLenB
             iAddSBi = iAddSB(3,3) + iLenAa * (iB-1)
             call daxpy_(iLenAa,1.0d0,Work(iAddSBi),1,Work(iAddExSB),1)
             iAddExSB = iAddExSB + iLenAa
           EndDo  ! iB
         EndIf
       EndIf

      ENDIF
* --- END GATERING of SubBlocks

      Do iSB_A = 1, 3
        Do iSB_B = 1, 3
          If (iAddSB(iSB_A,iSB_B).GT.0) Call GetMem('SB','Free','Real',
     &                         iAddSB(iSB_A,iSB_B), LenSB(iSB_A,iSB_B))
        EndDo
      EndDo

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(LenEx)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function nBas_Eff(NrExp,NrBas,Exp,Cff,nExp_Eff)
      Implicit Real*8 (a-h,o-z)
      Real*8 Exp(NrExp), Cff(NrExp,NrBas)
*
      nBas_Eff=NrBas
*
      Do iBas = 1, NrBas
*
         Do iExp = 1, nExp_Eff
*
            If (Cff(iExp,iBas).ne.0.0D0) Then
               nBas_Eff = NrBas-iBas+1
               Return
            End If
*
         End Do
*
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Exp)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine NxtWrd(Line,i_F,iE)
!***********************************************************************
!                                                                      *
! Object:                                                              *
!                                                                      *
! Called from: DefInt                                                  *
!                                                                      *
! Calling    : None                                                    *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             May '91                                                  *
!***********************************************************************

use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: Line
integer(kind=iwp), intent(inout) :: i_F, iE
integer(kind=iwp) :: nChar

nChar = len(Line)
! Find first non-blank character
do
  if ((i_F == 0) .or. (i_F > nChar)) then
    call WarningMessage(2,'NxtWrd: (i_F == 0) .or. (i_F > nChar)')
    write(u6,*) 'nChar=',nChar
    write(u6,*) 'i_F,iE=',i_F,iE
    call Abend()
  end if
  if (Line(i_F:i_F) /= ' ') exit
  i_F = i_F+1
  if (i_F >= nChar) then
    i_F = nChar
    iE = -1
    return
  end if
end do
! Find the end of the present word
iE = i_F+1
do
  if (Line(iE:iE) /= ' ') then
    iE = iE+1
    if (iE > nChar) then
      iE = nChar
      return
    end if
  else
    iE = iE-1
    exit
  end if
end do

return

end subroutine NxtWrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      Logical Function ChoMP2_ChkPar()
C
C     Thomas Bondo Pedersen, Nov. 2006.
C
C     Purpose: return true if parallel run (nProcs>1), else return
C              false.
C
      Implicit None
#if defined (_MOLCAS_MPP_)
#include "cho_para_info.fh"
      ChoMP2_ChkPar=nProcs.gt.1 .and. Is_Real_Par()
#else
      ChoMP2_ChkPar=.False.
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NYPART(iExtra,nPart,COORD,rStart,nCent,iSeed)

use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iExtra, nCent
integer(kind=iwp), intent(inout) :: nPart, iSeed
real(kind=wp), intent(inout) :: COORD(3,(nPart+iExtra)*nCent)
real(kind=wp), intent(in) :: rStart
integer(kind=iwp) :: I, IA, IIN, iMAXVAR, IND, IVARV
real(kind=wp) :: DR, DX, DY, DZ, R2, RLIM, RLIM2, rlm, X, Y, Z
real(kind=wp), external :: Random_Molcas
#include "warnings.h"

! Preparing some numbers
iMAXVAR = 100*iExtra**2
IIN = 1
IVARV = 0
RLIM = rStart-8.5_wp
rlm = rlim*Two
RLIM2 = RLIM**Two
! Check if not all molecules been put out in reasonable time
outer: do
  if (IVARV >= iMAXVAR) then
    write(u6,*) 'Failure to add particles. Try to increase the dielectric radie or change the random seed.'
    call Quit(_RC_GENERAL_ERROR_)
  end if
  ! Here is the random change relative the first user defined water
  DX = Random_Molcas(iseed)*RLM-rlim
  DY = Random_Molcas(iseed)*RLM-rlim
  DZ = Random_Molcas(iseed)*RLM-rlim
  DR = DX*DX+DY*DY+DZ*DZ
  IVARV = IVARV+1
  if (DR > RLIM2) cycle outer
  IND = IIN+NPART
  X = DX+COORD(1,1)
  Y = DY+COORD(2,1)
  Z = DZ+COORD(3,1)
  ! Check so that two water molecules do not come too close...
  do I=1,IND*NCENT,NCENT
    R2 = (COORD(1,I)-X)**2+(COORD(2,I)-Y)**2+(COORD(3,I)-Z)**2
    if (R2 < 60.0_wp) cycle outer
  end do
  ! ...and if they do not then shove its coordinates in variable
  IIN = IIN+1
  IA = (IIN+NPART-1)*NCENT
  COORD(1,IA+1:NCENT) = COORD(1,1:NCENT)+DX
  COORD(2,IA+1:NCENT) = COORD(2,1:NCENT)+DY
  COORD(3,IA+1:NCENT) = COORD(3,1:NCENT)+DZ
  ! Check if all water molecules have been put where they should
  if (IIN >= IEXTRA) exit outer
end do outer
! Give nPart its new value and exit gracefully
NPART = NPART+IEXTRA

return

end subroutine NYPART

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cpinp(LUnit,iRc)

use UnixInfo, only: ProgName
use spool, only: Close_LuSpool, Disable_Spool, SpoolInp
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: LUnit, iRC
integer(kind=iwp) :: istatus, LUSpool
character(len=180) :: line
character :: ch
#ifdef _DMRG_
character(len=180) :: line2
#endif
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

iRc = _RC_ALL_IS_WELL_
! The following code will open, and return the unit number LUSpool,
! of an ASCII file with a copy of the presently used input.
! The records are strings of 180 characters, conforming to the
! standards set e.g. in src/util/inputil.f. This may change in the
! future, so look out!

call SpoolInp(LUSpool)
call Disable_Spool()
rewind(LUSpool)
! Now open a new file, and copy only the input between the '&RASSCF'
! and the 'End of Input' markers, inclusive, and skipping any commented
! lines. (The latter is put there by sbin/auto.plx, so it is safe to
! assume it is not abbreviated). The copied lines are left adjusted.
! Positioning LUSpool after the '&RASSCF' marker.
if (ProgName(1:5) == 'dmrgs') then
  call RdNLst(LuSpool,'DMRGSCF')
  call setpos(luspool,'OOPT',line,irc)
else
  call RdNLst(LuSpool,'RASSCF')
end if
! Opening a new file:
LUnit = 99
LUnit = IsFreeUnit(LUnit)
call Molcas_Open(LUnit,'CleanInput')
! Copy only the relevant lines of input:
line = ' '
line(1:7) = '&RASSCF'
write(LUnit,'(A180)') line
do
  read(luspool,'(A180)',iostat=istatus) line
  if (istatus /= 0) then
    ! Something went wrong...Let the caller handle it:
    iRc = _RC_INPUT_ERROR_
    return
  end if
  line = adjustl(line)
# ifdef _DMRG_
  if (ProgName(1:5) == 'dmrgs') then
    line2 = line
    call upcase(line2(1:4))
    if (line2(1:4) == 'ENDO') then
      line = ' '
      line(1:12) = 'End of Input'
      write(LUnit,'(A180)') line
      exit
    end if
  end if
# endif
  ch = line(1:1)
  if ((ch /= ' ') .and. (ch /= '*') .and. (ch /= '!')) write(LUnit,'(A180)') line
  call upcase(line(1:12))
  if (line(1:12) == 'END OF INPUT') exit
end do
call close_luspool(LUSpool)

return

end subroutine cpinp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_0(dim_,A)
! check zero

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dim_
real(kind=wp), intent(in) :: A(dim_)
integer(kind=iwp) :: bad, i

bad = 0
do i=1,dim_
  if (abs(A(i)) > 1.0e-10_wp) bad = bad+1
end do

write(u6,*) ' Nonzero elements ',bad,dim_

return

end subroutine Chck_0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ChCar(iChCar,iGen,nGen)
      Implicit Integer (a-z)
      Integer iChCar(3), iGen(nGen)
*
*     Generate characteristics for x, y, and z.
*
      Do iCar = 1, 3
         iChCar(iCar) = 0
         iComp = 2**(iCar-1)
         Do i = 1, nGen
            If (iAnd(iGen(i),iComp).eq.iComp) iChCar(iCar) = iComp
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************
!  get_BasisType
!
!> @brief
!>   Logical function to check basis set
!> @author V. Veryazov
!>
!> @details
!> Function returns ``.true.`` if the basis set in the current
!> calculation has specific type.
!> Only 3 first characters are used, so
!> ``get_BasisType('segmented')`` is the same as ``get_BasisType('SEG')``.
!>
!> The list of available basis set types is available at
!> src/input_util/basistype.fh and basis_library/basistype.tbl.
!>
!> @param[in] BasisType Basis set type
!>
!> @return ``.true.`` if the basis set in the current calculation has specific type
!***********************************************************************

function get_BasisType(BasisType)

use BasisType_Mod, only: BasTypeAll, BasTypeCon, BasTypeRel
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: get_BasisType
character(len=*), intent(in) :: BasisType
integer(kind=iwp) :: BasisTypes(4), i, nData
logical(kind=iwp) :: Found
character(len=3) :: temp, TypeCon, TypeAll, TypeRel

nData = 0
Found = .false.
call Qpg_iArray('BasType',Found,nData)
if (.not. Found) then
  get_BasisType = .false.
  return
end if
call get_bastype(BasisTypes,nData)
i = BasisTypes(1)
if (i <= 0) then
  TypeCon = 'UNK'
else
  TypeCon = BasTypeCon((i-1)*4+1:(i-1)*4+3)
end if
i = BasisTypes(2)
if (i <= 0) then
  TypeAll = 'UNK'
else
  TypeAll = BasTypeAll((i-1)*4+1:(i-1)*4+3)
end if
i = BasisTypes(3)
if (i <= 0) then
  TypeRel = 'UNK'
else
  TypeRel = BasTypeRel((i-1)*4+1:(i-1)*4+3)
end if

i = len(BasisType)
if (i > 3) i = 3
temp = '___'
temp(1:i) = BasisType(1:i)
call UpCase(temp)
get_BasisType = .false.
if ((temp == TypeCon) .or. (temp == TypeAll) .or. (temp == TypeRel)) get_BasisType = .true.

return

end function get_BasisType

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine appendint_cvb(c,nmbr,iskip)

use Definitions, only: iwp, u6

implicit none
character(len=*), intent(inout) :: c
integer(kind=iwp), intent(in) :: nmbr, iskip
integer(kind=iwp) :: ibegin, iend, itens, limit, mnumber
character(len=10) :: frmt

ibegin = len_trim(c)+1+iskip
iend = len(c)

frmt = ' '
if (nmbr >= 0) then
  limit = 0
  do itens=0,99
    limit = limit+9*(10**itens)
    if (nmbr <= limit) then
      write(frmt,'(a,i4.4,a)') '(i',itens+1,')'
      write(c(ibegin:iend),frmt) nmbr
      return
    end if
  end do
else
  mnumber = -nmbr
  limit = 0
  do itens=0,99
    limit = limit+9*(10**itens)
    if (mnumber <= limit) then
      write(frmt,'(a,i4.4,a)') '(a,i',itens+1,')'
      write(c(ibegin:iend),frmt) '-',mnumber
      return
    end if
  end do
end if
write(u6,*) ' Number too large in appendint :',nmbr
call abend_cvb()

end subroutine appendint_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MMEtoRMO(nAObas,nMObas,ipAvRed,iMME)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension iMME(MxMltp*(MxMltp+1)*(MxMltp+2)/6)

*
*--- First all multipoles are transformed to MO-basis...
*
      Call GetMem('Squared','Allo','Real',iSq,nAObas**2)
      Call GetMem('TEMP','Allo','Real',iTEMP,nAObas*nMObas)
      Call GetMem('Final','Allo','Real',iMmeMO,nMObas**2)
      nUniqueM=1+3+6
      Do 11, iMlt=1,nUniqueM
        Call Square(Work(iMME(iMlt)),Work(iSq),iONE,nAObas,nAObas)
        Call Dgemm_('T','N',nMObas,nAObas,nAObas,ONE,Work(ipAvRed)
     &            ,nAObas,Work(iSq),nAObas,ZERO,Work(iTEMP),nMObas)
        Call Dgemm_('N','N',nMObas,nMObas,nAObas,ONE,Work(iTEMP)
     &            ,nMObas,Work(ipAvRed),nAObas,ZERO,Work(iMmeMO),nMObas)
        Call SqToTri_Q(Work(iMmeMO),Work(iMME(iMlt)),nMObas)
11    Continue
      Call GetMem('Squared','Free','Real',iSq,nAObas**2)
      Call GetMem('TEMP','Free','Real',iTEMP,nAObas*nMObas)
      Call GetMem('Final','Free','Real',iMmeMO,nMObas**2)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkV_T18 (Va,V,dima,no)
c
c       this routine do:
c        Va(a,j,i,u) = - [2V(ai|ju)-V(aj|iu)]
c        from V(o_a,P,Q,a)
c
c        N.B. Kvajto odflaknute, ozaj ze hnus, treba sa zamysliet
c        ci je nutva permutacia s a-ckom na konci - bod QK2.2 @@
c
c
        implicit none
        integer dima,no
        real*8 Va(1:dima,1:no,1:no,1:no)
        real*8 V(1:no,1:no,1:no,1:dima)
c
c       help variables
        integer a,j,i,u
c
        do u=1,no
          do i=1,no
            do j=1,no
              do a=1,dima
                Va(a,j,i,u)=V(j,i,u,a)-2.0d0*V(i,j,u,a)
              end do
            end do
          end do
        end do
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine SphAve()

use Genano_globals, only: MxLqn, nPrim, tDsym
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i, ij, iLqn, ind, iPtr, nDim
real(kind=wp) :: t

iPtr = 0
do iLqn=0,MxLqn
  nDim = nPrim(iLqn)*(nPrim(iLqn)+1)/2
  do ij=1,nDim
    ind = iPtr+ij
    t = Zero
    do i=0,2*iLqn
      t = t+tDsym(ind+i*nDim)
    end do
    t = t/(2*iLqn+1)
    do i=0,2*iLqn
      tDsym(ind+i*nDim) = t
    end do
  end do
  iPtr = iPtr+(2*iLqn+1)*nDim
end do
!write(u6,*) '*** Density matrix in SphAve ***'
!iBlk = 0
!do iLqn=0,MxLqn
!  do iShell=-iLqn,iLqn
!    iBlk = iBlk+1
!    if (nPrim(iLqn) > 0) then
!      write(u6,'(a,2i5)') ' Block',iLqn,iShell
!      call Triprt(' ','(6f12.6)',tDsym(iSymBk(iBlk)),nPrim(iLqn))
!    end if
!  end do
!end do

return

end subroutine SphAve

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine IIJJ(ICSPCK,INTSYM,HDIAG,FC,FIIJJ,FIJIJ)

use mrci_global, only: IFIRST, IRC, IROW, LN, LSYM, Lu_27, NSM, NVIR, NVIRP, NVIRT
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICSPCK(*), INTSYM(*)
real(kind=wp), intent(_OUT_) :: HDIAG(*)
real(kind=wp), intent(in) :: FC(*), FIIJJ(*), FIJIJ(*)
integer(kind=iwp) :: I, IA, IAD27, IAV, IB, IBV, II1, IJ, ILIM, IND, IOC(55), IR, IRL, J, JOJ, NA, NA1, NA2, NB, NB1, NB2, NSA, NSS
real(kind=wp) :: SUM1, SUM2, TERM
integer(kind=iwp), external :: ICUNP, JSUNP

IAD27 = 0
II1 = 0
ILIM = 4
if (IFIRST /= 0) ILIM = 2
IRL = IRC(ILIM)
do IR=1,IRL
  do I=1,LN
    II1 = II1+1
    JOJ = ICUNP(ICSPCK,II1)
    if (JOJ > 1) JOJ = JOJ-1
    IOC(I) = JOJ
  end do
  NSS = MUL(JSUNP(INTSYM,IR),LSYM)
  SUM1 = Zero
  do I=1,LN
    IJ = IROW(I)
    if (IOC(I) == 0) cycle
    do J=1,I-1
      IJ = IJ+1
      if (IOC(J) /= 0) SUM1 = SUM1+IOC(I)*(IOC(J)*FIIJJ(IJ)-FIJIJ(IJ))
    end do
    IJ = IJ+1
    SUM1 = SUM1+(IOC(I)-1)*FIIJJ(IJ)+IOC(I)*FC(IJ)
  end do
  if (IR <= IRC(1)) then
    HDIAG(IR) = SUM1
    if (IR == IRC(1)) call dDAFILE(Lu_27,1,HDIAG,IRC(1),IAD27)
  else
    IND = 0
    if (IR <= IRC(2)) then
      NA1 = NVIRP(NSS)+1
      NA2 = NVIRP(NSS)+NVIR(NSS)
      do NA=NA1,NA2
        IND = IND+1
        IA = IROW(LN+NA)
        SUM2 = SUM1+FC(IA+LN+NA)
        do I=1,LN
          if (IOC(I) /= 0) SUM2 = SUM2+IOC(I)*FIIJJ(IA+I)-FIJIJ(IA+I)
        end do
        HDIAG(IND) = SUM2
      end do
      call dDAFILE(Lu_27,1,HDIAG,IND,IAD27)
    else
      IND = 0
      do NA=1,NVIRT
        NSA = MUL(NSS,NSM(LN+NA))
        NB1 = NVIRP(NSA)+1
        NB2 = NVIRP(NSA)+NVIR(NSA)
        if (NB2 > NA) NB2 = NA
        if (NB2 < NB1) cycle
        IA = IROW(LN+NA)
        IAV = IA+LN
        do NB=NB1,NB2
          IND = IND+1
          IB = IROW(LN+NB)
          IBV = IB+LN
          TERM = SUM1+FIIJJ(IAV+NB)+FC(IAV+NA)+FC(IBV+NB)
          if (IR <= IRC(3)) then
            SUM2 = TERM-FIJIJ(IAV+NB)
          else
            SUM2 = TERM+FIJIJ(IAV+NB)
          end if
          do I=1,LN
            if (IOC(I) /= 0) then
              TERM = IOC(I)*(FIIJJ(IA+I)+FIIJJ(IB+I))-FIJIJ(IA+I)-FIJIJ(IB+I)
              SUM2 = SUM2+TERM
            end if
          end do
          HDIAG(IND) = SUM2
        end do
      end do
      if (IND > 0) call dDAFILE(Lu_27,1,HDIAG,IND,IAD27)
    end if
  end if
end do

return

end subroutine IIJJ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************
!  HelState
!
!> @brief
!>   Couple the electrostatic part of the solvent with the QM-region.
!>   Only include the static part, no polarization at this moment
!> @author A. Ohrn
!>
!> @note
!> The quadrupoles are put in 'Buckingham-style'.
!>
!> @details
!> Rather easy to follow. This subroutine is a slightly modified
!> copy of ::hel. The interesting quantities are collected in
!> \p Vmat and are later to be added to the 'RASSI-matrix'.
!>
!> @param[in]  Eint    Field from static part of solvent on the Qm-molecule centers
!> @param[in]  nrstate Number of states in RASSI
!> @param[in]  ici     Number of MME-centers
!> @param[in]  Cha     Charges
!> @param[in]  Dip     Dipoles
!> @param[in]  Qua     Quadrupoles
!> @param[out] Vmat    The electrostatic part of the solute-solvent interaction matrix
!***********************************************************************

subroutine HelState(Eint,nrstate,ici,Cha,Dip,Qua,Vmat)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nrstate, ici
real(kind=wp), intent(in) :: Eint(ici,10), Cha(nTri_Elem(nrstate),ici), Dip(nTri_Elem(nrstate),3,ici), Qua(nTri_Elem(nrstate),6,ici)
real(kind=wp), intent(out) :: Vmat(nTri_Elem(nrstate))
integer(kind=iwp) :: i, j, k, kaunt

Vmat(:) = Zero

! The interaction between the distributed multipoles
! and the generalized field from the solvent.
kaunt = 0
do i=1,nrState
  do j=1,i
    kaunt = kaunt+1
    do k=1,ici
      Vmat(kaunt) = Vmat(kaunt)+Eint(k,1)*Cha(kaunt,k)+ &
                    Eint(k,2)*Dip(kaunt,1,k)+Eint(k,3)*Dip(kaunt,2,k)+Eint(k,4)*Dip(kaunt,3,k)+ &
                    Eint(k,5)*Qua(kaunt,1,k)+Eint(k,7)*Qua(kaunt,3,k)+Eint(k,10)*Qua(kaunt,6,k)+ &
                    Eint(k,6)*Qua(kaunt,2,k)*Two+Eint(k,8)*Qua(kaunt,4,k)*Two+Eint(k,9)*Qua(kaunt,5,k)*Two
    end do
  end do
end do

return

end subroutine HelState

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_AddConstraintCorrection(Constraint,AB,l_C,C)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: add constraint correction to coefficients.
C
      Implicit None
      Integer Constraint
      Integer AB
      Integer l_C
      Real*8  C(l_C)

      Character*27 SecNam
      Parameter (SecNam='LDF_AddConstraintCorrection')

      If (Constraint.eq.-1) Then ! no constraint
         Return
      Else If (Constraint.eq.0) Then ! charge constraint
         Call LDF_AddChargeConstraintCorrection(AB,l_C,C)
      Else ! unknown constraint
         Call WarningMessage(2,SecNam//': illegal constraint')
         Write(6,'(A,I10)') 'Constraint=',Constraint
         Call LDF_Quit(1)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine sg2symg(CI,lCI,imode,pState_Sym)

use sguga, only: CIS, EXS, SGS, SG_Free
use Str_Info, only: CFTP, CNSM
use input_mclr, only: nConf, nCSF, nSym, State_Sym
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: lCI, imode, pState_Sym
real(kind=wp), intent(inout) :: CI(lCI)
integer(kind=iwp) :: iss
#ifdef _DEBUGPRINT_
real(kind=wp), parameter :: PRWTHR = 0.05_wp
#endif

! Transformation of CI vector to symmetric group from GUGA pepresentation, or the reverse

call SG_Setup_MCLR(pState_Sym)

NCSF(1:nSym) = CIS%NCSF(1:nSym)
NCONF = CIS%NCSF(pState_Sym)

iss = 1
if (pState_sym /= state_sym) iss = 2

#ifdef _DEBUGPRINT_
write(u6,101)
write(u6,102) PRWTHR
call SG_PrWF(SGS,CIS,pState_sym,PRWTHR,SGS%iSpin,CI,nConf,.false.,-99)
write(u6,103)
101 format(/,6X,100('-'),/,6X,29X,'Wave function printout: Split Graph format',/,6X,8X, &
           'in parenthesis: midvertex, upper-walk symmetry upper- and lower-walk serial numbers',/,6X,100('-'),/)
102 format(6X,'printout of CI-coefficients larger than',F6.2)
103 format(/,6X,100('-'),/)
#endif

call REORD(SGS,CIS,EXS,NCONF,iMode,CNSM(iss)%ICONF,CFTP,pState_Sym,CI)

#ifdef _DEBUGPRINT_
call SG_PrWF(SGS,CIS,pState_sym,PRWTHR,SGS%iSpin,CI,nConf,.false.,-99)
#endif

call SG_Free(SGS,CIS,EXS)

end subroutine sg2symg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine ReadIn_Polar(NoField,Delta,MpProp_Level,Bond_Threshold,
     &                        iPlot,iPrint,Standard,Opt_Method,UserDen,
     &                        PrintDen,SubtractDen,SubScale,Restart,
     &                        TDensity,nStateI,nStateF,XHole,Diffuse,
     &                        dLimmo,Thrs1,Thrs2,nThrs,ThrsMul,Alpha,
     &                        LIonize)
      Implicit Real*8 (a-h,o-z)
      Logical NoField, Standard, UserDen, PrintDen, SubtractDen
      Logical TDensity, XHole, Diffuse(3)
      Logical LIonize,Restart
      Character*12  Opt_Method
      Dimension dLimmo(2)
*
*
*     copy input from standard input to a local scratch file
*
      LuSpool=21
      Call SpoolInp(LuSpool)
*
*     read input
*
      Call RdInp_Polar(LuSpool,NoField,Delta,MpProp_Level,
     &          Bond_Threshold,iPlot,iPrint,Standard,Opt_Method,UserDen,
     &          PrintDen,SubtractDen,SubScale,Restart,TDensity,nStateI,
     &          nStateF,XHole,Diffuse,dLimmo,Thrs1,Thrs2,nThrs,ThrsMul,
     &          Alpha, LIonize)
*
*     remove local copy of standard input
*
      Call Close_LuSpool(LuSpool)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fetch_data_RunFile_init(nss,nstate)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: nss, nstate
integer(kind=iwp) :: mxjob, ndata, njob
logical(kind=iwp) :: FOUND

! check the presence of the RUNFILE
call f_inquire('RUNFILE',FOUND)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The RUNFILE was not found in the $WorkDir'
  write(u6,'(5X,A)') 'Are you running this calculation in the'
  write(u6,'(5X,A)') 'same $WorkDir where RASSI calculation'
  write(u6,'(5X,A)') 'was executed?'
  write(u6,'(5X,A)') 'Check your calculation again, and If'
  write(u6,'(5X,A)') 'necessary, submit a BUG report.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

! check the presence of the necessary information on RUNFILE:
call qpg_iscalar('NSS_SINGLE',FOUND)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The NSS Value was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_iscalar('NJOB_SINGLE',FOUND)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The NJOB Value was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_iscalar('MXJOB_SINGLE',FOUND)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The MXJOB Value was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_iscalar('NSTATE_SINGLE',FOUND)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The NSTATE Value was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

! fetch scalar data from RUNFILE
call get_iscalar('NSS_SINGLE',NSS)
call get_iscalar('NJOB_SINGLE',NJOB)
call get_iscalar('MXJOB_SINGLE',MXJOB)
call get_iscalar('NSTATE_SINGLE',NSTATE)

! check the presence of saved arrays on RUNFILE:

call qpg_iArray('MLTP_SINGLE',FOUND,NDATA)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The MLTP array was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_iArray('JBNUM_SINGLE',FOUND,NDATA)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The JBNUM array was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_iArray('LROOT_SINGLE',FOUND,NDATA)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The LROOT array was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_dArray('ESO_SINGLE',FOUND,NDATA)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The ESO array was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_dArray('UMATR_SINGLE',FOUND,NDATA)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The UMATR array was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_dArray('UMATI_SINGLE',FOUND,NDATA)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The UMATI array was not found on RUNFILE'
  write(u6,'(5X,A)') 'Please report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_dArray('ANGM_SINGLE',FOUND,NDATA)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The ANGMOM array was not found on RUNFILE'
  write(u6,'(5X,A)') '1. Check If ANGM keyword was used for SEWARD.'
  write(u6,'(5X,A)') '2. Check If MEES keyword was used for RASSI.'
  write(u6,'(5X,A)') '3. Check If PROP keyword was used for RASSI:'
  write(u6,'(9X,A)') 'PROP'
  write(u6,'(9X,A)') '3'
  write(u6,'(9X,A)') ' ''ANGMOM'' 1'
  write(u6,'(9X,A)') ' ''ANGMOM'' 2'
  write(u6,'(9X,A)') ' ''ANGMOM'' 3'
  write(u6,'(5X,A)') 'If MEES, ANGMOM and PROP keywords  were used and you still see this problem,'
  write(u6,'(5X,A)') 'please, report a BUG.'
  call xFlush(u6)
  call Quit_OnUserError()
end if

call qpg_dArray('DIP1_SINGLE',FOUND,NDATA)
if (.not. FOUND) then
  write(u6,'(5X,A)') 'The DIPMOM array was not found on RUNFILE'
  write(u6,'(5X,A)') 'Absorption intensities will not be computed'
end if

return

end subroutine fetch_data_RunFile_init

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine AB_CPF(ICASE,JSY,INDX,C,S,FC,A,B,F,ENP)

use cpf_global, only: IDENS, IFIRST, IPRINT, IRC, IREF0, IROW, LN, LSYM, NDIAG, NORBT, NSYM, NSYS, NVIR, NVIRT, SQ2
use Symmetry_Info, only: Mul
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICASE(*), JSY(*), INDX(*)
real(kind=wp), intent(inout) :: C(*), S(*), FC(*)
real(kind=wp), intent(_OUT_) :: A(*), B(*), F(*)
real(kind=wp), intent(in) :: ENP(*)
integer(kind=iwp) :: I, IAB, IASYM, ICSYM, IFT, II1, IIA, IIC, IIN, IJ, INDA, INMY, INN, INUM, IOC(55), IPF, IPOA(9), IPOF(9), &
                     ITAIL, ITURN, JOJ, LNA, LNC, MYL, MYSYM, NA, NA1, NA2, NAA, NAB, NAC, NB, NCLIM, NVIRA, NVIRC
real(kind=wp) :: COPI, RSUM, TR, TSUM
integer(kind=iwp), external :: ICUNP, JSUNP
real(kind=r8), external :: DDOT_

INUM = IRC(4)-IRC(3)
call PSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)
NCLIM = 4
NAB = 0 ! dummy initialize
if (IFIRST /= 0) NCLIM = 2
! MOVE FOCK (DENSITY) MATRIX TO F IN SYMMETRY BLOCKS
call IPO_CPF(IPOF,NVIR,MUL,NSYM,1,-1)
ITURN = 0
do
  do IASYM=1,NSYM
    IAB = IPOF(IASYM)
    NA1 = NSYS(IASYM)+1
    NA2 = NSYS(IASYM+1)
    do NA=NA1,NA2
      do NB=NA1,NA2
        IAB = IAB+1
        if (NA >= NB) NAB = IROW(LN+NA)+LN+NB
        if (NB > NA) NAB = IROW(LN+NB)+LN+NA
        if (ITURN == 1) then
          if (NA < NB) FC(NAB) = F(IAB)
        else
          if (IDENS == 0) F(IAB) = Zero
          if (IDENS == 1) F(IAB) = FC(NAB)
          if (NA /= NB) F(IAB) = FC(NAB)
        end if
      end do
    end do
  end do
  if (ITURN /= 0) then
    TR = Zero
    IJ = 0
    do I=1,NORBT
      IJ = IJ+I
      TR = TR+FC(IJ)
    end do
    if (iPrint >= 15) write(u6,310) TR
    exit
  end if
  II1 = 0
  ITAIL = IRC(NCLIM)
  do INDA=1,ITAIL
    if (IDENS /= 0) then
      do I=1,LN
        II1 = II1+1
        JOJ = ICUNP(ICASE,II1)
        if (JOJ > 1) JOJ = JOJ-1
        IOC(I) = JOJ
      end do
    end if
    if (INDA <= IRC(1)) then
      if ((IDENS == 0) .or. (INDA == IREF0)) cycle
      TSUM = C(INDA)*C(INDA)/(sqrt(ENP(INDA))*sqrt(ENP(INDA)))
    else
      MYSYM = JSUNP(JSY,INDA)
      MYL = MUL(MYSYM,LSYM)
      INMY = INDX(INDA)+1
      if (INDA <= IRC(2)) then
        ! DOUBLET-DOUBLET INTERACTIONS
        if (NVIR(MYL) == 0) cycle
        if (IDENS /= 1) then
          call FMMM(F(IPOF(MYL)+1),C(INMY),A,NVIR(MYL),1,NVIR(MYL))
          S(INMY:INMY+NVIR(MYL)-1) = S(INMY:INMY+NVIR(MYL)-1)+A(1:NVIR(MYL))
          cycle
        end if
        call FMUL2(C(INMY),C(INMY),A,NVIR(MYL),NVIR(MYL),1)
        IPF = IPOF(MYL)+1
        IIN = IPOF(MYL+1)-IPOF(MYL)
        COPI = One/(sqrt(ENP(INDA))*sqrt(ENP(INDA)))
        F(IPF:IPF+IIN-1) = F(IPF:IPF+IIN-1)+COPI*A(1:IIN)
        NVIRA = NVIR(MYL)
        LNA = LN+NSYS(MYL)
        IIA = IROW(LNA+1)
        TSUM = Zero
        do I=1,NVIRA
          RSUM = COPI*C(INMY)*C(INMY)
          INMY = INMY+1
          TSUM = TSUM+RSUM
          IIA = IIA+LNA+I
          FC(IIA) = FC(IIA)+RSUM
        end do
      else
        ! TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
        IFT = 1
        if (INDA > IRC(3)) IFT = 0
        call IPO_CPF(IPOA,NVIR,MUL,NSYM,MYL,IFT)
        IIN = 0
        TSUM = Zero
        do IASYM=1,NSYM
          IAB = IPOF(IASYM+1)-IPOF(IASYM)
          if (IAB == 0) cycle
          ICSYM = MUL(MYL,IASYM)
          if (NVIR(ICSYM) == 0) cycle
          if (IDENS /= 1) then
            if (MYL == 1) then
              if (IFT == 0) call SQUAR(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
              !if (IFT == 1) call SQUARN(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
              if (IFT == 1) call SQUARM(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
              NAA = NVIR(IASYM)*NVIR(IASYM)
              call FMMM(F(IPOF(IASYM)+1),A,B,NVIR(IASYM),NVIR(IASYM),NVIR(IASYM))
              A(1:NAA) = B(1:NAA)
              if (IFT /= 1) then
                call SIADD(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
              else
                call TRADD(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
              end if
              A(1:NAA) = Zero
            else
              NAC = NVIR(IASYM)*NVIR(ICSYM)
              if (IASYM <= ICSYM) then
                I = INMY+IPOA(ICSYM)
                call FMMM(F(IPOF(IASYM)+1),C(I),A,NVIR(IASYM),NVIR(ICSYM),NVIR(IASYM))
              else
                I = INMY+IPOA(IASYM)
                call FMMM(C(I),F(IPOF(IASYM)+1),A,NVIR(ICSYM),NVIR(IASYM),NVIR(IASYM))
              end if
              S(I:I+NAC-1) = S(I:I+NAC-1)+A(1:NAC)
            end if
          else
            if (MYL == 1) then
              if (IFT == 0) call SQUAR(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
              if (IFT == 1) call SQUARM(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
            else if (IASYM <= ICSYM) then
              NAC = NVIR(IASYM)*NVIR(ICSYM)
              if (IFT == 0) call DCOPY_(NAC,C(INMY+IPOA(ICSYM)),1,A,1)
              if (IFT == 1) call VNEG(NAC,C(INMY+IPOA(ICSYM)),1,A,1)
            else
              call MTRANS(C(INMY+IPOA(IASYM)),A,NVIR(IASYM),NVIR(ICSYM))
            end if
            call FMUL2(A,A,B,NVIR(IASYM),NVIR(IASYM),NVIR(ICSYM))
            IPF = IPOF(IASYM)+1
            COPI = One/(sqrt(ENP(INDA))*sqrt(ENP(INDA)))
            F(IPF:IPF+IAB-1) = F(IPF:IPF+IAB-1)+COPI*B(1:IAB)
            NVIRA = NVIR(IASYM)
            NVIRC = NVIR(ICSYM)
            INN = 1
            LNC = LN+NSYS(ICSYM)
            IIC = IROW(LNC+1)
            do I=1,NVIRC
              RSUM = DDOT_(NVIRA,A(INN),1,A(INN),1)
              RSUM = COPI*RSUM
              TSUM = TSUM+RSUM
              IIC = IIC+LNC+I
              FC(IIC) = FC(IIC)+RSUM
              INN = INN+NVIRA
            end do
          end if
        end do
        if (IDENS == 0) cycle
        TSUM = TSUM*Half
      end if
    end if
    IJ = 0
    do I=1,LN
      IJ = IJ+I
      FC(IJ) = FC(IJ)+IOC(I)*TSUM
    end do
  end do
  ITURN = 1
  if (IDENS /= 1) exit
end do
call DSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)
!NCONF = JSC(4)
!write(u6,987) (S(I),I=1,NCONF)
!write(u6,986) (W(I),I=1,NCONF)

return

310 format(/,6X,'TRACE OF DENSITY MATRIX',F16.8)
!986 format(1X,'W,AB',5F10.6)
!987 format(1X,'S,AB',5F10.6)

end subroutine AB_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SYGTOSD(ICNFTAB,ISPNTAB,ISSTAB,IFSBTAB,CISYG,CISD)
      IMPLICIT NONE
      REAL*8 CISYG(*),CISD(*)
      INTEGER ICNFTAB(*),ISPNTAB(*),ISSTAB(*),IFSBTAB(*)
      INTEGER NASPRT
      INTEGER MINOP,MAXOP,NACTEL,NOPEN,NCLSD
      INTEGER NCNF,NSPD,NCPL,ISPART,ISST
C     INTEGER KFSB,IBLK,ISPD,I,IPOS,IORB,ISYM
      INTEGER KFSB,IBLK,ISPD,I,IPOS,IORB
      INTEGER ISPN,NO,IOSTA,IOEND,IMORS,ISBSTR
#include "WrkSpc.fh"
      INTEGER ICNF,IEL,IEL1,IEL2,IFORM,IFSB,IOCC
      INTEGER IPART,IREST
C     INTEGER ISTARR,LDIM,LOCARR,LORBARR,LSBSET,LSSARR,LSTARR
      INTEGER        LDIM,LOCARR,LORBARR,LSBSET,LSSARR,LSTARR
      INTEGER ISORB,ISPEND,ISPSTA,ISUM,ISYGEND,ISYGSTA,NWRD
      INTEGER IWORD,IWRD,JSST,KCNF,KCNFINF,KGSLIM,KGSORB,KHSHMAP
      INTEGER KMRSSBS,KSPNINF,KSSTARR,KSSTTB,LBLK,KSPN,LSPTRA
      INTEGER LSYM,MORSBITS,MXBLK,NAPART,NBLK,NHEAD
      INTEGER NHSHMAP,NOCC,NOP,NORB,NSP,NSSTP,NSYM
C     INTEGER IERR,ICPL,KSBSMRS,JMORS,NFSB
      INTEGER IERR,     KSBSMRS,      NFSB
      INTEGER OCC2MRS
      EXTERNAL OCC2MRS

C Unbutton the configuration table:
      NACTEL=ICNFTAB(3)
      NORB  =ICNFTAB(4)
      MINOP =ICNFTAB(5)
      MAXOP =ICNFTAB(6)
      NSYM  =ICNFTAB(7)
      LSYM  =ICNFTAB(8)
      NAPART=ICNFTAB(9)
      IFORM =ICNFTAB(10)
      NHEAD=10
      KGSORB =NHEAD+1
      KGSLIM =KGSORB+(NSYM+1)*(NAPART+1)
      KCNFINF =KGSLIM+2*NAPART
CTEST      write(*,*)' Table at KGSORB:'
CTEST      do ipart=0,napart
CTEST       write(*,'(1x,10i5)')(icnftab(kgsorb+isym+(nsym+1)*ipart)
CTEST     &                                             ,isym=0,nsym)
CTEST      end do
CTEST      write(*,*)' Table at KGSLIM:'
CTEST      write(*,'(1x,10i5)')(icnftab(kgslim+2*(ipart-1)),ipart=1,napart)
CTEST      write(*,'(1x,10i5)')(icnftab(kgslim+1+2*(ipart-1)),ipart=1,napart)
C Unbutton the spin coupling table:
      KSPNINF=9
C Unbutton the Substring Table:
      NASPRT=ISSTAB(5)
      MORSBITS=ISSTAB(6)
      NSSTP =ISSTAB(7)
      KSSTTB=15
      KSBSMRS=ISSTAB(11)
      KMRSSBS=ISSTAB(12)
C Unbutton the Fock Sector Block table:
      NHEAD=7
      KSSTARR=NHEAD+1
      NFSB   =IFSBTAB(2)
      NHSHMAP=IFSBTAB(6)
      KHSHMAP=IFSBTAB(7)

C MXBLK=Largest individual SYG block of determinants:
      MXBLK=0
      DO NOPEN=MINOP,MAXOP
        NCNF=ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP)))
        NCPL=ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+2)
        MXBLK=MAX(NCNF*NCPL,MXBLK)
      END DO
C A variety of small temporary arrays used:
      CALL GETMEM('TmpArr','Allo','Real',LBLK,MXBLK)
      CALL GETMEM('OrbArr','Allo','Inte',LORBARR,NACTEL)
      CALL GETMEM('OccArr','Allo','Inte',LOCARR,2*NORB)
      CALL GETMEM('STArr','Allo','Inte',LSTARR,NASPRT)
      CALL GETMEM('Dims','Allo','Inte',LDIM,NASPRT)
      CALL GETMEM('SSArr','Allo','Inte',LSSARR,NASPRT)
      CALL GETMEM('NSBSET','Allo','Inte',LSBSET,NSSTP)
C We will need later the accumulated number of substrings of
C earlier substring types:
      ISUM=0
      DO ISST=1,NSSTP
        IWORK(LSBSET-1+ISST)=ISUM
        ISUM=ISUM+ISSTAB(KSSTTB+5*(ISST-1))
      END DO
C Loop over nr of open shells.
      ISYGEND=0
      DO NOPEN=MINOP,MAXOP
        NCLSD=(NACTEL-NOPEN)/2
        IF(NCLSD.LT.0) GOTO 100
        IF(2*NCLSD+NOPEN.NE.NACTEL) GOTO 100
        NOCC=NCLSD+NOPEN
        IF(NOCC.GT.NORB) GOTO 100
        NCNF=ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP)))
        IF(NCNF.EQ.0) GOTO 100
        KCNF=ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP))+1)
        NWRD=ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP))+2)
        NCPL=ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+1)
        NSPD=ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+2)
        KSPN=ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+4)
        IF(NSPD.EQ.0) GOTO 100
        IF(NCPL.EQ.0) GOTO 100
C ISYGSTA=1st element of each block
        NBLK=NCPL*NCNF
        ISYGSTA=ISYGEND+1
        ISYGEND=ISYGEND+NBLK
C Location of spin coupling coefficients:
        LSPTRA=ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+5)
C Matrix multiplication into temporary array:
        CALL  DGEMM_('N','N',NSPD,NCNF,NCPL,1.0D0,
     &               WORK(LSPTRA),NSPD,
     &               CISYG(ISYGSTA),NCPL,0.0D0,
     &               WORK(LBLK),NSPD)

C There is no phase factor in the reorder of orbitals from SYG
C to SD. But there is a fairly lengthy procedure for finding the
C correct position of each CI coefficient.
        IBLK=0
C Loop over configurations
        IWORD = 0 ! dummy initialize
        DO ICNF=1,NCNF
          IF(IFORM.EQ.1) THEN
            DO IEL=1,NOCC
              IWORK(LORBARR-1+IEL)=ICNFTAB(KCNF-1+IEL+NWRD*(ICNF-1))
            END DO
          ELSE IF(IFORM.EQ.2) THEN
            IEL2=0
            IEL1=NCLSD
            DO IORB=1,NORB
              IOCC=ICNFTAB(KCNF-1+IORB+NWRD*(ICNF-1))
              IF(IOCC.EQ.1) THEN
                IEL1=IEL1+1
                IWORK(LORBARR-1+IEL1)=IORB
              ELSE
                IEL2=IEL2+1
                IWORK(LORBARR-1+IEL2)=IORB
              END IF
            END DO
          ELSE IF(IFORM.EQ.3) THEN
            DO IEL=1,NOCC
              IWRD=(3+IEL)/4
              IREST=(3+IEL)-4*IWRD
              IF(IREST.EQ.0) THEN
                IWORD=ICNFTAB(KCNF-1+IWRD+NWRD*(ICNF-1))
              END IF
              IORB=MOD(IWORD,256)
              IWORD=IWORD/256
              IWORK(LORBARR-1+IEL)=IORB
            END DO
          ELSE IF(IFORM.EQ.4) THEN
            IEL2=0
            IEL1=NCLSD
            DO IORB=1,NORB
              IWRD=(IORB+14)/15
              IREST=IORB+14-15*IWRD
              IF(IREST.EQ.0) THEN
                IWORD=ICNFTAB(KCNF-1+IWRD+NWRD*(ICNF-1))
              END IF
              IOCC=MOD(IWORD,4)
              IWORD=IWORD/4
              IF(IOCC.EQ.1) THEN
                IEL1=IEL1+1
                IWORK(LORBARR-1+IEL1)=IORB
              ELSE
                IEL2=IEL2+1
                IWORK(LORBARR-1+IEL2)=IORB
              END IF
            END DO
          END IF

CTEST      write(*,'(1x,a,10i5)')'Configuration:',
CTEST     &                          (iwork(lorbarr-1+iel),iel=1,nocc)
CTEST      write(*,*)' Loop over spin determinants.'
C Loop over spin determinants
          DO ISPD=1,NSPD
CTEST      write(*,'(1x,a,20i3)')'Spin determinant:',
CTEST     &                    (ISPNTAB(KSPN-1+I+NOPEN*(ISPD-1)),I=1,nopen)
            IBLK=IBLK+1
C Construct occupation number array:
            CALL ICOPY(2*NORB,[0],0,IWORK(LOCARR),1)
            DO IEL=1,NCLSD
              IORB=IWORK(LORBARR-1+IEL)
              IWORK(LOCARR-1+2*IORB-1)=1
              IWORK(LOCARR-1+2*IORB  )=1
            END DO
            DO I=1,NOPEN
C Spin of each electron is coded as 1 for alpha, 0 for beta.
              ISPN=ISPNTAB(KSPN-1+I+NOPEN*(ISPD-1))
              IEL=NCLSD+I
              ISORB=2*IWORK(LORBARR-1+IEL)-ISPN
              IWORK(LOCARR-1+ISORB)=1
            END DO
C Identify substrings:
C Loop over active partitions. Subdivide as needed into subpartitions.
CTEST      write(*,*)' Identify substrings.'
CTEST      write(*,'(1x,a,10i5)')'Occupation array:',
CTEST     &                          (iwork(locarr-1+isorb),isorb=1,2*norb)
            IOEND=0
            ISPEND=0
CTEST      write(*,'(1x,a,10i5)')'NAPART:',NAPART
            DO IPART=1,NAPART
CTEST      write(*,'(1x,a,10i5)')' In loop, IPART:',IPART
             NOP=2*ICNFTAB(KGSORB+(NSYM+1)*IPART)
CTEST      write(*,'(1x,a,10i5)')'            NOP:',NOP
CTEST             IF(NOP.EQ.0) write(*,*)' (Skip it.)'
             IF(NOP.EQ.0) GOTO 200
             NSP=(NOP+MORSBITS-1)/MORSBITS
CTEST      write(*,'(1x,a,10i5)')'            NSP:',NSP
             ISPSTA=ISPEND+1
             ISPEND=ISPEND+NSP
             DO ISPART=ISPSTA,ISPEND
CTEST      write(*,'(1x,a,10i5)')'Loop lims ISPSTA,ISPEND:',ISPSTA,ISPEND
              NO=MIN(NOP,MORSBITS)
              NOP=NOP-NO
              IOSTA=IOEND+1
              IOEND=IOEND+NO
CTEST      write(*,'(1x,a,10i5)')'IOSTA,IOEND:',IOSTA,IOEND
CTEST      write(*,'(1x,a,10i5)')'Occ array:',
CTEST     &                     (IWORK(LOCARR-1+ISORB),ISORB=IOSTA,IOEND)
              IMORS=OCC2MRS(NO,IWORK(LOCARR-1+IOSTA))
CTEST      write(*,'(1x,a,10i5)')'IMORS=',IMORS
C Position in Morsel-to-Substring table:
              IPOS=KMRSSBS+2*(IMORS+(2**MORSBITS)*(ISPART-1))
C Substring ID number
              ISBSTR=ISSTAB(IPOS)
C Test:
CTEST              JMORS=ISSTAB(KSBSMRS+2*(ISBSTR-1))
CTEST              IF(IMORS.NE.JMORS)THEN
CTEST                WRITE(*,*)' Mistranslated morsel!!'
CTEST      write(*,'(1x,a,4i12)')'IMORS->ISBSTR:',IMORS,ISBSTR
CTEST      write(*,'(1x,a,4i12)')'but ISBSTR->IMORS:',ISBSTR,JMORS
CTEST      write(*,'(1x,a,4i12)')'KMRSSBS:',KMRSSBS
CTEST      write(*,'(1x,a,4i12)')'KSBSMRS:',KSBSMRS
CTEST                CALL ABEND()
CTEST              END IF
CTEST      write(*,'(1x,a,10i5)')'ISBSTR:',ISBSTR
C Substring type ISST, nr of such substrings is NDIM
              ISST=ISSTAB(IPOS+1)
CTEST      write(*,'(1x,a,10i5)')'ISST  :',ISST
              IWORK(LSTARR-1+ISPART)=ISST
              IWORK(LDIM-1+ISPART)=ISSTAB(KSSTTB+5*(ISST-1))
              IWORK(LSSARR-1+ISPART)=ISBSTR-IWORK(LSBSET-1+ISST)
             END DO
 200         CONTINUE
            END DO
CTEST      write(*,*)' Finally, substring types and substrings:'
CTEST      write(*,'(1x,a,10i5)')'Substr types:',
CTEST     &                   (IWORK(LSTARR-1+ISPART),ISPART=1,NASPRT)
CTEST      write(*,'(1x,a,10i5)')'Substrings  :',
CTEST     &                    (IWORK(LSSARR-1+ISPART),ISPART=1,NASPRT)
CTEST      write(*,'(1x,a,10i5)')'Dimensions  :',
CTEST     &                    (IWORK(LDIM  -1+ISPART),ISPART=1,NASPRT)
C Position within FS block:
            IPOS=(IWORK(LSSARR-1+NASPRT)-1)
            DO ISPART=NASPRT-1,1,-1
              IPOS=IWORK(LDIM-1+ISPART)*IPOS+(IWORK(LSSARR-1+ISPART)-1)
            END DO
            IPOS=IPOS+1
C Identify Fock Sector Block:
CTEST      write(*,*)' Arguments in HSHGET call:'
CTEST      write(*,'(1x,a,10i5)')'Key:',
CTEST     &                   (IWORK(LSTARR-1+ISPART),ISPART=1,NASPRT)
CTEST      write(*,'(1x,a,10i5)')'Size of key:',NASPRT
CTEST      write(*,'(1x,a,10i5)')'Size of items stored:',NASPRT+2
CTEST      write(*,'(1x,a,10i5)')'Items stored at KSSTARR=',KSSTARR
CTEST      write(*,'(1x,a,10i5)')'      Map size  NHSHMAP=',NHSHMAP
CTEST      write(*,'(1x,a,10i5)')'  Map stored at KHSHMAP=',KHSHMAP
            CALL HSHGET(IWORK(LSTARR),NASPRT,NASPRT+2,IFSBTAB(KSSTARR),
     &                            NHSHMAP,IFSBTAB(KHSHMAP),IFSB)
CTEST      write(*,'(1x,a,10i5)')' Map returns index IFSB=',IFSB
CTEST      write(*,'(1x,a,10i5)')' Item stored there is  =',
CTEST     &                 (IFSBTAB(KSSTARR-1+ISPART+(NASPRT+2)*(IFSB-1)),
CTEST     &                                              ISPART=1,NASPRT+2)
C Position of this FS block in SD wave function:
            KFSB=IFSBTAB(KSSTARR+(NASPRT+2)*IFSB-1)
C Temporary check, may be removed later. See that we have picked up
C the correct FS block.
            IERR=0
            DO ISPART=1,NASPRT
              JSST=IFSBTAB(KSSTARR-1+ISPART+(NASPRT+2)*(IFSB-1))
              ISST=IWORK(LSTARR-1+ISPART)
              IF(ISST.NE.JSST) IERR=1
            END DO
            IF(IERR.NE.0) THEN
              WRITE(6,*) ' SYGTOSD Error:'//
     &                     ' Hash map returned the wrong FS block!'
              WRITE(6,'(1x,a,8I8)')'NOPEN,ICNF,ISPN:',NOPEN,ICNF,ISPN
              WRITE(6,'(1x,a,20I3)')'Configuration:',
     &                               (IWORK(LORBARR-1+IEL),IEL=1,NACTEL)
              WRITE(6,'(1x,a,20I3)')'Determinant:',
     &                            (IWORK(LOCARR-1+ISORB),ISORB=1,2*NORB)
              WRITE(6,'(1x,a,10I5)')'Substring type combination:',
     &                         (IWORK(LSTARR-1+ISPART),ISPART=1,NASPRT)
              WRITE(6,'(1x,a,10I5)')'Substring combination:',
     &                         (IWORK(LSSARR-1+ISPART),ISPART=1,NASPRT)
              WRITE(6,'(1x,a,8I8)')'Hash table says IFSB=',IFSB
              IF(IFSB.GT.0 .AND. IFSB.LE.NFSB) THEN
              WRITE(6,'(1x,a,8I8)')'but that FS block would contain',
     & (IFSBTAB(KSSTARR-1+ISPART+(NASPRT+2)*(IFSB-1)),ISPART=1,NASPRT)
              ELSE
              WRITE(6,*)'but there is no such FS block!'
              WRITE(6,*)' The FS block table follows:'
              CALL PRFSBTAB(IFSBTAB)
              END IF
              CALL ABEND()
            END IF
C Finally:
            CISD(KFSB-1+IPOS)=WORK(LBLK-1+IBLK)
C End of spin-determinant loop
          END DO
C End of loop over configurations
        END DO
C End of loop over nr of open shells
 100    CONTINUE
      END DO
      CALL GETMEM('TmpArr','Free','Real',LBLK,MXBLK)
      CALL GETMEM('OrbArr','Free','Inte',LORBARR,NACTEL)
      CALL GETMEM('OccArr','Free','Inte',LOCARR,NORB)
      CALL GETMEM('STArr','Free','Inte',LSTARR,NASPRT)
      CALL GETMEM('Dims','Free','Inte',LDIM,NASPRT)
      CALL GETMEM('SSArr','Free','Inte',LSSARR,NASPRT)
      CALL GETMEM('NSBSET','Free','Inte',LSBSET,NSSTP)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Qpg_zArray(Label,Found,nData)
      Implicit None

      Character*(*) Label
      Logical       FoundR, FoundI, Found
      Integer       nData, nDataR, nDataI

      call qpg_darray ('R'//Label,FoundR,nDataR)
      call qpg_darray ('I'//Label,FoundI,nDataI)

      if ((nDataR.eq.nDataI).and.FoundR.and.FoundI) then
         nData=nDataR
         found=.true.
      else
         found=.false.
         ndata=0
      end if

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifdef _IN_MODULE_

subroutine Fix_Exponents(nP,mP,nC,Expn,CoeffC,CoeffP)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nP, nC
integer(kind=iwp), intent(out) :: mP
real(kind=wp), allocatable, intent(inout) :: Expn(:), CoeffC(:,:,:), CoeffP(:,:,:)
integer(kind=iwp) :: i, iC, iP, jP, iSkip
real(kind=wp) :: Temp, Thr_Skip
real(kind=wp), allocatable :: Scr1(:), Scr2(:,:,:)

!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt('Fix_Exponents: Expn',' ',Expn,1,nP)
call RecPrt('Fix_Exponents: CoeffC(1)',' ',CoeffC(:,:,1),nP,nC)
call RecPrt('Fix_Exponents: CoeffC(2)',' ',CoeffC(:,:,2),nP,nC)
call RecPrt('Fix_Exponents: CoeffP(1)',' ',CoeffP(:,:,1),nP,nP)
call RecPrt('Fix_Exponents: CoeffP(2)',' ',CoeffP(:,:,2),nP,nP)
#endif

mP = nP

! First, put the exponents with all coefficients less than the
! threshold, Thr_Skip, at the end.

Thr_Skip = 1.0e-13_wp
do iP=nP,1,-1

  iSkip = 1
  do iC=1,nC
    if (abs(CoeffC(iP,iC,1)) >= Thr_Skip) iSkip = 0
  end do

  if (iSkip == 1) then
    if (iP < mP) then
      Temp = Expn(iP)
      Expn(iP) = Expn(mP)
      Expn(mP) = Temp
      do i=1,2
        Temp = CoeffP(iP,iP,i)
        CoeffP(iP,iP,i) = CoeffP(mP,mP,i)
        CoeffP(mP,mP,i) = Temp
        do iC=1,nC
          Temp = CoeffC(iP,iC,i)
          CoeffC(iP,iC,i) = CoeffC(mP,iC,i)
          CoeffC(mP,iC,i) = Temp
        end do
      end do
    end if
    mP = mP-1
  end if

end do

! Second, order from largest to smallest exponent

do iP=1,mP-1
  do jP=iP+1,mP
    if (Expn(jP) > Expn(ip)) then
      Temp = Expn(iP)
      Expn(iP) = Expn(jP)
      Expn(jP) = Temp
      do i=1,2
        Temp = CoeffP(iP,iP,i)
        CoeffP(iP,iP,i) = CoeffP(jP,jP,i)
        CoeffP(jP,jP,i) = Temp
        do iC=1,nC
          Temp = CoeffC(iP,iC,i)
          CoeffC(iP,iC,i) = CoeffC(jP,iC,i)
          CoeffC(jP,iC,i) = Temp
        end do
      end do
    end if
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'After Fix_Exp'
call RecPrt('Fix_Exponents: Expn',' ',Expn,1,nP)
call RecPrt('Fix_Exponents: CoeffC(1)',' ',CoeffC(:,:,1),nP,nC)
call RecPrt('Fix_Exponents: CoeffC(2)',' ',CoeffC(:,:,2),nP,nC)
call RecPrt('Fix_Exponents: CoeffP(1)',' ',CoeffP(:,:,1),nP,nP)
call RecPrt('Fix_Exponents: CoeffP(2)',' ',CoeffP(:,:,2),nP,nP)
#endif

! Reallocate arrays if the number of primitives is reduced.

if (mP /= nP) then
  call mma_allocate(Scr1,mP,Label='Expn')
  Scr1(:) = Expn(1:mP)
  call mma_deallocate(Expn)
  call move_alloc(Scr1,Expn)

  call mma_allocate(Scr2,mP,nC,2,Label='CoeffC')
  Scr2(:,:,:) = CoeffC(1:mP,1:nC,:)
  call mma_deallocate(CoeffC)
  call move_alloc(Scr2,CoeffC)

  call mma_allocate(Scr2,mP,mP,2,Label='CoeffP')
  Scr2(:,:,:) = CoeffP(1:mP,1:mP,:)
  call mma_deallocate(CoeffP)
  call move_alloc(Scr2,CoeffP)

# ifdef _DEBUGPRINT_
  write(u6,*) 'After Reallocation'
  call RecPrt('Fix_Exponents: Expn',' ',Expn,1,mP)
  call RecPrt('Fix_Exponents: CoeffC(1)',' ',CoeffC(:,:,1),mP,nC)
  call RecPrt('Fix_Exponents: CoeffC(2)',' ',CoeffC(:,:,2),mP,nC)
  call RecPrt('Fix_Exponents: CoeffP(1)',' ',CoeffP(:,:,1),mP,mP)
  call RecPrt('Fix_Exponents: CoeffP(2)',' ',CoeffP(:,:,2),mP,mP)
else
  write(u6,*) 'No Reallocation'
# endif
end if

return

end subroutine Fix_Exponents

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************
!  MyGetKey
!
!> @brief
!>   General purpose routine to read arbitrary data from user input.
!> @author V. Veryazov
!>
!> @details
!> The routine read a line from unit \p InUnit (ignoring molcas comments
!> and blank lines), and return a value or an array.
!>
!> Parameter \p What specifies the type of data:
!> * ``I`` -- read an integer and return it as \p IValue
!> * ``R`` -- read a real and return it as \p RValue
!> * ``S`` -- read a string and return it as \p SValue
!> * ``U`` -- recognize integer/real/string and return corresponding value
!> * ``A`` -- read integer array and return \p IArr
!> * ``D`` -- read real array and return \p RArr
!>
!> @param[in]     InUnit   Unit number
!> @param[in,out] What     Type of input
!> @param[out]    IValue   Integer Value
!> @param[out]    RValue   Real Value
!> @param[out]    SValue   String value
!> @param[in]     N        Size of array
!> @param[out]    IArr     Integer Array
!> @param[out]    RArr     Real Array

function MyGetKey(InUnit,What,IValue,RValue,SValue,N,IArr,RArr)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

#include "intent.fh"

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: MyGetKey
integer(kind=iwp), intent(in) :: InUnit, N
character, intent(inout) :: What
integer(kind=iwp), intent(out) :: IValue
real(kind=wp), intent(out) :: RValue
character(len=*), intent(out) :: SValue
integer(kind=iwp), intent(_OUT_) :: IArr(*)
real(kind=wp), intent(_OUT_) :: RArr(*)
integer(kind=iwp) :: i, iptr, istatus
logical(kind=iwp) :: retry
character(len=120) :: KWord

MyGetKey = 0
iptr = 1
i = 1
retry = .true.
do while (retry)
  read(InUnit,'(A)',iostat=istatus) KWord
  if (istatus /= 0) then
    MyGetKey = 1
    exit
  end if
  if ((KWord(1:1) == '*') .or. (KWord == ' ')) cycle
  retry = .false.
  call UpCase(KWord)
  select case (What)
    case ('I')
      read(KWord,*,iostat=istatus) IValue
      if (istatus > 0) MyGetKey = 1
    case ('R')
      read(KWord,*,iostat=istatus) RValue
      if (istatus > 0) MyGetKey = 1
    case ('A')
      read(KWord,*,iostat=istatus) (IArr(i),i=iptr,N)
      if (istatus > 0) then
        MyGetKey = 1
      else if (istatus < 0) then
        iptr = i
        retry = .true.
      end if
    case ('D')
      read(KWord,*,iostat=istatus) (RArr(i),i=iptr,N)
      if (istatus > 0) then
        MyGetKey = 1
      else if (istatus < 0) then
        iptr = i
        retry = .true.
      end if
    case ('S')
      call NoBlanks(SValue,KWord)
    case ('U')
      read(KWord,*,iostat=istatus) IValue
      if (istatus > 0) then
        read(KWord,*,iostat=istatus) RValue
        if (istatus > 0) then
          call NoBlanks(SValue,KWord)
          What = 'S'
        else
          What = 'R'
        end if
      else
        What = 'I'
      end if
    case default
  end select
end do

return

end function MyGetKey

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine sets the name for the runfile.                          *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund university, Sweden                                     *
! Written: August 2003                                                 *
!                                                                      *
!***********************************************************************

subroutine NameRun(fName)

use RunFile_data, only: RnNmStk, RunName

implicit none
character(len=*), intent(in) :: fName

if (fName == '#Pop') then
  RunName = RnNmStk(1)
  RnNmStk(1) = RnNmStk(2)
  RnNmStk(2) = RnNmStk(3)
  RnNmStk(3) = RnNmStk(4)
  RnNmStk(4) = ''
else
  RnNmStk(4) = RnNmStk(3)
  RnNmStk(3) = RnNmStk(2)
  RnNmStk(2) = RnNmStk(1)
  RnNmStk(1) = RunName
  RunName = fName
end if

call ClrRunCache()

! Do not create the run file when naming it, patch 6.7.263

!iRc = 0
!iOpt = 1
!call MkRun(iRc,iOpt)

return

end subroutine NameRun

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      FUNCTION IZNUM_PTDT(IAB,NOPEN,NALPHA,Z,NEWORD,IREORD)
*
* Adress of prototype determinant IAB
* alpha occupation is used to define lex address
*
* Jeppe Olsen, Dec. 2001
*
#include "implicit.fh"
      INTEGER Z(NOPEN,NALPHA)
      DIMENSION IAB(*),NEWORD(*)
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' IZNUM_PTDT, NOPEN, NALPHA = ', NOPEN,NALPHA
        WRITE(6,*) ' Input Z- matrix '
        CALL IWRTMA(Z,NOPEN,NALPHA,NOPEN,NALPHA)
      END IF
*
      IZ = 1
      IALPHA = 0
      DO I = 1,NOPEN
        IF(IAB(I).GT.0) THEN
          IALPHA = IALPHA + 1
          IZ = IZ + Z(I,IALPHA)
        END IF
      END DO
*
C?    WRITE(6,*) ' IZ = ', IZ
      IF(IREORD.EQ.0) THEN
        IZNUM_PTDT = IZ
      ELSE
        IZNUM_PTDT = NEWORD(IZ)
      END IF
*
      IF ( NTEST .GE. 100 ) THEN
        WRITE(6,*) ' Output from IZNUM_PTDT '
        WRITE(6,*) ' Prototype determinant '
        CALL IWRTMA(IAB,1,NOPEN,1,NOPEN)
        WRITE(6,*) ' Address = ', IZNUM_PTDT
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Ignacio Fdez. Galvan                             *
*               2017, Roland Lindh                                     *
************************************************************************
*  Davidson_SCF
*
*> @brief
*>   Compute the lowest \p k eigenvalues of a symmetric matrix.
*> @author Ignacio Fdez. Galv&aacute;n
*> @modified_by Roland Lindh
*>
*> @details
*> Simple application of the Davidson procedure to obtain the lowest \p k eigenvalues
*> and corresponding eigenvectors of a symmetric matrix.
*> On input, \p Vec can contain an initial guess for the eigenvectors (from a previous
*> run with smaller \p k, for example), only the non-zero vectors are used.
*> This routine is adapted to an augmented Hessian, which is not explicitly expressed,
*> rather the original Hessian is implicitly there, via a diagonal and an on-the-fly
*> update when multiplied by a vector, and the gradient is explicit there.
*>
*> @param[in]     HDiag  Diagonal of the Hessian matrix
*> @param[in]     g      Gradient vector
*> @param[in]     m      Size of diagonal Hessian and gradient
*> @param[in]     k      Number of lowest eigenvalues to compute
*> @param[in]     Fact   Scaling factor
*> @param[out]    Eig    Lowest eigenvalues
*> @param[in,out] Vec    Lowest eigenvectors
*> @param[in]     MemRsv Amount of reserved memory
*> @param[out]    iRC    Return code (0 if converged)
************************************************************************
      SUBROUTINE Davidson_SCF(HDiag,g,m,k,Fact,Eig,Vec,MemRsv,iRC)
      IMPLICIT NONE
      INTEGER m,n,k,iRC, MemRsv
      REAL*8  HDiag(m),g(m),Eig(k),Vec(m+1,k), Fact
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: Sub, Ab
      REAL*8, DIMENSION(:), ALLOCATABLE :: Eig_old, EVec, Proj, EVal
      INTEGER, DIMENSION(:), ALLOCATABLE :: Index_D
      REAL*8 Aux,Thr,Thr2,Thr3,Conv,Alpha,tmp
      real*8 ddot_
      INTEGER mk,old_mk,mink,maxk,ig,info,nTmp,iter,maxiter
      INTEGER i,j,ii,jj
      INTEGER ipTmp,ipDum
      INTEGER ipDiag,ipTVec,ipTAV,ipTRes
      LOGICAL Last,Augmented,Reduced
      external ddot_
      PARAMETER (Thr=1.0D-6, maxiter=300, Thr2=1.0D-16, Thr3=1.0D-16)
*
#include "stdalloc.fh"
#include "real.fh"
#include "WrkSpc.fh"
      INTEGER iPrint,iRout
#include "print.fh"

      iRout=216
      iPrint=nPrint(iRout)
      n=m+1

*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call NrmClc(HDiag,m,'Davidson_SCF','HDiag')
      Call NrmClc(    g,m,'Davidson_SCF','g')
*     CALL RecPrt('HDiag',' ',HDiag,m,1)
*     CALL RecPrt('g',' ',g,m,1)
      Do i = 1, m
         Write (6,'(2G10.1)') g(i),HDiag(i)
      End Do
#endif

*---- Initialize some parameters
*      mk   = subspace size (initially k)
*      maxk = maximum subspace size (25 if k=1)
*      mink = subspace size to reduce to when the maximum is exceeded (5 if k=1)
*
      IF (k.GT.n) THEN
        CALL SysAbendMsg('Davidson_SCF','Wrong k value.','')
      END IF
      mink=MIN(MAX(k+2,5),n)
      maxk=MIN(5*mink,n)
      mk=k
      iRC=0

*---- Allocate matrices
*      Sub  = Vectors (columns) defining the subspace (maximum maxk vectors)
*      Ab   = A*b vectors (A * Sub)
*      EVal  = Set of computed eigenvalues (maximum maxk elements)
*      EVec  = Set of computed eigenvectors, in the subspace (maximum maxk*maxk)
*
      CALL mma_allocate(Eig_old,k,label="Eig_old")
      Call mma_allocate(Sub,n,maxk,Label='Sub')
      Call mma_allocate(Ab ,n,maxk,Label='Ab ')
      Call mma_allocate(Proj,maxk*maxk,Label='Proj')
      Call mma_allocate(EVal,maxk     ,Label='EVal')
      Call mma_allocate(EVec,maxk*maxk,Label='EVec')
      CALL DZero(Ab,n*maxk)
      CALL DZero(EVal,maxk)
      CALL DZero(EVec,maxk*maxk)

*---- Build an index of sorted diagonal elements in A
*
      Call mma_allocate(Index_D,n,Label='Index_D')
      DO i=1,n
         Index_D(i)=i
      END DO
*
      DO i=1,n
         ii=Index_D(i)
         If (ii.eq.n) Then
            Aux=Zero
         Else
            Aux=HDiag(ii)
         End If
         ii=i
         DO j=i,n
            jj=Index_D(j)
            If (jj.eq.n) Then
               Tmp=Zero
            Else
               Tmp=HDiag(jj)
            End If
            IF (Tmp .LT. Aux) THEN
               Aux=Tmp
               ii=j
            END IF
         END DO
         IF (ii .NE. i) THEN
            jj=Index_D(ii)
            Index_D(ii)=Index_D(i)
            Index_D(i)=jj
         END IF
      END DO
#ifdef _DEBUGPRINT_
*     Write (6,*) 'Index_D=',Index_D
#endif

*---- Setup the initial subspace
*      Read the non-linear-dependent columns from the initial eigenvector matrix
*      Fill up to mk with selected base vectors from the initial matrix
*       (those corresponding to the lowest diagonal elements)
*      The rest is set to zero, just in case
*
      nTmp=0
      CALL Allocate_Work(ipTmp,n)
      DO i=1,k
        call dcopy_(n,Vec(1,i),1,Work(ipTmp),1)
        CALL Add_Vector(n,nTmp,Sub,Work(ipTmp),Thr3)
      END DO
*
      ii=0
      CALL DZero(Work(ipTmp),n)
*
      DO WHILE ((nTmp .LT. mk) .AND. (ii .LT. n))
         ii=ii+1
         jj=Index_D(ii)
*
*        A large value indicates a forbidden rotation.
*        A negative value indicates large rotation to another
*        global minimum. Avoid these!!!
*
         If (jj.eq.n) Then
           Aux=Zero
         Else
           Aux=HDiag(jj)
         End If
         If (Aux.lt.1.0D10.and.Aux.gt.-0.10D0) Then
            Work(ipTmp+jj-1)=One
            CALL Add_Vector(n,nTmp,Sub,Work(ipTmp),Thr3)
            Work(ipTmp+jj-1)=Zero
         End If
      END DO
*
*     ig will be a global counter to loop across all n base vectors
      ig=ii
      CALL Free_Work(ipTmp)
      CALL DZero(Sub(1,mk+1),(maxk-mk)*n)

*---- Iterative procedure starts here
*      mk     = subspace size at each iteration
*      old_mk = value of mk at the previous iteration
*
      Augmented=.FALSE.
      Reduced=.FALSE.
      Last=.FALSE.
      old_mk=0
      iter=0
      CALL Allocate_Work(ipDum,1)
      CALL Allocate_Work(ipDiag,n)
      CALL Allocate_Work(ipTVec,n)
      CALL Allocate_Work(ipTAV,n)
      CALL Allocate_Work(ipTRes,n)
      DO WHILE (.NOT. Last)
        iter=iter+1
        IF (iter .GT. 1) call dcopy_(k,Eig,1,Eig_old,1)
#ifdef _DEBUGPRINT_
        IF (.NOT. Reduced) THEN
          WRITE(6,'(A)') '---------------'
          WRITE(6,'(A,1X,I5)') 'Iteration',iter
        END IF
        CALL RecPrt('Orthonormalized subspace',' ',Sub,n,mk)
#endif

*----   Compute the matrix product
*        Ab = A * Sub
*        Only the new vectors since the last iterations need to be
*        calculated
*
*       Note that the A-matrix is the augmented Hessian of a rs-rfo
*       approach. The A matrix is not explicitly stored but rather only
*       the associated gradient is. The original Hessian is implicitly
*       there and a vector corresponding to the contraction of the updated
*       Hessian and a trial vector can be computed on-the-fly.
*
        Do j=old_mk,mk-1
#ifdef _DEBUGPRINT_
           Write (6,*) 'Davidson_SCF: j,Fact=',j,Fact
           Call NrmClc(Sub(1,j+1),n,'Davidson_SCF','Sub(1,j+1)')
           Call RecPrt('Sub',' ',Sub(1,j+1),1,n)
#endif
*
*          Pick up the contribution for the updated Hessian (BFGS update)
*
           Call SOrUpV(MemRsv,Sub(1,j+1),HDiag,m,Ab(1,j+1),'GRAD',
     &                                                     'BFGS')
           Call DScal_(m,One/Fact,Ab(1,j+1),1)
*
*          Add contribution from the gradient
*
           tmp=Sub(n,j+1)
           Call DaXpY_(m,One/Sqrt(Fact),g,1,Ab(1,j+1),1)
*
           Ab(n,j+1) = DDot_(m,g,1,Sub(1,j+1),1)
#ifdef _DEBUGPRINT_
           Call NrmClc(Ab(1,j+1),n,'Davidson_SCF','Ab(1,j+1)')
           Call RecPrt('Ab',' ',Ab(1,j+1),1,n)
#endif
*
        End Do
*
*----   Compute the matrix to diagonalize (symmetric)
*        Proj = Sub^t * Ab
*        Again, only the new rows/columns are needed
*
        IF (old_mk .EQ. 0) THEN
           CALL DGeMM_('T','N',
     &                 mk,mk,n,
     &                 One,Sub,n,
     &                     Ab,n,
     &                 Zero,Proj,maxk)
        ELSE
          DO i=0,mk-1
            DO j=MAX(old_mk,i),mk-1
              Proj(1+i*maxk+j)=DDot_(n,Sub(1,j+1),1,Ab(1,i+1),1)
            END DO
          END DO
        END IF

*----   Compute the eigenvalues of the projected matrix
*        Make sure the eigenpairs are sorted
*        If the subspace has been reduced, no need to compute new eigenpairs
*
        IF (.NOT. Reduced) THEN
#ifdef _DEBUGPRINT_
          WRITE(6,'(2X,A,1X,I5)') 'Solving for subspace size:',mk
#endif
          call dcopy_(maxk*maxk,Proj,1,EVec,1)
          call dsyev_('V','L',mk,EVec,maxk,EVal,
     &                          Work(ipDum),-1,info)
          nTmp=INT(Work(ipDum))
          CALL Allocate_Work(ipTmp,nTmp)
          call dsyev_('V','L',mk,EVec,maxk,EVal,
     &                          Work(ipTmp),nTmp,info)
          CALL Free_Work(ipTmp)
          CALL JacOrd2(EVal,EVec,mk,maxk)
          call dcopy_(k,EVal,1,Eig,1)
#ifdef _DEBUGPRINT_
          CALL RecPrt('Current guess',' ',Eig,1,k)
#endif
        END IF
#ifdef _DEBUGPRINT_
        IF (iPrint .GE. 99) THEN
          CALL RecPrt('Eigenvalues',' ',EVal,1,mk)
          CALL SubRecPrt('Subspace Eigenvectors',' ',EVec,
     &      maxk,mk,mk)
          WRITE(6,*)
        END IF
#endif
*                                                                      *
************************************************************************
************************************************************************
*----   Check for convergence                                          *
*
*       Converge if the change in the eigenvalues is small
*       (but if a mink size has been reached)
*       Converge if the full system has been solved
*       Stop if the number of iterations exceeds the maximum
*       Stop if no new vectors to add are found
*
*                                                                      *
************************************************************************
*                                                                      *
*       Compute Conv
*
        IF (iter .GT. 1) THEN
*                                                                      *
************************************************************************
*                                                                      *
           Conv=Zero
           DO i=1,k
              IF (ABS(Eig(i)) .GT. Thr2) THEN
                 Conv=MAX(Conv,ABS((Eig(i)-Eig_old(i))/Eig(i)))
              ELSE
                 Conv=MAX(Conv,ABS(Eig(i)-Eig_old(i)))
              END IF
           END DO
#ifdef _DEBUGPRINT_
           IF (Augmented)
     &       WRITE(6,'(2X,A,1X,G12.6)') 'Maximum relative eigenvalue '//
     &                                 'change:',Conv
#endif
*                                                                      *
************************************************************************
*                                                                      *
        ELSE
*                                                                      *
************************************************************************
*                                                                      *
           Conv=Ten*Thr
*                                                                      *
************************************************************************
*                                                                      *
        END IF
*                                                                      *
************************************************************************
*                                                                      *
*       Now check for convergence
*
        old_mk=mk
*                                                                      *
************************************************************************
*                                                                      *
        IF (Augmented .AND. (Conv .LE. Thr)
     &      .AND. (mk .GE. mink)) THEN
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
              WRITE(6,'(A)') 'Converged due to small change'
#endif
          Last=.TRUE.
*                                                                      *
************************************************************************
*                                                                      *
        ELSE IF (mk .EQ. n) THEN
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
          WRITE(6,'(A)') 'Complete system solved'
#endif
          Last=.TRUE.
*                                                                      *
************************************************************************
*                                                                      *
        ELSE IF (iter .GE. maxiter) THEN
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
          WRITE(6,'(A)') 'Not converged'
#endif
          Last=.TRUE.
          iRC=1

*----     Reduce the subspace size if it exceeds the maximum (maxk)
*          Sub' = Sub * Vec(1:mink)
*          Sub' should be orthonormal if Sub is orthonormal
*        (A reduction does not consume an iteration)
*       There is also a reduction if the process is stagnated
*
*                                                                      *
************************************************************************
*                                                                      *
        ELSE IF (mk .GT. mink .AND.
     &    (MIN(mk+k,n) .GT. maxk) .OR. (iRC .EQ. 2)) THEN
*                                                                      *
************************************************************************
*                                                                      *
          IF (iRC .EQ. 2) iRC=0
#ifdef _DEBUGPRINT_
          WRITE(6,'(2X,A,1X,I5)') 'Reducing search space to',mink
#endif
          CALL Allocate_Work(ipTmp,mink*n)
          CALL DGeMM_('N','N',
     &                n,mink,mk,
     &                One,Sub,n,
     &                    EVec,maxk,
     &                Zero,Work(ipTmp),n)
          call dcopy_(mink*n,Work(ipTmp),1,Sub,1)
          CALL Free_Work(ipTmp)

*----     To make sure Sub' is orthonormal, add the vectors one by one
*
          j=0
          i=0
          DO WHILE ((j .LT. mink) .AND. (i .LT. mk))
            i=i+1
            Call Add_Vector(n,j,Sub,Sub(1,i),Thr3)
          END DO

*----     j should be mink, but who knows...
*
#ifdef _DEBUGPRINT_
          IF (j .LT. mink) THEN
            WRITE(6,'(2X,A,1X,I5)') 'Fewer vectors found:',j
          END IF
#endif
          CALL DZero(Sub(1,j+1),(maxk-j)*n)
          CALL DZero(Ab(1,j+1),(maxk-j)*n)
          CALL DZero(EVec,maxk*maxk)
          DO i=0,j-1
            EVec(1+i*(maxk+1))=One
          END DO
          mk=j
          old_mk=0
          Augmented=.FALSE.
          Reduced=.TRUE.
          iter=iter-1
*                                                                      *
************************************************************************
*                                                                      *
        ELSE
*                                                                      *
************************************************************************
*                                                                      *
*----     Expand the subspace
*          For each eigenpair i of the first k,
*          check convergence for the residuals r:
*           r = Ab * Vec(i) - Val(i) * Sub * Vec(i)
*          Add a new vector, orthonormalized with the previous vectors,
*          computed from r and the eigenpair
*          (different possible variants)
*
          CALL Allocate_Work(ipTmp,n)
          Conv=Zero
*
          jj=0
          DO i=0,k-1
*            Vector in full space: Sub*Vec(i)
             Call dGeMV_('N',n,mk,One,Sub,n,
     &                               EVec(1+i*maxk),1,
     &                           Zero,Work(ipTVec),1)
*            Product of matrix and vector: Ab*Vec(i)
             Call dGeMV_('N',n,mk,One,Ab,n,
     &                               EVec(1+i*maxk),1,
     &                           Zero,Work(ipTAV),1)
*            Residual: (A-Val(i))*Vec(i) = Ab*Vec(i) - Val(i)*Sub*Vec(i)
             call dcopy_(n,Work(ipTAV),1,Work(ipTRes),1)
             call daxpy_(n,-EVal(1+i),Work(ipTVec),1,Work(ipTRes),1)
             Conv=MAX(Conv,DDot_(n,Work(ipTRes),1,Work(ipTRes),1))

*----        Scale vector, orthonormalize, and add to subspace
*
*            Diagonal matrix to scale the vectors: 1/(A(j,j)-Val(i))
             DO j=0,n-1
*               Aux=A((j+1)*(j+2)/2)-EVal(1+i)
                If (j.eq.n-1) Then
                   Aux=          -Eval(1+i)
                Else
                   Aux=HDiag(j+1)-Eval(1+i)
                End If
                If (j.eq.n-1) Then
                   Work(ipDiag+j)=One/SIGN(MAX(ABS(Aux),Thr2),Aux)
                Else
                   If (HDiag(j+1).lt.1.0D20) Then
                      Work(ipDiag+j)=One/SIGN(MAX(ABS(Aux),Thr2),Aux)
                   Else
                      Work(ipDiag+j)=1.0D20
                   End If
                End If
             END DO
*
*            scale
             DO j=0,n-1
                If (Work(ipDiag+j).lt.1.0D02) Then
                   Work(ipTmp+j)=Work(ipTRes+j)*Work(ipDiag+j)
                Else
                   Work(ipTmp+j)=Zero
                End If
             END DO
*
             Alpha=Zero
             DO j=0,n-1
                If (Work(ipDiag+j).lt.1.0D02) Then
                   Alpha=Alpha+Work(ipDiag+j)*Work(ipTVec+j)**2
                End If
             END DO
             Alpha=DDot_(n,Work(ipTVec),1,Work(ipTmp),1)/Alpha
*            subtract
             DO j=0,n-1
                If (Work(ipDiag+j).lt.1.0D02) Then
                   Work(ipTVec+j)=Work(ipTVec+j)*Work(ipDiag+j)
                Else
                   Work(ipTVec+j)=Zero
                End If
             END DO
             call daxpy_(n,-Alpha,Work(ipTVec),1,Work(ipTmp),1)
*
             IF (mk+jj .LE. n-1) THEN
                jj=mk+jj
                CALL Add_Vector(n,jj,Sub,Work(ipTmp),Thr3)
                jj=jj-mk
             END IF
          END DO
*
#ifdef _DEBUGPRINT_
          WRITE(6,'(2X,A,1X,G12.6)') 'Maximum residual:',Conv
#endif
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
          IF ((Conv .LT. Thr3) .AND. (mk .GE. mink)) THEN
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
#ifdef _DEBUGPRINT_
             WRITE(6,'(A)') 'Converged due to small residual'
#endif
             Last=.TRUE.
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
          ELSE
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
             mk=MIN(mk+jj,n)

*----        If no new vector is found to add to the subspace, we are in
*            trouble. Try to find a non-linear-dependent base vector in
*            the original matrix
*
             IF (jj .EQ. 0) THEN
#ifdef _DEBUGPRINT_
               WRITE(6,'(A)') 'Process stagnated'
#endif
               IF (mk .LT. maxk) THEN
                  CALL DZero(Work(ipTmp),n)
                  i=0
*
                  DO WHILE ((jj .LT. 1) .AND. (i .LT. n))
                     i=i+1
                     ig=MOD(ig,n)+1
                     ii=Index_D(ig)
*
*                    Avoid explicitly rotations between fermions of
*                    different types. Avoid rotations which will be
*                    large,
*
                     If (ii.eq.n) Then
                       Aux=Zero
                     Else
                       Aux=HDiag(ii)
                     End If
                     If (Aux.lt.1.0D20  .and. Aux.gt.-0.10D0) Then
                        Work(ipTmp+ii-1)=One
                        jj=mk+jj
                        CALL Add_Vector(n,jj,Sub,Work(ipTmp),Thr3)
                        Work(ipTmp+ii-1)=Zero
                        jj=jj-mk
                     End If
*
                  END DO
*
                  mk=MIN(mk+jj,n)
                  IF (jj .GT. 0) Augmented=.TRUE.
               END IF
               IF (jj .EQ. 0) THEN
                  Augmented=.FALSE.
                  iRC=2
               ENDIF
            ELSE
               Augmented=.TRUE.
            END IF
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
          END IF
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
          CALL Free_Work(ipTmp)
          Reduced=.FALSE.
*                                                                      *
************************************************************************
*                                                                      *
        END IF
*                                                                      *
************************************************************************
*                                                                      *
      END DO
*
      CALL Free_Work(ipDum)
      CALL Free_Work(ipDiag)
      CALL Free_Work(ipTVec)
      CALL Free_Work(ipTAV)
      CALL Free_Work(ipTRes)
      Call mma_deallocate(Index_D)

*---- Store the current lowest k eigenvectors (in the full space)
*      Vec' = Sub * Vec(1:k)
*
      CALL DGeMM_('N','N',
     &            n,k,mk,
     &            One,Sub,n,
     &                EVec,maxk,
     &            Zero,Vec,n)

#ifdef _DEBUGPRINT_
      Call NrmClc(Vec(1,1),m,'Davidson_SCF','Vec(1-m)')
      Call NrmClc(Vec(n,1),1,'Davidson_SCF','Vec(n)')
#endif
      Call mma_deallocate(Sub)
      Call mma_deallocate(Ab)
      Call mma_deallocate(Proj)
      Call mma_deallocate(EVal)
      Call mma_deallocate(EVec)
      CALL mma_deallocate(Eig_old)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine GeoNew(lprint)
!***********************************************************************
!                                                                      *
! Object: to pick up the geometry from a special file. This will only  *
!         make any difference of there exist a file otherwise SEWARD   *
!         will use the geometry as specified by the standard input     *
!         file.                                                        *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             March 1991                                               *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use stdalloc, only: mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: lprint
integer(kind=iwp) :: iCnt, iCnttp, iDC, iNuc, lBuf, nNuc
logical(kind=iwp) :: Exists
real(kind=wp), allocatable :: CN(:,:)
interface
  subroutine Get_Coord_New(CN,lBuf)
    import :: wp, iwp
    real(kind=wp), allocatable :: CN(:,:)
    integer(kind=iwp) :: lBuf
  end subroutine
end interface

! Prologue

! Check if there is a data field called 'NewGeom'

call Get_Coord_New(CN,lBuf)

! Quit if the datafield 'NewGeom' is not available. However,
! if the field is available on RUNOLD pick it up there.

if (lBuf == 0) then

  ! Check RUNOLD

  call f_Inquire('RUNOLD',Exists)
  if (Exists) then
    call NameRun('RUNOLD')
    call Get_Coord_New(CN,lBuf)
    if (lBuf == 0) then
      nNuc = 0
      call NameRun('RUNFILE')
      return
    else
      call Get_iScalar('Unique atoms',nNuc)
      call NameRun('RUNFILE')
      if (lprint) then
        write(u6,*)
        write(u6,'(A)') '    Geometry read from RUNOLD'
        write(u6,*)
      end if
    end if
  else
    nNuc = 0
    return
  end if
else
  call Get_iScalar('Unique atoms',nNuc)
  if (lprint) then
    write(u6,*)
    write(u6,'(A)') '    Geometry read from RUNFILE'
    write(u6,*)
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Replace coodinates read in subroutine input

iDC = 1
iNuc = 0
!call RecPrt('CN',' ',CN,3,nNuc)
outer: do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
    do iCnt=1,dbsc(iCnttp)%nCntr
      dbsc(iCnttp)%Coor(1:3,iCnt) = CN(1:3,iDC)
      iDC = iDC+1
      iNuc = iNuc+1
      if (iNuc == nNuc) exit outer
    end do
  end if
end do outer
!                                                                      *
!***********************************************************************
!                                                                      *
! Epilogue, end

call mma_deallocate(CN)

return

end subroutine GeoNew

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1995, Roland Lindh                                *
************************************************************************
      SubRoutine EFPrm(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &                 Final,nZeta,nComp,la,lb,A,RB,nRys,
     &                 Array,nArr,Ccoor,nOrdOp)
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of electric field         *
*         integrals.                                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, January '91                             *
*                                                                      *
* Modified for explicit code, R. Lindh, February '95.                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      External TNAI, Fake, XCff2D, XRys2D
#include "real.fh"
#include "print.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp),
     &       Zeta(nZeta), ZInv(nZeta), Alpha(nAlpha), Beta(nBeta),
     &       rKappa(nZeta), P(nZeta,3), A(3), RB(3),
     &       Array(nZeta*nArr), Ccoor(3)
*---- Local Arrays
      Real*8 Coori(3,4), CoorAC(3,2)
      Logical EQ, NoSpecial
      Integer iAnga(4)
      Character*80 Label
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      iRout = 200
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In EFPrm: Alpha',' ',Alpha,nAlpha,1)
         Call RecPrt(' In EFPrm: Beta',' ',Beta,nBeta,1)
      End If
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nComp,[Zero],0,Final,1)
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = nOrdOp
      iAnga(4) = 0
      call dcopy_(3, A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
      mabMin=nabSz(Max(la,lb)-1)+1
      mabMax=nabSz(la+lb)
      If (EQ(A,RB)) mabMin=nabSz(la+lb-1)+1
      mcdMin=nabSz(nOrdOp-1)+1
      mcdMax=nabSz(nOrdOp)
      lab=(mabMax-mabMin+1)
      kab=nElem(la)*nElem(lb)
      lcd=(mcdMax-mcdMin+1)
      labcd=lab*lcd
*
*---- Compute Flop's and size of work array which HRR will Use.
*
      Call mHRR(la,lb,nFLOP,nMem)
*
*---- Distribute the work array
*
      ip2 = 1
      ip1 = ip2 + nZeta*Max(labcd,lcd*nMem)
      mArr = nArr - Max(labcd,lcd*nMem)
*
*---- Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
         call dcopy_(3, A,1,CoorAC(1,1),1)
      Else
         call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
      call dcopy_(3,Ccoor,1,CoorAC(1,2),1)
      call dcopy_(3,Ccoor,1, Coori(1,3),1)
      call dcopy_(3,Ccoor,1, Coori(1,4),1)
*
*-----Compute integrals with the Rys-Gauss quadrature.
*
      nT=nZeta
      NoSpecial=.True.
      Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &         [One],[One],1,P,nZeta,
     &         CCoor,1,rKappa,[One],Coori,Coori,CoorAC,
     &         mabMin,mabMax,mcdMin,mcdMax,Array(ip1),mArr*nZeta,
     &         TNAI,Fake,XCff2D,XRys2D,NoSpecial)
*
*---- The integrals are now ordered as ijkl,e,f
*
*     a) Change the order to f,ijkl,e
*     b) Unfold e to ab, f,ijkl,ab
*     c) Change the order back to ijkl,ab,f
*
*a)--
*
      Call DGetMO(Array(ip1),nZeta*lab,nZeta*lab,lcd,Array(ip2),lcd)
*
*b)-- Use the HRR to unfold e to ab
*
      Call HRR(la,lb,A,RB,Array(ip2),lcd*nZeta,nMem,ipIn)
      ip3=ip2-1+ipIn
*
*c)--
*
      Call DGetMO(Array(ip3),lcd,lcd,nZeta*kab,Final,nZeta*kab)
      Call DScal_(nZeta*kab*lcd,-One,Final,1)
*
      If (iPrint.ge.49) Then
         Write (6,*) ' In EFPrm la,lb=',la,lb
         Do 400 iElem = 1, nElem(la)
            Do 410 jElem = 1, nElem(lb)
               If (lcd.eq.1) Then
                  Write (Label,'(A,I2,A,I2,A)')
     &                  ' EFPrm: Final (',iElem,',',jElem,') '
                  Call RecPrt(Label,' ',Final(1,iElem,jElem,1),nZeta,1)
               Else If (lcd.eq.3) tHEN
                  Write (Label,'(A,I2,A,I2,A)')
     &                  ' EFPrm: Final (',iElem,',',jElem,',x) '
                  Call RecPrt(Label,' ',Final(1,iElem,jElem,1),nZeta,1)
                  Write (Label,'(A,I2,A,I2,A)')
     &                  ' EFPrm: Final (',iElem,',',jElem,',y) '
                  Call RecPrt(Label,' ',Final(1,iElem,jElem,2),nZeta,1)
                  Write (Label,'(A,I2,A,I2,A)')
     &                  ' EFPrm: Final (',iElem,',',jElem,',z) '
                  Call RecPrt(Label,' ',Final(1,iElem,jElem,3),nZeta,1)
               End If
 410        Continue
 400     Continue
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nRys)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SMDFGP_GEN(NGRP,NSMST,MXPNS,NSTFSMGP,NACTSYM,ISMDFGP)

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NGRP, NSMST, MXPNS, NSTFSMGP(MXPNS,NGRP)
integer(kind=iwp), intent(out) :: NACTSYM(NGRP), ISMDFGP(NSMST,NGRP)
integer(kind=iwp) :: IGRP, IOFF, ISYM

#ifdef _DEBUGPRINT_
write(u6,*) 'Entering  SMDFGP_GEN'
write(u6,*) 'NGRP : ',NGRP
write(u6,*) 'NSMST: ',NSMST
write(u6,*) 'MXPNS',MXPNS
write(u6,*) 'INPUT: NSTFSMGP'
do ISYM=1,NSMST
  write(u6,'(40I5)') (NSTFSMGP(ISYM,IGRP),IGRP=1,NGRP)
end do
#endif

do IGRP=1,NGRP
  IOFF = 0
  do ISYM=1,NSMST
    ISMDFGP(ISYM,IGRP) = 0
    if (NSTFSMGP(ISYM,IGRP) /= 0) then
      IOFF = IOFF+1
      ISMDFGP(IOFF,IGRP) = ISYM
    end if
  end do
  NACTSYM(IGRP) = IOFF
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'Number of Active Symm per GRP:'
write(u6,*) (NACTSYM(IGRP),IGRP=1,NGRP)
write(u6,*) 'Symmetries allowed by each group:'
do ISYM=1,NSMST
  write(u6,'(40I2)') (ISMDFGP(ISYM,IGRP),IGRP=1,NGRP)
end do
#endif

end subroutine SMDFGP_GEN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               2001, Hans-Joachim Werner                              *
************************************************************************
      SubRoutine Drvpot(Ccoor,opnuc,ncmp,ptchrg,ngrid,iaddpot)
************************************************************************
*                                                                      *
* Object: driver for computation of one-electron property matrices     *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January '91                                              *
*                                                                      *
*     Modified for Properties only by HJW Aug 2001                     *
*     Restricted to POT: Ignacio Fdez. Galvan, March 2019              *
************************************************************************
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External PotInt, NAMem
#include "stdalloc.fh"
#include "espf.fh"
      Character*8 Label
      Real*8 Ccoor(3),opnuc(*),ptchrg(*)
      Real*8, Allocatable :: Centr(:,:), Dens(:)
      Logical Do_ESPF
      Dimension dummy(1),iopadr(1)
*                                                                      *
************************************************************************
*                                                                      *
      Call IniSewM('mltpl',0)
*
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      ntdg = 0
      Do iIrrep = 0, nIrrep - 1
         ntdg = ntdg + nBas(iIrrep)*(nBas(iIrrep)+1)/2
      End Do
      Call DecideOnESPF(Do_ESPF)
c
      Call mma_allocate(Centr,3,S%mCentr)
      ndc = 0
      nc = 1
      Do jCnttp = 1, nCnttp
         mCnt = dbsc(jCnttp)%nCntr
         If (dbsc(jCnttp)%Aux) mCnt = 0
         Do jCnt = 1, mCnt
            ndc = ndc + 1
            Do i = 0, nIrrep/dc(ndc)%nStab - 1
               Call OA(dc(ndc)%iCoSet(i,0),dbsc(jCnttp)%Coor(1:3,jCnt),
     &                 Centr(1:3,nc))
               nc = nc + 1
            End Do
            jxyz = jxyz + 3
         End Do
      End Do
      nc = nc-1
c
      nComp=1
      nOrdOp = 0
      Call GetMem('ip    ','ALLO','INTE',ip1,nComp)
      Call GetMem('lOper ','ALLO','INTE',ip2,nComp)
      Call GetMem('kOper ','ALLO','INTE',ip3,nComp)
      Label='Pot '
      If (iaddpot.le.0.and..not.Do_ESPF) Then
         Call GetMem('Nuc ','ALLO','REAL',ipNuc,ngrid)
         Call Pot_nuc(CCoor,work(ipnuc),ngrid)
      Else
        ipnuc=ip_Dummy
      End if
      If (iaddpot.lt.0) Then

         Call mma_allocate(Dens,ntdg,Label='Dens')
         If (iaddpot.eq.-1) Then
            Call Get_D1ao_Var(Dens,ntdg)
         Else
            Call Get_D1ao(Dens,ntdg)
         End If
         call Drv1_Pot(Dens,CCoor,ptchrg,ngrid,1,0)
         Call mma_deallocate(Dens)

         If (.not.Do_ESPF) Then
            Call daxpy_(ngrid,1.0d0,work(ipnuc),1,ptchrg,1)
            Call dCopy_(ngrid,work(ipnuc),1,opnuc,1)
         End If
      Else
        iWork(ip2) = 2**nirrep-1
        iWork(ip3) = 0
        Call OneEl(PotInt,NAMem,Label,iWork(ip1),iWork(ip2),ncmp,
     &             Ccoor,nOrdOp,work(ipnuc),rHrmt,iWork(ip3),
     &             dummy,1,opnuc,iopadr,1,1,
     &             ptchrg,ngrid,iaddpot)
         If (iaddpot.eq.0.and..not.Do_ESPF)
     &      opnuc(1)=work(ipnuc)
      End If
      If (iaddpot.le.0.and..not.Do_ESPF)
     &   Call GetMem('Nuc ','FREE','REAL',ipNuc,ngrid)
      Call GetMem('kOper ','FREE','INTE',ip3,nComp)
      Call GetMem('lOper ','FREE','INTE',ip2,nComp)
      Call GetMem('ip    ','FREE','INTE',ip1,nComp)
*
      Call mma_deallocate(Centr)
      Call Free_iSD()
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1992,1994,1996, Roland Lindh                      *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
!#define _CHECK_
subroutine Tcrtnc(Coef1,n1,m1,Coef2,n2,m2,Coef3,n3,m3,Coef4,n4,m4,ACInt,mabcd,Scrtch,nScr,ACOut,IndZet,lZeta,IndEta,lEta)
!***********************************************************************
!                                                                      *
! Object: to transform the integrals from primitives to contracted     *
!         basis functions. The subroutine will do both complete and    *
!         incomplete transformations.                                  *
!                                                                      *
!         Observe that ACInt and ACOut may overlap!!!!                 *
!         (which is against Fortran standard, so this should be fixed) *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified to back transformation, January '92.            *
!***********************************************************************

use Molcas, only: lCache
use Definitions, only: wp, iwp
#if defined (_DEBUGPRINT_) || defined (_CHECK_)
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: n1, m1, n2, m2, n3, m3, n4, m4, mabcd, nScr, lZeta, IndZet(lZeta), lEta, IndEta(lEta)
real(kind=wp), intent(in) :: Coef1(n1,m1), Coef2(n2,m2), Coef3(n3,m3), Coef4(n4,m4), ACInt(m1*m2*m3*m4,mabcd)
real(kind=wp), intent(out) :: Scrtch(nScr)
! FIXME: This should be intent(out), but the aliasing/overlap (see above) prevents it
real(kind=wp), intent(_OUT_) :: ACOut(lZeta*lEta,mabcd)
integer(kind=iwp) :: nCache, lsize, nVec, IncVec, ipA2, ipA3

#ifdef _DEBUGPRINT_
call WrCheck('Tcrtnc:P(AB|CD)',ACInt,m1*m2*m3*m4*mabcd)
call RecPrt(' In Tcrtnc: P(ab|cd)',' ',ACInt,mabcd,m1*m2*m3*m4)
call RecPrt(' Coef1',' ',Coef1,n1,m1)
call RecPrt(' Coef2',' ',Coef2,n2,m2)
call RecPrt(' Coef3',' ',Coef3,n3,m3)
call RecPrt(' Coef4',' ',Coef4,n4,m4)
write(u6,*) n1,n2,n3,n4
#endif

! Reduce for contraction matrix
nCache = (3*lCache)/4-n3*m3-n4*m4
lsize = m3*m4+m3*n4
nVec = m1*m2*mabcd
IncVec = min(max(1,nCache/lsize),nVec)
ipA3 = 1
ipA2 = ipA3+nVec*lEta

#ifdef _CHECK_
if (nVec*lEta+n4*m3*IncVec > nScr) then
  write(u6,*) 'Tcrtnc: Memory failure 1'
  write(u6,*) 'n4*IncVec*m3(A2)=',n4*IncVec*m3
  write(u6,*) 'nVec*lEta(A3)=',nVec*lEta
  write(u6,*) 'n4,IndVec,m3=',n4,IndVec,m3
  write(u6,*) 'nVec,lEta=',nVec,lEta
  write(u6,*) 'nScr=',nScr
  call Abend()
end if
#endif

call TncHlf(Coef3,m3,n3,Coef4,m4,n4,lEta,nVec,IncVec,ACInt,Scrtch(ipA2),Scrtch(ipA3),IndEta)

nCache = (3*lCache)/4-n1*m1-n2*m2
lsize = m1*m2+m1*n2
nVec = mabcd*lEta
IncVec = min(max(1,nCache/lsize),nVec)

#ifdef _CHECK_
if (nVec*m1*m2+n2*IncVec*m1 > nScr) then
  write(u6,*) 'Tcrtnc: Memory failure 2'
  write(u6,*) 'nVec*m1*m2(A1)=',nVec*m1*m2
  write(u6,*) 'n2*IncVec*m1(A2)=',n2*IncVec*m1
  write(u6,*) 'nVec,m1,m2=',nVec,m1,m2
  write(u6,*) 'n2,IncVec,m1=',n2,IncVec,m1
  write(u6,*) 'nScr=',nScr
  call Abend()
end if
#endif

call TncHlf(Coef1,m1,n1,Coef2,m2,n2,lZeta,nVec,IncVec,Scrtch(ipA3),Scrtch(ipA2),ACOut,IndZet)

#ifdef _DEBUGPRINT_
call RecPrt(' In Tcrtnc: P(ab|cd) ',' ',ACOut,mabcd,lZeta*lEta)
call WrCheck('Tcrtnc:P(ab|cd)',ACOut,lZeta*lEta*mabcd)
#endif

end subroutine Tcrtnc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine XDR_fpFW(n,s,t,v,w,Tr,Bk,EL,ES,OL,OS,
     &                    P,E0,A,B,R,clight)
C
C Transform to moment space ( eigenfunction space of non-relativistic kinetic matrix T )
C   and apply the free-particle Foldy-Wothuysen transformation to the Fock matrices
C
      implicit none
#include "WrkSpc.fh"
C Input
C   w   aka pVp
      integer n
      Real*8 s(n,n),t(n,n),v(n,n),w(n,n),clight
C
C Output :
C   Tr     transform matrix to moment space
C   Bk     back transform matrix of moment space =Tr^{-1}
C   ( EL OL )
C   ( OS ES ) represent the structure of potential matrix in fpFW space
C   P      kinetic matrix (diagonal) in fpFW space, aka Ep
C   E0     =P-mc^{2}
C   A,B,R  kinetic factors (used to construct the fpFW transformation in moment space)
C
      Real*8 Tr(n,n),Bk(n,n),EL(n,n),ES(n,n),OL(n,n),OS(n,n),
     &                 P(n),E0(n),A(n),B(n),R(n)
C Temp
      integer i,j,k,itmp,lwork,iW,iA,iB,info
      Real*8 av,aw
C
C Diagonalization
C
      lwork = 8*n
      call getmem('Tmp  ','ALLOC','REAL',itmp ,lwork)
      call getmem('Eig  ','ALLOC','REAL',iW   ,n+4)
      k = 0
      do i=1,n
        do j=1,n
          Tr(j,i) = t(j,i)
          Bk(j,i) = s(j,i)
          k = k + 1
        end do
      end do
      call dsygv_(1,'V','L',n,Tr,n,Bk,n,Work(iW),Work(itmp),lwork,info)
C
C Transform potential matrices to moment space
C
      call getmem('TmpA ','ALLOC','REAL',iA ,n*n+4)
      call getmem('TmpB ','ALLOC','REAL',iB ,n*n+4)
      call dmxma(n,'C','N',Tr,v,Bk,1.d0)
      call dmxma(n,'N','N',Bk,Tr,Work(iA),1.d0)
      call dmxma(n,'C','N',Tr,w,Bk,1.d0)
      call dmxma(n,'N','N',Bk,Tr,Work(iB),1.d0)
C
C Calculate kinetic moment factors
C
      do i=1,n
        P(i) = sqrt(clight*clight+Work(iW+i-1)*2.d0) * clight
        A(i) = sqrt( (P(i)+clight*clight) / (P(i)+P(i)) )
        B(i) = clight/sqrt( 2.d0*P(i)*(P(i)+clight*clight) )
        R(i) = sqrt( Work(iW+i-1)*2.d0 ) * clight /
     &         ( P(i)+clight*clight )
C       ! E0 equal to Ep-c^{2}, but this formula is more stable, especially E0 close to zero
        E0(i) = 2.d0*Work(iW+i-1)*clight*clight/(P(i)+clight*clight)
      enddo
C
C Multiply potential matrices with moment factors
C   aka the fpFW transformation in moment space
C
      k = 0
      do i=1,n
        do j=1,n
          av = Work(iA+k) * A(i) * A(j)
          aw = Work(iB+k) * B(i) * B(j)
          EL(j,i) = av + aw
          ES(j,i) = aw/R(i)/R(j) + av*R(i)*R(j)
          OL(j,i) = aw/R(i) - av*R(i)
          OS(j,i) = aw/R(j) - av*R(j)
          Bk(j,i) = Tr(j,i)
          k = k + 1
        enddo
      enddo
C
C Make back transform matrix
C
      call XDR_dmatinv(Bk,n)
C
C Free temp memories
C
      call getmem('Tmp  ','FREE','REAL',itmp ,lwork)
      call getmem('Eig  ','FREE','REAL',iW   ,n+4)
      call getmem('TmpA ','FREE','REAL',iA ,n*n+4)
      call getmem('TmpB ','FREE','REAL',iB ,n*n+4)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRGASTAB(REST)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: REST(*)
integer(kind=iwp) :: IGAS, ISYM, KORB, KREST, NGAS, NSYM

write(u6,*)
write(u6,*) ' GAS restriction table printout'
write(u6,'(A,I5)') 'Table size        NSIZE=',REST(1)
write(u6,'(A,I5)') 'Table type ID     ITYPE=',REST(2)
write(u6,'(A,I5)') 'Nr of partitions  NGAS=',REST(3)
write(u6,'(A,I5)') 'Nr of symm labels NSYM =',REST(4)
write(u6,*) ' Orbital partitions:'
NGAS = REST(3)
NSYM = REST(4)
KORB = 5
write(u6,'(8X,I5,5X,8I5)') (REST(KORB+ISYM),ISYM=0,NSYM-1)
do IGAS=1,NGAS
  write(u6,'(I3,5X,I5,5X,8I5)') IGAS,(REST(KORB+ISYM+(NSYM+1)*IGAS),ISYM=0,NSYM-1)
end do
write(u6,*) ' Electron population restrictions:'
KREST = KORB+(NGAS+1)*(NSYM+1)
write(u6,'(5X,A7,5X,30I3)') 'Minimum',(REST(KREST+0+2*(IGAS-1)),IGAS=1,NGAS)
write(u6,'(5X,A7,5X,30I3)') 'Maximum',(REST(KREST+1+2*(IGAS-1)),IGAS=1,NGAS)

end subroutine PRGASTAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine chcc (ireturn)
c
c       docasny drajver reorder procesu
c
        use Para_Info, only: MyRank, nProcs
#ifdef _MOLCAS_MPP_
        use Para_Info, only: Is_Real_Par
#endif
        implicit none
#include "chcc1.fh"
#include "parcc.fh"
#include "chcc_files.fh"
#include "chcc_reord.fh"
c#include "SysDef.fh"
#include "WrkSpc.fh"
#include "chcc_casy.fh"
        integer ireturn
c
        integer NvGrp,NvSGrp,NchBlk
        integer LunAux
        integer wrksize
        integer maxspace,iOff
c
        integer maxdim
        integer NChHere
c        jalove
        integer Jal1,Jal2
c
        real*8 e1new,e2new,e1old,e2old,e2os,escf
        integer iter
cmp
cmp
c
#ifdef _MOLCAS_MPP_
        if (is_real_par()) then
         write (6,*) ' Parallel run'
        else
         write (6,*) ' Serial run'
        end if
cmp!         write (6,*) ' MyRank, Nprocs',MyRank, Nprocs
#else
         write (6,*) ' Serial run'
cmp!         write (6,*) ' MyRank, Nprocs',MyRank, Nprocs
#endif
cmp
c        vynuluj hodiny
        Call CWTime(TCpu,TWall)
        TCpu0=TCpu
        TWall0=TWall
        TCpu_l=TCpu
        TCpu_l=TCpu
        TWall_l=TWall
        TWall_l=TWall
cmp
c
c@@     real*8, allocatable :: wrk(:)
c        real*8 wrk(1:40000000)
c        real*8 wrk(1:26593281)
c        wrksize=26593281
c        wrksize=40000000
c
cmp! ##########################################################
c0      info o cholesky vektoroch

        call frankie_drv_fake (NChHere)
        write (6,'(A,i9,A,i4)') ' Number of Cholesky vectors ',
     & NChHere,' on node ',myRank
c
#ifdef _MOLCAS_MPP_
c
        do jal1=0,Nprocs-1
          NChLoc(jal1)=0
        end do
c
        NChLoc(MyRank)=NChHere
        call gaigop (NChLoc(0),NProcs,'+')
c
        jal2=0
        do jal1=0,NProcs-1
          jal2=jal2+NChLoc(jal1)
cmp!          write (6,*) ' NChLoc',jal1,NChLoc(jal1)
        end do

        nc = jal2
#else
        nc = NChHere
#endif
cmp! ##########################################################
c
c       Get the maximum available memory
c
        Call GetMem('CCSD','Max','Real',maxspace,maxspace)
        maxspace=maxspace-8
        write (6,'(A,i13,A,f9.1,A,f5.1,A)') ' Max Size              : ',
     & maxspace,' in r*8 Words,',
     & 1.0d0*maxspace*8/(1024*1024),' Mb,',
     & 1.0d0*maxspace*8/(1024*1024*1024),' Gb'
c
c1      Nacitanie vstupu (Docasne) + time Delay
c
        call IniReord (NvGrp,NvSGrp,NchBlk,LunAux,wrksize)
cmp!        call TimeDelay (LunAux) ! temporarily disabled (MP)
c
c       Decide on automatic segmentation generation
        if (NvGrp.eq.0) then
           call autoSegmentation(Nprocs, maxspace,
     & Jal1, Jal2,
     & NvGrp, NvSGrp, NchBlk, wrksize, maxdim)
        else
           call checkMem(NvGrp, NvSGrp, NchBlk,
     & Jal1, Jal2, wrksize, maxdim)

           if (wrksize.gt.maxspace) then
              write (6,*) ' Not Enough Memory! '//
     & 'Increase large and/or small segmentation',
     & (1.0d0*wrksize)/(1.0d0*maxspace)
             call abend
           end if
        endif
c
c         write Large segmentation to RunFile
        Call Put_iScalar('CHCCLarge',NvGrp)
c
c ---------------------------------------------------------
c
c        Transformation of Local L(ao) -> L(mo)
c        CD1tmp file is created
c
        call frankie_drv (NChHere)
        if (printkey.ge.10) then
        write (6,*) ' After Frenkie',myRank,NChHere
        end if
c
c ---------------------------------------------------------
c
        Call GetMem('CCSD','Allo','Real',iOff,wrksize)
        write (6,'(A,i13,A,f9.1,A,f5.1,A)') ' Real Allocated Memory : ',
     & wrksize,' in r*8 Words,',
     & 1.0d0*wrksize*8/(1024*1024),' Mb,',
     & 1.0d0*wrksize*8/(1024*1024*1024),' Gb'
        call mv0zero (wrksize,wrksize,Work(iOff))
c
c3      Priprava integralov
c
        call Reord_chcc (Work(iOff),wrksize,
     &              NvGrp,NvSGrp,NchBlk,LunAux)
        if (generkey.eq.1) then
cmp!          if (printkey.ge.10) then ! uvidime ...
          write (6,*) ' Generation of integrals (Reord_chcc) done'
          write (6,*)
cmp!          end if
        else
          write (6,*) ' Generation of integrals (Reord_chcc) skipped,'//
     &          ' only basic'
          write (6,*)
        end if
cmp
        Call CWTime(TCpu,TWall)
c
        if (printkey.gt.1) then
        write (6,'(A,f18.1)') ' Cpu last call [s] = ',
     & TCpu-TCpu_l
        write (6,'(A,f18.1)') 'Wall last call [s] = ',
     & TWall-TWall_l
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if
        TCpu_l=TCpu
        TWall_l=TWall
cmp
c
c4        Restart, ak treba
c
        if (restkey.eq.1) then
c        read T1o,niter,E1old,E2old (T2 are in T2files)
          call GetRest (Work(iOff),wrksize,LunAux,iter,E1old,E2old)
          goto 1
        else
cBug    v originale chyba
c        set T1o=0
           call VanishT1 (Work(iOff),wrksize)
        end if
c
c@@
c        write (6,*) ' Pred Chck'
c        Call MakeChckData (Work(iOff),wrksize,LunAux)
c        Call SaveChckData (LunAux)
c        Call GetChckData (LunAux)
c        write (6,*) ' Chck  done'
c@@
c
c
c5        iteracny cyklus
c
        e1old=0.0d0
        e2old=0.0d0
        iter=1
c
cmp
c
        write (6,*)
        write (6,*) '------------------------'
        write (6,*) 'Starting CCSD iterations'
        write (6,*) '------------------------'
        write (6,*)

        write (6,*) '                  CCSD Energy  ',
     & '    Difference'
        write (6,*)
cmp!
        call xflush(6)
cmp!
c
        Call CWTime(TCpu,TWall)
c
        if (printkey.gt.1) then
        write (6,'(A,f18.1)') ' Cpu last call [s] = ',
     & TCpu-TCpu_l
        write (6,'(A,f18.1)') 'Wall last call [s] = ',
     & TWall-TWall_l
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if
        TCpu_l=TCpu
        TWall_l=TWall
cmp

1        continue
c
           call o3v3ctl (Work(iOff),wrksize,NvGrp,LunAux)
        if (printkey.gt.1) then
         write (6,*) ' o3v3 done'
        end if
cmp
        Call CWTime(TCpu,TWall)
        if (printkey.gt.1) then
        write (6,*)
        write (6,'(A,f18.1)') ' Cpu last call [s] = ',
     & TCpu-TCpu_l
        write (6,'(A,f18.1)') 'Wall last call [s] = ',
     & TWall-TWall_l
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if
        TCpu_l=TCpu
        TWall_l=TWall
cmp
        call o2v4ctl (Work(iOff),wrksize,NvGrp,NvSGrp,LunAux)
        if (printkey.gt.1) then
        write (6,*) ' o2v4 done'
        end if
cmp
        Call CWTime(TCpu,TWall)
        if (printkey.gt.1) then
        write (6,*)
        write (6,'(A,f18.1)') ' Cpu last call [s] = ',
     & TCpu-TCpu_l
        write (6,'(A,f18.1)') 'Wall last call [s] = ',
     & TWall-TWall_l
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if
        TCpu_l=TCpu
        TWall_l=TWall
cmp
           call summary (Work(iOff),wrksize,NvGrp,LunAux,maxdim,
     &                e1new,e2new,e2os)
        if (printkey.gt.1) then
        write (6,*) ' summary done'
        end if
cmp
        Call CWTime(TCpu,TWall)
        if (printkey.gt.1) then
        write (6,*)
        write (6,'(A,f18.1)') ' Cpu last call [s] = ',
     & TCpu-TCpu_l
        write (6,'(A,f18.1)') 'Wall last call [s] = ',
     & TWall-TWall_l
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if
        TCpu_l=TCpu
        TWall_l=TWall
cmp
        call SaveRest (Work(iOff),wrksize,LunAux,(iter+1),E1new,E2new)
c
cmp!        write (6,91) ' Iteration :',iter,e1new,e2new,
cmp!     c                             e1old+e2old-e1new-e2new
cmp!91        format (a12,1x,i3,1x,3(f15.12,1x))

        if (iter.eq.1) then
           write (6,91) ' Iteration :',iter,      e2new
        else
           write (6,93) ' Iteration :',iter,      e2new,
     c                             e1old+e2old-e1new-e2new
        end if

        call xflush(6)

91        format (a12,1x,i3,1x,f15.12,1x)
93        format (a12,1x,i3,1x,2(f15.12,1x))
c
        if ((abs(e1old+e2old-e1new-e2new).gt.conv).and.
     c      (iter.lt.maxiter)) then
          e1old=e1new
          e2old=e2new
          iter=iter+1
          goto 1
        end if
c
        write (6,*)
        write (6,*)  ' Final CCSD energy decomposition'
        write (6,92) ' E1 CCSD energy :',e1new
        write (6,92) ' E2 CCSD energy :',e2new
        write (6,92) ' E2 CCSD ss     :',e2new-e2os
        write (6,92) ' E2 CCSD os     :',e2os
        write (6,*)
92        format (a17,1x,f15.12)
cmp! for MOLCAS verify
        Call Get_dScalar('SCF energy',escf)
        Call Add_Info('CHCCene', [e2new], 1, 6)
        Call Add_Info('E_CHCC', [e2new], 1, 6)
        Call Add_Info('E_HYPE', [e2new+escf], 1, 6)
c    for NUMERICAL_GRADIENTS
        Call Put_cArray('Relax Method','CHCC    ',8)
        Call Store_Energies(1,e2new+escf,1)
cmp!
c
c@@        deallocate (wrk)
        Call GetMem('CCSD','Free','Real',iOff,wrksize)
c
        ireturn=0
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION qRINT (N,A,C,EXPA)
      Implicit Real*8(A-H,O-Z)
      Real*8 qRint
#include "real.fh"
#include "welcom.fh"
      Real*8 F(kmax+1)
*
      qRINT=Zero
      NN=N/2+1
*     Write (*,*) ' N,NN=',n,nn
      BP=Half*C
      START=Sqrt(Pi)
      PRSUM=EXP(BP*BP*A+EXPA)
      SUM=Zero
      ALF=sqrt(A)
      ARG=(BP*ALF)**2
      nT = 1
      call dcopy_(kMax+1,[Zero],0,F,1)
      Call Auxil([Arg],nT,F,nn-1)
*     Call RecPrt(' In qRint:Fm',' ',F,nt,nn)
      GINT=Zero
      Dac = -One
      Do 10 I=0,N
         TAL=(-BP)**(N-I)*Binom(n,i)
         J=(I/2)
*
         IF(J*2.EQ.I) THEN
            Dac = Dac * (Two*DBLE(J)-One)/Two
            FACT=ALF**(-I-1)*START*DAC
            FACT2=BP**(I+1)*F(J+1)
            GINT=(FACT-FACT2)*TAL+GINT
         ELSE
            GAL=One
            HINT=Zero
            Do 101 K=I-1,0,-2
               HINT=HINT+Half/A*BP**K*EXP(-ARG)*GAL
               GAL=Half*DBLE(K)/A*GAL
101         Continue
            GINT=GINT+TAL*HINT
         EndIF
*
         qRINT=GINT*PRSUM
 10   Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_PrintBlockMatrix(MatrixName,ip_Blocks)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Print block matrix.
C
      Implicit None
      Character*(*) MatrixName
      Integer ip_Blocks
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom

      real*8 ddot_
      external ddot_

      Integer l_max
      Parameter (l_max=80)
      Character*(l_max) myName

      Real*8 tnorm, bnorm

      Integer l
      Integer iAtomPair
      Integer iAtom, jAtom
      Integer nBas_i, nBas_j
      Integer ip
      Integer nShell_i, nShell_j
      Integer ipi, ipj
      Integer iS, jS
      Integer iShell, jShell

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      l=min(len(MatrixName),l_max)
      If (l.gt.0) Then
         Write(myName,'(A)') MatrixName(1:l)
      Else
         Write(myName,'(A)') '<unknown> '
      End If

      Call Cho_Head(myName(1:l)//' (blocked)','=',120,6)

      tnorm=0.0d0
      Do iAtomPair=1,NumberOfAtomPairs
         ip=iWork(ip_Blocks-1+iAtomPair)
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         nBas_i=LDF_nBas_Atom(iAtom)
         nBas_j=LDF_nBas_Atom(jAtom)
         bnorm=dDot_(nBas_i*nBas_j,Work(ip),1,Work(ip),1)
         tnorm=tnorm+bnorm
         Write(6,'(/,A,A,I9,A,I9,1X,I9,A)')
     &   myName(1:l),' block',iAtomPair,' (Atoms:',iAtom,jAtom,')'
         Write(6,'(A,I9,A,I9,A,1P,D15.6)')
     &   'Block dimension:',nBas_i,' by',nBas_j,'    Block norm:',
     &   sqrt(bnorm)
         nShell_i=LDF_nShell_Atom(iAtom)
         nShell_j=LDF_nShell_Atom(jAtom)
         ipi=LDF_lShell_Atom(iAtom)-1
         ipj=LDF_lShell_Atom(jAtom)-1
         Do jS=1,nShell_j
            jShell=iWork(ipj+jS)
            Do iS=1,nShell_i
               iShell=iWork(ipi+iS)
               Write(6,'(/,A,A,I9,A,I9,1X,I9,A)')
     &         myName(1:l),' block',iAtomPair,' (Atoms:',iAtom,jAtom,')'
               Write(6,'(A,I9,1X,I9,A,I9,1X,I9,A,I9)')
     &         'Shells:',iS,jS,' (',iShell,jShell,')   Location:',ip
               Write(6,'(A,I9,A,I9,A,1P,D15.6)')
     &         'Dimension:',nBasSh(iShell),' by',nBasSh(jShell),
     &         '    Norm:',
     &         sqrt(ddot_(nBasSh(iShell)*nBasSh(jShell),Work(ip),1,
     &                                                 Work(ip),1))
               Call Cho_Output(Work(ip),1,nBasSh(iShell),
     &                         1,nBasSh(jShell),nBasSh(iShell),
     &                         nBasSh(jShell),1,6)
               ip=ip+nBasSh(iShell)*nBasSh(jShell)
            End Do
         End Do
      End Do
      Write(6,'(/,A,A,1P,D15.6)')
     & myName(1:l),' total norm:',sqrt(tnorm)
      Call xFlush(6)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_SetRed_L()
C
C     Purpose: set next local reduced set. The next global reduced set
C              must be available at (global) index array location 2.
C
      Implicit None
#include "cholesky.fh"
#include "choptr.fh"
#include "choptr2.fh"
#include "choglob.fh"
#include "WrkSpc.fh"

      Character*14 SecNam
      Parameter (SecNam = 'Cho_P_SetRed_L')

      Integer irc, iC, nDim
      Integer i, j, k, i0, k0, l, ll
      Integer iSym, iSP, iShlAB
      Integer kOff

      Integer iL2G, mySP
      Integer IndRed, iiBstRSh, nnBstRSh
      Integer IndRed_G, iiBstRSh_G, nnBstRSh_G

      iL2G(i)=iWork(ip_iL2G-1+i)
      mySP(i)=iWork(ip_mySP-1+i)
      IndRed(i,j)=iWork(ip_IndRed-1+mmBstRT*(j-1)+i)
      iiBstRSh(i,j,k)=iWork(ip_iiBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      nnBstRSh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      IndRed_G(i,j)=iWork(ip_IndRed_G-1+mmBstRT_G*(j-1)+i)
      iiBstRSh_G(i,j,k)=
     &            iWork(ip_iiBstRSh_G-1+nSym*nnShl_G*(k-1)+nSym*(j-1)+i)
      nnBstRSh_G(i,j,k)=
     &            iWork(ip_nnBstRSh_G-1+nSym*nnShl_G*(k-1)+nSym*(j-1)+i)


C     Copy current local reduced set (at location 2) to location 3.
C     -------------------------------------------------------------

      Call Cho_X_RSCopy(irc,2,3)
      If (irc .ne. 0) Then
         Write(Lupri,*) SecNam,': Cho_X_RSCopy returned ',irc
         Call Cho_Quit('Error in '//SecNam,104)
      End If

C     Re-initialize local reduced set indices at location 2.
C     ------------------------------------------------------

      nDim = nSym*nnShl
      Call Cho_iZero(iWork(ip_IndRed+mmBstRT),mmBstRT)
      Call Cho_iZero(iWork(ip_iiBstRSh+nDim),nDim)
      Call Cho_iZero(iWork(ip_nnBstRSh+nDim),nDim)
      Call Cho_iZero(iiBstR(1,2),nSym)
      Call Cho_iZero(nnBstR(1,2),nSym)
      nnBstRT(2) = 0

C     Set local nnBstRSh counter at location 2.
C     -----------------------------------------

      k0 = ip_nnBstRSh + nDim - 1
      Do iSP = 1,nnShl
         iShlAB = mySP(iSP)
         k = k0 + nSym*(iSP-1)
         Do iSym = 1,nSym
            iWork(k+iSym) = nnBstRSh_G(iSym,iShlAB,2)
         End Do
      End Do

C     Set remaining reduced set indices (excl. IndRed), location 2.
C     -------------------------------------------------------------

      Call Cho_SetRedInd(iWork(ip_iiBstRSh),iWork(ip_nnBstRSh),nSym,
     &                   nnShl,2)

C     Set local IndRed to point to local 1st reduced set.
C     ---------------------------------------------------

      kOff = ip_IndRed + mmBstRT - 1
      iC = 0
      Do iSym = 1,nSym
         Do iSP = 1,nnShl
            iShlAB = mySP(iSP)
            i0 = iiBstR_G(iSym,2) + iiBstRSh_G(iSym,iShlAB,2)
            k0 = iiBstR(iSym,3) + iiBstRSh(iSym,iSP,3)
            Do i = 1,nnBstRSh_G(iSym,iShlAB,2)
               j = IndRed_G(i0+i,2) ! addr in global rs1
               iC = iC + 1
               k = 0
               Do While (k .lt. nnBstRSh(iSym,iSP,3))
                  k = k + 1
                  ll = IndRed(k0+k,3)
                  l = iL2G(ll)
                  If (l .eq. j) Then
                     iWork(kOff+iC) = ll
                     k = nnBstRSh(iSym,iSP,3) ! break while loop
                  End If
               End Do
            End Do
         End Do
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine axexsol_cvb( &
#                      define _CALLING_
#                      include "ddsol_interface.fh"
                      )
! Diagonalize Hamiltonian in Davidson subspace:

use casvb_global, only: corenrg, ifollow, ipdd, iroot, jroot, nfrdim1 => nfrdim, nroot
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
#include "ddsol_interface.fh"
integer(kind=iwp) :: i
real(kind=wp) :: del, delmin
real(kind=wp), allocatable :: eigval(:), eigvec(:,:)

#include "macros.fh"
unused_var(rhsp)
unused_var(nfrdim)

call mma_allocate(eigval,itdav,label='eigval')
call mma_allocate(eigvec,itdav,itdav,label='eigvec')
eigvec(:,:) = ap(1:itdav,1:itdav)

if (ipdd >= 3) then
  write(u6,*) ' AP matrix :'
  do i=1,itdav
    eigval(i) = eigvec(i,i)
    eigvec(i,i) = eigvec(i,i)+corenrg
  end do
  call mxprintd_cvb(eigvec,itdav,itdav,0)
  do i=1,itdav
    eigvec(i,i) = eigval(i)
  end do
end if

call mxdiag_cvb(eigvec,eigval,itdav)

if (ifollow <= 2) then
  iroot = nroot
  jroot = mod(itdav,nroot)
  if (jroot == 0) jroot = nroot
  if ((itdav == maxdav) .or. (itdav == nfrdim1)) jroot = nroot
  iroot = min(itdav,iroot)
  jroot = min(itdav,jroot)
  if (ifollow == 1) then
    iroot = itdav-iroot+1
    jroot = itdav-jroot+1
  end if
else if (ifollow == 3) then
  write(u6,*) ' Overlap-based root following not yet implemented!'
  call abend_cvb()
else if (ifollow == 4) then
  ! Eigenvalue-based root following -- determine closest root:
  iroot = 1
  delmin = abs(eigval(1)-eig)
  do i=1,min(itdav,nroot)
    del = abs(eigval(i)-eig)
    if (del < delmin) then
      delmin = del
      iroot = i
    end if
  end do
  jroot = iroot
end if
eig = eigval(iroot)
solp(:) = eigvec(:,iroot)
eig_res = eigval(jroot)
solp_res(:) = eigvec(:,jroot)
if (ipdd >= 2) then
  write(u6,'(a)') ' Eigenvalues :'
  eigval(1:itdav) = eigval(1:itdav)+corenrg
  call vecprint_cvb(eigval,itdav)
  eigval(1:itdav) = eigval(1:itdav)-corenrg
  write(u6,'(a,i3,a)') ' Eigenvector number',iroot,' :'
  call vecprint_cvb(solp,itdav)
  if (jroot /= iroot) then
    write(u6,'(a,i3,a)') ' Eigenvector number',jroot,' :'
    call vecprint_cvb(solp_res,itdav)
  end if
end if
call mma_deallocate(eigval)
call mma_deallocate(eigvec)

return

end subroutine axexsol_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine ChkOrt(CMO,nCMO,Ovl,nOvl,OffMx)
************************************************************************
*                                                                      *
*     purpose: Check orthogonality of CMOs                             *
*                                                                      *
*     input:                                                           *
*       CMO     : orthonormal (?) vectors                              *
*       Ovl     : overlap matrix in AO basis                           *
*                                                                      *
*     output:                                                          *
*       OffMx   : maximal off diagonal element                         *
*                                                                      *
*     called from: NewOrb                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1995                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 CMO(nCMO),Ovl(nOvl)
*
      Parameter (OrtThr = 1.0d-9)
*
*     declaration of local vars
      Integer iOffMx,jOffMx,iDgNo1
      Real*8 OffMx,DgNo1
      Logical termin
      Real*8, Dimension(:), Allocatable:: OvlS, Aux
*
      Call mma_allocate(OvlS,MaxBas**2,Label='OvlS')
      Call mma_allocate(Aux,MaxBas**2,Label='Aux')
*
      ij   = 1
      iCMO = 1
      termin = .FALSE.
      Do iSym = 1, nSym
        OffMx = Zero
        DgNo1 = Zero
        nBs = nBas(iSym)
        nOr = nOrb(iSym)
        If (nOr.gt.0) Then
           Call Square(Ovl(ij),OvlS,1,nBs,nBs)
           Call DGEMM_('N','N',
     &                 nBs,nOr,nBs,
     &                 1.0d0,OvlS,nBs,
     &                       CMO(iCMO),nBs,
     &                 0.0d0,Aux,nBs)
           Call DGEMM_('T','N',
     &                 nOr,nOr,nBs,
     &                 1.0d0,CMO(iCMO),nBs,
     &                       Aux,nBs,
     &                 0.0d0,OvlS,nOr)
*          get largest non zero off diag element
           Do i=1,nOr
             Do j = 1, i-1
               iOff = (j-1)*nOr+i
               OffMx = Max(OffMx,Abs(OvlS(iOff)))
             End Do
           End Do
*          get diag element most different from one
           Do i=1,nOr
             iOff = (i-1)*nOr+i
             DgNo1 = Max(DgNo1,Abs(OvlS(iOff)-One))
           End Do
*          check, if orthogonality violated
           If ((OffMx.gt.OrtThr).OR.(DgNo1.gt.OrtThr)) Then
*            Ooooops...
C            Write(6,*) 'WARNING: reorthonormalizing MOs...',OffMx,DgNo1
*
*            try to re-orthonormalize...
             Call Orthox(OvlS,CMO(iCMO),nOr,nBs)
*
*            and test again...
             OffMx = Zero
             DgNo1 = Zero
             Call Square(Ovl(ij),OvlS,1,nBs,nBs)
             Call DGEMM_('N','N',
     &                   nBs,nOr,nBs,
     &                   1.0d0,OvlS,nBs,
     &                         CMO(iCMO),nBs,
     &                   0.0d0,Aux,nBs)
             Call DGEMM_('T','N',
     &                   nOr,nOr,nBs,
     &                   1.0d0,CMO(iCMO),nBs,
     &                         Aux,nBs,
     &                   0.0d0,OvlS,nOr)
*            get largest non zero off diag element
             Do i=1,nOr
               Do j = 1, i-1
                 iOff = (j-1)*nOr+i
                 OffMx = Max(OffMx,Abs(OvlS(iOff)))
               End Do
             End Do
*            get diag element most different from one
             Do i=1,nOr
               iOff = (i-1)*nOr+i
               DgNo1 = Max(DgNo1,Abs(OvlS(iOff)-One))
             End Do
*            check, if orthogonality violated
             If ((OffMx.gt.OrtThr).OR.(DgNo1.gt.OrtThr)) Then
               termin=.TRUE.
               If (OffMx.gt.OrtThr) Then
*                off diag element too large. Now we have time, since
*                program will terminate anyway -> Go through matrix
*                again, this time we want element indices...
                 Do i=1,nOr
                   Do j = 1, i-1
                     iOff = (j-1)*nOr+i
                     If (Abs(OvlS(iOff)).ge.OffMx) Then
*                      found
                       iOffMx=i
                       jOffMx=j
                       OffMx=OvlS(iOff)
*                      exit loop
                       GoTo 100
                     End If
                   End Do
                 End Do
  100            Continue
c                 call WarningMessage(0, 'Orthogonality violated')
                 Write(6,*)' iSym =',iSym
                 Write(6,*)' largest off diag element:',
     &                     ' [',iOffMx,',',jOffMx,']',' = ',OffMx
               End If
               If (DgNo1.gt.OrtThr) Then
*                diag element too different from One
                 Do i=1,nOr
                   iOff = (i-1)*nOr+i
                   If (Abs(OvlS(iOff)-One).ge.DgNo1) Then
*                    found
                     iDgNo1=i
                     DgNo1=OvlS(iOff)
*                    exit loop
                     GoTo 110
                   End If
                 End Do
  110            Continue
c                 call WarningMessage(0, 'Orthogonality violated')
                 Write(6,*)
                 Write(6,*)' ***** Orthogonality violated *****'
                 Write(6,*)' iSym =',iSym
                 Write(6,*)' diag element most different from 1.0:',
     &                     ' [',iDgNo1,',',iDgNo1,']',' = ',DgNo1
               End If
             End If
           End If
        End If
        ij   = ij   + nBs*(nBs + 1)/2
        iCMO = iCMO + nBs*nOr
      End Do
*
      Call mma_deallocate(Aux)
      Call mma_deallocate(OvlS)
      If (termin) then
         Call Abend
         call WarningMessage(0, 'Orthogonality cannot be '//
     *   'recovered\n Basis set problem???')
      endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine icomb_cvb(i1,i2,icomb_cvbval)

use Constants, only: One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: i1, i2
integer(kind=iwp), intent(out) :: icomb_cvbval
integer(kind=iwp) :: i3, j
real(kind=wp) :: comb

! Special cases - return ICOMB_CVB=0:
if ((i1 < 0) .or. (i2 < 0) .or. (i1 < i2)) then
  icomb_cvbval = 0
  return
end if
! I3 is I2 but always less than I1/2:
i3 = (i1-abs(i1-2*i2))/2
comb = One
do j=1,i3
  comb = comb/real(j,kind=wp)
  comb = comb*real(i1-j+1,kind=wp)
end do
icomb_cvbval = nint(comb)
! If integer overflow - return ICOMB_CVB=-1:
if (abs(real(icomb_cvbval,kind=wp)-comb) > Half) icomb_cvbval = -1

return

end subroutine icomb_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2000, Roland Lindh                                *
************************************************************************
      SubRoutine Init_PCM(NonEq,iCharg)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*                                                                      *
*             Modified for Langevin polarizabilities, March 2000 (RL)  *
************************************************************************
      use PCM_arrays
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "angstr.fh"
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
#include "stdalloc.fh"
#include "unixinfo.fh"
      Character*2 Elements(MxAtom*8)
      Logical NonEq
      Integer  iix(2)
      Real*8   rix(2)
#include "periodic_table.fh"
      Real*8, Allocatable:: Coor(:,:), LcCoor(:,:)
      Integer, Allocatable:: ANr(:), LcANr(:)
*
      If (.Not.PCM) Return
*
      iRout=1
      iPrint=nPrint(iRout)
*
      nbyte_i = iiloc(iix(2)) - iiloc(iix(1))
      nbyte_r = idloc(rix(2)) - idloc(rix(1))
*                                                                      *
************************************************************************
*                                                                      *
*---- Reinitiate always for gradient calculations
*
      DoDeriv=.False.
cpcm_solvent
c added mckinley for pcm in second derivatives
      If (      ProgName.eq.'alaska'
     &     .or. ProgName.eq.'mckinley'
     &     .or. ProgName.eq.'mclr'    )
     &    DoDeriv=.True.
cpcm_solvent end
      If (DoDeriv) Then
         LcNAtm = ISlPar(42)
         nDeg=3*LcNAtm
         Call mma_allocate(dTes,nTs,lcNAtm,3,Label='dTes')
         Call mma_allocate(dPnt,nTs,lcNAtm,3,3,Label='dPnt')
         Call mma_allocate(dRad,nS ,lcNAtm,3,Label='dRad')
         Call mma_allocate(dCntr,nS ,lcNAtm,3,3,Label='dCntr')
         Call mma_allocate(PCM_SQ,2,nTs,Label='PCM_SQ')
         Call Get_dArray('PCM Charges',PCM_SQ,2*nTs)
         Go To 888
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Check if we have retrievable PCM data
*
      Call Get_iScalar('PCM info length',nPCM_info)
      If (nPCM_info.ne.0) Then
*
*------- If charge or NonEq/Eq status in retrieved data not the same as
*        for request redo the PCM initiation.
*
         If (iCharge_ref.ne.  iCharg) Go To 888
         If (NonEq_ref  .neqv.NonEq ) Go To 888
*
*        Evolving the new code
*
         Call mma_allocate(PCMSph,4,NS,Label='PCMSph')
         Call mma_allocate(PCMTess,4,nTs,Label='PCMTess')
         Call mma_allocate(Vert,3,MxVert,nTs,Label='Vert')
         Call mma_allocate(Centr,3,MxVert,nTs,Label='Centr')
         Call mma_allocate(SSph,NS,Label='SSph')
         Call mma_allocate(PCMDM,nTs,nTs,Label='PCMDM')
         Call mma_allocate(PCM_N,NS,Label='PCM_N')
         Call mma_allocate(PCMiSph,nTs,Label='PCMiSph')
         Call mma_allocate(NVert,nTs,Label='NVert')
         Call mma_allocate(IntSph,MxVert,nTs,Label='IntSph')
         Call mma_allocate(NewSph,2,NS,Label='NewSph')
*
         Call Get_dArray('PCMSph',PCMSph,4*NS)
         Call Get_dArray('PCMTess',PCMTess,4*nTs)
         Call Get_dArray('Vert',Vert,3*MxVert*nTs)
         Call Get_dArray('Centr',Centr,3*MxVert*nTs)
         Call Get_dArray('SSph',SSph,NS)
         Call Get_dArray('PCMDM',PCMDM,nTs**2)
         Call Get_iArray('PCM_N',PCM_N,NS)
         Call Get_iArray('PCMiSph',PCMiSph,nTs)
         Call Get_iArray('NVert',NVert,nTs)
         Call Get_iArray('IntSph',IntSph,MxVert*nTs)
         Call Get_iArray('NewSph',NewSph,2*NS)

         Go To 999
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Initial processing for PCM
*
 888  Call Get_nAtoms_All(nAtoms)
      Call mma_allocate(Coor,3,nAtoms,Label='Coor')
      Call Get_Coord_All(Coor,nAtoms)
      Call Get_Name_All(Elements)
      Call mma_Allocate(ANr,nAtoms,Label='ANr')
      Do i = 1, nAtoms
         Do j = 0, Num_Elem
            If (PTab(j).eq.Elements(i)) ANr(i)=j
         End Do
      End Do
      Call mma_allocate(LcCoor,3,nAtoms,Label='LcCoor')
      Call mma_allocate(LcANr,nAtoms,Label='LcANr')
*
*---- Initialize PCM model
*
*     iPrint: Print level
*     ICharg: Molecular charge
*     nAtoms: total number of atoms
*     angstr: conversion factor from bohr to Angstrom
*     Coor: Coordinates of atoms
*    MxVert*nTs ANr: atomic numbers
*     LcCoor: local array for atomic coordinates
*     LcANr: local array for atomic numbers
*     Solvent: string with explicit solvent name
*     Conductor: logical flag to activate conductor approximation
*     aArea: average area of a tessera
*     r_min_sphere: minimum radius of smoothing sphere
*     ip_Ts: pointer to tesserae
*     nTs  : number of tesserae
*
      Call PCM_Init(iPrint,ICharg,nAtoms,angstr,Coor,ANr,LcCoor,
     &              LcANr,nIrrep,NonEq)
      If (iPrint.gt.5) Then
         Write (6,*)
         Write (6,*)
      End If
*
      Call mma_deallocate(LcANr)
      Call mma_deallocate(LcCoor)
      Call mma_deallocate(ANr)
      Call mma_deallocate(Coor)
*                                                                      *
************************************************************************
*                                                                      *
*---- Put the dynamic arrays on COMFILE
*
      Call Save_PCM_Info(cRFStrt,iRFStrt,lRFStrt,rRFStrt)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
 999    Continue
      Return
*
*     This is to allow type punning without an explicit interface
      Contains
      SubRoutine Save_PCM_Info(cRFStrt,iRFStrt,lRFStrt,rRFStrt)
      Use Iso_C_Binding
      Integer, Target :: cRFStrt,iRFStrt,lRFStrt
      Real*8, Target :: rRFStrt
      Integer, Pointer :: p_cRF(:),p_iRF(:),p_lRF(:)
      Real*8, Pointer :: p_rRF(:)
*
      Call Put_iScalar('PCM info length',nPCM_info)

      Call Put_dArray('PCMSph',PCMSph,4*NS)
      Call Put_dArray('PCMTess',PCMTess,4*nTs)
      Call Put_dArray('Vert',Vert,3*MxVert*nTs)
      Call Put_dArray('Centr',Centr,3*MxVert*nTs)
      Call Put_dArray('SSph',SSph,NS)
      Call Put_dArray('PCMDM',PCMDM,nTs**2)
      Call Put_iArray('PCM_N',PCM_N,NS)
      Call Put_iArray('PCMiSph',PCMiSph,nTs)
      Call Put_iArray('NVert',NVert,nTs)
      Call Put_iArray('IntSph',IntSph,MxVert*nTs)
      Call Put_iArray('NewSph',NewSph,2*NS)
*
      iCharge_ref=iCharg
      NonEq_ref=NonEq
*
*---- Put the reaction field common blocks on disk again!
*
      Len = ilLoc(lRFEnd)-ilLoc(lRFStrt)
      Len = (Len+nByte_i)/nByte_i
      Call C_F_Pointer(C_Loc(lRFStrt),p_lRF,[Len])
      Call Put_iArray('RFlInfo',p_lRF,Len)
*
      Len = idLoc(rRFEnd)-idLoc(rRFStrt)
      Len = (Len+nByte_r)/nByte_r
      Call C_F_Pointer(C_Loc(rRFStrt),p_rRF,[Len])
      Call Put_dArray('RFrInfo',p_rRF,Len)
*
      Len = iiLoc(iRFEnd)-iiLoc(iRFStrt)
      Len = (Len+nByte_i)/nByte_i
      Call C_F_Pointer(C_Loc(iRFStrt),p_iRF,[Len])
      Call Put_iArray('RFiInfo',p_iRF,Len)
*
      Len = iiLoc(cRFEnd)-iiLoc(cRFStrt)
      Len = (Len+nByte_i)/nByte_i
      Call C_F_Pointer(C_Loc(cRFStrt),p_cRF,[Len])
      Call Put_iArray('RFcInfo',p_cRF,Len)
*
      Nullify(p_lRF,p_rRF,p_iRF,p_cRF)
*
      End SubRoutine Save_PCM_Info
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Fold_tMat(nSym,nBas,A,B)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Fold up symmetry blocked matrix A (UT-storage)                   *
!     into triangular matrices with scaled (by two) off-diagonals      *
!     The input and output matrices may be                             *
!     identical.                                                       *
!                                                                      *
!     calling arguments:                                               *
!     nSym    : input, integer                                         *
!               number of symmetry blocks                              *
!     nBas    : input, array of integers                               *
!               matrix dimension per symmetry block                    *
!     A       : input, array of real*8                                 *
!               Unfolded input matrix (UT-storage)                     *
!     B       : output, array of real*8                                *
!               Folded output matrix  (UT-storage)                     *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use Constants, only: Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym)
real(kind=wp), intent(in) :: A(*)
real(kind=wp), intent(_OUT_) :: B(*)
integer(kind=iwp) :: i, iOff, iSym, j

!************************************
iOff = 0

do iSym=1,nSym

  do j=1,nBas(iSym)

    do i=j+1,nBas(iSym)

      B(iOff+iTri(i,j)) = two*A(iOff+iTri(i,j))

    end do

    B(iOff+nTri_Elem(j)) = A(iOff+nTri_Elem(j))

  end do

  iOff = iOff+nTri_Elem(nBas(iSym))

end do

!ij = 0
!do isym=1,nsym
!  do i=1,nbas(isym)
!    do j=1,i-1
!      ij = ij+1
!      B(ij) = Two*A(ij)
!    end do
!    ij = ij+1
!    B(ij) = A(ij)
!  end do
!end do

return

end subroutine Fold_tMat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine getAOs(lhigh)
!bs get expansions of atomic orbitals in contracted functions

use AMFI_global, only: AOcoeffs, ncontrac, noccorb, occup
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lhigh
integer(kind=iwp) :: icont, iorbital, lrun, Lu_33
logical(kind=iwp) :: EX
character(len=12) :: occread, occtext
character(len=18) :: textnorbmf, textnorbmf2
integer(kind=iwp), external :: IsFreeUnit

occtext = 'OCCUPATION: '
textnorbmf = 'Number of orbitals'
call f_inquire('AO-expansion',EX)
if (.not. EX) then
  !BS write(u6,*) 'get occupations from DATA-block'
  call getAOs2(lhigh)
else
  Lu_33 = IsFreeUnit(33)
  call molcas_open(Lu_33,'AO-expansion')
  !open(unit=Lu_33,file='AO-expansion',status='UNKNOWN')
  !BS write(u6,*) 'Orbitals for mean-field'
  do lrun=0,lhigh
    !BS write(u6,'(A3,I3)') 'L= ',lrun
    read(Lu_33,'(A18,I3)') textnorbmf2,noccorb(lrun)
    if (textnorbmf /= textnorbmf2) call SysAbendMsg('getAOs','wrong keyword for number of orbitals in getAOs',' ')
    !BS write(u6,*) 'number of orbitals ',noccorb(lrun)
    do iorbital=1,noccorb(lrun)
      read(Lu_33,'(A12,F5.3)') occread,occup(iorbital,lrun)
      !BS write(u6,'(A,F8.4)') occtext,occup(iorbital,lrun)
      if (occread /= occtext) call SysAbendMsg('getAOs','error reading AOs',' ')
      read(Lu_33,*) (AOcoeffs(icont,iorbital,lrun),icont=1,ncontrac(lrun))
      !BS write(u6,'(8F10.4)') (AOcoeffs(icont,iorbital,lrun),icont=1,ncontrac(lrun))
      !BS write(u6,*) ' '
      read(Lu_33,*)
    end do
  end do
  close(Lu_33)
end if

return

end subroutine getAOs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Naoki Nakatani                                   *
************************************************************************
      SUBROUTINE MKXMAT(TORB,XMAT)
      IMPLICIT REAL*8 (A-H,O-Z)
* Make full transformation matrix for active space
* from that stored for each symmetry in IAD1M(4)
* Written by N. Nakatani, Oct. 2014
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
      DIMENSION TORB(NTORB), XMAT(NASHT,NASHT)

      IF(NASHT.GT.0) THEN
        ITOEND=0
        DO ISYM=1,NSYM
          NI=NISH(ISYM)
          NA=NASH(ISYM)
          NR1=NRAS1(ISYM)
          NR2=NRAS2(ISYM)
          NR3=NRAS3(ISYM)
          NS=NSSH(ISYM)
          ITOSTA=ITOEND+1
          ITOEND=ITOEND+NI**2+NR1**2+NR2**2+NR3**2+NS**2

* Normally, NRAS2 should only be non-zero, but NRAS1 and NRAS3 should be zero
* for DMRG-CASSCF calculation
          ITO=ITOSTA+NI**2
C         ITO=ITOSTA+NI**2-1
* RAS1
          IF(NA.GT.0) THEN
            IF(NR1.GT.0) THEN
              ISTART=NAES(ISYM)
              DO JR1=1,NR1
                J=ISTART+JR1
                DO IR1=1,NR1
                  I=ISTART+IR1
                  XMAT(I,J)=TORB(ITO)
                  ITO=ITO+1
                END DO
              END DO
            END IF
* RAS2
            IF(NR2.GT.0) THEN
              ISTART=NAES(ISYM)+NR1
              DO JR2=1,NR2
                J=ISTART+JR2
                DO IR2=1,NR2
                  I=ISTART+IR2
                  XMAT(I,J)=TORB(ITO)
                  ITO=ITO+1
                END DO
              END DO
            END IF
* RAS3
            IF(NR3.GT.0) THEN
              ISTART=NAES(ISYM)+NR1+NR2
              DO JR3=1,NR3
                J=ISTART+JR3
                DO IR3=1,NR3
                  I=ISTART+IR3
                  XMAT(I,J)=TORB(ITO)
                  ITO=ITO+1
                END DO
              END DO
            END IF
          END IF
        END DO
      END IF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine x2c_ts1e(n,s,t,v,w,ul,us,clight)
! Evaluate the X2C Hamiltonian matrix and store the transform matrices

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
! w   aka pVp
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: s(n,n), t(n,n), v(n,n), w(n,n)
real(kind=wp), intent(out) :: ul(n,n), us(n,n)
real(kind=wp), intent(in) :: clight
integer(kind=iwp) :: m, i, j
real(kind=wp) :: c_2c2, c_4c2, c_2c
real(kind=wp), allocatable :: F(:,:), St(:,:), X(:,:), A(:,:), B(:,:), C(:,:), SS(:,:)

! Construct the full dimensional (2*n) Fock matrix and overlap matrix

m = n+n
c_2c = clight*Two
c_2c2 = clight*clight*Two
c_4c2 = c_2c2*Two
! rescale, in order to make X matrix close to unit matrix
w(:,:) = w(:,:)/c_4c2
call mma_allocate(F,m,m,label='TmpF')
call mma_allocate(St,m,m,label='TmpS')
St(:,:) = Zero
do i=1,n
  do j=1,n
    St(j,i) = s(j,i)
    St(n+j,n+i) = t(j,i)/c_2c2
    F(i,j) = v(j,i)
    F(n+i,j) = t(j,i)
    F(i,n+j) = t(j,i)
    F(n+i,n+j) = w(j,i)-t(j,i)
  end do
end do

! Call diagonalization routine to obtain the X matrix

call mma_allocate(X,n,n,label='TmpX')
call x2c_makx(m,n,F,St,X)

! Calculate transformed Hamiltonian matrix

call mma_allocate(A,n,n,label='TmpA')
call mma_allocate(B,n,n,label='TmpB')
call mma_allocate(C,n,n,label='TmpC')
call mma_allocate(SS,n,n,label='TmpC')
call dmxma(n,'C','N',X,t,A,One)
call dmxma(n,'N','N',t,X,B,One)
call dmxma(n,'N','N',A,X,C,One)
! X-projected overlap matrix
SS(:,:) = s(:,:)+C(:,:)/c_2c2
! X-projected kinetic matrix
t(:,:) = A(:,:)+B(:,:)-C(:,:)
call XDR_dmatsqrt(s,n)
call dmxma(n,'C','N',s,SS,A,One)
call dmxma(n,'N','N',A,s,B,One)
call XDR_dmatsqrt(B,n)
call dmxma(n,'N','N',s,B,C,One)
call XDR_dmatinv(s,n)
! renormalization matrix, also the upper part of transformation matrix
call dmxma(n,'N','N',C,s,ul,One)
! lower part of the transformation matrix
call dmxma(n,'N','N',X,ul,us,One)

! Apply transformation to kinetic and potential matrices

call dmxma(n,'C','N',ul,t,A,One)
call dmxma(n,'N','N',A,ul,t,One)
call dmxma(n,'C','N',ul,v,A,One)
call dmxma(n,'N','N',A,ul,v,One)
call dmxma(n,'C','N',us,w,A,One)
call dmxma(n,'N','N',A,us,w,One)
v(:,:) = v(:,:)+t(:,:)+w(:,:)
! since pVp was rescaled, the lower part of transformation matrix also need to be rescaled
us(:,:) = us(:,:)/c_2c

! Free temp memories

call mma_deallocate(F)
call mma_deallocate(St)
call mma_deallocate(X)
call mma_deallocate(A)
call mma_deallocate(B)
call mma_deallocate(C)
call mma_deallocate(SS)

return

end subroutine x2c_ts1e

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine GetPDFTFock(bk)

use Symmetry_Info, only: Mul
use MCLR_Data, only: ipMat, nDens
use input_mclr, only: nBas, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: bk(nDens)
integer(kind=iwp) :: IS, JS
real(kind=wp), allocatable :: T(:), bktmp(:)

call mma_allocate(bktmp,nDens)
call mma_allocate(T,nDens)
call Get_DArray('FxyMS',T,nDens)
do IS=1,nSym
  jS = Mul(iS,1)
  if (nBas(iS)*nBas(jS) /= 0) &
    call DGeSub(T(ipMat(iS,jS)),nBas(iS),'N',T(ipMat(jS,iS)),nBas(jS),'T',bktmp(ipMat(iS,jS)),nBas(iS),nBas(iS),nBas(jS))
end do
bk(:) = bk(:)-Two*bktmp(:)
call mma_deallocate(T)
call mma_deallocate(bktmp)

end subroutine GetPDFTFock

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DVer(IOpt,IC,L0,L,L2,DX,DY,DZ,Vert,Centr,Sphere,IntSph)

use PCM_Arrays, only: MxVert
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IOpt, IC, L0, L, L2, IntSph(MxVert)
real(kind=wp), intent(out) :: DX, DY, DZ
real(kind=wp), intent(in) :: Vert(3,MxVert), Centr(3,MxVert), Sphere(4,*)
integer(kind=iwp) :: L1, NSJ
real(kind=wp) :: DNORM3, FACT, P(3), P1(3), P2(3), P3(3), PROD

! Trova la derivata della posizione del vertice L della tessera ITS
!
! IOpt = 0 : rispetto alla coordinata IC della sfera che, intersecando
!            ISPHE, forma il lato in esame. (ex derver)
! IOpt = 1 : rispetto al raggio della sfera aggiunta NSJ che,
!            intersecando la tessera ITS, crea il lato considerato.
!            (ex derver1, IC not referenced)
!
! Se stiamo considerando il primo vertice del lato : L > 0,
! il lato che si muove e' L-L2, e il vettore derivata e' diretto
! lungo la tangente al lato precedente (L0-L).
! Se stiamo considerando il secondo vertice del lato : L < 0,
! il lato che si muove e' L0-L, e il vettore derivata e' tangente
! al lato seguente (L-L2).

if (L > 0) then
  L1 = L
  NSJ = INTSPH(L1)
else
  L1 = -L
  NSJ = INTSPH(L0)
end if

! Il vettore P indica la posizione del vertice rispetto al centro
! della sfera NSJ
P(:) = VERT(:,L1)-Sphere(1:3,NSJ)

! Trova il versore tangente al lato L0-L1 se stiamo considerando il
! primo vertice, L2-L1 se consideriamo il secondo
if (L > 0) then
  P1(:) = VERT(:,L1)-CENTR(:,L0)
  P2(:) = VERT(:,L0)-CENTR(:,L0)
else
  P1(:) = VERT(:,L1)-CENTR(:,L1)
  P2(:) = VERT(:,L2)-CENTR(:,L1)
end if
call crprod(P1,P2,P3)
P2(:) = P3(:)
call crprod(P1,P2,P3)
DNORM3 = sqrt(P3(1)*P3(1)+P3(2)*P3(2)+P3(3)*P3(3))
P3(:) = P3(:)/DNORM3
! Trova la derivata
PROD = P(1)*P3(1)+P(2)*P3(2)+P(3)*P3(3)
if (IOpt == 0) then
  if ((PROD == ZERO) .and. (P(IC) /= ZERO)) then
    write(u6,'(a)') 'Stop in DVer.'
    call Abend()
  end if
  if (PROD == ZERO) PROD = One
  FACT = P(IC)/PROD
else if (IOpt == 1) then
  if (PROD == ZERO) then
    write(u6,'(a)') 'Stop in DVer.'
    call Abend()
  end if
  FACT = Sphere(4,NSJ)/PROD
else
  FACT = Zero
  write(u6,'(a)') 'Illegal IOpt in DVer.'
  call Abend()
end if
DX = FACT*P3(1)
DY = FACT*P3(2)
DZ = FACT*P3(3)

return

end subroutine DVer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine prtfid_cvb(chr,fileid)
      implicit real*8 (a-h,o-z)
#include "io_cvb.fh"
      character*200 line
      character*(*) chr

      line=chr
      call mkfn_cvb(fileid,ibf)
      call appendchr_cvb(line,' file ',0)
      call appendchr_cvb(line,filename(ibf),1)
      call appendchr_cvb(line,'.',0)
      write(6,'(a)')line(1:len_trim_cvb(line))
      return
      end
      logical function tstfile_cvb(fileid)
      implicit real*8 (a-h,o-z)
      logical ex
#include "io_cvb.fh"

      if(fileid.lt.1.d-2)then
        tstfile_cvb=.false.
        return
      endif
      call mkfn_cvb(fileid,ibf)
      if(ifilio(ibf).eq.0)then
        call f_inquire(filename(ibf),ex)
        tstfile_cvb=ex
      else
        tstfile_cvb=.true.
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ChoMP2g_ConstrAP(irc,Scr,lScr,typ,iSym,nVec,Ap,lAp,Dens,lDens,factor)

use Symmetry_Info, only: Mul
use Cholesky, only: nSym, NumCho
use ChoMP2, only: iAdrOff, lUnit_F, LuVVec, LuWVec, nFro, nMoMo, nOcc, nVir
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: lScr, iSym, nVec, lAp, lDens
real(kind=wp), intent(out) :: Scr(lScr)
real(kind=wp), intent(inout) :: Ap(lAp)
real(kind=wp), intent(in) :: Dens(lDens), factor
character, intent(in) :: typ(4)
integer(kind=iwp) :: i, iAdr, iAdrLip, iAdrLiq, iAdrLir, iAdrLpq, iAdrLrp, iAdrLrq, iBat, iCol, iIP, iIQ, iIR, iOffAp(8), iOffL, &
                     iOffL1, iOffp(8), iOffY, iOffY1, iOffZ, iOffZ1, iOpt, iOrbType(4), iPQ, iRP, iRQ, iSym1, iSymI, iSymP, iSymQ, &
                     iSymR, iTypL, iVec, iVec1, kEndLip, kEndLiq, kEndLir, kEndLpq, kEndLrp, kEndLrq, kEndX, kEndY, kLip, kLiq, &
                     kLir, kLpq, kLrp, kLrq, kX, kY, kZ, lLip, lLiq, lLir, lLpq, lLrp, lLrq, lTot, lX, lY, nBatL, nI, nIP, nIQ, &
                     nIR, nOrb1(8,4), nP, nPQ, nQ, nR, nRow, nRP, nRQ, nTypes, NumVec
real(kind=wp) :: yfactor
logical(kind=iwp) :: DoX, DoY, DoZ
character(len=*), parameter :: SecNam = 'ChoMP2g_ConstrAP'

! Setup some lengths
! ------------------
nTypes = 4

iTypL = 1

! Setup lengths of needed cholesky/intermediate vectors
! -----------------------------------------------------

! Read the char-array Type = 'pqri'
! ---------------------------------
do i=1,nTypes
  if (typ(i) == 'f') then
    iOrbType(i) = 1
    nOrb1(1:nSym,i) = nFro(1:nSym)
  else if (typ(i) == 'o') then
    iOrbType(i) = 2
    nOrb1(1:nSym,i) = nOcc(1:nSym)
  else if (typ(i) == 'v') then
    iOrbType(i) = 3
    nOrb1(1:nSym,i) = nVir(1:nSym)
  else
    write(u6,*) 'Forbidden Type pqrs in',SecNam
    irc = -1
    return
  end if
end do

! Set vector type index
! ---------------------
iPQ = 3*(iOrbType(1)-1)+iOrbType(2)
iIR = 3*(iOrbType(4)-1)+iOrbType(3)
iIQ = 3*(iOrbType(4)-1)+iOrbType(2)
iRP = 3*(iOrbType(3)-1)+iOrbType(1)
iIP = 3*(iOrbType(4)-1)+iOrbType(1)
iRQ = 3*(iOrbType(3)-1)+iOrbType(2)

! Set vector lengths
! ------------------
nPQ = nMoMo(iSym,iPQ)
nIR = nMoMo(iSym,iIR)
nIQ = nMoMo(iSym,iIQ)
nRP = nMoMo(iSym,iRP)
nIP = nMoMo(iSym,iIP)
nRQ = nMoMo(iSym,iRQ)

! Set address-offset for cholesky vector address
! ----------------------------------------------
iAdrLpq = iAdrOff(iSym,iPQ)
iAdrLir = iAdrOff(iSym,iIR)
iAdrLiq = iAdrOff(iSym,iIQ)
iAdrLrp = iAdrOff(iSym,iRP)
iAdrLip = iAdrOff(iSym,iIP)
iAdrLrq = iAdrOff(iSym,iRQ)

! Set

#ifdef _DEBUGPRINT_
write(u6,*) 'iPQ',iPQ
write(u6,*) 'iIQ',iIQ
write(u6,*) 'iIR',iIR
write(u6,*) 'iIP',iIP
write(u6,*) 'iRQ',iRQ
write(u6,*) 'iRP',iRP

write(u6,*) 'nPQ',nPQ
write(u6,*) 'nIQ',nIQ
write(u6,*) 'nIR',nIR
write(u6,*) 'nIP',nIP
write(u6,*) 'nRQ',nRQ
write(u6,*) 'nRP',nRP
#endif
! Decide what type of intermediate vectors is needed
! --------------------------------------------------
DoX = .true.
DoY = .true.
DoZ = .true.

if (iSym /= 1) DoX = .false.
if ((nPQ == 0) .or. (nIR == 0)) DoX = .false.
if ((nRP == 0) .or. (nIQ == 0)) DoY = .false.
if ((nIP == 0) .or. (nRQ == 0)) DoZ = .false.
if (typ(1) == typ(2)) DoZ = .false.

if (DoY .or. DoZ) then
  iOffp(1) = 0
  iOffap(1) = 0
  do iSym1=2,nSym
    iOffp(iSym1) = iOffp(iSym1-1)+nOrb1(iSym1-1,1)*nOrb1(iSym1-1,2)
    iOffap(iSym1) = iOffap(iSym1-1)+nOrb1(iSym1-1,3)*nOrb1(iSym1-1,4)
  end do
end if

!     Allocate memory for L-vectors
!     ------------------------------

!        Lri:
lLir = nIR*nVec
kLir = 1
kEndLir = kLir+lLir

!        Lpq:
lLpq = nPQ*nVec
kLpq = kEndLir
kEndLpq = kLpq+lLpq

!        Lrp:
lLrp = nRP*nVec
kLrp = kEndLpq
kEndLrp = kLrp+lLrp

! Lrq:
lLrq = nRQ*nVec
kLrq = kEndLrp
kEndLrq = kLrq+lLrq

! Lip:
lLip = nIP*nVec
kLip = kEndLrq
kEndLip = kLip+lLip

! Liq:
lLiq = nIQ*nVec
kLiq = kEndLip
kEndLiq = kLiq+lLiq

! Allocate memory for Intermediate Vectors
! ----------------------------------------
! X-vector
lX = NumCho(iSym)
kX = kEndLiq
kEndX = kX+lX
! Y-vector
lY = nVec*nIP
kY = kEndX
kEndY = kY+lY
! Z-vector
kZ = kEndY

nBatL = (NumCho(iSym)-1)/nVec+1

! Construction of Intermediate vectors
! ------------------------------------
do iBat=1,nBatL
  if (iBat == nBatL) then
    NumVec = NumCho(iSym)-nVec*(nBatL-1)
  else
    NumVec = nVec
  end if
  iVec = nVec*(iBat-1)+1

  ! Read Lpq-vectors
  ! ----------------
  if (DoX) then
    iOpt = 2
    lTot = nPQ*NumVec
    iAdr = nPQ*(iVec-1)+1+iAdrLpq
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLpq),lTot,iAdr)
  end if

  ! Read Liq-vectors
  ! ----------------
  if (DoY) then
    iOpt = 2
    lTot = nIQ*NumVec
    iAdr = nIQ*(iVec-1)+1+iAdrLiq
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLiq),lTot,iAdr)
  end if

  if (DoZ) then
    iOpt = 2
    lTot = nIP*NumVec
    iAdr = nIP*(iVec-1)+1+iAdrLip
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLip),lTot,iAdr)
  end if

  ! Construct X-vector
  ! ------------------
  if (DoX) then
    nRow = 1
    call dGemm_('T','N',nRow,NumVec,nPQ,One,Dens(1),nPQ,Scr(kLpq),nPQ,Zero,Scr(kX+iVec-1),nRow)
  end if

  ! Construct Y-vector
  ! ------------------
  if (DoY) then
    do iVec1=1,NumVec
      iOffL1 = 0
      iOffY1 = 0
      do iSymI=1,nSym
        iSymP = Mul(iSym,iSymI)
        iSymQ = iSymP
        nI = nOrb1(iSymI,4)
        nP = nOrb1(iSymP,1)
        nQ = nOrb1(iSymQ,2)
        nR = nOrb1(iSymI,3)
        if (nQ*nP*nI*nR /= 0) then
          iOffL = (iVec1-1)*nIQ+iOffL1
          iOffY = (iVec1-1)*nIP+iOffY1
          call dGemm_('T','N',nP,nI,nQ,One,Dens(1+iOffP(iSymP)),nQ,Scr(kLiq+iOffL),nQ,Zero,Scr(kY+iOffY),nP)
        end if
        iOffL1 = iOffL1+nQ*nI
        iOffY1 = iOffY1+nP*nI
      end do
    end do
    if (nBatL /= 1) then
      iOpt = 1
      lTot = nIP*NumVec
      iAdr = nIP*(iVec-1)+1
      call dDaFile(LuVVec,iOpt,Scr(kY),lTot,iAdr)
    end if
  end if
  ! Construct Z-vectors
  ! -------------------
  if (DoZ) then
    do iVec1=1,NumVec
      iOffL1 = 0
      iOffZ1 = 0
      do iSymI=1,nSym
        iSymP = Mul(iSym,iSymI)
        iSymQ = iSymP
        nI = nOrb1(iSymI,4)
        nP = nOrb1(iSymP,1)
        nQ = nOrb1(iSymQ,2)
        nR = nOrb1(iSymI,3)
        if (nQ*nP*nI*nR /= 0) then
          iOffL = (iVec1-1)*nIP+iOffL1
          iOffZ = (iVec1-1)*nIQ+iOffZ1
          call dGemm_('N','N',nQ,nI,nP,One,Dens(1+iOffP(iSymQ)),nQ,Scr(kLip+iOffL),nP,Zero,Scr(kZ+iOffZ),nQ)
        end if
        iOffL1 = iOffL1+nP*nI
        iOffZ1 = iOffZ1+nQ*nI
      end do
    end do
    if (nBatL /= 1) then
      iOpt = 1
      lTot = nIQ*NumVec
      iAdr = nIQ*(iVec-1)+1
      call dDaFile(LuWVec,iOpt,Scr(kZ),lTot,iAdr)
    end if

  end if
end do

! Contracting to produce the final contribution to A*p
! ----------------------------------------------------
do iBat=1,nBatL
  if (iBat == nBatL) then
    NumVec = NumCho(iSym)-nVec*(nBatL-1)
  else
    NumVec = nVec
  end if
  iVec = nVec*(iBat-1)+1

  ! Read Lir-vectors
  ! ----------------
  if (DoX) then
    iOpt = 2
    lTot = nIR*NumVec
    iAdr = nIR*(iVec-1)+1+iAdrLir
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLir),lTot,iAdr)
  end if

  ! Read Lrp-vectors
  ! ----------------
  if (DoY) then
    iOpt = 2
    lTot = nRP*NumVec
    iAdr = nRP*(iVec-1)+1+iAdrLrp
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLrp),lTot,iAdr)
  end if

  ! Read Lrq-vectors
  ! ----------------
  if (DoZ) then
    iOpt = 2
    lTot = nRQ*NumVec
    iAdr = nRQ*(iVec-1)+1+iAdrLrq
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLrq),lTot,iAdr)
  end if

  if (DoX) then
    iCol = 1
    call dGemm_('N','N',nIR,iCol,NumVec,Four*factor,Scr(kLir),nIR,Scr(kX+iVec-1),NumVec,One,Ap(1),nIR)
  end if

  if (DoY) then
    ! Read Y-vector (if they are stored on disk and not in memory)
    ! ------------------------------------------------------------
    if (nBatL /= 1) then
      iOpt = 2
      lTot = nIP*NumVec
      iAdr = nIP*(iVec-1)+1
      call dDaFile(LuVVec,iOpt,Scr(kY),lTot,iAdr)
    end if

    yfactor = factor
    if (.not. DoZ) yfactor = yfactor*Two
    do iVec1=1,NumVec
      iOffL1 = 0
      iOffY1 = 0
      do iSymI=1,nSym
        iSymP = Mul(iSym,iSymI)
        iSymR = iSymI
        nI = nOrb1(iSymI,4)
        nR = nOrb1(iSymR,3)
        nP = nOrb1(iSymP,1)
        nQ = nOrb1(iSymP,2)

        if (nI*nR*nP*nQ /= 0) then
          iOffL = (iVec1-1)*nRP+iOffL1
          iOffY = (iVec1-1)*nIP+iOffY1
          call dGemm_('T','N',nR,nI,nP,-yfactor,Scr(kLrp+iOffL),nP,Scr(kY+iOffY),nP,One,Ap(1+iOffAP(iSymI)),nR)
        end if
        iOffL1 = iOffL1+nR*nP
        iOffY1 = iOffY1+nI*nP
      end do
    end do

  end if

  if (DoZ) then
    ! Read Z-vector (if they are stored on disk and not in memory)
    ! ------------------------------------------------------------
    if (nBatL /= 1) then
      iOpt = 2
      lTot = nIQ*NumVec
      iAdr = nIQ*(iVec-1)+1
      call dDaFile(LuWVec,iOpt,Scr(kZ),lTot,iAdr)
    end if

    do iVec1=1,NumVec
      iOffL1 = 0
      iOffZ1 = 0
      do iSymI=1,nSym
        iSymQ = Mul(iSym,iSymI)
        iSymR = iSymI
        nI = nOrb1(iSymI,4)
        nR = nOrb1(iSymR,3)
        nQ = nOrb1(iSymQ,2)
        nP = nOrb1(iSymQ,1)
        if (nI*nR*nQ*nP /= 0) then
          iOffL = (iVec1-1)*nRQ+iOffL1
          iOffZ = (iVec1-1)*nIQ+iOffZ1
          call dGemm_('T','N',nR,nI,nQ,-factor,Scr(kLrq+iOffL),nQ,Scr(kZ+iOffZ),nQ,One,Ap(1+iOffAP(iSymI)),nR)
        end if
        iOffL1 = iOffL1+nR*nQ
        iOffZ1 = iOffZ1+nI*nQ
      end do
    end do
  end if
end do

return

end subroutine ChoMP2g_ConstrAP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SYMINF_MCLR(NIRREP,IPRNT)
*
* Information about number of symmetries
*
      IMPLICIT REAL*8(A-H,O-Z)
*
* NSMSX : number of symmetries of single excitations
* NSMDX : Number of symmetries of double excitations
* NSMST : Number of symmetries of strings
* NSMCI : NUmber of symmetries of CI spaces
* ITSSX : Total symmetrix single excitation
* ITSDX : Total symmetrix double excitation
*
#include "detdim.fh"
#include "csm.fh"
#include "csmprd.fh"
*
* ADASX : symmetry of orbs i and i => symmetry of a+iaj
* ASXAD : symmetry of orb j and excit a+iaj => symmetry of i
* ADSXA : symmetry of orb i and excit a+iaj => symmetry of j
*
* SXSXDX : Symmetry of two single excitations
*          => symmetry of double  excitation
* SXDXSX : Symmetry of single excitation and double excitation
*          => symmetry of single  excitation
*.
      NSMSX = NIRREP
      NSMDX = NIRREP
      NSMST = NIRREP
      NSMCI = NIRREP
      NSMXT = NIRREP
      ITSSX = 1
      ITSDX = 1
      ITSXT = 1
*
      Call iCopy(MXPOBS*MXPOBS,[0],0,ADASX,1)
      Call iCopy(MXPOBS*2*MXPOBS,[0],0,ADSXA,1)
      Call iCopy(MXPOBS*2*MXPOBS,[0],0,ASXAD,1)
      Call iCopy(2*MXPOBS*2*MXPOBS,[0],0,SXSXDX,1)
      Call iCopy(2*MXPOBS*4*MXPOBS,[0],0,SXDXSX,1)
      DO 10 ISYM=1,8
         DO 20 JSYM=1,8
            IJSYM=1+IEOR(ISYM-1,JSYM-1)
            ADASX(ISYM,JSYM)=IJSYM
            ADSXA(ISYM,JSYM)=IJSYM
            ASXAD(ISYM,JSYM)=IJSYM
            SXSXDX(ISYM,JSYM)=IJSYM
            SXDXSX(ISYM,JSYM)=IJSYM
20       CONTINUE
10    CONTINUE
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(IPRNT)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Logical Function LDF_DbguvJ(Tol,Silent)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Compare integrals of type (uv|J) computed by two
C              different routines (debug code).
C
      Implicit None
      Real*8  Tol
      Logical Silent
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      real*8 ddot_
      external ddot_

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Integer AB, A, B, nuv, M, iCount
      Integer ip_Int1, l_Int1, ip_Int2, l_Int2
      Real*8  x

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      iCount=0
      Do AB=1,NumberOfAtomPairs
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         nuv=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
         M=LDF_nBasAux_Pair(AB)
         l_Int1=nuv*M
         If (l_Int1.gt.0) Then
            l_Int2=l_Int1
            Call GetMem('Int1','Allo','Real',ip_Int1,l_Int1)
            Call GetMem('Int2','Allo','Real',ip_Int2,l_Int2)
            Call LDF_SetIndxG(AB)
            Call LDF_ComputeIntegrals_uvJ(AB,l_Int1,Work(ip_Int1))
            Call LDF_UnsetIndxG()
            Call LDF_ComputeIntegrals_uvJ_2P(AB,AB,l_Int2,Work(ip_Int2))
            Call dAXPY_(l_Int1,-1.0d0,Work(ip_Int2),1,Work(ip_Int1),1)
            x=sqrt(dDot_(l_Int1,Work(ip_Int1),1,
     &                         Work(ip_Int1),1))/dble(l_Int1)
            Call GetMem('Int2','Free','Real',ip_Int2,l_Int2)
            Call GetMem('Int1','Free','Real',ip_Int1,l_Int1)
         Else
            x=0.0d0
         End If
         If (.not.Silent) Then
            Write(6,'(A,I9,A,I9,A,1P,D15.6)')
     &      'Atom pair',AB,'   Dimension: ',nuv*M,
     &      '   Normalized diff. norm uvJ-uvJ_2P=',x
         End If
         If (x.gt.Tol) Then
            iCount=iCount+1
         End If
      End Do

      LDF_DbguvJ=iCount.eq.0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkfilemgrcom()
! this routine makes names of temp files

use ccsd_global, only: filename, filerst, maxfiles, minfiles
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nhelp

!3 def filenames

do nhelp=minfiles,maxfiles
  write(filename(nhelp),'("Temp",I2.2)') nhelp
end do
filename(10) = 'INTAB'
filename(11) = 'INTA1'
filename(12) = 'INTA2'
filename(13) = 'INTA3'
filename(14) = 'INTA4'
filename(15) = 'INTSTA'
filename(16) = filerst

return

end subroutine mkfilemgrcom

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine KE_exchange(N1,N2,lant,t,u,OPT,HEXC)
c this function computes the exchange+covalent contributions to Hamiltonian of a given Lanthanide
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)           :: N1, N2, OPT, lant
      Real(kind=8), intent(in)     :: t, u
      Complex(kind=8), intent(out) :: HEXC(N1,N1,N2,N2)
c local variables
      Integer       :: i1,j1,i2,j2,JLn,SR,ms1,ns1,ms2,ns2
      Real(kind=8) :: HEXC1(N1,N1,N2,N2)
      Real(kind=8) :: test1, test2
      Real(kind=8) :: Jfinal(0:7, -5:5, 0:1, -1:1)
      Real(kind=8) :: WCG ! Clebsh_Gordan Coefficeints
      External      :: WCG
#include "stdalloc.fh"
#include "jcoeff.fh"

      HEXC1=0.0_wp
      HEXC=(0.0_wp,0.0_wp)
      JLn=N1-1  !nexch(iLn)-1
      SR =N2-1  !nexch(iRad)-1
      Do i1=1,N1
      ms1=-(N1-1)+2*(i1-1)
      Do j1=1,N1
      ns1=-(N1-1)+2*(j1-1)
      Do i2=1,N2
      ms2=-(N2-1)+2*(i2-1)
      Do j2=1,N2
      ns2=-(N2-1)+2*(j2-1)


      If(OPT.eq.1) Then ! FULL calculation

      Do iLS=1,4
         Do iJ=1,17
            Do iK=0,7
               Do ika=-5,5
                  Do iP=0,1
                     Do iph=-1,1
                     test1=0.0_wp
                     test1=WCG(JLn, JLn, 2*iK, 0,  JLn, JLn )
     &                    *WCG( SR,  SR, 2*iP, 0,   SR,  SR )
                     test2=0.0_wp
                     test2=WCG(JLn,  ns1, 2*iK, 2*ika, JLn,  ms1 )
     &                    *WCG( SR,  ns2, 2*iP, 2*iph,  SR,  ms2 )
                     If(test1.eq.0.0_wp) Go To 104
                     If(test2.eq.0.0_wp) Go To 104

                   HEXC1(i1,j1,i2,j2) = HEXC1(i1,j1,i2,j2)
     &                           + t*t/(u+dE(lant,iLS,iJ))
     &                           * Jx(lant,iLS,iJ, iK,ika,iP,iph)
     &                           * WCG(JLn, ns1, 2*iK, 2*ika, JLn, ms1 )
     &                           * WCG( SR, ns2, 2*iP, 2*iph,  SR, ms2 )
     &                           / WCG(JLn, JLn, 2*iK,     0, JLn, JLn )
     &                           / WCG( SR,  SR, 2*iP,     0,  SR,  SR )

 104                 continue
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do


      If ( (i1.eq.1).and.(j1.eq.1).and.(i2.eq.1).and.(j2.eq.1) ) Then
      Jfinal=0.0_wp
      Write(6,'(A)') 'Jfinal(iK,ika,iP,iph):'
      Do iK=0,7
         Do ika=-5,5
            Do iP=0,1
               Do iph=-1,1

                  Do iLS=1,4
                     Do iJ=1,17

                 Jfinal(iK,ika,iP,iph) = Jfinal(iK,ika,iP,iph)
     &                           + t*t/(u+dE(lant,iLS,iJ))
     &                           * Jx(lant,iLS,iJ, iK,ika,iP,iph)

                     End Do
                  End Do
      If ( ABS(Jfinal(iK,ika,iP,iph)).gt.1.d-13 ) Then
         Write(6,'(4i4,4x,2E24.14)') iK,ika,iP,iph,
     &                              Jfinal(iK,ika,iP,iph),
     &                              Jfinal(iK,ika,iP,iph)*0.123984193_wp
      End If
               End Do
            End Do
         End Do
      End Do
      End If

      Else If(OPT.eq.2) Then ! 1/U approximation

      Do iLS=1,4
         Do iJ=1,17
            Do iK=0,7
               Do ika=-5,5
                  Do iP=0,1
                     Do iph=-1,1
                     test1=0.0_wp
                     test1=WCG(JLn, JLn, 2*iK, 0,  JLn, JLn )
     &                    *WCG( SR,  SR, 2*iP, 0,   SR,  SR )
                     test2=0.0_wp
                     test2=WCG(JLn,  ns1, 2*iK, 2*ika, JLn,  ms1 )
     &                    *WCG( SR,  ns2, 2*iP, 2*iph,  SR,  ms2 )
                     If(test1.eq.0.0_wp) Go To 105
                     If(test2.eq.0.0_wp) Go To 105

                   HEXC1(i1,j1,i2,j2) = HEXC1(i1,j1,i2,j2)
     &                           + t*t/u
     &                           * Jx(lant,iLS,iJ, iK,ika,iP,iph)
     &                           * WCG(JLn, ns1, 2*iK, 2*ika, JLn, ms1 )
     &                           * WCG( SR, ns2, 2*iP, 2*iph,  SR, ms2 )
     &                           / WCG(JLn, JLn, 2*iK,     0, JLn, JLn )
     &                           / WCG( SR,  SR, 2*iP,     0,  SR,  SR )
 105                 continue
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do

      End If !( OPT )

      ! kind=8, complex double precision
      HEXC(i1,j1,i2,j2) = cmplx(HEXC1(i1,j1,i2,j2),0.0_wp, wp)

      End Do !j2
      End Do !i2
      End Do !j1
      End Do !i1

      Call mma_deallocate(Jx)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
!===================================================
!  have computed vlop0 and vlop1, link to extern space
!  (ss, st, ts, tt)
!  lin type of the act-ext space node
!  lri index of ar
!  lrj index of bl
!====================================================
      subroutine arbl_act_c_link_ext_ab(lin,lri,lrj)

      if(lin.eq.1) call ar_bl_ext_ss(lri,lrj,1)
      if(lin.eq.2) call ar_bl_ext_st(lri,lrj,1)
      if(lin.eq.3) call ar_bl_ext_ts(lri,lrj,1)
      if(lin.eq.11) call ar_bl_ext_tt(lri,lrj,1)
      if(lin.eq.10) call ar_br_sv_ext_br_ar(lri,lrj)
      if(lin.eq.17) call ar_br_tv_ext_br_ar(lri,lrj)

      return
      end

!===================================================
!  have computed vlop0 and vlop1, link to extern space
!  (ss, st, ts, tt)
!  lin type of the act-ext space node
!  lri index of drl
!====================================================
      subroutine drl_act_c_link_ext_ab(lin,lri)

      if(lin.eq.1) call drl_ss_ext(lri)
      if(lin.eq.2) call drl_st_ext(lri)
      if(lin.eq.3) call drl_ts_ext(lri)
      if(lin.eq.11) call drl_tt_ext(lri)

      return
      end

      subroutine drl_act_c_link_ext_ab_sum(lin,lri,lrj)

      if(lin.eq.1) call drl_ss_sum(lri,lrj)
      if(lin.eq.11) call drl_tt_sum(lri,lrj)

      return
      end

      subroutine sd_ar_act_bl_sgt0(lin,lra)
!sd(6-3) a&r(13)c'(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd3 =w0_sd(3)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd3 =-w0sd3
        endif
!sd(6-3) a&r(13)c'(22)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd3
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd3
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1)
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1)
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1)
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1)
        enddo
      enddo

      return
      end

!======================================================
!extern space -bl-ar or -br-al (ss,st,ts,tt)
!double occupied space ar-bl-  (ss)
!active space -c"-
!spin great than 0
!======================================================
      subroutine ss_arbl_act_c_ext_ab_sgt0(lin)
!-------------------------------------------------------------------
!ss(1-1)  ar(01)-bl(32)-        act -c"-
!ss(1-3)  ar(13)-bl(20)-        act -c"-
!ss(1-6)  (11)-ar(23)-bl(32)-   act -c"-
!ss(1-7)  ar(13)-c'(21)-bl(32)- act -c"-
!ss(1-8)  ar(13)-c'(22)-bl(31)- act -c"-
!ss(1-9)  ar(23)-c'(11)-bl(32)- act -c"-
!ss(1-11) ar(13)-bl(31)-c"(22)- act -c"-
!ss(1-12) ar(13)-bl(32)-c"(21)- act -c"-
!ss(1-13) ar(23)-bl(31)-c"(12)- act -c"-
!-------------------------------------------------------------------
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w0ss1=w0_ss(1)
          w1ss1=w1_ss(1)
          w0ss3=w0_ss(3)
          w1ss3=w1_ss(3)
          w0ss6=w0_ss(6)
          w1ss6=w1_ss(6)
          w0ss7=w0_ss(7)
          w1ss7=w1_ss(7)
          w0ss8=w0_ss(8)
          w1ss8=w1_ss(8)
          w0ss9=w0_ss(9)
          w1ss9=w1_ss(9)
          w0ss11=w0_ss(11)
          w1ss11=w1_ss(11)
          w0ss12=w0_ss(12)
          w1ss12=w1_ss(12)
          w0ss13=w0_ss(13)
          w1ss13=w1_ss(13)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0ss1=-w0ss1
            w1ss1=-w1ss1
            w0ss3=-w0ss3
            w1ss3=-w1ss3
            w0ss6=-w0ss6
            w1ss6=-w1ss6
            w0ss7=-w0ss7
            w1ss7=-w1ss7
            w0ss8=-w0ss8
            w1ss8=-w1ss8
            w0ss9=-w0ss9
            w1ss9=-w1ss9
            w0ss11=-w0ss11
            w1ss11=-w1ss11
            w0ss12=-w0ss12
            w1ss12=-w1ss12
            w0ss13=-w0ss13
            w1ss13=-w1ss13
          endif
          if(jml.eq.1.and.lmij.eq.jmr) then
!ss(1-1)  ar(01)-bl(32)-        act -c"-
            iwdl=just(lri,lri)
            iwdr=just(lrj,lri)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss1
            enddo
            call arbl_act_c_link_ext_ab(lin,lri,lrj)
          endif
          if(jmr.eq.1.and.lmij.eq.jml) then
!ss(1-3)  ar(13)-bl(20)-        act -c"-
            iwdl=just(lrj,lri)
            iwdr=just(lrj,lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss3
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss3
            enddo
            call arbl_act_c_link_ext_ab(lin,lri,lrj)
          endif
!ss(1-6)  (11)-ar(23)-bl(32)-   act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss6
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss6
          enddo
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmi,lmk)
            lmkj=mul_tab(lmj,lmk)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
!ss(1-7)  ar(13)-c'(21)-bl(32)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0ss7
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ss7
          enddo
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmj,lmk)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
!ss(1-8)  ar(13)-c'(22)-bl(31)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0ss8
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ss8
          enddo
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
!ss(1-9)  ar(23)-c'(11)-bl(32)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0ss9
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ss9
          enddo
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
!ss(1-11) ar(13)-bl(31)-c"(22)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss11
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss11
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
!ss(1-12) ar(13)-bl(32)-c"(21)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss12
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmj,lmk)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
!ss(1-13) ar(23)-bl(31)-c"(12)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss13
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss13
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmi,lmk)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
        enddo
      enddo

      return
      end


!======================================================
!extern space -bl-ar or -br-al (ss,st,ts,tt)
!double occupied space drl-  (ss)
!active space -c"-
!spin great than 0
!======================================================
      subroutine ss_drl_act_c_ext_ab_sgt0(lin)
!ss(1-16) (11)-drl(22)-         act -c"-
!ss(1-18) drl(11)-c"(22)-       act -c"-
!ss(1-19) drl(12)-c"(21)-       act -c"-
!ss(1-20) (11)-drl(33)-c"(22)-  act -c"-
!ss(1-20) drl(33)-c"(11)-c"(22)-act -c"-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml.or.lmij.ne.jmr) cycle
          iwdl=just(lrj,lri)
          iwdr=iwdl
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
!ss(1-16) (11)-drl(22)-         act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(16)
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(16)
          enddo
          call drl_act_c_link_ext_ab(lin,lrj)
!ss(1-18) drl(11)-c"(22)-       act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(18)
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(18)
          enddo
          call drl_act_c_link_ext_ab(lin,lri)
!ss(1-20) (11)-drl(33)-c"(22)-  act -c"-
!ss(1-20) drl(33)-c"(11)-c"(22)-act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(20)
            vplp_w1(mpl)=0.d0
          enddo
          do lrk=1,norb_dz
            if(lrk.eq.lri) cycle
            if(lrk.eq.lrj) cycle
            call drl_act_c_link_ext_ab(lin,lrk)
          enddo
        enddo
      enddo

      return
      end

!======================================================
!extern space -bl-ar or -br-al (ss,st,ts,tt)
!double occupied space drl-  (st)
!active space -c"-
!spin great than 0
!======================================================
      subroutine st_drl_act_c_ext_ab_sgt0(lin)
!st(2-7) drl(12)-c"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jmr.ne.jml) return
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(jml.ne.lmij) cycle
        iwdl=just(lrj,lri)
        iwdr=just(lri,lrj)      !
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        do mpl=1,mtype
          vplp_w0(mpl)=0.d0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1_st(7)
        enddo
        call drl_act_c_link_ext_ab(lin,lri)
      enddo
      enddo

      return
      end

!======================================================
!extern space -bl-ar or -br-al (ss,st,ts,tt)
!double occupied space ar-bl-  (st)
!active space -c"-
!spin great than 0
!======================================================
      subroutine st_arbl_act_c_ext_ab_sgt0(lin)
!st(2-3) ar(13)-c'(22)-bl(32)-
!st(2-3) ar(13)-bl(32)-c'(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w1st3=w1_st(3)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w1st3=-w1st3
          endif
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!st(2-3) ar(13)-c'(22)-bl(32)-
              iwdl=just(lrk,lri)
              iwdr=just(lrk,lrj)      !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=-vplpnew_w1(mpl)*w1st3
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo

          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!st(2-3) ar(13)-bl(32)-c'(22)-
              iwdl=just(lrk,lri)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=vplpnew_w1(mpl)*w1st3
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
        enddo
      enddo

      return
      end

      subroutine stt_arbl_act_c_ext_ab_sgt1(lin)
!st1(4-1) ar(01)-bl(31)-
!st1(4-2) (11)ar(23)-bl(31)-
!st1(4-3) ar(13)-c'(21)-bl(31)-
!st1(4-3) ar(13)-bl(31)-c"(21)-
!st1(4-4) ar(23)-c'(11)-bl(31)-
!st1(4-4) ar(23)-bl(31)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        w1st1=w1_st1(1)
        w1st2=w1_st1(2)
        w1st3=w1_st1(3)
        w1st4=w1_st1(4)
        if(mod(lrj-lri,2).eq.0) then
          w1st1=-w1st1
          w1st2=-w1st2
          w1st3=-w1st3
          w1st4=-w1st4
        endif
!st1(4-1) ar(01)-bl(31)-
        if(jml.eq.1.and.jmr.eq.mul_tab(lmi,lmj)) then
          iwdl=just(lri,lri)
          iwdr=just(lri,lrj)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1st1
          enddo
          call arbl_act_c_link_ext_ab(lin,lri,lrj)
        endif
!st1(4-2) (11)ar(23)-bl(31)-
        do lrk=norb_frz+1,lri-1
           lmk=lsm_inn(lrk)
      if(jml.ne.mul_tab(lmk,lmi).or.jmr.ne.mul_tab(lmk,lmj)) cycle
           iwdl=just(lri,lrk)
           iwdr=just(lrk,lrj)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           do mpl=1,mtype
             vplp_w0(mpl)=0.d0
             vplp_w1(mpl)=vplpnew_w1(mpl)*w1st2
           enddo
           call arbl_act_c_link_ext_ab(lin,lri,lrj)
        enddo
!st1(4-3) ar(13)-c'(21)-bl(31)-
         do lrk=lri+1,lrj-1
           lmk=lsm_inn(lrk)
      if(jml.eq.mul_tab(lmi,lmk).and.jmr.eq.mul_tab(lmk,lmj)) then
           iwdl=just(lrk,lri)
           iwdr=just(lrk,lrj)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           do mpl=1,mtype
             vplp_w0(mpl)=0.d0
             vplp_w1(mpl)=-vplpnew_w1(mpl)*w1st3
           enddo
           call arbl_act_c_link_ext_ab(lin,lri,lrj)
!st1(4-4) ar(23)-c'(11)-bl(31)-
           iwdl=just(lri,lrk)
           iwdr=just(lrk,lrj)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           do mpl=1,mtype
             vplp_w0(mpl)=0.d0
             vplp_w1(mpl)=-vplpnew_w1(mpl)*w1st4
           enddo
           call arbl_act_c_link_ext_ab(lin,lri,lrj)
      endif
      enddo
      do lrk=lrj+1,norb_dz
         lmk=lsm_inn(lrk)
!st1(4-4) ar(23)-bl(31)-c"(11)-
      if(jml.eq.mul_tab(lmi,lmk).and.jmr.eq.mul_tab(lmj,lmk)) then
           iwdl=just(lri,lrk)
           iwdr=just(lrj,lrk)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           do mpl=1,mtype
             vplp_w0(mpl)=0.d0
             vplp_w1(mpl)=vplpnew_w1(mpl)*w1st4
           enddo
           call arbl_act_c_link_ext_ab(lin,lri,lrj)
!st1(4-3) ar(13)-bl(31)-c"(21)-
           iwdl=just(lrk,lri)
           iwdr=just(lrj,lrk)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           do mpl=1,mtype
             vplp_w0(mpl)=0.d0
             vplp_w1(mpl)=vplpnew_w1(mpl)*w1st3
           enddo
           call arbl_act_c_link_ext_ab(lin,lri,lrj)
      endif
         enddo
      enddo
      enddo

      return
      end

      subroutine tts_arbl_act_c_ext_ab_sgt1(lin)
!t1s(5-1)   ar(13)-bl(10)-
!t1s(5-2)   ar(13)-bl(32)-
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        w1ts1=w1_t1s(1)
        w1ts2=w1_t1s(2)
        w1ts3=w1_t1s(3)
        w1ts4=w1_t1s(4)
        if(mod(lrj-lri,2).eq.0) then
          w1ts1=-w1ts1
          w1ts2=-w1ts2
          w1ts3=-w1ts3
          w1ts4=-w1ts4
        endif
!t1s(5-1)   ar(13)-bl(10)-
        if(jml.eq.mul_tab(lmi,lmj).and.jmr.eq.1) then
          iwdl=just(lri,lrj)
          iwdr=just(lrj,lrj)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts1
          enddo
          call arbl_act_c_link_ext_ab(lin,lri,lrj)
        endif
!t1s(5-2)   (11)ar(13)-bl(32)-
        do mpl=1,mtype
          vplp_w0(mpl)=0.d0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts2
        enddo
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
      if(jml.ne.mul_tab(lmk,lmi).or.jmr.ne.mul_tab(lmk,lmj)) cycle
          iwdl=just(lrk,lri)
          iwdr=just(lrj,lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call arbl_act_c_link_ext_ab(lin,lri,lrj)
        enddo
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
        do mpl=1,mtype
          vplp_w0(mpl)=0.d0
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ts2
        enddo
        do lrk=lri+1,lrj-1
           lmk=lsm_inn(lrk)
      if(jml.ne.mul_tab(lmi,lmk).or.jmr.ne.mul_tab(lmk,lmj)) cycle
          iwdl=just(lri,lrk)
          iwdr=just(lrj,lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call arbl_act_c_link_ext_ab(lin,lri,lrj)
        enddo
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
        do mpl=1,mtype
          vplp_w0(mpl)=0.d0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts3
        enddo
        do lrk=lrj+1,norb_dz
          lmk=lsm_inn(lrk)
      if(jml.ne.mul_tab(lmi,lmk).or.jmr.ne.mul_tab(lmj,lmk)) cycle
          iwdl=just(lri,lrk)
          iwdr=just(lrk,lrj)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call arbl_act_c_link_ext_ab(lin,lri,lrj)
        enddo
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
        do mpl=1,mtype
          vplp_w0(mpl)=0.d0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts4
        enddo
        do lrk=lrj+1,norb_dz
          lmk=lsm_inn(lrk)
      if(jml.ne.mul_tab(lmi,lmk).or.jmr.ne.mul_tab(lmj,lmk)) cycle
          iwdl=just(lri,lrk)
          iwdr=just(lrj,lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call arbl_act_c_link_ext_ab(lin,lri,lrj)
        enddo
      enddo
      enddo

      return
      end

      subroutine tts_drl_act_c_ext_ab_sgt1(lin)
!t1s(5-5)   (11)drl(12)-
!t1s(5-6)   drl(11)-c"(12)-
!t1s(5-7)   drl(12)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jml.ne.jmr) return
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(jml.ne.lmij) cycle
!t1s(5-5)   (11)drl(12)-
        iwdl=just(lri,lrj)
        iwdr=just(lrj,lri)      !
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        do mpl=1,mtype
          vplp_w0(mpl)=0.d0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1_t1s(5)
        enddo
        call drl_act_c_link_ext_ab(lin,lrj)
!t1s(5-6)   drl(11)-c"(12)-
        iwdl=just(lri,lrj)
        iwdr=just(lrj,lri)      !
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        do mpl=1,mtype
          vplp_w0(mpl)=0.d0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1_t1s(6)
        enddo
        call drl_act_c_link_ext_ab(lin,lri)
!t1s(5-7)   drl(12)-c"(11)-
        iwdl=just(lri,lrj)
        iwdr=just(lri,lrj)      !
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        do mpl=1,mtype
          vplp_w0(mpl)=0.d0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1_t1s(7)
        enddo
        call drl_act_c_link_ext_ab(lin,lri)
      enddo
      enddo

      return
      end

      subroutine sdd_ar_act_bl_sgt0(lin,lra)
!sd1(8-1)    ar(01)-
!sd1(8-2)    (11)ar(23)-
!sd1(8-3)    ar(13)-c'(21)-
!sd1(8-4)    ar(23)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1 =w0_sd1(1)
        w0sd2 =w0_sd1(2)
        w0sd3 =w0_sd1(3)
        w0sd4 =w0_sd1(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd2 =-w0sd2
          w0sd3 =-w0sd3
          w0sd4 =-w0sd4
        endif
        if(jml.eq.1.and.lmi.eq.jmr) then
!sd1(8-1)    ar(01)-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1)
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1)
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1)
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1)
        endif
!sd1(8-2)    (11)ar(23)-
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
        enddo
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1)
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1)
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1)
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1)

        enddo
!sd1(8-3)    ar(13)-c'(21)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd3
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd3
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1)
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1)
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1)
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1)
        enddo
!sd1(8-4)    ar(23)-c'(11)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1)
          if(lin.eq.2) call ar_bl_ext_st(lri,lra,1)
          if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1)
          if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1)
        enddo
      enddo
      return
      end

      subroutine tttt_arbl_act_c_ext_ab_sgt0(lin)
!t1t1(12-1)  ar(13)-bl(31)-
!t1t1(12-1)  ar(13)-c'(11)-bl(31)-
!t1t1(12-1)  ar(13)-bl(31)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w0tt1=w0_t1t1(1)
          w1tt1=w1_t1t1(1)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0tt1=-w0tt1
            w1tt1=-w1tt1
          endif
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0tt1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1tt1
          enddo
!t1t1(12-1)  (11)ar(13)-bl(31)-
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)       !
              iwdr=just(lrk,lrj)      !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
!t1t1(12-1)  ar(13)-bl(31)-c"(11)-
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)     !
              iwdr=just(lrj,lrk)      !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=-vplp_w0(mpl)
            vplp_w1(mpl)=-vplp_w1(mpl)
          enddo
!t1t1(12-1)  ar(13)-c'(11)-bl(31)-
          do lrk=lri+1,lrj-1
           lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)     !
              iwdr=just(lrk,lrj)     !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
        enddo
      enddo

      return
      end


      subroutine tttt_drl_act_c_ext_ab_sgt0(lin)
!t1t1(12-2)  drl(11)-
!t1t1(12-2)  drl(11)-c"(11)-
!t1t1(12-3)  drl(33)-
!t1t1(12-3)  drl(33)-c"(11)-
!t1t1(12-3)  drl(33)-c"(11)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      w0tt2=w0_t1t1(2)
      w1tt2=w1_t1t1(2)
      w0tt3=w0_t1t1(3)
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml.or.lmij.ne.jmr) cycle
!t1t1(12-2)  drl(11)-
!t1t1(12-2)  drl(11)-c"(11)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0tt2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1tt2
            enddo
            iwdl=just(lri,lrj)   !
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call drl_act_c_link_ext_ab(lin,lri)
            call drl_act_c_link_ext_ab(lin,lrj)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0tt3
              vplp_w1(mpl)=0.d0
            enddo
!t1t1(12-3)  drl(33)-
!t1t1(12-3)  drl(33)-c"(11)-
!t1t1(12-3)  drl(33)-c"(11)-c"(11)-
c      do lrk=1,norb_dz
c        if(lrk.eq.lri) cycle
c        if(lrk.eq.lrj) cycle
c        call drl_ss_ext(lrk)
c     enddo
            call drl_act_c_link_ext_ab_sum(lin,lri,lrj)
          enddo
        enddo

      return
      end

      subroutine ttdd_ar_act_bl_sgt1(lin,lra)
!t1d1(15-1)  ar(13)-
!t1d1(15-1)  ar(13)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_t1d1(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
!-------------------------------------------------------------------
!t1d1(15-1)  (11)ar(13)-
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)                   !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1)
            if(lin.eq.2) call ar_bl_ext_st(lri,lra,1)
            if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1)
            if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1)
          enddo
!-------------------------------------------------------------------
!t1d1(15-1)  ar(13)-c'(11)-
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)        !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            if(lin.eq.1) call ar_bl_ext_ss(lri,lra,1)
            if(lin.eq.2) call ar_bl_ext_st(lri,lra,1)
            if(lin.eq.3) call ar_bl_ext_ts(lri,lra,1)
            if(lin.eq.11) call ar_bl_ext_tt(lri,lra,1)
          enddo
        enddo

      return
      end

      subroutine d1d1_arbl_act_c_ext_ab_sgt0(lin)
!d1d1(20-1) ar(13)-bl(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(jml.ne.lmi.and.jmr.ne.lmj) cycle
          w0dd1=w0_d1d1(1)
          w1dd1=w1_d1d1(1)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0dd1=-w0dd1
            w1dd1=-w1dd1
          endif
          if(lmi.eq.jml.and.lmj.eq.jmr) then
!d1d1(20-1) ar(13)-bl(31)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo
            iwdl=jud(lri)
            iwdr=jud(lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call arbl_act_c_link_ext_ab(lin,lri,lrj)
          endif
        enddo
      enddo

      return
      end

      subroutine d1d1_drl_act_c_ext_ab_sgt0(lin)
!d1d1(20-2) drl(11)-
!d1d1(20-3) drl(33)-
!d1d1(20-3) drl(33)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jml.ne.jmr) return
      w0dd2=w0_d1d1(2)
      w1dd2=w1_d1d1(2)
      w0dd3=w0_d1d1(3)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle
!d1d1(20-2) drl(11)-
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd2
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd2
        enddo
        iwdl=jud(lri)
        iwdr=iwdl
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call drl_act_c_link_ext_ab(lin,lri)
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd3
          vplp_w1(mpl)=0.d0
        enddo
!d1d1(20-3) drl(33)-
!d1d1(20-3) drl(33)-c"(11)-
      do lrk=1,norb_dz
        if(lrk.eq.lri) cycle
        call drl_act_c_link_ext_ab(lin,lrk)
      enddo
!        call drl_act_c_link_ext_ab_sum(lin,lri,0)
      enddo

      return
      end

      subroutine dd1_arbl_act_c_ext_ab_sgt0(lin)
!dd1(21) ar(23)-bl(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
          w0dd1=w0_dd1
          w1dd1=w1_dd1
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0dd1=-w0dd1
            w1dd1=-w1dd1
          endif
          if(lmi.eq.jml.and.lmj.eq.jmr) then
!dd1(21)ar(23)-bl(31)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo
            iwdl=jud(lri)
            iwdr=jud(lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call arbl_act_c_link_ext_ab(lin,lri,lrj)
          endif
        enddo
      enddo

      return
      end

      subroutine d1d_arbl_act_c_ext_ab_sgt0(lin)
!d1d(22-1)   ar(13)-bl(32)-
!d1d(22-2)   drl(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
          w0dd1=w0_d1d(1)
          w1dd1=w1_d1d(1)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0dd1=-w0dd1
            w1dd1=-w1dd1
          endif
          if(lmi.eq.jml.and.lmj.eq.jmr) then
!d1d(22-1)   ar(13)-bl(32)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo
            iwdl=jud(lri)
            iwdr=jud(lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call arbl_act_c_link_ext_ab(lin,lri,lrj)
          endif
        enddo
      enddo

      return
      end

      subroutine d1d_drl_act_c_ext_ab_sgt0(lin)
!d1d(22-2)   drl(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jmr.ne.jml) return
      do lri=norb_frz+1,norb_dz
         lmi=lsm_inn(lri)
         if(jml.ne.lmi) cycle
         do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0_d1d(2)
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1_d1d(2)
         enddo
         iwdl=jud(lri)
         iwdr=jud(lri)
         do mpl=1,mhlp
           iwal=lpnew_lwei(mpl)
           iwar=lpnew_rwei(mpl)
           lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
           lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
         enddo
         call drl_act_c_link_ext_ab(lin,lri)
      enddo

      return
      end

      subroutine d1v_ar_act_bl_ext_ab_sgt0(lin,lra)
!d1v(24-1)  ar(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1)w0dv1=-w0dv1
!d1v(24-1)  ar(13)-
        iwdl=jud(lri)
        iwdr=0
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0dv1
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0dv1
        enddo
        call arbl_act_c_link_ext_ab(lin,lri,lra)
      enddo

      return
      end

      subroutine ar_br_stv_link_ext_brar(lin,lri,lrj)
        if(lin.eq.17) call ar_br_tv_ext_br_ar(lri,lrj)
        if(lin.eq.10) call ar_br_sv_ext_br_ar(lri,lrj)
      end

      subroutine sd_ar_act_br_sgt0(lin,lra)
!sd(6-3) a&r(13)c'(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd3=w0_sd(3)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0sd3=-w0sd3

!sd(6-3) a&r(13)c'(22)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd3
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd3
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_stv_link_ext_brar(lin,lri,lra)
        enddo
      enddo

      return
      end

      subroutine sdd_ar_act_br_sgt0(lin,lra)
!sd1(8-1)    ar(01)-
!sd1(8-2)    (11)ar(23)-
!sd1(8-3)    ar(13)-c'(21)-
!sd1(8-4)    ar(23)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1 =w0_sd1(1)
        w0sd2 =w0_sd1(2)
        w0sd3 =w0_sd1(3)
        w0sd4 =w0_sd1(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd2 =-w0sd2
          w0sd3 =-w0sd3
          w0sd4 =-w0sd4
        endif
        if(jml.eq.1.and.lmi.eq.jmr) then
!sd1(8-1)    ar(01)-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_stv_link_ext_brar(lin,lri,lra)
        endif
!sd1(8-2)    (11)ar(23)-
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
        enddo
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_stv_link_ext_brar(lin,lri,lra)
        enddo
!sd1(8-3)    ar(13)-c'(21)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd3
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd3
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_stv_link_ext_brar(lin,lri,lra)
        enddo
!sd1(8-4)    ar(23)-c'(11)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_stv_link_ext_brar(lin,lri,lra)
        enddo
      enddo

      return
      end

      subroutine ttdd_ar_act_br_sgt1(lin,lra)
!t1d1(15-1)  ar(13)-
!t1d1(15-1)  ar(13)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_t1d1(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
!-------------------------------------------------------------------
!t1d1(15-1)  (11)ar(13)-
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)                   !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_br_stv_link_ext_brar(lin,lri,lra)
          enddo
!-------------------------------------------------------------------
!t1d1(15-1)  ar(13)-c'(11)-
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)        !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_br_stv_link_ext_brar(lin,lri,lra)
          enddo
        enddo

      return
      end

      subroutine ttv_arbr_act_c_stv_sgt1(lin)
!t1v(18) ar(13)-br(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
!-------------------------------------------------------------------
          iwdl=just(lri,lrj)     !
          iwdr=0
          ni=mod(lrj-lri,2)
          w1=w1_t1v
          if(ni.eq.0) w1=-w1
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_stv_link_ext_brar(lin,lri,lrj)
        enddo
      enddo

      return
      end

      subroutine ss_s_drl_act_c_ext_ab_sgt0(lin)
!ss(1-19) drl(12)-c"(21)-       act -c"-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jml.ne.jmr) return
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
!ss(1-19) drl(12)-c"(21)-       act -c"-
          iwdl=just(lrj,lri)
          iwdr=just(lri,lrj)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(19)
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(19)
          enddo
          call drl_act_c_link_ext_ab(lin,lri)
        enddo
      enddo

      return
      end

      subroutine ds_arblbr_act_c1_sgt0(lin )
!=======================================================================
!ds(7-2) ar(23)-bl(31)-br(32)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmr) cycle
!ds(7-2) ar(23)-bl(31)-br(32)-
          do lrd=norb_frz+1,lri-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jml) cycle
            ijk=lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
            w1ds =w1_ds(2)
            ni=mod(norb_dz-lrj+lri-lrd,2)
            if(ni.eq.0) w1ds =-w1ds

            iwdr=just(lrj,lri)
            iwdl=jud(lrd)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ds
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          enddo
        enddo
      enddo

      return
      end

      subroutine sdd_ar_act_dlr_sgt0(lin,lra)
!sd1(8-1)    ar(01)-
!sd1(8-2)    (11)ar(23)-
!sd1(8-3)    ar(13)-c'(21)-
!sd1(8-4)    ar(23)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        w0sd1=w0_sd1(1)
        w1sd1=w1_sd1(1)
        w0sd2=w0_sd1(2)
        w1sd2=w1_sd1(2)
        w0sd3=w0_sd1(3)
        w1sd3=w1_sd1(3)
        w0sd4=w0_sd1(4)
        w1sd4=w1_sd1(4)
        if(mod(norb_dz-lri,2).eq.1) then
          w0sd1=-w0sd1
          w1sd1=-w1sd1
          w0sd2=-w0sd2
          w1sd2=-w1sd2
          w0sd3=-w0sd3
          w1sd3=-w1sd3
          w0sd4=-w0sd4
          w1sd4=-w1sd4
        endif
!sd1(8-1)    ar(01)-
        if(jml.eq.1.and.jmr.eq.lmi) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd1
          enddo
          call ar_drl_ext_al_new(lin,lri,lra)
        endif
!sd1(8-2)    (11)ar(23)-
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd2
        enddo
        do lrj=norb_frz+1,lri-1
          lmj=lsm_inn(lrj)
          if(jml.ne.mul_tab(lmi,lmj).or.jmr.ne.lmj) cycle
          iwdl=just(lri,lrj)
          iwdr=jud(lrj)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_drl_ext_al_new(lin,lri,lra)
        enddo
!sd1(8-3)    ar(13)-c'(21)-
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          if(jml.ne.mul_tab(lmi,lmj).or.jmr.ne.lmj) cycle
          iwdl=just(lrj,lri)
          iwdr=jud(lrj)
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd3
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w1sd3
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_drl_ext_al_new(lin,lri,lra)
!sd1(8-4)    ar(23)-c'(11)-
          iwdl=just(lri,lrj)
          iwdr=jud(lrj)
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w1sd4
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_drl_ext_al_new(lin,lri,lra)
        enddo
      enddo

      return
      end

      subroutine tts_arbl_act_c_sgt1(lin,lra)
!=======================================================================
!tts(5) a&r-b^l-  act -b&l ............................................
!t1s(5-1)   ar(13)-bl(10)-
!t1s(5-2)   ar(13)-bl(32)-
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        w1ts1=w1_t1s(1)
        w1ts2=w1_t1s(2)
        w1ts3=w1_t1s(3)
        w1ts4=w1_t1s(4)
        if(mod(lrj-lri,2).eq.0) then
          w1ts1=-w1ts1
          w1ts2=-w1ts2
          w1ts3=-w1ts3
          w1ts4=-w1ts4
        endif
        ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz) !???
        intpos=intind_ijka(ijk)                         !???
!t1s(5-1)   ar(13)-bl(10)-
        if(jmr.eq.1.and.jml.eq.lmij) then
          iwdl=just(lri,lrj)
          iwdr=just(lrj,lrj)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts1
          enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1)
        endif
!t1s(5-2)   (11)ar(13)-bl(32)-
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
         if(jmr.eq.mul_tab(lmk,lmi).and.jml.eq.mul_tab(lmk,lmj)) then
            iwdl=just(lrk,lri)
            iwdr=just(lrj,lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts2
            enddo
            call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          endif
        enddo
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
        do lrk=lri+1,lrj-1
          lmk=lsm_inn(lrk)
          if(jmr.eq.mul_tab(lmi,lmk).and.jml.eq.mul_tab(lmk,lmj)) then
            iwdl=just(lri,lrk)
            iwdr=just(lrj,lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts2
            enddo
            call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          endif
        enddo
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
        do lrk=lrj+1,norb_dz
          lmk=lsm_inn(lrk)
          if(jmr.eq.mul_tab(lmi,lmk).and.jml.eq.mul_tab(lmj,lmk)) then
            iwdl=just(lri,lrk)
            iwdr=just(lrk,lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts3
            enddo
            call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
            iwdl=just(lri,lrk)
            iwdr=just(lrj,lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts4
            enddo
            call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          endif
        enddo
      enddo
      enddo

      return
      end

      subroutine tts_arbl_act_br_sgt1(lin,lra)
!=======================================================================
!tts(5) a&r-b^l-  act -b&l ............................................
!t1s(5-1)   ar(13)-bl(10)-
!t1s(5-2)   ar(13)-bl(32)-
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        w1ts1=w1_t1s(1)
        w1ts2=w1_t1s(2)
        w1ts3=w1_t1s(3)
        w1ts4=w1_t1s(4)
        if(mod(lrj-lri,2).eq.0) then
          w1ts1=-w1ts1
          w1ts2=-w1ts2
          w1ts3=-w1ts3
          w1ts4=-w1ts4
        endif
        ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz) !???
        intpos=intind_ijka(ijk)                         !???
!t1s(5-1)   ar(13)-bl(10)-
        if(jmr.eq.1.and.jml.eq.lmij) then
          iwdl=just(lri,lrj)
          iwdr=just(lrj,lrj)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts1
          enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1)
        endif
!t1s(5-2)   (11)ar(13)-bl(32)-
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
         if(jml.eq.mul_tab(lmk,lmi).and.jmr.eq.mul_tab(lmk,lmj)) then
            iwdl=just(lrk,lri)
            iwdr=just(lrj,lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts2
            enddo
            call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          endif
        enddo
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
        do lrk=lri+1,lrj-1
          lmk=lsm_inn(lrk)
          if(jml.eq.mul_tab(lmi,lmk).and.jmr.eq.mul_tab(lmk,lmj)) then
            iwdl=just(lri,lrk)
            iwdr=just(lrj,lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ts2
            enddo
            call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          endif
        enddo
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
        do lrk=lrj+1,norb_dz
          lmk=lsm_inn(lrk)
          if(jml.eq.mul_tab(lmi,lmk).and.jmr.eq.mul_tab(lmj,lmk)) then
            iwdl=just(lri,lrk)
            iwdr=just(lrk,lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts3
            enddo
            call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
            iwdl=just(lri,lrk)
            iwdr=just(lrj,lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts4
            enddo
            call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          endif
        enddo
      enddo
      enddo

      return
      end

      subroutine sd_ar_act_dlr_sgt0(lin,lra)
!sd(6-3) a&r(13)c'(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd3 =w0_sd(3)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.0) then
          w0sd3 =-w0sd3
        endif
!------------------------------------------------------------------
!sd(6-3) a&r(13)c'(22)-
        do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd3
           vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd3
        enddo
        do lrk=lri+1,norb_dz
           lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
           iwdl=just(lrk,lri)
           iwdr=jud(lrk)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           call ar_drl_ext_al_new(lin,lri,lra)
        enddo
      enddo

      return
      end

      subroutine sdd_ar_act_blbr_sgt0(lin,jk)
!sdd(8-1) a&r(01)-
!sdd(8-2) (11)a&(23)-
!sdd(8-3) a&r(13)c'(21)-
!sdd(8-4) a&r(23)c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        w0sd1=w0_sd1(1)
        w1sd1=w1_sd1(1)
        w0sd2=w0_sd1(2)
        w1sd2=w1_sd1(2)
        w0sd3=w0_sd1(3)
        w1sd3=w1_sd1(3)
        w0sd4=w0_sd1(4)
        w1sd4=w1_sd1(4)
        if(mod(norb_dz-lri,2).eq.1) then
          w0sd1=-w0sd1
          w1sd1=-w1sd1
          w0sd2=-w0sd2
          w1sd2=-w1sd2
          w0sd3=-w0sd3
          w1sd3=-w1sd3
          w0sd4=-w0sd4
          w1sd4=-w1sd4
        endif
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
!sdd(8-1) a&r(01)-
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
         call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
        endif
!------------------------------------------------------------------
!sdd(8-2) c(11)a&(23)-
         do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
           vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
         enddo
         do lrk=norb_frz+1,lri-1
           lmk=lsm_inn(lrk)
           if(lmk.ne.jmr.or.jml.ne.mul_tab(lmk,lmi)) cycle
           iwdl=just(lri,lrk)
           iwdr=jud(lrk)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
         enddo
!-------------------------------------------------------------------
!sdd(8-3) a&r(13)c'(21)-
         do lrk=lri+1,norb_dz
           lmk=lsm_inn(lrk)
           if(lmk.ne.jmr.or.jml.ne.mul_tab(lmi,lmk)) cycle
           iwdl=just(lrk,lri)
           iwdr=jud(lrk)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           do mpl=1,mtype
             vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd3
             vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd3
           enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
!sdd(8-4) a&r(23)c'(11)-
           iwdl=just(lri,lrk)
           iwdr=jud(lrk)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           do mpl=1,mtype
             vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
             vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
           enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1 )
         enddo
      enddo

      return
      end

      subroutine sd_ar_act_blbr_sgt0(lin,jk)
!sd(6-3) a&r(13)c'(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
        w0sd3 =w0_sd(3)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.0) then
          w0sd3 =-w0sd3
        endif
!-------------------------------------------------------------------
!sd(6-3) a&r(13)c'(22)-
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd3
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd3
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1)
        enddo
      enddo

      return
      end

      subroutine sdd_ar_act_c_sd_ext_sgt0(lin)
!sd1(8-1)    ar(01)-
!sd1(8-2)    (11)ar(23)-
!sd1(8-3)    ar(13)-c'(21)-
!sd1(8-4)    ar(23)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(jml.ne.1.or.jmr.ne.lmi) cycle
        w0sd1=w0_sd1(1)
        w1sd1=w1_sd1(1)
        if(mod(norb_dz-lri,2).eq.1) then
          w0sd1=-w0sd1
          w1sd1=-w1sd1
        endif
        iwdl=just(lri,lri)
        iwdr=jud(lri)
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd1
        enddo
        if(lin.eq.6) then
          call ar_sd_ext_ar(26,lri,lrj,isma)
          call ar_sd_ext_rest(lri)
        endif
        if(lin.eq.13) then
          call ar_td_ext_ar(26,lri,lrj,isma)
          call ar_td_ext_rest(lri)
        endif
        if(lin.eq.23) then
          call ar_dv_ext_ar(26,isma,lri,lrj)   !ar_dv
        endif
      enddo

       do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle

         if(lmi.eq.jmr) then
            iwdl=just(lrj,lri)
            iwdr=jud(lri)
            w0sd2=w0_sd1(2)
!            w1sd2=w0_sd1(2)
            ni=mod(norb_dz-lrj,2)
            if(ni.eq.1) then
!              w1sd2=-w1sd2
              w0sd2=-w0sd2
            endif
!sd1(8-2)    (11)ar(23)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            if(lin.eq.6) then
              call ar_sd_ext_ar(25,lrj,lri,isma)
              call ar_sd_ext_rest(lrj)
            endif
            if(lin.eq.13) then
              call ar_td_ext_ar(25,lrj,lri,isma)
              call ar_td_ext_rest(lrj)
            endif
           if(lin.eq.23) then
              call ar_dv_ext_ar(25,isma,lrj,lri)   !ar_dv
            endif
          endif
!sd1(8-3)    ar(13)-c'(21)-
!sd1(8-4)    ar(23)-c'(11)-
          if(lmj.ne.jmr) cycle
         w0sd3=w0_sd1(3)
          w1sd3=w1_sd1(3)
          w0sd4=w0_sd1(4)
          w1sd4=w1_sd1(4)
          ni=mod(norb_dz-lri,2)
          if(ni.eq.0) then
            w0sd3=-w0sd3
            w1sd3=-w1sd3
            w0sd4=-w0sd4
            w1sd4=-w1sd4
          endif
          if(lmj.eq.jmr) then
            iwdl=just(lrj,lri)
            iwdr=jud(lrj)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd3
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd3
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            if(lin.eq.6) then
              call ar_sd_ext_ar(29,lri,lrj,isma)
              call ar_sd_ext_rest(lri)
            endif
            if(lin.eq.13) then
              call ar_td_ext_ar(29,lri,lrj,isma)
              call ar_td_ext_rest(lri)
            endif
           if(lin.eq.23) then
              call ar_dv_ext_ar(29,isma,lri,lrj)   !ar_dv
            endif
            iwdl=just(lri,lrj)
            iwdr=jud(lrj)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd4
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd4
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            if(lin.eq.6) then
              call ar_sd_ext_ar(57,lri,lrj,isma)
              call ar_sd_ext_rest(lri)
            endif
            if(lin.eq.13) then
              call ar_td_ext_ar(57,lri,lrj,isma)
              call ar_td_ext_rest(lri)
            endif
           if(lin.eq.23) then
              call ar_dv_ext_ar(57,isma,lri,lrj)   !ar_dv
            endif
          endif
        enddo
      enddo

      return
      end

      subroutine ttdd_ar_act_c_ttdd_ext_sgt1(lin)
!t1d1(15-1)  ar(13)-
!t1d1(15-1)  ar(13)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=norb_frz+1,lri-1
        lmj=lsm_inn(lrj)
        if(jml.ne.mul_tab(lmi,lmj).or.jmr.ne.lmj) cycle
        w0td1=w0_t1d1(1)
        w1td1=w1_t1d1(1)
        if(mod(norb_dz-lri,2).eq.1) then
          w0td1=-w0td1
          w1td1=-w1td1
        endif
        do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1td1
        enddo
!t1d1(15-1)  (11)ar(13)-
        iwdl=just(lrj,lri)
        iwdr=jud(lrj)
        do mpl=1,mhlp
           iwal=lpnew_lwei(mpl)
           iwar=lpnew_rwei(mpl)
           lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
           lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        if(lin.eq.6) then
          call ar_sd_ext_ar(43,lri,lrj,isma)
          call ar_sd_ext_rest(lri)
        endif
        if(lin.eq.13) then
          call ar_td_ext_ar(43,lri,lrj,isma)
          call ar_td_ext_rest(lri)
        endif
        if(lin.eq.23) then
          call ar_dv_ext_ar(43,isma,lri,lrj)
        endif
      enddo
!t1d1(15-1)  ar(13)-c'(11)-
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        if(jml.ne.mul_tab(lmi,lmj).or.jmr.ne.lmj) cycle
        w0td1=w0_t1d1(1)
        w1td1=w1_t1d1(1)
        if(mod(norb_dz-lri,2).eq.1) then
          w0td1=-w0td1
          w1td1=-w1td1
        endif
        do mpl=1,mtype
           vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
           vplp_w1(mpl)=-vplpnew_w1(mpl)*w1td1
        enddo
        iwdl=just(lri,lrj)
        iwdr=jud(lrj)
        do mpl=1,mhlp
           iwal=lpnew_lwei(mpl)
           iwar=lpnew_rwei(mpl)
           lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
           lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        if(lin.eq.6) then
          call ar_sd_ext_ar(46,lri,lrj,isma)
          call ar_sd_ext_rest(lri)
        endif
        if(lin.eq.13) then
          call ar_td_ext_ar(46,lri,lrj,isma)
          call ar_td_ext_rest(lri)
        endif
        if(lin.eq.23) then
          call ar_dv_ext_ar(46,isma,lri,lrj)
        endif
      enddo
      enddo

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CopyUniqueAtomPairs(irc)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Copy unique atom pair data
C
      Implicit None
      Integer irc
#include "ldf_atom_pair_info.fh"

      Integer iAtomPair

      ! Init return code
      irc=0

      ! Copy
      Do iAtomPair=1,NumberOfAtomPairs
         Call LDF_CopyUniqueAtomPair(iAtomPair)
      End Do

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CopyUniqueAtomPair(iAtomPair)
      Implicit None
      Integer iAtomPair
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_AtomPair_DiagDim, LDF_DiskAddressOfC
      External LDF_AtomPair_DiagDim, LDF_DiskAddressOfC

      Character*8 Label

      Integer jAtomPair
      Integer ip, l

      Integer i,j
      Integer ip_D, AP_Unique, AP_1CLinDep, AP_2CFunctions
      ip_D(i)=iWork(ip_AP_Diag-1+i)
      AP_Unique(i)=iWork(ip_AP_Unique-1+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Get unique atom pair
      jAtomPair=AP_Unique(iAtomPair)

      ! Only copy if iAtomPair is not the unique one
      If (jAtomPair.ne.iAtomPair) Then
         ! Copy 1CLinDep
         iWork(ip_AP_1CLinDep+2*(iAtomPair-1))=AP_1CLinDep(1,jAtomPair)
         If (AP_1CLinDep(1,iAtomPair).gt.0) Then
            Write(Label,'(A,I5.5)') '1CL',iAtomPair-1
            l=3*AP_1CLinDep(1,iAtomPair)
            Call GetMem(Label,'Allo','Inte',ip,l)
            iWork(ip_AP_1CLinDep+2*(iAtomPair-1)+1)=ip
            Call iCopy(l,iWork(AP_1CLinDep(2,jAtomPair)),1,
     &                   iWork(AP_1CLinDep(2,iAtomPair)),1)
         End If
         ! Copy 2CFunctions
         iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=AP_2CFunctions(1,
     &                                                        jAtomPair)
         If (AP_2CFunctions(1,iAtomPair).gt.0) Then
            Write(Label,'(A,I5.5)') '2CF',iAtomPair-1
            l=4*AP_2CFunctions(1,iAtomPair)
            Call GetMem(Label,'Allo','Inte',ip,l)
            iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=ip
            Call iCopy(l,iWork(AP_2CFunctions(2,jAtomPair)),1,
     &                   iWork(AP_2CFunctions(2,iAtomPair)),1)
         End If
         ! Copy updated diagonal block
         l=LDF_AtomPair_DiagDim(iAtomPair)
         Call dCopy_(l,Work(ip_D(jAtomPair)),1,Work(ip_D(iAtomPair)),1)
         ! Copy disk address of coefficients
         iWork(ip_AP_DiskC-1+iAtomPair)=LDF_DiskAddressOfC(jAtomPair)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine SlvNt1(K_Lap,NTimes,Coeff,T)
!-----------------------------------------------------------------------
! Function : Newton-Raphson method (type 1)
!            obtain omega & alpha
!-----------------------------------------------------------------------

use ReMez_mod, only: IW
use Constants, only: One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: K_Lap, NTimes
real(kind=wp), intent(inout) :: Coeff(40)
real(kind=wp), intent(in) :: T(40)
integer(kind=iwp) :: I, I_Dim, IRes, Iter
real(kind=wp) :: A(40,40), CoeffOld(40), Eps0, Eps1, Theta, VV(40), W(40)
logical(kind=iwp) :: Dbg, Error
real(kind=wp), parameter :: THTMIN = 1.0e-4_wp, TOL = 1.0e-22_wp

Theta = One
Dbg = .false.
I_Dim = 2*K_Lap

outer: do Iter=1,NTimes
  IRes = 1
  call AltErr(K_Lap,Coeff,T,VV,Eps0)
  if (Eps0 > Tol) then
    call PtDiff(I_Dim,Coeff,T,A)

    if (Dbg) then
      write(IW,'(A)') 'Check values of derivatives'
      call Laplace_PRSQ(A,I_Dim,I_Dim,I_Dim)
    end if

    call SlvEqs(I_Dim,A,W,VV,Error)
    if (Dbg) then
      write(IW,*) 'Check solutions of equations',Error
      do I=1,I_Dim
        write(IW,*) I,W(I)
      end do
    end if
    if (Error) then
      CoeffOld(1:I_Dim) = Coeff(1:I_Dim)

      do
        Coeff(1:I_Dim) = CoeffOld(1:I_Dim)-Theta*W(1:I_Dim)
        call AltErr(K_Lap,Coeff,T,VV,Eps1)
        if (Eps1 < Eps0) then
          Theta = Two*Theta
          if (Theta > One) Theta = One
          cycle outer
        end if
        if (Theta < THTMIN) then
          cycle outer
        else
          Theta = Theta*Half
        end if
      end do
    end if
  end if
  IRes = 0
  if (IRes == 0) exit
end do outer

return

end subroutine SlvNt1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Giovanni Ghigo                                   *
************************************************************************
      Subroutine MkExSB31(iAddSB,LenSB,
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV, iAddSBt,LenSBt)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden & Torino University, Italy         *
*           February 2005                                              *
*----------------------------------------------------------------------*
* Purpuse:  Generation of the SubBlock(3,1) (p,q secondary,inactive)   *
*           two-electron integral matrix for each i,j occupied couple. *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Logical SameLx

*   - SubBlock 3 1
      LenSB = nSsh(iSymA) * nIsh(iSymB)
      Call GetMem('SB','Allo','Real',iAddSB,LenSB)
      If (iSymA.EQ.iSymB .and. iSymI.EQ.iSymJ .and. iI.EQ.iJ) then
*       SB 3,1 = (SB 1,3)+
        Call Trnsps(nSsh(iSymB),nIsh(iSymA),Work(iAddSBt),Work(iAddSB))
        Return
      EndIf

*     Build Lx
      Call GetMem('Lx','Allo','Real',iAddLx0,nSsh(iSymA)*numV)
      LxType=0
      iIx=0
      SameLx=.False.
      Call MkL3(iSymA,iSymI,iI,numV, LxType,iIx, iAddLx0,SameLx)

*     Build Ly
      Call GetMem('Ly','Allo','Real',iAddLy0,nIsh(iSymB)*numV)
      Call MkL1(iSymB,iSymJ,iJ,numV, LxType,iIx, iAddLy0,SameLx)

*     Generate the SubBlock
      Call DGEMM_('N','T',nIsh(iSymB),nSsh(iSymA),numV,1.0d0,
     &    Work(iAddLy0),nIsh(iSymB), Work(iAddLx0),nSsh(iSymA),
     &                     0.0d0,Work(iAddSB),nIsh(iSymB) )

      Call GetMem('Ly','Free','Real',iAddLy0,nIsh(iSymB)*numV)
      Call GetMem('Lx','Free','Real',iAddLx0,nSsh(iSymA)*numV)

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(LenSBt)
      End

      Subroutine MkCouSB31(iAddSB,LenSB,
     &     iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden & Torino University, Italy         *
*           July 2005                                                  *
*----------------------------------------------------------------------*
* Purpuse:  Generation of the SubBlock(3,1) (p secondary, q inactive)  *
*           two-electron integral matrix for each i,j occupied couple. *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"

*   - SubBlock 3 1
      LenSB = nSsh(iSymA) * nIsh(iSymB)
      Call GetMem('SB','Allo','Real',iAddSB,LenSB)
      Call GetMem('SBt','Allo','Real',iAddSBt,LenSB)

*     Define Lab
      iAddAB = iMemTCVX(3,iSymA,iSymB,1)
      LenAB  = LenSB
CGG   ------------------------------------------------------------------
c      If(IfTest) then
c      Write(6,*)'     MkCouSB31: TCVB(',iSymA,',',iSymB,')'
c      Write(6,'(8F10.6)')(Work(iAddAB+k),k=0,LenAB*numV-1)
c      Call XFlush(6)
c      EndIf
CGG   ------------------------------------------------------------------

*     Build Lij
      LenLij = numV
      Call GetMem('Lij','Allo','Real',iAddLij,LenLij)
      Call MkLij(iSymI,iSymJ,iI,iJ,numV, iAddLij)

*     Generate the SubBlock
      Call DGEMM_('N','N',LenAB,1,numV,1.0d0,
     &    Work(iAddAB),LenAB, Work(iAddLij),LenLij,
     &                0.0d0,Work(iAddSBt),LenSB )
      Call Trnsps(nSsh(iSymA),nIsh(iSymB),Work(iAddSBt),Work(iAddSB))

      Call GetMem('Lij','Free','Real',iAddLij,LenLij)
      Call GetMem('SBt','Free','Real',iAddSBt,LenSB)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017,2020, Roland Lindh                                *
!***********************************************************************

subroutine Fix_FockOp(LuRd)
!***********************************************************************
!                                                                      *
!    Objective: To compute the fock operator for basis sets which do   *
!               not carry this information explicitly in the basis set *
!               file or are inline basis sets.                         *
!                                                                      *
!    The Fock operator is defined as F=\sum_{k,m} |k>e_{k,m}<m|.       *
!                                                                      *
! Called from: Input                                                   *
!                                                                      *
! Calling    : GetBS                                                   *
!                                                                      *
!     Author:  Roland Lindh (thanks to Ben Swerts)                     *
!                                                                      *
!     Modified for muons by R. Lindh January 2017                      *
!***********************************************************************

use Her_RW, only: nPrp
use Basis_Info, only: dbsc, nCnttp, Shells
use Sizes_of_Seward, only: S
use Gateway_Info, only: UnNorm, Do_FckInt, FNMC
use Isotopes, only: PTab
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Six, Eight, Ten, Twelve
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: LuRd
#include "itmax.fh"
#include "Molcas.fh"
integer(kind=iwp) :: BasisTypes(4), i, iAng, iAngMax_Proj, iAtom, iB, iBF, iC, iCmp_a, iCmp_r, iCnttp, iComp, iFerm, iFrom, ijB, &
                     ijC, ijTri, Indx, iShll, iShll_a, iShll_Proj_r, iShll_r, iSing, iTo, jB, jBF, jShll, kEval, Last, &
                     List(0:iTabMx), List_Add(0:iTabMx), List_AE(0:iTabMx), lSTDINP, mCnttp, MemNA, MmKnEP, MmMltp, naa, nBF, &
                     nCntrc_a, nCntrc_Proj, nCntrc_r, nCntrc_t, nHer, nOrdOp, nPrim_a, nPrim_r, nRemove, nSAA, nSAR, nSBB, nSCC, &
                     nScr1, nScr2, nScr3, nSRR
real(kind=wp) :: A(4), C_ik, C_jk, Charge_Actual, Charge_Effective, Check, D, e, e12i, qTest, Test_Charge, Tmp, xFactor, xMass
logical(kind=iwp) :: Do_Cycle, lPP, Try_Again
character(len=256) :: Basis_lib, Fname
character(len=180) :: Ref(2)
character(len=80) :: Bsl_, BSLbl
real(kind=wp), allocatable :: C(:,:), E_R(:), EVal(:), EVec(:,:), FockOp_t(:,:), FPrim(:,:), Hm1(:,:), KnE(:), NAE(:), Ovr(:,:), &
                              Ovrlp(:), S12i(:,:), S_AA(:), S_AR(:), SAA(:), SAR(:), Scr1(:), Scr2(:), Scr3(:), Temp(:,:), &
                              Tmp1(:), Tmp2(:), Tmp3(:)
character(len=180), allocatable :: STDINP(:) ! CGGn
character(len=*), parameter :: DefNm = 'basis_library'
real(kind=r8), external :: DDot_
external :: KnEPrm, MltPrm, NAPrm

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
nPrint(114) = 99
nPrint(116) = 99
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
lPP = .false.
do i=1,nCnttp
  lPP = lPP .or. (dbsc(i)%nPP /= 0)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate a dummy center. This is fine since we will only do
! 1-center overlap integrals here.

A(:) = Zero
call mma_allocate(STDINP,mxAtom*2,label='STDINP')

nOrdOp = 2
iComp = 1

nPrp = max(4,S%nMltpl)

List(:) = 0
List_AE(:) = 0
BasisTypes(:) = 0
lSTDINP = 0

! Loop over all valence shell with a non-funtional FockOp

mCnttp = nCnttp   ! to be restored at the end
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
do iCnttp=1,mCnttp
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
  iFerm = 1
  if (dbsc(iCnttp)%fMass /= One) iFerm = 2

  if (dbsc(iCnttp)%FOp .and. (dbsc(iCnttp)%Charge == Zero)) then
    do iAng=0,dbsc(iCnttp)%nVal-1
      iShll_a = dbsc(iCnttp)%iVal+iAng
      Shells(iShll_a)%FockOp(:,:) = Zero
    end do
  end if

  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag .or. (dbsc(iCnttp)%nFragType > 0) .or. dbsc(iCnttp)%FOp) then
    cycle
  end if

  ! Special treatment for muonic basis sets

  if (iFerm == 2) then

    iShll = S%Mx_Shll-1
    jShll = iShll

    ! The Fock operator will simply be the one-particle
    ! Hamiltonian (kinetic + nuclear-attraction operator)

    xFactor = One/dbsc(iCnttp)%fMass
    if (FNMC) then
      iAtom = dbsc(iCnttp)%AtmNr
      ! Get the atom mass in au (me=1)
      xMass = dbsc(iCnttp)%CntMass
      ! Substract the electron mass to get the nuclear mass.
      xMass = xMass-real(iAtom,kind=wp)
      xfactor = xfactor+One/xMass
    end if

    do iAng=0,dbsc(iCnttp)%nVal-1

      iShll_a = dbsc(iCnttp)%iVal+iAng
      nPrim_a = Shells(iShll_a)%nExp
      if (nPrim_a == 0) cycle
      nCntrc_a = Shells(iShll_a)%nBasis_C
      iCmp_a = (iAng+1)*(iAng+2)/2
      if (Shells(iShll_a)%Prjct) iCmp_a = 2*iAng+1
      naa = nTri_Elem1(iAng)*nTri_Elem1(iAng)
      nScr1 = max(nPrim_a,nPrim_a)*max(nCntrc_a,nCntrc_a)*naa
      nScr2 = max(nCntrc_a,nCntrc_a)**2*naa
      call mma_allocate(Scr1,nScr1,Label='Scr1')
      call mma_allocate(Scr2,nScr2,Label='Scr2')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Compute the kinetic integrals

      nOrdOp = 2
      nSAA = nCntrc_a**2*naa

      call KnEMmP(nHer,MmKnEP,iAng,iAng,nOrdOp)
      nScr3 = nPrim_a**2*MmKnEP
      call mma_allocate(Scr3,nScr3,Label='Scr1')

      call mma_Allocate(KnE,NSAA,Label='KnE')
      call One_Int(KnEPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,Scr1,nScr1,Scr2,nScr2,naa,KnE,nSAA,iShll_a,nPrim_a,Shells(iShll_a)%Exp, &
                   nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,iShll_a,nPrim_a,Shells(iShll_a)%Exp,nCntrc_a, &
                   Shells(iShll_a)%Cff_c(1,1,1),iCmp_a)
      call mma_deallocate(Scr3)
#     ifdef _DEBUGPRINT_
      call DScal_(nCntrc_a**2*iCmp_a**2,xFactor,KnE,1)
      call RecPrt('Kinetric Energy Integrals',' ',KnE,nCntrc_a**2,iCmp_a**2)
      call DScal_(nCntrc_a**2*iCmp_a**2,One/xFactor,KnE,1)
#     endif
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Compute the nuclear-attraction integrals

      nOrdOp = 0
      A(4) = real(iCnttp,kind=wp) ! Dirty tweak
      nSBB = nCntrc_a**2*naa
      call mma_Allocate(NAE,nSBB,Label='NAE')

      call NAMem(nHer,MemNA,iAng,iAng,nOrdOp)
      nScr3 = nPrim_a**2*MemNA
      call mma_allocate(Scr3,nScr3,Label='Scr3')

      call One_Int(NAPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,Scr1,nScr1,Scr2,nScr2,naa,NAE,nSBB,iShll_a,nPrim_a,Shells(iShll_a)%Exp, &
                   nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,iShll_a,nPrim_a,Shells(iShll_a)%Exp,nCntrc_a, &
                   Shells(iShll_a)%Cff_c(1,1,1),iCmp_a)
      call mma_deallocate(Scr3)
#     ifdef _DEBUGPRINT_
      call RecPrt('Nuclear-attraction Integrals',' ',NAE,nCntrc_a**2,iCmp_a**2)
#     endif
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Add together the kinetic and nuclear-attraction

      call DaXpY_(nCntrc_a**2*iCmp_a**2,xFactor,KnE,1,NAE,1)
      call mma_deallocate(KnE)

      ! Change to proper order (nCntrc_a * iCmp_a)

      call mma_allocate(Hm1,nCntrc_a**2,iCmp_a**2,Label='Hm1')
      call Reorder_GW(NAE,Hm1,nCntrc_a,nCntrc_a,iCmp_a,iCmp_a)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Compute the overlap integrals

      nOrdOp = 0
      nSCC = nCntrc_a**2*naa
      call mma_allocate(Ovrlp,nSCC,Label='Ovrlp')

      call MltMmP(nHer,MmMltp,iAng,iAng,nOrdOp)
      nScr3 = nPrim_a**2*MmMltp
      call mma_allocate(Scr3,nScr3,Label='Scr3')

      call One_Int(MltPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,Scr1,nScr1,Scr2,nScr2,naa,Ovrlp,nSCC,iShll_a,nPrim_a,Shells(iShll_a)%Exp, &
                   nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,iShll_a,nPrim_a,Shells(iShll_a)%Exp,nCntrc_a, &
                   Shells(iShll_a)%Cff_c(1,1,1),iCmp_a)
      call mma_deallocate(Scr3)
#     ifdef _DEBUGPRINT_
      call RecPrt('Overlap Integrals',' ',Ovrlp,nCntrc_a**2,iCmp_a**2)
#     endif

      ! Change to proper order (nCntrc_a * iCmp_a)

      nBF = nCntrc_a*iCmp_a
      call mma_allocate(Ovr,nBF,nBF,Label='Ovr')
      call Reorder_GW(Ovrlp,Ovr,nCntrc_a,nCntrc_a,iCmp_a,iCmp_a)
      call mma_deallocate(Ovrlp)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Now we need to convert it to the Fock operator!
      !
      ! Solve F C = e S C
      !
      ! S^(-1/2) F S^(-1/2) S^(1/2) C = e S^(1/2) C
      ! Set F' = S^(-1/2) F S^(-1/2)
      !     C' = S^(1/2) C
      !
      ! Solve F' C' = e C' , generate C = S^-(1/2) C'

      call mma_Allocate(S12i,nBF,nBF,Label='S')
      S12i(:,:) = Zero

      ! 1) Compute the eigenvectors and eigenvalues of the overlap matrix

      call mma_allocate(EVal,nBF*(nBF+1)/2,Label='EVal')
      call mma_allocate(EVec,nBF,nBF,Label='EVec')
      EVec(:,:) = Zero
      do iBF=1,nBF
        EVec(iBF,iBF) = One
        do jBF=1,iBF
          ijTri = (iBF-1)*iBF/2+jBF
          EVal(ijTri) = Ovr(iBF,jBF)
        end do
      end do
      call mma_deallocate(Ovr)
      call NIDiag_new(EVal,EVec,nBF,nBF)

      ! 2) Construct S^(1/2) and S^(-1/2)

      do kEval=1,nBF
        e = EVal(kEval*(kEval+1)/2)
        e12i = One/sqrt(e)
        do iBF=1,nBF
          C_ik = EVec(iBF,kEVal)
          do jBF=1,nBF
            C_jk = EVec(jBF,kEVal)
            S12i(iBF,jBF) = S12i(iBF,jBF)+C_ik*e12i*C_jk
          end do
        end do
      end do

      ! 3) Form F' =  S^(-1/2) F S^(-1/2)

      call mma_allocate(FPrim,nBF,nBF,Label='FPrim')
      FPrim(:,:) = Zero
      call mma_allocate(Temp,nBF,nBF,Label='Temp')
      call DGEMM_('N','N',nBF,nBF,nBF,One,S12i,nBF,Hm1,nBF,Zero,Temp,nBF)
      call DGEMM_('N','N',nBF,nBF,nBF,One,Temp,nBF,S12i,nBF,Zero,FPrim,nBF)

      ! 4) Compute C' and the eigenvalues

      EVec(:,:) = Zero
      do iBF=1,nBF
        EVec(iBF,iBF) = One
        do jBF=1,iBF
          ijTri = (iBF-1)*iBF/2+jBF
          EVal(ijTri) = FPrim(iBF,jBF)
        end do
      end do
      call mma_deallocate(Temp)
      call mma_deallocate(FPrim)
      call NIDiag_new(EVal,EVec,nBF,nBF)

      ! 5) Form C = S^(-1/2) C'

      call mma_allocate(C,nBF,nBF,Label='C')
      C(:,:) = Zero
      call DGEMM_('N','N',nBF,nBF,nBF,One,S12i,nBF,EVec,nBF,Zero,C,nBF)
#     ifdef _DEBUGPRINT_
      call RecPrt('Cs for F',' ',C,nBF,nBF)
#     endif

      ! 6) Form the matrix representation of the Fock operator

      call mma_deallocate(Hm1)
      call mma_allocate(Hm1,nBF,nBF,Label='Hm1')
      Hm1(:,:) = Zero
      do kEval=1,nBF
        e = EVal(kEval*(kEval+1)/2)
        do iBF=1,nBF
          C_ik = C(iBF,kEVal)
          do jBF=1,nBF
            C_jk = C(jBF,kEVal)
            Hm1(iBF,jBF) = Hm1(iBF,jBF)+C_ik*e*C_jk
          end do
        end do
      end do
      call mma_deallocate(C)

      call Reorder_GW(Hm1,NAE,nCntrc_a,iCmp_a,nCntrc_a,iCmp_a)
      call mma_deallocate(Hm1)

      ! Make result isotropic and distribute

      do iB=1,nCntrc_a
        do jB=1,nCntrc_a
          ijB = (jB-1)*nCntrc_a+iB
          Tmp = Zero
          do iC=1,iCmp_a
            ijC = (iC-1)*iCmp_a+iC
            iFrom = (ijC-1)*nCntrc_a**2+ijB
            Tmp = Tmp+NAE(iFrom)
          end do
          Shells(iShll_a)%FockOp(iB,jB) = Tmp/real(iCmp_a,kind=wp)
        end do
      end do
      call mma_deallocate(NAE)
#     ifdef _DEBUGPRINT_
      call RecPrt('Actual Fock operator',' ',Shells(iShll_a)%FockOp,nCntrc_a,nCntrc_a)
#     endif
      call mma_deallocate(EVal)
      call mma_deallocate(EVec)
      call mma_deallocate(S12i)
      call mma_deallocate(Scr1)
      call mma_deallocate(Scr2)
    end do

    dbsc(iCnttp)%FOp = .true.
    cycle
  end if

  ! create a new basis set index (temporary)

  nCnttp = mCnttp+1
  if (nCnttp > Mxdbsc) then
    call WarningMessage(2,'Fix_FockOp: Increase Mxdbsc')
    call Abend()
  end if

  ! create the temporary basis set label for this element to
  ! read the corresponding ANO-RCC basis set.

  BSLbl = ' '
  BSLbl = PTab(dbsc(iCnttp)%AtmNr)

  if (BSLbl(1:1) == ' ') then
    BSLbl = BSLbl(2:2)//'.ANO-RCC.....'
  else
    BSLbl = BSLbl(1:2)//'.ANO-RCC.....'
  end if

  Last = len_trim(BSLbl)
  Indx = index(BSLbl,'/')

  Bsl_ = ' '
  if (Indx == 0) then
    call WhichMolcas(Basis_lib)
    if (Basis_lib(1:1) /= ' ') then
      ib = index(Basis_lib,' ')-1
      if (ib < 1) call SysAbendMsg('Read_ANO_RCC','Too long PATH to MOLCAS',' ')
      Fname = Basis_lib(1:ib)//'/basis_library'
    else
      Fname = DefNm
    end if
    Indx = Last+1
    Bsl_ = BSLbl
  else
    Fname = BSLbl(Indx+2:Last)
    if (Fname == ' ') then
      call WarningMessage(2,' No basis set library specified for BSLbl='//BSLbl//',Fname='//Fname)
      call Quit_OnUserError()
    end if
    Fname = adjustl(Fname)
    Bsl_ = BSLbl(1:Indx-1)
  end if

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*)
  write(u6,'(1X,A,I5,A,A)') 'Basis Set ',nCnttp,' Label: ',BSLbl(1:Indx-1)
  write(u6,'(1X,A,A)') 'Basis set is read from library:',Fname
# endif

  ! Let's get the reference basis set (ANO-RCC).

  iShll = S%Mx_Shll-1
  jShll = iShll
  call GetBS(Fname,Bsl_,iShll,Ref,UnNorm,LuRd,BasisTypes,STDINP,lSTDINP,.false.,.true.,' ')

  if (.not. dbsc(nCnttp)%FOp) then
    write(u6,*) 'Fix_FockOp: reference basis doesn''t contain a proper Fock operator'
    cycle
  end if
  Shells(jShll+1)%Transf = .false.
  Shells(jShll+1)%Prjct = .false.
  Shells(jShll+2)%Transf = .false.
  Shells(jShll+2)%Prjct = .false.
  dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal+dbsc(nCnttp)%nPrj+dbsc(nCnttp)%nSRO+dbsc(nCnttp)%nSOC+dbsc(nCnttp)%nPP
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Start processing shells of iCnttp and mCnttp. Loop only over
  ! the shells of iCnttp (mCnttp might be larger!)

  Try_Again = .true.
  List_Add(:) = 0

  Do_Cycle = .true.
  do while (Do_Cycle)
    Test_Charge = Zero
    do iAng=0,dbsc(iCnttp)%nVal-1

      ! Pointers to the actuall shell

      iShll_a = dbsc(iCnttp)%iVal+iAng
      nPrim_a = Shells(iShll_a)%nExp
      if (nPrim_a == 0) cycle
      nCntrc_a = Shells(iShll_a)%nBasis_C
      iCmp_a = (iAng+1)*(iAng+2)/2
      if (Shells(iShll_a)%Prjct) iCmp_a = 2*iAng+1

      ! Pointers to the reference shell

      iShll_r = dbsc(nCnttp)%iVal+iAng
      nPrim_r = Shells(iShll_r)%nExp
      if (nPrim_r == 0) then
        write(u6,*) 'GuessOrb option turned off!'
        dbsc(iCnttp)%FOp = .false.
        exit
      end if
      nCntrc_r = Shells(iShll_r)%nBasis_C
      iCmp_r = (iAng+1)*(iAng+2)/2
      if (Shells(iShll_r)%Prjct) iCmp_r = 2*iAng+1

      !                                                                *
      !*****************************************************************
      !                                                                *
      if (dbsc(iCnttp)%ECP) then
#       ifdef _DEBUGPRINT_
        if (lPP) then
          write(u6,*) 'Reference is ECP (Pseudo Potential)'
        else
          write(u6,*) 'Reference is ECP (Huzinaga type)'
        end if
        call RecPrt('Reference Exponents',' ',Shells(iShll_r)%Exp,1,nPrim_r)
        call RecPrt('Reference Coefficients',' ',Shells(iShll_r)%Cff_c(1,1,1),nPrim_r,nCntrc_r)
        call RecPrt('Reference Fock operator',' ',Shells(iShll_r)%FockOp,nCntrc_r,nCntrc_r)
#       endif
        call OrbType(dbsc(nCnttp)%AtmNr,List_AE,31)
        call ECP_Shells(dbsc(iCnttp)%AtmNr,List)
        if (lPP .or. (dbsc(iCnttp)%nM1 == 0)) then

          ! Pseud potential case

          nRemove = List_AE(iAng)-List(iAng)

        else

          ! Huzinaga type, remove according to the number of projected shells.

          iAngMax_Proj = dbsc(iCnttp)%nPrj
          if (iAng <= iAngMax_Proj) then
            iShll_Proj_r = dbsc(iCnttp)%iPrj+iAng
            nCntrc_Proj = Shells(iShll_Proj_r)%nBasis
            nRemove = nCntrc_Proj
          else
            nRemove = 0
          end if

          ! If too many try the default

          if (nRemove > nCntrc_r) then
            nRemove = List_AE(iAng)-List(iAng)
          end if

        end if ! lPP
#       ifdef _DEBUGPRINT_
        write(u6,*) 'nRemove=',nRemove
        write(u6,*) 'List_Add(iAng)=',List_Add(iAng)
#       endif
        nRemove = nRemove-List_Add(iAng)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'nRemove=',nRemove
#       endif
        Test_Charge = Test_Charge+real(2*(2*iAng+1)*nRemove,kind=wp)

        ! Update pointers in case of ECP

        ! Update the number of contracted functions of ref.
        nCntrc_t = nCntrc_r-nRemove
        ! Pick up relevant parts of the FockOp matrix of ref.
        call mma_allocate(FockOp_t,nCntrc_t,nCntrc_t)
        do i=1,nCntrc_t
          FockOp_t(:,i) = Shells(iShll_r)%FockOp(nRemove+1:nRemove+nCntrc_t,nRemove+i)
        end do
        nCntrc_r = nCntrc_t
      else
        nRemove = 0
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *

#     ifdef _DEBUGPRINT_
      call RecPrt('Actual Exponents',' ',Shells(iShll_a)%Exp,1,nPrim_a)
      call RecPrt('Actual Coefficients',' ',Shells(iShll_a)%Cff_c(1,1,1),nPrim_a,nCntrc_a)
      call RecPrt('Reference Exponents',' ',Shells(iShll_r)%Exp,1,nPrim_r)
      call RecPrt('Reference Coefficients',' ',Shells(iShll_r)%Cff_c(1,nRemove+1,1),nPrim_r,nCntrc_r)
      if (allocated(FockOp_t)) then
        call RecPrt('Reference Fock operator',' ',FockOp_t,nCntrc_r,nCntrc_r)
      else
        call RecPrt('Reference Fock operator',' ',Shells(iShll_r)%FockOp,nCntrc_r,nCntrc_r)
      end if
#     endif
      if (allocated(FockOp_t)) then
        Check = DDot_(nCntrc_r**2,FockOp_t,1,FockOp_t,1)
      else
        Check = DDot_(nCntrc_r**2,Shells(iShll_r)%FockOp,1,Shells(iShll_r)%FockOp,1)
      end if
      if ((Check == Zero) .or. (dbsc(iCnttp)%Charge == Zero)) then
        if (allocated(FockOp_t)) call mma_deallocate(FockOp_t)
        cycle
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
      naa = nTri_Elem1(iAng)*nTri_Elem1(iAng)
      nScr1 = max(nPrim_a,nPrim_r)*max(nCntrc_a,nCntrc_r)*naa
      nScr2 = max(nCntrc_a,nCntrc_r)**2*naa
      call mma_allocate(Scr1,nScr1,Label='Scr1')
      call mma_allocate(Scr2,nScr2,Label='Scr2')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Compute S_AA

      nOrdOp = 0
      nSAA = nCntrc_a**2*naa
      call mma_allocate(SAA,nSAA,Label='SAA')

      call MltMmP(nHer,MmMltp,iAng,iAng,nOrdOp)
      nScr3 = nPrim_a**2*MmMltp
      call mma_allocate(Scr3,nScr3,Label='Scr3')

      call One_Int(MltPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,Scr1,nScr1,Scr2,nScr2,naa,SAA,nSAA,iShll_a,nPrim_a,Shells(iShll_a)%Exp, &
                   nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,iShll_a,nPrim_a,Shells(iShll_a)%Exp,nCntrc_a, &
                   Shells(iShll_a)%Cff_c(1,1,1),iCmp_a)
      call mma_deallocate(Scr3)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Compute S_AR

      nOrdOp = 0
      nSAR = nCntrc_a*nCntrc_r*naa
      call mma_allocate(SAR,nSAR,Label='SAR')

      call MltMmP(nHer,MmMltp,iAng,iAng,nOrdOp)
      nScr3 = nPrim_a*nPrim_r*MmMltp
      call mma_allocate(Scr3,nScr3,Label='Scr3')

      call One_Int(MltPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,Scr1,nScr1,SCr2,nScr2,naa,SAR,nSAR,iShll_a,nPrim_a,Shells(iShll_a)%Exp, &
                   nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,iShll_r,nPrim_r,Shells(iShll_r)%Exp,nCntrc_r, &
                   Shells(iShll_r)%Cff_c(1,1+nRemove,1),iCmp_a)
      call mma_deallocate(Scr3)

      nSRR = nCntrc_r**2*naa
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Reorder and compute the inverse of SAA

      call mma_allocate(S_AA,nSAA,Label='S_AA')
      call Reorder_GW(SAA,S_AA,nCntrc_a,nCntrc_a,iCmp_a,iCmp_a)
#     ifdef _DEBUGPRINT_
      call RecPrt('Reordered SAA',' ',S_AA,nCntrc_a*iCmp_a,nCntrc_a*iCmp_a)
#     endif
      call MInv(S_AA,SAA,iSing,D,nCntrc_a*iCmp_a)
      call mma_deallocate(S_AA)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'iSing=',iSing
      write(u6,*) 'Det=',D
      call RecPrt('Inverse of SAA',' ',SAA,nCntrc_a*iCmp_a,nCntrc_a*iCmp_a)
#     endif

      ! Reorder SAR
      call mma_allocate(S_AR,nSAR,Label='S_AR')
      call Reorder_GW(SAR,S_AR,nCntrc_a,nCntrc_r,iCmp_a,iCmp_r)
      call mma_deallocate(SAR)
#     ifdef _DEBUGPRINT_
      call RecPrt('Reordered SAR',' ',S_AR,nCntrc_a*iCmp_a,nCntrc_r*iCmp_r)
#     endif

      ! Expand and reorder the reference fock operator

      call mma_allocate(E_R,nSRR,Label='E_R')
      call mma_allocate(Tmp1,nSRR,Label='Tmp1')
      Tmp1(:) = Zero
      if (allocated(FockOp_t)) then
        do iB=1,nCntrc_r
          do jB=1,nCntrc_r
            ijB = (jB-1)*nCntrc_r+iB
            do iC=1,iCmp_r
              ijC = (iC-1)*iCmp_r+iC
              iTo = (ijC-1)*nCntrc_r**2+ijB
              Tmp1(iTo) = FockOp_t(iB,jB)
            end do
          end do
        end do
      else
        do iB=1,nCntrc_r
          do jB=1,nCntrc_r
            ijB = (jB-1)*nCntrc_r+iB
            Tmp = Shells(iShll_r)%FockOp(iB,jB)
            do iC=1,iCmp_r
              ijC = (iC-1)*iCmp_r+iC
              iTo = (ijC-1)*nCntrc_r**2+ijB
              Tmp1(iTo) = Tmp
            end do
          end do
        end do
      end if
#     ifdef _DEBUGPRINT_
      call RecPrt('Expanded ER',' ',Tmp1,nCntrc_r*nCntrc_r,iCmp_r*iCmp_r)
#     endif
      call Reorder_GW(Tmp1,E_R,nCntrc_r,nCntrc_r,iCmp_r,iCmp_r)
#     ifdef _DEBUGPRINT_
      call RecPrt('Reordered ER',' ',E_R,nCntrc_r*iCmp_r,nCntrc_r*iCmp_r)
#     endif
      call mma_deallocate(Tmp1)

      ! Form (SAA)-1 SAR

      call mma_allocate(Tmp1,nSAR,Label='Tmp1')
      call DGEMM_('N','N',nCntrc_a*iCmp_a,nCntrc_r*iCmp_r,nCntrc_a*iCmp_a,One,SAA,nCntrc_a*iCmp_a,S_AR,nCntrc_a*iCmp_a,Zero,Tmp1, &
                  nCntrc_a*iCmp_a)
#     ifdef _DEBUGPRINT_
      call RecPrt('(SAA)^-1 SAR',' ',Tmp1,nCntrc_a*iCmp_a,nCntrc_r*iCmp_r)
#     endif
      call mma_deallocate(S_AR)

      ! Form (SAA)-1 SAR ER

      call mma_allocate(Tmp2,nSAR,Label='Tmp2')
      call DGEMM_('N','N',nCntrc_a*iCmp_a,nCntrc_r*iCmp_r,nCntrc_r*iCmp_r,One,Tmp1,nCntrc_a*iCmp_a,E_R,nCntrc_r*iCmp_r,Zero,Tmp2, &
                  nCntrc_a*iCmp_a)
#     ifdef _DEBUGPRINT_
      call RecPrt('(SAA)^-1 SAR ER',' ',Tmp2,nCntrc_a*iCmp_a,nCntrc_r*iCmp_r)
#     endif
      call mma_deallocate(E_R)

      ! Form (SAA)-1 SAR ER (SAR)^T (SAA)-1

      call DGEMM_('N','T',nCntrc_a*iCmp_a,nCntrc_a*iCmp_a,nCntrc_r*iCmp_r,One,Tmp2,nCntrc_a*iCmp_a,Tmp1,nCntrc_a*iCmp_a,Zero,SAA, &
                  nCntrc_a*iCmp_a)
#     ifdef _DEBUGPRINT_
      call RecPrt('EA',' ',SAA,nCntrc_a*iCmp_a,nCntrc_a*iCmp_a)
#     endif
      call mma_deallocate(Tmp2)
      call mma_deallocate(Tmp1)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Now we just need to reorder and put it into place!

      call mma_allocate(Tmp3,nSAA,Label='Tmp3')
      call Reorder_GW(SAA,Tmp3,nCntrc_a,iCmp_a,nCntrc_a,iCmp_a)
      call mma_deallocate(SAA)
#     ifdef _DEBUGPRINT_
      call RecPrt('Reordered EA',' ',Tmp3,nCntrc_a*nCntrc_a,iCmp_a*iCmp_a)
#     endif

      do iB=1,nCntrc_a
        do jB=1,nCntrc_a
          ijB = iB+(jB-1)*nCntrc_a
          Tmp = Zero
          do iC=1,iCmp_a
            ijC = iC+(iC-1)*iCmp_a
            iFrom = ijB+(ijC-1)*nCntrc_a**2
            Tmp = Tmp+Tmp3(iFrom)
          end do
          Shells(iShll_a)%FockOp(iB,jB) = Tmp/real(iCmp_a,kind=wp)
        end do
      end do
      if (allocated(FockOp_t)) call mma_deallocate(FockOp_t)
#     ifdef _DEBUGPRINT_
      call RecPrt('Actual Fock operator',' ',Shells(iShll_a)%FockOp,nCntrc_a,nCntrc_a)
#     endif
      call mma_deallocate(Tmp3)
      call mma_deallocate(Scr1)
      call mma_deallocate(Scr2)
      !                                                                *
      !*****************************************************************
      !                                                                *
    end do  ! iAng
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Deallocate the memory for the reference Fock operator

    do iShll_r=jShll+1,iShll
      if (allocated(Shells(iShll_r)%Exp)) call mma_deallocate(Shells(iShll_r)%Exp)
      Shells(iShll_r)%nExp = 0
      if (allocated(Shells(iShll_r)%FockOp)) call mma_deallocate(Shells(iShll_r)%FockOp)
      Shells(iShll_r)%nFockOp = 0
      if (allocated(Shells(iShll_r)%pCff)) call mma_deallocate(Shells(iShll_r)%pCff)
      if (allocated(Shells(iShll_r)%Cff_c)) call mma_deallocate(Shells(iShll_r)%Cff_c)
      if (allocated(Shells(iShll_r)%Cff_p)) call mma_deallocate(Shells(iShll_r)%Cff_p)
      Shells(iShll_r)%nExp = 0
      Shells(iShll_r)%nBasis = 0
    end do
    !                                                                  *
    !*******************************************************************
    !                                                                  *

    Charge_Actual = real(dbsc(iCnttp)%AtmNr,kind=wp)
    Charge_Effective = dbsc(iCnttp)%Charge
    qTest = Test_Charge-(Charge_Actual-Charge_Effective)
    !write(u6,*) 'qtest, Test_Charge = ',qtest,Test_Charge
    !write(u6,*) 'Charge_Actual,Charge_Effective = ',Charge_Actual,Charge_Effective
    if ((qTest == Zero) .or. (dbsc(iCnttp)%Charge == Zero)) then
      dbsc(iCnttp)%FOp = .true.
    else if (Try_Again) then
      if (qTest == Two) then
        ! s
        List_Add(0) = 1
      else if (qTest == Six) then
        ! p
        List_Add(1) = 1
      else if (qTest == Ten) then
        ! d
        List_Add(2) = 1
      else if (qTest == Eight) then
        ! s,p
        List_Add(0) = 1
        List_Add(1) = 1
      else if (qTest == Twelve) then
        ! s,d
        List_Add(0) = 1
        List_Add(2) = 1
      else if (qTest == 16.0_wp) then
        ! p,d
        List_Add(1) = 1
        List_Add(2) = 1
      else if (qTest == 18.0_wp) then
        ! s,p,d
        List_Add(0) = 1
        List_Add(1) = 1
        List_Add(2) = 1
      else if (qTest == 26.0_wp) then
        ! 2s,2p,d
        List_Add(0) = 2
        List_Add(1) = 2
        List_Add(2) = 1
      end if
      Try_Again = .false.
      cycle
    else
      write(u6,*) 'GuessOrb option turned off!'
      dbsc(iCnttp)%FOp = .false.
    end if
    Do_Cycle = .false.
  end do
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
end do ! iCnttp
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Restore the correct nCnttp value

nCnttp = mCnttp

#ifdef _INSANE_DEBUGPRINT_
nPrint(113) = 5
nPrint(114) = 5
nPrint(116) = 5
nPrint(122) = 5
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Check if we can activate the computation of FckInt!

Do_FckInt = .true.
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag .or. (dbsc(iCnttp)%nFragType > 0) .or. dbsc(iCnttp)%FOp) cycle

  Do_FckInt = Do_FckInt .and. dbsc(iCnttp)%FOp ! To be activated!

end do
call mma_deallocate(STDINP)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Fix_FockOp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RSCOPY(IRS1,IRS2)
!
! Purpose: copy red. set info from location IRS1 to IRS2.
!          Special action is taken with INDRED if IRS1=1 so that it
!          will point as expected for the "current" reduced set.

use Cholesky, only: iiBstR, iiBstRSh, IndRed, nnBstR, nnBstRSh, nnBstRT
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IRS1, IRS2
integer(kind=iwp) :: IAB
integer(kind=iwp) :: MSYM

MSYM = size(iiBstRSh,1)
nnBstRSh(:,:,IRS2) = nnBstRSh(:,:,IRS1)
iiBstRSh(:,:,IRS2) = iiBstRSh(:,:,IRS1)
iiBstR(1:MSYM,IRS2) = iiBstR(1:MSYM,IRS1)
nnBstR(1:MSYM,IRS2) = nnBstR(1:MSYM,IRS1)
if (IRS1 == 1) then
  do IAB=1,size(INDRED,1)
    INDRED(IAB,IRS2) = IAB
  end do
else
  IndRed(:,iRS2) = IndRed(:,iRS1)
end if
NNBSTRT(IRS2) = NNBSTRT(IRS1)

end subroutine CHO_RSCOPY

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module McKinley_global

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: SCF = 1, RASSCF = 2, &
                                nOneel = 1, nTwoel = 2, nTwoDens = 3, nIntegrals = 4, nScreen = 5, nTrans = 6, nFckAcc = 7, &
                                nMOTrans = 8, nTotal = 9
integer(kind=iwp) :: nFck(0:7), nMethod
real(kind=wp) :: CPUStat(nTotal)
logical(kind=iwp) :: lGrd, lHss, Nona, PreScr, sIrrep
integer(kind=iwp), allocatable :: ipDisp(:), ipDisp2(:), ipDisp3(:), ipMO(:)

public :: CPUStat, ipDisp, ipDisp2, ipDisp3, ipMO, lGrd, lHss, nFck, nFckAcc, nIntegrals, nMethod, nMOTrans, Nona, nOneel, &
          nScreen, nTotal, nTrans, nTwoDens, nTwoel, PreScr, RASSCF, SCF, sIrrep

end module McKinley_global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  GETNCI    := Get number of CASSCF determinants in each irrep.      *
!*                                                                     *
!***********************************************************************
subroutine getnci_cvb(nciloc,nelloc,i2sloc,isymloc)

use casvb_global, only: mxirrep, norb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: nciloc(*)
integer(kind=iwp), intent(in) :: nelloc, i2sloc, isymloc
integer(kind=iwp) :: iasyind(0:mxirrep), ibsyind(0:mxirrep), irpdet(mxirrep), nalf1, nbet1, nda1, ndb1
integer(kind=iwp), allocatable :: isymalf(:), isymbet(:)

nalf1 = (nelloc+i2sloc)/2
nbet1 = nelloc-nalf1
call icomb_cvb(norb,nalf1,nda1)
call icomb_cvb(norb,nbet1,ndb1)
call mma_allocate(isymalf,nda1,label='isymalf')
call mma_allocate(isymbet,ndb1,label='isymbet')

call symgen_cvb(nalf1,nbet1,nda1,ndb1,isymalf,isymbet,iasyind,ibsyind,irpdet)

if (isymloc == 0) then
  nciloc(1:mxirrep) = irpdet(:)
else
  nciloc(1) = irpdet(isymloc)
end if

call mma_deallocate(isymalf)
call mma_deallocate(isymbet)

return

end subroutine getnci_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Bingbing Suo                                     *
!***********************************************************************

subroutine jl_ne_jr(mp,jl,jr,jwl,jwr,lopu)

use gugaci_global, only: iy, iyl, jj_sub, jjl_sub, loputmp
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: mp, lopu(4,loputmp)
integer(kind=iwp), intent(in) :: jl, jr, jwl, jwr
integer(kind=iwp) :: i, idlr, jlp, jrp, jwlp, jwrp, lpi, lpj, ml, mr, nlp
integer(kind=iwp), allocatable :: lopi(:,:), lopj(:,:)

!-----------------------------------------------------------------------
! on entry:
!     jl  - left DRT node
!     jr  - right DRT node
!     jwl - left weight
!     jwr - right weight
! output
!     mp  - number of partial loop tails
!     lopu(1,i) - left weight of parital loop i
!     lopu(2,i) - right weight of partial loop i
!     lopu(3,i) - loop tail node
!-----------------------------------------------------------------------

! lopu(1,*)=jwl lopu(2,*)=jwr,lopu(3,*)=jl,lopu(4,*)=jr
!write(u6,*) 'in subroutine jl_ne_jr',jl,jr
call mma_allocate(lopi,4,loputmp,label='lopi')
call mma_allocate(lopj,4,loputmp,label='lopj')
mp = 0
lpi = 1
lopi(1,1) = jwl
lopi(2,1) = jwr
lopi(3,1) = jl
lopi(4,1) = jr
do
  lpj = 0
  do nlp=1,lpi
    if (lopi(3,nlp) == lopi(4,nlp)) then
      mp = mp+1
      lopu(1:4,mp) = lopi(1:4,nlp)
      cycle
    end if
    jlp = lopi(3,nlp)
    jrp = lopi(4,nlp)
    do idlr=1,4
      ml = jjl_sub(idlr,jlp)
      mr = jj_sub(idlr,jrp)
      !write(u6,*) 'ml,mr',ml,mr
      if ((ml == 0) .or. (mr == 0)) cycle
      jwlp = lopi(1,nlp)
      jwrp = lopi(2,nlp)
      if (idlr /= 1) jwlp = jwlp+iyl(idlr,jlp)
      if (idlr /= 1) jwrp = jwrp+iy(idlr,jrp)
      lpj = lpj+1
      lopj(1,lpj) = jwlp
      lopj(2,lpj) = jwrp
      lopj(3,lpj) = ml
      lopj(4,lpj) = mr
    end do
  end do
  if (lpj == 0) exit
  lpi = lpj
  do i=1,lpj
    lopi(1:4,i) = lopj(1:4,i)
  end do
end do
call mma_deallocate(lopi)
call mma_deallocate(lopj)

return

end subroutine jl_ne_jr

!  idb=1  in dbl_space          ity_up=0-5                 0,  jpad,iwdl,iwdr,
!  idb=2  in act_space          ity_up=0-5,itdown=0,3      jph,jpe, iwal,iwa
!  idb=3  between dbl and act   ity_up=0-5,itdown=0,3      jpe,iwdl,iwdr,

subroutine prodab_h0(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
!***********************************************************************
! calculate h matrix elements which were contributed
! only by whole inner space loops and store them into
! vector2

use gugaci_global, only: ihy, ipae, ipael, iseg_downwei, iw_downwei, iy, jpad, jpad_upwei, jpadl, jphy, loputmp, vector2
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, isegdownwei, iwa, iwadl, iwadr, iwal, iwar, iwd, iwdl, iwdown, iwdr, iwe, iwl, iwr, iwupwei, jpe, &
                     jph, jpl, jpy, jwd, jwnu, jwu, lp, lwnu, m, mm, mntmp, mp, nn
integer(kind=iwp), allocatable :: lopu(:,:)
integer(kind=iwp), external :: iwalk_ad

!write(u6,*) 'prodab_02 '

select case (idb)
  case default ! (1)
    ! in dbl_space
    !jpad = mg2
    iwdl = mg3
    iwdr = mg4
    ipae = 1
    jpad = 1
    mntmp = 0
    iwdown = iw_downwei(jpad,ipae)
    lwnu = iseg_downwei(ipae)
    do iwa=0,iwdown-1
      iwadl = iwalk_ad(jpad,ipae,iwa,iwdl)
      iwadr = iwalk_ad(jpad,ipae,iwa,iwdr)
      mm = iwadl
      nn = iwadr
      do m=1,lwnu
        mm = mm+1
        nn = nn+1
        if (mm > nn) mntmp = mm*(mm-1)/2+nn
        if (nn > mm) mntmp = nn*(nn-1)/2+mm
        vector2(mntmp) = vector2(mntmp)+wl
        !if (mntmp == 2) write(u6,*) '  102',vector2(mntmp),wl
      end do
    end do
    !end do

  case (2)
    ! in act_space
    if (jpad /= jpadl) return
    jph = mg1
    jpl = mg2
    !iwal = mg3
    !iwar = mg4
    iwupwei = jpad_upwei(jpad)
    isegdownwei = iseg_downwei(ipae)
    jpy = jphy(jph)
    in_ = ihy(jpy)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
    do lp=1,mp
      iwl = lopu(1,lp)-1
      iwr = lopu(2,lp)-1
      jpe = lopu(3,lp)
      lwnu = iy(1,jpe)
      do jwu=jpy+1,jpy+in_
        iwal = iwl+ihy(jwu)
        iwar = iwr+ihy(jwu)
        do jwd=1,lwnu
          iwal = iwal+1
          iwar = iwar+1
          do iwd=0,iwupwei-1
            iwadl = iwalk_ad(jpadl,ipael,iwal,iwd)
            iwadr = iwalk_ad(jpad,ipae,iwar,iwd)
            do iwe=1,isegdownwei
              mm = iwadl+iwe
              nn = iwadr+iwe
              if (mm > nn) then
                mntmp = mm*(mm-1)/2+nn
              else
                mntmp = nn*(nn-1)/2+mm
              end if
              vector2(mntmp) = vector2(mntmp)+wl
              if (mntmp == 7) then
                write(u6,*) '  202',vector2(mntmp),wl
              end if
            end do
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)

  case (3)
    ! between act and dbl
    jpl = mg1
    iwdl = mg2
    iwdr = mg3
    isegdownwei = iseg_downwei(ipae)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
    do lp=1,mp
      iwal = lopu(1,lp)-1
      iwar = lopu(2,lp)-1
      jpe = lopu(3,lp)
      jwnu = iy(1,jpe)
      do ii=1,jwnu
        iwal = iwal+1
        iwar = iwar+1
        mm = iwalk_ad(jpadl,ipael,iwal,iwdl)
        nn = iwalk_ad(jpad,ipae,iwar,iwdr)
        do iwe=1,isegdownwei
          mm = mm+1             ! iwl=iwalk_ad
          nn = nn+1             ! iwl=iwalk_ad
          if (mm > nn) then
            mntmp = mm*(mm-1)/2+nn
          else
            mntmp = nn*(nn-1)/2+mm
          end if
          vector2(mntmp) = vector2(mntmp)+wl
          !if (mntmp == 2) write(u6,*) '  302',vector2(mntmp),wl
        end do
      end do
    end do
    call mma_deallocate(lopu)
end select

return

end subroutine prodab_h0

subroutine prodab_h(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
!***********************************************************************
! whole inner space loops - h*c
! 26 feb 2007 - revised by suo bing for multi-root calculation

use gugaci_global, only: ihy, indx, ipae, ipael, iseg_downwei, iw_downwei, iy, jpad, jpad_upwei, jpadl, jphy, loputmp, mcroot, &
                         nu_ae, vector1, vector2
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, ipae_, ipaeend, irot, irtidx, isegdownwei, iwa, iwadl, iwadr, iwal, iwar, iwd, iwdl, iwdown, iwdr, &
                     iwe, iwl, iwr, iwupwei, jpe, jph, jpl, jpy, jwd, jwnu, jwu, lp, lwnu, m, mm, mp, nn
integer(kind=iwp), allocatable :: lopu(:,:)
integer(kind=iwp), external :: iwalk_ad

!write(u6,*) 'prodab_02 ',mcroot,indx(1),iw_downwei(jpad,ipae)
select case (idb)
  case default ! (1)
    ! in dbl_space
    jpad = mg2
    iwdl = mg3
    iwdr = mg4
    ipaeend = 25
    do ipae_=1,ipaeend
      ipae = ipae_ ! ipae is in global module, is this necessary?
      if (nu_ae(ipae) == 0) cycle
      iwdown = iw_downwei(jpad,ipae)
      if (iwdown == 0) cycle
      lwnu = iseg_downwei(ipae)
      do iwa=0,iwdown-1
        iwadl = iwalk_ad(jpad,ipae,iwa,iwdl)
        iwadr = iwalk_ad(jpad,ipae,iwa,iwdr)
        do irot=1,mcroot
          irtidx = indx(irot)
          mm = iwadl+irtidx
          nn = iwadr+irtidx
          do m=1,lwnu
            mm = mm+1
            nn = nn+1
            !if ((mm > nci_dim) .or. (nn > nci_dim)) write(u6,*) jpad,ipae,iw_downwei(jpad,ipae),iseg_downwei(ipae), &
            !                                                    jpad_upwei(jpad),iw_sta(jpad,ipae),iwadl,iwadr
            vector2(mm) = vector2(mm)+vector1(nn)*wl
            vector2(nn) = vector2(nn)+vector1(mm)*wl
          end do
        end do
      end do
    end do

  case (2)
    ! in act_space
    if (jpad /= jpadl) return
    jph = mg1
    jpl = mg2
    !iwal = mg3
    !iwar = mg4
    iwupwei = jpad_upwei(jpad)
    isegdownwei = iseg_downwei(ipae)
    jpy = jphy(jph)
    in_ = ihy(jpy)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
    do lp=1,mp
      iwl = lopu(1,lp)-1
      iwr = lopu(2,lp)-1
      jpe = lopu(3,lp)
      lwnu = iy(1,jpe)
      do jwu=jpy+1,jpy+in_
        iwal = iwl+ihy(jwu)
        iwar = iwr+ihy(jwu)
        do jwd=1,lwnu
          iwal = iwal+1
          iwar = iwar+1
          do iwd=0,iwupwei-1
            iwadl = iwalk_ad(jpadl,ipael,iwal,iwd)
            iwadr = iwalk_ad(jpad,ipae,iwar,iwd)
            do irot=1,mcroot
              irtidx = indx(irot)
              mm = iwadl+irtidx
              nn = iwadr+irtidx
              do iwe=1,isegdownwei
                mm = mm+1
                nn = nn+1
                vector2(mm) = vector2(mm)+vector1(nn)*wl
                vector2(nn) = vector2(nn)+vector1(mm)*wl
              end do
            end do
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)

  case (3)
    ! between act and dbl
    jpl = mg1
    iwdl = mg2
    iwdr = mg3
    isegdownwei = iseg_downwei(ipae)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)

    do lp=1,mp
      iwal = lopu(1,lp)-1
      iwar = lopu(2,lp)-1
      jpe = lopu(3,lp)
      jwnu = iy(1,jpe)
      do ii=1,jwnu
        iwal = iwal+1
        iwar = iwar+1
        iwadl = iwalk_ad(jpadl,ipael,iwal,iwdl)
        iwadr = iwalk_ad(jpad,ipae,iwar,iwdr)
        do irot=1,mcroot
          irtidx = indx(irot)
          mm = iwadl+irtidx
          nn = iwadr+irtidx
          do iwe=1,isegdownwei
            mm = mm+1             ! iwl=iwalk_ad
            nn = nn+1             ! iwl=iwalk_ad
            vector2(mm) = vector2(mm)+vector1(nn)*wl
            vector2(nn) = vector2(nn)+vector1(mm)*wl
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)
end select

return

end subroutine prodab_h

subroutine prodab(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)

use gugaci_global, only: log_prod
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr
real(kind=wp), intent(in) :: wl

select case (log_prod)
  case (1)
    call prodab_h(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
  case (2)  ! save H0 CI matrix, use for mrci
    call prodab_h0(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
  case (3)
    call prodab_h0_t(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
  case (4)  ! H0C, use for mrpt2
    call prodab_h0_d(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)
  case default ! HC, use for mrci
end select

return

end subroutine prodab

subroutine prodab_h0_d(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)

use gugaci_global, only: ihy, indx, ipae, ipael, iw_downwei, iy, jpad, jpad_upwei, jpadl, jpae_downwei, jphy, loputmp, mcroot, &
                         vector1, vector2
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, irot, irtidx, iwa, iwadl, iwadr, iwal, iwar, iwd, iwdl, iwdown, iwdr, iwe, iwl, iwr, iwupwei, &
                     jpaedownwei, jpe, jph, jpl, jpy, jwd, jwnu, jwu, lp, lwnu, m, mm, mp, nn
integer(kind=iwp), allocatable :: lopu(:,:)
integer(kind=iwp), external :: iwalk_ad

! log_prod=2:directly no_formh0
!write(u6,*) 'prodab_h0 '

select case (idb)
  case default ! (1)
    ! in dbl_space
    iwdl = mg3
    iwdr = mg4
    iwdown = iw_downwei(jpad,ipae)
    lwnu = jpae_downwei(ipae)
    do iwa=0,iwdown-1
      iwadl = iwalk_ad(jpad,ipae,iwa,iwdl)
      iwadr = iwalk_ad(jpad,ipae,iwa,iwdr)
      do irot=1,mcroot
        irtidx = indx(irot)
        mm = iwadl+irtidx
        nn = iwadr+irtidx
        do m=1,lwnu
          mm = mm+1
          nn = nn+1
          !if ((mm > nci_dim) .or. (nn > nci_dim)) write(u6,*) jpad,ipae,iw_downwei(jpad,ipae),iseg_downwei(ipae), &
          !                                                    jpad_upwei(jpad),iw_sta(jpad,ipae),iwadl,iwadr
          vector2(mm) = vector2(mm)+vector1(nn)*wl
          vector2(nn) = vector2(nn)+vector1(mm)*wl
        end do
      end do
      !do m=1,lwnu
      !  mm = mm+1
      !  nn = nn+1
      !  vector2(mm) = vector2(mm)+vector1(nn)*wl
      !  vector2(nn) = vector2(nn)+vector1(mm)*wl
      !end do
    end do

  case (2)
    ! in act_space
    if (jpad /= jpadl) return
    jph = mg1
    jpl = mg2
    !iwal = mg3
    !iwar = mg4
    iwupwei = jpad_upwei(jpad)
    jpaedownwei = jpae_downwei(ipae)
    jpy = jphy(jph)
    in_ = ihy(jpy)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
    do lp=1,mp
      iwl = lopu(1,lp)-1
      iwr = lopu(2,lp)-1
      jpe = lopu(3,lp)
      lwnu = iy(1,jpe)
      do jwu=jpy+1,jpy+in_
        iwal = iwl+ihy(jwu)
        iwar = iwr+ihy(jwu)
        do jwd=1,lwnu
          iwal = iwal+1
          iwar = iwar+1
          do iwd=0,iwupwei-1
            iwadl = iwalk_ad(jpadl,ipael,iwal,iwd)
            iwadr = iwalk_ad(jpad,ipae,iwar,iwd)
            do irot=1,mcroot
              irtidx = indx(irot)
              mm = iwadl+irtidx
              nn = iwadr+irtidx
              do iwe=1,jpaedownwei
                mm = mm+1
                nn = nn+1
                vector2(mm) = vector2(mm)+vector1(nn)*wl
                vector2(nn) = vector2(nn)+vector1(mm)*wl
              end do
            end do
            !do iwe=1,jpaedownwei
            !  mm = iwadl+iwe
            !  nn = iwadr+iwe
            !  vector2(mm) = vector2(mm)+vector1(nn)*wl
            !  vector2(nn) = vector2(nn)+vector1(mm)*wl
            !end do
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)

  case (3)
    ! between act and dbl
    jpl = mg1
    iwdl = mg2
    iwdr = mg3
    jpaedownwei = jpae_downwei(ipae)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
    do lp=1,mp
      iwal = lopu(1,lp)-1
      iwar = lopu(2,lp)-1
      jpe = lopu(3,lp)
      jwnu = iy(1,jpe)
      do ii=1,jwnu
        iwal = iwal+1
        iwar = iwar+1
        iwadl = iwalk_ad(jpadl,ipael,iwal,iwdl)
        iwadr = iwalk_ad(jpad,ipae,iwar,iwdr)
        do irot=1,mcroot
          irtidx = indx(irot)
          mm = iwadl+irtidx
          nn = iwadr+irtidx
          do iwe=1,jpaedownwei
            mm = mm+1             ! iwl=iwalk_ad
            nn = nn+1             ! iwl=iwalk_ad
            vector2(mm) = vector2(mm)+vector1(nn)*wl
            vector2(nn) = vector2(nn)+vector1(mm)*wl
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)
end select

return

end subroutine prodab_h0_d

subroutine prodab_h0_t(idb,mg1,mg2,mg3,mg4,mg5,wl,jpr)

use gugaci_global, only: ihy, ipae, ipael, iw_downwei, iy, jpad, jpad_upwei, jpadl, jpae_downwei, jphy, loputmp, vector2
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idb, mg1, mg2, mg3, mg4, mg5, jpr
real(kind=wp), intent(in) :: wl
integer(kind=iwp) :: ii, in_, iwa, iwadl, iwadr, iwal, iwar, iwd, iwdl, iwdown, iwdr, iwe, iwl, iwr, iwupwei, jpaedownwei, jpe, &
                     jph, jpl, jpy, jwd, jwnu, jwu, lp, lwnu, m, mm, mnh0, mp, nn
integer(kind=iwp), allocatable :: lopu(:,:)
integer(kind=iwp), external :: iwalk_ad

! log_prod=1:traditional formh0
!write(u6,*) 'prodab_h0 '

select case (idb)
  case default ! (1)
    ! in dbl_space
    iwdl = mg3
    iwdr = mg4
    iwdown = iw_downwei(jpad,ipae)
    lwnu = jpae_downwei(ipae)
    do iwa=0,iwdown-1
      mm = iwalk_ad(jpad,ipae,iwa,iwdl)
      nn = iwalk_ad(jpad,ipae,iwa,iwdr)
      do m=1,lwnu
        mm = mm+1
        nn = nn+1
        mnh0 = mm*(mm-1)/2+nn
        if (nn > mm) mnh0 = nn*(nn-1)/2+mm
        vector2(mnh0) = vector2(mnh0)+wl
        !if (((mm == 1) .and. (nn == 9)) .or. ((mm == 9) .and. (nn == 1))) write(nf2,'(a10,2i5,2f18.8)') ' in dbl ',mm,nn,wl, &
        !                                                                                                vector2(mnh
      end do
    end do

  case (2)
    ! in act_space
    if (jpad /= jpadl) return
    jph = mg1
    jpl = mg2
    !iwal = mg3
    !iwar = mg4
    iwupwei = jpad_upwei(jpad)
    jpaedownwei = jpae_downwei(ipae)
    jpy = jphy(jph)
    in_ = ihy(jpy)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg3,mg4,lopu)
    do lp=1,mp
      iwl = lopu(1,lp)-1
      iwr = lopu(2,lp)-1
      jpe = lopu(3,lp)
      lwnu = iy(1,jpe)
      do jwu=jpy+1,jpy+in_
        iwal = iwl+ihy(jwu)
        iwar = iwr+ihy(jwu)
        do jwd=1,lwnu
          iwal = iwal+1
          iwar = iwar+1
          do iwd=0,iwupwei-1
            iwadl = iwalk_ad(jpadl,ipael,iwal,iwd)
            iwadr = iwalk_ad(jpad,ipae,iwar,iwd)
            do iwe=1,jpaedownwei
              mm = iwadl+iwe
              nn = iwadr+iwe
              mnh0 = mm*(mm-1)/2+nn
              if (nn > mm) mnh0 = nn*(nn-1)/2+mm
              vector2(mnh0) = vector2(mnh0)+wl
              !if (((mm == 1) .and. (nn == 9)) .or. ((mm == 9) .and. (nn == 1))) write(nf2,'(a10,2i5,2f18.8)') ' in act ',mm,nn,wl, &
              !                                                                                                vector2(mnh
            end do
          end do
        end do
      end do
    end do
    call mma_deallocate(lopu)

  case (3)
    ! between act and dbl
    jpl = mg1
    iwdl = mg2
    iwdr = mg3
    jpaedownwei = jpae_downwei(ipae)

    call mma_allocate(lopu,4,loputmp,label='lopu')
    call jl_ne_jr(mp,jpl,jpr,mg4,mg5,lopu)
    do lp=1,mp
      iwal = lopu(1,lp)-1
      iwar = lopu(2,lp)-1
      jpe = lopu(3,lp)
      jwnu = iy(1,jpe)
      do ii=1,jwnu
        iwal = iwal+1
        iwar = iwar+1
        mm = iwalk_ad(jpadl,ipael,iwal,iwdl)
        nn = iwalk_ad(jpad,ipae,iwar,iwdr)
        do iwe=1,jpaedownwei
          mm = mm+1             ! iwl=iwalk_ad
          nn = nn+1             ! iwl=iwalk_ad
          mnh0 = mm*(mm-1)/2+nn
          if (nn > mm) mnh0 = nn*(nn-1)/2+mm
          vector2(mnh0) = vector2(mnh0)+wl
          !if (((mm == 1) .and. (nn == 9)) .or. ((mm == 9) .and. (nn == 1))) write(nf2,'(a10,2i5,2f18.8)') ' act-dbl ',mm,nn,wl, &
          !                                                                                                vector2(mnh0)
        end do
      end do
    end do
    call mma_deallocate(lopu)
end select

return

end subroutine prodab_h0_t

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Initialize_BLAS(lib,prlev)

use link_blas, only: lb_initialize
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: lib
integer(kind=iwp), intent(in) :: prlev

call lb_initialize(lib,prlev)

end subroutine Initialize_BLAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DONEI(DLT,DSQ,CMO)
*
      IMPLICIT REAL*8 (A-H,O-Z)
*

#include "motra_global.fh"
*
      Real*8 CMO(*)
      DIMENSION DSQ(*),DLT(*)
*
*
      ISTSQ=0
      ISTLT=0
      DO 100 ISYM=1,NSYM
        NF=NFRO(ISYM)
        NB=NBAS(ISYM)
        If ( NB*NF.GT.0 )
     &  CALL DGEMM_('N','T',
     &              NB,NB,NF,
     &              1.0d0,CMO(ISTSQ+1),NB,
     &              CMO(ISTSQ+1),NB,
     &              0.0d0,DSQ(ISTSQ+1),NB)
        CALL DSCAL_(NB*NB,2.0D0,DSQ(ISTSQ+1),1)
        IJ=ISTLT
        DO 130 IB=1,NB
          DO 140 JB=1,IB
            IJ=IJ+1
            DLT(IJ)=2.0D0*DSQ(ISTSQ+JB+(IB-1)*NB)
140       CONTINUE
          DLT(IJ)=0.5D0*DLT(IJ)
130     CONTINUE
        ISTSQ=ISTSQ+NB*NB
        ISTLT=ISTLT+NB*(NB+1)/2
100   CONTINUE
*
      IF( IPRINT.GE.5 .OR. DEBUG.NE.0 ) THEN
        WRITE(6,'(6X,A)')'Frozen one-body density matrix in AO basis'
        ISTLT=1
        DO ISYM=1,NSYM
          NB=NBAS(ISYM)
          IF ( NB.GT.0 ) THEN
            WRITE(6,'(6X,A,I2)')'symmetry species:',ISYM
            CALL TRIPRT(' ',' ',DLT(ISTLT),NB)
            ISTLT=ISTLT+NB*(NB+1)/2
          END IF
        END DO
      END IF
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gridExpandSelect(SelectStr)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use grid_it_globals, only: iReq, MAXGRID, nReq
use Definitions, only: iwp, u6

implicit none
character(len=120), intent(in) :: SelectStr
integer(kind=iwp) :: i, ibr, ibrm, iend, ifirst, iibeg, iiend, ilen, istart, istatus, isymm
character(len=120) :: tmp

ifirst = 0
ilen = 0
tmp = ' '
do i=1,len(SelectStr)
  if ((ifirst == 0) .and. (SelectStr(i:i) /= ' ')) then
    ilen = ilen+1
    tmp(ilen:ilen) = SelectStr(i:i)
    ifirst = 1
  else if ((ifirst == 1) .and. (SelectStr(i:i) /= ' ')) then
    ilen = ilen+1
    tmp(ilen:ilen) = SelectStr(i:i)
  else if ((ifirst == 1) .and. (SelectStr(i:i) == ' ')) then
    ilen = ilen+1
    tmp(ilen:ilen) = SelectStr(i:i)
    ifirst = 0
  end if
end do
if (ilen < 2) then
  write(u6,*) 'SELEct section is incomplete'
  call Quit_OnUserError()
end if
!write(u6,*) 'current',tmp
nReq = 0
do
  istart = 1
  iend = index(tmp(istart:),' ')
  ibr = index(tmp(istart:iend),':')
  if (ibr == 0) then
    write(u6,*) 'Wrong format in SELEct section'
    write(u6,*) 'Expecting : sign in >',tmp(istart:iend),'<'
    call Quit_OnUserError()
  end if
  !write(u6,*) 'v01 >',tmp(istart:istart+ibr-2),'<'
  read(tmp(istart:istart+ibr-2),*,iostat=istatus) isymm
  if (istatus /= 0) then
    write(u6,*) 'Error in analyzing SELECT section'
    call Quit_OnUserError()
  end if
  ibrm = index(tmp(istart+ibr+1:iend),'-')
  if (ibrm == 0) then
    ! the only number
    !write(u6,*) 'v02 >',tmp(istart+ibr:iend),'<'
    read(tmp(istart+ibr:iend),*,iostat=istatus) iibeg
    if (istatus /= 0) then
      write(u6,*) 'Error in analyzing SELECT section'
      call Quit_OnUserError()
    end if
    iReq(2*nReq+1) = isymm
    iReq(2*nReq+2) = iibeg
    nReq = nReq+1
    if (nReq > MAXGRID) then
      write(u6,*) 'Too many Grids requested'
      call Quit_OnUserError()
    end if
  else
    !write(u6,*) 'v03 >',tmp(istart+ibr:istart+ibr+ibrm-1),'<'
    read(tmp(istart+ibr:istart+ibr+ibrm-1),*,iostat=istatus) iibeg
    if (istatus /= 0) then
      write(u6,*) 'Error in analyzing SELECT section'
      call Quit_OnUserError()
    end if
    !write(u6,*) 'v04 >',tmp(istart+ibr+ibrm+1:iend),'<'
    read(tmp(istart+ibr+ibrm+1:iend),*,iostat=istatus) iiend
    if (istatus /= 0) then
      write(u6,*) 'Error in analyzing SELECT section'
      call Quit_OnUserError()
    end if
    if (iiend < iibeg) then
      write(u6,*) 'Wrong data in SELEct section'
      call Quit_OnUserError()
    end if
    do i=iibeg,iiend
      iReq(2*nReq+1) = isymm
      iReq(2*nReq+2) = i
      nReq = nReq+1
      if (nReq > MAXGRID) then
        write(u6,*) 'Too many Grids requested'
        call Quit_OnUserError()
      end if
    end do
  end if
  !write(u6,*) 'current',tmp(iend+1:)
  tmp = tmp(iend+1:)
  if (tmp == ' ') exit
end do

return

end subroutine GridExpandSelect

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine CloseR()
!***********************************************************************
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             September '90                                            *
!***********************************************************************

use vRys_RW, only: Cff, ddx, HerR2, HerW2, iHerR2, iHerW2, Map, TMax, x0
use abdata, only: close_abdata
#ifdef _RYS_SCRATCH_
use RysScratch, only: UnSetAux
#endif
use stdalloc, only: mma_deallocate

implicit none

#ifdef _RYS_SCRATCH_
call UnSetAux()
#endif

call close_abdata()

if (.not. allocated(iHerW2)) return
call mma_deallocate(iHerW2)
call mma_deallocate(iHerR2)
call mma_deallocate(HerW2)
call mma_deallocate(HerR2)
call mma_deallocate(Cff)
call mma_deallocate(x0)
call mma_deallocate(Map)
call mma_deallocate(ddx)
call mma_deallocate(TMax)

return

end subroutine CloseR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine ddsolsvb_cvb(dum,rhsp,itdav,maxdav,nfrdim1,
     >  solp,solp_res,eig,eig_res)
      implicit real*8 (a-h,o-z)
#include "direct_cvb.fh"
      dimension rhsp(maxdav),solp(maxdav),solp_res(maxdav)
      save one
      data one/1d0/

      call fmove_cvb(rhsp,solp,itdav)
      eig=dnrm2_(itdav,solp,1)
      call dscal_(itdav,one/eig,solp,1)
      eig_res=eig
      call fmove_cvb(solp,solp_res,itdav)
      return
      entry ddinitsvb_cvb(ifollow1,isaddle1,ip1)
      ifollow=ifollow1
      isaddle=isaddle1
      nroot=max(1,isaddle+1)
      ip=ip1
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real(dum)
        call Unused_integer(nfrdim1)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CLagFinal(nConf,nRoots,nState,CLag,SLag)

use PrintLevel, only: VERBOSE
use caspt2_global, only: iPrGlb
use caspt2_module, only: ISCF, REFENE
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nConf, nRoots, nState
real(kind=wp), intent(inout) :: CLag(nConf,nRoots), SLag(nState**2)
integer(kind=iwp) :: ijst, ilStat, jlStat
real(kind=wp) :: Ovl, Scal
real(kind=wp), allocatable :: CI1(:), CI2(:)
real(kind=wp), external :: DDOT_

call mma_allocate(CI1,nConf,Label='CI1')
call mma_allocate(CI2,nConf,Label='CI2')

!! Construct SLag
ijst = 0
do ilStat=1,nState
  if (ISCF == 0) then
    call LoadCI(CI1,ilStat)
  else
    CI1(1) = One
  end if
  do jlStat=1,ilStat !! -1
    ijst = ilStat+nState*(jlStat-1)
    if (ilStat == jlStat) cycle
    if (ISCF == 0) then
      call LoadCI(CI2,jlStat)
    else
      CI2(1) = One
    end if
    Scal = DDOT_(nConf,CI1,1,CLag(1,jlStat),1)-DDOT_(nConf,CI2,1,CLag(1,ilStat),1)
    Scal = Scal/(REFENE(jlStat)-REFENE(ilStat))
    SLag(ijst) = SLag(ijst)+Scal
    if (IPRGLB >= VERBOSE) then
      write(u6,*)
      write(u6,'(1x,"SLag for State ",i1,"-",i1," = ",f20.10)') ilstat,jlstat,slag(ijst)
      write(u6,*)
    end if
  end do
end do

!! This projection is required to get convergence in MCLR.
!! also the linear equation for non-invariant CASPT2
do ilStat=1,nState
  CI1(1:nConf) = CLag(1:nConf,ilStat)
  !do i=1,nconf
  !  write(u6,'(i3,f20.10)') i,clag(i,ilstat)
  !end do
  do jlStat=1,nState
    if (ISCF == 0) then
      call LoadCI(CI2,jlStat)
    else
      CI2(1) = One
    end if
    Ovl = DDot_(nConf,CI1,1,CI2,1)
    !write(u6,*) 'projection coeff = ',ovl
    CLag(1:nConf,ilStat) = CLag(1:nConf,ilStat)-Ovl*CI2(1:nConf)
  end do
  !write(u6,*) 'clag after projection'
  !write(u6,*) 'state = ',ilstat
  !do i=1,nconf
  !  write(u6,'(i3,f20.10)') i,clag(i,ilstat)
  !end do
end do

call mma_deallocate(CI1)
call mma_deallocate(CI2)

return

end subroutine CLagFinal

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contf22(wrk,wrksize)
! this routine does:
! f2(m,i) <- 0.5 sum(m) [fok(m,e) . T1o(e,i)]
!
! N.B. use and destroy : M1,M2

use ccsd_global, only: f21, f22, fk3, fk4, idaabb, idbaab, m1, m2, t11, t12
use Para_Info, only: MyRank
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: post, rc, ssc

!1 f2(m,i)aa <- 0.5 sum(e-a) [ fok(e,m)aa . t1o(e,i)aa]

!par
if (myRank == idbaab) then

  !1.1 map M1(m,e) <= fok(e,m)aa
  call map(wrk,wrksize,2,2,1,0,0,fk3,1,m1,post,rc)

  !1.2 mult M2(m,i) <= M1(m,e) . T1o(e,i)aa
  call ccmult(wrk,wrksize,2,2,2,1,m1,1,t11,1,m2,ssc,rc)

  !1.3 add f2(m,i)aa <- 0.5 M2(m,i)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,Half,m2,1,f21,1,rc)

end if

!2 f2(m,i)aa <- 0.5 sum(e-b) [ fok(e,m)bb . t1o(e,i)bb]

!par
if (myRank == idaabb) then

  !2.1 map M1(m,e) <= fok(e,m)bb
  call map(wrk,wrksize,2,2,1,0,0,fk4,1,m1,post,rc)

  !2.2 mult M2(m,i) <= M1(m,e) . T1o(e,i)bb
  call ccmult(wrk,wrksize,2,2,2,1,m1,1,t12,1,m2,ssc,rc)

  !2.3 add f2(m,i)bb <- 0.5 M2(m,i)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,Half,m2,1,f22,1,rc)

end if

return

end subroutine contf22

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Yan Zhao                                         *
************************************************************************
      Subroutine XM06(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                CoeffA,iSpin,F_xc,T_X,ijzy)
************************************************************************
*                                                                      *
*  M06x evaluates the exchange part of the M06 suite of                *
*  functionals on a grid.                                              *
*  !!! Second derivatives are not available yet.                       *
*                                                                      *
*  Ref: (a) Zhao, Y.  and Truhlar, D. G. J. Chem. Phys. 125,           *
*    194101 (2006).                                                    *
*       (b) Y. Zhao and D. G. Truhlar, J. Phys. Chem. A (2006),        *
*    110(49),13126-13130.                                              *
*                                                                      *
*       ijzy - 1 M06-L                                                 *
*       ijzy - 2 M06-HF                                                *
*       ijzy - 3 M06                                                   *
*       ijzy - 4 M06-2X                                                *
*                                                                      *
*  YZ (10/07)                                                          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),
     &       F_xc(mGrid)
      Integer mGrid

      integer ijzy
      REAL*8 at1, at2, at3, at4, at5, at6, at7, at8, at9
      REAL*8 at, at10, at11, C1, C2, fL, fNL, at0
      REAL*8 rrho, rho43, rho13, rhoo, rho53
      REAL*8 Gamma
      REAL*8 TauUEG, Tsig, Wsig, Fsig
      REAL*8 tauu
      REAL*8 F83, F23, F53, F1o3
      REAL*8 F1o4, F2o3, F3o2, F4o3, F4o9, F3o5
      REAL*8 Nine, F10, F11
      REAL*8  Ax,  x, x2, En, Ed, E, dE, dEn, dEd
      REAL*8 dFdW, dWdT, dTdR, dTdTau, dGGAdR, dFdR
      REAL*8 dFdTau, dGGAdG
      parameter (F1o3=1.d0/3.d0, F1o4=1.d0/4.d0, F2o3=2.d0/3.d0,
     &             F3o2=3.d0/2.d0)
      parameter (F4o3=4.d0/3.d0, F4o9=4.0d0/9.0d0, F3o5=3.d0/5.d0)
      parameter (F83=8.0d0/3.0d0, F23=2.0d0/3.d0, F53=5.d0/3.d0)
      parameter (Nine=9.0d0,F10=10.0d0, F11=11.d0)

      if (ijzy.eq.1) then
C     Parameters for M06-L
        at0=    3.987756D-01
        at1=    2.548219D-01
        at2=    3.923994D-01
        at3=    -2.103655D+00
        at4=    -6.302147D+00
        at5=    1.097615D+01
        at6=    3.097273D+01
        at7=    -2.318489D+01
        at8=    -5.673480D+01
        at9=    2.160364D+01
        at10=   3.421814D+01
        at11=   -9.049762D+00
       elseif (ijzy.eq.2) then
C     Parameters for M06-HF
        at0=    1.179732D-01
        at1=    -1.066708D+00
        at2=    -1.462405D-01
        at3=    7.481848D+00
        at4=    3.776679D+00
        at5=    -4.436118D+01
        at6=    -1.830962D+01
        at7=    1.003903D+02
        at8=    3.864360D+01
        at9=    -9.806018D+01
        at10=   -2.557716D+01
        at11=   3.590404D+01
       elseif (ijzy.eq.3) then
C     Parameters for M06
        at0=    5.877943D-01
        at1=    -1.371776D-01
        at2=    2.682367D-01
        at3=    -2.515898D+00
        at4=    -2.978892D+00
        at5=    8.710679D+00
        at6=    1.688195D+01
        at7=    -4.489724D+00
        at8=    -3.299983D+01
        at9=    -1.449050D+01
        at10=   2.043747D+01
        at11=   1.256504D+01
C      elseif (ijzy.eq.4) then
       else
C     Parameters for M06-2X
        at0=    4.600000D-01
        at1=    -2.206052D-01
        at2=    -9.431788D-02
        at3=    2.164494D+00
        at4=    -2.556466D+00
        at5=    -1.422133D+01
        at6=    1.555044D+01
        at7=    3.598078D+01
        at8=    -2.722754D+01
        at9=    -3.924093D+01
        at10=   1.522808D+01
        at11=   1.522227D+01
      endif
*
      at=1.0d0
      C1     = 3.36116D-03
      C2     = 4.49267D-03

      fL  =  1.0d0
      fNL =  1.0d0
*
      Ax = -F3o2*(F4o3*PI)**(-F1o3)
      Ta=0.5D0*T_X
*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=1
*
      If (iSpin.eq.1) Then
*                                                                      *
************************************************************************
*                                                                      *
        Do iGrid = 1, mGrid
         if(Rho(ipR,iGrid).lt.Ta .or.  Rho(ipTau,iGrid).lt.Ta) goto 110
         rhoo=max(1.0D-24,rho(ipR,igrid),Ta)
         rho43 = rhoo**F4o3
         rrho = 1.0d0/rhoo       ! reciprocal of rho
         rho13 = rho43*rrho
         rho53 = rhoo**F53
*
         tauu=Rho(ipTau,iGrid)
         TauUEG=F3o5*((Six*pi*pi)**F2o3)*rho53
         Tsig =TauUEG/tauu
         Wsig =(Tsig-One)/(Tsig+One)
         Fsig=at*(at0 + Wsig*(at1 + Wsig*(at2 + Wsig*(at3 + Wsig*(
     &            at4 + Wsig*(at5 + Wsig*(at6 + Wsig*(at7 + Wsig*(
     &            at8 + Wsig*(at9 + Wsig*(at10+Wsig*at11)))))))))))
         Gamma = sqrt(Rho(ipdRx,igrid)**2
     &                +Rho(ipdRy,igrid)**2
     &                +Rho(ipdRz,igrid)**2)
         x = Gamma/rho43
         x2 = x*x
         En = C1*x2
         Ed = One + C2*x2
         E  = -En/Ed
         F_xc(igrid)=F_xc(igrid)+(Ax*fL+fNL*E)*Fsig*rho43*2.0D0
*
*     functional derivatives
*
         dEn   = Two*C1*x
         dEd   = Two*C2*x
         dE    = -(dEn*Ed-En*dEd)/(Ed*Ed)
         dFdW=at*(      at1 + Wsig*(Two  *at2 + Wsig*(Three*at3 + Wsig*(
     &            Four *at4 + Wsig*(Five *at5 + Wsig*(Six  *at6 + Wsig*(
     &            Seven*at7 + Wsig*(Eight*at8 + Wsig*(Nine *at9 + Wsig*(
     &            F10  *at10+ Wsig*F11*at11))))))))))
         dWdT = Two/((One + Tsig)**2)
         dTdR = ((Six*PI*PI)**F2o3)*(rhoo**F2o3)/tauu
         dTdTau = -TauUEG/tauu**2
         dGGAdR = F4o3*rho13*(fL*Ax+fNL*(E-x*dE))
         dFdR = dFdW*dWdT*dTdR
         dFdTau=dFdW*dWdT*dTdTau
         dGGAdG =(fNL*dE/(Two*Gamma))
*        dF/dRho
         dF_dRho(ipR,igrid)=dF_dRho(ipR,igrid)+dGGAdR*Fsig
     &        + (fL*Ax+fNL*E)*rho43*dFdR
*        dF/dGamma
         dF_dRho(ipGxx,igrid)=dF_dRho(ipGxx,iGrid)+ dGGAdG*Fsig
*        dF/dTau
         dF_dRho(ipT,iGrid)
     &      =dF_dRho(ipT,iGrid)+rho43*(Ax*fL+fNL*E)*dFdTau

110     continue
       Enddo
*                                                                      *
************************************************************************
*                                                                      *
*     ispin .ne. 1, use both alpha and beta components.
*
      Else
*                                                                      *
************************************************************************
*                                                                      *
        Do iGrid = 1, mGrid
*
* alpha component
*
         If(Rho(ipRa,iGrid).lt.Ta .or. Rho(ipTaua,iGrid).lt.Ta) goto 210
         rhoo=Rho(ipRa,iGrid)
         rho43 = rhoo**F4o3
         rrho = 1.0d0/rhoo       ! reciprocal of rho
         rho13 = rho43*rrho
         rho53 = rhoo**F53
*
         tauu=rho(ipTaua,iGrid)
         TauUEG=F3o5*((Six*pi*pi)**F2o3)*rho53
         Tsig =TauUEG/tauu
         Wsig =(TauUEG - tauu)/(TauUEG + tauu)
         Fsig=at*(at0 + Wsig*(at1 + Wsig*(at2 + Wsig*(at3 + Wsig*(
     &            at4 + Wsig*(at5 + Wsig*(at6 + Wsig*(at7 + Wsig*(
     &            at8 + Wsig*(at9 + Wsig*(at10+Wsig*at11)))))))))))
         Gamma = sqrt(Rho(ipdRxa,igrid)**2
     &                +Rho(ipdRya,igrid)**2
     &                +Rho(ipdRza,igrid)**2)
         x = Gamma/rho43
         x2 = x*x
         En = C1*x2
         Ed = One + C2*x2
         E  = -En/Ed
         F_xc(iGrid)=F_xc(iGrid)+(Ax*fL+fNL*E)*Fsig*rho43
*
*     functional derivatives
*

         dEn   = Two*C1*x
         dEd   = Two*C2*x
         dE    = -(dEn*Ed-En*dEd)/(Ed*Ed)
         dFdW=at*(      at1 + Wsig*(Two  *at2 + Wsig*(Three*at3 + Wsig*(
     &            Four *at4 + Wsig*(Five *at5 + Wsig*(Six  *at6 + Wsig*(
     &            Seven*at7 + Wsig*(Eight*at8 + Wsig*(Nine *at9 + Wsig*(
     &            F10  *at10+ Wsig*F11*at11))))))))))
         dWdT = Two/((One + Tsig)**2)
         dTdR = ((Six*PI*PI)**F2o3)*(rhoo**F2o3)/tauu
         dTdTau = -TauUEG/tauu**2
         dGGAdR = F4o3*rho13*(fL*Ax+fNL*(E-x*dE))
         dFdR = dFdW*dWdT*dTdR
         dFdTau=dFdW*dWdT*dTdTau
         dGGAdG =(fNL*dE/(Two*Gamma))
*        dF/dRhoa
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,igrid)+dGGAdR*Fsig
     &        + (fL*Ax+fNL*E)*rho43*dFdR
*        dF/dGammaaa
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+ dGGAdG*Fsig
*        dF/dTaua
         dF_dRho(ipTa,iGrid)
     &      =dF_dRho(ipTa,iGrid)+rho43*(Ax*fL+fNL*E)*dFdTau
210      continue
*
* beta component
*
         if(Rho(ipRb,iGrid).lt.Ta .or. Rho(ipTaub,iGrid).lt.Ta) goto 310
         rhoo=Rho(ipRb,iGrid)
         rho43 = rhoo**F4o3
         rrho = 1.0d0/rhoo       ! reciprocal of rho
         rho13 = rho43*rrho
         rho53 = rhoo**F53
*
         tauu=Rho(ipTaub,iGrid)
         TauUEG=F3o5*((Six*pi*pi)**F2o3)*rho53
         Tsig =TauUEG/tauu
         Wsig =(Tsig-One)/(Tsig+One)
         Fsig=at*(at0 + Wsig*(at1 + Wsig*(at2 + Wsig*(at3 + Wsig*(
     &            at4 + Wsig*(at5 + Wsig*(at6 + Wsig*(at7 + Wsig*(
     &            at8 + Wsig*(at9 + Wsig*(at10+Wsig*at11)))))))))))
         Gamma = sqrt(Rho(ipdRxb,iGrid)**2
     &                +Rho(ipdRyb,iGrid)**2
     &                +Rho(ipdRzb,iGrid)**2)
         x = Gamma/rho43
         x2 = x*x
         En = C1*x2
         Ed = One + C2*x2
         E  = -En/Ed
         F_xc(iGrid)=F_xc(iGrid)+(Ax*fL+fNL*E)*Fsig*rho43
*
*     functional derivatives
*
         dEn   = Two*C1*x
         dEd   = Two*C2*x
         dE    = -(dEn*Ed-En*dEd)/(Ed*Ed)
         dFdW=at*(      at1 + Wsig*(Two  *at2 + Wsig*(Three*at3 + Wsig*(
     &            Four *at4 + Wsig*(Five *at5 + Wsig*(Six  *at6 + Wsig*(
     &            Seven*at7 + Wsig*(Eight*at8 + Wsig*(Nine *at9 + Wsig*(
     &            F10  *at10+ Wsig*F11*at11))))))))))
         dWdT = Two/((One + Tsig)**2)
         dTdR = ((Six*PI*PI)**F2o3)*(rhoo**F2o3)/tauu
         dTdTau = -TauUEG/tauu**2
         dGGAdR = F4o3*rho13*(fL*Ax+fNL*(E-x*dE))
         dFdR = dFdW*dWdT*dTdR
         dFdTau=dFdW*dWdT*dTdTau
         dGGAdG =(fNL*dE/(Two*Gamma))
*        dF/dRhob
         dF_dRho(ipRb,igrid)=dF_dRho(ipRb,igrid)+dGGAdR*Fsig
     &        + (fL*Ax+fNL*E)*rho43*dFdR
*        dF/dGammabb
         dF_dRho(ipGbb,igrid)=dF_dRho(ipGbb,iGrid)+ dGGAdG*Fsig
*        dF/dTaub
         dF_dRho(ipTb,igrid)
     &      =dF_dRho(ipTb,iGrid)+rho43*(Ax*fL+fNL*E)*dFdTau
310     continue
       enddo
*                                                                      *
************************************************************************
*                                                                      *
       End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(CoeffA)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Roland Lindh                                     *
*               2004,2012, Thomas Bondo Pedersen                       *
*               2007, Francesco Aquilante                              *
************************************************************************
      subroutine MP2_Driver(ireturn)
************************************************************************
*                                                                      *
*     New MP2 driver for Molcas                                        *
*                                                                      *
*                                                                      *
*    Author: R. Lindh                                                  *
*            Dept. of Chemical Physics                                 *
*            University of Lund, Sweden                                *
*            November 7, 1998                                          *
*                                                                      *
*    Modified:                                                         *
*                                                                      *
*       - code using Cholesky vectors directly                         *
*         October 2004, T. B. Pedersen                                 *
*         Dept. of Theoretical Chemistry                               *
*         University of Lund, Sweden                                   *
*                                                                      *
*       - code for the "Scaled Opposite-Spin" (SOS) MP2                *
*         May 2007, F. Aquilante                                       *
*         Dept. of Theoretical Chemistry                               *
*         University of Lund, Sweden                                   *
*                                                                      *
*       - code for Laplace-SOS-MP2 for Cholesky/DF and LDF             *
*         November-December 2012, T. B. Pedersen                       *
*         Centre for Theoretical and Computational Chemistry           *
*         Dept. of Chemistry                                           *
*         University of Oslo, Norway                                   *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
      External Cho_X_GetTol, Seconds
#include "cddos.fh"
#include "trafo.fh"
#include "mxdim.fh"
#include "corbinf.fh"
#include "orbinf2.fh"
#include "mbpt2aux.fh"
#include "files_mbpt2.fh"
#include "timtra.fh"

#include "real.fh"
#include "WrkSpc.fh"
#include "print_mbpt2.fh"
#include "chomp2_cfg.fh"
#include "mp2grad.fh"
#include "namact.fh"
      Common /ctimt/cpubas
      Real*8 E2BJAI, ESCF, REFC, Seconds
      Integer nIsh(8), nAsh(8), nFro_tra(8), nDel_tra(8)
      Logical Ready, Direct, Debug, Exist
      Logical Conventional
      Data Debug/.False./
      Character*8 Method, Method1
      Integer  Cho_X_GetTol
*                                                                      *
************************************************************************
*                                                                      *
      cpubas=seconds()
      Call Set_Data
*
************************************************
*     Check so it is a RHF-SCF reference that is
*     being used.
* TBP, November 2012: do not quit, just issue a warning!
      Call Get_cArray('Relax Method',Method1,8)
      If((Method1(1:7) .ne. 'RHF-SCF').and.
     &   (Method1(1:5) .ne. 'MBPT2')) Then
         Write(6,*)
         Call WarningMessage(1,
     &            'MP2 implementation intended for RHF references only')
         Write(6,'(A,A)')
     &   'MBPT2 WARNING: Reference function according to RunFile:',
     &   Method1
         Write(6,'(A)')
     &   'I''ll assume you know what you''re doing and continue'
         Write(6,*)
         Call xFlush(6)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Figure out if it's a cholesky run, DF run, LDF run
      DoCholesky=.false.
      DoDF=.false.
      DoLDF=.false.
      Call DecideOnCholesky(DoCholesky)
      Call DecideOnDF(DoDF)
      Call DecideOnLocalDF(DoLDF)
*                                                                      *
************************************************************************
*                                                                      *
*     read COMFILE Interface file from SCF and allocate memory...
*
      CALL TIMING(TCPE(1),TCPT,TIOE(1),TIOT)
      Call RdMBPT(mAdCMO,lthCMO,mAdEOr,lthEOr)
*
      Call GetMem('EOcc  ','Allo','Real',mAdEOc,lthEOr)
      Call GetMem('EExt  ','Allo','Real',mAdEEx,lthEOr)
      Call FZero(Work(mAdEOc),lthEOr)
      Call FZero(Work(mAdEEx),lthEOr)
*                                                                      *
************************************************************************
*                                                                      *
*     read Program Input Cards...
*
      Call RdInp(Work(mAdCMO),Work(mAdEOr),Work(mAdEOc),Work(mAdEEx),
     &           iTst,ESCF)
*                                                                      *
************************************************************************
*                                                                      *
      mAdCMO_t=mAdCMO
      mAdEOr_t=mAdEOr
      Call DelGHOST_MBPT(mAdCMO,mAdCMO_t,lthCMO,mAdEOr,mAdEOr_t,lthEOr)
*                                                                      *
************************************************************************
*                                                                      *
      E2BJAI=Zero
      REFC=Zero
      PE2=Zero
      PVECL2=Zero
*
      Wref=Zero
*                                                                      *
************************************************************************
*                                                                      *
*     Write out input parameters
*
      Call PrInp_MBPT2(Work(mAdEOc),Work(mAdEEx))
*                                                                      *
************************************************************************
*                                                                      *
*     Copy pointers to orbital energies to chomp2_dec.fh
*     Needed for amplitude Cholesky decomposition.
*
      If (DoCholesky) Then
         Call ChoMP2_SetPtsOen(mAdEOc,mAdEEx)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Check, if there is an ORDINT file...
*
      Call f_Inquire(FNINTA,Exist)
      Call DecideOnDirect(.True.,Exist,Direct,DoCholesky)
      CALL TIMING(TCPE(2),TCPT,TIOE(2),TIOT)
      CALL TIMING(TCPE(3),TCPT,TIOE(3),TIOT)
*
*
      If (DoT1amp) Then
        l_T1=nOcc(1)*nExt(1)
        nOccT=nOcc(1)
        Do iSym=2,nSym
           l_T1=l_T1+nOcc(iSym)*nExt(iSym)
           nOccT=nOccT+nOcc(iSym)
        End Do
        Call GetMem('T1amp','Allo','Real',jT1amp,l_T1)
        Call Thouless_T1(Work(mAdCMO),nSym,nBas,nFro,nOcc,nExt,
     &                   Work(jT1amp))
        t1nrm=ddot_(l_T1,Work(jT1amp),1,Work(jT1amp),1)
        t1dg=sqrt(t1nrm/nOccT)
        write(6,'(A,F8.4)') '       T1 diagnostic : ',t1dg
        write(6,*)
        Call Set_iOff(nSym,nOcc,nExt,jT1amp-1,iOffT1)
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      If (DoLDF) Then ! LDF
         Conventional=.false.
         Ready=.false.
         If (Laplace .and. SOS_MP2) Then
            Call WarningMessage(2,
     &                       'LDF-Laplace-SOS-MP2 not implemented yet!')
            Call SysHalt('mp2_driver')
         Else
            Call WarningMessage(2,
     &                          'Only LDF-Laplace-SOS-MP2 implemented!')
            Call SysHalt('mp2_driver')
         End If
      Else If (DoCholesky .and. ChoAlg.gt.0 .and. .not.SOS_mp2
     &                                      .and. .not.FNOMP2
     &                                      .and. .not.LovMP2) Then
         Conventional = .false.
         Ready = .false.
         Call ChoMP2_Drv(irc,E2BJAI,Work(mAdCMO),
     &                   Work(mAdEOc),Work(mAdEEx))
         If (irc .ne. 0) Then
            Write(6,*) 'MP2_Driver: ChoMP2_Drv returned ',irc
            Call SysAbendMsg('MP2_Driver',
     &                       'Non-zero return code from ChoMP2_Drv',
     &                       ' ')
         Else
            Ready = .true.
         End If
      Else If (DoCholesky .and. SOS_mp2) Then ! CD/DF SOS-MP2
         Conventional=.false.
         Ready=.false.
         If (Laplace) Then
            Call ChoMP2_Drv(irc,E2BJAI,Work(mAdCMO),
     &                      Work(mAdEOc),Work(mAdEEx))
            If (irc .ne. 0) Then
               Write(6,*) 'MP2_Driver: ChoMP2_Drv returned ',irc
               Call SysAbendMsg('MP2_Driver',
     &                          'Non-zero return code from ChoMP2_Drv',
     &                          ' ')
            Else
               Ready=.true.
            End If
         Else
            Call Cho_SOSmp2_Drv(irc,E2BJAI,Work(mAdCMO),
     &                          Work(mAdEOc),Work(mAdEEx))
            If (irc .ne. 0) Then
               Write(6,*) 'SOS-MP2_Driver: Cho_SOSmp2_Drv returned ',irc
               Call SysAbendMsg('SOS-MP2_Driver',
     &                       'Non-zero return code from Cho_SOSmp2_Drv',
     &                          ' ')
            Else
               Ready=.true.
            End If
         End If
!     CD/DF Frozen Natural Orbital MP2
      Else If (DoCholesky .and. FNOMP2) Then
         Conventional = .false.
         Ready = .false.
         Write(6,'(A)')
     &   '-------------------------------------------------------'
         Write(6,'(A)') ' Start FNO-MP2 section '
         Write(6,'(A)')
     &   '-------------------------------------------------------'
         Write(6,'(A,8I4)')
         Write(6,'(A,I3,A)')
     &  ' NOs specified: ',int(vkept*100),'% of the total virtual space'
         Call FNOMP2_Drv(irc,E2BJAI,Work(mAdCMO),
     &                   Work(mAdEOc),Work(mAdEEx))
         If (irc .ne. 0) Then
            Write(6,*) 'MP2 driver: FNOMP2_Drv returned ',irc
            Call SysAbendMsg('MP2 driver',
     &                       'Non-zero return code from FNOMP2_Drv',
     &                       ' ')
         Else
            Ready = .true.
         End If
         Write(6,'(A)')
     &   '-------------------------------------------------------'
         Write(6,'(A)') ' End FNO-MP2 section '
         Write(6,'(A)')
     &   '-------------------------------------------------------'
         Write(6,'(A,8I4)')
         Write(6,'(A,8I4)')
      Else If (DoCholesky .and. LovMP2) Then ! CD/DF Localized O-V MP2
         Conventional = .false.
         Ready = .false.
         Write(6,'(A)')
     &   '-------------------------------------------------------'
         Write(6,'(A)') ' Start LovMP2 section '
         Write(6,'(A)')
     &   '-------------------------------------------------------'
         Write(6,'(A,8I4)')
         Call LovMP2_Drv(irc,E2BJAI,Work(mAdCMO),
     &                   Work(mAdEOc),Work(mAdEEx),NamAct,nActa,
     &                   ThrLov,DoMP2,all_Vir)
         If (irc .ne. 0) Then
            Write(6,*) 'MP2 driver: LovMP2_Drv returned ',irc
            Call SysAbendMsg('MP2 driver',
     &                       'Non-zero return code from LovMP2_Drv',
     &                       ' ')
         Else
            Ready = .true.
         End If
         Write(6,'(A)')
     &   '-------------------------------------------------------'
         Write(6,'(A)') ' End LovMP2 section '
         Write(6,'(A)')
     &   '-------------------------------------------------------'
         Write(6,'(A,8I4)')
         Write(6,'(A,8I4)')
      Else ! conventional (possibly with Cholesky)
         Conventional = .true.
         If (DoCholesky) Then
            If (ChoAlg .eq. 0 .and. iPL.ge.2) Then
               Write(6,*) 'Conventional algorithm used.'
               Write(6,*)
               Write(6,*) 'Integrals generated from Cholesky vectors '
     &                   //'(Algorithm 0):'
            Else
               Call SysHalt('mp2_driver')
            End If
         Else
            If (iPL.ge.2) Write(6,*) 'Conventional algorithm used...'
         End If
         If ( iTst.ne.0 ) Go To 100
*
*------- Use the driver from the CASPT2 code.
*
         Call DaName_MF_wa(LuIntM,FnIntM)

         If(DoDens) Then

*--------   Same as just above but keeping frozen and deleted orbitals in the
*--------   transformation
            Do i=1,8
               nIsh(i) = nOrb(i)+nDel(i)
            EndDo
            itmp=0
            Call ICopy(8,[itmp],0,nFro_tra,1)
            Call ICopy(8,[itmp],0,nDel_tra,1)
         Else
            Call ICopy(8,nOcc,1,nIsh,1)
         End If

         itmp=0
         Call ICopy(8,[itmp],0,nAsh,1)
         If(.not.DoDens) Then
* PAM Jan 2013: Set correct nOrb:
      do i=1,8
        norb(i)=norb(i)-nfro(i)
      end do
            Call SetUp_CASPT2_Tra(nSym,nBas,nOrb,nIsh,nAsh,
     &                            nFro,nDel,mAdCMO,lthCMO,
     &                            LuIntM,LuHlf1,LuHlf2,LuHlf3)
* End of patch
         Else
            Call SetUp_CASPT2_Tra(nSym,nBas,nIsh,nIsh,nAsh,
     &                            nFro_tra,nDel_tra,mAdCMO,lthCMO,
     &                            LuIntM,LuHlf1,LuHlf2,LuHlf3)
         End If
         If(.NOT.DoCholesky) then
           iRC=-1
           iOpt=0
           Call OpnOrd(iRC,iOpt,FnIntA,LuIntA)
           If (iRC.ne.0) Then
             Write (6,*) 'mp2_driver: error opening MOLINT'
             Call Abend
           End If
         EndIf
*
CGG         Call TraCtl
         iType=1  ! Means that TraCtl_Drv is called by MP2
CGG      DoExch2=.True. ! Do generate Exch-2 integrals (not really used).
         Call TraCtl_Drv(iType,.True.,8)
*
         Call DaClos(LuHlf1)
         Call DaClos(LuHlf2)
         Call DaClos(LuHlf3)
*
*
         CALL TIMING(TCPE(3),TCPT,TIOE(3),TIOT)
*        PRINT TRANSFORMED INTEGRALS (USED ONLY FOR DEBUGGING PURPOSES)
         If (Debug) Then
            iPrc=0
            Call RDInt2_MP2(iPrc)
         ENDIF
*                                                                      *
************************************************************************
*                                                                      *
         If(DoDens) then
*
*           Obtain variational density if requested by user
*
            ipEOcc=mAdEOc
            ipEVir=mAdEEx
            ipCMO=mAdCMO
            Call Mp2Dens_drv(E2BJAI,REFC)
         Else
*
*           COMPUTE CORRELATION ENERGY CONTRIBUTION
*
            CALL BJAI(IADOUT,Work(mAdEOc),Work(mAdEEx),E2BJAI,REFC)
         End If
         CALL TIMING(TCPE(4),TCPT,TIOE(4),TIOT)

         Ready=.True.

*        Close files (for Cholesky, OrdInt was never opened)
         If (.not. DoCholesky) Then
            iRc=-1
            iOpt=0
            Call ClsOrd(iRc,iOpt)
            If (iRc.ne.0) Then
               Write (6,*) 'MP2_Driver: Error closing ORDINT'
               Call Abend
            End If
         End If
         Call DaClos(LuIntM)
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Write out resulting energy, etc.
*
      If (Ready) Then

         Wref=One/(One+Wref)   ! Note: this is Cref**2

         If (DoLDF) Then
            Call WarningMessage(2,'LDF should not be implemented....')
            Call SysHalt('mp2_driver')
         Else If (DoCholesky .and. ChoAlg.gt.0 .and. .not.SOS_mp2
     &                                        .and. .not.LovMP2
     &                                        .and. .not.FNOMP2) Then
            If (iPL.ge.2)
     &      Write (6,'(3(/6X,A,F20.10,A)//6X,A,F20.10,A//6X,A,F15.5)')
     &    ' SCF energy                           =',ESCF,       ' a.u.',
     &    ' Second-order correlation energy      =',E2BJAI,     ' a.u.',
     &    ' ( Opposite-Spin contribution         =',-EOSMP2,    ' )',
     &    ' Total energy                         =',E2BJAI+ESCF,' a.u.',
     &    ' Reference weight ( Cref**2 )         =',Wref
         ElseIf (DoCholesky .and. LovMP2) Then
            ESSMP2=E2BJAI+EOSMP2
            If (iPL.ge.2)
     &      Write (6,'(4(/6X,A,F20.10,A)//6X,A,F20.10,A//6X,A,F15.5)')
     &    ' SCF energy                           =',ESCF,       ' a.u.',
     &    ' Second-order correlation energy      =',E2BJAI,     ' a.u.',
     &    ' ( Opposite-Spin contribution         =',-EOSMP2,    ' )',
     &    ' ( Same-Spin contribution             =', ESSMP2,    ' )',
     &    ' Total energy                         =',E2BJAI+ESCF,' a.u.',
     &    ' Reference weight ( Cref**2 )         =',Wref
         ElseIf (DoCholesky .and. FNOMP2) Then
            ESSMP2=E2BJAI+EOSMP2-XEMP2
            If (iPL.ge.2)
     &      Write (6,'(5(/6X,A,F20.10,A)//6X,A,F20.10,A//6X,A,F15.5)')
     &    ' SCF energy                           =',ESCF,       ' a.u.',
     &    ' Second-order correlation energy      =',E2BJAI,     ' a.u.',
     &    ' ( Opposite-Spin contribution         =',-EOSMP2,    ' )',
     &    ' ( Same-Spin contribution             =', ESSMP2,    ' )',
     &    ' ( Truncation error estimate          =', XEMP2,     ' )',
     &    ' Total energy                         =',E2BJAI+ESCF,' a.u.',
     &    ' Reference weight ( Cref**2 )         =',Wref
         ElseIf (DoCholesky .and. SOS_mp2) Then ! CD/DF SOS-MP2 energy
            E2BJAI = C_os*E2BJAI
            If (iPL.ge.2) Then
               If (Laplace) Then
                  Write(6,'(/,6X,A,I4)')
     &    ' Number of Laplace grid points:',Laplace_nGridPoints
                  Write (6,'(3(/6X,A,F20.10,A)//6X,A,F20.10,A)')
     &    ' Opposite-Spin (OS) scaling factor    =',C_os,       '     ',
     &    ' SCF energy                           =',ESCF,       ' a.u.',
     &    ' L-SOS 2nd-order correlation energy   =',E2BJAI,     ' a.u.',
     &    ' Total L-SOS-MP2 energy               =',E2BJAI+ESCF,' a.u.'
               Else
                  Write (6,'(3(/6X,A,F20.10,A)//6X,A,F20.10,A)')
     &    ' Opposite-Spin (OS) scaling factor    =',C_os,       '     ',
     &    ' SCF energy                           =',ESCF,       ' a.u.',
     &    ' SOS 2nd-order correlation energy     =',E2BJAI,     ' a.u.',
     &    ' Total SOS-MP2 energy                 =',E2BJAI+ESCF,' a.u.'
               End If
            End If
         Else
            WRef=REFC**2
            If (iPL.ge.2)
     &      Write (6,'(2(/6X,A,F20.10,A)//6X,A,F20.10,A/6X,A,F15.5)')
     &    ' SCF energy                           =',ESCF,       ' a.u.',
     &    ' Second-order correlation energy      =',E2BJAI,     ' a.u.',
     &    ' Total energy                         =',E2BJAI+ESCF,' a.u.',
     &    ' Reference weight ( Cref**2 )         =',Wref
         End If
         If (iPL.ge.2) Then
           ETot=E2BJAI+ESCF
           Write(6,*)
           Call PrintResult(6,'(6X,A,T50,F19.10)',
     &                      'Total MBPT2 energy',0,'',[ETot],1)
         End If
         Call xFlush(6)
         If (iPL.ge.2) Write (6,*)
         Call Store_Energies(1,E2BJAI+ESCF,1)
         Method='MBPT2   '
         Call Put_cArray('Relax Method',Method,8)
         If(DoDens) Call Prpt()
         If (iPL.ge.2) Write (6,*)
      Else
         Write (6,*) ' Energy evaluation not completed.'
      End If
*
*     Shanks-type series convergence acceleration
*
      Call Compute_Shanks(ESCF,E2BJAI+ESCF,Work(mAdEOr),lthEOr,
     &                    nBas,nFro,nOcc,nSym,E0,Shanks1_E)
*
      If (iPL.ge.2) Then
         WRITE(6,'(6X,A,A,(F20.10),A)')
     &    ' Zeroth-order energy (E0)   ',
     &    '          =',E0,' a.u.'
         write(6,*)

         WRITE(6,'(6X,A,A,(F20.10),A)')
     &    ' Shanks-type energy S1(E)   ',
     &    '          =',Shanks1_E,' a.u.'
         write(6,*)
         write(6,*)
      End If
*
*       PRINT PROCESSING AND TIMING INFORMATION
*
      If (Conventional.and.iPL.ge.2) Then
         WRITE (6,'(//6X,A//6X,A/6X,A/)')
     &' Data processing and timing information:',
     &' Section                                              time(sec)',
     &'                                                    CPU  Elapsed'
         WRITE(6,'(6X,A,A,2(2X,F8.2))') 'Input data processing      ',
     &    '                  ',TCPE(2)-TCPE(1),TIOE(2)-TIOE(1)
         WRITE(6,'(6X,A,A,2(2X,F8.2))') 'Transformation of integrals',
     &    '                  ',TCPE(3)-TCPE(2),TIOE(3)-TIOE(2)
         WRITE(6,'(6X,A,A,2(2X,F8.2))') 'MBPT2 calculations (BJAI)  ',
     &    '                  ',TCPE(4)-TCPE(3),TIOE(4)-TIOE(3)
         WRITE(6,'(6X,A,A,2(2X,F8.2))') 'Total MBPT2 calculations   ',
     &    '                  ',TCPE(4)-TCPE(1),TIOE(4)-TIOE(1)
         WRITE(6,*)
         WRITE(6,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      iTol = Cho_X_GetTol(8)
      Call Add_Info('E_MP2',[E2BJAI+ESCF],1,iTol)
      Call Add_Info('HF ref weight',[WREF],1,iTol)
*                                                                      *
************************************************************************
*                                                                      *
 100  Continue
*
*---- Close up calculation
*
      If (DoT1amp) Call GetMem('T1amp','Free','Real',jT1amp,l_T1)
      Call GetMem('EExt  ','Free','Real',mAdEEx,lthEOr)
      Call GetMem('EOcc  ','Free','Real',mAdEOc,lthEOr)
      Call GetMem('EOrb  ','Free','Real',mAdEOr,lthEOr)
      Call GetMem('CMO   ','Free','Real',mAdCMO,lthCMO)
*
      ireturn=0
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!               1993, Per Boussard                                     *
!***********************************************************************

subroutine PrjGrd_mck( &
#                     define _CALLING_
#                     include "grd_mck_interface.fh"
                     )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of ECP integrals.         *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
!             Physics, University of Stockholm, Sweden, October 1993.  *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_mck_interface.fh"
integer(kind=iwp) :: iAng, iCnt, iDCRT(0:7), Indx(3,4), ip, ipFA1, ipFA2, ipFB1, ipFB2, ipFin, iShll, iuvwx(4), JndGrd(3,4,0:7), &
                     kCnt, kCnttp, kdc, lDCRT, LmbdT, mOp(4), mvec, nBasisi, nDCRT, nExpi, nt
real(kind=wp) C(3), Dum(1), Fact, TC(3)
logical(kind=iwp) :: DiffCnt, ifhess_dum(3,4,3,4), JfGrad(3,4), tr(4)
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(P)
unused_var(nHer)
unused_var(Ccoor)
unused_var(Trans)
!                                                                      *
!***********************************************************************
!                                                                      *
iuvwx(1) = iu
iuvwx(2) = iv
mop(1) = nOp(1)
mop(2) = nOp(2)
DiffCnt = IfGrad(iDCar,1) .or. IfGrad(iDCar,2)

#ifdef _DEBUGPRINT_
call RecPrt(' In PrjGrd_McK: A',' ',A,1,3)
call RecPrt(' In PrjGrd_McK: RB',' ',RB,1,3)
!call RecPrt(' In PrjGrd_McK: P',' ',P,nZeta,3)
call RecPrt(' In PrjGrd_McK: Alpha',' ',Alpha,nAlpha,1)
call RecPrt(' In PrjGrd_McK: Beta',' ',Beta,nBeta,1)
write(u6,*) ' In PrjGrd_McK: la,lb=',' ',la,lb
write(u6,*) ' In PrjGrd_McK: Diffs=',' ',IfGrad(iDCar,1),IfGrad(iDCar,2)
write(u6,*) ' In PrjGrd_McK: Center=',' ',iDCNT
#endif

kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (.not. dbsc(kCnttp)%ECP) cycle
  if (dbsc(kCnttp)%nSRO <= 0) cycle

  do kCnt=1,dbsc(kCnttp)%nCntr
    if ((.not. DiffCnt) .and. (kdc+kCnt /= iDCnt)) cycle

    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)
    iuvwx(3) = dc(kdc+kCnt)%nStab
    iuvwx(4) = dc(kdc+kCnt)%nStab

    JfGrad(:,:) = .false.
    tr(:) = .false.
    JndGrd(:,:,0:nIrrep-1) = 0
    JfGrad(iDCar,1:2) = IfGrad(iDCar,1:2)
    do ICnt=1,2
      if (IfGrad(idcar,iCnt)) JndGrd(iDCar,iCnt,0:nIrrep-1) = IndGrd(0:nIrrep-1)
    end do

    if ((kdc+kCnt) == iDCnt) then
      Tr(3) = .true.
      JfGrad(iDCar,1:2) = .true.
      JndGrd(iDCar,3,0:nIrrep-1) = -IndGrd(0:nIrrep-1)
    end if

    do lDCRT=0,nDCRT-1

      mop(3) = nropr(iDCRT(lDCRT))
      mop(4) = mop(3)
      call OA(iDCRT(lDCRT),C,TC)

      if (EQ(A,RB) .and. EQ(A,TC)) cycle

      do iAng=0,dbsc(kCnttp)%nPrj-1
        iShll = dbsc(kCnttp)%iPrj+iAng
        nExpi = Shells(iShll)%nExp
        nBasisi = Shells(iShll)%nBasis
#       ifdef _DEBUGPRINT_
        write(u6,*) 'nExp(iShll)=',nExpi
        write(u6,*) 'nBasisi=',nBasisi
        write(u6,*) ' iAng=',iAng
        call RecPrt('TC',' ',TC,1,3)
#       endif

        if ((nExpi == 0) .or. (nBasisi == 0)) cycle

        ip = 1

        ipFin = ip
        ip = ip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*6

        ipFA1 = ip
        ip = ip+nAlpha*nExpi*nTri_Elem1(la)*nTri_Elem1(iAng)*4

        ipFB1 = ip
        ip = ip+nExpi*nBeta*nTri_Elem1(iAng)*nTri_Elem1(lb)*4

        ipFB2 = ip
        ipFA2 = ip
        if (ip >= narr) then
          write(u6,*) 'No mem in PrjGrd_McK',ip,narr
          call abend()
        end if

        Array(:) = Zero

#       ifdef _DEBUGPRINT_
        call Acore(iang,la,ishll,nordop,TC,A,Array(ip),narr-ip+1,Alpha,nalpha,Array(ipFA1),array(ipFA2),jfgrad(1,1),ifhess_dum,1, &
                   .true.)
#       else
        call Acore(iang,la,ishll,nordop,TC,A,Array(ip),narr-ip+1,Alpha,nalpha,Array(ipFA1),array(ipFA2),jfgrad(1,1),ifhess_dum,1, &
                   .false.)
#       endif
        call LToCore(Array(ipFA1),nalpha,ishll,la,iAng,4)

#       ifdef _DEBUGPRINT_
        call coreB(iang,lb,ishll,nordop,TC,RB,Array(ip),narr-ip+1,Beta,nbeta,Array(ipFB1),array(ipFB2),jfgrad(1,2),ifhess_dum,1, &
                   .true.)
#       else
        call coreB(iang,lb,ishll,nordop,TC,RB,Array(ip),narr-ip+1,Beta,nbeta,Array(ipFB1),array(ipFB2),jfgrad(1,2),ifhess_dum,1, &
                   .false.)
#       endif
        call RToCore(Array(ipFB1),nBeta,ishll,lb,iAng,4)

        call CmbnACB1(Array(ipFA1),Array(ipFB1),Array(ipFin),Fact,nAlpha,nBeta,Dum,nBasisi,la,lb,iang,jfgrad,Dum,.false.,Indx, &
                      mvec,idcar)

        nt = nAlpha*nBeta*nTri_Elem1(lb)*nTri_Elem1(la)
        call SmAdNa(Array(ipFin),nt,rFinal,mop,loper,JndGrd,iuvwx,Indx,idcar,One,tr)

      end do
    end do
  end do
end do

return

end subroutine PrjGrd_mck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************

subroutine RDVEC_(FName,LU_,LABEL,IUHF,NSYM,NBAS,NORB,CMO,CMO_ab,OCC,OCC_ab,EORB,EORB_ab,INDT,TITLE,iWarn,iErr,iWFtype)
!-----------------------------------------------------------------------
! Advanced RdVec (to remove all clones!)
!-----------------------------------------------------------------------
!iWFtype =  0  -- Unknown origin of orbitals
!           1  -- Orbitals for Guessorb
!           2  -- Orbitals for closed shell HF
!           3  -- Orbitals for closed shell DFT
!           4  -- Orbitals for unrestricted HF
!           5  -- Orbitals for unrestricted DFT
!           6  -- Natural orbitals for unrestricted HF
!           7  -- Natural orbitals for unrestricted DFT
!           8  --
!-----------------------------------------------------------------------

use InpOrbFmt, only: FmtEne, FmtInd, FmtOcc, FmtOrb, mxVer, Magic, nDivEne, nDivInd, nDivOcc, nDivOrb, nSkpInd
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
character(len=*), intent(in) :: FName, LABEL
integer(kind=iwp), intent(in) :: LU_, iUHF, NSYM, NBAS(NSYM), NORB(NSYM), iWarn
real(kind=wp), intent(_OUT_) :: CMO(*), CMO_ab(*), OCC(*), OCC_ab(*), EORB(*), EORB_ab(*)
integer(kind=iwp), intent(_OUT_) :: INDT(*)
character(len=*), intent(out) :: TITLE
integer(kind=iwp), intent(out) :: iErr, iWFType
integer(kind=iwp) :: i, iA, iB, IBAS, IBASEND, iBeta, iCMO, iEne, iInd, IND, iOcc, IORB, IORBEND, iShift, istatus, ISYM, iVer, &
                     jVer, KCMO, KOCC, Lu, myiUHF, myNSYM, nDiv
logical(kind=iwp) :: Exists
character(len=256) :: LINE
character(len=40) :: FRMT
character(len=10) :: Buff
integer(kind=iwp), allocatable :: myNBAS(:), myNORB(:)
character(len=*), parameter :: Crypt = 'fi123sd', &
                               CryptUP = 'FIXXXSD', &
                               Location = 'rdVec_'

Line = 'not defined yet'

! Analyze Label

iCMO = 0
iOCC = 0
iEne = 0
iInd = 0
iBeta = 0
if (index(Label,'C') /= 0) iCMO = 1
if (index(Label,'O') /= 0) iOcc = 1
if (index(Label,'E') /= 0) iEne = 1
if (index(Label,'I') /= 0) iInd = 1
if (index(Label,'A') /= 0) iBeta = -1
if (index(Label,'B') /= 0) iBeta = 1
!----------------------------------------------------------------------*
! Open file Name                                                       *
!----------------------------------------------------------------------*
iErr = 0
Lu = Lu_
call OpnFl(FName,Lu,Exists)
if (.not. Exists) then
  write(u6,*) 'RdVec: File ',trim(FName),' not found!'
  call Abend()
end if
rewind(LU)
!----------------------------------------------------------------------*
! Check version!                                                       *
!----------------------------------------------------------------------*
read(LU,'(A256)',iostat=istatus) Line
if (istatus /= 0) call Error()
iVer = 0
do jVer=1,mxVer
  if (Magic(jVer) == Line(1:len(Magic(jVer)))) iVer = jVer
end do

if (iVer == 0) then
  call SysWarnMsg(Location,'INPORB file in old format',' ')
  call Abend()
end if
!----------------------------------------------------------------------*
! INFO section, read it unconditionally                                *
!----------------------------------------------------------------------*
do
  read(LU,'(A256)',iostat=istatus) Line
  if (istatus /= 0) call Error()
  if (Line(1:5) == '#INFO') exit
end do
read(Lu,'(a)',iostat=istatus) Title
if (istatus /= 0) call Error()
read(Lu,'(a)',iostat=istatus) Line
if (istatus /= 0) call Error()
Line(76:80) = '0 0 0'
read(Line,*) myiUHF,myNSYM,iWFtype
!read(Lu,*,iostat=istatus) myiUHF,myNSYM
!if (istatus /= 0) call Error()
! In case of UHF mismatch:
if (myiUHF /= iUHF) then
  ! Stop if UHF requested, but the INPORB is not UHF
  if (myiUHF == 0) then
    call SysWarnFileMsg(Location,FName,'IUHF does not match',' ')
    call Abend()
  end if
  ! With a UHF INPORB, only go on if alpha or beta orbitals
  ! explicitly requested
  if ((iUHF == 0) .and. (iBeta == 0)) then
    call SysWarnFileMsg(Location,FName,'IUHF does not match',' ')
    call Abend()
  end if
end if
if (myNSYM /= NSYM) then
  call SysWarnFileMsg(Location,FName,'NSYM does not match',' ')
  call Abend()
end if
call mma_allocate(myNBAS,NSYM,label='myNBAS')
call mma_allocate(myNORB,NSYM,label='myNORB')
read(Lu,*,iostat=istatus) (myNBAS(i),i=1,NSYM)
if (istatus /= 0) call Error()
read(Lu,*,iostat=istatus) (myNORB(i),i=1,NSYM)
if (istatus /= 0) call Error()
!----------------------------------------------------------------------*
! Do checks                                                            *
!----------------------------------------------------------------------*
do i=1,NSYM
  if (myNBAS(i) /= NBAS(i)) then
    Line = 'NBAS does not match'
    if (iWarn == 1) then
      call SysWarnMsg(Location,Line,' ')
    else
      call SysWarnFileMsg(Location,FName,Line,' ')
      call Abend()
    end if
  end if
end do
if (iWarn > 0) then
  do i=1,NSYM
    if (myNORB(i) < NORB(i)) then
      Line = 'NORB does not match'
      if (iWarn == 1) then
        call SysWarnMsg(Location,Line,' ')
      else
        call SysWarnFileMsg(Location,FName,Line,' ')
        call Abend()
      end if
    end if
  end do
end if
call mma_deallocate(myNBAS)
!----------------------------------------------------------------------*
! ORB section                                                          *
!----------------------------------------------------------------------*
if (iCMO == 1) then
  nDiv = nDivOrb(iVer)
  FRMT = FmtOrb(iVer)
  rewind(LU)
  do
    read(LU,'(A256)',iostat=istatus) Line
    if (istatus /= 0) call Error()
    if (Line(1:4) == '#ORB') exit
  end do
  KCMO = 0
  do ISYM=1,NSYM
    do IORB=1,myNORB(ISYM)
      do IBAS=1,NBAS(ISYM),NDIV
        IBASEND = min(IBAS+NDIV-1,NBAS(ISYM))
        do
          read(LU,'(A256)',iostat=istatus) LINE
          if (istatus /= 0) call Error()
          if (LINE(1:1) /= '*') exit
        end do
        if (iOrb <= nOrb(iSym)) then
          read(LINE,FRMT,iostat=istatus) (CMO(I+KCMO),I=IBAS,IBASEND)
          if (istatus /= 0) call Error()
        end if
      end do
      if (iOrb <= nOrb(iSym)) KCMO = KCMO+NBAS(ISYM)
    end do
  end do
  if ((iUHF == 1) .or. (iBeta == 1)) then
    do
      read(LU,'(A256)',iostat=istatus) Line
      if (istatus /= 0) call Error()
      if (Line(1:5) == '#UORB') exit
    end do
    KCMO = 0
    do ISYM=1,NSYM
      do IORB=1,NORB(ISYM)
        do IBAS=1,NBAS(ISYM),NDIV
          IBASEND = min(IBAS+NDIV-1,NBAS(ISYM))
          do
            read(LU,'(A256)',iostat=istatus) LINE
            if (istatus /= 0) call Error()
            if (LINE(1:1) /= '*') exit
          end do
          if (iOrb <= nOrb(iSym)) then
            if (iBeta == 1) then
              read(LINE,FRMT,iostat=istatus) (CMO(I+KCMO),I=IBAS,IBASEND)
              if (istatus /= 0) call Error()
            else
              read(LINE,FRMT,iostat=istatus) (CMO_ab(I+KCMO),I=IBAS,IBASEND)
              if (istatus /= 0) call Error()
            end if
          end if
        end do
        if (iOrb <= nOrb(iSym)) KCMO = KCMO+NBAS(ISYM)
      end do
    end do
  end if ! iUHF
end if ! iCMO
!----------------------------------------------------------------------*
! OCC section                                                          *
!----------------------------------------------------------------------*
if (iOcc == 1) then
  nDiv = nDivOcc(iVer)
  FRMT = FmtOcc(iVer)
  rewind(LU)
  do
    read(LU,'(A256)',iostat=istatus) Line
    if (istatus /= 0) call Error()
    if (Line(1:4) == '#OCC') exit
  end do
  KOCC = 0
  do ISYM=1,NSYM
    do IORB=1,myNORB(ISYM),NDIV
      IORBEND = min(IORB+NDIV-1,myNORB(ISYM))
      do
        read(LU,'(A256)',iostat=istatus) LINE
        if (istatus /= 0) call Error()
        if (LINE(1:1) /= '*') exit
      end do
      read(LINE,FRMT,iostat=istatus) (OCC(I+KOCC),I=IORB,IORBEND)
      if (istatus /= 0) call Error()
    end do
    !KOCC = KOCC+myNORB(ISYM)
    KOCC = KOCC+nOrb(iSym)
  end do
  if ((iUHF == 1) .or. (iBeta == 1)) then
    do
      read(LU,'(A256)',iostat=istatus) Line
      if (istatus /= 0) call Error()
      if (Line(1:5) == '#UOCC') exit
    end do
    KOCC = 0
    do ISYM=1,NSYM
      do IORB=1,myNORB(ISYM),NDIV
        IORBEND = min(IORB+NDIV-1,myNORB(ISYM))
        do
          read(LU,'(A256)',iostat=istatus) LINE
          if (istatus /= 0) call Error()
          if (LINE(1:1) /= '*') exit
        end do
        if (iBeta == 1) then
          read(LINE,FRMT,iostat=istatus) (OCC(I+KOCC),I=IORB,IORBEND)
          if (istatus /= 0) call Error()
        else
          read(LINE,FRMT,iostat=istatus) (OCC_ab(I+KOCC),I=IORB,IORBEND)
          if (istatus /= 0) call Error()
        end if
      end do
      !KOCC = KOCC+myNORB(ISYM)
      KOCC = KOCC+nOrb(iSym)
    end do
  end if ! iUHF
end if ! iOCC
!----------------------------------------------------------------------*
! ONE section                                                          *
!----------------------------------------------------------------------*
if (iEne == 1) then
  nDiv = nDivEne(iVer)
  FRMT = FmtEne(iVer)
  rewind(LU)
  do
    read(LU,'(A256)',iostat=istatus) Line
    if (istatus /= 0) then
      call End2()
      return
    end if
    if (Line(1:4) == '#ONE') exit
  end do
  KOCC = 0
  do ISYM=1,NSYM
    do IORB=1,myNORB(ISYM),NDIV
      IORBEND = min(IORB+NDIV-1,myNORB(ISYM))
      do
        read(LU,'(A256)',iostat=istatus) LINE
        if (istatus /= 0) call Error()
        if (LINE(1:1) /= '*') exit
      end do
      read(LINE,FRMT,iostat=istatus) (EORB(I+KOCC),I=IORB,IORBEND)
      if (istatus /= 0) call Error()
    end do
    !KOCC = KOCC+myNORB(ISYM)
    KOCC = KOCC+nOrb(iSym)
  end do
  if ((iUHF == 1) .or. (iBeta == 1)) then
    do
      read(LU,'(A256)',iostat=istatus) Line
      if (istatus /= 0) call Error()
      if (Line(1:5) == '#UONE') exit
    end do
    KOCC = 0
    do ISYM=1,NSYM
      do IORB=1,myNORB(ISYM),NDIV
        IORBEND = min(IORB+NDIV-1,myNORB(ISYM))
        do
          read(LU,'(A256)',iostat=istatus) LINE
          if (istatus /= 0) call Error()
          if (LINE(1:1) /= '*') exit
        end do
        if (iBeta == 1) then
          read(LINE,FRMT,iostat=istatus) (EORB(I+KOCC),I=IORB,IORBEND)
          if (istatus /= 0) call Error()
        else
          read(LINE,FRMT,iostat=istatus) (EORB_ab(I+KOCC),I=IORB,IORBEND)
          if (istatus /= 0) call Error()
        end if
      end do
      !KOCC = KOCC+myNORB(ISYM)
      KOCC = KOCC+nOrb(iSym)
    end do
  end if ! iUHF
end if ! iOne
!----------------------------------------------------------------------*
! INDEX section                                                        *
!----------------------------------------------------------------------*
if (iInd == 1) then
  rewind(LU)
  do
    read(LU,'(A256)',iostat=istatus) Line
    if (istatus /= 0) then
      call End2()
      return
    end if
    if (Line(1:6) == '#INDEX') exit
  end do
  FRMT = FMTIND(iVer)
  nDiv = nDivInd(iVer)
  iShift = 1
  do ISYM=1,NSYM
    !iShift = (ISYM-1)*7
    do i=1,nSkpInd(iVer)
      read(LU,*)
    end do
    do IORB=1,myNORB(ISYM),nDiv
      read(LU,FRMT,iostat=istatus) Buff
      if (istatus /= 0) then
        call End2()
        return
      end if
      do i=1,nDiv
        IND = index(Crypt,Buff(i:i))+index(CryptUp,Buff(i:i))
        if (Buff(i:i) /= ' ') then
          if (IND == 0) then
            write(u6,*) '* ERROR IN RDVEC WHILE READING TypeIndex'
            write(u6,'(3A)') '* Type=',Buff(i:i),' is UNKNOWN'
            call End2()
            return
          end if
          IndT(iShift) = IND
          iShift = iShift+1
        end if
      end do
    end do
  end do

  iA = 1
  iB = 1
  do iSym=1,nSym
    IndT(iB:iB+nOrb(iSym)-1) = IndT(iA:iA+nOrb(iSym)-1)
    iA = iA+nBas(iSym)
    iB = iB+nOrb(iSym)
  end do
end if  ! Index
close(Lu)
call End1()

return

contains

subroutine End1()
  call mma_deallocate(myNORB)
end subroutine End1

subroutine End2()
  !--------------------------------------------------------------------*
  ! a special case - INDEX information is not found                    *
  !--------------------------------------------------------------------*
  iErr = 1
  write(u6,*) '* TypeIndex information is IGNORED *'
  close(Lu)
  call End1()
end subroutine End2

subroutine Error()
  call SysWarnFileMsg(Location,FName,'Error during reading INPORB\n',Line)
  call Abend()
end subroutine Error

end subroutine RDVEC_

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine divthelp1(t1,dima,dimi,dp)
! this routine does:
! t1(a,i) = t1(a,i)/(dp(i)-dp(a))
!
! t1   - T1 matrix (I/O)
! dima - v dimension of T1 (I)
! dimi - o dimension of T1 (I)
! dp   - diagonal part of Fok (I)
!
! N.B. Since for T1 i and a are of the same spin, there is no reason
! to specify spin of dp. It must be automatically the same spin as i and a.

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimi
real(kind=wp), intent(inout) :: t1(dima,dimi)
real(kind=wp), intent(in) :: dp(*)
integer(kind=iwp) :: a, i
real(kind=wp) :: den, dpi

do i=1,dimi
  dpi = dp(i)
  do a=1,dima
    ! t1(a,i)=t1(a,i)/(dpi-dp(dimi+a))

    den = dpi-dp(dimi+a)
    if ((abs(den) >= 1.0e-7_wp) .or. (abs(t1(a,i)) > 1.0e-10_wp)) t1(a,i) = t1(a,i)/den

  end do
end do

return

end subroutine divthelp1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRAONE_MOTRA(PAO,PMO,TEMP,CMO)
! Transformation program: one-electron section
!
! Objective: transforms a one-electron matrix PAO in AO-basis
!            to a molecular orbital matrix PMO.

#include "intent.fh"

use motra_global, only: nBas, nDel, nFro, nOrb, nSym
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: PAO(*), CMO(*)
real(kind=wp), intent(_OUT_) :: PMO(*), TEMP(*)
integer(kind=iwp) :: IAO, ICMO, IMO, IOFF, ISYM

ICMO = 1
IAO = 1
IMO = 1
do ISYM=1,NSYM
  ICMO = ICMO+NBAS(ISYM)*NFRO(ISYM)
  IOFF = 1+NBAS(ISYM)*NBAS(ISYM)
  call SQUARE(PAO(IAO),TEMP(1),1,NBAS(ISYM),NBAS(ISYM))
  call DGEMM_('T','N',NORB(ISYM),NBAS(ISYM),NBAS(ISYM),One,CMO(ICMO),NBAS(ISYM),TEMP,NBAS(ISYM),Zero,TEMP(IOFF),max(1,NORB(ISYM)))
  If (NORB(ISYM)*NBAS(ISYM) > 0) call DGEMM_Tri('N','N',NORB(ISYM),NORB(ISYM),NBAS(ISYM),One,TEMP(IOFF),NORB(ISYM),CMO(ICMO), &
                                                NBAS(ISYM),Zero,PMO(IMO),NORB(ISYM))
  ICMO = ICMO+NBAS(ISYM)*(NORB(ISYM)+NDEL(ISYM))
  IAO = IAO+NBAS(ISYM)*(NBAS(ISYM)+1)/2
  IMO = IMO+NORB(ISYM)*(NORB(ISYM)+1)/2
end do

return

end subroutine TRAONE_MOTRA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine GenGnu_Localisation(FilNam,Den,Coord,n)
      Implicit None
      Character*12 FilNam
      Integer n
      Real*8  Den(n,n), Coord(3,n)

      Integer  isFreeUnit
      External isFreeUnit

      Character*4  Postfix
      Character*16 FName
      Parameter (Postfix = '.dat')

      Integer i, j, Lu
      Real*8  Dist, D, Fac

C     Open data file.
C     ---------------

      Lu = isFreeUnit(11)
      Write(FName,'(A12,A4)') FilNam,Postfix
      If (FName(1:1) .eq. ' ') FName(1:1) = 'G'
      Do i = 2,12
         If (FName(i:i) .eq. ' ') FName(i:i) = '_'
      End Do
      Call Molcas_Open(Lu,FName)
      Rewind(Lu)

C     Write data file.
C     ----------------

      Fac = 1.0d0/log(1.0d1)
      Do j = 1,n
         Do i = j,n
            Dist = sqrt((Coord(1,j)-Coord(1,i))**2
     &                 +(Coord(2,j)-Coord(2,i))**2
     &                 +(Coord(3,j)-Coord(3,i))**2
     &                 )
            If (abs(Den(i,j)) .lt. 1.0d-16) Then
               D = -4.0d1
            Else
               D = Fac*log(abs(Den(i,j)))
            End If
            Write(Lu,'(1X,1P,D20.10,1X,D20.10)') Dist,D
         End Do
      End Do

C     Close data file.
C     ----------------

      Close(Lu,Status='Keep')

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKBC_DP(DREF,NDREF,PREF,NPREF,FD,FP,iSYM,BC,MBC,iLo,iHi,jLo,jHi,LDC)

use Index_Functions, only: iTri, nTri_Elem
use SUPERINDEX, only: MTUV
use caspt2_global, only: ipea_shift
use caspt2_module, only: EASUM, EPSA, NASHT, NTUVES
use Constants, only: Two, Four, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF, iSYM, MBC, iLo, iHi, jLo, jHi, LDC
real(kind=wp), intent(in) :: DREF(NDREF), PREF(NPREF), FD(NDREF), FP(NPREF)
real(kind=wp), intent(inout) :: BC(MBC)
integer(kind=iwp) :: ID, IDT, IDU, IDV, IP, ISADR, ITABS, ITUV, ITUVABS, ITX, ITZ, IUABS, IVABS, IVU, IVX, IVZ, IXABS, IXYZ, &
                     IXYZABS, IYABS, IYZ, IZABS
real(kind=wp) :: EU, EY, EYU, FACT, Val

do IXYZ=jLo,jHi
  IXYZABS = IXYZ+NTUVES(ISYM)
  IXABS = MTUV(1,IXYZABS)
  IYABS = MTUV(2,IXYZABS)
  IZABS = MTUV(3,IXYZABS)
  EY = EPSA(IYABS)
  do ITUV=iLo,iHi
    ITUVABS = ITUV+NTUVES(ISYM)
    ITABS = MTUV(1,ITUVABS)
    IUABS = MTUV(2,ITUVABS)
    IVABS = MTUV(3,ITUVABS)
    EU = EPSA(IUABS)
    EYU = EY+EU
    FACT = EYU-EASUM
    ISADR = 1+iTUV-iLo+LDC*(iXYZ-jLo)
    if (LDC == 0) then
      if (iXYZ > iTUV) cycle
      ISADR = iTri(ITUV,IXYZ)
    end if
    Val = FACT*BC(ISADR)
    !Val = Fvutxyz+(EPSA(y)+EPSA(u))*SC(tuv,xyz)
    ! Add  dyu ( Fvztx - EPSA(u)*Gvztx )
    if (IYABS == IUABS) then
      IVZ = IVABS+NASHT*(IZABS-1)
      ITX = ITABS+NASHT*(IXABS-1)
      IP = iTri(IVZ,ITX)
      Val = Val+Two*(FP(IP)-EU*PREF(IP))
    end if
    ! Add  dyx ( Fvutz - EPSA(y)*Gvutz )
    if (IYABS == IXABS) then
      IVU = IVABS+NASHT*(IUABS-1)
      ITZ = ITABS+NASHT*(IZABS-1)
      IP = iTri(IVU,ITZ)
      Val = Val+Two*(FP(IP)-EY*PREF(IP))
    end if
    ! Add  dtu ( Fvxyz - EPSA(u)*Gvxyz + dyx Fvz - (EPSA(u)+EPSA(y)*dyz Gvz)
    if (ITABS == IUABS) then
      IVX = IVABS+NASHT*(IXABS-1)
      IYZ = IYABS+NASHT*(IZABS-1)
      IP = iTri(IVX,IYZ)
      Val = Val+Two*(FP(IP)-EU*PREF(IP))
      if (IYABS == IXABS) then
        ID = iTri(IVABS,IZABS)
        Val = Val+FD(ID)-EYU*DREF(ID)
      end if
    end if
    !GG.Nov03
    if (ITUV == IXYZ) then
      IDT = nTri_Elem(ITABS)
      IDU = nTri_Elem(IUABS)
      IDV = nTri_Elem(IVABS)
      Val = Val+ipea_shift*Half*BC(ISADR)*(Four-DREF(IDT)-DREF(IDV)+DREF(IDU))
    end if
    !GG End
    BC(ISADR) = Val
  end do
end do

end subroutine MKBC_DP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
Module RASSIWfn
integer wfn_fileid, wfn_sfs_energy, wfn_sos_energy, wfn_sfs_coef, wfn_sos_coefr, wfn_sos_coefi,       &
        wfn_sfs_angmom, wfn_sos_angmomr, wfn_sos_angmomi, wfn_sos_spinr, wfn_sos_spini, wfn_sfs_tdm,  &
        wfn_sfs_tsdm, wfn_overlap, wfn_sfs_tm, wfn_sos_tm, wfn_sfs_edipmom, wfn_sfs_amfi,             &
        wfn_sos_hsor, wfn_sos_hsoi, wfn_sfs_wetdm, wfn_sos_edipmomr, wfn_sos_edipmomi, wfn_sos_vsor,  &
        wfn_sos_vsoi, wfn_sos_dys, wfn_detcoeff, wfn_detocc, wfn_cmo, wfn_cmo_or, wfn_detcoeff_or,    &
        wfn_detocc_or
End Module RASSIWfn

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SPIND(ISYOP,MS2OP,IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,PSI1,PSI2,SPD12)

use rassi_global_arrays, only: FSBANN1, FSBANN2
use Symmetry_Info, only: MUL
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ISYOP, MS2OP, IORBTAB(*), ISSTAB(*), IFSBTAB1(*), IFSBTAB2(*)
real(kind=wp), intent(in) :: PSI1(*), PSI2(*)
real(kind=wp), intent(_OUT_) :: SPD12(*)
integer(kind=iwp) :: IMODE, ISMLAB, ISORB, ISPLAB, JMS2, JSMLAB, JSORB, JSPLAB, JSYM, KOINFO, NASORB, NDETS1, NDETS2
real(kind=wp) :: COEFF, OVLP
real(kind=wp), allocatable :: ANN1(:), ANN2(:)
real(kind=wp), external :: OVERLAP_RASSI

!TEST write(u6,*) ' Test prints in SPIND.'
! Nr of active spin-orbitals
NASORB = IORBTAB(4)
! Loop over pairs of spin orbitals ISORB,JSORB:
KOINFO = 19
do ISORB=1,NASORB
  ISMLAB = IORBTAB(KOINFO+1+8*(ISORB-1))
  !UNUSED ISOIND = IORBTAB(KOINFO+2+8*(ISORB-1))
  ISPLAB = IORBTAB(KOINFO+3+8*(ISORB-1))
  ! Annihilate a single orbital:
  COEFF = One
  IMODE = -1
  call FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB1,1)
  NDETS1 = FSBANN1(5)
  call mma_allocate(ANN1,NDETS1,Label='ANN1')
  ANN1(:) = Zero
  call PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,FSBANN1,IFSBTAB1,COEFF,ANN1,PSI1)
  !TEST write(u6,*) ' Prior to call to PRIMSGM.'
  !TEST write(u6,*) ' FS block structure at FSBANN1:'
  !TEST call PRFSBTAB(FSBANN1)
  !TEST write(u6,*) ' Wave function ANN1 after PRIMSGM:'
  !TEST PRTHR = 0.01_wp
  !TEST call PRWVF(IORBTAB,ISSTAB,FSBANN1,PRTHR,ANN1)
  ! Compute those ANN2 wave functions, which have the correct properties:
  JSYM = MUL(ISMLAB,ISYOP)
  JMS2 = MS2OP+ISPLAB
  do JSORB=1,NASORB
    OVLP = Zero
    JSMLAB = IORBTAB(KOINFO+1+8*(JSORB-1))
    !UNUSED JSOIND = IORBTAB(KOINFO+2+8*(JSORB-1))
    JSPLAB = IORBTAB(KOINFO+3+8*(JSORB-1))
    if ((JSMLAB == JSYM) .and. (JSPLAB == JMS2)) then
      COEFF = One
      IMODE = -1
      call FSBOP(IMODE,JSORB,IORBTAB,ISSTAB,IFSBTAB2,2)
      NDETS2 = FSBANN2(5)
      call mma_allocate(ANN2,NDETS2,Label='ANN2')
      ANN2(:) = Zero
      call PRIMSGM(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN2,IFSBTAB2,COEFF,ANN2,PSI2)

      ! Compute the spin transition density matrix element:
      OVLP = OVERLAP_RASSI(FSBANN1,FSBANN2,ANN1,ANN2)
      !TEST write(u6,*) ' Their overlap:',OVLP
      call mma_deallocate(ANN2)
      call mma_deallocate(FSBANN2)
    end if
    SPD12(ISORB+NASORB*(JSORB-1)) = OVLP
  end do
  call mma_deallocate(ANN1)
  call mma_deallocate(FSBANN1)
end do

end subroutine SPIND

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine SortDiag(HH,EigVec,nVec,nDim)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nVec, nDim
real(kind=wp), intent(inout) :: HH(nTri_Elem(nDim)), EigVec(nDim,nVec)
integer(kind=iwp) :: i, iMax, ii, jj
integer(kind=iwp), external :: idAMax_

do i=1,nVec-1
  iMax = idAMax_(nVec-i+1,EigVec(i,i),nDim)
  if (iMax > 1) then
    iMax = iMax+i-1
    ii = nTri_Elem(i)
    jj = nTri_Elem(iMax)
    call dSwap_(1,HH(ii),1,HH(jj),1)
    call dSwap_(nDim,EigVec(:,i),1,EigVec(:,iMax),1)
  end if
end do

end subroutine SortDiag

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1992, Roland Lindh                                *
************************************************************************
      SubRoutine HRR2Da(Arr1,nVec,nabMax,ncdMax,Arr2,A,B,la,lb,lc,ld,
     &                 IfGrad)
************************************************************************
*                                                                      *
* Object: to apply the transfer equation to the 2D-integrals.          *
*         The transformation is in place and the recursion             *
*         is replaced with the indentity when applicable.              *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             September '91                                            *
*             Modified to recurrence algorithm, February '92.          *
*             Improved algorithm, June '92.                            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 A(3), B(3), Arr1(nVec,3,0:nabMax,0:ncdMax),
     &                   Arr2(nVec,0:la+1,0:lb+1,0:ncdMax,3)
      Logical IfGrad(3,4)
*
      iRout = 233
      iPrint = nPrint(iRout)
*     iQ = 0
*
      Do 10 iCar = 1, 3
         lla = 0
         If(IfGrad(iCar,1)) lla = 1
         llb = 0
         If(IfGrad(iCar,2)) llb = 1
         llcd = 0
         If(IfGrad(iCar,3).or.IfGrad(iCar,4)) llcd = 1
*
         AB = A(iCar)-B(iCar)
         If (AB.eq.Zero) Then
            Do 100 icd = 0, lc+ld+llcd
*-----------Using the identity
               Do 200 ia = 0, la+lla
                  Do 210 ib = 0, lb+llb
                  iab = ia + ib
                  If (iab.gt.la+lb+Max(lla,llb)) Go To 210
                  do i=1,nVec
                  Arr2(i,ia,ib,icd,iCar)=Arr1(i,iCar,iab,icd)
                  enddo
210               Continue
200            Continue
100         Continue
         Else
            If (la.ge.lb) Then
               Do 101 icd = 0, lc+ld+llcd
*-----------------Move the first row I(ia,0)
                  Do 20 ia = 0, la+lb+Max(lla,llb)
                     ja = ia
                     jb = 0
                     If (ja.gt.la+1) Then
                        ja = ja - (la+2)
                        jb = 1
                     End If
                     do i=1,nVec
                     Arr2(i,ja,jb,icd,iCar)=Arr1(i,iCar,ia,icd)
                     end do
 20               Continue
*-----------------Generate I(ia,ib) for fixed ib
                  Do 30 ib = 1, lb + llb
                     Do 31 ia = la+lb+Max(lla,llb)-ib, 0, -1
                        ja = ia
                        jb = ib
                        mb = ib-1
                        If (ja.gt.la+1) Then
                           ja = ja - (la+2)
                           jb = jb + 1
                           mb = mb + 1
                        End If
                        ma = ja
                        ka = ia+1
                        kb = ib-1
                        If (ka.gt.la+1) Then
                           ka = ka - (la+2)
                           kb = kb + 1
                        End If
                        Call DZaXpY(nVec,AB,Arr2(1,ma,mb,icd,iCar),1,
     &                                      Arr2(1,ka,kb,icd,iCar),1,
     &                                      Arr2(1,ja,jb,icd,iCar),1)
 31                  Continue
 30               Continue
 101           Continue
            Else
               AB = -AB
               Do 102 icd = 0, lc+ld+llcd
*-----------------Move the first row I(0,ib)
                  Do 40 ib = 0, la+lb+Max(lla,llb)
                     jb = ib
                     ja = 0
                     If (jb.gt.lb+1) Then
                        jb = jb - (lb+2)
                        ja = 1
                     End If
                     do i=1,nVec
                     Arr2(i,ja,jb,icd,iCar)=Arr1(i,iCar,ib,icd)
                     end do
 40               Continue
*-----------------Generate I(ia,ib) for fixed ia
                  Do 50 ia = 1, la + lla
                     Do 51 ib = la+lb+Max(lla,llb)-ia, 0, -1
                        jb = ib
                        ja = ia
                        ma = ia-1
                        If (jb.gt.lb+1) Then
                           jb = jb - (lb+2)
                           ja = ja + 1
                           ma = ma + 1
                        End If
                        mb = jb
                        kb = ib+1
                        ka = ia-1
                        If (kb.gt.lb+1) Then
                           kb = kb - (lb+2)
                           ka = ka + 1
                        End If
                        Call DZaXpY(nVec,AB,Arr2(1,ma,mb,icd,iCar),1,
     &                                      Arr2(1,ka,kb,icd,iCar),1,
     &                                      Arr2(1,ja,jb,icd,iCar),1)
 51                  Continue
 50               Continue
 102           Continue
            End If
         End If
 10   Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dkh_xpx(n,dkord,xord,vord,EL,ES,OL,OS,Ep,E0,dkcof,cc,wr,rw,t1,t2,t3,t4,or,ro,e,rer,or_,ro_,e_,rer_,s1,s2,wsav)
! Evaluate DKH transformation in moment space for property operator

#include "intent.fh"

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
! Output : EL overwritten by the transformed property matrix
integer(kind=iwp), intent(in) :: n, dkord, xord, vord
real(kind=wp), intent(inout) :: EL(n,n)
real(kind=wp), intent(in) :: ES(n,n), OL(n,n), OS(n,n), Ep(n), E0(n), dkcof(*), cc(*), wsav(n,n,xord*2)
real(kind=wp), intent(out) :: wr(n,n), rw(n,n), t1(n,n), t2(n,n), t3(n,n), t4(n,n)
real(kind=wp), intent(_OUT_) :: or(n,n,*), ro(n,n,*), e(n,n,*), rer(n,n,*), or_(n,n,*), ro_(n,n,*), e_(n,n,*), rer_(n,n,*), &
                                s1(n,n,*), s2(n,n,*)
integer(kind=iwp) :: k, ord, cou, ks, ioe
logical(kind=iwp) :: ifodd

#include "macros.fh"
unused_var(dkord)
unused_var(Ep)
unused_var(E0)
unused_var(cc(1))

! Copy initial matrices

e(:,:,1) = EL(:,:)
rer(:,:,1) = ES(:,:)
or(:,:,1) = OL(:,:)
ro(:,:,1) = OS(:,:)

cou = 0
do ord=1,xord
  or_(:,:,1:vord) = Zero
  ro_(:,:,1:vord) = Zero
  e_(:,:,1:vord) = Zero
  rer_(:,:,1:vord) = Zero

  ! Set up W(ord) matrix, copy from saved set generated from dkh_ham

  wr(:,:) = wsav(:,:,ord*2-1)
  rw(:,:) = wsav(:,:,ord*2)

  ! Calculate [W(ord)->E(1-...)/O(1-...)]
  !   note that no odd term will be eliminated

  do ks=1,xord+1
    ! W1 only apply to E1/O1
    !DP if ((ord == 1) .and. (ks >= 2)) cycle
    if ((ord > 1) .or. (ks < 2)) then
      do ioe=1,2
        k = ks
        if (ioe == 1) then
          ifodd = .true.
        else
          ifodd = .false.
        end if
        ! copy initial matrix
        if (ifodd) then
          t1(:,:) = or(:,:,k)
          t2(:,:) = ro(:,:,k)
          or_(:,:,k) = or_(:,:,k)+t1(:,:)
          ro_(:,:,k) = ro_(:,:,k)+t2(:,:)
        else
          t1(:,:) = e(:,:,k)
          t2(:,:) = rer(:,:,k)
          e_(:,:,k) = e_(:,:,k)+t1(:,:)
          rer_(:,:,k) = rer_(:,:,k)+t2(:,:)
        end if
        call dkh_wgene(n,ord,k,xord+1,ifodd,dkcof,wr,rw,t1,t2,e_,rer_,or_,ro_,cou,s1,s2,t3,t4)
        ! cycle for odd/even operator
      end do
    end if
    ! cycle for ks
  end do
  ! copy
  or(:,:,1:xord+1) = or_(:,:,1:xord+1)
  ro(:,:,1:xord+1) = ro_(:,:,1:xord+1)
  e(:,:,1:xord+1) = e_(:,:,1:xord+1)
  rer(:,:,1:xord+1) = rer_(:,:,1:xord+1)
! cycle for ord
end do

! Sum over all k<=xord+1 terms
!   +1 appears because X itself is not counted as an order

do k=2,xord+1
  EL(:,:) = EL(:,:)+e(:,:,k)
end do
!write(u6,*) 'DKHX',xord,' Total matmul',cou

return

end subroutine dkh_xpx

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_DecChk_2(irc,iSym,Col,nDim,nCol,Wrk,lWrk,ErrStat)
!
! Thomas Bondo Pedersen, Jan. 2008.
!
! Purpose: check MP2 decomposition of the MP2 amplitudes
!          (sym. block iSym). The columns of the matrix are
!          compared nCol columns at a time. This
!          implies that the memory requirement of this routine
!          should be limited to approximately that of the
!          decomposition itself. Note, however, that since all
!          integrals are computed, this routine will consume
!          significantly more CPU time.
!          Files are assumed open.
!          On exit,
!          ErrStat(1) = min error
!          ErrStat(2) = max error
!          ErrStat(3) = rms error

use Symmetry_Info, only: Mul
use Cholesky, only: nSym, NumCho
use ChoMP2, only: EOcc, EVir, Incore, iOcc, iT1am, iVir, lUnit_F, nMP2Vec, nOcc, nT1am, nVir, OldVec
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iSym, nDim, nCol, lWrk
real(kind=wp), intent(inout) :: Col(nDim,nCol)
real(kind=wp), intent(out) :: Wrk(lWrk), ErrStat(3)
integer(kind=iwp) :: a, b, i, iai, iai0, iBatCol, ibj, ibj0, ibj1, iCol, iSyma, iSymb, iSymi, iSymj, j, kai, kbj, lU, Nai, &
                     nBatCol, Nbj, NumCol, NumVec
real(kind=wp) :: DE, Ebj, Fac, xdim
character(len=*), parameter :: SecNam = 'ChoMP2_DecChk_2'
real(kind=wp), external :: ddot_

irc = 0

! Check dimensions.
! -----------------

if ((nDim < 1) .or. (nCol < 1)) return
if (nDim /= nT1am(iSym)) then
  irc = -1
  return ! exit
end if

! Initialize.
! -----------

ErrStat(1) = 9.9e15_wp
ErrStat(2) = -9.9e15_wp
ErrStat(3) = Zero

! Set up batching over columns of the (ai|bj) matrix.
! ---------------------------------------------------

NumCol = min(nCol,nT1am(iSym))
nBatCol = (nT1am(iSym)-1)/NumCol+1

! Start column batch loop.
! ------------------------

Nai = nDim
do iBatCol=1,nBatCol

  ! Set batch info.
  ! ---------------

  if (iBatCol == nBatCol) then
    Nbj = nT1am(iSym)-NumCol*(nBatCol-1)
  else
    Nbj = NumCol
  end if
  ibj1 = NumCol*(iBatCol-1)+1

  ! Compute amplitudes from "old" vectors.
  ! --------------------------------------

  if (InCore(iSym)) then
    call DGEMM_('N','T',Nai,Nbj,NumCho(iSym),One,OldVec,Nai,OldVec(ibj1),Nai,Zero,Col,Nai)
  else
    lU = lUnit_F(iSym,1)
    NumVec = NumCho(iSym)
    Fac = Zero
    call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,Wrk,lWrk,Fac)
    if (irc /= 0) then
      write(u6,*) SecNam,': ChoMP2_DecChk_Int returned ',irc,' [2]'
      irc = 2
      return
    end if
  end if

  ibj0 = ibj1-1
  do iCol=1,Nbj
    ibj = ibj0+iCol
    call ChoMP2_Col_Invai(ibj,iSym,b,iSymb,j,iSymj)
    Ebj = EVir(iVir(iSymb)+b)-Eocc(iOcc(iSymj)+j)
    do iSymi=1,nSym
      iSyma = Mul(iSymi,iSym)
      do i=1,nOcc(iSymi)
        iai0 = iT1am(iSyma,iSymi)+nVir(iSyma)*(i-1)
        do a=1,nVir(iSyma)
          iai = iai0+a
          DE = EVir(iVir(iSyma)+a)-EOcc(iOcc(iSymi)+i)+Ebj
          Col(iai,iCol) = Col(iai,iCol)/DE
        end do
      end do
    end do
  end do

  ! Compute amplitudes from "new" vectors and subtract "old".
  ! ---------------------------------------------------------

  lU = lUnit_F(iSym,2)
  NumVec = nMP2Vec(iSym)
  Fac = -One
  call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,Wrk,lWrk,Fac)
  if (irc /= 0) then
    write(u6,*) SecNam,': ChoMP2_DecChk_Int returned ',irc,' [1]'
    irc = 1
    return
  end if

  ! Compute error stats.
  ! --------------------

  do kbj=1,Nbj
    do kai=1,Nai
      ErrStat(1) = min(ErrStat(1),Col(kai,kbj))
      ErrStat(2) = max(ErrStat(2),Col(kai,kbj))
    end do
  end do
  ErrStat(3) = ErrStat(3)+dDot_(Nai*Nbj,Col,1,Col,1)

end do

! Compute rms error.
! ------------------

xdim = real(Nai,kind=wp)**2
ErrStat(3) = sqrt(ErrStat(3)/xdim)

end subroutine ChoMP2_DecChk_2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine EFPrm(Zeta,ZInv,rKappa,P,rFinal,nZeta,nComp,la,lb,A,RB,Array,nArr,Ccoor,nOrdOp)
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of electric field         *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, January '91                             *
!                                                                      *
! Modified for explicit code, R. Lindh, February '95.                  *
!***********************************************************************

use Index_Functions, only: nTri_Elem1, nTri3_Elem1
use Rys_interfaces, only: cff2d_kernel, modu2_kernel, rys2d_kernel, tval_kernel
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nZeta, nComp, la, lb, nArr, nOrdOp
real(kind=wp), intent(in) :: Zeta(nZeta), ZInv(nZeta), rKappa(nZeta), P(nZeta,3), A(3), RB(3), Ccoor(3)
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nComp)
real(kind=wp), intent(inout) :: Array(nZeta*nArr)
integer(kind=iwp) :: iAnga(4), ip1, ip2, ip3, ipIn, kab, lab, labcd, lcd, mabMax, mabMin, mArr, mcdMax, mcdMin, nFlop, nMem, nT
real(kind=wp) :: CoorAC(3,2), Coori(3,4)
logical(kind=iwp) :: NoSpecial
procedure(cff2d_kernel) :: XCff2D
procedure(modu2_kernel) :: Fake
procedure(rys2d_kernel) :: XRys2D
procedure(tval_kernel) :: TNAI
logical(kind=iwp), external :: EQ
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iElem, jElem
character(len=80) :: Label
#endif

rFinal(:,:,:,:) = Zero

iAnga(1) = la
iAnga(2) = lb
iAnga(3) = nOrdOp
iAnga(4) = 0
Coori(:,1) = A(:)
Coori(:,2) = RB(:)
mabMin = nTri3_Elem1(max(la,lb)-1)
mabMax = nTri3_Elem1(la+lb)-1
if (EQ(A,RB)) mabMin = nTri3_Elem1(la+lb-1)
mcdMin = nTri3_Elem1(nOrdOp-1)
mcdMax = nTri3_Elem1(nOrdOp)-1
lab = (mabMax-mabMin+1)
kab = nTri_Elem1(la)*nTri_Elem1(lb)
lcd = (mcdMax-mcdMin+1)
labcd = lab*lcd

! Compute Flop's and size of work array which HRR will Use.

call mHRR(la,lb,nFLOP,nMem)

! Distribute the work array

ip2 = 1
ip1 = ip2+nZeta*max(labcd,lcd*nMem)
mArr = nArr-max(labcd,lcd*nMem)

! Find center to accumulate angular momentum on. (HRR)

if (la >= lb) then
  CoorAC(:,1) = A(:)
else
  CoorAC(:,1) = RB(:)
end if

CoorAC(:,2) = Ccoor(:)
Coori(:,3) = Ccoor(:)
Coori(:,4) = Ccoor(:)

! Compute integrals with the Rys-Gauss quadrature.

nT = nZeta
NoSpecial = .true.
call Rys(iAnga,nT,Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,CCoor,1,rKappa,[One],Coori,Coori,CoorAC,mabMin,mabMax,mcdMin,mcdMax, &
         Array(ip1),mArr*nZeta,TNAI,Fake,XCff2D,XRys2D,NoSpecial)

! The integrals are now ordered as ijkl,e,f

! a) Change the order to f,ijkl,e
! b) Unfold e to ab, f,ijkl,ab
! c) Change the order back to ijkl,ab,f

!a)--

call DGetMO(Array(ip1),nZeta*lab,nZeta*lab,lcd,Array(ip2),lcd)

!b)-- Use the HRR to unfold e to ab

call HRR(la,lb,A,RB,Array(ip2),lcd*nZeta,nMem,ipIn)
ip3 = ip2-1+ipIn

!c)--

call DGetMO(Array(ip3),lcd,lcd,nZeta*kab,rFinal,nZeta*kab)
rFinal(:,:,:,1:lcd) = -rFinal(:,:,:,1:lcd)

#ifdef _DEBUGPRINT_
write(u6,*) ' In EFPrm la,lb=',la,lb
do iElem=1,nTri_Elem1(la)
  do jElem=1,nTri_Elem1(lb)
    if (lcd == 1) then
      write(Label,'(A,I2,A,I2,A)') ' EFPrm: rFinal (',iElem,',',jElem,') '
      call RecPrt(Label,' ',rFinal(1,iElem,jElem,1),nZeta,1)
    else if (lcd == 3) then
      write(Label,'(A,I2,A,I2,A)') ' EFPrm: rFinal (',iElem,',',jElem,',x) '
      call RecPrt(Label,' ',rFinal(1,iElem,jElem,1),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' EFPrm: rFinal (',iElem,',',jElem,',y) '
      call RecPrt(Label,' ',rFinal(1,iElem,jElem,2),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' EFPrm: rFinal (',iElem,',',jElem,',z) '
      call RecPrt(Label,' ',rFinal(1,iElem,jElem,3),nZeta,1)
    end if
  end do
end do
#endif

return

end subroutine EFPrm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine BdVGrd(                                                &
#define _FIXED_FORMAT_
#define _CALLING_
#include "grd_interface.fh"
     &                 )
      use Index_Functions, only: nTri_Elem1
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "grd_interface.fh"
#include "espf.fh"
*
      External TNAI1, Fake, XCff2D
#include "print.fh"
#include "disp.fh"
      Integer iDCRT(0:7)
      Logical ESPFexist
      Character*180 Key,Get_Ln
      External Get_Ln
*
*-----Local arrays
*
      Real*8 C(3), TC(3), Coori(3,4), CoorAC(3,2), ZFd(3),TZFd(3)
      Logical NoLoop, JfGrad(3,4)
      Integer iAnga(4), iStb(0:7),
     &          jCoSet(8,8), JndGrd(3,4), lOp(4), iuvwx(4)
      Character ChOper(0:7)*3
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iPrint = 5
*
*---- Modify the density matrix with the prefactor
*
      nDAO = nElem(la) * nElem(lb)
      Do iDAO = 1, nDAO
         Do iZeta = 1, nZeta
            Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
            DAO(iZeta,iDAO) = Fact * DAO(iZeta,iDAO)
         End Do
      End Do
      If (iPrint.ge.99) Then
         Call RecPrt('DAO',' ',DAO,nZeta,nDAO)
         Call RecPrt('Alpha',' ',Alpha,1,nAlpha)
         Call RecPrt('Beta ',' ',Beta ,1,nBeta )
         Call RecPrt('Zeta ',' ',Zeta ,1,nZeta )
      End If
*
*---- Loop over charges and dipole moments in the external field
*
      iOrdOp = 0
*
      nip = 1
      ipA = nip
      nip = nip + nAlpha*nBeta
      ipB = nip
      nip = nip + nAlpha*nBeta
      ipDAO = nip
      nip = nip + nAlpha*nBeta*nElem(la)*nElem(lb)*nElem(iOrdOp)
      If (nip-1.gt.nZeta*nArr) Then
         Write (6,*) 'nip-1.gt.nZeta*nArr'
         Call ErrTra
         Call Abend
      End If
      nArray = nZeta*nArr - nip + 1
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = iOrdOp
      iAnga(4) = 0
      call dcopy_(3, A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
*
*     Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
       call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
       call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      lOp(1) = kOp(1)
      lOp(2) = kOp(2)
*
      ipAOff = ipA
      Do iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
      End Do
*
      ipBOff = ipB
      Do iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
      End Do
*
*     Loop over centers of the grid
*     But how to retrieve the grid ???
*     I just read it in the ESPF file !
      Call F_Inquire('ESPF.DATA',ESPFExist)
      If (.not.ESPFExist) Then
         Write(6,*)' Error ! No ESPF.DATA file found'
         Call Quit_OnUserError()
      EndIf
      IPotFl = IsFreeUnit(1)
      Call Molcas_Open(IPotFl,'ESPF.DATA')
10    Key = Get_Ln(IPotFl)
      If (Key(1:10).eq.'GRID      ') Then
         Call Get_I1(2,nGrdPt)
         Goto 11
      EndIf
      Goto 10
11    Close (IPotFl)
*
      iDum=0
      Do iPnt = 1, nGrdPt
         ZFd(1)=CCoor((iPnt-1)*4+4)
         NoLoop = ZFd(1).eq.Zero
         If (NoLoop) Go To 111
*------- Pick up the center coordinates
         C(1)=CCoor((iPnt-1)*4+1)
         C(2)=CCoor((iPnt-1)*4+2)
         C(3)=CCoor((iPnt-1)*4+3)

         If (iPrint.ge.99) Call RecPrt('C',' ',C,1,3)
*
*------- Generate stabilizer of C
*
         iChxyz=iChAtm(C)
         Call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)
*
*--------Find the DCR for M and S
*
         Call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
         Fact = -DBLE(nStabM) / DBLE(LmbdT)
*
         If (iPrint.ge.99) Then
            Write (6,*) ' ZFd=',(ZFd(i),i=1,nElem(iOrdOp))
            Write (6,*) ' Fact=',Fact
            Call RecPrt('DAO*Fact*ZFd()',' ',Array(ipDAO),nZeta*nDAO,
     &                   nElem(iOrdOp))
            Write (6,*) ' m      =',nStabM
            Write (6,'(9A)') '(M)=',(ChOper(iStabM(ii)),
     &            ii = 0, nStabM-1)
            Write (6,*) ' s      =',nStb
            Write (6,'(9A)') '(S)=',(ChOper(iStb(ii)),
     &            ii = 0, nStb-1)
            Write (6,*) ' LambdaT=',LmbdT
            Write (6,*) ' t      =',nDCRT
            Write (6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),
     &            ii = 0, nDCRT-1)
         End If
         iuvwx(3) = nStb
         iuvwx(4) = nStb
         Call ICopy(6,IndGrd,1,JndGrd,1)
         Do i = 1, 3
            Do j = 1, 2
               JfGrad(i,j) = IfGrad(i,j)
            End Do
         End Do
*
*------- No derivatives with respect to the third or fourth center.
*        The positions of the points in the external field are frozen.
*
         Call ICopy(3,[0],0,JndGrd(1,3),1)
         JfGrad(1,3) = .False.
         JfGrad(2,3) = .False.
         JfGrad(3,3) = .False.
         Call ICopy(3,[0],0,JndGrd(1,4),1)
         JfGrad(1,4) = .False.
         JfGrad(2,4) = .False.
         JfGrad(3,4) = .False.
         mGrad = 0
         Do iCar = 1, 3
            Do i = 1, 2
               If (JfGrad(iCar,i)) mGrad = mGrad + 1
            End Do
         End Do
         If (iPrint.ge.99) Write (6,*) ' mGrad=',mGrad
         If (mGrad.eq.0) Go To 111
*
         Do lDCRT = 0, nDCRT-1
            lOp(3) = NrOpr(iDCRT(lDCRT))
            lOp(4) = lOp(3)
            Call OA(iDCRT(lDCRT),C,TC)
            call dcopy_(3,TC,1,CoorAC(1,2),1)
            call dcopy_(3,TC,1,Coori(1,3),1)
            call dcopy_(3,TC,1,Coori(1,4),1)
*
            If (iOrdOp.eq.0) Then
               Call DYaX(nZeta*nDAO,Fact*ZFd(1),DAO,1,Array(ipDAO),1)
            Else
               Call OA(iDCRT(lDCRT),ZFd,TZFd)
               jpDAO = ipDAO
               ZFdx=TZFd(1)
               Call DYaX(nZeta*nDAO,Fact*ZFdx,DAO,1,Array(jpDAO),1)
               jpDAO = jpDAO + nZeta*nDAO
               ZFdy=TZFd(2)
               Call DYaX(nZeta*nDAO,Fact*ZFdy,DAO,1,Array(jpDAO),1)
               jpDAO = jpDAO + nZeta*nDAO
               ZFdz=TZFd(3)
               Call DYaX(nZeta*nDAO,Fact*ZFdz,DAO,1,Array(jpDAO),1)
            End If
*
*           Compute integrals with the Rys quadrature.
*
            nT = nZeta
            nDiff=1
            mRys=(la+lb+2+nDiff+iOrdOp)/2
            Call Rysg1(iAnga,mRys,nT,
     &                 Array(ipA),Array(ipB),[One],[One],
     &                 Zeta,ZInv,nZeta,
     &                 [One],[One],1,
     &                 P,nZeta,TC,1,Coori,Coori,CoorAC,
     &                 Array(nip),nArray,
     &                 TNAI1,Fake,XCff2D,
     &                 Array(ipDAO),nDAO*nElem(iOrdOp),
     &                 Grad,nGrad,JfGrad,JndGrd,lOp,iuvwx)
*
*           Call RecPrt(' In XFdGrd:Grad',' ',Grad,nGrad,1)
         End Do  ! End loop over DCRs
*
111      Continue
      End Do     ! End loop over centers in the grid
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(rFinal)
        Call Unused_integer(nHer)
        Call Unused_integer(nOrdOp)
        Call Unused_integer(nComp)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  quater
!
!> @brief
!>   Driver for quater
!> @author Y. Carissan
!>
!> @details
!> Driver for quater.
!>
!> @param[out] ireturn return code
!***********************************************************************

subroutine quater(ireturn)

use Quater_globals, only: debug
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
real(kind=wp) :: U1(3), U2(3), V1(3), V2(3), V1best(3), V2best(3), Q(0:3)

debug = .false.
call quaterinit()

call RdInput_Quater(U1,U2,V1,V2)

if (debug) then
  write(u6,*) 'Reference axis'
  call RecPrt('U1',' ',U1,3,1)
  call RecPrt('U2',' ',U2,3,1)
  write(u6,*) 'New axis'
  call RecPrt('V1',' ',V1,3,1)
  call RecPrt('V2',' ',V2,3,1)
end if

call QuaterSolve(U1,U2,V1,V2,Q)

! for test
call Add_Info('Quaternion',Q,4,8)

if (debug) then
  write(u6,*) 'Normalized Reference axis'
  call RecPrt('U1',' ',U1,3,1)
  call RecPrt('U2',' ',U2,3,1)
  write(u6,*) 'Normalized New axis'
  call RecPrt('V1',' ',V1,3,1)
  call RecPrt('V2',' ',V2,3,1)
  call QuaterRotation(Q,U1,V1best)
  call QuaterRotation(Q,U2,V2best)
  call RecPrt('Best V1',' ',V1best,3,1)
  call RecPrt('Best V2',' ',V2best,3,1)
end if

call GenerateGeoms(Q)

call QuaterReport(V1best,V2best,V1,V2)

call QuaterFinish()

ireturn = 0

return

end subroutine quater

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_XCV_TmpFiles(irc,iOpt)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iOpt

irc = 0
if (iOpt == 1) then
  call Cho_XCV_OpenTmpFiles()
else if (iOpt == 2) then
  call Cho_XCV_CloseAndKeepTmpFiles()
else if (iOpt == 3) then
  call Cho_XCV_CloseAndEraseTmpFiles()
else
  irc = 1
end if

return

end subroutine Cho_XCV_TmpFiles

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_MaxDX(Diag,Sync,Dmax)
!
! Purpose: get max. diagonal elements in each sym. block,
!          qualified diagonals excluded.

use Cholesky, only: Cho_Real_Par, Diag_G
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: Diag(*)
real(kind=wp), intent(_OUT_) :: Dmax(*)
logical(kind=iwp), intent(in) :: Sync
integer(kind=iwp) :: iLoc

if (Cho_Real_Par) then
  if (Sync) then
    iLoc = 2
    call Cho_P_SyncDiag(Diag,iLoc)
  end if
  call Cho_P_IndxSwp()
  call Cho_MaxDX(Diag_G,Dmax)
  call Cho_P_IndxSwp()
else
  call Cho_MaxDX(Diag,Dmax)
end if

end subroutine Cho_P_MaxDX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_T_contractors

! Module containing routines to generate contributions to a
! multipole potential on the fly.
! Note that another module allows contraction of T-pairs to generate
! an energy or J-matrix directly (e.g.to exploit symmetry).

   USE fmm_global_paras
   USE fmm_stats
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_init_T_contractors,          &
             fmm_free_T_contractors,          &
             fmm_select_T_con,                &
             fmm_set_T_con_ptrs

   ! Public variable to stop the resetting of T_con pointers with open T-buffer
   PUBLIC :: fmm_lock_T_con

   REAL(REALK), ALLOCATABLE, SAVE :: T_matrix(:,:)
   INTEGER(INTK),            SAVE :: TLDA
   ! when building multiple T matrices together
   REAL(REALK), ALLOCATABLE, SAVE :: T_mats(:,:,:)

   ! Pointers to actual moments and potentials described elsewhere
   REAL(REALK), POINTER, SAVE :: Vff_ptr(:,:)
   REAL(REALK), POINTER, SAVE :: qlm_ptr(:,:)

   ! Diagnostic variables
   CHARACTER(LEN=11), SAVE :: T_con_stat
   LOGICAL,       SAVE :: fmm_lock_T_con

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_T_contractors(scheme)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      INTEGER(INTK) :: LMAX, T_con
      INTEGER(INTK) :: lm_max

      LMAX = scheme%trans_lmax
      lm_max = (LMAX+1)**2
      IF (scheme%phase == NEAR_FIELD) THEN
         T_con = scheme%T_con%NF_id
      ELSE
         T_con = scheme%T_con%FF_id
      END IF

      SELECT CASE (T_con)
         CASE (T_CONTRACTOR_MULTI)
            IF (ALLOCATED(T_mats)) CALL fmm_quit('T_mats not deallocated!')
!FIXME: will need to change TMATM_DF if changed elsewhere
            ALLOCATE(T_mats(TMATM_DF,lm_max,lm_max))
            T_mats = zero
         CASE (T_CONTRACTOR_BOUNDARY)
            IF (ALLOCATED(T_matrix)) CALL fmm_quit('T_matrix not deallocated!')
            ALLOCATE(T_matrix(lm_max,1))
            T_matrix = zero
         CASE DEFAULT
            IF (ALLOCATED(T_matrix)) CALL fmm_quit('T_matrix not deallocated!')
            ALLOCATE(T_matrix(lm_max,lm_max))
            T_matrix = zero
      END SELECT
      TLDA = lm_max

      ! code for statistics only
      CALL fmm_init_matrix_stats('T')

   END SUBROUTINE fmm_init_T_contractors

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_free_T_contractors

      IMPLICIT NONE

      IF (ALLOCATED(T_matrix)) DEALLOCATE(T_matrix)
      IF (ALLOCATED(T_mats)) DEALLOCATE(T_mats)

   END SUBROUTINE fmm_free_T_contractors

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_set_T_con_ptrs(Vff,qlm)

      IMPLICIT NONE
      REAL(REALK), TARGET, INTENT(IN) :: Vff(:,:), qlm(:,:)

      IF (T_con_stat /= 'initialised') STOP 'no T_contractor preselected!'
      IF (fmm_lock_T_con) STOP 'T_buffer not empty! Cannot reset T_con!'
      NULLIFY (Vff_ptr, qlm_ptr)
      Vff_ptr => Vff(:,:)
      qlm_ptr => qlm(:,:)

   END SUBROUTINE fmm_set_T_con_ptrs

!-------------------------------------------------------------------------------
! Built for DIRECT scheme.  Can only take one T_pair at a time.
! Only generates a square T-matrix with dim = MAX(LHS_LMAX,RHS_LMAX)
! Generates local potential to order MAX(LHS_LMAX,RHS_LMAX)
! Adds to Vff only up to LHS_LMAX.
! FIXME: because T_matrix is only built for (l+j)<=LMAX then with dynamic
! contraction we need LEXTRA>0 even for primitive basis sets and FQUAD.

   SUBROUTINE fmm_T_con_DIRECT(T_pair)

      USE fmm_T_worker, ONLY: fmm_get_SPLTSQ_T_matrix,  &
                              fmm_contract_Tq

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: T_pair

      REAL(REALK)   :: Vff_tmp(T_pair%lm_max)
      INTEGER(INTK) :: weight, iLHS,iRHS, hi

      stat_T_mat_builds = stat_T_mat_builds + one
      CALL fmm_get_SPLTSQ_T_matrix(T_pair%LMAX,T_pair%r_ab,T_matrix)

      iRHS = T_pair%paras%RHS_id
      hi = T_pair%lm_max

      Vff_tmp = fmm_contract_Tq(T_pair%LMAX,qlm_ptr(:hi,iRHS),T_matrix)
      iLHS = T_pair%paras%LHS_id
      hi = (1+T_pair%paras%LHS_LMAX)**2
      weight = T_pair%paras%weight
      !WRITE(LUPRI,*) iRHS, qlm_ptr(1,iRHS), weight, Vff_tmp(:hi)
      Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS) + weight*Vff_tmp(:hi)

   END SUBROUTINE fmm_T_con_DIRECT

!-------------------------------------------------------------------------------
! Modification of T_con_DIRECT for evaluation of boundary potential
! when only the first element of Vff needs to be built

   SUBROUTINE fmm_T_con_BOUNDARY(T_pair)

      USE fmm_T_worker, ONLY: fmm_get_boundary_T_matrix

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: T_pair

      REAL(REALK)   :: Vff_tmp
      INTEGER(INTK) :: weight, iLHS,iRHS, hi

      stat_T_mat_builds = stat_T_mat_builds + one
      CALL fmm_get_boundary_T_matrix(T_pair%LMAX,T_pair%r_ab,T_matrix)

      iRHS = T_pair%paras%RHS_id
      hi = T_pair%lm_max

      Vff_tmp = half*DOT_PRODUCT(qlm_ptr(:hi,iRHS),T_matrix(:hi,1))

      iLHS = T_pair%paras%LHS_id
      hi = (1+T_pair%paras%LHS_LMAX)**2
      weight = T_pair%paras%weight
      !WRITE(LUPRI,*) iRHS, qlm_ptr(1,iRHS), weight, Vff_tmp

      Vff_ptr(1,iLHS) = Vff_ptr(1,iLHS) + weight*Vff_tmp

   END SUBROUTINE fmm_T_con_BOUNDARY

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_T_con_TREE(T_pairs)

      USE fmm_T_worker, ONLY: fmm_get_SPLTSQ_T_matrix,    &
                              fmm_contract_Tq

      IMPLICIT NONE
      TYPE(T_pair_list), INTENT(IN) :: T_pairs

      REAL(REALK)   :: Vff_tmp(T_pairs%lm_max)
      REAL(REALK)   :: lastlen, r_pq(3), r_pq_mod(3)
      INTEGER(INTK) :: LMAX, weight, i, p,q, hi

      r_pq_mod(:) = T_pairs%r_ab(:)
      LMAX = T_pairs%LMAX
      lastlen = zero

      DO i = 1, SIZE(T_pairs%paras)

         p = T_pairs%paras(i)%LHS_id
         q = T_pairs%paras(i)%RHS_id

         IF(ABS(T_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) THEN
            stat_T_mat_builds = stat_T_mat_builds + one
            r_pq = r_pq_mod * T_pairs%paras(i)%ratio
            CALL fmm_get_SPLTSQ_T_matrix(LMAX,r_pq,T_matrix)
            lastlen = T_pairs%paras(i)%ratio
         END IF

         hi = T_pairs%lm_max
         Vff_tmp = fmm_contract_Tq(LMAX,qlm_ptr(:hi,q),T_matrix)
         hi = (1+T_pairs%paras(i)%LHS_LMAX)**2
         weight = T_pairs%paras(i)%weight
         Vff_ptr(:hi,p) = Vff_ptr(:hi,p) + weight*Vff_tmp(:hi)

      END DO

   END SUBROUTINE fmm_T_con_TREE

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_T_con_SCALE(T_pairs)

      USE fmm_T_worker, ONLY: fmm_get_SPLTSQ_T_matrix,    &
                              fmm_contract_Tq,            &
                              fmm_scale_vec

      IMPLICIT NONE
      TYPE(T_pair_batch), INTENT(IN) :: T_pairs

      INTEGER(INTK) :: LMAX, i, p,q, hi, lastq
      REAL(REALK)   :: ratio, lastlen, pref
      REAL(REALK)   :: Vff_tmp(T_pairs%items(1)%lm_max)
      REAL(REALK)   :: scaled_qlm(T_pairs%items(1)%lm_max)
      REAL(REALK)   :: scale_vec(T_pairs%items(1)%lm_max)
      LOGICAL       :: new_vec

      pref = one
      lastq = -1
      lastlen = one
      scale_vec(:) = one
      LMAX = T_pairs%items(1)%LMAX
      stat_T_mat_builds = stat_T_mat_builds + one
      CALL fmm_get_SPLTSQ_T_matrix(LMAX,T_pairs%items(1)%r_ab,T_matrix)

      iloop: DO i = 1, T_pairs%ndim

         p = T_pairs%items(i)%paras%LHS_id
         q = T_pairs%items(i)%paras%RHS_id

         new_vec = .FALSE.
         ratio = T_pairs%items(i)%paras%ratio
         IF (ABS(ratio-lastlen) > DISTINCT_T_TOL) THEN
            CALL fmm_scale_vec(LMAX,ratio,scale_vec,pref)
            lastlen = ratio
            new_vec = .TRUE.
         END IF

         hi = T_pairs%items(i)%lm_max
         IF ( new_vec .OR. (q /= lastq) ) THEN
            scaled_qlm = scale_vec(:hi)*qlm_ptr(:hi,q)
            lastq = q
         END IF

         Vff_tmp = fmm_contract_Tq(LMAX,scaled_qlm(:hi),T_matrix(:hi,:hi))

         hi = (1+T_pairs%items(i)%paras%LHS_LMAX)**2
         Vff_ptr(:hi,p) = Vff_ptr(:hi,p) + pref*scale_vec(:hi)*Vff_tmp(:hi)

      END DO iloop

   END SUBROUTINE fmm_T_con_SCALE

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_T_con_SCALE_TREE(T_pairs)

      USE fmm_T_worker, ONLY: fmm_get_SPLTSQ_T_matrix,    &
                              fmm_contract_Tq,            &
                              fmm_scale_vec

      IMPLICIT NONE
      TYPE(T_pair_list), INTENT(IN) :: T_pairs

      INTEGER(INTK) :: LMAX, i, p,q, hi, lastq
      REAL(REALK)   :: weight, lastlen, pref
      REAL(REALK)   :: Vff_tmp(T_pairs%lm_max)
      REAL(REALK)   :: scaled_qlm(T_pairs%lm_max)
      REAL(REALK)   :: scale_vec(T_pairs%lm_max)
      LOGICAL       :: new_vec

      pref = one
      lastq = -1
      lastlen = one
      scale_vec(:) = one
      LMAX = T_pairs%LMAX
      stat_T_mat_builds = stat_T_mat_builds + one
      CALL fmm_get_SPLTSQ_T_matrix(LMAX,T_pairs%r_ab,T_matrix)

      iloop: DO i = 1, SIZE(T_pairs%paras)

         p = T_pairs%paras(i)%LHS_id
         q = T_pairs%paras(i)%RHS_id

         new_vec = .FALSE.
         IF(ABS(T_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) THEN
            CALL fmm_scale_vec(LMAX,T_pairs%paras(i)%ratio,scale_vec,pref)
            lastlen = T_pairs%paras(i)%ratio
            new_vec = .TRUE.
         END IF

         hi = T_pairs%lm_max
         IF ( new_vec .OR. (q /= lastq) ) THEN
            scaled_qlm = scale_vec(:hi)*qlm_ptr(:hi,q)
            lastq = q
         END IF

         Vff_tmp = fmm_contract_Tq(LMAX,scaled_qlm(:hi),T_matrix(:hi,:hi))

         hi = (1+T_pairs%paras(i)%LHS_LMAX)**2
         weight = pref*T_pairs%paras(i)%weight
         Vff_ptr(:hi,p) = Vff_ptr(:hi,p) + weight*scale_vec(:hi)*Vff_tmp(:hi)

      END DO iloop

   END SUBROUTINE fmm_T_con_SCALE_TREE

!-------------------------------------------------------------------------------
! Special contractor designed to take batch of T-pairs ordered in pairs
! such that ( b T1 1; a -T1 2; c T2 1; a -T2 3 ....)
! to halve the number of T matrix builds (using fmm_scale...)
! But only the common RHS qlm can be contracted simultaneously which slows
! it down a lot.
!
!   SUBROUTINE fmm_T_con_MULTI(T_pairs)
!
!      USE fmm_T_worker_multi, ONLY: fmm_get_SPLTSQ_T_matrices,    &
!                                   fmm_contract_multi_Tq
!      USE fmm_T_worker,       ONLY: fmm_contract_Tq, fmm_scale_vec
!
!      IMPLICIT NONE
!      TYPE(T_pair_batch), INTENT(IN) :: T_pairs
!
!      REAL(REALK), ALLOCATABLE :: Vff_tmp(:,:)
!
!      REAL(REALK), ALLOCATABLE :: scaled_qlm(:)
!      REAL(REALK), ALLOCATABLE :: scale_vec(:)
!
!      REAL(REALK)   :: T_vectors((T_pairs%ndim/2),3)
!      REAL(REALK)   :: pref, weight
!      INTEGER(INTK) :: i,j, iLHS,iRHS,iRHS_last, hi, LMAX, nT
!
!      ! FIRST DO MULTIPLE T contracted with SAME RHS
!      !---------------------------------------------
!
!      IF (BTEST(T_pairs%ndim,0)) CALL fmm_quit('ndim not EVEN!')
!      nT = T_pairs%ndim/2
!
!      LMAX = 0
!      iRHS_last = T_pairs%items(1)%paras%RHS_id
!      DO i = 1, nT
!         j = 2*i-1
!         LMAX = MAX(LMAX,T_pairs%items(i)%LMAX)
!         iRHS = T_pairs%items(j)%paras%RHS_id
!         ! get *distinct* T-vectors as every second item in batch
!         T_vectors(i,:) = T_pairs%items(j)%r_ab(:)
!         IF (iRHS /= iRHS_last) CALL fmm_quit('must have same qlm on RHS')
!         iRHS_last = iRHS
!      END DO
!
!      stat_T_mat_builds = stat_T_mat_builds + nT
!      CALL fmm_get_SPLTSQ_T_matrices(nT,LMAX,T_vectors,T_mats(:nT,:,:))
!
!      hi = (1+LMAX)**2
!      ALLOCATE( Vff_tmp(nT,hi) )
!      ALLOCATE( scaled_qlm(hi) )
!      ALLOCATE( scale_vec(hi) )
!      Vff_tmp(:,:) = zero
!      scale_vec(:) = one
!
!      iRHS = T_pairs%items(1)%paras%RHS_id
!
!      Vff_tmp(:,:hi) = fmm_contract_multi_Tq(LMAX,qlm_ptr(:hi,iRHS),    &
!                                            T_mats(:nT,:,:),nT)
!
!      DO i = 1, nT
!         j = 2*i-1
!         iLHS = T_pairs%items(j)%paras%LHS_id
!         hi = (1+T_pairs%items(j)%paras%LHS_LMAX)**2
!         weight = T_pairs%items(j)%paras%weight
!         Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS) + weight*Vff_tmp(i,:hi)
!      END DO
!
!      ! NOW DO remaining half of batched T-pairs corresponding to same LHS
!      !-------------------------------------------------------------------
!
!      iLHS = T_pairs%items(2)%paras%LHS_id
!      DO i = 1, nT
!         ! get T_matrix correpxonding to the minus T-vector
!         CALL fmm_scale_vec(LMAX,-one,scale_vec,pref)
!         iRHS = T_pairs%items(2*i)%paras%RHS_id
!         scaled_qlm = scale_vec(:hi)*qlm_ptr(:hi,iRHS)
!         Vff_tmp(1,:hi) = fmm_contract_Tq(LMAX,scaled_qlm(:hi),T_mats(i,:,:))
!         weight = pref
!         Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS)  &
!                             + weight*scale_vec(:hi)*Vff_tmp(1,:hi)
!      END DO
!
!      DEALLOCATE(Vff_tmp)
!      DEALLOCATE(scaled_qlm)
!      DEALLOCATE(scale_vec)
!
!   END SUBROUTINE fmm_T_con_MULTI

!-------------------------------------------------------------------------------
! Contractor designed to build multiple T matrices simultaneously.
! Exact performance will depend on architecture and choice of NDIM.
! Assumes RHS moments are the same, but T-vectors are different.

   SUBROUTINE fmm_T_con_MULTI(T_pairs)

      USE fmm_multiple_T_worker, ONLY: fmm_get_SPLTSQ_T_matrices,    &
                                       fmm_contract_multi_Tq

      IMPLICIT NONE
      TYPE(T_pair_batch), INTENT(IN) :: T_pairs

      REAL(REALK)   :: Vff_tmp(T_pairs%ndim,T_pairs%items(1)%lm_max)
      REAL(REALK)   :: T_vectors(T_pairs%ndim,3)
      INTEGER(INTK) :: i, iLHS,iRHS, hi, LMAX, nT

      nT = T_pairs%ndim
      LMAX = T_pairs%items(1)%LMAX

      DO i = 1, nT
         T_vectors(i,:) = T_pairs%items(i)%r_ab
         iRHS = T_pairs%items(i)%paras%RHS_id
         IF ( iRHS /=  T_pairs%items(MAX(i-1,1))%paras%RHS_id ) THEN
            CALL fmm_quit('RHS moments not sorted in fmm_T_con_MULTI')
         END IF
      END DO

      stat_T_mat_builds = stat_T_mat_builds + nT
      CALL fmm_get_SPLTSQ_T_matrices(nT,LMAX,T_vectors,T_mats(:nt,:,:))

      iRHS = T_pairs%items(1)%paras%RHS_id
      hi = (1+LMAX)**2

      Vff_tmp(:,:hi) = fmm_contract_multi_Tq(LMAX,qlm_ptr(:hi,iRHS),    &
                                            T_mats(:nT,:,:),nT)

      DO i = 1, nT
         iLHS = T_pairs%items(i)%paras%LHS_id
         Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS) + Vff_tmp(i,:hi)
      END DO

   END SUBROUTINE fmm_T_con_MULTI

!-------------------------------------------------------------------------------
! Builds full T-matrix for exact contraction at low orders

   SUBROUTINE fmm_T_con_FULL(T_pair)

      USE fmm_T_worker, ONLY: fmm_get_FLTSQ_T_matrix, fmm_postfac_Vff,  &
                              fmm_contract_Tq

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: T_pair

      REAL(REALK)   :: Vff_tmp(T_pair%lm_max)
      INTEGER(INTK) :: iLHS,iRHS, hi

      stat_T_mat_builds = stat_T_mat_builds + one
      CALL fmm_get_FLTSQ_T_matrix(T_pair%LMAX,T_pair%r_ab,T_matrix)

      iRHS = T_pair%paras%RHS_id
      hi = T_pair%lm_max
      CALL DSYMV('L',hi,1d0,T_matrix,TLDA,qlm_ptr(:,iRHS),1,0D0,Vff_tmp,1)

      iLHS = T_pair%paras%LHS_id
      hi = (1+T_pair%paras%LHS_LMAX)**2
      CALL fmm_postfac_Vff(T_pair%paras%LHS_LMAX,Vff_tmp)
      Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS) + Vff_tmp(:hi)

   END SUBROUTINE fmm_T_con_FULL

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_select_T_con(scheme)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      INTEGER(INTK) :: T_con_ID
      EXTERNAL fmm_store_t_contractor

      IF (scheme%phase == NEAR_FIELD) THEN
         T_con_ID = scheme%T_con%NF_id
      ELSE
         T_con_ID = scheme%T_con%FF_id
      END IF

      SELECT CASE (T_con_ID)
         CASE (T_CONTRACTOR_DIRECT)
            CALL fmm_store_t_contractor(fmm_T_con_DIRECT)
         CASE (T_CONTRACTOR_BOUNDARY)
            CALL fmm_store_t_contractor(fmm_T_con_BOUNDARY)
         CASE (T_CONTRACTOR_TREE)
            CALL fmm_store_t_contractor(fmm_T_con_TREE)
         CASE (T_CONTRACTOR_SCALE_TREE)
            CALL fmm_store_t_contractor(fmm_T_con_SCALE_TREE)
         CASE (T_CONTRACTOR_SCALE)
            CALL fmm_store_t_contractor(fmm_T_con_SCALE)
         CASE (T_CONTRACTOR_MULTI)
            CALL fmm_store_t_contractor(fmm_T_con_MULTI)
         CASE (T_CONTRACTOR_FULL)
            CALL fmm_store_t_contractor(fmm_T_con_FULL)
         CASE DEFAULT
            CALL fmm_quit ('invalid T_contractor requested!')
      END SELECT
      ! initialise diagnostics
      T_con_stat = 'initialised'
      fmm_lock_T_con = .FALSE.

   END SUBROUTINE fmm_select_T_con

!-------------------------------------------------------------------------------

END MODULE fmm_T_contractors

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CLagEig(if_SSDMloc,force_equal,nConf,nRoots,nState,nLev,CLag,RDMEIG)

use caspt2_global, only: DREF, DWGT, OMGDER, Weight
use caspt2_module, only: IFDW, IFSADREF, ISCF, JSTATE, NASHT, ZETA
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: if_SSDMloc, force_equal
integer(kind=iwp), intent(in) :: nConf, nRoots, nState, nLev
real(kind=wp), intent(inout) :: CLag(nConf,nRoots)
real(kind=wp), intent(in) :: RDMEIG(nLev**2)
integer(kind=iwp) :: iState
real(kind=wp) :: Scal, WGT
real(kind=wp), allocatable :: CI1(:), WRK(:)
real(kind=wp), external :: DDOT_

! MODE=0: Either state-averaged or DWGT matrix
! MODE=1: XMS-specific term, always state-averaged DM

!! RDMEIG
call mma_allocate(CI1,nConf,Label='LCI')
call mma_allocate(WRK,max(NLEV,NASHT)**2,Label='WRK')

do iState=1,nState
  if (.not. if_SSDMloc) then
    if (force_equal .or. (.not. IFSADREF)) then
      WGT = One/nState ! force equal-weight for XMS
    else if (IFSADREF) then
      WGT = Weight(iState) ! can be unequal weight
    else
      WGT = One/nState ! this should not happen...
    end if
    if (abs(wgt) <= 1.0e-9_wp) cycle
    if (ISCF == 0) then
      call LoadCI(CI1,iState)
    else
      CI1(1) = One
    end if
    WRK(1:NLEV**2) = RDMEIG(1:NLEV**2)*WGT
    call Poly1_CLag(NCONF,NLEV,CI1,CLag(:,iState),WRK)
  else
    Wgt = DWgt(iState,jState)
    if (abs(wgt) > 1.0e-9_wp) then
      if (ISCF == 0) then
        call LoadCI(CI1,iState)
      else
        CI1(1) = One
      end if
      WRK(1:NLEV**2) = RDMEIG(1:NLEV**2)*WGT
      call Poly1_CLag(NCONF,NLEV,CI1,CLag(:,iState),WRK)
    end if

    !! Derivative of omega for dynamically weighted density
    if (IFDW .and. (zeta >= Zero)) then
      if (ISCF == 0) then
        call LoadCI(CI1,iState)
      else
        CI1(1) = One
      end if
      call POLY1(CI1,nConf)
      call GETDREF(DREF,size(DREF))
      call SQUARE(DREF,WRK,1,nAshT,nAshT)
      !! probably it is doubled somewhere, so should half
      Scal = DDOT_(nAshT**2,RDMEIG,1,WRK,1)*Half
      !write(u6,*) 'scal = ',scal
      OMGDER(iState,jState) = OMGDER(iState,jState)+Scal
    end if

  end if
end do

call mma_deallocate(WRK)
!write(u6,*) 'clag before projection'
!do istate=1,nstate
!  write(u6,*) 'state = ',istate
!  do i=1,nconf
!    write(u6,'(i3,f20.10)') i,clag(i,istate)
!  end do
!end do
!write(u6,*) 'debug'
!if (ORBIN == 'TRANSFOR') call CLagX_TrfCI(NCONF,CLAG)
!if (proj) then
!  ovl = ddot_(nconf*nstate,ci1,1,clag,1)
!  write(u6,*) 'projection coeff = ',ovl
!  clag(:,1:nstate) = clag(:,1:nstate)-ovl*ci1(nconf*nstate)
!  write(u6,*) 'clag after projection'
!  do istate=1,nstate
!    write(u6,*) 'state = ',istate
!    do i=1,nconf
!      write(u6,'(i3,f20.10)') i,clag(i,istate)
!    end do
!  end do
!end if

call mma_deallocate(CI1)

return

end subroutine CLagEig

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
!module_grad works for the ci gradient calculations.
! subroutine ci_grad
! subroutine ci_density_label
! subroutine convert_vector
! subroutine trans_ijkl_intpos
! subroutine trans_intpos_ijkl
! subroutine square_canonical
! subroutine moread
! subroutine lagran
! subroutine cidensity_test
      subroutine ci_grad
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "grad_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      common /lgrn/ xlgrn(max_orb,max_orb)
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      common /grad_xyz/dxyz(3,max_atom),numat
      common /ncprhf/ nrot,nxyz,ndbl,next,nsolv,nres,n_frz,n_all
      parameter (htoklm=627.50956d+00,zero=0.0d+00)
c================================================
c    the main subroutine for ci gradient calculations.
c    ican_a and ican_b save canonical order.
c    e(*) save the scf orbital energies.
c    xlgrn(*) save the lagrangian matrix.

c ci gradient is still in developing, so we do not include it in current
c version of xian-ci

      return

      write(6,'(a18,2x,f10.2,2x,a1)') 'end of grad, takes',sc5-sc0,'s'
      end


      subroutine convert_vector()
#include "drt_h.fh"
c=====================================================
!    this just uses at debug.

!      open(10,file='cigmsvector')
!        do i=1,nci_dim
!           read(10,*) iiii,val1,j,val2
!           vector1(j)=val1
!           if(val2.gt.0.0d0.and.val1.lt.0.0d0) vector1(j)=-vector1(j)
!           if(val2.lt.0.0d0.and.val1.gt.0.0d0) vector1(j)=-vector1(j)
!        enddo
!      close(10)

      end

      subroutine moread(ii,jj,kk,ll,val)
#include "drt_h.fh"
#include "grad_h.fh"
      common /pcklab/ labsiz
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
c====================================================
!    transfer the ci mo indexs to scf mo indexs
!    and use library function ishft() to save
!    two electron mo indexs to dm2_index().


      lrj=min(ii,jj)
      lri=max(ii,jj)
      lrl=min(kk,ll)
      lrk=max(kk,ll)
      if(lri.lt.lrk) then
        lrn=lrk
        lrk=lri
        lri=lrn
        lrn=lrl
        lrl=lrj
        lrj=lrn
      endif
      if(lri.eq.lrk.and.lrj.lt.lrl) then
        lrn=lrj
        lrj=lrl
        lrl=lrn
      endif

         nij=ican_a(lri)+lrj
         nkl=ican_a(lrk)+lrl
         nijkl=ican_b(nij)+nkl
         vector1(nijkl)=val
c      write(nf2,'(4i4,f18.10)') lri,lrj,lrk,lrl,vector1(nijkl)
      end

      subroutine trans_ijkl_intpos(ii,jj,kk,ll,nxo)
#include "drt_h.fh"
#include "grad_h.fh"
      common /pcklab/ labsiz
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
c====================================================
!    transfer the ci mo indexs to scf mo indexs
!    and use library function ishft() to save
!    two electron mo indexs to dm2_index().
c       write(nf2,'(4i4)') ii,jj,kk,ll

c      i=map_orb_order_t(ii)
c      j=map_orb_order_t(jj)
c      k=map_orb_order_t(kk)
c      l=map_orb_order_t(ll)

      lrj=min(ii,jj)
      lri=max(ii,jj)
      lrl=min(kk,ll)
      lrk=max(kk,ll)
      if(lri.lt.lrk) then
        lrn=lrk
        lrk=lri
        lri=lrn
        lrn=lrl
        lrl=lrj
        lrj=lrn
      endif
      if(lri.eq.lrk.and.lrj.lt.lrl) then
        lrn=lrj
        lrj=lrl
        lrl=lrn
      endif

         nij=ican_a(lri)+lrj
         nkl=ican_a(lrk)+lrl
         nxo=ican_b(nij)+nkl

c      if(nxo.eq.3003) then
c       write(nf2,'(8i4,i8)')ii,jj,kk,ll,lri,lrj,lrk,lrl,nxo
c      endif
      end

      subroutine trans_intpos_ijkl(intpos,lijkl)

#include "drt_h.fh"
#include "grad_h.fh"
      common /pcklab/ labsiz
      dimension lijkl(4)

c=========================================================
!    read the saved two electron mo indexs.

      return
c Avoid unused argument warnings
      if (.false.) then
         call Unused_integer(intpos)
         call Unused_integer_array(lijkl)
      end if
      end


      subroutine lagran_act(x1e)
#include "drt_h.fh"
#include "grad_h.fh"
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      common /ncprhf/ nrot,nxyz,ndbl,next,nsolv,nres,n_frz,n_all
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /lgrn/ xlgrn(max_orb,max_orb)
      dimension x1e(50000),fock(n_all,n_all)
      parameter (zero=0.0d+00,two=2.0d+00)

c================================================
c lyb
c     xlgrn(norb_all,norb_all) is the lagrange matrix.

      norbf=n_frz+1
c      norbf=1

      xlgrn(1:n_all,1:n_all)=0.0d0

      call lagran_fock(x1e,fock)

c form two electron contributions to the lagrangian with frozen mo

      do i=ndbl+1,n_all
         do j=1,n_frz
            dum=fock(j,i)*two
            do k=norbf,n_all
               do l=norbf,n_all
                  i0=max(i,j)
                  j0=min(i,j)
                  nji=ican_a(i0)+j0
                  k0=max(k,l)
                  l0=min(k,l)
                  nkl=ican_a(k0)+l0
                  if(nji.ge.nkl) then
                     njikl=ican_b(nji)+nkl
                  else
                     njikl=ican_b(nkl)+nji
                  endif
                  dum=dum+dm1(k0,l0)*vector1(njikl)*two

                  i0=max(i,l)
                  l0=min(i,l)
                  nil=ican_a(i0)+l0
                  j0=max(j,k)
                  k0=min(j,k)
                  njk=ican_a(j0)+k0
                  if(nil.ge.njk) then
                     niljk=ican_b(nil)+njk
                  else
                     niljk=ican_b(njk)+nil
                  endif
                  dum=dum-dm1(k0,l0)*vector1(niljk)
               enddo
            enddo
            xlgrn(i,j)=xlgrn(i,j)+dum
         enddo
      enddo

      do i=1,n_frz
         do j=ndbl+1,n_all
            dum=fock(j,i)*two
            do k=norbf,n_all
               do l=norbf,n_all
                  i0=max(i,j)
                  j0=min(i,j)
                  nji=ican_a(i0)+j0
                  k0=max(k,l)
                  l0=min(k,l)
                  nkl=ican_a(k0)+l0
                  if(nji.ge.nkl) then
                     njikl=ican_b(nji)+nkl
                  else
                     njikl=ican_b(nkl)+nji
                  endif
                  dum=dum+dm1(k0,l0)*vector1(njikl)*two

                  i0=max(i,l)
                  l0=min(i,l)
                  nil=ican_a(i0)+l0
                  j0=max(j,k)
                  k0=min(j,k)
                  njk=ican_a(j0)+k0
                  if(nil.ge.njk) then
                     niljk=ican_b(nil)+njk
                  else
                     niljk=ican_b(njk)+nil
                  endif
                  dum=dum-dm1(k0,l0)*vector1(niljk)
               enddo
            enddo
            xlgrn(i,j)=xlgrn(i,j)+dum
         enddo
      enddo



c form two electron contributions to the lagrangian with active mo


      do i=norbf,ndbl
         do j=ndbl+1,n_all
            dum=zero
            do m=norbf,n_all
               i0=ican_a(max(i,m))+min(i,m)
               j0=ican_a(max(j,m))+min(j,m)
               kl=0
               do k=norbf,n_all
                  dumtmp=zero
                  do l=norbf,k-1
                     kl=kl+1
                     if(kl.gt.i0) then
                        nimkl=ican_b(kl)+i0
                     else
                        nimkl=ican_b(i0)+kl
                     endif

                     if(kl.gt.j0) then
                        njmkl=ican_b(kl)+j0
                     else
                        njmkl=ican_b(j0)+kl
                     endif
                     dumtmp=dumtmp+vector1(nimkl)*vector2(njmkl)
c         if(i.eq.1.and.j.eq.5)
c     :   write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl)
                  enddo

                  dum=dum+dumtmp*two

                  kl=kl+1
                  if(kl.gt.i0) then
                     nimkl=ican_b(kl)+i0
                  else
                     nimkl=ican_b(i0)+kl
                  endif

                  if(kl.gt.j0) then
                     njmkl=ican_b(kl)+j0
                  else
                     njmkl=ican_b(j0)+kl
                  endif

                  dum=dum+vector1(nimkl)*vector2(njmkl)
c      if(nimkl.ne.njmkl)
c     :                write(nf2,'(2i8,2f18.10)') nimkl,njmkl,
c     :vector1(nimkl),vector2(njmkl)
c         if(i.eq.1.and.j.eq.5)
c     :    write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl
               enddo
            enddo

            xlgrn(i,j)=xlgrn(i,j)+dum*two
c       write(2,'(a7,2i4,f18.10)') 'xlgrn_2',i,j,xlgrn(i,j)
         enddo
      enddo
      do i=norbf,ndbl
         do j=ndbl+1,n_all
            dum=zero
            do k=norbf,norb_all
               mik=max(i,k)
               nik=min(i,k)
               mjk=max(j,k)
               njk=min(j,k)
               dum=dum+fock(mik,nik)*dm1(mjk,njk)

c            write(nf2,'(2f18.10)') x1e(mnik),dm1(mjk,njk)
            enddo
            xlgrn(i,j)=xlgrn(i,j)+dum
c       write(2,'(a9,2i4,f18.10)') 'xlgrn_all',i,j,xlgrn(i,j)
         enddo
      enddo


      do i=ndbl+1,n_all
         do j=norbf,ndbl
            dum=zero
            do m=norbf,n_all
               i0=ican_a(max(i,m))+min(i,m)
               j0=ican_a(max(j,m))+min(j,m)
               kl=0
               do k=norbf,n_all
                  dumtmp=zero
                  do l=norbf,k-1
                     kl=kl+1
                     if(kl.gt.i0) then
                        nimkl=ican_b(kl)+i0
                     else
                        nimkl=ican_b(i0)+kl
                     endif

                     if(kl.gt.j0) then
                        njmkl=ican_b(kl)+j0
                     else
                        njmkl=ican_b(j0)+kl
                     endif
                     dumtmp=dumtmp+vector1(nimkl)*vector2(njmkl)
c         if(i.eq.1.and.j.eq.5)
c     :   write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl)
                  enddo

                  dum=dum+dumtmp*two

                  kl=kl+1
                  if(kl.gt.i0) then
                     nimkl=ican_b(kl)+i0
                  else
                     nimkl=ican_b(i0)+kl
                  endif

                  if(kl.gt.j0) then
                     njmkl=ican_b(kl)+j0
                  else
                     njmkl=ican_b(j0)+kl
                  endif

                  dum=dum+vector1(nimkl)*vector2(njmkl)
c      if(nimkl.ne.njmkl)
c     :                write(nf2,'(2i8,2f18.10)') nimkl,njmkl,
c     :vector1(nimkl),vector2(njmkl)
c         if(i.eq.1.and.j.eq.5)
c     :    write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl
               enddo
            enddo

            xlgrn(i,j)=xlgrn(i,j)+dum*two
c       write(2,'(a7,2i4,f18.10)') 'xlgrn_2',i,j,xlgrn(i,j)
         enddo
      enddo


      do i=ndbl+1,n_all
         do j=norbf,ndbl
            dum=zero
            do k=norbf,norb_all
               mik=max(i,k)
               nik=min(i,k)
               mjk=max(j,k)
               njk=min(j,k)
               dum=dum+fock(mik,nik)*dm1(mjk,njk)

c            write(nf2,'(2f18.10)') x1e(mnik),dm1(mjk,njk)
            enddo
            xlgrn(i,j)=xlgrn(i,j)+dum
c       write(2,'(a9,2i4,f18.10)') 'xlgrn_all',i,j,xlgrn(i,j)
         enddo
      enddo


      end


      subroutine lagran_all(x1e)
#include "drt_h.fh"
#include "grad_h.fh"
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /lgrn/ xlgrn(max_orb,max_orb)
      common /ncprhf/ nrot,nxyz,ndbl,next,nsolv,nres,n_frz,n_all
      dimension x1e(50000)
      parameter (zero=0.0d+00,two=2.0d+00)

c================================================
c lyb
c     xlgrn(norb_all,norb_all) is the lagrange matrix.

      norbf=n_frz+1
c      norbf=1

      xlgrn(1:norb_all,1:norb_all)=0.0d0

c form two electron contributions to the lagrangian
      do i=1,norb_all
         do j=1,norb_all
            dum=zero
            do m=1,norb_all
               i0=ican_a(max(i,m))+min(i,m)
               j0=ican_a(max(j,m))+min(j,m)
               kl=0
               do k=1,norb_all
                  dumtmp=zero
                  do l=1,k-1
                     kl=kl+1
                     if(kl.gt.i0) then
                        nimkl=ican_b(kl)+i0
                     else
                        nimkl=ican_b(i0)+kl
                     endif

                     if(kl.gt.j0) then
                        njmkl=ican_b(kl)+j0
                     else
                        njmkl=ican_b(j0)+kl
                     endif
                     dumtmp=dumtmp+vector1(nimkl)*vector2(njmkl)
c         if(i.eq.1.and.j.eq.5)
c     :   write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl)
                  enddo

                  dum=dum+dumtmp*two

                  kl=kl+1
                  if(kl.gt.i0) then
                     nimkl=ican_b(kl)+i0
                  else
                     nimkl=ican_b(i0)+kl
                  endif

                  if(kl.gt.j0) then
                     njmkl=ican_b(kl)+j0
                  else
                     njmkl=ican_b(j0)+kl
                  endif

                  dum=dum+vector1(nimkl)*vector2(njmkl)
c      if(nimkl.ne.njmkl)
c     :                write(nf2,'(2i8,2f18.10)') nimkl,njmkl,
c     :vector1(nimkl),vector2(njmkl)
c         if(i.eq.1.and.j.eq.5)
c     :    write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl
               enddo
            enddo

            xlgrn(i,j)=xlgrn(i,j)+dum*two
c       write(2,'(a7,2i4,f18.10)') 'xlgrn_2',i,j,xlgrn(i,j)
         enddo
      enddo
      do i=1,norb_all
         do j=1,norb_all
            dum=zero
            do k=1,norb_all
               mik=max(i,k)
               nik=min(i,k)
               mjk=max(j,k)
               njk=min(j,k)
               mnik=ican_a(mik)+nik
               dum=dum+x1e(mnik)*dm1(mjk,njk)

c            write(nf2,'(2f18.10)') x1e(mnik),dm1(mjk,njk)
            enddo
            xlgrn(i,j)=xlgrn(i,j)+dum
c       write(2,'(a9,2i4,f18.10)') 'xlgrn_all',i,j,xlgrn(i,j)
         enddo
      enddo



      end

      subroutine writedm2(nx)
#include "drt_h.fh"
#include "grad_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      character*256 filename

      filename=tmpdir(1:len_str)//"/density"
      len=len_str+8
! Need debug
!      open(nf22,file=filename(1:len),form='unformatted')

c      open(nf22,file='density',form='unformatted')
!      write(nf22) (vector2(i),i=1,nx)
!      close(nf22)

c Avoid unused argument warnings
      if (.false.) call Unused_integer(nx)

      end

      subroutine readdm2(nx)
#include "drt_h.fh"
#include "grad_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
c     character*256 filename

      vector2(1:nx)=0.0d+00

!      filename=tmpdir(1:len_str)//"/density"
!      len=len_str+8

!      open(nf22,file=filename(1:len),form='unformatted')

c      open(nf22,file='density',form='unformatted')
!      read(nf22) (vector2(i),i=1,nx)
!      close(nf22)

      end


#ifdef _COMPILE_
      subroutine backtransmo
#include "drt_h.fh"
#include "grad_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
c     character*256 filename
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /density/ p(max_orb,max_orb)
      dimension ican_ab(norb_all),c(70000),dm1_act(naorbs,naorbs)
      logical resina
      parameter (htoklm=627.50956d+00,zero=0.0d+00,two=2.0d+00,
     :           half=0.5d+00,half2=0.25d+00)

************************************************************************
*
*   rrogram transmo transfers the one and two electronic ao integrals to
*   integrals.
*          on input
* cf      = all m.o.'s coefficient
* naorbs  = number of atomic orbitals
* maxao   = the number of ao integrals
* h       = the one electronic ao integrals
* vector1  = the two electronic ao density matrix
* norb    = the start mo wanted to be transfered
* norbs   = the end mo wanted to be transfered
* c       = the m.o.'s coefficient with the order that is different from
*           this is need by the transformation subroutine c4itd
*
*          on output
* tmoint1 = the one electronic mo integrals
* vector2 = the two electronic mo density matrix
*
* c4itd   = the subroutine to transfer aos to mos
*           copy right by carlos f. bunge. annik vivier bunge. gerardo c
*           and jean-pierre daudey, 1987.
*           reference: c. f. bunge, a. v. bunge, g. cisneros and j.-p. d
*                      comput. chem. vol 12, page 91, year 1988.
* iteifd  = the subroutine to scale the aos by a factor 1/2

************************************************************************
      time0=c_time()

!      write(nf2,*) 'start of backtransform'

      norbf=norb_frz

      norbs1=naorbs*(naorbs+1)*0.5
      norbe=norb_all-norbf
      norbs2=norbe*(norbe+1)*0.5
      norbs3=(norbe-norbf+1)*naorbs
      nx=(naorbs*naorbs+naorbs)*(naorbs*naorbs+naorbs+2)*0.125
      mx=(norbe*norbe+norbe)*(norbe*norbe+norbe+2)*0.125

      vector1(1:nx)=zero

      l1=norbe
      do i=1,l1
         i0=i-1
         ican_ab(i)=i0*l1-(i0*i0-i0)/2
      enddo

      ij=0
      do i=norbf+1,norb_all
         do j=1,naorbs
            ij=ij+1
            c(ij)=cf(j,i)
c         write(nf2,'(2i4,2f18.10)')i,j,c(ij),cf(j,i)
         enddo
      enddo

      do i0=norbf+1,norb_all
         do j0=norbf+1,i0
            do k0=norbf+1,i0
               l0max=k0
               if(i0.eq.k0) l0max=j0
               do l0=norbf+1,l0max
                  if(l0.le.norbf) cycle
                  nij0=ican_a(i0)+j0
                  nkl0=ican_a(k0)+l0
                  nijkl0=ican_b(nij0)+nkl0
                  val=vector2(nijkl0)
                  i=i0-norbf
                  j=j0-norbf
                  k=k0-norbf
                  l=l0-norbf

                  nij=ican_ab(j)+i-j+1
                  nkl=ican_ab(l)+k-l+1
                  if(nij.ge.nkl) then
                     nijkl=ican_b(nij)+nkl
                  else
                     nijkl=ican_b(nkl)+nij
                  endif
                  vector1(nijkl)=val
c      write(nf2,'(8i4,2i8,f18.10)')i0,j0,k0,l0,i,j,k,l,nijkl0,nijkl,val

               enddo
            enddo
         enddo
      enddo



c*******************************************************
* the aoints should be saved as the order the following
* provided.
*
c        nijkl=0
c        do i=1,naorbs
c           do j=i,naorbs
c              do k=1,i
c                 if(k.eq.i) then
c                   inl=j
c                 else
c                   inl=naorbs
c                 endif
c                 do l=k,inl
c                    nijkl=nijkl+1
c                   read(naoint) vector1(nijkl)

c       write(6,'(4i3,i8,f18.10)')i,j,k,l,nijkl,vector1(nijkl)
c       write(nf2,'(5i8)')i,j,k,l,nijkl
c

c                 enddo
c              enddo
c           enddo
c        enddo
c*******************************************************

      vector2(1:nx)=zero
      resina=.false.
      nsym=1
      ncase=1

      call iteifd(ncase,nsym,norbe,norbe,norbe,norbe,vector1)

      call c4itd(norbe,norbe,norbe,norbe,naorbs,naorbs,naorbs,naorbs,
     1     nsym,ncase,c,c,c,c,vector1,resina,vector2)


      vector2(1:nx)=zero

c--------------------------------------------------------------
      dm1_act(1:naorbs,1:naorbs)=zero

      call density_ci_one(dm1_act)

c      do i=1,naorbs
c         do j=1,naorbs
c            write(nf2,'(2i4,f18.10)') i,j,dm1_act(i,j)
c         enddo
c      enddo


       nijkl=0
        do i=1,naorbs
           do j=1,i
              do k=1,i
                 if(k.eq.i) then
                   inl=j
                 else
                   inl=k
                 endif
                 do l=1,inl
                    nijkl=nijkl+1

                    valtmp=two*p(i,j)*p(k,l)-half*p(i,l)*p(j,k)
     :                    -half*p(i,k)*p(j,l)
     :                    +p(i,j)*dm1_act(k,l)+p(k,l)*dm1_act(i,j)
     :                    -half2*(p(j,k)*dm1_act(i,l)
     :                    +p(j,l)*dm1_act(i,k)
     :                    +p(i,k)*dm1_act(j,l)
     :                    +p(i,l)*dm1_act(j,k))

                    vector1(nijkl)=vector1(nijkl)+valtmp
c       write(nf2,'(4i3,i8,f18.10)')i,j,k,l,nijkl,vector1(nijkl)
c       write(nf2,'(5i8)')i,j,k,l,nijkl
c
                 enddo
              enddo
           enddo
        enddo

!      write(nf2,*) 'the new dm2'

c      do i=1,nx
c        write(nf2,'(i8,f18.10)')i, vector1(i)
c      enddo


!      filename=tmpdir(1:len_str)//"/backdm2"
!      len=len_str+8

!      open(20,file=filename(1:len),form='unformatted')

c      open(20,file='backdm2',form='unformatted')
!       write(20) (vector1(i),i=1,nx)
!      close(20)

      time1=c_time()-time0
!      write(nf2,'(4x,"trans run time =",f8.3,2x,"seconds")') time1
!      write(nf2,*) 'end of backtransform'

  100 format(2i4,f18.10)
  200 format(4i4,4x,f18.10)
  300 format(4x,a6,2x,f18.10,5i4,f20.15)
      end
#endif

      subroutine backtrans_test
#include "drt_h.fh"
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
c-------------------------------------------------------------
c this subroutine for test the backtrans result by just one density matr
c ao, such as (ij|kl)
c
      sum=0.0d+00
      i0=6
      j0=6
      k0=6
      l0=6

      do i=norb_frz+1,norb_all
         do j=norb_frz+1,norb_all
            if(i.ge.j) then
               nij=ican_a(i)+j
            else
               nij=ican_a(j)+i
            endif

            do k=norb_frz+1,norb_all
               do l=norb_frz+1,norb_all
                  if(k.ge.l) then
                     nkl=ican_a(k)+l
                  else
                     nkl=ican_a(l)+k
                  endif
                  if(nij.ge.nkl) then
                     nijkl=ican_b(nij)+nkl
                  else
                     nijkl=ican_b(nkl)+nij
                  endif
                  val=vector2(nijkl)
                  sum=sum+val*cf(i0,i)*cf(j0,j)*cf(k0,k)*cf(l0,l)
               enddo
            enddo
         enddo
      enddo

!      write(nf2,*) 'num 1 sum=',sum

      end

      subroutine grad_two
#include "drt_h.fh"
      common /grad_xyz/dxyz(3,max_atom),numat
      common /ndao/ ndao
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      character*256 filename
      dimension index_atom(3,numat*(numat+1)/2),ndi0(ndao),ndj0(ndao),
     :          ndk0(ndao),ndl0(ndao),daoint1(ndao)
      dimension dgxyz(3,numat),daoxyz(3,numat)
      parameter (htoklm=627.50956d+00)
      parameter (zero=0.0d+00,one=1.0d+00,two=2.0d+00,four=4.0d+00)

      npat=numat*(numat+1)/2
      index_atom(1:3,1:npat)=0

      filename=tmpdir(1:len_str)//"/daoints"
      len=len_str+8

!      open(40,file=filename(1:len),form='formatted')

c      open(40,file='daoints',form='formatted')
!      read(40,*)

!      do i=1,3
!         read(40,*) (index_atom(i,j),j=1,npat)
!      enddo
!      read(40,*) (ndi0(i),i=1,ndao)
!      read(40,*) (ndj0(i),i=1,ndao)
!      read(40,*) (ndk0(i),i=1,ndao)
!      read(40,*) (ndl0(i),i=1,ndao)
!      read(40,*) (daoint1(i),i=1,ndao)
!
!      close(40)

      ncon=0

      do i=1,numat
         do j=1,i-1
            nnij=ican_a(i)+j
c            write(nf2,*) i,ican_a(i)
            do k=1,3
               ind=index_atom(k,nnij)
               val=zero
               do l=1,ind
                  ncon=ncon+1
                  i0=ndi0(ncon)
                  j0=ndj0(ncon)
                  k0=ndk0(ncon)
                  l0=ndl0(ncon)
                  val2=daoint1(ncon)
c                 write(2,'(4i4,f18.10)')i0,j0,k0,l0,val2
                  nij=ican_a(j0)+i0
                  nkl=ican_a(l0)+k0
                  nijkl=ican_b(nij)+nkl
                  val1=vector1(nijkl)
                  aa=one
                  bb=one
                  if(i0.ne.j0) aa=two*aa
                  if(k0.ne.l0) bb=two*bb
c===================================================
c this place should multiple two, because the gradient
c integral always exist the relation that :
c index nij=i*(i-1)/2+j
c index nkl=k*(k-1)/2+l
c but here always the nij >= nkl.
c
                  val=val+val1*val2*aa*bb*two
               enddo
               daoxyz(k,i)=daoxyz(k,i)+val
               daoxyz(k,j)=daoxyz(k,j)-val

               dxyz(k,i)=dxyz(k,i)+val
               dxyz(k,j)=dxyz(k,j)-val
           enddo
         enddo
      enddo

c      dgxyz(1:3,1:numat)=zero
c      do i=1,numat
c         do j=1,3
c            dgxyz(j,i)=daoxyz(j,i)*htoklm
c         enddo
c      enddo


c      write(nf2,'(//10x,''cartesian coordinate derivatives'',//3x,
c     1''number  atom '',5x,''x'',12x,''y'',12x,''z'',/)')

c      do i=1,numat
c         write(nf2,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
c      enddo

      dgxyz(1:3,1:numat)=zero
      do i=1,numat
         do j=1,3
            dgxyz(j,i)=dxyz(j,i)*htoklm
         enddo
      enddo


!      write(nf2,'(//10x,''cartesian coordinate derivatives'',//3x,
!     1''number  atom '',5x,''x'',12x,''y'',12x,''z'',/)')

      do i=1,numat
         write(6,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
      enddo


      end



      subroutine grad_one_ao

#include "drt_h.fh"
#include "grad_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      character*256 filename
      common /lgrn/ xlgrn(max_orb,max_orb)
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      common /grad_xyz/dxyz(3,max_atom),numat
      common /density/ p(max_orb,max_orb)
      dimension dsaos(3,numat,naorbs*(naorbs+1)/2)
      dimension dgxyz(3,numat),dmo1xyz(3,numat),dm1_act(naorbs,naorbs)
      parameter (htoklm=627.50956d+00)
      parameter (zero=0.0d+00,one=1.0d+00,two=2.0d+00,four=4.0d+00)

      dsaos(1:3,1:numat,1:naorbs*(naorbs+1)/2)=zero

      filename=tmpdir(1:len_str)//"/dfock1"
      len=len_str+7

!      open(500,file=filename(1:len),form='unformatted')

c      open(500,file='dfock1',form='unformatted')
!      do i=1,numat
!         do k=1,3
!            read(500) (dsaos(k,i,j),j=1,naorbs*(naorbs+1)/2)
!         enddo
!      enddo
!      close(500)

      dmo1xyz(1:3,1:numat)=zero


c---------------------------------------------------
c partial backtransform one electron density matrix

      dm1_act(1:naorbs,1:naorbs)=zero
      call density_ci_one(dm1_act)

!      write(nf2,*) 'the new transformed dm1'

      do i=1,naorbs
         do j=1,naorbs
            dm1_act(i,j)=dm1_act(i,j)+two*p(i,j)
         enddo
      enddo

c      do i=1,naorbs
c         do j=1,i
c            write(nf2,'(2i8,f18.10)') i,j,dm1_act(i,j)
c         enddo
c      enddo

      do i=1,3
         do j=1,numat
            do k=1,naorbs
               do l=1,k
                  if(k.eq.l) then
                     nkl=ican_a(k)+k
                     dxyz(i,j)=dxyz(i,j)+dsaos(i,j,nkl)*dm1_act(k,l)
                  dmo1xyz(i,j)=dmo1xyz(i,j)+dsaos(i,j,nkl)*dm1_act(k,l)

                  else
                     nkl=ican_a(k)+l
                     dxyz(i,j)=dxyz(i,j)
     :                        +dsaos(i,j,nkl)*dm1_act(k,l)*two

                     dmo1xyz(i,j)=dmo1xyz(i,j)
     :                        +dsaos(i,j,nkl)*dm1_act(k,l)*two
                  endif
               enddo
            enddo
         enddo
      enddo

c      dgxyz(1:3,1:numat)=zero
c      do i=1,numat
c         do j=1,3
c            dgxyz(j,i)=dmo1xyz(j,i)*htoklm
c         enddo
c      enddo


c      write(nf2,'(//10x,''cartesian coordinate derivatives'',//3x,
c     1''number  atom '',5x,''x'',12x,''y'',12x,''z'',/)')
c      write(nf2,*) 'the one electron gradient'
c      do i=1,numat
c         write(nf2,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
c      enddo

      dgxyz(1:3,1:numat)=zero
      do i=1,numat
         do j=1,3
            dgxyz(j,i)=dxyz(j,i)*htoklm
         enddo
      enddo

      write(6,1000)

      do i=1,numat
         write(6,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
      enddo

1000  format(//10x,"cartesian coordinate derivatives",//3x,
     * "number  atom ",5x,"x",12x,"y",12x,"z",/)
      end



      subroutine grad_one_mo

#include "drt_h.fh"
#include "grad_h.fh"
      common /lgrn/ xlgrn(max_orb,max_orb)
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      common /grad_xyz/dxyz(3,max_atom),numat
      dimension dsaos(3,numat,naorbs*(naorbs+1)/2)
      dimension dgxyz(3,numat),dmo1xyz(3,numat)
      parameter (htoklm=627.50956d+00)
      parameter (zero=0.0d+00,one=1.0d+00,two=2.0d+00,four=4.0d+00)
      return

      dsaos(1:3,1:numat,1:naorbs*(naorbs+1)/2)=zero
!
!      open(500,file='dfock1',form='unformatted')
!      do i=1,numat
!         do k=1,3
!            do j=1,naorbs*(naorbs+1)/2
!              read(500) dsaos(k,i,j)
!            enddo
!         enddo
!      enddo
!      close(500)

      dmo1xyz(1:3,1:numat)=zero


      do i=1,3
         do j=1,numat

            do i0=1,norb_all
               do j0=1,i0

               val=zero
            do k=1,naorbs
               do l=1,k
                  nkl=ican_a(k)+l

                  if(k.eq.l) then
                     val=val+dsaos(i,j,nkl)*cf(k,i0)*cf(l,j0)
                  else
                     val=val+dsaos(i,j,nkl)*cf(k,i0)*cf(l,j0)
     :                  +dsaos(i,j,nkl)*cf(k,j0)*cf(l,i0)
                  endif
               enddo
            enddo
            if(i0.eq.j0) then
               dxyz(i,j)=dxyz(i,j)+dm1(i0,j0)*val
               dmo1xyz(i,j)=dmo1xyz(i,j)+dm1(i0,j0)*val

            else
               dxyz(i,j)=dxyz(i,j)+dm1(i0,j0)*val*two
               dmo1xyz(i,j)=dmo1xyz(i,j)+dm1(i0,j0)*val*two

            endif
            write(6,'(2i4,2f18.10)') i0,j0,dm1(i0,j0),val
               enddo
            enddo
         enddo
      enddo

      dgxyz(1:3,1:numat)=zero
      do i=1,numat
         do j=1,3
            dgxyz(j,i)=dmo1xyz(j,i)*htoklm
         enddo
      enddo

      write(6,1000)

      do i=1,numat
         write(6,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
      enddo

      dgxyz(1:3,1:numat)=zero
      do i=1,numat
         do j=1,3
            dgxyz(j,i)=dxyz(j,i)*htoklm
         enddo
      enddo

      write(6,1000)

      do i=1,numat
         write(6,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
      enddo

1000  format(//10x,"cartesian coordinate derivatives",//3x,
     * "number  atom ",5x,"x",12x,"y",12x,"z",/)
      end

      subroutine density_ci_one(dm1_act)
#include "drt_h.fh"
#include "grad_h.fh"
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      dimension dm1_act(naorbs,naorbs)
      parameter (zero=0.0d+00,one=1.0d+00,two=2.0d+00,four=4.0d+00)

      norbf=norb_frz+1
      do i=1,naorbs
         do j=1,i
            dm1_act(i,j)=zero
            do np=norbf,norb_all
               do nq=norbf,np
                  if(np.eq.nq) then
                     dm1_act(i,j)=dm1_act(i,j)
     :                          +dm1(np,nq)*cf(i,np)*cf(j,nq)
                  else
                     dm1_act(i,j)=dm1_act(i,j)
     :                          +dm1(np,nq)*cf(i,np)*cf(j,nq)
     :                          +dm1(np,nq)*cf(j,np)*cf(i,nq)
                  endif
               enddo
            enddo
            dm1_act(j,i)=dm1_act(i,j)
         enddo
      enddo

      end

      subroutine lagran_fock(x1e,fock)
#include "drt_h.fh"
#include "grad_h.fh"
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /ncprhf/ nrot,nxyz,ndbl,next,nsolv,nres,n_frz,n_all
      dimension x1e(50000),fock(n_all,n_all)
      parameter (zero=0.0d+00,two=2.0d+00)

      fock(1:n_all,1:n_all)=zero

      do i=1,n_all
         do j=1,i
            nij=ican_a(i)+j
            fock(i,j)=x1e(nij)
            val=zero
            do k=1,n_frz
               nkk=ican_a(k)+k
               if(nij.ge.nkk) then
                  nijkk=ican_b(nij)+nkk
               else
                  nijkk=ican_b(nkk)+nij
               endif
               val=val+vector1(nijkk)*two

               i0=max(i,k)
               k0=min(i,k)
               nik=ican_a(i0)+k0
               j0=max(j,k)
               k0=min(j,k)
               njk=ican_a(j0)+k0
               nikjk=ican_b(nik)+njk
               val=val-vector1(nikjk)
            enddo
            fock(i,j)=fock(i,j)+val
            fock(j,i)=fock(i,j)
         enddo
      enddo

      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995, Roland Lindh                                *
!***********************************************************************

subroutine DrvN0()
!***********************************************************************
!                                                                      *
! Object: to compute the nuclear contributions to the nuclear potential*
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!             Modified for various other contributions May 95', RL     *
!***********************************************************************

use External_Centers, only: XF, nOrd_XF, nXF
use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Phase_Info, only: iPhase
use Gateway_global, only: Expert
use Gateway_Info, only: PotNuc
use Symmetry_Info, only: nIrrep
use Constants, only: Zero, One, Two, Three, Four, Six, Half, Quart
use Definitions, only: wp, iwp, u6

implicit none
#include "print.fh"
integer(kind=iwp) :: iChxyz, iCnt, iCnttp, iDCRR(0:7), iDum, iFd, iM1xp, iM2xp, iR, iStb(0:7), jCnt, jCntMx, jCnttp, jCoSet(8,8), &
                     jFd, jStb(0:7), jxyz, LmbdR, mdc, mStb, ndc, nDCRR, nStb
real(kind=wp) :: A(3), ABx, ABy, ABz, B(3), CffM1, CffM2, DAx, DAy, DAz, DBx, DBy, DBz, DRBx, DRBy, DRBz, eDD, eDQ, eDZ, eQD, eQQ, &
                 eQZ, eTot, eZD, eZQ, eZZ, fab, Fact, Gam, PNX, PXX, QAsum, QAxx, QAxy, QAxz, QAyy, QAyz, QAzz, QBsum, QBxx, QBxy, &
                 QBxz, QByy, QByz, QBzz, QRBxx, QRBxy, QRBxz, QRByy, QRByz, QRBzz, Qxx, Qxy, Qxz, Qyy, Qyz, Qzz, r12, r12_Min, &
                 RB(3), temp, temp0, temp1, temp2, x, y, z, ZA, ZAZB, ZB
logical(kind=iwp) :: EQ, NoLoop
integer(kind=iwp), external :: iChAtm, isstructure

NoLoop = .true.
iDum = 0
r12_Min = Zero

! Nuclear repulsion, in case of some ECP we include the core electronic
! contribution (pseudo charges). The interaction of pseudo charges is
! excluded from the energy term.

PotNuc = Zero
mdc = 0
ZB = Zero
do iCnttp=1,nCnttp
  ZA = dbsc(iCnttp)%Charge
  if (dbsc(iCnttp)%Frag) ZA = dbsc(iCnttp)%FragCharge
  mdc = mdc+dbsc(iCnttp)%nCntr
  if (ZA == Zero) cycle
  mdc = mdc-dbsc(iCnttp)%nCntr
  do iCnt=1,dbsc(iCnttp)%nCntr
    A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

    ndc = 0
    do jCnttp=1,iCnttp
      ndc = ndc+dbsc(jCnttp)%nCntr
      if (dbsc(iCnttp)%pChrg .and. dbsc(jCnttp)%pChrg) cycle
      if (dbsc(iCnttp)%Frag .and. dbsc(jCnttp)%Frag) cycle
      ZB = dbsc(jCnttp)%Charge
      if (dbsc(jCnttp)%Frag) ZB = dbsc(jCnttp)%FragCharge
      if (ZB == Zero) cycle
      ndc = ndc-dbsc(jCnttp)%nCntr
      ZAZB = ZA*ZB
      jCntMx = dbsc(jCnttp)%nCntr
      if (iCnttp == jCnttp) jCntMx = iCnt
      do jCnt=1,jCntMx
        ! Introduce factor to ensure that contributions from
        ! A>B are the only to be accumulated.
        Fact = One
        if ((iCnttp == jCnttp) .and. (iCnt == jCnt)) Fact = Half
        B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

        ! Find the DCR for the two centers

        call DCR(LmbdR,dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,iDCRR,nDCRR)

        temp = Zero
        do iR=0,nDCRR-1
          RB(1) = real(iPhase(1,iDCRR(iR)),kind=wp)*B(1)
          RB(2) = real(iPhase(2,iDCRR(iR)),kind=wp)*B(2)
          RB(3) = real(iPhase(3,iDCRR(iR)),kind=wp)*B(3)
          ! The index A=RB is illegal.
          if (.not. EQ(A,RB)) then
            r12 = sqrt((A(1)-RB(1))**2+(A(2)-RB(2))**2+(A(3)-RB(3))**2)
            if ((r12 < r12_min) .and. (.not. Expert)) then
              call WarningMessage(2,' The distance between two centers are found to be unphysically too short.; '// &
                                  'If you want to persist operate in expert mode.')
              call Abend()
            end if
            fab = One
            if (dbsc(iCnttp)%ECP) then
              ! Add contribution from M1 operator
              do iM1xp=1,dbsc(iCnttp)%nM1
                Gam = dbsc(iCnttp)%M1xp(iM1xp)
                CffM1 = dbsc(iCnttp)%M1cf(iM1xp)
                fab = fab+CffM1*exp(-Gam*r12**2)
              end do
              ! Add contribution from M2 operator
              do iM2xp=1,dbsc(iCnttp)%nM2
                Gam = dbsc(iCnttp)%M2xp(iM2xp)
                CffM2 = dbsc(iCnttp)%M2cf(iM2xp)
                fab = fab+CffM2*r12*exp(-Gam*r12**2)
              end do
            end if
            if (dbsc(jCnttp)%ECP) then
              ! Add contribution from M1 operator
              do iM1xp=1,dbsc(jCnttp)%nM1
                Gam = dbsc(jCnttp)%M1xp(iM1xp)
                CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
                fab = fab+CffM1*exp(-Gam*r12**2)
              end do
              ! Add contribution from M2 operator
              do iM2xp=1,dbsc(jCnttp)%nM2
                Gam = dbsc(jCnttp)%M2xp(iM2xp)
                CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
                fab = fab+CffM2*r12*exp(-Gam*r12**2)
              end do
            end if

            temp = temp+fab/r12
          else
            ! turn off checking if in expert mode, for wavefunction overlaps
            if (.not. Expert) then
              if ((iCnttp /= jCnttp) .or. (iCnt /= jCnt)) then
                call WarningMessage(2,'You have two charges on top of each other!; Correct the input!')
                call Quit_OnUserError()
              end if
            end if
          end if
        end do
        PotNuc = PotNuc+(Fact*ZAZB*temp*real(nIrrep,kind=wp))/real(LmbdR,kind=wp)

        jxyz = jxyz+3
      end do
      ndc = ndc+dbsc(jCnttp)%nCntr
    end do
  end do
  mdc = mdc+dbsc(iCnttp)%nCntr
end do

if (Show) then
  write(u6,*)
  write(u6,'(11X,A,F16.8,A)') ' Nuclear Potential Energy        ',PotNuc,' au'
  write(u6,*)
end if

if (allocated(XF) .and. (nOrd_XF >= 0)) then

  ! Add contribution for interaction external field and nuclear
  ! charges. Here we will have charge-charge, and charge-dipole
  ! inteaction.

  ZA = Zero
  DAx = Zero
  DAy = Zero
  DAz = Zero
  Qxx = Zero
  Qxy = Zero
  Qxz = Zero
  Qyy = Zero
  Qyz = Zero
  Qzz = Zero

  PNX = Zero
  iDum = 0
  do iFd=1,nXF
    if (nOrd_XF == 0) then
      ZA = XF(4,iFd)
      NoLoop = ZA == Zero
    else if (nOrd_XF == 1) then
      ZA = XF(4,iFd)
      DAx = XF(5,iFd)
      DAy = XF(6,iFd)
      DAz = XF(7,iFd)
      NoLoop = (ZA == Zero) .and. (DAx == Zero) .and. (DAy == Zero) .and. (DAz == Zero)
    else if (nOrd_XF == 2) then
      ZA = XF(4,iFd)
      DAx = XF(5,iFd)
      DAy = XF(6,iFd)
      DAz = XF(7,iFd)
      Qxx = XF(8,iFd)
      Qxy = XF(9,iFd)
      Qxz = XF(10,iFd)
      Qyy = XF(11,iFd)
      Qyz = XF(12,iFd)
      Qzz = XF(13,iFd)
      NoLoop = (ZA == Zero) .and. (DAx == Zero) .and. (DAy == Zero) .and. (DAz == Zero) .and. (Qxx == Zero) .and. &
               (Qxy == Zero) .and. (Qxz == Zero) .and. (Qyy == Zero) .and. (Qyz == Zero) .and. (Qzz == Zero)
    else
      call WarningMessage(2,'Option not implemented yet!')
      call Quit_OnUserError()
    end if
    if (NoLoop) cycle
    A(1:3) = XF(1:3,iFd)
    iChxyz = iChAtm(A)
    call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)

    ndc = 0
    do jCnttp=1,nCnttp
      ZB = dbsc(jCnttp)%Charge
      ndc = ndc+dbsc(jCnttp)%nCntr
      if (dbsc(jCnttp)%pChrg) cycle
      if (ZB == Zero) cycle
      if (dbsc(jCnttp)%Frag) cycle
      ndc = ndc-dbsc(jCnttp)%nCntr
      ZAZB = ZA*ZB
      do jCnt=1,dbsc(jCnttp)%nCntr
        B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

        ! Find the DCR for the two centers

        call DCR(LmbdR,iStb,nStb,dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,iDCRR,nDCRR)

        temp0 = Zero
        temp1 = Zero
        temp2 = Zero
        do iR=0,nDCRR-1
          RB(1) = real(iPhase(1,iDCRR(iR)),kind=wp)*B(1)
          RB(2) = real(iPhase(2,iDCRR(iR)),kind=wp)*B(2)
          RB(3) = real(iPhase(3,iDCRR(iR)),kind=wp)*B(3)
          ! The index A=RB is illegal.
          if (.not. EQ(A,RB)) then
            ABx = A(1)-RB(1)
            ABy = A(2)-RB(2)
            ABz = A(3)-RB(3)
            r12 = sqrt(ABx**2+ABy**2+ABz**2)

            fab = One
            if (dbsc(jCnttp)%ECP) then
              ! Add contribution from M1 operator
              do iM1xp=1,dbsc(jCnttp)%nM1
                Gam = dbsc(jCnttp)%M1xp(iM1xp)
                CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
                fab = fab+CffM1*exp(-Gam*r12**2)
              end do
              ! Add contribution from M2 operator
              do iM2xp=1,dbsc(jCnttp)%nM2
                Gam = dbsc(jCnttp)%M2xp(iM2xp)
                CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
                fab = fab+CffM2*r12*exp(-Gam*r12**2)
              end do
            end if
            temp0 = temp0+fab/r12
            if (nOrd_XF >= 1) temp1 = temp1-fab*(DAx*ABx+DAy*ABy+DAz*ABz)/r12**3
            if (nOrd_XF >= 2) then

              temp2 = temp2+fab*Half*(Three*(Qxx*ABx**2+Two*Qxy*ABx*ABy+Two*Qxz*ABx*ABz+Qyy*ABy**2+ &
                                             Two*Qyz*ABy*ABz+Qzz*ABz**2)/r12**5-One/r12**3*(Qxx+Qyy+Qzz))
            end if

          end if
        end do
        PNX = PNX+((ZAZB*temp0+ZB*(temp1+temp2))*real(nIrrep,kind=wp))/real(LmbdR,kind=wp)

      end do
      ndc = ndc+dbsc(jCnttp)%nCntr
    end do
  end do

  if (Show) then
    write(u6,'(19X,A,F16.8,A)') ' Nuclear-External Field Potential Energy ',PNX,' au'
  end if

  PotNuc = PotNuc+PNX

  ! Add contribution for self interaction of the external field.
  ! Here we will have charge-charge, charge-dipole, and dipole-
  ! dipole inteaction. This term will only be computed but not
  ! added to the acutual nuclear potential energy.

  ! LU: in the case when the number of point charges is larger than
  !     10^4, the algorith below is extremely slow, as it implies a
  !     double loop over all field points (nXF). The resulting value
  !     is stored in the RunFile (label='PC Self Energy'), but never
  !     used again in the entire MOLCAS code.
  !     As a first attempt to optimize this part of the code, we skip
  !     the computation of the self interaction of the external field.

  if (nXF <= 9999) then

    PXX = Zero

    DAx = Zero
    DAy = Zero
    DAz = Zero
    QAxx = Zero
    QAxy = Zero
    QAxz = Zero
    QAyy = Zero
    QAyz = Zero
    QAzz = Zero
    DBx = Zero
    DBy = Zero
    DBz = Zero
    QBxx = Zero
    QBxy = Zero
    QBxz = Zero
    QByy = Zero
    QByz = Zero
    QBzz = Zero

    iDum = 0
    do iFd=1,nXF
      if (nOrd_XF == 0) then
        ZA = XF(4,iFd)
        NoLoop = ZA == Zero
      else if (nOrd_XF == 1) then
        ZA = XF(4,iFd)
        DAx = XF(5,iFd)
        DAy = XF(6,iFd)
        DAz = XF(7,iFd)
        NoLoop = (ZA == Zero) .and. (DAx == Zero) .and. (DAy == Zero) .and. (DAz == Zero)
      else if (nOrd_XF == 2) then
        ZA = XF(4,iFd)
        DAx = XF(5,iFd)
        DAy = XF(6,iFd)
        DAz = XF(7,iFd)
        QAxx = XF(8,iFd)
        QAxy = XF(9,iFd)
        QAxz = XF(10,iFd)
        QAyy = XF(11,iFd)
        QAyz = XF(12,iFd)
        QAzz = XF(13,iFd)
        NoLoop = (ZA == Zero) .and. (DAx == Zero) .and. (DAy == Zero) .and. (DAz == Zero) .and. (QAxx == Zero) .and. &
                 (QAxy == Zero) .and. (QAxz == Zero) .and. (QAyy == Zero) .and. (QAyz == Zero) .and. (QAzz == Zero)
      else
        call WarningMessage(2,'Option not implemented yet!')
        call Quit_OnUserError()
      end if

      if (NoLoop) cycle
      A(1:3) = XF(1:3,iFd)
      iChxyz = iChAtm(A)
      call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)

      do jFd=1,iFd
        if (nOrd_XF == 0) then
          ZB = XF(4,jFd)
          NoLoop = ZB == Zero
        else if (nOrd_XF == 1) then
          ZB = XF(4,jFd)
          DBx = XF(5,jFd)
          DBy = XF(6,jFd)
          DBz = XF(7,jFd)
          NoLoop = (ZB == Zero) .and. (DBx == Zero) .and. (DBy == Zero) .and. (DBz == Zero)
        else if (nOrd_XF == 2) then
          ZB = XF(4,jFd)
          DBx = XF(5,jFd)
          DBy = XF(6,jFd)
          DBz = XF(7,jFd)
          QBxx = XF(8,jFd)
          QBxy = XF(9,jFd)
          QBxz = XF(10,jFd)
          QByy = XF(11,jFd)
          QByz = XF(12,jFd)
          QBzz = XF(13,jFd)
          NoLoop = (ZB == Zero) .and. (DBx == Zero) .and. (DBy == Zero) .and. (DBz == Zero) .and. (QBxx == Zero) .and. &
                   (QBxy == Zero) .and. (QBxz == Zero) .and. (QByy == Zero) .and. (QByz == Zero) .and. (QBzz == Zero)
        else
          call WarningMessage(2,'Option not implemented yet!')
          call Quit_OnUserError()
        end if

        if (NoLoop) cycle
        ZAZB = ZA*ZB
        B(1:3) = XF(1:3,jFd)
        iChxyz = iChAtm(B)
        call Stblz(iChxyz,mStb,jStb,iDum,jCoSet)
        ! Introduce factor to ensure that contributions from
        ! A>B are the only to be accumulated.
        Fact = One
        if (iFd == jFd) Fact = Half

        ! Find the DCR for the two centers

        call DCR(LmbdR,iStb,nStb,jStb,mStb,iDCRR,nDCRR)

        temp = Zero
        do iR=0,nDCRR-1
          RB(1) = real(iPhase(1,iDCRR(iR)),kind=wp)*B(1)
          RB(2) = real(iPhase(2,iDCRR(iR)),kind=wp)*B(2)
          RB(3) = real(iPhase(3,iDCRR(iR)),kind=wp)*B(3)
          DRBx = real(iPhase(1,iDCRR(iR)),kind=wp)*DBx
          DRBy = real(iPhase(2,iDCRR(iR)),kind=wp)*DBy
          DRBz = real(iPhase(3,iDCRR(iR)),kind=wp)*DBz
          QRBxx = QBxx
          QRByy = QByy
          QRBzz = QBzz
          QRBxy = real(iPhase(1,iDCRR(iR))*iPhase(2,iDCRR(iR)),kind=wp)*QBxy
          QRBxz = real(iPhase(1,iDCRR(iR))*iPhase(3,iDCRR(iR)),kind=wp)*QBxz
          QRByz = real(iPhase(2,iDCRR(iR))*iPhase(3,iDCRR(iR)),kind=wp)*QByz

          ! The index A=RB is illegal.
          if (.not. EQ(A,RB)) then
            x = A(1)-RB(1)
            y = A(2)-RB(2)
            z = A(3)-RB(3)
            r12 = sqrt(x**2+y**2+z**2)

            eZZ = ZAZB*One/r12
            eDZ = ZB*(-(DAx*x+DAy*y+DAz*z))/r12**3
            eZD = ZA*(DRBx*x+DRBy*y+DRBz*z)/r12**3
            eDD = (DAx*DRBx+DAy*DRBy+DAz*DRBz)/r12**3-Three*(DAx*x+DAy*y+DAz*z)*(DRBx*x+DRBy*y+DRBz*z)/r12**5

            if (nOrd_XF < 2) then
              eTOT = eZZ+eZD+eDZ+eDD
            else

              QAsum = (QAxx*x*x+QAyy*y*y+QAzz*z*z+Two*(QAxy*x*y+QAxz*x*z+QAyz*y*z))
              QBsum = (QRBxx*x*x+QRByy*y*y+QRBzz*z*z+Two*(QRBxy*x*y+QRBxz*x*z+QRByz*y*z))

              ! Q-Z
              eZQ = Half*Three/r12**5*ZA*QBsum-Half/r12**3*ZA*(QRBxx+QRByy+QRBzz)
              eQZ = Half*Three/r12**5*ZB*QAsum-Half/r12**3*ZB*(QAxx+QAyy+QAzz)

              ! Q-D
              eDQ = Half*(-15.0_wp/r12**7*(DAx*x+DAy*y+DAz*z)*QBsum+Three/r12**5* &
                    (Three*DAx*QRBxx*x+DAy*QRBxx*y+DAz*QRBxx*z+Two*DAx*QRBxy*y+Two*DAy*QRBxy*x+Two*DAx*QRBxz*z+Two*DAz*QRBxz*x+ &
                     DAx*QRByy*x+Three*DAy*QRByy*y+DAz*QRByy*z+Two*DAy*QRByz*z+Two*DAz*QRByz*y+DAx*QRBzz*x+DAy*QRBzz*y+ &
                     Three*DAz*QRBzz*z))

              eQD = -Half*(-15.0_wp/r12**7*(DRBx*x+DRBy*y+DRBz*z)*QAsum+Three/r12**5* &
                    (Three*DRBx*QAxx*x+DRBy*QAxx*y+DRBz*QAxx*z+Two*DRBx*QAxy*y+Two*DRBy*QAxy*x+Two*DRBx*QAxz*z+Two*DRBz*QAxz*x+ &
                     DRBx*QAyy*x+Three*DRBy*QAyy*y+DRBz*QAyy*z+Two*DRBy*QAyz*z+Two*DRBz*QAyz*y+DRBx*QAzz*x+DRBy*QAzz*y+ &
                     Three*DRBz*QAzz*z))

              ! Q-Q
              eQQ = Quart*(105.0_wp/r12**9*QAsum*QBsum-15.0_wp/r12**7* &
                    (Six*QAxx*QRBxx*x*x+Six*QAxx*QRBxy*x*y+Six*QAxx*QRBxz*x*z+QAxx*QRByy*x*x+QAxx*QRByy*y*y+Two*QAxx*QRByz*y*z+ &
                     QAxx*QRBzz*x*x+QAxx*QRBzz*z*z+Six*QAxy*QRBxx*x*y+Four*QAxy*QRBxy*x*x+Four*QAxy*QRBxy*y*y+Four*QAxy*QRBxz*y*z+ &
                     Six*QAxy*QRByy*x*y+Four*QAxy*QRByz*x*z+Two*QAxy*QRBzz*x*y+Six*QAxz*QRBxx*x*z+Four*QAxz*QRBxy*y*z+ &
                     Four*QAxz*QRBxz*x*x+Four*QAxz*QRBxz*z*z+Two*QAxz*QRByy*x*z+Four*QAxz*QRByz*x*y+Six*QAxz*QRBzz*x*z+ &
                     QAyy*QRBxx*x*x+QAyy*QRBxx*y*y+Six*QAyy*QRBxy*x*y+Two*QAyy*QRBxz*x*z+Six*QAyy*QRByy*y*y+Six*QAyy*QRByz*y*z+ &
                     QAyy*QRBzz*y*y+QAyy*QRBzz*z*z+Two*QAyz*QRBxx*y*z+Four*QAyz*QRBxy*x*z+Four*QAyz*QRBxz*x*y+Six*QAyz*QRByy*y*z+ &
                     Four*QAyz*QRByz*y*y+Four*QAyz*QRByz*z*z+Six*QAyz*QRBzz*y*z+QAzz*QRBxx*x*x+QAzz*QRBxx*z*z+Two*QAzz*QRBxy*x*y+ &
                     Six*QAzz*QRBxz*x*z+QAzz*QRByy*y*y+QAzz*QRByy*z*z+Six*QAzz*QRByz*y*z+Six*QAzz*QRBzz*z*z)+ &
                    Three/r12**5* &
                    (Three*QAxx*QRBxx+QAxx*QRByy+QAxx*QRBzz+Four*QAxy*QRBxy+Four*QAxz*QRBxz+QAyy*QRBxx+ &
                     Three*QAyy*QRByy+QAyy*QRBzz+Four*QAyz*QRByz+QAzz*QRBxx+QAzz*QRByy+Three*QAzz*QRBzz))

              eTOT = eZZ+eZD+eDZ+eDD+eZQ+eQZ+eDQ+eQD+eQQ
              !write(u6,*)'eZZ',eZZ
              !write(u6,*)'eDZ',eDZ
              !write(u6,*)'eZD',eZD
              !write(u6,*)'eDD',eDD
              !write(u6,*)'eZQ',eZQ
              !write(u6,*)'eQZ',eQZ
              !write(u6,*)'eDQ',eDQ
              !write(u6,*)'eQD',eQD
              !write(u6,*)'eQQ',eQQ
              !write(u6,*)'eTOT',eTOT

            end if ! if quadrupoles are present

            temp = temp+eTOT

          end if
        end do
        !PXX = PXX+(Fact*(ZAZB*temp0+ZB*temp1+ZA*temp2+temp3)*real(nIrrep,kind=wp))/real(LmbdR,kind=wp)
        PXX = PXX+(Fact*temp*real(nIrrep,kind=wp))/real(LmbdR,kind=wp)

      end do
    end do

    if (Show) then
      write(u6,'(19X,A,F16.8,A)') ' External Field Potential Energy         ',PXX,' au '
    end if
    call Put_dScalar('PC Self Energy',PXX)

    !PotNuc = PotNuc+PXX

    if (Show) then
      write(u6,*)
      write(u6,*)
      write(u6,'(11X,A,F16.8,A)') ' Total Nuclear Potential Energy        ',PotNuc,' au'
      write(u6,*)
    end if

  end if
end if

call Put_dScalar('PotNuc',PotNuc)
if (isstructure() == 1) then
  call Add_Info('PotNuc',[PotNuc],1,6)
else
  call Add_Info('PotNuc',[PotNuc],1,12)
end if

return

end subroutine DrvN0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_GetAtomPairToUniqueAtomPairMap(AP2UAP,nAP)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Get mapping from atom pair to unique atom pair.
C
C TODO/FIXME: only unique atoms are used at the moment.
C
      Implicit None
      Integer nAP
      Integer AP2UAP(nAP)
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

      Integer ip0
      Integer iAtomPair
      Integer iAtom, jAtom
      Integer ip_A2AP, l_A2AP

      Integer  LDF_nAtom, LDF_UniqueAtom
      External LDF_nAtom, LDF_UniqueAtom

      Integer i, j
      Integer A2AP
      Integer AP_Atoms
      A2AP(i)=iWork(ip_A2AP-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

#if defined (_DEBUGPRINT_)
      If (nAP.lt.NumberOfAtomPairs) Then
         Call WarningMessage(2,
     &           'LDF_GetAtomPairToUniqueAtomPairMap: dimension error!')
         Call LDF_Quit(1)
      End If
#endif

      l_A2AP=LDF_nAtom()
      Call Getmem('A2AP','Allo','Inte',ip_A2AP,l_A2AP)

      ip0=ip_A2AP-1
      Do iAtomPair=1,NumberOfAtomPairs
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         If (iAtom.eq.jAtom) Then
            iWork(ip0+iAtom)=iAtomPair
         End If
      End Do

      Do iAtomPair=1,NumberOfAtomPairs
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         If (iAtom.eq.jAtom) Then
            AP2UAP(iAtomPair)=A2AP(LDF_UniqueAtom(iAtom))
         Else ! TODO/FIXME: all off-diagonal pairs are considered unique
            AP2UAP(iAtomPair)=iAtomPair
         End If
      End Do

      Call Getmem('A2AP','Free','Inte',ip_A2AP,l_A2AP)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine Mult_Zp_Qv_s(Zp,nZp,Qv,nQv,Rv,n_Rv,nVec,nMuNu,nI,nIrrep,QMode)
!***********************************************************************
!     Author:   F. Aquilante                                           *
!                                                                      *
!     Qv: is a symmetry blocked square matrix                          *
!                                                                      *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZp, nQv, n_Rv, nIrrep, nVec(0:nIrrep-1), nMuNu(0:nIrrep-1), nI(0:nIrrep-1)
real(kind=wp), intent(in) :: Zp(nZp)
real(kind=wp), intent(out) :: Qv(nQv), Rv(n_Rv)
character, intent(in) :: QMode
integer(kind=iwp) :: iAddr, iIrrep, iOffA, iOffA2, iOffR, iOffR2, iSeed, lQv, lstepA, lstepR, Lu_Q, mQv, nI_, nK, nMuNu_
character(len=6) :: Name_Q
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
lstepA = 0
lstepR = 1
if (Qmode == 'T') then
  Rv(:) = Zero
  lstepA = 1
  lstepR = 0
end if

iOffA = 1
iOffR = 1

do iIrrep=0,nIrrep-1
  nI_ = nI(iIrrep)
  if (iIrrep == 0) nI_ = nI_-1
  nMuNu_ = nMuNu(iIrrep)
  if ((nMuNu_ <= 0) .or. (nI_ <= 0)) cycle

  iSeed = 55+iIrrep
  Lu_Q = IsFreeUnit(iSeed)
  write(Name_Q,'(A4,I2.2)') 'QVEC',iIrrep
  call DaName_MF_WA(Lu_Q,Name_Q)
  iAddr = 0

  iOffR2 = iOffR
  iOffA2 = iOffA
  mQv = nI_*nVec(iIrrep)
  do while (mQv >= nI_)

    nK = min(mQv,nQv)/nI_
    lQv = nI_*nK
    call dDaFile(Lu_Q,2,Qv,lQv,iAddr)

    call A_3C_Qv_s(Zp(iOffA2),Qv,Rv(iOffR2),nMuNu_,nI_,nK,QMode)
    mQv = mQv-lQv
    iOffR2 = iOffR2+lstepR*nMuNu_*nK
    iOffA2 = iOffA2+lstepA*nMuNu_*nK
  end do

  iOffA = iOffA+nMuNu_*nI_
  iOffR = iOffR+nMuNu_*nVec(iIrrep)
  call DaClos(Lu_Q)
end do

return

end subroutine Mult_Zp_Qv_s

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine dds_drlbr_act_c_sgt0(lin)
!=======================================================================
!dds(9-4) drl(12)-br(31)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmr.or.lmi.ne.jml) cycle
          iwdr=just(lri,lrj)
          iwdl=jud(lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          w1ds =w1_d1s(4)
          ni=mod(norb_dz-lrj,2)
          if(ni.eq.1) w1ds=-w1ds
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w0(mpl)*w1ds
          enddo
          call drl_br_ext_al_new(lin,lri,lrj)
        enddo
      enddo

      return
      end

      subroutine dds_ardlr_act_c_sgt0(lin )
!=======================================================================
!dds(9-1) ar(13)-drl(30)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrd=norb_frz+1,lri-1
          lmd=lsm_inn(lrd)
          if(lmd.ne.jml) cycle
          iwdr=just(lri,lri)
          iwdl=jud(lrd)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          w0ds1 =w0_d1s(1)
          ni=mod(norb_dz-lrd,2)
          if(ni.eq.0) w0ds1 =-w0ds1
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ds1
            vplp_w1(mpl)=0.d0
          enddo
          call ar_drl_ext_al_new(lin,lrd,lri )
        enddo
      enddo

      return
      end

      subroutine dds_arblbr_act_c_sgt0(lin )
!=======================================================================
!d1s(9-2)    ar(13)-bl(31)-br(32)-
!d1s(9-3)    ar(13)-bl(32)-br(31)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmr) cycle
          do lrd=norb_frz+1,lri-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jml) cycle
            ijk=lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
            w0ds2 =w0_d1s(2)
            w1ds2 =w1_d1s(2)
            w0ds3 =w0_d1s(3)
            w1ds3 =w1_d1s(3)
            ni=mod(norb_dz-lrj+lri-lrd,2)
            if(ni.eq.0) then
             w0ds2 =-w0ds2
              w1ds2 =-w1ds2
             w0ds3 =-w0ds3
              w1ds3 =-w1ds3
            endif
!d1s(9-2)    ar(13)-bl(31)-br(32)-
            iwdr=just(lrj,lri)
            iwdl=jud(lrd)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ds2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ds2
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!d1s(9-3)    ar(13)-bl(32)-br(31)-
            iwdr=just(lri,lrj)
            iwdl=jud(lrd)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ds3
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ds3
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          enddo
        enddo
      enddo
      return
      end

      subroutine tttt_drl_act_br_sgt1(lin,lra)
!t1t1(12-2)  drl(11)-
!t1t1(12-2)  drl(11)-c"(11)-
!t1t1(12-3)  drl(33)-
!t1t1(12-3)  drl(33)-c"(11)-
!t1t1(12-3)  drl(33)-c"(11)-c"(11)-
!tt(11-2) (22)drl(22)-
!tt(11-2) drl(22)-c"(22)-
!tt(11-3) (22)(22)drl(33)-
!tt(11-3) (22)drl(33)-c"(22)-
!tt(11-3) drl(33)-c"(22)-c"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
        do lri=norb_frz+1,norb_dz
          lmi=lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj=lsm_inn(lrj)
            lmij=mul_tab(lmi,lmj)
            if(lmij.ne.jml) cycle
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_t1t1(2)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_t1t1(2)
            enddo
!t1t1(12-2)  drl(11)-
!t1t1(12-2)  drl(11)-c"(11)-
            iwdl=just(lri,lrj)       !
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call drl_br_ext_al_new(lin,lri,lra)
            call drl_br_ext_al_new(lin,lrj,lra)
!t1t1(12-3)  drl(33)-
!t1t1(12-3)  drl(33)-c"(11)-
!t1t1(12-3)  drl(33)-c"(11)-c"(11)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_t1t1(3)
              vplp_w1(mpl)=0.d0
            enddo
            if(lra.gt.norb_dz) then
             call drl_br_sum_al_new(lin,lri,lrj,lra)
            else
             do lrk=1,norb_dz
                if(lrk.eq.lri) cycle
                if(lrk.eq.lrj) cycle
                call drl_br_ext_al_new(lin,lrk,lra)
              enddo
            endif
          enddo
        enddo
      return
      end


      subroutine tttt_arbl_act_br_sgt1(lin,lra)
!=======================================================================
!t1t1(12-1)  (22)ar(13)-bl(31)-
!t1t1(12-1)  ar(13)-c'(11)-bl(31)-
!t1t1(12-1)  ar(13)-bl(31)-c"(11)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
        do lri=norb_frz+1,norb_dz
          lmi=lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj=lsm_inn(lrj)
            lmij=mul_tab(lmi,lmj)
            if(lmij.ne.jmlr) cycle
           ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
            intpos=intind_ijka(ijk)
            w0tt1=w0_t1t1(1)
            w1tt1=w1_t1t1(1)
            ni=mod(lrj-lri,2)
            if(ni.eq.0) then
              w0tt1=-w0tt1
              w1tt1=-w1tt1
            endif
!-------------------------------------------------------------------
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0tt1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1tt1
          enddo
!t1t1(12-1)  (22)ar(13)-bl(31)-
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            if(mul_tab(lmk,lmi).ne.jml) cycle
           iwdl=just(lrk,lri)      !
            iwdr=just(lrk,lrj)      !
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          enddo
!t1t1(12-1)  ar(13)-bl(31)-c"(11)-
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            if(mul_tab(lmk,lmi).ne.jml) cycle
            iwdl=just(lri,lrk)    !
            iwdr=just(lrj,lrk)    !
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          enddo
!t1t1(12-1)  ar(13)-c'(11)-bl(31)-
          do mpl=1,mtype
            vplp_w0(mpl)=-vplp_w0(mpl)
            vplp_w1(mpl)=-vplp_w1(mpl)
          enddo
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            if(mul_tab(lmk,lmi).ne.jml) cycle
           iwdl=just(lri,lrk)       !
            iwdr=just(lrk,lrj)       !
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          enddo
        enddo
      enddo
      return
      end

      subroutine ttdd_ar_act_dlr_sgt1(lin,lra)
!t1d1(15-1) (11)a(13)
!t1d1(15-1) a(13)c'(11)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_t1d1(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
        ijk=lri-norb_frz+lra
        intpos=intind_ijka(ijk)
!-------------------------------------------------------------------
!t1d1(15-1) (11)a(13)
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr.and.mul_tab(lmk,lmi).ne.jml) cycle
            iwdl=just(lrk,lri)   !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_drl_ext_al_new(lin,lri,lra)
          enddo
!-------------------------------------------------------------------
!t1d1(15-1) a(13)c'(11)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr.and.mul_tab(lmk,lmi).ne.jml) cycle
            iwdl=just(lri,lrk)     !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_drl_ext_al_new(lin,lri,lra)
          enddo
        enddo
      return
      end

      subroutine ttdd_ar_act_blbr_sgt1(lin,jk )
!t1d1(15-1) (11)a(13)
!t1d1(15-1) a(13)c'(11)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_t1d1(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
!-------------------------------------------------------------------
!t1d1(15-1) (11)a(13)
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)    !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          enddo
!-------------------------------------------------------------------
!t1d1(15-1) a(13)c'(11)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)    !
            iwdr=jud(lrk)
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          enddo
        enddo
      return
      end

      subroutine ddtt_arblbr_act_c1_sgt1(lin )
!=======================================================================
!d1t1(16) ar(13)-bl(31)-br(31)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmr) cycle
!d1t1(16) ar(13)-bl(31)-br(31)-
          do lrd=norb_frz+1,lri-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jml) cycle
            ijk=lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
            w0dt =w0_d1t1
            w1dt =w1_d1t1
            ni=mod(norb_dz-lrj+lri-lrd,2)
            if(ni.eq.0) w0dt =-w0dt
            if(ni.eq.0) w1dt =-w1dt

            iwdr=just(lri,lrj)     !
            iwdl=jud(lrd)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dt
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dt
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1)
          enddo
        enddo
      enddo

      return
      end

      subroutine dddd_drl_act_br_sgt0(lin,lra)
!d1d1(20-2) drl(11)-
!d1d1(20-3) drl(33)-c"(11)-
!d1d1(20-3) (11)drl(33)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
      do lrl=norb_frz+1,norb_dz
        lml=lsm_inn(lrl)
        if(lml.ne.jml) cycle
!-------------------------------------------------------------------
         iwdl=jud(lrl)
         iwdr=iwdl
         do mpl=1,mhlp
           iwal=lpnew_lwei(mpl)
           iwar=lpnew_rwei(mpl)
           lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
           lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
         enddo
         w0=w0_d1d1(2)
         w1=w1_d1d1(2)
         do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1
         enddo
         call drl_br_ext_al_new(lin,lrl,lra)

         w0=w0_d1d1(3)
         w1=0.d0
         do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1
         enddo
         do lrk=1,norb_dz
           if(lrk.eq.lrl) cycle
           call drl_br_ext_al_new(lin,lrk,lra)
         enddo
       enddo
      return
      end

      subroutine dddd_arbl_act_br_sgt0(lin,lra)
!d1d1(20-1) a&r(13)-b&l(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lrl=norb_frz+1,norb_dz-1
        lml=lsm_inn(lrl)
        if(lml.ne.jml) cycle
        do lrr=lrl+1,norb_dz
          lmr=lsm_inn(lrr)
          if(lmr.ne.jmr) cycle
            ijk=lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
            intpos=intind_ijka(ijk)
            w0dd1=w0_d1d1(1)
            w1dd1=w1_d1d1(1)
            ni=mod(lrr-lrl,2)
            if(ni.eq.0) w0dd1=-w0dd1
            if(ni.eq.0) w1dd1=-w1dd1
           do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo

            iwdl=jud(lrl)
            iwdr=jud(lrr)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!-------------------------------------------------------------------
        enddo
      enddo
      return
      end

      subroutine ddv_ar_act_blbr_sgt0(lin,jk )
!=======================================================================
!dv(24-1) ar(13)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)

        w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0dv1=-w0dv1
        iwdl=jud(lri)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0dv1
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0dv1
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_bl_br_ext_al_new(lin,intpos,isma,1)
      enddo
      return
      end

      subroutine ddv_ar_act_dlr_sgt0(lin,lra)
!=======================================================================
!d1v(24-1) ar(13)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle

        w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0dv1=-w0dv1
        iwdl=jud(lri)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0dv1
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0dv1
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_drl_ext_al_new(lin,lri,lra)
      enddo

      return
      end

      subroutine dd1_arbl_act_br_sgt0(lin,lra)
!dd1(21-1) a&r(23)-b&l(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lrl=norb_frz+1,norb_dz-1
        lml=lsm_inn(lrl)
        if(lml.ne.jml) cycle
        do lrr=lrl+1,norb_dz
          lmr=lsm_inn(lrr)
          if(lmr.ne.jmr) cycle
            ijk=lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
            intpos=intind_ijka(ijk)
!            w0dd1=0.d0
            w1dd1=w1_dd1
            ni=mod(lrr-lrl,2)
            if(ni.eq.0) w1dd1=-w1_dd1
           do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo

            iwdl=jud(lrl)
            iwdr=jud(lrr)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!-------------------------------------------------------------------
        enddo
      enddo
      return
      end

      subroutine d1d_arbl_act_br_sgt0(lin,lra)
!d1d(22-1) a&r(13)-b&l(32)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lrl=norb_frz+1,norb_dz-1
        lml=lsm_inn(lrl)
        if(lml.ne.jml) cycle
        do lrr=lrl+1,norb_dz
          lmr=lsm_inn(lrr)
          if(lmr.ne.jmr) cycle
            ijk=lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
            intpos=intind_ijka(ijk)
!            w0dd1=0.d0
            w1dd1=w1_d1d(1)
            ni=mod(lrr-lrl,2)
            if(ni.eq.0) w1dd1=-w1dd1
           do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo

            iwdl=jud(lrl)
            iwdr=jud(lrr)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
           call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!-------------------------------------------------------------------
        enddo
      enddo
      return
      end

      subroutine d1d_drl_act_br_sgt0(lin,lra)
!d1d(22-2) drl(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=1
      do lrl=norb_frz+1,norb_dz
        lml=lsm_inn(lrl)
        if(lml.ne.jml) cycle
!-------------------------------------------------------------------
         iwdl=jud(lrl)
         iwdr=iwdl
         do mpl=1,mhlp
           iwal=lpnew_lwei(mpl)
           iwar=lpnew_rwei(mpl)
           lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
           lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
         enddo
         w1=w1_d1d(2)
         do mpl=1,mtype
           vplp_w0(mpl)=0.d0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1
         enddo
         call drl_br_ext_al_new(lin,lrl,lra)
      enddo

      return
      end

!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! end of vd, next dd
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine ss_arbr_act_c_dd_ext_sgt0()
!ss(1-1)  ar(01)-bl(32)-        act -c"-
!ss(1-3)  ar(13)-bl(20)-        act -c"-
!ss(1-6)  (11)-ar(23)-bl(32)-   act -c"-
!ss(1-7)  ar(13)-c'(21)-bl(32)- act -c"-
!ss(1-8)  ar(13)-c'(22)-bl(31)- act -c"-
!ss(1-9)  ar(23)-c'(11)-bl(32)- act -c"-
!ss(1-11) ar(13)-bl(31)-c"(22)- act -c"-
!ss(1-12) ar(13)-bl(32)-c"(21)- act -c"-
!ss(1-13) ar(23)-bl(31)-c"(12)- act -c"-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w0ss1=w0_ss(1)
          w1ss1=w1_ss(1)
          w0ss3=w0_ss(3)
          w1ss3=w1_ss(3)
          w0ss6=w0_ss(6)
          w1ss6=w1_ss(6)
          w0ss7=w0_ss(7)
          w1ss7=w1_ss(7)
          w0ss8=w0_ss(8)
          w1ss8=w1_ss(8)
          w0ss9=w0_ss(9)
          w1ss9=w1_ss(9)
          w0ss11=w0_ss(11)
          w1ss11=w1_ss(11)
          w0ss12=w0_ss(12)
          w1ss12=w1_ss(12)
          w0ss13=w0_ss(13)
          w1ss13=w1_ss(13)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0ss1=-w0ss1
            w1ss1=-w1ss1
            w0ss3=-w0ss3
            w1ss3=-w1ss3
            w0ss6=-w0ss6
            w1ss6=-w1ss6
            w0ss7=-w0ss7
            w1ss7=-w1ss7
            w0ss8=-w0ss8
            w1ss8=-w1ss8
            w0ss9=-w0ss9
            w1ss9=-w1ss9
            w0ss11=-w0ss11
            w1ss11=-w1ss11
            w0ss12=-w0ss12
            w1ss12=-w1ss12
            w0ss13=-w0ss13
            w1ss13=-w1ss13
          endif
!ss(1-1)  ar(01)-bl(32)-        act -c"-
          if(jml.eq.1.and.lmij.eq.jmr) then
            iwdl=just(lri,lri)
            iwdr=just(lrj,lri)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
              do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss1
            enddo
          call ar_bl_dd_ext(lri,lrj,1)
          endif
!ss(1-3)  ar(13)-bl(20)-        act -c"-
          if(jmr.eq.1.and.lmij.eq.jml) then
            iwdl=just(lrj,lri)
            iwdr=just(lrj,lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
              do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss3
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss3
            enddo
          call ar_bl_dd_ext(lri,lrj,1)
          endif
!ss(1-6)  (11)-ar(23)-bl(32)-   act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss6
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss6
          enddo
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
              if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
            enddo
!ss(1-7)  ar(13)-c'(21)-bl(32)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0ss7
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ss7
          enddo
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!ss(1-8)  ar(13)-c'(22)-bl(31)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0ss8
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ss8
          enddo
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!ss(1-9)  ar(23)-c'(11)-bl(32)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0ss9
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ss9
          enddo
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!ss(1-11) ar(13)-bl(31)-c"(22)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss11
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss11
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!ss(1-12) ar(13)-bl(32)-c"(21)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss12
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss12
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!ss(1-13) ar(23)-bl(31)-c"(12)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss13
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss13
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
        enddo
      enddo

      return
      end

      subroutine ss_arbr_act_c_dd_ext()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w0ss2=w0_ss(2)
          w1ss2=w1_ss(2)
          w0ss4=w0_ss(4)
          w1ss4=w1_ss(4)
          w0ss5=w0_ss(5)
          w1ss5=w1_ss(5)
          w0ss10=-w0_ss(10)
          w1ss10=-w1_ss(10)
          w0ss14=w0_ss(14)
          w1ss14=w1_ss(14)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0ss2=-w0ss2
            w1ss2=-w1ss2
            w0ss4=-w0ss4
            w1ss4=-w1ss4
            w0ss5=-w0ss5
            w1ss5=-w1ss5
            w0ss10=-w0ss10
            w1ss10=-w1ss10
            w0ss14=-w0ss14
            w1ss14=-w1ss14
          endif
          if(jml.eq.1.and.lmij.eq.jmr) then
!ss(1-2)  ar(02)-bl(31)-        act -c"-
            iwdl=just(lri,lri)
            iwdr=just(lri,lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
              do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss2
            enddo
          call ar_bl_dd_ext(lri,lrj,1)
          endif
          if(jmr.eq.1.and.lmij.eq.jml) then
!ss(1-4)  ar(23)-bl(10)-        act -c"-                         ! iprad
            iwdl=just(lri,lrj)
            iwdr=just(lrj,lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
              do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss4
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss4
            enddo
          call ar_bl_dd_ext(lri,lrj,1)
          endif
!ss(1-5)  (22)-ar(13)-bl(31)-   act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss5
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss5
          enddo
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
              if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
            enddo
!ss(1-10) ar(23)-c'(12)-bl(31)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss10
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss10
          enddo
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
              if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!ss(1-14) ar(23)-bl(32)-c"(11)- act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss14
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss14
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
        enddo
      enddo

      return
      end


      subroutine ss_drl_act_c_dd_ext_sgt0()
!ss(1-18) drl(11)-c"(22)-       act -c"-
!ss(1-19) drl(12)-c"(21)-       act -c"-
!ss(1-20) (11)-drl(33)-c"(22)-  act -c"-
!ss(1-20) drl(33)-c"(11)-c"(22)-act -c"-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jml.ne.jmr) return
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          iwdl=just(lrj,lri)
          iwdr=iwdl
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
!ss(1-16) (11)-drl(22)-         act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(16)
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(16)
          enddo
          call drl_dd_ext(lrj)
!ss(1-18) drl(11)-c"(22)-       act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(18)
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(18)
          enddo
          call drl_dd_ext(lri)
!ss(1-20) (11)(22)drl(33)-  act -c"-
!ss(1-20) (11)-drl(33)-c"(22)-  act -c"-
!ss(1-20) drl(33)-c"(11)-c"(22)-act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0_ss(20)
            vplp_w1(mpl)=0.d0
          enddo
          do lrk=1,norb_dz
            if(lrk.eq.lri) cycle
            if(lrk.eq.lrj) cycle
            call drl_dd_ext(lrk)
          enddo
        enddo
      enddo

      return
      end

      subroutine ss_s_drl_act_c_dd_ext_sgt0()
!ss(1-19) drl(12)-c"(21)-       act -c"-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jml.ne.jmr) return
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
!ss(1-19) drl(12)-c"(21)-       act -c"-
          iwdl=just(lrj,lri)
          iwdr=just(lri,lrj)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_ss(19)
          enddo
          call drl_dd_ext(lri)
        enddo
      enddo

      return
      end

      subroutine ss_drl_act_c_dd_ext()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      w0ss15=w0_ss(15)
      w1ss15=w1_ss(15)
      w0ss17=w0_ss(17)
      w1ss17=w1_ss(17)
      w0ss20=w0_ss(20)
      if(jml.eq.1.and.jmr.eq.1) then
!ss(1-20) drl(33)-c"(00)-       act -c"-                     ! ipl(r)ad=
        do lr0=norb_frz+1,norb_dz
          iwdl=just(lr0,lr0)
          iwdr=iwdl
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do lrk=1,norb_dz
            if(lrk.eq.lr0) cycle
              do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss20
              vplp_w1(mpl)=0.d0
            enddo
            call drl_dd_ext(lrk)
          enddo
        enddo
      endif
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml.or.lmij.ne.jmr) cycle
          iwdl=just(lri,lrj)
          iwdr=iwdl
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
!ss(1-15) (22)-drl(11)-         act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss15
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss15
          enddo
          call drl_dd_ext(lrj)
!ss(1-17) drl(22)-c"(11)-       act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss17
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ss17
          enddo
          call drl_dd_ext(lri)
!ss(1-20) (22)(11)drl(33)-      act -c"-
!ss(1-20) (22)drl(33)-c"(11)-   act -c"-
!ss(1-20) drl(33)-c"(22)-c"(11)-act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0ss20
            vplp_w1(mpl)=0.d0
          enddo
          do lrk=1,norb_dz
            if(lrk.eq.lri) cycle
            if(lrk.eq.lrj) cycle
            call drl_dd_ext(lrk)
          enddo
        enddo
      enddo

      return
      end

      subroutine st_arbl_act_c_dd_ext_sgt0()
!st(2-3) ar(13)-c'(22)-bl(32)-   act -c"-
!st(2-3) ar(13)-bl(32)-c'(22)-   act -c"-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w1st3=w1_st(3)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w1st3=-w1st3
          endif
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!st(2-3) ar(13)-c'(22)-bl(32)-   act -c"-
              iwdl=just(lrk,lri)
              iwdr=just(lrk,lrj)      !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
                do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=-vplpnew_w1(mpl)*w1st3
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!st(2-3) ar(13)-bl(32)-c'(22)-   act -c"-
              iwdl=just(lrk,lri)
              iwdr=just(lrj,lrk)      !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=vplpnew_w1(mpl)*w1st3
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
        enddo
      enddo

      return
      end

      subroutine st_arbl_act_c_dd_ext()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w1st1=w1_st(1)
          w1st2=w1_st(2)
          w1st4=w1_st(4)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w1st1=-w1st1
            w1st2=-w1st2
            w1st4=-w1st4
          endif
          if(jml.eq.1.and.lmij.eq.jmr) then
!st(2-1) ar(02)-bl(32)-          act -c"-
            iwdl=just(lri,lri)
            iwdr=just(lri,lrj)      !
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
              do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1st1
            enddo
            call ar_bl_dd_ext(lri,lrj,1)
          endif
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
              if(lmki.eq.jml.and.lmkj.eq.jmr) then
!st(2-2) (22)ar(13)-bl(32)-      act -c"-
              iwdl=just(lrk,lri)
              iwdr=just(lrk,lrj)         !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
                do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=vplpnew_w1(mpl)*w1st2
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
            enddo
            do lrk=lri+1,lrj-1
              lmk=lsm_inn(lrk)
              lmki=mul_tab(lmk,lmi)
              lmkj=mul_tab(lmk,lmj)
              if(lmki.eq.jml.and.lmkj.eq.jmr) then
!st(2-4) ar(23)-c'(12)-bl(32)-   act -c"-
              iwdl=just(lri,lrk)
              iwdr=just(lrk,lrj)      !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
                do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=vplpnew_w1(mpl)*w1st4
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!st(2-4) ar(23)-bl(32)-c'(12)-   act -c"-
              iwdl=just(lri,lrk)
              iwdr=just(lrj,lrk)      !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
                do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=vplpnew_w1(mpl)*w1st4
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
        enddo
      enddo

      return
      end

      subroutine st_drl_act_c_dd_ext_sgt0()
!----------------------------------------------------------
!st(2-7) drl(12)-c"(22)-         act -c"-
!----------------------------------------------------------
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
!st(2-7) drl(12)-c"(22)-         act -c"-
          if(lmij.ne.jml.or.lmij.ne.jmr) cycle
          iwdl=just(lrj,lri)
          iwdr=just(lri,lrj)      !
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_st(7)
          enddo
          call drl_dd_ext(lri)
        enddo
      enddo

      return
      end

      subroutine st_drl_act_c_dd_ext()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml.or.lmij.ne.jmr) cycle
!st(2-5) (22)drl(12)-          act -c"-
          iwdl=just(lri,lrj)
          iwdr=just(lrj,lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_st(5)
          enddo
          call drl_dd_ext(lrj)
!st(2-6) drl(22)-c"(12)-       act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1_st(6)
          enddo
          call drl_dd_ext(lri)
        enddo
      enddo

      return
      end

      subroutine ts_arbl_act_c_dd_exe_sgt0()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w1ts3=w1_ts(3)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w1ts3=-w1ts3
          endif
!ts(3-3) ar(23)-bl(31)-c"(22)-   act -c"-
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts3
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)          !
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
        enddo
      enddo

      return
      end

      subroutine stt_arbl_act_c_dd_ext_sgt1()
!st1(4-1) ar(01)-bl(31)-
!st1(4-2) ar(23)-bl(31)-
!st1(4-3) ar(13)-c'(21)-bl(31)-
!st1(4-3) ar(13)-bl(31)-c"(21)-
!st1(4-4) ar(23)-c'(11)-bl(31)-
!st1(4-4) ar(23)-bl(31)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w1ts1=w1_st1(1)
          w1ts2=w1_st1(2)
          w1ts3=w1_st1(3)
          w1ts4=w1_st1(4)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w1ts1=-w1ts1
            w1ts2=-w1ts2
            w1ts3=-w1ts3
            w1ts4=-w1ts4
          endif
          if(jml.eq.1.and.lmij.eq.jmr) then
!st1(4-1) ar(01)-bl(31)-
            iwdl=just(lri,lri)   !
            iwdr=just(lri,lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts1
            enddo
            call ar_bl_dd_ext(lri,lrj,1)
          endif
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!st1(4-2) (11)ar(23)-bl(31)-
              iwdl=just(lri,lrk)      !
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts2
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!st1(4-3) ar(13)-c'(21)-bl(31)-
!st1(4-4) ar(23)-c'(11)-bl(31)-
              iwdl=just(lrk,lri)        !
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ts3
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
              iwdl=just(lri,lrk)        !
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ts4
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!st1(4-3) ar(13)-bl(31)-c"(21)-
!st1(4-4) ar(23)-bl(31)-c"(11)-
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)          !
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
               vplp_w0(mpl)=0.d0
               vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts3
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
              iwdl=just(lri,lrk)          !
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
               vplp_w0(mpl)=0.d0
               vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts4
              enddo
              call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
        enddo
      enddo

      return
      end

      subroutine tts_arbl_act_c_dd_ext_sgt1()
!t1s(5-1)   ar(13)-bl(10)-
!t1s(5-2)   ar(13)-bl(32)-
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
!t1s(5-5)   drl(12)-
!t1s(5-6)   drl(12)-c"(12)-
!t1s(5-7)   drl(12)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w1ts1=w1_t1s(1)
          w1ts2=w1_t1s(2)
          w1ts3=w1_t1s(3)
          w1ts4=w1_t1s(4)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w1ts1=-w1ts1
            w1ts2=-w1ts2
            w1ts3=-w1ts3
            w1ts4=-w1ts4
          endif
          if(jmr.eq.1.and.lmij.eq.jml) then
!t1s(5-1)   ar(13)-bl(10)-
            iwdl=just(lri,lrj)   !
            iwdr=just(lrj,lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
              do mpl=1,mtype
              vplp_w0(mpl)=0.d0
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts1
            enddo
          call ar_bl_dd_ext(lri,lrj,1)
          endif
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!t1s(5-2)   (11)ar(13)-bl(32)-
              iwdl=just(lrk,lri)      !
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
                do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts2
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
            enddo
            do lrk=lri+1,lrj-1
             lmk=lsm_inn(lrk)
              lmki=mul_tab(lmk,lmi)
              lmkj=mul_tab(lmk,lmj)
              if(lmki.eq.jml.and.lmkj.eq.jmr) then
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
              iwdl=just(lri,lrk)        !
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
                do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=-vplpnew_w1(mpl)*w1ts2
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts3
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)          !
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts4
          enddo
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)          !
              iwdr=just(lrj,lrk)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
        enddo
      enddo

      return
      end

      subroutine tts_drl_act_c_dd_ext_sgt1()
!t1s(5-5)   (11)drl(12)-
!t1s(5-6)   drl(12)-c"(12)-
!t1s(5-7)   drl(12)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jml.ne.jmr) return
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=norb_frz+1,lri-1
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(jml.ne.lmij) cycle
!t1s(5-5)   (11)drl(12)-
!t1s(5-6)   drl(11)-c"(12)-
         iwdl=just(lrj,lri)          !
         iwdr=just(lri,lrj)
         do mpl=1,mhlp
           iwal=lpnew_lwei(mpl)
           iwar=lpnew_rwei(mpl)
           lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
           lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
         enddo
         do mpl=1,mtype
           vplp_w0(mpl)=0.d0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1_t1s(5)
         enddo
         call drl_dd_ext(lri)
         do mpl=1,mtype
           vplp_w0(mpl)=0.d0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1_t1s(6)
         enddo
         call drl_dd_ext(lrj)
!t1s(5-7)   drl(12)-c"(11)-
         iwdl=just(lrj,lri)          !
         iwdr=iwdl
         do mpl=1,mhlp
           iwal=lpnew_lwei(mpl)
           iwar=lpnew_rwei(mpl)
           lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
           lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
         enddo
         do mpl=1,mtype
           vplp_w0(mpl)=0.d0
           vplp_w1(mpl)=vplpnew_w1(mpl)*w1_t1s(7)
         enddo
         call drl_dd_ext(lrj)
      enddo
      enddo

      return
      end

      subroutine sd_ar_act_bl_dd_ext_sgt0(lra)
!sd(6-3) a&r(13)c'(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd3=w0_sd(3)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0sd3=-w0sd3
!sd(6-3) a&r(13)-c'(22)-
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          lmki=mul_tab(lmk,lmi)
          if(lmki.eq.jml.and.lmk.eq.jmr) then
            iwdl=just(lrk,lri)
            iwdr=jud(lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd3
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd3
            enddo
          call ar_bl_dd_ext(lri,lra,1)
          endif
        enddo
      enddo

      return
      end


      subroutine sdd_ar_act_bl_dd_ext_sgt0(lra)
!sd1(8-1)    ar(01)-
!sd1(8-2)    (11)ar(23)-
!sd1(8-3)    ar(13)-c'(21)-
!sd1(8-4)    ar(23)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1=w0_sd1(1)
        w0sd2=w0_sd1(2)
        w0sd3=w0_sd1(3)
        w0sd4=w0_sd1(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1)w0sd1=-w0sd1
        if(ni.eq.1)w0sd2=-w0sd2
        if(ni.eq.1)w0sd3=-w0sd3
        if(ni.eq.1)w0sd4=-w0sd4
        if(jml.eq.1.and.lmi.eq.jmr) then
!sd1(8-1)    ar(01)-
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          call ar_bl_dd_ext(lri,lra,1)
        endif
!sd1(8-2)    (11)ar(23)-
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          lmki=mul_tab(lmk,lmi)
          if(lmki.eq.jml.and.lmk.eq.jmr) then
            iwdl=just(lri,lrk)
            iwdr=jud(lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
            enddo
            call ar_bl_dd_ext(lri,lra,1)
          endif
        enddo
!sd1(8-3)    ar(13)-c'(21)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd3           ! - ????
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd3           ! - ????
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          lmki=mul_tab(lmk,lmi)
          if(lmki.eq.jml.and.lmk.eq.jmr) then
            iwdl=just(lrk,lri)
            iwdr=jud(lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_dd_ext(lri,lra,1)
          endif
        enddo
!sd1(8-4)    ar(23)-c'(11)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4           ! - ????
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4           ! - ????
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          lmki=mul_tab(lmk,lmi)
          if(lmki.eq.jml.and.lmk.eq.jmr) then
            iwdl=just(lri,lrk)
            iwdr=jud(lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
          call ar_bl_dd_ext(lri,lra,1)
          endif
        enddo
      enddo

      return
      end

      subroutine tttt_arbl_act_c_dd_ext_sgt1()
!t1t1(12-1)  ar(13)-bl(31)-
!t1t1(12-1)  ar(13)-c'(11)-bl(31)-
!t1t1(12-1)  ar(13)-bl(31)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w0tt1=w0_t1t1(1)
          w1tt1=w1_t1t1(1)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0tt1=-w0tt1
            w1tt1=-w1tt1
          endif
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0tt1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1tt1
          enddo
!t1t1(12-1)  (11)ar(13)-bl(31)-
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)       !
              iwdr=just(lrk,lrj)       !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
!t1t1(12-1)  ar(13)-bl(31)-c"(11)-
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)     !
              iwdr=just(lrj,lrk)     !
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=-vplp_w0(mpl)
            vplp_w1(mpl)=-vplp_w1(mpl)
          enddo
!t1t1(12-1)  ar(13)-c'(11)-bl(31)-
          do lrk=lri+1,lrj-1
           lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)      !
              iwdr=just(lrk,lrj)      !
            do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
            call ar_bl_dd_ext(lri,lrj,1)
            endif
          enddo
        enddo
      enddo

      return
      end

      subroutine tttt_drl_act_c_dd_ext_sgt1()
!t1t1(12-2)  drl(11)-
!t1t1(12-2)  drl(11)-c"(11)-
!t1t1(12-3)  drl(33)-
!t1t1(12-3)  drl(33)-c"(11)-
!t1t1(12-3)  drl(33)-c"(11)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml.or.lmij.ne.jmr) cycle
!t1t1(12-2)  drl(11)-
!t1t1(12-2)  drl(11)-c"(11)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_t1t1(2)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_t1t1(2)
            enddo
            iwdl=just(lri,lrj)   !
            iwdr=iwdl
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call drl_dd_ext(lri)
            call drl_dd_ext(lrj)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_t1t1(3)
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,norb_dz
              if(lrk.eq.lri) cycle
              if(lrk.eq.lrj) cycle
              lmk=lsm_inn(lrk)
              lmki=mul_tab(lmk,lmi)
              lmkj=mul_tab(lmk,lmj)
!t1t1(12-3)  drl(33)-
!t1t1(12-3)  drl(33)-c"(11)-
!t1t1(12-3)  drl(33)-c"(11)-c"(11)-
              call drl_dd_ext(lrk)
            enddo
          enddo
        enddo

      return
      end

      subroutine ttdd_ar_act_bl_dd_ext_sgt1(lra)
!t1d1(15-1)  (11)ar(13)-
!t1d1(15-1)  ar(13)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_t1d1(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1)w0td1=-w0td1

        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.eq.jmr) then
!t1d1(15-1)  (11)ar(13)-
            iwdl=just(lrk,lri)    !
            iwdr=jud(lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
            enddo
          call ar_bl_dd_ext(lri,lra,1)
          endif
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.eq.jmr) then
!t1d1(15-1)  ar(13)-c'(11)-
            iwdl=just(lri,lrk)    !
            iwdr=jud(lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
              vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
            enddo
            call ar_bl_dd_ext(lri,lra,1)
          endif
        enddo
      enddo

      return
      end

      subroutine dddd_arbl_act_c_dd_ext_sgt0()
!d1d1(20-1) ar(13)-bl(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
          w0dd1=w0_d1d1(1)
          w1dd1=w1_d1d1(1)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0dd1=-w0dd1
            w1dd1=-w1dd1
          endif
          if(lmi.eq.jml.and.lmj.eq.jmr) then
!d1d1(20-1) ar(13)-bl(31)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo
            iwdl=jud(lri)
            iwdr=jud(lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_bl_dd_ext(lri,lrj,1)
          endif
        enddo
      enddo

      return
      end

      subroutine dddd_drl_act_c_dd_ext_sgt0()
!d1d1(20-2) drl(11)-
!d1d1(20-3) drl(33)-
!d1d1(20-3) drl(33)-c"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jmr.ne.jml) return
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle
!d1d1(20-2) drl(11)-
        iwdl=jud(lri)
        iwdr=iwdl
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0_d1d1(2)
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1_d1d1(2)
        enddo
        call drl_dd_ext(lri)
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0_d1d1(3)
          vplp_w1(mpl)=0.d0
        enddo
!d1d1(20-3) drl(33)-
!d1d1(20-3) drl(33)-c"(11)-
        do lrk=1,norb_dz
          if(lrk.eq.lri) cycle
          call drl_dd_ext(lrk)
        enddo
      enddo

      return
      end

      subroutine dd1_arbl_act_c_dd_ext_sgt0()
!dd1(21)ar(23)-bl(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
          w0dd1=w0_dd1
          w1dd1=w1_dd1
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0dd1=-w0dd1
            w1dd1=-w1dd1
          endif
          if(lmi.eq.jml.and.lmj.eq.jmr) then
!dd1(21)ar(23)-bl(31)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo
            iwdl=jud(lri)
            iwdr=jud(lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_bl_dd_ext(lri,lrj,1)
          endif
        enddo
      enddo

      return
      end

      subroutine d1d_arbl_act_c_dd_ext_sgt0()
!d1d(22-1)   ar(13)-bl(32)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
          w0dd1=w0_d1d(1)
          w1dd1=w1_d1d(1)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0dd1=-w0dd1
            w1dd1=-w1dd1
          endif
          if(lmi.eq.jml.and.lmj.eq.jmr) then
!d1d(22-1)   ar(13)-bl(32)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0dd1
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1dd1
            enddo
            iwdl=jud(lri)
            iwdr=jud(lrj)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_bl_dd_ext(lri,lrj,1)
          endif
        enddo
      enddo

      return
      end

      subroutine d1d_drl_act_c_dd_ext_sgt0()
!d1d(22-2)   drl(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      if(jml.ne.jmr) return
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle
!d1d(22-2)   drl(12)-
        do mpl=1,mtype
          vplp_w0(mpl)=0.d0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w1_d1d(2)
        enddo
        iwdl=jud(lri)
        iwdr=iwdl
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call drl_dd_ext(lri)
      enddo

      return
      end

      subroutine d1v_ar_act_bl_dd_ext_sgt0(lra)
!d1v(24-1)  ar(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1)w0dv1=-w0dv1
!d1v(24-1)  ar(13)-
        iwdl=jud(lri)
        iwdr=0
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0dv1
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0dv1
        enddo
        call ar_bl_dd_ext(lri,lra,1)
      enddo

      return
      end

      subroutine sd_adb_act_c_ext_ar(lin)
!sd(6-3) a&r(13)c'(22)-
!sd(6-10) d&r&l(12)b^l(23)
!sd(6-15) d&r&l(33)b^l(13)c'(22)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
         if(lmi.eq.jmr) then
            iwdl=just(lrj,lri)
            iwdr=jud(lri)
            w0sd10=w0_sd(10)
            w1sd10=w1_sd(10)
            ni=mod(norb_dz-lrj,2)
            if(ni.eq.1) then
              w0sd10=-w0sd10
              w1sd10=-w1sd10
            endif
!sd(6-10) d&r&l(12)b^l(23)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd10
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd10
            enddo
            call drl_bl_ext_ar_new(lin,lri,lrj)
          endif
!sd(6-3) a&r(13)c'(22)-
          w0sd3=w0_sd(3)
          w1sd3=w1_sd(3)
          w0sd15=w0_sd(15)
          w1sd15=w1_sd(15)
          ni=mod(norb_dz-lri,2)
          if(ni.eq.0) then
            w0sd3=-w0sd3
            w1sd3=-w1sd3
            w0sd15=-w0sd15
            w1sd15=-w1sd15
          endif
          if(lmj.eq.jmr) then
            iwdl=just(lrj,lri)
            iwdr=jud(lrj)
           do mpl=1,mtype
             vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd3
             vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd3
           enddo
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
      if(lin.eq.13) then
        call ar_td_ext_ar(57,lri,lrj,isma)
        call ar_td_ext_rest(lri)
      endif
      if(lin.eq.6) then
        call ar_sd_ext_ar(57,lri,lrj,isma)
        call ar_sd_ext_rest(lri)
      endif
      if(lin.eq.23) then
        call ar_dv_ext_ar(57,isma,lri,lrj) !ar_dv
      endif
!sd(6-15) d&r&l(33)b^l(13)c'(22)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd15
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(lin,lrk,lri)
            enddo
          endif
!sd(6-6) a&r(13)b&r(23)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd=lsm_inn(lrd)
           if(lmd.ne.jmr) cycle

            w0sd6=w0_sd(6)
            w1sd6=w1_sd(6)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0sd6=-w0sd6
              w1sd6=-w1sd6
            endif
            iwdl=just(lrj,lri)
            iwdr=jud(lrd)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd6
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd6
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos=intind_ijka(ijk)
            call ar_br_br_ext_ar_new(lin,intpos,isma)
          enddo
!sd(6-7) a&r(13)b&l(32)b^l(23)
          do lrd=lri+1,lrj-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdl=just(lrj,lri)
            iwdr=jud(lrd)
            w0sd7=w0_sd(7)
            w1sd7=w1_sd(7)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0sd7=-w0sd7
              w1sd7=-w1sd7
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd7
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd7
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            ijk=lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
            call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
          enddo
        enddo
      enddo

      return
      end

      subroutine sd_ar_act_brbr_sgt0(lin,jk)
!sd(6-3) a&r(13)c'(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
        w0sd3 =w0_sd(3)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd3 =-w0sd3
        endif
!-------------------------------------------------------------------
!sd(6-3) a&r(13)c'(22)-
        if(jb_sys.gt.0) then
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd3
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd3
          enddo
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
            if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)
            iwdr=jud(lrk)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_br_br_ext_ar_new(lin,intpos,isma )
          enddo
        endif
      enddo

      return
      end

      subroutine sd_ar_act_blbl_sgt0(lin,jk)
!sd(6-3) a&r(13)c'(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      jmlr=mul_tab(jml,jmr)
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        ijk=lri-norb_frz+jk
        intpos=intind_ijka(ijk)
        w0sd3 =w0_sd(3)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.0) then
          w0sd3 =-w0sd3
        endif
!sd(6-3) a&r(13)c'(22)-
         do mpl=1,mtype
           vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd3
           vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd3
         enddo
         do lrk=lri+1,norb_dz
           lmk=lsm_inn(lrk)
           if(lmk.ne.jmr) cycle
           iwdl=just(lrk,lri)
           iwdr=jud(lrk)
           do mpl=1,mhlp
             iwal=lpnew_lwei(mpl)
             iwar=lpnew_rwei(mpl)
             lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
             lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
           enddo
           call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
         enddo
      enddo

      return
      end

      subroutine sv_arbr_act_br_sgt0(lin,lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      isma=mul_tab(iml,imr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          w0sv1=w0_sv(1)
          w1sv1=w1_sv(1)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0sv1=-w0sv1
            w1sv1=-w1sv1
          endif
!-------------------------------------------------------------------
         if(lri.ne.lrj) then
!sv(10-1) ar(13)-br(23)-
            if(jb_sys.gt.0) then
              iwdl=just(lrj,lri)
              iwdr=0
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
                vplp_w0(mpl)=vplpnew_w0(mpl)*w0sv1
                vplp_w1(mpl)=vplpnew_w1(mpl)*w1sv1
              enddo
              ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
             intpos=intind_ijka(ijk)
              call ar_br_br_ext_ar_new(lin,intpos,isma)
            endif
          endif
        enddo
      enddo

      return
      end


      subroutine d1v_ar_act_c_ext(lin)
!d1v(24-1)  ar(13)-
!d1v(24-2)  drl(33)-bl(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      isma=mul_tab(iml,imr)
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)

!d1v(24-1)  ar(13)-
        w0=w0_d1v(1)
        if(ni.eq.1)w0=-w0_d1v(1)
          iwdl=jud(lrd)
          iwdr=0
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        if(lin.eq.6) then
          call ar_sd_ext_ar(51,lrd,0,isma)
          call ar_sd_ext_rest(lrd)
        endif
        if(lin.eq.13) then
          call ar_td_ext_ar(51,lrd,0,isma)
          call ar_td_ext_rest(lrd)
        endif
!d1v(24-2)  drl(33)-bl(13)-
        w0=w0_d1v(2)
        if(ni.eq.1)w0=-w0_d1v(2)
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=0.d0
        enddo
        do lrk=1,lrd-1
          call drl_bl_ext_ar_new(lin,lrk,lrd)
        enddo
      enddo

      return
      end

      subroutine d1v_ar_act_brbr_ext(lin,jk)
!d1v(24-1)  ar(13)-
!d1v(24-2)  drl(33)-bl(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      isma=mul_tab(iml,imr)
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)
        w0=w0_d1v(1)
        if(ni.eq.1)w0=-w0_d1v(1)
!..............................................................
!d1v(24-1) ar(13)-
        iwdl=jud(lrd)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        ijk=lrd-norb_frz+jk
        intpos=intind_ijka(ijk)
        call ar_br_br_ext_ar_new(lin,intpos,isma)
      enddo

      return
      end

      subroutine d1v_ar_act_blbl_ext(lin,jk)
!d1v(24-1)  ar(13)-
!d1v(24-2)  drl(33)-bl(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      isma=mul_tab(iml,imr)
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)
        w0=w0_d1v(1)
        if(ni.eq.1)w0=-w0_d1v(1)
!dv(23-1) ar(23)-
        iwdl=jud(lrd)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        ijk=lrd-norb_frz+jk
        intpos=intind_ijka(ijk)
        call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
      enddo

      return
      end

      subroutine ts_arbl_act_c_ext_ab_sgt0(lin)
!ts(3-3) ar(23)-bl(31)-c"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w1ts3=w1_ts(3)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w1ts3=-w1ts3
          endif
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!ts(3-3) ar(23)-bl(31)-c"(22)-
              iwdl=just(lri,lrk)
              iwdr=just(lrk,lrj)
              do mpl=1,mhlp
                iwal=lpnew_lwei(mpl)
                iwar=lpnew_rwei(mpl)
                lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
                lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
              enddo
              do mpl=1,mtype
                vplp_w0(mpl)=0.d0
                vplp_w1(mpl)=vplpnew_w1(mpl)*w1ts3
              enddo
              call arbl_act_c_link_ext_ab(lin,lri,lrj)
            endif
          enddo
        enddo
      enddo

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

subroutine RHSOD_H(IVEC)

use Symmetry_Info, only: Mul
use SUPERINDEX, only: MAGEB, MAGTB, MAREL, MIGEJ, MIGTJ, MIREL
use CHOVEC_IO, only: ChoVec_Read, ChoVec_Size, NVTOT_CHOSYM
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB
#else
use fake_GA, only: GA_Arrays
#endif
use caspt2_global, only: iPrGlb
use caspt2_module, only: NAGEB, NAGEBES, NAGTB, NAGTBES, NIGEJ, NIGEJES, NIGTJ, NIGTJES, NSSH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Three, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: IA, IAABS, IAEND, IAGEB, IAGEBTOT, IAGTB, IAGTBTOT, IAJ, IAL, IASTA, IC, ICABS, iCASE, ICJ, ICL, IDX, IIEND, &
                     IISTA, IJ, IJABS, IJGEL, IJGELTOT, IJGTL, IJGTLTOT, IL, ILABS, IOFFAJ, IOFFAL, IOFFCJ, IOFFCL, IOSYM(8,8), &
                     ISYA, ISYC, ISYJ, ISYL, ISYM, lg_W, MW, NAS, NCHOBUF, NIS, NV, NW
real(kind=wp) :: AJCL, ALCJ, HMACJL, HPACJL, SCL
real(kind=wp), allocatable :: CHOBUF(:)
real(kind=wp), parameter :: SQRT3 = sqrt(Three), SQRTH = sqrt(Half)
real(kind=wp), external :: DDot_
!logical Incore

if (iPrGlb >= DEBUG) write(u6,*) 'RHS on demand: case H'

!***********************************************************************
! Case H:
!   WP(jl,ac)=((ajcl)+(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
!   WM(jl,ac)=((ajcl)-(alcj))*SQRT(Three)
!***********************************************************************

!***********************************************************************
!SVC: read in all the cholesky vectors (need all symmetries)
!***********************************************************************
call CHOVEC_SIZE(4,NCHOBUF,IOSYM)

call mma_allocate(CHOBUF,NCHOBUF,LABEL='CHOBUF')

call CHOVEC_READ(4,CHOBUF,NCHOBUF)

iCASE = 12
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NAGEB(ISYM)
  NIS = NIGEJ(ISYM)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  do IJGEL=IISTA,IIEND
    IJGELTOT = IJGEL+NIGEJES(ISYM)
    IJABS = MIGEJ(1,IJGELTOT)
    ILABS = MIGEJ(2,IJGELTOT)
    IJ = MIREL(1,IJABS)
    ISYJ = MIREL(2,IJABS)
    IL = MIREL(1,ILABS)
    ISYL = MIREL(2,ILABS)
    do IAGEB=IASTA,IAEND ! these are always all elements
      IAGEBTOT = IAGEB+NAGEBES(ISYM)
      IAABS = MAGEB(1,IAGEBTOT)
      ICABS = MAGEB(2,IAGEBTOT)
      IA = MAREL(1,IAABS)
      ISYA = MAREL(2,IAABS)
      IC = MAREL(1,ICABS)
      ISYC = MAREL(2,ICABS)
      ! compute integrals (ajcl) and (alcj)
      NV = NVTOT_CHOSYM(Mul(ISYA,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
      IAJ = IA-1+NSSH(ISYA)*(IJ-1)
      ICL = IC-1+NSSH(ISYC)*(IL-1)
      IOFFAJ = 1+IOSYM(ISYA,ISYJ)+NV*IAJ
      IOFFCL = 1+IOSYM(ISYC,ISYL)+NV*ICL
      AJCL = DDOT_(NV,CHOBUF(IOFFAJ),1,CHOBUF(IOFFCL),1)

      NV = NVTOT_CHOSYM(Mul(ISYA,ISYL))
      IAL = IA-1+NSSH(ISYA)*(IL-1)
      ICJ = IC-1+NSSH(ISYC)*(IJ-1)
      IOFFAL = 1+IOSYM(ISYA,ISYL)+NV*IAL
      IOFFCJ = 1+IOSYM(ISYC,ISYJ)+NV*ICJ
      ALCJ = DDOT_(NV,CHOBUF(IOFFAL),1,CHOBUF(IOFFCJ),1)

      ! HP(ac,jl)=((ajcl)+(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
      SCL = One
      if (IAABS == ICABS) SCL = SCL*SQRTH
      if (ILABS == IJABS) SCL = SCL*SQRTH
      HPACJL = SCL*(AJCL+ALCJ)
      ! write element HP(ac,jl)
      IDX = IAGEB+NAS*(IJGEL-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = HPACJL
#     else
      GA_Arrays(lg_w)%A(IDX) = HPACJL
#     endif
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

iCASE = 13
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NAGTB(ISYM)
  NIS = NIGTJ(ISYM)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  do IJGTL=IISTA,IIEND
    IJGTLTOT = IJGTL+NIGTJES(ISYM)
    IJABS = MIGTJ(1,IJGTLTOT)
    ILABS = MIGTJ(2,IJGTLTOT)
    IJ = MIREL(1,IJABS)
    ISYJ = MIREL(2,IJABS)
    IL = MIREL(1,ILABS)
    ISYL = MIREL(2,ILABS)
    do IAGTB=IASTA,IAEND ! these are always all elements
      IAGTBTOT = IAGTB+NAGTBES(ISYM)
      IAABS = MAGTB(1,IAGTBTOT)
      ICABS = MAGTB(2,IAGTBTOT)
      IA = MAREL(1,IAABS)
      ISYA = MAREL(2,IAABS)
      IC = MAREL(1,ICABS)
      ISYC = MAREL(2,ICABS)
      ! compute integrals (ajcl) and (alcj)
      NV = NVTOT_CHOSYM(Mul(ISYA,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
      IAJ = IA-1+NSSH(ISYA)*(IJ-1)
      ICL = IC-1+NSSH(ISYC)*(IL-1)
      IOFFAJ = 1+IOSYM(ISYA,ISYJ)+NV*IAJ
      IOFFCL = 1+IOSYM(ISYC,ISYL)+NV*ICL
      AJCL = DDOT_(NV,CHOBUF(IOFFAJ),1,CHOBUF(IOFFCL),1)

      NV = NVTOT_CHOSYM(Mul(ISYA,ISYL))
      IAL = IA-1+NSSH(ISYA)*(IL-1)
      ICJ = IC-1+NSSH(ISYC)*(IJ-1)
      IOFFAL = 1+IOSYM(ISYA,ISYL)+NV*IAL
      IOFFCJ = 1+IOSYM(ISYC,ISYJ)+NV*ICJ
      ALCJ = DDOT_(NV,CHOBUF(IOFFAL),1,CHOBUF(IOFFCJ),1)

      ! HP(ac,jl)=((ajcl)-(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
      SCL = SQRT3
      HMACJL = SCL*(AJCL-ALCJ)
      ! write element HP(ac,jl)
      IDX = IAGTB+NAS*(IJGTL-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = HMACJL
#     else
      GA_Arrays(lg_W)%A(IDX) = HMACJL
#     endif
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

call mma_deallocate(CHOBUF)

end subroutine RHSOD_H

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Per Ake Malmqvist                                *
!               1996, Roland Lindh                                     *
!***********************************************************************

subroutine AMPMem( &
#                 define _CALLING_
#                 include "mem_interface.fh"
                 )

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: Mem1, Mem2, Mem3, nOrder

#include "macros.fh"
unused_var(lr)

! Mem1: Workspace for MltPrm.
! Mem2: Tables Tpp,Tp,T0,Tm, and Tmm.
! Mem3: Result from AMPr.
Mem1 = 0
call MltMmP(nOrder,Mem,la,lb+2,2)
Mem1 = max(Mem1,Mem)
Mem2 = 6*nTri_Elem1(la)*nTri_Elem1(lb+2)
nHer = nOrder
call MltMmP(nOrder,Mem,la,lb+1,1)
Mem1 = max(Mem1,Mem)
Mem2 = Mem2+3*nTri_Elem1(la)*nTri_Elem1(lb+1)
call MltMmP(nOrder,Mem,la,lb,2)
Mem1 = max(Mem1,Mem)
Mem2 = Mem2+6*nTri_Elem1(la)*nTri_Elem1(lb)
if (lb >= 1) then
  call MltMmP(nOrder,Mem,la,lb-1,1)
  Mem1 = max(Mem1,Mem)
  Mem2 = Mem2+3*nTri_Elem1(la)*nTri_Elem1(lb-1)
  if (lb >= 2) then
    call MltMmP(nOrder,Mem,la,lb-2,2)
    Mem1 = max(Mem1,Mem)
    Mem2 = Mem2+6*nTri_Elem1(la)*nTri_Elem1(lb-2)
  end if
end if
Mem3 = 6*nTri_Elem1(la)*nTri_Elem1(lb)

Mem = Mem1+Mem2+Mem3+1

return

end subroutine AMPMem

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Jeppe Olsen                                      *
!***********************************************************************

subroutine H0CSF(H0,IPQCSF,IPQCNF,MXP1DM,MXP2DM,MXQDM,DTOC,IPRODT,ICONF,IREFSM,NACTOB,SCR,NCONF,NEL,NAEL,NBEL,IPWAY,NP1CSF,NP1CNF, &
                 NP2CSF,NP2CNF,NQCSF,NQCNF,NPQCSF,NPQCNF,DIAG,DIAGCN,INTSPC,ICOMBI,PSSIGN)
! Obtain H0 subspace defined by the three parameters
! MXP1DM,MXP2DM,MXQDM and obtain
! explicit representation of hamilton matrix in subspace
!
! The H0 space consist of three subspaces
! P1,P2 AND Q
! The H0 matrix can be pictured as
!
!              P1    P2        Q
!             ***************************
!             *    *     *              *
!         P1  * Ex *  Ex *   Ex         *    Ex : exact H matrix
!             ***************************         is used in this block
!         P2  *    *     *              *
!             * Ex *  Ex *     Diag     *    Diag : Diagonal
!             ************              *           appriximation used
!             *    *      *             *
!             *    *        *           *
!             * Ex *  Diag    *         *
!         Q   *    *            *       *
!             *    *              *     *
!             *    *                *   *
!             *    *                  * *
!             ***************************
!
! The exact Hamiltonian is therefore calculated in subspace P1 and P2
! but only the interaction between a larger space Q and subspace P1
! is calculated exactly
!
! Lucia Version, September 1993, Jeppe Olsen
!
! ===========
! ARGUMENTS :
! ===========
!   H0 : combined block to contain :
!      PHP : hamilton matrix in subspace P1+P2 output)
!      PHQ : Hamiltonian matrix block with row in P1 and column in Q
!      QHQ : Diagonal approximation to matrix in Q-Q space
!   IPQCSF : CSFs defining subspace (output)
!   IPQCNF : Configurations defining subspace (output)
!   MXP1DM : Largest allowed dimension of subspace P1 (Input)
!   MXP2DM : Largest allowed dimension of subspace P2 (Input)
!   MXQDM  : Largest allowed dimension of subspace Q  (Input)
!   DTOC : Transformation matrix between CSFs and DETs (input)
!   IPRODT : Prototype determinants (input)
!   ICONF : List of configurations  (input)
!   IREFSM : symmetry of considered CI space (input)
!   NACTOB : Number of active orbitals (input)
!   SCR    : Scratch array of length ????
!   NCONF : Number of configurations of symmetry IREFSM
!   IPWAY : Defines way of choosing Primary space
!    = 1  : use the first configurations (until at most
!           MXPDIM CSFs have been included)
!   NP1CNF : Number of primary configurations obtained in P1 (output)
!   NP1CSF : Number of primary CSFs obtained in P1 (OUTPUT)
!   NP2CNF : Number of primary configurations obtained in P2 (output)
!   NP2CSF : Number of primary CSFs obtained in P2 (OUTPUT)
!   NQCNF  : Number of primary configurations obtained in Q (output)
!   NQCSF  : Number of primary CSFs obtained in Q (OUTPUT)
!
!   DIAG   : Hamilton diagonal over CSFs (INPUT)
!   DIAGCN : space for diagonal over configurations
!   INTSPC : Internal space number of actual expansion
!   ICOMBI : = 0 => no spin combinations
!            = 1 =>    spin combinations
!   PSSIGN : Spin combination sign
!
! =========================================
! Jeppe Olsen, Spring of 90, from PHPCSF
! =========================================
!  Lucia Version, September 1993
! =========================================

use Index_Functions, only: nTri_Elem
use MCLR_Data, only: NCNATS, NCPCNT, NTYP
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: H0(*), SCR(*), DIAGCN(*)
integer(kind=iwp), intent(_OUT_) :: IPQCSF(*), IPQCNF(*)
integer(kind=iwp), intent(in) :: MXP1DM, MXP2DM, MXQDM, IPRODT(*), ICONF(*), IREFSM, NACTOB, NCONF, NEL, NAEL, NBEL, IPWAY, &
                                 INTSPC, ICOMBI
real(kind=wp), intent(in) :: DTOC(*), DIAG(*), PSSIGN
integer(kind=iwp), intent(out) :: NP1CSF, NP1CNF, NP2CSF, NP2CNF, NQCSF, NQCNF, NPQCSF, NPQCNF
integer(kind=iwp) :: i, ICNF, ICSFMN, ICSFOF, IDEG, IDGCNF, IDGCSF, IDGVL, IFINIT, IICNF, IICSF, IMIN, ITYP, KLCONF, KLPHP, KLPHQ, &
                     MXPQDM, NCSFMN, NDGVL, NIRREP, NJCNF, NPCNF, NPCSF
real(kind=wp) :: DIAVAL, XMAX, XMIN
integer(kind=iwp), allocatable :: ISCR(:)
real(kind=wp), external :: FNDMNX

! 1 : Obtain primary subspace

NP1CSF = 0
NP1CNF = 0
NP2CSF = 0
NP2CNF = 0
NPCSF = 0
NQCSF = 0
NQCNF = 0
NPQCSF = 0
NPQCNF = 0
ICSFMN = 0 ! dummy initialize
NCSFMN = 0 ! dummy initialize
MXPQDM = MXP1DM+MXP2DM+MXQDM

! ======================================================================
! 1 :                 Generate initial subspace
! ======================================================================

if (IPWAY == 1) then

  ! Just use the first CSFs as subspace

  ICNF = 0
  outer: do ITYP=1,NTYP
    NJCNF = NCNATS(ITYP,IREFSM)
    NIRREP = NCPCNT(ITYP)
    do IICNF=1,NJCNF
      ICNF = ICNF+1
      if (NP1CSF+NIRREP <= MXP1DM) then
        NPQCNF = NPQCNF+1
        NP1CNF = NP1CNF+1
        IPQCNF(NPQCNF) = ICNF
        IPQCSF(NPQCSF+1:NPQCSF+NIRREP) = [(IICSF,IICSF=NPQCSF+1,NPQCSF+NIRREP)]
        NPQCSF = NPQCSF+NIRREP
        NP1CSF = NP1CSF+NIRREP
      else if (NP2CSF+NIRREP <= MXP2DM) then
        NPQCNF = NPQCNF+1
        NP2CNF = NP2CNF+1
        IPQCNF(NPQCNF) = ICNF
        IPQCSF(NPQCSF+1:NPQCSF+NIRREP) = [(IICSF,IICSF=NPQCSF+1,NPQCSF+NIRREP)]
        NPQCSF = NPQCSF+NIRREP
        NP2CSF = NP2CSF+NIRREP
      else if (NQCSF+NIRREP <= MXQDM) then
        NPQCNF = NPQCNF+1
        NQCNF = NQCNF+1
        IPQCNF(NPQCNF) = ICNF
        IPQCSF(NPQCSF+1:NPQCSF+NIRREP) = [(IICSF,IICSF=NPQCSF+1,NPQCSF+NIRREP)]
        NPQCSF = NPQCSF+NIRREP
        NQCSF = NQCSF+NIRREP
      else
        exit outer
      end if
    end do
  end do outer

else if (IPWAY == 2) then
  ! Obtain lowest CSFs

  ! 1 :  local Diagonal elements over configurations

  IICSF = 1
  IICNF = 1

  call mma_allocate(ISCR,MXPQDM+NEL,Label='ISCR')
  KLCONF = MXPQDM+1

  do ITYP=1,NTYP
    NJCNF = NCNATS(ITYP,IREFSM)
    NIRREP = NCPCNT(ITYP)
    do ICNF=1,NJCNF
      DIAGCN(IICNF) = DIAG(IICSF)
      IICNF = IICNF+1
      IICSF = IICSF+NIRREP
    end do
  end do
  ! Largest element
  XMAX = FNDMNX(DIAGCN,NCONF,2)
  ! loop over lowest configurations

  IFINIT = 0

  do
    XMIN = XMAX+One
    IMIN = 0

    IICNF = 1
    ICSFOF = 1
    do ITYP=1,NTYP
      NIRREP = NCPCNT(ITYP)
      do ICNF=1,NCNATS(ITYP,IREFSM)
        if (DIAGCN(IICNF) < XMIN) then
          XMIN = DIAGCN(IICNF)
          IMIN = IICNF
          ICSFMN = ICSFOF
          NCSFMN = NIRREP
        end if

        IICNF = IICNF+1
        ICSFOF = ICSFOF+NIRREP
      end do
    end do

    ! Next lowest element has been found

    if (NPQCSF+NCSFMN <= MXPQDM) then
      ! 1  add new configuration
      NPQCNF = NPQCNF+1
      IPQCNF(NPQCNF) = IMIN
      SCR(NPQCNF) = XMIN
      IPQCSF(NPQCSF+1:NPQCSF+NCSFMN) = [(i,i=ICSFMN,ICSFMN+NCSFMN-1)]
      NPQCSF = NPQCSF+NCSFMN

      ! Mask
      DIAGCN(IMIN) = XMAX+One
    else
      IFINIT = 1
      ! 2  No space for this configuration, remove previous
      !    configurations with the same diagonal value
      IICNF = NPQCNF+1
      do
        IICNF = IICNF-1
        DIAVAL = DIAGCN(IPQCNF(IICNF))
        if (abs(DIAVAL-XMIN) > 1.0e-10_wp) exit
        NPQCNF = NPQCNF-1
        call GETCNF_MCLR(ISCR(KLCONF),ITYP,IPQCNF(IICNF),ICONF,IREFSM,NEL)
        NPQCSF = NPQCSF-NCPCNT(ITYP)
      end do
    end if
    if ((IFINIT /= 0) .or. (NPQCNF >= NCONF)) exit
  end do
  ! NPQCSF has now been collected, obtain P1,P2 and Q space
  ! so that degenerate configurations are not  in
  ! different  subspaces

  ! Arrange selected configurations in degenerate pairs

  call DEGVEC(SCR,NPQCNF,NDGVL,ISCR)
  ! Number of configurations in P1,P2,Q
  ICNF = 0
  do IDEG=1,NDGVL
    ! Number of CSFs in this group of degenerate values
    IDGVL = ISCR(IDEG)
    IDGCSF = 0
    do IDGCNF=1,IDGVL
      ICNF = ICNF+1
      call GETCNF_MCLR(ISCR(KLCONF),ITYP,IPQCNF(ICNF),ICONF,IREFSM,NEL)
      IDGCSF = IDGCSF+NCPCNT(ITYP)
    end do
    if ((NP1CSF+IDGCSF <= MXP1DM) .and. (NP2CSF+NQCSF == 0)) then
      ! Add to P1
      NP1CSF = NP1CSF+IDGCSF
      NP1CNF = NP1CNF+IDGVL
    else if ((NP2CSF+IDGCSF <= MXP2DM) .and. (NQCSF == 0)) then
      ! Add to P2
      NP2CSF = NP2CSF+IDGCSF
      NP2CNF = NP2CNF+IDGVL
    else if (NQCSF+IDGCSF <= MXQDM) then
      ! Add to Q
      NQCSF = NQCSF+IDGCSF
      NQCNF = NQCNF+IDGVL
    else
      ! No space for configuration so
      exit
    end if
  end do

  NPCSF = NP1CSF+NP2CSF
  NPCNF = NP1CNF+NP2CNF

  NPQCSF = NPCSF+NQCSF
  NPQCNF = NPCNF+NQCNF

  call mma_deallocate(ISCR)

end if
! End if for IPWAY = 2

! This is not beautiful, but necessary
!MXP1DM = NP1CSF
!MXP2DM = NP2CSF
!MXQDM = NQCSF

! ============================================================
! 2          Construct Hamiltonian matrix in subspace
! ============================================================

! Do not add core energy to subspace Hamiltonian, add to eigenvalues
! Pointers in H0
KLPHP = 1
KLPHQ = KLPHP+nTri_Elem(NPCSF)

! PHP matrix

call CNHCNM(H0(KLPHP),1,IPQCNF,NPCNF,IPQCNF,NPCNF,NPCSF,DIAGCN,ICONF,NEL,IREFSM,NAEL,NBEL,NACTOB,IPRODT,DTOC,INTSPC,ICOMBI,PSSIGN)

! PHQ matrix

call CNHCNM(H0(KLPHQ),0,IPQCNF,NP1CNF,IPQCNF(1+NPCNF),NQCNF,NP1CSF,DIAGCN,ICONF,NEL,IREFSM,NAEL,NBEL,NACTOB,IPRODT,DTOC,INTSPC, &
            ICOMBI,PSSIGN)

end subroutine H0CSF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Per-Olof Widmark                                 *
!               2012,2013, Victor P. Vysotskiy                         *
!***********************************************************************
!***********************************************************************
!                                                                      *
!                             A I X - I / O                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! rc=AixRd(Handle,Buf,nBuf,iDisk,iErrSkip)                             *
!                                                                      *
! A buffer is read from a file associated with the file handle. The    *
! operation is asynchronous, and must be followed by a call to AixWt   *
! to ensure that data is in memory.                                    *
!                                                                      *
! Input:  Handle   - This is the unique file identifier associated     *
!                    with the file. It is created by AixOpn, and must  *
!                    be used on subsequent references to the file.     *
!         Buf      - The buffer that is to be written to disk.         *
!         nBuf     - Length of the buffer in words.                    *
!         iDisk    - External disk address.                            *
!         iErrSkip - if 0 : stop in the error case                     *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          S&TC, ACIS, IBM Sweden                                      *
! Written: November 1990                                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! History:                                                             *
!          V.P. Vysotskiy,University of Lund, Sweden, 2012-2013        *
!                                                                      *
!***********************************************************************

function AixRd(handle,Buf,nBuf,iDisk,iErrSkip)

#include "intent.fh"

use Fast_IO, only: CtlBlk, eEof, eInErr, eNtOpn, FCtlBlk, MxFile, pDesc, pHndle, ProfData, pWhere
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: AixRd
integer(kind=iwp), intent(in) :: handle, nBuf, iErrSkip
integer(kind=iwp), intent(_OUT_) :: Buf(*)
integer(kind=iwp), intent(inout) :: iDisk
integer(kind=iwp) :: desc, Lu, n, nFile, pDisk, rc
real(kind=wp) :: CPUA, CPUE, TIOA, TIOE
character(len=80) :: ErrTxt
character(len=64) :: Temp
character(len=*), parameter :: TheName = 'AixRd'
integer(kind=iwp), external :: AixErr
#include "warnings.h"
interface
  function c_lseek(FileDescriptor,Offset) bind(C,name='c_lseek_')
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: c_lseek
    integer(kind=MOLCAS_C_INT) :: FileDescriptor, Offset
  end function c_lseek
end interface

!----------------------------------------------------------------------*
! Entry to AixRd                                                       *
!----------------------------------------------------------------------*
AixRd = 0
Temp = 'Premature abort while reading buffer from disk'
!----------------------------------------------------------------------*
! Check if file is opened.                                             *
!----------------------------------------------------------------------*
n = 1
do
  if (CtlBlk(pHndle,n) == handle) exit
  n = n+1
  if (n > MxFile) then
    AixRd = eNtOpn
    return
  end if
end do
nFile = n
desc = CtlBlk(pDesc,nFile)
call FSCB2UNIT(handle,Lu)
call Timing(CPUA,CPUE,TIOA,TIOE)
!----------------------------------------------------------------------*
! Position file pointer                                                *
!----------------------------------------------------------------------*
pDisk = iDisk
if (CtlBlk(pWhere,nFile) /= pDisk) then
  rc = c_lseek(desc,pDisk)
  ProfData(8,Lu) = ProfData(8,Lu)+1
  if (rc < 0) then
    if (iErrSkip == 1) then
      AixRd = 99
      return
    end if
    call FASTIO('STATUS')
    AixRd = AixErr(ErrTxt)
    call SysWarnFileMsg(TheName,FCtlBlk(nFile),'MSG: seek',ErrTxt)
    call SysCondMsg('rc < 0',rc,'<',0)
  else if (rc /= pDisk) then
    if (iErrSkip == 1) then
      AixRd = 99
      return
    end if
    call FASTIO('STATUS')
    AixRd = eInErr
    call SysWarnFileMsg(TheName,FCtlBlk(nFile),'MSG: seek',' ')
    call SysCondMsg('rc != pDisk',rc,'!=',pDisk)
  end if
end if
CtlBlk(pWhere,nFile) = pDisk
!----------------------------------------------------------------------*
! Read from file                                                       *
!----------------------------------------------------------------------*
rc = c_read_wrapper(desc,Buf,nBuf)
if (rc < 0) then
  if (iErrSkip == 1) then
    AixRd = 99
    return
  end if
  call FASTIO('STATUS')
  AixRd = AixErr(ErrTxt)

  call SysQuitFileMsg(_RC_IO_ERROR_READ_,TheName,FCtlBlk(nFile),Temp,ErrTxt)

else if (rc /= nBuf) then
  if (iErrSkip == 1) then
    AixRd = 99
    return
  end if
  call FASTIO('STATUS')
  AixRd = eEof
  call SysQuitFileMsg(_RC_IO_ERROR_READ_,TheName,FCtlBlk(nFile),Temp,'\nEnd of file reached ')
end if
CtlBlk(pWhere,nFile) = CtlBlk(pWhere,nFile)+nBuf
iDisk = iDisk+nBuf
call Timing(CPUA,CPUE,TIOA,TIOE)
ProfData(4,Lu) = ProfData(4,Lu)+1
ProfData(5,Lu) = ProfData(5,Lu)+nBuf
ProfData(6,Lu) = ProfData(6,Lu)+TIOE
!----------------------------------------------------------------------*
! Finished so return to caller                                         *
!----------------------------------------------------------------------*
return

contains

function c_read_wrapper(FileDescriptor,Buffer,nBytes)

  use, intrinsic :: iso_c_binding, only: c_loc

  integer(kind=iwp) :: c_read_wrapper
  integer(kind=iwp), intent(in) :: FileDescriptor, nBytes
  integer(kind=iwp), intent(_OUT_), target :: Buffer(*)
  interface
    function c_read(FileDescriptor,Buffer,nBytes) bind(C,name='c_read_')
      use, intrinsic :: iso_c_binding, only: c_ptr
      use Definitions, only: MOLCAS_C_INT
      integer(kind=MOLCAS_C_INT) :: c_read
      integer(kind=MOLCAS_C_INT) :: FileDescriptor, nBytes
      type(c_ptr), value :: Buffer
    end function c_read
  end interface

  c_read_wrapper = c_read(FileDescriptor,c_loc(Buffer(1)),nBytes)

end function c_read_wrapper

end function AixRd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989,2003, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE CNHCN(ICNL,ITPL,ICNR,ITPR,CNHCNM,SCR,
     *                 NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,
     *                 NORB,TUVX,IPREXH,ExFac,IREOTS)
*
* Obtain Hamilton matrix over CSF's of configurations ICNL,ICNR
*
* Jeppe Olsen , Summer of '89
*               IREOTS added August 2003
*
      IMPLICIT REAL*8(A-H,O-Z)
C
#include "spinfo.fh"
#include "ciinfo.fh"
C
      DIMENSION ICNL(*),ICNR(*),SCR(*)
      DIMENSION IPRODT(*),DTOC(*),ONEBOD(*)
      DIMENSION CNHCNM(*)
      DIMENSION TUVX(*)
      INTEGER IREOTS(*)
C
      CALL CNHCN_INTERNAL(SCR)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE CNHCN_INTERNAL(SCR)
      USE ISO_C_BINDING
      REAL*8, TARGET :: SCR(*)
      INTEGER, POINTER :: iSCRla(:),iSCRlb(:),iSCRra(:),iSCRrb(:),
     &                    iSCRf(:)
      NTEST = 0
*
** 1 : Obtain determints corresponding to configurations
*
      NDETL = NDTFTP(ITPL)
      NDETR = NDTFTP(ITPR)
*
      NCSFL = NCSFTP(ITPL)
      NCSFR = NCSFTP(ITPR)
*
      KLFREE = 1
*
      KLDTLA = KLFREE
      KLFREE = KLFREE + NDETL*NAEL
*
      KLDTLB = KLFREE
      KLFREE = KLFREE + NDETL*NBEL
*
      KLISL  = KLFREE
      KLFREE = KLFREE + NDETL
*
      KLDTRA = KLFREE
      KLFREE = KLFREE + NDETR*NAEL
*
      KLDTRB = KLFREE
      KLFREE = KLFREE + NDETR*NBEL
*
      KLISR  = KLFREE
      KLFREE = KLFREE + NDETR
*
      CALL C_F_POINTER(C_LOC(SCR(KLDTLA)),iSCRla,[1])
      CALL C_F_POINTER(C_LOC(SCR(KLDTLB)),iSCRlb,[1])
      CALL C_F_POINTER(C_LOC(SCR(KLFREE)),iSCRf,[1])
      CALL CNFSTR(ICNL,ITPL,iSCRla,iSCRlb,
     *            NORB,NAEL,NBEL,NDETL,IPRODT,iSCRf,
     *            SCR(KLISL),IPREXH)
      NULLIFY(iSCRla,iSCRlb,iSCRf)
      CALL C_F_POINTER(C_LOC(SCR(KLDTRA)),iSCRra,[1])
      CALL C_F_POINTER(C_LOC(SCR(KLDTRB)),iSCRrb,[1])
      CALL C_F_POINTER(C_LOC(SCR(KLFREE)),iSCRf,[1])
      CALL CNFSTR(ICNR,ITPR,iSCRra,iSCRrb,
     *            NORB,NAEL,NBEL,NDETR,IPRODT,iSCRf,
     *            SCR(KLISR),IPREXH)
      NULLIFY(iSCRra,iSCRrb,iSCRf)
*
** Hamiltonin matrix over determinants of ths configuration
*
      KLDHD = KLFREE
      KLFREE = KLFREE + NDETL*NDETR
      CALL COMBINATIONS(ICOMBI,PSIGN)
      CALL C_F_POINTER(C_LOC(SCR(KLDTLA)),iSCRla,[1])
      CALL C_F_POINTER(C_LOC(SCR(KLDTLB)),iSCRlb,[1])
      CALL C_F_POINTER(C_LOC(SCR(KLDTRA)),iSCRra,[1])
      CALL C_F_POINTER(C_LOC(SCR(KLDTRB)),iSCRrb,[1])
      CALL C_F_POINTER(C_LOC(SCR(KLFREE)),iSCRf,[1])
      CALL DIHDJ_MOLCAS(iSCRla,iSCRlb,NDETL,
     *           iSCRra,iSCRrb,NDETR,
     *           NAEL,NBEL,iSCRf,NORB,ONEBOD,
     *           SCR(KLDHD),0,0,ECORE,ICOMBI,PSIGN,0,TUVX,ExFac,IREOTS)
      NULLIFY(iSCRla,iSCRlb,iSCRra,iSCRrb,iSCRf)
*
** Transform matrix to CSF basis
*
** : sign changes
      CALL DGMM2_MOLCAS (SCR(KLDHD),SCR(KLDHD),SCR(KLISL),1,NDETL,NDETR)
      CALL DGMM2_MOLCAS (SCR(KLDHD),SCR(KLDHD),SCR(KLISR),2,NDETL,NDETR)
      IPL = 1
      DO 200 JTYP = 1, ITPL - 1
        JCSF = NCSFTP(JTYP)
        JDET = NDTFTP(JTYP)
        IPL = IPL + JCSF*JDET
200   CONTINUE
      IF(ITPR.EQ. ITPL) THEN
        IPR = IPL
      ELSE
        IPR = 1
        DO 300 JTYP = 1, ITPR - 1
          JCSF = NCSFTP(JTYP)
          JDET = NDTFTP(JTYP)
          IPR = IPR + JCSF*JDET
300     CONTINUE
      END IF
*
      KLCHD = KLFREE
      KLFREE = KLFREE + NCSFL*NDETR
      CALL MATML4(SCR(KLCHD),DTOC(IPL),SCR(KLDHD),
     *            NCSFL,NDETR,NDETL,NCSFL,NDETL,NDETR,1)
      CALL MATML4(CNHCNM,SCR(KLCHD),DTOC(IPR),
     *            NCSFL,NCSFR,NCSFL,NDETR,NDETR,NCSFR,0)
*
      IF( NTEST.GE.20 ) THEN
        WRITE(6,*)
     *  ' CSF-Hamiltonian matrix between two configurations'
        CALL WRTMAT(CNHCNM,NCSFL,NCSFR,NCSFL,NCSFR)
      END IF
*
      RETURN
      END SUBROUTINE CNHCN_INTERNAL
*
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1995,1996, Anders Bernhardsson                         *
************************************************************************
      SubRoutine Drvg2(Hess,nhess,l_Grd,l_Hss)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals. The four outermost loops *
*          will controll the type of the two-electron integral, eg.    *
*          (ss|ss), (sd|pp), etc. The next four loops will generate    *
*          list of symmetry distinct centers that do have basis func-  *
*          tions of the requested type.                                *
*                                                                      *
* Input:                                                               *
*              nHess         : Size of gradient and hessian            *
*              l_Grd,l_Hss   : Boolean on/off for gradient/hessian     *
*                              generation                              *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March 1990                                               *
*             Anders Bernhardsson 1995-1996                            *
************************************************************************
      use Real_Spherical
      use k2_setup
      use iSD_data
      use k2_arrays
      use pso_stuff
      use Basis_Info
      use Symmetry_Info, only: nIrrep, iOper
      use Sizes_of_Seward, only:S
      use Real_Info, only: CutInt
      Implicit Real*8 (A-H,O-Z)
      External Rsv_Tsk
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "disp.fh"
#include "disp2.fh"
#include "buffer.fh"
#include "etwas.fh"
#include "cputime.fh"
#include "nsd.fh"
#include "setup.fh"
*     Local arrays
      Real*8, Dimension(:), Allocatable :: DeDe2(:)
      Integer, Allocatable:: ipOffDA(:,:)
      Real*8  Coor(3,4), Hess(*)
      Integer iAngV(4), iCmpV(4), iShelV(4), iShllV(4),
     &        iAOV(4), iAOst(4), JndGrd(3,4,0:7), iFnc(4),
     &        JndHss(4,3,4,3,0:7)
      Logical Shik, Shjl, Shijij, JfGrd(3,4),lpick,
     &        JfHss(4,3,4,3), JfG(4),ltri,ldot, Rsv_Tsk,
     &        l_Hss,l_Grd,lGrad,n8,ldot2,new_fock,
     &        Post_Process
      Integer moip(0:7)
#ifdef _DEBUGPRINT_
      Character*40 format
#endif
      Real*8, Allocatable:: TMax(:,:)
      Integer, Allocatable:: Ind_ij(:,:)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
* - - - - - - P R O L O G
*
      Call StatusLine(' McKinley:',
     &                ' Computing 2-electron 2nd order derivatives')
*
      ipDij   = ip_Dummy
      ipDij2  = ip_Dummy
      ipDDij  = ip_Dummy
      ipDDij2 = ip_Dummy
      ipDkl   = ip_Dummy
      ipDkl2  = ip_Dummy
      ipDDkl  = ip_Dummy
      ipDDkl2 = ip_Dummy
      ipDik   = ip_Dummy
      ipDik2  = ip_Dummy
      ipDDik  = ip_Dummy
      ipDDik2 = ip_Dummy
      ipDil   = ip_Dummy
      ipDil2  = ip_Dummy
      ipDDil  = ip_Dummy
      ipDDil2 = ip_Dummy
      ipDjk   = ip_Dummy
      ipDjk2  = ip_Dummy
      ipDDjk  = ip_Dummy
      ipDDjk2 = ip_Dummy
      ipDjl   = ip_Dummy
      ipDjl2  = ip_Dummy
      ipDDjl  = ip_Dummy
      ipDDjl2 = ip_Dummy
      ipBuffer= ip_Dummy
      ipMOC   = ip_Dummy
      iFnc(1) = -99
      iFnc(2) = -99
      iFnc(3) = -99
      iFnc(4) = -99
      nDij=0
      nDkl=0
      nDik=0
      nDjl=0
      nDil=0
      nDjk=0
      mDCRij=0
      mDCRkl=0
      mDCRik=0
      mDCRjl=0
      mDCRil=0
      mDCRjk=0
      ipDijS =0
      ipDijS2=0
*
      Call CtrlMO(moip,nAco)
*
      iiii=0
      ipdex=0
      ndisp=0
      naco=0
      New_Fock=nirrep.eq.1
      Do iS=0,nIrrep-1
         nDisp=nDisp+ldisp(is)
         naco=naco+nAsh(is)
      End do
      n8=.true.
      Int_Direct=.true.
*
      call dcopy_(nHess,[Zero],0,Hess,1)
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
*                                                                      *
************************************************************************
*                                                                      *
*-----Precompute k2 entities.
*
      lgrad=l_Grd
      lpick=lgrad.and.(.not.New_Fock)
      Pren = Zero
      Prem = Zero
      nIndK2 = S%nShlls*(S%nShlls+1)/2
      Call mma_allocate(IndK2,2,nIndk2)
      Call Drvk2_mck(ndede,new_Fock)
*
      Call StatP(0)
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Allocate auxiliary array for symmetry transformation
*
      nAux = nIrrep**3
      If (nIrrep==1) nAux = 1
      Call mma_allocate(Aux,nAux,Label='Aux')
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate working area
*
      MxPrm = 0
      MxDij = 0
      MxBsC = 0
      Do iAng = 0, S%iAngMx
         MxPrm = Max(MxPrm,S%MaxPrm(iAng))
         Do 2900 iCnttp = 1,nCnttp
            iShll = dbsc(iCnttp)%iVal + iAng
            iPrim = Shells(iShll)%nExp
            If (iPrim.eq.0) Go To 2900
            If (Shells(iShll)%nBasis.eq.0) Go To 2900
            iBas  = Shells(iShll)%nBasis
            iCmp  = (iAng+1)*(iAng+2)/2
            MxBsC=Max(MxBsC,iBas*iCmp)
            MxDij= Max(MxDij,(iBas**2+1)*iCmp**2+iPrim**2+1)
 2900    Continue
      End Do
      MxDij = 6 * nIrrep * MxDij
      nZeta = MxPrm * MxPrm
      nEta  = MxPrm * MxPrm
      iii=nDens*10+10
      MemR=9*nZeta + 9*nEta +nZeta*nEta
      Call mma_allocate(Mem_INT,nZeta+nEta,Label='Mem_INT')
      ipIndZet=1
      ipIndEta=ipIndZet+nZeta
      Call mma_allocate(Mem_DBLE,MemR,Label='Mem_DBLE')
      ipZeta=1
*                                                                      *
************************************************************************
*                                                                      *
      If (lGrad) Then
*
*-----Calculate the size of memory needed for storing fock matrixes and
*     MO integrals and allocate it.
*
      nIndij=S%nShlls*(S%nShlls+1)/2
      nInt=0
      jDisp=0
      Do iIrrep=0,nIrrep-1
         Do iDisp=1,lDisp(iIrrep)
            jDisp=jDisp+1
            ipDisp(jDisp)=nInt+1
            Do jIrr=0,nIrrep-1
               kIrr=nrOpr(iEOr(iOper(iIrrep),iOper(jIrr)))
               If (jIrr.eq.kIrr) Then
                  nInt=nInt+nBas(jIrr)*(nBas(jIrr)+1)/2
               Else If (kIrr.lt.jIrr) Then
                  nInt=nInt+nBas(jIrr)*nBas(kIrr)
               End If
            End Do
*
            If (nMethod.eq.RASSCF) Then
               ipMO(jDisp,1)=nInt+1
               nInt=nInt+nMO(iIrrep)
               ipdisp2(jdisp)=nInt+1
               Do jIrr=0,nIrrep-1
                  kIrr=nrOpr(iEOr(iOper(iIrrep),iOper(jIrr)))
                  If (jIrr.eq.jIrr) Then
                     nInt=nInt+nBas(jIrr)*(nBas(jIrr)+1)/2
                  Else If (kIrr.lt.jIrr) Then
                     nInt=nInt+nBas(jIrr)*nBas(kIrr)
                  End If
               End Do
               ipMO(jDisp,2)=nInt+1-ipMO(jDisp,1)
            End If
*
         End Do
      End Do
      If (nMethod.eq.RASSCF) Then
         jDisp=0
         Do iIrrep=0,nIrrep-1
            Do iDisp=1,lDisp(iIrrep)
               jDisp=jDisp+1
               ipdisp3(jdisp)=nInt+1
               Do iS=0,nirrep-1
                  js=nrOpr(iEOr(iOper(is),iOper(iIrrep)))
                  nInt=nInt+nBas(iS)*nAsh(jS)
               End Do
            End Do
         End Do
      End If
      Call GetMem('Integrals','ALLO','REAL',ipInt,nInt)
      nTwo=0
      Do iIrrep=0,nIrrep-1
          nTwo=Max(nTwo,nFck(iIrrep))
      End Do
      If (Int_Direct) Then
         nTwo2=nInt
      Else
         nTwo2=nTwo
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Desymmetrize  densities.
*     Observe that the desymmetrized 1st order density matrices are
*     canonical, i.e. the relative order of the indices are canonically
*     ordered.
*
      ipDTemp=ip_Dummy
      ipDIN=ip_Dummy
      call dcopy_(nInt,[Zero],0,Work(ipInt),1)
      If (New_Fock) Then
         If (nmethod.ne.RASSCF) Then
            Call getmem('DTemp','Allo','Real',ipDTemp,nDens)
            Call Get_D1ao_Var(Work(ipDTemp),nDens)
            Call DScal_(nDens,Half,Work(ipDTemp),1)
            ij=0
            Do i = 1, nBas(0)
               ij = ij + i
               Work(ipdtemp-1+ij)=Two*Work(ipDTemp-1+ij)
            End Do
         Else
            Call GetMem('DIN','Allo','Real',ipDIN,ndens)
            Call GetMem('DTemp','Allo','Real',ipDTemp,ndens)
            Call Din(Work(ipDIN))
            Call DScal_(nDens,Half,Work(ipDIN),1)
            ij=0
            Do i = 1, nBas(0)
               ij = ij + i
               Work(ipDIN-1+ij)=Two*Work(ipDIN-1+ij)
            End Do
            Call Dan(Work(ipDTemp))
            Call DScal_(nDens,Half,Work(ipDTemp),1)
            ij=0
            Do i = 1, nBas(0)
               ij = ij + i
               Work(ipDtemp-1+ij)=Two*Work(ipDTemp-1+ij)
            End Do
         End if
      Else
         mmdede=ndede
         Call mma_allocate(ipOffD,3,nIndij,label='ipOffD')
         Call mma_allocate(DeDe,mmDeDe+MxDij,label='DeDe')
         ipDijS = 1 + mmDeDe
         If (nMethod.ne.RASSCF) Then
            Call getmem('DTemp','Allo','Real',ipDTemp,nDens)
            Call Get_D1ao_Var(Work(ipDTemp),nDens)
            Call DeDe_mck(Work(ipDTemp),nFck(0),ipOffD,nIndij,
     &                    Dede,mmDeDe,mDeDe,mIndij)
            Call GetMem('Dtemp','Free','Real',ipDTemp,ndens)
            ipDTemp=ip_Dummy
         Else
            Call mma_allocate(ipOffDA,3,nIndij,Label='ipOffDA')
            Call mma_allocate(DeDe2,mmDeDe+MxDij,label='DeDe2')
            ipDijS2 = 1 + mmDeDe
            Call GetMem('DIN','Allo','Real',ipDIN,ndens)
            Call GetMem('DTemp','Allo','Real',ipDTemp,ndens)
*
            Call Dan(Work(ipDTemp))
            Call DeDe_mck(Work(ipDTemp),nFck(0),ipOffD,nIndij,
     &                    DeDe,mmDeDe,mDeDe,mIndij)
            Call GetMem('Dtemp','Free','Real',ipDTemp,ndens)
            ipDTemp=ip_Dummy

            Call Din(Work(ipDIN))
            Call DeDe_mck(Work(ipDIN),nFck(0),ipOffDA,nIndij,
     &                    DeDe2,mmDeDe,mDeDe,mIndij)
            Call GetMem('DIN','Free','Real',ipDIN,ndens)
            ipDIN=ip_Dummy

            If (mDeDe.ne.nDeDe) Then
               Write (6,*) 'DrvG2: mDeDe.ne.nDeDe'
               Write (6,*) 'mDeDe,nDeDe=',mDeDe,nDeDe
               Call Abend
            End If
         End If
      End If
*
      nb=0
      Do is=0,nIrrep-1
         nb=nb+nBas(iS)
      End Do
*
      End If ! lGrad
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_iSD()
      Call Set_Basis_Mode('Valence')
      Call Nr_Shells(nSkal)
      Call Setup_iSD()
*
      nPairs=nSkal*(nSkal+1)/2
      nQuad=nPairs*(nPairs+1)/2
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      Call mma_allocate(TMax,nSkal,nSkal,Label='TMax')
      Call Shell_MxSchwz(nSkal,TMax)
      TMax_all=Zero
      Do iS = 1, nSkal
         Do jS = 1, iS
            TMax_all=Max(TMax_all,TMax(iS,jS))
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Create list of non-vanishing pairs
*
      Call mma_allocate(Ind_ij,2,nSkal*(nSkal+1)/2,Label='Ind_ij')
      nijS=0
      Do iS = 1, nSkal
         Do jS = 1, iS
            If (TMax_All*TMax(iS,jS).ge.CutInt) Then
               nijS = nijS + 1
               Ind_ij(1,nijS)=iS
               Ind_ij(2,nijS)=jS
            End If
         End Do
      End Do
      Call Init_Tsk(id_Tsk,nijS)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_MaxDBLE(MemMax)
      Call mma_allocate(Sew_Scr,MemMax-iii,Label='Sew_Scr')
      ipMem=1
      memmax=memmax-iii
*                                                                      *
************************************************************************
*                                                                      *
*     big loop over individual tasks, distributed over individual nodes
 10   Continue
*     make reservation of a task on global task list and get task range
*     in return. Function will be false if no more tasks to execute.
      If (.Not.Rsv_Tsk(id_Tsk,ijSh)) Go To 11
      iS = Ind_ij(1,ijSh)
      jS = Ind_ij(2,ijSh)
      Call CWTime(TCpu1,TWall1)
*                                                                      *
************************************************************************
*                                                                      *
*     Outer loops (ij) over angular momenta and centers
*
C     Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         Coor(1:3,1)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
         iAngV(1) = iAng
         iShllV(1) = iShll
         iCmpV(1) = iCmp
         iShelV(1) = iShell
         iAOV(1) = iAO
*
C        Do jS = 1, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
            Coor(1:3,2)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
            iAngV(2) = jAng
            iShllV(2) = jShll
            iCmpV(2) = jCmp
            iShelV(2) = jShell
            iAOV(2) = jAO
*
            ijAng = iAng + jAng
*
            nHrrab=0
            Do i=0,iAng+1
               Do j=0,jAng+1
                  If (i+j.le.iAng+jAng+1) Then
                     ijMax=Min(iAng,jAng)+1
                     nHrrab=nHrrab+ijMax*2+1
                  End If
               End Do
            End Do
            If (iShell.ge.jShell) Then
               ijShll = iShell*(iShell-1)/2+jShell
            Else
               ijShll = jShell*(jShell-1)/2+iShell
            End If
*                                                                      *
************************************************************************
*                                                                      *
*           Cltrls for MO transformation
*                                                                      *
************************************************************************
*                                                                      *
            If (nMethod.eq.RASSCF.and.l_Grd) Then
               iMemB=nACO**2*iCmp*iBas*jCmp*jBas*nDisp*nirrep
               If (iMemB.gt.MemMax) Then
                  Write (6,*) 'DrvG2: iMemB.gt.MemMax'
                  Write (6,*) 'iMemB=',iMemB
                  Write (6,*) 'MemMax=',MemMax
                  Write (6,*) 'Increase MOLCAS_MEM!'
                  Call Abend()
               End If
               Sew_Scr(1:iMemb)=Zero
            Else
               iMemb=0
            End If
*                                                                      *
************************************************************************
*                                                                      *
            Post_Process=.False.
            Do klSh = 1, nijS
               ks = Ind_ij(1,klSh)
               ls = Ind_ij(2,klSh)
*
               Aint=TMax(iS,jS)*TMax(kS,lS)
C              Write (*,*) 'is,js,ks,ls=',is,js,ks,ls
               If (AInt.lt.CutInt) Go To 400
*
C           Do kS = 1, nSkal
               kShll  = iSD( 0,kS)
               kAng   = iSD( 1,kS)
               kCmp   = iSD( 2,kS)
               kBas   = iSD( 3,kS)
               kPrim  = iSD( 5,kS)
               kAO    = iSD( 7,kS)
               mdck   = iSD(10,kS)
               kShell = iSD(11,kS)
               kCnttp = iSD(13,kS)
               kCnt   = iSD(14,kS)
               Coor(1:3,3)=dbsc(kCnttp)%Coor(1:3,kCnt)
*
               iAngV(3) = kAng
               iShllV(3) = kShll
               iCmpV(3) = kCmp
               iShelV(3) = kShell
               iAOV(3) = kAO
*
               Shik = iShell.eq.kShell
*
C              Do lS = 1, kS
                  lShll  = iSD( 0,lS)
                  lAng   = iSD( 1,lS)
                  lCmp   = iSD( 2,lS)
                  lBas   = iSD( 3,lS)
                  lPrim  = iSD( 5,lS)
                  lAO    = iSD( 7,lS)
                  mdcl   = iSD(10,lS)
                  lShell = iSD(11,lS)
                  lCnttp = iSD(13,lS)
                  lCnt   = iSD(14,lS)
                  Coor(1:3,4)=dbsc(lCnttp)%Coor(1:3,lCnt)
*
                  iAngV(4) = lAng
                  iShllV(4) = lShll
                  iCmpV(4) = lCmp
                  iShelV(4) = lShell
                  iAOV(4) = lAO
*
*
                  klAng = kAng + lAng
                  nHrrcd=0
                  Do i=0,kAng+1
                     Do j=0,lAng+1
                        If (i+j.le.kAng+lAng+1) Then
                           ijMax=Min(kAng,lAng)+1
                           nHrrcd=nHrrcd+ijMax*2+1
                        End If
                     End Do
                  End Do
*                                                                      *
************************************************************************
*                                                                      *
*-----------------Skip out if no symmetry and integral of
*                 one center type
*
                  If (kShell.ge.lShell) Then
                     klShll = kShell*(kShell-1)/2+lShell
                  Else
                     klShll = lShell*(lShell-1)/2+kShell
                  End If
*
*-----------------The code is working in such away that the MO needs
*                 upper and lower triangular parts of ij kl but hessian
*                 needs only lower, check if the integralbatch is lower
*                 or upper!!
*
                  lTri=iTri(iS,jS).ge.iTri(kS,lS)
                  If (.not.lTri.and.nMethod.ne.RASSCF) Goto 400
                  lDot=(lTri.and.l_Hss)
*
                  Shjl = jShell.eq.lShell
                  Shijij = Shik.and.Shjl
*                                                                      *
************************************************************************
*                                                                      *
              iCmpV(1)=icmp
              iCmpV(2)=jcmp
              iCmpV(3)=kcmp
              iCmpV(4)=lcmp
              iPrimi   = Shells(iShllV(1))%nExp
              jPrimj   = Shells(iShllV(2))%nExp
              kPrimk   = Shells(iShllV(3))%nExp
              lPriml   = Shells(iShllV(4))%nExp
              iBasi    = Shells(iShllV(1))%nBasis
              jBasj    = Shells(iShllV(2))%nBasis
              kBask    = Shells(iShllV(3))%nBasis
              lBasl    = Shells(iShllV(4))%nBasis
*                                                                      *
************************************************************************
*                                                                      *
*-------------Allocate memory for zeta, eta, kappa, P and Q.
*             Allocate also for Alpha, Beta , Gamma and Delta
*             in expanded form.
*
              nZeta = iPrimi * jPrimj
              nEta = kPrimk * lPriml
              MemR=9*nZeta + 9*nEta +nEta*nZeta
              ipZI  = ipZeta + nZeta
              ipKAB = ipZi   + nZeta
              ipP   = ipKAB  + nZeta
              ipxA  = ipP    + nZeta*3
              ipxB  = ipxA   + nZeta
              ipEta = ipxB   + nZeta
              ipEI  = ipEta  + nEta
              ipKCD = ipEI   + nEta
              ipQ   = ipKCD   + nEta
              ipxG  = ipQ    + nEta*3
              ipxD  = ipxG   + nEta
              ipxPre= ipxD   + nEta
*                                                                      *
************************************************************************
*                                                                      *
                  nab = nElem(iAng)*nElem(jAng)
                  ncd = nElem(kAng)*nElem(lAng)

                  ijS = iTri(iShell,jShell)
                  klS = iTri(kShell,lShell)
                  ikS = iTri(iShell,kShell)
                  ilS = iTri(iShell,lShell)
                  jkS = iTri(jShell,kShell)
                  jlS = iTri(jShell,lShell)
*                 If (.Not.l2DI) Then
*                    nab = 0
*                    ncd = 0
*                 End If
                  k2ij  = Indk2(1,ijS)
                  nDCRR = Indk2(2,ijS)
                  k2kl  = Indk2(1,klS)
                  nDCRS = Indk2(2,klS)
*
                  If (ltri) Then
*
*-------------------------------------------------------------------*
*
*                 Fix the 1st order density matrix
*
*-----------------Pick up pointers to desymmetrized 1st order density
*                 matrices. Observe that the desymmetrized 1st order
*                 density matrices follows the contraction index.
*
                  ipTmp =0
                  ipTmp2=0
                  If (lpick) Then
*
                  ipDij = ipOffD(1,ijS)
                  mDCRij= ipOffD(2,ijS)
                  nDij  = ipOffD(3,ijS)
*
                  ipTmp = ipDijs
                  If (nMethod.eq.RASSCF) Then
                     ipDij2 = ipOffDA(1,ijS)
                     ipTmp2= ipDijs2
                  End If
*
                  If (mDCRij.ne.0) Then
                     ipDDij = ipTmp
                     ipTmp = ipTmp + nDij*mDCRij
                     If (nMethod.eq.RASSCF) Then
                        ipDDij2=ipTmp2
                        ipTmp2= ipTmp2+ nDij*mDCRij
                     End If
                  Else
                     ipDDij = ip_Dummy
                  End If
*
                  ipDkl = ipOffD(1,klS)
                  If (nMethod.eq.RASSCF) ipDkl2 = ipOffDA(1,klS)
                  mDCRkl= ipOffD(2,klS)
                  nDkl  = ipOffD(3,klS)
                  If (mDCRkl.ne.0) Then
                     ipDDkl = ipTmp
                     ipTmp = ipTmp + nDkl*mDCRkl
                     If (nMethod.eq.RASSCF) Then
                       ipDDkl2=ipTmp2
                       ipTmp2= ipTmp2+ nDkl*mDCRkl
                     End If
                  Else
                     ipDDkl = ip_Dummy
                  End If
*
                  ipDik = ipOffD(1,ikS)
                  If (nMethod.eq.RASSCF) ipDik2 = ipOffDA(1,ikS)
                  mDCRik= ipOffD(2,ikS)
                  nDik  = ipOffD(3,ikS)
                  If (mDCRik.ne.0) Then
                     ipDDik = ipTmp
                     ipTmp = ipTmp + nDik*mDCRik
                    If (nMethod.eq.RASSCF) Then
                      ipDDik2=ipTmp2
                      ipTmp2= ipTmp2+ nDik*mDCRik
                    End If
                  Else
                     ipDDik = ip_Dummy
                  End If
*
                  ipDil = ipOffD(1,ilS)
                  If (nMethod.eq.RASSCF) ipDil2 = ipOffDA(1,ilS)
                  mDCRil= ipOffD(2,ilS)
                  nDil  = ipOffD(3,ilS)
                  If (mDCRil.ne.0) Then
                     ipDDil = ipTmp
                     ipTmp = ipTmp + nDil*mDCRil
                     If (nMethod.eq.RASSCF) Then
                      ipDDil2=ipTmp2
                      ipTmp2= ipTmp2+ nDil*mDCRil
                     End If
                  Else
                     ipDDil = ip_Dummy
                  End If
*
                  ipDjk = ipOffD(1,jkS)
                  If (nMethod.eq.RASSCF) ipDjk2 = ipOffDA(1,jkS)
                  mDCRjk= ipOffD(2,jkS)
                  nDjk  = ipOffD(3,jkS)
                  If (mDCRjk.ne.0) Then
                     ipDDjk = ipTmp
                     ipTmp = ipTmp + nDjk*mDCRjk
                     If (nMethod.eq.RASSCF) Then
                      ipDDjk2=ipTmp2
                      ipTmp2= ipTmp2 + nDjk*mDCRjk
                     End If
                  Else
                     ipDDjk = ip_Dummy
                  End If
*
                  ipDjl = ipOffD(1,jlS)
                  If (nMethod.eq.RASSCF) ipDjl2 = ipOffDA(1,jlS)
                  mDCRjl= ipOffD(2,jlS)
                  nDjl  = ipOffD(3,jlS)
                  If (mDCRjl.ne.0) Then
                     ipDDjl = ipTmp
                     ipTmp = ipTmp + nDjl*mDCRjl
                     If (nMethod.eq.RASSCF) Then
                      ipDDjl2=ipTmp2
                      ipTmp2= ipTmp2+ nDjl*mDCRjl
                     End If
                  Else
                     ipDDjl = ip_Dummy
                  End If
*
                  End If  ! If (lpick) Then
                  End If  ! If (ltri) Then
*                                                                      *
************************************************************************
*                                                                      *
*-----------------Compute total size of the second order density
*                 matrix in SO basis.
*
*----------------------------------------------------------------------*
                  nSO = MemSO2_P(iCmp,jCmp,kCmp,lCmp,
     &                           iAOV(1),iAOV(2),iAOV(3),iAOV(4))
                  ldot2=ldot
                  If (nSO.eq.0) ldot2=.false.
*
*-----------------Compute memory request for the primitives.
*
                  ider=2
                  if (.not.ldot2) iDer=1
                  Call MemRg2(iAngV,nRys,MemPrm,ider)
*
*----------------------------------------------------------------------*
*
*                 Calculate which derivatives that should be made.
*
*----------------------------------------------------------------------*
*
                  Call DerCtr(mdci,mdcj,mdck,mdcl,ldot2,JfGrd,
     &                        JndGrd,JfHss,JndHss,JfG,mBatch)
*

*----------------------------------------------------------------------*
*
*-----------------Decide on the partioning of the shells based on the
*                 available memory and the requested memory.
*
                  Call PSOAO2(nSO,MemPrm, MemMax,
     &                        iAngV, iCmpV, iAOV,iFnc,
     &                        iBasi,iBsInc, jBasj,jBsInc,
     &                        kBask,kBsInc, lBasl,lBsInc,
     &                        iPrimi,iPrInc,jPrimj,jPrInc,
     &                        kPrimk,kPrInc,lPriml,lPrInc,
     &                        nAco,
     &                        Mem1,Mem2,Mem3,Mem4,
     &                        MemX,MemPSO,
     &                        MemFck,nFT,memCMO2,MemFin,MemBuffer,
     &                        iMemB)

*
*----------------------------------------------------------------------*
*
*   Loop over basis function if we do not have enough of memory to
*   calculate them in one step.
*
*----------------------------------------------------------------------*
                  Do 500 iBasAO = 1, iBasi, iBsInc
                    iBasn=Min(iBsInc,iBasi-iBasAO+1)
                    iAOst(1) = iBasAO-1
*----------------------------------------------------------------------*
*
*----------------- Move appropiate portions of the desymmetrized 1st
*                  order density matrix.
*
*
*----------------------------------------------------------------------*
                  Do 510 jBasAO = 1, jBasj, jBsInc
                    jBasn=Min(jBsInc,jBasj-jBasAO+1)
                    iAOst(2) = jBasAO-1
                    If (lpick.and.nDij*mDCRij.ne.0) Then
                     Call Picky(DeDe(ipDij),iBasi,jBasj,
     &                         iPrimi*jPrimj,
     &                         iCmpV(1)*iCmpV(2),mDCRij,
     &                         iBasAO,iBasAO+iBasn-1,
     &                         jBasAO,jBasAO+jBasn-1,DeDe(ipDDij))
                    If (nMethod.eq.RASSCF)
     &              Call Picky(DeDe2(ipDij2),iBasi,jBasj,
     &                         iPrimi*jPrimj,
     &                         iCmpV(1)*iCmpV(2),mDCRij,
     &                         iBasAO,iBasAO+iBasn-1,
     &                         jBasAO,jBasAO+jBasn-1,DeDe2(ipDDij2))
                    End If
                    mDij = (iBasn*jBasn+1)*iCmpV(1)*iCmpV(2) +
     &                     iPrimi*jPrimj + 1
                    mDij = Min(nDij,mDij)
*
                  Do 520 kBasAO = 1, kBask, kBsInc
                    kBasn=Min(kBsInc,kBask-kBasAO+1)
                    iAOst(3) = kBasAO-1
                    If (lpick.and.nDik*mDCRik.ne.0) Then
                     Call Picky(DeDe(ipDik),iBasi,kBask,
     &                         iPrimi*kPrimk,
     &                         iCmpV(1)*iCmpV(3),mDCRik,
     &                         iBasAO,iBasAO+iBasn-1,
     &                         kBasAO,kBasAO+kBasn-1,DeDe(ipDDik))
                     If (nMethod.eq.RASSCF)
     &               Call Picky(DeDe2(ipDik2),iBasi,kBask,
     &                         iPrimi*kPrimk,
     &                         iCmpV(1)*iCmpV(3),mDCRik,
     &                         iBasAO,iBasAO+iBasn-1,
     &                         kBasAO,kBasAO+kBasn-1,DeDe2(ipDDik2))
                    End If
                    mDik = (iBasn*kBasn+1)*iCmpV(1)*iCmpV(3) +
     &                     iPrimi*kPrimk + 1
                    mDik = Min(nDik,mDik)
                    If (lpick.and.nDjk*mDCRjk.ne.0) Then
                     Call Picky(DeDe(ipDjk),jBasj,kBask,
     &                         jPrimj*kPrimk,
     &                         iCmpV(2)*iCmpV(3),mDCRjk,
     &                         jBasAO,jBasAO+jBasn-1,
     &                         kBasAO,kBasAO+kBasn-1,DeDe(ipDDjk))
                    If (nMethod.eq.RASSCF)
     &               Call Picky(DeDe2(ipDjk2),jBasj,kBask,
     &                         jPrimj*kPrimk,
     &                         iCmpV(2)*iCmpV(3),mDCRjk,
     &                         jBasAO,jBasAO+jBasn-1,
     &                         kBasAO,kBasAO+kBasn-1,DeDe2(ipDDjk2))
                    End If
                    mDjk = (jBasn*kBasn+1)*iCmpV(2)*iCmpV(3) +
     &                     jPrimj*kPrimk + 1
                    mDjk = Min(nDjk,mDjk)

                  Do 530 lBasAO = 1, lBasl, lBsInc
                    lBasn=Min(lBsInc,lBasl-lBasAO+1)
                    iAOst(4) = lBasAO-1
                    If (lpick.and.nDkl*mDCRkl.ne.0) Then
                    Call Picky(DeDe(ipDkl),kBask,lBasl,
     &                         kPrimk*lPriml,
     &                         iCmpV(3)*iCmpV(4),mDCRkl,
     &                         kBasAO,kBasAO+kBasn-1,
     &                         lBasAO,lBasAO+lBasn-1,DeDe(ipDDkl))
                    If (nMethod.eq.RASSCF)
     &              Call Picky(DeDe2(ipDkl2),kBask,lBasl,
     &                         kPrimk*lPriml,
     &                         iCmpV(3)*iCmpV(4),mDCRkl,
     &                         kBasAO,kBasAO+kBasn-1,
     &                         lBasAO,lBasAO+lBasn-1,DeDe2(ipDDkl2))
                    End If
                    mDkl = (kBasn*lBasn+1)*iCmpV(3)*iCmpV(4) +
     &                     kPrimk*lPriml + 1
                    mDkl = Min(nDkl,mDkl)
                    If (lpick.and.nDil*mDCRil.ne.0) Then
                    Call Picky(DeDe(ipDil),iBasi,lBasl,
     &                         iPrimi*lPriml,
     &                         iCmpV(1)*iCmpV(4),mDCRil,
     &                         iBasAO,iBasAO+iBasn-1,
     &                         lBasAO,lBasAO+lBasn-1,DeDe(ipDDil))
                    If (nMethod.eq.RASSCF)
     &              Call Picky(DeDe2(ipDil2),iBasi,lBasl,
     &                         iPrimi*lPriml,
     &                         iCmpV(1)*iCmpV(4),mDCRil,
     &                         iBasAO,iBasAO+iBasn-1,
     &                         lBasAO,lBasAO+lBasn-1,DeDe2(ipDDil2))
                    End If
                    mDil = (iBasn*lBasn+1)*iCmpV(1)*iCmpV(4) +
     &                     iPrimi*lPriml + 1
                    mDil = Min(nDil,mDil)
                    If (lpick.and.nDjl*mDCRjl.ne.0) Then
                    Call Picky(DeDe(ipDjl),jBasj,lBasl,
     &                         jPrimj*lPriml,
     &                         iCmpV(2)*iCmpV(4),mDCRjl,
     &                         jBasAO,jBasAO+jBasn-1,
     &                         lBasAO,lBasAO+lBasn-1,DeDe(ipDDjl))
                    If (nMethod.eq.RASSCF)
     &              Call Picky(DeDe2(ipDjl2),jBasj,lBasl,
     &                         jPrimj*lPriml,
     &                         iCmpV(2)*iCmpV(4),mDCRjl,
     &                         jBasAO,jBasAO+jBasn-1,
     &                         lBasAO,lBasAO+lBasn-1,DeDe2(ipDDjl2))
                    End If
                    mDjl = (jBasn*lBasn+1)*iCmpV(2)*iCmpV(4) +
     &                     jPrimj*lPriml + 1
                    mDjl = Min(nDjl,mDjl)
                    If (.not.lpick) Then
                     ipddjl1=ip_Dummy
                     ipddjl2=ip_Dummy
                     ipddil1=ip_Dummy
                     ipddil2=ip_Dummy
                     ipddkl1=ip_Dummy
                     ipddkl2=ip_Dummy
                     ipddij1=ip_Dummy
                     ipddij2=ip_Dummy
                     ipddik1=ip_Dummy
                     ipddik2=ip_Dummy
                     ipddjk1=ip_Dummy
                     ipddjk2=ip_Dummy
                    End If
*
*----------------------------------------------------------------------*
*
                    MEMCMO=nACO*(kCmp*kBasn+lCmp*lBasn)
*.................. MO tranformation buffer
                    ipBuffer = ipMem
                    ipMOC    = ipBuffer + MEMBUFFER
*.................. Area for the AO integrals
                    ipFin    = ipMOC    + MemCMO
*.................. Area for 2el density
                    ip_PP     = ipFin    + MemFin
                    ipMem2   = ip_PP     + Mem1         ! Work
                    ipMem3   = ipMem2   + Mem2          ! Work
                    ipMemX   = ipMem3   + Mem3          ! Work
*
*-------------------If MO transformation is performed in the standard way
*                   reserve memory for partial transfromed integrals
*
*
*-------------------Multilayer
*
                    ipMem4   = ipMem2   + Mem2 - Mem4

*
*----------------------------------------------------------------------*
*
*-------------------Get the 2nd order density matrix in SO basis.
*
*----------------------------------------------------------------------*
*

                    nijkl = iBasn*jBasn*kBasn*lBasn
                    Call Timing(dum,Time,Dum,Dum)
                    If (n8)
     &              Call PickMO(Sew_Scr(ipMOC),MemCMO,nAcO,iCmpV,
     &                          iBasAO,iBasn,jBasAO,jBasn,
     &                          kBasAO,kBasn,lBasAO,lBasn,iAOV)
                    If (ldot2)
     &               Call PGet0(iCmpV,
     &                         iBasn,jBasn,kBasn,lBasn,Shijij,
     &                         iAOV,iAOst,nijkl,Sew_Scr(ip_PP),nSO,
     &                         iFnc(1)*iBasn,iFnc(2)*jBasn,
     &                         iFnc(3)*kBasn,iFnc(4)*lBasn,MemPSO,
     &                         Sew_Scr(ipMem2),Mem2,
     &                         iS,jS,kS,lS,nQuad,PMax)
                    Call Timing(dum,Time,Dum,Dum)
                    CPUStat(nTwoDens)=CPUStat(nTwoDens)+Time
*
*-------------------Compute gradients of shell quadruplet
*
                    ipD0=ip_of_Work(D0(1,1))
                    Call TwoEl_mck(Coor,iAngV,iCmpV,iShelV,iShllV,iAOV,
     &                   iAOst,mdci,mdcj,mdck,mdcl,nRys,
     &                   Data_k2(k2ij),nab,nDCRR,
     &                   Data_k2(k2kl),ncd,nDCRS,Pren,Prem,
     &            Shells(iShllV(1))%Exp,iPrimi,iPrInc,
     &            Shells(iShllV(2))%Exp,jPrimj,jPrInc,
     &            Shells(iShllV(3))%Exp,kPrimk,kPrInc,
     &            Shells(iShllV(4))%Exp,lPriml,lPrInc,
     &            Shells(iShllV(1))%pCff(1,iBasAO),iBasn,
     &            Shells(iShllV(2))%pCff(1,jBasAO),jBasn,
     &            Shells(iShllV(3))%pCff(1,kBasAO),kBasn,
     &            Shells(iShllV(4))%pCff(1,lBasAO),lBasn,
     &           Mem_DBLE(ipZeta),Mem_DBLE(ipZI),
     &           Mem_DBLE(ipP),Mem_DBLE(ipKab),nZeta,
     &           Mem_DBLE(ipEta), Mem_DBLE(ipEI),
     &           Mem_DBLE(ipQ),Mem_DBLE(ipKcd),nEta,
     &           Mem_DBLE(ipxA),Mem_DBLE(ipxB),
     &           Mem_DBLE(ipxG),Mem_DBLE(ipxD),
     &                   Mem_DBLE(ipxPre),
     &                   Hess, nhess,JfGrd,JndGrd,JfHss,JndHss,JfG,
     &                   Sew_Scr(ip_PP), nSO,Sew_Scr(ipMem2),Mem2,
     &                   Sew_Scr(ipMem3),Mem3,Sew_Scr(ipMem4),Mem4,
     &                   Aux,nAux,Sew_Scr(ipMemX),MemX,Shijij,
     &                   DeDe(ipDDij),DeDe2(ipDDij2),mDij,mDCRij,
     &                   DeDe(ipDDkl),DeDe2(ipDDkl2),mDkl,mDCRkl,
     &                   DeDe(ipDDik),DeDe2(ipDDik2),mDik,mDCRik,
     &                   DeDe(ipDDil),DeDe2(ipDDil2),mDil,mDCRil,
     &                   DeDe(ipDDjk),DeDe2(ipDDjk2),mDjk,mDCRjk,
     &                   DeDe(ipDDjl),DeDe2(ipDDjl2),mDjl,mDCRjl,
     &                   iCmpV,Sew_Scr(ipFin),MemFin,
     &                   Sew_Scr(ipMem2),Mem2+Mem3+MemX,nTwo2,nFT,
     &                   Mem_INT(ipIndEta),Mem_INT(ipIndZet),
     &                   Work(ipInt),ipd0,Sew_Scr(ipBuffer),MemBuffer,
     &                   lgrad,ldot2,n8,ltri,Work(ipDTemp),Work(ipDIN),
     &                   moip,nAco,Sew_Scr(ipMOC),MemCMO,new_fock)
                  Post_Process=.True.

*----------------------------------------------------------------------*
*
 530              Continue
 520              Continue
 510              Continue
 500              Continue
*
 400              Continue
C              End Do ! lS
C           End Do ! kS
            End Do ! klS
*
            If (nMethod.eq.RASSCF.and.Post_Process) Then
               ip1=ipMOC
               ip2=ip1+iCmp*iBas*naco
               ip3=ip2+nAco**2
               ip4=ip3+jcmp*jBas*naco
               ip5=ip4+iCmp*naco*iBas
               ip6=ip5+jcmp*jbas*naco
               Call CLR2(Sew_Scr(ipBuffer),Work(ipInt),
     &                   ibas,icmp,jbas,jcmp,iAOV(1),iAOV(2),
     &                   naco,ishelV,
     &                   Sew_Scr(ip1),Sew_Scr(ip2),Sew_Scr(ip3),
     &                   Sew_Scr(ip4),Sew_Scr(ip5),Sew_Scr(ip6))
            End If
*
C        End Do ! jS
C     End Do !  iS
*
      Call CWTime(TCpu2,TWall2)
      Call SavTim(4,TCpu2-TCpu1,TWall2-Twall1)
      Call SavStat(1,One,'+')
      Call SavStat(2,DBLE(nijs),'+')
      Go To 10
 11   Continue
*     End of big task loop
*                                                                      *
************************************************************************
*                                                                      *
* - - - - - - - E P I L O G
*                                                                      *
************************************************************************
*                                                                      *
      If (New_Fock) Then
         idd=0
         Do iS=0,nirrep-1
           Do iD=1,ldisp(is)
            idd=idd+1
            ip=ipInt-1+ipDisp(idd)
            Call DScal_(nDens,Half,work(ip),1)
            ij =ip-1
            Do i = 1, nBas(0)
             ij=ij+i
             Work(ij)=Two*Work(ij)
            End Do
           End Do
          End Do
         If (nmethod.eq.RASSCF) Then
         idd=0
         Do iS=0,nirrep-1
           Do iD=1,ldisp(is)
            idd=idd+1
            ip=ipInt-1+ipDisp2(idd)
            Call DScal_(nDens,Half,work(ip),1)
            ij =ip-1
            Do i = 1, nBas(0)
             ij=ij+i
             Work(ij)=Two*Work(ij)
            End Do
           End Do
          End Do

      End If
      End If
#ifdef _DEBUGPRINT_
      Call GADSum_SCAL(Pren)
      Call GADSum_SCAL(Prem)
      Write (Format,'(A,I2,A,I2,A)') '(A,F',
     &              3+Int(Log10(Pren)),
     &              '.0,A,F',
     &              3+Int(Log10(Prem)),
     &              '.0,A)'
      Write (6,Format)
     &   ' A total of', Pren,' entities were prescreened and',
     &                  Prem,' were kept.'
#endif
      Call mma_deallocate(Sew_Scr)
      Call Free_Tsk(id_Tsk)
*
*    YIPPIEEEE Finished OK fill it UP!!
*
      Call GADSum(Work(ipInt),nInt)
      jDisp=0
      Do iIrr=0,nIrrep-1
        Do iDisk=1,lDisp(iIrr)
         jDisp=jDisp+1
           Call WrDisk(Work(ipInt),nInt,jdisp,iIrr)
        End Do
      End Do
*
      Call mma_deallocate(Ind_ij)
      Call mma_deallocate(TMax)
      Call Free_iSD()
*
      If (.not.New_Fock) Then
         Call mma_deallocate(ipOffD)
         Call mma_deallocate(DeDe)
         If (nMethod.eq.RASSCF) Then
            Call mma_deallocate(DeDe2)
            Call mma_deallocate(ipOffDA)
         End If
      End If
*
      Call mma_deallocate(Mem_DBLE)
      Call mma_deallocate(Mem_INT)
*
      If (ipDIN.ne.ip_Dummy)
     &   Call GetMem('DIN','Free','Real',ipDIN,ndens)
      If (ipDTemp.ne.ip_Dummy)
     &   Call GetMem('DTemp','Free','Real',ipDTemp,ndens)
      Call GetMem('Integrals','Free','REAL',ipInt,nInt)
*
      Call mma_deallocate(Aux)
*
*-----Generate statistic of partioning
*
      Call mma_deallocate(IndK2)
      Call mma_deallocate(Data_k2)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      real*8 function  gammat(x)
************************************************************************
*                                                                      *
* Object: to compute the angular contribution to the multipole integral*
*         between continuum basis functions within an R-matrix sphere  *
*         (theta integration)                                          *
*                                                                      *
************************************************************************
      Implicit real*8 (a-h,o-z)
#include "nrmf.fh"
#include "gam.fh"
*
      lsint=m_gam
      lcost=n_gam
      k=(-1)**lcost
      if(k.eq.(-1)) then
       gammat=0.0d0
      else
       arg1=(DBLE(lcost)+1.0d0)/2.0d0
       arg2=(DBLE(lsint)+2.0d0)/2.0d0
       arg3=(DBLE(lsint)+DBLE(lcost)+3.0d0)/2.0d0
       gammat=dgamma_molcas(arg1)*dgamma_molcas(arg2)/
     >                            dgamma_molcas(arg3)
      Endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(x)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Set_Fake_ERIs
      use Basis_Info, only: nBas
      use RICD_Info, only: Do_RI, Cholesky
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
#include "cholesky.fh"
      Character*16 NamRfil
      Integer, Dimension(:), Allocatable :: iSOShl
*
      write(6,*)
      write(6,*)'   *** Skipping anything related to ERIs ***'
      write(6,*)
*
      If (.not.Cholesky .and. .not.Do_RI) Return

      Call Get_NameRun(NamRfil)
      Call NameRun('AUXRFIL')
*
      Call Get_iScalar('ChoVec Address',CHO_ADRVEC)
      nBasT=nBas(0)
      Do i=1,nIrrep-1
         nBasT=nBasT+nBas(i)
      End Do
      Call mma_allocate(iSOShl,nBasT)
      Call Get_dScalar('Cholesky Threshold',THRCOM)
      Call Get_iArray('NumCho',NumCho,nIrrep)
      Call Get_iArray('iSOShl',ISOSHL,NBAST)
*
      Call NameRun(NamRfil)
      CALL Put_iArray('iSOShl',ISOSHL,NBAST)
      Call mma_deallocate(iSOShl)
      CALL Put_iArray('NumCho',NumCho,nIrrep)
      Call Put_iScalar('ChoVec Address',CHO_ADRVEC)
      CALL Put_dScalar('Cholesky Threshold',THRCOM)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ThermoChem_(UserT,UserP,TotalM,TRotA,TRotB,TRotC,
     &                 nUserPT,nsRot,iMult,nAtom,EVal,in_nFreq,
     &                 lSlapaf)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "constants.fh"
#include "WrkSpc.fh"
#include "real.fh"
      Integer in_nFreq, nFreq, iMult, nUserPT, nsRot, nAtom
      Real*8 UserT(64), UserP, EVal(*)
      Real*8 TotalM, TRotA, TRotB, TRotC
      Real*8 Freq(MxAtom*3-6), VibT(MxAtom*3-6), dFreqI
      Real*8 Energy
      Logical lSlapaf
*
* --- If nUserPT.EQ.0 (no User-defined Pressure and Temperatures)
* --- Compute thermodynamic data at  1.00 atm &  298.15 Kelvin.
*
      If (nUserPT.EQ.0) then
        nUserPT=1
        UserP=1.0d0
        UserT(1)=298.15d0
      EndIf
      Call Get_dScalar('Last energy',Energy)
*
* --- Is the system linear?
*
      nTR = 6
      If (TRotA.GT.1.0d99) then
        TRotA = 0.0d0
        nTR = nTR -1
      EndIf
      If (TRotB.GT.1.0d99) then
        TRotB = 0.0d0
        nTR = nTR -1
      EndIf
      If (TRotC.GT.1.0d99) then
        TRotC = 0.0d0
        nTR = nTR -1
      EndIf
*
* --- Remove translational and rotational frequencies
*
      nFreq = 0
      nTr2=nTr
      If(lSlapaf) nTr2=0
      Do i = 1, in_nFreq
        dFreqI = EVal(i)
        If (dFreqI.GT.20.0d0) Then
          nFreq = nFreq + 1
          Freq(nFreq) = dFreqI
        End if
      End Do
      If ((in_nFreq-nFreq-nTR2).GT.0 ) Write (6,*) ' *** Warning: ',
     &   (in_nFreq-nFreq-nTR2),' vibrational contributions removed.'
*
* --- Convert frequencies from cm-1 to hartree
*
      r_k = CONST_BOLTZMANN_
      r_J2au=1.0D-3 / CONV_AU_TO_KJ_
      rk = r_k * r_J2au ! Bolzmann constant in a.u./ K
      ZPVE  = 0.0d0
      Do i = 1, nFreq
         Freq(i) = Freq(i) / CONV_AU_TO_CM1_ ! = 219474.625
         VibT(i) = Freq(i) / rk
         ZPVE = ZPVE  + Freq(i)/2.0d0
      End Do
      Write (6,'(A)') ' Vibrational temperature (K): '
      Do i = 1, nFreq, 5
        If (i.LE.(nFreq-4)) Write (6,'(1X,5F9.2)') (VibT(j),j=i,i+4)
        If (i.EQ.(nFreq-3)) Write (6,'(1X,4F9.2)') (VibT(j),j=i,i+3)
        If (i.EQ.(nFreq-2)) Write (6,'(1X,3F9.2)') (VibT(j),j=i,i+2)
        If (i.EQ.(nFreq-1)) Write (6,'(1X,2F9.2)') (VibT(j),j=i,i+1)
        If (i.EQ.(nFreq))   Write (6,'(1X, F9.2)') VibT(i)
      EndDo
      Write (6,'(A,I2)')
     &            ' Number of trans. and rot. degrees of freedom: ',nTR
      Write (6,'(A,F9.3,A,F9.6,A)') ' ZPVE             ',
     &   ZPVE*6.27509541D+2,' kcal/mol     ',ZPVE,' au.'
      Write (6,'(A,13X,F15.6,A)') ' ZPVE corrected energy',
     &   ZPVE+Energy,' au.'
*
      Do i = 1, nUserPT
        Call Thermo_VibG(nFreq,Freq,UserT(i),UserP,TotalM,
     &                  nTR,nsRot,TRotA,TRotB,TRotC,iMult,Energy)
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nAtom)
      End
*
      Subroutine Thermo_VibG(nFreq,Freq,T,P,TotalM,
     &            nTR,nsRot,TRotA,TRotB,TRotC,iMult,Energy)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "constants.fh"
#include "constants2.fh"
      Real*8 Freq(nFreq), T, P,Energy
*
      r_k  = 1.3806580d-23 ! Boltzmann / SI
      r_J2au= 1.0D-3 / CONV_AU_TO_KJ_
      rk = r_k * r_J2au ! Bolzmann constant in a.u./ K
      dAU2kCal = 627.5095d0
      R_gas_kcal = 1.987216d-3
      q_e   = 1.0d0
      q_tr  = 1.0d0
      q_rot = 1.0d0
      q_vib_Tot = 1.0d0
      dS_e   = 0.0d0
      dS_tr  = 0.0d0
      dS_rot = 0.0d0
      dS_vib_Tot = 0.0d0
      dU_e   = 0.0d0
      dU_tr  = 0.0d0
      dU_rot = 0.0d0
      dU_vib_Tot = 0.0d0
      ZPVE       = 0.0d0
      q_TOT  = 1.0d0
      dS_TOT = 0.0d0
      dU_TOT = 0.0d0
      dH_TOT = 0.0d0
      dG_TOT = 0.0d0
*
* --- Electronic Contributions
*
*     Molecular Partition Function
      q_e    = iMult
*     Canonical Partition Function
      CQ_e = q_e
*     Entropy
      dS_e = R_gas_kcal * log(CQ_e)
*     Thermal
      dU_e = 0.0d0
*
* --- Translational Contributions
*
      If (T.GT.0.0d0) then
*       Molecular Partition Function (q/V in 1/m^3)
        dFact = 1.8793338d26        ! ((2*PI*k_B)/(h^2 *N_A*1000))^(3/2)
        dMT   = (TotalM/1.0d3) * T  ! m = PM/1000
        q_tr  = dFact * dMT
        q_tr  = q_tr * sqrt(dMT)
*       Entropy
        dVM   = 8.20575d-5 * T / P ! Gas Molar Volume / m**3
        dS_tr = 1.0d3 * R_gas_kcal *
     &  (log(dVM) + 1.5d0*(log(T)+log(TotalM/1.0d3)) + 18.605d0)
*       Thermal
        dU_tr = 1.5d0 * R_gas_kcal * T
      EndIf
*
* --- Rotational Contributions
*
      If (T.GT.0.0d0) then
*       Molecular Partition Function
        If (nTR.EQ.5) then
          q_rot = T / (nsRot*TRotC)
        Else If (nTR.EQ.3) Then
           q_rot = 1.0d0
        else
          q_rot = T*T*T
          q_rot = q_rot / TRotA
          q_rot = q_rot / TRotB
          q_rot = q_rot / TRotC
          q_rot = PI*q_rot
          q_rot = sqrt(q_rot)
          q_rot = q_rot/nsRot
        EndIf
      EndIf
*     Entropy
      If (nTR.EQ.5) then
        dS_rot = 1.0d3 * R_gas_kcal * ( log(q_rot) + 1.0d0 )
      Else If (nTR.EQ.3) Then
        dS_rot=0.0d0
      else
        dS_rot = 1.0d3 * R_gas_kcal * ( log(q_rot) + 1.5d0 )
      EndIf
*     Thermal
      If (nTR.EQ.5) then
        dU_rot = R_gas_kcal*T
      Else if (nTr.EQ.3) then
        dU_rot = 0.0d0
      else
        dU_rot = 1.5d0*R_gas_kcal*T
      EndIf
*
* --- Vibrational Contributions
*
      If (T.eq.Zero) then
         beta = 1.0D99
      else
         beta = One / (rk*T)
      EndIf
      Do i = 1, nFreq
        q_vib  = 1.0d0
        dU_vib = 0.0d0
        dS_vib = 0.0d0
        eta = Freq(i)
        If (eta.gt.Zero) Then
          ZPVE  = ZPVE  + eta/Two
          If (T.eq.Zero) Then
            q_vib  = One
            dU_vib = (eta/Two)
            dS_vib = Zero
          Else
*           Eq. (6-20)
            q_vib  = exp(-eta*beta/Two) / (One - exp(-eta*beta))
            dU_vib = (eta/Two) + (eta / (exp(eta*beta)-One))
            dS_vib = (eta*beta) / (exp(eta*beta) - One)
            dS_vib = dS_vib - log(One - exp(-eta*beta) )
          End If
          q_vib_Tot  =  q_vib_Tot *  q_vib
          dU_vib_Tot = dU_vib_Tot + dU_vib
          dS_vib_Tot = dS_vib_Tot + dS_vib
        End If
      End Do
      dU_vib_Tot = dU_vib_Tot * dAU2kCal
      dS_vib_Tot = dS_vib_Tot * R_gas_kcal * 1.0d3
*
      q_TOT  = q_e  * q_tr  * q_rot  * q_vib_Tot
      dS_TOT = dS_e + dS_tr + dS_rot + dS_vib_Tot
      dU_TOT = dU_e + dU_tr + dU_rot + dU_vib_Tot
      dH_TOT = dU_TOT + R_gas_kcal*T
      dG_TOT = dH_TOT - dS_TOT*T /1.0d3
*
* --- Print Results
*
      Write (6,*)
      Write (6,'(A)')
     &          ' *****************************************************'
      Write (6,'(A,F8.2,A,F7.2,A)') ' Temperature = ',T,
     &                              ' Kelvin, Pressure =',P,' atm'
      Write (6,'(A)')
     &          ' -----------------------------------------------------'
      Write (6,'(A)')
     &          ' Molecular Partition Function and Molar Entropy:'
      Write (6,'(A)')
     &          '                        q/V (M**-3)    S(kcal/mol*K)'
      Write (6,'(A,D17.6,F13.3)') ' Electronic       ',q_e,dS_e
      Write (6,'(A,D17.6,F13.3)') ' Translational    ',q_tr,dS_tr
      Write (6,'(A,D17.6,F13.3)') ' Rotational       ',q_rot,dS_rot
      Write (6,'(A,D17.6,F13.3)') ' Vibrational      ',q_vib_Tot,
     &                                                        dS_vib_Tot
      Write (6,'(A,D17.6,F13.3)') ' TOTAL            ',q_TOT,dS_TOT
*
      Write (6,*)
      Write (6,'(A)') ' Thermal contributions to INTERNAL ENERGY:'
      Write (6,'(A,F9.3,A,F9.6,A)') ' Electronic       ',
     &  dU_e      ,  ' kcal/mol     ',dU_e      /dAU2kCal,' au.'
      Write (6,'(A,F9.3,A,F9.6,A)') ' Translational    ',
     &  dU_tr     ,  ' kcal/mol     ',dU_tr     /dAU2kCal,' au.'
      Write (6,'(A,F9.3,A,F9.6,A)') ' Rotational       ',
     &  dU_rot    ,  ' kcal/mol     ',dU_rot    /dAU2kCal,' au.'
      Write (6,'(A,F9.3,A,F9.6,A)') ' Vibrational      ',
     &  dU_vib_Tot,  ' kcal/mol     ',dU_vib_Tot/dAU2kCal,' au.'
      Write (6,'(A,F9.3,A,F9.6,A)') ' TOTAL            ',
     &  dU_TOT    ,  ' kcal/mol     ',dU_TOT    /dAU2kCal,' au.'
      Write (6,*)
      Write (6,'(A)') ' Thermal contributions to'
      Write (6,'(A,F9.3,A,F9.6,A)') ' ENTHALPY         ',
     &  dH_TOT    ,  ' kcal/mol     ',dH_TOT    /dAU2kCal,' au.'
      Write (6,'(A,F9.3,A,F9.6,A)') ' GIBBS FREE ENERGY',
     &  dG_TOT    ,  ' kcal/mol     ',dG_TOT    /dAU2kCal,' au.'
      Write (6,*)
      Write (6,'(A)') ' Sum of energy and thermal contributions'
      Write (6,'(A,17X,F15.6,A)') ' INTERNAL ENERGY  ',
     &  Energy + dU_TOT    /dAU2kCal,' au.'
      Write (6,'(A,17X,F15.6,A)') ' ENTHALPY         ',
     &  Energy + dH_TOT    /dAU2kCal,' au.'
      Write (6,'(A,17X,F15.6,A)') ' GIBBS FREE ENERGY',
     &  Energy + dG_TOT    /dAU2kCal,' au.'
      Write (6,'(A)')
     &          ' -----------------------------------------------------'
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKCOUP(nLev,iSm,nVert,MidLev,nMidV,MVSta,MVEnd,
     &                  MxEO,nICoup,nWalk,nICase,nVTab,
     &                  IVR,IMAW,ISGMNT,VSGMNT,NOW,IOW,
     &                  NOCP,IOCP,ILNDW,ICASE,ICOUP,VTAB,
     &                  ISGPTH,VALUE)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='MKCOUP')
#include "symmul.fh"
#include "segtab.fh"
C Purpose: Compute and return the table ICOUP(1..3,ICOP).
C The number of coupling coeffs is obtained from NOCP, the offset to
C the ICOP numbering is given by IOCP. The numbers ICOUP(1..3,ICOP) are
C then the ket and bra half-walks, enumerated by the Lund scheme,
C and the index into the VTAB table (the pool of possible values of
C coupling coefficients).

C Any loop is regarded as a segment path from top to midlevel, or
C from midlevel to bottom.
C The segment path is described by the table ISGPTH. It is
C essentially a list of which one of segments nr 1..26 that are
C used at each level. The segments are of three types:
C Type 0: Upwalk segment or top loop segment.
C Type 1: Mid segment.
C Type 2: Bottom segment.
C Type 3: Downwalk segment.
C ISGPTH(IVLFT,LEV)=Left upper vertex.
C ISGPTH(ITYPE,LEV)=Type of segment, (0..3).
C ISGPTH(IAWSL,LEV)=Left arc weight sum (from top, or from bottom).
C ISGPTH(IAWSR,LEV)=Similar, right.
C ISGPTH(ILS  ,LEV)=Left symmetry label (accum from top or bottom).
C ISGPTH(ICS  ,LEV)=Left coupling case number (0..3).
C ISGPTH(ISEG ,LEV)=Segment type (1..26).
C These indices are used to denote the columns of table ISGPTH.
      PARAMETER (IVLFT=1,ITYPE=2,IAWSL=3,IAWSR=4,ILS=5,ICS=6)
      PARAMETER (ISEG=7)
C INPUT CALL PARAMETERS:
      DIMENSION ISM(NLEV)
      DIMENSION IVR(NVERT,2),IMAW(NVERT,0:3)
      DIMENSION ISGMNT(NVERT,26), VSGMNT(NVERT,26)
      DIMENSION NOW(2,NSYM,NMIDV), NOCP(MXEO,NSYM,NMIDV)
C OUTPUT CALL PARAMETERS:
      DIMENSION IOW(2,NSYM,NMIDV), IOCP(MXEO,NSYM,NMIDV)
      DIMENSION ILNDW(NWALK),ICASE(NICASE)
      DIMENSION VTAB(NVTAB)
      DIMENSION ICOUP(3,NICOUP)
C SCRATCH CALL PARAMETERS:
      DIMENSION ISGPTH(7,0:NLEV), VALUE(0:NLEV)




      nIpWlk=1+(MidLev-1)/15
      nIpWlk=max(nIpWlk,1+(nLev-MidLev-1)/15)
C NOW IS ZEROED AND WILL BE USED AS AN ARRAY OF COUNTERS, BUT WILL
C    BE RESTORED FINALLY.
      DO IHALF=1,2
        DO MV=1,NMIDV
          DO IS=1,NSYM
            NOW(IHALF,IS,MV)=0
          END DO
        END DO
      END DO
C SIMILAR FOR THE COUPLING COEFFICIENT TABLE:
      DO INDEO=1,MXEO
        DO MV=1,NMIDV
          DO  IS=1,NSYM
            NOCP(INDEO,IS,MV)=0
          END DO
        END DO
      END DO
C COUPLING COEFFICIENT VALUE TABLE:
      NVTAB=2
      VTAB(1)=1.0D00
      VTAB(2)=-1.0D00
      NCHECK=0
      DO IHALF=1,2
        IF(IHALF.EQ.1) THEN
          IVTSTA=1
          IVTEND=1
          LEV1=NLEV
          LEV2=MIDLEV
          ITYPMX=0
        ELSE
          IVTSTA=MVSTA
          IVTEND=MVEND
          LEV1=MIDLEV
          LEV2=0
          ITYPMX=2
        END IF
        DO IVTOP=IVTSTA,IVTEND
         DO ITYP=0,ITYPMX
          IVRTOP=IVTOP
          IF(ITYP.GT.0)IVRTOP=IVR(IVTOP,ITYP)
          IF(IVRTOP.EQ.0) GOTO 400
          LEV=LEV1
          ISGPTH(IVLFT,LEV)=IVTOP
          ISGPTH(ITYPE,LEV)=ITYP
          ISGPTH(IAWSL,LEV)=0
          ISGPTH(IAWSR,LEV)=0
          ISGPTH(ILS,LEV)=1
          ISGPTH(ISEG,LEV)=0
          VALUE(LEV)=1.0D00
100       CONTINUE
           IF(LEV.GT.LEV1) GOTO 400
           ITYPT=ISGPTH(ITYPE,LEV)
           IVLT=ISGPTH(IVLFT,LEV)
           DO ISGT=ISGPTH(ISEG,LEV)+1,26
             IVLB=ISGMNT(IVLT,ISGT)
             IF(IVLB.NE.0 .AND. ITYPT.EQ.ITVPT(ISGT)) GOTO 200
           END DO
           ISGPTH(ISEG,LEV)=0
           LEV=LEV+1
          GOTO 100

200       CONTINUE
          ISGPTH(ISEG,LEV)=ISGT
          ICL=IC1(ISGT)
          ISYM=1
          IF((ICL.EQ.1).OR.(ICL.EQ.2)) ISYM=ISM(LEV)
          IVRT=IVLT
          IF((ITYPT.EQ.1).OR.(ITYPT.EQ.2)) IVRT=IVR(IVLT,ITYPT)
          ICR=IC2(ISGT)
          ISGPTH(ICS,LEV)=ICL
          LEV=LEV-1
          ISGPTH(IAWSL,LEV)=ISGPTH(IAWSL,LEV+1)+IMAW(IVLT,ICL)
          ISGPTH(IAWSR,LEV)=ISGPTH(IAWSR,LEV+1)+IMAW(IVRT,ICR)
          VALUE(LEV)=VALUE(LEV+1)*VSGMNT(IVLT,ISGT)
          ISGPTH(ILS,LEV)=MUL(ISYM,ISGPTH(ILS,LEV+1))
          ISGPTH(IVLFT,LEV)=IVLB
          ISGPTH(ITYPE,LEV)=IBVPT(ISGT)
          ISGPTH(ISEG,LEV)=0
          IF (LEV.GT.LEV2) GOTO 100

          MV=ISGPTH(IVLFT,MIDLEV)+1-MVSTA
          LFTSYM=ISGPTH(ILS,LEV2)
          IT=ISGPTH(ITYPE,MIDLEV)
          IF(IT.EQ.0) IT=3
          IF(ISGPTH(ITYPE,LEV2).EQ.0) IT=0
          IF(IT.EQ.0) THEN
            ILND=1+NOW(IHALF,LFTSYM,MV)
            IAWS=ISGPTH(IAWSL,LEV2)
            ILNDW(IAWS)=ILND
            NOW(IHALF,LFTSYM,MV)=ILND
            IPOS=IOW(IHALF,LFTSYM,MV)+(ILND-1)*NIPWLK
            DO LL=LEV2+1,LEV1,15
              IC=0
              DO L=MIN(LL+14,LEV1),LL,-1
                IC=4*IC+ISGPTH(ICS,L)
              END DO
              IPOS=IPOS+1
              ICASE(IPOS)=IC
            END DO
          ELSE
            IP=0
            IQ=0
            DO L=LEV2+1,LEV1
              ISG=ISGPTH(ISEG,L)
              IF((ISG.GE.5).AND.(ISG.LE.8))IP=L
              IF((ISG.GE.19).AND.(ISG.LE.22))IQ=L
            END DO
            IF(IP.EQ.0) IP=IQ
            INDEO=NLEV*(IT-1)+IP
            IF(IT.EQ.3) INDEO=2*NLEV+(IP*(IP-1))/2+IQ
            ICOP=1+NOCP(INDEO,LFTSYM,MV)
            NOCP(INDEO,LFTSYM,MV)=ICOP
            ICOP=IOCP(INDEO,LFTSYM,MV)+ICOP
            NCHECK=NCHECK+1
            IF (ICOP.GT.NICOUP) THEN
              WRITE(6,*)' ERROR: NICOUP=',NICOUP
              WRITE(6,*)' NR OF COUPS PRODUCED:',NCHECK
              WRITE(6,*)'           TYPE NR IT:',IT
              WRITE(6,*)'            IP,IQ    :',IP,IQ
              WRITE(6,*)'            INDEO    :',INDEO
              WRITE(6,*)'        MIDVERTEX MV :',MV
              WRITE(6,*)' LEFT SYMMETRY LFTSYM:',LFTSYM
              WRITE(6,*)' COUP OFFSET IOCP    :',IOCP(INDEO,LFTSYM,MV)
              WRITE(6,*)' COUP SERIAL NR ICOP :',ICOP
              WRITE(6,*)' D:O, WITHOUT OFFSET :',
     *                    ICOP-IOCP(INDEO,LFTSYM,MV)
              WRITE(6,*)' CURRENT NOCP NUMBER :',NOCP(INDEO,LFTSYM,MV)
              CALL ABEND()
            END IF
C
            C=VALUE(LEV2)

C Determine value code, IVTAB:
            DO I=1,NVTAB
              IVTAB=I
              IF(ABS(C-VTAB(I)).LT.1.0D-10) GOTO 212
            END DO
            NVTAB=NVTAB+1
            IF(NVTAB.GT.5000)THEN
              WRITE(6,*)' MKCOUP: NVTAB > 5000!'
              WRITE(6,*)' Need recompilation.'
              CALL ABEND()
            END IF
            VTAB(NVTAB)=C
            IVTAB=NVTAB
212         CONTINUE

            ICOUP(1,ICOP)=ISGPTH(IAWSL,LEV2)
            ICOUP(2,ICOP)=ISGPTH(IAWSR,LEV2)
            ICOUP(3,ICOP)=IVTAB
            IF (ICOP.GT.NICOUP) THEN
              WRITE(6,*)' ICOP > NICOUP!'
              WRITE(6,*)' (This should never happen!)'
              CALL ABEND()
            END IF
          END IF
          LEV=LEV+1
          GOTO 100
* End of long loops
400      CONTINUE
         END DO
        END DO
* End of a long loop
      END DO
C RENUMBER THE COUPLING COEFFICIENT INDICES BY LUND SCHEME:
      DO ICOP=1,NICOUP
        I1=ICOUP(1,ICOP)
        I2=ICOUP(2,ICOP)
        ICOUP(1,ICOP)=ILNDW(I1)
        ICOUP(2,ICOP)=ILNDW(I2)
      END DO

      IF(IPGLOB.GE.DEBUG) THEN
        ICOP1=0
        ICOP2=0
        WRITE(6,*)' NR OF DIFFERENT VALUES OF COUP:',NVTAB
        DO ICOP=1,NICOUP
          I3=ICOUP(3,ICOP)
          IF(I3.EQ.1) ICOP1=ICOP1+1
          IF(I3.EQ.2) ICOP2=ICOP2+1
        END DO
        WRITE(6,*)
        WRITE(6,*)' NR OF COUPS WITH VALUE  1.0:',ICOP1
        WRITE(6,*)' NR OF COUPS WITH VALUE -1.0:',ICOP2
      END IF
      IF(IPGLOB.GE.INSANE) THEN
        WRITE(6,*)
        WRITE(6,*)' COUPLING COEFFICIENTS:'
        WRITE(6,*)'    IP    IQ    MV LFTSYM NOCP'
        WRITE(6,*)' 1. OPEN LOOPS TYPE 1.'
        DO IP=1,NLEV
          DO MV=1,NMIDV
            DO LFTSYM=1,NSYM
              N=NOCP(IP,LFTSYM,MV)
              WRITE(6,'(6X,6(1X,I5),1X,F10.7)') IP,MV,LFTSYM,N
            END DO
          END DO
        END DO
        WRITE(6,*)' 2. OPEN LOOPS TYPE 2.'
        DO IP=1,NLEV
          INDEO=NLEV+IP
          DO MV=1,NMIDV
            DO LFTSYM=1,NSYM
              N=NOCP(INDEO,LFTSYM,MV)
              WRITE(6,'(6X,6(1X,I5),1X,F10.7)') IP,MV,LFTSYM,N
            END DO
          END DO
        END DO
        WRITE(6,*)' 3. CLOSED LOOPS.'
        DO IP=1,NLEV
         DO IQ=1,IP
          INDEO=2*NLEV+(IP*(IP-1))/2+IQ
          DO MV=1,NMIDV
            DO LFTSYM=1,NSYM
              N=NOCP(INDEO,LFTSYM,MV)
              WRITE(6,'(7(1X,I5),1X,F10.7)') IP,IQ,MV,LFTSYM,N
            END DO
          END DO
         END DO
        END DO
      END IF
      IF(IPGLOB.GE.INSANE) THEN
        WRITE(6,*)
        WRITE(6,*)' COUPLING COEFFICIENTS:'
        WRITE(6,*)'    IP    IQ    MV LFTSYM ICOP   ICOUP1&2   COUP'
        WRITE(6,*)' 1. OPEN LOOPS TYPE 1.'
        DO IP=1,NLEV
          DO MV=1,NMIDV
            DO LFTSYM=1,NSYM
              N=NOCP(IP,LFTSYM,MV)
              ICOP=IOCP(IP,LFTSYM,MV)
              DO I=1,N
                ICOP=ICOP+1
                ICP1=ICOUP(1,ICOP)
                ICP2=ICOUP(2,ICOP)
                CP=VTAB(ICOUP(3,ICOP))
                WRITE(6,'(6X,6(1X,I5),1X,F10.7)')
     &          IP,MV,LFTSYM,ICOP,ICP1,ICP2,CP
              END DO
            END DO
          END DO
        END DO
        WRITE(6,*)' 2. OPEN LOOPS TYPE 2.'
        DO IP=1,NLEV
          INDEO=NLEV+IP
          DO MV=1,NMIDV
            DO LFTSYM=1,NSYM
              N=NOCP(INDEO,LFTSYM,MV)
              ICOP=IOCP(INDEO,LFTSYM,MV)
              DO I=1,N
                ICOP=ICOP+1
                ICP1=ICOUP(1,ICOP)
                ICP2=ICOUP(2,ICOP)
                CP=VTAB(ICOUP(3,ICOP))
                WRITE(6,'(6X,6(1X,I5),1X,F10.7)')
     &            IP,MV,LFTSYM,ICOP,ICP1,ICP2,CP
              END DO
            END DO
          END DO
        END DO
        WRITE(6,*)' 3. CLOSED LOOPS.'
        DO IP=1,NLEV
         DO IQ=1,IP
          INDEO=2*NLEV+(IP*(IP-1))/2+IQ
          DO MV=1,NMIDV
            DO LFTSYM=1,NSYM
              N=NOCP(INDEO,LFTSYM,MV)
              ICOP=IOCP(INDEO,LFTSYM,MV)
              DO I=1,N
                ICOP=ICOP+1
                ICP1=ICOUP(1,ICOP)
                ICP2=ICOUP(2,ICOP)
                CP=VTAB(ICOUP(3,ICOP))
                WRITE(6,'(7(1X,I5),1X,F10.7)')
     &            IP,IQ,MV,LFTSYM,ICOP,ICP1,ICP2,CP
              END DO
            END DO
          END DO
         END DO
        END DO
      END IF
      IF(IPGLOB.GE.INSANE) THEN
      WRITE(6,*)
      WRITE(6,*)' CONVENTIONAL NR OF COUPLING COEFFS, BY PAIR:'
      NRC=0
      DO IP=2,MIDLEV
        DO IQ=1,IP-1
          NRCPQ=0
          INDEO=2*NLEV+(IP*(IP-1))/2+IQ
          DO LFTSYM=1,NSYM
            ISYM=LFTSYM
            DO MV=1,NMIDV
              NRCPQ=NRCPQ+NOCP(INDEO,LFTSYM,MV)*NOW(1,ISYM,MV)
           END DO
          END DO
          WRITE(6,'(1X,2I5,5X,I9)') IP,IQ,NRCPQ
          NRC=NRC+NRCPQ
        END DO
      END DO
      DO IP=MIDLEV+1,NLEV
        DO IQ=1,MIDLEV
          NRCPQ=0
          DO LFTSYM=1,NSYM
            ISYM=LFTSYM
            DO MV=1,NMIDV
              NRCPQ=NRCPQ+NOCP(IP,LFTSYM,MV)*NOCP(IQ,ISYM,MV)
              NRCPQ=NRCPQ+NOCP(NLEV+IP,LFTSYM,MV)*NOCP(NLEV+IQ,ISYM,MV)
           END DO
          END DO
          WRITE(6,'(1X,2I5,5X,I9)') IP,IQ,NRCPQ
          NRC=NRC+NRCPQ
        END DO
      END DO
      DO IP=MIDLEV+2,NLEV
        DO IQ=MIDLEV+1,IP-1
          NRCPQ=0
          INDEO=2*NLEV+(IP*(IP-1))/2+IQ
          DO LFTSYM=1,NSYM
            ISYM=LFTSYM
            DO MV=1,NMIDV
              NRCPQ=NRCPQ+NOCP(INDEO,LFTSYM,MV)*NOW(2,ISYM,MV)
           END DO
          END DO
          WRITE(6,'(1X,2I5,5X,I9)') IP,IQ,NRCPQ
          NRC=NRC+NRCPQ
        END DO
      END DO
      WRITE(6,*)
      WRITE(6,*)' TOTAL CONVENTIONAL COUPLING COEFFS:',NRC
      END IF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_REOVEC(IRS2F,N,LRDIM,WRK,LWRK)
!
! Purpose: reorder Cholesky vectors on disk to full storage.

use Index_Functions, only: iTri
use Cholesky, only: iBas, nBas, mmBstRT, nnBstRT
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, LRDIM, LWRK
integer(kind=iwp), intent(out) :: IRS2F(N,LRDIM)
real(kind=wp), intent(inout) :: WRK(LWRK)
integer(kind=iwp) :: IA, IB, IRS1, ISYMA, ISYMB, JA, JAB, JB
character(len=*), parameter :: SECNAM = 'CHO_REOVEC'
integer(kind=iwp), external :: CHO_ISAO

! Set up mapping from rs1 to full storage.
! ----------------------------------------

if (N < 3) call CHO_QUIT('Dimension error [1] in '//SECNAM,104)
if (LRDIM /= MMBSTRT) call CHO_QUIT('Dimension error [2] in '//SECNAM,104)
call CHO_RSTOF(IRS2F,N,MMBSTRT,1)
do IRS1=1,NNBSTRT(1)
  IA = IRS2F(1,IRS1)
  IB = IRS2F(2,IRS1)
  ISYMA = CHO_ISAO(IA)
  ISYMB = CHO_ISAO(IB)
  JA = IA-IBAS(ISYMA)
  JB = IB-IBAS(ISYMB)
  if (ISYMA == ISYMB) then
    JAB = ITRI(JA,JB)
  else
    JAB = NBAS(ISYMA)*(JB-1)+JA
  end if
  IRS2F(1,IRS1) = ISYMA
  IRS2F(2,IRS1) = ISYMB
  IRS2F(3,IRS1) = JAB
end do

! Set up index arrays and open files for storing full vectors.
! ------------------------------------------------------------

call CHO_REOINI()

! Reorder vectors on disk.
! ------------------------

call CHO_REOVC1(IRS2F,N,LRDIM,WRK,LWRK)

end subroutine CHO_REOVEC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine tetin(lmax)
      Implicit Real*8(A-H,O-Z)
#include "real.fh"
#include "welcom.fh"
*
      Do 100 k=0,lmax
         lm2=k/2
         Do 110 l=0,lm2
            tetint(k,l)=Zero
            m=k-l*2
            Do 120 i=0,l
               tetint(k,l)=tetint(k,l)+binom(l,i)*(-One)**i
     &                    / DBLE(m+i*2+1)
120         Continue
110      Continue
100   Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_VecBuf_Final()
C
C     Purpose: deallocate and finalize vector buffer.
C
      use ChoVecBuf, only: CHVBUF, ip_CHVBUF_SYM, l_CHVBUF_SYM,
     &                     CHVBFI, ip_CHVBFI_SYM, l_CHVBFI_SYM,
     &                     nVec_in_Buf
      Implicit None
#include "cholesky.fh"
#include "stdalloc.fh"

      If (Allocated(CHVBUF)) Call mma_deallocate(CHVBUF)
      If (Allocated(CHVBFI)) Call mma_deallocate(CHVBFI)

      Call iZero(ip_ChVBuf_Sym,nSym)
      Call iZero(l_ChVBuf_Sym,nSym)
      Call iZero(ip_ChVBFI_Sym,nSym)
      Call iZero(l_ChVBFI_Sym,nSym)
      Call iZero(nVec_in_Buf,nSym)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine Precaii(iB,is,js,nd,rOut,nbaj,fockii,fockai,fockti,focki,focka,Sgn,A_J,A_K,Scr,nScr)
!***********************************************************************
!                                                                      *
!                                        [2]                           *
!   Calculates the diagonal submatrix of E    that couple              *
!                                                                      *
!   kappa                with   kappa                for a             *
!        kactive,inactive            kactive,inactive                  *
!                                                                      *
!   single active index.                                               *
!   Used for preconditioner.                                           *
!                                                                      *
!   See Olsen,Yeager, Joergensen:                                      *
!    "Optimization and characterization of an MCSCF state"             *
!                                                                      *
!     Eq. C.12a                                                        *
!                                                                      *
!   Called by prec                                                     *
!                                                                      *
!   ib,is       :       active index for the submatrix                 *
!   js          :       symmetry of inactive,inactive                  *
!   rOut        :       Submatrix                                      *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: G1t, G2t, nA
use input_mclr, only: nAsh, nBas, nIsh, nSym
use Constants, only: Two, Four, Seven
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iB, is, js, nd, nbaj, nScr
real(kind=wp), intent(inout) :: rout(nTri_Elem(nd))
real(kind=wp), intent(in) :: fockii, fockai, fockti, Focki(nbaj,nbaj), FockA(nBaj,nBaj), Sgn
real(kind=wp), intent(out) :: A_J(nScr), A_K(nScr), Scr(nScr)
integer(kind=iwp) :: i, iBB, iBC, iC, iCB, iCC, iCD, iiB, iiC, jA, jB, jC, jCC, jD, jDD, jjC, jjD, kS, nTri
real(kind=wp) :: BCij, BiCj, CDij, CiBj, CiDj, rDens, rDens1, rDens2, rFock

!                                                                      *
!***********************************************************************
!                                                                      *
nTri = nTri_Elem(nd)
iBB = ib+nA(is)
iiB = ib+nish(is)
!                                                                      *
!***********************************************************************
!                                                                      *
do jA=1,nIsh(jS)
  do jB=1,jA

    i = nTri-iTri(nd-ja+1,nd-jb+1)+1

    do kS=1,nSym

      call Coul(kS,kS,jS,jS,jA,jB,A_J,Scr)
      call Exch(kS,jS,kS,jS,jA,jB,A_K,Scr)

      do jC=1,nAsh(ks)
        jCC = jC+nA(ks)
        jjC = jC+nIsh(ks)
        do jD=1,nAsh(kS)
          jDD = jD+nA(ks)
          jjD = jD+nIsh(ks)

          ! gamma(cdbb)=gamma(bbcd)

          rDens1 = Sgn*G2t(iTri(iTri(jCC,jDD),nTri_Elem(iBB)))

          ! gamma(bdcb)

          rDens2 = Sgn*G2t(iTri(iTri(iBB,jDD),iTri(jCC,iBB)))

          ! (cd|ij)

          icd = (jjD-1)*nBas(kS)+jjC
          cdij = A_J(icd)
          cidj = A_K(icd)
          ! is the coefficient opposite?
          rout(i) = rout(i)+Two*(rDens2*cidj+Two*rDens1*cdij)
          !rout(i) = rout(i)+Two*(rDens1*cdij+Two*rDens2*cidj)
        end do
      end do
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
do iC=1,nAsh(is)
  iCC = ic+nA(is)
  iiC = iC+nIsh(is)

  ! 2*(delta(bc)-D(bc))

  rDens = Sgn*(-G1t(iTri(iCC,iBB)))
  if (iCC == iBB) rdens = rdens+Sgn
  rDens = Two*rDens

  call Coul(jS,jS,iS,iS,iiB,iiC,A_J,Scr)
  call Exch(jS,iS,jS,iS,iiB,iiC,A_K,Scr)

  do jA=1,nIsh(jS)
    do jB=1,jA
      i = nTri-iTri(nd-jA+1,nd-jB+1)+1

      ! (ci|bj)
      ! (bi|cj)

      icb = (jB-1)*nBas(jS)+jA
      ibc = (jA-1)*nBas(jS)+jB
      cibj = A_K(icb)
      bicj = A_K(ibc)

      ! (bc|ij)

      bcij = A_J(ibc)

      rout(i) = rout(i)+rdens*(Seven*cibj-Sgn*(bicj+Two*bcij))

    end do
  end do

end do
!                                                                      *
!***********************************************************************
!                                                                      *
rFock = Sgn*(Two*(Fockii+Fockai)-Fockti)
rdens = Sgn*Two*G1t(nTri_Elem(ibb))
i = 0 ! dummy initialize

do jA=1,nIsh(jS)
  do jB=1,jA

    i = nTri-iTri(nd-ja+1,nd-jb+1)+1

    rout(i) = rout(i)-Sgn*Four*(Focka(jA,jB)+Focki(jA,jB))+rdens*Focki(ja,jb)
  end do
  rout(i) = rout(i)+Two*rfock
end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Precaii

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GTDMCTL(PROP,JOB1,JOB2,OVLP,DYSAMPS,NZ,IDISK)

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: MUL, nIrrep
use frenkel_global_vars, only: DoCoul
use sguga, only: CIStruct, EXStruct, SG_Free, SGStruct
use mspt2_eigenvectors, only: Heff_evc_pc, Heff_evc_sc, prpdata_mspt2_eigenvectors
use rasdef, only: NRAS, NRASEL, NRS1, NRS1T, NRS2, NRS2T, NRS3, NRS3T, NRSPRT
use rasscf_global, only: DoDMRG
use rassi_aux, only: AO_Mode, iDisk_TDM, ipglob, jDisk_TDM
use rassi_data, only: ENUC, NASH, NASHT, NCMO, NDEL, NFRO, NISH, NISHT, NOSH, NSSH, NTDMAB, NTDMZZ, NTRA
use rassi_global_arrays, only: CnfTab1, CnfTab2, FSBTAB1, FSBTAB2, HAM, OrbTab, PART, REST1, REST2, SFDYS, SPNTAB1, SPNTAB2, &
                               SSTAB, TRANS1, TRANS2
use Cntrl, only: CITHR, DCHO, DCHS, DOGSOR, DYSO, ERFNUC, IFEJOB, IFHAM, IFHEFF, IFHEXT, IFNTO, IFTRD1, IFTRD2, IRREP, ISTAT, &
                 iToc15, JBNAME, LSYM1, LSYM2, LuIph, LuTDM, MLTPLT, NACTE, NATO, NCONF1, NDET, NELE3, NHOLE1, NPROP, NSTAT, &
                 NSTATE, PRCI, QDPT2EV, QDPT2SC, RASTYP, SAVEDENS, SECOND_TIME, TDYS, sonatnstate
#ifdef _HDF5_
use mh5, only: mh5_put_dset
use Cntrl, only: CIH5
use RASSIWfn, only: wfn_CMO, wfn_CMO_OR, wfn_DetCoeff, wfn_DetCoeff_OR, wfn_DetOcc, wfn_DetOcc_OR
#endif
#ifdef _DMRG_
use qcmaquis_info, only: qcm_prefixes
use qcmaquis_interface_cfg, only: dmrg_external
use qcmaquis_interface_mpssi, only: qcmaquis_mpssi_overlap
use qcmaquis_interface_utility_routines, only: pretty_print_util
use rassi_global_arrays, only: LROOT
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, auToEV
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: PROP(NSTATE,NSTATE,NPROP), OVLP(NSTATE,NSTATE), DYSAMPS(NSTATE,NSTATE)
integer(kind=iwp), intent(in) :: JOB1, JOB2, NZ
integer(kind=iwp), intent(inout) :: IDISK
integer(kind=iwp) :: AUGSPIN, DCHIJ, I, IAD, IE1, IE1MN, IE1MX, IE2, IE2MN, IE2MX, IE3, IE3MN, IE3MX, IEMPTY, IERR, IFORM, IGO, &
                     IJ, IO, IOP1, IOP2, IOP3, IOPT, IRC, ISOIND, ISORB, ISPART, IST, ISTATE, ISUM, ISY, ISY12, ISYM, IT, ITABS, &
                     J, JST, JSTATE, JSY, KOINFO, KSPART, LSY, LUCITH, LUIPHn, MAXOP, MINOP, MPLET1, MPLET2, MSPROJ1, MSPROJ2, &
                     nActE1, NACTE2, NASHES(8), NASORB, NASPRT, NCONF2, NDCHSM, NDET1, NDET2, NDYSAB, NDYSZZ, NELE31, NELE32, &
                     NGAS, NGASLIM(2,10), NGASORB(100), NGL11, NGL12, NGL13, NGL21, NGL22, NGL23, NHOL11, NHOL12, NI, NJ, NL, NO, &
                     NPART, NRT2M, NRT2MAB, NTDM1, NTDM2, NTRAD
real(kind=wp) :: BEi, BEij, BEj, Dot_Prod, DYNORM, DYSAMP, ECORE, Energies(1:20), fac1, fac2, HII, HIJ, HJJ, HONE, HTWO, HZERO, &
                 Norm_fac, OVERLAP_RASSI, SIJ
real(kind=wp), pointer :: DET1(:), DET2(:)
logical(kind=iwp) :: DoNTO, IF00, IF01, IF02, IF10, IF11, IF12, IF20, IF21, IF22, IFTWO, mstate_dens, TRORB
character(len=48) :: STLNE2
character(len=8) :: WFTP1, WFTP2
type(CIStruct) :: CIS(2)
type(EXStruct) :: EXS(2)
type(SGStruct) :: SGS(2)
integer, allocatable :: OMAP(:)
real(kind=wp), allocatable :: CI1(:), CI2(:), CI2_o(:), CMO1(:), CMO2(:), DCHSM(:), detcoeff1(:), detcoeff2(:), DYSAB(:), &
                              DYSCOF(:), DYSZZ(:), FMO(:), mixed_1p_overlap(:,:), mixed_1p_rtdm(:,:,:), mixed_1p_stdm(:,:,:), &
                              mixed_1p_wtdm(:,:,:), RT2M(:), RT2MAB(:), TDM2(:), TDMAB(:), TDMZZ(:), Theta1(:), ThetaM(:), &
                              ThetaN(:), TRA1(:), TRA2(:), TRAD(:), TRASD(:), TSDMAB(:), TSDMZZ(:), TUVX(:), WDMAB(:), WDMZZ(:), &
                              WERD(:)
real(kind=wp), allocatable, target :: DETTOT1(:,:), DETTOT2(:,:)
character(len=NASHT+1), allocatable :: detocc(:)
integer(kind=iwp), external :: IsFreeUnit
real(kind=wp), external :: DDot_

#define _TIME_GTDM
#ifdef _TIME_GTDM_
call CWTime(TCpu1,TWall1)
#endif

! WF parameters for ISTATE and JSTATE

NACTE1 = NACTE(JOB1)
MPLET1 = MLTPLT(JOB1)
LSYM1 = IRREP(JOB1)
NHOL11 = NHOLE1(JOB1)
NELE31 = NELE3(JOB1)
WFTP1 = RASTYP(JOB1)
NACTE2 = NACTE(JOB2)
MPLET2 = MLTPLT(JOB2)
LSYM2 = IRREP(JOB2)
NHOL12 = NHOLE1(JOB2)
NELE32 = NELE3(JOB2)
WFTP2 = RASTYP(JOB2)
SGS(1)%IFRAS = 1
SGS(2)%IFRAS = 1
if (IPGLOB >= 4) then
  write(u6,*) ' Entered GTDMCTL.'
  write(u6,'(1X,A,I3,A,I3)') '  JOB1:',JOB1,'        JOB2:',JOB2
  write(u6,'(1X,A,I3,A,I3)') 'NACTE1:',NACTE1,'      NACTE2:',NACTE2
  write(u6,'(1X,A,I3,A,I3)') 'MPLET1:',MPLET1,'      MPLET2:',MPLET2
  write(u6,'(1X,A,I3,A,I3)') ' LSYM1:',LSYM1,'       LSYM2:',LSYM2
  write(u6,'(1X,A,A8,A,A8)') ' WFTP1:',WFTP1,'       WFTP2:',WFTP2
  write(u6,'(1X,A,I3,A,I3)') ' NPROP:',NPROP
end if

if (doDMRG .and. (nacte1 /= nacte2)) then
  call WarningMessage(2,'Problem in gtdmctl for MPS-SI: no match for #e- in bra/ket')
  call abend()
end if

!> Logical variables, controlling which GTDM's to compute

!>  Overlap
IF00 = (NACTE1 == NACTE2) .and. (MPLET1 == MPLET2)
IF00 = IF00 .and. (LSYM1 == LSYM2)

!> Dyson amplitudes
IF10 = (NACTE1-NACTE2) == 1
IF10 = IF10 .and. (abs(MPLET1-MPLET2) == 1)
IF01 = (NACTE1-NACTE2) == -1
IF01 = IF01 .and. (abs(MPLET1-MPLET2) == 1)

!> Pair amplitudes:
IF20 = (NACTE1-NACTE2) == 2
IF02 = (NACTE1-NACTE2) == -2

!> 1-TDMs and transition spin densities
IF11 = (NACTE1 == NACTE2) .and. (NACTE1 >= 1)
IF11 = IF11 .and. (abs(MPLET1-MPLET2) <= 2)

!> 2h1p and 1h2p amplitudes:
IF21 = IF10 .and. (NACTE2 >= 1)
IF21 = IF21 .and. (abs(MPLET1-MPLET2) <= 3)
IF12 = IF01 .and. (NACTE1 >= 1)
IF12 = IF12 .and. (abs(MPLET1-MPLET2) <= 3)

!> 2-TDMs and transition spin densities
IF22 = (NACTE1 == NACTE2) .and. (NACTE1 >= 2)
IF22 = IF22 .and. (abs(MPLET1-MPLET2) <= 4)

!> check if they are needed at all:
!> It may be that the Hamiltonian matrix should be used in
!> diagonalization (IFHAM is .TRUE.), but it does not have
!> to be computed (because IFHEXT or IFHEFF or IFEJOB are true).
IFTWO = IFHAM .and. (.not. (IFHEXT .or. IFHEFF .or. IFEJOB))

!> For the moment, we have no use for the two-electron density
!> except when used for the scalar two-body Hamiltonian matrix:
IF22 = IF22 .and. IFTWO .and. (MPLET1 == MPLET2) .and. (LSYM1 == LSYM2)

if (IPGLOB >= 4) then
  if (IF00) write(u6,*) ' Overlap will be computed.'
  if (IF10 .or. IF01) write(u6,*) ' Dyson orbital will be computed.'
  if (IF20 .or. IF02) write(u6,*) ' Pair amplitudes will be computed.'
  if (IF11) write(u6,*) ' Density 1-matrix will be computed.'
  if (IF21 .or. IF12) write(u6,*) ' 2h1p amplitudes will be computed.'
  if (IF22) write(u6,*) ' Density 2-matrix will be computed.'
end if

! Pick up orbitals of ket and bra states.
call mma_allocate(CMO1,nCMO,Label='CMO1')
call mma_allocate(CMO2,nCMO,Label='CMO2')
call RDCMO_RASSI(JOB1,CMO1)
call RDCMO_RASSI(JOB2,CMO2)

! Nr of active spin-orbitals
NASORB = 2*NASHT
NTDM1 = NASHT**2
NTDM2 = nTri_Elem(NTDM1)

! Size of some data sets of reduced-2TDM in terms of active
! orbitals NASHT (For Auger matrix elements):
NRT2M = NASHT**3
! Size of Symmetry blocks
ISY12 = MUL(LSYM1,LSYM2)
NRT2MAB = 0
do ISY=1,nIrrep
  NI = NOSH(ISY)
  if (NI == 0) cycle
  do JSY=1,nIrrep
    NJ = NOSH(JSY)
    if (NJ == 0) cycle
    do LSY=1,nIrrep
      NL = NOSH(LSY)
      if (NL == 0) cycle
      if (MUL(ISY,MUL(JSY,LSY)) == ISY12) NRT2MAB = NRT2MAB+NI*NJ*NL
    end do
  end do
end do
if (TDYS .and. (.not. DYSO)) then
  write(u6,*)
  write(u6,*) 'Auger (TDYS) requires Dyson calculation.'
  write(u6,*) 'Make sure to activate Dyson in your RASSI input.'
  write(u6,*) 'For now, Auger computation will be skipped.'
end if
! evaluation of DCH
if (DCHS) NDCHSM = NASHT**2

! +++ J. Norell 13/7 - 2018
! 1D arrays for Dyson orbital coefficients
! COF = active biorthonormal orbital base
! AB  = inactive+active biorthonormal orbital base
! ZZ  = atomic (basis function) base
if ((IF10 .or. IF01) .and. DYSO) then
  call mma_allocate(DYSCOF,NASORB,Label='DYSCOF')
  ! Number of inactive+active orbitals
  NDYSAB = NASHT+NISHT
  call mma_allocate(DYSAB,nDYSAB,Label='DYSAB')
  ! Number of atomic / basis functions
  NDYSZZ = NZ
  call mma_allocate(DYSZZ,nDYSZZ,Label='DYSZZ')
  DYSZZ(:) = Zero
end if
! +++

! Transition density matrices, TDMAB is for active biorthonormal
! orbitals only, while TDMZZ is in the fixed AO basis.
! WDMAB, WDMZZ similar, but WE-reduced 'triplet' densities.
if (IF11 .and. (NATO .or. (NPROP > 0))) then
  call mma_allocate(TDMAB,nTDMAB,Label='TDMAB')
  call mma_allocate(TSDMAB,nTDMAB,Label='TSDMAB')
  call mma_allocate(WDMAB,nTDMAB,Label='WDMAB')
  call mma_allocate(TDMZZ,nTDMZZ,Label='TDMZZ')
  call mma_allocate(TSDMZZ,nTDMZZ,Label='TSDMZZ')
  call mma_allocate(WDMZZ,nTDMZZ,Label='WDMZZ')
end if

if (IF11) then
  NTRAD = NASHT**2 ! NTRAD == NWERD == NTRASD
  call mma_allocate(TRAD,nTRAD+1,Label='TRAD')
  call mma_allocate(TRASD,nTRAD+1,Label='TRASD')
  call mma_allocate(WERD,nTRAD+1,Label='WERD')
end if
if (IF22) then
  call mma_allocate(TDM2,nTDM2,Label='TDM2')
else
  ! To avoid passing an unallocated argument
  call mma_allocate(TDM2,0,Label='TDM2')
end if

if (JOB1 /= JOB2) then
  ! Transform to biorthonormal orbital system
  if (DoGSOR) then
    call FCopy(trim(JBNAME(JOB2)),'JOBGS',ierr)
    call DANAME(LUIPH,'JOBGS')
    IAD = 0
    call IDAFile(LUIPH,2,ITOC15,30,IAD)
    IAD = ITOC15(2)
    call DDAFile(LUIPH,1,CMO2,nCMO,IAD)
    call DACLOS(LUIPH)
  end if !DoGSOR

  call mma_allocate(TRA1,nTRA,Label='TRA1')
  call mma_allocate(TRA2,nTRA,Label='TRA2')
  call FINDT(CMO1,CMO2,TRA1,TRA2)
# ifdef _HDF5_
  ! put the pair of transformed orbitals to h5
  if (CIH5) then
    call mh5_put_dset(wfn_cmo,CMO1,[nCMO,1],[0,JOB1-1])
    call mh5_put_dset(wfn_cmo,CMO2,[nCMO,1],[0,JOB2-1])
  end if
# endif
  TRORB = .true.
else
# ifdef _HDF5_
  ! put original orbitals to hdf5 file
  if (CIH5) call mh5_put_dset(wfn_cmo_or,CMO1,[nCMO,1],[0,JOB1-1])
# endif
  TRORB = .false.
end if

!> check whether we do RASSI with an effective multi-state PT2 Hamiltonian
!> whose eigenvectors are stored in Heff_evc_pc/Heff_evc_sc
!> i.e., we do not use mixed CI coefficients / MPS wave functions but rather mix the TDMs

mstate_dens = (job1 == job2) .and. (allocated(Heff_evc_pc) .or. allocated(Heff_evc_sc))
mstate_dens = mstate_dens .and. if11
mstate_dens = mstate_dens .and. qdpt2ev

if (mstate_dens) then
  call mma_allocate(mixed_1p_overlap,nstat(job1),nstat(job1),Label='mixed_1p_overlap')
  call mma_allocate(mixed_1p_rtdm,NTDMZZ,nstat(job1),nstat(job1),Label='mixed_1p_rtdm')
  call mma_allocate(mixed_1p_stdm,NTDMZZ,nstat(job1),nstat(job1),Label='mixed_1p_stdm')
  call mma_allocate(mixed_1p_wtdm,NTDMZZ,nstat(job1),nstat(job1),Label='mixed_1p_wtdm')
  mixed_1p_rtdm(:,:,:) = 0
  mixed_1p_stdm(:,:,:) = 0
  mixed_1p_wtdm(:,:,:) = 0
  mixed_1p_overlap(:,:) = 0
end if

#ifdef _DMRG_
dmrg_external%MPSrotated = trorb
#endif

! OBTAIN CORE ENERGY, FOCK MATRIX, AND TWO-ELECTRON INTEGRALS
! IN THE MIXED ACTIVE MO BASIS:
ECORE = Zero
if (IFTWO .and. (MPLET1 == MPLET2)) then
  call mma_allocate(FMO,nTDM1,Label='FMO')
  call mma_allocate(TUVX,nTDM2,Label='TUVX')
  TUVX(:) = Zero
  !TEST  write(u6,*) 'GTDMCTL calling TRINT.'
  call TRINT(CMO1,CMO2,ECORE,nTDM1,FMO,nTDM2,TUVX)
  ECORE = ENUC+ERFNUC+ECORE
  !TEST  write(u6,*) 'GTDMCTL back from TRINT.'
  !TEST  write(u6,*) 'ENUC  =',ENUC
  !TEST  write(u6,*) 'ERFNUC=',ERFNUC
  !TEST  write(u6,*) 'ECORE =',ECORE
end if

! In the calculation of matrix elements ( S1, S2 ), we will use
! the same Ms quantum numbers, if S1 and S2 differ by 0 or an int,
! else we will use Ms quantum numbers that differ by 1/2:
if (mod(abs(MPLET1-MPLET2),2) == 0) then
  MSPROJ1 = min(MPLET1,MPLET2)-1
  MSPROJ2 = MSPROJ1
else
  if (MPLET1 > MPLET2) then
    MSPROJ2 = MPLET2-1
    MSPROJ1 = MSPROJ2+1
  else
    MSPROJ1 = MPLET1-1
    MSPROJ2 = MSPROJ1+1
  end if
end if

#ifdef _DMRG_
!> set spin-up/spin-down # of electrons for target state(s)
if (doDMRG) then
  dmrg_external%nalpha = (nacte1+msproj1)/2
  dmrg_external%nbeta = (nacte1-msproj1)/2
end if
#endif

!---------------  For all wave functions: ---------------------
! Define structures ('tables') pertinent all jobs.
! (Later, move this up before the GTDMCTL calls).
! These are at:
! PART
! ORBTAB
! SSTAB
call NEWPRTTAB(nIrrep,NFRO,NISH,NRS1,NRS2,NRS3,NSSH,NDEL)
if (IPGLOB >= 4) call PRPRTTAB(PART)

call NEWORBTAB(PART)
if (IPGLOB >= 4) call PRORBTAB(ORBTAB)

call NEWSSTAB(ORBTAB)
if (IPGLOB >= 4) call PRSSTAB(SSTAB)

! Mapping from active spin-orbital to active orbital in external order.
! Note that these differ, not just because of the existence of two
! spin-orbitals for each orbital, but also because the active orbitals
! (external order) are grouped by symmetry and then RAS space, but the
! spin orbitals are grouped by subpartition.
call mma_allocate(OMAP,NASORB,Label='OMAP')
NASPRT = ORBTAB(9)
KSPART = ORBTAB(10)
KOINFO = 19
ISUM = 0
do ISYM=1,nIrrep
  NASHES(ISYM) = ISUM
  ISUM = ISUM+NASH(ISYM)
end do
ISORB = 0
do ISPART=1,NASPRT
  NO = OrbTab(KSPART-1+ISPART)
  do IO=1,NO
    ISORB = ISORB+1
    ! Orbital symmetry:
    ISYM = OrbTab(KOINFO+1+(ISORB-1)*8)
    ! In-Symmetry orbital index:
    ISOIND = OrbTab(KOINFO+2+(ISORB-1)*8)
    ! Subtract nr of inactive orbitals in that symmetry:
    IT = ISOIND-NISH(ISYM)
    ! Add nr of actives in earlier symmetries:
    ITABS = NASHES(ISYM)+IT
    OMAP(ISORB) = ITABS
  end do
end do

!---------------    JOB1 wave functions: ---------------------
! Initialize SGUGA tables for JOB1 functions.
! These are structures stored in user defined types:
! SGS(1),CIS(1) and EXS(1).

! Set variables in /RASDEF/, used by SGUGA codes, which define
! the SGUGA space of JOB1. General RAS:
if (WFTP1 == 'GENERAL') then
  NRSPRT = 3
  NRAS(:,1) = NRS1(:)
  NRAS(:,2) = NRS2(:)
  NRAS(:,3) = NRS3(:)
  NRASEL(1) = 2*NRS1T-NHOL11
  NRASEL(2) = NACTE1-NELE31
  NRASEL(3) = NACTE1

  if (.not. doDMRG) then
    call SG_Setup_RASSI(nIrrep,NACTE1,MPLET1,SGS(1),CIS(1))
    if (IPGLOB > 4) then
      write(u6,*) 'Split-graph structure for JOB1=',JOB1
      call SG_Print(SGS(1))
    end if
    call SG_CXInit(SGS(1),CIS(1),EXS(1))
    ! CI sizes, as function of symmetry, are now known.
    NCONF1 = CIS(1)%NCSF(LSYM1)
  else
    NCONF1 = 1
  end if
else
  ! Presently, the only other cases are HISPIN, CLOSED or EMPTY.
  ! Note: the HISPIN case may be buggy and is not used presently.
  NCONF1 = 1
end if
call mma_allocate(CI1,NCONF1,Label='CI1')

! Still JOB1, define structures ('tables') pertinent to JOB1
! These are at:
! REST1
! CNFTAB1
! FSBTAB1
! SPNTAB1

NPART = 3
NGAS = NPART
do ISYM=1,nIrrep
  NGASORB(1:nIrrep) = NRS1(1:nIrrep)
  NGASORB(nIrrep+1:2*nIrrep) = NRS2(1:nIrrep)
  NGASORB(2*nIrrep+1:3*nIrrep) = NRS3(1:nIrrep)
end do

!PAM2008: The old MAXOP was far too generous:
!MAXOP = NASHT
!PAM2008: MAXOP is determined by RAS restrictions:
! Preliminary ranges of nr of electrons:
IE1MN = max(0,2*NRS1T-NHOL11)
IE1MX = 2*NRS1T
IE3MN = max(0,NACTE1-IE1MX-2*NRS2T)
IE3MX = min(2*NRS3T,NELE31)
IE2MN = max(0,NACTE1-IE1MX-IE3MX)
IE2MX = min(2*NRS2T,NACTE1-IE1MN-IE3MN)
! Preliminary NGASLIM:
NGL11 = IE1MX
NGL21 = IE1MN
NGL12 = IE2MX
NGL22 = IE2MN
NGL13 = IE3MX
NGL23 = IE3MN
! Start with MAXOP=0, then increase:
MAXOP = 0
! Loop over possible ranges:
do IE1=IE1MN,IE1MX
  IOP1 = min(IE1,(2*NRS1T-IE1))
  if (IOP1 >= 0) then
    do IE3=IE3MN,IE3MX
      IOP3 = min(IE3,(2*NRS3T-IE3))
      if (IOP3 >= 0) then
        IE2 = NACTE1-IE1-IE3
        IOP2 = min(IE2,(2*NRS2T-IE2))
        if (IOP2 >= 0) then
          ! Actually possible combination:
          MAXOP = max(MAXOP,IOP1+IOP2+IOP3)
          NGL11 = min(NGL11,IE1)
          NGL21 = max(NGL21,IE1)
          NGL12 = min(NGL12,IE2)
          NGL22 = max(NGL22,IE2)
          NGL13 = min(NGL13,IE3)
          NGL23 = max(NGL23,IE3)
        end if
      end if
    end do
  end if
end do
NGASLIM(1,1) = NGL11
NGASLIM(2,1) = NGL21
NGASLIM(1,2) = NGL12
NGASLIM(2,2) = NGL22
NGASLIM(1,3) = NGL13
NGASLIM(2,3) = NGL23

if (.not. doDMRG) then
  IFORM = 1
  MINOP = 0
  call NEWGASTAB(nIrrep,NGAS,NGASORB,NGASLIM,1)
  if (IPGLOB >= 4) call PRGASTAB(REST1)

  ! At present, we will only annihilate, at most 2 electrons will
  ! be removed. This limits the possible MAXOP:
  MAXOP = min(MAXOP+1,NACTE1,NASHT)
  call NEWCNFTAB(NACTE1,NASHT,MINOP,MAXOP,LSYM1,NGAS,NGASORB,NGASLIM,IFORM,1)
  if (IPGLOB >= 4) call PRCNFTAB(CNFTAB1,100)

  call NEWFSBTAB(NACTE1,MSPROJ1,LSYM1,REST1,SSTAB,1)
  if (IPGLOB >= 4) call PRFSBTAB(FSBTAB1)
  NDET1 = FSBTAB1(5)
  if (ndet1 /= ndet(job1)) ndet(job1) = ndet1
  call NEWSCTAB(MINOP,MAXOP,MPLET1,MSPROJ1,1)
  if (IPGLOB > 4) then
    !PAM2009: Put in impossible call to PRSCTAB, just so code analyzers
    ! do not get their knickers into a twist.
    call PRSCTAB(SPNTAB1,TRANS1)
  end if
else
  NDET1 = 1 ! minimum to avoid runtime error
end if
!---------------    JOB2 wave functions: ---------------------
! Initialize SGUGA tables for JOB2 functions.
! These are structures stored in arrays:
! SGS(2),CIS(2) and EXS(2).

! Set variables in /RASDEF/, used by SGUGA codes, which define
! the SGUGA space of JOB1. General RAS:
if (WFTP2 == 'GENERAL') then
  NRSPRT = 3
  NRAS(:,1) = NRS1(:)
  NRAS(:,2) = NRS2(:)
  NRAS(:,3) = NRS3(:)
  NRASEL(1) = 2*NRS1T-NHOL12
  NRASEL(2) = NACTE2-NELE32
  NRASEL(3) = NACTE2

  if (.not. doDMRG) then
    call SG_Setup_RASSI(nIrrep,NACTE2,MPLET2,SGS(2),CIS(2))
    if (IPGLOB > 4) then
      write(u6,*) 'Split-graph structure for JOB2=',JOB2
      call SG_Print(SGS(2))
    end if
    call SG_CXInit(SGS(2),CIS(2),EXS(2))
    ! CI sizes, as function of symmetry, are now known.
    NCONF2 = CIS(2)%NCSF(LSYM2)
  else
    NCONF2 = 1
  end if
else
  ! Presently, the only other cases are HISPIN, CLOSED or EMPTY.
  ! Note: the HISPIN case may be buggy and is not used presently.
  NCONF2 = 1
end if
call mma_allocate(CI2,NCONF2,Label='CI2')
if (DoGSOR) call mma_allocate(CI2_o,NCONF2,Label='CI2_o')

NPART = 3
NGAS = NPART
do ISYM=1,nIrrep
  NGASORB(1:nIrrep) = NRS1(1:nIrrep)
  NGASORB(nIrrep+1:2*nIrrep) = NRS2(1:nIrrep)
  NGASORB(2*nIrrep+1:3*nIrrep) = NRS3(1:nIrrep)
end do
!PAM2008: The old MAXOP was far too generous:
!MAXOP = NASHT
!PAM2008: MAXOP is determined by RAS restrictions:
! Preliminary ranges of nr of electrons:
IE1MN = max(0,2*NRS1T-NHOL12)
IE1MX = 2*NRS1T
IE3MN = max(0,NACTE2-IE1MX-2*NRS2T)
IE3MX = min(2*NRS3T,NELE32)
IE2MN = max(0,NACTE2-IE1MX-IE3MX)
IE2MX = min(2*NRS2T,NACTE2-IE1MN-IE3MN)
! Preliminary NGASLIM:
NGL11 = IE1MX
NGL21 = IE1MN
NGL12 = IE2MX
NGL22 = IE2MN
NGL13 = IE3MX
NGL23 = IE3MN
! Start with MAXOP=0, then increase:
MAXOP = 0
! Loop over possible ranges:
do IE1=IE1MN,IE1MX
  IOP1 = min(IE1,(2*NRS1T-IE1))
  if (IOP1 >= 0) then
    do IE3=IE3MN,IE3MX
      IOP3 = min(IE3,(2*NRS3T-IE3))
      if (IOP3 >= 0) then
        IE2 = NACTE2-IE1-IE3
        IOP2 = min(IE2,(2*NRS2T-IE2))
        if (IOP2 >= 0) then
          ! Actually possible combination:
          MAXOP = max(MAXOP,IOP1+IOP2+IOP3)
          NGL11 = min(NGL11,IE1)
          NGL21 = max(NGL21,IE1)
          NGL12 = min(NGL12,IE2)
          NGL22 = max(NGL22,IE2)
          NGL13 = min(NGL13,IE3)
          NGL23 = max(NGL23,IE3)
        end if
      end if
    end do
  end if
end do
NGASLIM(1,1) = NGL11
NGASLIM(2,1) = NGL21
NGASLIM(1,2) = NGL12
NGASLIM(2,2) = NGL22
NGASLIM(1,3) = NGL13
NGASLIM(2,3) = NGL23

if (.not. dodmrg) then
  call NEWGASTAB(nIrrep,NGAS,NGASORB,NGASLIM,2)
  if (IPGLOB >= 4) call PRGASTAB(REST2)

  IFORM = 1
  MINOP = 0
  ! At present, we will only annihilate. This limits the possible MAXOP:
  MAXOP = min(MAXOP+1,NACTE2,NASHT)
  call NEWCNFTAB(NACTE2,NASHT,MINOP,MAXOP,LSYM2,NGAS,NGASORB,NGASLIM,IFORM,2)
  if (IPGLOB >= 4) call PRCNFTAB(CNFTAB2,100)

  call NEWFSBTAB(NACTE2,MSPROJ2,LSYM2,REST2,SSTAB,2)
  if (IPGLOB >= 4) call PRFSBTAB(FSBTAB2)
  NDET2 = FSBTAB2(5)
  if (ndet2 /= ndet(job2)) ndet(job2) = ndet2
  call NEWSCTAB(MINOP,MAXOP,MPLET2,MSPROJ2,2)
  !PAM2009: Put in impossible call to PRSCTAB, just so code analyzers
  ! do not get their knickers into a twist.
  if (IPGLOB > 4) call PRSCTAB(SPNTAB2,TRANS2)
else
  NDET2 = 1 ! minimum to avoid runtime error
end if
!-------------------------------------------------------------
call mma_allocate(DETTOT1,NDET1,NSTAT(JOB1),Label='DETTOT1')
call mma_allocate(DETTOT2,NDET2,NSTAT(JOB2),Label='DETTOT2')
call mma_allocate(detocc,max(nDet1,nDet2),label='detocc')

! Loop over the states of JOBIPH nr JOB1
do IST=1,NSTAT(JOB1)
  DET1 => DETTOT1(1:NDET1,IST)
  ISTATE = ISTAT(JOB1)-1+IST

  if (.not. doDMRG) then
    ! Read ISTATE wave function
    if (WFTP1 == 'GENERAL') then
      call READCI(ISTATE,SGS(1),CIS(1),NCONF1,CI1)
    else
      CI1(1) = One
    end if
    DET1(:) = Zero
    ! Transform to bion basis, Split-Guga format
    if (TrOrb) call CITRA(WFTP1,SGS(1),CIS(1),EXS(1),LSYM1,TRA1,NCONF1,CI1)
    call mma_allocate(detcoeff1,nDet1,label='detcoeff1')
    call PREPSD(WFTP1,SGS(1),CIS(1),LSYM1,CNFTAB1,SPNTAB1,SSTAB,FSBTAB1,NCONF1,CI1,DET1,detocc,detcoeff1,TRANS1)

    ! print transformed ci expansion
    if (JOB1 /= JOB2) then
      if (PRCI) call prwf_biorth(istate,job1,nconf1,ndet1,nasht,detocc,detcoeff1,cithr)
#     ifdef _HDF5_
      ! put transformed ci coefficients for JOB1 to h5
      if (CIH5) then
        call mh5_put_dset(wfn_detcoeff,detcoeff1,[nDet1,1],[0,istate-1])
        call mh5_put_dset(wfn_detocc,detocc(:nDet1),[nDet1,1],[0,(JOB1-1)])
      end if
    else
      ! JOB1=JOB2, put original ci coefficients for JOB1 to h5
      if (CIH5) then
        call mh5_put_dset(wfn_detcoeff_or,detcoeff1,[nDet1,1],[0,istate-1])
        call mh5_put_dset(wfn_detocc_or,detocc(:nDet1),[nDet1,1],[0,(JOB1-1)])
      end if
#     endif
    end if

    call mma_deallocate(detcoeff1)

# ifdef _DMRG_
  else ! doDMRG
    call prepMPS(TRORB,LROOT(ISTATE),LSYM1,MPLET1,MSPROJ1,NACTE1,TRA1,NTRA,NISH,NASH,NOSH,nIrrep,6,job1,ist)
# endif
  end if
end do

if (DoGSOR) then
  call mma_allocate(Theta1,NCONF2,Label='Theta1')
  Theta1(:) = Zero
end if

!-------------------------------------------------------------

do JST=1,NSTAT(JOB2)
  DET2 => DETTOT2(1:NDET2,JST)
  JSTATE = ISTAT(JOB2)-1+JST
  if (.not. doDMRG) then
    ! Read JSTATE wave function
    if (WFTP2 == 'GENERAL') then
      call READCI(JSTATE,SGS(2),CIS(2),NCONF2,CI2)
    else
      CI2(1) = One
    end if
    if (DoGSOR) CI2_o(:) = CI2(:)
    DET2(:) = Zero
    ! Transform to bion basis, Split-Guga format
    if (TrOrb) call CITRA(WFTP2,SGS(2),CIS(2),EXS(2),LSYM2,TRA2,NCONF2,CI2)
    call mma_allocate(detcoeff2,nDet2,label='detcoeff2')
    call PREPSD(WFTP2,SGS(2),CIS(2),LSYM2,CNFTAB2,SPNTAB2,SSTAB,FSBTAB2,NCONF2,CI2,DET2,detocc,detcoeff2,TRANS2)

    ! print transformed ci expansion
    if (JOB1 /= JOB2) then
      if (PRCI) call prwf_biorth(jstate,job2,nconf2,ndet2,nasht,detocc,detcoeff2,cithr)
#     ifdef _HDF5_
      ! put ci coefficients for JOB2 to h5
      if (CIH5) then
        call mh5_put_dset(wfn_detcoeff,detcoeff2,[nDet2,1],[0,jstate-1])
        call mh5_put_dset(wfn_detocc,detocc(:nDet2),[nDet2,1],[0,(JOB2-1)])
      end if
#     endif
    end if
    call mma_deallocate(detcoeff2)

  else
#   ifdef _DMRG_
    call prepMPS(TRORB,lroot(JSTATE),LSYM2,MPLET2,MSPROJ2,NACTE2,TRA2,NTRA,NISH,NASH,NOSH,nIrrep,6,job2,jst)
#   endif
  end if
end do

! Loop over the states of JOBIPH nr JOB2
job2_loop: do JST=1,NSTAT(JOB2)
  JSTATE = ISTAT(JOB2)-1+JST
  ! Loop over the states of JOBIPH nr JOB1
  job1_loop: do IST=1,NSTAT(JOB1)
    ISTATE = ISTAT(JOB1)-1+IST
    if (ISTATE < JSTATE) cycle
    !-------------------------------------------------------------------

    ! Entry into monitor: Status line
    write(STLNE2,'(A33,I5,A5,I5)') 'Trans. dens. matrices for states ',ISTATE,' and ',JSTATE
    call StatusLine('RASSI: ',STLNE2)

    ! Read ISTATE WF from TOTDET1 and JSTATE WF from TOTDET2
#   ifdef _DMRG_
    if (.not. doDMRG) then
#   endif
      DET1 => DETTOT1(1:NDET1,IST)
      DET2 => DETTOT2(1:NDET2,JST)
#   ifdef _DMRG_
    end if
#   endif

    if (doGSOR) then
      if (JOB1 /= JOB2) then
        Dot_prod = DDOT_(NCONF2,CI1,1,CI2,1)
        THETA1(:) = THETA1(:)+Dot_prod*CI2(:)
      end if
    end if

    ! Calculate whatever type of GTDM that was requested, unless
    ! it is known to be zero.
    HZERO = Zero
    HONE = Zero
    HTWO = Zero

    SIJ = Zero
    DYSAMP = Zero
    ! +++ J. Norell 12/7 - 2018
    ! +++ Modified by Bruno Tenorio, 2020
    ! Dyson amplitudes:
    ! DYSAMP = D_ij for states i and j
    ! DYSCOF = Active orbital coefficents of the DO
    if ((IF10 .or. IF01) .and. DYSO) then
      call MKDYSORB(OrbTab,SSTAB,FSBTAB1,FSBTAB2,DET1,DET2,IF10,IF01,DYSAMP,DYSCOF)

      ! Write Dyson orbital coefficients in AO basis to disk.
      ! In full biorthonormal basis:
      call MKDYSAB(DYSCOF,DYSAB)
      ! Correct Dyson norms, for a biorth. basis. Add by Bruno
      call DYSNORM(CMO2,DYSAB,DYNORM) !do not change CMO2
      if (DYNORM > 1.0e-5_wp) then
        ! In AO basis:
        call MKDYSZZ(CMO2,DYSAB,DYSZZ)  !do not change CMO2
        if (DYSO) then
          SFDYS(:,JSTATE,ISTATE) = DYSZZ(:)
          SFDYS(:,ISTATE,JSTATE) = DYSZZ(:)
        end if
        DYSZZ(:) = Zero
        ! DYSAMPS corresponds to the Dyson norms corrected
        ! for a MO biorth. basis
        DYSAMPS(ISTATE,JSTATE) = sqrt(DYNORM)
        DYSAMPS(JSTATE,ISTATE) = sqrt(DYNORM)
      end if ! AMP THRS
    end if ! IF01 IF10

    ! ------------------------------------------------------------
    ! This part computes the needed densities for Auger.
    ! (DOI:10.1021/acs.jctc.2c00252)
    if ((IF21 .or. IF12) .and. TDYS .and. DYSO) then
      call mma_allocate(RT2M,nRT2M,Label='RT2M')
      RT2M(:) = Zero
      call mma_allocate(RT2MAB,nRT2MAB,Label='RT2MAB')
      RT2MAB(:) = Zero
      ! Defining the Binding energy Ei-Ej
      BEi = HAM(ISTATE,ISTATE)
      BEj = HAM(JSTATE,JSTATE)
      BEij = abs(BEi-BEj)*auToEV

      if ((MPLET1-MPLET2) == int(1)) then
        ! evaluate K-2V spin+1 density
        AUGSPIN = 1
        call MKRTDM2(FSBTAB1,FSBTAB2,SSTAB,OMAP,DET1,DET2,IF21,IF12,NRT2M,RT2M,AUGSPIN,OrbTab)
        call RTDM2_PRINT(ISTATE,JSTATE,BEij,NDYSAB,DYSAB,NRT2MAB,RT2M,CMO1,CMO2,AUGSPIN)

      else if ((MPLET1-MPLET2) == int(-1)) then
        ! evaluate K-2V spin-1 density
        AUGSPIN = -1
        call MKRTDM2(FSBTAB1,FSBTAB2,SSTAB,OMAP,DET1,DET2,IF21,IF12,NRT2M,RT2M,AUGSPIN,OrbTab)
        call RTDM2_PRINT(ISTATE,JSTATE,BEij,NDYSAB,DYSAB,NRT2MAB,RT2M,CMO1,CMO2,AUGSPIN)
      else ! write then both
        AUGSPIN = 1
        call MKRTDM2(FSBTAB1,FSBTAB2,SSTAB,OMAP,DET1,DET2,IF21,IF12,NRT2M,RT2M,AUGSPIN,OrbTab)
        call RTDM2_PRINT(ISTATE,JSTATE,BEij,NDYSAB,DYSAB,NRT2MAB,RT2M,CMO1,CMO2,AUGSPIN)

        AUGSPIN = -1
        call MKRTDM2(FSBTAB1,FSBTAB2,SSTAB,OMAP,DET1,DET2,IF21,IF12,NRT2M,RT2M,AUGSPIN,OrbTab)
        call RTDM2_PRINT(ISTATE,JSTATE,BEij,NDYSAB,DYSAB,NRT2MAB,RT2M,CMO1,CMO2,AUGSPIN)
      end if
      call mma_deallocate(RT2M)
      call mma_deallocate(RT2MAB)
    end if
    ! ------------------------------------------------------------

    ! evaluation of DCH shake-up intensities (DOI:10.1063/5.0062130)
    if ((IF20 .or. IF02) .and. DCHS) then
      DCHIJ = DCHO+NASHT*(DCHO-1)
      ! Defining the Binding energy Ei-Ej
      BEi = HAM(ISTATE,ISTATE)
      BEj = HAM(JSTATE,JSTATE)
      BEij = abs(BEi-BEj)*auToEV
      call mma_allocate(DCHSM,nDCHSM,Label='DCHSM')
      DCHSM(:) = Zero
      call MKDCHS(FSBTAB1,FSBTAB2,SSTAB,OMAP,DET1,DET2,IF20,IF02,NDCHSM,DCHSM,OrbTab)
      write(u6,'(A,I5,I5,A,F14.5,ES23.14)') '  RASSI Pair States:',JSTATE,ISTATE,'  ssDCH BE(eV) and Norm:  ',BEij,DCHSM(DCHIJ)
      call mma_deallocate(DCHSM)
    end if
    ! ------------------------------------------------------------

    ! General 1-particle transition density matrix:
    if (IF11) then
      call MKTDM1(LSYM1,MPLET1,MSPROJ1,FSBTAB1,LSYM2,MPLET2,MSPROJ2,FSBTAB2,SSTAB,OMAP,DET1,DET2,SIJ,NASHT,TRAD,TRASD,WERD,ISTATE, &
                  JSTATE,job1,job2,OrbTab)
      ! Calculate Natural Transition Orbital (NTO):
      if (IFNTO) then
        DoNTO = job1 /= job2
        if (DoNTO) then
          call NTOCalc(job1,job2,ISTATE,JSTATE,TRAD,TRASD,MPLET1)
          write(u6,*) 'ntocalculation finished'
        end if
      end if
      ! End of Calculating NTO

      ! Compute 1-electron contribution to Hamiltonian matrix element:
      if (IFTWO .and. (MPLET1 == MPLET2)) HONE = DDOT_(NTRAD,TRAD,1,FMO,1)

      ! BEGIN MODIFIED by Aquilante, Segatta and Kaiser (2022)
      if (DoCoul) call EXCTDM(SIJ,TRAD,TDMAB,iRC,CMO1,CMO2,TDMZZ,TRASD,TSDMAB,TSDMZZ,ISTATE,JSTATE)
      ! END MODIFIED by Aquilante, Segatta and Kaiser(2022)

      ! Write density 1-matrices in AO basis to disk.
      if (NATO .or. (NPROP > 0)) then

        iEmpty = 0
        !> regular-TDM
        call MKTDAB(SIJ,TRAD,TDMAB,iRC)
        !> transform to AO basis
        call MKTDZZ(CMO1,CMO2,TDMAB,TDMZZ,iRC)
        if (iRC == 1) iEmpty = 1

        !> spin-TDM
        call MKTDAB(Zero,TRASD,TSDMAB,iRC)
        !> transform to AO basis
        call MKTDZZ(CMO1,CMO2,TSDMAB,TSDMZZ,iRC)
        if (iRC == 1) iEmpty = iEmpty+2

        !> WE-reduced TDM's of triplet type:
        call MKTDAB(Zero,WERD,WDMAB,iRC)
        !> transform to AO basis
        call MKTDZZ(CMO1,CMO2,WDMAB,WDMZZ,iRC)
        if (iRC == 1) iEmpty = iEmpty+4

        if (.not. mstate_dens) then

          if (SaveDens) then
            ! Transition density matrices, TDMZZ, in AO or MO basis.
            ! WDMZZ similar, but WE-reduced 'triplet' densities.
            ij = nTri_Elem(iSTATE-1)+JSTATE
            jDisk_TDM(1,ij) = IDISK
            jDisk_TDM(2,ij) = iEmpty
            iOpt = 1
            iGo = ibset(ibset(ibset(0,0),1),2)
            if (AO_Mode) then
              call dens2file(TDMZZ,TSDMZZ,WDMZZ,nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,IState,jState)
            else
              iEmpty = 0
              TRAD(nTrad+1) = SIJ
              iRC = 0
              if (DDot_(nTRAD+1,TRAD,1,TRAD,1) > Zero) iRC = 1
              if (iRC == 1) iEmpty = 1

              TRASD(nTrad+1) = Zero
              iRC = 0
              if (DDot_(nTRAD+1,TRASD,1,TRASD,1) > Zero) iRC = 1
              if (iRC == 1) iEmpty = iEmpty+2

              WERD(nTrad+1) = Zero
              iRC = 0
              if (DDot_(nTRAD+1,WERD,1,WERD,1) > Zero) iRC = 1
              if (iRC == 1) iEmpty = iEmpty+4

              call dens2file(TRAD,TRASD,WERD,nTRAD+1,LUTDM,IDISK,iEmpty,iOpt,iGo,ISTATE,JSTATE)
            end if
          end if
          !> calculate property matrix elements
          call PROPER(PROP,ISTATE,JSTATE,TDMZZ,WDMZZ)
        else

          !> scale rdm elements with eigenvector coefficients of Heff of a multi-state (PT2) Hamiltonian
          !> accumulate data first and run PROPER and other utility routines later
          do i=1,nstat(job1)
            do j=1,nstat(job2)

              if (i < j) cycle

              if (qdpt2sc) then
                fac1 = Heff_evc_sc(ist,i,job1)
                fac2 = Heff_evc_sc(jst,j,job2)
              else
                fac1 = Heff_evc_pc(ist,i,job1)
                fac2 = Heff_evc_pc(jst,j,job2)
              end if

              !> regular-TDM
              mixed_1p_rtdm(:,i,j) = mixed_1p_rtdm(:,i,j)+fac1*fac2*tdmzz(:)
              !> spin-TDM
              mixed_1p_stdm(:,i,j) = mixed_1p_stdm(:,i,j)+fac1*fac2*tsdmzz(:)
              !> WE-reduced TDM's of triplet type:
              mixed_1p_wtdm(:,i,j) = mixed_1p_wtdm(:,i,j)+fac1*fac2*wdmzz(:)
              !> overlap
              mixed_1p_overlap(i,j) = mixed_1p_overlap(i,j)+fac1*fac2*sij
            end do
          end do
        end if
      end if

    else ! IF11

      !> overlap
      if (IF00) then
#       ifdef _DMRG_
        if (.not. doDMRG) then
#       endif
          SIJ = OVERLAP_RASSI(FSBTAB1,FSBTAB2,DET1,DET2)
#       ifdef _DMRG_
        else
          sij = qcmaquis_mpssi_overlap(qcm_prefixes(job1),LROOT(ISTATE),qcm_prefixes(job2),LROOT(JSTATE),.true.)
        end if !doDMRG
#       endif
      end if ! IF00
    end if ! IF11

    if (.not. mstate_dens) then
      OVLP(ISTATE,JSTATE) = SIJ
      OVLP(JSTATE,ISTATE) = SIJ
    end if

    !> General 2-particle transition density matrix:
    if (IF22) then
      call MKTDM2(LSYM1,MSPROJ1,FSBTAB1,LSYM2,MSPROJ2,FSBTAB2,SSTAB,OMAP,DET1,DET2,NTDM2,TDM2,OrbTab)

      !> Compute 2-electron contribution to Hamiltonian matrix element:
      if (IFTWO .and. (MPLET1 == MPLET2)) HTWO = DDOT_(NTDM2,TDM2,1,TUVX,1)

    end if ! IF22

    !> PAM 2011 Nov 3, writing transition matrices if requested
    if ((IFTRD1 .or. IFTRD2) .and. (.not. mstate_dens)) call trd_print(ISTATE,JSTATE,IFTRD2 .and. IF22,TDMAB,TDM2,CMO1,CMO2,SIJ)

    ! Store SIJ temporarily
    if (IFEJOB .and. (ISTATE /= JSTATE)) then
      HAM(ISTATE,JSTATE) = SIJ
      HAM(JSTATE,ISTATE) = SIJ
    end if
    if (IFHAM .and. (.not. (IFHEXT .or. IFHEFF .or. IFEJOB))) then
      HZERO = ECORE*SIJ
      HIJ = HZERO+HONE+HTWO
      HAM(ISTATE,JSTATE) = HIJ
      HAM(JSTATE,ISTATE) = HIJ

      ! SI-PDFT related code for "second_time" case
      if (second_time) then
        Energies(:) = Zero
        call DANAME(LUIPH,'JOBGS')
        IAD = 0
        call IDAFILE(LUIPH,2,ITOC15,30,IAD)
        IAD = ITOC15(6)
        call DDAFILE(LUIPH,2,Energies,NSTAT(JOB1),IAD)
        do i=1,NSTAT(JOB1)
          HAM(i,i) = Energies(i)
        end do
        call DACLOS(LUIPH)
      end if

      if (IPGLOB >= 4) then
        write(u6,'(1x,a,2I5)') ' ISTATE, JSTATE:',ISTATE,JSTATE
        write(u6,'(1x,a,f16.8)') ' HZERO=',HZERO
        write(u6,'(1x,a,f16.8)') ' HONE =',HONE
        write(u6,'(1x,a,f16.8)') ' HTWO =',HTWO
        write(u6,'(1x,a,f16.8)') ' HIJ  =',HIJ
      end if
    end if
  end do job1_loop

end do job2_loop

! For ejob, create an approximate off-diagonal based on the overlap (temporarily stored in HIJ)

if (IFEJOB .and. JOB1 /= JOB2) then
  do JST=1,NSTAT(JOB2)
    JSTATE = ISTAT(JOB2)-1+JST
    do IST=1,NSTAT(JOB1)
      ISTATE = ISTAT(JOB1)-1+IST
      if (ISTATE <= JSTATE) cycle
      SIJ = HAM(ISTATE,JSTATE)
      HII = HAM(ISTATE,ISTATE)
      HJJ = HAM(JSTATE,JSTATE)
      HAM(ISTATE,JSTATE) = SIJ*(HII+HJJ)*Half
      HAM(JSTATE,ISTATE) = SIJ*(HII+HJJ)*Half
    end do
  end do
end if
! For ejob same-job pairs: zero HAM off-diagonals. EJOB uses only the diagonal
! (REFENE set by inpprc); same-job off-diagonals must be zero for consistency.
if (IFEJOB .and. JOB1 == JOB2) then
  do JST=1,NSTAT(JOB2)
    JSTATE = ISTAT(JOB2)-1+JST
    do IST=1,NSTAT(JOB1)
      ISTATE = ISTAT(JOB1)-1+IST
      if (ISTATE == JSTATE) cycle
      HAM(ISTATE,JSTATE) = Zero
      HAM(JSTATE,ISTATE) = Zero
    end do
  end do
end if
! For all keywords, same-job: enforce orthogonal overlap. Same-job MPSSI states
! must be orthogonal by construction; QCMaquis may produce identical MPS for
! degenerate roots, giving SIJ=1, which makes OVLP rank-1 and the eigensolver
! produce unphysical energies. Zero the off-diagonals to enforce orthogonality.
if (JOB1 == JOB2) then
  do JST=1,NSTAT(JOB2)
    JSTATE = ISTAT(JOB2)-1+JST
    do IST=1,NSTAT(JOB1)
      ISTATE = ISTAT(JOB1)-1+IST
      if (ISTATE == JSTATE) cycle
      OVLP(ISTATE,JSTATE) = Zero
      OVLP(JSTATE,ISTATE) = Zero
    end do
  end do
end if

if (DoGSOR) then
  if (job1 /= job2) then
    dot_prod = DDOT_(NCONF2,THETA1,1,THETA1,1)
    Norm_Fac = One/sqrt(dot_prod)
    THETA1(:) = Norm_Fac*THETA1(:)

    !Write theta1 to file.
    LUCITH = IsFreeUnit(87)
    !Open(unit=87,file='CI_THETA', action='write',iostat=ios)
    call Molcas_Open(LUCITH,'CI_THETA')
    do i=1,NCONF2
      write(LUCITH,*) Theta1(i)
    end do
    close(LUCITH)

    ! Now we need to build the other states.
    call mma_allocate(detcoeff2,nDet2,label='detcoeff2')
    do JST=2,NSTAT(JOB2)
      JSTATE = ISTAT(JOB2)-1+JST
      call READCI(JSTATE,SGS(2),CIS(2),NCONF2,CI2)
      CI2_o(:) = CI2(:)
      DET2(:) = Zero
      if (TrOrb) call CITRA(WFTP2,SGS(2),CIS(2),EXS(2),LSYM2,TRA2,NCONF2,CI2)
      call PREPSD(WFTP2,SGS(2),CIS(2),LSYM2,CNFTAB2,SPNTAB2,SSTAB,FSBTAB2,NCONF2,CI2,DET2,detocc,detcoeff2,TRANS2)

      call mma_allocate(ThetaN,NCONF2,Label='ThetaN')
      ThetaN(:) = Zero
      Norm_Fac = DDOT_(NCONF2,THETA1,1,CI2_o,1)
      ThetaN(:) = ThetaN(:)-Norm_Fac*THETA1(:)

      LUCITH = IsFreeUnit(LUCITH)
      call Molcas_Open(LUCITH,'CI_THETA')
      !open(unit=87,file='CI_THETA',action='read',iostat=ios)
      if (JST-1 >= 2) then
        do i=1,NCONF2
          read(LUCITH,*) dot_prod ! dummy
        end do
      end if
      call mma_allocate(ThetaM,NCONF2,Label='ThetaM')
      do IST=2,JST-1
        ! Read in previous theta vectors
        do i=1,NCONF2
          read(LUCITH,*) ThetaM(i)
        end do
        Dot_prod = DDOT_(NCONF2,ThetaM,1,CI2_o,1)
        ThetaN(:) = ThetaN(:)-Dot_prod*ThetaM(:)

      end do
      call mma_deallocate(detcoeff2)
      close(LUCITH)
      ! Normalize
      dot_prod = DDOT_(NCONF2,ThetaN,1,ThetaN,1)
      Norm_Fac = One/sqrt(dot_prod)
      ThetaN(:) = Norm_Fac*ThetaN(:)

      !dot_prod = DDOT_(NCONF2,THETA1,1,THETA1,1)
      !dot_prod = DDOT_(NCONF2,ThetaN,1,THETA1,1)
      !dot_prod = DDOT_(NCONF2,ThetaN,1,ThetaN,1)

      ! Write to file
      LUCITH = IsFreeUnit(LUCITH)
      call Molcas_Open(LUCITH,'CI_THETA')
      call Append_file(LUCITH)
      !open(unit=87,file='CI_THETA',position='append',iostat=ios,action='write')
      do i=1,nConf2
        write(LUCITH,*) ThetaN(i)
      end do
      close(LUCITH)
      ! Deallocate
      call mma_deallocate(ThetaN)
    end do
    ! Copy to new IPH file
    LUCITH = IsFreeUnit(LUCITH)
    call Molcas_Open(LUCITH,'CI_THETA')
    !open(unit=87,file='CI_THETA',iostat=ios,action='read')
    call DANAME(LUIPHn,'JOBGS')
    IAD = 0
    call IDAFILE(LUIPHn,2,ITOC15,30,IAD)
    IAD = ITOC15(4)
    do i=1,ISTAT(JOB1)-1
      do j=1,nCONF2
        read(LUCITH,*) ThetaM(i)
      end do
      call DDafile(LUIPHn,1,ThetaM,nCONF2,IAD)
    end do

    IAD = ITOC15(4)
    call DDAFILE(LUIPHn,2,ThetaM,nCONF2,IAD)
    call DDAFILE(LUIPHn,2,ThetaM,nCONF2,IAD)

    close(LUCITH)
    call DACLOS(LUIPHn)
    call mma_deallocate(ThetaM)
  end if
  call mma_deallocate(Theta1)
end if !DoGSOR

#ifdef _DMRG_
if (IPGLOB >= 4) then
  write(u6,*) 'full SF-HAMILTONIAN'
  write(u6,*) 'dimension: ',nstate**2
  call pretty_print_util(HAM,1,nstate,1,nstate,nstate,nstate,1,u6)
end if
#endif

!> create actual property data and put everything to file (if requested)
!> in case of using eigenvectors of a multi-state (PT2) Hamiltonian
if (mstate_dens) then
  do JST=1,NSTAT(JOB2)
    JSTATE = ISTAT(JOB2)-1+JST
    do IST=1,NSTAT(JOB1)
      ISTATE = ISTAT(JOB1)-1+IST
      if (istate < jstate) cycle

      ovlp(istate,jstate) = mixed_1p_overlap(ist,jst)
      ovlp(jstate,istate) = mixed_1p_overlap(ist,jst)

      call prpdata_mspt2_eigenvectors(mixed_1p_rtdm(:,ist,jst),mixed_1p_stdm(:,ist,jst),mixed_1p_wtdm(:,ist,jst),prop,nprop, &
                                      nstate,istate,jstate,ntdmzz,iDisk_TDM(JSTATE,ISTATE,1),iDisk_TDM(JSTATE,ISTATE,2),lutdm, &
                                      sonatnstate > 0,if11 .and. (lsym1 == lsym2))
    end do
  end do
end if

if (WFTP1 == 'GENERAL') then
  if (.not. doDMRG) call SG_Free(SGS(1),CIS(1),EXS(1))
end if
if (WFTP2 == 'GENERAL') then
  if (.not. doDMRG) call SG_Free(SGS(2),CIS(2),EXS(2))
end if

if (JOB1 /= JOB2) then
  call mma_deallocate(TRA1)
  call mma_deallocate(TRA2)
end if
nullify(DET1,DET2)
call mma_deallocate(DETTOT1)
call mma_deallocate(DETTOT2)
call mma_deallocate(detocc)
call mma_deallocate(CI2)
if (DoGSOR) call mma_deallocate(CI2_o)
call mma_deallocate(CI1)
if (.not. doDMRG) then
  call mma_deallocate(TRANS2)
  call mma_deallocate(TRANS1)
  call mma_deallocate(SPNTAB1)
  call mma_deallocate(SPNTAB2)
end if
if ((IF10 .or. IF01) .and. DYSO) then
  call mma_deallocate(DYSCOF)
  call mma_deallocate(DYSAB)
  call mma_deallocate(DYSZZ)
end if
if (IF11) then
  call mma_deallocate(TRAD)
  call mma_deallocate(TRASD)
  call mma_deallocate(WERD)
  if (NATO .or. (NPROP > 0)) then
    call mma_deallocate(TDMAB)
    call mma_deallocate(TSDMAB)
    call mma_deallocate(WDMAB)
    call mma_deallocate(TDMZZ)
    call mma_deallocate(TSDMZZ)
    call mma_deallocate(WDMZZ)
  end if
end if
call mma_deallocate(TDM2)

if (IFTWO .and. (MPLET1 == MPLET2)) then
  call mma_deallocate(FMO)
  call mma_deallocate(TUVX)
end if

call mma_deallocate(CMO2)
call mma_deallocate(CMO1)
call mma_deallocate(PART)
call mma_deallocate(OrbTab)
call mma_deallocate(SSTAB)
if (.not. doDMRG) then
  call mma_deallocate(REST2)
  call mma_deallocate(REST1)
  call mma_deallocate(CNFTAB2)
  call mma_deallocate(CNFTAB1)
  call mma_deallocate(FSBTAB2)
  call mma_deallocate(FSBTAB1)
end if
call mma_deallocate(OMAP)

!> release memory
if (mstate_dens) then
  call mma_deallocate(mixed_1p_overlap)
  call mma_deallocate(mixed_1p_rtdm)
  call mma_deallocate(mixed_1p_stdm)
  call mma_deallocate(mixed_1p_wtdm)
end if

#ifdef _TIME_GTDM_
call CWTime(TCpu2,TWall2)
write(u6,*) 'Time for GTDM : ',TCpu2-TCpu1,TWall2-TWall1
#endif

end subroutine GTDMCTL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine AixCheck()
      Implicit Integer (a-z)
#include "ctl.fh"
      Logical Opened
      character name*256
*----------------------------------------------------------------------*
* Check if slot in table is available, it should NOT!                  *
*----------------------------------------------------------------------*
      Do n = 1, MxFile
         If (CtlBlk(pStat,n).ne.0) Then
#ifndef _DEVEL_
            Call SysAbendFileMsg('AixCheck',FCtlBlk(n),'Active unit.',
     &                           'Should have been closed!')
#else
            Call SysWarnMsg('AixCheck','Active unit: '//FCtlBlk(n),
     &                           ', should have been closed!')
#endif
         End If
         Inquire(unit=n,Opened=Opened)
         If (Opened ) Then
         if(.not. (n.eq.6.or.n.eq.5))then
          inquire(unit=n,name=name)
            Write (6,*) 'Fortran file:', n, '(',name(1:index(name,' ')),
     *        ')  is still open!'
#ifndef _DEVEL_
            Call Abend()
#endif
         End If
         endif
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
************************************************************************
      Subroutine QNR(nInter,nIter,dq,H,g)
************************************************************************
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             December '94                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 dq(nInter,nIter), H(nInter,nInter), g(nInter,nIter+1)
*
      iRout = 115
      iPrint = nPrint(iRout)
*
*-----Compute a new independent geometry by relaxation of
*     the gradient vector.
*
!     Call Allocate_iWork(ipTmp,1)
      Call Allocate_iWork(ipTmp,nInter*nInter)
!     iWork(ipTmp)=0
      Call IZero(iWork(ipTmp),nInter*nInter)
!     Call DZero(nInter,dq(1,nIter))
      Call DZero(dq(1,nIter),nInter)
      Call CG_Solver(nInter,nInter**2,H,iWork(ipTmp),
     &               g(1,nIter),dq(1,nIter),Info)
      Call Free_iWork(ipTmp)
      If (Info.lt.0) Then
        Call SysAbendMsg('QNR','Conjugate gradients not converged',' ')
      End If
*
      If (iPrint.ge.99) Then
        Write(6,*) 'CG converged in ',Info,' iterations'
        Call RecPrt(' H ',' ',H,nInter,nInter)
        Call RecPrt(' dq',' ',dq(1,nIter),1,nInter)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CoSys(Cent,R,xyz)

use Constants, only: Zero, One
#ifdef _DEBUGPRINT_
use Constants, only: Pi
#endif
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Cent(3,3)
real(kind=wp), intent(out) :: r(3), xyz(3,2)
integer(kind=iwp) :: i, iComp(3), j, k, nComp
real(kind=wp) :: Co, Crap, r11, r12, r2, R21j, R21k, R23j, R23k, RR, RR1, RR2, Si
logical(kind=iwp) :: Linear, Retry
real(kind=wp), parameter :: ThrAcos = 1.0e-6_wp
#ifdef _DEBUGPRINT_
real(kind=wp) :: Fi
real(kind=wp), external :: ArCos, ArSin

call RecPrt('CoSys: Cent',' ',Cent,3,3)
#endif

! Check if linear

Co = Zero
Crap = Zero
RR1 = Zero
RR2 = Zero
do i=1,3
  Co = Co+(Cent(i,1)-Cent(i,2))*(Cent(i,3)-Cent(i,2))
  RR1 = RR1+(Cent(i,1)-Cent(i,2))**2
  RR2 = RR2+(Cent(i,3)-Cent(i,2))**2
end do
RR1 = sqrt(RR1)
RR2 = sqrt(RR2)
Co = Co/(RR1*RR2)
do i=1,3
  Crap = Crap+((Cent(i,3)-Cent(i,2))/RR2-sign(One,Co)*(Cent(i,1)-Cent(i,2))/RR1)**2
end do
Crap = sqrt(Crap)
#ifdef _DEBUGPRINT_
write(u6,*) 'Co=',Co
write(u6,*) 'Crap=',Crap
#endif
if (Crap < 1.0e-6_wp) then
  Si = Crap
# ifdef _DEBUGPRINT_
  if (Co < Zero) then
    Fi = Pi-ArSin(Si)
  else
    Fi = ArSin(Si)
  end if
# endif
else
  if ((Co > One) .and. (Co < One+ThrAcos)) Co = One
  if ((Co < -One) .and. (Co > -One-ThrAcos)) Co = -One
  if ((Co > One+ThrAcos) .or. (Co < -One-ThrAcos)) then
    call WarningMessage(2,'Error in CoSys')
    write(u6,*) 'Error in cosys: arcos(',Co,')'
    call Abend()
  end if
  Si = sqrt(One-Co**2)
# ifdef _DEBUGPRINT_
  Fi = ArCos(Co)
# endif
end if
#ifdef _DEBUGPRINT_
write(u6,*) 'Fi,Pi=',Fi,Pi
write(u6,*) 'Pi-Fi=',Pi-Fi
#endif

Linear = abs(Si) < 1.0e-13_wp

! Form reference axis

R(:) = Cent(:,3)-Cent(:,1)
RR = sqrt(R(1)**2+R(2)**2+R(3)**2)
if ((RR1 >= RR2) .and. (RR1 >= RR)) then
  R(:) = Cent(:,1)-Cent(:,2)
  RR = RR1
else if (RR2 >= RR) then
  R(:) = Cent(:,3)-Cent(:,2)
  RR = RR2
end if
R(:) = R(:)/RR

#ifdef _DEBUGPRINT_
write(u6,*) 'Linear=',Linear
write(u6,*) 'RR=',RR
call RecPrt('R',' ',R,3,1)
#endif

Retry = .true.
do while (Retry)
  Retry = .false.
  if (Linear) then

    nComp = 0
    do i=1,3
      if (R(i) == Zero) then
        nComp = nComp+1
        iComp(nComp) = i
      end if
    end do

    ! Compute the WDC B-matrix

    xyz(:,:) = Zero
    if (nComp == 0) then
      !write(u6,*) ' Case nComp == 0'

      xyz(1,1) = R(1)
      xyz(2,1) = R(2)
      xyz(3,1) = -R(3)
      r12 = R(1)**2+R(2)**2-R(3)**2
      r11 = R(1)**2+R(2)**2+R(3)**2
      xyz(1,1) = xyz(1,1)-(r12/r11)*R(1)
      xyz(2,1) = xyz(2,1)-(r12/r11)*R(2)
      xyz(3,1) = xyz(3,1)-(r12/r11)*R(3)
      r2 = sqrt(xyz(1,1)**2+xyz(2,1)**2+xyz(3,1)**2)
      xyz(1,1) = xyz(1,1)/r2
      xyz(2,1) = xyz(2,1)/r2
      xyz(3,1) = xyz(3,1)/r2
      xyz(1,2) = R(2)*xyz(3,1)-R(3)*xyz(2,1)
      xyz(2,2) = R(3)*xyz(1,1)-R(1)*xyz(3,1)
      xyz(3,2) = R(1)*xyz(2,1)-R(2)*xyz(1,1)
      r2 = sqrt(xyz(1,2)**2+xyz(2,2)**2+xyz(3,2)**2)
      xyz(1,2) = xyz(1,2)/r2
      xyz(2,2) = xyz(2,2)/r2
      xyz(3,2) = xyz(3,2)/r2

    else if (nComp == 1) then
      !write(u6,*) ' Case nComp == 1'

      i = iComp(1)
      xyz(i,1) = One
      xyz(1,2) = R(2)*xyz(3,1)-R(3)*xyz(2,1)
      xyz(2,2) = R(3)*xyz(1,1)-R(1)*xyz(3,1)
      xyz(3,2) = R(1)*xyz(2,1)-R(2)*xyz(1,1)
      r2 = sqrt(xyz(1,2)**2+xyz(2,2)**2+xyz(3,2)**2)
      xyz(1,2) = xyz(1,2)/r2
      xyz(2,2) = xyz(2,2)/r2
      xyz(3,2) = xyz(3,2)/r2

    else if (nComp == 2) then
      !write(u6,*) ' Case nComp == 2'

      i = iComp(1)
      xyz(i,1) = One
      i = iComp(2)
      xyz(i,2) = One

    else
      call WarningMessage(2,'Error in CoSys')
      write(u6,*) ' CoSys: nComp == 3'
      call Abend()
    end if

  else     ! Non-linear

    ! Form the cross product R12xR32
    RR = Zero
    do i=1,3
      j = mod(i,3)+1
      k = mod(i+1,3)+1
      R21j = Cent(j,1)-Cent(j,2)
      R21k = Cent(k,1)-Cent(k,2)
      R23j = Cent(j,3)-Cent(j,2)
      R23k = Cent(k,3)-Cent(k,2)
      xyz(i,2) = R21j*R23k-R21k*R23j
      RR = RR+xyz(i,2)**2
    end do
    if (RR == Zero) then
      Linear = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Linear=',Linear
#     endif
      Retry = .true.
    else
      xyz(:,2) = xyz(:,2)/sqrt(RR)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'RR=',RR
#     endif

      RR = Zero
      do i=1,3
        j = mod(i,3)+1
        k = mod(i+1,3)+1
        xyz(i,1) = xyz(j,2)*R(k)-xyz(k,2)*R(j)
        RR = RR+xyz(i,1)**2
      end do
      xyz(:,1) = xyz(:,1)/sqrt(RR)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'RR=',RR
      call RecPrt('xyz',' ',xyz,3,2)
#     endif
    end if

  end if
end do

#ifdef _DEBUGPRINT_
call RecPrt(' Reference Axis',' ',R,3,1)
call RecPrt(' Perpendicular Axes',' ',xyz,3,2)
#endif

end subroutine CoSys

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine checkMem(NvGrp, NvSGrp, NchBlk,
     & Jal1, Jal2, wrksize, maxdim)
c
c Check memory consumption according to the specified
c orbital segmentation
c
        implicit none
#include "chcc1.fh"
c
        integer NvGrp,NvSGrp,NchBlk
        integer wrksize
c
        integer maxdim,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
        integer PossV1,PossV2,PossV3,PossV4
        integer PossL11,PossL12
        integer PossH1,PossH2,PossH3,PossH4,PossH5
        integer PossM1,PossM2,PossM3,PossM4,PossM5
        integer PossK,PossQ
        integer PossT,PossMax
c        jalove
        integer Jal1,Jal2,Jal3
c
c2      Distribute memory (and redefine wrksize)
c
c*.1        Distribute Permanent arrays
c
        PossT=1
        call DistMemPerm (PossT)
        PossMax=PossT
c
c*.2    Distribute Work arrays for Reord
c
        call DefParReord (NvGrp,maxdim)
c        also
        call DefParo2v4 (NvGrp,NvGrp,NvSGrp,NvSGrp,
     c                   mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
        PossT=PossFree
        call DistMemReord (NvGrp,maxdim,mdSGrpa,NchBlk,
     c       PossV1,PossV2,PossV3,PossV4,PossM1,PossM2,
     c       PossT)
        if (PossT.gt.PossMax) then
          PossMax=PossT
        end if
c
c*.3    Distribute Work arrays for o3v3
c
        call DefParo3v3 (NvGrp,maxdim)
c
        PossT=PossFree
        call DistMemo3v3jk (NvGrp,maxdim,
     c       PossV1,PossV2,PossV3,PossV4,
     c       PossH1,PossH2,PossH3,PossH4,PossH5,
     c       PossK,PossQ,
     c       PossT)
        if (PossT.gt.PossMax) then
          PossMax=PossT
        end if
c
        PossT=PossFree
        call DistMemo3v3t2 (NvGrp,maxdim,
     c       PossV1,PossV2,PossV3,PossV4,
     c       PossH1,PossH2,PossH3,PossH4,
     c       PossK,PossQ,
     c       PossT)
        if (PossT.gt.PossMax) then
          PossMax=PossT
        end if
c
        PossT=PossFree
        call DistMemo3v3chol (NvGrp,maxdim,
     c       PossV1,PossV2,PossV3,PossV4,
     c       PossH1,PossH2,PossH3,PossH4,
     c       PossM1,PossM2,PossM3,PossM4,PossM5,
     c       PossK,PossQ,
     c       PossT)
        if (PossT.gt.PossMax) then
          PossMax=PossT
        end if
c
c*.4    Distribute Work arrays for o2v4
c
        call DefParo2v4 (NvGrp,NvGrp,NvSGrp,NvSGrp,
     c                   mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
        PossT=PossFree
c        Nazvy premennych tu davam ine, lebo ide len o vypocet narokov na Mem
        call DistMemo2v4 (NvGrp,NvGrp,NvSGrp,NvSGrp,
     c                 mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,
     c                 PossV1,PossV2,PossV3,PossV4,
     c                 PossL11,PossL12,
     c                 PossH1,PossH2,PossH3,PossH4,PossQ,
     c                 Jal1,Jal2,
     c                 PossM1,PossM2,PossM3,PossM4,PossM5,Jal3,
     c                 PossT,PossK)
        if (PossT.gt.PossMax) then
          PossMax=PossT
        end if
c
c*.5        Memory requirements for Summary step are upperbounded by o3v3
c        and also o2v4, this it is skipped
c
        wrksize=PossMax
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SG_setup_RASSI(nSym,nActEl,iSpin,SGS,CIS)

use Molcas, only: MxLev
use sguga, only: CIStruct, SG_Init, SGStruct
use rassi_aux, only: Level
use rassi_data, only: NASH
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, nActEl, iSpin
type(SGStruct), intent(inout) :: SGS
type(CIStruct), intent(inout) :: CIS
integer(kind=iwp) :: ILEV, iq, ISM(MxLev), ISYM, IT, L2Act(MxLev), nLev

nLev = 0
do ISYM=1,NSYM
  do IT=1,NASH(ISYM)
    nLev = nLev+1
    ILEV = Level(nLev)
    ISM(ILEV) = ISYM
  end do
end do

L2Act(1:MxLev) = [(iq,iq=1,MxLev)]

call SG_Init(nSym,nActEl,iSpin,SGS,CIS,xLevel=Level,xL2Act=L2Act,xNLEV=nLev,xNSM=ISM)

end subroutine SG_setup_RASSI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Cho_ov_Loc(irc,Thrs,nSym,nBas,nFro,nIsh,
     &                               nAsh,nSsh,CMO,SMAT,iD_vir)

      Implicit Real*8 (a-h,o-z)
      Integer nSym, nBas(nSym), nFro(nSym), nAsh(nSym)
      Integer nIsh(nSym), nSsh(nSym), iD_vir(*)
      Real*8  Thrs, CMO(*), SMAT(*)
#include "WrkSpc.fh"

      irc=0
      l_Dens = 0
      Do iSym = 1,nSym
         l_Dens = max(l_Dens,nBas(iSym)**2)
      End Do
      Call GetMem('Density','Allo','Real',ip_Dens,2*l_Dens)
      ipD2=ip_Dens+l_Dens
      kOffC = 0
      jD = 1
      Do iSym = 1,nSym
         If (nIsh(iSym) .gt. 0) Then
            kOff1 = 1 + kOffC + nBas(iSym)*nFro(iSym)
            Call GetDens_Localisation(Work(ip_Dens),CMO(kOff1),
     &                                nBas(iSym),nIsh(iSym))
            Call FZero(CMO(kOff1),nBas(iSym)*nIsh(iSym))
            Call ChoLoc(irc,Work(ip_Dens),CMO(kOff1),Thrs,yNrm,
     &                      nBas(iSym),nIsh(iSym))
            If (irc .ne. 0) Then
               Call GetMem('Density','Free','Real',ip_Dens,2*l_Dens)
               irc  = 1
               Return
            End If
         End If
         Call izero(iD_vir(jD),nBas(iSym))
         If (nSsh(iSym) .gt. 0) Then
            kOff1= 1 + kOffC
            nOcc=nFro(iSym)+nIsh(iSym)+nAsh(iSym)
            Call GetDens_Localisation(Work(ip_Dens),CMO(kOff1),
     &                                nBas(iSym),nOcc)
            If ( nOcc+nSsh(iSym) .lt. nBas(iSym) ) Then  ! nDel > 0
               write(6,*) ' ******************************************'
               write(6,*) ' Cho_ov_Loc found Deleted orbitals in your '
               write(6,*) ' original MOs. She cannot properly handle  '
               write(6,*) ' this situation. The program may crash !! '
               write(6,*) ' ******************************************'
            EndIf
* compute -DS
            Call DGEMM_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),
     &                        -1.0d0,Work(ip_Dens),nBas(iSym),
     &                               SMAT(kOff1),nBas(iSym),
     &                         0.0d0,Work(ipD2),nBas(iSym))
* compute 1-DS = 1 + (-DS)
            Do i=0,nBas(iSym)-1
               ii=ipD2+nBas(iSym)*i+i
               Work(ii)=1.0d0+Work(ii)
            End Do
* compute (1-DS)*(1-DS)'
            Call GetDens_Localisation(Work(ip_Dens),Work(ipD2),
     &                                nBas(iSym),nBas(iSym))
            kOff2= kOff1+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
            Call FZero(CMO(kOff2),nBas(iSym)*nSsh(iSym))
            Call ChoLoc_xp(irc,Work(ip_Dens),CMO(kOff2),Thrs,yNrm,
     &                         nBas(iSym),nSsh(iSym),iD_vir(jD))
            If (irc .ne. 0) Then
               Call GetMem('Density','Free','Real',ip_Dens,2*l_Dens)
               irc  = 1
               Return
            End If
         End If
         kOffC = kOffC + nBas(iSym)**2
         jD = jD + nBas(iSym)
      End Do

      Call GetMem('Density','Free','Real',ip_Dens,2*l_Dens)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine zlcase(line)

use Definitions, only: iwp

implicit none
character(len=*), intent(inout) :: line
integer(kind=iwp) :: k, idx

do k=1,len(line)
  idx = ichar(line(k:k))
  !if ((97 <= idx).and.(idx <= 122)) line(k:k) = char(idx-32)
  if ((65 <= idx) .and. (idx <= 90)) line(k:k) = char(idx+32)
end do

return

end subroutine zlcase

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Anders Bernhardsson                              *
*               1991, Roland Lindh                                     *
************************************************************************
      SubRoutine NAHss(
#define _CALLING_
#include "hss_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: to compute the gradient of the nuclear attraction integrals. *
*                                                                      *
*     Author: Anders Bernhardsson & Roland Lindh,                      *
*             Dept. of Theoretical Chemistry, University               *
*             of Lund, SWEDEN.                                         *
*             October 1991                                             *
************************************************************************
      use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
      External TNAI1, Fake, Cff2D
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
c#include "print.fh"
#include "disp.fh"
#include "disp2.fh"

#include "hss_interface.fh"

*     Local variables
      Integer iDCRT(0:7), Index(3,4)
      Logical TstFnc, TF, EQ,IfG(0:3),Tr(0:3)
#ifdef _PATHSCALE_
      Save Fact
#endif
*
*     Local arrrays
*
      Real*8 Coori(3,4), CoorAC(3,2), C(3), TC(3)
      Integer iAnga(4), JndGrd(0:2,0:3,0:7),
     &        JndHss(0:3,0:2,0:3,0:2,0:7),
     &        mOp(4), iuvwx(4)
      Logical JfHss(0:3,0:2,0:3,0:2),JfGrd(0:2,0:3)
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      itri(i1,i2)=MAX(i1,i2)*(MAX(i1,i2)-1)/2+MIN(i1,i2)
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*
c     iRout = 150
c     iPrint = nPrint(iRout)
*
c     If (iPrint.ge.99) Then
c        Write (6,*) ' In NAHss: nArr=',nArr
c     End If
*
      nRys=nHer
*
      nip = 1
      ipA = nip
      nip = nip + nAlpha*nBeta
      ipB = nip
      nip = nip + nAlpha*nBeta
      ipDAO = nip
      nip = nip + nAlpha*nBeta*nElem(la)*nElem(lb)
      If (nip-1.gt.nArr) Then
         Write (6,*) 'NAHss: nip-1.gt.nArr'
         Write (6,*) 'nip,nArr=',nip,nArr
         Call Abend()
      End If
      ipArr = nip
      nArray = nArr - nip +1
*
      iIrrep = 0
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = 0
      iAnga(4) = 0
      call dcopy_(3,A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
      If (la.ge.lb) Then
         call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
         call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      mOp(1) = nOp(1)
      mOp(2) = nOp(2)
*
      ipAOff = ipA
      Do iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
      End Do
*
      ipBOff = ipB
      Do iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
      End Do
*
*     Modify the density matrix with the prefactor
*
      nDAO = nElem(la) * nElem(lb)
      Do iDAO = 1, nDAO
         Do iZeta = 1, nZeta
            Fact = Two*rkappa(iZeta)*Pi/Zeta(iZeta)
            DAO(iZeta,iDAO) = Fact * DAO(iZeta,iDAO)
         End Do
      End Do
c     If (iPrint.ge.99) Call RecPrt('DAO',' ',DAO,nZeta,nDAO)
*
*-----Loop over nuclear centers
*
      kdc = 0
      Do kCnttp = 1, nCnttp
         If (dbsc(kCnttp)%Charge.eq.Zero) Go To 111
         Do kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3)=dbsc(kCnttp)%Coor(1:3,kCnt)

            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = -dbsc(kCnttp)%Charge*DBLE(nStabM) / DBLE(LmbdT)
*
            Call DYaX(nZeta*nDAO,Fact,DAO,1,Array(ipDAO),1)
*
            iuvwx(3) = dc(kdc+kCnt)%nStab
            iuvwx(4) = dc(kdc+kCnt)%nStab
*
            Do 102 lDCRT = 0, nDCRT-1
*
               mOp(3) = NrOpr(iDCRT(lDCRT))
               mOp(4) = mOp(3)
               Call OA(iDCRT(lDCRT),C,TC)
               call dcopy_(3,TC,1,CoorAC(1,2),1)
               call dcopy_(3,TC,1,Coori(1,3),1)
               call dcopy_(3,TC,1,Coori(1,4),1)
               If (EQ(A,TC).and.EQ(A,RB)) Goto 102
*
*              Initialize JfGrd, JndGrd, JfHss, and JndHss.
*
               Call LCopy(12,[.False.],0,JfGrd,1)
               Call ICopy(nSym*4*3,[0],0,JndGrd,1)
               Call LCopy(144,[.False.],0,JfHss,1)
               Call ICopy(nSym*16*9,[0],0,JndHss,1)
*
*              Overwrite with information in IfGrd, IndGrd, IfHss,
*              and IndHss.

               Do iAtom = 0, 1
                  Do iCar  = 0, 2
                     JfGrd(iCar,iAtom) = Ifgrd(iCar,iAtom)
                     Do iIrrep=0,nSym-1
                        JndGrd(iCar,iAtom,iIrrep)=
     &                     IndGrd(iCar,iAtom,iIrrep)
                     End Do
                     Do jAtom = 0, 1
                        Do jCar = 0, 2
                           JfHss(iAtom,iCar,jAtom,jCar) =
     &                       IfHss(iAtom,iCar,jAtom,jCar)
                           Do iIrrep=0,nSym-1
                              JndHss(iAtom,iCar,jAtom,jCar,iIrrep) =
     &                          IndHss(iAtom,iCar,jAtom,jCar,iIrrep)
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
*
*--------------Derivatives with respect to the operator is computed via
*              the translational invariance.
*
               nnIrrep=nSym
               If (sIrrep) nnIrrep=1
               Do iIrrep=0,nnIrrep-1
                  nDisp = IndDsp(kdc+kCnt,iIrrep)
                  Do iCar = 0, 2
                     iComp = 2**iCar
                     If (TF(kdc+kCnt,iIrrep,iComp)) Then
                        nDisp = nDisp + 1
*
*-----------------------Reset flags for the basis set centers so that we
*                       will explicitly compute the derivatives with
*                       respect to those centers. Activate flag for the
*                       third center so that its derivative will be comp-
*                       uted by the translational invariance.
*
                        JndGrd(iCar,0,iIrrep)=Abs(JndGrd(iCar,0,iIrrep))
                        JndGrd(iCar,1,iIrrep)=Abs(JndGrd(iCar,1,iIrrep))
                        JndGrd(iCar,2,iIrrep)=-nDisp
                        JfGrd(iCar,0) = .True.
                        JfGrd(iCar,1) = .True.
                        JfGrd(iCar,2) = .False.
                     Else
                        JndGrd(iCar,2,iIrrep) = 0
                     End If
                  End Do
               End Do
*
*              The third center is calculated by translational invariance.
*              This requires the 2nd derivatives on the other centers.
*
               Call LCopy(4,[.False.],0,Tr,1)
               Do iCar=0,2
                  Do jAtom=0,2
                     If (jAtom.eq.2) Then
                        iStop=iCar
                     Else
                        iStop=2
                     End If
                     Do jCar=0,iStop
                        Do iIrrep=0,nSym-1
                           If ((JndGrd(iCar,2,iIrrep).ne.0) .and.
     &                         (JndGrd(jCar,jAtom,iIrrep).ne.0)) Then
                              JndHss(2,iCar,jAtom,jCar,iIrrep)=
     &                          -itri(Abs(JndGrd(iCar,2,    iIrrep)),
     &                                Abs(JndGrd(jCar,jAtom,iIrrep)))

                              Tr(2)=.True.
                              If (jAtom.eq.2) Then
                                 Maxi=Max(iCar,jCar)
                                 Mini=Min(iCar,jCar)
                                 JfHss(0,Maxi,0,Mini)=.True.
                                 JfHss(1,Maxi,1,Mini)=.True.
                                 JfHss(1,iCar,0,jCar)=.True.
                                 JfHss(1,jCar,0,iCar)=.True.
                              Else
                                 Maxi=Max(iCar,jCar)
                                 Mini=Min(iCar,jCar)
                                 JfHss(jAtom,Maxi,jAtom,Mini)=.True.
                                 JfHss(1,iCar,0,jCar)=.True.
                                 JfHss(1,jCar,0,iCar)=.True.
                              End If
                           End If
                        End Do
                     End Do
                  End Do
               End Do
*
               IfG(0)=.True.
               IfG(1)=.True.
               IfG(2)=.False.
               IfG(3)=.False.
               Do iCent=0,1
                  If (EQ(Coori(1,iCent+1),Coori(1,3) ) ) Then
                     IfG(iCent)=.False.
                     Do iCar=0,2
                        jfGrd(iCar,iCent)=.False.
                        Do kCar=0,2
                           Do KCent=0,3
                              jfHss(iCent,iCar,kCent,kCar)=.False.
                              jfHss(kCent,kCar,iCent,iCar)=.False.
                              Do iIrrep=0,nSym-1
                                 jndHss(iCent,iCar,kCent,kCar,iIrrep)=0
                                 jndHss(kCent,kCar,iCent,iCar,iIrrep)=0
                              End Do
                           End Do
                        End Do
                        Do iIrrep=0,nSym-1
                           jndGrd(iCar,iCent,iIrrep)=0
                        End Do
                     End Do
                  End If
               End Do
               Call lCopy(12,[.False.],0,jfgrd,1)
*
               nFinal = 0
               Call Rysg2(iAnga,nRys,nZeta,
     &                    Array(ipA),Array(ipB),[One],[One],
     &                    Zeta,ZInv,nZeta,[One],[One],1,
     &                    P,nZeta,TC,1,Coori,Coori,CoorAC,
     &                    Array(ipArr),nArray,
     &                    TNAI1,Fake,Cff2D,
     &                    Array(ipDAO),nDAO,Hess,nHess,
     &                    JfGrd,JndGrd,
     &                    JfHss,JndHss,mOp,iuvwx,ifg,
     &                    nFinal,index,.false.,.true.,tr)
*
 102        Continue
         End Do
 111     kdc = kdc + dbsc(kCnttp)%nCntr
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Final)
         Call Unused_real_array(Ccoor)
         Call Unused_integer(nOrdOp)
         Call Unused_integer_array(lOper)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_DensDrv(irc,EOcc,EVir,EFro,CMO)
!
! Jonas Bostrom, Feb 2010
!
! Purpose: To Compute MP2 density from Cholesky MO-vectors and
!          decomposed MP2 amplitudes.

use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: EOcc(*), EVir(*), EFro(*), CMO(*)
integer(kind=iwp) :: lWrk
real(kind=wp), allocatable :: Wrk(:)

irc = 0

call mma_maxDBLE(lWrk)
! Leave 5% of the memory unallocated
! ----------------------------------
#ifdef _I8_
lWrk = lWrk*19/20
#else
lWrk = lWrk-lWrk/20
#endif
call mma_allocate(Wrk,lWrk,Label='Wrk')
!Wrk(:) = Zero

call ChoMP2g_Reord_R(Wrk,lWrk)

call ChoMP2g_density1(irc,EOcc,EVir,EFro,Wrk,lWrk)
call ChoMP2g_density2(irc,EOcc,EVir,EFro,Wrk,lWrk)

call mma_deallocate(Wrk)

call ChoMP2g_density3(irc,CMO)

end subroutine ChoMP2g_DensDrv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CLagDX(Mode,iSym,iCase,VEC1,VEC2,VEC3,VEC4,nIN,nIS,nAS,nState,VECROT,VEC5,lg_V2,BDERmat,SDERmat)

use EQSOLV, only: IDBMAT, IDTMAT, IVECR
use caspt2_global, only: do_lindep, idSDMat, imag_shift, LUSBT, LUSTD, real_shift, sigma_p_epsilon
use caspt2_module, only: IFMSCOUP, JSTATE, MAXIT
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, King
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mode, iSym, iCase, nIN, nIS, nAS, nState, lg_V2
real(kind=wp), intent(in) :: VEC1(NIN*NIS), VEC3(NIN*NIS), VEC4(NAS*NIS), VECROT(nState), VEC5(NIN*NIS)
real(kind=wp), intent(inout) :: VEC2(NIN*NIS), BDERmat(NAS*NAS), SDERmat(NAS*NAS)
integer(kind=iwp) :: idB, idSD, idT, iICB, jICB
real(kind=wp) :: EigI, EigJ, SCAL, tmp
logical(kind=iwp) :: invar_act
real(kind=wp), allocatable :: EIG(:), TRANS(:), WRK1(:), WRK2(:), WRK3(:)

!! sigma^P may not introduce non-invariance, so the name may be
!! simply confusing. I just do not know how to apply the
!! non-canonical approach for the derivative of the exponential
!! that appears in the denominator of the sigma^P regularization
invar_act = .true.
if (sigma_p_epsilon /= Zero) invar_act = .false.

call mma_allocate(WRK1,nAS**2,Label='WRK1')
call mma_allocate(WRK2,max(nAS**2,nAS*nIS),Label='WRK2')
call mma_allocate(WRK3,nAS**2,Label='WRK3')
call mma_allocate(TRANS,nAS*nIN,Label='TRANS')
call mma_allocate(EIG,nIN,Label='EIG')

idT = idTMAT(iSym,iCase)
call DDAFILE(LUSBT,2,TRANS,nAS*nIN,idT)
idB = idBMAT(iSym,iCase)
call DDAFILE(LUSBT,2,EIG,nIN,idB)

SCAL = One
if (IFMSCOUP) SCAL = VECROT(jState)

!! VEC1: solution in IC basis
!! VEC2: lambda   in IC basis
!! VEC3: RHS      in IC basis
!! VEC4: RHS      in MO basis

!! Form the density in internally contracted basis
!! The G subspace is employed in the following comments
!! as an example.
!! i  : inactive
!! a,b: secondary
!! t,u: active
!! o,p: internally contracted configuration (basis)
!! WRK1(o,p) = \sum_{iab} T_{o,i}^{ab}*T_{p,i}^{ab}
!! WRK1 is the effective density in the IC basis,
!! and will be the B derivative contribution.

if (Mode == 0) then
  !! WRK1 = T*T
  call DGEMM_('N','T',nIN,nIN,nIS,SCAL,VEC1,nIN,VEC1,nIN,Zero,WRK1,nIN)
else
  WRK1(1:nIN*nIN) = Zero
end if

if ((real_shift /= Zero) .or. (imag_shift /= Zero) .or. (sigma_p_epsilon /= Zero) .or. IFMSCOUP) then
  !! WRK1 = T*T + (T*lambda+lambda*T)/2
  !! For sigma-p CASPT2, this if branch computes the pseudo-
  !! density that comes from the numerator of the shift.
  call DGEMM_('N','T',nIN,nIN,nIS,Half,VEC2,nIN,VEC1,nIN,One,WRK1,nIN)
  call DGEMM_('N','T',nIN,nIN,nIS,Half,VEC1,nIN,VEC2,nIN,One,WRK1,nIN)
end if
if ((sigma_p_epsilon /= Zero) .and. (mode == 0)) then
  !! the remaining is the derivative of 2<1|H|0>, so the unscaled
  !! lambda is loaded
# ifdef _MOLCAS_MPP_
  !! --- To Do ---
  !! Parallel sigma^P gradient does not work at the moment. I know
  !! that the next part has to be fixed, but it is not possible to
  !! load the unscaled lambda in the KING environment, so this
  !! subroutine should be completely rewritten or an additional
  !! (relatively large) array has to be allocated. The number of
  !! allocated VEC arrays is already large (5?), so it is better
  !! to rewrite this subroutine...
  if (Is_Real_Par()) then
    if (KING()) call GA_GET(lg_V2,1,NIN,1,NIS,VEC2,NIN)
  else
# endif
    call RHS_READ_SR(lg_V2,ICASE,ISYM,iVecR)
# ifdef _MOLCAS_MPP_
  end if
# endif
end if

if (invar_act) then
  !! Transform the internally contracted density to
  !! active MO basis
  !! WRK3(t,u) = ST(t,o)*WRK1(o,p)*ST(u,p)
  !! WRK3 is the derivative contribution of the B matrix
  !! in the MO basis
  call DGEMM_('N','N',nAS,nIN,nIN,One,TRANS,nAS,WRK1,nIN,Zero,WRK2,nAS)
  call DGEMM_('N','T',nAS,nAS,nIN,One,WRK2,nAS,TRANS,nAS,Zero,WRK3,nAS)
  !write(u6,*) 'B derivative in MO'
  !call sqprt(WRK3,nas)

  !! Implicit derivative of the IC vector. This derivative
  !! comes from the derivative of the eigenvalue only. Other
  !! contributions of the derivative of the IC vector is
  !! considered later.
  !! -(e_o + e_p)*dS/da
  do jICB=1,nIN
    EigJ = EIG(jICB)
    WRK1(nIN*(jICB-1)+1:nIN*jICB) = -WRK1(nIN*(jICB-1)+1:nIN*jICB)*(EIG(:)+EigJ)*Half
  end do
else
  WRK3(1:NIN**2) = WRK1(1:NIN**2)
  WRK1(1:NIN**2) = Zero
end if

!! Derivative of the overlap in the IC basis.
!! WRK1(o,p) = WRK1(o,p) - T_{o,i}^{ab}*RHS(p,i,a,b)
!! This contribution should not be done for the imaginary
!! shift-specific term
!  1) Implicit overlap derivative of the 2<1|H|0> part
if (Mode == 0) then
  !! WRK1 = -RHS*T
  call DGEMM_('N','T',nIN,nIN,nIS,-One,VEC5,nIN,VEC1,nIN,One,WRK1,nIN)
  !! WRK1 = -RHS*(T+lambda/2)
  if ((real_shift /= Zero) .or. (imag_shift /= Zero) .or. (sigma_p_epsilon /= Zero) .or. IFMSCOUP) &
    call DGEMM_('N','T',nIN,nIN,nIS,-Half,VEC3,nIN,VEC2,nIN,One,WRK1,nIN)
end if

if (.not. invar_act) then
  !! it seems that only the diagonal elements are correct?
  !! construct the off-diagonal
  do iICB=1,NIN
    EigI = EIG(iICB)
    do jICB=1,iICB-1 !NIN
      EigJ = EIG(jICB)
      tmp = (WRK1(iICB+NIN*(jICB-1))-WRK1(jICB+NIN*(iICB-1)))/(EigI-EigJ)
      WRK3(iICB+NIN*(jICB-1)) = tmp
      WRK3(jICB+NIN*(iICB-1)) = tmp
    end do
  end do
  !! -(e_o + e_p)*dS/da
  do jICB=1,nIN
    EigJ = EIG(jICB)
    WRK1(nIN*(jICB-1)+1:nIN*jICB) = WRK1(nIN*(jICB-1)+1:nIN*jICB)-WRK3(nIN*(jICB-1)+1:nIN*jICB)*(EIG(:)+EigJ)*Half
  end do
  !! IC -> MO (B matrix)
  call DGEMM_('N','N',nAS,nIN,nIN,One,TRANS,nAS,WRK3,nIN,Zero,WRK2,nAS)
  call DGEMM_('N','T',nAS,nAS,nIN,One,WRK2,nAS,TRANS,nAS,Zero,WRK3,nAS)
end if
!! Convert the IC basis to the MO basis
call DGEMM_('N','N',nAS,nIN,nIN,One,TRANS,nAS,WRK1,nIN,Zero,WRK2,nAS)
call DGEMM_('N','T',nAS,nAS,nIN,One,WRK2,nAS,TRANS,nAS,Zero,WRK1,nAS)

!! Add some trivial contributions due to the dependence
!! on the linearly independent space
if (do_lindep .and. (nAS /= nIN)) call LinDepLag(WRK3,WRK1,nAS,nIN,iSym,iCase)

!  2) Explicit overlap derivative of the 2<1|H|0> part
!     Again, not for imaginary shift-specific terms
if (Mode == 0) then
  !! E = 2<1|H|0> + <1|H0-E0|1>
  call DGEMM_('N','N',nAS,nIS,nIN,SCAL,TRANS,nAS,VEC1,nIN,Zero,WRK2,nAS)
  if ((real_shift /= Zero) .or. (imag_shift /= Zero) .or. (sigma_p_epsilon /= Zero) .or. IFMSCOUP) &
    call DGEMM_('N','N',nAS,nIS,nIN,Half,TRANS,nAS,VEC2,nIN,One,WRK2,nAS)
  call DGEMM_('N','T',nAS,nAS,nIS,Two,WRK2,nAS,VEC4,nAS,One,WRK1,nAS)
end if

!! Add the contributions from the off-diagonal coupling
!! (i.e., CASPT2-N). Of course, this is not for imaginary shift-
!! specific terms.
if ((MAXIT /= 0) .and. (Mode == 0)) then
  idSD = idSDMat(iSym,iCase)
  call DDAFILE(LuSTD,2,WRK2,nAS*nAS,idSD)
  !! T*(T+lambda) + (T+lambda)*T is saved, so 1/2
  WRK1(1:NAS**2) = WRK1(1:NAS**2)+Half*WRK2(1:NAS**2)
end if

if (mode == 0) then
  BDERmat(1:NAS**2) = BDERmat(1:NAS**2)+WRK3(1:NAS**2)
  SDERmat(1:NAS**2) = SDERmat(1:NAS**2)+WRK1(1:NAS**2)
else
  BDERmat(1:NAS**2) = BDERmat(1:NAS**2)-WRK3(1:NAS**2)
  SDERmat(1:NAS**2) = SDERmat(1:NAS**2)-WRK1(1:NAS**2)
end if

call mma_deallocate(WRK1)
call mma_deallocate(WRK2)
call mma_deallocate(WRK3)
call mma_deallocate(TRANS)
call mma_deallocate(EIG)

end subroutine CLagDX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************
subroutine TransferMO(MOas,TabMO,mAO,mGrid,nMOs,iAO)
! Purpose:
! Transferring MO information to MOas to be used in dgemm.
! It records the MO values on each grid point, too.
! But the difference from TransActMO is that the first and
! the second elements are the values of the first MO at grid
! point 1 and grid point 2.

use nq_Info, only: mIrrep, mOrb, nOrbt, OffBasFro
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mAO, mGrid, nMOs, iAO
real(kind=wp), intent(out) :: MOas(mGrid,nOrbt)
real(kind=wp), intent(in) :: TabMO(mAO,mGrid,nMOs)
integer(kind=iwp) :: iIrrep, IOff1, iOff2

IOff2 = 0
do iIrrep=0,mIrrep-1
  IOff1 = OffBasFro(iIrrep)
  MOas(:,IOff2+1:IOff2+mOrb(iIrrep)) = TabMO(iAO,:,IOff1+1:IOff1+mOrb(iIrrep))
  IOff2 = IOff2+mOrb(iIrrep)
end do

return

end subroutine TransferMO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MQCT(AREF,EREF,CI,SGM,ICI)

use mrci_global, only: CSPCK, ENGY, ESHIFT, ESMALL, ETHRE, FOCK, GFAC, HZERO, ICPF, IDFREE, IDISKC, IDISKS, INDX, INTSY, IPRINT, &
                       IREFX, IROOT, ISAB, ISMAX, ITER, JREFX, KBUFF1, LUEIG, LUREST, MAXIT, MBUF, MXVEC, MXZ, NBMN, NCONF, NNEW, &
                       NREF, NRROOT, NSECT, NSTOT, NVEC, NVMAX, NVSQ, NVTOT, SQNLIM, SZERO, VSMALL, VZERO
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
real(kind=wp), intent(in) :: AREF(NREF,NREF), EREF(NREF)
real(kind=wp), intent(out) :: CI(NCONF), SGM(NCONF)
integer(kind=iwp), intent(out) :: ICI(MBUF)
#include "warnings.h"
integer(kind=iwp) :: I, IBUF, ICSF, IDISK, IDREST, IEND, II, III, IMAX, IMIN, IPOS, IR, IRR, ISTA, IVEC, J, K, KK, KL, L, LL, &
                     NCONV, NN, NRON, NZ
real(kind=wp) :: C, C2NREF, C2REF, CPTIT, CPTNOW, CPTOLD, CPTOT, CPTSTA, DUM, EACPF, ECI, EDAV, EDISP, ELOW, EMIN, ENREF, H, P, &
                 PMAX, QACPF, QDAV, RSUM, S, SQNRM, THR, TMP
integer(kind=iwp), allocatable :: IBMN(:), IDC(:), IDS(:)
real(kind=wp), allocatable :: ABIJ(:), AC1(:), AC2(:), AIBJ(:), AJBI(:), ARR(:,:,:), ASCR1(:), ASCR2(:), BFIN3(:), BFIN4(:), &
                              BIAC2(:), BICA2(:), BMN(:), BSCR1(:), BSCR2(:), CBUF(:,:), CNEW(:,:), CSECT(:,:), DBK(:), DBUF(:), &
                              ELAST(:), EZERO(:), FSCR1(:), FSCR2(:), FSEC(:), HCOPY(:,:), HSMALL(:,:), PCOPY(:,:), PSEL(:), &
                              PSMALL(:,:), RNRM(:), RSECT(:,:), SBUF(:,:), SCOPY(:,:), SCR(:), SSMALL(:,:), XI1(:,:), XI2(:,:)
real(kind=r8), external :: DDOT_

call mma_allocate(CBUF,MBUF,MXVEC,label='CBUF')
call mma_allocate(SBUF,MBUF,MXVEC,label='SBUF')
call mma_allocate(DBUF,MBUF,label='DBUF')
call mma_allocate(CSECT,NSECT,MXVEC,label='CSECT')
call mma_allocate(RSECT,NSECT,MXVEC,label='RSECT')
call mma_allocate(XI1,NSECT,NRROOT,label='XI1')
call mma_allocate(XI2,NSECT,NRROOT,label='XI2')
call mma_allocate(CNEW,NSECT,NRROOT,label='CNEW')
call mma_allocate(SCR,MXVEC*MBUF,label='SCR')
call mma_allocate(IDC,MXVEC,label='IDC')
call mma_allocate(IDS,MXVEC,label='IDS')
call mma_allocate(ELAST,NRROOT,label='ELAST')
call mma_allocate(HCOPY,MXVEC,MXVEC,label='HCOPY')
call mma_allocate(PCOPY,MXVEC,MXVEC,label='PCOPY')
call mma_allocate(SCOPY,MXVEC,MXVEC,label='SCOPY')
call mma_allocate(PSEL,MXVEC,label='PSEL')
call mma_allocate(RNRM,NRROOT,label='RNRM')
call mma_allocate(HSMALL,MXVEC,MXVEC,label='HSMALL')
call mma_allocate(SSMALL,MXVEC,MXVEC,label='SSMALL')
call mma_allocate(PSMALL,MXVEC,MXVEC,label='PSMALL')
call mma_allocate(EZERO,MXZ,label='EZERO')
call mma_allocate(HZERO,MXZ,MXZ,label='HZERO')
call mma_allocate(SZERO,MXZ,MXZ,label='SZERO')
call mma_allocate(VZERO,MXZ,MXZ,label='VZERO')

write(u6,*)
write(u6,*) ('-',I=1,60)
if (ICPF == 0) then
  write(u6,*) '   MR SDCI CALCULATION.'
else
  write(u6,*) '   MR ACPF CALCULATION.'
end if
write(u6,*) ('-',I=1,60)
write(u6,*)
write(u6,*) '         CONVERGENCE STATISTICS:'
write(u6,'(1X,A)') 'ITER NVEC     ENERGIES    LOWERING RESIDUAL SEL.WGT CPU(S) CPU TOT'
ITER = 0
call SETTIM()
call TIMING(CPTNOW,DUM,DUM,DUM)
CPTOLD = CPTNOW
CPTSTA = CPTNOW
HSMALL(1,1) = Zero
! LOOP HEAD FOR CI ITERATIONS:
do
  ITER = ITER+1
  ! --------------------------------------------------------------------
  ! CALCULATE SIGMA ARRAYS FOR SHIFTED HAMILTONIAN IN MCSF BASIS:
  do I=1,NNEW
    IVEC = 1+mod(NVTOT-NNEW+I-1,MXVEC)
    IDISK = IDISKC(IVEC)
    do ISTA=1,NCONF,MBUF
      NN = min(MBUF,NCONF+1-ISTA)
      call iDAFILE(LUEIG,2,ICI,NN,IDISK)
      call UPKVEC(NN,ICI,CI(ISTA))
    end do
    call mma_allocate(BMN,NBMN,label='BMN')
    call mma_allocate(IBMN,NBMN,label='IBMN')
    call mma_allocate(BIAC2,ISMAX,label='BIAC2')
    call mma_allocate(BICA2,ISMAX,label='BICA2')
    call mma_allocate(BFIN3,KBUFF1,label='BFIN3')
    call mma_allocate(AC1,ISMAX,label='AC1')
    call mma_allocate(AC2,ISMAX,label='AC2')
    call mma_allocate(BFIN4,KBUFF1,label='BFIN4')
    call mma_allocate(ABIJ,NVSQ,label='ABIJ')
    call mma_allocate(AIBJ,NVSQ,label='AIBJ')
    call mma_allocate(AJBI,NVSQ,label='AJBI')
    call mma_allocate(ASCR1,NVMAX**2,label='ASCR1')
    call mma_allocate(BSCR1,NVMAX**2,label='BSCR1')
    call mma_allocate(FSCR1,NVSQ,label='FSCR1')
    call mma_allocate(FSEC,2*NVSQ,label='FSEC')
    call mma_allocate(ASCR2,NVMAX**2,label='ASCR2')
    call mma_allocate(BSCR2,NVMAX**2,label='BSCR2')
    call mma_allocate(FSCR2,NVSQ,label='FSCR2')
    call mma_allocate(DBK,2*NVSQ,label='DBK')
    call SIGMA(SGM,AREF,CI,INTSY,INDX,BMN,IBMN,BIAC2,BICA2,BFIN3,ISAB,AC1,AC2,BFIN4,ABIJ,AIBJ,AJBI,ASCR1,BSCR1,FSCR1,FSEC,FOCK, &
               ASCR2,BSCR2,FSCR2,DBK)
    call mma_deallocate(BMN)
    call mma_deallocate(IBMN)
    call mma_deallocate(BIAC2)
    call mma_deallocate(BICA2)
    call mma_deallocate(BFIN3)
    call mma_deallocate(AC1)
    call mma_deallocate(AC2)
    call mma_deallocate(BFIN4)
    call mma_deallocate(ABIJ)
    call mma_deallocate(AIBJ)
    call mma_deallocate(AJBI)
    call mma_deallocate(ASCR1)
    call mma_deallocate(BSCR1)
    call mma_deallocate(FSCR1)
    call mma_deallocate(FSEC)
    call mma_deallocate(ASCR2)
    call mma_deallocate(BSCR2)
    call mma_deallocate(FSCR2)
    call mma_deallocate(DBK)
    NSTOT = NSTOT+1
    ! WRITE IT OUT:
    IVEC = 1+mod(NSTOT-1,MXVEC)
    IDISK = IDISKS(IVEC)
    if (IDISK == -1) IDISK = IDFREE
    do ISTA=1,NCONF,MBUF
      NN = min(MBUF,NCONF+1-ISTA)
      call dDAFILE(LUEIG,1,SGM(ISTA),NN,IDISK)
    end do
    if (IDISK > IDFREE) then
      IDISKS(IVEC) = IDFREE
      IDFREE = IDISK
    end if
  end do
  ! --------------------------------------------------------------------
  ! NR OF VECTORS PRESENTLY RETAINED:
  NVEC = min(MXVEC,NVTOT)
  ! --------------------------------------------------------------------
  ! COPY HSMALL, SSMALL AND PSMALL IN REORDERED FORM, BY AGE:
  do L=NNEW+1,NVEC
    LL = 1+mod(NVTOT-L,MXVEC)
    do K=NNEW+1,NVEC
      KK = 1+mod(NVTOT-K,MXVEC)
      HCOPY(K,L) = HSMALL(KK,LL)
      SCOPY(K,L) = SSMALL(KK,LL)
      PCOPY(K,L) = PSMALL(KK,LL)
    end do
  end do
  ! CLEAR NEW AREAS TO BE USED:
  HCOPY(1:NVEC,1:NNEW) = Zero
  SCOPY(1:NVEC,1:NNEW) = Zero
  PCOPY(1:NVEC,1:NNEW) = Zero
  ! THEN LOOP OVER BUFFERS. FIRST GET COPIES OF DISK ADDRESSES:
  IDC(1:NVEC) = IDISKC(1:NVEC)
  IDS(1:NVEC) = IDISKS(1:NVEC)
  do ISTA=1,NCONF,MBUF
    IEND = min(NCONF,ISTA+MBUF-1)
    IBUF = 1+IEND-ISTA
    do K=1,NVEC
      KK = 1+mod(NVTOT-K,MXVEC)
      call iDAFILE(LUEIG,2,ICI,IBUF,IDC(KK))
      call UPKVEC(IBUF,ICI,CBUF(1,K))
      if (K <= NNEW) call dDAFILE(LUEIG,2,SBUF(1,K),IBUF,IDS(KK))
    end do
    ! ------------------------------------------------------------------
    ! NOTE: AT THIS POINT, THE COLUMNS NR 1..NVEC OF CBUF WILL
    ! CONTAIN THE BUFFERS OF, FIRST, THE NNEW NEWEST PSI ARRAYS,
    ! THEN, THE NOLD ONES FROM EARLIER ITERATIONS.
    ! THE COLUMNS 1..NNEW OF SBUF WILL CONTAIN THE NEWEST NNEW
    ! SIGMA ARRAYS. LEADING DIMENSION OF CBUF AND SBUF IS MBUF. ACTUAL
    ! BUFFER SIZE IS IBUF, WHICH CAN BE SMALLER. ACCUMULATE:
    call DGEMM_('T','N',NVEC,NNEW,IBUF,One,CBUF,MBUF,CBUF,MBUF,Zero,SCR,NVEC)
    KL = 0
    do L=1,NNEW
      do K=1,NVEC
        KL = KL+1
        SCOPY(K,L) = SCOPY(K,L)+SCR(KL)
      end do
    end do
    call DGEMM_('T','N',NVEC,NNEW,IBUF,One,CBUF,MBUF,SBUF,MBUF,Zero,SCR,NVEC)
    KL = 0
    do L=1,NNEW
      do K=1,NVEC
        KL = KL+1
        HCOPY(K,L) = HCOPY(K,L)+SCR(KL)
      end do
    end do
    ! ALSO, UPDATE PSMALL, WHICH IS USED FOR SELECTION.
    if (ISTA > IREFX(NRROOT)) cycle
    do I=1,NRROOT
      IR = IROOT(I)
      IRR = IREFX(IR)
      if ((IRR < ISTA) .or. (IRR > IEND)) cycle
      IPOS = IRR+1-ISTA
      do L=1,NNEW
        PCOPY(1:NVEC,L) = PCOPY(1:NVEC,L)+CBUF(IPOS,1:NVEC)*CBUF(IPOS,L)
      end do
    end do
  end do
  ! TRANSFER ELEMENTS BACK TO HSMALL, ETC.
  do L=1,NNEW
    LL = 1+mod(NVTOT-L,MXVEC)
    do K=1,NVEC
      KK = 1+mod(NVTOT-K,MXVEC)
      H = HCOPY(K,L)
      S = SCOPY(K,L)
      P = PCOPY(K,L)
      HCOPY(L,K) = H
      SCOPY(L,K) = S
      PCOPY(L,K) = P
      HSMALL(KK,LL) = H
      SSMALL(KK,LL) = S
      PSMALL(KK,LL) = P
      HSMALL(LL,KK) = H
      SSMALL(LL,KK) = S
      PSMALL(LL,KK) = P
    end do
  end do
  if (IPRINT >= 10) then
    write(u6,*)
    write(u6,*) ' HSMALL MATRIX:'
    do I=1,NVEC
      write(u6,'(1X,5F15.6)') (HSMALL(I,J),J=1,NVEC)
    end do
    write(u6,*)
    write(u6,*) ' SSMALL MATRIX:'
    do I=1,NVEC
      write(u6,'(1X,5F15.6)') (SSMALL(I,J),J=1,NVEC)
    end do
    write(u6,*)
    write(u6,*) ' PSMALL MATRIX:'
    do I=1,NVEC
      write(u6,'(1X,5F15.6)') (PSMALL(I,J),J=1,NVEC)
    end do
    !write(u6,*)
    !write(u6,*)
    !write(u6,*) ' HCOPY MATRIX:'
    !do I=1,NVEC
    !  write(u6,'(1X,5F15.6)') (HCOPY(I,J),J=1,NVEC)
    !end do
    !write(u6,*)
    !write(u6,*) ' SCOPY MATRIX:'
    !do I=1,NVEC
    !  write(u6,'(1X,5F15.6)') (SCOPY(I,J),J=1,NVEC)
    !end do
    !write(u6,*)
  end if
  ! --------------------------------------------------------------------
  ! THE UPPER-LEFT NVEC*NVEC SUBMATRICES OF HSMALL AND SSMALL NOW
  ! CONTAINS THE CURRENT HAMILTONIAN AND OVERLAP MATRICES, IN THE
  ! BASIS OF PRESENTLY RETAINED PSI VECTORS. DIAGONALIZE, BUT USE
  ! THE REORDERED MATRICES IN SCOPY, HCOPY. THERE THE BASIS
  ! FUNCTIONS ARE ORDERED BY AGE.
  THR = 1.0e-6_wp
  call SECULAR(MXVEC,NVEC,NRON,HCOPY,SCOPY,VSMALL,ESMALL,SCR,THR)
  ! REORDER THE ELEMENTS OF VSMALL TO GET EIGENVECTORS OF HSMALL. NOTE:
  ! THIS IS NOT THE SAME AS IF WE DIAGONALIZED HSMALL DIRECTLY.
  ! THE DIFFERENCE OCCURS WHENEVER VECTORS ARE THROWN OUT OF THE
  ! CALCULATION IN SECULAR BECAUSE OF LINEAR DEPENDENCE. THE RESULT
  ! WILL DEPEND SLIGHTLY BUT CRITICALLY ON THE ORDER BY WHICH THE
  ! VECTORS WERE ORTHONORMALIZED.
  do I=1,NRON
    do K=1,NVEC
      KK = 1+mod(NVTOT-K,MXVEC)
      SCR(KK) = VSMALL(K,I)
    end do
    do K=1,NVEC
      VSMALL(K,I) = SCR(K)
    end do
  end do
  if (NRON < NRROOT) then
    write(u6,*) 'DIAGRO Error: Linear dependence has reduced'
    write(u6,*) ' the number of solutions to NRON, but you'
    write(u6,*) ' wanted NRROOT soultions.'
    write(u6,'(1X,A,I3)') '  NRON=',NRON
    write(u6,'(1X,A,I3)') 'NRROOT=',NRROOT
    call QUIT(_RC_INTERNAL_ERROR_)
  end if
  ! ORDER THE EIGENFUNCTIONS BY DECREASING OVERLAP WITH THE SPACE
  ! SPANNED BY THE ORIGINALLY SELECTED REFCI ROOTS.
  call DGEMM_('N','N',NVEC,NRON,NVEC,One,PSMALL,MXVEC,VSMALL,MXVEC,Zero,SCR,NVEC)
  II = 1
  do I=1,NRON
    PSEL(I) = DDOT_(NVEC,VSMALL(1,I),1,SCR(II),1)
    II = II+NVEC
  end do
  ! PSEL(I) NOW CONTAINS EXPECTATION VALUE OF PMAT FOR I-TH EIGENVECTOR.
  !write(u6,*) ' ARRAY OF SELECTION AMPLITUDES IN SCR:'
  !write(u6,'(1X,5F15.6)') (PSEL(I),I=1,NRON)
  do I=1,NRON-1
    IMAX = I
    PMAX = PSEL(I)
    do J=I+1,NRON
      if (PSEL(J) >= PMAX) then
        PMAX = PSEL(J)
        IMAX = J
      end if
    end do
    if (IMAX == I) cycle
    PSEL(IMAX) = PSEL(I)
    PSEL(I) = PMAX
    TMP = ESMALL(IMAX)
    ESMALL(IMAX) = ESMALL(I)
    ESMALL(I) = TMP
    do K=1,NVEC
      TMP = VSMALL(K,IMAX)
      VSMALL(K,IMAX) = VSMALL(K,I)
      VSMALL(K,I) = TMP
    end do
  end do
  ! FINALLY, REORDER THE SELECTED ROOTS BY ENERGY:
  do I=1,NRROOT-1
    IMIN = I
    EMIN = ESMALL(I)
    do J=I+1,NRROOT
      if (ESMALL(J) < EMIN) then
        EMIN = ESMALL(J)
        IMIN = J
      end if
    end do
    if (IMIN == I) cycle
    ESMALL(IMIN) = ESMALL(I)
    ESMALL(I) = EMIN
    TMP = PSEL(IMIN)
    PSEL(IMIN) = PSEL(I)
    PSEL(I) = TMP
    do K=1,NVEC
      TMP = VSMALL(K,IMIN)
      VSMALL(K,IMIN) = VSMALL(K,I)
      VSMALL(K,I) = TMP
    end do
  end do
  !write(u6,*) ' EIGENVALUES OF HSMALL. NRON=',NRON
  !write(u6,'(1X,5F15.6)') (ESMALL(I),I=1,NRON)
  !write(u6,*) ' SELECTION WEIGHTS:'
  !write(u6,'(1X,5F15.6)') (   PSEL(I),I=1,NRON)
  !write(u6,*) ' SELECTED EIGENVECTORS:'
  !do I=1,NRROOT
  !  write(u6,'(1X,5F15.6)') (VSMALL(K,I),K=1,NVEC)
  !end do
  !write(u6,*)
  ! --------------------------------------------------------------------
  ! CALCULATE RESIDUAL ARRAYS FOR THE NRROOTS EIGENFUNCTIONS OF HSMALL.
  ! ALSO, USE THE OPPORTUNITY TO FORM MANY OTHER SMALL ARRAYS.
  call mma_allocate(ARR,NRROOT,NRROOT,11,label='ARR')
  call HZLP1(CBUF,SBUF,DBUF,ARR,CSECT,RSECT,XI1,XI2,ICI)
  ! USE THESE SMALLER ARRAYS TO FORM HZERO AND SZERO. THIS IS
  ! OVERLAP AND HAMILTONIAN IN THE BASIS (PSI,RHO,XI1,XI2), WHERE
  ! PSI ARE THE EIGENFUNCTIONS OF HSMALL, RHO ARE RESIDUALS, ETC.
  call HZ(ARR)
  call mma_deallocate(ARR)
  NZ = 4*NRROOT
  !write(u6,*)
  !write(u6,*) ' AFTER HZ CALL. HZERO HAMILTONIAN:'
  !do I=1,NZ
  !  write(u6,'(1X,5F15.6)') (HZERO(I,J),J=1,NZ)
  !end do
  !write(u6,*) ' SZERO:'
  !do I=1,NZ
  !  write(u6,'(1X,5F15.6)') (SZERO(I,J),J=1,NZ)
  !end do
  do I=1,NRROOT
    RNRM(I) = sqrt(SZERO(NRROOT+I,NRROOT+I))
    !EPERT(I) = ESMALL(I)-SZERO(3*NRROOT+I,NRROOT+I)
  end do
  !write(u6,*)
  !write(u6,*) ' PERTURBATION ESTIMATES TO ENERGY:'
  !write(u6,'(1X,5F15.6)') (ESHIFT+EPERT(I),I=1,NRROOT)
  ! --------------------------------------------------------------------
  NCONV = 0
  call TIMING(CPTNOW,DUM,DUM,DUM)
  CPTIT = CPTNOW-CPTOLD
  CPTOLD = CPTNOW
  CPTOT = CPTNOW-CPTSTA
  if (ITER == 1) then
    EDISP = ESMALL(1)+ESHIFT
    write(u6,1234) ITER,NVEC,EDISP,RNRM(1),PSEL(1),CPTIT,CPTOT
  else
    ELOW = ESMALL(1)-ELAST(1)
    if ((ELOW < Zero) .and. (abs(ELOW) <= ETHRE)) NCONV = 1
    EDISP = ESMALL(1)+ESHIFT
    write(u6,1235) ITER,NVEC,EDISP,ELOW,RNRM(1),PSEL(1),CPTIT,CPTOT
  end if
  if (NRROOT > 1) then
    do I=2,NRROOT
      EDISP = ESMALL(I)+ESHIFT
      if (ITER == 1) then
        write(u6,1236) EDISP,RNRM(I),PSEL(I)
      else
        ELOW = ESMALL(I)-ELAST(I)
        if ((ELOW < Zero) .and. (abs(ELOW) <= ETHRE)) NCONV = NCONV+1
        write(u6,1237) EDISP,ELOW,RNRM(I),PSEL(I)
      end if
    end do
    write(u6,*)
  end if
  do I=1,NRROOT
    ELAST(I) = ESMALL(I)
  end do
  if (NCONV == NRROOT) then
    write(u6,*) ' CONVERGENCE IN ENERGY.'
    exit
  end if
  ! --------------------------------------------------------------------
  THR = 1.0e-6_wp
  call SECULAR(MXZ,NZ,NRON,HZERO,SZERO,VZERO,EZERO,SCR,THR)
  !write(u6,*) ' AFTER SECULAR CALL. NRON=',NRON
  !write(u6,*) ' EIGENVALUES & -VECTORS:'
  !do I=1,NRON
  !  write(u6,'(1X,5F15.6)') EZERO(I)
  !  write(u6,'(1X,5F15.6)') (VZERO(K,I),K=1,NZ)
  !end do
  ! ORDER THE EIGENFUNCTIONS BY DECREASING SIZE OF PSI PART.
  call DGEMM_('T','N',NRON,NRROOT,NZ,One,VZERO,MXZ,SZERO,MXZ,Zero,SCR(1+NRON),NRON)
  do I=1,NRON
    II = I
    RSUM = Zero
    do K=1,NRROOT
      II = II+NRON
      RSUM = RSUM+SCR(II)**2
    end do
    SCR(I) = RSUM
  end do
  !write(u6,*)
  !write(u6,*) ' SELECTION CRITERION VECTOR, BEFORE ORDERING:'
  !write(u6,'(1X,5F15.6)') (SCR(I),I=1,NRON)
  do I=1,NRON-1
    IMAX = I
    PMAX = SCR(I)
    do J=I+1,NRON
      if (SCR(J) >= PMAX) then
        PMAX = SCR(J)
        IMAX = J
      end if
    end do
    if (IMAX == I) cycle
    SCR(IMAX) = SCR(I)
    SCR(I) = PMAX
    TMP = EZERO(IMAX)
    EZERO(IMAX) = EZERO(I)
    EZERO(I) = TMP
    do K=1,NZ
      TMP = VZERO(K,IMAX)
      VZERO(K,IMAX) = VZERO(K,I)
      VZERO(K,I) = TMP
    end do
  end do
  !PAM 94-10-30, must reorder as before:
  ! REORDER THE SELECTED ROOTS BY ENERGY:
  do I=1,NRROOT-1
    IMIN = I
    EMIN = EZERO(I)
    do J=I+1,NRROOT
      if (EZERO(J) < EMIN) then
        EMIN = EZERO(J)
        IMIN = J
      end if
    end do
    if (IMIN == I) cycle
    EZERO(IMIN) = EZERO(I)
    EZERO(I) = EMIN
    TMP = SCR(IMIN)
    SCR(IMIN) = SCR(I)
    SCR(I) = TMP
    do K=1,NZ
      TMP = VZERO(K,IMIN)
      VZERO(K,IMIN) = VZERO(K,I)
      VZERO(K,I) = TMP
    end do
  end do
  !PAM 94-10-30, end of update.
  ! NOTE: IF THE UPDATE PART IS SMALL ENOUGH FOR ALL THE FIRST NRROOT
  ! ARRAY, THE CALCULATION HAS CONVERGED.
  NNEW = 0
  !write(u6,*) ' CONVERGENCE CRITERION: SIZE OF UPDATE PART.'
  do I=1,NRROOT
    SQNRM = One-SCR(I)
    !write(u6,*) ' ROOT NR, SQNRM:',I,SQNRM
    if (SQNRM >= SQNLIM) NNEW = NNEW+1
  end do
  !write(u6,*)
  !write(u6,*) ' EIGENVALUES OF THE HZERO HAMILTONIAN:'
  !write(u6,'(1X,5F15.6)') (EZERO(I),I=1,NRON)
  !write(u6,*) ' SELECTION WEIGHTS:'
  !write(u6,'(1X,5F15.6)') (SCR(I),I=1,NRON)
  !write(u6,*) ' EIGENVECTORS:'
  !do I=1,NRON
  !  write(u6,'(1X,5F15.6)') (VZERO(K,I),K=1,NZ)
  !end do
  !write(u6,*) ' NR OF NEW VECTORS SELECTED, NNEW:',NNEW
  if (NNEW == 0) then
    write(u6,*) ' CONVERGENCE IN NORM.'
    exit
  end if
  ! NOTE: A CHANGE HERE. ALWAYS USE ALL THE NRROOT UPDATED VECTORS TO
  ! AVOID OVERWRITING AN EARLY CONVERGED VECTOR (WHICH HAS NEVER BEEN
  ! OUTDATED BY A LATER) BY A VECTOR BELONGING TO ANOTHER ROOT.
  NNEW = NRROOT
  ! --------------------------------------------------------------------
  ! FORM NEW UPDATED VECTORS: SKIP THE FIRST NRROOT-NNEW VECTORS,
  ! WHICH MAKE NO ESSENTIAL IMPROVEMENT.
  !write(u6,*) ' RESET VZERO TO (0,0,0,1) FOR CONVENTIONAL DAVIDSON.'
  !VZERO(:,1:NRROOT) = Zero
  !call DCOPY_(NRROOT,[One],0,VZERO(3*NRROOT+1,1),MXZ+1)
  call HZLP2(CBUF,SBUF,DBUF,CSECT,RSECT,XI1,XI2,CNEW,ICI)
  if (ITER >= MAXIT) then
    write(u6,*) ' UNCONVERGED.'
    exit
  end if
end do
call mma_deallocate(IDC)
call mma_deallocate(IDS)
call mma_deallocate(ELAST)
call mma_deallocate(HCOPY)
call mma_deallocate(PCOPY)
call mma_deallocate(SCOPY)
call mma_deallocate(PSEL)
call mma_deallocate(RNRM)
call mma_deallocate(HSMALL)
call mma_deallocate(SSMALL)
call mma_deallocate(PSMALL)
call mma_deallocate(EZERO)
call mma_deallocate(HZERO)
call mma_deallocate(SZERO)
call mma_deallocate(VZERO)
write(u6,*) ' ',('*',III=1,70)
! WRITE CI VECTORS TO LUREST -- CI RESTART FILE.
IDREST = 0
do I=1,NRROOT
  IVEC = 1+mod(NVTOT-NRROOT+I-1,MXVEC)
  IDISK = IDISKC(IVEC)
  do ISTA=1,NCONF,MBUF
    NN = min(MBUF,NCONF+1-ISTA)
    call iDAFILE(LUEIG,2,ICI,NN,IDISK)
    call UPKVEC(NN,ICI,CI(ISTA))
  end do
  call CSFTRA(' CSF',CI,AREF)
  C2REF = Zero
  do IR=1,NREF
    ICSF = IREFX(IR)
    C = CI(ICSF)
    C2REF = C2REF+C**2
  end do
  IR = IROOT(I)
  ECI = ESMALL(I)+ESHIFT
  ENREF = ECI-EREF(IR)
  C2NREF = One-C2REF
  ! WRITE ENERGIES TO PRINTED OUTPUT, AND SAVE TOTAL ENERGIES TO ENGY
  ! FOR LATER PRINTOUT WITH PROPERTIES:
  write(u6,'(A,I3)') '               FINAL RESULTS FOR STATE NR ',I
  write(u6,'(A,I3)') ' CORRESPONDING ROOT OF REFERENCE CI IS NR:',IR
  write(u6,'(A,F15.8)') '            REFERENCE CI ENERGY:',EREF(IR)
  write(u6,'(A,F15.8)') '         EXTRA-REFERENCE WEIGHT:',C2NREF
  if (ICPF == 1) then
    write(u6,'(A,F15.8)') '        ACPF CORRELATION ENERGY:',ENREF
    write(u6,'(A,F15.8)') '                    ACPF ENERGY:',ECI
    ENGY(I,1) = ECI
    ENGY(I,2) = Zero
    ENGY(I,3) = Zero
    call Add_Info('E_MRACPF',[ECI],1,8)
  else
    write(u6,'(A,F15.8)') '          CI CORRELATION ENERGY:',ENREF
    write(u6,'(A,F15.8)') '                      CI ENERGY:',ECI
    ! APPROXIMATE CORRECTIONS FOR UNLINKED QUADRUPLES:
    QDAV = ENREF*C2NREF/C2REF
    EDAV = ECI+QDAV
    QACPF = ENREF*(C2NREF*(One-GFAC))/(C2REF+GFAC*C2NREF)
    EACPF = ECI+QACPF
    write(u6,'(A,F15.8)') '            DAVIDSON CORRECTION:',QDAV
    write(u6,'(A,F15.8)') '               CORRECTED ENERGY:',EDAV
    write(u6,'(A,F15.8)') '                ACPF CORRECTION:',QACPF
    write(u6,'(A,F15.8)') '               CORRECTED ENERGY:',EACPF
    ENGY(I,1) = ECI
    ENGY(I,2) = QDAV
    ENGY(I,3) = QACPF
    call Add_Info('E_MRSDCI',[ECI],1,8)
  end if
  write(u6,*)
  call PRWF_MRCI(CSPCK,INTSY,INDX,CI,JREFX)
  write(u6,*) ' ',('*',III=1,70)
  call dDAFILE(LUREST,1,CI,NCONF,IDREST)
end do

call mma_deallocate(CBUF)
call mma_deallocate(SBUF)
call mma_deallocate(DBUF)
call mma_deallocate(CSECT)
call mma_deallocate(RSECT)
call mma_deallocate(XI1)
call mma_deallocate(XI2)
call mma_deallocate(CNEW)
call mma_deallocate(scr)

return

1234 format(1X,I4,1X,I4,1X,F15.8,9X,D9.2,1X,F6.3,2(1X,F7.1))
1235 format(1X,I4,1X,I4,1X,F15.8,D9.2,D9.2,1X,F6.3,2(1X,F7.1))
1236 format(11X,F15.8,9X,D9.2,1X,F6.3)
1237 format(11X,F15.8,D9.2,D9.2,1X,F6.3)

end subroutine MQCT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine RotateOrb_ER(R,CMO,nBasis,nOrb2Loc,Debug)
C
C     Thomas Bondo Pedersen, November 2005.
C
C     Purpose: rotate ER orbitals,
C              CMO -> CMO * U
C              U = R*[R^T*R]^(-1/2)
C
      Implicit Real*8 (a-h,o-z)
      Real*8  R(nOrb2Loc,nOrb2Loc), CMO(nBasis,nOrb2Loc)
      Logical Debug
#include "WrkSpc.fh"

      Character*12 SecNam
      Parameter (SecNam = 'RotateOrb_ER')

      If (nOrb2Loc.lt.1 .or. nBasis.lt.1) Return

C     Allocate transformation matrix U.
C     ---------------------------------

      lU = nOrb2Loc**2
      Call GetMem('Umat','Allo','Real',ipU,lU)

C     Compute U.
C     ----------

      Call GetU_ER(Work(ipU),R,nOrb2Loc)

C     Debug: check that U is unitary.
C     -------------------------------

      If (Debug) Then
         ThrU = 1.0d-10
         irc = -1
         Call Chk_Unitary(irc,Work(ipU),nOrb2Loc,ThrU)
         If (irc .ne. 0) Then
            Call SysAbendMsg(SecNam,'U matrix is not unitary!',' ')
         End If
      End If

C     Update C.
C     ---------

      lCMO = nBasis*nOrb2Loc
      Call GetMem('CMOscr','Allo','Real',ipCMO,lCMO)
      Call dCopy_(lCMO,CMO,1,Work(ipCMO),1)
      Call DGEMM_('N','N',nBasis,nOrb2Loc,nOrb2Loc,
     &           1.0d0,Work(ipCMO),nBasis,Work(ipU),nOrb2Loc,
     &           0.0d0,CMO,nBasis)
      Call GetMem('CMOscr','Free','Real',ipCMO,lCMO)

C     De-allocate U.
C     --------------

      Call GetMem('Umat','Free','Real',ipU,lU)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995,1998, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GSBBD1(RHO1,NACOB,ISCSM,ISCTP,ICCSM,ICCTP,IGRP,NROW,NGAS,ISEL,ICEL,SB,CB,MXPNGAS,NOBPTS,IOBPTS,MAXI,MAXK,SSCR,CSCR,I1, &
                  XI1S,I2,XI2S,NSMOB,RHO1S,SCLFAC,IPHGAS,IDOSRHO1,SRHO1,IAB)
! SUBROUTINE GSBBD1 --> 40
!
! Contributions to one electron density matrix from column excitations
!
! GAS version, August 95, Jeppe Olsen
! Particle-Hole version of Jan. 98
!
! =====
! Input
! =====
! RHO1  : One body density matrix to be updated
! NACOB : Number of active orbitals
! ISCSM,ISCTP : Symmetry and type of sigma columns
! ICCSM,ICCTP : Symmetry and type of C     columns
! IGRP : String group of columns
! NROW : Number of rows in S and C block
! NGAS : Number of active spaces
! ISEL : Number of electrons per AS for S block
! ICEL : Number of electrons per AS for C block
! CB   : Input C block
! MXPNGAS : Max number of AS spaces (program parameter)
! NOBPTS  : Number of orbitals per type and symmetry
! IOBPTS : base for orbitals of given type and symmetry
! IBORB  : Orbitals of given type and symmetry
! NSMOB  : Number of symmetries of orbitals
! MAXI   : Largest Number of "spectator strings" treated simultaneously
! MAXK   : Largest number of inner resolution strings treated at simult.
!
! ======
! Output
! ======
! RHO1 : Updated density block
!
! =======
! Scratch
! =======
!
! SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
!              largest number of orbital pairs of given symmetries and
!              types.
! I1, XI1S   : MAXK*Max number of orbitals of given type and symmetry
! I2, XI2S   : MAXK*Max number of orbitals of given type and symmetry
!              type and symmetry
! RHO1S : Space for one electron density
!
! Jeppe Olsen, Winter of 1991
! Updated for GAS, August '95

use Symmetry_Info, only: Mul
use Para_Info, only: MyRank, nProcs
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: RHO1(*), XI1S(*), XI2S(*), RHO1S(*), SRHO1(*)
integer(kind=iwp), intent(in) :: NACOB, ISCSM, ISCTP, ICCSM, ICCTP, IGRP, NROW, NGAS, ISEL(NGAS), ICEL(NGAS), MXPNGAS, &
                                 NOBPTS(MXPNGAS,*), IOBPTS(MXPNGAS,*), MAXI, MAXK, NSMOB, IPHGAS(*), IDOSRHO1, IAB
real(kind=wp), intent(in) :: SB(*), CB(*), SCLFAC
real(kind=wp), intent(_OUT_) :: SSCR(*), CSCR(*)
integer(kind=iwp), intent(inout) :: I1(*), I2(*)
integer(kind=iwp) :: IBIORB, IBJORB, IBOT, ICGOFF, ICGRP(16), IDOCOMP, IIORB, IIPART, IJ_AC(2), IJ_DIM(2), IJ_OFF(2), IJ_REO(2), &
                     IJ_SM(2), IJ_TP(2), IJSM, IJTP, IORB, ISGOFF, ISGRP(16), ISM, ITOP, ITP(256), ITYP, IXXX, JJORB, JORB, JSM, &
                     JTP(256), JTYP, KACT, KBOT, KEND, KTOP, LKABTC, NIBTC, NIORB, NIPART, NIPARTSZ, NJORB, NKAEFF, NKASTR, NKI, &
                     NSXTP
real(kind=wp) :: FACTORAB, FACTORC, SCLFACS, SIGNIJ, XAB

! Add or subtract for spindensity
if (IAB == 1) then
  XAB = One
else
  XAB = -One
end if
! Local arrays
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ================'
write(u6,*) ' GSBBu61 in action'
write(u6,*) ' ================'
write(u6,*)
write(u6,*) ' Occupation of active left strings'
call IWRTMA(ISEL,1,NGAS,1,NGAS)
write(u6,*) ' Occupation of active Right strings'
call IWRTMA(ICEL,1,NGAS,1,NGAS)
write(u6,*) ' ISCSM, ICCSM = ',ISCSM,ICCSM

write(u6,*) ' GSBBD1, sclfac ',SCLFAC
#endif

! Number of partitionings over column strings
!SVC: determine optimum number of partitions as the lowest multiple of
!     NPROCS that satisfies a block size smaller than MAXI:
NIPART = 0
do
  NIPART = NIPART+NPROCS
  NIPARTSZ = max(NROW-1,0)/NIPART+1
  if (NIPARTSZ <= MAXI) exit
end do

! Groups defining supergroups
!    GET_SPGP_INF(ISPGP,ITP,IGRP)
call GET_SPGP_INF(ICCTP,IGRP,ICGRP)
call GET_SPGP_INF(ISCTP,IGRP,ISGRP)

! Type of single excitations that connects the two column strings
call SXTYP2_GAS(NSXTP,ITP,JTP,NGAS,ISEL,ICEL,IPHGAS)
! Symmetry of single excitation that connects IBSM and JBSM
IJSM = Mul(ISCSM,ICCSM)
#ifdef _DEBUGPRINT_
write(u6,*) ' ISCSM,ICCSM IJSM ',ISCSM,ICCSM,IJSM
#endif
if (IJSM /= 0) then
  do IJTP=1,NSXTP
    ITYP = ITP(IJTP)
    JTYP = JTP(IJTP)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' ITYP JTYP ',ITYP,JTYP
#   endif
    ! Hvilken vej skal vi valge,
    ! Mi pojdem drugim putem (C)
    ! VV: the code below confuses Absoft compiler and was rewritten.
    !NOP = 2
    IJ_AC(1) = 2
    IJ_AC(2) = 1
    IJ_TP(1) = ITYP
    IJ_TP(2) = JTYP
    !if (IUSE_PH == 1) call ALG_ROUTERX(IAOC,JAOC,NOP,IJ_TP,IJ_AC,IJ_REO,SIGNIJ)
    IJ_REO(1) = 1
    IJ_REO(2) = 2
    SIGNIJ = One
    !end if

    if (IJ_REO(1) == 1) then

      IJ_TP(1) = ITYP
      IJ_TP(2) = JTYP
    else
      IXXX = IJ_AC(1)
      IJ_AC(1) = IJ_AC(2)
      IJ_AC(2) = IXXX

      !ISCR(1) = ITYP
      !ISCR(2) = JTYP
      IJ_TP(1) = JTYP
      IJ_TP(2) = ITYP
    end if

    !ISCR(1) = IJ_AC(1)
    !ISCR(2) = IJ_AC(2)
    !IJ_AC(1) = ISCR(IJ_REO(1))
    !IJ_AC(2) = ISCR(IJ_REO(2))

    ! nasty code to avoid optimization
    !if (iscr(1) == -1000) write(u6,*) IJ_TP,IJ_REO
    !ISCR(1) = ITYP
    !ISCR(2) = JTYP
    !IJ_TP(1) = ISCR(IJ_REO(1))
    !IJ_TP(2) = ISCR(IJ_REO(2))

    do ISM=1,NSMOB
      ! new i and j so new intermediate strings

      JSM = Mul(ISM,IJSM)
      if (JSM == 0) cycle
#     ifdef _DEBUGPRINT_
      write(u6,*) ' ISM JSM ',ISM,JSM
#     endif
      NIORB = NOBPTS(ITYP,ISM)
      NJORB = NOBPTS(JTYP,JSM)
      IBIORB = IOBPTS(ITYP,ISM)
      IBJORB = IOBPTS(JTYP,JSM)
      ! Reorder
      !ISCR(1) = ISM
      !ISCR(2) = JSM
      !IJ_SM(1) = ISCR(IJ_REO(1))
      !IJ_SM(2) = ISCR(IJ_REO(2))

      !ISCR(1) = NIORB
      !ISCR(2) = NJORB
      !IJ_DIM(1) = ISCR(IJ_REO(1))
      !IJ_DIM(2) = ISCR(IJ_REO(2))

      !ISCR(1) = IBIORB
      !ISCR(2) = IBJORB
      !IJ_OFF(1) = ISCR(IJ_REO(1))
      !IJ_OFF(2) = ISCR(IJ_REO(2))

      if (IJ_REO(1) == 1) then
        IJ_SM(1) = ISM
        IJ_SM(2) = JSM
        IJ_DIM(1) = NIORB
        IJ_DIM(2) = NJORB
        IJ_OFF(1) = IBIORB
        IJ_OFF(2) = IBJORB
      else
        IJ_SM(1) = JSM
        IJ_SM(2) = ISM
        IJ_DIM(1) = NJORB
        IJ_DIM(2) = NIORB
        IJ_OFF(1) = IBJORB
        IJ_OFF(2) = IBIORB
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) ' NIORB NJORB ',NIORB,NJORB
#     endif
      if ((NIORB == 0) .or. (NJORB == 0)) cycle

      ! For operator connecting to |Ka> and |Ja> i.e. operator 2
      SCLFACS = SCLFAC*SIGNIJ
#     ifdef _DEBUGPRINT_
      write(u6,*) ' IJ_SM,IJ_TP,IJ_AC',IJ_SM(2),IJ_TP(2),IJ_AC(2)
#     endif
      call ADAST_GAS(IJ_SM(2),IJ_TP(2),NGAS,ICGRP,ICCSM,I1,XI1S,NKASTR,KACT,SCLFACS,IJ_AC(1))
      ! For operator connecting |Ka> and |Ia>, i.e. operator 1
      if (NKASTR == 0) cycle
      call ADAST_GAS(IJ_SM(1),IJ_TP(1),NGAS,ISGRP,ISCSM,I2,XI2S,NKASTR,KACT,One,IJ_AC(1))
      if (NKASTR == 0) cycle
      ! Compress list to common nonvanishing elements
      IDOCOMP = 1
      if (IDOCOMP == 1) then
        call COMPRS2LST(I1,XI1S,IJ_DIM(2),I2,XI2S,IJ_DIM(1),NKASTR,NKAEFF)
      else
        NKAEFF = NKASTR
      end if
      !write(u6,*) ' NKAEFF NKASTR',NKAEFF,NKASTR

      ! Loop over partitionings of N-1 strings
      KBOT = 1-MAXK
      KTOP = 0
      do
        KBOT = KBOT+MAXK
        KTOP = min(KTOP+MAXK,NKAEFF)
        if (KTOP == NKAEFF) then
          KEND = 1
        else
          KEND = 0
        end if
        LKABTC = KTOP-KBOT+1

        ! This is the place to start over partitioning of I strings
        do IIPART=1+MYRANK,NIPART,NPROCS
          IBOT = (IIPART-1)*NIPARTSZ+1
          ITOP = min(IBOT+NIPARTSZ-1,NROW)
          NIBTC = ITOP-IBOT+1
          if (NIBTC <= 0) exit
          ! Obtain CSCR(I,K,JORB) = SUM(J)<K!A JORB!J>C(I,J)
          do JJORB=1,IJ_DIM(2)
            ICGOFF = 1+(JJORB-1)*LKABTC*NIBTC
            call MATCG(CB,CSCR(ICGOFF),NROW,NIBTC,IBOT,LKABTC,I1(KBOT+(JJORB-1)*NKASTR),XI1S(KBOT+(JJORB-1)*NKASTR))
          end do
          ! Obtain SSCR(I,K,IORB) = SUM(I)<K!A IORB!J>S(I,J)
          do IIORB=1,IJ_DIM(1)
            ! Gather S Block
            ISGOFF = 1+(IIORB-1)*LKABTC*NIBTC
            call MATCG(SB,SSCR(ISGOFF),NROW,NIBTC,IBOT,LKABTC,I2(KBOT+(IIORB-1)*NKASTR),XI2S(KBOT+(IIORB-1)*NKASTR))
          end do

          ! And then the hard work
          NKI = LKABTC*NIBTC
#         ifdef _DEBUGPRINT_
          write(u6,*) ' CSCR and SSCR'
          call WRTMAT(CSCR,IJ_DIM(2),NKI,IJ_DIM(2),NKI)
          call WRTMAT(SSCR,IJ_DIM(1),NKI,IJ_DIM(1),NKI)
#         endif
          FACTORC = Zero
          FACTORAB = One
          call MATML7(RHO1S,SSCR,CSCR,IJ_DIM(1),IJ_DIM(2),NKI,IJ_DIM(1),NKI,IJ_DIM(2),FACTORC,FACTORAB,1)

#         ifdef _DEBUGPRINT_
          write(u6,*) ' Block to one-body density'
          call WRTMAT(RHO1S,IJ_DIM(1),IJ_DIM(2),IJ_DIM(1),IJ_DIM(2))
#         endif
          ! Scatter out to complete matrix
          do JJORB=1,IJ_DIM(2)
            JORB = IJ_OFF(2)-1+JJORB
            do IIORB=1,IJ_DIM(1)
              IORB = IJ_OFF(1)-1+IIORB
              RHO1((JORB-1)*NACOB+IORB) = RHO1((JORB-1)*NACOB+IORB)+RHO1S((JJORB-1)*IJ_DIM(1)+IIORB)
              if (IDOSRHO1 == 1) SRHO1((JORB-1)*NACOB+IORB) = SRHO1((JORB-1)*NACOB+IORB)+XAB*RHO1S((JJORB-1)*IJ_DIM(1)+IIORB)
            end do
          end do
          ! End of hard work

        end do
        ! end of this I partitioning
        ! end of this K partitioning
        if (KEND /= 0) exit
      end do
      ! End of loop over I partitionings
    end do
    ! (end of loop over symmetries)
  end do
end if

!stop ' enforced stop in RSBBD1'

end subroutine GSBBD1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Ben Swerts                                             *
!               2020, Roland Lindh                                     *
!***********************************************************************

subroutine FragExpand(LuRd)
!***********************************************************************
!                                                                      *
!    Objective: To expand the data for the fragments and append them   *
!               to regular arrays in Basis_Info, Center_Info           *
!                                                                      *
! Called from: Input                                                   *
!                                                                      *
! Calling    : GetBS                                                   *
!                                                                      *
!     Author: Ben Swerts                                               *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, Max_Shells, nCnttp, Shells
use Center_Info, only: dc, n_dc
use Sizes_of_Seward, only: S
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LuRd
#include "Molcas.fh"
integer(kind=iwp), parameter :: storageSize = 200, LineWords = storageSize/8
real(kind=wp) :: eqBasis(LineWords), x1, y1, z1
integer(kind=iwp) :: BasisTypes(4), LenLbl, iAtom, ib, iBas, iCnttp, iCntr, ii, Indx, iSh, iShll, jShll, lAng, Last, LenBSL, &
                     lSTDINP, mCnttp, mdc, ndc
logical(kind=iwp) :: UnNorm
character(len=4) :: label
character(len=13) :: DefNm = 'basis_library'
character(len=180) :: Ref(2)
character(len=storageSize) :: sBasis
character(len=256) :: Basis_lib, Fname
character(len=180), allocatable :: STDINP(:)
! external functions and procedures
integer(kind=iwp), external :: iMostAbundantIsotope, iCLast
real(kind=wp), external :: NucExp, rMass
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(STDINP,mxAtom*2,label='STDINP')
UnNorm = .false.
LenLbl = 0
mdc = dbsc(nCnttp)%mdci+dbsc(nCnttp)%nCntr
BasisTypes(:) = 0
iShll = S%Mx_Shll-1
lSTDINP = 0
mCnttp = nCnttp
#ifdef _DEBUGPRINT_
write(u6,*) 'nCnttp, iShll, mdc = ',nCnttp,iShll,mdc
#endif

#ifdef _DEBUGPRINT_
write(u6,'(A,i6)') 'FragExpand: just before the ''Do iCnttp'''
write(u6,'(A,i6)') 'FragExpand:       mdc          = ',mdc
write(u6,'(A,i6)') 'FragExpand:    mCnttp          = ',mCnttp
write(u6,'(A)') ' dbsc(nCnttp)%mdci   dbsc(nCnttp)%nCntr  nFragType(nCnttp)   nFragCoor(nCnttp)  '
do i=1,mCnttp
  write(u6,'(4(3X,I6,11X))') dbsc(i)%mdci,dbsc(i)%nCntr,dbsc(i)%nFragType,dbsc(i)%nFragCoor
end do
#endif

! Loop over distrinct basis set centers (dbsc)

ndc = 0 ! distinct center index
do iCnttp=1,mCnttp

  ! Skip if this is not a fragment dbsc to expand.

  if (dbsc(iCnttp)%nFragType <= 0) then
    ndc = ndc+dbsc(iCnttp)%nCntr
    cycle
  end if

  ! Loop over the centers associated with this dbsc.

  do iCntr=1,dbsc(iCnttp)%nCntr
    ndc = ndc+1

    ! Loop over the fragments associated with this dbsc.

    do iAtom=1,dbsc(iCnttp)%nFragCoor

      ! Create a new basis set center

      nCnttp = nCnttp+1
      if (nCnttp > Mxdbsc) then
        write(u6,*) ' Increase Mxdbsc'
        call ErrTra()
        call Quit_OnUserError()
      end if

      ! Read the associated basis set in sBasis

      iBas = int(dbsc(iCnttp)%FragCoor(1,iAtom))
      call dcopy_(LineWords,dbsc(iCnttp)%FragType(1,iBas),1,eqBasis,1)
      sBasis = transfer(eqBasis,sBasis) ! ???

      ! Get the basis set directory

      LenBSL = len(sBasis)
      Last = iCLast(sBasis,LenBSL)
      Indx = index(sBasis,'/')
      if (Indx == 0) then
        call WhichMolcas(Basis_lib)
        if (Basis_lib(1:1) /= ' ') then
          ib = index(Basis_lib,' ')-1
          if (ib < 1) call SysAbendMsg('fragexpand','Too long PATH to MOLCAS',' ')
          Fname = Basis_lib(1:ib)//'/basis_library'
        else
          Fname = DefNm
        end if
        Indx = Last+1
        dbsc(nCnttp)%Bsl = trim(sBasis)
      else
        Fname = sBasis(Indx+2:Last)
        if (Fname == ' ') then
          write(u6,*) ' No basis set library specified for'
          write(u6,'(A,A)') 'Fname=',Fname
          call Quit_OnUserError()
        end if
        Fname = adjustl(Fname)
        dbsc(nCnttp)%Bsl = sBasis(1:Indx-1)
      end if
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Setting Bsl(',nCnttp,') to ',dbsc(nCnttp)%Bsl
      write(u6,*) 'Fname = ',Fname
#     endif
      ! Now Fname contains the basis set directory and dbsc(.)%Bsl
      ! contains the basis set label

      jShll = iShll
      dbsc(nCnttp)%mdci = mdc
      call GetBS(Fname,sBasis(1:Indx-1),iShll,Ref,UnNorm,LuRd,BasisTypes,STDINP,lSTDINP,.false.,.true.,' ')
      lAng = max(dbsc(nCnttp)%nVal,dbsc(nCnttp)%nSRO,dbsc(nCnttp)%nPrj)-1
      S%iAngMx = max(S%iAngMx,lAng)
      Shells(jShll+1)%Transf = .false.
      Shells(jShll+1)%Prjct = .false.
      Shells(jShll+2)%Transf = .false.
      Shells(jShll+2)%Prjct = .false.
      dbsc(nCnttp)%Fixed = .true.
      dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal+dbsc(nCnttp)%nPrj+dbsc(nCnttp)%nSRO+dbsc(nCnttp)%nSOC+dbsc(nCnttp)%nPP
      dbsc(nCnttp)%CntMass = rMass(dbsc(nCnttp)%AtmNr)
      do iSh=jShll+1,iShll
        Shells(iSh)%Frag = .true.
      end do
      if (index(sBasis(1:Indx-1),'6-31G') /= 0) then
        iSh = jShll+3
        if (iSh <= iShll) then
          Shells(iSh)%Prjct = .false.
          Shells(iSh)%Transf = .false.
        end if
      end if
      dbsc(nCnttp)%Frag = .true.

      ! add the coordinates (1 atom / basis set center)
      dbsc(nCnttp)%nCntr = 1

      mdc = mdc+1
      n_dc = max(mdc,n_dc)
      if (mdc > MxAtom) then
        write(u6,*) ' FragExpand: Increase MxAtom'
        write(u6,*) '        MxAtom=',MxAtom
        call ErrTra()
        call Quit_OnUserError()
      end if
      ! get the relative coordinates
      x1 = dbsc(iCnttp)%FragCoor(2,iAtom)
      y1 = dbsc(iCnttp)%FragCoor(3,iAtom)
      z1 = dbsc(iCnttp)%FragCoor(4,iAtom)
      ! make them absolute
      x1 = x1+dbsc(iCnttp)%Coor(1,iCntr)
      y1 = y1+dbsc(iCnttp)%Coor(2,iCntr)
      z1 = z1+dbsc(iCnttp)%Coor(3,iCntr)
#     ifdef _DEBUGPRINT_
      write(u6,'(a,i3,3(a,F12.7))') 'FragExpand: Center ',nCnttp,' Coordinates:  x =',x1,' y=',y1,' z=',z1
#     endif
      ! store them
      call mma_allocate(dbsc(nCnttp)%Coor_Hidden,3,1,Label='dbsc:C')
      dbsc(nCnttp)%Coor => dbsc(nCnttp)%Coor_Hidden(:,:)
      dbsc(nCnttp)%Coor(1,1) = x1
      dbsc(nCnttp)%Coor(2,1) = y1
      dbsc(nCnttp)%Coor(3,1) = z1
      ! store the Mulliken charge
      dbsc(nCnttp)%FragCharge = dbsc(iCnttp)%FragCoor(5,iAtom)
      ! create custom (hopefully) unique label
      LenLbl = index(sBasis,'.')-1
      label = sBasis(1:LenLbl)
      do ii=LenLbl+1,4
        label(ii:ii) = '_'
      end do
#     ifdef _DEBUGPRINT_
      write(u6,'(2A)') 'Label=',label
#     endif
      ! LenIn possible BUG
      dc(mdc)%LblCnt = label
      if (mdc < 10) then
        write(label,'(a3,i1)') '___',mdc
      else if (mdc < 100) then
        write(label,'(a2,i2)') '__',mdc
      else if (mdc < 1000) then
        write(label,'(a1,i3)') '_',mdc
      else
        write(label,'(i4)') mdc
      end if
      dc(mdc)%LblCnt(5:LenIn2) = label
#     ifdef _DEBUGPRINT_
      write(u6,'(2A)') 'Label=',label
      write(u6,'(2A)') 'LblCnt(mdc)=',dc(mdc)%LblCnt
#     endif
      call Chk_LblCnt(dc(mdc)%LblCnt,mdc-1)
      ! store a reference to the originating fragment placeholder
      ! misuse nFragCoor for this purpose: it will not overwrite anything, but
      ! beware of redimensioning this array to anything other than Mxdbsc
      ! To signify this we store the negative value such that we can identify
      ! the that the actual number of centers is 0 and that the corresponding
      ! size of dbsc()%FragCoor is 0 and nothing else.
      dbsc(nCnttp)%nFragCoor = -ndc  ! DO NOT CHANGE THIS!!!!

      if (dbsc(nCnttp)%ExpNuc < Zero) dbsc(nCnttp)%ExpNuc = NucExp(iMostAbundantIsotope(dbsc(nCnttp)%AtmNr))
    end do  ! iAtom
  end do    ! iCntr
end do      ! iCnttp
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,'(A,i6)') 'FragExpand: After the ''Do iCnttp'''
write(u6,'(A,i6)') 'FragExpand:       mdc          = ',mdc
write(u6,'(A,i6)') 'FragExpand:    nCnttp          = ',nCnttp
write(u6,'(A)') ' dbsc(nCnttp)%mdci   dbsc(nCnttp)%nCntr  nFragType(nCnttp)   nFragCoor(nCnttp)  '
do i=1,nCnttp
  write(u6,'(4(3X,I6,11X))') dbsc(i)%mdci,dbsc(i)%nCntr,dbsc(i)%nFragType,dbsc(i)%nFragCoor
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
S%Mx_Shll = iShll+1
Max_Shells = S%Mx_Shll
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(STDINP)

return

end subroutine FragExpand

!s***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine daname_cvb(lu,fname)

use casvb_global, only: idan
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: lu
character(len=*), intent(in) :: fname
integer(kind=iwp) :: i_open, ilu
logical(kind=iwp) :: find_unused
integer(kind=iwp), external :: isfreeunit, find_lu
logical(kind=iwp), external :: is_opened

ilu = find_lu(fname)
if (ilu > 0) then
  lu = ilu
else
  find_unused = (lu < 1)
  if (.not. find_unused) find_unused = is_opened(lu)
  if (find_unused) ilu = isfreeunit(10)
end if

if (is_opened(lu)) then
  i_open = 1
else
  i_open = 0
  lu = 10  ! initialize
end if
call istkpush_cvb(idan,i_open)
if (i_open == 0) call daname(lu,fname)

return

end subroutine daname_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ORDER(C,D,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(N,N),D(N)
      DO 30 I=1,N-1
        IMIN=I
        DMIN=D(I)
        DO 10 J=I+1,N
          IF(D(J).GE.DMIN) GOTO 10
          DMIN=D(J)
          IMIN=J
10      CONTINUE
        IF(I.EQ.IMIN) GOTO 30
        D(IMIN)=D(I)
        D(I)=DMIN
        DO 20 K=1,N
          TMP=C(K,I)
          C(K,I)=C(K,IMIN)
          C(K,IMIN)=TMP
20      CONTINUE
30    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cre_gsswfn()

! SVC: Create a wavefunction file. If another .guessorb.h5 file already
! exists, it will be overwritten.
#ifdef _HDF5_
use GuessOrb_global, only: nBas, nSym, wfn_energy, wfn_fileid, wfn_mocoef, wfn_occnum, wfn_orbene, wfn_tpidx
use mh5, only: mh5_create_file, mh5_init_attr, mh5_create_dset_real, mh5_create_dset_str
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nBasTot, nSqrTot, iSym

! create a new wavefunction file!
wfn_fileid = mh5_create_file('GSSWFN')

! set module type
call mh5_init_attr(wfn_fileid,'MOLCAS_MODULE','GUESSORB')

! copy basic molecular information to the HDF5 file
call run2h5_molinfo(wfn_fileid)
call one2h5_ovlmat(wfn_fileid,nsym,nbas)
call one2h5_fckint(wfn_fileid,nsym,nbas)

! energy
wfn_energy = mh5_create_dset_real(wfn_fileid,'ENERGY')
call mh5_init_attr(wfn_energy,'DESCRIPTION','Total energy (sum of orbital energies)')

call mh5_init_attr(wfn_fileid,'ORBITAL_TYPE','GUESS')

nBasTot = 0
nSqrTot = 0
do iSym=1,nSym
  nSqrTot = nSqrTot+nBas(iSym)*nBas(iSym)
  nBasTot = nBasTot+nBas(iSym)
end do

! typestring
wfn_tpidx = mh5_create_dset_str(wfn_fileid,'MO_TYPEINDICES',1,[nBasTot],1)
call mh5_init_attr(wfn_tpidx,'DESCRIPTION', &
                   'Type index of the molecular orbitals arranged as blocks of size [NBAS(i)], i=1,#irreps')
! molecular orbital coefficients
wfn_mocoef = mh5_create_dset_real(wfn_fileid,'MO_VECTORS',1,[nSqrTot])
call mh5_init_attr(wfn_mocoef,'DESCRIPTION', &
                   'Coefficients of the molecular orbitals, arranged as blocks of size [NBAS(i)**2], i=1,#irreps')
! molecular orbital occupation numbers
wfn_occnum = mh5_create_dset_real(wfn_fileid,'MO_OCCUPATIONS',1,[nBasTot])
call mh5_init_attr(wfn_occnum,'DESCRIPTION', &
                   'Occupation numbers of the molecular orbitals arranged as blocks of size [NBAS(i)], i=1,#irreps')
! molecular orbital energies
wfn_orbene = mh5_create_dset_real(wfn_fileid,'MO_ENERGIES',1,[nBasTot])
call mh5_init_attr(wfn_orbene,'DESCRIPTION', &
                   'Orbital energies of the molecular orbitals arranged as blocks of size [NBAS(i)], i=1,#irreps')
#endif

end subroutine cre_gsswfn

!-----------------------------------------------------------------------

subroutine cls_gsswfn()

#ifdef _HDF5_
use GuessOrb_global, only: wfn_fileid
use mh5, only: mh5_close_file
implicit none
call mh5_close_file(wfn_fileid)
#endif

end subroutine cls_gsswfn

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1992, Roland Lindh                                *
!***********************************************************************

subroutine Inputg(LuSpool)
!***********************************************************************
!                                                                      *
! Object: input module for the gradient code                           *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             September '91                                            *
!                                                                      *
!             Modified to complement GetInf, January '92.              *
!***********************************************************************

use Alaska_Info, only: Am, Auto, ForceNAC
use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep, iChTbl, iOper, lIrrep, lBsFnc
use Gateway_global, only: Onenly, Test
use Gateway_Info, only: CutInt
use RI_glob, only: Timings_default
use OFembed, only: Do_OFemb, KEonly, OFE_first, Xsigma, dFMD, OFE_KSDFT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8, u6

implicit none
integer(kind=iwp), intent(in) :: LuSpool
#include "itmax.fh"
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"
#include "columbus_gamma.fh"
#include "nac.fh"
#include "chotime.fh"
integer(kind=iwp) :: i, iCar, iCnt, iCnttp, iCo, iComp, iElem, iGroup, iIrrep, ijSym, iPL, iPrint, iRout, istatus, iSym(3), iTR, &
                     j, jIrrep, jOper, jPrint, jRout, jTR, k, kTR, ldsp, lTR, LuWr, mc, mdc, mDisp, n, nCnttp_Valence, nDisp, &
                     nElem, nGroup, nRoots, nSlct
real(kind=wp) :: alpha, Fact, ovlp
logical(kind=iwp) :: TstFnc, ltype, Slct, T_Only, No_Input_OK, Skip
character(len=80) :: KWord, Key
integer(kind=iwp), allocatable :: IndCar(:), iTemp(:)
real(kind=wp), allocatable :: Tmp(:), C(:,:), Scr(:,:), Temp(:,:)
character, parameter :: xyz(0:2) = ['x','y','z']
integer(kind=iwp), external :: iPrintLevel, iPrmt, NrOpr
real(kind=r8), external :: DDot_
logical(kind=iwp), external :: Reduce_Prt

iRout = 99
iPrint = nPrint(iRout)
do i=1,nRout
  nPrint(i) = 5
end do
if (ForceNAC) isNAC = .true.
DoCSF = .true.
isCSF = .false.
Auto = .false.
Test = .false.
T_Only = .false.
TRSymm = .false.
lEq = .false.
Slct = .false.
l2DI = .true.
HF_Force = .false.
NO_NUC = .false.
Timings_default = Timings
Xsigma = 1.0e4_wp
dFMD = Zero
Do_OFemb = .false.
KEonly = .false.
OFE_first = .true.
Show = .true.
LuWr = u6
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = iPL-1
if (iPL == 0) then
  jPrint = 0
else if (iPL == 1) then
  jPrint = 0
else if (iPL == 2) then
  jPrint = 6
else if (iPL == 3) then
  jPrint = 6
else if (iPL == 4) then
  jPrint = 49
else
!else if (iPL == 5) then
  jPrint = 98
end if

do i=1,nRout
  nPrint(i) = jPrint
end do

call mma_allocate(iTemp,3*MxAtom,label='iTemp')

! First CutGrd can not be more accurate than CutInt!
CutGrd = max(1.0e-7_wp,CutInt)
! Second CutInt should now locally for Alaska be reset to the value
! of CutInt/100!
CutInt = CutGrd*1.0e-2_wp
do i=1,3*MxAtom
  IndxEq(i) = i
end do
do ldsp=1,3*MxAtom
  Direct(ldsp) = .true.
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! KeyWord directed input

rewind(LuSpool)
No_Input_OK = .true.
call RdNLst_(LuSpool,'ALASKA',No_Input_OK)
KWord = ' &ALASKA'
do
  read(LuSpool,'(A72)',iostat=istatus) Key
  if (istatus < 0) then
    exit
  else if (istatus > 0) then
    call Error()
  end if
  KWord = Key
  call UpCase(KWord)
  if (KWord(1:1) == '*') cycle
  if (KWord == '') cycle
  select case (KWord(1:4))
    case ('VERB')
      !                                                                *
      !***** VERB ******************************************************
      !                                                                *
      ! Verbose mode.

      nPrint(80) = 6
      nPrint(1) = 6
      nPrint(9) = 6
      nPrint(99) = 6
    case ('PRIN')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Print level

      do
        read(LuSpool,'(A)',iostat=istatus) KWord
        call Error()
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      read(KWord,*,iostat=istatus) n
      call Error()
      do i=1,n
        do
          read(LuSpool,'(A)',iostat=istatus) KWord
          call Error()
          if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
        end do
        read(KWord,*,iostat=istatus) jRout,iPrint
        call Error()
        nPrint(jRout) = iPrint
      end do
    case ('EQUI')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Equivalence option

      if (T_Only) then
        call WarningMessage(2,'Error in InputG')
        write(LuWr,*) 'EQUI option does not ork with RF calculations!'
        call Quit_OnUserError()
      end if
      lEq = .true.
      do
        read(LuSpool,'(A)',iostat=istatus) KWord
        call Error()
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      read(KWord,*) nGroup
      do iGroup=1,nGroup
        do
          read(LuSpool,'(A)',iostat=istatus) KWord
          call Error()
          if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
        end do
        read(KWord,*) nElem,(iTemp(iElem),iElem=1,nElem)
        do iElem=2,nElem
          IndxEq(iTemp(iElem)) = iTemp(1)
          Direct(iTemp(iElem)) = .false.
        end do
      end do
    case ('CUTO')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Cutoff for computing primitive gradients

      do
        read(LuSpool,'(A)',iostat=istatus) KWord
        call Error()
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      read(KWord,*,iostat=istatus) CutGrd
      call Error()
      CutGrd = abs(CutGrd)
    case ('HF-F')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Compute Hellmann-Feynman forces

      HF_Force = .true.
    case ('NOIN')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Disable the utilization of translational and
      ! rotational invariance of the energy in the
      ! computation of the molecular gradient.

      TRSymm = .false.
    case ('SELE')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! selection option

      if (T_Only) then
        call WarningMessage(2,'Error in InputG')
        write(LuWr,*) 'SELE option does not work with RF calculations!'
        call Quit_OnUserError()
      end if
      Slct = .true.
      if (lEq) then
        call WarningMessage(2,'Error in InputG')
        write(LuWr,*) ' The Selection option must preceed the Equivalence option to work together.'
        call Quit_OnUserError()
      end if
      do i=1,3*MxAtom
        Direct(i) = .false.
      end do
      do
        read(LuSpool,'(A)',iostat=istatus) KWord
        call Error()
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      read(KWord,*) nSlct

      do
        read(LuSpool,'(A)',iostat=istatus) KWord
        call Error()
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      read(KWord,*) (iTemp(iElem),iElem=1,nSlct)
      do iElem=1,nSlct
        Direct(iTemp(iElem)) = .true.
      end do
    case ('2DOP')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Change default for the prescreening.

      l2DI = .false.
    case ('2DIP')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Change default for the prescreening.

      l2DI = .true.
    case ('ONEO')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Do not compute two electron integrals.

      Onenly = .true.
    case ('TEST')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Process only the input.

      Test = .true.
    case ('SHOW')
      !                                                                *
      !*****************************************************************
      !                                                                *
      !-----Raise the printlevel to show gradient contributions

      if (iPL >= 2) then
        nPrint(112) = 15
        nPrint(1) = 15
        nPrint(33) = 15
      end if
    case ('PNEW')
      !                                                                *
      !***** PNEW ******************************************************
      !                                                                *
      ! Print gradient in NEW human-readable format

      nPrint(1) = 4
    case ('POLD')
      !                                                                *
      !***** POLD ******************************************************
      !                                                                *
      ! Print gradient in OLD format

      nPrint(1) = 5
    case ('NONU')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Do not compute the nuclear charge contribution

      NO_NUC = .true.
    case ('EXTR')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Put the program name and the time stamp onto the extract file

      write(LuWr,*) 'InputG: EXTRACT option is redundant and is ignored!'
    case ('CHOI')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Cholesky input section

      call Cho_alaska_rdInp(LuSpool)
    case ('OFEM')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Orbital-Free Embedding (OFE) input section

      do
        read(LuSpool,'(A)',iostat=istatus) KWord
        call Error()
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      call UpCase(KWord)
      KWord = adjustl(KWord)
      read(KWord,'(A)') OFE_KSDFT
      Do_OFemb = .true.
    case ('KEON')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Mode "Kinetic Energy Only" for OFE input section

      KEonly = .true.
    case ('DFMD')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Mode "Kinetic Energy Only" for OFE input section

      do
        read(LuSpool,'(A)',iostat=istatus) KWord
        call Error()
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      read(KWord,*) dFMD,Xsigma
    ! Keyword 'NUMErical' checked earlier - forces numerical gradients
    ! Keyword 'DELTa' selects the scaling factor for the displacements
    !                 in the numerical_gradient module
    ! Keyword 'KEEP' does not remove the old gradient
    ! Keyword 'INVErt' inverts the treatment of constraints
    ! Here it's only included for consistency
    case ('NUME')
    case ('DELT')
    case ('KEEP')
    case ('INVE')
    case ('ROOT')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Root keyword, now also for analytical gradient
      ! This is a dummy, the keyword is already read in chk_numerical

      do
        read(LuSpool,'(A)',iostat=istatus) KWord
        call Error()
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      read(KWord,*) i
    case ('NAC ')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! NAC keyword: compute non-adiabatic couplings between 2 states
      ! The keyword is already read in chk_numerical

      do
        read(LuSpool,'(A)',iostat=istatus) KWord
        call Error()
        if ((KWord(1:1) /= '*') .and. (KWord /= '')) exit
      end do
      read(KWord,*) NACstates(1),NACstates(2)
      isNAC = .true.
    case ('NOCS')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! NOCSF keyword, to neglect the CSF contribution to the NAC,
      ! which is the cause for translational variance

      DoCSF = .false.
    case ('AUTO')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! AUTO keyword, used by SLAPAF, to signal this is an automated
      ! call to ALASKA

      Auto = .true.
    case ('END ')
      exit
    case default
      istatus = 1
      call Error()
  end select
end do
!                                                                      *
!***********************************************************************
!                                                                      *
!                          End of input section.                       *
!                                                                      *
!***********************************************************************
!                                                                      *

! NAC could have been activated through explicit input or through
! a previous MCLR

if (isNAC) then
  No_Nuc = .true.
  ! Get the state energies
  call Get_iScalar('Number of roots',nRoots)
  call mma_Allocate(Tmp,nRoots,Label='Tmp')
  call Get_dArray('Last energies',Tmp,nRoots)
  Ediff = Tmp(NACstates(1))-Tmp(NACstates(2))
  call mma_deallocate(Tmp)
end if

nCnttp_Valence = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux) exit
  nCnttp_Valence = nCnttp_Valence+1
end do

if (lEq) TRSymm = .false.
if (Slct) TRSymm = .false.
iPrint = nPrint(iRout)

TRsymm = (TRsymm .or. T_Only) .and. (.not. Test)

! Compute number of centers and displacements. Ignore pseudo centers.
! If any pseudo centers disable use of translational and rotational
! invariance.

mDisp = 0
mdc = 0
do iCnttp=1,nCnttp_Valence
  if (dbsc(iCnttp)%pChrg) then
    TRSymm = .false.
    mdc = mdc+dbsc(iCnttp)%nCntr
  else
    if ((dbsc(iCnttp)%nFragType > 0) .or. dbsc(iCnttp)%Frag) TRSymm = .false.
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      mDisp = mDisp+3*(nIrrep/dc(mdc)%nStab)
    end do
  end if
end do

if (HF_Force .and. Show .and. (iPrint >= 6)) then
  write(LuWr,*)
  write(LuWr,'(A)') '            O B S E R V E ! '
  write(LuWr,'(A)') '            Option for computation of interstate coupling vector or'
  write(LuWr,'(A)') '            Hellmann-Feynman gradient is active.'
  write(LuWr,*)
end if
if (Show .and. (iPrint >= 6)) then
  write(LuWr,*)
  write(LuWr,'(20X,A,E10.3)') ' Threshold for contributions to the gradient:',CutGrd
  write(LuWr,*)
end if

! Generate symmetry adapted cartesian displacements

if (Show .and. (iPrint >= 6)) then
  write(LuWr,*)
  write(LuWr,'(20X,A)') '********************************************'
  write(LuWr,'(20X,A)') '* Symmetry Adapted Cartesian Displacements *'
  write(LuWr,'(20X,A)') '********************************************'
  write(LuWr,*)
end if

IndDsp(:,:) = 0
InxDsp(:,:) = 0
Disp_Fac(:,:,:) = One
mult_Disp(:) = 1
nDisp = 0
do iIrrep=0,nIrrep-1
  lDisp(iIrrep) = 0
  ltype = .true.
  ! Loop over basis function definitions
  mdc = 0
  mc = 1
  do iCnttp=1,nCnttp_Valence
    ! Loop over unique centers associated with this basis set.
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      IndDsp(mdc,iIrrep) = nDisp
      ! Loop over the cartesian components
      do iCar=0,2
        iComp = 2**iCar
        if (TstFnc(dc(mdc)%iCoSet,iIrrep,iComp,dc(mdc)%nStab) .and. (.not. dbsc(iCnttp)%pChrg)) then
          nDisp = nDisp+1
          if (iIrrep == 0) InxDsp(mdc,iCar+1) = nDisp
          lDisp(iIrrep) = lDisp(iIrrep)+1
          mult_Disp(nDisp) = nIrrep/dc(mdc)%nStab
          if (ltype) then
            if (Show .and. (iPrint >= 6)) then
              write(LuWr,*)
              write(LuWr,'(10X,A,A)') ' Irreducible representation : ',lIrrep(iIrrep)
              write(LuWr,'(10X,2A)') ' Basis function(s) of irrep: ',lBsFnc(iIrrep)
              write(LuWr,*)
              write(LuWr,'(A)') ' Basis Label        Type   Center Phase'
            end if
            ltype = .false.
          end if
          if (iIrrep == 0) then
            do jOper=0,nIrrep-1
              Disp_Fac(iCar+1,jOper,mdc) = real(iPrmt(jOper,iComp)*iChTbl(iIrrep,jOper),kind=wp)
            end do
          end if
          if (Show .and. (iPrint >= 6)) then
            write(LuWr,'(I4,3X,A8,5X,A1,7X,8(I3,4X,I2,4X))') nDisp,dc(mdc)%LblCnt,xyz(iCar), &
                                                             (mc+iCo,iPrmt(NrOpr(dc(mdc)%iCoSet(iCo,0)),iComp)* &
                                                              iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0))), &
                                                              iCo=0,nIrrep/dc(mdc)%nStab-1)
          end if
          write(ChDisp(nDisp),'(A,1X,A1)') dc(mdc)%LblCnt,xyz(iCar)
        end if

      end do
      mc = mc+nIrrep/dc(mdc)%nStab
    end do
  end do

end do

if (nDisp /= mDisp) then
  call WarningMessage(2,'Error in InputG')
  write(LuWr,*) ' Wrong number of symmetry adapted displacements',nDisp,'=/=',mDisp
  call Abend()
end if

! Set up data for the utilization of the translational
! and rotational invariance of the energy.

if (TRSymm) then
  write(u6,*) 'Unsupported option: TRSymm'
  call Abend()
  iSym(1) = 0
  iSym(2) = 0
  iSym(3) = 0
  do i=1,min(nIrrep-1,5)
    j = i
    if (i == 3) j = 4
    do k=1,3
      if (btest(iOper(j),k-1)) iSym(k) = 2**(k-1)
    end do
  end do
  nTR = 0
  ! Translational equations
  do i=1,3
    if (iSym(i) == 0) nTR = nTR+1
  end do
  if (iPrint >= 99) write(LuWr,*) ' nTR=',nTR
  ! Rotational equations
  if (.not. T_Only) then
    do i=1,3
      j = i+1
      if (j > 3) j = j-3
      k = i+2
      if (k > 3) k = k-3
      ijSym = ieor(iSym(j),iSym(k))
      if (ijSym == 0) nTR = nTR+1
    end do
  end if
  if (nTR == 0) then
    TRSymm = .false.
    Skip = .true.
  else
    if (iPrint >= 99) write(LuWr,*) ' nTR=',nTR
    call mma_allocate(Am,nTR,lDisp(0),Label='Am')
    call mma_allocate(Temp,nTR,nTR,Label='Temp')
    call mma_allocate(C,4,lDisp(0),Label='C')
    call mma_allocate(IndCar,lDisp(0),Label='IndCar')

    Am(:,:) = Zero
    C(:,:) = Zero

    ! Generate temporary information of the symmetrical
    ! displacements.

    ldsp = 0
    mdc = 0
    iIrrep = 0
    do iCnttp=1,nCnttp_Valence
      do iCnt=1,dbsc(iCnttp)%nCntr
        mdc = mdc+1
        !call RecPrt(' Coordinates',' ',dbsc(iCnttp)%Coor(1,iCnt),1,3)
        Fact = Zero
        iComp = 0
        if (dbsc(iCnttp)%Coor(1,iCnt) /= Zero) iComp = ibset(iComp,0)
        if (dbsc(iCnttp)%Coor(2,iCnt) /= Zero) iComp = ibset(iComp,1)
        if (dbsc(iCnttp)%Coor(3,iCnt) /= Zero) iComp = ibset(iComp,2)
        do jIrrep=0,nIrrep-1
          if (TstFnc(dc(mdc)%iCoSet,jIrrep,iComp,dc(mdc)%nStab)) then
            Fact = Fact+One
          end if
        end do
        do iCar=1,3
          iComp = 2**(iCar-1)
          if (TstFnc(dc(mdc)%iCoSet,iIrrep,iComp,dc(mdc)%nStab)) then
            ldsp = ldsp+1
            Direct(lDsp) = .true.
            ! Transfer the coordinates
            C(:,ldsp) = dbsc(iCnttp)%Coor(1:3,iCnt)
            ! Transfer the multiplicity factor
            C(4,ldsp) = Fact
            IndCar(ldsp) = iCar
          end if
        end do
      end do
    end do
    if (iPrint >= 99) then
      call RecPrt(' Information',' ',C,4,lDisp(0))
      write(LuWr,*) (IndCar(i),i=1,lDisp(0))
    end if

    ! Set up coefficient for the translational equations

    iTR = 0
    do i=1,3
      if (iSym(i) == 0) then
        iTR = iTR+1
        do ldsp=1,lDisp(0)
          if (IndCar(ldsp) == i) then
            Am(iTR,ldsp) = C(4,ldsp)
          end if
        end do
      end if
    end do

    ! Set up coefficient for the rotational invariance

    if (.not. T_Only) then
      do i=1,3
        j = i+1
        if (j > 3) j = j-3
        k = i+2
        if (k > 3) k = k-3
        ijSym = ieor(iSym(j),iSym(k))
        if (ijSym == 0) then
          iTR = iTR+1
          do ldsp=1,lDisp(0)
            if (IndCar(ldsp) == j) then
              Fact = C(4,ldsp)*C(k,ldsp)
              Am(iTR,ldsp) = Fact
            else if (IndCar(ldsp) == k) then
              Fact = -C(4,ldsp)*C(j,ldsp)
              Am(iTR,ldsp) = Fact
            end if
          end do
        end if
      end do
    end if
    if (iPrint >= 99) call RecPrt(' The A matrix',' ',Am,nTR,lDisp(0))

    ! Now, transfer the coefficient of those gradients which will
    ! not be computed directly.
    ! The matrix to compute the inverse of is determined via
    ! a Gram-Schmidt procedure.

    ! Pick up the other vectors
    do iTR=1,nTR
      !write(LuWr,*) ' Looking for vector #',iTR
      ovlp = Zero
      kTR = 0
      ! Check all the remaining vectors
      do ldsp=1,lDisp(0)
        Skip = .false.
        do jTR=1,iTR-1
          if (iTemp(jTR) == ldsp) then
            Skip = .true.
            exit
          end if
        end do
        if (.not. Skip) then
          !write(LuWr,*) ' Checking vector #',ldsp
          Temp(:,iTR) = AM(:,ldsp)
          !call RecPrt(' Vector',' ',Temp(1,iTR),nTR,1)
          ! Gram-Schmidt orthonormalize against accepted vectors
          do lTR=1,iTR-1
            alpha = DDot_(nTR,Temp(1,iTR),1,Temp(1,lTR),1)
            !write(LuWr,*) ' <x|y> =',alpha
            call DaXpY_(nTR,-alpha,Temp(1,lTR),1,Temp(1,iTR),1)
          end do
          !call RecPrt(' Remainings',' ',Temp(1,iTR),nTR,1)
          alpha = DDot_(nTR,Temp(1,iTR),1,Temp(1,iTR),1)
          !write(LuWr,*) ' Remaining overlap =',alpha
          ! Check the remaining magnitude of vector after Gram-Schmidt
          if (alpha > ovlp) then
            kTR = ldsp
            ovlp = alpha
          end if
          if ((.not. Direct(ldsp)) .and. (alpha > 1.0e-2_wp)) then
            kTR = ldsp
            ovlp = huge(ovlp)
          end if
        end if
      end do
      Skip = .false.
      if (kTR == 0) then
        call WarningMessage(2,'Error in InputG')
        write(LuWr,*) ' No Vector found!'
        call Abend()
      end if
      !write(LuWr,*) ' Selecting vector #',kTR
      ! Pick up the "best" vector
      Temp(:,iTR) = Am(:,kTR)
      do lTR=1,iTR-1
        alpha = DDot_(nTR,Temp(1,iTR),1,Temp(1,lTR),1)
        call DaXpY_(nTR,-alpha,Temp(1,lTR),1,Temp(1,iTR),1)
      end do
      alpha = DDot_(nTR,Temp(1,iTR),1,Temp(1,iTR),1)
      call DScal_(nTR,One/sqrt(alpha),Temp(1,iTR),1)
      iTemp(iTR) = kTR
    end do
    do iTR=1,nTR
      Temp(:,iTR) = Am(:,iTemp(iTR))
      Am(:,iTemp(iTR)) = Zero
    end do
    if (iPrint >= 99) then
      call RecPrt(' The A matrix',' ',Am,nTR,lDisp(0))
      call RecPrt(' The T matrix',' ',Temp,nTR,nTR)
      write(LuWr,*) (iTemp(iTR),iTR=1,nTR)
    end if

    ! Compute the inverse of the T matrix

    call MatInvert(Temp,nTR)
    if (IPrint >= 99) call RecPrt(' The T-1 matrix',' ',Temp,nTR,nTR)
    call DScal_(nTR**2,-One,Temp,1)

    ! Generate the complete matrix

    call mma_allocate(Scr,nTR,lDisp(0),Label='Scr')
    call DGEMM_('N','N',nTR,lDisp(0),nTR,One,Temp,nTR,Am,nTR,Zero,Scr,nTR)
    if (IPrint >= 99) call RecPrt(' A-1*A',' ',Scr,nTR,lDisp(0))
    call mma_deallocate(Am)
    call mma_allocate(Am,lDisp(0),lDisp(0),Label='Am')
    Am(:,:) = Zero
    do i=1,lDisp(0)
      Am(i,i) = One
    end do
    do iTR=1,nTR
      ldsp = iTemp(iTR)
      call dcopy_(lDisp(0),Scr(1,iTR),nTR,Am(1,lDisp),lDisp(0))
    end do
    if (iPrint >= 99) call RecPrt('Final A matrix',' ',Am,lDisp(0),lDisp(0))

    call mma_deallocate(Scr)
    call mma_deallocate(IndCar)
    call mma_deallocate(C)
    call mma_deallocate(Temp)
    do iTR=1,nTR
      ldsp = iTemp(iTR)
      Direct(ldsp) = .false.
    end do

    write(LuWr,*)
    write(LuWr,'(20X,A)') ' Automatic utilization of translational and rotational invariance of the energy is employed.'
    write(LuWr,*)
    do i=1,lDisp(0)
      if (Direct(i)) then
        write(LuWr,'(25X,A,A)') Chdisp(i),' is independent'
      else
        write(LuWr,'(25X,A,A)') Chdisp(i),' is dependent'
      end if
    end do
    write(LuWr,*)
  end if

else
  nTR = 0
  if (Show .and. (iPrint >= 6)) then
    write(LuWr,*)
    write(LuWr,'(20X,A)') ' No automatic utilization of translational and rotational invariance of the energy is employed.'
    write(LuWr,*)
  end if
end if

call mma_deallocate(iTemp)

if (Slct .and. (.not. Skip)) then
  write(LuWr,*)
  write(LuWr,'(20X,A)') ' The Selection option is used'
  write(LuWr,*)
  do i=1,lDisp(0)
    if (Direct(i)) then
      write(LuWr,'(25X,A,A)') Chdisp(i),' is computed'
    else
      write(LuWr,'(25X,A,A)') Chdisp(i),' is set to zero'
    end if
  end do
  write(LuWr,*)
end if

Onenly = HF_Force

return

contains

subroutine Error()
  if (istatus > 0) then
    call WarningMessage(2,'Error in InputG')
    write(LuWr,*) 'Inputg: Illegal keyword'
    write(LuWr,'(A,A)') 'KWord=',KWord
    call Quit_OnUserError()
  else if (istatus < 0) then
    call Abend()
  end if
end subroutine Error

end subroutine Inputg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TermCho_RI(irc,nVec_RI,l_nVec_RI)

use ChoArr, only: MySP
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: l_nVec_RI, nVec_RI(l_nVec_RI) ! #RI vectors per irrep on this node

irc = 0

! Save number of vectors and other info on runfile.
! -------------------------------------------------

call Cho_Final(.false.)
call Cho_RI_Final(irc,nVec_RI,l_nVec_RI)
if (irc /= 0) return

! Close storage files.
! --------------------

call Cho_P_OpenVR(2)

! Deallocate index arrays.
! ------------------------

call Cho_X_Dealloc(irc)
if (irc /= 0) return

! More deallocations.
! -------------------

if (allocated(MySP)) call mma_deallocate(MySP)

end subroutine TermCho_RI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine set0(wrk,wrksize,map)
! this routine vanishes given mediate

use ccsd_global, only: Map_Type
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: map
integer(kind=iwp) :: ii, pos0

!1 def pos0
pos0 = map%d(1,1)

!2 set appropriate wrk = 0
ii = map%d(0,5)
wrk(pos0:map%d(ii,1)+map%d(ii,2)-1) = Zero

return

end subroutine set0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE AIAI(BUFOUT,INDOUT,ICAD,IBUFL,KBUF,NTPB,NBINS)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
      DIMENSION BUFOUT(*),INDOUT(*),ICAD(*),IBUFL(*)
#include "real_guga.fh"
#include "integ.fh"
#include "files_guga.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
      COMMON/D/JNDX(500 000)

      KBUF0=RTOI*KBUF
      KBUF1=KBUF0+KBUF+1
      KBUF2=KBUF1+1
      IDIV=RTOI
      DO 10 NI=1,LN
      I=ICH(NI)
      IIJ=(I*(I+1))/2
      IJS=IJ(I+1)+1
      IJM=IJ(I)
      DO 100 ITT=2,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      DO 30 IJJ=IJS,IJM
      ITAIL=IX(IT1+IJJ)
      IWAY(I)=1
32    KM=I
      J2(KM+1)=IJJ
      J1(KM+1)=IJJ
      JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      IFAI=0
      CALL LOOP26(KM,ISTOP,IFAI,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 30
      IF(J1(KM).NE.J2(KM))GO TO 32
41    KM=KM-1
      IF(KM.EQ.0)GO TO 51
      IWAY(KM)=1
42    JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      IFAI=0
      CALL LOOP23(KM,ISTOP,IFAI,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 43
      IF(J1(KM).NE.J2(KM))GO TO 42
      GO TO 41
43    KM=KM+1
      IF(KM.EQ.I)GO TO 32
      GO TO 42
51    IVL=J2(1)
      ISUM=IV0-IVL
      ISU=IRC(ISUM)
      IF(ISUM.EQ.3)CP=COUP(1)
      IF(ISUM.NE.3)CP=COUP1(1)
      DO 62 IN=1,ITAIL
      JND1=JNDX(ISU+ICOUP(1)+IN)
      IF(JND1.EQ.0)GO TO 62
      IPOS=(JND1-1)*LNP+IIJ
      NBN=(IPOS-1)/NTPB+1
      IBUFL(NBN)=IBUFL(NBN)+1
      ICQ=ICAD(NBN)
      ICP=ICQ/IDIV+IBUFL(NBN)
      BUFOUT(ICP)=CP
      ICPP=ICQ+KBUF0+IBUFL(NBN)
      INDOUT(ICPP)=IPOS
      IF(IBUFL(NBN).LT.KBUF)GO TO 62
      INDOUT(ICQ+KBUF1)=KBUF
      IAD110=IADD11
      CALL iDAFILE(Lu_11,1,INDOUT(ICQ+1),KBUF2,IADD11)
      INDOUT(ICQ+KBUF2)=IAD110
      IBUFL(NBN)=0
62    CONTINUE
      IF(I.EQ.1)GO TO 32
      KM=1
      GO TO 42
30    CONTINUE
100   CONTINUE
10    CONTINUE
C EMPTY LAST BUFFERS
      DO 150 I=1,NBINS
      ICQ=ICAD(I)
      INDOUT(ICQ+KBUF1)=IBUFL(I)
      IAD110=IADD11
      CALL iDAFILE(Lu_11,1,INDOUT(ICQ+1),KBUF2,IADD11)
      ICAD(I)=IAD110
150   CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2007, Markus Reiher                               *
************************************************************************
      subroutine write_operators (nbas,isize,dkhorder,xorder,dkhscfflg,
     *                            scrno2,scr6,scr7,scr8,paramtype,
     *                            clight)
c
c************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2)
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 21.06.2006 MR (ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer nbas,isize,dkhorder,xorder,scrno2
      REAL*8 scr6(isize,0:dkhorder),scr7(isize,0:xorder),
     *                 scr8(isize,scrno2),clight
      character*(3) paramtype
c
      integer i,j,k,idum
      intrinsic INT
#ifdef _MOLCAS_
      Integer IsFreeUnit
      outunit1=21
      outunit1=IsFreeUnit(outunit1)
      Call Molcas_Open(outunit1,'dkhout.21')
#else
      open (outunit1, file='dkhout.21', status='UNKNOWN',
     *        form='FORMATTED')
#endif
      rewind (outunit1)
      write (outunit1,1001) nbas,
     *                      dkhorder,xorder,
     *                      paramtype,dkhscfflg
1001  format (60('-'),/2X,
     *        'Basis:',1X,'No. of basis functions:',2X,I3,/2X,6('-'),
     *        /12X,
     *        'Relativity:',3X,'DKH order (H) :',2X,I2,/2X,11('-'),3X,
     *        'DKH order (X) :',2X,I2,/16X,'Paramtype',5X,':',2X,A3,
     *        /16X,'dkhscfflg',5X,':',2X,L1)
      write (outunit1,1008) clight
1008  format (16X,'Speed of light: ',D18.11,/,60('-'))
c
      iDum =INT((iSize+3)/4)
      write (outunit1,1033) iDum
1033  format ('***',/3X,'sinv(i,j) (j=1,nbas,  i=1,j)',3X,I5)
      do j=1,iSize,4
        write (outunit1,1035) (scr8(k,scrno2), k=j,Min(j+3,iSize))
1035    format (4(D25.18,1X))
      enddo
c
      do i=0,dkhorder
        write (outunit1,1243) i,idum
1243    format ('***',/2X,I2,3X,I5)
        do j=1,iSize,4
          write (outunit1,1245) (scr6(k,i), k=j,Min(j+3,iSize))
1245      format (4(D25.18,1X))
        enddo
      enddo
c
      close (outunit1)
c
      if (.not.dkhscfflg) then
#ifdef _MOLCAS_
        outunit2=22
        outunit2=IsFreeUnit(outunit2)
        Call Molcas_Open(outunit2,'dkhout.22')
#else
        open (outunit2, file='dkhout.22', status='UNKNOWN',
     *          form='FORMATTED')
#endif
        rewind (outunit2)
c
        write (outunit2,1001) nbas,
     *                        dkhorder,xorder,
     *                        paramtype,dkhscfflg
        write (outunit2,1008) clight
c
        iDum = INT((iSize+3)/4)
        write (outunit2,2033) idum
2033    format ('***',/3X,'sinv(i,j) (j=1,nbas,  i=1,j)',3X,I5)
*
        do j=1,iSize,4
          write (outunit2,2035) (scr8(k,scrno2), k=j,Min(iSize,j+3))
2035      format (4(D25.18,1X))
        enddo
        do i=0,xorder
          write (outunit2,2043) i,idum
2043      format ('***',/2X,I2,3X,I5)
          do j=1,iSize,4
            write (outunit2,2045) (scr7(k,i), k=j,Min(iSize,j+3))
2045        format (4(D25.18,1X))
          enddo
        enddo
c
        close (outunit2)
c
      endif
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dawrtmediate(wrk,wrksize,lun,mapd,mapi,rc)
! this routine writes required mediate to open unformatted file
! with number lun
! it also stores mapd and mapi of the given mediade
!
! lun   - Logical unit number of file, where mediate will be stored (Input)
! mapd  - direct map matrix corresponding to given mediate (Input)
! mapi  - inverse map matrix corresponding to given mediate (Input)
! rc    - return (error) code (Output)
!
! N.B.
! all mediates are stored as follows
! 1 - mapd, mapi
! 2 - one record with complete mediate

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, lun
real(kind=wp), intent(_IN_) :: wrk(wrksize)
integer(kind=iwp), intent(_IN_) :: mapd(0:512,6), mapi(8,8,8)
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: im, length, pos0

rc = 0

!1 write mapd

call dawrtmap(lun,mapd,mapi,rc)

!2 calculate overall length

length = 0

do im=1,mapd(0,5)
  length = length+mapd(im,2)
end do

! write mediate in one block

if (length == 0) then
  ! RC=1 : there is nothing to write, length of mediate is 0
  rc = 1
else
  pos0 = mapd(1,1)
  call dawri(lun,length,wrk(pos0))
end if

return

end subroutine dawrtmediate

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 2005  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine EQCTL2(ICONV)
! On return, the following data sets will be defined and stored
! on LUSOLV.
! At position IVEC=IRHS, the RHS array, in SR representation.
! At position IVEC=IVECX, the solution array, in SR representation.
! At position IVEC=IVECR, the residual array, in SR representation.
! At position IVEC=IVECC, the solution array, in contravariant rep.
! At position IVEC=IVECC2, the solution array, in covariant repr.
! At position IVEC=IVECW, the RHS array, in contravariant repr.

use PrintLevel, only: INSANE, USUAL, VERBOSE
use EQSOLV, only: IRHS, IVECC, IVECC2, IVECR, IVECW, IVECX
use ChoCASPT2, only: iALGO
use caspt2_global, only: do_grad, iPrGlb, iStpGrd, nStpGrd
use caspt2_module, only: CPUEIG, CPULCS, CPUNAD, CPUOVL, CPUPCG, CPURHS, CPUSBM, CPUSCA, CPUSER, CPUSGM, CPUVEC, E2TOT, HZERO, &
                         IfChol, NASUP, NINDEP, NISUP, NSYM, RHSDIRECT, SDECOM, SMATRIX, TIOEIG, TIOLCS, TIONAD, TIOOVL, TIOPCG, &
                         TIORHS, TIOSBM, TIOSCA, TIOSER, TIOSGM, TIOVEC
use SC_NEVPT2, only: do_FIC, SC_NEVPT2_Print
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: ICONV
integer(kind=iwp) :: ICASE, ISYM, LAXITY
real(kind=wp) :: CPU, CPU0, CPU1, TIO, TIO0, TIO1
integer(kind=iwp), external :: Cho_X_GetTol

if (iStpGrd == 1) then

  if (IPRGLB >= VERBOSE) then
    write(u6,'(1X,A)')
    write(u6,'(1X,A)') 'Computing the S/B matrices'
    write(u6,'(1X,A)') '--------------------------'
  end if

  ! Compute S and (possibly) B matrices and write them on LUSBT
  ! this uses previously stored data on LUSOLV!!
  call GASync()
  call TIMING(CPU0,CPU,TIO0,TIO)

  ! Necessary to reset NINDEP to conservative estimate. It gets its
  ! final value after SBDIAG call, but must have its original value when
  ! calling MKSMAT and MKBMAT.
  do ICASE=1,13
    do ISYM=1,NSYM
      if (NISUP(ISYM,ICASE) == 0) then
        NINDEP(ISYM,ICASE) = 0
      else
        NINDEP(ISYM,ICASE) = NASUP(ISYM,ICASE)
      end if
    end do
  end do

  if (SMATRIX /= 'NO') then
    if (HZERO == 'DYALL') then
      call MKSMAT()
      call MKBNEV()
    else
      call MKSBMAT()
    end if
  end if

  ! Modify B matrices, if necessary:
  if (HZERO == 'CUSTOM') call NEWB()

  call GASync()
  call TIMING(CPU1,CPU,TIO1,TIO)
  CPUSBM = CPU1-CPU0
  TIOSBM = TIO1-TIO0

  ! Linear dependence removal, ON transformation of S matrix,
  ! and spectral resolution of H0:
  call GASync()
  call TIMING(CPU0,CPU,TIO0,TIO)

  if ((SDECOM /= 'NO') .and. do_FIC) call SBDIAG()

  call GASync()
  call TIMING(CPU1,CPU,TIO1,TIO)
  CPUEIG = CPU1-CPU0
  TIOEIG = TIO1-TIO0
end if

! The transformation matrices have now been computed and
! written at disk addresses given by IDTMAT().
! The B matrices were destroyed here. In their place,
! at the IDBMAT() addresses, we find two sets of diagonal
! energy values. Each consists of: first the energies of
! the active combination, which are eigenvalues of the
! B matrix using overlap S; then the energies of the
! non-active combinations. Usually, only the first set of
! energies is used. The second is used, in a manner specific
! to future modifications, for additional energy parameters
! of more sophisticated H0 or resolvent definitions.
! Modif PAM 961022: If BMATRIX='YES     ', diagonal energies
! are put at IDBMAT(). If BTRANS='YES     ', these are the
! diagonal values of B after transformation to ON basis.
! If furthermore BSPECT='YES     ', the ON basis consists
! of eigenvectors. This is the usual CASPT2 situation.
! However, if only BMATRIX is 'YES     ', then the values
! are the diagonal values of B divided by diagonal values
! of S.

call GASync()
call TIMING(CPU0,CPU,TIO0,TIO)

! Non-active part of diagonal elements of H0 are computed
! and written to LUSBT:
call NADIAG()
! Modify diagonal elements, if requested:
if (HZERO == 'CUSTOM') call NEWDIA()

! A second set of energy parameters may now have been
! computed and written to LUSBT.
call GASync()
call TIMING(CPU1,CPU,TIO1,TIO)
CPUNAD = CPU1-CPU0
TIONAD = TIO1-TIO0

if (IPRGLB >= VERBOSE) then
  write(u6,'(1X,A)')
  write(u6,'(1X,A)') 'Computing the right-hand side (RHS) elements'
  write(u6,'(1X,A)') '--------------------------------------------'
end if

IRHS = 1
IVECX = 2
IVECR = 3
IVECC = 4
IVECC2 = 5
IVECW = 6

call GASync()
call TIMING(CPU0,CPU,TIO0,TIO)

!-SVC: initialize the RHS array offsets
call RHS_INIT()
! at this point LUSOLV is not used as a temporary disk anymore, so it's
! safe to initialize it (safe to write zeros to LUSOLV or delete it)

! Set up right-hand side matrix elements.
if (IfChol .and. (iALGO == 1)) then
  if (RHSDIRECT) then
    if (NSYM == 1) then
      call RHSOD_NOSYM(IVECW)
    else
      call RHSOD(IVECW)
    end if
  else
    call RHS_ZERO(IVECW)
    call RHSALL2(IVECW)
  end if
else
  call MKRHS(IVECW)
end if

call GASync()
call TIMING(CPU1,CPU,TIO1,TIO)
CPURHS = CPU1-CPU0
TIORHS = TIO1-TIO0

if (IPRGLB >= INSANE) then
  write(u6,'("DEBUG> ")')
  write(u6,'("DEBUG> ",A)') 'Norms of the RHS blocks:'
  call RHS_FPRINT('C',IVECW)
end if

!-SVC: start PCG routine, set timers.
call GASync()
call TIMING(CPU0,CPU,TIO0,TIO)
CPUSCA = 0
CPULCS = 0
CPUOVL = 0
CPUSGM = 0
CPUVEC = 0
TIOSCA = 0
TIOLCS = 0
TIOOVL = 0
TIOSGM = 0
TIOVEC = 0

if (do_FIC) then
  ! Transform RHS of CASPT2 equations to eigenbasis for H0:
  call PTRTOSR(1,IVECW,IRHS)

  if (IPRGLB >= INSANE) then
    write(u6,'("DEBUG> ")')
    write(u6,'("DEBUG> ",A)') 'Norms of the RHS blocks (H0 eigenbasis):'
    call RHS_FPRINT('SR',IRHS)
  end if

  if (iStpGrd == 1) call PCG(ICONV)
  if (iStpGrd == 2) then
    call RHS_ZERO(IVECR)
    ICONV = 0
    !! Just for verification
    LAXITY = 8
    if (IfChol) LAXITY = Cho_X_GetTol(LAXITY)
    call Add_Info('E_CASPT2',[E2TOT],1,LAXITY)
  end if

  call PTRTOC(0,IVECX,IVECC)
  call PTRTOC(1,IVECX,IVECC2)
else
  ! SC-NEVPT2: it is a direct summation, so we assume the convergence is always achieved
  ICONV = 0
end if

if ((HZERO == 'DYALL') .and. (iStpGrd == 1)) call SC_NEVPT2_Print()

!-SVC: end of PCG routine, compute total time.
call GASync()
call TIMING(CPU1,CPU,TIO1,TIO)
CPUPCG = CPU1-CPU0
TIOPCG = TIO1-TIO0

!-SVC: collect and print information on coefficients/denominators
if ((nStpGrd == 1) .or. ((nStpGrd == 2) .and. (.not. do_grad))) then
  if (IPRGLB >= USUAL) call H0SPCT()
end if

call GASync()
call TIMING(CPU0,CPU,TIO0,TIO)
call GASync()
call TIMING(CPU1,CPU,TIO1,TIO)
CPUSER = CPU1-CPU0
TIOSER = TIO1-TIO0

end subroutine EQCTL2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine exth4 (a,b,dimp,dimpq,dimr,p)
c
c     this routine extract A(pq,r) -> B_p(q,r)
c
c     a     - matrxi a (Input)
c     b     - matrix b (Output)
c     dimp  - dimension of p (and also q) (Input)
c     dimpq - dimension of pq (Input)
c     dimr  - dimension of r (Input)
c     p     - value of index p (Input)
c
#include "t31.fh"
       integer dimp,dimpq,dimr,p
       real*8 a(1:dimpq,1:dimr)
       real*8 b(1:dimp,dimr)
c
c     help variables
c
       integer q,r,qp,pq0
c
       if (p.eq.0) then
       return
       end if
c
c     q>p part
       if (p.gt.1) then
       pq0=nshf(p)
       do 20 r=1,dimr
       do 21 q=1,p-1
       b(q,r)=a(pq0+q,r)
 21     continue
 20     continue
       end if
c
c     q=p part
       do 40 r=1,dimr
       b(p,r)=0.0d0
 40     continue
c
c     r<p part
       if (p.lt.dimp) then
       do 60 r=1,dimr
       do 61 q=p+1,dimp
       qp=nshf(q)+p
       b(q,r)=-a(qp,r)
 61     continue
 60     continue
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1998, Roland Lindh                                *
************************************************************************
      Subroutine FckAcc(iAng, iCmp, jCmp, kCmp, lCmp, Shijij,
     &                  iShll, iShell, kOp, nijkl,
     &                  AOInt,TwoHam,nDens,Scrt,nScrt,
     &                  iAO,iAOst,iBas,jBas,kBas,lBas,
     &                  Dij,ij1,ij2,ij3,ij4,
     &                  Dkl,kl1,kl2,kl3,kl4,
     &                  Dik,ik1,ik2,ik3,ik4,
     &                  Dil,il1,il2,il3,il4,
     &                  Djk,jk1,jk2,jk3,jk4,
     &                  Djl,jl1,jl2,jl3,jl4,
     &                  FT,nFT,DoCoul,DoExch,ExFac)
************************************************************************
*                                                                      *
*  Object: to accumulate contributions from the AO integrals directly  *
*          to the symmetry adapted Fock matrix.                        *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*          In addition to this complication we have that the order of  *
*          indices in the integrals are not ordered canonically but    *
*          rather in an order such that the contraction step will be   *
*          optimal. Hence, special care has to be taken when tracing   *
*          the density with the integrals so that both entities have   *
*          the same order.                                             *
*                                                                      *
*          The Fock matrix is computed in lower triangular form.       *
*                                                                      *
*          The density matrix is not folded if the shell indices and   *
*          the angular indices are identical.                          *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden. February '93                            *
*                                                                      *
*     Modified July '98 in Tokyo by R. Lindh                           *
************************************************************************
      use Basis_Info
      use SOAO_Info, only: iAOtSO
      use Real_Spherical, only: iSphCr
      use Symmetry_Info, only: iChBas, iOper, nIrrep, Prmt
      use Gateway_Info, only: ThrInt, CutInt
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
*
*     Since I sometimes use Scrt as an anchor to reach into the
*     density matrix a check if I'm out of bounds does not work!
*
#ifndef _BOUND_
      Real*8 Scrt(nScrt)
#else
      Real*8 Scrt(*)
#endif
      Real*8 AOInt(nijkl,iCmp,jCmp,kCmp,lCmp), TwoHam(nDens),FT(nFT),
     &       Dij(ij1*ij2+1,ij3,ij4),
     &       Dkl(kl1*kl2+1,kl3,kl4),
     &       Dik(ik1*ik2+1,ik3,ik4),
     &       Dil(il1*il2+1,il3,il4),
     &       Djk(jk1*jk2+1,jk3,jk4),
     &       Djl(jl1*jl2+1,jl3,jl4)
      Logical Shijij, Qijij, DoCoul, DoExch,
     &        iShij, iShkl, iQij, iQkl,
     &        iQik, iShik, iQil, iShil, iQjk, iShjk, iQjl, iShjl,
     &        lFij, lFkl, lFik, lFjl, lFil, lFjk
      Integer iAng(4), iShell(4), iShll(4), kOp(4), kOp2(4),
     &        iAO(4), iAOst(4), iCmpa(4)
*     Local Arrays
      Integer iSym(4)
c     Character*72 Label
*                                                                      *
************************************************************************
*                                                                      *
*     Statement Function
*
      iOff(ixyz)  = ixyz*(ixyz+1)*(ixyz+2)/6
c     iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      If (.Not.DoCoul.and..Not.DoExch) Return
*     iRout = 38
*     iPrint = nPrint(iRout)
*
*     If (iPrint.ge.49) Then
*        Write (*,*) ' FckAcc:AOIn',DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
*    &               AOInt,1,AOInt,1), DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
*    &               AOInt,1,One,0)
*     End If
*     If (iPrint.ge.99) Then
*        Call RecPrt('FckAcc:AOInt',' ',AOInt,nijkl,iCmp*jCmp*kCmp*lCmp)
*        Write (*,*)'Dij=',XDot(Dij,ij1,ij2,ij3,ij4)
*        Write (*,*)'Dkl=',XDot(Dkl,kl1,kl2,kl3,kl4)
*        Write (*,*)'Dik=',XDot(Dik,ik1,ik2,ik3,ik4)
*        Write (*,*)'Dil=',XDot(Dil,il1,il2,il3,il4)
*        Write (*,*)'Djk=',XDot(Djk,jk1,jk2,jk3,jk4)
*        Write (*,*)'Djl=',XDot(Djl,jl1,jl2,jl3,jl4)
*     End If
C     Call RecPrt('AOInt',' ',AOInt,nijkl,iCmp*jCmp*kCmp*lCmp)
*
      If (iBas*jBas*kBas*lBas.gt.nScrt) Then
         Call WarningMessage(2,'FckAcc: nScrt too small!')
         Call Abend()
      End If
      ii = iOff(iAng(1))
      jj = iOff(iAng(2))
      kk = iOff(iAng(3))
      ll = iOff(iAng(4))

      kOp2(1) = iOper(kOp(1))
      kOp2(2) = iOper(kOp(2))
      kOp2(3) = iOper(kOp(3))
      kOp2(4) = iOper(kOp(4))
      iCmpa(1) = iCmp
      iCmpa(2) = jCmp
      iCmpa(3) = kCmp
      iCmpa(4) = lCmp
      lFij = .False.
      lFkl = .False.
      lFik = .False.
      lFjl = .False.
      lFil = .False.
      lFjk = .False.
*
      ipFij = 1
      nFij  = iBas*jBas*iCmpa(1)*iCmpa(2)
*
      ipFkl = ipFij + nFij
      nFkl  = kBas*lBas*iCmpa(3)*iCmpa(4)
*
      ipFik = ipFkl + nFkl
      nFik  = iBas*kBas*iCmpa(1)*iCmpa(3)
*
      ipFjl = ipFik + nFik
      nFjl  = jBas*lBas*iCmpa(2)*iCmpa(4)
*
      ipFil = ipFjl + nFjl
      nFil  = iBas*lBas*iCmpa(1)*iCmpa(4)
*
      ipFjk = ipFil + nFil
      nFjk  = jBas*kBas*iCmpa(2)*iCmpa(3)
*
      call dcopy_(nFij+nFkl+nFik+nFjl+nFil+nFjk,[Zero],0,FT(ipFij),1)
*
      ipDij = 1
      ipDkl = 1
      ipDik = 1
      ipDil = 1
      ipDjk = 1
      ipDjl = 1
      ipFij1= 1
      ipFkl1= 1
      ipFik1= 1
      ipFil1= 1
      ipFjk1= 1
      ipFjl1= 1
*
*     Quadruple loop over elements of the basis functions angular
*     description. Loops are reduced to just produce unique SO integrals
*     Observe that we will walk through the memory in AOInt in a
*     sequential way.
*
      iShij = iShell(1).eq.iShell(2)
      iShkl = iShell(3).eq.iShell(4)
      iShik = iShell(1).eq.iShell(3)
      iShil = iShell(1).eq.iShell(4)
      iShjk = iShell(2).eq.iShell(3)
      iShjl = iShell(2).eq.iShell(4)
      mijkl=iBas*jBas*kBas*lBas
      Do 100 i1 = 1, iCmp
         ix = 0
         Do j = 0, nIrrep-1
            If (iAOtSO(iAO(1)+i1,j)>0) ix = iEor(ix,2**j)
         End Do
         iSym(1)=ix
         jCmpMx = jCmp
         If (iShij) jCmpMx = i1
         iChBs = iChBas(ii+i1)
         If (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+i1))
         pEa = Prmt(iOper(kOp(1)),iChBs)
         Do 200 i2 = 1, jCmpMx
            ix = 0
            Do j = 0, nIrrep-1
               If (iAOtSO(iAO(2)+i2,j)>0) ix = iEor(ix,2**j)
            End Do
            iSym(2)=ix
            jChBs = iChBas(jj+i2)
            If (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+i2))
            pRb = Prmt(iOper(kOp(2)),jChBs)
            If (iShell(2).gt.iShell(1)) Then
               i12 = jCmp*(i1-1) + i2
            Else
               i12 = iCmp*(i2-1) + i1
            End If
            Do 300 i3 = 1, kCmp
               ix = 0
               Do j = 0, nIrrep-1
                  If (iAOtSO(iAO(3)+i3,j)>0) ix = iEor(ix,2**j)
               End Do
               iSym(3)=ix
               lCmpMx = lCmp
               If (iShkl) lCmpMx = i3
               kChBs = iChBas(kk+i3)
               If (Shells(iShll(3))%Transf)
     &            kChBs = iChBas(iSphCr(kk+i3))
               pTc = Prmt(iOper(kOp(3)),kChBs)
               Do 400 i4 = 1, lCmpMx
                  ix = 0
                  Do j = 0, nIrrep-1
                     If (iAOtSO(iAO(4)+i4,j)>0) ix = iEor(ix,2**j)
                  End Do
                  iSym(4)=ix
                  lChBs = iChBas(ll+i4)
                  If (Shells(iShll(4))%Transf)
     &               lChBs = iChBas(iSphCr(ll+i4))
                  pTSd= Prmt(iOper(kOp(4)),lChBs)
                  If (iShell(4).gt.iShell(3)) Then
                     i34 = lCmp*(i3-1) + i4
                  Else
                     i34 = kCmp*(i4-1) + i3
                  End If
                  If (Shijij .and. i34.gt.i12) Go To 400
                  vijkl=Zero
                  do ijkl=1,mijkl
                    vijkl=max(vijkl,abs(AOInt(ijkl,i1,i2,i3,i4)))
                  end do
c                 vijkl = DNrm2_(iBas*jBas*kBas*lBas,
c    &                          AOInt(1,i1,i2,i3,i4),1)
                  If (vijkl.lt.CutInt) Go To 400
*
                  Qijij = Shijij .and. i12.eq.i34
                  iQij = iShij.and.i1.eq.i2
                  iQkl = iShkl.and.i3.eq.i4
                  iQik = iShik.and.i1.eq.i3
                  iQil = iShil.and.i1.eq.i4
                  iQjk = iShjk.and.i2.eq.i3
                  iQjl = iShjl.and.i2.eq.i4
                  pFctr=pEa*pRb*pTc*pTSd
************************************************************************
*
                  Fac_ij = pFctr
                  Fac_kl = pFctr
                  Fac_ik =-Quart * pFctr
                  Fac_jl =-Quart * pFctr
                  Fac_il =-Quart * pFctr
                  Fac_jk =-Quart * pFctr
                  If (iQij) Fac_ij = Fac_ij * Half
                  If (iQkl) Fac_kl = Fac_kl * Half
                  If (iQjl.and. .Not.iQik) Fac_ik = Fac_ik * Two
                  If (iQik.and. .Not.iQjl) Fac_jl = Fac_jl * Two
                  If (iQjk.and. .Not.iQil) Fac_il = Fac_il * Two
                  If (iQil.and. .Not.iQjk) Fac_jk = Fac_jk * Two
*
                  D_ij=Two
                  If (iQij) D_ij=One
                  D_kl=Two
                  If (iQkl) D_kl=One
                  D_ik=Two
                  If (iQik) D_ik=One
                  D_jl=Two
                  If (iQjl) D_jl=One
                  D_il=Two
                  If (iQil) D_il=One
                  D_jk=Two
                  If (iQjk) D_jk=One
*
                  Fac_ij=Fac_ij*D_kl
                  Fac_kl=Fac_kl*D_ij
                  Fac_jl=Fac_jl*D_ik
                  Fac_ik=Fac_ik*D_jl
                  Fac_jk=Fac_jk*D_il
                  Fac_il=Fac_il*D_jk
*
C                 Write (*,*)
C                 Write (*,*) 'iShell(1),iShell(2),i1,i2=',
C    &                         iShell(1),iShell(2),i1,i2
C                 Write (*,*) 'Dij=',Dij(1,i1,i2)
C                 Write (*,*) 'Fac_ij,iQij=',Fac_ij,iQij
C                 Write (*,*)
C                 Write (*,*) 'iShell(3),iShell(4),i3,i4=',
C    &                         iShell(3),iShell(4),i3,i4
C                 Write (*,*) 'Dkl=',Dkl(1,i3,i4)
C                 Write (*,*) 'Fac_kl,iQkl=',Fac_kl,iQkl
C                 Write (*,*)
                  If (Qijij) Then
                     Fac_kl = Zero
                     Fac_jk = Zero
                  End If
                  If (iQij.and.iQkl) Then
                     Fac_jl = Zero
                     Fac_il = Zero
                     Fac_jk = Zero
                  End If
                  If (iQij.or.iQkl) Then
                     Fac_il = Zero
                     Fac_jk = Zero
                  End If
************************************************************************
*
                  iOpt=0
                  ip = 1
                  If (DoCoul .and.
     &                iAnd(iSym(1),iSym(2)).ne.0 .and.
     &                iAnd(iSym(3),iSym(4)).ne.0) Then
                     iOpt = iOpt + 1
*
                     If (iShell(3).lt.iShell(4)) Then
                        vkl = Dkl(kBas*lBas+1,i4,i3)
                        ipDkl=ip
                        ip = ip + kBas*lBas
                        Call DGetMO(Dkl(1,i4,i3),kl1,kl1,
     &                              kl2,Scrt(ipDkl),kl2)
                     Else
                        vkl = Dkl(kBas*lBas+1,i3,i4)
#ifndef _BOUND_
                        ipDkl = ip_of_Work(Dkl(1,i3,i4)) -
     &                          ip_of_Work(Scrt(1)) + 1
#else
                        ipDkl=ip
                        ip = ip + kBas*lBas
                        call dcopy_(kl1*kl2,Dkl(1,i3,i4),1,
     &                             Scrt(ipDkl),1)
#endif
                     End If
                     ipFij1 = ((i2-1)*iCmpa(1)+i1-1)*iBas*jBas
     &                      + ipFij
                     If (iShell(1).lt.iShell(2)) Then
                        vij = Dij(iBas*jBas+1,i2,i1)
                        ipDij=ip
                        ip = ip + iBas*jBas
                        Call DGeTMO(Dij(1,i2,i1),ij1,ij1,
     &                              ij2,Scrt(ipDij),ij2)
                     Else
                        vij = Dij(iBas*jBas+1,i1,i2)
#ifndef _BOUND_
                        ipDij = ip_of_Work(Dij(1,i1,i2)) -
     &                          ip_of_Work(Scrt(1)) + 1
#else
                        ipDij=ip
                        ip = ip + iBas*jBas
                        call dcopy_(ij1*ij2,Dij(1,i1,i2),1,
     &                             Scrt(ipDij),1)
#endif
                     End  If
                     ipFkl1 = ((i4-1)*iCmpa(3)+i3-1)*kBas*lBas
     &                      + ipFkl
                     If (vkl*vijkl*Abs(Fac_ij).lt.ThrInt .and.
     &                   vij*vijkl*Abs(Fac_kl).lt.ThrInt) Then
                        iOpt = iOpt -1
                     Else
                        lFij=.True.
                        lFkl=.True.
                     End If
                  End If
                  If (DoExch .and.
     &                iAnd(iSym(1),iSym(3)).ne.0 .and.
     &                iAnd(iSym(2),iSym(4)).ne.0) Then
                     iOpt = iOpt + 2
*
                     If (iShell(2).lt.iShell(4)) Then
                        vjl=Djl(jBas*lBas+1,i4,i2)
                        ipDjl=ip
                        ip = ip + jBas*lBas
                        Call DGeTMO(Djl(1,i4,i2),jl1,jl1,
     &                              jl2,Scrt(ipDjl),jl2)
                     Else
                        vjl=Djl(jBas*lBas+1,i2,i4)
#ifndef _BOUND_
                        ipDjl = ip_of_Work(Djl(1,i2,i4)) -
     &                          ip_of_Work(Scrt(1)) + 1
#else
                        ipDjl=ip
                        ip = ip + jBas*lBas
                        call dcopy_(jl1*jl2,Djl(1,i2,i4),1,
     &                             Scrt(ipDjl),1)
#endif
                     End If
                     ipFik1 = ((i3-1)*iCmpa(1)+i1-1)*iBas*kBas
     &                      + ipFik
                     If (iShell(1).lt.iShell(3)) Then
                        vik=Dik(iBas*kBas+1,i3,i1)
                        ipDik = ip
                        ip = ip + iBas*kBas
                        Call DGeTMO(Dik(1,i3,i1),ik1,ik1,
     &                              ik2,Scrt(ipDik),ik2)
                     Else
                        vik=Dik(iBas*kBas+1,i1,i3)
#ifndef _BOUND_
                        ipDik = ip_of_Work(Dik(1,i1,i3)) -
     &                          ip_of_Work(Scrt(1)) + 1
#else
                        ipDik = ip
                        ip = ip + iBas*kBas
                        call dcopy_(ik1*ik2,Dik(1,i1,i3),1,
     &                             Scrt(ipDik),1)
#endif
                     End If
                     ipFjl1 = ((i4-1)*iCmpa(2)+i2-1)*jBas*lBas
     &                      + ipFjl
                     If (vik*vijkl*Abs(Fac_jl) .lt. ThrInt .and.
     &                   vjl*vijkl*Abs(Fac_ik) .lt. ThrInt) Then
                        iOpt = iOpt - 2
                     Else
                        lFik = .True.
                        lFjl = .True.
                     End If
                  End If
                  If (DoExch .and.
     &                iAnd(iSym(1),iSym(4)).ne.0 .and.
     &                iAnd(iSym(2),iSym(3)).ne.0) Then
                     iOpt = iOpt + 4
*
                     If (iShell(2).lt.iShell(3)) Then
                        vjk = Djk(jBas*kBas+1,i3,i2)
                        ipDjk = ip
                        ip = ip + jBas*kBas
                        Call DGeTMO(Djk(1,i3,i2),jk1,jk1,
     &                              jk2,Scrt(ipDjk),jk2)
                     Else
                        vjk = Djk(jBas*kBas+1,i2,i3)
#ifndef _BOUND_
                        ipDjk = ip_of_Work(Djk(1,i2,i3)) -
     &                          ip_of_Work(Scrt(1)) + 1
#else
                        ipDjk = ip
                        ip = ip + jBas*kBas
                        call dcopy_(jk1*jk2,Djk(1,i2,i3),1,
     &                             Scrt(ipDjk),1)
#endif
                     End If
                     ipFil1 = ((i4-1)*iCmpa(1)+i1-1)*iBas*lBas
     &                      + ipFil
                     If (iShell(1).lt.iShell(4)) Then
                        vil = Dil(iBas*lBas+1,i4,i1)
                        ipDil = ip
                        ip = ip + iBas*lBas
                        Call DGeTMO(Dil(1,i4,i1),il1,il1,
     &                              il2,Scrt(ipDil),il2)
                     Else
                        vil = Dil(iBas*lBas+1,i1,i4)
#ifndef _BOUND_
                        ipDil = ip_of_Work(Dil(1,i1,i4)) -
     &                          ip_of_Work(Scrt(1)) + 1
#else
                        ipDil = ip
                        ip = ip + iBas*lBas
                        call dcopy_(il1*il2,Dil(1,i1,i4),1,
     &                             Scrt(ipDil),1)
#endif
                     End If
                     ipFjk1 = ((i3-1)*iCmpa(2)+i2-1)*jBas*kBas
     &                     + ipFjk
                     If (vil*vijkl*Abs(Fac_jk) .lt. ThrInt .and.
     &                   vjk*vijkl*Abs(Fac_il) .lt. ThrInt) Then
                        iOpt = iOpt -4
                     Else
                        lFil = .True.
                        lFjk = .True.
                     End If
                  End If
                  If (ip-1.gt.nScrt) Then
                     Call WarningMessage(2,'FckAcc: nScrt too small!')
                     Call Abend()
                  End If
C                 Write (*,*) 'iOpt=',iOpt
                  Go To ( 1, 2, 3, 4, 5, 6, 7) iOpt
                  Go To 400
*
************************************************************************
 1                Continue
                  Call Fck1(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDij),FT(ipFij1),Fac_ij,
     &                      Scrt(ipDkl),FT(ipFkl1),Fac_kl,ExFac)
                  Go To 400
 2                Continue
                  Call Fck2(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDik),FT(ipFik1),Fac_ik,
     &                      Scrt(ipDjl),FT(ipFjl1),Fac_jl,ExFac)
                  Go To 400
 3                Continue
                  Call Fck3(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDij),FT(ipFij1),Fac_ij,
     &                      Scrt(ipDkl),FT(ipFkl1),Fac_kl,
     &                      Scrt(ipDik),FT(ipFik1),Fac_ik,
     &                      Scrt(ipDjl),FT(ipFjl1),Fac_jl,ExFac)
                  Go To 400
 4                Continue
                  Call Fck4(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDil),FT(ipFil1),Fac_il,
     &                      Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
                  Go To 400
 5                Continue
                  Call Fck5(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDij),FT(ipFij1),Fac_ij,
     &                      Scrt(ipDkl),FT(ipFkl1),Fac_kl,
     &                      Scrt(ipDil),FT(ipFil1),Fac_il,
     &                      Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
                  Go To 400
 6                Continue
                  Call Fck6(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDik),FT(ipFik1),Fac_ik,
     &                      Scrt(ipDjl),FT(ipFjl1),Fac_jl,
     &                      Scrt(ipDil),FT(ipFil1),Fac_il,
     &                      Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
                  Go To 400
 7                Continue
                  Call Fck7(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDij),FT(ipFij1),Fac_ij,
     &                      Scrt(ipDkl),FT(ipFkl1),Fac_kl,
     &                      Scrt(ipDik),FT(ipFik1),Fac_ik,
     &                      Scrt(ipDjl),FT(ipFjl1),Fac_jl,
     &                      Scrt(ipDil),FT(ipFil1),Fac_il,
     &                      Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
                  Go To 400
************************************************************************
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
*
      iIrrep=0
      Fact=One
      If (lFij)
     &Call FckDst(TwoHam,nDens,FT(ipFij),iBas,jBas,iCmpa(1),iCmpa(2),
     &            kOp2(1),kOp2(2),iIrrep,
     &            iShij,
     &            iAO(1),iAO(2),iAOst(1),iAOst(2),
     &            Fact)
*
      If (lFkl)
     &Call FckDst(TwoHam,nDens,FT(ipFkl),kBas,lBas,iCmpa(3),iCmpa(4),
     &            kOp2(3),kOp2(4),iIrrep,
     &            iShkl,
     &            iAO(3),iAO(4),iAOst(3),iAOst(4),
     &            Fact)
*
      If (lFik)
     &Call FckDst(TwoHam,nDens,FT(ipFik),iBas,kBas,iCmpa(1),iCmpa(3),
     &            kOp2(1),kOp2(3),iIrrep,
     &            iShik,
     &            iAO(1),iAO(3),iAOst(1),iAOst(3),
     &            Fact)
*
      If (lFjl)
     &Call FckDst(TwoHam,nDens,FT(ipFjl),jBas,lBas,iCmpa(2),iCmpa(4),
     &            kOp2(2),kOp2(4),iIrrep,
     &            iShjl,
     &            iAO(2),iAO(4),iAOst(2),iAOst(4),
     &            Fact)
      If (lFil)
     &Call FckDst(TwoHam,nDens,FT(ipFil),iBas,lBas,iCmpa(1),iCmpa(4),
     &            kOp2(1),kOp2(4),iIrrep,
     &            iShil,
     &            iAO(1),iAO(4),iAOst(1),iAOst(4),
     &            Fact)
      If (lFjk)
     &Call FckDst(TwoHam,nDens,FT(ipFjk),jBas,kBas,iCmpa(2),iCmpa(3),
     &            kOp2(2),kOp2(3),iIrrep,
     &            iShjk,
     &            iAO(2),iAO(3),iAOst(2),iAOst(3),
     &            Fact)
*
      Return
      End
      Subroutine Fck1(AOInt,iBas,jBas,kBas,lBas,
     &                Dij,Fij,Cij,Dkl,Fkl,Ckl,ExFac)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 AOInt(iBas,jBas,kBas,lBas),
     &       Dij(iBas,jBas), Fij(iBas,jBas),
     &       Dkl(kBas,lBas), Fkl(kBas,lBas)
*
C     Call RecPrt('Dij',' ',Dij,iBas,jBas)
C     Write (*,*) 'Cij=',Cij
C     Call RecPrt('Dkl',' ',Dkl,kBas,lBas)
C     Write (*,*) 'Ckl=',Ckl
C     Call RecPrt('Fij(enter)',' ',Fij,iBas,jBas)
      Do l = 1, lBas
         Do k = 1, kBas
            F_kl = Zero
            D_kl = Dkl(k,l)*Cij
            Do j = 1, jBas
               Do i = 1, iBas
                  Vijkl = AOInt(i,j,k,l)
*
                  Fij(i,j) = Fij(i,j) +D_kl*Vijkl
                  F_kl = F_kl + Dij(i,j)*Vijkl
*
               End Do
            End Do
            Fkl(k,l) = Fkl(k,l) + Ckl*F_kl
         End Do
      End Do
C     Call RecPrt('Fij(exit)',' ',Fij,iBas,jBas)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(ExFac)
      End
      Subroutine Fck2(AOInt,iBas,jBas,kBas,lBas,
     &                Dik,Fik,Cik,Djl,Fjl,Cjl,ExFac)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 AOInt(iBas,jBas,kBas,lBas),
     &       Dik(iBas,kBas), Fik(iBas,kBas),
     &       Djl(jBas,lBas), Fjl(jBas,lBas)
*
      Do l = 1, lBas
         Do k = 1, kBas
            Do j = 1, jBas
               F_jl = Zero
               D_jl = Djl(j,l)*Cik
               Do i = 1, iBas
                  Vijkl = AOInt(i,j,k,l)*ExFac
*
                  Fik(i,k) = Fik(i,k) + D_jl*Vijkl
                  F_jl = F_jl + Dik(i,k)*Vijkl
*
               End Do
               Fjl(j,l) = Fjl(j,l) + Cjl*F_jl
            End Do
         End Do
      End Do
*
      Return
      End
      Subroutine Fck3(AOInt,iBas,jBas,kBas,lBas,
     &                Dij,Fij,Cij,Dkl,Fkl,Ckl,
     &                Dik,Fik,Cik,Djl,Fjl,Cjl,ExFac)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 AOInt(iBas,jBas,kBas,lBas),
     1       Dij(iBas,jBas), Fij(iBas,jBas),
     2       Dkl(kBas,lBas), Fkl(kBas,lBas),
     3       Dik(iBas,kBas), Fik(iBas,kBas),
     4       Djl(jBas,lBas), Fjl(jBas,lBas)
c    5       Dil(iBas,lBas), Fil(iBas,lBas),
c    6       Djk(jBas,kBas), Fjk(jBas,kBas)
*
      Do l = 1, lBas
         Do k = 1, kBas
            F_kl = Zero
            D_kl = Dkl(k,l)*Cij
            Do j = 1, jBas
               F_jl = Zero
               D_jl = Djl(j,l)*Cik
               Do i = 1, iBas
                  Vijkl = AOInt(i,j,k,l)
*
                  Fij(i,j) = Fij(i,j) +D_kl*Vijkl
                  F_kl = F_kl + Dij(i,j)*Vijkl
*
                  Fik(i,k) = Fik(i,k) + D_jl*Vijkl*ExFac
                  F_jl = F_jl + Dik(i,k)*Vijkl
*
               End Do
               Fjl(j,l) = Fjl(j,l) + Cjl*F_jl*ExFac
            End Do
            Fkl(k,l) = Fkl(k,l) + Ckl*F_kl
         End Do
      End Do
*
      Return
      End
      Subroutine Fck4(AOInt,iBas,jBas,kBas,lBas,
     &                Dil,Fil,Cil,Djk,Fjk,Cjk,ExFac)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 AOInt(iBas,jBas,kBas,lBas),
     &       Dil(iBas,lBas), Fil(iBas,lBas),
     &       Djk(jBas,kBas), Fjk(jBas,kBas)
*
      Do l = 1, lBas
         Do k = 1, kBas
            Do j = 1, jBas
               F_jk = Zero
               D_jk = Djk(j,k)*Cil
               Do i = 1, iBas
                  Vijkl = AOInt(i,j,k,l)*ExFac
*
                  Fil(i,l) = Fil(i,l) + D_jk*Vijkl
                  F_jk = F_jk + Dil(i,l)*Vijkl
*
               End Do
               Fjk(j,k) = Fjk(j,k) + Cjk*F_jk
            End Do
         End Do
      End Do
*
      Return
      End
      Subroutine Fck5(AOInt,iBas,jBas,kBas,lBas,
     &                Dij,Fij,Cij,Dkl,Fkl,Ckl,
     &                Dil,Fil,Cil,Djk,Fjk,Cjk,ExFac)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 AOInt(iBas,jBas,kBas,lBas),
     &       Dij(iBas,jBas), Fij(iBas,jBas),
     &       Dkl(kBas,lBas), Fkl(kBas,lBas),
     &       Dil(iBas,lBas), Fil(iBas,lBas),
     &       Djk(jBas,kBas), Fjk(jBas,kBas)
*
      Do l = 1, lBas
         Do k = 1, kBas
            F_kl = Zero
            D_kl = Dkl(k,l)*Cij
            Do j = 1, jBas
               F_jk = Zero
               D_jk = Djk(j,k)*Cil
               Do i = 1, iBas
                  Vijkl = AOInt(i,j,k,l)
*
                  Fij(i,j) = Fij(i,j) +D_kl*Vijkl
                  F_kl = F_kl + Dij(i,j)*Vijkl
*
                  Fil(i,l) = Fil(i,l) + D_jk*Vijkl*ExFac
                  F_jk = F_jk + Dil(i,l)*Vijkl
*
               End Do
               Fjk(j,k) = Fjk(j,k) + Cjk*F_jk*ExFac
            End Do
            Fkl(k,l) = Fkl(k,l) + Ckl*F_kl
         End Do
      End Do
*
      Return
      End
      Subroutine Fck6(AOInt,iBas,jBas,kBas,lBas,
     &                Dik,Fik,Cik,Djl,Fjl,Cjl,
     &                Dil,Fil,Cil,Djk,Fjk,Cjk,ExFac)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 AOInt(iBas,jBas,kBas,lBas),
     &       Dik(iBas,kBas), Fik(iBas,kBas),
     &       Djl(jBas,lBas), Fjl(jBas,lBas),
     &       Dil(iBas,lBas), Fil(iBas,lBas),
     &       Djk(jBas,kBas), Fjk(jBas,kBas)
*
      Do l = 1, lBas
         Do k = 1, kBas
            Do j = 1, jBas
               F_jl = Zero
               D_jl = Djl(j,l)*Cik
               F_jk = Zero
               D_jk = Djk(j,k)*Cil
               Do i = 1, iBas
                  Vijkl = AOInt(i,j,k,l)
*
                  Fik(i,k) = Fik(i,k) + D_jl*Vijkl*ExFac
                  F_jl = F_jl + Dik(i,k)*Vijkl
*
                  Fil(i,l) = Fil(i,l) + D_jk*Vijkl*ExFac
                  F_jk = F_jk + Dil(i,l)*Vijkl
*
               End Do
               Fjl(j,l) = Fjl(j,l) + Cjl*F_jl*ExFac
               Fjk(j,k) = Fjk(j,k) + Cjk*F_jk*ExFac
            End Do
         End Do
      End Do
*
      Return
      End
      Subroutine Fck7(AOInt,iBas,jBas,kBas,lBas,
     &                Dij,Fij,Cij,Dkl,Fkl,Ckl,
     &                Dik,Fik,Cik,Djl,Fjl,Cjl,
     &                Dil,Fil,Cil,Djk,Fjk,Cjk,ExFac)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 AOInt(iBas,jBas,kBas,lBas),
     &       Dij(iBas,jBas), Fij(iBas,jBas),
     &       Dkl(kBas,lBas), Fkl(kBas,lBas),
     &       Dik(iBas,kBas), Fik(iBas,kBas),
     &       Djl(jBas,lBas), Fjl(jBas,lBas),
     &       Dil(iBas,lBas), Fil(iBas,lBas),
     &       Djk(jBas,kBas), Fjk(jBas,kBas)
*
      Do l = 1, lBas
         Do k = 1, kBas
            F_kl = Zero
            D_kl = Dkl(k,l)*Cij
            Do j = 1, jBas
               F_jl = Zero
               D_jl = Djl(j,l)*Cik
               F_jk = Zero
               D_jk = Djk(j,k)*Cil
               Do i = 1, iBas
                  Vijkl = AOInt(i,j,k,l)
*
                  Fij(i,j) = Fij(i,j) +D_kl*Vijkl
                  F_kl = F_kl + Dij(i,j)*Vijkl
*
                  Fik(i,k) = Fik(i,k) + D_jl*Vijkl*ExFac
                  F_jl = F_jl + Dik(i,k)*Vijkl
*
                  Fil(i,l) = Fil(i,l) + D_jk*Vijkl*ExFac
                  F_jk = F_jk + Dil(i,l)*Vijkl
*
               End Do
               Fjl(j,l) = Fjl(j,l) + Cjl*F_jl*ExFac
               Fjk(j,k) = Fjk(j,k) + Cjk*F_jk*ExFac
            End Do
            Fkl(k,l) = Fkl(k,l) + Ckl*F_kl
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mxprintd_cvb(a,nrow,ncol,itype)

use Index_Functions, only: iTri
use casvb_global, only: formMXP1, formMXP2, formMXP3, formMXP4, iprec, iwidth
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: a(*)
integer(kind=iwp), intent(in) :: nrow, ncol, itype
integer(kind=iwp), parameter :: mxbuf = 8
integer(kind=iwp) :: i, ibuf(mxbuf), iform, ind, j, jend, jin, k, nbuf
real(kind=wp) :: buffer(mxbuf)

nbuf = min((iwidth-4)/(iprec+8),mxbuf)
if (nbuf == 7) nbuf = 6
iform = 1
jin = 1
do
  jend = jin+nbuf-1
  if (ncol <= nbuf) jend = ncol
  if (jend > ncol+nbuf-1) return
  jend = min(ncol,jend)
  k = 0
  do j=jin,jend
    k = k+1
    ibuf(k) = j
  end do
  if (iform == 0) then
    write(u6,formMXP1) ibuf(1:jend-jin+1)
  else
    write(u6,formMXP2) ibuf(1:jend-jin+1)
  end if
  do i=1,nrow
    k = 0
    do j=jin,jend
      k = k+1
      if (itype == 0) then
        ind = (j-1)*nrow+i
      else if (itype == 1) then
        ind = iTri(i,j)
      else
        ind = (i-1)*ncol+j
      end if
      buffer(k) = a(ind)
    end do
    if (iform == 0) then
      write(u6,formMXP3) i,buffer(1:jend-jin+1)
    else
      write(u6,formMXP4) i,buffer(1:jend-jin+1)
    end if
  end do
  jin = jend+1
  if (ncol <= nbuf) exit
end do

return

end subroutine mxprintd_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine seths_cvb(arr,n)
      implicit real*8(a-h,o-z)
      character*(*) arr(n)

      call seth_cvb([n],1)
      lenarr=len(arr(1))
      do 100 i=1,n
      do 101 j=1,lenarr
      call seth_cvb([ichar(arr(i)(j:j))],1)
101   continue
100   continue
      return
      end

      subroutine geths_cvb(arr,n)
      implicit real*8(a-h,o-z)
      character*(*) arr(n)
      dimension iaux(1)
      call geth_cvb(iaux,1)
      n=iaux(1)
      lenarr=len(arr(1))
      do 200 i=1,n
      do 201 j=1,lenarr
      call geth_cvb(iaux,1)
      iret=iaux(1)
      arr(i)(j:j)=char(iret)
201   continue
200   continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FILLMA(N,S,OVE)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION S(2),OVE(N,N)
      IJ=0
      DO 1 I=1,N
      DO 2 J=1,I
      IJ=IJ+1
      OVE(I,J)=S(IJ)
      OVE(J,I)=S(IJ)
2     CONTINUE
1     CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE TAB2F(IVER,LV)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      DIMENSION IORB(MXVERT)
      nijj=0
      IEL=2
      IF(IFIRST.NE.0)IEL=1
      IEL=IEL+1
      IUT=0
      IBF(1)=INT(2*S)
      IAF(1)=INT(N-2*S)/2
      IJF(LN+1)=0
      IJF(LN)=1
      NIJ=1
      IJR=1
      IJS=2
      IJRL=IJR
      IORB(1)=0
      DO 10 II=1,LN
      IIM=LN-II+1-LV
C     S=0
16    NIJ=NIJ+1
c      IF(NIJ.GT.IVER)
      nijj=max(nij,nijj)
      IAF(NIJ)=IAF(IJR)
      IBF(NIJ)=IBF(IJR)
      IORB(NIJ)=IORB(IJR)+2
      IF(IIM.LE.0)GO TO 11
      CALL CHEL(IAF(NIJ),IBF(NIJ),IIM,IEL,ISTOP)
      IF(ISTOP.EQ.1)NIJ=NIJ-1
11    IF(IBF(IJR).EQ.0)GO TO 12
C     S=1
      NIJ=NIJ+1
c      IF(NIJ.GT.IVER)
      nijj=max(nij,nijj)
      IAF(NIJ)=IAF(IJR)
      IBF(NIJ)=IBF(IJR)-1
      IORB(NIJ)=IORB(IJR)+1
      IF(IIM.LE.0)GO TO 12
      CALL CHEL(IAF(NIJ),IBF(NIJ),IIM,IEL,ISTOP)
      IF(ISTOP.EQ.1)NIJ=NIJ-1
12    IF(IAF(IJR).EQ.0)GO TO 13
C     S=2
      NIJ=NIJ+1
c      IF(NIJ.GT.IVER)
      nijj=max(nij,nijj)
      IAF(NIJ)=IAF(IJR)-1
      IBF(NIJ)=IBF(IJR)+1
      IORB(NIJ)=IORB(IJR)+1
      IF(IIM.LE.0)GO TO 13
      CALL CHEL(IAF(NIJ),IBF(NIJ),IIM,IEL,ISTOP)
      IF(ISTOP.EQ.1)NIJ=NIJ-1
13    IF(IAF(IJR).EQ.0)GO TO 14
C     S=3
      NIJ=NIJ+1
c      IF(NIJ.GT.IVER)
      nijj=max(nij,nijj)
      IAF(NIJ)=IAF(IJR)-1
      IBF(NIJ)=IBF(IJR)
      IORB(NIJ)=IORB(IJR)
      IF(IIM.LE.0)GO TO 14
      CALL CHEL(IAF(NIJ),IBF(NIJ),IIM,IEL,ISTOP)
      IF(ISTOP.EQ.1)NIJ=NIJ-1
14    IF(IJR.EQ.IJRL)GO TO 15
      IJR=IJR+1
      GO TO 16
C     DELETE VERTICES
15    CONTINUE
      NIJ1=NIJ-1
      IN=IJS
      IUT=IJS
      IF(NIJ1.LT.IJS)GO TO 21
      DO 20 IJD=IJS,NIJ1
         JJ1=NIJ-IJD+IJS-1
         J=JJ1+1
         DO 25 K=IJS,JJ1
            IF(IAF(J).NE.IAF(K))GO TO 25
            IF(IBF(J).NE.IBF(K))GO TO 25
            GO TO 26
25       CONTINUE
         GO TO 20
26       IAF(J)=-1
         IBF(J)=-1
20    CONTINUE
C     PACK VERTICES
      IJS1=IJS+1
      DO 30 J=IJS1,NIJ
         IF(IAF(J).NE.-1)GO TO 31
         IF(IBF(J).NE.-1)GO TO 31
         IN=IN+1
         GO TO 30
31       IN=IN+1
         IUT=IUT+1
         IAF(IUT)=IAF(IN)
         IBF(IUT)=IBF(IN)
         IORB(IUT)=IORB(IN)
30    CONTINUE
C     ORDER VERTICES
      IUT1=IUT-1
      IF(IUT1.LT.IJS)GO TO 21
      DO 41 J=IJS,IUT1
         J11=J+1
         DO 42 K=J11,IUT
            IF (IAF(J)-IAF(K).LT.0) THEN
               GO TO 43
            ELSE IF (IAF(J)-IAF(K).EQ.0) THEN
               GO TO 44
            ELSE
               GO TO 42
            END IF
44          IF(IBF(J).GT.IBF(K))GO TO 42
43          IAT=IAF(J)
            IBT=IBF(J)
            IAF(J)=IAF(K)
            IBF(J)=IBF(K)
            IAF(K)=IAT
            IBF(K)=IBT
42       CONTINUE
41    CONTINUE
21    IF(II.NE.LN)IJF(LN-II)=IUT
      IJR=IJS
      IJS=IUT+1
      IJRL=IUT
      NIJ=IUT
10    CONTINUE
      JJ2=0
      DO 40 II=1,LN
      I=LN-II+1
      JJ1=IJF(I+1)+1
      JJ2=IJF(I)
      J3=JJ2+1
      IF(I.NE.1)J4=IJF(I-1)
      IF(I.EQ.1)J4=IUT
C     DETERMINE CASE DOWN
      DO 50 J=JJ1,JJ2
      IA1=IAF(J)
      IB1=IBF(J)
      K0F(J)=0
      K1F(J)=0
      K2F(J)=0
      K3F(J)=0
      DO 60 JJ=J3,J4
      IF(IA1.EQ.IAF(JJ))GO TO 61
      IF((IA1-IAF(JJ)).NE.1)GO TO 60
      IF(IB1.EQ.IBF(JJ))GO TO 62
      IF((IBF(JJ)-IB1).NE.1)GO TO 60
      K2F(J)=JJ
      GO TO 60
62    K3F(J)=JJ
      GO TO 60
61    IF(IB1.EQ.IBF(JJ))GO TO 63
      IF((IB1-IBF(JJ)).NE.1)GO TO 60
      K1F(J)=JJ
      GO TO 60
63    K0F(J)=JJ
60    CONTINUE
50    CONTINUE
40    CONTINUE
      IVF0=IUT
      IVF1=IUT-1
      IVF2=IUT-2
      IVF3=IUT-3
      K0F(IUT)=0
      K1F(IUT)=0
      K2F(IUT)=0
      K3F(IUT)=0
      K0F(IUT+1)=0
      K1F(IUT+1)=0
      K2F(IUT+1)=0
      K3F(IUT+1)=0
      IF(IPRINT.GE.5)WRITE(IW,101)
101   FORMAT(///,6X,'TAB2F',//,8X,'J',7X,'AF',2X,'BF',6X,
     *'K0F',1X,'K1F',1X,'K2F',1X,'K3F',/)
      IF(IPRINT.GE.5)WRITE(IW,100)(J,IAF(J),IBF(J),K0F(J),
     *K1F(J),K2F(J),K3F(J),J=1,IUT)
100   FORMAT(6X,I3,5X,2I4,5X,4I4)
      write(6,*) ' Number of vertices', nijj, iut
      if (nijj.gt.iver) go to 300
      RETURN
300   WRITE(IW,310)IVER
310   FORMAT(/,6X,'NUMBER OF VERTICES EXCEEDS',I7)
      CALL Abend
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_MOReOrd(CMO,COcc,CVir)
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: reorder MOs,
!
!          CMO(alpha,i) -> COcc(i,alpha)
!          CMO(alpha,a) -> CVir(alpha,a)

use Cholesky, only: nBas, nSym
use ChoMP2, only: iAOVir, iT1AOT, nFro, nOcc, nVir
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(_OUT_) :: COcc(*), CVir(*)
integer(kind=iwp) :: i, iCount, iSym, jCount, kOff1, kOff2

iCount = 0
do iSym=1,nSym

  jCount = iCount+nBas(iSym)*nFro(iSym)

  do i=1,nOcc(iSym)
    kOff1 = jCount+nBas(iSym)*(i-1)+1
    kOff2 = iT1AOT(iSym,iSym)+i
    call dCopy_(nBas(iSym),CMO(kOff1),1,COcc(kOff2),nOcc(iSym))
  end do

  kOff1 = jCount+nBas(iSym)*nOcc(iSym)
  kOff2 = iAOVir(iSym,iSym)
  CVir(kOff2+1:kOff2+nBas(iSym)*nVir(iSym)) = CMO(kOff1+1:kOff1+nBas(iSym)*nVir(iSym))

  iCount = iCount+nBas(iSym)*nBas(iSym)

end do

end subroutine ChoMP2_MOReOrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE SPGRPCON(IOFSPGRP,  NSPGRP,    NGAS, MXPNGAS,IELFSPGRP,
     &                    ISPGRPCON,  IPRNT)
*
* Find connection matrix for string types
*
* ISPGRPCON(ISPGP,JSPGRP) = 0 => spgrps are identical
*                         = 1 => spgrps are connected by single excitation
*      .                  = 2 => spgrps are connected by double excitation
*       .              . ge.3 => spgrps are connected by triple or
*        .                       higher excitation
*
* Jeppe Olsen, September 1996
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION IELFSPGRP(MXPNGAS,*)
*. output
      DIMENSION ISPGRPCON(NSPGRP,NSPGRP)
*
      NTEST = 000
      NTEST = MAX(NTEST,IPRNT)
*
      DO ISPGRP = 1, NSPGRP
        ISPGRPA = IOFSPGRP-1+ISPGRP
        DO JSPGRP = 1, ISPGRP
          JSPGRPA = IOFSPGRP-1+JSPGRP
          IDIF = 0
          DO IGAS = 1, NGAS
            IDIF = IDIF
     &    + ABS(IELFSPGRP(IGAS,ISPGRPA)-IELFSPGRP(IGAS,JSPGRPA))
          END DO
          NEXC = IDIF/2
          ISPGRPCON(ISPGRP,JSPGRP) = NEXC
          ISPGRPCON(JSPGRP,ISPGRP) = NEXC
        END DO
      END DO
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) '==================== '
        WRITE(6,*) 'output from SPGRPCON '
        WRITE(6,*) '==================== '
        WRITE(6,*)
        NEXC1 = 0
        NEXC2 = 0
        DO ISPGRP=1, NSPGRP
          DO JSPGRP = 1, NSPGRP
            IF(ISPGRPCON(ISPGRP,JSPGRP).EQ.1) THEN
              NEXC1 = NEXC1 + 1
            ELSE IF(ISPGRPCON(ISPGRP,JSPGRP).EQ.2) THEN
              NEXC2 = NEXC2 + 1
            END IF
          END DO
        END DO
*
        WRITE(6,*)
     &  ' single excitation interactions',NEXC1,
     &   '( ',dble(NEXC1)*100.0D0/DBLE(NSPGRP)**2,' % ) '
        WRITE(6,*)
     &  ' double excitation interactions',NEXC2,
     &   '( ',dble(NEXC2)*100.0D0/DBLE(NSPGRP)**2,' % ) '
*
      END IF
*
      IF(NTEST.GE.1000) THEN
         WRITE(6,*) ' Supergroup connection matrix '
         CALL IWRTMA(ISPGRPCON,NSPGRP,NSPGRP,NSPGRP,NSPGRP)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine creates a symmetric ON basis a la Lowdin                *
! Not true if orbitals are deleted.                                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: Oct 2004                                                    *
!                                                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine goLowdin(CMO)

use Index_Functions, only: nTri_Elem
use GuessOrb_Global, only: nBas, nDel, nSym, SThr
use OneDat, only: sNoOri
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: CMO(*)
integer(kind=iwp) :: iBas, iComp, iOff, iOpt, iOrb, ipCMO, ipOvl(8), irc, iSym, iSymlb, jBas, kBas, nBig, nElem, npSmat, nTot, &
                     nTriTot
real(kind=wp) :: Temp
character(len=8) :: Lbl
real(kind=wp), allocatable :: Eig(:), Ovl(:), SMat(:), Vec(:)
#ifdef _DEBUGPRINT_
real(kind=wp), allocatable :: Tmp(:,:)
#endif

!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
nBig = 0
nTot = 0
nTriTot = 0
do iSym=1,nSym
  nTot = nTot+nBas(iSym)
  nTriTot = nTriTot+nTri_Elem(nBas(iSym))
  if (nBig < nBas(iSym)) nBig = nBas(iSym)
end do
!----------------------------------------------------------------------*
! Get overlap matrix                                                   *
!----------------------------------------------------------------------*
npSmat = nBig*nBig
call mma_allocate(Ovl,nTriTot+4)
ipOvl(1) = 1
call mma_allocate(Smat,npSmat)
iSymlb = 1
iOpt = ibset(0,sNoOri)
Lbl = 'Mltpl  0'
iComp = 1
call RdOne(irc,iOpt,Lbl,iComp,Ovl,iSymlb)
do iSym=1,nSym-1
  ipOvl(iSym+1) = ipOvl(iSym)+nTri_Elem(nBas(iSym))
end do
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
call mma_allocate(Vec,nBig**2)
call mma_allocate(Eig,nBig)

ipCMO = 1
do iSym=1,nSym
  nElem = nTri_Elem(nBas(iSym))
  Smat(1:nElem) = Ovl(ipOvl(iSym):ipOvl(iSym)+nElem-1)
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) '***'
  write(u6,*) '*** lowdin: symmetry',iSym
  write(u6,*) '***'
  write(u6,*)
  call TriPrt('Overlap matrix','(12f18.12)',Ovl(ipOvl(iSym)),nBas(iSym))
# endif
  call unitmat(Vec,nBas(iSym))
  call NIdiag_New(Ovl(ipOvl(iSym)),Vec,nBas(iSym),nbas(iSym))

  do iBas=1,nBas(iSym)
    call VecPhase(Vec((iBas-1)*nBas(iSym)+1),nBas(iSym))
  end do

# ifdef _DEBUGPRINT_
  call RecPrt('Transformation','(12f18.12)',Vec,nBas(iSym),nBas(iSym))
# endif
  call goPickUp(Ovl(ipOvl(iSym)),Eig,nBas(iSym))
# ifdef _DEBUGPRINT_
  call RecPrt('Overlap eigenvalues before sort','(12f18.12)',Eig,1,nBas(iSym))
# endif
  Eig(1:nBas(iSym)) = -Eig(1:nBas(iSym))
  call goSort(Eig,Vec,nBas(iSym),nBas(iSym))
  Eig(1:nBas(iSym)) = -Eig(1:nBas(iSym))
# ifdef _DEBUGPRINT_
  call RecPrt('Overlap eigenvalues after sort','(12f18.12)',Eig,1,nBas(iSym))
# endif
  nDel(iSym) = 0
  do iBas=1,nBas(iSym)
    if (Eig(iBas) < SThr) nDel(iSym) = nDel(iSym)+1
  end do
  Eig(1:nBas(iSym)) = One/sqrt(Eig(1:nBas(iSym)))
  if (.false.) then
    do iBas=1,nBas(iSym)
      do jBas=1,nBas(iSym)
        Temp = Zero
        do kBas=1,nBas(iSym)
          Temp = Temp+Eig(kBas)*Vec(nBas(iSym)*(kBas-1)+iBas)*Vec(nBas(iSym)*(kBas-1)+jBas)
        end do
        CMO(ipCMO+nBas(iSym)*(jBas-1)+(iBas-1)) = Temp
      end do
    end do
  else
    nElem = nBas(iSym)**2
    CMO(ipCMO:ipCMO+nElem-1) = Vec(1:nElem)
    do iOrb=1,nBas(iSym)
      iOff = ipCMO+nBas(iSym)*(iOrb-1)
      CMO(iOff:iOff+nBas(iSym)-1) = Eig(iOrb)*CMO(iOff:iOff+nBas(iSym)-1)
    end do
  end if
# ifdef _DEBUGPRINT_
  call RecPrt('Symmetric orbitals','(12f18.12)',CMO(ipCMO),nBas(iSym),nBas(iSym))
  call mma_allocate(Tmp,nBas(iSym),nBas(iSym))
  iSymlb = 1
  Lbl = 'Mltpl  0'
  call RdOne(irc,iOpt,Lbl,iComp,Ovl(ipOvl(1)),iSymlb)
  do iBas=1,nBas(iSym)
    do jBas=1,nBas(iSym)
      Temp = Zero
      do kBas=1,nBas(iSym)
        Temp = Temp+CMO(ipCMO+nBas(iSym)*(kBas-1)+(iBas-1))*CMO(ipCMO+nBas(iSym)*(jBas-1)+(kBas-1))
      end do
      Tmp(iBas,jBas) = Temp
    end do
  end do
  call RecPrt('Inverted overlap matrix','(12f18.12)',Tmp,nBas(iSym),nBas(iSym))
  call mma_deallocate(Tmp)
# endif
  ipCMO = ipCMO+nBas(iSym)*nBas(iSym)
end do

call mma_deallocate(Eig)
call mma_deallocate(Vec)
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
call mma_deallocate(Smat)
call mma_deallocate(Ovl)
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*

end subroutine goLowdin

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Get_D1A_RASSCF_m(CMO,D1A_MO,D1A_AO)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Compute the active one-body density                              *
*                                                                      *
*     calling arguments:                                               *
*     CMO     : input, array of real*8                                 *
*               MO-coefficients                                        *
*     D1A_MO  : output, array of real*8                                *
*               active one-body density in MO-space                    *
*     D1A_AO  : output, array of real*8                                *
*               active one-body density in AO-space                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension CMO(*) , D1A_MO(*) , D1A_AO(*)

#include "rasdim.fh"
#include "general.fh"
#include "WrkSpc.fh"


      Zero = 0.0d0

      iOff1 = 1
      iOff2 = 1
      iOff3 = 1
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        iAsh = nAsh(iSym)
        iIsh = nIsh(iSym)
        iFro = nFro(iSym)
        Call dCopy_(iBas*iBas,[Zero],0,D1A_AO(iOff3),1)
        If ( iAsh.ne.0 ) then
          Call GetMem('Scr1','Allo','Real',iTmp1,iAsh*iAsh)
          Call GetMem('Scr2','Allo','Real',iTmp2,iAsh*iBas)
          Call Square(D1A_MO(iOff1),Work(iTmp1),1,iAsh,iAsh)
          Call DGEMM_('N','T',
     &                iBas,iAsh,iAsh,
     &                1.0d0,CMO(iOff2+(iFro+iIsh)*iBas),iBas,
     &                Work(iTmp1),iAsh,
     &                0.0d0,Work(iTmp2),iBas)
          Call DGEMM_('N','T',
     &                iBas,iBas,iAsh,
     &                1.0d0,Work(iTmp2),iBas,
     &                CMO(iOff2+(iFro+iIsh)*iBas),iBas,
     &                0.0d0,D1A_AO(iOff3),iBas)
          Call GetMem('Scr2','Free','Real',iTmp2,iAsh*iBas)
          Call GetMem('Scr1','Free','Real',iTmp1,iAsh*iAsh)
        End If
        iOff1 = iOff1 + (iAsh*iAsh+iAsh)/2
        iOff2 = iOff2 + iBas*iBas
        iOff3 = iOff3 + iBas*iBas
      End Do


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ProjSym(nCent,Ind,A,iDCRs,B,dB,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,Proc_dB,nqB,nB,iq,rMult)

use Slapaf_Info, only: jStab, nStab, Smmtrc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nCent, Ind(nCent), iDCRs(nCent), nB_Tot, ndB_Tot, nB, iq
real(kind=wp), intent(in) :: A(3,nCent), B(3,nCent), dB(3,nCent,3,nCent), rMult
integer(kind=iwp), intent(inout) :: mB_Tot, mdB_Tot, iBM(nB_Tot), idBM(2,ndB_Tot), nqB(nB)
real(kind=wp), intent(inout) :: BM(nB_Tot), dBM(ndB_Tot)
logical(kind=iwp), intent(in) :: Proc_dB
integer(kind=iwp) :: i, i_Dim, ixyz, j, jDim, jxyz, jxyz_Max, k, kxyz, kxyz_Max, nq
real(kind=wp) :: ATemp(3)
real(kind=wp), allocatable :: Tx(:,:)

#ifdef _DEBUGPRINT_
call RecPrt('B',' ',B,3,nCent)
call RecPrt('dB',' ',dB,3*nCent,3*nCent)
write(u6,*) iDCRs
#endif

! Set up the T-matrix

! Project away nonsymmetric displacements

call mma_allocate(Tx,3,nCent,Label='Tx')

Tx(:,:) = One
do i=1,nCent
  call NonSym(nStab(Ind(i)),jStab(0,Ind(i)),A(:,i),Tx(:,i))

  ! Rotate vector back to the unique center

  call OA(iDCRS(i),Tx(1:3,i),ATemp)
  Tx(:,i) = ATemp(:)
end do

! Create BqR

nq = 0
do i=1,nCent
  do ixyz=1,3
    if (Smmtrc(ixyz,Ind(i))) then
      i_Dim = 0
      do j=1,Ind(i)
        jxyz_Max = 3
        if (j == Ind(i)) jxyz_Max = ixyz
        do jxyz=1,jxyz_Max
          if (Smmtrc(jxyz,j)) i_Dim = i_Dim+1
        end do
      end do
      mB_Tot = mB_Tot+1
      nq = nq+1
      BM(mB_Tot) = Tx(ixyz,i)*B(ixyz,i)
      iBM(mB_Tot) = i_Dim
    end if
  end do
end do
nqB(iq) = nq

! Create dBqR

if (Proc_dB) then
  do i=1,nCent
    do ixyz=1,3
      if (Smmtrc(ixyz,Ind(i))) then
        i_Dim = 0
        do j=1,Ind(i)
          jxyz_Max = 3
          if (j == Ind(i)) jxyz_Max = ixyz
          do jxyz=1,jxyz_Max
            if (Smmtrc(jxyz,j)) i_Dim = i_Dim+1
          end do
        end do

        do j=1,nCent
          do jxyz=1,3
            if (Smmtrc(jxyz,Ind(j))) then

              jDim = 0
              do k=1,Ind(j)
                kxyz_Max = 3
                if (k == Ind(j)) kxyz_Max = jxyz
                do kxyz=1,kxyz_Max
                  if (Smmtrc(kxyz,k)) jDim = jDim+1
                end do
              end do

              mdB_Tot = mdB_Tot+1
              dBM(mdB_Tot) = rMult*Tx(ixyz,i)*dB(ixyz,i,jxyz,j)*Tx(jxyz,j)
              idBM(1,mdB_Tot) = i_Dim
              idBM(2,mdB_Tot) = jDim

            end if
          end do
        end do

      end if
    end do
  end do
end if

call mma_deallocate(Tx)

return

end subroutine ProjSym

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKSE(DREF,NDREF)
! Set up the matrix SE(t,x)
! Formula used:
!    SE(t,x)=2*dtx - Dtx

use Index_Functions, only: iTri, nTri_Elem
use EQSOLV, only: IDSMAT
use caspt2_global, only: LUSBT
use caspt2_module, only: NAES, NASH, NINDEP, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDREF
real(kind=wp), intent(in) :: DREF(NDREF)
integer(kind=iwp) :: ID, IDISK, ISE, ISYM, IT, ITABS, IX, IXABS, NAS, NINM, NINP, NSE
real(kind=wp), allocatable :: SE(:)

do ISYM=1,NSYM
  NINP = NINDEP(ISYM,6)
  if (NINP == 0) cycle
  NINM = NINDEP(ISYM,7)
  NAS = NASH(ISYM)
  NSE = nTri_Elem(NAS)
  if (NSE > 0) call mma_allocate(SE,NSE,Label='SE')
  do IT=1,NAS
    ITABS = IT+NAES(ISYM)
    do IX=1,IT
      IXABS = IX+NAES(ISYM)
      ISE = iTri(IT,IX)
      ID = iTri(ITABS,IXABS)
      if (ITABS == IXABS) then
        SE(ISE) = Two-DREF(ID)
      else
        SE(ISE) = -DREF(ID)
      end if
    end do
  end do

  ! Write to disk
  if ((NSE > 0) .and. (NINDEP(ISYM,6) > 0)) then
    IDISK = IDSMAT(ISYM,6)
    call DDAFILE(LUSBT,1,SE,NSE,IDISK)
    if ((NINM > 0) .and. (NINDEP(ISYM,7) > 0)) then
      IDISK = IDSMAT(ISYM,7)
      call DDAFILE(LUSBT,1,SE,NSE,IDISK)
    end if
    call mma_deallocate(SE)
  end if
end do

end subroutine MKSE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Order_Arrays(mode,A1,N1,N2,P2,SCR1)

use Definitions, only: wp, iwp, u6

implicit none
character(len=4), intent(in) :: mode
integer(kind=iwp), intent(in) :: N1, N2
real(kind=wp), intent(inout) :: A1(N1,N2), P2(N2)
real(kind=wp), intent(out) :: SCR1(N1)
integer(kind=iwp) :: j, k
real(kind=wp) :: tmp

if (mode == 'decr') then
  do j=1,N2-1
    do k=j+1,N2
      if (P2(j) < P2(k)) then
        tmp = P2(j)
        P2(j) = P2(k)
        P2(k) = tmp
        SCR1(:) = A1(:,j)
        A1(:,j) = A1(:,k)
        A1(:,k) = SCR1(:)
      end if
    end do
  end do
else if (mode == 'incr') then
  do j=1,N2-1
    do k=j+1,N2
      if (P2(j) > P2(k)) then
        tmp = P2(j)
        P2(j) = P2(k)
        P2(k) = tmp
        SCR1(:) = A1(:,j)
        A1(:,j) = A1(:,k)
        A1(:,k) = SCR1(:)
      end if
    end do
  end do
else
  write(u6,*) ' In routine Order_Arrays: wrong mode!'
  call Abend()
end if

return

end subroutine Order_Arrays

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine PrMtrx(Label,lOper,nComp,ip,Matrix)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, Sweden, January '91                  *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Basis_Info, only: nBas
use Gateway_global, only: PrPrt
use Symmetry_Info, only: Mul, nIrrep
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: nComp, lOper(nComp), ip(nComp)
real(kind=wp), intent(in) :: Matrix(*)
integer(kind=iwp) :: iComp, iIrrep, ip1, iSmLbl, jIrrep
logical(kind=iwp) :: typ
character(len=80) :: Line

do iComp=1,nComp
  ip1 = ip(iComp)
  iSmLbl = lOper(iComp)
  if (Prprt) iSmLbl = merge(1,0,btest(iSmLbl,0))
  typ = .true.
  do iIrrep=0,nIrrep-1
    if (nBas(iIrrep) <= 0) cycle
    do jIrrep=0,iIrrep
      if (nBas(jIrrep) <= 0) cycle
      if (.not. btest(iSmLbl,Mul(iIrrep+1,jIrrep+1)-1)) cycle
      if (typ) then
        typ = .false.
        write(u6,*)
        write(u6,*)
        write(u6,'(A,A,A,I2)') ' SO Integrals of type ',Label,' Component ',iComp
      end if
      Line = ''
      if (iIrrep == jIrrep) then
        write(Line,'(1X,A,I1)') ' Diagonal Symmetry Block ',iIrrep+1
        call TriPrt(Line,' ',Matrix(ip1),nBas(iIrrep))
        ip1 = ip1+nTri_Elem(nBas(iIrrep))
      else
        write(Line,'(1X,A,I1,A,I1)') ' Off-diagonal Symmetry Block ',iIrrep+1,',',jIrrep+1
        call RecPrt(Line,' ',Matrix(ip1),nBas(iIrrep),nBas(jIrrep))
        ip1 = ip1+nBas(iIrrep)*nBas(jIrrep)
      end if
    end do
  end do
end do

return

end subroutine PrMtrx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE INCOOS(IDC,IBLTP,NOOS,NOCTPA,NOCTPB,ISTSM,ISTTA,ISTTB,
     &                  NSMST,IENSM,IENTA,IENTB,IACOOS,MXLNG,IFINI,
     &                  NBLOCK,INCFST,IOCOC)
*
* Obtain Number of OOS blocks that can be included
* IN MXLNG word starting from block after ISTSM,ISTTA,ISTTB
* Activated blocks are given in IACOOS
* Last activated block is (IENSM,IENTA,IENTB)
* If all blocks have been accessed IFINI is returned as 1
* Diagonal blocks are expanded
*
* Jeppe Olsen, Winter of 1991
*
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
      INTEGER NOOS(NOCTPA,NOCTPB,NSMST)
      INTEGER IOCOC(NOCTPA,NOCTPB)
C-May 7
      INTEGER IBLTP(*)
C-May 7
*.Output
      INTEGER IACOOS(NOCTPA,NOCTPB,NSMST)
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' =================='
        WRITE(6,*) ' INCOOS in action  '
        WRITE(6,*) ' =================='
        WRITE(6,*)
        WRITE(6,*) ' NOOS(NOCTPA,NOCTPB,NSMST) array (input) '
        WRITE(6,*)
        DO ISMST = 1, NSMST
         WRITE(6,*) ' ISMST = ', ISMST
         CALL IWRTMA(NOOS(1,1,ISMST),NOCTPA,NOCTPB,NOCTPA,NOCTPB)
        END DO
      END IF
*
      IPA = 0
      IPB = 0
      IPSM = 0
*
*.Initialize
      CALL ISETVC(IACOOS,0,NOCTPA*NOCTPB*NSMST)
      ISM = ISTSM
      IA = ISTTA
      IB = ISTTB
      LENGTH = 0
      NBLOCK = 0
      IENSM = ISTSM
      IENTA = ISTTA
      IENTB = ISTTB
      IFINI = 0
      IF(INCFST.EQ.1) GOTO 999
 1000 CONTINUE
*.Next block
      IPA = IA
      IPB = IB
      IPSM = ISM
*
      IF(IB.LT.NOCTPB) THEN
        IB = IB + 1
      ELSE
        IB = 1
        IF(IA.LT.NOCTPA) THEN
          IA = IA+ 1
        ELSE
          IA = 1
          IF(ISM.LT.NSMST) THEN
            ISM = ISM + 1
          ELSE
            IFINI = 1
          END IF
        END IF
      END IF
      IF(IFINI.EQ.1) GOTO 1001
*. Should this block be included
  999 CONTINUE
      IF(IDC.NE.1.AND.IBLTP(ISM).EQ.0) GOTO 1000
      IF(IDC.NE.1.AND.IBLTP(ISM).EQ.2.AND.IA.LT.IB) GOTO 1000
      IF(IOCOC(IA,IB).EQ.0) GOTO 1000
C?    write(6,*) ' INCOOS IDC IBLTP ', IDC,IBLTP(ISM)
*. can this block be included
      LBLOCK = NOOS(IA,IB,ISM)
C?    write(6,*) ' IA IB ISM LBLOCK ', IA,IB,ISM,LBLOCK
      IF(LENGTH+LBLOCK.LE.MXLNG) THEN
        NBLOCK = NBLOCK + 1
        LENGTH = LENGTH + LBLOCK
        IACOOS(IA,IB,ISM) = 1
        IF(NBLOCK.EQ.1) THEN
          ISTTA = IA
          ISTTB = IB
          ISTSM = ISM
         END IF
        GOTO 1000
      ELSE
        IA = IPA
        IB = IPB
        ISM = IPSM
      END IF
 1001 CONTINUE
*
      IENSM = ISM
      IENTA = IA
      IENTB = IB
      IF(IFINI.EQ.0.AND.NBLOCK.EQ.0) THEN
        WRITE(6,*) ' Not enough scratch space to include a single Block'
        WRITE(6,*) ' Since I cannot procede I will stop '
        WRITE(6,*) ' Insufficient buffer detected in INCOOS '
        WRITE(6,*) ' Alter RAS space of raise Buffer from ', MXLNG
        CALL MEMCHK
*        STOP 11
        CALL SYSABENDMSG('lucia_util/incoos','Internal error',' ')
      END IF
*
      IF(NTEST.NE.0) THEN
        WRITE(6,*) 'Output from INCOOS '
        WRITE(6,*) '==================='
        WRITE(6,*)
     &  ' Length and number of included blocks ',LENGTH,NBLOCK
      END IF
      IF(NTEST.GE.2) THEN
        DO 100 ISM = ISTSM,IENSM
          WRITE(6,*) ' Active blocks of symmetry ',ISM
          CALL IWRTMA(IACOOS(1,1,ISM),NOCTPA,NOCTPB,NOCTPA,NOCTPB)
  100   CONTINUE
        IF(IFINI.EQ.1) WRITE(6,*) ' No new blocks '
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
*  MyGetKey
*
*> @brief
*>   General purpose routine to read arbitrary data from user input.
*> @author V. Veryazov
*>
*> @details
*> The routine read a line from unit \p InUnit (ignoring molcas comments
*> and blank lines), and return a value or an array.
*>
*> Parameter \p What specifies the type of data:
*> * ``I`` -- read an integer and return it as \p IValue
*> * ``R`` -- read a real and return it as \p RValue
*> * ``S`` -- read a string and return it as \p SValue
*> * ``U`` -- recognize integer/real/string and return corresponding value
*> * ``A`` -- read integer array and return \p IArr
*> * ``D`` -- read real array and return \p RArr
*>
*> @param[in]     InUnit   Unit number
*> @param[in,out] What     Type of input
*> @param[out]    IValue   Integer Value
*> @param[out]    RValue   Real Value
*> @param[out]    SValue   String value
*> @param[in]     N        Size of array
*> @param[out]    IArr     Integer Array
*> @param[out]    RArr     Real Array
      Function MyGetKey(InUnit,What,IValue,RValue,SValue,N,IArr,RArr)
************************************************************************
* Adapted from SAGIT to work with OpenMolcas (October 2020)            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      character SValue *(*)
      Dimension IArr(*), RArr(*)
      character What
      character KWord*120
      MyGetKey=0
      iptr=1
      i=1
 1    Read(InUnit,'(A)',Err=20, end=20) KWord
      If (KWord(1:1).eq.'*'.or.KWord.eq.' ') Go To 1
      Call UpCase(KWord)
        if(What.eq.'I') then
              Read(KWord,*,Err=20) IValue
          else
           if(What.eq.'R') then
               Read(KWord,*,Err=20) RValue
             return
           else
           if(What.eq.'A') then
               Read(KWord,*,Err=20, End=40) (IArr(i),i=iptr,N)
           else

            if(What.eq.'D') then
               Read(KWord,*,Err=20, End=40) (RArr(i),i=iptr,N)
            else

            if(What.eq.'S') then
               Call NoBlanks(SValue, 120, KWord)
               goto 100
            else
             if(What.eq.'U') then
               Read(KWord,*,Err=2) IValue
               What='I'
               Goto 100
2              Read(KWord,*,Err=3) RValue
               What='R'
               Goto 100
3              Call NoBlanks(SValue, 120, KWord)
               What='S'
               Goto 100
             endif
            endif
           endif
          endif
         endif
        endif
100    return
40      iptr=i
        goto 1
20      MyGetKey=1
        return
       end
        subroutine NoBlanks(out,n,in)
        character out*(*), in*(n)
        integer flag
        flag=-1
        j=0
        do 1 i=1,len(in)
         if(flag.eq.-1.and.in(i:i).eq.' ') goto 1
         flag=0
         if(i.le.len(in)-1) then
           if(in(i:i+1).eq.'  ') goto 1
         endif
         j=j+1
         out(j:j)=in(i:i)
1       continue
        out(j+1:)=' '
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine check_create_klvab_t3_mem(vblock)
! this routine finds the upper estimate of the memory
! requirements of the most demanding step in create_klvab_t3

use ChT3_global, only: maxdim, nc, no, nv, printkey
use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: vblock
integer(kind=iwp) :: mem, mem_avail, mem_trial, vblock_my
real(kind=wp), parameter :: kb = 1024.0_wp

!.0 - calculate vblock_my

call my_block(vblock,vblock_my)

if (printkey >= 10) then
  write(u6,*)
  write(u6,*) 'check_create_klvab_t3_mem '
  write(u6,*)
  write(u6,'(A,3(i5,1x))') 'nc,no,nv',nc,no,nv
  write(u6,'(A,3(i5,1x))') 'maxdim,vblock,vblock_my',maxdim,vblock,vblock_my
end if

!.1 !create
mem = vblock*vblock*(no+nv)+nv*nTri_Elem(nv)+nv*nv+nc*maxdim+nc*maxdim*maxdim+ &
      max(nc*maxdim*maxdim,nc*no*maxdim,maxdim*maxdim*maxdim)
!.2 !klvaa_vvvo
mem_trial = vblock*vblock*(no+nv)+nv*nTri_Elem(nv)+nv*nv+vblock_my*vblock_my*no*no+2*maxdim*maxdim*no*no

if (mem_trial > mem) mem = mem_trial
!.3 !create
mem_trial = vblock*vblock*(no+nv)+nv*nTri_Elem(nv)+nv*nv+vblock_my*vblock_my*no*no+2*maxdim*maxdim*no*no

if (mem_trial > mem) mem = mem_trial
!.4 !create
mem_trial = no*no*vblock*(no+nv)+no*nv*nTri_Elem(no)+vblock*no*no+nc*nTri_Elem(no)+nc*no*nv+ &
            max(nc*nTri_Elem(no),nc*no*maxdim,nc*no*nv)

if (mem_trial > mem) mem = mem_trial
!.5 !create
mem_trial = no*no*vblock*(no+nv)+no*nv*nTri_Elem(no)+vblock*no*no+nv*vblock_my*no*no+2*maxdim*maxdim*no*no

if (mem_trial > mem) mem = mem_trial
!.6 !klvaa_oovo
mem_trial = no*no*vblock*(no+nv)+no*nv*nTri_Elem(no)+vblock*no*no+nv*vblock_my*nTri_Elem(no-1)+2*maxdim*maxdim*no*no

if (mem_trial > mem) mem = mem_trial
!.7 !klvaa_oovo
mem_trial = nTri_Elem(no-1)*vblock*vblock+vblock_my*vblock_my*no*no+nc*no*maxdim+2*max(nc*no*maxdim,maxdim*maxdim*no*no)

if (mem_trial > mem) mem = mem_trial
!.8 !klvaa_oovo
mem_trial = no*no*vblock*vblock+vblock_my*vblock_my*no*no+nc*no*maxdim+2*max(nc*no*maxdim,maxdim*maxdim*no*no)

if (mem_trial > mem) mem = mem_trial

if (printkey >= 10) then
  write(u6,*)
  write(u6,'(A,f10.1,A,f7.1,A,f3.1,A)') 'Memory required for the reorg. step = ',real(8*mem,kind=wp)/kb,' kb ', &
                                        real(8*mem,kind=wp)/kb**2,' Mb ',real(8*mem,kind=wp)/kb**3,' Gb'
end if

! - calculate available free memory

call mma_maxDBLE(mem_avail)

if (printkey >= 10) then
  write(u6,'(A,f10.1,A,f7.1,A,f3.1,A)') 'Available memory                    = ',real(8*mem_avail,kind=wp)/kb,' kb ', &
                                        real(8*mem_avail,kind=wp)/kb**2,' Mb ',real(8*mem_avail,kind=wp)/kb**3,' Gb'
  write(u6,*)
end if

! - check, if mem fits

if (mem_avail < mem) then
  write(u6,*) 'Not enough memory for the transformation step '
  call Abend()
end if

return

end subroutine check_create_klvab_t3_mem

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetMassDx(Mass,natom)

use Isotopes, only: Isotope
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natom
real(kind=wp), intent(out) :: Mass(natom)
integer(kind=iwp) :: matom, i, Iso
character(len=2), allocatable :: atom(:)

call mma_allocate(atom,natom)
call Get_Name_Full(atom)
call Get_nAtoms_All(matom)
call Get_Mass_All(Mass,matom)
do i=matom+1,natom
  atom(i) = adjustl(atom(i))
  Iso = 0
  call Isotope(Iso,atom(i),Mass(i))
end do
call mma_deallocate(atom)

end subroutine GetMassDx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine change_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"

#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


c General settings :
      proj=projsym

c Determine changes to memory assignment :
      call chpcmp0_cvb()

      call change1_cvb()
      call change2_cvb()
      call change3_cvb()
      call change4_cvb()
      call change5_cvb()
      call change6_cvb()
      call change7_cvb()

c  Finished determining reassignment of memory, now determine
c  what information must be evaluated/read again :

      call chpcmp2_cvb(kbasis,kbasisp)
      if(up2date_cvb('GUESS').and.kbasiscvb.ne.kbasis)
     >  call touch_cvb('TRNSPN')
      call symchk_cvb()
      if(chpcmp_cvb(nint(strtint*1d1)))call touch_cvb('RDINT')

c  Redo CIVB if definition has changed (from CVB or CIVECP) :
      if(lchpcmp_cvb(projcas))then
        call setcnt2_cvb(2,0)
        call setcnt2_cvb(3,0)
        call setcnt2_cvb(4,0)
        call setcnt2_cvb(5,0)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine MS_STRANS(IVEC,JVEC,NASHT,NTG3,OVL,TG1,TG2,TG3,HEL,SCAL_)
! Compute the coupling Hamiltonian element defined as
!     HEL = < ROOT1 | H * OMEGA | ROOT2 >
! assuming that IVEC contains a contravariant representation of
! H|ROOT1>, JVEC contains a contravariant representation of
! OMEGA|ROOT2>, and OVL, TG1, TG2, TG3 contain the overlap (normally
! expected to be 0 or 1) and active transition density matrices of ROOT1
! and ROOT2. See also subroutine TSVEC for explanations.

! SVC (March 2014): modification of original code to handle distributed
! RHS arrays. There is now a main HCOUP subroutine that loops over cases
! and irreps and gets access to the process-specific block of the RHS.
! The coupling for that block is computed by the subroutine HCOUP_BLK.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB
#endif
use PrintLevel, only: DEBUG
use fake_GA, only: GA_Arrays
use caspt2_global, only: iPrGlb
use caspt2_module, only: CASES, NASUP, NINDEP, NISUP, NSYM
use SC_NEVPT2, only: SC_prop
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC, NASHT, NTG3
real(kind=wp), intent(inout) :: OVL, TG1(NASHT,NASHT), TG2(NASHT,NASHT,NASHT,NASHT), TG3(NTG3)
real(kind=wp), intent(out) :: HEL
real(kind=wp), intent(in) :: SCAL_
integer(kind=iwp) :: IC, ICASE, iHi1, iHi2, iLo1, iLo2, IS, ISYM, jHi1, jHi2, jLo1, jLo2, lg_V1, lg_V2, MV1, MV2, NAS, NHECOMP, &
                     NIN, NIS, nvlen
real(kind=wp) :: HEBLK, HECOMP(14,9), SCAL
character :: CNT

! The dimension of TG3 is NTG3=(NASHT**2+2 over 3)

! Sketch of procedure:
!  Loop over every (case/symmetry)-block.
!     If (No such vector block) Skip to end of loop
!     Allocate two places for this block, VEC1 and VEC2
!     Read VEC1 as IVEC component from file.
!     Read VEC2 as JVEC component from file.
!     Loop nest, computing
!        HEL := HEL + VEC1*GOM*VEC2
!     End of loop nest
!     Deallocate VEC1 and VEC2
!  End of loop.

if (SC_prop) then
  CNT = 'T'
  SCAL = Half*SCAL_
else
  CNT = 'N'
  SCAL = SCAL_
end if

HEL = Zero
HECOMP = Zero
do ICASE=1,13
  !if ((icase /= 12) .and. (icase /= 13)) cycle ! H
  !if ((icase /= 10) .and. (icase /= 11)) cycle ! G
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIN = NINDEP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    HEBLK = Zero

    if ((NAS*NIS /= 0) .and. (NIN /= 0)) then
      call RHS_ALLO(NAS,NIS,lg_V1)
      call RHS_ALLO(NAS,NIS,lg_V2)
      call RHS_READ(NAS,NIS,lg_V1,ICASE,ISYM,IVEC)
      call RHS_READ(NAS,NIS,lg_V2,ICASE,ISYM,JVEC)
      call RHS_ACCESS(NAS,NIS,lg_V1,iLo1,iHi1,jLo1,jHi1,MV1)
      call RHS_ACCESS(NAS,NIS,lg_V2,iLo2,iHi2,jLo2,jHi2,MV2)

      if ((iLo1 /= iLo2) .or. (iHi1 /= iHi2) .or. (jLo1 /= jLo2) .or. (jHi1 /= jHi2)) then
        write(u6,'(1X,A)') 'HCOUP: Error: block mismatch, abort...'
        call ABEND()
      end if

      nvlen = (iHi1-jLo1+1)*(jHi1-jLo1+1)

#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par()) then
        call MS_STRANS_BLK(ICASE,ISYM,NAS,nvlen,NASHT,NTG3,jLo1,jHi1,DBL_MB(MV1),DBL_MB(MV2),OVL,TG1,TG2,TG3,SCAL,CNT)
      else
#     endif
        call MS_STRANS_BLK(ICASE,ISYM,NAS,nvlen,NASHT,NTG3,jLo1,jHi1,GA_Arrays(MV1)%A,GA_Arrays(MV2)%A,OVL,TG1,TG2,TG3,SCAL,CNT)
#     ifdef _MOLCAS_MPP_
      end if
#     endif
      !! Save T*S
      call RHS_SAVE(NAS,NIS,lg_V2,ICASE,ISYM,JVEC)

      call RHS_RELEASE(lg_V1,iLo1,iHi1,jLo1,jHi1)
      call RHS_RELEASE(lg_V2,iLo2,iHi2,jLo2,jHi2)
      call RHS_FREE(lg_V1)
      call RHS_FREE(lg_V2)
    end if
    HECOMP(ICASE,ISYM) = HEBLK
    HEL = HEL+HEBLK
  end do
end do

! Sum-reduce the per-process contributions
call GADGOP_SCAL(HEL,'+')
NHECOMP = 14*9
call GADGOP(HECOMP,NHECOMP,'+')

if (IPRGLB >= DEBUG) then
  do ICASE=1,13
    HECOMP(ICASE,NSYM+1) = sum(HECOMP(ICASE,1:NSYM))
  end do

  do ISYM=1,NSYM+1
    HECOMP(14,ISYM) = sum(HECOMP(1:13,ISYM))
  end do

  write(u6,'(A)') repeat('-',80)
  write(u6,*) 'HCOUP: The contributions to the Hamiltonian coupling'
  write(u6,*) ' elements, by case and by symmetry label.'
  do IC=1,13
    write(u6,'(1X,A8,9F12.8)') CASES(IC),(HECOMP(IC,IS),IS=1,NSYM+1)
  end do
  call XFLUSH(u6)
  write(u6,'(1X,A8,9F12.8)') 'Summed: ',(HECOMP(14,IS),IS=1,NSYM+1)
  write(u6,*)
end if

end subroutine MS_STRANS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_Gvv(Gvv)
! check Gvv(be,a)

use chcc_global, only: Gvvc, Hvvc, no, nv, Q3, T1c
use stdalloc, only: mma_allocate
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Gvv(nv,nv)
integer(kind=iwp) :: a, b, bad, be, i
real(kind=wp) :: s

call mma_allocate(Gvvc,nv,nv,label='Gvvc')

bad = 0

do be=1,nv
  do a=1,nv

    !s = Zero
    !do i=1,no
    !  do j=1,no
    !    do b=1,nv
    !      s = s+(Two*Q21(a,i,b,j)-Q21(a,j,b,i))*T2c(be,b,i,j)
    !    end do
    !  end do
    !end do
    !s =-s

    s = Hvvc(be,a)

    do i=1,no
      do b=1,nv
        s = s+(Two*Q3(a,be,b,i)-Q3(b,be,a,i))*T1c(b,i)
      end do
    end do

    Gvvc(be,a) = s

    if (abs(Gvv(be,a)-s) > 1.0e-10_wp) bad = bad+1

  end do
end do

write(u6,*) ' Gvv Chck :',bad

return

end subroutine Chck_Gvv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module ChoCASPT2

! Comment: numcho_pt2, InfVec_N2_PT2, and MaxVec_PT2 are copies
! of corresponding values in module Cholesky.
! Values are transferred at the beginning of caspt2.

use Data_Structures, only: Alloc1DiArray_Type
use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: iALGO, MaxVec_PT2, MXCHARR, MXNVC, nAsplit(8), NCHSPC, NFTSPC, NFTSPC_TOT, NHTSPC, nIsplit(8), nksh(8), &
                     npsh(8), numcho_pt2(8)
type(Alloc1DiArray_Type) :: Unt(8)

public :: iALGO, MaxVec_PT2, MXCHARR, MXNVC, NASplit, NCHSPC, NFTSPC, NFTSPC_TOT, NHTSPC, NISplit, nksh, npsh, NumCho_PT2, Unt

end module ChoCASPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      Subroutine R1IntA
************************************************************************
*                                                                      *
*     purpose: Read one-electron hamiltonian and overlap matrix        *
*                                                                      *
*     called from: ReadIn                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      use SCF_Arrays
      Implicit Real*8 (a-h,o-z)
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
#include "real.fh"
#ifdef _FDE_
#include "embpotdata.fh"
#endif
*
*---- Define local variables
      Character*8 Label
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
#ifdef _FDE_
      ! Embedding
      iDummyEmb=0
      Call Get_iScalar('embpot', iDummyEmb)
      if (iDummyEmb.eq.1) embPot=.true.
      if (embPot) then
         call mma_allocate(Emb,nBT,Label='Emb')
         ipEmb=ip_of_Work(Emb(1))
         Call EmbPotRdRun
      end if
#endif
*---- Allocate memory for one-electron integrals
      Call mma_allocate(OneHam,nBT,Label='OneHam')
      Call mma_allocate(Ovrlp,nBT+4,Label='Ovrlp')
      Call FZero(OneHam,nBT)
      Call FZero(Ovrlp,nBT+4)
*
*---- Read core Hamiltonian
      iRc=-1
      iOpt=6
      iComp=1
      iSyLbl=1
      Label='OneHam  '
      Call RdOne(iRc,iOpt,Label,iComp,OneHam,iSyLbl)
      If (iRc.ne.0) Then
         Write (6,*) 'R1Inta: Error readin ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend()
      End If
#ifdef _FDE_
      ! Embedding
      if (embPot) then
       if (embPotInBasis) then
        ! If the potential is given in basis set representation it
        ! has not been calculated with a OneEl call and is just read
        ! from file here.
        iunit = isFreeUnit(1)
        call molcas_open(iunit, embPotPath)
        do iEmb=1, nBT
         read(iunit,*) Emb(iEmb)
        end do
        close(iunit)
       else
        ! Read one-electron integrals due to embedding potential
        iRc=-1
        Label='embpot  '
        Call RdOne(iRc,iOpt,Label,iComp,Emb,iSyLbl)
        If (iRc.ne.0) Then
           Write (6,*) 'R1Inta: Error readin ONEINT'
           Write (6,'(A,A)') 'Label=',Label
           Call Abend()
        End If
       end if
      end if
#endif
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      ist1Hm=1
      Write (6,*)
      Write (6,*) ' One electron Hamiltonian at start'
      Write (6,*) ' ---------------------------------'
      Do iSym=1,nSym
         Write (6,*) ' symmetry block',iSym
         Call TriPrt(' ',' ',OneHam(ist1Hm),nBas(iSym))
         ist1Hm=ist1Hm+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
#endif
*
*---- Read overlap integrals and total effective nuclear charge
      iRc=-1
      iOpt=2
      iComp=1
      iSyLbl=1
      Label='Mltpl  0'
      Call RdOne(iRc,iOpt,Label,iComp,Ovrlp,iSyLbl)
      If (iRc.ne.0) Then
         Write (6,*) 'R1Inta: Error readin ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend()
      End If
      Tot_Nuc_Charge=Ovrlp(nBT+4)
#ifdef _DEBUGPRINT_
      istOvl=1
      Write (6,*)
      Write (6,*) ' Overlap matrix at start'
      Write (6,*) ' -----------------------'
      Do iSym=1,nSym
         Write (6,*) ' symmetry block',iSym
         Call TriPrt(' ',' ',Ovrlp(istOvl),nBas(iSym))
         istOvl=istOvl+nBas(iSym)*(nBAs(iSym)+1)/2
      End Do
#endif
*
*---- Perform Lowdin orthonormalization
*
      nD = iUHF+1
      Call mma_allocate(Lowdin,nBB,nD,Label='Lowdin')
      Call FZero(Lowdin,nBB*nD)
      ioff=1
      Do iSym=1,nSym
         Call dCopy_(nBas(iSym),[One],0,Lowdin(ioff,1),nBas(iSym)+1)
         ioff=ioff+nBas(iSym)*nBas(iSym)
      End Do
      Call xxLowdin(Ovrlp,Lowdin(1,1),nBas,nSym)
      If (nD.eq.2) Call DCopy_(nBB,Lowdin(1,1),1,Lowdin(1,2),1)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine saamphlp2 (t2aaaa,t2bbbb,t2abab,t2baba,t2abba,t2baab,
     & noai,noaj,nobi,nobj,nvaa,nvab,nvba,nvbb,key)
c
c     adaptation routine for T2 amplitudes for symi>symj, syma>symb
c
c     t2aaaa- amplitides T2(a,b,i,j)aaaa (I/O)
c     t2bbbb- amplitides T2(a,b,i,j)bbbb (I/O)
c     t2abab- amplitides T2(a,b,i,j)abab (I/O)
c     t2baba- amplitides T2(b,a,j,i)abab (I/O)
c     t2abba- amplitides T2(b,a,i,j)abab (I/O)
c     t2baab- amplitides T2(a,b,j,i)abab (I/O)
c     noai  - number of alpha occupied orbitals in symi (I)
c     noaj  - number of alpha occupied orbitals in symj (I)
c     nobi  - number of beta occupied orbitals in symi (I)
c     nobj  - number of beta occupied orbitals in symj (I)
c     nvaa  - number of alpha virtual orbitals in syma (I)
c     nvab  - number of alpha virtual orbitals in symb (I)
c     nvba  - number of beta virtual orbitals in syma (I)
c     nvbb  - number of beta virtual orbitals in symb (I)
c     key   - type of adaptation (I)
c     0 - no adaptation
c     1 - T2 DDVV adaptation
c     2 - T2 DDVV + T1 DV adaptation
c     3 - full T1 and T2 adaptation (only for doublets)
c     4 - full T2 without SDVS (only for doublets)
c
       integer noai,noaj,nobi,nobj,nvaa,nvab,nvba,nvbb
cT2
       real*8 t2aaaa(1:nvaa,1:nvab,1:noai,1:noaj)
       real*8 t2bbbb(1:nvba,1:nvbb,1:nobi,1:nobj)
       real*8 t2abab(1:nvaa,1:nvbb,1:noai,1:nobj)
       real*8 t2baba(1:nvab,1:nvba,1:noaj,1:nobi)
       real*8 t2abba(1:nvab,1:nvba,1:noai,1:nobj)
       real*8 t2baab(1:nvaa,1:nvbb,1:noaj,1:nobi)
c
       integer key
c
c     help variables
c
       integer ndi,ndj,nva,nvb,nsi,nsj,nsa,nsb
       integer i,j,a,b
       real*8 taaaa,tbbbb,tabab,tabba,tbaab,tbaba,t1,t2
c
       if (key.eq.0) then
       return
       end if
c
       ndi=nobi
       ndj=nobj
       nva=nvaa
       nvb=nvab
       nsi=noai-nobi
       nsj=noaj-nobj
       nsa=nvba-nvaa
       nsb=nvbb-nvab
c
c
c     T2 adatption
c
c     case I) DDVV i>=j,a>=b
c     turn od in any case of type of adaption
c
c     aaaa=t24a(ijab) DDVV
c     bbbb=t24b(ijab) DDVV
c     abab=t22b(ijab) DDVV
c     abba=-t22b(ijba) DDVV
c     baab=-t22b(jiab) DDVV
c     baba=t22b(ji,ba) DDVV
c
c     direct
c     t1 = (abab+baba-abba-baab)/4
c     t2 = (2aaaa+2bbbb+abab+baba+abba+baab)/12
c
c     reverse
c
c     aaaa = 2t2
c     bbbb = 2t2
c     abab = t2+t1
c     abba = t2-t1
c     baab = t2-t1
c     baba = t2+t1
c
       do 100 j=1,ndj
       do 101 i=1,ndi
       do 102 b=1,nvb
       do 103 a=1,nva
c
       taaaa=t2aaaa(a,b,i,j)
       tbbbb=t2bbbb(a+nsa,b+nsb,i,j)
       tabab=t2abab(a,b+nsb,i,j)
       tbaba=t2baba(b,a+nsa,j,i)
       tabba=-t2abba(b,a+nsa,i,j)
       tbaab=-t2baab(a,b+nsb,j,i)
c
       t1=(tabab+tbaba-tabba-tbaab)/4.0d0
       t2=(2.0d0*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/1.2d1
c
       taaaa=2.0d0*t2
       tbbbb=2.0d0*t2
       tabab=t1+t2
       tbaba=t1+t2
       tabba=t2-t1
       tbaab=t2-t1
c
       t2aaaa(a,b,i,j)=taaaa
       t2bbbb(a+nsa,b+nsb,i,j)=tbbbb
       t2abab(a,b+nsb,i,j)=tabab
       t2baba(b,a+nsa,j,i)=tbaba
       t2abba(b,a+nsa,i,j)=-tabba
       t2baab(a,b+nsb,j,i)=-tbaab
c
 103    continue
 102    continue
 101    continue
 100    continue
c
c
       if (((key.eq.3).or.(key.eq.4)).and.(nsb.gt.0)) then
c
c     case II) DDVS
c
c     bbbb = t24b(ij,ab)
c     abab = t22b(i,j,a,b)
c     baab =-t22b(j,i,a,b)
c
c     direct :
c
c     t1=(abab-baab)/2
c     t2=(2bbbb+abab+baab)/6
c
c     reverse:
c
c     bbbb = 2t2
c     abab = t2+t1
c     baab = t2-t1
c
       b=nsb
       do 200 j=1,ndj
       do 201 i=1,ndi
       do 202 a=1,nva
c
       tbbbb=t2bbbb(a+nsa,b,i,j)
       tabab=t2abab(a,b,i,j)
       tbaab=-t2baab(a,b,j,i)
c
       t1=(tabab-tbaab)/2.0d0
       t2=(2.0d0*tbbbb+tabab+tbaab)/6.0d0
c
       tbbbb=2.0d0*t2
       tabab=t2+t1
       tbaab=t2-t1
c
       t2bbbb(a+nsa,b,i,j)=tbbbb
       t2abab(a,b,i,j)=tabab
       t2baab(a,b,j,i)=-tbaab
c
 202    continue
 201    continue
 200    continue
c
       end if
c
c
       if (((key.eq.3).or.(key.eq.4)).and.(nsa.gt.0)) then
c
c     case III) DDSV
c
c     bbbb = - t24b(ij,ab)
c     abab = - -t22b(i,j,b,a)
c     baab = - t22b(j,i,b,a)
c
c     direct :
c
c     t1=(abab-baab)/2
c     t2=(2bbbb+abab+baab)/6
c
c     reverse:
c
c     bbbb = 2t2
c     abab = t2+t1
c     baab = t2-t1
c
       a=nsa
       do 300 j=1,ndj
       do 301 i=1,ndi
       do 302 b=1,nvb
c
       tbbbb=-t2bbbb(a,b+nsb,i,j)
       tabab=t2abba(b,a,i,j)
       tbaab=-t2baba(b,a,j,i)
c
       t1=(tabab-tbaab)/2.0d0
       t2=(2.0d0*tbbbb+tabab+tbaab)/6.0d0
c
       tbbbb=2.0d0*t2
       tabab=t2+t1
       tbaab=t2-t1
c
       t2bbbb(a,b+nsb,i,j)=-tbbbb
       t2abba(b,a,i,j)=tabab
       t2baba(b,a,j,i)=-tbaab
c
 302    continue
 301    continue
 300    continue
c
       end if
c
c
       if (((key.eq.3).or.(key.eq.4)).and.(nsi.gt.0)) then
c
c     case IV) SDVV
c
c     aaaa=t24a(ij,ab)
c     abab=t22b(i,j,a,b)
c     abba=-t22b(i,j,b,a)
c
c     direct
c
c     t1=(abab-abba)/2
c     t2=(2aaaa+abab+abba)/6
c
c     reverse
c
c     aaaa=2t2
c     abab=t2+t1
c     abba=t2-t1
c
       i=ndi+nsi
       do 400 j=1,ndj
       do 401 b=1,nvb
       do 402 a=1,nva
c
       taaaa=t2aaaa(a,b,i,j)
       tabab=t2abab(a,b+nsb,i,j)
       tabba=-t2abba(b,a+nsa,i,j)
c
       t1=(tabab-tabba)/2.0d0
       t2=(2.0d0*taaaa+tabab+tabba)/6.0d0
c
       taaaa=2.0d0*t2
       tabab=t2+t1
       tabba=t2-t1
c
       t2aaaa(a,b,i,j)=taaaa
       t2abab(a,b+nsb,i,j)=tabab
       t2abba(b,a+nsa,i,j)=-tabba
c
 402    continue
 401    continue
 400    continue
c
       end if
c
c
       if (((key.eq.3).or.(key.eq.4)).and.(nsj.gt.0)) then
c
c     case V) DSVV
c
c     aaaa= - t24a(ij,ab)
c     abab= - -t22b(j,i,a,b)
c     abba= - t22b(j,i,b,a)
c
c     direct
c
c     t1=(abab-abba)/2
c     t2=(2aaaa+abab+abba)/6
c
c     reverse
c
c     aaaa=2t2
c     abab=t2+t1
c     abba=t2-t1
c
       j=ndj+nsj
       do 500 i=1,ndi
       do 501 b=1,nvb
       do 502 a=1,nva
c
       taaaa=-t2aaaa(a,b,i,j)
       tabab=t2baab(a,b+nsb,j,i)
       tabba=-t2baba(b,a+nsa,j,i)
c
       t1=(tabab-tabba)/2.0d0
       t2=(2.0d0*taaaa+tabab+tabba)/6.0d0
c
       taaaa=2.0d0*t2
       tabab=t2+t1
       tabba=t2-t1
c
       t2aaaa(a,b,i,j)=-taaaa
       t2baab(a,b+nsb,j,i)=tabab
       t2baba(b,a+nsa,j,i)=-tabba
c
 502    continue
 501    continue
 500    continue
c
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************

subroutine VECSORT(NSYM,NBAS,NORB,CMO,OCC,INDT,NNWORD,NEWORD,iErr)
! Sorting routine: sort CMO, OCC according to INDT

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NSYM, NBAS(NSYM), NORB(NSYM), NNWORD
real(kind=wp), intent(inout) :: CMO(*), OCC(*)
integer(kind=iwp), intent(inout) :: INDT(*), iErr
! PAM 2012: Have VecSort return an array NEWORD with new orbital indices.
! If typedef info in an orbital file is used to change the order
! of orbitals, this is done by a call to VecSort. If user, as a result,
! needs to alter orbital indices ( e.g. in the supersymmetry array
! IXSYM) he needs to know how orbitals have changed order.
! The mapping is (New orbital index)=NEWORD(Old orbital index).
integer(kind=iwp), intent(out) :: NEWORD(NNWORD)
! PAM 2012: End of update
integer(kind=iwp) :: i, ii, iii, ip, isfirst, ISYM, iType, j, kcmo, kocc, m, MBAS, NeedSort, nw
real(kind=wp) :: q
real(kind=wp), allocatable :: TCMO(:)

MBAS = NBAS(1)
do i=2,nSym
  MBAS = max(MBAS,NBAS(i))
end do
call mma_allocate(TCMO,MBAS,label='TCMO')

kcmo = 0
kocc = 0
iii = 0

! PAM 2012: NewOrd update
! If NNWORD is > 0, this indicates the caller wish to get back
! a reindicing array. Then this must be large enough:
if (NNWORD > 0) then
  nw = 0
  do ISYM=1,NSYM
    do i=1,NORB(ISYM)
      nw = nw+1
    end do
  end do
  if (nw > NNWORD) then
    call Abend()
  end if

  do nw=1,NNWORD
    NEWORD(nw) = nw
  end do
end if
! PAM 2012: End of update

do ISYM=1,NSYM
  ! Check Do we need make sort?
  NeedSort = 0
  !write(u6,*) 'indt'
  !write(u6,*) (indt(i+iii),i=1,norb(isym))
  do I=1,NORB(ISYM)
    if (IndT(i+iii) == 0) then
      iErr = 1
    end if
    if (i > 1) then
      if (IndT(i+iii) < IndT(i-1+iii)) NeedSort = 1
    end if
  end do
  !write(u6,*) 'NeedSort=',NeedSort
  if (NeedSort == 1) then
    ! Start sort
    ! we do have only a few types of orbitals, so sorting is a simple...
    do iType=1,7
      ip = 0
      isfirst = 0
      do i=1,NORB(ISYM)
        if (isfirst == 0) then
          if (IndT(i+iii) > iType) then
            isfirst = 1
          end if
          if (IndT(i+iii) <= iType) then
            ip = i
          end if
        end if
        if ((isfirst == 1) .and. (IndT(i+iii) == iType)) then
          ! We need to shift CMO, Occ
          m = IndT(i+iii)
          q = Occ(i+KOCC)
          ! PAM 2012: NewOrd update
          if (NNWORD > 0) nw = NEWORD(i+KOCC)
          ! PAM 2012: End of update
          do ii=1,NBAS(ISYM)
            TCMO(ii) = CMO((i-1)*NORB(ISYM)+KCMO+ii)
          end do
          do j=i,ip+2,-1
            IndT(j+iii) = IndT(j-1+iii)
            Occ(j+KOCC) = Occ(j-1+KOCC)
            ! PAM 2012: NewOrd update
            if (NNWORD > 0) NEWORD(j+KOCC) = NEWORD(j-1+KOCC)
            ! PAM 2012: End of update
            do ii=1,NBAS(ISYM)
              CMO((j-1)*NORB(ISYM)+KCMO+ii) = CMO((j-2)*NORB(ISYM)+KCMO+ii)
            end do
          end do

          IndT(ip+1+iii) = m
          Occ(ip+1+KOCC) = q
          ! PAM 2012: NewOrd update
          if (NNWORD > 0) NEWORD(ip+1+KOCC) = nw
          ! PAM 2012: End of update
          do ii=1,NBAS(ISYM)
            CMO((ip)*NORB(ISYM)+KCMO+ii) = TCMO(ii)
          end do

          ip = ip+1
        end if
      end do
    end do
    !write(u6,*) 'sorted:'
    !write(u6,'(10i2)') (IndT(i+iii),i=1,NORB(ISYM))
    !write(u6,'(4E18.12)') (Occ(i+KOCC),i=1,NORB(ISYM))

    !do ii=1,NBAS(ISYM)
    !  write(u6,*)
    !  write(u6,'(4E18.12)') (CMO(i+KOCC+(ii-1)*NBAS(ISYM)),i=1,NORB(ISYM))
    !end do

    ! End sort
  end if
  ! Next symmetry
  KCMO = KCMO+NBAS(ISYM)*NORB(ISYM)
  KOCC = KOCC+NORB(ISYM)
  iii = iii+NORB(ISYM)

end do
call mma_deallocate(TCMO)

return

end subroutine VECSORT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Francesco Aquilante                              *
************************************************************************
      SubRoutine Cho_SOSmp2_DecDrv(irc,DelOrig,Diag)
C
C     Francesco Aquilante, May 2007.
C
C     Purpose: decompose M(ai,bj) = (ai|bj)^2 for use in
C              SOS-MP2 approach.
C
C     DelOrig: flag for deleting files with original vectors after
C              decomposition completes.
C
#include "implicit.fh"
      External Cho_SOSmp2_Col, ChoMP2_Vec
      Integer  irc
      Logical  DelOrig
      Real*8   Diag(*)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"
#include "WrkSpc.fh"

      Character*6  ThisNm
      Character*17 SecNam
      Parameter (SecNam = 'Cho_SOSmp2_DecDrv', ThisNm = 'DecDrv')

      Logical Restart, Failed
      Parameter (Restart = .false.)

      Integer iClos(2)

C     Initializations.
C     ----------------

      irc = 0

      lErrStat = 3
      Call GetMem('ErrStat','Allo','Real',ipErrStat,lErrStat)
      If (Verbose) Then
         nBin = 18
         Call GetMem('Bin','Allo','Real',ipBin,nBin)
      Else
         ipBin = -999999
         nBin  = 0
      End If

      Do iSym = 1,nSym
         nMP2Vec(iSym) = 0
         InCore(iSym)  = .false.
      End Do
      NowSym    = -999999
      ip_OldVec = -999999
      l_OldVec  = 0

      If (DelOrig) Then
         iClos(1) = 3  ! signals close and delete original vectors
      Else
         iClos(1) = 2  ! signals close and keep original vectors
      End If
      iClos(2) = 2     ! signals close and keep result vectors


C     Print.
C     ------

      If (Verbose) Then
         Write(6,*)
         Call Cho_Head('Cholesky Decomposition of  M(ai,bj) = (ai|bj)^2'
     &                 //' for SOS-MP2','=',80,6)
         Write(6,'(/,1X,A)') 'Configuration of decomposition:'
         Write(6,'(1X,A,1P,D15.6)') 'Threshold: ',ThrMP2
         Write(6,'(1X,A,1P,D15.6)') 'Span     : ',SpanMP2
         If (ChkDecoMP2) Then
            Write(6,'(1X,A)') 'Full decomposition check activated.'
         End If
      End If

C     Start symmetry loop.
C     --------------------

      kOffD = 1
      Do iSym = 1,nSym

         nDim = nT1am(iSym)
         If (nDim.gt.0 .and. NumCho(iSym).gt.0) Then

            If (Verbose .and. nBin.gt.0) Then
               Work(ipBin) = 1.0D2
               Do iBin = ipBin+1,ipBin+nBin-1
                  Work(iBin) = Work(iBin-1)*1.0D-1
               End Do
               Write(6,'(//,1X,A,I2,A,I9)')
     &         '>>> Cholesky decomposing symmetry block ',iSym,
     &         ', dimension: ',nDim
               Write(6,'(/,1X,A)') 'Analysis of initial diagonal:'
               Call Cho_AnaSize(Diag(kOffD),nDim,Work(ipBin),nBin,6)
            End If

C           Open files.
C           -----------

            Do iTyp = 1,2
               Call ChoMP2_OpenF(1,iTyp,iSym)
            End Do

C           Setup decomposition.
C           --------------------

            NowSym = iSym

            If (MxQualMP2 .ne. MxQual_Def) Then ! user-defined
               MxQual = min(max(MxQualMP2,1),nDim)
            Else ! default
               If (nDim .gt. 10) Then
                  MxQual = max(min(nDim/10,MxQualMP2),1)
               Else
                  MxQual = max(min(nDim,MxQualMP2),1)
               End If
            End If
#if !defined (_I8_)
            lTstBuf = (nDim+MxQual)*MxQual
            lTstQua = nDim*(MxQual+1)
            Do While ((lTstBuf.lt.0.or.lTstQua.lt.0) .and. MxQual.gt.0)
               MxQual  = MxQual - 1
               lTstBuf = (nDim+MxQual)*MxQual
               lTstQua = nDim*(MxQual+1)
            End Do
            If (MxQual .lt. 1) Then
               Write(6,*) SecNam,': MxQual causes integer overflow!'
               Write(6,*) SecNam,': parameters:'
               Write(6,*) 'Symmetry block: ',iSym
               Write(6,*) 'Dimension     : ',nDim
               Write(6,*) 'MxQual        : ',MxQual
               irc = -99
               Go To 1 ! exit
            End If
#endif

            lQual   = nDim*(MxQual + 1)
            liQual  = MxQual
            liPivot = nDim
            Call GetMem('Qual','Allo','Real',ipQual,lQual)
            Call GetMem('iQual','Allo','Inte',ipiQual,liQual)
            Call GetMem('iPivot','Allo','Inte',ipiPivot,liPivot)

            Call GetMem('GetMax','Max ','Real',ipB,lB)
            lBuf = min((nDim+MxQual)*MxQual,lB)
            Left = lB - lBuf
            nInC = Left/nDim
            If (nInC .ge. NumCho(iSym)) Then
               InCore(iSym) = .true.
               l_OldVec = nDim*NumCho(iSym)
               Call GetMem('OldVec','Allo','Real',ip_OldVec,l_OldVec)
               iOpt = 2
               lTot = l_OldVec
               iAdr = 1
               Call ddaFile(lUnit_F(iSym,1),iOpt,
     &                      Work(ip_OldVec),lTot,iAdr)
            End If
            Call GetMem('GetMx2','Max ','Real',ipB,lBuf)
            Call GetMem('DecBuf','Allo','Real',ipBuf,lBuf)

C           Decompose this symmetry block.
C           ------------------------------

            Thr  = ThrMP2
            Span = SpanMP2
            Call ChoDec(Cho_SOSmp2_Col,ChoMP2_Vec,Restart,Thr,Span,
     &                  MxQual,Diag(kOffD),Work(ipQual),Work(ipBuf),
     &                  iWork(ipiPivot),iWork(ipiQual),nDim,lBuf,
     &                  Work(ipErrStat),nMP2Vec(iSym),irc)
            If (irc .ne. 0) Then
               Write(6,*) SecNam,': ChoDec returned ',irc,
     &                           '   Symmetry block: ',iSym
               Go To 1 ! exit...
            End If
            XMn = Work(ipErrStat)
            XMx = Work(ipErrStat+1)
            RMS = Work(ipErrStat+2)
            If (Verbose) Then
               Write(6,'(/,1X,A)')
     &         '- decomposition completed!'
               Write(6,'(1X,A,I9,A,I9,A)')
     &         'Number of vectors needed: ',nMP2Vec(iSym),
     &         ' (number of AO vectors: ',NumCho(iSym),')'
               Write(6,'(1X,A)')
     &         'Error statistics for (ai|ai)^2 [min,max,rms]:'
               Write(6,'(1X,1P,3(D15.6,1X))') XMn,XMx,RMS
            End If
            Failed = abs(Xmn).gt.Thr .or. abs(XMx).gt.thr .or.
     &               RMS.gt.Thr
            If (Failed) Then
               If (.not. Verbose) Then
                  Write(6,'(1X,A)')
     &            'Error statistics for (ai|ai)^2 [min,max,rms]:'
                  Write(6,'(1X,1P,3(D15.6,1X))') XMn,XMx,RMS
               End If
               Write(6,*) SecNam,': (ai|bj)^2 decomposition failed!'
               irc = -9999
               Go To 1 ! exit
            End If

C           If requested, check decomposition.
C           ----------------------------------

            If (ChkDecoMP2) Then
               Write(6,*)
               Write(6,*)SecNam,': Checking M(ai,bj)=(ai|bj)^2 CD.'
               Write(6,*)'Symmetry block: ',iSym
               Write(6,*)'Threshold, Span, MxQual: ',Thr,Span,MxQual
               Write(6,*)'Error statistics for (ai|ai)^2 [min,max,rms]:'
               Write(6,*) (Work(ipErrStat+i),i=0,2)
               Call Cho_SOSmp2_DecChk(irc,iSym,Work(ipQual),nDim,MxQual,
     &                            Work(ipBuf),lBuf,Work(ipErrStat))
               If (irc .ne. 0) Then
                Write(6,*) SecNam,': ChoMP2_DecChk returned ',irc,
     &                            '   Symmetry block: ',iSym
                Call ChoMP2_Quit(SecNam,'SOS-MP2 decomposition failed!',
     &                             ' ')
               Else
                  XMn = Work(ipErrStat)
                  XMx = Work(ipErrStat+1)
                  RMS = Work(ipErrStat+2)
                  Failed = Failed .or. abs(Xmn).gt.Thr .or.
     &                     abs(XMx).gt.Thr .or. RMS.gt.Thr
                  Write(6,*)
     &            'Error statistics for (ai|bj)^2 [min,max,rms]:'
                  Write(6,*) XMn,XMx,RMS
                  If (Failed) Then
                     Write(6,*) '==> DECOMPOSITION FAILURE <=='
                     irc = -9999
                     Go To 1 ! exit
                  Else
                     Write(6,*) '==> DECOMPOSITION SUCCESS <=='
                  End If
                  Call xFlush(6)
               End If
            End If

C           Free memory.
C           ------------

            Call GetMem('DecBuf','Free','Real',ipBuf,lBuf)
            If (InCore(iSym)) Then
               Call GetMem('OldVec','Free','Real',ip_OldVec,l_OldVec)
               ip_OldVec = -999999
               l_OldVec  = 0
            End If
            Call GetMem('iPivot','Free','Inte',ipiPivot,liPivot)
            Call GetMem('iQual','Free','Inte',ipiQual,liQual)
            Call GetMem('Qual','Free','Real',ipQual,lQual)

C           Close (possibly deleting original) files.
C           -----------------------------------------

            Do iTyp = 1,2
               Call ChoMP2_OpenF(iClos(iTyp),iTyp,iSym)
            End Do

C           Update pointer to diagonal block.
C           ---------------------------------

            kOffD = kOffD + nT1am(iSym)

         Else

            If (Verbose) Then
               Write(6,'(//,1X,A,I2,A)')
     &         '>>> Symmetry block',iSym,' is empty!'
            End If

         End If

      End Do

    1 If (irc .ne. 0) Then ! make sure files are closed before exit
         Do iSym = 1,nSym
            Do iTyp = 1,2
               Call ChoMP2_OpenF(2,iTyp,iSym)
            End Do
         End Do
      End If
      Call GetMem('Flush','Flush','Real',ipErrStat,lErrStat)
      Call GetMem('ErrStat','Free','Real',ipErrStat,lErrStat)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fokupdate1(foka,fokb,symp,i,vint,ndimv1,ndimv2,ndimv3)
! this routine realizes update
! foka(p,q) = foka(p,q) + <ip|iq>
! fokb(p,q) = fokb(p,q) + <ip|iq>
!
! N.B. integrals are of type <symi, symp| symi,symp>
!
! foka    - packed Fokaa matrix (I,O)
! fokb    - packed Fokbb matrix (I,O)
! symp    - irrep or p (and also q) index (I)
! i       - value of i, (I)
! vint    - array of integrals <ip|iq> for given i (I)
! ndimv1  - first dimension (norb(symp)) (I)
! ndimv2  - second dimension (norb(symi)) (I)
! ndimv3  - third dimension (norb(symp)) (I)

use ccsort_global, only: NORB
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: foka(*), fokb(*)
integer(kind=iwp), intent(in) :: symp, i, ndimv1, ndimv2, ndimv3
real(kind=wp), intent(in) :: vint(ndimv1,ndimv2,ndimv3)
integer(kind=iwp) :: nhelp1, nhelp2, p, pq, q

! calculate shift

nhelp1 = 0
do nhelp2=1,symp-1
  nhelp1 = nhelp1+(norb(nhelp2)**2+norb(nhelp2))/2
end do

! add integral

pq = nhelp1
do p=1,norb(symp)
  do q=1,p
    pq = pq+1
    foka(pq) = foka(pq)+vint(p,i,q)
    fokb(pq) = fokb(pq)+vint(p,i,q)
  end do
end do

return

end subroutine fokupdate1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SGPRWF(SGS,CIS,LSYM,PRWTHR,iSpin,CI,lCI,KeyPRSD,LUVECDET)
! PURPOSE: PRINT THE WAVEFUNCTION (SPIN COUPLING AND OCCUPATIONS)
!
! NOTE:    THIS ROUTINE USES THE SPLIT GRAPH GUGA CONVENTION, I.E.,
!          CI BLOCKS ARE MATRICES CI(I,J), WHERE THE  FIRST INDEX
!          REFERS TO THE UPPER PART OF THE WALK.

use gugx, only: CIStruct, SGStruct
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
type(SGStruct), intent(inout) :: SGS
type(CIStruct), intent(inout) :: CIS
integer(kind=iwp), intent(in) :: LSYM, iSpin, lCI, LUVECDET
real(kind=wp), intent(in) :: PRWTHR, CI(lCI)
logical(kind=iwp), intent(in) :: KeyPrSD
integer(kind=iwp) :: IC1, ICDPOS, ICDWN, ICONF, ICS(50), ICUP, ICUPOS, IDW0, IDWN, IDWNSV, IMS, iOff, ISYDWN, ISYM, ISYUP, IUP, &
                     IUW0, LEV, MV, NCI, NDWN, NNN, NUP
real(kind=wp) :: COEF
character(len=400) :: Line
integer(kind=iwp), allocatable :: Lex(:)

! RECONSTRUCT THE CASE LIST

if (.not. allocated(CIS%iCase)) call MKCLIST(SGS,CIS)

! scratch for determinant expansion
if (KeyPRSD) call mma_allocate(LEX,SGS%nLev,Label='LEX')

Line(1:16) = '      conf/sym  '
iOff = 16
iSym = SGS%ISm(1)
do Lev=1,SGS%nLev
  if (SGS%ISm(Lev) /= iSym) iOff = iOff+1
  write(Line(iOff+Lev:),'(I1)') SGS%ISm(Lev)
  if (SGS%ISm(Lev) /= iSym) iSym = SGS%ISm(Lev)
end do
iOff = iOff+SGS%nLev+3
Line(iOff:iOff+15) = '   Coeff  Weight'
write(u6,'(A)') Line(1:iOff+15)
Line = ' '

! ENTER THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
! WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.

do MV=1,CIS%nMidV
  do ISYUP=1,SGS%nSym
    NCI = CIS%NOCSF(ISYUP,MV,LSYM)
    if (NCI == 0) cycle
    NUP = CIS%NOW(1,ISYUP,MV)
    ISYDWN = 1+ieor(ISYUP-1,LSYM-1)
    NDWN = CIS%NOW(2,ISYDWN,MV)
    ICONF = CIS%IOCSF(ISYUP,MV,LSYM)
    IUW0 = 1-CIS%nIpWlk+CIS%IOW(1,ISYUP,MV)
    IDW0 = 1-CIS%nIpWlk+CIS%IOW(2,ISYDWN,MV)
    IDWNSV = 0
    do IDWN=1,NDWN
      do IUP=1,NUP
        ICONF = ICONF+1
        COEF = CI(ICONF)
        ! SKIP OR PRINT IT OUT?
        if (abs(COEF) < PRWTHR) cycle
        if (IDWNSV /= IDWN) then
          ICDPOS = IDW0+IDWN*CIS%nIpWlk
          ICDWN = CIS%iCase(ICDPOS)
          ! UNPACK LOWER WALK.
          NNN = 0
          do LEV=1,SGS%MidLev
            NNN = NNN+1
            if (NNN == 16) then
              NNN = 1
              ICDPOS = ICDPOS+1
              ICDWN = CIS%iCase(ICDPOS)
            end if
            IC1 = ICDWN/4
            ICS(LEV) = ICDWN-4*IC1
            ICDWN = IC1
          end do
          IDWNSV = IDWN
        end if
        ICUPOS = IUW0+CIS%nIpWlk*IUP
        ICUP = CIS%iCase(ICUPOS)
        ! UNPACK UPPER WALK:
        NNN = 0
        do LEV=SGS%MidLev+1,SGS%nLev
          NNN = NNN+1
          if (NNN == 16) then
            NNN = 1
            ICUPOS = ICUPOS+1
            ICUP = CIS%iCase(ICUPOS)
          end if
          IC1 = ICUP/4
          ICS(LEV) = ICUP-4*IC1
          ICUP = IC1
        end do
        ! PRINT IT!
        write(Line(1:),'(I8)') iConf
        iOff = 10
        iSym = SGS%ISm(1)
        do Lev=1,SGS%nLev
          if (SGS%ISm(Lev) /= iSym) iOff = iOff+1

          select case (ICS(Lev))
            case (3)
              write(Line(iOff+Lev:),'(A1)') '2'
            case (2)
              write(Line(iOff+Lev:),'(A1)') 'd'
            case (1)
              write(Line(iOff+Lev:),'(A1)') 'u'
            case (0)
              write(Line(iOff+Lev:),'(A1)') '0'
            case default
              call Abend()
          end select

          if (SGS%ISm(Lev) /= iSym) iSym = SGS%ISm(Lev)

        end do
        iOff = iOff+SGS%nLev+3
        write(Line(iOff:),'(2F8.5)') COEF,COEF**2
        write(u6,'(6X,A)') Line(1:iOff+15)
        if (KeyPRSD) then
          ! use maximum spin projection value
          IMS = ISPIN-1
          write(u6,*)
          call EXPCSF(ICS,SGS%nLev,IMS,LEX,coef,LuVecDet)
          write(u6,*)
        end if
        Line = ' '
      end do
    end do
  end do
end do

! free memory for determinant expansion
if (KeyPRSD) call mma_deallocate(LEX)

end subroutine SGPRWF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
      subroutine stermha4(w,ww,ind1,jbr)
      implicit real*8 (a-h,o-z)
      data done,two/1.d0,2.d0/
      isq=0
      w=0.0d0
      ww=0.0d0
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      goto(34,35,40,44),ind1
c     case a&l
c     case a&r
34    w=fq
      goto 1
35    w=done
      goto 1
40    w=sqrt(b/(b+done))
      goto 1
44    w=-fq*sqrt((b+two)/(b+done))
c      if(abs(w).gt.1.e-13) then
1     isq=1
      ww=w
      return
      end
c
      subroutine stermhd1(w,ww,ind1,jbr)
      implicit real*8 (a-h,o-z)
      data done,two,three/1.d0,2.d0,3.d0/
      isq=0
      w=0.0d0
      ww=0.0d0
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      goto(38,39,43,48),ind1
c   d1: case d&r&l
38    w=-fq/sqrt(two)
      ww=-fq*sqrt((b-done)/(b+b+two))
      goto 2
43    w=-fq/sqrt(two)
      ww=fq*sqrt((b+three)/(b+b+two))
      goto 2
48    w=fq*sqrt(two)
      goto 2
39    ww=-sqrt(b/(b+done))
c      if(dldr.eq.2101) ww=(b+two)/(b+done)
2     isq=2
      return
      end
c
      subroutine stermhd5(w,ww)
      implicit real*8 (a-h,o-z)
      data two/2.d0/
      isq=0
      w=0.0d0
      ww=0.0d0
c     calculate w,ww
c   d5: case d&r&r
      w=-sqrt(two)
      isq=3
      return
      end
c
      subroutine stermla1(w,ww,ind1,jbr)
c     case a^l
      implicit real*8 (a-h,o-z)
      data done/1.d0/
      w=0.0d0
      ww=0.0d0
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      goto(19,24,50,60),ind1
19    w=-sqrt((b+1)/(b+2))
      goto 2
24    w=-done
      goto 2
50    w=fq*sqrt((b+1)/b)
      goto 2
60    w=fq
2     ww=w
      return
      end
c
      subroutine stermla2(w,ww,ind1,jbr)
c     case a^r
      implicit real*8 (a-h,o-z)
      data done,two/1.d0,2.d0/
      w=0.0d0
      ww=0.0d0
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      goto(21,31,57,62),ind1
21    w=-fq
      goto 3
57    w=done
      goto 3
62    w=sqrt((b+done)/b)
      goto 3
31    w=-fq*sqrt((b+done)/(b+two))
3     ww=w
      return
      end
c
      subroutine stermld2(w,ww,ind1,jbr)
c    d2: case d^r^l
      implicit real*8 (a-h,o-z)
      data done,two/1.d0,2.d0/
      w=0.0d0
      ww=0.0d0
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      goto(7,38,43,48,74),ind1
38    w=-fq/sqrt(two)
      ww=fq*sqrt((b+two)/(b*two))
      goto 4
43    w=-fq/sqrt(two)
      ww=-fq*sqrt(b/(b+b+4.0d0))
      goto 4
48    w=-fq*sqrt(two)
      goto 4
7     ww=-sqrt((b+done)/(b+two))
      goto 4
74    ww=sqrt((b+done)/b)
4     return
      end
c
      subroutine stermld6(w,ww)
c   d6: case d^r^r
      implicit real*8  (a-h,o-z)
      data dzero,two/0.d0,2.d0/
      w=-sqrt(two)
      ww=dzero
      return
      end
c
      subroutine segmidc1(w,ww,ind1,jbr)
c  case c1
      implicit real*8 (a-h,o-z)
      data dzero,done,three/0.d0,1.d0,3.d0/
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      w=dzero
      ww=dzero
      goto(17,22,23,27,32,49,54,58,59,64),ind1
17    w=done
      goto 2
22    w=done
      goto 2
23    w=fq/sqrt((b*b+4.0d0*b+4.0d0))
      goto 2
27    w=-sqrt((b+done)*(b+three)/(b*b+4.0d0*b+4.0d0))
      goto 2
32    w=-done
      goto 2
49    w=done
      goto 2
54    w=sqrt((b+done)*(b-done)/(b*b))
      goto 2
58    w=fq/b
      goto 2
59    w=-done
      goto 2
64    w=-done
2     ww=w
      return
      end
c
      subroutine segmidc2(w,ww,ind1,jbr)
c  case c2
      implicit real*8 (a-h,o-z)
      data dzero,done,two,three/0.d0,1.d0,2.d0,3.d0/
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      w=dzero
      ww=dzero
      goto(1,6,7,11,16,33,38,39,42,43,48,65,70,74,75,80),ind1
33    w=done
      ww=done
      goto 2
38    w=-done
      ww=-sqrt((b-done)*(b+two)/(b*b+b))
      goto 2
43    w=-done
      ww=-sqrt(b*(b+three)/(b*b+three*b+two))
      goto 2
48    w=done
      ww=done
      goto 2
39    ww=-fq*sqrt(two/(b*b+three*b+two))
      goto 2
7     ww=-fq*sqrt(two/((b+two)*(b+three)))
      goto 2
1     ww=done
      goto 2
6     ww=-done
      goto 2
11    ww=-sqrt((b+done)*(b+4.0d0)/((b+two)*(b+three)))
      goto 2
16    ww=done
      goto 2
65    ww=done
      goto 2
70    ww=-sqrt((b-two)*(b+done)/(b*b-b))
      goto 2
75    ww=-done
      goto 2
80    ww=done
      goto 2
42    ww=fq*sqrt(two/(b*(b+done)))
      goto 2
74    ww=fq*sqrt(two/(b*b-b))
2     return
      end
c
      subroutine segmidc22(w,ww,ind1,jbr)
c  case c22
      implicit real*8 (a-h,o-z)
      data dzero,done,two,three/0.d0,1.d0,2.d0,3.d0/
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      w=dzero
      ww=dzero
      goto(1,6,7,11,16,33,38,39,43,48,65,70,75,80),ind1
33    w=done
      ww=done
      goto 2
38    w=-done
      ww=-sqrt((b-done)*(b+two)/(b*b+b))
      goto 2
43    w=-done
      ww=-sqrt(b*(b+three)/(b*b+three*b+two))
      goto 2
48    w=done
      ww=done
      goto 2
39    ww=-fq*sqrt(two/(b*b+three*b+two))
      goto 2
7     ww=-fq*sqrt(two/((b+two)*(b+three)))
      goto 2
1     ww=done
      goto 2
6     ww=-done
      goto 2
11    ww=-sqrt((b+done)*(b+4.0d0)/((b+two)*(b+three)))
      goto 2
16    ww=done
      goto 2
65    ww=done
      goto 2
70    ww=-sqrt((b-two)*(b+done)/(b*b-b))
      goto 2
75    ww=-done
      goto 2
80    ww=done
2     return
      end
c
      subroutine segmidb3(w,ww,ind1,jbr)
c  submid b3(b&l)
      implicit real*8     (a-h,o-z)
      data dzero,done,two,three/0.d0,1.d0,2.d0,3.d0/vtwo/0.5d0/
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      w=dzero
      ww=dzero
      goto(21,25,30,31,53,57,62,63),ind1
21    w=- sqrt(vtwo)
      ww=-sqrt(b/(b+b+4.0d0))
      goto 2
57    w=fq*sqrt(vtwo)
      ww=-fq*sqrt((b+two)/(b+b))
      goto 2
62    w=-fq*sqrt((b+done)/(b+b))
      ww=fq*sqrt((b-done)/(b+b))
      goto 2
31    w=sqrt((b+done)/(b+b+4.0d0))
      ww=sqrt((b+three)/(b+b+4.0d0))
      goto 2
25    ww=-fq*sqrt((b+three)/(b+two))
      goto 2
30    ww=fq
      goto 2
53    ww=-sqrt((b-done)/b)
      goto 2
63    ww=done
2     return
      end
c
      subroutine segmidb4(w,ww,ind1,jbr)
c   segmid b4(b&r)
      implicit real*8 (a-h,o-z)
      data dzero,done,two,three/0.d0,1.d0,2.d0,3.d0/vtwo/0.5d0/
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      w=dzero
      ww=dzero
      goto(18,19,24,28,50,51,56,60),ind1
50    w=-sqrt((b+done)/(b+b))
      ww=-sqrt((b-done)/(b+b))
      goto 6
19    w=fq*sqrt((b+done)/(b+b+4.0d0))
      ww=-fq*sqrt((b+three)/(b+b+4.0d0))
      goto 6
24    w=-fq*sqrt(vtwo)
      ww=fq*sqrt(b/(b+b+4.0d0))
      goto 6

60    w=sqrt(vtwo)
      ww=sqrt((b+two)/(b+b))
      goto 6
18    ww=-done
      goto 6
28    ww=sqrt((b+three)/(b+two))
      goto 6
51    ww=-fq
      goto 6
56    ww=fq*sqrt((b-done)/b)
6     return
      end
c
      subroutine segmidd10(w,ww,ind1,jbr)
c   segmid d10(d^r&l)
      implicit real*8 (a-h,o-z)
      data dzero,done/0.d0,1.d0/
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      w=dzero
      ww=dzero
      goto(29,61),ind1
61    w=fq
      goto 100
29    w=fq
100   return
      end

      subroutine segmidb2(w,ww,ind1,jbr)
c   segmid b2(b^r)
      implicit real*8 (a-h,o-z)
      data dzero,done,two/0.d0,1.d0,2.d0/vtwo/0.5d0/
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      w=dzero
      ww=dzero
      goto(5,15,37,41,46,47,73,78),ind1
37    w=-sqrt(b/(b+b+two))
      ww=sqrt((b+two)/(b+b+two))
      goto 2
41    w=fq*sqrt((b+two)/(b+b+two))
      ww=fq*sqrt(b/(b+b+two))
      goto 2
46    w=fq*sqrt(vtwo)
      ww=fq*sqrt((b+two)/(b+b))
      goto 2
47    w=sqrt(vtwo)
      ww=-sqrt(b/(b+b+4.0d0))
      goto 2
5     ww=done
      goto 2
73    ww=fq
      goto 2
78    ww=fq*sqrt((b+done)/b)
      goto 2
15    ww=-sqrt((b+done)/(b+two))
2     return
      end
c
      subroutine segmidb1(w,ww,ind1,jbr)
c   segmid b1(b^l)
      implicit real*8 (a-h,o-z)
      data dzero,done,two/0.d0,1.d0,2.d0/vtwo/0.5d0/
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      w=dzero
      ww=dzero
      goto(3,8,34,35,40,44,66,76),ind1
34    w=-sqrt(vtwo)
      ww=sqrt((b+two)/(b+b))
      goto 4
35    w=-fq*sqrt(vtwo)
      ww=-fq*sqrt(b/(b+b+4.0d0))
      goto 4
40    w=-fq*sqrt(b/(b+b+two))
      ww=-fq*sqrt((b+two)/(b+b+two))
      goto 4
44    w=sqrt((b+two)/(b+b+two))
      ww=-sqrt(b/(b+b+two))
      goto 4
66    ww=sqrt((b+done)/b)
      goto 4
3     ww=-fq*sqrt((b+done)/(b+two))
      goto 4
8     ww=-fq
      goto 4
76    ww=-done
4     return
      end

      subroutine stermh(isq,w,ww,ind1,jbr)
      implicit real*8 (a-h,o-z)
      data dzero,done,two,three/0.d0,1.d0,2.d0,3.d0/vtwo/0.5d0/
      isq=0
      w=dzero
      ww=dzero
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      goto(34,35,36,38,39,40,43,44,48),ind1
c     case a&l
c     case a&r
34    w=fq
      goto 1
35    w=done
      goto 1
40    w=sqrt(b/(b+done))
      goto 1
44    w=-fq*sqrt((b+two)/(b+done))
c      if(abs(w).gt.1.e-13) then
1     isq=1
      ww=w
      goto 100
c     case d&r&l
38    w=-fq*sqrt(vtwo)
      ww=-fq*sqrt((b-done)/(b+b+two))
      goto 2
43    w=-fq*sqrt(vtwo)
      ww=fq*sqrt((b+three)/(b+b+two))
      goto 2
48    w=fq*sqrt(two)
      goto 2
39    ww=-sqrt(b/(b+done))
c      if(dldr.eq.2101) ww=(b+two)/(b+done)
2     isq=2
      goto 100
c     case d&l&l
c     case d&r&r
36    w=-sqrt(two)
      isq=3
100   return
      end
c

      subroutine stmh(isq,w,ww,mw,ind1,jbr)
      implicit real*8    (a-h,o-z)
      data dzero,done,two,three/0.0d0,1.0d0,2.0d0,3.0d0/vtwo/0.5d0/
      mw=0
      isq=0
      w=dzero
      ww=dzero
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      goto(38,43,48),ind1
38    w=-fq*sqrt(vtwo)
      ww=-fq*sqrt((b-done)/(b+b+two))
      goto 2
43    w=-fq*sqrt(vtwo)
      ww=fq*sqrt((b+three)/(b+b+two))
      goto 2
48    w=fq*sqrt(two)
2     if(abs(ww).gt.1.d-13) mw=2
      if(abs(w).gt.1.d-13) mw=mw+1
      sq=401
      goto 100
100   return
      end
c
      subroutine smidc2(isq,w,ww,mw,ind1,jbr)
      implicit real*8 (a-h,o-z)
      data dzero,done,two,three/0.0d0,1.0d0,2.0d0,3.0d0/
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      w=dzero
      ww=dzero
      isq=0
      mw=0
      goto(33,38,43,48),ind1
c     write(6,*) 'this is case c2'
33    w=done
      ww=done
      goto 2
38    w=-done
      ww=-sqrt((b-done)*(b+two)/(b*b+b))
      goto 2
43    w=-done
      ww=-sqrt(b*(b+three)/(b*b+three*b+two))
      goto 2
48    w=done
      ww=done
      goto 2
2     sq=302
      return
      end

      subroutine stml(isq,w,ww,mw,ind1,jbr)
      implicit real*8 (a-h,o-z)
      data dzero,done,two/0.0d0,1.0d0,2.0d0/vtwo/0.5d0/
      mw=0
      isq=0
      w=dzero
      ww=dzero
c     calculate w,ww
      b=dble(jbr)
      if(mod(jbr,2).eq.0) fq=done
      if(mod(jbr,2).ne.0) fq=-done
      jf=1
      goto(38,43,48),ind1
c     case d^r^l
38    w=-fq*sqrt(vtwo)
      ww=fq*sqrt((b+two)/(b*two))
      goto 4
43    w=-fq*sqrt(vtwo)
      ww=-fq*sqrt(b/(b+b+4.0d0))
      goto 4
48    w=-fq*sqrt(two)
4     if(abs(ww).gt.1.d-13) mw=2
      if(abs(w).gt.1.d-13) mw=mw+1
      isq=402
      goto 100
100   return
      end

      subroutine neoc(kcoe,nocc,tcoe)
      real*8 tcoe
      nocc=1
      tcoe=kcoe
      if(kcoe.eq.0)   nocc=0
      if(kcoe.eq.100) tcoe=0.d0
      if(kcoe.eq.200) then
        nocc=2
        tcoe=-0.5d0
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
FUNCTION fmm_second()

   USE fmm_global_paras
   IMPLICIT NONE
   REAL(REALK) :: fmm_second
   INTEGER :: count, count_rate, count_max, tmp
   INTEGER(INTK), SAVE :: parity=0
   INTEGER(INTK), SAVE :: last_count=0

! VV: order changed due to a bug in NAG compiler.
   CALL SYSTEM_CLOCK(count,count_rate,count_max)

   IF (parity == 0) parity = 1  ! first call to fmm_second()
   parity = -parity
   ! must check if count has "cycled"
   tmp = count
   IF ( parity == 1 ) THEN  ! second of a paired call to fmm_second()
      IF ( count < last_count ) tmp = count + (count_max - last_count)
   END IF
   fmm_second = REAL(tmp,REALK)/REAL(count_rate,REALK)
   last_count = count

END FUNCTION fmm_second

!-------------------------------------------------------------------------------

SUBROUTINE TIMTXT(TEXTIN,TIMUSD,IUNIT)

! TIMTXT based on TIMER by TUH //900709-hjaaj

   USE fmm_global_paras
   IMPLICIT NONE
   CHARACTER(LEN=*) :: TEXTIN
   CHARACTER :: AHOUR*6, ASEC*8, AMIN*8
   REAL(REALK) :: TIMUSD
   INTEGER :: ISECND, IUNIT, IHOURS, MINUTE
   CHARACTER(LEN=45) :: TEXT

   TEXT = TEXTIN

   ISECND = INT(TIMUSD)
   IF (ISECND .GE. 60) THEN
      MINUTE = ISECND/60
      IHOURS = MINUTE/60
      MINUTE = MINUTE - 60*IHOURS
      ISECND = ISECND - 3600*IHOURS - 60*MINUTE
      IF (IHOURS .EQ. 1) THEN
         AHOUR = ' hour '
      ELSE
         AHOUR = ' hours'
      END IF
      IF (MINUTE .EQ. 1) THEN
         AMIN = ' minute '
      ELSE
         AMIN = ' minutes'
      END IF
      IF (ISECND .EQ. 1) THEN
         ASEC = ' second '
      ELSE
         ASEC = ' seconds'
      END IF
      IF (IHOURS .GT. 0) THEN
         WRITE(IUNIT,100) TEXT, IHOURS, AHOUR, MINUTE, AMIN, ISECND, ASEC
      ELSE
         WRITE(IUNIT,200) TEXT, MINUTE, AMIN, ISECND, ASEC
      END IF
   ELSE
      WRITE(IUNIT,300) TEXT,TIMUSD
   END IF
100 FORMAT(1X,A,I4,A,I3,A,I3,A)
200 FORMAT(1X,A,     I3,A,I3,A)
300 FORMAT(1X,A,F7.2,' seconds')
   RETURN
END SUBROUTINE TIMTXT

!-------------------------------------------------------------------------------

SUBROUTINE fmm_quit(msg)
   CHARACTER(LEN=*) msg
   write(6,*) msg
   WRITE(6,*) ">>> FATAL ERROR"
   CALL Abend()
END SUBROUTINE fmm_quit

!------------------------------------------------------------------------------

SUBROUTINE fmm_matrix_norm(label,matrix,ndim)

   USE fmm_global_paras

   IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(IN) :: label
   INTEGER,      INTENT(IN) :: ndim
   REAL(REALK),  INTENT(IN) :: matrix(ndim)

   INTEGER :: i
   REAL(REALK) :: norm

   norm = 0d0
   DO i = 1, ndim
      norm = norm + matrix(i)*matrix(i)
   END DO
   WRITE(6,*) 'o fmm_matrix_norm: ', label,' = ', SQRT(norm)

END SUBROUTINE fmm_matrix_norm

!------------------------------------------------------------------------------

MODULE fmm_utils

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_distance_between_lines

CONTAINS

!-------------------------------------------------------------------------------

   FUNCTION fmm_cross_product(a,b)

      IMPLICIT NONE
      REAL(REALK), INTENT(IN)  :: a(3), b(3)
      REAL(REALK) :: fmm_cross_product(3)

      fmm_cross_product(1) =    a(2)*b(3) - a(3)*b(2)
      fmm_cross_product(2) = -( a(1)*b(3) - a(3)*b(1) )
      fmm_cross_product(3) =    a(1)*b(2) - a(2)*b(1)

   END FUNCTION fmm_cross_product

!-------------------------------------------------------------------------------

   FUNCTION fmm_distance_between_lines(p,q,ep,eq)

      IMPLICIT NONE
      REAL(REALK), INTENT(IN)  :: p(3), q(3), ep(3), eq(3)
      REAL(REALK) :: fmm_distance_between_lines

      REAL(REALK) :: d1, d2, n(3)

      n = fmm_cross_product(ep,eq)

      d1 = DOT_PRODUCT(p,n)
      d2 = DOT_PRODUCT(q,n)

      fmm_distance_between_lines = ABS(d1 - d2)

   END FUNCTION fmm_distance_between_lines

!-------------------------------------------------------------------------------

END MODULE fmm_utils

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine biksmain_cvb(aikcof,bikcof,nel,nalf,ndet,ifns,kbasis,share,iprint)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nel, nalf, ndet, ifns, kbasis, iprint
real(kind=wp), intent(inout) :: aikcof(ndet,ifns)
real(kind=wp), intent(out) :: bikcof(ndet,ifns)
logical(kind=iwp) :: share
integer(kind=iwp) :: nbet, nswpdim

if ((nel == 0) .and. (kbasis /= 6)) then
  bikcof(1,1) = One
  aikcof(1,1) = One
  return
end if

nbet = nel-nalf
nswpdim = 2**nbet

call rumer_cvb(bikcof,nel,nalf,nbet,ndet,ifns,kbasis,iprint,nswpdim)

if ((kbasis == 1) .or. (kbasis == 5)) call kotani_cvb(bikcof,ndet,ifns)

if (kbasis == 5) call projspn_cvb(bikcof,nel,nalf,nbet,ndet,ifns)

if (kbasis == 2) call serber_cvb(bikcof,nel,nalf,nbet,ndet,ifns)

call aikcof_cvb(aikcof,bikcof,ndet,ifns,kbasis,share)

return

end subroutine biksmain_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Marcus Johansson                                 *
************************************************************************
      Subroutine fmsym_create_context(ctx)
      Implicit Real*8 (a-h,o-z)
      Integer ret
*     INT cmsym_create_context(msym_context *pctx, int *err)
      call cmsym_create_context(ctx,ret)
      if (ret.ne.0) then
         Call WarningMessage(2,'Failed to create symmetry context')
         Call Abend()
      end if
      Return
      End

      Subroutine fmsym_set_elements(ctx)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "WrkSpc.fh"
      Character*2 Element(MxAtom)
      Call Get_nAtoms_All(nAtoms)
      Call Allocate_Work(ipCoord,3*nAtoms)
      Call Get_Coord_All(Work(ipCoord),nAtoms)
      Call Get_Name_All(Element)
      Call fmsym_set_ele_orb(ctx,nAtoms,Element,Work(ipCoord))
      Call Free_Work(ipCoord)
      Return
      End

      Subroutine fmsym_release_context(ctx)
      Integer ret
*     INT cmsym_release_context(msym_context *pctx, int*err)
      call cmsym_release_context(ctx,ret)
      Return
      End

      Subroutine fmsym_set_ele_orb(ctx,nAtoms,Element,Coord)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "periodic_table.fh"
#include "WrkSpc.fh"
#include "constants2.fh"
      Character*2 Element(nAtoms)
      Real*8 Coord(3,nAtoms)
      Character*(LENIN) AtomLabel(nAtoms)
      Integer basis_ids(4*mxBas)
      Dimension nBas(mxSym)
      Integer ret

      Call Get_LblCnt_All(AtomLabel)
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)

       if (nSym.ne.1) then
         Call WarningMessage(2,'MSYM can only be used with group c1')
*        INT cmsym_release_context(msym_context *pctx, int*err)
         call cmsym_release_context(ctx, ret)
         Call Abend()
      end if

      nCMO=0
      nMO=0
      do iSym=1, nSym
         nMO = nMO + nBas(iSym)
         nCMO = nCMO + nBas(iSym)**2
      end do

      Call Get_iArray('Basis IDs',basis_ids,(4*nMO))
*     INT cmsym_set_elements(msym_context *pctx, INT *pel, INT *puel, char *uelement, double xyz[][3], INT *paol, INT basis_ids[][4], int *err)
      call cmsym_set_elements(ctx,nAtoms,(LENIN),AtomLabel,Coord,
     & nMO, basis_ids, ret)
      call xflush(6)
      if (ret.ne.0) then
         Call WarningMessage(2,'Failed to set elements')
*        INT cmsym_release_context(msym_context *pctx, int*err)
         call cmsym_release_context(ctx, ret)
         Call Abend()
      end if

      return
      if (.false.) Call Unused_character(Element)
      End

      Subroutine fmsym_find_symmetry(ctx)
      Implicit Real*8 (a-h,o-z)
      Character*6 PGName
      Integer ret
*     INT cmsym_find_symmetry(msym_context *pctx, char pgname[6], int *err)
      Call cmsym_find_symmetry(ctx,PGName,ret)
      if (ret.ne.0) then
         Call WarningMessage(2,'Failed to find symmetry')
*        INT cmsym_release_context(msym_context *pctx, int*err)
         call cmsym_release_context(ctx, ret)
         Call Abend()
      end if

      Write (6,*) 'Found Point Group:'
      Write (6,*) PGName

      End

      Subroutine fmsym_symmetrize_molecule(ctx)
      Implicit Real*8 (a-h,o-z)
      Character*256 FN
      Integer ret
      Call PrgmTranslate('MSYMOUT',FN,lFN)
      FN = FN(1:lFN)
      FN(lFN+1:lFN+1)=Char(0)
*     INT cmsym_symmetrize_molecule(msym_context *pctx, char *outfile, INT *err)
      call cmsym_symmetrize_molecule(ctx, FN, ret)
      if (ret.ne.0) then
         Call WarningMessage(2,'Failed to symmetrize molecule')
*        INT cmsym_release_context(msym_context *pctx, int*err)
         call cmsym_release_context(ctx, ret)
         Call Abend()
      end if

      End

      Subroutine fmsym_generate_orbital_subspaces(ctx)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
#include "mh5.fh"
      integer fileid, dsetid
#endif
      Character*80 Title
      Character(len=8), allocatable :: irrep_strings(:)
      Integer ret
      Dimension nBas(mxSym)
      Dimension Dummy(1)

      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      nCMO=0
      nMO=0
      do iSym=1, nSym
         nMO = nMO + nBas(iSym)
         nCMO = nCMO + nBas(iSym)**2
      end do

      Call Allocate_Work(ipCAO,nCMO)
      Call Allocate_Work(ipOcc,nMO)
      Call Allocate_iWork(ipIrrIds,nMO)
      Call Allocate_iWork(ipIrrInd,nMO)
      call mma_allocate(irrep_strings, nMO)

*      INT cmsym_generate_orbital_subspaces(msym_context *pctx, INT *l, double c[*l][*l], INT irrep_ids[*l], INT irrep_ind[*l], INT *err)
      call cmsym_generate_orbital_subspaces(ctx,nMO,Work(ipCAO),
     &     iWork(ipIrrIds),iWork(ipIrrInd),nIrr,irrep_strings,ret)
      Write(6,*) 'Irrep indeces= '
      Write(6,'(5i3)') (iWork(ipIrrInd+k), k=0,nMO-1)
      Write(6,*) 'Irrep ids= '
      Write(6,'(5i3)') (iWork(ipIrrInd+k), k=0,nMO-1)

      if (ret.ne.0) then
         Call WarningMessage(2,'Failed to generate SALCs')
*        INT cmsym_release_context(msym_context *pctx, int*err)
         call cmsym_release_context(ctx, ret)
         Call Abend()
      end if

      Call FZero(Work(ipOcc),nMO)

      Title='Orbital Subspaces'
      LuOrb=50
      LuOrb=isfreeunit(LuOrb)
      Call WrVec('MSYMAORB',LuOrb,'CO',nSym,nBas,nBas,Work(ipCAO),
     &     Work(ipOcc),Dummy,iWork(ipIrrInd),Title)
#ifdef _HDF5_
      fileid = mh5_create_file('MSYMH5')
      call run2h5_molinfo(fileid)
      call one2h5_ovlmat(fileid, nsym, nbas)
      call one2h5_fckint(fileid, nsym, nbas)
      ! mocoef
      dsetid = mh5_create_dset_real(fileid,'MO_VECTORS', 1, [nCMO])
      call mh5_init_attr(dsetid, 'description',
     $        'Coefficients of the SALCs as produced by MSYM, '//
     $        'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')
      call mh5_put_dset(dsetid, Work(ipCAO))
      call mh5_close_dset(dsetid)
      ! mooc
      dsetid = mh5_create_dset_real(fileid,'MO_OCCUPATIONS', 1, [nMO])
      call mh5_init_attr(dsetid, 'description',
     $        'Dummy occupation numbers '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
      call mh5_put_dset(dsetid, Work(ipOcc))
      call mh5_close_dset(dsetid)
      ! moene
      dsetid = mh5_create_dset_real(fileid,'MO_ENERGIES', 1, [nMO])
      call mh5_init_attr(dsetid, 'description',
     $        'Dummy orbital energies '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
      call mh5_put_dset(dsetid, Work(ipOcc))
      call mh5_close_dset(dsetid)
      ! supsym
      dsetid = mh5_create_dset_int(fileid,
     $ 'SUPSYM_IRREP_IDS', 1, [nMO])
      call mh5_init_attr(dsetid, 'description',
     $        'Super-symmetry ids as produced by MSYM, '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
      call mh5_put_dset(dsetid, iWork(ipIrrIds))
      call mh5_close_dset(dsetid)
      dsetid = mh5_create_dset_int(fileid,
     $ 'SUPSYM_IRREP_INDICES', 1, [nMO])
      call mh5_init_attr(dsetid, 'description',
     $        'Super-symmetry indices as produced by MSYM, '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
      call mh5_put_dset(dsetid, iWork(ipIrrInd))
      call mh5_close_dset(dsetid)
      ! irrep_labels
      dsetid = mh5_create_dset_str(fileid,
     $ 'SUPSYM_IRREP_LABELS', 1, [nIrr], 8)
      call mh5_init_attr(dsetid, 'description',
     $        'Super-symmetry labels as produced by MSYM, '//
     $        'arranged as array of size i=1,#supsym_irreps')
      call mh5_put_dset(dsetid, irrep_strings)
      call mh5_close_dset(dsetid)
      call mh5_close_file(fileid)
#endif

      call mma_deallocate(irrep_strings)
      Call Free_Work(ipCAO)
      Call Free_Work(ipOcc)
      Call Free_iWork(ipIrrInd)
      Call Free_iWork(ipIrrIds)

      End

      Subroutine fmsym_symmetrize_orbitals(ctx,CIO)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Integer ret
      Dimension CIO(*)
      Dimension nBas(mxSym)

      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)

      if (nSym.ne.1) then
         Call WarningMessage(2,'MSYM can only be used with group c1')
*        INT cmsym_release_context(msym_context *pctx, int*err)
         call cmsym_release_context(ctx, ret)
         Call Abend()
      end if

      nCMO=0
      nMO=0
      do iSym=1, nSym
         nMO = nMO + nBas(iSym)
         nCMO = nCMO + nBas(iSym)**2
      end do

*      INT cmsym_symmetrize_orbitals(msym_context *pctx, INT *l, double c[*l][*l], INT *err)
      call cmsym_symmetrize_orbitals(ctx,nMO,CIO,ret)
      if (ret.ne.0) then
         Call WarningMessage(2,'Failed to symmetrize orbitals')
*        INT cmsym_release_context(msym_context *pctx, int*err)
         call cmsym_release_context(ctx, ret)
         Call Abend()
      end if

      End

      Subroutine fmsym_symmetrize_orb_file(ctx,INPORB)

      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "constants2.fh"
      Integer ret
      Dimension nBas(mxSym),indType(7,mxSym)
      Character*80 Title
      Character INPORB*(*)


      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)

      if (nSym.ne.1) then
         Call WarningMessage(2,'MSYM can only be used with group c1')
*        INT cmsym_release_context(msym_context *pctx, int*err)
         call cmsym_release_context(ctx, ret)
         Call Abend()
      end if

      nCMO=0
      nMO=0
      do iSym=1, nSym
         nMO = nMO + nBas(iSym)
         nCMO = nCMO + nBas(iSym)**2
      end do

      Call Allocate_Work(ipCIO,nCMO)
      Call Allocate_Work(ipOcc,nMO)
      Call Allocate_Work(ipE,nMO)
      Call Allocate_iWork(iTIND,maxbfn)

      LuOrb=50
      LuOrb=isfreeunit(LuOrb)
      Call RdVec(INPORB,LuOrb,'COEI',nSym,nBas,nBas,Work(ipCIO),
     &     Work(ipOcc), Work(ipE) ,iWork(iTIND),Title,iWarn,iErr)

*     INT cmsym_symmetrize_orbitals(msym_context *pctx, INT *l, double c[*l][*l], INT *err)
      call cmsym_symmetrize_orbitals(ctx,nMO,Work(ipCIO),ret)

      if (ret.ne.0) then
         Call WarningMessage(2,'Failed to symmetrize orbitals')
*        INT cmsym_release_context(msym_context *pctx, int*err)
         call cmsym_release_context(ctx, ret)
         Call Abend()
      end if
      indType=0
      i=0
      do iSym=1,nSym
        do iBas=1,nBas(iSym)
          j = iWork(iTIND+i)
          indType(j,iSym) = indType(j,iSym)+1
          i = i+1
        end do
      end do
      Title='Symmetrized Orbitals'
      LuOrb=50
      LuOrb=isfreeunit(LuOrb)
      Call WrVec('MSYMMORB',LuOrb,'COEI',nSym,nBas,nBas,Work(ipCIO),
     &     Work(ipOcc),Work(ipE),indType,Title)

      Call Free_Work(ipCIO)
      Call Free_Work(ipOcc)
      Call Free_Work(ipE)
      Call Free_iWork(iTIND)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine init_motra()

use motra_global, only: Debug, FnHalf, FnInpOrb, FnJobIph, FnOneMO, FnTwoAO, FnTwoMO, iAutoCut, iOneOnly, iPrint, iRFpert, &
                        iVecTyp, LuHalf, LuInpOrb, LuJobIph, LuOneMO, LuTwoAO, LuTwoMO

implicit none

!----------------------------------------------------------------------*
! Define  file names and unit numbers.                                 *
!----------------------------------------------------------------------*
FnInpOrb = 'INPORB'
FnJobIph = 'JOBIPH'
FnTwoAO = 'ORDINT'
FnOneMO = 'TRAONE'
FnTwoMO = 'TRAINT'
FnHalf = 'TEMP1'
Debug = 0
iPrint = 0
iOneOnly = 0
iVecTyp = 2
iAutoCut = 0
iRFpert = 0
LuInpOrb = 10
LuJobIph = 15
LuTwoAO = 40
LuOneMO = 30
LuTwoMO = 50
LuHalf = 60

return

end subroutine init_motra

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Dissoc(xyz,nCntr,mCntr,rMss,Dist,B,lWrite,Label,dB,ldB)
!***********************************************************************
!                                                                      *
!     Object: To evaluate the B matrix elements of an internal         *
!             coordinate corresponding to a dissociation of two        *
!             parts of a molecule.                                     *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCntr, mCntr
real(kind=wp), intent(in) :: xyz(3,nCntr+mCntr), rMss(nCntr+mCntr)
real(kind=wp), intent(out) :: Dist, B(3,nCntr+mCntr)
logical(kind=iwp), intent(in) :: lWrite, ldB
character(len=8), intent(in) :: Label
real(kind=wp), intent(inout) :: dB(3,nCntr+mCntr,3,nCntr+mCntr)
integer(kind=iwp) :: i, iCntr, ix, j, jCntr, jx
real(kind=wp) :: dRdri, dRdrj, Fact, Facti, Factj, R(3,2), RM(2), Sgn, Signi, Signj

RM(:) = Zero
R(:,:) = Zero

#ifdef _DEBUGPRINT_
write(u6,*) ' nCntr,mCntr=',nCntr,mCntr
call RecPrt(' Masses',' ',rMss,nCntr+mCntr,1)
call RecPrt(' xyz',' ',xyz,3,nCntr+mCntr)
#endif
do iCntr=1,nCntr+mCntr
  i = 1
  if (iCntr > nCntr) i = 2
  ! Sum up mass of fragment
  RM(i) = RM(i)+rMss(iCntr)
  ! Compute center of mass of the fragment
  R(:,i) = R(:,i)+rMss(iCntr)*xyz(:,iCntr)
end do
#ifdef _DEBUGPRINT_
call RecPrt('RM',' ',RM,1,2)
#endif

! Evaluate center of mass of the two parts and the distance between

R(:,1) = R(:,1)/RM(1)
R(:,2) = R(:,2)/RM(2)
Dist = Zero
do ix=1,3
  Dist = Dist+(R(ix,1)-R(ix,2))**2
end do
#ifdef _DEBUGPRINT_
call RecPrt(' Center of mass of fragments',' ',R,3,2)
#endif

Dist = sqrt(Dist)

if (lWrite) write(u6,'(1X,A,A,2(F10.6,A))') Label,' : Dissociation distance=',Dist,'/bohr',Dist*Angstrom,'/angstrom'

! Compute the B-matrix

do iCntr=1,nCntr+mCntr
  if (iCntr <= nCntr) then
    Sgn = One
    i = 1
  else
    Sgn = -One
    i = 2
  end if
  do ix=1,3
    if (xyz(ix,iCntr) /= Zero) then
      Fact = Sgn*rMss(iCntr)/RM(i)
    else
      Fact = Zero
    end if
    B(ix,iCntr) = Fact*(R(ix,1)-R(ix,2))/Dist
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('B',' ',B,3,nCntr+mCntr)
#endif

! Compute the Cartesian derivative of the B-Matrix

if (ldB) then
  dB(:,:,:,:) = Zero
  do iCntr=1,nCntr+mCntr
    if (iCntr <= nCntr) then
      Signi = One
      i = 1
    else
      Signi = -One
      i = 2
    end if
    Facti = Signi*rMss(iCntr)/RM(i)

    do jCntr=1,nCntr+mCntr
      if (jCntr <= nCntr) then
        Signj = One
        j = 1
      else
        Signj = -One
        j = 2
      end if
      Factj = Signj*rMss(jCntr)/RM(j)

      do ix=1,3
        if (xyz(ix,iCntr) /= Zero) then
          dRdri = Facti
        else
          dRdri = Zero
        end if
        do jx=1,3
          if (xyz(jx,jCntr) /= Zero) then
            dRdrj = Factj
          else
            dRdrj = Zero
          end if

          if (ix == jx) then
            dB(ix,iCntr,jx,jCntr) = (dRdri*dRdrj-B(ix,iCntr)*B(jx,jCntr))/Dist
          else
            dB(ix,iCntr,jx,jCntr) = (-B(ix,iCntr)*B(jx,jCntr))/Dist
          end if
        end do
      end do

    end do
  end do
# ifdef _DEBUGPRINT_
  call RecPrt('dB',' ',dB,3*(nCntr+mCntr),3*(nCntr+mCntr))
# endif
end if

return

end subroutine Dissoc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine RdJobIph_td(CIVec)
!***********************************************************************
!                                                                      *
!     Read the contents of the JOBIPH file.                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use MCLR_Data, only: CMO, FnJob, G1t, G2sq, G2t, LuJob, nA, nNA
use input_mclr, only: ERASSCF, Headerjp, iPT2, iRoot, iSpin, iTOC, iTocIph, lRoots, nActEl, nAsh, nBas, nCOnf, nDel, nElec3, nFro, &
                      nHole1, nIsh, nOrb, nRoots, nRS1, nRS2, nRS3, nSym, ntAsh, ntASqr, ntATri, ntBas, ntBSqr, ntBTri, ntIsh, &
                      ntISqr, ntITri, State_Sym, TitleJP, Weight
use Molcas, only: LenIn, MxOrb, MxRoot, MxSym
use RASDim, only: MxIter, MxTit
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), allocatable, intent(out) :: CIVec(:,:)
integer(kind=iwp) :: i, iB, iDij, iDij2, iDisk, iDkl, iDkl2, iIJKL, iIJKL2, iS, iSym, Iter, jB, jS, kB, kRoots, kS, lB, Length, &
                     lS, nAct, nAct2, nAct4, nG1, nG2
real(kind=wp) :: Fact, Fact2, Factij, Factkl, PotNuc0, rdum(1), Temp
real(kind=wp), allocatable :: G2tta(:), G2tts(:), Tmp2(:)
character, allocatable :: TempTxt(:)

!----------------------------------------------------------------------*
!     Save the ROOT input parameter                                    *
!----------------------------------------------------------------------*
kRoots = lRoots
!----------------------------------------------------------------------*
!     Read the table of disk addresses                                 *
!----------------------------------------------------------------------*
call DaName(LuJob,FnJob)
iDisk = 0
call iDaFile(LuJob,2,iToc,iTOCIPH,iDisk)
!----------------------------------------------------------------------*
!     Read the the system description                                  *
!----------------------------------------------------------------------*
call mma_allocate(TempTxt,(LenIn+8)*MxOrb,Label='TempTxt')
iDisk = iToc(1)
call WR_RASSCF_Info(LuJob,2,iDisk,nActEl,iSpin,nSym,State_sym,nFro,nIsh,nAsh,nDel,nBas,MxSym,TempTxt,(LenIn+8)*mxorb,nConf, &
                    HeaderJP,144,TitleJP,4*18*mxTit,PotNuc0,lRoots,nRoots,iRoot,mxRoot,nRs1,nRs2,nRs3,nHole1,nElec3,iPt2,Weight)
call mma_deallocate(TempTxt)
!----------------------------------------------------------------------*
!     Overwrite the variable lroots if approriate                      *
!----------------------------------------------------------------------*
if (kRoots /= -1) then
  if (iPt2 /= 0) then
    write(u6,*)
    write(u6,*) ' *** Error in subroutine RDJOBIPH_TD ***'
    write(u6,*) ' Pt2 /= 0'
    write(u6,*)
  else if (kRoots > lRoots) then
    write(u6,*)
    write(u6,*) ' *** Error in subroutine RDJOBIPH_TD ***'
    write(u6,*) ' kRoots > lRoots'
    write(u6,*)
  end if
  lRoots = kRoots
  nRoots = 1
else if (nRoots /= 1) then
  write(u6,*)
  write(u6,*) ' *** Error in subroutine RDJOBIPH_TD ***'
  write(u6,*) ' nRoots /= 1'
  write(u6,*)
end if
!----------------------------------------------------------------------*
!     Precompute the total sum of variables and size of matrices       *
!----------------------------------------------------------------------*
ntIsh = sum(nIsh(1:nSym))
ntIsqr = sum(nIsh(1:nSym)**2)
ntAsh = sum(nAsh(1:nSym))
ntAsqr = sum(nAsh(1:nSym)**2)
ntBas = sum(nBas(1:nSym))
ntBsqr = sum(nBas(1:nSym)**2)
nOrb(1:nSym) = nBas(1:nSym)-nDel(1:nSym)
Length = sum(nBas(1:nSym)*nOrb(1:nSym))
ntItri = 0
ntAtri = 0
ntBtri = 0
nna = 0
do iSym=1,nSym
  ntItri = ntItri+nTri_Elem(nIsh(iSym))
  ntAtri = ntAtri+nTri_Elem(nAsh(iSym))
  ntBtri = ntBtri+nTri_Elem(nBas(iSym))
  nA(iSym) = nna
  nnA = nnA+nAsh(isym)
end do
!----------------------------------------------------------------------*
!     Load the orbitals used in the last macro iteration               *
!----------------------------------------------------------------------*

call mma_allocate(CMO,Length,Label='CMO')
call Get_dArray_chk('Last orbitals',CMO,Length)
!iDisk = iToc(9)
!if (IPT2 == 0) iDisk = iToc(2)
!call dDaFile(LuJob,2,CMO,ntBsqr,iDisk)
!jpCMO = 1
!do iSym=1,nSym
!  write(Line,'(A,i2.2)') 'MO coefficients, iSym = ',iSym
!  call RecPrt(Line,' ',CMO(jpCMO),nBas(iSym),nBas(iSym))
!  jpCMO = jpCMO+nBas(iSym)*nBas(iSym)
!end do
!----------------------------------------------------------------------*
!     Load the CI vector for the root lRoots                           *
!----------------------------------------------------------------------*
call mma_allocate(CIVec,nConf,1,Label='CIVec')
iDisk = iToc(4)
do i=1,lroots-1
  call dDaFile(LuJob,0,CIVec,nConf,iDisk)
end do
call dDaFile(LuJob,2,CIVec,nConf,iDisk)
if (.false.) call DVcPrt('CI coefficients',' ',CIVec,nConf)
!----------------------------------------------------------------------*
!     Load state energy                                                *
!----------------------------------------------------------------------*
call mma_allocate(Tmp2,mxRoot*mxIter,Label='Tmp2')
iDisk = iToc(6)
call dDaFile(LuJob,2,Tmp2,mxRoot*mxIter,iDisk)
ERASSCF(1) = Zero
do iter=0,mxIter-1
  Temp = Tmp2(iter*mxRoot+lRoots)
  if (Temp /= Zero) ERASSCF(1) = Temp
end do
call mma_deallocate(Tmp2)
!if (debug) write(u6,*) ' RASSCF energy =',ERASSCF(1)

nAct = 0
nAct2 = 0
nAct4 = 0
do iSym=1,nSym
  nAct = nAct+nAsh(iSym)
  nAct2 = nAct2+nAsh(iSym)**2
end do
do iS=1,nSym
  do jS=1,nSym
    do kS=1,nSym
      lS = Mul(Mul(is,js),ks)
      nAct4 = nAct4+nAsh(iS)*nAsh(jS)*nAsh(kS)*nAsh(lS)
    end do
  end do
end do
!----------------------------------
! One electron dens - triang stor.
!----------------------------------
nG1 = nTri_Elem(nAct)
call mma_allocate(G1t,nG1,Label='G1t')
G1t(:) = Zero

!---------------------------------------
! Triangular part of two electron dens,
! symmetric part
!---------------------------------------
nG2 = nTri_Elem(nG1)

call mma_allocate(G2sq,nAct**4,Label='G2sq')
call mma_allocate(G2t,nG2,Label='G2t')
call mma_allocate(G2tts,nG2,Label='G2tts')
call mma_allocate(G2tta,nG2,Label='G2tta')
iDisk = iToc(3)
do i=1,lroots-1
  call dDaFile(LuJob,0,rdum,nG1,iDisk)
  call dDaFile(LuJob,0,rdum,nG1,iDisk)
  call dDaFile(LuJob,0,rdum,nG2,iDisk)
  call dDaFile(LuJob,0,rdum,nG2,iDisk)
end do
call dDaFile(LuJob,2,G1t,nG1,iDisk)
call dDaFile(LuJob,0,rdum,nG1,iDisk)
call dDaFile(LuJob,2,G2tts,nG2,iDisk)
call dDaFile(LuJob,2,G2tta,nG2,iDisk)

do iB=1,nAct
  do jB=1,iB
    iDij = iTri(ib,jB)
    do kB=1,ib
      do lB=1,kB
        iDkl = iTri(kB,lB)
        fact = One
        if ((iDij >= iDkl) .and. (kB == lB)) fact = Two
        if ((iDij < iDkl) .and. (iB == jB)) fact = Two
        iijkl = iTri(iDij,iDkl)
        G2t(iijkl) = Fact*G2tts(iijkl)
      end do
    end do
  end do
end do

!----------------------------------------------
! Rectangular part of the two el dens,
! symmetric and asymmetric contributions added
! ipG2sq = ipG2tts + ipG2tta
!----------------------------------------------

do iB=1,nAct
  do jB=1,nact
    Factij = One
    if (ib > jb) Factij = -One
    iDij = iTri(ib,jB)
    iDij2 = ib+(jb-1)*NACT
    do kB=1,nact
      do lB=1,nact
        Factkl = One
        if (kb > lb) Factkl = -One
        iDkl = iTri(kB,lB)
        iDkl2 = kb+(lb-1)*NACT
        fact = One
        Fact2 = Factij*Factkl
        if ((iDij >= iDkl) .and. (kB == lB)) fact = Two
        if ((iDij < iDkl) .and. (iB == jB)) fact = Two
        iijkl = iTri(iDij,iDkl)
        iijkl2 = iDij2+nact**2*(iDkl2-1)

        G2sq(iijkl2) = Fact*(G2tts(iijkl)+G2tta(iijkl)*Fact2)
      end do
    end do
  end do
end do
call mma_deallocate(G2tts)
call mma_deallocate(G2tta)
!----------------------------------------------------------------------*
!     exit                                                             *
!----------------------------------------------------------------------*

end subroutine RdJobIph_td

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine fetch_neq(nneq,neq,nexch)
      Implicit None

      Integer, intent(inout) :: nneq
      Integer, intent(inout):: neq(nneq), nexch(nneq)
      !local variables:
      Integer       :: i, Input, LineNr
      Character(Len=72) :: LINE
      Logical       :: ab_initio_all
      Logical       :: DBG
      DBG=.false.
      If(DBG) Write(6,'(A)') 'Enter fetch_neq'
      If(DBG) Write(6,'(A,i3)') 'fetch_neq:  nneq=',nneq

      neq=0
      nexch=0
C=========== End of default settings====================================
      Input = 5
      Rewind(Input)
50    READ(Input,'(A72)',End=998) LINE
      If(DBG) write(6,'(A)') LINE
      Call NORMAL(LINE)
      If(LINE(1:5).ne.'&POLY') Go To 50
      LINENR=0

100   Call xFlush(6)
      READ(Input,'(A72)',End=998) LINE
      LINENR=LINENR+1
      Call NORMAL(LINE)
      If(LINE(1:1).eq.'*')   Go To 100
      If(LINE     .eq.' ')   Go To 100
      If(LINE(1:3).eq.'END') Go To 210 !End

      If (LINE(1:4).eq.'NNEQ') Then
!        number of non-equivalent centers; type of all centers
         READ(Input,*,ERR=997)  NNEQ, ab_initio_all
         If(DBG) Write(6,'(A,i4,A,L2)') 'NNEQ=', NNEQ,
     &                          ' ab_initio_all=',ab_initio_all
!        number of equivalent centers of type "i"
         READ(Input,*,ERR=997) (NEQ(i)  ,i=1,Nneq)
         If(DBG) Write(6,'(A,100I4)') 'NEQ(I)=',(NEQ(i),i=1,nneq)
!        number of RASSI wf for exchange
         READ(Input,*,ERR=997) (Nexch(i),i=1,Nneq)
         If(DBG) Write(6,'(A,100I4)') 'NExch(I)=',(NExch(i),i=1,nneq)
         Go To 210
      End If
      Go To 100

210   Continue



      GoTo 999 ! end

c-----------------------------------------------------------
997   continue
      Write(6,*)' READIN: Error reading "poly_aniso.input" '
      Write(6,*)' near line nr.',LINENR+1
      Go To 999
998   continue
      Write(6,*)' READIN: Unexpected End of input file.'
c-----------------------------------------------------------
999   Continue
      If(DBG) Write(6,'(A)') 'Exit fetch_neq'
      Return
      End Subroutine fetch_neq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Roland Lindh                                     *
************************************************************************
      SubRoutine Subblock(iNQ,x_NQ,y_NQ,z_NQ,InBox,
     &                    x_min_,x_max_,
     &                    y_min_,y_max_,
     &                    z_min_,z_max_,
     &                    list_p,nlist_p,
     &                    Grid,Weights,mGrid,
     &                    Process,
     &                    number_of_grid_points,
     &                    R_box_min,R_box_max,
     &                    ilist_p,xyz0,iAngular_Grid,nR_Eff)
************************************************************************
*                                                                      *
* Object:                                                              *
*                                                                      *
*     Author: Roland Lindh,                                            *
*             Dept of Chemical Physics,                                *
*             University of Lund, Sweden                               *
*             August 1999                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "setup.fh"
#include "nq_info.fh"
#include "grid_on_disk.fh"
#include "nsd.fh"
#include "debug.fh"
      Integer list_p(nlist_p)
      Real*8 Grid(3,mGrid), Weights(mGrid), xyz0(3,2)
      Logical Process,InBox, Check
      Integer iAngular_Grid(nR_Eff)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions                                              *
*                                                                      *
#include "nq_structure.fh"
      declare_ip_r_quad
      iROff(i,ir)=2*(ir-1)+i-1
      Check(i,j)=iAnd(i,2**(j-1)).ne.0
      x_a(i,iSet)=Work(Info_Ang(3,iSet)+(i-1)*4  )
      y_a(i,iSet)=Work(Info_Ang(3,iSet)+(i-1)*4+1)
      z_a(i,iSet)=Work(Info_Ang(3,iSet)+(i-1)*4+2)
      w_a(i,iSet)=Work(Info_Ang(3,iSet)+(i-1)*4+3)
*                                                                      *
************************************************************************
*                                                                      *
      nGrid=(9*mGrid)/10
      iStrt=number_of_grid_points+1
*                                                                      *
************************************************************************
*                                                                      *
*---- Start loop over the atomic grid
*
      ip_iRx=ip_of_iWork_d(Work(ip_R_Quad(iNQ)))
      ip_Rx=iWork(ip_iRx)
#ifdef _DEBUGPRINT_
      If (Debug) Then
         Write (6,*) 'ip_Rx=',ip_Rx
         Write (6,*) ' x_NQ=',x_NQ
         Write (6,*) ' y_NQ=',y_NQ
         Write (6,*) ' z_NQ=',z_NQ
         Write (6,*) ' Process=',Process
         Write (6,*) ' number_of_grid_points=',number_of_grid_points
         Write (6,*) 'x:', x_min_,x_max_
         Write (6,*) 'y:', y_min_,y_max_
         Write (6,*) 'z:', z_min_,z_max_
         Write (6,*)
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
      iStart_R= nR_Eff
      iEnd_R=1
c     Write (*,*)
c     Write (*,*) 'Start range:',iEnd_R, iStart_R
      If (.Not.Check(iOpt_Angular,2)) Then
c        Write (*,*) 'Find R subrange!'
*
*------- Compute valid subrange for R
*
         iR_End = iEnd_R
         Do iR = iEnd_R, iStart_R
            R_Value = Work(ip_Rx+iROff(1,iR))
            If (R_Value.le.R_box_Min) Then
               iR_End = iR
            Else
               Go To 8888
            End If
         End Do
 8888    Continue
*
         iR_Start = iStart_R
         Do iR = iStart_R, iR_End, -1
            R_Value = Work(ip_Rx+iROff(1,iR))
            If (R_Value.ge.R_Box_Max) Then
               iR_Start = iR
            Else
               Go To 8889
            End If
         End Do
 8889    Continue
*
      Else
c        Write (*,*) 'Do whole R range!'
*
*------- Scan the whole range
*
         iR_Start=iStart_R
         iR_End  =iEnd_R
*
      End If
*
*---- Reset iStart_R and iEnd_R, these are not to be modified again!
*
      iStart_R=iR_Start
      iEnd_R  =iR_End
      iSet=-1
c     Write (*,*) 'Actual range:',iEnd_R, iStart_R
*                                                                      *
************************************************************************
*                                                                      *
*     Outer loop over angular grids
*
 999  Continue
*                                                                      *
************************************************************************
*                                                                      *
*        Determine a range (iStart_R,iEnd_R) where we will use a
*        specific angular grid. As we get closer to the nuclei we will
*        reduce the order of the angular grid.
*
*
*------- Start loop at the outermost point and iterate towards the
*        nuclei.
*
         iR_End=iR_Start+1
         Do iR = iR_Start, iEnd_R, -1
            kSet = iAngular_Grid(iR)
*
*---------- Save new iSet for the first point of this
*           subrange.
*
            If (iR.eq.iR_Start) iSet  = kSet
*
*---------- Branch out if we hit on a range where we can reduce the
*           angular grid further.
*
            If (kSet.ne.iSet) Go To 888
*
*---------- Update inner index
*
            iR_End = iR
         End Do
*
  888    Continue
*
*------ Branch out if subrange is outside the box
*
         R_Value_Min = Work(ip_Rx+iROff(1,iR_End))
         If (R_Value_Min.gt.R_box_Max) Go To 8887
         R_Value_Max = Work(ip_Rx+iROff(1,iR_Start))
         If (R_Value_Max.lt.R_box_Min) Go To 8887
*
c        Write (*,*) 'Selected range:',iR_End, iR_Start
c        Write (*,*) 'l_max=',Info_Ang(1,iSet)
*                                                                      *
************************************************************************
*                                                                      *
*---- Angular loop
*
      Do iPoint=1,Info_Ang(2,iSet)
#ifdef _DEBUGPRINT_
         If (Debug) Then
            Write (6,*) 'X,Y,Z*',x_a(iPoint,iSet),
     &                           y_a(iPoint,iSet),
     &                           z_a(iPoint,iSet)
         End If
#endif
*
         If (.Not.InBox.and..Not.Check(iOpt_Angular,2)) Then
c           Write (*,*) 'Select angular points!'
            If (x_a(iPoint,iset).lt.xyz0(1,1) .or.
     &          x_a(iPoint,iset).gt.xyz0(1,2) .or.
     &          y_a(iPoint,iset).lt.xyz0(2,1) .or.
     &          y_a(iPoint,iset).gt.xyz0(2,2) .or.
     &          z_a(iPoint,iset).lt.xyz0(3,1) .or.
     &          z_a(iPoint,iset).gt.xyz0(3,2) ) Go To 7777
         End If
*                                                                      *
************************************************************************
*                                                                      *
*------- Radial loop over the reduced range
*
         Do iR = iR_End,iR_Start
            Radius=Work(ip_Rx+iROff(1,iR))
*           In the atomic referential
            xpt=Radius*x_a(iPoint,iSet)
            ypt=Radius*y_a(iPoint,iSet)
            zpt=Radius*z_a(iPoint,iSet)
*           In the system referential
            x=xpt+x_NQ
            y=ypt+y_NQ
            z=zpt+z_NQ
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*) 'Radius=',Radius
               Write (6,*) ' x,y,z:',x,y,z
               Write (6,*) x_NQ, y_NQ, z_NQ
            End If
#endif
*
*---------- Check if the point is inside the box.
*           Points on the border of boxes are shared.
*
            If (
     &           (x.ge.x_min_).and.(x.le.x_max_) .and.
     &           (y.ge.y_min_).and.(y.le.y_max_) .and.
     &           (z.ge.z_min_).and.(z.le.z_max_)
     &         ) Then
*
*------------- For shared points modify the weight.
*
               Fact=One
               If (x.eq.x_min_) Fact=Fact*Half
               If (y.eq.y_min_) Fact=Fact*Half
               If (z.eq.z_min_) Fact=Fact*Half
               If (x.eq.x_max_) Fact=Fact*Half
               If (y.eq.y_max_) Fact=Fact*Half
               If (z.eq.z_max_) Fact=Fact*Half
#ifdef _DEBUGPRINT_
               If (Debug) Then
                  Write (6,*) x_a(iPoint,iSet),
     &                        y_a(iPoint,iSet),
     &                        z_a(iPoint,iSet)
                  Write (6,*) 'x:', xyz0(1,1),xyz0(1,2)
                  Write (6,*) 'y:', xyz0(2,1),xyz0(2,2)
                  Write (6,*) 'z:', xyz0(3,1),xyz0(3,2)
                  Write (6,*) ' Inside:',x,y,z
               End If
#endif
*
               number_of_grid_points=number_of_grid_points+1
*              Radial weight
               weight=Work(ip_Rx+iROff(2,iR))
*              Combine the radial and angular weight
               w_g=weight*w_a(iPoint,iSet)
               Grid(1,number_of_grid_points)= x
               Grid(2,number_of_grid_points)= y
               Grid(3,number_of_grid_points)= z
*              Compute the partitioning weight
               Weights(number_of_grid_points)=w_g*Fact
            End If
*                                                                      *
************************************************************************
*                                                                      *
*    The call of Do_Batch is done if the buffer is full :
*     (number_of_grid_points.gt.nGrid)
*                                                                      *
************************************************************************
*                                                                      *
         If (number_of_grid_points.gt.mGrid) Then
            Call WarningMessage(2,'Subblock: Buffer overflowed!;'//
     &                  'Try a larger buffer size!')
            Call Abend()
         End If
         If (number_of_grid_points.gt.nGrid) Then
*
*---------- Dump grid information to disk
            nBatch = nBatch + 1
            If (nBatch.gt.nBatch_Max) Then
               Call WarningMessage(2,'Subblock: nBatch.gt.nBatch_Max')
               Call Abend()
            End If
            iBatchInfo(1,nBatch)=iDisk_Grid
            iBatchInfo(2,nBatch)=number_of_grid_points
            iBatchInfo(3,nBatch)=iNQ
*
            Call dDaFile(Lu_Grid,1,Grid,3*number_of_grid_points,
     &                   iDisk_Grid)
*
*---------- Generate weights
*
            Call W(Grid(1,iStrt),ilist_p,Weights(iStrt),list_p,
     &             nList_p,number_of_grid_points-iStrt+1)
            Call dDaFile(Lu_Grid,1,Weights,number_of_grid_points,
     &                   iDisk_Grid)
*
            ntotgp=ntotgp+number_of_grid_points
C           Write (*,*) 'ntotgp=',ntotgp
            number_of_grid_points=0
            iStrt=number_of_grid_points+1
         End If
*
         End Do           ! iR, Radial loop
 7777    Continue
      End Do              ! iPoint
*                                                                      *
************************************************************************
*                                                                      *
 8887 Continue
      iR_Start=iR_End-1
      If (Angular_Prunning.eq.On.and.iR_End.ne.iEnd_R) Go To 999
*                                                                      *
************************************************************************
*                                                                      *
*---- Generate weights
*
*     Write (6,*) 'number_of_grid_points=',number_of_grid_points
*     Write (6,*) 'iStrt=',iStrt
      If (number_of_grid_points-iStrt+1.gt.0)
     &   Call W(Grid(1,iStrt),ilist_p,Weights(iStrt),list_p,
     &          nList_p,number_of_grid_points-iStrt+1)
*                                                                      *
************************************************************************
*                                                                      *
*---- Process batch if not processed yet.
*
      If (Process.and.number_of_grid_points.gt.0) Then
*
*------- Dump grid information to disk
         nBatch = nBatch + 1
         If (nBatch.gt.nBatch_Max) Then
            Call WarningMessage(2,'Subblock: nBatch.gt.nBatch_Max')
            Call Abend()
         End If
         iBatchInfo(1,nBatch)=iDisk_Grid
         iBatchInfo(2,nBatch)=number_of_grid_points
         iBatchInfo(3,nBatch)=iNQ
         Call dDaFile(Lu_Grid,1,Grid,3*number_of_grid_points,
     &                iDisk_Grid)
         Call dDaFile(Lu_Grid,1,Weights,number_of_grid_points,
     &                iDisk_Grid)
*
         ntotgp=ntotgp+number_of_grid_points
C        Write (*,*) 'ntotgp=',ntotgp
         number_of_grid_points=0
      End If
*                                                                      *
************************************************************************
*                                                                      *
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c ci diagonal elements
      subroutine diagonal_loop_wyb()  !  for norb_act<>0
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      nst=norb_all
      ndy=norb_ext
      do lr0=2,norb_all
        do lr=1,lr0-1
          vdint(lr,lr0)=voint(lr0,lr)
     :      -vdint(lr0,lr)-vdint(lr0,lr)   ! 520
!      write(6,'(2i4,3f14.8)')
!     :   lr,lr0,voint(lr0,lr),vdint(lr0,lr),vdint(lr,lr0)
        enddo
      enddo
c     write(6,*)'               ***** start h-diaelm *****'
      vector1(1:nci_dim)=vpotnuc
!      wl8 = hnil*(hnil-1)*vmd(lr,lr)*0.5d0+hnil*vo(lr,lr)   800

      ndimsum=0
      jpae=jv
      ipae=1
      jaedownwei=iseg_downwei(ipae)
      do jpad=1,mxnode
        iw_sta(jpad,ipae)=ndimsum
        if(nu_ad(jpad).eq.0) cycle
        call seg_drt()
        iwupwei=jpad_upwei(jpad)
        iw_downwei(jpad,ipae)=ndim
        ndimsum=ndimsum+ndim*jaedownwei*iwupwei
        if(ndim .eq. 0) cycle
        call diagonal_act_d()
        call diagonal_act_c()
      enddo
      do im=1,ng_sm
        jpae=jd(im)
        ipae=1+im
        if(nu_ae(ipae).eq.0) cycle
        jaedownwei=iseg_downwei(ipae)
        do jpad=1,mxnode
          iw_sta(jpad,ipae)=ndimsum
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          iwupwei=jpad_upwei(jpad)
          iw_downwei(jpad,ipae)=ndim
c       if(jpad.ge.26) then
c     write(6,*)
c     endif
          ndimsum=ndimsum+ndim*jaedownwei*iwupwei
          if(ndim .eq. 0) cycle
          call diagonal_act_d()
          call diagonal_act_c()
          ista=iw_sta(jpad,ipae)+1
        enddo
      enddo
      do im=1,ng_sm
        jpae=jt(im)
        ipae=9+im
        if(nu_ae(ipae).eq.0) cycle
        jaedownwei=iseg_downwei(ipae)
        do jpad=1,mxnode
          iw_sta(jpad,ipae)=ndimsum
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          iwupwei=jpad_upwei(jpad)
          iw_downwei(jpad,ipae)=ndim
          ndimsum=ndimsum+ndim*jaedownwei*iwupwei
          if(ndim .eq. 0) cycle
          call diagonal_act_d()
          call diagonal_act_c()
        enddo
      enddo
      do im=1,ng_sm
        jpae=js(im)
        ipae=17+im
        jaedownwei=iseg_downwei(ipae)
        if(nu_ae(ipae).eq.0) cycle
        do jpad=1,mxnode
          iw_sta(jpad,ipae)=ndimsum
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          iwupwei=jpad_upwei(jpad)
          iw_downwei(jpad,ipae)=ndim
          ndimsum=ndimsum+ndim*jaedownwei*iwupwei
          if(ndim .eq. 0) cycle
          call diagonal_act_d()
          call diagonal_act_c()
        enddo
      enddo
      call diagonal_dbl()
      call diagonal_ext()
      do ipae=1,25
        do jpad=1,mxnode
          if(iw_sta(jpad,ipae).eq.0) cycle
          nci_h0=iw_sta(jpad,ipae)
          goto 200
        enddo
      enddo
200   continue

      !do i=1,nci_dim
      !  write(6,"(i8,f18.8)") i,vector1(i)
      !enddo
      !stop 888

      return
      end

      subroutine diagonal_act_c()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      dimension ndr(max_innorb)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      real*8, allocatable :: te(:), tee(:)
      integer, allocatable :: jpe(:), jee(:), jwe(:)
c     write(6,*)'               ***** start h-diaelm *****'
c      write(6,*)  jpad,jpae
      allocate(te(maxpl),tee(maxpl),jpe(maxpl),jee(maxpl),jwe(maxpl))
      ndr=0
      if(norb_act.eq.0) then
        mh=1
        th(1)=1.d0
        thh(1)=1.d0
        call diagonal_link_dae(mh)
        return
      endif
      mp=0
      nsum=0
c 520
      mh=0
      me=0
      jp=jpad
      jpb=jb(jp)
      do idl=1,4
        if(jj_sub(idl,jp).eq.0) cycle
        ind1=idl
c     link c"
        call smidc2(isq,w,ww,mw,ind1,jpb)
        mh=mh+1
        jeh(mh)=jj_sub(idl,jp)
        th(mh)=w
        thh(mh)=ww
        jph(mh)=0
        jwh(mh)=0
        if(idl.ne.1) jwh(mh)=iy(idl,jp)
c     complete a loop 'v'
        if(ind1.eq.1) cycle
        call stml(isq,w,ww,mw,ind1-1,jpb)
        vlop0=w
        vlop1=ww
        if(vlop0.eq.0.0d0.and.vlop1.eq.0.0d0) cycle
        mpe=jj_sub(idl,jp)
        iwa=iy(idl,jp)
        call diagonal_link_ad(mpe,iwa,vlop0,vlop1)
      enddo
c************************************************************
c      write(6,*)ad(i)
c************************************************************
      lr=norb_dz+1

40    continue
      if(lr.eq.norb_inn) then
        if(mh.ne.0) call diagonal_link_dae(mh)
        return
      end if
      lr=lr+1
      me=0
      do 160 m=1,mh
        je=jeh(m)
        jeb=jb(je)
c        jp=jph(m)
        do idl=1,4
          if(jj_sub(idl,je).eq.0) cycle
          ind1=idl
c          if(lr.eq.1) goto 20
c     link loop
          call smidc2(isq,w,ww,mw,ind1,jeb)
          me=me+1
          jwe(me)=jwh(m)
          if(idl.ne.1) jwe(me)=jwe(me)+iy(idl,je)
          jee(me)=jj_sub(idl,je)
          te(me)=th(m)*w
          tee(me)=thh(m)*ww
          jpe(me)=jph(m)
c   complete a loop 'v'
c20        continue
          if(ind1.eq.1) cycle
          call stml(isq,w,ww,mw,ind1-1,jeb)
          vlop0=th(m)*w
          vlop1=thh(m)*ww
          if(vlop0.eq.0.0d0.and.vlop1.eq.0.0d0) cycle
          mp=mp+1
          mpe=jj_sub(idl,je)
          iwa=jwh(m)
          if(idl.ne.1) iwa=iwa+iy(idl,je)
          call diagonal_link_ad(mpe,iwa,vlop0,vlop1)
c*****   520  ******************************************************
       enddo
160     continue
c***********************************************************
c      write(6,*) ad(i)
c************************************************************
        do m=1,me
          th(m)=te(m)
          te(m)=0.0d0
          thh(m)=tee(m)
          tee(m)=0.0d0
          jwh(m)=jwe(m)
          jwe(m)=0
          jeh(m)=jee(m)
          jee(m)=0
          jph(m)=jpe(m)
          jpe(m)=0
        enddo
        mh=me
        if(ndr(lr).lt.mh) ndr(lr)=mh
        goto 40
        do m=1,mh
          th(m)=0.0d0
          thh(m)=0.0d0
          jwh(m)=0
          jph(m)=0
          jeh(m)=0
        enddo
      return
      end

      subroutine diagonal_act_d()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      dimension ndr(max_innorb)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      real*8, allocatable :: te(:), tee(:)
      integer, allocatable :: jpe(:), jee(:), jwe(:)
c     write(6,*)'               ***** start h-diaelm *****'
c      write(6,*)   '   diagonal_act_d:',jpad,ipae
      allocate(te(maxpl),tee(maxpl),jpe(maxpl),jee(maxpl),jwe(maxpl))
      ndr=0
      nsum=0
      do lr=norb_dz+1,norb_inn
        jp0=no(lr-1)+1
        jp1=no(lr)
        lr0=lr
        do jp=jp0,jp1
          if(iy(1,jp).eq.0) cycle
c  800
          do idl=2,3
            mpe=jj_sub(idl,jp)
            if(mpe.eq.0) cycle
            wt = voint(lr0,lr0)    ! hnil=1
            jw=iy(idl,jp)
            call prodel(3,wt,jp,mpe,jw)
          enddo
          mpe=jj_sub(4,jp)
          if(mpe.ne.0) then
            wt = vdint(lr0,lr0)+2.d0*voint(lr0,lr0)     !idl=4 hnil=2
            jw=iy(4,jp)
            call prodel(3,wt,jp,mpe,jw)
          endif
        enddo
      enddo
c 520
      do 5 lr0=norb_dz+1,norb_inn
        mh=0
        me=0
        jp0=no(lr0-1)+1
        jp1=no(lr0)
        if(jp0.gt.jp1) jp0=jp1
        do 1 jp=jp0,jp1
          if(iy(1,jp).eq.0) cycle
c     start '^'
          do idl=1,4
            if(jj_sub(idl,jp).eq.0) cycle
            idr=idl
            jbl=jb(jp)
            ind1=idl-1
            if(ind1.eq.0) cycle
            call stmh(isq,w,ww,mw,ind1,jbl)
            mh=mh+1
            jeh(mh)=jj_sub(idl,jp)
            th(mh)=w
            thh(mh)=ww
            jph(mh)=jp
            jwh(mh)=0
            if(idl.ne.1) jwh(mh)=iy(idl,jp)
          enddo
1       continue
c************************************************************
c      write(6,*)ad(i)
c************************************************************
        lr=lr0
        if(ndr(lr).lt.mh) ndr(lr)=mh
40      if(lr.eq.norb_inn) then
        call diagonal_link_ae(mh)
        goto 5
        end if
        lr=lr+1
        me=0
        mp=0
        do 160 m=1,mh
          je=jeh(m)
          jeb=jb(je)
          jp=jph(m)
          do 17 idl=1,4
            if(jj_sub(idl,je).eq.0) goto 17
            ind1=idl
            if(lr.eq.1) goto 20
c     link loop
            call smidc2(isq,w,ww,mw,ind1,jeb)
            me=me+1
            jwe(me)=jwh(m)
            if(idl.ne.1) jwe(me)=jwe(me)+iy(idl,je)
            jee(me)=jj_sub(idl,je)
            te(me)=th(m)*w
            tee(me)=thh(m)*ww
            jpe(me)=jph(m)
c     complete a loop 'v'
20          if(ind1.eq.1) goto 17
            call stml(isq,w,ww,mw,ind1-1,jeb)
            vlop0=th(m)*w
            vlop1=thh(m)*ww
            if(vlop0.eq.0.0d0.and.vlop1.eq.0.0d0) goto 17
            mp=mp+1
            mpe=jj_sub(idl,je)
            iwa=jwh(m)
           if(idl.ne.1) iwa=iy(idl,je)+iwa
            wt=(vlop0-vlop1)*voint(lr,lr0)-2.d0*vlop0*vdint(lr,lr0)

            call prodel(3,wt,jp,mpe,iwa)
c*****   520  ******************************************************
17        continue
160     continue
c***********************************************************
c      write(6,*) ad(i)
c************************************************************
      do  m=1,me
          th(m)=te(m)
          te(m)=0.0d0
          thh(m)=tee(m)
          tee(m)=0.0d0
          jwh(m)=jwe(m)
          jwe(m)=0
          jeh(m)=jee(m)
          jee(m)=0
          jph(m)=jpe(m)
          jpe(m)=0
        enddo
        mh=me
        if(ndr(lr).lt.mh) ndr(lr)=mh
        goto 40
        do m=1,mh
          th(m)=0.0d0
          thh(m)=0.0d0
          jwh(m)=0
          jph(m)=0
          jeh(m)=0
        enddo
5     continue
      return
      end

      subroutine diagonal_link_ae(mh)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      data dsq2,vsq2/1.414213562373095d0,0.7071067811865d0/
!     dsq2=sqrt(2.d0)
!     vsq2=1/sqrt(2.d0)
!     dsq3vsq2=sqrt(3.d0)/sqrt(2.d0)
      if(ipae.eq.1) return   !could not  link
      ityae=(ipae-1)/8+1
      imae=mod(ipae-1,8)
      if(imae.eq.0) then
        ityae=ityae-1
        imae=8
      endif
      do 108 ip=1,mh
        iwe=0
        jp=jph(ip)
        lr0=kk(jp)
c      write(6,*)'ip,jpe,ind0',ip,jpe,ind0
        iwa=jwh(ip)
        vlop0=th(ip)
        vlop1=thh(ip)

c      wl5=(vlop0-vlop1)*vo(lr0,lr)-2.0d0*vlop0*vmd(lr0,lr)
c      wl8=vlop0*(vo(lr0,lr0)+(vlop0-1)*0.5*vmd(lr0,lr0))
c             two-index,one-loop 520
c   520=<a,j,k,a>:13,14(ss=3),38(tt=2),50(dd=1)
      goto(100,200,300),ityae
!link arc_d
!100     zz='  g50  '
100     wg50 = vlop0*vsq2
        wwg50=-vlop1*sqrt(3.d0)/sqrt(2.d0)
        do la=1,norb_ext
         ma=lsm(la)
          if(ma.ne.imae) cycle
          lra=norb_all-la+1
          iwe=iwe+1
          wld =(wg50-wwg50)*voint(lra,lr0)-2.d0*wg50*vdint(lra,lr0)
c       write(6,'(a11,2i3,i6,1x,5f10.4)')
c     :   zz,lr0,la,jwl,vo(lr0,la),vmd(lr0,la),wg50,wwg50,wl
          call prodel(5,wld,jp,iwa,iwe)
        enddo
        goto 108
!200     zz='  g38,39  '
200     wg38 =-vlop0*vsq2
        wwg38= vlop1
        do ima=1,ng_sm
          imb=mul_tab(ima,imae)
          if(imb.gt.ima) cycle
          do la=ibsm_ext(ima),iesm_ext(ima)
            lra=norb_all-la+1
            lbsta=ibsm_ext(imb)
            lbend=iesm_ext(imb)
            if(ima.eq.imb) lbend=la-1
            do lb=lbsta,lbend
              lrb=norb_all-lb+1
              iwe=iwe+1
              wlt =(wg38-wwg38)*(voint(lra,lr0)+voint(lrb,lr0))
     :          -2.d0*wg38*(vdint(lra,lr0)+vdint(lrb,lr0))
c        write(6,*)' 520 r0,la,lb '
c     :   ,vo(r0,la),vo(r0,lb),vmd(r0,la),vmd(r0,lb)

              call prodel(5,wlt,jp,iwa,iwe)
            enddo
         enddo
        enddo
        goto 108
!300     zz='  g14,15  '
300     wg14 =-vlop0*vsq2
        do ima=1,ng_sm
          imb=mul_tab(ima,imae)
          if(imb.gt.ima) cycle
          if(nlsm_ext(ima).eq.0) cycle
          if(nlsm_ext(imb).eq.0) cycle
         do la=ibsm_ext(ima),iesm_ext(ima)
            lra=norb_all-la+1
            lbsta=ibsm_ext(imb)
            lbend=iesm_ext(imb)
            if(ima.eq.imb) lbend=la-1
            do lb=lbsta,lbend
              lrb=norb_all-lb+1
              iwe=iwe+1
              wls =wg14*(voint(lra,lr0)+voint(lrb,lr0))
     :           -2.d0*wg14*(vdint(lra,lr0)+vdint(lrb,lr0))
              call prodel(5,wls,jp,iwa,iwe)
            enddo
         enddo
        enddo
        if(ipae.ne.18) goto 108
!       zz='  g13     '
        wg13 =-vlop0*dsq2
        do la=1,norb_ext
          lra=norb_all-la+1
          iwe=iwe+1
          wls =wg13*(voint(lra,lr0)-2.d0*vdint(lra,lr0))
          call prodel(5,wls,jp,iwa,iwe)
c        write(6,*)' g13 ',
c     :   vo(lr0,la),vo(lr0,lb),vmd(lr0,la),vmd(lr0,lb)
        enddo
108   continue
      mh=0
      return
      end

      subroutine diagonal_link_ad(mpe,iwa,vlop0,vlop1)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      data dsq2,vsq2/1.414213562373095d0, 0.7071067811865d0/
!     dsq2=sqrt(2.d0)
!     vsq2=1/sqrt(2.d0)
!     dsq3vsq2=sqrt(3.d0)/sqrt(2.d0)
      if(norb_dz.eq.0) return
      ityad=1
      if(jpad.ne.1) ityad=(jpad-1)/8+2
      imad=mod(jpad-1,8)
      if(imad.eq.0) then
        ityad=ityad-1
        imad=8
      endif
      lra=kk(mpe)-1
      goto(100,200,300,400,500,600),ityad
! v: d&r&l(3)
100   fqi=-fg
          vl0=fqi*dsq2*vlop0
          wlv=0.d0
c          do lr=norb_frz+1,norb_dz
           do lr=1,norb_dz
           wlv=wlv-vl0*vdint(lr,lra)
           enddo
          call prodel(4,wlv,mpe,0,iwa)
      return
!  jpad=jd(im)
200   fqi=-fg
      do lri=norb_frz+1,norb_dz
        imd=mul_tab(lsm_inn(lri),ns_sm)
        if(imd.ne.imad) cycle
        iwd=jud(lri)

! d: d&r&l(2)
        vl0=fqi*vsq2*vlop0
        vl1=pd*vlop1
        wld=-2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
! d: d&r&l(3)+c"(2)
        vl0=fqi*dsq2*vlop0
        do lr=1,lri-1
          wld=wld+vl0*(voint(lra,lr)-2.d0*vdint(lra,lr))
        enddo
! d: d&r&l(3)
        do lr=lri+1,norb_dz
          wld=wld+vl0*(voint(lra,lr)-2.d0*vdint(lra,lr))
        enddo

        call prodel(4,wld,mpe,iwd,iwa)
      enddo
      return
!  jpad=jt(im)
300   fqi=fg
      iwt=0
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iwt=just(lri,lrj)    !

! t: d&r&l(2)
! t: d&r&l(2)+c"(2)
          vl0=fqi*vsq2*vlop0
          vl1=pt*vlop1
          wlt=   -2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
          wlt=wlt-2.0d0*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
          vl0=fqi*dsq2*vlop0
          do lr=1,lri-1
! t: d&r&l(3)+c"(2)+c"(2)
            wlt=wlt+vl0*vdint(lr,lra)
          enddo
! t: d&r&l(3)+c"(2)
          do lr=lri+1,lrj-1
            wlt=wlt+vl0*vdint(lr,lra)
          enddo
! t: d&r&l(3)
          do lr=lrj+1,norb_dz
            wlt=wlt+vl0*vdint(lr,lra)
         enddo
          call prodel(4,wlt,mpe,iwt,iwa)
        enddo
      enddo
      return
400   fqi=fg
      iws=0
      do lri=norb_frz+1,norb_dz
        if(imad.eq.ns_sm)  then
          lrj=lri
          iws=just(lri,lri)
! s: d&r&l(3)+c"(0)
! s: d&r&l(3)
        vl0=fqi*dsq2*vlop0
          wls=0.d0
          do lr=1,norb_dz
            if(lr.eq.lri) cycle
            wls=wls+vl0*(voint(lra,lr)-2.d0*vdint(lra,lr))
          enddo
          call prodel(4,wls,mpe,iws,iwa)
          endif

        imi=mul_tab(lsm_inn(lri),ns_sm)
        lrjsta=lri+1
        do lrj=lrjsta,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iws=just(lri,lrj)
! s1: d&r&l(1)
          vl0=fqi*vsq2*vlop0
          vl1=ps1*vlop1
          wls=-2.0d0*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
! s4: d&r&l(2)+c"(1)
          vl0=fqi*vsq2*vlop0
          vl1=ps4*vlop1
          wls=wls-2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)

          vl0=fqi*dsq2*vlop0
! s: d&r&l(3)+c"(2)+c"(1)
          do lr=1,lri-1
            wls=wls+vl0*vdint(lr,lra)
          enddo
! s: d&r&l(3)+c"(1)
          do lr=lri+1,lrj-1
            wls=wls+vl0*vdint(lr,lra)
          enddo
! s: d&r&l(3)
          do lr=lrj+1,norb_dz
            wls=wls+vl0*vdint(lr,lra)
         enddo
          call prodel(4,wls,mpe,iws,iwa)
        enddo
      enddo

      if(jb_sys.eq.0) return      !any diffrence when jb_sys=1 and jb_sy
      fqi=fg
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
       !   iws=iws+1
          iws=just(lrj,lri)
! s1: d&r&l(1)-c"(2)
          vl0=fqi*vsq2*vlop0
          vl1=ps3*vlop1
          wls=-2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)

! s3: (11)d&r&l(2)
          vl0=fqi*vsq2*vlop0
          vl1=ps2*vlop1
          wls=wls-2.0d0*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)

          vl0=fqi*dsq2*vlop0
! s: d&r&l(3)+c"(1)+c"(2)
          do lr=1,lri-1
            wls=wls+vl0*vdint(lr,lra)
          enddo
! s: d&r&l(3)+c"(2)
          do lr=lri+1,lrj-1
            wls=wls+vl0*vdint(lr,lra)
          enddo
! s: d&r&l(3)
          do lr=lrj+1,norb_dz
            wls=wls+vl0*vdint(lr,lra)
           enddo
          call prodel(4,wls,mpe,iws,iwa)
        enddo
      enddo
      return

500   fqi=-fg
      iwd=0

      do lri=norb_frz+1,norb_dz
        imd=mul_tab(lsm_inn(lri),ns_sm)
        if(imd.ne.imad) cycle
        iwd=jud(lri)

! dd1: d&r&l(1)
        vl0=fqi*vsq2*vlop0
        vl1=pdd*vlop1
!        if(mpe.eq.43.and.iwd.eq.1.) then
!          write(6,*)
!          write(6,*) lri,lra,vl0,vl1,wld,vlop0,vlop1
!        endif

        wld=-2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)

        vl0=fqi*dsq2*vlop0

! d: d&r&l(3)+c"(1)
        do lr=1,lri-1
          wld=wld+vl0*vdint(lr,lra)
        enddo

! d: d&r&l(3)
        do lr=lri+1,norb_dz
          wld=wld+vl0*vdint(lr,lra)
        enddo

        call prodel(4,wld,mpe,iwd,iwa)
      enddo
      return

600   fqi=fg
      iwt=0
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iwt=just(lri,lrj)

! tt: d&r&l(1)
! tt: d&r&l(1)+c"(1)
          vl0=fqi*vsq2*vlop0
          vl1=ptt*vlop1
          wlt=   -2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
          wlt=wlt-2.0d0*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
          vl0=fqi*dsq2*vlop0
          do lr=1,lri-1
! t: d&r&l(3)+c"(1)+c"(1)
            wlt=wlt+vl0*vdint(lr,lra)
          enddo
! t: d&r&l(3)+c"(1)
          do lr=lri+1,lrj-1
            wlt=wlt+vl0*vdint(lr,lra)
          enddo
! t: d&r&l(3)
          do lr=lrj+1,norb_dz
            wlt=wlt+vl0*vdint(lr,lra)
         enddo

          call prodel(4,wlt,mpe,iwt,iwa)
        enddo
      enddo
      return
      end

      subroutine diagonal_link_dae(mh)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      data dsq2,vsq2/1.414213562373095d0, 0.7071067811865d0/
!     dsq2=sqrt(2.d0)
!     vsq2=1/sqrt(2.d0)
!     dsq3vsq2=sqrt(3.d0)/sqrt(2.d0)
      ityad=1
      if(jpad.ne.1) ityad= (jpad-1)/8+2
      imad=mod(jpad-1,8)
      if(imad.eq.0) then
        ityad=ityad-1
        imad=8
      endif
      do 108 ip=1,mh
        iwa=jwh(ip)
        vlop0=th(ip)
        vlop1=thh(ip)

      goto(100,200,300,400,500,600),ityad

!  jpad=1
100   if(abs(vlop0).lt.1e-30) goto 108
        fqi=fg
! v: d&r&l(3)
        lri=0
        lrj=0
        iwd=0
        vij0=0.d0
        vij1=0.d0
        vij2=0.d0
        vl0=fqi*dsq2*vlop0
        call diagonal_call_dae(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)
        goto 108
!  jpad=jd(im)
200   fqi=-fg
      lrj=0
      do lri=norb_frz+1,norb_dz
        imd=mul_tab(lsm_inn(lri),ns_sm)
        if(imd.ne.imad) cycle
        iwd=jud(lri)

! d: d&r&l(2)
        vij0=fqi*vsq2*vlop0
        vij1=pd*vlop1
        vij2=0.d0
! d: d&r&l(3)+c"(2)
! d: d&r&l(3)
        vl0=fqi*dsq2*vlop0

        call diagonal_call_dae(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)

      enddo
      goto 108
!  jpad=jt(im)
300   fqi=fg
      iwt=0
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iwt=just(lri,lrj)      !

! t: d&r&l(2)
! t: d&r&l(2)+c"(2)
          vij0=fqi*vsq2*vlop0
          vij1=pt*vlop1
          vij2=vij1
! t: d&r&l(3)+c"(2)+c"(2)
! t: d&r&l(3)+c"(2)
! t: d&r&l(3)
          vl0=fqi*dsq2*vlop0

          call diagonal_call_dae(lri,lrj,iwt,iwa,vij0,vij1,vij2,vl0)
        enddo
      enddo
      goto 108
400   fqi=fg
      iws=0
      do lri=norb_frz+1,norb_dz           !cc
        if(imad.eq.ns_sm) then
          lrj=lri
          iws=just(lri,lri)
          vij0=0.d0
          vij1=0.d0
          vij2=0.d0
! s: d&r&l(3)+c"(0)
! s: d&r&l(3)
          vl0=fqi*dsq2*vlop0
          call diagonal_call_dae(lri,lrj,iws,iwa,vij0,vij1,vij2,vl0)
        endif
        imi=mul_tab(lsm_inn(lri),ns_sm)
        lrjsta=lri+1
        do lrj=lrjsta,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iws=just(lri,lrj)
! s2: d&r&l(2)
! s4: d&r&l(2)+c"(1)
          vij0=fqi*vsq2*vlop0
          vij1=ps1*vlop1
          vij2=ps4*vlop1
! s: d&r&l(3)+c"(2)+c"(1)
! s: d&r&l(3)+c"(1)
! s: d&r&l(3)
          vl0=fqi*dsq2*vlop0
          call diagonal_call_dae(lri,lrj,iws,iwa,vij0,vij1,vij2,vl0)
        enddo
      enddo
      if(jb_sys.eq.0) goto 108
      fqi=fg
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        if(imad.eq.ns_sm) lrjsta=lri
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iws=just(lrj,lri)
! s1: d&r&l(1)
! s3: d&r&l(1)+c"(2)
          vij0=fqi*vsq2*vlop0
          vij1=ps2*vlop1
          vij2=ps3*vlop1
! s: d&r&l(3)+c"(1)+c"(2)
! s: d&r&l(3)+c"(2)
! s: d&r&l(3)
          vl0=fqi*dsq2*vlop0
          call diagonal_call_dae(lri,lrj,iws,iwa,vij0,vij1,vij2,vl0)
        enddo
      enddo
      goto 108
500   fqi=-fg
      lrj=0
      do lri=norb_frz+1,norb_dz
        imd=mul_tab(lsm_inn(lri),ns_sm)
        if(imd.ne.imad) cycle
        iwd=jud(lri)

! dd1: d&r&l(1)
        vij0=fqi*vsq2*vlop0
        vij1=pdd*vlop1
        vij2=0.d0
! d: d&r&l(3)+c"(1)
! d: d&r&l(3)
        vl0=fqi*dsq2*vlop0

        call diagonal_call_dae(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)

      enddo
      goto 108

600   fqi=fg               !aa
      iwt=0
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iwt=just(lri,lrj)

          vij0=fqi*vsq2*vlop0
! tt: d&r&l(1)
          vij1=ptt*vlop1
! tt: d&r&l(1)+c"(1)
          vij2=ptt*vlop1
! t: d&r&l(3)+c"(1)+c"(1)
! t: d&r&l(3)+c"(1)
! t: d&r&l(3)
          vl0=fqi*dsq2*vlop0
          call diagonal_call_dae(lri,lrj,iwt,iwa,vij0,vij1,vij2,vl0)
        enddo
      enddo

108   continue
      return
      end

      subroutine diagonal_call_dae(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      data dsq2,vsq2/1.414213562373095d0, 0.7071067811865d0 /
      data dsq3vsq2/1.224744871392d0/
!     dsq2=sqrt(2.d0)
!     vsq2=1/sqrt(2.d0)
!     dsq3vsq2=sqrt(3.d0)/sqrt(2.d0)
      if(norb_dz.eq.0) return
      if(ipae.eq.1) return   !could not  link
      ityae=(ipae-1)/8+1
      imae=mod(ipae-1,8)
      if(imae.eq.0) then
        ityae=ityae-1
        imae=8
      endif
      iwe=0
c   520=<a,j,k,a>:13,14(ss=3),38(tt=2),50(dd=1)
      goto(100,200,300),ityae
!link arc_d
!100     zz='  g50  '
100   do la=ibsm_ext(imae),iesm_ext(imae)
        lra=norb_all-la+1
        iwe=iwe+1
        vlop0=vl0*vsq2
        wl=0.d0
        do lr=1,norb_dz
          if(lr.eq.lri) cycle
          if(lr.eq.lrj) cycle
          wl =wl+vlop0*vdint(lr,lra)    !db space drl(33)- ext space -
        enddo
        if(lri.ge.lrj) then
          vlop0= vij0*vsq2
          vlop1=-vij1*dsq3vsq2
          wl=wl+(vlop0-vlop1)*voint(lra,lri)-2.d0*vlop0*vdint(lra,lri)
          vlop1=-vij2*dsq3vsq2
          wl=wl+(vlop0-vlop1)*voint(lra,lrj)-2.d0*vlop0*vdint(lra,lrj)
c       write(6,'(a11,2i3,i6,1x,5f10.4)')
c     :   zz,lr0,la,jwl,vo(lr0,la),vmd(lr0,la),wg50,wwg50,wl
        else
          vlop0= vij0*vsq2
          vlop1=-vij1*dsq3vsq2       !db space (22)drl(11)- ext space -g
          wl=wl+(vlop0-vlop1)*voint(lra,lrj)-2.d0*vlop0*vdint(lra,lrj)
          vlop1=-vij2*dsq3vsq2        !db space drl(22)c"(11)- ext space
          wl=wl+(vlop0-vlop1)*voint(lra,lri)-2.d0*vlop0*vdint(lra,lri)
        endif
        call prodel(6,wl,iwd,iwa,iwe)
      enddo
        goto 108
!200     zz='  g38,39  '
200   do ima=1,ng_sm
        imb=mul_tab(ima,imae)
        if(imb.gt.ima) cycle
        do la=ibsm_ext(ima),iesm_ext(ima)
          lra=norb_all-la+1
          lbsta=ibsm_ext(imb)
          lbend=iesm_ext(imb)
          if(ima.eq.imb) lbend=la-1
          do lb=lbsta,lbend
            lrb=norb_all-lb+1
            iwe=iwe+1
            volalb=0.d0
            vd2lalb=0.d0
            do lr=1,norb_dz
              if(lr.eq.lri) cycle
              if(lr.eq.lrj) cycle
              volalb=volalb+(voint(lra,lr)+voint(lrb,lr))
              vd2lalb=vd2lalb-2.d0*(vdint(lra,lr)+vdint(lrb,lr))
            enddo

            vlop0=-vl0*vsq2
            wl=vlop0*(volalb+vd2lalb)
            if(lri.ge.lrj) then
              vlop0=-vij0*vsq2
              vlop1=vij1
              wl=wl+(vlop0-vlop1)*(voint(lra,lri)+voint(lrb,lri))
     :          -2.d0*vlop0*(vdint(lra,lri)+vdint(lrb,lri))
              vlop1=vij2
              wl=wl+(vlop0-vlop1)*(voint(lra,lrj)+voint(lrb,lrj))
     :          -2.d0*vlop0*(vdint(lra,lrj)+vdint(lrb,lrj))
            else
              vlop0=-vij0*vsq2
              vlop1=vij1
              wl=wl+(vlop0-vlop1)*(voint(lra,lrj)+voint(lrb,lrj))
     :          -2.d0*vlop0*(vdint(lra,lrj)+vdint(lrb,lrj))
              vlop1=vij2
              wl=wl+(vlop0-vlop1)*(voint(lra,lri)+voint(lrb,lri))
     :          -2.d0*vlop0*(vdint(lra,lri)+vdint(lrb,lri))
            endif
c        write(6,*)' 520 r0,la,lb '
c     :   ,vo(r0,la),vo(r0,lb),vmd(r0,la),vmd(r0,lb)

            call prodel(6,wl,iwd,iwa,iwe)
          enddo
        enddo
      enddo
      goto 108
!300     zz='  g14,15  '
300   do ima=1,ng_sm
        imb=mul_tab(ima,imae)
        if(imb.gt.ima) cycle
        do la=ibsm_ext(ima),iesm_ext(ima)
          lra=norb_all-la+1
          lbsta=ibsm_ext(imb)
          lbend=iesm_ext(imb)
          if(ima.eq.imb) lbend=la-1
          do lb=lbsta,lbend
            lrb=norb_all-lb+1
            iwe=iwe+1
            volalb=0.d0
            vd2lalb=0.d0
            do lr=1,norb_dz
              if(lr.eq.lri) cycle
              if(lr.eq.lrj) cycle
              volalb=volalb+(voint(lra,lr)+voint(lrb,lr))
              vd2lalb=vd2lalb-2.d0*(vdint(lra,lr)+vdint(lrb,lr))
            enddo

            wg14 =-vl0*vsq2
            wl=wg14*(volalb+vd2lalb)

            if(jpad.eq.18.and.lri.eq.lrj) goto 301
            wg14 =-vij0*vsq2
            wl=wl+wg14*(voint(lra,lri)+voint(lrb,lri))
     :          -2.d0*wg14*(vdint(lra,lri)+vdint(lrb,lri))
            wl=wl+wg14*(voint(lra,lrj)+voint(lrb,lrj))
     :          -2.d0*wg14*(vdint(lra,lrj)+vdint(lrb,lrj))
c        write(6,*)' 520 r0,la,lb '
c     :   ,vo(r0,la),vo(r0,lb),vmd(r0,la),vmd(r0,lb)
301         call prodel(6,wl,iwd,iwa,iwe)
          enddo
        enddo
      enddo

      if(ipae.ne.18) return
!       zz='  g13     '
      do la=1,norb_ext
        lra=norb_all-la+1
        iwe=iwe+1
        vovdla=0.d0
        do lr=1,norb_dz
          if(lr.eq.lri) cycle
          if(lr.eq.lrj) cycle
          vovdla=vovdla+vdint(lr,lra)
        enddo

        wg13 =-vl0*dsq2
        wl=wg13*vovdla
        wg13 =-vij0*dsq2
        wl=wl+wg13*(vdint(lri,lra)+vdint(lrj,lra))

        call prodel(6,wl,iwd,iwa,iwe)
c        write(6,*)' g13 ',
c     :   vo(lr0,la),vo(lr0,lb),vmd(lr0,la),vmd(lr0,lb)
      enddo
108   continue
      return
      end

      subroutine diagonal_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      data dzero/0.d0/
      if(norb_dz.eq.0) return
      wt0=dzero
      do lr=1,norb_dz
        wt0=wt0+voint(lr,lr)+voint(lr,lr)+vdint(lr,lr)
      enddo
      do ipae=1,25
        if(nu_ae(ipae).eq.0) cycle
        iwdownv=iw_downwei(1,ipae)
        do iwa=0,iwdownv-1
c       zz=' doub_800_v'
          iwad=iwalk_ad(1,ipae,iwa,0)
          call prodel(1,wt0,0,ipae,iwad)
c         zz=' doub_800_s'
        enddo
      enddo
c       jps=js(1)
      do 100 lr0=norb_frz+1,norb_dz
        mr0=mul_tab(lsm_inn(lr0),ns_sm)
        iwd=jud(lr0)
! d_800
          jpad =1+mr0
          jpad1=jpad+24
          wld=wt0-voint(lr0,lr0)-vdint(lr0,lr0)
          wls=wld-voint(lr0,lr0)
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpad,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpad,ipae,iwa,iwd)
              call prodel(1,wld,0,ipae,iwad)
            enddo
          enddo

          if(jb_sys.gt.0) then
            do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpad1,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpad1,ipae,iwa,iwd)
              call prodel(1,wld,0,ipae,iwad)
            enddo
          enddo
        endif
! d_800
         jpad=17+ns_sm
          iwd=just(lr0,lr0)
          do ipae=1,25
          if(nu_ae(ipae).eq.0) cycle
          iwdownv=iw_downwei(jpad,ipae)
          do iwa=0,iwdownv-1
            iwad=iwalk_ad(jpad,ipae,iwa,iwd)
          call prodel(1,wls,0,ipae,iwad)
        enddo
        enddo

      if(lr0.eq.norb_dz) goto 100
           wld0=wld

      do 200 lr=lr0+1,norb_dz
        mr=mul_tab(mr0,lsm_inn(lr))
        jpat=9+mr
        jpas=17+mr
        jpat1=jpat+24
        iws=just(lr0,lr)
        iwt=iws            !
          wld=wld0-voint(lr,lr)-vdint(lr,lr)
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
            call prodel(1,wld,0,ipae,iwad)
          enddo
            if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
              do iwa=0,iwdownv-1
                iwad=iwalk_ad(jpat1,ipae,iwa,iwt)         !t1
              call prodel(1,wld,0,ipae,iwad)
            enddo
          endif
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
            call prodel(1,wld,0,ipae,iwad)
          enddo
            if(jb_sys.gt.0) then
            iws1=just(lr,lr0)
              do iwa=0,iwdownv-1
                iwad=iwalk_ad(jpas,ipae,iwa,iws1)
              call prodel(1,wld,0,ipae,iwad)
            enddo
          endif
        enddo
200     continue
100   continue
!     wl8 = 1/2*hnil*(hnil-1)*vmd(lr,lr)+hnil*voint(lr,lr)   800
!     wl5=(vlop0-vlop1)*vo(lr0,lr)-2*vlop0*vmd(lr0,lr)
!     wl5= vlop0*vmd(lr,lr0)   -vlop1*vo(lr0,lr)   2000.11.26
      wt0=dzero
      do lr0=2,norb_dz
        do lr=1,lr0-1
                        !    vlop0=-2 vlop1=0
          wt0=wt0-2.d0*vdint(lr,lr0)
        enddo
      enddo
      jpad=1
      iwd=0
      do ipae=1,25
        if(nu_ae(ipae).eq.0) cycle
        iwdownv=iw_downwei(jpad,ipae)
        do iwa=0,iwdownv-1
          iwad=iwalk_ad(jpad,ipae,iwa,iwd)
          call prodel(1,wt0,0,ipae,iwad)
          enddo
      enddo
      do 300 lrm=norb_frz+1,norb_dz
          mrm=mul_tab(lsm_inn(lrm),ns_sm)
          iws=just(lrm,lrm)
          iwd=jud(lrm)
          jpad=1+mrm
          jpad1=jpad+24
          jpas=17+ns_sm
! d_520
          wld=wt0
        do lr=1,lrm-1
          wld=wld+vdint(lr,lrm)
      enddo
        do lr0=lrm+1,norb_dz
          wld=wld+vdint(lrm,lr0)
        enddo
      wls=wld
      do lr=lrm+1,norb_dz
       wls=wls+vdint(lrm,lr)
      enddo
      do lr0=1,lrm-1
       wls=wls+vdint(lr0,lrm)
      enddo
      do ipae=1,25
        if(nu_ae(ipae).eq.0) cycle
        iwdownv=iw_downwei(jpad,ipae)
        do iwa=0,iwdownv-1
          iwad=iwalk_ad(jpad,ipae,iwa,iwd)
          call prodel(1,wld,0,ipae,iwad)
      enddo
        if(jb_sys.gt.0) then
        iwdownv=iw_downwei(jpad1,ipae)
        do iwa=0,iwdownv-1
          iwad=iwalk_ad(jpad1,ipae,iwa,iwd)
            call prodel(1,wld,0,ipae,iwad)
        enddo
      endif
! 520
        iwdownv=iw_downwei(jpas,ipae)
        do iwa=0,iwdownv-1
          iwad=iwalk_ad(jpas,ipae,iwa,iws)
          call prodel(1,wls,0,ipae,iwad)
      enddo
      enddo
300   continue
                                             ! 520
      do 400 lr0=norb_frz+1,norb_dz-1
        mr0=mul_tab(lsm_inn(lr0),ns_sm)
        do 401 lr=lr0+1,norb_dz
         mr=mul_tab(mr0,lsm_inn(lr))
         jpat=9+mr
         jpas=17+mr
          jpat1=jpat+24
         iws=just(lr0,lr)
         iwt=iws            !
            iws1=just(lr,lr0)
          if(jb_sys.eq.0) then
            wls=wt0+3.d0*(voint(lr,lr0)-vdint(lr,lr0))
           wlt=wt0+voint(lr,lr0)-3.d0*vdint(lr,lr0)
          endif
           !    2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
           !      vo(lr0,lr)+  vmd(lr0,lr)  w0=-1/2  w1=-3/2
           !    2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
           !    - vo(lr0,lr)+  vmd(lr0,lr)  w0=-1/2  w1=1/2
          if(jb_sys.gt.0) then
            db=jb_sys
           w1=-(db+3)/(2.d0*db+2)
            wls=wt0+(1.50d0-w1)*voint(lr,lr0)-3.d0*vdint(lr,lr0)
           wlt=wt0+voint(lr,lr0)-3.d0*vdint(lr,lr0)
           w1=-(db-1)/(2.d0*db+2)
           wls1=wt0+(1.50d0-w1)*voint(lr,lr0)-3.d0*vdint(lr,lr0)
            !    2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
            !    (-1/2-w1)*vo(lr0,lr)+vmd(lr0,lr)
           !  w0=-1/2    w1=-(db-1)/(2*db+2)
          endif
        !  if(jb_sys.gt.1) then
        !    wlt1=wt0+voint(lr,lr0)-3*vdint(lr,lr0)
            !     2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
            !      -vo(lr0,lr)+  vmd(lr0,lr)
        !  endif
          do lrg=1,lr0-1
            wls=wls+vdint(lrg,lr0)+vdint(lrg,lr)
            wlt=wlt+vdint(lrg,lr0)+vdint(lrg,lr)
            if(jb_sys.gt.0) then
              wls1=wls1+vdint(lrg,lr0)+vdint(lrg,lr)
            endif
          !  if(jb_sys.gt.1) then
            !    wlt1=wlt1+vdint(lrg,lr0)+vdint(lrg,lr)
          !  endif
           !    2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
           !    - vo(lr0,lr)+2*vmd(lr0,lr)  w0=-1 w1=0
          enddo
          do lrg=lr0+1,lr-1
            wls=wls+vdint(lr0,lrg)+vdint(lrg,lr)
            wlt=wlt+vdint(lr0,lrg)+vdint(lrg,lr)
            if(jb_sys.gt.0) then
              wls1=wls1+vdint(lr0,lrg)+vdint(lrg,lr)
            endif
         !   if(jb_sys.gt.1) then
           !      wlt1=wlt1+vdint(lr0,lrg)+vdint(lrg,lr)
         !   endif
           !  2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
           !  - vo(lr0,lr)+2*vmd(lr0,lr)  w0=-1 w1=0
          enddo
          do lrg=lr+1,norb_dz
            wls=wls+vdint(lr0,lrg)+vdint(lr,lrg)
            wlt=wlt+vdint(lr0,lrg)+vdint(lr,lrg)
            if(jb_sys.gt.0) then
              wls1=wls1+vdint(lr0,lrg)+vdint(lr,lrg)
            endif
       !     if(jb_sys.gt.1) then
         !       wlt1=wlt1+vdint(lr0,lrg)+vdint(lr,lrg)
       !     endif
          enddo
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
                call prodel(1,wlt,0,ipae,iwad)
             enddo
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
                call prodel(1,wls,0,ipae,iwad)
             enddo
            if(jb_sys.gt.0) then
              iwdownv=iw_downwei(jpas,ipae)
              do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
              call prodel(1,wls1,0,ipae,iwad)
            enddo
           endif
           if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
               do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpat1,ipae,iwa,iwt)     !t 1-1
                 call prodel(1,wlt,0,ipae,iwad)
               enddo
           endif
            enddo
401     continue
400   continue
c ------------- end of delm --------------
      return
      end


      subroutine diagonal_ext()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      character*10 cc
        cc=' out_800_d'
        jws0=0
      do mra=1,8
        ipae=1+mra
        lasta=ibsm_ext(mra)
        laend=iesm_ext(mra)
        lrzz=laend-lasta+1
        lrzz=lrzz*(lrzz-1)/2
        jws0=jws0+lrzz
        jw=0
        do la=lasta,laend
c        jpd=jd(mra)
          jw=jw+1
                                          ! d(1)_800
          lra=norb_all-la+1
         wld=voint(lra,lra)
          call prodel(2,wld,0,ipae,jw)
        enddo
      enddo

!      zz=' out_800_s'
c       jps=js(1)

      jweis=jws0
      do la=1,norb_ext
c        jpd=jd(mra)
        lra=norb_all-la+1
        jweis=jweis+1
                                          ! (3)_800
        wls=2.d0*voint(lra,lra)+vdint(lra,lra)
        call prodel(2,wls,0,18,jweis)
      enddo
      do im=1,8
        jws=0
        jwt=0
        ipat=9+im
        ipas=17+im
        do la=2,norb_ext
         lra=norb_all-la+1
         ima=lsm(la)
         do 600 lb=1,la-1
           lrb=norb_all-lb+1
           imb=lsm(lb)
           mr=mul_tab(ima,imb)
           if(mr.ne.im) goto 600
c          jps=js(mr)
c          jpt=jt(mr)
           jws=jws+1
           jwt=jwt+1
            wls=voint(lra,lra)+voint(lrb,lrb)
            wlt=wls
            wls=wls+voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=-3/2
            wlt=wlt-voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=1/2

           call prodel(2,wls,0,ipas,jws)
            call prodel(2,wlt,0,ipat,jwt)
600       continue
          enddo
      enddo
c ------------- end of h_delm --------------
      return
      end

      subroutine prodel(idb,wl,mg1,mg2,mg3)
#include "drt_h.fh"
      if(log_prod.eq.3) then
        call prodel_pt(idb,wl,mg1,mg2,mg3) ! pt1
      else
        call prodel_hd(idb,wl,mg1,mg2,mg3)! form_h
      endif
      return
      end


c  2001.10.2 for norb_act<>0            mg1,mg2,mg3:
!  idb=1  in dbl_space      ity_up=0-5             jd_type,jd_im,iwd
!  idb=2  in ext_space      ity_down=0-3          je_type,je_im,iwe
!  idb=3  in act_space      ity_up=0-5,itdown=0,3      jp ,mpe,iwa
!  idb=4  betwin dbl and act   ity_up=0-5,itdown=0,3      mpe,iwd,iwa
!  idb=5  betwin act and ext  ity_down=0-3            jp ,iwa,iwe
!  idb=6  betwin dbl and ext   ity_down=0-3            iwd,iwa,iwe
      subroutine prodel_hd(idb,wl,mg1,mg2,mg3)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      ndr=1
      goto(100,200,300,400,500,600),idb
! in dbl_space
100   ipae=mg2
      iwad=mg3
      isegdownwei=iseg_downwei(ipae)
      do mm=iwad+1,iwad+isegdownwei
          vector1(mm)=vector1(mm)+wl
!      if(mm.eq.ndr) then
!       write(6,'(a8,3i6,2f20.14)')
!     :     ' in dbl _',mg1,mg2,mg3,wl,vector1(mm)
!      endif
      enddo
      goto 1000
! in ext_space
 200  ipae=mg2
      iwe=mg3
      do jdbl=1,mxnode
        if(nu_ad(jdbl).eq.0) cycle
        iw=iw_downwei(jdbl,ipae)
        iwupwei=jpad_upwei(jdbl)
        do iwa=0,iw-1
          do iwd=0,iwupwei-1
            mm=iwalk_ad(jdbl,ipae,iwa,iwd)+iwe
            vector1(mm)=vector1(mm)+wl
!      if(mm.eq.ndr) then
!       write(nf2,'(a8,3i6,2f20.14)')
!     :     ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
!       write(6,'(a8,3i6,2f20.14)')
!     :     ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
!      endif
          enddo
        enddo
      enddo
      goto 1000
! in act_space
300   jp=mg1
      mpe=mg2
      jw=mg3
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jph=jphy(jp)
      in=ihy(jph)
      lwnu=iy(1,mpe)
      do jwu=jph+1,jph+in
        iwa=jw+ihy(jwu)-1
        do jwd=1,lwnu
          iwa=iwa+1
          do iwd=0,iwupwei-1
            iwad=iwalk_ad(jpad,ipae,iwa,iwd)
            do iwe=1,isegdownwei
              mm=iwe+iwad
              vector1(mm)=vector1(mm)+wl
!      if(mm.eq.ndr) then
!       write(6,'(a8,3i6,2f20.14)')
!     :     ' in act _',mg1,mg2,mg3,wl,vector1(mm)
!      endif
           enddo
          enddo
        enddo
      enddo
      goto 1000
! betwin dbl and act
400   mpe=mg1
      iwd=mg2
      iwa=mg3-1
      isegdownwei=iseg_downwei(ipae)   ! betwin dbl and act
      jwnu=iy(1,mpe)
      do ii=1,jwnu
        iwa=iwa+1
        iwad=iwalk_ad(jpad,ipae,iwa,iwd)
        do iwe=1,isegdownwei
          mm=iwe+iwad                  ! iwl=iwalk_ad
          vector1(mm)=vector1(mm)+wl
!      if(mm.eq.ndr) then
!       write(6,'(a8,3i6,2f20.14)')
!     :     ' dbl_act ',mg1,mg2,mg3,wl,vector1(mm)
!      endif
        enddo
      enddo
      goto 1000
! betwin act and ext
500   jp=mg1
      iwa0=mg2
      iwe=mg3
      iwupwei=jpad_upwei(jpad)
      jph=jphy(jp)
      in=ihy(jph)
      do jwu=jph+1,jph+in
        iwa=iwa0+ihy(jwu)
        do iwd=0,iwupwei-1
          iwad=iwalk_ad(jpad,ipae,iwa,iwd)
          mm=iwe+iwad
          vector1(mm)=vector1(mm)+wl
!      if(mm.eq.ndr) then
!       write(nf2,'(a8,3i6,2f20.14)')
!     :     ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
!       write(6,'(a8,3i6,2f20.14)')
!     :     ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
!      endif
        enddo
      enddo
      goto 1000
! betwin dbl and ext
600   iwd=mg1
      iwa=mg2
      iwe=mg3
      iwad=iwalk_ad(jpad,ipae,iwa,iwd)   ! betwin dbl,act and ext
      mm=iwe+iwad
      vector1(mm)=vector1(mm)+wl
!      if(mm.eq.ndr) then
!       write(nf2,'(a8,3i6,2f20.14)')
!     :     ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
!       write(6,'(a8,3i6,2f20.14)')
!     :     ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
!      endif
1000  return
      end

      subroutine prodel_pt(idb,wl,mg1,mg2,mg3)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)

!      if(jpad.eq.18.and.ipae.eq.2) ndr=ndim_h0+1

!      ndr=32257+ndim_h0
      goto(100,200,300,400,500,600),idb
! in dbl_space
100   ipae=mg2
      iwad=mg3
      isegdownwei=jpae_downwei(ipae)
      do mm=iwad+1,iwad+isegdownwei
          vector1(mm)=vector1(mm)+wl
!          if(mm.eq.ndr) then
!             write(nf2,'(a8,3i6,2f20.14)')
!     :         ' in dbl _',mg1,mg2,mg3,wl,vector1(mm)
!             write(*,'(a8,3i6,2f20.14)')
!     :         ' in dbl _',mg1,mg2,mg3,wl,vector1(mm)
!          endif
      enddo
      goto 1000
! in ext_space
 200  ipae=mg2
      iwe=mg3
      iw=ndim
!      iw=iseg_dim(jpad,ipae)
      iwupwei=jpad_upwei(jpad)
      do iwa=0,iw-1
        do iwd=0,iwupwei-1
          mm=iwalk_ad(jpad,ipae,iwa,iwd)+iwe
          vector1(mm)=vector1(mm)+wl
!       if(mm.eq.ndr) then
!         write(nf2,'(a8,3i6,2f20.14)')
!     :         ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
!         write(*,'(a8,3i6,2f20.14)')
!     :         ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
!      endif
        enddo
      enddo
      goto 1000
! in act_space
300   jp=mg1
      mpe=mg2
      jw=mg3
      iwupwei=jpad_upwei(jpad)
      isegdownwei=jpae_downwei(ipae)
      jph=jphy(jp)
      in=ihy(jph)
      lwnu=iy(1,mpe)
      do jwu=jph+1,jph+in
         iwa=jw+ihy(jwu)-1
         do jwd=1,lwnu
           iwa=iwa+1
           do iwd=0,iwupwei-1
             iwad=iwalk_ad(jpad,ipae,iwa,iwd)
             do iwe=1,isegdownwei
               mm=iwe+iwad
                  vector1(mm)=vector1(mm)+wl
!       if(mm.eq.ndr) then
!         write(nf2,'(a8,3i6,2f20.14)')
!     :         ' in act _',mg1,mg2,mg3,wl,vector1(mm)
!         write(*,'(a8,3i6,2f20.14)')
!     :         ' in act _',mg1,mg2,mg3,wl,vector1(mm)
!      endif
             enddo
           enddo
         enddo
       enddo
       goto 1000
! betwin dbl and act
400       mpe=mg1
      iwd=mg2
      iwa=mg3-1
      isegdownwei=jpae_downwei(ipae)       ! betwin dbl and act
      jwnu=iy(1,mpe)
      do ii=1,jwnu
         iwa=iwa+1
         iwad=iwalk_ad(jpad,ipae,iwa,iwd)
         do iwe=1,isegdownwei
           mm=iwe+iwad                  ! iwl=iwalk_ad
           vector1(mm)=vector1(mm)+wl
!       if(mm.eq.ndr) then
!         write(nf2,'(a8,3i6,2f20.14)')
!     :         ' dbl_act ',mg1,mg2,mg3,wl,vector1(mm)
!         write(*,'(a8,3i6,2f20.14)')
!     :         ' dbl_act ',mg1,mg2,mg3,wl,vector1(mm)
!      endif
         enddo
      enddo
      goto 1000
! betwin act and ext
500   jp=mg1
      iwa0=mg2
      iwe=mg3
      iwupwei=jpad_upwei(jpad)
      jph=jphy(jp)
      in=ihy(jph)
      do jwu=jph+1,jph+in
        iwa=iwa0+ihy(jwu)
        do iwd=0,iwupwei-1
          iwad=iwalk_ad(jpad,ipae,iwa,iwd)
          mm=iwe+iwad
          vector1(mm)=vector1(mm)+wl
!       if(mm.eq.ndr) then
!         write(nf2,'(a8,3i6,2f20.14)')
!     :         ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
!         write(*,'(a8,3i6,2f20.14)')
!     :         ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
!      endif
        enddo
      enddo
      goto 1000
! betwin dbl and ext
600   iwd=mg1
      iwa=mg2
      iwe=mg3
      iwad=iwalk_ad(jpad,ipae,iwa,iwd)       ! betwin dbl,act and ext
      mm=iwe+iwad
      vector1(mm)=vector1(mm)+wl
!       if(mm.eq.ndr) then
!         write(nf2,'(a8,3i6,2f20.14)')
!     :         ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
!         write(*,'(a8,3i6,2f20.14)')
!     :         ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
!      endif
1000  return
      end

      subroutine get_jp(ity,nms,jp,id)
#include "drt_h.fh"
      ms=nms
      if(id.eq.1) ms=mul_tab(nms,ns_sm)
      goto(10,20,30,40,50,60),ity
10    jp=1
      return
20    jp=1+ms
      return
30    jp=9+ms
      return
40    jp=17+ms
      return
50    jp=25+ms
      return
60    jp=33+ms
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExV_X41(Vp,V,dimab,no)
! this routine does:
! Vp(a_b,ij) <- V(a_b,i,j) for i>=j

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimab, no
real(kind=wp), intent(out) :: Vp(dimab,nTri_Elem(no))
real(kind=wp), intent(in) :: V(dimab,no,no)
integer(kind=iwp) :: i, ij

ij = 0
do i=1,no
  Vp(:,ij+1:ij+i) = V(:,i,1:i)
  ij = ij+i
end do

return

end subroutine ExV_X41

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Blocked2Full(ip_Blocks,Packed,FullMatrix)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: reorder atom pair blocks to FullMatrix.
C              FullMatrix may be stored triangularly (Packed=.True.)
C              or as a quadratic array (Packed=.False.).
C              iWork(ip_Blocks-1+iAtomPair) must point to the
C              location in Work where the block of atom pair iAtomPair
C              is to be stored. Note that the blocks are always stored
C              rectangularly.
C
C     NOTE: only elements of FullMatrix that are defined by the blocks
C           are extracted (i.e. some elements may be undefined - hence,
C           it is a good idea to zero FullMatrix before entry).
C
      Implicit None
      Integer ip_Blocks
      Logical Packed
      Real*8  FullMatrix(*)
#include "WrkSpc.fh"
#include "localdf_bas.fh"

#if defined (_DEBUGPRINT_)
      Character*16 SecNam
      Parameter (SecNam='LDF_Blocked2Full')

      Logical  LDF_AtomPairInfoIsSet
      External LDF_AtomPairInfoIsSet
#endif

      Integer  LDF_nAtomPair
      External LDF_nAtomPair

      Integer iAtomPair
      Integer ip_SB, l_SB
      Integer n, ip0, iS
      Integer ip

      Integer i
      Integer nBasSh
      nBasSh(i)=iWork(ip_nBasSh-1+i)

#if defined (_DEBUGPRINT_)
      ! Check that atom pair info is set
      If (.not.LDF_AtomPairInfoIsSet()) Then
         Call WarningMessage(2,SecNam//': atom pair info not set!')
         Call LDF_Quit(1)
      End If
#endif

      ! Allocate and set offset array to shell blocks
      l_SB=nShell_Valence
      Call GetMem('SB','Allo','Inte',ip_SB,l_SB)
      n=0
      ip0=ip_SB-1
      Do iS=1,nShell_Valence
         iWork(ip0+iS)=n
         n=n+nBasSh(iS)
      End Do
#if defined (_DEBUGPRINT_)
      If (n.ne.nBas_Valence) Then
         Call WarningMessage(2,SecNam//': nBas_Valence problem!')
         Call LDF_Quit(1)
      End If
#endif

      ! Block-by-block sorting
      Do iAtomPair=1,LDF_nAtomPair()
         ip=iWork(ip_Blocks-1+iAtomPair)
         Call LDF_Block2Full(iAtomPair,FullMatrix,Packed,iWork(ip_SB),
     &                       Work(ip))
      End Do

      ! Deallocation
      Call GetMem('SB','Free','Inte',ip_SB,l_SB)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Block2Full(iAtomPair,FullMatrix,Packed,iSB,Block)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: put atom pair block into FullMatrix.
C
      Implicit None
      Integer iAtomPair
      Real*8  FullMatrix(*)
      Logical Packed
      Integer iSB(*)
      Real*8  Block(*)

      If (Packed) Then
         Call LDF_Block2Full_Packed(iAtomPair,FullMatrix,iSB,Block)
      Else
         Call LDF_Block2Full_Quadratic(iAtomPair,FullMatrix,iSB,Block)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Block2Full_Packed(iAtomPair,FullMatrix,iSB,Block)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: put atom pair block into packed FullMatrix.
C
      Implicit None
      Integer iAtomPair
      Real*8  FullMatrix(*)
      Integer iSB(*)
      Real*8  Block(*)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom

      Integer iAtom, jAtom
      Integer nShell_iAtom, nShell_jAtom
      Integer iS, jS
      Integer ipi, ipj
      Integer iShell, jShell
      Integer iOffi, iOffj
      Integer j_
      Integer ij0
      Integer iOffB

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms, iTri
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      ! Get atoms of atom pair
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)

      ! Get number of shells on atoms
      nShell_iAtom=LDF_nShell_Atom(iAtom)
      nShell_jAtom=LDF_nShell_Atom(jAtom)

      ! Get pointers to atomic shell lists
      ipi=LDF_lShell_Atom(iAtom)-1
      ipj=LDF_lShell_Atom(jAtom)-1

      ! Extract block
      iOffB=0
      Do jS=1,nShell_jAtom
         jShell=iWork(ipj+jS)
         iOffj=iSB(jShell)
         Do iS=1,nShell_iAtom
            iShell=iWork(ipi+iS)
            iOffi=iSB(iShell)
            Do j=1,nBasSh(jShell)
               j_=iOffj+j
               ij0=iOffB+nBasSh(iShell)*(j-1)
               Do i=1,nBasSh(iShell)
                  FullMatrix(iTri(iOffi+i,j_))=Block(ij0+i)
               End Do
            End Do
            iOffB=iOffB+nBasSh(iShell)*nBasSh(jShell)
         End Do
      End Do

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Block2Full_Quadratic(iAtomPair,FullMatrix,iSB,
     &                                    Block)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: put atom pair block into quadratic FullMatrix.
C
      Implicit None
      Integer iAtomPair
      Real*8  FullMatrix(*)
      Integer iSB(*)
      Real*8  Block(*)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom

      Integer iAtom, jAtom
      Integer nShell_iAtom, nShell_jAtom
      Integer iS, jS
      Integer ipi, ipj
      Integer iShell, jShell
      Integer iOffi, iOffj
      Integer j_
      Integer ij0, ij0_, ji00_, ji0_
      Integer iOffB

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Get atoms of atom pair
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)

      ! Get number of shells on atoms
      nShell_iAtom=LDF_nShell_Atom(iAtom)
      nShell_jAtom=LDF_nShell_Atom(jAtom)

      ! Get pointers to atomic shell lists
      ipi=LDF_lShell_Atom(iAtom)-1
      ipj=LDF_lShell_Atom(jAtom)-1

      ! Extract block
      iOffB=0
      Do jS=1,nShell_jAtom
         jShell=iWork(ipj+jS)
         iOffj=iSB(jShell)
         Do iS=1,nShell_iAtom
            iShell=iWork(ipi+iS)
            iOffi=iSB(iShell)
            ji00_=nBas_Valence*(iOffi-1)
            Do j=1,nBasSh(jShell)
               j_=iOffj+j
               ij0=iOffB+nBasSh(iShell)*(j-1)
               ij0_=nBas_Valence*(j_-1)+iOffi
               ji0_=ji00_+j_
               Do i=1,nBasSh(iShell)
                  FullMatrix(ij0_+i)=Block(ij0+i)
                  FullMatrix(ji0_+nBas_Valence*i)=Block(ij0+i)
               End Do
            End Do
            iOffB=iOffB+nBasSh(iShell)*nBasSh(jShell)
         End Do
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Translation(ifg,jfgrd,jfhss,tr,jndgrd,jndhss,coorm,nirrep,indgrd,indhss)

use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(inout) :: ifg(4), jfgrd(3,4), jfhss(4,3,4,3), tr(4)
integer(kind=iwp), intent(in) :: nirrep, indgrd(3,4,0:nirrep-1), indhss(4,3,4,3,0:nirrep-1)
integer(kind=iwp), intent(inout) :: jndgrd(3,4,0:nirrep-1), jndhss(4,3,4,3,0:nirrep-1)
real(kind=wp), intent(in) :: Coorm(3,4)
integer(kind=iwp) :: iCent, iiC, iiCar, iiCent, iMax, iMin, iStop, jCent, jjC, jjCent, kCar, kCent, kkCar, lCar, lCent
logical(kind=iwp) :: alike
logical(kind=iwp), external :: EQ

Alike = .false.
if (IfG(1) .and. IfG(2) .and. IfG(3) .and. IfG(4)) then
  do iCent=1,3
    if (.not. Alike) then
      do jCent=iCent+1,4
        if (EQ(CoorM(1,iCent),CoorM(1,jCent))) then
          do kCent=1,4
            iMax = max(jCent,kCent)
            iMin = min(jCent,kCent)
            JndHss(iMax,:,iMin,:,0:nIrrep-1) = 0
            JfHss(iMax,:,iMin,:) = .false.
          end do
          JndGrd(:,jCent,0:nIrrep-1) = 0
          JfGrd(:,jCent) = .false.
          IfG(jCent) = .false.
          if (.not. Alike) then
            IfG(iCent) = .false.
            Tr(iCent) = .true.
            Alike = .true.
            do kCent=1,4
              if ((.not. EQ(CoorM(1,iCent),CoorM(1,kCent))) .or. (kCent == iCent)) then
                iMax = max(iCent,kCent)
                iMin = min(iCent,kCent)
                do kCar=1,3
                  if (iMax == iMin) then
                    iStop = kCar
                  else
                    iStop = 3
                  end if
                  JndHss(iMax,kCar,iMin,1:iStop,0:nIrrep-1) = -IndHss(iMax,kCar,iMin,1:iStop,0:nIrrep-1)
                  JfHss(iMax,kCar,iMin,1:iStop) = .false.
                  do lCar=1,iStop

                    ! Set the derivatives that are needed for the translation
                    ! invariance calculations.

                    do iiCent=1,4
                      if (.not. EQ(CoorM(1,iiCent),CoorM(1,iCent))) then
                        do jjCent=1,iiCent
                          if (.not. EQ(CoorM(1,jjCent),CoorM(1,iCent))) then
                            do kkCar=1,3
                              if (iiCent == jjCent) then
                                iStop = kkCar
                              else
                                iStop = 3
                              end if
                              JfHss(iiCent,kkCar,jjCent,1:iStop) = .true.
                            end do
                          end if
                        end do ! icent
                        JfGrd(:,iiCent) = .true.
                      end if
                    end do
                  end do
                end do
              end if
            end do
            JndGrd(:,iCent,0:nIrrep-1) = -IndGrd(:,iCent,0:nIrrep-1)
            JfGrd(:,iCent) = .false.
          end if
        end if
      end do
    end if
  end do
end if

! If all centers are different delete the fourth center

if (.not. Alike) then
  IfG(4) = .false.
  Tr(4) = .true.
  JfGrd(:,:) = .true.
  !JfHss(:,:,:,:) = .true.
  do iiC=1,4
    do jjC=1,iiC
      do iiCar=1,3
        if (iic == jjc) then
          iStop = iiCar
        else
          iStop = 3
        end if
        JfHss(iiC,iiCar,jjc,1:iStop) = .true.
      end do
    end do
  end do

  do kCar=1,3
    do lCent=1,4
      if (lCent == 4) then
        iStop = kCar
      else
        iStop = 3
      end if
      JndHss(4,kCar,lCent,1:iStop,nIrrep-1) = -IndHss(4,kCar,lCent,1:iStop,nIrrep-1)
      JfHss(4,kCar,lCent,1:iStop) = .false.
    end do
  end do

  Jndgrd(:,4,nIrrep-1) = -IndGrd(:,4,nIrrep-1)
  JfGrd(:,4) = .false.

end if

return

end subroutine Translation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SONATORB_PLOT (DENS, FILEBASE, CHARTYPE, ASS, BSS)
      use definitions, only: iwp, wp, u6
      use constants, only: Zero, One, Two
      use OneDat, only: sNoNuc, sNoOri
      use stdalloc, only: mma_allocate, mma_deallocate
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NBTRI,NBMX,NBASF,NBSQ,NBST

      IMPLICIT None
      real(kind=wp), intent(in):: DENS(6,NBTRI)
      CHARACTER(LEN=*), intent(in):: FILEBASE
      CHARACTER(LEN=8), intent(in):: CHARTYPE
      INTEGER(KIND=IWP), INTENT(IN):: ASS,BSS

      CHARACTER(LEN=25) FNAME
      CHARACTER(LEN=16) KNUM
      CHARACTER(LEN=16) FNUM,XNUM
      CHARACTER(LEN=8) LABEL
      CHARACTER CDIR
      Real(kind=wp) Dummy(1)
      Integer(kind=iwp) iDummy(7,8)
      Real(kind=wp), allocatable:: SZZ(:), VEC(:), VEC2(:), DMAT(:),
     &                             SCR(:)
      Real(kind=wp), allocatable:: VNAT(:), EIG(:), OCC(:)
      Integer(kind=iwp) ITYPE, NBMX2, IRC, IOPT, ICMP, ISYLAB, LS, LV,
     &                  LE, ISYM, NB, I, LS1, LV1, LE1, ISTART, IEND,
     &                  IDIR, INV, II2, IOCC, J, IJ, JI, ID1, ID2, ISCR,
     &                  II, I1, I2, LuXXVEC
      Integer(kind=iwp), External:: IsFreeUnit
      REAL(kind=wp) X

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C PLOTTING SECTION
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C Get the proper type of the property
      ITYPE=0
      IF(CHARTYPE.EQ.'HERMSING') ITYPE=1
      IF(CHARTYPE.EQ.'ANTISING') ITYPE=2
      IF(CHARTYPE.EQ.'HERMTRIP') ITYPE=3
      IF(CHARTYPE.EQ.'ANTITRIP') ITYPE=4
      IF(ITYPE.EQ.0) THEN
        WRITE(u6,*)'RASSI/SONATORB internal error.'
        WRITE(u6,*)'Erroneous property type:',CHARTYPE
        CALL ABEND()
      END IF

      NBMX2=NBMX**2

c SZZ  - AO Overlap integral
c VEC  - AO Overlap eigenvectors
c EIG  - AO Overlap eigenvalues
c VEC2 - Eigenvectors of density matrix
c SCR  - Temporary for matrix multiplication
C NOTE: SCR COULD PROBABLY BE SOMETHING LIKE NBMX*(NBMX+1)/2
C       ALTHOUGH IT PROBABLY DOESN'T SAVE MUCH
C       (JACOB TAKES A TRIANGULAR MATRIX LIKE ZHPEV DOES?)
      CALL mma_allocate(SZZ,NBTRI,Label='SZZ')
      CALL mma_allocate(VEC,NBSQ,Label='VEC')
      CALL mma_allocate(VEC2,NBMX2,Label='VEC2')
      CALL mma_allocate(SCR,NBMX2,Label='SCR')
      CALL mma_allocate(EIG,NBST,Label='EIG')
      SZZ(:)=Zero
      VEC(:)=Zero
      VEC2(:)=Zero
      SCR(:)=Zero
      EIG(:)=Zero

      CALL mma_allocate(VNAT,NBSQ,Label='VNAT')
      VNAT(:)=Zero
      CALL mma_allocate(OCC,NBST,Label='OCC')
      OCC(:)=Zero

C READ ORBITAL OVERLAP MATRIX.
      IRC=-1

c IOPT=6, origin and nuclear contrib not read
      IOPT=ibset(ibset(0,sNoOri),sNoNuc)
      ICMP=1
      ISYLAB=1
      LABEL='MLTPL  0'
      CALL RDONE(IRC,IOPT,LABEL,ICMP,SZZ,ISYLAB)
      IF ( IRC.NE.0 ) THEN
        WRITE(u6,*)
        WRITE(u6,*)'      *** ERROR IN SUBROUTINE  SONATORB ***'
        WRITE(u6,*)'      OVERLAP INTEGRALS ARE NOT AVAILABLE'
        WRITE(u6,*)
        CALL ABEND()
      ENDIF


C DIAGONALIZE EACH SYMMETRY BLOCK OF THE OVERLAP MATRIX.
      LS=1
      LV=1
      LE=1
      VEC(:)=Zero
      DO ISYM=1,NSYM
        NB=NBASF(ISYM)
        DO I=1,NB**2,(NB+1)
          VEC(LV-1+I)=One
        END DO
        CALL JACOB(SZZ(LS),VEC,NB,NB)
C SCALE EACH VECTOR TO OBTAIN AN ORTHONORMAL BASIS.
        LS1=LS
        LV1=LV
        LE1=LE
        DO I=1,NB
          EIG(LE1)=SZZ(LS1)
          X=One/SQRT(MAX(SZZ(LS1),1.0D-14))
          CALL DSCAL_(NB,X,VEC(LV1),1)
          LS1=LS1+I+1
          LV1=LV1+NB
          LE1=LE1+1
        END DO
        LS=LS+(NB*(NB+1))/2
        LV=LV+NB**2
        LE=LE+NB
      END DO

      CALL mma_deallocate(SZZ)

      CALL mma_allocate(DMAT,NBMX2,Label='DMAT')

      IF(ITYPE.LE.2) THEN
        ISTART=3
        IEND=3
      ELSE
        ISTART=1
        IEND=3
      END IF

      DO IDIR=ISTART,IEND

        CDIR='?'
        IF(IDIR.EQ.1) CDIR='X'
        IF(IDIR.EQ.2) CDIR='Y'
        IF(IDIR.EQ.3) CDIR='Z'

        INV=1
        II2=0
        IOCC=0
        LV=1
        LE=1
        DO ISYM=1,NSYM
          NB=NBASF(ISYM)
          IF(NB.EQ.0) CYCLE

C TRANSFORM TO ORTHONORMAL BASIS. THIS REQUIRES THE CONJUGATE
C BASIS, BUT SINCE WE USE CANONICAL ON BASIS THIS AMOUNTS TO A
C SCALING WITH THE EIGENVALUES OF THE OVERLAP MATRIX:

C expand the triangular matrix for this symmetry to a square matrix
          DMAT(:)=Zero
          CALL DCOPY_(NBMX2,[Zero],0,SCR,1)
          DO J=1,NB
          DO I=1,J
            II2=II2+1
            IJ=NB*(J-1)+I
            JI=NB*(I-1)+J
            IF(I.NE.J) THEN
              DMAT(IJ)=DENS(IDIR,II2)/Two
              DMAT(JI)=DENS(IDIR,II2)/Two
            ELSE
              DMAT(IJ)=DENS(IDIR,II2)
              DMAT(JI)=DENS(IDIR,II2)
            END IF
          END DO
          END DO

          CALL DGEMM_('N','N',NB,NB,NB,One,
     &                 DMAT,NB,VEC(LV),NB,
     &                 Zero,SCR,NB)
          CALL DGEMM_('T','N',NB,NB,NB,One,
     &                 VEC(LV),NB,SCR,NB,
     &                 Zero,DMAT,NB)

          ID1=1
          ID2=1
          DO I=1,NB
            CALL DSCAL_(NB,EIG(LE-1+I),DMAT(ID1),NB)
            CALL DSCAL_(NB,EIG(LE-1+I),DMAT(ID2),1)
            ID1=ID1+1
            ID2=ID2+NB
          END DO


C SYMMETRIZE THIS BLOCK INTO SCRATCH AREA, TRIANGULAR STORAGE:
          SCR(:)=Zero
          ISCR=1
          DO I=1,NB
            DO J=1,I
              IJ=I+NB*(J-1)
              JI=J+NB*(I-1)
c simple averaging
              SCR(ISCR)=(DMAT(IJ)+DMAT(JI))/Two

c add a factor of two to convert spin -> sigma
              IF(ITYPE.GE.3) SCR(ISCR)=SCR(ISCR)*Two
              ISCR=ISCR+1
            END DO
          END DO

C DIAGONALIZE THE DENSITY MATRIX BLOCK:
          CALL DCOPY_(NBMX2,[Zero],0,VEC2,1)
          CALL DCOPY_(NB,[One],0,VEC2,NB+1)

          CALL JACOB(SCR,VEC2,NB,NB)
          CALL JACORD(SCR,VEC2,NB,NB)

C JACORD ORDERS BY INCREASING EIGENVALUE. REVERSE THIS ORDER.
          II=0
          DO I=1,NB
            II=II+I
            OCC(IOCC+NB+1-I)=SCR(II)
          END DO
          IOCC=IOCC+NB

C REEXPRESS THE EIGENVALUES IN AO BASIS FUNCTIONS. REVERSE ORDER.
          CALL DGEMM_('N','N',NB,NB,NB,One,
     &                 VEC(LV),NB,VEC2,NB,
     &                 Zero,SCR,NB)
          I1=1
          I2=INV+NB**2
          DO I=1,NB
            I2=I2-NB
            CALL DCOPY_(NB,SCR(I1),1,VNAT(I2),1)
            I1=I1+NB
          END DO
          INV=INV+NB**2
          LV=LV+NB**2
          LE=LE+NB

        END DO

C WRITE OUT THIS SET OF NATURAL SPIN ORBITALS
       IF(ITYPE.LE.2) THEN
         WRITE(KNUM,'(I2.2,A,I2.2)') ASS,".",BSS
       ELSE
         WRITE(KNUM,'(I2.2,A,I2.2,A,A)') ASS,".",BSS,".",CDIR
       END IF
       WRITE(FNUM,'(I8)') BSS
       FNUM=ADJUSTL(FNUM)
       IF (ASS.NE.BSS) THEN
         WRITE(XNUM,'(I8,A)') ASS,'_'//TRIM(FNUM)
         FNUM=ADJUSTL(XNUM)
       END IF
       IF (ITYPE.GT.2) FNUM=CDIR//TRIM(FNUM)

       FNAME=FILEBASE//'.'//TRIM(FNUM)
       IF(ITYPE.EQ.1)
     &        WRITE(u6,'(A,A)')' NATURAL ORBITALS FOR ',KNUM
       IF(ITYPE.EQ.2)
     &        WRITE(u6,'(A,A)')' ANTISING NATURAL ORBITALS FOR  ',KNUM
       IF(ITYPE.EQ.3)
     &        WRITE(u6,'(A,A)')' NATURAL SPIN ORBITALS FOR  ',KNUM
       IF(ITYPE.EQ.4)
     &        WRITE(u6,'(A,A)')' ANTITRIP NATURAL ORBITALS FOR  ',KNUM

       WRITE(u6,'(A,A)') ' ORBITALS ARE WRITTEN ONTO FILE ',FNAME

        LuxxVec=50
        LuxxVec=isfreeunit(LuxxVec)

        CALL WRVEC(FNAME,LUXXVEC,'CO',NSYM,NBASF,NBASF,
     &             VNAT, OCC, Dummy, iDummy,
     &     '* DENSITY FOR PROPERTY TYPE ' // CHARTYPE // KNUM )

c       Test a few values
C        CALL ADD_INFO("SONATORB_PLOT", VNAT, 1, 4)

c    ONLYFOR NATURAL ORBITALS
      if(ITYPE.EQ.1)
     &       CALL ADD_INFO("SONATORB_NO_OCC", OCC, SUM(NBASF), 4)

      END DO

      CALL mma_deallocate(DMAT)
      CALL mma_deallocate(VEC)
      CALL mma_deallocate(VEC2)
      CALL mma_deallocate(SCR)
      CALL mma_deallocate(EIG)
      CALL mma_deallocate(VNAT)
      CALL mma_deallocate(OCC)

      END SUBROUTINE SONATORB_PLOT

      SUBROUTINE SONATORB_CPLOT (DENS, FILEBASE, CHARTYPE, ASS, BSS)
      use definitions, only: iwp, wp, u6
      use constants, only: Zero, One, Two
      use OneDat, only: sNoNuc, sNoOri, sOpSiz
      use rassi_aux, only: ipglob
      use stdalloc, only: mma_allocate, mma_deallocate
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NBTRI,NBMX,NBASF,NBSQ,NBST
      IMPLICIT NONE
      Real(kind=wp) DENS(6,NBTRI)
      CHARACTER(LEN=*) FILEBASE
      CHARACTER(LEN=8) CHARTYPE
      INTEGER(kind=iwp) ASS,BSS

      CHARACTER(LEN=25) FNAME
      CHARACTER(LEN=16) KNUM
      CHARACTER(LEN=16) FNUM,XNUM
      CHARACTER(LEN=8) LABEL
      CHARACTER CDIR
      Real(kind=wp) Dummy(1)
      Integer(kind=iwp) IDUM(1),iDummy(7,8)
      Real(kind=wp), Allocatable:: SZZ(:), VEC(:), VEC2(:), VEC2I(:),
     &                             SCR(:)
      Real(kind=wp), Allocatable:: SCRI(:), EIG(:)
      Real(kind=wp), Allocatable:: VNAT(:), VNATI(:), OCC(:)
      Real(kind=wp), Allocatable:: DMAT(:), DMATI(:)
      Real(kind=wp), Allocatable:: SANG(:)
      Real(kind=wp), Allocatable:: SANGF(:), SANGTR(:), SANGTI(:)
      Real(kind=wp), Allocatable:: SANGTR2(:), SANGTI2(:)

      Integer(kind=iwp) ITYPE, NBMX2, IRC, IOPT, ICMP, ISYLAB, LS, LV,
     &                  LE, ISYM, NB, I, LS1, LV1, LE1, ISTART, IEND,
     &                  IDIR, INV, II2, IOCC, J, IJ, JI, ID1, ID2, ISCR,
     &                  II, I1, I2, LuXXVEC, JOPT, I1I, INV2, ISCRI
      Integer(kind=iwp), External:: IsFreeUnit
      REAL(kind=wp) X, SUM, SUMI


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C PLOTTING SECTION
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C Get the proper type of the property
      ITYPE=0
      IF(CHARTYPE.EQ.'HERMSING') ITYPE=1
      IF(CHARTYPE.EQ.'ANTISING') ITYPE=2
      IF(CHARTYPE.EQ.'HERMTRIP') ITYPE=3
      IF(CHARTYPE.EQ.'ANTITRIP') ITYPE=4
      IF(ITYPE.EQ.0) THEN
        WRITE(u6,*)'RASSI/SONATORB internal error.'
        WRITE(u6,*)'Erroneous property type:',CHARTYPE
        CALL ABEND()
      END IF

      NBMX2=NBMX**2

c SZZ  - AO Overlap integral
c VEC  - AO Overlap eigenvectors
c EIG  - AO Overlap eigenvalues
c VEC2 - Eigenvectors of density matrix
c SCR  - Temporary for matrix multiplication
C NOTE: SCR COULD PROBABLY BE SOMETHING LIKE NBMX*(NBMX+1)/2
C       ALTHOUGH IT PROBABLY DOESN'T SAVE MUCH
C       (JACOB TAKES A TRIANGULAR MATRIX LIKE ZHPEV DOES?)
      CALL mma_allocate(SZZ,NBTRI,Label='SZZ')
      SZZ(:)=Zero
      CALL mma_allocate(VEC,NBSQ,Label='VEC')
      VEC(:)=Zero
      CALL mma_allocate(VEC2,NBMX2,Label='VEC2')
      VEC2(:)=Zero
      CALL mma_allocate(VEC2I,NBMX2,Label='VEC2I')
      VEC2I(:)=Zero
      CALL mma_allocate(SCR,NBMX2,Label='SCR')
      SCR(:)=Zero
      CALL mma_allocate(SCRI,NBMX2,Label='SCRI')
      SCRI(:)=Zero
      CALL mma_allocate(EIG,NBST,Label='EIG')
      EIG(:)=Zero

      CALL mma_allocate(VNAT,NBSQ,Label='VNAT')
      VNAT(:)=Zero
      CALL mma_allocate(VNATI,NBSQ,Label='VNATI')
      VNATI(:)=Zero
      CALL mma_allocate(OCC,NBST,Label='OCC')
      OCC(:)=Zero

C READ ORBITAL OVERLAP MATRIX.
      IRC=-1

c IOPT=6, origin and nuclear contrib not read
      IOPT=ibset(ibset(0,sNoOri),sNoNuc)
      ICMP=1
      ISYLAB=1
      LABEL='MLTPL  0'
      CALL RDONE(IRC,IOPT,LABEL,ICMP,SZZ,ISYLAB)
      IF ( IRC.NE.0 ) THEN
        WRITE(u6,*)
        WRITE(u6,*)'      *** ERROR IN SUBROUTINE  SONATORB ***'
        WRITE(u6,*)'      OVERLAP INTEGRALS ARE NOT AVAILABLE'
        WRITE(u6,*)
        CALL ABEND()
      ENDIF


C DIAGONALIZE EACH SYMMETRY BLOCK OF THE OVERLAP MATRIX.
      LS=1
      LV=1
      LE=1
      VEC(:)=Zero
      DO ISYM=1,NSYM
        NB=NBASF(ISYM)
        DO I=1,NB**2,(NB+1)
          VEC(LV-1+I)=One
        END DO
        CALL JACOB(SZZ(LS),VEC(LV),NB,NB)
C SCALE EACH VECTOR TO OBTAIN AN ORTHONORMAL BASIS.
        LS1=LS
        LV1=LV
        LE1=LE
        DO I=1,NB
          EIG(LE1)=SZZ(LS1)
          X=One/SQRT(MAX(SZZ(LS1),1.0D-14))
          CALL DSCAL_(NB,X,VEC(LV1),1)
          LS1=LS1+I+1
          LV1=LV1+NB
          LE1=LE1+1
        END DO
        LS=LS+(NB*(NB+1))/2
        LV=LV+NB**2
        LE=LE+NB
      END DO

      CALL mma_deallocate(SZZ)

      CALL mma_allocate(DMAT,NBMX2,Label='DMAT')
      CALL mma_allocate(DMATI,NBMX2,Label='DMATI')

      IF(ITYPE.LE.2) THEN
        ISTART=3
        IEND=3
      ELSE
        ISTART=1
        IEND=3
      END IF

      DO IDIR=ISTART,IEND

          CDIR='?'
          IF(IDIR.EQ.1) CDIR='X'
          IF(IDIR.EQ.2) CDIR='Y'
          IF(IDIR.EQ.3) CDIR='Z'


cccccccccccccccccccccccc
cccccccccccccccccccccccc
cccccccccccccccccccccccc
cccccccccccccccccccccccc
C read in ao matrix for angmom or mltpl
      CALL mma_allocate(SANG,NBTRI,Label='SANG')
      SANG(:)=Zero

      IRC=-1
      IOPT=ibset(ibset(0,sNoOri),sNoNuc)
      JOPT=ibset(0,sOpSiz)

      IF(ITYPE.EQ.1.OR.ITYPE.EQ.3) THEN
        ICMP=1
        LABEL='MLTPL  0'
        CALL iRDONE(IRC,JOPT,LABEL,ICMP,IDUM,ISYLAB)
        CALL  RDONE(IRC,IOPT,LABEL,ICMP,SANG,ISYLAB)

        IF ( IRC.NE.0 ) THEN
          WRITE(u6,*)
          WRITE(u6,*)'      *** ERROR IN SUBROUTINE  SONATORB ***'
          WRITE(u6,*)'      MLTPL0 INTEGRALS ARE NOT AVAILABLE'
          WRITE(u6,*)'      IRC:',IRC
          WRITE(u6,*)
          CALL ABEND()
        END IF

      ELSE IF(ITYPE.EQ.2.OR.ITYPE.EQ.4) THEN
        ICMP=3
        LABEL='ANGMOM'
        CALL iRDONE(IRC,JOPT,LABEL,ICMP,IDUM,ISYLAB)
        CALL  RDONE(IRC,IOPT,LABEL,ICMP,SANG,ISYLAB)

        IF ( IRC.NE.0 ) THEN
          WRITE(u6,*)
          WRITE(u6,*)'      *** ERROR IN SUBROUTINE  SONATORB ***'
          WRITE(u6,*)'      ANGMOM INTEGRALS ARE NOT AVAILABLE'
          WRITE(u6,*)'      IRC:',IRC
          WRITE(u6,*)
          CALL ABEND()
        END IF

      END IF

cccccccccccccccccccccccc
cccccccccccccccccccccccc
cccccccccccccccccccccccc
cccccccccccccccccccccccc
        INV=1
        II2=0
        IOCC=0
        LV=1
        LE=1
        DO ISYM=1,NSYM
          NB=NBASF(ISYM)
          IF(NB.EQ.0) cycle

C TRANSFORM TO ORTHONORMAL BASIS. THIS REQUIRES THE CONJUGATE
C BASIS, BUT SINCE WE USE CANONICAL ON BASIS THIS AMOUNTS TO A
C SCALING WITH THE EIGENVALUES OF THE OVERLAP MATRIX:

C expand the triangular matrix for this symmetry to a square matrix
          DMAT(:)=Zero
          DMATI(:)=Zero
          SCR(:)=Zero
          SCRI(:)=Zero

          DO J=1,NB
          DO I=1,J
            II2=II2+1
            IJ=NB*(J-1)+I
            JI=NB*(I-1)+J
            IF(I.NE.J) THEN
              DMAT(IJ)=DENS(IDIR,II2)/Two
              DMAT(JI)=DENS(IDIR,II2)/Two
              DMATI(IJ)=-DENS(IDIR+3,II2)/Two
              DMATI(JI)= DENS(IDIR+3,II2)/Two
            ELSE
              DMAT(IJ)=DENS(IDIR,II2)
              DMATI(JI)=DENS(IDIR+3,II2)
            END IF
          END DO
          END DO

          CALL DGEMM_('N','N',NB,NB,NB,One,
     &                 DMAT,NB,VEC(LV),NB,
     &                 Zero,SCR,NB)
          CALL DGEMM_('N','N',NB,NB,NB,One,
     &                 DMATI,NB,VEC(LV),NB,
     &                 Zero,SCRI,NB)



          CALL DGEMM_('T','N',NB,NB,NB,One,
     &                 VEC(LV),NB,SCR,NB,
     &                 Zero,DMAT,NB)
          CALL DGEMM_('T','N',NB,NB,NB,One,
     &                 VEC(LV),NB,SCRI,NB,
     &                 Zero,DMATI,NB)

          ID1=1
          ID2=1
          DO I=1,NB
            CALL DSCAL_(NB,EIG(LE-1+I),DMAT(ID1),NB)
            CALL DSCAL_(NB,EIG(LE-1+I),DMAT(ID2),1)
            CALL DSCAL_(NB,EIG(LE-1+I),DMATI(ID1),NB)
            CALL DSCAL_(NB,EIG(LE-1+I),DMATI(ID2),1)
            ID1=ID1+1
            ID2=ID2+NB
          END DO


C SYMMETRIZE THIS BLOCK INTO SCRATCH AREA, TRIANGULAR STORAGE:
          SCR(:)=Zero
          SCRI(:)=Zero

          ISCR=1
          ISCRI=1
          DO I=1,NB
            DO J=1,I
              IJ=I+NB*(J-1)
              JI=J+NB*(I-1)
c simple averaging
              SCR(ISCR)=(DMAT(JI)+DMAT(IJ))/Two
              SCRI(ISCRI)=(DMATI(JI)-DMATI(IJ))/Two
c add a factor of two to convert spin -> sigma
              IF(ITYPE.GE.3) SCR(ISCR)=SCR(ISCR)*Two
              IF(ITYPE.GE.3) SCRI(ISCRI)=SCRI(ISCRI)*Two
              ISCR=ISCR+1
              ISCRI=ISCRI+1
            END DO
          END DO

C DIAGONALIZE THE DENSITY MATRIX BLOCK:
          VEC2(:)=Zero
          VEC2I(:)=Zero

          CALL CPLOT_DIAG(SCR,SCRI, NB,VEC2,VEC2I)

C LAPACK ORDERS BY INCREASING EIGENVALUE. REVERSE THIS ORDER.
          II=0
          DO I=1,NB
            II=II+I
            OCC(IOCC+NB+1-I)=SCR(II)
          END DO
          IOCC=IOCC+NB

C REEXPRESS THE EIGENVECTORS IN AO BASIS FUNCTIONS. REVERSE ORDER.
          CALL DGEMM_('N','N',NB,NB,NB,One,
     &                 VEC(LV),NB,VEC2,NB,
     &                 Zero,SCR,NB)
          CALL DGEMM_('N','N',NB,NB,NB,One,
     &                 VEC(LV),NB,VEC2I,NB,
     &                 Zero,SCRI,NB)

          I1=1
          I1I=1
          I2=INV+NB**2
          DO I=1,NB
            I2=I2-NB
            CALL DCOPY_(NB,SCR(I1),1,VNAT(I2),1)
            CALL DCOPY_(NB,SCRI(I1I),1,VNATI(I2),1)
            I1=I1+NB
            I1I=I1I+NB
          END DO
          INV=INV+NB**2
          LV=LV+NB**2
          LE=LE+NB
        END DO

CCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCC TESTING
CCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IF(IPGLOB.GE.4) THEN

      CALL mma_allocate(SANGF,NBMX**2,Label='SANGF')
      SANGF(:)=Zero
      CALL mma_allocate(SANGTR,NBMX**2,Label='SANGTR')
      CALL mma_allocate(SANGTI,NBMX**2,Label='SANGTI')
      SANGTR(:)=Zero
      SANGTI(:)=Zero
      CALL mma_allocate(SANGTR2,NBMX**2,Label='SANGTR2')
      CALL mma_allocate(SANGTI2,NBMX**2,Label='SANGTI2')
      SANGTR2(:)=Zero
      SANGTI2(:)=Zero

      INV=0
      INV2=0
      II=0
      SUM = Zero
      SUMI = Zero

      DO ISYM=1,NSYM
        NB=NBASF(ISYM)
        IF (NB/=0) THEN

c       Expand integrals for this symmetry to full storage
        SANGF(:)=Zero

        DO J=1,NB
        DO I=1,J
          IJ=NB*(J-1)+I-1
          JI=NB*(I-1)+J-1

          SANGF(1+JI) = SANG(1+II)

          IF(I.NE.J) THEN
            IF(ITYPE.EQ.2.OR.ITYPE.EQ.4) THEN
              SANGF(1+IJ) = -SANG(1+II)
            ELSE
              SANGF(1+IJ) =  SANG(1+II)
            END IF
          END IF

          II=II+1

        END DO
        END DO

        IF(ITYPE.EQ.1.OR.ITYPE.EQ.3) THEN
          CALL DGEMM_('T','N',NB,NB,NB,One,SANGF,NB,
     &             VNAT(1+INV),NB,Zero,SANGTR,NB)
          CALL DGEMM_('T','N',NB,NB,NB,One,SANGF,NB,
     &              VNATI(1+INV),NB,Zero,SANGTI,NB)

          CALL DGEMM_('T','N',NB,NB,NB,One,VNAT(1+INV),NB,
     &             SANGTR,NB,Zero,SANGTR2,NB)
          CALL DGEMM_('T','N',NB,NB,NB,One,VNATI(1+INV),NB,
     &             SANGTI,NB,One,SANGTR2,NB)

          CALL DGEMM_('T','N',NB,NB,NB,-One,VNATI(1+INV),NB,
     &             SANGTR,NB,Zero,SANGTI2,NB)
          CALL DGEMM_('T','N',NB,NB,NB,One,VNAT(1+INV),NB,
     &             SANGTI,NB,One,SANGTI,NB)

        ELSE IF(ITYPE.EQ.2.OR.ITYPE.EQ.4) THEN

          CALL DGEMM_('T','N',NB,NB,NB,One,SANGF,NB,
     &             VNAT(1+INV),NB,Zero,SANGTI,NB)
          CALL DGEMM_('T','N',NB,NB,NB,-One,SANGF,NB,
     &             VNATI(1+INV),NB,Zero,SANGTR,NB)

          CALL DGEMM_('T','N',NB,NB,NB,One,VNAT(1+INV),NB,
     &             SANGTR,NB,Zero,SANGTR2,NB)
          CALL DGEMM_('T','N',NB,NB,NB,One,VNATI(1+INV),NB,
     &             SANGTI,NB,One,SANGTR2,NB)

          CALL DGEMM_('T','N',NB,NB,NB,-One,VNATI(1+INV),NB,
     &             SANGTR,NB,Zero,SANGTI2,NB)
          CALL DGEMM_('T','N',NB,NB,NB,One,VNAT(1+INV),NB,
     &             SANGTI,NB,One,SANGTI2,NB)

        END IF

c Sum over the trace
        DO I = 1,NB
          IJ = I+(I-1)*NB-1
          SUM  = SUM  + OCC(I+INV2) * SANGTR2(1+IJ)
          SUMI = SUMI + OCC(I+INV2) * SANGTI2(1+IJ)
        END DO

        END IF

        INV=INV+NB**2
        INV2=INV2+NB

      END DO

        WRITE(u6,*) "Ben P TEST for JA:"
        WRITE(u6,*) "REAL: ",SUM
        WRITE(u6,*) "IMAG: ",SUMI

        CALL mma_deallocate(SANGF)
        CALL mma_deallocate(SANGTR)
        CALL mma_deallocate(SANGTI)
        CALL mma_deallocate(SANGTR2)
        CALL mma_deallocate(SANGTI2)
      END IF ! IPGLOB >= 4

      CALL mma_deallocate(SANG)

C WRITE OUT THIS SET OF NATURAL SPIN ORBITALS
C REAL PART
       IF(ITYPE.LE.2) THEN
         WRITE(KNUM,'(I2.2,A,I2.2,A,A)') ASS,".",BSS,".","R"
       ELSE
         WRITE(KNUM,'(I2.2,A,I2.2,A,A,A,A)')ASS,".",BSS,".",CDIR,".","R"
       END IF
       WRITE(FNUM,'(I8)') BSS
       FNUM=ADJUSTL(FNUM)
       IF (ASS.NE.BSS) THEN
         WRITE(XNUM,'(I8,A)') ASS,'_'//TRIM(FNUM)
         FNUM=ADJUSTL(XNUM)
       END IF
       IF (ITYPE.GT.2) FNUM=CDIR//TRIM(FNUM)

       FNAME=FILEBASE//'.'//TRIM(FNUM)//'.R'
       IF(ITYPE.EQ.1)
     &        WRITE(u6,'(A,A)')' NATURAL ORBITALS FOR ',KNUM
       IF(ITYPE.EQ.2)
     &        WRITE(u6,'(A,A)')' ANTISING NATURAL ORBITALS FOR  ',KNUM
       IF(ITYPE.EQ.3)
     &        WRITE(u6,'(A,A)')' NATURAL SPIN ORBITALS FOR  ',KNUM
       IF(ITYPE.EQ.4)
     &        WRITE(u6,'(A,A)')' ANTITRIP NATURAL ORBITALS FOR  ',KNUM

       WRITE(u6,'(A,A)') ' ORBITALS ARE WRITTEN ONTO FILE ',FNAME

        LuxxVec=50
        LuxxVec=isfreeunit(LuxxVec)

        CALL WRVEC(FNAME,LUXXVEC,'CO',NSYM,NBASF,NBASF,
     &             VNAT, OCC, Dummy, iDummy,
     &     '* DENSITY FOR PROPERTY TYPE ' // CHARTYPE // KNUM )

C IMAGINARY PART
       IF(ITYPE.LE.2) THEN
         WRITE(KNUM,'(I2.2,A,I2.2,A,A)') ASS,".",BSS,".","I"
       ELSE
         WRITE(KNUM,'(I2.2,A,I2.2,A,A,A,A)')ASS,".",BSS,".",CDIR,".","I"
       END IF

       FNAME=FILEBASE//'.'//TRIM(FNUM)//'.I'
       IF(ITYPE.EQ.1)
     &        WRITE(u6,'(A,A)')' NATURAL ORBITALS FOR ',KNUM
       IF(ITYPE.EQ.2)
     &        WRITE(u6,'(A,A)')' ANTISING NATURAL ORBITALS FOR  ',KNUM
       IF(ITYPE.EQ.3)
     &        WRITE(u6,'(A,A)')' NATURAL SPIN ORBITALS FOR  ',KNUM
       IF(ITYPE.EQ.4)
     &        WRITE(u6,'(A,A)')' ANTITRIP NATURAL ORBITALS FOR  ',KNUM

       WRITE(u6,'(A,A)') ' ORBITALS ARE WRITTEN ONTO FILE ',FNAME

        LuxxVec=50
        LuxxVec=isfreeunit(LuxxVec)

        CALL WRVEC(FNAME,LUXXVEC,'CO',NSYM,NBASF,NBASF,
     &             VNATI, OCC, Dummy, iDummy,
     &     '* DENSITY FOR PROPERTY TYPE ' // CHARTYPE // KNUM )

c       Test a few values
C        CALL ADD_INFO("SONATORB_CPLOTR", VNAT, 1, 4)
C        CALL ADD_INFO("SONATORB_CPLOTI", VNATI, 1, 4)
C        CALL ADD_INFO("SONATORB_CPLOTO", OCC, 1, 4)

      END DO

      CALL mma_deallocate(DMAT)
      CALL mma_deallocate(DMATI)
      CALL mma_deallocate(VEC)
      CALL mma_deallocate(VEC2)
      CALL mma_deallocate(VEC2I)
      CALL mma_deallocate(SCR)
      CALL mma_deallocate(SCRI)
      CALL mma_deallocate(VNAT)
      CALL mma_deallocate(VNATI)
      CALL mma_deallocate(OCC)

      END SUBROUTINE SONATORB_CPLOT




      SUBROUTINE CPLOT_DIAG(MATR, MATI, DIM, EIGVECR, EIGVECI)
      use definitions, only: iwp, wp, u6
      use constants, only: Zero
      IMPLICIT NONE
      INTEGER(KIND=IWP), INTENT(IN):: DIM
      REAL(KIND=WP), INTENT(INOUT):: MATR(DIM*(DIM+1)/2),
     &                               MATI(DIM*(DIM+1)/2)
      REAL(KIND=WP), INTENT(OUT):: EIGVECR(DIM,DIM),EIGVECI(DIM,DIM)

      REAL(KIND=WP) CEIGVAL(DIM)
      COMPLEX(KIND=WP) MATFULL((DIM*(DIM+1)/2))
      COMPLEX(KIND=WP) CEIGVEC(DIM,DIM)
      COMPLEX(KIND=WP) ZWORK(2*DIM-1)
      REAL(KIND=WP) RWORK(3*DIM-2)
      INTEGER(KIND=IWP) INFO, I, J

      DO J=1,(DIM*(DIM+1)/2)
          MATFULL(J) = CMPLX(MATR(J),MATI(J),kind=WP)
      END DO


      call zhpev_('V','U',DIM,MATFULL,CEIGVAL,
     &           CEIGVEC,DIM,ZWORK,RWORK,INFO)


      IF(INFO.NE.0) THEN
          WRITE(u6,*) "Error in diagonalization"
          WRITE(u6,*) "INFO: ",INFO
          CALL ABEND()
      END IF

      DO I=1,DIM
      DO J=1,DIM
          EIGVECR(I,J) = REAL(CEIGVEC(I,J))
          EIGVECI(I,J) = AIMAG(CEIGVEC(I,J))
      END DO
      END DO

      CALL DCOPY_(DIM*(DIM+1)/2,[Zero],0,MATR,1)
      CALL DCOPY_(DIM*(DIM+1)/2,[Zero],0,MATI,1)

      DO J=1,DIM
         MATR((J*(J-1)/2)+J) = CEIGVAL(J)
      END DO

      END SUBROUTINE CPLOT_DIAG

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine cvbnrm_cvb(cvb)

use casvb_global, only: nfrag, nvb, nvb_fr
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: cvb(nvb)
integer(kind=iwp) :: ifrag, nvbadd
real(kind=wp) :: f
real(kind=wp), external :: dnrm2_

if (nfrag <= 1) then
  f = One/dnrm2_(nvb,cvb,1)
  cvb(:) = f*cvb(:)
else
  nvbadd = 0
  do ifrag=1,nfrag
    f = One/dnrm2_(nvb_fr(ifrag),cvb(nvbadd+1:nvbadd+nvb_fr(ifrag)),1)
    cvb(nvbadd+1:nvbadd+nvb_fr(ifrag)) = f*cvb(nvbadd+1:nvbadd+nvb_fr(ifrag))
    nvbadd = nvbadd+nvb_fr(ifrag)
  end do
end if

return

end subroutine cvbnrm_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2002, Roland Lindh                                     *
!               2021, Jie J. Bao                                       *
!***********************************************************************

subroutine DrvDFTg(Grad,Temp,nGrad)
!***********************************************************************
!                                                                      *
! Object: driver for computation of gradient with respect to the DFT   *
!         energy.                                                      *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chem. Phys.                       *
!             University of Lund, SWEDEN                               *
!             August 2002                                              *
!             Jie Bao, Dept. of Chem.                                  *
!             University of Minnesota, US                              *
!             October 2021                                             *
!***********************************************************************

use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Para_Info, only: King
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6
use stdalloc, only: mma_allocate, mma_deallocate
use nq_Info, only: nAshT, Grid_Type, Moving_Grid

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Temp(nGrad)
#include "Molcas.fh"
#include "print.fh"
#include "rctfld.fh"
#include "disp.fh"
integer(kind=iwp) :: iDFT, iEnd, iI, iIrrep, IK, iOpt, iPrint, iRout, iSpin, jPrint, LuWr, nAct(nIrrep), nDens, ng1, ng2, nRoots
real(kind=wp) :: Dummy(1), ExFac, TCpu1, TCpu2, TWall1, TWall2
logical(kind=iwp) :: Do_Grad, l_casdft
character(len=80) :: Label
character(len=80) :: KSDFT
character(len=8) Method
character(len=4) :: DFTFOCK
real(kind=wp), allocatable :: Temp2(:), R(:), G1qs(:), G2qs(:), G1qt(:), G2qt(:), D1AOMS(:), D1SAOMS(:), D1AOt(:), D1SAOt(:)

!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TCpu1,TWall1)
!                                                                      *
!***********************************************************************
!                                                                      *
!...  Prologue
DFTFOCK = 'SCF '
iRout = 131
iPrint = nPrint(iRout)
LuWr = u6

nDens = 0
do iIrrep=0,nIrrep-1
  nDens = nDens+nBas(iIrrep)*(nBas(iIrrep)+1)/2
end do

!     D F T - g r a d i e n t                                          *
!***********************************************************************
!8)                                                                    *
!     D F T - g r a d i e n t

!call Get_iOption(iDFT)

call Get_cArray('DFT functional',KSDFT,80)
l_casdft = (KSDFT(1:2) == 'T:') .or. (KSDFT(1:3) == 'FT:')

if (l_casdft) then
  DFTFOCK = 'ROKS'
  call Get_iScalar('System BitSwitch',iOpt)
  iOpt = ibset(iOpt,6)
  call Put_iScalar('System BitSwitch',iOpt)
end if

call Get_iScalar('System BitSwitch',iDFT)
if (btest(iDFT,6)) then

  call StatusLine(' Alaska:',' Computing DFT gradients')

  call Get_cArray('DFT functional',KSDFT,80)
  ExFac = Zero ! Set to proper value at retrun!
  Do_Grad = .true.
  call Get_iScalar('Multiplicity',iSpin)
  !write(LuWr,*) 'DrvDFTg: KSDFT=',KSDFT
  !write(LuWr,*) 'DrvDFTg: ExFac=',ExFac
  call Get_cArray('Relax Method',Method,8)
  if (Method /= 'MSPDFT') then
    call DrvDFT(Dummy,nDens,KSDFT,ExFac,Do_Grad,Temp,nGrad,iSpin,DFTFOCK)
  else
    ! modifications for MS-PDFT gradient starting here
    call Get_iScalar('Number of roots',nRoots)
    call Get_iScalar('Relax CASSCF root',iI)
    call Get_iArray('nAsh',nAct,nIrrep)
    nasht = 0
    do iIrrep=1,nIrrep
      NASHT = NASHT+nAct(IIrrep)
    end do
    NG1 = NASHT*(NASHT+1)/2
    NG2 = NG1*(NG1+1)/2
    call mma_allocate(R,nRoots**2)
    call mma_allocate(Temp2,nGrad)
    call mma_allocate(G1qt,nG1)
    call mma_allocate(G2qt,nG2)
    call mma_allocate(G1qs,nG1*nRoots)
    call mma_allocate(G2qs,nG2*nRoots)
    call mma_allocate(D1AOMS,nDens*nRoots)
    call mma_allocate(D1AOt,nDens)
    if (iSpin /= 1) then
      call mma_allocate(D1SAOMS,nDens*nRoots)
      call mma_allocate(D1SAOt,nDens)
    end if
    call Get_DArray('MS_FINAL_ROT',R,nRoots**2)
    Temp(:) = Zero
    call Get_D1MO(G1qt,nG1)
    call Get_P2MO(G2qt,nG2)
    call Get_DArray('D1INTER',G1qs,ng1*nRoots)
    call Get_DArray('P2INTER',G2qs,ng2*nRoots)
    call Get_DArray('D1AO_MS',D1AOMS,nDens*nRoots)
    call Get_D1AO(D1AOt,nDens)
    if (iSpin /= 1) then
      call Get_DArray('D1SAO_MS',D1SAOMS,nDens*nRoots)
      call Get_D1SAO(D1SAOt,nDens)
    end if
    do IK=1,nRoots
      call Put_D1MO(G1qs((IK-1)*nG1+1),nG1)
      call Put_P2MO(G2qs((IK-1)*nG2+1),nG2)
      call Put_D1AO(D1AOMS((IK-1)*nDens+1),nDens)
      if (iSpin /= 1) then
        call Put_D1SAO(D1SAOMS((IK-1)*nDens+1),nDens)
      end if
      Temp2(:) = Zero
      call DrvDFT(Dummy,nDens,KSDFT,ExFac,Do_Grad,Temp2,nGrad,iSpin,DFTFOCK)
      jPrint = nPrint(112)
      if (jPrint >= 15) then
        Label = 'DFT Int Contribution'
        write(u6,*) 'state, coeff',IK,R((II-1)*nRoots+IK)
        call PrGrad(Label,Temp2,nGrad,ChDisp)
      end if
      call DAXPY_(nGrad,R((II-1)*nRoots+IK)**2,Temp2,1,Temp,1)
    end do
    call Put_D1MO(G1qt,nG1)
    call Put_P2MO(G2qt,nG2)
    call Put_D1AO(D1AOt,nDens)
    if (ISpin /= 1) call Put_D1SAO(D1SAOt,nDens)
    call mma_deallocate(R)
    call mma_deallocate(Temp2)
    call mma_deallocate(G1qt)
    call mma_deallocate(G2qt)
    call mma_deallocate(G1qs)
    call mma_deallocate(G2qs)
    call mma_deallocate(D1AOMS)
    call mma_deallocate(D1AOt)
    if (iSpin /= 1) then
      call mma_deallocate(D1SAOMS)
      call mma_deallocate(D1SAOt)
    end if
    ! End of condition for MS-PDFT gradient
  end if
  iEnd = 1
  do
    if (KSDFT(iEnd:iEnd) == ' ') then
      iEnd = iEnd-1
      exit
    else
      iEnd = iEnd+1
    end if
  end do
  Label = 'The DFT('//KSDFT(1:iEnd)//') contribution'
  jPrint = nPrint(112)
  !AMS
  !jPrint = 15
  if (jPrint >= 15) call PrGrad(Label,Temp,nGrad,ChDisp)
  if (king()) call DaXpY_(nGrad,One,Temp,1,Grad,1)
  if (iPrint >= 6) then
    write(LuWr,*)
    if (Grid_Type == Moving_Grid) then
      write(LuWr,*) 'DFT contribution computed for a moving grid.'
    else
      write(LuWr,*) 'DFT contribution computed for a fixed grid.'
    end if
    write(LuWr,*)
  end if

end if
!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TCpu2,TWall2)
call SavTim(5,TCpu2-TCpu1,TWall2-TWall1)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine DrvDFTg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C     Integer Function Set_CHO_ADRVEC(ii)
      Function Set_CHO_ADRVEC(ii)
#include "cholesky.fh"
      Integer Set_CHO_ADRVEC
*
      Set_CHO_ADRVEC=0
      If (ii.lt.0) Then
         Set_CHO_ADRVEC=CHO_ADRVEC
      Else If (ii.eq.1.or.ii.eq.2) Then
         CHO_ADRVEC=ii
         Set_CHO_ADRVEC=CHO_ADRVEC
      Else
         Call WarningMessage(2,'Set_CHO_ADRVEC: Illegal option')
         Write (6,*) 'ii=',ii
         Call Abend()
      End if
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RasRasTrans(nB,nStatePrim,Eig2,iPrint)

use qmstat_global, only: BigT, nState, RassiM
use Index_Functions, only: iTri, nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nB, nStatePrim, iPrint
real(kind=wp), intent(in) :: Eig2(nStatePrim,nStatePrim)
integer(kind=iwp) :: i, iB, iBas, iDisk, iiS, indx, indypop, iS, j, jB, jBas, jjS, jS, kaunt, kaunter, LuIn, MEMMAX, nSize, &
                     nSizeBig, nSizeBigPrim, nTriS, nTriSP
character(len=30) :: OutLine
integer(kind=iwp), allocatable :: iTocBig(:)
real(kind=wp), allocatable :: AOG(:), BigV(:,:), Int1(:), Int2(:), Snt1(:,:), Snt2(:,:), Snt3(:,:)
#include "warnings.h"

!Guten Tag.

write(u6,*) '     ----- Transform from non-orthogonal RASSCF states to orthogonal RASSI states.'

! Set zeros and decide if transformation is at all possible.

LuIn = 66
kaunt = 0
iDisk = 0
call DaName(LuIn,RassiM)
nTriSP = nTri_Elem(nStatePrim)
call mma_allocate(iTocBig,nTriSP,label='iTocBig')
call iDaFile(LuIn,2,iTocBig,nTriSP,iDisk)
nSize = nTri_Elem(nB)
nTriS = nTri_Elem(nState)
nSizeBig = nSize*nTriS
nSizeBigPrim = nSize*nTriSP
call mma_maxDBLE(MEMMAX)

if (MEMMAX <= nSizeBig) then
  ! This means that we do not have memory enough for TDM in contracted
  ! form. Then there is no use to proceed at all.

  write(u6,*)
  write(u6,*) 'The transition density matrix is too big to put in memory!'
  write(u6,*) 'Either,'
  write(u6,*) '       (1) increase MOLCAS_MEM,'
  write(u6,*) '       (2) contract number of states further.'
  call Quit(_RC_GENERAL_ERROR_)

else if (MEMMAX >= (nSizeBig+nSizeBigPrim+nTriSP+nTriS+nStatePrim**2+nState*nStatePrim+nState**2)) then
  ! Here we go if there is enough memory for an in core transformation.

  call mma_allocate(BigT,nSize,nTriS,label='ALLES')
  call mma_allocate(BigV,nSize,nTriSP,label='ALLESin')
  call mma_allocate(Int1,nTriSP,label='Int1')
  call mma_allocate(Int2,nTriS,label='Int2')
  call mma_allocate(Snt1,nStatePrim,nStatePrim,label='Square1')
  call mma_allocate(Snt2,nState,nStatePrim,label='Square2')
  call mma_allocate(Snt3,nState,nState,label='Square3')
  BigT(:,:) = Zero
  kaunt = 0
  do i=1,nStatePrim
    do j=1,i
      kaunt = kaunt+1
      iDisk = iTocBig(kaunt)
      call dDaFile(LuIn,2,BigV(:,kaunt),nSize,iDisk)
    end do
  end do

  ! A lot of printing of TDM if requested.

  if (iPrint >= 25) then
    kaunt = 0
    do i=1,nStatePrim
      do j=1,i
        kaunt = kaunt+1
        write(OutLine,'(A,I3,I3)') 'TDM, Piece ',i,j
        call TriPrt(OutLine,' ',BigV(:,kaunt),nB)
      end do
    end do
  end if

  ! Proceed with transformation.

  kaunt = 0
  do iBas=1,nB
    do jBas=1,iBas
      kaunt = kaunt+1
      Int1(:) = BigV(kaunt,:)
      call Square(Int1,Snt1,1,nStatePrim,nStatePrim)
      call Dgemm_('T','N',nState,nStatePrim,nStatePrim,One,Eig2,nStatePrim,Snt1,nStatePrim,Zero,Snt2,nState)
      call Dgemm_('N','N',nState,nState,nStatePrim,One,Snt2,nState,Eig2,nStatePrim,Zero,Snt3,nState)
      call SqToTri_Q(Snt3,Int2,nState)
      BigT(kaunt,:) = Int2
    end do
  end do
  call mma_deallocate(BigV)
  call mma_deallocate(Int1)
  call mma_deallocate(Int2)
  call mma_deallocate(Snt1)
  call mma_deallocate(Snt2)
  call mma_deallocate(Snt3)

else
  ! Here we go if both TDM's can not be put in memory. Might be a bit
  ! slow due to its nested nature with repeated IO.

  call mma_allocate(BigT,nSize,nTriS,label='ALLES')
  call mma_allocate(AOG,nSize,label='AOGamma')
  BigT(:,:) = Zero
  do iiS=1,nStatePrim
    do jjS=1,nStatePrim
      indypop = iTri(iiS,jjS)
      iDisk = iTocBig(indypop)
      call dDaFile(LuIn,2,AOG,nSize,iDisk)
      kaunter = 0
      do iB=1,nB
        do jB=1,iB
          kaunter = kaunter+1
          do iS=1,nState
            do jS=1,iS
              indx = iTri(iS,jS)
              BigT(kaunter,indx) = BigT(kaunter,indx)+Eig2(iiS,iS)*Eig2(jjS,jS)*AOG(kaunter)
            end do
          end do
        end do
      end do
    end do
  end do
  call mma_deallocate(AOG)
end if

! Deallocations and finish up.

call mma_deallocate(iTocBig)
call DaClos(LuIn)

return

end subroutine RasRasTrans

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010,2012, Thomas Bondo Pedersen                       *
************************************************************************
      Subroutine LDF_SetAtomPairInfo(useUnique,Verbose,irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: Set atom pair info in ldf_atom_pair_info.fh
C
C     Return codes:
C       irc=0: success
C       irc=1: already set
C       irc=2: an error occurred
C
C     -----
C     NOTES
C     -----
C
C     Thomas Bondo Pedersen, February 2012:
C     useUnique introduced:
C     Unique mapping should be disabled, useUnique=.False.; a warning
C     message is printed if not.
C     This implies that unique atom pairs are disabled.
C     The problem is that linear dependencies and 2C
C     functions are not handled correctly. In particular, linear
C     dependency arrays point to the parent atom and through that the
C     absolute shell - which is obviously wrong for a duplicate pair.
C     TODO/FIXME: fix index arrays for duplicate pairs and turn unique
C     atoms and atom pairs back on. This should be done at the end of
C     the LDF where the information is set for the non-unique pairs.
C
      Implicit None
      Logical useUnique
      Logical Verbose
      Integer irc
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

      Character*19 SecNam
      Parameter (SecNam='LDF_SetAtomPairInfo')

      Integer iAtomPair
      Integer ip0

      Logical FirstCall
      Save FirstCall
      Data FirstCall /.True./

      ! Init return code
      irc=0

      ! If already set, print warning message and return
      If (FirstCall) Then
         FirstCall=.False.
      Else
         If (LDF_AtomPairInfo_Status.eq.LDF_AtomPairInfo_Set) Then
            If (Verbose) Then
               Call WarningMessage(1,
     &                        SecNam//'LDF Atom Pair Info already set!')
            End If
            irc=1
            Return
         End If
      End If

      ! Find significant atom pairs.
      Call LDF_FindSignificantAtomPairs(irc)
      If (irc.ne.0) Then
         If (Verbose) Then
            Write(6,'(A,A,I8)')
     &      SecNam,': LDF_FindSignificantAtomPairs returned code',irc
         End If
         LDF_AtomPairInfo_Status=LDF_AtomPairInfo_Unset
         irc=2
         Return
      End If

      ! Allocate and get unique significant atom pairs
      l_AP_Unique=NumberOfAtomPairs
      Call GetMem('AP_Unique','Allo','Inte',ip_AP_Unique,l_AP_Unique)
      If (useUnique) Then
         ! tbp: see note above
         Call WarningMessage(1,SecNam//
     &': WARNING: setting unique atom pair list; this may cause errors')
         Call xFlush(6)
         Call LDF_GetAtomPairToUniqueAtomPairMap(iWork(ip_AP_Unique),
     &                                           l_AP_Unique)
      Else
         ! tbp: make unique list a trivial mapping => no duplicate atom
         ! pairs.
         ip0=ip_AP_Unique-1
         Do iAtomPair=1,NumberOfAtomPairs
            iWork(ip0+iAtomPair)=iAtomPair
         End Do
      End If

      ! Allocate and initialize disk addresses for C
      l_AP_DiskC=NUmberOfAtomPairs
      Call GetMem('AP_DiskC','Allo','Inte',ip_AP_DiskC,l_AP_DiskC)
      Do iAtomPair=0,NumberOfAtomPairs-1
         iWork(ip_AP_DiskC+iAtomPair)=-1
      End Do

      ! Mark info set
      LDF_AtomPairInfo_Status=LDF_AtomPairInfo_Set

      ! Print
      If (Verbose) Then
         Call LDF_PrintAtomPairInfo()
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Francesco Aquilante                              *
!***********************************************************************

subroutine DM_FNO_RHF(irc,nSym,nBas,nFro,nIsh,nSsh,nDel,CMOI,EOcc,EVir,DM0,DM)
!***********************************************************************
!                                                                      *
!     Purpose:  setup of FNO density matrix calculation (RHF-based)    *
!                                                                      *
!     Author:   F. Aquilante  (Geneva, Sep 2010)                       *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use ChoMP2, only: MP2_small
use Molcas, only: MxBas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: iRC
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nFro(nSym), nIsh(nSym), nSsh(nSym), nDel(nSym)
real(kind=wp), intent(in) :: CMOI(*), EOcc(*), EVir(*)
real(kind=wp), intent(_OUT_) :: DM0(*), DM(*)
integer(kind=iwp) :: i, ifr, ioff, iSkip, iSym, iTo, j, jD, jOcc, jOff, jp, jTo, jVir, kDM, kfr, kij, kOff, kTo, lij, lnDel(8), &
                     lnFro(8), lnOcc(8), lnOrb(8), lnVir(8), lOff, nBasT, nBmx, nCMO, nOA, nOkk, nOrb, nSQ, nTri, nVV
real(kind=wp) :: Dummy, SqOcc, tmp
real(kind=wp), allocatable :: CMO(:,:), DMAT(:), EOrb(:,:)

irc = 0
MP2_small = .false.

!----------------------------------------------------------------------*
!     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
!----------------------------------------------------------------------*

nBasT = 0
ntri = 0
nSQ = 0
nBmx = 0
nOrb = 0
nVV = 0
do i=1,nSym
  nBasT = nBasT+nBas(i)
  nOrb = nOrb+nFro(i)+nIsh(i)+nSsh(i)+nDel(i)
  ntri = ntri+nTri_Elem(nBas(i))
  nSQ = nSQ+nBas(i)**2
  nVV = nVV+nSsh(i)**2
  nBmx = max(nBmx,nBas(i))
end do
if (nBasT > mxBas) then
  write(u6,'(/6X,A)') 'The number of basis functions exceeds the present limit'
  call Abend()
end if

NCMO = nSQ
call mma_allocate(CMO,nCMO,2,Label='CMO')
CMO(:,1) = CMOI(1:nCMO)

nOA = 0
do iSym=1,nSym  ! setup info
  lnFro(iSym) = nFro(iSym)
  lnOcc(iSym) = nIsh(iSym)
  nOA = nOA+lnOcc(iSym)
  lnVir(iSym) = nSsh(iSym)
  lnOrb(iSym) = lnOcc(iSym)+lnVir(iSym)
  lnDel(iSym) = nDel(iSym)
end do

call mma_Allocate(EOrb,nOrb,4,Label='EOrb')
jOff = 0
kOff = 0
lOff = 0
do iSym=1,nSym
  jp = 1+lOff+nFro(iSym)
  jOcc = jOff+1
  EOrb(jp:jp+nIsh(iSym)-1,1) = EOcc(jOcc:jOcc+nIsh(iSym)-1)
  jVir = kOff+1
  jp = jp+nIsh(iSym)
  EOrb(jp:jp+nSsh(iSym)-1,1) = EVir(jVir:jVir+nSsh(iSym)-1)
  jOff = jOff+nIsh(iSym)
  kOff = kOff+nSsh(iSym)
  lOff = lOff+nBas(iSym)
end do
ioff = 0
joff = 0
koff = 0
do iSym=1,nSym
  ifr = 1+ioff+nFro(iSym)
  ito = 1+joff
  EOrb(ito:ito+nIsh(iSym)-1,3) = EOrb(ifr:ifr+nIsh(iSym)-1,1)
  ifr = 1+ioff+nFro(iSym)+nIsh(iSym)
  ito = 1+koff
  EOrb(ito:ito+nSsh(iSym)-1,4) = EOrb(ifr:ifr+nSsh(iSym)-1,1)
  ioff = ioff+nBas(iSym)
  joff = joff+nIsh(iSym)
  koff = koff+nSsh(iSym)
end do
call mma_Allocate(DMAT,nVV+nOA,Label='DMAT')
DMAT(:) = Zero

call FnoSCF_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir)

CMO(:,2) = Zero
iOff = 0
do iSym=1,nSym
  kfr = 1+iOff+nBas(iSym)*nFro(iSym)
  kto = 1+iOff+nBas(iSym)*lnFro(iSym)
  CMO(kto:kto+nBas(iSym)*lnOcc(iSym)-1,2) = CMO(kfr:kfr+nBas(iSym)*lnOcc(iSym)-1,1)
  kfr = 1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
  kto = kto+nBas(iSym)*lnOcc(iSym)
  CMO(kto:kto+nBas(iSym)*lnVir(iSym)-1,2) = CMO(kfr:kfr+nBas(iSym)*lnVir(iSym)-1,1)
  iOff = iOff+nBas(iSym)**2
end do
call Check_Amp_SCF(nSym,lnOcc,lnVir,iSkip)
if (iSkip > 0) then
  call ChoMP2_Drv(irc,Dummy,CMO(:,2),EOrb(:,3),EOrb(:,4),DMAT(1:nVV),DMAT(nVV+1:))
  if (irc /= 0) then
    write(u6,*) 'MP2 pseudodensity calculation failed !'
    call Abend()
  end if
else
  write(u6,*)
  write(u6,*) 'There are ZERO amplitudes T(ai,bj) with the given '
  write(u6,*) 'combinations of inactive and virtual orbitals !! '
  write(u6,*) 'Check your input and rerun the calculation! Bye!!'
  call Abend()
end if

! Compute the correlated density in AO basis
! -------------------------------------------------------------
jOcc = 1+nVV
!write(u6,*) ' Occ    : ',(DMAT(jOcc+j),j=0,nOA-1)
!write(u6,*) ' Sum    : ',ddot_(nOA,One,0,DMAT(jOcc),1)
DMAT(jOcc:jOcc+nOA-1) = Two*DMAT(jOcc:jOcc+nOA-1)+One

iOff = 0
jOff = 0
kDM = 1
do iSym=1,nSym

  kto = 1+jOff
  nOkk = nFro(iSym)+nIsh(iSym)
  call DGEMM_Tri('N','T',nBas(iSym),nBas(iSym),nOkk, &
                 Two,CMO(kto,1),nBas(iSym), &
                 CMO(kto,1),nBas(iSym), &
                 Zero,DM0(kDM),nBas(iSym))

  sqocc = sqrt(Two)
  CMO(kto:kto+nBas(iSym)*nFro(iSym)-1,1) = sqocc*CMO(kto:kto+nBas(iSym)*nFro(iSym)-1,1)
  do j=0,nIsh(iSym)-1
    sqocc = sqrt(DMAT(jOcc+j))
    ito = kto+nBas(iSym)*j
    CMO(ito:ito+nBas(iSym)-1,1) = sqocc*CMO(ito:ito+nBas(iSym)-1,1)
  end do
  call DGEMM_Tri('N','T',nBas(iSym),nBas(iSym),nOkk, &
                 One,CMO(kto,1),nBas(iSym), &
                 CMO(kto,1),nBas(iSym), &
                 Zero,DM(kDM),nBas(iSym))

  if (nSsh(iSym) > 0) then
    jD = 1+iOff
    ! Eigenvectors will be in increasing order of eigenvalues
    call Eigen_Molcas(nSsh(iSym),DMAT(jD),EOrb(:,2),Eorb(:,1))
    ! Reorder to get relevant eigenpairs first
    do j=1,nSsh(iSym)/2
      do i=1,nSsh(iSym)
        lij = jD-1+nSsh(iSym)*(j-1)+i
        kij = jD-1+nSsh(iSym)**2-(nSsh(iSym)*j-i)
        tmp = DMAT(lij)
        DMAT(lij) = DMAT(kij)
        DMAT(kij) = tmp
      end do
      tmp = EOrb(j,2)
      EOrb(j,2) = EOrb(nSsh(iSym)-j,2)
      EOrb(nSsh(iSym)-j,2) = tmp
    end do

    ! Compute new MO coeff. : X=C*U
    kfr = 1+jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
    kto = 1+jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
    call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym), &
                One,CMO(kfr,2),nBas(iSym), &
                DMAT(jD),nSsh(iSym), &
                Zero,CMO(kto,1),nBas(iSym))

    !write(u6,*) ' Occ_vir: ',(EOrb(j,2),j=1,nSsh(iSym))
    !write(u6,*) ' Sum_vir: ',ddot_(nSsh(iSym),One,0,EOrb(:,2),1)
    do j=0,nSsh(iSym)-1
      sqocc = sqrt(Two*EOrb(1+j,2))
      jto = kto+nBas(iSym)*j
      CMO(jto:jto+nBas(iSym)-1,1) = sqocc*CMO(jto:jto+nBas(iSym)-1,1)
    end do
    call DGEMM_Tri('N','T',nBas(iSym),nBas(iSym),nSsh(iSym), &
                   One,CMO(kto,1),nBas(iSym), &
                   CMO(kto,1),nBas(iSym), &
                   One,DM(kDM),nBas(iSym))

    iOff = iOff+nSsh(iSym)**2
  end if
  jOff = jOff+nBas(iSym)**2
  kDM = kDM+nTri_Elem(nBas(iSym))
  jOcc = jOcc+nIsh(iSym)
end do

call mma_deAllocate(EOrb)
call mma_deAllocate(DMAT)
call mma_deallocate(CMO)

return

end subroutine DM_FNO_RHF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
*               Francesco Aquilante                                    *
************************************************************************
*  Cho_X_CheckDiag
*
*> @brief
*>   Check diagonal
*> @author Thomas Bondo Pedersen
*> @modified_by F. Aquilante (add ::OneCenter_ChkDiag)
*> @modified_by T.B. Pedersen (If ``(Cho_1Center)``: \p Err only contains 1-center errors on exit)
*>
*> @details
*> This routine reads and analyzes (histogram and statistics)
*> the exact integral diagonal, computes and analyzes the
*> diagonal from Cholesky vectors,
*> and the difference between the two (exact minus Cholesky).
*>
*> The statistics printed are: minimum value, maximum
*> value, mean value, mean absolute value, variance (wrt mean
*> value), and standard deviation (wrt mean value).
*>
*> On exit:
*>
*> - \p Err(1) = min error
*> - \p Err(2) = max error
*> - \p Err(3) = average error
*> - \p Err(4) = RMS error
*>
*> Return code is ``0`` if successful execution. If \p irc is non-zero,
*> the contents or \p Err are ill-defined.
*> Results will only be printed to output if \c iPrint is ``-5`` or
*> greater (\c iPrint stored in choprint.inc).
*>
*> @param[out] irc Return code
*> @param[out] Err min, max, average, and RMS error
************************************************************************
      SubRoutine Cho_X_CheckDiag(irc,Err)
      Implicit None
      Integer irc
      Real*8  Err(4)
#include "cholesky.fh"
#include "choprint.fh"
#include "stdalloc.fh"

      Character(LEN=15), Parameter:: SecNam = 'Cho_X_CheckDiag'

      Integer iPrThr
      Parameter (iPrThr=-5)

      Real*8   dDot_
      external ddot_

      Integer i
      Real*8, Allocatable::  XD(:), CD(:), Bin(:), Stat(:)

C     Set return code.
C     ----------------

      irc = 0
      If (nnBstRT(1) .lt. 1) Then
         Call FZero(Err,4)
         Return
      End If

C     Allocations.
C     ------------

      Call mma_allocate(XD,nnBstRT(1),Label='XD')
      Call mma_allocate(CD,nnBstRT(1),Label='CD')
      Call mma_allocate(Bin,16,Label='Bin')
      Call mma_allocate(Stat,7,Label='Stat')

C     Set bins for histograms.
C     ------------------------

      Bin(1) = 1.0d0
      Do i = 1,SIZE(Bin)-1
         Bin(1+i) = Bin(i)*1.0d-1
      End Do

C     Read exact diagonal.
C     --------------------

      Call Cho_IODiag(XD,2)

C     Print histogram of exact diagonal and get statistics.
C     -----------------------------------------------------

      If (iPrint.ge.iPrThr) Then
         Call Cho_Head('Analysis of Exact Integral Diagonal','=',80,6)
         Call Cho_AnaSize(XD,SIZE(XD),Bin,SIZE(Bin),6)
         Call Statistics(XD,SIZE(XD),Stat,1,2,3,4,5,6,7)
         Call Cho_PrtSt(XD,SIZE(XD),Stat)
      End If

C     Calculate Cholesky diagonal.
C     ----------------------------

      Call Cho_X_CalcChoDiag(irc,CD)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_X_CalcChoDiag returned ',irc
         Go To 1 ! return after dealloc
      End If

C     Print histogram of Cholesky diagonal and get statistics.
C     --------------------------------------------------------

      If (iPrint.ge.iPrThr) Then
         Call Cho_Head('Analysis of Cholesky Integral Diagonal','=',80,
     &                 6)
         Call Cho_AnaSize(CD,SIZE(CD),Bin,SIZE(Bin),6)
         Call Statistics(CD,SIZE(CD),Stat,1,2,3,4,5,6,7)
         Call Cho_PrtSt(CD,SIZE(CD),Stat)
      End If

C     Subtract Cholesky diagonal from exact diagonal.
C     -----------------------------------------------

      Call dAXPY_(nnBstRT(1),-1.0d0,CD,1,XD,1)

C     Print histogram of difference array and get statistics.
C     -------------------------------------------------------

      If (iPrint.ge.iPrThr) Then
         Call Cho_Head('Analysis of Difference (Exact-Cholesky)','=',80,
     &                 6)
         Call Cho_AnaSize(XD,SIZE(XD),Bin,SIZE(Bin),6)
      End If
      Call Statistics(XD,SIZE(XD),Stat,1,2,3,4,5,6,7)
      If (iPrint.ge.iPrThr) Then
         Call Cho_PrtSt(XD,SIZE(XD),Stat)
      End If

C     Set Err array.
C     --------------

      Err(1) = Stat(3)
      Err(2) = Stat(4)
      Err(3) = Stat(1)
      Err(4) = sqrt(dDot_(nnBstRT(1),XD,1,XD,1)/dble(nnBstRT(1)))

      If (iPrint.ge.iPrThr) Then
         Write(6,'(/,1X,A,1P,D15.6)')
     &   'Minimum error   : ',Err(1)
         Write(6,'(1X,A,1P,D15.6)')
     &   'Maximum error   : ',Err(2)
         Write(6,'(1X,A,1P,D15.6)')
     &   'Average error   : ',Err(3)
         Write(6,'(1X,A,1P,D15.6)')
     &   'RMS error       : ',Err(4)
      End If

C     Error analysis for the 1-center diagonals only.
C     If this is a one-center calculation, use statistics from 1-center
C     diagonals only as elements of Err array.
C     -----------------------------------------------------------------

      If (nSym.eq.1) Then
         Call OneCenter_ChkDiag(XD,SIZE(XD),Stat,iPrint.ge.iPrThr)
         If (Cho_1Center) Then
            Err(1) = Stat(3)
            Err(2) = Stat(4)
            Err(3) = Stat(1)
            Err(4) = sqrt(dDot_(nnBstRT(1),XD,1,XD,1)/dble(nnBstRT(1)))
         End If
      End If

C     Deallocations.
C     --------------

    1 Continue
      Call mma_deallocate(Stat)
      Call mma_deallocate(Bin)
      Call mma_deallocate(CD)
      Call mma_deallocate(XD)

      End
      SubRoutine Cho_PrtSt(Vec,lVec,Stat)
      Implicit None
      Integer lVec
      Real*8  Vec(lVec)
      Real*8  Stat(7)

      Real*8   dDot_
      external ddot_

      Write(6,'(/,1X,A,I15)')
     & 'No. of elements: ',lVec
      Write(6,'(1X,A,1P,D15.6)')
     & 'Frobenius norm : ',sqrt(dDot_(lVec,Vec,1,Vec,1))
      Write(6,'(1X,A,1P,D15.6)')
     & 'Minimum value  : ',Stat(3)
      Write(6,'(1X,A,1P,D15.6)')
     & 'Maximum value  : ',Stat(4)
      Write(6,'(1X,A,1P,D15.6)')
     & 'Mean value     : ',Stat(1)
      Write(6,'(1X,A,1P,D15.6)')
     & 'Mean abs. value: ',Stat(2)
      Write(6,'(1X,A,1P,D15.6)')
     & 'Max. abs. value: ',Stat(5)
      Write(6,'(1X,A,1P,D15.6)')
     & 'Biased variance: ',Stat(6)
      Write(6,'(1X,A,1P,D15.6,A)')
     & 'Standard dev.  : ',Stat(7),' (unbiased variance)'

      End
      Subroutine OneCenter_ChkDiag(Diag,l_D,Stat,DoPrint)
      use ChoArr, only: iRS2F
      Implicit Real*8 (a-h,o-z)
      Real*8 Diag(l_D), Stat(7)
      Logical DoPrint
#include "Molcas.fh"
#include "cholesky.fh"
#include "choorb.fh"
      Character*(LENIN8)  Name(maxbfn)
      Character*(LENIN)  ctmp1, ctmp2
      Real*8 Err(4)

      Call Get_cArray('Unique Basis Names',Name,LENIN8*nBasT)

      Do krs=1,nnBstRT(1)
         ia = iRS2F(1,krs)
         ctmp1=Name(ia)(1:LENIN)
         ib = iRS2F(2,krs)
         ctmp2=Name(ib)(1:LENIN)
         If (ctmp1.ne.ctmp2) Diag(krs)=0.0d0
      End Do

      If (DoPrint) Then
         Call Cho_Head('Analysis of Difference (1-Center only)','=',80,
     &                 6)
      End If
      Call Statistics(Diag,l_D,Stat,1,2,3,4,5,6,7)
      If (DoPrint) Then
         Call Cho_PrtSt(Diag,l_D,Stat)
      End If

C     Set Err array.
C     --------------

      Err(1) = Stat(3)
      Err(2) = Stat(4)
      Err(3) = Stat(1)
      Err(4) = sqrt(dDot_(nnBstRT(1),Diag,1,
     &                              Diag,1)/dble(nnBstRT(1)))

      If (DoPrint) Then
         Write(6,'(/,1X,A,1P,D15.6)')
     &   'Minimum error   : ',Err(1)
         Write(6,'(1X,A,1P,D15.6)')
     &   'Maximum error   : ',Err(2)
         Write(6,'(1X,A,1P,D15.6)')
     &   'Average error   : ',Err(3)
         Write(6,'(1X,A,1P,D15.6)')
     &   'RMS error       : ',Err(4)
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Get_AnalHess
*
*> @brief
*>   Read the the symmetry blocked nuclear Hessian from the runfile and return a
*>   pointer to the array's location in \c Work and the length of the array
*> @author R. Lindh
*>
*> @details
*> The utility will read the symmetry blocked nuclear Hessian from the runfile and
*> return a pointer and the length of the array.
*>
*> @param[out] ipAnalHess pointer to array with the symmetry blocked nuclear Hessian
*>                        in Cartesian coordinates
*> @param[out] nAnalHess  size of the array of the symmetry blocked nuclear Hessian
************************************************************************
      Subroutine Get_AnalHess(ipAnalHess,nAnalHess)
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"

      Character*24 Label
      Logical      Found

      Label='Analytic Hessian'
      Call qpg_dArray(Label,Found,nAnalHess)
      If(.not.Found .or. nAnalHess.eq.0) Return
      Call GetMem('AnalHess','Allo','Real',ipAnalHess,nAnalHess)
      Call Get_dArray(Label,Work(ipAnalHess),nAnalHess)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Pickmo_td(rmo,rmoaa,idsym)
      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
      real*8 rmo(*),rmoaa(*)
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      If (.not.timedep) Then
      Do iS=1,nSym
       Do jS=1,iS
        Do kS=1,is
         ls=ieor(iEor(is-1,js-1),iEor(ks-1,idsym-1))+1
         If (ls.le.ks) Then
          Do iA=1,nAsh(is)
           iAA=iA+nA(is)
           Do jA=1,nAsh(js)
            jAA=jA+nA(js)
            ijAA=itri(iAA,jAA)
            Do kA=1,nAsh(ks)
             kAA=kA+nA(ks)
             Do lA=1,nAsh(ls)
              lAA=lA+nA(ls)
              klAA=iTri(kAA,lAA)
              If (ijAA.ge.klAA) Then
               ijkl=iTri(ijAA,klAA)
               ipi=ipMO(js,ks,ls)+nIsh(is)+iA-1+
     &          nBas(is)*(jA-1)+nBas(is)*nAsh(js)*
     6          (kA-1)+nBas(is)*nAsh(js)*nAsh(ks)*(lA-1)
*              ipi=ipMO(js,ks,ls)+
*    &          (nBas(is)*(jA-1+nAsh(js)*
*    6          (kA-1+nAsh(ks)*(lA-1))))+nish(is)+iA-1
               rmoaa(ijkl)=rmo(ipi)
              End If
             End Do
            End Do
           End Do
          End Do
         End If
        End Do
       End Do
      End Do
      Else
      Do iS=1,nSym
       Do jS=1,nsym
        Do kS=1,nsym
         ls=ieor(iEor(is-1,js-1),iEor(ks-1,idsym-1))+1
          Do iA=1,nAsh(is)
           iAA=iA+nA(is)
           Do jA=1,nAsh(js)
            jAA=jA+nA(js)
            ijAA=iAA+(jaa-1)*ntash
            Do kA=1,nAsh(ks)
             kAA=kA+nA(ks)
             Do lA=1,nAsh(ls)
              lAA=lA+nA(ls)
              klAA=kAA+(laa-1)*ntash
              If (ijAA.ge.klAA) Then
               ijkl=iTri(ijAA,klAA)
               ipi=ipMO(js,ks,ls)+nIsh(is)+iA-1+
     &          nBas(is)*(jA-1)+nBas(is)*nAsh(js)*
     6          (kA-1)+nBas(is)*nAsh(js)*nAsh(ks)*(lA-1)
*              ipi=ipMO(js,ks,ls)+
*    &          (nBas(is)*(jA-1+nAsh(js)*
*    6          (kA-1+nAsh(ks)*(lA-1))))+nish(is)+iA-1
               rmoaa(ijkl)=rmo(ipi)
              End If
             End Do
            End Do
           End Do
          End Do
        End Do
       End Do
      End Do
      End IF
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine input2_cvb(
     >  iorbrel,mxdimrel,ifxorb,
     >  iorts,irots,izeta,orbs,irdorbs)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "inpmod_cvb.fh"
#include "spinb_cvb.fh"
#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension iorbrel(mxdimrel),ifxorb(mxorb)
      dimension iorts(2,*),irots(2,*),izeta(*)
      dimension orbs(mxaobf,mxorb),irdorbs(mxorb)

      ibase = mstacki_cvb(0)
      ip_iconfs = mheapiz_cvb(0)
      ip_cvb = mheaprz_cvb(0)
      ip_symelm = mheaprz_cvb(0)
      ifxstr = mheapiz_cvb(0)
      idelstr = mheapiz_cvb(0)
      noe=2*mxorb

      call hini_cvb()

      call defs_cvb()
      call casinfodef_cvb()

c  Counters
      nconf=0
      nvbinp=0
      nsyme=0
      norbrel=0
      ndimrel=0
      nijrel=0
      nfxorb=0
      nfxvb=0
      nzrvb=0
      nort=0
      ndrot=0
      lfxvb=0
      lzrvb=0
      call maxdims0_cvb()
      call izero(ifxorb,mxorb)
      call izero(izeta,mxsyme)
      call fraginit_cvb()

      call input3_cvb(
     >  iorbrel,mxdimrel,ifxorb,ifxstr,
     >  idelstr,iorts,irots,izeta,
     >  ip_iconfs,orbs,irdorbs,ip_cvb,ip_symelm,kbasiscvb_inp)

      if(inputmode.eq.2)then
c  Input parsing complete for this step ...
c  ... Work out NORB, NEL, S ...
        noe1=noe
        call casinfoset_cvb()
c  ... Do ICONFS before others to get NVB and related info ...
        do 100 iconf=1,nconf
        call imove_cvb(iwork((iconf-1)*noe1+ip_iconfs),
     >    iwork((iconf-1)*noe+ip_iconfs),noe)
100     continue
        call mrealloci_cvb(ip_iconfs,noe*nconf)

        if(nfrag.le.1)then
          nMs_fr(1)=1
          nalf_fr(1,1)=nalf
          nbet_fr(1,1)=nbet
        else
          do ifrag=1,nfrag
          nMs_fr(ifrag)=1
          nalf_fr(1,ifrag)=(nel_fr(ifrag)+i2s_fr(1,ifrag))/2
          nbet_fr(1,ifrag)=nel_fr(ifrag)-nalf_fr(1,ifrag)
          enddo
        endif
        if(nfrag.eq.0)then
          nfrag=1
          nel_fr(1)=nel
          nconf_fr(1)=nconf
          nS_fr(1)=1
          i2s_fr(1,1)=nalf-nbet
        endif
        do ifrag=1,nfrag
        if(nS_fr(ifrag).eq.0)then
          nS_fr(ifrag)=1
          i2s_fr(1,ifrag)=nalf-nbet
        endif
        enddo
        iconf_add=0
        do 1001 ifrag=1,nfrag
        if(nel_fr(ifrag).eq.0)then
          nel_fr(ifrag)=nel
          nalf_fr(1,ifrag)=nalf
          nbet_fr(1,ifrag)=nbet
        endif
        if(nS_fr(ifrag).eq.0)then
          nS_fr(ifrag)=1
          i2s_fr(1,ifrag)=nalf-nbet
        endif
        if(nconf_fr(ifrag).eq.0)then
          nconf=nconf+1
          nconf_fr(ifrag)=1
          call mrealloci_cvb(ip_iconfs,noe*nconf)
          do jconf=nconf,iconf_add+2,-1
          call imove_cvb(iwork((jconf-2)*noe+ip_iconfs),
     >      iwork((jconf-1)*noe+ip_iconfs),noe)
          enddo
          call izero(iwork(iconf_add*noe+ip_iconfs),noe)
          do 1201 i=1,min(nel_fr(ifrag),norb)
          iwork(i+iconf_add*noe+ip_iconfs-1)=1
1201      continue
          do 1301 i=1,nel_fr(ifrag)-norb
          iwork(i+iconf_add*noe+ip_iconfs-1)=2
1301      continue
        endif
        call cnfcheck_cvb(iwork(iconf_add*noe+ip_iconfs),
     >    nconf_fr(ifrag),
     >    nel_fr(ifrag))
        call cnfini_cvb(iwork(iconf_add*noe+ip_iconfs),nconf_fr(ifrag),
     >    nel_fr(ifrag),
     >    nS_fr(ifrag),i2s_fr(1,ifrag),
     >    nMs_fr(ifrag),nalf_fr(1,ifrag),nbet_fr(1,ifrag),
     >    nvbr_fr(ifrag),ndetvb_fr(ifrag),ndetvb2_fr(ifrag),
     >    mnion_fr(ifrag),mxion_fr(ifrag),nconfion_fr(0,ifrag),ifsc)
        iconf_add=iconf_add+nconf_fr(ifrag)
1001    continue
        ndetvb=0
        ndetvb2=0
        nvbr=0
        nelcheck=0
        do i=1,nfrag
        ndetvb=ndetvb+ndetvb_fr(i)
        ndetvb2=ndetvb2+ndetvb2_fr(i)
        nvbr=nvbr+nvbr_fr(i)
        nelcheck=nelcheck+nel_fr(i)
        enddo
        if(nelcheck.ne.nel)then
          write(6,*)' Error: total number of electrons in fragment ',
     >      'wavefunctions :',nelcheck,
     >      ' not equal to number of electrons ',nel
          call abend_cvb()
        endif
        sc=(nfrag.eq.1.and.ifsc.eq.1)
c  Set absym and use just lowest spin value if spinbas=determinants :
        absym(1)=(nalf.eq.nbet)
        do ifrag=1,nfrag
        i2s_min=nel_fr(ifrag)
        do iS=1,nS_fr(ifrag)
        if(i2s_fr(iS,ifrag).ne.0)absym(1)=.false.
        enddo
        if(kbasis.eq.6)then
          nS_fr(ifrag)=1
          i2s_fr(1,ifrag)=i2s_min
        endif
        enddo
        do i=2,5
        absym(i)=absym(1)
        enddo
        nvb=nvb_cvb(kbasis)
        mnion=mnion_fr(1)
        mxion=mxion_fr(1)
        do i=2,nfrag
        mnion=min(mnion,mnion_fr(i))
        mxion=max(mxion,mxion_fr(i))
        enddo
c  ... Now remaining quantities that depend on NORB or NVB ...
c  SYMELM
        ip_from=ip_symelm
        ip_to=ip_symelm
        do 400 isyme=1,nsyme
        do 500 iorb=1,norb
        if(ip_from.ne.ip_to)call fmove_cvb(work(ip_from),work(ip_to),
     >                                     norb)
        ip_from=ip_from+mxorb
        ip_to=ip_to+norb
500     continue
        ip_from=ip_from+(mxorb-norb)*mxorb
400     continue
c  IORBREL
        ifrom=1
        ito=1
600     continue
        if(ifrom.le.ndimrel)then
          iorb=iorbrel(ifrom)
          jorb=iorbrel(ifrom+1)
          nmov=3+iorbrel(ifrom+2)
          if(iorb.le.norb.and.jorb.le.norb)then
            if(ifrom.ne.ito)
     *            call imove_cvb(iorbrel(ifrom),iorbrel(ito),nmov)
            ito=ito+nmov
          endif
          ifrom=ifrom+nmov
          goto 600
        endif
        ndimrel=ito-1
c  IFXSTR
        ito=0
        do 700 ifrom=1,nfxvb
        if(iwork(ifrom+ifxstr-1).le.nvb)then
          ito=ito+1
          iwork(ito+ifxstr-1)=iwork(ifrom+ifxstr-1)
        endif
700     continue
        nfxvb=ito
c  IDELSTR
        ito=0
        do 800 ifrom=1,nzrvb
        if(iwork(ifrom+idelstr-1).le.nvb)then
          ito=ito+1
          iwork(ito+idelstr-1)=iwork(ifrom+idelstr-1)
        endif
800     continue
        nzrvb=ito
c  IORTS
        ito=0
        do 900 ifrom=1,nort
        if(iorts(1,ifrom).le.norb.and.iorts(2,ifrom).le.norb)then
          ito=ito+1
          iorts(1,ito)=iorts(1,ifrom)
          iorts(2,ito)=iorts(2,ifrom)
        endif
900     continue
        nort=ito
c  IROTS
        ito=0
        do 1000 ifrom=1,ndrot
        if(irots(1,ifrom).le.norb.and.irots(2,ifrom).le.norb)then
          ito=ito+1
          irots(1,ito)=irots(1,ifrom)
          irots(2,ito)=irots(2,ifrom)
        endif
1000    continue
        ndrot=ito
c  Calling DEFS2 before INITOPT is required in order to set things
c  such as ICRIT :
        call defs2_cvb(ifxorb)
        call initopt_cvb(icrit,lfxvb,nfxvb,iorts,nort,norb)

        call defs2_cvb(ifxorb)

c Try for new record
        call rdioff1_cvb(need)
        need=need+3*ihlf_cvb(1)+ihlf_cvb(noe*nconf)+
     >    mxaobf*norb+ihlf_cvb(norb)+nvbinp+nsyme*norb*norb+
     >    ihlf_cvb(ndimrel)+
     >    ihlf_cvb(norb)+ihlf_cvb(nfxvb)+ihlf_cvb(nzrvb)+
     >    ihlf_cvb(2*nort)+ihlf_cvb(2*ndrot)+ihlf_cvb(2*ndrot)+
     >    ihlf_cvb(nsyme)
        if(recinp.eq.0d0)then
          recinp=recn_tmp01
        elseif(recinp_old.eq.0d0)then
          recinp_old=recn_tmp01
          recinp=recn_tmp02
        else
          swap=recinp_old
          recinp_old=recinp
          recinp=swap
        endif
        call reserv_cvb(need,recinp)
        call rdioff1_cvb(ioffs)
        call wrioff_cvb(1,recinp,ioffs)
        call wris_cvb([noe],1,recinp,ioffs)
        call wrioff_cvb(2,recinp,ioffs)
        call wris_cvb([nconf],1,recinp,ioffs)
        call wrioff_cvb(3,recinp,ioffs)
        call wris_cvb([kbasiscvb_inp],1,recinp,ioffs)
        call wrioff_cvb(4,recinp,ioffs)
        call wris_cvb(iwork(ip_iconfs),noe*nconf,recinp,ioffs)
        call wrioff_cvb(5,recinp,ioffs)
        call wrrs_cvb(orbs,mxaobf*norb,recinp,ioffs)
        call wrioff_cvb(6,recinp,ioffs)
        call wris_cvb(irdorbs,norb,recinp,ioffs)
        call wrioff_cvb(7,recinp,ioffs)
        call wrrs_cvb(work(ip_cvb),nvbinp,recinp,ioffs)
        call wrioff_cvb(8,recinp,ioffs)
        call wrrs_cvb(work(ip_symelm),nsyme*norb*norb,recinp,ioffs)
        call wrioff_cvb(9,recinp,ioffs)

        call dset_cvb(iorbrel,ifxorb,ifxstr,
     >    idelstr,iorts,irots,izeta)
      else
        call maxdims_cvb()
      endif
      call mhpfreei_cvb(ip_iconfs)
      call mhpfreer_cvb(ip_cvb)
      call mhpfreer_cvb(ip_symelm)
      call mhpfreei_cvb(ifxstr)
      call mhpfreei_cvb(idelstr)
      call hend_cvb()
      call mfreei_cvb(ibase)

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1984,1989, Per Ake Malmqvist                           *
************************************************************************
C---------------------------------------------------------------
      SUBROUTINE PART1(NDIMEN,NBLOCK,NSIZE,SXY,B,A,SCR,IPIV,BUF)
      use definitions, only: iwp, wp
      use constants, only: zero, one
      IMPLICIT NONE
      integer(kind=iwp), intent(in):: NDIMEN, NBLOCK
      real(kind=wp), intent(in):: SXY(NDIMEN,NDIMEN)
      real(kind=wp), intent(out):: A(NDIMEN,NDIMEN),B(NDIMEN,NDIMEN)
      real(kind=wp), intent(inout):: SCR(NDIMEN,NDIMEN)
      real(kind=wp), intent(out):: BUF(NDIMEN)
      integer(kind=iwp), intent(out):: IPIV(NDIMEN,2)
      integer(kind=iwp), intent(in):: NSIZE(NBLOCK)

      integer(kind=iwp) I,J,LIM1,K,NSZ,LIM3,LIM2,KK,L,M
      real(kind=wp) DET,T
C
C  PURPOSE: SEE SUBROUTINE PART.
C  SUBDIVISION INTO TWO LEVELS OF ROUTINE CALLS IS MERELY TO
C  FACILITATE HANDLING OF SYMMETRY AND INDEXING.
C  ORIGINAL VERSION, MALMQUIST 84-04-04
C  RASSCF VERSION,   MALMQUIST 89-11-15
C---------------------------------------------------------------
C INITIALIZE A = INVERSE OF SXY, AND B = UNIT MATRIX:
      DO I=1,NDIMEN
        DO J=1,NDIMEN
          A(I,J)=zero
          B(I,J)=Zero
          SCR(I,J)=SXY(I,J)
        END DO
        A(I,I)=One
        B(I,I)=one
      END DO
      CALL DOOL (NDIMEN,NDIMEN,NDIMEN,NDIMEN,SCR,A,DET,
     *           IPIV(1,1),IPIV(1,2),BUF)
C---------------------------------------------------------------
C LOOP BACKWARDS OVER THE BLOCKS. KEEP THREE LIMITS UPDATED:
C LIM1= POS IMMEDIATELY BEFORE CURRENT BLOCK, LIM2= BEGINNING
C OF CURRENT BLOCK, AND LIM3=END OF CURRENT BLOCK.
      LIM1=NDIMEN
      DO K=NBLOCK,2,-1
        NSZ=NSIZE(K)
        LIM3=LIM1
        LIM1=LIM1-NSZ
        LIM2=LIM1+1
C---------------------------------------------------------------
C CALCULATE (INVERSE OF CURRENT A-BLOCK)*(ALL TO THE LEFT OF IT)
C AND PUT IT INTO B-MATRIX. THEN CLEAR ALL TO THE LEFT OF THE A-BLOCK.
        DO I=LIM2,LIM3
          DO J=LIM2,LIM3
            SCR(I,J)=A(I,J)
          END DO
          DO J=1,LIM1
            B(I,J)=A(I,J)
            A(I,J)=zero
          END DO
        END DO
        CALL DOOL(NDIMEN,NDIMEN,NSZ,LIM1,SCR(LIM2,LIM2),B(LIM2,1),DET,
     *            IPIV(1,1),IPIV(1,2),BUF)
C---------------------------------------------------------------
C THEN UPDATE THE COLUMNS OF A TO THE LEFT OF THE CURRENT BLOCK:
        DO J=1,LIM1
          DO I=1,LIM1
            T=A(I,J)
            DO KK=LIM2,LIM3
              T=T-B(KK,J)*A(I,KK)
            END DO
            A(I,J)=T
          END DO
        END DO
      END DO
C TRANSPOSE MATRIX B:
      DO I=1,NDIMEN-1
        DO J=I,NDIMEN
          T=B(I,J)
          B(I,J)=B(J,I)
          B(J,I)=T
        END DO
      END DO
C---------------------------------------------------------------
C COMBINED LU-PARTITIONING AND UNITARY TRANSFORMATION OF A AND B:
      CALL LU2(NDIMEN,NBLOCK,NSIZE,B,A,BUF)
C
C     LU PARTITIONING OF THE MATRICES WAS DONE IN-PLACE.
C     NOW CHANGE SIGN OF LOWER-TRIANGULAR PARTS AND
C     INVERT UPPER-TRIANGULAR PARTS, AS INDICATED IN (VI.6):
C
      DO I=2,NDIMEN
        DO J=1,I-1
          A(I,J)=-A(I,J)
          B(I,J)=-B(I,J)
        END DO
      END DO
      DO L=NDIMEN,1,-1
        A(L,L)=One/A(L,L)
        B(L,L)=One/B(L,L)
        DO M=L+1,NDIMEN
          A(L,M)=A(L,L)*A(L,M)
          B(L,M)=B(L,L)*B(L,M)
        END DO
        DO K=1,L-1
          DO M=L+1,NDIMEN
            A(K,M)=A(K,M)-A(K,L)*A(L,M)
            B(K,M)=B(K,M)-B(K,L)*B(L,M)
          END DO
          A(K,L)=-(A(L,L)*A(K,L))
          B(K,L)=-(B(L,L)*B(K,L))
        END DO
      END DO

      END SUBROUTINE PART1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NATORB_MRCI(CMO,DMO,CNO,OCC,SCR)

use mrci_global, only: ICH, NASH, NBAS, NBAST, NBMAX, NBTRI, NCMO, NDEL, NDMO, NFMO, NFRO, NISH, NORB, NSYM, NVIR
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CMO(NCMO), DMO(NBTRI)
real(kind=wp), intent(out) :: CNO(NCMO), OCC(NBAST), SCR((NBMAX*(NBMAX+1))/2)
integer(kind=iwp) :: I, I12, IEB, IECMO, IEO, II, IMAX, IO1, IO12, IO2, ISB, ISCMO, ISO, ISTA1, ISTA2, ISYM, J, NB, NBD, NBF, NBO, &
                     ND, NF, NIAV, NN, NO
real(kind=wp) :: OC, OMAX

OCC(:) = Zero
CNO(:) = CMO
! LOOP OVER SYMMETRY LABELS
! Present index of end of processed CMO block:
IECMO = 0
! Present end of index to MO-s, to be translated by ICH array:
IEO = 0
! Present end of index to basis functions:
IEB = 0
do ISYM=1,NSYM
  NO = NORB(ISYM)
  NIAV = NISH(ISYM)+NASH(ISYM)+NVIR(ISYM)
  NB = NBAS(ISYM)
  if (NB == 0) cycle
  ISB = IEB+1
  IEB = IEB+NB
  ! ORBITALS PRE-FROZEN IN MOTRA, OR FROZEN IN MRCI:
  NF = NFMO(ISYM)+NFRO(ISYM)
  NBF = NB*NF
  ISCMO = IECMO+1
  IECMO = IECMO+NBF
  ! (DO NOTHING WITH THE FROZEN ORBITALS)
  if (NF > 0) OCC(ISB:ISB+NF-1) = Two
  IEO = IEO+NFRO(ISYM)
  ! ORBITALS EXPLICITLY USED IN CI:
  NBO = NB*NIAV
  ISCMO = IECMO+1
  IECMO = IECMO+NBO
  ISO = IEO+1
  IEO = IEO+NIAV
  ! TRANSFER SYMMETRY BLOCK OF DMO TO TRIANGULAR SCRATCH MATRIX:
  I12 = 0
  do I=ISO,IEO
    IO1 = ICH(I)
    do J=ISO,I
      IO2 = ICH(J)
      IO12 = (IO1*(IO1-1))/2+IO2
      if (IO1 < IO2) IO12 = (IO2*(IO2-1))/2+IO1
      I12 = I12+1
      SCR(I12) = DMO(IO12)
    end do
  end do
  ! DIAGONALIZE AND TRANSFORM ORBITALS:
  call JACOB(SCR,CNO(ISCMO),NIAV,NB)
  ! PICK OCCUP NR FROM DIAGONAL:
  II = 0
  do I=1,NIAV
    II = II+I
    OCC(ISB+NF-1+I) = SCR(II)
  end do
  ! ORDER BY DECREASING NATURAL OCCUPANCY:
  NN = NO-NFRO(ISYM)
  do I=1,NN-1
    OMAX = OCC(ISB+NF-1+I)
    IMAX = I
    do J=I+1,NN
      OC = OCC(ISB+NF-1+J)
      if (OMAX < OC) then
        IMAX = J
        OMAX = OC
      end if
    end do
    if (IMAX /= I) then
      OCC(ISB+NF-1+IMAX) = OCC(ISB+NF-1+I)
      OCC(ISB+NF-1+I) = OMAX
      ISTA1 = ISCMO+NB*(I-1)
      ISTA2 = ISCMO+NB*(IMAX-1)
      SCR(1:NB) = CNO(ISTA1:ISTA1+NB-1)
      CNO(ISTA1:ISTA1+NB-1) = CNO(ISTA2:ISTA2+NB-1)
      CNO(ISTA2:ISTA2+NB-1) = SCR(1:NB)
    end if
  end do
  ! ORBITALS PRE-DELETED IN MOTRA OR DELETED IN MRCI:
  ND = NDMO(ISYM)+NDEL(ISYM)
  NBD = NB*ND
  ISCMO = IECMO+1
  IECMO = IECMO+NBD
  IEO = IEO+NDEL(ISYM)
  ! (DO NOTHING WITH THE DELETED ORBITALS)
end do

return

end subroutine NATORB_MRCI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************
!#define _DEBUGPRINT_

Module SOAO_Info
Implicit None
Private
Public :: iSOInf, iAOtSO, nSOInf, SOAO_Info_Init, SOAO_Info_Dmp, SOAO_Info_Get, SOAO_Info_Free, iOffSO
#include "stdalloc.fh"
#include "itmax.fh"
Integer, Allocatable:: iSOInf(:,:)
Integer, Allocatable:: iAOtSO(:,:)
Integer :: iOffSO(0:7)=[0,0,0,0,0,0,0,0]
Integer :: nSOInf=0
Integer :: nIrrep=0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!
Interface
   Subroutine Abend()
   End Subroutine Abend
   Subroutine Put_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Put_iArray
   Subroutine Get_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Get_iArray
   Subroutine Qpg_iArray(Label,Found,nData)
   Character*(*) Label
   Logical       Found
   Integer       nData
   End Subroutine Qpg_iArray
End Interface
!
!***********************************************************************
!***********************************************************************
!
Contains
!
!***********************************************************************
!***********************************************************************
!
!     This to make either the initial allocation of dbsc and Shells according to the default sizes
!     as defined by the parameters in Molcas.fh or according to the actual sizes as recorded on the
!     run file.
!

!***********************************************************************

Subroutine SOAO_Info_Init(nSize,mIrrep)
Implicit None
#ifdef _DEBUGPRINT_
#endif
Integer nSize,mIrrep
If (Allocated(iSOInf).or.Allocated(iAOtSO)) Call SOAO_Info_Free()
nSOInf=nSize
nIrrep=mIrrep
Call mma_allocate(iSOInf,3,nSOInf,Label='iSOInf')
iSOInf(:,:)=-99999999
! Do not change this value, since it also explicitly signals symmetry information.
! This is explicitly used in some routines.
Call mma_allocate(iAOtSO,[1,nSOInf],[0,nIrrep-1],Label='iAOtSO')
iAOtSO(:,:)=-99999999        ! Dito
End Subroutine SOAO_Info_Init

!***********************************************************************

Subroutine SOAO_Info_Dmp()
Implicit None
Integer, Allocatable:: iDmp(:)
Integer i, j
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Enter SOAO_Info_Dmp'
Write (6,*)
Block
Integer i
Write (6,*)
Write (6,*) 'iAOtSO:'
Do i = 0, nIrrep-1
   Write (6,'(8I9)') iAOtSO(1:nSOInf,i)
End Do
End Block
#endif
Call mma_allocate(iDmp,3*nSOInf+8,Label='iDmp')
j=0
Do i = 1, nSOInf
   iDmp(j+1:j+3)=iSOInf(1:3,i)
   j=j+3
End Do
iDmp(j+1:j+8)=iOffSO(0:7)
Call Put_iArray('iSOInf',iDmp,3*nSOInf+8)
Call mma_deallocate(iDmp)
Call Put_iArray('iAOtSO',iAOtSO,nSOInf*nIrrep)
End Subroutine SOAO_Info_Dmp

!***********************************************************************

Subroutine SOAO_Info_Get()
Implicit None
Integer, Allocatable:: iDmp(:)
Integer i, j
Logical Found
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Enter SOAO_Info_Get'
Write (6,*)
#endif
If (Allocated(iSOInf).or.Allocated(iAOtSO)) Call SOAO_Info_Free()
Call Qpg_iArray('iSOInf',Found,nSOInf)
If (.NOT.Found) Then
   Write (6,*) 'SOAO_Info_Get: iSOInf not found.'
   Call Abend()
End If
nSOInf=(nSOInf-8)/3
Call mma_allocate(iSOInf,3,nSOInf,Label='iSOInf')
Call mma_allocate(iDmp,3*nSOInf+8,Label='iDmp')
Call Get_iArray('iSOInf',iDmp,3*nSOInf+8)
j=0
Do i = 1, nSOInf
   iSOInf(1:3,i)=iDmp(j+1:j+3)
   j=j+3
End Do
iOffSO(0:7)=iDmp(j+1:j+8)
Call mma_deallocate(iDmp)
!
Call Qpg_iArray('iAOtSO',Found,nIrrep)
If (.NOT.Found) Then
   Write (6,*) 'SOAO_Info_Get: iAOtSO not found.'
   Call Abend()
End If
nIrrep=nIrrep/nSOInf
Call mma_allocate(iAOtSO,[1,nSOInf],[0,nIrrep-1],Label='iAOtSO')
Call Get_iArray('iAOtSO',iAOtSO,nSOInf*nIrrep)
#ifdef _DEBUGPRINT_
Block
Integer i
Write (6,*)
Write (6,*) 'iAOtSO:'
Do i = 0, nIrrep-1
   Write (6,'(8I9)') iAOtSO(1:nSOInf,i)
End Do
Write (6,*)
Write (6,*) 'Exit SOAO_Info_Get'
Write (6,*)
End Block
#endif
End Subroutine SOAO_Info_Get

!***********************************************************************

Subroutine SOAO_Info_Free()
Implicit None
If (Allocated(iSOInf)) Call mma_deallocate(iSOInf)
If (Allocated(iAOtSO)) Call mma_deallocate(iAOtSO)
nSOInf=0
nIrrep=0
End Subroutine SOAO_Info_Free
!
!***********************************************************************
!***********************************************************************
!
End Module SOAO_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine rotder(nmass,xmass,currxyz,ref123,trans,rotang,rotvec,rotmat,norder,dRVdXYZ,d2RVdXYZ2)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nmass, norder
real(kind=wp), intent(in) :: xMass(nMass), CurrXYZ(3,nMass), Ref123(3,nMass)
real(kind=wp), intent(out) :: trans(3), RotAng, RotMat(3,3), dRVdXYZ(3,3*nMass)
real(kind=wp), intent(inout) :: RotVec(3), d2RVdXYZ2(3,3*nMass,3*nMass)
integer(kind=iwp) :: i, imass, ip, ip1, ip2, ipk, ipk1, ipk2, iter, j, j1, k, k1, k2
real(kind=wp) :: d2RVdA2(3,3,3), d3RVdA3(3,3,3,3), d4RVdA4(3,3,3,3,3), dRVdA(3,3), MOI(3,3), MOIInv(3,3), RotErr, rSum, &
                 Sayvetz2(3), SmallRot(3), SMat(3,3), sval(3), TotMass, Trace, umat(3,3), vmat(3,3), wTmp(100) !, &
                 !det, detinv, G(3,3)
real(kind=wp), allocatable :: Curr123(:,:), dAdXYZ(:,:,:), tmp(:,:)

#ifdef _DEBUGPRINT_
call RecPrt('Ref123',' ',Ref123,3,nMass)
#endif
call mma_allocate(Curr123,3,nMass,label='Curr123')
call mma_allocate(tmp,3,3*nMass,label='tmp')
call mma_allocate(dAdXYZ,3,3,nMass,label='dAdXYZ')

! Compute the Center-of-Mass coordinates.
! These are the same as the translation vector.
Trans(:) = Zero
TotMass = Zero
do imass=1,nmass
  TotMass = TotMass+xMass(imass)
  Trans(:) = Trans(:)+xMass(imass)*CurrXYZ(:,imass)
end do
Trans(:) = Trans(:)/TotMass
! A lengthy piece of code determines the exact orientation
! of the internal frame. This is defined by Sayvetz conditions
! using a reference conformation. The procedure is iterative.
! At least an approximate rotation vector is assumed to be
! known when entering the Subroutine.
! Given rotation vector (''BigOmega'' in formulas),
! compute scalar rotation angle, and rotation matrix.
#ifdef _DEBUGPRINT_
call RecPrt('RotVec(00)',' ',RotVec,1,3)
#endif
RotAng = sqrt(RotVec(1)**2+RotVec(2)**2+RotVec(3)**2)
call mkRotMat(RotVec,RotMat)
#ifdef _DEBUGPRINT_
call RecPrt('RotVec(0)',' ',RotVec,1,3)
#endif
iter = 0
do
  iter = iter+1
  if (iter >= 100) then
    !call Quit_OnConvError()
    call WarningMessage(1,'Warning: Convergence problem in the internal frame')
    exit
  end if
  ! compute cartesian position vectors in the co-moving frame:
  ! (Note: Inverse rotation matrix = transpose)
  do imass=1,nmass
    do i=1,3
      rSum = Zero
      do j=1,3
        rSum = rSum+RotMat(j,i)*(CurrXYZ(j,imass)-Trans(j))
      end do
      Curr123(i,imass) = rSum
    end do
  end do
  ! Compute the Moments-of-Inertia matrix. The asymmetrical
  ! one, used for Sayvetz conditions.
  tmp(:,1:nmass) = Ref123(:,:)
# ifdef _DEBUGPRINT_
  call RecPrt('Curr123',' ',Curr123,3,nMass)
  call RecPrt('tmp',' ',tmp,3,nMass)
# endif
  do imass=1,nMass
    tmp(:,imass) = xMass(iMass)*tmp(:,imass)
  end do
  call DGEMM_('N','T',3,3,nmass,One,tmp,3,Curr123,3,Zero,SMat,3)
  Trace = (SMat(1,1)+SMat(2,2)+SMat(3,3))
  MOI(:,:) = -SMat(:,:)
  do i=1,3
    MOI(i,i) = MOI(i,i)+Trace
  end do
# ifdef _DEBUGPRINT_
  call RecPrt('MOI',' ',MOI,size(MOI,1),size(MOI,2))
# endif
  ! Invert the MOI-matrix.
  !     G(1,1) = MOI(2,2)*MOI(3,3)-MOI(2,3)*MOI(3,2)
  !     G(2,1) = MOI(3,2)*MOI(1,3)-MOI(3,3)*MOI(1,2)
  !     G(3,1) = MOI(1,2)*MOI(2,3)-MOI(1,3)*MOI(2,2)
  !     G(1,2) = MOI(2,3)*MOI(3,1)-MOI(2,1)*MOI(3,3)
  !     G(2,2) = MOI(3,3)*MOI(1,1)-MOI(3,1)*MOI(1,3)
  !     G(3,2) = MOI(1,3)*MOI(2,1)-MOI(1,1)*MOI(2,3)
  !     G(1,3) = MOI(2,1)*MOI(3,2)-MOI(2,2)*MOI(3,1)
  !     G(2,3) = MOI(3,1)*MOI(1,2)-MOI(3,2)*MOI(1,1)
  !     G(3,3) = MOI(1,1)*MOI(2,2)-MOI(1,2)*MOI(2,1)
  !     Det = MOI(1,1)*G(1,1)+MOI(2,1)*G(2,1)+MOI(3,1)*G(3,1)
  !     DetInv = One/Det
  !     MOIInv(1,1) = G(1,1)*DetInv
  !     MOIInv(2,1) = G(1,2)*DetInv
  !     MOIInv(3,1) = G(1,3)*DetInv
  !     MOIInv(1,2) = G(2,1)*DetInv
  !     MOIInv(2,2) = G(2,2)*DetInv
  !     MOIInv(3,2) = G(2,3)*DetInv
  !     MOIInv(1,3) = G(3,1)*DetInv
  !     MOIInv(2,3) = G(3,2)*DetInv
  !     MOIInv(3,3) = G(3,3)*DetInv
  ! (use the Moore-Penrose pseudoinverse, to deal with linear systems)
  call dgesvd_('A','A',3,3,MOI,3,sval,umat,3,vmat,3,wTmp,100,i)
  do i=1,3
    if (abs(sval(i)) > 1.0e-12_wp) then
      umat(:,i) = umat(:,i)/sval(i)
    else
      umat(:,i) = Zero
    end if
  end do
  call dgemm_('T','T',3,3,3,One,vmat,3,umat,3,Zero,MOIInv,3)
# ifdef _DEBUGPRINT_
  call RecPrt('vmat',' ',vmat,size(vmat,1),size(vmat,2))
  call RecPrt('umat',' ',umat,size(umat,1),size(umat,2))
  call RecPrt('MOI',' ',MOIInv,size(MOIInv,1),size(MOIInv,2))
  call RecPrt('xMass',' ',xMass,1,nMass)
  call RecPrt('Ref123',' ',Ref123,3,nMass)
  call RecPrt('Curr123',' ',Curr123,3,nMass)
# endif
  ! Determine small rotation that zeroes the Sayvetz rotational conditions
  !write(u6,*) ' Determine small rotation. First compute Sayvetz2:'
  Sayvetz2(:) = Zero
  do i=1,3
    j = 1+mod(i,3)
    k = 1+mod(j,3)
    do imass=1,nMass
      Sayvetz2(i) = Sayvetz2(i)+xMass(imass)*(Ref123(j,imass)*Curr123(k,imass)-Ref123(k,imass)*Curr123(j,imass))
    end do
  end do
# ifdef _DEBUGPRINT_
  call RecPrt('Sayvetz2',' ',Sayvetz2,1,3)
# endif
  RotErr = Zero
  do i=1,3
    rSum = Zero
    do j=1,3
      rSum = rSum+MOIInv(j,i)*Sayvetz2(j)
    end do
    SmallRot(i) = rSum
    RotErr = RotErr+rSum**2
  end do
# ifdef _DEBUGPRINT_
  call RecPrt('SmallRot',' ',SmallRot,1,3)
# endif
  RotErr = sqrt(RotErr)
  ! Limiting step size:
  if (RotErr > One) then
    SmallRot(1) = SmallRot(1)/RotErr
    SmallRot(2) = SmallRot(2)/RotErr
    SmallRot(3) = SmallRot(3)/RotErr
    RotErr = One
  end if
  ! Apply this rotation to the rotation matrix:
  call updRotMat(SmallRot,RotMat)
# ifdef _DEBUGPRINT_
  call RecPrt('RotMat(i)',' ',RotMat,3,3)
  call RecPrt('SmallRot',' ',SmallRot,1,3)
# endif
  if (RotErr <= 1.0e-12_wp) exit
end do
#ifdef _DEBUGPRINT_
call RecPrt('RotMat(Final)',' ',RotMat,3,3)
#endif
! Now RotMat is converged. Recompute RotVec, RotAng.
call Mat2Vec(RotMat,RotVec,RotAng)
#ifdef _DEBUGPRINT_
call RecPrt('RotVec(Recomputed)',' ',RotVec,1,3)
#endif
! Derivatives w.r.t A(i), of global rotation parameters RotVec
! Note: A(i) is the dual vector of the antisymmetric part of the
! asymmetrically defined MOI matrix, with frozen orientation.
! RotVec is the rotation parameter array necessary to make MOI
! symmetrical.
call rotder4(norder,SMat,RotVec,dRVdA,d2RVdA2,d3RVdA3,d4RVdA4)
! Note that A(i) is exactly linear in atom coordinates.
! Definition of A(i) is as follows:
!    A(1) = sum(xMass(imass)*(Ref123(2,imass)*Curr123(3,imass)-Ref123(3,imass)*Curr123(2,imass)) )
!    A(2) = sum(xMass(imass)*(Ref123(3,imass)*Curr123(1,imass)-Ref123(1,imass)*Curr123(3,imass)) )
!    A(3) = sum(xMass(imass)*(Ref123(1,imass)*Curr123(2,imass)-Ref123(2,imass)*Curr123(1,imass)) )
! First, compute derivatives without accounting for COM motion:
do ip=1,nmass
  dAdXYZ(1,:,ip) = xmass(ip)*(RotMat(:,3)*Ref123(2,ip)-RotMat(:,2)*Ref123(3,ip))
  dAdXYZ(2,:,ip) = xmass(ip)*(RotMat(:,1)*Ref123(3,ip)-RotMat(:,3)*Ref123(1,ip))
  dAdXYZ(3,:,ip) = xmass(ip)*(RotMat(:,2)*Ref123(1,ip)-RotMat(:,1)*Ref123(2,ip))
end do
! Correction for COM motion: (Theoretically, this makes no
! difference to the results, but why not...)
do i=1,3
  do k=1,3
    rSum = Zero
    do ip=1,nmass
      rSum = rSum+dAdXYZ(i,k,ip)
    end do
    dAdXYZ(i,k,:) = dAdXYZ(i,k,:)-(xMass(:)/TotMass)*rSum
  end do
end do
! Finally,transform dXdA, etc, into derivatives w.r.t atom coordinates:
!    dRVdXYZ(i,k,ip) = sum dRVdA(i,j)*dAdXYZ(j,k,ip)
!    d2RVdXYZ2(i,k1,ip1,k2,ip2) = sum d2RVdA2(i,j1,j2)*dAdXYZ(j1,k1,ip1)*dAdXYZ(j2,k2,ip2)
! and so on. Note: A is linear in nuclear coordinates.
if (nOrder >= 1) then
  do i=1,3
    do ip=1,nMass
      do k=1,3
        ipk = k+3*(ip-1)
        dRVdXYZ(i,ipk) = sum(dRVdA(i,:)*dAdXYZ(:,k,ip))
      end do
    end do
  end do
end if
if (nOrder >= 2) then
  do i=1,3
    do j1=1,3
      do ip2=1,nMass
        do k2=1,3
          ipk2 = k2+3*(ip2-1)
          tmp(j1,ipk2) = sum(d2RVdA2(i,j1,:)*dAdXYZ(:,k2,ip2))
        end do
      end do
    end do
    do ipk2=1,3*nMass
      do ip1=1,nMass
        do k1=1,3
          ipk1 = k1+3*(ip1-1)
          d2RVdXYZ2(i,ipk1,ipk2) = sum(tmp(:,ipk2)*dAdXYZ(:,k1,ip1))
        end do
      end do
    end do
  end do
end if
call mma_deallocate(Curr123)
call mma_deallocate(tmp)
call mma_deallocate(dAdXYZ)

return

end subroutine rotder

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CMP2CN(ICNL,NCLL,NOPL,ICNR,NCLR,NOPR,ISCR,NORB,NDIFF,
     &                  NTEST)
*
* Number of differences in occupation of two configurations
*
      DIMENSION ICNL(*),ICNR(*)
      DIMENSION ISCR(*)
* Length of Scratch : Number of orbitals
*
      CALL ISETVC(ISCR,0,NORB)
      DO 10 ICL = 1, NCLL
        ISCR(ICNL(ICL) ) = 2
   10 CONTINUE
      DO 20 IOP = 1, NOPL
        ISCR(ICNL(NCLL+IOP)) = 1
   20 CONTINUE
*
      NDIFF = 0
      DO 30 ICL = 1, NCLR
        NDIFF = NDIFF +  2 - ISCR(ICNR(ICL))
   30 CONTINUE
      DO 40 IOP = 1, NOPR
        IF(ISCR(ICNR(NCLR+IOP)).EQ.0) NDIFF = NDIFF + 1
   40 CONTINUE
*
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NTEST)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TSHop(CI1,CI2)

use rassi_aux, only: ipglob
use rassi_global_arrays, only: JBNUM, LROOT
use Cntrl, only: ChkHop, ISTATE1, ISTATE2, iTOC15, JBNAME, LuIph, nCI1, nCI2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Quart
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: CI1(NCI1), CI2(NCI2)
integer(kind=iwp) :: file1, file2, I, IAD, IAD3, IADR3(3), IDISK, JOB1, JOB2, LROOT1, maxHop, nHop
real(kind=wp) :: prdct(2,2)
logical(kind=iwp) :: fexist, lAllowHop, lHop, lHopped, lMaxHop
character(len=80) :: filnam, filother
real(kind=wp), allocatable :: CI1pr(:), CI2pr(:)

! Skip the test if a hop has occurred
!  (this should happen when testing for state n+1
!  right after a hop to state n-1)
call Get_iScalar('Relax CASSCF root',I)
if (I /= ISTATE1) then
  if (IPGLOB >= 2) write(u6,'(6X,A)') 'A hop has just been detected, skipping this state.'
  return
end if

call mma_allocate(CI1pr,NCI1,Label='CI1pr')
call mma_allocate(CI2pr,NCI2,Label='CI2pr')

! Initialization
CI1pr(:) = Zero
CI2pr(:) = Zero
file1 = 83
file2 = 83
lHopped = .false.

! Get the CI coefficients for current state

! Open JOBIPH file:
JOB1 = JBNUM(ISTATE1)
call DANAME(LUIPH,JBNAME(JOB1))
! Read table of contents on this JOBIPH file:
IAD = 0
call IDAFILE(LUIPH,2,ITOC15,15,IAD)
! Read CI coefficients from interface.
IDISK = ITOC15(4)
LROOT1 = LROOT(ISTATE1)
do I=1,LROOT1-1
  call DDAFILE(LUIPH,0,CI1,NCI1,IDISK)
end do
call DDAFILE(LUIPH,2,CI1,NCI1,IDISK)
call DACLOS(LUIPH)

! Get the CI coefficients for state2

! Open JOBIPH file:
JOB2 = JBNUM(ISTATE2)
call DANAME(LUIPH,JBNAME(JOB2))
! Read table of contents on this JOBIPH file:
IAD = 0
call IDAFILE(LUIPH,2,ITOC15,15,IAD)
! Read CI coefficients from interface.
IDISK = ITOC15(4)
LROOT1 = LROOT(ISTATE2)
do I=1,LROOT1-1
  call DDAFILE(LUIPH,0,CI2,NCI2,IDISK)
end do
call DDAFILE(LUIPH,2,CI2,NCI2,IDISK)
call DACLOS(LUIPH)

! Check if it is a hop up or hop down

I = ISTATE1-ISTATE2
if (I > 0) then
  if (IPGLOB >= 2) write(u6,*) 'Checking for a hop to a root lower in energy.'
  filnam = 'CIVECTOR'
  filother = 'CIVECTUP'
else if (I < 0) then
  if (IPGLOB >= 2) write(u6,*) 'Checking for a hop to a root higher in energy.'
  filnam = 'CIVECTUP'
  filother = 'CIVECTOR'
else
  write(u6,*) 'Unknown problem'
  write(u6,*) 'ISTATE1 = ',ISTATE1
  write(u6,*) 'ISTATE2 = ',ISTATE2
end if

! Open the file with the previous CI-vectors

call f_inquire(filnam,fexist)
if (fexist) then
  call DANAME(file1,filnam)
  if (IPGLOB >= 3) write(u6,*) trim(filnam)//' file exists.'
else
  ! If the file does not exist, create a new one with the current vectors
  call DANAME(file1,filnam)
  ! Dummy table of contents is written
  IADR3(:) = 0
  IAD3 = 0
  call IDAFILE(file1,1,IADR3,3,IAD3)
  IADR3(1) = IAD3
  ! Current CI coefficients are written
  call DDAFILE(file1,1,CI1,NCI1,IAD3)
  IADR3(2) = IAD3
  call DDAFILE(file1,1,CI2,NCI2,IAD3)
  IADR3(3) = IAD3
  ! Write the real table of contents
  IAD3 = 0
  call IDAFILE(file1,1,IADR3,3,IAD3)
  if (IPGLOB >= 3) write(u6,*) trim(filnam)//' file created.'
end if

! Check for surface hop if the energy difference is smaller than
! the threshold.

if (ChkHop) then

  ! Read table of contents on this file
  IAD3 = 0
  call IDAFILE(file1,2,IADR3,3,IAD3)
  ! Read the CI coefficients of ISTATE1 from previuos step
  IAD3 = IADR3(1)
  call DDAFILE(file1,2,CI1pr,NCI1,IAD3)
  ! Read the CI coefficients of ISTATE2 from previuos step
  IAD3 = IADR3(2)
  call DDAFILE(file1,2,CI2pr,NCI2,IAD3)

  ! Calculate the scalar product of the CI coefficient vectors.
  prdct(1,1) = Zero
  prdct(1,2) = Zero
  prdct(2,1) = Zero
  prdct(2,2) = Zero
  if (IPGLOB >= 3) write(u6,'(4(A16))') 'CI1','CI1pr','CI2','CI2pr'
  do i=1,NCI1
    if (IPGLOB >= 3) write(u6,'(4(3X,ES13.6))') CI1(i),CI1pr(i),CI2(i),CI2pr(i)
    prdct(1,1) = prdct(1,1)+CI1pr(i)*CI1(i)
    prdct(1,2) = prdct(1,2)+CI1pr(i)*CI2(i)
    prdct(2,1) = prdct(2,1)+CI2pr(i)*CI1(i)
    prdct(2,2) = prdct(2,2)+CI2pr(i)*CI2(i)
  end do
  if (IPGLOB >= 2) then
    write(u6,'(6X,A)') 'The scalar products of the CI-vectors:'
    write(u6,3000) 'CIpr(state1) * CI(state1) =',prdct(1,1)
    write(u6,3000) 'CIpr(state1) * CI(state2) =',prdct(1,2)
    write(u6,3000) 'CIpr(state2) * CI(state1) =',prdct(2,1)
    write(u6,3000) 'CIpr(state2) * CI(state2) =',prdct(2,2)
    write(u6,*)
  end if
  ! Check the conditions for a surface hop
  if ((abs(prdct(1,2)) >= Quart) .and. (abs(prdct(2,1)) >= Quart)) then
    write(u6,'(6X,3A)') '+',repeat('-',78),'+'
    write(u6,'(6X,A1,T86,A1)') '|','|'
    write(u6,'(6X,A1,T35,A,T86,A1)') '|','A HOP event is detected!','|'
    write(u6,'(6X,A1,T86,A1)') '|','|'
    write(u6,'(6X,A1,T32,2(A,I3,4X),T86,A1)') '|','From state:',ISTATE1,'To state:',ISTATE2,'|'
    ! Check if the number of Hops is limited:
    call qpg_iScalar('MaxHops',lMaxHop)
    if (lMaxHop) then
      call Get_iScalar('MaxHops',maxHop)
      if (maxHop < 1) lMaxHop = .false.
    end if
    if (lMaxHop) then
      call qpg_iScalar('Number of Hops',lHop)
      if (lHop) then
        call Get_iScalar('Number of Hops',nHop)
      else
        nHop = 0
      end if
      if (maxHop <= nHop) then
        lAllowHop = .false.
        write(u6,'(6X,A1,T40,A,T86,A1)') '|','maxHop > nHop','|'
        write(u6,'(6X,A1,T31,A,T86,A1)') '|','This surface HOP is not allowed','|'
        write(u6,'(6X,A1,T24,A,T86,A1)') '|','because the number of allowed Hops is exceeded','|'
      else
        lAllowHop = .true.
      end if
    else
      lAllowHop = .true.
    end if
    ! Bottom of the printed box
    write(u6,'(6X,A1,T86,A1)') '|','|'
    write(u6,'(6X,3A,//)') '+',repeat('-',78),'+'
    ! Set the numbers of Hops
    if (lAllowHop) then
      call Put_iScalar('Relax CASSCF root',ISTATE2)
      call Put_iScalar('NumGradRoot',ISTATE2)
      nHop = nHop+1
      call Put_iScalar('Number of Hops',nHop)
      lHopped = .true.
    end if
  end if
end if
if (IPGLOB >= 3) then
  write(u6,'(2(6X,A8,I3))') 'ISTATE1=',ISTATE1,'ISTATE2=',ISTATE2
  do i=1,NCI1
    write(u6,'(6X,ES12.5,8X,ES12.5)') CI1(i),CI2(i)
  end do
end if

call mma_deallocate(CI1pr)
call mma_deallocate(CI2pr)

! Save the CI coefficients to the right file,
! dependending on whether or not a hop has occurred

if (lHopped) then

  ! Delete the file with the CI-vectors
  call DaEras(file1)

  ! Note that, if a hop occurred, the vectors are written
  ! in the *other* file, and in reversed order
  call f_inquire(filother,fexist)
  if (fexist) then
    call DANAME(file2,filother)
    IAD3 = 0
    call IDAFILE(file2,2,IADR3,3,IAD3)
    IAD3 = IADR3(1)
    call DDAFILE(file2,1,CI2,NCI2,IAD3)
    IAD3 = IADR3(2)
    call DDAFILE(file2,1,CI1,NCI1,IAD3)
    call DACLOS(file2)
  else
    ! The file does not exist, create a new one
    call DANAME(file2,filother)
    IAD3 = 0
    call IDAFILE(file2,1,IADR3,3,IAD3)
    IADR3(1) = IAD3
    call DDAFILE(file2,1,CI2,NCI2,IAD3)
    IADR3(2) = IAD3
    call DDAFILE(file2,1,CI1,NCI1,IAD3)
    IADR3(3) = IAD3
    IAD3 = 0
    call IDAFILE(file2,1,IADR3,3,IAD3)
    call DACLOS(file2)
  end if
else

  ! Write the CI-vectors normally if no hop occurred
  IAD3 = 0
  call IDAFILE(file1,2,IADR3,3,IAD3)
  IAD3 = IADR3(1)
  call DDAFILE(file1,1,CI1,NCI1,IAD3)
  IAD3 = IADR3(2)
  call DDAFILE(file1,1,CI2,NCI2,IAD3)
  call DACLOS(file1)
end if

return

3000 format(6X,A,F7.2)

end subroutine TSHop

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Interf(i_root,Ene,isuseene,iscasvb)
!***********************************************************************
!                                                                      *
!     Object: Driver toward MOLDEN interface                           *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: i_root, isuseene, iscasvb
real(kind=wp), intent(in) :: Ene(*)
integer(kind=iwp) :: iDum(7,8), iS, iUHF, LuTmp, nB, nB2
character(len=80) :: Note
character(len=10) :: Filename
real(kind=wp), allocatable :: AdCMOA(:), AdCMOB(:), CA(:,:), CB(:,:), EAB(:,:), OccA(:), OccB(:)
integer(kind=iwp), external :: isFreeUnit
#include "rasdim.fh"
#include "general.fh"
#include "casvb.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute memory requirements and allocate memory

nB = 0
nB2 = 0
do iS=1,nSym
  nB = nB+nBas(iS)
  nB2 = nB2+nBas(iS)**2
end do

call mma_allocate(OccA,nB,label='OCCA')
call mma_allocate(OccB,nB,label='OCCB')
call mma_allocate(EAB,nB,2,label='ENERGY')
call mma_allocate(CA,nB,nB,label='CMOA')
call mma_allocate(CB,nB,nB,label='CMOB')
call mma_allocate(AdCMOA,nB2,label='AdCMOA')
call mma_allocate(AdCMOB,nB2,label='AdCMOB')
!                                                                      *
!***********************************************************************
!                                                                      *
! For the moment: Orbital energies just zero
if (isuseene /= 0) then
  EAB(:,1) = Ene(1:nB)
  EAB(:,2) = Ene(1:nB)
else
  EAB(:,:) = Zero
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the coeff. of sym adapted basis functions (CA, CB) and
! the spin orbital occupations (OccA, OccB)

call Dens_IF(i_root,CA,CB,OccA,OccB)
call Dens_IF_SCF(CA,AdCMOA,'B')
call Dens_IF_SCF(CB,AdCMOB,'B')
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out info on a temporary vector file.

Note = 'Temporary orbital file for the MOLDEN interface.'
LuTmp = 50
LuTmp = IsFreeUnit(LuTmp)
iUHF = IFVB
if (i_root /= 0) iUHF = 1
call WrVec_('TMPORB',LuTmp,'COE',iUHF,nSym,nBas,nBas,AdCMOA,AdCMOB,OccA,OccB,EAB(:,1),EAB(:,2),iDum,Note,0)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(OccA)
call mma_deallocate(OccB)
call mma_deallocate(EAB)
call mma_deallocate(CA)
call mma_deallocate(CB)
call mma_deallocate(AdCMOA)
call mma_deallocate(AdCMOB)
!                                                                      *
!***********************************************************************
!                                                                      *
if (i_root /= 0) then
  if (i_root <= 9) then
    write(filename,'(A7,I1)') 'MD_CAS.',i_root
  else if (i_root <= 99) then
    write(filename,'(A7,I2)') 'MD_CAS.',i_root
  else if (i_root <= 999) then
    write(filename,'(A7,I3)') 'MD_CAS.',i_root
  else
    filename = 'MD_CAS.x'
  end if
else
  filename = 'MD_CAS'
end if
if (iscasvb == 1) filename = 'MD_VB'
!                                                                      *
!***********************************************************************
!                                                                      *
! Call the generic MOLDEN interface

call Molden_Interface(iUHF,'TMPORB',filename)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Interf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Ignacio Fdez. Galvan                             *
************************************************************************
      Module Dens2HDF5

      Integer, Allocatable :: IdxState(:,:)
      Real*8, Parameter, Private :: Thrs=1.0D-14

      Contains

************************************************************************
*  UpdateIdx
*
*> @brief
*>   Update index of TDMs to save to HDF5
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Update the table of indices of states for the TDMs that will be saved
*> on the HDF5 file. If SUBSets keyword is not used, all TDMs are saved,
*> otherwise only those for the selected transitions. Since the TDMs are
*> saved in SF basis, for a SO calculation we need to figure out which
*> SF TDMs contribute to the desired transitions.
*>
*> @param[in] IndexE  SF states sorted by energy
*> @param[in] nSS     number of SO states
*> @param[in] nSS     number of SO states
*> @param[in] USOR    SO coefficients in SF basis (real part)
*> @param[in] USOI    SO coefficients in SF basis (imaginary part)
*> @param[in] MapSt   map of SF states expanded by multiplicity
************************************************************************
      Subroutine UpdateIdx(IndexE, nSS, USOR, USOI, MapSt)
      Implicit None
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      Integer, Dimension(nState), Intent(In) :: IndexE
      Integer, Intent(In) :: nSS
      Real*8, Intent(In), Optional :: USOR(nSS,nSS),USOI(nSS,nSS)
      Integer, Intent(In), Optional :: MapSt(nSS)
      Integer :: i,j,i_,j_,iState,jState,iSS,jSS,iEnd,jStart
      Real*8 :: f1,f2
      If (.not.Allocated(IdxState)) Then
        Call mma_Allocate(IdxState,nState,nState,Label='IdxState')
        Call iCopy(nState**2,[0],0,IdxState,1)
      End If
      If (ReduceLoop) Then
        iEnd=LoopDivide
        jStart=LoopDivide+1
      Else
        iEnd=nState
        If (nSS.gt.0) iEnd=nSS
        jStart=1
      End If
!     list states for/between which we want to store the density matrices
      If (nSS.gt.0) Then
        Do iSS=1,nSS
          Do jSS=1,nSS
            If ((jSS.ne.iSS).and.
     &          ((jSS.lt.jStart).or.(iSS.gt.iEnd))) Cycle
            Do i=1,nSS
              iState=MapSt(i)
              Do j=1,i
                jState=MapSt(j)
                i_=Max(jState,iState)
                j_=Min(jState,iState)
                If (IdxState(i_,j_).gt.0) Cycle
                f1=(USOR(i,iSS)*USOR(j,jSS)+USOI(i,iSS)*USOI(j,jSS))**2
     &            +(USOR(i,iSS)*USOI(j,jSS)-USOI(i,iSS)*USOR(j,jSS))**2
                f2=(USOR(j,iSS)*USOR(i,jSS)+USOI(j,iSS)*USOI(i,jSS))**2
     &            +(USOR(j,iSS)*USOI(i,jSS)-USOI(j,iSS)*USOR(i,jSS))**2
!               this should be Thrs**2, but let's be looser with SO states
                If (Max(f1,f2).ge.Thrs) IdxState(i_,j_)=2
            End Do
            End Do
          End Do
        End Do
      Else
        Do i=1,nState
          iState=IndexE(i)
          IdxState(iState,iState)=1
          If (i.gt.iEnd) Cycle
          Do j=Max(i+1,jStart),nState
            jState=IndexE(j)
            i_=Max(jState,iState)
            j_=Min(jState,iState)
            IdxState(i_,j_)=1
          End Do
        End Do
      End If
      End Subroutine UpdateIdx

************************************************************************
*  StoreDens
*
*> @brief
*>   Store the density matrices to HDF5
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Save the selected state and transition density matrices to the HDF5
*> file. The TDMs were computed in input state basis, but will be stored
*> in SF eigen states, so a transformation is needed.
*>
*> @param[in] EigVec  coefficients of the SF eigen states in the input state basis
************************************************************************
#ifdef _HDF5_
      Subroutine StoreDens(EigVec)
      Use rassi_aux, Only : iDisk_TDM
      Use rassi_global_arrays, Only : JbNum
      Implicit None
#include "rassi.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "symmul.fh"
#include "Files.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "rassiwfn.fh"
      Real*8, Intent(In) :: EigVec(nState,nState)
      Integer :: iState,jState,k,l,nThisTDMZZ
      Integer :: Job1,Job2,iSym1,iSym2,iSy12,iDisk,iEmpty,iOpt,iGo
      Logical isZero(3)
      Real*8, Allocatable :: TDMZZ(:),TSDMZZ(:),WDMZZ(:),
     &                       TDMIJ(:),TSDMIJ(:),WDMIJ(:)
      Real*8 :: f1,f2
      If (.not.Allocated(IdxState)) Return
C Transform TDMs to SF eigenstates
      Call mma_Allocate(TDMZZ,nTDMZZ,Label='TDMZZ')
      Call mma_Allocate(TSDMZZ,nTDMZZ,Label='TSDMZZ')
      Call mma_Allocate(WDMZZ,nTDMZZ,Label='WDMZZ')
      Call mma_Allocate(TDMIJ,nTDMZZ,Label='TDMIJ')
      Call mma_Allocate(TSDMIJ,nTDMZZ,Label='TSDMIJ')
      Call mma_Allocate(WDMIJ,nTDMZZ,Label='WDMIJ')
      Do iState=1,nState
        Do jState=1,iState
          If (IdxState(iState,jState).eq.0) Cycle
          Call dCopy_(nTDMZZ,[0.0D0],0,TDMIJ,1)
          Call dCopy_(nTDMZZ,[0.0D0],0,TSDMIJ,1)
          Call dCopy_(nTDMZZ,[0.0D0],0,WDMIJ,1)
          isZero=[.True.,.True.,.True.]
          Do k=1,nState
            Job1=JbNum(k)
            iSym1=Irrep(Job1)
            Do l=1,k
              f1=EigVec(k,iState)*EigVec(l,jState)
              f2=EigVec(l,iState)*EigVec(k,jState)
              If (Max(Abs(f1),Abs(f2)).lt.Thrs) Cycle
              Job2=JbNum(l)
              iSym2=Irrep(Job2)
              iSy12=Mul(iSym1,iSym2)
              iDisk=iDisk_TDM(k,l,1)
              iEmpty=iDisk_TDM(k,l,2)
              iOpt=2
              iGo=3
              If (IfSO) iGo=iGo+4
              Call dens2file(TDMZZ,TSDMZZ,WDMZZ,nTDMZZ,
     &                       LuTDM,iDisk,iEmpty,iOpt,iGo,k,l)
              If (IAnd(iEmpty,1).ne.0) Then
                isZero(1)=.False.
                If (Abs(f1).ge.Thrs)
     &            Call daXpY_(nTDMZZ,f1,TDMZZ,1,TDMIJ,1)
                If ((k.ne.l).and.(Abs(f2).ge.Thrs)) Then
                  Call Transpose_TDM(TDMZZ,iSy12)
                  Call daXpY_(nTDMZZ,f2,TDMZZ,1,TDMIJ,1)
                End If
              End If
              If (IAnd(iEmpty,2).ne.0) Then
                isZero(2)=.False.
                If (Abs(f1).ge.Thrs)
     &            Call daXpY_(nTDMZZ,f1,TSDMZZ,1,TSDMIJ,1)
                If ((k.ne.l).and.(Abs(f2).ge.Thrs)) Then
                  Call Transpose_TDM(TSDMZZ,iSy12)
                  Call daXpY_(nTDMZZ,f2,TSDMZZ,1,TSDMIJ,1)
                End If
              End If
              If (IFSO.and.(IAnd(iEmpty,4).ne.0)) Then
                isZero(3)=.False.
                If (Abs(f1).ge.Thrs)
     &            Call daXpY_(nTDMZZ,f1,WDMZZ,1,WDMIJ,1)
                If ((k.ne.l).and.(Abs(f2).ge.Thrs)) Then
                  Call Transpose_TDM(WDMZZ,iSy12)
                  Call daXpY_(nTDMZZ,f2,WDMZZ,1,WDMIJ,1)
                End If
              End If
            End Do
          End Do
          If (All(isZero)) Cycle
          nThisTDMZZ=0
          Do iSym1=1,nSym
            iSym2=Mul(iSy12,iSym1)
            nThisTDMZZ=nThisTDMZZ+NBASF(iSym1)*NBASF(iSym2)
          End Do
          If (.not.isZero(1)) Then
            call mh5_put_dset_array_real(wfn_sfs_tdm,
     &        TDMIJ,[nThisTDMZZ,1,1], [0,iState-1,jState-1])
          End If
          If (.not.isZero(2)) Then
          call mh5_put_dset_array_real(wfn_sfs_tsdm,
     &      TSDMIJ,[nThisTDMZZ,1,1], [0,iState-1,jState-1])
          End If
          If (IFSO.and.(.not.isZero(3))) Then
            call mh5_put_dset_array_real(wfn_sfs_wetdm,
     &        WDMIJ,[nThisTDMZZ,1,1], [0,iState-1,jState-1])
          End If
        End Do
      End Do
      Call mma_deAllocate(IdxState)
      Call mma_deAllocate(TDMZZ)
      Call mma_deAllocate(TSDMZZ)
      Call mma_deAllocate(WDMZZ)
      Call mma_deAllocate(TDMIJ)
      Call mma_deAllocate(TSDMIJ)
      Call mma_deAllocate(WDMIJ)
      End Subroutine StoreDens
#endif

************************************************************************
*  Transpose_TDM
*
*> @brief
*>   Transpose a transition density matrix in place.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Transpose a transition density matrix, stored in symmetry blocks,
*> replacing the original matrix. The matrices contain only the symmetry
*> blocks that match the total symmetry of the transition.
*>
*> @param[in,out] TDM       Transition density matrix
*> @param[in]     Symmetry  Symmetry of the transition
************************************************************************
      Subroutine Transpose_TDM(TDM,Symmetry)
      Implicit None
      Real*8, Intent(InOut) :: TDM(*)
      Integer, Intent(In) :: Symmetry
#include "rassi.fh"
#include "symmul.fh"
#include "stdalloc.fh"
      Integer :: iSym1,iSym2,nTot,i,j
      Integer :: iBlock(0:8)
      Real*8, Allocatable :: Tmp(:)
* Compute the location of all the stored symmetry blocks
      nTot=0
      iBlock(0)=0
      Do iSym1=1,nSym
        iSym2=Mul(Symmetry,iSym1)
        nTot=nTot+nBasF(iSym1)*nBasF(iSym2)
        iBlock(iSym1)=nTot
      End Do
* Make a copy so we can transpose in place
      Call mma_Allocate(Tmp,nTot,Label='Tmp')
      Call dCopy_(nTot,TDM,1,Tmp,1)
* Transpose symmetry block (a,b) onto symmetry block (b,a)
      Do iSym1=1,nSym
        iSym2=Mul(Symmetry,iSym1)
        Do i=1,nBasF(iSym2)
          Do j=1,nBasF(iSym1)
            TDM(iBlock(iSym2-1)+(j-1)*nBasF(iSym2)+i) =
     &      Tmp(iBlock(iSym1-1)+(i-1)*nBasF(iSym1)+j)
          End Do
        End Do
      End Do
      Call mma_deAllocate(Tmp)
      End Subroutine Transpose_TDM

      End Module Dens2HDF5

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DIAG_DKH(A,N,EIG,EW,SINV,AUX,IC)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(N*(N+1)/2),AUX(N,N),SINV(N,N),EIG(N,N),EW(N)
#ifdef MOLPRO
CMR
CMR ATTENTION, THE SCRATCH ARRAY TMP IS NOT PROPERLY ALLOCATED
      DIMENSION TMP(6*N)
CMR
#endif
*
      IJ=0
      DO I=1,N
         DO  J=1,I
            IJ=IJ+1
            AUX(I,J)=A(IJ)
            AUX(J,I)=A(IJ)
         END DO
      END DO
      DO 3 K=1,N
        DO 30 J=1,N
          EIG(K,J)=0.D0
          DO 2 L=1,J
            EIG(K,J)=EIG(K,J)+AUX(K,L)*SINV(L,J)
    2     CONTINUE
   30   CONTINUE
    3 CONTINUE
      DO 5 I=1,N
         DO 50 J=1,I
         AUX(I,J)=0.D0
         DO 4 K=1,I
           AUX(I,J)=AUX(I,J)+SINV(K,I)*EIG(K,J)
    4    CONTINUE
         AUX(J,I)=AUX(I,J)
   50    CONTINUE
    5 CONTINUE
*
      TOL=1.D-80
#ifdef MOLPRO
      DO 6 I=1,N
         DO 60 J=1,N
            EIG(J,I)=AUX(J,I)
   60    CONTINUE
    6 CONTINUE
      CALL diag2(n,n,ew,eig)
c     call dsyev_('V','L',N,EIG,N,EW,TMP,6*N,INFO)
#else
      CALL JACOB_REL(AUX,EIG,EW,N,TOL,IC)
#endif
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SetUp_MCLR(DSYM)
! Setup pointers and size of matrices (includes in Pointers.fh)

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use MCLR_Data, only: ipCM, ipMat, ipMatBA, ipMatLT, ipMO, n1Dens, n2Dens, nA, nB, nCMO, nDens, nDensC, nMBA, nNA, pInt1, pInt2
use input_mclr, only: iMethod, nAsh, nBas, nDel, nFro, nIsh, nOrb, nRS1, nRS2, nRs3, nSym, PT2, TimeDep
use caspt2_module, only: nBMx
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: dsym
integer(kind=iwp) :: i, i1, iExt0, iExt1, iExt2, iExt3, iExt4, iInt0, iInt1, iInt2, iInt3, iInt4, iiSym, ijNum, ijOrb, ijS, ijSym, &
                     iOff, iOrb, ip, iPlus, ipP, iS, jjSym, jOrb, jS, kkSym, klNum, klOrb, klS, klSym, kOrb, kS, llSym, lOrb, lS, &
                     mATAB, nDensLT
integer(kind=iwp), external :: iPntSO

!                                                                      *
!***********************************************************************
!                                                                      *
ip = 1
ipMO(:,:,:) = 0

nBMx = max(0,maxval(nBas(1:nsym)))
nB(1:nsym) = nAsh(1:nsym)+nIsh(1:nsym)
nA(1) = 0
do iS=2,nsym
  nA(iS) = nA(iS-1)+nAsh(iS-1)
end do

nna = sum(nAsh(1:nsym))
n2Dens = nTri_Elem(nnA**2)

n1Dens = nnA*nnA
ip = 1
do kS=1,nSym
  do lS=1,nsym
    klS = Mul(lS,kS)
    do jS=1,nSym
      do iS=1,nSym
        ijS = Mul(iS,jS)
        ipp = nOrb(iS)*nAsh(jS)*nAsh(kS)*nAsh(lS)
        if ((Mul(ijS,klS) == DSym) .and. (ipp /= 0)) then
          ipMO(kS,lS,jS) = ip
          ip = ip+ipp
        end if
      end do
    end do
  end do
end do

nmba = ip-1
nDens = 0
nDensLT = 0
nCMO = 0
nDensC = 0
ipMat(:,:) = 0
ipMatLT(:,:) = 0
ipCM(:) = 0

do jS=1,nSym
  do iS=1,js
    if (Mul(iS,jS) == DSym) then
      if (is < js) then
        ipMatLT(jS,iS) = ipntso(js-1,is-1,ibset(0,dsym-1),nBas)+1
        nDensLT = nDensLT+nBas(iS)*nBas(jS)
        iExt0 = nOrb(is)-nIsh(is)
        iExt1 = nOrb(iS)-nRs1(iS)
        iExt2 = nOrb(iS)-nRs2(iS)
        iExt3 = nOrb(iS)-nRs3(iS)
        iInt4 = nOrb(js)-nish(js)-nAsh(js)
        iExt4 = nIsh(is)+nAsh(is)
        nDensC = nDensC+iExt0*nIsh(js)+iExt1*nRs1(js)+iExt2*nRs2(js)+iExt3*nRs3(js)+iExt4*iInt4
      end if
      if (is == js) then
        i1 = nOrb(is)-nish(is)-nAsh(is)
        ipMatLT(jS,iS) = nDensLT+1
        nDensLT = nDensLT+nTri_Elem(nBas(iS))
        iint0 = nOrb(is)-nIsh(is)
        iint1 = i1+nRs2(is)+nRs3(is)
        iint2 = i1+nRs3(is)
        iint3 = i1
        nDensC = nDensC+iint0*nIsh(is)+iint1*nRs1(is)+iint2*nRs2(is)+iint3*nRs3(is)
      end if
    end if
  end do
  ipCM(jS) = nCMO+1
  nCMO = nCMO+nBas(js)**2
end do

if (TimeDep) nDensC = 2*nDensC
nDens = 0
matab = 1
do jS=1,nSym
  do iS=1,nSym
    if (Mul(iS,jS) == DSym) then
      ipMatba(is,js) = matab
      ipMat(jS,iS) = nDens+1
      nDens = nDens+nBas(iS)*nBas(jS)
      matab = matab+nash(js)*nOrb(iS)
    end if
  end do
end do

! To begin with we assume that we have permutation symmetry

if (iMethod == 2) then
  iOff = 1
  do iiSym=1,nSym
    iOrb = nRs1(iiSym)+nRs2(iiSym)+nRs3(iiSym)
    do jjSym=1,iiSym
      jOrb = nRs1(jjSym)+nRs2(jjSym)+nRs3(jjSym)

      if (Mul(iiSym,jjSym) == Dsym) then
        pINT1(iiSym) = iOff
        if (iiSym == jjSym) then
          iOff = iOff+nTri_Elem(iOrb)
        else
          iOff = iOff+iOrb*jOrb
        end if
      end if

    end do
  end do

  iOff = 1
  do iiSym=1,nSym
    iOrb = nRs1(iiSym)+nRs2(iiSym)+nRs3(iiSym)
    do jjSym=1,iiSym
      jOrb = nRs1(jjSym)+nRs2(jjSym)+nRs3(jjSym)

      ijSym = Mul(iiSym,jjSym)
      klSym = Mul(ijSym,DSym)

      ijNum = iTri(iiSym,jjSym)

      if (iiSym == jjSym) then
        ijOrb = nTri_Elem(iOrb)
      else
        ijOrb = iOrb*jOrb
      end if
      do kkSym=1,nsym
        kOrb = nRs1(kkSym)+nRs2(kkSym)+nRs3(kkSym)

        llSym = Mul(klSym,kkSym)
        lOrb = nRs1(llSym)+nRs2(llSym)+nRs3(llSym)

        if (llSym > kkSym) cycle

        klNum = iTri(kkSym,llSym)
        if (klNum > ijNum) cycle

        if (kkSym == llSym) then
          klOrb = nTri_Elem(kOrb)
        else
          klOrb = kOrb*lOrb
        end if
        ip = iiSym+nSym*((jjSym-1)+nSym*(kkSym-1))
        if (ijNum == klNum) then
          iPlus = nTri_Elem(ijOrb)
        else
          iPlus = ijOrb*klOrb
        end if

        if (iPlus > 0) pINT2(ip) = iOff

        iOff = iOff+iPlus

      end do
    end do
  end do
end if

call Get_iArray('nFro',nFro,nSym)
do i=1,nSym
  if (nFro(i) /= 0) then
    call WarningMessage(2,'MCLR module cannot handle frozen orbitals!')
    call Abend()
  end if
end do
call Put_iArray('nFroPT',nFro,nSym)
if (PT2) call Put_iArray('nIsh',nIsh,nSym)
call Get_iArray('nDel',nDel,nSym)
do i=1,nSym
  if (nDel(i) /= 0) then
    call WarningMessage(2,'MCLR module cannot handle deleted orbitals!')
    call Abend()
  end if
end do
call Put_iArray('nDelPT',nDel,nSym)

!call iWrtMa(pINT2,64,8,64,8)

end subroutine SetUp_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
#if defined (_MOLCAS_MPP_)
      Subroutine LDF_P_AddAuxBasVector(ip_V)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Add aux bas vector across nodes.
C
      Implicit None
      Integer ip_V
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "para_info.fh"

      Integer  LDF_nAtom, LDF_nBasAux_Atom
      External LDF_nAtom, LDF_nBasAux_Atom

      Integer iAtom, nAtom, iAtomPair
      Integer ipV0, ip, l

      Integer i, j
      Integer AP_2CFunctions
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      If (nProcs.gt.1 .and. Is_Real_Par()) Then
         nAtom=LDF_nAtom()
         ipV0=ip_V-1
         Do iAtom=1,nAtom
            l=LDF_nBasAux_Atom(iAtom)
            If (l.gt.0) Then
               ip=iWork(ipV0+iAtom)
               Call GAdGOp(Work(ip),l,'+')
            End If
         End Do
         ipV0=ipV0+nAtom
         Do iAtomPair=1,NumberOfAtomPairs
            l=AP_2CFunctions(1,iAtomPair)
            If (l.gt.0) Then
               ip=iWork(ipV0+iAtomPair)
               Call GAdGOp(Work(ip),l,'+')
            End If
         End Do
      End If
      End
#elif defined (NAGFOR)
c Some compilers do not like empty files
      Subroutine empty_LDF_P_AddAuxBasVector()
      End
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine D1Int( &
#                define _CALLING_
#                include "int_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: to compute the 1-electron Darwin contact term.               *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, Sweden, February '91                 *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: ia, ib, ipAxyz, ipBxyz, iPrint, iRout, nip
character(len=80) :: Label

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(ZInv)
unused_var(nOrdOp)
unused_var(lOper)
unused_var(iChO)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 150
iPrint = nPrint(iRout)

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+1)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+1)
if (nip-1 > nArr*nZeta) then
  call WarningMessage(2,'D1Int: nip-1 > nArr*nZeta')
  write(u6,*) 'nip=',nip
  write(u6,*) 'nArr,nZeta=',nArr,nZeta
  call Abend()
end if

if (iPrint >= 49) then
  call RecPrt(' In D1Int: A',' ',A,1,3)
  call RecPrt(' In D1Int: RB',' ',RB,1,3)
  call RecPrt(' In D1Int: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In D1Int: P',' ',P,nZeta,3)
  write(u6,*) ' In D1Int: la,lb=',la,lb
end if

! Compute the contact terms.

call Darwin(Zeta,P,nZeta,A,Array(ipAxyz),la,RB,Array(ipBxyz),lb,rFinal,iStabM,nStabM,nComp,rKappa)

if (iPrint >= 99) then
  do ia=1,nTri_Elem1(la)
    do ib=1,nTri_Elem1(lb)
      write(Label,'(A,I2,A,I2,A)') 'Darwin contact(',ia,',',ib,')'
      call RecPrt(Label,' ',rFinal(:,ia,ib,:),nZeta,nComp)
    end do
  end do
end if

return

end subroutine D1Int

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine INT9(I,J,L,IT1,IT2,II,IID,JJ,JJD,JTYP,ITAI,L0,L1,L2,L3)
! I < L . CASE 1 J=K=L , CASE 2 I=J=K .

use guga_global, only: COUP, IJ, IWAY, IX, J1, J2
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: I, J, L, IT1, IT2, II, IID, JJ, JJD, JTYP, L0(*), L1(*), L2(*), L3(*)
integer(kind=iwp), intent(_OUT_) :: ITAI(*)
integer(kind=iwp) :: ISTOP, ITAIL, ITYP, KM, LJ, LJM, LJS
real(kind=wp) :: FAC
logical(kind=iwp) :: first, skip

ITYP = 0
FAC = One
LJS = IJ(L+1)+1
LJM = IJ(L)
do LJ=LJS,LJM
  ITAIL = IX(IT2+LJ)
  if (IT1 /= IT2) call TAIL(L,LJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
  IWAY(L) = 1
  skip = .false.
  loop_1: do
    if (skip) then
      skip = .false.
    else
      KM = L
      J2(KM+1) = LJ
      J1(KM+1) = LJ
      call LOOP1(KM,ISTOP,IT1,IT2)
      if (ISTOP == 1) exit loop_1
      if (I /= J) then
        FAC = One
        if ((IWAY(KM) == 2) .or. (IWAY(KM) == 4)) FAC = Zero
      end if
    end if
    KM = KM-1
    first = .false.
    if (KM == 0) then
      if (FAC /= Zero) call COMP1(LJ,ITYP,L,IT2,II,IID,JJ,JJD,JTYP,ITAI)
      KM = 1
      if (KM == L) cycle loop_1
    else
      IWAY(KM) = 1
      if (KM == I) first = .true.
    end if
    do
      if (first) then
        IWAY(I) = 1
        do
          KM = I
          call LOOP3(KM,ISTOP,IT1,IT2)
          if (ISTOP == 1) exit
          if (I == J) then
            FAC = One
            if (IWAY(KM) == 2) FAC = Zero
          end if
          if (FAC == Zero) cycle
          if (abs(COUP(I)) < 1.0e-6_wp) cycle
          call COMP(I,LJ,ITYP,I,IT1,IT2)
        end do
        first = .false.
      else
        call LOOP5(KM,ISTOP,IT1,IT2)
        if (ISTOP == 0) then
          skip = .true.
          cycle loop_1
        end if
      end if
      KM = KM+1
      if (KM == L) cycle loop_1
    end do
    if (.true.) exit loop_1
  end do loop_1
end do

return

end subroutine INT9

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine DEPSATrf(NBSQT,nAshT,DEPSA,FPT2,WRK1,WRK2)

use caspt2_global, only: CMOPT2
use caspt2_module, only: IfChol, NASH, NBAS, NBAST, NFRO, NISH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NBSQT, nAshT
real(kind=wp), intent(in) :: DEPSA(nAshT,nAshT)
real(kind=wp), intent(out) :: FPT2(NBSQT), WRK1(NBSQT), WRK2(NBSQT)
integer(kind=iwp) :: iAshI, iOrb, iSym, iSymA, iSymB, iSymI, iSymJ, jAsh, jAshI, jOrb, nBasI, nCorI
real(kind=wp), allocatable :: DAO(:), DMO(:)

FPT2(1:nBasT**2) = Zero

iSym = 1
iSymA = 1
iSymI = 1
iSymB = 1
iSymJ = 1

!if ((nFroT /= 0) .and. IfChol) then
if (IfChol) then
  !! DEPSA(MO) -> DEPSA(AO) -> G(D) in AO -> G(D) in MO
  !! The Cholesky vectors do not contain frozen orbitals...
  call mma_allocate(DAO,NBSQT,Label='DAO')
  call mma_allocate(DMO,NBSQT,Label='DMO')
  !! First, MO-> AO transformation of DEPSA
  do iSym=1,nSym
    DMO(:) = Zero
    nCorI = nFro(iSym)+nIsh(iSym)
    nBasI = nBas(iSym)
    do jAsh=1,nAsh(iSym)
      DMO(nCorI+nBasI*(nCorI+jAsh-1)+1:nCorI+nBasI*(nCorI+jAsh-1)+nAsh(iSym)) = DEPSA(1:nAsh(iSym),jAsh)
    end do
    call OLagTrf(1,iSym,NBSQT,CMOPT2,DMO,DAO,WRK1)
  end do
  !! Compute G(D)
  WRK1(1:NBSQT) = Zero
  DMO(:) = Zero
  !! it's very inefficient
  call OLagFro4(NBSQT,1,1,1,1,1,DAO,WRK1,DMO,WRK1,WRK2)
  !! G(D) in AO -> G(D) in MO
  do iSym=1,nSym
    call OLagTrf(2,iSym,NBSQT,CMOPT2,FPT2,DMO,WRK1)
  end do
  call mma_deallocate(DAO)
  call mma_deallocate(DMO)
else
  nCorI = nFro(iSym)+nIsh(iSym)
  do iAshI=1,nAsh(iSym)
    iOrb = nCorI+iAshI
    do jAshI=1,nAsh(iSym)
      jOrb = nCorI+jAshI

      call Coul(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,WRK1,WRK2)
      FPT2(1:nBasT**2) = FPT2(1:nBasT**2)+DEPSA(iAshI,jAshI)*WRK1(1:nBasT**2)

      call Exch(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,WRK1,WRK2)
      FPT2(1:nBasT**2) = FPT2(1:nBasT**2)-Half*DEPSA(iAshI,jAshI)*WRK1(1:nBasT**2)
    end do
  end do
end if

return

end subroutine DEPSATrf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995,1999, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE PART_CIV2(     IDC,   IBLTP,   NSSOA,   NSSOB,  NOCTPA,
     &                       NOCTPB,   NSMST,   MXLNG,   IOCOC,  ISMOST,
     &                       NBATCH,  LBATCH, LEBATCH, I1BATCH,  IBATCH,
     &                        ICOMP, ISIMSYM)
*
* Jeppe Olsen
*
* Last update : May 1999 : ISIMSYM added
*
* Partition a CI vector into batches of blocks.
* The length of a batch must be at most MXLNG
* If ISIMSYM.EQ.1, TTS blocks that differs only in symmetry are not
*                  split.
*
* IF ICOMP. eq. 1 the complete civector is constructed
*
*
* Compared to PART_CIV, the NOOS arrays have been eliminated.
* They are becoming the size defining arrays - atleast at
* the laptop
*
*. Output
* NBATCH : Number of batches
* LBATCH : Number of blocks in a given batch
* LEBATCH : Number of elements in a given batch ( packed ) !
* I1BATCH : Number of first block in a given batch
* IBATCH : TTS blocks in Start of a given TTS block with respect to start
*          of batch
*   IBATCH(1,*) : Alpha type
*   IBATCH(2,*) : Beta sym
*   IBATCH(3,*) : Sym of alpha
*   IBATCH(4,*) : Sym of beta
*   IBATCH(5,*) : Offset of block with respect to start of block in
*                 expanded form
*   IBATCH(6,*) : Offset of block with respect to start of block in
*                 packed form
*   IBATCH(7,*) : Length of block, expandend form
*   IBATCH(8,*) : Length of block, packed form
*
*
*
* Jeppe Olsen, August 1995
*
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
C     INTEGER NOOS(NOCTPA,NOCTPB,NSMST)
C     INTEGER NOOSP(NOCTPA,NOCTPB,NSMST)
      INTEGER NSSOA(NSMST,*),NSSOB(NSMST,*)
      INTEGER IOCOC(NOCTPA,NOCTPB)
      INTEGER IBLTP(*)
      INTEGER ISMOST(*)
*.Output
      INTEGER LBATCH(*)
      INTEGER LEBATCH(*)
      INTEGER I1BATCH(*)
      INTEGER IBATCH(8,*)
*
C Dummy initialize
      INCLUDE = 0
      LBLOCKP = 0
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
         WRITE(6,*)
         WRITE(6,*) ' =================='
         WRITE(6,*) '     PART_CIV2     '
         WRITE(6,*) ' =================='
         WRITE(6,*) ' IDC = ', IDC
         WRITE(6,*)
         WRITE(6,*) ' IOCOC Array '
         CALL IWRTMA(IOCOC,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
         WRITE(6,*) ' ISMOST array '
         CALL IWRTMA(ISMOST,1,NSMST,1,NSMST)
         WRITE(6,*) ' IBLTP array '
         CALL IWRTMA(IBLTP,1,NSMST,1,NSMST)
         WRITE(6,*) ' NSSOA, NSSOB '
         CALL IWRTMA(NSSOA,NSMST,NOCTPA,NSMST,NOCTPA)
         CALL IWRTMA(NSSOB,NSMST,NOCTPB,NSMST,NOCTPB)
         WRITE(6,*) 'ISIMSYM, ICOMP = ', ISIMSYM,ICOMP
      END IF
*
*. block 1
*
      IB = 1
      IA = 1
      ISM = 1
      IFRST = 1
      NBATCH = 0
      IBLOCK = 0
      IFINI = 0
*. Loop over batches of blocks
 2000 CONTINUE
      NBATCH = NBATCH + 1
      LBATCH(NBATCH) = 0
      I1BATCH(NBATCH) = IBLOCK  + 1
      LENGTH = 0
      LENGTHP= 0
      NBLOCK = 0
      IFRST = 1
*. Loop over blocks in batch
 1000 CONTINUE
      IF(IFRST.EQ.0) THEN
*. New order : ISM,IB,IA (leftmost inner loop )
         IF(ISM.LT.NSMST) THEN
            ISM = ISM + 1
         ELSE
            ISM = 1
            IF(IB.LT.NOCTPB) THEN
               IB = IB + 1
            ELSE
               IB = 1
               IF(IA.LT.NOCTPA) THEN
                  IA = IA + 1
               ELSE
                  IFINI = 1
               END IF
            END IF
         END IF
      END IF
      IFRST = 0
      IF(IFINI.EQ.1) GOTO 2002
      IF(IOCOC(IA,IB).EQ.0) GOTO 1000
*. Size of TT block ( all symmetries)
c      LBLOCK_AS = 0
c      IF(ISIMSYM.EQ.1 .AND. ISM. EQ. 1 ) THEN
c         DO IASM = 1, NSMST
c            IBSM = ISMOST(IASM)
c            NSTA = NSSOA(IASM,IA)
c            NSTB = NSSOB(IBSM,IB)
c            IF(IBLTP(IASM).EQ.0) GOTO 99
c            IF(IBLTP(IASM).EQ.2.AND.IA.LT.IB) GOTO 99
c            LBLOCK_AS = LBLOCK_AS + NSTA*NSTB
c 99         CONTINUE
c         END DO
c         INCLUDE = 0
C?      WRITE(6,*) ' IA IB LBLOCK_AS', IA,IB, LBLOCK_AS
c         IF(LENGTH+LBLOCK_AS.LE.MXLNG.OR.ICOMP.EQ.1) INCLUDE = 1
c      END IF
*. Should this block be included
      IASM = ISM
      IBSM = ISMOST(IASM)
      IF(IDC.EQ.2) THEN
         IF(IA.LT.IB) GOTO 1000
         IF(IA.EQ.IB.AND.IASM.LT.IBSM) GOTO 1000
      END IF
*. can this block be included
      NSTA = NSSOA(ISM,IA)
      NSTB = NSSOB(IBSM,IB)
      LBLOCK= NSTA*NSTB
      IF(IDC.EQ.1.OR.IA.GT.IB.OR.(IA.EQ.IB.AND.IASM.GT.IBSM)) THEN
         LBLOCKP = NSTA*NSTB
      ELSE IF(IDC.EQ.2.AND.IA.EQ.IB.AND.IASM.EQ.IBSM) THEN
         LBLOCKP = NSTA*(NSTA+1)/2
      END IF
C?      WRITE(6,*) ' IASM IBSM IA IB LBLOCKP,LBLOCK' ,
C?   &               IASM,IBSM,IA,IB,LBLOCKP,LBLOCK
*
c      IF(ISIMSYM.EQ.0) THEN
         INCLUDE = 0
         IF(LENGTH+LBLOCK.LE.LBLOCK.OR.ICOMP.EQ.1) INCLUDE = 1
c      END IF
*
      IF(INCLUDE.EQ.1) THEN
         NBLOCK = NBLOCK + 1
         IBLOCK = IBLOCK + 1
         LBATCH(NBATCH) = LBATCH(NBATCH)+1
         IBATCH(1,IBLOCK) = IA
         IBATCH(2,IBLOCK) = IB
         IBATCH(3,IBLOCK) = ISM
         IBATCH(4,IBLOCK) = IBSM
         IBATCH(5,IBLOCK) = LENGTH+1
         IBATCH(6,IBLOCK) = LENGTHP+1
         IBATCH(7,IBLOCK) = LBLOCK
         IBATCH(8,IBLOCK) = LBLOCKP
         LENGTH = LENGTH + LBLOCK
         LENGTHP= LENGTHP+ LBLOCKP
         LEBATCH(NBATCH) = LENGTHP
         GOTO 1000
      ELSE IF(ICOMP.EQ.0.AND.INCLUDE.EQ.0.AND.NBLOCK.EQ.0) THEN
         WRITE(6,*)
     &        ' Not enough space to include a single Block'
         WRITE(6,*) ' Since I cannot procede I will stop '
         WRITE(6,*) ' Insufficient space detected in PART_CIV'
         WRITE(6,*) ' Alter GAS space or raise Buffer from ', MXLNG
*         STOP 'Error in PART_CIV2'
         CALL SYSABENDMSG('lucia_util/part_civ2','Internal error',' ')
      ELSE
*. This batch is finished, goto next batch
         GOTO 2000
      END IF
 2002 CONTINUE
*
      IF(NTEST.NE.0) THEN
C?      WRITE(6,*) 'Output from PART_CIV'
C?      WRITE(6,*) '====================='
         WRITE(6,*)
         WRITE(6,*) ' Number of batches ', NBATCH
         DO JBATCH = 1, NBATCH
            WRITE(6,*)
            WRITE(6,*) ' Info on batch ', JBATCH
            WRITE(6,*) ' *********************** '
            WRITE(6,*)
          WRITE(6,*) '      Number of blocks included ', LBATCH(JBATCH)
          WRITE(6,*) '      TTSS and offsets and lengths of each block '
          DO IBLOCK = I1BATCH(JBATCH),I1BATCH(JBATCH)+ LBATCH(JBATCH)-1
               WRITE(6,'(10X,4I3,4I8)') (IBATCH(II,IBLOCK),II=1,8)
            END DO
         END DO
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
Subroutine Gradient_Kriging(x0_,dy_,ndimx)
  use kriging_mod
  Implicit None
  Integer ndimx
  Real*8 x0_(ndimx),dy_(ndimx)
!
!#define _Grad_Test
#ifdef _Grad_Test
  Integer i
  Real*8 Delta,tpred,thpred
  Real*8 GradT
  GradT = 1.0D-6
#endif
!
!x0 is the n-dimensional vector of the coordinates at which the gradient is evaluated.
! subroutine
  x0(:) = x0_(:)
!
  ! Write(6,*) 'Entro grad'
  call covarvector(1) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
  call predict(1)
  dy_(:)=gpred(:)
!
#ifdef _Grad_Test
 ! Numerical Gradient of GEK
  write(6,*) 'Begining Numerical Gradient'
  Delta = 1.0D-4!Max(Abs(x_(i,1)),1.0D-5)*Scale
  do i = 1,nInter
    x0(:) = x0_(:)
!
    x0(i) = x0_(i) + Delta
!
    call covarvector(0) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
    call predict(0)
    tpred = pred
!
    x0(i) = x0_(i) - Delta
!
    call covarvector(0) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
    call predict(0)
    thpred = pred
!
    gpred(i) = (tpred-thpred)/(2.0D0*Delta)
!
  enddo
  write(6,*) 'Gradient Threshold',GradT
  do i = 1,nInter
    write(6,*) 'i',i
    write(6,*) 'gpred, dy_',gpred(i),dy_(i)
    if (abs(dy_(i)-gpred(i)).gt.GradT) then
      Write(6,*) 'Error in entry',i,'of the gradient vector'
      Call RecPrt('Anna Grad',' ',dy_,1,nInter)
      Call RecPrt('Num Grad',' ',gpred,1,nInter)
      Write(6,*) 'abs(dy_(i,j)+ HessT)',abs(dy_(i)+ GradT)
      Write(6,*) 'abs(dy_(i,j)- HessT)',abs(dy_(i)- GradT)
      Write(6,*) 'abs(gpred(i))',abs(gpred(i))
      Call Abend()
    endif
  enddo
#endif
  return
End Subroutine Gradient_Kriging

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Schmidt(N,S,C,Temp,M)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Schmidt orthogonalization such that the latest vector (in chro-  *
!     nological order) remains unchanged and the previous are ortho-   *
!     gonalized relative to it.                                        *
!                                                                      *
!     calling arguments:                                               *
!     N       : Type integer, input.                                   *
!               Dimensions of the overlap matrix.                      *
!     S       : Type double precision real, input.                     *
!               Overlap matrix.                                        *
!     C       : Type double precision real, output.                    *
!               Matrix containing the transformation vectors.          *
!     Temp    : Type double precision real, input/output.              *
!               Scratch area.                                          *
!     M       : Type integer, output.                                  *
!               This is the number of linearly independent basis       *
!               vectors that span space the metric given by the        *
!               overlap matrix.                                        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher, University of Lund, Sweden, 1993                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
integer(kind=iwp), intent(out) :: M
real(kind=wp), intent(in) :: S(N,N)
real(kind=wp), intent(out) :: C(N,N), Temp(N)
integer(kind=iwp) :: i, j, k
real(kind=wp) :: Alpha, rSum
logical(kind=iwp), parameter :: forward = .true.

M = 0
C(:,:) = Zero
do i=1,N
  C(i,i) = One/sqrt(S(i,i))
end do

! forward orthonormalization
! (vectors 1 remains unchanged)
if (forward) then
  do i=1,N
    Alpha = C(i,i)
    do j=1,N
      Temp(j) = S(j,i)*Alpha
    end do
    do j=1,i-1
      rSum = Zero
      do k=1,i
        rSum = rSum+C(k,j)*Temp(k)
      end do
      do k=1,i
        C(k,i) = C(k,i)-rSum*C(k,j)
      end do
    end do
    rSum = Zero
    do k=1,i
      rSum = rSum+C(k,i)*Temp(k)
    end do
    if (rSum > 1.0e-9_wp) then
      M = M+1
      Alpha = One/sqrt(rSum)
      do k=1,i
        C(k,i) = C(k,i)*Alpha
      end do
    else
      do k=1,i
        C(k,i) = Zero
      end do
    end if
  end do
end if

! backward orthonormalization
! (vectors N remains unchanged)
if (.not. forward) then
  do i=N,1,-1
    Alpha = C(i,i)
    do j=1,N
      Temp(j) = S(j,i)*Alpha
    end do
    do j=N,i+1,-1
      rSum = Zero
      do k=j,N
        rSum = rSum+C(k,j)*Temp(k)
      end do
      do k=j,N
        C(k,i) = C(k,i)-rSum*C(k,j)
      end do
    end do
    rSum = Zero
    do k=i,N
      rSum = rSum+C(k,i)*Temp(k)
    end do
    if (rSum > 1.0e-9_wp) then
      M = M+1
      Alpha = One/sqrt(rSum)
      do k=i,N
        C(k,i) = C(k,i)*Alpha
      end do
    else
      do k=i,N
        C(k,i) = Zero
      end do
    end if
  end do
end if

return

end subroutine Schmidt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function nToken(Line)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nToken
character(len=*), intent(in) :: Line
integer(kind=iwp) :: iLine, nLine
logical(kind=iwp) :: On

nLine = len(Line)
nToken = 0
On = .true.

do iLine=1,nLine-1
  if (Line(iLine:iLine) == ' ') then
    On = .true.
  else
    if (On) nToken = nToken+1
    On = .false.
  end if
end do

end function nToken

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

module rhodyn_data
!***********************************************************************
! Purpose: declaration of variables used between different subroutines *
!***********************************************************************
! i_rasscf         integer key used inside program (private):
!                  = 0 - nothing has been read from RASSCF
!                  = 1 - from RASSCF the spin-free H obtained
!                  = 2 - from RASSCF the CIs and Es obtained
!                  = 3 - from CASPT2 CIs and Es
!  runmode         integer key in input file:
!                  = 1 - start from rasscf/rassi input to propagation
!                  = 2 - start with sdprep.h5 file to propagation
!                  = 3 - just prepare sdprep.h5 file without propagation
!                  = 4 - charge migration (only rassi input)
!  N               nr of spin manifolds
!  Nstate          nr of total SF states acccounting for spin-degeneracy
!  ndet            dim(N) nr of the DET   for different spin manifolds
!  nconf           dim(N) nr of the CSFs for different spin manifolds
!  lroots          dim(N) nr of states (roots) for different spin manifolds
!  ispin           dim(N) multiplicity for different spin manifolds
!  istates         set of states (dim(Nstate)) included in dynamics
!  NDET_TOT        total nr of DETs (NDET_TOT=sum(NDET(I)))
!  nconftot        total nr of CSFs (nconftot=sum(NCONF(I)))
!  lrootstot       total nr of states (LROOTSTOT=sum(LROOTS(I)*ISPIN(I))
!  d               dimension of propagated matrices
!  N_populated     nr of the CSF/DET/SF/SO states to be populated
!  CI              CI(nconf,lroots,N) CI coefficients matrix including
!                      all spin manifolds
!  U_CI            U_CI(nconftot,lrootstot) the transformation matrix
!                      from spin-free states accounting for
!                       the spin-degeneracy  to CSFs
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  CSF ->  SF     !  U_CI^T     * . * U_CI                             !
!  SF  ->  CSF    !  U_CI       * . * U_CI^T                           !
!  SF  ->  SO     !  SO_CI^C    * . * SO_CI                            !
!  SO  ->  SF     !  SO_CI      * . * SO_CI^C                          !
!  SO  ->  CSF    !  CSF2SO     * . * CSF2SO^C                         !
!  CSF ->  SO     !  CSF2SO^C   * . * CSF2SO                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  DTOC            DTOC(NDET,NCONF,N) transformation matrix
!                      from CSF to DET for particular spin manifold
!  DET2CSF         DET2CSF(NDET_TOT,NCONFTOT) full transform matrix
!                      from CSF to DET
!  V_SO            V_SO(NSS,NSS) SO-Hamiltonian matrix elements over
!                      spin components of spin-free eigenstates (SFS)
!  V_CSF           V_CSF(NCONFTOT,NCONFTOT) SO-Hamiltonian over CSFs
!  HTOTRE_CSF      real matrix, Hamiltonian in CSF basis of all spin
!                      manifolds which is extracted from RASSCF output
!  HTOT_CSF        complex matrix, HTOT_CSF=HTOTRE_CSF+V_CSF, total
!                       Hamiltonian in CSF basis including SO coupling
!  HSOCX           complex SO-Hamiltonian (taken from rassi)
!  p_style         what's populated: CSF, DET, SF or SO eigenstates
!  dysamp          matrix of Dyson amplitudes read from rassi (SO)
!  dysamp_bas      same as above in required basis
!
! out2_fmt, out3_fmt: formats for output writing declared in propagate
!***********************************************************************

use Constants, only: kBoltzmann, auTokJ
use Definitions, only: wp, iwp

implicit none
private

! some abstract interfaces, which fit to several subroutines
abstract interface
  subroutine pulse_func(h0,ht,time,pcount)
    import :: wp, iwp
    complex(kind=wp), intent(in) :: h0(:,:)
    complex(kind=wp), intent(out) :: ht(:,:)
    real(kind=wp), intent(in) :: time
    integer(kind=iwp), intent(in) :: pcount
  end subroutine pulse_func
  subroutine equation_func(time,rho_t,res)
    import :: wp
    real(kind=wp), intent(in) :: time
    complex(kind=wp), intent(in) :: rho_t(:,:)
    complex(kind=wp), intent(out) :: res(:,:)
  end subroutine equation_func
end interface

! list of constants
real(kind=wp), parameter :: k_B = kBoltzmann/(auTokJ*1.0e3_wp), threshold = 1.0e-6_wp
integer(kind=iwp) :: ipglob, i_rasscf, runmode, N, Nstate, d, n_freq, ndet_tot, nconftot, lrootstot, maxnconf, maxlroots
integer(kind=iwp), allocatable :: ispin(:), istates(:), lroots(:), nconf(:), ndet(:)
real(kind=wp), allocatable :: a_einstein(:,:), CI(:,:,:), DTOC(:,:,:), dysamp(:,:), E(:,:), H_CSF(:,:,:), HTOTRE_CSF(:,:), U_CI(:,:)
complex(kind=wp), allocatable :: CSF2SO(:,:), dipole(:,:,:), dipole_basis(:,:,:), DM0(:,:), dysamp_bas(:,:), E_SF(:), E_SO(:), &
                                 HSOCX(:,:), HTOT_CSF(:,:), SO_CI(:,:), tmp(:,:), U_CI_compl(:,:), V_CSF(:,:), V_SO(:,:)
! ----------------------------------------------------------------------
logical(kind=iwp) :: flag_decay, flag_dipole, flag_diss, flag_dyson, flag_emiss, flag_fdm, flag_so, flag_test
character(len=256) :: basis, dm_basis, method, p_style, pulse_type
character(len=64) :: out2_fmt, out3_fmt, out_fmt, out_fmt_csf
character(len=6), allocatable :: rassd_list(:)
character(len=*), parameter :: int2real = '(a,2i5,2f16.8)', &
                               scha = '(1x,a,t52,a)', &
                               scmp = '(1x,a,t45,f5.2,sp,f5.2,"i")', &
                               sdbl = '(1x,a,t45,f9.3)', &
                               sint = '(1x,a,t45,i8)', &
                               slog = '(1x,a,t45,l8)'
! ----------------------------------------------------------------------
! prep, out hdf5 files (description in cre_prep, cre_out)
integer(kind=iwp) :: out_decay_i, out_decay_r, out_dm_csf, out_dm_sf, out_dm_so, out_emiss, out_fdm, out_freq, out_ham_i, &
                     out_ham_r, out_id, out_pulse, out_t, out_tfdm, out_tout, prep_ci, prep_csfsoi, prep_csfsor, prep_dipolei, &
                     prep_dipoler, prep_dm_i, prep_dm_r, prep_do, prep_fhi, prep_fhr, prep_hcsf, prep_id, prep_uci, prep_vcsfi, &
                     prep_vcsfr
! predefined units for writing output, think of more clever choice:
integer(kind=iwp) :: lu_csf = 32, &
                     lu_dip = 34, &
                     lu_pls = 33, &
                     lu_sf = 31, &
                     lu_so = 30
! ----------------------------------------------------------------------
! variables used for density matrix propagation
integer(kind=iwp) :: N_L2, N_L3, N_Populated, Nmode, Npop, Nstep, Ntime_tmp_dm, Nval
logical(kind=iwp) :: HRSO, kext
real(kind=wp) :: alpha, dt, errorthreshold, finaltime, cgamma, initialtime, ion_diss, safety, T, tau_L2, tau_L3, time_fdm, &
                 timestep, tout
real(kind=wp), allocatable :: dgl(:), emiss(:)
complex(kind=wp), allocatable :: decay(:,:), density0(:,:), densityt(:,:), hamiltonian(:,:), hamiltoniant(:,:), k_bar_basis(:,:), &
                                 kab_basis(:,:), pulse_vector(:,:)
! Runge-Kutta midpoints
complex(kind=wp), allocatable :: ak1(:,:), ak2(:,:), ak3(:,:), ak4(:,:), ak5(:,:), ak6(:,:)
! pulse characteristics
integer(kind=iwp) :: N_pulse, power_shape
logical(kind=iwp) :: flag_acorrection, flag_pulse
real(kind=wp) :: linear_chirp
complex(kind=wp) :: pulse_vec(3)
real(kind=wp), allocatable :: amp(:), omega(:), phi(:), sigma(:), taushift(:)

public :: a_einstein, ak1, ak2, ak3, ak4, ak5, ak6, alpha, amp, basis, cgamma, CI, CSF2SO, d, decay, density0, densityt, dgl, &
          dipole, dipole_basis, DM0, DM_basis, dt, DTOC, dysamp, dysamp_bas, E, E_SF, E_SO, emiss, equation_func, errorthreshold, &
          finaltime, flag_acorrection, flag_decay, flag_dipole, flag_diss, flag_dyson, flag_emiss, flag_fdm, flag_pulse, flag_so, &
          flag_test, H_CSF, hamiltonian, hamiltoniant, HRSO, HSOCX, HTOT_CSF, HTOTRE_CSF, i_rasscf, initialtime, int2real, &
          ion_diss, ipglob, ispin, istates, k_b, K_bar_basis, kab_basis, kext, linear_chirp, lroots, lrootstot, lu_csf, lu_dip, &
          lu_pls, lu_sf, lu_so, maxlroots, maxnconf, method, N, n_freq, N_L2, N_L3, N_Populated, N_pulse, nconf, nconftot, ndet, &
          ndet_tot, Nmode, Npop, Nstate, Nstep, Ntime_tmp_dm, Nval, omega, out2_fmt, out3_fmt, out_decay_i, out_decay_r, &
          out_dm_csf, out_dm_sf, out_dm_so, out_emiss, out_fdm, out_fmt, out_fmt_csf, out_freq, out_ham_i, out_ham_r, out_id, &
          out_pulse, out_t, out_tfdm, out_tout, p_style, phi, power_shape, prep_ci, prep_csfsoi, prep_csfsor, prep_dipolei, &
          prep_dipoler, prep_dm_i, prep_dm_r, prep_do, prep_fhi, prep_fhr, prep_hcsf, prep_id, prep_uci, prep_vcsfi, prep_vcsfr, &
          pulse_func, pulse_type, pulse_vec, pulse_vector, rassd_list, runmode, safety, scha, scmp, sdbl, sigma, sint, slog, &
          SO_CI, T, tau_L2, tau_L3, taushift, threshold, time_fdm, timestep, tmp, tout, U_CI, U_CI_compl, V_CSF, V_SO

end module rhodyn_data

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! GET NUMBERS FROM STARTFILE.
subroutine Get8(Ract,Etot)

use qmstat_global, only: Cordst, iLuStIn, iPrint, iTcSim, nCent, nPart, StFilIn
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Ract, Etot
integer(kind=iwp) :: i, iDisk
real(kind=wp) :: Esub, Gamold, GaOld
character(len=200) :: Head
real(kind=wp), allocatable :: CT(:)

iDisk = 0
call DaName(iLuStIn,StFilIn)
call WrRdSim(iLuStIn,2,iDisk,iTcSim,64,Etot,Ract,nPart,Gamold,GaOld,Esub)
iDisk = iTcSim(1)

! In this loop we read the coordinates. The construction of Cordst
! makes this loop necessary. Maybe we should consider going to
! dynamic allocation.

call mma_allocate(CT,nPart*nCent,label='CTemp')
do i=1,3
  call dDaFile(iLuStIn,2,CT,nPart*nCent,iDisk)
  Cordst(i,:) = CT
  iDisk = iTcSim(i+1)
end do
call mma_deallocate(CT)
call DaClos(iLuStIn)

! If requested, print initial coordinates.

if (iPrint >= 10) then
  write(Head,*) 'Coordinates read from startfile.'
  call Cooout(Head,Cordst,nPart,nCent)
end if

return

end subroutine Get8

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Langevin(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq)

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: DBSC, ncnttp
use Center_Info, only: DC
use Langevin_arrays, only: CAVxyz, DAVxyz, DField, DIP, DipEF, Field, Grid, PolEF, RAVxyz
use External_Centers, only: iXPOLType, nOrd_XF, nXF, nXMolNr, XEle, XF, XMolNr
use Symmetry_Info, only: nIrrep
use rctfld_module, only: CordSI, DipCutOff, DIPSI, DistSparse, Done_Lattice, lDamping, lDipRestart, lFirstIter, lGridAverage, &
                         lLangevin, nCavxyz, nGrid, nGrid_Eff, nGridAverage, nGridSeed, nSparse, PolSI, RadLat, RotAlpha, RotBeta, &
                         RotGamma, Scala, TK
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, auTokJ, kBoltzmann
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nh1
real(kind=wp), intent(inout) :: h1(nh1), TwoHam(nh1), RepNuc
real(kind=wp), intent(in) :: D(nh1)
logical(kind=iwp), intent(in) :: First, Dff, NonEq
integer(kind=iwp) :: mdc, ndc, iCnttp, jCnttp, MaxAto, iCnt, jCnt, nC, mCnt, i, nAV, iSeed, iAV, Lu, j, Inc, iOrdOp, iXF, nCnt, &
                     iEle, k
integer(kind=iwp), save :: nAnisopol, nPolComp
logical(kind=iwp) :: Exists
real(kind=wp) :: ATOD, ATRad, SUMREPNUC, SumRepNuc2, XA, YA, Z, ZA
real(kind=wp), allocatable :: Atom_R(:), Chrg(:), Cord(:,:), D1ao(:), pField(:,:), tmpField(:,:)
real(kind=wp), parameter :: auToK = auTokJ/kBoltzmann*1.0e3_wp
real(kind=wp), external :: CovRadT, Random_molcas

#include "macros.fh"
unused_var(NonEq)

!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of all atoms
!
! Cord: list of all atoms
! Atom_R: associated effective atomic radius

mdc = 0
MaxAto = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag) cycle
  nCnt = dbsc(iCnttp)%nCntr
  do iCnt=1,nCnt
    mdc = mdc+1
    MaxAto = MaxAto+nIrrep/dc(mdc)%nStab
  end do
end do

call mma_allocate(Cord,3,MaxAto,Label='Cord')
call mma_allocate(Chrg,MaxAto,Label='Chrg')
call mma_allocate(Atom_R,MaxAto,Label='Atom_R')

ndc = 0
nc = 0
do jCnttp=1,nCnttp
  if (dbsc(jCnttp)%Aux .or. dbsc(jCnttp)%Frag) cycle
  Z = dbsc(jCnttp)%Charge
  mCnt = dbsc(jCnttp)%nCntr
  if (dbsc(jCnttp)%AtmNr >= 1) then
    !Atod = CovRad(dbsc(jCnttp)%AtmNr)
    Atod = CovRadT(dbsc(jCnttp)%AtmNr)
  else
    Atod = Zero
  end if
  do jCnt=1,mCnt
    ndc = ndc+1
    do i=0,nIrrep/dc(ndc)%nStab-1
      nc = nc+1
      call OA(dc(ndc)%iCoSet(i,0),dbsc(jCnttp)%Coor(1:3,jCnt),Cord(:,nc))
      Atom_R(nc) = Atod
      Chrg(nc) = Z
      !write(u6,*) 'Z=',Z
    end do
  end do
end do

if (LGridAverage) then
  nAv = nGridAverage
  if (nGridSeed == 0) then
    iSeed = 0
  else if (nGridSeed == -1) then
    iSeed = 0
    ! Use system_clock only for some systems
    !call System_clock(iSeed,j,k)
  else
    iSeed = nGridSeed
  end if
else
  nAv = 1
end if
sumRepNuc = Zero
sumRepNuc2 = Zero

do iAv=1,nAv
  if (LGridAverage) then
    cordsi(1,1) = Random_Molcas(iSeed)
    cordsi(2,1) = Random_Molcas(iSeed)
    cordsi(3,1) = Random_Molcas(iSeed)
    rotAlpha = Random_Molcas(iSeed)*180.0_wp
    rotBeta = Random_Molcas(iSeed)*180.0_wp
    rotGamma = Random_Molcas(iSeed)*180.0_wp
    write(u6,'(a,i4,a,6f10.4)') 'GRID NR',iAv,': ',cordsi(1,1),cordsi(2,1),cordsi(3,1),rotAlpha,rotBeta,rotGamma
    Done_Lattice = .false.
    RepNuc = Zero
  end if

  if (.not. Done_Lattice) then
    lFirstIter = .true.
    Done_Lattice = .true.
    if (iXPolType == 2) then
      nAnisopol = nXF
      nPolComp = 6
    else
      nAnisopol = 0
      nPolComp = 1
    end if

    ! Compute Effective Polarizabilities on the Langevin grid,
    ! flag also if points on the grid are excluded.
    ! This information is computed once!

    ! Grid : The Langevin grid
    ! PolEf: Effective Polarizability on grid
    ! DipEf: Effective Dipole moment on grid

    nGrid_Eff = 0
    ! Both these subroutines can increase nGrid_Eff
    if (iXPolType > 0) call lattXPol(Grid,nGrid,nGrid_Eff,PolEf,DipEf,XF,nXF,nOrd_XF,nPolComp)
    ! Note: Gen_Grid is now a part of the lattcr subroutine
    if (lLangevin) call lattcr(Grid,nGrid,nGrid_Eff,PolEf,DipEf,Cord,maxato,Atom_R,nPolComp,XF,nXF,nOrd_XF,XEle,iXPolType)
    !write(u6,*) 'nGrid,  nGrid_Eff',nGrid,nGrid_Eff

  end if

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute Electric Field from the Quantum Chemical System on the
  ! Langevin grid.

  ! cavxyz: MM expansion of the total charge of the QM system
  ! ravxyz: scratch
  ! dField: EF on Langevin grid due to QM system

  ! Get the total 1st order AO density matrix

  call mma_allocate(D1ao,nh1,Label='D1ao')
  call Get_dArray_chk('D1ao',D1ao,nh1)

  ! Save field from permanent multipoles for use in ener
  call mma_allocate(pField,4,nGrid_Eff,Label='pField')
  call mma_allocate(tmpField,4,nGrid_Eff,Label='tmpField')

  pField(:,:) = Zero

  call eperm(D1ao,nh1,Ravxyz,Cavxyz,nCavxyz,dField,Grid,nGrid_Eff,Cord,MaxAto,Chrg,pField)

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Save system info, to be used by visualisation program

  Lu = 21
  call OpnFl('LANGINFO',Lu,Exists)
  if (.not. Exists) then
    write(Lu,*) nc
    do i=1,nc
      write(Lu,11) int(Chrg(i)),Atom_R(i),(Cord(j,i),j=1,3)
    end do
    write(Lu,*) nXF
    Inc = 3
    do iOrdOp=0,nOrd_XF
      Inc = Inc+nTri_Elem1(iOrdOp)
    end do
    if (iXPolType > 0) Inc = Inc+6
    do iXF=1,nXF
      xa = XF(1,iXF)
      ya = XF(2,iXF)
      za = XF(3,iXF)
      if (XEle(iXF) <= 0) then
        atrad = -real(XEle(iXF),kind=wp)/1000.0_wp
        iele = 0
      else
        iele = XEle(iXF)
        atrad = CovRadT(iele)
      end if
      write(Lu,11) iele,atrad,xa,ya,za
    end do
    write(Lu,*) nGrid_eff,nAnisopol
    do i=1,nGrid_eff
      write(Lu,12) (Grid(j,i),j=1,3),PolEf(:,i),DipEf(i),(dField(j,i),j=1,3),(pField(j,i),j=1,3)
    end do
    write(Lu,*) polsi,dipsi,scala,auToK/tK
    write(Lu,*) (cordsi(k,1),k=1,3)
    write(Lu,*) rotAlpha,rotBeta,rotGamma
    write(Lu,*) radlat,nSparse,distSparse
    write(Lu,*) lDamping,dipCutoff
  end if
  close(Lu)

  tmpField(:,:) = dField(:,1:nGrid_eff)

  if (lDiprestart .or. lFirstIter) then
    Field(:,:) = Zero
    Dip(:,:) = Zero
    Davxyz(:) = Zero
  end if

  ! Subtract the static MM from the previous iteration
  ! from the static MM of this iteration, and save the
  ! untouched static MM of this iteration into Davxyz
  ! for use in the next iteration. Ravxyz is
  ! just a temporary array

  Ravxyz(:) = Cavxyz(:)
  Cavxyz(:) = Cavxyz(:)-Davxyz(:)
  Davxyz(:) = Ravxyz(:)

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Equation solver: compute the Langevin dipole moments and the
  !                  counter charge on the boundary of the cavity.

  ! Field : total EF of the Langevin grid
  ! Dip   : dipole momement on the Langevin grid

  call edip(Field,Dip,dField,PolEf,DipEf,Grid,nGrid_Eff,nPolComp,nAnisopol,nXF,iXPolType,nXMolnr,XMolnr)

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute contributions to RepNuc, h1, and TwoHam

  call Ener(h1,TwoHam,D,RepNuc,nh1,First,Dff,D1ao,Grid,nGrid_Eff,Dip,Field,DipEf,PolEf,Cord,MaxAto,Chrg,nPolComp,nAnisopol,pField, &
            tmpField)

  ! Subtract the static field from the self-consistent field
  ! This gives the field from the induced dipoles (saved
  ! in Field, to be used in the next iteration if
  ! not DRES has been requested

  Field(:,:) = Field(:,:)-tmpField(:,:)
  lFirstIter = .false.

  call mma_deallocate(pField)
  call mma_deallocate(tmpField)
  if (LGridAverage) then
    write(u6,'(a,i4,a,f18.10)') 'Solvation energy (Grid nr. ',iAv,'):',RepNuc
    sumRepNuc = sumRepNuc+RepNuc
    sumRepNuc2 = sumRepNuc2+RepNuc**2
  end if
end do
if (LGridAverage) write(u6,'(a,f18.10,f18.10)') 'Average solvation energy and stdev: ',sumRepNuc/real(nAv,kind=wp), &
                                                sqrt(sumRepNuc2/real(nAv,kind=wp)-(sumRepNuc/real(nAv,kind=wp))**2)
call mma_deallocate(Atom_R)
call mma_deallocate(D1ao)
call mma_deallocate(Chrg)
call mma_deallocate(Cord)
!                                                                      *
!***********************************************************************
!                                                                      *
return

11 format(i3,f10.4,3f16.8)
12 format(11f20.10)

end subroutine Langevin

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine defv (wrk,wrksize,
     & deftyp,possv0,mapdv,mapiv,ssv,
     & mapdr,mapir,ssr,rc)
c
c     this routine define v mediate as:
c     V_i(abc) = <ab||ic>  from integrals, stored in R_i(abc)
c     R _i(a,bc)bbb is a matrix, where integrals <ab|ic> are stored
c     for b>=c
c
c     deftyp - type of definition (see table) (I)
c     possv0 - initial address of V (I)
c     mapdv  - direct map of V (O)
c     mapiv  - inverse map of V (O)
c     ssv    - overall spin of V (O)
c     mapdr  - direct map of R (I)
c     mapir  - inverse map of R (I)
c     ssr    - overall spin of R (I)
c     rc     - return (error) code (O)
c
c     Table of definitions
c
c     deftyp         Operation                 Implement.
c     1      V(ab,c)aaa  = R(abc)-R(bac)         Yes
c     2      V(ab,c)bbb  = R(abc)-R(bac)         Yes
c     3      V(a,b,c)abb = R(abc)                Yes
c     4      V(a,b,c)aba = -R(bac)                Yes
c
#include "t31.fh"
#include "wrk.fh"
c
       integer deftyp,possv0,ssv,ssr,rc
       integer mapdv(0:512,1:6),mapdr(0:512,1:6)
       integer mapiv(1:8,1:8,1:8),mapir(1:8,1:8,1:8)
c
c     help variables
c
       integer posst,possv,possr1,possr2
       integer iv,ir1,ir2,syma,symb,symc
       integer nhelp1,nhelp2,nhelp3,nhelp4,nhelp5
       integer nhelp6,nhelp7,nhelp8,nhelp9,nhelp10
c
c
c0.*  def mapdv,mapiv
       if (deftyp.eq.1) then
c     case V(ab,c)aaa
       call cct3_grc0 (3,1,3,3,3,0,ssr,possv0,posst,mapdv,mapiv)
       else if (deftyp.eq.2) then
c     case V(ab,c)bbb
       call cct3_grc0 (3,1,4,4,4,0,ssr,possv0,posst,mapdv,mapiv)
       else if (deftyp.eq.3) then
c     case V(a,b,c)abb
       call cct3_grc0 (3,0,3,4,4,0,ssr,possv0,posst,mapdv,mapiv)
       else if (deftyp.eq.4) then
c     case V(a,b,c)aba
       call cct3_grc0 (3,0,3,4,3,0,ssr,possv0,posst,mapdv,mapiv)
       else
c     RC=1 , deftyp out of range (1-4) (Stup)
       rc=1
       return
       end if
c
c0.*  some tests
c

c0.*  define spin
       ssv=ssr
c
       if ((deftyp.eq.1).or.(deftyp.eq.2)) then
c
c12   case V(ab,c)aaa,bbb
c
       do 12 iv=1,mapdv(0,5)
c
c12.* def symmetries
       syma=mapdv(iv,3)
       symb=mapdv(iv,4)
       symc=mapdv(iv,5)
c
       if (syma.eq.symb) then
c12.1 syma=symb
c
       if (symb.eq.symc) then
c12.1.1            case syma=symb=symc
c
c12.1.1.*     def possitions of V, R1
       possv=mapdv(iv,1)
       ir1=mapir(syma,symb,1)
       possr1=mapdr(ir1,1)
c
c12.1.1.*     def dimensions
       nhelp1=nvb(syma)
       nhelp2=nhelp1*(nhelp1+1)/2
       nhelp4=dimm(mapdv(0,1),syma)
       nhelp3=nhelp4*(nhelp4-1)/2
       nhelp5=nvb(syma)-nhelp4
c
c12.1.1.*     realize definition of V
       call defvhlp1 (wrk(possr1),wrk(possv),
     & nhelp1,nhelp2,nhelp3,nhelp4,nhelp5)
c
       else
c12.1.2            case syma=symb.ne.symc
c
c12.1.2.*     def possitions of V, R1
       possv=mapdv(iv,1)
       if (syma.ge.symc) then
       ir1=mapir(syma,symb,1)
       else
       ir1=mapir(syma,symc,1)
       end if
       possr1=mapdr(ir1,1)
c
c12.1.2.*     def dimensions
       nhelp1=nvb(syma)
       nhelp2=nvb(symc)
       nhelp4=dimm(mapdv(0,1),syma)
       nhelp3=nhelp4*(nhelp4-1)/2
       nhelp5=dimm(mapdv(0,3),symc)
       nhelp6=nvb(syma)-nhelp4
       nhelp7=nvb(symc)-nhelp5
c
c12.1.2.*     realize definition of V
       if (syma.ge.symc) then
       call defvhlp21 (wrk(possr1),wrk(possv),nhelp1,nhelp2,
     & nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)
       else
       call defvhlp22 (wrk(possr1),wrk(possv),nhelp1,nhelp2,
     & nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)
       end if
c
       end if
c
       else
c12.2 syma > symb
c
       if (syma.eq.symc) then
c12.2.1     case syma>symb , syma=symc
c
c12.2.1.*     def possitions of V, R1, R2
       possv=mapdv(iv,1)
c     R1 is permuted, since (a=c)>b
       ir1=mapir(syma,symc,1)
       possr1=mapdr(ir1,1)
       ir2=mapir(symb,syma,1)
       possr2=mapdr(ir2,1)
c
c12.2.1.*     def dimensions
       nhelp1=nvb(syma)
       nhelp2=nvb(symb)
       nhelp3=nvb(symc)
       nhelp4=nhelp1*(nhelp1+1)/2
       nhelp5=dimm(mapdv(0,1),syma)
       nhelp6=dimm(mapdv(0,2),symb)
       nhelp7=dimm(mapdv(0,3),symc)
       nhelp8=nvb(syma)-nhelp5
       nhelp9=nvb(symb)-nhelp6
       nhelp10=nvb(symc)-nhelp7
c
c12.2.1.*     realize definition of V
       call defvhlp3 (wrk(possr1),wrk(possr2),wrk(possv),
     & nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,
     & nhelp6,nhelp7,nhelp8,nhelp9,nhelp10)
c
       else if (symb.eq.symc) then
c12.2.2     case syma>symb , symb=symc
c
c12.2.2.*     def possitions of V, R1, R2
       possv=mapdv(iv,1)
       ir1=mapir(syma,symb,1)
       possr1=mapdr(ir1,1)
       ir2=mapir(symb,syma,1)
       possr2=mapdr(ir2,1)
c
c12.2.2.*     def dimensions
       nhelp1=nvb(syma)
       nhelp3=nvb(symb)
       nhelp4=nvb(symc)
       nhelp2=nhelp3*(nhelp3+1)/2
       nhelp5=dimm(mapdv(0,1),syma)
       nhelp6=dimm(mapdv(0,2),symb)
       nhelp7=dimm(mapdv(0,3),symc)
       nhelp8=nvb(syma)-nhelp5
       nhelp9=nvb(symb)-nhelp6
       nhelp10=nvb(symc)-nhelp7
c
c12.2.2.*     realize definition of V
       call defvhlp4 (wrk(possr1),wrk(possr2),wrk(possv),
     & nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,
     & nhelp6,nhelp7,nhelp8,nhelp9,nhelp10)
c
       else
c12.2.3     case syma>symb , symc.ne.syma,symb
c
c
c12.2.3.*     def possitions of V, R1, R2
       possv=mapdv(iv,1)
c
       if (symb.ge.symc) then
       ir1=mapir(syma,symb,1)
       else
       ir1=mapir(syma,symc,1)
       end if
       possr1=mapdr(ir1,1)
c
       if (syma.ge.symc) then
       ir2=mapir(symb,syma,1)
       else
       ir2=mapir(symb,symc,1)
       end if
       possr2=mapdr(ir2,1)
c
c12.2.3.*     def dimensions
       nhelp1=nvb(syma)
       nhelp2=nvb(symb)
       nhelp3=nvb(symc)
       nhelp4=dimm(mapdv(0,1),syma)
       nhelp5=dimm(mapdv(0,2),symb)
       nhelp6=dimm(mapdv(0,3),symc)
       nhelp7=nvb(syma)-nhelp4
       nhelp8=nvb(symb)-nhelp5
       nhelp9=nvb(symc)-nhelp6
c
c12.2.3.*     realize definition of V
       if ((syma.gt.symc).and.(symb.gt.symc)) then
       call defvhlp51 (wrk(possr1),wrk(possr2),wrk(possv),
     & nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,
     & nhelp6,nhelp7,nhelp8,nhelp9)
       else if ((syma.gt.symc).and.(symb.lt.symc)) then
       call defvhlp52 (wrk(possr1),wrk(possr2),wrk(possv),
     & nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,
     & nhelp6,nhelp7,nhelp8,nhelp9)
       else if ((syma.lt.symc).and.(symb.gt.symc)) then
       call defvhlp53 (wrk(possr1),wrk(possr2),wrk(possv),
     & nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,
     & nhelp6,nhelp7,nhelp8,nhelp9)
       else if ((syma.lt.symc).and.(symb.lt.symc)) then
       call defvhlp54 (wrk(possr1),wrk(possr2),wrk(possv),
     & nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,
     & nhelp6,nhelp7,nhelp8,nhelp9)
       end if
c
       end if
c
       end if
c
 12     continue
c
c
       else if (deftyp.eq.3) then
c
c3    case V(a,b,c)abb
c
       do 3 iv=1,mapdv(0,5)
c
c3.*  def symmetries
       syma=mapdv(iv,3)
       symb=mapdv(iv,4)
       symc=mapdv(iv,5)
c
       if (symb.eq.symc) then
c3.1  symb=symc
c
c3.1.*def possitions of V, R1
       possv=mapdv(iv,1)
       ir1=mapir(syma,symb,1)
       possr1=mapdr(ir1,1)
c
c3.1.*def dimensions
       nhelp1=nvb(syma)
       nhelp2=nvb(symb)
       nhelp3=nhelp2*(nhelp2+1)/2
       nhelp4=dimm(mapdv(0,1),syma)
       nhelp5=dimm(mapdv(0,2),symb)
       nhelp6=dimm(mapdv(0,3),symc)
       nhelp7=nvb(syma)-nhelp4

c3.1.*realize definition of V
       call defvhlp7 (wrk(possr1),wrk(possv),nhelp1,nhelp2,
     & nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)
c
       else
c     case symb.ne.symc
c
c3.1.*def possitions of V, R1
       possv=mapdv(iv,1)
       if (symb.ge.symc) then
       ir1=mapir(syma,symb,1)
       else
       ir1=mapir(syma,symc,1)
       end if
       possr1=mapdr(ir1,1)
c
c3.1.*def dimensions
       nhelp1=nvb(syma)
       nhelp2=nvb(symb)
       nhelp3=nvb(symc)
       nhelp4=dimm(mapdv(0,1),syma)
       nhelp5=dimm(mapdv(0,2),symb)
       nhelp6=dimm(mapdv(0,3),symc)
       nhelp7=nvb(syma)-nhelp4
c
c3.1.*realize definition of V
       if (symb.gt.symc) then
       call defvhlp61 (wrk(possr1),wrk(possv),nhelp1,nhelp2,
     & nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)
       else
       call defvhlp62 (wrk(possr1),wrk(possv),nhelp1,nhelp2,
     & nhelp3,nhelp4,nhelp5,nhelp6,nhelp7)
       end if
c
       end if
c
 3      continue
c
       else if (deftyp.eq.4) then
c
c4    case V(a,b,c)aba
c
       do 4 iv=1,mapdv(0,5)
c
c4.*  def symmetries
       syma=mapdv(iv,3)
       symb=mapdv(iv,4)
       symc=mapdv(iv,5)
c
       if (syma.eq.symc) then
c4.1  syma=symc
c
c4.1.*def possitions of V, R2
       possv=mapdv(iv,1)
       ir2=mapir(symb,syma,1)
       possr2=mapdr(ir2,1)
c
c4.1.*def dimensions
       nhelp1=nvb(symb)
       nhelp2=nvb(syma)
       nhelp3=nhelp2*(nhelp2+1)/2
       nhelp4=dimm(mapdv(0,1),syma)
       nhelp5=dimm(mapdv(0,2),symb)
       nhelp6=dimm(mapdv(0,3),symc)
       nhelp7=nvb(syma)-nhelp4
       nhelp8=nvb(symc)-nhelp6
c
c4.1.*realize definition of V
       call defvhlp9 (wrk(possr2),wrk(possv),nhelp1,nhelp2,
     & nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8)
c
       else
c     case symb.ne.symc
c
c4.1.*def possitions of V, R2
       possv=mapdv(iv,1)
       if (syma.ge.symc) then
       ir2=mapir(symb,syma,1)
       else
       ir2=mapir(symb,symc,1)
       end if
       possr2=mapdr(ir2,1)
c
c4.1.*def dimensions
       nhelp1=nvb(symb)
       nhelp2=nvb(syma)
       nhelp3=nvb(symc)
       nhelp4=dimm(mapdv(0,1),syma)
       nhelp5=dimm(mapdv(0,2),symb)
       nhelp6=dimm(mapdv(0,3),symc)
       nhelp7=nvb(syma)-nhelp4
       nhelp8=nvb(symc)-nhelp6
c
c4.1.*realize definition of V
       if (syma.gt.symc) then
       call defvhlp81 (wrk(possr2),wrk(possv),nhelp1,nhelp2,
     & nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8)
       else
       call defvhlp82 (wrk(possr2),wrk(possv),nhelp1,nhelp2,
     & nhelp3,nhelp4,nhelp5,nhelp6,nhelp7,nhelp8)
       end if
c
       end if
c
 4      continue
c
       else
c     not implemented deftyp
c
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine PotGrd(Temp,nGrad)
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External PCMGrd1,PCMMmg
#include "Molcas.fh"
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "disp.fh"
#include "wldata.fh"
#include "rctfld.fh"
      Character Method*8, Label*80
      Real*8 Temp(nGrad)
      Logical DiffOp
      Real*8, Allocatable:: D_Var(:)
*
*-----Statement function
*
      nElem(i) = (i+1)*(i+2)/2
*
*...  Prologue
      iRout = 131
      iPrint = nPrint(iRout)
      Call CWTime(TCpu1,TWall1)
*
*---- Allocate memory for density
*
      nDens = 0
      Do iIrrep = 0, nIrrep - 1
         nDens = nDens + nBas(iIrrep)*(nBas(iIrrep)+1)/2
      End Do
*
*...  Get the method label
*     print *,' Read Method label'
      Call Get_cArray('Relax Method',Method,8)
*
*...  Read the variational 1st order density matrix
*...  density matrix in AO/SO basis
*     print *,' Read density matrix'
      Call mma_allocate(D_Var,nDens,Label='D_Var')
      Call Get_D1ao_Var(D_var,nDens)
*
      If (iPrint.ge.99) then
         Write(6,*) 'variational 1st order density matrix'
         ii=1
         Do iIrrep = 0, nIrrep - 1
            Write(6,*) 'symmetry block',iIrrep
            Call TriPrt(' ',' ',D_Var(ii),nBas(iIrrep))
            ii = ii + nBas(iIrrep)*(nBas(iIrrep)+1)/2
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     nOrdOp: order/rank of the operator
*     Work(ip1): lOper of each component of the operator
*
      nOrdOp=0
      nComp = nElem(nOrdOp)
      Call GetMem('Coor','Allo','Real',ipC,3*nComp)
      Call GetMem('lOper','Allo','Inte',ip1,nComp)
      call dcopy_(nComp*3,[Zero],0,Work(ipC),1)
      iWork(ip1) = 1
      DiffOp = .True.
      Call dZero(Temp,nGrad)
      Call OneEl_g_mck(PCMGrd1,PCMMmG,Temp,nGrad,DiffOp,Work(ipC),
     &                 D_Var,nDens,iWork(ip1),nComp,nOrdOp,
     &             Label)
      Call PrGrad_mck(' TEST '
     &   //'(PCM) contribution',Temp,nGrad,ChDisp,5)
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('lOper','Free','Inte',ip1,nComp)
      Call GetMem('Coor','Free','Real',ipC,3*nComp)
*                                                                      *
************************************************************************
*                                                                      *
*...  Epilogue, end
*
*
      Call mma_deallocate(D_Var)
*
      Call CWTime(TCpu2,TWall2)
      Call SavTim(3,TCpu2-TCpu1,TWall2-TWall1)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine evbd_cvb(orbs,cvb,fx,ioptc,iter)

use casvb_global, only: corenrg, evb, ifollow, isaddle, isaddledd, ipdd, ipr, follow, have_solved_it, maxdav, mxiter, n_div, &
                        norb, nortiter, nroot, nvb, orththr, ovraa, resthr
use casvb_interfaces, only: ddasonc_sub, ddres_sub, ddres2upd_sub, ddsol_sub
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: orbs(norb,norb)
real(kind=wp), intent(inout) :: cvb(nvb)
real(kind=wp), intent(out) :: fx
integer(kind=iwp), intent(out) :: ioptc, iter
integer(kind=iwp) :: ifollow1, nvguess, nvrestart
real(kind=wp), allocatable :: axc(:,:), c(:,:), dum(:), hp(:,:), res(:), solp(:), solp_res(:), sxc(:,:)
procedure(ddasonc_sub) :: asonc_cvb
procedure(ddres_sub) :: ddres7_cvb
procedure(ddres2upd_sub) :: ddres2upd10_cvb
procedure(ddsol_sub) :: ddsol7_cvb

call makegjorbs_cvb(orbs)

ioptc = 1
nvguess = 1
nvrestart = 0
call mma_allocate(c,nvb,maxdav,label='c')
c(:,1) = cvb(:)
if (.not. follow) then
  ifollow1 = 2
else
  ifollow1 = 4
end if

ifollow = ifollow1
isaddledd = isaddle
nroot = max(1,isaddledd+1)
ipdd = ipr(3)
n_div = 0
call mma_allocate(axc,nvb,maxdav,label='axc')
call mma_allocate(sxc,nvb,maxdav,label='sxc')
call mma_allocate(res,nvb,label='res')
call mma_allocate(hp,maxdav,maxdav,label='hp')
call mma_allocate(solp,maxdav,label='solp')
call mma_allocate(solp_res,maxdav,label='solp_res')
call mma_allocate(dum,max(nvb,maxdav),label='dum')
call dirdiag_cvb(asonc_cvb,ddsol7_cvb,ddres7_cvb,ddres2upd10_cvb,c,axc,sxc,.false.,cvb,res,dum,hp,dum,solp,solp_res,.false., &
                 .true.,.false.,maxdav,nvb,nvb,nvguess,nvrestart,isaddle,ifollow1,mxiter,resthr,orththr,nortiter,corenrg,ioptc, &
                 iter,fx,ipr(3))
call mma_deallocate(c)
call mma_deallocate(axc)
call mma_deallocate(sxc)
call mma_deallocate(res)
call mma_deallocate(hp)
call mma_deallocate(solp)
call mma_deallocate(solp_res)
call mma_deallocate(dum)
have_solved_it = .true.

ovraa = One
evb = fx

return

end subroutine evbd_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagFro2(NBSQT,DPT2,FPT2,ERI,Scr)

use caspt2_module, only: NBAS, NDEL, NFRO, NISH, NSYM
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NBSQT
real(kind=wp), intent(in) :: DPT2(NBSQT)
real(kind=wp), intent(inout) :: FPT2(NBSQT)
real(kind=wp), intent(out) :: ERI(NBSQT), Scr(NBSQT)
integer(kind=iwp) :: iMO, iOrb, iSym, iSymA, iSymB, iSymI, iSymJ, jOrb, nFroI, nIshI, nOrbI
real(kind=wp) :: Scal, Val

!write(u6,*) 'FPT2 before frozen orbital'
!call sqprt(fpt2,nbast)
iMO = 1
isymi = 1
isymj = 1
isyma = 1
isymb = 1
do iSym=1,nSym
  nOrbI = nBas(iSym)-nDel(iSym)
  nFroI = nFro(iSym)
  nIshI = nIsh(iSym)
  !! Fpq = ((pq|rs)-1/2(pr|qs))*Drs
  do iOrb=1,nFroI
    do jOrb=nFroI+1,nFroI+nIshI
      Scal = DPT2(iMO+iOrb-1+nOrbI*(jOrb-1))
      call Coul(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,ERI,Scr)
      FPT2(iMO:iMO+nOrbI*nOrbI-1) = FPT2(iMO:iMO+nOrbI*nOrbI-1)+Scal*ERI(1:nOrbI*nOrbI)
      call Exch(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,ERI,Scr)
      FPT2(iMO:iMO+nOrbI*nOrbI-1) = FPT2(iMO:iMO+nOrbI*nOrbI-1)-Half*Scal*ERI(1:nOrbI*nOrbI)
    end do
  end do

  !! Symmetrize FPT2
  do iOrb=1,nOrbI
    do jOrb=1,iOrb-1
      Val = (FPT2(iMO+iOrb-1+nOrbI*(jOrb-1))+FPT2(iMO+jOrb-1+nOrbI*(iOrb-1)))*Half
      FPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) = Val
      FPT2(iMO+jOrb-1+nOrbI*(iOrb-1)) = Val
    end do
  end do
  iMO = iMO+nOrbI*nOrbI
end do
!write(u6,*) 'FPT2 after frozen orbital'
!call sqprt(fpt2,nbast)

end subroutine OLagFro2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!> Cleanup and close files
subroutine pt2close()

use nevpt2_cfg, only: MultGroup
use info_state_energy, only: deinit_energies         ! energies
use info_orbital_space, only: finalize_inforb_molcas ! orbital specifications read from JobIph
use nevpt2wfn, only: nevpt2wfn_close
use stdalloc, only: mma_deallocate

implicit none
#include "mxdm.fh"
#include "caspt2.fh"

call nevpt2wfn_close()
call deinit_energies()
call finalize_inforb_molcas()

if (allocated(MultGroup%h5_file_name)) call mma_deallocate(MultGroup%h5_file_name)

!> close file LUONEM
call DaClos(LUONEM)

end subroutine pt2close

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine GenBMp(irc,X,n,m,Lunit,nStp,StpSiz,Color)
      Implicit None
      Integer irc, n, m, Lunit, nStp
      Real*8  X(n,m), StpSiz
      Character*1 Color
#include "WrkSpc.fh"

      Character*6 SecNam
      Parameter (SecNam = 'GenBMp')

      Integer i, j, iBin, nBin, ipBin, ipBMp, nCh
      Real*8  Step, absX
      Character*1 myColor

      Integer nBin_Def, iUpLim, i0, i255
      Real*8  Step_Def
      Character*1 Color_Def

      Integer  iRnge
      External iRnge

C     Defaults and limits.
C     --------------------

      nBin_Def  = 5
      Step_Def  = 1.0d-2
      Color_Def = 'R'
      iUpLim    = 999999
      i0        = 0
      i255      = 255

C     Check input.
C     ------------

      irc = 0
      If (n.lt.1 .or. m.lt.1) Then
         Return
      End If
      If (n.gt.iUpLim .or. m.gt.iUpLim) Then
         irc = 1
         Return
      End If
      If (Lunit .lt. 1) Then
         irc = 2
         Return
      End If

      If (nStp.lt.2 .or. nStp.gt.256) Then
         nBin = nBin_Def
      Else
         nBin = nStp
      End If
      If (StpSiz .le. 0.0d0) Then
         Step = Step_Def
      Else
         Step = StpSiz
      End If
      myColor = Color
      Call UpCase(myColor)
      If (myColor.ne.'R' .and. myColor.ne.'G' .and. myColor.ne.'B') Then
         myColor = Color_Def
      End If

C     Set up bins.
C     ------------

      nCh = 255/(nBin-1)

      Call GetMem('Bins','Allo','Real',ipBin,nBin)
      Call GetMem('iBMp','Allo','Inte',ipBMp,nBin)

      Work(ipBin) = 1.0d0
      Do iBin = 2,nBin-1
         Work(ipBin-1+iBin)  = Work(ipBin+iBin-2)*Step
      End Do
      Work(ipBin-1+nBin) = -1.0d0

      iWork(ipBMp-1+nBin) = 255
      Do iBin = nBin-1,1,-1
         iWork(ipBMp-1+iBin) = iWork(ipBMp+iBin) - nCh
      End Do

C     Generate bitmap file.
C     Note the special loop structure.
C     --------------------------------

      Write(Lunit,'(2(1X,I6))') m,n ! #col,#row
      If (myColor .eq. 'R') Then ! red
         Do i = n,1,-1
            Do j = 1,m
               absX = abs(X(i,j))
               iBin = iRnge(absX,Work(ipBin),nBin)
               If (iWork(ipBmp+iBin-1) .eq. 255) Then
                  Write(Lunit,'(4(1X,I3))') i255,i255,i255,i0
               Else
                  Write(Lunit,'(4(1X,I3))') iWork(ipBmp+iBin-1),i0,i0,i0
               End If
            End Do
         End Do
      Else If (myColor .eq. 'G') Then ! green
         Do i = n,1,-1
            Do j = 1,m
               absX = abs(X(i,j))
               iBin = iRnge(absX,Work(ipBin),nBin)
               If (iWork(ipBmp+iBin-1) .eq. 0) Then
                  Write(Lunit,'(4(1X,I3))') i255,i255,i255,i0
               Else
                  Write(Lunit,'(4(1X,I3))') i0,iWork(ipBmp+iBin-1),i0,i0
               End If
            End Do
         End Do
      Else If (myColor .eq. 'B') Then ! blue
         Do i = n,1,-1
            Do j = 1,m
               absX = abs(X(i,j))
               iBin = iRnge(absX,Work(ipBin),nBin)
               If (iWork(ipBmp+iBin-1) .eq. 0) Then
                  Write(Lunit,'(4(1X,I3))') i255,i255,i255,i0
               Else
                  Write(Lunit,'(4(1X,I3))') i0,i0,iWork(ipBmp+iBin-1),i0
               End If
            End Do
         End Do
      Else
         Call SysAbendMsg(SecNam,'Logical error!',
     &                    '(Should never happen)')
      End If

C     De-allocations.
C     ---------------

      Call GetMem('iBMp','Free','Inte',ipBMp,nBin)
      Call GetMem('Bins','Free','Real',ipBin,nBin)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Mk_SO2cI(SO2cI,iSO2Shell,nSOs)
      Implicit Real*8 (a-h,o-z)
      Integer SO2cI(2,nSOs), iSO2Shell(nSOs)
*                                                                      *
************************************************************************
*                                                                      *
*-----Set up table SO to contigues index over the shell
*
*     Write (*,*) 'Enter SO2cI'
      Call ICopy(2*nSOs,[0],0,SO2cI,1)
      Call Nr_Shells(nShell)
      Do iShell = 1, nShell
*
*------- Generate contigues index for this shell
*
         Index=0
         Do iSO = 1, nSOs
            If (iSO2Shell(iSO).eq.iShell) Then
               Index = Index + 1
               SO2cI(1,iSO) = Index
            End If
         End Do
*
*------- Store dimension for this shell
*
         Do iSO = 1, nSOs
            If (iSO2Shell(iSO).eq.iShell) Then
               SO2cI(2,iSO) = Index
            End If
         End Do
*
      End Do ! iShell
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine read_formatted_aniso( input_file_name, nss, nstate,
     &                                multiplicity, eso, esfs,
     &                                U, MM, MS, ML, DM, ANGMOM, EDMOM,
     &                                AMFI, HSO )
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(inout)        :: nss, nstate
      Integer, intent(out)          :: multiplicity(nstate)
      Real(kind=8), intent(out)    :: eso(nss), esfs(nstate)
      Real(kind=8), intent(out)    ::  edmom(3,nstate,nstate)
      Real(kind=8), intent(out)    :: angmom(3,nstate,nstate)
      Real(kind=8), intent(out)    ::   amfi(3,nstate,nstate)
      Complex(kind=8), intent(out) :: MM(3,nss,nss)
      Complex(kind=8), intent(out) :: MS(3,nss,nss)
      Complex(kind=8), intent(out) :: ML(3,nss,nss)
!     electric dipole moment
      Complex(kind=8), intent(out) :: DM(3,nss,nss)
      Complex(kind=8), intent(out) ::   U(nss,nss)
      Complex(kind=8), intent(out) :: HSO(nss,nss)
      Character(Len=180)            :: input_file_name
      ! local variables:
      Integer       :: l,j,j1,j2,LuAniso,IsFreeUnit
      Real(kind=8) :: g_e
      Real(kind=8), allocatable :: tmpR(:,:), tmpI(:,:)
      External      :: IsFreeUnit
      logical :: DBG

      dbg=.false.

      If(dbg) write(6,'(A)') 'Enterring read_formatted_aniso'
      call xFlush(6)
      g_e=2.00231930437180_wp
c   set to zero all arrays:
      multiplicity=0
      eso=0.0_wp
      esfs=0.0_wp
      edmom=0.0_wp
      angmom=0.0_wp
      MM=(0.0_wp,0.0_wp)
      MS=(0.0_wp,0.0_wp)
      ML=(0.0_wp,0.0_wp)
      DM=(0.0_wp,0.0_wp)
       U=(0.0_wp,0.0_wp)
c  read the file "aniso.input":
      LuAniso=IsFreeUnit(81)
      Call molcas_open(LuAniso,trim(input_file_name))
c compatibility with the present version: of aniso_i.input file
      read(LuAniso,*) nstate, nss
      If(dbg) write(6,'(A,2I6)') 'nstate, nss:',nstate, nss
      call xFlush(6)
      read(LuAniso,*) (eso(j),j=1,nss)
      If(dbg) then
         write(6,'(A)') 'ESO:'
         write(6,'(5ES24.14)') (eso(j),j=1,nss)
      End If
      read(LuAniso,*) (multiplicity(j),j=1,nstate)
      If(dbg) then
         write(6,'(A)') '(multiplicity(j),j=1,nstate)'
         write(6,'(50I3)') (multiplicity(j),j=1,nstate)
      End If
      call xFlush(6)

      Call mma_allocate(tmpR,nss,nss,'tmpR')
      Call mma_allocate(tmpI,nss,nss,'tmpI')
      ! magnetic moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do j1=1,nss
          read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss )
        End Do
        Do j1=1,nss
          Do j2=1,nss
            MM(l,j1,j2) = cmplx( tmpR(j1,j2), tmpI(j1,j2), wp )
          End Do
        End Do
      End Do
      call xFlush(6)

      ! spin moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do j1=1,nss
          read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss )
        End Do
        Do j1=1,nss
          Do j2=1,nss
            MS(l,j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
          End Do
        End Do
      End Do

      ! spin-free energies
      read(LuAniso,*) (esfs(j),j=1,nstate)
      If(dbg) then
         write(6,'(A)') 'ESFS:'
         write(6,'(5ES24.14)') (esfs(j),j=1,nstate)
      End If

      ! U matrix
      tmpR=0.0_wp
      tmpI=0.0_wp
      Do j1=1,nss
        read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss )
      End Do

      Do j1=1,nss
        Do j2=1,nss
          U(j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
        End Do
      End Do

      ! angmom
      Do l=1,3
        Do j1=1,nstate
          Read(LuAniso,*) ( angmom(l,j1,j2), j2=1,nstate )
        End Do
      End Do

      ! compute the orbital moment
      Do l=1,3
        Do j1=1,nss
          Do j2=1,nss
            ML(l,j1,j2) = -MM(l,j1,j2) - MS(l,j1,j2)*g_e
          End Do
        End Do
      End Do

      ! DMmom
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do j1=1,nss
          read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss )
        End Do
        Do j1=1,nss
          Do j2=1,nss
            DM(l,j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
          End Do
        End Do
      End Do

      ! edmom
      Do l=1,3
        Do j1=1,nstate
          Read(LuAniso,*) (edmom(l,j1,j2),j2=1,nstate)
        End Do
      End Do

      ! amfi
      Do l=1,3
        Do j1=1,nstate
          Read(LuAniso,*) (amfi(l,j1,j2),j2=1,nstate)
        End Do
      End Do

      ! HSO matrix
      tmpR=0.0_wp
      tmpI=0.0_wp
      Do j1=1,nss
        read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss )
      End Do

      Do j1=1,nss
        Do j2=1,nss
          HSO(j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
        End Do
      End Do

      Call mma_deallocate(tmpR)
      Call mma_deallocate(tmpI)

      Close(LuAniso)
      Return
      End



      Subroutine read_formatted_aniso_old( input_file_name, nss, nstate,
     &                                multiplicity, eso, MM, MS, ML )
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(inout)        :: nss, nstate
      Integer, intent(out)          :: multiplicity(nstate)
      Real(kind=8), intent(out)    :: eso(nss)
      Complex(kind=8), intent(out) :: MM(3,nss,nss)
      Complex(kind=8), intent(out) :: MS(3,nss,nss)
      Complex(kind=8), intent(out) :: ML(3,nss,nss)
      Character(Len=180)            :: input_file_name
      ! local variables:
      Integer       :: l,j,j1,j2,LuAniso,IsFreeUnit
      Real(kind=8) :: g_e
      Real(kind=8), allocatable :: tmpR(:,:), tmpI(:,:)
      External      :: IsFreeUnit

      g_e=2.00231930437180_wp
c   set to zero all arrays:
      multiplicity=0
      eso=0.0_wp
        MM=(0.0_wp,0.0_wp)
        MS=(0.0_wp,0.0_wp)
        ML=(0.0_wp,0.0_wp)
c  read the file "aniso.input":
      LuAniso=IsFreeUnit(81)
      Call molcas_open(LuAniso,trim(input_file_name))
c compatibility with the present version: of aniso_i.input file
      read(LuAniso,*) nstate, nss
      read(LuAniso,*) (eso(j),j=1,nss)
      read(LuAniso,*) (multiplicity(j),j=1,nstate)

      Call mma_allocate(tmpR,nss,nss,'tmpR')
      Call mma_allocate(tmpI,nss,nss,'tmpI')
      ! magnetic moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do j1=1,nss
          read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss )
        End Do
        Do j1=1,nss
          Do j2=1,nss
            MM(l,j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
          End Do
        End Do
      End Do

      ! spin moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do j1=1,nss
          read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss )
        End Do
        Do j1=1,nss
          Do j2=1,nss
            MS(l,j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
          End Do
        End Do
      End Do
      Call mma_deallocate(tmpR)
      Call mma_deallocate(tmpI)

      ! compute the orbital moment
      Do l=1,3
        Do j1=1,nss
          Do j2=1,nss
            ML(l,j1,j2) = -MM(l,j1,j2) - MS(l,j1,j2)*g_e
          End Do
        End Do
      End Do

c      If (iprint.gt.4) Then
c        Write(6,'(10a12)') (('------------'),j=1,10)
c        Write(6,'(15x,a,i2,a)') 'aniso_.input'
c        Write(6,'(10a12)') (('------------'),j=1,10)
c        Write(6,'(5x,a,i6)') 'nstate = ',nstate
c        Write(6,'(5x,a,i6)') '   nss = ',nss
c        Write(6,'(5x,a)')    ' eso(j): '
c        Write(6,'(10(f12.5,1x))') (eso(j),j=1,nss)
c        Write(6,'(5x,a,i2,a)') 'multiplicity(j):'
c        Write(6,'(40i3)') (multiplicity(j),j=1,nstate)
c        Write(6,'(5x,a,i2,a)') 'dipso(l,j1,j2):'
c        Do l=1,3
c          Write(6,'(5x,a,i2)') 'axis= ',l
c          Do j1=1,nss
c            Write(6,'(20(2f20.14,1x))') (MM(l,j1,j2), j2=1,nss)
c          End Do
c        End Do
c        Write(6,*)
c        Write(6,'(5x,a,i2,a)') 's_so(l,j1,j2):'
c        Do l=1,3
c          Write(6,'(5x,a,i2)') 'axis= ',l
c          Do j1=1,nss
c            Write(6,'(20(2f20.14,1x))') (MS(l,j1,j2), j2=1,nss)
c          End Do
c        End Do
c      End If
      close(LuAniso)
      Return
      End


      Subroutine read_formatted_aniso_poly( input_file_name, nss,
     &                                      nstate, nLoc, eso, MM, MS,
     &                                      iReturn )
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(inout)        :: nss, nstate, nLoc, iReturn
      ! nLoc is the maximal value of the array nss(1:nneq)
      Real(kind=8), intent(out)    :: eso(nLoc)
      Complex(kind=8), intent(out) :: MM(3,nLoc,nLoc)
      Complex(kind=8), intent(out) :: MS(3,nLoc,nLoc)
      Character(len=180)            :: input_file_name
      ! local variables:
      Integer       :: l,j,j1,j2,LuAniso,IsFreeUnit
      Integer       :: multiplicity(nLoc)
      Real(kind=8), allocatable :: tmpR(:,:), tmpI(:,:)
      External      :: IsFreeUnit

c   set to zero all arrays:
      iReturn=0
      multiplicity=0
      eso(:)=0.0_wp
      MM(:,:,:)=(0.0_wp,0.0_wp)
      MS(:,:,:)=(0.0_wp,0.0_wp)
c  read the file "aniso.input":
      LuAniso=IsFreeUnit(40)
      Call molcas_open( LuAniso, input_file_name )
c compatibility with the present version: of aniso_i.input file
      read(LuAniso,*) nstate, nss
      read(LuAniso,*) (eso(j),j=1,nss)
      read(LuAniso,*) (multiplicity(j),j=1,nstate)

      Call mma_allocate(tmpR,nss,nss,'tmpR')
      Call mma_allocate(tmpI,nss,nss,'tmpI')
      ! magnetic moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do j1=1,nss
          read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss )
        End Do
        Do j1=1,nss
          Do j2=1,nss
            MM(l,j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
          End Do
        End Do
      End Do

      ! spin moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do j1=1,nss
          read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss )
        End Do
        Do j1=1,nss
          Do j2=1,nss
            MS(l,j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
          End Do
        End Do
      End Do
      Call mma_deallocate(tmpR)
      Call mma_deallocate(tmpI)
c
c      If (iprint.gt.4) Then
c        Write(6,'(10a12)') (('------------'),j=1,10)
c        Write(6,'(15x,a,i2,a)') 'aniso_.input'
c        Write(6,'(10a12)') (('------------'),j=1,10)
c        Write(6,'(5x,a,i6)') 'nstate = ',nstate
c        Write(6,'(5x,a,i6)') '   nss = ',nss
c        Write(6,'(5x,a)')    ' eso(j): '
c        Write(6,'(10(f12.5,1x))') (eso(j),j=1,nss)
c        Write(6,'(5x,a,i2,a)') 'multiplicity(j):'
c        Write(6,'(40i3)') (multiplicity(j),j=1,nstate)
c        Write(6,'(5x,a,i2,a)') 'dipso(l,j1,j2):'
c        Do l=1,3
c          Write(6,'(5x,a,i2)') 'axis= ',l
c          Do j1=1,nss
c            Write(6,'(20(2f20.14,1x))') (MM(l,j1,j2), j2=1,nss)
c          End Do
c        End Do
c        Write(6,*)
c        Write(6,'(5x,a,i2,a)') 's_so(l,j1,j2):'
c        Do l=1,3
c          Write(6,'(5x,a,i2)') 'axis= ',l
c          Do j1=1,nss
c            Write(6,'(20(2f20.14,1x))') (MS(l,j1,j2), j2=1,nss)
c          End Do
c        End Do
c      End If
      Close(LuAniso)
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer_array(multiplicity)
#endif
      End









      Subroutine write_formatted_aniso( nss, nstate, multiplicity, eso,
     &                                  esfs, U, MM, MS, DM, angmom,
     &                                  edmom, amfi, HSO )

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)          :: nss, nstate, multiplicity(nstate)
      Real(kind=8), intent(in)    :: eso(nss), esfs(nstate)
      Real(kind=8), intent(in)    :: angmom(3,nstate,nstate)
      Real(kind=8), intent(in)    ::  edmom(3,nstate,nstate)
      Real(kind=8), intent(in)    ::   amfi(3,nstate,nstate)
      Complex(kind=8), intent(in) :: MM(3,nss,nss)
      Complex(kind=8), intent(in) :: MS(3,nss,nss)
      Complex(kind=8), intent(in) :: DM(3,nss,nss)
      Complex(kind=8), intent(in) ::    U(nss,nss)
      Complex(kind=8), intent(in) ::  HSO(nss,nss)
      ! local stuff
      Integer                      :: l,i,j,LuAniso,IsFreeUnit
      External                     :: IsFreeUnit

      LuAniso=IsFreeUnit(81)
      Call molcas_open(LuAniso,'ANISOINPUT')
      Write(LuAniso,'(2i10)') nstate, nss
      Write(LuAniso,'(5ES24.14)') (eso(i),i=1,nss)
      Write(LuAniso,'(30i4)') (multiplicity(i),i=1,nstate)
      Do l=1,3
         Do i=1,nss
            Write(LuAniso,'(5ES24.14)') (MM(l,i,j),j=1,nss)
         End Do
      End Do
      Do l=1,3
         Do i=1,nss
            Write(LuAniso,'(5ES24.14)') (MS(l,i,j),j=1,nss)
         End Do
      End Do
      ! add data at the end, so that we do not break the functionality
      ! with the present format:
      Write(LuAniso,'(5ES24.14)') (esfs(i),i=1,nstate)
      Do i=1,nss
         Write(LuAniso,'(5ES24.14)') (U(i,j) ,j=1,nss)
      End Do
      ! angmom
      Do l=1,3
        Do i=1,nstate
          Write(LuAniso,'(5ES24.14)') (angmom(l,i,j),j=1,nstate)
        End Do
      End Do

      ! DMmom
      Do l=1,3
        Do i=1,nss
          Write(LuAniso,'(5ES24.14)') (DM(l,i,j),j=1,nss)
        End Do
      End Do

      ! edmom
      Do l=1,3
        Do i=1,nstate
          Write(LuAniso,'(5ES24.14)') (edmom(l,i,j),j=1,nstate)
        End Do
      End Do

      ! amfi
      Do l=1,3
        Do i=1,nstate
          Write(LuAniso,'(5ES24.14)') (amfi(l,i,j),j=1,nstate)
        End Do
      End Do

      ! HSO matrix
      Do i=1,nss
         Write(LuAniso,'(5ES24.14)') (HSO(i,j) ,j=1,nss)
      End Do

      Close(LuAniso)
      Return
      End




      Subroutine read_aniso_old_exch( input_file_name, nss, eso,
     &                                MM, MS, ML )
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)           :: nss
      Real(kind=8), intent(out)    :: eso(nss)
      Complex(kind=8), intent(out) :: MM(3,nss,nss)
      Complex(kind=8), intent(out) :: MS(3,nss,nss)
      Complex(kind=8), intent(out) :: ML(3,nss,nss)
      Character(Len=180)            :: input_file_name
      ! local variables:
      Integer       :: nss_local, nstate_local
      Integer       :: l,j,j1,j2,LuAniso,IsFreeUnit
      Real(kind=8) :: g_e
      Real(kind=8), allocatable :: tmpR(:,:), tmpI(:,:), tmp(:)
      External      :: IsFreeUnit
!     in this subroutine nss is input data




      g_e=2.00231930437180_wp
c   set to zero all arrays:
      eso=0.0_wp
        MM=(0.0_wp,0.0_wp)
        MS=(0.0_wp,0.0_wp)
        ML=(0.0_wp,0.0_wp)
      nss_local=0
      nstate_local=0

c  read the file "aniso.input":
      LuAniso=IsFreeUnit(81)
      Call molcas_open(LuAniso,trim(input_file_name))
c compatibility with the present version: of aniso_i.input file
      read(LuAniso,*) nstate_local, nss_local
!---------------------------------------------------------
      Call mma_allocate(tmp,nss_local,'tmp')
      Call dcopy_(nss_local,[0.0_wp],0,tmp,1)
      ! local spin-orbit energy
      read(LuAniso,*) (tmp(j),j=1,nss_local)
      ! copy the lowest nss states to eso:
      Do j=1,nss
        eso(j) = tmp(j)
      End Do
      Call mma_deallocate(tmp)
!---------------------------------------------------------
      read(LuAniso,*) (l,j=1,nstate_local)
!---------------------------------------------------------

      Call mma_allocate(tmpR,nss_local,nss_local,'tmpR')
      Call mma_allocate(tmpI,nss_local,nss_local,'tmpI')
      ! magnetic moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do j1=1,nss_local
          read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss_local )
        End Do
        Do j1=1,nss
          Do j2=1,nss
            MM(l,j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
          End Do
        End Do
      End Do

      ! spin moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do j1=1,nss_local
          read(LuAniso,*) ( tmpR(j1,j2), tmpI(j1,j2), j2=1,nss_local )
        End Do
        Do j1=1,nss
          Do j2=1,nss
            MS(l,j1,j2) = cmplx(tmpR(j1,j2),tmpI(j1,j2),wp)
          End Do
        End Do
      End Do
      Call mma_deallocate(tmpR)
      Call mma_deallocate(tmpI)

      ! compute the orbital moment
      Do l=1,3
        Do j1=1,nss
          Do j2=1,nss
            ML(l,j1,j2) = -MM(l,j1,j2) - MS(l,j1,j2)*g_e
          End Do
        End Do
      End Do

      close(LuAniso)
      Return
      End




      Subroutine write_formatted_aniso_poly( filename, nss, eso, MM, MS)

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)          :: nss
      Real(kind=8), intent(in)    :: eso(nss)
      Complex(kind=8), intent(in) :: MM(3,nss,nss)
      Complex(kind=8), intent(in) :: MS(3,nss,nss)
      Character(len=180), intent(in):: filename
      ! local stuff
      Integer                      :: l,i,j,LuAniso,IsFreeUnit
      Integer                      :: nstate, multiplicity
      External                     :: IsFreeUnit

      LuAniso=IsFreeUnit(81)
      Call molcas_open(LuAniso,filename)
      nstate=1
      multiplicity=1
      Write(LuAniso,'(2i10)') nstate, nss
      Write(LuAniso,'(5ES24.14)') (eso(i),i=1,nss)
      Write(LuAniso,'(30i4)') multiplicity
      Do l=1,3
         Do i=1,nss
            Write(LuAniso,'(5ES24.14)') (MM(l,i,j),j=1,nss)
         End Do
      End Do
      Do l=1,3
         Do i=1,nss
            Write(LuAniso,'(5ES24.14)') (MS(l,i,j),j=1,nss)
         End Do
      End Do
      Close(LuAniso)
      Return
      End









      Subroutine write_new_formatted_aniso(
     &                               nss, nstate, multiplicity, eso_au,
     &                               esfs_au, U, MM, MS, DM, angmom,
     &                               edmom, amfi, HSO )

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)         :: nss, nstate, multiplicity(nstate)
      Real(kind=8), intent(in)    :: eso_au(nss), esfs_au(nstate)
      Real(kind=8), intent(in)    :: angmom(3,nstate,nstate)
      Real(kind=8), intent(in)    ::  edmom(3,nstate,nstate)
      Real(kind=8), intent(in)    ::   amfi(3,nstate,nstate)
      Complex(kind=8), intent(in) :: MM(3,nss,nss)
      Complex(kind=8), intent(in) :: MS(3,nss,nss)
      Complex(kind=8), intent(in) :: DM(3,nss,nss)
      Complex(kind=8), intent(in) ::    U(nss,nss)
      Complex(kind=8), intent(in) ::  HSO(nss,nss)
      ! local stuff
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "angstr.fh"
      Integer                     :: njob, mxjob, mult, iss, ipar, ist
      Integer                     :: data_file_format
      Integer                     :: i,IsFreeUnit,Lu,Lutmp
      !Character(LEN=30)           :: fmt_int, fmt_real, fmt_key
      External                    :: IsFreeUnit
      Integer, allocatable        :: szproj(:), jbnum(:), mltplt(:)
      Integer, allocatable        :: nroot(:)
      Character(len=128)          :: Filename
      Character(len=1024)         :: molcas,fname,molcasversion
      LOGICAL                     :: dbg
      !
      Integer                     :: nAtoms, iAt, l
      Character(LEN=LENIN)        :: AtomLbl(MxAtom)
      Real*8, Allocatable         :: xyz(:,:)
      dbg=.false.

      !-------------------------------------------------------------
      ! some preparations
      njob=0
      mxjob=0
      Call get_iScalar('NJOB_SINGLE',njob)
      Call get_iScalar('MXJOB_SINGLE',mxjob)
      ! allocate temporary memory:
      Call mma_allocate(jbnum,nstate,'jbnum')
      Call mma_allocate(mltplt,mxjob,'mltplt')
      ! get the information from RUNFILE:
      mltplt=0
      jbnum=0
      Call get_iArray('MLTP_SINGLE',mltplt,mxjob)
      Call get_iArray('JBNUM_SINGLE',jbnum,nstate)
      !-------------------------------------------------------------


      !-------------------------------------------------------------
      ! prepare the szproj index table
      Call mma_allocate(szproj,nss,'szproj')
      szproj(1:nss)=0
      iss=0
      ipar=mod(multiplicity(1),2)
      Do Ist=1,nstate
         Mult=Multiplicity(Ist)
         Do I=-(Mult-Ipar)/2,(Mult-Ipar)/2
            If( (Ipar==0) .AND. (I==0)) Go To 310
               Iss=Iss+1
               szproj(iss)=I
  310       Continue
         End Do ! i
      End Do ! ist

      Call get_iScalar('MXJOB_SINGLE',mxjob)
      Call mma_allocate(nroot,mxjob,'nroot')
      nroot=0
      Call get_iArray('NSTAT_SINGLE',nroot,mxjob)


      !-------------------------------------------------------------
      ! Get the MOLCAS version: index table
      CALL getenvf('MOLCAS ',molcas)
      WRITE(fname,'(A)') trim(molcas)//'/.molcasversion'
      Lutmp=IsFreeUnit(89)
      CALL molcas_open(Lutmp,fname)
      READ(Lutmp,'(A180)') molcasversion
      CLOSE(Lutmp)


      !-------------------------------------------------------------
      ! add coordinates
      nAtoms=0
      Call Get_iScalar('Unique atoms',nAtoms)
      Call Get_cArray('Unique Atom Names',AtomLbl,LENIN*nAtoms)
      Call mma_allocate(xyz,3,8*nAtoms)
      Call Get_dArray('Unique Coordinates',xyz,3*nAtoms)

      !-------------------------------------------------------------
      ! write the data to the new aniso file
      FileName='ANISOFILE'
      Lu=IsFreeUnit(81)

      Call molcas_open(Lu,FileName)
      data_file_format=2021

      !fmt_key='(A)'
      !fmt_real='(5ES22.14,1x)'
      !fmt_int='(40(I0,1x))'

      WRITE(Lu,'(        A)') '# OPENMOLCAS interface to ANISO'
      !-------------------------------------------------------------
      ! ORIGIN of DATA file
      WRITE(Lu,'(        A)') '$source '
      WRITE(Lu,'(       2A)') 'MOLCAS  ',trim(molcas)
      WRITE(Lu,'(       2A)') 'VERSION ',trim(molcasversion)
      WRITE(Lu,'(        A)')
      !-------------------------------------------------------------
      ! DATA FILE FORMAT VERSION:
      WRITE(Lu,'(        A)') '$format '
      WRITE(Lu,'(40(I0,1x))')  data_file_format
      WRITE(Lu,'(        A)')
      !-------------------------------------------------------------
      ! Atom labels and coordinates
      WRITE(Lu,'(        A)') '$natoms '
      WRITE(Lu,'(40(I0,1x))')  nAtoms
      WRITE(Lu,'(        A)')
      WRITE(Lu,'(        A)') '$atomlbl'
      WRITE(Lu,'(40(I0,1x))')  nAtoms
      WRITE(Lu,'(40(A8,1x))')  (AtomLbl(iAt),iAt=1,nAtoms)
      WRITE(Lu,'(        A)')
      WRITE(Lu,'(        A)') '$coords (in Angstrom)'
      WRITE(Lu,'(40(I0,1x))')  nAtoms
      DO iAt=1,nAtoms
        WRITE(Lu,'(i3,1x,A8,1x,3(ES22.14,1x))')
     &                    iAt, AtomLbl(iAt), (Angstr*XYZ(l,iAt),l=1,3)
      END DO
      WRITE(Lu,'(        A)')
      !-------------------------------------------------------------
      ! Number of spin orbit states
      CALL write_nss ( LU, nss, dbg )
      !-------------------------------------------------------------
      ! Number of spin free states
      CALL write_nstate ( LU, nstate, dbg )
      !-------------------------------------------------------------
      ! Number of spin multiplicities
      CALL write_nmult ( LU, njob, dbg )
      !-------------------------------------------------------------
      ! Values of the spin multiplicity
      CALL write_imult ( LU, njob, mltplt, dbg )
      !-------------------------------------------------------------
      ! Number of roots in each spin multiplicity
      CALL write_nroot ( LU, njob, nroot, dbg )
      !-------------------------------------------------------------
      ! SZ projection of the states defining the ording
      CALL write_szproj ( LU, nss, szproj, dbg )
      !-------------------------------------------------------------
      ! spin multiplicity for all states
      CALL write_multiplicity ( LU, nstate, multiplicity, dbg )
      !-------------------------------------------------------------
      ! Eigenvalues of the HBO matrix (spin-free energies from RASSCF)
      ! atomic units
      CALL write_eso ( LU, nss, eso_au, dbg )
      !-------------------------------------------------------------
      ! Eigenvalues of the HBO matrix (spin-free energies from RASSCF)
      ! atomic units
      CALL write_esfs ( LU, nstate, esfs_au, dbg )
      !-------------------------------------------------------------
      ! Angular momentum operator in the basis of spin free states,
      ! component X,Y,Z
      CALL write_angmom ( LU, nstate, angmom, dbg )
      !-------------------------------------------------------------
      ! AMFI/SOMF operator in the basis of spin free states
      ! (see eq. 35 in:
      ! D. Ganyushin and F. Neese, J. Chem. Phys. 138, 104113, 2013.
      ! Note that the meaning of AMFI integrals is different in
      ! MOLCAS and ORCA
      CALL write_amfi ( LU, nstate, amfi, dbg )
      !-------------------------------------------------------------
      ! Electric transition-dipole moments in the basis of spin
      ! free states
      ! The dipole moments, where bra and ket have the same state,
      ! are not computed. ??
      CALL write_edipmom ( LU, nstate, edmom, dbg )
      !-------------------------------------------------------------
      ! Magnetic dipole moment in the basis of SO states
      CALL write_magnetic_moment ( LU, nss, MM, dbg )
      !-------------------------------------------------------------
      ! Spin moment in the basis of SO states
      CALL write_spin_moment ( Lu, nss, MS, dbg )
      !-------------------------------------------------------------
      ! Electric transition-dipole moments in the basis of SO states
      CALL write_electric_moment ( LU, nss, DM, dbg )
      !-------------------------------------------------------------
      ! Eigenvectors of the HBO+SOC matrix
      CALL write_eigen ( LU, nss, U, dbg )
      !-------------------------------------------------------------
      ! The HBO+SOC matrix, atomic units
      CALL write_hso ( LU, nss, HSO, dbg )
      !-------------------------------------------------------------
      FLUSH(Lu)
      CLOSE(Lu)

      Call mma_deallocate(szproj)
      Call mma_deallocate(jbnum)
      Call mma_deallocate(mltplt)
      Call mma_deallocate(nroot)
      Call mma_deallocate(xyz)

      Return
      End






      Subroutine read_formatted_new_aniso( input_file_name, nss, nstate,
     &                                multiplicity, eso, esfs,
     &                                U, MM, MS, ML, DM, ANGMOM, EDMOM,
     &                                AMFI, HSO, eso_au, esfs_au )

      Implicit None
      Integer, Parameter           :: wp=kind(0.d0)
      Integer, intent(inout)       :: nss, nstate
      Integer, intent(out)         :: multiplicity(nstate)
      Real(kind=8), intent(out)    :: eso(nss), esfs(nstate)
      Real(kind=8), intent(out)    :: eso_au(nss), esfs_au(nstate)
      Real(kind=8), intent(out)    ::  edmom(3,nstate,nstate)
      Real(kind=8), intent(out)    :: angmom(3,nstate,nstate)
      Real(kind=8), intent(out)    ::   amfi(3,nstate,nstate)
      Complex(kind=8), intent(out) :: MM(3,nss,nss)
      Complex(kind=8), intent(out) :: MS(3,nss,nss)
      Complex(kind=8), intent(out) :: ML(3,nss,nss)
!     electric dipole moment
      Complex(kind=8), intent(out) :: DM(3,nss,nss)
      Complex(kind=8), intent(out) ::   U(nss,nss)
      Complex(kind=8), intent(out) :: HSO(nss,nss)
      Character(Len=180)           :: input_file_name
      ! local variables:
      Integer       :: l,i,j,LuAniso,IsFreeUnit
      Real(kind=8)  :: g_e,conv_au_to_cm1
      External      :: IsFreeUnit
      logical       :: DBG

      dbg=.false.
      If(dbg) write(6,'(A)') 'Enterring read_formatted_aniso_new'
      If(dbg) call xFlush(6)
      g_e=2.00231930437180_wp
      conv_au_to_cm1=2.194746313702E5_wp
!     set to zero all arrays:
      multiplicity=0
      eso=0.0_wp
      esfs=0.0_wp
      edmom=0.0_wp
      angmom=0.0_wp
      MM=(0.0_wp,0.0_wp)
      MS=(0.0_wp,0.0_wp)
      ML=(0.0_wp,0.0_wp)
      DM=(0.0_wp,0.0_wp)
       U=(0.0_wp,0.0_wp)
!     read the data file:
      LuAniso=IsFreeUnit(81)
      Call molcas_open(LuAniso,input_file_name)
      Call read_magnetic_moment(LuAniso,nss,MM,dbg)
      Call read_electric_moment(LuAniso,nss,DM,dbg)
      Call read_spin_moment(LuAniso,nss,MS,dbg)
      Call read_angmom(LuAniso,nstate,angmom,dbg)
      Call read_amfi(LuAniso,nstate,amfi,dbg)
      Call read_edipmom(LuAniso,nstate,EDMOM,dbg)
      Call read_multiplicity(LuAniso,nstate,multiplicity,dbg)
      Call read_eso(LuAniso,nss,eso_au,dbg)
      Call read_esfs(LuAniso,nstate,esfs_au,dbg)
      Call read_hso(LuAniso,nss,HSO,dbg)
      Call read_eigen(LuAniso,nss,U,dbg)

      ! compute the relative spin-orbit energies in cm-1
      do i=1,nss
        eso(i)=(eso_au(i)-eso_au(1))*conv_au_to_cm1
      end do

      ! compute the relative spin-free energies in cm-1
      do i=1,nstate
        esfs(i)=(esfs_au(i)-esfs_au(1))*conv_au_to_cm1
      end do
      write(6,*) esfs

      ! compute the orbital moment
      do l=1,3
        do i=1,nss
          do j=1,nss
            ML(l,i,j) = -MM(l,i,j) - MS(l,i,j)*g_e
          end do
        end do
      end do

      !read_nmult,
      !read_imult,
      !read_format,
      !read_nroot,
      !read_szproj,

      Close(LuAniso)
      Return
      End


      Subroutine read_formatted_aniso_poly_NEW (
     &                                      input_file_name, nss,
     &                                      nstate, eso, MM, MS,
     &                                      iReturn )
      Implicit None
#include "stdalloc.fh"
      Integer, Parameter           :: wp=kind(0.d0)
      Integer, intent(inout)       :: nss, nstate, iReturn
      ! nLoc is the maximal value of the array nss(1:nneq)
      Real(kind=8), intent(out)    :: eso(nss)
      Complex(kind=8), intent(out) :: MM(3,nss,nss)
      Complex(kind=8), intent(out) :: MS(3,nss,nss)
      Character(len=180)           :: input_file_name
      ! local variables:
      Real(wp), allocatable        :: eso_au(:)
      Real(wp) :: conv_au_to_cm1
      Integer  :: i,j,l,LuAniso,IsFreeUnit
      External :: IsFreeUnit
      Logical  :: dbg

      dbg=.false.
      iReturn=0
      conv_au_to_cm1=2.194746313702E5_wp
      eso(1:nss)=0.0_wp
      MM(1:3,1:nss,1:nss)=(0.0_wp,0.0_wp)
      MS(1:3,1:nss,1:nss)=(0.0_wp,0.0_wp)
      Call mma_allocate(eso_au,nss,'eso_au')
      eso_au=0.0_wp

      LuAniso=IsFreeUnit(81)
      Call molcas_open(LuAniso,input_file_name)

      Call read_nss( LuAniso, nss, dbg )
      If(dbg) Write(6,*) 'read_formatted_aniso_poly_NEW: nss=',nss
      Call read_nstate( LuAniso, nstate, dbg )
      If(dbg) Write(6,*) 'read_formatted_aniso_poly_NEW: nstate=',nstate
      Call read_eso( LuAniso, nss, eso_au, dbg )
      If(dbg) Write(6,*) 'read_formatted_aniso_poly_NEW: eso_au=',
     &                   (eso_au(i),i=1,nss)
      Call read_magnetic_moment ( LuAniso, nss,
     &                            MM(1:3,1:nss,1:nss), dbg )
      IF (dbg) WRITE (6,*) 'Call read_spin_moment'
      FLUSH(6)
      Call read_spin_moment ( LuAniso, nss,
     &                        MS, dbg )

      ! compute the relative spin-orbit energies in cm-1
      do i=1,nss
        eso(i)=(eso_au(i)-eso_au(1))*conv_au_to_cm1
      end do
      Call mma_deallocate(eso_au)
      Close(LuAniso)

      IF (dbg) THEN
        WRITE(6,*) 'read_formatted_aniso_poly_NEW:  nss: ',nss
        WRITE(6,*) 'read_formatted_aniso_poly_NEW:   MM: '
        DO l=1,3
          WRITE(6,'(A,I0)') 'projection: L=',l
          DO i=1,nss
             WRITE(6,'(10(2F8.4,2x))')  ( MM(l,i,j), j=1,nss )
          END DO
        END DO

        WRITE(6,*) 'read_formatted_aniso_poly_NEW:   MS'
        DO l=1,3
          WRITE(6,'(A,I0)') 'projection: L=',l
          DO i=1,nss
             WRITE(6,'(10(2F8.4,2x))')  ( MS(l,i,j),j=1,nss )
          END DO
        END DO
      END IF


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NEWTYP_MCLR(INCLS,INTP,IACOP,ITPOP,NOP,OUTCLS,OUTTP)
! an input string of given group and occupation type are given
! apply an string of elementary operators to this group and
! obtain group and type of new string
!
! Jeppe Olsen, October 1993
!
! ------
! Input
! ------
!
! INGRP : Group of input string
! INTP  : Type of input string (occupation type, # e in ras1,ras3)
! IACOP(I) = 1 : operator I is an annihilation operator
!          = 2 : operator I is a  creation   operator
! ITPOP(I) : orbitals space of operator I
! NOP : Number of operators
!
! Output
! ------
! OUTCLS : group of resulting string
! OUTTP  : Type of resulting string

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: INCLS, INTP, NOP, IACOP(NOP), ITPOP(NOP)
integer(kind=iwp), intent(out) :: OUTCLS, OUTTP
integer(kind=iwp) :: IDELTA, IEL1, IEL3, IOP

! Number of electrons in RAS1,RAS3
call GTSTTP_2(INCLS,IEL1,IEL3,INTP)

IDELTA = 0
do IOP=1,NOP
  ! Change in number of orbitals
  if (IACOP(IOP) == 1) then
    IDELTA = IDELTA-1
  else
    IDELTA = IDELTA+1
  end if
  ! Change in RAS1, RAS3
  if (ITPOP(IOP) == 1) then
    if (IACOP(IOP) == 1) then
      IEL1 = IEL1-1
    else
      IEL1 = IEL1+1
    end if
  else if (ITPOP(IOP) == 3) then
    if (IACOP(IOP) == 1) then
      IEL3 = IEL3-1
    else
      IEL3 = IEL3+1
    end if
  end if
end do
! Out class
OUTCLS = INCLS-IDELTA
!write(u6,*) ' OUTCLS,IEL1,IEL3 ',OUTCLS,IEL1,IEL3
! out type
call GTSTTP_1(OUTCLS,IEL1,IEL3,OUTTP)

#ifdef _DEBUGPRINT_
write(u6,*) ' NEWTYP, OUTCLS, OUTTP ',OUTCLS,OUTTP
#endif

return

end subroutine NEWTYP_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Markus P. Fuelscher                              *
!***********************************************************************
! TriRecPrt
!
!> @brief
!>   Print a triangular matrix
!> @author M. P. F&uuml;lscher, Lund, 1992
!>
!> @details
!> Print a square matrix stored in packed, lower triangular storage mode.
!>
!> @param[in] Title   String containing a title
!> @param[in] FmtIn   String containing a format
!> @param[in] A       Triangular matrix to be printed
!> @param[in] N       Dimension of matrix \p A
!***********************************************************************

subroutine TriPrt(Title,FmtIn,A,N)

use Index_Functions, only: nTri_Elem
use Spool, only: LuWr
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: Title, FmtIn
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: A(nTri_Elem(N))
integer(kind=iwp), parameter :: lPaper = 120
integer(kind=iwp) :: i, iPmax, iPmin, jEnd, jStart, lFmt, lItem, lLeft, lLine, lNumbr, lTitle, nCols, nDecim, nDigit
real(kind=wp) :: Amax, Amin, Pmax, Pmin
character(len=lPaper) :: Line
character(len=20) :: FRMT

!----------------------------------------------------------------------*
if (N <= 0) return
!----------------------------------------------------------------------*
#ifdef _DEBUGPRINT_
call TrcPrt(Title,FmtIn,A,1,nTri_Elem(N))
return
#endif
!----------------------------------------------------------------------*
! print the title                                                      *
!----------------------------------------------------------------------*
lTitle = len_trim(Title)
if (lTitle > 0) then
  Line = ''
  lLeft = 1
  do i=1,lTitle
    if (Title(i:i) /= ' ') then
      lLeft = i-1
      exit
    end if
  end do
  do i=1,lPaper
    if (i+lLeft <= lTitle) Line(i:i) = Title(i+lLeft:i+lLeft)
  end do
  write(LuWr,*)
  write(LuWr,'(2X,A)') Line
  !do i=1,len_trim(Line)
  !  Line(i:i) = '-'
  !end do
  !write(LuWr,'(2X,A)') Line
  write(LuWr,'(2X,A,I5,A,I5)') 'mat. size = ',N,'x',N
end if
!----------------------------------------------------------------------*
! determine the printing format                                        *
!----------------------------------------------------------------------*
lFmt = len_trim(FmtIn)
if (lFmt /= 0) then
  FRMT = FmtIn
else
  Amax = -huge(Amax)
  Amin = huge(Amin)
  do i=1,nTri_Elem(N)
    Amax = max(Amax,A(i))
    Amin = min(Amin,A(i))
  end do
  if (Amax /= Zero) then
    Pmax = log10(abs(Amax))
    iPmax = int(One+Pmax)
    iPmax = max(1,iPmax)
  else
    iPmax = 1
  end if
  if (Amin /= Zero) then
    Pmin = log10(abs(Amin))
    iPmin = int(One+Pmin)
    iPmin = max(1,iPmin)
  else
    iPmin = 1
  end if
  nDigit = 24
  nDecim = min(16,abs(nDigit-max(iPmin,iPmax)))
  if (Amax < Zero) iPmax = iPmax+1
  if (Amin < Zero) iPmin = iPmin+1
  lNumbr = max(iPmin,iPmax)+nDecim+2
  nCols = 10
  lLine = nCols*lNumbr
  if (lLine > lPaper) then
    if ((lLine <= lPaper+nCols) .and. (nDecim > 1)) then
      nDecim = nDecim-1
      lNumbr = max(iPmin,iPmax)+nDecim
      lItem = max(lNumbr,lPaper/nCols)
    else
      nCols = 5
      lItem = max(lNumbr,lPaper/nCols)
    end if
  else
    lItem = lNumbr
  end if
  write(FRMT,'(A,I4.4,A,I4.4,A,I4.4,A)') '(2X,',nCols,'F',lItem,'.',nDecim,')'
end if
!----------------------------------------------------------------------*
! print the data                                                       *
!----------------------------------------------------------------------*
write(LuWr,*)
jEnd = 0
do i=1,N
  jStart = jEnd+1
  jEnd = jEnd+i
  write(LuWr,FRMT) A(jStart:jEnd)
end do

!----------------------------------------------------------------------*
! End procedure                                                        *
!----------------------------------------------------------------------*

end subroutine TriPrt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SSOTRA(SGS,CIS,EXS,ISYM,LSM,NA,NO,TRA,NCO,CI,TMP)
      use gugx, only: SGStruct, CIStruct, EXStruct
      use stdalloc, only: mma_allocate, mma_deallocate
      IMPLICIT NONE
      Type (SGSTruct) SGS
      Type (CISTruct) CIS
      Type (EXSTruct) ExS
      Integer ISYM, LSM, NA, NO, NCO
      Real*8 TRA(NO,NO),CI(NCO),TMP(NCO)

      Integer, allocatable:: ILEV(:)
      INTEGER NI,IL,IP,IK,IKLEV,IPLEV
      REAL*8 CPK,X,CKK

C ILEV(IORB)=GUGA LEVEL CORRESPONDING TO A SPECIFIC ACTIVE ORBITAL
C OF SYMMETRY ISYM.
      CALL mma_allocate(ILEV,NA,Label='ILEV')
      NI=NO-NA
      IL=0
      DO IP=1,NA
5       IL=IL+1
        IF(SGS%ISM(IL).NE.ISYM) GOTO 5
        ILEV(IP)=IL
      END DO
CTEST      write(*,*)' Check prints in SSOTRA.'
CTEST      write(*,*)' ISYM:',ISYM
      DO IK=1,NA
        IKLEV=ILEV(IK)
        CALL DCOPY_(NCO,[0.0D0],0,TMP,1)
        DO IP=1,NA
          IPLEV=ILEV(IP)
          CPK=TRA(NI+IP,NI+IK)
          IF(IP.EQ.IK) CPK=CPK-1.0D00
          X=0.5D0*CPK
CTEST          write(*,*)' IP,IK,X:',IP,IK,X
          IF(ABS(X).LT.1.0D-14) cycle
          CALL SIGMA1(SGS,CIS,EXS,IPLEV,IKLEV,X,LSM,CI,TMP)
        END DO
        CKK=TRA(NI+IK,NI+IK)
        X= 3.0D00-CKK
        CALL DAXPY_(NCO,X,TMP,1,CI,1)
        DO IP=1,NA
          IPLEV=ILEV(IP)
          CPK=TRA(NI+IP,NI+IK)
          IF(IP.EQ.IK) CPK=CPK-1.0D00
          IF(ABS(CPK).LT.1.0D-14) cycle
          CALL SIGMA1(SGS,CIS,EXS,IPLEV,IKLEV,CPK,LSM,TMP,CI)

        END DO
      END DO
      CALL mma_deallocate(ILEV)

      END SUBROUTINE SSOTRA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CoreToPoint(nAt,ipMP,iTP)
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"

      Dimension ByggareBas(6)

      Logical GoHere

      Data ByggareBas/2.0d0,8.0d0,8.0d0,18.0d0,18.0d0,32.0d0/

*
*-- A crude but to the point algorithm to put core electrons and
*   nuclei together, and separating the presumably more diffuse
*   part of the charge distribution in a separate chunk.
*
      Call GetMem('NucC','Allo','Real',iNucCh,nAt)
      Call Get_dArray('Nuclear charge',Work(iNucCh),nAt)
      kAt=0
      dToPoint=0.0d0
      Do iAt=1,nAt
        ByggMeraHus=0.0d0
        GoHere=.true.
        dScaleOffSave=Work(iNucCh+iAt-1)
        Do i=1,6
          dScaleOff=dScaleOffSave-ByggareBas(i)
          If(dScaleOff.le.0.0D0.and.GoHere) then
            dToPoint=ByggMeraHus
            GoHere=.false.
          Endif
          dScaleOffSave=dScaleOff
          ByggMeraHus=ByggMeraHus+ByggareBas(i)
        Enddo
        kAt=kAt+iAt
        Work(ipMP+kAt-1)=Work(ipMP+kAt-1)+dToPoint
        Work(iTP+iAt-1)=Work(iNucCh+iAt-1)-dToPoint
      Enddo
      Call GetMem('NucC','Free','Real',iNucCh,nAt)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_map42 (a,b,dimp,dimq,dimr,dims,dim1,dim2,
     & dim3,dim4,p,q,r,s,nfact)
c
       integer dimp,dimq,dimr,dims,dim1,dim2,dim3,dim4,p,q,r,s,nfact
       real*8 a(1:dimp,1:dimq,1:dimr,1:dims)
       real*8 b(1:dim1,1:dim2,1:dim3,1:dim4)
c     integer index(1:4)
c
       integer pp,qq,rr,ss
c
       if (nfact.eq.1) then
c
c     factor + 1
c
c     do 100 ss=1,dims
c     index(s)=ss
c     do 100 rr=1,dimr
c     index(r)=rr
c     do 100 qq=1,dimq
c     index(q)=qq
c     do 100 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2),index(3),index(4))=a(pp,qq,rr,ss)
c100  continue
c
       if (p.eq.1) then
c     1***
       if (q.eq.2) then
c     12**
       if (r.eq.3) then
c     123* (4)
       do 111 ss=1,dims
       do 1110 rr=1,dimr
       do 1111 qq=1,dimq
       do 1112 pp=1,dimp
       b(pp,qq,rr,ss)=a(pp,qq,rr,ss)
 1112   continue
 1111   continue
 1110   continue
 111    continue
       else
c     124* (3)
       do 112 ss=1,dims
       do 1120 rr=1,dimr
       do 1121 qq=1,dimq
       do 1122 pp=1,dimp
       b(pp,qq,ss,rr)=a(pp,qq,rr,ss)
 1122   continue
 1121   continue
 1120   continue
 112    continue
       end if
       else if (q.eq.3) then
c     13**
       if (r.eq.2) then
c     132* (4)
       do 113 ss=1,dims
       do 1130 rr=1,dimr
       do 1131 qq=1,dimq
       do 1132 pp=1,dimp
       b(pp,rr,qq,ss)=a(pp,qq,rr,ss)
 1132   continue
 1131   continue
 1130   continue
 113    continue
       else
c     134* (2)
       do 114 ss=1,dims
       do 1140 rr=1,dimr
       do 1141 qq=1,dimq
       do 1142 pp=1,dimp
       b(pp,ss,qq,rr)=a(pp,qq,rr,ss)
 1142   continue
 1141   continue
 1140   continue
 114    continue
       end if
       else if (q.eq.4) then
c     14**
       if (r.eq.2) then
c     142* (3)
       do 115 ss=1,dims
       do 1150 rr=1,dimr
       do 1151 qq=1,dimq
       do 1152 pp=1,dimp
       b(pp,rr,ss,qq)=a(pp,qq,rr,ss)
 1152   continue
 1151   continue
 1150   continue
 115    continue
       else
c     143* (2)
       do 116 ss=1,dims
       do 1160 rr=1,dimr
       do 1161 qq=1,dimq
       do 1162 pp=1,dimp
       b(pp,ss,rr,qq)=a(pp,qq,rr,ss)
 1162   continue
 1161   continue
 1160   continue
 116    continue
       end if
       end if
c
       else if (p.eq.2) then
c     2***
       if (q.eq.1) then
c     21**
       if (r.eq.3) then
c     213* (4)
       do 121 ss=1,dims
       do 1210 rr=1,dimr
       do 1211 qq=1,dimq
       do 1212 pp=1,dimp
       b(qq,pp,rr,ss)=a(pp,qq,rr,ss)
 1212   continue
 1211   continue
 1210   continue
 121    continue
       else
c     214* (3)
       do 122 ss=1,dims
       do 1220 rr=1,dimr
       do 1221 qq=1,dimq
       do 1222 pp=1,dimp
       b(qq,pp,ss,rr)=a(pp,qq,rr,ss)
 1222   continue
 1221   continue
 1220   continue
 122    continue
       end if
       else if (q.eq.3) then
c     23**
       if (r.eq.1) then
c     231* (4)
       do 123 ss=1,dims
       do 1230 rr=1,dimr
       do 1231 qq=1,dimq
       do 1232 pp=1,dimp
       b(rr,pp,qq,ss)=a(pp,qq,rr,ss)
 1232   continue
 1231   continue
 1230   continue
 123    continue
       else
c     234* (1)
       do 124 ss=1,dims
       do 1240 rr=1,dimr
       do 1241 qq=1,dimq
       do 1242 pp=1,dimp
       b(ss,pp,qq,rr)=a(pp,qq,rr,ss)
 1242   continue
 1241   continue
 1240   continue
 124    continue
       end if
       else if (q.eq.4) then
c     24**
       if (r.eq.3) then
c     243* (1)
       do 125 ss=1,dims
       do 1250 rr=1,dimr
       do 1251 qq=1,dimq
       do 1252 pp=1,dimp
       b(ss,pp,rr,qq)=a(pp,qq,rr,ss)
 1252   continue
 1251   continue
 1250   continue
 125    continue
       else
c     241* (3)
       do 126 ss=1,dims
       do 1260 rr=1,dimr
       do 1261 qq=1,dimq
       do 1262 pp=1,dimp
       b(rr,pp,ss,qq)=a(pp,qq,rr,ss)
 1262   continue
 1261   continue
 1260   continue
 126    continue
       end if
       end if
c
       else if (p.eq.3) then
c     3***
       if (q.eq.1) then
c     31**
       if (r.eq.2) then
c     312* (4)
       do 131 ss=1,dims
       do 1310 rr=1,dimr
       do 1311 qq=1,dimq
       do 1312 pp=1,dimp
       b(qq,rr,pp,ss)=a(pp,qq,rr,ss)
 1312   continue
 1311   continue
 1310   continue
 131    continue
       else
c     314* (2)
       do 132 ss=1,dims
       do 1320 rr=1,dimr
       do 1321 qq=1,dimq
       do 1322 pp=1,dimp
       b(qq,ss,pp,rr)=a(pp,qq,rr,ss)
 1322   continue
 1321   continue
 1320   continue
 132    continue
       end if
       else if (q.eq.2) then
c     32**
       if (r.eq.1) then
c     321* (4)
       do 133 ss=1,dims
       do 1330 rr=1,dimr
       do 1331 qq=1,dimq
       do 1332 pp=1,dimp
       b(rr,qq,pp,ss)=a(pp,qq,rr,ss)
 1332   continue
 1331   continue
 1330   continue
 133    continue
       else
c     324* (1)
       do 134 ss=1,dims
       do 1340 rr=1,dimr
       do 1341 qq=1,dimq
       do 1342 pp=1,dimp
       b(ss,qq,pp,rr)=a(pp,qq,rr,ss)
 1342   continue
 1341   continue
 1340   continue
 134    continue
       end if
       else if (q.eq.4) then
c     34**
       if (r.eq.1) then
c     341* (2)
       do 135 ss=1,dims
       do 1350 rr=1,dimr
       do 1351 qq=1,dimq
       do 1352 pp=1,dimp
       b(rr,ss,pp,qq)=a(pp,qq,rr,ss)
 1352   continue
 1351   continue
 1350   continue
 135    continue
       else
c     342* (1)
       do 136 ss=1,dims
       do 1360 rr=1,dimr
       do 1361 qq=1,dimq
       do 1362 pp=1,dimp
       b(ss,rr,pp,qq)=a(pp,qq,rr,ss)
 1362   continue
 1361   continue
 1360   continue
 136    continue
       end if
       end if
c
       else if (p.eq.4) then
c     4***
       if (q.eq.1) then
c     41**
       if (r.eq.3) then
c     413* (2)
       do 141 ss=1,dims
       do 1410 rr=1,dimr
       do 1411 qq=1,dimq
       do 1412 pp=1,dimp
       b(qq,ss,rr,pp)=a(pp,qq,rr,ss)
 1412   continue
 1411   continue
 1410   continue
 141    continue
       else
c     412* (3)
       do 142 ss=1,dims
       do 1420 rr=1,dimr
       do 1421 qq=1,dimq
       do 1422 pp=1,dimp
       b(qq,rr,ss,pp)=a(pp,qq,rr,ss)
 1422   continue
 1421   continue
 1420   continue
 142    continue
       end if
       else if (q.eq.2) then
c     42**
       if (r.eq.1) then
c     421* (3)
       do 143 ss=1,dims
       do 1430 rr=1,dimr
       do 1431 qq=1,dimq
       do 1432 pp=1,dimp
       b(rr,qq,ss,pp)=a(pp,qq,rr,ss)
 1432   continue
 1431   continue
 1430   continue
 143    continue
       else
c     423* (1)
       do 144 ss=1,dims
       do 1440 rr=1,dimr
       do 1441 qq=1,dimq
       do 1442 pp=1,dimp
       b(ss,qq,rr,pp)=a(pp,qq,rr,ss)
 1442   continue
 1441   continue
 1440   continue
 144    continue
       end if
       else if (q.eq.3) then
c     43**
       if (r.eq.1) then
c     431* (2)
       do 145 ss=1,dims
       do 1450 rr=1,dimr
       do 1451 qq=1,dimq
       do 1452 pp=1,dimp
       b(rr,ss,qq,pp)=a(pp,qq,rr,ss)
 1452   continue
 1451   continue
 1450   continue
 145    continue
       else
c     432* (1)
       do 146 ss=1,dims
       do 1460 rr=1,dimr
       do 1461 qq=1,dimq
       do 1462 pp=1,dimp
       b(ss,rr,qq,pp)=a(pp,qq,rr,ss)
 1462   continue
 1461   continue
 1460   continue
 146    continue
       end if
       end if
c
       end if
c
       else
c
c     factor = -1
c
c     do 200 ss=1,dims
c     index(s)=ss
c     do 200 rr=1,dimr
c     index(r)=rr
c     do 200 qq=1,dimq
c     index(q)=qq
c     do 200 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2),index(3),index(4))=-a(pp,qq,rr,ss)
c200  continue
c
       if (p.eq.1) then
c     1***
       if (q.eq.2) then
c     12**
       if (r.eq.3) then
c     123* (4)
       do 211 ss=1,dims
       do 2110 rr=1,dimr
       do 2111 qq=1,dimq
       do 2112 pp=1,dimp
       b(pp,qq,rr,ss)=-a(pp,qq,rr,ss)
 2112   continue
 2111   continue
 2110   continue
 211    continue
       else
c     124* (3)
       do 212 ss=1,dims
       do 2120 rr=1,dimr
       do 2121 qq=1,dimq
       do 2122 pp=1,dimp
       b(pp,qq,ss,rr)=-a(pp,qq,rr,ss)
 2122   continue
 2121   continue
 2120   continue
 212    continue
       end if
       else if (q.eq.3) then
c     13**
       if (r.eq.2) then
c     132* (4)
       do 213 ss=1,dims
       do 2130 rr=1,dimr
       do 2131 qq=1,dimq
       do 2132 pp=1,dimp
       b(pp,rr,qq,ss)=-a(pp,qq,rr,ss)
 2132   continue
 2131   continue
 2130   continue
 213    continue
       else
c     134* (2)
       do 214 ss=1,dims
       do 2140 rr=1,dimr
       do 2141 qq=1,dimq
       do 2142 pp=1,dimp
       b(pp,ss,qq,rr)=-a(pp,qq,rr,ss)
 2142   continue
 2141   continue
 2140   continue
 214    continue
       end if
       else if (q.eq.4) then
c     14**
       if (r.eq.2) then
c     142* (3)
       do 215 ss=1,dims
       do 2150 rr=1,dimr
       do 2151 qq=1,dimq
       do 2152 pp=1,dimp
       b(pp,rr,ss,qq)=-a(pp,qq,rr,ss)
 2152   continue
 2151   continue
 2150   continue
 215    continue
       else
c     143* (2)
       do 216 ss=1,dims
       do 2160 rr=1,dimr
       do 2161 qq=1,dimq
       do 2162 pp=1,dimp
       b(pp,ss,rr,qq)=-a(pp,qq,rr,ss)
 2162   continue
 2161   continue
 2160   continue
 216    continue
       end if
       end if
c
       else if (p.eq.2) then
c     2***
       if (q.eq.1) then
c     21**
       if (r.eq.3) then
c     213* (4)
       do 221 ss=1,dims
       do 2210 rr=1,dimr
       do 2211 qq=1,dimq
       do 2212 pp=1,dimp
       b(qq,pp,rr,ss)=-a(pp,qq,rr,ss)
 2212   continue
 2211   continue
 2210   continue
 221    continue
       else
c     214* (3)
       do 222 ss=1,dims
       do 2220 rr=1,dimr
       do 2221 qq=1,dimq
       do 2222 pp=1,dimp
       b(qq,pp,ss,rr)=-a(pp,qq,rr,ss)
 2222   continue
 2221   continue
 2220   continue
 222    continue
       end if
       else if (q.eq.3) then
c     23**
       if (r.eq.1) then
c     231* (4)
       do 223 ss=1,dims
       do 2230 rr=1,dimr
       do 2231 qq=1,dimq
       do 2232 pp=1,dimp
       b(rr,pp,qq,ss)=-a(pp,qq,rr,ss)
 2232   continue
 2231   continue
 2230   continue
 223    continue
       else
c     234* (1)
       do 224 ss=1,dims
       do 2240 rr=1,dimr
       do 2241 qq=1,dimq
       do 2242 pp=1,dimp
       b(ss,pp,qq,rr)=-a(pp,qq,rr,ss)
 2242   continue
 2241   continue
 2240   continue
 224    continue
       end if
       else if (q.eq.4) then
c     24**
       if (r.eq.3) then
c     243* (1)
       do 225 ss=1,dims
       do 2250 rr=1,dimr
       do 2251 qq=1,dimq
       do 2252 pp=1,dimp
       b(ss,pp,rr,qq)=-a(pp,qq,rr,ss)
 2252   continue
 2251   continue
 2250   continue
 225    continue
       else
c     241* (3)
       do 226 ss=1,dims
       do 2260 rr=1,dimr
       do 2261 qq=1,dimq
       do 2262 pp=1,dimp
       b(rr,pp,ss,qq)=-a(pp,qq,rr,ss)
 2262   continue
 2261   continue
 2260   continue
 226    continue
       end if
       end if
c
       else if (p.eq.3) then
c     3***
       if (q.eq.1) then
c     31**
       if (r.eq.2) then
c     312* (4)
       do 231 ss=1,dims
       do 2310 rr=1,dimr
       do 2311 qq=1,dimq
       do 2312 pp=1,dimp
       b(qq,rr,pp,ss)=-a(pp,qq,rr,ss)
 2312   continue
 2311   continue
 2310   continue
 231    continue
       else
c     314* (2)
       do 232 ss=1,dims
       do 2320 rr=1,dimr
       do 2321 qq=1,dimq
       do 2322 pp=1,dimp
       b(qq,ss,pp,rr)=-a(pp,qq,rr,ss)
 2322   continue
 2321   continue
 2320   continue
 232    continue
       end if
       else if (q.eq.2) then
c     32**
       if (r.eq.1) then
c     321* (4)
       do 233 ss=1,dims
       do 2330 rr=1,dimr
       do 2331 qq=1,dimq
       do 2332 pp=1,dimp
       b(rr,qq,pp,ss)=-a(pp,qq,rr,ss)
 2332   continue
 2331   continue
 2330   continue
 233    continue
       else
c     324* (1)
       do 234 ss=1,dims
       do 2340 rr=1,dimr
       do 2341 qq=1,dimq
       do 2342 pp=1,dimp
       b(ss,qq,pp,rr)=-a(pp,qq,rr,ss)
 2342   continue
 2341   continue
 2340   continue
 234    continue
       end if
       else if (q.eq.4) then
c     34**
       if (r.eq.1) then
c     341* (2)
       do 235 ss=1,dims
       do 2350 rr=1,dimr
       do 2351 qq=1,dimq
       do 2352 pp=1,dimp
       b(rr,ss,pp,qq)=-a(pp,qq,rr,ss)
 2352   continue
 2351   continue
 2350   continue
 235    continue
       else
c     342* (1)
       do 236 ss=1,dims
       do 2360 rr=1,dimr
       do 2361 qq=1,dimq
       do 2362 pp=1,dimp
       b(ss,rr,pp,qq)=-a(pp,qq,rr,ss)
 2362   continue
 2361   continue
 2360   continue
 236    continue
       end if
       end if
c
       else if (p.eq.4) then
c     4***
       if (q.eq.1) then
c     41**
       if (r.eq.3) then
c     413* (2)
       do 241 ss=1,dims
       do 2410 rr=1,dimr
       do 2411 qq=1,dimq
       do 2412 pp=1,dimp
       b(qq,ss,rr,pp)=-a(pp,qq,rr,ss)
 2412   continue
 2411   continue
 2410   continue
 241    continue
       else
c     412* (3)
       do 242 ss=1,dims
       do 2420 rr=1,dimr
       do 2421 qq=1,dimq
       do 2422 pp=1,dimp
       b(qq,rr,ss,pp)=-a(pp,qq,rr,ss)
 2422   continue
 2421   continue
 2420   continue
 242    continue
       end if
       else if (q.eq.2) then
c     42**
       if (r.eq.1) then
c     421* (3)
       do 243 ss=1,dims
       do 2430 rr=1,dimr
       do 2431 qq=1,dimq
       do 2432 pp=1,dimp
       b(rr,qq,ss,pp)=-a(pp,qq,rr,ss)
 2432   continue
 2431   continue
 2430   continue
 243    continue
       else
c     423* (1)
       do 244 ss=1,dims
       do 2440 rr=1,dimr
       do 2441 qq=1,dimq
       do 2442 pp=1,dimp
       b(ss,qq,rr,pp)=-a(pp,qq,rr,ss)
 2442   continue
 2441   continue
 2440   continue
 244    continue
       end if
       else if (q.eq.3) then
c     43**
       if (r.eq.1) then
c     431* (2)
       do 245 ss=1,dims
       do 2450 rr=1,dimr
       do 2451 qq=1,dimq
       do 2452 pp=1,dimp
       b(rr,ss,qq,pp)=-a(pp,qq,rr,ss)
 2452   continue
 2451   continue
 2450   continue
 245    continue
       else
c     432* (1)
       do 246 ss=1,dims
       do 2460 rr=1,dimr
       do 2461 qq=1,dimq
       do 2462 pp=1,dimp
       b(ss,rr,qq,pp)=-a(pp,qq,rr,ss)
 2462   continue
 2461   continue
 2460   continue
 246    continue
       end if
       end if
c
       end if
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(s)
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DGMM2_MOLCAS(A,DIAG,IWAY,NRDIM,NCDIM)
! PRODUCT OF DIAGONAL MATRIX AND MATRIX, IN PLACE :
!
! IWAY = 1 : A(I,J) = DIAG(I)*A(I,J)
! IWAY = 2 : A(I,J) = DIAG(J)*A(I,J)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IWAY, NRDIM, NCDIM
real(kind=wp), intent(inout) :: A(NRDIM,NCDIM)
real(kind=wp), intent(in) :: DIAG(*)
integer(kind=iwp) :: I, J, NTEST

if (IWAY == 1) then
  do J=1,NCDIM
    do I=1,NRDIM
      A(I,J) = A(I,J)*DIAG(I)
    end do
  end do
end if

if (IWAY == 2) then
  do J=1,NCDIM
    A(:,J) = A(:,J)*DIAG(J)
  end do
end if

NTEST = 0
if (NTEST /= 0) then
  write(u6,*) ' DIAG A  FROM DGMM2_MOLCAS '
  if (IWAY == 1) then
    call WRTMAT(DIAG,1,NRDIM,1,NRDIM)
  else
    call WRTMAT(DIAG,1,NCDIM,1,NCDIM)
  end if
  call WRTMAT(A,NRDIM,NCDIM,NRDIM,NCDIM)
end if

return

end subroutine DGMM2_MOLCAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefW4cdba(W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)
! define W(a,b,c,d) from (cd|ba)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimc, dimd, abLen, cdLen, aSGrp, bSGrp, cSGrp, dSGrp
real(kind=wp), intent(inout) :: W(dima,dimb,dimc,dimd)
real(kind=wp), intent(in) :: Wx(cdLen,abLen)
integer(kind=iwp) :: a, ba, c, cd, d

#include "macros.fh"
unused_var(aSGrp)
unused_var(bSGrp)

if (cSGrp == dSGrp) then
  ! case (c=d|b,a)
  ba = 0
  do a=1,dima
    do c=2,dimc
      cd = nTri_Elem(c-1)
      do d=1,c-1
        cd = cd+1
        W(a,:,c,d) = W(a,:,c,d)+Wx(cd,ba+1:ba+dimb)
        W(a,:,d,c) = W(a,:,d,c)+Wx(cd,ba+1:ba+dimb)
      end do
    end do
    do c=1,dimc
      cd = nTri_Elem(c)
      W(a,:,c,c) = W(a,:,c,c)+Wx(cd,ba+1:ba+dimb)
    end do
    ba = ba+dimb
  end do

else
  ! case (c,d|b,a)
  ba = 0
  do a=1,dima
    cd = 0
    do d=1,dimd
      do c=1,dimc
        cd = cd+1
        W(a,:,c,d) = W(a,:,c,d)+Wx(cd,ba+1:ba+dimb)
      end do
    end do
    ba = ba+dimb
  end do

end if

return

end subroutine DefW4cdba

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ORDINT(IINST,IOUTST,NELMNT,INO,IPRNT)
*
* ORDER A STRING OF INTEGERS TO ASCENDING ORDER
*
* IINST : INPUT STRING
* IOUTST : OUTPUT STRING
* NELMNT : NUMBER OF INTEGERS
* INO : Mapping array from new to old order
*
* THIS CODE CONTAINS THE OLD ORDER CODE OF JOE GOLAB
* ( HE IS HEREBY AKNOWLEDGED , AND I AM EXCUSED )
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IINST(NELMNT),IOUTST(NELMNT),INO(NELMNT)
*
      IF(NELMNT.EQ.0) GOTO 1001
      CALL ICOPVE(IINST,IOUTST,NELMNT)
      DO  5 I = 1, NELMNT
        INO(I) = I
    5 CONTINUE
C
C       BEGIN TO ORDER
C
        JOE = 1
  10    I = JOE
  20    CONTINUE
        IF(I.EQ.NELMNT) GO TO 50
        IF(IOUTST(I).LE.IOUTST(I+1)) GO TO 40
        JOE = I + 1
  30    ISWAP = IOUTST(I)
        IOUTST(I) = IOUTST(I+1)
        IOUTST(I+1) = ISWAP
        ISWAP = INO(I)
        INO(I) = INO(I+1)
        INO(I+1) = ISWAP
        IF(I.EQ.1) GO TO 10
        I = I - 1
        IF(IOUTST(I).GT.IOUTST(I+1)) GO TO 30
        GO TO 10
 40     I = I + 1
      GO TO 20
C
C     END ORDER
C
 50   CONTINUE
*
 1001 CONTINUE
      NTEST = 000
      NTEST = MAX(NTEST,IPRNT)
      IF( NTEST .GE.200) THEN
        WRITE(6,*) ' Result from ORDINT '
        WRITE(6,*)
        WRITE(6,*)  ' Input string '
        CALL IWRTMA(IINST,1,NELMNT,1,NELMNT)
        WRITE(6,*)  ' Ordered string '
        CALL IWRTMA(IOUTST,1,NELMNT,1,NELMNT)
        WRITE(6,*) ' New to old order '
        CALL IWRTMA(INO,1,NELMNT,1,NELMNT)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine CIDIA_TD(iSym)

use Str_Info, only: CNSM
use ipPage, only: ipclose, ipget, ipin, ipnout, W
use MCLR_Data, only: ICISTR, ipDia, NCNATS, NCPCNT, NCSASM, NDPCNT, nexp, nexp_max, NOCSF, NTYP, XISPSM
use input_mclr, only: ERASSCF, nCSF, PotNuc, rIn_Ene, State_Sym, TimeDep
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iSym
integer(kind=iwp) :: i, iAMCmp, iPDCSFI, ipDIAI, iPDSDI, iSM(1), iSPC(1), nD, nP1, nP2, nQ, nSD, nSpc

! This is just a interface to hide Jeppe from the rest of the world
! we dont want to let world see the work of the Danish
! (I hope he never reads that)
! Anyway concerning the CSF/SD stuff.
! If we work with spin dependent perturbations
! we never use CSF's (to complicated), instead we use
! SD in all parts of the program,
! otherwise we will switch to SD representation in this routine

NSPC = 1
ISPC(1) = 1
iSM(1) = iSym
IAMCMP = 0
ICISTR = 1
i = 2
if (isym == state_sym) i = 1
if (NOCSF == 0) then
  nsd = max(ncsf(isym),nint(XISPSM(ISYM,1)))
  ipdcsfi = ipget(nsd)
  call ipin(ipdcsfi)
  ipDSDi = ipGet(nSD)
else
  nsd = max(ncsf(isym),nint(XISPSM(ISYM,1)))
  ipDSDi = ipGet(nsd)
  call ipin(ipdsdi)
end if
if (NOCSF == 0) then
  nD = NCSASM(ISYM)
  ipdiai = ipdcsfi
else
  nD = int(XISPSM(ISYM,ISPC(1)))
  ipdiai = ipdsdi
end if

call ipin(ipDSDi)
call IntDia(W(ipDSDi)%A,NSPC,ISPC,ISM,IAMCMP,rin_ene+potnuc)
if (NOCSF /= 1) call CSDIAG_MCLR(W(ipDCSFi)%A,W(ipDSDi)%A,NCNATS(1,ISYM),NTYP,CNSM(i)%ICTS,NDPCNT,NCPCNT)

if (nocsf == 0) call ipClose(ipDSDi)
! Calculate explicit part of hamiltonian

np2 = min(nd,nexp_max)
np1 = 0
nq = 0
if (np2 /= 0) then
  call ipnout(ipdiai)
  call ipin(ipdiai)
  call h0(W(ipdiai)%A,np1,nexp_max,nq,isym,nexp,TimeDep)
else
  nexp = 0
end if

call ipin(ipdiai)
W(ipdiai)%A(1:nD) = W(ipdiai)%A(1:nD)-ERASSCF(1)

ipdia = ipdiai

end subroutine CIDIA_TD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine Cff2Dq( &
#                 define _CALLING_
#                 include "cff2d_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: to compute the coefficients in the three terms recurrence    *
!         relation of the 2D-integrals.                                *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
! Modified loop structure for RISC 1991 R. Lindh, Dept. of Theoretical *
! Chemistry, University of Lund, Sweden.                               *
!             May '92. Modified for 2nd order differentiation needed   *
!             for the evaluation of the gradient estimates.            *
!***********************************************************************

use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
#include "cff2d_interface.fh"
integer(kind=iwp) :: iCar, iT
real(kind=wp) :: h12
logical(kind=iwp) :: AeqB, CeqD
logical(kind=iwp), external :: EQ

#ifdef _DEBUGPRINT_
call RecPrt('Cff2Dq: Coori',' ',Coori,3,4)
call RecPrt('Cff2Dq: U2',' ',U2,nRys,nT)
#endif
AeqB = EQ(Coori(1,1),Coori(1,2))
CeqD = EQ(Coori(1,3),Coori(1,4))

h12 = Half
if ((nabMax /= 0) .and. (ncdMax /= 0)) then
  B00(:,:,1) = h12*U2(:,:)
  do iT=1,nT
    B10(:,iT,1) = (h12-h12*U2(:,iT)*Eta(iT))*ZInv(iT)
    B01(:,iT,1) = (h12-h12*U2(:,iT)*Zeta(iT))*EInv(iT)
  end do
else if ((ncdMax == 0) .and. (nabMax /= 0) .and. (lac == 0)) then
  call WarningMessage(2,' Cff2Dq: You should not be here!')
  call Abend()
else if ((nabMax == 0) .and. (ncdMax /= 0) .and. (lac == 0)) then
  call WarningMessage(2,' Cff2Dq: You should not be here!')
  call Abend()
else if ((ncdMax == 0) .and. (nabMax /= 0)) then
  call WarningMessage(2,' Cff2Dq: You should not be here!')
  call Abend()
else if ((nabMax == 0) .and. (ncdMax /= 0)) then
  call WarningMessage(2,' Cff2Dq: You should not be here!')
  call Abend()
else if ((nabMax == 0) .and. (ncdMax == 0) .and. (lac /= 0)) then
  B00(:,:,1) = h12*U2(:,:)
end if
if (nabMax /= 0) then
  B10(:,:,2) = B10(:,:,1)
  B10(:,:,3) = B10(:,:,1)
end if
if (lac /= 0) then
  B00(:,:,2) = B00(:,:,1)
  B00(:,:,3) = B00(:,:,1)
end if
if (ncdMax /= 0) then
  B01(:,:,2) = B01(:,:,1)
  B01(:,:,3) = B01(:,:,1)
end if

if ((la+lb+nOrdOp /= 0) .and. (lc+ld+nOrdOp /= 0)) then
  if ((.not. AeqB) .and. (.not. CeqD)) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = P(iT,iCar)-CoorAC(iCar,1)+Eta(iT)*(U2(:,iT)*(Q(iT,iCar)-P(iT,iCar)))
        QCPQ(:,iT,iCar) = Q(iT,iCar)-CoorAC(iCar,2)-Zeta(iT)*(U2(:,iT)*(Q(iT,iCar)-P(iT,iCar)))
      end do
    end do
  else if (AeqB .and. (.not. CeqD)) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = Eta(iT)*(U2(:,iT)*(Q(iT,iCar)-P(iT,iCar)))
        QCPQ(:,iT,iCar) = Q(iT,iCar)-CoorAC(iCar,2)-Zeta(iT)*(U2(:,iT)*(Q(iT,iCar)-P(iT,iCar)))
      end do
    end do
  else if ((.not. AeqB) .and. CeqD) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = P(iT,iCar)-CoorAC(iCar,1)+Eta(iT)*(U2(:,iT)*(Q(iT,iCar)-P(iT,iCar)))
        QCPQ(:,iT,iCar) = -Zeta(iT)*(U2(:,iT)*(Q(iT,iCar)-P(iT,iCar)))
      end do
    end do
  else
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = Eta(iT)*(U2(:,iT)*(Q(iT,iCar)-P(iT,iCar)))
        QCPQ(:,iT,iCar) = -Zeta(iT)*(U2(:,iT)*(Q(iT,iCar)-P(iT,iCar)))
      end do
    end do
  end if
else if (la+lb+nOrdOp /= 0) then
  call WarningMessage(2,' Cff2Dq: You should not be here!')
  call Abend()
else if (lc+ld+nOrdOp /= 0) then
  call WarningMessage(2,' Cff2Dq: You should not be here!')
  call Abend()
end if
#ifdef _DEBUGPRINT_
if (la+lb+nOrdOp > 0) then
  call RecPrt('Cff2Dq:  PAQP(x)',' ',PAQP(:,:,1),nRys,nT)
  call RecPrt('Cff2Dq:  PAQP(y)',' ',PAQP(:,:,2),nRys,nT)
  call RecPrt('Cff2Dq:  PAQP(z)',' ',PAQP(:,:,3),nRys,nT)
end if
if (lc+ld+nOrdOp > 0) then
  call RecPrt('Cff2Dq:  QCPQ(x)',' ',QCPQ(:,:,1),nRys,nT)
  call RecPrt('Cff2Dq:  QCPQ(y)',' ',QCPQ(:,:,2),nRys,nT)
  call RecPrt('Cff2Dq:  QCPQ(z)',' ',QCPQ(:,:,3),nRys,nT)
end if
if (nabMax /= 0) then
  call RecPrt('Cff2Dq:  B10(x)',' ',B10(:,:,1),nRys,nT)
  call RecPrt('Cff2Dq:  B10(y)',' ',B10(:,:,2),nRys,nT)
  call RecPrt('Cff2Dq:  B10(z)',' ',B10(:,:,3),nRys,nT)
end if
if (lac /= 0) then
  call RecPrt('Cff2Dq:  B00(x)',' ',B00(:,:,1),nRys,nT)
  call RecPrt('Cff2Dq:  B00(y)',' ',B00(:,:,2),nRys,nT)
  call RecPrt('Cff2Dq:  B00(z)',' ',B00(:,:,3),nRys,nT)
end if
if (ncdMax /= 0) then
  call RecPrt('Cff2Dq:  B01(x)',' ',B01(:,:,1),nRys,nT)
  call RecPrt('Cff2Dq:  B01(y)',' ',B01(:,:,2),nRys,nT)
  call RecPrt('Cff2Dq:  B01(z)',' ',B01(:,:,3),nRys,nT)
end if
#endif

return

end subroutine Cff2Dq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CSCALE(INDX,INTSYM,C,X)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(*),INDX(*),INTSYM(*)

#include "SysDef.fh"

#include "mrci.fh"
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CPAM96      JSYM(L)=UNPACK(INTSYM((L+9)/10),3*MOD(L-1,10)+1,3)+1
c      JSYM(L)=JSUNP(INTSYM,L)

c      DO 10 II1=IRC(3)+1,IRC(4)
       II1=IRC(3)+1
30       if(II1.gt.IRC(4)) goto 10
c        IF(JSYM(II1).NE.LSYM) GOTO 40
        IF(JSUNP(INTSYM,II1).NE.LSYM) GOTO 40
        NA=INDX(II1)
        MA=1
        if(NVIRT.lt.1) goto 620
c        DO 20 MA=1,NVIRT
720          C(NA+NDIAG(MA))=X*C(NA+NDIAG(MA))
c20      CONTINUE
        MA=MA+1
        if(MA.le.NVIRT) goto 720
620     continue
40      II1=II1+1
        GOTO 30
10    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Gunnar Karlstrom                                 *
!               2000, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine eperm(D_Tot,nDens,Ravxyz,Cavxyz,nCavxyz_,dEF,Grid,nGrid_,Cord,MaxAto,Z_Nuc,xfEF)
!***********************************************************************
!                                                                      *
!     Object:                                                          *
!                                                                      *
!     Authors: G. Karlstroem                                           *
!              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
!                                                                      *
!              and                                                     *
!                                                                      *
!              R. Lindh                                                *
!              Dept. of Chem. Phys., Univ. of Lund, Sweden.            *
!                                                                      *
!              March 2000                                              *
!***********************************************************************

use Index_Functions, only: nTri3_Elem
use external_centers, only: iXPolType, nOrd_XF, nXF, nXMolnr, XF, XMolnr
use Symmetry_Info, only: iChBas
use Integral_interfaces, only: int_kernel, int_mem
use Gateway_global, only: PrPrt
use rctfld_module, only: fMax, lMax, lRFCav, Scal14
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: nIrrep
use Basis_Info, only: nBas
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nDens, nCavxyz_, nGrid_, MaxAto
real(kind=wp), intent(in) :: D_Tot(nDens), Grid(3,nGrid_), Cord(3,MaxAto), Z_Nuc(MaxAto)
real(kind=wp), intent(out) :: Ravxyz(nCavxyz_)
real(kind=wp), intent(inout) :: Cavxyz(nCavxyz_), dEF(4,nGrid_), xfEF(4,nGrid_)
integer(kind=iwp) :: iComp, iGrid, iMax, iMltpl, ip, iSym, iSymC, iSymX, iSymXY, iSymXZ, iSymY, iSymYZ, iSymZ, iSyXYZ, iTemp, ix, &
                     ixyz, iy, iz, l_Oper(1), MltLbl, nComp, nh1, nOpr, nOrdOp
real(kind=wp) :: CCoor(3), FactOp(1), fTest, Origin(3), rHrmt, Sig
logical(kind=iwp) :: Save_tmp
character(len=8) :: Label
integer(kind=iwp), allocatable :: ips(:), kOper(:), lOper(:)
real(kind=wp), allocatable :: C_Coor(:,:), Nuc(:)
procedure(int_kernel) :: EFInt
procedure(int_mem) :: EFMem
integer(kind=iwp), external :: IrrFnc
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: lOff, iIrrep, n
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
if (lRFCav) then  !Skip calculation of moments if no cavity
  Origin(:) = Zero
  !                                                                      *
  !***********************************************************************
  !                                                                      *
  ! Compute the multipole moment of the QC system,
  ! both nuclear(1) and electronic(2).

  ! Cavxyz: Multipole moments in cartesian basis
  ! Ravxyz: temporary storage

  Cavxyz(:) = Zero

  ! 1) Compute M(nuc,nl), nuclear multipole moments

  do iMax=0,lMax
    ip = 1+nTri3_Elem(iMax)
    call RFNuc(Origin,Ravxyz(ip),iMax)
  end do

# ifdef _DEBUGPRINT_
  call RecPrt('Nuclear Multipole Moments',' ',Ravxyz,1,nCavxyz_)
# endif

  ! 2) Compute the electronic contribution to the charge distribution.

  ! M(el,nl) =  - Sum(p,q) Dpq <p|M(nl)|q>

  nOpr = 1
  FactOp = One
  l_Oper = 1
  ! Reset array for storage of multipole moment expansion
  do iMltpl=1,lMax
    do ix=iMltpl,0,-1
      if (mod(ix,2) == 0) then
        iSymX = 1
      else
        ixyz = 1
        iSymX = 2**IrrFnc(ixyz)
        if (Origin(1) /= Zero) iSymX = ibset(iSymX,0)
      end if
      do iy=iMltpl-ix,0,-1
        if (mod(iy,2) == 0) then
          iSymY = 1
        else
          ixyz = 2
          iSymY = 2**IrrFnc(ixyz)
          if (Origin(2) /= Zero) iSymY = ibset(iSymY,0)
        end if
        iz = iMltpl-ix-iy
        if (mod(iz,2) == 0) then
          iSymZ = 1
        else
          ixyz = 4
          iSymZ = 2**IrrFnc(ixyz)
          if (Origin(3) /= Zero) iSymZ = ibset(iSymZ,0)
        end if

        iTemp = MltLbl(iSymX,MltLbl(iSymY,iSymZ))
        l_Oper = ior(l_Oper,iTemp)
      end do
    end do
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) '1st order total density'
  lOff = 1
  do iIrrep=0,nIrrep-1
    n = nTri_Elem(nBas(iIrrep))
    write(Label,'(A,I1)') 'Diagonal Symmetry Block ',iIrrep+1
    call Triprt(Label,' ',D_Tot(lOff),nBas(iIrrep))
    lOff = lOff+n
  end do
# endif

  call Drv1_RF(FactOp,nOpr,D_tot,nh1,Origin,l_Oper,Cavxyz,lMax)

# ifdef _DEBUGPRINT_
  call RecPrt('Electronic Multipole Moments',' ',Cavxyz,1,nCavxyz_)
# endif

  ! Add nuclear MM expansion to the electronic one

  Cavxyz(:) = Cavxyz(:)+Ravxyz(:)

# ifdef _DEBUGPRINT_
  call RecPrt('Electronic+Nuclear Moments',' ',Cavxyz,1,nCavxyz_)
# endif

  if (allocated(XF)) call XFMoment(lMax,Cavxyz,Ravxyz,nCavxyz_,Origin)

# ifdef _DEBUGPRINT_
  call RecPrt('Total Multipole Moments ',' ',Cavxyz,1,nCavxyz_)
# endif
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over the Langevin grid, compute EF and store in dEF.

! The code here is initially with the loop over the grid outermost.
! We might have to change this later on!

! Be happy, don't worry!

rHrmt = One
nOrdOp = 1
nComp = 3
Sig = -One
iSymX = IrrFnc(1)
iSymY = IrrFnc(2)
iSymZ = IrrFnc(4)
iSymXY = IrrFnc(3)
iSymXZ = IrrFnc(5)
iSymYZ = IrrFnc(6)
iSyXYZ = IrrFnc(7)

call mma_allocate(ips,nComp,Label='ips')
call mma_allocate(lOper,nComp,Label='lOper')
call mma_allocate(kOper,nComp,Label='kOper')
call mma_allocate(Nuc,nComp,Label='Nuc')
call mma_allocate(C_Coor,3,nComp,Label='CCoor')

Save_tmp = PrPrt
PrPrt = .true.

do iGrid=1,nGrid_
  write(Label,'(A,I5)') 'EF ',iGrid
  Ccoor(:) = Grid(:,iGrid)
  iSymC = 1
  if (Ccoor(1) /= Zero) iSymC = ibset(iSymC,iSymX)
  if (Ccoor(2) /= Zero) iSymC = ibset(iSymC,iSymY)
  if (Ccoor(3) /= Zero) iSymC = ibset(iSymC,iSymZ)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero)) iSymC = ibset(iSymC,iSymXY)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ibset(iSymC,iSymXZ)
  if ((Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ibset(iSymC,iSymYZ)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ibset(iSymC,iSyXYZ)

  iComp = 0
  do ix=nOrdOp,0,-1
    do iy=nOrdOp-ix,0,-1
      iComp = iComp+1
      iz = nOrdOp-ix-iy
      ixyz = 0
      if (mod(ix,2) /= 0) ixyz = ibset(ixyz,0)
      if (mod(iy,2) /= 0) ixyz = ibset(ixyz,1)
      if (mod(iz,2) /= 0) ixyz = ibset(ixyz,2)
      iSym = 2**IrrFnc(ixyz)
      if (Ccoor(iComp) /= Zero) iSym = ibset(iSym,0)
      lOper(iComp) = MltLbl(iSymC,iSym)
      kOper(iComp) = iChBas(iComp+1)
      C_Coor(:,iComp) = Ccoor(:)
    end do
  end do

  call EFNuc(C_Coor,Z_Nuc,Cord,MaxAto,Nuc,nOrdOp)
  call OneEl_Property(EFInt,EFMem,Label,ips,lOper,nComp,C_Coor,nOrdOp,Nuc,rHrmt,kOper,D_Tot,nDens,dEF(:,iGrid),Sig)

  ! Field contribution from XF
  call EFXF(C_Coor,XF,nXF,nOrd_XF,iXPolType,xfEF(:,iGrid),XMolnr,nXMolnr,iGrid,scal14)

end do

! Add XF contribution to the total field
dEF(1:nComp,:) = dEF(1:nComp,:)+xfEF(1:nComp,:)

PrPrt = Save_tmp

call mma_deallocate(C_Coor)
call mma_deallocate(Nuc)
call mma_deallocate(kOper)
call mma_deallocate(lOper)
call mma_deallocate(ips)
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over grid points and compute square norm of EF. Store the
! largest of the latter in fmax (used in solver).

fmax = Zero
do iGrid=1,nGrid_
  ftest = dEF(1,iGrid)**2+dEF(2,iGrid)**2+dEF(3,iGrid)**2
  dEF(4,iGrid) = ftest
  fmax = max(fmax,ftest)
end do ! iGrid

!call RecPrt('eperm: dEF ',' ',dEF,4,nGrid_)

return

end subroutine eperm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RdInp_Dynamix(LuSpool,Task,nTasks,mTasks)

#ifdef _HDF5_
use mh5, only: mh5_put_dset
use Dynamix_Globals, only: dyn_dt, dyn_mass, File_H5Res, lH5Restart
#endif
use Dynamix_Globals, only: DT, iPrint, PIN, POUT, RESTART, TEMP, THERMO, VELO, VelVer, VV_First, VV_Second, Gromacs
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LuSpool, nTasks
integer(kind=iwp), intent(inout) :: Task(nTasks)
integer(kind=iwp), intent(out) :: mTasks
integer(kind=iwp) :: maxhop
real(kind=wp) TIME
logical(kind=iwp) :: lHop
character(len=72) :: Title
character(len=180) :: Key, Line
character(len=180), external :: Get_Ln
#ifdef _HDF5_
integer(kind=iwp) :: natom
real(kind=wp), allocatable :: Mass(:)
#endif

mTasks = 0

! Start of input

rewind(LuSpool)
call RdNLst(LuSpool,'Dynamix')

do
  Key = Get_Ln(LuSpool)
  Line = Key
  call UpCase(Line)

  if (Line(1:4) == 'TITL') then
    !>>>>>>>>>>>>>>>>>>>> TITL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    Line = Get_Ln(LuSpool)
    call Get_S(1,Title,72)
  else if (Line(1:4) == 'PRIN') then
    !>>>>>>>>>>>>>>>>>>>> PRIN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    Line = Get_Ln(LuSpool)
    call Get_I1(1,iPrint)
  else if (Line(1:4) == 'VV_F') then
    !>>>>>>>>>>>>>>>>>>>> VV_First <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    write(u6,*) ' VV_First 1'
    mTasks = mTasks+1
    Task(mTasks) = VV_First
    write(u6,*) ' VV_First 2'
  else if (Line(1:4) == 'VV_S') then
    !>>>>>>>>>>>>>>>>>>>> VV_Second <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    mTasks = mTasks+1
    Task(mTasks) = VV_Second
  else if (Line(1:4) == 'THER') then
    !>>>>>>>>>>>>>>>>>>>> THERmostat <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix starts reading THERMO.'
#   endif
    Line = Get_Ln(LuSpool)
    call Get_I1(1,THERMO)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix ends reading THERMO.'
#   endif
  else if (Line(1:4) == 'VELO') then
    !>>>>>>>>>>>>>>>>>>>> VELOcities <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix starts reading VELO.'
#   endif
    Line = Get_Ln(LuSpool)
    call Get_I1(1,VELO)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix ends reading VELO.'
#   endif
  else if (Line(1:2) == 'DT') then
    !>>>>>>>>>>>>>>>>>>>> DT   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix starts reading DT.'
#   endif
    Line = Get_Ln(LuSpool)
    call Get_F1(1,DT)
    call Put_dScalar('Timestep',DT)
#   ifdef _HDF5_
    call mh5_put_dset(dyn_dt,DT)
#   endif
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix ends reading DT.'
#   endif
  else if (Line(1:4) == 'GROM') then
    !>>>>>>>>>>>>>>>>>>>> GROM <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    mTasks = mTasks+1
    Task(mTasks) = Gromacs
  else if (Line(1:4) == 'TIME') then
    !>>>>>>>>>>>>>>>>>>>> TIME <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    Line = Get_Ln(LuSpool)
    call Get_F1(1,TIME)
  else if (Line(1:4) == 'VELV') then
    !>>>>>>>>>>>>>>>>>>>> VelVer <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ! This is the keyword for Velocity Verlet algorithm
    mTasks = mTasks+1
    Task(mTasks) = VelVer
  else if (Line(1:3) == 'HOP') then
    !>>>>>>>>>>>>>>>>>>>> Hop    <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    Line = Get_Ln(LuSpool)
    call Get_I1(1,maxHop)
    lHop = .false.
    call qpg_iScalar('MaxHops',lHop)
    if (.not. lHop) then
      call Put_iScalar('MaxHops',maxHop)
    end if
#   ifdef _DEBUGPRINT_
    write(u6,*) ' lHop = ',lHop,'maxHop = ',maxHop
#   endif
  else if (Line(1:4) == 'REST') then
    !>>>>>>>>>>>>>>>>>>>> Restart <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    Line = Get_Ln(LuSpool)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix starts reading RESTART.'
#   endif
    call Get_F1(1,RESTART)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix ends reading RESTART.'
#   endif
  else if (Line(1:4) == 'TEMP') then
    !>>>>>>>>>>>>>>>>>>>> TEMPERATURE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix starts reading Temperature.'
#   endif
    Line = Get_Ln(LuSpool)
    call Get_F1(1,TEMP)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix ends reading Temperature.'
#   endif
  else if (Line(1:4) == 'ISOT') then
    !>>>>>>>>>>>>>>>>>>>> Isotope <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    write(u6,*) 'ISOTope keyword is obsolete in DYNAMIX,'
    write(u6,*) 'use it in GATEWAY to specify isotopes/masses'
    call Abend()
  else if (Line(1:4) == 'H5RE') then
    !>>>>>>>>>>>>>>>>>>>> Restart from HDF5 file <<<<<<<<<<<<<<<<<<<<<<<<<
#   ifdef _HDF5_
    lH5Restart = .true.
    Line = Get_Ln(LuSpool)
    call Get_S(1,File_H5Res,1)
#   else
    write(u6,*) 'The user asks to restart the dynamics calculation '
    write(u6,*) 'from a HDF5 file, but this is not supported in this'
    write(u6,*) 'installation.'
    call Quit_OnUserError()
#   endif
  else if (Line(1:3) == 'OUT') then
    !>>>>>>>>>>>>>>>>>>>> project OUT some coordinates <<<<<<<<<<<<<<<<<<<<<<<
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix starts reading OUT.'
#   endif
    Line = Get_Ln(LuSpool)
    call Get_I1(1,POUT)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix ends reading OUT.'
#   endif
  else if (Line(1:2) == 'IN') then
    !>>>>>>>>>>>>>>>>>>>> keep IN only some coordinates <<<<<<<<<<<<<<<<<<<<<<<
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix starts reading IN.'
#   endif
    Line = Get_Ln(LuSpool)
    call Get_I1(1,PIN)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Dynamix ends reading IN.'
#   endif
  else if (Line(1:3) == 'END') then
    !>>>>>>>>>>>>>>>>>>>> END <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    write(u6,*)
    exit
  else
    write(u6,*) 'Unknown keyword:',Key
    call Abend()
  end if
end do

#ifdef _HDF5_
call Get_nAtoms_All(natom)
call mma_allocate(Mass,natom)
call Get_Mass_All(Mass,natom)
call mh5_put_dset(dyn_mass,Mass)
call mma_deallocate(Mass)
#endif

return

end subroutine RdInp_Dynamix

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE INPPRC
      use rassi_global_arrays, only: HAM, ESHFT, HDIAG, JBNUM, LROOT
      use rassi_aux, Only : jDisk_TDM, AO_Mode, JOB_INDEX, CMO1, CMO2,
     &                      DMAB, mTRA
      use kVectors
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='INPPRC')
#include "stdalloc.fh"
#include "WrkSpc.fh"
#include "rasdim.fh"
#include "rasdef.fh"
#include "symmul.fh"
#include "rassi.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "SysDef.fh"
#include "centra.fh"
      CHARACTER*8 LABEL
      CHARACTER*8 LABEL2
      !CHARACTER*8 LABEL3
      CHARACTER*8 PRPLST(MXPROP)
      Character*3 lIrrep(8)
      INTEGER ICMPLST(MXPROP)
      LOGICAL JOBMATCH
      DIMENSION IDUM(1)
* Analysing and post-processing the input that was read in readin_rassi.


      Call mma_allocate(jDisk_TDM,2,nState*(nState+1)/2,
     &                  Label='jDisk_TDM')
      jDisk_TDM(:,:)=-1
* PAM07: The printing of spin-orbit Hamiltonian matrix elements:
* If no value for SOTHR_PRT was given in the input, it has a
* negative value that was set in init_rassi:
      IF(SOTHR_PRT.lt.0.0D0) THEN
* Assign default settings. SOTHR_PRT is in cm-1:
       IF(IPGLOB.ge.DEBUG) THEN
        NSOTHR_PRT=10000
        SOTHR_PRT=0.0001D0
      ELSE IF (IPGLOB.ge.VERBOSE) THEN
        NSOTHR_PRT=100
        SOTHR_PRT=0.01D0
      ELSE IF(IPGLOB.ge.USUAL) THEN
        NSOTHR_PRT=20
        SOTHR_PRT=1.00D0
       ELSE
        NSOTHR_PRT=0
       END IF
      END IF

C Some sizes:
      NBSQ=0
      NBMX=0
      IPRP=0
      DO I=1,NSYM
        NBI=NBASF(I)
        NBMX=MAX(NBMX,NBI)
        NBSQPR(I)=NBSQ
        NBSQ=NBSQ+NBI**2
      END DO
      NBTRI=(NBSQ+NBST)/2
      NLEV=0
      DO I=1,NSYM
        NLEV=NLEV+NRS1(I)+NRS2(I)+NRS3(I)
      END DO
C Sizes of some data sets:
C ACTUAL SIZES OF TDMAB AND TDMZZ DEPENDS ON BOTH LSYM1 AND LSYM2.
C HOWEVER, MAX POSSIBLE SIZE IS WHEN LSYM1=LSYM2.
      NCMO=NOSH(1)*NBASF(1)
      NTRA=NOSH(1)**2
      NTDMZZ=NBASF(1)**2
      DO IS=2,NSYM
        NCMO=NCMO+NOSH(IS)*NBASF(IS)
        NTRA=NTRA+NOSH(IS)**2
        NTDMZZ=NTDMZZ+NBASF(IS)**2
      END DO
      NTDMS=(NTDMZZ+NBST)/2
      NTDMA=NTDMS
      NTDMAB=NTRA
      SaveDens=(IFTRD1.OR.IFTRD2).OR.
     &         (SONATNSTATE.GT.0).OR.NATO.OR.Do_TMOM
      IF(SaveDens) THEN
        WRITE(6,*)
        WRITE(6,*) ' Info: creating TDMFILE'
        LUTDM=21
        LUTDM=IsFreeUnit(LUTDM)
        FNTDM='TDMFILE'
        CALL DANAME_MF(LUTDM,FNTDM)
        AO_Mode=.True.
        iByte=8*3*nstate*(nstate-1)/2*nTDMZZ
*
*       For the time we will move over to compact mode if the required
*       estimate of disk space if more than 1 Gb.
*
        If (iByte.gt.1024**3) AO_Mode=.False.
*       Force for debugging purpose.
        If (Force_NON_AO_TDM)  AO_Mode=.False.
        WRITE(6,*) '       estimated file size ', iByte/1024, 'kB'
*
*       For small basis set with symmetry we might not benefit from
*       doing this.
*
        If (NASHT**2+1.gt.nTDMAB) AO_Mode=.True.
*
        If (.NOT.AO_Mode) Then
           WRITE(6,*) '       TDMs in reduced format'
           Call mma_allocate(JOB_INDEX,nState,Label='JOB_INDEX')
           Call ICopy(nState,JBNUM,1,JOB_INDEX,1)
*          Write (6,*) 'Job_Index=',Job_Index
           Call mma_allocate(CMO1,nCMO,Label='CMO1')
           Call mma_allocate(CMO2,nCMO,Label='CMO2')
           Call mma_allocate(DMAB,nTDMAB,Label='DMAB')
           mTRA=nTRA
        Else
           WRITE(6,*) '       TDMs in AO format'
        End If
        WRITE(6,*)
      END IF

C Upcase property names in lists of requests:
      DO IPROP=1,NPROP
        CALL UPCASE(PNAME(IPROP))
      END DO
      DO ISOPR=1,NSOPR
        CALL UPCASE(SOPRNM(ISOPR))
      END DO

C Which properties are available in the ONEINT file?
C (IPUSED will be set later, set it to zero now.)
      !write(6,*)"Which properties are available in the ONEINT file?"
      IPRP=0
      IRC=-1
      IOPT=15
      LABEL='UNDEF'
      CALL iRDONE(IRC,IOPT,LABEL,ICMP,IDUM,ISYLAB)
      IF(IRC.EQ.0) NSIZ=IDUM(1)
      IF(IRC.NE.0) GOTO 110
      IPRP=1
      CALL UPCASE(LABEL)
      PRPLST(1)=LABEL
      ICMPLST(1)=ICMP
      IPUSED(1)=0
*
      DO I=1,MXPROP
        IF(IPRP.GE.MXPROP) GOTO 110
        IRC=-1
        IOPT=23
        CALL iRDONE(IRC,IOPT,LABEL,ICMP,IDUM,ISYLAB)
        IF(IRC.EQ.0) NSIZ=IDUM(1)
        IF(IRC.NE.0) GOTO 110
        IPRP=IPRP+1
        CALL UPCASE(LABEL)
        PRPLST(IPRP)=LABEL
        ICMPLST(IPRP)=ICMP
        IPUSED(IPRP)=0

c Copy the EF2 integral label for hyperfine calculations
        IF(LABEL(1:3).EQ.'EF2') THEN
          IF(IPRP.GE.MXPROP) GOTO 110
          IPRP=IPRP+1
          LABEL2=LABEL
          LABEL2(1:3)='ASD'
          PRPLST(IPRP)=LABEL2
          ICMPLST(IPRP)=ICMP
          IPUSED(IPRP)=0

        END IF

        IF(LABEL(1:4).EQ.'PSOI') THEN
          IF(IPRP.GE.MXPROP) GOTO 110
          IPRP=IPRP+1
          LABEL2=LABEL
          LABEL2(1:4)='PSOP'
          PRPLST(IPRP)=LABEL2
          ICMPLST(IPRP)=ICMP
          IPUSED(IPRP)=0
        END IF
        IF(LABEL(1:6).EQ.'DMS  1') THEN
          IF(IPRP.GE.MXPROP) GOTO 110
          IPRP=IPRP+1
          LABEL2=LABEL
          LABEL2(1:6)='DMP   '
          PRPLST(IPRP)=LABEL2
          ICMPLST(IPRP)=ICMP
          IPUSED(IPRP)=0
        END IF
      END DO
110   CONTINUE
      NPRPLST=IPRP
*
*     Add empty slots for on-the-fly TM integrals.
*
*     If the RASSI code is run several instances on the same job some
*     of these labels will already be available on the file and need
*     not to be added to the list.
*
      IF (Do_TMOM.AND.PRPLST(IPRP)(1:4).NE.'TMOM') THEN
         PRPLST(IPRP+ 1)='TMOM0  R'
         ICMPLST(IPRP+ 1)=1
         IPUSED(IPRP+ 1)=0
         PRPLST(IPRP+ 2)='TMOM0  I'
         ICMPLST(IPRP+ 2)=1
         IPUSED(IPRP+ 2)=0
         IPRP=IPRP+2
*
         PRPLST(IPRP+ 1)='TMOM  RS'
         ICMPLST(IPRP+ 1)=1
         IPUSED(IPRP+ 1)=0
         PRPLST(IPRP+ 2)='TMOM  RS'
         ICMPLST(IPRP+ 2)=2
         IPUSED(IPRP+ 2)=0
         PRPLST(IPRP+ 3)='TMOM  RS'
         ICMPLST(IPRP+ 3)=3
         IPUSED(IPRP+ 3)=0
         PRPLST(IPRP+ 4)='TMOM  RA'
         ICMPLST(IPRP+ 4)=1
         IPUSED(IPRP+ 4)=0
         PRPLST(IPRP+ 5)='TMOM  RA'
         ICMPLST(IPRP+ 5)=2
         IPUSED(IPRP+ 5)=0
         PRPLST(IPRP+ 6)='TMOM  RA'
         ICMPLST(IPRP+ 6)=3
         IPUSED(IPRP+ 6)=0
         PRPLST(IPRP+ 7)='TMOM  IS'
         ICMPLST(IPRP+ 7)=1
         IPUSED(IPRP+ 7)=0
         PRPLST(IPRP+ 8)='TMOM  IS'
         ICMPLST(IPRP+ 8)=2
         IPUSED(IPRP+ 8)=0
         PRPLST(IPRP+ 9)='TMOM  IS'
         ICMPLST(IPRP+ 9)=3
         IPUSED(IPRP+ 9)=0
         PRPLST(IPRP+10)='TMOM  IA'
         ICMPLST(IPRP+10)=1
         IPUSED(IPRP+10)=0
         PRPLST(IPRP+11)='TMOM  IA'
         ICMPLST(IPRP+11)=2
         IPUSED(IPRP+11)=0
         PRPLST(IPRP+12)='TMOM  IA'
         ICMPLST(IPRP+12)=3
         IPUSED(IPRP+12)=0
         IPRP=IPRP+12
*
C Not currently in use.
C        PRPLST(IPRP+ 1)='TMOM2  R'
C        ICMPLST(IPRP+ 1)=1
C        IPUSED(IPRP+ 1)=0
C        CALL MKTDAB(0.0D0,WERD,WDMAB,iRC)PRPLST(IPRP+ 2)='TMOM2  R'
C        ICMPLST(IPRP+ 2)=2
C        IPUSED(IPRP+ 2)=0
C        PRPLST(IPRP+ 3)='TMOM2  R'
C        ICMPLST(IPRP+ 3)=3
C        IPUSED(IPRP+ 3)=0
C        PRPLST(IPRP+ 4)='TMOM2  I'
C        ICMPLST(IPRP+ 4)=1
C        IPUSED(IPRP+ 4)=0
C        PRPLST(IPRP+ 5)='TMOM2  I'
C        ICMPLST(IPRP+ 5)=2
C        IPUSED(IPRP+ 5)=0
C        PRPLST(IPRP+ 6)='TMOM2  I'
C        ICMPLST(IPRP+ 6)=3
C        IPUSED(IPRP+ 6)=0
C        IPRP=IPRP+6
C     Else IF (Do_TMOM) Then
C        PRPLST(IPRP+ 1)='TMOM0  R'
C        ICMPLST(IPRP+ 1)=1
C        IPUSED(IPRP+ 1)=0
C        PRPLST(IPRP+ 2)='TMOM0  I'
C        ICMPLST(IPRP+ 2)=1
C        IPUSED(IPRP+ 2)=0
C        IPRP=IPRP+2
*
C Not currently in use.
C        PRPLST(IPRP+ 1)='TMOM2  R'
C        ICMPLST(IPRP+ 1)=2
C        IPUSED(IPRP+ 1)=0
C        PRPLST(IPRP+ 2)='TMOM2  R'
C        ICMPLST(IPRP+ 2)=3
C        IPUSED(IPRP+ 2)=0
C        PRPLST(IPRP+ 3)='TMOM2  I'
C        ICMPLST(IPRP+ 3)=2
C        IPUSED(IPRP+ 3)=0
C        PRPLST(IPRP+ 4)='TMOM2  I'
C        ICMPLST(IPRP+ 4)=3
C        IPUSED(IPRP+ 4)=0
C        IPRP=IPRP+4
      END IF
*
      NPRPLST=IPRP
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C Add some property names by defaults, if no input:                   C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      IF (NPROP.EQ.0) THEN
C
         IF (NSOPR.EQ.0) THEN
C If no input at all, use this selection:
            DO IPRP=1,NPRPLST
C
               IF (PRPLST(IPRP).eq.'MLTPL  0' .or.
     &             PRPLST(IPRP).eq.'MLTPL  1' .or.
     &             PRPLST(IPRP).eq.'MLTPL  2' .or.
     &             PRPLST(IPRP).eq.'MLTPL  3' .or.
     &             PRPLST(IPRP).eq.'OMQ     ' .or.
     &             PRPLST(IPRP).eq.'ANGMOM' .or.
     &             PRPLST(IPRP)(1:4).eq.'TMOM' .or.
     &             PRPLST(IPRP).eq.'VELOCITY' .or.
     &             PRPLST(IPRP).eq.'MLTPV  2' .or.
     &             PRPLST(IPRP)(1:4).eq.'EMFR') THEN
C
                  NSOPR=NSOPR+1
                  SOPRNM(NSOPR)=PRPLST(IPRP)
C
C SET the proper default type label. That is, which WE-reduced density
C should the integral be contracted with. If not set here it will
C default to a Hermitian singlet reduced density.
                  IF (PRPLST(IPRP).EQ.'ANGMOM'  ) THEN
                     SOPRTP(NSOPR)='ANTISING'
                  ELSE IF (PRPLST(IPRP).EQ.'VELOCITY'  ) THEN
                     SOPRTP(NSOPR)='ANTISING'
                  ELSE IF (PRPLST(IPRP).EQ.'OMQ     '  ) THEN
                     SOPRTP(NSOPR)='ANTISING'
                  ELSE IF (PRPLST(IPRP).EQ.'MLTPV  2'  ) THEN
                     SOPRTP(NSOPR)='ANTISING'
                  ELSE IF (PRPLST(IPRP).EQ.'TMOM  RS'  ) THEN
                     SOPRTP(NSOPR)='HERMSING'
                  ELSE IF (PRPLST(IPRP).EQ.'TMOM  RA'  ) THEN
                     SOPRTP(NSOPR)='ANTISING'
                  ELSE IF (PRPLST(IPRP).EQ.'TMOM  IS'  ) THEN
                     SOPRTP(NSOPR)='HERMSING'
                  ELSE IF (PRPLST(IPRP).EQ.'TMOM  IA'  ) THEN
                     SOPRTP(NSOPR)='ANTISING'
                  ELSE IF (PRPLST(IPRP).EQ.'TMOM0  R'  ) THEN
                     SOPRTP(NSOPR)='HERMTRIP'
                  ELSE IF (PRPLST(IPRP).EQ.'TMOM0  I'  ) THEN
                     SOPRTP(NSOPR)='HERMTRIP'
                  ELSE
                     SOPRTP(NSOPR)='HERMSING'
                  END IF
C
C Set the number of elements of the property
                  ISOCMP(NSOPR)=ICMPLST(IPRP)
C
C Add properties for the explicit spin part of the transition moments
C in the case of spin-orbit coupled wave functrions.
C
                  IF (IFSO) THEN
                     IF (PRPLST(IPRP).EQ.'MLTPL  0') THEN
                        NSOPR=NSOPR+1
                        SOPRNM(NSOPR)=PRPLST(IPRP)
                        ISOCMP(NSOPR)=ICMPLST(IPRP)
                        SOPRTP(NSOPR)='ANTITRIP'
                     ELSE IF (PRPLST(IPRP).EQ.'MLTPL  1') THEN
                        NSOPR=NSOPR+1
                        SOPRNM(NSOPR)=PRPLST(IPRP)
                        ISOCMP(NSOPR)=ICMPLST(IPRP)
                        SOPRTP(NSOPR)='ANTITRIP'
C Uncomment to activate more options!!!
C                    ELSE IF (PRPLST(IPRP).EQ.'MLTPL  2') THEN
C                       NSOPR=NSOPR+1
C                       SOPRNM(NSOPR)=PRPLST(IPRP)
C                       ISOCMP(NSOPR)=ICMPLST(IPRP)
C                       SOPRTP(NSOPR)='HERMTRIP'
C                    ELSE IF (PRPLST(IPRP).EQ.'ANGMOM'  ) THEN
C                       NSOPR=NSOPR+1
C                       SOPRNM(NSOPR)=PRPLST(IPRP)
C                       ISOCMP(NSOPR)=ICMPLST(IPRP)
C                       SOPRTP(NSOPR)='ANTITRIP'
                     END IF
                  END IF
C
               END IF
C
C Add some properties if DQVD is requested
               IF (DQVD) THEN
C                 'MLTPL  2' already there by default
                  IF (PRPLST(IPRP).eq.'EF0    1') THEN
                     NSOPR=NSOPR+1
                     SOPRNM(NSOPR)=PRPLST(IPRP)
                     ISOCMP(NSOPR)=ICMPLST(IPRP)
                  END IF
               END IF
C
            END DO
         END IF
C If no PROP input, copy the SOPR selection:
         NPROP=NSOPR
         DO IPROP=1,NPROP
            PNAME(IPROP)=SOPRNM(IPROP)
            PTYPE(IPROP)=SOPRTP(IPROP)
            ICOMP(IPROP)=ISOCMP(IPROP)
         END DO
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
      ELSE
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C If no SOPR input, copy the PROP selection:
         IF (NSOPR.EQ.0) THEN
            NSOPR=NPROP
            DO ISOPR=1,NSOPR
               SOPRNM(ISOPR)=PNAME(ISOPR)
               SOPRTP(ISOPR)=PTYPE(ISOPR)
               ISOCMP(ISOPR)=ICOMP(ISOPR)
            END DO
         END IF
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
      END IF
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
* Lists (above) now contain either a default choice, or
* a selection by the user. Check that integrals are
* available on the oneint file.

* Check if we need to activate IFJ2/IFJZ automatically
      if(natoms.eq.1) then
       ifj2=1
      endif
      xaxis=0.d0
      zaxis=0.d0
      Do iatom=1,natoms
       xaxis=xaxis+abs(coor(1,iatom))+abs(coor(2,iatom))
       zaxis=zaxis+abs(coor(3,iatom))
      Enddo
      if(xaxis.lt.1.d-10.and.zaxis.gt.0.1d0) ifjz=1

* Check if angular momentum integrals have been computed
      MISSAMX=1
      MISSAMY=1
      MISSAMZ=1
      DO IPRP=1,NPRPLST
         IF (PRPLST(IPRP).eq.'ANGMOM  ') THEN
            IF (ICMPLST(IPRP).eq.1) MISSAMX=0
            IF (ICMPLST(IPRP).eq.2) MISSAMY=0
            IF (ICMPLST(IPRP).eq.3) MISSAMZ=0
         END IF
      END DO
      IF (MISSAMX+MISSAMY+MISSAMZ.gt.0) THEN
       IF(IFJ2.eq.1) THEN
        write(6,*)' J2 values cannot be computed.'
        write(6,*)' Reason: Angular momentum integrals are missing.'
        IFJ2=0
       END IF
       IF(IFGCAL .OR. IFXCAL) THEN
        write(6,*)' Neither GCAL or XCAL can be computed.'
        write(6,*)' Reason: Angular momentum integrals are missing.'
        IFJ2=0
       END IF
      END IF
      IF (MISSAMZ.gt.0) THEN
       IF(IFJZ.eq.1) THEN
        write(6,*)' Omega values will not be computed.'
        write(6,*)' Reason: Angular momentum integrals are missing.'
        IFJZ=0
       END IF
      END IF

C Is everything available that we may need?
      IMiss=0
      DO IPROP=1,NPROP
       DO IPRP=1,NPRPLST
        IF(PNAME(IPROP).EQ.PRPLST(IPRP).AND.
     &        ICOMP(IPROP).EQ.ICMPLST(IPRP)) THEN
         IPUSED(IPRP)=1
         GOTO 120
        END IF
       END DO

       IMiss=IMiss+1
       IF(IMiss.eq.1) THEN
         Write(6,*)
         Call WarningMessage(1,'Requested integrals are missing.')
         Write(6,*)' Property name, and component:',
     &           PNAME(IPROP),ICOMP(IPROP)
         Write(6,*)' This record cannot be found. Some of the requested'
         Write(6,*)' properties cannot be computed. Suggested fix: Try'
         Write(6,*)' recomputing one-electron integrals with keyword'
         Write(6,*)' ''OneOnly'', and additional keywords for the'
         Write(6,*)' properties needed.'
       ELSE
         Write(6,*)' Also missing:',PNAME(IPROP),ICOMP(IPROP)
       END IF

 120   CONTINUE
      END DO
      IMiss=0
      DO ISOPR=1,NSOPR
       DO IPRP=1,NPRPLST
        IF(SOPRNM(ISOPR).EQ.PRPLST(IPRP).AND.
     &        ISOCMP(ISOPR).EQ.ICMPLST(IPRP)) THEN
         IPUSED(IPRP)=1
         GOTO 130
        END IF
       END DO

       IMiss=IMiss+1
       IF(IMiss.eq.1) THEN
         Write(6,*)
         Call WarningMessage(1,'Requested integrals are missing.')
         Write(6,*)' SO-Property name, and component:',
     &           SOPRNM(ISOPR),ISOCMP(ISOPR)
         Write(6,*)' This record cannot be found. Some of the requested'
         Write(6,*)' properties cannot be computed. Suggested fix: Try'
         Write(6,*)' recomputing one-electron integrals with keyword'
         Write(6,*)' ''OneOnly'', and additional keywords for the'
         Write(6,*)' properties needed.'
       ELSE
         Write(6,*)' Also missing:',SOPRNM(ISOPR),ISOCMP(ISOPR)
       END IF

 130   CONTINUE
      END DO
cnf
      If (IfDCpl) Then
         Call Get_iScalar('Unique atoms',natom)
         IErr = 3*natom
         Do IPrp = 1, NPrpLst
            If(PrpLst(IPrp)(1:3).eq.'EF1') Then
               IErr=IErr -1
               IPUsed(IPrp)=1
            End If
         End Do
         If (IErr.ne.0) Then
            Write(6,*)
            Write(6,'(A,i5,A)') '  Approx derivative couplings require',
     &                 3*natom,' field integrals.'
            Write(6,*)' Add the keywords EFLD=0 and ONEONLY to'//
     &                ' the SEWARD input and recompute ONEINT.'
            Write(6,*)' Program will continue, but DerCpl calculations'
     &                //' are disabled.'
            IfDCpl = .False.
         End If
      End If
cnf
C Temporary use IPUSED to mark operators that may be needed:
      DO IPRP=1,NPRPLST
       DO IPROP=1,NPROP
        IF(PNAME(IPROP).EQ.PRPLST(IPRP).AND.
     &        ICOMP(IPROP).EQ.ICMPLST(IPRP)) THEN
          IPUSED(IPRP)=1
          GOTO 221
        END IF
       END DO
 221   CONTINUE
      END DO

      IF(.not.IFHAM) THEN
        IF(IFSHFT) THEN
          Call WarningMessage(1,'Ignored user request.')
          WRITE(6,*)' INPCTL Warning: Both keywords ONEL and SHIFT.'
          WRITE(6,*)' User-supplied diagonal energy shifts are'//
     &              ' meaningless since no Hamiltonian will be'
          WRITE(6,*)' used/computed anyway. Ignored.'
          IFSHFT=.FALSE.
        END IF
        IF(IFHDIA) THEN
          Call WarningMessage(1,'Ignored user request.')
          WRITE(6,*)' INPCTL Warning: Both keywords ONEL and HDIAG.'
          WRITE(6,*)' User-supplied diagonal H elements are'//
     &              ' meaningless since no Hamiltonian will be'
          WRITE(6,*)' used/computed anyway. Ignored.'
          IFHDIA=.FALSE.
        END IF
      END IF
C In any Spin-Orbit calculation, we need SO integrals as well.
C Right now, only AMFI is available. Check that first.
      IF(IFSO.OR.IFGCAL.OR.IFXCAL.OR.IFMCAL) THEN
        IERR=3
        DO IPRP=1,NPRPLST
          IF(PRPLST(IPRP).EQ.'AMFI    ') THEN
           IERR=IERR-1
           IPUSED(IPRP)=1

          END IF
          !IF(PRPLST(IPRP).EQ.'PSOI    ') THEN
          ! IERR=IERR-1
          ! IPUSED(IPRP)=1
          !END IF

        END DO
        IF(IERR.NE.0) THEN
          Call WarningMessage(1,'Incomplete integrals.')
          WRITE(6,*)' Spin-Orbit interaction calculation was requested'
          WRITE(6,*)' but this requires three components of AMFI'
          WRITE(6,*)' integrals. Add the keywords AMFI and ONEONLY to'
          WRITE(6,*)' the SEWARD input and recompute ONEINT.'
          WRITE(6,*)' Program will continue, but SO/EPRG/MAGN'
          WRITE(6,*)' calculations are disabled.'
          IFSO=.FALSE.
          NSOPR=0
          IFGCAL=.FALSE.
          IFXCAL=.FALSE.
          IFMCAL=.FALSE.
        END IF
      END IF
C SVC2009 Check for the presence of the ANGMOM integrals needed for G factor
C or Magnetic Moment calculations.
      IF(IFGCAL.OR.IFXCAL.OR.IFMCAL) THEN
        IERR=3
        DO IPRP=1,NPRPLST
          IF(PRPLST(IPRP).EQ.'ANGMOM  ') THEN
           IERR=IERR-1
           IPUSED(IPRP)=1
          END IF

          !IF(PRPLST(IPRP).EQ.'PSOI    ') THEN
          ! write(6,*)"5*****rassi/inpprc ANGMOM"
          ! IERR=IERR-1
          ! IPUSED(IPRP)=1
          !END IF

        END DO
        IF(IERR.NE.0) THEN
          Call WarningMessage(1,'Incomplete integrals.')
          WRITE(6,*)' EPRG or MAGN keyword was requested'
          WRITE(6,*)' but this requires three components of ANGMOM'
          WRITE(6,*)' integrals. Add the keywords ANGMOM and ONEONLY to'
          WRITE(6,*)' the SEWARD input and recompute ONEINT.'
          WRITE(6,*)' Program will continue, but EPRG/MAGN calculations'
          WRITE(6,*)' are disabled.'
          IFGCAL=.FALSE.
          IFXCAL=.FALSE.
          IFMCAL=.FALSE.
        END IF
      END IF
C Similarly, check integrals for which we want matrix elements over
C SO eigenstates.
      DO IPRP=1,NPRPLST
       DO ISOPR=1,NSOPR
        IF(SOPRNM(ISOPR).EQ.PRPLST(IPRP).AND.
     &        ISOCMP(ISOPR).EQ.ICMPLST(IPRP)) THEN
          IPUSED(IPRP)=1
          GOTO 222
        END IF
       END DO
 222   CONTINUE
      END DO
C
C Reassemble the PNAME, ICOMP arrays.
C
      DO IPRP=1,NPRPLST
         IF (IPUSED(IPRP).EQ.0) THEN
            DO IPROP = 1, NPROP
               IF (PNAME(IPROP).EQ.PRPLST(IPRP)) PNAME(IPROP)='REMOVE'
            END DO
         ELSE
            IADD=1
            DO IPROP = 1, NPROP
               IF (PNAME(IPROP).EQ.PRPLST(IPRP) .AND.
     &             ICOMP(IPROP).EQ.ICMPLST(IPRP)) IADD=0
            END DO
            IF (IADD.EQ.1) THEN
               NPROP=NPROP+1
               PNAME(NPROP)=PRPLST(IPRP)
               PTYPE(NPROP)='UNDEF.  '
               ICOMP(NPROP)=ICMPLST(IPRP)
            END IF
         END IF
      END DO
      MPROP=NPROP
      DO IPROP = 1, NPROP
         IF (PNAME(IPROP).EQ.'DONE') EXIT
         IF (PNAME(IPROP).EQ.'REMOVE') THEN
            DO JPROP = IPROP, MPROP-1
               PNAME(JPROP)=PNAME(JPROP+1)
               PTYPE(JPROP)=PTYPE(JPROP+1)
               ICOMP(JPROP)=ICOMP(JPROP+1)
            END DO
            PNAME(MPROP)='DONE'
            MPROP=MPROP-1
         END IF
      END DO
      NPROP=MPROP
C
C Reassemble the SOPRNM, ISOCMP arrays:
C
      DO IPRP=1,NPRPLST
         IF (IPUSED(IPRP).EQ.0) THEN
            DO ISOPR = 1, NSOPR
               IF (SOPRNM(ISOPR).EQ.PRPLST(IPRP)) SOPRNM(ISOPR)='REMOVE'
            END DO
         ELSE
            IADD=1
            DO ISOPR = 1, NSOPR
               IF (SOPRNM(ISOPR).EQ.PRPLST(IPRP) .AND.
     &             ISOCMP(ISOPR).EQ.ICMPLST(IPRP)) IADD=0
            END DO
            IF (IADD.EQ.1) THEN
               NSOPR=NSOPR+1
               SOPRNM(NSOPR)=PRPLST(IPRP)
               SOPRTP(NSOPR)='UNDEF.  '
               ISOCMP(NSOPR)=ICMPLST(IPRP)
            END IF
         END IF
      END DO
      MSOPR=NSOPR
      DO ISOPR = 1, NSOPR
         IF (SOPRNM(ISOPR).EQ.'DONE') EXIT
         IF (SOPRNM(ISOPR).EQ.'REMOVE') THEN
            DO JSOPR = ISOPR, MSOPR-1
               SOPRNM(JSOPR)=SOPRNM(JSOPR+1)
               SOPRTP(JSOPR)=SOPRTP(JSOPR+1)
               ISOCMP(JSOPR)=ISOCMP(JSOPR+1)
            END DO
            PNAME(MSOPR)='DONE'
            MSOPR=MSOPR-1
         END IF
      END DO
      NSOPR=MSOPR

C IPUSED is used later for other purposes, and should be initialized
C to zero.
      DO IPRP=1,NPRPLST
       IPUSED(IPRP)=0
      END DO
C
C PTYPE and SOPRTP is set here if not already set above. Note that this
C is a fallback procedure that should not be used actively. This
C fallback typically assigns the type of WE-reduced density to be
C used for user-specified lists of properties.
C
      DO IPROP=1,NPROP
       IF (PTYPE(IPROP).NE.'UNDEF.  ') CYCLE
       PTYPE(IPROP)='HERMSING'
       IF(PNAME(IPROP).EQ.'VELOCITY') PTYPE(IPROP)='ANTISING'
       IF(PNAME(IPROP).EQ.'ANGMOM  ') PTYPE(IPROP)='ANTISING'
       IF(PNAME(IPROP).EQ.'MLTPV  2') PTYPE(IPROP)='ANTISING'
       IF(PNAME(IPROP)(1:4).EQ.'PSOP') PTYPE(IPROP)='ANTISING'
       IF(PNAME(IPROP).EQ.'OMQ     ') PTYPE(IPROP)='ANTISING'
       IF(PNAME(IPROP).EQ.'AMFI    ') PTYPE(IPROP)='ANTITRIP'
       IF(PNAME(IPROP)(1:3).EQ.'ASD') PTYPE(IPROP)='HERMTRIP'
       IF(PNAME(IPROP)(1:6).EQ.'DMP   ') PTYPE(IPROP)='HERMSING'
       IF(PNAME(IPROP).EQ.'EMFR  RA')PTYPE(IPROP)='ANTISING'
       IF(PNAME(IPROP).EQ.'EMFR  IA')PTYPE(IPROP)='ANTISING'
       IF(PNAME(IPROP).EQ.'TMOM  RA')PTYPE(IPROP)='ANTISING'
       IF(PNAME(IPROP).EQ.'TMOM  IA')PTYPE(IPROP)='ANTISING'
       IF(PNAME(IPROP).EQ.'EMFR0  I')PTYPE(IPROP)='ANTITRIP'
       IF(PNAME(IPROP).EQ.'TMOM0  R')PTYPE(IPROP)='HERMTRIP'
       IF(PNAME(IPROP).EQ.'TMOM0  I')PTYPE(IPROP)='HERMTRIP'
       IF(PNAME(IPROP).EQ.'TMOM2  I')PTYPE(IPROP)='ANTISING'
       END DO

      DO ISOPR=1,NSOPR
       IF (SOPRTP(ISOPR).NE.'UNDEF.  ') CYCLE
       SOPRTP(ISOPR)='HERMSING'
       IF(SOPRNM(ISOPR).EQ.'VELOCITY') SOPRTP(ISOPR)='ANTISING'
       IF(SOPRNM(ISOPR).EQ.'ANGMOM  ') SOPRTP(ISOPR)='ANTISING'
       IF(SOPRNM(ISOPR).EQ.'MLTPV  2') SOPRTP(ISOPR)='ANTISING'
       IF(SOPRNM(ISOPR)(1:4).EQ.'PSOP') SOPRTP(ISOPR)='ANTISING'
       IF(SOPRNM(IPROP).EQ.'OMQ     ') SOPRTP(IPROP)='ANTISING'
       IF(SOPRNM(ISOPR).EQ.'AMFI    ') SOPRTP(ISOPR)='ANTITRIP'
       IF(SOPRNM(ISOPR)(1:3).EQ.'ASD') SOPRTP(ISOPR)='HERMTRIP'
       IF(SOPRNM(ISOPR)(1:6).EQ.'DMP   ') SOPRTP(ISOPR)='HERMSING'
       IF(SOPRNM(ISOPR).EQ.'EMFR  RA')SOPRTP(ISOPR)='ANTISING'
       IF(SOPRNM(ISOPR).EQ.'EMFR  IA')SOPRTP(ISOPR)='ANTISING'
       IF(SOPRNM(ISOPR).EQ.'TMOM  RA')SOPRTP(ISOPR)='ANTISING'
       IF(SOPRNM(ISOPR).EQ.'TMOM  IA')SOPRTP(ISOPR)='ANTISING'
       IF(SOPRNM(ISOPR).EQ.'EMFR0  I')SOPRTP(ISOPR)='ANTITRIP'
       IF(SOPRNM(ISOPR).EQ.'TMOM0  R')SOPRTP(ISOPR)='HERMTRIP'
       IF(SOPRNM(ISOPR).EQ.'TMOM0  I')SOPRTP(ISOPR)='HERMTRIP'
       IF(SOPRNM(ISOPR).EQ.'TMOM2  I')SOPRTP(ISOPR)='ANTISING'
      END DO

C Write out various input data:
*
      Call Get_cArray('Irreps',lIrrep,24)
      Do iSym = 1, nSym
         Call RightAd(lIrrep(iSym))
      End Do
*
* determine if there are any matching wavefunctions
      JOBMATCH=.FALSE.
      do job1=1,njob
        do job2=1,job1-1
          if ((MLTPLT(JOB1).EQ.MLTPLT(JOB2)) .AND.
     &        (IRREP(JOB1).EQ.IRREP(JOB2))) then
            JOBMATCH=.TRUE.
          end if
        end do
      end do
* make decision regarding the use of input hamiltonian/diagonal values
      if (ifheff) then
        if (have_heff) then
          DO J=1,NSTATE
            DO I=1,NSTATE
              iadr=(j-1)*nstate+i-1
              iadr2=(i-1)*nstate+j-1
              HAM(i,j)=0.5D0*(Work(L_HEFF+iadr)+
     &                               Work(L_HEFF+iadr2))
            END DO
          END DO
          if (jobmatch) then
            call WarningMessage(1,'HEFF used for a situation where '//
     &        'possible extra interaction between states is ignored!')
          end if
        else
          call WarningMessage(2,'HEFF used but none is available!')
          call Quit_OnUserError
        end if
      else if (ifejob) then
        if (have_heff) then
          call WarningMessage(1,'EJOB used when HEFF is available, '//
     &      'possible extra interaction between states is ignored!')
        end if
        if (have_diag) then
          DO I=1,NSTATE
           HAM(i,i)=Work(LREFENE+i-1)
          END DO
        else if (have_heff) then
          DO I=1,NSTATE
            HAM(i,i)=Work(L_HEFF+(i-1)*nstate+i-1)
          END DO
        else
          call WarningMessage(2,'EJOB used but no energies available!')
          call Quit_OnUserError
        end if
        if (jobmatch) then
          call WarningMessage(1,'EJOB used for a situation where '//
     &      'possible extra interaction between states is ignored!')
        end if
      else if (.not.(ifhext.or.ifhdia.or.ifshft.or.ifhcom)) then
* the user has selected no procedure...
        if (have_heff.and. (.not.jobmatch)) then
          ifheff=.true.
          DO J=1,NSTATE
            DO I=1,NSTATE
              iadr=(j-1)*nstate+i-1
              iadr2=(i-1)*nstate+j-1
              HAM(i,j)=0.5D0*(Work(L_HEFF+iadr)+
     &                               Work(L_HEFF+iadr2))
            END DO
          END DO
        else if (have_diag) then
          ifhdia=.true.
          DO I=1,NSTATE
            HDIAG(I)=Work(LREFENE+i-1)
          END DO
        end if
      end if
*
      IF (IPGLOB.GE.USUAL) THEN
        WRITE(6,*)
        WRITE(6,*)'  The following data are common to all the states:'
        WRITE(6,*)'  ------------------------------------------------'
        WRITE(6,*)
     &    '  (note: frozen counts as inactive, deleted as secondary)'
        WRITE(6,*)
        WRITE(6,'(6X,A,I2)')'Nr of irreps:',NSYM
        WRITE(6,*)
        WRITE(6,'(6X,A)')
     &       '           Total     No./Irrep '
        WRITE(6,'(6X,A,8X,8I4)')
     &       'Irrep       ',(I,I=1,NSYM)
        WRITE(6,'(6X,A,8X,8(1X,A))')
     &       '            ',(lIrrep(I),I=1,NSYM)
        WRITE(6,*)
        WRITE(6,'(6X,A,I4,4X,8I4)')
     &       'INACTIVE    ',NISHT, (NISH(I),I=1,NSYM)
        WRITE(6,'(6X,A,I4,4X,8I4)')
     &       'ACTIVE      ',NASHT, (NASH(I),I=1,NSYM)
        WRITE(6,'(6X,A,I4,4X,8I4)')
     &       'SECONDARY   ',NSSHT, (NSSH(I),I=1,NSYM)
        WRITE(6,'(6X,A,I4,4X,8I4)')
     &       'BASIS       ',NBST, (NBASF(I),I=1,NSYM)
        WRITE(6,*)
        WRITE(6,'(6X,A,I4,4X,8I4)')
     &    'RAS1        ',NRS1T, (NRS1(I),I=1,NSYM)
        WRITE(6,'(6X,A,I4,4X,8I4)')
     &    'RAS2        ',NRS2T, (NRS2(I),I=1,NSYM)
        WRITE(6,'(6X,A,I4,4X,8I4)')
     &    'RAS3        ',NRS3T, (NRS3(I),I=1,NSYM)
        WRITE(6,*)
        IF(.NOT.(TRACK.OR.ONLY_OVERLAPS)) THEN
          WRITE(6,*) '      '
     &           //' MATRIX ELEMENTS WILL BE COMPUTED FOR THE FOLLOWING'
     &           //' ONE-ELECTRON OPERATORS, UNLESS ZERO BY SYMMETRY.'
          WRITE(6,*) '  (Herm=Hermitian, Anti=Antihermitian,'//
     &                 ' Sing=Singlet operator, Trip=Triplet operator)'
          Do i1=1,nProp,3
            i2=Min(i1+2,nProp)
            WRITE(6,'(3(5X,A8,1X,I3,1X,A1,A8,A1))')
     &           (PNAME(i),ICOMP(i),'(',PTYPE(i),')',i=i1,i2)
          End Do
        END IF
        IF(IFHAM) THEN
          WRITE(6,*)
          WRITE(6,*)'      EIGENSTATES OF A SPIN-FREE HAMILTONIAN'//
     &            ' WILL BE COMPUTED BASED ON:'
          WRITE(6,*)
* which kind of base hamiltonian is taken?
          IF(IFHEXT) THEN
            WRITE(6,*)' a Hamiltonian matrix that '//
     &                'was supplied in the input.'
          ELSE IF(IFHEFF) THEN
            WRITE(6,*)' a (effective) Hamiltonian matrix that '//
     &                'was read from the wavefunction file(s).'
          ELSE IF(IFEJOB) THEN
            WRITE(6,*)' a Hamiltonian matrix assumed to be diagonal '//
     &          'with energies read from the wavefunction file(s).'
          ELSE
            WRITE(6,*)' A Hamiltonian matrix computed by RASSI.'
          END IF
* which kind of corrections are applied?
          IF(IFHDIA) THEN
            WRITE(6,*)' In addition, the diagonal energies of the '//
     &    'hamiltonian matrix will be replaced by either the user '//
     &    '(HDIAG keyword) or read from the wavefunction file(s).'
          END IF
          IF(IFSHFT) THEN
            WRITE(6,*)' In addition, the diagonal energies of the '//
     &    'hamiltonian matrix will be shifted by the user '//
     &    '(SHIFT keyword).'
          END IF
          IF(NSOPR.GT.0) THEN
            WRITE(6,*)' SO coupling elements will be added.'
            WRITE(6,*)'      EIGENSTATES OF SPIN-ORBIT HAMILTONIAN'//
     &            ' WILL BE COMPUTED'
          END IF
        END IF
        IF(.NOT.(TRACK.OR.ONLY_OVERLAPS)) THEN
          IF(NSOPR.GT.0) THEN
          WRITE(6,*) '       MATRIX ELEMENTS OVER SPIN EIGENSTATES FOR:'
          Do i1=1,NSOPR,3
            i2=Min(i1+2,NSOPR)
            WRITE(6,'(3(5X,A8,1X,I3,1X,A1,A8,A1))')
     &           (SOPRNM(i),ISOCMP(i),'(',SOPRTP(i),')',i=i1,i2)
          End Do
          END IF
        END IF
      END IF
      IF(IPGLOB.GE.DEBUG) THEN
        WRITE(6,*)'Initial default flags are:'
        WRITE(6,*)'     PRSXY :',PRSXY
        WRITE(6,*)'     PRORB :',PRORB
        WRITE(6,*)'     PRTRA :',PRTRA
        WRITE(6,*)'     PRCI  :',PRCI
        WRITE(6,*)'     IFHAM :',IFHAM
        WRITE(6,*)'     IFHEXT:',IFHEXT
        WRITE(6,*)'     IFHEFF:',IFHEFF
        WRITE(6,*)'     IFEJOB:',IFEJOB
        WRITE(6,*)'     IFHCOM:',IFHCOM
        WRITE(6,*)'     IFSHFT:',IFSHFT
        WRITE(6,*)'     IFHDIA:',IFHDIA
        WRITE(6,*)'     IFSO  :',IFSO
        WRITE(6,*)'     NATO  :',NATO
        WRITE(6,*)'     RFPERT:',RFPERT
        WRITE(6,*)'     TOFILE:',ToFile
        WRITE(6,*)'     PRXVR :',PRXVR
        WRITE(6,*)'     PRXVE :',PRXVE
        WRITE(6,*)'     PRXVS :',PRXVS
        WRITE(6,*)'     PRMER :',PRMER
        WRITE(6,*)'     PRMEE :',PRMEE
        WRITE(6,*)'     PRMES :',PRMES
      END IF
      IF(IPGLOB.GE.USUAL) THEN
       IF(NATO.AND.(NRNATO.GT.0)) THEN
        WRITE(6,*)' Natural orbitals will be computed for the'
        WRITE(6,*)' lowest eigenstates. NRNATO=',NRNATO
       END IF
       IF(BINA) THEN
        WRITE(6,*)' Bi-natural orbitals will be computed for the'
        WRITE(6,*)' following pairs of states:'
        WRITE(6,'(5X,8(2X,A1,I2,A1,I2,A1))')
     &             ('(',IBINA(1,I),',',IBINA(2,I),')',I=1,NBINA)
       END IF
       WRITE(6,*)
       WRITE(6,*)' Nr of states:',NSTATE
       DO II=1,NSTATE,20
        III=MIN(II+19,NSTATE)
        WRITE(6,*)
        WRITE(6,'(1X,A8,5x,20I4)')'  State:',(I,I=II,III)
        WRITE(6,'(1X,A8,5x,20I4)')' JobIph:',
     &                             (JBNUM(I),I=II,III)
        WRITE(6,'(1X,A8,5x,20I4)')'Root nr:',
     &                             (LROOT(I),I=II,III)
       END DO
       IF(IFSHFT) THEN
         WRITE(6,*)
         WRITE(6,*)'Each input state will be shifted with an individual'
         WRITE(6,*)'amount of energy. These energy shifts are (a.u.):'
         WRITE(6,'(1X,5F16.8)')(ESHFT(I),I=1,NSTATE)
       END IF
      END IF

C Added by Ungur Liviu on 04.11.2009
C Addition of NSTATE, JBNUM, and LROOT to RunFile.

       CALL Put_iscalar('NSTATE_SINGLE',NSTATE)
       CALL Put_iArray('JBNUM_SINGLE',JBNUM,NSTATE)
       CALL Put_iArray('LROOT_SINGLE',LROOT,NSTATE)
*
* Generate the quadrature points for isotropic integration of the exponential operator
*
      If (Do_TMOM) Then
        If (Do_SK) Then
          nQuad=1
        Else
          nk_Vector = 1
          Call Setup_O()
          Call Do_Lebedev_Sym(L_Eff,nQuad,ipR)
          Call Free_O()
          Call Free_Work(ipR)
        End If
      Else
        nk_Vector = 0
        nQuad = 0
      End If
*
      CALL XFLUSH(6)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine reord2_cvb(cfrom,cto,imode)
      implicit real*8(a-h,o-z)
c Front-end routine for molcas reord2, transforms
c from SGA CSFs to split-graph-GUGA CSFs.
      dimension cfrom(*),cto(*)
#include "WrkSpc.fh"
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "csfbas.fh"

c NAC      rasscf.fh
c NACTEL   general.fh
c LSYM     general.fh
c IPR      rasscf.fh
c KICONF   csfbas.fh
c KCFTP    csfbas.fh
      call getmem('kcnf','allo','inte',ivkcnf,nactel)
      call reord2(nac,nactel,lsym,imode,
     >  iwork(kiconf(1)),iwork(kcftp),
     >  cfrom,cto,iWork(ivkcnf))
      call getmem('kcnf','free','inte',ivkcnf,nactel)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mksymorbs_cvb()

use casvb_global, only: ipr, nconstr, norb, orbs, sorbs, sym
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: ierr, nconstr_kp
real(kind=wp) :: delorbs, dum(1)
real(kind=wp), parameter :: thresh = 1.0e-7_wp
real(kind=wp), external :: detm_cvb, dnrm2_

if (sym) then
  sorbs(:,:) = orbs(:,:)
  nconstr_kp = nconstr
  nconstr = 0
  call symtrizorbs_cvb(orbs)
  nconstr = nconstr_kp
  sorbs(:,:) = orbs(:,:)-sorbs(:,:)
  delorbs = dnrm2_(norb*norb,sorbs,1)
  if ((delorbs > thresh) .and. (ipr(1) >= 2)) then
    write(u6,'(/,a)') ' Change in symmetrized orbitals:'
    call report_cvb(sorbs,norb)
  end if
  ierr = 0
  call nize_cvb(orbs,norb,dum,norb,0,ierr)
  if ((delorbs > thresh) .and. (ipr(1) >= 2)) then
    write(u6,'(a)') ' Orbitals after symmetrization:'
    call report_cvb(orbs,norb)
  end if
  if (abs(detm_cvb(orbs,norb)) < 1.0e-8_wp) then
    write(u6,*) ' Fatal error - orbital matrix singular after symmetrization!'
    call abend_cvb()
  end if
end if

return

end subroutine mksymorbs_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FIXIC(nFix,SS,mInt,B,NDIM,F,Label,u)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 SS(mInt), B(nDim*mInt), F(nDim), u(nDim)
      Character(LEN=8) Label(mInt)
      Real*8, Allocatable:: uInv(:,:), uB(:,:)
*
*
*     write out the internal coordinates which will be fixed
*
      WRITE (6,*)
      WRITE (6,*)
     &      ' Following internal coordinates are fixed'
      WRITE (6,*)
*
*     loop over all internal coordinates to be fixed
*
      Do I = mInt-nFix+1,mInt
         WRITE (6,'(A,A,E10.3,A)')
     &             Label(i),' with a gradient of ',SS(I),
     &             ' is frozen and the gradient is annihilated'
         SS(i) = Zero
      End Do
*
*     now transform remaining internal coordinates back to cartesian ba
*                          -1 +
*                    fx = u  B  fq
*
      Call mma_allocate(uInv,nDim,nDim,Label='uInv')
      uInv(:,:)=Zero
      Do i = 1, nDim
         uInv(i,i)=One/u(i)
      End Do
*     Call RecPrt('uInv',' ',uInv,nDim,nDim)

      Call mma_allocate(uB,mInt,nDim,Label='uB')
      uB(:,:)=Zero

      Call DGEMM_('N','N',
     &            nDim,mInt,nDim,
     &            One,uInv,nDim,
     &            B,nDim,
     &            Zero,uB,nDim)
*     Call RecPrt('uInvB',' ',uB,nDim,mInt)
      Call DGEMM_('N','N',
     &            nDim,1,mInt,
     &            One,uB,nDim,
     &            SS,mInt,
     &            Zero,F,nDim)
*     Call RecPrt('F',' ',F,mInt,1)

      Call mma_deallocate(uB)
      Call mma_deallocate(uInv)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ylmnor(lmax)

use welcom, only: aNorm, FiInt, TetInt
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lmax
integer(kind=iwp) :: i, lm2, j, k
real(kind=wp) :: Tal

do i=0,lmax
  lm2 = i/2
  do j=0,lm2
    do k=0,j
      anorm(i,j,k) = fiint(j-k,k)*tetint(i,j)
    end do
  end do
end do
do i=0,lmax
  tal = One/anorm(i,0,0)
  lm2 = i/2
  do j=0,lm2
    anorm(i,j,0:j) = anorm(i,j,0:j)*tal
  end do
end do

return

end subroutine ylmnor

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHO_LK_RASSI(DLT,MSQ,FLT,FSQ,TUVX,Ash,nScreen,dmpk)
!*********************************************************************
!  Author : F. Aquilante
!
!  Note: this routine should be used only to compute the FI matrix
!        for cases in which the 2 sets of MOs are identical and
!        therefore FI is symmetric and stored as LT matrix.
!        For historical reasons, the routine is written as if it
!        could handle the more general case of different MOs.
!
!        Please, for that purpose, use CHO_LK_RASSI_X instead!
!
! *************** INACTIVE AO-BASIS FOCK MATRIX **********************
!
!   FI(ab) = 2 * sum_J  Lab,J * U(J)  -  sum_Jk  Xka,J * Ykb,J
!
!      U(J) = sum_gd  Lgd,J * DI(gd)
!
!      a,b,g,d:  AO-index
!      k:        MO-index   belonging to (Inactive)
!      v,w,x,y:  MO-indices belonging to (Active)
!
!*********************************************************************

use ChoArr, only: nBasSh, nDimRS
use ChoSwp, only: IndRed, InfVec, nnBstRSh
use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Fock_util_interface, only: cho_lr_MOs
use Fock_util_global, only: Deco, Estimate, Fake_CMO2, PseudoChoMOs, Update
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, L_Full_Type, Lab_Type, NDSBA_Type, SBA_Type, twxy_Type
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
type(DSBA_Type), intent(in) :: DLT, Ash(2)
type(DSBA_Type), intent(inout) :: MSQ(2), FLT(1), FSQ
real(kind=wp), intent(_OUT_) :: TUVX(*)
integer(kind=iwp), intent(in) :: nScreen
real(kind=wp), intent(in) :: dmpk
#include "warnings.h"
#include "chotime.fh"
#include "rassi.fh"
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: ia, iab, iabg, iag, iaSh, iaSkip, ib, iBatch, ibcount, ibg, ibs, ibSh, ibSkip, iCase, iE, ik, iLoc, iml, Inc, &
                     ioffa, iOffAB, ioffb, iOffShb, iOK, irc, ired1, IREDC, iS, ish, iShp, iSwap, ISYM, iSyma, iSymb, iSymv, iTmp, &
                     IVEC2, iVrs, jaSkip, jden, jK, jK_a, jml, jmlmax, JNUM, JRED, JRED1, JRED2, jrs, jSym, jvc, JVEC, k, kDen, &
                     kMOs, kOff(8), krs, kscreen, kSym, l, l1, LFMAX, LFULL(2), LKsh, LKshp, LREAD, lSh, lSym, LWORK, MaxB, &
                     MaxRedT, MaxVecPerBatch, Mmax, mrs, mSh, mTvec, mTvec1, mTvec2, MUSED, MxB, MxBasSh, myJRED2, n1, n2, &
                     nAux(8), NAv, NAw, nBatch, nBs, nBsa, nDen, nMat, nMOs, nnO, nRS, NumCV, numSh1, numSh2, NUMV, NumVT, nVec, &
                     nVrs
real(kind=wp) :: Fact, LKThr, SKsh, tau, TCC1, TCC2, TCINT1, TCINT2, tcoul(2), TCR1, TCR2, TCS1, TCS2, TCT1, TCT2, TCX1, TCX2, &
                 texch(2), THRSX, thrv, tintg(2), tmotr(2), Tmp, TOTCPU, TOTCPU1, TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, tread(2), &
                 tscrn(2), TWC1, TWC2, TWINT1, TWINT2, TWR1, TWR2, TWS1, TWS2, TWT1, TWT2, TWX1, TWX2, xFab, xtau, xTmp, YMax, &
                 YshMax
logical(kind=iwp) :: add, DoScreen, DoReord
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: Debug
#endif
character(len=50) :: CFmt
character :: mode, mode2
type(NDSBA_Type) :: DiaH
type(DSBA_Type) :: CM(2), KLT, MO(2)
type(SBA_Type) :: Laq(2)
type(twxy_Type) :: Scr
type(L_Full_Type) :: L_Full
type(Lab_Type) :: Lab
integer(kind=iwp), allocatable :: Indx(:,:,:), iShp_rs(:), kOffSh(:,:), nnBfShp(:,:)
real(kind=wp), allocatable :: AbsC(:), Diag(:), Drs(:), Faa(:), Fia(:), Frs(:), Lrs(:,:), MLk(:,:,:), SumAClk(:,:,:), SvShp(:,:), &
                              VJ(:), Ylk(:,:,:)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: i, myJRED1, NNBSTMX, ntv0
real(kind=wp), allocatable :: DiagJ(:)
#endif
real(kind=wp), parameter :: FactCI = One, FactXI = -One
logical(kind=iwp), parameter :: DoRead = .false.
character(len=*), parameter :: SECNAM = 'CHO_LK_RASSI'
integer(kind=iwp), external :: Cho_LK_MaxVecPerBatch
real(kind=wp), external :: Cho_LK_ScreeningThreshold
real(kind=r8), external :: ddot_

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
Debug = .false. ! to avoid double printing in CASSCF-debug
#endif
DoReord = .false.
IREDC = -1 ! unknown reduced set in core
! Temporary use of FSQ
call Allocate_DT(KLT,nBas,nBas,nSym,aCase='TRI',Ref=FSQ%A0)

nDen = 2 ! the two bi-orthonormal sets of orbitals
if (Fake_CMO2) nDen = 1 ! MO1 = MO2
kDen = nDen

call CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = zero ! time read/transform vectors
tcoul(:) = zero ! time for computing Coulomb
texch(:) = zero ! time for computing Exchange
tintg(:) = zero ! time for computing (tw|xy) integrals
tmotr(:) = zero ! time for the half-transf of vectors
tscrn(:) = zero ! time for screening overhead

! ==================================================================

! Various offsets
! ----------------
nnO = 0
kOff(1) = 0
MaxB = nBas(1)
do ISYM=2,NSYM
  MaxB = max(MaxB,nBas(iSym))
  nnO = nnO+nIsh(iSym-1)
  kOff(iSym) = nnO
end do
nnO = nnO+nIsh(nSym)
nAux(:) = nIsh(:)+nAsh(:)

!*************************************************
if (Deco) then

  call Allocate_DT(CM(1),nBas,nAux,nSym)
  call Allocate_DT(CM(2),nBas,nAux,nSym)

  if (PseudoChoMOs) then
    call cho_get_MO(iOK,nDen,nSym,nBas,nIsh,MSQ,CM)
  else
    call cho_lr_MOs(iOK,nDen,nSym,nBas,nIsh,MSQ,CM)
  end if

  if (iOK == 0) then ! point to the "generalized" Cholesky MOs
    do jden=1,nDen
      call Allocate_DT(MO(jDen),nBas,nAux,nSym,Ref=CM(jDen)%A0)
    end do
    !write(u6,*) 'Cholesky MOs used for state A'
    !if (nDen == 2) write(u6,*) 'Pseudo Cholesky MOs used for state B'
  else
    write(u6,*) '*******************************'
    write(u6,*) '*** Resort to Canonical MOs ***'
    write(u6,*) '*******************************'

    do jden=1,nDen
      call Allocate_DT(MO(jDen),nBas,nAux,nSym,Ref=MSQ(jDen)%A0)
    end do

  end if

else

  do jden=1,nDen
    call Allocate_DT(MO(jDen),nBas,nAux,nSym,Ref=MSQ(jDen)%A0)
  end do

end if
!*************************************************

! Define the max number of vectors to be treated in core at once

MaxVecPerBatch = Cho_LK_MaxVecPerBatch()

! Define the screening threshold

! threshold for max BLB matrix element
! Note: must be consistent with threshold in subroutine rasscf/rasscf_init.f
THRSX = 1.0e-4_wp
LKThr = Cho_LK_ScreeningThreshold(THRSX)
tau = (LKThr/max(1,nnO))*dmpk

MaxRedT = MaxRed
call GAIGOP_SCAL(MaxRedT,'+')

if (Estimate) tau = tau/MaxRedT

xtau = sqrt(tau)

! Vector MO transformation screening thresholds
NumVT = NumChT
call GAIGOP_SCAL(NumVT,'+')
thrv = (sqrt(LKThr/(max(1,nnO)*NumVT)))*dmpk

call mma_allocate(DIAG,NNBSTRT(1),Label='DIAG')

#ifdef _MOLCAS_MPP_
if ((nProcs > 1) .and. Update .and. Is_Real_Par()) then
  NNBSTMX = 0
  do i=1,nSym
    NNBSTMX = max(NNBSTMX,NNBSTR(i,1))
  end do
  call mma_allocate(diagJ,NNBSTMX,Label='diagJ')
  diagJ(:) = Zero
end if
#endif
! *************** Read the diagonal integrals (stored as 1st red set)
if (Update) call CHO_IODIAG(DIAG,2) ! 2 means "read"

! allocate memory for sqrt(D(a,b)) stored in full (squared) dim
call Allocate_DT(DiaH,nBas,nBas,nSym)
DiaH%A0(:) = Zero

! allocate memory for the abs(C(l)[k])
call mma_allocate(AbsC,MaxB,Label='AbsC')

! allocate memory for the Y(l)[k] vectors
call mma_allocate(Ylk,MaxB,nnO,nDen,Label='Ylk')

! allocate memory for the ML[k] lists of largest elements in significant shells
call mma_allocate(MLk,nShell,nnO,nDen,Label='MLk')

! allocate memory for the lists of  S:= sum_l abs(C(l)[k]) for each shell
call mma_allocate(SumAClk,nShell,nnO,nDen,Label='SumAClk')
! allocate memory for the Index arrays
call mma_allocate(Indx,[0,nShell],[1,nnO],[1,nDen],Label='Indx')

! allocate memory for kOffSh
call mma_allocate(kOffSh,nShell,nSym,Label='kOffSh')

! allocate memory for nnBfShp
call mma_allocate(nnBfShp,nnShl_tot,nSym,Label='nnBfShp')

! allocate memory for iShp_rs
call mma_allocate(iShp_rs,nnShl_tot,Label='iShp_rs')

! allocate memory for the shell-pair Frobenius norm of the vectors
call mma_allocate(SvShp,nnShl,2,Label='SvShp')

! *** Compute Shell Offsets ( MOs and transformed vectors)

MxBasSh = 0

do iSyma=1,nSym

  LKsh = 0

  do iaSh=1,nShell ! kOffSh(iSh,iSym)

    kOffSh(iaSh,iSyma) = LKsh

    LKsh = LKsh+nBasSh(iSyma,iaSh)

    MxBasSh = max(MxBasSh,nBasSh(iSyma,iaSh))

  end do

end do

! allocate memory for the diagonal elements of the Fock matrix
call mma_allocate(Fia,MxBasSh,Label='Fia')
call mma_allocate(Faa,nShell,Label='Faa')
Fia(:) = Zero
Faa(:) = Zero

! *** Determine S:= sum_l C(l)[k]^2  in each shell of C(a,k)
do jDen=1,nDen
  do kSym=1,nSym

    do jK=1,nIsh(kSym)
      jK_a = jK+kOff(kSym)

      do iaSh=1,nShell

        SKsh = zero
        iS = kOffSh(iaSh,kSym)+1
        iE = kOffSh(iaSh,kSym)+nBasSh(kSym,iaSh)
        do ik=iS,iE
          SKsh = SKsh+MO(jDen)%SB(kSym)%A2(ik,jK)**2
        end do

        SumAClk(iaSh,jk_a,jDen) = SkSh

      end do

    end do
  end do
end do

! *** Compute Shell-pair Offsets in the K-matrix

do iSyma=1,nSym

  LKshp = 0

  do iaSh=1,nShell

    do ibSh=1,iaSh

      iShp = iaSh*(iaSh-1)/2+ibSh

      nnBfShp(iShp,iSyma) = LKShp

      LKShp = LKShp+nBasSh(iSyma,iaSh)*nBasSh(iSyma,ibSh)-(1-min((iaSh-ibSh),1))*nBasSh(iSyma,iaSh)*(nBasSh(iSyma,iaSh)-1)/2

    end do

  end do

end do

! *** Mapping shell pairs from the full to the reduced set

call Mk_iShp_rs(iShp_rs,nShell)

! *************** BIG LOOP OVER VECTORS SYMMETRY *******************
do jSym=1,nSym

  NumCV = NumCho(jSym)
  call GAIGOP_SCAL(NumCV,'max')
  if (NumCV < 1) cycle

  JNUM = 1
  call Allocate_DT(L_Full,nShell,iShp_rs,JNUM,JSYM,nSym,Memory=LFULL)

  iCase = 0 ! twxy
  call Allocate_DT(Scr,nAsh,nAsh,JSYM,nSym,iCase)

  iLoc = 3 ! use scratch location in reduced index arrays

  ! ****************     MEMORY MANAGEMENT SECTION    *****************
  ! --------------------------------------------------------------
  ! compute memory needed to store at least 1 vector of JSYM
  ! and do all the subsequent calculations
  ! --------------------------------------------------------------
  mTvec1 = 0
  mTvec2 = 0
  MxB = 0
  do l=1,nSym
    k = Mul(l,JSYM)
    Mmax = max(0,nIsh(k))
    if (Mmax > 0) MxB = max(MxB,nBas(l))
    mTvec1 = mTvec1+nAsh(k)*nBas(l)
    mTvec2 = mTvec2+nAsh(k)*nAsh(l)
  end do
  mTvec = mTvec1+mTvec2

  LFMAX = max(mTvec,LFULL(1)) ! re-use memory for the active vec
  mTvec = nDen*max(MxB,1) ! mem for storing half-transformed vec

  ! ------------------------------------------------------------------
  ! ------------------------------------------------------------------

  JRED1 = InfVec(1,2,jSym)            ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) ! red set of the last vec
# ifdef _MOLCAS_MPP_
  myJRED1 = JRED1 ! first red set present on this node
  ntv0 = 0
# endif
  myJRED2 = JRED2 ! last red set present on this node

  ! entire red sets range for parallel run
  call GAIGOP_SCAL(JRED1,'min')
  call GAIGOP_SCAL(JRED2,'max')

  kscreen = 1
  DoScreen = .true.

  do JRED=JRED1,JRED2

    call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

    if (nVrs /= 0) then ! otherwise no vectors in that (jred,jsym)

      if (nVrs < 0) then
        write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
        call Abend()
      end if

      call Cho_X_SetRed(irc,iLoc,JRED)
      ! set index arrays at iLoc
      if (irc /= 0) then
        write(u6,*) SECNAM//'cho_X_setred non-zero return code. rc= ',irc
        call Abend()
      end if

      IREDC = JRED

      nRS = nDimRS(JSYM,JRED)

      if (JSYM == 1) then
        call mma_allocate(Drs,nRS,Label='Drs')
        call mma_allocate(Frs,nRS,Label='Frs')
        Drs(:) = Zero
        Frs(:) = Zero
      end if

      call mma_maxDBLE(LWORK)

      nVec = min((LWORK-LFULL(2))/(nRS+mTvec+LFMAX),min(nVrs,MaxVecPerBatch))

      if (nVec < 1) then
        write(u6,*) SECNAM//': Insufficient memory for batch'
        write(u6,*) 'LWORK= ',LWORK
        write(u6,*) 'min. mem. need= ',nRS+mTvec+LFMAX
        write(u6,*) 'nRS= ',nRS
        write(u6,*) 'mTvec= ',mTvec
        write(u6,*) 'LFMAX= ',LFMAX
        write(u6,*) 'jsym= ',jsym
        call Quit(_RC_MEMORY_ERROR_)
        nBatch = -9999 ! dummy assignment
      end if

      LREAD = nRS*nVec

      call mma_allocate(Lrs,nRS,nVec,Label='Lrs')

      if (JSYM == 1) then
        ! Transform the density to reduced storage
        add = .false.
        nMat = 1
        call swap_full2rs(irc,iLoc,nRS,nMat,JSYM,[DLT],Drs,add)
      end if

      ! BATCH over the vectors ----------------------------

      nBatch = (nVrs-1)/nVec+1

      do iBatch=1,nBatch

        if (iBatch == nBatch) then
          JNUM = nVrs-nVec*(nBatch-1)
        else
          JNUM = nVec
        end if

        JVEC = nVec*(iBatch-1)+iVrs
        IVEC2 = JVEC-1+JNUM

        call CWTIME(TCR1,TWR1)

        call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

        if ((NUMV <= 0) .or. (NUMV /= JNUM)) return

        call CWTIME(TCR2,TWR2)
        tread(1) = tread(1)+(TCR2-TCR1)
        tread(2) = tread(2)+(TWR2-TWR1)

        if (JSYM == 1) then
          ! ************ (alpha+beta) COULOMB CONTRIBUTION  ****************
          !
          ! Contraction with the density matrix
          ! -----------------------------------
          ! V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * DI(rs)
          !==========================================================

          call CWTIME(TCC1,TWC1)

          call mma_allocate(VJ,JNUM,Label='VJ')

          call DGEMV_('T',nRS,JNUM,ONE,Lrs,nRS,Drs,1,ZERO,VJ,1)

          ! FI(rs){#J} <- FI(rs){#J} + FactCI * sum_J L(rs,{#J})*V{#J}
          !===========================================================

          Fact = real(min(jVec-iVrs,1),kind=wp)

          call DGEMV_('N',nRS,JNUM,FactCI,Lrs,nRS,VJ,1,Fact,Frs,1)

          call mma_deallocate(VJ)

          call CWTIME(TCC2,TWC2)
          tcoul(1) = tcoul(1)+(TCC2-TCC1)
          tcoul(2) = tcoul(2)+(TWC2-TWC1)

        end if ! Coulomb contribution

        ! *************** EXCHANGE CONTRIBUTIONS  ***********************

        call CWTIME(TCS1,TWS1)
        ! -----------------------------------------------------------------
        ! Estimate the diagonals :   D(a,b) = sum_J (Lab,J)^2

        if (Estimate) then

          call Fzero(DIAG(1+iiBstR(jSym,1)),NNBSTR(jSym,1))

          do krs=1,nRS

            mrs = iiBstR(JSYM,iLoc)+krs
            jrs = IndRed(mrs,iLoc) ! address in 1st red set

            do jvc=1,JNUM

              Diag(jrs) = Diag(jrs)+Lrs(krs,jvc)**2

            end do

          end do

        end if

        call CWTIME(TCS2,TWS2)
        tscrn(1) = tscrn(1)+(TCS2-TCS1)
        tscrn(2) = tscrn(2)+(TWS2-TWS1)
        !                                                              *
        !***************************************************************
        !***************************************************************
        !***************************************************************
        !                                                              *
        call Allocate_DT(L_Full,nShell,iShp_rs,JNUM,JSYM,nSym)
        call Allocate_DT(Lab,JNUM,nBasSh,nBas,nShell,nSym,nDen)

        call CWTIME(TCX1,TWX1)

        ! Reorder vectors to Full-dimensions
        !
        ! Vectors are returned in the storage LaJ,b with the restriction:
        !
        !    Sym(a) >= Sym(b)
        !
        ! and blocked in shell pairs

        call CHO_getShFull(Lrs,lread,JNUM,JSYM,IREDC,L_Full,SvShp,nnShl,iShp_rs,nnShl_tot)

        call CWTIME(TCX2,TWX2)
        texch(1) = texch(1)+(TCX2-TCX1)
        texch(2) = texch(2)+(TWX2-TWX1)

        if (DoScreen) then

          call CWTIME(TCS1,TWS1)

          ! Compute DH(a,b)=sqrt(D(a,b)) from the updated diagonals.
          !                              Only the symmetry blocks with
          !                              compound symmetry JSYM are computed
          ! ----------------------------------------------------------------
          ired1 = 1 ! location of the 1st red set
          call swap_tosqrt(irc,ired1,NNBSTRT(1),JSYM,DIAH,DIAG)

          call CWTIME(TCS2,TWS2)
          tscrn(1) = tscrn(1)+(TCS2-TCS1)
          tscrn(2) = tscrn(2)+(TWS2-TWS1)

        end if

        do kSym=1,nSym

          lSym = Mul(JSYM,kSym)

          do jK=1,nIsh(kSym)

            jk_a = jK+kOff(kSym)

            Lab%A0(1:nDen*nBas(lSym)*JNUM) = Zero

            if (DoScreen) then

              call CWTIME(TCS1,TWS1)
              !--------------------------------------------------------------
              ! Setup the screening
              !--------------------------------------------------------------

              do jDen=1,nDen

                do ik=1,nBas(kSym)
                  AbsC(ik) = abs(MO(jDen)%SB(kSym)%A2(ik,jK))
                end do

                if (lSym >= kSym) then
                  ! ----------------------------------------------------------
                  ! Y(l)[k] = sum_n  DH(l,n) * |C(n)[k]|
                  !===========================================================
                  Mode = 'N'
                  n1 = nBas(lSym)
                  n2 = nBas(kSym)

                else
                  ! ----------------------------------------------------------
                  ! Y(l)[k] = sum_n  DH(n,l) * |C(n)[k]|
                  !===========================================================
                  Mode = 'T'
                  n1 = nBas(kSym)
                  n2 = nBas(lSym)

                end if

                if (n1 > 0) call DGEMV_(Mode,n1,n2,ONE,DiaH%SB(lSym,kSym)%A2,n1,AbsC,1,ZERO,Ylk(1,jK_a,jDen),1)

              end do

              ! List the shells present in Y(l)[k] by the largest element
              do jDen=1,nDen
                do ish=1,nShell
                  YshMax = zero
                  do ibs=1,nBasSh(lSym,ish)
                    YshMax = max(YshMax,Ylk(koffSh(ish,lSym)+ibs,jK_a,jDen))
                  end do
                  MLk(ish,jK_a,jDen) = YshMax
                end do
              end do

              ! Sort the lists ML[k]
              do jDen=1,nDen
                do ish=1,nShell
                  Indx(ish,jk_a,jDen) = ish
                end do
              end do

              ! ****  The Max in the MO set 1 is used as reference
              numSh1 = 0 ! # of significant shells in MO set 1
              YMax = MLk(1,jK_a,1)
              jmlmax = 1
              do iml=2,nShell ! get the max in the MO set 1
                if (MLk(iml,jK_a,1) > YMax) then
                  YMax = MLk(iml,jK_a,1)
                  jmlmax = iml
                end if
              end do
              if (jmlmax /= 1) then ! swap positions
                xTmp = MLk(1,jK_a,1)
                iTmp = Indx(1,jk_a,1)
                MLk(1,jK_a,1) = YMax
                Indx(1,jk_a,1) = Indx(jmlmax,jk_a,1)
                MLk(jmlmax,jK_a,1) = xTmp
                Indx(jmlmax,jk_a,1) = iTmp
              end if

              ! **** Sort the list for the MO set 2   iff  MOs1 /= MOs2
              if (.not. Fake_CMO2) then
                numSh2 = 0 ! # of significant shells in MO set 2
                jml = 1
                do while (jml <= nShell)

                  YMax = MLk(jml,jK_a,2)
                  jmlmax = jml

                  do iml=jml+1,nShell ! get the max
                    if (MLk(iml,jK_a,2) > YMax) then
                      YMax = MLk(iml,jK_a,2)
                      jmlmax = iml
                    end if
                  end do

                  if (jmlmax /= jml) then ! swap positions
                    xTmp = MLk(jml,jK_a,2)
                    iTmp = Indx(jml,jK_a,2)
                    MLk(jml,jK_a,2) = YMax
                    Indx(jml,jK_a,2) = Indx(jmlmax,jK_a,2)
                    MLk(jmlmax,jK_a,2) = xTmp
                    Indx(jmlmax,jk_a,2) = iTmp
                  end if

                  ! Exact bounds (quadratic scaling of the MO transformation)
                  ! Note that in true RASSI the exchange matrix is not
                  ! positive definite.

                  if (MLk(jml,jK_a,2)*MLk(1,jK_a,1) >= tau) then
                    numSh2 = numSh2+1
                  else
                    jml = nShell ! exit the loop
                  end if

                  jml = jml+1

                end do

                Indx(0,jk_a,2) = numSh2
                numSh1 = 1

              else ! fake biorthonormal basis

                numSh2 = 6669666 ! dummy assignement

                if (MLk(1,jK_a,1) >= xtau) numSh1 = 1

              end if

              ! **** Sort the list for the MO set 1 only if needed
              if (numSh2 > 0) then
                jml = 2 ! the 1st element has already been treated
                do while (jml <= nShell)

                  YMax = MLk(jml,jK_a,1)
                  jmlmax = jml
                  do iml=jml+1,nShell ! get the max
                    if (MLk(iml,jK_a,1) > YMax) then
                      YMax = MLk(iml,jK_a,1)
                      jmlmax = iml
                    end if
                  end do

                  if (jmlmax /= jml) then ! swap positions
                    xTmp = MLk(jml,jK_a,1)
                    iTmp = Indx(jml,jk_a,1)
                    MLk(jml,jK_a,1) = YMax
                    Indx(jml,jk_a,1) = Indx(jmlmax,jk_a,1)
                    MLk(jmlmax,jK_a,1) = xTmp
                    Indx(jmlmax,jk_a,1) = iTmp
                  end if

                  if ((.not. Fake_CMO2) .and. (MLk(jml,jK_a,1)*MLk(1,jK_a,kDen) >= tau)) then
                    numSh1 = numSh1+1

                    ! Here we use a non-exact bound for the exchange matrix because a
                    ! fake rassi (MOs1=MOs2) has a positive definite exchange
                  else if (Fake_CMO2 .and. (MLk(1,jK_a,1) >= xtau)) then
                    numSh1 = numSh1+1
                  else
                    jml = nShell ! exit the loop
                  end if

                  jml = jml+1

                end do
              else
                numSh1 = 0
              end if

              Indx(0,jk_a,1) = numSh1

              call CWTIME(TCS2,TWS2)
              tscrn(1) = tscrn(1)+(TCS2-TCS1)
              tscrn(2) = tscrn(2)+(TWS2-TWS1)
              !------------------------------------------------------------------
            end if ! Screening setup

            ! Transform vectors for shells in the lists ML[k]
            !
            ! Screening based on the Frobenius norm: sqrt(sum_ij A(i,j)^2)
            !
            !  || La,J[k] ||  <=  || Lab,J || * || Cb[k] ||

            call CWTIME(TCT1,TWT1)

            do jDen=1,nDen

              do iSh=1,Indx(0,jK_a,jDen)

                iaSh = Indx(ish,jK_a,jDen)

                Lab%Keep(iaSh,jDen) = .true.

                ibcount = 0

                do ibSh=1,nShell

                  iOffShb = kOffSh(ibSh,kSym)

                  iShp = iTri(iaSh,ibSh)

                  if (iShp_rs(iShp) <= 0) cycle

                  if ((nnBstRSh(JSym,iShp_rs(iShp),iLoc)*nBasSh(lSym,iaSh)*nBasSh(kSym,ibSh) > 0) .and. &
                      (sqrt(abs(SumAClk(ibSh,jk_a,jDen)*SvShp(iShp_rs(iShp),1))) >= thrv)) then

                    ibcount = ibcount+1

                    if (lSym >= kSym) then

                      l1 = 1
                      if (iaSh < ibSh) l1 = 2

                      ! LaJ,[k] = sum_b  L(aJ,b) * C(b)[k]
                      ! ----------------------------------
                      Mode = 'N'
                      n1 = nBasSh(lSym,iaSh)*JNUM
                      n2 = nBasSh(kSym,ibSh)

                      call DGEMV_(Mode,n1,n2,One,L_Full%SPB(lSym,iShp_rs(iShp),l1)%A21,n1,MO(jDen)%SB(kSym)%A2(iOffShb+1:,jK),1, &
                                  ONE,Lab%SB(iaSh,lSym,jDen)%A,1)

                    else   ! lSym < kSym

                      l1 = 1
                      if (ibSh < iaSh) l1 = 2

                      ! LJa,[k] = sum_b  L(b,Ja) * C(b)[k]
                      ! -----------------------------------
                      Mode = 'T'
                      n1 = nBasSh(kSym,ibSh)
                      n2 = JNUM*nBasSh(lSym,iaSh)

                      call DGEMV_(Mode,n1,n2,One,L_Full%SPB(kSym,iShp_rs(iShp),l1)%A12,n1,MO(jDen)%SB(kSym)%A2(iOffShb+1:,jK),1, &
                                  ONE,Lab%SB(iaSh,lSym,jDen)%A,1)

                    end if

                  end if

                end do ! ibsh

                ! The following re-assignement is used later on to check if the
                ! iaSh vector LaJ[k] can be neglected because identically zero

                if (ibcount == 0) Lab%Keep(iash,jDen) = .false.

              end do ! iSh

            end do ! jDen

            call CWTIME(TCT2,TWT2)
            tmotr(1) = tmotr(1)+(TCT2-TCT1)
            tmotr(2) = tmotr(2)+(TWT2-TWT1)

            ! Prepare the J-screening

            call CWTIME(TCS1,TWS1)

            do iSh=1,Indx(0,jK_a,1)

              iaSh = Indx(iSh,jK_a,1)

              iaSkip = merge(1,0,Lab%Keep(iaSh,1))

              jaSkip = merge(1,0,Lab%Keep(iaSh,kDen))

              if (iaSkip*jaSkip == 0) cycle

              if (lSym >= kSym) then

                ! Faa,[k] = sum_J  LaJ[k1]*LaJ[k2]
                ! --------------------------------
                Inc = nBasSh(lSym,iaSh)
                n1 = 1

              else ! lSym < kSym

                ! Faa,[k] = sum_J  LJa[k1]*LJa[k2]
                ! --------------------------------
                Inc = 1
                n1 = JNUM

              end if

              Tmp = Zero
              do ia=1,nBasSh(lSym,iaSh)
                Fia(ia) = DDot_(JNUM,Lab%SB(iash,lSym,1)%A(1+n1*(ia-1):),Inc,Lab%SB(iash,lSym,kDen)%A(1+n1*(ia-1):),Inc)
                Tmp = max(abs(Fia(ia)),Tmp)
              end do

              Faa(iaSh) = Tmp

            end do

            call CWTIME(TCT2,TWT2)
            tmotr(1) = tmotr(1)+(TCT2-TCT1)
            tmotr(2) = tmotr(2)+(TWT2-TWT1)

            !--------------------------------------------------------
            ! Compute exchange matrix for the interacting shell pairs
            !--------------------------------------------------------

            call CWTIME(TCX1,TWX1)

            do lSh=1,Indx(0,jK_a,1)

              iaSh = Indx(lSh,jK_a,1)

              iaSkip = merge(1,0,Lab%Keep(iaSh,1))

              mSh = 1

              do while (mSh <= Indx(0,jK_a,kDen))

                ibSh = Indx(mSh,jK_a,kDen)

                ibSkip = merge(1,0,Lab%Keep(ibSh,kDen))

                iShp = iTri(iaSh,ibSh)

                iOffShb = kOffSh(ibSh,lSym)

                iOffAB = nnBfShp(iShp,lSym)

                xFab = sqrt(abs(Faa(iaSh)*Faa(ibSh)))

                if (MLk(lSh,jK_a,1)*MLk(mSh,jK_a,kDen) < tau) then

                  mSh = Indx(0,jK_a,kDen) ! skip rest

                else if ((iaSh == ibSh) .and. (xFab >= tau/MaxRedT) .and. (iaSkip*ibSkip == 1)) then

                  nBs = nBasSh(lSym,iaSh)

                  if (lSym >= kSym) then

                    ! F(a,b)[k] = F(a,b)[k] + FactXI * sum_J  X1(a,J)[k] * X2(b,J)[k]
                    ! ---------------------------------------------------------------

                    Mode = 'N'
                    Mode2 = 'T'
                    n2 = nBs

                  else

                    ! F(a,b)[k] = F(a,b)[k] + FactXI * sum_J  X1(J,a)[k] * X2(J,b)[k]
                    ! ---------------------------------------------------------------

                    Mode = 'T'
                    Mode2 = 'N'
                    n2 = JNUM

                  end if

                  call DGEMM_Tri(Mode,Mode2,nBasSh(lSym,iaSh),nBasSh(lSym,ibSh),JNUM,FActXI,Lab%SB(iaSh,lsym,1)%A,n2, &
                                 Lab%SB(ibSh,lsym,kDen)%A,n2,One,KLT%SB(lSym)%A1(iOffAB+1:),nBs)

                else if ((iaSh > ibSh) .and. (xFab >= tau/MaxRedT) .and. (iaSkip*ibSkip == 1)) then

                  nBsa = nBasSh(lSym,iaSh)
                  if (lSym >= kSym) then

                    ! F(a,b)[k] = F(a,b)[k] + FactXI * sum_J  X1(a,J)[k] * X2(b,J)[k]
                    ! ---------------------------------------------------------------
                    n1 = nBasSh(lSym,iaSh)
                    n2 = max(1,nBasSh(lSym,ibSh))
                    Mode = 'N'
                    Mode2 = 'T'

                  else

                    ! F(a,b)[k] = F(a,b)[k] + FactXI * sum_J  X1(J,a)[k] * X2(J,b)[k]
                    ! ---------------------------------------------------------------

                    n1 = JNUM
                    n2 = JNUM
                    Mode = 'T'
                    Mode2 = 'N'

                  end if

                  call DGEMM_(Mode,Mode2,nBasSh(lSym,iaSh),nBasSh(lSym,ibSh),JNUM,FActXI,Lab%SB(iaSh,lsym,1)%A,n1, &
                              Lab%SB(ibSh,lsym,kDen)%A,n2,ONE,KLT%SB(lSym)%A1(iOffAB+1:),nBsa)

                end if

                mSh = mSh+1 ! update shell counter

              end do

            end do

            call CWTIME(TCX2,TWX2)
            texch(1) = texch(1)+(TCX2-TCX1)
            texch(2) = texch(2)+(TWX2-TWX1)

          end do ! loop over k MOs

        end do ! loop over MOs symmetry

        call Deallocate_DT(Lab)
        call Deallocate_DT(L_Full)
        !                                                              *
        !***************************************************************
        !***************************************************************
        !***************************************************************
        !                                                              *
        DoScreen = .false. ! avoid redo screening inside batch loop

        ! Diagonals updating. It only makes sense if Nscreen > 0

        if (Update .and. (Nscreen > 0)) then

          call CWTIME(TCS1,TWS1)
          ! -----------------------------------------------------------------
          ! update the diagonals :   D(a,b) = D(a,b) - sum_J (Lab,J)^2
          !
          ! subtraction is done in the 1st reduced set
#         ifdef _MOLCAS_MPP_
          if ((nProcs > 1) .and. Is_Real_Par()) then

            do krs=1,nRS

              mrs = iiBstR(JSYM,iLoc)+krs
              jrs = IndRed(mrs,iLoc)-iiBstR(JSYM,1)

              do jvc=1,JNUM

                DiagJ(jrs) = DiagJ(jrs)+Lrs(krs,jvc)**2
              end do

            end do

          else
#         endif

            do krs=1,nRS

              mrs = iiBstR(JSYM,iLoc)+krs
              jrs = IndRed(mrs,iLoc) ! address in 1st red set

              do jvc=1,JNUM

                Diag(jrs) = Diag(jrs)-Lrs(krs,jvc)**2
              end do

            end do

#         ifdef _MOLCAS_MPP_
          end if
#         endif

          call CWTIME(TCS2,TWS2)
          tscrn(1) = tscrn(1)+(TCS2-TCS1)
          tscrn(2) = tscrn(2)+(TWS2-TWS1)

        end if

        ! ************  END EXCHANGE CONTRIBUTION  ****************

        iSwap = 0  ! Lvb,J are returned
        call Allocate_DT(Laq(1),nAsh,nBas,nVec,JSYM,nSym,iSwap)
        call Allocate_DT(Laq(2),nAsh,nAsh,nVec,JSYM,nSym,iSwap)
        ! ----------------------------------------------------------------
        ! First half Active transformation  Lvb,J = sum_a  C1(v,a) * Lab,J
        ! ----------------------------------------------------------------

        call CWTIME(TCINT1,TWINT1)

        ! The memory used before for the full-dimension AO-vectors
        !     is now re-used to store half and full transformed
        !     vectors in the active space
        ! ---------------------------------------------------------

        kMOs = 1
        nMOs = 1 ! Active MOs (1st set)

        call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,Ash,Laq,DoRead)

        if (irc /= 0) return

        ! ----------------------------------------------------------------
        ! Active-Active transformation  Lvw,J = sum_b  Lvb,J * C2(w,b)
        ! ----------------------------------------------------------------
        do iSymb=1,nSym

          iSymv = Mul(JSYM,iSymb)
          NAv = nAsh(iSymv)
          NAw = nAsh(iSymb) ! iSymb=iSymw

          if (NAv*NAw /= 0) then

            do JVC=1,JNUM

              call DGEMM_('N','T',NAv,NAw,NBAS(iSymb),One,Laq(1)%SB(iSymv)%A3(:,:,JVC),NAv,Ash(kDen)%SB(iSymb)%A2,NAw,Zero, &
                          Laq(2)%SB(iSymv)%A3(:,:,JVC),NAv)

            end do

          end if

        end do

        ! *************** EVALUATION OF THE (TW|XY) INTEGRALS ***********

        DoReord = (JRED == myJRED2) .and. (iBatch == nBatch)

        call CHO_rassi_twxy(irc,Scr,Laq(2),TUVX,nAsh,JSYM,JNUM,DoReord)

        call CWTIME(TCINT2,TWINT2)
        tintg(1) = tintg(1)+(TCINT2-TCINT1)
        tintg(2) = tintg(2)+(TWINT2-TWINT1)

        if (irc /= 0) return

        ! ---------------- END (TW|XY) EVALUATION -----------------------

        call Deallocate_DT(Laq(2))
        call Deallocate_DT(Laq(1))

      end do ! end batch loop

      if (JSYM == 1) then
        ! backtransform fock matrix to full storage
        add = .true.
        nMat = 1
        call swap_rs2full(irc,iLoc,nRS,nMat,JSYM,FLT,Frs,add)
      end if

      ! free memory
      call mma_deallocate(Lrs)

      if (JSYM == 1) then
        call mma_deallocate(Frs)
        call mma_deallocate(Drs)
      end if

    end if

    ! Screening control section
    DoScreen = kscreen == Nscreen

    if (.not. DoScreen) then
      kscreen = kscreen+1
    else
      kscreen = 1
    end if

#   ifdef _MOLCAS_MPP_
    if ((nProcs > 1) .and. Update .and. DoScreen .and. Is_Real_Par()) then
      call GaDsum(DiagJ,nnBSTR(JSYM,1))
      call Daxpy_(nnBSTR(JSYM,1),-One,DiagJ,1,DIAG(1+iiBstR(JSYM,1)),1)
      call Fzero(DiagJ,nnBSTR(JSYM,1))
    end if
    ! Need to activate the screening to setup the contributing shell
    ! indices the first time the loop is entered .OR. whenever other nodes
    ! have performed screening in the meanwhile
    if ((nProcs > 1) .and. (.not. DoScreen) .and. (nVrs == 0) .and. Is_Real_Par()) then
      ntv0 = ntv0+1
      DoScreen = (JRED < myJRED1) .or. (ntv0 >= Nscreen)
      if (DoScreen) ntv0 = 0
    end if
#   endif

  end do   ! loop over red sets

  call Deallocate_DT(Scr)

end do ! loop over JSYM

! Accumulate Coulomb and Exchange contributions
do iSym=1,nSym

  do iaSh=1,nShell

    ioffa = kOffSh(iaSh,iSym)

    ! ibSh < iaSh
    ! -----------
    do ibSh=1,iaSh-1

      iShp = iaSh*(iaSh-1)/2+ibSh

      iOffAB = nnBfShp(iShp,iSym)

      ioffb = kOffSh(ibSh,iSym)

      do ib=1,nBasSh(iSym,ibSh)

        do ia=1,nBasSh(iSym,iaSh)

          iab = nBasSh(iSym,iaSh)*(ib-1)+ia

          iag = ioffa+ia
          ibg = ioffb+ib

          iabg = iTri(iag,ibg)

          FLT(1)%SB(iSym)%A1(iabg) = FLT(1)%SB(iSym)%A1(iabg)+KLT%SB(iSym)%A1(iOffAB+iab)

        end do

      end do

    end do

    ! ibSh = iaSh
    ! -----------
    iShp = iaSh*(iaSh+1)/2

    iOffAB = nnBfShp(iShp,iSym)

    do ib=1,nBasSh(iSym,iaSh)

      do ia=ib,nBasSh(iSym,iaSh)

        iab = ia*(ia-1)/2+ib

        iag = ioffa+ia
        ibg = ioffa+ib

        iabg = iag*(iag-1)/2+ibg

        FLT(1)%SB(iSym)%A1(iabg) = FLT(1)%SB(iSym)%A1(iabg)+KLT%SB(iSym)%A1(iOffAB+iab)

      end do

    end do

  end do

end do

call mma_deallocate(Fia)
call mma_deallocate(Faa)
call mma_deallocate(SvShp)
call mma_deallocate(iShp_rs)
call mma_deallocate(nnBfShp)
call mma_deallocate(kOffSh)
call mma_deallocate(Indx)
call mma_deallocate(SumAClk)
call mma_deallocate(MLk)
call mma_deallocate(Ylk)
call mma_deallocate(AbsC)
call Deallocate_DT(DiaH)
#ifdef _MOLCAS_MPP_
if ((nProcs > 1) .and. Update .and. Is_Real_Par()) call mma_deallocate(DiagJ)
#endif
call mma_deallocate(DIAG)

if (Deco) then
  call Deallocate_DT(CM(2))
  call Deallocate_DT(CM(1))
end if
do jden=1,nDen
  call Deallocate_DT(MO(jDen))
end do

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky RASSI timing from '//SECNAM
  write(u6,CFmt) '----------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Fock matrix construction        CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ VECTORS                              ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COULOMB                                   ',tcoul(1),tcoul(2)
  write(u6,'(2x,A26,2f10.2)') 'EXCHANGE                                  ',texch(1),texch(2)
  write(u6,'(2x,A26,2f10.2)') '(TW|XY) INTEGRALS                         ',tintg(1),tintg(2)
  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

! Print the Fock-matrix
#ifdef _DEBUGPRINT_
if (Debug) then ! to avoid double printing in RASSI-debug

  write(u6,'(6X,A)') 'TEST PRINT FROM '//SECNAM
  write(u6,'(6X,A)')
  write(u6,'(6X,A)') '***** INACTIVE FOCK MATRIX ***** '
  do ISYM=1,NSYM
    if (NBAS(ISYM) > 0) then
      write(u6,'(6X,A)')
      write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
      call TRIPRT('','',FLT(1)%SB(ISYM)%A1,NBAS(ISYM))
    end if
  end do

end if
#endif

call Deallocate_DT(KLT)

return

end subroutine CHO_LK_RASSI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Stefan Knecht                                    *
!***********************************************************************

subroutine mpssi(iReturn)

#ifdef _DMRG_
use rasscf_data, only: doDMRG
#endif
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iReturn
! ----------------------------------------------------------------------

!> set QCMaquis as default (actually the only possible) DMRG driver in RASSI
#ifdef _DMRG_
doDMRG = .true.
#else
! this should not happen
call WarningMessage(2, "Please compile with QCMaquis support to run MPSSI.")
call Quit_OnUserError()
#endif

!> print info about MPS-SI
write(u6,'(/a/,a//,a/,a/,a/,a/,a/)') &
  '   ---------------------------------------------------------', &
  '   Matrix-Product-State State-Interaction (MPS-SI) activated', &
  '   Please cite for the MPS-SI framework:',                     &
  '   S. Knecht, S. Keller, J. Autschbach, M. Reiher,',           &
  '   J. Chem. Theory Comput., 12, 5881-5894 (2016).',            &
  '   ---------------------------------------------------------'

!> call state-interaction workhorse aka RASSI
iReturn = 0
call rassi(iReturn)

#ifdef _DMRG_
!> reset in case we call RASSI afterwards requesting a CI driver
doDMRG = .false.
#endif

end subroutine mpssi

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine WfCtl_SA(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,iRHSDisp,converged,iPL)
!***********************************************************************
!                                                                      *
!     called from: MCLR                                                *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: Mul
use ipPage, only: ipclose, ipget, ipin, ipnout, ipout, opout, W
use gugx, only: CIS, EXS, SGS
use MCLR_Data, only: ipCI, ipDia, IRLXROOT, ISNAC, LuQDat, LuTemp, NACSTATES, nConf1, nDens, nDensC, XISPSM
use input_mclr, only: Debug, Eps, Fail, iAddressQDat, iBreak, iMethod, iSpin, kPrint, lSave, nActEl, nAsh, nConf, nCSF, nDisp, &
                      nElec3, nHole1, nIter, NROOTS, nRS1, nRS2, nRS3, nSym, PT2, State_Sym, STEPTYPE, TWOSTEP
use PCM_grad, only: def_solv, do_RF, iStpPCM, PCM_grad_CLag, PCM_grad_PT2
use ISRotation, only: DMInvISR, InvSCF, ISR, ISR_final, ISR_init, ISR_projection, ISR_RHS
use cgs_mod, only: CGS, CGS_init, CGS_final
use dmrginfo, only: DoDMRG, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iKapDisp(nDisp), isigDisp(nDisp), iCIDisp(nDisp), iCIsigDisp(nDisp), iRHSDisp(nDisp)
logical(kind=iwp), intent(out) :: converged(8)
integer(kind=iwp), intent(in) :: iPL
integer(kind=iwp) :: iDis, iDisp, iLen, ipCID, ipCIT, ipPre2, ipS1, ipS2, ipST, iR, iSym, Iter, jSpin, Left, lLine, lPaper, Lu_50, &
                     nConf3, niPre2, nPre2
real(kind=wp) :: Delta, Delta0, DeltaC, DeltaK, R1, R2, rAlpha, rAlphaC, rAlphaK, rBeta, ReCo, Res, rEsci, rEsk, rEss
logical(kind=iwp) :: CI, cnvrgd, lPrint
character(len=8) :: Fmt2
integer(kind=iwp), allocatable :: iPre(:)
real(kind=wp), allocatable :: dKappa(:), Fancy(:), Kappa(:), rCHC(:), Sc1(:), Sc2(:), Sigma(:), SLag(:,:), Temp3(:), Temp4(:), &
                              wrk(:)
integer(kind=iwp), external :: niPre, nPre
real(kind=wp), external :: DDot_

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
call StatusLine('MCLR: ','Computing Lagrangian multipliers for SA-CASSCF')

lPaper = 132
lLine = 120
left = (lPaper-lLine)/2
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
!----------------------------------------------------------------------*

iDis = 0

fail = .false.
Converged(:) = .true.
!MGD I think this is nice when printed...
lprint = .true.
reco = -One
Lu_50 = 50
if (lSAVE) call DANAME(Lu_50,'RESIDUALS')
if (lSAVE) then
  write(u6,*) 'WfCtl_SA: SAVE option not implemented'
  call Abend()
end if
if (btest(kprint,1)) lprint = .true.
isym = 1
nconf1 = ncsf(State_Sym)
!! iStpPCM has been set somewhere; just a reminder
iStpPCM = 1

CI = .false.
if ((iMethod == 2) .and. (nconf1 > 0)) CI = .true.

! Initiate CSF <-> SD
call InCSFSD(Mul(iSym,State_Sym),State_sym)

! Calculate length of the density, Fock and Kappa matrix etc
! notice that this matrices are not necessarily symmetric.
! Store pointers.
!
! Input:
!        iSym: Symmetry of perturbation
!
! Output: Commonblocks (Pointers.fh)

nConf3 = nint(max(xispsm(State_SYM,1),xispsm(State_SYM,1)))

call Setup_MCLR(iSym)

! Determine if we should page CI vectors
!                            [2]
! Calculate the diagonal of E    and store in core/disc

call mma_allocate(FANCY,nroots**3,Label='FANCY')
call mma_allocate(rCHC,nRoots,Label='rCHC')
call CIDia_SA(State_Sym,rCHC,Fancy)
call mma_deallocate(rCHC)

call ipOut(ipdia)

! initialize CGS and some for InvSCF/InvEne
call ISR_Init(iPL,do_RF,def_solv)

! Allocate disk/memory space

! This areas should be addressed through ipIn
! ipOut will page them out to disk and free the memory area
! if page mode is used

! opOut will release the memory area without update the disk

ipS1 = ipGet(nconf3*nroots)
ipS2 = ipGet(nconf3*nroots)
ipST = ipGet(nconf3*nroots)
ipCIT = ipGet(nconf1*nroots)
ipCId = ipGet(nconf1*nroots)

nipre2 = nipre(isym)
npre2 = npre(isym)
ipPre2 = ipGet(npre2)
call ipIn(ipPre2)
call mma_allocate(iPre,nipre2,Label='iPre')
if (TwoStep .and. (StepType == 'RUN2')) then
  ! fetch data from LuQDAT and skip the call to "Prec"
  call ddafile(LuQDAT,2,W(ipPre2)%A,npre2,iaddressQDAT)
  call idafile(LuQDAT,2,iPre,nipre2,iaddressQDAT)
else
  call Prec(W(ipPre2)%A,iPre,isym)
  call ipOut(ippre2)
end if
if (TwoStep .and. (StepType == 'RUN1')) then
  ! save the computed data in "Prec" to LuQDAT and skip the
  ! following part of this function
  call ipIn(ipPre2)
  call ddafile(LuQDAT,1,W(ipPre2)%A,npre2,iaddressQDAT)
  call idafile(LuQDAT,1,iPre,nipre2,iaddressQDAT)
else

  ! OK START WORKING

  !idisp = 1
  jspin = 0

  ! Allocate areas for scratch and state variables

  call mma_allocate(Kappa,nDensC,Label='Kappa')
  call mma_allocate(dKappa,nDensC,Label='dKappa')
  call mma_allocate(Sigma,nDensC,Label='Sigma')
  call mma_allocate(Temp3,nDens,Label='Temp3')
  call mma_allocate(Temp4,nDensC,Label='Temp4')
  call mma_allocate(Sc1,nDens,Label='Sc1')
  call mma_allocate(Sc2,nDensC,Label='Sc2')
  if (CGS) call CGS_init(nconf1,nRoots,nDens)

  do iDisp=1,nDisp
    Kappa(:) = Zero
    dKappa(:) = Zero
    Sigma(:) = Zero
    Sc1(:) = Zero

    !-------------------------------------------------------------------
    !
    ! Calculate RHS for the perturbation
    !
    !-------------------------------------------------------------------

    ! (T1,T2,T3,T4,T5,T6,T7,Kappa1,CI1)

    if (debug) then
      if (isNAC) then
        write(u6,*) 'States: ',NACstates(1),NACstates(2)
      else
        write(u6,*) 'State: ',irlxroot
      end if
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    call mma_allocate(SLag,nRoots,nRoots,Label='SLag')
    SLag(:,:) = Zero
    if (PT2) then
      call RHS_PT2(Sc1,W(ipST)%A,SLag)
      ! The order of CSF coefficients in CASPT2 and MCLR is somehow
      ! different, so the CI lagrangian computed in CASPT2 must be
      ! reordered so that it can be used here.
      call mma_allocate(wrk,nConf1,Label='wrk')
      do iR=1,nRoots
        wrk(:) = W(ipST)%A(nConf1*(iR-1)+1:nConf1*iR)
        call GugaNew(nSym,iSpin,nActEl,nHole1,nElec3,nRs1,nRs2,nRs3,SGS,CIS,EXS,wrk,1,State_Sym,State_Sym)
        NCSF(1:nSym) = CIS%NCSF(1:nSym)
        NCONF = CIS%NCSF(State_Sym)
        call mkGuga_Free(SGS,CIS,EXS)
        W(ipST)%A(nConf1*(iR-1)+1:nConf1*iR) = wrk(:)
      end do
      call mma_deallocate(wrk)
      ! SLag given by the CASPT2 routine should be treated as the
      ! initial rotation of the reference states.
      ! If we need to treat parameters as internal rotations, they
      ! will be computed later using configuration parameters.
      if (do_RF) call PCM_grad_PT2()
    else
      W(ipST)%A(1:nconf3*nRoots) = Zero
    end if

    if (do_RF .or. PT2) then
      !! SA-CASSCF/PCM may not be stationary wrt CI coefficients
      !! Use ipS2 for the moment (some intermediate vectors are SD but output vectors are CSF)
      if (do_RF) then
        call PCM_grad_CLag(1,ipCI,ipS2)
        W(ipS2)%A(1:nconf1*nRoots) = W(ipS2)%A(1:nconf1*nRoots)+W(ipST)%A(1:nconf1*nRoots)
      else if (PT2) then
        W(ipS2)%A(1:nconf1*nRoots) = W(ipST)%A(1:nconf1*nRoots)
      end if
      if (InvSCF) then
        call ISR_RHS(W(ipCI)%A,W(ipS2)%A)
        call ISR_Projection(W(ipCI)%A,W(ipS2)%A)
        SLag(:,:) = SLag(:,:)+ISR%Rvec(:,:)
        ISR%Rvec(:,:) = Zero
      end if
      W(ipST)%A(1:nconf1*nRoots) = W(ipS2)%A(1:nconf1*nRoots)
      W(ipS2)%A(1:nconf3*nRoots) = Zero
      ! If SLag is nonzero, the contribution comes from the rotation of the model state (i.e., MS-type CASPT2)
      ! but should not be taken as the initial residue of the internal rotation, so SLag should not be added to Rvec.
      !if (.not. InvSCF) ISR%Rvec(:,:) = ISR%Rvec(:,:)+SLag
    end if

    if (isNAC) then
      call RHS_NAC(Temp3,SLag,ipS2)
    else
      call RHS_SA(Temp3,SLag,ipS2)
    end if
    call mma_deallocate(SLag)

    ! Add implicit CI derivative contributions (if evaluated in rhs_sa/nac)
    ! due to the non-iterative internal state rotations
    if (do_RF) then
      W(ipST)%A(1:nconf1*nRoots) = W(ipST)%A(1:nconf1*nRoots)+W(ipS2)%A(1:nconf1*nRoots)
      call ISR_RHS(W(ipCI)%A,W(ipST)%A)
      call ISR_Projection(W(ipCI)%A,W(ipST)%A)
    end if

    ! Temp3: SA-CASSCF contributions
    ! Sc1  : CASPT2 contributions
    if (PT2) then
      Temp3(:) = Temp3(:)+Sc1(:)
      Sc1(:) = Zero
    end if

    call opOut(ipci)

    if (lprint) write(u6,*) '       Iteration       Delta           Res(kappa)       Res(CI)          DeltaK           DeltaC'
    iLen = nDensC
    iRHSDisp(iDisp) = iDis
    call Compress(Temp3,Sigma,iSym)
    r1 = ddot_(nDensC,Sigma,1,Sigma,1)
    if (PT2 .or. do_RF) R1 = R1+DDot_(nConf1*nRoots,W(ipST)%A,1,W(ipST)%A,1)
    if (debug) write(u6,*) 'Hi how about r1',r1
    call dDaFile(LuTemp,1,Sigma,iLen,iDis)

    if (PT2 .or. do_RF) then !! .or. unequal_SA) then
      W(ipST)%A(1:nConf1*nRoots) = -W(ipST)%A(1:nConf1*nRoots)
      if (CI) then
        ! precondition (z0 = M^{-1}*r0)
        if (CGS) then
          W(ipS2)%A(1:nConf1*nRoots) = W(ipST)%A(1:nConf1*nRoots)
        else
          call DMinvCI_sa(ipST,W(ipS2)%A,fancy)
        end if
        call opOut(ipci)
        call opOut(ipdia)
        ! z0 <= p0
        W(ipCId)%A(1:nConf1*nRoots) = W(ipS2)%A(1:nConf1*nRoots)
      end if
    else
      call ipIn(ipCIT)
      call ipIn(ipST)
      call ipIn(ipCID)
      W(ipCIT)%A(1:nConf1*nroots) = Zero
      W(ipST)%A(1:nConf1*nroots) = Zero
      W(ipCID)%A(1:nConf1*nroots) = Zero
    end if
    call ipOut(ipCIT)
    Sigma(:) = -Sigma(:)

    iter = 1
    call ipIn(ipPre2)
    if (CGS) then
      Kappa(1:nDensC) = Sigma(1:nDensC)
    else
      call DMInvKap(W(ipPre2)%A,iPre,Sigma,Kappa,Temp3,isym,iter)
    end if

    call opOut(ippre2)
    r2 = ddot_(nDensC,Kappa,1,Kappa,1)
    if (PT2) R2 = R2+DDot_(nConf1*nRoots,W(ipS2)%A,1,W(ipS2)%A,1)
    if (debug) write(u6,*) 'In that case I think that r2 should be:',r2
    if (r2 > r1) write(u6,*) 'Warning perturbation number ',idisp,' might diverge'

    dKappa(:) = Kappa(:)

    if (.not. InvSCF) then
      ISR%Rvec(:,:) = -ISR%Rvec(:,:)
      if (.not. CGS) then
        call DMInvISR(ISR%Rvec,ISR%prec)
        ISR%p(:,:) = ISR%prec(:,:)
      end if
    end if

    if (CGS) then
      call cgs_pre(nDensC,nConf1,nRoots,Kappa,dKappa,Sigma,Fancy,Sc1,ipCI,ipCId,ipDia,ipPre2,iPre,ipST,ipS1,delta,iSym,iter)
    else
      deltaC = Zero
      if (PT2) deltaC = ddot_(nConf1*nroots,W(ipST)%A,1,W(ipS2)%A,1)
      call ipOut(ipcid)
      deltaK = ddot_(nDensC,Kappa,1,Sigma,1)
      Kappa(:) = Zero
      delta = deltac+deltaK
    end if
    delta0 = delta
    iter = 1
    iStpPCM = 2
    !-------------------------------------------------------------------

    cnvrgd = .true.
    do
      if (delta == Zero) exit
      if (CGS) then
        !! (Preconditioned) Conjugate Gradient Squared (CGS) method, instead of the conventional PCG
        call cgs_x(nDensC,nConf1,nRoots,iSym,jspin,iter,ipCI,ipDia,ipS1,ipS2,ipST,ipCIT,ipCId,ipPre2,reco,Fancy,Kappa,dKappa, &
                   Sigma,Temp4,Sc1,iPre,delta,resk,resci,deltak,deltac)
        !! end of CGS
      else
        !! standard PCG starts here

        call TimesE2(dKappa,ipCId,1,reco,jspin,ipS2,Temp4,ipS1)

        !---------------------------------------------------------------
        !
        !            delta
        ! rAlpha=------------
        !        dKappa:dSigma
        !
        !---------------------------------------------------------------

        rAlphaK = Zero
        rAlphaK = ddot_(nDensC,Temp4,1,dKappa,1)
        rAlphaC = Zero
        call ipIn(ipS1)
        call ipIn(ipCId)
        rAlphaC = ddot_(nConf1*nroots,W(ipS1)%A,1,W(ipCId)%A,1)
        if (.not. InvSCF) rAlphaC = rAlphaC+ddot_(nRoots**2,ISR%Ap,1,ISR%p,1)
        rAlpha = delta/(rAlphaK+rAlphaC)

        !--------------------------------------------------------------*

        ! Kappa=Kappa+rAlpha*dKappa
        Kappa(:) = Kappa(:)+ralpha*dKappa(:)
        ! Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa
        Sigma(:) = Sigma(:)-ralpha*Temp4(:)
        resk = sqrt(ddot_(nDensC,Sigma,1,Sigma,1))
        resci = Zero
        call ipIn(ipCIT)
        W(ipCIT)%A(1:nConf1*nroots) = W(ipCIT)%A(1:nConf1*nroots)+ralpha*W(ipCId)%A(1:nConf1*nroots)
        call ipOut(ipcit)
        ! ipST =ipST -rAlpha*ipS1         ipST=RHS-A*ipCIT
        call ipIn(ipS1)
        call ipIn(ipST)
        W(ipST)%A(1:nConf1*nroots) = W(ipST)%A(1:nConf1*nroots)-ralpha*W(ipS1)%A(1:nConf1*nroots)
        call opOut(ipS1)
        call ipIn(ipST)
        resci = sqrt(ddot_(nconf1*nroots,W(ipST)%A,1,W(ipST)%A,1))
        if (.not. InvSCF) then
          ISR%Xvec(:,:) = ISR%Xvec(:,:)+ralpha*ISR%p(:,:)
          ISR%Rvec(:,:) = ISR%Rvec(:,:)-ralpha*ISR%Ap(:,:)
          ress = sqrt(ddot_(nRoots**2,ISR%Rvec,1,ISR%Rvec,1))
          resci = resci+ress
        end if

        !--------------------------------------------------------------*
        ! Precondition......
        !    -1
        ! S=M  Sigma

        call opOut(ipcid)

        call ipIn(ipS2)
        call DMinvCI_SA(ipST,W(ipS2)%A,Fancy)
        call opOut(ipci)
        call opOut(ipdia)

        call ipIn(ipPre2)
        call DMInvKap(W(ipPre2)%A,iPre,Sigma,Sc2,Sc1,iSym,iter)
        call opOut(ippre2)

        if (.not. InvSCF) call DMInvISR(ISR%Rvec,ISR%prec)

        !--------------------------------------------------------------*
        !      s:Sigma (k+1)     s:Sigma (k+1)
        ! Beta=-------        =  -------------
        !       delta  (k)        s:Sigma (k)
        !
        ! delta=s:sigma
        !
        ! dKappa=s+Beta*dKappa

        deltaC = ddot_(nConf1*nroots,W(ipST)%A,1,W(ipS2)%A,1)
        call ipOut(ipST)
        if (.not. InvSCF) deltaC = deltaC+ddot_(nRoots**2,ISR%Rvec,1,ISR%prec,1)

        deltaK = ddot_(nDensC,Sigma,1,Sc2,1)
        if (.not. CI) then
          rBeta = deltaK/delta
          delta = deltaK
          dKappa(:) = rBeta*dKappa(:)+Sc2(:)
        else
          rbeta = (deltac+deltaK)/delta
          delta = deltac+deltaK
          call ipIn(ipCID)
          W(ipCID)%A(1:nConf1*nroots) = rBeta*W(ipCID)%A(1:nConf1*nroots)+W(ipS2)%A(1:nConf1*nroots)
          dKappa(:) = rBeta*dKappa(:)+Sc2(:)
          call opOut(ipS2)
          call ipOut(ipCID)
          if (.not. InvSCF) ISR%p(:,:) = ISR%prec(:,:)+rbeta*ISR%p(:,:)
        end if
      end if ! CGS vs PCG

      !  ######  #    #  #####        #####    ####    ####
      !  #       ##   #  #    #       #    #  #    #  #    #
      !  #####   # #  #  #    #       #    #  #       #
      !  #       #  # #  #    #       #####   #       #  ###
      !  #       #   ##  #    #       #       #    #  #    #
      !  ######  #    #  #####        #        ####    ####
      !
      !----------------------------------------------------------------*

      res = Zero ! dummy initialize
      if (iBreak == 1) then
        if (abs(delta) < abs(Eps**2*delta0)) exit
      else if (iBreak == 2) then
        res = sqrt(resk**2+resci**2)
        if (doDMRG) res = sqrt(resk**2)
        if (res < abs(Eps)) exit
      else
        if ((abs(delta) < abs(Eps**2*delta0)) .and. (res < abs(Eps))) exit
      end if
      if (iter >= niter) then
        cnvrgd = .false.
        exit
      end if
      if (lprint) write(u6,Fmt2//'I7,4X,ES17.9,ES17.9,ES17.9,ES17.9,ES17.9)') iter,delta/delta0,resk,resci,deltak,deltac
      iter = iter+1

    end do

    !*******************************************************************

    if (.not. cnvrgd) then
      write(u6,Fmt2//'A,I4,A)') 'No convergence for perturbation no: ',idisp,'. Increase Iter.'
      converged(isym) = .false.
      fail = .true.
    else
      if (iPL >= 2) write(u6,Fmt2//'A,I4,A,I4,A)') 'Perturbation no: ',idisp,' converged in ',iter-1,' steps.'
      call ipnout(-1)
    end if

    if (iPL >= 2) write(u6,*)
    iLen = nDensC
    iKapDisp(iDisp) = iDis
    call dDaFile(LuTemp,1,Kappa,iLen,iDis)
    iSigDisp(iDisp) = iDis
    call dDaFile(LuTemp,1,Sigma,iLen,iDis)
    ilen = nconf1*nroots
    iCIDisp(iDisp) = iDis

    call ipin(ipCIT)
    call dDaFile(LuTemp,1,W(ipCIT)%A,iLen,iDis)

    !MGD This last call seems unused, so I comment it

    !call TimesE2(Kappa,ipCIT,1,reco,jspin,ipS2,Temp4,ipS2)
    iCISigDisp(iDisp) = iDis
    call ipin(ipST)
    call dDaFile(LuTemp,1,W(ipST)%A,iLen,iDis)

    !! Save the total internal rotations so that CIDens_sa can use
    !! the parameters to generate correct densities
    if (.not. InvSCF) ISR%p(:,:) = ISR%Xvec(:,:)
  end do ! iDisp

  call mma_deallocate(Temp4)
  call mma_deallocate(Temp3)
  call mma_deallocate(Sigma)
  call mma_deallocate(dKappa)
  call mma_deallocate(Kappa)
  call mma_deallocate(Sc2)
  call mma_deallocate(Sc1)
end if

if (CGS) call CGS_final()
call ISR_final()

! Free all memory and remove from disk all data
! related to this symmetry

call mma_deallocate(Fancy)
call mma_deallocate(iPre)

call ipclose(ipdia)
if (.not. CI) call ipclose(ipPre2)

if (debug) then
  write(u6,*) '********************************************************************************'
  write(u6,*)
end if
if (doDMRG) then  ! yma
  nash(:) = RGras2(:)
  nrs2(:) = RGras2(:)
end if
iStpPCM = 3

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine WfCtl_SA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE OSPIR(  NOSPIR,  IOSPIR,  PNTGRP,  NIRREP,  MXPIRR,
     &                   MXPOBS,   IPRNT)
*
* Number and symmetries of orbitals corresponding to a given shell
*
* =====
* Input
* =====
*
*   PNTGRP  : type of pointgroup
*         = 1 => D2h or a subgroup of D2H
*         = 2 => C inf v
*         = 3 => D inf h
*         = 4 => O 3
*   NIRREP : Number of irreducible representations per point group
*   MXPIRR : Largest allowed number of shell irreps
*   MXPOBS : Largest allowed number of orbital symmetries
*
* ======
* Output
* ======
*
*   NOSPIR : Number of orbital symmetries per irrep
*   IOSPIR : Orbital symmetries corresponding to a given irrep
*
* Jeppe Olsen , Winter of 1991
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER PNTGRP
*. Output
      DIMENSION NOSPIR(MXPIRR),IOSPIR(MXPOBS,MXPIRR)
*
      IF(PNTGRP.EQ.1) THEN
*=====
*.D2h
*=====
        NSMOB = 0
        DO 10 IRREP = 1, 8
          NOSPIR(IRREP) = 1
          IOSPIR(1,IRREP) = IRREP
   10   CONTINUE
      ELSE
        WRITE(6,*) ' Sorry  PNTGRP out of range , PNTGRP = ', PNTGRP
        WRITE(6,*) ' OSPIR fatally wounded '
*        STOP 5
        CALL SYSABENDMSG('lucia_util/ospir','Internal error',' ')
      END IF
*
      NTEST = 0
      NTEST = MAX(IPRNT,NTEST)
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' OSPIR speaking '
        WRITE(6,*) ' ================'
        WRITE(6,*) ' Number of orbitals per irrep '
        CALL IWRTMA(NOSPIR,1,NIRREP,1,NIRREP)
        WRITE(6,*) ' Orbital symmetries per irrep '
        DO 100 IRREP = 1, NIRREP
          CALL IWRTMA(IOSPIR(1,IRREP),1,NOSPIR(IRREP),1,NOSPIR(IRREP))
  100   CONTINUE
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Dipol_Exchange(N1,N2,vec,dist,M1,M2,HDIP)
! this Subroutine computes the dipolar coupling between the two moments

use Constants, only: Zero, Three, cZero, cOne, cm_s, hPlanck, mBohr
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N1, N2
real(kind=wp), intent(in) :: vec(3), dist
complex(kind=wp), intent(in) :: M1(3,N1,N1), M2(3,N2,N2)
complex(kind=wp), intent(out) :: HDIP(N1,N1,N2,N2)
integer(kind=iwp) :: i1, i2, j1, j2, m
complex(kind=wp) :: d3, HL, mb2c, p1, p2a, p2b, vec1(3)
real(kind=wp), parameter :: MB2 = 1.0e23_wp*mBohr**2/(cm_s*hPlanck) ! -- the value of (mu_Bohr*mu_Bohr)/(angstrom^3)  in cm-1
complex(kind=wp), parameter :: threeC = Three*cOne

if ((N1 <= 0) .or. (N2 <= 0)) return
if (dist == Zero) then
  HDIP(:,:,:,:) = cZero
  write(u6,'(A)') 'DIPOL_EXCHANGE::  dist = 0'
  write(u6,'(A)') 'this is not normal. Stop.'
  return
end if
! switch to Complex arithmetic:
d3 = dist*dist*dist*cOne
mb2c = MB2*cOne
vec1(:) = vec(:)*cOne
! calculate the dipolar coupling:
do i1=1,N1
  do j1=1,N1
    do i2=1,N2
      do j2=1,N2
        p2a = cZero
        p2b = cZero
        p1 = cZero
        do m=1,3
          p2a = p2a+M1(m,i1,j1)*vec1(m)
          p2b = p2b+M2(m,i2,j2)*vec1(m)
          p1 = p1+M1(m,i1,j1)*M2(m,i2,j2)
        end do
        HL = p1-threeC*p2a*p2b
        HDIP(i1,j1,i2,j2) = mb2c*HL/d3
      end do
    end do
  end do
end do

return

end subroutine Dipol_Exchange

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine casinfodef_cvb()
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "casinfo_cvb.fh"
#include "inpmod_cvb.fh"

c  Counters
      nstsym_d=0

      noe=2*mxorb
      if(.not.variat)then
        strtci=recn_jobold
      else
        strtci=recn_jobiph
      endif
      strtmo=recn_jobiph
      strtint=recn_oneint
      strtvb=recn_vbwfn
      savvb=recn_vbwfn
      savvbci=recn_jobiph

      if(inputmode.eq.2)then
        do 100 i=1,mxstsy_ci
        iorcore_d(i)=-1
        iorclos_d(i)=-1
        iorocc_d(i)=-1
100     continue
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Index_NoSym(iCntr,iCmp,iCnt,iAng,iR,cIndex,iBas,nBas)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: Index_NoSym
integer(kind=iwp), intent(in) :: iCntr, iCmp, iCnt, iAng, iR, nBas
integer(kind=iwp), intent(inout) :: cIndex(5,nBas), iBas
integer(kind=iwp) :: i

outer: do
  Index_NoSym = 0
  do i=1,iBas
    if ((cIndex(1,i) == iCntr) .and. (cIndex(2,i) == iCmp) .and. (cIndex(3,i) == iCnt) .and. (cIndex(4,i) == iAng) .and. &
        (cIndex(5,i) == iR)) then
      Index_NoSym = i
      exit outer
    end if
  end do

  iBas = iBas+1
  cIndex(1,iBas) = iCntr
  cIndex(2,iBas) = iCmp
  cIndex(3,iBas) = iCnt
  cIndex(4,iBas) = iAng
  cIndex(5,iBas) = iR
end do outer

end function Index_NoSym

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010-2012, Thomas Bondo Pedersen                       *
************************************************************************
      Subroutine LDF_CheckPairIntegrals(Mode,iAtomPair,l_C,C,irc)
C
C     Thomas Bondo Pedersen, March 2011.
C
C     Purpose: check fitting coefficients by comparing exact and
C              approximate integrals for atom pair iAtomPair.
C
      Integer Mode
      Integer iAtomPair
      Integer l_C
      Real*8  C(l_C)
      Integer irc
#include "localdf.fh"
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*22 SecNam
      Parameter (SecNam='LDF_CheckPairIntegrals')

      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_nBasAux_Pair

      Integer iAtom, jAtom
      Integer nBas_iAtom, nBas_jAtom
      Integer nShell_iAtom, nShell_jAtom
      Integer M

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)
      nBas_iAtom=LDF_nBas_Atom(iAtom)
      nBas_jAtom=LDF_nBas_Atom(jAtom)
      nShell_iAtom=LDF_nShell_Atom(iAtom)
      nShell_jAtom=LDF_nShell_Atom(jAtom)
      M=LDF_nBasAux_Pair(iAtomPair)
      Call Cho_Head(SecNam//': Integral Check','-',80,6)
      Write(6,'(A,I9)')
     & 'Atom Pair..............................',iAtomPair
      Write(6,'(A,2I9)')
     & 'Atoms..................................',iAtom,jAtom
      Write(6,'(A,2I9)')
     & 'Number of basis functions..............',nBas_iAtom,nBas_jAtom
      Write(6,'(A,2I9)')
     & 'Number of shells.......................',
     & nShell_iAtom,nShell_jAtom
      Write(6,'(A,I9)')
     & 'Number of auxiliary functions..........',M
      Write(6,'(A,1P,D15.6)')
     & 'Target accuracy........................',Thr_Accuracy
      Call xFlush(6)
      If (Mode.eq.1) Then
         Call LDF_CheckPairIntegrals_Robust(iAtomPair,l_C,C,irc)
         If (irc.ne.0) Then
            If (irc.eq.1) Then
               Write(6,'(A)')
     &         '(Delta(AB)|Delta(AB)) matrix not symmetric'
            Else If (irc.eq.2) Then
               Write(6,'(A)')
     &         '(Delta(AB)|Delta(AB)) matrix not positive semidefinite'
            Else If (irc.eq.3) Then
               Write(6,'(A)')
     &         '(Delta(AB)|Delta(AB)) matrix diagonal not consistent'
            Else
               Write(6,'(A,A,I10,A)')
     &         'Non-zero return code from ',
     &         'LDF_CheckPairIntegrals_Robust:',irc,' (unkown)'
            End If
         End If
      Else If (Mode.eq.2) Then
         Call LDF_CheckPairIntegrals_Nonrobust(iAtomPair,l_C,C,irc)
      Else If (Mode.eq.3) Then
         Call LDF_CheckPairIntegrals_HlfNHlf(iAtomPair,l_C,C,irc)
      Else
         Call WarningMessage(2,SecNam//': illegal Mode')
         Call LDF_Quit(1)
      End If
      If (irc.eq.0) Then
         Write(6,'(A,A,I10)')
     &   SecNam,': pair integrals all right for atom pair',iAtomPair
         Call xFlush(6)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CheckPairIntegrals_Robust(AB,l_C,C,irc)
C
C     Thomas Bondo Pedersen, March 2011.
C
C     Purpose: check fitting coefficients by comparing exact and
C     approximate integrals for atom pair iAtomPair.
C
C     Checks:
C     1) Symmetry: irc=1 is returned if the diff ints are not symmetric.
C     2) Diagonal: irc=2 is returned if the diagonal diff ints are not
C                  equal to the updated diagonal.
C     3) Accuracy: if 2C functions are included and the max diagonal is
C                  greater than the target accuracy, irc=3 is returned.
C                  Exception: if this is constrained LDF, irc=0 is
C                  returned and a warning is printed.
C     4) PSD: irc=4 is returned if the diff ints do not constitute a
C             positive semidefinite matrix (which implies that the
C             Cauchy-Schwarz inequality is fulfilled).
C
C     Note: this is a debug code and has not been written with
C     efficiency in mind!
C
C     Note: this routine uses the robust integral representation.
C
      Implicit None
      Integer AB
      Integer l_C
      Real*8  C(l_C)
      Integer irc
#include "localdf.fh"
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*29 SecNam
      Parameter (SecNam='LDF_CheckPairIntegrals_Robust')

      Logical  isSymmetric
      External isSymmetric

      Integer  LDF_AtomPair_DiagDim, LDF_nBasAux_Pair
      External LDF_AtomPair_DiagDim, LDF_nBasAux_Pair

      Real*8 Tol
      Parameter (Tol=1.0d-12)

      Integer nAB
      Integer M, Mm
      Integer ip_Int, l_Int
      Integer ip_3IndxInt, l_3IndxInt
      Integer ip_G, l_G
      Integer ip_D
      Integer kl
      Integer n
      Integer ip_Vec, l_Vec
      Integer nAcc

      Real*8 D_max

      ! Init return code
      irc=0

      ! Get and check dimensions
      nAB=LDF_AtomPair_DiagDim(AB)
      M=LDF_nBasAux_Pair(AB)
      Mm=max(M,1)
      If (l_C.lt.(nAB*M)) Then
         Call WarningMessage(2,SecNam//': insufficient array dimension')
         Call LDF_Quit(1)
      End If

      ! Exit with proper return code if nothing to do
      If (M.lt.1) Then
         If (nAB.lt.1) Then
            irc=0
            Return
         End If
      Else
         If (nAB.lt.1) Then
            irc=-1
            Return
         End If
      End If

      ! Allocate and compute exact integrals (uv|kl)
      l_Int=nAB**2
      Call GetMem('CPII','Allo','Real',ip_Int,l_Int)
      Call LDF_ComputeValenceIntegrals(AB,AB,l_Int,Work(ip_Int))

      ! Check symmetry
      If (.not.isSymmetric(Work(ip_Int),nAB,Tol)) Then
         Call WarningMessage(2,
     &        SecNam//': (AB|AB) integrals not symmetric')
         Write(6,'(A,1P,D20.10)') 'Tolerance=',Tol
         Call LDF_Quit(1)
      End If

      ! Set indices for G matrix calculation
      Call LDF_SetIndxG(AB)

      ! Allocate and compute 3 index integrals (uv|J)
      l_3IndxInt=nAB*Mm
      Call GetMem('CPI3I','Allo','Real',ip_3IndxInt,l_3IndxInt)
      Call LDF_ComputeIntegrals_uvJ(AB,l_3IndxInt,Work(ip_3IndxInt))

      ! Allocate and compute G matrix (J|K)
      l_G=M**2
      Call GetMem('CPIG','Allo','Real',ip_G,l_G)
      Call LDF_ComputeGMat(AB,M,Work(ip_G))

      ! (uv|kl) := - sum_K (uv|K)*C(kl,K) + (uv|kl)
      Call dGeMM_('N','T',nAB,nAB,M,
     &            -1.0d0,Work(ip_3IndxInt),nAB,C,nAB,
     &            1.0d0,Work(ip_Int),nAB)

      ! (kl|J) := sum_K C(kl,K)*(K|J) - (kl|J)
      Call dGeMM_('N','N',nAB,M,M,
     &            1.0d0,C,nAB,Work(ip_G),Mm,
     &            -1.0d0,Work(ip_3IndxInt),nAB)

      ! (uv|kl) = sum_J C(uv,J)*(kl|J) + (uv|kl)
      Call dGeMM_('N','T',nAB,nAB,M,
     &            1.0d0,C,nAB,Work(ip_3IndxInt),nAB,
     &            1.0d0,Work(ip_Int),nAB)

      ! Deallocation
      Call GetMem('CPIG','Free','Real',ip_G,l_G)
      Call GetMem('CPI3I','Free','Real',ip_3IndxInt,l_3IndxInt)
      Call LDF_UnsetIndxG()

      ! Check 1) Symmetry
      If (irc.eq.0) Then
         If (.not.isSymmetric(Work(ip_Int),nAB,Tol)) Then
            Call WarningMessage(2,
     &        SecNam//': (Delta(AB)|Delta(AB)) integrals not symmetric')
            Write(6,'(A,1P,D20.10)') 'Tolerance=',Tol
            irc=1
         End If
      End If

      ! Check 2) Diagonal
      If (irc.eq.0) Then
         ip_D=iWork(ip_AP_Diag-1+AB)
         n=nAB+1
         kl=0
         Do While (kl.lt.nAB .and. irc.eq.0)
            If (abs(Work(ip_D+kl)-Work(ip_Int+n*kl)).gt.Tol) Then
               Call WarningMessage(2,
     &          SecNam//': (Delta(AB)|Delta(AB)) diagonal inconsistent')
               Write(6,'(A,1P,D20.10)') 'Tolerance=',Tol
               irc=2
            End If
            kl=kl+1
         End Do
      End If

      ! Check 3) Accuracy
      If (irc.eq.0) Then
         If (LDF2) Then
            D_max=0.0d0
            nAcc=0
            n=nAB+1
            Do kl=0,nAB-1
               If (Work(ip_Int+n*kl).gt.Thr_Accuracy) Then
                  nAcc=nAcc+1
                  D_max=max(D_max,Work(ip_Int+n*kl))
               End If
            End Do
            If (nAcc.ne.0) Then
               Call WarningMessage(2,
     &                   SecNam//': error greater than target accuracy')
               Write(6,'(A,1P,D20.10)') 'Max diagonal:',D_max
               If (LDF_Constraint.eq.-1) Then ! unconstrained LDF
                  irc=3
               End If
            End If
         End If
      End If

      ! Check 4) PSD
      If (irc.eq.0) Then
         l_Vec=nAB**2
         Call GetMem('CPIV','Allo','Real',ip_Vec,l_Vec)
         Call CD_InCore(Work(ip_Int),nAB,Work(ip_Vec),nAB,n,Tol,irc)
         Call GetMem('CPIV','Free','Real',ip_Vec,l_Vec)
         If (irc.ne.0) Then
            Call WarningMessage(2,
     &              SecNam//': (Delta(AB)|Delta(AB)) integrals not PSD')
            Write(6,'(A,1P,D20.10)') 'Tolerance=',Tol
            irc=4
         End If
      End If

      ! Deallocation
      Call GetMem('CPII','Free','Real',ip_Int,l_Int)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CheckPairIntegrals_Nonrobust(iAtomPair,l_C,C,irc)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: Check fitting coefficients by comparing exact and
C     approximate integrals for atom pair iAtomPair. A report is
C     printed on Cauchy-Schwarz (C-S) violations of the residual matrix.
C     If all integrals are represented with an accuracy better than (or
C     equal to) the max diagonal, irc=0 on exit; else, irc=1.
C     If 2-center functions are included, all errors must be below or
C     equal to the target accuracy. If not, irc=1 is returned.
C
C     Note: this is a debug code and has not been written with
C     efficiency in mind!
C
C     Note: this routine uses the non-robust integral representation.
C
      Implicit None
      Integer iAtomPair
      Integer l_C
      Real*8  C(l_C)
      Integer irc
#include "WrkSpc.fh"
#include "localdf.fh"
#include "localdf_mem.fh"
#include "localdf_int.fh"
#include "localdf_bas.fh"
#include "localdf_print.fh"
#include "ldf_atom_pair_info.fh"

      Real*8 Small
      Parameter (Small=1.0d-3)

      Integer ThrPrint
      Parameter (ThrPrint=5)

      Character*32 SecNam
      Parameter (SecNam='LDF_CheckPairIntegrals_Nonrobust')

      External Int_LDF_SQ

      Integer  LDF_nBas_Atom
      Integer  LDF_nShell_Atom, LDF_lShell_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom, LDF_nBasAux_Pair

      Real*8 tC0, tC1, tW0, tW1
      Real*8 Err_max, Err_min, Err_amx, Err_amn, Err_ave, Err_aav
      Real*8 Dij, Dkl, Dijkl, Dmax
      Real*8 CSDevMax, CSDev

      Integer M, Mm
      Integer ip_G, l_G
      Integer iAtom, jAtom
      Integer nBas_iAtom, nBas_jAtom, nB2
      Integer ip_Int, l_Int
      Integer ip_V, l_V
      Integer ip_C_, l_C_
      Integer nShell_iAtom, nShell_jAtom
      Integer ipi, ipj
      Integer iS, jS, iShell, jShell
      Integer kS, lS, kShell, lShell
      Integer iS1, kS1, ijS, klS
      Integer maxSP
      Integer ip_SPB, l_SPB, n
      Integer ip_SPD, l_SPD
      Integer k, l
      Integer nij, nkl
      Integer nErr_CS, nAcc_CS
      Integer ip_D
      Integer ipInt
      Integer ip_SewWrk, l_SewWrk

      Logical WriteFirstLine

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer SPB
      Integer SPD
      Integer iTri
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      SPB(i,j)=iWork(ip_SPB-1+nShell_iAtom*(j-1)+i)
      SPD(i,j)=iWork(ip_SPD-1+nShell_iAtom*(j-1)+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      Call CWTime(tC0,tW0)
      WriteFirstLine=iPrint.ge.ThrPrint

      ! Init return code
      irc=0

      ! Get number of auxiliary functions
      M=LDF_nBasAux_Pair(iAtomPair)
      Mm=max(M,1)

      ! Get atoms
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)

      ! Get number of basis functions on each atom
      nBas_iAtom=LDF_nBas_Atom(iAtom)
      nBas_jAtom=LDF_nBas_Atom(jAtom)
      nB2=nBas_iAtom*nBas_jAtom

      If (l_C.lt.nB2*M) Then
         Call WarningMessage(2,SecNam//': l_C<nB2*M')
         Call LDF_Quit(1)
      End If

      ! Exit with proper return code if nothing to do
      If (M.lt.1) Then
         If (nB2.lt.1) Then
            irc=0
            Return
         End If
      Else
         If (nB2.lt.1) Then
            irc=1
            Return
         End If
      End If

      ! Get number of shells on each atom
      nShell_iAtom=LDF_nShell_Atom(iAtom)
      nShell_jAtom=LDF_nShell_Atom(jAtom)

      ! Get pointer to diagonal for this atom pair
      ip_D=iWork(ip_AP_Diag-1+iAtomPair)-1

      ! Allocate and compute G matrix
      ! G[JK]=(J|K)
      l_G=Mm**2
      Call GetMem('ChkG','Allo','Real',ip_G,l_G)
      Call LDF_SetIndxG(iAtomPair)
      Call LDF_ComputeGMat(iAtomPair,M,Work(ip_G))
      Call LDF_UnsetIndxG()

      ! Get pointers to atomic shell lists
      ipi=LDF_lShell_Atom(iAtom)-1
      ipj=LDF_lShell_Atom(jAtom)-1

      ! Find largest shell pair
      maxSP=0
      Do jS=1,nShell_jAtom
         jShell=iWork(ipj+jS)
         Do iS=1,nShell_iAtom
            iShell=iWork(ipi+iS)
            maxSP=max(maxSP,nBasSh(iShell)*nBasSh(jShell))
         End Do
      End Do

      ! Allocate memory for integrals corresponding to largest shell
      ! pair
      l_Int=maxSP**2
      Call GetMem('ChkInt','Allo','Real',ip_Int,l_Int)

      ! Allocate tmp arrays to store shell pair blocks of C
      l_C_=maxSP*Mm
      Call GetMem('ChkC','Allo','Real',ip_C_,l_C_)

      ! Allocate V array to store intermediate
      ! V[J,kl]=sum_K (J|K)*C[kl,K]
      l_V=Mm*maxSP
      Call GetMem('ChkV','Allo','Real',ip_V,l_V)

      ! Allocate and set up offset array to shell pair blocks in C
      l_SPB=nShell_iAtom*nShell_jAtom
      Call GetMem('ChkSPB','Allo','Inte',ip_SPB,l_SPB)
      n=0
      Do jS=1,nShell_jAtom
         jShell=iWork(ipj+jS)
         Do iS=1,nShell_iAtom
            iWork(ip_SPB-1+nShell_iAtom*(jS-1)+iS)=n
            iShell=iWork(ipi+iS)
            n=n+nBasSh(iShell)*nBasSh(jShell)
         End Do
      End Do

      ! Allocate and set up offset array to shell pair blocks in
      ! diagonal
      l_SPD=nShell_iAtom*nShell_jAtom
      Call GetMem('ChkSPD','Allo','Inte',ip_SPD,l_SPD)
      n=0
      If (iAtom.eq.jAtom) Then
         Do iS=1,nShell_iAtom
            iShell=iWork(ipi+iS)
            Do jS=1,iS-1
               iWork(ip_SPD-1+nShell_iAtom*(jS-1)+iS)=n
               iWork(ip_SPD-1+nShell_iAtom*(iS-1)+jS)=n
               jShell=iWork(ipi+jS)
               n=n+nBasSh(iShell)*nBasSh(jShell)
            End Do
            iWork(ip_SPD-1+nShell_iAtom*(iS-1)+iS)=n
            n=n+nBasSh(iShell)*(nBasSh(iShell)+1)/2
         End Do
      Else If (iAtom.gt.jAtom) Then
         Call iCopy(nShell_iAtom*nShell_jAtom,iWork(ip_SPB),1,
     &                                        iWork(ip_SPD),1)
      Else
         Call WarningMessage(2,SecNam//': iAtom<jAtom')
         Call LDF_Quit(1)
      End If

      ! Allocate memory for seward
      Call GetMem('MaxMem','Max ','Real',ip_SewWrk,l_SewWrk)
      l_SewWrk = min(l_SewWrk,MaxLDFSew)
      Call xSetMem_Ints(l_SewWrk)

      ! Compare integrals one shell quadruple at a time
      nErr_CS=0
      nAcc_CS=0
      Err_max=-9.9d9
      Err_min=9.9d9
      Err_amx=-9.9d9
      Err_amn=9.9d9
      Err_ave=0.0d0
      Err_aav=0.0d0
      Dmax=-9.9d9
      CSDevMax=0.0d0
      n=0
      Do lS=1,nShell_jAtom
         lShell=iWork(ipj+lS)
         If (iAtom.eq.jAtom) Then
            kS1=lS
         Else
            kS1=1
         End If
         Do kS=kS1,nShell_iAtom
            kShell=iWork(ipi+kS)
            klS=iTri(kShell,lShell)
            nkl=nBasSh(kShell)*nBasSh(lShell)
            Do K=0,M-1
               Call dCopy_(nkl,C(nB2*K+SPB(kS,lS)+1),1,
     &                        Work(ip_C_+nkl*K),1)
            End Do
            Call dGeMM_('N','T',M,nkl,M,
     &                  1.0d0,Work(ip_G),Mm,Work(ip_C_),nkl,
     &                  0.0d0,Work(ip_V),Mm)
            Do jS=1,nShell_jAtom
               jShell=iWork(ipj+jS)
               If (iAtom.eq.jAtom) Then
                  iS1=jS
               Else
                  iS1=1
               End If
               Do iS=iS1,nShell_iAtom
                  iShell=iWork(ipi+iS)
                  ijS=iTri(iShell,kShell)
                  If (ijS.ge.klS) Then
                     nij=nBasSh(iShell)*nBasSh(jShell)
                     Do K=0,M-1
                        Call dCopy_(nij,C(nB2*K+SPB(iS,jS)+1),1,
     &                                 Work(ip_C_+nij*K),1)
                     End Do
                     SHA=iShell
                     SHB=jShell
                     SHC=kShell
                     SHD=lShell
                     Call FZero(Work(ip_Int),nij*nkl)
                     Call Eval_IJKL(iShell,jShell,kShell,lShell,
     &                              Work(ip_Int),l_Int,
     &                              Int_LDF_SQ)
                     Call dGeMM_('N','N',nij,nkl,M,
     &                           -1.0d0,Work(ip_C_),nij,Work(ip_V),Mm,
     &                           1.0d0,Work(ip_Int),nij)
                     ipInt=ip_Int-1
                     Do l=1,nBasSh(lShell)
                        Do k=1,nBasSh(kShell)
                           If (iAtom.eq.jAtom) Then
                              Dkl=Work(ip_D+SPD(kS,lS)+iTri(k,l))
                           Else
                              Dkl=Work(ip_D+SPD(kS,lS)
     &                                 +nBasSh(kShell)*(l-1)+k)
                           End If
                           Dmax=max(Dmax,Dkl)
                           Do j=1,nBasSh(jShell)
                              Do i=1,nBasSh(iShell)
                                 If (iAtom.eq.jAtom) Then
                                    Dij=Work(ip_D+SPD(iS,jS)+iTri(i,j))
                                 Else
                                    Dij=Work(ip_D+SPD(iS,jS)
     &                                       +nBasSh(iShell)*(j-1)+i)
                                 End If
                                 Dijkl=max(sqrt(Dij*Dkl),1.0d-14)
                                 ipInt=ipInt+1
                                 CSDev=abs(Work(ipInt))-Dijkl
                                 CSDevMax=max(CSDevMax,CSDev)
                                 If (abs(Work(ipInt)).gt.Dijkl) Then
                                    If (WriteFirstLine) Then
                                       Write(6,'(A,A)')
     &                                 'Cauchy-Schwarz check [shells,',
     &                                 'indices,error,CS upper bound]:'
                                       WriteFirstLine=.False.
                                    End If
                                    nErr_CS=nErr_CS+1
                                    If (abs(CSDev).gt.Small) Then
                                       If (iPrint.ge.ThrPrint) Then
                                          Write(6,'(8I8,1P,2D21.12)')
     &                                    iS,jS,kS,lS,i,j,k,l,
     &                                    Work(ipInt),Dijkl
                                       End If
                                    Else
                                       nAcc_CS=nAcc_CS+1
                                       If (iPrint.ge.ThrPrint) Then
                                          Write(6,'(8I8,1P,2D21.12,A)')
     &                                    iS,jS,kS,lS,i,j,k,l,
     &                                   Work(ipInt),Dijkl,' (accepted)'
                                       End If
                                    End If
                                 End If
                                 Err_max=max(Err_max,Work(ipInt))
                                 Err_min=min(Err_min,Work(ipInt))
                                 Err_amx=max(Err_amx,abs(Work(ipInt)))
                                 Err_amn=min(Err_amn,abs(Work(ipInt)))
                                 Err_ave=Err_ave+Work(ipInt)
                                 Err_aav=Err_aav+abs(Work(ipInt))
                              End Do
                           End Do
                        End Do
                     End Do
                     n=n+nij*nkl
                  End If
               End Do
            End Do
         End Do
      End Do
      If (n.eq.0) Then
         Call WarningMessage(2,SecNam//': n=0 (division by zero)')
         Call LDF_Quit(1)
      End If
      Err_ave=Err_ave/dble(n)
      Err_aav=Err_aav/dble(n)
      Write(6,'(A,1P,2D15.6)')
     & 'Max and Min Error......................',Err_max,Err_min
      Write(6,'(A,1P,2D15.6)')
     & 'Max and Min Abs Error..................',Err_amx,Err_amn
      Write(6,'(A,1P,2D15.6)')
     & 'Average and Average Abs Error..........',Err_ave,Err_aav
      Write(6,'(A,1P,D15.6)')
     & 'Max Cauchy-Schwarz deviation...........',CSDevMax
      Write(6,'(A,I9)')
     & 'Number of integrals checked............',n
      Write(6,'(A,I9)')
     & 'Number of Cauchy-Schwarz violations....',nErr_CS
      Write(6,'(A,I9)')
     & 'Number of acceptable C-S violations....',nAcc_CS
      nErr_CS=nErr_CS-nAcc_CS ! unacceptable C-S violations
      Write(6,'(A,I9,A,1P,D15.6,A)')
     & 'Number of unacceptable C-S violations..',nErr_CS,
     & ' (deviation >',Small,')'
      If (Err_amx.gt.Dmax .and. abs(Err_amx-Dmax).gt.Small) Then
         Write(6,'(A,1P,D15.6,A,A,D15.6,A)')
     &   'Max abs error deviates from max diagonal (',Dmax,') by',
     &   ' more than ',Small,' => not accepted!'
         irc=1
      Else
         If (nErr_CS.gt.0) Then
            Write(6,'(A,1P,D15.6,A,A,D15.6,A)')
     &      'Max abs error deviates from max diagonal (',Dmax,') by',
     &      ' less than ',Small,' => accepted!'
         End If
         irc=0
      End If
      If (LDF2) Then
         If (Err_amx.gt.Thr_Accuracy .and.
     &       abs(Err_amx-Thr_Accuracy).gt.Small) Then
            Write(6,'(A,1P,D15.6,A,A,D15.6,A)')
     &      'Max abs error deviates from target accuracy (',
     &      Thr_Accuracy,') by',
     &      ' more than ',Small,' => not accepted!'
            irc=1
         End If
      End If
      Call xFlush(6)

      ! Deallocate seward memory
      Call xRlsMem_Ints()

      ! Deallocate offset array to shell pair blocks in
      ! diagonal
      Call GetMem('ChkSPD','Free','Inte',ip_SPD,l_SPD)

      ! Deallocate offset array to shell pair blocks in C
      Call GetMem('ChkSPB','Free','Inte',ip_SPB,l_SPB)

      ! Deallocate V array
      Call GetMem('ChkV','Free','Real',ip_V,l_V)

      ! Deallocate C array
      Call GetMem('ChkC','Free','Real',ip_C_,l_C_)

      ! Deallocate integral array
      Call GetMem('ChkInt','Free','Real',ip_Int,l_Int)

      ! Deallocate G matrix
      Call GetMem('ChkG','Free','Real',ip_G,l_G)

      ! Print timing
      Call CWTime(tC1,tW1)
      Write(6,'(A,2(1X,F12.2),A)')
     & 'CPU and wall time for integral check:',
     & tC1-tC0,tW1-tW0,' seconds'

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CheckPairIntegrals_HlfNHlf(AB,l_C,C,irc)
C
C     Thomas Bondo Pedersen, January 2012.
C     - based on LDF_CheckPairIntegrals_Robust
C
C     Purpose: check fitting coefficients by comparing exact and
C     approximate integrals for atom pair iAtomPair.
C
C     Checks:
C     1) Symmetry: irc=1 is returned if the diff ints are not symmetric.
C     2) Diagonal: irc=2 is returned if the diagonal diff ints are not
C                  equal to the updated diagonal.
C     3) Accuracy: if 2C functions are included and the max diagonal is
C                  greater than the target accuracy, irc=3 is returned.
C                  Exception: if this is constrained LDF, irc=0 is
C                  returned and a warning is printed.
C     4) PSD: irc=4 is returned if the diff ints do not constitute a
C             positive semidefinite matrix (which implies that the
C             Cauchy-Schwarz inequality is fulfilled).
C
C     Note: this is a debug code and has not been written with
C     efficiency in mind!
C
C     Note: this routine uses the half-and-half integral representation.
C
      Implicit None
      Integer AB
      Integer l_C
      Real*8  C(l_C)
      Integer irc
#include "localdf.fh"
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*30 SecNam
      Parameter (SecNam='LDF_CheckPairIntegrals_HlfNHlf')

      Logical  isSymmetric
      External isSymmetric

      Integer  LDF_AtomPair_DiagDim, LDF_nBasAux_Pair
      External LDF_AtomPair_DiagDim, LDF_nBasAux_Pair

      Real*8 Tol
      Parameter (Tol=1.0d-12)

      Integer nAB
      Integer M, Mm
      Integer ip_Int, l_Int
      Integer ip_3IndxInt, l_3IndxInt
      Integer ip_D
      Integer kl
      Integer n
      Integer ip_Vec, l_Vec
      Integer nAcc

      Real*8 D_max

      ! Init return code
      irc=0

      ! Get and check dimensions
      nAB=LDF_AtomPair_DiagDim(AB)
      M=LDF_nBasAux_Pair(AB)
      Mm=max(M,1)
      If (l_C.lt.(nAB*M)) Then
         Call WarningMessage(2,SecNam//': insufficient array dimension')
         Call LDF_Quit(1)
      End If

      ! Exit with proper return code if nothing to do
      If (M.lt.1) Then
         If (nAB.lt.1) Then
            irc=0
            Return
         End If
      Else
         If (nAB.lt.1) Then
            irc=-1
            Return
         End If
      End If

      ! Allocate and compute exact integrals (uv|kl)
      l_Int=nAB**2
      Call GetMem('CPII','Allo','Real',ip_Int,l_Int)
      Call LDF_ComputeValenceIntegrals(AB,AB,l_Int,Work(ip_Int))

      ! Check symmetry
      If (.not.isSymmetric(Work(ip_Int),nAB,Tol)) Then
         Call WarningMessage(2,
     &        SecNam//': (AB|AB) integrals not symmetric')
         Write(6,'(A,1P,D20.10)') 'Tolerance=',Tol
         Call LDF_Quit(1)
      End If

      ! Set indices for G matrix calculation
      Call LDF_SetIndxG(AB)

      ! Allocate and compute 3 index integrals (uv|J)
      l_3IndxInt=nAB*Mm
      Call GetMem('CPI3I','Allo','Real',ip_3IndxInt,l_3IndxInt)
      Call LDF_ComputeIntegrals_uvJ(AB,l_3IndxInt,Work(ip_3IndxInt))

      ! (uv|kl) := -1/2*sum_K (uv|K)*C(kl,K) + (uv|kl)
      Call dGeMM_('N','T',nAB,nAB,M,
     &            -0.5d0,Work(ip_3IndxInt),nAB,C,nAB,
     &            1.0d0,Work(ip_Int),nAB)

      ! (uv|kl) := -1/2*sum_J C(uv,J)*(kl|J) + (uv|kl)
      Call dGeMM_('N','T',nAB,nAB,M,
     &            -0.5d0,C,nAB,Work(ip_3IndxInt),nAB,
     &            1.0d0,Work(ip_Int),nAB)

      ! Deallocation
      Call GetMem('CPI3I','Free','Real',ip_3IndxInt,l_3IndxInt)
      Call LDF_UnsetIndxG()

      ! Check 1) Symmetry
      If (irc.eq.0) Then
         If (.not.isSymmetric(Work(ip_Int),nAB,Tol)) Then
            Call WarningMessage(2,
     &        SecNam//': (Delta(AB)|Delta(AB)) integrals not symmetric')
            Write(6,'(A,1P,D20.10)') 'Tolerance=',Tol
            irc=1
         End If
      End If

      ! Check 2) Diagonal
      If (irc.eq.0) Then
         ip_D=iWork(ip_AP_Diag-1+AB)
         n=nAB+1
         kl=0
         Do While (kl.lt.nAB .and. irc.eq.0)
            If (abs(Work(ip_D+kl)-Work(ip_Int+n*kl)).gt.Tol) Then
               Call WarningMessage(2,
     &          SecNam//': (Delta(AB)|Delta(AB)) diagonal inconsistent')
               Write(6,'(A,1P,D20.10)') 'Tolerance=',Tol
               irc=2
            End If
            kl=kl+1
         End Do
      End If

      ! Check 3) Accuracy
      If (irc.eq.0) Then
         If (LDF2) Then
            D_max=0.0d0
            nAcc=0
            n=nAB+1
            Do kl=0,nAB-1
               If (Work(ip_Int+n*kl).gt.Thr_Accuracy) Then
                  nAcc=nAcc+1
                  D_max=max(D_max,Work(ip_Int+n*kl))
               End If
            End Do
            If (nAcc.ne.0) Then
               Call WarningMessage(2,
     &                   SecNam//': error greater than target accuracy')
               Write(6,'(A,1P,D20.10)') 'Max diagonal:',D_max
               If (LDF_Constraint.eq.-1) Then ! unconstrained LDF
                  irc=3
               End If
            End If
         End If
      End If

      ! Check 4) PSD
      If (irc.eq.0) Then
         l_Vec=nAB**2
         Call GetMem('CPIV','Allo','Real',ip_Vec,l_Vec)
         Call CD_InCore(Work(ip_Int),nAB,Work(ip_Vec),nAB,n,Tol,irc)
         Call GetMem('CPIV','Free','Real',ip_Vec,l_Vec)
         If (irc.ne.0) Then
            Call WarningMessage(2,
     &              SecNam//': (Delta(AB)|Delta(AB)) integrals not PSD')
            Write(6,'(A,1P,D20.10)') 'Tolerance=',Tol
            irc=4
         End If
      End If

      ! Deallocation
      Call GetMem('CPII','Free','Real',ip_Int,l_Int)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WeGotThis(nAt,nB,ipMP,ipC,nij,EC,iANr,ipT,ipTi,lMax
     &                    ,iTP,iPrint,Pot_Expo,Pot_Point,Pot_Fac,Diffed)
      Implicit real*8 (a-h,o-z)

#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "warnings.fh"

      Dimension EC(3,nij),Pot_Expo(nij*2),Pot_Point(nij),Pot_Fac(nij*4)
      Dimension iANr(nAt)
      Dimension Expo(4),dMullig((lMax*(lMax**2+6*lMax+11)+6)/6)

      Logical Diffed(nij*2)
      Logical Que,D1,D2
      Logical Found
      Real*8, Allocatable:: D1ao(:)

      Character*10 DistType(2),OneFile,Label

      Data DistType/'Monopole  ','Dipole    '/

*
*-- Print exponents and factors.
*
      Write(6,*)
      Write(6,'(A)')' *************************************************'
     &//'*********************************'
      Write(6,'(A)')' *                                                '
     &//'                                *'
      Write(6,'(A)')' *                  Result for the Diffuse Distrib'
     &//'ution                           *'
      Write(6,'(A)')' *                                                '
     &//'                                *'
      Write(6,'(A)')' *************************************************'
     &//'*********************************'
      Write(6,*)
      Write(6,401)'Centre','Coordinate','Multipole','Factor'
     &           ,'Exponent','Point-charge'
      Write(6,402)'|--------------------------------------------------'
     &          //'-----------------------------------------------|'
      kauntA=0
      Do iA=1,nAt
        Do jA=1,iA
          kauntA=kauntA+1
          Do iDC=1,2
            PP=-1.0d0
            If(iDC.eq.1)PP=Pot_Point(kauntA)
            If(Diffed(2*(kauntA-1)+iDC)) then
              If(iDC.eq.1) then
                Write(6,403)kauntA,(EC(k,kauntA),k=1,3),DistType(iDC)
     &                     ,Pot_Fac(4*(kauntA-1)+iDC)
     &                     ,2.0d0*Pot_Expo(2*(kauntA-1)+iDC),PP
              ElseIf(iDC.eq.2) then
                Write(6,404)kauntA,(EC(k,kauntA),k=1,3),DistType(iDC)
     &                     ,(Pot_Fac(4*(kauntA-1)+iDC+k),k=0,2)
     &                     ,2.0d0*Pot_Expo(2*(kauntA-1)+iDC)
              Endif
            Else
              If(iDC.eq.1) then
                Write(6,405)kauntA,(EC(k,kauntA),k=1,3),DistType(iDC)
     &                     ,Pot_Fac(4*(kauntA-1)+iDC),'Point(inf)',PP
              ElseIf(iDC.eq.2) then
                Write(6,406)kauntA,(EC(k,kauntA),k=1,3),DistType(iDC)
     &                     ,(Pot_Fac(4*(kauntA-1)+iDC+k),k=0,2)
     &                     ,'Point(inf)'
              Endif
            Endif
          Enddo
        Enddo
      Enddo
401   Format(' ',A,'     ',A,'             ',A,'             ',A
     &      ,'          ',A,'     ',A)
402   Format(A)
403   Format(' ',I3,' (',2(F7.3,','),F7.3,')      ',A,'          '
     &                            ,F7.3,'          ',F7.3,'      ',F7.3)
404   Format(' ',I3,' (',2(F7.3,','),F7.3,')      ',A,
     &              ' (',2(F7.3,','),F7.3,') ',F7.3)
405   Format(' ',I3,' (',2(F7.3,','),F7.3,')      ',A,'          '
     &                            ,F7.3,'            ',A,'      ',F7.3)
406   Format(' ',I3,' (',2(F7.3,','),F7.3,')      ',A,
     &              ' (',2(F7.3,','),F7.3,')   ',A)

*
*-- If the extra ONEINT-file exist, then do an error analysis.
*
      Que=.false.
      Call F_Inquire('ONEINTP',Que)
      If(Que) then
        Write(6,*)
        Write(6,'(A)')' Found Test-grid for error analysis.'
        Write(6,*)
        ErrAv1=0.0d0
        ErrAv2=0.0d0
        ErrDe1=0.0d0
        ErrDe2=0.0d0
        ErrVar1=0.0d0
        ErrVar2=0.0d0
        ErrMax1=0.0d0
        ErrMax2=0.0d0
        ErrCorr=0.0d0
        nImprove=0
        nShitty=0
        DeNom=0.0d0
        Write(OneFile,'(A)')'ONEINTP'
        Call Diff_Aux1(nEPP,ipEPCo,nB,OneFile)
        Call Qpg_dArray('D1ao',Found,nDens)
        If (Found .and. nDens/=0) Then
           Call mma_allocate(D1ao,nDens,Label='D1ao')
        Else
           Write (6,*) 'WeGotThis: do not think so!'
           Call Abend()
        End If
        Call Get_D1ao(D1ao,nDens)
        Call GetMem('ElPot','Allo','Real',iElP,nDens+4)
        If(iPrint.ge.2) then
          Write(6,*)
          Write(6,'(A)')' Electric Potential'
          Write(6,'(A)')'  Reference   Approximate MP-expanded'
        Endif
*
*---- Loop over all points where the electric potential has
*     been sampled.
*
        Do iPP=1,nEPP
*
*---- First, get the true electric potential, the reference.
*
          Write(Label,'(A3,I5)')'EF0',iPP
          irc=-1
          iOpt=0
          iSmLbl=0
          iComp=1
          Call RdOne(irc,iOpt,Label,iComp,Work(iElP),iSmLbl)
          ElPot_REF=Work(iElP+nDens+3)
          ElPot_REF=ElPot_REF-Ddot_(nDens,D1ao,1,Work(iElP),1)
*
*---- Second, get the approximate electric potential and also the
*     completely multipole expanded potential.
*
          ElPot_APP=0.0d0
          ElPot_MP=0.0d0
          kauntA=0
*          rMin=1d10
          Do iA=1,nAt
            Do jA=1,iA
              kauntA=kauntA+1
              x=Work(ipEPCo+(iPP-1)*3+0)-EC(1,kauntA)
              y=Work(ipEPCo+(iPP-1)*3+1)-EC(2,kauntA)
              z=Work(ipEPCo+(iPP-1)*3+2)-EC(3,kauntA)
              r=sqrt(x**2+y**2+z**2)
              rinv=1.0d0/r
              D1=Diffed(2*(kauntA-1)+1)
              D2=Diffed(2*(kauntA-1)+2)
              Expo(1)=Pot_Expo(2*(kauntA-1)+1)
              Expo(2)=Pot_Expo(2*(kauntA-1)+2)
              chP=Pot_Point(kauntA)
              kaunt=0
*              rmin=min(r,rmin)
              Do l=0,lMax
                kComp=(l+1)*(l+2)/2
                Do k=1,kComp
                  kaunt=kaunt+1
                  dMullig(kaunt)=Work(ipMP+nij*(kaunt-1)+kauntA-1)
                Enddo
              Enddo
              ElPot_APP=ElPot_APP+ElPot(r,rinv,x,y,z,dMullig,lMax,Expo
     &                                 ,chP,D1,D2)
              ElPot_MP=ElPot_MP+ElPot(r,rinv,x,y,z,dMullig,lMax,Expo
     &                                 ,chP,.false.,.false.)
            Enddo
          Enddo
*          Write(6,*)'Minimum Dist:',rMin

*
*---- Print if requested.
*
          If(iPrint.ge.2) then
            Write(6,441)ElPot_REF,ElPot_APP,ElPot_MP
     &                 ,(Work(ipEPCo+(iPP-1)*3+k),k=0,2)
          Endif
*
*---- Third, accumulate to error analysis.
*
*------ The difference
          Dif1=ElPot_APP-ElPot_REF
          Dif2=ElPot_MP-ElPot_REF
*------ Accumulate to average error
          ErrAv1=ErrAv1+Dif1
          ErrAv2=ErrAv2+Dif2
*------ Accumulate to variance of error
          ErrVar1=ErrVar1+Dif1**2
          ErrVar2=ErrVar2+Dif2**2
*------ Accumulate to deviation
          ErrDe1=ErrDe1+abs(Dif1)
          ErrDe2=ErrDe2+abs(Dif2)
*------ Maximal error
          If(ErrMax1.lt.abs(Dif1))ErrMax1=abs(Dif1)
          If(ErrMax2.lt.abs(Dif2))ErrMax2=abs(Dif2)
*------ Accumulate to covariance of errors
          ErrCorr=ErrCorr+Dif1*Dif2
*------ Better or worse
          If(abs(Dif1).le.abs(Dif2))nImprove=nImprove+1
          If(abs(Dif2).lt.abs(Dif1))nShitty=nShitty+1
*------ Accumulate to denominator in relative error
          DeNom=DeNom+abs(ElPot_REF)
        Enddo
        ErrRe1=ErrDe1/DeNom
        ErrRe2=ErrDe2/DeNom
        ErrAv1=ErrAv1/dble(nEPP)
        ErrAv2=ErrAv2/dble(nEPP)
        ErrDe1=ErrDe1/dble(nEPP)
        ErrDe2=ErrDe2/dble(nEPP)
        ErrVar1=ErrVar1/dble(nEPP)
        ErrVar2=ErrVar2/dble(nEPP)
        ErrCorr=ErrCorr/dble(nEPP)
        CorrCoeff=(ErrCorr-ErrAv1*ErrAv2)
     &           /sqrt((ErrVar1-ErrAv1**2)*(ErrVar2-ErrAv2**2))
        PImp=100.0*dble(nImprove)/dble(nEPP)
        PShi=100.0*dble(nShitty)/dble(nEPP)
*
*---- Four, print the analysis.
*
        Write(6,*)
        Write(6,'(A)')'   Error Analysis'
        Write(6,'(A)')' |----------------------------------------------'
     &//'------|'
        Write(6,'(A)')'                                Diffuse    '
     &//' MP-expanded'
        Write(6,442)'  Average absolute error:      ',ErrAv1,ErrAv2
        Write(6,442)'  Average absolute deviation:  ',ErrDe1,ErrDe2
        Write(6,442)'  Average relative error:      ',ErrRe1,ErrRe2
        Write(6,442)'  Maximal deviation:           ',ErrMax1,ErrMax2
        Write(6,*)
        Write(6,443)'  Error correlation:           ',CorrCoeff
        Write(6,444)'  Smaller error than MP:       ',PImp,'%'
        Write(6,444)'  Larger error than MP:        ',PShi,'%'
        Write(6,'(A)')' |----------------------------------------------'
     &//'------|'
        Write(6,*)
*
*---- Deallocate
*
        Call GetMem('ElPot','Free','Real',iElP,nDens+4)
        Call mma_deallocate(D1ao)
        Call GetMem('PotPointCoord','Free','Real',ipEPCo,3*nEPP)
        irc=-1
        Call ClsOne(irc,0)
      Endif

441   Format(3(F12.8),'    In: ',3(F8.4))
442   Format(A,2(F12.8))
443   Format(A,F12.8)
444   Format(A,F12.8,A)

      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(ipC)
         Call Unused_integer_array(iANr)
         Call Unused_integer(ipT)
         Call Unused_integer(ipTi)
         Call Unused_integer(iTP)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989-1992,1998,1999, Roland Lindh                      *
!               1990, IBM                                              *
!               2000-2015, Valera Veryazov                             *
!***********************************************************************

subroutine Grid_it(iRun,ireturn)
!  iRun =1 normal run, 0=truncated from scf
!***********************************************************************
!                                                                      *
!  Object: Driver for evaluation MO values on a grid.                  *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA     *
!          July '89 - May '90                                          *
!                                                                      *
!          Modified to gradient calculations September 1991 -          *
!          February 1992.                                              *
!                                                                      *
!          Modified to evaluating the spin density and spin density    *
!          gradients on a grid                                         *
!                                                                      *
!          Modified to interface with the MSI Cerius 2.                *
!          April 1998                                                  *
!                                                                      *
!          Modified at June- Sept 1999                                 *
!                                                                      *
!   This code was rewritten from scratch by V. Veryazov                *
!          Lund, 2000-2015                                             *
!***********************************************************************

use grid_it_globals, only: isUHF, levelprint, LuVal, LuVal_ab
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iRun
integer(kind=iwp), intent(out) :: ireturn
#include "warnings.h"
integer(kind=iwp) :: nDiff
logical(kind=iwp) :: DoRys
character(len=1024) :: INPORB
!character(len=120) :: Lines(17)
integer(kind=iwp), external :: IPRINTLEVEL

! Prologue

levelprint = IPRINTLEVEL(-1)
if ((iRun == 0) .and. (levelprint < 3)) then
  levelprint = 0
  levelprint = IPRINTLEVEL(levelprint)
end if
if (iRun == 1) then
  call SetTim()

  !call bXML('GRID_IT')

  ! Get the work space size

end if

nDiff = 0
DoRys = .false.
call IniSew(DoRys,nDiff)

!---- Read the input

iReturn = 0
call Input_Grid_It(iRun,INPORB)
if (iReturn == _RC_INVOKED_OTHER_MODULE_) then
  ! take care to close files and release the potential memory...
  !close(LuOrb)
  close(LuVal)
  if (isUHF) close(LuVal_ab)
else

  ! Start computing the spin density and spin density gradient at the grid.

  call DrvMO(iRun,INPORB)

  !-----At the end of the calculation free all memory to check for
  !     corruption of the memory.

end if

call ClsSew()

! Epilogue

!if (iRun == 1) then
!  call eXML('GRID_IT')
!else
!  write(u6,*) 'Input file for molcasgv was generated'
!end if
!ireturn = 0

return

end subroutine Grid_it

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Oskar Weser                                      *
************************************************************************
#include "compiler_features.h"
      module sorting
        implicit none
        private
        public ::
     &    sort, argsort,  tAlgorithm, algorithms, bubble_sort_trsh
#ifndef INTERNAL_PROC_ARG
        public :: compare_int_t
#endif

! TODO: Should be changed to default construction in the future.
! As of July 2019 the Sun and PGI compiler have problems.
        type :: tAlgorithmValues
          integer :: mergesort, quicksort
        end type
        type(tAlgorithmValues), parameter ::
     &      algorithms = tAlgorithmValues(mergesort=1, quicksort=2)

        type :: tAlgorithm
          integer :: val
        end type
        type(tAlgorithm), parameter ::
     &      default_algorithm = tAlgorithm(algorithms%mergesort)

! When to switch to naive sort, which scales with n^2,
! but requires less overhead.
        integer, parameter :: bubble_sort_trsh = 20

        ! Should be an abstract interface
        interface
          logical pure function compare_int_t(a, b)
            integer, intent(in) :: a, b
          end function

          logical pure function compare_real_t(x, y)
            real*8, intent(in) :: x, y
          end function
        end interface

!>  @brief
!>    Returns the indices that would sort a vector.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  The vector is sorted until f(v(i), v(i + 1)) is true for all i.
!>  If you want to sort the vector increasingly, just use
!>  \code{.unparsed}
!>  logical pure function le(i, j)
!>    integer, intent(in) :: i, j
!>    le = i <= j
!>  end function
!>  \endcode
!>  If you want to change the sorting algorithm, you can do so on the fly.
!>  The default is always a stable sorting algorithm.
!>  \code{.unparsed}
!>   call argsort(V, le, tAlgorithm(algorithms%mergesort))
!>   call argsort(V, le, tAlgorithm(algorithms%quicksort))
!>  \endcode
!>
!>  @param[in] V Integer or real vector to be sorted
!>  @param[in] compare A logical pure function of two integer or real arguments.
!>  @param[in] algorithm The sorting algorithm to use.
        interface argsort
          module procedure I1D_argsort, R1D_argsort
        end interface

#ifndef INTERNAL_PROC_ARG
        integer, pointer :: mod_iV(:)
        real*8, pointer :: mod_rV(:)
        procedure(compare_int_t), pointer :: mod_comp_int
        procedure(compare_real_t), pointer :: mod_comp_real
#endif

        contains

#ifndef INTERNAL_PROC_ARG
        logical pure function my_compare_iV(x, y)
          integer, intent(in) :: x, y
          my_compare_iV = mod_comp_int(mod_iV(x), mod_iV(y))
        end function

        logical pure function my_compare_rV(x, y)
          integer, intent(in) :: x, y
          my_compare_rV = mod_comp_real(mod_rV(x), mod_rV(y))
        end function
#endif

        function I1D_argsort(V, compare, algorithm) result(idx)
          integer, target, intent(inout) :: V(:)
          procedure(compare_int_t) :: compare
          type(tAlgorithm), intent(in), optional :: algorithm
          type(tAlgorithm)  :: algorithm_
          integer :: idx(lbound(V, 1):ubound(V, 1)), i
          if (present(algorithm)) then
            algorithm_ = algorithm
          else
            algorithm_ = default_algorithm
          end if

          idx = [(i, i = lbound(V, 1), ubound(V, 1))]

#ifdef INTERNAL_PROC_ARG
          call sort(idx, my_compare, algorithm_)
#else
          mod_iV => V
          mod_comp_int => compare
          call sort(idx, my_compare_iV, algorithm_)
#endif

#ifdef INTERNAL_PROC_ARG
          contains
            logical pure function my_compare(x, y)
              integer, intent(in) :: x, y
              my_compare = compare(V(x), V(y))
            end function
#endif
        end function I1D_argsort




        function R1D_argsort(V, compare, algorithm) result(idx)
          real*8, target, intent(inout) :: V(:)
          procedure(compare_real_t) :: compare
          type(tAlgorithm), intent(in), optional :: algorithm
          type(tAlgorithm)  :: algorithm_
          integer :: idx(lbound(V, 1):ubound(V, 1)), i
          if (present(algorithm)) then
            algorithm_ = algorithm
          else
            algorithm_ = default_algorithm
          end if

          idx = [(i, i = lbound(V, 1), ubound(V, 1))]

#ifdef INTERNAL_PROC_ARG
          call sort(idx, my_compare, algorithm_)
#else
          mod_rV => V
          mod_comp_real => compare
          call sort(idx, my_compare_rV, algorithm_)
#endif

#ifdef INTERNAL_PROC_ARG
          contains
            logical pure function my_compare(x, y)
              integer, intent(in) :: x, y
              my_compare = compare(V(x), V(y))
            end function
#endif
        end function R1D_argsort

!>  @brief
!>    Sort the array V inplace.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  The array is sorted until f(v(i), v(i + 1)) is true for all i.
!>  If you want to sort an array increasingly, just use
!>  \code{.unparsed}
!>  logical pure function le(i, j)
!>    integer, intent(in) :: i, j
!>    le = i <= j
!>  end function
!>  \endcode
!>  The real power of this routine shines, when the array
!>  is treated as an index array of other matrices or tensors.
!>  If you want to sort a 2D-matrix according to the column sum,
!>  just use:
!>  \code{.unparsed}
!>   integer :: col_idx(lbound(matrix, 2):ubound(matrix, 2))
!>   col_idx = [(i, i = lbound(col_idx, 1), ubound(col_idx, 1))]
!>   call sort(col_idx, col_sum)
!>
!>   contains
!>
!>    logical pure function col_sum(i, j)
!>      integer, intent(in) :: i, j
!>      col_sum = sum(abs(matrix(:, i))) <= sum(abs(matrix(:, j)))
!>    end function
!>  \endcode
!>  If you want to change the sorting algorithm, you can do so on the fly.
!>  The default is always a stable sorting algorithm.
!>  \code{.unparsed}
!>   call sort(col_idx, col_sum, tAlgorithm(algorithms%mergesort))
!>   call sort(col_idx, col_sum, tAlgorithm(algorithms%quicksort))
!>  \endcode
!>
!>  @param[in] V Integer 1D-Array to be sorted
!>  @param[in] compare A logical pure function of two integer arguments.
!>  @param[in] algorithm The sorting algorithm to use.
        subroutine sort(V, compare, algorithm)
          integer, intent(inout) :: V(:)
          procedure(compare_int_t) :: compare
          type(tAlgorithm), intent(in), optional :: algorithm
          type(tAlgorithm)  :: algorithm_
          if (present(algorithm)) then
            algorithm_ = algorithm
          else
            algorithm_ = default_algorithm
          end if

          select case (algorithm_%val)
            case(algorithms%mergesort)
              call mergesort(V, compare)
            case(algorithms%quicksort)
              call quicksort(V, compare)
          end select
        end subroutine sort

        subroutine bubble_sort(V, compare)
          integer, intent(inout) :: V(:)
          procedure(compare_int_t) :: compare

          integer :: n, i

          do n = ubound(V, 1), lbound(V, 1) + 1, -1
            do i = lbound(V, 1), ubound(V, 1) - 1
              if (.not. compare(V(i), V(i + 1))) then
                call swap(V(i), V(i + 1))
              end if
            end do
          end do
        end subroutine bubble_sort

        subroutine swap(a, b)
          integer, intent(inout) :: a, b
          integer :: t
          t = a; a = b; b = t
        end subroutine

!>  @brief
!>    Merge two sorted arrays into sorted array.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  A and B are in-parameters and C is an out-parameter, if
!>  non overlapping memory is used.
!>  Either A or B is allowed to overlap with the second half
!>  of the output array C.
!>
!>  @param[inout] A Sorted 1D-array to be merged.
!>  @param[inout] B Sorted 1D-array to be merged.
!>  @param[inout] C Merged and sorted 1D-array.
!>  @param[in] compare A logical pure function of two integer arguments.
        subroutine merge_(A, B, C, compare)
! The target attribute is there to prevent the compiler from
! assuming non overlapping memory.
          integer, target, intent(inout) :: A(:), B(:), C(:)
          procedure(compare_int_t) :: compare

          integer :: i, j, k

          if (size(A) + size(B) > size(C)) stop

          i = lbound(A, 1)
          j = lbound(B, 1)
          do k = lbound(C, 1), ubound(C, 1)
            if (i <= ubound(A, 1) .and. j <= ubound(B, 1)) then
              if (compare(A(i), B(j))) then
                C(k) = A(i)
                i = i + 1
              else
                C(k) = B(j)
                j = j + 1
              end if
            else if (i <= ubound(A, 1)) then
              C(k) = A(i)
              i = i + 1
            else if (j <= ubound(B, 1)) then
              C(k) = B(j)
              j = j + 1
            end if
          end do
        end subroutine merge_


        recursive subroutine mergesort(A, compare)
          integer, intent(inout) :: A(:)
          procedure(compare_int_t) :: compare

          integer, allocatable :: work(:)
          integer :: half
          half = (ubound(A, 1) - lbound(A, 1)) / 2 + 1
          allocate(work(half))
          call mergesort_work(A, compare, work)
          deallocate(work)
        end subroutine mergesort

        recursive subroutine mergesort_work(A, compare, work)
          integer, intent(inout) :: A(:)
          procedure(compare_int_t) :: compare
          integer, intent(inout) :: work(:)

          integer :: half
          half = (ubound(A, 1) - lbound(A, 1)) / 2 + 1
          if (size(A) < 2) then
            continue
          else if (size(A) == 2) then
            call bubble_sort(A, compare)
          else
            call mergesort_work(A( : half), compare, work)
            call mergesort_work(A(half + 1 :), compare, work)
            if (.not. compare(A(half), A(half + 1))) then
              work(1 : half) = A(1 : half)
              call merge_(work(1 : half), A(half + 1:), A, compare)
            endif
          end if
        end subroutine mergesort_work


        recursive subroutine quicksort(idx, compare)
          integer, intent(inout) :: idx(:)
          procedure(compare_int_t) :: compare

          integer :: i, j, pivot

          if (size(idx) > bubble_sort_trsh) then
            i = lbound(idx, 1)
            j = ubound(idx, 1)
            pivot = idx((j - i) / 2 + 1)

            do
              do while (.not. compare(idx(i), pivot))
                 i = i + 1
              end do
              do while (.not. compare(pivot, idx(j)))
                 j = j - 1
              end do
              if (i >= j) exit
              call swap(idx(i), idx(j))
              i = i + 1
              j = j - 1
            end do

            if (lbound(idx, 1) + 1 < i) then
              call quicksort(idx(: i  - 1), compare)
            end if
            if (j + 1 < ubound(idx, 1)) then
              call quicksort(idx(j + 1 : ), compare)
            end if
          else
            call bubble_sort(idx, compare)
          end if
        end subroutine quicksort
      end module sorting

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1992, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine PSOAO1(nSO,MemPrm,MemMax,iAnga,iCmpa,iAO,iFnc,iBas,iBsInc,jBas,jBsInc,kBas,kBsInc,lBas,lBsInc,iPrim,iPrInc,jPrim, &
                  jPrInc,kPrim,kPrInc,lPrim,lPrInc,ipMem1,ipMem2,Mem1,Mem2,MemPSO)
!***********************************************************************
!                                                                      *
!  Object: to partion the SO and AO block. It will go to some length   *
!          before it will start and break up the SO block. This will   *
!          reduce the total flop count. However, as we are breaking up *
!          the AO block this will affect the vectorization. Hence, at  *
!          some point it will actually be better to recompute the      *
!          primitives.                                                 *
!          Current stratergy:                                          *
!          1. Start reducing the length of the primitives in the order *
!             lPrim,jPrim.                                             *
!          2. Reduce the size of the SO block by reducing the number of*
!             basis functions in the order lBas, jBas.                 *
!          3. Terminate run telling job max and min of additional      *
!             memory needed to perform the calculation.                *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified to first order derivatives. January '92         *
!***********************************************************************

use aces_stuff, only: nGamma, Gamma_On
use PSO_Stuff, only: lPSO
use SOAO_Info, only: iAOtSO
use Gateway_global, only: force_part_c, force_part_p
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSO, MemPrm, MemMax, iAnga(4), iCmpa(4), iAO(4), iBas, jBas, kBas, lBas, iPrim, jPrim, kPrim, &
                                 lPrim, ipMem1
integer(kind=iwp), intent(out) :: iFnc(4), iBsInc, jBsInc, kBsInc, lBsInc, iPrInc, jPrInc, kPrInc, lPrInc, ipMem2, Mem1, Mem2, &
                                  MemPSO
integer(kind=iwp) :: i1, iCmp, iFac, iiBas(4), IncVec, iTmp1, j, jCmp, jPam, kCmp, kSOInt, la, lb, lc, lCmp, ld, lSize, mabcd, &
                     Mem0, Mem3, MemAux, MemAux0, MemDeP, MemRys, MemScr, MemSph, MemTrn, nA2, nA3, nabcd, nCache, nFac, &
                     nPam(4,0:7), nTmp1, nTmp2, nVec1
logical(kind=iwp) :: Fail, QiBas, QjBas, QjPrim, QkBas, QlBas, QlPrim
integer(kind=iwp), external :: MemTra
#include "lCache.fh"
#include "pstat.fh"

la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)
iCmp = iCmpa(1)
jCmp = iCmpa(2)
kCmp = iCmpa(3)
lCmp = iCmpa(4)
iTotal = iTotal+1
mabcd = nTri_Elem1(la)*nTri_Elem1(lb)*nTri_Elem1(lc)*nTri_Elem1(ld)
nabcd = iCmp*jCmp*kCmp*lCmp

if (force_part_c) then
  iBsInc = (iBas+1)/2
  jBsInc = (jBas+1)/2
  kBsInc = (kBas+1)/2
  lBsInc = (lBas+1)/2
else
  iBsInc = iBas
  jBsInc = jBas
  kBsInc = kBas
  lBsInc = lBas
end if
if (force_part_p) then
  jPrInc = (jPrim+1)/2
  lPrInc = (lPrim+1)/2
else
  jPrInc = jPrim
  lPrInc = lPrim
end if
iPrInc = iPrim
kPrInc = kPrim

do
  QjPrim = .false.
  QlPrim = .true.
  QiBas = .false.
  QjBas = .false.
  QkBas = .false.
  QlBas = .false.
  Mem0 = MemMax

  ! *** Work1 ***

  ! Memory for 2nd order density matrix in SO basis.

  kSOInt = nSO*iBsInc*jBsInc*kBsInc*lBsInc
  Mem1 = kSOInt

  ! Allocate memory for MO to SO/AO transformation
  ! of the 2nd order density matrix for this shell quadruplet.

  if (lPSO) then
    iiBas(1) = iBsInc
    iiBas(2) = jBsInc
    iiBas(3) = kBsInc
    iiBas(4) = lBsInc
    nPam(:,:) = 0
    MemPSO = 1
    nTmp2 = 0

    do jPam=1,4
      iTmp1 = 0
      nTmp1 = 0
      do j=0,nIrrep-1
        do i1=1,iCmpa(jPam)
          if (iAOtSO(iAO(jPam)+i1,j) > 0) then
            nPam(jPam,j) = nPam(jPam,j)+iiBas(jPam)
            nTmp1 = nTmp1+iiBas(jPam)
            iTmp1 = iTmp1+1
          end if
        end do
      end do
      MemPSO = MemPSO*nTmp1
      nTmp2 = nTmp2+nTmp1
      iFnc(jPam) = iTmp1
    end do
    MemScr = MemTra(nPam)
    nFac = 4
    nTmp2 = nTmp2+4
  else
    MemScr = 0
    MemPSO = 0
    nFac = 0
    nTmp2 = 0
  end if
  MemAux0 = MemPSO+MemScr+nFac*S%nDim+nTmp2+4
  if (Mem1+1+MemAux0 > Mem0) then
    MaxReq = max(MaxReq,Mem1+1+MemAux0-Mem0)
    QjPrim = .false.
    QlPrim = .false.
    QiBas = .false.
    QjBas = .false.
    QkBas = .false.
    QlBas = .true.
    call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                MaxReq,Fail)
    if (Fail) then
      write(u6,*) ' Memory allocation failed for Work1'
      write(u6,'(2I3,L1,2I3,L1)') iBas,iBsInc,QiBas,kBas,kBsInc,QkBas
      write(u6,'(2I3,L1,2I3,L1)') jBas,jBsInc,QjBas,lBas,lBsInc,QlBas
      write(u6,'(2I3,L1,2I3,L1)') jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim
      write(u6,*) MemMax,Mem0,Mem1,MemAux0+1
      write(u6,*) MemPSO,MemScr,4*S%nDim,nTmp2+4
      call Abend()
    end if
    cycle
  end if
  ! Subtract one additional word (?)
  Mem0 = Mem0-Mem1-1

  ! *** Work2 and Work4 ***

  ! Memory for 2nd order density matrix in contracted basis (both
  ! cartesian and spherical harmonic) and in primitive basis.
  ! MemDeP: Target for desymmetrization
  ! MemTrn: Scratch and target for decontraction
  ! MemAux: Contracted 2nd order density matrix (if partial decon.)
  ! MemSph: transformation spherical harmonics to cartesian, source
  !         and target.
  ! nGamma: temporary storage of bins as read from file.

  if (Gamma_On) then
    iiBas(1) = iBas
    iiBas(2) = jBas
    iiBas(3) = kBas
    iiBas(4) = lBas
    nGamma = 1

    do jPam=1,4
      nTmp1 = 0
      do j=0,nIrrep-1
        do i1=1,iCmpa(jPam)
          if (iAOtSO(iAO(jPam)+i1,j) > 0) then
            nTmp1 = nTmp1+iiBas(jPam)
          end if
        end do
      end do
      nGamma = nGamma*nTmp1
    end do
  else
    nGamma = 0
  end if

  MemDeP = nabcd*iBsInc*jBsInc*kBsInc*lBsInc

  MemTrn = mabcd*max(iBsInc*jBsInc*kBsInc*lBsInc,iPrInc*jPrInc*kPrInc*lPrInc)
  ! If partial decontraction we need to keep the contracted 2nd
  ! order density matrix. (Work4)
  if ((jPrInc /= jPrim) .or. (lPrInc /= lPrim)) then
    MemAux = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
  else
    MemAux = 0
  end if
  MemSph = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
  Mem2 = max(MemTrn+MemAux,MemDeP,MemSph,nGamma+MemAux0)
  if (Mem2+1 > Mem0) then
    MaxReq = max(MaxReq,Mem2+1-Mem0)
    call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                MaxReq,Fail)
    if (Fail) then
      write(u6,*) ' Memory allocation failed for Work2'
      write(u6,'(2I3,L1,2I3,L1)') iBas,iBsInc,QiBas,kBas,kBsInc,QkBas
      write(u6,'(2I3,L1,2I3,L1)') jBas,jBsInc,QjBas,lBas,lBsInc,QlBas
      write(u6,'(2I3,L1,2I3,L1)') jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim
      write(u6,*) MemMax,Mem0,Mem1,Mem2
      call Abend()
    end if
    cycle
  end if
  ! Subtract one additional word (?)
  Mem0 = Mem0-Mem2-1

  ! *** Work3 and Work5 ***

  ! Scratch for decontraction and transformation to spherical gaussian.
  ! Working array for Rysg1.
  ! Scratch area for resolving degeneracies due to the double coset
  ! treatement of the symmetry.
  ! MemTrn: Scratch for decontraction
  ! MemRys: Scratch for calualation of primitive integral gradients.
  ! MemScr: Scratch for prescreening

  ! If mabcd /= 1 we need to do a transpose!
  iFac = 0
  if (mabcd /= 1) iFac = 1

  nCache = (3*lCache)/4-iBas*iPrim-jBas*jPrim
  lSize = iBsInc*jBsInc+max(iBsInc*jPrInc,iPrInc*jBsInc)
  nVec1 = kBsInc*lBsInc*mabcd
  IncVec = min(max(1,nCache/lSize),nVec1)
  nA2 = max(iBsInc*jPrInc,iPrInc*jBsInc)*IncVec
  nA3 = iPrInc*jPrInc*nVec1
  MemTrn = nA2+nA3

  nCache = (3*lCache)/4-kBas*kPrim-lBas*lPrim
  lSize = kBsInc*lBsInc+max(kBsInc*lPrInc,kPrInc*lBsInc)
  nVec1 = iPrInc*jPrInc*mabcd
  IncVec = min(max(1,nCache/lSize),nVec1)
  nA2 = max(kBsInc*lPrInc,kPrInc*lBsInc)*IncVec
  MemTrn = max(MemTrn,nA3+nA2,iFac*mabcd*iBsInc*jBsInc*kBsInc*lBsInc)
  !                                                                      *
  !***********************************************************************
  !                                                                      *
  nCache = (3*lCache)/4-kBas*kPrim-lBas*lPrim
  lSize = kBsInc*lBsInc+max(kBsInc*lPrInc,kPrInc*lBsInc)
  nVec1 = iBsInc*jBsInc*mabcd
  IncVec = min(max(1,nCache/lSize),nVec1)
  nA2 = max(kBsInc*lPrInc,kPrInc*lBsInc)*IncVec
  nA3 = kPrInc*lPrInc*nVec1
  MemTrn = max(MemTrn,nA3+nA2)

  MemTrn = max(MemTrn,nA2+nA3)
  nCache = (3*lCache)/4-iBas*iPrim-jBas*jPrim
  lSize = iBsInc*jBsInc+max(iBsInc*jPrInc,iPrInc*jBsInc)
  nVec1 = kPrInc*lPrInc*mabcd
  IncVec = min(max(1,nCache/lSize),nVec1)
  nA2 = max(iBsInc*jPrInc,iPrInc*jBsInc)*IncVec

  MemTrn = max(MemTrn,nA2+nA3,iFac*mabcd*iBsInc*jBsInc*kBsInc*lBsInc)

  MemRys = MemPrm*iPrInc*jPrInc*kPrInc*lPrInc
  MemScr = (2*mabcd+1)*iPrInc*jPrInc*kPrInc*lPrInc+iPrInc*jPrInc+kPrInc*lPrInc
  Mem3 = max(MemTrn,MemRys,MemScr)
  if (Mem3+1 > Mem0) then
    MaxReq = max(MaxReq,Mem3+1-Mem0)
    call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                MaxReq,Fail)
    if (Fail) then
      write(u6,*) ' Memory allocation failed for Work3'
      write(u6,'(2I3,L1,2I3,L1)') iBas,iBsInc,QiBas,kBas,kBsInc,QkBas
      write(u6,'(2I3,L1,2I3,L1)') jBas,jBsInc,QjBas,lBas,lBsInc,QlBas
      write(u6,'(2I3,L1,2I3,L1)') jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim
      write(u6,*) MemMax,Mem0,Mem1,Mem2,Mem3
      write(u6,*) MemTrn,MemRys,MemPrm
      call Abend()
    end if
  else
    exit
  end if
end do
! Subtract one additional word (?)
Mem0 = Mem0-Mem3-1
MinXtr = min(MinXtr,Mem0)

Mem2 = Mem2+Mem3

ipMem2 = ipMem1+Mem1

r1 = r1+real(iBsInc,kind=wp)/real(iBas,kind=wp)
r2 = r2+real(jBsInc,kind=wp)/real(jBas,kind=wp)
r3 = r3+real(kBsInc,kind=wp)/real(kBas,kind=wp)
r4 = r4+real(lBsInc,kind=wp)/real(lBas,kind=wp)
q1 = q1+real(iPrInc,kind=wp)/real(iPrim,kind=wp)
q2 = q2+real(jPrInc,kind=wp)/real(jPrim,kind=wp)
q3 = q3+real(kPrInc,kind=wp)/real(kPrim,kind=wp)
q4 = q4+real(lPrInc,kind=wp)/real(lPrim,kind=wp)

return

end subroutine PSOAO1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

subroutine CalcAXX(AXX,W)

use Index_Functions, only: iTri, nTri_Elem
use input_mclr, only: nRoots
use Constants, only: Zero, Two, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: AXX(nTri_Elem(nRoots-1),nTri_Elem(nRoots-1))
real(kind=wp), intent(in) :: W(nTri_Elem(nRoots),nTri_Elem(nRoots))
integer(kind=iwp) :: IC, IKK, IKL, IKL2, ILL, IMM, IMN, IMN2, INN, K, L, M, N
real(kind=wp) :: VKLMN, VKLNM, VLKMN, VLKNM

do K=1,nRoots
  do L=1,K-1
    IKL = iTri(K,L)
    IKK = nTri_Elem(K)
    ILL = nTri_Elem(L)
    IKL2 = nTri_Elem(K-2)+L
    do M=1,nRoots
      do N=1,M-1
        IMN = iTri(M,N)
        IMM = nTri_Elem(M)
        INN = nTri_Elem(N)
        IMN2 = nTri_Elem(M-2)+N
        VKLMN = Zero
        VLKNM = Zero
        VLKMN = Zero
        VKLNM = Zero
        if (L == M) then
          IC = iTri(K,N)
          VKLMN = W(IC,IKK)+W(IC,INN)-Two*W(IC,ILL)-Four*W(IKL,IMN)
        end if
        if (K == N) then
          IC = iTri(L,M)
          VLKNM = W(IC,ILL)+W(IC,IMM)-Two*W(IC,IKK)-Four*W(IKL,IMN)
        end if
        if (K == M) then
          IC = iTri(L,N)
          VLKMN = W(IC,ILL)+W(IC,INN)-Two*W(IC,IKK)-Four*W(IKL,IMN)
        end if
        if (L == N) then
          IC = iTri(K,M)
          VKLNM = W(IC,IKK)+W(IC,IMM)-Two*W(IC,ILL)-Four*W(IKL,IMN)
        end if
        AXX(IMN2,IKL2) = VKLMN+VLKNM-VKLNM-VLKMN
      end do
    end do
  end do
end do

end subroutine CalcAXX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine SROMem(nHer,MemSRO,la,lb,lr)
************************************************************************
*  Object: to compute the number of real*8 the kernal routine will     *
*          need for the computation of a matrix element between two    *
*          cartesian Gaussin functions with the total angular momentum *
*          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
*          lr is the order of the operator (this is only used when the *
*          integrals are computed with the Hermite-Gauss quadrature).  *
*                                                                      *
*  Called from: OneEl                                                  *
*                                                                      *
************************************************************************
*
      use Basis_Info, only: dbsc, nCnttp, Shells
*
      nElem(i) = (i+1)*(i+2)/2
*
      nHer = 0
      MemSRO = 0
      Do 1960 iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%ECP) Cycle
         Do 1966 iAng = 0, dbsc(iCnttp)%nSRO-1
            iShll = dbsc(iCnttp)%iSRO + iAng
            nExpi = Shells(iShll)%nExp
            If (nExpi.eq.0) Cycle
*
            ip = 0
            ip = ip + nExpi**2
            nac = nElem(la)*nElem(iAng)
            ip = ip + nExpi*nac
            ip = ip + 3 * nExpi
            ip = ip + nExpi
            ip = ip + nExpi
            ip = ip + nExpi
*
            Call MltMmP(nH,MemMlt,la,iAng,lr)
            nHer = Max(nH,nHer)
            MemSRO = Max(MemSRO,ip+nExpi*MemMlt)
            ip = ip - 6 * nExpi
*
            ncb = nElem(iAng)*nElem(lb)
            ip = ip + nExpi*ncb
            ip = ip + 3 * nExpi
            ip = ip + nExpi
            ip = ip + nExpi
            ip = ip + nExpi
*
            Call MltMmP(nH,MemMlt,iAng,lb,lr)
            nHer = Max(nH,nHer)
            MemSRO = Max(MemSRO,ip+nExpi*MemMlt)
            ip = ip - 6 * nExpi
*
            ip = ip + Max(nExpi*nac,ncb*nExpi)
            MemSRO = Max(MemSRO,ip)
*
 1966    Continue
 1960 Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NEWFSBTAB(NACTEL,MSPIN2,LSYM,REST,SSTAB,ICASE)
      use stdalloc, only: mma_allocate, mma_deallocate
      use rassi_global_arrays, only: FSBARR
      use rassi_global_arrays, only: FSBTAB1, FSBTAB2, FSBTAB
      IMPLICIT NONE
      INTEGER NACTEL,MSPIN2,LSYM
      INTEGER REST(*), SSTAB(*)
      INTEGER ICASE

      INTEGER LSSTARR,NSIZE,ITYPE
      INTEGER NASPRT
      INTEGER NSSTARR,NPART,NSYM
      INTEGER NRDETS,NRDETS0,NFSB,NFSB0
      INTEGER KORB,KREST,IFSB,IERR
      INTEGER NHEAD,NHSHMAP,KHSHMAP,JFSB
      INTEGER NLEN
C Purpose: Construct an FSB table and return its address in the
C FSBTAB1/FiSBTAB2 array.
C ITYPE=73 is the check code for this table.
      ITYPE=73
      IF(SSTAB(2).NE.19) THEN
        WRITE(6,*)' NEWFSBTAB error: Not a Substring Table.'
        CALL ABEND()
      END IF
      IF(REST(2).NE.91) THEN
        WRITE(6,*)' NEWFSBTAB error: Not a GAS Restriction Table.'
        CALL ABEND()
      END IF
      NSYM  =SSTAB(4)
      NASPRT=SSTAB(5)
      NPART=REST(3)
      KORB=5
      KREST=KORB+(NSYM+1)*(NPART+1)
C Table consists of a 6-word header with data (see below), then
C an array dimensioned (NASPRT+2)*NFSB, and finally a hash map
C with suitable capacity e.g. 2*NFSB (50% usage). Each item in a
C hash map takes up 2 integers. Capacity must be at least NFSB+997.
      CALL mkVERTAB(NACTEL,MSPIN2,LSYM,NPART,REST(KORB),REST(KREST),
     &              SSTAB,NFSB0,NRDETS0,NFSB,NRDETS)
      NHEAD=7
      NSSTARR=(NASPRT+2)*NFSB
      NHSHMAP=997+2*NFSB
      NSIZE=NHEAD+NSSTARR+2*NHSHMAP
      SELECT CASE (iCase)
      CASE (1)
         CALL mma_allocate(FSBTAB1,NSIZE,Label='FSBTAB1')
         FSBTAB=>FSBTAB1(:)
      CASE (2)
         CALL mma_allocate(FSBTAB2,NSIZE,Label='FSBTAB2')
         FSBTAB=>FSBTAB2(:)
      CASE DEFAULT
         WRITE(6,*) 'NEWFSBTAB: Illegal ICASE value'
         WRITE(6,*) 'ICASE=',ICASE
      END SELECT
      NLEN=(NASPRT+2)*NFSB
      CALL ICOPY(NLEN,FSBARR(1:NLEN),1,
     &                FSBTAB(1+NHEAD:NLEN+NHEAD),1)
      Call mma_deallocate(FSBARR)

      LSSTARR=1+NHEAD

C Position of hash table ('Map')
      KHSHMAP=1+NHEAD+NSSTARR
      FSBTAB(1)=NSIZE
      FSBTAB(2)=ITYPE
      FSBTAB(3)=NFSB
      FSBTAB(4)=NASPRT
      FSBTAB(5)=NRDETS
      FSBTAB(6)=NHSHMAP
      FSBTAB(7)=KHSHMAP
C Make the hash map: NULL is a null marker. Suggested value=-1.
!     NULL=-1
!     CALL HSHINI(NHSHMAP,FSBTAB(KHSHMAP),NULL)
!     In conflict with the null() pointer
      CALL HSHINI(NHSHMAP,FSBTAB(KHSHMAP:),-1)
C Store values in the map:
      DO IFSB=1,NFSB
        CALL HSHPUT(NASPRT,NASPRT+2,FSBTAB(LSSTARR:),
     &              NHSHMAP,FSBTAB(KHSHMAP:),IFSB)
      END DO
C Check that they can be obtained back:
      IERR=0
      DO IFSB=1,NFSB
        CALL HSHGET(FSBTAB(LSSTARR+(NASPRT+2)*(IFSB-1):),NASPRT,
     &        NASPRT+2,FSBTAB(LSSTARR:),NHSHMAP,FSBTAB(KHSHMAP:),JFSB)
        IF(IFSB.NE.JFSB) IERR=IERR+1
      END DO
      IF(IERR.GT.0) THEN
        WRITE(6,*)'NEWFSBTAB Hash index errors. IERR=',IERR
        CALL ABEND()
      END IF
      nullify(FSBTAB)

      END SUBROUTINE NEWFSBTAB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine formats_cvb()

use casvb_global, only: form2AD, form2AF, formAD, formAF, formChk1, formChk2, formChk3, formcvp, formE, formMXP1, formMXP2, &
                        formMXP3, formMXP4, formMXP5, formMXP6, formroot, formSymW, formVBWnorm, iprec
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ix1, ix2, lenfld

lenfld = 4+iprec
ix2 = max(0,(lenfld-3)/2)
ix1 = max(0,lenfld-3-ix2)
! iprec=8 => formMXP1='(4x,8(5x,i3,4x))'
formMXP1 = '(4x,8('
if (ix1 > 0) then
  call appendint_cvb(formMXP1,ix1,0)
  call appendchr_cvb(formMXP1,'x,',0)
end if
call appendchr_cvb(formMXP1,'i3',0)
if (ix2 > 0) then
  call appendchr_cvb(formMXP1,',',0)
  call appendint_cvb(formMXP1,ix2,0)
  call appendchr_cvb(formMXP1,'x',0)
end if
call appendchr_cvb(formMXP1,'))',0)
! iprec=8 => formMXP2='(4x,8(7x,i3,6x))'
formMXP2 = '(4x,8('
if (ix1 > 0) then
  call appendint_cvb(formMXP2,ix1+2,0)
  call appendchr_cvb(formMXP2,'x,',0)
end if
call appendchr_cvb(formMXP2,'i3',0)
if (ix2 > 0) then
  call appendchr_cvb(formMXP2,',',0)
  call appendint_cvb(formMXP2,ix2+2,0)
  call appendchr_cvb(formMXP2,'x',0)
end if
call appendchr_cvb(formMXP2,'))',0)
! iprec=8 => formMXP3='(1x,i3,8f12.8)'
formMXP3 = '(1x,i3,8f'
call appendint_cvb(formMXP3,lenfld,0)
call appendchr_cvb(formMXP3,'.',0)
call appendint_cvb(formMXP3,iprec,0)
call appendchr_cvb(formMXP3,')',0)
! iprec=8 => formMXP4='(1x,i3,8es16.8)'
formMXP4 = '(1x,i3,8es'
call appendint_cvb(formMXP4,lenfld+4,0)
call appendchr_cvb(formMXP4,'.',0)
call appendint_cvb(formMXP4,iprec,0)
call appendchr_cvb(formMXP4,')',0)
! iprec=8 => formMXP5='(4x,8f12.8)'
formMXP5 = '(4x,8f'
call appendint_cvb(formMXP5,lenfld,0)
call appendchr_cvb(formMXP5,'.',0)
call appendint_cvb(formMXP5,iprec,0)
call appendchr_cvb(formMXP5,')',0)
! iprec=8 => formMXP6='(4x,8es16.8)'
formMXP6 = '(4x,8es'
call appendint_cvb(formMXP6,lenfld+4,0)
call appendchr_cvb(formMXP6,'.',0)
call appendint_cvb(formMXP6,iprec,0)
call appendchr_cvb(formMXP6,')',0)

! iprec=8 => formE='(a,f16.10)'
formE = '(a,f'
call appendint_cvb(formE,iprec+8,0)
call appendchr_cvb(formE,'.',0)
call appendint_cvb(formE,iprec+2,0)
call appendchr_cvb(formE,')',0)
! iprec=8 => formSymW='(a,i2,a,4es16.8)'
formSymW = '(a,i2,a,4es'
call appendint_cvb(formSymW,iprec+8,0)
call appendchr_cvb(formSymW,'.',0)
call appendint_cvb(formSymW,iprec,0)
call appendchr_cvb(formSymW,')',0)
! iprec=8 => formVBWnorm='(a,f12.8,a)'
formVBWnorm = '(a,f'
call appendint_cvb(formVBWnorm,iprec+4,0)
call appendchr_cvb(formVBWnorm,'.',0)
call appendint_cvb(formVBWnorm,iprec,0)
call appendchr_cvb(formVBWnorm,',a)',0)

! iprec=8 => formChk1='(a,es16.8)'
formChk1 = '(a,es'
call appendint_cvb(formChk1,iprec+8,0)
call appendchr_cvb(formChk1,'.',0)
call appendint_cvb(formChk1,iprec,0)
call appendchr_cvb(formChk1,')',0)
! iprec=8 => formChk2='(5(6x,a,1x))'
lenfld = 8+iprec
ix1 = max(0,min(lenfld-9,6))
ix2 = max(0,lenfld-9-ix1)
formChk2 = '(5('
call appendint_cvb(formChk2,ix1,0)
call appendchr_cvb(formChk2,'x,a,',0)
call appendint_cvb(formChk2,ix2,0)
call appendchr_cvb(formChk2,'x))',0)
! iprec=8 => formChk3='(5es16.8)'
formChk3 = '(5es'
call appendint_cvb(formChk3,iprec+8,0)
call appendchr_cvb(formChk3,'.',0)
call appendint_cvb(formChk3,iprec,0)
call appendchr_cvb(formChk3,')',0)
! iprec=8 => formcvp='(2(a,es16.8))'
formcvp = '(2(a,es'
call appendint_cvb(formcvp,iprec+8,0)
call appendchr_cvb(formcvp,'.',0)
call appendint_cvb(formcvp,iprec,0)
call appendchr_cvb(formcvp,'))',0)
! iprec=8 => formAD='(a,10es16.8)'
formAD = '(a,10es'
call appendint_cvb(formAD,iprec+8,0)
call appendchr_cvb(formAD,'.',0)
call appendint_cvb(formAD,iprec,0)
call appendchr_cvb(formAD,')',0)
! iprec=8 => formAF='(a,10f16.8)'
formAF = '(a,10f'
call appendint_cvb(formAF,iprec+8,0)
call appendchr_cvb(formAF,'.',0)
call appendint_cvb(formAF,iprec,0)
call appendchr_cvb(formAF,')',0)
! iprec=8 => form2AD='(2(a,es16.8))'
form2AD = '(2(a,es'
call appendint_cvb(form2AD,iprec+8,0)
call appendchr_cvb(form2AD,'.',0)
call appendint_cvb(form2AD,iprec,0)
call appendchr_cvb(form2AD,'))',0)
! iprec=8 => form2AF='(2(a,f16.8))'
form2AF = '(2(a,f'
call appendint_cvb(form2AF,iprec+8,0)
call appendchr_cvb(form2AF,'.',0)
call appendint_cvb(form2AF,iprec,0)
call appendchr_cvb(form2AF,'))',0)
! iprec=8 => formroot='(/,a,i3,a,f16.10,a)'
formroot = '(/,a,i3,a,f'
call appendint_cvb(formroot,iprec+8,0)
call appendchr_cvb(formroot,'.',0)
call appendint_cvb(formroot,iprec+2,0)
call appendchr_cvb(formroot,',a)',0)

return

end subroutine formats_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETVEC1(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,
     &                       SCR,LSCR)
C
C     Purpose: read Cholesky vectors IVEC=IVEC1,....,IVEC1+NUMVEC-1
C              of symmetry ISYM from file. The vectors are returned
C              in the "current" reduced set. This routine attempts
C              to minimize gather/scatter operations and uses batched
C              reading to (hopefully) improve buffering.
C
C     NOTE: the scratch array SCR(LSCR) is used to read vectors from
C           disk and should not be smaller than NNBSTR(ISYM,1)+1.
C
      use ChoArr, only: iScr
      use ChoSwp, only: InfVec
#include "implicit.fh"
      DIMENSION CHOVEC(LENVEC,NUMVEC)
      DIMENSION SCR(LSCR)
#include "cholesky.fh"

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_GETVEC1')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

      INTEGER IOFF(0:1)

C     Some initializations.
C     ---------------------

      ILOC  = 3
      IVEC2 = IVEC1 + NUMVEC - 1

      KJUNK = 1
      KSCR  = KJUNK + 1
      LEFT  = LSCR  - KSCR + 1
      IF (LEFT .LE. 0) THEN
         CALL CHO_QUIT('Insufficient scratch space in '//SECNAM,101)
      END IF

      SCR(KJUNK) = 0.0D0
      IOFF(0)    = KJUNK

C     Get reduced sets of first and last vector.
C     ------------------------------------------

      IRED1 = INFVEC(IVEC1,2,ISYM)
      IRED2 = INFVEC(IVEC2,2,ISYM)

C     Loop through reduced sets to be read.
C     -------------------------------------

      KVEC1 = 1
      JVEC1 = IVEC1
      DO IRED = IRED1,IRED2

C        Count vectors in this reduced set.
C        ----------------------------------

         JNUM = 0
         JVEC = JVEC1 - 1
         DO WHILE (JVEC.LT.IVEC2)
            JVEC = JVEC + 1
            JRED = INFVEC(JVEC,2,ISYM)
            IF (JRED .EQ. IRED) THEN
               JNUM = JNUM + 1 ! increase counter
            ELSE
               JVEC = IVEC2 ! break while loop
            END IF
         END DO

C        Skip if this reduced set is empty.
C        ----------------------------------

         IF (JNUM .EQ. 0) GO TO 100

C        Check vector range.
C        -------------------

         IF (LOCDBG) THEN
            JVEC2 = JVEC1 + JNUM - 1
            IF (JVEC2 .GT. IVEC2) THEN
               WRITE(LUPRI,*) SECNAM,': IRED  = ',IRED
               WRITE(LUPRI,*) SECNAM,': JNUM  = ',JNUM
               WRITE(LUPRI,*) SECNAM,': JVEC1 = ',JVEC1
               WRITE(LUPRI,*) SECNAM,': JVEC2 = ',JVEC2
               CALL CHO_QUIT('Vector index error in '//SECNAM,103)
            END IF
         END IF

C        Read reduced set index arrays.
C        ------------------------------

         CALL CHO_GETRED(IRED,ILOC,.FALSE.)
         CALL CHO_SETREDIND(ILOC)

C        If reduced sets are identical, simply read the vectors
C        directly into CHOVEC array and go to next reduced set.
C        ------------------------------------------------------

         IF (NNBSTR(ISYM,3) .EQ. NNBSTR(ISYM,2)) THEN
C           IF (CHO_ADRVEC .EQ. 1) THEN
C              IOPT = 2
C              IADR = INFVEC(JVEC1,3,ISYM)
C              LTOT = NNBSTR(ISYM,2)*JNUM
C              CALL DDAFILE(LUCHO(ISYM),IOPT,CHOVEC(1,KVEC1),LTOT,IADR)
C              NSYS_CALL = NSYS_CALL + 1
C           ELSE IF (CHO_ADRVEC .EQ. 2) THEN
C              IOPT = 2
C              LTOT = NNBSTR(ISYM,2)
C              DO KK = 1,JNUM
C                 IADR = INFVEC(JVEC1+KK-1,3,ISYM)
C                 CALL DDAFILE(LUCHO(ISYM),IOPT,CHOVEC(1,KVEC1+KK-1),
C    &                         LTOT,IADR)
C                 NSYS_CALL = NSYS_CALL + 1
C              END DO
C           ELSE
C              CALL CHO_QUIT('[1] CHO_ADRVEC error in '//SECNAM,102)
C           END IF
C-tbp: replaced above to make use of buffer in cho_vecrd.
            LTOT = NNBSTR(ISYM,2)*JNUM
            JVEC_END = JVEC1 + JNUM - 1
            JNUM_RD = 0
            IREDC = IRED
            MUSED = 0
            CALL CHO_VECRD(CHOVEC(1,KVEC1),LTOT,JVEC1,JVEC_END,ISYM,
     &                     JNUM_RD,IREDC,MUSED)
            IF (JNUM_RD .NE. JNUM) THEN
               CALL CHO_QUIT('Logical error [RD1] in '//SECNAM,103)
            END IF
            NSYS_CALL = NSYS_CALL + 1
            GO TO 100
         END IF

C        Set up batch over vectors to be read.
C        -------------------------------------

         MINL = NNBSTR(ISYM,3)
         IF (MINL .LT. 1) THEN
            NVEC = 0
         ELSE
            NVEC = MIN(LEFT/MINL,JNUM)
         END IF
         IF (NVEC .LT. 1) THEN
            WRITE(LUPRI,*) SECNAM,': insufficient scratch space:'
            WRITE(LUPRI,*) 'LEFT = ',LEFT
            WRITE(LUPRI,*) 'JNUM = ',JNUM
            WRITE(LUPRI,*) 'MINL = ',MINL
            WRITE(LUPRI,*) 'NVEC = ',NVEC
            WRITE(LUPRI,*) 'Input:'
            WRITE(LUPRI,*) 'IVEC1  = ',IVEC1
            WRITE(LUPRI,*) 'NUMVEC = ',NUMVEC
            WRITE(LUPRI,*) 'LENVEC = ',LENVEC
            WRITE(LUPRI,*) 'ISYM   = ',ISYM
            CALL CHO_QUIT('Insufficient scratch space in '//SECNAM,104)
            NBATCH = 0 ! to avoid compiler warnings
         ELSE
            NBATCH = (JNUM - 1)/NVEC + 1
         END IF

C        Set up mapping between reduced sets.
C        ------------------------------------

         CALL CHO_RS2RS(ISCR,SIZE(ISCR),2,3,IRED,ISYM)

C        Start batch loop.
C        -----------------

         DO IBATCH = 1,NBATCH

            IF (IBATCH .EQ. NBATCH) THEN
               NUMV = JNUM - NVEC*(NBATCH - 1)
            ELSE
               NUMV = NVEC
            END IF
            IBVEC1 = JVEC1 + NVEC*(IBATCH - 1)
            KBVEC1 = KVEC1 + NVEC*(IBATCH - 1)

C           Read vectors.
C           -------------

C           IF (CHO_ADRVEC .EQ. 1) THEN
C              IOPT = 2
C              LTOT = NNBSTR(ISYM,3)*NUMV
C              IADR = INFVEC(IBVEC1,3,ISYM)
C              CALL DDAFILE(LUCHO(ISYM),IOPT,SCR(KSCR),LTOT,IADR)
C              NSYS_CALL = NSYS_CALL + 1
C           ELSE IF (CHO_ADRVEC .EQ. 2) THEN
C              IOPT = 2
C              LTOT = NNBSTR(ISYM,3)
C              KTRG = KSCR
C              DO KK = 1,NUMV
C                 IADR = INFVEC(IBVEC1+KK-1,3,ISYM)
C                 CALL DDAFILE(LUCHO(ISYM),IOPT,SCR(KTRG),LTOT,IADR)
C                 KTRG = KTRG + NNBSTR(ISYM,3)
C                 NSYS_CALL = NSYS_CALL + 1
C              END DO
C           ELSE
C              CALL CHO_QUIT('[2] CHO_ADRVEC error in '//SECNAM,102)
C           END IF
C-tbp: replaced above to make use of buffer in cho_vecrd.
            LTOT = NNBSTR(ISYM,3)*NUMV
            JVEC_END = IBVEC1 + NUMV - 1
            JNUM_RD = 0
            IREDC = IRED
            MUSED = 0
            CALL CHO_VECRD(SCR(KSCR),LTOT,IBVEC1,JVEC_END,ISYM,
     &                     JNUM_RD,IREDC,MUSED)
            IF (JNUM_RD .NE. NUMV) THEN
               CALL CHO_QUIT('Logical error [RD2] in '//SECNAM,103)
            END IF
            IF (CHO_ADRVEC .EQ. 1) THEN
               NSYS_CALL = NSYS_CALL + 1
            ELSE IF (CHO_ADRVEC .EQ. 2) THEN
               NSYS_CALL = NSYS_CALL + NUMV
            ELSE
               CALL CHO_QUIT('CHO_ADRVEC error in '//SECNAM,102)
            END IF

C           Copy vectors into result array.
C           -------------------------------

            DO JVEC = 1,NUMV
               KVEC = KBVEC1 + JVEC - 1
               IOFF(1) = IOFF(0) + NNBSTR(ISYM,3)*(JVEC - 1)
               DO IAB = 1,NNBSTR(ISYM,2)
                  KOFF = IOFF(MIN(ISCR(IAB),1)) + ISCR(IAB)
                  CHOVEC(IAB,KVEC) = SCR(KOFF)
               END DO
            END DO

         END DO

C        Set next vector to be treated.
C        ------------------------------

  100    KVEC1 = KVEC1 + JNUM
         JVEC1 = JVEC1 + JNUM

      END DO

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c       this file contains:
c
c       Map4_1342_t3
c       Map4_1423_t3
c       Map4_1243_t3
c       Map4_1432_t3
c       Map4_1324_t3
c
c       Map4_2143_t3
c       Map4_2314_t3
c
c       Map4_3124_t3
c       Map4_3142_t3
c       Map4_3412_t3
c       Map4_3421_t3
c
c       Map4_4123_t3
c       Map4_4312_t3
c
c       Map3_132_t3
c       Map3_213_t3
c       Map3_321_t3
c       Map3_123_t3
c
c       Map2_21_t3
c
c
c       --------------------------------
c
        subroutine Map4_1342_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(1423) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d1,1:d4,1:d2,1:d3)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i3=1,d3
        do i2=1,d2
        do i4=1,d4
        do i1=1,d1
        b(i1,i4,i2,i3)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_1423_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(1342) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d1,1:d3,1:d4,1:d2)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i2=1,d2
        do i4=1,d4
        do i3=1,d3
        do i1=1,d1
        b(i1,i3,i4,i2)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_1243_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(1243) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1*d2,1:d3,1:d4)
        real*8 B(1:d1*d2,1:d4,1:d3)
c
c       help variables
        integer i12,i3,i4
c
        do i3=1,d3
        do i4=1,d4
        do i12=1,d1*d2
        b(i12,i4,i3)=a(i12,i3,i4)
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_1432_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(1432) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d1,1:d4,1:d3,1:d2)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i2=1,d2
        do i3=1,d3
        do i4=1,d4
        do i1=1,d1
        b(i1,i4,i3,i2)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_1324_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(1324) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d1,1:d3,1:d2,1:d4)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i4=1,d4
        do i2=1,d2
        do i3=1,d3
        do i1=1,d1
        b(i1,i3,i2,i4)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_2143_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(2143) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d2,1:d1,1:d4,1:d3)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i3=1,d3
        do i4=1,d4
        do i1=1,d1
        do i2=1,d2
        b(i2,i1,i4,i3)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_2314_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(3124) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d3,1:d1,1:d2,1:d4)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i4=1,d4
        do i2=1,d2
        do i1=1,d1
        do i3=1,d3
        b(i3,i1,i2,i4)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_3124_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(2314) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d2,1:d3,1:d1,1:d4)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i4=1,d4
        do i1=1,d1
        do i3=1,d3
        do i2=1,d2
        b(i2,i3,i1,i4)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_3142_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(2413) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d2,1:d4,1:d1,1:d3)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i3=1,d3
        do i1=1,d1
        do i4=1,d4
        do i2=1,d2
        b(i2,i4,i1,i3)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_3412_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(3412) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d3,1:d4,1:d1,1:d2)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i2=1,d2
        do i1=1,d1
        do i4=1,d4
        do i3=1,d3
        b(i3,i4,i1,i2)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_3421_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(4312) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d4,1:d3,1:d1,1:d2)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i2=1,d2
        do i1=1,d1
        do i3=1,d3
        do i4=1,d4
        b(i4,i3,i1,i2)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_4123_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(2341) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d2,1:d3,1:d4,1:d1)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i1=1,d1
        do i4=1,d4
        do i3=1,d3
        do i2=1,d2
        b(i2,i3,i4,i1)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map4_4312_t3 (A,B,d1,d2,d3,d4)
c
c       this routine do:
c       map B(3421) <- A(1234)
c
        implicit none
        integer d1,d2,d3,d4
        real*8 A(1:d1,1:d2,1:d3,1:d4)
        real*8 B(1:d3,1:d4,1:d2,1:d1)
c
c       help variables
        integer i1,i2,i3,i4
c
        do i1=1,d1
        do i2=1,d2
        do i4=1,d4
        do i3=1,d3
        b(i3,i4,i2,i1)=a(i1,i2,i3,i4)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map3_132_t3 (A,B,d1,d2,d3)
c
c       this routine do:
c       map B(132) <- A(123)
c
        implicit none
        integer d1,d2,d3
        real*8 A(1:d1,1:d2,1:d3)
        real*8 B(1:d1,1:d3,1:d2)
c
c       help variables
        integer i1,i2,i3
c
        do i2=1,d2
        do i3=1,d3
        do i1=1,d1
        b(i1,i3,i2)=a(i1,i2,i3)
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map3_213_t3 (A,B,d1,d2,d3)
c
c       this routine do:
c       map B(213) <- A(123)
c
        implicit none
        integer d1,d2,d3
        real*8 A(1:d1,1:d2,1:d3)
        real*8 B(1:d2,1:d1,1:d3)
c
c       help variables
        integer i1,i2,i3
c
        do i3=1,d3
        do i2=1,d2
        do i1=1,d1
        b(i2,i1,i3)=a(i1,i2,i3)
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map3_321_t3 (A,B,d1,d2,d3)
c
c       this routine do:
c       map B(321) <- A(123)
c
        implicit none
        integer d1,d2,d3
        real*8 A(1:d1,1:d2,1:d3)
        real*8 B(1:d3,1:d2,1:d1)
c
c       help variables
        integer i1,i2,i3
c
        do i1=1,d1
        do i2=1,d2
        do i3=1,d3
        b(i3,i2,i1)=a(i1,i2,i3)
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map3_231_t3 (A,B,d1,d2,d3)
c
c       this routine do:
c       map B(231) <- A(123)
c
        implicit none
        integer d1,d2,d3
        real*8 A(1:d1,1:d2,1:d3)
        real*8 B(1:d2,1:d3,1:d1)
c
c       help variables
        integer i1,i2,i3
c
        do i1=1,d1
        do i2=1,d2
        do i3=1,d3
        b(i2,i3,i1)=a(i1,i2,i3)
        end do
        end do
        end do
c
        return
        end
c
c         --------------------------------
c
        subroutine Map3_312_t3 (A,B,d1,d2,d3)
c
c       this routine do:
c       map B(132) <- A(123)
c
        implicit none
        integer d1,d2,d3
        real*8 A(1:d1,1:d2,1:d3)
        real*8 B(1:d3,1:d1,1:d2)
c
c       help variables
        integer i1,i2,i3
c
        do i2=1,d2
        do i3=1,d3
        do i1=1,d1
        b(i3,i1,i2)=a(i1,i2,i3)
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map3_123_t3 (A,B,d1,d2,d3)
c
c       this routine do:
c       map B(132) <- A(123)
c
        implicit none
        integer d1,d2,d3
        real*8 A(1:d1,1:d2,1:d3)
        real*8 B(1:d1,1:d2,1:d3)
c
c       help variables
        integer i1,i2,i3
c
        do i3=1,d3
        do i2=1,d2
        do i1=1,d1
        b(i1,i2,i3)=a(i1,i2,i3)
        end do
        end do
        end do
c
        return
        end
c
c       --------------------------------
c
        subroutine Map2_21_t3 (A,B,d1,d2)
c
c       this routine do:
c       map B(21) <- A(12)
c
        implicit none
        integer d1,d2
        real*8 A(1:d1,1:d2)
        real*8 B(1:d2,1:d1)
c
c       help variables
        integer i1,i2
c
        do i1=1,d1
        do i2=1,d2
        b(i2,i1)=a(i1,i2)
        end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Rulin Feng                                       *
!***********************************************************************

!****************************************************
!                    Do SO-NTO
!****************************************************
! This routine is made to prepare the transition density
! This routine is modified from do_sonatorb.
! matrices, transition spin density matrices.
! In the future, this may include antisymmetric, transition
! densities. Namely the keyword antisin or antitrip
!
!                                               -RF 8/18,2021
subroutine DO_SONTO(NSS,USOR,USOI)

use rassi_global_arrays, only: EIGVEC, JBNUM
use rassi_data, only: NBST
use Cntrl, only: MLTPLT, NOSO, NSTATE, SONTO, SONTOSTATES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSS
real(kind=wp), intent(in) :: USOR(NSS,NSS), USOI(NSS,NSS)
integer(kind=iwp) :: I, INTOSTATE, IOPT, ISS, ISTATE, JNTOSTATE, JOB1, JOB2, JSS, JSTATE, MPLET1, MPLET2, MSPROJ1, MSPROJ2
real(kind=wp) :: IDENTMAT(3,3)
real(kind=wp), allocatable :: ANTSIN(:), TDMAO(:), TSDMAO(:), UMATI(:), UMATR(:), VMAT(:,:)

! Calculates natural orbitals, including spinorbit effects
write(u6,*)
write(u6,*)
write(u6,*) '*****************************************'
write(u6,*) '* RUNNING SONTO CODE ********************'
write(u6,*) '*****************************************'
write(u6,*)

call unitmat(IDENTMAT,3)

call mma_allocate(UMATR,NSS**2,Label='UMATR')
call mma_allocate(UMATI,NSS**2,Label='UMATI')
call mma_allocate(VMAT,NSS,NSS,Label='VMAT')

VMAT(:,:) = Zero

! transform V matrix in SF basis to spin basis
! This was taken from smmat and modified slightly
ISS = 0
do ISTATE=1,NSTATE
  JOB1 = JBNUM(ISTATE)
  MPLET1 = MLTPLT(JOB1)
  !S1 = Half*real(MPLET1-1,kind=wp)

  do MSPROJ1=-MPLET1+1,MPLET1-1,2
    !SM1 = Half*real(MSPROJ1,kind=wp)
    ISS = ISS+1
    JSS = 0

    do JSTATE=1,NSTATE
      JOB2 = JBNUM(JSTATE)
      MPLET2 = MLTPLT(JOB2)
      !S2 = Half*real(MPLET2-1,kind=wp)

      do MSPROJ2=-MPLET2+1,MPLET2-1,2
        !SM2 = Half*real(MSPROJ2,kind=wp)
        JSS = JSS+1

        if ((MPLET1 == MPLET2) .and. (MSPROJ1 == MSPROJ2)) VMAT(ISS,JSS) = EIGVEC(JSTATE,ISTATE)
      end do
    end do
  end do
end do

if (.not. NOSO) then
  ! combine this matrix with the SO eigenvector matrices
  call DGEMM_('N','N',NSS,NSS,NSS,One,VMAT,NSS,USOR,NSS,Zero,UMATR,NSS)
  call DGEMM_('N','N',NSS,NSS,NSS,One,VMAT,NSS,USOI,NSS,Zero,UMATI,NSS)
else
  ! Spinorbit contributions to this are disabled
  UMATR(:) = pack(VMAT(:,:),.true.)
  UMATI(:) = Zero
end if

! SONTONSTATE = number of state pairs to calculate.
! These states are stored as pairs beginning in SONTO
do I=1,SONTOSTATES
  INTOSTATE = SONTO(1,I)
  JNTOSTATE = SONTO(2,I)
  write(u6,*)
  write(u6,*) 'CALCULATING SO-NTOs BETWEEN SO STATES: ',INTOSTATE,JNTOSTATE
  if ((INTOSTATE > NSS) .or. (INTOSTATE <= 0) .or. (JNTOSTATE > NSS) .or. (JNTOSTATE <= 0)) then
    write(u6,*) '...WHICH DOES NOT EXIST!'
    call ABEND()
  end if
  write(u6,*)
  iOpt = 0
  ! Currently only HERMISING TDMs are dealt with here
  call mma_allocate(TDMAO,6*NBST**2,Label='TDMAO')
  call mma_allocate(TSDMAO,6*NBST**2,Label='TSDMAO')
  call mma_allocate(ANTSIN,6*NBST**2,Label='ANTSIN')
  ! Initialization is important
  TDMAO(:) = Zero
  TSDMAO(:) = Zero
  ANTSIN(:) = Zero

  call MAKETDMAO('HERMSING',UMATR,UMATI,INTOSTATE,JNTOSTATE,NSS,iOpt,IDENTMAT,TDMAO)
  ! Following codes are left for other types of SO-TDMs
  !call print_matrixt('TDM after MAKETDMAO 1',nbst,nbst**2,1,TDMAO)
  !call MAKETDMAO('HERMTRIP',UMATR,UMATI,INTOSTATE,JNTOSTATE,NSS,iOpt,IDENTMAT,TSDMAO,NBST)
  !call print_matrixt('TSDM after MAKETDMAO 1',nbst,nbst**2,1,TSDMAO)
  !call MAKETDMAO('ANTISING',UMATR,UMATI,INTOSTATE,JNTOSTATE,NSS,iOpt,IDENTMAT,ANTSIN,NBST)
  !call print_matrixt('ANTITDM after MAKETDMAO 1',nbst,nbst**2,1,ANTSIN)
  call DO_AOTDMNTO(TDMAO,TSDMAO,ANTSIN,INTOSTATE,JNTOSTATE,NBST,NBST**2)
  call mma_deallocate(TDMAO)
  call mma_deallocate(TSDMAO)
  call mma_deallocate(ANTSIN)
end do
call mma_deallocate(UMATR)
call mma_deallocate(UMATI)
call mma_deallocate(VMAT)
call mma_deallocate(SONTO)

end subroutine DO_SONTO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine Util1(Alpha,Beta,nZeta,Final,la,lb,
     *                 Slaplb,Slamlb,Slalbp,Slalbm)
************************************************************************
*                                                                      *
* Object: to assemble the electric field integrals from                *
*         derivative integrals of the electric potential.              *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             February '91                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8  Final(nZeta,3,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2),
     *        Slaplb(nZeta,(la+2)*(la+3)/2,(lb+1)*(lb+2)/2),
     *        Slamlb(nZeta,(la)*(la+1)/2,(lb+1)*(lb+2)/2),
     *        Slalbp(nZeta,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2),
     *        Slalbm(nZeta,(la+1)*(la+2)/2,(lb)*(lb+1)/2),
     *        Alpha(nZeta), Beta(nZeta)
      Character*80 Label
*
*     Statement function for cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
      nElem(ix) = (ix+1)*(ix+2)/2
*
      iRout = 203
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
          Write (6,*) ' In Util1 la,lb=',la,lb
          Call RecPrt('Alpha',' ',Alpha,nZeta,1)
          Call RecPrt('Beta',' ',Beta,nZeta,1)
          Do 200 ib = 1, nElem(lb)
             Write (Label,'(A,I2,A)') ' Slaplb(la,',ib,')'
             Call RecPrt(Label,' ',Slaplb(1,1,ib),nZeta,nElem(la+1))
200       Continue
          If (la.gt.0) Then
             Do 201 ib = 1, nElem(lb)
                Write (Label,'(A,I2,A)') ' Slamlb(la,',ib,')'
                Call RecPrt(Label,' ',Slamlb(1,1,ib),nZeta,nElem(la-1))
201          Continue
          End If
          Do 300 ib = 1, nElem(lb+1)
             Write (Label,'(A,I2,A)') ' Slalbp(la,',ib,')'
             Call RecPrt(Label,' ',Slalbp(1,1,ib),nZeta,nElem(la))
300       Continue
          If (lb.gt.0) Then
             Do 301 ib = 1, nElem(lb-1)
                Write (Label,'(A,I2,A)') ' Slalbm(la,',ib,')'
                Call RecPrt(Label,' ',Slalbm(1,1,ib),nZeta,nElem(la))
301          Continue
          End If
      End If
*
      Do 10 ixa = la, 0, -1
         Do 11 iya = la-ixa, 0, -1
            iza = la-ixa-iya
            ipa = Ind(la,ixa,iza)
*
      Do 20 ixb = lb, 0, -1
         Do 21 iyb = lb-ixb, 0, -1
            izb = lb-ixb-iyb
            ipb = Ind(lb,ixb,izb)
*
            If (ixa.eq.0 .and. ixb.eq.0) Then
*
            Do 33 iZeta = 1, nZeta
               Final(iZeta,1,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa+1,iza),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb))
33          Continue
*
            Else If (ixa.eq.0) Then
*
            Do 32 iZeta = 1, nZeta
               Final(iZeta,1,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa+1,iza),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb))
     *          -Dble(ixb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb))
32          Continue
*
            Else If (ixb.eq.0) Then
*
            Do 31 iZeta = 1, nZeta
               Final(iZeta,1,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa+1,iza),ipb)
     *          -Dble(ixa)*Slamlb(iZeta,Ind(la-1,ixa-1,iza),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb))
31          Continue
*
            Else
*
            Do 30 iZeta = 1, nZeta
               Final(iZeta,1,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa+1,iza),ipb)
     *          -Dble(ixa)*Slamlb(iZeta,Ind(la-1,ixa-1,iza),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb))
     *          -Dble(ixb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb))
30          Continue
*
            End If
*
            If (iya.eq.0 .and. iyb.eq.0) Then
*
            Do 63 iZeta = 1, nZeta
               Final(iZeta,2,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa,iza),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb))
63          Continue
*
            Else If (iya.eq.0) Then
*
            Do 62 iZeta = 1, nZeta
               Final(iZeta,2,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa,iza),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb))
     *          -Dble(iyb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb))
62          Continue
*
            Else If (iyb.eq.0) Then
*
            Do 61 iZeta = 1, nZeta
               Final(iZeta,2,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa,iza),ipb)
     *          -Dble(iya)*Slamlb(iZeta,Ind(la-1,ixa,iza),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb))
61          Continue
*
            Else
*
            Do 60 iZeta = 1, nZeta
               Final(iZeta,2,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa,iza),ipb)
     *          -Dble(iya)*Slamlb(iZeta,Ind(la-1,ixa,iza),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb))
     *          -Dble(iyb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb))
60          Continue
*
            End If
*
            If (iza.eq.0 .and. izb.eq.0) Then
*
            Do 93 iZeta = 1, nZeta
               Final(iZeta,3,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa,iza+1),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1))
93          Continue
*
            Else If (iza.eq.0) Then
*
            Do 92 iZeta = 1, nZeta
               Final(iZeta,3,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa,iza+1),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1))
     *          -Dble(izb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1))
92          Continue
*
            Else If (izb.eq.0) Then
*
            Do 91 iZeta = 1, nZeta
               Final(iZeta,3,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa,iza+1),ipb)
     *          -Dble(iza)*Slamlb(iZeta,Ind(la-1,ixa,iza-1),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1))
91          Continue
*
            Else
*
            Do 90 iZeta = 1, nZeta
               Final(iZeta,3,ipa,ipb) =
     *           Two*Alpha(iZeta)*Slaplb(iZeta,Ind(la+1,ixa,iza+1),ipb)
     *          -Dble(iza)*Slamlb(iZeta,Ind(la-1,ixa,iza-1),ipb)
     *          +Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1))
     *          -Dble(izb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1))
90          Continue
*
            End If
*
21       Continue
20    Continue
*
11       Continue
10    Continue
*
      If (iPrint.ge.49) Then
          Write (6,*) ' In Util1 la,lb=',la,lb
          Do 400 iElem = 1, nElem(la)
             Do 410 jElem = 1, nElem(lb)
                Write (Label,'(A,I2,A,I2,A)')
     *                ' Final (',iElem,',',jElem,') '
                Call RecPrt(Label,' ',Final(1,1,iElem,jElem),nZeta,3)
410          Continue
400       Continue
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_DecChk(irc,iSym,Col,nDim,nCol,Wrk,lWrk,ErrStat)
!
! Thomas Bondo Pedersen, Jan. 2008.
!
! Purpose: check Cholesky decomposition of the (ai|bj) integrals
!          or MP2 amplitudes (sym. block iSym).
!          The columns of the matrix are
!          compared nCol columns at a time. This
!          implies that the memory requirement of this routine
!          should be limited to approximately that of the
!          decomposition itself. Note, however, that since all
!          integrals are computed, this routine will consume
!          significantly more CPU time.
!          Files are assumed open.
!          On exit,
!          ErrStat(1) = min error
!          ErrStat(2) = max error
!          ErrStat(3) = rms error

use ChoMP2, only: iOption_MP2CD
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iSym, nDim, nCol, lWrk
real(kind=wp), intent(inout) :: Col(nDim,nCol)
real(kind=wp), intent(out) :: Wrk(lWrk), ErrStat(3)
character(len=*), parameter :: SecNam = 'ChoMP2_DecChk'

if (iOption_MP2CD == 1) then ! (ai|bj) int
  call ChoMP2_DecChk_1(irc,iSym,Col,nDim,nCol,Wrk,lWrk,ErrStat)
else if (iOption_MP2CD == 2) then ! MP2 amp
  call ChoMP2_DecChk_2(irc,iSym,Col,nDim,nCol,Wrk,lWrk,ErrStat)
else
  write(u6,*) SecNam,': WARNING! Unknown option, iOption_MP2CD = ',iOption_MP2CD
  irc = -123456
end if

end subroutine ChoMP2_DecChk

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine Precaaa_Pre(ActInt,A_J,Scr)

use MCLR_Data, only: nA
use input_mclr, only: nAsh, nBas, nIsh, nSym, ntAsh
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(out) :: ActInt(ntAsh,ntAsh,ntAsh,ntAsh)
real(kind=wp), intent(_OUT_) :: A_J(*), Scr(*)
integer(kind=iwp) :: iA, iAabs, iAtot, iB, iBabs, iBtot, iC, iCabs, iCtot, iD, iDabs, iDtot, iSym, jSym
real(kind=wp) :: Val

do iSym=1,nSym
  do iA=1,nAsh(iSym)
    iAabs = iA+nA(iSym)
    iAtot = iA+nIsh(iSym)
    do iB=1,nAsh(iSym) ! iA
      iBabs = iB+nA(iSym)
      iBtot = iB+nIsh(iSym)
      do jSym=1,iSym
        call Coul(iSym,iSym,jSym,jSym,iAtot,iBtot,A_J,Scr)
        do iC=1,nAsh(jSym)
          iCabs = iC+nA(jSym)
          iCtot = iC+nIsh(jSym)
          do iD=1,nAsh(jSym) ! iC
            iDabs = iD+nA(jSym)
            iDtot = iD+nIsh(jSym)
            Val = A_J(iCtot+nBas(jSym)*(iDtot-1))
            ActInt(iAabs,iBabs,iCabs,iDabs) = Val
            !ActInt(iBabs,iAabs,iCabs,iDabs) = Val
            !ActInt(iAabs,iBabs,iDabs,iCabs) = Val
            !ActInt(iBabs,iAabs,iDabs,iCabs) = Val
            !ActInt(iCabs,iDabs,iAabs,iBabs) = Val
            !ActInt(iCabs,iDabs,iBabs,iAabs) = Val
            !ActInt(iDabs,iCabs,iAabs,iBabs) = Val
            !ActInt(iDabs,iCabs,iBabs,iAabs) = Val
          end do
        end do
      end do
    end do
  end do
end do

end subroutine Precaaa_Pre

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Step4(SMatrix,nDim,TMatrix,iType)
! Step 4. LW S3 ->S4

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, iType(nDim)
real(kind=wp), intent(inout) :: SMatrix(nDim,nDim)
real(kind=wp), intent(out) :: TMatrix(nDim,nDim)
integer(kind=iwp) :: i, j

!lg  write(u6,*) 'Step 4', nDim
!lg  call RecPrt('T before LW 4',' ',TMatrix,nDim,nDim)
!lg  call RecPrt('S in step4 ',' ',SMatrix,nDim,nDim)
!lg  write(u6,*)
do i=1,nDim
  do j=1,nDim
    if ((i /= j) .and. (iType(i) /= iType(j))) then
      SMatrix(j,i) = Zero
    end if
  end do
end do
!lg call RecPrt('S before LW 4',' ',SMatrix,nDim,nDim)

TMatrix(:,:) = Zero
call dcopy_(nDim,[One],0,TMatrix,nDim+1)
call Lowdin_LP(SMatrix,TMatrix,nDim)

return

end subroutine Step4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DistMemSum (NvGrp,maxdim,
     c        PossV1,PossV2,PossV3,
     c        PossH1,PossH2,
     c        PossT)

c
c       This routine do:
c       define initial possitions of V and H
c       used in summary routine
c

        implicit none
#include "chcc1.fh"
c
        integer NvGrp,maxdim
        integer PossV1,PossV2,PossV3
        integer PossH1,PossH2
        integer PossT
c
c
c       help variables
        integer length
c
c
c1        V files
c
        length=no*no*maxdim*maxdim
        PossV1=possT
        PossT=PossT+length
        PossV2=possT
        PossT=PossT+length
        PossV3=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,99) 'DM V ',PossV1,PossV2,PossV3,length
        end if
c
c
c2        H files
c
        length=no*maxdim
        PossH1=possT
        PossT=PossT+length
        PossH2=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,99) 'DM H ',PossH1,PossH2,PossV3,length
        end if
c
c
99      format (a7,10(i10,1x))
c
        if (printkey.ge.10) then
        write (6,99) 'PossT ',PossT
        end if
c
        return
c Avoid unused argument warnings
        if (.false.) Call Unused_integer(NvGrp)
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine CmbnMP(Rnxyz,nZeta,la,lb,lr,Zeta,rKappa,rFinal,nComp)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, lr, nComp
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la,0:lb,0:lr), Zeta(nZeta), rKappa(nZeta)
real(kind=wp), intent(inout) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nComp)
integer(kind=iwp) :: iComp, ipa, ipb, ix, ixa, ixb, iy, iya, iyaMax, iyb, iybMax, iz, iza, izb

do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)
        !if (iPrint >= 99) then
        !  write(u6,*) ixa,iya,iza,ixb,iyb,izb
        !  write(u6,*) ipa,ipb
        !end if

        ! Combine multipole moment integrals

        iComp = 0
        do ix=lr,0,-1
          do iy=lr-ix,0,-1
            iz = lr-ix-iy
            iComp = iComp+1
            !write(u6,*) ix,iy,iz,iComp
            rFinal(:,ipa,ipb,iComp) = rKappa(:)/sqrt(Zeta(:)**3)*Rnxyz(:,1,ixa,ixb,ix)*Rnxyz(:,2,iya,iyb,iy)*Rnxyz(:,3,iza,izb,iz)
          end do
        end do

      end do
    end do
  end do
end do

return

end subroutine CmbnMP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Set_Basis_Mode(Label)
#include "Basis_Mode.fh"
      Character*(*) Label
      Character*7 Lbl
*
      Atomic=.False.
      kCnttp=0
      Lbl=Label(1:7)
      Call UpCase(Lbl)
      If (Lbl.eq.'VALENCE') Then
         Basis_Mode = Valence_Mode
      Else If (Lbl.eq.'AUXILIA') Then
         Basis_Mode = Auxiliary_Mode
      Else If (Lbl.eq.'FRAGMEN') Then
         Basis_Mode = Fragment_Mode
      Else If (Lbl.eq.'WITHAUX') Then
         Basis_Mode = With_Auxiliary_Mode
      Else If (Lbl.eq.'WITHFRA') Then
         Basis_Mode = With_Fragment_Mode
      Else If (Lbl.eq.'ALL    ') Then
         Basis_Mode = All_Mode
      Else
         Call WarningMessage(2,'Set_Basis_Mode: illegal mode,'//
     &               'Label='//Lbl)
         Call Abend()
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WelMmG(nHer,MmWelG,la,lb,lr)
*
      nElem(i) = (i+1)*(i+2)/2
*
      k = la+lb+1
      jsum = 1
      Do 10 i = 1, k
         jsum = jsum + 3**i
 10   Continue
      nHer=1
      MmWelG = 2*jsum +Max((k+1)*(k/2+1)*(k/4+1)+1,
     &                   9+3**k,
     &                   5)
*
*---- Add memory for contributions to the derivative
*
      MmWelG = MmWelG + nElem(la+1)*nElem(lb)
      If (la.ge.1) MmWelG = MmWelG + nElem(la-1)*nElem(lb)
      MmWelG = MmWelG + nElem(la)*nElem(lb+1)
      If (lb.ge.1) MmWelG = MmWelG + nElem(la)*nElem(lb-1)
      MmWelG = MmWelG + 2
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lr)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine bufio_wrbuf_cvb()
      implicit real*8 (a-h,o-z)
#include "bufio_cvb.fh"
#include "idbl_cvb.fh"

      call bufio_wrbuf_internal(ibuffer)
      return

      entry bufio_wrzbuf_cvb()
      call bufio_wrzbuf_internal(izbuffer)
      return

      entry bufio_rdbuf_cvb()
      call bufio_rdbuf_internal(ibuffer)
      return
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine bufio_wrbuf_internal(ibuffer)
      use iso_c_binding
      integer, target :: ibuffer(*)
      real*8, pointer :: buffer(:)
      if(ibuf.eq.0)return

      ioffset=(ibuf-1)*lbuf/idbl
      call c_f_pointer(c_loc(ibuffer(1)),buffer,[nword])
      call wrlow_cvb(buffer,nword,file_id,ioffset+1)
      nullify(buffer)
      if(ibuf.gt.nbuf)then
        nbuf=ibuf
      endif
      return
      end subroutine bufio_wrbuf_internal
      subroutine bufio_wrzbuf_internal(izbuffer)
      use iso_c_binding
      integer, target :: izbuffer(*)
      real*8, pointer :: buffer(:)
      if(ibuf.eq.0)return

      ioffset=(ibuf-1)*lbuf/idbl
      call c_f_pointer(c_loc(izbuffer(1)),buffer,[nword])
      call wrlow_cvb(buffer,nword,file_id,ioffset+1)
      nullify(buffer)
      if(ibuf.gt.nbuf)then
        nbuf=ibuf
      endif
      return
      end subroutine bufio_wrzbuf_internal
      subroutine bufio_rdbuf_internal(ibuffer)
      use iso_c_binding
      integer, target :: ibuffer(*)
      real*8, pointer :: buffer(:)
      if(nbuf.lt.ibuf)then
        call izero(ibuffer,lbuf)
        return
      endif
      ioffset=(ibuf-1)*lbuf/idbl
      call c_f_pointer(c_loc(ibuffer(1)),buffer,[nword])
      call rdlow_cvb(buffer,nword,file_id,ioffset+1)
      nullify(buffer)
      return
      end subroutine bufio_rdbuf_internal
*
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NYPART(iExtra,nPart,COORD,Rstart,nCent,iSeed)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "warnings.fh"

      DIMENSION COORD(MxCen*MxPut,3)
      External Ranf

*Preparing some numbers
      iMAXVAR=100*iExtra**2
      IN=1
      IVARV=0
      RLIM=RSTART-8.5d0
      rlm=rlim*2.
      RLIM2=RLIM**2
*Check if not all molecules been put out in reasonable time
 100  IF(IVARV.GE.iMAXVAR) Then
        Write(6,*)'Failure to add particles. Try to increase the dielec'
     &//'tric radie or change the random seed.'
        Call Quit(_RC_GENERAL_ERROR_)
      EndIf
*Here is the random change relative the first user definied water
      DX=ranf(iseed)*RLM-rlim
      DY=ranf(iseed)*RLM-rlim
      DZ=ranf(iseed)*RLM-rlim
      DR=DX*DX+DY*DY+DZ*DZ
      IVARV=IVARV+1
      IF(DR.GT.RLIM2)GO TO 100
      IND=IN+NPART
      X=DX+COORD(1,1)
      Y=DY+COORD(1,2)
      Z=DZ+COORD(1,3)
*Check so that two water molecules do not come too close...
      DO 10 I=1,IND*NCENT,NCENT
        R2=(COORD(I,1)-X)**2+(COORD(I,2)-Y)**2+(COORD(I,3)-Z)**2
        IF(R2.LT.60d0)Go To 100
10    CONTINUE
*...and if they do not then shove its coordinates in variable
      IN=IN+1
      IA=(IN+NPART-1)*NCENT
      DO 20 I=1,NCENT
        COORD(IA+I,1)=COORD(I,1)+DX
        COORD(IA+I,2)=COORD(I,2)+DY
        COORD(IA+I,3)=COORD(I,3)+DZ
20    Continue
*Check if all water molecules have been put where they should
      IF(IN.LT.(IEXTRA)) GO TO 100
*Give nPart its new value and exit gracefully
      NPART=NPART+IEXTRA
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Qmstat(ireturn)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension Coord(MxAt*3)
      Dimension nBas(1),nBas_C(1),nCnC_C(MxBasC)
*******JoseMEP New variables to perform the MEP calculation
      Dimension Eint(MxQCen,10),Poli(MxQCen,10)
      Dimension SumElcPot(MxQCen,10)
      Dimension PertElcInt(MxBas*(MxBas+1)/2)
      Dimension nOcc(MxBas),natyp(MxAt)
      Character Labjhr*4
****************
      Logical  Is_Real_Par
      External Is_Real_Par

*
*-- The journey begins. Set non-zero return code.
*
      ireturn=99

*
*-- If parallel compilation, terminate, but gracefully.
*
#ifdef _MOLCAS_MPP_
      If (Is_Real_Par()) Then
        Write(6,*)
        Write(6,*)' QMStat does not run in parallel!'
        Write(6,*)
        Call Quit(_RC_NOT_AVAILABLE_)
      End If
#endif

*
*-- Set defaults, zeros and initial values.
*
      Call Qmstat_init

*
*-- Make discrete banner.
*

*
*-- Read ('process') input. To do that we need the number of atoms in
*   the QM-region, therefore that initial call to the RUNFILE.
*
      Call Get_iScalar('Unique atoms',iQ_Atoms)
      Call Get_Qmstat_Input(iQ_Atoms)

*
*-- If only the startfile is to be edited or the sampfile analyzed,
*   go here, then terminate.
*
      If(EdSt) then
        Call EditStart
        Go To 666
      Endif
      If(Anal) then
        Call Analyze_Q(iQ_Atoms)
        Go To 666
      Endif

*
*-- Read in orbitals, basis functions, integrals and bla bla bla. This
*   is the centre for communicating with the rest of Molcas.
*
*******JoseMEP*** Qfread is called with more variables to the MEP calculation
      Call Qfread(iQ_Atoms,nAtomsCC,Coord,nBas,nBas_C,nCnC_C
     &,nOcc,natyp,nntyp)
********

*
*-- The turning point for the single-point calculation.
*
      nCalls=0
3333  Continue

*
*-- If user request a set of single point calcualtions, then go in to
*   a separate routine and do a 'reintrepreation' of the input.
*
      If(SingPoint) Call SingP(nCalls,iQ_Atoms,ipStoreCoo,nPart2)

*
*-- Decide which type of calculation we are to run. At this stage only
*   QM equilibration and QM production is available. Should probably
*   be so in the future, hence all-classical should be removed
*   at some stage. Also, ordinary sampfile analysis is performed
*   seperately.
*
      If(Smeq.or.Smprod) then
        Write(6,*)
        Write(6,*)'All classical simulation is currently not available.'
        Call Quit(_RC_GENERAL_ERROR_)
      Elseif(Qmeq.or.Qmprod) then  !Qmeq=.true. is default option.
        If(QmType(1:3).eq.'SCF') then
          Call EqScf(iQ_Atoms,nAtomsCC,Coord,nBas,nBas_C,nCnC_C
     &              ,iSupDeAll,iV1DeAll)
        Elseif(QmType(1:4).eq.'RASS') then
          Call EqRas(iQ_Atoms,nAtomsCC,Coord,nBas,nBas_C,nCnC_C
     &              ,iBigDeAll,nSizeBig,ip,nRM)
        Endif
      Endif
*
*********JoseMEP
* If MEP option true. Calculate the Interaction energy coming from the
* Interaction with Mean Elec. Potential, Field and Field-Gradient
* E=q*Pot-dipol*field+quad*field-grad
* Also is included the non_Electr perturbation
* For a quantum AO i nonE=d*Sum_k <Xi|Chi_k>*Sum_k <Xi|Chi_k>*E_k
* These Energies are added to the SEWARD One-electron file
* as a perturbation to the One-e Hamiltoniam
*
      If(lExtr(8)) then
        Labjhr='Pert'
        Call AverMEP(Labjhr,Eint,Poli,iCi,SumElcPot
     &               ,NCountField,PertElcInt
     &               ,iQ_Atoms,nBas(1),nOcc(1),natyp(1),nntyp)
      Endif
*********
*
*-- If we are doing single point calculations, then jump back up.
*
      If(SingPoint) then
        If(nCalls.lt.nPart2) then
          Write(6,*)
          Write(6,*)
          Write(6,*)
          Write(6,*)'     *********** << NEW CALCULATION >> ***********'
          Write(6,'(A,I3,A)')'Single point-calculation nr.',nCalls+1,' '
     &//'follows below.'
          Write(6,*)
          Write(6,*)
          Go To 3333
        Else
          Call GetMem('Store','Free','Real',ipStoreCoo,nPart2*nCent*3)
          Write(6,*)
          Write(6,*)
          Write(6,*)' Single-point calculation ended.'
          Write(6,*)
        Endif
      Endif

*
*-- Deallocations of stuff from qfread to simulations. These are unique
*   for the QM-method.
*
      If(QmType(1:4).eq.'RASS') then
        Call GetMem('ALLES','Free','Real',iBigDeAll,nSizeBig)
        If(MoAveRed) then
          Call GetMem('UncleMoe','Free','Real',ip,nBas(1)*nRM)
        Endif
      Elseif(QmType(1:3).eq.'SCF') then
        nS=iOrb(1)*(iOrb(1)+1)/2
        Call GetMem('SUPER','Free','Real',iSupDeAll,nS**2)
        Call GetMem('OrbCoeffQ','Free','Real',iV1DeAll,iOrb(1)*nBas(1))
      Endif

*
*-- Exit
*
666   Continue

      ireturn=0

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Sorb2CMOs(CMO,nCMO,nD,Occ,nnB,nBas,nOrb,nSym,OrbType)
      Implicit Real*8 (a-h,o-z)
      Real*8 CMO(nCMO,nD), Occ(nnB,nD)
      Integer nBas(nSym), nOrb(nSym), OrbType(nnB,nD)
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Do iD = 1, nD
         iOff=1
         jOff=1
         Do iSym = 1, nSym
            Call RecPrt('Occ','(10F6.2)',Occ(iOff,iD),1,nOrb(iSym))
            Call RecPrt('CMO','(10F6.2)',CMO(jOff,iD),
     &                  nBas(iSym),nOrb(iSym))
            iOff = iOff + nOrb(iSym)
            jOff = jOff + nBas(iSym)*nOrb(iSym)
         End Do
      End Do
#endif
*
*     Sort orbitals into
*     1) occupied and virtual orbitals
*     2) within each block sort according to the orbital energy
*
      Do iD = 1, nD
*        Write (6,*)
*        Write (6,*) 'iD=',iD
*        Write (6,*)
         iOff1= 0
         iOff2= 1
         Do iSym = 1, nSym
*
            nOcc = 0
*
*           Sort first the orbitals according to the occupation numbers.
*
            Do iOrb = 1, nOrb(iSym)-1
*
               Occ_i = Occ(iOff1+iOrb,iD)
*              Write (6,*) 'Occ_i,iOrb=',Occ_i,iOrb
               kOrb = 0
               Do jOrb = iOrb + 1, nOrb(iSym)
                  Occ_j = Occ(iOff1+jOrb,iD)
*                 Write (6,*) 'Occ_j,jOrb=',Occ_j,jOrb
                  If (Occ_i==0.0D0 .and.
     &                Occ_j.gt.Occ_i) Then
                     Occ_i=Occ_j
                     kOrb = jOrb
                  End If
               End Do
*              Write (6,*) 'kOrb=',kOrb
               If (kOrb.ne.0) Then
                  iTmp=OrbType(iOff1+iOrb,iD)
                  OrbType(iOff1+iOrb,iD)=OrbType(iOff1+kOrb,iD)
                  OrbType(iOff1+kOrb,iD)=iTmp
*
                  Occ_i = Occ(iOff1+iOrb,iD)
                  Occ(iOff1+iOrb,iD)=Occ(iOff1+kOrb,iD)
                  Occ(iOff1+kOrb,iD)=Occ_i
                  Call DSwap_(nBas(iSym),
     &                        CMO(iOff2+(iOrb-1)*nBas(iSym),iD),1,
     &                        CMO(iOff2+(kOrb-1)*nBas(iSym),iD),1)
               End If
*
               If (Occ(iOff1+iOrb,iD).ne.0.0D0) nOcc = nOcc + 1
*
            End Do
*
            iOff1 = iOff1 + nOrb(iSym)
            iOff2 = iOff2 + nBas(iSym)*nOrb(iSym)
         End Do        ! iSym
      End Do           ! iD
#ifdef _DEBUGPRINT_
      Do iD = 1, nD
         iOff=1
         jOff=1
         Do iSym = 1, nSym
            Call RecPrt('Occ','(10F6.2)',Occ(iOff,iD),1,nOrb(iSym))
            Call RecPrt('CMO','(10F6.2)',CMO(jOff,iD),
     &                  nBas(iSym),nOrb(iSym))
            iOff = iOff + nOrb(iSym)
            jOff = jOff + nBas(iSym)*nOrb(iSym)
         End Do
      End Do
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pa_sort(a,n)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n
integer(kind=iwp), intent(inout) :: a(n)
integer(kind=iwp) :: k, l, temp

do k=1,n-1
  do l=k+1,n
    if (a(k) > a(l)) then
      temp = a(k)
      a(k) = a(l)
      a(l) = temp
    end if
  end do
end do

return

end subroutine pa_sort

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DispEnergy(EEDisp,BoMaH,BoMaO,dAtO1,dAtH1,dAtH2
     &                     ,Rab13i,Rab23i,Rab33i,indQAt)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"

      Dimension BoMaH(MxAt),BoMaO(MxAt)
      Dimension DampBarn(3)

*
*--- If Damping, do it, otherwise easy stuff
*
      If(DispDamp) then
*
*--- Get the damping, for the relevant QM-atom with all solvent
*    atoms.
*
        kFac=1
        DampBarn(1)=1.0d0
        Do 661, k=1,6
          kFac=kFac*k
          DampBarn(1)=DampBarn(1)+(BoMaH(indQAt)*dAtH1)**k/dble(kFac)
661     Continue
        DampBarn(1)=1.0d0-DampBarn(1)*exp(-BoMaH(indQAt)*dAtH1)

        kFac=1
        DampBarn(2)=1.0d0
        Do 662, k=1,6
          kFac=kFac*k
          DampBarn(2)=DampBarn(2)+(BoMaH(indQAt)*dAtH2)**k/dble(kFac)
662     Continue
        DampBarn(2)=1.0d0-DampBarn(2)*exp(-BoMaH(indQAt)*dAtH2)

        kFac=1
        DampBarn(3)=1.0d0
        Do 663, k=1,6
          kFac=kFac*k
          DampBarn(3)=DampBarn(3)+(BoMaO(indQAt)*dAtO1)**k/dble(kFac)
663     Continue
        DampBarn(3)=1.0d0-DampBarn(3)*exp(-BoMaO(indQAt)*dAtO1)

*
*--- If not damping, set factors to 1.0d0
*
      Else
        DampBarn(1)=1.0d0
        DampBarn(2)=1.0d0
        DampBarn(3)=1.0d0
      Endif

*
*--- Now evaluate the Dispersion energy.
*
      EfromO1=Rab13i**2*DampBarn(3)*uDisp(indQAt,1)
      EfromH1=Rab23i**2*DampBarn(1)*uDisp(indQAt,2)
      EfromH2=Rab33i**2*DampBarn(2)*uDisp(indQAt,2)

      EEDisp=EEdisp+EfromO1+EfromH1+EfromH2

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE VEIG(N,A,V)
C
C     THE DIAGONAL ELEMENTS OF THE LOWER TRIANGULAR MATRIX, A, STORED
C     IN UPPER PACKED STORAGE MODE ARE COPIED TO THE FIELD V.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*),V(*)
C
      DO 10 I=1,N
       V(I)=A((I*(I+1))/2)
   10 CONTINUE
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CutOff_Error(l,lMax,rMP,xrMP,nij,EC,C_o_C,nElem,
     &                        Scratch_New,Scratch_Org,nAtoms,iPrint,
     &                        Cut_Off_Error)
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
#include "status.fh"
      Real*8 rMP(nij,nElem),xrMP(nij,nElem),EC(3,nij),C_o_C(3)
      Real*8 Scratch_New(nij*(2+lMax+1)),Scratch_Org(nij*(2+lMax+1))
      Character*80 Banner_Line
*     Statement function
*
      mElem(i)=(i+1)*(i+2)*(i+3)/6
*
      iEnd  = mElem(lMax)
      iStrt = mElem(l) + 1
      ij = 0
      Do iAtom = 1, nAtoms
         Do jAtom = 1, iAtom
            ij = ij + 1
            Call ReExpand(xrMP,nij,nElem,C_o_C,EC(1,ij),ij,lMax)
*
*--- Set all elements corresponding to l+1 = 0
            Do iElem = iStrt, iEnd
               xrMP(ij,iElem) = Zero
            End Do
*
            Call ReExpand(xrMP,nij,nElem,EC(1,ij),C_o_C,ij,lMax)
         End Do
      End Do
*
      If (iPrint .ge. 1) Then
         Write (6,*)
         Write(Banner_Line,'(A,I2)') 'Errors introduced by zeroing '
     &      // 'multipole moments greater than l = ',l
         Call Banner (Banner_Line,1,80)
      End If
      Sum    = 0.0D0
      iElem  = mElem(l) + 1
      Do k = l+1, lMax
         If (iPrint .ge. 1) Then
            Write (6,*)
            Write (6,'(A,I1)') 'l=',k
            Write (6,*)
            Write (6,*)
     &   ' m     Original       New            Error            Percent'
            Write (6,*)
         End If
*
         kDim = (k+1)*(k+2)/2
         Call DGEMM_('N','N',
     &               nij,2*k+1,kDim,
     &               1.0d0,xrMP(1,iElem),nij,
     &               RSph(ipSph(k)),kDim,
     &               0.0d0,Scratch_New,nij)
         Call DGEMM_('N','N',
     &               nij,2*k+1,kDim,
     &               1.0d0,rMP(1,iElem),nij,
     &               RSph(ipSph(k)),kDim,
     &               0.0d0,Scratch_Org,nij)


         iOff   = 1
         rms    = 0.0D0
         iCount = 0
         Do m = -k, k
            Original  = DDot_(nij,[One],0,Scratch_Org(iOff),1)
            Estimated = DDot_(nij,[One],0,Scratch_New(iOff),1)
            Error     = Original - Estimated

            Sum       = Sum + Error*Error
            rms       = rms + Error*Error
            Percent   = 0.0D0
            If (abs(Error) .lt. 1.0D-8) Then
               Percent   = 0.0D0
            Else If (abs(Original) .gt. 1.0D-13) Then
               Percent   = abs(Error/Original) * 100.0d0
            Else
               Percent   = -999.99D0
            End If

            If (iPrint .ge. 1) Then
               If (Percent .ge. Zero) Then
                  Write (6,'(I3,3F16.8,4X,F6.2)')
     &                         m, Original, Estimated, Error, Percent
               Else
                  Write (6,'(I3,3F16.8,4X,A)')
     &                         m, Original, Estimated, Error, 'Infinite'
               Endif
            End If

            iOff = iOff + nij
         End Do
         If (iPrint .ge. 1) Then
            rms = sqrt(rms/DBLE(2*k+1))
            Write(6,*)
            Write(6,'(A,F16.8)') 'Root mean square = ',rms
         End If
*
         iElem = iElem + (k+1)*(k+2)/2
      End Do
*
      Cut_Off_Error = Sum
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GR_DArray(Array,nArray)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: nProcs, Is_Real_Par
#endif
      Implicit Real*8 (a-h,o-z)
*
      Real*8 Array(nArray)
*
#ifdef _MOLCAS_MPP_
      If (.Not. Is_Real_Par() .OR. nProcs.eq.1) Return
      Call CWTime(TCpu1,TWall1)
      Call GADGOP(Array,nArray,'+')
      Call CWTime(TCpu2,TWall2)
      Call SavTim(10,TCpu2-TCpu1,TWall2-TWall1)
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Array)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine FBLOCK(FIFA,NO,NI,NA,NS,FIT,FTI,FIA,FAI,FTA,FAT)
! Extract three rectangular submatrices FIT, FIA and FTA from the
! triangular matrix FIFA.
! SVC: add transposed submatrices to avoid complicated strides in the
! low-level sgm subroutines

use Index_Functions, only: iTri, nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NO, NI, NA, NS
real(kind=wp), intent(in) :: FIFA(nTri_Elem(NO))
real(kind=wp), intent(out) :: FIT(NI,NA), FTI(NA,NI), FIA(NI,NS), FAI(NS,NI), FTA(NA,NS), FAT(NS,NA)
integer(kind=iwp) :: IA, IAI, IAT, IATOT, II, IT, ITI, ITTOT

do IT=1,NA
  ITTOT = NI+IT
  do II=1,NI
    ITI = iTri(ITTOT,II)
    FIT(II,IT) = FIFA(ITI)
    FTI(IT,II) = FIFA(ITI)
  end do
end do
do IA=1,NS
  IATOT = NI+NA+IA
  do II=1,NI
    IAI = iTri(IATOT,II)
    FIA(II,IA) = FIFA(IAI)
    FAI(IA,II) = FIFA(IAI)
  end do
end do
do IA=1,NS
  IATOT = NI+NA+IA
  do IT=1,NA
    ITTOT = NI+IT
    IAT = iTri(IATOT,ITTOT)
    FTA(IT,IA) = FIFA(IAT)
    FAT(IA,IT) = FIFA(IAT)
  end do
end do

end subroutine FBLOCK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Expand_Coor(Coord,nAtoms,W1,iAll_Atom)
!***********************************************************************
!                                                                      *
!     purpose: to generate a list of all atoms                         *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: iOper, nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms
real(kind=wp), intent(in) :: Coord(3,nAtoms)
real(kind=wp), intent(out) :: W1(3,nAtoms*8)
integer(kind=iwp), intent(out) :: iAll_Atom
integer(kind=iwp) :: iAtom, iChAtom, iCo, iCoSet(0:7,0:7), iGen(3), iStab(0:7), MaxDCR, nCoSet, nGen, nStab
integer(kind=iwp), external :: iChxyz

!----------------------------------------------------------------------*
W1(:,1:nAtoms) = Coord(:,:)
!----------------------------------------------------------------------*
! Apply the symmetry operations                                        *
!----------------------------------------------------------------------*
nGen = 0
if (nIrrep == 2) nGen = 1
if (nIrrep == 4) nGen = 2
if (nIrrep == 8) nGen = 3
if (nGen >= 1) iGen(1) = iOper(1)
if (nGen >= 2) iGen(2) = iOper(2)
if (nGen >= 3) iGen(3) = iOper(4)

MaxDCR = 0
iAll_Atom = nAtoms
do iAtom=1,nAtoms
  iChAtom = iChxyz(W1(1,iAtom),iGen,nGen)
  call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
  nCoSet = nIrrep/nStab

  do iCo=1,nCoSet-1

    iAll_Atom = iAll_Atom+1
    call OA(iCoSet(iCo,0),W1(:,iAtom),W1(:,iAll_Atom))

  end do

end do

!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*

end subroutine Expand_Coor

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2003, Valera Veryazov                                  *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine RdInp_scf()
************************************************************************
*                                                                      *
*     purpose: Read input options                                      *
*                                                                      *
*     called from: ReadIn                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*     modified by M.Schuetz @teokem.lu.se, 1995                        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: UHF- V.Veryazov, 2003                                   *
*                                                                      *
************************************************************************
      use OccSets
      use IOBUF
*
      Implicit Real*8 (a-h,o-z)
      External Allocdisk
      Integer Allocdisk
*
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
#include "stdalloc.fh"
#include "hflda.fh"
#include "ldfscf.fh"
#include "file.fh"
#include "iprlv.fh"
#include "ksdft.fh"
#ifdef _HDF5_
#  include "mh5.fh"
#endif
*
*---- Define local variables
      Character*180  Key, Line, BLIne
      Character*180 Get_Ln
      External Get_Ln
      Integer nLev,iArray(32)
      Logical lTtl, IfAufChg,OccSet,FermSet,CharSet,UHFSet,SpinSet
      Logical Cholesky,REORD,DECO,timings,DensityCheck
      Integer ALGO,NSCREEN
      Real*8  dmpk,dFKmat
      Real*8  ThrRd(1)
      Integer Mode(1)
*     character ww*128
      character Method*8
      Logical Cho_Aufb,Estimate,Update
      Logical TDen_UsrDef

      Common /CHOSCF / REORD,DECO,dmpk,dFKmat,ALGO,NSCREEN
      COMMON /CHOTIME / timings
      COMMON /CHODENSITY/ DensityCheck
      COMMON /CHOSCREEN/ Estimate,Update
      Common /CHOAUF / Cho_Aufb
      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
      Character*16  OFE_KSDFT
      COMMON  / OFembed_C / OFE_KSDFT
      COMMON  / OFembed_I / ipFMaux, ip_NDSD, l_NDSD
      COMMON  / OFembed_T / ThrFThaw
      COMMON  / OFembed_R1/ Xsigma
      COMMON  / OFembed_R2/ dFMD
      Logical Do_Tw
      COMMON  / Tw_corr_L   / Do_Tw
      Character*16  ADDC_KSDFT
      COMMON  / ADDcorr_C   / ADDC_KSDFT
      Logical Do_Addc
      COMMON  / ADDcorr_L   / Do_Addc
      Logical Do_SpinAV
      COMMON  / SPAVE_L  / Do_SpinAV

*
*     copy input from standard input to a local scratch file
*
      Call SpoolInp(LuSpool)
*
      Call ICopy(2*MxPrLv,[0],0,iPrLV,1)
*
      BLine=' '
      OccSet=.false.
      FermSet=.false.
      CharSet=.false.
      SpinSet=.false.
*
      Neg2_Action='STOP'
*
* Some initialization
*
      Cholesky=.false.
      ALGO  = 4
      REORD =.false.
      DECO  =.true.
      DensityCheck=.false.
      timings=.false.
      UHFSet=.false.
      Nscreen = 10    ! default screening interval (# of red sets)
      dmpk = 1.0d0   ! default damping of the screening threshold
      Estimate=.false.
      Update=.true.
#if defined (_MOLCAS_MPP_)
      ChFracMem=0.3d0
#else
      ChFracMem=0.5d0
#endif
      SCF_FileOrb='INPORB'
      isHDF5=.False.
* Constrained SCF initialization
      Do i=1,nSym
         nConstr(i)=0
      End Do
      MxConstr=0
      klockan=1
      Do_Addc=.false.
      Do_SpinAV=.false.
      iTer2run=2
* Orbital-free embedding
      Do_OFemb=.false.
      KEonly  =.false.
      OFE_first  =.true.
      ThrFThaw = 0.0d0
      dFMD = 0.0d0
      Xsigma = 1.0d4
      ipFMaux = -666666
      ip_NDSD = -696969
      l_NDSD = 0
* KSDFT exch. and corr. scaling factors
      CoefX = 1.0D0
      CoefR = 1.0D0
* Delta_Tw correlation energy calculation
      Do_Tw=.false.
* Read Cholesky info from runfile and save in infscf.fh
      Call DecideOnCholesky(DoCholesky)
      if (DoCholesky) then
         Cholesky=.True.
         DSCF=.false.
         Call Cho_scf_rdInp(.True.,LuSpool)
         if(ALGO.ge.2)then
            DDnOFF = .True. !do not use diffential density
            MiniDn = .False.
         endif
*tbp, may 2013: no thr modification with Cholesky
*tbp     Call Get_dScalar('Cholesky Threshold',ThrCom)
*tbp     EThr = Max(EThr,ThrCom)
      else
         DDnOFF = .false. !default for conventional
         MiniDn = .true.
      endif
      TDen_UsrDef=.False.
* Decide on LDF (stored in infscf.fh)
      Call DecideOnLocalDF(DoLDF)
* LDF defaults - ldfscf.fh
      LDF_IntegralMode=1 ! robust integral representation
      LDF_Timing=.False. ! do not time Fock build
      LDFracMem=0.2d0 ! at most 20% of memory used as coef. buffer
      ! integral prescreening threshold (negative => based on LDF target
      ! accuracy
      LDF_IntegralPrescreening=0.0d0  ! TODO/FIXME: should be neg
      ! contribution prescreening threshold (negative => based on LDF
      ! target accuracy
      LDF_ContributionPrescreening=0.0d0  ! TODO/FIXME: should be neg
      ! Debug options: integrals used for building Coulomb Fock matrix
      LDF_UseConventionalIntegrals=.False. ! conventional integrals
      LDF_UseLDFIntegrals=.False. ! integrals computed from LDF coeffs
      LDF_UsePSDIntegrals=.False. ! integrals selected based on PSD
      LDF_UseExactIntegralDiagonal=.False. ! use exact integral diagonal
      ! Debug option: check all integrals
      LDF_IntegralCheck=.False.
      ! Debug option: verify fit
      LDF_FitVerification=.False.
      ! Debug option: check coefficients
      LDF_CoefficientCheck=.False.
      ! Debug option: Compute norm of upper bound Fock matrix error
      ! (Coulomb only)
      LDF_UBCNorm=.False.
      ! Debug option: check Coulomb Fock matrix error (Coulomb only)
      LDF_CoulombCheck=.False.
      ! Debug option: check overlap integrals
      LDF_OverlapCheck=.False.
      ! Debug option: check charge
      LDF_ChargeCheck=.False.
      ! Debug option: print charge and fitted charge
      LDF_ChargePrint=.False.
      ! Debug option: check integral representatons (consistency)
      LDF_ModeCheck=.False.
      ! Debug option: check that full integral matrix is PSD
      LDF_IntegralPSDCheck=-1 ! do not check
      ! Debug option: use exact diagonal blocks when checking PSD
      LDF_UseExactIntegrals=0

*---- Set up number of orbitals
      Do iSym = 1, nSym
         nOrb(iSym) = nBas(iSym)
      End Do
*---- Set up some counters
      nSqrSum=0
      Do iSym = 1, nSym
         nSqrSum=nSqrSum+nBas(iSym)*nBas(iSym)
      End Do
*
      iOrbi = 0
      iFroz = 0
      iOccu = 0
      nTit  = 0
      UHF_Size=1
      ivvloop=0
      iPrForm=-1
      iterprlv=0
      HFLDA=0.0d0
      ScrFac=0.0d0
*
*---- Parameters that control how new orbitals
*---- are generated by neworb.
*
      RotLev=0.0d0
      RotFac=1.0d0
      RotMax=1.0d1
*     HLgap=-1.0d0
      HLgap= 0.2d0
      DoHLgap=.false.
      MaxFlip=10
      FlipThr=0.1
*
* Skip exchange when building Fock matrix
* (for debugging purposes)
*
      NoExchange=.False.
*
*---- Default value for starting orbitals
*---- Invec=-1 indicate decision in sorb
*
      InVec=-1
*
*---- Default to aufbau for neutral species
*
      Aufb   = .True.
      Teee   = .True.
      RTemp  = 0.500d0
      TemFac = 0.460d0
      TStop  = 0.010d0
      nAufb(1) = -1
      nAufb(2) = -1
      Call Get_dScalar('Total Nuclear Charge',Tot_Nuc_Charge)
      Tot_El_Charge=Zero
      Tot_Ml_Charge=Zero
      Tot_Charge=Zero
      iAu_ab=0
      iStatPRN=0
*
      IfAufChg=.False.
*
      Falcon=.False.
      MSYMON=.False.
*
      iUHF = 0
      nD = 1
*
*---- Locate "start of input"
      Rewind(LuSpool)
      Call RdNLst(LuSpool,'SCF')
*
      KeywNo=0
 1000 lTtl=.False.
  999 Continue
      Key = Get_Ln(LuSpool)
      Line = Key
      Call UpCase(Line)
      KeywNo=KeywNo+1
*
      If (Line(1:4).eq.'TITL') Go To 1100
      If (Line(1:4).eq.'ITER') Go To 1200
      If (Line(1:4).eq.'OCCU') Go To 1300
      If (Line(1:4).eq.'ORBI') Go To 1400
      If (Line(1:4).eq.'FROZ') Go To 1500
      If (Line(1:4).eq.'OVLD') Go To 1700
      If (Line(1:4).eq.'PRLS') Go To 1800
      If (Line(1:4).eq.'PRLI') Go To 1850
      If (Line(1:4).eq.'PROR') Go To 1900
      If (Line(1:4).eq.'KEEP') Go To 2000
      If (Line(1:4).eq.'STAR') Go To 2100
*
* Section for Cholesky input
      If (Line(1:4).eq.'CHOL') Go To 20000
      If (Line(1:4).eq.'CHOI') Go To 20001
*
      If (Line(1:4).eq.'CONS') Go To 20002
      If (Line(1:4).eq.'CORE') Go To 21000
      If (Line(1:4).eq.'NDDO') Go To 21001
      If (Line(1:4).eq.'LUMO') Go To 21002
      If (Line(1:4).eq.'GSSR') Go To 21003
      If (Line(1:4).eq.'REST') Go To 21004
      If (Line(1:4).eq.'THRE') Go To 2200
      If (Line(1:4).eq.'NODI') Go To 2300
      If (Line(1:4).eq.'DIIS') Go To 2400
      If (Line(1:4).eq.'OCCN') Go To 2500
      If (Line(1:4).eq.'MCCN') Go To 2510
      If (Line(1:4).eq.'IVO ') Go To 2600
      If (Line(1:4).eq.'UHF ') Go To 2700
      If (Line(1:4).eq.'ROHF') Go To 2800
      If (Line(1:4).eq.'NODA') Go To 2900
      If (Line(1:4).eq.'CONV') Go To 3000
      If (Line(1:4).eq.'DISK') Go To 3100
      If (Line(1:4).eq.'THIZ') Go To 3200
      If (Line(1:4).eq.'SIMP') Go To 3300
      If (Line(1:4).eq.'NOMI') Go To 3400
      If (Line(1:4).eq.'TDEN') Go To 3401
      If (Line(1:4).eq.'WRDE') Go To 3500
      If (Line(1:4).eq.'C1DI') Go To 3600
      If (Line(1:4).eq.'QUAD') Go To 3700
      If (Line(1:4).eq.'RS-R') Go To 3750
      If (Line(1:4).eq.'SCRA') Go To 3800
      If (Line(1:4).eq.'EXTR') Go To 3900
      If (Line(1:4).eq.'RFPE') Go To 4000
      If (Line(1:4).eq.'QNRT') Go To 4100
      If (Line(1:4).eq.'AUFB') Go To 4200
      If (Line(1:4).eq.'FERM') Go To 4250
      If (Line(1:4).eq.'TEEE') Go To 4300
      If (Line(1:4).eq.'CHAR') Go To 4400
      If (Line(1:4).eq.'NOTE') Go To 4500
      If (Line(1:4).eq.'KSDF') Go To 4600
      If (Line(1:4).eq.'DFCF') Go To 4605
      If (Line(1:4).eq.'OFEM') Go To 4650
      If (Line(1:4).eq.'FTHA') Go To 4655
      If (Line(1:4).eq.'DFMD') Go To 4656
      If (Line(1:4).eq.'KEON') Go To 4660
      If (Line(1:4).eq.'TWCO') Go To 4661
      If (Line(1:4).eq.'ADDC') Go To 4662
      If (Line(1:4).eq.'SAVE') Go To 4663
      If (Line(1:4).eq.'DEBU') Go To 4700
      If (Line(1:4).eq.'ZSPI') Go To 4800
      If (Line(1:4).eq.'SPIN') Go To 4850
      If (Line(1:4).eq.'EXFA') Go To 4900
      If (Line(1:4).eq.'ONEG') Go To 4901
      If (Line(1:4).eq.'ROTP') Go To 5000
      If (Line(1:4).eq.'HLGA') Go To 5002
      If (Line(1:4).eq.'CLOC') Go To 5001
      If (Line(1:4).eq.'HFLD') Go To 5010
      If (Line(1:4).eq.'FLIP') Go To 5020
      If (Line(1:4).eq.'PMTI') Go To 6000
      If (Line(1:4).eq.'STAT') Go To 6010
      If (Line(1:4).eq.'ADDF') Go To 6020
      If (Line(1:4).eq.'FILE') Go To 6030
      If (Line(1:4).eq.'ITPR') Go To 7100
      If (Line(1:4).eq.'PROP') Go To 7200
      If (Line(1:4).eq.'NOPR') Go To 7201
      If (Line(1:4).eq.'NONR') Go To 7300
      If (Line(1:4).eq.'NR-2') Go To 7300
      If (Line(1:4).eq.'ROBU') Go To 7301
      If (Line(1:4).eq.'HALF') Go To 7302
      If (Line(1:4).eq.'NR-3') Go To 7302
      If (Line(1:4).eq.'INTM') Go To 7303
      If (Line(1:4).eq.'CBUF') Go To 7400
      If (Line(1:4).eq.'INTE') Go To 7500
      If (Line(1:4).eq.'CONT') Go To 7600
      If (Line(1:4).eq.'USEC') Go To 7700
      If (Line(1:4).eq.'USEL') Go To 7800
      If (Line(1:4).eq.'USEP') Go To 7801
      If (Line(1:4).eq.'CHEC') Go To 7900
      If (Line(1:4).eq.'VERI') Go To 8000
      If (Line(1:4).eq.'CCHE') Go To 8100
      If (Line(1:4).eq.'UBNO') Go To 8200
      If (Line(1:4).eq.'COUL') Go To 8300
      If (Line(1:4).eq.'OVER') Go To 8400
      If (Line(1:4).eq.'QCHE') Go To 8500
      If (Line(1:4).eq.'QPRI') Go To 8600
      If (Line(1:4).eq.'NOX ') Go To 8700
      If (Line(1:4).eq.'MCHE') Go To 8800
      If (Line(1:4).eq.'PSDC') Go To 8900
      If (Line(1:4).eq.'USEX') Go To 8901
      If (Line(1:4).eq.'XIDI') Go To 8902
      If (Line(1:4).eq.'NEG2') Go To 8903
      If (Line(1:4).eq.'MSYM') Go To 8904
      If (Line(1:4).eq.'ITDI') Go To 8905
      If (Line(1:4).eq.'FCKA') Go To 8906
*
      If (Line(1:4).eq.'FALC') Go To 30000
*
      If (Line(1:4).eq.'END ') Go To 9000

      If (lTtl) Go To 1101
      Write (6,*) 'Unidentified key word:', Key
      call FindErrorLine
      Call Quit_OnUserError()
*
*>>>>>>>>>>>>> TITL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1100 Continue
      Line = Get_Ln(LuSpool)
      lTtl=.True.
 1101 Continue
      nTit = nTit + 1
      if(nTit.eq.1) Then
        Title(1)=Line(1:72)
      else
        if(nTit.eq.2) then
        call WarningMessage(1,'More than one title line!')
        endif
      endif
c      If (nTit.le.MxTit) Then
c         Title(nTit) = Line(1:72)
c      End If
      GoTo 999
*
*>>>>>>>>>>>>> ITER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1200 Continue
      Line=Get_Ln(LuSpool)
      Line(179:180)='-1'
      Call Put_Ln(Line)
      Call Get_I(1,nIter,2)
      If(nIter(1).eq.-1) nIter(1)=nIter(0)
      GoTo 1000
*
*>>>>>>>>>>>>> OCCU <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1300 Continue
      If(FermSet) Then
         call WarningMessage(2,
     &    'Options OCCUpied and FERMi are mutually exclusive')
         Call Abend()
      End If
      If(SpinSet) Then
         call WarningMessage(2,
     &     'Keyword OCCUpied and ZSPIn/SPIN are mutually exclusive')
         Call Abend()
      End If
      If(CharSet) Then
         call WarningMessage(2,
     &    'Options OCCUpied and CHARGE are mutually exclusive')
         Call Abend()
      End If
      Do iD = 1, nD
         Line=Get_Ln(LuSpool)
         Call Get_I(1,nOcc(1,iD),nSym)
         If (iD.eq.1) Then
            Call Put_iArray('nIsh',nOcc(1,iD),nSym)
         Else
            Call Put_iArray('nIsh beta',nOcc(1,iD),nSym)
         End If
      End Do
*
      iOccu = 1
      if(iUHF.eq.0) then
      Do i = 1, nSym
         Tot_El_Charge=Tot_El_Charge-DBLE(2*nOcc(i,1))
      End Do
      else
      Do i = 1, nSym
         Tot_El_Charge=Tot_El_Charge-DBLE(nOcc(i,1)+nOcc(i,2))
      End Do
      endif
      Aufb=.False. ! Disable default action.
      Teee=.False.
      OccSet=.true.
      Cho_Aufb=.false.
      UHFSet=.true.
      GoTo 1000
*
*>>>>>>>>>>>>> ORBI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1400 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,nOrb,nSym)
      iOrbi = 1
      Do iSym=1,nSym
         nDel(iSym)=nBas(iSym)-nOrb(iSym)
      End Do
      GoTo 1000
*
*>>>>>>>>>>>>> FROZ <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1500 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,nFro,nSym)
      Call Put_iArray('nFro',nFro,nSym)
      iFroz = 1
      GoTo 1000
*
*>>>>>>>>>>>>> OVLD <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1700 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,DelThr)
      GoTo 1000
*
*>>>>>>>>>>>>> PRLS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1800 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I1(1,iPri)
      iPrint = Max(iPri,iPrint)
      GoTo 1000
*
*>>>>>>>>>>>>> PRLI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1850 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I1(1,nLev)
      nLev = Min(2*nLev,2*MxPrLv)
      Line=Get_Ln(LuSpool)
      Call Get_I(1,iPrLV,nLev)
      GoTo 1000
*
*>>>>>>>>>>>>> PROR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1900 Continue
      Line=Get_Ln(LuSpool)
      Line(179:180)='-1'
      Call Put_Ln(Line)
      Call Get_I1(1,iPrOrb)
      If (iPrOrb.ge.2) then
           Call Get_F1(2,ThrEne)
           Call Get_I1(3,iPrForm)
      else
            Call Get_I1(2,iPrForm)
      endif
      GoTo 1000
*
*>>>>>>>>>>>>> KEEP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2000 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I1(1,iDKeep)
      GoTo 1000
*
*>>>>>>>>>>>>> STAR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2100 Continue
      Line=Get_Ln(LuSpool)
      Line(157:180)='-1 -1 -1 -1 -1 -1 -1 -1'
      Call Put_Ln(Line)
      Call Get_I(1,LstVec,7)
* temporary hack to use density
      If(LstVec(1).eq.3) Then
         InVec=3
         RTemp  = 0.100d0
         TemFac = 0.100d0
         TStop  = 0.005d0
*        Aufb=.false.
*        Teee=.false.
      End If
      GoTo 1000
*
*...... Explicit Start Options
*
*>>>>>>>>>>>>> CHOL <<<<<<< Cholesky Default Input <<<<<<<<<<<<<<<<<
*
20000 Continue
      Cholesky=.True.
      DSCF=.false. !Cholesky is conventional
      Call Cho_scf_rdInp(.True.,LuSpool)
       if(ALGO.ge.2)then
         DDnOFF = .True. !do not use diffential density
         MiniDn = .False.
       endif
      GoTo 1000
*
*>>>>>>>>>>>>> CHOI <<<<<<< Cholesky Custom  Input <<<<<<<<<<<<<<<<<
*
*     Cholesky with user-defined settings.
*
20001 Continue
      Cholesky=.True.
      DSCF=.false. !Cholesky is conventional
      DDnOFF = .False. ! reset to default value
      MiniDn = .True.  ! reset to default value
      Call Cho_scf_rdInp(.False.,LuSpool)
       if(ALGO.ge.2)then
         DDnOFF = .True. !do not use diffential density
         MiniDn = .False.
       else
         DECO=.false.
       endif
      GoTo 1000
*
*>>>>>>>>>>>>> CONS <<<<<<<<<<<< Constrained SCF <<<<<<<<<<<
20002 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,nConstr,nSym)
      Call Izero(indxC,16*2*8)
      Do i=1,nSym
         MxConstr=Max(MxConstr,nConstr(i))
         Line=Get_Ln(LuSpool)
         Call Get_I(1,indxC(1,1,i),nConstr(i))
         If (nConstr(i).gt.16) Then
            write(6,*) ' Max nConstr=16. Increase 1st dim of indxC and',
     &                 'recompile'
            Call Abend()
         EndIf
         Do j=1,nConstr(i)
            If (indxC(j,1,i).ne.1 .and. indxC(j,1,i).ne.-1) Then
               write(6,*) ' Only 1 and -1 are accepted values'
               Call Abend()
            ElseIf (indxC(j,1,i).eq.1) Then
               indxC(j,2,i)=2
            Else
               indxC(j,1,i)=2
               indxC(j,2,i)=1
            EndIf
         End Do
      End Do
      GoTo 1000
*
*>>>>>>>>>>>>> CORE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
21000 Continue
      InVec=0
      LstVec(1)=4
      LstVec(2)=-1
      GoTo 1000
*>>>>>>>>>>>>> NDDO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
21001 Continue
      If (Cholesky) Then
         call WarningMessage(1,
     &     'RdInp: NDDO and Cholesky are incompatible!!;'//
     &     ' NDDO Option ignored')
      Else
      InVec=1
      LstVec(1)=5
      LstVec(2)=-1
      EndIf
      GoTo 1000
*>>>>>>>>>>>>> LUMO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
21002 Continue
      InVec=2
      One_Grid=.True.
      LstVec(1)=2
      LstVec(2)=-1
      GoTo 1000
*>>>>>>>>>>>>> FILE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
6030  Continue
      InVec=2
      One_Grid=.True.
      LstVec(1)=2
      LstVec(2)=-1
      Line=Get_Ln(LuSpool)
      call fileorb(Line,SCF_FileOrb)
#ifdef _HDF5_
      If (mh5_is_hdf5(SCF_FileOrb)) Then
         isHDF5=.True.
         fileorb_id=mh5_open_file_r(SCF_FileOrb)
      End If
#endif
      goto 1000
*>>>>>>>>>>>>> GSSR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
21003 Continue
      InVec=9
      One_Grid=.True.
      LstVec(1)=1
      LstVec(2)=-1
      GoTo 1000
*>>>>>>>>>>>>> REST <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
21004 Continue
      Write (6,*) 'WARNING: Option REST is redundant.'
      GoTo 1000
*>>>>>>>>>>>>> THRE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2200 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,EThr)
      Call Get_F1(2,DThr)
      Call Get_F1(3,FThr)
      Call Get_F1(4,DltNTh)
*tbp, may 2013: no thr modification with Cholesky
*tbp  If (DoCholesky) then
*tbp     write(ww,'(a,e20.8)')
*tbp &     'Detected Cholesky or RI/DF calculation BUT user'
*tbp &           //'specified EThr will be used. Ethr = ',EThr
*tbp     call WarningMessage(1,ww)
*tbp  EndIf
*     If (  DThr*1.D-2.gt.EThr) Then
*        Write (6,*)
*        Write (6,*) '----> WARNING! <----'
*        Write (6,*)
*        Write (6,*) ' The value of DThr is inconsistent with'
*        Write (6,*) ' with the value of EThr. The code will'
*        Write (6,*) ' automatically reset the value to something'
*        Write (6,*) ' more reasonable based on the requested'
*        Write (6,*) ' threshold of the energy.'
*        DThr=100.D+00*EThr
*     End If
*     If (  FThr*1.D-2.gt.EThr) Then
*        Write (6,*)
*        Write (6,*) '----> WARNING! <----'
*        Write (6,*)
*        Write (6,*) ' The value of FThr is inconsistent with'
*        Write (6,*) ' with the value of EThr. The code will'
*        Write (6,*) ' automatically reset the value to something'
*        Write (6,*) ' more reasonable based on the requested'
*        Write (6,*) ' threshold of the energy.'
*        FThr=100.D+00*EThr
*     End If
*     If (DltNTh*1.D-2.gt.Sqrt(EThr)) Then
*        Write (6,*)
*        Write (6,*) '----> WARNING! <----'
*        Write (6,*)
*        Write (6,*) ' The value of DltNTh is inconsistent with'
*        Write (6,*) ' with the value of EThr. The code will'
*        Write (6,*) ' automatically reset the value to something'
*        Write (6,*) ' more reasonable based on the requested'
*        Write (6,*) ' threshold of the energy.'
*        DltNTh=100.D+00*Sqrt(EThr)
*     End If
      GoTo 1000
*
*>>>>>>>>>>>>> NODI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2300 Continue
      Diis = .False.
      GoTo 1000
*
*>>>>>>>>>>>>> DIIS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2400 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,DiisTh)
      GoTo 1000
*
*>>>>>>>>>>>>> OCCN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2500 Continue
      If (iOccu.ne.1) Then
         Call WarningMessage(2,' Input Error!;'//
     &      'The OCCNumber option works only if '//
     &      ' the OCCUpied option has been specified!')
         Call Abend()
      End If
      lthSet_a = 0
      lthSet_b = 0
      Do 2501 iSym = 1, nSym
         lthSet_a = lthSet_a + nOcc(iSym,1)
         If(iUHF.eq.1) Then
            lthSet_b = lthSet_b + nOcc(iSym,2)
         End If
 2501 Continue
      nOccSet_e=max(lthSet_a,lthSet_b)
*     Write(6,'(a,i5)') 'rdinp: lthset_a ',lthset_a
*     Write(6,'(a,i5)') 'rdinp: lthset_b ',lthset_b
*
*---- Note, it is dangerous to read Line first. There may be many
*     lines with occupation numbers.
*
      nD = iUHF + 1
      Call mma_allocate(OccSet_e,nOccSet_e,nD,Label='OccSet_e')
      Call FZero(OccSet_e,nOccSet_e*nD)
      Read(LuSpool,*,End=902,Err=903) (OccSet_e(i,1),i=1,lthSet_a)
      If(iUHF.eq.1) then
        Read(LuSpool,*,End=902,Err=903) (OccSet_e(i,2),i=1,lthSet_b)
      End If

      Tot_El_Charge=Zero
      Do iD = 1, nD
         Do i = 1, nOccSet_e
            Tot_El_Charge=Tot_El_Charge-OccSet_e(i,iD)
         End Do
      End Do
      UHFSet=.true.
      iCoCo=1
      GoTo 1000
*
*>>>>>>>>>>>>> MCCN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*     Just as OCCN, but for muons
 2510 Continue
      If (iOccu.ne.1) Then
         Call WarningMessage(2,' Input Error!;'//
     &      'The OCCNumber option works only if '//
     &      ' the OCCUpied option has been specified!')
         Call Abend()
      End If
      lthSet_a = 0
      lthSet_b = 0
      Do 2511 iSym = 1, nSym
         lthSet_a = lthSet_a + nOcc(iSym,1)
         If(iUHF.eq.1) Then
            lthSet_b = lthSet_b + nOcc(iSym,2)
         End If
 2511 Continue
      nOccset_m=max(lthSet_a,lthSet_b)
*     Write(6,'(a,i5)') 'rdinp: lthset_a ',lthset_a
*     Write(6,'(a,i5)') 'rdinp: lthset_b ',lthset_b
*
*---- Note, it is dangerous to read Line first. There may be many
*     lines with occupation numbers.
*
      Call mma_allocate(OccSet_m,nOccSet_m,nD,Label='OccSet_m')
      Call FZero(OccSet_m,nOccSet_m*nD)
      Read(LuSpool,*,End=902,Err=903) (OccSet_m(i,1),i=1,lthSet_a)
      If(iUHF.eq.1) then
        Read(LuSpool,*,End=902,Err=903) (OccSet_m(i,2),i=1,lthSet_b)
      End If

      Tot_Ml_Charge=Zero
      Do iD = 1, nD
         Do i = 1, nOccSet_m
            Tot_Ml_Charge=Tot_Ml_Charge-OccSet_m(i,iD)
         End Do
      End Do
      UHFSet=.true.
      iCoCo=1
      GoTo 1000
*
*>>>>>>>>>>>>> IVO  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2600 Continue
      kIvo = 1
      GoTo 1000
*
*>>>>>>>>>>>>> UHF  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2700 Continue
      if(UHFSet) then
      call sysAbendMsg('rdinp','incorrect input',
     &                 'UHF keyword should be placed before others')
      endif
      iUHF     = 1
      UHF_Size = 2
      MiniDn = .False.
      nD       = 2
      GoTo 1000
*
*>>>>>>>>>>>>> ROHF <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2800 Continue
      iROHF = 1
      GoTo 1000
*
*>>>>>>>>>>>>> NODA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 2900 Continue
      Damping=.False.
      GoTo 1000
*
*>>>>>>>>>>>>> CONV <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3000 Continue
      DSCF = .False.
      GoTo 1000
*
*>>>>>>>>>>>>> DISK <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3100 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I1(1,nDisc)
      Call Get_I1(2,nCore)
      GoTo 1000
*
*>>>>>>>>>>>>> THIZ <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3200 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,Thize)
      GoTo 1000
*
*>>>>>>>>>>>>> SIMP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3300 Continue
      PreSch = .True.
      GoTo 1000
*
*>>>>>>>>>>>>> NOMI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3400 Continue
      MiniDn = .False.  !do not use minimized density diff
      GoTo 1000
*
*>>>>>>>>>>>>> TDEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3401 Continue
      DDnOFF = .True. !do not use diffential density
      MiniDn = .False.
      TDen_UsrDef=.True.
      GoTo 1000
*
*>>>>>>>>>>>>> WRDE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3500 Continue
      WrOutD = .True.
      GoTo 1000
*
*>>>>>>>>>>>>> C1DI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3600 Continue
      c1Diis = .True.
      GoTo 1000
*
*>>>>>>>>>>>>> QUAD <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3700 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,QudThr)
      GoTo 1000
*
*>>>>>>>>>>>>> RS-R <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3750 Continue
      RSRFO = .True.
      GoTo 1000
*
*>>>>>>>>>>>>> SCRA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3800 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,ScrFac)
      Scrmbl = .True.
      GoTo 1000
*
*>>>>>>>>>>>>> EXTR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 3900 Continue
      call WarningMessage(1,
     &    'EXTRACT option is redundant and is ignored!')
      Goto 1000
*
*>>>>>>>>>>>>> RFPE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4000 Continue
      RFpert = .True.
      GoTo 1000
*
*>>>>>>>>>>>>> QNRT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4100 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,QNRTh)
      GoTo 1000
*
*>>>>>>>>>>>>> AUFB <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4200 Continue
      call WarningMessage(2,
     & ' Error: Keyword AUFBau is now obsolete!;' //
     & 'Use keyword CHARge')
      Call Abend()
      if(Cholesky)then
        DDnOFF = .true.
        DECO   = .true.
        MiniDn = .false.
      endif
      Line=Get_Ln(LuSpool)
      Line(180:180)='2'
      Call Put_Ln(Line)
      Call Get_I(1,iArray,UHF_Size+1)
      Do i=1,UHF_Size
         nAufb(i)=iArray(i)
      EndDo
      iAuf=iArray(UHF_Size+1)
      If (IfAufChg) Then
      call WarningMessage(2,
     &  'Option AUFBau is mutually exclusive CHARge')
         Call Abend()
      End If
      if(iUHF.eq.0) then
       Tot_El_Charge=-Two*DBLE(nAufb(1))
      else
       Tot_El_Charge=-DBLE(nAufb(1)+nAufb(2))
      endif
      IfAufChg=.True.
 4210 If(iAuf.eq.0) Then
         Teee = .False.
      Else If(iAuf.eq.1) Then
         RTemp  = 0.500d0
         TemFac = 0.400d0
         TStop  = 0.005d0
      Else If(iAuf.eq.2) Then
         RTemp  = 0.500d0
         TemFac = 0.460d0
         TStop  = 0.010d0
      Else If(iAuf.eq.3) Then
         RTemp  = 0.500d0
         TemFac = 0.610d0
         TStop  = 0.025d0
      Else If(iAuf.eq.4) Then
         RTemp  = 1.000d0
         TemFac = 0.730d0
         TStop  = 0.060d0
      Else If(iAuf.eq.5) Then
         RTemp  = 1.000d0
         TemFac = 0.870d0
         TStop  = 0.150d0
      Else
            call WarningMessage(1,
     & ' RdInp: Aufbau case must be in the range 0-5;'//
     &     'Using case 5!')
         RTemp  = 1.000d0
         TemFac = 0.870d0
         TStop  = 0.150d0
      End If
      UHFSet=.true.
      GoTo 1000
*>>>>>>>>>>>>> FERM <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4250 Continue
      If(OccSet) Then
      call WarningMessage(2,
     & 'Options OCCUpied and FERMi are mutually exclusive')
         Call Abend()
      End If
      if(Cholesky)then
        DDnOFF = .true.
        DECO   = .true.
        MiniDn = .false.
      endif
      Line=Get_Ln(LuSpool)
      Call Get_I1(1,iAuf)
      FermSet=.true.
      GoTo 4210
*>>>>>>>>>>>>> TEEE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4300 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,RTemp)
      Call Get_F1(2,TemFac)
      Call Get_F1(3,TStop)
      If (TStop.lt.Zero) Then
      call WarningMessage(2,
     &     'Input Error!; End temperture < 0.0 ')
         Call Abend
      End If
      If (TemFac.lt.Zero) Then
      call WarningMessage(2,
     &     'Input Error!; Temperture factor < 0.0 ')
         Call Abend
      End If
      If (RTemp.lt.Zero) Then
      call WarningMessage(2,
     &     'Input Error!; Start temperature < 0.0 ')
         Call Abend
      End If
      If (RTemp.lt.TStop) Then
      call WarningMessage(2,
     &     'Input Error!; End temperture > start temperature ')
         Call Abend
      End If
      GoTo 1000
*>>>>>>>>>>>>> CHAR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4400 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,iArray,1)
      Tot_Charge=DBLE(iArray(1))
      nAufb(1)=-1
      nAufb(2)=-1
      If (IfAufChg) Then
      call WarningMessage(2,
     &     'Input Error!; Option CHARge is mutually exclusive'//
     &     ' to AUFBau')
         Call Abend()
      End If
      If (OccSet) Then
      call WarningMessage(2,
     &     'Input Error!; Option CHARge is mutually exclusive'//
     &     ' to OCCUpied')
         Call Abend()
      End If
      IfAufChg=.True.
      CharSet=.True.
      GoTo 1000
*>>>>>>>>>>>>> NOTE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4500 Continue
      Teee=.False.
      GoTo 1000
*
*>>>>>>>>>>>>> KSDF <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4600 Continue
      Line=Get_Ln(LuSpool)
      Call UpCase(Line)
      Call LeftAd(Line)
      KSDFT=Line(1:16)
      GoTo 1000
*
*>>>>>>>>>>>>> DFCF <<<< Factors to scale exch. and corr. <<
 4605 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,CoefX)
      Call Get_F1(2,CoefR)
!      Call put_dscalar('DFT exch coeff',CoefX)
!      Call put_dscalar('DFT corr coeff',CoefR)
      GoTo 1000
*
*>>>>>>>>>>>>> OFEM <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4650 Continue
      Do_OFemb=.true.
      Line=Get_Ln(LuSpool)
      Call UpCase(Line)
      Call LeftAd(Line)
      OFE_KSDFT=Line(1:16)
      write(6,*)  '  --------------------------------------'
      write(6,*)  '   Orbital-Free Embedding Calculation'
      write(6,*)  '  --------------------------------------'
      If (OFE_KSDFT(1:4).eq.'LDTF') Then
       write(6,*) '    T_nad potential   : Thomas-Fermi    '
      Else
       write(6,*) '    T_nad potential   : ',OFE_KSDFT(1:4)
      EndIf
      If (KEonly) Then
       write(6,*) '    Exc_nad potential :  None           '
      Else
       write(6,*) '    Exc_nad potential : ',OFE_KSDFT(6:10)
      EndIf
      write(6,*)  '  --------------------------------------'
      write(6,*)
      GoTo 1000
*
*>>>>>>>>>>>>> FTHA <<<< threshold for Freeze-n-Thaw <<<<<<<
 4655 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,ThrFThaw)
      GoTo 1000
*
*>>>>>>>>>>>>> DFMD <<<< fraction of correlation potential <
 4656 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,dFMD)
      Call Get_F1(2,Xsigma)
      If (dFMD+Xsigma.lt.0.0d0) Then
       write(6,*)' *** Warning: arguments to DFMD must be nonnegative!'
       write(6,*)' ***          I will take their ABS !!! '
       dFMD=abs(dFMD)
       Xsigma=abs(Xsigma)
      EndIf
      GoTo 1000
*
*>>>>>>>>>>>>> KEON <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4660 Continue
      KEonly=.true.
      If (.not.Do_OFemb) Then
       write(6,*) ' *** Warning:  KEonly works in OFembedding runs!'
      Else
       write(6,*) ' *** Warning:  Exc_nad set to NONE at this point ***'
      EndIf
      write(6,*)
      GoTo 1000
*
*>>>>>>>>>>>>> TWCO <<<<< activate Tw correlation <<<<<<<<<<
 4661 Continue
      Do_Tw =.true.
      GoTo 1000
*
*>>>>>>>>>>>>> ADDC << add correlation energy (CONStraint) <
 4662 Continue
      Do_Addc=.True.
      Line=Get_Ln(LuSpool)
      Call UpCase(Line)
      Call LeftAd(Line)
      ADDC_KSDFT=Line(1:16)
      GoTo 1000
*
*>>>>>>>>>>>>> SAVE << Spin-Averaged wavelets (CONStraint) <
 4663 Continue
      Do_SpinAV=.True.
      GoTo 1000
*
*>>>>>>>>>>>>> DEBUG <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4700 Continue
       ivvloop=1
       Diis=.false.
       MiniDn=.false.
       Damping=.False.
      GoTo 1000
*>>>>>>>>>>>>> ZSPI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4800 Continue
      If (SpinSet) Then
         Call WarningMessage(2,
     &        'Multiple definition of SPIN/ZSPIn')
         Call Abend()
      End If
      If(OccSet) Then
      call WarningMessage(2,
     &     'Input Error!; Keywords OCCUpied and ZSPIn are mutually'//
     &     ' exclusive')
         Call Abend()
      End if
      Line=Get_Ln(LuSpool)
      Call Get_I(1,iArray,1)
      iAu_ab=iArray(1)
      If ((iUHF.ne.1).and.(iAu_ab.ne.0)) Then
         Call WarningMessage(2,
     &        'ZSPIn different from 0 requires UHF before it')
         Call Abend()
      End If
      SpinSet=.true.
      GoTo 1000
*>>>>>>>>>>>>> SPIN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4850 Continue
      If (SpinSet) Then
         Call WarningMessage(2,
     &        'Multiple definition of SPIN/ZSPIn')
         Call Abend()
      End If
      If(OccSet) Then
      call WarningMessage(2,
     &     'Input Error!; Keywords OCCUpied and SPIN are mutually'//
     &     ' exclusive')
         Call Abend()
      End if
      Line=Get_Ln(LuSpool)
      Call Get_I(1,iArray,1)
      iAu_ab=iArray(1)-1
      If (iAu_ab.lt.0) Then
         Call WarningMessage(2,
     &        'SPIN must be a positive integer')
         Call Abend()
      End If
      If ((iUHF.ne.1).and.(iAu_ab.ne.0)) Then
         Call WarningMessage(2,
     &        'SPIN greater than 1 requires UHF before it')
         Call Abend()
      End If
      SpinSet=.true.
      GoTo 1000
*>>>>>>>>>>>>> EXFA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4900 Continue
      ExFac=0.0D0
      GoTo 1000

*>>>>>>>>>>>>> ONEG <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 4901 Continue
      One_Grid=.True.
      GoTo 1000

*>>>>>>>>>>>>> ROTP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 5000 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,RotLev)
      Call Get_F1(2,RotFac)
      Call Get_F1(3,RotMax)
      Write(6,'(a,E15.3)') 'Fock matrix levelshift   ',RotLev
      Write(6,'(a,E15.3)') 'Fock matrix scaling      ',RotFac
      Write(6,'(a,E15.3)') 'Fock matrix max rotation ',RotMax
      GoTo 1000
*>>>>>>>>>>>>> CLOC <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 5001 Continue
      timings=.True.
      LDF_Timing=.True.
      GoTo 1000
*>>>>>>>>>>>>> HLGA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 5002 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,HLgap)
      Write(6,'(a,E15.3)') 'Minimum HOMO-LUMO gap    ',HLgap
      DoHLgap=.true.
      QNRTh    = 0.0d0
      GoTo 1000
*>>>>>>>>>>>>> HFLDA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 5010 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,HFLDA)
      Write(6,'(a,F15.3)') 'HFLDA=', HFLDA
      Goto 1000
*>>>>>>>>>>>>> FLIP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 5020 Continue
      Line=Get_Ln(LuSpool)
      Line(178:180)='0.1'
      Call Put_Ln(Line)
      Call Get_I(1,iArray,1)
      Call Get_F1(2,FlipThr)
      MaxFlip=iArray(1)
*     Write(6,*) 'MaxFlip:',MaxFlip
*     Write(6,*) 'FlipThr:',FlipThr
      Goto 1000
*>>>>>>>>>>>>> PMTI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Time (CPU *and* wall) subroutine pmat_scf (2-el Fock matrix)
 6000 Continue
      PmTime=.true.
      GoTo 1000
*>>>>>>>>>>>>> STAT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Print Statistic information
 6010 Continue
      iStatPRN=1
      GoTo 1000
*>>>>>>>>>>>>> ADDF <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Add the fragment atoms to the MOLDEN file
 6020 Continue
      AddFragments = .True.
      Goto 1000
*>>>>>>>>>>>>> ITPR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 7100 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I1(1,iterprlv)
      Goto 1000
*>>>>>>>>>>>>> PROP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 7200 Continue
      InVec=2
      One_Grid=.True.
      LstVec(1)=2
      LstVec(2)=-1
      OnlyProp=.true.
      Goto 1000
*>>>>>>>>>>>>> SKIP PROP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 7201 Continue
      NoProp=.true.
      Goto 1000
*>>>>>>>>>>>>> NONR or NR-2 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: non-robust integral representation
 7300 Continue
      LDF_IntegralMode=2
      Goto 1000
*>>>>>>>>>>>>> ROBU <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: robust integral representation
 7301 Continue
      LDF_IntegralMode=1
      Goto 1000
*>>>>>>>>>>>>> HALF or NR-3 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: half-and-half integral representation
 7302 Continue
      LDF_IntegralMode=3
      Goto 1000
*>>>>>>>>>>>>> INTM <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: set integral mode
 7303 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,Mode,1)
      LDF_IntegralMode=max(0,min(3,Mode(1)))
      If (LDF_IntegralMode.eq.0) Then
         LDF_UseConventionalIntegrals=.True.
         If (LDF_UseLDFIntegrals .or. LDF_UsePSDIntegrals) Then
            Call WarningMessage(2,
     &     'Conv. and LDF/PSD integrals can not be used simultaneously')
            Write(6,'(1X,A)')
     &     'Keywords "USEC", "USEL", and "USEP" are mutually exclusive!'
            Write(6,'(1X,A)') 'Illegal input: INTM=0'
            Call Quit_OnUserError()
         End If
      End If
      Goto 1000
*>>>>>>>>>>>>> CBUF <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: fraction of memory to use for coefficient buffer
 7400 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F1(1,LDFracMem)
      Goto 1000
*>>>>>>>>>>>>> INTE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: integral prescreening threshold
 7500 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F(1,ThrRd,1)
      LDF_IntegralPrescreening=max(ThrRd(1),0.0d0)
      Goto 1000
*>>>>>>>>>>>>> CONT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: contribution prescreening threshold
* (i.e. contributions to Fock matrix and intermediates)
 7600 Continue
      Line=Get_Ln(LuSpool)
      Call Get_F(1,ThrRd,1)
      LDF_ContributionPrescreening=max(ThrRd(1),0.0d0)
      Goto 1000
*>>>>>>>>>>>>> USEC <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: use conventional integrals to compute Coulomb
*          Fock matrix
 7700 Continue
      If (LDF_UseLDFIntegrals .or. LDF_UsePSDIntegrals) Then
         Call WarningMessage(2,
     &     'Conv. and LDF/PSD integrals can not be used simultaneously')
         Write(6,'(1X,A)')
     &   'Keywords "USEC", "USEL", and "USEP" are mutually exclusive!'
         Call Quit_OnUserError()
      End If
      LDF_UseConventionalIntegrals=.True.
      Call WarningMessage(0,
     & 'You have specified a debug option (USEC)'//
     & ' which will slow down execution')
      Call xFlush(6)
      Goto 1000
*>>>>>>>>>>>>> USEL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: use integrals computed from LDF coefficients to
C          calculate Coulomb Fock matrix
 7800 Continue
      If (LDF_UseConventionalIntegrals .or. LDF_UsePSDIntegrals) Then
         Call WarningMessage(2,
     &     'LDF and PSD/conv. integrals can not be used simultaneously')
         Write(6,'(1X,A)')
     &   'Keywords "USEC", "USEL", and "USEP" are mutually exclusive!'
         Call Quit_OnUserError()
      End If
      LDF_UseLDFIntegrals=.True.
      Call WarningMessage(0,
     & 'You have specified a debug option (USEL)'//
     & ' which will slow down execution')
      Call xFlush(6)
      Goto 1000
*>>>>>>>>>>>>> USEP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: use integrals computed from LDF coefficients or
C          conventional integrals, depending on positivity
C          of the LDF integrals, to calculate Coulomb Fock matrix
 7801 Continue
      If (LDF_UseConventionalIntegrals .or. LDF_UseLDFIntegrals) Then
         Call WarningMessage(2,
     &     'PSD and LDF/conv. integrals can not be used simultaneously')
         Write(6,'(1X,A)')
     &   'Keywords "USEC", "USEL", and "USEP" are mutually exclusive!'
         Call Quit_OnUserError()
      End If
      LDF_UsePSDIntegrals=.True.
      Call WarningMessage(0,
     & 'You have specified a debug option (USEP)'//
     & ' which will slow down execution')
      Call xFlush(6)
      Goto 1000
*>>>>>>>>>>>>> CHEC <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: check all integrals (in first iteration)
 7900 Continue
      LDF_IntegralCheck=.True.
      Call WarningMessage(0,
     & 'You have specified a debug option (CHEC)'//
     & ' which will slow down execution')
      Call xFlush(6)
      Goto 1000
*>>>>>>>>>>>>> VERI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: verify fit for each atom pair (in first iteration)
 8000 Continue
      LDF_FitVerification=.True.
      Call WarningMessage(0,
     & 'You have specified a debug option (VERI)'//
     & ' which will slow down execution')
      Call xFlush(6)
      Goto 1000
*>>>>>>>>>>>>> CCHE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: check fitting coefficients (in first iteration)
 8100 Continue
      LDF_CoefficientCheck=.True.
      Goto 1000
*>>>>>>>>>>>>> UBNO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: compute norm of upper bound Fock matrix error
*          (Coulomb only)
 8200 Continue
      LDF_UBCNorm=.True.
      Goto 1000
*>>>>>>>>>>>>> COUL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: Check Coulomb Fock matrix error
*          (Coulomb only)
 8300 Continue
      LDF_CoulombCheck=.True.
      Call WarningMessage(0,
     & 'You have specified a debug option (COUL)'//
     & ' which will slow down execution')
      Call xFlush(6)
      Goto 1000
*>>>>>>>>>>>>> OVER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: Check overlap integrals
 8400 Continue
      LDF_OverlapCheck=.True.
      Goto 1000
*>>>>>>>>>>>>> QCHE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: Check charge
 8500 Continue
      LDF_ChargeCheck=.True.
      Goto 1000
*>>>>>>>>>>>>> QPRI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* For LDF: Print charge
 8600 Continue
      LDF_ChargePrint=.True.
      Goto 1000
*>>>>>>>>>>>>> NOX  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Debug option: skip exchange in Fock matrix build
 8700 Continue
      NoExchange=.True.
      Goto 1000
*>>>>>>>>>>>>> MCHE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Debug option: Check integral representations (modes)
 8800 Continue
      LDF_ModeCheck=.True.
      Goto 1000
*>>>>>>>>>>>>> PSDC <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Debug option: check that full integral matrix is PSD
* input=1: diagonalization
* input=2: Cholesky decomposition
 8900 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,Mode,1)
      LDF_IntegralPSDCheck=max(1,min(2,Mode(1)))
      Goto 1000
*>>>>>>>>>>>>> USEX <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Debug option: use exact diagonal (1) or off-dagonal (2) blocks when
* checking PSD
 8901 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I(1,Mode,1)
      LDF_UseExactIntegrals=max(0,min(2,Mode(1)))
      Goto 1000
*>>>>>>>>>>>>> XIDI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Use exact integral diagonal to (partially) avoid problems
* associated with non-positive definite integrals. Used in
* Fock matrix build.
 8902 Continue
      LDF_UseExactIntegralDiagonal=.True.
      Goto 1000
*>>>>>>>>>>>>> NEG2 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Specify action when negative two-electron energies are
* encountered (stop, warn, continue).
 8903 Continue
      Line=Get_Ln(LuSpool)
      Call UpCase(Line)
      Neg2_Action=Line(1:4)
      If (Neg2_Action.ne.'STOP' .and. Neg2_Action.ne.'WARN' .and.
     *    Neg2_Action.ne.'CONT') Then
         Write(6,'(A,A)') 'Illegal input for NEG2 keyword: ',Line(1:4)
c        Call FindErrorLine()
         Call Quit_OnUserError()
      End If
      Goto 1000
*>>>>>>>>>>>>> MSYM <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 8904 Continue
      MSYMON = .True.
      GoTo 1000
*>>>>>>>>>>>>> ITDIIS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 8905 Continue
      Line=Get_Ln(LuSpool)
      Call Get_I1(1,iTer2run)
      GoTo 1000
*>>>>>>>>>>>>> ITDIIS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 8906 Continue
      Line=Get_Ln(LuSpool)
      Call UpCase(Line)
      If (Index(Line,'TRUE').ne.0) Then
         FckAuf=.True.
      Else
         FckAuf=.False.
      End If
      GoTo 1000
*>>>>>>>>>>>>> FALC <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
30000 Continue
      Falcon = .True.
      GoTo 1000
*
*>>>>>>>>>>>>> END  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 9000 Continue
*
      If (iPrint.ge.3) iStatPRN=1
*
      Tot_El_charge=Tot_El_Charge+Tot_Ml_Charge
*
* xml tag method
*
      If(iUHF.eq.0) Then
         If(KSDFT.eq.'SCF') Then
            Call xml_cDump('method','','',0,'rhf',1,1)
         Else
            Call xml_cDump('method','','',0,'rdft',1,1)
         End If
      Else
         If(KSDFT.eq.'SCF') Then
            Call xml_cDump('method','','',0,'uhf',1,1)
         Else
            Call xml_cDump('method','','',0,'udft',1,1)
         End If
      End If
*
* Even or odd number of electrons
*
      If(.not.SpinSet) Then
         nnn=Int(tot_nuc_charge-tot_charge+0.5d0)
         If((nnn/2)*2.ne.nnn) Then
            iAu_ab=1
         End If
      End If
*
* Check start orbital priority list
*
      If(.not.OccSet .and. .not.FermSet) Then
*        Write(6,*) 'rdinp: Checking OCCU/FERM'
         Call VecFind(OccSet,FermSet,CharSet,SpinSet)
         If(OccSet .and. .not.FermSet) Then
*           Write(6,*) 'Using OCCU'
            Aufb=.false.
            Teee=.false.
            Cho_Aufb=.false.
         Else If(FermSet .and. .not.OccSet) Then
*           Write(6,*) 'Using FERM'
            Aufb=.true.
            Teee=.true.
            Cho_Aufb=.true.
         Else
            call WarningMessage(2,
     &                'Internal (logical) error in rdinp_scf')
            Call Abend()
         End If
      End If
      If(SpinSet) Then
         nnn=Int(Tot_Nuc_Charge-Tot_Charge-iAu_ab+0.5d0)
         If((nnn/2)*2.ne.nnn) Then
         call WarningMessage(2, 'Input error!;'//
     &    'zSpin inconsistent with number of electrons')
            Call Abend()
         End If
      End If
*
*---- Check if certain input parameters are not in conflict
*
      If (iCoCo.eq.1.and.iOccu.eq.0) Then
         call WarningMessage(2, 'Input error!;'//
     &     ' The OCCNumber option require that the '//
     &             ' OCCUpied option is specified!')
         Call Abend
      End If
*
      If (Max(nIter(0),nIter(1)).gt.MxIter) Then
         call WarningMessage(1, 'Input error!;'//
     &    'Number of iterations specified in '
     &             //'input exceeds allowed maximum!')
c         Write (6,*) 'nIter(0)=',nIter(0)
c         Write (6,*) 'nIter(1)=',nIter(1)
c         Write (6,*) 'MxIter=',MxIter
c         Write (6,*)
         nIter(0)=MxIter
         nIter(1)=MxIter

c         Write (6,*) 'Number of iteration reset to ',MxIter
c         Write (6,*)
      End If
*
      If (iOrbi.eq.1 .and. (InVec.ne.2 .and. InVec.ne.4)) Then
         call WarningMessage(2, 'Input error!;'//
     &    ' The ORBITAL option can only be used '
     &             //'with input orbitals!;'//
     &    ' Possible exclusive options are: LUMORB RESTART')
         Call Abend
      End If
*
      If (iFroz.eq.1 .and. InVec.eq.3) Then
         call WarningMessage(2, 'Input error!;'//
     &   ' The FROZEN option does not work with an'
     &             //'density matrix input')
         Call Abend
      End If
*
      If (InVec.eq.1 .and. Aufb .and. .not.Cholesky) Then
         call WarningMessage(2, 'Input error!;'//
     &   ' Aufbau not compatible with NDDO option')
         Call Abend
      End If
*
      If (Invec.lt.-1 .or. InVec.gt.9) Then
         call WarningMessage(2, 'Input error!;'//
     &   'inappropriate value for Invec')
         Call Abend
      End If
*
*---- Print out warning informations (if any)
*
      If (iFroz.eq.1 .and. (InVec.eq.2 .or. InVec.eq.4)) Then
         call WarningMessage(1,
     &   'RdInp: Warning!;'//
     &   'Option FROZEN is used together with input orbitals as'
     &       //' initial guess.;' //
     &    'Freezing of orbitals is performed at MO level.;'//
     &    'First orbitals in each symmetry will not be modified.')
      End If
*
      If (Aufb .AND.(iFroz.eq.1)) Then
         Do iSym = 1, nSym
            nAufb(1)=nAufb(1)+nFro(iSym)
          if(iUHF.eq.1) nAufb(2)=nAufb(2)+nFro(iSym)
         End Do
         Call ICopy(nSym,[0],0,nFro,1)
         call WarningMessage(2, 'Input error!;'//
     &    'Aufbau not allowed with frozen orbitals')
         Call Abend()
      End If
*
*---- Check parameters for semi direct SCF
*
*
*---- If semi-direct and I/O buffer value not specified set to
*     default value.
      If (nCore.eq.0.and.nDisc.ne.0) nCore=lDaRec*nSect*2*8/1024
      nCore=((nCore+7)/8)*8
*
*---- Adjust disk size to multiple of I/O buffer
      If (nDisc.ne.0) nDisc=(nDisc*1024+nCore-1)/1024
*
C     nDisc=Min(Int(DiskMx_MByte),nDisc)
      nDisc=Min(10*Allocdisk(),nDisc)
*
*---- Set up parameters that follow from others
*
      If (.Not.Diis .and. .Not.Damping) iDKeep = 0
*
      If (InVec.eq.3 .and. Max(nIter(0),nIter(1)).eq.0) Then
         iPrOrb = 0
         jVOut  = 0
      End If
*
*---- Check Cholesky vs. Aufbau
      If (Aufb .and. DoCholesky) Then
         Cho_Aufb=.true.
c         Write (6,*)
c         Write (6,*) ' ********** WARNING! *********'
c         Write(6,*)' Cholesky SCF runs much slower with AufBau !'
c         Write(6,*)' *** Do you really need AufBau in this case? ***'
c         Write (6,*)
      EndIf
*
*---- Check CONS vs. UHF+OCCU
      If (MxConstr.gt.0 .and. (iUHF+iOCCU).ne.2) Then
         call WarningMessage(2,
     &    'For CONStraints, keywords UHF and OCCUpied are compulsory!')
         Call Abend()
      EndIf
*
*---- Check CONS vs. ADDC
      If (MxConstr.eq.0 .and. Do_Addc  ) Then
         call WarningMessage(0,
     &    ' In absence of CONStraints, ADDCorrelation is de-activated!')
         Do_Addc  =.false.
      EndIf
*
*---- Check CONS vs. SAVE
      If (MxConstr.eq.0 .and. Do_SpinAV) Then
         call WarningMessage(0,
     &      ' In absence of CONStraints, SAVErage is de-activated!')
         Do_SpinAV=.false.
      EndIf
*
      If (Do_SpinAV) DThr=1.0d4 ! reset because it is not meaningful
      If (MxConstr.gt.0) InVec=6
*
*---- Check parameters of KS-DFT
*
      If (KSDFT.ne.'SCF') Then
         If (MiniDn) Then
            If (jPrint.ge.2) Then
            call WarningMessage(0,
     &            ' Minimized-density-differences option turned off!')
            End If
            MiniDn = .False.
         End If
         If (Do_OFemb .and. dFMD.ne.0.0d0) Then
            call WarningMessage(0,
     &      ' KSDFT/OFE requires DFMD=0 for correlation potential!')
            write(6,*) ' dFMD = ',dFMD
         EndIf
      Else
         If (Do_OFemb .and. dFMD.ne.1.0d0) Then
            call WarningMessage(0,
     &      ' HF/OFE may require DFMD=1 for correlation potential!')
            write(6,*) ' dFMD = ',dFMD
         EndIf
      End If
*
      Call Put_iScalar('SCF mode',iUHF)
*
      LKon = ALGO.eq.4
*
      Method='RHF-SCF '
      If (iUHF.eq.1) Method='UHF-SCF '
      If (kIvo.ne.0) Method='IVO-SCF '
      If (KSDFT.ne.'SCF') Method='KS-DFT  '
      Call Put_cArray('Relax Method',Method,8)
*
      ExFac=Get_ExFac(KSDFT)
      If (ExFac.eq.0.0d0 .and. .not.TDen_UsrDef
     &                   .and. .not.Do_OFemb
     &                   .and. .not.DoLDF) Then
         DDnOFF = .false. ! use always differential density
      EndIf
*     DDnOFF = .True.
*     MiniDn = .False.
*                                                                      *
************************************************************************
*                                                                      *
*     remove local copy of standard input
*
      Call Close_LuSpool(LuSpool)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
*
*---- Error exit
  902 Continue
      call WarningMessage(2, 'Input error!;'//
     & 'Error reading input file for OCCNO option')
      Call Abend()
  903 Continue
      call WarningMessage(2, 'Input error!;'//
     & 'End of input file for OCCNO option')
      Call Abend()
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine cre_out()
!***********************************************************************
! creates output h5 file *.rhodyn.h5 as well as ASCII files for
! densities, pulse, dipole moments if needed
!
!***********************************************************************

use rhodyn_data, only: d, DM_basis, flag_decay, flag_dipole, flag_emiss, flag_fdm, flag_pulse, lu_csf, lu_dip, lu_pls, lu_sf, &
                       lu_so, n_freq, nconftot, Npop, Nstate, Nstep, Ntime_tmp_dm, out2_fmt, out3_fmt, out_decay_i, out_decay_r, &
                       out_dm_csf, out_dm_sf, out_dm_so, out_emiss, out_fdm, out_fmt, out_fmt_csf, out_freq, out_ham_i, out_ham_r, &
                       out_id, out_pulse, out_t, out_tfdm, out_tout
use mh5, only: mh5_create_dset_real, mh5_create_file, mh5_init_attr
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i
integer(kind=iwp), external :: isfreeunit
character(len=64) :: out1_fmt, out1_fmt_csf

! write formats for output files SFDENS, SODENS, CSFDENS
! header formats
write(out1_fmt,'(a,i5,a)') '(a22,',Nstate,'(i8,14x),a)'
write(out1_fmt_csf,'(a,i5,a)') '(a22,',nconftot,'(i8,14x),a)'
! line formats
write(out_fmt,'(a,i5,a)') '(1x,',Nstate+2,'(f22.16))'
write(out_fmt_csf,'(a,i5,a)') '(1x,',nconftot+2,'(f22.16))'
out2_fmt = '(2x,a,28x,a,28x,a,28x,a)'
out3_fmt = '(2x,f22.16,1x,f22.16,1x,f22.16,1x,i1,a1,i2.2,a1,i2.2)'

! creating main output file of rhodyn
out_id = mh5_create_file('RDOUT')

call mh5_init_attr(out_id,'MOLCAS_MODULE','RHODYN')

! PULSE
if (flag_pulse) then
  out_pulse = mh5_create_dset_real(out_id,'PULSE',2,[Nstep,6])
  call mh5_init_attr(out_pulse,'description','Pulse')
  ! ascii file
  lu_pls = isfreeunit(lu_pls)
  call molcas_open(lu_pls,'PULSE')
end if

! TIME
out_t = mh5_create_dset_real(out_id,'TIME',1,[Nstep])
call mh5_init_attr(out_t,'description','Complete time grid')

! this set/file is for the diagonal density matrix in CSF basis
if ((DM_basis == 'CSF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'ALL')) then
  out_dm_csf = mh5_create_dset_real(out_id,'DM_CSF',2,[Npop,nconftot])
  call mh5_init_attr(out_dm_csf,'description','Density matrix in CSF basis')
  ! ascii file
  lu_csf = isfreeunit(lu_csf)
  call molcas_open(lu_csf,'CSFDEN')
  write(lu_csf,out1_fmt_csf) '#time(fs)',(i,i=1,nconftot),'Norm'
end if

! this set/file is for the diagonal of density matrix in SO basis
if ((DM_basis == 'SO') .or. (DM_basis == 'CSF_SO') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) then
  out_dm_so = mh5_create_dset_real(out_id,'DM_SO',2,[Npop,Nstate])
  call mh5_init_attr(out_dm_so,'description','Density matrix in SO basis')
  ! ascii file
  lu_so = isfreeunit(lu_so)
  call molcas_open(lu_so,'SODENS')
  write(lu_so,out1_fmt) '#time(fs)',(i,i=1,Nstate),'Norm'
end if

! this set/file is for the diagonal density matrix in SF basis
if ((DM_basis == 'SF') .or. (DM_basis == 'CSF_SF') .or. (DM_basis == 'SF_SO') .or. (DM_basis == 'ALL')) then
  out_dm_sf = mh5_create_dset_real(out_id,'DM_SF',2,[Npop,Nstate])
  call mh5_init_attr(out_dm_sf,'description','Density matrix in SF basis')
  ! ascii file
  lu_sf = isfreeunit(lu_sf)
  call molcas_open(lu_sf,'SFDENS')
  write(lu_sf,out1_fmt) '#time(fs)',(i,i=1,Nstate),'Norm'
end if

! TIME FOR DENSITY OUT
out_tout = mh5_create_dset_real(out_id,'TOUT',1,[Npop])
call mh5_init_attr(out_tout,'description','TOUT step time grid')

! Hamiltonian used for propagation
out_ham_r = mh5_create_dset_real(out_id,'HAM_R',2,[d,d])
call mh5_init_attr(out_ham_r,'description','Hamiltonian used for propagation, real part')
out_ham_i = mh5_create_dset_real(out_id,'HAM_I',2,[d,d])
call mh5_init_attr(out_ham_i,'description','Hamiltonian used for propagation, imaginary part')

! Decay matrix
if (flag_decay) then
  out_decay_r = mh5_create_dset_real(out_id,'DECAY_R',2,[d,d])
  call mh5_init_attr(out_decay_r,'description','Decay matrix, real part')
  out_decay_i = mh5_create_dset_real(out_id,'DECAY_I',2,[d,d])
  call mh5_init_attr(out_decay_i,'description','Decay matrix, imaginary part')
end if

if (flag_emiss) then
  ! frequencies
  out_freq = mh5_create_dset_real(out_id,'FREQ',1,[n_freq])
  call mh5_init_attr(out_freq,'description','frequencies')
  ! emission spectra
  out_emiss = mh5_create_dset_real(out_id,'EMISSION',2,[Npop,n_freq])
  call mh5_init_attr(out_emiss,'description','emission spectrum')
end if

if (flag_fdm) then
  ! TIME steps FOR FULL DENSITY OUT
  out_tfdm = mh5_create_dset_real(out_id,'TFDM',1,[Ntime_tmp_dm])
  call mh5_init_attr(out_tfdm,'description','TFDM grid')
  ! Full density matrix out
  out_fdm = mh5_create_dset_real(out_id,'FDM',3,[Ntime_tmp_dm,d,d])
  call mh5_init_attr(out_fdm,'description','Full density matrix ABS')
end if

! this file is for the TD-dipole moment data
if (flag_dipole) then
  lu_dip = isfreeunit(lu_dip)
  call molcas_open(lu_dip,'DIPOLE')
end if

end subroutine cre_out

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AdV_A23(V1,A,dimij,no)
! this routine does:
! A(ij,u,v) <<- V1(j,iu,v) + V1(i,jv,u)
!
! Velmi odflaknute, da sa to urobit podstatne lepsie, ale
! o4 proces osrat fok

use Index_Functions, only: iTri
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimij, no
real(kind=wp), intent(in) :: V1(no,dimij,no)
real(kind=wp), intent(inout) :: A(dimij,no,no)
integer(kind=iwp) :: i, ij, iu, j, jv, u, v

do v=1,no
  do u=1,no

    ij = 0

    do i=1,no
      iu = iTri(i,u)

      do j=1,i
        ij = ij+1
        jv = iTri(j,v)

        A(ij,u,v) = A(ij,u,v)+V1(j,iu,v)+V1(i,jv,u)

      end do
    end do

  end do
end do

return

end subroutine AdV_A23

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Jonas Bostrom                                    *
************************************************************************

      SubRoutine ChoMP2_Read_Batch(LnPQRSprod,LiPQRSprod,Wrk,lWrk,
     &                             iBatch,jBatch,kXpqrs)
C
C     Jonas Bostrom, Aug 2008. (Generalization and modification of some
C                               stuff in ChoMP2_energy_*)
C
C     Purpose: Reads parts of cholesky vectors from disk and
C              multiply them into two integral batches (or one batch if
C              jBatch=iBatch).
C
      Implicit Real*8 (a-h,o-z)
      Real*8 Wrk(lWrk)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"
*
      Character*15 ThisNm
      Character*25 SecNam
      Parameter (SecNam = 'ChoMP2_Read_Batch',
     &           ThisNm = 'Read_Batch')
*
      Integer nEnrVec(8), LnPQRSprod, LiPQRSprod(8)
      Real*8 X(0:1)
      Data X /0.0D0,1.0D0/
*
      LnPQprod(i,j)=iWork(ip_LnPQprod-1+nSym*(j-1)+i)
*
C     Set number and type of vectors.
C     -------------------------------
*
      iTyp = 1
      Call iCopy(nSym,NumCho,1,nEnrVec,1)
*
*     Allocate memory for integrals.
*     ------------------------------
*
      kXpqrs = 1
      kEnd0  = kXpqrs + LnPQRSprod
      lWrk0  = lWrk   - kEnd0 + 1
      If (lWrk0 .lt. 1) Then
         Call ChoMP2_Quit(SecNam,'insufficient memory','[0]')
      End If
*
C     Special code for iBatch=jBatch and ChoAlg=2:
C     compute M(ab,ij) = (ai|bj) with i<=j using level 3 BLAS.
C     For ChoAlg=1: use strictly lower triangular storage (=>
C     level 2 BLAS).
C     --------------------------------------------------------
*
      If (ChoAlg.eq.2) Then
         Write(6,*) 'No support for Cholesky algorithm 2'
      Else
*
C     Loop over Cholesky vector symmetries.
C     -------------------------------------
*
         Do iSym = 1,nSym
*
            Nai = LnPQprod(iSym,iBatch)
            Nbj = LnPQprod(iSym,jBatch)
            If ((Nai.gt.0) .and. (Nbj.gt.0) .and.
     &           (nEnrVec(iSym).gt.0)) Then
*
*
C     Allocate memory for reading 1 vector.
C     -------------------------------------
*
               kRead = kEnd0
               If(nBatch .ne. 1) Then
                  kEnd1 = kRead + nPQ_prod(iSym)
                  lWrk1 = lWrk  - kEnd1 + 1
                  If (lWrk1 .lt. 1) Then
                     Call ChoMP2_Quit(SecNam,'insufficient memory',
     &                    '[0.1]')
                  End If
               Else
                  kEnd1 = kRead
                  lWrk1 = lWrk0
               End If
*
C     Setup Cholesky vector batching.
C     -------------------------------
*
               If (jBatch .eq. iBatch) Then
                  MinMem = Nai
               Else
                  MinMem = Nai + Nbj
               End If
               NumVec = min(lWrk1/MinMem,nEnrVec(iSym))
               If (NumVec .lt. 1) Then
                  Call ChoMP2_Quit(SecNam,'insufficient memory',
     &                 '[1]')
               End If
               nBat = (nEnrVec(iSym) - 1)/NumVec + 1
*
*     Open Cholesky vector file.
*     --------------------------
*
               Call ChoMP2_OpenF(1,iTyp,iSym)
*
C     Cholesky vector batch loop.
C     ---------------------------
*
               Do iBat = 1,nBat
*
                  If (iBat .eq. nBat) Then
                     NumV = nEnrVec(iSym) - NumVec*(nBat-1)
                  Else
                     NumV = NumVec
                  End If
                  iVec1 = NumVec*(iBat-1) + 1
*
                  kVai = kEnd1
                  kVbj = 0
                  kEnd2 = 0
                  lWrk2 = 0
                  If(nBatch .ne. 1) Then
                     kVbj = kVai + Nai*NumV
                     If (jBatch .eq. iBatch) Then
                        kEnd2 = kVbj
                        kVbj  = kVai
                     Else
                        kEnd2 = kVbj + Nbj*NumV
                     End If
                     lWrk2 = lWrk - kEnd2 + 1
                     If (lWrk2 .lt. 0) Then ! this would be a bug...
                        Call ChoMP2_Quit(SecNam,
     &                       'insufficient memory',
     &                       '[2]')
                     End If
                  End If

*
C     Read vectors, copy out sub-blocks.
C     ----------------------------------
*
                  If(nBatch.eq.1) Then
*
                     iOpt = 2
                     lTot = nPQ_prod(iSym)*NumV
                     iAdr = nPQ_prod(iSym)*(iVec1 - 1) + 1
                     Call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVai),
     &                            lTot,iAdr)
                  Else
                     Do iVec = 1,NumV
*
                        jVec = iVec1 + iVec - 1
                        iOpt = 2
                        lTot = nPQ_prod(iSym)
                        iAdr = nPQ_prod(iSym)*(jVec-1) + 1
                        Call ddaFile(lUnit_F(iSym,iTyp),iOpt,
     &                       Wrk(kRead),lTot,iAdr)
                        kOff = kVai + Nai*(iVec - 1)
                        Call ChoMP2_Srt(Wrk(kRead),Wrk(kOff),
     &                                  1,iSym,iBatch)
                        If (jBatch .ne. iBatch) Then
                           kOff = kVbj + Nbj*(iVec - 1)
                           Call ChoMP2_Srt(Wrk(kRead),Wrk(kOff),
     &                          1,iSym,jBatch)
                        End If
                     End Do
                  End If
*
C     Compute integral contribution.
C     ------------------------------
*
                  Fac   = X(min((iBat-1),1))
                  kXint = kXpqrs + LiPQRSprod(iSym)
                  If (iBatch .eq. jBatch) Then
                     Call dGeMM_Tri('N','T',Nai,Nai,NumV,
     &                    1.0D0,Wrk(kVai),Nai,
     &                    Wrk(kVai),Nai,
     &                    Fac,Wrk(kXint),Nai)
                  Else
                     Call DGEMM_('N','T',Nai,Nbj,NumV,
     &                    1.0D0,Wrk(kVai),Nai,Wrk(kVbj),Nbj,
     &                    Fac,Wrk(kXint),Nai)
                  End If
               End Do           ! Cholesky vector batch
*
C     Close Cholesky vector files.
C     ----------------------------
*
               Call ChoMP2_OpenF(2,iTyp,iSym)
*
            End If
*
         End Do                 ! iSym
*
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine MKBNEVD(nAshT,NG3,Hbar,Gact,G1,G2,G3,idxG3)

use Index_Functions, only: iTri, nTri_Elem
use caspt2_global, only: LUSBT
use caspt2_module, only: IASYM, NINDEP, NSYM, NTU, NTUES
use EQSOLV, only: IDBMAT
use SUPERINDEX, only: KTU, MTU
use nevpt2_mod, only: ex2, ex3
use Symmetry_Info, only: Mul
use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: nAshT, NG3
real(kind=wp), intent(in) :: Hbar(nAshT,nAshT), Gact(nAshT,nAshT,nAshT,nAshT), G1(nAshT,nAshT), G2(nAshT,nAshT,nAshT,nAshT), G3(*)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: IB11, IB12, IB21, IB22, id, IDISK, iG3, IST, ISU, ISV, ISX, ISY, ISYM, ISZ, IT, ITABS, ITU, ITU2, ITUABS, &
                     ITUVS, IU, IUABS, IV, IVABS, IVX, IW, IWABS, IX, IXABS, IXY, IXY2, IXYABS, IXYZS, IY, IYABS, IYZ, IZ, IZABS, &
                     NAS, NBD
real(kind=wp) :: B11, B22, G3VAL, tmp
real(kind=wp), allocatable :: BD(:), BD1(:), BD2(:)

do ISYM=1,NSYM
  if (NINDEP(ISYM,5) == 0) cycle
  NAS = NTU(ISYM)
  NBD = nTri_Elem(2*NAS)
  if (NBD > 0) then
    call mma_Allocate(bD,NBD,LABEL='BD')
    call mma_Allocate(bD1,nTri_Elem(NAS),LABEL='BD1')
    call mma_Allocate(bD2,nTri_Elem(NAS),LABEL='BD2')
  end if
  BD(:) = Zero
  BD1(:) = Zero
  BD2(:) = Zero
  call Init_Tsk(ID,Nas)

  !do ITU=1,NAS
  !  if (.not. Rsv_Tsk(ID,ITU)) cycle
  do while (Rsv_Tsk(id,ITU))
    !ITU2 = ITU+NAS
    ITUABS = ITU+NTUes(ISYM)
    ITABS = MTU(1,ITuabS)
    IUABS = MTU(2,ITuabS)
    do IXY=1,ITU
      !IXY2 = IXY+NAS
      IXYABS = IXY+NtueS(ISYM)
      IXABS = MTU(1,ixyABS)
      IYABS = MTU(2,ixyABS)
      IB11 = iTri(ITU,IXY)
      !IB21 = iTri(ITU2,IXY)
      !IB12 = iTri(IXY2,ITU)
      !IB22 = iTri(ITU2,IXY2)

      !! A matrix
      B11 = Zero
      do IV=1,NASHT
        IVABS = IV
        !B11 = B11+hbar(IVABS,IXABS)*G2(IUABS,ITABS,IVABS,IYABS)
        !if (ITABS == IVABS) B11 = B11+Hbar(IVABS,IXABS)*G1(IUABS,IYABS)
        !B11 = B11-hbar(IYABS,IVABS)*G2(IUABS,ITABS,IXABS,IVABS)
        !if (ITABS == IXABS) B11 = B11-Hbar(IYABS,IVABS)*G1(IUABS,IVABS)
        B11 = B11+Hbar(IVABS,IXABS)*ex2(IUABS,ITABS,IVABS,IYABS,G1,G2)
        B11 = B11-Hbar(IYABS,IVABS)*ex2(IUABS,ITABS,IXABS,IVABS,G1,G2)
      end do

      !! D matrix (hbar terms)
      B22 = Zero
      do IV=1,NASHT
        IVABS = IV
        !! tilde{E}_{ab} = 2 \delta_{a,b} - E_{ba}
        tmp = -ex2(IxabS,ITABS,IUABS,IVABS,G1,G2)
        if (ITABS == ixABS) tmp = tmp+Two*G1(IUABS,IVABS)
        if (IUABS == itABS) tmp = tmp+G1(IVABS,IXABS)
        B22 = B22-Hbar(IYABS,IVABS)*tmp
        tmp = -ex2(IvabS,ITABS,IUABS,IYABS,G1,G2)
        if (ITABS == ivABS) tmp = tmp+Two*G1(IUABS,IYABS)
        if (IUABS == itABS) tmp = tmp+G1(IYABS,IVABS)
        B22 = B22+Hbar(IVABS,IXABS)*tmp
      end do

      !! D matrix (erI terms)
      do IV=1,NASHT
        IVABS = IV
        do IW=1,NASHt
          IWABS = IW
          do IZ=1,NAsht
            IZABS = iz
            tmp = Zero
            if (ITABs == IXABS) tmp = tmp+Two*ex2(IVABS,IZABS,IUABS,IWABS,G1,G2)
            if (ITABs == IXABS) tmp = tmp+Two*ex2(IUABS,IWABS,IVABS,IZABS,G1,G2)
            if (IUABs == ITABS) tmp = tmp+ex2(IVABS,IZABS,IXABS,IWABS,G1,G2)
            if (IUABs == ITABS) tmp = tmp+ex2(IXABS,IWABS,IVABS,IZABS,G1,G2)
            if ((ITABs == IVABS) .and. (IZABS == IXABS)) tmp = tmp+Two*G1(IUABS,IWABS)
            if (ITABs == IVABS) tmp = tmp-ex2(IXABS,IZABS,IUABS,IWABS,G1,G2)
            if ((IUABs == IZABS) .and. (IXABS == ITABS)) tmp = tmp-Two*G1(IVABS,IWABS)
            if (IUABs == IZABS) tmp = tmp+ex2(IXABS,ITABS,IVABS,IWABS,G1,G2)
            B22 = B22-half*tmp*Gact(IVABS,IZABS,IYABS,IWABS)

            tmp = Zero
            if (ITABs == IWABS) tmp = tmp+Two*ex2(IVABS,IZABS,IUABS,IYABS,G1,G2)
            if (ITABs == IWABS) tmp = tmp+Two*ex2(IUABS,IYABS,IVABS,IZABS,G1,G2)
            if (IUABs == ITABS) tmp = tmp+ex2(IVABS,IZABS,IWABS,IYABS,G1,G2)
            if (IUABs == ITABS) tmp = tmp+ex2(IWABS,IYABS,IVABS,IZABS,G1,G2)
            if ((ITABs == IVABS) .and. (IZABS == IWABS)) tmp = tmp+Two*G1(IUABS,IYABS)
            if (ITABs == IVABS) tmp = tmp-ex2(IWABS,IZABS,IUABS,IYABS,G1,G2)
            if ((IUABs == IZABS) .and. (ITABS == IWABS)) tmp = tmp-Two*G1(IVABS,IYABS)
            if (IUABs == IZABS) tmp = tmp+ex2(IWABS,ITABS,IVABS,IYABS,G1,G2)
            B22 = B22+half*tmp*Gact(IVABS,IZABS,IWABS,IXABS)
          end do
        end do
      end do

      BD1(IB11) = B11
      BD2(IB11) = B22
    end do
  end do
  call Free_Tsk(ID)

  do IG3=1,NG3
    iT = idxG3(1,iG3)
    iU = idxG3(2,iG3)
    iV = idxG3(3,iG3)
    iX = idxG3(4,iG3)
    iY = idxG3(5,iG3)
    iZ = idxG3(6,iG3)
    iST = IASYM(iT)
    iSU = IASYM(iU)
    iSV = IASYM(iV)
    iSX = IASYM(iX)
    iSY = IASYM(iY)
    iSZ = IASYM(iZ)
    ituvs = MUL(IST,mul(ISU,ISV))
    ixyzs = MUL(ISX,mul(ISY,ISZ))
    if (ituvs /= ixyzs) cycle
    iTU = iT+NASHT*(iu-1)
    iVX = iV+NASHT*(ix-1)
    iYZ = iY+NASHT*(iz-1)

    ! G3(tuvxyz) = <psi|t+ v+ y+ z x u|Psi>
    !G3VAL = tG3(IT,iu,IV,IX,IY,IZ,G1,G2,G3(iG3))

    ! D(tuvxyz)
    if ((MUL(iSU,iST) == iSym) .or. (MUL(iSU,ISV) == iSym) .or. (MUL(iSX,iSY) == iSym)) then
      G3VAL = ex3(IT,iu,IV,IX,IY,IZ,G1,G2,G3(iG3))
      call Add_MKBNEvd(iT,iU,iV,iX,iY,iZ)
    end if

    if ((iTU /= iVX) .or. (iVX /= iYZ)) then
      if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
        ! D(vxtuyz)
        if ((MUL(iSX,isv) == iSym) .or. (MUL(iSX,iST) == iSym) .or. (MUL(iSU,iSY) == iSym)) then
          G3VAL = ex3(iV,IX,IT,IU,IY,IZ,G1,G2,G3(iG3))
          call Add_MkbnEVD(iV,iX,iT,iU,iY,iZ)
        end if
        ! D(yzvxtu)
        if ((MUL(iSZ,isy) == iSym) .or. (MUL(iSZ,iSV) == iSym) .or. (MUL(iSX,iST) == iSym)) then
          G3VAL = ex3(iY,IZ,IV,IX,IT,IU,G1,G2,G3(iG3))
          call Add_MkbnEVD(iY,iZ,iV,iX,iT,iU)
        end if
        ! D(tuyzvx)
        if ((MUL(iSU,ist) == iSym) .or. (MUL(iSU,iSY) == iSym) .or. (MUL(iSZ,iSV) == iSym)) then
          G3VAL = ex3(iT,IU,IY,IZ,IV,IX,G1,G2,G3(iG3))
          call Add_MkbnEVD(iT,iU,iY,iZ,iV,iX)
        end if
      end if
      ! D(yztuvx)
      if ((MUL(iSZ,iSy) == iSym) .or. (MUL(iSZ,iST) == iSym) .or. (MUL(iSU,iSV) == iSym)) then
        G3VAL = ex3(iy,IZ,IT,IU,IV,IX,G1,G2,G3(iG3))
        call Add_MKBnevD(iY,iZ,iT,iU,iV,iX)
      end if
      ! D(vxyztu)
      if ((MUL(iSX,iSv) == iSym) .or. (MUL(iSX,iSY) == iSym) .or. (MUL(iSZ,iST) == iSym)) then
        G3VAL = ex3(iv,IX,IY,IZ,IT,IU,G1,G2,G3(iG3))
        call Add_MKBnevD(iV,iX,iY,iZ,iT,iU)
      end if
    end if

    if ((iT == iU) .and. (iV == iX) .and. (iY == iZ)) cycle
    if ((iT == iU) .and. (iV == iZ) .and. (iX == iY)) cycle
    if ((iX == iV) .and. (iT == iZ) .and. (iU == iY)) cycle
    if ((iZ == iY) .and. (iV == iU) .and. (iX == iT)) cycle

    ! D(utxvzy)
    if ((MUL(iST,iSU) == iSym) .or. (MUL(iST,iSX) == iSym) .or. (MUL(iSV,iSZ) == iSym)) then
      G3VAL = ex3(IU,it,IX,IV,IZ,IY,G1,G2,G3(iG3))
      call Add_MKBNEvd(iU,iT,iX,iV,iZ,iY)
    end if

    if ((iTU == iVX) .and. (iVX == iYZ)) cycle
    if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
      ! D(xvutzy)
      if ((MUL(iSV,iSx) == iSym) .or. (MUL(iSV,iSU) == iSym) .or. (MUL(iST,iSZ) == iSym)) then
        G3VAL = ex3(ix,IV,IU,IT,IZ,IY,G1,G2,G3(iG3))
        call Add_MKBnevD(iX,iV,iU,iT,iZ,iY)
      end if
      ! D(zyxvut)
      if ((MUL(iSY,iSz) == iSym) .or. (MUL(iSY,iSX) == iSym) .or. (MUL(iSV,iSU) == iSym)) then
        G3VAL = ex3(iz,IY,IX,IV,IU,IT,G1,G2,G3(iG3))
        call Add_MKBnevD(iZ,iY,iX,iV,iU,iT)
      end if
      ! D(utzyxv)
      if ((MUL(iST,iSu) == iSym) .or. (MUL(iST,iSZ) == iSym) .or. (MUL(iSY,iSX) == iSym)) then
        G3VAL = ex3(iu,IT,IZ,IY,IX,IV,G1,G2,G3(iG3))
        call Add_MKBnevD(iU,iT,iZ,iY,iX,iV)
      end if
    end if
    ! D(zyutxv)
    if ((MUL(iSY,iSZ) == iSym) .or. (MUL(iSY,iSU) == iSym) .or. (MUL(iST,iSX) == iSym)) then
      G3VAL = ex3(IZ,iy,IU,IT,IX,IV,G1,G2,G3(iG3))
      call Add_MKBNEvd(iZ,iY,iU,iT,iX,iV)
    end if
    ! D(xvzyut)
    if ((MUL(iSV,iSX) == iSym) .or. (MUL(iSV,iSZ) == iSym) .or. (MUL(iSY,iSU) == iSym)) then
      G3VAL = ex3(IX,iv,IZ,IY,IU,IT,G1,G2,G3(iG3))
      call Add_MKBNEvd(iX,iV,iZ,iY,iU,iT)
    end if
  end do

  do ITU=1,NAS
    ITU2 = ITU+NAS
    ITUABS = ITU+NTUes(ISYM)
    ITABS = MTU(1,ITuabS)
    IUABS = MTU(2,ITuabS)
    do IXY=1,ITU
      IXY2 = IXY+NAS
      IXYABS = IXY+NtueS(ISYM)
      IXABS = MTU(1,ixyABS)
      IYABS = MTU(2,ixyABS)
      IB11 = iTri(ITU,IXY)
      IB21 = iTri(ITU2,IXY)
      IB12 = iTri(IXY2,ITU)
      IB22 = iTri(ITU2,IXY2)

      B11 = Two*BD1(ib11)
      B22 = BD2(IB11)

      BD(IB11) = B11
      BD(IB21) = -Half*B11
      BD(IB12) = -Half*B11
      BD(IB22) = B22
    end do
  end do

# ifdef _MOLCAS_MPP_
  if (is_real_par()) call GADGOP(BD,NBD,'+')
# endif

  if ((NBD > 0) .and. (ninDEP(ISYM,5) > 0)) then
    IDISK = IDBMAT(Isym,5)
    call DDAFILE(LUSbt,1,BD,NBD,IDISK)
    call mma_deallocate(BD)
    call mma_deallocate(BD1)
    call mma_deallocate(BD2)
  end if
end do

contains

subroutine Add_MKBNEvd(ITABS_,IUABS_,IVABS_,IXABS_,IYABS_,IZABS_)

  integer(kind=iwp), intent(in) :: ITABS_, IUABS_, IVABS_, IXABS_, IYABS_, IZABS_
  integer(kind=iwp) :: IBADR, ITU_, IWABS, IXY_

  !! A
  iTU_ = KTU(IUABS_,itaBS_)-NTUES(ISYM)
  if (MUL(IASYM(IUABs_),IASYM(ITABS_)) == iSym) then
    do IWABS=1,nAshT
      !! A(a'b',ab) = (ce|da) E(b'a',ce,db) --> A(ut,wz) = (vx|yw) E(tu,vx,yz)
      if (MUL(IASYM(iwaBS),IASYM(IZABS_)) == iSym) then
        iXY_ = KTU(IwabS,IZABS_)-NTUES(ISYM)
        if (iTU_ >= ixy_) then
          IBADR = iTri(iTu_,iXY_)
          BD1(IBADR) = BD1(IBADR)+Half*G3VAL*Gact(IVABS_,IXABS_,IYABS_,IWABS)
        end if
      end if
      !! A(a'b',ab) = (ce|da) E(b'a',db,ce) --> A(ut,wx) = (yz|vw) E(tu,vx,yz)
      if (MUL(IASYM(iwaBS),IASYM(IXABS_)) == iSym) then
        iXY_ = KTU(IwabS,IXABS_)-NTUES(ISYM)
        if (iTU_ >= ixy_) then
          IBADR = iTri(iTu_,iXY_)
          BD1(IBADR) = BD1(IBADR)+Half*G3VAL*Gact(IYABS_,IZABS_,IVABS_,IWABS)
        end if
      end if

      !! A(a'b',ab) = (be|cd) E(b'a',ae,cd) --> A(ut,vw) = (wx|yz) E(tu,vx,yz)
      if (MUL(IASYM(ivaBS_),IASYM(IWABS)) == iSym) then
        iXY_ = KTU(IvabS_,IWABS)-NTUES(ISYM)
        if (iTU_ >= ixy_) then
          IBADR = iTri(iTu_,iXY_)
          BD1(IBADR) = BD1(IBADR)-Half*G3VAL*Gact(IWABS,IXABS_,IYABS_,IZABS_)
        end if
      end if
      !! A(a'b',ab) = (be|cd) E(b'a',cd,ae) --> A(ut,yw) = (wz|vx) E(tu,vx,yz)
      if (MUL(IASYM(iyaBS_),IASYM(IWABS)) == iSym) then
        iXY_ = KTU(IyabS_,IWABS)-NTUES(ISYM)
        if (iTU_ >= ixy_) then
          IBADR = iTri(iTu_,iXY_)
          BD1(IBADR) = BD1(IBADR)-Half*G3VAL*Gact(IWABS,IZABS_,IVABS_,IXABS_)
        end if
      end if
    end do
  end if

  !! D
  do IWABS=1,nAshT
    !! D(a'b',ab) = -(ce|bd) E(ce,aa',b'd) --> D(xy,vw) = -(tu|wz) E(tu,vx,yz)
    iTU_ = KTU(IXABS_,iYABS_)-NTUES(ISYM)
    if (MUL(IASYM(IXabs_),IASYM(IYABS_)) == iSym) then
      if (MUL(IASYM(ivaBS_),IASYM(IWABS)) == iSym) then
        iXY_ = KTU(IvabS_,IWABS)-NTUES(ISYM)
        if (iTU_ >= ixy_) then
          IBADR = iTri(iTu_,iXY_)
          BD2(IBADR) = BD2(IBADR)+Half*G3VAL*Gact(ITABS_,IUABS_,IWABS,IZABS_)
        end if
      end if
    end if
    !! D(a'b',ab) = -(ce|bd) E(aa',b'd,ce) --> D(uv,tw) = -(yz|wx) E(tu,vx,yz)
    iTU_ = KTU(IUABS_,iVABS_)-NTUES(ISYM)
    if (MUL(IASYM(IUabs_),IASYM(IVABS_)) == iSym) then
      if (MUL(IASYM(itaBS_),IASYM(IWABS)) == iSym) then
        iXY_ = KTU(ItabS_,IWABS)-NTUES(ISYM)
        if (iTU_ >= ixy_) then
          IBADR = iTri(iTu_,iXY_)
          BD2(IBADR) = BD2(IBADR)+Half*G3VAL*Gact(IYABS_,IZABS_,IWABS,IXABS_)
        end if
      end if
    end if

    !! D(a'b',ab) = +(ce|da) E(ce,da',b'b) --> D(xy,wz) = +(tu|vw) E(tu,vx,yz)
    iTU_ = KTU(IXABS_,iYABS_)-NTUES(ISYM)
    if (MUL(IASYM(IXabs_),IASYM(IYABS_)) == iSym) then
      if (MUL(IASYM(iwaBS),IASYM(IZABS_)) == iSym) then
        iXY_ = KTU(IwabS,IZABS_)-NTUES(ISYM)
        if (iTU_ >= ixy_) then
          IBADR = iTri(iTu_,iXY_)
          BD2(IBADR) = BD2(IBADR)-Half*G3VAL*Gact(ITABS_,IUABS_,IVABS_,IWABS)
        end if
      end if
    end if
    !! D(a'b',ab) = +(ce|da) E(da',b'b,ce) --> D(uv,wx) = +(yz|tw) E(tu,vx,yz)
    iTU_ = KTU(IUABS_,iVABS_)-NTUES(ISYM)
    if (MUL(IASYM(IUabs_),IASYM(IVABS_)) == iSym) then
      if (MUL(IASYM(iwaBS),IASYM(IXABS_)) == iSym) then
        iXY_ = KTU(IwabS,IXABS_)-NTUES(ISYM)
        if (iTU_ >= ixy_) then
          IBADR = iTri(iTu_,iXY_)
          BD2(IBADR) = BD2(IBADR)-Half*G3VAL*Gact(IYABS_,IZABS_,ITABS_,IWABS)
        end if
      end if
    end if
  end do

end subroutine Add_MkbnEVD

end subroutine MKBNEvd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine MkAno()

use Genano_globals, only: MxLqn, nPrim, Ssym, tDSym, thr, rowise, Title, symlab
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: Lu, i, iLqn, ind, iPtr, j, k, l, n, nBig, nOccNo, nTri, nContr(0:MxLqn)
real(kind=wp) :: ChkSum, p, t
real(kind=wp), allocatable :: s(:), u(:), c(:), d(:), q(:), OccNo(:)
integer(kind=iwp), external :: IsFreeUnit

Lu = IsFreeUnit(17)
call molcas_open(Lu,'ANO')
iPtr = 1
write(u6,*)
call CollapseOutput(1,'   Contraction coefficients')
write(u6,'(3x,a)') '   ------------------------'

call mma_allocate(OccNo,sum(nPrim),label='OccNo')

! Loop over angular quantum number

nOccNo = 0
ChkSum = Zero
do iLqn=0,MxLqn
  n = nPrim(iLqn)
  nContr(iLqn) = 0
  if (n <= 0) cycle
  write(u6,*)
  write(u6,*) '*** Contraction coefficients for the ',symlab(iLqn*(iLqn+1)+1)(3:3),' shell ***'
  write(u6,*)
  nTri = n*(n+1)/2
  call mma_allocate(s,nTri,label='s')
  call mma_allocate(u,n*n,label='u')
  u(:) = Zero
  do i=1,n
    ind = i+(i-1)*n
    u(ind) = One
  end do
  do i=1,nTri
    s(i) = Ssym(iPtr-1+i)
  end do
  !call TriPrt('s matrix','(6f12.6)',s,n)
  !write(u6,*) 'u matrix'
  !call sqprt(u,n)
  call Jacob(s,u,n,n)
  !call TriPrt('s matrix','(6f12.6)',s,n)
  !write(u6,*) 'u matrix'
  !call sqprt(u,n)
  !write(u6,*)
  do i=1,n
    s(i) = sqrt(s(i*(i+1)/2))
  end do
  call mma_allocate(c,n*n,label='c')
  call mma_allocate(q,n*n,label='c')
  do i=1,n
    do j=1,n
      t = Zero
      p = Zero
      do k=1,n
        t = t+u(i+(k-1)*n)/s(k)*u(j+(k-1)*n)
        p = p+u(i+(k-1)*n)*s(k)*u(j+(k-1)*n)
      end do
      c(j+(i-1)*n) = t
      q(j+(i-1)*n) = p
    end do
  end do
  call mma_deallocate(s)
  call mma_deallocate(u)
  call mma_allocate(d,nTri,label='d')
  do i=1,n
    do j=1,i
      t = Zero
      do k=1,n
        do l=1,n
          ind = min(k,l)+max(k,l)*(max(k,l)-1)/2
          p = q(i+(k-1)*n)*tDsym(ind+iPtr-1)*q(j+(l-1)*n)
          !write(u6,'(a,f12.6)') '   p:',p
          t = t+p
        end do
      end do
      d(j+i*(i-1)/2) = t
    end do
  end do
  call mma_deallocate(q)
  !call TriPrt('d matrix','(6f12.6)',d,n)
  !write(u6,*) 'c matrix'
  !call sqprt(c,n)
  call Jacob(d,c,n,n)
  !call TriPrt('d matrix','(6f12.6)',d,n)
  !write(u6,*) 'c matrix'
  !call sqprt(c,n)
  !write(u6,*)
  nBig = 0
  do i=1,n
    d(i) = d(i*(i+1)/2)
    if (d(i) > thr) nBig = nBig+1
  end do
  !nBig = n
  nContr(iLqn) = nBig
  call Sort_genano(d,c,n,n)
  do i=1,nContr(iLqn)
    OccNo(i+nOccNo) = d(i)
  end do
  nOccNo = nOccNo+nContr(iLqn)
  !write(u6,*) 'c matrix'
  !call sqprt(c,n)
  call NOphase(c,n)
  !write(u6,*) 'c matrix'
  !call sqprt(c,n)
  !write(u6,*)
  write(u6,'(a,10(1x,f9.4))') 'occ    ',(d(i),i=1,nBig)
  write(u6,'(a,10(1x,f9.4))') 'lg(occ)',(log10(d(i)+1.0e-12_wp),i=1,nBig)
  write(u6,*)

  do j=1,n
    write(u6,'(7x,10(1x,f9.4))') (c(j+(i-1)*n),i=1,nBig)
  end do
  do i=1,nBig
    do j=1,n
      do k=1,n
        ChkSum = ChkSum+d(i)*c(j+(i-1)*n)*c(k+(i-1)*n)
      end do
    end do
  end do
  !write(Lu,*) 'Coefficients for the ',symlab(iLqn*(iLqn+1)+1),' shell.'
  !write(Lu,*)
  write(Lu,'(2i5)') n,nBig
  if (rowise) then
    if (n*nBig > 0) then
      do i=1,nBig
        write(Lu,'(10(1x,f15.10))') (c(j+(i-1)*n),j=1,n)
      end do
    end if
  else
    if (n*nBig > 0) then
      do j=1,n
        write(Lu,'(10(1x,f15.10))') (c(j+(i-1)*n),i=1,nBig)
      end do
    end if
  end if
  call mma_deallocate(c)
  call mma_deallocate(d)
  !write(Lu,*)
  !write(Lu,*)
  iPtr = iPtr+(2*iLqn+1)*nTri
end do
call CollapseOutput(0,'   Contraction coefficients')
write(u6,*)
!write(u6,'(a,f12.6)') 'Check sum is',ChkSum
call Add_Info('GENANO_CHKSUM',[ChkSum],1,5)
close(Lu)
Lu = IsFreeUnit(18)
call molcas_open(Lu,'FIG')
call FigOpn(Lu)
call FigPrt(Lu,Title,MxLqn,nContr,OccNo)
call FigCls(Lu)
close(Lu)
call mma_deallocate(OccNo)

return

end subroutine MkAno

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE MAX_OPEN_ORB(MAXOP,IOCLS,NGAS,NOCLS,NOBPT)
*
* Max number of open orbitals in occupation classes
*
* Jeppe Olsen, November 2001
*
#include "implicit.fh"
#include "csfbas.fh"
*. Input
      INTEGER IOCLS(NGAS,NOCLS)
      INTEGER NOBPT(NGAS)
*
      MAXOP = 0
C?    WRITE(6,*) ' NOCLS, NGAS = ', NOCLS, NGAS
      DO JOCLS = 1, NOCLS
        MAXOP_J = 0
        DO IGAS = 1, NGAS
          NEL = IOCLS(IGAS,JOCLS)
          NORB = NOBPT(IGAS)
C?        WRITE(6,*) ' IGAS, NEL, NORB = ', IGAS, NEL, NORB
          MAXOP_IGAS = MIN(NEL,2*NORB-NEL)
          MAXOP_J = MAXOP_J + MAXOP_IGAS
        END DO
        MAXOP = MAX(MAXOP,MAXOP_J)
      END DO
      maxop_lucia=maxop
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
     &  ' Max number of unpaired orbitals = ', MAXOP
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Per Ake Malmqvist                                *
*               1996, Roland Lindh                                     *
************************************************************************
      SubRoutine AMPInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for computing matrix elements of the          *
*         six hermitized products of two angular momentum ops          *
*                                                                      *
*     Author: Per-Ake Malmqvist, Dept. of Theoretical Chemistry,       *
*             University of Lund, SWEDEN                               *
*             November '96                                             *
*     After pattern of other SEWARD soubroutines by R. Lindh.          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local Variables
      Real*8 TC(3)
      Integer iStabO(0:7), iDCRT(0:7)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = ((ixyz+1)*(ixyz+2))/2
*
      iRout = 220
      iPrint = nPrint(iRout)
*
      nip = 1
      ipB = nip
      nip = nip + nZeta
      ipTpp = nip
      nip = nip + nZeta*nElem(la)*nElem(lb+2)*6
      ipTp  = nip
      nip = nip + nZeta*nElem(la)*nElem(lb+1)*3
      ipT   = nip
      nip = nip + nZeta*nElem(la)*nElem(lb  )*6
      ipTm  = 1
      ipTmm = 1
      if(lb.gt.0) then
        ipTm  = nip
        nip = nip + nZeta*nElem(la)*nElem(lb-1)*3
        if(lb.gt.1) then
          ipTmm = nip
          nip = nip + nZeta*nElem(la)*nElem(lb-2)*6
        end if
      end if
      ipRes=nip
      nip = nip + nZeta*nElem(la)*nElem(lb)*nComp
      If (nip-1.gt.nZeta*nArr) Then
         Call WarningMessage(2,' AMPInt: nip-1.gt.nZeta*nArr')
         call Abend()
      End If
      ipArr = nip
      mArr = (nArr*nZeta - (nip-1))/nZeta

      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)

      ipOff = ipB
      Do iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipOff),nAlpha)
         ipOff = ipOff + 1
      End Do

      llOper = lOper(1)
      Do iComp = 2, nComp
         iDum=lOper(iComp)
         llOper = iOr(llOper,iDum)
      End Do

C Compute stabilizer, and then the double coset representation:
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

C Loop over the cosets of the stabilizer group:
      Do lDCRT = 0, nDCRT-1
         Call OA(iDCRT(lDCRT), Ccoor, TC)


C Generate the quadrupole integral tables:
         iComp=6
         iOrdOp = 2
         nHer = (la + (lb+2) + 2 + 2) / 2
         Call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,
     &             Array(ipTpp),nZeta,iComp,la,lb+2,A,RB,nHer,
     &             Array(ipArr),mArr,TC,iOrdOp)
         nHer = (la +  lb    + 2 + 2) / 2
         Call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,
     &             Array(ipT  ),nZeta,iComp,la,lb  ,A,RB,nHer,
     &             Array(ipArr),mArr,TC,iOrdOp)
         if(lb.ge.2) then
           nHer = (la + (lb-2) + 2 + 2) / 2
           Call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,
     &               Array(ipTmm),nZeta,iComp,la,lb-2,A,RB,nHer,
     &               Array(ipArr),mArr,TC,iOrdOp)
         end if
C Generate the dipole integral tables:
         iComp=3
         iOrdOp = 1
         nHer = (la + (lb+1) + 1 + 2) / 2
         Call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,
     &             Array(ipTp ),nZeta,iComp,la,lb+1,A,RB,nHer,
     &             Array(ipArr),mArr,TC,iOrdOp)
         if(lb.ge.1) then
           nHer = (la + (lb-1) + 1 + 2) / 2
           Call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,
     &               Array(ipTm ),nZeta,iComp,la,lb-1,A,RB,nHer,
     &               Array(ipArr),mArr,TC,iOrdOp)
         end if

         if(iprint.gt.49) write(6,*)' AMPInt calling AMPr.'
         Call AMPr(Array(ipB),nZeta,Array(ipRes),la,lb,Array(ipTpp),
     &             Array(ipTp),Array(ipT),Array(ipTm),Array(ipTmm))

C Symmetry adaption:
         if(iprint.gt.49) write(6,*)' AMPInt calling SymAdO'
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array(ipRes),nZeta,la,lb,nComp,Final,nIC,
     &               nOp,lOper,iChO,One)
         if(iprint.gt.49) write(6,*)' Back to AMPInt.'
      End Do

      if(iprint.gt.49) write(6,*)' Leaving AMPInt.'
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nOrdOp)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_W_worker

use fmm_global_paras, only: INTK, REALK, LUPRI, ZERO_VECT_TOL, Zero, One, Half
use fmm_utils, only: fmm_quit

implicit none
private
! Public procedures
public :: fmm_get_ltsqr_W_matrix, &
          fmm_get_boundary_W_matrix, &
          fmm_contract_Wq

contains

!-------------------------------------------------------------------------------
! Routine to build the lower-triangular elements of a square W_matrix.
! Only the non-zero elements of the full square matrix are written.
! LMAX is the order of translation:
!  W_lm,jk is built for all l and j <= LMAX
! r_ab is the translation vector (final-initial).
! (note to translate a potential -r_ab should be passed, and W' used)

subroutine fmm_get_ltsqr_W_matrix(LMAX,JMAX,r_ab,W_matrix)

  implicit none
  integer(INTK), intent(in) :: LMAX, JMAX
  real(REALK), intent(in)   :: r_ab(3)
  real(REALK), intent(out)  :: W_matrix(:,:)
  integer(INTK) :: n, m

  n = max(LMAX,JMAX)
  m = min(LMAX,JMAX)
  call fmm_build_ltsqr_W_matrix()

contains

subroutine fmm_build_ltsqr_W_matrix()
  implicit none
  real(REALK) :: R_sh(-n:n,0:n)

  call fmm_generate_R(n,-r_ab,R_sh)
  ! note minus sign above - see TUH eqn.(9.13.58)
  call fmm_generate_W(n,m,R_sh,W_matrix)

end subroutine fmm_build_ltsqr_W_matrix

end subroutine fmm_get_ltsqr_W_matrix

!-------------------------------------------------------------------------------
! Get single-column W-matrix for getting boundary potential only

subroutine fmm_get_boundary_W_matrix(LMAX,r_ab,W_matrix)

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: r_ab(3)
  real(REALK), intent(out)  :: W_matrix(:,:)

  real(REALK) :: R_sh(-LMAX:LMAX,0:LMAX)

  call fmm_generate_R(LMAX,-r_ab,R_sh)
  ! note minus sign above - see TUH eqn.(9.13.58)
  call fmm_generate_boundary_W(LMAX,R_sh,W_matrix)

end subroutine fmm_get_boundary_W_matrix

!-------------------------------------------------------------------------------

subroutine fmm_generate_R(LMAX,point,R_sh)

  ! Subroutine to generate scaled regular solid harmonics
  ! See page 416, "Molecular Electronic Structure Theory"
  !-------------------------------------------------------
  ! R_sh(M,L)  == COS component of R_sh(M,L)
  ! R_sh(-M,L) == SIN component of R_sh(-M,L)
  ! where L and M are positive
  ! Note that R_sh(0,L) == COS component of R_sh(0,L) !
  !-------------------------------------------------------

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: point(3)
  real(REALK), intent(out)  :: R_sh(-LMAX:LMAX,0:LMAX)

  real(REALK) :: x, y, z, r_2, r_minus2
  real(REALK) :: A(6)
  integer(INTK) :: signl, l, m

  A(:) = zero
  x = point(1)
  y = point(2)
  z = point(3)
  r_2 = dot_product(point,point)
  r_minus2 = one/(r_2)

  if (r_2 < ZERO_VECT_TOL*ZERO_VECT_TOL) then
    write(LUPRI,'(3E25.15)') point
    call fmm_quit('ERROR: Why do we try to do zero W-vector.')
  end if

  if (LMAX == 0) then
    R_sh(0,0) = one
    return
  end if

  ! Start with initialization of lowest order terms

  R_sh(0,0) = one       ! cannot assign "sin" terms for m==0
  R_sh(-1,1) = -half*y
  R_sh(0,1) = z         ! cannot assign "sin" terms for m==0
  R_sh(1,1) = -half*x

  ! Now iterate higher order terms

  signl = -1
  lloop: do l=2,LMAX
    signl = -signl
    A(1) = one/(2*l)
    A(2) = A(1)*x
    A(3) = A(1)*y*signl

    ! cos terms:
    R_sh(l,l) = A(3)*R_sh(1-l,l-1)-A(2)*R_sh(l-1,l-1)
    ! sin terms:
    R_sh(-l,l) = A(3)*R_sh(l-1,l-1)+A(2)*R_sh(1-l,l-1)

    A(5) = (2*l-1)*(z)*(r_minus2)
    do m=0,(l-2)
      A(6) = (r_2)/(l*l-m*m)
      ! cos terms:
      R_sh(m,l) = A(6)*(A(5)*R_sh(m,l-1)-R_sh(m,l-2))
      ! sin terms:
      R_sh(-m,l) = A(6)*(A(5)*R_sh(-m,l-1)-R_sh(-m,l-2))
    end do

    ! Now do (l,l-1) terms to avoid calling elements that do not exist
    m = l-1
    ! cos terms:
    R_sh(m,l) = z*R_sh(m,l-1)
    ! sin terms:
    R_sh(-m,l) = z*R_sh(-m,l-1)

  end do lloop

end subroutine fmm_generate_R

!-------------------------------------------------------------------------------

subroutine fmm_generate_W(LMAX,JMAX,R_sh,W_matrix)

  ! Subroutine to generate Real Translation Matrix for
  ! given point from the Regular Solid Harmonics R_sh(m,l)
  ! cf Helgaker et. al. pp 413
  ! Note that W-matrix is lower triangular wrt W(lm,jk) and that
  ! only NON-ZERO elements are added here.
  ! We must therefore zero W_matrix initially, or use a special contractor
  !------------------------------------------------------------------------

  implicit none
  integer(INTK), intent(in) :: LMAX, JMAX
  real(REALK), intent(in)   :: R_sh(-LMAX:LMAX,0:LMAX)
  real(REALK), intent(out)  :: W_matrix(:,:)

  integer(INTK) :: l, m, j, k, a, b, q, pp, qq, lm_min, lm_max
  integer(INTK) :: signk, phase

  ! l==j case first:
  ! diagonal = one
  ! all other off-diagonal elements identically zero
  do j=0,JMAX
    qq = j*(j+1)+1
    do k=-j,j
      q = qq+k
      W_matrix(q,q) = one
    end do
  end do

  if (LMAX == 0) return
  if (JMAX > LMAX) call fmm_quit('error in fmm_generate_W')

  ! remaining l:
  jloop: do j=0,JMAX
    qq = j*(j+1)+1

    ! loop over positive k
    signk = -1
    kloop1: do k=0,j
      signk = -signk
      q = qq+k

      lloop1: do l=(j+1),LMAX
        a = (l-j)
        pp = l*(l+1)+1

        ! cos-cos terms
        !--------------

        ! (m-k) terms
        phase = 1
        do m=(k-1),max((k-a),0),-1     ! reverse order
          ! (m-k)<0
          phase = -phase
          b = -(m-k)
          W_matrix(pp+m,q) = phase*R_sh(b,a)
        end do
        do m=k,(a+k)      ! (a+k)<l
          ! (m-k)>=0
          b = (m-k)
          W_matrix(pp+m,q) = R_sh(b,a)
        end do
        ! (m+k) terms
        do m=0,(a-k)   ! always overlaps (m-k) terms
          ! (m+k)>=0
          b = (m+k)
          W_matrix(pp+m,q) = W_matrix(pp+m,q)+signk*R_sh(b,a)
        end do

        ! sin-cos terms
        !--------------

        ! m==-k first
        m = min(-k,-1)
        W_matrix(pp+m,q) = zero
        ! (m+k) terms
        do m=-(k+a),-(k+1)
          ! (m+k)<0
          b = (m+k)
          W_matrix(pp+m,q) = signk*R_sh(b,a)
        end do
        phase = -signk
        do m=-k+1,min(-1,(a-k))
          ! (m+k)>0
          phase = -phase
          b = -(m+k)
          W_matrix(pp+m,q) = phase*R_sh(b,a)
        end do
        ! (m-k) terms
        do m=(k-a),-1   ! always overlap (m+k) terms
          ! (m-k)<0
          b = (m-k)
          W_matrix(pp+m,q) = W_matrix(pp+m,q)+R_sh(b,a)
        end do

      end do lloop1
    end do kloop1

    ! (half)**(delta(0,k)) correction:
    lm_min = j*(j+2)+2
    lm_max = LMAX*(LMAX+2)+1
    W_matrix(lm_min:lm_max,qq) = half*W_matrix(lm_min:lm_max,qq)   !k==0

    ! loop over negative k
    signk = 1
    kloop2: do k=-1,-j,-1     ! reverse order
      signk = -signk
      q = qq+k

      lloop2: do l=(j+1),LMAX
        a = (l-j)
        pp = l*(l+1)+1

        ! cos-sin terms
        !--------------
        ! (m+k) terms
        do m=max(0,-(a+k)),(-k-1)
          ! (m+k)<0
          b = (m+k)
          W_matrix(pp+m,q) = signk*R_sh(b,a)
        end do
        m = -k
        W_matrix(pp+m,q) = zero
        phase = -signk
        do m=-k+1,(a-k)  !<=l
          ! (m+k)>=0
          phase = -phase
          b = -(m+k)
          W_matrix(pp+m,q) = phase*R_sh(b,a)
        end do
        ! (m-k) terms
        phase = signk
        do m=0,(a+k)    ! always overlap (m+k) terms
          ! (m-k)>0
          phase = -phase
          b = -(m-k)
          W_matrix(pp+m,q) = W_matrix(pp+m,q)-phase*R_sh(b,a)
        end do

        ! sin-sin terms
        !--------------

        ! (m-k) terms
        phase = 1
        do m=(k-1),(k-a),-1    ! reverse order
          ! (m-k)<0
          phase = -phase
          b = -(m-k)
          W_matrix(pp+m,q) = phase*R_sh(b,a)
        end do
        do m=k,min(-1,(a+k))
          ! (m-k)>=0
          b = (m-k)
          W_matrix(pp+m,q) = R_sh(b,a)
        end do
        ! (m+k) terms
        phase = 1
        do m=-1,-(a+k),-1     ! reverse order
          ! (m+k)<0              ! always overlap (m-k) terms
          phase = -phase
          b = -(m+k)
          W_matrix(pp+m,q) = W_matrix(pp+m,q)-phase*R_sh(b,a)
        end do

      end do lloop2
    end do kloop2
  end do jloop

end subroutine fmm_generate_W

!-------------------------------------------------------------------------------

subroutine fmm_generate_boundary_W(LMAX,R_sh,W_matrix)

  ! This is a simplified version of fmm_generate_W_matrix when building
  ! only the boundary potential, when only one column of the W-matrix
  ! is required.

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: R_sh(-LMAX:LMAX,0:LMAX)
  real(REALK), intent(out)  :: W_matrix(:,:)

  integer(INTK) :: l, m, pp

  W_matrix(1,1) = one
  do l=1,LMAX
    pp = l*(l+1)+1
    do m=-l,l
      W_matrix(pp+m,1) = R_sh(m,l)
    end do
  end do

end subroutine fmm_generate_boundary_W

!-------------------------------------------------------------------------------

subroutine fmm_contract_Wq(N_or_T,W_mat,WLDA,vec_in,n,vec_out,m)

  implicit none
  character, intent(in)      :: N_or_T
  integer(INTK), intent(in)  :: n, m, WLDA
  real(REALK), intent(in)    :: W_mat(WLDA,WLDA)
  real(REALK), intent(in)    :: vec_in(n)
  real(REALK), intent(inout) :: vec_out(m)

  integer(INTK) :: q

  if (N_or_T == 'N') then
    do q=1,n
      vec_out(q:m) = vec_out(q:m)+W_mat(q:m,q)*vec_in(q)
    end do
  else
    ! Perform transpose contraction
    do q=1,m
      vec_out(q) = vec_out(q)+dot_product(W_mat(q:n,q),vec_in(q:n))
    end do
  end if

end subroutine fmm_contract_Wq

!-------------------------------------------------------------------------------

end module fmm_W_worker

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
      SUBROUTINE RdInp_Dynamix(LuSpool,Task,nTasks,mTasks)
      IMPLICIT REAL*8 (a-h,o-z)
#include "MD.fh"
#include "stdalloc.fh"
#include "dyn.fh"
#include "constants2.fh"
      INTEGER Task(nTasks),maxHop
      INTEGER VelVer, VV_First, VV_Second, Gromacs, VV_Dump
      PARAMETER(VelVer=1,VV_First=2,VV_Second=3,Gromacs=4,VV_Dump=5)
#ifdef _HDF5_
      REAL*8, ALLOCATABLE :: Mass(:)
#endif
      LOGICAL lHop
      CHARACTER Title*72

C
C     Define local variables
C
      CHARACTER*180  Key, Line
      CHARACTER*180  Get_Ln
      EXTERNAL       Get_Ln
C
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
C
      mTasks=0
C
C     Start of input
C
      REWIND(LuSpool)
      CALL RdNLst(LuSpool,'Dynamix')

  999 CONTINUE
      Key = Get_Ln(LuSpool)
      Line = Key
      CALL UpCase(Line)
*
      IF (Line(1:4).eq.'TITL') GOTO 1100
      IF (Line(1:4).eq.'PRIN') GOTO 1101
      IF (Line(1:4).EQ.'VV_F') GOTO 1102
      IF (Line(1:4).EQ.'VV_S') GOTO 1103
      IF (Line(1:4).EQ.'VV_D') GOTO 1104
      IF (Line(1:4).EQ.'THER') GOTO 1105
      IF (Line(1:4).EQ.'VELO') GOTO 1106
      IF (Line(1:2).EQ.'DT')   GOTO 1107
      IF (Line(1:4).EQ.'GROM') GOTO 1108
      IF (Line(1:4).EQ.'TIME') GOTO 1109
      IF (Line(1:4).EQ.'VELV') GOTO 1110
      IF (Line(1:3).EQ.'HOP')  GOTO 1111
      IF (Line(1:4).EQ.'REST') GOTO 1112
      IF (Line(1:4).EQ.'TEMP') GOTO 1113
      IF (Line(1:4).EQ.'ISOT') GOTO 1114
      IF (Line(1:4).EQ.'H5RE') GOTO 1115
      IF (Line(1:3).EQ.'OUT')  GOTO 1116
      IF (Line(1:2).EQ.'IN')   GOTO 1117
      IF (Line(1:3).EQ.'END')  GOTO 9000

*>>>>>>>>>>>>>>>>>>>> TITL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1100 CONTINUE
      Line = Get_Ln(LuSpool)
      CALL Get_S(1,Title,72)
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> PRIN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1101 CONTINUE
      Line = Get_Ln(LuSpool)
      CALL Get_I1(1,iPrint)
*>>>>>>>>>>>>>>>>>>>> VV_First <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1102 CONTINUE
      WRITE(6,*) ' VV_First 1'
      mTasks = mTasks + 1
      Task(mTasks) = VV_First
      WRITE(6,*) ' VV_First 2'
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> VV_Second <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1103 CONTINUE
      mTasks = mTasks + 1
      Task(mTasks) = VV_Second
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> VV_Dump <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1104 CONTINUE
      mTasks = mTasks + 1
      Task(mTasks) = VV_Dump
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> THERmostat <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1105 CONTINUE
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix starts reading THERMO.'
#endif
      Line = Get_Ln(LuSpool)
      CALL Get_I1(1,THERMO)
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix ends reading THERMO.'
#endif
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> VELOcities <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1106 CONTINUE
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix starts reading VELO.'
#endif
      Line = Get_Ln(LuSpool)
      CALL Get_I1(1,VELO)
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix ends reading VELO.'
#endif
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> DT   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1107 CONTINUE
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix starts reading DT.'
#endif
      Line = Get_Ln(LuSpool)
      CALL Get_F1(1,DT)
      CALL Put_dScalar('Timestep',DT)
#ifdef _HDF5_
      call mh5_put_dset(dyn_dt,DT)
#endif
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix ends reading DT.'
#endif
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> GROM <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1108 CONTINUE
      mTasks = mTasks + 1
      Task(mTasks) = Gromacs
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> TIME <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1109 CONTINUE
      Line = Get_Ln(LuSpool)
      CALL Get_F1(1,TIME)
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> VelVer <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1110 CONTINUE
C     This is the keyword for Velocity Verlet algorithm
      mTasks = mTasks + 1
      Task(mTasks) = VelVer
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> Hop    <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1111 CONTINUE
      Line = Get_Ln(LuSpool)
      CALL Get_I1(1,maxHop)
      lHop=.FALSE.
      CALL qpg_iScalar('MaxHops',lHop)
      IF (.NOT.lHop) THEN
         CALL Put_iScalar('MaxHops',maxHop)
      END IF
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' lHop = ',lHop,'maxHop = ',maxHop
#endif
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> Restart <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1112 CONTINUE
      Line = Get_Ln(LuSpool)
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix starts reading RESTART.'
#endif
      CALL Get_F1(1,RESTART)
      GOTO 999
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix ends reading RESTART.'
#endif

*>>>>>>>>>>>>>>>>>>>> TEMPERATURE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1113 CONTINUE
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix starts reading Temperature.'
#endif
      Line = Get_Ln(LuSpool)
      CALL Get_F1(1,TEMP)
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix ends reading Temperature.'
#endif
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> Isotope <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1114 CONTINUE
      Write (6,*) 'ISOTope keyword is obsolete in DYNAMIX,'
      Write (6,*) 'use it in GATEWAY to specify isotopes/masses'
      CALL Abend()
      GOTO 999
c      Write (6,*) 'Unknown keyword:', Key
c      CALL Abend()
*>>>>>>>>>>>>>>>>>>>> Restart from HDF5 file <<<<<<<<<<<<<<<<<<<<<<<<<
 1115 CONTINUE
#ifdef _HDF5_
      lH5Restart = .True.
      Line = Get_Ln(LuSpool)
      CALL Get_S(1,FILE_H5RES,1)
#else
      write (6,*) 'The user asks to restart the dynamics calculation '
      write (6,*) 'from a HDF5 file, but this is not supported in this'
      write (6,*) 'installation.'
      call Quit_OnUserError()
#endif
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> project OUT some coordinates <<<<<<<<<<<<<<<<<<<<<<<
 1116 CONTINUE
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix starts reading OUT.'
#endif
      Line = Get_Ln(LuSpool)
      CALL Get_I1(1,POUT)
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix ends reading OUT.'
#endif
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> keep IN only some coordinates <<<<<<<<<<<<<<<<<<<<<<<
 1117 CONTINUE
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix starts reading IN.'
#endif
      Line = Get_Ln(LuSpool)
      CALL Get_I1(1,PIN)
#ifdef _DEBUGPRINT_
      WRITE(6,*) ' Dynamix ends reading IN.'
#endif
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> END <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 9000 CONTINUE
      WRITE (6,*)
*
#ifdef _HDF5_
      CALL Get_nAtoms_All(natom)
      CALL mma_allocate(Mass,natom)
      CALL Get_Mass_All(Mass,natom)
      CALL mh5_put_dset(dyn_mass,Mass)
      CALL mma_deallocate(Mass)
#endif
*
      RETURN
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FndBnd(IOut,AlBond,MxBond,NAtoms,IAn,C,Nbond,IBond,IBType,PBO)
! Generate connectivity based on bond distances alone.  The criteria
! are contained in routine IPBO.
! Cartesian coords. are in Angstroms

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IOut, MxBond, NAtoms, IAn(NAtoms)
logical(kind=iwp), intent(in) :: AlBond
integer(kind=iwp), intent(out) :: Nbond(NAtoms), IBond(MxBond,NAtoms), IBType(MxBond,NAtoms)
real(kind=wp), intent(in) :: C(3,NAtoms)
real(kind=wp), intent(out) :: PBO(MxBond,NAtoms)
integer(kind=iwp) :: I, IbondO, J
real(kind=wp) :: BondOr, RIJ
integer(kind=iwp), external :: IPBO

IBond(:,:) = 0
IBType(:,:) = 0
BondOr = Zero
NBond(:) = 0
do I=1,NAtoms
  do J=1,NAtoms
    if (J == I) cycle
    RIJ = sqrt((C(1,I)-C(1,J))**2+(C(2,I)-C(2,J))**2+(C(3,I)-C(3,J))**2)
    IBondO = IPBO(IAn(I),IAn(J),RIJ,BondOr)
    if ((IBondO > 0) .or. AlBond) then
      NBond(I) = NBond(I)+1
      if (NBond(I) > MxBond) then
        write(IOut,1000) MxBond,I
        call Abend()
      end if
      IBond(NBond(I),I) = J
      IBType(NBond(I),I) = IBondO
      PBO(NBond(I),I) = BondOr
    end if
  end do
end do

return

1000 format(' Maximum number of bonds=',I3,' exceeded for atom',I4,'.')

end subroutine FndBnd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2003-2005, Valera Veryazov                             *
*               2017, Roland Lindh                                     *
************************************************************************
      subroutine SCF(ireturn)
************************************************************************
*                                                                      *
*     purpose: perform RHF calculations                                *
*                                                                      *
*     calls to: OpnFls_SCF,ReadIn_SCF,SOrb,WrInp_SCF,WfCtl_SCF,Final,  *
*               ClsFls_SCF                                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, P. Borowski, M. Schuetz, and R. Lindh              *
*     University of Lund, Sweden, 1992-1998                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      use SCF_Arrays
      Implicit Real*8 (a-h,o-z)
*
#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
#include "stdalloc.fh"
#include "twoswi.fh"
#include "file.fh"
#include "hflda.fh"
#include "warnings.fh"
      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
*
      Character*8 EMILOOP
      Logical FstItr, Semi_Direct
      Real*8 SIntTh
#include "interfaces_scf.fh"
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Call CWTime(TCPU1,TWall1)
      HFLDA=0.0
      Call SCF_Init()
      iTerm=0
*
      Call OpnFls_SCF
      Call ReadIn_SCF(SIntTh)
      LuOrb=LuInp
*
      Semi_Direct = DSCF .and. (nDisc.ne.0 .or. (nCore.ne.0
     &      .and. nDisc.eq.0))
      If (Semi_Direct) Then
         Call mma_MaxDBLE(MemSew)
         MemLow=Min(MemSew/2,1024*1024)
         MemSew=Max(MemSew/10,MemLow)
         Call xsetmem_ints(MemSew)
      End If
*
      Call Init_SCF()
*                                                                      *
************************************************************************
*                                                                      *
*     Pick up the starting orbitals and set the occupation numbers.
*
      LuOrb=LuInp
      nD = iUHF + 1
      Call SOrb(LuOrb,SIntTh,iTerm)
      Call OccDef(OccNo,nnB,nD,CMO,nBB)
*
      Call mma_deallocate(HDiag)
      If (Aufb) Then
         lthH = nBB
      Else
         lthH = nOV
      End If
      Call mma_allocate(HDiag,lthH,nD,Label='HDiag')
*                                                                      *
************************************************************************
*                                                                      *
      Call WrInp_SCF(SIntTh)

      Call Cre_SCFWfn

      FstItr=.True.

      If(.not.OnlyProp) Then
         Call WfCtl_SCF(iTerm,KSDFT,FstItr,SIntTh)
      End If

*     so that iPsLst is right in case of nIter==0
      If (nIter(nIterP).eq.0) iter0=-1
      Call Final()
      If (DSCF) Call Free_TLists
*
      Call CWTime(TCPU2,TWall2)
      Call SavTim(4,TCPU2-TCPU1,TWall2-TWall1)
*
      Call GMFree()
      Call ClsFls_SCF
      If (Semi_Direct) Call xRlsMem_Ints
*
*     Call MolDen Interface
*
      If(iUHF.eq.0) Then
         Call Molden_Interface(iUHF,'SCFORB','MD_SCF')
      Else
         Call Molden_Interface(iUHF,'UHFORB','MD_SCF')
      End If
      if(iStatPRN.gt.0) then
       Call FastIO('STATUS')
      endif
*
*.... Everything has to come to an end...
*
      iReturn=iTerm
*
      If (Do_OFemb) Then
         Call GetEnvF('EMIL_InLoop',EMILOOP)
         If (EMILOOP.eq.' ') EMILOOP='0'
         If (EMILOOP(1:1).ne.'0') Then
            If (iReturn.ne._RC_ALL_IS_WELL_) Then
               Call WarningMessage(1,'SCF: non-zero return code.')
            EndIf
            iReturn=_RC_CONTINUE_LOOP_
            Call Check_FThaw(iReturn)
         EndIf
      EndIf
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      return
*
      End
************************************************************************
      SubRoutine IniLLs
*     initialize the diverse linked lists
      Implicit Real*8 (a-h,o-z)

#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
#include "llists.fh"
#include "lnklst.fh"
*
*
*     MemRsv set tentatively to the size of six density matrices
c     MemRsv=6*nBT
      LLlist=0
      LLGrad=0
      Call IniLst(LLGrad,20)
      Call IniLst(LLDgrd,20)
      Call IniLst(LLDelt,20)
      Call IniLst(LLy,20)
      Call IniLst(LLx,MxOptm)
      Init_LLs=1
*
      End subroutine IniLLs
*----------------------------------------------------------------------*
#ifdef _NOTUSED_
      Subroutine StatLLS()
      Implicit Real*8 (a-h,o-z)
#include "llists.fh"
      If (Init_LLs.eq.1) Then
         Call StlLst(LLGrad)
         Call StlLst(LLDgrd)
         Call StlLst(LLDelt)
         Call StlLst(LLy)
         Call StlLst(LLx)
      Else
         Write (6,*) '****** W A R N I N G ! ******'
         Write (6,*) ' Linked lists are not there!'
      End If
      Return
      End
#endif
*----------------------------------------------------------------------*
      SubRoutine KiLLs
*     dispose the diverse linked lists
      Implicit Real*8 (a-h,o-z)
#include "llists.fh"
      If (Init_LLs.eq.1) Then
         Call KilLst(LLGrad)
         Call KilLst(LLDgrd)
         Call KilLst(LLDelt)
         Call KilLst(LLy)
         Call KilLst(LLx)
         Init_LLs=-1
      Else
         Write (6,*) '****** W A R N I N G ! ******'
         Write (6,*) ' Linked list already killed!'
      End If
      Return
      End
*----------------------------------------------------------------------*
      Subroutine RclLLs(iDskPt)
      Implicit Real*8 (a-h,o-z)
#include "infso.fh"
#include "file.fh"
#include "llists.fh"
      Integer iDskPt(5)
      Call RclLst(LLGrad,LuGrd,iDskPt(1),MemRsv)
      Call RclLst(LLDgrd,LuDGd,iDskPt(2),MemRsv)
      Call RclLst(LLDelt,LuDel,iDskPt(3),MemRsv)
      Call RclLst(LLy   ,Lux  ,iDskPt(4),MemRsv)
      Call RclLst(LLx   ,Luy  ,iDskPt(5),MemRsv)
      Init_LLs=1
*     Call StatLLs
      Return
      End
*----------------------------------------------------------------------*
      Subroutine DmpLLs(iDskPt)
      Implicit Real*8 (a-h,o-z)
#include "file.fh"
#include "llists.fh"
      Integer iDskPt(5)
      If (Init_LLs.eq.1) Then
*        Call StatLLs
         Call DmpLst(LLGrad,LuGrd,iDskPt(1))
         Call DmpLst(LLDgrd,LuDGd,iDskPt(2))
         Call DmpLst(LLDelt,LuDel,iDskPt(3))
         Call DmpLst(LLy   ,Lux  ,iDskPt(4))
         Call DmpLst(LLx   ,Luy  ,iDskPt(5))
      Else
         Write (6,*) '****** W A R N I N G ! ******'
         Write (6,*) ' Linked list already killed!'
      End If
      Return
      End
*----------------------------------------------------------------------*
      Subroutine StlLst(LLink)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      return
       Write (6,*)
       Write (6,*) '*********** Status of Linked List *************'
       Write (6,*)
       Write (6,*) ' LLink:',LLink
       Write (6,*)
       Write (6,*) ' CNOD data'
       Write (6,*) 'Error code:                       ',iWork(LLink  )
       Write (6,*) 'Pointer to first NODE in the list:',iWork(LLink+1)
       Write (6,*) 'Actual length of list:            ',iWork(LLink+2)
       Write (6,*) '# of vectors in core:             ',iWork(LLink+3)
       Write (6,*)
       iRoot=iWork(LLink+1)
       Do while (iRoot.ne.0)
          Write (6,*) ' NODE data'
          Write (6,*) 'NODE @:                         ',iRoot
          Write (6,*) 'Pointer to next NODE:           ',iWork(iRoot  )
          Write (6,*) 'Pointer to stored vector:       ',iWork(iRoot+1)
          If (iWork(iRoot+5).ge.1) Then
             Write (6,*) 'Vector status:                  in Core'
          Else
             Write (6,*) 'Vector status:                  on Disk'
          End If
          Write (6,*) 'Next free position:             ',iWork(iRoot+2)
          Write (6,*) 'Length of vector:               ',iWork(iRoot+3)
          Write (6,*) 'Iteration number:               ',iWork(iRoot+4)
          Write (6,*)
          iRoot=iWork(iRoot)
       End Do
       Write (6,*) '************ End of Status Report *************'
       Write (6,*)
      Return
      End
#ifdef _NOTUSED_
*----------------------------------------------------------------------*
      Subroutine Init_TLists
      Implicit Real*8 (a-h,o-z)
*     Include 'mxdm.fh'
#include <mxdm.fh>

      Logical Triangular
*
      If (DSCF) Then
         Triangular=.True.
         Call Init_TList(Triangular)
         Call Init_PPList
         Call Init_GTList
      End If
*
      Return
      End
#endif
*----------------------------------------------------------------------*
      Subroutine Free_TLists
      Implicit Real*8 (a-h,o-z)

#include "mxdm.fh"
#include "infscf.fh"
*
      If (DSCF) Then
         Call Free_TList
         Call Free_PPList
         Call Free_GTList
      End If
*
      Return
      End
*----------------------------------------------------------------------*
      Subroutine Reduce_Thresholds(EThr_,SIntTh)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
*
#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
      Common /Save/ SIntTh_old, EThr_old, DThr_old, DltNTh_old,
     &              FThr_old, ThrInt_Old
*
      Write (6,*)
      Write (6,*) 'Temporary increase of thresholds...'
      Write (6,*)
      SIntTh_old=SIntTh
      EThr_old=EThr
      DThr_old=DThr
      DltNTh_old=DltNTh
      FThr_old=FThr
*
*---- Get threshold used in connection of products of integrals and
*     densities
*
      ThrInt_Old=Get_ThrInt()
*
      EThr=EThr_
      If (EThr_old.eq.Zero) Then
         Relax=One
      Else
         Relax=EThr/EThr_old
      End If
      SIntTh=SIntTh*Relax
      DThr=DThr*Relax
      DltNTh=100.0D0*EThr
      FThr=FThr*Relax
      Call xSet_ThrInt(ThrInt_Old*Relax)
*
      Return
      End
      Subroutine Reset_Thresholds
      Implicit Real*8 (a-h,o-z)
*
#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
      Common /Save/ SIntTh_old, EThr_old, DThr_old, DltNTh_old,
     &              FThr_old, ThrInt_Old
*
      Write (6,*)
      Write (6,*) 'Restore thresholds...'
      Write (6,*)
      SIntTh=SIntTh_old
      EThr=EThr_old
      DThr=DThr_old
      DltNTh=DltNTh_old
      FThr=FThr_old
      Call xSet_ThrInt(ThrInt_Old)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CSDIAG_CI_UTIL(NCSF,NDET,CSFDIA,DETDIA,NCNFTP,NTYP,ICTSDT,NDTFTP,NCSFTP,IPRINT)
! PURPOSE: OBTAIN AVERAGE CI DIAGONAL ELEMENTS AND STORE IN CSFDIA
!
! CALLING PARAMETERS.
! CSFDIA  : CI DIAGONAL IN SCF BASIS
! DETDIA  : CI DIAGONAL IN DETERMINENT BASIS
! NCNFTP  :
! NTYP    :
! ICTSDT  :
! NDTFTP  :
! NCSFTP  :

use Constants, only: Zero
use Definitions, only: wp, iwp,u6

implicit none
integer(kind=iwp), intent(in) :: NCSF, NDET, NTYP, NCNFTP(NTYP), ICTSDT(NDET), NDTFTP(NTYP), NCSFTP(NTYP), IPRINT
real(kind=wp), intent(out) :: CSFDIA(NCSF)
real(kind=wp), intent(in) :: DETDIA(NDET)
real(kind=wp) :: EAVER
integer(kind=iwp) :: ICNF, ICSF, ICSOFF, IDET, IDTOFF, ITYP, JCNABS, JCNF, JDET, NCSTOT, NDTTOT

ICSOFF = 0
IDTOFF = 0
JCNABS = 0
do ITYP=1,NTYP
  IDET = NDTFTP(ITYP)
  ICSF = NCSFTP(ITYP)
  ICNF = NCNFTP(ITYP)
  do JCNF=1,ICNF
    JCNABS = JCNABS+1
    EAVER = Zero
    do JDET=1,IDET
      EAVER = EAVER+DETDIA(abs(ICTSDT(IDTOFF+JDET)))
    end do
    if (IDET /= 0) EAVER = EAVER/real(IDET,kind=wp)
    CSFDIA(ICSOFF+1:ICSOFF+ICSF) = EAVER
    ICSOFF = ICSOFF+ICSF
    IDTOFF = IDTOFF+IDET
  end do
end do

if (IPRINT >= 40) then
  NCSTOT = ICSOFF
  NDTTOT = IDTOFF
  write(u6,*)
  write(u6,*) ' CIDIAGONAL IN DET BASIS'
  call WRTMAT(DETDIA,1,NDTTOT,1,NDTTOT)
  write(u6,*)
  write(u6,*) ' CIDIAGONAL IN CSF BASIS'
  call WRTMAT(CSFDIA,1,NCSTOT,1,NCSTOT)
end if

return

end subroutine CSDIAG_CI_UTIL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE WRISEQ(G,IDIMENS,IFILE)
      implicit none
      integer IDIMENS,IFILE,IAS
      REAL*8 G(IDIMENS)
      integer INDI(IDIMENS)
C     write(6,*)'wrote',ifile,idimens
      WRITE(IFILE)G
      RETURN

      ENTRY REASEQ(G,IDIMENS,IFILE)
C     write(6,*)'reading',ifile,idimens
      READ(IFILE)G
      RETURN

      ENTRY WRIDIR(G,IDIMENS,IFILE,IAS)
      WRITE(IFILE,REC=IAS)G
      RETURN

      ENTRY READIR(G,IDIMENS,IFILE,IAS)
      READ(IFILE,REC=IAS)G
      RETURN


C     WRITED BY J. SIMUNEK JULY 2006
C     START PART

      ENTRY WRI_I(INDI,IDIMENS,IFILE,IAS)
      WRITE(IFILE,REC=IAS)INDI
      RETURN

      ENTRY REA_I(INDI,IDIMENS,IFILE,IAS)
      READ(IFILE,REC=IAS)INDI
      RETURN

      ENTRY WRI_IR(G,INDI,IDIMENS,IFILE,IAS)
      WRITE(IFILE,REC=IAS)INDI,G
      RETURN

      ENTRY REA_IR(G,INDI,IDIMENS,IFILE,IAS)
      READ(IFILE,REC=IAS)INDI,G
      RETURN
C     END PART
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine expandbas(Bas1,Nbas1,Bas2,Nbas2,Orb1,Orb2,occ1,eorb1,
     &                  indt1,occ2,eorb2,indt2)
C
C     This subroutine expands the MOs for a given symmetry
C     Orb1 are the input orbitals of dimension Nbas1*bas1 (file INPORB)
C     Orb2 are the output orbitals of dimension Nbas2*bas2 (file EXPORB)
C     Bas1 and Bas2 are the basis set specifications for the old and
C     new basis, respectively. They have dimensions Nbas1 and Nbas2.
C
C
      Implicit real*8 (a-h,o-z)
#include "Molcas.fh"
      Character*(LENIN8) Bas1(*),Bas2(*)
      Integer indt1(*),indt2(*)
      Dimension Orb1(*),Orb2(*),Izero(Nbas2),occ1(*),eorb1(*),
     &          occ2(*),eorb2(*)
C
C     Loop through the new basis labels and compare with the old.
C     If they are equal copy orbital coefficients
C     If not, add zeros until they fit again
C
      Nzero=0
      Ibas2=1
      If(Nbas1.eq.0) go to 200
      Ibas1=1
  100 Continue
      If(Bas2(Ibas2).eq.Bas1(Ibas1)) then
       lmo1=0
       lmo2=0
       Do imo=1,Nbas1
        Orb2(lmo2+Ibas2)=Orb1(lmo1+Ibas1)
        lmo1=lmo1+nBas1
        lmo2=lmo2+nBas2
       Enddo
       Ibas1=Ibas1+1
       Ibas2=Ibas2+1
      Else If(Bas2(Ibas2).ne.Bas1(Ibas1)) then
       Nzero=Nzero+1
       Izero(Nzero)=Ibas2
       lmo2=0
       Do imo=1,Nbas1
        Orb2(lmo2+Ibas2)=0.D0
        lmo2=lmo2+nBas2
       Enddo
       Ibas2=Ibas2+1
      Endif
      If(Ibas1.le.Nbas1) go to 100
  200 Continue
C
C     Add zeros at the end of each basis function
C
      If(Ibas2.le.Nbas2) then
       Do i=Ibas2,Nbas2
        Nzero=Nzero+1
        Izero(Nzero)=i
        lmo2=0
        Do imo=1,Nbas1
         Orb2(lmo2+i)=0.D0
         lmo2=lmo2+nBas2
        Enddo
       Enddo
      Endif
C
C     Add new basis functions at the end and expand occ, eorb, and indt
C
      If(nBas1.ne.0) then
       Do imo=1,nBas1
        occ2(imo)=occ1(imo)
        eorb2(imo)=eorb1(imo)
        indt2(imo)=indt1(imo)
       Enddo
      Endif

      If(Nbas1.lt.Nbas2) then
       Nzero=0
       Do imo=Nbas1+1,Nbas2
        Nzero=Nzero+1
        Do Ibas2=1,Nbas2
         Orb2(Nbas2*(imo-1)+Ibas2)=0.D0
        Enddo
        Orb2(Nbas2*(imo-1)+Izero(Nzero))=1.D0
        occ2(imo)=0.d0
        eorb2(imo)=0.d0
        indt2(imo)=6
       Enddo
      Endif

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      Function Gamma2(m,T)
************************************************************************
*                                                                      *
* Object: to compute the auxiliary function in the high argument       *
*         approximation.                                               *
*                                                                      *
************************************************************************
      Implicit real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Gamma2
*
      Gamma2= Sqrt(Two*ACos(Zero)/T)/Two
      Do 10 i = 1, m
         Gamma2 = ((Two*DBLE(i)-One)/(Two*T))*Gamma2
 10   Continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine depend_cvb(chr1,chr2)
      implicit real*8 (a-h,o-z)
      character*(*) chr1,chr2
#include "make_cvb.fh"

      call mkafter_cvb(chr1,chr2)
      call touchdepend_cvb(chr1,chr2)

      if(iprint.ge.10)then
        write(6,*)' IOFFS :',(ioffs(ii),ii=1,nobj+1)
        write(6,*)' JOFFS :',(joffs(ii),ii=1,nobj+1)
        write(6,*)' I_DEP_ON_J :',(i_dep_on_j(ii),ii=1,ndep_ij)
        write(6,*)' J_DEP_ON_I :',(j_dep_on_i(ii),ii=1,ndep_ji)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Spectc(Req,E0,Atom1,Atom2,nE)
C
C     Subroutine for calculation of spectroscopic constants for
C     diatomic molecules from the raw vibrational term values
C     obtained in Vibrot. A least square fit to these data is used
C
C     ********** MOLCAS-Release 91 05 01 **********
C
      Implicit Real*8 (A-H,O-Z)
#include "dimensions.fh"
      Parameter (ndim=nVib_Max*(nRot_Max+1),nemax=nVib_Max)
      Character*2 Atom1,Atom2
#include "intinp.fh"

#include "WrkSpc.fh"
#include "SysDef.fh"
C     Dimension Tvj(ndim),T(ndim),Gv(nemax),Gv2(nemax),F(100),Fc(100),
      Dimension Gv(nemax),Gv2(nemax),F(nemax),Fc(nemax),
     *          A(3,3),B(nemax),X(3),jind(nemax),D(nemax),G(3),dF(nemax)
*
C
      ChkSum=0.0d0
      zero=0.d0
      ntot=ne*(J2A-J1A+1)
      If(ntot.gt.ndim) then
        Write(6,*)'SPECTC Error: NTOT.gt.NDIM'
        Write(6,'(1x,a,2i6)')'NTOT,NDIM:',NTOT,NDIM
        Call Abend
      End If
      If(ne.gt.nemax) then
        Write(6,*)'SPECTC Error: NE.gt.NEMAX'
        Write(6,'(1x,a,2i6)')'NE,NEMAX:',NE,NEMAX
        Call Abend
      End If
c
      Call GetMem('VecTvj','Allo','Real',indexTvj,ndim)
      Call GetMem('VecT','Allo','Real',indexT,ndim)
c
      iend=0
      Do 10 J=J1A,J2A
       ist=iend+1
       iend=iend+ne
       Call DDafile(Vibwvs,2,Work(indexTvj+ist-1),ne,iadrsp(J-J1A+1))
10    Continue
C
C     Compute rotaional constants B and D for each vibrational band
C
      Const=219474.6D0
      If ( (J2A-J1A).lt.3 ) Then
        Write(6,*)'SPECTC Error: J2A-J1A.lt.3'
        Write(6,*)' SPECTC requires a range of rotational quanta'
        Write(6,*)' in order to fit spectroscopic constants.'
        Write(6,*)' The upper and lower limits of J must differ by'
        Write(6,*)'  at least 3.'
        Write(6,'(1x,a,2i6)')'J2A,J1A:',J2A,J1A
        Call Abend
      End If
      Do 100 nv=1,ne
      ij=ne
c     Term values for this band
      Do 90 j=J1A+1,J2A
       F(j)=Work(indexTvj+ij+nv-1)-Work(indexTvj+nv-1)
       F(j)=F(j)*const
       ij=ij+ne
90    Continue
      B1=0.D0
      B2=0.D0
      A11=0.D0
      A12=0.D0
      A22=0.D0
      Do 91 J=J1A+1,J2A
       Xj1=J*(J+1)-J1A*(J1A+1)
       Xj2=Xj1**2
       Xj3=Xj1**3
       Xj4=Xj2**2
       B1=B1+F(J)*Xj1
       B2=B2-F(J)*Xj2
       A11=A11+Xj2
       A12=A12+Xj3
       A22=A22+Xj4
91    Continue
c
      Xd=A12/A22
      Det=A11-Xd*A12
      B(nv)=(B1+B2*Xd)/Det
      D(nv)=(B2*A11/A22+B1*Xd)/Det
      Do 92 J=J1A+1,J2A
       Xj=J*(J+1)-J1A*(J1A+1)
       Fc(J)=B(nv)*Xj-D(nv)*Xj**2
       dF(J)=F(J)-Fc(J)
       nv1=nv-1
92    Continue
      write(6,990) nv1,B(nv),D(nv)
990   format(/5x,'Rotational constants for vibrational quantum number',
     *       i3/5x,'B=',e13.6,' cm-1     D=',e13.6,' cm-1'/
     *       5x,'Observed and computed term values (cm-1)')
      Do 93 J=J1A+1,J2A
       write(6,991) J,F(J),Fc(J),dF(J)
991    format(5x,i3,3e20.6)
93    Continue
100   Continue
      write(6,992)
992   format(/5x,'Rotational constants B(nv) and D(nv) in cm-1')
      Do 101 nv=1,ne
       write(6,991) nv,B(nv),D(nv)
101   Continue
C
C     Compute spectroscopic constants de (dele) and betae
C     by a least square fit
C
      dele=0.D0
      betae=0.D0
      if(ne.eq.1) de=d(1)
      if(ne.eq.1) go to 111
      a11=ne
      b1=0.D0
      b2=0.D0
      a12=0.D0
      a22=0.D0
      Do 110 nv=1,ne
       xnv=nv-0.5d0
       b1=b1+d(nv)
       b2=b2+d(nv)*xnv
       a12=a12+xnv
       a22=a22+xnv**2
110   Continue
      det=a11*a22-a12*a12
      dele=(b1*a22-b2*a12)/det
      betae=(b2*a11-b1*a12)/det
111   Continue
      write(6,994) dele,betae
994   format(/5x,'Spectroscopic constants De=',e13.6,' cm-1  Betae=',
     *       e13.6,' cm-1'/5x,'Observed and computed D values')
      Do 112 nv=1,ne
       nv1=nv-1
       dc=dele+betae*(nv-0.5d0)
       diff=d(nv)-dc
       write(6,991) nv1,d(nv),dc,diff
112   Continue
C
C     Spectroscopic constants Be,Alphe, and Gammae from rotational
C     constants B(nv)
C
      x(1)=0.D0
      x(2)=0.D0
      x(3)=0.D0
      if(ne.eq.1) x(1)=b(1)
      if(ne.eq.1) go to 126
      if(ne.eq.2) then
       x(1)=1.5D0*b(1)-0.5d0*b(2)
       x(2)=b(2)-b(1)
       go to 126
      Endif
      Do 115 i=1,3
       g(i)=0.D0
      Do 116 k=1,3
       a(i,k)=0.D0
116   Continue
115   Continue
      a(1,1)=ne
      Do 120 nv=1,ne
       xnv=nv-0.5d0
       xnv2=xnv**2
       xnv3=xnv**3
       xnv4=xnv2**2
       g(1)=g(1)+b(nv)
       g(2)=g(2)+b(nv)*xnv
       g(3)=g(3)+b(nv)*xnv2
       a(1,2)=a(1,2)+xnv
       a(1,3)=a(1,3)+xnv2
       a(2,3)=a(2,3)+xnv3
       a(3,3)=a(3,3)+xnv4
120   Continue
      a(2,1)=a(1,2)
      a(2,2)=a(1,3)
      a(3,1)=a(1,3)
      a(3,2)=a(2,3)
      call dminv(3,3,a)
      Do 125 i=1,3
       x(i)=0.D0
       Do 124 k=1,3
        x(i)=x(i)+a(i,k)*g(k)
124    Continue
125   Continue
126   Continue
      be=x(1)
      alphae=-x(2)
      gammae=x(3)
      write(6,995) be,alphae,gammae
995   format(/5x,'Spectroscopic constants Be,Alphae and Gammae'
     *       /5x,'Be=',e13.6,' cm-1    Alphae=',e13.6,' cm-1    Gammae='
     *       ,e13.6/5x,'Observed and computed B values')
      Do 127 nv=1,ne
       nv1=nv-1
       bc=be-alphae*(nv-0.5d0)+gammae*(nv-0.5d0)**2
       diff=b(nv)-bc
       write(6,991) nv1,b(nv),bc,diff
127   Continue
c
c     vibrational constants we,wexe and weye from band origins
c
      x(1)=0.D0
      x(2)=0.D0
      x(3)=0.D0
      if(ne.eq.1) x(1)=2*Work(indexTvj)
      if(ne.eq.1) go to 150
      if(ne.eq.2) then
       x(1)=3*Work(indexTvj)-Work(indexTvj+1)/3
       x(2)=2*Work(indexTvj+1)/3-2*Work(indexTvj)
       go to 150
      Endif
      Do 132 i=1,3
       g(i)=0.D0
      Do 133 k=1,3
       a(i,k)=0.D0
133   Continue
132   Continue
      Do 135 nv=1,ne
       xnv=nv-0.5d0
       xnv2=xnv**2
       xnv3=xnv**3
       g(1)=g(1)+Work(indexTvj+nv-1)*xnv
       g(2)=g(2)+Work(indexTvj+nv-1)*xnv2
       g(3)=g(3)+Work(indexTvj+nv-1)*xnv3
       a(1,1)=a(1,1)+xnv2
       a(1,2)=a(1,2)+xnv3
       a(1,3)=a(1,3)+xnv2**2
       a(2,3)=a(2,3)+xnv2*xnv3
       a(3,3)=a(3,3)+xnv3**2
135   Continue
      a(2,1)=a(1,2)
      a(2,2)=a(1,3)
      a(3,1)=a(1,3)
      a(3,2)=a(2,3)
      call dminv(3,3,a)
      Do 137 i=1,3
       x(i)=0.D0
       Do 136 k=1,3
        x(i)=x(i)+a(i,k)*g(k)
136    Continue
137   Continue
150   Continue
      we=x(1)*const
      wexe=x(2)*const
      weye=x(3)*const
      write(6,996) we,wexe,weye
996   format(/5x,'Vibrational constants we  =',e13.6,' cm-1'
     *       /5x,'                      wexe=',e13.6,' cm-1'
     *       /5x,'                      weye=',e13.6,' cm-1'
     *       /5x,'Observed and computed band origins')
      Do 155 nv=1,ne
       nv1=nv-1
       xnv=nv-0.5d0
       Tvjc=we*xnv+wexe*xnv**2+weye*xnv**3
       Tvjnv=const*Work(indexTvj+nv-1)
       diff=Tvjnv-Tvjc
       write(6,991) nv1,Tvjnv,Tvjc,diff
155   Continue
c
c     print output of spectroscopic constants
c
      write(6,1000) Atom1,Atom2
1000  format(//5x,'Spectroscopic constants for ',2a2)
      nv1=0
      nv2=ne-1
      write(6,1100) j1A,j2A,nv1,nv2
1100  format(//5x,'Range of J-values used in fit',2i3,
     *        /5x,'Range of v-values used in fit',2i3)
c
      Re=Req/1.88976d0
      dE=-E0*27.2099d0
      d0=dE-Work(indexTvj)*27.2099d0
c
      write(6,1200) Re,dE,d0,we,wexe,weye,
     *               Be,Alphae,Gammae,Dele,Betae
1200  format(///5x,'Re(a)',15x,f8.4,
     *         /5x,'De(ev)',14x,f8.4,
     *         /5x,'D0(ev)',14x,f8.4,
     *         /5x,'we(cm-1)',7x,e13.6,
     *         /5x,'wexe(cm-1)',5x,e13.6,
     *         /5x,'weye(cm-1)',5x,e13.6,
     *         /5x,'Be(cm-1)',7x,e13.6,
     *         /5x,'Alphae(cm-1)',3x,e13.6,
     *         /5x,'Gammae(cm-1)',3x,e13.6,
     *         /5x,'Dele(cm-1)',5x,e13.6,
     *         /5x,'Betae(cm-1)',4x,e13.6)
*...+....1....+....2....+....3....+....4....+....5....+....6....+....7.>..+....8
      ChkSum=ChkSum + we + wexe
c
c     compute term values for check
c
      ind=0
      Do 300 J=J1A,J2A
       xj=J*(J+1)
       Do 290 nv=1,ne
        ind=ind+1
        xnv=nv-0.5d0
        Work(indexT+ind-1)=we*xnv+wexe*xnv**2+weye*xnv**3
     *        +xj*(be-alphae*xnv+gammae*xnv**2)
     *        -xj**2*(dele+betae*xnv)
290    Continue
300   Continue
c
c     compute max deviation
c
      tmax=zero
      Do 310 i=1,ntot
      Work(indexTvj+i-1)=Work(indexTvj+i-1)*const
      diff=abs(Work(indexT+i-1)-Work(indexTvj+i-1))
      if(diff.lt.tmax) go to 310
      tmax=diff
310   Continue
      ChkSum=ChkSum + tmax
      write(6,1300) tmax
1300  format(//5x,'Max deviation in term values is',e10.2,' cm(-1)')
c
c     print output of term values
c
      write(6,1400)
1400  format(//5x,'Term values(observed and computed) in cm(-1)')
      jst=j1A
315   jend=jst+4
      if(jend.gt.j2A) jend=j2A
      jrng=jend-jst+1
      Do 320 i=1,jrng
      jind(i)=jst+i-1
320   Continue
      write(6,1500) (jind(i),i=1,jrng)
1500  format(/1x,'J-value',7x,i3,19x,i3,19x,i3,19x,i3,19x,i3)
      write(6,1510)
1510  format(/1x,'v-value')
      Do 340 nv=1,ne
      nv1=nv-1
      js=(jst-j1A)*ne+nv
      je=(jend-j1A)*ne+nv
      write(6,1600) nv1,(Work(indexTvj+i-1),Work(indexT+i-1),i=js,je,ne)
1600  format(4x,i2,2x,5(f8.2,2x,f8.2,4x))
340   Continue
      jst=jend+1
      if(jend.lt.j2A) go to 315
c
c     observed g-values (Tvj for j=0)
c
      Do 350 i=1,ne
      Gv(i)=Work(indexTvj+i-1)
      ChkSum=ChkSum + Gv(i)
350   Continue
c
c      compute delta g(v+1/2) values
c
      ne1=ne-1
      Do 420 i=1,ne1
      Gv2(i)=Gv(i+1)-Gv(i)
420   Continue
c
c     print Gv and Gv2
c
      write(6,1700)
1700  format(//5x,'observed G-values in cm(-1)'/
     *       /5x,'v',6x,'G(v)',5x,'deltaG(v+1/2)')
      Do 440 i=1,ne1
      i1=i-1
      write(6,1800) i1,Gv(i)
1800  format(4x,i2,f11.2)
      write(6,1810) Gv2(i)
1810  format(17x,f13.2)
440   Continue
      i1=ne-1
      write(6,1800) i1,Gv(ne)
c
      Call GetMem('VecTvj','Free','Real',indexTvj,ndim)
      Call GetMem('VecT','Free','Real',indexT,ndim)
c
      Call Add_Info('VIBROT_SPECTC',[ChkSum],1,2)
*     Write(*,*) 'Spectc: ChkSum',ChkSum
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETVEC(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,
     &                      SCR,LSCR)
C
C     Purpose: read Cholesky vectors IVEC=IVEC1,....,IVEC1+NUMVEC-1
C              of symmetry ISYM from file. The vectors are returned
C              in the "current" reduced set. The algorithm used for
C              reading is taken from input (via cholesky.fh header
C              file).
C
      use ChoArr, only: iScr
      use ChoSwp, only: InfVec
#include "implicit.fh"
      DIMENSION CHOVEC(LENVEC,NUMVEC)
      DIMENSION SCR(LSCR)
#include "cholesky.fh"

      external ddot_

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_GETVEC')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

C     Return if no vectors requested.
C     -------------------------------

      IF (NUMVEC .LT. 1) THEN
         IF (LOCDBG) THEN
            WRITE(LUPRI,*) SECNAM,': WARNING: no vectors in this call!'
            WRITE(LUPRI,*) SECNAM,': NUMVEC = ',NUMVEC
         END IF
         RETURN
      END IF

C     Check vector dimension: should be identical to current reduced
C     set. Check also symmetry and vector index.
C     --------------------------------------------------------------

      IF (LOCDBG) THEN
         IFAIL = 0
         IF (LENVEC.NE.NNBSTR(ISYM,2) .OR. LENVEC.LT.1) THEN
            WRITE(LUPRI,*) SECNAM,': illegal vector dimension:'
            WRITE(LUPRI,*) SECNAM,': LENVEC = ',LENVEC
            IFAIL = IFAIL + 1
         END IF
         IF (ISYM.LT.1 .OR. ISYM.GT.NSYM) THEN
            WRITE(LUPRI,*) SECNAM,': illegal symmetry input:'
            WRITE(LUPRI,*) SECNAM,': ISYM = ',ISYM
            IFAIL = IFAIL + 1
         END IF
         IVEC2 = IVEC1 + NUMVEC - 1
         IF (IVEC1.LT.1 .OR. IVEC1.GT.MAXVEC .OR.
     &       IVEC2.LT.1 .OR. IVEC2.GT.MAXVEC) THEN
            WRITE(LUPRI,*) SECNAM,': illegal vector index:'
            WRITE(LUPRI,*) SECNAM,': IVEC1,IVEC2 = ',IVEC1,IVEC2
            IFAIL = IFAIL + 1
         ELSE
            IF (INFVEC(IVEC1,3,ISYM) .LT. 0) THEN
               WRITE(LUPRI,*) SECNAM,': illegal first vector address:'
               WRITE(LUPRI,*) SECNAM,': address: ',INFVEC(IVEC1,3,ISYM)
               IFAIL = IFAIL + 1
            END IF
            IF (INFVEC(IVEC2,3,ISYM) .LT. 0) THEN
               WRITE(LUPRI,*) SECNAM,': illegal last vector address:'
               WRITE(LUPRI,*) SECNAM,': address: ',INFVEC(IVEC2,3,ISYM)
               IFAIL = IFAIL + 1
            END IF
         END IF
         IF (CHO_IOVEC.EQ.1 .OR. CHO_IOVEC.EQ.2 .OR. CHO_IOVEC.EQ.3 .OR.
     &       CHO_IOVEC.EQ.4) THEN
            IF (SIZE(ISCR) .LT. NNBSTR(ISYM,2)) THEN
               WRITE(LUPRI,*) SECNAM,': insufficient iscratch:'
               WRITE(LUPRI,*) SECNAM,': SIZE(ISCR) = ',SIZE(ISCR)
               IFAIL = IFAIL + 1
            END IF
         END IF
         IF (IFAIL .NE. 0) THEN
            WRITE(LUPRI,*) SECNAM,': unable to continue!'
            CALL CHO_QUIT('Error in '//SECNAM,104)
         END IF
      END IF

C     Call reading routine.
C     ---------------------

      IF (CHO_IOVEC .EQ. 1) THEN
         CALL CHO_GETVEC1(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,SCR,LSCR)
      ELSE IF (CHO_IOVEC.EQ.2 .OR. CHO_IOVEC.EQ.3 .OR. CHO_IOVEC.EQ.4)
     & THEN
         CALL CHO_GETVEC2(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,SCR,LSCR)
      ELSE
         CALL CHO_GETVEC0(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,SCR,LSCR)
      END IF

C     Debug print.
C     ------------

      IF (LOCDBG) THEN
         CALL CHO_FLUSH(LUPRI)
         WRITE(LUPRI,*)
         WRITE(LUPRI,*) SECNAM,':'
         WRITE(LUPRI,*) 'Vectors ',IVEC1,' to ',IVEC1+NUMVEC-1,
     &                  ' of symmetry ',ISYM,' read from unit ',
     &                  LUCHO(ISYM)
         WRITE(LUPRI,*) 'Vector dimension: ',LENVEC,
     &                  ' (current reduced set)'
         WRITE(LUPRI,*) 'Algorithm: ',CHO_IOVEC
         DO IVEC = 1,NUMVEC
            JVEC = IVEC1 + IVEC - 1
            JADR = INFVEC(JVEC,3,ISYM)
            XNRM = SQRT(DDOT_(LENVEC,CHOVEC(1,IVEC),1,CHOVEC(1,IVEC),1))
            WRITE(LUPRI,*) 'Vector:',JVEC,' address: ',JADR,' norm: ',
     &                     XNRM
         END DO
         CALL CHO_FLUSH(LUPRI)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Cho_x_Loc(irc,Thrs,nSym,nBas,nFro,nIsh,
     &                                        nAsh,nSsh,CMO)

      use definitions, only: iwp, wp
      use stdalloc, only: mma_allocate, mma_deallocate
      Implicit None
      integer(kind=iwp), intent(in):: nSym, nBas(nSym), nFro(nSym),
     &                                nAsh(nSym), nIsh(nSym), nSsh(nSym)
      real(kind=wp), intent(in)::  Thrs
      real(kind=wp), intent(inout)::  CMO(*)

      real(kind=wp), allocatable:: Dens(:)
      integer(kind=iwp) irc, iSym, kOff1, kOffC, l_Dens
      real(kind=wp) yNrm

      irc=0
      l_Dens = 0
      Do iSym = 1,nSym
         l_Dens = max(l_Dens,nBas(iSym)**2)
      End Do
      Call mma_allocate(Dens,l_Dens,Label='Dens')
      kOffC = 0
      Do iSym = 1,nSym
         If (nIsh(iSym) .gt. 0) Then
            kOff1 = 1 + kOffC + nBas(iSym)*nFro(iSym)
            Call GetDens_Localisation(Dens,CMO(kOff1),
     &                                nBas(iSym),nIsh(iSym))
            Call FZero(CMO(kOff1),nBas(iSym)*nIsh(iSym))
            Call ChoLoc(irc,Dens,CMO(kOff1),Thrs,yNrm,
     &                  nBas(iSym),nIsh(iSym))
            If (irc .ne. 0) Then
               Call mma_deallocate(Dens)
               irc  = 1
               Return
            End If
         End If
         If (nSsh(iSym) .gt. 0) Then
            kOff1= 1+kOffC+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
            Call GetDens_Localisation(Dens,CMO(kOff1),
     &                                nBas(iSym),nSsh(iSym))
            Call FZero(CMO(kOff1),nBas(iSym)*nSsh(iSym))
            Call ChoLoc(irc,Dens,CMO(kOff1),Thrs,yNrm,
     &                  nBas(iSym),nSsh(iSym))
            If (irc .ne. 0) Then
               Call mma_deallocate(Dens)
               irc  = 1
               Return
            End If
         End If
         kOffC = kOffC + nBas(iSym)**2
      End Do

      Call mma_deallocate(Dens)

      End Subroutine Cho_x_Loc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1992,1995, Roland Lindh                           *
*               1997, Anders Bernhardsson                              *
************************************************************************
      SubRoutine CmbnEldot
     &             (Rnxyz,nZeta,la,lb,lr,Zeta,rKappa,Final,nComp,
     &                   Fact,Temp,Alpha,Beta,DAO,
     &                   iStb,jStb,nOp,rout,indgrd)
************************************************************************
*                                                                      *
* Object: to compute gradient integrals for SC Reaction Fields         *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             Modified for reaction field calculations July '92        *
*             Modified for gradient calculations May '95               *
*             Modified for trans. prob.   calculations Oct '97         *
*             by Anders Bernhardsson                                   *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChTbl, iChBas
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Integer nOp(2),indgrd(2,3,3,0:7)
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp,6),
     &       Zeta(nZeta), rKappa(nZeta), Fact(nZeta), Temp(nZeta),
     &       Rnxyz(nZeta,3,0:la+1,0:lb+1,0:lr),
     &       DAO(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2),
     &       Alpha(nZeta), Beta(nZeta),rout(*)
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
      iOff(ixyz) = ixyz*(ixyz+1)*(ixyz+2)/6
*
*
      tTwo=Two
*
      Do 130 iZeta = 1, nZeta
         Fact(iZeta) = rKappa(iZeta) * Zeta(iZeta)**(-Three/Two)
130   Continue
*
*---- Loop over angular components of the basis set
*
      Do 10 ixa = 0, la
         iyaMax=la-ixa
      Do 11 ixb = 0, lb
         iybMax=lb-ixb
         Do 20 iya = 0, iyaMax
            iza = la-ixa-iya
            ipa= Ind(la,ixa,iza)
         Do 21 iyb = 0, iybMax
            izb = lb-ixb-iyb
            ipb= Ind(lb,ixb,izb)
*
*           Combine multipole moment integrals
*
               Do ix = 0, lr
                  Do iy = 0, lr-ix
                     If (ixa.gt.0) Then
                        xa = -ixa
                        Do iZeta = 1, nZeta
                           Temp(iZeta) = Fact(iZeta) *
     &                                   (tTwo*Alpha(iZeta) *
     &                                   Rnxyz(iZeta,1,ixa+1,ixb,ix) +
     &                                xa*Rnxyz(iZeta,1,ixa-1,ixb,ix)) *
     &                                   Rnxyz(iZeta,2,iya,iyb,iy)
                        End Do
                     Else
                        Do iZeta = 1, nZeta
                           Temp(iZeta) = Fact(iZeta) *
     &                                   tTwo*Alpha(iZeta) *
     &                                   Rnxyz(iZeta,1,ixa+1,ixb,ix) *
     &                                   Rnxyz(iZeta,2,iya,iyb,iy)
                        End Do
                     End If
*
                     Do ir = ix+iy, lr
                        iz = ir-ix-iy
                        iComp=Ind(ir,ix,iz)+iOff(ir)
                        Do iZeta = 1, nZeta
                           Final(iZeta,ipa,ipb,iComp,1) = Temp(iZeta)*
     &                             Rnxyz(iZeta,3,iza,izb,iz)
                        End Do
                     End Do
                  End Do
               End Do
               Do ix = 0, lr
                  Do iy = 0, lr-ix
                     If (ixb.gt.0) Then
                        xb = -ixb
                        Do iZeta = 1, nZeta
                           Temp(iZeta) = Fact(iZeta) *
     &                                   (tTwo*Beta(iZeta) *
     &                                   Rnxyz(iZeta,1,ixa,ixb+1,ix) +
     &                                xb*Rnxyz(iZeta,1,ixa,ixb-1,ix)) *
     &                                   Rnxyz(iZeta,2,iya,iyb,iy)
                        End Do
                     Else
                        Do iZeta = 1, nZeta
                           Temp(iZeta) = Fact(iZeta) *
     &                                   tTwo*Beta(iZeta) *
     &                                   Rnxyz(iZeta,1,ixa,ixb+1,ix) *
     &                                   Rnxyz(iZeta,2,iya,iyb,iy)
                        End Do
                     End If
*
                     Do ir = ix+iy, lr
                        iz = ir-ix-iy
                        iComp=Ind(ir,ix,iz)+iOff(ir)
                        Do iZeta = 1, nZeta
                           Final(iZeta,ipa,ipb,iComp,4) = Temp(iZeta)*
     &                             Rnxyz(iZeta,3,iza,izb,iz)
                        End Do
                     End Do
                  End Do
               End Do
               Do ix = 0, lr
                  Do iy = 0, lr-ix
                     If (iya.gt.0) Then
                        ya = -iya
                        Do iZeta = 1, nZeta
                           Temp(iZeta) = Fact(iZeta) *
     &                                   Rnxyz(iZeta,1,ixa,ixb,ix) *
     &                                   (tTwo*Alpha(iZeta) *
     &                                   Rnxyz(iZeta,2,iya+1,iyb,iy) +
     &                                ya*Rnxyz(iZeta,2,iya-1,iyb,iy))
                        End Do
                     Else
                        Do iZeta = 1, nZeta
                           Temp(iZeta) = Fact(iZeta) *
     &                                   Rnxyz(iZeta,1,ixa,ixb,ix) *
     &                                   tTwo*Alpha(iZeta) *
     &                                   Rnxyz(iZeta,2,iya+1,iyb,iy)
                        End Do
                     End If
*
                     Do ir = ix+iy, lr
                        iz = ir-ix-iy
                        iComp=Ind(ir,ix,iz)+iOff(ir)
                        Do iZeta = 1, nZeta
                           Final(iZeta,ipa,ipb,iComp,2) = Temp(iZeta)*
     &                             Rnxyz(iZeta,3,iza,izb,iz)
                        End Do
                     End Do
                  End Do
               End Do
               Do ix = 0, lr
                  Do iy = 0, lr-ix
                     If (iyb.gt.0) Then
                        yb = -iyb
                        Do iZeta = 1, nZeta
                           Temp(iZeta) = Fact(iZeta) *
     &                                   Rnxyz(iZeta,1,ixa,ixb,ix) *
     &                                   (tTwo*Beta(iZeta) *
     &                                   Rnxyz(iZeta,2,iya,iyb+1,iy) +
     &                                yb*Rnxyz(iZeta,2,iya,iyb-1,iy))
                        End Do
                     Else
                        Do iZeta = 1, nZeta
                           Temp(iZeta) = Fact(iZeta) *
     &                                   Rnxyz(iZeta,1,ixa,ixb,ix) *
     &                                   tTwo*Beta(iZeta) *
     &                                   Rnxyz(iZeta,2,iya,iyb+1,iy)
                        End Do
                     End If
*
                     Do ir = ix+iy, lr
                        iz = ir-ix-iy
                        iComp=Ind(ir,ix,iz)+iOff(ir)
                        Do iZeta = 1, nZeta
                           Final(iZeta,ipa,ipb,iComp,5) = Temp(iZeta)*
     &                             Rnxyz(iZeta,3,iza,izb,iz)
                        End Do
                     End Do
                  End Do
               End Do
               Do ix = 0, lr
                  Do iy = 0, lr-ix
                     Do iZeta = 1, nZeta
                        Temp(iZeta) = Fact(iZeta) *
     &                                Rnxyz(iZeta,1,ixa,ixb,ix)*
     &                                Rnxyz(iZeta,2,iya,iyb,iy)
                     End Do
*
                     Do ir = ix+iy, lr
                        iz = ir-ix-iy
                        iComp=Ind(ir,ix,iz)+iOff(ir)
                        If (iza.gt.0) Then
                           za = -iza
                           Do iZeta = 1, nZeta
                              Final(iZeta,ipa,ipb,iComp,3)= Temp(iZeta)*
     &                                (tTwo*Alpha(iZeta) *
     &                                Rnxyz(iZeta,3,iza+1,izb,iz) +
     &                             za*Rnxyz(iZeta,3,iza-1,izb,iz))
                           End Do
                        Else
                           Do iZeta = 1, nZeta
                              Final(iZeta,ipa,ipb,iComp,3)= Temp(iZeta)*
     &                                tTwo*Alpha(iZeta) *
     &                                Rnxyz(iZeta,3,iza+1,izb,iz)
                           End Do
                        End If
                     End Do
                  End Do
               End Do
               Do ix = 0, lr
                  Do iy = 0, lr-ix
                     Do iZeta = 1, nZeta
                        Temp(iZeta) = Fact(iZeta) *
     &                                Rnxyz(iZeta,1,ixa,ixb,ix)*
     &                                Rnxyz(iZeta,2,iya,iyb,iy)
                     End Do
*
                     Do ir = ix+iy, lr
                        iz = ir-ix-iy
                        iComp=Ind(ir,ix,iz)+iOff(ir)
                        If (izb.gt.0) Then
                           zb = -izb
                           Do iZeta = 1, nZeta
                              Final(iZeta,ipa,ipb,iComp,6)= Temp(iZeta)*
     &                                (tTwo* Beta(iZeta) *
     &                                Rnxyz(iZeta,3,iza,izb+1,iz) +
     &                             zb*Rnxyz(iZeta,3,iza,izb-1,iz))
                           End Do
                        Else
                           Do iZeta = 1, nZeta
                              Final(iZeta,ipa,ipb,iComp,6)= Temp(iZeta)*
     &                                tTwo* Beta(iZeta) *
     &                                Rnxyz(iZeta,3,iza,izb+1,iz)
                           End Do
                        End If
                     End Do
                  End Do
               End Do
*
 21      Continue
 20      Continue
 11   Continue
 10   Continue
*
      nDAO = nZeta * (la+1)*(la+2)/2 * (lb+1)*(lb+2)/2
      Do  iIrrep=0,nIrrep-1
       Do  iCnt=1,2
        Do   iCar=1,3
          Do jCar=1,3
              icomp=jcar+1
              iGrad = Abs(IndGrd(icnt,iCar,jcar,iirrep))
               If (iCnt.eq.1) Then
                  i1 = iCar
                  ps=DBLE(iChTbl(iIrrep,nOp(1)))
                  ps=ps*DBLE(iPrmt( nOp(1),iChBas(1+iCar)))
                  Fct = DBLE(iStb)/DBLE(nIrrep)
               Else
                  i1 = iCar + 3
                  ps=DBLE(iChTbl(iIrrep,nOp(2)))
                  ps = ps*DBLE( iPrmt( nOp(2), iChBas(1+iCar) ) )
                  Fct = ps * DBLE(jStb)/DBLE(nIrrep)
              End If

            If (IndGrd(iCnt,iCar,jCar,iIrrep).ne.0) Then
               ihess=indgrd(icnt,icar,jcar,iirrep)
               rtemp=DDot_(nDAO,DAO,1,Final(1,1,1,icomp,i1),1)
               rout(iHess) = rOut(iHess) + Fct*rtemp
            End If

          End Do
        End Do
       End Do
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1999, Markus P. Fuelscher                         *
*               1993, Per Ake Malmqvist                                *
************************************************************************
      Subroutine I4Len(nData,InBuf,lIndx)
************************************************************************
*                                                                      *
*     purpose: return the length of packed integer values              *
*                                                                      *
*    Calling parameters:                                               *
*    nData : number of unpacked integrals                              *
*    InBuf : contains on input unpack integers                         *
*    lIndx : contains length of packed integers on output              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and P. A. Malmqvist                               *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     replace various older algorithms                                 *
*     M.P. Fuelscher, University of Lund, Sweden, 1999                 *
*                                                                      *
************************************************************************
*
      Integer InBuf(nData)
      Integer lIndx(nData)
*
*----------------------------------------------------------------------*
*
      iOpt = 1
      Call iziplen(iOpt,nData,InBuf,lIndx)
*
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_MaxDX(Diag,Sync,Dmax)
C
C     Purpose: get max. diagonal elements in each sym. block,
C              qualified diagonals excluded.
C
      use ChoSwp, only: Diag_G
      Implicit None
      Real*8  Diag(*)
      Logical Sync
      Real*8  Dmax(*)
#include "cho_para_info.fh"
#include "choglob.fh"

      Integer iLoc

      If (Cho_Real_Par) Then
         If (Sync) Then
            iLoc = 2
            Call Cho_P_SyncDiag(Diag,iLoc)
         End If
         Call Cho_P_IndxSwp()
         Call Cho_MaxDX(Diag_G,Dmax)
         Call Cho_P_IndxSwp()
      Else
         Call Cho_MaxDX(Diag,Dmax)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************

module Cholesky_Structures

! An extension to Data_Structures
! This is in a separate module because it needs the Cholesky module,
! which needs Data_Structures, so there would be a circular dependency.

use Index_Functions, only: iTri, nTri_Elem
use Data_Structures, only: Allocate_DT, Deallocate_DT, V1
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
private

public :: Allocate_DT, Deallocate_DT, L_Full_Type, Lab_Type

type L_Full_Pointers
  real(kind=wp), contiguous, pointer :: A3(:,:,:) => null()
  real(kind=wp), contiguous, pointer :: A21(:,:) => null()
  real(kind=wp), contiguous, pointer :: A12(:,:) => null()
end type L_Full_Pointers

type L_Full_Type
  integer(kind=iwp) :: iCase = 0
  integer(kind=iwp) :: iSym = 0
  integer(kind=iwp) :: nSym = 0
  integer(kind=iwp) :: nShell = 0
  real(kind=wp), allocatable :: A0(:)
  type(L_Full_Pointers), allocatable :: SPB(:,:,:)
end type L_Full_Type

type Lab_Type
  integer(kind=iwp) :: nSym = 0
  integer(kind=iwp) :: nDen = 0
  integer(kind=iwp) :: nShell = 0
  real(kind=wp), allocatable :: A0(:)
  logical(kind=iwp), allocatable :: Keep(:,:)
  type(V1), allocatable :: SB(:,:,:)
end type Lab_Type

! Extend allocate/deallocate data types

interface Allocate_DT
  module procedure :: Allocate_L_Full, Allocate_Lab
end interface Allocate_DT
interface Deallocate_DT
  module procedure :: Deallocate_L_Full, Deallocate_Lab
end interface Deallocate_DT

! Private extensions to mma interfaces

interface mma_allocate
  module procedure :: lfp_mma_allo_3D, lfp_mma_allo_3D_lim, v1_mma_allo_3D, v1_mma_allo_3D_lim
end interface
interface mma_deallocate
  module procedure :: lfp_mma_free_3D, v1_mma_free_3D
end interface

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!                      L F u l l - T Y P E   S E C T I O N             !
!                                                                      !
!                      L  full storage shell-pair blocked              !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Allocate_L_Full(Adam,nShell,iShp_rs,JNUM,JSYM,nSym,Memory)

  use Cholesky, only: nBasSh, nnBstRSh
  use Constants, only: Zero

  type(L_Full_Type), target, intent(out) :: Adam
  integer(kind=iwp), intent(in) :: nShell, iShp_rs(nTri_Elem(nShell)), JNUM, JSYM, nSym
  integer(kind=iwp), intent(out), optional :: Memory(2)
  integer(kind=iwp) :: iaSh, ibSh, iShp, iSyma, iSymb, LFULL, iS, iE, MemSPB, n1, n2

  LFULL = 0
  do iaSh=1,nShell
    do ibSh=1,iaSh
      iShp = iTri(iaSh,ibSh)

      if (iShp_rs(iShp) <= 0) cycle

      if (nnBstRSh(Jsym,iShp_rs(iShp),1) <= 0) cycle

      do iSymb=1,nSym
        iSyma = Mul(iSymb,Jsym)
        if (iSyma < iSymb) cycle

        LFULL = LFULL+nBasSh(iSyma,iaSh)*nBasSh(iSymb,ibSh)
        if (iaSh == ibSh) cycle

        LFULL = LFULL+nBasSh(iSyma,ibSh)*nBasSh(iSymb,iaSh)

      end do

    end do
  end do
  LFULL = LFULL*JNUM

  if (present(Memory)) then
    MemSPB = nSym*nShell*(nShell+1)
    MemSPB = (MemSPB*storage_size(Adam%SPB)-1)/storage_size(Adam%A0)+1
    Memory = [LFULL,MemSPB]
    return
  end if

  Adam%iCase = 1
  Adam%nSym = nSym
  Adam%iSym = JSYM
  Adam%nShell = nShell

  call mma_allocate(Adam%A0,LFULL,Label='Adam%A0')
  Adam%A0(:) = Zero

  call mma_allocate(Adam%SPB,nSym,nTri_Elem(nShell),2,label='Adam%SPB')
# include "macros.fh"
  unused_proc(mma_allocate(Adam%SPB,[0,0],[0,0],[0,0]))

  iE = 0
  do iaSh=1,nShell
    do ibSh=1,iaSh
      iShp = iTri(iaSh,ibSh)

      if (iShp_rs(iShp) <= 0) cycle

      if (nnBstRSh(Jsym,iShp_rs(iShp),1) <= 0) cycle

      do iSymb=1,nSym
        iSyma = Mul(iSymb,Jsym)
        if (iSyma < iSymb) cycle

        iS = iE+1

        n1 = nBasSh(iSyma,iaSh)
        n2 = nBasSh(iSymb,ibSh)

        iE = iE+n1*JNUM*n2

        Adam%SPB(iSyma,iShp_rs(iShp),1)%A3(1:n1,1:JNUM,1:n2) => Adam%A0(iS:iE)
        Adam%SPB(iSyma,iShp_rs(iShp),1)%A21(1:n1*JNUM,1:n2) => Adam%A0(iS:iE)
        Adam%SPB(iSyma,iShp_rs(iShp),1)%A12(1:n1,1:JNUM*n2) => Adam%A0(iS:iE)

        if (iaSh == ibSh) cycle

        iS = iE+1

        n1 = nBasSh(iSyma,ibSh)
        n2 = nBasSh(iSymb,iaSh)

        iE = iE+n1*JNUM*n2

        Adam%SPB(iSyma,iShp_rs(iShp),2)%A3(1:n1,1:JNUM,1:n2) => Adam%A0(iS:iE)
        Adam%SPB(iSyma,iShp_rs(iShp),2)%A21(1:n1*JNUM,1:n2) => Adam%A0(iS:iE)
        Adam%SPB(iSyma,iShp_rs(iShp),2)%A12(1:n1,1:JNUM*n2) => Adam%A0(iS:iE)

      end do

    end do
  end do

end subroutine Allocate_L_Full

subroutine Deallocate_L_Full(Adam)

  type(L_Full_Type), intent(inout) :: Adam
  integer(kind=iwp) :: iaSh, ibSh, iShp, iSyma

  do iaSh=1,Adam%nShell
    do ibSh=1,iaSh
      iShp = iTri(iaSh,ibSh)

      do iSyma=1,Adam%nSym

        nullify(Adam%SPB(iSyma,iShp,1)%A3,Adam%SPB(iSyma,iShp,1)%A21,Adam%SPB(iSyma,iShp,1)%A12, &
                Adam%SPB(iSyma,iShp,2)%A3,Adam%SPB(iSyma,iShp,2)%A21,Adam%SPB(iSyma,iShp,2)%A12)

      end do

    end do
  end do

  call mma_deallocate(Adam%SPB)
  call mma_deallocate(Adam%A0)
  Adam%iCase = 0
  Adam%nSym = 0
  Adam%iSym = 0
  Adam%nShell = 0

end subroutine Deallocate_L_Full

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!                      L a b - T Y P E   S E C T I O N                 !
!                                                                      !
!                      Lab storaged                                    !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Allocate_Lab(Lab,JNUM,nBasSh,nBas,nShell,nSym,nDen,Memory)

  use Constants, only: Zero

  type(Lab_Type), target, intent(out) :: Lab
  integer(kind=iwp), intent(in) :: JNUM, nShell, nSym, nBasSh(nSym,nShell), nBas(nSym), nDen
  integer(kind=iwp), intent(out), optional :: Memory(2)
  integer(kind=iwp) :: iSym, iDen, Lab_Memory, iE, iS, iSh, MemKeep, MemSB

  Lab_Memory = 0
  do iSym=1,nSym
    Lab_Memory = max(nBas(iSym),Lab_Memory)
  end do
  Lab_Memory = Lab_Memory*JNUM*nDen

  if (present(Memory)) then
    MemKeep = nShell*nDen
    MemKeep = (MemKeep*storage_size(Lab%Keep)-1)/storage_size(Lab%A0)+1
    MemSB = nShell*nSym*nDen
    MemSB = (MemSB*storage_size(Lab%SB)-1)/storage_size(Lab%A0)+1
    Memory = [Lab_Memory,MemKeep+MemSB]
    return
  end if

  Lab%nSym = nSym
  Lab%nDen = nDen
  Lab%nShell = nShell
  call mma_allocate(Lab%A0,Lab_Memory,Label='Lab%A0')
  Lab%A0(:) = Zero
  call mma_allocate(Lab%Keep,nShell,nDen,Label='Lab%Keep')
  call mma_allocate(Lab%SB,nShell,nSym,nDen,Label='Lab%SB')
# include "macros.fh"
  unused_proc(mma_allocate(Lab%SB,[0,0],[0,0],[0,0]))

  do iSym=1,nSym
    iE = 0
    do iDen=1,nDen
      do iSh=1,nShell

        iS = iE+1
        iE = iE+nBasSh(iSym,iSh)*JNUM

        Lab%SB(iSh,iSym,iDen)%A(1:nBasSh(iSym,iSh)*JNUM) => Lab%A0(iS:iE)

      end do
    end do
  end do

end subroutine Allocate_Lab

subroutine Deallocate_Lab(Lab)

  type(Lab_Type), intent(inout) :: Lab
  integer(kind=iwp) :: iSym, iDen, iSh

  do iSym=1,Lab%nSym
    do iDen=1,Lab%nDen
      do iSh=1,Lab%nShell

        nullify(Lab%SB(iSh,iSym,iDen)%A)

      end do
    end do
  end do

  Lab%nSym = 0
  Lab%nDen = 0
  Lab%nShell = 0
  call mma_deallocate(Lab%A0)
  call mma_deallocate(Lab%Keep)
  call mma_deallocate(Lab%SB)

end subroutine Deallocate_Lab

! Define lfp_mma_allo_3D, lfp_mma_allo_3D_lim, lfp_mma_free_3D
!        v1_mma_allo_3D, v1_mma_allo_3D_lim, v1_mma_free_3D
#define _TYPE_ type(L_Full_Pointers)
#  define _SUBR_NAME_ lfp_mma
#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'lfp_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

#define _TYPE_ type(V1)
#  define _SUBR_NAME_ v1_mma
#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'v1_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

end module Cholesky_Structures

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetChargeConstraint()
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: set info for charge constraint.
C              To unset, call LDF_UnsetChargeConstraint()
C
      Implicit None
#include "WrkSpc.fh"
#include "ldf_charge_constraint_info.fh"
#include "ldf_atom_pair_info.fh"

      Character*23 SecNam
      Parameter (SecNam='LDF_SetChargeConstraint')

      Integer  LDF_nAtom, LDF_nBasAux_Atom, LDF_nBas_Atom
      External LDF_nAtom, LDF_nBasAux_Atom, LDF_nBas_Atom

      Character*8 Label

      Integer nAtom
      Integer l
      Integer ip0
      Integer A, AB
      Integer ip

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      If (ChargeConstraintSet) Return

      ! Allocate memory for storing integrals over 1C aux functions
      nAtom=LDF_nAtom()
      l=nAtom
      Call GetMem('CCAIV_BP','Allo','Inte',ip_CC_AuxIntVec,l)
      l=0
      ip0=ip_CC_AuxIntVec-1
      Do A=1,nAtom
         iWork(ip0+A)=l
         l=l+LDF_nBasAux_Atom(A)
      End Do
      Call GetMem('CCAuxInt','Allo','Real',ip,l)
      Do A=1,nAtom
         iWork(ip0+A)=iWork(ip0+A)+ip
      End Do

      ! Compute integrals over 1C aux functions
      Label='Mltpl  0'
      Call LDF_SetOneEl(Label)
      Do A=1,nAtom
         l=LDF_nBasAux_Atom(A)
         ip=iWork(ip0+A)
         Call LDF_ComputeAuxInt_1(A,l,Work(ip))
      End Do
      Call LDF_UnsetOneEl(Label)

      ! Allocate memory for largest overlap and multiplier blocks
      l=0
      Do AB=1,NumberOfAtomPairs
         l=max(l,LDF_nBas_Atom(AP_Atoms(1,AB))
     &          *LDF_nBas_Atom(AP_Atoms(2,AB)))
      End Do
      l_CC_Overlap=l
      Call GetMem('CLDFOv','Allo','Real',ip_CC_Overlap,l_CC_Overlap)
      l_CC_lambda=l
      Call GetMem('CLDFla','Allo','Real',ip_CC_lambda,l_CC_lambda)

      ChargeConstraintSet=.True.

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_UnsetChargeConstraint()
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: unset info for charge constraint.
C
      Implicit None
#include "WrkSpc.fh"
#include "ldf_charge_constraint_info.fh"

      Integer  LDF_nAtom, LDF_nBasAux_Atom
      External LDF_nAtom, LDF_nBasAux_Atom

      Integer nAtom
      Integer l
      Integer A
      Integer ip

      If (.not.ChargeConstraintSet) Return

      ! Deallocate memory for storing integrals over 1C aux functions
      nAtom=LDF_nAtom()
      l=0
      Do A=1,nAtom
         l=l+LDF_nBasAux_Atom(A)
      End Do
      ip=iWork(ip_CC_AuxIntVec)
      Call GetMem('CCAuxInt','Free','Real',ip,l)
      l=nAtom
      Call GetMem('CCAIV_BP','Free','Inte',ip_CC_AuxIntVec,l)
      ip_CC_AuxIntVec=0

      ! Deallocate largest overlap and multiplier blocks
      Call GetMem('CLDFOv','Free','Real',ip_CC_Overlap,l_CC_Overlap)
      l_CC_Overlap=0
      ip_CC_Overlap=0
      Call GetMem('CLDFla','Free','Real',ip_CC_lambda,l_CC_lambda)
      l_CC_lambda=0
      ip_CC_lambda=0

      ChargeConstraintSet=.False.

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine Prpt_old(nirrep,nbas,ndim,n2dim,vec,occ,maxscr,scr)
************************************************************************
c
c     Purpose: calculation of expectation values of different
c              operators as available on the 'ONEINT' file
c
c     Caution: before calling this subroutine one needs to
c              open the ONEINT file
c
c     Calling parameters:
c
c       nIrRep            number of irreducible representations
c
c       nBas(0:nIrRep)    number of basis functions in each repre-
c                         sentation
c
c       ndim              total number of basis functions
c
c       n2dim             sum(i,i=0,nirrep-1)(nbas(i)**2): elements
c                         of all vectors in all representations
c
c       vec(1:n2dim)      eigenvectors, all for each representation
c
c       occ(1:ndim)       occupation number for all eigenvectors
c
c       maxscr            the maximum available size of the
c                         scratch area
c
c       scr(1:maxscr)     a scratch area whose size, nscr, can be
c                         calculated in the following way:
c
c                         nscr =sum(i,i=0,nirrep-1)(nbas(i)*
c                                  (nbas(i)+1)/2)
c                               +3
c                               +3
c                               +nComp
c                               +nComp
c                               +2*nComp
c                               +ndim*(ndim+1)/2+4
c                               +2*ntComp*(ntComp+1)
c
c                         and should not exceed maxscr.
c                         nComp is the number of cartresian compo-
c                         nets for the given operator
c                         ntComp is the number of components of
c                         the l-th moment opartors which are trans-
c                         formed into l-pole moment. Currently,
c                         ntComp=15 (hexadecpole moments)
c
c
c
* 1991 R. Lindh, Dept. of Theor. Chem. Univ. of Lund, Sweden.          *
************************************************************************
      Implicit real*8 (a-h,o-z)
*
#include "real.fh"
c
      Character*8 label
      Logical short, NxtOpr, ifallorb
      Integer nbas(0:nirrep)
      Real*8 vec(1:n2dim), occ(1:ndim), scr(1:maxscr)
      Dimension idum(1)
c
      Call Prpt_old_Internal(Scr)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine Prpt_old_Internal(Scr)
      Use Iso_C_Binding
      Real*8, Target :: Scr(*)
      Character, Pointer :: cScr(:)
      Write (6,*)
      Call CollapseOutput(1,'   Molecular properties:')
      Write (6,'(3X,A)')    '   ---------------------'
      Write (6,*)
      short=.true.
      ifallorb=.false.
      mDim = 1
      iadopr=-1 ! dummy initialize
      iadtmt=-1 ! dummy initialize
      iadtmp=-1 ! dummy initialize
c
      nblock=0
      do 1 i=0,nirrep-1
        nblock=nblock+nbas(i)*(nbas(i)+1)/2
1     continue
      nfblock=ndim*(ndim+1)/2
c
c     estimate the minimum scratch area needed for calculatig
c     the average values of a 3 component operator
c
      nscr=nblock+nfblock
      iscr=nscr+76
c
      if (iscr.gt.maxscr) Go To 999
c
      iadDen=1
c
c     calculate the density matrix with all off-diagonal elements
c     multipled by 2
c
      call dcopy_(nblock,[Zero],0,Scr(iadDen),1)
      iCount=iadDen
      iVec  =0
      iOcc  =0
      do i=0,nIrrep-1
         do ii=1,nBas(i)
            iOcc=iOcc+1
            jCount=iCount
            do 4 il=1,nBas(i)
               Do ir=1,il-1
                  Scr(jCount)=Scr(jCount)
     &                       +Two*Vec(iVec+il)*Vec(iVec+ir)*Occ(iOcc)
                   jCount=jCount+1
                End Do
                Scr(jCount)=Scr(jCount)
     &                     +Vec(iVec+il)*Vec(iVec+il)*Occ(iOcc)
                jCount=jCount+1
    4        continue
            iVec=iVec+nBas(i)
         End Do
         iCount=iCount+nbas(i)*(nBas(i)+1)/2
      End Do
*                                                                      *
************************************************************************
*                                                                      *
c     Scan the ONEINT file for multipole moment operators
c
      iadC1 =iadDen+nblock
      iadC2 =iadC1+3
      iadNuc=iadC2+3
c
C     Write (*,*) ' Starting scan of ONEINT for multipole moments'
      do 100 i=1,99
        NxtOpr = .False.
        nComp=(i+1)*(i+2)/2
c
        iadEl =iadNuc+nComp
        iadLab=iadEl +nComp
        iscr=nscr+10+4*nComp
        if (iscr.gt.maxscr) Go To 999
c
        call dcopy_(nComp,[Zero],0,Scr(iadNuc),1)
        call dcopy_(nComp,[Zero],0,Scr(iadEl ),1)
        call dcopy_(2*nComp,[Zero],0,Scr(iadLab),1)
        write (label,'(a,i2)') 'MLTPL ',i
        do 101 iComp=1,nComp
          irc=-1
          iopt=1
          Call iRdOne (irc,iopt,label,iComp,idum,iSmLbl)
          if (irc.eq.0) nInt=idum(1)
          if (irc.ne.0) go to 101
          NxtOpr = .True.
          irc=-1
          iopt=0
          iadOpr=iadLab+2*nComp
          Call RdOne (irc,iopt,label,iComp,scr(iadOpr),iSmLbl)
          if (irc.ne.0) go to 101
          If (nInt.ne.0)
     &       Call CmpInt(scr(iadOpr),nInt,nBas,nIrrep,iSmLbl)
          scr(iadNuc+icomp-1)=scr(iadOpr+nInt+3)
          if (iComp.eq.1) then
            do 102 k=0,2
              scr(iadC1+k)=scr(iadOpr+nInt+k)
              scr(iadC2+k)=scr(iadOpr+nInt+k)
102         continue
          endif
          If (nInt.eq.0) Go To 101
          Call Xprop(short, ifallorb,
     &               nIrrep,nBas,
     &               nBlock,Scr(iadDen),nDim,Occ,dummy,
     &               nblock,Scr(iadOpr),Scr(iadEl+iComp-1))
101     continue
        if (.Not.NxtOpr) Go To 199
        iadTmt=iadOpr+nblock
        if (i.le.4) then
          iadTmp=iadTmt+nComp**2
          iscr=iadTmp+nComp
          if (iscr.gt.maxscr) Go To 999
        else
          iadTmp=iadTmt
        endif
c
        Call C_F_Pointer(C_Loc(Scr(iadLab)),cScr,[1])
        call prop (short,label,scr(iadC1),scr(iadC2),
     &             nirrep,nBas,mDim,occ,dummy,
     &             scr(iadEl),scr(iadNuc),i,cScr,
     &             scr(iadTmt),scr(iadTmp),ifallorb)
        Nullify(cScr)
100   continue
*                                                                      *
************************************************************************
*                                                                      *
c     Scan 'ONEINT' for electric field integrals
c
199   continue
c
c
C     Write (*,*) ' Starting scan of ONEINT for various elec. field integrals'
c
      do 210 iEF=0,2
        nComp=(iEF+1)*(iEF+2)/2
c
        iadEl =iadNuc+nComp
        iadLab=iadEl +nComp
c
c
c       loop over differnt operator origins (max.9999)
c
        maxCen=9999
        do 200 i=1,maxCen
          call dcopy_(nComp,[Zero],0,Scr(iadNuc),1)
          call dcopy_(nComp,[Zero],0,Scr(iadEl ),1)
          call dcopy_(2*nComp,[Zero],0,Scr(iadLab),1)
          write (label,'(a,i1,i5)') 'EF',iEF,i
          NxtOpr=.False.
          do 201 iComp=1,nComp
            irc=-1
            iopt=1
            Call iRdOne (irc,iopt,label,iComp,idum,iSmLbl)
            if (irc.eq.0) nInt=idum(1)
            if (irc.ne.0) go to 201
            NxtOpr = .True.
            irc=-1
            iopt=0
            iadOpr=iadLab+2*nComp
            Call RdOne (irc,iopt,label,iComp,scr(iadOpr),iSmLbl)
            if (irc.ne.0) go to 201
            If (nInt.ne.0)
     &         Call CmpInt(scr(iadOpr),nInt,nBas,nIrrep,iSmLbl)
            scr(iadNuc+icomp-1)=scr(iadOpr+nInt+3)
            if (iComp.eq.1) then
              do 202 k=0,2
                scr(iadC1+k)=scr(iadOpr+nInt+k)
                scr(iadC2+k)=scr(iadOpr+nInt+k)
202           continue
            endif
            If (nInt.eq.0) Go To 201
            Call Xprop(short, ifallorb,
     &                 nIrrep,nBas,
     &                 nBlock,Scr(iadDen),nDim,Occ,dummy,
     &                 nblock,Scr(iadOpr),Scr(iadEl+iComp-1))
201       continue
          if (.Not.NxtOpr) go to 299
c
          Call C_F_Pointer(C_Loc(Scr(iadLab)),cScr,[1])
          call prop (short,label,scr(iadC1),scr(iadC2),
     &               nirrep,nBas,mDim,occ,dummy,
     &               scr(iadEl),scr(iadNuc),i,cScr,
     &               scr(iadTmt),scr(iadTmp),ifallorb)
          Nullify(cScr)
200     continue
c
299      continue
210   continue
*                                                                      *
************************************************************************
*                                                                      *
C     Write (*,*) ' Starting scan of ONEINT diamagnetic shielding'
c
      nComp=9
c
      iadEl =iadNuc+nComp
      iadLab=iadEl +nComp
c
c
c
      maxGG =99
      maxCen=99
c     loop over differnt gauge origins (max.99)
      do 400 j=1,maxGG
         call dcopy_(nComp,[Zero],0,Scr(iadNuc),1)
         call dcopy_(nComp,[Zero],0,Scr(iadEl ),1)
         call dcopy_(2*nComp,[Zero],0,Scr(iadLab),1)
        jRC = 0
c       loop over differnt operator origins (max.99)
        do 401 i=1,maxCen
          write (label,'(a,i2,i2)') 'DMS ',j,i
          NxtOpr = .False.
          do 402 iComp=1,nComp
            irc=-1
            iopt=1
            Call iRdOne (irc,iopt,label,iComp,idum,iSmLbl)
            if (irc.eq.0) nInt=idum(1)
            if (irc.ne.0) go to 402
            NxtOpr = .True.
            irc=-1
            iopt=0
            iadOpr=iadLab+2*nComp
            Call RdOne (irc,iopt,label,iComp,scr(iadOpr),iSmLbl)
            if (irc.ne.0) go to 402
            If (nInt.ne.0)
     &         Call CmpInt(scr(iadOpr),nInt,nBas,nIrrep,iSmLbl)
            scr(iadNuc+icomp-1)=scr(iadOpr+nInt+3)
            if (iComp.eq.1) then
              do 403 k=0,2
                scr(iadC1+k)=scr(iadOpr+nInt+k)
403           continue
            endif
            if (iComp.eq.2) then
              do 404 k=0,2
                scr(iadC2+k)=scr(iadOpr+nInt+k)
404           continue
            endif
            If (nInt.eq.0) Go To 402
            Call Xprop(short,ifallorb,
     &                 nIrrep,nBas,
     &                 nBlock,Scr(iadDen),nDim,Occ,dummy,
     &                 nblock,Scr(iadOpr),Scr(iadEl+iComp-1))
402       continue
          If (.Not.NxtOpr) Go To 4000
c
          Call C_F_Pointer(C_Loc(Scr(iadLab)),cScr,[1])
          call prop (short,label,scr(iadC1),scr(iadC2),
     &               nirrep,nBas,mDim,occ,dummy,
     &               scr(iadEl),scr(iadNuc),i,cScr,
     &               scr(iadTmt),scr(iadTmp),ifallorb)
          Nullify(cScr)
           jRC = 1
401     continue
4000    If (jRC.eq.0) Go To 499
400   continue
c
*                                                                      *
************************************************************************
*                                                                      *
499   continue
c

      Call CollapseOutput(0,'   Molecular properties:')
      Write(6,*)
      Return
c
  999 continue
      write (6,'(//1x,a/1x,a/1x,a,i8,a,i8)')
     &  ' Warrning:',
     &  ' Not enough scratch area to perform calculations',
     &  ' Needed at least:',iscr,'   available:',maxscr
c
      Call CollapseOutput(0,'   Molecular properties:')
      Write(6,*)
      Return
      End Subroutine Prpt_old_Internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mk_List2(List2,nTheta_All,mData,nSO_Tot,iCnttp,nTest,ijS_req)

use Index_Functions, only: iTri, nTri_Elem1
use Basis_Info, only: dbsc, Shells
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nTheta_All, mData, nSO_Tot, iCnttp, nTest, ijS_req
integer(kind=iwp), intent(out) :: List2(2*mData,nTheta_All)
integer(kind=iwp) :: iAng, iAng_, iCmp, iCmp_, iCont, iCont_, iiSO, ijS, ijSO, iShll, iShll_, iSO, iSO_, jAng, jAng_, jCmp_, &
                     jCont_, jjSO, jShll, jShll_, jSO, jSO_Max, mCmp, mSO, nCmp, nCont, nSO
logical(kind=iwp) :: Only_DB
integer(kind=iwp), allocatable :: iList(:,:)

call mma_allocate(iList,mData,nSO_Tot,Label='iList')

Only_DB = ijS_req /= 0

! Generate intermediate list
! Generate list2, shell blocked!

ijSO = 0
iiSO = 0
iSO_ = 0
do iAng=0,nTest
  iShll = dbsc(iCnttp)%iVal+iAng
  nCmp = nTri_Elem1(iAng)
  if (Shells(iShll)%Prjct) nCmp = 2*iAng+1
  nSO = nCmp*Shells(iShll)%nBasis
  do iCmp=1,nCmp
    nCont = Shells(iShll)%nBasis
    do iCont=1,nCont
      iSO_ = iSO_+1
      iList(1,iSO_) = iAng
      iList(2,iSO_) = iCmp
      iList(3,iSO_) = iCont
      iList(4,iSO_) = iShll
    end do
  end do
  !write(u6,*) 'iSO_=',iSO_

  jjSO = 0
  do jAng=0,iAng
    !write(u6,*) 'iAng,jAng=',iAng,jAng
    jShll = dbsc(iCnttp)%iVal+jAng
    mCmp = nTri_Elem1(jAng)
    if (Shells(jShll)%Prjct) mCmp = 2*jAng+1

    mSO = mCmp*Shells(jShll)%nBasis

    ijS = iTri(iAng+1,jAng+1)

    if ((.not. Only_DB) .or. (ijS == ijS_req)) then
      do iSO=iiSO+1,iiSO+nSO
        iAng_ = iList(1,iSO)
        iCmp_ = iList(2,iSO)
        iCont_ = iList(3,iSO)
        iShll_ = iList(4,iSO)

        jSO_Max = jjSO+mSO
        if (jAng == iAng) jSO_Max = iSO
        do jSO=jjSO+1,jSO_Max
          ijSO = ijSO+1
          jAng_ = iList(1,jSO)
          jCmp_ = iList(2,jSO)
          jCont_ = iList(3,jSO)
          jShll_ = iList(4,jSO)

          !write(u6,*) 'iSO,jSO,ijSO=',iSO,jSO,ijSO
          List2(1,ijSO) = iAng_
          List2(2,ijSO) = jAng_
          List2(3,ijSO) = iCmp_
          List2(4,ijSO) = jCmp_
          List2(5,ijSO) = iCont_
          List2(6,ijSO) = jCont_
          List2(7,ijSO) = iShll_
          List2(8,ijSO) = jShll_
        end do   ! jSO
      end do     ! iSO

    end if

    jjSO = jjSO+mSO
  end do         ! jAng

  iiSO = iiSO+nSO
end do           ! iAng

!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
write(u6,*) 'List2'
write(u6,*) '  iAng,  jAng,  iCmp,  jCmp, iCont, jCont, iShll, jShll'
do ijSO=1,nTheta_All
  write(u6,'(8I7)') (List2(i,ijSO),i=1,8)
end do
#endif

call mma_deallocate(iList)

return

end subroutine Mk_List2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module EtWas

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: mBas(0:7), mIrrep, nASh(0:7), nCMo, nCred, nDSO, nISh(0:7), nPSOP, nScr1, nScr2
real(kind=wp) :: CoulFac, ExFac

public :: CoulFac, ExFac, mBas, mIrrep, nASh, nCMo,nCred, nDSO, nISh, nPSOP, nScr1, nScr2

end module EtWas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SIGVEC(CIN,HC,HD,BM,SXN,G,H,DIA,F1,F2,X,C,NTRIAL)
C
C RASSCF Program version IBM-3090: SX section
C
C Purpose: Calculation of the SIGMA vector HC for a super-CI
C Hamiltonian.
C called from HMAT
CPAM01 Added miniscule constant times CIN to HC.
C
C ********** IBM-3090 Release 88 09 01 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CIN(*),HC(*),BM(*),SXN(*),G(*),H(*),DIA(*),F1(*),F2(*),
     &          X(*),C(*)
      DIMENSION HD(*)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Character*16 ROUTINE
      Parameter (ROUTINE='SIGVEC  ')
C Local print level (if any)
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
      NST=0
      DO 300 ITRIAL=1,NTRIAL
       NNST=NROOT+NST
C
C renormalize the C vector
C
       DO 10 I=1,NSXS
        C(I)=SXN(I)*CIN(I+NNST)
10     CONTINUE

C Remove any unwanted rotations from C:
       DO I=1,NSXS
        IF(HD(I+NROOT).GT.1.0D20) C(I)=0.0D0
       END DO

C Initialize sigma vector to zero.
       CALL DCOPY_(NROOT+NSXS,[0.0D0],0,HC(NST+1),1)

       ISTIA=1
       ISTAE=1
       ISTBM=1
       ISTH=1
       ISTZ=0
       DO 100 ISYM=1,NSYM
        NIO=NISH(ISYM)
        NAO=NASH(ISYM)
        NEO=NSSH(ISYM)
        NIA=NIO+NAO
        NAE=NAO+NEO
        IF(NIA.EQ.0.OR.NAE.EQ.0) GO TO 98
C
C G-matrix contribution to HC (G*C)
C
        CALL DGEMM_('N','N',NIA,NAE,NIA,
     &              1.0D0,G(ISTIA),NIA,C(ISTBM+NST),NIA,
     &              1.0D0,HC(ISTBM+NNST),NIA)
C
C H-matrix contribution to HC (-C*H)
C
        IF(NAO.NE.0) CALL DGEMM_('N','N',NIA,NAO,NAE,
     &                           -1.0D0,C(ISTBM+NST),NIA,H(ISTH),NAE,
     &                           1.0D0,HC(ISTBM+NNST),NIA)
        IF(NAO*NEO.NE.0) CALL DGEMM_('N','T',NIA,NEO,NAO,
     &                         -1.0D0,C(ISTBM+NST),NIA,H(ISTH+NAO),NAE,
     &                          1.0D0,HC(ISTBM+NAO*NIA+NNST),NIA)
C
C First Fock matrix contribution D*C*FP
C
        CALL DGEMM_('N','N',
     &              NIA,NAE,NAE,
     &              1.0d0,C(ISTBM+NST),NIA,
     &              F2(ISTAE),NAE,
     &              0.0d0,X,NIA)
        CALL DGEMM_('N','N',NIA,NAE,NIA,
     &             1.0D0,DIA(ISTIA),NIA,X,NIA,
     &             1.0D0,HC(ISTBM+NNST),NIA)
C
C Second Fock matrix contribution FP*C*D
C
       IF(NAO.NE.0) THEN
         CALL DGEMM_('N','N',
     &               NIA,NAO,NIA,
     &               1.0d0,F1(ISTIA),NIA,
     &               C(ISTBM+NST),NIA,
     &               0.0d0,X,NIA)
         CALL DGEMM_('N','N',NIA,NAO,NAO,
     &              1.0D0,X,NIA,DIA(ISTIA+NIA*NIO+NIO),NIA,
     &              1.0D0,HC(ISTBM+NNST),NIA)
        ENDIF
C
98      ISTIA=ISTIA+NIA**2
        ISTAE=ISTAE+NAE**2
        ISTBM=ISTBM+NIA*NAE
        ISTH=ISTH+NAO*NAE
        ISTZ=ISTZ+(NAO**2-NAO)/2
100    CONTINUE
C
C Add diagonal contributions to the CI part
C
      IF(ICICP.NE.0) THEN
       DO 105 I=1,NROOT
       HC(NST+I)=HC(NST+I)+CIN(NST+I)*(ENER(I,ITER)-ENER(IROOT(1),ITER))
105    CONTINUE
      ENDIF
C
      If (NSXS.ne.0) Then
C
C BM contributions to CI part of sigma
C
*         CALL DGEMTX(NSXS,NROOT,1.0D0,BM,NSXS,C,1,HC(NST+1),1)
         CALL DGEMV_('T',NSXS,NROOT,1.0D0,BM,NSXS,C,1,1.0D0,HC(NST+1),1)
C
C BM contributions to SX part of sigma
C
         CALL DAXPY_(NSXS,CIN(NST+1),BM,1,HC(NNST+1),1)
C
      End If

C Remove any unwanted rotations:
       DO I=1,NSXS
        IF(HD(I+NROOT).GT.1.0D20) HC(I+NNST)=0.0D0
       END DO

C Adding a constant times C to the HC vectors at this point
C is equivalent to modifying the underlying minimization problem
C by adding a penalty for orbital rotations.
C This should be large enough that rotations get confined to values
C for which the Taylor expansion of rotations (which underlies the
C orbital optimization theory) is not too unrealistic.
C Example: if SXDAMP=0.0001, then a total rotation 'angle' of 0.1
C radians is penalized as an energy increase of 0.0001*(0.1)**2
C i.e., 10**(-6) a.u.
C Larger SXDAMP may make iterations sluggier.
C Too low SXDAMP may give erratic convergence in some exceptional
C cases.
C SXDAMP is set in READIN.
       CALL DAXPY_(NSXS,SXDAMP,C,1,HC(NNST+1),1)
C
C Renormalize the sigma vector
C
       DO 110 I=1,NSXS
        HC(I+NNST)=HC(I+NNST)*SXN(I)
110    CONTINUE
C
C Add Level shift part of the diagonal
C
      CALL DAXPY_(NSXS,SXSHFT,CIN(1+NNST),1,HC(1+NNST),1)
      NST=NST+NDIMSX
300   CONTINUE
C
C Test print out of the sigma vector
C
      IF(IPRLEV.GE.DEBUG) THEN
         Write(LF,1000) (HC(I),I=1,NDIMSX)
      END IF
1000  FORMAT(/1X,'Sigma vector in SIGVEC'/(1X,10F11.6))
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Felix Plasser                                    *
************************************************************************

      Subroutine wfa(ireturn)
      USE iso_c_binding
      Implicit None
#include "Molcas.fh"
#include "standard_iounits.fh"
#include "warnings.fh"

      Integer ireturn

#ifdef _WFA_
      Integer iLU, ist, ien
      Character*180 Get_Ln
      External Get_Ln
      Character Line*180
      Character Inp*900
#endif

      ireturn=_RC_NOT_AVAILABLE_

#ifdef _WFA_
!   Read the input file and parse as a string to libwfa
      ist = 1
      Call SpoolInp(iLU)
      Do While (Line(1:4).ne.'END ')
          Line=(Get_ln(iLU))

          ien = ist + len(trim(Line))
          Inp(ist:ien) = trim(Line)
          ist = ien + 1

          Call Normal(Line)
      End Do

      write(6,*) 'Starting wavefunction analysis ...'
      call wfa_driver(ireturn,Inp)
#else
      write(6,*) 'WFA module not installed!'
#endif

      End Subroutine wfa

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine expand40(a,b,dimpq,dimrs,dimp,dimr)
! expand a(pq,rs) -> b(p,q,r,s)
! assumption: p>q,r>s, + antisymmetry
! RISC version

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimpq, dimrs, dimp, dimr
real(kind=wp), intent(in) :: a(dimpq,dimrs)
real(kind=wp), intent(out) :: b(dimp,dimp,dimr,dimr)
integer(kind=iwp) :: p, pq, q, r, rs, s
real(kind=wp) :: scalar

if ((dimp > 1) .and. (dimr > 1)) then

  rs = 0
  do r=2,dimr
    do s=1,r-1
      rs = rs+1

      pq = 0
      do p=2,dimp
        do q=1,p-1
          pq = pq+1

          scalar = a(pq,rs)
          b(p,q,r,s) = scalar
          b(p,q,s,r) = -scalar
          b(q,p,r,s) = -scalar
          b(q,p,s,r) = scalar

        end do
      end do
    end do
  end do

end if

do r=1,dimr
  b(:,:,r,r) = Zero
end do

do p=1,dimp
  b(p,p,:,:) = Zero
end do

return

end subroutine expand40

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Sebastian Wouters                                *
!               2016, Quan Phung                                       *
!***********************************************************************
! Subroutine to load 2RDM
! Written by Quan Phung and Sebastian Wouters, Leuven, Aug 2016

subroutine chemps2_load2pdm(NAC,PT,CHEMROOT)

use mh5, only: mh5_open_file_r, mh5_open_group, mh5_fetch_dset, mh5_close_group, mh5_close_file
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NAC, CHEMROOT
real(kind=wp), intent(out) :: PT(NAC,NAC,NAC,NAC)
character(len=30) :: file_2rdm
character(len=10) :: rootindex
integer(kind=iwp) :: file_h5, group_h5, i, j, k, l, idx
logical(kind=iwp) :: irdm
real(kind=wp), allocatable :: two_rdm(:)

write(rootindex,'(i2)') chemroot-1
file_2rdm = 'molcas_2rdm.h5.r'//trim(adjustl(rootindex))
file_2rdm = trim(adjustl(file_2rdm))
call f_inquire(file_2rdm,irdm)
if (.not. irdm) then
  write(u6,'(1x,a15,i3,a16)') 'CHEMPS2> Root: ',CHEMROOT,' :: No 2RDM file'
  call abend()
end if

!#ifdef _MOLCAS_MPP_
!if (MPP() .and. KING()) then
!#endif

call mma_allocate(two_rdm,NAC**4,label='two_rdm')

file_h5 = mh5_open_file_r(file_2rdm)
group_h5 = mh5_open_group(file_h5,'2-RDM')
call mh5_fetch_dset(group_h5,'elements',two_rdm)
call mh5_close_group(group_h5)
call mh5_close_file(file_h5)
!#ifdef _MOLCAS_MPP_
!end if
!call MPI_Bcast(two_rdm,NAC**4,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,IERROR4)
!#endif

do i=1,NAC
  do j=1,NAC
    do k=1,NAC
      do l=1,NAC
        idx = i+NAC*(k-1+NAC*(j-1+NAC*(l-1)))
        PT(i,j,k,l) = two_rdm(idx)
      end do
    end do
  end do
end do

call mma_deallocate(two_rdm)

return

end subroutine chemps2_load2pdm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_AnaDia(Diag,Sync,Bin1,Step,NumBin,Full)
!
! Purpose: analyze global diagonal (histogram). Diag is the local
!          diagonal. If Sync=.True. the global diagonal is
!          synchronized before analysis.

use Cholesky, only: Cho_Real_Par, Diag_G
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*), Bin1, Step
logical(kind=iwp), intent(in) :: Sync, Full
integer(kind=iwp) :: NumBin
integer(kind=iwp) :: iLoc

if (Cho_Real_Par) then

  ! If requested, sync diagonal.
  ! ----------------------------

  if (Sync) then
    iLoc = 2
    call Cho_P_SyncDiag(Diag,iLoc)
  end if

  ! Swap local and global index arrays and use original serial
  ! serial to perform analysis of the global diagonal.
  ! ----------------------------------------------------------

  call Cho_P_IndxSwp()
  call Cho_AnaDia(Diag_G,Bin1,Step,NumBin,Full)
  call Cho_P_IndxSwp()

else

  call Cho_AnaDia(Diag,Bin1,Step,NumBin,Full)

end if

end subroutine Cho_P_AnaDia

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************

module NQ_Structure

use NQ_Info, only: LMax_NQ
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

type Info_Ang_t
  integer(kind=iwp) :: L_eff = 0
  integer(kind=iwp) :: nPoints = 0
  real(kind=wp), allocatable :: R(:,:)
end type Info_Ang_t

type NQ_data_t
  real(kind=wp), allocatable :: Coor(:)
  real(kind=wp) :: A_High = -huge(Zero)
  real(kind=wp) :: A_Low = huge(Zero)
  real(kind=wp) :: R_RS = Zero
  real(kind=wp) :: R_max = Zero
  integer(kind=iwp) :: l_max = -1
  real(kind=wp), allocatable :: R_Quad(:,:)
  integer(kind=iwp), allocatable :: Angular(:)
  integer(kind=iwp) :: Atom_Nr = -1
  real(kind=wp), allocatable :: dOdx(:,:,:)
end type NQ_data_t

type(Info_Ang_t) Info_Ang(LMax_NQ)
type(NQ_data_t), allocatable :: NQ_data(:)

public :: Close_Info_Ang, Close_NQ_Data, Info_Ang, NQ_data, Open_NQ_Data

! Private extensions to mma interfaces

interface cptr2loff
  module procedure nqd_cptr2loff
end interface
interface mma_allocate
  module procedure nqdata_mma_allo_1D, nqdata_mma_allo_1D_lim
end interface
interface mma_deallocate
  module procedure nqdata_mma_free_1D
end interface

contains

subroutine Open_NQ_Data(Coor)

  real(kind=wp), intent(in) :: Coor(:,:)
  integer(kind=iwp) :: iNQ, nNQ

  nNQ = size(Coor,2)
  call mma_allocate(NQ_data,nNQ,'NQ_data')
  do iNQ=1,nNQ
    call mma_allocate(NQ_data(iNQ)%Coor,3,Label='NQ_data(iNQ)%Coor')
    NQ_data(iNQ)%Coor(:) = Coor(1:3,iNQ)
  end do

# include "macros.fh"
  unused_proc(mma_allocate(NQ_data,[0,0]))

end subroutine Open_NQ_Data

subroutine Close_Info_Ang()

  integer(kind=iwp) :: iAngular

  do iAngular=1,size(Info_Ang)
    Info_Ang(iAngular)%L_eff = 0
    Info_Ang(iAngular)%nPoints = 0
    if (allocated(Info_Ang(iAngular)%R)) call mma_deallocate(Info_Ang(iAngular)%R)
  end do

end subroutine Close_Info_Ang

subroutine Close_NQ_Data()

  integer(kind=iwp) :: iNQ

  ! Cleanup and close
  do iNQ=1,size(NQ_data)
    call mma_deallocate(NQ_data(iNQ)%Coor)
    if (allocated(NQ_data(iNQ)%R_Quad)) call mma_deallocate(NQ_data(iNQ)%R_Quad)
    if (allocated(NQ_data(iNQ)%Angular)) call mma_deallocate(NQ_data(iNQ)%Angular)
    if (allocated(NQ_data(iNQ)%dOdx)) call mma_deallocate(NQ_data(iNQ)%dOdx)
  end do
  call mma_deallocate(NQ_Data)

end subroutine Close_NQ_Data

! Private extensions to mma_interfaces, using preprocessor templates
! (see src/mma_util/stdalloc.f)

! Define nqd_cptr2loff, nqdata_mma_allo_1D, nqdata_mma_allo_1D_lim, nqdata_mma_free_1D
! (using _NO_GARBLE_ because all members are initialized)
#define _TYPE_ type(NQ_data_t)
#  define _NO_GARBLE_
#  define _FUNC_NAME_ nqd_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ nqdata_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'nqd_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#  undef _NO_GARBLE_
#undef _TYPE_

end module NQ_Structure

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Lucia_Close()

use lucia_data, only: LUC, LUDIA, LUHC, LUMOUT, LUSC1, LUSC2, LUSC3, LUSC34, LUSC35, LUSC36, LUSC37, LUSC38, LUSC39, LUSC40

implicit none

! Free memory allocated by Lucia

call FREESTR_GAS()
call DeAlloc_Lucia()

! Close any files opened by Lucia

call DAClos(LUDIA)
call DAClos(LUC)
call DAClos(LUHC)
call DAClos(LUSC1)
call DAClos(LUSC2)
call DAClos(LUSC3)
call DAClos(LUSC34)
call DAClos(LUSC35)
call DAClos(LUSC36)
call DAClos(LUSC37)
call DAClos(LUSC38)
call DAClos(LUSC39)
call DAClos(LUSC40)
call DAClos(LUMOUT)

end subroutine Lucia_Close

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_PMAT(P,X)
C
C     RASSCF version IBM-3090: SX section
C
c     Purpose: To construct from a canonically ordered list of
c              2-matrix elements a list ordered as the transformed
c              two-electron integrals. P is the input matrix and X is
c              the output matrix. the matrix is multiplied by two and
c              used to construct the Q-matrix in fock.
c
c      Used in order to obtain the right factor for the 2-body
c           density to be used in Cholesky (algo=2)
C
C          ********** IBM-3090 MOLCAS Release: 90 02 22 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
      DIMENSION X(*),P(*)
      COMMON /CHOPMAT / ipPL

C
c     Loop over all reordered 2-matrix elements.
C
      LPMAT=ISTORP(NSYM+1)
      CALL FZERO(X,LPMAT)
C
      IAT=0
      DO 14 NSP=1,NSYM
       NAP=NASH(NSP)
       IF(NAP.EQ.0) GO TO 14
       INDF=ISTORP(NSP)
       NUVX=(ISTORP(NSP+1)-INDF)/NAP
       LROW=0
       IAU=0
       DO 13 NSQ=1,NSYM
        NAQ=NASH(NSQ)
        IF(NAQ.EQ.0) GO TO 13
        NSPQ=IEOR(NSP-1,NSQ-1)
        IAV=0
        DO 12 NSR=1,NSYM
         NAR=NASH(NSR)
         IF(NAR.EQ.0) GO TO 12
         NSS=IEOR(NSPQ,NSR-1)+1
         IF(NSS.GT.NSR) GO TO 121
         NAS=NASH(NSS)
         IF(NAS.EQ.0) GO TO 121
         IAX=0
         IF(NSS.NE.1) THEN
          NSSM=NSS-1
          DO 7 NSS1=1,NSSM
          IAX=IAX+NASH(NSS1)
7         CONTINUE
         ENDIF
         DO 11 NAV=1,NAR
          LAV=NAV+IAV
          NAXE=NAS
          IF(NSR.EQ.NSS) NAXE=NAV
          DO 10 NAX=1,NAXE
           LAX=NAX+IAX
           DO 9 NAU=1,NAQ
            LAU=NAU+IAU
            LROW=LROW+1
            INDX=INDF+LROW-NUVX
            DO 8 NAT=1,NAP
             INDX=INDX+NUVX
             LAT=NAT+IAT
C
c            Compute canonical index ntuvx and find prefactor
C
             LAT1=MAX(LAT,LAU)
             LAU1=MIN(LAT,LAU)
             NTU=ITRI(LAT1)+LAU1
             NVX=ITRI(LAV)+LAX
             NTUVX=ITRI(MAX(NTU,NVX))+MIN(NTU,NVX)
             FAC=2.0D0
             IF(NTU.LT.NVX) THEN
              IF(LAT1.EQ.LAU1.AND.LAV.NE.LAX) FAC=4.0D0
              IF(LAT1.NE.LAU1.AND.LAV.EQ.LAX) FAC=1.0D0
             ENDIF
             X(INDX)=FAC*P(NTUVX)
             Work(ipPL+ntuvx-1) = 0.5d0*X(INDX)
8           CONTINUE
9          CONTINUE
10        CONTINUE
11       CONTINUE
121      IAV=IAV+NAR
12      CONTINUE
        IAU=IAU+NAQ
13     CONTINUE
       IAT=IAT+NAP
14    CONTINUE
C
      IF(IPR.GE.20) Write(IW,1000) (X(I),I=1,LPMAT)
1000  FORMAT(/1X,'Reordered 2-matrix'/(10F10.6))
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DGETMI(A,ldA,N)
! TRANSPOSE A SQUARE MATRIX (IN-PLACE)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ldA, N
real(kind=wp), intent(inout) :: A(ldA,N)
integer(kind=iwp) :: i, j
real(kind=wp) :: Temp

if (N <= 0) then
  write(u6,*)
  write(u6,*) '  *** Error in subroutine DGETMI ***'
  write(u6,*) '  Invalid dimension of matrix A :'
  write(u6,*) '  The number of rows/columns, N, must be greater than zero'
  write(u6,*)
end if
if (ldA < N) then
  write(u6,*)
  write(u6,*) '  *** Error in subroutine DGETMI ***'
  write(u6,*) '  Invalid leading dimension of matrix A :'
  write(u6,*) '  ldA must be equal to N or greater'
  write(u6,*)
end if

do i=1,N
  do j=1,i-1
    Temp = A(j,i)
    A(j,i) = A(i,j)
    A(i,j) = Temp
  end do
end do

return

end subroutine DGETMI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine UpOrb(n,o,w,Orb,Lab)
      Implicit Real*8 (a-h,o-z)
      Dimension Orb(n)
#include "parm.fh"
#include "common.fh"
      Character*(LENIN8) Lab(n)
      dimension indx((MxLqn+1)*(MxLqn+1))
      dimension jndx((MxLqn+1)*(MxLqn+1))
#include "symlab.fh"
      Do 100 i=1,(MxLqn+1)*(MxLqn+1)
         indx(i)=0
         jndx(i)=0
100   Continue
      Do 200 iBas=1,n
*        Write(*,'(a,i5)') '     iBas:',iBas
         If(Lab(iBas)(1:LENIN).eq.Center) Then
            iBlk=0
            Do 210 i=1,(MxLqn+1)*(MxLqn+1)
               If(type(i).eq.Lab(iBas)(LENIN1:LENIN8)) iBlk=i
210         Continue
*           Write(*,'(a,i5)') '       iBlk:',iBlk
            If(iBlk.eq.0) Then
               Write(6,*) 'Unknown basis function: ',
     &                    Lab(iBas)(LENIN1:LENIN8)
               Call Quit_OnUserError()
            End If
            indx(iBlk)=indx(iBlk)+1
*           Write(*,'(a,i5)') '     indx:',indx(iBlk)
            jndx(iBlk)=0
            Do 220 jBas=1,iBas
*              Write(*,'(a,i5)') '       jBas:',jBas
               If(Lab(jBas)(1:LENIN).eq.Center) Then
                  If(Lab(iBas)(LENIN1:LENIN8).eq.
     &               Lab(jBas)(LENIN1:LENIN8)) Then
                     jndx(iBlk)=jndx(iBlk)+1
*                    Write(*,'(a,i5)') '     jndx:',jndx(iBlk)
                     ind=jndx(iBlk)
     &                  +indx(iBlk)*(indx(iBlk)-1)/2
     &                  +iSymBk(iBlk)-1
*                    add=w*o*Cmo(iBas)*Cmo(jBas)
                     add=w*o*Orb(iBas)*Orb(jBas)
                     pDsym(ind)=pDsym(ind)+add
*                    Write(*,'(a,f12.6,a,i5)') 'add',add,' to',ind
                  End If
               End If
220         Continue
         End If
200   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OrdExp1(nExp,rExp,nCntrc,Cff)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nExp, nCntrc
real(kind=wp), intent(inout) :: rExp(nExp), Cff(nExp,nCntrc)
integer(kind=iwp) :: iBottom, iCntrc, iExp, jExp, kExp, mExp
real(kind=wp) :: Exp1, Exp2

! Order exponents
! Make the subsequent change in the contraction matrix

do iExp=1,nExp-1
  Exp1 = rExp(iExp)
  kExp = iExp
  do jExp=iExp+1,nExp
    Exp2 = rExp(jExp)
    if (Exp2 > Exp1) then
      Exp1 = Exp2
      kExp = jExp
    end if
  end do
  if (kExp /= iExp) then
    call DSwap_(1,rExp(iExp),1,rExp(kExp),1)
    call DSwap_(nCntrc,Cff(iExp,1),nExp,Cff(kExp,1),nExp)
  end if
end do

! Move any exponent which are already decontracted to the bottom

iBottom = nExp
do iCntrc=nCntrc,1,-1
  mExp = 0
  jExp = -1
  do iExp=1,nExp
    if (Cff(iExp,iCntrc) /= Zero) then
      jExp = iExp
      mExp = mExp+1
    end if
  end do
  if (mExp == 1) then
    call DSwap_(1,rExp(jExp),1,rExp(iBottom),1)
    call DSwap_(nCntrc,Cff(jExp,1),nExp,Cff(iBottom,1),nExp)
    iBottom = iBottom-1
  end if
end do

return

end subroutine OrdExp1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE PT2_PUT(NSIZE,LAB,VEC)
      use definitions, only: iwp, wp, u6
      use caspt2_global, only: LUDMAT
      use pt2_guga, only: IADR10, cLab10
      IMPLICIT None
      integer(kind=iwp), intent(in):: NSIZE
      CHARACTER(len=*), intent(in):: LAB
      real(kind=wp):: VEC(*)

      CHARACTER(len=8) LAB1
      integer(kind=iwp) I, IAD

      I=9-LEN(LAB)
      IF(I>=1) THEN
        LAB1='        '
        LAB1(I:8)=LAB
      ELSE
        LAB1=LAB(1:8)
      END IF

C FIND DISK ADDRESS:
      DO I=1,64
        IF(CLAB10(I)=='   EMPTY') THEN
          CLAB10(I)=LAB1
          IAD=IADR10(I,1)
          IADR10(I,2)=NSIZE
          CALL DDAFILE(LUDMAT,1,VEC,NSIZE,IAD)
          IF(I<64) IADR10(I+1,1)=IAD
          RETURN
        ELSE IF (CLAB10(I)==LAB1) THEN
          IF(NSIZE.GT.IADR10(I,2)) THEN
             WRITE(u6,*)' ATTEMPT TO INCREASE SIZE OF A FIELD.'
             WRITE(u6,*)' SUBROUTINE PUT FAILS.'
             CALL ABEND()
          End If
          IAD=IADR10(I,1)
          IADR10(I,2)=NSIZE
          CALL DDAFILE(LUDMAT,1,VEC,NSIZE,IAD)
          RETURN
        END IF
      END DO

      WRITE(u6,*)' NO MORE AVAILABLE FIELDS ON FILE DENS.'
      WRITE(u6,*)' SUBROUTINE PUT FAILS.'
      CALL ABEND()


      END SUBROUTINE PT2_PUT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagFinal(nOLag,nTrf,OLagLoc,Trf)

use Index_Functions, only: nTri_Elem
use caspt2_global, only: CMOPT2, OLagFull, WLag
use caspt2_module, only: IFMSCOUP, iRlxRoot, JSTATE, NBAS, NBAST, NBSQT, NBTRI, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nOLag, nTrf
real(kind=wp), intent(inout) :: OLagLoc(nOLag)
real(kind=wp), intent(in) :: Trf(nTrf)
integer(kind=iwp) :: iBasI, iBasSq, iBasTr, iSym, jBasI, liBasSq, liBasSq2, liBasTr, nBasI
real(kind=wp), allocatable :: WLagLoc(:), WRK(:)

call mma_allocate(WRK,NBSQT,Label='WRK')
call mma_allocate(WLagLoc,NBSQT,Label='WLagLoc')

if (NBSQT /= nOLag) then
  write(u6,*) 'NBSQT /= nOLag in OLagFinal'
  call abend()
end if

WLagLoc(1:NBSQT) = Half*OLagLoc(1:nOLag)
!write(u6,*) 'Wlag square'
!call sqprt(wlag,nbast)

!! W(MO) -> W(AO) using the quasi-canonical orbitals
!! No need to back transform to natural orbital basis
call DGemm_('N','N',nBasT,nBasT,nBasT,One,CMOPT2,nBasT,WLagLoc,nBasT,Zero,WRK,nBasT)
call DGemm_('N','T',nBasT,nBasT,nBasT,One,WRK,nBasT,CMOPT2,nBasT,Zero,WLagLoc,nBasT)

!! square -> triangle for WLag(AO)
WRK(:) = WLagLoc(:)
iBasTr = 1
iBasSq = 1
do iSym=1,nSym
  nBasI = nBas(iSym)
  liBasTr = iBasTr
  liBasSq = iBasSq
  do iBasI=1,nBasI
    do jBasI=1,iBasI
      liBasSq = iBasSq+iBasI-1+nBasI*(jBasI-1)
      if (iBasI == jBasI) then
        WLagLoc(liBasTr) = WRK(liBasSq)
      else
        liBasSq2 = iBasSq+jBasI-1+nBasI*(iBasI-1)
        WLagLoc(liBasTr) = WRK(liBasSq)+WRK(liBasSq2)
      end if
      liBasTr = liBasTr+1
    end do
  end do
  iBasTr = iBasTr+nTri_Elem(nBasI)
  iBasSq = iBasSq+nBasI*nBasI
end do
! accumulate W Lagrangian only for MS,XMS,XDW,RMS,
! but not for SS-CASPT2
if ((jState == iRlxRoot) .or. IFMSCOUP) WLag(1:NBTRI) = WLag(1:NBTRI)+WLagLoc(1:NBTRI)
call mma_deallocate(WLagLoc)

!! Transform quasi-canonical -> natural MO basis
!! orbital Lagrangian
call DGemm_('N','N',nBasT,nBasT,nBasT,One,Trf,nBasT,OLagLoc,nBasT,Zero,WRK,nBasT)
call DGemm_('N','T',nBasT,nBasT,nBasT,One,WRK,nBasT,Trf,nBasT,Zero,OLagLoc,nBasT)
!! sufficient only for active
nBasI = nBas(1)
WRK(1:nBasI**2) = OLagLoc(1:nBasI**2)
call DGeSub(WRK,nBas(1),'N',WRK,nBas(1),'T',OLagLoc,nBas(1),nBas(1),nBas(1))
! accumulate orbital Lagrangian only for MS,XMS,XDW,RMS,
! but not for SS-CASPT2
if ((jState == iRlxRoot) .or. IFMSCOUP) OLagFull(1:nOLag) = OLagFull(1:nOLag)+OLagLoc(1:nOLag)

call mma_deallocate(WRK)

end subroutine OLagFinal

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine exth3 (a,b,dimp,dimq,dimr,q,nfact)
c
c     this routine extract A(p,q,r) -> B_q(p,r)
c
c     a     - matrxi a (Input)
c     b     - matrix b (Output)
c     dimp  - dimension of p (Input)
c     dimq  - dimension of q (Input)
c     dimr  - dimension of r (Input)
c     q     - value of index q (Input)
c     nfact - sign (+-1,0) (Input)
c
       integer dimp,dimq,dimr,q,nfact
       real*8 a(1:dimp,1:dimq,1:dimr)
       real*8 b(1:dimp,1:dimr)
c
c     help variables
c
       integer p,r
c
       if (nfact.eq.1) then
       do 10 r=1,dimr
       do 11 p=1,dimp
       b(p,r)=a(p,q,r)
 11     continue
 10     continue
       else if (nfact.eq.-1) then
       do 20 r=1,dimr
       do 21 p=1,dimp
       b(p,r)=-a(p,q,r)
 21     continue
 20     continue
       else if (nfact.eq.0) then
       do 30 r=1,dimr
       do 31 p=1,dimp
       b(p,r)=0.0d0
 31     continue
 30     continue
       end if

c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subRoutine INTX(FockI,Temp1,Temp2,Temp3,Temp4,Fock,
     &                rMo,loper,idisp,r)
*
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
#include "disp_mclr.fh"
#include "WrkSpc.fh"
*
      Character*8 Label
      Real*8 FockI(nDens2),Temp2(ndens2),Temp3(nDens2),Temp4(ndens2),
     &       Temp1(nDens2),Fock(nDens2),rMO(*)
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
************************************************************************
      If (nDens2.eq.0) Return
      jDisp=DspVec(idisp)
*
*           x
*     Read P
*
*     Remember Two electron contributions is saved in MO base
*     but one electron contributions is saved in AO base.
*
*
*
      If (iAnd(ntpert(idisp),2**2).eq.4) Then   ! 2 el contribution
       If (iAnd(ntpert(idisp),2**4).eq.2**4) Then  ! from mckinley
       If (iMethod.eq.2) Then
*
*-------------------------------------------------------------------*
*
*     RASSCF
*
*-------------------------------------------------------------------*
*
        Label='TOTAL'
        iop=2**loper
        irc=-1
        iopt=0
        Call dRdMck(iRC,iOpt,Label,jDisp,Fock,iop)
        If (iRc.ne.0) Then
           Write (6,*) 'IntX: Error reading MCKINT'
           Write (6,'(A,A)') 'Label=',Label
           Call Abend()
        End If
        Call ReLoad(Fock,loper+1,nbas,norb)
*
        Label='INACTIVE'
        iop=2**loper
        irc=-1
        iopt=0
        Call dRdMck(iRC,iOpt,Label,jDisp,Focki,iop)
        If (iRc.ne.0) Then
           Write (6,*) 'IntX: Error reading MCKINT'
           Write (6,'(A,A)') 'Label=',Label
           Call Abend()
        End If
        Call ReLoad(Focki,loper+1,nbas,norb)
*
        Label='MOPERT'
        iop=2**loper
        iopt=0
        irc=-1
        Call dRdMck(iRC,iOpt,Label,jDisp,rMO,iop)
        If (iRc.ne.0) Then
           Write (6,*) 'IntX: Error reading MCKINT'
           Write (6,'(A,A)') 'Label=',Label
           Call Abend()
        End If
       Else
*
*-------------------------------------------------------------------*
*
*     SCF
*
*-------------------------------------------------------------------*
*
       Label='TOTAL'
       iop=2**loper
       irc=-1
       iopt=0
       Call dRdMck(iRC,iOpt,Label,jDisp,Focki,iop)
       If (iRc.ne.0) Then
          Write (6,*) 'IntX: Error reading MCKINT'
          Write (6,'(A,A)') 'Label=',Label
          Call Abend()
       End If
       call dcopy_(ndens2,[0.0d0],0,fock,1)
       Do iS=1,nSym
        js=iEOR(is-1,loper)+1
        Call Dyax(nOrb(is)*nIsh(js),2.0d0,
     &     Focki(ipMat(is,js)),1,Fock(ipMat(is,js)),1)
       End Do
       End If
       End If
       End If
*
*-------------------------------------------------------------------*
*
* Two electron fock matrix done!
* Lets fix  the one electron matrixes
*
*-------------------------------------------------------------------*
*
      If (iAnd(nTPert(iDisp),2**1).eq.2) Then ! 1 el contribution
      iop=2**loper
      If (iAnd(ntpert(idisp),2**4).eq.2**4) Then  ! from mckinley
       Label='ONEGRD'
       iopt=0
       irc=-1
       Call dRdMck(iRC,iOpt,Label,jDisp,Temp1,iop)
       If (iRc.ne.0) Then
          Write (6,*) 'IntX: Error reading MCKINT'
          Write (6,'(A,A)') 'Label=',Label
          Call Abend()
       End If
      Else                                         ! or seward
       Label=SwLbl(idisp)
       iopt=0
       irc=-1
       Call RdOne(irc,iopt,Label,jDisp,temp1,iop)
       If (iRc.ne.0) Then
          Write (6,*) 'IntX: Error reading MCKINT'
          Write (6,'(A,A)') 'Label=',Label
          Call Abend()
       End If
       Call DSCAL_(ndens2,1.0d0,Temp1,1)
      End If
      End If
*
      call dcopy_(nDens,[0.0d0],0,Temp2,1)
      ip=1
      Do iS=1,nSym
       Do jS=1,is
        If (nBas(is)*nBas(js).ne.0) Then
        If (iEOr(iS-1,jS-1).eq.loper) Then
           If (is.eq.js) Then
             Call Square(Temp1(ipMatLt(iS,jS)),
     &                   Temp4,
     &                   1,nBas(is),nBas(is))
           Else
             call dcopy_(nBas(iS)*nBas(jS),
     &                  temp1(ipMatLT(iS,Js)),1,
     &                  Temp4,1)
           End If
           Call DGEMM_('T','N',
     &                 nOrb(iS),nBas(jS),nBAs(iS),
     &                 1.0d0,Work(ipCMO+ipCM(iS)-1),nBas(is),
     &                 Temp4,nBas(iS),
     &                 0.0d0,Temp3,nOrb(iS))
           Call DGEMM_('N','N',
     &                 nOrb(is),nB(jS),nBas(jS),
     &                 1.0d0,Temp3,nOrb(iS),
     &                 Work(ipCMO+ipCM(jS)-1),nBas(jS),
     &                 0.0d0,Temp2(ipMat(iS,jS)),nOrb(iS))
           If (is.ne.js) Then
           Call DGEMM_('T','T',
     &                 nOrb(jS),nOrb(iS),nBAs(jS),
     &                 1.0d0,Work(ipCMO+ipCM(jS)-1),nBas(js),
     &                 Temp4,nBas(iS),
     &                 0.0d0,Temp3,nOrb(jS))
           Call DGEMM_('N','N',
     &                 nOrb(js),nB(iS),nBas(iS),
     &                 1.0d0,Temp3,nOrb(jS),
     &                 Work(ipCMO+ipCM(iS)-1),nBas(iS),
     &                 0.0d0,Temp2(ipMat(jS,iS)),nOrb(jS))
          End If

        End If
        End If
       End Do
      End Do

*
       call dcopy_(ndens2,[0.0d0],0,Temp3,1)
       Do iS=1,nSym
        js=iEOR(is-1,loper)+1
        Do j=1,nAsh(is)+nish(is)
         Do i=1,nAsh(is)+nIsh(is)
          If (i.eq.j.and.i.le.nish(is).and.j.le.nish(is))
     &    Then
           rde=2.0d0
          Else If  (i.gt.nish(is).and.j.gt.nish(is)) Then
           rde=Work(ipG1-1+itri(i-nish(is)+nA(is),
     &           j-nIsh(is)+nA(is)))
          Else
           rde=0.0d0
          end if
          If (rde.ne.0.0d0)
     &    Call DaXpY_(nOrb(js),rDe,
     &               Temp2(ipMat(js,is)+(j-1)*nOrb(js)),1,
     &               Temp3(ipMat(js,is)+(i-1)*nOrb(js)),1)
         End Do
        End Do
       End Do
************************************************************************
*
*
*-------------------------------------------------------------------*
*
* One electron fock matrix done!
*
*-------------------------------------------------------------------*
*
      If (iAnd(ntpert(idisp),2**2).eq.4) Then
        call daxpy_(nDens2,1.0d0,Temp2,1,Focki,1)
        call daxpy_(nDens2,1.0d0,Temp3,1,Fock,1)
      Else
        call dcopy_(ndens2,Temp2,1,FockI,1)
        call dcopy_(ndens2,Temp3,1,Fock,1)
      End If

*
*
      return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(r)
      End
      Subroutine ReLoad(A,idsym,NBAS1,NBAS2)
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
      Real*8 A(*)
      Integer nbas2(nsym),nbas1(nsym)
      Call GetMem('A','ALLO','REAL',ipA,ndens2)
      Do iS=1,nsym
       js=ieor(is-1,idsym-1) +1
       Do j=0,Min(nbas2(js),nbas1(js))-1
        call dcopy_(Min(nbas1(is),nbas2(is)),
     &             A(ipMat(is,js)+j*nbas1(is)),1,
     &             Work(ipA-1+ipmat(is,js)+j*nbas2(is)),1)
       End Do
      End Do
      call dcopy_(ndens2,Work(ipA),1,A,1)
      Call GetMem('A','FREE','REAL',ipA,ndens2)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Per-Olof Widmark                                 *
!               1993, Markus P. Fuelscher                              *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine WrMCK(rc,Option,InLab,iComp,iData,iSymLab)
!***********************************************************************
!                                                                      *
!     Purpose: write data to one-electron integral file                *
!                                                                      *
!     Calling parameters:                                              *
!     rc      : Return code                                            *
!     Option  : Switch to set options                                  *
!     InLab   : Identifier for the data to write                       *
!     Comp    : Composite identifier to select components              *
!     iData   : contains on input the data to store on disk            *
!     SymLab  : symmetry label of the provided data                    *
!                                                                      *
!     Local data declarations:                                         *
!     Label   : character(len=8), used to covert incoming names        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark and M.P. Fuelscher                                  *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!     Modified by:                                                     *
!     Anders Bernhardsson                                              *
!     University of Lund, Sweden, 1995                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use MckDat, only: AuxMck, LenOp, lTocMck, MxOp, NaN, NotNaN, nTitle, oAddr, oComp, oLabel, oSymLb, pASh, pBas, pchdisp, pdegdisp, &
                  pEnd, pFID, pish, pldisp, pndisp, pNext, pnrdisp, pOp, pPert, pSym, pSymOp, ptdisp, pTitle, pVersN, rcMck, sDbg, &
                  sLength, TocMck
use Molcas, only: MxSym
use Definitions, only: iwp, u6, RtoI, ItoB

#include "intent.fh"

implicit none
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp), intent(in) :: Option, iComp, iSymLab
character(len=*), intent(in) :: InLab
integer(kind=iwp), intent(_IN_) :: iData(*)
integer(kind=iwp) :: Comp, i, iBas, icpi, iDisk, ij, ijS, iS, iSym, j, jBas, jS, k, Len_, Length, LuMCK, nA, SymLab, &
                     LabTmp(2)
logical(kind=iwp) :: Debug
!character(len=11) :: Label_Add
character(len=8) :: Label
character(len=*), parameter :: TheName = 'WrMck'
!real(kind=wp), external :: Check, DDot_

!----------------------------------------------------------------------*
! Start procedure:                                                     *
! Pick up the file definitions                                         *
!----------------------------------------------------------------------*
SymLab = iSymLab
icpi = ItoB
Comp = iComp
Len_ = rc
rc = rcMck%good
LuMCK = AuxMck%Lu
!----------------------------------------------------------------------*
! Check the file status                                                *
!----------------------------------------------------------------------*
if (.not. AuxMck%Opn) call SysFileMsg(TheName,'MSG: open',LuMck,' ')
!----------------------------------------------------------------------*
! Truncate the label to 8 characters and convert it to upper case      *
!----------------------------------------------------------------------*
!call StdFmt(InLab,Label)
Label = InLab
call UpCase(Label)
Length = len(Label)/ItoB
LabTmp(:Length) = transfer(Label,LabTmp,Length)
!----------------------------------------------------------------------*
! Print debugging information                                          *
!----------------------------------------------------------------------*
Debug = btest(option,sDbg)
if (Debug) then
  write(u6,*) '<<< Entering WrMck >>>'
  write(u6,'(a,z8)') ' rc on entry:     ',rc
  write(u6,'(a,a)') ' Label on entry:  ',Label
  write(u6,'(a,z8)') ' Comp on entry:   ',Comp
  write(u6,'(a,z8)') ' SymLab on entry: ',SymLab
  write(u6,'(a,z8)') ' Option on entry: ',Option
  write(u6,*) ' Contents of the Toc'
  write(u6,*) ' ==================='
  write(u6,'(i6,z8)') 'pFID,TocMck(pFID)=',pFID,TocMck(pFID)
  write(u6,'(i6,z8)') pVersN,TocMck(pVersN)
  write(u6,'(i6,z8)') pTitle,TocMck(pTitle)
  write(u6,'(i6,z8)') pOp,TocMck(pOp)
  write(u6,'(i6,z8)') pSym,TocMck(pSym)
  write(u6,'(i6,z8)') pSymOp,TocMck(pSymOp)
  write(u6,'(i6,z8)') pBas,TocMck(pBas)
  write(u6,'(i6,z8)') pNext,TocMck(pNext)
  write(u6,'(i6,z8)') pEnd,TocMck(pEnd)
end if
!----------------------------------------------------------------------*
! Store data in TocMck                                                 *
!----------------------------------------------------------------------*

if (Label == 'TITLE') then

  TocMck(pTitle) = NotNaN
  TocMck(pTitle+1:pTitle+nTitle) = iData(1:nTitle)
  !--------------------------------------------------------------------*

else if (Label == 'NSYM') then

  if ((iData(1) > MxSym) .or. (iData(1) < 1)) then
    call SysWarnMsg(TheName,'Label=',Label)
    call SysValueMsg('iData(1)=',iData(1))
  end if
  TocMck(pSym) = iData(1)
  !--------------------------------------------------------------------*

else if (Label == 'NBAS') then

  if (TocMck(pSym) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pSym)
  TocMck(pbas:pbas+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else if (label == 'NISH') then

  if (TocMck(pSym) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pSym)
  TocMck(pISH:pISH+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else if (label == 'NASH') then

  if (TocMck(pSym) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pSym)
  TocMck(pASH:pASH+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else if (label == 'LDISP') then

  if (TocMck(pSym) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pSym)
  TocMck(pldisp:pldisp+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else if (label == 'TDISP') then

  if (TocMck(pndisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pndisp)
  TocMck(ptdisp:ptdisp+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else if (label == 'NDISP') then

  TocMck(pnDisp) = iData(1)
  !--------------------------------------------------------------------*

else if (label == 'CHDISP') then

  if (TocMck(pndisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pndisp)*30/icpi+1
  TocMck(pchdisp:pchdisp+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else if (label == 'NRCTDISP') then

  if (TocMck(pndisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pndisp)
  TocMck(pnrdisp:pnrdisp+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else if (label == 'DEGDISP ') then

  if (TocMck(pndisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = TocMck(pndisp)
  TocMck(pdegdisp:pdegdisp+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else if (Label == 'SYMOP') then

  if (TocMck(pSym) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
  Length = (3*TocMck(pSym)+ItoB-1)/ItoB
  TocMck(pSymOp:pSymOp+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else if (label == 'PERT') then

  Length = 16/icpi
  TocMck(pPert:pPert+Length-1) = iData(1:Length)
  !--------------------------------------------------------------------*

else
  !--------------------------------------------------------------------*
  ! Store operators as individual records on disk                      *
  ! Note: If the incoming operator has already been stored             *
  ! previously (label, component and symmetry labels are identical)    *
  ! it will replace the existing one.                                  *
  !--------------------------------------------------------------------*
  if ((label == 'STATHESS') .or. (label == 'RESPHESS') .or. (label == 'CONNHESS') .or. (label == 'HESS') .or. (label == 'NUCGRAD') &
      .or. (label == 'TWOGRAD')) then
    Comp = 1
    SymLab = 1
  end if

  if (TocMck(pBas) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)

  k = 0
  do i=MxOp,1,-1
#   ifdef _I8_
    if ((TocMck(pOp+LenOp*(i-1)+oLabel) == LabTmp(1)) .and. (TocMck(pOp+LenOp*(i-1)+oComp) == Comp)) k = i
    !   .and. (TocMck(pOp+LenOp*(i-1)+oSymLb) == SymLab)) k = i
#   else
    if ((TocMck(pOp+LenOp*(i-1)+oLabel) == LabTmp(1)) .and. (TocMck(pOp+LenOp*(i-1)+oLabel+1) == LabTmp(2)) .and. &
        (TocMck(pOp+LenOp*(i-1)+oComp) == Comp)) k = i
    !   .and. (TocMck(pOp+LenOp*(i-1)+oSymLb) == SymLab)) k = i
#   endif
  end do

  iDisk = TocMck(pOp+LenOp*(k-1)+oAddr)
  if (k == 0) then
    do i=MxOp,1,-1
      if (TocMck(pOp+LenOp*(i-1)+oLabel) == NaN) k = i
    end do
    iDisk = TocMck(pNext)
    if (Debug) then
      write(u6,*) ' This is a new field!'
      write(u6,*) ' iDisk=',iDisk
      write(u6,*) ' FldNo=',k
      write(u6,*) ' pNext=',pNext
    end if
  else
    if (Debug) then
      write(u6,*) ' This is an old field!'
      write(u6,*) ' iDisk=',iDisk
      write(u6,*) ' FldNo=',k
      write(u6,*) ' pNext=',pNext
    end if
  end if
  if (k == 0) call SysAbendMsg(TheName,'Undefined Label:',Label)
  !write(u6,*) isymlab,label
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (Label == 'MOPERT') then

    nA = 0
    do i=0,TocMck(psym)-1
      nA = TocMck(pAsh+i)+nA
    end do
    Length = nTri_Elem(nA)
    Length = nTri_Elem(Length)
    !write(u6,*) Length
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else if (label == 'NUCGRAD') then
    Comp = 1
    SymLab = 1
    if (TocMck(pldisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
    Length = TocMck(pldisp)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else if (label == 'TWOGRAD') then
    Comp = 1
    SymLab = 1
    if (TocMck(pldisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
    Length = TocMck(pldisp)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else if ((label == 'STATHESS') .or. (label == 'RESPHESS') .or. (label == 'CONNHESS') .or. (label == 'HESS')) then
    Comp = 1
    SymLab = 1
    if (TocMck(pndisp) == NaN) call SysAbendMsg(TheName,'Undefined Label:',Label)
    Length = 0
    do iSym=0,TocMck(pSym)-1
      Length = Length+nTri_Elem(TocMck(pldisp+isym))
    end do
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else if (label == 'INACTIVE') then
    Length = 0
    do iS=1,TocMck(pSym)
      do jS=1,TocMck(pSym)
        ijS = Mul(iS,jS)-1
        if (btest(iSymLab,ijS)) then
          jBas = TocMck(pbas+jS-1)
          iBas = TocMck(pbas+iS-1)
          if (jBas == NaN) call SysAbendMsg(TheName,'jBas == NaN at label',Label)
          if (iBas == NaN) call SysAbendMsg(TheName,'iBas == NaN at label',Label)
          Length = Length+iBas*jBas
        end if
      end do
    end do
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else if (label == 'TOTAL') then
    Length = 0
    do iS=1,TocMck(pSym)
      do jS=1,TocMck(pSym)
        ijS = Mul(iS,jS)-1
        if (btest(iSymLab,ijS)) then
          jBas = TocMck(pbas+jS-1)
          iBas = TocMck(pbas+iS-1)
          if (jBas == NaN) call SysAbendMsg(TheName,'jBas == NaN at label',Label)
          if (iBas == NaN) call SysAbendMsg(TheName,'iBas == NaN at label',Label)
          Length = Length+iBas*jBas
        end if
      end do
    end do
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else
    Length = 0
    do i=1,TocMck(pSym)
      do j=1,i
        ij = Mul(i,j)-1
        if (btest(iSymLab,ij)) then
          if (i == j) then
            Length = Length+nTri_Elem(TocMck(pBas-1+i))
          else
            Length = Length+TocMck(pBas-1+i)*TocMck(pBas-1+j)
          end if
        end if
      end do
    end do
    if (btest(Option,sLength)) Length = Len_
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  Length = RtoI*Length
  TocMck(pOp+LenOp*(k-1)+oLabel) = LabTmp(1)
# ifndef _I8_
  TocMck(pOp+LenOp*(k-1)+oLabel+1) = LabTmp(2)
# endif
  TocMck(pOp+LenOp*(k-1)+oComp) = Comp
  TocMck(pOp+LenOp*(k-1)+oSymLb) = iSymLab
  TocMck(pOp+LenOp*(k-1)+oAddr) = iDisk
  !write(u6,*) Length,idisk
  call iDAFile(LuMCK,1,iData,Length,iDisk)
  !if ((Label == 'TOTAL') .or. (Label == 'INACTIVE') .or. (Label == 'MOPERT')) then
  !  !write(u6,*) 'iComp=',iComp
  !  !call RecPrt(Label,' ',iData,1,Length/RtoI)
  !  Check = DDot_(Length/RtoI,iData,1,iData,1)
  !  Label_Add = ' '
  !  Label_Add = Label
  !  write(Label_Add(9:11),'(I3.3)') iComp
  !  !write(u6,*) Label_Add,Label,iComp,Check(1)
  !  if (Label == 'TOTAL') then
  !    call Add_Info(Label_Add,Check,1,6)
  !  else if (Label == 'INACTIVE') then
  !    call Add_Info(Label_Add,Check,1,7)
  !  else
  !    call Add_Info(Label_Add,Check,1,1)
  !  end if
  !end if
  !TocMck(pNext) = iDisk
  TocMck(pNext) = max(TocMck(pNext),iDisk)
end if
!----------------------------------------------------------------------*
! Finally copy the TocMck back to disk                                 *
!----------------------------------------------------------------------*
iDisk = 0
call iDaFile(LuMCK,1,TocMck,lTocMck,iDisk)
!----------------------------------------------------------------------*
! Print debugging information                                          *
!----------------------------------------------------------------------*
if (Debug) then
  write(u6,*) '<<< Exiting WrMck >>>'
  write(u6,'(a,z8)') ' rc on exit:     ',rc
  write(u6,'(a,a)') ' Label on exit:  ',Label
  write(u6,'(a,z8)') ' Comp on exit:   ',Comp
  write(u6,'(a,z8)') ' SymLab on exit: ',SymLab
  write(u6,'(a,z8)') ' Option on exit: ',Option
end if

!----------------------------------------------------------------------*
! Terminate procedure                                                  *
!----------------------------------------------------------------------*
return

end subroutine WrMCK

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine two2mean13(carteSO,occup,AOcoeffs,onecart,
     *ncontmf,norbsum,noccorb)
cbs   gives the two first contributions
cbs   < i M | j M >  with Malpha  and Mbeta
cbs   the other orbit parts cancel
      implicit real*8 (a-h,o-z)
#include "para.fh"
      dimension carteSO(ncontmf,ncontmf,norbsum,norbsum),
     *occup(*),AOcoeffs(MxcontL,*),onecart(MxcontL,MxcontL)
      do icartleft=1,norbsum
      do icartright=1,norbsum
      coeff=0d0
      do Mrun=1,noccorb
      coeff=coeff+occup(Mrun)*AOcoeffs(icartleft,Mrun)*
     *      AOcoeffs(icartright,Mrun)
      enddo
      do irun=1,ncontmf
      do jrun=1,ncontmf
      onecart(irun,jrun)=onecart(irun,jrun)+coeff*
     *carteSO(irun,jrun,icartleft,icartright)
      enddo
      enddo
      enddo
      enddo
c     write(6,*) 'effective integrals'
c     do jrun=1,ncontmf
c     write(6,'(4E20.14)') (onecart(irun,jrun),irun=1,ncontmf)
c     enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! Molcas BLAS wrappers
! These wrappers handle lp64/ilp64 interfaces and various other
! requirements related to e.g. matrix size on GPUs. Any BLAS call in
! Molcas should use these wrappers.

! List of BLAS wrappers currently implemented:
! dasum_
! daxpy_
! dcopy_
! ddot_
! dgemm_
! dgemv_
! dger_
! dnrm2_
! drot_
! dscal_
! dspmv_
! dswap_
! dznrm2_
! idamax_
! scopy_
! zcopy_
! zdscal_
! zgemm_

! Specify if integer conversion will be needed.
! (real conversion is not implemented yet)
#if defined (LINALG_I4) && defined (_I8_)
# define MOLCAS_TO_BLAS_INT
# define _BLAS_INT_use_ use Definitions, only: BLASInt
#else
# define _BLAS_INT_use_
#endif
#ifdef _CUDA_BLAS_
# define _CUDA_INT_use_ use Definitions, only: CUDAInt
#else
# define _CUDA_INT_use_
#endif

#include "intent.fh"

function dasum_(n_,dx,incx_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  real(kind=BLASR8) :: dasum_
  integer(kind=iwp), intent(in) :: n_, incx_
  real(kind=BLASR8), intent(in) :: dx(*)
  real(kind=BLASR8), external :: dasum
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  dasum_ = dasum(n,dx,incx)
# else
  dasum_ = dasum(n_,dx,incx_)
# endif
end function dasum_

subroutine daxpy_(n_,da,dx,incx_,dy,incy_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  integer(kind=iwp), intent(in) :: n_, incx_, incy_
  real(kind=BLASR8), intent(in) :: da, dx(*)
  real(kind=BLASR8), intent(inout) :: dy(*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx, incy
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  incy = int(incy_,kind=BLASInt)
  call daxpy(n,da,dx,incx,dy,incy)
# else
  call daxpy(n_,da,dx,incx_,dy,incy_)
# endif
end subroutine daxpy_

subroutine dcopy_(n_,dx,incx_,dy,incy_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  integer(kind=iwp), intent(in) :: n_, incx_, incy_
  real(kind=BLASR8), intent(in) :: dx(*)
  real(kind=BLASR8), intent(_OUT_) :: dy(*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx, incy
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  incy = int(incy_,kind=BLASInt)
  call dcopy(n,dx,incx,dy,incy)
# else
  call dcopy(n_,dx,incx_,dy,incy_)
# endif
end subroutine dcopy_

function ddot_(n_,dx,incx_,dy,incy_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  real(kind=BLASR8) :: ddot_
  integer(kind=iwp), intent(in) :: n_, incx_, incy_
  real(kind=BLASR8), intent(in) :: dx(*), dy(*)
  real(kind=BLASR8), external :: ddot
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx, incy
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  incy = int(incy_,kind=BLASInt)
  ddot_ = ddot(n,dx,incx,dy,incy)
# else
  ddot_ = ddot(n_,dx,incx_,dy,incy_)
# endif
end function ddot_

subroutine dgemm_(transa,transb,m_,n_,k_,alpha,a,lda_,b,ldb_,beta,c,ldc_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  _CUDA_INT_use_
  implicit none
  character, intent(in) :: transa, transb
  integer(kind=iwp), intent(in) :: m_, n_, k_, lda_, ldb_, ldc_
  real(kind=BLASR8), intent(in) :: alpha, a(lda_,*), b(ldb_,*), beta
  real(kind=BLASR8), intent(inout) :: c(ldc_,*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: k, lda, ldb, ldc, m, n
# endif
# ifdef _CUDA_BLAS_
  integer(kind=CUDAInt) :: k4, lda4, ldb4, ldc4, m4, n4
  integer(kind=iwp), parameter :: ncuda = 128*128
# endif

  if ((m_ == 0) .and. (n_ == 0)) return

# ifdef _CUDA_BLAS_
  if (n_*m_ > ncuda) then
    m4 = int(m_,kind=CUDAInt)
    n4 = int(n_,kind=CUDAInt)
    k4 = int(k_,kind=CUDAInt)
    lda4 = int(lda_,kind=CUDAInt)
    ldb4 = int(ldb_,kind=CUDAInt)
    ldc4 = int(ldc_,kind=CUDAInt)
    call cublas_dgemm(transa,transb,m4,n4,k4,alpha,a,lda4,b,ldb4,beta,c,ldc4)
  else
# endif

#   ifdef MOLCAS_TO_BLAS_INT
    m = int(m_,kind=BLASInt)
    n = int(n_,kind=BLASInt)
    k = int(k_,kind=BLASInt)
    lda = int(lda_,kind=BLASInt)
    ldb = int(ldb_,kind=BLASInt)
    ldc = int(ldc_,kind=BLASInt)
    call dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
#   else
    call dgemm(transa,transb,m_,n_,k_,alpha,a,lda_,b,ldb_,beta,c,ldc_)
#   endif

# ifdef _CUDA_BLAS_
  end if
# endif
end subroutine dgemm_

subroutine dgemv_(trans,m_,n_,alpha,a,lda_,x,incx_,beta,y,incy_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  _CUDA_INT_use_
  implicit none
  character, intent(in) :: trans
  integer(kind=iwp), intent(in) :: m_, n_, lda_, incx_, incy_
  real(kind=BLASR8), intent(in) :: alpha, a(lda_,*), x(*), beta
  real(kind=BLASR8), intent(inout) :: y(*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: incx, incy, lda, m, n
# endif
# ifdef _CUDA_BLAS_
  integer(kind=CUDAInt) :: lda4, m4, n4, incx4, incy4
  integer(kind=iwp), parameter :: ncuda = 128*128
# endif

# ifdef _CUDA_BLAS_
  if (n_*m_ > ncuda) then
    m4 = int(m_,kind=CUDAInt)
    n4 = int(n_,kind=CUDAInt)
    lda4 = int(lda_,kind=CUDAInt)
    incx4 = int(incx_,kind=CUDAInt)
    incy4 = int(incy_,kind=CUDAInt)
    call cublas_dgemv(trans,m4,n4,alpha,a,lda4,x,incx4,beta,y,incy4)
  else
# endif

#   ifdef MOLCAS_TO_BLAS_INT
    m = int(m_,kind=BLASInt)
    n = int(n_,kind=BLASInt)
    lda = int(lda_,kind=BLASInt)
    incx = int(incx_,kind=BLASInt)
    incy = int(incy_,kind=BLASInt)
    call dgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
#   else
    call dgemv(trans,m_,n_,alpha,a,lda_,x,incx_,beta,y,incy_)
#   endif

# ifdef _CUDA_BLAS_
  end if
# endif
end subroutine dgemv_

subroutine dger_(m_,n_,alpha,x,incx_,y,incy_,a,lda_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  integer(kind=iwp), intent(in) :: m_, n_, incx_, incy_, lda_
  real(kind=BLASR8), intent(in) :: alpha, x(*), y(*)
  real(kind=BLASR8), intent(inout) :: a(lda_,*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: m, n, incx, incy, lda
  m = int(m_,kind=BLASInt)
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  incy = int(incy_,kind=BLASInt)
  lda = int(lda_,kind=BLASInt)
  call dger(m,n,alpha,x,incx,y,incy,a,lda)
# else
  call dger(m_,n_,alpha,x,incx_,y,incy_,a,lda_)
# endif
end subroutine dger_

function dnrm2_(n_,x,incx_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  real(kind=BLASR8) :: dnrm2_
  integer(kind=iwp), intent(in) :: n_, incx_
  real(kind=BLASR8), intent(in) :: x(*)
  real(kind=BLASR8), external :: dnrm2
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  dnrm2_ = dnrm2(n,x,incx)
# else
  dnrm2_ = dnrm2(n_,x,incx_)
# endif
end function dnrm2_

subroutine drot_(n_,dx,incx_,dy,incy_,c,s)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  integer(kind=iwp), intent(in) :: n_, incx_, incy_
  real(kind=BLASR8), intent(inout) :: dx(*), dy(*)
  real(kind=BLASR8), intent(in) :: c, s
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx, incy
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  incy = int(incy_,kind=BLASInt)
  call drot(n,dx,incx,dy,incy,c,s)
# else
  call drot(n_,dx,incx_,dy,incy_,c,s)
# endif
end subroutine drot_

subroutine dscal_(n_,da,dx,incx_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  integer(kind=iwp), intent(in) :: n_, incx_
  real(kind=BLASR8), intent(in) :: da
  real(kind=BLASR8), intent(inout) :: dx(*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  call dscal(n,da,dx,incx)
# else
  call dscal(n_,da,dx,incx_)
# endif
end subroutine dscal_

subroutine dspmv_(uplo,n_,alpha,ap,x,incx_,beta,y,incy_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  _CUDA_INT_use_
  implicit none
  character, intent(in) :: uplo
  integer(kind=iwp), intent(in) :: n_, incx_, incy_
  real(kind=BLASR8), intent(in) :: alpha, ap(*), x(*), beta
  real(kind=BLASR8), intent(inout) :: y(*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx, incy
# endif
# ifdef _CUDA_BLAS_
  integer(kind=CUDAInt) :: n4, incx4, incy4
  integer(kind=iwp), parameter :: ncuda = 128
# endif

# ifdef _CUDA_BLAS_
  if (n_ > ncuda) then
    n4 = int(n_,kind=CUDAInt)
    incx4 = int(incx_,kind=CUDAInt)
    incy4 = int(incy_,kind=CUDAInt)
    call cublas_dspmv(uplo,n4,alpha,ap,x,incx4,beta,y,incy4)
  else
# endif

#   ifdef MOLCAS_TO_BLAS_INT
    n = int(n_,kind=BLASInt)
    incx = int(incx_,kind=BLASInt)
    incy = int(incy_,kind=BLASInt)
    call dspmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
#   else
    call dspmv(uplo,n_,alpha,ap,x,incx_,beta,y,incy_)
#   endif

# ifdef _CUDA_BLAS_
  end if
# endif
end subroutine dspmv_

subroutine dswap_(n_,dx,incx_,dy,incy_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  integer(kind=iwp), intent(in) :: n_, incx_, incy_
  real(kind=BLASR8), intent(inout) :: dx(*), dy(*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx, incy
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  incy = int(incy_,kind=BLASInt)
  call dswap(n,dx,incx,dy,incy)
# else
  call dswap(n_,dx,incx_,dy,incy_)
# endif
end subroutine dswap_

function dznrm2_(n_,x,incx_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  real(kind=BLASR8) :: dznrm2_
  integer(kind=iwp), intent(in) :: n_, incx_
  complex(kind=BLASR8), intent(in) :: x(*)
  real(kind=BLASR8), external :: dznrm2
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  dznrm2_ = dznrm2(n,x,incx)
# else
  dznrm2_ = dznrm2(n_,x,incx_)
# endif
end function dznrm2_

function idamax_(n_,dx,incx_)
  use Definitions, only: BLASR8, iwp, BLASInt
  implicit none
  integer(kind=iwp) :: idamax_
  integer(kind=iwp), intent(in) :: n_, incx_
  real(kind=BLASR8), intent(in) :: dx(*)
  integer(kind=BLASInt), external :: idamax
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  idamax_ = idamax(n,dx,incx)
# else
  idamax_ = idamax(n_,dx,incx_)
# endif
end function idamax_

subroutine scopy_(n_,sx,incx_,sy,incy_)
  use Definitions, only: BLASR4, iwp
  _BLAS_INT_use_
  implicit none
  integer(kind=iwp), intent(in) :: n_, incx_, incy_
  real(kind=BLASR4), intent(in) :: sx(*)
  real(kind=BLASR4), intent(_OUT_) :: sy(*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx, incy
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  incy = int(incy_,kind=BLASInt)
  call scopy(n,sx,incx,sy,incy)
# else
  call scopy(n_,sx,incx_,sy,incy_)
# endif
end subroutine scopy_

subroutine zcopy_(n_,dx,incx_,dy,incy_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  integer(kind=iwp), intent(in) :: n_, incx_, incy_
  complex(kind=BLASR8), intent(in) :: dx(*)
  complex(kind=BLASR8), intent(_OUT_) :: dy(*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx, incy
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  incy = int(incy_,kind=BLASInt)
  call zcopy(n,dx,incx,dy,incy)
# else
  call zcopy(n_,dx,incx_,dy,incy_)
# endif
end subroutine zcopy_

subroutine zdscal_(n_,da,dx,incx_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  implicit none
  integer(kind=iwp), intent(in) :: n_, incx_
  real(kind=BLASR8), intent(in) :: da
  complex(kind=BLASR8), intent(inout) :: dx(*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: n, incx
  n = int(n_,kind=BLASInt)
  incx = int(incx_,kind=BLASInt)
  call zdscal(n,da,dx,incx)
# else
  call zdscal(n_,da,dx,incx_)
# endif
end subroutine zdscal_

subroutine zgemm_(transa,transb,m_,n_,k_,alpha,a,lda_,b,ldb_,beta,c,ldc_)
  use Definitions, only: BLASR8, iwp
  _BLAS_INT_use_
  _CUDA_INT_use_
  implicit none
  character, intent(in) :: transa, transb
  integer(kind=iwp), intent(in) :: m_, n_, k_, lda_, ldb_, ldc_
  complex(kind=BLASR8), intent(in) :: alpha, a(lda_,*), b(ldb_,*), beta
  complex(kind=BLASR8), intent(inout) :: c(ldc_,*)
# ifdef MOLCAS_TO_BLAS_INT
  integer(kind=BLASInt) :: k, lda, ldb, ldc, m, n
# endif
# ifdef _CUDA_BLAS_
  integer(kind=CUDAInt) :: k4, lda4, ldb4, ldc4, m4, n4
  integer(kind=iwp), parameter :: ncuda = 128*128
# endif

  if ((m_ == 0) .and. (n_ == 0)) return

# ifdef _CUDA_BLAS_
  if (n_*m_ > ncuda) then
    m4 = int(m_,kind=CUDAInt)
    n4 = int(n_,kind=CUDAInt)
    k4 = int(k_,kind=CUDAInt)
    lda4 = int(lda_,kind=CUDAInt)
    ldb4 = int(ldb_,kind=CUDAInt)
    ldc4 = int(ldc_,kind=CUDAInt)
    call cublas_zgemm(transa,transb,m4,n4,k4,alpha,a,lda4,b,ldb4,beta,c,ldc4)
  else
# endif

#   ifdef MOLCAS_TO_BLAS_INT
    m = int(m_,kind=BLASInt)
    n = int(n_,kind=BLASInt)
    k = int(k_,kind=BLASInt)
    lda = int(lda_,kind=BLASInt)
    ldb = int(ldb_,kind=BLASInt)
    ldc = int(ldc_,kind=BLASInt)
    call zgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
#   else
    call zgemm(transa,transb,m_,n_,k_,alpha,a,lda_,b,ldb_,beta,c,ldc_)
#   endif

# ifdef _CUDA_BLAS_
  end if
# endif
end subroutine zgemm_

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine schmidt_cvb(c,nvec,sao,n,metr)
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
      dimension c(n,nvec),sao(*)

      if(metr.eq.0)then
        i1 = mstackr_cvb(nvec)
        call schmidt2_cvb(c,c,work(i1),nvec,sao,n,metr)
        call mfreer_cvb(i1)
      else
        i1 = mstackr_cvb(n*nvec)
        i2 = mstackr_cvb(nvec)
        call schmidt2_cvb(c,work(i1),work(i2),nvec,sao,n,metr)
        call mfreer_cvb(i1)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     Only read the number of states                                   *
!                                                                      *
!***********************************************************************

subroutine rdjob_nstates(JOB)

use Cntrl, only: bNAME, HEAD1, IROOT1, ISTAT, iTOC15, JBNAME, LROT1, LSYM1, LuIph, MPLET1, NACTE1, NASH1, NBAS1, NCONF1, NDEL1, &
                 NELE31, NFRO1, NHOL11, NISH1, NROOT1, NRS11, NRS21, NRS31, NSTAT, NSTATE, NSYM1, TITLE1
use Molcas, only: LenIn, MxOrb, MxRoot, MxSym
use RASDim, only: MxTit
#ifdef _HDF5_
use mh5, only: mh5_close_file, mh5_fetch_attr, mh5_is_hdf5, mh5_open_file_r
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: job
integer(kind=iwp) :: iad, ipt2
#ifdef _HDF5_
integer(kind=iwp) :: ref_nstates, refwfn_id
#endif
real(kind=wp) :: ENUCDUMMY
real(kind=wp), allocatable :: Weight(:)

#ifdef _HDF5_
if (mh5_is_hdf5(jbname(job))) then
  !*********************************************************************
  !
  ! For HDF5 formatted job files
  !
  !*********************************************************************
  refwfn_id = mh5_open_file_r(jbname(job))
  call mh5_fetch_attr(refwfn_id,'NSTATES',ref_nstates)
  ! update the state offset, number of states, and total number of states
  ISTAT(JOB) = NSTATE+1
  NSTAT(JOB) = ref_nstates
  NSTATE = NSTATE+ref_nstates
  call mh5_close_file(refwfn_id)
else
#endif
  call DANAME(LUIPH,JBNAME(JOB))
  ! READ TABLE OF CONTENTS ON THIS JOBIPH FILE:
  IAD = 0
  call IDAFILE(LUIPH,2,ITOC15,30,IAD)
  ! SCATTER-READ VARIOUS DATA:
  IAD = ITOC15(1)
  call mma_allocate(Weight,MxRoot,Label='Weight')
  call WR_RASSCF_Info(LUIPH,2,IAD,NACTE1,MPLET1,NSYM1,LSYM1,NFRO1,NISH1,NASH1,NDEL1,NBAS1,mxSym,bNAME,(LenIn+8)*mxOrb,NCONF1, &
                      HEAD1,2*72,TITLE1,4*mxTit*18,ENUCDUMMY,LROT1,NROOT1,IROOT1,mxRoot,NRS11,NRS21,NRS31,NHOL11,NELE31,IPT2,Weight)
  call mma_deallocate(Weight)
  ! update the state offset, number of states, and total number of states
  ISTAT(JOB) = NSTATE+1
  NSTAT(JOB) = NROOT1
  NSTATE = NSTATE+NROOT1
  call DACLOS(LUIPH)
#ifdef _HDF5_
end if
#endif

end subroutine rdjob_nstates

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ALLOC_MRCI()

use mrci_global, only: IFIRST, IPASS, IROW, ISMAX, JSC, KBUFF1, LN, MBUF, MEMWRK, MXVEC, NBITM1, NBITM2, NBITM3, NBMN, NCHN1, &
                       NCHN2, NCHN3, NREF, NRROOT, NSECT, NSYM, NVIR, NVIRT, NVMAX, NVSQ
use guga_util_global, only: IAD10
use Definitions, only: wp, iwp, RtoI

implicit none
#include "warnings.h"
integer(kind=iwp) :: I, ILIM, MBUF1, MBUF2, MEMB, MEMX, NARR, NBSIZ1, NBSIZ2, NBSIZ3, NBUFBI, NHREF, NIJ, NIJKL, NOT2, NOVLY1, &
                     NPER, NPLEN, NVT

ILIM = 4
if (IFIRST /= 0) ILIM = 2
NVSQ = 0
NVMAX = 0
do I=1,NSYM
  NVMAX = max(NVMAX,NVIR(I))
  NVSQ = NVSQ+NVIR(I)**2
end do
NVT = (NVIRT*(NVIRT+1))/2
if (NVIRT == 0) then
  call SysAbendMsg('alloc_mrci.f:','no virtual orbitals in the basis',' ')
end if
!PAM04 MOVE ALLOCATION OF FOCK MATRIX TO SDCI.
! FOCK MATRIX IN SORT,IIJJ,IJIJ,FIJ,AI.
!-----------------------------------------------
!PAM97 ! BUFFER FOR MOTRA INTEGRALS, TIBUF, IN SORT, SORTA, SORTB.
!PAM06: Evidently some miscounting margin needed:
MEMX = int(0.9_wp*real(MEMWRK,kind=wp))
! ALLOCATION FOR SORTA.
NCHN1 = LN*NVIRT+1
if (IFIRST /= 0) NCHN1 = 1
NBSIZ1 = MEMX/NCHN1-1
NBUFBI = KBUFF1
NBSIZ1 = min(NBSIZ1,MEMX-2*ISMAX-NBUFBI-1)
NBSIZ1 = max(NBSIZ1,256)
!PAM96 NBSIZ1=Size counted in real*8 words.
!PAM96 Must contain NBITM1 real*8 + NBITM1 integ + 2 integ:
NBITM1 = (RTOI*NBSIZ1-2)/(RTOI+1)
NBITM1 = min(NBITM1,NVSQ)
NBITM1 = ((NBITM1+2)/RTOI)*RTOI-2
NBSIZ1 = ((RTOI+1)*NBITM1+2+(RTOI-1))/RTOI
! BIAC
! DYNAMIC ALLOCATION FOR SORTING ABCD
NBITM2 = 1
if (IFIRST == 0) then
  IPASS = 0
  do
    IPASS = IPASS+1
    NCHN2 = (NVT-1)/IPASS+1
    NBSIZ2 = (MEMX-2*ISMAX-KBUFF1)/NCHN2
    if (RTOI*NBSIZ2 > ((RTOI+1)*NVSQ+2)) exit
    if (IPASS == 5) exit
    if (NBSIZ2 >= 1024) exit
  end do
  NBITM2 = (RTOI*NBSIZ2-2)/(RTOI+1)
  NBITM2 = min(NBITM2,NVSQ)
  NBITM2 = ((NBITM2+2)/RTOI)*RTOI-2
  NBSIZ2 = ((RTOI+1)*NBITM2+2+(RTOI-1))/RTOI
end if
! DYNAMIC ALLOCATION FOR SORTING AIBJ, AND CREATING HDIAG:
NOT2 = IROW(LN+1)
NCHN3 = 3*NOT2
NBSIZ3 = (MEMWRK-1)/NCHN3
NBSIZ3 = max(NBSIZ3,256)
NBITM3 = (RTOI*NBSIZ3-2)/(RTOI+1)
NBITM3 = min(NBITM3,NVSQ)
NBITM3 = ((NBITM3+2)/RTOI)*RTOI-2
NBSIZ3 = ((RTOI+1)*NBITM3+2+(RTOI-1))/RTOI
! CALCULATE HOW MUCH SCRATCH WILL BE NEEDED FOR PERS PART:
! FIRST, SET ASIDE WHATS NEEDED FOR SIGMA GENERATION:
NIJ = (LN*(LN+1))/2
NIJKL = NIJ*(NIJ+1)/2
NBMN = IAD10(1)
if (IFIRST /= 0) NBMN = 0
NPER = 5*NVSQ+NBSIZ3+2*NVMAX**2
NPER = max(NPER,NIJKL)
NPER = max(NPER,2*NBMN+2*ISMAX+KBUFF1)
NPER = max(NPER,NBSIZ3+2*NVMAX**2+2*NVSQ)
! OVERLAY CI,((HREF,PLEN) & (SGM,PERS PART))
NHREF = (NREF*(NREF+1))/2
NPLEN = NREF
NOVLY1 = JSC(ILIM)+max(JSC(ILIM)+NPER,NHREF+NPLEN)
! THIS IS TO BE OVERLAYED WITH (CBUF,...,LSCR) IN MQCT. TWO ALT:
NARR = 11*NRROOT**2
MEMB = MEMWRK
MBUF1 = MEMB-NOVLY1-NARR
MBUF2 = (MEMB-NARR-(3*NRROOT+2*MXVEC)*NSECT)/(3*MXVEC+2)
MBUF = min(MBUF1,MBUF2,20249)
MBUF = max(MBUF,1259)
! ALLOCATION OF PERS PART ENDS HERE ------------------------------

end subroutine ALLOC_MRCI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************
!****************************************************
!** Routines that deal with spatial configurations **
!****************************************************

!***********************************************************************
!*                                                                     *
!*  CNFCHECK := Check input configurations and convert to occ no       *
!*              representation if necessary.                           *
!*              Also sort in order of increasing ionicity.             *
!*                                                                     *
!***********************************************************************
subroutine cnfcheck_cvb(iconfs,nconf1,nel1)

use casvb_global, only: noe
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: nconf1, iconfs(noe,nconf1)
integer(kind=iwp), intent(in) :: nel1

call cnfcheck2_cvb(iconfs,nconf1,nel1)
call cnfsort_cvb(iconfs,nconf1,nel1)

return

end subroutine cnfcheck_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine MakeDomainComplete(iDomain,f,S,T,Threshold,nBas_per_Atom,nBas_Start,nBas,nAtom)
! Thomas Bondo Pedersen, January 2006.
!
! Purpose: Boughton-Pulay completeness check of an orbital domain.
!          Extend domain as needed to obtain completeness.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtom, nBas_per_Atom(nAtom), nBas_Start(nAtom), nBas
integer(kind=iwp), intent(inout) :: iDomain(0:nAtom)
real(kind=wp), intent(out) :: f
real(kind=wp), intent(in) :: S(nBas,nBas), T(nBas), Threshold
integer(kind=iwp) :: iA, iB, iCol, irc, iRow, kTi, lnu, mu1, nA, nmu, nnu, nSize, nu, nu1
character(len=80) :: Txt
logical(kind=iwp) :: Complete
real(kind=wp), allocatable :: Scr(:), Si(:,:), Sl(:,:), Ti(:)
real(kind=wp), external :: ddot_
character(len=*), parameter :: SecNam = 'MakeDomainComplete'

nA = iDomain(0)
f = Zero
Complete = nA == nAtom
do while ((nA < nAtom) .and. (.not. Complete))

  ! Allocate S[i], T[i], and Scr[i].
  ! --------------------------------

  nSize = nBas_per_Atom(iDomain(1))
  do iA=2,nA
    nSize = nSize+nBas_per_Atom(iDomain(iA))
  end do
  call mma_allocate(Si,nSize,nSize,label='MkDmC_Si')
  call mma_allocate(Sl,nSize,nSize,label='MkDmC_Sl')
  call mma_allocate(Ti,nSize,label='MkDmC_Ti')
  call mma_allocate(Scr,nSize,label='MkDmC_Scr')

  ! Get S[i] and T[i].
  ! ------------------

  kTi = 1
  iCol = 0
  do iB=1,nA
    nu1 = nBas_Start(iDomain(iB))
    nnu = nBas_per_Atom(iDomain(iB))
    do lnu=0,nnu-1
      nu = nu1+lnu
      iCol = iCol+1
      iRow = 0
      do iA=1,nA
        mu1 = nBas_Start(iDomain(iA))
        nmu = nBas_per_Atom(iDomain(iA))
        Si(:,iCol) = S(mu1:mu1+nmu-1,nu)
        iRow = iRow+nmu
      end do
    end do
    Ti(kTi:kTi+nnu-1) = T(nu1:nu1+nnu-1)
    kTi = kTi+nnu
  end do

  ! Solve S[i]Y=T[i] (Y stored in T[i] on exit).
  ! Use a scratch array for S[i], as it is ruined on exit from
  ! LinEqSolv.
  ! ----------------------------------------------------------

  irc = 0
  Sl(:,:) = Si
  call LinEqSolv(irc,'N',Sl,nSize,Ti,nSize,nSize,1)
  if (irc /= 0) then
    write(Txt,'(A,I9)') 'LinEqSolv returned',irc
    if (irc < 0) then
      call SysAbendMsg(SecNam,Txt,'LinEqSolv input error!')
    else
      call SysAbendMsg(SecNam,Txt,'Singular domain overlap matrix!')
    end if
  end if

  ! Compute f=1-Y(T)S[i]Y.
  ! ----------------------

  call dGeMV_('N',nSize,nSize,One,Si,nSize,Ti,1,Zero,Scr,1)
  f = One-dDot_(nSize,Ti,1,Scr,1)

  ! Deallocation.
  ! -------------

  call mma_deallocate(Si)
  call mma_deallocate(Sl)
  call mma_deallocate(Ti)
  call mma_deallocate(Scr)

  ! Check completeness (f<=Threshold).
  ! If not complete, add next atom to domain.
  ! (If complete, we break the while loop.)
  ! -----------------------------------------

  Complete = f <= Threshold
  if (.not. Complete) nA = nA+1

end do

! Set new domain size.
! --------------------

iDomain(0) = nA

end subroutine MakeDomainComplete

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine contandmult(Lhigh,makemean,AIMP,oneonly,numballcart,
     &                       LUPROP,ifinite,onecart,
     &                       onecontr,oneoverR3,iCenter)
      implicit real*8 (a-h,o-z)
#include "para.fh"
#include "param.fh"
#include "ired.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: Dummy(:), OCA(:,:), OCA2(:,:), OCA3(:,:)
      logical makemean,AIMP,oneonly
      character*8 xa,ya,za
      dimension xa(4),ya(4),za(4),
     *          onecart(mxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax,3),
     *          onecontr(mxcontL,MxcontL,-Lmax:Lmax,3,Lmax),
     *          oneoverR3((MxprimL*MxprimL+MxprimL)/2,Lmax)
      common /nucleus/ charge,Exp_Finite
*
      IPNT(I,J)=(J*J-J)/2+I
*
cbs   get back the real number of functions for the finite nucleus
      if (ifinite.eq.2) ncontrac(0)=ncontrac_keep
c###############################################################################
cbs   subroutine to contract radial one-electron integrals
cbs   and multiply them with angular factors
c###############################################################################
      xa(1)='********'
      ya(1)='********'
      za(1)='********'
      xa(2)='        '
      ya(2)='        '
      Za(2)='        '
      xa(3)='ANTISYMM'
      ya(3)='ANTISYMM'
      Za(3)='ANTISYMM'
      xa(4)='X1SPNORB'
      ya(4)='Y1SPNORB'
      ZA(4)='Z1SPNORB'
c
cbs   clean the arrays for cartesian integrals
C
      length3=(numbalLcart*numbalLcart+numbalLcart)/2
      Call mma_allocate(OCA,Length3,3,Label='OCA')
      Call mma_allocate(OCA2,Length3,3,Label='OCA2')
      Call mma_allocate(Dummy,MxContL**2,Label='Dummy')
      Dummy(:)=0.0D0
      OCA(:,:)=0.0D0
      OCA2(:,:)=0.0D0
c
c
c
c
cbs   one-electron-integrals:
cbs   1. index: number of first contracted function
cbs   2. index: number of second contracted function
cbs   3. index: pointer(m1,m2)    m1< m2 otherwise change sign of integral
cbs   4. index: L-value
cbs    onecart(mxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax,1),
cbs    onecart(mxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax,2),
cbs    onecart(mxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax,3)
c
c
c
cbs   generate one-electron integrals for all L greater/equal 1
      if (ifinite.eq.2) charge=0d0 ! nuclear integrals
cbs                                  are modelled for finite nucleus somewhere else
      do L=1,Lhigh
              call contone(L,oneoverr3(1,L),onecontr(1,1,-Lmax,1,L),
     *                     Lmax,contrarray(iaddtyp3(L)),nprimit(L),
     *                     ncontrac(L),MxcontL,Dummy,
     *                     onecart(1,1,1,L,1),
     *                     onecart(1,1,1,L,2),
     *                     onecart(1,1,1,L,3),
     *                     charge,oneonly)
      Enddo
c
cbs   ***********************************************************************
cbs   now move all integrals to one big arrays for X,Y,Z
cbs   ***********************************************************************
      do Lrun=1,Lhigh  !loop over L-values (integrals are diagonal in L)
      mrun=0
      do Msec=-Lrun,Lrun    ! cartesian M-values  (Mfirst,Msec) with
      do Mfirst=-Lrun,Msec  ! Mfirst <= Msec (actually '=' does never
c                             appear as there is no L-component  in Ag
C
c
cbs   determine  if L_X L_Y or L_Z
        ipowx=ipowxyz(1,mfirst,Lrun)+ipowxyz(1,msec,Lrun)
        ipowy=ipowxyz(2,mfirst,Lrun)+ipowxyz(2,msec,Lrun)
        ipowz=ipowxyz(3,mfirst,Lrun)+ipowxyz(3,msec,Lrun)
c
        mrun=mrun+1
cbs     now determine the irreducable representations
        iredfirst=iredLM(Mfirst,Lrun)
        iredsec=iredLM(Msec,Lrun)
cbs     check out which IR is the lower one.
        if (iredfirst.le.iredsec) then
*
cbs     calculate shift to get to the beginning of the block
           iredired= shiftIRIR((iredsec*iredsec-iredsec)/2+iredfirst)
     *             + incrlm(Mfirst,Lrun)*itotalperIR(iredsec)
     *             + incrLM(Msec,Lrun)
           if (mod(ipowx,2).eq.0.and.mod(ipowy,2).eq.1.and.
     *         mod(ipowz,2).eq.1) then
              do icartfirst=1,ncontrac(Lrun) ! loop first index
                 do icartsec=1,ncontrac(Lrun)   ! loop second index
                    oca(iredired+icartsec,1)=oca(iredired+icartsec,1)
     *                +onecart(icartfirst,icartsec,mrun,Lrun,1)
                 enddo
cbs              shift pointer by number of functions in IR
                 iredired=iredired+itotalperIR(iredsec)
             enddo
          endif
          if (mod(ipowx,2).eq.1.and.mod(ipowy,2).eq.0.and.
     *        mod(ipowz,2).eq.1) then
              do icartfirst=1,ncontrac(Lrun) ! loop first index
                 do icartsec=1,ncontrac(Lrun)   ! loop second index
                    oca(iredired+icartsec,2)=oca(iredired+icartsec,2)
     *                +onecart(icartfirst,icartsec,mrun,Lrun,2)
                 enddo
cbs              shift pointer by number of functions in IR
                 iredired=iredired+itotalperIR(iredsec)
              enddo
           endif
           if (mod(ipowx,2).eq.1.and.mod(ipowy,2).eq.1.and.
     *         mod(ipowz,2).eq.0) then
              do icartfirst=1,ncontrac(Lrun) ! loop first index
                 do icartsec=1,ncontrac(Lrun)   ! loop second index
                    oca(iredired+icartsec,3)=oca(iredired+icartsec,3)
     *                +onecart(icartfirst,icartsec,mrun,Lrun,3)
                 enddo
cbs              shift pointer by number of functions in IR
                 iredired=iredired+itotalperIR(iredsec)
              enddo
           endif
        elseif (iredfirst.gt.iredsec) then
cbs        In this case, indices are exchanged with respect to former
cbs        symmetry of blocks. Therefore, there will be a minus sign
c
cbs        calculate shift to get to the beginning of the block
           iredired=shiftIRIR((iredfirst*iredfirst-iredfirst)/2+iredsec)
     *             + incrLM(Msec,Lrun)*itotalperIR(iredfirst)
     *             + incrLM(Mfirst,Lrun)
           if (mod(ipowx,2).eq.0.and.mod(ipowy,2).eq.1.and.
     *         mod(ipowz,2).eq.1) then
              do icartsec=1,ncontrac(Lrun) !loopsecond index
                 do icartfirst=1,ncontrac(Lrun) !loop first index
                    oca(iredired+icartfirst,1)=
     *                oca(iredired+icartfirst,1)
     *               -onecart(icartsec,icartfirst,mrun,Lrun,1)
                 enddo
cbs              shift pointer by number of functions in IR
                 iredired=iredired+itotalperIR(iredfirst)
              enddo
           endif
           if (mod(ipowx,2).eq.1.and.mod(ipowy,2).eq.0.and.
     *         mod(ipowz,2).eq.1) then
              do icartsec=1,ncontrac(Lrun) !loop second index
                 do icartfirst=1,ncontrac(Lrun) !loop first index
                    oca(iredired+icartfirst,2)=
     *                oca(iredired+icartfirst,2)
     *               -onecart(icartsec,icartfirst,mrun,Lrun,2)
                 enddo
cbs              shift pointer by number of functions in IR
                 iredired=iredired+itotalperIR(iredfirst)
              enddo
           endif
           if (mod(ipowx,2).eq.1.and.mod(ipowy,2).eq.1.and.
     *         mod(ipowz,2).eq.0) then
              do icartsec=1,ncontrac(Lrun) !loop  second index
                 do icartfirst=1,ncontrac(Lrun) !loop first index
                    oca(iredired+icartfirst,3)=
     *                oca(iredired+icartfirst,3)
     *               -onecart(icartsec,icartfirst,mrun,Lrun,3)
                 enddo
cbs              shift pointer by number of functions in IR
                 iredired=iredired+itotalperIR(iredfirst)
              enddo
           endif
        endif
      enddo
      enddo
      enddo
C
cbs   copy integrals on arrays with no symmetry blocking at all
cbs   which means huge triangular matrices
      irun=0
      do norb2=1,numballcarT
         ired2=iredoffunctnew(norb2)
         norbsh2=norb2-shiftIRED(ired2)
         do norb1=1,norb2
            ired1=iredoffunctnew(norb1)
            norbsh1=noRb1-shiftIRED(ired1)
            irun=irun+1
            iredired=shiftIRIR((ired2*ired2-ired2)/2+ired1)
            if (ired1.ne.ired2) then
               oca2(irun,1)=
     &            oca(iredired+norbsh2+(norbsH1-1)*itotalperIR(IREd2),1)
               oca2(irun,2)=
     &            oca(iredired+norbsh2+(norbsH1-1)*itotalperIR(IREd2),2)
               oca2(irun,3)=
     &            oca(iredired+norbsh2+(norbsH1-1)*itotalperIR(IREd2),3)
            else
               oca2(irun,1)=
     &            oca(iredired+norbsh2*(norbsH2-1)/2+norbsh1,1)
               oca2(irun,2)=
     &            oca(iredired+norbsh2*(norbsH2-1)/2+norbsh1,2)
               oca2(irun,3)=
     &            oca(iredired+norbsh2*(norbsH2-1)/2+norbsh1,3)
            endif
         Enddo
      enddo
      if (.not.AIMP) then
c     write a hermit-like file   b.s. 4.10.96
CBS   write(6,*) 'number of orbitals ',numbalLcarT
CBS   write(6,*) 'length of triangular matrix ', length3
CBS    This was removed and will be done in SEWARD
CBS           OPEN(LUPROP,STATUS='UNKNOWN',FORM='UNFORMATTED',
CBS  *        FILE='AOPROPER_MF')
CBS    rewind LUPROP
              write(LUPROP)  iCenter
              write(LUPROP)  xa,numbofsym,(nrtofiperIR(I),
     *        i=1,numbofsym),
     *        numballcart,(Loffunction(I),I=1,numballcart),
     *        (Moffunction(I),I=1,numballcart),
     *        Lhigh,(ncontrac(I),I=0,Lhigh)
              write(LUPROP) (oca2(irun,1),irun=1,length3)
              write(LUPROP)  Ya
              write(LUPROP) (oca2(irun,2),irun=1,length3)
              write(LUPROP)  Za
              write(LUPROP) (oca2(irun,3),irun=1,length3)
CBS   close(luprop)
      else
cbs   reorder for AIMP
cbs   write(6,*) 'reorder integrals for AIMP'
      length3=ikeeporb*(ikeeporb+1)/2
      Call mma_allocate(OCA3,length3,3,Label='OCA3')
      OCA3(:,:)=0.0D0
cbs   write(6,*) 'number of orbitals ',ikeeporb
cbs   write(6,*) 'length of triangular matrix ', length3
      do irun2=1,ikeeporb
         do irun1=1,irun2
            ind2=ikeeplist(irun2)
            ind1=ikeeplist(irun1)
            ipntold=ipnt(ind1,ind2)
            ipntnew=ipnt(irun1,irun2)
*
            oca3(ipntnew,1)=oca2(ipntold,1)
            oca3(ipntnew,2)=oca2(ipntold,2)
            oca3(ipntnew,3)=oca2(ipntold,3)
         enddo
      enddo
CBS   write(6,*) 'transfered to new blocks'
CBS   Luprop=19
CBS   OPEN(LUPROP,STATUS='UNKNOWN',FORM='UNFORMATTED',
CBS  *     FILE='AOPROPER_MF')
CBS   rewind LUPROP
*
      write(LUPROP)  iCenter
      write(LUPROP)  xa,numbofsym,(nrtofiperIR(I),
     *               i=1,numbofsym),
     *               ikeeporb,(Loffunction(ikeeplist(i)),i=1,ikeeporb),
     *               (Moffunction(ikeeplist(i)),I=1,ikeeporb),
     *               Lhigh,((NContrac(I)-icore(I)),I=0,Lhigh)
      write(LUPROP) (oca3(irun,1),irun=1,length3)
      write(LUPROP)  Ya
      write(LUPROP) (oca3(irun,2),irun=1,length3)
      write(LUPROP)  Za
      write(LUPROP) (oca3(irun,3),irun=1,length3)
*
      Call mma_deallocate(OCA3)
CBS   close(luprop)
      endif
cbs
cbs   that is it!!
cbs
      Call mma_deallocate(OCA2)
      Call mma_deallocate(OCA)
      Call mma_deallocate(Dummy)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_logical(makemean)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      SubRoutine List2(Title,Lbl,gq,nAtom,nInter,Smmtrc)
************************************************************************
*                                                                      *
* Object: to print cartesian internal coordinates.                     *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             1993                                                     *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
*
      Real*8 gq(3*nAtom,nInter)
      Character Lbl(nAtom)*(*), Title*(*)
      Logical Smmtrc(3*nAtom)
*
      n_qLbl=3*nAtom
      nChar=4*n_qLbl
      Call GetMem('qLbl','Allo','Char',ip_qLbl,nChar)
      Call List2_(Title,Lbl,gq,nAtom,nInter,Smmtrc,cWork(ip_qLbl),
     &            n_qLbl)
      Call GetMem('qLbl','Free','Char',ip_qLbl,nChar)
*
      Return
      End
      SubRoutine List2_(Title,Lbl,gq,nAtom,nInter,Smmtrc,qLbl,n_qLbl)
************************************************************************
*                                                                      *
* Object: to print cartesian internal coordinates.                     *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             1993                                                     *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
*
      Real*8 gq(3*nAtom,nInter)
      Character Lbl(nAtom)*(*), Format*72, Title*(*), Line*80
      Character*4 qLbl(n_qLbl), qLbl_tmp*14
      Logical Start, Smmtrc(3*nAtom)
      character*16 filnam
      Lu=6
*
      iRout = 119
      iPrint = nPrint(iRout)
*
      Thr=0.001D+00 ! Threshold for printout.
*
      mInt=3*nAtom
*
      Write (Lu,*)
      Call CollapseOutput(1,'Internal coordinates')
      Write (Lu,*)
      Write (Lu,*) ' Specification of the internal coordinates '
     &          //'according to the user-defined internal'
      Write(Lu,*) ' coordinate format.'
      Write (Lu,*)
      Write (Lu,'(A)') 'Internal Coordinates'
      iq = 0
      Do igq = 1, mInt, 3
         If (Smmtrc(igq  )) Then
            iq=iq+1
            Write (qLbl(igq  ),'(A,I3.3)') 'c',iq
            Write (Lu,'(3A)')
     &             qLbl(igq  ),' = Cartesian x ',Lbl((igq+2)/3)
         End If
         If (Smmtrc(igq+1)) Then
            iq=iq+1
            Write (qLbl(igq+1),'(A,I3.3)') 'c',iq
            Write (Lu,'(3A)')
     &             qLbl(igq+1),' = Cartesian y ',Lbl((igq+2)/3)
         End If
         If (Smmtrc(igq+2)) Then
            iq=iq+1
            Write (qLbl(igq+2),'(A,I3.3)') 'c',iq
            Write (Lu,'(3A)')
     &             qLbl(igq+2),' = Cartesian z ',Lbl((igq+2)/3)
         End If
      End Do
      Write (Lu,'(A)') 'Vary'
      Do iQQ = 1, nInter
         Write(Line,'(A,I3.3,A)') 'q',iQQ,' ='
         iF=7
         jq=0
         Start=.True.
         Do iq = 1, mInt
            temp=Abs(gq(iq,iQQ))
            If (temp.gt.Thr) Then
               jq = jq + 1
               If (jq.gt.4) Then
                  Line(80:80)='&'
                  Write (Lu,'(A)') Line
                  Line=' '
                  iF=6
                  jq = 1
                  Start=.False.
               End If
               If (jq.eq.1.and.Start) Then
                  iE=iF+16
                  Write(Line(iF:iE),'(A,F10.8,4A)') ' ',gq(iq,iQQ),
     &                                            ' ',qLbl(iq),' '
               Else
                  iE=iF+17
                  Write(Line(iF:iE),'(A,F10.8,4A)') '+ ',gq(iq,iQQ),
     &                                            ' ',qLbl(iq),' '
               End If
               iF=iE+1
            End If
         End Do
         Write (Lu,'(A)') Line
      End Do
      Write (Lu,'(A)') 'End Of Internal Coordinates'
      Call CollapseOutput(0,'Internal coordinates')
*
*     Write linear combinations to disc
*
      LuTmp=11
      filnam='SPCINX'
      call molcas_binaryopen_vanilla(luTmp,filnam)
c      Open(luTmp,File=filnam,Form='unformatted',Status='unknown')
      ReWind (LuTmp)
*
      Write (LuTmp) mInt,nInter
      Do iq = 1, mInt
         qLbl_tmp=qLbl(iq)
         Write (LuTmp) qLbl_tmp,(gq(iq,iQQ),iQQ=1,nInter)
      End Do
*
      Close  (LuTmp)
*
      Write (Lu,*)
      Call CollapseOutput(1,Title)
*
      MxWdth=132
      nLbl=8+1
      nRow=9
      inc = Min((MxWdth-nLbl)/nRow,nInter)
*
      Do 10 ii = 1, nInter, inc
         Write (Lu,*)
         Write(Format,'(A,I2,A)') '(A,1X,',inc,'(I5,4X))'
         Write (Lu,Format) 'Internal',(i,i=ii,Min(ii+inc-1,nInter))
         Write (Lu,*)
         Write(Format,'(A,I2,A)') '(A4,A4,1X,',inc,'(F8.5,1X))'
         Do 20 igq = 1, mInt, 3
            Write (Lu,Format) Lbl((igq+2)/3),' x  ',
     &            (gq(igq  ,i),i=ii,Min(ii+inc-1,nInter))
            Write (Lu,Format) Lbl((igq+2)/3),' y  ',
     &            (gq(igq+1,i),i=ii,Min(ii+inc-1,nInter))
            Write (Lu,Format) Lbl((igq+2)/3),' z  ',
     &            (gq(igq+2,i),i=ii,Min(ii+inc-1,nInter))
 20      Continue
         Write (Lu,*)
 10   Continue
      Call CollapseOutput(0,Title)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992,1999, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Drv2_RF(llOper,Ccoor,nOrdOp,Fldxyz,lMax,h0,nh0)
!***********************************************************************
!                                                                      *
! Object: to compute the one-electron integrals. The method employed at*
!         this point is not necessarily the fastest. However, the total*
!         time for the computation of integrals will depend on the time*
!         spent in computing the two-electron integrals.               *
!         The memory at this point is assumed to be large enough to do *
!         the computation in core.                                     *
!         The data is structured with respect to four indices, two (my *
!         ny or i j) refer to primitives or basis functions and two (a *
!         b) refer to the components of the cartesian or spherical     *
!         harmonic gaussians.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!             Modified for Hermite-Gauss quadrature November '90       *
!             Modified for Rys quadrature November '90                 *
!             Modified for multipole moments November '90              *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for general kernel routines January  91         *
!             Modified for nonsymmetrical operators February  91       *
!             Modified to reaction field calculations July  92         *
!             Modified loop structure April  99                        *
!***********************************************************************

use Index_Functions, only: nTri_Elem1, nTri3_Elem1
use Real_Spherical, only: ipSph, rSph
use iSD_data, only: iSD
use Basis_Info, only: DBSC, MolWgh, Shells
use Center_Info, only: DC
use Gateway_global, only: PrPrt
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use define_af, only: Angtp
use Symmetry_Info, only: ChOper
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: llOper, nOrdOp, lMax, nh0
real(kind=wp), intent(in) :: Ccoor(3), Fldxyz(nTri3_Elem1(lMax))
real(kind=wp), intent(inout) :: h0(nh0)
integer(kind=iwp) :: iAng, iAO, iBas, iCmp, iCnt, iCnttp, iDCRR(0:7), iDCRRT, iDCRT(0:7), iIC, iPrim, is, iShell, iShll, iSmLbl, &
                     iStabM(0:7), iStabO(0:7), iuv, jAng, jAO, jBas, jCmp, jCnt, jCnttp, jPrim, js, jShell, jShll, kk, lDCRR, &
                     lDCRT, lFinal, LmbdR, LmbdT, mdci, mdcj, MemKer, MemKrn, mSO, nComp, nDCRR, nDCRT, nFnc, nIC, nOp(2), nOrder, &
                     NrOpr, nScr1, nScr2, nSkal, nSO, nStabM, nStabO
real(kind=wp) :: A(3), B(3), Fact
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, ii
#endif
real(kind=wp), allocatable :: Fnl(:,:), Kappa(:), Kern(:), PCoor(:,:), Scr1(:), Scr2(:), SO_Int(:), Zeta(:), ZI(:)
integer(kind=iwp), external :: MemSO1, n2Tri

#ifdef _DEBUGPRINT_
write(u6,*) ' In Drv2_RF: llOper'
write(u6,'(1X,8I5)') llOper
write(u6,*) ' In Drv2_RF: n2Tri'
write(u6,'(1X,8I5)') n2Tri(llOper)
#endif

call SOS(iStabO,nStabO,llOper)

! Auxiliary memory allocation.

call mma_allocate(Zeta,S%m2Max,Label='Zeta')
call mma_allocate(ZI,S%m2Max,Label='ZI')
call mma_allocate(Kappa,S%m2Max,Label='Kappa')
call mma_allocate(PCoor,S%m2Max,3,Label='PCoor')
!                                                                      *
!***********************************************************************
!                                                                      *
call Nr_Shells(nSkal)
!                                                                      *
!***********************************************************************
!                                                                      *
! Double loop over shells. These loops decide the integral type

do iS=1,nSkal
  iShll = iSD(0,iS)
  if (Shells(iShll)%Aux) exit
  iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  mdci = iSD(10,iS)
  iShell = iSD(11,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  do jS=1,iS
    jShll = iSD(0,jS)
    jAng = iSD(1,jS)
    jCmp = iSD(2,jS)
    jBas = iSD(3,jS)
    jPrim = iSD(5,jS)
    jAO = iSD(7,jS)
    mdcj = iSD(10,jS)
    jShell = iSD(11,jS)
    jCnttp = iSD(13,jS)
    jCnt = iSD(14,jS)

    iSmLbl = llOper
    if (Prprt) iSmLbl = merge(1,0,btest(iSmLbl,0))
    nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' nSO=',nSO
#   endif
    if (nSO == 0) cycle

#   ifdef _DEBUGPRINT_
    write(u6,'(A,A,A,A,A)') ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
#   endif

    ! Call kernel routine to get memory requirement. Observe, however
    ! that kernels which will use the HRR will allocate that
    ! memory internally.

    call RFMem(nOrder,MemKer,iAng,jAng,nOrdOp)
    !write(u6,*) nOrder,MemKer,iAng,jAng,nOrdOp
    MemKrn = MemKer*S%m2Max
    call mma_allocate(Kern,MemKrn,Label='Kern')

    ! Allocate memory for the final integrals all in the
    ! primitive basis.
    nComp = nTri3_Elem1(lMax)
    lFinal = S%MaxPrm(iAng)*S%MaxPrm(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)
    call mma_allocate(Fnl,lFinal,nComp+1,Label='Fnl')

    ! Scratch area for contraction step

    nScr1 = max(S%MaxPrm(iAng),S%MaxPrm(jAng))*max(S%MaxBas(iAng),S%MaxBas(jAng))*nComp*nTri_Elem1(iAng)*nTri_Elem1(jAng)
    call mma_allocate(Scr1,nScr1,Label='Scr1')

    ! Scratch area for the transformation to spherical gaussians

    nScr2 = nComp*S%MaxBas(iAng)*S%MaxBas(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)
    call mma_allocate(Scr2,nScr2,Label='Scr2')

    ! At this point we can compute Zeta.
    ! This is now computed in the ij or ji order.

    call ZXia(Zeta,ZI,iPrim,jPrim,Shells(iShll)%Exp,Shells(jShll)%Exp)

    ! Allocate memory for SO integrals that will be generated by
    ! this batch of AO integrals.

    call mma_allocate(SO_Int,nSO*iBas*jBas,Label='SO')
    SO_Int(:) = Zero

    ! Find the DCR for A and B

    call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)

    ! Find the stabilizer for A and B

    call Inter(dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iStabM,nStabM)

    ! Find the DCR for M and S

    call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) ' g      =',nIrrep
    write(u6,*) ' u      =',dc(mdci)%nStab
    write(u6,'(9A)') '(U)=',(ChOper(dc(mdci)%iStab(ii)),ii=0,dc(mdci)%nStab-1)
    write(u6,*) ' v      =',dc(mdcj)%nStab
    write(u6,'(9A)') '(V)=',(ChOper(dc(mdcj)%iStab(ii)),ii=0,dc(mdcj)%nStab-1)
    write(u6,*) ' LambdaR=',LmbdR
    write(u6,*) ' r      =',nDCRR
    write(u6,'(9A)') '(R)=',(ChOper(iDCRR(ii)),ii=0,nDCRR-1)
    write(u6,*) ' m      =',nStabM
    write(u6,'(9A)') '(M)=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
    write(u6,*) ' s      =',nStabO
    write(u6,'(9A)') '(S)=',(ChOper(iStabO(ii)),ii=0,nStabO-1)
    write(u6,*) ' LambdaT=',LmbdT
    write(u6,*) ' t      =',nDCRT
    write(u6,'(9A)') '(R)=',(ChOper(iDCRT(ii)),ii=0,nDCRT-1)
#   endif

    ! Compute normalization factor

    iuv = dc(mdci)%nStab*dc(mdcj)%nStab
    Fact = real(iuv*nStabO,kind=wp)/real(nIrrep**2*LmbdT,kind=wp)
    if (MolWgh == 1) then
      Fact = Fact*real(nIrrep,kind=wp)**2/real(iuv,kind=wp)
    else if (MolWgh == 2) then
      Fact = sqrt(real(iuv,kind=wp))*real(nStabO,kind=wp)/real(nIrrep*LmbdT,kind=wp)
    end if

    ! Loops over symmetry operations.

    do lDCRT=0,nDCRT-1
      call OA(iDCRT(lDCRT),dbsc(iCnttp)%Coor(1:3,iCnt),A)
      nOp(1) = NrOpr(iDCRT(lDCRT))
#     ifdef _DEBUGPRINT_
      if (jbas < -99999) write(u6,*) 'nDCRR=',nDCRR
#     endif
      do lDCRR=0,nDCRR-1
        iDCRRT = ieor(iDCRR(lDCRR),iDCRT(lDCRT))
        call OA(iDCRRT,dbsc(jCnttp)%Coor(1:3,jCnt),B)
        nOp(2) = NrOpr(ieor(iDCRT(lDCRT),iDCRR(lDCRR)))
#       ifdef _DEBUGPRINT_
        write(u6,'(A,3(3F6.2,2X))') '***** Centers A, B, & C. *****',(A(i),i=1,3),(B(i),i=1,3),(Ccoor(i),i=1,3)
#       endif

        ! Compute kappa and P.

        call Setup1(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,A,B,Kappa,PCoor,ZI)

        ! Compute primitive integrals. Result is ordered ij,ab.

        call RFInt(Zeta,Kappa,Pcoor,Fnl,iPrim*jPrim,nComp,iAng,jAng,A,B,nOrder,Kern,MemKer,Ccoor,lMax)
#       ifdef _DEBUGPRINT_
        call RecPrt(' Primitive Integrals',' ',Fnl,iPrim*jPrim*nTri_Elem1(iAng)*nTri_Elem1(jAng),nComp)
#       endif

        ! Accumulate contributions due to interaction between the
        ! electric field and the multipole moments.

        nFnc = iPrim*jPrim*nTri_Elem1(iAng)*nTri_Elem1(jAng)
        Fnl(1:nFnc,nComp+1) = Zero
        call DNaXpY(nComp,nFnc,Fldxyz,1,Fnl,1,nFnc,Fnl(1,nComp+1),1,0)
#       ifdef _DEBUGPRINT_
        call RecPrt(' Solvation integrals',' ',Fnl(1,nComp+1),iPrim*jPrim,nTri_Elem1(iAng)*nTri_Elem1(jAng))
#       endif

        ! Transform from primitive to contracted basis functions.
        ! Order of transformation is fixed. It has been shown through
        ! testing that the index order ij,ab will give a performance
        ! that is up to 20% faster than the ab,ij index order.

#       ifdef _DEBUGPRINT_
        call RecPrt(' Left side contraction',' ',Shells(iShll)%pCff,iPrim,iBas)
        call RecPrt(' Right side contraction',' ',Shells(jShll)%pCff,jPrim,jBas)
#       endif

        ! Transform ij,x,ab to j,xabI
        kk = nTri_Elem1(iAng)*nTri_Elem1(jAng)
        call DGEMM_('T','N',jPrim*kk,iBas,iPrim,One,Fnl(1,nComp+1),iPrim,Shells(iShll)%pCff,iPrim,Zero,Scr1,jPrim*kk)
        ! Transform j,xabI to xab,IJ
        call DGEMM_('T','N',kk*iBas,jBas,jPrim,One,Scr1,jPrim,Shells(jShll)%pCff,jPrim,Zero,Fnl(1,nComp+1),kk*iBas)

#       ifdef _DEBUGPRINT_
        call RecPrt(' Contracted integrals in cartesians',' ',Fnl(1,nComp+1),kk,iBas*jBas)
#       endif

        ! Transform to spherical gaussians if needed.

        if (Shells(iShll)%Transf .or. Shells(jShll)%Transf) then

          ! Result comes back as IJxAB or IJxAb
          Scr2(1:kk*iBas*jBas) = Fnl(1:kk*iBas*jBas,nComp+1)
          call CarSph(Scr2,kk,iBas*jBas,Fnl(1,nComp+1),nScr2,RSph(ipSph(iAng)),iAng,Shells(iShll)%Transf,Shells(iShll)%Prjct, &
                      RSph(ipSph(jAng)),jAng,Shells(jShll)%Transf,Shells(jShll)%Prjct,Scr1,iCmp*jCmp)
        else
          ! Transpose back to IJ,x,ab
          call DGeTmO(Fnl(1,nComp+1),kk,kk,iBas*jBas,Scr1,iBas*jBas)
        end if
#       ifdef _DEBUGPRINT_
        call RecPrt(' Contracted Integrals in Sphericals',' ',Scr1,iBas*jBas,iCmp*jCmp)

        ! At this point accumulate the batch of integrals onto the
        ! final symmetry adapted integrals.

        call RecPrt(' Accumulated SO integrals, so far...',' ',SO_Int,iBas*jBas,nSO)
#       endif

        iSmLbl = llOper
        if (Prprt) iSmLbl = merge(1,0,btest(iSmLbl,0))
        mSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
        nIC = 1
        iIC = 1
        if (mSO /= 0) &
          call SymAd1(iSmLbl,iAng,jAng,iCmp,jCmp,iShell,jShell,iShll,jShll,iAO,jAO,Scr1,iBas,jBas,nIC,iIC,SO_Int,mSO,nOp)

      end do
    end do

    ! Multiply with factors due to projection operators

    if (Fact /= One) SO_Int(:) = Fact*SO_Int(:)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Scaling SO''s',Fact
    call RecPrt(' Final SO integrals',' ',SO_Int,iBas*jBas,mSO)
#   endif

    ! Accumulate contribution to the Hamiltonian.

    iSmLbl = llOper
    if (Prprt) iSmLbl = merge(1,0,btest(iSmLbl,0))
    call SOAdd(SO_Int,iBas,jBas,mSO,h0,n2Tri(iSmLbl),iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)

    call mma_deallocate(SO_Int)
    call mma_deallocate(Scr2)
    call mma_deallocate(Scr1)
    call mma_deallocate(Fnl)
    call mma_deallocate(Kern)
  end do
end do

call mma_deallocate(PCoor)
call mma_deallocate(Kappa)
call mma_deallocate(ZI)
call mma_deallocate(Zeta)

return

end subroutine Drv2_RF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Nrmlz(Exp,nPrim,Coeff,nCntrc,iAng)
      Implicit Real*8 (A-H,O-Z)
#include "stdalloc.fh"
      Real*8 Exp(nPrim), Coeff(nPrim,nCntrc)
      Real*8, Dimension(:), Allocatable :: Scrt1, Scrt2
*
      If (nPrim*nCntrc.eq.0) Return
*
      nScrt1=nPrim**2
      nScrt2=nPrim*nCntrc
      Call mma_allocate(Scrt1,nScrt1)
      Call mma_allocate(Scrt2,nScrt2)
      Call Nrmlz_Internal(Exp,nPrim,Coeff,nCntrc,Scrt1,nScrt1,
     &                                           Scrt2,nScrt2,iAng)
      Call mma_deallocate(Scrt2)
      Call mma_deallocate(Scrt1)
*
*
      Return
      End
      SubRoutine Nrmlz_Internal(Exp,nPrim,Coeff,nCntrc,
     &                          Scrt1,nScrt1,Scrt2,nScrt2,iAng)
************************************************************************
*                                                                      *
* Object: normalize the contraction coefficients with respect to the   *
*         radial overlap.                                              *
*                                                                      *
* Called from: Input                                                   *
*                                                                      *
* Calling    : RecPrt                                                  *
*              DGEMM_  (ESSL)                                          *
*              DnDot   (ESSL)                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 Exp(nPrim), Coeff(nPrim,nCntrc), Scrt1(nScrt1),
     &       Scrt2(nScrt2)
#include "real.fh"
*
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*) ' In Nrmlz: iAng=',iAng
      Call RecPrt(' In Nrmlz: Coefficients',' ',Coeff,nPrim,nCntrc)
      Call RecPrt(' In Nrmlz: Exponents',' ',Exp,nPrim,1)
#endif
*
*     Normalize the coefficients (only radial normalization)
*
*     Compute overlap for all primitives of this shell.
*     This formula includes the normalization constant for each
*     primitive as well as the overlap factor of between the primitives.
*     Hence, the overlap matrix elements correspond to those of the
*     normalized primitive gaussian functions.
*
      Do 200 iExp = 1, nPrim
         Do 210 jExp = 1, iExp-1
            Pro_ij = Sqrt(Exp(iExp)*Exp(jExp))
            Sum_ij = (Exp(iExp)+Exp(jExp))/Two
            Power  = Dble(iAng) + OneHalf
            Temp   = (Pro_ij/Sum_ij)**Power
            Scrt1(nPrim*(iExp-1)+jExp)=Temp
            Scrt1(nPrim*(jExp-1)+iExp)=Temp
210      Continue
         Scrt1(nPrim*(iExp-1)+iExp)=One
200   Continue
*     Contract right side
      Call DGEMM_('N','N',
     &            nPrim,nCntrc,nPrim,
     &            1.0d0,Scrt1,nPrim,
     &            Coeff,nPrim,
     &            0.0d0,Scrt2,nPrim)
#ifdef _DEBUGPRINT_
      Call RecPrt(' Overlap primitives',' ',Scrt1,nPrim,nPrim)
      Call RecPrt(' Overlap PrimCon',' ',Scrt2,nPrim,nCntrc)
#endif
*
*     Compute the overlap for each contracted basis function, <i|i>
*
      Call DnDot(nCntrc,nPrim,Scrt1,1,1,Scrt2,1,nPrim,Coeff,1,nPrim)
#ifdef _DEBUGPRINT_
      Call RecPrt(' Overlap Contracted',' ',Scrt1,nCntrc,1)
#endif
*
*     Normalize coefficients, i.e. combine the normalization factor
*     of the primitive and the overlap of the unnormalized contracted
*     basis function.

      Do 300 i = 1, nCntrc
         If ( Abs(Scrt1(i)).lt.1.0D-12 ) then
            Call WarningMessage(2,
     &                  '; Error in contraction matrix, zero column'
     &                //'; ; Abend in subroutine NRMLZ')
            Call Abend()
         End If
300   Continue
*
      Rtemp=0.5D0*DBLE(iAng) + 0.75D0
      Qtemp=2.0D0**(iAng+1) * Sqrt(2.0D0) * TwoP34
      Do i = 1, nCntrc
         vRR= Scrt1(i)**(-0.5d0)
         Do j = 1, nPrim
            vR2=Exp(j)**Rtemp
            Coeff(j,i) = Coeff(j,i)*Qtemp*vRR*vR2
         End Do
      End Do
      If (nPrim.eq.1 .and. nCntrc.eq.1 .and. Exp(1).eq.Zero) Then
         Coeff(1,1)=One
      End If
#ifdef _DEBUGPRINT_
      Call Recprt(' In Nrmlz: Normalized coefficients',' ',
     &            Coeff,nPrim,nCntrc)
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ICOPY(n,x,incX,y,incY)
************************************************************************
*                                                                      *
*     Copy vector X into vector Y                                      *
*                                                                      *
*     calling arguments:                                               *
*     N       : Integer, input.                                        *
*               Number of input elements.                              *
*     X       : Array of Integer, input.                               *
*               Input vector, X.                                       *
*     incX    : Integer, input.                                        *
*               Stride of vector X.                                    *
*     Y       : Array of Integer, output.                              *
*               Output vector, Y.                                      *
*     incY    : Integer, input.                                        *
*               Stride of vector Y.                                    *
*                                                                      *
************************************************************************
c
      Implicit Integer (A-Z)
c
c     copies integer vector, x, to integer vector, y.
c     uses unrolled loops for increments equal to one.
c
      integer x(*),y(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        y(iy) = x(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,7)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        y(i) = x(i)
   30 continue
      if( n .lt. 7 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,7
        y(i) = x(i)
        y(i + 1) = x(i + 1)
        y(i + 2) = x(i + 2)
        y(i + 3) = x(i + 3)
        y(i + 4) = x(i + 4)
        y(i + 5) = x(i + 5)
        y(i + 6) = x(i + 6)
   50 continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine get_dkoperators(i,string,carray)
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      character*(*) string
      character carray(*)
*
      call get_dkoperators_internal(carray)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine get_dkoperators_internal(carray)
      use iso_c_binding
      character, target :: carray(*)
      integer, pointer :: iarray(:)
      call c_f_pointer(c_loc(carray(1)),iarray,[1])
      call get_dkoperators_i(i,string,iarray)
      nullify(iarray)
      return
      end subroutine get_dkoperators_internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Niclas Forsberg                                  *
!***********************************************************************

!module OptMod

!  Contains:
!    PotFit       (ipow,var,yin,coef,x,energy,Hess,D3,D4,trfName,stand_dev,max_err,find_minimum)
!    Optimize     (ipow,var,coef,x,energy,Hess,D3,D4)
!    var_to_qvar  (var,qvar,ref,qref,alpha,trfName)
!    x_to_qvar    (x,ref,qref,alpha,trfName)
!    qvar_to_var  (var,x,grad,Hess,D3,D4,ref,qref,trfName,alpha)
!    funcval      (x,coef,ipow) Result(sum)
!    gradient     (x,coef,ipow) Result(grad)
!    Hessian      (x,coef,ipow) Result(Hess)
!    thirdDer     (x,coef,ipow) Result(D3)
!    fourthDer    (x,coef,ipow) Result(D4)
!    ShiftHess    (Hess,shift)
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

!contains

subroutine PotFit(nterm,nvar,ndata,ipow,var,yin,coef,x,nOsc,energy,grad,Hess,D3,D4,trfName,stand_dev,max_err,find_minimum, &
                  max_term,use_weight,l_Hess_1,l_Hess_2,l_D)
!  Purpose:
!    Fit polynomial to data and then depending upun the variable
!    find_minimum, we either calculate the energy, gradient, Hessian,
!    and qubic and quartic force constants in x or we optimize the
!    structure before we perform the calculations.
!
!  Input:
!    ipow         : Two dimensional integer array - terms in polynomial.
!    var          : Real two dimensional array - coordinates for which we know the energy.
!    yin          : Real array - energy in points given in var.
!    trfName      : Character array - transformation associated with each internal coordinate.
!    find_minimum : Logical variable - whether or not to optimize structure.
!    max_term     : Integer - highest power if term in polynomial fit.
!    use_weight   : Logical variable - whether or not to use weights to make the minimum more important in the fit.
!
!  Output:
!    coef         : Real two dimensional array - coefficients for each term specified by ipow.
!    x            : Real array - geometry in internal coordinates.
!    energy       : Real - energy in minimum.
!    Hess         : Real two dimensional array - Hessian in minimum.
!    D3           : Real three dimensional array - cubic force constants.
!    D4           : Real four dimensional array - quartic force constants.
!    stand_dev    : Real variable - standard deviation of fitted values in Subroutine PolFit.
!    max_err      : Real variable - maximum error of fitted values in Subroutine PolFit.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use RandomMod, only: Ranmar, Rmarin
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nterm, nvar, iPow(nterm,nvar), ndata, nOsc, max_term, l_Hess_1, l_Hess_2, l_D
real(kind=wp), intent(in) :: var(ndata,nvar), yin(ndata)
real(kind=wp), intent(out) :: coef(nterm,1), x(nosc), energy, grad(nosc), Hess(l_Hess_1,l_Hess_2), D3(l_D,l_D,l_D), &
                              D4(l_D,l_D,l_D,l_D), stand_dev, max_err
character(len=80), intent(in) :: trfName(nvar)
logical(kind=iwp), intent(in) :: find_minimum, use_weight
integer(kind=iwp) :: ifit, iPoints, iRandNum, istart, istop, ivar, ivarMax, length, nPoints
real(kind=wp) :: alphaMax, stand_dev_best
logical(kind=iwp) :: fit_alpha
character(len=32) :: Inline, trfcode
real(kind=wp), allocatable :: alpha(:), alpha0(:), alphaRad(:), alphaStart(:), alphaStop(:), alphaTemp(:), diff_vec(:), qref(:), &
                              qvar(:,:), RandVec(:), ref(:)

! Initialize.
coef(:,:) = Zero
call mma_allocate(qvar,ndata,nvar,label='qvar')
call mma_allocate(ref,nvar,label='ref')
call mma_allocate(qref,nvar,label='qref')

! Check if a fit of alpha is wanted.
fit_alpha = .false.
call mma_allocate(alphaStart,nvar,label='alphaStart')
call mma_allocate(alphaStop,nvar,label='alphaStop')
call mma_allocate(alpha,nvar,label='alpha')
call mma_allocate(alpha0,nvar,label='alpha')
call mma_allocate(alphaTemp,nvar,label='alpha')
call mma_allocate(alphaRad,nvar,label='alpha')
alphaStart(:) = -One
alphaStop(:) = -One
do ivar=1,nvar
  trfcode = trfName(ivar)(1:32)
  ifit = index(trfcode,'FIT')
  if (ifit > 0) then
    fit_alpha = .true.
    Inline = trfName(ivar)(1:32)
    istart = index(Inline,'ALPHA=')
    istart = istart+6
    Inline = trfCode(istart:len(trfCode))
    istop = len(Inline)
    read(Inline(1:istop),*) alphaStart(ivar),alphaStop(ivar)
    alphaRad(ivar) = (alphaStop(ivar)-alphaStart(ivar))*Half
    alpha0(ivar) = alphaStart(ivar)+alphaRad(ivar)
  end if
end do

call mma_allocate(diff_vec,ndata,label='diff_vec')

if (fit_alpha) then

  ! Determine which alpha radius is the largest.
  alphaMax = alphaRad(1)
  ivarMax = 1
  do ivar=2,nvar
    if (alphaRad(ivar) > alphaMax) then
      alphaMax = alphaRad(ivar)
      ivarMax = ivar
    end if
  end do

  ! Initialize random number calculation.
  nPoints = 20000
  call RmarIn(1802,9373)

  ! Start with the (nRandom+1)'th set of random numbers.
  !nRandom = 4
  !do i=1,nRandom
  !  call Ranmar(temp,2)
  !end do

  ! Store nPoints random numbers in vector RandVec.
  length = nvar*nPoints
  call mma_allocate(RandVec,length,label='RandVec')

  call Ranmar(RandVec,length)

  ! Simulated annealing.
  stand_dev_best = 100.0_wp
  iRandNum = 1
  do while (alphaRad(ivarMax) > 0.1_wp)
    alphaTemp(:) = alpha0
    do iPoints=1,1000
      do ivar=1,nvar
        if (alphaStart(ivar) > Zero) then
          alpha(ivar) = alpha0(ivar)+alphaRad(ivar)*(Two*RandVec(iRandNum+ivar-1)-One)
        end if
      end do
      iRandNum = iRandNum+nvar
      call var_to_qvar(var,qvar,ref,qref,alpha,trfName,ndata,nvar)
      call PolFit(ipow,nvar,qvar,yin,ndata,coef,nterm,stand_dev,max_err,diff_vec,use_weight)
      if (stand_dev < stand_dev_best) then
        stand_dev_best = stand_dev
        alphaTemp(:) = alpha
      end if
    end do
    alpha0(:) = alphaTemp
    write(u6,*) alpha0(:),stand_dev_best
    alphaRad(:) = alphaRad*Half
  end do
  alpha(:) = alpha0
  write(u6,*) alpha(1),alpha(2)
  call mma_deallocate(RandVec)

end if

call mma_deallocate(alphaStart)
call mma_deallocate(alphaStop)
call mma_deallocate(alpha0)
call mma_deallocate(alphaTemp)
call mma_deallocate(alphaRad)

! Transform coordinates to get better numerical fit.
call var_to_qvar(var,qvar,ref,qref,alpha,trfName,ndata,nvar)

! Fit polynomial to energies.
call PolFit(ipow,nvar,qvar,yin,ndata,coef,nterm,stand_dev,max_err,diff_vec,use_weight)

!write(u6,*) ndata

!do i=1,ndata
!  write(u6,'(4f15.8,es15.6)') (var(i,j),j=1,nvar),yin(i),diff_vec(i)
!end do

call mma_deallocate(diff_vec)

if (find_minimum) then
  call Optimize(ipow,qvar,coef,x,energy,Hess,nterm,nvar,ndata)
else
  call x_to_qvar(x,ref,qref,alpha,trfName,nvar)
end if

! Calculate gradient and quadratic, cubic and quartic force constants.
call funcval(x,coef,ipow,energy,nterm,nvar)
call gradient(x,coef,ipow,grad,nterm,nvar)
call Hessian(x,coef,ipow,Hess,nterm,nvar)
if (max_term > 2) then
  call thirdDer(x,coef,ipow,D3,nterm,nvar)
else
  D3(:,:,:) = Zero
end if
if (max_term > 3) then
  call fourthDer(x,coef,ipow,D4,nterm,nvar)
else
  D4(:,:,:,:) = Zero
end if

! Transform back to original coordinates.
call qvar_to_var(x,grad,Hess,D3,D4,ref,qref,trfName,alpha,nvar)

call mma_deallocate(alpha)
call mma_deallocate(qvar)
call mma_deallocate(ref)
call mma_deallocate(qref)

end subroutine PotFit

subroutine Optimize(ipow,var,coef,x,energy,Hess,nterm,nvar,ndata)
!  Purpose:
!    Optimize structure given the polynomial fit from PolFit.
!
!  Input:
!    ipow      : Two dimensional integer array - terms in polynomial.
!    var       : Real two dimensional array - coordinates for which we know the energy.
!    coef      : Real two dimensional array - coefficients for each term specified by ipow.
!
!  Output:
!    x         : Real array - geometry in minimum.
!    energy    : Real - energy in minimum.
!    Hess      : Real two dimensional array - Hessian in minimum.
!
!  Calls:
!    Dool_MULA
!    funcval
!    gradient
!    Hessian
!    ShiftHess
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nterm, nvar, ipow(nterm,nvar), ndata
real(kind=wp), intent(in) :: var(ndata,nvar), coef(nterm,1)
real(kind=wp), intent(out) :: x(nvar), energy, Hess(nterm,nvar)
integer(kind=iwp) :: i, iseed, iter, iterm, iv, ivar, j
real(kind=wp) :: delta_norm, det, fval, rand_number, rscale, rsum
logical(kind=iwp) :: shift
real(kind=wp), allocatable :: delta(:,:), grad(:), var_intervals(:,:), xmin(:)
integer(kind=iwp), parameter :: maxiter = 100
real(kind=wp), parameter :: delta_max = One
real(kind=r8), external :: Random_Molcas

! Initialize.

call mma_allocate(var_intervals,nvar,2,label='var_intervals')
call mma_allocate(grad,nvar,label='grad')
call mma_allocate(delta,nvar,1,label='delta')
call mma_allocate(xmin,nvar,label='xmin')

! Determine intervals for random starting point in optimization.
var_intervals(:,1) = var(1,:)
var_intervals(:,2) = var(1,:)
do ivar=1,nvar
  do iterm=2,nterm
    if (var(iterm,ivar) < var_intervals(ivar,1)) then
      var_intervals(ivar,1) = var(iterm,ivar)
    else if (var(iterm,ivar) > var_intervals(ivar,2)) then
      var_intervals(ivar,2) = var(iterm,ivar)
    end if
  end do
end do

! Optimize using Newton-Raphson.
iseed = 12345
energy = 1.0e3_wp
!call Srand(Half)
do i=1,1
  do j=1,nvar
    !rand_number = rand()
    ! Random_molcas takes an integer seed 0 < iseed < 2**31
    ! and produces a pseudorandom number 0 < z < 1.0
    rand_number = Random_molcas(iseed)
    iseed = nint(rand_number*Two**31)
    x(j) = var_intervals(j,1)+(var_intervals(j,2)-var_intervals(j,1))*rand_number
  end do
  call gradient(x,coef,ipow,grad,nterm,nvar)
  call Hessian(x,coef,ipow,Hess,nterm,nvar)
  call ShiftHess(Hess,shift,nterm,nvar)
  delta(:,1) = -grad
  call Dool_MULA(Hess,nterm,nvar,delta,nvar,1,det)
  !call calcNorm(delta(:,1),delta_norm)
  rsum = Zero
  do iv=1,nvar
    rsum = rsum+delta(iv,1)**2
  end do
  delta_norm = sqrt(rsum)

  rscale = One
  if (delta_norm > delta_max) rscale = delta_max/delta_norm
  x(:) = x(:)+delta(:,1)*rscale
  iter = 0
  do while ((delta_norm > 1.0e-12_wp) .and. (iter <= maxiter))
    iter = iter+1
    call gradient(x,coef,ipow,grad,nterm,nvar)
    call Hessian(x,coef,ipow,Hess,nterm,nvar)
    call ShiftHess(Hess,shift,nterm,nvar)
    delta(:,1) = -grad
    call Dool_MULA(Hess,nterm,nvar,delta,nvar,1,det)
    !call calcNorm(delta(:,1),delta_norm)
    rsum = Zero
    do iv=1,nvar
      rsum = rsum+delta(iv,1)**2
    end do
    delta_norm = sqrt(rsum)

    rscale = One
    if (delta_norm > delta_max) rscale = delta_max/delta_norm
    x(:) = x(:)+delta(:,1)*rscale
  end do
  if (iter >= maxiter) write(u6,*) 'WARNING!! No convergence in Optimize'
  call funcval(x,coef,ipow,fval,nterm,nvar)
  if (fval < energy) then
    energy = fval
    xmin(:) = x
  end if
end do
x(:) = xmin

call mma_deallocate(var_intervals)
call mma_deallocate(grad)
call mma_deallocate(delta)
call mma_deallocate(xmin)

end subroutine Optimize

subroutine var_to_qvar(var,qvar,ref,qref,alpha,trfName,ndata,nvar)
!  Purpose:
!    Transform coordinates given in input using tranformation specified in input.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndata, nvar
real(kind=wp), intent(in) :: var(ndata,nvar)
real(kind=wp), intent(out) :: qvar(ndata,nvar), ref(nvar), qref(nvar)
real(kind=wp), intent(inout) :: alpha(nvar)
character(len=80), intent(in) :: trfName(nvar)
integer(kind=iwp) :: ia, ic, id, idata, ie, ifit, ir, is, istart, istop, ivar, ix
real(kind=wp) :: angsc, rsum, v
character(len=32) :: Inline, trfCode
real(kind=wp), allocatable :: par(:,:)

call mma_allocate(par,ndata,nvar,label='par')

do ivar=1,nvar
  trfcode = trfName(ivar)(1:32)
  ix = index(trfcode,'AS IT IS')
  ia = index(trfcode,'-AVG')
  ie = index(trfcode,'EXP')
  ir = index(trfcode,'RAD')
  id = index(trfcode,'DEG')
  ic = index(trfcode,'COS')
  is = index(trfcode,'SIN')
  angsc = One
  if (ir > 0) angsc = One
  if (id > 0) angsc = deg2rad
  do idata=1,ndata
    v = var(idata,ivar)
    if (ic > 0) then
      par(idata,ivar) = cos(angsc*v)
    else if (is > 0) then
      par(idata,ivar) = sin(angsc*v)
    else if ((ix > 0) .or. (ie > 0)) then
      par(idata,ivar) = v
    else
      write(u6,*) ' TRFCODE ERROR.'
      call abend()
    end if
  end do
  ! Calculate refrence value.
  rsum = Zero
  do idata=1,ndata
    rsum = rsum+var(idata,ivar)
  end do
  ref(ivar) = rsum/ndata
  if (ic > 0) then
    ref(ivar) = cos(angsc*ref(ivar))
  else if (is > 0) then
    ref(ivar) = sin(angsc*ref(ivar))
  end if

  ! Subtract reference value if requested.
  if (ia > 0) then
    do idata=1,ndata
      v = par(idata,ivar)
      if ((ic > 0) .or. (is > 0)) then
        par(idata,ivar) = ref(ivar)-v
      else
        par(idata,ivar) = v-ref(ivar)
      end if
    end do
  end if
end do

! Transform coordinates.
do ivar=1,nvar
  trfcode = trfName(ivar)(1:32)
  ie = index(trfcode,'EXP')
  ifit = index(trfcode,'FIT')
  if ((ie > 0) .and. (ifit == 0)) then
    Inline = trfName(ivar)(1:32)
    istart = index(Inline,'ALPHA=')
    istart = istart+6
    Inline = trfCode(istart:len(trfCode))
    istop = index(Inline,' ')
    istop = istop-1
    read(Inline(1:istop),*) alpha(ivar)
  end if
  do idata=1,ndata
    if (ie > 0) then
      qvar(idata,ivar) = One-exp(-alpha(ivar)*par(idata,ivar))
    else
      qvar(idata,ivar) = par(idata,ivar)
    end if
  end do
end do

call mma_deallocate(par)

! Calculate reference value of transformed coordinates.
do ivar=1,nvar
  rsum = Zero
  do idata=1,ndata
    rsum = rsum+qvar(idata,ivar)
  end do
  qref(ivar) = rsum/ndata
end do

! Subtract reference value from transformed coordinates.
do ivar=1,nvar
  do idata=1,ndata
    qvar(idata,ivar) = qvar(idata,ivar)-qref(ivar)
  end do
end do

end subroutine var_to_qvar

subroutine x_to_qvar(x,ref,qref,alpha,trfName,nDimX)
!  Purpose:
!    Transform the coordinates of a given point.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDimX
real(kind=wp), intent(inout) :: x(nDimX), alpha(nDimx)
real(kind=wp), intent(in) :: ref(nDimX), qref(nDimX)
character(len=80), intent(in) :: trfName(nDimX)
integer(kind=iwp) :: ia, ic, ie, is, istart, istop, ivar
real(kind=wp) :: v
character(len=32) :: Inline, trfCode
real(kind=wp), allocatable :: par(:)

call mma_allocate(par,nDimX,label='par')

do ivar=1,nDimX
  trfcode = trfName(ivar)(1:32)
  ia = index(trfcode,'-AVG')
  ic = index(trfcode,'COS')
  is = index(trfcode,'SIN')
  if (ic > 0) then
    par(ivar) = cos(x(ivar))
  else if (is > 0) then
    par(ivar) = sin(x(ivar))
  else
    par(ivar) = x(ivar)
  end if
  if (ia > 0) then
    v = par(ivar)
    if ((ic > 0) .or. (is > 0)) then
      par(ivar) = ref(ivar)-v
    else
      par(ivar) = v-ref(ivar)
    end if
  end if
end do

! Transform coordinates.
do ivar=1,nDimX
  trfcode = trfName(ivar)(1:32)
  ie = index(trfcode,'EXP')
  if (ie > 0) then
    Inline = trfName(ivar)(1:32)
    istart = index(Inline,'ALPHA=')
    istart = istart+6
    Inline = trfCode(istart:len(trfCode))
    istop = index(Inline,' ')
    istop = istop-1
    read(Inline(1:istop),*) alpha(ivar)
  end if
  if (ie > 0) then
    x(ivar) = One-exp(-alpha(ivar)*par(ivar))
  else
    x(ivar) = par(ivar)
  end if
end do

call mma_deallocate(par)

! Subtract reference value from transformed coordinates.
do ivar=1,nDimX
  x(ivar) = x(ivar)-qref(ivar)
end do

end subroutine x_to_qvar

subroutine qvar_to_var(x,grad,Hess,D3,D4,ref,qref,trfName,alpha,nvar)
!  Purpose:
!    Tranform coordinates, gradient, Hessian, third derivatives and
!    fourth derivates back to the coordinates originally specified.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Four, Six
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nvar
real(kind=wp), intent(inout) :: x(nvar), grad(nvar), Hess(nvar,nvar), D3(nvar,nvar,nvar), D4(nvar,nvar,nvar,nvar)
real(kind=wp), intent(in) :: ref(nvar), qref(nvar), alpha(nvar)
character(len=80), intent(in) :: trfName(nvar)
integer(kind=iwp) :: i, ia, ic, ie, is, ivar, ix, j, k, l
character(len=32) :: trfCode
logical(kind=iwp) :: ijEq, jkEq, klEq
real(kind=wp), allocatable :: D3trans(:,:,:), D4trans(:,:,:,:), q(:), s(:), t(:), Temp(:,:), tempgrad(:), u(:), v(:)

call mma_allocate(s,nvar,label='s')
call mma_allocate(t,nvar,label='t')
call mma_allocate(u,nvar,label='u')
call mma_allocate(v,nvar,label='v')
call mma_allocate(q,nvar,label='q')
call mma_allocate(tempgrad,nvar,label='tempgrad')
call mma_allocate(Temp,nvar,nvar,label='Temp')
call mma_allocate(D3trans,nvar,nvar,nvar,label='D3trans')
call mma_allocate(D4trans,nvar,nvar,nvar,nvar,label='D4trans')

x(:) = x+qref
do ivar=1,nvar
  trfcode = trfName(ivar)(1:32)
  ix = index(trfcode,'AS IT IS')
  ia = index(trfcode,'-AVG')
  ie = index(trfcode,'EXP')
  ic = index(trfcode,'COS')
  is = index(trfcode,'SIN')
  if (ic > 0) then
    if (ia > 0) then
      x(ivar) = x(ivar)-ref(ivar)
    end if
    q(ivar) = acos(-x(ivar))
    t(ivar) = sin(q(ivar))
    u(ivar) = cos(q(ivar))
    v(ivar) = -sin(q(ivar))
    s(ivar) = -cos(q(ivar))
  else if (is > 0) then
    if (ia > 0) then
      x(ivar) = x(ivar)-ref(ivar)
    end if
    q(ivar) = asin(-x(ivar))
    t(ivar) = -cos(q(ivar))
    u(ivar) = sin(q(ivar))
    v(ivar) = cos(q(ivar))
    s(ivar) = -sin(q(ivar))
  else if (ie > 0) then
    q(ivar) = -log(One-x(ivar))/alpha(ivar)
    t(ivar) = alpha(ivar)*(One-x(ivar))
    u(ivar) = -alpha(ivar)**2*(One-x(ivar))
    v(ivar) = alpha(ivar)**3*(One-x(ivar))
    s(ivar) = -alpha(ivar)**4*(One-x(ivar))
    if (ia > 0) then
      q(ivar) = q(ivar)+ref(ivar)
    end if
  else if (ix > 0) then
    if (ia > 0) then
      x(ivar) = x(ivar)+ref(ivar)
    end if
    q(ivar) = x(ivar)
    t(ivar) = One
    u(ivar) = Zero
    v(ivar) = Zero
    s(ivar) = Zero
  else
    write(u6,*) ' TRFCODE ERROR.'
    call abend()
  end if
end do

! Transform gradient.
do i=1,nvar
  tempgrad(i) = t(i)*grad(i)
end do

! Transform Hessian.
do i=1,nvar
  do j=i,nvar
    if (i == j) then
      Temp(i,i) = t(i)**2*Hess(i,i)+u(i)*grad(i)
    else
      Temp(i,j) = t(i)*t(j)*Hess(i,j)
    end if
  end do
end do
do i=1,nvar
  do j=i,nvar
    Temp(j,i) = Temp(i,j)
  end do
end do

! Transform third derivatives.
do i=1,nvar
  do j=i,nvar
    ijEq = (i == j)
    do k=j,nvar
      jkEq = (j == k)
      if (ijEq .and. jkEq) then
        D3trans(i,i,i) = t(i)*t(i)*t(i)*D3(i,i,i)+Three*u(i)*t(i)*Hess(i,i)+v(i)*grad(i)
      else if (ijEq .and. (.not. jkEq)) then
        D3trans(i,i,k) = t(i)*t(i)*t(k)*D3(i,i,k)+u(i)*t(k)*Hess(i,k)
      else if ((.not. ijEq) .and. jkEq) then
        D3trans(i,j,j) = t(i)*t(j)*t(j)*D3(i,j,j)+t(i)*u(j)*Hess(i,j)
      else if ((.not. ijEq) .and. (.not. jkEq)) then
        D3trans(i,j,k) = t(i)*t(j)*t(k)*D3(i,j,k)
      end if
    end do
  end do
end do
do i=1,nvar
  do j=i,nvar
    do k=j,nvar
      D3trans(i,k,j) = D3trans(i,j,k)
      D3trans(j,i,k) = D3trans(i,j,k)
      D3trans(j,k,i) = D3trans(i,j,k)
      D3trans(k,i,j) = D3trans(i,j,k)
      D3trans(k,j,i) = D3trans(i,j,k)
    end do
  end do
end do

! Transform fourth derivatives.
do i=1,nvar
  do j=i,nvar
    ijEq = (i == j)
    do k=j,nvar
      jkEq = (j == k)
      do l=k,nvar
        klEq = (k == l)
        if (ijEq .and. jkEq .and. klEq) then
          D4trans(i,i,i,i) = t(i)**4*D4(i,i,i,i)+Six*u(i)*t(i)**2*D3(i,i,i)+Four*v(i)*t(i)*Hess(i,i)+Three*u(i)*u(i)*Hess(i,i)+ &
                             s(i)*grad(i)
        else if (ijEq .and. jkEq .and. (.not. klEq)) then
          D4trans(i,i,i,l) = (t(i)*t(i)*t(i)*D4(i,i,i,l)+Three*u(i)*t(i)*D3(i,i,l)+v(i)*Hess(i,l))*t(l)
        else if ((.not. ijEq) .and. jkEq .and. klEq) then
          D4trans(i,j,j,j) = t(i)*(t(j)*t(j)*t(j)*D4(i,j,j,j)+Three*u(j)*t(j)*D3(i,j,j)+v(j)*Hess(i,j))
        else if ((.not. ijEq) .and. jkEq .and. (.not. klEq)) then
          D4trans(i,j,j,l) = t(i)*(t(j)*t(j)*D4(i,j,j,l)+u(j)*D3(i,j,l))*t(l)
        else if (ijEq .and. (.not. jkEq) .and. (.not. klEq)) then
          D4trans(i,i,k,l) = (t(i)*t(i)*D4(i,i,k,l)+u(i)*D3(i,k,l))*t(k)*t(l)
        else if ((.not. ijEq) .and. (.not. jkEq) .and. klEq) then
          D4trans(i,j,k,k) = (t(k)*t(k)*D4(i,j,k,k)+u(k)*D3(i,j,k))*t(i)*t(j)
        else if (ijEq .and. klEq) then
          D4trans(i,i,k,k) = t(i)*t(i)*t(k)*t(k)*D4(i,i,k,k)+t(i)*t(i)*u(k)*D3(i,i,k)+u(i)*t(k)*t(k)*D3(i,k,k)+u(i)*u(k)*Hess(i,k)
        else if ((.not. ijEq) .and. (.not. jkEq) .and. (.not. klEq)) then
          D4trans(i,j,k,l) = t(i)*t(j)*t(k)*t(l)*D4(i,j,k,l)
        end if
      end do
    end do
  end do
end do
do i=1,nvar
  do j=i,nvar
    do k=j,nvar
      do l=k,nvar
        D4trans(i,k,j,l) = D4trans(i,j,k,l)
        D4trans(i,j,l,k) = D4trans(i,j,k,l)
        D4trans(i,l,k,j) = D4trans(i,j,k,l)
        D4trans(i,l,j,k) = D4trans(i,j,k,l)
        D4trans(i,k,l,j) = D4trans(i,j,k,l)

        D4trans(j,i,k,l) = D4trans(i,j,k,l)
        D4trans(j,k,i,l) = D4trans(i,j,k,l)
        D4trans(j,i,l,k) = D4trans(i,j,k,l)
        D4trans(j,l,k,i) = D4trans(i,j,k,l)
        D4trans(j,l,i,k) = D4trans(i,j,k,l)
        D4trans(j,k,l,i) = D4trans(i,j,k,l)

        D4trans(k,i,j,l) = D4trans(i,j,k,l)
        D4trans(k,j,i,l) = D4trans(i,j,k,l)
        D4trans(k,i,l,j) = D4trans(i,j,k,l)
        D4trans(k,l,j,i) = D4trans(i,j,k,l)
        D4trans(k,l,i,j) = D4trans(i,j,k,l)
        D4trans(k,j,l,i) = D4trans(i,j,k,l)

        D4trans(l,i,j,k) = D4trans(i,j,k,l)
        D4trans(l,j,i,k) = D4trans(i,j,k,l)
        D4trans(l,k,j,i) = D4trans(i,j,k,l)
        D4trans(l,i,k,j) = D4trans(i,j,k,l)
        D4trans(l,k,i,j) = D4trans(i,j,k,l)
        D4trans(l,j,k,i) = D4trans(i,j,k,l)
      end do
    end do
  end do
end do

! Assign transformed values.
x(:) = q
grad(:) = tempgrad

Hess(:,:) = Temp

D3(:,:,:) = D3trans

D4(:,:,:,:) = D4trans

call mma_deallocate(s)
call mma_deallocate(t)
call mma_deallocate(u)
call mma_deallocate(v)
call mma_deallocate(q)
call mma_deallocate(tempgrad)
call mma_deallocate(Temp)
call mma_deallocate(D3trans)
call mma_deallocate(D4trans)

end subroutine qvar_to_var

subroutine funcval(x,coef,ipow,fval,nterm,nvar)
!  Purpose:
!    Return function value at x.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nterm, nvar, ipow(nterm,nvar)
real(kind=wp), intent(in) :: x(nvar), coef(nterm)
real(kind=wp), intent(out) :: fval
integer(kind=iwp) :: iterm, ivar, nsum
real(kind=wp) :: prod, rsum

rsum = Zero
do iterm=1,nterm
  prod = One
  do ivar=1,nvar
    nsum = ipow(iterm,ivar)
    prod = prod*(x(ivar)**(nsum))
  end do
  rsum = rsum+coef(iterm)*prod
end do
fval = rsum

end subroutine funcval

subroutine gradient(x,coef,ipow,grad,nterm,nvar)
!  Purpose:
!    Return gradient at x.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nterm, nvar, ipow(nterm,nvar)
real(kind=wp), intent(in) :: x(nvar), coef(nvar)
real(kind=wp), intent(out) :: grad(nvar)
integer(kind=iwp) :: iterm, ivar, jvar, nder, nsum
real(kind=wp) :: prod, rfactor, rsum
logical(kind=iwp) :: ijEq

do ivar=1,nvar
  rsum = Zero
  do iterm=1,nterm
    prod = One
    do jvar=1,nvar
      ijEq = (ivar == jvar)
      if ((ipow(iterm,jvar) >= 1) .and. ijEq) then
        nder = 1
        nsum = ipow(iterm,jvar)-nder
      else if ((ipow(iterm,jvar) >= 0) .and. (.not. ijEq)) then
        nder = 0
        nsum = ipow(iterm,jvar)
      else
        nder = -1
        nsum = 0
      end if
      call factor(nsum,nder,rfactor)
      prod = prod*rfactor*(x(jvar)**(nsum))
    end do
    rsum = rsum+coef(iterm)*prod
  end do
  grad(ivar) = rsum
end do

end subroutine gradient

subroutine Hessian(x,coef,ipow,Hess,nterm,nvar)
!  Purpose:
!    Return Hessian at x.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nterm, nvar, ipow(nterm,nvar)
real(kind=wp), intent(in) :: x(nvar), coef(nvar)
real(kind=wp), intent(out) :: Hess(nvar,nvar)
integer(kind=iwp) :: iterm, ivar, jvar, kvar, nder, nsum
real(kind=wp) :: prod, rfactor, rsum
logical(kind=iwp) :: ijEq, ikEq, jkEq

do ivar=1,nvar
  do jvar=ivar,nvar
    ijEq = (ivar == jvar)
    rsum = Zero
    do iterm=1,nterm
      prod = One
      do kvar=1,nvar
        ikEq = (ivar == kvar)
        jkEq = (jvar == kvar)
        if ((ipow(iterm,kvar) >= 2) .and. ikEq .and. jkEq) then
          nder = 2
          nsum = ipow(iterm,kvar)-nder
        else if ((ipow(iterm,kvar) >= 1) .and. (ikEq .or. jkEq) .and. (.not. ijEq)) then
          nder = 1
          nsum = ipow(iterm,kvar)-nder
        else if ((ipow(iterm,kvar) >= 0) .and. (.not. ikEq) .and. (.not. jkEq)) then
          nder = 0
          nsum = ipow(iterm,kvar)
        else
          nder = -1
          nsum = 0
        end if
        call factor(nsum,nder,rfactor)
        prod = prod*rfactor*(x(kvar)**(nsum))
      end do
      rsum = rsum+coef(iterm)*prod
    end do
    Hess(ivar,jvar) = rsum
    Hess(jvar,ivar) = rsum
  end do
end do

end subroutine Hessian

subroutine thirdDer(x,coef,ipow,D3,nterm,nvar)
!  Purpose:
!    Return third derivatives at x.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nterm, nvar, ipow(nterm,nvar)
real(kind=wp), intent(in) :: x(nvar), coef(nvar)
real(kind=wp), intent(out) :: D3(nvar,nvar,nvar)
integer(kind=iwp) :: iterm, ivar, jvar, kvar, lvar, nder, nsum
real(kind=wp) :: prod, rfactor, rsum
logical(kind=iwp) :: ilEq, jlEq, klEq

D3(:,:,:) = Zero
do ivar=1,nvar
  do jvar=ivar,nvar
    do kvar=jvar,nvar
      rsum = Zero
      do iterm=1,nterm
        prod = One
        do lvar=1,nvar
          ilEq = (ivar == lvar)
          jlEq = (jvar == lvar)
          klEq = (kvar == lvar)
          if ((ipow(iterm,lvar) >= 3) .and. ilEq .and. jlEq .and. klEq) then
            nder = 3
            nsum = ipow(iterm,lvar)-nder
          else if ((ipow(iterm,lvar) >= 2) .and. ((ilEq .and. jlEq .and. (.not. klEq)) .or. &
                                                  (jlEq .and. klEq .and. (.not. ilEq)))) then
            nder = 2
            nsum = ipow(iterm,lvar)-nder
          else if ((ipow(iterm,lvar) >= 1) .and. ((ilEq .and. (.not. jlEq) .and. (.not. klEq)) .or. &
                                                  (jlEq .and. (.not. ilEq) .and. (.not. klEq)) .or. &
                                                  (klEq .and. (.not. ilEq) .and. (.not. jlEq)))) then
            nder = 1
            nsum = ipow(iterm,lvar)-nder
          else if ((ipow(iterm,lvar) >= 0) .and. (.not. ilEq) .and. (.not. jlEq) .and. (.not. klEq)) then
            nder = 0
            nsum = ipow(iterm,lvar)
          else
            nder = -1
            nsum = 0
          end if
          call factor(nsum,nder,rfactor)
          prod = prod*rfactor*(x(lvar)**(nsum))
        end do
        rsum = rsum+coef(iterm)*prod
      end do
      D3(ivar,jvar,kvar) = rsum
      D3(kvar,ivar,jvar) = rsum
      D3(jvar,kvar,ivar) = rsum
      D3(jvar,ivar,kvar) = rsum
      D3(kvar,jvar,ivar) = rsum
      D3(ivar,kvar,jvar) = rsum
    end do
  end do
end do

end subroutine thirdDer

subroutine fourthDer(x,coef,ipow,D4,nterm,nvar)
!  Purpose:
!    Return fourth derivatives at x.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nterm, nvar, ipow(nterm,nvar)
real(kind=wp), intent(in) :: x(nvar), coef(nvar)
real(kind=wp), intent(out) :: D4(nvar,nvar,nvar,nvar)
integer(kind=iwp) :: iterm, ivar, jvar, kvar, lvar, mvar, nder, nsum
real(kind=wp) :: prod, rfactor, rsum
logical(kind=iwp) :: imEq, jmEq, kmEq, lmEq

D4(:,:,:,:) = Zero
do ivar=1,nvar
  do jvar=ivar,nvar
    do kvar=jvar,nvar
      do lvar=kvar,nvar
        rsum = Zero
        do iterm=1,nterm
          prod = One
          do mvar=1,nvar
            imEq = (ivar == mvar)
            jmEq = (jvar == mvar)
            kmEq = (kvar == mvar)
            lmEq = (lvar == mvar)
            if ((ipow(iterm,mvar) >= 4) .and. imEq .and. jmEq .and. kmEq .and. lmEq) then
              nder = 4
              nsum = ipow(iterm,mvar)-nder
            else if ((ipow(iterm,mvar) >= 3) .and. ((imEq .and. jmEq .and. kmEq .and. (.not. lmEq)) .or. &
                                                    (jmEq .and. kmEq .and. lmEq .and. (.not. imEq)))) then
              nder = 3
              nsum = ipow(iterm,mvar)-nder
            else if ((ipow(iterm,mvar) >= 2) .and. ((imEq .and. jmEq .and. (.not. kmEq) .and. (.not. lmEq)) .or. &
                                                    (jmEq .and. kmEq .and. (.not. imEq) .and. (.not. lmEq)) .or. &
                                                    (kmEq .and. lmEq .and. (.not. imEq) .and. (.not. jmEq)))) then
              nder = 2
              nsum = ipow(iterm,mvar)-nder
            else if ((ipow(iterm,mvar) >= 1) .and. ((imEq .and. (.not. jmEq) .and. (.not. kmEq) .and. (.not. lmEq)) .or. &
                                                    (jmEq .and. (.not. imEq) .and. (.not. kmEq) .and. (.not. lmEq)) .or. &
                                                    (kmEq .and. (.not. imEq) .and. (.not. jmEq) .and. (.not. lmEq)) .or. &
                                                    (lmEq .and. (.not. imEq) .and. (.not. jmEq) .and. (.not. kmEq)))) then
              nder = 1
              nsum = ipow(iterm,mvar)-nder
            else if ((ipow(iterm,mvar) >= 0) .and. (.not. imEq) .and. (.not. jmEq) .and. (.not. kmEq) .and. (.not. lmEq)) then
              nder = 0
              nsum = ipow(iterm,mvar)
            else
              nder = -1
              nsum = 0
            end if
            call factor(nsum,nder,rfactor)
            prod = prod*rfactor*(x(mvar)**(nsum))
          end do
          rsum = rsum+coef(iterm)*prod
        end do
        D4(ivar,jvar,kvar,lvar) = rsum
        D4(ivar,kvar,jvar,lvar) = rsum
        D4(ivar,jvar,lvar,kvar) = rsum
        D4(ivar,lvar,kvar,jvar) = rsum
        D4(ivar,lvar,jvar,kvar) = rsum
        D4(ivar,kvar,lvar,jvar) = rsum

        D4(jvar,ivar,kvar,lvar) = rsum
        D4(jvar,kvar,ivar,lvar) = rsum
        D4(jvar,ivar,lvar,kvar) = rsum
        D4(jvar,lvar,kvar,ivar) = rsum
        D4(jvar,lvar,ivar,kvar) = rsum
        D4(jvar,kvar,lvar,ivar) = rsum

        D4(kvar,ivar,jvar,lvar) = rsum
        D4(kvar,jvar,ivar,lvar) = rsum
        D4(kvar,ivar,lvar,jvar) = rsum
        D4(kvar,lvar,jvar,ivar) = rsum
        D4(kvar,lvar,ivar,jvar) = rsum
        D4(kvar,jvar,lvar,ivar) = rsum

        D4(lvar,ivar,jvar,kvar) = rsum
        D4(lvar,jvar,ivar,kvar) = rsum
        D4(lvar,kvar,jvar,ivar) = rsum
        D4(lvar,ivar,kvar,jvar) = rsum
        D4(lvar,kvar,ivar,jvar) = rsum
        D4(lvar,jvar,kvar,ivar) = rsum
      end do
    end do
  end do
end do

end subroutine fourthDer

subroutine ShiftHess(Hess,shift,nDim,nDim2)
!  Purpose:
!    Shifts Hessian to make it positive definite.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, nDim2
real(kind=wp), intent(inout) :: Hess(nDim,nDim2)
logical(kind=iwp), intent(out) :: shift
integer(kind=iwp) :: i, j, k
real(kind=wp) :: eigen_min, eps
real(kind=wp), allocatable :: Hess_lowT(:), U(:,:)

call mma_allocate(U,nDim,nDim2,label='U')
call mma_allocate(Hess_lowT,nDim*(nDim+1)/2,label='Hess_lowT')

! Initialize.

k = 0
do i=1,nDim
  do j=1,i
    k = k+1
    Hess_lowT(k) = Hess(i,j)
  end do
end do
U(:,:) = Zero
do i=1,nDim
  U(i,i) = One
end do
call Jacob(Hess_lowT,U,nDim,nDim)
call Jacord(Hess_lowT,U,nDim,nDim)
eigen_min = Hess_lowT(1)
shift = eigen_min < Zero
if (shift) then
  eps = 2*eigen_min
  do i=1,nDim
    Hess(i,i) = Hess(i,i)-eps
  end do
end if
call mma_deallocate(U)
call mma_deallocate(Hess_lowT)

end subroutine ShiftHess

!end module OptMod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Cho_P_QualSwp()

      Implicit None
#include "cholesky.fh"
#include "choptr.fh"
#include "cholq.fh"

      Integer i, scr

C --- Swap nQual array  local <-> global
      Do i=1,nSym
         scr = nQual_L(i)
         nQual_L(i) = nQual(i)
         nQual(i) = scr
      End Do
c      Call iSwap(nSym,nQual,1,nQual_L,1)


C --- Swap pointer for iQuAB  local <-> global
      scr = ip_iQuAB_L
      ip_iQuAB_L = ip_iQuAB
      ip_iQuAB = scr

C --- Swap length for iQuAB   local <-> global
      scr = l_iQuAB_L
      l_iQuAB_L = l_iQuAB
      l_iQuAB = scr


      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************
!  iPrintLevel
!
!> @brief
!>   Check or set global print level
!> @author V. Veryazov
!>
!> @details
!> If Level is a number &ge; ``0``, set print level,
!> else return current print level.
!>
!> In a first call of the routine environment variable
!> ``MOLCAS_PRINT`` is used to set the initial print level.
!>
!> Allowed values are:
!>
!> - ``SILENT`` (``0``)
!> - ``TERSE`` (``1``)
!> - ``NORMAL`` (``2``)
!> - ``VERBOSE`` (``3``)
!> - ``DEBUG`` (``4``)
!> - ``INSANE`` (``5``)
!>
!> @param[in] Level Print Level
!>
!> @return Print level
!***********************************************************************

function iPrintLevel(Level)

use Definitions, only: iwp

implicit none
integer(kind=iwp) iPrintLevel
integer(kind=iwp), intent(in) :: Level
integer(kind=iwp), save :: isFirst = 0, nPrintLevel
character(len=80) :: Val

if (Level >= 0) then
  nPrintLevel = Level
  isFirst = 1
  iPrintLevel = Level
  return
end if
if (isFirst == 0) then
  call getenvf('MOLCAS_PRINT',Val)
  call UpCase(Val)
  select case (Val)
    case ('SILENT','0')
      nPrintLevel = 0
    case ('TERSE','1')
      nPrintLevel = 1
    case ('NORMAL','2')
      nPrintLevel = 2
    case ('VERBOSE','3')
      nPrintLevel = 3
    case ('DEBUG','4')
      nPrintLevel = 4
    case ('INSANE','5')
      nPrintLevel = 5
    case default
      nPrintLevel = 2
  end select
end if
iPrintLevel = nPrintLevel

return

end function iPrintLevel

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module DMRGInfo
! These are used for the MCLR part
! ndets_RGLR   : number of Slater determinants
! LRras2       : CI space when solving LR equation
! RGras2       : CI space when solving LR equation
! nstates_RGLR : number of states

use Definitions, only: iwp

implicit none
private

logical(kind=iwp) :: doDMRG, doMCLR

integer(kind=iwp) :: LRras2(8), MS2_RGLR, ndets_RGLR, nele_RGLR, nstates_RGLR, RGras2(8)

public :: DoDMRG, DoMCLR, LRras2, MS2_RGLR, ndets_RGLR, nele_RGLR, nstates_RGLR, RGras2

end module DMRGInfo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Martin Schuetz                                   *
!***********************************************************************

!#define _CHECK_
subroutine SOFSh1(nSkal,nSym,nSOs)
!***********************************************************************
! This Module contains subroutines which are used to compute info on   *
! the size of the SO integral symmetry blocks for direct integral      *
! transformation                                                       *
!                                                                      *
! SubRoutine SOFSh1                                                    *
!  -> compute (1) # SO functions in irrep for all shells iShell        *
!             (2) position of 1st component of shell in irrep for      *
!                 all shells in all irreps                             *
!             (3) map vector between shells and psedoshells for each   *
!                 irrep (not any shell contributes to all irreps)      *
!             (4) map vector between SO indices and shells             *
! relevant data is declared and passed in common "inftra.fh"           *
!----------------------------------------------------------------------*
!     written by:                                                      *
!     M. Schuetz                                                       *
!     University of Lund, Sweden, 1995                                 *
!***********************************************************************

use SOAO_Info, only: iAOtSO
use iSD_data, only: iCntr, iSD, iSh2Sh, iShOff, iSO2Sh, nShBf, nShBfMx, nShIrp
use Basis_Info, only: nBas, nBas_Aux
use BasisMode, only: Auxiliary_Mode, Basis_Mode
use stdalloc, only: mma_allocate
use Definitions, only: iwp
#if defined (_DEBUGPRINT_) || defined (_CHECK_)
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nSkal, nSym, nSOs
integer(kind=iwp) :: i, iAO, iCmp, iPtr, iRP, iSkal, iSO, iSOB, nShBfi, nShOff(0:7)

! Allocate all memory

call mma_allocate(nShBF,[0,nSym-1],[1,nSkal],Label='nShBF')
call mma_allocate(iShOff,[0,nSym-1],[1,nSkal],Label='iShOff')
call mma_allocate(iSh2Sh,[0,nSym-1],[1,nSkal],Label='iSh2Sh')
call mma_allocate(iSO2Sh,nSOs,Label='iSO2Sh')
call mma_allocate(iCntr,nSkal,Label='iCntr')

! Initialize
nShBF(:,:) = 0
iShOff(:,:) = 9999999
nShOff(:) = 1

do iSkal=1,nSkal
  iAO = iSD(7,iSkal)
  iCmp = iSD(2,iSkal)
  icntr(iSkal) = iSD(10,iSkal)

  ! loop over components of shell...

  do i=1,iCmp
    ! loop over irreps...
    do irp=0,nSym-1
      if (iAOtSO(iAO+i,irp) > 0) then
        nShBF(irp,iSkal) = nShBF(irp,iSkal)+iSD(3,iSkal)
#       ifdef _CHECK_
        if (Basis_Mode == Auxiliary_Mode) then
          iShOff(irp,iSkal) = min(iShOff(irp,iSkal),iAOtSO(iAO+i,irp)-nBas(irp))
        else
          iShOff(irp,iSkal) = min(iShOff(irp,iSkal),iAOtSO(iAO+i,irp))
        end if
#       endif
      end if
    end do
  end do
  do irp=0,nSym-1
#   ifdef _CHECK_
    if ((nShBF(irp,iskal) /= 0) .and. (nShOff(irp) /= iShOff(irp,iSkal))) then
      call WarningMessage(2,'PROGRAMMING ERROR IN SHELL_SIZES')
      write(u6,*) nShBF(irp,iskal)
      write(u6,*) nShOff(irp)
      write(u6,*) iShOff(irp,iSkal)
      write(u6,*) 'PROGRAMMING ERROR IN SHELL_SIZES: SHELLS NOT CONTIGUOUS. IRP=',irp,'  ISKAL=',iskal
      call Abend()
    end if
#   endif
    iShOff(irp,iSkal) = nShOff(irp)
    nShOff(irp) = nShOff(irp)+nShBF(irp,iSkal)
  end do
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'nShBF'
  write(u6,'(8I4)') iSkal,(nShBF(irp,iSkal),irp=0,nSym-1)
  write(u6,'(A)') 'iShOff'
  write(u6,'(8I4)') iSkal,(iShOff(irp,iSkal),irp=0,nSym-1)
# endif
end do

! and now set up SO-Shell and Shell-Psudoshell index vectors...

nShIrp(0:nSym-1) = 0
iSO2Sh(:) = -9999999
iSh2Sh(:,:) = -9999999

! Loop over irreps...

iptr = 0
nShBFMx = 0
do irp=0,nSym-1
  do iSkal=1,nSkal

    nShBFi = nShBF(irp,iSkal)
    nShBFMx = max(nShBFMx,nShBFi)
    iSOb = iShOff(irp,iSkal)
    do iSO=iSOb,iSOb+nShBFi-1
      if (iSO > nSOs) then
        call WarningMessage(2,' Fucked again!')
        call Quit_OnUserError()
      end if
      iSO2Sh(iptr+iSO) = iSkal
    end do

    if (nShBFi > 0) then
      nShIrp(irp) = nShIrp(irp)+1
      iSh2Sh(irp,iSkal) = nShIrp(irp)
    end if
  end do
  if (Basis_Mode == Auxiliary_Mode) then
    iptr = iptr+nBas_Aux(irp)
  else
    iptr = iptr+nBas(irp)
  end if
end do
#ifdef _DEBUGPRINT_
write(u6,'(A,I4)') 'max shell size:',nShBFMx
write(u6,'(A)') '# of shells contributing to each irrep:'
write(u6,'(8I4)') (nShIrp(irp),irp=0,nSym-1)
write(u6,'(A)') '# shell-psudoshell map vector:'
do irp=0,nSym-1
  write(u6,'(A4,2X,I4,2X,A4,2X,8I4)') 'irp=',irp,'map:',(iSh2Sh(irp,iSkal),iSkal=1,nSkal)
end do
write(u6,'(A)') 'SO-index to shell map vector:'
write(u6,'(50I4)') (iSO2Sh(iSO),iSO=1,nSOs)
#endif
return

end subroutine SOFSh1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SGMOP(IMODE,IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,COEFF,SGM,PSI)
! Purpose: Add to the wave function SGM the result of applying
! an operator to PSI. The operator is a sum of creators (IMODE=1)
! or annihilators (IMODE=-1) multiplied by coefficients. Only the
! sector of SGM described by IFSBTAB1 will be updated.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IMODE, IORBTAB(*), ISSTAB(*), IFSBTAB1(*), IFSBTAB2(*)
real(kind=wp), intent(in) :: COEFF(*), PSI(*)
real(kind=wp), intent(inout) :: SGM(*)
integer(kind=iwp) :: I, IBLKPOS1, IBLKPOS2, IERR, IFSB1, IFSB2, IPH, IPHARR(50), IPOS1, IPOS2, ISBS1, ISBS2, ISORB, ISPART, ISST, &
                     ISST1, ISST2, ISSTARR(50), ISUM, J, KHSH2, KOINFO, KPOS, KSBS1, KSBS2, KSBSAN, KSBSCR, KSBSOP, KSORB, KSSTAN, &
                     KSSTCR, KSSTOP, KSSTTB, KSTARR1, KSTARR2, MORSBITS, NASORB, NASPRT, NDETS1, NDETS2, NDI, NDIARR(50), NDJ, &
                     NDJARR(50), NFSB1, NHSH2, NPOP1, NSBS1, NSBS2, NSSTP
real(kind=wp) :: CFFPHS, SCL
integer(kind=iwp), allocatable :: SBSET(:)

! The orbital table:
NASPRT = IORBTAB(9)
NASORB = IORBTAB(4)
KOINFO = 19
! The substring table:
MORSBITS = ISSTAB(6)
NSSTP = ISSTAB(7)
KSSTTB = 15
KSSTAN = ISSTAB(9)
KSSTCR = ISSTAB(10)
KSBSAN = ISSTAB(13)
KSBSCR = ISSTAB(14)
if (IMODE == 1) then
  KSSTOP = KSSTAN
  KSBSOP = KSBSAN
else
  KSSTOP = KSSTCR
  KSBSOP = KSBSCR
end if
! The FS blocks of the SGM wave function:
NFSB1 = IFSBTAB1(3)
NDETS1 = IFSBTAB1(5)
KSTARR1 = 8
! The FS blocks of the PSI wave function:
NDETS2 = IFSBTAB2(5)
NHSH2 = IFSBTAB2(6)
KHSH2 = IFSBTAB2(7)
KSTARR2 = 8
! Make an array with nr of earlier substrings for each
! substring type:
call mma_allocate(SBSET,NSSTP,Label='SBSET')
ISUM = 0
do ISST=1,NSSTP
  SBSET(ISST) = ISUM
  ISUM = ISUM+ISSTAB(KSSTTB+5*(ISST-1))
end do

! Loop over FS blocks of the SGM wave function
do IFSB1=1,NFSB1
  KPOS = KSTARR1+(NASPRT+2)*(IFSB1-1)
  ISSTARR(1:NASPRT) = IFSBTAB1(KPOS:KPOS+NASPRT-1)
  IBLKPOS1 = IFSBTAB1(KPOS+NASPRT+1)
  !TEST write(u6,'(1x,a,8I8)') 'SGM FSB1,IBLKPOS1=',IBLKPOS1
  !TEST write(u6,'(1x,a,8I8)') 'SGM FSB1=',(ISSTARR(I),I=1,NASPRT)
  ! Initial values for lower and higher dimensions.
  ! Also, extra phase factor due to spin orbitals in higher substrings.
  NDI = 1
  do ISPART=1,NASPRT
    NDIARR(ISPART) = NDI
    ISST1 = ISSTARR(ISPART)
    NDI = NDI*ISSTAB(KSSTTB+5*(ISST1-1))
  end do
  NDJ = 1
  IPH = 1
  do ISPART=NASPRT,1,-1
    NDJARR(ISPART) = NDJ
    IPHARR(ISPART) = IPH
    ISST1 = ISSTARR(ISPART)
    NSBS1 = ISSTAB(KSSTTB+0+5*(ISST1-1))
    NPOP1 = ISSTAB(KSSTTB+1+5*(ISST1-1))
    NDJ = NDJ*NSBS1
    if (NPOP1 /= 2*(NPOP1/2)) IPH = -IPH
  end do
  ! Loop over active orbitals:
  do ISORB=1,NASORB
    if (COEFF(ISORB) == Zero) cycle
    ISPART = IORBTAB(KOINFO+6+8*(ISORB-1))
    CFFPHS = real(IPHARR(ISPART),kind=wp)*COEFF(ISORB)
    KSORB = IORBTAB(KOINFO+7+8*(ISORB-1))
    !TEST write(u6,'(1x,a,8I8)') 'ISORB,ISPART,KSORB:',ISORB,ISPART,KSORB
    ISST1 = ISSTARR(ISPART)
    NSBS1 = ISSTAB(KSSTTB+5*(ISST1-1))

    ! Modify the bra substring type by annih or creating ISORB
    ISST2 = ISSTAB(KSSTOP-1+KSORB+MORSBITS*(ISST1-1))
    if (ISST2 == 0) cycle

    !TEST write(u6,'(1x,a,8I8)') 'ISST1,ISST2:',ISST1,ISST2
    ! Determine dimensions for multiple daxpy:
    ! Dimension for earlier subpartitions is NDI
    ! Dimension for later   subpartitions is NDJ
    ! Dimensions for present subpartition are NSBS1,NSBS2
    NDI = NDIARR(ISPART)
    NDJ = NDJARR(ISPART)

    NSBS2 = ISSTAB(KSSTTB+5*(ISST2-1))
    ISSTARR(ISPART) = ISST2
    ! Get the corresponding FS block number
    !TEST write(u6,'(1x,a,8I8)') 'PSI FSB2=',(ISSTARR(I),I=1,NASPRT)
    call HSHGET(ISSTARR,NASPRT,NASPRT+2,IFSBTAB2(KSTARR2),NHSH2,IFSBTAB2(KHSH2),IFSB2)
    !TEST write(u6,'(1x,a,8I8)') 'IFSB1,IFSB2:',IFSB1,IFSB2
    ISSTARR(ISPART) = ISST1
    if (IFSB2 == 0) cycle
    KPOS = KSTARR2+(NASPRT+2)*(IFSB2-1)
    IBLKPOS2 = IFSBTAB2(KPOS+NASPRT+1)
    ! Now loop over ket substrings in this subpartition
    do KSBS1=1,NSBS1
      ISBS1 = KSBS1+SBSET(ISST1)
      ISBS2 = ISSTAB(KSBSOP-1+KSORB+MORSBITS*(ISBS1-1))
      if (ISBS2 == 0) then
        cycle
      else if (ISBS2 > 0) then
        SCL = CFFPHS
        ISBS2 = ISBS2
      else
        SCL = -CFFPHS
        ISBS2 = -ISBS2
      end if
      KSBS2 = ISBS2-SBSET(ISST2)

      ! CALL some multiple daxpy...
      do I=0,NDI-1
        do J=0,NDJ-1
          IPOS1 = IBLKPOS1+I+NDI*(KSBS1-1+NSBS1*J)
          IPOS2 = IBLKPOS2+I+NDI*(KSBS2-1+NSBS2*J)
          SGM(IPOS1) = SGM(IPOS1)+SCL*PSI(IPOS2)
          IERR = 0
          if ((IPOS1 < 1) .or. (IPOS1 > NDETS1)) IERR = 1
          if ((IPOS2 < 1) .or. (IPOS2 > NDETS2)) IERR = 1
          if (IERR /= 0) then
            write(u6,*) ' SGMOP addressing error.'
            write(u6,'(1x,a,8I8)') ' SGM dimension NDETS1=',NDETS1
            write(u6,'(1x,a,8I8)') ' Position IPOS1=',IPOS1
            write(u6,'(1x,a,8I8)') ' PSI dimension NDETS2=',NDETS2
            write(u6,'(1x,a,8I8)') ' Position IPOS2=',IPOS2
            call ABEND()
          end if
          ! Temporary test print:
          !TEST if (PSI(IPOS2) /= Zero) then
          !TEST   write(u6,'(1x,f16.8,2i8)') SCL,IPOS1,IPOS2
          !TEST   write(u6,'(1x,a,8I8)') 'IFSB1,IFSB2:',IFSB1,IFSB2
          !TEST   write(u6,'(1x,a,8I8)') 'IBLKPOS1,NDI,NSBS1:',IBLKPOS1,NDI,NSBS1
          !TEST   write(u6,'(1x,a,8I8)') 'IBLKPOS2,NDI,NSBS2:',IBLKPOS2,NDI,NSBS2
          !TEST   write(u6,'(1x,a,8I8)') 'I,KSBS1,J:',I,KSBS1,J
          !TEST   write(u6,'(1x,a,8I8)') 'I,KSBS2,J:',I,KSBS2,J
          !TEST end if
          ! End of test prints
        end do
      end do

    end do

    ! End of loop over orbitals
  end do
  ! End of loop over FS blocks
end do
call mma_deallocate(SBSET)

end subroutine SGMOP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_XCV_OpenTmpFiles()

use Cholesky, only: LuTmp, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iSym
character(len=6) :: Filename

do iSym=1,nSym
  LuTmp(iSym) = 7
  write(Filename,'(A4,I2.2)') 'VTMP',iSym
  call DAName_MF_WA(LuTmp(iSym),Filename)
end do

end subroutine Cho_XCV_OpenTmpFiles

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Danjo De Chavez                                  *
!***********************************************************************
!  exp_series
!
!> @brief  Compute the exponential of the U matrix
!> @author Danjo De Chavez
!>
!> @details
!> Computes the exponential of an antisymmetric real matrix U through
!> a modified Taylor expansion of the K matrix. This takes advantage of the
!> subblocks and trend in the powers of K matrix. \cite Sei2022-JCTC-18-4164
!>
!> \note
!> Some equations in the reference are wrong.
!>
!> @see ::exp_series2, ::exp_svd, ::exp_schur, ::exp_eig
!>
!> @param[in]     N        Size of the square matrix
!> @param[in]     No       Number of Occupied Orbitals
!> @param[in,out] U        U matrix is replaced by its exponential
!***********************************************************************

subroutine exp_series(N,No,U)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none

integer(kind=iwp), intent(in) :: N, No
real(kind=wp), intent(inout) :: U(N,N)
integer(kind=iwp) :: cnt, Nv
real(kind=wp) :: factor, ithrsh, ithrshoo, ithrshvo, ithrshvv
real(kind=wp), allocatable :: Koo(:,:), Kvo(:,:), Kvv(:,:), theta(:,:), Uoo(:,:), Uvo(:,:), Uvv(:,:), xUoo(:,:), xUvo(:,:), &
                              xUvv(:,:)
real(kind=wp), parameter :: thrsh = 1.0e-20_wp

if (N < 1) return
Nv = N-No

call mma_allocate(theta,Nv,No,label='theta')

call mma_allocate(Koo,No,No,label='Koo')
call mma_allocate(Kvv,Nv,Nv,label='Kvv')
call mma_allocate(Kvo,Nv,No,label='Kvo')

call mma_allocate(Uoo,No,No,label='Uoo')
call mma_allocate(Uvv,Nv,Nv,label='Uvv')
call mma_allocate(Uvo,Nv,No,label='Uvo')

call mma_allocate(xUoo,No,No,label='xUoo')
call mma_allocate(xUvv,Nv,Nv,label='xUvv')
call mma_allocate(xUvo,Nv,No,label='xUvo')

theta(:,:) = U(No+1:N,:No)

U(:,:) = Zero

cnt = 1
factor = One

ithrsh = 2.0e-16_wp

! Initialization
! Taylor expansion terms to n=1

Uvo(:,:) = Zero

call unitmat(Uoo,No)

xUoo(:,:) = Zero
xUvv(:,:) = Zero
xUvo(:,:) = Zero

call unitmat(Uvv,Nv)

Kvo(:,:) = theta
Uvo(:,:) = theta

! Main Loop
! Taylor expansion terms from n=2 to convergence

do while (thrsh < ithrsh)
  cnt = cnt+1
  factor = factor*cnt

  if (mod(cnt,2) == 0) then
    call dgemm_('T','N',No,No,Nv,One,-theta,Nv,Kvo,Nv,Zero,Koo,No)
    call dgemm_('N','T',Nv,Nv,No,One,Kvo,Nv,-theta,Nv,Zero,Kvv,Nv)
    Uoo(:,:) = Uoo+Koo/factor
    Uvv(:,:) = Uvv+Kvv/factor

  else
    call dgemm_('N','N',Nv,No,No,One,theta,Nv,Koo,No,Zero,Kvo,Nv)
    Uvo(:,:) = Uvo+Kvo/factor

    ithrshoo = maxval(abs(Uoo-xUoo)/(abs(Uoo)+thrsh))
    ithrshvv = maxval(abs(Uvv-xUvv)/(abs(Uvv)+thrsh))
    ithrshvo = maxval(abs(Uvo-xUvo)/(abs(Uvo)+thrsh))
    ithrsh = max(ithrshoo,ithrshvv,ithrshvo)

    xUoo(:,:) = Uoo
    xUvv(:,:) = Uvv
    xUvo(:,:) = Uvo

  end if
end do

U(:No,:No) = Uoo
U(No+1:N,:No) = Uvo
U(:No,No+1:N) = -transpose(Uvo)
U(No+1:N,No+1:N) = Uvv

call mma_deallocate(Koo)
call mma_deallocate(Kvv)
call mma_deallocate(Kvo)

call mma_deallocate(Uoo)
call mma_deallocate(Uvv)
call mma_deallocate(Uvo)

call mma_deallocate(xUoo)
call mma_deallocate(xUvv)
call mma_deallocate(xUvo)

call mma_deallocate(theta)

return

end subroutine exp_series

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE VSUB(VEC1,IST1,VEC2,IST2,VEC3,IST3,NS)
      implicit none
      integer IST1,IST2,IST3,NS, I, IS1,IS2,IS3
      REAL*8 VEC1,VEC2,VEC3
      DIMENSION VEC1(*),VEC2(*),VEC3(*)
c
      IF(IST1.EQ.1.AND.IST2.EQ.1.AND.IST3.EQ.1)THEN
         DO I=1,NS
            VEC3(I  )=VEC2(I  )-VEC1(I  )
         enddo
      ELSE
         IS1=1
         IS2=1
         IS3=1
         DO I=1,NS
            VEC3(IS3)=VEC2(IS2)-VEC1(IS1)
            IS1=IS1+IST1
            IS3=IS3+IST3
            IS2=IS2+IST2
      enddo
      ENDIF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986,1995, Bernd Artur Hess                            *
*               2005, Jesper Wisborg Krogh                             *
************************************************************************
C $Id: relsew.r,v 1.4 1995/05/08 14:08:53 hess Exp $
C calculate relativistic operators
C   Bernd Artur Hess, hess@uni-bonn.de
C   Modified: 2005 Jesper Wisborg Krogh, Jesper.Krogh@teokem.lu.se
C
C
      SUBROUTINE SCFCLI(idbg,epsilon,S,H,V,PVP,N,ISIZE,VELIT,
     *                  TMP1,TMP2,TMP3,TMPA,TMPB,TMPC,EW,E,AA,RR,TT,
     *                  TMP4,TMPD,TMPE,TMPF,TWRK4,IDIM)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION S(ISIZE),H(ISIZE),V(ISIZE),PVP(ISIZE)
      DIMENSION TMP1(IDIM*(IDIM+1)/2),TMP2(ISIZE),TMP3(ISIZE),
     *          TMPA(N,N),TMPB(N,N),TMPC(N,N),
     *          EW(N),E(N),AA(N),RR(N),TT(N)
#include "relae.fh"
      DIMENSION TMP4(IDIM*(IDIM+1)/2)
      DIMENSION TMPD(IDIM,IDIM)
      DIMENSION TMPE(N,N)
      DIMENSION TMPF(N,N)
      DIMENSION TWRK4(N*200)
*
C
c      write(6,*) ' in SCFCLI', N, iSize
      TOL=1.D-14
      PREA=1d0/(VELIT*VELIT)
      CON2=PREA+PREA
      CON=1.D0/PREA
#ifdef _DEBUGPRINT_
C
C     CALCULATE DETERMINANT
C
      Call Square(S,TMPB,n,1,n)
c      do i=1,n
c         write(6,'(5f10.5)') (TMPB(i,j),j=1,n)
c      enddo
      icontr=-1
      dtol=tol
      CALL dcopiv(TMPB,TMPB,n,1,n,dtol,det,iex,icontr,TMP2)
      if(idbg.gt.0)WRITE (idbg,2016) icontr,det,iex
2016  FORMAT('  relsew| DCOPIV rc=',I2,', |S|=',D20.6,'x 10**(',I4,') ')
      IF (icontr.NE.0) THEN
         WRITE (6,2016) icontr,det,iex
         WRITE (6,2012) dtol
2012     FORMAT('  relsew|****** '/,
     * '        |****** WARNING - OVERLAP MATRIX SINGULAR '/,
     * '        |****** PIVOTAL ELEMENT LESS THAN ',D20.4,' FOUND'/,
     * '        |******'//)
         CALL errex_rel(' relsew| singular overlap matrix')
      ENDIF
#endif
C
C     SCHMIDT-ORTHOGONALIZE
C
      CALL Sogr(idbg,N,S,TMPE,TMP2,TMPC,EW)
C
C ** TMPE CONTAINS TRANSFORMATION TO ORTHOGONAL AO-BASIS
C--------------------------------------------------------------------
C     NON-RELATIVISTIC KINETIC ENERGY
C--------------------------------------------------------------------
      CALL Diagr(H,N,TMPF,EW,TMPE,TMPB,TMP2)
      if(idbg.gt.0)WRITE (idbg,556)
  556 FORMAT(//,7X,'- NREL. ENERG.  -  DIVIDED BY C ',
     *             '- REL.  ENERG.  -  MOMENTUM    -',
     *             ' TERMS OF POWER SERIES (LOW ENERGY ONLY)'//)
      DO 4 I=1,N
         IF (ew(i).LT.0.D0) THEN
             WRITE (6,*) ' scfcli| ew(',i,') = ',ew(i)
         CALL errex_rel('kinetic energy eigenvalue less than zero')
         ENDIF
C
C     IF T SUFFICIENTLY SMALL, USE SERIES EXPANSION TO AVOID CANCELLATIO
C
         RATIO=EW(I)/VELIT
C
C     CALCULATE RELATIVISTIC ENERGY AND MOMENTUM
C
         SR=sqrt(2.D0*EW(I))
         TT(I)=EW(I)
         IF (RATIO.GT.0.02D0) GOTO 11
         TV1=EW(I)
         TV2=-TV1*EW(I)*PREA/2.D0
         TV3=-TV2*EW(I)*PREA
         TV4=-TV3*EW(I)*PREA*1.25D0
         EW(I)=TV1+TV2+TV3+TV4
         if(idbg.gt.0)WRITE (idbg,100) I,TV1,RATIO,EW(I),SR,TV2,TV3,TV4
  100    FORMAT(1X,I4,7(1X,D15.8))
         GOTO 12
  11     TV1=EW(I)
         EW(I)=CON*(sqrt(1.D0+CON2*EW(I))-1.D0)
         if(idbg.gt.0)WRITE (idbg,100) I,TV1,RATIO,EW(I),SR
  12     CONTINUE
         E(I)=EW(I)+CON
4     CONTINUE
C---------------------------------------------------------------------
C     CALCULATE REVERSE TRANSFORMATION
C---------------------------------------------------------------------
      Call DGEMM_('N','N',n,n,n,1.0D0,TMPE,n,TMPF,n,0.0D0,TMPB,n)
#ifdef MOLPRO
      Call Square(TMPC,S,N,N)
#else
      Call Square(S,TMPC,N,1,N)
#endif
      Call DGEMM_('N','N',n,n,n,1.0D0,TMPC,n,TMPB,n,0.0D0,TMPA,n)
C ** TMPC  CONTAINS OVERLAP MATRIX IN FULL
*
      IF(IRELAE.NE.21.AND.IRELAE.NE.22.AND.IRELAE.NE.23) THEN
*
         Call dCopy_(iSize,[0.0D0],0,H,1)
         Do K = 1,N
            IJ = 0
            Do I = 1,N
               Do J = 1,I
                  IJ = IJ + 1
                  H(IJ) = H(IJ) + TMPA(I,K)*TMPA(J,K)*EW(K)
               End Do
            End Do
         End Do
*
      ELSE
         Call dCopy_(iSize,[0.0D0],0,H,1)
      ENDIF
C
C     CALCULATE KINEMATICAL FACTORS
C
      IF(IRELAE.NE.11) THEN
*
         DO 362 I=1,N
            AA(I)=sqrt((CON+E(I)) / (2.D0*E(I)))
            RR(I)=sqrt(CON)/(CON+E(I))
362      CONTINUE
*
      ELSE IF(IRELAE.EQ.11) THEN
*
         DO I=1,N
            AA(I)=(sqrt(1.0D0+CON*TT(I)*2.0D0/((CON+E(I))*(CON+E(I)))))
     $                                /(CON+E(I))
! O OPERATOR
            RR(I)=sqrt(CON)/(CON+E(I))
! Q OPERATOR
         ENDDO
*
      ENDIF
C
C     POTENTIAL
C
C
C     BEYOND THIS POINT, TMPC IS USED AS SCRATCH ARRAY
C
C
C    TRANSFORM V TO T-BASIS
C
      CALL TrSmr2(V,TMPE,TMP3,N,TMPB,TMPF,TMPC)
culf
      if(idbg.gt.0)CALL PRMAT(IDBG,V,N,0,'v oper  ')
C
C    MULTIPLY
C
      IF(IRELAE.EQ.0.OR.IRELAE.EQ.1.OR.IRELAE.EQ.2.OR.
     &   IRELAE.EQ.3) THEN
*
         IJ=0
         DO 2005 I=1,N
            DO 2006 J=1,I
               IJ=IJ+1
               TMP2(IJ)=TMP3(IJ)
               TMP3(IJ)=TMP3(IJ)*AA(I)*AA(J)
2006        CONTINUE
2005     CONTINUE
         IF (IRELAE .eq. 3) Then
#ifdef MOLPRO
           Call Square(TMPD,TMP3,N,N)
#else
           Call Square(TMP3,TMPD,N,1,N)
#endif
         ENDIF
*
      ELSE IF(IRELAE.EQ.11) THEN
*
         IJ=0
         DO I=1,N
             DO J=1,I
                  IJ=IJ+1
                  TMP2(IJ)=TMP3(IJ)
                  TMP3(IJ)=VELIT*TMP3(IJ)*(sqrt(RR(I)*RR(J))
     $                      *AA(I)/AA(J)+sqrt(RR(J)*RR(I))*AA(J)/AA(I))
             ENDDO
         ENDDO
*
      ELSE IF(IRELAE.EQ.22) THEN   ! ZORA(FP)
*
         IJ=0
         DO I=1,N
            DO J=1,I
               IJ=IJ+1
               TMP3(IJ)=TMP3(IJ)*AA(I)*AA(J)
            ENDDO
         ENDDO
*
      ENDIF
*
      CALL TrSmtr(TMP3,TMPA,H,1.0D0,N,TMPB,TMPC)
culf
C
C     PVP INTEGRALS AND TRANSFORM THEM TO T-BASIS
C
      if(idbg.gt.0)CALL PRMAT(IDBG,pvp,N,0,'raw pvp integrals  ')
      CALL TrSmr2(PVP,TMPE,PVP,N,TMPB,TMPF,TMPC)
C
C    MULTIPLY
C
      IF(IRELAE.EQ.0.OR.IRELAE.EQ.1.OR.IRELAE.EQ.2.OR.
     *   IRELAE.EQ.3) THEN
*
         IJ=0
         DO 3005 I=1,N
            DO 3006 J=1,I
               IJ=IJ+1
               TMP3(IJ)=PVP(IJ)
               PVP(IJ)=PVP(IJ)*AA(I)*RR(I)*AA(J)*RR(J)
               IF (IRELAE .eq. 3) Then
                  TMPD(I,J)=TMPD(I,J)+PVP(IJ)
                  TMPD(J,I)=TMPD(I,J)
               End If
3006        CONTINUE
3005     CONTINUE
*
      ELSE IF(IRELAE.EQ.11) THEN
*
         IJ=0
         DO I=1,N
            DO J=1,I
               IJ=IJ+1
               TMP3(IJ)=PVP(IJ)
               PVP(IJ)=PVP(IJ)*(RR(I)*RR(J)*AA(I)/AA(J)
     $                      +RR(J)*RR(I)*AA(J)/AA(I))*0.5D0
            ENDDO
         ENDDO
*
      ELSE IF(IRELAE.EQ.21.OR.IRELAE.EQ.22.OR.IRELAE.EQ.23) THEN
*
         IJ=0
         DO I=1,N
            DO J=1,I
               IJ=IJ+1
               PVP(IJ)=-PVP(IJ)*0.5D0*PREA
               IF(I.EQ.J) PVP(IJ)=PVP(IJ)+TT(I)*2.0D0
            ENDDO
         ENDDO
#ifdef MOLPRO
         Call Square(TMPD,PVP,N,N)
#else
         Call Square(PVP,TMPD,N,1,N)
#endif
C
C     ----- inverse operator -----
C
         EPS=1.d-13
         CALL MINVD(TMPD,N,N,EPS,ILL)
         IJ=0
         DO I=1,N
            DO J=1,I
               IJ=IJ+1
               PVP(IJ)=TMPD(I,J)
               PVP(IJ)=PVP(IJ)*TT(I)*TT(J)*2.0D0
               IF(IRELAE.EQ.22) PVP(IJ)=PVP(IJ)*AA(I)*AA(J)
            ENDDO
         ENDDO
*
      ENDIF
*
      CALL TrSmtr(PVP,TMPA,H,1.0D0,N,TMPB,TMPC)
culf
*
      IF(IRELAE.EQ.23) THEN
         IJ=0
#ifdef MOLPRO
         Call Square(TMPE,PVP,N,N)
#else
         Call Square(PVP,TMPE,N,1,N)
#endif
         DO I=1,N
            DO J=1,I
               IJ=IJ+1
               TMPD(I,J)=PVP(IJ)/TT(J)*0.5D0*PREA
               TMPD(J,I)=PVP(IJ)/TT(I)*0.5D0*PREA
            ENDDO
         ENDDO
         M=N
         Call dCopy_(N*N,[0.0D0],0,TMPC,1)
         Call dCopy_(N,[1.0D0],0,TMPC,N+1)
         Call DGEMM_('N','N',N,N,N,1.0D0,TMPD,M,TMPE,M,1.0D0,TMPC,M)
* ----- modified overlap is incorporated into PVP
         Call DGEMM_('N','N',N,N,N,1.0D0,TMPA,N,TMPC,N,0.0D0,TMPB,N)
         Call dGemm_tri('N','T',N,N,N,1.0D0,TMPB,N,TMPA,N,0.0D0,PVP,N)
      ENDIF
      IF(IRELAE.EQ. 1.OR.IRELAE.EQ.11.OR.
     &   IRELAE.EQ.21.OR.IRELAE.EQ.22.OR.IRELAE.EQ.23)
     &   GOTO 1000
*
      If (IRELAE .eq. 3) Then
* --- KEEP T-BASIS VEXT INTO TMP1 FOR HIGHER-ORDER DK
         Call dCopy_(N*(N+1)/2,TMP2,1,TMP1,1)
* --- KEEP T-BASIS PVP INTO TMP4 FOR HIGHER-ORDER DK
         Call dCopy_(N*(N+1)/2,TMP3,1,TMP4,1)
      End If
C
C     CALCULATE Even2r OPERATOR
C
      CALL Even2r(idbg,N,TMP2,TMP3,E,AA,RR,TT,TMPE,TMPB,TMPC,
     $            TMPF)
C
C    TRANSFORM BACK
C
culf
      if(idbg.gt.0)CALL PRMAT(IDBG,TMP3,n,0,'ev2 orig')
      CALL TrSmtr(TMP3,TMPA,H,1.0D0,N,TMPB,TMPC)
culf
      IF(IRELAE.EQ.0.OR.IRELAE.EQ.2) GOTO 1000   ! DK2
C
C     ----- CALCULATE Even3r OPERATOR -----
C
      CALL Even3r(idbg,N,TMP2,TMP3,E,AA,RR,TT,TMPB,
     &            TMPD,TMP1,TMP4,TMPE,TMPF)
C
C    TRANSFORM BACK
C
culf
      if(idbg.gt.0)CALL PRMAT(IDBG,TMP3,n,0,'ev2 orig')
      CALL TrSmtr(TMP3,TMPA,H,1.0D0,N,TMPB,TMPC)
culf
*
      IF(IRELAE.EQ.3) GOTO 1000   ! DK3
*
*     More to come!
*
 1000 CONTINUE
*
culf
      if(idbg.gt.0)CALL PRMAT(IDBG,h,n,0,'h   oper')
      CALL Sogr(idbg,N,S,TMPE,TMP2,TMPC,EW)
      CALL Diagr(H,N,TMPF,EW,TMPE,TMPB,TMP2)
      if(idbg.gt.0)CALL PRMAT(IDBG,h,n,0,'h   oper(final)')
      if(idbg.gt.0)WRITE (idbg,*) '--- EIGENVALUES OF H MATRIX ---'
      if(idbg.gt.0)WRITE (idbg,'(4D20.12)') EW
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_real(epsilon)
        CALL Unused_real_array(TWRK4)
      END IF
      END
      SUBROUTINE TrSmr(A,B,C,N,H,W)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(N*(N+1)/2),B(N,N),C(N*(N+1)/2),H(N,N),W(N,N)
C
C     TRANSFORM SYMMETRIC MATRIX A BY UNITARY TRANSFORMATION
C     IN B. RESULT IS IN C
C
#ifdef MOLPRO
      Call Square(W,A,n,n)
#else
      Call Square(A,W,n,1,n)
#endif
      Call DGEMM_('T','N',n,n,n,1.0D0,B,n,W,n,0.0D0,H,n)
      Call dGemm_tri('N','N',n,n,n,1.0D0,H,n,B,n,0.0D0,C,n)
      RETURN
      END
*
      SUBROUTINE TrSmr2(A,B,C,N,H,G,W)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(N*(N+2)/2),B(N,N),C(N*(N+1)/2),H(N,N),W(N,N),G(N,N)
C
C     Performs the equivalent operations as two calls to TrSmr
C     RESULT IS IN C = G^T * (B^T * A * B) * G
C     and where C and A are triangular packed.
C
#ifdef MOLPRO
      Call Square(W,A,n,n)
#else
      Call Square(A,W,n,1,n)
#endif
      Call DGEMM_('T','N',n,n,n,1.0D0,B,n,W,n,0.0D0,H,n)
      Call DGEMM_('N','N',n,n,n,1.0D0,H,n,B,n,0.0D0,W,n)
      Call DGEMM_('T','N',n,n,n,1.0D0,G,n,W,n,0.0D0,H,n)
      Call dGemm_tri('N','N',n,n,n,1.0D0,H,n,G,n,0.0D0,C,n)
      RETURN
      END
*
      SUBROUTINE TrSmtr(A,B,C,FACTOR,N,H,W)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(N*(N+1)/2),B(N,N),C(N*(N+1)/2),H(N,N),W(N,N)
C
C     B*A*BT
C
#ifdef MOLPRO
      Call Square(W,A,n,n)
#else
      Call Square(A,W,n,1,n)
#endif
      Call DGEMM_('N','N',n,n,n,1.0D0,B,n,W,n,0.0D0,H,n)
      Call dGemm_tri('N','T',n,n,n,1.0D0,H,n,B,n,Factor,C,n)
      RETURN
      END
      SUBROUTINE Sogr(idbg,N,SS,SINV,P,G,A1)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION SS(*),P(*),G(*),A1(*),SINV(N,N)
C
C     SUBROUTINE TO CALCULATE TRANSFORMATION TO SCHMIDT-
C     ORTHOGONALIZED BASIS.
C     N              DIMENSION OF MATRICES. ISIZE=N*(N+1)/2
C     SS(ISIZE)      ORIGINAL OVERLAP MATRIX (LOWER TRIANGULAR)
C                    WILL NOT BE DESTROYED
C     P (ISIZE)      OUTPUT TRANSFORMATION MATRIX
C     G (ISIZE)      SCRATCH
C     A1(N)          SCRATCH
C
      INTEGER ierr
      If (iDbg.gt.0) Call PrMat(idbg,SS,n,0,'SS')
      ierr=0
      JL=0
      IQ=0
      DO 349 J=1,N
         IL=JL
         JQ=IQ
         S1KK=SS(IQ+J)
         G(IL+J)=1.D0
         IF(J.EQ.1)GO TO 341
         J1=J-1
         JL=0
         DO 342 K=1,J1
            LG=JQ
            ETOT=0.D0
            DO 343 L=1,K
               LG=LG+1
               JL=JL+1
               ETOT=ETOT+SS(LG)*G(JL)
  343       CONTINUE
            S1KK=S1KK-ETOT*ETOT
            A1(K)=ETOT
  342    CONTINUE
         JF=1
         JL=IL
         DO 344 K=1,J1
            SUM=0.D0
            JL=JL+1
            JF=JF+K-1
            IH=JF
            DO 345 L=K,J1
               IH=IH+L-1
               SUM=SUM+A1(L)*G(IH)
  345       CONTINUE
            G(JL)=-SUM
  344    CONTINUE
  341    CONTINUE
         IF (s1kk .LE. 1.D-16) THEN
            WRITE (6,*) '    Sogr| j=',j,' s1kk=',s1kk
            ierr=ierr+1
         ENDIF
         S1KK=1.D0/sqrt(S1KK)
         JL=IL
         DO 340 K=1,J
            JL=JL+1
            IQ=IQ+1
            G(JL)=G(JL)*S1KK
            P(IQ)=G(JL)
  340    CONTINUE
  349 CONTINUE
      IJ=0
      DO 1 I=1,N
         DO 2 J=1,I
            IJ=IJ+1
            SINV(I,J)=0.D0
            SINV(J,I)=P(IJ)
2        CONTINUE
1     CONTINUE
      IF (ierr.GT.0)  CALL errex_rel('function has negative norm')
      If (iDbg.gt.0) Call PrMat(idbg,P,n,0,'P')
      RETURN
      END
C***** NAME AddMar
      SUBROUTINE AddMar(N,S,OVE)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION S(N),OVE(N)
      DO 1 I=1,N
         OVE(I)=OVE(I)+S(I)
1     CONTINUE
      RETURN
      END
*
      SUBROUTINE Diagr(A,N,EIG,EW,SINV,AUX,AUXI)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(*),AUX(N,N),SINV(N,N),EIG(N,N),EW(*),AUXI(*)
#include "WrkSpc.fh"
      If (n.eq.0) Return
#ifdef MOLPRO
      Call Square(Aux,A,n,n)
#else
      Call Square(A,Aux,n,1,n)
#endif
      Call DGEMM_('N','N',n,n,n,1.0D0,Aux,n,Sinv,n,0.0D0,Eig,n)
      Call dGemm_tri('T','N',n,n,n,1.0D0,SINV,n,EIG,n,0.0D0,AUXI,n)
*
      Call dCopy_(n*n,[0.0D0],0,Eig,1)
      Call dCopy_(n,[1.0D0],0,Eig,n+1)
      Call dCopy_(N*(N+1)/2,AUXI,1,AUX,1)
C      Call NIDiag(AUXI,EIG,N,N,0)
      Call NIDiag_New(AUXI,EIG,N,N,0)
      Call vEig(N,AUXI,EW)
      Call JacOrd2(EW, Eig, n, n)
*
      RETURN
      END
      SUBROUTINE Even2r(idbg,N,V,G,E,A,R,TT,AUXF,AUXG,AUXH,W1W1)

C  DELC$
C     EVEN2 - BERND HESS - V 1.0 - 5.2.86
C     CALCULATE EVEN2 OPERATORS
C
C
C     N       DIMENSION OF MATRICES
C     V       POTENTIAL MATRIX
C     G       MATRIX OF PVP OPERATOR. WILL CONTAIN EVEN2 OPERATORS
C             ON OUTPUT
C     E       RELATIVISTIC ENERGY (DIAGONAL)
C     A       A-FACTORS (DIAGONAL)
C     R       R-FACTORS (DIAGONAL)
C     TT      NONREL. KINETIC ENERGY (DIAGONAL)
C     AUXF,AUXG,AUXH  SCRATCH ARAYS
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION V(N*(N+1)/2),G(N*(N+1)/2),E(N),R(N),A(N),TT(N),
     &          AUXF(N,N),AUXG(N,N),AUXH(N,N)
      DIMENSION W1W1(N,N)
culf
#ifdef _DEBUGPRINT_
      if(idbg.gt.0)CALL PRMAT(IDBG,V,N,0,'V       ')
      if(idbg.gt.0)CALL PRMAT(IDBG,G,N,0,'G       ')
      if(idbg.gt.0)CALL PRMAT(IDBG,E,N,1,'E       ')
      if(idbg.gt.0)CALL PRMAT(IDBG,A,N,1,'A       ')
      if(idbg.gt.0)CALL PRMAT(IDBG,R,N,1,'R       ')
      if(idbg.gt.0)CALL PRMAT(IDBG,TT,N,1,'TT      ')
#endif
      M=N
      Call dCopy_(N*N,[0.0D0],0,AUXH,1)
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            V(IJ)=V(IJ)/(E(I)+E(J))
            G(IJ)=G(IJ)/(E(I)+E(J))
         End Do
      End Do
      DO J=1,N
         IJ = J*(J-1)/2 + 1
         DO I=J,N
            IJ = IJ + I-1
            AUXF(I,J)=A(I)*R(I)*G(IJ)*A(J)*A(J)
            AUXG(I,J)=R(I)*V(IJ)*A(J)
         End Do
      End Do
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(J,I)=A(J)*R(J)*G(IJ)*A(I)*A(I)
            AUXG(J,I)=R(J)*V(IJ)*A(I)
         End Do
      End Do
C
C     ARQA ARQA
C
      CALL CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
#ifdef _DEBUGPRINT_
      IF (IE.NE.0) Call SysHalt('relsew')
culf
      if(idbg.gt.0)CALL prsq(idbg,'AUXH   1',auxh,n)
#endif
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXG(J,I)=-0.5D0/TT(J)*G(IJ)*A(I)*R(I)
         End Do
      End Do
      DO J=1,N
         IJ = INT(DBLE(J*(J-1))*0.5D0 + 1D0)
         DO I=J,N
            IJ = IJ + I-1
            AUXG(I,J)=-0.5D0/TT(I)*G(IJ)*A(J)*R(J)
         End Do
      End Do
C
C     ARQA AQRA
C
      CALL CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
culf
#ifdef _DEBUGPRINT_
      if(idbg.gt.0)CALL prsq(idbg,'AUXH   2',auxh,n)
#endif
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(J,I)=A(J)*V(IJ)*A(I)*A(I)*R(I)
         End Do
      End Do
      DO J=1,N
         IJ = INT(DBLE(J*(J-1))*0.5D0 + 1D0)
         DO I=J,N
            IJ = IJ + I-1
            AUXF(I,J)=A(I)*V(IJ)*A(J)*A(J)*R(J)
         End Do
      End Do
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXG(J,I)=-2.D0*TT(J)*R(J)*V(IJ)*A(I)
         End Do
      End Do
      DO J=1,N
         IJ = INT(DBLE(J*(J-1))*0.5D0 + 1D0)
         DO I=J,N
            IJ = IJ + I-1
            AUXG(I,J)=-2.D0*TT(I)*R(I)*V(IJ)*A(J)
         End Do
      End Do
C
C     AQRA ARQA
C
      CALL CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
culf
#ifdef _DEBUGPRINT_
      if(idbg.gt.0)CALL prsq(idbg,'AUXH   3',auxh,n)
#endif
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXG(J,I)=G(IJ)*A(I)*R(I)
         End Do
      End Do
      DO J=1,N
         IJ = INT(DBLE(J*(J-1))*0.5D0 + 1D0)
         DO I=J,N
            IJ = IJ + I-1
            AUXG(I,J)=G(IJ)*A(J)*R(J)
         End Do
      End Do
C
C     AQRA AQRA
C
      CALL CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
C
C     KEEP W1*W1 FOR HIGHER-ORDER DK
C
      Call dCopy_(N*N,AuxH,1,W1W1,1)
*
culf
#ifdef _DEBUGPRINT_
      if(idbg.gt.0)CALL prsq(IDBG,'W*W     ',AUXH,N)
#endif
C
C     1/2 EW*W + 1/2 W*WE
C
      DO 610 I=1,N
         DO 611 J=1,N
            AUXH(I,J)=0.5D0*( AUXH(I,J)*E(I) + AUXH(I,J)*E(J) )
611      CONTINUE
610   CONTINUE
culf
#ifdef _DEBUGPRINT_
      if(idbg.gt.0)CALL prsq(idbg,'AUXH SYM',auxh,n)
#endif
C
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(J,I)=A(J)*R(J)*G(IJ)*A(I)*E(I)*A(I)
            AUXG(J,I)=R(J)*V(IJ)*A(I)
         End Do
      End Do
      DO J=1,N
         IJ = INT(DBLE(J*(J-1))*0.5D0 + 1D0)
         DO I=J,N
            IJ = IJ + I-1
            AUXF(I,J)=A(I)*R(I)*G(IJ)*A(J)*E(J)*A(J)
            AUXG(I,J)=R(I)*V(IJ)*A(J)
         End Do
      End Do
      CALL CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
culf
#ifdef _DEBUGPRINT_
      if(idbg.gt.0)CALL prsq(idbg,'AUXH   5',auxh,n)
#endif
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXG(J,I)=-0.5D0/TT(J)*G(IJ)*A(I)*R(I)
         End Do
      End Do
      DO J=1,N
         IJ = INT(DBLE(J*(J-1))*0.5D0 + 1D0)
         DO I=J,N
            IJ = IJ + I-1
            AUXG(I,J)=-0.5D0/TT(I)*G(IJ)*A(J)*R(J)
         End Do
      End Do
      CALL CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
culf
#ifdef _DEBUGPRINT_
      if(idbg.gt.0)CALL prsq(idbg,'AUXH   6',auxh,n)
#endif
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(J,I)=A(J)*V(IJ)*R(I)*A(I)*E(I)*A(I)
         End Do
      End Do
      DO J=1,N
         IJ = INT(DBLE(J*(J-1))*0.5D0 + 1D0)
         DO I=J,N
            IJ = IJ + I-1
            AUXF(I,J)=A(I)*V(IJ)*R(J)*A(J)*E(J)*A(J)
         End Do
      End Do
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXG(J,I)=-2.D0*TT(J)*R(J)*V(IJ)*A(I)
         End Do
      End Do
      DO J=1,N
         IJ = INT(DBLE(J*(J-1))*0.5D0 + 1D0)
         DO I=J,N
            IJ = IJ + I-1
            AUXG(I,J)=-2.D0*TT(I)*R(I)*V(IJ)*A(J)
         End Do
      End Do
      CALL CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
culf
#ifdef _DEBUGPRINT_
      if(idbg.gt.0)CALL prsq(idbg,'AUXH   7',auxh,n)
#endif
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXG(J,I)=G(IJ)*A(I)*R(I)
         End Do
      End Do
      DO J=1,N
         IJ = INT(DBLE(J*(J-1))*0.5D0 + 1D0)
         DO I=J,N
            IJ = IJ + I-1
            AUXG(I,J)=G(IJ)*A(J)*R(J)
         End Do
      End Do
      CALL CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
culf
#ifdef _DEBUGPRINT_
      if(idbg.gt.0)CALL prsq(idbg,'AUXH   8',auxh,n)
#endif
C
C     SYMMETRISIEREN
C
      IJ=0
      DO 430 I=1,N
         DO 431 J=1,I
            IJ=IJ+1
            G(IJ)=-0.5D0*(AUXH(I,J)+AUXH(J,I))
 431     CONTINUE
 430  CONTINUE
*
CCC   CALL PRM('OUTPUT  ',G,N)
      RETURN
#ifndef _DEBUGPRINT_
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(idbg)
#endif
      END
      SUBROUTINE CpLabr (A,B,L,M,N,IA,IB,C,IC,IER)
      implicit real*8(a-h,o-z)
      REAL*8   A(IA,M),B(IB,N),C(IC,N)
#ifdef _DEBUGPRINT_
      IF (IA .GE. L .AND. IB .GE. M .AND. IC .GE. L) GO TO 5
      IER=129
      GO TO 9000
    5 CONTINUE
#endif
      IER = 0
      Call DGEMM_('N','N',L,M,N,1.0D0,A,IA,B,IB,1.0D0,C,IC)
#ifdef _DEBUGPRINT_
 9000 CONTINUE
#endif
      RETURN
      END
      subroutine errex_rel(char)
      character*(*) char
      write(6,'(a50)') char
      Call Abend
      end
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE CZERO2(XX,N,M,NDIM)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XX(NDIM,*)
      DATA ZERO /0.0D+00/
C
      DO J=1,N
         DO I=1,M
            XX(I,J)=ZERO
         ENDDO
      ENDDO
C
      RETURN
      END
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE Even3r(idbg,N,V,G,E,A,R,TT,AUXF,
     &                  AUXH,VEXTT,PVPT,RE1R,W1W1)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION V(N*(N+1)/2),G(N*(N+1)/2),E(N),R(N),A(N),TT(N)
      DIMENSION AUXF(N,N)                          ! Scratch
      DIMENSION AUXH(N,N)                          ! Input/Scratch
      DIMENSION RE1R(N,N)                          ! Scratch
      DIMENSION VEXTT(N*(N+1)/2),PVPT(N*(N+1)/2)   ! Input
      DIMENSION W1W1(N,N)                          ! Input/Scratch
C
C     ----- CONSTRUCT RE1R -----
C
C     write(6,*) 'Hello from Even3R'
      Call xflush(6)
      CALL DKRE1R(A,R,E,TT,V,G,RE1R,VEXTT,PVPT,N)
C
      M=N
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            V(IJ)=VEXTT(IJ)/(E(I)+E(J))
            G(IJ)=PVPT(IJ)/(E(I)+E(J))
         ENDDO
      ENDDO
C
C     ----- W1*W1*E1 -----
C
C     ------- 1/2 E1*W1*W1 + 1/2 W1*W1*E1
C
      DO J=1,N
         DO I=1,N
            AUXF(I,J)=0.5D0*AUXH(I,J)
         ENDDO
      ENDDO
      Call dCopy_(N*N,[0.0D0],0,AUXH,1)
      CALL CpLabr(W1W1,AUXF,N,N,N,M,M,AUXH,M,IE)
      CALL CpLabr(AUXF,W1W1,N,N,N,M,M,AUXH,M,IE)
C
C     ----- W1*E1*W1 TERM -----
C
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(I,J)=A(I)*R(I)*G(IJ)*A(J)/R(J)/TT(J)*0.5D0
            AUXF(J,I)=A(J)*R(J)*G(IJ)*A(I)/R(I)/TT(I)*0.5D0
         ENDDO
      ENDDO
      CALL CZERO2(W1W1,N,N,N)
      CALL CpLabr(AUXF,RE1R,N,N,N,M,M,W1W1,M,IE)
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(I,J)=-A(I)*V(IJ)*A(J)
            AUXF(J,I)=-A(J)*V(IJ)*A(I)
         ENDDO
      ENDDO
      CALL CpLabr(W1W1,AUXF,N,N,N,M,M,AUXH,M,IE)
C
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(I,J)=A(I)*V(IJ)*A(J)
            AUXF(J,I)=A(J)*V(IJ)*A(I)
         ENDDO
      ENDDO
      CALL CZERO2(W1W1,N,N,N)
      CALL CpLabr(AUXF,RE1R,N,N,N,M,M,W1W1,M,IE)
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(I,J)=-A(I)/R(I)*G(IJ)*A(J)*R(J)/TT(I)*0.5D0
            AUXF(J,I)=-A(J)/R(J)*G(IJ)*A(I)*R(I)/TT(J)*0.5D0
         ENDDO
      ENDDO
      CALL CpLabr(W1W1,AUXF,N,N,N,M,M,AUXH,M,IE)
C
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(I,J)=A(I)*V(IJ)*A(J)
            AUXF(J,I)=A(J)*V(IJ)*A(I)
         ENDDO
      ENDDO
      CALL CZERO2(W1W1,N,N,N)
      CALL CpLabr(AUXF,RE1R,N,N,N,M,M,W1W1,M,IE)
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(I,J)=A(I)*V(IJ)*A(J)
            AUXF(J,I)=A(J)*V(IJ)*A(I)
         ENDDO
      ENDDO
      CALL CpLabr(W1W1,AUXF,N,N,N,M,M,AUXH,M,IE)
C
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(I,J)=A(I)*R(I)*G(IJ)*A(J)/R(J)/TT(J)*0.5D0
            AUXF(J,I)=A(J)*R(J)*G(IJ)*A(I)/R(I)/TT(I)*0.5D0
         ENDDO
      ENDDO
      CALL CZERO2(W1W1,N,N,N)
      CALL CpLabr(AUXF,RE1R,N,N,N,M,M,W1W1,M,IE)
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            AUXF(I,J)=A(I)/R(I)*G(IJ)*A(J)*R(J)/TT(I)*0.5D0
            AUXF(J,I)=A(J)/R(J)*G(IJ)*A(I)*R(I)/TT(J)*0.5D0
         ENDDO
      ENDDO
      CALL CpLabr(W1W1,AUXF,N,N,N,M,M,AUXH,M,IE)
C
C     ----- SYMMETRISIEREN -----
C
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            G(IJ)=0.5D0*(AUXH(I,J)+AUXH(J,I))
         ENDDO
      ENDDO
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(idbg)
      END
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE DKRE1R(A,R,E,TT,V,G,RE1R,VEXTT,PVPT,N)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     ----- CONSTRUCT RE1R FOR DK3 -----
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION E(N),A(N),R(N),TT(N)
      DIMENSION V(N*(N+1)/2),G(N*(N+1)/2)
      DIMENSION VEXTT(N*(N+1)/2),PVPT(N*(N+1)/2)
      DIMENSION RE1R(N,N)
C
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            V(IJ)=VEXTT(IJ)
            G(IJ)=PVPT(IJ)
         ENDDO
      ENDDO
C
C     ------- MULTIPLY
C
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            V(IJ)=V(IJ)*A(I)*A(J)*R(I)*R(I)*R(J)*R(J)*TT(I)*TT(J)*4.0D0
            RE1R(I,J)=V(IJ)
            RE1R(J,I)=RE1R(I,J)
         ENDDO
      ENDDO
C
      IJ=0
      DO I=1,N
         DO J=1,I
            IJ=IJ+1
            G(IJ)=G(IJ)*A(I)*A(J)*R(I)*R(J)
            RE1R(I,J)=RE1R(I,J)+G(IJ)
            RE1R(J,I)=RE1R(I,J)
         ENDDO
      ENDDO
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_real_array(E)
      END
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE MATOUT(NBF,NMO,VEC,MBF)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      IMPLICIT real*8(A-H,O-Z)
      DIMENSION VEC(MBF,1)
C
      IAMARI=MOD(NMO,10)
      IROW=NMO/10
      IF(IAMARI.NE.0) THEN
         IROW=IROW+1
      ELSE
         IAMARI=10
      ENDIF
C
      DO 10 I=1,IROW
         ISTART=(I-1)*10+1
         IF(I.EQ.IROW) THEN
            IEND=(I-1)*10+IAMARI
         ELSE
            IEND=I*10
         END IF
         WRITE(6,9999) (II,II=ISTART,IEND)
         DO 20 J=1,NBF
            WRITE(6,9998) J,(VEC(J,K),K=ISTART,IEND)
   20    CONTINUE
         WRITE(6,9997)
   10 CONTINUE
      RETURN
 9999 FORMAT(4X,10(5X,I3,4X))
 9998 FORMAT(1X,I3,10(1X,F11.6))
 9997 FORMAT(//)
      END
C
C#NUMPAC#MINVD               REVISED ON 1984-11-30
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MINVD(A,KA,N,EPS,ILL)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(KA,N)
      INTEGER MX(1000)
      IF(N.LT.1.OR.N.GT.1000.OR.N.GT.KA.OR.EPS.LE.0.) GO TO 250
C-----LU DECOMPOSITION--------------------------------------------------
      JM1=0  ! dummy initialize
      M  =0  ! dummy initialize
      NM1=N-1
      DO 90 J=1,N
         IF(J.EQ.1) GO TO 30
         JM1=J-1
         DO 20 I=1,JM1
            M=MX(I)
            S=A(M,J)
            A(M,J)=A(I,J)
            IF(I.EQ.1) GO TO 21
            IM1=I-1
            DO 10 K=1,IM1
               S=A(I,K)*A(K,J)+S
   10       CONTINUE
   21       A(I,J)=S
   20    CONTINUE
   30    AM=0.
         DO 60 I=J,N
            S=A(I,J)
            IF(J.EQ.1) GO TO 50
            DO 40 K=1,JM1
               S=A(I,K)*A(K,J)+S
   40       CONTINUE
            A(I,J)=S
   50       AA=abs(S)
            IF(AA.LE.AM) GO TO 60
            AM=AA
            M=I
   60    CONTINUE
         IF(AM.LT.EPS) GO TO 240
         MX(J)=M
         IF(M.EQ.J) GO TO 80
         DO 70 K=1,J
            W=A(M,K)
            A(M,K)=A(J,K)
            A(J,K)=W
   70    CONTINUE
   80    IF(J.EQ.N) GO TO 100
         JP1=J+1
         W=-A(J,J)
         DO 91 I=JP1,N
            A(I,J)=A(I,J)/W
   91    CONTINUE
   90 CONTINUE
  100 IF(N.LE.2) GO TO 130
C-----INPLACE INVERSION OF L-COMPONENT----------------------------------
      DO 120 I=3,N
         IM1=I-1
         IM2=I-2
         DO 121 J=1,IM2
            S=A(I,J)
            JP1=J+1
            DO 110 K=JP1,IM1
                S=A(I,K)*A(K,J)+S
  110       CONTINUE
            A(I,J)=S
  121    CONTINUE
  120 CONTINUE
C-----INPLACE INVERSION OF U-COMPONENT----------------------------------
  130 A(1,1)=1./A(1,1)
      IF(N.EQ.1) GO TO 230
      DO 150 J=2,N
         A(J,J)=1./A(J,J)
         P=-A(J,J)
         JM1=J-1
         DO 151 I=1,JM1
            S=0.
            DO 140 K=I,JM1
               S=A(I,K)*A(K,J)+S
  140       CONTINUE
            A(I,J)=S*P
  151    CONTINUE
  150 CONTINUE
C-----INPLACE MULTIPLICATION OF L AND U COMPONENT-----------------------
      DO 190 J=1,NM1
         JP1=J+1
         DO 170 I=1,J
            S=A(I,J)
            DO 160 K=JP1,N
               S=A(I,K)*A(K,J)+S
  160       CONTINUE
            A(I,J)=S
  170    CONTINUE
         DO 191 I=JP1,N
            S=0.
            DO 180 K=I,N
                S=A(I,K)*A(K,J)+S
  180       CONTINUE
            A(I,J)=S
  191    CONTINUE
  190 CONTINUE
C------INTERCHANGE OF COLUMNS-------------------------------------------
      J=NM1
  200 M=MX(J)
      IF(M.EQ.J) GO TO 220
      DO 210 I=1,N
         W=A(I,M)
         A(I,M)=A(I,J)
         A(I,J)=W
  210 CONTINUE
  220 J=J-1
      IF(J.GE.1) GO TO 200
  230 ILL=0
      RETURN
  240 ILL=J
      RETURN
  250 ILL=30000
      RETURN
      END
C
C
C#NUMPAC#MNORMD              REVISED ON 1984-11-30
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MNORMD(A,KA,N,M,S,ILL)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL*8 A(KA,M),S(N),D,AM,F
      IF(N.LT.2.OR.N.GT.KA.OR.N.GT.M) GO TO 20
      F=1.0D0/LOG(2.0D0)
      DO 1 I=1,N
         AM=0.
         DO 2 J=1,N
            AM=MAX(abs(A(I,J)),AM)
    2    CONTINUE
         IF(AM.EQ.0.) GO TO 10
         NPS=INT(LOG(AM)*F)
         S(I)=2.0D0**NPS
         D=1.D0/S(I)
         DO 3 J=1,M
            A(I,J)=D*A(I,J)
    3    CONTINUE
    1 CONTINUE
      ILL=0
      RETURN
   10 ILL=I
      RETURN
   20 ILL=30000
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************
      SubRoutine ChoMP2g_density1(irc,EOcc,EVir,EFro,Wrk,lWrk)

*     Jonas Bostrom, Feb 2010
*
*     Purpose: To Compute MP2 density from Cholesky MO-vectors and
*              decomposed MP2 amplitudes.

#include "implicit.fh"
#include "chomp2g.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
*
      Character*16 SecNam
      Parameter (SecNam='ChoMP2g_density1')
*
      Character Fname*5
      Real*8 Wrk(lWrk), EOcc(*), EVir(*), EFro(*)

      Real*8 X(0:1)
      Data X /0.0D0,1.0D0/
*     -----------------------------
      MulD2h(i,j)=iEor(i-1,j-1) + 1
      iAdrVec(i,j,k) = (i-1) + (j-1)*nSym + (k-1)*nSym*nSym
*     -----------------------------
      maxvalue = 200

*     Do not delete vectors
*     ---------------------
      iClos = 2

*     Set type of Choleskyvectors
*     ---------------------------
      iTypL = 1
      iTypR = 2
      iVecOV = 6
      iVecOF = 4
      iVecOO = 5
      iVecFV = 3
      iVecVV = 9
*
*     Calc max number of cholesky vectors in a specific sym
*     -----------------------------------------------------
      nMP2VecMax = 0
      NumChoMax = 0
      Do i = 1, nSym
         nMP2VecMax = Max(nMP2VecMax,nMP2Vec(i))
         NumChoMax = Max(NumChoMax, NumCho(i))
      End Do
*
      nMoMoMax = 0
      Do iSym = 1, nSym
         nMoMoMax = max(nMoMo(iSym,iVecOV),nMoMoMax)
      End Do

*     Allocate Memory for Pab-Vector
*     ------------------------------
      lPab = nVir(1)*nVir(1)
      kPab(1) = 1
      Do iSym = 2, nSym
         kPab(iSym) = kPab(iSym-1) + nVir(iSym-1)*nVir(iSym-1)
         lPab = lPab + nVir(iSym)*nVir(iSym)
      End Do
      kEndPab = kPab(1) + lPab
      Call FZero(Wrk(kPab(1)),lPab)

*     Allocate Memory for Wab-Vector
*     ------------------------------
      lWab = nVir(1)*nVir(1)
      kWab(1) = kEndPab
      Do iSym = 2, nSym
         kWab(iSym) = kWab(iSym-1) + nVir(iSym-1)*nVir(iSym-1)
         lWab = lWab + nVir(iSym)*nVir(iSym)
      End Do
      kEndWab = kWab(1) + lWab
      Call FZero(Wrk(kWab(1)),lWab)

*     Allocate memory for Pij-Vector
*     ------------------------------

      lPij = nOcc(1)*nOcc(1)
      kPij(1) = kEndWab
      Do iSym = 2, nSym
         kPij(iSym) = kPij(iSym-1) + nOcc(iSym-1)*nOcc(iSym-1)
         lPij = lPij + nOcc(iSym)*nOcc(iSym)
      End Do
      kEndPij = kPij(1) + lPij
      Call FZero(Wrk(kPij(1)),lPij)

*     Allocate memory for Wij-Vector
*     ------------------------------

      lWij = nOcc(1)*nOcc(1)
      kWij(1) = kEndPij
      Do iSym = 2, nSym
         kWij(iSym) = kWij(iSym-1) + nOcc(iSym-1)*nOcc(iSym-1)
         lWij = lWij + nOcc(iSym)*nOcc(iSym)
      End Do
      kEndWij = kWij(1) + lWij
      Call FZero(Wrk(kWij(1)),lWij)

*     Allocate memory for Pai-Vector
*     ------------------------------

      lPai = nVir(1)*nOcc(1)
      kPai(1) = kEndWij
      Do iSym = 2, nSym
         kPai(iSym) = kPai(iSym-1) + nVir(iSym-1)*nOcc(iSym-1)
         lPai = lPai + nVir(iSym)*nOcc(iSym)
      End Do
      kEndPai = kPai(1) + lPai
      Call FZero(Wrk(kPai(1)),lPai)

*     Allocate memory for Wai-Vector
*     ------------------------------

      lWai = nVir(1)*nOcc(1)
      kWai(1) = kEndPai
      Do iSym = 2, nSym
         kWai(iSym) = kWai(iSym-1) + nVir(iSym-1)*nOcc(iSym-1)
         lWai = lWai + nVir(iSym)*nOcc(iSym)
      End Do
      kEndWai = kWai(1) + lWai
      Call FZero(Wrk(kWai(1)),lWai)

*     Allocate memory for PaK-Vector
*     ------------------------------

      lPaK = nVir(1)*nFro(1)
      kPaK(1) = kEndWai
      Do iSym = 2, nSym
         kPaK(iSym) = kPaK(iSym-1) + nVir(iSym-1)*nFro(iSym-1)
         lPaK = lPaK + nVir(iSym)*nFro(iSym)
      End Do
      kEndPaK = kPaK(1) + lPaK
      Call FZero(Wrk(kPaK(1)),lPaK)

*     Allocate memory for WaK-Vector
*     ------------------------------

      lWaK = nVir(1)*nFro(1)
      kWaK(1) = kEndPaK
      Do iSym = 2, nSym
         kWaK(iSym) = kWaK(iSym-1) + nVir(iSym-1)*nOcc(iSym-1)
         lWaK = lWaK + nVir(iSym)*nOcc(iSym)
      End Do
      kEndWaK = kWaK(1) + lWaK
      Call FZero(Wrk(kWaK(1)),lWaK)


*     Allocate memory for PiK-vector (occ-fro)
*     ----------------------------------------

      lPiK = nOcc(1)*nFro(1)
      kPiK(1) = kEndWaK
      Do iSym = 2, nSym
         kPiK(iSym) = kPiK(iSym-1) + nOcc(iSym-1)*nFro(iSym-1)
         lPiK = lPiK + nOcc(iSym)*nFro(iSym)
      End Do
      kEndPiK = kPiK(1) + lPiK
      Call FZero(Wrk(kPiK(1)),lPiK)

*     Allocate memory for WiK-vector (occ-fro)
*     ----------------------------------------

      lWiK = nOcc(1)*nFro(1)
      kWiK(1) = kEndPiK
      Do iSym = 2, nSym
         kWiK(iSym) = kWiK(iSym-1) + nOcc(iSym-1)*nFro(iSym-1)
         lWiK = lWiK + nOcc(iSym)*nFro(iSym)
      End Do
      kEndWiK = kWiK(1) + lWiK
      Call FZero(Wrk(kWiK(1)),lWiK)

*     Allocate memory for WJK-vector (fro-fro)
*     ----------------------------------------

      lWJK = nFro(1)*nFro(1)
      kWJK(1) = kEndWiK
      Do iSym = 2, nSym
         kWJK(iSym) = kWJK(iSym-1) + nFro(iSym-1)*nFro(iSym-1)
         lWJK = lWJK + nFro(iSym)*nFro(iSym)
      End Do
      kEndWJK = kWJK(1) + lWJK
      Call FZero(Wrk(kWJK(1)),lWJK)

*     Allocate memory for Lagr-vector
*     ------------------------------

      lLagr = nOcc(1)*nVir(1)
      kLagr(1) = kEndWJK
      Do iSym = 2, nSym
         kLagr(iSym) = kLagr(iSym-1) + nOcc(iSym-1)*nVir(iSym-1)
         lLagr = lLagr + nOcc(iSym)*nVir(iSym)
      End Do
      kEndLagr = kLagr(1) + lLagr
      Call FZero(Wrk(kLagr(1)),lLagr)

*     Allocate memory for FrozenLagr-vector
*     -------------------------------------

      lFLagr = nFro(1)*nVir(1)
      kFLagr(1) = kEndLagr
      Do iSym = 2, nSym
         kFLagr(iSym) = kFLagr(iSym-1) + nFro(iSym-1)*nVir(iSym-1)
         lFLagr = lFLagr + nFro(iSym)*nVir(iSym)
      End Do
      kEndFLagr = kFLagr(1) + lFLagr
      Call FZero(Wrk(kFlagr(1)),lFLagr)

      nVec = Min(maxvalue,Max(nMP2VecMax,NumChoMax))
      If(nVec .lt. 1) Then
         Call ChoMP2_Quit(SecNam,'Insufficient memory','[1]')
      End If

*     Allocate memory for X^KJ-vector
*     -------------------------------

      lX = nVec*nMp2VecMax
      kX = kEndFLagr
      kEndX = kX + lX
*
      Do iSym = 1, nSym

*        Allocate memory for Ria-vectors
*        -------------------------------
         lRia = nMoMo(iSym,iVecOV)*nVec
         kRia = kEndX
         kEndRia = kRia + lRia
         kLia = kRia
*
         lRia2 = nMoMo(iSym,iVecOV)*nVec
         kRia2 = kEndRia
         kEndRia2 = kRia2 + lRia2
         kLia2 = kRia2

*        Allocate memory for L-vectors
*        -----------------------------
         lLKa = nMoMo(iSym,iVecFV)*nVec
         kLKa = kEndRia2
         kEndLKa = kLKa + lLKa

         lLab = nMoMo(iSym,iVecVV)*nVec
         kLab = kEndLKa
         kEndLab = kLab + lLab

         lLij = nMoMo(iSym,iVecOO)*nVec
         kLij = kEndLab
         kEndLij = kLij + lLij

         lLiK = nMoMo(iSym,iVecOF)*nVec
         kLiK = kEndLij
         kEndLiK = kLiK + lLiK

*        Allocate memory for U-vector
*        ----------------------------

         lU = nMoMo(iSym,iVecOV)*nVec
         kU = kEndLiK
         kEndU = kU + lU

*        Setup batch over amplitude vectors.
*        -----------------------------------
         nBatR = (nMP2Vec(iSym)-1)/nVec + 1
         nBatL = (NumCho(iSym)-1)/nVec + 1
         If((nMoMo(iSym,iVecOV) .gt. 0).and.(nMp2Vec(iSym).gt.0)) Then
*
*           Open the File for reordered amplitude vectors
*           ---------------------------------------------
            Call ChoMP2_OpenF(1,iTypR,iSym)
            Call ChoMP2_OpenF(1,iTypL,iSym)

            iSeed = 7
            LuUVec = IsFreeUnit(iSeed)
            Write(Fname,'(A4,I1)') 'TMPV',1
            Call DaName_MF_WA(LuUVec,Fname)
*
            iSeed = 7
            LuVVec = IsFreeUnit(iSeed)
            Write(Fname,'(A4,I1)') 'TMPV',2
            Call DaName_MF_WA(LuVVec,Fname)
*
*           Calculate Intermediate vectors U
*           --------------------------------
            Do kBat = 1, nBatR
               Call FZero(Wrk(kX),lX)
               If (kBat .eq. nBatR) Then
                  NumVecK = nMP2Vec(iSym) - nVec*(nBatR-1)
               Else
                  NumVecK = nVec
               End If
               kVec = nVec*(kBat-1) + 1

*              Read Amplitude vectors from kBat
*              --------------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecOV)*NumVecK
               iAdr = nMoMo(iSym,iVecOV)*(kVec-1) + 1
               Call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia),lTot,
     &                      iAdr)
*
               Do jBat = 1, nBatR
                  If (jBat .eq. nBatR) Then
                     NumVecJ = nMP2Vec(iSym) - nVec*(nBatR-1)
                  Else
                     NumVecJ = nVec
                  End If
                  jVec = nVec*(jBat-1) + 1
*
*                 Read Amplitude vectors from jBat
*                 --------------------------------
                  iOpt = 2
                  lTot = nMoMo(iSym,iVecOV)*NumVecJ
                  iAdr = nMoMo(iSym,iVecOV)*(jVec-1) + 1
                  Call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia2),lTot,
     &                         iAdr)

*                 Construct X^JK-vector
*                 ---------------------
                 iOffX = NumVecK*(jVec-1)
                 Call dGemm_('T','N',NumVecK,NumVecJ,nMoMo(iSym,iVecOV),
     &                       1.0d0, Wrk(kRia),nMoMo(iSym,iVecOV),
     &                       Wrk(kRia2),nMoMo(iSym,iVecOV),0.0d0,
     &                       Wrk(kX+iOffX),NumVecK)

               End Do
*
               iOpt = 1
               lTot = nMP2Vec(iSym)*NumVecK
               iAdr = 1 + nMP2Vec(iSym)*(kVec-1)
               Call dDaFile(LuVVec,iOpt,Wrk(kX),lTot,iAdr)
            End Do
            Do kBat = 1, nBatR
               If (kBat .eq. nBatR) Then
                  NumVecK = nMP2Vec(iSym) - nVec*(nBatR-1)
               Else
                  NumVecK = nVec
               End If
               kVec = nVec*(kBat-1) + 1
*
               iOpt = 2
               lTot = nMP2Vec(iSym)*NumVecK
               iAdr = 1 + nMP2Vec(iSym)*(kVec-1)
               Call dDaFile(LuVVec,iOpt,Wrk(kX),lTot,iAdr)

               Do jBat = 1, nBatR
                  If (jBat .eq. nBatR) Then
                     NumVecJ = nMP2Vec(iSym) - nVec*(nBatR-1)
                  Else
                     NumVecJ = nVec
                  End If
                  jVec = nVec*(jBat-1) + 1

*                 Read Amplitude vectors from jBat
*                 --------------------------------
                  iOpt = 2
                  lTot = nMoMo(iSym,iVecOV)*NumVecJ
                  iAdr = nMoMo(iSym,iVecOV)*(jVec-1) + 1
                  Call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia),lTot,
     &                         iAdr)
*
                 iOffX = NumVecK*(jVec-1)
                 Fac = X(min((jBat-1),1))
                 Call dGemm_('N','T',nMoMo(iSym,iVecOV),NumVecK,NumVecJ,
     &                       1.0d0,Wrk(kRia),nMoMo(iSym,iVecOV),
     &                       Wrk(kX+iOffX),NumVecK,Fac,
     &                       Wrk(kU),nMoMo(iSym,iVecOV))
               End Do
*
               iOpt = 1
               lTot = nMoMo(iSym,iVecOV)*NumVecK
               iAdr = 1 + nMoMo(iSym,iVecOV)*(kVec-1)
               Call dDaFile(LuUVec,iOpt,Wrk(kU),
     &                      lTot,iAdr)
            End Do
*
*           Calculate "Coulomb"-contributions to Densities from U
*           -----------------------------------------------------
            Do kBat = 1,nBatR
               If (kBat .eq. nBatR) Then
                  NumVecK = nMP2Vec(iSym) - nVec*(nBatR-1)
               Else
                  NumVecK = nVec
               End If
               kVec = nVec*(kBat-1) + 1

*              Read Amplitude vectors from kBat
*              --------------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecOV)*NumVecK
               iAdr = nMoMo(iSym,iVecOV)*(kVec-1) + 1
               Call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia),lTot,
     &                      iAdr)

*              Load intermediate vectors U^K_ib
*              --------------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecOV)*NumVecK
               iAdr = nMoMo(iSym,iVecOv)*(kVec-1) + 1
               Call dDaFile(LuUVec,iOpt,Wrk(kU),lTot,iAdr)

*              Calculate the "Coulomb" Contribution to Pab
*              -------------------------------------------
               iOff1 = 0
               Do iSymI = 1, nSym
                  iSymA = MulD2h(iSym,iSymI)
                  If(nOcc(iSymI)*nVir(iSymA).eq.0) Go To 121
                  Do iI = 1, nOcc(iSymI)
                     iOff = (iI-1)*nVir(iSymA) + iOff1
                     Call dGemm_('N','T',nVir(iSymA),nVir(iSymA),
     &                          NumVecK, 4.0d0,
     &                          Wrk(kRia+iOff),nMoMo(iSym,iVecOV),
     &                          Wrk(kU+iOff),nMoMo(iSym,iVecOV),1.0d0,
     &                          Wrk(kPab(iSymA)),nVir(iSymA))
                  End Do
 121              Continue
                  iOff1 = iOff1 + nOcc(iSymI)*nVir(iSymA)
               End Do
*              Calculate the "Coulomb" Contribution to Pik
*              -------------------------------------------
*
               Do kVec1 = 1, NumVecK
                  iOff1 = 0
                  Do iSymK = 1, nSym
                     iSymI = iSymK
                     iSymB = MulD2h(iSymK,iSym)
                     If(nOcc(iSymK)*nVir(iSymB) .eq. 0) Go To 122
                     iOff = nMoMo(iSym,iVecOV)*(kVec1-1) + iOff1
                     Call dGemm_('T','N', nOcc(iSymI), nOcc(iSymK),
     &                          nVir(iSymB), -4.0d0,
     &                          Wrk(kU+iOff),nVir(iSymB),
     &                          Wrk(kRia+iOff),nVir(iSymB),1.0d0,
     &                          Wrk(kPij(iSymK)),nOcc(iSymI))
 122                 Continue
                     iOff1 = iOff1 + nOcc(iSymI)*nVir(iSymB)
                  End Do
               End Do

            End Do
*

*           Calculate Intermediate vectors U*
*           ---------------------------------
            Do kBat = 1, nBatL
               Call FZero(Wrk(kX),lX)
               If (kBat .eq. nBatL) Then
                  NumVecK = NumCho(iSym) - nVec*(nBatL-1)
               Else
                  NumVecK = nVec
               End If
               kVec = nVec*(kBat-1) + 1

*              Read Integral vectors from kBat
*              --------------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecOV)*NumVecK
               iAdr = 1 + nMoMo(iSym,iVecOV)*(kVec-1) +
     &                iAdrOff(iSym,iVecOV)
               Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLia),lTot,
     &                      iAdr)
*
               Do jBat = 1, nBatR
                  If (jBat .eq. nBatR) Then
                     NumVecJ = nMP2Vec(iSym) - nVec*(nBatR-1)
                  Else
                     NumVecJ = nVec
                  End If
                  jVec = nVec*(jBat-1) + 1
*
*                 Read Amplitude vectors from jBat
*                 --------------------------------
                  iOpt = 2
                  lTot = nMoMo(iSym,iVecOV)*NumVecJ
                  iAdr = nMoMo(iSym,iVecOV)*(jVec-1) + 1
                  Call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia2),lTot,
     &                         iAdr)

*                 Construct X^JK-vector
*                 ---------------------
                 iOffX = NumVecK*(jVec-1)
                 Call dGemm_('T','N',NumVecK,NumVecJ,nMoMo(iSym,iVecOV),
     &                       1.0d0, Wrk(kLia),nMoMo(iSym,iVecOV),
     &                       Wrk(kRia2),nMoMo(iSym,iVecOV),0.0d0,
     &                       Wrk(kX+iOffX),NumVecK)
               End Do
*
               iOpt = 1
               lTot = nMP2Vec(iSym)*NumVecK
               iAdr = 1 + nMP2Vec(iSym)*(kVec-1)
               Call dDaFile(LuVVec,iOpt,Wrk(kX),lTot,iAdr)
            End Do
            Do kBat = 1, nBatL
               If (kBat .eq. nBatL) Then
                  NumVecK = NumCho(iSym) - nVec*(nBatL-1)
               Else
                  NumVecK = nVec
               End If
               kVec = nVec*(kBat-1) + 1
*
               iOpt = 2
               lTot = nMP2Vec(iSym)*NumVecK
               iAdr = 1 + nMP2Vec(iSym)*(kVec-1)
               Call dDaFile(LuVVec,iOpt,Wrk(kX),lTot,iAdr)
*
               Do jBat = 1, nBatR
                  If (jBat .eq. nBatR) Then
                     NumVecJ = nMP2Vec(iSym) - nVec*(nBatR-1)
                  Else
                     NumVecJ = nVec
                  End If
                  jVec = nVec*(jBat-1) + 1

*                 Read Amplitude vectors from jBat
*                 --------------------------------
                  iOpt = 2
                  lTot = nMoMo(iSym,iVecOV)*NumVecJ
                  iAdr = nMoMo(iSym,iVecOV)*(jVec-1) + 1
                  Call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia),lTot,
     &                         iAdr)
*
                 iOffX = NumVecK*(jVec-1)
                 Fac = X(min((jBat-1),1))
                 Call dGemm_('N','T',nMoMo(iSym,iVecOV),NumVecK,NumVecJ,
     &                       1.0d0,Wrk(kRia),nMoMo(iSym,iVecOV),
     &                       Wrk(kX+iOffX),NumVecK,Fac,
     &                       Wrk(kU),nMoMo(iSym,iVecOV))
               End Do
*
               iOpt = 1
               lTot = nMoMo(iSym,iVecOV)*NumVecK
               iAdr = 1 + nMoMo(iSym,iVecOV)*(kVec-1)
               Call dDaFile(LuUVec,iOpt,Wrk(kU),lTot,iAdr)
            End Do

*           Calculate "Coulomb"-contributions to Densities and
*           the Lagrangian from U*
*           -----------------------------------------------------
            Do kBat = 1,nBatL
*
               If (kBat .eq. nBatL) Then
                  NumVecK = NumCho(iSym) - nVec*(nBatL-1)
               Else
                  NumVecK = nVec
               End If
               kVec = nVec*(kBat-1) + 1

*              Read Integral vectors(FV) from kBat
*              --------------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecFV)*NumVecK
               iAdr = 1 + nMoMo(iSym,iVecFV)*(kVec-1) +
     &                 iAdrOff(iSym,iVecFV)
               Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLKa),lTot,
     &                      iAdr)
*
*              Read Integral vectors(VV) from kBat
*              --------------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecVV)*NumVecK
               iAdr = 1 + nMoMo(iSym,iVecVV)*(kVec-1) +
     &                 iAdrOff(iSym,iVecVV)
               Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLab),lTot,
     &                      iAdr)

*              Read Integral vectors(OO) from kBat
*              --------------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecOO)*NumVecK
               iAdr = 1 + nMoMo(iSym,iVecOO)*(kVec-1) +
     &                 iAdrOff(iSym,iVecOO)
               Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLij),lTot,
     &                      iAdr)

*              Read Integral vectors(OF) from kBat
*              --------------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecOF)*NumVecK
               iAdr = 1 + nMoMo(iSym,iVecOF)*(kVec-1) +
     &                 iAdrOff(iSym,iVecOF)
               Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLiK),lTot,
     &                      iAdr)

*              Read Integral vectors(OV) from kBat
*              --------------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecOV)*NumVecK
               iAdr = 1 + nMoMo(iSym,iVecOV)*(kVec-1) +
     &                 iAdrOff(iSym,iVecOV)
               Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLia),lTot,
     &                      iAdr)

*              Load intermediate vectors
*              -------------------------
               iOpt = 2
               lTot = nMoMo(iSym,iVecOV)*NumVecK
               iAdr = nMoMo(iSym,iVecOv)*(kVec-1) + 1
               Call dDaFile(LuUVec,iOpt,Wrk(kU),lTot,iAdr)

*        Calculate the "Coulomb" Contribution to Froz-occupied density PiK
*        -----------------------------------------------------------------
*
               Do kVec1 = 1, NumVecK
                  iOffU1 = 0
                  iOffL1 = 0
                  Do iSymK = 1, nSym
                     iSymI = iSymK
                     iSymB = MulD2h(iSymK,iSym)
                     If(nOcc(iSymI)*nFro(iSymK)*nVir(iSymB) .eq. 0)
     &                      Go To 131
                    iOffU = nMoMo(iSym,iVecOV)*(kVec1-1) + iOffU1
                    iOffL = nMoMo(iSym,iVecFV)*(kVec1-1) + iOffL1
                    Call dGemm_('T','N', nOcc(iSymI), nFro(iSymK),
     &                          nVir(iSymB), -4.0d0,
     &                          Wrk(kU+iOffU),nVir(iSymB),
     &                          Wrk(kLKa+iOffL),nVir(iSymB),1.0d0,
     &                          Wrk(kPiK(iSymK)),nOcc(iSymI))
 131                 Continue
                     iOffU1 = iOffU1 + nOcc(iSymI)*nVir(iSymB)
                     iOffL1 = iOffL1 + nFro(iSymK)*nVir(iSymB)
                  End Do
               End Do

*              Calculate the "Coulomb" contribution to Wij (froz-occ)
*              ------------------------------------------------------

               Do kVec1 = 1, NumVecK
                  iOffU1 = 0
                  iOffL1 = 0
                  Do iSymK = 1, nSym
                     iSymI = iSymK
                     iSymB = MulD2h(iSymK,iSym)
                     If(nOcc(iSymI)*nFro(iSymK)*nVir(iSymB) .eq. 0)
     &                      Go To 135
                    iOffU = nMoMo(iSym,iVecOV)*(kVec1-1) + iOffU1
                    iOffL = nMoMo(iSym,iVecFV)*(kVec1-1) + iOffL1
                    Call dGemm_('T','N', nOcc(iSymI), nFro(iSymK),
     &                          nVir(iSymB), 4.0d0,
     &                          Wrk(kU+iOffU),nVir(iSymB),
     &                          Wrk(kLKa+iOffL),nVir(iSymB),1.0d0,
     &                          Wrk(kWiK(iSymK)),nOcc(iSymI))
 135                 Continue
                     iOffU1 = iOffU1 + nOcc(iSymI)*nVir(iSymB)
                     iOffL1 = iOffL1 + nFro(iSymK)*nVir(iSymB)
                  End Do
               End Do


*              Calculate "Coulomb"-contribution to Lagr(IV)
*              --------------------------------------------
               Do kVec1 = 1, NumVecK
                  iOffU1 = 0
                  iOffL1 = 0
                  Do iSymA = 1, nSym
                     iSymI = iSymA
                     iSymB = MulD2h(iSymA,iSym)
                     If(nOcc(iSymI)*nVir(iSymA)*nVir(iSymB) .eq. 0)
     &                      Go To 132
                     iOffU = nMoMo(iSym,iVecOV)*(kVec1-1) + iOffU1
                     iOffL = nMoMo(iSym,iVecVV)*(kVec1-1) + iOffL1
                     Call dGemm_('T','N', nVir(iSymA), nOcc(iSymI),
     &                          nVir(iSymB), 4.0d0,
     &                          Wrk(kLab+iOffL),nVir(iSymB),
     &                          Wrk(kU+iOffU),nVir(iSymB),1.0d0,
     &                          Wrk(kLagr(iSymA)),nVir(iSymA))
*
 132                 Continue
                     iOffU1 = iOffU1 + nOcc(iSymI)*nVir(iSymB)
                     iOffL1 = iOffL1 + nVir(iSymA)*nVir(iSymB)
                  End Do
               End Do

*              Calculate "Coulomb"-contribution to Lagr(III)
*              ---------------------------------------------
               iOffU1 = 0
               iOffL1 = 0
               Do iSymJ = 1, nSym
                  iSymA = MulD2h(iSym,iSymJ)
                  iSymI = iSymA
                  If(nOcc(iSymI)*nVir(iSymA)*nOcc(iSymJ).eq.0) Go To 133
                  Do iJ = 1, nOcc(iSymJ)
                     iOffU = (iJ-1)*nVir(iSymA) + iOffU1
                     iOffL = (iJ-1)*nOcc(iSymI) + iOffL1
                     Call dGemm_('N','T',nVir(iSymA),nOcc(iSymI),
     &                         NumVecK, -4.0d0,
     &                         Wrk(kU+iOffU),nMoMo(iSym,iVecOV),
     &                         Wrk(kLij+iOffL),nMoMo(iSym,iVecOO),1.0d0,
     &                         Wrk(kLagr(iSymA)),nVir(iSymA))
                  End Do
 133              Continue
                  iOffU1 = iOffU1 + nOcc(iSymJ)*nVir(iSymA)
                  iOffL1 = iOffL1 + nOcc(iSymJ)*nOcc(iSymI)
               End Do

*              Calculate "Coulomb"-contribution to Wai
*              ---------------------------------------
               iOffU1 = 0
               iOffL1 = 0
               Do iSymJ = 1, nSym
                  iSymA = MulD2h(iSym,iSymJ)
                  iSymI = iSymA
                  If(nOcc(iSymI)*nVir(iSymA)*nOcc(iSymJ).eq.0) GoTo 1331
                  Do iJ = 1, nOcc(iSymJ)
                     iOffU = (iJ-1)*nVir(iSymA) + iOffU1
                     iOffL = (iJ-1)*nOcc(iSymI) + iOffL1
                     Call dGemm_('N','T',nVir(iSymA),nOcc(iSymI),
     &                         NumVecK, 8.0d0,
     &                         Wrk(kU+iOffU),nMoMo(iSym,iVecOV),
     &                         Wrk(kLij+iOffL),nMoMo(iSym,iVecOO),1.0d0,
     &                         Wrk(kWai(iSymA)),nVir(iSymA))
                  End Do
 1331             Continue
                  iOffU1 = iOffU1 + nOcc(iSymJ)*nVir(iSymA)
                  iOffL1 = iOffL1 + nOcc(iSymJ)*nOcc(iSymI)
               End Do


*              Calculate "Coulomb"-contribution to Wab
*              ---------------------------------------
               iOff1 = 0
               Do iSymI = 1, nSym
                  iSymA = MulD2h(iSym,iSymI)
                  If(nOcc(iSymI)*nVir(iSymA).eq.0) Go To 151
                  Do iI = 1, nOcc(iSymI)
                     iOff = (iI-1)*nVir(iSymA)+iOff1
                     Call dGemm_('N','T',nVir(iSymA),nVir(iSymA),
     &                          NumVecK, 4.0d0,
     &                          Wrk(kLia+iOff),nMoMo(iSym,iVecOV),
     &                          Wrk(kU+iOff),nMoMo(iSym,iVecOV),1.0d0,
     &                          Wrk(kWab(iSymA)),nVir(iSymA))
                  End Do
 151              Continue
                  iOff1 = iOff1 + nOcc(iSymI)*nVir(iSymA)
               End Do

*              Calculate "Coulomb"-contribution to Wij (Wik)
*              ---------------------------------------------
               Do kVec1 = 1, NumVecK
                  iOff1 = 0
                  Do iSymK = 1, nSym
                     iSymI = iSymK
                     iSymB = MulD2h(iSymK,iSym)
                     If(nOcc(iSymK)*nVir(iSymB) .eq. 0) Go To 152
                     iOff = nMoMo(iSym,iVecOV)*(kVec1-1) + iOff1
                     Call dGemm_('T','N', nOcc(iSymI), nOcc(iSymK),
     &                          nVir(iSymB), 4.0d0,
     &                          Wrk(kU+iOff),nVir(iSymB),
     &                          Wrk(kLia+iOff),nVir(iSymB),1.0d0,
     &                          Wrk(kWij(iSymK)),nOcc(iSymI))
 152                 Continue
                  End Do
               End Do


*     Calculate "Coulomb"-contribution to the Frozen Lagr(III)
*     --------------------------------------------------------
               iOffU1 = 0
               iOffL1 = 0
               Do iSymJ = 1, nSym
                  iSymA = MulD2h(iSym,iSymJ)
                  iSymI = iSymA
                  If(nFro(iSymI)*nVir(iSymA)*nOcc(iSymJ).eq.0) Go To 134
                  Do iJ = 1, nOcc(iSymJ)
                     iOffU = (iJ-1)*nVir(iSymA) + iOffU1
                     iOffL = (iJ-1)*nFro(iSymI) + iOffL1
                     Call dGemm_('N','T',nVir(iSymA),nFro(iSymI),
     &                         NumVecK, -4.0d0,
     &                         Wrk(kU+iOffU),nMoMo(iSym,iVecOV),
     &                         Wrk(kLiK+iOffL),nMoMo(iSym,iVecOF),1.0d0,
     &                         Wrk(kFLagr(iSymA)),nVir(iSymA))
                  End Do
 134              Continue
                  iOffU1 = iOffU1 + nOcc(iSymJ)*nVir(iSymA)
                  iOffL1 = iOffL1 + nOcc(iSymJ)*nFro(iSymI)
               End Do


*     Calculate "Coulomb"-contribution to the WaK (vir-froz)
*     --------------------------------------------------------
               iOffU1 = 0
               iOffL1 = 0
               Do iSymJ = 1, nSym
                  iSymA = MulD2h(iSym,iSymJ)
                  iSymI = iSymA
                  If(nFro(iSymI)*nVir(iSymA)*nOcc(iSymJ).eq.0) GoTo 1341
                  Do iJ = 1, nOcc(iSymJ)
                     iOffU = (iJ-1)*nVir(iSymA) + iOffU1
                     iOffL = (iJ-1)*nFro(iSymI) + iOffL1
                     Call dGemm_('N','T',nVir(iSymA),nFro(iSymI),
     &                         NumVecK, 8.0d0,
     &                         Wrk(kU+iOffU),nMoMo(iSym,iVecOV),
     &                         Wrk(kLiK+iOffL),nMoMo(iSym,iVecOF),1.0d0,
     &                         Wrk(kWaK(iSymA)),nVir(iSymA))
                  End Do
 1341             Continue
                  iOffU1 = iOffU1 + nOcc(iSymJ)*nVir(iSymA)
                  iOffL1 = iOffL1 + nOcc(iSymJ)*nFro(iSymI)
               End Do
            End Do

            Call ChoMP2_OpenF(iClos,iTypR,iSym)
            Call ChoMP2_OpenF(iClos,iTypL,iSym)
            Call DaClos(LuUVec)
            Call DaClos(LuVVec)

         End If                 ! vector check
      End Do !iSym

***********************************************************
*     --------------------------------------------------  *
*     Calculate the exchange part needing U_ic^K-vectors  *
*     --------------------------------------------------  *
***********************************************************
*     Calculate the max number of orbitals of a specific type
*     -------------------------------------------------------
      nFroMax = 0
      nVirMax = 0
      nOccMax = 0
      Do iSym = 1, nSym
         nFroMax = Max(nFroMax,nFro(iSym))
         nVirMax = Max(nVirMax,nVir(iSym))
         nOccMax = Max(nOccMax,nOcc(iSym))
      End Do



      If(nVirMax .gt. 1) Then
         nB = Min(nVirMax,maxvalue)
      Else
         nB = nVirMax
      End If

*     Allocate memory for T_[i]j^[b]c
*     -------------------------------
      lAmp = nVirMax*nB*nOccMax
      kAmp = kEndFLagr
      kEndAmp = kAmp + lAmp
      Call FZero(Wrk(kAmp),lAmp)

*
*     Allocate memory for Rjc^K
*     -------------------------
      lRjc = nVirMax*nVec
      kRjc = kEndAmp
      kEndRjc = kRjc+lRjc

*     Allocate memory for Rib^K
*     -------------------------
      lRib = nOccMax*nVec
      kRib = kEndRjc
      kEndRib = kRib + lRib


*     Open files for Reordered R-vectors
*     ----------------------------------
      iSeed = 7
      LuRInv(1) = IsFreeUnit(iSeed)
      Write(Fname,'(A4,I1)') 'TMPV',4
      Call DaName_MF_WA(LuRInv(1),Fname)
*
      iSeed = 8
      LuRInv(2) = IsFreeUnit(iSeed)
      Write(Fname,'(A4,I1)') 'TMPV',5
      Call DaName_MF_WA(LuRInv(2),Fname)

*
      Do jSym = 1, nSym
         If((nMoMo(jSym,iVecOV) .le. 0) .or.
     &      (nMp2Vec(jSym)*NumCho(jSym)).le.0)
     &       Go To 10

*        Allocate memory for Ric^J
*        -------------------------
         lRic = nMoMo(jSym,iVecOV)*nVec
         kRic = kEndRib
         kEndRic = kRic + lRic

*        Allocate memory for Lic^J
*        -------------------------
         lLic = nMoMo(jSym,iVecOV)*nVec
         kLic = kEndRic
         kEndLic = kLic + lLic

*        Allocate memory for Lab^J
*        -------------------------
         lLab = nMoMo(jSym,iVecVV)*nVec
         kLab = kEndLic
         kEndLab = kLab + lLab

*        Allocate memory for Lji^J
*        -------------------------
         lLji = nMoMo(jSym,iVecOO)*nVec
         kLji = kEndLab
         kEndLji = kLji + lLji

*        Allocate memory for LKa^J
*        -------------------------
         lLKa = nMoMo(jSym,iVecFV)*nVec
         kLKa = kEndLji
         kEndLKa = kLKa + lLKa

*        Allocate memory for LiK^J
*        -------------------------
         lLiK = nMoMo(jSym,iVecOF)*nVec
         kLiK = kEndLKa
         kEndLiK = kLiK + lLiK

*        Allocate memory for Ujb^J
*        -------------------------
         lU = nMoMo(jSym,iVecOV)*nVec
         kU = kEndLiK
         kEndU = kU+lU

*        Allocate memory for Vjb^J
*        -------------------------
         lV = nMoMo(jSym,iVecOV)*nVec
         kV = kEndU
         kEndV = kV+lV

         nBatR = (nMP2Vec(jSym)-1)/nVec + 1
         nBatL = (NumCho(jSym)-1)/nVec + 1
*
*        Open the File for reordered amplitude vectors
*        ---------------------------------------------
         Call ChoMP2_OpenF(1,iTypR,jSym)
         Call ChoMP2_OpenF(1,iTypL,jSym)

         iSeed = 7
         LuUVec = IsFreeUnit(iSeed)
         Write(Fname,'(A4,I1)') 'TMPV',1
         Call DaName_MF_WA(LuUVec,Fname)

         iSeed = 7
         LuVVec = IsFreeUnit(iSeed)
         Write(Fname,'(A4,I1)') 'TMPV',2
         Call DaName_MF_WA(LuVVec,Fname)

         nBatMax = Max(nBatR,nBatL)
         Do jBat = 1, nBatMax
            Call fZero(Wrk(kU),lU)
            Call fZero(Wrk(kV),lV)
            If (jBat .eq. nBatR) Then
               NumRVecJ = nMP2Vec(jSym) - nVec*(nBatR-1)
            Else If(jBat .gt. nBatR) Then
               NumRVecJ = 0
            Else
               NumRVecJ = nVec
            End If
            If (jBat .eq. nBatL) Then
               NumLVecJ = NumCho(jSym) - nVec*(nBatL-1)
            Else If(jBat .gt. nBatL) Then
               NumLVecJ = 0
            Else
               NumLVecJ = nVec
            End If
            jVec = nVec*(jBat-1) + 1

*           Read Amplitude vectors from kBat
*           --------------------------------
            If(NumRVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecOV)*NumRVecJ
               iAdr = nMoMo(jSym,iVecOV)*(jVec-1) + 1
               Call dDaFile(lUnit_F(jSym,iTypR),iOpt,Wrk(kRic),lTot,
     &                      iAdr)
            End If
            If(NumLVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecOV)*NumLVecJ
               iAdr = nMoMo(jSym,iVecOV)*(jVec-1) + 1
               Call dDaFile(lUnit_F(jSym,iTypL),iOpt,Wrk(kLic),lTot,
     &                      iAdr)
            End If

            Do iSymJ = 1, nSym

               iSymB = MulD2h(jSym,iSymJ)
               If(nVir(iSymB) .eq. 0) Go To 202
               nBBlock = (nVir(iSymB)-1)/nB + 1

               Do iSymI = 1, nSym
                  iSymC = MulD2h(jSym,iSymI)
                  iSymJC = MulD2h(iSymJ,iSymC)
                  iSymIB = MulD2h(iSymI,iSymB)
                  NumIC = nOcc(iSymI)*nVir(iSymC)
                  If(nOcc(iSymI)*nVir(iSymC)*(NumRVecJ+NumLVecJ) .eq. 0)
     &              Go To 201
                  Do iJ = 1, nOcc(iSymJ)
                     Do iBBlock = 1, nBBlock
                        If(iBBlock.eq.nBBlock) Then
                           NumB = nVir(iSymB) - nB*(nBBlock-1)
                        Else
                           NumB = nB
                        End If
                        iB1 = nB*(iBBlock-1) + 1

                        Do kBat = 1, nBatR
                           If (kBat .eq. nBatR) Then
                              NumVecK = nMP2Vec(iSymJC) - nVec*(nBatR-1)
                           Else
                              NumVecK = nVec
                           End If
                           kVec = nVec*(kBat-1) + 1

                           iOpt = 2
                           lTot = NumVecK*nVir(iSymC)
                           iAdr = iWork(ipAdrR1+iAdrVec(iSymC,iSymJ,iJ))
     &                          + (kVec-1)*nVir(iSymC)
                           Call dDaFile(LuRInv(1),iOpt,Wrk(kRjc),
     &                                  lTot,iAdr)
*
                           Do iBRel = 1, NumB
                              iB = iBrel + (iB1-1)
                              iOpt = 2
                              lTot = NumVecK*nOcc(iSymI)
                              iAdr = iWork(ipAdrR2+
     &                                     iAdrVec(iSymB,iSymI,iB))
     &                             + (kVec-1)*nOcc(iSymI)
*
                              Call dDaFile(LuRInv(2),iOpt, Wrk(kRib),
     &                                     lTot,iAdr)
                              iOffAmp =(iBrel-1)*nVir(iSymC)*nOcc(iSymI)
                              Fac = X(min((kBat-1),1))
                              Call dGemm_('N','T',nVir(iSymC),
     &                             nOcc(iSymI),
     &                             NumVecK, 1.0d0,Wrk(kRjc),
     &                             nVir(iSymC),
     &                             Wrk(kRib),nOcc(iSymI),Fac,
     &                             Wrk(kAmp+iOffAmp),nVir(iSymC))
                           End Do
                        End Do

*                       Calculate the contribution to U^J_jb
*                       ------------------------------------
                        If(NumRVecJ .gt. 0) Then
                           iOffRic = iT1am(iSymC,iSymI)
                           iOffU = iT1am(iSymB,iSymJ)+(iJ-1)*nVir(iSymB)
     &                           + (iB1-1)
                           Call dGemm_('T','N', NumB, NumRVecJ, NumIC,
     &                           1.0d0,Wrk(kAmp),NumIC,
     &                           Wrk(kRic+iOffRic),nMoMo(jSym,iVecOV),
     &                           1.0d0,Wrk(kU+iOffU),nMoMo(jSym,iVecOV))
                        End If
*                       Calculate the contribution to V^J_jb
*                       ------------------------------------
                        If(NumLVecJ .gt. 0) Then
                           iOffLic = iT1am(iSymC,iSymI)
                           iOffV = iT1am(iSymB,iSymJ)+(iJ-1)*nVir(iSymB)
     &                           + (iB1-1)
                           Call dGemm_('T','N', NumB, NumLVecJ, NumIC,
     &                           1.0d0,Wrk(kAmp),NumIC,
     &                           Wrk(kLic+iOffLic),nMoMo(jSym,iVecOV),
     &                           1.0d0,Wrk(kV+iOffV),nMoMo(jSym,iVecOV))
                        End If

                     End Do

                  End Do        !iJ
 201              Continue
               End Do           !iSymI
 202           Continue
            End Do              !iSymJ
*
            iOpt = 1
            lTot = nMoMo(jSym,iVecOV)*NumRVecJ
            iAdr = 1 + nMoMo(jSym,iVecOV)*(jVec-1)
            Call dDaFile(LuUVec,iOpt,Wrk(kU),
     &                   lTot,iAdr)
*
            iOpt = 1
            lTot = nMoMo(jSym,iVecOV)*NumLVecJ
            iAdr = 1 + nMoMo(jSym,iVecOV)*(jVec-1)
            Call dDaFile(LuVVec,iOpt,Wrk(kV),
     &                   lTot,iAdr)
         End Do                 !jBat
*
         Do jBat = 1, nBatMax
            If (jBat .eq. nBatR) Then
               NumRVecJ = nMP2Vec(jSym) - nVec*(nBatR-1)
            Else If(jBat .gt. nBatR) Then
               NumRVecJ = 0
            Else
               NumRVecJ = nVec
            End If
            If (jBat .eq. nBatL) Then
               NumLVecJ = NumCho(jSym) - nVec*(nBatL-1)
            Else If(jBat .gt. nBatL) Then
               NumLVecJ = 0
            Else
               NumLVecJ = nVec
            End If
            jVec = nVec*(jBat-1) + 1

*           Read Amplitude Rja
*           --------------------------------
            If(NumRVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecOV)*NumRVecJ
               iAdr = nMoMo(jSym,iVecOV)*(jVec-1) + 1
               Call dDaFile(lUnit_F(jSym,iTypR),iOpt,Wrk(kRic),lTot,
     &              iAdr)
            End If
*           Read Integrals R_ab^J from disk
*           -------------------------------
            If(NumLVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecVV)*NumLVecJ
               iAdr = 1 + nMoMo(jSym,iVecVV)*(jVec-1) +
     &                 iAdrOff(jSym,iVecVV)
               Call dDaFile(lUnit_F(jSym,iTypL),iOpt,Wrk(kLab),lTot,
     &              iAdr)
            End If

*           Read Integrals L_ab^J from disk
*           -------------------------------
            If(NumLVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecVV)*NumLVecJ
               iAdr = 1 + nMoMo(jSym,iVecVV)*(jVec-1) +
     &                 iAdrOff(jSym,iVecVV)
               Call dDaFile(lUnit_F(jSym,iTypL),iOpt,Wrk(kLab),lTot,
     &              iAdr)
            End If

*           Read L_ji^J-vectors from disk
*           -----------------------------
            If(NumLVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecOO)*NumLVecJ
               iAdr = 1 + nMoMo(jSym,iVecOO)*(jVec-1) +
     &                 iAdrOff(jSym,iVecOO)
               Call dDaFile(lUnit_F(jSym,iTypL),iOpt,Wrk(kLji),lTot,
     &              iAdr)
            End If

*           Read L_ic^J-vectors from disk
*           -----------------------------
            If(NumLVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecOV)*NumLVecJ
               iAdr = nMoMo(jSym,iVecOV)*(jVec-1) + 1
               Call dDaFile(lUnit_F(jSym,iTypL),iOpt,Wrk(kLic),lTot,
     &                      iAdr)
            End If

*           Read L_Ka^J-vectors from disk
*           -----------------------------
            If(NumLVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecFV)*NumLVecJ
               iAdr = 1 + nMoMo(jSym,iVecFV)*(jVec-1) +
     &                 iAdrOff(jSym,iVecFV)
               Call dDaFile(lUnit_F(jSym,iTypL),iOpt,Wrk(kLKa),lTot,
     &              iAdr)
            End If

*           Read L_Ka^J-vectors from disk
*           -----------------------------
            If(NumLVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecOF)*NumLVecJ
               iAdr = 1 + nMoMo(jSym,iVecOF)*(jVec-1) +
     &                 iAdrOff(jSym,iVecOF)
               Call dDaFile(lUnit_F(jSym,iTypL),iOpt,Wrk(kLiK),lTot,
     &              iAdr)
            End If

*           Read U_jb^J-vectors from disk
*           -----------------------------
            If(NumRVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecOV)*NumRVecJ
               iAdr = nMoMo(jSym,iVecOv)*(jVec-1) + 1
               Call dDaFile(LuUVec,iOpt,Wrk(kU),lTot,iAdr)
            End If


*           Read V_jb^J-vectors from disk
*           -----------------------------
            If(NumLVecJ .gt. 0) Then
               iOpt = 2
               lTot = nMoMo(jSym,iVecOV)*NumLVecJ
               iAdr = nMoMo(jSym,iVecOv)*(jVec-1) + 1
               Call dDaFile(LuVVec,iOpt,Wrk(kV),lTot,iAdr)
            End If


*           Calculate the "Exchange" Contribution to Pab
*           -------------------------------------------

            iOff1 = 0
            Do iSymJ = 1, nSym
               iSymA = MulD2h(jSym,iSymJ)
               If(nOcc(iSymJ)*nVir(iSymA)*NumRVecJ.eq.0) Go To 221
               Do iI = 1, nOcc(iSymJ)
                  iOff = (iI-1)*nVir(iSymA) + iOff1
                  Call dGemm_('N','T',nVir(iSymA),nVir(iSymA),
     &                       NumRVecJ, -2.0d0,
     &                       Wrk(kRic+iOff),nMoMo(jSym,iVecOV),
     &                       Wrk(kU+iOff),nMoMo(jSym,iVecOV),1.0d0,
     &                       Wrk(kPab(iSymA)),nVir(iSymA))
               End Do
 221           Continue
               iOff1 = iOff1 + nOcc(iSymJ)*nVir(iSymA)
            End Do

*           Calculate the "Exchange" Contribution to Pij
*           -------------------------------------------
*
            Do jVec1 = 1, NumRVecJ
               iOff1 = 0
               Do iSymJ = 1, nSym
                  iSymI = iSymJ
                  iSymB = MulD2h(iSymJ,jSym)
                  If(nOcc(iSymJ)*nVir(iSymB) .eq. 0) Go To 222
                  iOff = nMoMo(jSym,iVecOV)*(jVec1-1) + iOff1
                  Call dGemm_('T','N', nOcc(iSymJ), nOcc(iSymI),
     &                 nVir(iSymB), 2.0d0,
     &                 Wrk(kU+iOff),nVir(iSymB),
     &                 Wrk(kRic+iOff),nVir(iSymB),1.0d0,
     &                 Wrk(kPij(iSymJ)),nOcc(iSymJ))
 222              Continue
                  iOff1 = iOff1 + nOcc(iSymJ)*nVir(iSymB)
               End Do
            End Do

*           Calculate the "Exchange"-contribution to PiK (Froz-occ)
*           -------------------------------------------------------

            Do jVec1 = 1, NumLVecJ
                  iOffV1 = 0
                  iOffL1 = 0
                  Do iSymK = 1, nSym
                     iSymI = iSymK
                     iSymA = MulD2h(iSymK,jSym)
                     If(nOcc(iSymI)*nFro(iSymK)*nVir(iSymA) .eq. 0)
     &                      Go To 231
                     iOffV = nMoMo(jSym,iVecOV)*(jVec1-1) + iOffV1
                     iOffL = nMoMo(jSym,iVecFV)*(jVec1-1) + iOffL1
                     Call dGemm_('T','N', nOcc(iSymI), nFro(iSymK),
     &                          nVir(iSymA), 2.0d0,
     &                          Wrk(kV+iOffV),nVir(iSymA),
     &                          Wrk(kLKa+iOffL),nVir(iSymA),1.0d0,
     &                          Wrk(kPiK(iSymK)),nOcc(iSymI))
 231                 Continue
                     iOffV1 = iOffV1 + nOcc(iSymI)*nVir(iSymA)
                     iOffL1 = iOffL1 + nFro(iSymK)*nVir(iSymA)
                   End Do
               End Do

*           Calculate the "Exchange"-contribution to WiK (Froz-occ)
*           -------------------------------------------------------

            Do jVec1 = 1, NumLVecJ
                  iOffV1 = 0
                  iOffL1 = 0
                  Do iSymK = 1, nSym
                     iSymI = iSymK
                     iSymA = MulD2h(iSymK,jSym)
                     If(nOcc(iSymI)*nFro(iSymK)*nVir(iSymA) .eq. 0)
     &                      Go To 273
                     iOffV = nMoMo(jSym,iVecOV)*(jVec1-1) + iOffV1
                     iOffL = nMoMo(jSym,iVecFV)*(jVec1-1) + iOffL1
                     Call dGemm_('T','N', nOcc(iSymI), nFro(iSymK),
     &                          nVir(iSymA), -2.0d0,
     &                          Wrk(kV+iOffV),nVir(iSymA),
     &                          Wrk(kLKa+iOffL),nVir(iSymA),1.0d0,
     &                          Wrk(kWiK(iSymK)),nOcc(iSymI))
 273                 Continue
                     iOffV1 = iOffV1 + nOcc(iSymI)*nVir(iSymA)
                     iOffL1 = iOffL1 + nFro(iSymK)*nVir(iSymA)
                   End Do
               End Do


*           Calculate the "Exchange"-contribution to Lagr(IV)
*           -------------------------------------------------

            Do jVec1 = 1, NumLVecJ
               iOffV1 = 0
               iOffL1 = 0
               Do iSymI = 1, nSym
                  iSymA = iSymI
                  iSymB = MulD2h(iSymI,jSym)
                  If(nOcc(iSymI)*nVir(iSymB)*nVir(iSymA) .eq. 0)
     &                 Go To 223
                  iOffV = nMoMo(jSym,iVecOV)*(jVec1-1) + iOffV1
                  iOffL = nMoMo(jSym,iVecVV)*(jVec1-1) + iOffL1
                  Call dGemm_('T','N', nVir(iSymA), nOcc(iSymI),
     &                 nVir(iSymB), -2.0d0,
     &                 Wrk(kLab+iOffL),nVir(iSymB),
     &                 Wrk(kV+iOffV),nVir(iSymB),1.0d0,
     &                 Wrk(kLagr(iSymA)),nVir(iSymA))
 223              Continue
                  iOffL1 = iOffL1 + nVir(iSymA)*nVir(iSymB)
                  iOffV1 = iOffV1 + nOcc(iSymI)*nVir(iSymB)
               End Do
            End Do

*           Calculate the "Exchange"-contribution to Lagr(III)
*           --------------------------------------------------

            iOffV1 = 0
            iOffL1 = 0
            Do iSymJ = 1, nSym
               iSymA = MulD2h(jSym,iSymJ)
               iSymI = iSymA
               If(nOcc(iSymI)*nVir(iSymA)*nOcc(iSymJ).eq.0) Go To 233
               Do iJ = 1, nOcc(iSymJ)
                  iOffV = (iJ-1)*nVir(iSymA) + iOffV1
                  iOffL = (iJ-1)*nOcc(iSymI) + iOffL1
                  Call dGemm_('N','T',nVir(iSymA),nOcc(iSymI),
     &                       NumLVecJ, 2.0d0,
     &                       Wrk(kV+iOffV),nMoMo(jSym,iVecOV),
     &                       Wrk(kLji+iOffL),nMoMo(jSym,iVecOO),1.0d0,
     &                       Wrk(kLagr(iSymA)),nVir(iSymA))
               End Do
 233           Continue
               iOffV1 = iOffV1 + nOcc(iSymJ)*nVir(iSymA)
               iOffL1 = iOffL1 + nOcc(iSymJ)*nOcc(iSymI)
            End Do

*           Calculate the "Exchange"-contribution to Wai
*           --------------------------------------------------

            iOffV1 = 0
            iOffL1 = 0
            Do iSymJ = 1, nSym
               iSymA = MulD2h(jSym,iSymJ)
               iSymI = iSymA
               If(nOcc(iSymI)*nVir(iSymA)*nOcc(iSymJ)*NumLVecJ.eq.0)
     &                 Go To 2331
               Do iJ = 1, nOcc(iSymJ)
                  iOffV = (iJ-1)*nVir(iSymA) + iOffV1
                  iOffL = (iJ-1)*nOcc(iSymI) + iOffL1
                  Call dGemm_('N','T',nVir(iSymA),nOcc(iSymI),
     &                       NumLVecJ, -4.0d0,
     &                       Wrk(kV+iOffV),nMoMo(jSym,iVecOV),
     &                       Wrk(kLji+iOffL),nMoMo(jSym,iVecOO),1.0d0,
     &                       Wrk(kWai(iSymA)),nVir(iSymA))
               End Do
 2331          Continue
               iOffV1 = iOffV1 + nOcc(iSymJ)*nVir(iSymA)
               iOffL1 = iOffL1 + nOcc(iSymJ)*nOcc(iSymI)
            End Do

*           Calculate the "Exchange"-contribution to Wab
*           ---------------------------------------------
            iOff1 = 0
            Do iSymJ = 1, nSym
               iSymA = MulD2h(jSym,iSymJ)
               If(nOcc(iSymJ)*nVir(iSymA)*NumLVecJ.eq.0) Go To 251
               Do iI = 1, nOcc(iSymJ)
                  iOff = (iI-1)*nVir(iSymA) + iOff1
                  Call dGemm_('N','T',nVir(iSymA),nVir(iSymA),
     &                       NumLVecJ, -2.0d0,
     &                       Wrk(kLic+iOff),nMoMo(jSym,iVecOV),
     &                       Wrk(kV+iOff),nMoMo(jSym,iVecOV),1.0d0,
     &                       Wrk(kWab(iSymA)),nVir(iSymA))
               End Do
 251           Continue
               iOff1 = iOff1 + nOcc(iSymJ)*nVir(iSymA)
            End Do

*           Calculate the "Exchange"-contribution to Wij
*           --------------------------------------------

            Do jVec1 = 1, NumLVecJ
               iOff1 = 0
               Do iSymJ = 1, nSym
                  iSymI = iSymJ
                  iSymB = MulD2h(iSymJ,jSym)
                  If(nOcc(iSymJ)*nVir(iSymB) .eq. 0) Go To 252
                  iOff = nMoMo(jSym,iVecOV)*(jVec1-1) + iOff1
                  Call dGemm_('T','N', nOcc(iSymJ), nOcc(iSymI),
     &                 nVir(iSymB), -2.0d0,
     &                 Wrk(kV+iOff),nVir(iSymB),
     &                 Wrk(kLic+iOff),nVir(iSymB),1.0d0,
     &                 Wrk(kWij(iSymJ)),nOcc(iSymJ))
 252              Continue
                  iOff1 = iOff1 + nOcc(iSymJ)*nVir(iSymB)
               End Do
            End Do

*           Calculate "Exchange"-contribution to the Frozen Lagr(III)
*           --------------------------------------------------------
            iOffV1 = 0
            iOffL1 = 0
            Do iSymJ = 1, nSym
               iSymA = MulD2h(jSym,iSymJ)
               iSymI = iSymA
               If(nFro(iSymI)*nVir(iSymA)*nOcc(iSymJ).eq.0) Go To 2341
               Do iJ = 1, nOcc(iSymJ)
                  iOffV = (iJ-1)*nVir(iSymA) + iOffV1
                  iOffL = (iJ-1)*nFro(iSymI) + iOffL1
                  Call dGemm_('N','T',nVir(iSymA),nFro(iSymI),
     &                       NumLVecJ, 2.0d0,
     &                       Wrk(kV+iOffV),nMoMo(jSym,iVecOV),
     &                       Wrk(kLiK+iOffL),nMoMo(jSym,iVecOF),1.0d0,
     &                       Wrk(kFLagr(iSymA)),nVir(iSymA))
               End Do
 2341          Continue
               iOffV1 = iOffV1 + nOcc(iSymJ)*nVir(iSymA)
               iOffL1 = iOffL1 + nOcc(iSymJ)*nFro(iSymI)
            End Do

*           Calculate "Exchange"-contribution to the Wak(Vir-Froz)
*           --------------------------------------------------------
            iOffV1 = 0
            iOffL1 = 0
            Do iSymJ = 1, nSym
               iSymA = MulD2h(jSym,iSymJ)
               iSymI = iSymA
               If(nFro(iSymI)*nVir(iSymA)*nOcc(iSymJ).eq.0) Go To 234
               Do iJ = 1, nOcc(iSymJ)
                  iOffV = (iJ-1)*nVir(iSymA) + iOffV1
                  iOffL = (iJ-1)*nFro(iSymI) + iOffL1
                  Call dGemm_('N','T',nVir(iSymA),nFro(iSymI),
     &                       NumLVecJ, -4.0d0,
     &                       Wrk(kV+iOffV),nMoMo(jSym,iVecOV),
     &                       Wrk(kLiK+iOffL),nMoMo(jSym,iVecOF),1.0d0,
     &                       Wrk(kWaK(iSymA)),nVir(iSymA))
               End Do
 234           Continue
               iOffV1 = iOffV1 + nOcc(iSymJ)*nVir(iSymA)
               iOffL1 = iOffL1 + nOcc(iSymJ)*nFro(iSymI)
            End Do


         End Do

         Call DaClos(LuUVec)
         Call DaClos(LuVVec)
         Call ChoMP2_OpenF(iClos,iTypR,jSym)
         Call ChoMP2_OpenF(iClos,iTypL,jSym)
 10      Continue
      End Do                    ! jSym

      Call DaClos(LuRInv(1))
      Call DaClos(LuRInv(2))


*     Scale the Frozen-Occupied part of the density
*     ---------------------------------------------
      Do iSym = 1, nSym
         Do iI = 1, nOcc(iSym)
            E_i = EOcc(iOcc(iSym) + iI)
            Do iK = 1, nFro(iSym)
               E_K = EFro(iFro(iSym) + iK)
               i = iI-1 + (iK-1)*nOcc(iSym)
               Wrk(kPik(iSym)+i) = Wrk(kPik(iSym)+i)/(E_i - E_k)
            End Do
         End Do
      End Do



      Do iSym = 1, nSym
         If(NumCho(iSym) .gt. 0) Then

*
            Call ChoMP2_OpenF(1,1,iSym)

*
*           I doubt the intermediate files here need to be
*           Multifiles, probably they will never be used again after the
*           end of the iSym-loop (or even IB-block loop).
            iSeed = 7
            LuUVec = IsFreeUnit(iSeed)
            Write(Fname,'(A4,I1)') 'TMPV',1
            Call DaName_MF_WA(LuUVec,Fname)
*
            iSeed = 7
            LuVVec = IsFreeUnit(iSeed)
            Write(Fname,'(A4,I1)') 'TMPV',2
            Call DaName_MF_WA(LuVVec,Fname)
*
            iSeed = 7
            LuWVec = IsFreeUnit(iSeed)
            Write(Fname,'(A4,I1)') 'TMPV',3
            Call DaName_MF_WA(LuWVec,Fname)
*
            lScr = lWrk - kEndFLagr
*           Construct Lagr(i)
*           -----------------
            Call ChoMP2g_ConstrAP(irc,Wrk(kEndFLagr),lScr,
     &                            'oovo',iSym,nVec,Wrk(kLagr(1)),
     &                            lLagr,Wrk(kPij(1)),lPij,-0.5d0)

            Call ChoMP2g_ConstrAP(irc,Wrk(kEndFLagr),lScr,
     &                            'fovo',iSym,nVec,Wrk(kLagr(1)),
     &                            lLagr,Wrk(kPiK(1)),lPiK,-1.0d0)
*           Construct FLagr(i)
*           ------------------
            Call ChoMP2g_ConstrAP(irc,Wrk(kEndFLagr),lScr,
     &                            'oovf',iSym,nVec,Wrk(kFLagr(1)),
     &                            lFLagr,Wrk(kPij(1)),lPij,-0.5d0)

            Call ChoMP2g_ConstrAP(irc,Wrk(kEndFLagr),lScr,
     &                            'fovf',iSym,nVec,Wrk(kFLagr(1)),
     &                            lFLagr,Wrk(kPiK(1)),lPiK,-1.0d0)
*           Construct Lagr(ii)
*           ------------------
            Call ChoMP2g_ConstrAP(irc,Wrk(kEndFLagr),lScr,
     &                            'vvvo',iSym,nVec,Wrk(kLagr(1)),
     &                            lLagr,Wrk(kPab(1)),lPab,-0.5d0)
*           Construct FLagr(ii)
*           -------------------
            Call ChoMP2g_ConstrAP(irc,Wrk(kEndFLagr),lScr,
     &                            'vvvf',iSym,nVec,Wrk(kFLagr(1)),
     &                            lFLagr,Wrk(kPab(1)),lPab,-0.5d0)

            Call ChoMP2_OpenF(iClos,1,iSym)
            Call DaClos(LuUVec)
            Call DaClos(LuVVec)
            Call DaClos(LuWVec)

         End If
      End Do
*

*
#ifdef _DEBUGPRINT_
      Write(6,*) 'Pab'
      Do i = 1,lPab
         Write(6,*) Wrk(kPab(1)+i-1)
      End Do
      Write(6,*) 'lWab'
      Do i = 1, lWab
         Write(6,*) Wrk(kWab(1)+i-1)
      End Do
      Write(6,*) 'Pij'
      Do i = 1, lPij
         Write(6,*) Wrk(kPij(1)+i-1)
      End Do
      Write(6,*) 'Wij'
      Do i = 1, lWij
         Write(6,*) Wrk(kWij(1)+i-1)
      End Do
      Write(6,*) 'WiK'
      Do i = 1, lWiK
         Write(6,*) Wrk(kWiK(1)+i-1)
      End Do
      Write(6,*) 'WaK'
      Do i = 1, lWaK
         Write(6,*) Wrk(kWaK(1)+i-1)
      End Do
      Write(6,*) 'Wai'
      Do i = 1, lWai
         Write(6,*) Wrk(kWai(1)+i-1)
      End Do
      Write(6,*) 'PiK'
      Do i = 1,lPiK
         Write(6,*) Wrk(kPiK(1)+i-1)
      End Do

      Write(6,*) 'Lagr'
      Do i = 1,lLagr
         Write(6,*) Wrk(kLagr(1)+i-1)
      End Do

      Write(6,*) 'FLagr'
      Do i = 1,lFLagr
         Write(6,*) Wrk(kFLagr(1)+i-1)
      End Do
#endif
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(EVir)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine cvbstart_cvb_ge9(icode)

use casvb_global, only: endvar, nmcscf, recinp, recinp_old, variat
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: icode

if (icode >= 9) then
  call cvbfinit_cvb()
  nmcscf = 0
end if
variat = (mod(icode,10) /= 0)
endvar = (mod(icode,10) == 2)
recinp = Zero
recinp_old = Zero

return

end subroutine cvbstart_cvb_ge9

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************

subroutine CalcFckO(CMO,FI,FA,FckO)

use Index_Functions, only: iTri, nTri_Elem
use rasscf_global, only: NAC
use general_data, only: NASH, NBAS, NFRO, NISH, NSYM, NTOT1, NTOT2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CMO(NTOT2), FI(NTOT1), FA(NTOT1)
real(kind=wp), intent(out) :: FckO(NAC,NAC)
integer(kind=iwp) :: IBas, IOff1, IOff2, IOff3, IOrb, ISym, JBas, NA, NB, NI
real(kind=wp), allocatable :: FIAAO(:,:), FckOt(:,:), Scr(:,:)

FckO(:,:) = Zero

IOff1 = 0
IOff2 = 1
IOff3 = 0
do ISym=1,NSym
  NB = NBas(ISym)
  NA = NASH(ISym)
  NI = NISH(ISym)+NFro(ISym)
  if (NASH(ISym) > 0) then
    call mma_allocate(FIAAO,nB,nB,Label='FIAAO')
    call mma_allocate(Scr,nB,nA,Label='Scr')
    call mma_allocate(FckOt,NA,NA,Label='FckOt')
    FckOt(:,:) = Zero
    !write(u6,*)'Print FI Matrix'
    !do IBas=1,NB
    !  write(u6,*) (FI(IOff1+iTri(IBas,JBas)),JBas=1,IBas)
    !end do
    !write(u6,*)'Print FA Matrix'
    !do IBas=1,NB
    ! write(u6,*) ( FA(IOff1+iTri(IBas,JBas)),JBas=1,IBas)
    !end do
    !write(u6,*) 'Active CMO mat for sym',ISym
    !call RecPrt(' ',' ',CMO(IOff2+NI*NB),NB,NA)
    do IBas=1,NB
      do JBas=1,IBas
        FIAAO(jBas,iBas) = FI(IOff1+iTri(IBas,JBas))+FA(IOff1+iTri(IBas,JBas))
        FIAAO(iBas,jBas) = FIAAO(jBas,iBas)
      end do
    end do
    !write(u6,*) 'FIA mat for sym',ISym
    !call RecPrt(' ',' ',FIAAO,NB,NB)
    call DGEMM_('n','n',NB,NA,NB,One,FIAAO,NB,CMO(IOff2+NI*NB),NB,Zero,Scr,NB)
    call DGEMM_('t','n',NA,NA,NB,One,CMO(IOff2+NI*NB),NB,Scr,NB,Zero,FckOt,NA)
    !write(u6,*) 'FckO mat for sym',ISym
    !call RecPrt(' ',' ',FckOt,NA,NA)
    do IOrb=1,NA
      FckO(IOrb+IOff3,IOff3+1:IOff3+NA) = FckOt(:,iOrb)
    end do
    call mma_deallocate(FIAAO)
    call mma_deallocate(Scr)
    call mma_deallocate(FckOt)
  end if
  IOff1 = IOff1+nTri_Elem(NB)
  IOff2 = IOff2+NB**2
  IOff3 = IOff3+NA
end do

end subroutine CalcFckO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SOOUT(label,cnt_ico,phase_ico)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
      Integer cnt_ico(0:7,*),phase_ico(0:7,*)
      Character Label(MaxBfn+MaxBfn_Aux)*(LENIN8)
*
      Call SOCtl_mod(Label,Maxbfn+MaxBfn_Aux,Cnt_ico,Phase_ico)
*
      Return
      End
*
      Subroutine SOCtl_mod(Mamn,nMamn,Cnt_ico,Phase_ico)
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iChTbl, iChBas
      use Real_Spherical, only: iSphCr, LblCBs, LblSBs
      Implicit Real*8 (a-h,o-z)
*
#include "Molcas.fh"
#include "real.fh"
*
      Character ChTemp*8, Mamn(nMamn)*(LENIN8)
      Logical kECP, TstFnc
      Integer cnt_ico(0:7,*),phase_ico(0:7,*)
*
*     Generate list of symmetry adapted or petite list basis functions
*
*     Loop over Irreps
      iSO = 0
*
*     Loop over irreducible representations and symmetry operations,
*     respectively, for SO and Petite list, respectively.
*
      Do 200 iIrrep = 0, nIrrep-1
*
*        Loop over distinct shell types
*
         mdc = 0
         mc  = 1
         Do 201 iCnttp = 1, nCnttp
            kECP = dbsc(iCnttp)%ECP
            If (dbsc(iCnttp)%Aux.or.dbsc(iCnttp)%Frag) Go To 201
*
*           Loop over distinct centers
*
            Do 202 iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = mdc + 1
*
*              Loop over shells associated with this center
*              Start with s type shells
*
               kComp = 0
               iSh = dbsc(iCnttp)%iVal - 1
               Do 203 iAng = 0, dbsc(iCnttp)%nVal-1
                  iSh = iSh + 1
                  nExpi=Shells(iSh)%nExp
                  If (nExpi.eq.0) Go To 2033
                  nBasisi=Shells(iSh)%nBasis
                  If (nBasisi.eq.0) Go To 2033
                  If (Shells(iSh)%Prjct ) Then
                     jComp = 2*iAng + 1
                  Else
                     jComp = (iAng+1)*(iAng+2)/2
                  End If
                  Do 204 iComp = 1, jComp
                     lComp = kComp + iComp
*                    Get character of basis function
                     iChBs = iChBas(lComp)
                     If (Shells(iSh)%Transf) iChBs=iChBas(iSphCr(lComp))
*
*                    Skip if function not a basis of irreps.
*
                     If (.Not.TstFnc(dc(mdc)%iCoSet,
     &                          iIrrep,iChBs,dc(mdc)%nStab)) Go To 204
*
                     Do 205 iCntrc = 1, nBasisi
                        iSO = iSO + 1
                        If (iSO.gt.nMamn) Then
                           Call WarningMessage(2,'SOout: iSO.gt.nMamn')
                           Call Abend()
                        End If
                        ChTemp=LblCBs(lComp)
                        If (Shells(iSh)%Transf) ChTemp=LblSbs(lComp)
                        Do ico=0,nIrrep/dc(mdc)%nStab-1
                        Cnt_ico(ico,iso)=mc+ico
                        Phase_ico(ico,iso)=
     &                        iPrmt(NrOpr(dc(mdc)%iCoSet(iCo,0)),iChbs)*
     &                        iChTbl(iIrrep,
     &                              NrOpr(dc(mdc)%iCoSet(iCo,0)))
                        End Do
                        Mamn(iSO)=dc(mdc)%LblCnt(1:LENIN)//ChTemp(1:8)
 205                 Continue
*
 204              Continue
 2033             continue
                  kComp = kComp + (iAng+1)*(iAng+2)/2
 203           Continue
               mc = mc + nIrrep/dc(mdc)%nStab
 202        Continue
*
 201     Continue
 200  Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Ben Swerts                                             *
*               2020, Roland Lindh                                    *
************************************************************************
      Subroutine FragExpand(LuRd)
************************************************************************
*                                                                      *
*    Objective: To expand the data for the fragments and append them   *
*               to regular arrays in info.fh                           *
*                                                                      *
* Called from: Input                                                   *
*                                                                      *
* Calling    : GetBS                                                   *
*                                                                      *
*     Author: Ben Swerts                                               *
*                                                                      *
************************************************************************
      Use Basis_Info
      Use Center_Info
      use Sizes_of_Seward, only: S
      Implicit None
#include "Molcas.fh"
#include "stdalloc.fh"
#include "real.fh"
#include "print.fh"
      integer     storageSize, LineWords
      parameter(  storageSize = 200, LineWords=storageSize/8)
      Real*8      eqBasis(LineWords)
      Integer     BasisTypes(4),
     &            LenLbl, LuRd, iAtom, ib, iBas, iCnttp, iCntr,
     &            ii, Indx, iSh, iShll, jShll,
     &            lAng, Last, LenBSL, lSTDINP, mCnttp, mdc, ndc,
     &            StayAlone
      Real*8      x1, y1, z1
      Character*4  label
      Character*13 DefNm
      Character*80 Ref(2)
      Character*(storageSize) sBasis
      Equivalence( sBasis, eqBasis)
      Character *256 Basis_lib, Fname
      Logical UnNorm
#ifdef _DEBUGPRINT_
      Integer i
#endif
      Character*180, Allocatable :: STDINP(:)
* external functions and procedures
      Integer     iMostAbundantIsotope, iCLast
      Real*8      NucExp, rMass
      External    NucExp, rMass, iMostAbundantIsotope, iCLast
      Data DefNm/'basis_library'/
*                                                                      *
************************************************************************
*                                                                      *
      Interface
#include "getbs_interface.fh"
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(STDINP,mxAtom*2,label='STDINP')
      UnNorm = .False.
      LenLbl=0
      mdc = dbsc(nCnttp)%mdci+dbsc(nCnttp)%nCntr
      BasisTypes(:)=0
      iShll = S%Mx_Shll-1
      lSTDINP=0
      mCnttp = nCnttp
#ifdef _DEBUGPRINT_
      write(6,*) 'nCnttp, iShll, mdc = ',nCnttp,iShll,mdc
#endif
*
#ifdef _DEBUGPRINT_
       write(6,'(A,i6)')'FragExpand: just before the ''Do 1000 iCnttp'''
       write(6,'(A,i6)') 'FragExpand:       mdc          = ',mdc
       write(6,'(A,i6)') 'FragExpand:    mCnttp          = ',mCnttp
       write(6,'(A)') ' dbsc(nCnttp)%mdci  '//
     &                ' dbsc(nCnttp)%nCntr '//
     &                ' nFragType(nCnttp)  '//
     &                ' nFragCoor(nCnttp)  '
       Do i = 1, mCnttp
       write(6,'(4(3X,I6,11X))')
     &                              dbsc(i)%mdci,
     &                              dbsc(i)%nCntr,
     &                              dbsc(i)%nFragType,
     &                              dbsc(i)%nFragCoor
       End Do
#endif
!
!     Loop over distrinct basis set centers (dbsc)
!
      ndc = 0 ! destinct center index
      Do iCnttp = 1, mCnttp
!
!       Skip if this is not a fragment dbsc to expand.
!
        If(dbsc(iCnttp)%nFragType.le.0) Then
          ndc = ndc + dbsc(iCnttp)%nCntr
          Cycle
        End If
!
!       Loop over the centers associated with this dbsc.
!
        Do iCntr = 1, dbsc(iCnttp)%nCntr
          ndc = ndc + 1
!
!         Loop over the fragments associated with this dbsc.
!
          Do iAtom = 1, dbsc(iCnttp)%nFragCoor
*
*           Create a new basis set center
*
            nCnttp = nCnttp + 1
            If (nCnttp.gt.Mxdbsc) Then
              Write (6,*) ' Increase Mxdbsc'
              Call ErrTra
              Call Quit_OnUserError()
            End If
*
*           Read the associated basis set in sBasis
*
            iBas = int(dbsc(iCnttp)%FragCoor(1,iAtom))
            call dcopy_(LineWords,dbsc(iCnttp)%FragType(1,iBas),1,
     &                            eqBasis, 1)
*
*           Get the basis set directory
*
            LenBSL = Len(sBasis)
            Last = iCLast(sBasis,LenBSL)
            Indx = Index(sBasis,'/')
            If(Indx.eq.0) Then
              Call WhichMolcas(Basis_lib)
              If(Basis_lib(1:1).ne.' ') then
                StayAlone = 1
                ib = index(Basis_lib,' ')-1
                If(ib.lt.1) Call SysAbendMsg('fragexpand',
     &                      'Too long PATH to MOLCAS',' ')
                Fname=Basis_lib(1:ib)//'/basis_library'
              Else
                Fname=DefNm
              Endif
              Indx = Last+1
              dbsc(nCnttp)%Bsl = Trim(sBasis)
            Else
              Fname = sBasis(Indx+2:Last)
              If (Fname.eq.' ') Then
                Write (6,*) ' No basis set library specified for'
                Write (6,'(A,A)') 'Fname=',Fname
                Call Quit_OnUserError()
              End If
 1001         If (Fname(1:1).eq.' ') Then
                Fname(1:79)=Fname(2:80)
                Fname(80:80) = ' '
                Go To 1001
              End If
              dbsc(nCnttp)%Bsl=sBasis(1:Indx-1)
            Endif
#ifdef _DEBUGPRINT_
            write(6,*) 'Setting Bsl(',nCnttp,') to ',dbsc(nCnttp)%Bsl
            write(6,*) 'Fname = ',Fname
#endif
*           Now Fname contains the basis set directory and dbsc(.)%Bsl
*           contains the basis set label
*
            jShll = iShll
            dbsc(nCnttp)%mdci=mdc
            Call GetBS(Fname,sBasis(1:Indx-1),iShll,Ref,
     &                 UnNorm,LuRd,BasisTypes,STDINP,lSTDINP,
     &                 .False.,.true.,' ')
           lAng=Max(dbsc(nCnttp)%nVal,
     &         dbsc(nCnttp)%nSRO,
     &         dbsc(nCnttp)%nPrj)-1
            S%iAngMx=Max(S%iAngMx,lAng)
            Shells(jShll+1)%Transf=.False.
            Shells(jShll+1)%Prjct =.False.
            Shells(jShll+2)%Transf=.False.
            Shells(jShll+2)%Prjct =.False.
            dbsc(nCnttp)%Fixed=.True.
            dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal
     &                           + dbsc(nCnttp)%nPrj
     &                           + dbsc(nCnttp)%nSRO
     &                           + dbsc(nCnttp)%nSOC
     &                           + dbsc(nCnttp)%nPP
            dbsc(nCnttp)%CntMass = rMass(dbsc(nCnttp)%AtmNr)
            Do iSh = jShll+1,iShll
               Shells(iSh)%Frag=.True.
            End Do
            If (INDEX(sBasis(1:Indx-1),'6-31G').ne.0) Then
              Do iSh = jShll+3, iShll
                Shells(iSh)%Prjct =.False.
                Shells(iSh)%Transf=.False.
              End Do
            End If
            dbsc(nCnttp)%Frag=.True.
*
* add the coordinates (1 atom / basis set center)
            dbsc(nCnttp)%nCntr = 1
*
            mdc = mdc + 1
            n_dc=max(mdc,n_dc)
            If (mdc.gt.MxAtom) Then
              Write (6,*) ' FragExpand: Increase MxAtom'
              Write (6,*) '        MxAtom=',MxAtom
              Call ErrTra
              Call Quit_OnUserError()
            End If
* get the relative coordinates
            x1 = dbsc(iCnttp)%FragCoor(2,iAtom)
            y1 = dbsc(iCnttp)%FragCoor(3,iAtom)
            z1 = dbsc(iCnttp)%FragCoor(4,iAtom)
* make them absolute
            x1 = x1 + dbsc(iCnttp)%Coor(1,iCntr)
            y1 = y1 + dbsc(iCnttp)%Coor(2,iCntr)
            z1 = z1 + dbsc(iCnttp)%Coor(3,iCntr)
#ifdef _DEBUGPRINT_
            write(6,'(a,i3,3(a,F12.7))') 'FragExpand: Center ',nCnttp,
     &      ' Coordinates:  x =',x1,' y=',y1,' z=',z1
#endif
* store them
            Call mma_allocate(dbsc(nCnttp)%Coor_Hidden,3,1,
     &                        Label='dbsc:C')
            dbsc(nCnttp)%Coor => dbsc(nCnttp)%Coor_Hidden(:,:)
            dbsc(nCnttp)%Coor(1,1) = x1
            dbsc(nCnttp)%Coor(2,1) = y1
            dbsc(nCnttp)%Coor(3,1) = z1
* store the Mulliken charge
            dbsc(nCnttp)%FragCharge = dbsc(iCnttp)%FragCoor(5,iAtom)
* create custom (hopefully) unique label
            LenLbl = Index(sBasis,'.') - 1
            label = sBasis(1:LenLbl)
            Do ii = LenLbl+1,4
              label(ii:ii) = '_'
            End Do
#ifdef _DEBUGPRINT_
            Write (6,'(2A)') 'Label=',label
#endif
c LENIN possible BUG
            dc(mdc)%LblCnt = label
            If(mdc.lt.10) then
              write(label,'(a3,i1)') '___',mdc
            Else If(mdc.lt.100) then
              write(label,'(a2,i2)') '__',mdc
            Else If(mdc.lt.1000) then
              write(label,'(a1,i3)') '_',mdc
            Else
              write(label,'(i4)') mdc
            End If
            dc(mdc)%LblCnt(5:LENIN2) = label
#ifdef _DEBUGPRINT_
            Write (6,'(2A)') 'Label=',label
            Write (6,'(2A)') 'LblCnt(mdc)=',dc(mdc)%LblCnt
#endif
            Call Chk_LblCnt(dc(mdc)%LblCnt,mdc-1)
* store a reference to the originating fragment placeholder
* misuse nFragCoor for this purpose: it will not overwrite anything, but
* beware of redimensioning this array to anything other than Mxdbsc
* To signify this we store the negative value such that we can identify
* the that the actual number of centers is 0 and that the corresponding
* size of dbsc()%FragCoor is 0 and nothing else.
            dbsc(nCnttp)%nFragCoor =  -ndc  ! DO NOT CHANGE THIS!!!!
*
            If (dbsc(nCnttp)%ExpNuc.lt.Zero) dbsc(nCnttp)%ExpNuc =
     &        NucExp(iMostAbundantIsotope(dbsc(nCnttp)%AtmNr))
          End Do  ! iAtom
        End Do    ! iCntr
      End Do      ! iCnttp
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
       write(6,'(A,i6)')'FragExpand: After the ''Do 1000 iCnttp'''
       write(6,'(A,i6)') 'FragExpand:       mdc          = ',mdc
       write(6,'(A,i6)') 'FragExpand:    nCnttp          = ',nCnttp
       write(6,'(A)') ' dbsc(nCnttp)%mdci  '//
     &                ' dbsc(nCnttp)%nCntr '//
     &                ' nFragType(nCnttp)  '//
     &                ' nFragCoor(nCnttp)  '
       Do i = 1, nCnttp
       write(6,'(4(3X,I6,11X))')
     &                              dbsc(i)%mdci,
     &                              dbsc(i)%nCntr,
     &                              dbsc(i)%nFragType,
     &                              dbsc(i)%nFragCoor
       End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
      S%Mx_Shll=iShll+1
      Max_Shells=S%Mx_Shll
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(STDINP)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine NAGrd_mck( &
#                    define _CALLING_
#                    include "grd_mck_interface.fh"
                    )
!***********************************************************************
!                                                                      *
! Object: to compute the gradient of the nuclear attraction integrals. *
!          Something is wrong here                                     *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             October 1991                                             *
!              Anders Bernhardsson 1995                                *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc, iCnttp_Dummy, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_mck_interface.fh"
integer(kind=iwp), parameter :: nHess = 1, nPAO = 1 ! Hess, PAO: Dummy arrays
integer(kind=iwp) :: iAnga(4), iBeta, iCnt, iDCRT(0:7), iElem, indi, Indx(3,4), ipA, ipAOff, ipB, ipBOff, iuvwx(4), &
                     JndGrd(3,4,0:7), JndHss(4,3,4,3,0:7), kCnt, kCnttp, kdc, kndgrd(3,4,0:7), lDCRT, LmbdT, mOp(4), nArray, nb, &
                     nDCRT, nGr, nip, nRys
real(kind=wp) :: C(3), Coora(3,4), CoorAC(3,2), Coori(3,4), Fact, Hess(nHess), PAO(nPAO), TC(3)
logical(kind=iwp) :: DiffCnt, jfg(4), JfGrd(3,4), JfHss(4,3,4,3), kfgrd(3,4), Tr(4)
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ
external :: Cff2D, Fake, TNAI1

#include "macros.fh"
unused_var(Ccoor)
unused_var(nOrdOp)
unused_var(Trans)

!iRout = 150
!iPrint = nPrint(iRout)

!if (iPrint >= 99) then
!  write(u6,*) ' In NAGrd_McK: nArr=',nArr
!end if

nRys = nHer

nip = 1
ipA = nip
nip = nip+nAlpha*nBeta
ipB = nip
nip = nip+nAlpha*nBeta
if (nip-1 > nArr) write(u6,*) ' nip-1 > nArr'
nArray = nArr-nip+1

iAnga(1) = la
iAnga(2) = lb
iAnga(3) = 0
iAnga(4) = 0
! Dummies
JndHss(:,:,:,:,0:nIrrep-1) = 0
JfHss(:,:,:,:) = .false.

Coora(:,1) = A
Coora(:,2) = RB
Coori(:,1) = A
Coori(:,2) = RB
if (la >= lb) then
  CoorAC(:,1) = A
else
  CoorAC(:,1) = RB
end if
iuvwx(1) = iu
iuvwx(2) = iv
mOp(1) = nOp(1)
mOp(2) = nOp(2)

ipAOff = ipA
do iBeta=1,nBeta
  Array(ipAOff:ipAOff+nAlpha-1) = Alpha
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB
do iBeta=1,nBeta
  Array(ipBOff:ipBOff+nAlpha-1) = Beta(iBeta)
  ipBOff = ipBOff+nAlpha
end do

! Loop over nuclear centers

nb = nZeta*nTri_Elem1(la)*nTri_Elem1(lb)
kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (kCnttp == iCnttp_Dummy) cycle
  if (dbsc(kCnttp)%Charge == Zero) cycle
  do kCnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
    DiffCnt = (IfGrad(iDCar,1) .or. IfGrad(iDCar,2))
    if ((.not. DiffCnt) .and. (kdc+kCnt /= iDCnt)) cycle

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    !Fact = -dbsc(kCnttp)%Charge*real(nStabM*nIrrep,kind=wp)/real(LmbdT*dc(kdc+kCnt)%nStab,kind=wp)
    Fact = -dbsc(kCnttp)%Charge*real(nStabM,kind=wp)/real(LmbdT,kind=wp)
    !if (iPrint >= 99) then
    !  write(u6,*) ' Charge=',dbsc(kCnttp)%Charge
    !  Write(u6,*) 'NZeta=',nzeta
    !  write(u6,*) 'NrOp=',nrop
    !  write(u6,*) ' Fact=',Fact
    !end if
    iuvwx(3) = dc(kdc+kCnt)%nStab
    iuvwx(4) = dc(kdc+kCnt)%nStab
    JndGrd(:,:,0:nIrrep-1) = 0
    JfGrd(:,:) = .false.
    JfGrd(iDCar,1:2) = IfGrad(iDCar,1:2)
    do ICnt=1,2
      if (IfGrad(idcar,iCnt)) JndGrd(iDCar,iCnt,0:nIrrep-1) = IndGrd(0:nIrrep-1)
    end do

    Tr(1) = .false.
    Tr(2) = .false.
    Tr(3) = .false.
    Tr(4) = .false.
    if ((kdc+kCnt) == iDCnt) then
      Tr(3) = .true.
      JfGrd(iDCar,1:2) = .true.
      JndGrd(iDCar,3,0:nIrrep-1) = -IndGrd(0:nIrrep-1)
    end if

    do lDCRT=0,nDCRT-1
      kndgrd(:,:,0:nIrrep-1) = JndGrd(:,:,0:nIrrep-1)
      kfgrd(:,:) = JfGrd(:,:)
      mOp(3) = NrOpr(iDCRT(lDCRT))
      mOp(4) = mOp(3)
      call OA(iDCRT(lDCRT),C,TC)
      CoorAC(:,2) = TC
      Coora(:,3) = TC
      Coora(:,4) = TC
      Coori(:,3) = TC
      Coori(:,4) = TC
      if (Eq(A,RB) .and. EQ(A,TC)) cycle
      if (EQ(A,TC)) then
        kfGrd(iDCar,1) = .false.
        kndGrd(iDCar,1,0:nIrrep-1) = 0
      end if
      if (EQ(RB,TC)) then
        kfGrd(iDCar,2) = .false.
        kndgrd(iDCar,2,0:nIrrep-1) = 0
      end if

      if (kfGrd(idcar,1)) then
        JFG(1) = .true.
      else
        JFG(1) = .false.
      end if
      if (kfGrd(idcar,2)) then
        JFG(2) = .true.
      else
        JFG(2) = .false.
      end if
      JFG(3) = .false.
      JFG(4) = .false.
      call Rysg2(iAnga,nRys,nZeta,Array(ipA),Array(ipB),[One],[One],Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,Coori,Coora,CoorAC, &
                 Array(nip),nArray,TNAI1,Fake,Cff2D,PAO,nPAO,Hess,nHess,kfGrd,kndGrd,JfHss,JndHss,mOp,iuvwx,Jfg,nGr,Indx,.true., &
                 .false.,tr)

      do iElem=1,nTri_Elem1(la)*nTri_Elem1(lb)*ngr
        indi = nip+(iElem-1)*nZeta
        Array(indi:indi+nZeta-1) = Two*rKappa(:)*Pi*ZInv(:)*Array(indi:indi+nZeta-1)
      end do

#     ifdef _DEBUGPRINT_
      call RecPrt('In NaGrd_McK PI',' ',Array(nip),nb,3)
      call RecPrt('In NaGrd_McK PI',' ',rFinal,nb,nrOp)
#     endif
      call SmAdNa(Array(nip),nb,rFinal,mop,loper,KndGrd,iuvwx,Indx,idcar,Fact,tr)
      !if (iPrint > 23) call RecPrt('In NaGrd_McK FI',' ',rFinal,nb,nrOp)
    end do
  end do
end do

return

end subroutine NAGrd_mck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Alaska_Super_Driver(iRC)

use Alaska_Info, only: Auto, DefRoot, ForceNAC, iRlxRoot
use Para_Info, only: nProcs
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iRC
#include "warnings.h"
#include "nac.fh"
integer(kind=iwp) :: Columbus, iForceAnalytical, iGo, iMp2Prpt, iPL, iReturn, istatus, LuInput, LuSpool, LuSpool2, nGrad, nsAtom, &
                     nSym
logical(kind=iwp) :: Do_Cholesky, Numerical, Do_DF, Do_ESPF, StandAlone, Exists, Do_Numerical_Cholesky, Do_1CCD, MCLR_Ready
character(len=128) :: FileName
character(len=180) :: Line
character(len=80) :: KSDFT
character(len=16) :: mstate1, mstate2, StdIn
character(len=8) :: Method
real(kind=wp), allocatable :: Grad(:)
integer(kind=iwp), external :: iPrintLevel, isFreeUnit
logical(kind=iwp), external :: Reduce_Prt

!                                                                      *
!***********************************************************************
!                                                                      *
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0
!                                                                      *
!***********************************************************************
!                                                                      *
!
! Check the input for the numerical keyword

! copy STDINP to LuSpool

LuSpool = 37
call SpoolInp(LuSpool)
call Chk_Numerical(LuSpool,Numerical)

! Call the numerical procedure if numerical option is available.
! Otherwise hope that the analytic code know how to handle the
! case.

call Get_cArray('Relax Method',Method,8)
call Get_iScalar('Columbus',Columbus)
!                                                                      *
!***********************************************************************
!                                                                      *
! Default for Cholesky or RI/DF is to do the numerical procedure.
! However, for pure DFT we have analytic gradients.

call DecideOnCholesky(Do_Cholesky)
call DecideOnDF(Do_DF)
call DecideOn1CCD(Do_1CCD)
call Get_iScalar('NSYM',nSym)

! Default for MBPT2 is the numerical procedure but if variational
! densities are calculated analytical gradients shall be used.
iMp2Prpt = 0
if (Method == 'MBPT2   ') then
  call Get_iScalar('mp2prpt',iMp2Prpt)

  ! Make sure that the analytic procedure is used if possible.

  if ((nSym == 1) .and. (iMp2Prpt /= 2) .and. (.not. Numerical)) then
    call WarningMessage(2,'Error in Alaska_Super_Driver')
    write(u6,*) 'Alaska: the MBPT2 module was run without the Grdt option!'
    write(u6,*) '   Correct the input and restart the calculation!'
    call Abend()
  end if
end if

Do_Numerical_Cholesky = Do_Cholesky .or. Do_DF

call Get_iScalar('agrad',iForceAnalytical)
if (iForceAnalytical == 1) Do_Numerical_Cholesky = .false.

if ((Method == 'KS-DFT  ') .and. Do_Numerical_Cholesky) then
  call Get_cArray('DFT functional',KSDFT,80)

  !   RI/DF                         1C-CD
  if (Do_DF .or. (Do_Cholesky .and. Do_1CCD .and. (nSym == 1))) then
    Do_Numerical_Cholesky = .false.
  end if

end if

if ((Do_DF .or. (Do_Cholesky .and. Do_1CCD .and. (nSym == 1)))) then

  if ((Method == 'KS-DFT  ') .or. (Method == 'UHF-SCF ') .or. (Method == 'RHF-SCF ') .or. (Method == 'CASSCF  ') .or. &
      (Method == 'RASSCF  ') .or. (Method == 'GASSCF  ') .or. (Method == 'DMRGSCF ') .or. (Method == 'CASSCFSA')) then
    Do_Numerical_Cholesky = .false.
  else if ((Method == 'MBPT2   ') .and. (nSym == 1)) then
    Do_Numerical_Cholesky = .false.
    !write(u6,*) 'Do Numerical', Do_Numerical_Cholesky
  end if

end if
!                                                                      *
!***********************************************************************
!                                                                      *
call DecideOnESPF(Do_ESPF)
! No ESPF for NAC, right?
!if (isNAC) Do_ESPF = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
if (Method == 'DMRGSCFS') then
  call Get_iScalar('SA ready',iGo)
end if

if (Numerical .or. Do_Numerical_Cholesky .or. (Method == 'RASSCFSA') .or. (Method == 'GASSCFSA') .or. &
    ((Method == 'DMRGSCFS') .and. (iGo /= 2)) .or. (Method == 'CASPT2') .or. ((Method == 'MBPT2') .and. (iMp2Prpt /= 2)) .or. &
    (Method == 'CCSDT') .or. (Method == 'EXTERNAL')) then
  if (isNAC) then
    call Store_Not_Grad(0,NACstates(1),NACstates(2))
    call WarningMessage(2,'Numerical nonadiabatic coupling not implemented')
    if (Auto) then
      iRC = 0
      return
    else
      call Abend()
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Numerical gradients to be used!
  ! Alaska will automatically generate the input for CASPT2_Gradient
  ! and signal to AUTO (iRC=2) to run the input file Stdin.x.

  if (iPL >= 3) then
    write(u6,*)
    write(u6,*) ' Alaska requests the Numerical_Gradient module to be executed!'
    write(u6,*)
  end if

  LuInput = 11
  LuInput = IsFreeUnit(LuInput)
  call StdIn_Name(StdIn)
  call Molcas_Open(LuInput,StdIn)

  write(LuInput,'(A)') '>ECHO OFF'
  write(LuInput,'(A)') '>export AL_OLD_TRAP=$MOLCAS_TRAP'
  write(LuInput,'(A)') '>export MOLCAS_TRAP=ON'

  write(LuInput,'(A)') ' &NUMERICAL_GRADIENT &End'
  write(LuInput,'(A)') 'End of Input'
  write(LuInput,'(A)') '>export MOLCAS_TRAP=$AL_OLD_TRAP'
  write(LuInput,'(A)') '>ECHO ON'
  close(LuInput)
  call Finish(_RC_INVOKED_OTHER_MODULE_)
!                                                                      *
!***********************************************************************
!                                                                      *
!   These do not work in parallel. Warn and stop early, better than
!   crash or give wrong results
!
!else if (Do_Cholesky .and. (Method == 'CASSCFSA') .and. (nProcs > 1)) then
!  call WarningMessage(2,'Error in Alaska_Super_Driver')
!  write(u6,*) 'RI SA-CASSCF analytical gradients do not work correctly in parallel (yet).'
!  call Abend()
else if (Do_Cholesky .and. (Method == 'MBPT2') .and. (nProcs > 1)) then
  call WarningMessage(2,'Error in Alaska_Super_Driver')
  write(u6,*) 'RI MBPT2 analytical gradients do not work correctly in parallel (yet).'
  call Abend()
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((Method == 'CASSCFSA') .or. ((Method == 'DMRGSCFS') .and. (iGo /= 2))) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! State-Average CASSCF / DMRGSCF

  call Get_iScalar('SA ready',iGo)
  call Get_iScalar('Relax CASSCF root',iRlxRoot)

  if (iRlxRoot == 0) iRlxRoot = 1
  if (isNAC) then
    write(mstate1,'(1X,I7,",",I7)') NACStates(1),NACStates(2)
  else
    write(mstate1,'(I16)') iRlxRoot
  end if

  ! iGo = -1 non-equivalent multi state SA-CASSCF
  ! iGo = 0  equivalent multi state SA-CASSCF
  ! iGo = 2  single root SA-CASSCF
  mstate2 = ''
  if (iGo /= 2) then
    call Get_cArray('MCLR Root',mstate2,16)
  end if

  ! If an explicit root was requested in MCLR and none in ALASKA,
  ! go for it
  if (DefRoot) then
    if (mstate2(1:1) == '+') then
      mstate1 = mstate2
      if (index(mstate2,',') /= 0) then
        read(mstate2,'(1X,I7,1X,I7)') NACStates(1),NACStates(2)
        ForceNAC = .true.
      else
        read(mstate2,'(1X,I15)') iRlxRoot
      end if
    end if
  end if
  mstate1(1:1) = mstate2(1:1)
  MCLR_Ready = (iGO == 1) .and. (mstate1 == mstate2)

  if (MCLR_Ready .or. (iGO > 1)) then
    call Alaska(LuSpool,iRC)

    ! Add ESPF contribution

    if (Do_ESPF) then
      StandAlone = .false.
      call ESPF(iReturn,StandAlone)
      if (iReturn /= 0) then
        call WarningMessage(2,'Error in Alaska_Super_Driver')
        write(u6,*) 'Alaska: ESPF finish with non-zero return code!'
        call Abend()
      end if
    end if
    ! Reset iGO to 0 to allow for new MCLR/ALASKA calculations
    if (iGo == 1) iGo = 0
    call Put_iScalar('SA ready',iGo)
  else if (iGO == -1) then
    call WarningMessage(2,'Error in Alaska_Super_Driver')
    write(u6,*) 'Gradients not implemented for SA-CASSCF with non-equivalent weights!'
    call Abend()
  else
    if (iPL >= 3) then
      write(u6,*)
      write(u6,*) ' Alaska requests MCLR to be run before it starts again!'
      write(u6,*)
    end if

    LuInput = 11
    LuInput = IsFreeUnit(LuInput)
    call StdIn_Name(StdIn)
    call Molcas_open(LuInput,StdIn)

    write(LuInput,'(A)') '>ECHO OFF'
    write(LuInput,'(A)') '>export AL_OLD_TRAP=$MOLCAS_TRAP'
    write(LuInput,'(A)') '>export MOLCAS_TRAP=ON'

    write(LuInput,'(A)') ' &MCLR &End'
    if (isNAC) then
      write(LuInput,'(A)') 'NAC'
      write(LuInput,'(I5,1X,I5)') NACstates(1),NACstates(2)
    end if
    write(LuInput,'(A)') 'End of Input'
    write(LuInput,'(A)') ' '

    FileName = 'ALASKINP'
    call f_inquire(Filename,Exists)

    if (Exists) then
      LuSpool2 = 77
      LuSpool2 = IsFreeUnit(LuSpool2)
      call Molcas_Open(LuSpool2,Filename)

      do
        read(LuSpool2,'(A)',iostat=istatus) Line
        if (istatus > 0) call Abend()
        if (istatus < 0) exit
        write(LuInput,'(A)') Line
      end do

      close(LuSpool2)

    else

      write(LuInput,'(A)') ' &Alaska &End'
      !write(LuInput,'(A)') 'Show'
      write(LuInput,'(A)') 'CutOff'
      write(LuInput,'(A)') '1.0D-7'
      write(LuInput,'(A)') 'End of Input'

    end if

    write(LuInput,'(A)') '>RM -FORCE $Project.MckInt'
    write(LuInput,'(A)') '>export MOLCAS_TRAP=$AL_OLD_TRAP'
    write(LuInput,'(A)') '>ECHO ON'
    close(LuInput)
    call Finish(_RC_INVOKED_OTHER_MODULE_)

  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((Method == 'MCPDFT') .or. (Method == 'MSPDFT')) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! MC-PDFT calculation

  Do_ESPF = .false.
  call Get_iScalar('SA ready',iGo)
  call Get_iScalar('Relax CASSCF root',iRlxRoot)

  ! Andrew - I need to identify the root and make sure it is not a
  ! state averaged calculation.  iGo=1 means do MCLR
  ! iGo=99 means the potentials were not calculated during the
  ! MCPDFT step, which is required for analytic gradients.
  if (iGO == 99) then
    call WarningMessage(2,'Error in Alaska_Super_Driver')
    write(u6,*) 'MC-PDFT was run without the GRADient keyword.  Analytic gradients require this keyword.  Please use the '// &
                'GRADient keyword in the preceeding MC-PDFT step.'
    call Abend()
  end if

  if (iRlxRoot == 0) iRlxRoot = 1
  !if (isNAC) then
  !  write(mstate1,'(1X,I7,",",I7)') NACStates(1),NACStates(2)
  !else
  write(mstate1,'(I16)') iRlxRoot
  !end if

  ! iGo = -1 non-equivalent multi state SA-CASSCF
  ! iGo = 0  equivalent multi state SA-CASSCF
  ! iGo = 2  single root SA-CASSCF
  mstate2 = ''
  if (iGo /= 2) then
    call Get_cArray('MCLR Root',mstate2,16)
  end if

  ! If an explicit root was requested in MCLR and none in ALASKA,
  ! go for it
  if (DefRoot) then
    if (mstate2(1:1) == '+') then
      mstate1 = mstate2
      if (index(mstate2,',') /= 0) then
        read(mstate2,'(1X,I7,1X,I7)') NACStates(1),NACStates(2)
        ForceNAC = .true.
      else
        read(mstate2,'(1X,I15)') iRlxRoot
      end if
    end if
  end if
  mstate1(1:1) = mstate2(1:1)
  MCLR_Ready = (iGO == 1) .and. (mstate1 == mstate2)

  if (MCLR_Ready .or. (iGO > 1)) then
    call Alaska(LuSpool,iRC)

    ! Add ESPF contribution

    !if (Do_ESPF) Then
    !  StandAlone = .false.
    !  call ESPF(iReturn,StandAlone)
    !  if (iReturn /= 0) then
    !     call WarningMessage(2,'Error in Alaska_Super_Driver')
    !     write(u6,*) 'Alaska: ESPF finish with non-zero return code!'
    !     call Abend()
    !  end if
    !end if
    ! Reset iGO to 0 to allow for new MCLR/ALASKA calculations
    if (iGo == 1) iGo = 0
    call Put_iScalar('SA ready',iGo)
  else if (iGO == -1) then
    call WarningMessage(2,'Error in Alaska_Super_Driver')
    write(u6,*) 'Gradients not implemented for SA-CASSCF with non-equivalent weights!'
    call Abend()
  else
    if (iPL >= 3) then
      write(u6,*)
      write(u6,*) ' Alaska requests MCLR to be run before it starts again!'
      write(u6,*)
    end if

    LuInput = 11
    LuInput = IsFreeUnit(LuInput)
    call StdIn_Name(StdIn)
    call Molcas_open(LuInput,StdIn)

    write(LuInput,'(A)') '>ECHO OFF'
    write(LuInput,'(A)') '>export AL_OLD_TRAP=$MOLCAS_TRAP'
    write(LuInput,'(A)') '>export MOLCAS_TRAP=ON'

    write(LuInput,'(A)') ' &MCLR &End'
    write(LuInput,'(A)') ' PRINT = 100'
    !if (isNAC) then
    !  write(LuInput,'(A)') 'NAC'
    !  write(LuInput,'(I5,1X,I5)') NACstates(1),NACstates(2)
    !end if
    write(LuInput,'(A)') 'End of Input'
    write(LuInput,'(A)') ' '

    FileName = 'ALASKINP'
    call f_inquire(Filename,Exists)

    if (Exists) then
      LuSpool2 = 77
      LuSpool2 = IsFreeUnit(LuSpool2)
      call Molcas_Open(LuSpool2,Filename)

      do
        read(LuSpool2,'(A)',iostat=istatus) Line
        if (istatus > 0) call Abend()
        if (istatus < 0) exit
        write(LuInput,'(A)') Line
      end do

      close(LuSpool2)

    else

      write(LuInput,'(A)') ' &Alaska &End'
      !write(LuInput,'(A)') 'Show'
      write(LuInput,'(A)') 'CutOff'
      write(LuInput,'(A)') '1.0D-7'
      write(LuInput,'(A)') 'End of Input'

    end if

    write(LuInput,'(A)') '>RM -FORCE $Project.MckInt'
    write(LuInput,'(A)') '>export MOLCAS_TRAP=$AL_OLD_TRAP'
    write(LuInput,'(A)') '>ECHO ON'
    close(LuInput)
    call Finish(_RC_INVOKED_OTHER_MODULE_)

  end if

!*********** columbus interface ****************************************

else if ((method == 'MR-CISD ') .and. (Columbus == 1)) then

  ! COLUMBUS MR-CI gradient:
  !     effective density matrix on RUNFILE 'densao_var'
  !     effective fock matrix  on RUNFILE   'FockOcc'
  !     effective  D2          on GAMMA
  !     G_TOC indices          on binary file gtoc
  !     RUNFILE read in drvh1
  !     GAMMA read in pget0
  !     gtoc read in drvg1

  call Get_iScalar('Relax CASSCF root',iRlxRoot)
  call Alaska(LuSpool,iRC)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Read the root, as it could be a CASSCF state-specific excited
  ! state calculation

  iRlxRoot = 0
  call Qpg_iScalar('Relax CASSCF root',Exists)
  if (Exists) call Get_iScalar('Relax CASSCF root',iRlxRoot)
  if (iRlxRoot == 0) iRlxRoot = 1

  ! Go ahead and compute the gradients

  call Alaska(LuSpool,iRC)

  ! Add ESPF contribution

  if (Do_ESPF) then
    StandAlone = .false.
    call ESPF(iReturn,StandAlone)
    if (iReturn /= 0) then
      call WarningMessage(2,'Error in Alaska_Super_Driver')
      write(u6,*) 'Alaska: ESPF finish with non-zero return code!'
      call Abend()
    end if
  end if

  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Read the gradient and store in the GRADS file
! It is done here because the gradient could have been modified by ESPF
! and we do not want to pass the root to ESPF (yet)

call Get_iScalar('Unique atoms',nsAtom)
call mma_Allocate(Grad,3*nsAtom,Label='Grad')
nGrad = 3*nsAtom
call Get_Grad(Grad,nGrad)
if (isNAC) then
  call Store_Grad(Grad,nGrad,0,NACstates(1),NACstates(2))
else
  call Store_Grad(Grad,nGrad,iRlxRoot,0,0)
end if
call mma_deallocate(Grad)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Alaska_Super_Driver

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function Eval_RMax(alpha,m,R_L)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Eval_RMax
*     Write (6,*) 'alpha,m,R_L=',
*    &            alpha,m,R_L
*
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute r_k_H as a function of m and R_L
*
*     Eq(19) R. Lindh, P.-A. Malmqvist, L. Gagliardi,
*     TCA, 106:178-187 (2001)

      If (MOD(m+3,2).eq.0) Then
         Gamma=One
         Do i = 2, (m+3)/2, 1
            Gamma = Gamma * DBLE(i-1)
         End Do
      Else
         Gamma=Sqrt(Pi)
         Do i = 5, m+3, 2
            Gamma = Gamma * DBLE(i-1)/Two
         End Do
      End If
*
*     x = Alpha * (r_k_H)**2
*
      x = 10.0D0 ! Start value
 123  Continue
      x_new = LOG((Gamma/R_L)*x**(Half*(DBLE(m)+One)))
C     Write (6,*) 'x,x_new=',x,x_new
      If (ABS(x-x_new).gt.1.0D-8) Then
         x=x_new
         Go To 123
      End If
*
      Eval_RMax=Sqrt(x/alpha)
C     Write (*,*) 'Eval_RMax=',Eval_RMax
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RPA_SetIntegralRepresentation()

use RPA_globals, only: doCD, doDF

implicit none

call DecideOnCholesky(doCD)
call DecideOnDF(doDF)
if (doDF) then
  doCD = .false.
else if (doCD) then
  doDF = .false.
end if

end subroutine RPA_SetIntegralRepresentation

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986,1995, Bernd Artur Hess                            *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

!#NUMPAC#MINVD               REVISED ON 1984-11-30
subroutine MINVD(A,KA,N,EPS,ILL)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: KA, N
real(kind=wp), intent(inout) :: A(KA,N)
real(kind=wp), intent(in) :: EPS
integer(kind=iwp), intent(out) :: ILL
integer(kind=iwp) :: I, IM1, IM2, J, JM1, JP1, K, M, NM1
real(kind=wp) :: AA, AM, P, S, W
integer(kind=iwp), allocatable :: MX(:)

if ((N < 1) .or. (N > KA) .or. (EPS <= Zero)) then
  ILL = 30000
  return
end if

call mma_allocate(MX,N,label='MX')

! LU DECOMPOSITION
JM1 = 0 ! dummy initialize
M = 0 ! dummy initialize
NM1 = N-1
do J=1,N
  if (J /= 1) then
    JM1 = J-1
    do I=1,JM1
      M = MX(I)
      S = A(M,J)
      A(M,J) = A(I,J)
      if (I /= 1) then
        IM1 = I-1
        do K=1,IM1
          S = A(I,K)*A(K,J)+S
        end do
      end if
      A(I,J) = S
    end do
  end if
  AM = 0.
  do I=J,N
    S = A(I,J)
    if (J /= 1) then
      do K=1,JM1
        S = A(I,K)*A(K,J)+S
      end do
      A(I,J) = S
    end if
    AA = abs(S)
    if (AA > AM) then
      AM = AA
      M = I
    end if
  end do
  if (AM < EPS) then
    ILL = J
    call mma_deallocate(MX)
    return
  end if
  MX(J) = M
  if (M /= J) then
    do K=1,J
      W = A(M,K)
      A(M,K) = A(J,K)
      A(J,K) = W
    end do
  end if
  if (J /= N) then
    JP1 = J+1
    W = -A(J,J)
    do I=JP1,N
      A(I,J) = A(I,J)/W
    end do
  end if
end do
if (N > 2) then
  ! INPLACE INVERSION OF L-COMPONENT
  do I=3,N
    IM1 = I-1
    IM2 = I-2
    do J=1,IM2
      S = A(I,J)
      JP1 = J+1
      do K=JP1,IM1
        S = A(I,K)*A(K,J)+S
      end do
      A(I,J) = S
    end do
  end do
end if
! INPLACE INVERSION OF U-COMPONENT
A(1,1) = 1./A(1,1)
if (N == 1) then
  ILL = 0
  call mma_deallocate(MX)
  return
end if
do J=2,N
  A(J,J) = 1./A(J,J)
  P = -A(J,J)
  JM1 = J-1
  do I=1,JM1
    S = 0.
    do K=I,JM1
      S = A(I,K)*A(K,J)+S
    end do
    A(I,J) = S*P
  end do
end do
! INPLACE MULTIPLICATION OF L AND U COMPONENT
do J=1,NM1
  JP1 = J+1
  do I=1,J
    S = A(I,J)
    do K=JP1,N
      S = A(I,K)*A(K,J)+S
    end do
    A(I,J) = S
  end do
  do I=JP1,N
    S = 0.
    do K=I,N
      S = A(I,K)*A(K,J)+S
    end do
    A(I,J) = S
  end do
end do
! INTERCHANGE OF COLUMNS
J = NM1
do
  M = MX(J)
  if (M /= J) then
    do I=1,N
      W = A(I,M)
      A(I,M) = A(I,J)
      A(I,J) = W
    end do
  end if
  J = J-1
  if (J < 1) exit
end do

call mma_deallocate(MX)

return

end subroutine MINVD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine chi_sum( N, Xex,Zex, XL,ZL, XR,ZR, iopt, X, Z )
c   computes the total CHI, provided all input values are provided
c   according to the desired partition scheme  (iopt = 1 or 2 )
c   all X tensors must be given in the general coordinate system
c
c definition of the variables:
c     N  -- total number of magnetic sites, Integer, input
c    Xex -- susceptibility tensor arising form the exchange states only, Real(kind=8) :: , (3,3) array, input
c    Zex -- statistical sum according to Boltzmann distribution law of the exchange states, Real(kind=8) :: , input
c    XL  -- susceptibility tensor arising from LOCAL states (all), Real(kind=8) :: , (N,3,3) array, input
c    ZL  -- statistical sum according to Boltzmann distribution law arising from LOCAL states (all), Real(kind=8) :: , (N) array, input
c    XR  -- susceptibility tensor arising from LOCAL states (exchange only), Real(kind=8) :: , (N,3,3) array, input
c    ZR  -- statistical sum according to Boltzmann distribution law arising from LOCAL states (exchange only), Real(kind=8) :: , (N) array, input
c   iopt -- option allowing to choose the desired formula, (Integer, input):
c           iopt=1  =>  formula for weak exchange limit ( new derivation)
c           iopt=2  =>  formula for strong exchange limit
c           iopt=3  =>  formula for strong exchange limit
c    X   -- total susceptibility, Real(kind=8) :: , (3,3) array, output
c    Z   -- total statistical sum according to Boltzmann distribution, Real(kind=8) :: , output
c---------
c  temporary (local) variables:
c
      Implicit None
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)       :: N, iopt
      Real(kind=8), intent(in) :: Xex(3,3), Zex
      Real(kind=8), intent(in) :: XL(N,3,3), ZL(N)
      Real(kind=8), intent(in) :: XR(N,3,3), ZR(N)
      Real(kind=8), intent(out):: X(3,3), Z
c local variables
      Integer       :: i, ic, jc
      Real(kind=8) :: ZLT, ZRT, XLT(3,3), XRT(3,3)

      ZLT=1.0_wp
      ZRT=1.0_wp
      Z=0.0_wp
      Call dcopy_(3*3,[0.0_wp],0,XRT,1)
      Call dcopy_(3*3,[0.0_wp],0,XLT,1)
      Call dcopy_(3*3,[0.0_wp],0,X,1)
      ! compute the total ZT
      If ( iopt == 1 ) Then
        ! my formula (simple):
        Do i=1,N
          ZLT=ZLT*ZL(i)
          ZRT=ZRT*ZR(i)
        End Do
        Z = Zex+ZLT-ZRT
        Do ic=1,3
          Do jc=1,3
            Do i=1,N
              XLT(ic,jc) = XLT(ic,jc) + XL(i,ic,jc)
              XRT(ic,jc) = XRT(ic,jc) + XR(i,ic,jc)
            End Do
            X(ic,jc) = Xex(ic,jc) + XLT(ic,jc) - XRT(ic,jc)
          End Do
        End Do

      Else If ( iopt == 2 ) Then
        ! "thesis formula:"
        Do i=1,N
          ZLT=ZLT*ZL(i)
          ZRT=ZRT*ZR(i)
        End Do
        Z = Zex+ZLT-ZRT
        Do ic=1,3
          Do jc=1,3
            Do i=1,N
              XLT(ic,jc) = XLT(ic,jc) + XL(i,ic,jc)*ZLT
              XRT(ic,jc) = XRT(ic,jc) + XR(i,ic,jc)*ZRT
            End Do
            X(ic,jc) = (Xex(ic,jc)*Zex + XLT(ic,jc) - XRT(ic,jc))/Z
          End Do
        End Do

      Else If ( iopt == 3 ) Then
        ! "weird formula as implemented in some version of the
        ! code, e.g. in the 2013 version:"
        Do i=1,N
          ZLT=ZLT*ZL(i)
          ZRT=ZRT*ZR(i)
        End Do
        ZLT = Zex*ZLT/ZRT
        ZRT = Zex
        Z   = ZLT - ZRT + Zex
        Do ic=1,3
          Do jc=1,3
            Do i=1,N
              XLT(ic,jc) = XLT(ic,jc) + XL(i,ic,jc)
              XRT(ic,jc) = XRT(ic,jc) + XR(i,ic,jc)
            End Do
                X(ic,jc) = ( XLT(ic,jc)*ZLT
     &                     - XRT(ic,jc)*ZRT
     &                     + Xex(ic,jc)*Zex ) / Z
          End Do
        End Do

      Else

        Write(6,'(A)') 'chi_sum: IOPT parameter out of range'
        Write(6,'(A,i8)') 'IOPT = ', IOPT
        Return

      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      SubRoutine PrjGrd_mck(
#define _CALLING_
#include "grd_mck_interface.fh"
     &                     )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of ECP integrals.         *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by ECPMem                 *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
*             Physics, University of Stockholm, Sweden, October 1993.  *
************************************************************************
      use Basis_Info
      use Center_Info
      use Real_Spherical
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "disp.fh"

#include "grd_mck_interface.fh"

*     Local variables
      Real*8 C(3), TC(3)
      Integer iDCRT(0:7), iuvwx(4), mOp(4), index(3,4), JndGrd(3,4,0:7)
      Logical JfGrad(3,4), EQ, DiffCnt,tr(4),ifg(4),ifhess_dum(3,4,3,4)
      Real*8 Dum(1)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*                                                                      *
************************************************************************
*                                                                      *
      iprint = 0
      iuvwx(1) = iu
      iuvwx(2) = iv
      mop(1) = nOp(1)
      mop(2) = nOp(2)
      DiffCnt=(IfGrad(iDCar,1).or.IfGrad(iDCar,2))
      iComp = 1

      If (iPrint.ge.49) Then
            Call RecPrt(' In PrjGrd: A',' ',A,1,3)
            Call RecPrt(' In PrjGrd: RB',' ',RB,1,3)
            Call RecPrt(' In PrjGrd: P',' ',P,nZeta,3)
            Call RecPrt(' In PrjGrd: Alpha',' ',Alpha,nAlpha,1)
            Call RecPrt(' In PrjGrd: Beta',' ',Beta,nBeta,1)
            Write (6,*) ' In PrjGrd: la,lb=',' ',la,lb
            Write (6,*) ' In PrjGrd: Diffs=',' ',
     &                    IfGrad(iDCar,1),IfGrad(iDCar,2)
            Write (6,*) ' In PrjGrd: Center=',' ',iDCNT
      End If

      kdc = 0
      Do 1960 kCnttp = 1, nCnttp
         If (.Not.dbsc(kCnttp)%ECP) Go To 1961
         If (dbsc(kCnttp)%nSRO.le.0) Go To 1961

         Do 1965 kCnt = 1,dbsc(kCnttp)%nCntr
            If ((.not.DiffCnt).and.((kdc+kCnt).ne.iDCnt)) Goto 1965

            C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
            iuvwx(3) = dc(kdc+kCnt)%nStab
            iuvwx(4) = dc(kdc+kCnt)%nStab

            Call LCopy(12,[.false.],0,JFgrad,1)
            Call LCopy(4 ,[.false.],0,iFg,1)
            Call LCopy(4 ,[.false.],0,tr,1)
            Call ICopy(12*nIrrep,[0],0,jndGrd,1)
            Do iCnt = 1, 2
                  JfGrad(iDCar,iCnt) = IfGrad(iDCar,iCnt)
            End Do
            Do ICnt=1,2
               If (ifgrad(idcar,iCnt)) Then
               ifg(icnt)=.true.
                 Do iIrrep=0,nIrrep-1
                   jndGrd(iDCar,iCnt,iIrrep)=IndGrd(iIrrep)
                 End Do
               End IF
            End Do

*
            If ((kdc+kCnt).eq.iDCnt) Then
                ifg(1)=.true.
                ifg(2)=.true.
                 Tr(3)=.true.
                 JfGrad(iDCar,1) = .true.
                 JfGrad(iDCar,2) = .true.
                 Do iIrrep=0,nIrrep-1
                 jndGrd(iDCar,3,iIrrep) = - IndGrd(iIrrep)
                 End Do
            End If

*
         Do 1967 lDCRT = 0, nDCRT-1

            mop(3)=nropr(iDCRT(lDCRT))
            mop(4)=mop(3)
            Call OA(iDCRT(lDCRT),C,TC)

            If (EQ(A,RB).and.EQ(A,TC)) Go To 1967

            Do 1966 iAng = 0, dbsc(kCnttp)%nPrj-1
               iShll = dbsc(kCnttp)%iPrj + iAng
               nExpi=Shells(iShll)%nExp
               nBasisi=Shells(iShll)%nBasis
               If (iPrint.ge.49) Then
                  Write (6,*) 'nExp(iShll)=',nExpi
                  Write (6,*) 'nBasisi=',nBasisi
                  Write (6,*) ' iAng=',iAng
                  Call RecPrt('TC',' ',TC,1,3)
               End If

               If (nExpi.eq.0 .or. nBasisi.eq.0) Go To 1966
*
               ip=1

               ipFin= ip
               ip=ip+nZeta*(la+1)*(la+2)/2*(lb+1)*(lb+2)/2*6

               ipFA1 = ip
               ip = ip + nAlpha*nExpi*nElem(la)*nElem(iAng)*4

               ipFB1 = ip
               ip = ip + nExpi*nBeta*nElem(iAng)*nElem(lb)*4

               ipFB2 = ip
               ipFA2 = ip
               if (ip.ge.narr) then
                 write(6,*) 'No mem in prjgrd',ip,narr
                 call abend()
                 endif

               call dcopy_(nArr,[0.0d0],0,Array,1)

*
               Call Acore(iang,la,ishll,nordop,TC,A,Array(ip),
     &                     narr-ip+1,Alpha,nalpha,Array(ipFA1),
     &                     array(ipFA2),jfgrad(1,1),ifhess_dum,
     &                     1,iprint.ge.49)
               call LToCore(Array(ipFA1),nalpha,ishll,la,iAng, 4)



               Call coreB(iang,lb,ishll,nordop,TC,RB,Array(ip),
     &                    narr-ip+1,Beta,nbeta,Array(ipFB1),
     &                    array(ipFB2),jfgrad(1,2),ifhess_dum,1,
     &                    iprint.ge.49)
               call RToCore(Array(ipFB1),nBeta,ishll,lb,iAng,4)



               call  CmbnACB1(Array(ipFA1),Array(ipFB1),Array(ipFin),
     &                        Fact,nAlpha,nBeta,Dum,nBasisi,
     &                        la,lb,iang,jfgrad,Dum,.false.,
     &                        index,mvec,idcar)


               nt=nAlpha*nBeta*nElem(lb)*nElem(la)
               Call SmAdNa(Array(ipFin),nt,Final,
     &                     mop,loper,JndGrd,iuvwx,JfGrad,index,
     &                     idcar,1.0d0,iFG,tr)


 1966       Continue
 1967    Continue
 1965    Continue
 1961    Continue
         kdc = kdc + dbsc(kCnttp)%nCntr
 1960 Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Zeta)
         Call Unused_real_array(ZInv)
         Call Unused_real_array(rKappa)
         Call Unused_integer(nHer)
         Call Unused_real_array(Ccoor)
         Call Unused_logical_array(Trans)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifdef _IN_MODULE_

subroutine GiveMeInfo(nntyp,natyp,BasCoo,iCon,nPrim,nBA,nCBoA,nBonA,Expo,Cont,nSh,nfSh,nSize,iPrint,nAtoms,MxAngqNr,Acc,nBas)

use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Real_Spherical, only: ipSph, RSph
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, nAtoms, MxAngqNr
integer(kind=iwp), intent(out) :: nntyp, natyp(nAtoms), nBA(nAtoms), nCBoA(nAtoms,MxAngqNr), nBonA(nAtoms), nSh(nAtoms), &
                                  nfSh(nAtoms,MxAngqNr), nSize, nBas
integer(kind=iwp), allocatable, intent(out) :: iCon(:,:), nPrim(:)
real(kind=wp), allocatable, intent(out) :: Expo(:,:), Cont(:,:), BasCoo(:,:), Acc(:)
integer(kind=iwp) :: i, iAng, iAngSav, iBas, iCnt, iCnttp, iCount, iHowMuch, ii, ind, ind1, ind2, ind3, ioio, iPrim, iTemp, j, jj, &
                     jSum, k, kaunt, kaunta, kaunter, kaunterPrev, kauntSav, kk, kkk, krekna, krekna2, l, ll, MaxAng, MxPrCon, na, &
                     nACCSize, ndc, nDiff, nnaa, nshj, nSumma, nVarv
real(kind=wp), allocatable :: TEMP1(:), TEMP2(:)
logical(kind=iwp) :: DoRys
#include "warnings.h"

!----------------------------------------------------------------------*
! Initialize in order to read properly from the info file.             *
!----------------------------------------------------------------------*
call Seward_Init()

!----------------------------------------------------------------------*
! GetInf reads everything in the runfile and puts it in variables      *
! in modules.                                                          *
!----------------------------------------------------------------------*
nDiff = 0
DoRys = .false.
call GetInf(DoRys,nDiff)

!----------------------------------------------------------------------*
! Set nntyp.                                                           *
!----------------------------------------------------------------------*
nntyp = nCnttp

!----------------------------------------------------------------------*
! Compute what we came here for. iBasAng will contain nBas elements    *
! with integers, such that 1=s-orbitals, 2=p-orbitals, 3=d-orbitals... *
!----------------------------------------------------------------------*
!ii = 0 !ii is number of basis sets.
!do
!  ii = ii+1
!  if (dbsc(ii)%nCntr == 0) exit
!end do
!ii = ii-1
!if (ii == 0) then
!  write(u6,*)
!  write(u6,*) 'ERROR in GiveMeInfo. No atoms?'
!end if
ii = nntyp

kaunta = 0
kaunt = 0
kaunter = 0
krekna = 0
MaxAng = 0
do i=1,ii
  kauntSav = kaunt
  do ioio=1,dbsc(i)%nCntr
    krekna = krekna+1
    krekna2 = 0
    kaunt = kauntSav
    kaunterPrev = kaunter
    nBA(krekna) = dbsc(i)%nShells
    if (nBA(krekna) > MaxAng) MaxAng = nBA(krekna)
    do j=1,dbsc(i)%nShells
      kaunt = kaunt+1
      krekna2 = krekna2+1
      nCBoA(krekna,krekna2) = Shells(kaunt)%nBasis
      kaunter = kaunter+Shells(kaunt)%nBasis
    end do
    kaunta = kaunta+1
    nBonA(kaunta) = kaunter-kaunterPrev  !Number of bases on each atom used below.
  end do
end do
nBas = kaunter
call mma_allocate(BasCoo,3,nBas,label='BasCoo')

!----------------------------------------------------------------------*
! And now coordinates of each basis.                                   *
!----------------------------------------------------------------------*
kaunter = 0
kaunt = 0
do i=1,ii
  do j=1,dbsc(i)%nCntr
    kaunt = kaunt+1
    do kk=1,nBonA(kaunt)
      kaunter = kaunter+1
      BasCoo(:,kaunter) = dbsc(i)%Coor(:,j)
    end do
  end do
end do

!----------------------------------------------------------------------*
! Now get info regarding the contraction. Icon is an array that for    *
! each basis type contain n1+n2+...+nx elements where n1 is the number *
! of contracted basis functions of s-type, n2 the same number for      *
! p-type etc. The value of the first n1 elements is the number of      *
! primitive basis functions of s-type, etc. So a contraction 7s3p.4s1p *
! generates the vector 7,7,7,7,3. We also compute natyp and also       *
! collect all exponents and contraction coefficients. These are stored *
! dynamically and then we return the pointers only.                    *
!----------------------------------------------------------------------*
MxPrCon = 0
kaunt = 0
do i=1,ii
  kaunter = 0
  do k=1,dbsc(i)%nShells
    kaunt = kaunt+1
    kaunter = kaunter+Shells(kaunt)%nBasis
  end do
  MxPrCon = max(MxPrCon,kaunter)
end do

call mma_allocate(Icon,nAtoms,MxPrCon,label='Icon')
kaunt = 0
do i=1,ii
  kaunter = 0
  do k=1,dbsc(i)%nShells
    kaunt = kaunt+1
    do ll=1,Shells(kaunt)%nBasis
      kaunter = kaunter+1
      Icon(i,kaunter) = Shells(kaunt)%nExp
    end do
  end do
end do

ndc = 0
iAngSav = 1
nSize = 0
kaunt = 0
do kk=1,ii !Just to get size of vector
  do kkk=1,dbsc(kk)%nShells
    kaunt = kaunt+1
    nSize = nSize+Shells(kaunt)%nBasis*Shells(kaunt)%nExp
  end do
end do
call mma_allocate(Expo,nntyp,nSize,label='Exponents')
call mma_allocate(Cont,nntyp,nSize,label='ContrCoef')
Expo(:,:) = Zero
Cont(:,:) = Zero

do iCnttp=1,nCnttp  !Here we set NaTyp.
  jSum = 0
  iTemp = 0
  nVarv = dbsc(iCnttp)%nShells
  nSh(iCnttp) = nVarv
  do iCnt=1,dbsc(iCnttp)%nCntr
    ndc = ndc+1
    iTemp = iTemp+dc(ndc)%nStab
  end do
  NaTyp(iCnttp) = iTemp
  do iAng=0,nVarv-1  !And in this loop we get hold of the contraction coefficients and the exponents.
    iCount = iAng+iAngSav
    iPrim = Shells(iCount)%nExp
    iBas = Shells(iCount)%nBasis
#   ifdef _DEBUGPRINT_
    call RecPrt('Exp',' ',Shells(iCount)%Exp,iPrim,1)
    call RecPrt('Cff',' ',Shells(iCount)%pCff,iPrim,iBas)
#   endif
    nfSh(iCnttp,iAng+1) = iBas
    do i=1,iBas
      Expo(iCnttp,jSum+1:jSum+iPrim) = Shells(iCount)%Exp(1:iPrim)
      Cont(iCnttp,jSum+1:jSum+iPrim) = Shells(iCount)%pCff(1:iPrim,i)
      jSum = jSum+iPrim
    end do
  end do
  iAngSav = iAngSav+iAng
end do
if (iPrint >= 30) then
  write(u6,*) 'Exp.'
  write(u6,'(10G13.4)') Expo(:,:)
  write(u6,*) 'Contr.'
  write(u6,'(10G13.4)') Cont(:,:)
end if

!----------------------------------------------------------------------*
! Construct the nPrim vector.                                          *
!----------------------------------------------------------------------*
call mma_allocate(nPrim,nbas,label='nPrim')
iBas = 0
do i=1,nntyp
  na = natyp(i)
  do j=1,na
    ind = 0
    nshj = nsh(i)
    do k=1,nshj
      nnaa = nfsh(i,k)
      do l=1,nnaa
        iBas = iBas+1
        ind = ind+1
        nPrim(iBas) = iCon(i,ind)
      end do
    end do
  end do
end do

! Then since overlap integrations are in cartesian coordinates while
! the AO-basis is spherical, we need transformation matrix for this.
! To our great joy, old reliable Seward computes this matrix of any
! order (within Molcas limits). Due to conflicting order conventions,
! some numbers gymnastics are required.

MaxAng = MaxAng-1
nSize = (2*MaxAng+1)*nTri_Elem1(MaxAng)
nACCSize = 0
do i=2,MaxAng
  nACCSize = nACCSize+(2*i+1)*nTri_Elem1(i)
end do
call mma_allocate(TEMP1,nSize,Label='TEMP1')
call mma_allocate(TEMP2,nSize,Label='TEMP2')
call mma_allocate(Acc,nACCSize,label='AccTransa')

nSumma = 0
do i=2,MaxAng
  ind1 = nTri_Elem1(i)
  ind2 = 2*i+1
  iHowMuch = ind1*ind2
  TEMP1(1:iHowMuch) = RSph(ipSph(i):ipSph(i)+iHowMuch-1)
  ind3 = 1
  do jj=1,ind1
    call dcopy_(ind2,TEMP1(jj),ind1,TEMP2(ind3),1)
    ind3 = ind3+ind2
  end do
  !call recprt('FFF',' ',TEMP1,nTri_Elem1(i),2*i+1)
  !call recprt('GGG',' ',TEMP2,ind2,ind1)
  Acc(nSumma+1:nSumma+iHowMuch) = Temp2(1:iHowMuch)
  nSumma = nSumma+iHowMuch
end do

call mma_deallocate(TEMP1)
call mma_deallocate(TEMP2)
!----------------------------------------------------------------------*
! Make deallocations. They are necessary because of the getinf.        *
!----------------------------------------------------------------------*
call ClsSew()

return

end subroutine GiveMeInfo

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************
!  CHO_GET_OED_cd
!
!> @brief
!>   Computes the Cholesky vectors of the 2nd-rank orbital energy denominators according to Eq. (7) of \cite Koc2000-JCP-113-508
!> @author F. Aquilante
!>
!> @details
!> Computes the Cholesky vectors of the 2nd-rank orbital energy denominators
!> according to Eq. (7) of \cite Koc2000-JCP-113-508
!>
!> @param[in]     incore Boolean for in or out of core decomposition
!> @param[in]     nOV    Number of (occ,vir) pairs matching a given compound symmetry
!> @param[in]     W      Array (\p nOV) of the orbital energy differences \p W(bj) = ``e(b)-e(j)``
!> @param[in]     NVec   Number of Cholesky vectors requested
!> @param[in]     ID_bj  Index array (\p NVec) of the decomposition pattern
!> @param[in]     JVec   Starting Cholesky vector
!> @param[in,out] Y      Matrix (\p nOV,\p NVec) of the Cholesky vectors for the decomposition of the orbital energy denominators
!> @param[in,out] R      Matrix (\p nOV) of the previous products, to be used for out of core decomposition.
!>                       Note: in case of out of core, in the first call this array *must* be initialized to ``1.0``.
!>                       For the in core case, it *must* also coincide with the first column of \p Y and *must* still be initialized in input.
!***********************************************************************

subroutine CHO_GET_OED_cd(incore,nOV,W,NVec,ID_bj,JVec,Y,R)

use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: incore
integer(kind=iwp), intent(in) :: nOV, NVec, ID_bj(*), JVec
real(kind=wp), intent(in) :: W(*)
real(kind=wp), intent(inout) :: Y(*), R(*)
integer(kind=iwp) :: Jk, Jm, kp, np
real(kind=wp), parameter :: xtwo = sqrt(Two)

#include "warnings.h"

if (NVec < 1) then
  write(u6,*) 'Error in CHO_GET_OED_cd : in input NVec < 1 .'
  call quit(_RC_CHO_LOG_)
end if

! Compute  R(p,k) = R(p,k-1) * (W(p) - W(J[k-1]))/(W(p) + W(J[k-1]))
! ------------------------------------------------------------------
if (incore) then

  if (JVec /= 1) then
    write(u6,*) 'CHO_GET_OED_cd : JVec must be 1 if incore .'
    call quit(_RC_CHO_LOG_)
  end if
  do Jk=2,NVec
    kp = NOV*(Jk-1)
    np = kp-NOV
    Jm = ID_bj(Jk-1)
    Y(kp+1:kp+NOV) = Y(np+1:np+NOV)*(W(1:NOV)-W(Jm))/(W(1:NOV)+W(Jm))
  end do

else

  Jm = ID_bj(JVec-1)
  Y(1:NOV) = R(1:NOV)*(W(1:NOV)-W(Jm))/(W(1:NOV)+W(Jm))
  do Jk=2,NVec
    kp = NOV*(Jk-1)
    np = kp-NOV
    Jm = ID_bj(JVec+Jk-3)
    Y(kp+1:kp+NOV) = Y(np+1:np+NOV)*(W(1:NOV)-W(Jm))/(W(1:NOV)+W(Jm))
  end do
  R(1:NOV) = Y(NOV*(NVec-1)+1:NOV*NVec)

end if

! Compute  Y(p,k) = R(p,k) * sqrt(2*W(J[k]))/(W(p) + W(J[k]))
! -----------------------------------------------------------
do Jk=1,NVec
  kp = NOV*(Jk-1)
  Jm = ID_bj(JVec+Jk-1)
  Y(kp+1:kp+NOV) = Y(kp+1:kp+NOV)*xtwo*sqrt(W(Jm))/(W(1:NOV)+W(Jm))
end do

return

end subroutine CHO_GET_OED_cd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*---------------------------------------------------------------------*
*                                                                     *
*     Information pertinent to the bin sort algorithm                 *
*                                                                     *
*     *--------------------------------------------------------*      *
*     *                                                        *      *
*     *  Note:                                                 *      *
*     *  These definitions depend on the record structure of   *      *
*     *       2el integral file which are given in the         *      *
*     *         common /TWODEF/ of the RDORD utility           *      *
*     *                                                        *      *
*     *--------------------------------------------------------*      *
*                                                                     *
*     Parameter definitions:                                          *
*     mxBin  : maximum number of bin allowed. The number should       *
*              not be smaller than:                                   *
*              If nSyOp=1 mxBin=  1 and If Square=.true. mxBin=  1    *
*                 nSyOp=2 mxBin=  4                      mxBin=  5    *
*                 nSyOp=4 mxBin= 19                      mxBin= 28    *
*                 nSyOp=8 mxBin=106                      mxBin=176    *
*     lBin   : buffer length of a bin                                 *
*              Note: if lBin is not a multiple of 4*lDaRec            *
*              the buffers used for intermediate storing of           *
*              labels on LuTmp are used very inefficiently            *
*     mxSrtA : maximum sorting area to be used                        *
*                                                                     *
*     Entries to common SRT2:                                         *
*     lwIBin : array used to store index Bins                         *
*     lwVBin : array  used to store value Bins                        *
*     nRec   : number of record per slice                             *
*     iDIBin : disk adresses of index bins                            *
*     iDVBin : disk adresses of value bins                            *
*     nByte  : packed size of value bins                              *
*     nInt   : number of integrals in a bin                           *
*     mInt   : number of integrals and bytes in a slice               *
*     nOff1  : memory allocation offset for index bins                *
*     nOff2  : memory allocation offset for value bins                *
*     LuTwo  : logical unit number of ordered 2el file                *
*     LuTmp  : logical unit number of temporary file                  *
*     iDaTw0 : first disk adress after header of ordered 2el file     *
*     iDaTwo : current disk position of LuTwo                         *
*     iDaTmp : current disk position of LuTmp                         *
*     mDaTwo : highest accessed disk position of LuTwo                *
*     mDaTwo : highest accessed disk position of LuTmp                *
*     MxOrd  : total number of records on LuTwo                       *
*                                                                     *
*---------------------------------------------------------------------*
*
      Module Srt2
#include "TwoDef.fh"
      Parameter ( mxBin = 2048 )
      Parameter ( lBin_tce   = 4*lDaRec          )
      Parameter ( lBin_rle   =32*lDaRec          )
*
      Integer iDIBin(3,mxBin),iDVBin(4,mxBin)
      Integer nRec(mxBin),nByte(mxBin),nInt(mxBin),mInt(3,mxBin)
*
      Integer LuTwo,LuTmp,iDaTw0,iDaTwo,iDaTmp,mDaTwo,mDaTmp,MxOrd,lbin
*
      Real*8, Allocatable:: ValBin(:)
      Integer, Allocatable:: IndBin(:), lIndx(:), lInts(:)
      Integer, Allocatable:: lwIBin(:,:)
      Real*8,  Allocatable:: lwVBin(:,:)
      End Module Srt2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_M(ZA,nAtoms,RA,T,M)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms
real(kind=wp), intent(in) :: ZA(nAtoms), RA(3,nAtoms), T(3)
real(kind=wp), intent(out) :: M(3,3)
integer(kind=iwp) :: i, iAtom, j
real(kind=wp) :: RTx, RTy, RTz
real(kind=wp), parameter :: Thrs = 1.0e-14_wp

!                                                                      *
!***********************************************************************
!                                                                      *
! Form the nuclear charge moment tensor

M(:,:) = Zero
do iAtom=1,nAtoms
  RTx = RA(1,iAtom)-T(1)
  RTy = RA(2,iAtom)-T(2)
  RTz = RA(3,iAtom)-T(3)
  M(1,1) = M(1,1)+ZA(iAtom)*(RTy**2+RTz**2)
  M(2,2) = M(2,2)+ZA(iAtom)*(RTx**2+RTz**2)
  M(3,3) = M(3,3)+ZA(iAtom)*(RTx**2+RTy**2)

  M(1,2) = M(1,2)+ZA(iAtom)*(-RTx*RTy)
  M(1,3) = M(1,3)+ZA(iAtom)*(-RTx*RTz)
  M(2,1) = M(2,1)+ZA(iAtom)*(-RTy*RTx)

  M(2,3) = M(2,3)+ZA(iAtom)*(-RTy*RTz)
  M(3,1) = M(3,1)+ZA(iAtom)*(-RTz*RTx)
  M(3,2) = M(3,2)+ZA(iAtom)*(-RTz*RTy)
end do

! Remove noise

do i=1,3
  do j=1,3
    if (abs(M(i,j)) < Thrs) M(i,j) = Zero
  end do
end do
!call RecPrt('Compute_M: M',' ',M,3,3)

return

end subroutine Compute_M

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, IBM                                              *
!***********************************************************************

subroutine mHrr(la,lb,nSize,nMem)

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: la, lb
integer(kind=iwp), intent(out) :: nSize, nMem
integer(kind=iwp) :: ia, ib, nMem1, nMem2

! First find the size of the working array.

nMem = 0
nMem2 = 0
nSize = 0
do ib=0,min(la,lb)
  nMem1 = 0
  do ia=max(la,lb),la+lb-ib
    nSize = nSize+nTri_Elem1(ib)*nTri_Elem1(ia)
    nMem1 = nMem1+nTri_Elem1(ib)*nTri_Elem1(ia)
  end do
  nMem = max(nMem,nMem1+nMem2)
  nMem2 = nMem1
  if (ib == 0) nSize = 0
end do

return

end subroutine mHrr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Ben Swerts                                             *
*               2016, Liviu Ungur                                      *
************************************************************************
      SubRoutine Drv2El_FAIEMP()
************************************************************************
*                                                                      *
*  Object: driver for the central-fragment interaction 2-electron      *
*          integrals (based on drv2el_3center_RI and drv2el_scf)       *
*                                                                      *
*     Author: Ben Swerts                                               *
*   Modified: Liviu Ungur                                              *
************************************************************************
      use k2_arrays, only: pDq, pFq
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iOper
      use Real_Info, only: ThrInt, CutInt
      Implicit None
      External No_Routine
#include "print.fh"
#include "real.fh"
#include "setup.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      Integer      nTInt
      Parameter(   nTInt=1)
      Real*8       TInt(nTInt)
*
      Logical      W2Disc, PreSch, FreeK2, Verbose, Indexation,
     &             DoIntegrals, DoFock, DoGrad,NoCoul,NoExch
      Integer      iTOffs(8,8,8)
      Integer      nBas_Valence(0:7)
      Character*8  Label
      Logical      lNoSkip, EnergyWeight
      Integer      i, j, iCnt, iCnttp, iDpos, iFpos, iIrrep, ijS,
     &             iOpt, ip_ij, ipDMax,
     &             ipFragDensAO, ipOneHam, ipTMax, iRC, iPrint, iRout,
     &             ipFragDensSO, iS, jS, lS, kS, klS, maxDens, mdc,
     &             lOper, mDens, nBasC, nBT, nBVT, nBVTi, nFock, nij,
     &             nOneHam, Nr_Dens, nSkal, nSkal_Fragments,
     &             nSkal_Valence

      Real*8       Aint, Count, Disc, Disc_Mx, Dix_Mx, Dtst, ExFac,
     &             P_Eff, TCpu1, TCpu2, Thize, ThrAO, TMax_all,
     &             TskHi, TskLw, TWall1, TWall2, DMax, TMax
      Real*8, Allocatable, Target:: Dens(:), Fock(:)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Integer      iFD
      Character*80 Line
#endif
#include "../integral_util/dede_interface.fh"
*                                                                      *
************************************************************************
*                                                                      *
*----- Statement functions
*
      TMax(i,j)=Work((j-1)*nSkal+i+ipTMax-1)
      DMax(i,j)=Work((j-1)*nSkal+i+ipDMax-1)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 203
      iPrint = nPrint(iRout)
      call xFlush(6)
      ExFac=One
      Nr_Dens=1
      DoIntegrals=.False.
      NoCoul=.False.
      NoExch=.False.
c     W2Disc=.False.
      W2Disc=.True.
*
*     Handle both the valence and the fragment basis set
*
      Call Set_Basis_Mode('Valence')
      Call Nr_Shells(nSkal_Valence)
      Call Free_iSD
      Call Set_Basis_Mode('WithFragments')
      Call SetUp_iSD
      nBT = 0
      nBVT = 0
      do i = 0, nIrrep - 1
        nBas_Valence(i) = nBas(i)
        nBVT = nBVT + nBas(i)*(nBas(i)+1)/2
        nBas(i) = nBas(i) + nBas_Frag(i)
        nBT = nBT + nBas(i)*(nBas(i)+1)/2
      enddo
*                                                                      *
************************************************************************
*                                                                      *
*---  Construct custom density matrix
*
      Call mma_allocate(Dens,nBT,Label='Dens')
      Call mma_allocate(Fock,nBT,Label='Fock')
* Valence part is zero
      Dens(:)=Zero
      Fock(:)=Zero
* Each fragment needs it's (symmetrized) density matrix added along the
* diagonal.
* This density matrix first has to be constructed from the MO coeffs
* so allocate space for the largest possible density matrix
      maxDens = 0
      Do iCnttp = 1, nCnttp
        If(dbsc(iCnttp)%nFragType.gt.0) maxDens = Max(maxDens,
     &     dbsc(iCnttp)%nFragDens*(dbsc(iCnttp)%nFragDens+1)/2)
      End Do
      Call GetMem('FragDSO','Allo','Real',ipFragDensSO,maxDens)
      ipFragDensAO = ipFragDensSO

      iDpos = 1 ! position in the total density matrix
      Do iIrrep = 0, nIrrep - 1
        nBasC = nBas_Valence(iIrrep)
        iDpos = iDpos + nBasC*(nBasC+1)/2
        mdc = 0
        Do 1000 iCnttp = 1, nCnttp
          If(dbsc(iCnttp)%nFragType.le.0) Then
            mdc = mdc + dbsc(iCnttp)%nCntr
            Go To 1000
          End If
* construct the density matrix
          EnergyWeight = .false.
          Call MakeDens(dbsc(iCnttp)%nFragDens,dbsc(iCnttp)%nFragEner,
     &                dbsc(iCnttp)%FragCoef,dbsc(iCnttp)%FragEner,
     &                EnergyWeight,Work(ipFragDensAO))
* create the symmetry adapted version if necessary
* (fragment densities are always calculated without symmetry)
#ifdef _DEBUGPRINT_
          Call TriPrt('Fragment density',' ',
     &      Work(ipFragDensSO),dbsc(iCnttp)%nFragDens)
#endif

          Do iCnt = 1, dbsc(iCnttp)%nCntr
            mdc = mdc + 1
* only add fragment densities that are active in this irrep
* => the following procedure still has to be verified thoroughly
*    but appears to be working
            If(iAnd(dc(mdc)%iChCnt,iIrrep).eq.iOper(iIrrep)) Then
* add it at the correct location in the large custom density matrix
              iFpos = 1
c              ! position in fragment density matrix
              Do i = 1, dbsc(iCnttp)%nFragDens
                iDpos = iDpos + nBasC
                Do j = 0, i-1
                  Dens(iDpos + j) =
     &                          Work(ipFragDensSO + iFpos + j - 1)
                End Do
                iDpos = iDpos + i
                iFpos = iFpos + i
              End Do
              nBasC = nBasC + dbsc(iCnttp)%nFragDens
            End If
          End Do
 1000   Continue
      End Do
#ifdef _DEBUGPRINT_
      iFD = 1
      Do iIrrep = 0, nIrrep - 1
         Call TriPrt('Combined density',' ',Dens(iFD),nBas(iIrrep))
         iFD = iFD + nBas(iIrrep)*(nBas(iIrrep)+1)/2
      End Do
#endif
      Call GetMem('FragDSO','Free','Real',ipFragDensSO,maxDens)
*                                                                      *
************************************************************************
*                                                                      *
*-----Desymmetrize the custom density matrix
*
* Should be possible to reduce the storage space for the Fock matrix
* and only store the top nBas_Valence(0) rows (non-symmetry case tested)
*
      Call AlloK2()
      Call DeDe_SCF(Dens,Fock,nBT,mDens)
#ifdef _DEBUGPRINT_
      If (nIrrep.eq.1) Then
         Call RecPrt('Desymmetrized Density:',' ',pDq,nBas(0),nBas(0))
      Else
         iFD = 1
         Do iIrrep = 0, nIrrep - 1
            Call TriPrt('Desymmetrized density',' ',
     &                  pDq(iFD),nBas(iIrrep))
            iFD = iFD + nBas(iIrrep)*(nBas(iIrrep)+1)/2
         End Do
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Initialize for 2-electron integral evaluation. Do not generate
*     tables for indexation.
*
      ThrAO = Zero
      Indexation = .False.
      DoFock=.True.
      DoGrad=.False.
      Call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
      nSkal_Fragments=nSkal-nSkal_Valence
*                                                                      *
************************************************************************
*                                                                      *
      Thize=1.0d-6
      PreSch=.False.
      Disc_Mx=Zero
*
      Disc=Zero
      Dix_Mx=Zero
      TskHi=Zero
      TskLw=Zero
      ThrInt = CutInt   ! Integral neglect threshold from SCF
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      Call GetMem('TMax','Allo','Real',ipTMax,nSkal**2)
      Call Shell_MxSchwz(nSkal,Work(ipTMax))
      TMax_all=Zero
      Do iS = 1, nSkal
         Do jS = 1, iS
            TMax_all=Max(TMax_all,TMax(iS,jS))
         End Do
      End Do
      Call GetMem('DMax','Allo','Real',ipDMax,nSkal**2)
      Call Shell_MxDens(Dens,work(ipDMax),nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*     Create list of non-vanishing pairs
*
      Call GetMem('ip_ij','Allo','Inte',ip_ij,nSkal*(nSkal+1))
      nij=0
      Do iS = 1, nSkal
         Do jS = 1, iS
            If (TMax_All*TMax(iS,jS).ge.CutInt) Then
               nij = nij + 1
               iWork((nij-1)*2+ip_ij  )=iS
               iWork((nij-1)*2+ip_ij+1)=jS
            End If
         End Do
      End Do
      P_Eff=dble(nij)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Call CWTime(TCpu1,TWall1)
*
*     Now do a quadruple loop over shells
*
c     ijS = Int((One+sqrt(Eight*TskLw-Three))/Two)
      ijS = 1
      iS = iWork((ijS-1)*2+ip_ij)
      jS = iWork((ijS-1)*2+ip_ij+1)
c     klS = Int(TskLw-DBLE(ijS)*(DBLE(ijS)-One)/Two)
      klS = 1
      kS = iWork((klS-1)*2+ip_ij)
      lS = iWork((klS-1)*2+ip_ij+1)
 13   Continue
      If(ijS.gt.int(P_Eff)) Go To 12
*                                                                      *
************************************************************************
*                                                                      *
* density prescreening (results in iS > nSkal_Valence)
         Aint=TMax(iS,jS)*TMax(kS,lS)
         Dtst=Max(DMax(is,ls)/Four,DMax(is,ks)/Four,
     &            DMax(js,ls)/Four,DMax(js,ks)/Four,
     &            DMax(is,js),DMax(ks,ls))
         lNoSkip = Aint*Dtst.ge.ThrInt
* only calculate needed integrals and only update the valence part of the
* Fock matrix (iS > nSkal_Valence, lS <= nSkal_Valence, jS and kS
* belonging to different regions)
         If(jS.le.nSkal_Valence) Then
           lNoSkip = lNoSkip.and.kS.gt.nSkal_Valence
         Else
           lNoSkip = lNoSkip.and.kS.le.nSkal_Valence
         End If
         lNoSkip = lNoSkip.and.lS.le.nSkal_Valence

         If (lNoSkip) Then
           Call Eval_Ints_New_Internal
     &                    (iS,jS,kS,lS,TInt,nTInt,
     &                     iTOffs,No_Routine,
     &                     pDq,pFq,mDens,[ExFac],Nr_Dens,
     &                     [NoCoul],[NoExch],
     &                     Thize,W2Disc,PreSch,Disc_Mx,Disc,
     &                     Count,DoIntegrals,DoFock)
#ifdef _DEBUGPRINT_
            write(6,*) 'Drv2El_FAIEMP: for iS, jS, kS, lS =',is,js,ks,ls
            If (nIrrep.eq.1) Then
               Call RecPrt('updated Fock',' ',pFq,nBas(0),nBas(0))
            Else
               iFD = 1
               Do iIrrep = 0, nIrrep - 1
                 Call TriPrt('updated Fock',' ',pFq(iFD),nBas(iIrrep))
                 iFD = iFD + nBas(iIrrep)*(nBas(iIrrep)+1)/2
               End Do
            End If
#endif
         End If
         klS = klS + 1
         If (klS.gt.ijS) Then
            ijS = ijS + 1
            klS = 1
         End If
         iS = iWork((ijS-1)*2+ip_ij  )
         jS = iWork((ijS-1)*2+ip_ij+1)
         kS = iWork((klS-1)*2+ip_ij  )
         lS = iWork((klS-1)*2+ip_ij+1)
         Go To 13
*
*     Task endpoint
*
 12   Continue
*
*     Use a time slot to save the number of tasks and shell
*     quadruplets processed by an individual node
      Call SavStat(1,One,'+')
      Call SavStat(2,TskHi-TskLw+One,'+')
*
      Call CWTime(TCpu2,TWall2)
      Call SavTim(1,TCpu2-TCpu1,TWall2-TWall1)
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('ip_ij','Free','Inte',ip_ij,nSkal*(nSkal+1))
      Call GetMem('DMax','Free','Real',ipDMax,nSkal**2)
      Call GetMem('TMax','Free','Real',ipTMax,nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*     Terminate integral environment.
*
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*
      Call Free_DeDe(Dens,Fock,nBT)

      Call mma_deallocate(Dens)
#ifdef _DEBUGPRINT_
      write(6,*)
      write(6,*)
      write(6,'(a)') 'SO Integrals of type Frag2El Component 1'
      iFD = 1
      Do iIrrep = 0, nIrrep - 1
         Write (Line,'(1X,A,I1)')
     &      ' Diagonal Symmetry Block ', iIrrep+1
         Call TriPrt(Line,' ',Fock(iFD),nBas_Valence(iIrrep))
         iFD = iFD + nBas_Valence(iIrrep)*(nBas_Valence(iIrrep)+1)/2
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Write the results to the one electron integral file
*
* read the one electron hamiltonian
      Label = 'OneHam  '
      iRC = -1
      iOpt = 0
      Call GetMem('Temp','Allo','Real',ipOneHam,nBVT+4)
      Call RdOne(iRC,iOpt,Label,1,Work(ipOneHam),lOper)
      If(iRC.ne.0) Then
        Write (6,*) 'Drv2El_FAIEMP: Error reading from ONEINT'
        Write (6,'(A,A)') 'Label=',Label
        Call Abend()
      End If
* add the calculated results
      nOneHam = 0 ! counter in the ipOneHam matrices (small)
      nFock = 1   ! counter in the ipFock matrices (larger)
      Do iIrrep = 0, nIrrep - 1
        nBVTi = nBas_Valence(iIrrep)*(nBas_Valence(iIrrep)+1)/2
        call daxpy_(nBVTi,One,Fock(nFock),1,
     &                       Work(ipOneHam+nOneHam),1)
        nOneHam = nOneHam + nBVTi
        nFock = nFock + nBas(iIrrep)*(nBas(iIrrep)+1)/2
      End Do

* write out the results
#ifdef _DEBUGPRINT_
      iFD = ipOneHam
      Do iIrrep = 0, nIrrep - 1
         Call TriPrt('OneHam at end',' ',Work(iFD),nBas_Valence(iIrrep))
         iFD = iFD + nBas_Valence(iIrrep)*(nBas_Valence(iIrrep)+1)/2
      End Do
#endif
      iRC = -1
      Call WrOne(iRC,iOpt,Label,1,Work(ipOneHam),lOper)
      If(iRC.ne.0) Then
        Write (6,*) 'Drv2El_FAIEMP: Error writing to ONEINT'
        Write (6,'(A,A)') 'Label=',Label
        Call Abend()
      End If
      iRC = -1
      Label = 'OneHam 0'
      Call WrOne(iRC,iOpt,Label,1,Work(ipOneHam),lOper)
      If(iRC.ne.0) Then
        Write (6,*) 'Drv2El_FAIEMP: Error writing to ONEINT'
        Write (6,'(A,A)') 'Label=',Label
        Call Abend()
      End If

* cleanup
      Call GetMem('Temp','Free','Real',ipOneHam,nBVT+4)
      Call mma_deallocate(Fock)
*                                                                      *
************************************************************************
************************************************************************
************************************************************************
*                                                                      *
      Call Free_iSD
      Call Set_Basis_Mode('Valence')
      Call SetUp_iSD
      Do i = 0, nIrrep - 1
         nBas(i) = nBas_Valence(i)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkT_T17 (Ta,T,dimb,dimbe,no)
c
c       this routine do:
c       Ta(i,b',be',u) <- 2 T(be',b',u,i) - T(be',b',i,u)
c
c       N.B. Qvajt odflaknute
c
        implicit none
        integer dimb,dimbe,no
        real*8 T(1:dimbe,1:dimb,1:no,1:no)
        real*8 Ta(1:no,1:dimb,1:dimbe,1:no)
c
c       help variables
        integer i,u,be,b
c
        do u=1,no
        do i=1,no
        do b=1,dimb
        do be=1,dimbe
          Ta(i,b,be,u)=2.0d0*T(be,b,u,i)-T(be,b,i,u)
        end do
        end do
        end do
        end do
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,2001, Roland Lindh                                *
!***********************************************************************

subroutine PCMInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of nuclear attraction     *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, January '91                             *
!                                                                      *
!             Modified to PCM-integrals, by RL June '01, Napoli, Italy.*
!***********************************************************************

use PCM_arrays, only: C_Tessera, nTiles, q_Tessera
use Index_Functions, only: nTri_Elem1, nTri3_Elem1
use Rys_interfaces, only: cff2d_kernel, modu2_kernel, rys2d_kernel, tval_kernel
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Symmetry_Info, only: ChOper
use Definitions, only: u6
#endif

implicit none
#include "int_interface.fh"
integer(kind=iwp) :: iAnga(4), iDCRT(0:7), ipIn, iTile, jStab_(0:0), lDCRT, LmbdT, mabMax, mabMin, nDCRT, nFlop, nMem, nOp, NrOpr, &
                     nStab_, nT
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ii
#endif
real(kind=wp) :: C(3), Coora(3,4), CoorAC(3,2), Coori(3,4), Fact, qTessera, TC(3)
logical(kind=iwp) :: NoSpecial
procedure(cff2d_kernel) :: XCff2D
procedure(modu2_kernel) :: Fake
procedure(rys2d_kernel) :: XRys2D
procedure(tval_kernel) :: TNAI
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(nHer)
unused_var(CoorO)
unused_var(nOrdOp)
unused_var(PtChrg)
unused_var(iAddPot)

rFinal(:,:,:,:) = Zero

iAnga(1) = la
iAnga(2) = lb
iAnga(3) = 0
iAnga(4) = 0
Coora(:,1) = A(:)
Coora(:,2) = RB(:)
Coori(:,1:2) = Coora(:,1:2)
mabMin = nTri3_Elem1(max(la,lb)-1)
if (EQ(A,RB)) mabMin = nTri3_Elem1(la+lb-1)
mabMax = nTri3_Elem1(la+lb)-1

! Compute FLOP's and size of work array which Hrr will use.

call mHrr(la,lb,nFLOP,nMem)

! Find center to accumulate angular momentum on. (HRR)

if (la >= lb) then
  CoorAC(:,1) = A(:)
else
  CoorAC(:,1) = RB(:)
end if

! The coordinates of the individual tiles are not stabilized by any
! operator but the unit operator.

nStab_ = 1
jStab_ = 0

! Loop over tiles.

do iTile=1,nTiles
  QTessera = Q_Tessera(iTile)
  C(:) = C_Tessera(:,iTile)
# ifdef _DEBUGPRINT_
  call RecPrt('C',' ',C,1,3)
# endif

  ! Find the DCR for M and S

  call DCR(LmbdT,iStabM,nStabM,jStab_,nStab_,iDCRT,nDCRT)
  Fact = One/real(LmbdT,kind=wp)

# ifdef _DEBUGPRINT_
  write(u6,*) ' m      =',nStabM
  write(u6,'(9A)') '(M)=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
  write(u6,*) ' s      =',nStab_
  write(u6,'(9A)') '(S)=',ChOper(jStab_)
  write(u6,*) ' LambdaT=',LmbdT
  write(u6,*) ' t      =',nDCRT
  write(u6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),ii=0,nDCRT-1)
# endif

  do lDCRT=0,nDCRT-1
    call OA(iDCRT(lDCRT),C,TC)
    CoorAC(:,2) = TC(:)
    Coori(:,3) = TC(:)
    Coori(:,4) = TC(:)
    Coora(:,3) = TC(:)
    Coora(:,4) = TC(:)

    ! Compute integrals with the Rys quadrature.

    nT = nZeta
    NoSpecial = .true.
    call Rys(iAnga,nT,Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,rKappa,[One],Coori,Coora,CoorAC,mabmin,mabmax,0,0,Array, &
             nArr*nZeta,TNAI,Fake,XCff2D,XRys2D,NoSpecial)

    ! Use the HRR to compute the required primitive integrals.

    call HRR(la,lb,A,RB,Array,nZeta,nMem,ipIn)

    ! Accumulate contributions to the symmetry adapted operator

    nOp = NrOpr(iDCRT(lDCRT))
    call SymAdO(Array(ipIn),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,-Fact*QTessera)
#   ifdef _DEBUGPRINT_
    write(u6,*) Fact*QTessera
    call RecPrt('PCMInt: Array(ipIn)',' ',Array(ipIn),nZeta,nTri_Elem1(la)*nTri_Elem1(lb)*nComp)
    call RecPrt('PCMInt: rFinal',' ',rFinal,nZeta,nTri_Elem1(la)*nTri_Elem1(lb)*nIC)
#   endif

  end do
end do

end subroutine PCMInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Per Ake Malmqvist                                *
*               2017, Giovanni Li Manni                                *
*               2017, Aron Cohen                                       *
************************************************************************
      Subroutine CSPBE(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object: To compute the functional called c_spbe in the Density       *
* Functional Repository (http://www.cse.clrc.ac.uk/qcg/dft)            *
* Original reference article: J.P. Perdew, K. Burke, and M. Ernzerhof, *
*  "Generalized gradient approximation made simple,"                   *
*      Phys. Rev. Lett. 77 (1996) 3865-3868.                           *
*                                                                      *
*      Author: G. Li Manni & A. Cohen, Max Planck Institute Stuttgart  *
*              Summer 2017, edited in Cambridge (UK) & Palermo (Sicily)*
************************************************************************
      use KSDFT_Info, only: tmpB
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
#include "ksdft.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
* Local arrays:
      Real*8 func1(3),func2(3,3)
* Call arguments:
* Weights(mGrid) (input) integration weights.
* Rho(nRho,mGrid) (input) Density and density derivative values,
*   Rho(1,iGrid) is rho_alpha values, Rho(2,iGrid) is rho_beta values
*   Rho(i,iGrid) is grad_rho_alpha (i=3..5 for d/dx, d/dy, d/dz)
*   Rho(i,iGrid) is grad_rho_beta  (i=6..8 for d/dx, d/dy, d/dz)
* dF_dRho (inout) are (I believe) values of derivatives of the
*   DFT functional (*NOT* derivatives of Fock matrix contributions).
* F_xc is values of the DFT energy density functional (surprised?)

* IDORD=Order of derivatives to request from CsPBE:
      idord=1

* cspbe has three input variables apart from idord=1:
*  The density (rho_in), its gradient (abs value!) grdrho_in,
*  and spin polarization zeta (zeta_in).
* The result is returned as follows:
*   func0 = Correlation energy density
*   func1(1) = Its first derivative wrt rho
*   func1(2) = Its first derivative wrt gamma
*   func1(3) = Its first derivative wrt zeta
*   func2(1,1) = Second derivative wrt rho
*   func2(2,2) = Second derivative wrt gamma
*   func2(3,3) = Second derivative wrt zeta
*   func2(1,2) = Mixed derivative wrt rho and gamma
*   func2(1,3) = Mixed derivative wrt rho and zeta
*   func2(2,3) = Mixed derivative wrt gamma and zeta
* Here, gamma=(grad rho)**2; AKA sigma in some formulas.
* The derivatives w.r.t. spin components rhoa, rhob, and to the
* gradients grdrhoa_x, etcetc, ..., grdrhob_z are then:
*  Let F(rhoa,rhob,grdrhoa_x,...,grdrhob_z) = CPBE(rho,gamma,zeta),
* then dF_drhoa = func1(1)+2*rhob*func1(3)/rho**2
*      dF_drhob = func1(1)-2*rhoa*func1(3)/rho**2
*      dF_dgrdrhoa_x = dF_dgrdrhob_x = 2*func1(2)*grdrho_x and so on.
      if (ispin.eq.1) then
* ispin=1 means spin zero.
        do iGrid=1,mgrid
         rhoa=Rho(ipR,iGrid)
         rho_in=2.0D0*rhoa
         if(rho_in.lt.T_X) goto 110
         grdrho_x=2.D0*Rho(ipdRx,iGrid)
         grdrho_y=2.D0*Rho(ipdRy,iGrid)
         grdrho_z=2.D0*Rho(ipdRz,iGrid)

         gamma=(grdrho_x**2+grdrho_y**2+grdrho_z**2)
         grdrho_in=sqrt(gamma)
         zeta_in=0.0D0
         call cspbe_(idord,rho_in,grdrho_in,zeta_in,func0,func1,func2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*func0
* dF_drhoa:
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*func1(1)
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*func1(2)
         dF_dRho(ipGxy,iGrid)=dF_dRho(ipGxy,iGrid)+Coeff*2.0D0*func1(2)
 110     continue
        end do
      else
* ispin .ne. 1, use both alpha and beta components.
        do iGrid=1,mgrid
         rhoa=max(1.0D-24,Rho(ipRa,iGrid))
         rhob=max(1.0D-24,Rho(ipRb,iGrid))
         rho_in=rhoa+rhob
         if(rho_in.lt.T_X) goto 210
         grdrhoa_x=Rho(ipdRxa,iGrid)
         grdrhoa_y=Rho(ipdRya,iGrid)
         grdrhoa_z=Rho(ipdRza,iGrid)
         grdrhob_x=Rho(ipdRxb,iGrid)
         grdrhob_y=Rho(ipdRyb,iGrid)
         grdrhob_z=Rho(ipdRzb,iGrid)

         grdrho_x=grdrhoa_x+grdrhob_x
         grdrho_y=grdrhoa_y+grdrhob_y
         grdrho_z=grdrhoa_z+grdrhob_z
         gamma=(grdrho_x**2+grdrho_y**2+grdrho_z**2)
         grdrho_in=sqrt(gamma)
         zeta_in=(rhoa-rhob)/rho_in
         call cspbe_(idord,rho_in,grdrho_in,zeta_in,func0,func1,func2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*func0
         tmpB(iGrid)=F_xc(iGrid)-tmpB(iGrid)
* dF_drhoa:
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+
     &            Coeff*(func1(1)+(2.0D0*func1(3))*(rhob/rho_in**2))
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+
     &            Coeff*(func1(1)-(2.0D0*func1(3))*(rhoa/rho_in**2))
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*func1(2)
         dF_dRho(ipGab,iGrid)=dF_dRho(ipGab,iGrid)+Coeff*2.0D0*func1(2)
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*func1(2)
 210     continue
        end do
      end if

      Return
      End

      subroutine cspbe_(idord,rho_in,grdrho_in,zeta_in
     &,func0,func1,func2)
      implicit none

C
C     Parameter variables
C
      REAL*8        ONE
      PARAMETER     (ONE = 1.0D0)
      REAL*8        TWO
      PARAMETER     (TWO = 2.0D0)
      REAL*8        THREE
      PARAMETER     (THREE = 3.0D0)
      REAL*8        FOUR
      PARAMETER     (FOUR = 4.0D0)
      REAL*8        HALF
      PARAMETER     (HALF = 0.5D0)
      REAL*8        THIRD
      PARAMETER     (THIRD = ONE/THREE)
      REAL*8        TOTHRD
      PARAMETER     (TOTHRD = TWO/THREE)
      REAL*8        FOTHRD
      PARAMETER     (FOTHRD = FOUR/THREE)
      REAL*8        PI
      PARAMETER     (PI = 3.1415926535897932384626433832795D0)
      REAL*8        KFCNST
      PARAMETER     (KFCNST = 1.9191582926775130066248203262468D0)
      REAL*8        FZCNST
      PARAMETER     (FZCNST = 1.9236610509315363197594581232755D0)
      REAL*8        D2FZ0
      PARAMETER     (D2FZ0 = 8.0D0*FZCNST/9.0D0)
      REAL*8        RHO2RS
      PARAMETER     (RHO2RS = 0.62035049088842779322331643499916D0)
      REAL*8        BETA
      PARAMETER     (BETA = 0.06672455060314922D0)
C
C     Argument variables
C
      REAL*8        FUNC0,       FUNC1(3),    FUNC2(3,3)
      REAL*8        GRDRHO_IN,   RHO_IN,      ZETA_IN
      INTEGER       IDORD
C
C     Local variables
C
      REAL*8        AC,          AI,          CFF1
      REAL*8        CFF2,        CFF3,        CFF4,        CFF5
      REAL*8        CFF6,        D2ACDR2,     D2AIDR2
      REAL*8        D2AIDRDZ,    D2AIDZ2
      REAL*8        D2ECDR2
      REAL*8        D2ECDRDZ,    D2ECDZ2,     D2ECFDR2
      REAL*8        D2ECPDR2,    D2FZDZ2,     D2GDX2
      REAL*8        D2PDG2
      REAL*8        D2PDGDZ
      REAL*8        D2PDR2
      REAL*8        D2PDRDG
      REAL*8        D2PDRDZ,     D2PDX2,      D2PDZ2,      D2QDG2
      REAL*8        D2QDGDZ
      REAL*8        D2QDR2,      D2QDRDG,     D2QDRDZ,     D2QDX2
      REAL*8        D2QDZ2,      D2TDG2,      D2TDGDZ
      REAL*8        D2TDR2,      D2TDRDG,     D2TDRDZ,     D2TDZ2
      REAL*8        D2XDG2
      REAL*8        D2XDGDZ
      REAL*8        D2XDR2,      D2XDRDG,     D2XDRDZ,     D2XDZ2
      REAL*8        D2YDG2
      REAL*8        D2YDGDZ
      REAL*8        D2YDR2
      REAL*8        D2YDRDG
      REAL*8        D2YDRDZ,     D2YDZ2,      DACDR,       DAIDR
      REAL*8        DAIDZ
      REAL*8        DECDR,       DECDZ,       DECFDR,      DECPDR
      REAL*8        DFZDZ,       DGDX
      REAL*8        DPDG,        DPDR,        DPDX,        DPDZ
      REAL*8        DQDG,        DQDR,        DQDX,        DQDZ
      REAL*8        DTDG,        DTDR,        DTDZ
      REAL*8        DXDG,        DXDR,        DXDZ
      REAL*8        DYDG,        DYDR,        DYDZ,        EC
      REAL*8        ECF,         ECP
      REAL*8        FZ,          G,           GRDRHO,      PHI
      REAL*8        PHI3G,       KF
      REAL*8        KS,          P,           Q,           RHO
      REAL*8        RHOI,        RS,          T,           X
      REAL*8        Y,           Z2,          Z3
      REAL*8        Z4,          ZETA
      REAL*8 D2HDG2
      REAL*8 D2HDGDZ
      REAL*8 D2HDR2
      REAL*8 D2HDRDG
      REAL*8 D2HDRDZ
      REAL*8 D2HDZ2
      REAL*8 D2PHIDZ2
      REAL*8 DHDG
      REAL*8 DHDR
      REAL*8 DHDZ
      REAL*8 DPHIDZ
      REAL*8 GAMMAS
      REAL*8 H
      REAL*8 s, dHds, d2Hdrds, d2Hdsdz, d2Hds2

      rho=Max(1.0D-24,rho_in)
      grdrho=grdrho_in
      if(zeta_in.gt. 1.0D0) zeta= 1.0d0
      if(zeta_in.lt.-1.0D0) zeta=-1.0d0
      zeta=zeta_in*(1.0d0-2.3d-16)

      rhoi=1.0D0/rho
      rs=rho2rs*(rhoi**third)
      x=sqrt(rs)
      kF=kFcnst/rs
      ks=sqrt(four/pi)*sqrt(kF)
*--------------------------------------------------------------
* PAM 2009: Some compilers doing code checking erroneously conclude that
* a lot of variables may get used uninitialized (due to if-statements).
* So they must get initialized here:
      d2acdr2=9.9D99
      d2aidr2=9.9D99
      d2aidrdz=9.9D99
      d2aidz2=9.9D99
      d2ecdr2=9.9D99
      d2ecdrdz=9.9D99
      d2ecdz2=9.9D99
      d2ecfdr2=9.9D99
      d2ecpdr2=9.9D99
      d2fzdz2=9.9D99
      d2pdg2=9.9D99
      d2pdgdz=9.9D99
      d2pdr2=9.9D99
      d2pdrdg=9.9D99
      d2pdrdz=9.9D99
      d2pdz2=9.9D99
      d2qdg2=9.9D99
      d2qdgdz=9.9D99
      d2qdr2=9.9D99
      d2qdrdg=9.9D99
      d2qdrdz=9.9D99
      d2qdz2=9.9D99
      d2tdgdz=9.9D99
      d2tdr2=9.9D99
      d2tdrdg=9.9D99
      d2tdrdz=9.9D99
      d2tdz2=9.9D99
      d2xdg2=9.9D99
      d2xdgdz=9.9D99
      d2xdr2=9.9D99
      d2xdrdg=9.9D99
      d2xdrdz=9.9D99
      d2xdz2=9.9D99
      d2ydg2=9.9D99
      d2ydgdz=9.9D99
      d2ydr2=9.9D99
      d2ydrdg=9.9D99
      d2ydrdz=9.9D99
      d2ydz2=9.9D99
      dacdr=9.9D99
      daidr=9.9D99
      daidz=9.9D99
      decdr=9.9D99
      decdz=9.9D99
      decfdr=9.9D99
      decpdr=9.9D99
      dfzdz=9.9D99
      dgdx=9.9D99
      dpdg=9.9D99
      dpdr=9.9D99
      dpdx=9.9D99
      dpdz=9.9D99
      dqdg=9.9D99
      dqdr=9.9D99
      dqdx=9.9D99
      dqdz=9.9D99
      dtdg=9.9D99
      dtdr=9.9D99
      dtdz=9.9D99
      dxdg=9.9D99
      dxdr=9.9D99
      dxdz=9.9D99
      dydg=9.9D99
      dydr=9.9D99
      dydz=9.9D99
      d2hdg2=9.9D99
      d2hdgdz=9.9D99
      d2hdr2=9.9D99
      d2hdrdg=9.9D99
      d2hdrdz=9.9D99
      d2hdz2=9.9D99
      d2phidz2=9.9D99
      dhdg=9.9D99
      dhdr=9.9D99
      dhdz=9.9D99
      dphidz=9.9D99
      dhds=9.9D99
      d2hdrds=9.9D99
      d2hdsdz=9.9D99
      d2hds2=9.9D99
*--------------------------------------------------------------
* Ac, and its derivatives w.r.t. rho:
      cff1=2.D0*0.016887D0
      cff2=0.11125D0
      cff3=10.357d0
      cff4=3.6231d0
      cff5=0.88026D0
      cff6=0.49671d0
      Q=cff1*x*(cff3+x*(cff4+x*(cff5+x*cff6)))
      P=log(one+one/Q)
      G=-cff1*(one+cff2*x**2)*P
      Ac=G
      if(idord.ge.1) then
       dxdr=-x*rhoi/6.0d0
       dQdx=cff1*(cff3+x*(2.D0*cff4+x*(3.D0*cff5+x*4.D0*cff6)))
       dPdx=-one/(Q*(Q+one))*dQdx
       dGdx=-cff1*(2.D0*cff2*x*P+(one+cff2*x**2)*dPdx)
       dAcdr=dGdx*dxdr
      end if
      if(idord.ge.2) then
       d2xdr2=-(7.0d0*dxdr*rhoi)/6.0d0
       d2Qdx2=cff1*(2.D0*cff4+x*(6.D0*cff5+x*12.D0*cff6))
       d2Pdx2=(dQdx**2.D0*(two-one/(Q+one))/Q-d2Qdx2)/(Q*(Q+one))
       d2Gdx2=-cff1*(2.D0*cff2*P+4.D0*cff2*x*dPdx
     &       +(one+cff2*x**2)*d2Pdx2)
       d2Acdr2=d2Gdx2*(dxdr**2)+dGdx*d2xdr2
      end if
*--------------------------------------------------------------
* EcP, and its derivatives:
      cff1=2.D0*0.0310907D0
      cff2=0.21370D0
      cff3=7.5957d0
      cff4=3.5876d0
      cff5=1.6382D0
      cff6=0.49294d0
      Q=cff1*x*(cff3+x*(cff4+x*(cff5+x*cff6)))
      P=log(one+one/Q)
      G=-cff1*(one+cff2*x**2)*P
      EcP=G
      if(idord.ge.1) then
       dQdx=cff1*(cff3+x*(2.D0*cff4+x*(3.D0*cff5+x*4.D0*cff6)))
       dPdx=-one/(Q*(Q+one))*dQdx
       dGdx=-cff1*(2.D0*cff2*x*P+(one+cff2*x**2)*dPdx)
       dEcPdr=dGdx*dxdr
      end if
      if(idord.ge.2) then
       d2Qdx2=cff1*(2.D0*cff4+x*(6.D0*cff5+x*12.D0*cff6))
       d2Pdx2=(dQdx**2.D0*(two-one/(Q+one))/Q-d2Qdx2)/(Q*(Q+one))
       d2Gdx2=-cff1*(2.D0*cff2*P+4.D0*cff2*x*dPdx
     &       +(one+cff2*x**2)*d2Pdx2)
       d2EcPdr2=d2Gdx2*(dxdr**2)+dGdx*d2xdr2
      end if
*--------------------------------------------------------------
* EcF, and its derivatives:
      cff1=2.D0*0.015545D0
      cff2=0.20548D0
      cff3=14.1189D0
      cff4=6.1977d0
      cff5=3.3662D0
      cff6=0.62517d0
      Q=cff1*x*(cff3+x*(cff4+x*(cff5+x*cff6)))
      P=log(one+one/Q)
      G=-cff1*(one+cff2*x**2)*P
      EcF=G
      if(idord.ge.1) then
       dQdx=cff1*(cff3+x*(2.D0*cff4+x*(3.D0*cff5+x*4.D0*cff6)))
       dPdx=-one/(Q*(Q+one))*dQdx
       dGdx=-cff1*(2.D0*cff2*x*P+(one+cff2*x**2)*dPdx)
       dEcFdr=dGdx*dxdr
      end if
      if(idord.ge.2) then
       d2Qdx2=cff1*(2.D0*cff4+x*(6.D0*cff5+x*12.D0*cff6))
       d2Pdx2=(dQdx**2.D0*(two-one/(Q+one))/Q-d2Qdx2)/(Q*(Q+one))
       d2Gdx2=-cff1*(2.D0*cff2*P+4.D0*cff2*x*dPdx
     &       +(one+cff2*x**2)*d2Pdx2)
       d2EcFdr2=d2Gdx2*(dxdr**2)+dGdx*d2xdr2
      end if
*--------------------------------------------------------------
* fz, and its derivatives:
      P=(one+zeta)**(fothrd)
      Q=(one-zeta)**(fothrd)
      fz=fzcnst*(P+Q-two)
      if(idord.ge.1) then
       dPdz= fothrd*P/(one+zeta)
       dQdz=-fothrd*Q/(one-zeta)
       dfzdz=fzcnst*(dPdz+dQdz)
      end if
      if(idord.ge.2) then
       d2Pdz2=third*dPdz/(one+zeta)
       d2Qdz2=-third*dQdz/(one-zeta)
       d2fzdz2=fzcnst*(d2Pdz2+d2Qdz2)
      end if
*--------------------------------------------------------------
* Ec(rho,zeta), and its derivatives:
      z2=zeta**2
      z3=z2*zeta
      z4=z3*zeta
      P=(Ac/d2fz0)
      Q=(P+EcF-EcP)
      Ec=EcP+(Q*z4-P)*fz
      if(idord.ge.1) then
       dPdr=(dAcdr/d2fz0)
       dQdr=dPdr+dEcFdr-dEcPdr
       dEcdr=dEcPdr+(dQdr*z4-dPdr)*fz
       dEcdz=four*Q*z3*fz+(Q*z4-P)*dfzdz
      end if
      if(idord.ge.2) then
       d2Pdr2=(d2Acdr2/d2fz0)
       d2Qdr2=d2Pdr2+d2EcFdr2-d2EcPdr2
       d2Ecdr2=d2EcPdr2+(d2Qdr2*z4-d2Pdr2)*fz
       d2Ecdrdz=four*dQdr*z3*fz+(dQdr*z4-dPdr)*dfzdz
       d2Ecdz2=12.0D0*Q*z2*fz+8.0d0*Q*z3*dfzdz+(Q*z4-P)*d2fzdz2
      end if
*--------------------------------------------------------------
* phi(zeta), and derivatives:
      kF=kFcnst/rs
      ks=sqrt(four/pi)*sqrt(kF)
      P=half*(one+zeta)**(tothrd)
      Q=half*(one-zeta)**(tothrd)
      phi=P+Q
      if(idord.ge.1) then
       dPdz= tothrd*P/(one+zeta)
       dQdz=-tothrd*Q/(one-zeta)
       dphidz=dPdz+dQdz
      end if
      if(idord.ge.2) then
       d2Pdz2=-third*dPdz/(one+zeta)
       d2Qdz2= third*dQdz/(one-zeta)
       d2phidz2=d2Pdz2+d2Qdz2
      end if
*--------------------------------------------------------------
* A(rho,zeta)=(beta/gammas)/(exp(-Ec/(phi**3*gammas))-1.0D0)
      gammas=0.031090690869654895034940863712730D0
      phi3g=phi**3*gammas

* and then used below in the combination "A*t**2".
* Here, we use the inverse Ai instead.

* P=Ec/(phi**3*gammas)

      P=Ec/phi3g
      Q=(gammas/beta)*exp(-P)
      Ai=Q-(gammas/beta)
      y=dphidz/phi
      if(idord.ge.1) then
       dPdr=dEcdr/phi3g
       dPdz=(dEcdz-3.D0*Ec*y)/phi3g
       dAidr=-Q*dPdr
       dAidz=-Q*dPdz
      end if
      if(idord.ge.2) then
       d2Pdr2=d2Ecdr2/phi3g
       d2Pdrdz=(d2Ecdrdz-3.D0*dEcdr*y)/phi3g
       d2Pdz2=(d2Ecdz2-6.D0*dEcdz*y+(12.D0*y**2-3.D0*(d2phidz2/phi))*Ec)
     &       /phi3g
       d2Aidr2=Q*(dPdr**2-d2Pdr2)
       d2Aidrdz=Q*(dPdr*dPdz-d2Pdrdz)
       d2Aidz2=Q*(dPdz**2-d2Pdz2)
      end if
* Ai and its derivatives have been checked OK.

* T in the code is T**2 in the original formula
      s=grdrho**2
      d2Tdg2=half/(phi*ks*rho)**2
      T=half*d2Tdg2*s
      if(idord.ge.1) then
       dTdg=d2Tdg2*grdrho
       dTdr=(-7.0d0*third)*T*rhoi
       dTdz=-2.D0*T*y
      end if
      if(idord.ge.2) then
       d2Tdrdg=(-7.0d0*third)*dTdg*rhoi
       d2Tdr2=(-10.0D0*third)*dTdr*rhoi
       d2Tdgdz=-2.D0*dTdg*y
       d2Tdz2=-3.D0*y*dTdz-2.D0*d2phidz2*T/phi
       d2Tdrdz=-2.D0*dTdr*y
      end if
* T and its derivatives have been checked OK.
!      x=Ai*(Ai+T)
!      if(idord.ge.1) then
!       dxdr=Ai*(2.D0*dAidr+dTdr)+T*dAidr
!       dxdz=Ai*(2.D0*dAidz+dTdz)+T*dAidz
!       dxdg=Ai*dTdg
!      end if
!      if(idord.ge.2) then
!       d2xdr2=2.D0*dAidr*(dAidr+dTdr)+Ai*(2.D0*d2Aidr2+d2Tdr2)+T*d2Aidr2
!       d2xdrdg=Ai*d2Tdrdg+dTdg*dAidr
!       d2xdrdz=dAidz*(2.D0*dAidr+dTdr)+Ai*(2.D0*d2Aidrdz+d2Tdrdz)+
!     &         dTdz*dAidr+T*d2Aidrdz
!       d2xdg2=Ai*d2Tdg2
!       d2xdgdz=Ai*d2Tdgdz+dAidz*dTdg
!       d2xdz2=2.D0*dAidz*(dAidz+dTdz)+Ai*(2.D0*d2Aidz2+d2Tdz2)+T*d2Aidz2
!      end if
!*
!      P=T*x
!      if(idord.ge.1) then
!       dPdr=dTdr*x+T*dxdr
!       dPdz=dTdz*x+T*dxdz
!       dPdg=dTdg*x+T*dxdg
!      end if
!      if(idord.ge.2) then
!       d2Pdr2=d2Tdr2*x+2.D0*dTdr*dxdr+T*d2xdr2
!       d2Pdrdz=d2Tdrdz*x+dTdr*dxdz+dTdz*dxdr+T*d2xdrdz
!       d2Pdz2=d2Tdz2*x+2.D0*dTdz*dxdz+T*d2xdz2
!       d2Pdg2=d2Tdg2*x+2.D0*dTdg*dxdg+T*d2xdg2
!       d2Pdrdg=d2Tdrdg*x+dTdr*dxdg+dTdg*dxdr+T*d2xdrdg
!       d2Pdgdz=d2Tdgdz*x+dTdg*dxdz+dTdz*dxdg+T*d2xdgdz
!      end if
!      Q=x+T**2
!      if(idord.ge.1) then
!       dQdr=dxdr+2.D0*T*dTdr
!       dQdz=dxdz+2.D0*T*dTdz
!       dQdg=dxdg+2.D0*T*dTdg
!      end if
!      if(idord.ge.2) then
!       d2Qdr2=d2xdr2+2.D0*(dTdr**2+T*d2Tdr2)
!       d2Qdrdz=d2xdrdz+2.D0*(dTdz*dTdr+T*d2Tdrdz)
!       d2Qdz2=d2xdz2+2.D0*(dTdz**2+T*d2Tdz2)
!       d2Qdg2=d2xdg2+2.D0*(T*d2Tdg2+dTdg**2)
!       d2Qdrdg=d2xdrdg+2.D0*(dTdg*dTdr+T*d2Tdrdg)
!       d2Qdgdz=d2xdgdz+2.D0*(dTdg*dTdz+T*d2Tdgdz)
!      end if
       y = Ai*T/(Ai+T)
!      y=P/Q
      if(idord.ge.1) then
       dydr= (dAidr*T+Ai*dTdR)/(Ai+T)-Ai*T*(dAidr+dTdr)/(Ai+T)**2
       dydz= (dAidz*T+Ai*dTdz)/(Ai+T)-Ai*T*(dAidz+dTdz)/(Ai+T)**2
       dydg= (Ai*dTdg)/(Ai+T)-Ai*T*(dTdg)/(Ai+T)**2
      end if
!      if(idord.ge.2) then
!       d2ydr2=(d2Pdr2-2.D0*dydr*dQdr-y*d2Qdr2)/Q
!       d2ydrdz=(d2Pdrdz-dydr*dQdz-dydz*dQdr-y*d2Qdrdz)/Q
!       d2ydz2=(d2Pdz2-2.D0*dydz*dQdz-y*d2Qdz2)/Q
!       d2ydg2=(d2Pdg2-2.D0*dydg*dQdg-y*d2Qdg2)/Q
!       d2ydrdg=(d2Pdrdg-dydr*dQdg-dydg*dQdr-y*d2Qdrdg)/Q
!       d2ydgdz=(d2Pdgdz-dydg*dQdz-dydz*dQdg-y*d2Qdgdz)/Q
!      end if
      P=log(one+(beta/gammas)*y)
      Q=(beta/gammas)/(one+(beta/gammas)*y)
      if(idord.ge.1) then
       dPdr=Q*dydr
       dPdz=Q*dydz
       dPdg=Q*dydg
      end if
      if(idord.ge.2) then
       d2Pdr2=Q*(d2ydr2-Q*dydr**2)
       d2Pdrdz=Q*(d2ydrdz-Q*dydr*dydz)
       d2Pdz2=Q*(d2ydz2-Q*dydz**2)
       d2Pdg2=Q*(d2ydg2-Q*dydg**2)
       d2Pdrdg=Q*(d2ydrdg-Q*dydr*dydg)
       d2Pdgdz=Q*(d2ydgdz-Q*dydg*dydz)
      end if

      H=phi3g*P
      if(idord.ge.1) then
       dHdr=phi3g*dPdr
       dHdg=phi3g*dPdg
       y=dphidz/phi
       dHdz=phi3g*(dPdz+3.D0*y*P)
      end if
      if(idord.ge.2) then
       d2Hdr2=phi3g*d2Pdr2
       d2Hdrdz=phi3g*(d2Pdrdz+3.D0*y*dPdr)
       d2Hdz2=phi3g*(d2Pdz2+6.D0*y*dPdz+
     &          (6.D0*y**2+3.D0*(d2phidz2/phi))*P)
       d2Hdg2=phi3g*d2Pdg2
       d2Hdrdg=phi3g*d2Pdrdg
       d2Hdgdz=phi3g*(d2Pdgdz+3.D0*y*dPdg)
      end if

* Change derivatives w.r.t. grad_rho into derivatives w.r.t. sigma:
      if(idord.ge.1) then
       dHds=dHdg/(2.D0*grdrho)
      end if
      if(idord.ge.2) then
       d2Hdrds=d2Hdrdg/(2.D0*grdrho)
       d2Hdsdz=d2Hdgdz/(2.D0*grdrho)
       d2Hds2 =(d2Hdg2-2.D0*dHds) /(4.D0*s)
      end if
* Finally, the functional is defined as the integrand in the
* expression for the correlation energy, i.e. there is a factor
* rho:
      func0=rho_in*(Ec+H)
      if(idord.ge.1) then
       func1(1)=rho_in*(dEcdr+dHdr)+(Ec+H)
       func1(2)=rho_in*(      dHds)
       func1(3)=rho_in*(dEcdz+dHdz)
      end if
      if(idord.ge.2) then
       func2(1,1)=rho_in*(d2Ecdr2 +d2Hdr2)+2.0D0*(dEcdr+dHdr)
       func2(1,2)=rho_in*(         d2Hdrds)+dHds
       func2(1,3)=rho_in*(d2Ecdrdz+d2Hdrdz)+(dEcdz+dHdz)
       func2(2,2)=rho_in*(         d2Hds2)
       func2(2,3)=rho_in*(         d2Hdsdz)
       func2(3,3)=rho_in*(d2Ecdz2 +d2Hdz2)
       func2(2,1)=func2(1,2)
       func2(3,1)=func2(1,3)
       func2(3,2)=func2(2,3)
      end if

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine Cho_X_SetInc(irc)
C
C     T.B. Pedersen, July 2004.
C
C     Purpose: define all entries in include files
C              choprint.fh
C              choorb.fh
C              cholesky.fh
C              chosew.fh
C              chovecbuf.f90
C              chosubscr.fh
C              chpari.fh
C              cho_para_info.fh
C              and some in the Module choarr.f90
C
      use ChoArr, only: nDim_Batch, nQual_L, n_MySP
      use ChoBkm, only:  nRow_BkmVec, nCol_BkmVec,
     &                   nRow_BkmThr, nCol_BkmThr
      use ChoVecBuf, only: ip_CHVBUF_SYM, l_CHVBUF_SYM,
     &                     ip_CHVBFI_SYM, l_CHVBFI_SYM,
     &                     nVec_in_Buf
      use ChoSubScr, only: Cho_SScreen, SSTau, SubScrStat, SSNorm
      Implicit None
      Integer irc
#include "choorb.fh"
#include "choprint.fh"
#include "cholesky.fh"
#include "chpari.fh"
#include "cho_para_info.fh"

      Integer iLarge
      Parameter (iLarge = 99999999)

      Real*8 Large, Small
      Parameter (Large = 1.0D15, Small = 1.0D-15)

C     Set return code.
C     ----------------

      irc = 0

C     choprint.fh.
C     -------------

      iPrint = -iLarge

C     choorb.fh.
C     -----------

      Call iZero(iBas,8)
      Call iZero(nBas,8)
      Call iZero(XnBas,8)
      nBasT = 0

C     cholesky.fh.
C     -------------

      ThrCom  = Large
      ThrDiag = Large
      Tol_DiaChk = -Large
      ThrNeg  = Large
      WarNeg  = Large
      TooNeg  = Large
      nSym    = -iLarge
      lBuf    = -iLarge
      MinQual = iLarge
      MaxQUal = iLarge
      IFCSew  = -iLarge
      Mode_Screen = -iLarge
      Cho_DecAlg  = -iLarge
      Cho_DecAlg_Def = -iLarge
      iAlQua  = iLarge
      MxShPr  = iLarge
      ModRst  = iLarge
      Run_Mode = iLarge
      ScDiag  = .false.
      ChkOnly = .false.
      Cho_IntChk = .false.
      Cho_MinChk = .false.
      Cho_UseAbs = .false.
      Cho_TrcNeg = .false.
      Cho_ReOrd  = .false.
      Cho_DiaChk = .false.
      Cho_TstScreen = .false.
      Cho_1Center = .false.
      Cho_No2Center = .false.
      Cho_PreScreen = .false.
      Cho_SimP = .false.
      Cho_Fake_Par = .false.
      RstDia  = .false.
      RstCho  = .false.
      Did_DecDrv = .false.
      HaltIt  = .false.
      Trace_Idle = .false.

      Call iZero(LuCho,8)
      Call iZero(LuSel,8)
      Call iZero(LuTmp,8)
      LuPri = 0
      LuScr = 0
      LuRed = 0
      LuRst = 0
      LuMap = 0

      nShell = 0
      nnShl_Tot  = 0
      nnShl = 0
      MxORSh = 0
      Mx2Sh  = 0
      Call iZero(iiBstR,8*3)
      Call iZero(nnBstR,8*3)
      Call iZero(nnBstRT,3)
      mmBstRT = 0
      nQual_L(:)=0
      Call iZero(iOffQ,8)

      Call FZero(DiaMax,8)
      Call FZero(DiaMaxT,8)
      Call FZero(DiaMin,8)
      Call FZero(Damp,2)
      Span   = Large
      XlDiag = Large
      DiaMnZ = Large
      Thr_PreScreen = -Large
      iABMnZ = -iLarge
      nnZTot = 0

      Call iZero(NumCho,8)
      NumChT = 0
      MaxVec = 0
      MaxRed = 0
      BlockSize = -iLarge

      ShA = -iLarge
      ShB = -iLarge
      ShC = -iLarge
      ShD = -iLarge
      ShAB = -iLarge
      ShCD = -iLarge
      nColAB = -iLarge
      Call iZero(iOff_Col,8)

      XThrCom  = Large
      XThrDiag = Large
      Call FZero(XDamp,2)
      XSpan    = Large
      XThrNeg  = Large
      XWarNeg  = Large
      XTooNeg  = Large
      XnSym    = 0
      XnShell  = 0
      XnnShl   = 0
      XnPass   = 0
      XScDiag  = .false.
      XCho_AdrVec = -iLarge

      Call iZero(iChkQ,4*(nChkQ+1))
      nCol_Chk = -iLarge
      Call FZero(TimSec,4*nSection)
      Call FZero(tInteg,2*nInteg)
      Call FZero(tDecom,2*nDecom)
      Call FZero(tMisc,2*nMisc)
      Call FZero(tDecDrv,2)

      Call iZero(nVecRS1,8)

      Cho_AdrVec= -iLarge
      Cho_IOVec = -iLarge
      nSys_Call = 0
      nDGM_Call = 0
      N1_VecRd  = 0
      N2_VecRd  = 0
      N_Subtr   = 0

      N1_Qual = -iLarge
      N2_Qual = iLarge

      Frac_ChVBuf = 0.0d0

      nDim_Batch(:)=0

      nQual_L(:)=0

      n_MySP=0

      Cho_SimRI = .false.
      Thr_SimRI = -Large

C     chovecbuf.f90.
C     --------------

      Call iZero(ip_ChVBuf_Sym,8)
      Call iZero(l_ChVBuf_Sym,8)
      Call iZero(ip_ChVBfI_Sym,8)
      Call iZero(l_ChVBfI_Sym,8)
      Call iZero(nVec_in_Buf,8)

C     chosubscr.fh.
C     --------------

      Cho_SScreen = .false.
      SSTau       = 0.0d0
      SubScrStat(1) = 0.0d0
      SubScrStat(2) = 0.0d0
      SSNorm      = 'tbp'

C     chpari.fh.
C     -----------

      Call iZero(NumCho_Bak,8)

C     cho_para_info.fh.
C     ------------------

      Cho_Real_Par = .false.

C     chobkm.f90
C     -----------

      nRow_BkmVec=0
      nCol_BkmVec=0
      nRow_BkmThr=0
      nCol_BkmThr=0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_VecTransp(Vec,Jin,Jfi,iSym,iRed,iPass)

#ifdef _MOLCAS_MPP_
use Para_Info, only: MyRank, nProcs
use Cholesky, only: Cho_AdrVec, Cho_Real_Par, iiBstR, iiBstR_G, iL2G, IndRed, InfVec_G, IndRed, LuCho_G, MaxVec, myNumCho, nnBstR, &
                    nnBstR_G
#ifdef _DEBUGPRINT_
use Cholesky, only: LuPri
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: u6
#endif
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: Vec(*)
integer(kind=iwp), intent(in) :: Jin, Jfi, iSym, iRed, iPass
character(len=*), parameter :: SecNam = 'Cho_VecTransp'
#ifdef _MOLCAS_MPP_
#include "mafdecls.fh"
integer(kind=iwp) :: g_a, i, i1, iAdr, iCount, iNode, iOpt, irc, iRSL, iStart, iVec, iVec1, j, j1, Jin0, jRed, jv, jVec, LastV, &
                     lTot, MxRSL, MyEnd, myStart, nProcs_eff, nRS_g, nRS_l, nV, nVR
logical(kind=iwp) :: ok
integer(kind=iwp), allocatable :: iAdrLG(:,:), iVecR(:), Map(:), MapRS2RS(:), nRSL(:)
real(kind=wp), allocatable :: VecR(:,:)
logical(kind=iwp), external :: ga_create_irreg, ga_destroy

if (.not. Cho_Real_Par) then
# ifdef _DEBUGPRINT_
  write(u6,'(A,A,A)') 'Illegal call to ',SecNam,':'
  write(u6,*) 'Should only be called in parallel, but Cho_Real_Par = ',Cho_Real_Par
# endif
  call Cho_Quit('Illegal call to '//SecNam,103)
end if

if (iRed == 2) then
  jRed = 3
else if (iRed == 3) then
  jRed = 2
else
  call Cho_Quit('iRed must be 2 or 3 in '//SecNam,104)
end if
nRS_l = nnBstR(iSym,iRed)   ! local  red set dimension
nRS_g = nnBstR_G(iSym,iRed) ! global red set dimension
nV = Jfi-Jin+1
nVR = 0

call mma_allocate(iVecR,nV,Label='iVecR')
call cho_p_distrib_vec(Jin,Jfi,iVecR,nVR)
call mma_allocate(VecR,nRS_g,nVR+1,Label='VecR')

call mma_allocate(nRSL,nProcs,Label='nRSL')
nRSL(:) = 0
nRSL(1+MyRank) = nRS_l  ! MyRank starts from 0
call Cho_GAIGOP(nRSL,nProcs,'+')

MxRSL = nRSL(1)
do i=2,nProcs
  MxRSL = max(MxRSL,nRSL(i))
end do
call mma_allocate(iAdrLG,MxRSL,nProcs,Label='iAdrLG')

call mma_allocate(Map,nProcs,Label='Map')
nProcs_eff = 0
iStart = 1
myStart = 0
do i=1,nProcs
  if (nRSL(i) > 0) then
    nProcs_eff = nProcs_eff+1
    Map(nProcs_eff) = iStart
    if ((i-1) == myRank) myStart = iStart
    iStart = iStart+nRSL(i)
  end if
end do

#ifdef _DEBUGPRINT_
write(LuPri,*)
write(LuPri,*) SecNam,': debug info.'
write(LuPri,*) '#nodes: ',nProcs,'  myRank: ',myRank
write(LuPri,*) '#contributing nodes: ',nProcs_eff
write(LuPri,*) 'Symmetry block: ',iSym
write(LuPri,*) 'On this node:'
write(LuPri,*) 'Vector dimension : ',nRS_l
write(LuPri,*) 'Number of vectors: ',nV,' (',Jin,'-',Jfi,')'
write(LuPri,*) 'Global vector dimension : ',nRS_g
write(LuPri,*) 'Number of global vectors: ',nVR
write(Lupri,*) 'MAP:'
write(LuPri,*) (map(i),i=1,nProcs_eff)
#endif
ok = ga_create_irreg(mt_dbl,nRS_g,nV,'Ga_Vec',Map,nProcs_eff,1,1,g_a)
if (.not. ok) call Cho_Quit(SecNam//': ga_create_irreg error',101)

if (nRS_l > 0) then
  myEnd = myStart+nRS_l-1
  call ga_put(g_a,myStart,myEnd,1,nV,Vec,nRS_l)
end if
call GASync()
Jin0 = Jin-1
do i=1,nVR
  jv = iVecR(i)-Jin0
  call ga_get(g_a,1,nRS_g,jv,jv,VecR(:,i),nRS_g)
end do

ok = ga_destroy(g_a)
if (.not. ok) call Cho_Quit(SecNam//': ga_destroy error',101)

! write the reordered vec on disk

call Cho_P_IndxSwp()
irc = -1
call Cho_X_RSCopy(irc,1,jRed)
if (irc /= 0) call Cho_Quit(SecNam//': Non-zero return code from Cho_X_RSCopy',104)

call mma_allocate(MapRS2RS,nnBstR(iSym,1),Label='MapRS2RS')
call Cho_RS2RS(mapRS2RS,size(mapRS2RS),jRed,iRed,iPass,iSym)
call Cho_P_IndxSwp()

iAdrLG(:,:) = 0
do i=1,nRS_l
  i1 = IndRed(iiBstR(iSym,iRed)+i,iRed) ! addr in local rs1
  j1 = iL2G(i1) ! addr in global rs1
  j = mapRS2RS(j1-iiBstR_G(iSym,1)) ! addr in glob. rs
  iAdrLG(i,myRank+1) = j
end do
call Cho_GAIGOP(iAdrLG,size(iAdrLG),'+')

call mma_deallocate(MapRS2RS)

#ifdef _DEBUGPRINT_
iCount = sum(nRSL(1:nProcs))
if (iCount /= nRS_g) call Cho_Quit('nRSL error in '//SecNam,104)
#endif

do j=1,nVR
  VecR(:,nVr+1) = VecR(:,j)
  iCount = 0
  do iNode=1,nProcs
    do iRSL=1,nRSL(iNode)
      VecR(iAdrLG(iRSL,iNode),j) = VecR(1+iCount,nVR+1)
      iCount = iCount+1
    end do
  end do
end do

if (CHO_ADRVEC /= 1) then ! only WA files!!
  call Cho_Quit('CHO_ADRVEC error in '//SecNam,102)
else ! write to disk and update InfVec_G(*,3,iSym)
  iVec1 = myNumCho(iSym)+1
  lTot = nRS_g*nVR
  if (lTot > 0) then
    iOpt = 1
    iAdr = InfVec_G(iVec1,3,iSym)
    call dDAfile(LuCho_G(iSym),iOpt,VecR,lTot,iAdr)
  end if
  do iVec=1,nVR
    jVec = iVec1+iVec-1
    if (jVec < MaxVec) InfVec_G(jVec+1,3,iSym) = InfVec_G(jVec,3,iSym)+nRS_g
  end do
  LastV = myNumCho(iSym)+nVR
  if (LastV > MaxVec) call Cho_Quit('Max. number of vectors exceeded in '//SecNam,104)
end if
myNumCho(iSym) = myNumCho(iSym)+nVR

! deallocations

call mma_deallocate(Map)
call mma_deallocate(iAdrLG)
call mma_deallocate(nRSL)
call mma_deallocate(VecR)
call mma_deallocate(iVecR)
#else

#include "macros.fh"
unused_var(Vec(1))
unused_var(Jin)
unused_var(Jfi)
unused_var(iSym)
unused_var(iRed)
unused_var(iPass)
call Cho_Quit(SecNam//' should never be called in serial installation',103)

#endif

end subroutine Cho_VecTransp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Cntrct_mck(First,
     &                  Coef1,n1,m1,Coef2,n2,m2,
     &                  Coef3,n3,m3,Coef4,n4,m4,
     &                  g1In,nGr,Array,nArr,
     &                  xpre,G1Out,ngr1,nt,
     &                  IndZet,nZeta,lZeta,IndEta,nEta,lEta)
************************************************************************
*                                                                      *
* Object: to transform the integrals from primitives to contracted     *
*         basis functions. The subroutine will do both complete and    *
*         incomplete transformations.                                  *
*                                                                      *
* Author:      Roland Lindh, Dept. of Theoretical Chemistry, University*
*              of Lund, SWEDEN.                                        *
*                                                                      *
* Modified by: Anders Bernhardsson for direct implementation of the    *
*              calculation of first order derivatives needed for       *
*              response calculation.                                   *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
c#include "print.fh"
#include "lCache.fh"
      Real*8 Coef1(n1,m1),Coef2(n2,m2),Coef3(n3,m3),Coef4(n4,m4),
     &       g1In(nT,nGr),
     &       Array(nArr),
     &       g1Out(nGr1),xpre(nt)
      Logical First
      Integer IndZet(nZeta), IndEta(nEta)
*
c     iRout = 18
c     iPrint = nPrint(iRout)
*
c     If (iPrint.ge.99)
c    &   Call RecPrt(' In Cntrct: ',' ',G1In,nt,nGr)
c     If (iPrint.ge.59 .and. .not.First)
c    &   Call RecPrt(' In Cntrct: Partial (a0|c0)',' ',
c    &               G1Out,nGr,m1*m2*m3*m4)

*-----Cache size is 32 k word (real*8)
*
      Do iabcdg=1,ngr
         Do it=1,nt
           G1In(it,iabcdg)=G1In(it,iabcdg)*xpre(it)
         End Do
      End Do
*
*-----Reduce for contraction matrix
      nCache = (3*lCache)/4 - n1*m1 - n2*m2
      lsize =  n1*n2 + n2*m1
      nVec = lEta*nGr
      IncVec = Min(Max(1,nCache/lsize),nVec)
      ipA3 = 1
      ipA2 = ipA3 + nVec*m1*m2
      ip=ipA2 + n2*IncVec*m1
      If (ip.gt.nArr)       Call Abend
*
      Call CntHlf_mck(Coef1,m1,n1,Coef2,m2,n2,nZeta,lZeta,nVec,
     &                .True.,IncVec,G1In,Array(ipA2),Array(ipA3),IndZet)
*
      nCache = (3*lCache)/4 - n3*m3 - n4*m4
      lsize = n3*n4 + n4*m3
      nVec = nGr*m1*m2
      IncVec = Min(Max(1,nCache/lsize),nVec)
      ip=ipA2 + n4*IncVec*m3
      If (ip.gt.nArr)       Call Abend
*
      Call CntHlf_mck(Coef3,m3,n3,Coef4,m4,n4,nEta,lEta,nVec,
     &                First,IncVec,Array(ipA3),Array(ipA2),G1Out,IndEta)
      First = .False.
*
c     If (iPrint.ge.59)
c    &  Call RecPrt(' In Cntrct:  ',' ',
c    &              ACOut,labcdG,m1*m2*m3*m4)
*
*     Call GetMem('Cntrct','Check','Real',iDum,iDum)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine ConMax(A,nPrim,mPrim,B,nCont,C,mCont)
!***********************************************************************
!                                                                      *
! Object: to find the largest element in the contraction matrix  for   *
!         each primitive index.                                        *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             July '91                                                 *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nPrim, mPrim, nCont, mCont
real(kind=wp), intent(out) :: A(nPrim,mPrim)
real(kind=wp), intent(in) :: B(nPrim,nCont), C(mPrim,mCont)
integer(kind=iwp) :: iPrim, jPrim
real(kind=wp) :: Temp
real(kind=wp), external :: DDot_

do iPrim=1,nPrim
  Temp = DDot_(nCont,B(iPrim,1),nPrim,B(iPrim,1),nPrim)
  A(iPrim,:) = Temp
end do

do jPrim=1,mPrim
  Temp = DDot_(mCont,C(jPrim,1),mPrim,C(jPrim,1),mPrim)
  A(:,jPrim) = sqrt(A(:,jPrim)*Temp)
end do

return

end subroutine ConMax

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               1998, Roland Lindh                                     *
*               2003, Valera Veryazov                                  *
************************************************************************
      SubRoutine SOrb(LuOrb,SIntTh,iTerm)
      use SCF_Arrays
      Implicit Real*8 (a-h,o-z)
#include "mxdm.fh"
#include "infscf.fh"
*
      nD = iUHF + 1
      Call SOrb_(LuOrb,SIntTh,iTerm,CMO,TrM,nBB,nD,OneHam,Fock,Ovrlp,
     &           nBT,Eorb,OccNo,nnB)
*
      Return
      End


      SubRoutine SOrb_(LuOrb,SIntTh,iTerm,CMO,TrM,mBB,nD,OneHam,Fock,
     &                 Ovrlp,mBT,EOrb,OccNo,mmB)
************************************************************************
*                                                                      *
*     purpose: Get starting orbitals from:                             *
*              -1) default choice                                      *
*               0) diagonalizaton of the core                          *
*               1) via intermediate calculation of HF AOs              *
*               2) input orbitals                                      *
*               3) input density matrix                                *
*                                                                      *
*     called from: SCF                                                 *
*                                                                      *
*     calls to: Start0, Start2, Start3, SorbChk                        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*                                                                      *
*     Modified by R. Lindh, May  98, Tokyo, Japan                      *
*     UHF - V.Veryazov, 2003                                           *
*                                                                      *
************************************************************************
*
#ifdef _HDF5_
      Use mh5, Only: mh5_close_file
#endif
      use InfSO
      Implicit Real*8 (a-h,o-z)
*
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "file.fh"
      Real*8 CMO(mBB,nD), TrM(mBB,nD), OneHam(mBT), Fock(mBT,nD),
     &       Ovrlp(mBT), EOrb(mmB,nD), OccNo(mmB,nD)
      Character FName*512, KSDFT_save*80
      Logical FstItr
      Logical found
*
*
      CALL DecideonCholesky(DoCholesky)
*-------- Cholesky and NDDO are incompatible
      IF (DoCholesky.and.InVec.eq.1) THEN
         call WarningMessage(1,
     &    ' In SORB: Cholesky and NDDO not implemented !!!; '//
     &    ' NDDO option ignored')
         InVec=-1
      ENDIF
*
*---- Is default clause choosen?
*
      If(InVec.eq.-1) Then
         Call qpg_darray('SCF orbitals',found,ndata)
         If(found .and. nData.eq.nBB) Then
            Call qpg_darray('OrbE',found,ndata)
            If(found) Then
               InVec=8
            End If
         End If
      End If
      If(InVec.eq.-1) Then
         Call qpg_darray('Guessorb',found,ndata)
         If(found .and. nData.eq.nBB) Then
            Call qpg_darray('Guessorb energies',found,ndata)
            If(found) Then
               InVec=9
            End If
         End If
      End If
      If(InVec.eq.-1) Then
         InVec=0
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Reset some parameters depending on which set of starting orbitals
*     we are using. If we have a good starting set of vectors we want
*     the Quasi Newton Raphson to kick in as soon as possible. Further,
*     we would like to use a single numerical grid in the calculation
*     and we would like to a single threshold for the direct SCF.
*
* No no no, not good for difficult cases!!!
*
*     if(iUHF.eq.0) Then
*     If (InVec.ne.0) Then
*        QNRTh =1.0D0
*        DiisTh=1.0D0
*        One_Grid=.True.
*        Two_Thresholds=.False.
*     End If
*     End If
*
*                                                                      *
************************************************************************
*                                                                      *

*
*---- Has the user selected a method?
*
100   Continue
*                                                                      *
************************************************************************
*                                                                      *
      Select Case (InVec)
*                                                                      *
************************************************************************
*                                                                      *
      Case (0)

*-------- Diagonalize core
          Call Start0(CMO,TrM,mBB,nD,OneHam,Ovrlp,mBT,EOrb,mmB)
*                                                                      *
************************************************************************
*                                                                      *
      Case (1)
*
*-------- HF AO orbitals as intermediate step...
*
*------- NDDO, always none-DFT
*
         Call SwiOpt(.False.,OneHam,Ovrlp,mBT,CMO,mBB,nD)
         Call Start0(CMO,TrM,mBB,nD,OneHam,Ovrlp,mBT,EOrb,mmB)
         InVec=0
         Call SOrbCHk(OneHam,Ovrlp,Fock,mBT,nD,CMO,mBB)
         KSDFT_save=KSDFT
         KSDFT='SCF'
         Call WrInp_SCF(SIntTh)
         FstItr=.True.
         Call WfCtl_SCF(iTerm,'NDDO      ',FstItr,SIntTh)
         KSDFT=KSDFT_save
         Call Free_TLists
         If (iTerm.ne.0) Call Quit(iTerm)
         Write(6,*)
         Write(6,'(A)') 'Generation of NDDO vectors completed!'
         Write(6,*)
         Write(6,*) '2nd step: optimizing HF MOs...'
         Write(6,*) '------------------------------'
         Call SwiOpt(.TRUE.,OneHam,Ovrlp,mBT,CMO,mBB,nD)
*------- Reset to to start from the current MO set
         Call Init_SCF()
         InVec=5
!IFG: I presume the arguments after LuOut in these two calls are correct,
!     they were missing!
         If(iUHF.eq.0) Then
            FName='SCFORB'
            Call Start2(FName,LuOut,CMO,mBB,nD,Ovrlp,mBT,
     &               EOrb,OccNo,mmB)
         Else
            FName='UHFORB'
            Call Start2(FName,LuOut,CMO,mBB,nD,Ovrlp,mBT,
     &               EOrb,OccNo,mmB)
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Case (2)
*                                                                      *
*-------- Read INPORB
         One_Grid=.True.
         FName=SCF_FileOrb
         Call Start2(FName,LuOrb,CMO,mBB,nD,Ovrlp,mBT,
     &               EOrb,OccNo,mmB)
*                                                                      *
************************************************************************
*                                                                      *
      Case (3)

*-------- Read COMOLD
         One_Grid=.True.
         Call Start3(CMO,TrM,mBB,nD,OneHam,Ovrlp,mBT)
*                                                                      *
************************************************************************
*                                                                      *
      Case (6)

         write(6,*)
         write(6,*) '     Constrained SCF calculation '
         write(6,*)
         StVec='Constrained orbitals'
         One_Grid=.True.
         FName=SCF_FileOrb
         Call Chk_Vec_UHF(FName,LuOrb,isUHF)
         If (IsUHF.eq.1) Then
            InVec=2
            Go To 100
         EndIf
         Call Start6(FName,LuOrb,CMO,mBB,nD,EOrb,OccNo,mmB)
*                                                                      *
************************************************************************
*                                                                      *
      Case (8)

         StVec='Detected old SCF orbitals'
         One_Grid=.True.
         Call start0y(CMO,mBB,nD,EOrb,mmB)
*                                                                      *
************************************************************************
*                                                                      *
      Case (9)

         StVec='Detected guessorb starting orbitals'
!        One_Grid=.True.
         Call start0x(CMO,mBB,nD,EOrb,mmB)
*                                                                      *
************************************************************************
*                                                                      *
      Case Default

         Write (6,*) 'Illegal inVec value:',InVec
         Call Abend()
*                                                                      *
************************************************************************
*                                                                      *
      End Select
*                                                                      *
************************************************************************
*                                                                      *
      If (Scrmbl) Then
         Do iD = 1, nD
            Call Scram(CMO(1,iD),nSym,nBas,nOrb,ScrFac)
         End Do
      End If

      Call SOrbCHk(OneHam,Ovrlp,Fock,mBT,nD,CMO,mBB)
#ifdef _HDF5_
      If (isHDF5) Call mh5_close_file(fileorb_id)
#endif

      End subroutine SOrb_

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Steven Vancoillie                                *
!***********************************************************************
MODULE ORBINT
  ! Implements a way to store and transform the molecular orbital coefficients
  ! and the 1-and 2-electron MO integrals.
  !
  ! Steven Vancoillie, November 2013, Lund

  USE ISO_FORTRAN_ENV, ONLY: REAL64
  IMPLICIT NONE

CONTAINS

  SUBROUTINE ORBINT_LOAD(CMO,ONEINT,TWOINT)
    IMPLICIT NONE
    REAL(REAL64), INTENT(OUT) :: CMO(:,:), ONEINT(:,:), TWOINT(:,:,:,:)
    INTEGER :: NAO, NMO
    INTEGER :: I, J, P
    INTEGER :: IERR

    NAO=SIZE(CMO,1)
    NMO=SIZE(CMO,2)

    ! MO coefficients
    OPEN(UNIT=8,FILE='MOS.DAT',STATUS='OLD',ACTION='READ',IOSTAT=IERR)
    IF (IERR.NE.0) STOP 'ORBINT_INIT: could not open MO coefficients file'
    DO I=1,NAO
      READ(8,*) CMO(I,:)
    END DO
    CLOSE(8)

    ! element ONEINT(P,Q) stores h_pq
    OPEN(UNIT=8,FILE='ONEINT.DAT',STATUS='OLD',ACTION='READ',IOSTAT=IERR)
    IF (IERR.NE.0) STOP 'ORBINT_INIT: could not open 1-el integral file'
    DO I=1,NMO
      READ(8,*) ONEINT(I,1:I)
      ONEINT(1:I,I)=ONEINT(I,1:I)
    END DO
    CLOSE(8)

    ! element TWOINT(P,Q,I,J) stores g_pqij (in file as ij|pq)
    OPEN(UNIT=8,FILE='TWOINT.DAT',STATUS='OLD',ACTION='READ',IOSTAT=IERR)
    IF (IERR.NE.0) STOP 'ORBINT_INIT: could not open 1-el integral file'
    DO I=1,NMO
      DO J=1,NMO
        DO P=1,NMO
          READ(8,*) TWOINT(P,:,I,J)
        END DO
      END DO
    END DO
    CLOSE(8)
  END SUBROUTINE ORBINT_LOAD

  SUBROUTINE ORBINT_TRANSFORM(CMO,ONEINT,TWOINT,OII,OAA,OSS)
    IMPLICIT NONE
    REAL(REAL64), INTENT(IN) :: OII(:,:), OAA(:,:), OSS(:,:)
    REAL(REAL64), INTENT(INOUT) :: CMO(:,:), ONEINT(:,:), TWOINT(:,:,:,:)
    REAL(REAL64), ALLOCATABLE :: TMP1(:,:), TMP2(:,:)
    INTEGER :: NI, NA, NS, NMO
    INTEGER :: P, Q

    NI=SIZE(OII,1)
    NA=SIZE(OAA,1)
    NS=SIZE(OSS,1)

    NMO=SIZE(CMO,2)

    ! orbitals
    ALLOCATE(TMP1(NMO,NI))
    TMP1(:,:) = MATMUL(CMO(:,1:NI),OII)
    CMO(:,1:NI) = TMP1
    DEALLOCATE(TMP1)
    ALLOCATE(TMP1(NMO,NA))
    TMP1(:,:) = MATMUL(CMO(:,NI+1:NI+NA),OAA)
    CMO(:,NI+1:NI+NA) = TMP1
    DEALLOCATE(TMP1)
    ALLOCATE(TMP1(NMO,NS))
    TMP1(:,:) = MATMUL(CMO(:,NI+NA+1:NI+NA+NS),OSS)
    CMO(:,NI+NA+1:NI+NA+NS) = TMP1
    DEALLOCATE(TMP1)

    ! 1-el integral transforms
    ! inactive
    ALLOCATE(TMP1(NMO,NI),TMP2(NI,NMO))
    TMP1(:,:) = MATMUL(ONEINT(:,1:NI),OII)
    ONEINT(:,1:NI) = TMP1
    TMP2(:,:) = MATMUL(TRANSPOSE(OII),ONEINT(1:NI,:))
    ONEINT(1:NI,:) = TMP2
    DEALLOCATE(TMP1,TMP2)
    ! active
    ALLOCATE(TMP1(NMO,NA),TMP2(NA,NMO))
    TMP1(:,:) = MATMUL(ONEINT(:,NI+1:NI+NA),OAA)
    ONEINT(:,NI+1:NI+NA) = TMP1
    TMP2(:,:) = MATMUL(TRANSPOSE(OAA),ONEINT(NI+1:NI+NA,:))
    ONEINT(NI+1:NI+NA,:) = TMP2
    DEALLOCATE(TMP1,TMP2)
    ! virtual
    ALLOCATE(TMP1(NMO,NS),TMP2(NS,NMO))
    TMP1(:,:) = MATMUL(ONEINT(:,NI+NA+1:NI+NA+NS),OSS)
    ONEINT(:,NI+NA+1:NI+NA+NS) = TMP1
    TMP2(:,:) = MATMUL(TRANSPOSE(OSS),ONEINT(NI+NA+1:NI+NA+NS,:))
    ONEINT(NI+NA+1:NI+NA+NS,:) = TMP2
    DEALLOCATE(TMP1,TMP2)

    ! 2-el integral transforms
    ! inactive
    ALLOCATE(TMP1(NMO,NI),TMP2(NI,NMO))
    DO P=1,NMO
      DO Q=1,NMO
        TMP1(:,:) = MATMUL(TWOINT(:,P,Q,1:NI),OII)
        TWOINT(:,P,Q,1:NI) = TMP1
        TMP2(:,:) = MATMUL(TRANSPOSE(OII),TWOINT(1:NI,P,Q,:))
        TWOINT(1:NI,P,Q,:) = TMP2
      END DO
    END DO
    DO P=1,NMO
      DO Q=1,NMO
        TMP1(:,:) = MATMUL(TWOINT(P,:,1:NI,Q),OII)
        TWOINT(P,:,1:NI,Q) = TMP1
        TMP2(:,:) = MATMUL(TRANSPOSE(OII),TWOINT(P,1:NI,:,Q))
        TWOINT(P,1:NI,:,Q) = TMP2
      END DO
    END DO
    DEALLOCATE(TMP1,TMP2)
    ! active
    ALLOCATE(TMP1(NMO,NA),TMP2(NA,NMO))
    DO P=1,NMO
      DO Q=1,NMO
        TMP1(:,:) = MATMUL(TWOINT(:,P,Q,NI+1:NI+NA),OAA)
        TWOINT(:,P,Q,NI+1:NI+NA) = TMP1
        TMP2(:,:) = MATMUL(TRANSPOSE(OAA),TWOINT(NI+1:NI+NA,P,Q,:))
        TWOINT(NI+1:NI+NA,P,Q,:) = TMP2
      END DO
    END DO
    DO P=1,NMO
      DO Q=1,NMO
        TMP1(:,:) = MATMUL(TWOINT(P,:,NI+1:NI+NA,Q),OAA)
        TWOINT(P,:,NI+1:NI+NA,Q) = TMP1
        TMP2(:,:) = MATMUL(TRANSPOSE(OAA),TWOINT(P,NI+1:NI+NA,:,Q))
        TWOINT(P,NI+1:NI+NA,:,Q) = TMP2
      END DO
    END DO
    DEALLOCATE(TMP1,TMP2)
    ! virtual
    ALLOCATE(TMP1(NMO,NS),TMP2(NS,NMO))
    DO P=1,NMO
      DO Q=1,NMO
        TMP1(:,:) = MATMUL(TWOINT(:,P,Q,NI+NA+1:NI+NA+NS),OSS)
        TWOINT(:,P,Q,NI+NA+1:NI+NA+NS) = TMP1
        TMP2(:,:) = MATMUL(TRANSPOSE(OSS),TWOINT(NI+NA+1:NI+NA+NS,P,Q,:))
        TWOINT(NI+NA+1:NI+NA+NS,P,Q,:) = TMP2
      END DO
    END DO
    DO P=1,NMO
      DO Q=1,NMO
        TMP1(:,:) = MATMUL(TWOINT(P,:,NI+NA+1:NI+NA+NS,Q),OSS)
        TWOINT(P,:,NI+NA+1:NI+NA+NS,Q) = TMP1
        TMP2(:,:) = MATMUL(TRANSPOSE(OSS),TWOINT(P,NI+NA+1:NI+NA+NS,:,Q))
        TWOINT(P,NI+NA+1:NI+NA+NS,:,Q) = TMP2
      END DO
    END DO
    DEALLOCATE(TMP1,TMP2)
  END SUBROUTINE ORBINT_TRANSFORM

END MODULE ORBINT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine puts scalar double data to the runfile.                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: August 2003                                                 *
!                                                                      *
!***********************************************************************
!  Put_dScalar
!
!> @brief
!>   To add/update scalar data in runfile
!> @author Per-Olof Widmark
!>
!> @details
!> This routine is used to put scalar data of type
!> ``Real`` into the runfile. The data items are
!> identified by the \p label. Below is a list of the
!> data items that are recognized. The labels are
!> case insensitive and significant to 16 characters.
!>
!> For development purposes you can use an unsupported
!> label. Whenever such a field is accessed a warning
!> message is printed in the output, to remind the
!> developer to update this routine.
!>
!> @param[in] Label Name of field
!> @param[in] rData Data to put on runfile
!***********************************************************************

subroutine Put_dScalar(Label,rData)

use RunFile_data, only: DS_cache, LabelsDS, lw, nTocDS, num_DS_init, sNotUsed, sRegularField, sSpecialField
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: Label
real(kind=wp), intent(in) :: rData
integer(kind=iwp) :: i, item, iTmp, nData, RecIdx(nTocDS)
real(kind=wp) :: RecVal(nTocDS)
character(len=lw) :: CmpLab1, CmpLab2, RecLab(nTocDS)

!----------------------------------------------------------------------*
! Do setup if this is the first call.                                  *
!----------------------------------------------------------------------*
! start pow mod ---
!write(6,'(3a)') 'Runfile: put_dscalar field "',Label,'"'
! end pow mod ---
call ffRun('dScalar labels',nData,iTmp)
if (nData == 0) then
  RecLab(:) = LabelsDS
  RecVal(:) = Zero
  RecIdx(:) = sNotUsed
  call cWrRun('dScalar labels',RecLab,lw*nTocDS)
  call dWrRun('dScalar values',RecVal,nTocDS)
  call iWrRun('dScalar indices',RecIdx,nTocDS)
else
  call cRdRun('dScalar labels',RecLab,lw*nTocDS)
  call dRdRun('dScalar values',RecVal,nTocDS)
  call iRdRun('dScalar indices',RecIdx,nTocDS)
end if
!----------------------------------------------------------------------*
! Locate item                                                          *
!----------------------------------------------------------------------*
item = -1
CmpLab1 = Label
call UpCase(CmpLab1)
do i=1,nTocDS
  CmpLab2 = RecLab(i)
  call UpCase(CmpLab2)
  if (CmpLab1 == CmpLab2) item = i
end do

! Do we create a new temporary field?

if (item == -1) then
  do i=1,nTocDS
    if (RecLab(i) == ' ') item = i
  end do
  if (item /= -1) then
    RecLab(item) = Label
    RecIdx(item) = sSpecialField
    call cWrRun('dScalar labels',RecLab,lw*nTocDS)
    call iWrRun('dScalar indices',RecIdx,nTocDS)
  end if
end if

! Is this a temporary field?

if (item /= -1) then
  if (Recidx(item) == sSpecialField) then
    write(u6,*) '***'
    write(u6,*) '*** Warning, writing temporary dScalar field'
    write(u6,*) '***   Field: ',Label
    write(u6,*) '***'
#   ifndef _DEVEL_
    call AbEnd()
#   endif
  end if
end if
!----------------------------------------------------------------------*
! Write data to disk.                                                  *
!----------------------------------------------------------------------*
if (item == -1) call SysAbendMsg('put_dScalar','Could not locate',Label)
RecVal(item) = rData
call dWrRun('dScalar values',RecVal,nTocDS)
if (RecIdx(item) == 0) then
  RecIdx(item) = sRegularField
  call iWrRun('dScalar indices',RecIdx,nTocDS)
end if
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
do i=1,num_DS_init
  if (DS_cache(i)%lab == CmpLab1) then
    DS_cache(i)%val = rData
    exit
  end if
end do

return

end subroutine Put_dScalar

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Lobatto_Grid(L_Max)
************************************************************************
*                                                                      *
*     Computes datas useful for the angular quadrature.                *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "nq_info.fh"
#include "real.fh"
#include "WrkSpc.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Observe that we use standard GGL for orders 1 and 2.
      Call GGL_Grid(2)
*                                                                      *
************************************************************************
*                                                                      *
*---- Generate angular grid a la Lobatto
*
      Do L_Eff = 3, L_Max
         nAngularGrids=nAngularGrids+1
*
         Call Do_Lobatto(L_Eff,nPoints,ipR)
*
         Info_Ang(1,nAngularGrids)=L_Eff
         Info_Ang(2,nAngularGrids)=nPoints
         Info_Ang(3,nAngularGrids)=ipR
*
      End Do        ! L_Eff
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine ddres2upd10_cvb(res,c,n)
      implicit real*8 (a-h,o-z)
#include "direct_cvb.fh"
      dimension res(n),c(n)

      if(n_div.eq.0)then
        call fmove_cvb(res,c,n)
      else
        resnrm1=dnrm2_(n_div,res,1)
        resnrm2=dnrm2_(n-n_div,res(n_div+1),1)
        if(resnrm1.gt.resnrm2)then
          call fmove_cvb(res,c,n_div)
          call fzero(c(n_div+1),n-n_div)
        else
          call fzero(c,n_div)
          call fmove_cvb(res(n_div+1),c(n_div+1),n-n_div)
        endif
      endif
      call ddproj_cvb(c,n)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Energy_E1(T1n,Fvo,no,nv,E1)
! this routine does:
! E1 = sum(a,i) T1n(a,i) . Fvo(a,i)
!
! calculate E1 component of energy

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: no, nv
real(kind=wp), intent(in) :: T1n(nv*no), Fvo(nv*no)
real(kind=wp), intent(out) :: e1
integer(kind=iwp) :: dim_1

e1 = Zero
dim_1 = nv*no
call mr0u3wt(dim_1,dim_1,dim_1,1,1,T1n,Fvo,e1)

return

end subroutine Energy_E1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8

      SUBROUTINE Dynamix(iReturn)
      IMPLICIT REAL*8 (a-h,o-z)
#include "Molcas.fh"
#include "warnings.fh"
#include "MD.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "dyn.fh"
#include "constants2.fh"
      INTEGER AixRm
      EXTERNAL IsFreeUnit,AixRm,IsStructure
      PARAMETER   (nTasks=3)
      PARAMETER  (nh=6)
      CHARACTER   StdIn*16, caption*15, ENV*8
      REAL*8      time, mean, kb
      REAL*8      Epot,Ekin,Etot0
      REAL*8      NHC(nh)
      INTEGER     Task(nTasks),natom,IsFreeUnit,irc,Itr,MxItr
      INTEGER     iRlxRoot,nRoots,i
      LOGICAL     Found,lHop
      INTEGER     VelVer, VV_First, VV_Second, Gromacs, VV_Dump
      PARAMETER   (au_time = CONST_AU_TIME_IN_SI_*1.0D15)
      PARAMETER   (kb = CONST_BOLTZMANN_/
     &             (CONV_AU_TO_KJ_*1.0D3))
      PARAMETER  (VelVer=1,VV_First=2,VV_Second=3,Gromacs=4,VV_Dump=5)
      PARAMETER  (iQ1=1,iQ2=2,iX1=3,iX2=4,iVx1=5,iVx2=6)
      CHARACTER, ALLOCATABLE :: atom(:)*2
      REAL*8, ALLOCATABLE ::    Mass(:),vel(:),pcoo(:,:)

*
      iReturn=99
*
C
C     Initialize Dynamix and set default values
C
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix calls Init_Dynamix.'
#endif
      Call Init_Dynamix
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix back from Init_Dynamix.'
#endif
C

C     Read the input
C
#ifdef _HDF5_
      call cre_dyn
#endif
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix calls Readin_Dynamix.'
#endif
      CALL Readin_Dynamix(Task,nTasks,mTasks)
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix back from Readin_Dynamix.'
#endif
C
C     Check if this is an initial run of Dynamix
C
      CALL Qpg_dScalar('MD_Time',Found)
C
#ifdef _HDF5_
      if (.not.found .and. lH5Restart) then
         call restart_dynamix(file_h5res)
         found = .true.
      endif
#endif

C     Generate or read velocities if this is an initial run
C
      IF (.NOT.Found) THEN
C     Check if the RESTART keyword was used.
         IF (RESTART.EQ.0.0D0) THEN
            time=0.000D0
         ELSE
            time=RESTART
            WRITE(6,'(5X,A,T55,F9.2,A)') 'MD restart time = ',
     &                                    RESTART, ' a.u.'
         END IF

         CALL Put_dScalar('MD_Time',time)
         CALL Get_nAtoms_Full(natom)

         CALL mma_allocate(atom,natom)
         CALL mma_allocate(Mass,natom)
         CALL mma_allocate(vel,natom*3)

         CALL Get_Name_Full(atom)
         CALL GetMassDx(Mass,natom)

C Initialize Thermostat Variables

         IF (THERMO.eq.2) THEN
            Freq = 1.D0/(2.2D1/au_time)
            Q1 = 3.D0*dble(natom)*TEMP*Kb/(Freq*Freq)
            Q2 = TEMP*Kb/(Freq*Freq)

            NHC(iQ1) = Q1
            NHC(iQ2) = Q2
            NHC(iX1) = 0.D0
            NHC(iX2) = 0.D0
            NHC(iVx1) = 0.D0
            NHC(iVx2) = 0.D0

            CALL Put_NHC(NHC,nh)
#ifdef _HDF5_
            call mh5_put_dset(dyn_nh,NHC)
#endif


         END IF

C Check if nuclear coordinates to project out from the dynamics
         IF ((POUT.eq.0) .AND. (PIN.eq.natom*3)) THEN
            WRITE(6,'(5X,A,T55)') 'Dynamics in full dimensionality.'
         ELSE
            WRITE(6,'(5X,A,T55)') 'Dynamics in reduced dimensionality.'
            IF (POUT .NE. 0) THEN
              CALL mma_allocate(pcoo,POUT,natom*3)
              CALL DxRdOut(pcoo,POUT,natom)
C Save on RUNFILE
              CALL Put_dArray('Proj_Coord',pcoo,POUT*natom*3)
            ELSEIF (PIN .NE. natom*3) THEN
              CALL mma_allocate(pcoo,PIN,natom*3)
              CALL DxRdIn(pcoo,PIN,natom)
C Save on RUNFILE
              CALL Put_dArray('Keep_Coord',pcoo,PIN*natom*3)
            ENDIF
         ENDIF


         IF (VELO.eq.1) THEN
            CALL DxRdVel(vel,natom)
            WRITE(6,'(5X,A,T55)')
     &      'The initial velocities (bohr/au) are read in.'
         ELSEIF (VELO.eq.2) THEN
            CALL DxRdVel(vel,natom)
            DO i=1, natom
               DO j=1, 3
                  vel(3*(i-1)+j)=vel(3*(i-1)+j)/SQRT(Mass(i))
               END DO
            END DO
            WRITE(6,'(5X,A,T55)')
     &     'The initial mass weighted velocities (bohr/au) are read in.'

C Maxwell-Boltzmann distribution
         ELSEIF (VELO.eq.3) THEN
            nFlag=0
            val=0.d0
            buffer=0.D0

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8

            WRITE(6,'(5X,A,T55)')
     & 'The initial velocities (bohr/au) are taken '
            WRITE(6,'(5X,A,f9.2,A)')
     & 'from a Boltzmann distribution at', TEMP, ' kelvin'

            CALL getSeed(iseed)

            DO i=1, natom
               arg=TEMP*Kb/Mass(i)
               Sigma=SQRT(arg)
               mean = 0.D0
               DO j=1, 3
                  CALL RandomGauss(mean,Sigma,iseed,nflag,buffer,Val)
                  vel(3*(i-1)+j)= Val

C                  WRITE(6,'(5X,A,T55,D16.8)') 'Vel = ', Val

               END DO
            END DO
         ELSE
            DO i=1, 3*natom
               vel(i)=0.000000000000D0
            END DO
            WRITE(6,'(5X,A,T55)')
     &      'The initial velocities are set to zero.'
         END IF
         caption='Velocities'
         CALL DxPtTableWithoutMassForce(caption,time,natom,
     &        atom,vel)

C Check if reduced dimensionality
         IF (POUT .NE. 0) THEN
           CALL project_out_vel(vel,natom)
         ELSEIF (PIN .NE. natom*3) THEN
           CALL project_in_vel(vel,natom)
           caption='Vel (red dim)'
           CALL DxPtTableWithoutMassForce(caption,time,natom,
     &        atom,vel)
         ENDIF

C     Calculate the kinetic energy
         IF (VELO.gt.0) THEN
            Ekin=0.000000000000D0
            DO i=1, natom
               DO j=1, 3
                  Ekin=Ekin+(5.0D-01)*Mass(i)*(vel(3*(i-1)+j)**2)
               END DO
            END DO
         ELSE
            Ekin=0.000000000000D0
         END IF
         WRITE(6,'(5X,A,6X,D19.12,1X,A)') 'Kinetic energy',Ekin,'a.u.'
C     Save the velocities on RUNFILE
         CALL Put_Velocity(vel,3*natom)
C     Save the total energy on RUNFILE if the total energy should be conserved.
         CALL Get_dScalar('Last Energy',Epot)
         Etot0 = Epot + Ekin
         CALL Put_dScalar('MD_Etot0',Etot0)
         CALL Put_dScalar('MD_Etot',Etot0)
#ifdef _HDF5_
         call mh5_put_dset(dyn_vel,vel)
         call mh5_put_dset(dyn_etot0,Etot0)
         call mh5_put_dset(dyn_etot,Etot0)
#endif
         CALL DxEnergies(time,Epot,Ekin,Etot0)
         WRITE(6,'(5X,A,8X,D19.12,1X,A)') 'Total Energy',Etot0,'a.u.'
         CALL mma_deallocate(atom)
         CALL mma_deallocate(Mass)
         CALL mma_deallocate(vel)
         IF ((POUT.NE.0) .OR. (PIN.NE.natom*3)) THEN
           CALL mma_deallocate(pcoo)
         ENDIF
      END IF

C
C     Execute the tasks
C
      DO iTask = 1, mTasks

         IF (Task(iTask).eq.VelVer) THEN

            IF (Found) THEN

#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix calls VelVer_Second.'
#endif
               CALL VelVer_Second(irc)
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix back from VelVer_Second.'
#endif
C
C     Check for Hopping?
C
               lHop=.FALSE.
               CALL qpg_iScalar('MaxHops',lHop)
               IF (lHop) THEN
C
C     Read the roots
C
                  CALL Get_iScalar('Number of roots',nRoots)
                  CALL Get_iScalar('Relax CASSCF root',iRlxRoot)
C
C     Run RASSI
C
                  LuInput=11
                  LuInput=IsFreeUnit(LuInput)
                  Call StdIn_Name(StdIn)
                  Call Molcas_Open(LuInput,StdIn)
                  Write (LuInput,'(A)')
     &                  '>export DYN_OLD_TRAP=$MOLCAS_TRAP'
                  Write (LuInput,'(A)') '>export MOLCAS_TRAP=ON'
                  Write (LuInput,'(A)') ' &RASSI &End'
                  Write (LuInput,'(A)') ' NR OF JOBIPHS'
                  Write (LuInput,*) ' 1 ',nRoots
                  Write (LuInput,*) (i,i=1,nRoots)
*                  Write (LuInput,'(X,I1,1X,I1)') inxtState,iRlxRoot
                  Write (LuInput,'(A)') ' HOP'
                  Write (LuInput,'(A)') 'End of Input'
                  Write (LuInput,'(A)') ' &Dynamix &End'
                  Write (LuInput,'(A)') ' VV_First'
                  Write (LuInput,'(A)') ' DT'
                  Write (LuInput,*) DT
                  Write (LuInput,'(A)') 'THERMO'
                  Write (LuInput,*) THERMO
                  Write (LuInput,'(A)') 'VELO'
                  Write (LuInput,*) VELO
                  Write (LuInput,'(A)') 'OUT'
                  Write (LuInput,*) POUT
                  Write (LuInput,'(A)') 'IN'
                  Write (LuInput,*) PIN
                  Write (LuInput,'(A)') 'End of Input'
                  Write (LuInput,'(A)')
     &                  '>export MOLCAS_TRAP=$DYN_OLD_TRAP'
                  Close(LuInput)
                  Call Finish(_RC_INVOKED_OTHER_MODULE_)
               ELSE
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix calls VelVer_First.'
#endif
                  CALL VelVer_First(irc)
               END IF

#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix back from VelVer_First.'
#endif
            ELSE
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix calls VelVer_First.'
#endif

               CALL VelVer_First(irc)
#ifdef _DEBUGPRINT_
      WRITE(6,*)' Dynamix back from VelVer_First.'
#endif
            END IF
         ELSE IF (Task(iTask).eq.VV_First) THEN
             CALL VelVer_First(irc)

         ELSE IF (Task(iTask).eq.VV_Second) THEN
             CALL VelVer_Second(irc)

         ELSE IF (Task(iTask).eq.Gromacs) THEN
            CALL GROM(irc)

         ELSE IF (Task(iTask).eq.VV_Dump) THEN
            CALL VelVer_Dump(irc)

         ELSE
            WRITE(6,*) 'Illegal task'
            CALL Abend()
         END IF
      END DO

C
C-----Remove the GRADS file
C
      Call f_Inquire('GRADS',Found)
      If (Found) Then
         If (AixRm('GRADS').ne.0) Call Abend()
      End If

#ifdef _HDF5_
      call mh5_close_file(dyn_fileid)
#endif

C
C-----If running in a DoWhile loop, we turn a successful
C     return code into "continue loop", except on the
C     last iteration
C
      If ((IsStructure().eq.1).and.(irc.eq.0)) Then
         MxItr=0
         Call GetEnvf('MOLCAS_MAXITER', ENV)
         If (ENV.ne.' ') Then
            Read (ENV,*) MxItr
         End If
         Itr=1
         Call GetEnvf('MOLCAS_ITER', ENV)
         If (ENV.ne.' ') Then
            Read (ENV,*) Itr
         End If
         If (Itr.lt.MxItr) Then
            iReturn=_RC_CONTINUE_LOOP_
         Else
            iReturn=irc
         End If
      Else
         iReturn=irc
      End If
      RETURN
*
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_XCV_WrVec(irc,Vec,l_Vec,NVT,l_NVT,
     &                         myRankSP,l_myRankSP,SP)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: write partial Cholesky vectors to disk.
C              (Parallel two-step algorithm)
C
#if defined (_DEBUGPRINT_)
      use ChoSwp, only: nnBstRSh
#endif
      Implicit None
      Integer irc
      Integer l_Vec, l_NVT, l_myRankSP
      Real*8  Vec(l_Vec)
      Integer NVT(l_NVT)
      Integer myRankSP(l_myRankSP)
      Integer SP
#include "cho_para_info.fh"

#if defined (_DEBUGPRINT_)
#include "cholesky.fh"

      Integer iSym, iSP, n

      If (l_NVT.lt.nSym .or. l_myRankSP.lt.nnShl) Then
         irc=-1
         Return
      End If
      If (SP.lt.1 .or. SP.gt.nnShl) Then
         irc=-2
         Return
      End If
      iSP=myRankSP(SP)
      n=nnBstRSh(1,iSP,2)*NVT(1)
      Do iSym=2,nSym
         n=n+nnBstRSh(iSym,iSP,2)*NVT(iSym)
      End Do
      If (l_Vec.lt.n) Then
         irc=-3
         Return
      End If

      If (.not.Cho_Real_Par) Then
         n=0
         Do iSym=1,nSym
            If (NVT(iSym).ne.NumCho(iSym)) Then
               n=n+1
            End If
         End Do
         If (n.ne.0) Then
            irc=-4
            Return
         End If
         If (SP.ne.myRankSP(SP)) Then
            irc=-5
            Return
         End If
      End If
#endif

      If (Cho_Real_Par) Then
         ! Parallel: block write to temp files
         Call Cho_XCV_WrVec_Par(irc,Vec,NVT,myRankSP,SP)
      Else
         ! Serial: write directly to vector files
         Call Cho_XCV_WrVec_Ser(irc,Vec,SP)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C SERIAL VERSION
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SubRoutine Cho_XCV_WrVec_Ser(irc,Vec,iSP)
C
C     Simply write the partial vectors to disk at the appropriate
C     addresses on the vector files.
C
      use ChoSwp, only: nnBstRSh, iiBstRSh
      Implicit None
      Integer irc
      Real*8  Vec(*)
      Integer iSP
#include "cholesky.fh"

      Integer iOpt
      Parameter (iOpt=1)

      Integer iSym, kV
      Integer lTot, iAdr, iAdr0, j

      irc=0

      kV=1
      Do iSym=1,nSym
         lTot=nnBstRSh(iSym,iSP,2)
         If (lTot .gt. 0) Then
            iAdr0=iiBstRSh(iSym,iSP,2)
            Do J=1,NumCho(iSym)
               iAdr=iAdr0+nnBstR(iSym,2)*(J-1)
               Call DDAFile(LuCho(iSym),iOpt,Vec(kV),lTot,iAdr)
               kV=kV+lTot
            End Do
         End If
      End Do

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C PARALLEL VERSION
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SubRoutine Cho_XCV_WrVec_Par(irc,Vec,NVT,myRankSP,SP)
C
C     Write the vectors in blocks.
C
      use ChoSwp, only: nnBstRSh
      Implicit None
      Integer irc
      Real*8  Vec(*)
      Integer NVT(*)
      Integer myRankSP(*)
      Integer SP
#include "cholesky.fh"

      Integer, Parameter:: iOpt=1

      Integer iSym, kV, j
      Integer lTot, iAdr
      Integer iSP

      irc=0

      iSP=myRankSP(SP)
      kV=1
      Do iSym=1,nSym
         lTot=nnBstRSh(iSym,iSP,2)*NVT(iSym)
         If (lTot .gt. 0) Then
            iAdr=0
            Do j=1,SP-1
               iAdr=iAdr+nnBstRSh(iSym,myRankSP(j),2)*NVT(iSym)
            End Do
            Call DDAFile(LuTmp(iSym),iOpt,Vec(kV),lTot,iAdr)
            kV=kV+lTot
         End If
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Yoshio Nishimoto                                 *
!***********************************************************************
!
! Save and restore many quantities that are used in CASPT2 gradient
! calculations using disk at present (hopefully)
! Save with Mode = 1, and restore with Mode = 2
! state-independent quantities

subroutine SavGradParams2(Mode,UEFF,U0,H0,nState)
! It seems that values that are unchanged during the gradient loop
! have to be separately saved and restored
! If this subroutine is updated, the shift at the beginning of
! the SavGradParams subroutine should also be updated

use caspt2_global, only: LUGRAD
use caspt2_module, only: Energy, ERFSelf, nBTri, RFPert
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Mode, nState
real(kind=wp), intent(inout) :: UEFF(nState,nState), U0(nState,nstate), H0(nSTate,nState)
integer(kind=iwp) :: ID, IORW
real(kind=wp), allocatable :: lTemp(:)

!! Decide what to do
if (Mode == 1) then
  IORW = 1 !! Write
else if (Mode == 2) then
  IORW = 2 !! Read
end if

ID = 0
call DDAFILE(LUGRAD,IORW,ENERGY,NSTATE,ID)
call DDAFILE(LUGRAD,IORW,UEFF,NSTATE**2,ID)
call DDAFILE(LUGRAD,IORW,U0,NSTATE**2,ID)
call DDAFILE(LUGRAD,IORW,H0,NSTATE**2,ID)

if (RFpert) then
  call mma_allocate(lTemp,NBTRI+1,Label='lTemp')
  if (Mode == 1) then
    call Get_dScalar('RF Self Energy',lTemp(1+NBTRI))
    call Get_dArray('Reaction field',lTemp,NBTRI)
    call DDAFILE(LUGRAD,IORW,lTemp,NBTRI+1,ID)
  else if (Mode == 2) then
    call DDAFILE(LUGRAD,IORW,lTemp,NBTRI+1,ID)
    call Put_dScalar('RF Self Energy',lTemp(1+NBTRI))
    ERFSelf = lTemp(1+NBTRI)
    call Put_dArray('Reaction field',lTemp,NBTRI)
  end if
  call mma_deallocate(lTemp)
end if

end subroutine SavGradParams2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Sync_Data(Pren,Prem,nBtch,mBtch,kBtch)
      use definitions, only: iwp, wp
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: nProcs, Is_Real_Par
#endif
      Implicit None
      real(kind=wp), Intent(inout):: Pren,Prem
      integer(kind=iwp), intent(in):: nBtch,mBtch,kBtch
*
#ifdef _MOLCAS_MPP_

      Real(kind=wp) PrenV(2)
      Integer(kind=iwp) nBtchV(3)
*
      If (.Not. Is_Real_Par()) Return
      If (nProcs.eq.1) Return
      PrenV(1)=Pren
      PrenV(2)=Prem
      Call GADGOP(PrenV,2,'+')
      Pren=PrenV(1)
      Prem=PrenV(2)
*
      nBtchV(1)=nBtch
      nBtchV(2)=mBtch
      nBtchV(3)=kBtch
      Call GAIGOP(nBtchV,3,'+')
      nBtchV(1)=nBtch
      nBtchV(2)=mBtch
      nBtchV(3)=kBtch
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(Pren)
         Call Unused_real(Prem)
         Call Unused_integer(nBtch)
         Call Unused_integer(mBtch)
         Call Unused_integer(kBtch)
      End If
#endif
*
      End Subroutine Sync_Data

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2007, Markus Reiher                               *
************************************************************************
      subroutine s_create (dkhscfflg,sused,snumber,scounter,stimes,
     *                     wstimes,sorder,smult,s,scrleng,scrchar,
     *                     stimestot,wopscounter,no_s)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic.
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 15.01.2007 (M. Reiher, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg,no_s
      integer sused,snumber,scounter(maxsnumber),stimes(maxsnumber),
     *        wstimes(maxuops,maxsnumber),sorder(maxsnumber,3),
     *        smult(maxsnumber),scrleng(maxsnumber),sinfo(maxsnumber,2),
     *        stimestot,wopscounter
c
      character*(4) s(maxsnumber)
      character*(9) scrchar(maxsnumber)
c
C     integer j,k,dkh_char2int,idum1,idum2
      integer j,k,dkh_char2int
      character*(3) dkh_int2char
c
*** use flag, which determines the memory available
      if (no_s) then
        sused=0
      else
        sused=216
      end if
c
      do 10 j=1,sused
        scounter(j)=1
        stimes(j)=0
        do 15 k=1,wopscounter
          wstimes(k,j)=0
  15    continue
        do 18 k=1,3
          sorder(j,k)=0
  18    continue
        sinfo(j,1)=0
        sinfo(j,2)=0
        smult(j)=0
        s(j)='    '
        scrchar(j)='         '
  10  continue
      snumber=0
      stimestot=0
c
      do 20 j=1,sused
        s(j)(1:4)='S'//dkh_int2char(j)
  20  continue
      scrchar(1)  ='W01O01   '
      scrchar(2)  ='O01W01   '
      scrchar(3)  ='W01W01   '
      scrchar(4)  ='W01E01W01'
      scrchar(5)  ='W01CO0   '
      scrchar(6)  ='CO0W01   '
      scrchar(7)  ='W01CE0W01'
      scrchar(8)  ='W02O01   '
      scrchar(9)  ='O01W02   '
      scrchar(10) ='W02W01   '
      scrchar(11) ='W01W02   '
      scrchar(12) ='W02E01W01'
      scrchar(13) ='W01E01W02'
      scrchar(14) ='W02W02   '
      scrchar(15) ='W02E01W02'
      scrchar(16) ='W02CO0   '
      scrchar(17) ='CO0W02   '
      scrchar(18) ='W02CE0W01'
      scrchar(19) ='W01CE0W02'
      scrchar(20) ='W02CE0W02'
      scrchar(21) ='W03O01   '
      scrchar(22) ='O01W03   '
      scrchar(23) ='W03W01   '
      scrchar(24) ='W01W03   '
      scrchar(25) ='W03E01W01'
      scrchar(26) ='W01E01W03'
      scrchar(27) ='W03W02   '
      scrchar(28) ='W02W03   '
      scrchar(29) ='W03E01W02'
      scrchar(30) ='W02E01W03'
      scrchar(31) ='W03W03   '
      scrchar(32) ='W03E01W03'
      scrchar(33) ='W03CO0   '
      scrchar(34) ='CO0W03   '
      scrchar(35) ='W03CE0W01'
      scrchar(36) ='W01CE0W03'
      scrchar(37) ='W03CE0W02'
      scrchar(38) ='W02CE0W03'
      scrchar(39) ='W03CE0W03'
      scrchar(40) ='W04O01   '
      scrchar(41) ='O01W04   '
      scrchar(42) ='W04W01   '
      scrchar(43) ='W01W04   '
      scrchar(44) ='W04E01W01'
      scrchar(45) ='W01E01W04'
      scrchar(46) ='W04W02   '
      scrchar(47) ='W02W04   '
      scrchar(48) ='W04E01W02'
      scrchar(49) ='W02E01W04'
      scrchar(50) ='W04W03   '
      scrchar(51) ='W03W04   '
      scrchar(52) ='W04E01W03'
      scrchar(53) ='W03E01W04'
      scrchar(54) ='W04W04   '
      scrchar(55) ='W04E01W04'
      scrchar(56) ='W04CO0   '
      scrchar(57) ='CO0W04   '
      scrchar(58) ='W04CE0W01'
      scrchar(59) ='W01CE0W04'
      scrchar(60) ='W04CE0W02'
      scrchar(61) ='W02CE0W04'
      scrchar(62) ='W04CE0W03'
      scrchar(63) ='W03CE0W04'
      scrchar(64) ='W04CE0W04'
      scrchar(65) ='W05O01   '
      scrchar(66) ='O01W05   '
      scrchar(67) ='W05W01   '
      scrchar(68) ='W01W05   '
      scrchar(69) ='W05E01W01'
      scrchar(70) ='W01E01W05'
      scrchar(71) ='W05W02   '
      scrchar(72) ='W02W05   '
      scrchar(73) ='W05E01W02'
      scrchar(74) ='W02E01W05'
      scrchar(75) ='W05W03   '
      scrchar(76) ='W03W05   '
      scrchar(77) ='W05E01W03'
      scrchar(78) ='W03E01W05'
      scrchar(79) ='W05W04   '
      scrchar(80) ='W04W05   '
      scrchar(81) ='W05E01W04'
      scrchar(82) ='W04E01W05'
      scrchar(83) ='W05W05   '
      scrchar(84) ='W05E01W05'
      scrchar(85) ='W05CO0   '
      scrchar(86) ='CO0W05   '
      scrchar(87) ='W05CE0W01'
      scrchar(88) ='W01CE0W05'
      scrchar(89) ='W05CE0W02'
      scrchar(90) ='W02CE0W05'
      scrchar(91) ='W05CE0W03'
      scrchar(92) ='W03CE0W05'
      scrchar(93) ='W05CE0W04'
      scrchar(94) ='W04CE0W05'
      scrchar(95) ='W05CE0W05'
      scrchar(96) ='W06O01   '
      scrchar(97) ='O01W06   '
      scrchar(98) ='W06W01   '
      scrchar(99) ='W01W06   '
      scrchar(100)='W06E01W01'
      scrchar(101)='W01E01W06'
      scrchar(102)='W06W02   '
      scrchar(103)='W02W06   '
      scrchar(104)='W06E01W02'
      scrchar(105)='W02E01W06'
      scrchar(106)='W06W03   '
      scrchar(107)='W03W06   '
      scrchar(108)='W06E01W03'
      scrchar(109)='W03E01W06'
      scrchar(110)='W06W04   '
      scrchar(111)='W04W06   '
      scrchar(112)='W06E01W04'
      scrchar(113)='W04E01W06'
      scrchar(114)='W06W05   '
      scrchar(115)='W05W06   '
      scrchar(116)='W06E01W05'
      scrchar(117)='W05E01W06'
      scrchar(118)='W06W06   '
      scrchar(119)='W06E01W06'
      scrchar(120)='W06CO0   '
      scrchar(121)='CO0W06   '
      scrchar(122)='W06CE0W01'
      scrchar(123)='W01CE0W06'
      scrchar(124)='W06CE0W02'
      scrchar(125)='W02CE0W06'
      scrchar(126)='W06CE0W03'
      scrchar(127)='W03CE0W06'
      scrchar(128)='W06CE0W04'
      scrchar(129)='W04CE0W06'
      scrchar(130)='W06CE0W05'
      scrchar(131)='W05CE0W06'
      scrchar(132)='W06CE0W06'
      scrchar(133)='W07O01   '
      scrchar(134)='O01W07   '
      scrchar(135)='W07W01   '
      scrchar(136)='W01W07   '
      scrchar(137)='W07E01W01'
      scrchar(138)='W01E01W07'
      scrchar(139)='W07W02   '
      scrchar(140)='W02W07   '
      scrchar(141)='W07E01W02'
      scrchar(142)='W02E01W07'
      scrchar(143)='W07W03   '
      scrchar(144)='W03W07   '
      scrchar(145)='W07E01W03'
      scrchar(146)='W03E01W07'
      scrchar(147)='W07W04   '
      scrchar(148)='W04W07   '
      scrchar(149)='W07E01W04'
      scrchar(150)='W04E01W07'
      scrchar(151)='W07W05   '
      scrchar(152)='W05W07   '
      scrchar(153)='W07E01W05'
      scrchar(154)='W05E01W07'
      scrchar(155)='W07W06   '
      scrchar(156)='W06W07   '
      scrchar(157)='W07E01W06'
      scrchar(158)='W06E01W07'
      scrchar(159)='W07W07   '
      scrchar(160)='W07E01W07'
      scrchar(161)='W07CO0   '
      scrchar(162)='CO0W07   '
      scrchar(163)='W07CE0W01'
      scrchar(164)='W01CE0W07'
      scrchar(165)='W07CE0W02'
      scrchar(166)='W02CE0W07'
      scrchar(167)='W07CE0W03'
      scrchar(168)='W03CE0W07'
      scrchar(169)='W08O01   '
      scrchar(170)='O01W08   '
      scrchar(171)='W08W01   '
      scrchar(172)='W01W08   '
      scrchar(173)='W08E01W01'
      scrchar(174)='W01E01W08'
      scrchar(175)='W08W02   '
      scrchar(176)='W02W08   '
      scrchar(177)='W08E01W02'
      scrchar(178)='W02E01W08'
      scrchar(179)='W08W03   '
      scrchar(180)='W03W08   '
      scrchar(181)='W08E01W03'
      scrchar(182)='W03E01W08'
      scrchar(183)='W08W04   '
      scrchar(184)='W04W08   '
      scrchar(185)='W08E01W04'
      scrchar(186)='W04E01W08'
      scrchar(187)='W08W05   '
      scrchar(188)='W05W08   '
      scrchar(189)='W08E01W05'
      scrchar(190)='W05E01W08'
      scrchar(191)='W08W06   '
      scrchar(192)='W06W08   '
      scrchar(193)='W08E01W06'
      scrchar(194)='W06E01W08'
      scrchar(195)='W08W07   '
      scrchar(196)='W07W08   '
      scrchar(197)='W08E01W07'
      scrchar(198)='W07E01W08'
      scrchar(199)='W08W08   '
      scrchar(200)='W08E01W08'
      scrchar(201)='W08CO0   '
      scrchar(202)='CO0W08   '
      scrchar(203)='W08CE0W01'
      scrchar(204)='W01CE0W08'
      scrchar(205)='W08CE0W02'
      scrchar(206)='W02CE0W08'
      scrchar(207)='W09O01   '
      scrchar(208)='O01W09   '
      scrchar(209)='W09W01   '
      scrchar(210)='W01W09   '
      scrchar(211)='W09CO0   '
      scrchar(212)='CO0W09   '
      scrchar(213)='W09CE0W01'
      scrchar(214)='W01CE0W09'
      scrchar(215)='W10CO0   '
      scrchar(216)='CO0W10   '
c
      do 25 j=1,sused
        if (scrchar(j)(7:9).eq.'   ') then
          scrleng(j)=6
        else
          scrleng(j)=9
        endif
  25  continue
c
      do 30 j=1,2
        do 31 k=1,sused
          if (scrleng(k).eq.6) then
            if (index(scrchar(k)(3*j-2:3*j),'C').eq.0) then
              sinfo(k,j)=dkh_char2int(2,scrchar(k)(3*j-1:3*j))
            else
              sinfo(k,j)=0
            endif
          endif
          if (scrleng(k).eq.9) then
            sinfo(k,j)=dkh_char2int(2,scrchar(k)(6*j-4:6*j-3))
          endif
  31    continue
  30  continue
c
      if (dkhscfflg) then
        do 130 j=1,sused
          sorder(j,3)=sinfo(j,1)+sinfo(j,2)
          if (scrleng(j).eq.9) sorder(j,3)=sorder(j,3)+1
          if (scrleng(j).eq.6 .and. index(scrchar(j)(1:6),
     *                            'CO0').gt.0) sorder(j,3)=sorder(j,3)+1
 130    continue
      else
        do 131 j=1,sused
          sorder(j,1)=sinfo(j,1)+sinfo(j,2)
          if (index(scrchar(j)(1:scrleng(j)),'E01').gt.0)
     *                                         sorder(j,1)=sorder(j,1)+1
          if (index(scrchar(j)(1:scrleng(j)),'C').gt.0) sorder(j,2)=1
          sorder(j,3)=sorder(j,1)+sorder(j,2)
 131    continue
      endif
c
      if (dbgflg.ge.1) then
        write (dbgunit,1001) sused
1001    format (/2X,'Creation and initialization of scratch arrays "s"',
     *          ' successful.',5X,'(sused=',I3,')')
      endif
c
      if (dbgflg.ge.3) then
         write (dbgunit,1156)sused
 1156    format (/2X,'The following ',I3,' Sxxx-matrices have been set',
     *           ' up:',//2X,'Sxxx',2X,'scrchar',2X,'sinfo',1X,
     *           'sinfo',2X,'sorder',1X,'sorder',1X,'sorder',2X,
     *           'smult',2X,'scrleng',/18X,'(,1)',2X,'(,2)',3X,'(V)',
     *           4X,'(X)',3X,'(tot)',/)
         do 6298 k=1,sused
           write (dbgunit,8877) s(k),scrchar(k),sinfo(k,1),sinfo(k,2),
     *                          sorder(k,1),sorder(k,2),sorder(k,3),
     *                          smult(k),scrleng(k)
8877       format (2X,A4,2X,A9,2X,I2,4X,I2,4X,I2,5X,I2,4X,I3,5X,I3,5X,
     *             I3)
6298     continue
      endif
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Anders Bernhardsson                              *
************************************************************************
#define NOCODE
#ifdef NOCODE
      Subroutine RHS_PT2(rkappa,iprci)
      Implicit Real*8(a-h,o-z)
      Real*8 rKappa(*)
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(rkappa)
         Call Unused_integer(iprci)
      End If
#else
      Subroutine RHS_PT2(rkappa,iprci)
      use Arrays, only: CMO, Int1
      use Str_Info, only: DTOC, CNSM
      use ipPage, only: W
      Implicit Real*8(a-h,o-z)
      Real*8 rKappa(*)
*
*    Calculate and reads in from CASPT2 the RHS needed
*    for the calculation of the Lagrangian multipliers
*    for CASPT2.
*
*    From the same Fock matrix the effective Fock matrix
*    needed for the renormalization term is  calculated.

*    Here is the structure, it is not debugged and one
*    needs to check the detail, but all "input" is there.
*
#include "Pointers.fh"

#include "Input.fh"
#include "stdalloc.fh"
#include "Files_mclr.fh"
#ifndef _DEBUGED_
#include "detdim.fh"
#endif
      Real*8, Allocatable:: DCAS(:), TempK(:), TempCI(:), TempCI2(:),
     &                      T2(:), FAO1(:), FAO2(:), FMO1(:), FMO2(:),
     &                      DP(:), DP2(:), DCAS2(:), K1(:), K2(:)
      Real*8 rDum(1)
      Half=0.5d0
*
*     Read in a and b part of effective gradient from CASPT2
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(TempK,ndens2,Label='TempK')
      If (imethod.eq.2)Then
         i=0
         Call mma_allocate(TempCI,nconf1,Label='TempCI')
         Call mma_allocate(TempCI2,nconf1,Label='TempCI2')
         Call dDaFile(LuPT2,2,TempK,ndens2,i)
#ifdef _DEBUGED_
*
*    CASPT2 mode
*
         Call dDaFile(LuPT2,2,TempCI,nconf1,i)
#else
*
* lucia mode
*
         n=nint(xispsm(State_SYM,1))
         Call dDaFile(LuPT2,2,TempCI,n,i)
#endif
*
*---- Transform from split GUGA to symmetric group
*
#ifdef _DEBUGED_
*
*    CASPT2 mode (split graph)
*
         Call Gugactl_MCLR(TempCI(1),1)
#else
*
* lucia mode (Symmetric group)
*
      iprdia=0
      Call INCSFSD(STATE_SYM,STATE_SYM,.false.)
      CALL CSDTVC_MCLR(TempCI2,TempCI,2,
     &                 TOC,CNSM(1)%ICTS,
     &                 State_SYM,1,IPRDIA)
#endif
      Call mma_deallocate(TempCI2)
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
*     MP2
*
        Call mma_allocate(TempCI,1,Label='TempCI')
        i=0
        Call dDaFile(LuPT2,2,TempK,ndens2,i)
*       Call ThreeP(Kappa)
*       MP2
*                                                                      *
************************************************************************
*                                                                      *
      End if
* ----
*
      Call mma_allocate(T2,ndens2,Label='T2')
      Call mma_allocate(FAO1,ndens2,Label='FAO1')
      Call mma_allocate(FAO2,ndens2,Label='FAO2')
      Call mma_allocate(FMO1,ndens2,Label='FMO1')
      Call mma_allocate(FMO2,ndens2,Label='FMO2')
      Call mma_allocate(DP,ndens2,Label='DP')
      Call mma_allocate(DP2,ndens2,Label='DP2')
      Call mma_allocate(DCAS2,ndens2,Label='DCAS2')
      Call mma_allocate(K1,ndens2,Label='K1')
      Call mma_allocate(K2,ndens2,Label='K2')
*
*---  Read in necessary densities.
*
      Call Qpg_dArray('D1ao',Found,nDens)
      If (Found .and. nDens/=0) Then
         Call mma_allocate(DCAS,nDens,Label='DCAS*)
      Else
         Write (6,*) 'RHS_PT2: Density not found'
         Call Abend()
      End If
      Call Get_D1ao(DCAS,nDens)
      irc=-1
      iopt=0
      Call RdRlx(irc,iopt,'D1PT22',DP)
      If (irc.ne.0) Goto 100
      irc=-1
      iopt=0
      Call RdRlx(irc,iopt,'OVLP',rovlp)
      If (irc.ne.0) Goto 100
*
*--- Squared density
*
      Call UnFold_MCLR(DP,DP2)
*
      Call UnFold_MCLR(DCAS,DCAS2)
*
*======================================================================*
*
*
*---  Make Fock matrixes
*
      ExFac=1.0D0
*
*  1) P(PT2)
*
      nFlt=0
      nBMX=0
      Do iSym = 1, nSym
         nFlt=nFlt+nBas(iSym)*(nBas(iSym)+1)/2
         nBMX=Max(nBMX,nBas(iSym))
      End Do
*
      FAO1(:)=0.0D0
      Call FockTwo_Drv(nSym,nBas,nBas,nSkip,DP,DP2),FAO1,nFlt,
     &                 ExFac,nBMX)
      Call AO2MO(FAO1,FMO1)
*
*  2) P(CAS)
*
      FAO2(:)=0.0D0
      Call FockTwo_Drv(nSym,nBas,nBas,nSkip,DAS,DCAS2,FAO2,nFlt,
     &                 ExFac,nBMX)
      Call AO2MO(FAO2,FMO2)
*
*-- Add one particle hamiltonian here ???
*
  ??? Call DaXpY_(ndens2,-rovlp,Int1,1,FMO1,1)
*
*======================================================================*
*
*---- CI Vector
*
*     <i|Sigma> = <i|F|0> - <0|F|0><i|0>+CI_a+CI_b
*
      Call CISigma(0,State_sym,State_sym,FMO1,nDens2,rdum,1,rdum,1,ipci,
     &             iprci,.False.)
      irc=ipin(iprci)
      irc=ipin(ipci)
      rE=ddot_(nconf1,W(iprci)%Vec,1,W(ipci)%Vec,1)
      Call Daxpy_(nconf1,1.0d0,TempCI,1,W(iprci)%Vec,1)
      Call Daxpy_(nconf1,-rE,W(ipCI)%Vec,1,W(iprci)%Vec,1)
*======================================================================*
*
*     D^CAS*P(PT2+CAS)
*
      Call DFock(DCAS2,FMO1,K1)
*
*     D^(PT2+CAS)*P(CAS)
*
      Call DFock(DP,FMO2,K2)
*
*======================================================================*
*
*     Add all orbital terms together
*
      Call Daxpy_(nDens2,1.0d0,K2,1,K1,1)
      call daxpy_(ndens2,1.0d0,TempK,1,K1,1)
*
*======================================================================*
*
*  OKIDOKI Two things are needed, first of all the symmetric fockmatrix for the
*  connection term:
*
*======================================================================*
*
*---  Calculate efficent Fock matrix in AO basis (contravariant,folded)
*     and write to disk. Woba
*
      Do iS=1,nSym
        If (nbas(is).ne.0)
     *  Call DGEadd(K1(ipMat(is,is)),nBas(is),'N',
     *              K1(ipMat(is,is)),nBas(is),'T',
     *              K2(ipMat(is,is)),nBas(is),
     *              nBas(is),nBas(is))
      End Do
      Do iS=1,nSym
        If (nBas(is).ne.0) Then
           Call DGEMM_('N','N',
     &                 nBas(iS),nBas(iS),nBas(iS),
     &                 1.0d0,CMO(ipCM(iS)),nBas(iS),
     &                 K2(ipMat(is,is)),nBas(iS),
     &                 0.0d0,T2,nBas(iS))
           Call DGEMM_('N','T',
     &                 nBas(is),nBas(iS),nBAs(iS),
     &                 1.0d0,T2,nBas(iS),
     &                 CMO(ipCM(iS)),nBas(iS),
     &                 0.0d0,FAO1(ipMat(iS,iS)),nBas(is))
        End If
      End Do
      Call Fold2(nsym,nbas,FAO1,FAO2)
      Call Put_Fock_Occ(FAO2,nDens2)
*
*     And then I want the unsymmetric part to the MCLR
*
*
*---  Keep gradient terms woba!!!!!!!
*
      Do iS=1,nSym
        If (nbas(is).ne.0)
     *  Call DGESUB(K1(ipMat(is,is)),nBas(is),'N',
     *              K1(ipMat(is,is)),nBas(is),'T',
     *              rKappa(ipMat(is,is)),nBas(is),
     *              nBas(is),nBas(is))
      End Do

*
*    OK Thats all folks!!
*
      Call mma_deallocate(T2)
      Call mma_deallocate(FAO1)
      Call mma_deallocate(FAO2)
      Call mma_deallocate(FMO1)
      Call mma_deallocate(FMO2)
      Call mma_deallocate(DP)
      Call mma_deallocate(DP2)
      Call mma_deallocate(DCAS)
      Call mma_deallocate(DCAS2)
      Call mma_deallocate(K1)
      Call mma_deallocate(K2)
      Call mma_deallocate(TempK)
      Call mma_deallocate(TempCI)
*
*............
      return
 100  Call SysHalt('rhs_pt2')
      end
      Subroutine DFock(DAO,FockMO,Fock)
      use Arrays, only: CMO
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
#include "stdalloc.fh"
      Real*8 DAO(*),FockMO(*),Fock(*)
      Real*8, Allocatable:: Temp1(:), Temp2(:)

      Call mma_allocate(Temp1,ndens2,Label='Temp1')
      Call mma_allocate(Temp2,ndens2,Label='Temp2')
      Do iS=1,nSym
        If (nBas(is).ne.0) Then
           Call DGEMM_('T','N',
     &                 nBas(iS),nBas(iS),nBas(iS),
     &                 1.0d0,CMO(ipCM(iS)),nBas(iS),
     &                 DAO(ipCM(is)),nBas(iS),
     &                 0.0d0,Temp2,nBas(iS))
           Call DGEMM_('N','N',
     &                 nBas(is),nBas(iS),nBAs(iS),
     &                 1.0d0,Temp2,nBas(iS),
     &                 CMO(ipCM(iS)),nBas(iS),
     &                 0.0d0,Temp1,nBas(is))
           Call DGEMM_('N','N',
     &                 nBas(is),nBas(iS),nBAs(iS),
     &                 1.0d0,Temp1,nBas(iS),
     &                 FockMO(ipCM(iS)),nBas(iS),
     &                 0.0d0,Fock(ipCM(is)),nBas(is))
        End If
      End Do
      Call mma_deallocate(Temp2)
      Call mma_deallocate(Temp1)
      Return
      End
      Subroutine AO2MO(FAO ,FMO)
      use Arrays, only: CMO
      Implicit Real*8 (a-h,o-z)
      Real*8 FAO(*),FMO(*)

#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: Temp1(:), Temp2(:)

      Call mma_allocate(Temp1,ndens2,Label='Temp1')
      Call mma_allocate(Temp2,ndens2,Label='Temp2')
      ip=1
      Do iS=1,nSym
        If (nBas(is).ne.0) Then
           Call Square(FAO(ip),Temp1,1,nBas(is),nBas(is))
           Call DGEMM_('T','N',
     &                 nBas(iS),nBas(iS),nBas(iS),
     &                 1.0d0,CMO(ipCM(iS)),nBas(iS),
     &                       Temp1,nBas(iS),
     &                 0.0d0,Temp2,nBas(iS))
           Call DGEMM_('N','N',
     &                 nBas(is),nBas(iS),nBAs(iS),
     &                 1.0d0,Temp2,nBas(iS),
     &                       CMO(ipCM(iS)),nBas(iS),
     &                 0.0d0,FMO(ipMat(iS,iS)),nBas(is))
           ip=ip+nBas(is)*(nBas(iS)+1)/2
        End If
      End Do
      Call mma_deallocate(Temp2)
      Call mma_deallocate(Temp1)
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SPIND2(ISYOP,MS2OP,IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB4,
     &                 PSI1,PSI4,SPD2)
      use stdalloc, only: mma_allocate, mma_deallocate
      use rassi_global_arrays, only: FSBANN1, FSBANN2, FSBANN3, FSBANN4
      use Symmetry_Info, only: MUL
      IMPLICIT NONE
      INTEGER ISYOP,MS2OP
      INTEGER IORBTAB(*)
      INTEGER ISSTAB(*)
      INTEGER IFSBTAB1(*),IFSBTAB4(*)
      REAL*8 PSI1(*),PSI4(*),SPD2(*)

      REAL*8 COEFF,OVLP
      INTEGER NASORB
      INTEGER IMODE,ISORB
      INTEGER ND1,ND2,ND3,ND4
      INTEGER JSORB
      INTEGER KOINFO
      INTEGER ISMLAB,ISPLAB,JSMLAB,JSPLAB
      INTEGER NASGEM,JISORB
      INTEGER LSORB,KSORB
      INTEGER KLSORB,KLSYM,KLMS2,LSMLAB,LSPLAB,KSMLAB
      INTEGER KSPLAB,IJKL
      Real*8, EXTERNAL:: OVERLAP_RASSI
      Real*8, Allocatable:: ANN1(:), ANN2(:), ANN3(:), ANN4(:)

C Nr of active spin-orbitals
      NASORB= IORBTAB(4)
C Nr of active spin-orbital pairs:
      NASGEM=(NASORB*(NASORB-1))/2
      KOINFO=19

      DO ISORB=2,NASORB
C Symmetry properties:
       ISMLAB=IORBTAB(KOINFO+1+8*(ISORB-1))
       ISPLAB=IORBTAB(KOINFO+3+8*(ISORB-1))
C Annihilate a single spin orbital, ISORB:
       IMODE=-1
       Call FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB1,1)
       ND1=FSBANN1(5)
       COEFF=1.0D0
       CALL mma_allocate(ANN1,ND1,Label='ANN1')
       ANN1(:)=0.0D0
       CALL PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,FSBANN1,
     &                   IFSBTAB1,COEFF,ANN1,PSI1)
CTEST       WRITE(*,*)' The ANN1 wave function, with ISORB=',ISORB
CTEST       PRTHR=0.01D0
CTEST       CALL PRWVF(IORBTAB,ISSTAB,FSBANN1,PRTHR,ANN1)
       DO JSORB=1,ISORB-1
C Symmetry properties:
        JSMLAB=IORBTAB(KOINFO+1+8*(JSORB-1))
        JSPLAB=IORBTAB(KOINFO+3+8*(JSORB-1))
C Pair index:
        JISORB=((ISORB-1)*(ISORB-2))/2+JSORB
C Annihilate once more, the spin orbital JSORB:
        IMODE=-1
        Call FSBOP(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN1,2)
        ND2=FSBANN2(5)
        CALL mma_allocate(ANN2,ND2,Label='ANN2')
        ANN2(:)=0.0D0
        CALL PRIMSGM(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN2,
     &               FSBANN1,COEFF,ANN2,ANN1)
CTEST       WRITE(*,*)' The ANN2 wave function, with JSORB=',JSORB
CTEST       PRTHR=0.01D0
CTEST       CALL PRWVF(IORBTAB,ISSTAB,FSBANN2,PRTHR,ANN2)

        KLSYM=MUL(MUL(ISMLAB,JSMLAB),ISYOP)
        KLMS2=MS2OP+ISPLAB+JSPLAB
        DO LSORB=2,NASORB
C Symmetry properties:
         LSMLAB=IORBTAB(KOINFO+1+8*(LSORB-1))
         LSPLAB=IORBTAB(KOINFO+3+8*(LSORB-1))
C Annihilate a single spin orbital, LSORB:
         IMODE=-1
         Call FSBOP(IMODE,LSORB,IORBTAB,ISSTAB,IFSBTAB4,4)
         ND4=FSBANN4(5)
         COEFF=1.0D0
         CALL mma_allocate(ANN4,ND4,Label='ANN4')
         ANN4(:)=0.0D0
         CALL PRIMSGM(IMODE,LSORB,IORBTAB,ISSTAB,FSBANN4,
     &                   IFSBTAB4,COEFF,ANN4,PSI4)
CTEST       WRITE(*,*)' The ANN4 wave function, with LSORB=',LSORB
CTEST       PRTHR=0.01D0
CTEST       CALL PRWVF(IORBTAB,ISSTAB,FSBANN4,PRTHR,ANN4)
         DO KSORB=1,LSORB-1
          OVLP=0.0D0
C Symmetry properties:
          KSMLAB=IORBTAB(KOINFO+1+8*(KSORB-1))
          KSPLAB=IORBTAB(KOINFO+3+8*(KSORB-1))
          IF(MUL(KSMLAB,LSMLAB).NE.KLSYM) cycle
          IF(KSPLAB+LSPLAB.NE.KLMS2)      cycle
C Pair index:
          KLSORB=((LSORB-1)*(LSORB-2))/2+KSORB
C Annihilate once more, the spin orbital KSORB:
          IMODE=-1
          Call FSBOP(IMODE,KSORB,IORBTAB,ISSTAB,FSBANN4,3)
          ND3=FSBANN3(5)
          CALL mma_allocate(ANN3,ND3,Label='ANN3')
          ANN3(:)=0.0D0
          CALL PRIMSGM(IMODE,KSORB,IORBTAB,ISSTAB,FSBANN3,
     &                FSBANN4,COEFF,ANN3,ANN4)
CTEST       WRITE(*,*)' The ANN3 wave function, with KSORB=',KSORB
CTEST       PRTHR=0.01D0
CTEST       CALL PRWVF(IORBTAB,ISSTAB,FSBANN3,PRTHR,ANN3)
C Compute the spin transition density matrix element:
          OVLP=OVERLAP_RASSI(FSBANN2,
     &                  FSBANN3,ANN2,ANN3)
CTEST       write(*,*)' Their overlap:',OVLP
            IJKL=JISORB+NASGEM*(KLSORB-1)
            SPD2(IJKL)=SPD2(IJKL)+OVLP
            Call mma_deallocate(ANN3)
            Call mma_deallocate(FSBANN3)
         END DO
         Call mma_deallocate(ANN4)
         Call mma_deallocate(FSBANN4)
        END DO
        Call mma_deallocate(ANN2)
        Call mma_deallocate(FSBANN2)
       END DO
       Call mma_deallocate(ANN1)
       CALL mma_deallocate(FSBANN1)
      END DO

      END SUBROUTINE SPIND2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
c  **************************************
c  ** General-purpose utility routines **
c  **************************************
c  ********************************************
c  ** Simple vector/matrix-handling routines **
c  ********************************************
      subroutine mxfold_cvb(a,avec,n)
      implicit real*8 (a-h,o-z)
      dimension a(n,n),avec(n*(n-1))
      iprm=0
      do 100 i=1,n
      do 101 j=1,n
      if(j.ne.i)then
        iprm=iprm+1
        avec(iprm)=a(j,i)
      endif
101   continue
100   continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine daxpint(from,to,fact,ndim1,ndim2,ndim3,ndim4)
      implicit real*8 (a-h,o-z)
cbs   subroutine similar to daxpy with interchange of two indices
cbs   change from physicists notation to chemists notaion
cbs   to(i,j,k,l)=to(i,j,k,l)+fact*from(i,k,j,l)
      dimension from(ndim1,ndim2,ndim3,ndim4),
     *to(ndim1,ndim3,ndim2,ndim4)
      if (fact.eq.0d0) return
      do irun4=1,ndim4
      do irun3=1,ndim3
      do irun2=1,ndim2
      do irun1=1,ndim1
      to(irun1,irun3,irun2,irun4)=to(irun1,irun3,irun2,irun4)+
     *fact*from(irun1,irun2,irun3,irun4)
      enddo
      enddo
      enddo
      enddo
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PtAdd(H0,Ovlp,RR,nSize,Temp,nTemp)
*
************************************************************************
*                                                                      *
*     Objective: Construct the modified Hamiltonian                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 ( A-H,O-Z )
*

#include "input.fh"
*
      Real*8 H0(nSize), Ovlp(nSize), RR(nSize), Temp(nTemp)
      Character*8 Label
      Logical Debug
      Data Debug /.False./
      Dimension idum(1)
*
*----------------------------------------------------------------------*
*                                                                      *
*     Start procedure                                                  *
*     Read nuclear attraction and kinteic energy integrals.            *
*     Combine them to generate the one-electron Hamiltonian.           *
*     Finally read the overlap matrix.                                 *
*                                                                      *
*----------------------------------------------------------------------*
*
*
      One=1.0D0
      iOpt1=1
      iOpt2=2
      iComp=1
      iSyLbl=nSym
      If(LCumulate) Then
         Label='OneHam  '
         Write(6,*)
         Write(6,*)'Adding perturbation cumulatively'
         Write(6,*)
      Else
         Label='OneHam 0'
      EndIf
      iRc=-1
      Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
      nInts=idum(1)
      If ( iRc.ne.0 ) Then
         Write (6,*) 'PtAdd: Error reading ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend()
      End If
      If (nInts+4.ne.nSize) Then
         Write (6,*) 'PtAdd: nInts+4.ne.nSize',nInts+4,nSize
         Call Abend
      End If
      iRc=-1
      Call RdOne(iRc,iOpt2,Label,iComp,H0,iSyLbl)
      If ( Debug ) Then
         Call PrDiOp('One Hamiltonian intgrl',nSym,nBas,H0)
         Write (6,*) 'PotNuc=',H0(nInts+4)
      End If
*
*----------------------------------------------------------------------*
*     Loop over all possible commands and branch to "special purpose"  *
*     subroutines to add perturbations.                                *
*----------------------------------------------------------------------*
*
      Call PtRela(H0,Ovlp,RR,nSize,Temp,nTemp)
      Call PtDipo(H0,Ovlp,RR,nSize,Temp,nTemp)
      Call PtQuad(H0,Ovlp,RR,nSize,Temp,nTemp)
      Call PtOkt0(H0,Ovlp,RR,nSize,Temp,nTemp)
      Call PtEfld(H0,Ovlp,RR,nSize,Temp,nTemp)
      Call PtEfgr(H0,Ovlp,RR,nSize,Temp,nTemp)
      Call PtGLbl(H0,Ovlp,RR,nSize,Temp,nTemp)
*
*----------------------------------------------------------------------*
*     If the user have requested a local (a la LoProp) perturbation    *
*     then make some modifications to the perturbation matrix.         *
*----------------------------------------------------------------------*
*                                                                      *
      If(ComStk(4,0,0,0))Call SelectLoc(H0,nSize)
*
*----------------------------------------------------------------------*
*     Terminate procedure                                              *
*----------------------------------------------------------------------*
*
      If ( Debug ) Then
         Call PrDiOp('Core Hamiltonian',nSym,nBas,H0)
         Write (6,*) 'PotNuc=',H0(nInts+4)
      End If
      iRc=-1
      iOpt=0
      iComp=1
      Label='OneHam  '
      Call WrOne(iRc,iOpt,Label,iComp,H0,iSyLbl)
      If ( iRc.ne.0 ) Then
         Write (6,*) 'PtAdd: Error writing to ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend()
      End If
*     Call Put_PotNuc(H0(nInts+4))
      Call Put_dScalar('PotNuc',H0(nInts+4))
*
*----------------------------------------------------------------------*
*     Normal Exit                                                      *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetChckData(LunAux)
! this routine does:
! Get Chck Data from ChkDat file

use chcc_global, only: L0k, L1k, L2k, OEo, OEv, Q0, Q1, Q21, Q22, Q3, Q4, T1c, T2c
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LunAux

!open(unit=LunAux,file='ChKDat',form='unformatted')
call Molcas_BinaryOpen_Vanilla(LunAux,'ChKDat')
read(LunAux) T1c,T2c,OEo,OEv,Q0,Q1,Q21,Q22,Q3,Q4,L0k,L1k,L2k
close(LunAux)

return

end subroutine GetChckData

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine One_Int(Kernel,Array,nArray,A,iAng,
     &                   iComp,nOrdOp,
     &                   Scr1,nScr1,Scr2,nScr2,naa,SAR,nSAR,
     &                   iShll_a,nPrim_a,Exp_a,nCntrc_a,Cff_a,
     &                   iCmp_a,
     &                   iShll_r,nPrim_r,Exp_r,nCntrc_r,Cff_r,
     &                   iCmp_r)
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
      use Basis_Info
      use Her_RW
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
#include "stdalloc.fh"
      External Kernel
      Real*8 Array(nArray)
      Real*8, Intent(Out):: SAR(nSAR)
      Real*8, Intent(In):: A(3)
      Real*8, Intent(In):: Exp_a(nPrim_a), Exp_r(nPrim_r)
      Real*8, Intent(In):: Cff_a(nPrim_a,nCntrc_a)
      Real*8, Intent(In):: Cff_r(nPrim_r,nCntrc_r)
      Real*8 Scr1(nScr1), Scr2(nScr2)
      Real*8, Allocatable:: ZAR(:), ZIAR(:), KAR(:), PAR(:,:)
      Real*8, Allocatable:: pSAR(:)
*
      mArr = nArray/(nPrim_a*nPrim_r)
      Call mma_allocate(ZAR,nPrim_a*nPrim_r,Label='ZAR')
      Call mma_allocate(ZIAR,nPrim_a*nPrim_r,Label='ZIAR')
      Call mma_allocate(KAR,nPrim_a*nPrim_r,Label='KAR')
      Call mma_allocate(PAR,nPrim_a*nPrim_r,3,Label='PAR')
*
      mSAR = nPrim_a*nPrim_r * naa
      Call mma_allocate(pSAR,mSAR,Label='pSAR')
*
      Call ZXia(ZAR,ZIAR,nPrim_a,nPrim_r,Exp_a,Exp_r)
      Call SetUp1(Exp_a,nPrim_a,Exp_r,nPrim_r,A,A,KAR,PAR,ZIAR)
*
      nHer = (2*iAng+2+nOrdOp)/2
      Call Kernel(Exp_a,nPrim_a,Exp_r,nPrim_r,
     &            ZAR,ZIAR,KAR,PAR,
     &            pSAR,nPrim_a*nPrim_r,iComp,
     &            iAng,iAng,A,A,nHer,Array,mArr,A,nOrdOp)
*
      Call mma_deallocate(ZAR)
      Call mma_deallocate(ZIAR)
      Call mma_deallocate(KAR)
      Call mma_deallocate(PAR)
*
      Call DGEMM_('T','N',
     &            nPrim_r*naa,nCntrc_a,nPrim_a,
     &            1.0d0,pSAR,nPrim_a,
     &                  Cff_a,nPrim_a,
     &            0.0d0,Scr1,nPrim_r*naa)
      Call DGEMM_('T','N',
     &            naa*nCntrc_a,nCntrc_r,nPrim_r,
     &            1.0d0,Scr1,nPrim_r,
     &                  Cff_r,nPrim_r,
     &            0.0d0,Scr2,naa*nCntrc_a)
#ifdef _DEBUGPRINT_
      Call RecPrt('S_AR in Cartesian',' ',Scr2,
     &            naa,nCntrc_a*nCntrc_r)
#endif
*
*     Transform to spherical Gaussian if needed!
*
      If (Shells(iShll_a)%Transf.or.Shells(iShll_r)%Transf) Then
*
         Call CarSph(Scr2,naa,nCntrc_a*nCntrc_r,
     &               pSAR,nScr2,
     &               RSph(ipSph(iAng)),iAng,
     &               Shells(iShll_a)%Transf,
     &               Shells(iShll_a)%Prjct,
     &               RSph(ipSph(iAng)),iAng,
     &               Shells(iShll_r)%Transf,
     &               Shells(iShll_r)%Prjct,
     &               SAR,iCmp_a*iCmp_r)
      Else
         Call DGeTmO(Scr2,naa,naa,nCntrc_a*nCntrc_r,
     &               SAR,nCntrc_a*nCntrc_r)
      End If
      Call mma_deallocate(pSAR)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('S_AR in Sphericals',' ',SAR,
     &                  iCmp_a*iCmp_r,nCntrc_a*nCntrc_r)
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PtEfGr(H0,Ovlp,RR,nSize,Temp,nTemp)
*
************************************************************************
*                                                                      *
*     Objective: Construct the modified Hamiltonian,                   *
*                i.e., add electric field gradient pert. operator      *
*                Note: This operator is already in traceless form      *
*                                                                      *
************************************************************************
*
      Implicit Real*8 ( A-H,O-Z )
*

#include "input.fh"
*
      Real*8 H0(nSize), Ovlp(nSize), RR(nSize), Temp(nTemp)
      Character*8 Label
      Character*20 PriLbl
      Logical Debug,Exec,Orig,NoCntr
      Data    Debug/.false./
      Dimension idum(1)
*
*----------------------------------------------------------------------*
*                                                                      *
*     Start procedure                                                  *
*     Check if the command has been specified on input                 *
*                                                                      *
*----------------------------------------------------------------------*
*
*
      Exec=.false.
      Exec=Exec.or.ComStk(2,4,1,1)
      Exec=Exec.or.ComStk(2,4,1,2)
      Exec=Exec.or.ComStk(2,4,1,3)
      Exec=Exec.or.ComStk(2,4,1,4)
      Exec=Exec.or.ComStk(2,4,1,5)
      Exec=Exec.or.ComStk(2,4,1,6)
      If ( .not.Exec ) then
         Return
      End If
*
*----------------------------------------------------------------------*
*     Check if a origin has been specified                             *
*     The unspecified components of the origin are set to 0.0 !        *
*----------------------------------------------------------------------*
*
      Orig=.false.
      Orig=Orig.or.ComStk(2,4,2,1)
      Orig=Orig.or.ComStk(2,4,2,2)
      Orig=Orig.or.ComStk(2,4,2,3)
      Orig=Orig.or.ComStk(2,4,2,4)
      If ( .not.Orig ) Then
         Write (6,*) 'PtEfGr: Input error, no matching center found.'
         Call Abend()
      End If
*
      XOrig=0.0D0
      YOrig=0.0D0
      ZOrig=0.0D0
      If ( ComStk(2,4,2,1) ) XOrig=ComVal(2,4,2,1)
      If ( ComStk(2,4,2,2) ) YOrig=ComVal(2,4,2,2)
      If ( ComStk(2,4,2,3) ) ZOrig=ComVal(2,4,2,3)
      If ( ComStk(2,4,2,4) ) Then
        iAtm=INT(ComVal(2,4,2,4))
        If ( Debug )
     *    Write(6,'(6X,A,I2)')'Origin of perturbation is centered '//
     *                        'at atom ',iAtm
        If ( iAtm.lt.0 .or. iAtm.gt.nAtoms ) Then
           Write (6,*) 'PrEfGr: iAtm.lt.0 .or. iAtm.gt.nAtoms'
           Write (6,*) 'iAtm,nAtoms=',iAtm,nAtoms
           Write (6,*) 'You specified a invalid atom number as the '
     &               //'origin of the perturbation operator.'
           Call Abend()
        End If
        XOrig=Coor(1,iAtm)
        YOrig=Coor(2,iAtm)
        ZOrig=Coor(3,iAtm)
      End If
      If ( Debug )
     *  Write(6,'(6X,A,3F12.6)')'Origin of perturbation operator =',
     *  XOrig,YOrig,ZOrig
*
*----------------------------------------------------------------------*
*     Loop over the max possible number of centers and                 *
*     search for coincidence in the origin definitions                 *
*----------------------------------------------------------------------*
*
      MxCntr=9999
      NoCntr=.true.
      Do iCntr=1,MxCntr
        If ( NoCntr ) Then
          Label='EF2     '
          Write(Label(4:8),'(I5)')iCntr
          iRc=-1
          iOpt1=1
          iOpt2=2
          iSyLbl=0
          Do iComp=1,6
            Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
            If ( iRc.eq.0 ) Then
              nInts=idum(1)
              Call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
              X=Temp(nInts+1)
              Y=Temp(nInts+2)
              Z=Temp(nInts+3)
              If ( X.eq.XOrig .and. Y.eq.YOrig .and. Z.eq.ZOrig )
     *          NoCntr=.false.
            End If
          End Do
        End If
      End Do
      If ( NoCntr ) Then
         Write (6,*) 'PrEfGr: No center found!'
         Write (6,*) 'XOrig,YOrig,ZOrig=',XOrig,YOrig,ZOrig
         Call Abend()
      End If
      If ( Debug )
     *  Write(6,'(6X,A,A)')'Label of perturbation operator =', Label
*
*----------------------------------------------------------------------*
*     Read all components and reduce the diagonal ones                 *
*----------------------------------------------------------------------*
*
      Do iComp=1,6
        If ( ComStk(2,4,1,iComp) ) Then
          iRc=-1
          iOpt1=1
          iOpt2=2
          iSyLbl=0
          Alpha=-ComVal(2,4,1,iComp)
*
          If (iComp.ne.6) Then
             Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
             nInts=idum(1)
             If ( iRc.ne.0 ) Goto 991
             Call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
             If ( iRc.ne.0 ) Goto 991
             Call CmpInt(Temp,nInts,nBas,nSym,iSyLbl)
             call daxpy_(nInts,Alpha,Temp,1,H0,1)
             H0(nInts+4)=H0(nInts+4)-Alpha*Temp(nInts+4)
          Else
*             Note that we have not explicit storage of the ZZ term!
*             It has to be computed as -XX-YY.
             jComp=1  ! the XX-term
             Call iRdOne(iRc,iOpt1,Label,jComp,idum,iSyLbl)
             nInts=idum(1)
             If ( iRc.ne.0 ) Goto 991
             Call RdOne(iRc,iOpt2,Label,jComp,Temp,iSyLbl)
             If ( iRc.ne.0 ) Goto 991
             Call CmpInt(Temp,nInts,nBas,nSym,iSyLbl)
             call daxpy_(nInts,-Alpha,Temp,1,H0,1)
             H0(nInts+4)=H0(nInts+4)+Alpha*Temp(nInts+4)
*
             jComp=4  ! the YY-term
             Call iRdOne(iRc,iOpt1,Label,jComp,idum,iSyLbl)
             nInts=idum(1)
             If ( iRc.ne.0 ) Goto 991
             Call RdOne(iRc,iOpt2,Label,jComp,Temp,iSyLbl)
             If ( iRc.ne.0 ) Goto 991
             Call CmpInt(Temp,nInts,nBas,nSym,iSyLbl)
             call daxpy_(nInts,-Alpha,Temp,1,H0,1)
             H0(nInts+4)=H0(nInts+4)+Alpha*Temp(nInts+4)
          End If
          If ( Debug ) Then
            Write (6,'(6X,A,F8.6)') 'weight =',ComVal(2,4,1,iComp)
            PriLbl='        ; Comp =    '
            PriLbl(1:8)=Label
            Write(PriLbl(19:20),'(I2)') iComp
            Call PrDiOp(PriLbl,nSym,nBas,Temp)
          End If
        End If
      End Do
*
*----------------------------------------------------------------------*
*     Normal Exit                                                      *
*----------------------------------------------------------------------*
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(Ovlp)
        Call Unused_real_array(RR)
      End If
*
*----------------------------------------------------------------------*
*     Error Exit                                                       *
*----------------------------------------------------------------------*
*
991   Write (6,*) 'PtEfGr: Error reading ONEINT'
      Write (6,'(A,A)') 'Label=',Label
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine SetChoIndx_RI(iiBstRSh,nnBstRSh,IndRed,IndRsh,iRS2F,I_nSym,I_nnShl,I_mmBstRT,iShij,nShij)

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use ChoArr, only: iSP2F, iBasSh, nBasSh, nBstSh
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: I_nSym, I_nnShl, I_mmBstRT, iRS2F(2,I_mmBstRT), nShij, iShij(2,nShij)
integer(kind=iwp), intent(out) :: iiBstRSh(I_nSym,I_nnShl,3), nnBstRSh(I_nSym,I_nnShl,3), IndRed(I_mmBstRT,3), IndRsh(I_mmBstRT)
#include "cholesky.fh"
integer(kind=iwp) :: i, ia, iaa, iab, ib, ibb, iCount, iRS(8), iSh_ij, iShla, iShlab, iShlb, iSym, iSyma, iSymb, jRS, jRS1, jRS2, &
                     nErr
integer(kind=iwp), external :: Cho_iSAOSh

! nnBstRSh(iSym,iSh_ij,1) = #elements in compound sym. iSym of
!                           shell-pair ab in 1st reduced set.
! IndRSh(jRS): shell-pair to which element jRS of first reduced set
!              belongs.
! IndRed(jRS,1): address (without symmetry) in shell-pair of element
!                jRS of first reduced set.
! ------------------------------------------------------------------

nnBstRSh(:,:,1) = 0
iRS(1:nSym) = iiBstR(1:nSym,1)
do iSh_ij=1,nShij
  iShla = iShij(1,iSh_ij)
  iShlb = iShij(2,iSh_ij)
  iShlab = iTri(iShla,iShlb)
  !write(u6,*) 'iSh_ij,iShlab,iShla,iShlb=',iSh_ij,iShlab,iShla,iShlb
  if (iShlab /= iSP2F(iSh_ij)) call SysAbendMsg('SetChoIndx_RI','SP2F setup error',' ')

  if (iShla > iShlb) then

    ! code for shell a > shell b

    do iSymb=1,nSym
      do ibb=1,nBasSh(iSymb,iShlb)
        ib = iBasSh(iSymb,iShlb)+ibb
        do iSyma=1,nSym
          iSym = Mul(iSyma,iSymb)
          do iaa=1,nBasSh(iSyma,iShla)
            ia = iBasSh(iSyma,iShla)+iaa
            iab = nBstSh(iShla)*(ib-1)+ia
            nnBstRSh(iSym,iSh_ij,1) = nnBstRSh(iSym,iSh_ij,1)+1
            iRS(iSym) = iRS(iSym)+1
            IndRSh(iRS(iSym)) = iShlab
            IndRed(iRS(iSym),1) = iab
          end do
        end do
      end do
    end do

  else

    ! code for shell a = shell b follows

    do ia=1,nBstSh(iShla)
      iSyma = Cho_iSAOSh(ia,iShla)
      do ib=1,ia
        iab = iTri(ia,ib)
        iSymb = Cho_iSAOSh(ib,iShlb)
        iSym = Mul(iSyma,iSymb)
        nnBstRSh(iSym,iSh_ij,1) = nnBstRSh(iSym,iSh_ij,1)+1
        iRS(iSym) = iRS(iSym)+1
        IndRSh(iRS(iSym)) = iShlab
        IndRed(iRS(iSym),1) = iab
      end do
    end do

  end if
end do   ! iSh_ij

! Check.
! ------

nErr = 0
do iSym=1,nSym
  iCount = nnBstRSh(iSym,1,1)
  do iSh_ij=2,nnShl
    iCount = iCount+nnBstRSh(iSym,iSh_ij,1)
  end do
  if (iCount /= nnBstR(iSym,1)) then
    nErr = nErr+1
  end if
end do
if (nErr /= 0) then
  call SysAbendMsg('SetChoIndx_RI','Setup error','iCount vs. nnBstR')
end if
do iSym=1,nSym
  if ((iRS(iSym)-iiBstR(iSym,1)) /= nnBstR(iSym,1)) nErr = nErr+1
end do
if (nErr /= 0) then
  call SysAbendMsg('SetChoIndx_RI','Setup error','ShP RS1 count')
end if

! iiBstRSh(iSym,iSh_ij,1) = offset to elements in compound sym. iSym
!                           of shell-pair ab in 1st reduced set.
! ------------------------------------------------------------------

do iSym=1,nSym
  iiBstRSh(iSym,1,1) = 0
  do iSh_ij=2,nnShl
    iiBstRSh(iSym,iSh_ij,1) = iiBstRSh(iSym,iSh_ij-1,1)+nnBstRSh(iSym,iSh_ij-1,1)
  end do
end do

! Check.
! ------

nErr = 0
do iSym=1,nSym
  do iSh_ij=1,nnShl
    jRS1 = iiBstR(iSym,1)+iiBstRSh(iSym,iSh_ij,1)+1
    jRS2 = jRS1+nnBstRSh(iSym,iSh_ij,1)-1
    do jRS=jRS1,jRS2
      if (IndRSh(jRS) /= iSP2F(iSh_ij)) nErr = nErr+1
    end do
  end do
end do
if (nErr /= 0) then
  call SysAbendMsg('SetChoIndx_RI','Setup error','IndRSh')
end if

! Copy index arrays to "locations" 2 and 3.
! Note: IndRed here returns the index in 1st reduced set.
! -------------------------------------------------------

do i=2,3
  do jRS=1,nnBstRT(1)
    IndRed(jRS,i) = jRS
  end do
  iiBstRSh(:,:,i) = iiBstRSh(:,:,1)
  nnBstRSh(:,:,i) = nnBstRSh(:,:,1)
end do

call Cho_RStoF(iRS2F,2,nnBstRT(1),1)

return

end subroutine SetChoIndx_RI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Francesco Aquilante                              *
************************************************************************
      SUBROUTINE Lov_CASPT2(irc,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,NAME,
     &       nUniqAt,Thrs,IFQCAN,DoMP2,DoEnv,all_Vir,EMP2,CMO,NCMO)
************************************************************************
*                                                                      *
* Purpose:  setup of Localized occupied-virtual CASPT2 (LovCASPT2).    *
*           The CASPT2 correction to the energy will later be computed *
*           only for the "active region" of the molecule.              *
*           The MP2 correction due to the remaining frozen region      *
*           is computed here if DoMP2=.true.                           *
*           If DoEnv=.true. we compute the energy of the environment   *
*           as the total MP2 energy minus the MP2 energy of the        *
*           "active region" of the molecule.                           *
*                                                                      *
* Author:   F. Aquilante  (Geneva, Feb. 2008)                          *
*                                                                      *
************************************************************************
      use definitions, only: iwp, wp, u6
      use OneDat, only: sNoNuc, sNoOri
      use Molcas, only: LenIn, MxAtom, MxBas
      use Constants, only: Zero, One
      use stdalloc, only: mma_allocate, mma_deallocate
      Implicit None
      integer(kind=iwp), intent(out):: irc
      integer(kind=iwp), intent(in)::  nSym
      integer(kind=iwp), intent(inout):: nFro(nSym),nIsh(nSym),
     &                                   nSsh(nSym),nDel(nSym)
      integer(kind=iwp), intent(in):: nBas(nSym), nAsh(nSym)
      Character(Len=LenIn+8), intent(in):: NAME(*)
      integer(kind=iwp), intent(in):: nUniqAt
      real(kind=wp), intent(in)::  Thrs
      integer(kind=iwp), intent(inout):: IFQCAN
      Logical(kind=iwp), intent(inout):: DoMP2
      Logical(kind=iwp), intent(in):: DoEnv, all_Vir
      real(kind=wp), intent(out)::  EMP2
      integer(kind=iwp), intent(in):: NCMO
      real(kind=wp), intent(inout):: CMO(nCMO)

      Character(Len=LENIN) blank, NamAct(mxAtom)
      character(len=8) :: Label
      Logical(kind=iwp) ortho
      real(kind=wp)  TrA(8), TrF(8), TrX(8)
      integer(kind=iwp) ns_O(8), ns_V(8)
      integer(kind=iwp) lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
      integer(kind=iwp), allocatable:: nBas_per_Atom(:), nBas_Start(:),
     &                                 D_A(:), D_Vir(:)
      real(kind=wp), allocatable:: SQ(:), SLT(:), CMOX(:), Q(:), Z(:)
      real(kind=wp), allocatable:: Saa(:), XMO(:), DMat(:), OrbE(:)
      real(kind=wp) Dumm, E2_ab, E2_Aonly, STrA, STrF, STrX, Thrd
      real(kind=wp), external:: DDot_
      integer(kind=iwp) i, iAt, iBat, iCMO, iComp, iDo, ie, ik, iloc,
     &                  iOff, iopt, ip_X, ip_Y, ipAsh, ipCMO, ipEorb,
     &                  ipQa, iQ, iQa, iSkip, iSQ, iSym, iSymLbl, iV,
     &                  jAt, jBas, jBat, jCMO, jDo, jjCMO, jjZ, jOff,
     &                  jQ, jZ, kBas, kEOcc, kEVir, kfr, kOff, kto,
     &                  l_nBas_per_Atom, l_nBas_Start, lBas, lOff, lsq,
     &                  ltri, mAsh, mOff, nActa, nAk, nBasT, nBat, nBk,
     &                  nBmx, nOA, nOrb, nSQ, nTri, nVV, ipOrbE, nBx
*
      irc=0
      EMP2=Zero
      blank='   '
      iDo=0
      jDo=0
      If (DoEnv .and. DoMP2) Then
         Call WarningMessage(1,'Both DoEnv and DoMP2 selected.')
         Write (u6,'(/,A)') ' DoMP2 will be ignored.'
         DoMP2=.false.
      EndIf
      If (all_Vir .and. DoMP2) Then
         Call WarningMessage(1,'Both VirAll and DoMP2 selected.')
         Write (u6,'(/,A)') ' DoMP2 will be ignored.'
         DoMP2=.false.
      EndIf
      Do iSym=1,nSym
         TrA(iSym)=0
         TrF(iSym)=0
         TrX(iSym)=0
      End Do
*
*----------------------------------------------------------------------*
*     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
*----------------------------------------------------------------------*
*
      nBasT=0
      ntri=0
      nSQ=0
      nBmx=0
      mAsh=0
      nOrb=0
      Do i=1,nSym
        nBasT=nBasT+nBas(i)
        nOrb=nOrb+nFro(i)+nIsh(i)+nAsh(i)+nSsh(i)+nDel(i)
        ntri=ntri+nBas(i)*(nBas(i)+1)/2
        nSQ=nSQ+nBas(i)**2
        nBmx=Max(nBmx,nBas(i))
        mAsh=Max(mAsh,nAsh(i))
      End Do
      IF(nBasT.GT.mxBas) then
       Write(u6,'(/6X,A)')
     & 'The number of basis functions exceeds the present limit'
       Call Abend
      Endif
*
*     nUniqAt = # of symm. unique atoms. Initialize NamAct to blanks.
*     ---------------------------------------------------------------

      If (nUniqAt.lt.1 .or. nUniqAt.gt.MxAtom) Then
         Write(u6,'(A,I9)') 'nUniqAt =',nUniqAt
         Call Abend()
      End If
      Do iAt=1,nUniqAt
         NamAct(iAt)=blank
      End Do

C     Allocate and get index arrays for basis functions per atom.
C     -----------------------------------------------------------

      l_nBas_per_Atom = nUniqAt
      l_nBas_Start    = nUniqAt
      Call mma_allocate(nBas_per_Atom,l_nBas_per_Atom,Label='nB/A')
      Call mma_allocate(nBas_Start,l_nBas_Start,Label='nBStart')
*
*----------------------------------------------------------------------*
*     Read the overlap matrix                                          *
*----------------------------------------------------------------------*
      CALL mma_allocate(SQ,nSQ,Label='SQ')
      CALL mma_allocate(SLT,nTri,Label='SLT')
      isymlbl=1
      iopt=ibset(ibset(0,sNoOri),sNoNuc)
      Label='Mltpl  0'
      iComp=1
      Call RdOne(irc,iopt,Label,iComp,SLT,isymlbl)
      If(irc.ne.0) return
      ltri=1
      lsq=1
      Do iSym=1,nSym
         Call Square(SLT(ltri),SQ(lsq),1,nBas(iSym),
     &                                               nBas(iSym))
         ltri=ltri+nBas(iSym)*(nBAs(iSym)+1)/2
         lsq=lsq+nBas(iSym)**2
      End Do
      CALL mma_deallocate(SLT)
*
      CALL mma_allocate(CMOX,2*NCMO,Label='CMOX')
      ipCMO=1+NCMO
* This is not the best solution, but I wanted to avoid having to rewrite
* the indexing code below just to use the CMO array directly
      call dcopy_(NCMO,CMO,1,CMOX,1)
      call dcopy_(NCMO,CMOX,1,CMOX(ipCMO),1)

*----------------------------------------------------------------------*
*     Compute Mulliken atomic charges of each active orbital           *
*             on each center to define the Active Site                 *
*----------------------------------------------------------------------*
      Call mma_allocate(Q,nUniqAt*(mAsh+1),Label='Q')
      ipQa=1+nUniqAt*mAsh
      Call Fzero(Q(ipQa),nUniqAt)
      Call mma_allocate(Z,nBmx*mAsh,Label='Z')
      lBas=0
      iOff=0
      Do iSym=1,nSym
         iSQ=1+iOff
         ipAsh=1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
         nBx=Max(1,nBas(iSym))
         Call DGEMM_('N','N',nBas(iSym),nAsh(iSym),nBas(iSym),
     &                      One,SQ(iSQ),nBx,
     &                          CMOX(ipAsh),nBx,
     &                      Zero,Z,nBx)
         jBas=lBas+1
         kBas=lBas+nBas(iSym)
         Call BasFun_Atom_Sym(nBas_per_Atom,nBas_Start,
     &                        Name,jBas,kBas,nUniqAt,.false.)
         Do ik=0,nAsh(iSym)-1
            nAk=nUniqAt*ik
            nBk=nBas(iSym)*ik
            jCMO=ipAsh+nBk-1
            jZ=nBk
            Do iAt=0,nUniqAt-1
               iBat=nBas_Start(1+iAt)
               jjCMO=jCMO+iBat
               jjZ=jZ+iBat
               nBat=nBas_per_Atom(1+iAt)
               iQ=1+nAk+iAt
               Q(iQ)=ddot_(nBat,CMOX(jjCMO),1,Z(jjZ),1)
            End Do
         End Do
         Do iAt=0,nUniqAt-1
            jQ=1+iAt
            iQa=ipQa+iAt
            Q(iQa) = Q(iQa)
     &             + ddot_(nAsh(iSym),Q(jQ),nUniqAt,Q(jQ),nUniqAt)
            If (sqrt(Q(iQa)).ge.Thrs) Then
               jBat=nBas_Start(1+iAt)+lBas
               NamAct(iAt+1)=Name(jBat)(1:LENIN)
            EndIf
         End Do
         lBas=lBas+nBas(iSym)
         iOff=iOff+nBas(iSym)**2
      End Do
      Call mma_deallocate(Z)
      Call mma_deallocate(Q)

*     We have now completed the definition of the active site
*----------------------------------------------------------------------*
      Call mma_allocate(D_A,nUniqAt,Label='D_A')
      nActa=0
      Do iAt=1,nUniqAt
         If (NamAct(iAt).ne.blank) Then
            nActa=nActa+1
            D_A(nActa)=iAt
         EndIf
      End Do
      Do iAt=1,nActa
         jAt=D_A(iAt)
         NamAct(iAt)=NamAct(jAt)
      End Do
      Do iAt=nActa+1,nUniqAt
         NamAct(iAt)=blank
      End Do
      Write(u6,*)
      Write(u6,'(A,F15.6)') ' Threshold for atom selection: ',Thrs
      Write(u6,*)
      If (nActa.ne.0) Then
         Write(u6,'(A,I3,A)') ' Selected ',nActa,' atoms: '
         Write(u6,*)
         Write(u6,*) (NamAct(i),i=1,nActa)
         Write(u6,*)
      ElseIf (.not.DoMP2 .and. .not.DoEnv) Then
         Write(u6,'(A,18A4)') ' Selected atoms: *** None *** '
         Go To 2000
      Else
         Write(u6,'(A,18A4)') ' Selected atoms: *** None *** '
      EndIf

      Call mma_deallocate(D_A)
*----------------------------------------------------------------------*

      Call mma_allocate(OrbE,4*nOrb,Label='OrbE')
      ipOrbE=1
      Call Get_darray('RASSCF OrbE',OrbE(ipOrbE),nOrb)
      Call Compute_Tr_Dab(nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &                    CMOX(ipCMO),OrbE(ipOrbE),TrX)
*
*---  MP2 calculation on the whole system (incompatible with DoMP2)
      If (DoEnv) Then
         Call energy_AplusB(nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &                           CMOX(ipCMO:),OrbE(ipOrbE:),E2_ab)
      EndIf
*----------------------------------------------------------------------*
*     Localize the inactive and virtual orbitals                       *
*                                                                      *
*        1) inactive orbitals ---> cholesky orbitals (orthonormal)     *
*        2) virtual orbitals ---> lin. indep. PAOs (non-orthonormal)   *
*                                                                      *
*----------------------------------------------------------------------*
      Thrd=1.d-06
      Call mma_allocate(D_vir,nBasT,Label='D_Vir')
      Call Cho_ov_Loc(irc,Thrd,nSym,nBas,nFro,nIsh,
     &                    nAsh,nSsh,CMOX(ipCMO),SQ,
     &                    D_vir)

      If(irc.ne.0) then
       write(u6,*) 'Localization failed in LovCASPT2'
       Call Abend()
      Endif

      ipEorb=ipOrbE+nOrb
      kEOcc=ipEorb+nOrb
      kEVir=kEOcc+nOrb
      Call mma_allocate(Xmo,2*NCMO,Label='XMO')
      iCMO=1+NCMO
      Call mma_allocate(Saa,nOrb,Label='Saa')
      Saa(:)=One


*     Inactive orbital selection                                       *
*----------------------------------------------------------------------*
      iOff=0
      kOff=0
      lOff=0
      mOff=0
      Do iSym=1,nSym
         jOff=iOff+nBas(iSym)*nFro(iSym)
         call dcopy_(nBas(iSym)*nIsh(iSym),CMOX(ipCMO+jOff),1,
     &                                    XMO(1+kOff),1)
         call dcopy_(nBas(iSym)*nIsh(iSym),CMOX(1+jOff),1,
     &                                    XMO(iCMO+kOff),1)
         jOff=lOff+nFro(iSym)
         call dcopy_(nIsh(iSym),OrbE(ipOrbE+jOff),1,
     &                         OrbE(ipEorb+mOff),1)
         iOff=iOff+nBas(iSym)**2
         kOff=kOff+nBas(iSym)*nIsh(iSym)
         lOff=lOff+nBas(iSym)
         mOff=mOff+nIsh(iSym)
      End Do
      ortho=.true.
*
      Call get_Orb_select(irc,XMO(iCMO),XMO,OrbE(ipEorb),
     &                        SQ,Saa,Name,NamAct,
     &                        nSym,nActa,nIsh,nBas,ortho,Thrs,ns_O)
      If(irc.ne.0) Return
      iOff=0
      kOff=0
      Do iSym=1,nSym
         lOff=iOff+nBas(iSym)*nFro(iSym)
         Do ik=nIsh(iSym),1,-1
            jOff=kOff+nBas(iSym)*(ik-1)
            call dcopy_(nBas(iSym),XMO(iCMO+jOff),1,
     &                            CMOX(1+lOff),1)
            lOff=lOff+nBas(iSym)
         End Do
         iOff=iOff+nBas(iSym)**2
         kOff=kOff+nBas(iSym)*nIsh(iSym)
      End Do
      iloc=0
      loff=0
      Do iSym=1,nSym
         Do ik=nIsh(iSym),ns_O(iSym)+1,-1
            ie=ipEorb+loff+ik-1
            OrbE(kEOcc+iloc)=OrbE(ie)
            iloc=iloc+1
         End Do
         loff=loff+nIsh(iSym)
      End Do
      joff=0
      loff=0
      Do iSym=1,nSym
         koff=joff+nFro(iSym)+nIsh(iSym)-ns_O(iSym)
         Do ik=0,ns_O(iSym)-1
            ie=ipEorb+loff+ik
            OrbE(ipOrbE+koff+ik)=OrbE(ie)
         End Do
         loff=loff+nIsh(iSym)
         joff=joff+nBas(iSym)
      End Do

      If (all_Vir) Then

        Do iSym=1,nSym
         ns_V(iSym)=nSsh(iSym)
        End Do

      Else

*     Virtual orbital selection                                        *
*----------------------------------------------------------------------*
      iOff=0
      kOff=0
      lOff=0
      mOff=0
      Do iSym=1,nSym
         jOff=iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
         call dcopy_(nBas(iSym)*nSsh(iSym),CMOX(ipCMO+jOff),1,
     &                                    XMO(1+kOff),1)
         call dcopy_(nBas(iSym)*nSsh(iSym),CMOX(1+jOff),1,
     &                                    XMO(iCMO+kOff),1)
         jOff=lOff+nFro(iSym)+nIsh(iSym)+nAsh(iSym)
         call dcopy_(nSsh(iSym),OrbE(ipOrbE+jOff),1,
     &                         OrbE(ipEorb+mOff),1)
         iOff=iOff+nBas(iSym)**2
         kOff=kOff+nBas(iSym)*nSsh(iSym)
         lOff=lOff+nBas(iSym)
         mOff=mOff+nSsh(iSym)
      End Do
      ortho=.false.
      Call get_Saa(nSym,nBas,nSsh,SQ,XMO,Saa)
*
      Call get_Vir_select(irc,XMO(iCMO),XMO,OrbE(ipEorb),
     &                        SQ,Name,NamAct,D_vir,
     &                        nSym,nActa,nSsh,nBas,ortho,ns_V)
      If(irc.ne.0) Return
      Call mma_deallocate(D_vir)
      iOff=0
      kOff=0
      Do iSym=1,nSym
         jOff=iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
         call dcopy_(nBas(iSym)*nSsh(iSym),XMO(iCMO+kOff),1,
     &                                    CMOX(1+jOff),1)
         iOff=iOff+nBas(iSym)**2
         kOff=kOff+nBas(iSym)*nSsh(iSym)
      End Do
      iloc=0
      loff=0
      Do iSym=1,nSym
         Do ik=ns_V(iSym)+1,nSsh(iSym)
            ie=ipEorb+loff+ik-1
            OrbE(kEVir+iloc)=OrbE(ie)
            iloc=iloc+1
         End Do
         loff=loff+nSsh(iSym)
      End Do
      joff=0
      loff=0
      Do iSym=1,nSym
         koff=joff+nFro(iSym)+nIsh(iSym)+nAsh(iSym)
         Do ik=0,ns_V(iSym)-1
            ie=ipEorb+loff+ik
            OrbE(ipOrbE+koff+ik)=OrbE(ie)
         End Do
         joff=joff+nBas(iSym)
         loff=loff+nSsh(iSym)
      End Do

      EndIf


*     MP2 calculation on the Frozen region                             *
*----------------------------------------------------------------------*
      If (DoMP2) Then

         iDo=0
         jDo=0
         nVV=0
         nOA=0
         Do iSym=1,nSym  ! setup info
            lnOrb(iSym)=nBas(iSym)
            lnOcc(iSym)=nIsh(iSym)-ns_O(iSym)
            lnFro(iSym)=nFro(iSym)+ns_O(iSym)
            lnDel(iSym)=nDel(iSym)+ns_V(iSym)
            lnVir(iSym)=nSsh(iSym)-ns_V(iSym)
            iDo=Max(iDo,lnOcc(iSym))
            jDo=Max(jDo,lnVir(iSym))
            nVV=nVV+lnVir(iSym)**2
            nOA=nOA+lnOcc(iSym)
         End Do
         If (Min(iDo,jDo).eq.0) goto 1000
*
         Call mma_allocate(Dmat,nVV+nOA,Label='DMat')
         ip_X=1
         ip_Y=ip_X+nVV
         DMat(:)=0.0D0
         Call FZero(XMO(iCMO),NCMO)
         iOff=0
         Do iSym=1,nSym
            kfr=1   +iOff+nBas(iSym)*nFro(iSym)
            kto=iCMO+iOff+nBas(iSym)*lnFro(iSym)
            call dcopy_(nBas(iSym)*lnOcc(iSym),CMOX(kfr),1,XMO(kto),1)
            kfr=1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym)
     &                                                     +ns_V(iSym))
            kto=kto+nBas(iSym)*lnOcc(iSym)
            call dcopy_(nBas(iSym)*lnVir(iSym),CMOX(kfr),1,XMO(kto),1)
            iOff=iOff+nBas(iSym)**2
         End Do
         Call Check_Amp(nSym,lnOcc,lnVir,iSkip)
         If (iSkip.gt.0) Then
            Call LovCASPT2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,
     &                            .true.)
            Call ChoMP2_Drv(irc,Dumm,XMO(iCMO),OrbE(kEOcc),OrbE(kEVir),
     &                      DMAT(ip_X),DMAT(ip_Y))
            Call LovCASPT2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,
     &                            .false.)
            Call ChoMP2_Drv(irc,EMP2,XMO(iCMO),OrbE(kEOcc),OrbE(kEVir),
     &                      DMAT(ip_X),DMAT(ip_Y))
            If(irc.ne.0) then
              write(u6,*) 'Frozen region MP2 failed'
              Call Abend
            Endif
            iV=ip_X
            Do iSym=1,nSym
             TrF(iSym)=ddot_(lnVir(iSym),DMAT(iV),1+lnVir(iSym),[One],0)
              iV=iV+lnVir(iSym)**2
            End Do
         EndIf
         Call mma_deallocate(Dmat)
1000     Write(u6,*)

         If (nActa.eq.0) Then
            Write(u6,'(A,F18.10)')' Frozen region MP2 correction: ',EMP2
            Write(u6,*)
         EndIf
      EndIf
*                                                                      *
*----------------------------------------------------------------------*

      Call mma_deallocate(Saa)
      Call mma_deallocate(XMO)
*
*     Update the nFro, nIsh, nSsh, nDel for the Active site CASPT2
      Do iSym=1,nSym
         nFro(iSym)=nFro(iSym)+nIsh(iSym)-ns_O(iSym)
         nIsh(iSym)=ns_O(iSym)
         nDel(iSym)=nDel(iSym)+nSsh(iSym)-ns_V(iSym)
         nSsh(iSym)=ns_V(iSym)
         iDo=Max(iDo,nIsh(iSym))
         jDo=Max(jDo,nSsh(iSym))
      End Do

      Call Compute_Tr_Dab(nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &                    CMOX,OrbE(ipOrbE),TrA)

      write(u6,*)
     &    '------------------------------------------------------'
      write(u6,*)
     &    ' Symm.  Tr(D):  Active        Frozen        Full      '
      write(u6,*)
     &    '------------------------------------------------------'
      STrA=Zero
      STrF=Zero
      STrX=Zero
      Do iSym=1,nSym
        If (DoEnv) TrF(iSym)=TrX(iSym) ! just a convention
        write(u6,'(2X,I4,10X,G11.4,3X,G11.4,3X,G11.4)') iSym,TrA(iSym),
     &       TrF(iSym),TrX(iSym)
        STrA=STrA+TrA(iSym)
        STrF=STrF+TrF(iSym)
        STrX=STrX+TrX(iSym)
      End Do
      write(u6,*)
     &    '------------------------------------------------------'
      write(u6,'(A,G11.4,3X,G11.4,3X,G11.4)')'          Sum:  ',
     & STrA,STrF,STrX
      write(u6,*)
     &    '------------------------------------------------------'
      write(u6,*)
*
      If (DoEnv) Then
         Call energy_AplusB(nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &                           CMOX,OrbE(ipOrbE),E2_Aonly)
         EMP2 = E2_ab - E2_Aonly
c         Write(6,'(A,F18.10)')' MP2 correction (environment): ',EMP2
c         Write(6,*)
      EndIf

      Call mma_deallocate(OrbE)

2000  Continue
      If (Min(iDo,jDo).eq.0) Then
         Write(u6,*)
         Write(u6,*)
     &       ' None of the inactive or virtual orbitals has been '
         Write(u6,*)
     &       ' assigned to the Active region of the molecule.    '
         Write(u6,*)
     &       ' This is presumably NOT what you want !!!          '
         Write(u6,*)' CASPT2 will Stop here. Bye Bye !! '
         Write(u6,*)
         Call Abend
      EndIf
*
      IF (IFQCAN.NE.0) IFQCAN=0 ! MOs to be recanonicalized on exit
      call dcopy_(NCMO,CMOX,1,CMO,1)

      Call mma_deallocate(CMOX)
      Call mma_deallocate(SQ)
      Call mma_deallocate(nBas_per_Atom)
      Call mma_deallocate(nBas_Start)

      End SUBROUTINE Lov_CASPT2
************************************************************************
*                                                                      *
************************************************************************
      Subroutine get_Saa(nSym,nBas,nOrb,Smn,Xmo,Saa)
      use definitions, only: iwp, wp
      use stdalloc, only: mma_allocate, mma_deallocate
      Implicit None
      integer(kind=iwp), intent(in)::  nSym, nBas(nSym), nOrb(nSym)
      real(kind=wp), intent(in)::  Smn(*), Xmo(*)
      real(kind=wp), intent(out)::  Saa(*)

      real(kind=wp), Allocatable:: Z(:)
      integer(kind=iwp) mOb, iSym, iX, kX, lX, nBX, j, jK, jX, jZ, lk
      real(kind=wp), external:: DDot_
*
*
      mOb=nBas(1)*nOrb(1)
      Do iSym=2,nSym
         mOb=Max(mOb,nBas(iSym)*nOrb(iSym))
      End Do
      Call mma_allocate(Z,mOb,Label='Z')

      iX=1
      kX=1
      lX=1
      Do iSym=1,nSym
         nBx=Max(1,nBas(iSym))
         Call DGEMM_('N','N',nBas(iSym),nOrb(iSym),nBas(iSym),
     &                      1.0d0,Smn(iX),nBx,
     &                            Xmo(kX),nBx,
     &                      0.0d0,Z,nBx)
         Do j=0,nOrb(iSym)-1
            jK=nBas(iSym)*j
            lk=kX+jK
            jZ=1+jK
            jX=lX+j
            Saa(jX)=ddot_(nBas(iSym),Xmo(lk),1,Z(jZ),1)
         End Do
         iX=iX+nBas(iSym)**2
         kX=kX+nBas(iSym)*nOrb(iSym)
         lX=lX+nOrb(iSym)
      End Do
      Call mma_deallocate(Z)
*
      End Subroutine get_Saa
************************************************************************
*                                                                      *
************************************************************************
      SubRoutine LovCASPT2_putInf(mSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,
     &                            isFNO)
C
C     Purpose: put info in MP2 common blocks.
C
      use definitions, only: iwp
      use constants, only: Zero
      Use ChoMP2, only: C_os, ChkDecoMP2, ChoAlg, Decom_Def, DecoMP2,
     &                  DoFNO, EOSMP2, ForceBatch, l_Dii, MxQual_Def,
     &                  MxQualMP2, OED_Thr, set_cd_thr, shf, SOS_mp2,
     &                  Span_Def, SpanMP2, ThrMP2, Verbose
      use cOrbInf, only: nSym, nOrb, nOcc, nFro, nDel, nExt
      Implicit none
      Integer(kind=iwp), intent(in) :: mSym
      Integer(kind=iwp), intent(in) :: lnOrb(8), lnOcc(8), lnFro(8),
     &                                 lnDel(8), lnVir(8)
      Logical(kind=iwp), intent(in) ::  isFNO

      Integer(kind=iwp) iSym
C
      nSym = mSym
C
      Do iSym = 1,nSym
         nOrb(iSym) = lnOrb(iSym)
         nOcc(iSym) = lnOcc(iSym)
         nFro(iSym) = lnFro(iSym)
         nDel(iSym) = lnDel(iSym)
         nExt(iSym) = lnVir(iSym)
      End Do
C
      ChoAlg=2
      DecoMP2=Decom_Def
      ThrMP2=-9.9D9
      SpanMP2=Span_Def
      MxQualMP2=MxQual_Def
      ChkDecoMP2=.false.
      ForceBatch=.false.
      Verbose=.false.
      SOS_mp2=.false.
      set_cd_thr=.true.
      OED_Thr=1.0d-8
      C_os=1.3d0
      EOSMP2=Zero
      shf=Zero
C
      DoFNO=isFNO
      l_Dii=nOcc(1)
      Do iSym=2,nSym
         l_Dii=l_Dii+nOcc(iSym)
      End Do
C
      End SubRoutine LovCASPT2_putInf

      Subroutine Energy_AplusB(nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &                         CMO,OrbE,E2_ab)

      use definitions, only: iwp, wp, u6
      use constants, only: Zero
      use stdalloc, only: mma_allocate, mma_deallocate
      Implicit None
      integer(kind=iwp), intent(in):: nSym
      integer(kind=iwp), intent(in):: nBas(nSym), nFro(nSym), nIsh(nSym)
      integer(kind=iwp), intent(in):: nAsh(nSym), nSsh(nSym), nDel(nSym)
      real(kind=wp), intent(in)::  CMO(*), OrbE(*)
      real(kind=wp), intent(out)::  E2_ab

      integer(kind=iwp) nAct(8), lnOrb(8), lnOcc(8), lnFro(8), lnDel(8),
     &                  lnVir(8)
      real(kind=wp) Dummy(1)
      real(kind=wp), Allocatable:: Eorb(:), CMOX(:)
      integer(kind=iwp) iE, ifr, ioff, irc, iSkip, iSym, ito, joff, k,
     &                  kEOcc, kEVir, kfr, koff, kto, nBB, nOA, nOrb,
     &                  nVV
*
*
      Call Izero(nAct,nSym)
      nVV=0
      nOrb=0
      Do iSym=1,nSym
         iE=1+nOrb+nFro(iSym)+nIsh(iSym)
         Do k=0,nAsh(iSym)-1
            If (OrbE(iE+k).lt.Zero) nAct(iSym)=nAct(iSym)+1
         End Do
         nVV=nVV+nSsh(iSym)**2
         nOrb=nOrb+nBas(iSym)
      End Do
*
      nBB=0
      nOA=0
      Do iSym=1,nSym  ! setup info
         lnOrb(iSym)=nBas(iSym)
         lnFro(iSym)=nFro(iSym)
         lnOcc(iSym)=nIsh(iSym)+nAct(iSym)
         lnVir(iSym)=nSsh(iSym)
         lnDel(iSym)=nDel(iSym)
         nBB=nBB+nBas(iSym)**2
         nOA=nOA+lnOcc(iSym)
      End Do
*
      Call mma_allocate(Eorb,2*nOrb,Label='Eorb')
      kEOcc=1
      kEVir=kEOcc+nOrb
      ioff=0
      joff=0
      koff=0
      Do iSym=1,nSym
         ifr=1+ioff+nFro(iSym)
         ito=kEOcc+joff
         call dcopy_(lnOcc(iSym),OrbE(ifr),1,Eorb(ito),1)
         ifr=1+ioff+nFro(iSym)+nIsh(iSym)+nAsh(iSym)
         ito=kEVir+koff
         call dcopy_(nSsh(iSym),OrbE(ifr),1,Eorb(ito),1)
         ioff=ioff+nBas(iSym)
         joff=joff+lnOcc(iSym)
         koff=koff+nSsh(iSym)
      End Do
*
      Call LovCASPT2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,.false.)
      Call mma_allocate(CMOX,nBB,Label='CMOX')
      CMOX(:)=Zero
      iOff=0
      Do iSym=1,nSym
         kfr=1+iOff+nBas(iSym)*nFro(iSym)
         kto=1+iOff+nBas(iSym)*lnFro(iSym)
         call dcopy_(nBas(iSym)*lnOcc(iSym),CMO(kfr),1,CMOX(kto),1)
         kfr=1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
         kto=kto+nBas(iSym)*lnOcc(iSym)
         call dcopy_(nBas(iSym)*lnVir(iSym),CMO(kfr),1,CMOX(kto),1)
         iOff=iOff+nBas(iSym)**2
      End Do
*
      Call Check_Amp(nSym,lnOcc,lnVir,iSkip)
      If (iSkip.gt.0) Then
         Call ChoMP2_Drv(irc,E2_ab,CMOX,Eorb(kEOcc),Eorb(kEVir),
     &                   Dummy,Dummy)
         If(irc.ne.0) then
           write(u6,*) 'MP2 calculation failed in energy_AplusB !'
           Call Abend
         Endif
      Else
         write(u6,*)
         write(u6,*)'There are ZERO amplitudes T(ai,bj) with the given '
         write(u6,*)'combinations of inactive and virtual orbitals !! '
         write(u6,*)'Check your input and rerun the calculation! Bye!!'
         Call Abend()
      Endif
      Call mma_deallocate(CMOX)
*
      Call mma_deallocate(Eorb)
*
      End Subroutine Energy_AplusB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RdCtl_Slapaf(iRow,iInt,nFix,LuSpool,Dummy_Call)
      use kriging_mod
      use Symmetry_Info, only: Symmetry_Info_Get
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "info_slapaf.fh"
#include "nadc.fh"
#include "weighting.fh"
#include "print.fh"
      Logical Found, Dummy_Call
      Character*8 Command
      Character*180 Get_Ln
      Character*16 FilNam
      Character*3 MEPLab
      External Get_SuperName
      Character*100 Get_SuperName
      Character*100 SuperName
*
*     Compare with inputil.f. Note that here Line is defined in
*     info:slapaf.fh. Otherwise the common cgetln should be
*     identical in size.
*
* mxn should be len(line)/2+1
      parameter (mxn=91)
      common/cgetln/ ncol, jstrt(mxn),jend(mxn)
      Integer StrnLn
      External Get_Ln, StrnLn
      Logical External_UDC, External_Case,
     &        Explicit_IRC, Expert, ThrInp, FirstNum
#include "angstr.fh"
*                                                                      *
************************************************************************
*                                                                      *
      iRout=2
      Expert=.False.
      Lu=6
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Initiate some parameters
*
      Call Symmetry_Info_Get()
      Call Init_Slapaf(iRow)
      iPrint=nPrint(iRout)
      iSetAll=2**30 - 1
*
      Call f_Inquire('UDC.Gateway',External_UDC)
      LuRd2=LuSpool
      External_Case=.False.
*
      iMEP=0
      Explicit_IRC=.False.
      lCtoF=.False.
      WeightedConstraints=.False.
      ThrInp=.False.
      Call Qpg_iScalar('nMEP',Found)
      If (Found) Call Get_iScalar('nMEP',iMEP)
      If (iMEP.eq.0) Then
         iOff_Iter=0
         Call Put_iScalar('iOff_Iter',iOff_Iter)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     When called from outside Slapaf or as a dummy call, process no
*     input but proceed with default values only.
*
      SuperName= Get_Supername()
      If ((SuperName.ne.'slapaf').or.Dummy_Call) Then
         Char='END '
         Go To 666
      End If
*                                                                      *
************************************************************************
**************************   Input section   ***************************
************************************************************************
*                                                                      *
      LuRd=LuSpool
      Call RdNlst(LuRd,'SLAPAF')
      Command='&SLAPAF'
 999  Char=Get_Ln(LuRd)
 666  Continue
      Call UpCase(Char)
      Command=Char(1:8)
C     Write (Lu,'(A)') Char
C     Write (Lu,*) iOptC
      If (Char.eq.BLine) Go To 999
      If (Char(1:1).eq.'*') Go To 999
!     If (Char(1:4).eq.'AIL ') Go To 102
!     If (Char(1:4).eq.'AIP ') Go To 104
!     If (Char(1:4).eq.'AISP') Go To 105
!     If (Char(1:4).eq.'AIME') Go To 107
!     If (Char(1:4).eq.'AIBL') Go To 108
!     If (Char(1:4).eq.'AIMB') Go To 109
!     If (Char(1:4).eq.'L-VA') Go To 112
      If (Char(1:4).eq.'BAKE') Go To 926
      If (Char(1:4).eq.'C1-D') Go To 936
      If (Char(1:4).eq.'C2-D') Go To 937
      If (Char(1:4).eq.'CART') Go To 918
      If (Char(1:4).eq.'CNWE') Go To 990
      If (Char(1:4).eq.'CONS') Go To 9478
      If (Char(1:4).eq.'CTOF') Go To 904
      If (Char(1:4).eq.'CUBI') Go To 947
      If (Char(1:4).eq.'DDVS') Go To 9271
      If (Char(1:4).eq.'DELT') Go To 946
      If (Char(1:4).eq.'DISO') Go To 9452
      If (Char(1:4).eq.'DXDX') Go To 939
      If (Char(1:4).eq.'DXG ') Go To 940
      If (Char(1:4).eq.'END ') Go To 998
      If (Char(1:4).eq.'EXPE') Go To 993
      If (Char(1:4).eq.'EXTR') Go To 971
      If (Char(1:4).eq.'FALC') Go To 800
      If (Char(1:4).eq.'FIND') Go To 963
      If (Char(1:4).eq.'FUZZ') Go To 123
      If (Char(1:4).eq.'GDX ') Go To 940
      If (Char(1:4).eq.'GG  ') Go To 941
      If (Char(1:4).eq.'GNRM') Go To 968
      If (Char(1:4).eq.'GRAD') Go To 979
      If (Char(1:4).eq.'HRMS') Go To 995
      If (Char(1:4).eq.'HUPD') Go To 914
      If (Char(1:4).eq.'HWRS') Go To 929
      If (Char(1:4).eq.'INTE') Go To 902
      If (Char(1:4).eq.'IRC ') Go To 997
      If (Char(1:4).eq.'ITER') Go To 925
      If (Char(1:4).eq.'KRIG') Go To 100
      If (Char(1:4).eq.'LAST') Go To 9280
      If (Char(1:4).eq.'LINE') Go To 9281
      If (Char(1:4).eq.'MAXS') Go To 915
      If (Char(1:4).eq.'MAXD') Go To 916
      If (Char(1:4).eq.'MEP-'.or. Char(1:4).eq.'MEP ') Go To 964
      If (Char(1:4).eq.'MEPA'.or. Char(1:4).eq.'IRCA') Go To 322
      If (Char(1:4).eq.'MEPC'.or. Char(1:4).eq.'IRCC') Go To 323
      If (Char(1:4).eq.'MEPS'.or. Char(1:4).eq.'IRCS') Go To 9971
      If (Char(1:4).eq.'MEPT'.or. Char(1:4).eq.'IRCT') Go To 321
      If (Char(1:4).eq.'MODE') Go To 942
      If (Char(1:4).eq.'MXMI') Go To 106
      If (Char(1:4).eq.'NMEP'.or. Char(1:4).eq.'NIRC') Go To 965
      If (Char(1:4).eq.'NEWT') Go To 935
      If (Char(1:4).eq.'NOEM') Go To 991
      If (Char(1:4).eq.'NOHW') Go To 960
      If (Char(1:4).eq.'NOLA') Go To 930
      If (Char(1:4).eq.'NOLI') Go To 928
      If (Char(1:4).eq.'NOWB') Go To 984
      If (Char(1:4).eq.'NOWC') Go To 985
      If (Char(1:4).eq.'NOWH') Go To 986
      If (Char(1:4).eq.'NUME') Go To 945
      If (Char(1:4).eq.'OLDF') Go To 903
      If (Char(1:4).eq.'PRFC') Go To 9201
      If (Char(1:4).eq.'PRIN') Go To 920
      If (Char(1:4).eq.'RATI') Go To 938
      If (Char(1:4).eq.'REDU') Go To 994
      If (Char(1:4).eq.'REAC') Go To 996
      If (Char(1:4).eq.'REFE') Go To 966
      If (Char(1:4).eq.'RHID') Go To 988
      If (Char(1:4).eq.'RMEP') Go To 980
      If (Char(1:4).eq.'RS-P') Go To 967
      If (Char(1:4).eq.'RTRN') Go To 962
      If (Char(1:4).eq.'SCHL') Go To 927
      If (Char(1:4).eq.'SUPS') Go To 911
      If (Char(1:4).eq.'TFOF') Go To 110
      If (Char(1:4).eq.'THER') Go To 9451
      If (Char(1:4).eq.'THRS') Go To 908
      If (Char(1:4).eq.'TOLE') Go To 909
      If (Char(1:4).eq.'TRAC') Go To 910
      If (Char(1:4).eq.'TS  ') Go To 951
      If (Char(1:4).eq.'TSCO') Go To 320
      If (Char(1:4).eq.'VDWB') Go To 981
      If (Char(1:4).eq.'VDWC') Go To 982
      If (Char(1:4).eq.'VDWH') Go To 983
      If (Char(1:4).eq.'WIND') Go To 934
      Call WarningMessage(2,'Error in RdCtl_Slapaf')
      If (Char(1:1).eq.' ') Then
         Write (Lu,*) ' RdCtl_Slapaf: Command line starts with a blank.'
      Else
         Write (Lu,*)
         Write (Lu,*) ' *********** ERROR ***********'
         Write (Lu,*) ' The program has been supplied'
         Write (Lu,*) ' with an unknown command.     '
         Write (Lu,*) ' *****************************'
      End If
      Write (Lu,'(A)') Char
      Call Quit_OnUserError()
*                                                                      *
****** INTE ************************************************************
*                                                                      *
*     Read the internal coordinate specification.
*
 902  Continue
      New_Line=1
      Lu_UDIC=91
      FilNam='UDIC'
cc      Open(Lu_UDIC,File=FilNam,Form='FORMATTED',Status='UNKNOWN')
      call molcas_open(Lu_UDIC,FilNam)
      ReWind(Lu_UDIC)
*
*     mInt is the number of internal coordinates you will define.
*     Subroutine DefInt defines the B matrix.
*     The matrix B relates a shift in an internal coordinate to
*     shifts in cartesian coordinates,
*
*               |dq> = B |dx>
*                      =
*     and has the dimension (3*nsAtom x mInt).
 992  Continue
         Line=Get_Ln(LuRd)
         Call UpCase(Line)
         If (Line(1:4).eq.'END ') Then
            Close(Lu_UDIC)
            Go To 999
         End If
*
*        Here is a fix because auto will break up the lines if there is an
*        equal sign in the input.
*
*        Lines with VARY or FIX doesn't have equal signs
*
         If (Line(1:4).eq.'VARY') nBVec=iRow
         If (Line(1:4).eq.'VARY'.or.
     &       Line(1:3).eq.'FIX' .or.
     &       Line(1:4).eq.'ROWH') Then
            New_Line=0
         End If
*
 111     Continue
         If (New_Line.eq.1) Then
            If (Index(Line,'=').eq.0) Call FixEqualSign2(Line,LuRd,
     &                                                   Lu_UDIC,iRow,
     &                                                   New_Line)
            If (New_Line.eq.2) Then
               Close(Lu_UDIC)
               Go To 999
            End If
            Go To 111
         End If
*
         iRow = iRow + 1
*
         Write (Lu_UDIC,'(A)') Line
*
*        If this line does not have a continuation the next line should
*        have a equal sign!
         If (Index(Line,'&').eq.0) New_Line=1
      Go To 992
*                                                                      *
****** CTOF ************************************************************
*                                                                      *
*     Read the internal (C)oordinate specification (TO) be (F)ollowed.
*
 904  Continue
      If (iRow.GT.0) then
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '*********** ERROR ***************'
         Write (Lu,*) 'CtoF and User-defined Coordinates'
         Write (Lu,*) 'are mutually exclusive.          '
         Write (Lu,*) '*********************************'
         Call Quit_OnUserError()
      EndIf
      iNull    = 0
      New_Line = 1
      lCtoF    = .True.
      Lu_UDIC  = 91
      FilNam='UDIC'
      call molcas_open(Lu_UDIC,FilNam)
      ReWind(Lu_UDIC)
      Line=Get_Ln(LuRd)
      Call UpCase(Line)
      Call FixEqualSign2(Line,LuRd,Lu_UDIC,iNull,New_Line)
      Write (Lu_UDIC,'(A)') Line
      Close(Lu_UDIC)
      Go To 999
*                                                                      *
****** CONS ************************************************************
*                                                                      *
*     Copy constraints definition into the UDC file, to be read
*     (after fixing and merging, if necessary) by DefInt2/Cllct2.
*
 9478 Continue
      If (.Not.Expert) Then
         Write (Lu,*)
         Write (Lu,*) ' ************ ERROR ***************'
         Write (Lu,*) ' Obsolete input standard!'
         Write (Lu,*) ' The CONSTRAINT section should'
         Write (Lu,*) ' be define in the &Gateway input.'
         Write (Lu,*)
         Write (Lu,*) ' To override add the EXPERT keyword'
         Write (Lu,*) ' to the top of the SLAPAF input.'
         Write (Lu,*) ' **********************************'
         Call Quit_OnUserError()
      End If
      If (External_UDC) Then
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '****************** ERROR *********************'
         Write (Lu,*) 'Multiple definitions of constraints.'
         Write (Lu,*) 'Check Gateway and Slapaf inputs for conflicts!'
         Write (Lu,*) '**********************************************'
         Call Quit_OnUserError()
      End If
      Lu_UDC=20
      FilNam='UDC'
      Lu_UDC=IsFreeUnit(Lu_UDC)
      Call Molcas_Open(Lu_UDC,FilNam)
 318  Continue
      Line=Get_Ln(LuRd)
      Call UpCase(Line)
      Call LeftAd(Line)
      Write(Lu_UDC,'(A)') Trim(Line)
      If (Line(1:4).ne.'END') Go To 318
      Close(Lu_UDC)
      Go To 999
*                                                                      *
****** VDWB VdW correction both coordinate and Hessian *****************
*                                                                      *
981   iOptC = iOr(1024,iOptC)
      iOptC = iOr(2048,iOptC)
      Go To 999
*                                                                      *
****** NO VDWB VdW correction both coordinate and Hessian **************
*                                                                      *
984   Mask=iSetAll-2**10-2**11
      iOptC = iAnd(Mask,iOptC)
      Go To 999
*                                                                      *
****** VDWB VdW correction for coordinate only *************************
*                                                                      *
982   iOptC = iOr(2048,iOptC)
      Go To 999
*                                                                      *
****** NO VDWB VdW correction for coordinate only **********************
*                                                                      *
985   Mask=iSetAll-2**11
      iOptC = iAnd(Mask,iOptC)
      Go To 999
*                                                                      *
****** VDWB VdW correction for Hessian only ****************************
*                                                                      *
983   iOptC = iOr(1024,iOptC)
      Go To 999
*                                                                      *
****** NO VDWB VdW correction for Hessian only *************************
*                                                                      *
986   Mask=iSetAll-2**10
      iOptC = iAnd(Mask,iOptC)
      Go To 999
*                                                                      *
****** OLDF ************************************************************
*                                                                      *
903   lOld = .True.
      Go To 999
*                                                                      *
****** CART ************************************************************
*                                                                      *
918   CurviLinear = .False.
      Go To 999
*                                                                      *
****** THRS ************************************************************
*                                                                      *
*     read the gradient threshold
*
 908  Char=Get_Ln(LuRd)
      Call Get_F1(1,ThrEne)
      Call Get_F1(2,ThrGrd)
      ThrInp=.True.
      Go To 999
*                                                                      *
****** TOLE ************************************************************
*                                                                      *
*     read the constraints threshold
*
 909  Char=Get_Ln(LuRd)
      Call Get_F1(1,ThrCons)
      ThrCons=Abs(ThrCons)
      Go To 999
*                                                                      *
****** SUPS ************************************************************
*                                                                      *
*     Introduce supersymmetry
*     Input format
*     nsg                (number of super groups)
*     Reapeat nsg times
*     nmem, (ind.., i = 1, nmem)
*
 911  LSup = .True.
      Char=Get_Ln(LuRd)
      Call Get_I1(1,nSupSy)
      Call GetMem(' NSup ','Allo','Inte',ipNSup,NSUPSY)
      Call GetMem('iAtom ','Allo','Inte',ipAtom,nsAtom)
      iStrt = ipAtom
      Do 950 i = ipNSup, ipNSup+nSupSy-1
         Read(LuRd,*,Err=9630)iWork(i),
     &       (iWork(j),j=iStrt,iStrt+iWork(i)-1)
         iStrt = iStrt + iWork(i)
 950  Continue
      Go To 999
9630  Call WarningMessage(2,'Error in RdCtl_Slapaf')
      Write (Lu,*)
      Write (Lu,*) '************ ERROR ****************'
      Write (Lu,*) 'Error while reading supersymmetry.'
      Write (Lu,*) '***********************************'
      Call Quit_OnUserError()
*                                                                      *
****** HUPD ************************************************************
*                                                                      *
914   Char=Get_Ln(LuRd)
      Read(Char,*) Char
      Call UpCase(Char)
      If (Trim(Char).eq.'BFGS') Then
         iOptH = 4
c     Else If (Trim(Char).eq.'MEYER') Then
c        iOptH = iOr(1,iAnd(iOptH,32))
c     Else If (Trim(Char).eq.'BP') Then
c        iOptH = iOr(2,iAnd(iOptH,32))
      Else If (Trim(Char).eq.'NONE') Then
         iOptH = iOr(8,iAnd(iOptH,32))
      Else If (Trim(Char).eq.'MSP') Then
         iOptH = iOr(16,iAnd(iOptH,32))
      Else If (Trim(Char).eq.'EU') Then
         iOptH = iOr(64,iAnd(iOptH,32))
      Else If (Trim(Char).eq.'TS-BFGS') Then
         iOptH = iOr(128,iAnd(iOptH,32))
      Else
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '************ ERROR ****************'
         Write (Lu,*) 'Unsupported Hessian update method: ',Trim(Char)
         Write (Lu,*) '***********************************'
         Call Quit_OnUserError()
      End If
      Go To 999
*                                                                      *
****** MAXS ************************************************************
*                                                                      *
 915  Char=Get_Ln(LuRd)
      If (Char.eq.BLine) Go To 915
      If (Char(1:1).eq.'*') Go To 915
      Call Get_F1(1,Beta)
      Go To 999
*                                                                      *
****** MAXD ************************************************************
*                                                                      *
 916  Char=Get_Ln(LuRd)
      If (Char.eq.BLine) Go To 916
      If (Char(1:1).eq.'*') Go To 916
      Call Get_F1(1,Beta_Disp)
      Go To 999
*                                                                      *
****** PRIN ************************************************************
*                                                                      *
 920  Char=Get_Ln(LuRd)
      Call UpCase(Char)
      If (Char.eq.BLine) Go To 920
      If (Char(1:1).eq.'*') Go To 920
      Call Get_I1(1,mPrint)
      Do 921 i = 1, mPrint
 922     Char=Get_Ln(LuRd)
         Call UpCase(Char)
         If (Char.eq.BLine) Go To 922
         If (Char(1:1).eq.'*') Go To 922
         Call Get_I1(1,iRout)
         Call Get_I1(2,kPrint)
         nPrint(iRout)=kPrint
 921  Continue
      Go To 999
*                                                                      *
****** PRFC ************************************************************
*                                                                      *
*     set nPrint to print internal coordinates and hessian
*
9201  nPrint(21)=6  ! Eigen-/Values/Vectors of the Hessian (diagmtrx)
      nPrint(116)=6 ! Internal Forces (rlxctl)
      If (.NOT.Request_Alaska) nPrint(30)=6 ! Coord.s & Forces (defint)
      nPrint(122)=6 ! Auto-Defined Internal coordinates (printq_sl)
      Go To 999
*                                                                      *
****** ITER ************************************************************
*                                                                      *
*     read max iterations
*
 925  Char=Get_Ln(LuRd)
      Call Get_I1(1,iTmp)
      MxItr=Min(iTmp,MxItr)
      Go To 999
*                                                                      *
****** KRIG ************************************************************
*                                                                      *
*     Activate Kriging
*
100   Kriging = .True.
      Line_Search = .False.
      Go To 999
!*                                                                      *
!****** AIMD ************************************************************
!*                                                                      *
!*      Analitical or numerical Matern derivatives
!*
!101   Char=Get_Ln(LuRd)
!      If (Char.eq.'False'.or.Char.eq.'false') then
!            anMd = .False.
!      Else
!            anMd = .True.
!      EndIf
!      Go To 999
!*                                                                      *
!****** AIL  ************************************************************
!*                                                                      *
!*     Width limits of the Matern function
!*
!102   Char=Get_Ln(LuRd)
!      Call Get_F(1,lb,3)
!      Go To 999
!*                                                                      *
!****** AIP  ************************************************************
!*                                                                      *
!*     Parameter of differentiability for Matern function
!*
!104   Char=Get_Ln(LuRd)
!      Call Get_F1(1,pAI)
!      If(pAI.gt.3.or.pAI.lt.1) anMd = .False.
!      Go To 999
!*                                                                      *
!****** AISP ************************************************************
!*                                                                      *
!*     Defining the number of source points for the AI method
!*
!105   Char=Get_Ln(LuRd)
!      Call Get_I1(1,nspAI)
!      Go To 999
*                                                                      *
****** MXMI ************************************************************
*                                                                      *
*     Maximum number of Iterations for the Kriging method
*
106   Char=Get_Ln(LuRd)
      Call Get_I1(1,Max_Microiterations)
      Go To 999
!*                                                                      *
!****** AIME ************************************************************
!*                                                                      *
!*     Minimum energy differences of the last two iterations
!*     (loop exit condition)
!*
!107   Char=Get_Ln(LuRd)
!      Call Get_F1(1,Thr_microiterations)
!      Go To 999
!*                                                                      *
!****** AIBL ************************************************************
!*                                                                      *
!*     Base line modification value to not ordinary
!*     (Trend Function on GEK)
!*
!108   Char=Get_Ln(LuRd)
!      Call Get_F1(1,blvAI)
!      blAI = .True.
!      Go To 999
!*                                                                      *
!****** AIMB ************************************************************
!*                                                                      *
!*     Base line modification value to maximum value of the Energy
!*     This option supersedes any value assigned to blAI
!*
!109   Char=Get_Ln(LuRd)
!      mblAI = .True.
!      Go To 999
*                                                                      *
****** TFOF ************************************************************
*                                                                      *
*     adding energy to the last energy value of the base line
*     This option supersedes any value assigned to blAI and mblAI
*
110   Char=Get_Ln(LuRd)
      Call Get_F1(1,blavAI)
      Go To 999
!*                                                                      *
!****** L-VA ************************************************************
!*                                                                      *
!*     Change the l value of the GEK.
!*
!112   Char=Get_Ln(LuRd)
!      Set_l=.True.
!      Call Get_F1(1,Value_l)
!      Call Qpg_dScalar('Value_l',Found)
!      If (.Not.Found) Call Put_dScalar('Value_l',Value_l)
!      Go To 999
*                                                                      *
****** BAKE ************************************************************
*                                                                      *
926   Baker = .True.
      Go To 999
*                                                                      *
****** SCHL ************************************************************
*                                                                      *
927   Schlegel = .True.
      Go To 999
*                                                                      *
****** DDVS ************************************************************
*                                                                      *
9271  DDV_Schlegel = .True.
      Go To 999
*                                                                      *
****** NOLA ************************************************************
*                                                                      *
930   CallLast = .False.
      Go To 999
*                                                                      *
****** NOLI ************************************************************
*                                                                      *
928   Line_Search = .False.
      Go To 999
*                                                                      *
****** LAST ************************************************************
*                                                                      *
9280  Char=Get_Ln(LuRd)
      Call LeftAd(Char)
      If (Char.eq.BLine) Go To 9280
      If (Char(1:1).eq.'*') Go To 9280
      Call UpCase(Char)
      Call Put_cArray('LastEnergyMethod',Char,8)
      Go To 999
*                                                                      *
****** LINE ************************************************************
*                                                                      *
9281  Line_Search = .True.
      Go To 999
*                                                                      *
****** HWRS ************************************************************
*                                                                      *
929   HWRS=.True.
      Go To 999
*                                                                      *
****** WIND ************************************************************
*                                                                      *
 934  Char=Get_Ln(LuRd)
      Call UpCase(Char)
      If (Char.eq.BLine) Go To 934
      If (Char(1:1).eq.'*') Go To 934
      Call Get_I1(1,nWndw)
      Go To 999
*                                                                      *
****** NEWT ************************************************************
*                                                                      *
935   Mask = iSetAll
      Mask = Mask - 2**0 - 2**1 - 2**2 - 2**3
      iOptC = iOr(2**0,iAnd(iOptC,Mask))
      Go To 999
*                                                                      *
****** C1-D ************************************************************
*                                                                      *
936   Mask = iSetAll
      Mask = Mask - 2**0 - 2**1 - 2**2 - 2**3
      iOptC = iOr(2**1,iAnd(iOptC,Mask))
      Go To 999
*                                                                      *
****** C2-D ************************************************************
*                                                                      *
937   Mask = iSetAll
      Mask = Mask - 2**0 - 2**1 - 2**2 - 2**3
      iOptC = iOr(2**2,iAnd(iOptC,Mask))
      Go To 999
*                                                                      *
****** RATI ************************************************************
*                                                                      *
938   Mask = iSetAll
      Mask = Mask - 2**0 - 2**1 - 2**2 - 2**3
      iOptC = iOr(2**3,iAnd(iOptC,Mask))
      Go To 999
*                                                                      *
****** DXDX ************************************************************
*                                                                      *
939   Mask = iSetAll
      Mask = Mask - 2**4 - 2**5 - 2**6
      iOptC = iOr(2**4,iAnd(iOptC,Mask))
      Go To 999
*                                                                      *
****** DXG  ************************************************************
*                                                                      *
940   Mask = iSetAll
      Mask = Mask - 2**4 - 2**5 - 2**6
      iOptC = iOr(2**5,iAnd(iOptC,Mask))
      Go To 999
*                                                                      *
****** GG   ************************************************************
*                                                                      *
941   Mask = iSetAll
      Mask = Mask - 2**4 - 2**5 - 2**6
      iOptC = iOr(2**6,iAnd(iOptC,Mask))
      Go To 999
*                                                                      *
****** MODE ************************************************************
*                                                                      *
*-----Mode following algorithm
942   Continue
*     Read (5,'(A)',End=9610) Char
      Char=Get_Ln(LuRd)
      If (Char.eq.BLine) Go To 942
      If (Char(1:1).eq.'*') Go To 942
      Call Get_I1(1,mode)
      Go To 999
*                                                                      *
****** NUME ************************************************************
*                                                                      *
945   lNmHss = .True.
      Go To 999
*                                                                      *
****** THER ************************************************************
*                                                                      *
9451  lNmHss = .True.
      lTherm = .True.
      Char=Get_Ln(LuRd)
      Call Get_I1(1,nsRot)
      Char=Get_Ln(LuRd)
      Call Get_F1(1,UserP)
9454  Char=Get_Ln(LuRd)
      Call UpCase(Char)
      If (Char(1:4).eq.'END ') then
         If (nUserPT.EQ.0) then
           nUserPT=1
           UserT(1)=298.15d0
         EndIf
         Go To 999
      EndIf
      nUserPT=nUserPT+1
      Call Get_F1(1,UserT(nUserPT))
      Go To 9454
*                                                                      *
****** DISO ************************************************************
*                                                                      *
9452  lDoubleIso = .True.
      Go To 999
*                                                                      *
****** CUBI ************************************************************
*                                                                      *
947   Cubic  = .True.
      Go To 999
*                                                                      *
****** DELT ************************************************************
*                                                                      *
 946  Char=Get_Ln(LuRd)
      Call Get_F1(1,Delta)
      Go To 999
*                                                                      *
****** TS   ************************************************************
*                                                                      *
 951  Mask=iSetAll - 2**7
      iOptC=iAnd(Mask,iOptC)
      Go To 999
*                                                                      *
****** EXTR ************************************************************
*                                                                      *
*     Put the program name and the time stamp onto the extract file
*
971   Write (Lu,*)
     &'RdCtl_Slapaf: EXTRACT option is redundant and is ignored!'
      Go To 999
*                                                                      *
****** NOHW ************************************************************
*                                                                      *
 960  HWRS=.False.
      Go To 999
*                                                                      *
****** RTRN ************************************************************
*                                                                      *
 962  Char = Get_Ln(LuRd)
      Call UpCase(Char)
      Call Get_I1(1,Max_Center)
      Call Get_F1(2,rtrnc)
      If (Index(Char,'ANGSTROM').ne.0) Rtrnc = Rtrnc/angstr
      Go To 999
*                                                                      *
****** FIND ************************************************************
*                                                                      *
 963  FindTS=.True.
      Go To 999
*                                                                      *
****** TSCO ************************************************************
*                                                                      *
 320  LuTS=20
      FilNam='TSC'
      LuTS=IsFreeUnit(LuTS)
      Call Molcas_Open(LuTS,FilNam)
 319  Line=Get_Ln(LuRd)
      Call UpCase(Line)
      Call LeftAd(Line)
      Write(LuTS,'(A)') Trim(Line)
      If (Line(1:4).ne.'END') Go To 319
      Close(LuTS)
      TSConstraints=.True.
      Go To 999
*                                                                      *
****** FUZZ ************************************************************
*                                                                      *
 123  Char = Get_Ln(LuRd)
      Call UpCase(Char)
      Call Get_F1(1,rFuzz)
      If (Index(Char,'ANGSTROM').ne.0) rFuzz = rFuzz/angstr
      rFuzz=Max(rFuzz,1.0D-3)
      Go To 999
*                                                                      *
****** MEP-/MEP  *******************************************************
*                                                                      *
 964  MEP=.True.
      rMEP=.False.
      Go To 999
*                                                                      *
****** NMEP/NIRC *******************************************************
*                                                                      *
 965  Char=Get_Ln(LuRd)
      Call Get_I1(1,nMEP)
      nMEP=Min(Max(nMEP,1),MaxItr)
      Go To 999
*                                                                      *
****** MEPT/IRCT *******************************************************
*                                                                      *
 321  Char=Get_Ln(LuRd)
      Call UpCase(Char)
      If (Char(1:6).eq.'SPHERE') Then
         MEP_Type='SPHERE'
      Else If (Char(1:5).eq.'PLANE') Then
         MEP_Type='TRANSVERSE'
      Else
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '********** ERROR **********'
         Write (Lu,*) ' Unrecognized MEP/IRC type.'
         Write (Lu,*) '***************************'
         Call Quit_OnUserError()
      End If
      Go To 999
*                                                                      *
****** MEPA/IRCA *******************************************************
*                                                                      *
 322  Char=Get_Ln(LuRd)
      Call UpCase(Char)
      If (Char(1:2).eq.'GS') Then
         MEP_Algo='GS'
      Else If (Char(1:2).eq.'MB') Then
         MEP_Algo='MB'
      Else
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '************* ERROR ************'
         Write (Lu,*) ' Unrecognized MEP/IRC algorithm.'
         Write (Lu,*) '********************************'
         Call Quit_OnUserError()
      End If
      Go To 999
*                                                                      *
****** MEPC/IRCC *******************************************************
*                                                                      *
 323  Char=Get_Ln(LuRd)
      Call Get_F1(1,ThrMEP)
      ThrMEP=Max(Zero,ThrMEP)
      Go To 999
*                                                                      *
****** REFE ************************************************************
*                                                                      *
 966  Call GetMem('RefGeom','Allo','Real',ipRef,3*nsAtom)
      Call Read_v(LuRd,Work(ipRef),1,3*nsAtom,1,iErr)
      If (iErr.ne.0) Then
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '************ ERROR ***************'
         Write (Lu,*) 'Error reading reference structure.'
         Write (Lu,*) '**********************************'
         Call Quit_OnUserError()
      End If
      Ref_Geom=.True.
      Go To 999
*                                                                      *
****** RS-P ************************************************************
*                                                                      *
 967  Mask=iSetAll
      Mask=Mask-2**9
      iOptC=iAnd(iOptC,Mask)
      Go To 999
*                                                                      *
****** GNRM ************************************************************
*                                                                      *
 968  Char = Get_Ln(LuRd)
      Call Get_F1(1,GNrm_Threshold)
      Go To 999
*                                                                      *
****** GRAD ************************************************************
*                                                                      *
 979  Call GetMem('ReGradient','Allo','Real',ipGradRef,nDimbc)

      Call Read_v(LuRd,Work(ipGradRef),1,nDimbc,1,iErr)
      If (iErr.ne.0) Then
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '*************** ERROR ******************'
         Write (Lu,*) 'Error reading reference gradient vector.'
         Write (Lu,*) '****************************************'
         Call Quit_OnUserError()
      End If
*
*     If there is a transverse vector stored, we are not using this one
*
      Call qpg_dArray('Transverse',Found,nRP)
      If (.Not. Found) Ref_Grad=.True.
      Go To 999
*                                                                      *
****** rMEP ************************************************************
*                                                                      *
 980  rMEP=.True.
      MEP=.False.
      Go To 999
*                                                                      *
****** rHidden *********************************************************
*                                                                      *
 988  Line = Get_Ln(LuRd)
      Call UpCase(Line)
      Call Get_F1(1,rHidden)
      If (rHidden.lt.Zero) Then
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '************ ERROR *****************'
         Write (Lu,*) 'Error reading rHidden. Should be >0.'
         Write (Lu,*) '************************************'
         Call Quit_OnUserError()
      End If
      If (Index(Line,'ANGSTROM').ne.0) rHidden = rHidden/angstr
      Go To 999
*                                                                      *
****** IRC *************************************************************
*                                                                      *
 997  Call Qpg_iScalar('IRC',Found)
      If (Found) Then
         Call Get_iScalar('IRC',IRC)
      Else
         IRC=1
         Call Put_iScalar('IRC',IRC)
      End If
      MEP=.True.
      rMEP=.False.
      Go To 999
*                                                                      *
****** MEPStep/IRCStep *************************************************
*                                                                      *
 9971 Char=Get_Ln(LuRd)
      Call UpCase(Char)
      Call Get_F1(1,dMEPStep)
*
*     Note that according to the Gonzalez-Schlegel method, only half
*     this step is used in the constraint
*
      If (Index(Char,'ANGSTROM').ne.0) dMEPStep = dMEPStep/angstr
      Go To 999
*                                                                      *
****** REAC ************************************************************
*                                                                      *
 996  Explicit_IRC=.True.
      Call GetMem('TmpRx','Allo','Real',ipTmpRx,3*nsAtom)
      Call Read_v(LuRd,Work(ipTmpRx),1,3*nsAtom,1,iErr)
      If (IErr.ne.0) Then
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '********** ERROR ***********************'
         Write (Lu,*) ' Error while reading the Reaction vector'
         Write (Lu,*) '****************************************'
         Call Quit_OnUserError()
      End If
      Go To 999
*                                                                      *
****** HRMS ************************************************************
*                                                                      *
 995  HrmFrq_Show=.True.
      Go To 999
*                                                                      *
****** CNWE ************************************************************
*                                                                      *
 990  Char=Get_Ln(LuRd)
      Call Get_F1(1,CnstWght)
      Go To 999
*                                                                      *
****** NOEM ************************************************************
*                                                                      *
 991  eMEPTest=.False.
      Go To 999
*                                                                      *
****** EXPE ************************************************************
*                                                                      *
 993  Expert=.True.
      Go To 999
*                                                                      *
****** REDU ************************************************************
*                                                                      *
 994  Redundant=.True.
      Go To 999
*                                                                      *
****** FALC ************************************************************
*                                                                      *
 800  isFalcon=.True.
      Go To 999
*                                                                      *
****** TRAC ************************************************************
*                                                                      *
 910  Track=.True.
      Go To 999
*                                                                      *
************************************************************************
************************   End of input section   **********************
************************************************************************
*                                                                      *
 998  Continue
*                                                                      *
************************************************************************
*                                                                      *
*     Now start fixing constraints.
*     First get the external constraints.
*
      If (External_UDC) Then
        Call Merge_Constraints('UDC.Gateway','','UDC',nLambda,iRow_c)
      Else
        Call Merge_Constraints('','UDC','UDC',nLambda,iRow_c)
      End If
*
*     Initial preprocessing
*
      If (iRow_c.gt.1) Then
         Lu_UDC=IsFreeUnit(20)
         Call Molcas_Open(Lu_UDC,'UDC')
         Call Preprocess_UDC(Lu_UDC,iPrint)
         Close (Lu_UDC)
      Else
         NADC=.False.
      End If
*
*     Add NAC if needed
*
      If (NADC) Then
         Lu_UDCTMP=IsFreeUnit(20)
         Call Molcas_Open(Lu_UDCTMP,'UDCTMP')
         Write(Lu_UDCTMP,*) 'NADC = NAC'
         Write(Lu_UDCTMP,*) 'VALUE'
         Write(Lu_UDCTMP,*) 'NADC = 0.0'
         Write(Lu_UDCTMP,*) 'END'
         Close (Lu_UDCTMP)
         Call Merge_Constraints('UDC','UDCTMP','UDC',nLambda,iRow_c)
      End If
*
*     Add MEP/IRC if needed
*
      If (MEP.or.rMEP.or.(Abs(IRC).eq.1)) Then
         If (Abs(IRC).eq.1) Then
           MEPLab='IRC'
         Else
           MEPLab='MEP'
         End If
         If (MEPCons.and.(.Not.Expert)) Then
            Call WarningMessage(2,'Error in RdCtl_Slapaf')
            Write (Lu,*)
            Write (Lu,*)
     &'***************** ERROR ********************'
            Write (Lu,*)
     &' There is a '//Trim(Mep_Type)//' constraint that may'
            Write (Lu,*)
     &' conflict with '//MEPLab//' calculations.'
            Write (Lu,*)
     &' You should not explictly specify this constraint,'
            Write (Lu,*)
     &' but just rely on '//MEPLab//'Step/'//MEPLab//'Type keywords.'
            Write (Lu,*)
     &' If you really know what you are doing, you'
            Write (Lu,*)
     &' can use the EXPERT keyword.'
            Write (Lu,*)
     &'********************************************'
            Call Quit_OnUserError()
         End If
         WeightedConstraints=.True.
         Valu=dMEPStep
         If (MEP_Type.eq.'SPHERE') Valu=Abs(Valu)
         If (MEP.and.(MEP_Algo.eq.'GS')) Valu=Half*Valu
         If (rMEP) Valu=Max(Dble(iMEP+1),One)*Valu
         Lu_UDCTMP=IsFreeUnit(20)
         Call Molcas_Open(Lu_UDCTMP,'UDCTMP')
         Write(Lu_UDCTMP,*) MEPLab//' = '//MEP_Type
         Write(Lu_UDCTMP,*) 'VALUE'
         Write(Lu_UDCTMP,*) MEPLab//' = ',Valu
         Write(Lu_UDCTMP,*) 'END'
         Close (Lu_UDCTMP)
         Call Merge_Constraints('UDC','UDCTMP','UDC',nLambda,iRow_c)
         Beta=Min(Beta,Abs(Valu))
         MEPnum=nLambda
      End If
*
*     Final fixes
*
      Call Fix_UDC(iRow_c,nLambda,AtomLbl,nsAtom,nStab,.True.)
*                                                                      *
************************************************************************
*                                                                      *
*     Initiate some variables which can only be set after the input has
*     been read.
*
      If ((.Not.ThrInp).and.(.Not.Baker)) ThrEne=Zero
      Call Init2
*     Gradients are not needed at the first iteration of a numerical
*     Hessian procedure (and only that, i.e. MxItr=0)
      FirstNum = (lRowH.or.lNmHss.or.Cubic)
     &           .and.(Iter.eq.1).and.(MxItr.eq.0)
      If ((SuperName.eq.'slapaf').and.(.not.FirstNum)) Then
         If (Track) Then
            Call Process_Track()
         Else
            Call Put_iArray('Root Mapping',RootMap,0)
         End If
         Call Process_Gradients()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Put in the "Reaction vector" in Cartesians.
*     Priority order:
*     1) Explicit by user input (REAC keyword)
*     2) Found on RunOld
*     3) Found on RunFile
*
      If (Abs(IRC).eq.1) Then
*
*        If this is the first macro iteration in the IRC search then
*        pick up the reaction vector.
*
         If (Explicit_IRC.and.iMEP.eq.0) Then
*           Case 1)
            call dcopy_(3*nsAtom,Work(ipTmpRx),1,Work(ipMF),1)
         Else If (iMEP.eq.0) Then
            Call NameRun('RUNOLD')
            Call qpg_dArray('Reaction Vector',Found,nRx)
C           Write (6,*) 'RUNOLD: Found=',Found
            If (Found) Then
*              Case 2)
               Call Get_dArray('Reaction Vector',Work(ipMF),3*nsAtom)
               Call NameRun('RUNFILE')
            Else
               Call NameRun('RUNFILE')
               Call qpg_dArray('Reaction Vector',Found,nRx)
C              Write (6,*) 'RUNFILE: Found=',Found
               If (Found) Then
*                 Case 3)
                  Call Get_dArray('Reaction Vector',Work(ipMF),3*nsAtom)
               Else
                  Call WarningMessage(2,'Error in RdCtl_Slapaf')
                  Write (6,*)
                  Write (6,*) '************ ERROR **************'
                  Write (6,*) 'IRC calculation but no IRC vector'
                  Write (6,*) '*********************************'
                  Call Quit_OnUserError()
               End If
            End If
         End If
*
*        Fix the direction forward/backwards
*
         If (iMEP.eq.0.and.iRC.eq.-1) Call DScal_(3*nsAtom,-1.0D0,
     &                                           Work(ipMF),1)
         If (iMEP.eq.0.and.MEP_Type.eq.'TRANSVERSE')
     &      Call Put_dArray('Transverse',Work(ipMF),3*nsAtom)
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (FindTS.and.(.Not.TSConstraints)) Then
         Call SysWarnMsg('RdCtl_Slapaf','WARNING:',
     &   'FindTS specified, but no TSConstraints. '//
     &   'It is highly recommended to use TSConstraints in SLAPAF '//
     &   'instead of (or in addition to) global constraints when '//
     &   'using FindTS. '//
     &   'TSConstraints will be lifted in the final TS search.')
      End If
      TSConstraints=TSConstraints.and.FindTS
*
      If ((MEP.or.rMEP).and.(.NOT.Request_Alaska)) Then
*
*        If no initial direction given, use the gradient (force)
*
         Call qpg_dArray('Transverse',Found,nRP)
         If (.Not.Found.And..Not.Ref_Grad) Then
*        Assume the initial reaction vector is already massaged
            If (Explicit_IRC) Then
               Call Put_dArray('Transverse',Work(ipTmpRx),3*nsAtom)
            Else
*        The direction is given by the gradient, but in weighted coordinates
               Call Allocate_Work(ipDir,3*nsAtom)
               iOff=0
               ip_Grd=ipGx+(iter-1)*3*nsAtom
               Do iAtom=1,nsAtom
                  xWeight=Work(ipWeights+iAtom-1)
                  Do ixyz=1,3
                     Work(ipDir+iOff)=Work(ip_Grd+iOff)/xWeight
                     iOff=iOff+1
                  End Do
               End Do
               Call Put_dArray('Transverse',Work(ipDir),3*nsAtom)
               Call Free_Work(ipDir)
            End If
         End If
      End If
*
      If (Explicit_IRC) Call Free_Work(ipTmpRx)
*
*     Activate MPS update of Hessian if FindTS
*
      If (FindTS) Then
*
         If (iAnd(iOptH,64).eq.64) Then
            iOptH=iOr(64,iAnd(iOptH,32)) ! EU
         Else If (iAnd(iOptH,128).eq.128) Then
            iOptH=iOr(128,iAnd(iOptH,32)) ! TS-BFGS
         Else
            iOptH=iOr(16,iAnd(iOptH,32)) ! MSP
         End If
         iOptC=iOr(iOptC,4096)
*
*------- Increase the update window so that we will not lose the update
*        which generated the negative curvature.
*
         nWndw=4*nWndw
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Modify some options if TS search
*
      If (iAnd(iOptC,128).ne.128) Then
         If (iAnd(iOptH,8).ne.8) iOptH=iOr(16,iAnd(iOptH,32)) ! MSP
         ThrB=0.01D+00
         Line_search=.False.
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     For TS optimization with the Saddle method set update to MSP
*
      Call qpg_dArray('Saddle',Found,nSaddle)
      If (Found.and.nSaddle.ne.0) Then
         Call Allocate_Work(ipTmp,nSaddle)
         Call Get_dArray('Saddle',Work(ipTmp),nSaddle)
         HSR0=Work(ipTmp+nSaddle-3)
         HSR=Work(ipTmp+nSaddle-2)
         Update=Work(ipTmp+nSaddle-1)
         If (Update.eq.2.0d0) Then
*
*           Enable FindTS procedure
*
C           Write (6,*) 'Enable FindTS procedure'
            If (iAnd(iOptH,8).ne.8) iOptH=iOr(16,iAnd(iOptH,32)) ! MSP
            nWndw=4*nWndw
*           make it look as if this were FindTS with constraints
            FindTS=.True.
            TSConstraints=.True.
            iOptC=iOr(iOptC,4096)
            iOptC=iOr(iOptC,8192)
            Beta=0.1d0
*
         Else
*
*           Normal constrained optimization with a reduced threshold.
*           Let the threshold be somewhat tighter as we are close to
*           the TS.
*
            If (HSR/HSR0.lt.0.20D0.or.HSR.lt.0.20D0) Then
*              ThrGrd=0.0003D0
               Beta=0.1d0
            Else
*              ThrGrd=0.003D0
               ThrGrd=Ten*ThrGrd
            End If
*
*           Add the constraints from the Saddle method
*
            Call Merge_Constraints('UDC','UDC.Saddle','UDC',
     &                             nLambda,iRow_c)

         End If
         Call Free_Work(ipTmp)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Modify some options if constraints are part of the calculation.
*
      If ((nLambda.gt.0).or.TSConstraints) Then
         iOptC=iOr(iOptC,256) ! Constraints
         Line_search=.False.
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     No iterations set iOptC=0
*
      If (MxItr.eq.0) iOptC=0
*                                                                      *
************************************************************************
*                                                                      *
*     Activate some additional printing for numerical Hessian
*
CGGd: Coherency with patch 7.1.615 !      If (lNmHss) nPrint(122)=10
*                                                                      *
************************************************************************
*                                                                      *
*.....Do some preprocessing due to input choice
*
      If (Request_Alaska) nPrint(51)=0
      Call PrePro(iRow,iInt,nFix,nsAtom,mInt,Work(ipCoor))
*                                                                      *
************************************************************************
*                                                                      *
*     In case of Kriging we use a sorting step in update_sl. For this
*     to work we need the values of the internal coordinates for more
*     points than the window size. Here we increase it with a factor of
*     2 temporarily. The sorted list will still be of the original size.
*     However, the default window for kriging is twice as large as
*     for conventional calculations.
*
      If (Kriging) nWndw=4*nWndw  ! 2*2=4
*                                                                      *
************************************************************************
*                                                                      *
*.....Write out input parameters, No output if we didn't find the proper
*     gradients on the runfile. We will come back!!!
*
      If (SuperName.eq.'slapaf') Then
         If (.Not.Request_Alaska) Call WrInp_sl(iRow)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      User_Def = iRow.ne.0
      If (.Not.User_Def) nBVec=1
*                                                                      *
************************************************************************
*                                                                      *
      If (lNmHss.and.lRowH) then
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
       Write (Lu,*)
       Write (Lu,*) '**************************************************'
       Write (Lu,*) ' ERROR: NUMErical and ROWH are mutually exclusive '
       Write (Lu,*) '**************************************************'
       Call Quit_OnUserError()
      EndIf
      If (lCtoF.and.User_Def) then
         Call WarningMessage(2,'Error in RdCtl_Slapaf')
         Write (Lu,*)
         Write (Lu,*) '******************************************'
         Write (Lu,*) ' ERROR: CtoF and User-defined Coordinates '
         Write (Lu,*) '        are mutually exclusive.           '
         Write (Lu,*) '******************************************'
         Call Quit_OnUserError()
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
      Return
*
      End
      Subroutine FixEqualSign(Line,LuRd)
      Character*(*) Line
      Character*180 Temp_Line
      Character*180 Get_Ln
      External Get_Ln
*
      nLine=LEN(Line)
      If (nLine.gt.LEN(Temp_Line)) Then
         Call WarningMessage(2,'Error in FixEqualSign!')
         Call Abend()
      End If
*
      Temp_Line=Line
      Call LeftAd(Temp_Line)
      ix = iCLast(Temp_Line,nLine)
      Temp_Line(ix+2:ix+2)='='
      ix = ix + 2
*
      Line=Get_Ln(LuRd)
      Call LeftAd(Line)
      iy = iCLast(Line,nLine)
      If (ix+2+iy.gt.nLine) Then
         Call WarningMessage(2,'Problems merging lines!')
         Call Abend()
      End If
      Temp_Line(ix+2:nLine) = Line(1:nLine-ix-1)
      Line = Temp_Line
      Call UpCase(Line)
*
      Return
      End
*
      Subroutine FixEqualSign2(Line,LuRd,Lu_UDIC,iRow,New_Line)
      Character*(*) Line
      Character*180 Temp_Line
      Character*180 Get_Ln
      External Get_Ln
*
      nLine=LEN(Line)
      If (nLine.gt.LEN(Temp_Line)) Then
         Call WarningMessage(2,'Error in FixEqualSign!')
         Call Abend()
      End If
*
      Temp_Line=Line
      Call LeftAd(Temp_Line)
      ix = iCLast(Temp_Line,nLine)
*                                                                      *
************************************************************************
*                                                                      *
*     Read the next line and determine if the lines should be merged.
*
      Line=Get_Ln(LuRd)
      Call LeftAd(Line)
      iy = iCLast(Line,nLine)
      Call UpCase(Line)
*                                                                      *
************************************************************************
*                                                                      *
      If (Index(Line(1:iy),'END ').eq.1) Then
         iRow = iRow + 1
         Write (Lu_UDIC,'(A)') Temp_Line
         New_Line=2
*                                                                      *
************************************************************************
*                                                                      *
*     If the line contains two or more items we should merge the lines.
*
      Else If (Index(Line(1:iy),' ').eq.0) Then
*
*        Just one item
*
         iRow = iRow + 1
         Write (Lu_UDIC,'(A)') Temp_Line
         New_Line=1
*
      Else
*                                                                      *
************************************************************************
*                                                                      *
         Temp_Line(ix+2:ix+2)='='
         ix = ix + 2
         If (ix+2+iy.gt.nLine) Then
            Call WarningMessage(2,'Problems merging lines!')
            Call Abend()
         End If
         Temp_Line(ix+2:nLine) = Line(1:nLine-ix-1)
         Line = Temp_Line
         Call UpCase(Line)
         New_Line=0
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1988, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PAMTMT(X,T,SCR,NORB)
! GENERATE PER AKE'S T MATRIX FROM AN
! ORBITAL ROTATION MATRIX X
!
! T IS OBTAINED AS A STRICTLY LOWER TRIANGULAR
! MATRIX TL AND AN UPPER TRIANGULAR MATRIX TU
!
!         TL = 1 - L
!         TU = U ** -1
!
! WHERE L AND U ARISES FROM A LU DECOMPOSITION OF
! X :
!         X = L * U
! WITH L BEING A LOWER TRIANGULAR MATRIX WITH UNIT ON THE
! DIAGONAL AND U IS AN UPPER TRIANGULAR MATRIX
!
! JEPPE OLSEN OCTOBER 1988

use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nOrb
real(kind=wp), intent(in) :: X(NORB,NORB)
real(kind=wp), intent(out) :: T(NORB,NORB), SCR(nOrb**2+nTri_Elem(nOrb))
integer(kind=iwp) :: I, ISING, J, KLFREE, KLL, KLU

#ifdef _DEBUGPRINT_
write(u6,*) ' Welcome to PAMTMT'
write(u6,*) ' ================='
write(u6,*)
#endif
! Allocate local memory
KLFREE = 1
!KLL = KFLREE
KLL = KLFREE
KLFREE = KLL+nTri_Elem(NORB)
KLU = KLFREE
KLFREE = KLU+NORB**2
! LU factorize X
call LULU(X,SCR(KLL),SCR(KLU),NORB)
! Expand U to full matrix
T(:,:) = Zero
do I=1,NORB
  do J=I,NORB
    T(I,J) = SCR(KLU-1+nTri_Elem(J-1)+I)
  end do
end do
#ifdef _DEBUGPRINT_
write(u6,*) ' MATRIX TO BE INVERTED'
call WRTMAT(T,NORB,NORB,NORB,NORB)
#endif
! Invert U
call INVMAT(T,SCR(KLU),NORB,ISING)
#ifdef _DEBUGPRINT_
write(u6,*) ' INVERTED MATRIX'
call WRTMAT(T,NORB,NORB,NORB,NORB)
#endif
! Subtract L
do I=1,NORB
  do J=1,I-1
    T(I,J) = -SCR(KLL-1+nTri_Elem(I-1)+J)
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' INPUT X MATRIX'
call WRTMAT(X,NORB,NORB,NORB,NORB)
write(u6,*) ' T MATRIX'
call WRTMAT(T,NORB,NORB,NORB,NORB)
#endif

end subroutine PAMTMT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
************************************************************************
      SUBROUTINE CNFORD(ICTSDT,ICONF,
     *           IREFSM,NORB,IPRODT,NCNFTP,
     *           NEL,ICNSTR,IGENSG,ISGNA,ISGNB,IAGRP,IBGRP,IOOS,
     *           NORB1,NORB2,NORB3,NEL1MN,NEL3MX,NAEL,NBEL,MINOP,MAXOP,
     *           PSSIGN,IPRNT)
*
* Generate configurations in ICONF
*
* Generate determinants in configuration order and obtain
* sign array for switching between the two formats .
*
* Jeppe Olsen January 1989
*
* December 1990 : ICNFOK added
* September 1993 : Combinations added
*
* NCNFCN .ne. 0 indicates that additional constraints on configurations
* should be checked
* by calling CICNCH.ICNFOK(ICNF) is 1 of tests are passed, ICNFOK(ICNF)
* is zero if test fails
* IGENSG .ne. 0 assumes general signs of strings given in ISGNA,ISGNB
      IMPLICIT REAL*8 (A-H,O-Z)
*.Specific input
      DIMENSION ISGNA(*),ISGNB(*)
      DIMENSION ICONF(*),NCNFTP(*)
      DIMENSION IOOS(*)
*.General input
      INTEGER IPRODT(*)
*.Output
      DIMENSION ICTSDT(*)
*.Scratch
#include "WrkSpc.fh"
#include "dmrginfo_mclr.fh"
* NOTE : NCNFTP IS COLUMN FOR SYMMETRY GIVEN , NOT COMPLETE MATRIX.
* Dim of IWORK : MAX(3*NORB,(MXDT+2)*NEL),
* where MXDT is the largest number of prototype determinants of
* a given type.
*
* ================================================================
*. Construct list of configurations,offset for each configuration
*   and type for each configuration
* ================================================================
*

      CALL GETMEM('KSCR11','ALLO','INTEGER',KL1,NORB1+NORB2+NORB3)
      CALL GETMEM('KSCR12','ALLO','INTEGER',KL2,NORB1+NORB2+NORB3)
      CALL GETMEM('KSCR13','ALLO','INTEGER',KL3,NORB1+NORB2+NORB3)
      CALL CONFG2(NORB1,NORB2,NORB3,NEL1MN,NEL3MX,
     *            MINOP,MAXOP,IREFSM,NEL,ICONF,
     *            NCNFTP,IWORK(KL1),IWORK(KL2),IWORK(KL3),IPRNT)
      CALL GETMEM('KSCR13','FREE','INTEGER',KL3,NORB1+NORB2+NORB3)
      CALL GETMEM('KSCR12','FREE','INTEGER',KL2,NORB1+NORB2+NORB3)
      CALL GETMEM('KSCR11','FREE','INTEGER',KL1,NORB1+NORB2+NORB3)
*
* =========================================================
* Obtain determinants for each configuration and determine
* the corresponding adress and phaseshift to reform into
* string form and ordering.
* ==========================================================
*
      CALL CNTOST(ICONF,ICTSDT,NAEL,NBEL,
     &            IPRODT,IREFSM,
     &            NORB,NEL,
     &            IGENSG,ISGNA,ISGNB,ICNSTR,IAGRP,IBGRP,IOOS,PSSIGN,
     &            IPRNT)
      RETURN
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE CNTOST(ICONF,ICTSDT,NAEL,NBEL,
     &                 IPRODT,IREFSM,
     &                 NORB,NEL,
     &                 IGENSG,ISGNA,ISGNB,ICNSTR,IAGRP,IBGRP,IOOS,
     &                 PSSIGN,IPRNT)

*
* Obtain pointer abs(ICTSDT(I)) giving adress of determinant I in
* STRING ordering for determinant I in CSF ordering.
* Going between the two formats can involve a sign change . this is
* stored in the sign of ICTSDT)
* SGNCTS is thus to be multiplied with vector ordered in CSF ordering.
*
* December 1990 : NCNFCN,ICNFOK added
* January 1991  : IGENSG,ISGNA,ISGNB added
* April   1991  : LUCIA version
* September 1993 > Sign and address stored together
*
* ICNSTR .ne. 0 indicates that additional constraints on configurations
* should be checked  (IS = 0 )
* by calling CICNCH.ICNFOK(ICNF) is 1 of tests are passed, ICNFOK(ICNF)
* is zero if test fails
      IMPLICIT REAL*8 (A-H,O-Z)

      DIMENSION ICONF(*),IPRODT(*)
      DIMENSION ICTSDT(*)
      DIMENSION ISGNA(*),ISGNB(*)
      DIMENSION IOOS(*)
C
C IWORK should at least be of length (MXDT+2)*NEL,
C where MXDT is the largest number of prototype determinants occuring
C in a single block.
C
*./SPINFO/
#include "detdim.fh"
#include "spinfo_mclr.fh"
#include "WrkSpc.fh"
#include "dmrginfo_mclr.fh"
*
       NEL = NAEL + NBEL
       NTEST=0000

C.. Local memory
C
C Largest number of dets for a given type
      MXDT = 0
      DO 10 ITYP = 1, NTYP
        MXDT   = MAX(MXDT,NDPCNT(ITYP) )
   10 CONTINUE
      CALL GETMEM('KSCR20','ALLO','INTEGER',KLDTBL,MXDT*NEL)
      CALL GETMEM('KSCR21','ALLO','INTEGER',KLIA,NAEL)
      CALL GETMEM('KSCR22','ALLO','INTEGER',KLIB,NBEL)
      CALL GETMEM('KSCR23','ALLO','INTEGER',KSCR23,NEL)
C
C.. Loop over configurations and generate determinants in compact form
C
      ICNF = 0
      IDT  = 0
      JDTABS = 0
      IPSFAC=0 ! Removes a compiler error
      ISGNAB=0 ! Removes a compiler error
      ICNBS0=0 ! dummy initialize
      IPBAS =0 ! dummy initialize
      ijkl_num =0 !yma counter
      DO 1000 ITYP = 1, NTYP
        IDET = NDPCNT(ITYP)
        IOPEN = ITYP + MINOP - 1
        ICL = (NEL - IOPEN) / 2
        IOCC = IOPEN + ICL
        IF( ITYP .EQ. 1 ) THEN
          ICNBS0 = 1
        ELSE
          ICNBS0 = ICNBS0 + NCNATS(ITYP-1,IREFSM)*(NEL+IOPEN-1)/2
        END IF
C Base for prototype determinants
        IF( ITYP .EQ. 1 ) THEN
          IPBAS = 1
        ELSE
          IPBAS = IPBAS + NDPCNT(ITYP-1)*(IOPEN-1)
        END IF
* Determinants for this configuration
        DO 900  IC = 1, NCNATS(ITYP,IREFSM)
          ICNF = ICNF + 1
          ICNBS = ICNBS0 + (IC-1)*(IOPEN+ICL)
*. Check orbital occupancy with additional constraints
          IF( NTEST .GE. 10 ) WRITE(6,*) ' IC ICNF ICNBS',IC,ICNF,ICNBS
          CALL CNDET(ICONF(ICNBS),IPRODT(IPBAS),IDET,
     &               NEL,IOCC,IOPEN,ICL, IWORK(KLDTBL),IPRNT)
C Separate determinants into strings and determine string number .
          DO 800 JDET = 1,IDET
!            write(117,"(1X,I8,1X,A,1X)",advance='no')ITYP,"ITYP"  ! yma
            JDTABS = JDTABS + 1
            CALL DETSTR_MCLR(IWORK(KLDTBL+(JDET-1)*NEL),IWORK(KLIA),
     &      IWORK(KLIB),NEL,NAEL,NBEL,NORB,ISIGN,IWORK(KSCR23),IPRNT)
            ijkl_num=ijkl_num+1
* Find number (and sign)of this determinant in string ordering
            ICTSDT(JDTABS) =
     &      IABNUM(IWORK(KLIA),IWORK(KLIB),IAGRP,IBGRP,IGENSG,
     &             ISGNA,ISGNB,ISGNAB,IOOS,NORB,IPSFAC,PSSIGN,
     &             IPRNT)
             IF(  DBLE(ISIGN*ISGNAB*IPSFAC) .eq. -1.0d0)then
               ICTSDT(JDTABS) = - ICTSDT(JDTABS)
             END IF
  800     CONTINUE
  900   CONTINUE
 1000 CONTINUE
      CALL GETMEM('KSCR23','FREE','INTEGER',KSCR23,NEL)
      CALL GETMEM('KSCR22','FREE','INTEGER',KLIB,NBEL)
      CALL GETMEM('KSCR21','FREE','INTEGER',KLIA,NAEL)
      CALL GETMEM('KSCR20','FREE','INTEGER',KLDTBL,MXDT*NEL)

C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(ICNSTR)
      END
      FUNCTION IABNUM(IASTR,IBSTR,IAGRP,IBGRP,IGENSG,
     &                ISGNA,ISGNB,ISGNAB,IOOS,NORB,IPSFAC,PSSIGN,
     &                IPRNT)
*
* Encapsulation routine for IABNUS
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IASTR(*),IBSTR(*)
      DIMENSION ISGNA(*),ISGNB(*)
#include "detdim.fh"
#include "strinp_mclr.fh"
#include "stinf_mclr.fh"
#include "strbas_mclr.fh"
#include "WrkSpc.fh"
      DIMENSION IOOS(NOCTYP(IAGRP),NOCTYP(IBGRP),*)
*
      IABNUM = IABNUS(IASTR,NELEC(IAGRP),iWORK(KSTREO(IAGRP)),
     &         iWORK(KSTCL(IAGRP)),iWORK(KSTSM(IAGRP)),
     &             NOCTYP(IAGRP),
     &         iWORK(KZ(IAGRP)),iWORK(KISTSO(IAGRP)),
     &         iWORK(KNSTSO(IAGRP)),
     &                IBSTR,NELEC(IBGRP),iWORK(KSTREO(IBGRP)),
     &         iWORK(KSTCL(IBGRP)),iWORK(KSTSM(IBGRP)),NOCTYP(IBGRP),
     &         iWORK(KZ(IBGRP)),iWORK(KISTSO(IBGRP)),
     &     iWORK(KNSTSO(IBGRP)),
     &         IOOS,NORB,IGENSG,ISGNA,ISGNB,ISGNAB,PSSIGN,IPSFAC,
     &         IPRNT)
      RETURN
      END
      FUNCTION IABNUS(IASTR,NAEL,IAORD,ITPFSA,ISMFSA,NOCTPA,ZA,
     &                ISSOA,NSSOA,
     &                IBSTR,NBEL,IBORD,ITPFSB,ISMFSB,NOCTPB,ZB,
     &                ISSOB,NSSOB,
     &                IOOS,NORB,IGENSG,ISGNA,ISGNB,ISGNAB,
     &                PSSIGN,IPSFAC,IPRNT)
*
* A determinant is given by strings IASTR,IBSTR .
* Find number of this determinant
*
* If PSSIGN .ne. 0, the determinant with higher alpha number is picked
* and phase factor IPSFAC calculated. This corresponds to
* configuration order
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IASTR(NAEL),IBSTR(NBEL)
      DIMENSION IAORD(*),IBORD(*)
      INTEGER ZA(*),ZB(*)
      INTEGER NSSOA(NOCTPA,*),NSSOB(NOCTPB,*)
      INTEGER ISSOA(NOCTPA,*),ISSOB(NOCTPB,*)
      INTEGER IOOS(NOCTPA,NOCTPB,*)
      INTEGER ISGNA(*),ISGNB(*)
      INTEGER ITPFSA(*),ITPFSB(*)
      INTEGER ISMFSA(*),ISMFSB(*)
*
* Jeppe Olsen
*
      NTEST =  000
      NTEST = MAX(NTEST,IPRNT)
      IF( NTEST .GT. 300) THEN
       WRITE(6,*) ' >>> IABNUS SPEAKING <<< '
       WRITE(6,*) ' NOCTPA,NOCTPB ', NOCTPA,NOCTPB
       WRITE(6,*) ' ALPHA AND BETA STRING '
       CALL IWRTMA(IASTR,1,NAEL,1,NAEL)
       CALL IWRTMA(IBSTR,1,NBEL,1,NBEL)
      END IF
*.Number of alpha- and beta-string
C             ISTRNM(IOCC,NORB,NEL,Z,NEWORD,IREORD)
      IANUM = ISTRNM(IASTR,NORB,NAEL,ZA,IAORD,1)
      IBNUM = ISTRNM(IBSTR,NORB,NBEL,ZB,IBORD,1)
      IF( NTEST .GE. 10 ) WRITE(6,*) ' IANUM AND IBNUM ',IANUM,IBNUM
*
      IF(IGENSG.NE.0) THEN
        ISGNAB = ISGNA(IANUM)*ISGNB(IBNUM)
      ELSE
        ISGNAB = 1
      END IF
*. Symmetries and types
      IASYM = ISMFSA(IANUM)
      IBSYM = ISMFSB(IBNUM)
C?    IF( NTEST .GE.10) WRITE(6,*) ' IASYM IBSYM ',IASYM,IBSYM
      IATP = ITPFSA(IANUM)
      IBTP = ITPFSB(IBNUM)
C?    IF(NTEST.GE.10) WRITE(6,*) ' IATP,IBTP ', IATP,IBTP
      IAREL = IANUM - ISSOA(IATP,IASYM)+1
      IBREL = IBNUM - ISSOB(IBTP,IBSYM)+1
C?    IF(NTEST .GE.10) WRITE(6,*) ' IAREL IBREL ', IAREL,IBREL
*
      IF(PSSIGN.EQ.0.0D0) THEN
*.      Normal determinant ordering
        IABNUS = IOOS(IATP,IBTP,IASYM)
     &         + (IBREL-1)*NSSOA(IATP,IASYM) + IAREL - 1
        IPSFAC = 1
      ELSE IF (PSSIGN .NE. 0.0D0 ) THEN
*.      Ensure mapping to proper determinant in combination
        IF(IANUM.GE.IBNUM) THEN
*.        No need for switching around so
          IF(IASYM.EQ.IBSYM .AND. IATP. EQ. IBTP ) THEN
*.          Lower triangular packed, column wise !
            IABNUS = IOOS(IATP,IBTP,IASYM)  -1
     &             + (IBREL-1)*NSSOA(IATP,IASYM) + IAREL
     &             -  IBREL*(IBREL-1)/2
          ELSE
            IABNUS = IOOS(IATP,IBTP,IASYM)
     &             + (IBREL-1)*NSSOA(IATP,IASYM) + IAREL - 1
          END IF
          IPSFAC = 1
        ELSE IF (IBNUM .GT. IANUM ) THEN
*. Switch alpha and beta string around
          IF(IASYM.EQ.IBSYM .AND. IATP. EQ. IBTP ) THEN
*. Lower triangular packed, column wise !
            IABNUS = IOOS(IBTP,IATP,IBSYM)  -1
     &             + (IAREL-1)*NSSOB(IBTP,IBSYM) + IBREL
     &             -  IAREL*(IAREL-1)/2
          ELSE
            IABNUS = IOOS(IBTP,IATP,IBSYM)
     &             + (IAREL-1)*NSSOB(IBTP,IBSYM) + IBREL
     &             -  1
          END IF
          IPSFAC = nInt(PSSIGN)
        END IF

      END IF
*
COLD
COLD    IABNUS = IOOS(IATP,IBTP,IASYM) + (IBREL-1)*NSSOA(IATP,IASYM)
COLD &           + IAREL - 1
C?    IF(NTEST .GT. 10 ) then
C?      WRITE(6,*) ' IOOS NSSOA ',IOOS(IATP,IBTP,IASYM),
C?   &              NSSOA(IATP,IASYM)
C?    END IF
*
      IF ( NTEST .GE.200) THEN
         WRITE(6,*) ' ALPHA AND BETA STRING '
         CALL IWRTMA(IASTR,1,NAEL,1,NAEL)
         CALL IWRTMA(IBSTR,1,NBEL,1,NBEL)
         WRITE(6,*) ' Corresponding determinant number ', IABNUS
      END IF

!      write(117,"(A,1X,I20)",advance='no')" SD_number",IABNUS ! yma
!      write(117,*)

*
      RETURN
      END

*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      Subroutine CsfInf(lSym,iSpin,MS,iSPC,iPrnt,nsym)
*
      Implicit Real*8 (A-H,O-Z)
*
#include "cstate_mclr.fh"
#include "detdim.fh"
#include "strinp_mclr.fh"
#include "strbas_mclr.fh"
#include "stinf_mclr.fh"
#include "orbinp_mclr.fh"
#include "csm.fh"
#include "cicisp_mclr.fh"
#include "csfbas_mclr.fh"
#include "spinfo_mclr.fh"
#include "cands.fh"
#include "WrkSpc.fh"
#include "Files_mclr.fh"
      integer idum(1)
*     COMMONBLOCK THE SUPPORT STORAGE OF REORDERING VECTOR
*     ON DISK
#include "csfsd.fh"

*
*
C.... Sorry about this  but this is just to tell the program
C     that no CSF<->SD coefficents is in core
      i1=-9
      iAnders=-9
      ICSM   = lSym
      ISSM   = lSym
      ICSPC  = 1
      ISSPC  = 1
      XNDET   = XISPSM(IsSM,Ispc)
      NEL    = NELCI(ISPC)
      IATP   = IASTFI(ISPC)
      IBTP   = IBSTFI(ISPC)
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
      MNELR1 = MNR1IC(ISPC)
      MXELR3 = MNR1IC(ISPC)
      iRefSm=lsym
*.... Obtain OOS pointer array
*     strbas_mclr.fh
      CALL GETMEM('SIOIO ','ALLO','INTE',KSIOIO,NOCTPA*NOCTPB)
      CALL IAIBCM_MCLR(MNR1IC(ISSPC),MXR3IC(ISSPC),NOCTPA,NOCTPB,
     &            IWORK(KEL1(IATP)),IWORK(KEL3(IATP)),
     &            IWORK(KEL1(IBTP)),IWORK(KEL3(IBTP)),
     &            iWORK(KSIOIO),IPRNT)
      CALL GETMEM('SBLTP','ALLO','INTE',KSBLTP,NSMST)
      NOOS = NOCTPA*NOCTPB*NSMST
      CALL GETMEM('IOOS1','ALLO','INTEGER',KIOOS1,NOOS)
      CALL GETMEM('NOOS1','ALLO','INTEGER',KNOOS1,NOOS)
      CALL INTCSF(NACOB,NEL,iSpin,MS2,
     &            NORB1,NORB2,NORB3,MNELR1,MXELR3,
     &            LLCSF,1,0,PSSIGN,IPRNT,lconf,lldet)
*
*     Calculate CG COEFFICENTS ETC
*
      CALL CSDTMT(IWORK(KDFTP),IWORK(KCFTP),
     &            WORK(KDTOC),PSSIGN,IPRNT)

*
*     Calculate the reordering vector and write it to disk
*

      iA=0
      Do iSym=1,nSym
*.OOS arrayy
          CALL ZBLTP(ISMOST(1,ISYM),NSMST,IDC,iWORK(KSBLTP),idum)
          CALL ZOOS(ISMOST(1,ISYM),iWORK(KSBLTP),
     &          NSMST,iWORK(KSIOIO),
     &          IWORK(KNSTSO(IATP)),IWORK(KNSTSO(IBTP)),
     &          NOCTPA,NOCTPB,idc,IWORK(KIOOS1),
     &          IWORK(KNOOS1),NCOMB,0)
*EAW           CALL CNFORD(IWORK(KICTS(1)),iWORK(KICONF(1)),
*    &          iSym,NACOB,IWORK(KDFTP),
*    &          NCNATS(1,ISYM),NEL,0,0,IDUM,IDUM,
*    &          IASTFI(ISPC),IBSTFI(ISPC),IWORK(KIOOS1),
*    &          NORB1,NORB2,NORB3,MNELR1,MXELR3,
*    &          NELEC(IASTFI(ISPC)),NELEC(IBSTFI(ISPC)),
*    &          MINOP,MAXOP,IPRNT)
           CALL CNFORD(IWORK(KICTS(1)),iWORK(KICONF(1)),
     &          iSym,NACOB,IWORK(KDFTP),
     &          NCNATS(1,ISYM),NEL,0,0,IDUM,IDUM,
     &          IASTFI(ISPC),IBSTFI(ISPC),IWORK(KIOOS1),
     &          NORB1,NORB2,NORB3,MNELR1,MXELR3,
     &          NELEC(IASTFI(ISPC)),NELEC(IBSTFI(ISPC)),
     &          MINOP,MAXOP,PSSIGN, IPRNT)
*
           CALL iDAFILE(LUCSF2SD,1,IWORK(KICTS(1)),lldet,iA)
           CALL iDAFILE(LUCSF2SD,1,IWORK(KICONF(1)),lconf,iA)
      End Do
*
*
      CALL GETMEM('KICTS','FREE','INTEGER',KICTS(1),NOOS)
      CALL GETMEM('KICONF','FREE','INTEGER',KICONF(1),NOOS)
      CALL GETMEM('IOOS1','FREE','INTEGER',KIOOS1,NOOS)
      CALL GETMEM('NOOS1','FREE','INTEGER',KNOOS1,NOOS)
      CALL GETMEM('SBLTP','FREE','INTE',KSBLTP,NSMST)
*     CALL GETMEM('KDFTP','FREE','INTE',KDFTP,NSMST)
*     strbas_mclr.fh
      CALL GETMEM('SIOIO ','FREE','INTE',KSIOIO,NOCTPA*NOCTPB)
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(MS)
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE CSFDET(NOPEN,IDET,NDET,ICSF,NCSF,CDC,PSSIGN,
     &                  IPRCSF)

* Expand csf's in terms of combinations with
* the use of the Graebenstetter method ( I.J.Q.C.10,P142(1976) )
*
* Input :
*         NOPEN : NUMBER OF OPEN ORBITALS
*         IDET  : OCCUPATION OF combinations
*         NDET  : NUMBER OF combinations
*         ICSF  : INTERMEDIATE SPIN COUPLINGS OF
*                 CSF'S IN BRANCHING DIAGRAM
* Output :
*         CDC :  NDET X NCSF MATRIX
*                GIVING EXPANSION FROM COMB'S TO CSF,S
*                CSF BASIS = Comb basis *CDC
*
* If combinations are use ( signaled by PSSIGN .ne. 0 )
* the factors are multiplies with sqrt(2), corresponding to
* a combination being 1/sqrt(2) times the sum or difference of two
* determinants
*
* The terms are not mutiplied with any sqrt(2), so the transformation is to
* the determinant normalization
*
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
      DIMENSION IDET(NOPEN,NDET),ICSF(NOPEN,NCSF)
      DIMENSION CDC(NDET,NCSF)

      NTEST = 0000
      NTEST = MAX(IPRCSF,NTEST)
      IF(PSSIGN.EQ.0.0D0) THEN
       CMBFAC = 1.0D0
      ELSE
       CMBFAC = SQRT(2.0D0)
      END IF
      CALL GETMEM('KSCR8','ALLO','REAL',KLMDET,NDET*NOPEN)
      CALL GETMEM('KSCR9','ALLO','REAL',KLSCSF,NDET*NOPEN)
C
C.. OBTAIN INTERMEDIATE VALUES OF MS FOR ALL DETERMINANTS
      DO 10 JDET = 1, NDET
        CALL MSSTRN(IDET(1,JDET),WORK(KLMDET+(JDET-1)*NOPEN),NOPEN)
   10 CONTINUE

C
      DO 1000 JCSF = 1, NCSF
       IF( NTEST .GE. 105 ) WRITE(6,*) ' ....Output for CSF ',JCSF
C
C OBTAIN INTERMEDIATE COUPLINGS FOR CSF
      CALL MSSTRN(ICSF(1,JCSF),WORK(KLSCSF),NOPEN)
C
      DO 900 JDET = 1, NDET
C EXPANSION COEFFICIENT OF DETERMINANT JDET FOR CSF JCSF
      COEF = 1.0D0
      SIGN = 1.0D0
      JDADD = (JDET-1)*NOPEN
      DO 700 IOPEN = 1, NOPEN
C
C + + CASE
        IF(ICSF(IOPEN,JCSF).EQ.1.AND.IDET(IOPEN,JDET).EQ.1) THEN
          COEF = COEF *
     &    (WORK(KLSCSF-1+IOPEN)+WORK(KLMDET-1+JDADD+IOPEN) )
     &    /(2.0D0*WORK(KLSCSF-1+IOPEN) )
        ELSE IF(ICSF(IOPEN,JCSF).EQ.1.AND.IDET(IOPEN,JDET).EQ.0) THEN
C + - CASE
          COEF = COEF *
     &    (WORK(KLSCSF-1+IOPEN)-WORK(KLMDET-1+JDADD+IOPEN) )
     &    /(2.0D0*WORK(KLSCSF-1+IOPEN) )
        ELSE IF(ICSF(IOPEN,JCSF).EQ.0.AND.IDET(IOPEN,JDET).EQ.1) THEN
C - + CASE
          COEF = COEF *
     &    (WORK(KLSCSF-1+IOPEN)-WORK(KLMDET-1+JDADD+IOPEN) +1.0D0)
     &    /(2.0D0*WORK(KLSCSF-1+IOPEN)+2.0D0 )
          SIGN  = - SIGN
        ELSE IF(ICSF(IOPEN,JCSF).EQ.0.AND.IDET(IOPEN,JDET).EQ.0) THEN
C - - CASE
          COEF = COEF *
     &    (WORK(KLSCSF-1+IOPEN)+WORK(KLMDET-1+JDADD+IOPEN) +1.0D0)
     &    /(2.0D0*WORK(KLSCSF-1+IOPEN)+2.0D0 )
        END IF
  700 CONTINUE
       CDC(JDET,JCSF) = SIGN * CMBFAC * SQRT(COEF)
  900 CONTINUE
 1000 CONTINUE
C
      CALL GETMEM('KSCR9','FREE','REAL',KLSCSF,NDET*NOPEN)
      CALL GETMEM('KSCR8','FREE','REAL',KLMDET,NDET*NOPEN)
*
      IF( NTEST .GE. 5 ) THEN
        WRITE(6,*)
        WRITE(6,'(A,2I2)')
     &  '  The CDC array for  NOPEN ',NOPEN
        WRITE(6,*)
        CALL WRTMAT(CDC,NDET,NCSF,NDET,NCSF)
      END IF

C
      RETURN
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE SPNCOM(iwork,NOPEN,MS2,NDET,IABDET,
     &                  IABUPP,IFLAG,PSSIGN,IPRCSF)
*
* Combinations of nopen unpaired electrons.Required
* spin projection MS2/2.
* JO 21-7-84
*    IFLAG = 1 : Only combinations ( in IABDET )
*    IFLAG = 2 : combinations and upper dets
*    IFLAG = 3 : Only upper dets
* A few revisions october 1988
* Upper dets added feb 1989
* Changed to combinations June 1992
*
* If PSSIGN differs from 0, spin combinations are assumed.
* we select as the unique determinants those with first electron
* having alpha spin
*
      INTEGER ADD
      DIMENSION IABDET(NOPEN,*),IABUPP(NOPEN,*)
      DIMENSION IWORK(*)
      REAL*8 PSSIGN
*
* LENGTH OF IWORK MUST BE AT LEAST NOPEN
*
      NDET=0
      NUPPER = 0
*
* Determinants are considered as binary numbers,1=alpha,0=beta
*
      MX=2 ** NOPEN
      CALL ISETVC(IWORK,0,NOPEN+1)
* Loop over all possible binary numbers
      DO 200 I=1,MX
C.. 1 : NEXT BINARY NUMBER
        ADD=1
        J=0
  190   CONTINUE
        J=J+1
        IF(IWORK(J).EQ.1) THEN
          IWORK(J)=0
        ELSE
          IWORK(J)=1
          ADD=0
        END IF
        IF( ADD .EQ. 1 ) GOTO 190
C
C.. 2 :  CORRECT SPIN PROJECTION ?
        NALPHA=0
        DO 180 J=1,NOPEN
          NALPHA=NALPHA+IWORK(J)
  180   CONTINUE
C
        IF(2*NALPHA-NOPEN.EQ.MS2.AND.
     &    .NOT.(PSSIGN.NE.0.0D0 .AND. IWORK(1).EQ.0)) THEN
          IF (IFLAG .LT. 3 ) THEN
            NDET=NDET+1
            CALL ICOPVE(IWORK,IABDET(1,NDET),NOPEN)
          END IF
          IF (IFLAG .GT. 1 ) THEN
C UPPER DET ?
            MS2L = 0
            LUPPER = 1
C
            DO 10 IEL = 1,NOPEN
              IF (IWORK(IEL).EQ.1) THEN
                 MS2L = MS2L + 1
              ELSE
                 MS2L = MS2L - 1
              END IF
              IF( MS2L .LT. 0 ) LUPPER = 0
   10       CONTINUE
            IF( LUPPER .EQ. 1 ) THEN
              NUPPER = NUPPER + 1
              CALL ICOPVE(IWORK,IABUPP(1,NUPPER),NOPEN)
            END IF
          END IF
        END  IF
C
  200 CONTINUE
C
*     XMSD2=DBLE(MS2)/2
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(IPRCSF)
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE CSDTMT(IDFTP,ICFTP,DTOC,PSSIGN,IPRNT)
*
* Construct list of prototype combinations in IDFTP
* Construct list of prototype CSF'S, in ICFTP
* Construct matrix expanding prototype CSF's in terms of
* prototype combinations in DTOC
*
*
      IMPLICIT REAL*8 (A-H,O-Z)
#include "detdim.fh"
#include "spinfo_mclr.fh"
#include "WrkSpc.fh"
      DIMENSION IDFTP(*),ICFTP(*),DTOC(*)
*./SPINFO/
*

      MULTS = MULTSP
      MS2 = MS2P
*
**.. Set up determinants and upper determinants
*
      IDTBS = 0 ! dummy initialize
      ICSBS = 0 ! dummy initialize
      DO 20 ITP = 1, NTYP
        IOPEN = MINOP+ITP-1
        IF( ITP .EQ. 1 ) THEN
          IDTBS = 1
          ICSBS = 1
        ELSE
          IDTBS = IDTBS + (IOPEN-1)*NDPCNT(ITP-1)
          ICSBS = ICSBS + (IOPEN-1)*NCPCNT(ITP-1)
        END IF
*
        IF( IOPEN .NE. 0 ) THEN
          CALL GETMEM('ISCR7','ALLO','INTEGER',KSCR7,IOPEN+1)
*. Proto type determinants and upper determinants
          IF( MS2+1 .EQ. MULTS ) THEN
            IFLAG = 2
            CALL SPNCOM(iwork(kscr7),IOPEN,MS2,NNDET,IDFTP(IDTBS),
     &                  ICFTP(ICSBS),IFLAG,PSSIGN,IPRNT)
          ELSE
            IFLAG = 1
            CALL SPNCOM(iwork(kscr7),IOPEN,MS2,NNDET,IDFTP(IDTBS),
     &                  ICFTP(ICSBS),IFLAG,PSSIGN,IPRNT)
            IFLAG = 3
            CALL SPNCOM(iwork(kscr7),IOPEN,MULTS-1,NNDET,IDFTP(IDTBS),
     &                  ICFTP(ICSBS),IFLAG,PSSIGN,IPRNT)
          END IF
          CALL GETMEM('ISCR7','FREE','INTEGER',KSCR7,IOPEN+1)
        END IF
   20 CONTINUE
*. Matrix expressing csf's in terms of combinations
      ICDCBS =0 ! dummy initialize
      DO 30 ITP = 1, NTYP
        IOPEN = MINOP+ITP-1
        IF( ITP .EQ. 1 ) THEN
          IDTBS = 1
          ICSBS = 1
          ICDCBS =1
        ELSE
          IDTBS = IDTBS + (IOPEN-1)*NDPCNT(ITP-1)
          ICSBS = ICSBS + (IOPEN-1)*NCPCNT(ITP-1)
          ICDCBS = ICDCBS + NDPCNT(ITP-1)*NCPCNT(ITP-1)
        END IF
        IF(NDPCNT(ITP)*NCPCNT(ITP).EQ.0) GOTO 30
        IF(IOPEN .EQ. 0 ) THEN
          DTOC(ICDCBS) = 1.0D0
        ELSE
          CALL CSFDET(IOPEN,IDFTP(IDTBS),NDPCNT(ITP),
     &               ICFTP(ICSBS),NCPCNT(ITP),DTOC(ICDCBS),
     &               PSSIGN,IPRNT)
        END IF
   30 CONTINUE
*

      RETURN
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE INTCSF(NACTOB,NACTEL,MULTP,MS2,NORB1,NORB2,NORB3,
     &                  NEL1MN,NEL3MX,
     &                  LLCSF,NCNSM,ICNSTR,PSSIGN,
     &IPRNT,lconf,lldet)

*
* Initializing routine for CSF-DET expansions of internal space
*
* Set up common block /CSFDIM/
* This gives information about the number of dets,csf's for
* each symmetry
*
* find local memory requirements for CSF routines
* Largest local memory requirements in CNFORD,CSFDET is returned in
* LLCSF
*
* DETERMINE BASE ADRESSES /CSFBAS/
*             KDFTP : OPEN SHELL DETERMINANTS OF PROTO TYPE
*             KCFTP : BRANCHING DIAGRAMS FOR PROTO TYPES
*             KDTOC  : CSF-DET TRANSFORMATION FOR PROTO TYPES
*             KICONF(I) : SPACE FOR STORING  NCNSM
*                        CONFIGURATION EXPANSIONS
*
* If PSSIGN .ne. 0, spin combinations are used !!

      IMPLICIT REAL*8 (A-H,O-Z)
#include "detdim.fh"
#include "spinfo_mclr.fh"
#include "WrkSpc.fh"
#include "csfbas_mclr.fh"
#include "dmrginfo_mclr.fh"
*
* Last modification : Sept 20 : sign and address of dets goes together
*                      in KICTS
      NTEST = 000
      NTEST = MAX(NTEST,IPRNT)
*
      IF(PSSIGN.NE.0.0D0) THEN
       IMSCMB = 1
      ELSE
       IMSCMB = 0
      END IF
*
**. Define parameters in SPINFO
*
      MULTSP = MULTP
      MS2P = MS2
      MULTS = MULTSP

      NEL = NACTEL
* ================================
*. Allowed number of open orbitals
* ================================
      MINOP = ABS(MS2)
      MAXOP = 0
      DO 5 IEL1 = NEL1MN,2*NORB1
        DO 4 IEL3 = 0,NEL3MX
          IEL2 = NACTEL-IEL1-IEL3
          IF(IEL2 .LT. 0 ) GOTO 4
          IOP1 = MIN(NORB1,2*NORB1-IEL1,IEL1)
          IOP2 = MIN(NORB2,2*NORB2-IEL2,IEL2)
          IOP3 = MIN(NORB3,2*NORB3-IEL3,IEL3)
          IOP = IOP1 + IOP2 + IOP3
          MAXOP = MAX(MAXOP,IOP)
    4   CONTINUE
    5 CONTINUE
C?    WRITE(6,*) ' MAXOP with RAS constraints :' ,MAXOP
      NTYP = MAXOP-MINOP + 1
*
      IF( NTYP .GT. MXPCTP ) THEN
        WRITE(6,*) '  NUMBER OF CONFIGURATION TYPES TO LARGE '
        WRITE(6,*) '  CHANGE PARAMETER MXPCTP TO AT LEAST ',NTYP
        WRITE(6,*) '  CURRENT VALUE OF MXPCTP ',MXPCTP
        write(6,*) ' MTYP IN LUSPIN TO SMALL '
        call Abend()
      END IF
*
      IF( NTEST .GE. 5 )
     &WRITE(6,*) ' MINOP MAXOP NTYP ',MINOP,MAXOP,NTYP
* ================================================
*. Number of sd's and csf's per configuration type
* ================================================
      DO 10 ITP = 1,NTYP
        IOPEN = MINOP+ITP - 1
        IAEL = (IOPEN + MS2 ) / 2
        IBEL = (IOPEN - MS2 ) / 2
        IF(IAEL+IBEL .EQ. IOPEN ) THEN
          NDPCNT(ITP) = IBION(IOPEN,IAEL)
          IF(IMSCMB.NE.0.AND.IOPEN.NE.0)
     &    NDPCNT(ITP) = NDPCNT(ITP)/2
          IF(IOPEN .GE. MULTS-1) THEN
            NCPCNT(ITP) = IWEYLF(IOPEN,MULTS)
          ELSE
            NCPCNT(ITP) = 0
          END IF
        ELSE
          NDPCNT(ITP) = 0
          NCPCNT(ITP) = 0
        END IF
   10 CONTINUE
      IF(NTEST.GE.2) THEN
      WRITE(6,'(/A)') ' Information about prototype configurations '
      WRITE(6,'( A)') ' ========================================== '
      WRITE(6,'(/A)')
      IF(IMSCMB.EQ.0) THEN
        WRITE(6,'(/A)') ' Combinations = Slater determinants'
      ELSE
        WRITE(6,'(/A)') ' Combinations = Spin combinations '
      END IF
      WRITE(6,'(/A)')
     &'  Open orbitals   Combinations    CSFs '
      DO 580 IOPEN = MINOP,MAXOP,2
        ITYPE = IOPEN - MINOP + 1
        WRITE(6,'(5X,I3,10X,I6,7X,I6)')
     &  IOPEN,NDPCNT(ITYPE),NCPCNT(ITYPE)
  580 CONTINUE
      END IF
* =================================================
**. Number of Combinations and CSF's per  symmetry
* =================================================
*EAW
      CALL GETMEM('KIICL','ALLO','INTEGER',KL1,NACTOB)
      CALL GETMEM('KIIOP','ALLO','INTEGER',KL2,NACTOB)
      CALL GETMEM('KIIOC','ALLO','INTEGER',KL3,NORB1+NORB2+NORB3)
*     KL1 = 1
*     KL2 = KL1 + NACTOB
*     KL3 = KL2 + NACTOB
*EAW

      CALL CISIZE(NORB1,NORB2,NORB3,NEL1MN,NEL3MX,NACTEL,
     &            MINOP,MAXOP,MXPCTP,MXPCSM,NCNATS,NCNASM,NDTASM,
     &            NCSASM,
     &            NDPCNT,NCPCNT,
     &            IWORK(KL1),IWORK(KL2),IWORK(KL3),IPRNT)

*EAW
      CALL GETMEM('KIIOC','FREE','INTEGER',KL3,NORB1+NORB2+NORB3)
      CALL GETMEM('KIIOP','FREE','INTEGER',KL2,NACTOB)
      CALL GETMEM('KIICL','FREE','INTEGER',KL1,NACTOB)
*EAW
* ==============================================
*   Permanent and local memory for csf routines
* ==============================================
*
*    memory for CSDTMT arrays.
*    Largest block of proto type determinants .
*    Largest number of prototype determinants
*    All configurations( of any specific symmetry )
*

      LIDT = 0
      LICS = 0
      LDTOC = 0
      MXPTBL = 0
      MXDT = 0
      LCONF = 0
      DO 11 ITP = 1,NTYP
        IOPEN = MINOP+ITP - 1
        LIDT = LIDT + NDPCNT(ITP) * IOPEN
        LICS = LICS + NCPCNT(ITP) * IOPEN
        LDTOC= LDTOC + NCPCNT(ITP)*NDPCNT(ITP)
        MXDT =   MAX(MXDT,NDPCNT(ITP) )
        MXPTBL = MAX(NDPCNT(ITP)*IOPEN,MXPTBL)
   11 CONTINUE
*. local memory for CSFDET
      LCSFDT = MXPTBL + MAXOP
*. local memory for CNFORD
      LCNFOR = MAX(2*NTYP+NACTOB,(MXDT+2)*NACTEL)
*. local memory for any routine used in construction of csf basis
      LLCSF = MAX(LCSFDT,LCNFOR)
*. Memory needed to store ICONF array
      LCONF = 0
      LDET = 0
      ILCNF = 0
      DO 30 ISYM = 1, MXPCSM
        ILLCNF = 0
        LLCONF = 0
        LDET = MAX(LDET,NDTASM(ISYM))
        DO 25 ITYP = 1, NTYP
          IOPEN = ITYP+MINOP-1
          ICL = ( NEL-IOPEN)/2
          LLCONF = LLCONF + NCNATS(ITYP,ISYM)*(IOPEN+ICL)
          ILLCNF = ILLCNF + NCNATS(ITYP,ISYM)
   25   CONTINUE
C?      WRITE(6,*) ' MEMORY FOR HOLDING CONFS OF SYM... ',ISYM,LLCONF
        LCONF = MAX(LCONF,LLCONF)
        ILCNF = MAX(ILCNF,ILLCNF)
   30 CONTINUE

      ! notice the ILCNF number ! yma

       IF(NTEST.GE.5) THEN
       WRITE(6,'(/A,I8)')
     & '  Memory for holding largest list of configurations ',LCONF
       WRITE(6,'(/A,I8)')
     & '  Size of largest CI expansion (combinations)',LDET
       WRITE(6,'(/A,I8)')
     & '  Size of largest CI expansion (confs)',ILCNF
       END IF
       call xflush(6) !yma

!       if(doDMRG.and.doMCLR)then  ! yma
!         ndets_RGLR=LDET
!         ncsfs_RGLR=ILCNF
!       end if

*. permanent memory for csf proto type arrays

      CALL GETMEM('KDFTP','ALLO','INTEGER',KDFTP,LIDT)
      CALL GETMEM('KCFTP','ALLO','INTEGER',KCFTP,LICS)
      CALL GETMEM('KDTOC','ALLO','REAL   ',KDTOC,LDTOC)

*. Permanent arrays for reordering and phases
      IF(NCNSM .GT. MXCNSM ) THEN
        WRITE(6,'(A,2I2)')
     &  '  TROUBLE IN CSFDIM NCNSM > MXCNSM : NCNSM,MXCNSM',
     &  NCNSM,MXCNSM
        write(6,*) ' CSFDIM : NCNSM  IS GREATER THAN MXCNSM '
        Call Abend()
      END IF
      DO 60 ICNSM = 1, NCNSM
        CALL GETMEM('KICONF','ALLO','INTEGER',KICONF(ICNSM),LCONF)
        CALL GETMEM('KICTS ','ALLO','INTEGER',KICTS(ICNSM),LDET)
   60 CONTINUE
*
*
*
      lldet=ldet

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(ICNSTR)
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE CISIZE(NORB1,NORB2,NORB3,
     &                  NEL1MN,NEL3MX,NACTEL,
     &                  MINOP,MAXOP,
     &                  MXPCNT,MXPCSM,
     &                  NCNATS,NCNASM,NDTASM,NCSASM,
     &                  NDPCNT,NCPCNT,
     &                  IICL,IIOP,IIOC,IPRNT)
*
*   Number of configurations per per configuration type and symmetry
*
*  Jeppe Olsen
*         August 1990 : Improved handling of large RAS 3 space
*         Winter 1991 : Modified for LUCIA
      IMPLICIT REAL*8 (A-H,O-Z)
*.Input
      DIMENSION NDPCNT(*),NCPCNT(*)
*.Output
      DIMENSION NCNATS(MXPCNT,*),NCNASM(*),NDTASM(*),NCSASM(*)
*. Scratch
      DIMENSION IICL(*),IIOP(*),IIOC(NORB1+NORB2+NORB3)
*
*
      NTEST = 0000
      NTEST = MAX(NTEST,IPRNT)
      ILOOP = 0
      ILOOP2 = 0
      NCNF = 0

*
      CALL iCOPY(MXPCSM*MXPCNT,[0],0,NCNATS,1)
      CALL iCOPY(MXPCSM,[0],0,NCSASM,1)
      CALL iCOPY(MXPCSM,[0],0,NDTASM,1)
      CALL iCOPY(MXPCSM,[0],0,NCNASM,1)

*
      IORB1F = 1
      IORB1L = IORB1F+NORB1-1
*
      IORB2F = IORB1L + 1
      IORB2L = IORB2F + NORB2 - 1
*
      IORB3F = IORB2L + 1
      IORB3L = IORB3F + NORB3 - 1
*
      NORB = NORB1 + NORB2 + NORB3
* Min number of doubly occupied orbitals in RAS 1
      MINCL1 = MAX(0,NEL1MN-NORB1)
      IF(NTEST.GE.1)  WRITE(6,*)
     &  ' Min number of doubly occupied orbitals in RAS 1',MINCL1
      DO 5000 NOP = MINOP,MAXOP,2
        ITYPE = NOP-MINOP+1
        NCL = (NACTEL-NOP)/2
        IF( NTEST .GE. 10 )
     &  WRITE(6,*) ' NOP NCL ITYPE',NOP,NCL,ITYPE
C. first combination of double occupied orbitals
        CALL iCOPY(NORB,[0],0,IIOC,1)
        DO 10 ICL = 1, NCL
          IICL(ICL) = ICL
          IIOC(ICL) = 2
   10   CONTINUE
        IFRSTC = 1
C.. Loop over double occupied orbital configurations
 2000   CONTINUE
C
C. next double occupied configuration
          IF ( IFRSTC .EQ. 1. OR. NCL .EQ. 0 ) GOTO 801
C         IF ( IFRSTC .EQ. 0 .AND. NCL .NE. 0 ) THEN
C
          DO 50 IORB = 1, NORB
            IF(IIOC(IORB) .EQ. 1 ) IIOC(IORB) = 0
   50     CONTINUE
C
          IPLACE = 0
  800     IPLACE = IPLACE + 1

          IPRORB = IICL(IPLACE)
          IIOC(IPRORB) = 0
          NEWORB = IPRORB+1
          IF((IPLACE .LT. NCL .AND. NEWORB .LT. IICL(IPLACE+1))
     &      .OR.
     &      IPLACE .EQ. NCL .AND.  NEWORB.LE. NORB ) THEN
            IICL(IPLACE) = NEWORB
            IIOC(NEWORB) = 2
          ELSE IF
     &    (.NOT.(IPLACE.EQ.NCL.AND.NEWORB.GE.NORB)) THEN
            IF(IPLACE .EQ. 1 ) THEN
              IICL(1) = 1
              IIOC(1) = 2
            ELSE
              IICL(IPLACE) = IICL(IPLACE-1) + 1
              IIOC(IICL(IPLACE)) = 2
            END IF
            GOTO 800
          ELSE
C. No more inactive configurations
             GOTO 2001
          END IF
COLD      END IF
  801     CONTINUE
          IFRSTC = 0
          IF( NTEST .GE.1500) THEN
            WRITE(6,*) ' Next inactive configuration '
            CALL IWRTMA(IICL,1,NCL,1,NCL)
          END IF
C..         CHECK RAS1 and RAS 3
            IEL1C = 0
            IEL3C = 0
            ICL1  = 0
            DO  20 ICL = 1,NCL
              IORB = IICL(ICL)
              IF(IORB1F.LE.IORB .AND. IORB.LE.IORB1L ) THEN
                 IEL1C = IEL1C + 2
                 ICL1 = ICL1 + 1
              ELSE IF (IORB3F .LE. IORB .AND. IORB .LE. IORB3L)THEN
                 IEL3C = IEL3C + 2
              END IF
   20       CONTINUE
            IIICHK = 1
            IF(ICL1 .LT.MINCL1.AND. IIICHK.EQ.1) THEN
* Next higher combination with a higher number of inactive orbitals
              DO 41 ICL = 1,ICL1+1
                IIOC(IICL(ICL)) = 0
                IICL(ICL) = ICL
                IIOC(ICL) = 2
   41         CONTINUE
              IPLACE=ICL1+1
              IF( IPLACE.GE.NCL) GOTO 2001
              GOTO 800
            END IF
            IF(IEL3C.GT.NEL3MX) GOTO 2000
C. Highest orbital not occupied
         MXMPTY = NORB
         IORB = NORB+1
C. begin while
   12      CONTINUE
           IORB = IORB - 1
           IF(IIOC(IORB) .EQ. 2 ) THEN
             MXMPTY = IORB-1
             IF( IORB .NE. 1 ) GOTO 12
           END IF
C. End while
C
C. first active configuration
          IORB = 0
          IOP = 0
          DO 30 IORB = 1, NORB
            IF(IIOC(IORB) .EQ. 0 ) THEN
              IOP = IOP + 1
              IF( IOP .GT. NOP ) GOTO 31
              IIOC(IORB) = 1
              IIOP(IOP) = IORB
            END IF
   30     CONTINUE
   31     CONTINUE
          IFRSTO = 1
C
C. Next open shell configuration
 1000     CONTINUE
            IF(IFRSTO.EQ.1. OR. NOP .EQ. 0 ) goto 701
COLD        IF(IFRSTO .EQ. 0 .AND. NOP .NE. 0 ) THEN
            IPLACE = 0
  700       CONTINUE
              IPLACE = IPLACE + 1
              IPRORB = IIOP(IPLACE)
              NEWORB = IPRORB + 1
              IIOC(IPRORB) = 0
  690         CONTINUE
                IF(NEWORB .LE. MXMPTY .AND. IIOC(NEWORB) .NE. 0) THEN
                   NEWORB = NEWORB + 1
                   IF(NEWORB .LE. MXMPTY ) GOTO 690
                END IF
C 691         End of loop
            IF(IPLACE .LT. NOP .AND. NEWORB .LT. IIOP(IPLACE+1)
     &      .OR.
     &      IPLACE .EQ. NOP .AND. NEWORB .LE. MXMPTY ) THEN
              IIOP(IPLACE) = NEWORB
              IIOC(NEWORB) = 1
           ELSE IF (  IPLACE .NE. NOP ) THEN
              IF(IPLACE.EQ.1) THEN
                NEWORB = 1 - 1
              ELSE
                NEWORB = IIOP(IPLACE-1)
              END IF
 671          CONTINUE
                NEWORB = NEWORB + 1
              IF(IIOC(NEWORB) .NE. 0 .AND. NEWORB.LE.MXMPTY ) GOTO 671
              IIOP(IPLACE) = NEWORB
              IIOC(NEWORB) = 1
              GOTO 700
           ELSE
C. No more active configurations , so
              IF( NCL .NE. 0 ) GOTO 2000
              IF( NCL .EQ. 0 ) GOTO 5001
           END IF
C          END IF
  701      CONTINUE
           IFRSTO = 0

          IF( NTEST .GE.1500) THEN
            WRITE(6,*) ' Next active configuration '
            CALL IWRTMA(IIOP,1,NOP,1,NOP)
          END IF
C        RAS  CONSTRAINTS
         IOKAY=1
           IEL1 = IEL1C
           IEL3 = IEL3C
C..        CHECK RAS1 and RAS3
           DO  40 IOP = 1,NOP
             IORB = IIOP(IOP)
             IF(IORB1F.LE.IORB .AND. IORB.LE.IORB1L ) THEN
                IEL1 = IEL1 + 1
             ELSE IF (IORB3F .LE. IORB .AND. IORB .LE. IORB3L)THEN
                IEL3 = IEL3 + 1
             END IF
   40      CONTINUE
           IR3CHK  = 1
           IF(IEL3.GT.NEL3MX.AND.IR3CHK.EQ.1) THEN
*. Number of electrons in substring
             IFSTR3 = 0
             DO 5607 IOP = 1, NOP
               IF(IIOP(IOP).GE.IORB3F) THEN
                IFSTR3 = IOP
                GOTO 5608
               END IF
 5607        CONTINUE
 5608        CONTINUE
             IF(IFSTR3.NE.NOP) THEN

*. Lowest possible string with NOP electrons
               DO 5610 K = 1, IFSTR3
                 IIOC(IIOP(K)) = 0
 5610          CONTINUE
*
               KEL = 0
               KORB = 0
 5630          CONTINUE
                 KORB = KORB + 1
                 IF(IIOC(KORB).NE.2) THEN
                   KEL = KEL + 1
                   IIOC(KORB) = 1
                   IIOP(KEL) = KORB
                 END IF
               IF(KEL.NE.IFSTR3) GOTO  5630
               IPLACE = IFSTR3
               GOTO 700
             END IF
           END IF
           IF( IEL1 .LT. NEL1MN .OR. IEL3 .GT. NEL3MX ) GOTO  999
C. Spatial symmetry
         ISYM = ISYMCN_MCLR(IICL,IIOP,NCL,NOP)
C
           IF( NTEST .GE.2000)
     &     WRITE(6,*) ' ISYM : ', ISYM
           IF(NTEST.GE.1500)
     &     WRITE(6,1120) ( IIOC(I),I = 1,NORB )
 1120      FORMAT(1H0,'  configuration included ',15I3,
     &               ('                         ',15I3))
           NCNF=NCNF+1

           NCNASM(ISYM) = NCNASM(ISYM)+1
           IF(NTEST.GE.1500 )
     &     WRITE(6,1311) NCNF,(IIOC(I),I=1,NORB)
 1311      FORMAT(1H ,' configuration ',I3,20I2,/,(1H ,18X,20I2))

           NCNATS(ITYPE,ISYM)=NCNATS(ITYPE,ISYM)+1
           IF(NTEST.GE.2000) WRITE(6,3111) NCNF,ITYPE
 3111      FORMAT(1H0,'  CONFIGURATION..',I3,' IS TYPE..',I3)
C
C** LOOP OVER CONFIGURATIONS, end
C
  999  CONTINUE
       ILOOP = ILOOP + 1
       ILOOP2 = ILOOP2 + 1
       IF(ILOOP2 .EQ. 10 000 000 ) THEN
         WRITE(6,*) ' 10 million configurations generated '
         ILOOP2 = 0
       END IF
*
       IF( NOP .EQ. 0 .AND. NCL .EQ. 0 ) GOTO 5001
       IF( NOP .EQ. 0 ) GOTO 2000
       GOTO 1000
 2001 CONTINUE
 5000 CONTINUE
 5001 CONTINUE

      IF( NTEST .GE. 2 ) THEN
        WRITE(6,'(A,I8)')
     &  '  Total number of configurations generated ', NCNF
      END IF
* ================================
*. Total number of CSF's and SD's
* ================================
      NTYP = MAXOP - MINOP + 1
      DO 610 ISYM = 1, MXPCSM
        DO 600 ITYPE = 1, NTYP
          NDTASM(ISYM) = NDTASM(ISYM)
     &    + NDPCNT(ITYPE)*NCNATS(ITYPE,ISYM)
          NCSASM(ISYM) = NCSASM(ISYM)
     &    + NCPCNT(ITYPE)*NCNATS(ITYPE,ISYM)
  600   CONTINUE
  610 CONTINUE

C
      IF( NTEST .GE. 2 ) THEN
       WRITE(6,*)
       ICSM = 0
       WRITE(6,'(/A)') ' Information about actual configurations '
       WRITE(6,'( A)') ' ========================================'
       WRITE(6,'(/A)')
     & '    Symmetry     Configurations     CSFs     Combinations  '
       WRITE(6,'(A)')
     & '  =============  ============== ============ ============  '
       DO 570 ICSM = 1, MXPCSM
         IF(NCNASM(ICSM) .NE. 0 ) THEN
            WRITE(6,'(4X,I3,4X,6X,I8,6X,I8,6X,I9)')
     &      ICSM ,NCNASM(ICSM),NCSASM(ICSM),NDTASM(ICSM)
         END IF
  570  CONTINUE
      END IF

*
*
      RETURN
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE CNDET_MCLR(ICONF,IPDET,NDET,NEL,NORB,NOP,NCL,
     *                 IDET,IPRNT)
C
C A configuration ICONF in compressed form and a set of
C prototype determinants ,IPDET, are given .
C
C Construct the corresponding determinants in contracted  form .
C
C JEPPE OLSEN , NOVEMBER 1988
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ICONF(*   )
C     DIMENSION IPDET(NOP,NDET)
      DIMENSION IPDET(*       )
      DIMENSION IDET(NEL,*   )
C
C
C POSITIVE NUMBER  : ALPHA ORBITAL
C NEGATIVE NUMBER  : BETA  ORBITAL
C
      NTEST = 0
      NTEST = MAX(IPRNT,NTEST)
      IF( NTEST .GT.200 ) THEN
        IF(NCL .NE. 0 ) THEN
          WRITE(6,*) ' DOUBLE OCCUPIED ORBITALS '
          CALL IWRTMA(ICONF,1,NCL,1,NCL)
        END IF
        IF(NOP .NE. 0 ) THEN
          WRITE(6,*) ' OPEN ORBITALS '
          CALL IWRTMA(ICONF(1+NCL),1,NOP,1,NOP)
        END IF
      END IF
C
C.. 1 DOUBLY OCCUPIED ORBITALS ARE PLACED FIRST
C
      DO 100 ICL = 1, NCL
        IBASE = 2 * (ICL-1)
        DO 90 JDET = 1, NDET
          IDET(IBASE+1,JDET) =  ICONF(ICL)
          IDET(IBASE+2,JDET) = -ICONF(ICL)
90      CONTINUE
100   CONTINUE
C
C..2  SINGLY OCCUPIED ORBITALS
C
      IADD = 2*NCL
      DO 200 JDET = 1, NDET
        DO 190 IOP = 1, NOP
          IADR = (JDET-1)*NOP + IOP
          IF( IPDET(IADR    ) .EQ. 1 ) IDET(IADD+IOP,JDET) =
     *    ICONF(NCL +IOP)
          IF( IPDET(IADR    ) .EQ. 0 ) IDET(IADD+IOP,JDET) =
     *    - ICONF(NCL +IOP)
190     CONTINUE
200   CONTINUE
C
C..3 OUTPUT
C
      IF( NTEST.GE.200) THEN
       WRITE(6,*) ' CONFIGURATION FROM DETCON '
       CALL IWRTMA(ICONF,1,NORB,1,NORB)
       WRITE(6,* ) ' PROTO TYPE DETERMINANTS '
       IF(NOP*NDET .GT. 0)
     * CALL IWRTMA(IPDET,NOP,NDET,NOP,NDET)
       IF(NEL*NDET .GT. 0 )
     * WRITE(6,*) ' CORRESPONDING DETERMINANTS '
       CALL IWRTMA(IDET,NEL,NDET,NEL,NDET)
      END IF
C
C..4  EXIT
C
      RETURN
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE DETSTR_MCLR(IDET,IASTR,IBSTR,NEL,NAEL,NBEL,NORB,
     *ISIGN,IWORK,IPRNT)

C
C A DETERMINANT,IDET,IS GIVEN AS A SET OF OCCUPIED SPIN ORBITALS,
C POSITIVE NUMBER INDICATES ALPHA ORBITAL AND NEGATIVE NUMBER
C INDICATES BETA ORBITAL .
C
C FIND CORRESPONDING ALPHA STRING AND BETA STRING ,
C AND DETERMINE SIGN NEEDED TO CHANGE DETERMINANT
C INTO PRODUCT OF ORDERED ALPHA STRING AND
C BETA STRING
C
C JEPPE OLSEN NOVEMBER 1988
C
      IMPLICIT REAL*8 (A-H,O-Z)

#include "dmrginfo_mclr.fh"
      DIMENSION IDET(NEL)
      DIMENSION IASTR(NAEL),IBSTR(NBEL)
      DIMENSION IWORK(*)
C
C
C
      NTEST = 000
      NTEST = MAX(NTEST,IPRNT)
C
C FIRST REORDER SPIN ORBITALS IN ASCENDING SEQUENCE
C THIS WILL AUTOMATICALLY SPLIT ALPHA AND BETASTRING
C
      CALL ORDSTR_MCLR(IDET,IWORK,NEL,ISIGN,IPRNT)
C
C ALPHA STRING IS LAST NAEL ORBITALS
      CALL iCOPY(NAEL,IWORK(NBEL+1),1,IASTR,1)
C
C BETA  STRING MUST BE COMPLETELY TURNED AROUND
      DO 10 IBEL = 1, NBEL
        IBSTR(IBEL) = -IWORK(NBEL+1-IBEL)
10    CONTINUE
C SIGN CHANGE FOR SWITCH OF BETA ORBITALS
      iTmp= NBEL*(NBEL+1)/2
      ISIGN = ISIGN * (-1) ** iTmp
C
      IF( NTEST.GE.200) THEN
        WRITE(6,*) ' INPUT DETERMINANT '
        CALL IWRTMA(IDET,1,NEL,1,NEL)
        WRITE(6,*) ' CORRESPONDING ALPHA STRING '
        CALL IWRTMA(IASTR,1,NAEL,1,NAEL)
        WRITE(6,*) ' CORRESPONDING BETA STRING '
        CALL IWRTMA(IBSTR,1,NBEL,1,NBEL)
        WRITE(6,*) ' ISIGN FOR SWITCH ', ISIGN
      END IF

!      if(doDMRG.and.doMCLR)then ! yma
!        DO I=1,NEL
!          Write(117,1110,advance='no') IDET(I)
!        end do
!        Write(117,"(A,1X,I2)",advance='no')" SIGN",ISIGN
!1110  FORMAT(1X,I5)
!      end if

C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NORB)
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE ORDSTR_MCLR(IINST,IOUTST,NELMNT,ISIGN,IPRNT)
C
C ORDER A STRING OF INTEGERS TO ASCENDING ORDER
C
C IINST : INPUT STRING IS IINST
C IOUTST : OUTPUT STRING IS IOUTST
C NELMNT : NUMBER OF INTEGERS IN STRING
C ISIGN :  SIGN OF PERMUTATION : + 1 : EVEN PERMUTATIONN
C                                - 1 : ODD  PERMUTATION
C
C THIS CODE CONTAINS THE OLD ORDER CODE OF JOE GOLAB
C ( HE IS HEREBY AKNOWLEDGED , AND I AM EXCUSED )
C
C IMPLEMENTED MORE TRANSPARENT BUBBLE SORTING INSTEAD
C               JR NOV 2006
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IINST(NELMNT),IOUTST(NELMNT)
      IF(NELMNT.EQ.0) RETURN
      ISIGN=1
      iTEMP=0

10       iPass=0
       DO I=1,NELMNT-1
       IF(IINST(I).GT.IINST(I+1)) THEN
         iTEMP=IINST(I)
         IINST(I)=IINST(I+1)
         IINST(I+1)=iTEMP
         ISIGN=-1*ISIGN
         iPass=1
         ENDIF
       ENDDO
       IF(IPASS.NE.0) GOTO 10


              DO I=1,NELMNT
              IOUTST(I)=IINST(I)
        ENDDO
C
C      NTEST = 0
C      NTEST = MAX(NTEST,IPRNT)
C
C      CALL iCOPY(NELMNT,IINST,1,IOUTST,1)
C      ISIGN = 1
C
C
c        JOE = 1
c10      I = JOE
c20      CONTINUE
c        IF(I.EQ.NELMNT) GO TO 50
c        IF(IOUTST(I).LE.IOUTST(I+1)) GO TO 40
c        JOE = I + 1
C30      iSWAP = IOUTST(I)
c        ISIGN = - ISIGN
c        IOUTST(I) = IOUTST(I+1)
c        IOUTST(I+1) = iSWAP
c       IF(I.EQ.1) GO TO 10
c        I = I - 1
c        IF(IOUTST(I).GT.IOUTST(I+1)) GO TO 30
c        GO TO 10
c40      I = I + 1
c      GO TO 20
C
C     END ORDER
C
c50    CONTINUE
c      IF( NTEST .GE.200) THEN
c        WRITE(6,*)  ' INPUT STRING ORDERED STRING ISIGN ',NELMNT
c        CALL IWRTMA(IINST,1,NELMNT,1,NELMNT)
c        CALL IWRTMA(IOUTST,1,NELMNT,1,NELMNT)
c        WRITE(6,*) ' ISIGN : ', ISIGN
c      END IF
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(IPRNT)
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE MSSTRN(INSTRN,UTSTRN,NOPEN)
*
* A STRING IS GIVEN IN FORM A SEQUENCE OF ZEROES
* AND ONE ' S
*
* REINTERPRET THIS AS :
*
* 1 : THE INPUT STRING IS A DETERMINANT AND THE
*     1'S INDICATE ALPHA ELECTRONS AND THE
*     0'S INDICATE BETA ELECTRONS .
*     UTSTRN IS THE MS-VALUES ATE EACH VERTEX
*
* 2 : THE INPUT STRING IS A CSF GIVEN IN A
*     BRANCHING DIAGRAM, WHERE
*     1'S INDICATE UPWARDS SPIN COUPLEING
*     WHILE THE 0'S INDICATES DOWNWARDS SPIN COUPLING ,
*     REEXPRESS THIS AS S VALUES OF ALL COUPLINGS
*
* THE TWO PROCEDURES ARE IDENTICAL .
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION INSTRN(NOPEN),UTSTRN(NOPEN)
*
      UTSTRN(1) = DBLE(INSTRN(1)) - 0.5D0
      DO 10 IOPEN = 2, NOPEN
        UTSTRN(IOPEN) = UTSTRN(IOPEN-1) +DBLE(INSTRN(IOPEN))-0.5D0
10    CONTINUE
*
      RETURN
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE CONFG2 (NORB1,NORB2,NORB3,
     &                   NEL1MN,NEL3MX,
     &                   MINOP,MAXOP,
     &                   IREFSM,NEL,ICONF,
     &                   NCNFTP,IIOC,IIOP,IICL,IPRNT)
*
*  Generate array,ICONF,giving occupation of each configuration
*  for CI space of reference symmetry IREFSM.
*
*
*  Jeppe Olsen April 1989
*              August 1990 : Improved handling of large RAS 3 space
*
*  Turbo configuration generator
*  Iconf is ordered so all configuratiuns of the same type are
*  consecutively stored .
*  ICONF is written so closed orbitals are given first and then single
*  occupied orbitals
*
      IMPLICIT REAL*8 (A-H,O-Z)
*.Input
      DIMENSION NCNFTP(*)
*.Output
      DIMENSION ICONF(*)
*.Scratch
      DIMENSION IIOC(*),IICL(*),IIOP(*)
*
*
      NTEST = 0000

      NTEST = MAX(NTEST,IPRNT)
*
      IORB1F = 1
      IORB1L = IORB1F+NORB1-1
*
      IORB2F = IORB1L + 1
      IORB2L = IORB2F + NORB2 - 1
*
      IORB3F = IORB2L + 1
      IORB3L = IORB3F + NORB3 - 1
*
      NORB = NORB1 + NORB2 + NORB3
C
C.. Loop over types of configurations
C
      JCONF =  0
      ICFREE = 1
* Min number of doubly occupied orbitals in RAS 1
      MINCL1 = MAX(0,NEL1MN-NORB1)
      IF(NTEST.GE.1) WRITE(6,*)
     &  ' Min number of doubly occupied orbitals in RAS 1',MINCL1
      DO 5000 NOP = MINOP,MAXOP,2
        ITYPE = NOP-MINOP+1
        NCL = (NEL-NOP)/2
        IF( NTEST .GE. 10 )
     &  WRITE(6,*) ' NOP NCL ITYPE',NOP,NCL,ITYPE
C
C. first combination of double occupied orbitals
        CALL iCOPY(NORB,[0],0,IIOC,1)
        DO 10 ICL = 1, NCL
          IICL(ICL) = ICL
          IIOC(ICL) = 2
   10   CONTINUE
        IFRSTC = 1
C.. Loop over double occupied orbital configurations
 2000   CONTINUE
C
C. next double occupied configuration
          IF( IFRSTC .EQ. 1 .OR. NCL .EQ. 0 ) GOTO 801
C
          DO 50 IORB = 1, NORB
            IF(IIOC(IORB) .EQ. 1 ) IIOC(IORB) = 0
   50     CONTINUE
C
          IPLACE = 0
  800     IPLACE = IPLACE + 1

          IPRORB = IICL(IPLACE)
          IIOC(IPRORB) = 0
          NEWORB = IPRORB+1
          IF((IPLACE .LT. NCL .AND. NEWORB .LT. IICL(IPLACE+1))
     &      .OR.
     &      IPLACE .EQ. NCL .AND.  NEWORB.LE. NORB ) THEN
C
            IICL(IPLACE) = NEWORB
            IIOC(NEWORB) = 2
          ELSE IF
     &    (.NOT.(IPLACE.EQ.NCL.AND.NEWORB.GE.NORB)) THEN
C
            IF(IPLACE .EQ. 1 ) THEN
              IICL(1) = 1
              IIOC(1) = 2
            ELSE
              IICL(IPLACE) = IICL(IPLACE-1) + 1
              IIOC(IICL(IPLACE)) = 2
            END IF
            GOTO 800
          ELSE
C. No more inactive configurations
             GOTO 2001
          END IF
  801     CONTINUE
          IFRSTC = 0
C..         CHECK RAS1 and RAS 3
            IEL1C = 0
            IEL3C = 0
            ICL1  = 0
            DO  20 ICL = 1,NCL
              IORB = IICL(ICL)
              IF(IORB1F.LE.IORB .AND. IORB.LE.IORB1L ) THEN
                 IEL1C = IEL1C + 2
                 ICL1 = ICL1 + 1
              ELSE IF (IORB3F .LE. IORB .AND. IORB .LE. IORB3L)THEN
                 IEL3C = IEL3C + 2
              END IF
   20       CONTINUE
            IIICHK = 1
            IF(ICL1 .LT.MINCL1.AND. IIICHK.EQ.1) THEN
* Next higher combination with a higher number of inactive orbitals
              DO 41 ICL = 1,ICL1+1
                IIOC(IICL(ICL)) = 0
                IICL(ICL) = ICL
                IIOC(ICL) = 2
   41         CONTINUE
              IPLACE=ICL1+1
              IF( IPLACE.GE.NCL) GOTO 2001
              GOTO 800
            END IF
            IF(IEL3C.GT.NEL3MX) GOTO 2000
C. Highest orbital not occupied
         MXMPTY = NORB
         IORB = NORB+1
C. begin while
   12      CONTINUE
           IORB = IORB - 1
           IF(IIOC(IORB) .EQ. 2 ) THEN
             MXMPTY = IORB-1
             IF( IORB .NE. 1 ) GOTO 12
           END IF
C. End while
          IF( NTEST .GE.1500) THEN
            WRITE(6,*) ' Next inactive configuration '
            CALL IWRTMA(IICL,1,NCL,1,NCL)
          END IF
C
C. first active configuration
          IORB = 0
          IOP = 0
          DO 30 IORB = 1, NORB
            IF(IIOC(IORB) .EQ. 0 ) THEN
              IOP = IOP + 1
              IF( IOP .GT. NOP ) GOTO 31
              IIOC(IORB) = 1
              IIOP(IOP) = IORB
            END IF
   30     CONTINUE
   31     CONTINUE
          IFRSTO = 1
C
C. Next open shell configuration
 1000     CONTINUE
            IF(IFRSTO. EQ. 1 .OR. NOP .EQ. 0 ) GOTO 701
            IPLACE = 0
  700       CONTINUE
              IPLACE = IPLACE + 1
              IPRORB = IIOP(IPLACE)
              NEWORB = IPRORB + 1
              IIOC(IPRORB) = 0

* PAM 2013: Searching for next orbital with IIOC=0:
  690         CONTINUE
              IF(NEWORB.LE.MXMPTY .and. IIOC(NEWORB) .NE. 0) THEN
                NEWORB = NEWORB + 1
                GOTO 690
              END IF

            IF(IPLACE .LT. NOP .AND. NEWORB .LT. IIOP(IPLACE+1)
     &      .OR.
     &      IPLACE .EQ. NOP .AND. NEWORB .LE. MXMPTY ) THEN
              IIOP(IPLACE) = NEWORB
              IIOC(NEWORB) = 1
           ELSE IF (  IPLACE .NE. NOP ) THEN
              IF(IPLACE.EQ.1) THEN
                NEWORB = 1 - 1
              ELSE
                NEWORB = IIOP(IPLACE-1)
              END IF
 671          CONTINUE
              NEWORB = NEWORB + 1
              IF(IIOC(NEWORB) .NE. 0 .AND. NEWORB.LT.MXMPTY ) GOTO 671
              IIOP(IPLACE) = NEWORB
              IIOC(NEWORB) = 1
              GOTO 700
           ELSE
C. No more active configurations , so
              IF( NCL .NE. 0 ) GOTO 2000
              IF( NCL .EQ. 0 ) GOTO 5001
           END IF
  701      CONTINUE
           IFRSTO = 0

          IF( NTEST .GE.1500) THEN
            WRITE(6,*) ' Next active configuration '
            CALL IWRTMA(IIOP,1,NOP,1,NOP)
          END IF
C        RAS  CONSTRAINTS
         IOKAY=1
           IEL1 = IEL1C
           IEL3 = IEL3C
C..        CHECK RAS1 and RAS3
           DO  40 IOP = 1,NOP
             IORB = IIOP(IOP)
             IF(IORB1F.LE.IORB .AND. IORB.LE.IORB1L ) THEN
                IEL1 = IEL1 + 1
             ELSE IF (IORB3F .LE. IORB .AND. IORB .LE. IORB3L)THEN
                IEL3 = IEL3 + 1
             END IF
   40      CONTINUE
*. Faster routine for RAS 3, added august 1990
           IR3CHK  = 1
           IF(IEL3.GT.NEL3MX.AND.IR3CHK.EQ.1) THEN
*. Number of electrons in substring
             IFSTR3 = 0
             DO 5607 IOP = 1, NOP
               IF(IIOP(IOP).GE.IORB3F) THEN
                IFSTR3 = IOP
                GOTO 5608
               END IF
 5607        CONTINUE
 5608        CONTINUE
             IF(IFSTR3.NE.NOP) THEN

*. Lowest possible string with NOP electrons
               DO 5610 K = 1, IFSTR3
                 IIOC(IIOP(K)) = 0
 5610          CONTINUE
*
               KEL = 0
               KORB = 0
 5630          CONTINUE
                 KORB = KORB + 1
                 IF(IIOC(KORB).NE.2) THEN
                   KEL = KEL + 1
                   IIOC(KORB) = 1
                   IIOP(KEL) = KORB
                 END IF
               IF(KEL.NE.IFSTR3) GOTO  5630
               IPLACE = IFSTR3
               GOTO 700
             END IF
           END IF
           IF( IEL1 .LT. NEL1MN .OR. IEL3 .GT. NEL3MX ) GOTO  999

C. Spatial symmetry
         ISYM = ISYMCN_MCLR(IICL,IIOP,NCL,NOP)
         IF(ISYM.EQ.IREFSM) THEN
           IF(NTEST.GE.100)
     &     WRITE(6,1120) ( IIOC(I),I = 1,NORB )
 1120      FORMAT(1H0,'  configuration included ',15I3)
           JCONF=JCONF+1
C
           DO 60 ICL = 1, NCL
             ICONF(ICFREE-1+ICL) = IICL(ICL)
   60      CONTINUE
           DO 61 IOP = 1, NOP
             ICONF(ICFREE-1+NCL+IOP) = IIOP(IOP)
   61      CONTINUE
           ICFREE = ICFREE + NOP + NCL
         END IF

C
C** LOOP OVER active configurations end
C
  999   CONTINUE
        IF( NOP .EQ. 0 .AND. NCL .EQ. 0 ) GOTO 5001
        IF( NOP .EQ. 0 ) GOTO 2000
        GOTO 1000
 2001 CONTINUE
 5000 CONTINUE
 5001 CONTINUE

*
      IF( NTEST .GE. 100)THEN
        WRITE(6,'(/A,I3)') '  Configurations of symmetry ', IREFSM
        WRITE(6,*)        ' ================================='
        IBAS = 0
        DO 1200 IOPEN = MINOP,MAXOP
          ITYPE = IOPEN - MINOP + 1
          ICL = (NEL-IOPEN)/2
          IOC = IOPEN + ICL
          LICONF = NCNFTP(ITYPE)
          WRITE(6,'(/A,2I3)')
     &    '  Type with number of closed and open orbitals ',ICL,IOPEN
          WRITE(6,'(A,I7)')
     &    '  Number of configurations of this type',LICONF
          DO 1180 JCONF = 1,LICONF
            WRITE(6,'(3X,20I3)') (ICONF(IBAS+IORB),IORB=1,IOC)
            IBAS = IBAS + IOC
 1180     CONTINUE
 1200   CONTINUE
      END IF

C
      RETURN
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE ICISPS(IPRNT)
*
* Number of dets and combinations
* per symmetry for each type of internal space
*
* Jeppe Olsen , Winter 1991
* Last revision April 1991
      IMPLICIT REAL*8(A-H,O-Z)
*
* ===================
*.Input common blocks
* ===================
*
#include "detdim.fh"
#include "cstate_mclr.fh"
#include "strinp_mclr.fh"
#include "strbas_mclr.fh"
#include "csm.fh"
#include "stinf_mclr.fh"
*
#include "WrkSpc.fh"
* ====================
*. Output common block : XISPSM is calculated
* ====================
*
#include "cicisp_mclr.fh"
*
*
*.Local memory
      Call GetMem('KLBLTP','ALLO','INTE',KLBLTP,NSMST)
*     IF(IDC.EQ.3 .OR. IDC .EQ. 4 )
*    &Call GetMem('KLCVST','INTE','ALLO',KLCVST,NSMST)
      klcvst=1

*. Obtain array giving symmetry of sigma v reflection times string
*. symmetry.
*     IF(IDC.EQ.3.OR.IDC.EQ.4)
*    &CALL SIGVST(iWORK(KLCVST),NSMST)

*. Array defining symmetry combinations of internal strings
*. Number of internal dets for each symmetry
C            SMOST(NSMST,NSMCI,MXPCSM,ISMOST)
        CALL SMOST_MCLR(NSMST,NSMCI,MXPCSM,ISMOST)

      MXSB = 0
      MXSOOB = 0
      MXCEXP = 0
      DO 100 ICI = 1, NICISP
      DO  50 ISYM = 1, NSMCI
        IATP = IASTFI(ICI)
        IBTP = IBSTFI(ICI)
CMS        write(6,*) ' NRASDT : ICI IATP IBTP ',ICI,IATP,IBTP
        IF(NAELCI(ICI).EQ.NBELCI(ICI)) THEN
          IIDC = IDC
        ELSE
          IIDC = 1
        END IF
        IF(IACTI(ICI).EQ.1) THEN
          CALL ZBLTP(ISMOST(1,ISYM),NSMST,IIDC,iWORK(KLBLTP),
     &               iWORK(KLCVST))
          CALL NRASDT(MNR1IC(ICI),MXR1IC(ICI),MNR3IC(ICI),MXR3IC(ICI),
     &         ISYM,NSMST,NOCTYP(IATP),NOCTYP(IBTP),iWORK(KEL1(IATP)),
     &         iWORK(KEL1(IBTP)),iWORK(KNSTSO(IATP)),
     &         iWORK(KNSTSO(IBTP)),
     &         iWORK(KEL3(IATP)),iWORK(KEL3(IBTP)),
     &         NCOMB,XNCOMB,MXS,MXSOO,iWORK(KLBLTP))
          XISPSM(ISYM,ICI) = XNCOMB
          MXSOOB = MAX(MXSOOB,MXSOO)
          MXSB = MAX(MXSB,MXS)
          MXCEXP = MAX(MXCEXP,NCOMB)
        ELSE
          XISPSM(ISYM,ICI) = 0.0D0
        END IF
   50 CONTINUE
  100 CONTINUE
      Call GetMem('KLBLTP','Free','INTE',KLBLTP,NSMST)
*
      NTEST = 0000
      NTEST = MAX(NTEST,IPRNT)
      If (ntest.ne.0) Then
      WRITE(6,*)
     &' Number of internal combinations per symmetry '
      WRITE(6,*)
     & ' =========================================== '
      IF(NTEST.EQ.0) THEN
        MX = 1
      ELSE
        MX = NICISP
      END IF
*
      DO 200 ICI = 1, MX
        IF(IACTI(ICI).EQ.1) THEN
          WRITE(6,*) ' Internal CI space ', ICI
          CALL WRTMAT(XISPSM(1,ICI),1,NSMCI,1,NSMCI)
        END IF
  200 CONTINUE
      WRITE(6,*) ' Largest CI space                 ',MXCEXP
      WRITE(6,*) ' Largest symmetry block           ',MXSB
      WRITE(6,*) ' Largest Symmetry-type-type block ',MXSOOB
      End If
*
      RETURN
      END
*
*----------------------------------------------------------------------
*
*
*----------------------------------------------------------------------
*
      SUBROUTINE NRASDT(MNRS1,MXRS1,MNRS3,MXRS3,ITOTSM,
     &                  NSMST,NOCTPA,NOCTPB,IEL1A,IEL1B,
     &                  NSSOA,NSSOB,
     &                  IEL3A,IEL3B,NCOMB,XNCOMB,MXSB,MXSOOB,
     &                  IBLTP)
*
* Number of combimations with symmetry ITOTSM and
*       MNRS1 - MXRS1 elecs in RAS1
*       MNRS3 - MXRS3 elecs in RAS3
*
* In view of the limited range of I*4, the number of dets
* is returned as integer and  real*8
*
* MXSB is largest UNPACKED symmetry block
* MXSOOB is largest UNPACKED symmetry-type-type block
*
* Updated with IBLTP, Summer of 93
*
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION IEL1A(*),IEL3A(*)
      DIMENSION IEL1B(*),IEL3B(*)
      DIMENSION NSSOA(NOCTPA,*),NSSOB(NOCTPB,*)
      DIMENSION IBLTP(*)
*
      MXSB = 0
      MXSOOB = 0
      NCOMB = 0
      XNCOMB = 0.0D0
      DO 300 IASM = 1, NSMST
        IF(IBLTP(IASM).EQ.0) GOTO 300
        CALL SYMCOM_MCLR(2,1,IASM,IBSM,ITOTSM)
        LSB = 0
        IF(IBSM.NE.0) THEN
          IF(IBLTP(IASM).EQ.2) THEN
            ISYM = 1
          ELSE
            ISYM = 0
          END IF
          DO 200 IATP = 1, NOCTPA
           IF(ISYM.EQ.1) THEN
             MXBTP = IATP
           ELSE
             MXBTP = NOCTPB
           END IF
           DO 100 IBTP = 1, MXBTP
             IEL1 = IEL1A(IATP)+IEL1B(IBTP)
             IEL3 = IEL3A(IATP)+IEL3B(IBTP)
             IF(IEL1.GE.MNRS1.AND.IEL1.LE.MXRS1.AND.
     &       IEL3.GE.MNRS3.AND.IEL3.LE.MXRS3 ) THEN
*. Size of unpacked block
               LTTSUP =  NSSOA(IATP,IASM)*NSSOB(IBTP,IBSM)
*. Size of packed block
               IF(ISYM.EQ.0.OR.IATP.NE.IBTP) THEN
                 LTTSBL = NSSOA(IATP,IASM)*NSSOB(IBTP,IBSM)
               ELSE
                 LTTSBL = NSSOA(IATP,IASM)*(NSSOA(IATP,IASM)+1)/2
               END IF
               NCOMB = NCOMB + LTTSBL
               LSB = LSB + LTTSUP
               MXSOOB = MAX(MXSOOB,LTTSUP)
               IF(ISYM.EQ.0.OR.IATP.NE.IBTP) THEN
                 XNCOMB = XNCOMB +
     &         DBLE(NSSOA(IATP,IASM))*DBLE(NSSOB(IBTP,IBSM))
               ELSE
                 XNCOMB = XNCOMB +
     &           DBLE(NSSOA(IATP,IASM))*
     &           (DBLE(NSSOB(IBTP,IBSM))+1.0D0)/2.0D0
               END IF
             END IF
  100      CONTINUE
  200     CONTINUE
          MXSB = MAX(MXSB,LSB)
        END IF
  300 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' NCOMB and XNCOMB ', NCOMB,XNCOMB
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Anders Bernhardsson                              *
************************************************************************
      Subroutine Dens_IF(i_root,CA,CB,OCCA,OCCB)
*
*     A small stupid interface for creating the alpha and beta
*     occupation numbers and corresponding molecular orbitals,
*     used in MOLDEN.
*
*     EAW 990118
*
      Implicit Real*8 (a-h,o-z)
#include "SysDef.fh"
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "casvb.fh"
#include "WrkSpc.fh"
      Real*8 CA(*),CB(*),OCCA(*),OCCB(*)
*
      Call GetMem('DS','ALLO','REAL',ipDS,NACPAR)
      Call GetMem('DT','ALLO','REAL',ipDT,NACPAR)
      Call GetMem('DA','ALLO','REAL',ipDA,NACPAR)
      Call GetMem('DB','ALLO','REAL',ipDB,NACPAR)
      Call GetMem('CMO','ALLO','REAL',ipC,NTOT2)
      Call GetMem('UNITY','ALLO','REAL',ipUnity,NAC**2)
*
*     READ IN ORBITALS
* Averaged...
      If ( iOrbTyp.ne.2 ) iad15=IADR15(2)
* Canonical...
      If ( iOrbTyp.eq.2 ) iad15=IADR15(9)

* Read-in orbitals from Jobiph following instructions from previous lines...
      Call DDAFile(JOBIPH,2,Work(ipC),NTOT2,IAD15)

*     COEN WANTED IT AS A BLOCKED MATRIX, SO HERE THEY COME...
      ip1=ipC
      ip2=1
      call dcopy_(nTOT**2,[0.0d0],0,CA,1)
      call dcopy_(nTOT**2,[0.0d0],0,CB,1)
      Do iS=1,nSym
         Do i=1,nbas(is)
            call dcopy_(nbas(is),Work(ip1),1,CA(ip2),1)
            call dcopy_(nbas(is),Work(ip1),1,CB(ip2),1)
            ip1=ip1+nbas(is)
            ip2=ip2+NTOT
         End Do
         ip2=ip2+nbas(is)
      End DO

*     --- FOLLOWING FOR STANDARD (PSEUDO/AVERAGED/CANONICAL) ORBITALS ---
      IF (i_root.eq.0) THEN
* Averaged...
       If ( iOrbTyp.ne.2 ) then
*        SIMPLY READ OCC NOS AS ALPHAS AND ZERO BETA OCC NOS
         iad15=IADR15(2)
         Call DDAFile(JOBIPH,0,[0.0d0],NTOT2,IAD15)
         CALL DDAFILE(JOBIPH,2,OCCA,NTOT,IAD15)
         call dcopy_(nTOT,[0.0d0],0,OCCB,1)
       end if
* Canonical...
       If ( iOrbTyp.eq.2 ) then
*        SIMPLY ZERO ALPHA and BETA OCC NOS
         call dcopy_(nTOT,[0.0d0],0,OCCA,1)
         call dcopy_(nTOT,[0.0d0],0,OCCB,1)
       end if
*
         IF (IFVB.NE.0)THEN
            Call GetMem('VB','ALLO','REAL',ipVB,NAC*NAC)
            call getvb2mo_cvb(Work(ipVB))
            Call GetMem('ACTMO1','ALLO','REAL',ipAM1,NTOT*NAC)
            Call GetMem('ACTMO2','ALLO','REAL',ipAM2,NTOT*NAC)
c           Gather active MOs ...
c           Also count no of active electrons ...
            iAC=0
            IMO=1
            IOCC=1
            OCCNO=0d0
            nAct=0
            Do iS=1,nSym
               call dcopy_(nTOT*nash(is),
     &                    CA((NISH(iS)+NFRO(IS))*NTOT+IMO),1,
     &                    Work(IAC+ipAM1),1)
               Do J=0,NASH(IS)-1
                  OCCNO=OCCNO+OCCA(J+NISH(IS)+NFRO(IS)+IOCC)
               End Do
               nAct=nAct+NASH(iS)
               IAC=IAC+NASH(iS)*NTOT
               IMO=IMO+nBas(is)*ntot
               IOCC=IOCC+NBAS(iS)
            End Do

            Call DGEMM_('N','N',NTOT,NAC,NAC,
     &                 1d0,Work(ipAM1),NTOT,Work(ipVB),NAC,
     &                 0d0,Work(ipAM2),NTOT)
*
*           Scatter active MOs ...
*           Also reset active occ nos - we choose nel/nact since that
*           gives as much meaning as anything ...
*
            iAC=0
            IMO=1
            IOCC=1
            Do iS=1,nSym
               call dcopy_(nTOT*nash(is),Work(IAC+ipAM2),1,
     &                    CA((NISH(iS)+NFRO(IS))*NTOT+IMO),1)
               call dcopy_(nash(is),[OCCNO/DBLE(nAct)],0,
     &                    OCCA(NISH(iS)+NFRO(IS)+IOCC),1)
               IAC=IAC+NASH(iS)*NTOT
               IMO=IMO+nBas(is)*ntot
               IOCC=IOCC+NBAS(iS)
            End Do
            Call GetMem('ACTMO1','FREE','REAL',ipAM1,NTOT*NAC)
            Call GetMem('ACTMO2','FREE','REAL',ipAM2,NTOT*NAC)
            Call GetMem('VB','FREE','REAL',ipVB,NAC*NAC)
         End If
*
      ELSE
*                                                                      *
************************************************************************
*                                                                      *
*     --- FOLLOWING FOR NATURAL *SPIN* ORBITALS ---
*
*     READ IN DENSITIES
*
      iad15=IADR15(3)
      Do i=1,i_root
        Call DDAFile(JOBIPH,2,Work(ipDS),NACPAR,IAD15)
        Call DDAFile(JOBIPH,2,Work(ipDT),NACPAR,IAD15)
        Call DDAFile(JOBIPH,0,[0.0d0],NACPR2,IAD15)
        Call DDAFile(JOBIPH,0,[0.0d0],NACPR2,IAD15)
      End Do
*
*     CREATE SPIN DENSITIES
*
      Do i=0,NACPAR-1
       Work(ipDA+i)=0.5d0*(Work(ipDS+i)+Work(ipDT+i))
       Work(ipDB+i)=0.5d0*(Work(ipDS+i)-Work(ipDT+i))
      End Do

*
*     DIAGONALIZE THE SPIN DENSITIES
*
*      FIRST ALPHA
*
      call dcopy_(nac**2,[0.0d0],0,Work(ipUnity),1)
      call dcopy_(nac,[1.0d0],0,Work(ipUnity),nac+1)
      Call Jacob(Work(ipDA),Work(ipUNITY),NAC,NAC)
*
* TRANSFORM THE ACTIVE ORBITALS
*
      iAC=0
      iAC2=1
      ip=ipC
      Do iS=1,nSym
         If (nBas(iS).ne.0) then
            ip=ip+nBas(iS)*nIsh(iS)
            iAC2=iAC2+nish(is)*nTot
            If (NASH(IS).gt.0)
     &      Call DGEMM_('N','N',NBAS(IS),NASH(IS),NASH(IS),
     &                  1.0d0,Work(ip),NBAS(IS),
     &                  WORK(IPUNITY+IAC),NAC,
     &                  0.0d0,CA(iAC2),NTOT)
            iAC=iAC+NASH(IS)*NAC+NASH(IS)
            iAC2=iAC2+(nbas(is)-nish(is))*NTOT+nbas(is)
            ip=ip+nbas(is)*(nbas(is)-nish(is))
         End If
      End Do
*
*     COPY OCCUPATION NUMBERS
*
      ip=1
      i=0
      ii=0
      Do iS=1,nSYM
         call dcopy_(nBAS(is),[0.0d0],0,OCCA(ip),1)
         call dcopy_((nFro(is)+nish(is)),[1.0d0],0,OCCA(ip),1)
         ip=ip+nFro(is)+nish(is)
         Do iA=1,nash(is)
            ii=ii+1
            i=i+ii
            OCCA(ip)=Work(ipDA+i-1)
            ip=ip+1
         End Do
         ip=ip+nbas(is)-nFro(is)-nish(is)-nash(is)
      End Do
*
*      THEN ONCE AGAIN FOR BETA....
*
      call dcopy_(nac**2,[0.0d0],0,Work(ipUnity),1)
      call dcopy_(nac,[1.0d0],0,Work(ipUnity),nac+1)
*
      Call Jacob(Work(ipDB),Work(ipUNITY),NAC,NAC)
*
      iAC=0
      iAC2=1
      ip=ipC
      Do iS=1,nSym
      if (nbas(is).ne.0) then
       ip=ip+nBas(is)*nIsh(is)
       iAC2=iAC2+nish(is)*NTOT
       If (NASH(IS).gt.0)
     & Call DGEMM_('N','N',NBAS(IS),NASH(IS),NASH(IS),
     &              1.0d0,Work(ip),NBAS(IS),WORK(IPUNITY+IAC),NAC,
     &              0.0d0,CB(iac2),NTOT)
       iAC=iAC+NASH(IS)*NAC+NASH(IS)
       iAC2=iAC2+(nbas(is)-nish(is))*NTOT+nbas(is)
       ip=ip+nbas(is)*(nbas(is)-nish(is))
      endif
      END DO
*
      ip=1
      i=0
      ii=0
      Do iS=1,nSYM
       call dcopy_(nBAS(is),[0.0d0],0,OCCB(ip),1)
       call dcopy_((nFro(is)+nish(is)),[1.0d0],0,OCCB(ip),1)
       ip=ip+nFro(is)+nish(is)
       Do iA=1,nash(is)
        ii=ii+1
        i=i+ii
        OCCB(ip)=Work(ipDB+i-1)
        ip=ip+1
       End Do
       ip=ip+nbas(is)-nFro(is)-nish(is)-nash(is)
      End Do
      ENDIF
*
*     OK, CLEAN UP
*
      Call GetMem('DS','FREE','REAL',ipDS,NACPAR)
      Call GetMem('DT','FREE','REAL',ipDT,NACPAR)
      Call GetMem('DA','FREE','REAL',ipDA,NACPAR)
      Call GetMem('DB','FREE','REAL',ipDB,NACPAR)
      Call GetMem('CMO','FREE','REAL',ipC,NTOT2)
      Call GetMem('UNITY','FREE','REAL',ipUnity,NAC**2)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ABCI_MRCI(INTSYM,indx,C,S,BMN,IBMN,BIAC,BICA,BUFIN)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION INTSYM(*),indx(*),C(*),S(*),BMN(*),IBMN(*),
     *BIAC(*),BICA(*),BUFIN(*)
*
      JSYM(L)=JSUNP(INTSYM,L)
*
      INUM=IRC(4)-IRC(3)
      CALL CSCALE(indx,INTSYM,C,SQ2)
      CALL CSCALE(indx,INTSYM,S,SQ2INV)
      ICHK=0
      INSIN=KBUFF1
      IAD15=IADABCI
      IADD10=IAD10(4)
      CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IN=2
      NSAVE=ICOP1(IN)
100   NI=NSAVE
      IOUT=0
110   IN=IN+1
      IF(IN.LE.LEN)GO TO 15
      CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.LE.0)GO TO 5
      IN=1
15    IF(ICHK.NE.0)GO TO 460
      IF(ICOP1(IN).EQ.0)GO TO 10
      IOUT=IOUT+1
      BMN(IOUT)=COP(IN)
      IBMN(IOUT)=ICOP1(IN)
      GO TO 110
10    ICHK=1
      GO TO 110
460   ICHK=0
      NSAVE=ICOP1(IN)
5     CONTINUE
      DO 20 NB=1,NVIRT
      NSIB=MUL(NSM(LN+NB),NSM(NI))
      NSLB=MUL(NSM(LN+NB),LSYM)
      LB=NB-NVIRP(NSM(LN+NB))
      INS=NVPAIR(NSIB)
      ILOOP=0
72    INSB=INS
73    IF(INSIN.LT.KBUFF1)GO TO 75
      CALL dDAFILE(Lu_70,2,BUFIN,KBUFF1,IAD15)
      INSIN=0
75    INB=KBUFF1-INSIN
      INUMB=INSB
      IF(INSB.GT.INB)INUMB=INB
      IST=INS-INSB+1
      IF(ILOOP.EQ.0)CALL DCOPY_(INUMB,BUFIN(INSIN+1),1,BIAC(IST),1)
      IF(ILOOP.EQ.1)CALL DCOPY_(INUMB,BUFIN(INSIN+1),1,BICA(IST),1)
      INSIN=INSIN+INUMB
      INSB=INSB-INUMB
      IF(INSB.GT.0)GO TO 73
      ILOOP=ILOOP+1
      IF(ILOOP.EQ.1)GO TO 72
      DO 25 IT=1,IOUT
      IND=IBMN(IT)
*      ICP1=MOD(IND/2**19,2**13)
      ICP1=IBITS(IND,19,13)
      INDA=IRC(1)+ICP1
      IF(JSYM(INDA).NE.NSLB)GO TO 25
      MA=indx(INDA)+LB
*      ICP2=MOD(IND/2**6,2**13)
*      ITYP=MOD(IND,2**6)
      ICP2=IBITS(IND,6,13)
      ITYP=IBITS(IND,0,6)
      IF(INS.EQ.0)GO TO 25
      COPL=BMN(IT)*C(MA)
      INDB=IRC(ITYP)+ICP2
      ICCB=indx(INDB)+1
      IF(ITYP.EQ.3)GO TO 26
      TERM=DDOT_(INS,C(ICCB),1,BICA,1)
      CALL DAXPY_(INS,COPL,BICA,1,S(ICCB),1)
      GO TO 27
26    TERM=DDOT_(INS,C(ICCB),1,BIAC,1)
      CALL DAXPY_(INS,COPL,BIAC,1,S(ICCB),1)
27    S(MA)=S(MA)+BMN(IT)*TERM
25    CONTINUE
20    CONTINUE
      IF(LEN.GE.0)GO TO 100
      CALL CSCALE(indx,INTSYM,C,SQ2INV)
      CALL CSCALE(indx,INTSYM,S,SQ2)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c -------------------------------------------------------------------
c The following function returns the size needed by ptrans for
c temporaries. It also puts into common some offsets and stuff.
c -------------------------------------------------------------------
      integer function memtra(npam)
      use pso_stuff
#include "etwas.fh"
      Integer nPam(4,0:7)
      intrinsic max
*
*     iQ = 1
      mxact=0
      mxS1=0
      mxS2=0
      mxS3=0
      mxS4=0
      do 10 isym=0,mirrep-1
        na=nash(isym)
        if(na.eq.0) goto 10
        mxact=max(mxact,na)
        mxS1=max(mxS1,npam(1,isym))
        mxS2=max(mxS2,npam(2,isym))
        mxS3=max(mxS3,npam(3,isym))
        mxS4=max(mxS4,npam(4,isym))
  10  continue
      mxS=max(mxS1,mxS2,mxS3,mxS4)
      mxa2=mxact*mxact
      mxa3=mxa2*mxact
      mxa4=mxa3*mxact
      mxS34=mxS3*mxS4
      mxS234=mxS2*mxS34
c Max sizes, in common, needed for certain temporaries:
      ncred=Max(1,mxS*mxact)

      nscr1=mxa4
      nscr2=mxa3*mxS4
      nscr3=mxa2*mxS34
      nscr4=mxact*mxS234
      nscr5=mxS1*mxS234
      nScr1=max(1,nscr1,nscr3,nscr5)
      nScr2=max(1,nscr2,nscr4)
      memtra=nCred+2*nScr1+nScr2+3
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine List2(Title,Lbl,gq,nAtom,nInter,Smmtrc)
!***********************************************************************
!                                                                      *
! Object: to print cartesian internal coordinates.                     *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             1993                                                     *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtom, nInter
character(len=*), intent(in) :: Title, Lbl(nAtom)
real(kind=wp), intent(in) :: gq(3*nAtom,nInter)
logical(kind=iwp), intent(in) :: Smmtrc(3*nAtom)
integer(kind=iwp) :: i, iE, i_F, igq, ii, inc, iq, iQQ, jq, LuTmp, mInt, MxWdth, nLbl, nRow
real(kind=wp) :: temp
logical(kind=iwp) :: Start
character(len=80) :: Line
character(len=72) :: Frmt
character(len=16) :: filnam
character(len=14) :: qLbl_tmp
character(len=4), allocatable :: qLbl(:)
real(kind=wp), parameter :: Thr = 0.001_wp ! Threshold for printout.

mInt = 3*nAtom
call mma_allocate(qLbl,mInt,Label='qLbl')

write(u6,*)
call CollapseOutput(1,'Internal coordinates')
write(u6,*)
write(u6,*) ' Specification of the internal coordinates according to the user-defined internal'
write(u6,*) ' coordinate format.'
write(u6,*)
write(u6,'(A)') 'Internal Coordinates'
iq = 0
do igq=1,mInt,3
  if (Smmtrc(igq)) then
    iq = iq+1
    write(qLbl(igq),'(A,I3.3)') 'c',iq
    write(u6,'(3A)') qLbl(igq),' = Cartesian x ',Lbl((igq+2)/3)
  end if
  if (Smmtrc(igq+1)) then
    iq = iq+1
    write(qLbl(igq+1),'(A,I3.3)') 'c',iq
    write(u6,'(3A)') qLbl(igq+1),' = Cartesian y ',Lbl((igq+2)/3)
  end if
  if (Smmtrc(igq+2)) then
    iq = iq+1
    write(qLbl(igq+2),'(A,I3.3)') 'c',iq
    write(u6,'(3A)') qLbl(igq+2),' = Cartesian z ',Lbl((igq+2)/3)
  end if
end do
write(u6,'(A)') 'Vary'
do iQQ=1,nInter
  write(Line,'(A,I3.3,A)') 'q',iQQ,' ='
  i_F = 7
  jq = 0
  Start = .true.
  do iq=1,mInt
    temp = abs(gq(iq,iQQ))
    if (temp > Thr) then
      jq = jq+1
      if (jq > 4) then
        Line(80:80) = '&'
        write(u6,'(A)') Line
        Line = ' '
        i_F = 6
        jq = 1
        Start = .false.
      end if
      if ((jq == 1) .and. Start) then
        iE = i_F+16
        write(Line(i_F:iE),'(A,F10.8,4A)') ' ',gq(iq,iQQ),' ',qLbl(iq),' '
      else
        iE = i_F+17
        write(Line(i_F:iE),'(A,F10.8,4A)') '+ ',gq(iq,iQQ),' ',qLbl(iq),' '
      end if
      i_F = iE+1
    end if
  end do
  write(u6,'(A)') Line
end do
write(u6,'(A)') 'End Of Internal Coordinates'
call CollapseOutput(0,'Internal coordinates')

! Write linear combinations to disc

LuTmp = 11
filnam = 'SPCINX'
call molcas_binaryopen_vanilla(luTmp,filnam)
!open(luTmp,File=filnam,Form='unformatted',Status='unknown')
rewind(LuTmp)

write(LuTmp) mInt,nInter
do iq=1,mInt
  qLbl_tmp = qLbl(iq)
  write(LuTmp) qLbl_tmp,(gq(iq,iQQ),iQQ=1,nInter)
end do
call mma_deallocate(qLbl)

close(LuTmp)

write(u6,*)
call CollapseOutput(1,Title)

MxWdth = 132
nLbl = 8+1
nRow = 9
inc = min((MxWdth-nLbl)/nRow,nInter)

do ii=1,nInter,inc
  write(u6,*)
  write(Frmt,'(A,I2,A)') '(A,1X,',inc,'(I5,4X))'
  write(u6,Frmt) 'Internal',(i,i=ii,min(ii+inc-1,nInter))
  write(u6,*)
  write(Frmt,'(A,I2,A)') '(A4,A4,1X,',inc,'(F8.5,1X))'
  do igq=1,mInt,3
    write(u6,Frmt) Lbl((igq+2)/3),' x  ',(gq(igq,i),i=ii,min(ii+inc-1,nInter))
    write(u6,Frmt) Lbl((igq+2)/3),' y  ',(gq(igq+1,i),i=ii,min(ii+inc-1,nInter))
    write(u6,Frmt) Lbl((igq+2)/3),' z  ',(gq(igq+2,i),i=ii,min(ii+inc-1,nInter))
  end do
  write(u6,*)
end do
call CollapseOutput(0,Title)

return

end subroutine List2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SIGVEC(CIN,HC,HD,BM,SXN,G,H,DIA,F1,F2,X,C,NTRIAL)
! RASSCF Program version IBM-3090: SX section
!
! Purpose: Calculation of the SIGMA vector HC for a super-CI
! Hamiltonian.
! called from HMAT
!PAM01 Added miniscule constant times CIN to HC.
!
! ********** IBM-3090 Release 88 09 01 **********

use Index_Functions, only: nTri_Elem
use rasscf_global, only: ICICP, ITER, NDIMSX, NROOT, NSXS, SXSHFT, IROOT, ENER
use PrintLevel, only: DEBUG
use output_ras, only: IPRLOC
use general_data, only: NSYM, NASH, NISH, NSSH, SXDAMP
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CIN(*), HD(*), BM(*), SXN(*), G(*), H(*), DIA(*), F1(*), F2(*)
real(kind=wp), intent(_OUT_) :: HC(*), X(*), C(*)
integer(kind=iwp) :: NTRIAL
integer(kind=iwp) :: I, iPrLev, ISTAE, ISTBM, ISTH, ISTIA, ISTZ, ISYM, ITRIAL, NAE, NAO, NEO, NIA, NIO, NNST, NST

! Local print level (if any)
IPRLEV = IPRLOC(4)
if (IPRLEV >= DEBUG) write(u6,*) ' Entering SIGVEC'
NST = 0
do ITRIAL=1,NTRIAL
  NNST = NROOT+NST

  ! renormalize the C vector

  C(1:NSXS) = SXN(1:NSXS)*CIN(NNST+1:NNST+NSXS)

  ! Remove any unwanted rotations from C:
  do I=1,NSXS
    if (HD(I+NROOT) > 1.0e20_wp) C(I) = Zero
  end do

  ! Initialize sigma vector to zero.
  HC(NST+1:NST+NROOT+NSXS) = Zero

  ISTIA = 1
  ISTAE = 1
  ISTBM = 1
  ISTH = 1
  ISTZ = 0
  do ISYM=1,NSYM
    NIO = NISH(ISYM)
    NAO = NASH(ISYM)
    NEO = NSSH(ISYM)
    NIA = NIO+NAO
    NAE = NAO+NEO

    if ((NIA /= 0) .and. (NAE /= 0)) then
      ! G-matrix contribution to HC (G*C)

      call DGEMM_('N','N',NIA,NAE,NIA,One,G(ISTIA),NIA,C(ISTBM+NST),NIA,One,HC(ISTBM+NNST),NIA)

      ! H-matrix contribution to HC (-C*H)

      if (NAO /= 0) call DGEMM_('N','N',NIA,NAO,NAE,-One,C(ISTBM+NST),NIA,H(ISTH),NAE,One,HC(ISTBM+NNST),NIA)
      if (NAO*NEO /= 0) call DGEMM_('N','T',NIA,NEO,NAO,-One,C(ISTBM+NST),NIA,H(ISTH+NAO),NAE,One,HC(ISTBM+NAO*NIA+NNST),NIA)

      ! First Fock matrix contribution D*C*FP

      call DGEMM_('N','N',NIA,NAE,NAE,One,C(ISTBM+NST),NIA,F2(ISTAE),NAE,Zero,X,NIA)
      call DGEMM_('N','N',NIA,NAE,NIA,One,DIA(ISTIA),NIA,X,NIA,One,HC(ISTBM+NNST),NIA)

      ! Second Fock matrix contribution FP*C*D

      if (NAO /= 0) then
        call DGEMM_('N','N',NIA,NAO,NIA,One,F1(ISTIA),NIA,C(ISTBM+NST),NIA,Zero,X,NIA)
        call DGEMM_('N','N',NIA,NAO,NAO,One,X,NIA,DIA(ISTIA+NIA*NIO+NIO),NIA,One,HC(ISTBM+NNST),NIA)
      end if
    end if

    ISTIA = ISTIA+NIA**2
    ISTAE = ISTAE+NAE**2
    ISTBM = ISTBM+NIA*NAE
    ISTH = ISTH+NAO*NAE
    ISTZ = ISTZ+nTri_Elem(NAO-1)
  end do

  ! Add diagonal contributions to the CI part

  if (ICICP /= 0) HC(NST+1:NST+NROOT) = HC(NST+1:NST+NROOT)+CIN(NST+1:NST+NROOT)*(ENER(1:NROOT,ITER)-ENER(IROOT(1),ITER))

  if (NSXS /= 0) then

    ! BM contributions to CI part of sigma

    !call DGEMTX(NSXS,NROOT,One,BM,NSXS,C,1,HC(NST+1),1)
    call DGEMV_('T',NSXS,NROOT,One,BM,NSXS,C,1,One,HC(NST+1),1)

    ! BM contributions to SX part of sigma

    HC(NNST+1:NNST+NSXS) = HC(NNST+1:NNST+NSXS)+CIN(NST+1)*BM(1:NSXS)

  end if

  ! Remove any unwanted rotations:
  do I=1,NSXS
    if (HD(I+NROOT) > 1.0e20_wp) HC(I+NNST) = Zero
  end do

  ! Adding a constant times C to the HC vectors at this point
  ! is equivalent to modifying the underlying minimization problem
  ! by adding a penalty for orbital rotations.
  ! This should be large enough that rotations get confined to values
  ! for which the Taylor expansion of rotations (which underlies the
  ! orbital optimization theory) is not too unrealistic.
  ! Example: if SXDAMP=0.0001, then a total rotation 'angle' of 0.1
  ! radians is penalized as an energy increase of 0.0001*(0.1)**2
  ! i.e., 10**(-6) a.u.
  ! Larger SXDAMP may make iterations sluggier.
  ! Too low SXDAMP may give erratic convergence in some exceptional
  ! cases.
  ! SXDAMP is set in READIN.
  HC(NNST+1:NNST+NSXS) = HC(NNST+1:NNST+NSXS)+SXDAMP*C(1:NSXS)

  ! Renormalize the sigma vector

  HC(NNST+1:NNST+NSXS) = SXN(1:NSXS)*HC(NNST+1:NNST+NSXS)

  ! Add Level shift part of the diagonal

  HC(NNST+1:NNST+NSXS) = HC(NNST+1:NNST+NSXS)+SXSHFT*CIN(NNST+1:NNST+NSXS)
  NST = NST+NDIMSX
end do

! Test print out of the sigma vector

if (IPRLEV >= DEBUG) write(u6,1000) (HC(I),I=1,NDIMSX)

1000 format(/1X,'Sigma vector in SIGVEC'/(1X,10F11.6))

return

end subroutine SIGVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReaW3hlp1(Ww,dima,dimbe,dimb,no,LunName,LunAux)
! this routine does:
! reconstruct  Ww(a",be',b,i)  for aSGrp>beSGrp
! from (a",be'|b,i) records in V3 file LunName

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimbe, dimb, no, LunAux
real(kind=wp), intent(out) :: Ww(dima,dimbe,dimb,no)
character(len=8) :: LunName
integer(kind=iwp) :: length

!open(unit=LunAux,file=LunName,form='unformatted')
call Molcas_BinaryOpen_Vanilla(LunAux,LunName)

length = dima*dimbe*dimb*no

! read block (a",be'|b,_i)
call rea_chcc(LunAux,length,Ww)
!mp Ww(1:length) = Zero

close(LunAux)

return

end subroutine ReaW3hlp1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Roland Lindh                                     *
!***********************************************************************

subroutine USOTRANS(USOR,USOI,NSS,EigVec,MSTATE,VSOR,VSOI)

use rassi_global_arrays, only: JBNUM
use Cntrl, only: MLTPLT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NSS, MSTATE
real(kind=wp), intent(in) :: USOR(NSS,NSS), USOI(NSS,NSS), EigVec(MSTATE,MSTATE)
real(kind=wp), intent(out) :: VSOR(NSS,NSS), VSOI(NSS,NSS)
integer(kind=iwp) :: ISS, ISTATE, JOB, JSS, JSS_, KSS, KSS_, MPLET, MSPROJ
real(kind=wp) :: tmp_I, tmp_R
integer(kind=iwp), allocatable :: MAPST(:,:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Before we start we need to backtransform the coefficients of the
! SO states from the basis of the SF states which diagonalize the
! SF Hamiltonian to the basis of the original SF states. This since
! all transition moments, whether or retrived from disk or
! recomputed, are in the basis of the original SF states.

! Mapping from spin states to spin-free state:
call mma_allocate(MAPST,nSS,3,Label='MAPST')
ISS = 0
do ISTATE=1,MSTATE
  JOB = JBNUM(ISTATE)
  MPLET = MLTPLT(JOB)
  do MSPROJ=-MPLET+1,MPLET-1,2
    ISS = ISS+1
    MAPST(ISS,1) = ISTATE
    MAPST(ISS,2) = MPLET
    MAPST(ISS,3) = MSPROJ
  end do
end do

! Let us transform the coefficients in USOR and USOI

do iSS=1,nSS
  do JSS=1,nSS
    tmp_R = Zero
    tmp_I = Zero
    jSS_ = MAPST(JSS,1)
    do kSS=1,nSS
      if (MAPST(kss,2) /= MAPST(jss,2)) cycle
      if (MAPST(kss,3) /= MAPST(jss,3)) cycle
      kSS_ = MAPST(kSS,1)
      tmp_R = tmp_R+USOR(kSS,iSS)*EigVec(jss_,kSS_)
      tmp_I = tmp_I+USOI(kSS,iSS)*EigVec(jss_,kSS_)
    end do
    VSOR(JSS,ISS) = tmp_R
    VSOI(JSS,ISS) = tmp_I
  end do
end do
call mma_deallocate(MAPST)
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine USOTRANS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Roland Lindh                                     *
!***********************************************************************

subroutine ReacX(V_Q,nQ,V_X,nX)
!***********************************************************************
!                                                                      *
!     Objective: Transform the "reaction vector" from internal         *
!                coordinates to Cartesians.                            *
!                                                                      *
!     Roland Lindh, Dept. of Theor. Chem., Lund University, Sweden     *
!     2009                                                             *
!***********************************************************************

use Slapaf_Info, only: BMx
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nQ, nX
real(kind=wp), intent(in) :: V_Q(nQ)
real(kind=wp), intent(out) :: V_X(nX)

!                                                                      *
!***********************************************************************
!                                                                      *
call DGEMM_('N','N',nX,1,nQ,One,BMx,nX,V_Q,nQ,Zero,V_X,nX)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine ReacX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996,1997, Anders Bernhardsson                         *
************************************************************************
      SubRoutine Prec_dig(rpre,idsym)
************************************************************************
*                                                                      *
*     idsym, symmetry of orbital hessian of interest                   *
*     CMtx preconditioner                                              *
*                                                                      *
*     The orbital hessian is dominated of elements that couples        *
*                                                                      *
*     kappa  -> kappa      where i is occupied and p,q is general.     *
*          ip        iq                                                *
*                                                                      *
*     we therefore approximate the hessian with thoose diagonal        *
*     terms in the preconditioner                                      *
*                                                                      *
*     Anders Bernhardsson 96                                           *
*                                                                      *
*     active; active,general is needed for rasscf calculation          *
*     and is not coded yet (ugly bastard) (970109, AB )                *
************************************************************************
      Implicit Real*8(a-h,o-z)
#include "Pointers.fh"
#include "Input.fh"
#include "WrkSpc.fh"
#include "machine.fh"
      Real*8 rpre(*)
*                                                                      *
************************************************************************
*                                                                      *
*
      Call Prec_dig_internal(rpre)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine Prec_dig_internal(rpre)
      Use Iso_C_Binding
      Real*8, Target :: rpre(*)
      Integer, Pointer :: ipre(:)
      nmm=0
      nmmm=0
      Do iS=1,nSym
       nMM=Max(nMM,nAsh(is)+nIsh(iS))
       nMMM=Max(nmmM,nBas(is))
      End Do
      n2=nMMM**2
      nmmm=((nmmm-1)/nRec+1)*nRec
      nmm=nmm*nMMM
      nmm=nmm**2
*
      Call GetMem('JInt','Allo','Real',ipJ,n2)
      Call GetMem('KInt','Allo','Real',ipK,n2)
      Call GetMem('Scr ','Allo','Real',ipS,n2)
*
      ip=1
      sign=1.0d0
      Do iS=1,nSym
         jS=iEOr(is-1,iDSym-1)+1
         nD=nBas(js)-nIsh(jS)
         ni=nBas(js)**2
         Call GetMem('2TEMP2','ALLO','REAL',ipTemp2,ni)
         Call GetMem('3TEMP3','ALLO','REAL',ipTemp3,ni)
         Call GetMem('4TEMP4','ALLO','REAL',ipTemp4,ni)
         call dcopy_(ni,[0.0d0],0,Work(ipTemp4),1)
         Call GetMem('1Temp1','MAX','Real',ipT1,nTemp)
         nTemp=Min(nmm,nTemp/2)
         Call GetMem('1Temp1','ALLO','Real',ipTemp1,2*nTemp)
         ipScr=ipTemp1+nTemp
         If (nD.eq.0) Goto 100
*
         Do iB=1,nIsh(iS)
            call dcopy_(nD**2,[0.0d0],0,Work(ipTemp3),1)
            ibb=nBas(is)*(ib-1)+ib-2
*
            If (iMethod.eq.iCASSCF) Then
*
*              G
*               iaib
*
               If (nash(js).gt.0)
     &         Call Preciaa(ib,is,js,nd,Work(ipTemp3),
     &                      nbas(is),nbas(js),
     &                      Work(ipFIMO+ipCM(is)+ibb),
     &                      Work(ipFAMO+ipCM(is)+ibb),
     &                      Work(ipF0sqMO+ipCM(is)+ibb),
     &                      Work(ipFIMO+ipCM(js)-1),
     &                      Work(ipFAMO+ipCM(js)-1),
     &                      Work(ipF0sqMO+ipCM(js)-1),sign,
     &                      Work(ipJ),Work(ipK),Work(ipS),n2) ! OK
*
*              G
*               ipia
*
               If ((nbas(js)-nish(js)-nash(js))*nash(js).gt.0)
     &         Call Preciba(ib,is,js,nd,Work(ipTemp3),nbas(js),
     y                      Work(ipFIMO+ipCM(js)-1),
     &                      Work(ipFAMO+ipCM(js)-1),
     &                      Work(ipF0sqMO+ipCM(js)-1),sign,
     &                      Work(ipJ),Work(ipK),Work(ipS),n2) ! OK
            End If
*
*           G
*            ipiq
*
            If ((nbas(js)-nish(js)-nash(js)) .gt.0)
     &      Call Precibb_td(ib,is,js,nd,Work(ipTemp3),nBas(js),
     &                   Work(ipTemp1),Work(ipScr),Work(ipTemp2),
     &                   Work(ipFiMo+ipCM(is)+ibb),
     &                   Work(ipFAMO+ipcm(is)+ibb),  ! OK
     &                   Work(ipFiMo+ipCM(js)-1),
     &                   Work(ipFAMO+ipcm(js)-1),sign)  ! OK
*
*           Factorize G:
*
*               T
*           G=LL
*
            If (.not.timedep) Then
               Call SQM(Work(ipTemp3),rpre(ip),nd)
#ifdef RS6K
               Call DGEF(rPre(ip),nD,nD,rpre(ip+nD**2))
#else
               irc=0
               call c_f_pointer(c_loc(rpre(ip+nd**2)),ipre,[nd])
               call dgetrf_(nd,nd,rpre(ip),nd,ipre,irc)
               nullify(ipre)
               If (irc.ne.0) Then
                  Write(6,*) 'Error in DGETRF called from prec_dig'
                  Call Abend
               End If
#endif
            Else
               Call SQM(Work(ipTemp3),Work(ipTemp4),nD)
               Call SortOutDiagonal2(Work(ipTemp4),rpre(ip),nd)
            End if
            If (TimeDep) then
               ip=ip+nD
            Else
               ip=ip+nD*(nd+1)
            End If
*
         End Do   ! iB, inactive
 100     Continue
*
         call dcopy_(ni,[0.0d0],0,Work(ipTemp4),1)
         Do iB=1,nAsh(iS)
            ibb=nBas(is)*(nish(is)+ib-1)+nish(is)+ib-2
            If (ib.le.nRs1(iS)+nRs2(is)+nRs3(is)) iR=3
            If (ib.le.nRs1(iS)+nRs2(is)) iR=2
            If (ib.le.nRs1(iS)) iR=1
            If (ir.eq.1) nD=nBas(js)-nRs1(js)
            If (ir.eq.2) nD=nBas(js)-nRs2(js)
            If (ir.eq.3) nD=nBas(js)-nRs3(js)
            If (nd.eq.0) Goto 110
            call dcopy_(nD**2,[0.0d0],0,Work(ipTemp3),1)
            If (nish(js).gt.0)
     &         Call Precaii(ib,is,js,nd,ir,Work(ipTemp3),
     &                      nbas(is),nbas(js),
     &                      Work(ipFIMO+ipCM(is)+ibb),
     &                      Work(ipFAMO+ipCM(is)+ibb),
     &                      Work(ipF0SqMO+ipCM(is)+ibb),
     &                      Work(ipFIMO+ipCM(js)-1),
     &                      Work(ipFAMO+ipCM(js)-1),
     &                      Work(ipF0SqMO+ipCM(js)-1),sign,
     &                      Work(ipJ),Work(ipK),Work(ipS),n2) ! OK
*           Call Precaai(ib,nd,ir,rpre(ip))
*           Call Precaaa(ib,nd,ir,rpre(ip))
            If (nish(js)*nBas(js).gt.0)
     &         Call Precabi(ib,is,js,ir,nd,Work(ipTemp3),nBas(js),
     &                      Work(ipFIMO+ipCM(js)-1),
     &                      Work(ipFAMO+ipCM(js)-1),
     &                      Work(ipF0SQMO+ipCM(js)-1),sign,
     &                      Work(ipJ),Work(ipK),Work(ipS),n2) !+/-?

*           Call Precaba(ib,nd,ir,rpre(ip))
            If (nBas(js).gt.0)
     &         Call Precabb(ib,is,js,nd,nbas(js),Work(ipTemp3),
     &                      Work(ipTemp1),ntemp,Work(ipScr),
     &                      Work(ipTemp2),
     &                      Work(ipF0SQMO+ipCM(is)+ibb),
     &                      Work(ipFiMo+ipCM(js)-1),
     &                      Work(ipFAMO+ipcm(js)-1) ,
     &                      Work(ipF0SQMO+ipCM(js)-1),sign)
            If (.not.timedep) then
               Call SQM(Work(ipTemp3),rpre(ip),nD)
#ifdef RS6K
               Call DGEF(rPre(ip),nD,nd,rpre(ip+nd**2))
#else
               irc=0
               call c_f_pointer(c_loc(rpre(ip+nd**2)),ipre,[nd])
               call dgetrf_(nd,nd,rpre(ip),nd,ipre,irc)
               nullify(ipre)
               If (irc.ne.0) then
                  Write(6,*) 'Error in DGETRF called from prec_dig'
                  Call Abend
               End If
#endif
            Else
*              From Triang mat
               Call SQM(Work(ipTemp3),Work(ipTemp4),nD)
               Call SortOutDiagonal2(Work(ipTemp4),rpre(ip),nd)
            End If
            If (timedep) Then
               ip=ip+nd
            Else
               ip=ip+nD*(nd+1)
            End if
         End Do ! iB
110      Continue
         Call GetMem('1TEMP1','FREE','REAL',ipTemp1,nTemp)
         Call GetMem('2TEMP2','FREE','REAL',ipTemp2,nBas(js)**2)
         Call GetMem('3TEMP3','FREE','REAL',ipTemp3,nBas(js)**2)
         Call GetMem('4TEMP4','FREE','REAL',ipTemp4,ni)
      End Do ! End loop over symmetries
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('Scr ','Free','Real',ipS,n2)
      Call GetMem('KInt','Free','Real',ipK,n2)
      Call GetMem('JInt','Free','Real',ipJ,n2)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End Subroutine Prec_dig_internal
*
      End
*===============================================================
      subroutine SortOutDiagonal(Matrix,diagonal,nb)
*
*    Copy the diagonal elements from Matrix to the vector
*    Diagonal
*
      Implicit Real*8(a-h,o-z)
      Real*8 Matrix(*),diagonal(*)
      call triPrt(' ',' ',matrix,nb)
      ipM=0
      do i=1,nb
       ipM=ipM+i
       Diagonal(i)=Matrix(ipM)
      end do
*      call recPrt(' ',' ',diagonal,nb,1)
      return
      end
*===============================================================
      subroutine SortOutDiagonal2(Matrix,diagonal,nb)
*
*    Copy the diagonal elements from Matrix to the vector
*    Diagonal
*
      Implicit Real*8(a-h,o-z)
      Real*8 Matrix(*),diagonal(*)
      ipM=1
      Do i=1,nb
       Diagonal(i)=Matrix(ipM)
       ipM=ipM+nb+1
      end do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Roland Lindh                                     *
!***********************************************************************

subroutine Cnthlf(Coeff1,nCntr1,nPrm1,Coeff2,nCntr2,nPrm2,lZeta,nVec,First,IncVec,A1,A2,A3,Indij)
!***********************************************************************
!                                                                      *
! Object: to do a half transformation. The loop over the two matrix-   *
!         matrix multiplications is segmented such that the end of the *
!         intermediate matrix will not push the start of the same out  *
!         from the cache.                                              *
!                                                                      *
! Author:     Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCntr1, nPrm1, nCntr2, nPrm2, lZeta, nVec, IncVec, Indij(lZeta)
real(kind=wp), intent(in) :: Coeff1(nPrm1,nCntr1), Coeff2(nPrm2,nCntr2), A1(lZeta,nVec)
logical(kind=iwp), intent(in) :: First
real(kind=wp), intent(inout) :: A2(IncVec,nprm2), A3(nVec,nCntr1,nCntr2)
integer(kind=iwp), parameter :: mxnprm = 1000 ! be aware of aCD(fat) basis sets.
integer(kind=iwp) :: ic1, iCntr1, iCntr2, idone(mxnprm), ifirst(mxnprm), iiVec, iPrm1, iPrm2, iZeta, last(mxnprm), minva, mPrm2, &
                     mVec, nnz2(mxnprm), nz2
real(kind=wp) :: C1, C2

if ((nPrm1 > mxnprm) .or. (nPrm2 > mxnprm)) then
  call WarningMessage(2,'CntHlf: nPrm > mxnprm')
  call Abend()
end if

! Sparsity check

nz2 = 0
minva = max(4,(nPrm2+1)/2)
do iCntr2=1,nCntr2
  nnz2(icntr2) = 0
  ifirst(icntr2) = nPrm2+1
  last(icntr2) = 0
  do iPrm2=1,nPrm2
    if (Coeff2(iPrm2,iCntr2) /= Zero) then
      ifirst(icntr2) = min(ifirst(icntr2),iprm2)
      last(icntr2) = max(last(icntr2),iprm2)
      nnz2(icntr2) = nnz2(icntr2)+1
    end if
  end do
  if ((nnz2(icntr2) >= minva) .and. (nz2 == iCntr2-1)) nz2 = iCntr2
end do

! Loop sectioning

do iiVec=1,nVec,IncVec
  mVec = min(IncVec,nVec-iiVec+1)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! First quarter transformation

  do iCntr1=1,nCntr1
    idone(1:nprm2) = 0

    do iZeta=1,lZeta
      iPrm2 = (Indij(iZeta)-1)/nPrm1+1
      iPrm1 = Indij(iZeta)-(iPrm2-1)*nPrm1
      C1 = Coeff1(iPrm1,iCntr1)
      if (abs(C1) > Zero) then
        if (idone(iprm2) > 0) then
          A2(1:mVec,iPrm2) = A2(1:mVec,iPrm2)+C1*A1(iZeta,iiVec:iiVec+mVec-1)
        else
          A2(1:mVec,iPrm2) = C1*A1(iZeta,iiVec:iiVec+mVec-1)
          idone(iprm2) = 1
        end if
      end if
    end do ! iZeta
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Second quarter transformation

    do iprm2=1,nprm2
      if (idone(iprm2) == 0) A2(1:mVec,iPrm2) = Zero
    end do

    ic1 = 1
    if (nz2 > 1) then
      if (first) then
        call DGEMM_('n','n',mVec,nz2,nprm2,One,A2,IncVec,Coeff2,nprm2,Zero,A3(iivec,iCntr1,1),nvec*ncntr1)
      else
        call DGEMM_('N','N',mVec,nz2,nPrm2,One,A2,IncVec,Coeff2,nprm2,One,A3(iivec,iCntr1,1),nvec*ncntr1)
      end if
      ic1 = nz2+1
    end if

    do iCntr2=ic1,nCntr2
      if (first) then
        if (nnz2(icntr2) >= minva) then
          call dGeMV_('N',mVec,nPrm2,One,A2,IncVec,Coeff2(1,icntr2),1,Zero,A3(iivec,iCntr1,icntr2),1)
        else
          iprm2 = ifirst(icntr2)
          c2 = coeff2(iprm2,icntr2)
          A3(iiVec:iiVec+mVec-1,iCntr1,iCntr2) = C2*A2(1:mVec,iPrm2)

          iPrm2 = ifirst(icntr2)+1
          mPrm2 = last(iCntr2)-iPrm2+1
          if (mPrm2 > 0) call DNaXpY(mPrm2,mVec,Coeff2(iPrm2,iCntr2),1,A2(1,iPrm2),1,IncVec,A3(iiVec,iCntr1,iCntr2),1,0)

        end if
      else
        if (nnz2(icntr2) >= minva) then
          call dGeMV_('N',mVec,nPrm2,One,A2,IncVec,Coeff2(1,icntr2),1,One,A3(iivec,iCntr1,icntr2),1)
        else
          iPrm2 = ifirst(icntr2)
          mPrm2 = last(icntr2)-iPrm2+1
          call DNaXpY(mPrm2,mVec,Coeff2(iPrm2,iCntr2),1,A2(1,iPrm2),1,IncVec,A3(iiVec,iCntr1,iCntr2),1,0)
        end if
      end if
    end do ! iCntr2
  end do   ! iCntr1

  ! End of loop sectioning

end do     ! iiVec

return

end subroutine Cnthlf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  getMatrix
*
*> @brief
*>   Utility routine for quaternion resolution
*> @author Y. Carissan
*>
*> @details
*> Fills the output matrix with the rotation matrix.
*>
*> @param[out] M Rotation matrix at output
************************************************************************
      subroutine getMatrix(M)
      Implicit none
#include "WrkSpc.fh"
#include "rotation.fh"
      Real*8 M(3,3)

      if (matrixSet) then
        call dcopy_(6,RotMatrix,1,M,1)
      else
        Call SysAbendMsg("RdInput","Rotation Matrix was not set",
     &          "")
      end if

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2022, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MODens()
!***********************************************************************
!                                                                      *
!     purpose: Compute density matrix in molecular orbital basis       *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use InfSCF, only: CMO, Dens, DMOMax, MaxBas, MaxBXO, MaxOrb, nBas, nD, nDens, nOcc, nOrb, nSym, Ovrlp, TEEE, TimFld
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use InfSCF, only: nBO, nBT
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: i, iD, iiBO, iiBT, iOvl, iSym, iT, j, jD
real(kind=wp) :: CPU1, CPU2, Tim1, Tim2, Tim3
real(kind=wp), allocatable :: Aux1(:), Aux2(:), DMoO(:), DnsS(:), OvlS(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

call Timing(Cpu1,Tim1,Tim2,Tim3)

! Allocate memory for squared density matrix
call mma_allocate(DnsS,MaxBas**2,Label='DnsS')

! Allocate memory for squared overlap matrix
call mma_allocate(OvlS,MaxBas**2,Label='OvlS')

! Allocate memory for density matrix in MO basis
call mma_allocate(DMoO,nTri_Elem(MaxOrb),Label='DMoO')

! Allocate memory for auxiliary matrix
call mma_allocate(Aux1,MaxBxO,Label='Aux1')

! Allocate memory for auxiliary matrix
call mma_allocate(Aux2,MaxBxO,Label='Aux2')

DMOMax = Zero
do jD=1,nD

# ifdef _DEBUGPRINT_
  call NrmClc(Dens(1,jD,nDens),nBT,'MoDens','D in AO   ')
  call NrmClc(Ovrlp,nBT,'MoDens','Overlap   ')
  call NrmClc(CMO(1,jD),nBO,'MoDens','CMOs      ')
  write(u6,*) 'nOcc=',(nOcc(i,jD),i=1,nSym)
  !write(u6,'(F16.8)') DXot(MaxBxO,CMO(1,jD),1,CMO(1,jD),1)
# endif
  it = 1
  id = 1
  iOvl = 1
  do iSym=1,nSym

    iiBO = nBas(iSym)*nOrb(iSym)
    iiBT = nTri_Elem(nBas(iSym))

    if ((nOcc(iSym,jD) > 0) .or. (Teee .and. (nBas(iSym) > 0))) then
      call DSq(Dens(id,jD,nDens),DnsS,1,nBas(iSym),nBas(iSym))
      call Square(Ovrlp(iOvl),OvlS,1,nBas(iSym),nBas(iSym))

      call DGEMM_('N','N',nBas(iSym),nOrb(iSym),nBas(iSym), &
                  One,OvlS,nBas(iSym), &
                  CMO(it,jD),nBas(iSym), &
                  Zero,Aux1,nBas(iSym))
      call DGEMM_('N','N',nBas(iSym),nOrb(iSym),nBas(iSym), &
                  One,DnsS,nBas(iSym), &
                  Aux1,nBas(iSym), &
                  Zero,Aux2,nBas(iSym))
      call DGEMM_('N','N',nBas(iSym),nOrb(iSym),nBas(iSym), &
                  One,OvlS,nBas(iSym), &
                  Aux2,nBas(iSym), &
                  Zero,Aux1,nBas(iSym))
      call DGEMM_Tri('T','N',nOrb(iSym),nOrb(iSym),nBas(iSym), &
                     One,CMO(it,jD),nBas(iSym), &
                     Aux1,nBas(iSym), &
                     Zero,DMoO,nOrb(iSym))

      !call TriPrt('D(mo)','(8F12.6)',DMoO,nOrb(iSym))
      do i=nOcc(iSym,jD)+1,nOrb(iSym)
        do j=1,nOcc(iSym,jD)
          DMOMax = max(DMOMax,real(nD,kind=wp)*abs(DMoO(iTri(i,j))))
        end do
      end do
    end if

    it = it+iiBO
    id = id+iiBT
    iOvl = iOvl+iiBT
  end do

end do

! Deallocate memory
call mma_deallocate(Aux2)
call mma_deallocate(Aux1)
call mma_deallocate(DMoO)
call mma_deallocate(OvlS)
call mma_deallocate(DnsS)

#ifdef _DEBUGPRINT_
write(u6,*) ' DMOMax in MODens',DMOMax
#endif
call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(14) = TimFld(14)+(Cpu2-Cpu1)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine MODens

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FRMDSC2(   ARRAY,    NDIM,  MBLOCK,   IFILE,  IMZERO,
     &                   I_AM_PACKED,NO_ZEROING)
C
C     TRANSFER ARRAY FROM DISC FILE IFILE
C
*. Version allowing zero and packed blocks
*
* If NO_ZEROING = 1, the elements of zero blocks
*    are not set to zero, the routine just returns with
*    IMZERO = 1
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "io_util.fh"
      DIMENSION ARRAY(*)
*
      DIMENSION ISCR(2)
      PARAMETER(LPBLK=50000)
      INTEGER IPAK(LPBLK)
      DIMENSION XPAK(LPBLK)
      DIMENSION IDUMMY(1)

      IMZERO = 0
C
      IPACK = 1
      IF(IPACK.NE.0) THEN
*. Read if ARRAY is zero
C       MMBLOCK = MBLOCK
C       IF(MMBLOCK.GE.2) MMBLOCK = 2
C       CALL IFRMDS(ISCR,2,MMBLOCK,IFILE)
         CALL IFRMDS(ISCR,2,2,IFILE)
         IMZERO=ISCR(1)
         I_AM_PACKED=ISCR(2)
         IF(IMZERO.EQ.1) THEN
            IF(NO_ZEROING.EQ.0) THEN
               ZERO = 0.0D0
               CALL SETVEC(ARRAY,ZERO,NDIM)
            END IF
            GOTO 1001
         END IF
      END IF
*
      IF(I_AM_PACKED.EQ.1) THEN
         ZERO = 0.0D0
         CALL SETVEC(ARRAY,ZERO,NDIM)
*. Loop over packed records of dimension LPBLK
         NBATCH = 0
C1000 CONTINUE
*. The next LPBLK elements
         LBATCH=-2**30
 999     CONTINUE
         NBATCH = NBATCH + 1
         IF(NBATCH.NE.1) THEN
            LBATCHP = LBATCH
         END IF
*. Read next batch
         CALL IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
         LBATCH=IDUMMY(1)
         IF(LBATCH.GT.0) THEN
           CALL IDAFILE(IFILE,2,IPAK,LBATCH,IDISK(IFILE))
           CALL DDAFILE(IFILE,2,XPAK,LBATCH,IDISK(IFILE))
         END IF
         CALL IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
         ISTOP=IDUMMY(1)
         DO IELMNT = 1, LBATCH
            IF(IPAK(IELMNT).LE.0.OR.IPAK(IELMNT).GT.NDIM) THEN
               WRITE(6,*) ' FRMDSC : Problemo IELMNT = ',IELMNT
               WRITE(6,*) ' IPAK(IELMNT) = ',IPAK(IELMNT )
               WRITE(6,*) ' LBATCH IFILE  = ',LBATCH,IFILE
               IF(NBATCH.EQ.1) THEN
                  WRITE(6,*) ' NBATCH = 1 '
               ELSE
                  WRITE(6,*) ' NBATCH, LBATCHP', NBATCH,LBATCHP
               END IF
               WRITE(6,*) ' NDIM,IMZERO = ', NDIM,IMZERO
*              STOP ' problem in FRMDSC '
               CALL SYSABENDMSG('lucia_util/frmdsc','Internal error',
     &                          ' ')
            END IF
            ARRAY(IPAK(IELMNT)) = XPAK(IELMNT)
         END DO
         IF(ISTOP.EQ.0) GOTO 999
*. End of loop over records of truncated elements
      ELSE IF ( I_AM_PACKED.EQ.0) THEN
            NBLOCK = MBLOCK
            IF ( MBLOCK .LE. 0 ) NBLOCK = NDIM
            IREST=NDIM
            IBASE=0
 100        CONTINUE
            IF(IREST.GT.NBLOCK) THEN
               CALL DDAFILE(IFILE,2,ARRAY(IBASE+1),NBLOCK,IDISK(IFILE))
               IBASE=IBASE+NBLOCK
               IREST=IREST-NBLOCK
            ELSE
               CALL DDAFILE(IFILE,2,ARRAY(IBASE+1),IREST,IDISK(IFILE))
               IREST=0
            END IF
            CALL IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
            IF( IREST .GT. 0 ) GOTO 100
C
      END IF
*
 1001 CONTINUE
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ChkLumo(OccSet,FermSet,SpinSet)
!***********************************************************************
!                                                                      *
! This routine figure out the status of the lumo file, i.e. should it  *
! trigger keywords OCCUpied or FERMi?                                  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University, Sweden                                     *
!                                                                      *
!***********************************************************************

use InfSCF, only: FileOrb_ID, iAU_AB, isHDF5, nBas, nD, nOcc, NoFerm, nOrb, nSym, nSym, SCF_FileOrb, Tot_EL_Charge, vTitle
#ifdef _HDF5_
use mh5, only: mh5_exists_dset
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use InfSCF, only: Tot_Charge, Tot_Nuc_Charge
use Definitions, only: u6
#endif

implicit none
logical(kind=iwp), intent(inout) :: OccSet, FermSet
logical(kind=iwp), intent(in) :: SpinSet
integer(kind=iwp) :: I, iD, iDiff, iDummy(1), iErr, iOff, isUHF, iSym, iWFType, J, LU, LU_, N, ntmp, nVec
real(kind=wp) :: Dummy(1), qA, qB, Tmp, Tmp1
logical(kind=iwp) :: Idem, Skip
character(len=512) :: FNAME
integer(kind=iwp), allocatable :: Ind(:,:)
real(kind=wp), allocatable :: EpsVec(:,:), OccVec(:,:)

!----------------------------------------------------------------------*
! Setup                                                                *
!----------------------------------------------------------------------*
call Peek_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
nVec = sum(nBas(1:nSym))
!----------------------------------------------------------------------*
! Allocate fields                                                      *
!----------------------------------------------------------------------*
call mma_Allocate(OccVec,nVec,nD,Label='OccVec')
call mma_Allocate(EpsVec,nVec,nD,Label='EpsVec')
!----------------------------------------------------------------------*
! Read occupation numbers and orbital energies                         *
!----------------------------------------------------------------------*
Lu = 17
FName = SCF_FileOrb
if (nD == 1) then
  if (isHDF5) then
    call RdVec_HDF5(fileorb_id,'OE',nSym,nBas,Dummy,OccVec(:,1),EpsVec(:,1),iDummy)
  else
    call RdVec_(FNAME,Lu,'OE',nD-1,nSym,nBas,nOrb,Dummy,Dummy,OccVec(:,1),Dummy,EpsVec(:,1),Dummy,iDummy,VTitle,1,iErr,iWFtype)
  end if
else
  isUHF = 0
  if (isHDF5) then
#   ifdef _HDF5_
    if (mh5_exists_dset(fileorb_id,'MO_ALPHA_VECTORS')) isUHF = 1
#   endif
  else
    Lu_ = 18
    isUHF = -1
    call Chk_Vec_UHF(FNAME,Lu_,isUHF)
  end if
  if (isUHF == 1) then
    if (isHDF5) then
      call RdVec_HDF5(fileorb_id,'OEA',nSym,nBas,Dummy,OccVec(:,1),EpsVec(:,1),iDummy)
      call RdVec_HDF5(fileorb_id,'OEB',nSym,nBas,Dummy,OccVec(:,2),EpsVec(:,2),iDummy)
    else
      call RdVec_(FNAME,Lu,'OE',nD-1,nSym,nBas,nOrb,Dummy,Dummy,OccVec(:,1),OccVec(:,2),EpsVec(:,1),EpsVec(:,2),iDummy,VTitle,1, &
                  iErr,iWFtype)
    end if
  else
    if (isHDF5) then
      call RdVec_HDF5(fileorb_id,'OE',nSym,nBas,Dummy,OccVec(:,1),EpsVec(:,1),iDummy)
    else
      call RdVec_(FNAME,Lu,'OE',0,nSym,nBas,nOrb,Dummy,Dummy,OccVec(:,1),Dummy,EpsVec(:,1),Dummy,iDummy,VTitle,1,iErr,iWFtype)
    end if
    OccVec(:,2) = OccVec(:,1)
    EpsVec(:,2) = EpsVec(:,1)
    OccVec(:,:) = Half*OccVec(:,:)
  end if
end if
#ifdef _DEBUGPRINT_
if (nD == 1) then
  write(u6,*) 'Orbital energies'
  write(u6,'(10f12.6)') (EpsVec(i,1),i=1,nVec)
  write(u6,*) 'Occupation numbers'
  write(u6,'(10f12.6)') (OccVec(i,1),i=1,nVec)
else
  write(u6,*) 'Alpha orbital energies'
  write(u6,'(10f12.6)') (EpsVec(i,1),i=1,nVec)
  write(u6,*) 'Alpha occupation numbers'
  write(u6,'(10f12.6)') (OccVec(i,1),i=1,nVec)
  write(u6,*) 'Beta orbital energies'
  write(u6,'(10f12.6)') (EpsVec(i,2),i=1,nVec)
  write(u6,*) 'Beta occupation numbers'
  write(u6,'(10f12.6)') (OccVec(i,2),i=1,nVec)
end if
#endif
!----------------------------------------------------------------------*
! What are the charges                                                 *
!----------------------------------------------------------------------*
qa = Zero
qb = Zero
if (nD == 1) then
  if (nSym /= 1) then
    tmp1 = Zero
    do i=1,nVec
      tmp1 = tmp1+OccVec(i,1)
      if (tmp1 >= Two) then
        qa = qa+Two
        tmp1 = tmp1-Two
        OccVec(i,1) = Two
      else if (tmp1 >= One) then
        qa = qa+One
        tmp1 = tmp1-One
        OccVec(i,1) = One
      else
        OccVec(i,1) = Zero
      end if
    end do
  else
    ntmp = nint(sum(OccVec(:,1)))
    OccVec(:,:) = Zero
    tmp1 = real(ntmp,kind=wp)
    do i=1,(ntmp+1)/2
      if (tmp1 >= Two) then
        qa = qa+Two
        OccVec(i,1) = Two
        tmp1 = tmp1-Two
      else if (tmp1 >= One) then
        qa = qa+One
        OccVec(i,1) = One
        tmp1 = tmp1-One
      end if
    end do
  end if
  qa = Half*qa
  qb = qa
else
  if (nSym /= 1) then
    tmp1 = Zero
    do i=1,nVec
      tmp1 = tmp1+OccVec(i,1)+OccVec(i,2)
      if (tmp1 >= Two) then
        qa = qa+One
        qb = qb+One
        tmp1 = tmp1-Two
        OccVec(i,1) = One
        OccVec(i,2) = One
      else if (tmp1 >= One) then
        qa = qa+One
        qb = qb+Zero
        OccVec(i,1) = One
        OccVec(i,2) = Zero
        tmp1 = tmp1-One
      else
        OccVec(i,1) = Zero
        OccVec(i,2) = Zero
      end if
    end do
  else
    ntmp = nint(sum(OccVec(:,1:2)))
    OccVec(:,:) = Zero
    tmp1 = real(ntmp,kind=wp)
    do i=1,(ntmp+1)/2
      if (tmp1 >= Two) then
        qa = qa+One
        qb = qb+One
        OccVec(i,1) = One
        OccVec(i,2) = One
        tmp1 = tmp1-Two
      else if (tmp1 >= One) then
        qa = qa+One
        qb = qb+Zero
        OccVec(i,1) = One
        OccVec(i,2) = Zero
        tmp1 = tmp1-One
      else
        OccVec(i,1) = Zero
        OccVec(i,2) = Zero
      end if
    end do
  end if
end if
#ifdef _DEBUGPRINT_
if (nD == 1) then
  write(u6,*) 'chklumo: Idempotency'
  write(u6,'(10f12.6)') (OccVec(i,1),i=1,nVec)
  write(u6,'(a,f12.6)') 'Tot charge         ',Tot_charge
  write(u6,'(a,f12.6)') 'Tot nuc. charge    ',Tot_nuc_charge
  write(u6,'(a,f12.6)') 'Tot el. charge     ',Tot_el_charge
  write(u6,'(a,f12.6)') 'Electron count     ',Two*qa
else
  write(u6,*) 'chklumo: Alpha idempotency'
  write(u6,'(10f12.6)') (OccVec(i,1),i=1,nVec)
  write(u6,*) 'chklumo: Beta idempotency'
  write(u6,'(10f12.6)') (OccVec(i,2),i=1,nVec)
  write(u6,'(a,f12.6)') 'Tot charge         ',Tot_charge
  write(u6,'(a,f12.6)') 'Tot nuc. charge    ',Tot_nuc_charge
  write(u6,'(a,f12.6)') 'Tot el. charge     ',Tot_el_charge
  write(u6,'(a,f12.6)') 'Alpha count        ',qa
  write(u6,'(a,f12.6)') 'Beta count         ',qb
end if
#endif
!----------------------------------------------------------------------*
! Is it the same charge.                                               *
!----------------------------------------------------------------------*
Skip = .false.
if (abs(qa+qb+Tot_el_charge) > half) then
# ifdef _DEBUGPRINT_
  write(u6,*) 'chklumo: System has changed charge!'
# endif
  Occset = .false.
  FermSet = .true.
  Skip = .true.
end if
!----------------------------------------------------------------------*
! Is it the same spin.                                                 *
!----------------------------------------------------------------------*
if (SpinSet .and. (.not. Skip)) then
# ifdef _DEBUGPRINT_
  write(u6,*) 'chklumo: System might have changed spin!'
  write(u6,*) '   iAu_ab=',iAu_ab
  write(u6,*) '   qa-qb=',qa-qb
# endif
  idiff = iAu_ab-int(qa-qb)
  if (idiff /= 0) then
#   ifdef _DEBUGPRINT_
    write(u6,*) '   yes indeed, spin has changed!'
#   endif
    Occset = .false.
    FermSet = .true.
    Skip = .true.
  end if
end if
if (.not. Skip) then
  !----------------------------------------------------------------------*
  ! Is it idempotent     D^2 = 2 D                                       *
  !----------------------------------------------------------------------*
  if (nD == 1) then
    Idem = .true.
    do i=1,nVec
      tmp = half*OccVec(i,1)*(One-half*OccVec(i,1))
      if (abs(tmp) > 0.1_wp) Idem = .false.
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) 'chklumo: Idempotency'
    write(u6,'(10f12.6)') (OccVec(i,1),i=1,nVec)
#   endif
  else
    Idem = .true.
    do i=1,nVec
      tmp = OccVec(i,1)*(One-OccVec(i,1))
      if (abs(tmp) > 0.1_wp) Idem = .false.
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) 'chklumo: Alpha idempotency'
    write(u6,'(10f12.6)') (OccVec(i,1),i=1,nVec)
#   endif
    do i=1,nVec
      tmp = OccVec(i,2)*(One-OccVec(i,2))
      if (abs(tmp) > 0.1_wp) Idem = .false.
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) 'chklumo: Beta idempotency'
    write(u6,'(10f12.6)') (OccVec(i,2),i=1,nVec)
#   endif
  end if
  !----------------------------------------------------------------------*
  ! Was it idempotent?                                                   *
  !----------------------------------------------------------------------*
  if (Idem) then
#   ifdef _DEBUGPRINT_
    write(u6,*) 'chklumo: Idempotent'
#   endif
    if (nD == 1) then
      iOff = 0
      do iSym=1,nSym
        n = sum(int(OccVec(iOff+1:iOff+nBas(iSym),1)))
        nOcc(iSym,1) = n/2
        iOff = iOff+nBas(iSym)
      end do
#     ifdef _DEBUGPRINT_
      write(u6,'(a,8i5)') 'Occupation       ',(nOcc(i,1),i=1,nSym)
#     endif
    else
      iOff = 0
      do iSym=1,nSym
        n = sum(int(OccVec(iOff+1:iOff+nBas(iSym),1)))
        nOcc(iSym,1) = n
        iOff = iOff+nBas(iSym)
      end do
      iOff = 0
      do iSym=1,nSym
        n = sum(int(OccVec(iOff+1:iOff+nBas(iSym),2)))
        nOcc(iSym,2) = n
        iOff = iOff+nBas(iSym)
      end do
#     ifdef _DEBUGPRINT_
      write(u6,'(a,8i5)') 'Alpha occupation ',(nOcc(i,1),i=1,nSym)
      write(u6,'(a,8i5)') 'Beta occupation  ',(nOcc(i,2),i=1,nSym)
#     endif
    end if
    Occset = .true.
    FermSet = .false.
  else
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Not idempotent'
#   endif
    Occset = .false.
    FermSet = .true.
  end if
end if
! If Fermi aufbau is explicitly disabled, force the plain occupation
if (FermSet .and. NoFerm) then
# ifdef _DEBUGPRINT_
  write(u6,*) 'Fermi aufbau disabled by the user'
# endif
  call mma_allocate(Ind,nVec,nD,label='Ind')
  Ind(:,:) = -1
  ! Sort orbital energies
  do iD=1,nD
    do i=1,nVec
      Tmp = huge(Tmp)
      ntmp = -1
      do j=1,nVec
        if (EpsVec(j,iD) < Tmp) then
          ntmp = j
          Tmp = EpsVec(j,iD)
        end if
      end do
      if (ntmp < 0) exit
      Ind(i,iD) = ntmp
      EpsVec(ntmp,iD) = huge(Tmp)
    end do
  end do
  OccVec(:,:) = Zero
  if (nD == 1) then
    ntmp = nint(-Tot_el_charge)/2
    do i=1,ntmp
      if (Ind(i,1) < 0) then
        call WarningMessage(2,'chklumo: Cannot find meaningful occupations')
        call Abend()
      end if
      OccVec(Ind(i,1),1) = Two
    end do
    iOff = 0
    do iSym=1,nSym
      n = sum(int(OccVec(iOff+1:iOff+nBas(iSym),1)))
      nOcc(iSym,1) = n/2
      iOff = iOff+nBas(iSym)
    end do
#   ifdef _DEBUGPRINT_
    write(u6,'(a,8i5)') 'Forced occupation       ',(nOcc(i,1),i=1,nSym)
    write(u6,'(10f12.6)') (OccVec(i,1),i=1,nVec)
#   endif
  else
    ntmp = (nint(-Tot_el_charge)-iAU_AB)/2
    do i=1,ntmp+iAU_AB
      if (Ind(i,1) < 0) then
        call WarningMessage(2,'chklumo: Cannot find meaningful occupations')
        call Abend()
      end if
      OccVec(Ind(i,1),1) = One
      if (i > ntmp) cycle
      if (Ind(i,2) < 0) then
        call WarningMessage(2,'chklumo: Cannot find meaningful occupations')
        call Abend()
      end if
      OccVec(Ind(i,2),2) = One
    end do
    iOff = 0
    do iSym=1,nSym
      n = sum(int(OccVec(iOff+1:iOff+nBas(iSym),1)))
      nOcc(iSym,1) = n
      iOff = iOff+nBas(iSym)
    end do
    iOff = 0
    do iSym=1,nSym
      n = sum(int(OccVec(iOff+1:iOff+nBas(iSym),2)))
      nOcc(iSym,2) = n
      iOff = iOff+nBas(iSym)
    end do
#   ifdef _DEBUGPRINT_
    write(u6,'(a,8i5)') 'Forced alpha occupation ',(nOcc(i,1),i=1,nSym)
    write(u6,'(10f12.6)') (OccVec(i,1),i=1,nVec)
    write(u6,'(a,8i5)') 'Forced beta occupation  ',(nOcc(i,2),i=1,nSym)
    write(u6,'(10f12.6)') (OccVec(i,2),i=1,nVec)
#   endif
  end if
  call mma_deallocate(Ind)
  OccSet = .true.
  FermSet = .false.
end if
!----------------------------------------------------------------------*
! Deallocate fields                                                    *
!----------------------------------------------------------------------*
call mma_deallocate(EpsVec)
call mma_deallocate(OccVec)
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine ChkLumo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_INIRSDIM()
C
C     Purpose: initialize reduced set dimension.
C
      use ChoArr, only: nDimRS
#include "implicit.fh"
#include "cholesky.fh"

      IF (RSTCHO) THEN
         ILOC = 3
         DO IRS = 1,XNPASS
            CALL CHO_GETRED(IRS,ILOC,.FALSE.)
            CALL CHO_SETREDIND(ILOC)
            CALL ICOPY(NSYM,NNBSTR(:,ILOC),1,nDimRS(:,iRS),1)
         END DO
         NSET = XNPASS
      ELSE
         CALL ICOPY(NSYM,NNBSTR(1,1),1,nDimRS,1)
         NSET = 1
      END IF

      NUM   = NSYM*(MAXRED - NSET)
      CALL IZERO(nDimRS(1,NSET+1),NUM)

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Roland Lindh                                     *
************************************************************************
      Subroutine DMP_EFP()
      use EFP_Module
      Integer CoorType
      Call Put_lScalar('EFP',lEFP)
      If (lEFP) Then
         Call Put_iScalar('nEFP_fragments',nEFP_fragments)
         CoorType=Coor_Type
         Call Put_iScalar('Coor_Type',CoorType)
         Call Put_cArray('FRAG_Type',FRAG_Type(1),180*nEFP_fragments)
         Call Put_cArray('ABC',ABC(1,1),3*180*nEFP_fragments)
         Call Put_iScalar('nEFP_Coor',nEFP_Coor)
         Call Put_dArray('EFP_COORS',EFP_COORS,nEFP_Coor*nEFP_fragments)
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_SetAtomShl(irc,iAtomShl,n)
!
! Purpose: set mapping from shell to atom (i.e., center).

use Cholesky, only: IPRINT, iSOShl, LuPri, nBasT, nShell, nSym
use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n
integer(kind=iwp), intent(out) :: irc, iAtomShl(n)
integer(kind=iwp) :: i, i1, i2, iAtom, iBatch, iSh, iSh0, iSh1, iSh2, nAtom, nBatch, nErr, nSh, numSh
integer(kind=iwp), allocatable :: nBas_per_Atom(:), nBas_Start(:)
character(len=LenIn+8), allocatable :: AtomLabel(:)
integer(kind=iwp), parameter :: Info_Debug = 4
#ifdef _DEBUGPRINT_
#define _DBG_ .true.
#else
#define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: Debug = _DBG_
character(len=*), parameter :: SecNam = 'Cho_SetAtomShl'

#ifdef _DEBUGPRINT_
write(Lupri,*) '>>> Enter ',SecNam
#endif

! Check.
! ------

irc = 0
if (nSym /= 1) then ! does not work with symmetry
  irc = 1
# ifdef _DEBUGPRINT_
  write(Lupri,*) '>>> Exit ',SecNam,' (error exit: symmetry not allowed!)'
# endif
  return
end if
if (n < nShell) call Cho_Quit(SecNam//': iAtomShl not allocated correctly!',104)

! Get number of atoms.
! --------------------

!call Get_nAtoms_All(nAtom)
call Get_iScalar('Bfn Atoms',nAtom)

! Get atomic labels and basis function labels.
! --------------------------------------------

call mma_allocate(AtomLabel,nBasT,Label='AtomLabel')
call Get_cArray('Unique Basis Names',AtomLabel,(LenIn+8)*nBasT)

! Allocate and get index arrays for indexation of basis functions on
! each atom.
! ------------------------------------------------------------------

call mma_allocate(nBas_per_Atom,nAtom,Label='nBas_per_Atom')
call mma_allocate(nBas_Start,nAtom,Label='nBas_Start')
call BasFun_Atom(nBas_per_Atom,nBas_Start,AtomLabel,nBasT,nAtom,Debug)
call mma_deallocate(AtomLabel)

! Set shell-to-atom mapping.
! --------------------------

do iAtom=1,nAtom
  i1 = nBas_Start(iAtom)
  i2 = i1+nBas_per_Atom(iAtom)-1
  do i=i1,i2
    iAtomShl(iSOShl(i)) = iAtom
  end do
end do

if ((iPrint >= Info_Debug) .or. Debug) then
  nErr = 0
  write(Lupri,*)
  write(Lupri,*) SecNam,': shell-to-atom mapping:'
  numSh = 7
  nBatch = (nShell-1)/numSh+1
  do iBatch=1,nBatch
    if (iBatch == nBatch) then
      nSh = nShell-numSh*(nBatch-1)
    else
      nSh = numSh
    end if
    iSh0 = numSh*(iBatch-1)
    iSh1 = iSh0+1
    iSh2 = iSh0+nSh
    write(Lupri,'(/,A,7(1X,I9))') 'Shell:',(iSh,iSh=iSh1,iSh2)
    write(Lupri,'(A,7(1X,I9))') 'Atom :',(iAtomShl(iSh),iSh=iSh1,iSh2)
    do iSh=iSh1,iSh2
      if ((iAtomShl(iSh) < 1) .or. (iAtomShl(iSh) > nAtom)) nErr = nErr+1
    end do
  end do
  if (nErr /= 0) call Cho_Quit(SecNam//': shell-to-atom init failed!',104)
end if

! Deallocations.
! --------------

call mma_deallocate(nBas_Start)
call mma_deallocate(nBas_per_Atom)

#ifdef _DEBUGPRINT_
write(Lupri,*) '>>> Exit ',SecNam
#endif

end subroutine Cho_SetAtomShl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Pickmo_MCLR(rmo,rmoaa,idsym)

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use MCLR_Data, only: ipMO, nA
use input_mclr, only: nAsh, nIsh, nOrb, nSym
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: rmo(*)
real(kind=wp), intent(_OUT_) :: rmoaa(*)
integer(kind=iwp), intent(in) :: idsym
integer(kind=iwp) :: iA, iAA, ijAA, ijkl, ipi, iS, jA, jAA, jS, kA, kAA, klAA, kS, lA, lAA, lS

do iS=1,nSym
  do jS=1,iS
    do kS=1,is
      ls = Mul(Mul(is,js),Mul(ks,idsym))
      if (ls <= ks) then
        do iA=1,nAsh(is)
          iAA = iA+nA(is)
          do jA=1,nAsh(js)
            jAA = jA+nA(js)
            ijAA = iTri(iAA,jAA)
            do kA=1,nAsh(ks)
              kAA = kA+nA(ks)
              do lA=1,nAsh(ls)
                lAA = lA+nA(ls)
                klAA = iTri(kAA,lAA)
                if (ijAA >= klAA) then
                  ijkl = iTri(ijAA,klAA)
                  ipi = ipMO(js,ks,ls)+nIsh(is)+iA-1+nOrb(is)*(jA-1)+nOrb(is)*nAsh(js)*(kA-1)+nOrb(is)*nAsh(js)*nAsh(ks)*(lA-1)
                  !ipi = ipMO(js,ks,ls)+(nOrb(is)*(jA-1+nAsh(js)*(kA-1+nAsh(ks)*(lA-1))))+nish(is)+iA-1
                  rmoaa(ijkl) = rmo(ipi)
                end if
              end do
            end do
          end do
        end do
      end if
    end do
  end do
end do

end subroutine Pickmo_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICEnSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Oskar Weser                                      *
!***********************************************************************

module orthonormalization

use Index_Functions, only: nTri_Elem
use general_data, only: nActEl, nBas, nDel, nDelt, nOrb, nSSH, nSym
use rasscf_global, only: nFr, nIn, nOrbt, nSec, nTot3, nTot4, Tot_Nuc_Charge
use output_ras, only: IPRLOC
use PrintLevel, only: USUAL
use blockdiagonal_matrices, only: blocksizes, delete, from_raw, from_symm_raw, new, t_blockdiagonal, to_raw
use linalg_mod, only: Canonical, Gram_Schmidt, Lowdin
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
private

#include "intent.fh"
#include "warnings.h"

public :: ON_scheme, ON_scheme_values, orthonormalize, t_ON_scheme

! TODO: Should be changed to default construction in the future.
! As of July 2019 the Sun and PGI compiler have problems.
type :: t_ON_scheme_values
  integer(kind=iwp) :: no_ON, Gram_Schmidt, Lowdin, Canonical
end type t_ON_scheme_values

! TODO: Dear fellow MOLCAS developer of the future:
! Please replace the following explicit constructur
! with the default constructor
!     instance = type()
! as soon as possible.
! As of July 2019 the Sun compiler requires explicit construction
! for parameter variables. (Which is wrong IMHO.)
type(t_ON_scheme_values), parameter :: ON_scheme_values = t_ON_scheme_values(no_ON=1,Gram_Schmidt=2,Lowdin=3,Canonical=4)

type :: t_ON_scheme
  integer(kind=iwp) :: val = ON_scheme_values%Gram_Schmidt
end type t_ON_scheme

type(t_ON_scheme) :: ON_scheme = t_ON_scheme()

!>  @brief
!>    Orthonormalize a basis.
!>
!>  @author
!>    Oskar Weser
!>
!>  @details
!>  Reads in the overlap matrix and orthonormalizes accordingly.
!>
!>  @param[in] basis Can be raw memory i.e. a 1D double array
!>    or a t_blockdiagonal matrix.
!>    return type depends on input type.
!>  @param[in] scheme Optional argument. The orthonormalization scheme to use.
!>    The possibilities are Gram_Schmidt, Lowdin, Canonical, or no_ON
!>    (no_orthonormalization)
!>    as given by orthonormalization::ON_scheme_values.
!>    For a detailed explanation see \cite szabo_ostlund (p. 143).
interface orthonormalize
  module procedure :: orthonormalize_raw, orthonormalize_blocks
end interface orthonormalize

contains

subroutine orthonormalize_blocks(basis,scheme,ONB)

  type(t_blockdiagonal), intent(in) :: basis(:)
  type(t_ON_scheme), intent(in) :: scheme
  type(t_blockdiagonal), intent(_OUT_) :: ONB(:)
  type(t_blockdiagonal), allocatable :: S(:)
  integer(kind=iwp) :: n_new(nSym), n_to_ON(nSym)

  ! gfortran -O0 warning bug
  allocate(S(0))
  call new(S,blocksizes=blocksizes(basis))
  call read_S(S)

  select case (scheme%val)
    case (ON_scheme_values%no_ON)
      !continue
    case (ON_scheme_values%Lowdin)
      call Lowdin_Blocks(basis,S,ONB)
    case (ON_scheme_values%Canonical)
      n_to_ON(:) = nBas(:nSym)-nDel(:nSym)
      call Canonical_Blocks(basis,S,n_to_ON,ONB,n_new)
      call update_orb_numbers(n_to_ON,n_new,nDel,nSSH,nOrb,nDelt,nSec,nOrbt,nTot3,nTot4)
    case (ON_scheme_values%Gram_Schmidt)
      n_to_ON(:) = nBas(:nSym)-nDel(:nSym)
      call Gram_Schmidt_Blocks(basis,S,n_to_ON,ONB,n_new)
      call update_orb_numbers(n_to_ON,n_new,nDel,nSSH,nOrb,nDelt,nSec,nOrbt,nTot3,nTot4)
  end select

  call delete(S)

end subroutine orthonormalize_blocks

subroutine orthonormalize_raw(CMO,scheme,ONB_v)

  real(kind=wp), intent(in) :: CMO(:)
  type(t_ON_scheme), intent(in) :: scheme
  real(kind=wp), intent(out) :: ONB_v(:)
  type(t_blockdiagonal), allocatable :: basis(:), ONB(:)

  ! gfortran -O0 warning bug
  allocate(basis(0))
  call new(basis,blocksizes=nBAS(:nSym))
  call new(ONB,blocksizes=nBAS(:nSym))

  call from_raw(CMO,basis)
  call orthonormalize(basis,scheme,ONB)
  call to_raw(ONB,ONB_v)

  call delete(ONB)
  call delete(basis)

end subroutine orthonormalize_raw

! TODO: It would be nice, to use `impure elemental`
! instead of the manual looping.
! As of July 2019 some compilers don't support it.
subroutine Lowdin_Blocks(basis,S,ONB)

  type(t_blockdiagonal), intent(in) :: basis(:), S(:)
  type(t_blockdiagonal), intent(_OUT_) :: ONB(:)
  integer(kind=iwp) :: i

  do i=1,size(basis)
    call Lowdin(basis(i)%blck,ONB(i)%blck,S(i)%blck)
  end do

end subroutine Lowdin_Blocks

! TODO: It would be nice, to use `impure elemental`
! instead of the manual looping.
! As of July 2019 some compilers don't support it.
subroutine Canonical_Blocks(basis,S,n_to_ON,ONB,n_new)

  type(t_blockdiagonal), intent(in) :: basis(:), S(:)
  integer(kind=iwp), intent(in) :: n_to_ON(:)
  type(t_blockdiagonal), intent(_OUT_) :: ONB(:)
  integer(kind=iwp), intent(out) :: n_new(:)
  integer(kind=iwp) :: i

  do i=1,size(basis)
    call Canonical(basis(i)%blck,n_to_ON(i),ONB(i)%blck,n_new(i),S(i)%blck)
  end do

end subroutine Canonical_Blocks

! TODO: It would be nice, to use `impure elemental`
! instead of the manual overloading.
! As of July 2019 some compilers don't support it.
subroutine Gram_Schmidt_Blocks(basis,S,n_to_ON,ONB,n_new)

  type(t_blockdiagonal), intent(in) :: basis(:), S(:)
  integer(kind=iwp), intent(in) :: n_to_ON(:)
  type(t_blockdiagonal), intent(_OUT_) :: ONB(:)
  integer(kind=iwp), intent(out) :: n_new(:)
  integer(kind=iwp) :: i

  do i=1,size(basis)
    call Gram_Schmidt(basis(i)%blck,n_to_ON(i),ONB(i)%blck,n_new(i),S(i)%blck)
  end do

end subroutine Gram_Schmidt_Blocks

subroutine update_orb_numbers(n_to_ON,nNew,nDel,nSSH,nOrb,nDelt,nSec,nOrbt,nTot3,nTot4)

  integer(kind=iwp), intent(in) :: n_to_ON(:), nNew(:)
  integer(kind=iwp), intent(inout) :: nDel(:), nSSH(:), nOrb(:), nDelt, nSec, nOrbt, nTot3, nTot4
  integer(kind=iwp) :: iSym, remove(nSym), total_remove

  remove = n_to_ON(:nSym)-nNew(:nSym)
  total_remove = sum(remove(:nSym))
  if (total_remove > 0) then
    do iSym=1,nSym
      if (nSSH(iSym) < remove(iSym)) then
        call WarningMessage(2,'Orthonormalization Error')
        write(u6,*) 'Exact or very near linear dependence '
        write(u6,*) 'forces RASSCF to stop execution.'
        write(u6,*) 'Symmetry block:',iSym
        write(u6,*) 'Effective NR of orthonormal orbs:',nNew(iSym)
        write(u6,*) 'Earlier number of deleted orbs:',nDel(iSym)
        write(u6,*) 'Earlier number of secondary orbs:',nSSH(iSym)
        write(u6,*) 'New number of deleted orbs:',nDel(iSym)+remove(iSym)
        write(u6,*) 'New number of secondary orbs:',nSSH(iSym)-remove(iSym)
        call quit(_RC_GENERAL_ERROR_)
      else if (iPRLoc(1) >= USUAL) then
        call WarningMessage(1,'Orthonormalization Warning')
        write(u6,*) 'Exact or very near linear dependence'
        write(u6,*) 'forces RASSCF to delete additional orbitals.'
        write(u6,*) 'Symmetry block:',iSym
        write(u6,*) 'Earlier number of deleted orbs =',nDel(iSym)
        write(u6,*) 'New number of deleted orbs =',nDel(iSym)+remove(iSym)
      end if
    end do
    nDel(:nSym) = nDel(:nSym)+remove(:nSym)
    nSSH(:nSym) = nSSH(:nSym)-remove(:nSym)
    nOrb(:nSym) = nOrb(:nSym)-remove(:nSym)
    nDelt = nDelt+total_remove
    nSec = nSec-total_remove
    nOrbt = nOrbt-total_remove
    nTot3 = sum(nTri_Elem(nOrb(:nSym)))
    nTot4 = sum(nOrb(:nSym)**2)
  end if

end subroutine update_orb_numbers

subroutine read_raw_S(S_buffer)

  use OneDat, only: sNoOri

  real(kind=wp), intent(inout) :: S_buffer(:)
  integer(kind=iwp) :: i_Component, i_Opt, i_Rc, i_SymLbl
  character(len=8) :: Label

  i_Rc = 0
  i_Opt = ibset(0,sNoOri)
  i_Component = 1
  i_SymLbl = 1
  Label = 'Mltpl  0'
  call RdOne(i_Rc,i_Opt,Label,i_Component,S_buffer,i_SymLbl)
  if (i_rc /= 0) then
    write(u6,*) ' RASSCF is trying to orthonormalize orbitals but'
    write(u6,*) ' could not read overlaps from ONEINT. Something'
    write(u6,*) ' is wrong with the file, or possibly with the'
    write(u6,*) ' program. Please check.'
    call quit(_RC_IO_ERROR_READ_)
  end if

end subroutine read_raw_S

subroutine read_S(S)

  type(t_blockdiagonal) :: S(nSym)
  integer(kind=iwp) :: size_S_buffer
  real(kind=wp) :: Mol_Charge
  real(kind=wp), allocatable :: S_buffer(:)

  size_S_buffer = sum(nTri_Elem(nBas(:nSym)))
  call mma_allocate(S_buffer,size_S_buffer+4)
  call read_raw_S(S_buffer)
  Tot_Nuc_Charge = S_buffer(size_S_buffer+4)
  call from_symm_raw(S_buffer,S)
  call mma_deallocate(S_buffer)

  Mol_Charge = Tot_Nuc_Charge-real(2*(nFr+nIn)+nActEl,kind=wp)
  call put_dscalar('Total Charge    ',Mol_Charge)
  if (IPRLOC(1) >= USUAL) then
    write(u6,*)
    write(u6,'(6x,A,f8.2)') 'Total molecular charge',Mol_Charge
  end if

end subroutine read_S

end module orthonormalization

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_TRDENS(irc,DLT,Salpha,istate,jstate,iType,DoExch,labB)
!
! Author:  F. Aquilante and F. Segatta, Bologna ca. Oct 2015
! Modified by A. Kaiser, 2022
!     Coulomb term from TDMAT  (level 2 BLAS) from Cholesky vectors
!
! --- V(J) = sum_gd  TDMAT(gd) * Lgd,J
!
!***********************************************************************

use Cholesky, only: InfVec, nBas, nDimRS, nSym, NumCho, timings
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, SBA_Type
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
type(DSBA_Type), intent(in) :: DLT(1), Salpha(1)
integer(kind=iwp), intent(in) :: istate, jstate, iType
logical(kind=iwp), intent(in) :: DoExch, labB
integer(kind=iwp) :: dimX, iAddr, iBatch, iCase, iLoc, IREDC, iSym, iSwap, IVEC2, iVrs, JNUM, JRED, JRED_, JRED1, JRED2, JSYM, &
                     JVEC, k, kMOs, LREAD, LuT, LuT1, LuT2, LuT_, LWork, MUSED, nBatch, nDen, nMOs, nRS, NUMV, nVec, nVrs
real(kind=wp) :: dimX_real(1), TCC1, TCC2, tcoul(2), TCR1, TCR2, TOTCPU, TOTCPU1, TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, tread(2), &
                 TWC1, TWC2, TWR1, TWR2
logical(kind=iwp) :: add, DoRead
character(len=50) :: CFmt
character(len=20) :: filnam1, filnam2
character(len=13) :: filnam
type(SBA_Type), target :: Ya(1)
real(kind=wp), allocatable :: Drs(:), Frs(:), Lrs(:), VJ(:)
character(len=*), parameter :: SECNAM = 'CHO_TRDENS'
integer(kind=iwp), external :: isFreeUnit
#ifdef _DEBUGPRINT_
real(kind=wp), external :: ddot_
#endif

irc = 0

IREDC = -1
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! For Coulomb only, the vectors symmetry is restricted to 1
JSYM = 1
if (NumCho(JSYM) < 1) return
write(filnam,'(A,I1,A,I3.3,A,I3.3)') 'WK_C',iType,'_',ISTATE,'_',JSTATE
LuT_ = 10
LuT = isFreeUnit(LuT_)
call molcas_open(LuT,filnam)
write(LuT,*) NumCho(JSYM)

! Create and open file WKX for DoExch
if (DoExch) then
  write(filnam1,'(A,I1,I2.2,I2.2)') 'X',iType,ISTATE,JSTATE
  LuT2 = 11
  LuT1 = isFreeUnit(LuT_)
  call DANAME(LuT1,filnam1)
  LuT2 = isFreeUnit(LuT_)
  write(filnam2,'(A)') 'nRedX'
  call DANAME(LuT2,filnam2)

  iSym = 1
  nRS = nDimRS(JSYM,1)
  dimX = nBas(iSym)*nBas(iSym)*NumCho(JSYM)
  dimX_real(1) = real(dimX,kind=wp)
  iAddr = 0
  call dDaFile(LuT2,1,dimX_real,1,iAddr)
  call DACLOS(LuT2)
end if

call CWTIME(TOTCPU1,TOTWALL1) ! start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = Zero ! time for reading the vectors
tcoul(:) = Zero ! time for computing Coulomb

iLoc = 3 ! use scratch location in reduced index arrays

JRED1 = InfVec(1,2,jSym)            ! red set of the 1st vec
JRED2 = InfVec(NumCho(jSym),2,jSym) ! red set of the last vec

do JRED=JRED1,JRED2

  ! Memory management section -----------------------------
  call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

  if (nVrs == 0) cycle

  if (nVrs < 0) then
    write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs < 0. STOP!!'
    call abend()
  end if

  call Cho_X_SetRed(irc,iLoc,JRED) ! set index arrays at iLoc
  if (irc /= 0) then
    write(u6,*) SECNAM//'cho_X_setred non-Zero return code. rc= ',irc
    call abend()
  end if

  nRS = nDimRS(JSYM,JRED)

  call mma_allocate(Drs,nRS,Label='Drs')
  call mma_allocate(Frs,nRS,Label='Frs')
  Drs(:) = Zero
  Frs(:) = Zero

  call mma_maxDBLE(LWork)
  nVec = min(LWORK/(nRS+1),nVrs)

  if (nVec < 1) then
    write(u6,*) SECNAM//': Insufficient memory for batch'
    write(u6,*) 'LWORK= ',LWORK
    write(u6,*) 'min. mem. need= ',nRS+1
    irc = 33
    call Abend()
    nBatch = -9999 ! dummy assignment
  end if

  LREAD = nRS*nVec

  call mma_allocate(Lrs,LREAD,Label='Lrs')

  call mma_allocate(VJ,nVec,Label='VJ')
  add = .false.
  nDen = 1
  ! Transform the density to reduced storage

  call swap_full2rs(irc,iLoc,nRS,nDen,JSYM,DLT,Drs,add)

  nBatch = (nVrs-1)/nVec+1

  iSym = 1

  do iBatch=1,nBatch

    if (iBatch == nBatch) then
      JNUM = nVrs-nVec*(nBatch-1)
    else
      JNUM = nVec
    end if

    JVEC = nVec*(iBatch-1)+iVrs
    IVEC2 = JVEC-1+JNUM

    call CWTIME(TCR1,TWR1)
    JRED_ = JRED
    call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,JRED_,MUSED)
    if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
      irc = 77
      return
    end if

    call CWTIME(TCR2,TWR2)
    tread(1) = tread(1)+(TCR2-TCR1)
    tread(2) = tread(2)+(TWR2-TWR1)

    ! ************ BEGIN COULOMB CONTRIBUTION  ****************
    !
    ! Computing the intermediate vector V(J)
    !
    ! Contraction with the density matrix
    ! -----------------------------------
    ! V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * D(rs)
    !==========================================================

    call CWTIME(TCC1,TWC1)

    call DGEMV_('T',nRS,JNUM,ONE,Lrs,nRS,Drs,1,Zero,VJ,1)

    ! Coulomb intermediate wrote to file
    write(LuT,*) (VJ(k),k=1,JNUM)

    call CWTIME(TCC2,TWC2)
    tcoul(1) = tcoul(1)+(TCC2-TCC1)
    tcoul(2) = tcoul(2)+(TWC2-TWC1)

    ! --- Exchange term
    ! ******************  L(ps,{#J}) * G(q,s)  ****************

    if (labB) then
      iSwap = 1 ! L(k,b,J) are returned
    else
      iSwap = 0 ! L(a,k,J) are returned
    end if

    if (doexch) then

      iSym = 1
      iCase = 0
      DoRead = .false.

      call Allocate_DT(Ya(1),nBas,nBas,JNUM,JSYM,nSYm,iCase)

      kMOs = 1
      nMOs = 1

      !********************************************************

      ! sending in Salpha and then print ddot of the result
      call Cho_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,Salpha,Ya,DoRead)
#ifdef _DEBUGPRINT_
      write(u6,*) 'ddot Y * Y from Salpha'
      write(u6,*) ddot_(dimX,Ya(1)%A0,1,Ya(1)%A0,1)
#endif
      iAddr = 0
      call dDaFile(LuT1,1,Ya(1)%A0(1),dimX,iAddr)
      call Deallocate_DT(Ya(1))

    end if

  end do  !end batch loop
  close(LuT)
  if (DoExch) call DACLOS(LuT1)

  ! free memory
  call mma_deallocate(VJ)
  call mma_deallocate(Lrs)
  call mma_deallocate(Frs)
  call mma_deallocate(Drs)

end do ! loop over red sets

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky SCF timing from '//SECNAM
  write(u6,CFmt) '-----------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Fock matrix construction        CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ VECTORS                              ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COULOMB                                   ',tcoul(1),tcoul(2)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

irc = 0

return

end subroutine CHO_TRDENS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine XDR_fpFW(n,s,t,v,w,Tr,Bk,EL,ES,OL,OS,P,E0,A,B,R,clight)
! Transform to moment space ( eigenfunction space of non-relativistic kinetic matrix T )
!   and apply the free-particle Foldy-Wothuysen transformation to the Fock matrices

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Two
use Definitions, only: wp, iwp

implicit none
! Input
!   w   aka pVp
! Output :
!   Tr     transform matrix to moment space
!   Bk     back transform matrix of moment space =Tr^{-1}
!   ( EL OL )
!   ( OS ES ) represent the structure of potential matrix in fpFW space
!   P      kinetic matrix (diagonal) in fpFW space, aka Ep
!   E0     =P-mc^{2}
!   A,B,R  kinetic factors (used to construct the fpFW transformation in moment space)
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: s(n,n), t(n,n), v(n,n), w(n,n), clight
real(kind=wp), intent(out) :: Tr(n,n), Bk(n,n), EL(n,n), ES(n,n), OL(n,n), OS(n,n), P(n), E0(n), A(n), B(n), R(n)
integer(kind=iwp) :: i, j, lwork, info
real(kind=wp) :: av, aw
real(kind=wp), allocatable :: tmp(:), sW(:), sA(:,:), sB(:,:)

! Diagonalization

lwork = 8*n
call mma_allocate(tmp,lwork,label='Tmp')
call mma_allocate(sW,n,label='Eig')
Tr(:,:) = t(:,:)
Bk(:,:) = s(:,:)
call dsygv_(1,'V','L',n,Tr,n,Bk,n,sW,tmp,lwork,info)

! Transform potential matrices to moment space

call mma_allocate(sA,n,n,label='TmpA')
call mma_allocate(sB,n,n,label='TmpB')
call dmxma(n,'C','N',Tr,v,Bk,One)
call dmxma(n,'N','N',Bk,Tr,sA,One)
call dmxma(n,'C','N',Tr,w,Bk,One)
call dmxma(n,'N','N',Bk,Tr,sB,One)

! Calculate kinetic moment factors

do i=1,n
  P(i) = sqrt(clight*clight+sW(i)*Two)*clight
  A(i) = sqrt((P(i)+clight*clight)/(P(i)+P(i)))
  B(i) = clight/sqrt(Two*P(i)*(P(i)+clight*clight))
  R(i) = sqrt(sW(i)*Two)*clight/(P(i)+clight*clight)
  ! E0 equal to Ep-c^{2}, but this formula is more stable, especially E0 close to zero
  E0(i) = Two*sW(i)*clight*clight/(P(i)+clight*clight)
end do

! Multiply potential matrices with moment factors
!   aka the fpFW transformation in moment space

do i=1,n
  do j=1,n
    av = sA(j,i)*A(i)*A(j)
    aw = sB(j,i)*B(i)*B(j)
    EL(j,i) = av+aw
    ES(j,i) = aw/R(i)/R(j)+av*R(i)*R(j)
    OL(j,i) = aw/R(i)-av*R(i)
    OS(j,i) = aw/R(j)-av*R(j)
  end do
end do
Bk(:,:) = Tr(:,:)

! Make back transform matrix

call XDR_dmatinv(Bk,n)

! Free temp memories

call mma_deallocate(tmp)
call mma_deallocate(sW)
call mma_deallocate(sA)
call mma_deallocate(sB)

return

end subroutine XDR_fpFW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CRESTR_GAS(STRING,NSTINI,NSTINO,NEL,NORB,IORBOF,Z,NEWORD,TI,TTO,NACOB)
! A type of strings containing NEL electrons are given
! set up all possible ways of adding an electron to this type of strings
!
!========
! Input :
!========
! STRING : Input strings containing NEL electrons
! NSTINI : Number of input  strings
! NSTINO : Number of output strings
! NEL    : Number of electrons in input strings
! NORB   : Number of orbitals
! IORBOF : Number of first orbital
! Z      : Lexical ordering matrix for output strings containing
!          NEL + 1 electrons
! NEWORD : Reordering array for N+1 strings
! LSGSTR : /= 0 => Include sign arrays ISGSTI,ISGSTO of strings
! ISGSTI : Sign array for NEL   strings
! ISGSTO : Sign array for NEL+1 strings
!
!=========
! Output :
!=========
!
!TI      : TI(I,ISTRIN) > 0 indicates that orbital I can be added
!          to string ISTRIN .
!TTO     : Resulting NEL + 1 strings
!          if the string have a negative sign
!          then the phase equals - 1

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSTINI, NEL, STRING(NEL,NSTINI), NSTINO, NORB, IORBOF, Z(NORB,NEL+1), NEWORD(NSTINO), NACOB
integer(kind=iwp), intent(out) :: TI(NORB,NSTINI), TTO(NORB,NSTINI)
integer(kind=iwp) :: IEL, IIISGN, IORB, IPLACE, ISTRIN, JSTRIN, STRIN2(500)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I, NPR
#endif
integer(kind=iwp), external :: ISTRNM

#ifdef _DEBUGPRINT_
write(u6,*) ' ==============='
write(u6,*) ' CRESTR speaking'
write(u6,*) ' ==============='
write(u6,*)
write(u6,*) ' Number of input electrons ',NEL
!write(u6,*) ' Reorder array NEWORD'
!call IWRTMA(NEWORD,1,NSTINO,1,NSTINO)
#endif

do ISTRIN=1,NSTINI
  do IORB=IORBOF,IORBOF-1+NORB

    IPLACE = 0

    if (NEL == 0) then

      IPLACE = 1

    else if (NEL /= 0) then

      do IEL=1,NEL
        if ((IEL == 1) .and. (STRING(1,ISTRIN) > IORB)) then
          IPLACE = 1
          exit
        else if (((IEL == NEL) .and. (IORB > STRING(IEL,ISTRIN))) .or. &
                 ((IEL < NEL) .and. (IORB > STRING(IEL,ISTRIN)) .and. (IORB < STRING(min(NEL,IEL+1),ISTRIN)))) then
          IPLACE = IEL+1
          exit
        else if (STRING(IEL,ISTRIN) == IORB) then
          IPLACE = 0
          exit
        end if
      end do

    end if

    if (IPLACE == 0) cycle

    ! Generate next string
    STRIN2(1:IPLACE-1) = STRING(1:IPLACE-1,ISTRIN)
    STRIN2(IPLACE) = IORB
    STRIN2(IPLACE+1:NEL+1) = STRING(IPLACE:NEL,ISTRIN)
    !write(u6,*) ' updated string (STRIN2)'
    !call iwrtma(STRIN2,1,NEL+1,1,NEL+1)
    JSTRIN = ISTRNM(STRIN2,NACOB,NEL+1,Z,NEWORD,1)
    !write(u6,*) ' corresponding number ',JSTRIN

    TTO(IORB-IORBOF+1,ISTRIN) = JSTRIN
    IIISGN = (-1)**(IPLACE-1)
    !if (LSGSTR /= 0) IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
    if (IIISGN == -1) TTO(IORB-IORBOF+1,ISTRIN) = -TTO(IORB-IORBOF+1,ISTRIN)
    TI(IORB-IORBOF+1,ISTRIN) = IORB

  end do

end do

#ifdef _DEBUGPRINT_
NPR = min(NSTINI,60)
write(u6,*) ' Output from CRESTR :'
write(u6,*) '==================='

write(u6,*)
write(u6,*) ' Strings with an electron added'
do ISTRIN=1,NPR
  write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' New strings.. ',(TTO(I,ISTRIN),I=1,NORB)
end do
do ISTRIN=1,NPR
  write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' orbitals added or removed ',(TI(I,ISTRIN),I=1,NORB)
end do
#endif

end subroutine CRESTR_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine cht3(ireturn)
c
c main driver for (T)
c
        implicit none
c
#include "cht3_casy.fh"
#include "cht3_ccsd1.fh"
#include "files.fh"
#include "cht3_reord.fh"
#include "WrkSpc.fh"
        integer ireturn
c DIRCC
cmp!        include 'memvir_inc'
#include "ccsd_t3compat.fh"
c
        integer wrksize
        integer maxspace
c
        integer isize
        integer iOE,ioeh,ioep
c       integer itmp,iW2,il1_1,ioff
c
        integer i,nOrbE,nBas(8),nOrb(8)
        character*24 Label
        logical Found
cmp
cmp
cmp
c       vynuluj hodiny
        Call CWTime(TCpu,TWall)
        TCpu0=TCpu
        TWall0=TWall
        TCpu_l=TCpu
        TCpu_l=TCpu
        TWall_l=TWall
        TWall_l=TWall
cmp
c.0        read input
c
        call IniReord_t3 (NvGrp,wrksize)
c
c.0.1        generate name convention for blocked integrals and T2 files
c
        call DefParReord_t3 (NvGrp,maxdim)
        if (printkey.ge.10) then
           write (6,*) 'Maxdim of virtual segment from CCSD = ',
     & maxdim
        end if
c
c.0.2        def commons for DIRCC
c
        call defcommon (nfr,no,nv)
c
c.2.2   regenerate integrals from the Cholesky vectors (L1) L1(m,I ,A'')
c
c.2.2.1 (vo|vo) for testing purpose
c
c        isize=nc*no*nv
c!        write (6,*) 'size for l1_1 ',isize
c!        write (6,*) 'size for l1_2 ',isize
c        Call GetMem('cht3_l1_1','Allo','Real',il1_1,isize)
c        Call GetMem('cht3_itmp','Allo','Real',itmp,isize)
c        isize=nv*nv*no*no
c!        write (6,*) 'size for W2 ',isize
c        Call GetMem('cht3_W2','Allo','Real',iW2,isize)
c        call gen_vvoo(Work(iW2),Work(il1_1),Work(itmp))
c
c.2.2.2 get orbital energies

c
c*      Get Oorital energies
c
        call Get_iArray('nBas',nBas,1)
        call Get_iArray('nOrb',nOrb,1)

        isize=nBas(1)

        if (printkey.ge.10) then
           write (6,*) 'Allocating memory for (tmp) OE files',
     &                  isize
        end if

        call GetMem('cht3_oe','Allo','Real',iOE,isize)
c
        Label='OrbE'
        Call qpg_dArray(Label,Found,nOrbE)
        if (nOrbE.ne.nBas(1)) then
          write (6,*) 'Warning! in cht3 : (nOrbE.ne.nBas)!'
        end if
        If(.not.Found .or. nOrbE.eq.0) Then
          Call SysAbendMsg('get_orbe','Did not find:',Label)
        End If
        if (printkey.ge.10) then
        write (6,*) 'isize = ',isize
        write (6,*) 'norbe = ',norbe
        end if
        call Get_dArray(Label,Work(iOE),nOrbE)
c
c        write out the orbital energies
c
        if (printkey.ge.10) then
           write (6,*)
           write (6,*) 'Orbital energies for nfr+no+nv'
           write (6,*)
           do i=1,nfr+no+nv
           write (6,'(A,2x,i5,2x,f18.10)') 'Orbital Energy ',
     &                                     i,Work(iOE+i-1)
           end do
        end if

c2.2.3        make OEH, OEP
c
        isize=2*no
         call GetMem('cht3_oeh','Allo','Real',ioeh,isize)
        isize=2*nv
         call GetMem('cht3_oeh','Allo','Real',ioep,isize)
c
        call generate_juzekOE (Work(ioe+nfr),
     & Work(ioeh),Work(ioep),no,nv)
c
c.2.3   Checkpoint. Calculate MP2 energy
c
c        call calc_MP2 (Work(iW2),Work(iOE+nfr),no,nv)
c        call abend()
c
c.3        start (T) calculation
c
        call GetMem('(T)','Max','Real',maxspace,maxspace)
c
        write (6,*)
        write (6,'(A,i13,A,f9.1,A,f5.1,A)')
     & ' Memory available for (T) calc = ',
     & (maxspace-1),' in r*8 Words',
     & ((maxspace-1)*8.0d0)/(1024*1024),' Mb',
     & ((maxspace-1)*8.0d0)/(1024*1024*1024),' Gb'
c
cmp        call GetMem('t3_ampl_bti','Allo','Real',ioff,1)
cmp        ioff=ioff+1
cmp!        write (6,*) 'ioe   = ',ioe
cmp!        write (6,*) 'ioeh  = ',ioeh
cmp!        write (6,*) 'ioep  = ',ioep
cmp        write (6,*) 'ioff volny  = ',ioff
cmp!        kvir1=ioff+1
cmp!        kvir2=kvir1+(maxspace-1)-1
c
c toto sa da vyhodit a nahradit iba natvrdo definovanim kvir
cmp        call adapt_mem(Work(1),Work(ioff),(maxspace-1),
cmp     & kvir1,kvir2)
c
c!        call alloc_vm(WORK, maxspace, KVIR1, KVIR2)
c
cmp        write (6,*) ' kvir1 = ',kvir1
cmp        write (6,*) ' kvir2 = ',kvir2
c
cmp        call T3AMPL_BTI(Work(ioff),Work(ioeh),Work(ioep))

        call T3AMPL_BTI(Work(ioeh),Work(ioep))
c
c.2.4        Free the unnecessary memory
c
cmp        isize=nfr+no+nv
cmp        isize=nOrb(1)
        isize=nBas(1)
        call GetMem('cht3_oeh','Free','Real',iOE,isize)
c
        isize=2*no
         call GetMem('cht3_oeh','Free','Real',ioeh,isize)
        isize=2*nv
         call GetMem('cht3_oeh','Free','Real',ioep,isize)
cmp        ioff=ioff-1
cmp        call GetMem('t3_ampl_bti','Free','Real',ioff,1)

c!        call GetMem('t3_ampl_bti','Free','Real',ioff,maxspace)
c
        !Call EndGlb

        ireturn = 0
        return
        end
c
c --------------
c
cmp!        subroutine adapt_mem(W1st,Wfree,maxsize,kvir1,kvir2)
cmp!c
cmp!        implicit none
cmp!        real*8 W1st(2)
cmp!        real*8 Wfree(2)
cmp!        integer locw
cmp!        integer maxsize
cmp!        integer kvir1,kvir2
cmp!        integer loc_1st,loc_free
cmp!#ifdef LOC
cmp!        integer loc
cmp!        external loc
cmp!#endif
cmp!        loc_1st=loc(W1st)
cmp!        loc_free=loc(Wfree)
cmp!        write(0,'(a,i21,2x,a)') 'FAKE ALLOC_VM,   W1st  =', loc_1st,
cmp!     &                          'byte address'
cmp!        write(0,'(a,i21,2x,a)') 'FAKE ALLOC_VM,   Wfree =', loc_free,
cmp!     &                          'byte address'
cmp!c
cmp!        kvir1= ( (loc_free - loc_1st)/8 + 1 )
cmp!        kvir2=kvir1+maxsize-1
cmp!c
cmp!      write(6,'(a,i21,2x,a)') 'FAKE ALLOC_VM, MAXSIZE =', maxsize,
cmp!     $     'real*8 words'
cmp!      write(6,'(a,i21,2x,a)') 'FAKE ALLOC_VM, KVIR1   =', KVIR1,
cmp!     $     'real*8 words'
cmp!      write(6,'(a,i21,2x,a)') 'FAKE ALLOC_VM, KVIR2   =', KVIR2,
cmp!     $     'real*8 words'
cmp!        return
cmp!        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Exp_2(Vector,n1,n2,Array,Fact)
!***********************************************************************
!                                                                      *
! Object: expand an array.                                             *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n1, n2
real(kind=wp), intent(out) :: Vector(n1,n2)
real(kind=wp), intent(in) :: Array(n2), Fact
integer(kind=iwp) :: i1

do i1=1,n1
  Vector(i1,:) = Array*Fact
end do

return

end subroutine Exp_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
************************************************************************
************************************************************************
*                                                                      *
* This routine uppercases a text string.                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-AAke Malmqvist                                          *
*          Lund University                                             *
*                                                                      *
************************************************************************
      Subroutine UpCase(string)
      Character*(*)  string
      Character*26   up,lw
      Dimension      itab(0:255)
      Save           up,lw,ifset,itab

      Data up    /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      Data lw    /'abcdefghijklmnopqrstuvwxyz'/
      Data ifset / 0 /

      If (ifset.eq.0) Then
        ifset=1
        Do i=0,255
          itab(i)=i
        End Do
        Do ii=1,26
          i=ichar(up(ii:ii))
          j=ichar(lw(ii:ii))
          itab(j)=i
        End Do
      End If

      Do ii=1,len(string)
        i=ichar(string(ii:ii))
        j=itab(i)
        string(ii:ii)=char(j)
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKWWOP(IVEC,JVEC,OP0,OP1,NOP2,OP2,NOP3,OP3)
! Presently symmetry blocking is disregarded for OP2, OP3, but
! index pair C permutation symmetry is used.
! NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
! NOP3=(NASHT**2+2 over 3)  (Binomial coefficient)

! Given the coefficients for two excitation operators in the
! vectors numbered IVEC and C JVEC on file, construct the
! zero-, one-, two-, and three-body
! expansions of the product (Op in IVEC conjugated)(Op in JVEC)
! as operating on the CASSCF space.

use caspt2_module, only: NASHT
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC, NOP2, NOP3
real(kind=wp), intent(out) :: OP0, OP1(NASHT,NASHT), OP2(NOP2), OP3(NOP3)

OP0 = Zero
OP1(:,:) = Zero
OP2(:) = Zero
OP3(:) = Zero
call MKWWOPA(IVEC,JVEC,OP1,NOP2,OP2,NOP3,OP3)
call MKWWOPB(IVEC,JVEC,OP0,OP1,NOP2,OP2)
call MKWWOPC(IVEC,JVEC,OP1,NOP2,OP2,NOP3,OP3)
call MKWWOPD(IVEC,JVEC,OP1,NOP2,OP2)
call MKWWOPE(IVEC,JVEC,OP0,OP1)
call MKWWOPF(IVEC,JVEC,NOP2,OP2)
call MKWWOPG(IVEC,JVEC,OP1)
call MKWWOPH(IVEC,JVEC,OP0)

end subroutine MKWWOP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2002, Roland Lindh                                *
************************************************************************
      SubRoutine RctFld(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq)
************************************************************************
*                                                                      *
*     Driver for RctFld_                                               *
*                                                                      *
************************************************************************
      use PCM_arrays, only: MM
      Implicit Real*8 (A-H,O-Z)
      Real*8 h1(nh1), TwoHam(nh1), D(nh1)
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
#include "stdalloc.fh"
      Logical First, Dff, NonEq
      Real*8, Allocatable:: Vs(:,:), QV(:,:)
*
      nComp=(lMax+1)*(lMax+2)*(lMax+3)/6
      call mma_Allocate(Vs,nComp,2,Label='Vs')
      call mma_Allocate(QV,nComp,2,Label='QV')
*
      Call RctFld_(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq,
     &             MM,nComp,Vs,QV)
*
      Call mma_deallocate(Vs)
      Call mma_deallocate(QV)
*
      Return
      End
      SubRoutine RctFld_(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq,
     &                   Q_solute,nComp,Vs,QV)
************************************************************************
*                                                                      *
* Object: to apply a modification to the one-electron hamiltonian due  *
*         the reaction field. The code here is direct!                 *
*         This subroutine works only if a call to GetInf has been      *
*         prior to calling this routine.                               *
*                                                                      *
*         h1: one-electron hamiltonian to be modified. Observe that    *
*             the contribution due to the reaction field is added to   *
*             this array, i.e. it should be set prior to calling this  *
*             routine.                                                 *
*                                                                      *
*         TwoHam: dito two-electron hamiltonian.                       *
*                                                                      *
*         D:  the first order density matrix                           *
*                                                                      *
*         h1, TwoHam and D are all in the SO basis.                    *
*                                                                      *
*         Observe the energy expression for the electric field -       *
*         charge distribution interaction!                             *
*                                                                      *
*         -1/2 Sum(nl) E(tot,nl)M(tot,nl)                              *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             July '92                                                 *
*                                                                      *
*             Modified for nonequilibrum calculations January 2002 (RL)*
************************************************************************
      use Basis_Info, only: nBas
      use External_Centers, only: XF
      use Temporary_Parameters, only: PrPrt
      use Real_Info, only: PotNuc
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      Real*8 h1(nh1), TwoHam(nh1), D(nh1), Origin(3)
      Character*72 Label
      Character*8 Label2
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
      Logical First, Dff, NonEq
      Real*8 Q_solute(nComp,2), Vs(nComp,2), QV(nComp,2)
      Dimension FactOp(1), lOper(1)
*
*-----Statement Functions
*
      iOff(ixyz) = ixyz*(ixyz+1)*(ixyz+2)/6
*
      iRout = 1
      iPrint = nPrint(iRout)
*
      lOper(1)=1
      nOrdOp=lMax
*-----Set flag so only the diagonal blocks are computed
      Prprt=.True.
      Call FZero(Origin,3)
*
*-----Generate local multipoles in the primitive basis and accumulate to
*     global multipoles.
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*-----Add nuclear-nuclear contribution to the potential energy
*
      If (First) Then
*
         If (NonEq) Then
            Call Get_dArray('RCTFLD',QV,nComp*2)
            Call Get_dScalar('E_0_NN',E_0_NN)
         End If
*1)
*
*------- Compute M(nuc,nl), nuclear multipole moments
*
         Do iMax = 0, lMax
            ip = 1+iOff(iMax)
            Call RFNuc(Origin,Q_solute(ip,1),iMax)
         End Do

         if(Allocated(XF)) Then
*
*------- Add contribution from XFIELD multipoles
*
*        Use Vs as temporary space, it will anyway be overwritten
            Call XFMoment(lMax,Q_solute,Vs,nComp,Origin)
         EndIf

         If (iPrint.ge.99) Call RecPrt('Nuclear Multipole Moments',
     &                                 ' ',Q_solute(1,1),1,nComp)
*
*--------Solve dielectical equation(nuclear contribution), i.e.
*        M(nuc,nl) -> E(nuc,nl)
*
         call dcopy_(nComp,Q_solute(1,1),1,Vs(1,1),1)
         Call AppFld(Vs(1,1),rds,Eps,lMax,EpsInf,NonEq)
*
         If (iPrint.ge.99) Call RecPrt('Nuclear Electric Field',
     &                                 ' ',Vs(1,1),1,nComp)
*
*--------Vnn = Vnn - 1/2 Sum(nl) E(nuc,nl)*M(nuc,nl)
*
         RepNuc = PotNuc -
     &            Half * DDot_(nComp,Q_solute(1,1),1,Vs(1,1),1)
*
*------- Add contibutions due to slow counter charges
*
         If (NonEq) RepNuc=RepNuc+E_0_NN
         If (iPrint.ge.99) Write (6,*) ' RepNuc=',RepNuc
*2)
*
*--------Compute contibution to the one-electron hamiltonian
*
*        hpq = hpq + Sum(nl) E(nuc,nl)*<p|M(nl)|q>
*
         If (iPrint.ge.19) Then
            Write (6,*) 'h1'
            lOff = 1
            Do iIrrep = 0, nIrrep-1
               n = nBas(iIrrep)*(nBas(iIrrep)+1)/2
               If (n.gt.0) Then
                  Write (Label,'(A,I1)')
     &             'Diagonal Symmetry Block ',iIrrep+1
                  Call Triprt(Label,' ',h1(lOff),nBas(iIrrep))
                  lOff = lOff + n
               End If
            End Do
         End If
*
*------- Add potential due to slow counter charges
*
         If (NonEq) Then
            call dcopy_(nComp,QV(1,1),1,QV(1,2),1)
            Call AppFld_NonEQ_2(QV(1,2),rds,Eps,lMax,EpsInf,NonEq)
            Call DaXpY_(nComp,One,QV(1,2),1,Vs(1,1),1)
         End If
*
         Call Drv2_RF(lOper(1),Origin,nOrdOp,Vs(1,1),lMax,h1,nh1)
*
         If (iPrint.ge.19) Then
            Write (6,*) 'h1(mod)'
            lOff = 1
            Do iIrrep = 0, nIrrep-1
               n = nBas(iIrrep)*(nBas(iIrrep)+1)/2
               If (n.gt.0) Then
                  Write (Label,'(A,I1)')
     &             'Diagonal Symmetry Block ',iIrrep+1
                  Call Triprt(Label,' ',h1(lOff),nBas(iIrrep))
                  lOff = lOff + n
               End If
            End Do
         End If
*
*------- Update h1 and RepNuc_save with respect to static contributions!
*
         Label2='PotNuc00'
         Call Put_Temp(Label2,[RepNuc],1)
         Label2='h1_raw  '
         Call Put_Temp(Label2,h1,nh1)
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute the electronic contribution to the charge distribution.
*
*3)
*     M(el,nl) =  - Sum(p,q) Dpq <p|M(nl)|q>
*
      nOpr=1
      FactOp(1)=One
*-----Reset array for storage of multipole moment expansion
      call dcopy_(nComp,[Zero],0,Q_solute(1,2),1)
      Do iMltpl = 1, lMax
         Do ix = iMltpl, 0, -1
            If (Mod(ix,2).eq.0) Then
               iSymX=1
            Else
               ixyz=1
               iSymX=2**IrrFnc(ixyz)
               If (Origin(1).ne.Zero) iSymX = iOr(iSymX,1)
            End If
            Do iy = iMltpl-ix, 0, -1
               If (Mod(iy,2).eq.0) Then
                  iSymY=1
               Else
                  ixyz=2
                  iSymY=2**IrrFnc(ixyz)
                  If (Origin(2).ne.Zero) iSymY = iOr(iSymY,1)
               End If
               iz = iMltpl-ix-iy
               If (Mod(iz,2).eq.0) Then
                  iSymZ=1
               Else
                  ixyz=4
                  iSymZ=2**IrrFnc(ixyz)
                  If (Origin(3).ne.Zero) iSymZ = iOr(iSymZ,1)
               End If
*
               iTemp = MltLbl(iSymX,MltLbl(iSymY,iSymZ))
               lOper(1)=iOr(lOper(1),iTemp)
            End Do
         End Do
      End Do
      If (iPrint.ge.19) Then
         Write (6,*) '1st order density'
         lOff = 1
         Do iIrrep = 0, nIrrep-1
            n = nBas(iIrrep)*(nBas(iIrrep)+1)/2
            Write (Label,'(A,I1)')
     &       'Diagonal Symmetry Block ',iIrrep+1
            Call Triprt(Label,' ',D(lOff),nBas(iIrrep))
            lOff = lOff + n
         End Do
      End If
*
      Call Drv1_RF(FactOp,nOpr,D,nh1,Origin,lOper,Q_solute(1,2),lMax)
*
      If (iPrint.ge.99) Call RecPrt('Electronic Multipole Moments',
     &                              ' ',Q_solute(1,2),1,nComp)
*
*-----Solve dielectical equation(electronic contribution), i.e.
*     M(el,nl) -> E(el,nl)
*
      call dcopy_(nComp,Q_solute(1,2),1,Vs(1,2),1)
      Call AppFld(Vs(1,2),rds,Eps,lMax,EpsInf,NonEq)
      If (iPrint.ge.99) Call RecPrt('Electronic Electric Field',
     &                              ' ',Vs(1,2),1,nComp)
*4)
*
*-----Compute contribution to the two-electron hamiltonian.
*
*     T(D)pq = T(D)pq + Sum(nl) E(el,nl)*<p|M(nl)|q>
*
      Call Drv2_RF(lOper(1),Origin,nOrdOp,Vs(1,2),lMax,TwoHam,nh1)
*
      If (iPrint.ge.19) Then
         Write (6,*) 'h1(mod)'
         lOff = 1
         Do iIrrep = 0, nIrrep-1
            n = nBas(iIrrep)*(nBas(iIrrep)+1)/2
            If (n.gt.0) Then
               Write (Label,'(A,I1)')
     &          'Diagonal Symmetry Block ',iIrrep+1
               Call Triprt(Label,' ',h1(lOff),nBas(iIrrep))
               lOff = lOff + n
            End If
         End Do
         Write (6,*) 'TwoHam(mod)'
         lOff = 1
         Do iIrrep = 0, nIrrep-1
            n = nBas(iIrrep)*(nBas(iIrrep)+1)/2
            Write (Label,'(A,I1)')
     &       'Diagonal Symmetry Block ',iIrrep+1
            Call Triprt(Label,' ',TwoHam(lOff),nBas(iIrrep))
            lOff = lOff + n
         End Do
         Write (6,*) ' RepNuc=',RepNuc
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Write information to be used for gradient calculations or for
*     non-equilibrium calculations
*
      If (.Not.NonEq) Then
*
*        Save total solute multipole moments and total potential
*        of the solution.
*
         call dcopy_(nComp,Q_solute(1,1),1,QV(1,1),1)
         call daxpy_(nComp,One,Q_solute(1,2),1,QV(1,1),1)
         call dcopy_(nComp,Vs(1,1),1,QV(1,2),1)
         call daxpy_(nComp,One,Vs(1,2),1,QV(1,2),1)
         Call Put_dArray('RCTFLD',QV,nComp*2)
*
*        Compute terms to be added to RepNuc for non-equilibrium
*        calculation.
*
         call dcopy_(nComp,QV(1,1),1,QV(1,2),1)
         Call AppFld_NonEQ_1(QV(1,2),rds,Eps,lMax,EpsInf,NonEq)
         E_0_NN=-Half*DDot_(nComp,QV(1,1),1,QV(1,2),1)
*
         call dcopy_(nComp,QV(1,1),1,QV(1,2),1)
         Call AppFld_NonEQ_2(QV(1,2),rds,Eps,lMax,EpsInf,NonEq)
         E_0_NN=E_0_NN+DDot_(nComp,Q_solute(1,1),1,QV(1,2),1)
         Call Put_dScalar('E_0_NN',E_0_NN)
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(Dff)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine expandfok(wrk,wrksize,fok)
! This routine expands fok operator to #2
! it also defines new mapd2,mapi2

use ccsort_global, only: mapd2, mapi2, NORB, NSYM, pos20
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
real(kind=wp), intent(in) :: fok(*)
integer(kind=iwp) :: p, postemp, pqfok, pqwrk, q, qpwrk, symp

! set mapi zero

mapi2(1:nsym,1:nsym,1:nsym) = 0

! def zeroth row of mapd

mapd2(0,1) = 5
mapd2(0,2) = 5
mapd2(0,3) = 0
mapd2(0,4) = 0
mapd2(0,5) = nsym
mapd2(0,6) = 0

postemp = pos20
pqfok = 0
do symp=1,nsym

  ! def mapd,mapi

  mapd2(symp,1) = postemp
  mapd2(symp,2) = norb(symp)*norb(symp)
  mapd2(symp,3) = symp
  mapd2(symp,4) = symp
  mapd2(symp,5) = 1
  mapd2(symp,6) = 1
  mapi2(symp,1,1) = symp

  ! expand

  do p=1,norb(symp)
    do q=1,p

      ! calc pq and qp position in work and fok
      ! and write integrals to this positions

      pqwrk = postemp+(norb(symp)*(p-1)+q)-1
      qpwrk = postemp+(norb(symp)*(q-1)+p)-1
      pqfok = pqfok+1
      wrk(pqwrk) = fok(pqfok)
      wrk(qpwrk) = fok(pqfok)

    end do
  end do

  postemp = postemp+mapd2(symp,2)

end do

return

end subroutine expandfok

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992,1999, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine NewPK(A,B,P,mZeta,nZeta,rKappa,Alpha,Beta)
************************************************************************
*                                                                      *
* Object : to compute P and kappa.                                     *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*             May '90, modified for integral cutoff.                   *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN.                              *
*             June '91, modified for k2 loop.                          *
*             January '92, modified for gradient calculations.         *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 Alpha(nZeta), Beta(nZeta), A(3), B(3), P(nZeta,3),
     &       rKappa(nZeta)
*
      iRout = 243
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In NewPK:Alpha',' ',Alpha,mZeta,1)
         Call RecPrt(' In NewPK:Beta',' ',Beta,mZeta,1)
      End If
*
      AB2=(A(1)-B(1))**2+(A(2)-B(2))**2+(A(3)-B(3))**2
      Do iZeta = 1, mZeta
         Tmp0=One/(Alpha(iZeta)+Beta(iZeta))
         Tmp1=TwoP54*Exp(-Alpha(iZeta)*Beta(iZeta)*AB2*Tmp0)*Tmp0
         If (Tmp1.lt.1.0D-99) Tmp1=1.0D-99
         rKappa(iZeta) = Tmp1
         P(iZeta,1) = (Alpha(iZeta)*A(1)+Beta(iZeta)*B(1))*Tmp0
         P(iZeta,2) = (Alpha(iZeta)*A(2)+Beta(iZeta)*B(2))*Tmp0
         P(iZeta,3) = (Alpha(iZeta)*A(3)+Beta(iZeta)*B(3))*Tmp0
      End Do
      Do iZeta = mZeta+1, nZeta
         rKappa(iZeta) = Zero
         P(iZeta,1) = Zero
         P(iZeta,2) = Zero
         P(iZeta,3) = Zero
      End Do
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In NewPK: Kappa',' ',rKappa,mZeta,1)
         Call RecPrt(' In NewPK: Px',' ',P(1,1),mZeta,1)
         Call RecPrt(' In NewPK: Py',' ',P(1,2),mZeta,1)
         Call RecPrt(' In NewPK: Px',' ',P(1,3),mZeta,1)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      subroutine rhs_mp2_help2(iSymA, iSymB, iSymI, iSymJ)
*
      Implicit Real*8 (a-h,o-z)
*
*defining One etc.
#include "real.fh"
#include "trafo.fh"
#include "WrkSpc.fh"
#include "files_mbpt2.fh"
#include "mp2grad.fh"
#include "corbinf.fh"
*
      iVirVir(i,j,k) = nFro(k) + nOcc(k) +  j-1 +
     &                (nOrb(k) + nDel(k))*
     &                (i + nFro(k) + nOcc(k) -1)
      iOccOcc(i,j,k) = j-1 + (nOrb(k)+nDel(k))
     &                               * (i -1)
      iMp2Lagr(i,j,k) = ip_Mp2Lagr(k) +
     &                         j-1 + (nOcc(k)+nFro(k))*(i-1)
*--------------------------------------------------
*      write(6,*) 'Starting subroutine with symmetries: '
*      write(6,*) 'I,J,A,B', I, J, iA, iB
*      write(6,*) 'NewSym',NewSym
*      write(6,*) 'IpoDens', IpoDens
*--------------------------------------------------
*
*     Reads the <..|AB> - integrals for the L3-term
*
      nB = nExt(iSymB) + nDel(iSymB)
      Do iA = 1, nExt(iSymA) + nDel(iSymA)
*        Decide i the AB-matrix is symmetric, if so
*        only loop over lower triangle
         if(iSymA.eq.iSymB) nB = iA
         Do iB = 1, nB
*
            fac_ab = One
            if((iA.ne.iB).and.(iSymA.eq.iSymB)) fac_ab = Two
*           If I is not equal J there is a symmetry J I B A
*           that is identical and not stored.
            if(iSymA.ne.iSymB) fac_ab = Two
*
            Call Exch(iSymI,iSymA,iSymJ,iSymB,
     &                iA+nOcc(iSymA)+nFro(iSymA),
     &                iB+nOcc(iSymB)+nFro(iSymB),
     &                Work(ipInt1), Work(ipScr1))
            If (iSymA.ne.iSymB) then
               Call Exch(iSymJ,iSymA,iSymI,iSymB,
     &                   iA+nOcc(iSymA)+nFro(iSymA),
     &                   iB+nOcc(iSymB)+nFro(iSymB),
     &                   Work(ipInt2),Work(ipScr1))
            End If
*            write(6,*) 'iOrbA',iA , 'iOrbB',iB
*            Call RecPrt('Int1:','(8F10.6)',Work(ipInt1),
*     &                nOrb(iSymA)+nDel(iSymA),
*     &                nOrb(iSymB)+nDel(iSymA))
*            If (iSymA.Ne.iSymB) Then
*               Call RecPrt('Int2:','(8F10.6)',Work(ipInt2),
*     &                     nOrb(iSymB)+nDel(iSymB),
*     &                     nOrb(iSymA)+nDel(iSymA))
*            End If
*
****************************************************************************************
*
*                  Lagrangian term 3
*
***************************************************************************************
*
*
*
            If((iSymA.Eq.iSymI).And.(iSymB.Eq.iSymJ)) Then
               If((iA.Eq.iB).And.(iSymA.Eq.iSymB)) Then
                  Fac = Half
               Else
                  Fac = One
               Endif
               iIC =(nFro(iSymB) + nOcc(iSymB)) *
     &              (nOrb(iSymA) + nDel(iSymA))
               iCI = nFro(iSymB) + nOcc(iSymB)
               Do iC = 1, nExt(iSymB) + nDel(iSymB)
                  Do iI = 1, nOcc(iSymA) + nFro(iSymA)
                     xaibc = Work(ipInt1 + iIC + iI-1 + (iC-1)
     &                     * (nOrb(iSymA)+nDel(iSymA)))
                     If(iSymA.Eq.iSymB) Then
                        xacbi = Work(ipInt1 + iCI +  iC-1 +
     &                          (iI-1)*(nOrb(iSymB)+nDel(iSymB)))
                     Else
                        xacbi = Work(ipInt2 + iCI + iC-1 +
     &                          (iI-1)*(nOrb(iSymB)+nDel(iSymB)))
                     End If
                    Work(iMp2Lagr(iA,iI,iSymA)) =
     &                    Work(iMp2Lagr(iA,iI,iSymA)) -
     &                        Fac*Work(ip_Density(iSymB) +
     &                                 iVirVir(iB,iC,iSymB))
     &                              * (Two*xaibc - xacbi)
                     If(iSymA.Eq.iSymB) Then
                       Work(iMp2Lagr(iB,iI,iSymA)) =
     &                    Work(iMp2Lagr(iB,iI,iSymA)) -
     &                        Fac*Work(ip_Density(iSymB) +
     &                                 iVirVir(iA,iC,iSymB))
     &                              * (Two*xacbi - xaibc)
                   End If
*                        Write(6,*) 'AIBC', iA, iI,iB,iC
*                        Write(6,*) 'AIBC2',iB,iI,iA, iC
*                        Write(6,*) 'icab', xaibc
*                        Write(6,*) 'ibac', xacbi
*                        Write(6,*) 'Dens', Work(ip_Density(iSymB) +
*     &                                 iVirVir(iB,iC,iSymB))
*                        Write(6,*) 'Dens2',Work(ip_Density(iSymB) +
*     &                                 iVirVir(iA,iC,iSymB))
*                        Write(6,*) 'A', (Two*xaibc - xacbi)
*                        Write(6,*) 'A2', (Two*xacbi - xaibc)
*                        Write(6,*) 'Bidrag', Work(ip_Density(iSymB)+
*     &                                 iVirVir(iB,iC,iSymB))
*     &                              * (Two*xaibc - xacbi)
*                        Write(6,*) 'Bidrag2',Work(ip_Density(iSymB) +
*     &                                 iVirVir(iA,iC,iSymB))
*     &                              * (Two*xacbi - xaibc)

*
                  EndDo
               EndDo
*
*           And again we need another loop for the symmetries that isnt written
*           explicitly. all references to A and B need to change too.
*
               If(iSymA.ne.iSymB) then
                  iIC = (nFro(iSymA) + nOcc(iSymA)) *
     &                  (nOrb(iSymB) + nDel(iSymB))
                  iCI = nFro(iSymA) + nOcc(iSymA)
                  Do iC = 1, nExt(iSymA) + nDel(iSymA)
                     Do iI = 1, nFro(iSymB) + nOcc(iSymB)
                        xaibc = Work(ipInt1 + iCI + iC-1 +
     &                           (iI-1)*(nOrb(iSymA)+nDel(iSymA)))
                        xacbi = Work(ipInt2 + iIC + iI-1 +
     &                           (iC-1)*(nOrb(iSymB)+nDel(iSymB)))
                        Work(iMp2Lagr(iB,iI,iSymB)) =
     &                    Work(iMp2Lagr(iB,iI,iSymB)) -
     &                        Fac*Work(ip_Density(iSymA) +
     &                                 iVirVir(iA,iC,iSymA))
     &                              * (Two*xaibc - xacbi)
                     EndDo
                  EndDo
               EndIf
            Endif
*

         EndDo
      EndDo
*     Reads one block of <ij|..> at the time.
*
      nJ = nFro(iSymJ) + nOcc(iSymJ)
      Do iI = 1, nFro(iSymI) + nOcc(iSymI)
*        Decide if the IJ-block i symmetric and
*        if so only read a triangle
         if(iSymI.eq.iSymJ) nJ = iI
******** Check if the IJ-matrix is symmetric, if so
***      only loop over lower triangle.
*
*****************************************
         Do iJ = 1, nJ
*           If we are only looping over a triangular matrix
*           we need to count each offdiagonal element twice.
            fac_ij = One
            If((iI.ne.iJ).and.(iSymI.eq.iSymJ)) fac_ij = Two
*           If I is not equal J there is a symmetry J I B A
*           that is identical and not stored.
            If(iSymI.Ne.iSymJ) fac_ij = Two
*           Copy one AB-block of integrals to the workspace
            Call Exch(iSymA,iSymI,iSymB,iSymJ,iI,
     &                iJ,Work(ipInt1),
     &                Work(ipScr1))
            if (iSymI.ne.iSymJ) then
               Call Exch(iSymB,iSymI,iSymA,iSymJ,
     &                   iI,iJ,
     &                   Work(ipInt2),Work(ipScr1))
            endif
*            Write(6,*)
*            Write(6,*) ' *  i,j = ',iI,iJ
*            Call RecPrt('Int1:','(8F10.6)',Work(ipInt1),nOrb(iSymA),
*     &                nOrb(iSymB))
*            if (iSymI.ne.iSymJ) then
*            Call RecPrt('Int2:','(8F10.6)',Work(ipInt2),nOrb(iSymB),
*     &                nOrb(iSymA))
*            endif


****************************************************************************************
*
*                  Lagrangian term 4
*
***************************************************************************************
*
*
*
            If((iSymI.eq.iSymA).and.(iSymJ.eq.iSymB)) then
               If((iI.eq.iJ).and.(iSymI.eq.iSymJ)) Then
                  Fac = Half
               Else
                  Fac = One
               Endif
*
*
*
               iKA = (nFro(iSymJ) + nOcc(iSymJ)) *
     &               (nOrb(iSymI) + nDel(iSymI))
               iAK = nFro(iSymJ) + nOcc(iSymJ)
               Do iK = 1, nFro(iSymI) + nOcc(iSymI)
                  Do iA = 1, nExt(iSymJ) + nDel(iSymJ)
                     xikja = Work(ipInt1 + iKA + iK-1 +
     &                            (iA-1)*(nOrb(iSymI)+nDel(iSymI)))
                     if(iSymI.eq.iSymJ) then
                        xiajk = Work(ipInt1 + iAK + iA-1 +
     &                               (iK-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                     else
                        xiajk = Work(ipInt2 + iAK + iA-1 +
     &                               (iK-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                     endif
                     Work(iMp2Lagr(iA,iJ,iSymJ)) =
     &                    Work(iMp2Lagr(iA,iJ,iSymJ)) -
     &                        Fac*Work(ip_Density(iSymI) +
     &                                 iOccOcc(iI,iK,iSymI))
     &                              * (Two*xikja - xiajk)
                     If (iSymI.eq.iSymJ) then
                        Work(iMp2Lagr(iA,iI,iSymJ)) =
     &                    Work(iMp2Lagr(iA,iI,iSymJ)) -
     &                        Fac*Work(ip_Density(iSymI) +
     &                                 iOccOcc(iJ,iK,iSymI))
     &                              * (Two*xiajk - xikja)
                     EndIf
*                     write(6,*) 'xikja', xikja
*                     write(6,*) 'xiajk', xiajk
                  EndDo
               EndDo

               If(iSymI.ne.iSymJ) then
                  iKA =(nFro(iSymI) + nOcc(iSymI)) *
     &                 (nOrb(iSymJ) + nDel(iSymJ))
                  iAK = nFro(iSymI) + nOcc(iSymI)
                  Do iK = 1, nFro(iSymJ) + nOcc(iSymJ)
                     Do iA = 1, nExt(iSymI) + nDel(iSymI)
                        xikja =Work(ipInt1 + iAK + iA-1 +
     &                            (iK-1)*(nOrb(iSymI)+nDel(iSymI)))
                        xiajk =Work(ipInt2 + iKA + iK-1 +
     &                               (iA-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                        Work(iMp2Lagr(iA,iI,iSymI)) =
     &                    Work(iMp2Lagr(iA,iI,iSymI)) -
     &                        Fac*Work(ip_Density(iSymJ) +
     &                                 iOccOcc(iJ,iK,iSymJ))
     &                              * (Two*xikja - xiajk)
                     EndDo
                  EndDo
               Endif
            Endif
         EndDo
      EndDo

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Name_to_lm
!
!> @brief
!>   Get \f$ l \f$ and \f$ m \f$ numbers from a basis function name.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Given a basis function name as a character string, extract the \f$ l
!> \f$ and \f$ m \f$ quantum numbers.
!>
!> Spherical harmonics functions are expected with the format `nnLmms`,
!> where `nn` is the shell number, `L` is a letter denoting angular
!> momentum, `mm` is the absolute value of the \f$ m \f$ number, and `s`
!> is the sign of \f$ m \f$.
!>
!> Cartesian functions are expected with the format `Lxxyyzz`, where `L`
!> is a letter denoting angular momentum, and `xx`, `yy`, `zz` are the
!> powers of \f$ x \f$, \f$ y \f$ and \f$ z \f$ (\f$ m_x,m_y,m_z \f$).
!> in this case, the numbers returned are \f$ -l \f$ and
!> \f$ ((m_y+m_z)^2+m_z-m_y)/2-m_x \f$.
!>
!> @param[in]  BName Basis function name
!> @param[out] l     \f$ l \f$ number (\f$ -l \f$ for Cartesians)
!> @param[out] m     \f$ m \f$ number (see details for Cartesians)
!***********************************************************************

subroutine Name_to_lm(BName,l,m)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: BName
integer(kind=iwp), intent(out) :: l, m
character :: Letter
integer(kind=iwp) :: i, lx, ly, lz
#include "angtp.fh"

Letter = BName(3:3)
call LoCase(Letter)
l = 0
m = 0
if (Letter == 's') then
  ! Default is s
  return
else if (Letter == 'p') then
  ! p usually appear as px, py, pz, except when they are contaminants
  l = 1
  if (BName(4:4) /= '0') then
    Letter = BName(4:4)
    call LoCase(Letter)
    if (Letter == 'x') then
      m = 1
    else if (Letter == 'y') then
      m = -1
    else if (Letter == 'z') then
      m = 0
    end if
    return
  end if
end if
! Parse the label for other cases
l = -1
! Find if there is an angular label
do i=sum(lbound(AngTp)),sum(ubound(AngTp))
  if (Letter == AngTp(i)) then
    l = i
    exit
  end if
end do
if (l >= 0) then
  ! If a label is found it is a spherical shell, just read m
  read(BName(4:5),*) m
  if (BName(6:6) == '-') m = -m
else
  ! If no label, this is a Cartesian shell, return -l and some convention for m.
  ! We use m=T(ly+lz)-(lx+ly), where T(n) is the nth triangular number: n*(n+1)/2).
  ! From here, ly+lz can be recovered as the (int) triangular root of m+l: (sqrt(8*(m+l)+1)-1)/2,
  ! lz is m+l-T(ly+lz) and lx is l-(ly+lz). This has the property that all
  ! possible combinations of lx,ly,lz are encoded in -l plus a number from -l to l*(l+1)/2,
  ! in descending order with priority lx>ly>lz: (3,0,0), (2,1,0), (2,0,1), (1,2,0),
  ! (1,1,1), (1,0,2), (0,3,0), (0,2,1), (0,1,2), (0,0,3)
  read(BName(2:3),*) lx
  read(BName(4:5),*) ly
  read(BName(6:7),*) lz
  l = -lx-ly-lz
  m = (ly+lz)*(ly+lz+1)/2-(lx+ly)
end if

return

end subroutine Name_to_lm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine casinfo1_cvb()

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i2s_c, ireturn_rasscf, isym_c, nel_c, neltot_c, norb_c
logical(kind=iwp) :: iphex, oldex

! Information from molcas interface file 'JOBIPH' :
write(u6,'(a)') ' ------- Recover RASSCF-related information --------------------------------------'
call f_inquire('JOBIPH',iphex)
call f_inquire('JOBOLD',oldex)
if (iphex) then
  write(u6,'(/,a)') ' Using JOBIPH interface file.'
  call Copy_JobIph('JOBIPH','JOBOLD')
else if (oldex) then
  write(u6,'(/,a)') ' Using JOBOLD interface file.'
  call Copy_JobIph('JOBOLD','JOBIPH')
else
  write(u6,'(/,a)') ' Error: need either JOBOLD or JOBIPH file!'
  call abend_cvb()
end if

call rdjobiph_cvb('JOBIPH')
call setjobiph_cvb(nel_c,norb_c,i2s_c,isym_c,neltot_c)
call rasscf(ireturn_rasscf)
call clsfls_rasscf()
! rasscf will have overwritten jobiph ...
call Copy_JobIph('JOBOLD','JOBIPH')
write(u6,'(a)') ' ------- RASSCF-related information recovered ------------------------------------'

return

end subroutine casinfo1_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FixHess(H,nH,iOptC,Mode,Iter,MF,GNrm,
     &                   GNrm_Threshold, iNeg,nAtoms,AnalHess,
     *                   Corrected)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
#include "WrkSpc.fh"
      Real*8 H(nH,nH), MF(3*nAtoms)
      Integer iNeg(2)
      Logical AnalHess, Corrected, Too_Small, Found
*
      iRout=211
      iPrint=nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt('FixHess: H(Start)',' ',H,nH,nH)
      End If
*
      Lu=6
      Corrected=.False.
      HTh=1.0d-3
      Too_Small=.False.
      ZTh=1.0D-12
      HHigh=1.0D0
*
      Call GetMem('EVal','Allo','Real',ipEVal,nH*(nH+1)/2)
*
*---- Copy elements for H
*
      SumHii=Zero
      Do i = 1, nH
         Do j = 1, i
            ij=i*(i-1)/2 + j + ipEVal -1
            Work(ij)=H(i,j)
         End Do
         SumHii=SumHii+H(i,i)
      End Do
*
      If (iPrint.ge.99) Then
         Write (Lu,*) 'FixHess: SumHii=',SumHii
         Call RecPrt('FixHess: Hessian',' ',H,nH,nH)
         Call TriPrt('FixHess: H',' ',Work(ipEVal),nH)
      End If
*
*---- Compute eigenvalues and eigenvectors
*
*---- Davidson procedure to compute only the lowest eigenvalues
*     For small matrices we can afford to solve it directly
*      (tested with NumVal=2 in all cases)
      If (nH .le. 30) Then
        NumVal=nH
      Else
        NumVal=2
      End If
      nVStep=2
      Found=.False.
      Call Allocate_Work(ipLowVal,NumVal)
      Call Allocate_Work(ipLowVec,NumVal*nH)
      Call DZero(Work(ipLowVec),NumVal*nH)
*---- Stop when the highest eigenvalue found is larger than HTh * 10
      Do While (.Not.Found)
        Call Davidson(Work(ipEVal),nH,
     &                NumVal,Work(ipLowVal),Work(ipLowVec),iStatus)
        If (iPrint.ge.99) Then
          Call RecPrt(' Eigenvalues',' ',Work(ipLowVal),1,NumVal)
          Call RecPrt(' Eigenvectors',' ',Work(ipLowVec),nH,NumVal)
        End IF
        If (iStatus.gt.0) Then
          Call SysWarnMsg('FixHess',
     &      'Davidson procedure did not converge','')
        End If
        If ((Work(ipLowVal+NumVal-1).gt.Ten*HTh).or.(NumVal.ge.nH)) Then
          Found=.True.
        Else
*----     Increase the number of eigenpairs to compute
          Call Allocate_Work(ipTmp,NumVal*nH)
          call dcopy_(NumVal*nH,Work(ipLowVec),1,Work(ipTmp),1)
          Call Free_Work(ipLowVal)
          Call Free_Work(ipLowVec)
*----     At some point, start doubling the number
          If (NumVal.ge.16) NVStep=NumVal
          nVStep=Min(nVStep,nH-NumVal)
          NumVal=NumVal+nVStep
          Call Allocate_Work(ipLowVal,NumVal)
          Call Allocate_Work(ipLowVec,NumVal*nH)
          call dcopy_((NumVal-nVStep)*nH,Work(ipTmp),1,Work(ipLowVec),1)
          Call DZero(Work(ipLowVec+(NumVal-nVStep)*nH),nVStep*nH)
          Call DZero(Work(ipLowVal),NumVal)
          Call Free_Work(ipTmp)
        End If
      End Do
      Call GetMem('EVal','Free','Real',ipEVal,nH*(nH+1)/2)
*
*---- Apply corrections if any ...
*
      Call GetMem('FixVal','Allo','Real',ipFixVal,NumVal)
      If (iPrint.ge.99) Then
         Call RecPrt(' Eigenvalues',' ',Work(ipLowVal),1,NumVal)
         Call RecPrt(' Eigenvectors',' ',Work(ipLowVec),nH,NumVal)
      End If
      iNeg(1)=0
      jNeg=0
      rLow=Ten
      iLow=0
*     with sorted eigenvalues, jNeg=iNeg, iLow=1
      Do i = 1, NumVal
         temp=Work(i+ipLowVal-1)
         Work(i+ipFixVal-1)=temp
         If (temp.lt.rlow) Then
            rlow=temp
            iLow=i
         End If
*        No fixes if the Hessian is analytical
         If (.Not.AnalHess.and.(Abs(temp).lt.HTh)) Then
            Too_Small=.True.
            Corrected=.True.
*
*           For redundant coordinates we will have some
*           eigenvalues which are zero due to the
*           redundancy.
*
            If (Abs(temp).lt.ZTh) Then
               temp=Zero
               Work(i+ipFixVal-1)=Zero
            Else
               Work(i+ipFixVal-1)=Sign(HTh,temp)
            End If
         End If
         If (temp.lt.Zero) Then
            iNeg(1)=iNeg(1)+1
            jNeg=i
            If (.Not.AnalHess .and.
     &          iAnd(iOptC,128).eq.128 .and.
     &          iAnd(iOptC,4096).ne.4096) Then
*
*              Change the sign and if just too large reduce the value
*              to the default of HHigh.
*
               Work(i+ipFixVal-1)=Min(HHigh,Abs(Work(i+ipFixVal-1)))
               Corrected=.True.
            End If
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     If FindTS and we have got a negative eigenvalue signal that
*     we are in the TS regime.
*
      Call qpg_darray('TanVec',Found,nRP)
      If (iAnd(iOptC,4096).eq.4096 .and.
     &    (iNeg(1).ge.1.or.Mode.ge.0) .and.
     &    ((GNrm.le.GNrm_Threshold).or.Found)) Then
         If (iAnd(iOptC,8192).ne.8192) Then
            Write (6,*) '**************************'
            Write (6,*) '* Enable TS optimization *'
            Write (6,*) '**************************'
         End If
         iOptC=iOr(iOptC,8192)
      End If
      If (iAnd(iOptC,8192).eq.8192) Then
         Mask=2**30-1  - 2**7
         iOptC=iAnd(Mask,iOptC)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
      If (Too_Small.and.iPrint.ge.6) Then
         Write (Lu,*) ' Some too small eigenvalues have been corrected'
         Write (Lu,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*----- M I N I M A
*                                                                      *
************************************************************************
*                                                                      *
      If (iAnd(iOptC,128).eq.128) Then
*
         If (iNeg(1).ne.0.and.iAnd(iOptC,256).ne.256.and.iPrint.ge.6)
     &   Then
            Write (Lu,*) ' Some negative eigenvalues have been'
     &                 //' corrected'
            Write (Lu,*) 'iNeg=',iNeg(1)
            Write (Lu,*)
         End If
*                                                                      *
************************************************************************
*                                                                      *
*---- T R A N S I T I O N  S T A T E  S E A R C H
*                                                                      *
************************************************************************
*                                                                      *
      Else If (iAnd(iOptC,8).eq.8 .or.
     &         iAnd(iOptC,8192).eq.8192 ) Then
*                                                                      *
************************************************************************
*                                                                      *
*        1 negative eigenvalue
*
         If (iNeg(1).eq.1) Then
*
            If (Mode.le.0) Then
*
*------------- Store the eigenvector which we are following
*
               Mode=jNeg
               ipFrom=ipLowVec + (Mode-1)*nH
               Call ReacX(Work(ipFrom),nH,MF,3*nAtoms)
               If (iPrint.ge.6) Then
                  Write (Lu,'(A,I3)') ' Store Original mode:',Mode
                  Call RecPrt(' Reaction mode',' ',MF,3,nAtoms)
               End If
*
            Else
*
*------------- Check that it is the correct eigenvector!
*
               If (iPrint.ge.6) Call RecPrt(' Old Reaction mode',' ',
     &                                      MF,3,nAtoms)
               iTest=0
               Test=Zero
               Call GetMem('Rx','Allo','Real',ipRx,3*nAtoms)
               Do i = 1, NumVal
                  ipFrom=ipLowVec + (i-1)*nH
                  Call ReacX(Work(ipFrom),nH,Work(ipRx),3*nAtoms)
                  dRx=Sqrt(DDot_(3*nAtoms,Work(ipRx),1,Work(ipRx),1))
                  rq=Abs(DDot_(3*nAtoms,MF,1,Work(ipRx),1))/dRx
                  If (rq.gt.Test) Then
                     iTest=i
                     Test=rq
                  End If
                  Temp=Work(i+ipFixVal-1)
                  If (iPrint.ge.6)
     &               Write (6,*) '<old|new>,H_new=',rq,Temp
               End Do
               Call GetMem('Rx','Free','Real',ipRx,3*nAtoms)
*
*              Only iTest and jNeg may be touched
               If (iTest.eq.jNeg) Then
                  Mode = jNeg
               Else
                  If (iPrint.ge.6)
     &               Write (Lu,*) ' Warning: wrong eigenvector has'
     &                          //' negative eigenvalue.'
*                 Keep the old vector if there is significant overlap
*                 Note: there could be a better vector not in the computed set
                  If (.Not.AnalHess.and.(Test.gt.0.50d0)) Then
                     Mode = iTest
                     If (iPrint.ge.6)
     &                  Write (Lu,*) 'Keep old eigenvector!',Mode
                     Work(jNeg+ipFixVal-1) = Abs(Work(jNeg+ipFixVal-1))
                     Corrected=.True.
*                 Prefer the new eigenvector if the Hessian is analytical
*                 or if the best overlap is poor
                  Else
                     Mode = jNeg
                     If (iPrint.ge.6)
     &                  Write (Lu,*) 'Take new eigenvector!',Mode
                  End if
               End If
*
               Work(Mode+ipFixVal-1) = -Abs(Work(Mode+ipFixVal-1))
               ipFrom=ipLowVec + (Mode-1)*nH
               Call ReacX(Work(ipFrom),nH,MF,3*nAtoms)
               If (iPrint.ge.6) Then
                  Write (Lu,'(A,1X,I3)') ' Store mode:',Mode
                  Call RecPrt(' New Reaction mode',' ',MF,3,nAtoms)
               End If
*
            End If
*                                                                      *
************************************************************************
*                                                                      *
*        0 negative eigenvalues
*
         Else If (iNeg(1).eq.0) Then
*
            If (Mode.lt.1) Then
*
*------------- Store the eigenvector which we are following
*
               Mode=iLow
               ipFrom=ipLowVec + (Mode-1)*nH
               Call ReacX(Work(ipFrom),nH,MF,3*nAtoms)
               If (iPrint.ge.6) Then
                  Write (Lu,'(A,I3)') ' Store Original mode:',Mode
                  Call RecPrt(' Reaction mode',' ',MF,3,nAtoms)
               End If
*
            Else
*
*------------- Find the eigenvector with the best overlap
*
               If (iPrint.ge.6) Call RecPrt(' Old Reaction mode',' ',
     &                                      MF,3,nAtoms)
               iTest=0
               Test=Zero
               Call GetMem('Rx','Allo','Real',ipRx,3*nAtoms)
               Do i = 1, NumVal
                  ipFrom=ipLowVec + (i-1)*nH
                  Call ReacX(Work(ipFrom),nH,Work(ipRx),3*nAtoms)
                  dRx=Sqrt(DDot_(3*nAtoms,Work(ipRx),1,Work(ipRx),1))
                  rq=Abs(DDot_(3*nAtoms,MF,1,Work(ipRx),1))/dRx
                  If (rq.gt.Test) Then
                     iTest=i
                     Test=rq
                  End If
                  Temp=Work(i+ipFixVal-1)
                  If (iPrint.ge.6)
     &               Write (6,*) '<old|new>,H_new=',rq,Temp
               End Do
               Call GetMem('Rx','Free','Real',ipRx,3*nAtoms)
*
*              Keep the old vector if there is significant overlap
*              Note: there could be a better vector not in the computed set
               If (Test.gt.0.50d0) Then
                  Mode = iTest
*              Prefer the lowest eigenvector if the best overlap is poor
               Else
                  Mode = iLow
                  If (iPrint.ge.6)
     &               Write (Lu,*) ' Warning: no good overlap among'
     &                          //' the computed set of eigenvectors.'
               End if
*
               ipFrom=ipLowVec + (Mode-1)*nH
               Call ReacX(Work(ipFrom),nH,MF,3*nAtoms)
               If (iPrint.ge.6) Then
                  Write (Lu,'(A,1X,I3)') ' Store mode:',Mode
                  Call RecPrt(' New Reaction mode',' ',MF,3,nAtoms)
               End If
*
            End If
*
            Work(Mode+ipFixVal-1) = - Half * Abs(Work(Mode+ipFixVal-1))
            Corrected=.True.
            If (iPrint.ge.6) Then
               Write (Lu,'(A,I2,A)')
     &                   ' No negative eigenvalue, correction: mode ',
     &                   Mode,' was changed to negative'
               Write (Lu,*)
            End If
*                                                                      *
************************************************************************
*                                                                      *
*        2 or more negative eigenvalues
*
         Else If (iNeg(1).ge.2) Then
*
            If (Mode.lt.1) Then
*
*------------- Store the eigenvector which we are following
*
               Mode=iLow
               ipFrom=ipLowVec + (Mode-1)*nH
               Call ReacX(Work(ipFrom),nH,MF,3*nAtoms)
               If (iPrint.ge.6) Then
                  Write (Lu,'(A,I3)') ' Store Original mode:',Mode
                  Call RecPrt(' Reaction mode',' ',MF,3,nAtoms)
               End If
*
            Else
*
*------------- Find the eigenvector with the best overlap
*
               If (iPrint.ge.6) Call RecPrt(' Old Reaction mode',' ',
     &                                      MF,3,nAtoms)
               iTest=0
               Test=Zero
               Call GetMem('Rx','Allo','Real',ipRx,3*nAtoms)
               Do i = 1, NumVal
                  ipFrom=ipLowVec + (i-1)*nH
                  Call ReacX(Work(ipFrom),nH,Work(ipRx),3*nAtoms)
                  dRx=Sqrt(DDot_(3*nAtoms,Work(ipRx),1,Work(ipRx),1))
                  rq=Abs(DDot_(3*nAtoms,MF,1,Work(ipRx),1))/dRx
                  If (rq.gt.Test) Then
                     iTest=i
                     Test=rq
                  End If
                  Temp=Work(i+ipFixVal-1)
                  If (iPrint.ge.6)
     &               Write (6,*) '<old|new>,H_new=',rq,Temp
               End Do
               Call GetMem('Rx','Free','Real',ipRx,3*nAtoms)
*
*              Keep the old vector if there is significant overlap
*              Note: there could be a better vector not in the computed set
               If (Test.gt.0.50d0) Then
                  Mode = iTest
*              Prefer the lowest eigenvector if the best overlap is poor
               Else
                  Mode = iLow
                  If (iPrint.ge.6)
     &               Write (Lu,*) ' Warning: no good overlap among'
     &                          //' the computed set of eigenvectors.'
               End if
*
               ipFrom=ipLowVec + (Mode-1)*nH
               Call ReacX(Work(ipFrom),nH,MF,3*nAtoms)
               If (iPrint.ge.6) Then
                  Write (Lu,'(A,1X,I3)') ' Store mode:',Mode
                  Call RecPrt(' New Reaction mode',' ',MF,3,nAtoms)
               End If
*
            End If
*
*           Caution! Negative eigenvalues which are not assigned
*           to the reaction mode will be increased by two orders of magnitude
*           magnitude!
*
            Fact=Ten**2
            Do i = 1, NumVal
               Temp = Work(i+ipFixVal-1)
               If (i.eq.Mode) Then
                  Work(i+ipFixVal-1) = -Abs(Temp)
               Else If (Temp.lt.0) Then
                  Work(i+ipFixVal-1) = Abs(Temp) * Fact
               Else
                  Work(i+ipFixVal-1) = Abs(Temp)
               End If
            End Do
            Corrected=.True.
            If (iPrint.ge.6) Then
               Write (Lu,'(A,I2,A)')
     &               ' Too many negative eigenvalue, correction: mode ',
     &               Mode,' was kept'
               Write (Lu,*)
            End If
*
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else
         If (iPrint.ge.6) Write (6,*) 'No Hessian massage!'
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
      If (iPrint.ge.49) Then
         Write (Lu,*)
         Write (Lu,*)' Analysis of the Hessian'
         Write (Lu,*)
         Call RecPrt(' Eigenvalues',' ',Work(ipFixVal),1,NumVal)
         Call RecPrt(' Eigenvectors',' ',Work(ipLowVec),nH,NumVal)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*.... Recompute the Hessian if needed
*
      iNeg(2)=iNeg(1)
      If (Corrected) Then
*
         If (iPrint.ge.99) Then
            Call RecPrt(' Corrected eigenvalues',' ',
     &                  Work(ipFixVal),1,NumVal)
            Call RecPrt(' Hessian',' ',H,nH,nH)
         End If
*
         Call GetMem('Vect','Allo','Real',ipVect,nH)
         iNeg(1)=0
         Do i=1,NumVal
           If (Work(i+ipFixVal-1).lt.Zero) iNeg(1)=iNeg(1)+1
           FixVal=Work(i+ipFixVal-1)-Work(i+ipLowVal-1)
           If (Abs(FixVal).gt.1.0D-12) Then
             FixVal=Work(i+ipFixVal-1)+Work(i+ipLowVal-1)
*
*            H |i>
*
             iVec=ipLowVec+(i-1)*nH
             Call dGeMV_('N',nH,nH,One,H,nH,Work(iVec),1,
     &                            Zero,Work(ipVect),1)
*
*            H' = (I-|i><i|) H (I-|i><i|) + val_new |i><i|
*               = H - H|i> <i| - |i> <i|H + (val_old + val_new) |i> <i|
*
*  (since |i> is an eigenvector this could be used instead):
*  H' = H + (val_new - val_old) |i> <i|
*
             Do j=1,nH
               Do k=1,nH
                 H(j,k)=H(j,k)-Work(j+ipVect-1)*Work(k+iVec-1)
     &                        -Work(k+ipVect-1)*Work(j+iVec-1)
     &                        +FixVal*Work(j+iVec-1)*Work(k+iVec-1)
               End Do
             End Do
           End If
         End Do
         Call GetMem('Vect','Free','Real',ipVect,nH)
*
      End If
*
      If (iPrint.ge.99) Then
         Call RecPrt('FixHess: Hessian',' ',H,nH,nH)
      End If
*
      Call GetMem('FixVal','Free','Real',ipFixVal,NumVal)
      Call Free_Work(ipLowVal)
      Call Free_Work(ipLowVec)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(Iter)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine symtrizcvb_cvb(vecstr)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension vecstr(nvb)
      dimension dum(1)

      if(iconstruc.eq.0)then
        return
      elseif(iconstruc.eq.1)then
        i1 = mstackr_cvb(ndetvb)
        i2 = mstackr_cvb(nvb)
        call symtrizcvb2_cvb(vecstr,
     >    iwork(ls(13)),iwork(ls(16)),work(i1),work(i2))
        call mfreer_cvb(i1)
        call symtrizcvb3_cvb(vecstr,iwork(ls(10)))
      elseif(iconstruc.eq.2)then
        call schmidtd_cvb(work(ls(15)),nconstr,vecstr,1,dum,nvb,0)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
#ifdef _HDF5_
      SUBROUTINE Restart_Dynamix(file_h5res)
      IMPLICIT NONE
#include "stdalloc.fh"
#include "mh5.fh"
      REAL*8, ALLOCATABLE ::    vel(:),NHC(:)
      REAL*8              ::    time,dt,e
      INTEGER             ::    attr_id,i,restart_fileid,natom,nsym,
     &                          dset_id,nh(1)
      Character           ::    tmp*256,sFile*256
      CHARACTER*180       ::    File_H5Res
      LOGICAL             ::    Exist

      write(6,'(A)') 'Restarting dynamix from h5 file', file_h5res

C Check the file exists
      sFile=File_H5Res
      call f_inquire(sFile,Exist)
      if(.not.Exist) then
        call getenvf('MOLCAS_SUBMIT_DIR',tmp)
        if(tmp.ne.' ') then
          i=index(tmp,' ')
          if(i.gt.0) then
            sFile=tmp(1:i-1)//'/'//file_h5res
            call f_inquire(sFile,Exist)
          endif
        endif
        if(.not.Exist) then
          Call WarningMessage(2,'File '//trim(sFile)//' is not found')
          call Quit_OnUserError()
        endif
      endif

      restart_fileid = mh5_open_file_r(sFile)

C read number of atoms
      call mh5_fetch_attr(restart_fileid,'NSYM',nsym)
      if (nsym .gt. 1) then
        attr_id = mh5_open_attr(restart_fileid,'NATOMS_ALL')
      else
        attr_id = mh5_open_attr(restart_fileid,'NATOMS_UNIQUE')
      endif
      call mh5_get_attr(attr_id,natom)

C read time and save in RunFile
      call mh5_fetch_dset_scalar_real(restart_fileid,'TIME',time)
      CALL Put_dScalar('MD_Time',time)

C read time step and save in RunFile
      call mh5_fetch_dset_scalar_real(restart_fileid,'TIME_STEP',dt)
      CALL Put_dScalar('Timestep',dt)

C read max hop and save in RunFile
      if (mh5_exists_dset(restart_fileid,'MAX_HOP')) then
        call mh5_fetch_dset_scalar_int(restart_fileid,'MAX_HOP',i)
        CALL Put_iScalar('MaxHops',i)
      endif

C read total energy and save in RunFile
      call mh5_fetch_dset_scalar_real(restart_fileid,'ETOT',e)
      CALL Put_dScalar('MD_Etot',e)

C read velocities and save in RunFile
      CALL mma_allocate(vel,natom*3)
      call mh5_fetch_dset_array_real(restart_fileid,'VELOCITIES',vel)
      call Put_dArray('Velocities',vel,3*natom)
      CALL mma_deallocate(vel)

C read thermostat info and save in RunFile
      dset_id=mh5_open_dset(restart_fileid,'NOSEHOOVER')
      call mh5_get_dset_array_dims(dset_id,nh)
      call mh5_close_dset(dset_id)
      CALL mma_allocate(NHC,nh(1))
      call mh5_fetch_dset_array_real(restart_fileid,'NOSEHOOVER',NHC)
      call Put_dArray('NOSEHOOVER',NHC,nh(1))
      CALL mma_deallocate(NHC)

      call mh5_close_file(restart_fileid)

      RETURN
      END
#elif defined (NAGFOR)
c Some compilers do not like empty files
      SUBROUTINE empty_Restart_Dynamix()
      END
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!  ********************************************************
!  ** Public-domain library routines used by casvb only. **
!  ********************************************************
!  **********************
!  ** EISPACK ROUTINES **
!  **********************

subroutine balanc(nm,n,a,low,igh,scl)
! this subroutine is a translation of the algol procedure balance,
! num. math. 13, 293-304(1969) by parlett and reinsch.
! handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
!
! this subroutine balances a real matrix and isolates
! eigenvalues whenever possible.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.
!
!    n is the order of the matrix.
!
!    a contains the input matrix to be balanced.
!
! on output
!
!    a contains the balanced matrix.
!
!    low and igh are two integers such that a(i,j)
!      is equal to zero if
!       (1) i is greater than j and
!       (2) j=1,...,low-1 or i=igh+1,...,n.
!
!    scl contains information determining the
!       permutations and scaling factors used.
!
! suppose that the principal submatrix in rows low through igh
! has been balanced, that p(j) denotes the index interchanged
! with j during the permutation step, and that the elements
! of the diagonal matrix used are denoted by d(i,j).  then
!    scl(j) = p(j),    for j = 1,...,low-1
!           = d(j,j),      j = low,...,igh
!           = p(j)         j = igh+1,...,n.
! the order in which the interchanges are made is n to igh+1,
! then 1 to low-1.
!
! note that 1 is returned for igh if igh is zero formally.
!
! the algol procedure exc contained in balance appears in
! balanc  in line.  (note that the algol roles of identifiers
! k,l have been reversed.)
!
! Questions and comments should be directed to Alan K. Cline,
! Pleasant Valley Software, 8603 Altus Cove, Austin, TX 78759.
! Electronic mail to cline@cs.utexas.edu.
!
! this version dated january 1989. (for the IBM 3090vf)
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n
real(kind=wp), intent(inout) :: a(nm,n)
integer(kind=iwp), intent(out) :: low, igh
real(kind=wp), intent(out) :: scl(n)
integer(kind=iwp) :: i, j, k, l, m
real(kind=wp) :: b2, c, f, g, r, s
logical(kind=iwp) :: first, noconv, skip
real(kind=wp), parameter :: rdx = 16.0_wp

b2 = rdx*rdx
k = 1
l = n
! .......... search for rows isolating an eigenvalue and push them down ..........
first = .true.
do
  if (first) then
    first = .false.
  else
    if (l == 1) exit
    l = l-1
  end if
  ! .......... for j=l step -1 until 1 do -- ..........
  do j=l,1,-1

    skip = .false.
    do i=1,l
      if (i == j) cycle
      if (a(j,i) /= Zero) then
        skip = .true.
        exit
      end if
    end do

    if (.not. skip) then
      m = l
      call rc_exchange()
      exit
    end if
  end do
end do

if (first .or. (l /= 1)) then

  ! .......... search for columns isolating an eigenvalue and push them left ..........
  first = .true.
  do
    if (first) then
      first = .false.
    else
      k = k+1
    end if

    do j=k,l

      skip = .false.
      do i=k,l
        if (i == j) cycle
        if (a(i,j) /= Zero) then
          skip = .true.
          exit
        end if
      end do

      if (.not. skip) then
        m = k
        call rc_exchange()
        exit
      end if
    end do
  end do
  ! .......... now balance the submatrix in rows k to l ..........
  scl(k:l) = One
  ! .......... iterative loop for norm reduction ..........
  do
    noconv = .false.

    do i=k,l
      c = Zero
      r = Zero

      do j=k,l
        if (j == i) cycle
        c = c+abs(a(j,i))
        r = r+abs(a(i,j))
      end do
      ! .......... guard against zero c or r due to underflow ..........
      if ((c == Zero) .or. (r == Zero)) cycle
      g = r/rdx
      f = One
      s = c+r
      do while (c < g)
        f = f*rdx
        c = c*b2
      end do
      g = r*rdx
      do while (c >= g)
        f = f/rdx
        c = c/b2
      end do
      ! .......... now balance ..........
      if ((c+r)/f >= 0.95_wp*s) cycle
      g = One/f
      scl(i) = scl(i)*f
      noconv = .true.

      a(i,k:) = a(i,k:)*g

      a(1:l,i) = a(1:l,i)*f

    end do

    if (.not. noconv) exit
  end do

end if

low = k
igh = l

return

contains

! .......... in-line procedure for row and column exchange ..........
subroutine rc_exchange()
  integer(kind=iwp) :: i
  scl(m) = j
  if (j == m) return
  do i=1,l
    f = a(i,j)
    a(i,j) = a(i,m)
    a(i,m) = f
  end do
  do i=k,n
    f = a(j,i)
    a(j,i) = a(m,i)
    a(m,i) = f
  end do
end subroutine rc_exchange

end subroutine balanc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKTDM1(LSYM1,MPLET1,MSPROJ1,IFSBTAB1,LSYM2,MPLET2,MSPROJ2,IFSBTAB2,ISSTAB,MAPORB,DET1,DET2,SIJ,NASHT,TDM1,TSDM1,WTDM1, &
                  ISTATE,JSTATE,job1,job2,OrbTab)
! Given two CI expansions, using a biorthonormal set of SD's,
! calculate the following quantities:
! (1) The overlap
! (2) The spin-summed 1-particle transition density matrix
! (3) The WE-reduced transition spin density matrix
! in the biorthonormal active orbital basis.

#ifdef _DMRG_
use rasscf_global, only: doDMRG
use qcmaquis_info, only: qcm_prefixes
use qcmaquis_interface_mpssi, only: qcmaquis_mpssi_get_onetdm_spin, qcmaquis_mpssi_overlap
use rassi_global_arrays, only: LROOT
#endif
use Symmetry_Info, only: MUL
use wigner_util, only: dclebs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LSYM1, MPLET1, MSPROJ1, IFSBTAB1(*), LSYM2, MPLET2, MSPROJ2, IFSBTAB2(*), ISSTAB(*), MAPORB(*), &
                                 NASHT, ISTATE, JSTATE, job1, job2, OrbTab(*)
real(kind=wp), intent(in) :: DET1(*), DET2(*)
real(kind=wp), intent(out) :: SIJ, TDM1(NASHT,NASHT), TSDM1(NASHT,NASHT), WTDM1(NASHT,NASHT)
integer(kind=iwp) :: IORB, ISORB, ISYOP, ITABS, IUABS, JORB, JSORB, MS2OP, NASORB, NSPD1
real(kind=wp) :: CGCOEF, FACT, GAA, GAB, GBA, GBB, RED, S1, S2, SM, SM1, SM2, TMATEL
real(kind=wp), allocatable :: SPD1(:)
#ifdef _DMRG_
real(kind=wp), allocatable :: TDMAA(:), TDMBB(:)
#endif
real(kind=wp), external :: OVERLAP_RASSI

! Pick out nr of active orbitals from orbital table:
NASORB = ORBTAB(4)

! Overlap:

SIJ = Zero

if ((MPLET1 == MPLET2) .and. (MSPROJ1 == MSPROJ2)) then

# ifdef _DMRG_
  if (.not. doDMRG) then
# endif

    SIJ = OVERLAP_RASSI(IFSBTAB1,IFSBTAB2,DET1,DET2)

# ifdef _DMRG_
  else
    sij = qcmaquis_mpssi_overlap(qcm_prefixes(job1),LROOT(istate),qcm_prefixes(job2),LROOT(jstate),.true.)

  end if ! DMRG or not

# endif
end if ! mmplet and msproj check

! General 1-particle transition density matrix:
NSPD1 = NASORB**2
#ifdef _DMRG_
if (.not. doDMRG) then
#endif
  call mma_allocate(SPD1,nSPD1,Label='SPD1')
  SPD1(:) = Zero
#ifdef _DMRG_
else
  ! For DMRG, we only need the AA and BB spin components
  ! Let's allocate two different arrays for them because that's
  ! easier for the new QCMaquis interface
  NSPD1 = NASHT**2
  call mma_allocate(TDMAA,nSPD1,Label='TDMAA')
  call mma_allocate(TDMBB,nSPD1,Label='TDMBB')
  TDMAA(:) = Zero
  TDMBB(:) = Zero
end if
#endif
ISYOP = MUL(LSYM1,LSYM2)
MS2OP = MSPROJ1-MSPROJ2

if (abs(MS2OP) <= 2) then
# ifdef _DMRG_
  if (.not. doDMRG) then
# endif
    !> spind constructs the 1-particle transition density matrix
    !> output in SPD1
    !> main input: DET1 and DET2
    call SPIND(ISYOP,MS2OP,ORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,DET1,DET2,SPD1)

# ifdef _DMRG_
  else
    if (isyop /= 1) then
      write(u6,*) 'MPS property density with spatial symm irrep > 1: FIXME!'
      call abend()
    end if
    ! calculate 1-TDMs: Must always be calculated with the higher multiplicity as <T|o|S>
    ! where T always has a higher multiplicity than S

    if (MPLET1 < MPLET2) then
      call qcmaquis_mpssi_get_onetdm_spin(qcm_prefixes(job2),LROOT(JSTATE),qcm_prefixes(job1),LROOT(ISTATE),TDMAA,TDMBB,NSPD1)
    else
      call qcmaquis_mpssi_get_onetdm_spin(qcm_prefixes(job1),LROOT(ISTATE),qcm_prefixes(job2),LROOT(JSTATE),TDMAA,TDMBB,NSPD1)
    end if
  end if
# endif
end if
! Create a scalar, and an WE-reduced spin, transition density matrix.
! The scalar matrix is simply the usual spin-summed density matrix.
! The WE-reduced matrix is the one defined through Wigner-Eckarts thm:
!  <A S1 M1 | T[K]_Q |B S2 M2>
!                   = FACT*CG(S2 M2 K Q;S1 M1)*<A S1 || T[K] ||B S2>
! i.e. with the usual Clebsch-Gordan factor, and a prefactor
!   FACT=(-1)**(MAX(S1,S2)-S1)/SQRT(2*S1+1)
S1 = Half*real(MPLET1-1,kind=wp)
S2 = Half*real(MPLET2-1,kind=wp)
SM1 = Half*real(MSPROJ1,kind=wp)
SM2 = Half*real(MSPROJ2,kind=wp)
do IORB=1,NASHT
  ISORB = 2*IORB-1
  do JORB=1,NASHT
    JSORB = 2*JORB-1
#   ifdef _DMRG_
    if (.not. doDMRG) then
#   endif
      GAA = SPD1(ISORB+NASORB*(JSORB-1))
      GAB = SPD1(ISORB+NASORB*(JSORB))
      GBA = SPD1(1+ISORB+NASORB*(JSORB-1))
      GBB = SPD1(1+ISORB+NASORB*(JSORB))
#   ifdef _DMRG_
    else
      GAA = TDMAA(JORB+NASHT*(IORB-1))
      GBB = TDMBB(JORB+NASHT*(IORB-1))
      ! transpose from row-major order,
      ! as it comes from C++ this way
      GAB = Zero
      GBA = Zero
    end if
#   endif

    ! Position determined by active orbital index in external order:
    ITABS = MAPORB(ISORB)
    IUABS = MAPORB(JSORB)

    !> scalar TDM
    TDM1(ITABS,IUABS) = GAA+GBB
    !> spin TDM
    TSDM1(ITABS,IUABS) = GAA-GBB

    ! Clebsch-Gordan coefficient:
    SM = SM1-SM2
    FACT = One/sqrt(real(MPLET1,kind=wp))
    if (MPLET1 == MPLET2-2) FACT = -FACT
    CGCOEF = FACT*DCLEBS(S2,One,S1,SM2,SM,SM1)
    ! Spin tensor component matrix element
    if (MSPROJ2 == MSPROJ1+2) then
      TMATEL = sqrt(Two)*GBA
    else if (MSPROJ2 == MSPROJ1-2) then
      TMATEL = -sqrt(Two)*GAB
    else if (MSPROJ2 == MSPROJ1) then
      TMATEL = Half*(GBB-GAA)
    end if
    ! Thus obtain reduced matrix element from Wigner-Eckart theorem:
    RED = Zero
    if (CGCOEF /= Zero) then
      RED = TMATEL/CGCOEF
    else
      if (abs(TMATEL) > 1.0e-12_wp) then
        call WarningMessage(1,'A possible bug was detected.')
        write(u6,*) ' WARNING: Non-zero matrix element computed'
        write(u6,*) ' which should be zero by spin symmetry!'
        write(u6,*) '              Spins S1, S2:',S1,S2
        write(u6,*) ' Spin projections SM1, SM2:',SM1,SM2
        write(u6,*) '    Operator has S=1.0, SM:',SM
        write(u6,*) ' Clebsch-Gordan:',CGCOEF
        write(u6,*) ' Size is TMATEL=',TMATEL
      end if
    end if

    !> W-reduced TDM
    WTDM1(ITABS,IUABS) = RED

  end do
end do

#ifdef _DMRG_
if (.not. doDMRG) then
#endif
  call mma_deallocate(SPD1)

#ifdef _DMRG_
else
  call mma_deallocate(TDMAA)
  call mma_deallocate(TDMBB)
end if
#else
#include "macros.fh"
! Avoid unused argument warnings
unused_var(ISTATE)
unused_var(JSTATE)
unused_var(job1)
unused_var(job2)
#endif

end subroutine MKTDM1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ireorg3(symp,typp,typpv1,paddv1,rc)
! this routine def. constants to be added to index from v2
! to determine proper index in v1
! N.B. typp and typpv1 must be compatible (this is testet
! in this version)
!
! symp  - irrep of p index (I)
! typp  - typ of p index in v2 (I)
! typpv1- typ of corresponding p index in v1 (I)
! paddv1- constant to be added (O) pv1 = pv2+paddv1
! rc    - return (error) code (O)

use ccsort_global, only: noa, nob, nva, nvb
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: symp, typp, typpv1
integer(kind=iwp), intent(out) :: paddv1, rc

rc = 0

select case (typp)
  case (1,2)
    if ((typpv1 == 1) .or. (typpv1 == 2) .or. (typpv1 == 5)) then
      paddv1 = 0
    else
      rc = 1
      ! RC=1 : typp=1 or 2, incompatible typpv1 (Stup)
    end if
  case (3)
    if (typpv1 == 3) then
      paddv1 = 0
    else if (typpv1 == 4) then
      paddv1 = nvb(symp)-nva(symp)
    else if (typpv1 == 5) then
      paddv1 = noa(symp)
    else
      rc = 2
      ! RC=2 : typp=3, incompatible typpv1 (Stup)
    end if
  case (4)
    if (typpv1 == 4) then
      paddv1 = 0
    else if (typpv1 == 5) then
      paddv1 = nob(symp)
    else
      rc = 3
      ! RC=3 : typp=4, incompatible typpv1 (Stup)
    end if
  case (5)
    if (typpv1 == 5) then
      paddv1 = 0
    else
      ! RC=4 : typp=5, incompatible typpv1 (Stup)
    end if
  case default
    rc = 5
    ! RC=5 : improper typp (Stup)
end select

return

end subroutine ireorg3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************
!  Cho_Dec_Qual
!
!> @author F. Aquilante
!>
!> @details
!> The symmetric positive (semi-)definite matrix
!>
!> \f[ Q_{ab,cd} = Q_{ab,cd} - \sum_J L_{ab,J} L_{cd,J} \f]
!>
!> is evaluated and the diagonal elements are returned in \p QDiag.
!> Subsequently, \p Q is Cholesky decomposed to yield \p NumV vectors
!> \f$ K_{ab,I} \f$ as
!>
!> \f[ Q_{ab,cd} = \sum_I K_{ab,I} K_{cd,I} \f]
!>
!> @note
!> \p Q is destroyed and cannot be used after this routine.
!>
!> @param[in,out] Diag  Array of diagonal integrals stored as in the first reduced set
!> @param[in]     Lab   Array of Cholesky vectors (symmetry blocked) for the qualified shell pairs
!> @param[in,out] Q     Array (symmetry blocked) containing the matrix of the qualified integrals
!> @param[out]    Kab   Array symmetry blocked of Cholesky vectors resulting from the decomposition
!>                      of the qualified integral matrix
!> @param[out]    iD    Index array. On exit \p iD(k,jSym) contains the index of the qualified diagonals
!>                      from which the \p k -th vector of \p jSym was generated
!> @param[out]    NumV  Array of the number of vectors in each symmetry from the decomposition of the
!>                      qualified integral matrix
!> @param[out]    QDiag Array (symmetry blocked) containing the updated qualified diagonals
!***********************************************************************

subroutine Cho_Dec_Qual(Diag,Lab,Q,Kab,iD,NumV,QDiag)

use Cholesky, only: Cho_1Center, nQual, nSym, Span, ThrCom
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: Diag(*), Q(*)
real(kind=wp), intent(in) :: Lab(*)
real(kind=wp), intent(_OUT_) :: Kab(*), QDiag(*)
integer(kind=iwp), intent(_OUT_) :: iD(*), NumV(*)
integer(kind=iwp) :: ipD, ipQ, ipQD, ipSQK, ipSQL, iQ, irc, jSym, mQ, nVecG(8)
real(kind=wp) :: Dmax(8), Thr
logical(kind=iwp) :: Sync
character(len=*), parameter :: SecNam = 'Cho_Dec_Qual'

irc = 0

! Determine the max diagonal (qualified excluded)
! For 1-center decomposition, this is done later.
if (Cho_1Center) then
  Dmax(1:nSym) = Zero
else
  Sync = .false.
  call Cho_P_MaxDX(Diag,Sync,Dmax)
end if

! Set the number of previous Cholesky vectors (global)
call Cho_P_GetGV(nVecG,nSym)

ipD = 1
ipQ = 1
ipSQL = 1
ipSQK = 1
ipQD = 0
do jSym=1,nSym

  mQ = max(nQual(jSym),1)

  ! Do the subtraction  Q({ab}|{cd}) -= sum_J  L({ab},J) * L({cd},J)
  ! -----------------------------------------------------------------
  call DGEMM_('N','T',nQual(jSym),nQual(jSym),nVecG(jSym),-One,Lab(ipSQL),mQ,Lab(ipSQL),mQ,One,Q(ipQ),mQ)

  ! Extract diagonal of updated Q({ab}|{cd})
  ! ----------------------------------------
  do iQ=1,nQual(jSym)
    QDiag(ipQD+iQ) = Q(ipQ-1+nQual(jSym)*(iQ-1)+iQ)
  end do

  ! For 1-Center decomposition, find max. diagonal among qualified
  ! --------------------------------------------------------------
  if (Cho_1Center) then
    do iQ=1,nQual(jSym)
      Dmax(jSym) = max(Dmax(jSym),QDiag(ipQD+iQ))
    end do
  end if

  ! Cholesky decompose Q({ab}|{cd})
  ! Note: Q is destroyed in CD_InCore_p
  ! -----------------------------------
  Thr = max(ThrCom,Dmax(jSym)*Span)
  call CD_InCore_p(Q(ipQ),nQual(jSym),Kab(ipSQK),nQual(jSym),iD(ipD),NumV(jSym),Thr,irc)

  if (irc /= 0) then
    write(u6,*) SecNam,' non-zero rc on exit from CD_InCore_p: ',irc
    call Cho_Quit('Decomposition error in '//SecNam,104)
  end if

  ipSQL = ipSQL+nQual(jSym)*nVecG(jSym)
  ipSQK = ipSQK+nQual(jSym)**2
  ipQ = ipQ+nQual(jSym)**2
  ipD = ipD+nQual(jSym)
  ipQD = ipQD+nQual(jSym)

end do

return

end subroutine Cho_Dec_Qual

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! PUT NUMBERS ON SAMPFILE.
subroutine Put9(Etot,Ract,iHowMSamp,Gmma,Gam,Esav,iDisk)

use qmstat_global, only: Cordst, iLuSaUt, iPrint, iTcSim, nCent, nPart
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_IN_) :: Etot, Ract, Gmma, Gam, Esav
integer(kind=iwp), intent(inout) :: iHowMSamp, iDisk
integer(kind=iwp) :: i, iDiskHead, iDiskOld
character(len=200) :: Head
real(kind=wp), allocatable :: CT(:)

iHowMSamp = iHowMSamp+1
iDiskOld = iDisk
call WrRdSim(iLuSaUt,1,iDisk,iTcSim,64,Etot,Ract,nPart,Gmma,Gam,Esav) !A header
iTcSim(1) = iDisk
call mma_allocate(CT,nPart*nCent)
do i=1,3
  CT(:) = Cordst(i,1:nCent*nPart)
  call dDaFile(iLuSaUt,1,CT,nPart*nCent,iDisk)
  ! The solvent coordinates.
  iTcSim(i+1) = iDisk
end do
call mma_deallocate(CT)
!call dDaFile(iLuSaUt,1,-DT,3*nPart*nPol,iDisk)
!iTcSim(5) = iDisk
iDiskHead = iDiskOld
! Put header again, but now with a meaningful iTcSim vector that contains the table of contents which simplifies reading
call WrRdSim(iLuSaUt,1,iDiskHead,iTcSim,64,Etot,Ract,nPart,Gmma,Gam,Esav)

if (iPrint >= 15) then
  write(Head,*) ' Coordinates put on sampfile.'
  call Cooout(Head,Cordst,nPart,nCent)
end if

return

end subroutine PUT9

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CnstAntiC(DPT2Canti,UEFF,U0)

use sguga, only: SGS
use caspt2_global, only: iRoot1, iRoot2, OLagFull
use caspt2_module, only: ENERGY, NASH, NASHT, NBAS, NBAST, NBSQT, NCONF, NDEL, NFRO, NISH, NORB, NSTATE, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: DPT2Canti(*)
real(kind=wp), intent(in) :: UEFF(nState,nState), U0(*)
integer(kind=iwp) :: i, iMO1, iMO2, iOrb0, iOrb2, iStat, iSym, j, jOrb0, jOrb2, jStat, nLev, nOrbI1, nOrbI2
real(kind=wp) :: Scal
real(kind=wp), allocatable :: CI1(:), CI2(:), G1(:,:), SGM1(:), SGM2(:), TG1(:,:), WRK1(:), WRK2(:)

nLev = SGS%nLev

call mma_allocate(CI1,nConf,Label='CI1')
call mma_allocate(CI2,nConf,Label='CI2')
call mma_allocate(SGM1,nConf,Label='SGM1')
call mma_allocate(SGM2,nConf,Label='SGM2')
call mma_allocate(TG1,nAshT,nAshT,Label='TG1')
call mma_allocate(G1,nAshT,nAshT,Label='G1')

G1(:,:) = Zero
do iStat=1,nState
  !! UEFF is in the CASSCF basis, so the CI coefficient
  !! has to be transformed(-back) accordingly
  call LoadCI_XMS('N',1,nConf,nState,CI1,iStat,U0)
  do jStat=1,nState
    if (iStat == jStat) cycle
    call LoadCI_XMS('N',1,nConf,nState,CI2,jStat,U0)

    call Dens1T_RPT2(CI1,CI2,SGM1,TG1,nLev)
    !call sqprt(tg1,5)
    G1(:,:) = G1(:,:)+Half*(UEFF(iStat,iRoot2)*UEFF(jStat,iRoot1)-UEFF(jStat,iRoot2)*UEFF(iStat,iRoot1))*TG1(:,:)
  end do
end do
!call sqprt(g1,5)

call mma_deallocate(CI1)
call mma_deallocate(CI2)
call mma_deallocate(SGM1)
call mma_deallocate(SGM2)
call mma_deallocate(TG1)

!! The DPT2Canti computed so far has been doubled
DPT2Canti(1:nBasT**2) = DPT2Canti(1:nBasT**2)*Half

iMO1 = 1
iMO2 = 1
do iSym=1,nSym
  nOrbI1 = nOrb(iSym)
  nOrbI2 = nBas(iSym)-nDel(iSym)
  if (nOrbI2 > 0) then
    !! Add active orbital density
    !! Probably incorrect if symmetry
    do iOrb0=1,nAsh(iSym)
      !iOrb1 = nIsh(iSym)+iOrb0
      iOrb2 = nFro(iSym)+nIsh(iSym)+iOrb0
      do jOrb0=1,nAsh(iSym)
        !jOrb1 = nIsh(iSym)+jOrb0
        jOrb2 = nFro(iSym)+nIsh(iSym)+jOrb0
        DPT2Canti(iMO2+iOrb2-1+nOrbI2*(jOrb2-1)) = DPT2Canti(iMO2+iOrb2-1+nOrbI2*(jOrb2-1))+G1(iOrb0,jOrb0)
      end do
    end do
  end if
  iMO1 = iMO1+nOrbI1*nOrbI1
  iMO2 = iMO2+nOrbI2*nOrbI2
end do
call mma_deallocate(G1)

!! Add orbital response
call mma_allocate(WRK1,NBSQT,Label='WRK1')
call mma_allocate(WRK2,NBSQT,Label='WRK2')

!! Scale with the CASPT2 energy difference
WRK1(1:nBasT**2) = (ENERGY(iRoot2)-ENERGY(iRoot1))*DPT2Canti(1:nBasT**2)
!! anti-symmetrize the orbital response
call DGeSub(WRK1,nBas(1),'N',WRK1,nBas(1),'T',WRK2,nBas(1),nBas(1),nBas(1))

!! Probably, the way CSF term is computed in MOLCAS is different
!! from in BAGEL; see Eqs.(51)--(53). In the active space, i.e.
!! for SA-CASSCF, the orbital response in the active space cancel
!! (see JCP 2004, 120, 7322), but not in off-diagonal blocks.
!! The way MOLCAS computes adds more than the one BAGEL does, so
!! the orbital response has to be subtracted?
OLagFull(1:nBasT**2) = OLagFull(1:nBasT**2)-WRK1(1:nBasT**2)

call mma_deallocate(WRK1)
call mma_deallocate(WRK2)

!! S[x]^A:D = S[x]:D^A, according to alaska_util/csfgrad
!! so antisymmetrize D
do i=1,nBasT
  do j=1,i-1
    Scal = Half*(DPT2Canti(i+nBasT*(j-1))-DPT2Canti(j+nBasT*(i-1)))
    DPT2Canti(i+nBasT*(j-1)) = Scal
    DPT2Canti(j+nBasT*(i-1)) = -Scal
  end do
end do

end subroutine CnstAntiC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine  StatP(Index)
      Implicit Real*8 (a-h,o-z)
#include "pstat.fh"
#include "print.fh"
*
      iRout = 10
      iPrint = nPrint(iRout)
      If (Index.eq.0) Then
         Call GetMem('PSOAO0','MAX','Real',iDum,MaxMem)
         MinXtr = MaxMem
      Else
         If (iPrint.ge.6) Then
            Write (6,*)
            Write (6,'(21X,A)') '******* Partitioning Ratios *******'
            Write (6,'(21X,A)') '* Index  i     j     k     l      *'
            Write (6,'(21X,A7,4F6.3,A4)') '* Cont.',
     &                r1/DBLE(iTotal),r2/DBLE(iTotal),
     &                r3/DBLE(iTotal),r4/DBLE(iTotal),'   *'
            Write (6,'(21X,A7,4F6.3,A4)') '* Prim.',
     &                q1/DBLE(iTotal),q2/DBLE(iTotal),
     &                q3/DBLE(iTotal),q4/DBLE(iTotal),'   *'
            Write (6,'(21X,A)') '***********************************'
            Write (6,*)
            Write (6,'(21X,A,I8)') ' Largest Memory Deficiency:',MaxReq
            Write (6,'(21X,A,I8)') ' Least Overflow of Memory :',MinXtr
            Write (6,'(21X,A,I8)') ' Max Available Memory     :',MaxMem
         End If
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module TempTime

use Definitions, only: wp

implicit none
private

real(kind=wp) :: ChoGet_CPU, ChoGet_Wall, Drvg1_CPU, Drvg1_Wall, Pget2_CPU, Pget2_Wall, Pget3_CPU, Pget3_Wall, Prepp_CPU, &
                 Prepp_Wall, rMult_CPU, rMult_Wall, Twoel2_CPU, Twoel2_Wall, Twoel3_CPU, Twoel3_Wall

public :: ChoGet_CPU, ChoGet_Wall, Drvg1_CPU, Drvg1_Wall, Pget2_CPU, Pget2_Wall, Pget3_CPU, Pget3_Wall, Prepp_CPU, Prepp_Wall, &
          rMult_CPU, rMult_Wall, Twoel2_CPU, Twoel2_Wall, Twoel3_CPU, Twoel3_Wall

end module TempTime

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETH1(nBtri,ipH1,RFpert,ERFNuc)

      IMPLICIT REAL*8 (A-H,O-Z)

#include "WrkSpc.fh"
      Character*8 OneLbl
      Logical RFpert

      iRc=-1
      iOpt=6
      iCmp=1
      iSyLab=1
      OneLbl='OneHam  '

      Call RdOne(iRc,iOpt,OneLbl,iCmp,Work(ipH1),iSyLab)

      IF ( IRC.NE.0 ) THEN
        WRITE(6,*)
        WRITE(6,*)'    *** ERROR IN SUBROUTINE  CHO_GETH1 *** '
        WRITE(6,*)'   BARE NUCLEI HAMILTONIAN IS NOT AVAILABLE'
        WRITE(6,*)
        CALL Abend
      ENDIF

      ERFNuc=0.0D0
      If ( RFpert ) then
         Call GetMem('RFFLD','Allo','Real',ipTmp,nBtri)
         Call Get_dScalar('RF Self Energy',ERFNuc)
         Call Get_dArray('Reaction field',Work(ipTmp),nBtri)
         Call Daxpy_(nBtri,1.0D0,Work(ipTmp),1,WORK(ipH1),1)
         Call GetMem('RFFLD','Free','Real',ipTmp,nBtri)
      End If


      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DERD(NSJ,ICOORD,Tessera,ISphe,DerDM,DerTes,DerPunt,DerCentr,NTs,NAt,NEsf)

use PCM_Arrays, only: DiagScale
use Constants, only: One, Pi, Angstrom
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NSJ, ICOORD, NTs, ISphe(NTs), NAt, NEsf
real(kind=wp), intent(in) :: Tessera(4,NTs), DerTes(NTs,NAt,3), DerPunt(NTs,NAt,3,3), DerCentr(NEsf,NAt,3,3)
real(kind=wp), intent(out) :: DerDM(NTs,NTs)
integer(kind=iwp) :: ITS, JTS, L, LJ
real(kind=wp) :: ANTOAU, DIJ, DXIJ, DYIJ, DZIJ, FAC, PROD, XIJ, YIJ, ZIJ

ANTOAU = One/Angstrom

! Calcola la matrice DERDM, derivata di DMAT (secondo COSMO)
! rispetto alla coordinata ICOORD della sfera NSJ

! Loop sugli elementi di DMAT
do ITS=1,NTS
  L = ISPHE(ITS)
  do JTS=1,NTS
    LJ = ISPHE(JTS)
    ! Elementi diagonali di DMAT(x)
    if (ITS == JTS) then
      FAC = -DiagScale*sqrt(PI)
      DERDM(ITS,ITS) = FAC*DERTES(ITS,NSJ,ICOORD)*ANTOAU/(Tessera(4,ITS)*sqrt(Tessera(4,ITS)))
    else
      ! Elementi fuori diagonale di DMAT(x)
      XIJ = Tessera(1,ITS)-Tessera(1,JTS)
      YIJ = Tessera(2,ITS)-Tessera(2,JTS)
      ZIJ = Tessera(3,ITS)-Tessera(3,JTS)
      DIJ = sqrt(XIJ*XIJ+YIJ*YIJ+ZIJ*ZIJ)
      DXIJ = DERPUNT(ITS,NSJ,ICOORD,1)+DERCENTR(L,NSJ,ICOORD,1)-DERPUNT(JTS,NSJ,ICOORD,1)-DERCENTR(LJ,NSJ,ICOORD,1)
      DYIJ = DERPUNT(ITS,NSJ,ICOORD,2)+DERCENTR(L,NSJ,ICOORD,2)-DERPUNT(JTS,NSJ,ICOORD,2)-DERCENTR(LJ,NSJ,ICOORD,2)
      DZIJ = DERPUNT(ITS,NSJ,ICOORD,3)+DERCENTR(L,NSJ,ICOORD,3)-DERPUNT(JTS,NSJ,ICOORD,3)-DERCENTR(LJ,NSJ,ICOORD,3)
      PROD = (XIJ*DXIJ+YIJ*DYIJ+ZIJ*DZIJ)/DIJ**3
      DERDM(ITS,JTS) = -PROD
    end if
  end do
end do

return

end subroutine DERD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2000, Roland Lindh                                *
!***********************************************************************

subroutine InpRct(LuSpool)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!                                                                      *
!             Modified for Langevin polarizabilities, March 2000 (RL)  *
!***********************************************************************

use Constants, only: Zero, One, Two, Three, Four, Ten, Half, Pi, deg2rad, auTokJ, kBoltzmann
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: LuSpool
integer(kind=iwp) :: i, I_Sph, i_sph_inp, iChrct, ii, iPrint, iRout, istatus, ITypRad, jRout, Last, n
real(kind=wp) :: aArea, epscm, poltot, r_min_Sphere, Radius, tal, Temp, val
character(len=180) :: KWord, Key
integer(kind=iwp), external :: iCLast, nToken, NumSolv
real(kind=r8), external :: Anal_Gitt
character(len=180), external :: Get_Ln
#include "print.fh"
#include "rctfld.fh"
#include "covradt_data.fh"

iRout = 1
iPrint = nPrint(iRout)
!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize data for dielectric medium

Eps = One
EpsInf = One
Eps_User = -One
EpsInf_User = Zero
rds = Zero
lMax = -1
lRF = .false.
lRFCav = .false.
RF_Basis = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize data for PCM

PCM = .false.
i_sph_inp = 0
! Default PCM parameters
call PCMDef(ISlPar,RSlPar,iPrint)
!                                                                      *
!***********************************************************************
!                                                                      *
! Setting up default values for parameters used in Langevin
! polarizabilities

! latato: Gitter type (1 or 4)
latato = 1
Cordsi(:,latato) = Half

! polsi: site polarizability
polsi = Zero

! dipsi: site dipole moment
dipsi = Zero

! radlat: maximum extension of the lattic
radlat = Zero

! scala,scalb,scalc: lengths of the cell dimensions
scala = Zero ! should be set by input
scalb = Zero
scalc = Zero

! scaaa: overall scaling
scaaa = One

! rotation of grid
rotAlpha = Zero
rotBeta = Zero
rotGamma = Zero

! rsca: scaling of radii
rsca = One

! Controls wheather a sparse grid should be used outside
! a distance distSparse from ALL atoms and XF points
! nSparse = scala(sparse) / scala(normal)
LSparse = .false.
nSparse = 1
distSparse = Zero

! Minimum distance for handling dipole-dipole interactions
dipCutoff = Zero

! Damping of dipole-dipole interactions
lDamping = .true.

! Use a dipole-dipole cutoff of Amber type, i.e. same exclusions
! as for the static field
lAmberPol = .false.

! Controls scaling of contributions from negative entries in
! the exclusion list, typically 1-4 interactions
scal14 = One

! Controls wheather an average of different grids is done
LGridAverage = .false.

! diedel: controls deletion of gitter polarizabilities
diedel = 0.01_wp

! tK: Boltzman factor
tK = 0.001_wp

! clim: convergence threshold for solver
clim = 1.0e-15_wp

! afac: controls equation solver (valid values 0.3-0.97)
afac = Half

! iterDamp: controls update of dipoles in equation solver
!newDip = oldDip*iterDamp + estimatedDip*(1-iterDamp)
dampIter = 0.4_wp
lDiprestart = .false.

! nexpo: exponent of the potential with which the QM system kills
!        the gitter polatizabilities
nexpo = 12

! prefac: scaling of the polarization energies
prefac = One

lLangevin = .false.

! default solvent
Solvent = 'WATER'
ISlPar(15) = NumSolv(Solvent)
!                                                                      *
!***********************************************************************
!                                                                      *
iPrint = 5
!                                                                      *
!***********************************************************************
!                                                                      *
! Process the input

do
  read(LuSpool,'(A72)',iostat=istatus) Key
  if (istatus < 0) call Error(1)
  if (istatus > 0) call Error(2)
  KWord = Key
  call UpCase(KWord)
  if ((KWord(1:1) == '*') .or. (KWord == '')) cycle
  select case (KWord(1:4))
    case ('REAC')
      !                                                                *
      !***** REAC ******************************************************
      !                                                                *
      ! Read reaction field parameters
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,Eps)
      call Get_F1(2,rds)
      call Get_I1(3,lmax)
      if (nToken(KWord) > 3) call Get_F1(4,EpsInf)
      lRF = .true.
      lRFCav = .true.
      write(KWord,'(A,F10.5,A,F10.5,A,I4)') 'eps=',Eps,' radius=',rds,' higest moment=',lMax
    case ('PRIN')
      !                                                                *
      !***** PRIN ******************************************************
      !                                                                *
      ! Print level
      KWord = Get_Ln(LuSpool)
      call Get_I1(1,n)
      do i=1,n
        KWord = Get_Ln(LuSpool)
        call Get_I1(1,jRout)
        call Get_I1(2,iPrint)
        nPrint(jRout) = iPrint
      end do
    case ('LANG')
      !                                                                *
      !***** LANG ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,scala)
      call Get_F1(2,scalb)
      call Get_F1(3,scalc)
      lLangevin = .true.
      lRF = .true.
    case ('GITT')
      !                                                                *
      !***** GITT ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_I1(1,latato)
      do i=1,latato
        KWord = Get_Ln(LuSpool)
        call Get_F(1,Cordsi(1,i),3)
      end do
    case ('POLA')
      !                                                                *
      !***** POLA ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,polsi)
    case ('DIPO')
      !                                                                *
      !***** DIPO ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,dipsi)
    case ('OSCA')
      !                                                                *
      !***** OSCA ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,scaaa)
    case ('DIED')
      !                                                                *
      !***** DIED ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,diedel)
    case ('MXLX')
      !                                                                *
      !***** MXLX ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,radlat)
    case ('AFAC')
      !                                                                *
      !***** AFAC ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,afac)
      if (afac >= One) then
        call WarningMessage(2,'InpRct: afac invalid value!;        afac >= 1.0 !')
        call Quit_OnUserError()
      end if
    case ('RFBA')
      !                                                                *
      !***** RFBA ******************************************************
      !                                                                *
      !RF_Basis = .true.
    case ('PCM-')
      !                                                                *
      !***** PCM- ******************************************************
      !                                                                *
      PCM = .true.
      lRF = .true.
      lLangevin = .false.
    case ('SOLV')
      !                                                                *
      !***** SOLV ******************************************************
      !                                                                *
      Solvent = trim(Get_Ln(LuSpool))
      ISlPar(15) = NumSolv(Solvent)
    case ('DIEL')
      !                                                                *
      !***** DIEL ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,Eps_User)
      if (nToken(KWord) > 1) call Get_F1(2,EpsInf_User)
    case ('COND')
      !                                                                *
      !***** COND ******************************************************
      !                                                                *
      Conductor = .true.
      ISlPar(16) = 2
    case ('AARE')
      !                                                                *
      !***** AARE ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,aArea)
      RSlPar(7) = aArea
    case ('R-MI')
      !                                                                *
      !***** RMIN ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,r_min_Sphere)
      RSlPar(3) = r_min_Sphere
    case ('PAUL')
      !                                                                *
      !***** PAUL ******************************************************
      !                                                                *
      ITypRad = 2
      ISlPar(9) = ITypRad
    case ('SPHE')
      !                                                                *
      !***** SPHE ******************************************************
      !                                                                *
      KWord = Get_Ln(LuSpool)
      call Get_I1(1,I_Sph)
      call Get_F1(2,Radius)
      ITypRad = 3
      ISlPar(9) = ITypRad
      i_sph_inp = i_sph_inp+1
      if (i_sph_inp > MxA) then
        call WarningMessage(2,'InpRct: i_sph_inp > MxA')
        call Abend()
      end if
      NOrdInp(i_sph_inp) = I_Sph
      RadInp(i_sph_inp) = Radius
      ISlPar(14) = i_sph_inp
    case ('TEMP')
      !                                                                *
      !***** TEMP ******************************************************
      !                                                                *
      ! Temperature for Langevin model
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,Temp)
      tK = kBoltzmann/auTokJ*1.0e-3_wp*Temp
    case ('RSCA')
      !                                                                *
      !***** RSCA ******************************************************
      !                                                                *
      ! Simultaneous scaling of all radii
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,rsca)
    case ('ROTA')
      !                                                                *
      !***** ROTA ******************************************************
      !                                                                *
      ! Rotation of the grid with Euler angles alpha, beta, gamma (degrees)
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,rotAlpha)
      call Get_F1(2,rotBeta)
      call Get_F1(3,rotGamma)
      rotAlpha = rotAlpha*deg2rad
      rotBeta = rotBeta*deg2rad
      rotGamma = rotGamma*deg2rad
    case ('SPAR')
      !                                                                *
      !***** SPAR ******************************************************
      !                                                                *
      ! Use sparse grid outside a distance distSparse from all atoms
      KWord = Get_Ln(LuSpool)
      LSparse = .true.
      call Get_I1(1,nSparse)
      call Get_F1(2,distSparse)
    case ('IDAM')
      !                                                                *
      !***** IDAM ******************************************************
      !                                                                *
      ! change dampIter
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,dampIter)
    case ('AVER')
      !                                                                *
      !***** AVER ******************************************************
      !                                                                *
      ! requests average among a number of random grids in the Langevin
      ! routine. Note: Average is taken for each SCF iteration and only
      ! the last grid is used for updating the density
      ! nGridSeed is RNG seed, 0=no seed, -1=system timer
      KWord = Get_Ln(LuSpool)
      LGridAverage = .true.
      call Get_I1(1,nGridAverage)
      call Get_I1(2,nGridSeed)
    case ('CONV')
      !                                                                *
      !***** CONV ******************************************************
      !                                                                *
      ! Change convergence threshold
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,clim)
    case ('SKIP')
      !                                                                *
      !***** SKIP ******************************************************
      !                                                                *
      ! Set minimal distance for dipole-dipole interactions
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,dipCutoff)
    case ('NODA')
      !                                                                *
      !***** NODA ******************************************************
      !                                                                *
      ! Turn off damping of dipole-dipole interactions
      lDamping = .false.
    case ('LRAD')
      !                                                                *
      !***** LRAD ******************************************************
      !                                                                *
      ! Input non-standard Langevin radii
      do
        Kword = Get_Ln(LuSpool)
        call UpCase(KWord)
        if (KWord(1:1) == '*') cycle
        if (KWord == '') cycle
        if (KWord(1:3) == 'END') exit
        read(KWord,*,iostat=istatus) ii,val
        if (istatus > 0) call Error(2)
        CovRadT_(ii) = val
        !write(u6,*) 'COVR',ii,val
      end do
    case ('AMBE')
      !                                                                *
      !***** AMBE ******************************************************
      !                                                                *
      ! Use dipole-dipole cutoff of AMBER type
      lAmberPol = .true.
    case ('SC14')
      !                                                                *
      !***** SC14 ******************************************************
      !                                                                *
      ! Scaling of negative entries in exclusion list
      KWord = Get_Ln(LuSpool)
      call Get_F1(1,scal14)
    case ('DRES')
      !                                                                *
      !***** DRES ******************************************************
      !                                                                *
      ! Restart dipoles from scratch in each QM iteration
      ! This sometimes gives better convergence.
      lDiprestart = .true.
    case ('END ')
      !                                                                *
      !***** END  ******************************************************
      !                                                                *
      ! End of input
      exit
    case default
      iChrct = len(KWord)
      Last = iCLast(KWord,iChrct)
      write(u6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
      call WarningMessage(2,'InpRct: Error in keyword.')
      call Quit_OnUserError()
  end select
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (lLangevin) then

  polsi = polsi*scaaa**Three
  scala = scala*scaaa
  scalb = scalb*scaaa
  scalc = scalc*scaaa
  dipsi = dipsi*scaaa**(Three/Two)

  ! Analyze the lattice

  gatom = Anal_Gitt(cordsi,latato)

  ! Scale the grid.

  do i=1,latato
    cordsi(1,i) = cordsi(1,i)*scala
    cordsi(2,i) = cordsi(2,i)*scalb
    cordsi(3,i) = cordsi(3,i)*scalc
  end do

  if (lRFCav) then
    if (radlat == Zero) radlat = rds-One/Ten
    if (radlat > rds) then
      call WarningMessage(2,'InpRct: radlat > rds')
      call Abend()
    end if
  else
    call WarningMessage(1,'Running Langevin without reaction field')
  end if

  tK = One/tK
  poltot = gatom*(polsi+dipsi**2*tK/Three)
  tal = poltot*Four*Pi/(Three*scala*scalb*scalc)
  epscm = (One+Two*tal)/(One-tal)
  if (Eps < One) Eps = epscm

  tk5 = Half*tk

end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

contains

subroutine Error(code)
  integer(kind=iwp), intent(in) :: code
  select case (code)
    case (1)
      call WarningMessage(2,'InpRct: Premature end of input file.')
    case (2)
      call WarningMessage(2,'InpRct: Error while reading input file.')
  end select
  call Quit_OnUserError()
end subroutine

end subroutine InpRct

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine WrHDsk(Hess,ngrad)
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "disp.fh"
#include "disp2.fh"
#include "real.fh"
      real*8 Hess(nGrad*(nGrad+1)/2)
      Character*8 Label
*
      Call Getmem('Temp','ALLO','REAL',ipTemp,nGrad**2)
      nH=0
      Do iIrrep=0,nIrrep-1
         nH=nH+lDisp(iIrrep)
      End Do
      Call Getmem('HStat','ALLO','REAL',ipHStat,nH)
*
*---- Reorder Hessian to lower triangular form
*
      iGrad1=1
      iGrad2=0
      iG=0
      ip_Acc=ipHStat
      Do iIrrep=0,nIrrep-1
         iGrad2=iGrad2+lDisp(iIrrep)
*
         ipH=ipTemp
         Do iG1=iGrad1,iGrad2
           Do iG2=iGrad1,iG1
              iG=iG+1
              Work(ipTemp+iG-1)=Hess(iG1*(iG1-1)/2+IG2)
           End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*------- Diagonalize and keep eigen values for check facility
*
         mH=lDisp(iIrrep)
         Call GetMem('EVal','Allo','Real',ipEVal,mH*(mH+1)/2)
         Call GetMem('EVec','Allo','Real',ipEVec,mH*mH)
*
         call dcopy_(mH*(mH+1)/2,Work(ipH),1,Work(ipEVal),1)
         call dcopy_(mH*mH,[Zero],0,Work(ipEVec),1)
         call dcopy_(mH,[One],0,Work(ipEVec),mH+1)
*
*------- Compute eigenvalues and eigenvectors
*
         Call Jacob(Work(ipEVal),Work(ipEVec),mH,mH)
         Call Jacord(Work(ipEVal),Work(ipEVec),mH,mH)
*
         Do i = 1, mH
            Work(ip_Acc)=Work(i*(i+1)/2+ipEVal-1)
            ip_Acc=ip_Acc+1
         End Do
*
         Call GetMem('EVec','Free','Real',ipEVec,mH*mH)
         Call GetMem('EVal','Free','Real',ipEVal,mH*(mH+1)/2)
*                                                                      *
************************************************************************
*                                                                      *
         iGrad1=iGrad1+lDisp(iIrrep)
      End Do
*
*---- Write eigen values to the check file.
*
      Call Add_Info('HStat',Work(ipHStat),nH,5)
*
      iRc=-1
      iOpt=0
      Label='StatHess'
      Call dWrMck(iRC,iOpt,Label,idum,Work(ipTemp),idum)
      If (iRc.ne.0) Then
         Write (6,*) 'WrHDsk: Error writing to MCKINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend()
      End If
      Call Getmem('HStat','Free','REAL',ipHStat,nH)
      Call Getmem('Temp','Free','REAL',ipTemp,nGrad**2)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1987, Jeppe Olsen                                      *
!               1989, Markus P. Fuelscher                              *
!***********************************************************************

subroutine CNDET(ICONF,IPDET,NDET,NEL,NORB,NOP,NCL,IDET,IPRINT)
! AUTHOR:        J. OLSEN, UNIV. OF LUND, SWEDEN, APRIL 1987
! MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
!                M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
!
! PURPOSE:
!
! A CONFIGURATION ICONF IN COMPRESSED FORM AND A SET OF
! PROTOTYPE DETERMINANTS, IPDET, ARE GIVEN.
! CONSTRUCT THE CORRESPONDING DETERMINANTS IN CONTRACTED FORM.

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NDET, NORB, NOP, ICONF(NORB), IPDET(NOP,NDET), NEL, NCL
integer(kind=iwp), intent(out) :: IDET(NEL,NDET)
integer(kind=iwp), intent(inout) :: IPRINT
integer(kind=iwp) :: IADD, IBASE, ICL, IOP, JDET

! POSITIVE NUMBER  : ALPHA ORBITAL
! NEGATIVE NUMBER  : BETA  ORBITAL
!
!IPRINT = 40
!write(u6,*) 'iprint == 40 in CNDET, nclosed, nopen',iprint, ncl,nop
!write(u6,*) 'iconf, nclosed, nopen',iconf(1:1+ncl-1)
!if (nop /= 0) then
!  write(u6,*) 'opened orbitals',iconf(1+ncl:ncl+nop)
!end if

if (IPRINT == 40) then
  if (NCL /= 0) then
    write(u6,*) ' DOUBLE OCCUPIED ORBITALS'
    call IWRTMA(ICONF,1,NCL,1,NCL)
  end if
  if (NOP /= 0) then
    write(u6,*) ' OPEN ORBITALS'
    call IWRTMA(ICONF(1+NCL),1,NOP,1,NOP)
  end if
end if

! 1 DOUBLY OCCUPIED ORBITALS ARE PLACED FIRST

do ICL=1,NCL
  IBASE = 2*(ICL-1)
  do JDET=1,NDET
    IDET(IBASE+1,JDET) = ICONF(ICL)
    IDET(IBASE+2,JDET) = -ICONF(ICL)
  end do
end do

! 2 SINGLY OCCUPIED ORBITALS

IADD = 2*NCL
do JDET=1,NDET
  do IOP=1,NOP
    if (IPDET(IOP,JDET) == 1) then
      IDET(IADD+IOP,JDET) = ICONF(NCL+IOP)
    else if (IPDET(IOP,JDET) == 0) then
      IDET(IADD+IOP,JDET) = -ICONF(NCL+IOP)
    end if
  end do
end do

if (IPRINT == 40) then
  write(u6,*) ' CONFIGURATION FROM DETCON'
  call IWRTMA(ICONF,1,NORB,1,NORB)
  write(u6,*) ' PROTO TYPE DETERMINANTS'
  if (NOP*NDET > 0) call IWRTMA(IPDET,NOP,NDET,NOP,NDET)

  if (NEL*NDET > 0) write(u6,*) ' CORRESPONDING DETERMINANTS'
  call IWRTMA(IDET,NEL,NDET,NEL,NDET)

end if

IPRINT = 0

return

end subroutine CNDET

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!               2002, Roland Lindh                                     *
!***********************************************************************

subroutine GrdTr_Alaska(GradIn,MxAto,GradOut,nGrad)
!***********************************************************************
!                                                                      *
!  The inverse of                                                      *
!  Transforms a symmetry adapted gradient to unsymmetric  form         *
!                                                                      *
!   Written by Anders Bernhardsson                                     *
!   960427                                                             *
!   Modified by Roland Lindh                                           *
!   020115                                                             *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: MxAto, nGrad
real(kind=wp), intent(in) :: GradIn(3,MxAto)
real(kind=wp), intent(out) :: GradOut(nGrad)
integer(kind=iwp) :: iCar, iCen, iCnt, iCnttp, iComp, iIrrep, mdc, nDispS
real(kind=wp), parameter :: tol = 1.0e-8_wp
logical(kind=iwp), external :: TF
#include "Molcas.fh"
#include "disp.fh"

iIrrep = 0

mdc = 0
iCen = 1
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux) return
  do iCnt=1,dbsc(iCnttp)%nCntr
    mdc = mdc+1
    nDispS = IndDsp(mdc,iIrrep)

    do iCar=0,2
      iComp = 2**iCar
      if (TF(mdc,iIrrep,iComp)) then
        nDispS = nDispS+1
        GradOut(nDispS) = GradIn(iCar+1,iCen)
      end if
    end do
    iCen = iCen+nIrrep/dc(mdc)%nStab
  end do
end do

return

end subroutine GrdTr_Alaska

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               1993, Per-Olof Widmark                                 *
!***********************************************************************

subroutine OrdIn1(iOpt,Buf0,lBuf0,iBatch)
!***********************************************************************
!                                                                      *
!     Purpose: Read a buffer of ordered two electron integrals         *
!                                                                      *
!     Note:    This subroutine has internal buffers.                   *
!                                                                      *
!    Calling parameters:                                               *
!    Buf0   : contains on output the integrals                         *
!    lBuf0  : number of integrals to be transfered                     *
!    iOpt   : option code (iOpt=1:start reading at first integral)     *
!                         (iOpt=2:continue reading)                    *
!    rc     : return code                                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher and P.O. Widmark                                 *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************
!----------------------------------------------------------------------*
!                                                                      *
!     This is a buffer exclusively used for I/O buffering              *
!     of the ordered 2-el. integrals file                              *
!                                                                      *
!     !!!     The current version uses one buffer only     !!!         *
!     !!! Double buffering and asynchronous I/O is preseen !!!         *
!                                                                      *
!----------------------------------------------------------------------*

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use TwoDat, only: AuxTwo, isDAdr, lStRec, lTop, TocTwo
use Definitions, only: wp, iwp, RtoB

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iOpt, iBatch
real(kind=wp), intent(_OUT_) :: Buf0(*)
integer(kind=iwp), intent(inout) :: lBuf0
integer(kind=iwp) :: iDisk1, isBuf0, isBuf1, jOpt, kOpt = 0, lBuf1, LuTwo, nByte, ncopy, nleft
character :: Buf1(8*lStRec) = ' '
real(kind=wp), external :: C2R8

!----------------------------------------------------------------------*
! Fetch the unit number, disk start address and pointers               *
!----------------------------------------------------------------------*
LuTwo = AuxTwo%Unt
iDisk1 = AuxTwo%DaDa
isBuf1 = AuxTwo%Upk8
lBuf1 = AuxTwo%lBf1
if (iOpt == 1) then
  !--------------------------------------------------------------------*
  ! If this is the first block of a symmetry batch                     *
  ! get the disk disk start address and load the buffer                *
  !--------------------------------------------------------------------*
  iDisk1 = TocTwo(isDAdr+iBatch-1)
  jOpt = 2
  call cdDAFILE(LuTwo,jOpt,Buf1,lStRec,iDisk1)
  !--------------------------------------------------------------------*
  ! Note:                                                              *
  ! If the records are organized in sequential order                   *
  ! (SORT3 in SEWARD is activated)                                     *
  ! deactivate the update of the disk address                          *
  !                                                                    *
  ! iDisk1=NINT(C2R8(Buf1(1)))                                         *
  !--------------------------------------------------------------------*
  lBuf1 = nint(C2R8(Buf1(17)))
  kOpt = nint(C2R8(Buf1(25)))
  isBuf1 = lTop*RtoB+1
end if
if (lBuf0 <= lBuf1) then
  !--------------------------------------------------------------------*
  ! If the number of requested integrals is smaller than               *
  ! the current buffer transfer data                                   *
  !--------------------------------------------------------------------*
  call cUPKR8(kOpt,lBuf0,nByte,Buf1(isBuf1),Buf0)
  isBuf1 = isBuf1+nByte
  lBuf1 = lBuf1-lBuf0
else
  !--------------------------------------------------------------------*
  ! If the number of requested integrals is larger than                *
  ! the current buffer first drain the current buffer and              *
  ! read as many subsequent buffers as needed                          *
  !--------------------------------------------------------------------*
  call cUPKR8(kOpt,lBuf1,nByte,Buf1(isBuf1),Buf0)
  isBuf0 = lBuf1+1
  nleft = lBuf0-lBuf1
  do while (nleft > 0)
    jOpt = 2
    call cdDAFILE(LuTwo,jOpt,Buf1,lStRec,iDisk1)
    !------------------------------------------------------------------*
    ! Note:                                                            *
    ! If the records are organized in sequential order                 *
    ! (SORT3 in SEWARD is activated)                                   *
    ! deactivate the update of the disk address                        *
    !                                                                  *
    ! iDisk1=NINT(C2R8(Buf1(1)))                                       *
    !------------------------------------------------------------------*
    lBuf1 = nint(C2R8(Buf1(17)))
    ncopy = min(nleft,lBuf1)
    kOpt = nint(C2R8(Buf1(25)))
    isBuf1 = lTop*RtoB+1
    call cUPKR8(kOpt,ncopy,nByte,Buf1(isBuf1),Buf0(isBuf0))
    isBuf0 = isBuf0+ncopy
    isBuf1 = lTop*RtoB+1+nByte
    lBuf1 = lBuf1-ncopy
    nleft = nleft-ncopy
  end do
end if
!----------------------------------------------------------------------*
! Update pointer to next disk address and integral to unpack           *
!----------------------------------------------------------------------*
AuxTwo%DaDa = iDisk1
AuxTwo%Upk8 = isBuf1
AuxTwo%lBf1 = lBuf1

!----------------------------------------------------------------------*
! exit                                                                 *
!----------------------------------------------------------------------*
return

!This is to allow type punning without an explicit interface
contains

subroutine cdDAFILE(Lu,iOpt,Buf,lBuf_,iDisk_)

  integer(kind=iwp), intent(in) :: Lu, iOpt, lBuf_
  character, target, intent(inout) :: Buf(*)
  integer(kind=iwp), intent(inout) :: iDisk_
  real(kind=wp), pointer :: pBuf(:)

  call c_f_pointer(c_loc(Buf(1)),pBuf,[lBuf_])
  call dDAFILE(Lu,iOpt,pBuf,lBuf_,iDisk_)
  nullify(pBuf)

end subroutine cdDAFILE

subroutine cUPKR8(iOpt,nData,nByte,InBuf,OutBuf)

  integer(kind=iwp), intent(in) :: iOpt
  integer(kind=iwp), intent(inout) :: nData
  integer(kind=iwp), intent(out) :: nByte
  character, target, intent(in) :: InBuf(*)
  real(kind=wp), intent(_OUT_) :: OutBuf(*)
  real(kind=wp), pointer :: dBuf(:)

  call c_f_pointer(c_loc(InBuf(1)),dBuf,[nData])
  call UPKR8(iOpt,nData,nByte,dBuf,OutBuf)
  nullify(dBuf)

end subroutine cUPKR8

end subroutine OrdIn1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Martin Schuetz                                         *
*               2017, Roland Lindh                                     *
************************************************************************
      Subroutine ErrV(lvec,ivec,QNRstp,ErrVec,HDiag)
************************************************************************
*                                                                      *
*     computes error vector for DIIS, in 1st order case, this          *
*     is just grad(ivec): in 2nd order case (QNRstp.eq..TRUE.)         *
*     this is -H(iterso)*grad(ivec)                                    *
*     the pointer to the proper error vector is returned as function   *
*     val.                                                             *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
*
      Real*8 HDiag(lVec), ErrVec(lVec)
      Integer lvec
      Logical QNRstp
*
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
#include "stdalloc.fh"
#include "file.fh"
#include "llists.fh"
*
*     local vars
      Integer inode
      Real*8, Dimension(:), Allocatable:: Grad
*
      Call GetNod(ivec,LLGrad,inode)
      If (inode.eq.0) GoTo 555
*
      If (QNRstp) Then
*
*       we eventually need one more vector
*
        Call mma_allocate(Grad,lvec,Label='Grad')
        Call iVPtr(LuGrd,Grad,lvec,inode)
        Call SOrUpV(MemRsv,Grad,HDiag,lvec,ErrVec,'DISP','BFGS')
        Call mma_deallocate(Grad)
*
      Else
*
        Call iVPtr(LuGrd,ErrVec,lvec,inode)
*
      End If
*
      Return
*
*-----Error handling
*
*     Hmmm, no entry found in LList, that's strange
 555  Write (6,*) 'ErrV: no entry found in LList!'
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CSFTRA(KEY,CI,AREF)

use mrci_global, only: IREFX, NCONF, NREF
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
character(len=4), intent(in) :: KEY
real(kind=wp), intent(inout) :: CI(NCONF)
real(kind=wp), intent(in) :: AREF(NREF,NREF)
integer(kind=iwp) :: I, J
real(kind=wp) :: RSUM
real(kind=wp), allocatable :: TMP(:)

if (NREF == 1) return
call mma_allocate(TMP,NREF,label='NREF')
if (KEY == ' CSF') then
  do I=1,NREF
    RSUM = Zero
    do J=1,NREF
      RSUM = RSUM+AREF(I,J)*CI(IREFX(J))
    end do
    TMP(I) = RSUM
  end do
else
  do I=1,NREF
    RSUM = Zero
    do J=1,NREF
      RSUM = RSUM+AREF(J,I)*CI(IREFX(J))
    end do
    TMP(I) = RSUM
  end do
end if
do I=1,NREF
  CI(IREFX(I)) = TMP(I)
end do
call mma_deallocate(TMP)

return

end subroutine CSFTRA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module RPA_globals

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: nTitle, nSym, nFreeze(2), nBas(8), nOrb(8), nFro(8,2), nOcc(8,2), nVir(8,2), nDel(8,2), l_CMO, l_EMO, &
                     l_OccEn(2), l_VirEn(2), iPrint
real(kind=wp) :: NuclearRepulsionEnergy(1)
logical(kind=iwp) :: dRPA, SOSEX, doCD, doDF, doLDF, LumOrb
character(len=3) :: Reference
character(len=8) :: RPAModel
character(len=80) :: DFTFunctional
real(kind=wp), allocatable :: CMO(:,:), EMO(:,:), OccEn(:,:), VirEn(:,:)
integer(kind=iwp), parameter :: mTitle = 10
character(len=80) :: Title(mTitle)

public :: nTitle, nSym, nFreeze, nBas, nORb, nFro, nOcc, nVir, nDel, CMO, l_CMO, EMO, l_EMO, OccEn, l_OccEn, VirEn, l_VirEn, &
          iPrint, NuclearRepulsionEnergy, dRPA, SOSEX, doCD, doDF, doLDF, LumOrb, Reference, RPAModel, DFTFunctional, mTitle, Title

end module RPA_globals

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PNT4DM(NSMOB,NO1PS,NO2PS,NO3PS,NO4PS,IDXSM,IS12,IS34,IS1234,IPNTR,ISM4A)
! Pointer for 4 dimensionl array with total symmetry IDXSM
! Pointer is given as 3 dimensional array corresponding
! to the first 3 indices
! Symmetry of last index is give by ISM4
!
! IS12 (0,1,-1)   : Permutational symmetry between indices 1 and 2
! IS34 (0,1,-1)   : Permutational symmetry between indices 3 and 3
! IS1234 (0,1,-1) : Permutational symmetry between indices 12 and 34

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSMOB, NO1PS(NSMOB), NO2PS(NSMOB), NO3PS(NSMOB), NO4PS(NSMOB), IDXSM, IS12, IS34, IS1234
integer(kind=iwp), intent(out) :: IPNTR(NSMOB,NSMOB,NSMOB), ISM4A(NSMOB,NSMOB,NSMOB)
integer(kind=iwp) :: I12NUM, I12SM, I1SM, I2SM, I34NUM, I34SM, I3SM, I4SM, IOFF, N12, N34

IPNTR(:,:,:) = 0
ISM4A(:,:,:) = 0

!write(u6,*) 'NO1PS NO2PS NO3PS NO4PS'
!call IWRTMA(NO1PS,1,NSMOB,1,NSMOB)
!call IWRTMA(NO2PS,1,NSMOB,1,NSMOB)
!call IWRTMA(NO3PS,1,NSMOB,1,NSMOB)
!call IWRTMA(NO4PS,1,NSMOB,1,NSMOB)
IOFF = 1
N12 = 0
N34 = 0

do I1SM=1,NSMOB
  do I2SM=1,NSMOB
    I12SM = Mul(I1SM,I2SM)
    I34SM = Mul(I12SM,IDXSM)
    if (I34SM == 0) cycle
    if ((IS12 /= 0) .and. (I1SM < I2SM)) cycle
    if (IS12 == 0) then
      I12NUM = (I1SM-1)*NSMOB+I2SM
    else
      I12NUM = nTri_Elem(I1SM)+I2SM
    end if
    if ((IS12 == 0) .or. (I1SM /= I2SM)) then
      N12 = NO1PS(I1SM)*NO2PS(I2SM)
    else if ((IS12 == 1) .and. (I1SM == I2SM)) then
      N12 = nTri_Elem(NO1PS(I1SM))
    else if ((IS12 == -1) .and. (I1SM == I2SM)) then
      N12 = nTri_Elem(NO1PS(I1SM)-1)
    end if
    do I3SM=1,NSMOB
      I4SM = Mul(I3SM,I34SM)
      if (I4SM == 0) cycle
      if ((IS34 /= 0) .and. (I3SM < I4SM)) cycle
      if (IS34 == 0) then
        I34NUM = (I3SM-1)*NSMOB+I4SM
      else
        I34NUM = nTri_Elem(I3SM)+I4SM
      end if
      if ((IS1234 /= 0) .and. (I12NUM < I34NUM)) cycle
      if ((IS34 == 0) .or. (I3SM /= I4SM)) then
        N34 = NO3PS(I3SM)*NO4PS(I4SM)
      else if ((IS34 == 1) .and. (I3SM == I4SM)) then
        N34 = nTri_Elem(NO3PS(I3SM))
      else if ((IS34 == -1) .and. (I3SM == I4SM)) then
        N34 = nTri_Elem(NO3PS(I3SM)-1)
      end if
      if ((IS1234 == 0) .or. (I12NUM /= I34NUM)) then
        IPNTR(I1SM,I2SM,I3SM) = IOFF
        ISM4A(I1SM,I2SM,I3SM) = I4SM
        IOFF = IOFF+N12*N34
      else if ((IS1234 == 1) .and. (I12NUM == I34NUM)) then
        IPNTR(I1SM,I2SM,I3SM) = IOFF
        ISM4A(I1SM,I2SM,I3SM) = I4SM
        IOFF = IOFF+nTri_Elem(N12)
      else if ((IS1234 == -1) .and. (I12NUM == I34NUM)) then
        IPNTR(I1SM,I2SM,I3SM) = IOFF
        ISM4A(I1SM,I2SM,I3SM) = I4SM
        IOFF = IOFF+nTri_Elem(N12-1)
      end if
      !write(u6,*) ' I1SM I2SM I3SM I4SM    IOFF'
      !write(u6,'(1X,4I4,I9)') I1SM,I2SM,I3SM,I4SM,IOFF
    end do
  end do
end do

!write(u6,*) ' PNT4DM, 64 elemets of IPNTR'
!call IWRTMA(IPNTR,1,64,1,64)
#ifdef _DEBUGPRINT_
write(u6,*) ' Length of 4 index array ',IOFF-1
#endif

end subroutine PNT4DM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2006, Markus Reiher                               *
************************************************************************
      subroutine operators_U (i,uniorder,dkhorder,xorder,dkhscfflg,
     *               ordercounter,opcounter,operleng,oporder,evenodd,
     *               doperators,operators,xordercounter,xopcounter,
     *               xoperleng,xoporder,xevenodd,xdoperators,xoperators,
     *               ucounter,uopsleng,uoporder,eouops,puop,duops,uops)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.3
c
c   last modified: 19.10.2006 (MR. ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer i,uniorder,dkhorder,xorder,ordercounter(0:maxorder),
     *        opcounter,operleng(maxoperators),oporder(maxoperators,3),
     *        evenodd(maxoperators),
     *        xordercounter(0:maxorder),xopcounter,
     *        xoperleng(maxoperators),xoporder(maxoperators),
     *        xevenodd(maxoperators)
      REAL*8 doperators(maxoperators),
     *                 xdoperators(maxoperators)
c
      integer ucounter,uopsleng(maxuops),uoporder(maxuops),
     *        eouops(maxuops),puop(maxuops)
      REAL*8 duops(maxuops)
      character*(maxlength) uops(maxuops)
#if defined(_MOLCAS_) || defined(MOLPRO)
      character operators(*),xoperators(*)
      character*(maxlength) opstring,opstring1,xopstring,xopstring1
#else
      character*(maxlength) operators(maxoperators)
     *                      xoperators(maxoperators)
#endif
c
      logical dkhscfflg,lasttrans
      integer idum1,idum2,j,l
      intrinsic INT,NINT,DBLE
c
      idum1=opcounter
      lasttrans=(i.eq.uniorder)
      do 10 j=1,ucounter
        do 20 l=1,idum1
          if (oporder(l,3)+uoporder(j).gt.dkhorder) goto 10
          if (lasttrans) then
            if (evenodd(l)*eouops(j).eq.-1) goto 20
          endif
          opcounter=opcounter+1
          if (opcounter.gt.maxoperators) then
            write (stdout,1001)
1001        format (/2X,'WARNING1: Too many operators (opcounter >',
     *              ' maxoperators)!',/11X,'Increase maxoperators ',
     *              '(e.g., by one order of magnitude)!',/2X,'STOP.',/)
            CALL Abend
          endif
          operleng(opcounter)=operleng(l)+uopsleng(j)
          if (operleng(opcounter).gt.maxlength) then
            write (stdout,1003)
1003        format (/2X,'WARNING2:  operleng > maxlength in SR',
     *              ' "operators_U".',/2X,'STOP.',/2X)
            CALL Abend
          endif
#if defined(_MOLCAS_) || defined(MOLPRO)
          call get_dkoperators(l,opstring1,operators)
          opstring=opstring1(1:operleng(l))//uops(j)(1:uopsleng(j))
          call put_dkoperators(opcounter,opstring,operators)
#else
          operators(opcounter)(1:operleng(opcounter))
     *        =operators(l)(1:operleng(l))//uops(j)(1:uopsleng(j))
#endif
          oporder(opcounter,3)=oporder(l,3)+uoporder(j)
          if (.not.dkhscfflg) then
            oporder(opcounter,1)=oporder(opcounter,3)
            oporder(opcounter,2)=0
          endif
          ordercounter(oporder(opcounter,3))=
     *      ordercounter(oporder(opcounter,3))+1
          evenodd(opcounter)=evenodd(l)*eouops(j)
          doperators(opcounter)=doperators(l)*duops(j)
* determine sign (because this is U_dagger !)
          if (INT(DBLE(puop(j))/2.0d0).ne.NINT(DBLE(puop(j))/2.0d0))
     *          doperators(opcounter)=-doperators(opcounter)
  20    continue
  10  continue
c
      if (.not.dkhscfflg) then
        idum2=xopcounter
        do 11 j=1,ucounter
          do 21 l=1,idum2
            if (xoporder(l)+uoporder(j).gt.xorder) goto 11
            if (lasttrans) then
              if (xevenodd(l)*eouops(j).eq.-1) goto 21
            endif
            xopcounter=xopcounter+1
            if (xopcounter.gt.maxoperators) then
              write (stdout,1005)
1005          format (/2X,'WARNING1: Too many xoperators (xopcounter >',
     *                ' maxoperators)!',/11X,'Increase maxoperators ',
     *                '(e.g., by one order of magnitude)!',/2X,'STOP.',
     *                /)
              CALL Abend
            endif
            xoperleng(xopcounter)=xoperleng(l)+uopsleng(j)
            if (xoperleng(xopcounter).gt.maxlength) then
              write (stdout,1006)
1006          format (/2X,'WARNING2:  xoperleng > maxlength in SR',
     *                ' "operators_U".',/2X,'STOP.',/2X)
              CALL Abend
            endif
#if defined(_MOLCAS_) || defined(MOLPRO)
          call get_dkoperators(l,xopstring1,xoperators)
          xopstring=xopstring1(1:xoperleng(l))//uops(j)(1:uopsleng(j))
          call put_dkoperators(xopcounter,xopstring,xoperators)
#else
            xoperators(xopcounter)(1:xoperleng(xopcounter))
     *          =xoperators(l)(1:xoperleng(l))//uops(j)(1:uopsleng(j))
#endif
            xoporder(xopcounter)=xoporder(l)+uoporder(j)
            xordercounter(xoporder(xopcounter))=
     *        xordercounter(xoporder(xopcounter))+1
            xevenodd(xopcounter)=xevenodd(l)*eouops(j)
            xdoperators(xopcounter)=xdoperators(l)*duops(j)
* determine sign (because this is U_dagger !)
            if (INT(DBLE(puop(j))/2.0d0).ne.NINT(DBLE(puop(j))/2.0d0))
     *          xdoperators(xopcounter)=-xdoperators(xopcounter)
  21      continue
  11    continue
      endif
c
      if (dbgflg.ge.1 .and. i.le.9) write (dbgunit,1011) i,i
1011  format (/2X,'Calculation of  U',I1,' * (operators) * U',I1,
     *        '^t has been successful.')
      if (dbgflg.ge.1 .and. i.le.9 .and. .not.dkhscfflg)
     *                                          write (dbgunit,1012) i,i
1012  format (2X,'Calculation of  U',I1,' * (xoperators) * U',I1,
     *        '^t has been successful.')
      if (dbgflg.ge.1 .and. i.ge.10) write (dbgunit,1013) i,i
1013  format (/2X,'Calculation of  U',I2,' * (operators) * U',I2,
     *        '^t has been successful.')
      if (dbgflg.ge.1 .and. i.ge.10 .and. .not.dkhscfflg)
     *                                          write (dbgunit,1014) i,i
1014  format (2X,'Calculation of  U',I2,' * (operators) * U',I2,
     *        '^t has been successful.')
c
      idum1=0
      idum2=0
      do 40 j=0,maxorder
        idum1=idum1+ordercounter(j)
        idum2=idum2+xordercounter(j)
  40  continue
      if (idum1.ne.opcounter) then
        write (stdout,1021) opcounter
1021    format (/2X,'WARNING: Number of operators "opcounter" = ',I7,
     *          ' deviates from sum over each order "ordercounter(j)".',
     *          //2X,'STOP in subroutine "operators_U.f".',/)
        CALL Abend
      endif
      if (idum2.ne.xopcounter) then
        write (stdout,1022) xopcounter
1022    format (/2X,'WARNING: Number of xoperators "xopcounter" = ',I7,
     *         ' deviates from sum over each order "xordercounter(j)".',
     *          //2X,'STOP in subroutine "operators_U.f".',/)
        CALL Abend
      endif
      if (dkhscfflg) then
        call sort_op1 (dkhorder,opcounter,operleng,oporder,
     &                 evenodd,doperators,operators)
        if (dbgflg.ge.1) write (dbgunit,1066)
1066    format (/2X,'Sorting of terms of Hamiltonian (operators) ',
     *          'in ascending order in V(X) succesful.')
      else
        call sort_op1 (dkhorder,opcounter,operleng,oporder(1,1),
     &                 evenodd,doperators,operators)
        call sort_op2 (xorder,xopcounter,xoperleng,xoporder,
     &                 xevenodd,xdoperators,xoperators)
        if (dbgflg.ge.1) write (dbgunit,1067)
1067    format (/2X,'Sorting of terms of Hamiltonian (operators) ',
     *          'in ascending order in V successful.')
        if (dbgflg.ge.1) write (dbgunit,1068)
1068    format (2X,'Sorting of terms of property (xoperators) in',
     *          ' ascending order in V successful.')
      endif
c
      if (dbgflg.ge.2) then
        if (i.le.9) then
          write (dbgunit,1026) i+1,i,i
1026      format (/2X,'Terms of Hamiltonian H',I1,' = [U',I1,' * ',
     *            '(operators) * U',I1,'^t]:',/2X,52('-'))
        endif
        if (i.ge.10) then
          write (dbgunit,1027) i+1,i,i
1027      format (/2X,'Terms of Hamiltonian H',I2,' = [U',I2,' * ',
     *            '(operators) * U',I2,'^t]:',/2X,55('-'))
        endif
        call output3 (dbgunit,opcounter,operleng,oporder,evenodd,
     *                doperators,operators)
      endif
c
      if (.not.dkhscfflg .and. dbgflg.ge.2) then
        if (i.le.9) then
          write (dbgunit,1028) i+1,i,i
1028      format (/2X,'Terms of property X',I1,' = [U',I1,' * ',
     *            '(xoperators) * U',I1,'^t]:',/2X,50('-'))
        endif
        if (i.ge.10) then
          write (dbgunit,1029) i+1,i,i
1029      format (/2X,'Terms of property X',I2,' = [U',I2,' * ',
     *            '(xoperators) * U',I2,'^t]:',/2X,53('-'))
        endif
        call output3b (dbgunit,xopcounter,xoperleng,xoporder,xevenodd,
     *                 xdoperators,xoperators)
      endif
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2007, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PGet0(ijkl,PSO,nPSO,iFnc,MemPSO,Mem2,nMem2,nQuad,PMax,iSD4)
!***********************************************************************
!                                                                      *
! Object: to act as a shell towards the manipulations of generating or *
!         accessing the 2nd order density matrix.                      *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January '92.                                             *
!                                                                      *
!             Modified for RI Feb. 2007                                *
!***********************************************************************

use setup, only: nSOs
use pso_stuff, only: Bin, Case_2C, Case_3C, CASPT2_On, CMOPT2, D0, DS, DSVar, DVar, G_Toc, Gamma_MRCISD, Gamma_On, iOffAO, lBin, &
                     lPSO, lSA, LuGamma, LuGamma_PT2, nBasT, nDens, nFro, nGamma, nNP, nOcc, nV_k, nZ_p_k, ReadBPT2, SO2CI, U_K, &
                     V_K, WRK1, WRK2, Z_P_K
use iSD_data, only: iSO2Sh, nSD
use Sizes_of_Seward, only: S
use RICD_Info, only: Cholesky, Do_RI
use Symmetry_Info, only: nIrrep
use EtWas, only: CoulFac, ExFac, nAsh, nCRED, nScr1, nScr2
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ijkl, nPSO, iFnc(4), MemPSO, nMem2, nQuad, iSD4(0:nSD,4)
real(kind=wp), intent(out) :: PSO(ijkl,nPSO), Mem2(nMem2), PMax
integer(kind=iwp) :: iAO(4), iAOst(4), iBas, iCmp(4), ipC, ipiPam, ipMAP, ipPAM, ipS1, ipS2, iShell_A, iShell_B, iShell_C, &
                     iShell_D, jBas, kBas, kOp(4), lBas, n1, n2, n3, n4, nSA

!                                                                      *
!***********************************************************************
!                                                                      *
iCmp(:) = iSD4(2,:)
iAO(:) = iSD4(7,:)
iAOst(:) = iSD4(8,:)
iBas = iSD4(19,1)
jBas = iSD4(19,2)
kBas = iSD4(19,3)
lBas = iSD4(19,4)
n1 = iFnc(1)*iBas
n2 = iFnc(2)*jBas
n3 = iFnc(3)*kBas
n4 = iFnc(4)*lBas
iShell_A = iSD4(20,1)
iShell_B = iSD4(20,2)
iShell_C = iSD4(20,3)
iShell_D = iSD4(20,4)
!                                                                      *
!***********************************************************************
!                                                                      *
PMax = One
nSA = 1
if (CASPT2_On) then
  if (Cholesky .or. Do_RI) then
    if (ReadBPT2) call DoReadBPT2(iShell_C,iShell_D)
  else
    call CASPT2_BTAMP(LuGAMMA_PT2,iShell_A,iShell_B,iShell_C,iShell_D,n1,n2,n3,n4,iOffAO,nBasT,nOcc(1),CMOPT2(1+nBasT*nFro(1)), &
                      WRK1,WRK2,G_Toc)
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! RASSCF wavefunction

if (lPSO) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *

  ipPam = 1
  ipiPam = ipPam+MemPSO
  ipMap = ipiPam+n1+n2+n3+n4
  ipC = ipMap+4*S%nDim
  ipS1 = ipC+nCred
  ipS2 = ipS1+2*nScr1

  if (lSA) then
    nSA = 4
    if (size(D0,2) > 4) nSA = 5
  end if

  if (nIrrep == 1) then
    kOp(1) = 0
    kOp(2) = 0
    kOp(3) = 0
    kOp(4) = 0
    if (Case_2C) then
      if (Do_RI) then
        call PGet1_RI2(PSO,ijkl,nPSO,iCmp,iAO,iAOst,jBas,lBas,kOp,ExFac,CoulFac,PMax,V_K,U_K,nV_K,Z_p_k,nSA)
        !write(u6,*) 'PGet1_RI2 ===========' ! yma
      else
        ! Not modified yet
        call Abend()
      end if
    else if (Case_3C) then
      if (Do_RI) then
        call PGet1_RI3(PSO,ijkl,nPSO,iCmp,iAO,iAOst,jBas,kBas,lBas,kOp,D0,DVar,nDens,ExFac,CoulFac,PMax,V_K,U_K,nV_K,Z_p_k,nnP(0), &
                       nSA,nAsh)
      else
        ! Not modified yet
        call Abend()
      end if
    else
      call PGet3(PSO,ijkl,nPSO,iCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp,Mem2(ipPam),n1,n2,n3,n4,Mem2(ipiPam),Mem2(ipMap), &
                 S%nDim,Mem2(ipC),nCred,Mem2(ipS1),nScr1,Mem2(ipS2),nScr2,PMax)
      !yma write(u6,*) 'PGet3 ==========='
    end if
  else
    if (Case_2C) then
      if (Do_RI) then
        call PGet2_RI2(iCmp,jBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,ExFac,CoulFac,PMax,V_K,nV_K,Z_p_k,nSA,nZ_p_k)
        !yma write(u6,*) 'PGet2_RI2 ==========='
      else
        ! Not modified yet
        call Abend()
      end if
    else if (Case_3C) then
      if (Do_RI) then
        call PGet2_RI3(iCmp,jBas,kBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,D0,nDens,ExFac,CoulFac,PMax,V_K,nV_K,Z_p_k,nSA,nAsh)
      else
        ! Not modified yet
        call Abend()
      end if
    else
      PSO(:,:) = Zero  !yma for testing

      !write(u6,*) 'Print out in integral_util/pget0 before'
      !call RecPrt('DSO in PGet0',' ',D0,ndens,5)  ! ====== yma ======

      call PGet4(iCmp,iBas,jBas,kBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,Mem2(ipPam),n1,n2,n3,n4,Mem2(ipiPam),Mem2(ipMap),S%nDim, &
                 Mem2(ipC),nCred,Mem2(ipS1),nScr1,Mem2(ipS2),nScr2,PMax)
      !yma write(u6,*) 'PGet4 ============'
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! SCF and DFT wavefunction

  if (Gamma_On .and. (nGamma > nMem2)) then
    write(u6,*) 'pGet0: nGamma < nMem2'
    call abend()
  end if

  if (nIrrep == 1) then
    kOp(1) = 0
    kOp(2) = 0
    kOp(3) = 0
    kOp(4) = 0
    if (Gamma_On) then
      if (Do_RI) call Abend()
      if (gamma_mrcisd) then
        call Read_Bin_Columbus(iShell_A,iShell_B,iShell_C,iShell_D,G_Toc,nQuad,Mem2,nGamma,LuGamma,Bin,lBin)
      else
        call Read_Bin(iShell_A,iShell_B,iShell_C,iShell_D,G_Toc,nQuad,Mem2,nGamma,LuGamma,Bin,lBin)
      end if
      call PGet1_Aces(PSO,ijkl,nPSO,iCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp,D0,DVar,DS,DSVar,nDens,Mem2,nGamma,SO2cI,nSOs,iSO2Sh, &
                      PMax)
    else
      if (Case_2C) then
        if (Do_RI) then
          call PGet1_RI2(PSO,ijkl,nPSO,iCmp,iAO,iAOst,jBas,lBas,kOp,ExFac,CoulFac,PMax,V_K,U_K,nV_K,Z_p_k,nSA)
        else
          call PGet1_CD2(PSO,ijkl,nPSO,iCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp,ExFac,CoulFac,PMax,V_K,U_K,nV_K,Z_p_k,nnP(0))
        end if
      else if (Case_3C) then
        if (Do_RI) then
          call PGet1_RI3(PSO,ijkl,nPSO,iCmp,iAO,iAOst,jBas,kBas,lBas,kOp,D0,DVar,nDens,ExFac,CoulFac,PMax,V_K,U_K,nV_K,Z_p_k, &
                         nnP(0),nSA,nAsh)
        else
          call PGet1_CD3(PSO,ijkl,nPSO,iCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp,D0,DVar,nDens,ExFac,CoulFac,PMax,V_K,U_K,nV_K)
        end if
      else
        call PGet1(PSO,ijkl,nPSO,iCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp,D0,DS,nDens,ExFac,CoulFac,PMax)
      end if
    end if
  else
    if (Gamma_On) then
      if (Do_RI) call Abend()
      if (gamma_mrcisd) then
        call Read_Bin_Columbus(iShell_A,iShell_B,iShell_C,iShell_D,G_Toc,nQuad,Mem2,nGamma,LuGamma,Bin,lBin)
      else
        call Read_Bin(iShell_A,iShell_B,iShell_C,iShell_D,G_Toc,nQuad,Mem2,nGamma,LuGamma,Bin,lBin)
      end if
      call PGet2_Aces(iCmp,iBas,jBas,kBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,D0,DVar,DS,DSVar,nDens,Mem2,nGamma,SO2cI,nSOs,iSO2Sh,PMax)
    else
      if (Case_2C) then
        if (Do_RI) then

          call PGet2_RI2(iCmp,jBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,ExFac,CoulFac,PMax,V_K,nV_K,Z_p_k,nSA,nZ_p_k)
        else
          call PGet2_CD2(iCmp,iBas,jBas,kBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,CoulFac,PMax,V_K,nV_K)
        end if
      else if (Case_3C) then
        if (Do_RI) then
          call PGet2_RI3(iCmp,jBas,kBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,D0,nDens,ExFac,CoulFac,PMax,V_K,nV_K,Z_p_k,nSA,nAsh)
        else
          call PGet2_CD3(iCmp,iBas,jBas,kBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,D0,nDens,CoulFac,PMax,V_K,nV_K)
        end if

      else
        call PGet2(iCmp,iBas,jBas,kBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,D0,DS,nDens,ExFac,CoulFac,PMax)
      end if
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('PSO in PGet0',' ',PSO,ijkl,nPSO)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine PGet0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

************************************************************************
* This file from SLATEC:                                               *
*   http://www.netlib.org/slatec                                       *
*                                                                      *
* To the best of our knowledge, the routines in SLATEC are public      *
* domain or freely distributable and modifiable.                       *
************************************************************************

c  ******************************
c  ** Random number generation **
c  ******************************
      REAL*8 function rand_cvb(r)
      implicit REAL*8 (a-h,o-z)
c***BEGIN PROLOGUE  RAND
c***DATE WRITTEN   770401   (YYMMDD)
c***REVISION DATE  820801   (YYMMDD)
c***CATEGORY NO.  L6A21
c***KEYWORDS  RANDOM NUMBER,SPECIAL FUNCTION,UNIFORM
c***AUTHOR  FULLERTON, W., (LANL)
c***PURPOSE  Generates a uniformly distributed random number.
c***DESCRIPTION
c
c      This pseudo-random number generator is portable among a wide
c variety of computers.  RAND(R) undoubtedly is not as good as many
c readily available installation dependent versions, and so this
c routine is not recommended for widespread usage.  Its redeeming
c feature is that the exact same random numbers (to within final round-
c off error) can be generated from machine to machine.  Thus, programs
c that make use of random numbers can be easily transported to and
c checked in a new environment.
c      The random numbers are generated by the linear congruential
c method described, e.g., by Knuth in Seminumerical Methods (p.9),
c Addison-Wesley, 1969.  Given the I-th number of a pseudo-random
c sequence, the I+1 -st number is generated from
c             X(I+1) = (A*X(I) + C) MOD M,
c where here M = 2**22 = 4194304, C = 1731 and several suitable values
c of the multiplier A are discussed below.  Both the multiplier A and
c random number X are represented in REAL*8 as two 11-bit
c words.  The constants are chosen so that the period is the maximum
c possible, 4194304.
c      In order that the same numbers be generated from machine to
c machine, it is necessary that 23-bit integers be reducible modulo
c 2**11 exactly, that 23-bit integers be added exactly, and that 11-bit
c integers be multiplied exactly.  Furthermore, if the restart option
c is used (where R is between 0 and 1), then the product R*2**22 =
c R*4194304 must be correct to the nearest integer.
c      The first four random numbers should be .0004127026,
c .6750836372, .1614754200, and .9086198807.  The tenth random number
c is .5527787209, and the hundredth is .3600893021 .  The thousandth
c number should be .2176990509 .
c      In order to generate several effectively independent sequences
c with the same generator, it is necessary to know the random number
c for several widely spaced calls.  The I-th random number times 2**22,
c where I=K*P/8 and P is the period of the sequence (P = 2**22), is
c still of the form L*P/8.  In particular we find the I-th random
c number multiplied by 2**22 is given by
c I   =  0  1*P/8  2*P/8  3*P/8  4*P/8  5*P/8  6*P/8  7*P/8  8*P/8
c RAND=  0  5*P/8  2*P/8  7*P/8  4*P/8  1*P/8  6*P/8  3*P/8  0
c Thus the 4*P/8 = 2097152 random number is 2097152/2**22.
c      Several multipliers have been subjected to the spectral test
c (see Knuth, p. 82).  Four suitable multipliers roughly in order of
c goodness according to the spectral test are
c    3146757 = 1536*2048 + 1029 = 2**21 + 2**20 + 2**10 + 5
c    2098181 = 1024*2048 + 1029 = 2**21 + 2**10 + 5
c    3146245 = 1536*2048 +  517 = 2**21 + 2**20 + 2**9 + 5
c    2776669 = 1355*2048 + 1629 = 5**9 + 7**7 + 1
c
c      In the table below LOG10(NU(I)) gives roughly the number of
c random decimal digits in the random numbers considered I at a time.
c C is the primary measure of goodness.  In both cases bigger is better.
c
c                   LOG10 NU(I)              C(I)
c       A       I=2  I=3  I=4  I=5    I=2  I=3  I=4  I=5
c
c    3146757    3.3  2.0  1.6  1.3    3.1  1.3  4.6  2.6
c    2098181    3.3  2.0  1.6  1.2    3.2  1.3  4.6  1.7
c    3146245    3.3  2.2  1.5  1.1    3.2  4.2  1.1  0.4
c    2776669    3.3  2.1  1.6  1.3    2.5  2.0  1.9  2.6
c   Best
c    Possible   3.3  2.3  1.7  1.4    3.6  5.9  9.7  14.9
c
c             Input Argument --
c R      If R=0., the next random number of the sequence is generated.
c        If R .LT. 0., the last generated number will be returned for
c          possible use in a restart procedure.
c        If R .GT. 0., the sequence of random numbers will start with
c          the seed R mod 1.  This seed is also returned as the value of
c          RAND provided the arithmetic is done exactly.
c
c             Output Value --
c RAND   a pseudo-random number between 0. and 1.
c***REFERENCES  (NONE)
c***ROUTINES CALLED  (NONE)
c***END PROLOGUE  RAND
      save ia1,ia0,ia1ma0,ic,ix1,ix0
      data ia1, ia0, ia1ma0 /1536, 1029, 507/
      data ic /1731/
      data ix1, ix0 /0, 0/
c***FIRST EXECUTABLE STATEMENT  RAND
      if (r.lt.0.d0) go to 10
      if (r.gt.0.d0) go to 20
c
c           A*X = 2**22*IA1*IX1 + 2**11*(IA1*IX1 + (IA1-IA0)*(IX0-IX1)
c                   + IA0*IX0) + IA0*IX0
c
      iy0 = ia0*ix0
      iy1 = ia1*ix1 + ia1ma0*(ix0-ix1) + iy0
      iy0 = iy0 + ic
      ix0 = mod (iy0, 2048)
      iy1 = iy1 + (iy0-ix0)/2048
      ix1 = mod (iy1, 2048)
c
 10   rand = dble(ix1*2048 + ix0)
      rand_cvb = rand / 4194304.d0
      return
c
 20   ix1 = int( dmod(r,1.d0)*4194304.d0 + 0.5d0 )
      ix0 = mod (ix1, 2048)
      ix1 = (ix1-ix0)/2048
      go to 10
c
      end
c  *************
c  ** Various **
c  *************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MyCoor(isAuto,
     &      Ox,Oy,Oz, Rx,Ry,Rz, iGx,iGy,iGz, iMagic,iCustOrig)
************************************************************************
* Adapted from SAGIT to work with OpenMolcas (October 2020)            *
************************************************************************
*                                                                      *
*   Read Coordinates and calculate a cub for grid                      *
*   isAuto=1 - real job, else only print                               *
*   Origin(3) fix cub in space                                         *
*   Rx,Ry,Rz - size of cub                                             *
*   iGx,iGy,iGz - net                                                  *
*   iMagic = magic guess for net                                       *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "grid.fh"
#include "real.fh"
c      Dimension iOper(8)
c      Dimension RotVec(3)
      Character*(LENIN) Byte4
c      Character*4 tt
      Character*128 Line
cVV: the constant is used in all GV packages
#define R529 0.52917721067d0
*----------------------------------------------------------------------*
*     Prologue                                                         *
*----------------------------------------------------------------------*
       if (isLUSCUS.eq.1) then
         x529=R529
       else
         x529=One
       endif
       lw2=1
      Call get_iScalar('nSym',nSym)
      Call Get_nAtoms_All(nAtoms)
      Call Get_LblCnt_All(AtomLbl)
      Call GetMem('Coor','ALLO','REAL',ipCoor,3*nAtoms)
      Call Get_Coord_All(Work(ipCoor),nAtoms)
      nCenter=nAtoms
* Check : are any strange names?
      NoOrig=0
      Do iAt=0,nCenter-1
       write(line,'(a)') AtomLbl(lw2+iAt)
       if(index( line,'Ori').ne.0) NoOrig=NoOrig+1
      enddo
*
      IF (ISLUSCUS .EQ. 1 .AND. ISBINARY .EQ. 3) THEN
        WRITE(LINE,'(2X,I8)') NCENTER-NOORIG
        CALL PRINTLINE(LID, LINE, 10,0)
        CALL PRINTLINE(LID, LINE, 0,0)
        if(isUHF.eq.1) then
        CALL PRINTLINE(LID_ab, LINE, 10,0)
        CALL PRINTLINE(LID_ab, LINE, 0,0)
        endif
        DO IAT=0,NCENTER-1
          WRITE(LINE,'(A)') ATOMLBL(LW2+IAT)
          IF(INDEX( LINE,'ORI').EQ.0) THEN
          Byte4=ATOMLBL(LW2+IAT)(1:2)
          if(index ('0123456789',Byte4(2:2)).ne.0) Byte4(2:2)=' '
            WRITE(LINE,'(1X,A2,2X,3F15.8)') Byte4,
     &      WORK(IPCOOR+3*IAT)*x529,WORK(IPCOOR+3*IAT+1)*x529,
     &      WORK(IPCOOR+3*IAT+2)*x529
            CALL PRINTLINE(LID, LINE, 50,0)
            if(isUHF.eq.1) then
            CALL PRINTLINE(LID_ab, LINE, 50,0)
            endif
          ENDIF
        ENDDO
      END IF

      Write(Line,'(A,I8)') 'Natom= ',nCenter-NoOrig
      If (isBinary.eq.1) Then
        Write(LuVal) Trim(Line)
        If (isUHF.eq.1) Write(LuVal_ab) Line(1:15)
      Else
        Write(LuVal,'(A)') Trim(Line)
        If (isUHF.eq.1) Write(LuVal_ab,'(A)') Line(1:15)
      End If
      Do iAt=0,nCenter-1
        If (Index(Line,'Ori').eq.0) Then
          Write(line,'(A,2X,3F15.8)') AtomLbl(lw2+iAt),
     &       Work(ipCoor+3*iAt  ),
     &       Work(ipCoor+3*iAt+1),
     &       Work(ipCoor+3*iAt+2)
        Else
          Write(Line,'(A)') AtomLbl(lw2+iAt)
        End If
        If (isBinary.eq.1) Then
          Write(LuVal) Trim(Line)
          If(isUHF.eq.1) Write(LuVal_ab) Trim(Line)
        Else
          Write(LuVal,'(A)') Trim(Line)
          If(isUHF.eq.1) Write(LuVal_ab,'(A)') Trim(Line)
        End If
      End Do

      if(iCustOrig.eq.1) goto 500

      if(isAuto.eq.1) Then
*----------------------------------------------------------------------*
*     Find Cub parameters                                              *
*                 Ox->RxMin, Rx->RxMax
*----------------------------------------------------------------------*
      Ox=9999.9D0
      Oy=9999.9D0
      Oz=9999.9D0
      Rx=-9999.9D0
      Ry=-9999.9D0
      Rz=-9999.9D0

      Do iAt=0,nCenter-1
       rrx=Work(ipCoor+3*iAt)
       rry=Work(ipCoor+3*iAt+1)
       rrz=Work(ipCoor+3*iAt+2)
       if(rrx.lt.Ox) Ox=rrx
       if(rrx.gt.Rx) Rx=rrx
       if(rry.lt.Oy) Oy=rry
       if(rry.gt.Ry) Ry=rry
       if(rrz.lt.Oz) Oz=rrz
       if(rrz.gt.Rz) Rz=rrz
      End Do
       Rx=Rx-Ox
       Ry=Ry-Oy
       Rz=Rz-Oz
*
* and now, expand this cub to place all atoms inside
*
      Ox=dble(int(Ox-TheGap))
      Oy=dble(int(Oy-TheGap))
      Oz=dble(int(Oz-TheGap))
      Rx=dble(int(Rx+Two*TheGap))
      Ry=dble(int(Ry+Two*TheGap))
      Rz=dble(int(Rz+Two*TheGap))
* finish of iAuto.
      endif
*----------------------------------------------------------------------*
*     Calculate corrected coords
*----------------------------------------------------------------------*
*
* make a stupid Patch: Cerius2 works well only with even nets!
*
       Rx=dble(int(Rx)/2*2)
       Ry=dble(int(Ry)/2*2)
       Rz=dble(int(Rz)/2*2)

       if(iMagic.gt.0) then
           iGx=int(abs(Rx))*iMagic
           iGy=int(abs(Ry))*iMagic
           iGz=int(abs(Rz))*iMagic
        endif
*
* make a stupid Patch: Cerius2 works well only with even nets!
*
      iGx=(iGx+1)/2*2
      iGy=(iGy+1)/2*2
      iGz=(iGz+1)/2*2
      mynCenter=nCenter

*----------------------------------------------------------------------*
*     Print coordinates of the system                                  *
*----------------------------------------------------------------------*
c      call bXML('Coord')
c      call iXML('nCoord',nCenter)
c      Do iAt=0,nCenter-1
c        Call cXML('Atom',AtomLbl(lw2+iAt))
c        call daXML('Atom coord',Work(ipCoor+3*iAt),3)
c      End Do
c      call eXML('Coord')

500   continue
      Write(6,*)
      Write(6,'(6X,A)')'Cartesian coordinates:'
      Write(6,'(6X,A)')'-----------------------------------------'
      Write(6,'(6X,A)')'No.  Label     X         Y         Z     '
      Write(6,'(6X,A)')'-----------------------------------------'
      Do iAt=0,nCenter-1
        Write(6,'(4X,I4,3X,A,2X,3F10.5)')
     &  iAt+1,AtomLbl(lw2+iAt),
     &  Work(ipCoor+3*iAt),Work(ipCoor+3*iAt+1),Work(ipCoor+3*iAt+2)
      End Do
      Write(6,'(6X,A)')'-----------------------------------------'
      Write(6,'(6X,A,3F12.6)')'Grid Origin      = ',Ox,Oy,Oz
      Write(6,'(6X,A,3F12.6)')'Grid Axis Length = ',Rx,Ry,Rz
      Write(6,'(6X,A)')'-----------------------------------------'
      Write(6,*)
      Write(6,*)

*
*----------------------------------------------------------------------*
*     Normal exit                                                      *
*----------------------------------------------------------------------*
      Return
      End
*----------------------------------------------------------------------*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine TRPGen(nDim,nAtom,Coor,mTR,CofM,TRVec)
      use Slapaf_Info, only: Degen, Smmtrc
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
      Real*8 Coor(3,nAtom), TRVec(3*nAtom*6)
      Logical CofM
      Logical, Save:: g12K=.True.
      Real*8, Allocatable:: TR(:), Scrt(:), G(:), EVal(:), EVec(:),
     &                      U(:)
*
      Call mma_allocate(TR,18*nAtom,Label='TR')
*
*-----Compute the symmetric translations and rotations
*
*     B    (nTR x nDim)
*      tr
*
      Call TRMake(TR,Coor,nAtom,nTR,Degen,nDim,CofM)
*
      TRVec(1:nTR*nDim) = TR(1:nTR*nDim)
*
      Call mma_allocate(Scrt,(3*nAtom)*nTR,Label='Scrt')
      Call mma_allocate(G,nTR**2,Label='G')
      Call mma_allocate(EVal,nTR*(nTR+1)/2,Label='EVal')
      Call mma_allocate(EVec,nTR**2,Label='EVec')
*
*-----Eliminate redundancy and produce an orthogonal representation.
*
*        -1/2
*     K g        (nTR x mTR)
*
      Call mma_allocate(U,nDim,Label='U')
      U(:) = One
      i=0
      Do iAtom = 1, nAtom
      Do ixyz = 1, 3
         If (Smmtrc(ixyz,iAtom)) Then
            i = i + 1
            Call DScal_(nTR,Sqrt(Degen(ixyz,iAtom)),
     &                  TRVec((i-1)*nTR+1),1)
         End If
      End Do
      End Do
*
      Thr_ElRed=1.0D-12
      Call ElRed(TRVec,nTR,nDim,G,EVal,EVec,mTR,U,Scrt,g12K,Thr_ElRed)
*
      If (mTR.gt.0) Then
         TRVec(1:3*nAtom*nTR) = Zero
         Call DGEMM_('T','N',
     &               nDim,mTR,nTR,
     &               1.0d0,TR,nTR,
     &                     EVec,nTR,
     &               0.0d0,TRVec,nDim)
      End If
*
      Call mma_deallocate(U)
      Call mma_deallocate(EVec)
      Call mma_deallocate(EVal)
      Call mma_deallocate(G)
      Call mma_deallocate(Scrt)
      Call mma_deallocate(TR)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function CDET(MA,N,A)
!=================================================
! MA is the MAximal dimension
! N is the dimension N<MA
! A is the Complex matrix
!=================================================

use Constants, only: Zero, cZero, cOne
use Definitions, only: wp, iwp

implicit none
complex(kind=wp) :: CDET
integer(kind=iwp), intent(in) :: MA, N
complex(kind=wp), intent(inout) :: A(MA,MA)
integer(kind=iwp) :: I, J, K, K1, L
real(kind=wp) :: P, Q
complex(kind=wp) :: CP, CQ

I = 0
CDET = cZero

do K=1,N
  P = Zero

  do J=K,N
    Q = abs(A(J,K))
    if (Q > P) then
      P = Q
      I = J
    end if
  end do

  CP = cOne/A(I,K)

  if (I /= K) then
    CDET = -CDET
    do L=K,N
      CQ = A(I,L)
      A(I,L) = A(K,L)
      A(K,L) = CQ
    end do
  end if

  CDET = CDET*A(K,K)

  if (K < N) then
    K1 = K+1
    do I=K1,N
      CQ = A(I,K)*CP
      A(I,K1:N) = A(I,K1:N)-CQ*A(K,K1:N)
    end do
  end if

end do ! K

return

end function CDET

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine xbacktrace
CSVC: this routine tries to print a backtrace
      implicit none
C     use backtrace intrinsic (introduced since gfortran 4.8)
#include "compiler_features.h"
#if   defined(__GNUC__) && (GCC_VERSION >= 40800)
      call backtrace
C     use tracebackqq intrinsic for ifort
#elif defined(__INTEL_COMPILER)
      call tracebackqq
#endif
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Valera Veryazov                                  *
!***********************************************************************

subroutine SysCondMsg(Text1,N1,Text2,N2)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: Text1, Text2
integer(kind=iwp), intent(in) :: N1, N2
character(len=64) :: s

call SysPuts('Condition: ',Text1,' ')
write(s,'(i16,a,i16)') N1,Text2,N2
call SysPuts('Actual   : ',s,' ')
call SysPutsEnd()
call Abend()

return

end subroutine SysCondMsg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_Vx (V)
c
c        check V
c
        implicit none
#include "chcc1.fh"
         real*8 V(1:nv,1:no,1:nv,1:no)
c
        integer be,u,i,a,bad
        real*8 s
c
        bad=0
        do a=1,nv
        do i=1,no
        do u=1,no
        do be=1,nv
c
           s=2.0d0*Jc(be,i,u,a)-Kc(i,be,u,a)
           s=Kc(i,be,u,a)
c
          if (abs(V(be,u,a,i)-s).gt.1.0d-10) then
            bad=bad+1
            V(be,u,a,i)=s
          end if
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck Vx :',bad
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!               Francesco Aquilante                                    *
!***********************************************************************

subroutine Cho_PrtSt(Vec,lVec,Stat)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: lVec
real(kind=wp), intent(in) :: Vec(lVec), Stat(7)
real(kind=wp), external :: dDot_

write(u6,'(/,1X,A,I15)') 'No. of elements: ',lVec
write(u6,'(1X,A,ES15.6)') 'Frobenius norm : ',sqrt(dDot_(lVec,Vec,1,Vec,1))
write(u6,'(1X,A,ES15.6)') 'Minimum value  : ',Stat(3)
write(u6,'(1X,A,ES15.6)') 'Maximum value  : ',Stat(4)
write(u6,'(1X,A,ES15.6)') 'Mean value     : ',Stat(1)
write(u6,'(1X,A,ES15.6)') 'Mean abs. value: ',Stat(2)
write(u6,'(1X,A,ES15.6)') 'Max. abs. value: ',Stat(5)
write(u6,'(1X,A,ES15.6)') 'Biased variance: ',Stat(6)
write(u6,'(1X,A,ES15.6,A)') 'Standard dev.  : ',Stat(7),' (unbiased variance)'

end subroutine Cho_PrtSt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  Polink
*
*> @brief
*>   Add the field from the QM-region onto the solvent. Include the field from the
*>   polarizabilities in the solvent onto the QM-region.
*>   (The effect of the static field is taken care of in hel.f)
*> @author A. Ohrn
*>
*> @details
*> To begin with we obtain the charge distribution of the QM-region
*> as it exists due to the pressent density matrix (recall that it
*> is the changes in the density matrix that causes the QM-region to
*> be polarized). The field from these new multipoles are added on to
*> solvent. We also include the reaction field from the QM-region.
*> Then, with the new field from the QM-region included, we compute
*> the field from the polarizabiolities in the solvent onto the QM-region,
*> which is done just like in hel.f.
*>
*> @param[out]    Energy  The energy of the electrostatic interaction
*> @param[in,out] iCall   An integer that tells if this is the first call in the iteration. Necessary for the copy of the one-particle Hamiltonian
*> @param[in]     iAtom2  Number of particles in the solvent, times number of polarizabilities per solvent molecule
*> @param[in]     iCi     Number of centers in QM-molecule
*> @param[in]     iFil    Pointer to the static field from the solvent
*> @param[out]    VpolMat The matrix due to polarization
*> @param[in,out] fil     The field from the induced dipoles in the solvent
*> @param[in]     polfac  A factor for the computation of the image
*> @param[out]    poli    The solvent polarized field on QM-region
*> @param[in]     iCstart Number to keep track of solvent molecules
*> @param[in]     iTri    ``iOrb(1)*(iOrb(1)+1)/2``
************************************************************************
      Subroutine Polink(Energy,iCall,iAtom2,iCi,iFil,VpolMat,fil,polfac
     &,poli,iCstart,iTri,iQ_Atoms,qTot,ChaNuc,xyzMyQ,xyzMyI,xyzMyP
     &,RoMat,xyzQuQ,CT)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qm1.fh"
#include "WrkSpc.fh"

      Dimension Fil(npart*npol,3),Qm(MxQCen),Dm(MxQCen,3),QQm(MxQCen,6)
     &,Poli(MxQCen,10),Gunnar(10),Eil(MxPut*MxPol,3),xyzMyC(3),CofC(3)
     &,VpolMat(MxOt),ChaNuc(MxAt),xyzMyQ(3),xyzMyI(3),xyzMyP(3)
     &,RoMat(MxOT)
      Dimension xyzQuQ(6),qQ(6),qD(6),qK(6),CT(3)
      Dimension iFil(MxQCen,10)

*----------------------------------------------------------------------*
* Begin with some zeros.                                               *
*----------------------------------------------------------------------*
      iCnum=iCStart/Ncent
      Do 2, i=1,iCi
        Qm(i)=0.0d0
        If(i.le.iQ_Atoms) Qm(i)=-ChaNuc(i) !Here is nuclear contribution
        Do 3, j=1,3                        !added to atoms.
          Dm(i,j)=0.0d0
          QQm(i,j)=0.0d0
          QQm(i,j+3)=0.0d0
3       Continue
2     Continue
      Do 6644, i=1,MxPut*MxPol
        Do 6645, j=1,3
          Eil(i,j)=0.0d0
6645    Continue
6644  Continue
*----------------------------------------------------------------------*
* Below we compute how the MME of the QM-molecule changes with the new *
* density matrix Romat. What we actually do is a HF-SCF procedure with *
* a MME-expanded density. A change in the density has the effect that  *
* the set of multipoles in the MME are slightly perturbed.             *
*----------------------------------------------------------------------*
      Do 4, i=1,iTri
        Do 41, j=1,iCi
          Qm(j)=Cha(i,j)*Romat(i)+Qm(j)
          Dm(j,1)=Dm(j,1)+DipMy(i,1,j)*Romat(i)
          Dm(j,2)=Dm(j,2)+DipMy(i,2,j)*Romat(i)
          Dm(j,3)=Dm(j,3)+DipMy(i,3,j)*Romat(i)
          QQm(j,1)=QQm(j,1)+Quad(i,1,j)*Romat(i)
          QQm(j,3)=QQm(j,3)+Quad(i,3,j)*Romat(i)
          QQm(j,6)=QQm(j,6)+Quad(i,6,j)*Romat(i)
          QQm(j,2)=QQm(j,2)+Quad(i,2,j)*Romat(i)
          QQm(j,4)=QQm(j,4)+Quad(i,4,j)*Romat(i)
          QQm(j,5)=QQm(j,5)+Quad(i,5,j)*Romat(i)
41      Continue
4     Continue
      Do 775, kk=1,3
        xyzMyQ(kk)=0
        xyzMyC(kk)=0
        CofC(kk)=0
775   Continue
      Do 776, kk=1,6
        xyzQuQ(kk)=0
        qQ(kk)=0
        qD(kk)=0
        qK(kk)=0
776   Continue
      !Observe one trixy thing about xyzmyq: the electric multipoles
      !we use above are actually of opposite sign, so how can xyzmyq be
      !the dipole in the qm-region unless we change sign (which we does
      !not)? The reason is that the density matrix elements will also
      !have opposite sign, which in turn has not physical meaning.
      !We also compute the quadupole moment - a mezzy formula.
      Do 866,i=1,iCi
        xyzMyQ(1)=xyzMyQ(1)+Dm(i,1)+Qm(i)*outxyz(i,1)
        xyzMyQ(2)=xyzMyQ(2)+Dm(i,2)+Qm(i)*outxyz(i,2)
        xyzMyQ(3)=xyzMyQ(3)+Dm(i,3)+Qm(i)*outxyz(i,3)
        qQ(1)=qQ(1)+Qm(i)*(outxyz(i,1)-CT(1))*(outxyz(i,1)-CT(1))
        qQ(2)=qQ(2)+Qm(i)*(outxyz(i,1)-CT(1))*(outxyz(i,2)-CT(2))
        qQ(3)=qQ(3)+Qm(i)*(outxyz(i,1)-CT(1))*(outxyz(i,3)-CT(3))
        qQ(4)=qQ(4)+Qm(i)*(outxyz(i,2)-CT(2))*(outxyz(i,2)-CT(2))
        qQ(5)=qQ(5)+Qm(i)*(outxyz(i,2)-CT(2))*(outxyz(i,3)-CT(3))
        qQ(6)=qQ(6)+Qm(i)*(outxyz(i,3)-CT(3))*(outxyz(i,3)-CT(3))
        qD(1)=qD(1)+2*Dm(i,1)*(outxyz(i,1)-CT(1))
        qD(2)=qD(2)+Dm(i,1)*(outxyz(i,2)-CT(2))
     &             +Dm(i,2)*(outxyz(i,1)-CT(1))
        qD(3)=qD(3)+Dm(i,1)*(outxyz(i,3)-CT(3))
     &             +Dm(i,3)*(outxyz(i,1)-CT(1))
        qD(4)=qD(4)+2*Dm(i,2)*(outxyz(i,2)-CT(2))
        qD(5)=qD(5)+Dm(i,2)*(outxyz(i,3)-CT(3))
     &             +Dm(i,3)*(outxyz(i,2)-CT(2))
        qD(6)=qD(6)+2*Dm(i,3)*(outxyz(i,3)-CT(3))
        qK(1)=qK(1)+QQm(i,1)
        qK(2)=qK(2)+QQm(i,2)
        qK(3)=qK(3)+QQm(i,4)
        qK(4)=qK(4)+QQm(i,3)
        qK(5)=qK(5)+QQm(i,5)
        qK(6)=qK(6)+QQm(i,6)
866   Continue
      Trace1=qQ(1)+qQ(4)+qQ(6)
      Trace2=qD(1)+qD(4)+qD(6)
      Trace1=Trace1/3
      Trace2=Trace2/3
      xyzQuQ(1)=1.5*(qQ(1)+qD(1)-Trace1-Trace2)+qK(1)
      xyzQuQ(2)=1.5*(qQ(2)+qD(2))+qK(2)
      xyzQuQ(3)=1.5*(qQ(3)+qD(3))+qK(3)
      xyzQuQ(4)=1.5*(qQ(4)+qD(4)-Trace1-Trace2)+qK(4)
      xyzQuQ(5)=1.5*(qQ(5)+qD(5))+qK(5)
      xyzQuQ(6)=1.5*(qQ(6)+qD(6)-Trace1-Trace2)+qK(6)
      If(ChargedQM) then  !If charged system, then do...
        qs=0
        Do 721, i=1,iCi
          CofC(1)=CofC(1)+abs(qm(i))*outxyz(i,1) !Center of charge
          CofC(2)=CofC(2)+abs(qm(i))*outxyz(i,2)
          CofC(3)=CofC(3)+abs(qm(i))*outxyz(i,3)
          qs=qs+abs(qm(i))
721     Continue
        CofC(1)=CofC(1)/qs
        CofC(2)=CofC(2)/qs
        CofC(3)=CofC(3)/qs
        Gx=CofC(1)-outxyz(1,1)+Cordst(1,1) !Where C-of-C is globally
        Gy=CofC(2)-outxyz(1,2)+Cordst(1,2)
        Gz=CofC(3)-outxyz(1,3)+Cordst(1,3)
        xyzMyC(1)=xyzMyC(1)+qtot*Gx !Dipole
        xyzMyC(2)=xyzMyC(2)+qtot*Gy
        xyzMyC(3)=xyzMyC(3)+qtot*Gz
      Endif
      Do 9977, i=1,3
          !Change sign on both the dipoles, which in effect gives
          !no sign change, all in order with Boettcher, p.145.
        Energy=Energy+Polfac*xyzMyQ(i)*(xyzMyQ(i)+xyzMyi(i))
9977  Continue
*----------------------------------------------------------------------*
* The multipoles of the QM-region, modified due to the polarization,   *
* now interacts with each polarizability in the solvent.               *
*----------------------------------------------------------------------*
      Do 5, i=1,iCi
        Do 6, j=1+(nPol*iCnum),iAtom2
          Do 7, k=1,3
            Eil(j,k)=Eil(j,k)+Work(iFil(i,1)-1+j+(k-1)*nPart*nPol)*Qm(i)
            Do 8, l=1,3
              Eil(j,k)=Eil(j,k)+Work(iFil(i,l+1)-1+j+(k-1)*nPart*nPol)
     &                *Dm(i,l)
8           Continue
         Eil(j,k)=Eil(j,k)+Work(iFil(i,5)-1+j+(k-1)*nPart*nPol)*QQm(i,1)
         Eil(j,k)=Eil(j,k)+Work(iFil(i,7)-1+j+(k-1)*nPart*nPol)*QQm(i,3)
        Eil(j,k)=Eil(j,k)+Work(iFil(i,10)-1+j+(k-1)*nPart*nPol)*QQm(i,6)
       Eil(j,k)=Eil(j,k)+Work(iFil(i,6)-1+j+(k-1)*nPart*nPol)*QQm(i,2)*2
       Eil(j,k)=Eil(j,k)+Work(iFil(i,8)-1+j+(k-1)*nPart*nPol)*QQm(i,4)*2
       Eil(j,k)=Eil(j,k)+Work(iFil(i,9)-1+j+(k-1)*nPart*nPol)*QQm(i,5)*2
7         Continue
6       Continue
5     Continue
C...THIS IS LEBENSGEFAHRLICH (original comment says it all!)
*----------------------------------------------------------------------*
* We add up the field from the QM-region to the field on all the       *
* solvent polarizabilities.                                            *
*----------------------------------------------------------------------*
      Do 10, i=1+(nPol*iCNum),iAtom2
        Iu=i-((i-1)/nPol)*nPol
        Do 11, j=1,3  !Here we add the QM-molecule image to the solvent
                      !polarizabilities. Good old classical dielectric
                      !cavity model!
          Fil(i,j)=Fil(i,j)+PolFac*xyzMyQ(j)+Eil(i,j)
          Energy=Energy+Fil(i,j)*Eil(i,j)*Pol(iu) !How much the induced
                            !dipoles in solvent interacts with the field
                            !from the QM-region.
11      Continue
10    Continue
*----------------------------------------------------------------------*
* Now we wish to make the induced field from the solvent interact with *
* the QM-region. The static field has already interacted in helstate.f.*
* The reaction field of the QM-region in the dielectric cavity is      *
* also included, excluding the quadrupoles and higher; they are        *
* small anyway, so this is not a major restriction.                    *
*----------------------------------------------------------------------*
      Do 1801, i=1,10
        Gunnar(i)=0
1801  Continue
      Gunnar(2)=PolFac*(xyzMyP(1)+xyzMyQ(1)+xyzMyI(1)+xyzMyC(1))
      Gunnar(3)=PolFac*(xyzMyP(2)+xyzMyQ(2)+xyzMyI(2)+xyzMyC(2))
      Gunnar(4)=PolFac*(xyzMyP(3)+xyzMyQ(3)+xyzMyI(3)+xyzMyC(3))
      Do 1304, l=1,iCi
        Gunnar(1)=Gunnar(2)*outxyz(l,1)+Gunnar(3)*outxyz(l,2)
     &           +Gunnar(4)*outxyz(l,3) !Potential from the apparent
        Do 1305, i=1,10          !surface charge, see Boettcher (4.22).
          Poli(l,i)=Gunnar(i)
          Do 1306, j=1+(nPol*iCnum),iAtom2
            Iu=j-((j-1)/nPol)*nPol
            Do 1307, k=1,3            !Compute the generalized field
                              !from induced dipoles in solvent on the
                              !QM-region cites.
              Poli(l,i)=Poli(l,i)-Fil(j,k)*Pol(iu)
     &                 *Work(iFil(l,i)-1+j+(k-1)*nPart*nPol)
1307        Continue
1306      Continue
1305    Continue
1304  Continue
      Do 201, i=1,iTri
        VpolMat(i)=0
201   Continue
      Do 300, i=1,iTri
        Do 301, j=1,iCi
          Vpolmat(i)=Vpolmat(i)+Poli(j,1)*Cha(i,j)
          Vpolmat(i)=Vpolmat(i)+Poli(j,2)*DipMy(i,1,j)
          Vpolmat(i)=Vpolmat(i)+Poli(j,3)*DipMy(i,2,j)
          Vpolmat(i)=Vpolmat(i)+Poli(j,4)*DipMy(i,3,j)
          Vpolmat(i)=Vpolmat(i)+Poli(j,5)*Quad(i,1,j)
          Vpolmat(i)=Vpolmat(i)+Poli(j,7)*Quad(i,3,j)
          Vpolmat(i)=Vpolmat(i)+Poli(j,10)*Quad(i,6,j)
          Vpolmat(i)=Vpolmat(i)+Poli(j,6)*Quad(i,2,j)*2
          Vpolmat(i)=Vpolmat(i)+Poli(j,8)*Quad(i,4,j)*2
          Vpolmat(i)=Vpolmat(i)+Poli(j,9)*Quad(i,5,j)*2
301     Continue
300   Continue
      Do 400, i=1,iQ_Atoms  !This is how the nuclei interact with the
                      !induced field (in equil2 exists a corresponding
                      !term for the interaction with the static field).
                      !This way interaction between a charged molecule
                      !and the induced/permanent potential is included.
        Energy=Energy-2*Poli(i,1)*ChaNuc(i)
400   Continue

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iCall)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1993,1999,2023, Roland Lindh                      *
!               1995, Martin Schuetz                                   *
!***********************************************************************

!#define _DEBUGPRINT_
!#define _DEBUGBREIT_
subroutine Eval_ijkl(iS,jS,kS,lS,TInt,nTInt)
!***********************************************************************
!                                                                      *
!  Object: driver for two-electron integrals, parallel region          *
!          contains memory partitioning and loops over uncontracted    *
!          functions...                                                *
!                                                                      *
!  Input:                                                              *
!          iiS,jjS,kkS,llS     : shell indices                         *
!          TInt                : Computed Integrals                    *
!          nTInt               : dimension of TInt                     *
!          Integ_Proc          : subroutine for post processing        *
!                                                                      *
!                                                                      *
!     Author: Roland Lindh / Martin Schuetz,                           *
!             Dept. of Theoretical Chemistry, University of Lund,      *
!             SWEDEN.                                                  *
!             Modified for k2 loop. August '91                         *
!             Modified for direct SCF. January '93                     *
!             Modified to minimize overhead for calculations with      *
!             small basis sets and large molecules. Sept. '93          *
!             parallel region split off in drvtwo.f, April '95         *
!             Total rehack May '99                                     *
!             Total rehack Aug '23                                     *
!***********************************************************************

use Index_Functions, only: iTri
use setup, only: nSOs
use k2_arrays, only: Create_BraKet, Destroy_Braket, iSOSym, Sew_Scr
use iSD_data, only: iSD, nSD
use Breit, only: nComp
use Gateway_Info, only: CutInt
use Symmetry_Info, only: nIrrep
use Int_Options, only: DoFock, DoIntegrals
use Integral_interfaces, only: Int_PostProcess, twoel_kernel
use RI_glob, only: jBas_, lBas_
#ifdef _DEBUGBREIT_
use Breit, only: nOrdOp
use UnixInfo, only: SuperName
#endif
use Constants, only: Zero
use stdalloc, only: mma_allocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iS, jS, kS, lS, nTInt
real(kind=wp), intent(inout) :: TInt(nTInt)
integer(kind=iwp) :: iAng(4), iBasAO, iBasi, iBasn, iBsInc, ipDum, ipMem1, ipMem2, iSD4(0:nSD,4), jBasAO, jBasj, jBasn, jBsInc, &
                     kBasAO, kBask, kBasn, kBsInc, lBasAO, lBasl, lBasn, lBsInc, Mem1, Mem2, MemMax, MemPrm, n, nAO, nIJKL, nSO
real(kind=wp) :: Coor(3,4), Tmax
logical(kind=iwp) :: NoInts
real(kind=wp), pointer :: SOInt(:), AOInt(:)
procedure(twoel_kernel) :: TwoEl_NoSym, TwoEl_Sym
procedure(twoel_kernel), pointer :: Do_TwoEl
integer(kind=iwp), parameter :: SCF = 1
integer(kind=iwp), external :: iDAMax_, MemSO2
!                                                                      *
!***********************************************************************
!                                                                      *
TInt(:) = Zero
#ifdef _DEBUGBREIT_
! use the Breit option computing 1/r^3 integralas but convert to
! conventional 1/r integrals
if ((.not. DoFock) .and. (SuperName /= 'gateway') .and. (nIrrep == 1)) call Set_Breit(1)
#endif
if (nIrrep == 1) then
  Do_TwoEl => TwoEl_NoSym
else
  Do_TwoEl => TwoEl_Sym
end if
!if (.not. associated(Int_PostProcess)) call Abend()
!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. allocated(iSOSym)) then
  call WarningMessage(2,'Eval_Ints_: Integral environment is not set up!')
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
NoInts = .true.
Tmax = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! If memory not allocated already at this point allocate!

if (.not. allocated(Sew_Scr)) then
  !write(u6,*) 'Eval_ints: Allocate memory'
  call mma_MaxDBLE(MemMax)
  if (MemMax > 8000) MemMax = MemMax-8000
  call mma_allocate(Sew_Scr,MemMax,Label='Sew_Scr')
else
  !write(u6,*) 'Eval_ints: Memory already allocated'
  MemMax = size(Sew_Scr)
end if
!write(u6,*) 'Eval_ints: MemMax=',MemMax
ipMem1 = 1

!write(u6,*) ' -->',iS,jS,kS,lS,'<--'
!                                                                      *
!***********************************************************************
!                                                                      *
call Gen_iSD4(iS,jS,kS,lS,iSD,nSD,iSD4)
!                                                                      *
!***********************************************************************
!                                                                      *
! No SO block in direct construction of the Fock matrix.
if (nIrrep > 1) then
  nSO = MemSO2(nSD,iSD4)
else
  nSO = 0
end if
if ((nIrrep > 1) .and. (nSO == 0)) return
nAO = product(iSD4(2,:))

call Coor_Setup(iSD4,nSD,Coor)
call Int_Setup(Coor)
!                                                                      *
!***********************************************************************
!                                                                      *
! partition memory for K2(ij)/K2(kl) temp spaces zeta,eta,kappa,P,Q

call Create_BraKet(iSD4(5,1)*iSD4(5,2),iSD4(5,3)*iSD4(5,4))
!                                                                      *
!***********************************************************************
!                                                                      *
! Pick up pointers to desymmetrized 1st order density
! matrices. Observe that the desymmetrized 1st order
! density matrices follows the contraction index.

if (DoFock) call Dens_Infos(SCF)
!                                                                      *
!***********************************************************************
!                                                                      *
!#ifdef _DEBUGPRINT_
!write(u6,*) ' *** Centers ***'
!write(u6,'(3F7.3,6X,3F7.3)') ((Coor(i,j),i=1,3),j=1,2)
!write(u6,'(3F7.3,6X,3F7.3)') ((Coor(i,j),i=1,3),j=3,4)
!#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute memory request for the primitives, i.e.
! how much memory is needed up to the transfer equation.
iAng(:) = iSD4(1,:)
call MemRys(iAng,MemPrm)
!                                                                      *
!***********************************************************************
!                                                                      *
! Decide on the partitioning of the shells based on the
! available memory and the requested memory.
call PSOAO0(nSO,MemPrm,MemMax,ipMem1,ipMem2,Mem1,Mem2,DoFock,nSD,iSD4)
SOInt(1:Mem1) => Sew_Scr(ipMem1:ipMem1+Mem1-1)
AOInt(1:Mem2) => Sew_Scr(ipMem2:ipMem2+Mem2-1)
!                                                                      *
!***********************************************************************
!                                                                      *

iBsInc = iSD4(4,1)
jBsInc = iSD4(4,2)
kBsInc = iSD4(4,3)
lBsInc = iSD4(4,4)

iBasi = iSD4(3,1)
jBasj = iSD4(3,2)
kBask = iSD4(3,3)
lBasl = iSD4(3,4)

jbas_ = jBasj
lbas_ = lBasl

!                                                                      *
!***********************************************************************
!                                                                      *
! These loops will partition the contraction loops if there is not
! enough memory to store the whole SO/AO-block simultaneously. The
! memory partitioning is determined by PSOAO0.

do iBasAO=1,iBasi,iBsInc
  iBasn = min(iBsInc,iBasi-iBasAO+1)
  iSD4(8,1) = iBasAO-1
  iSD4(19,1) = iBasn

  do jBasAO=1,jBasj,jBsInc
    jBasn = min(jBsInc,jBasj-jBasAO+1)
    iSD4(8,2) = jBasAO-1
    iSD4(19,2) = jBasn

    ! Move appropiate portions of the desymmetrized 1st
    ! order density matrix.

    if (DoFock) call Picky(nSD,iSD4,1,2)

    do kBasAO=1,kBask,kBsInc
      kBasn = min(kBsInc,kBask-kBasAO+1)
      iSD4(8,3) = kBasAO-1
      iSD4(19,3) = kBasn

      if (DoFock) then
        call Picky(nSD,iSD4,1,3)
        call Picky(nSD,iSD4,2,3)
      end if

      do lBasAO=1,lBasl,lBsInc
        lBasn = min(lBsInc,lBasl-lBasAO+1)
        iSD4(8,4) = lBasAO-1
        iSD4(19,4) = lBasn

        if (DoFock) then
          call Picky(nSD,iSD4,3,4)
          call Picky(nSD,iSD4,1,4)
          call Picky(nSD,iSD4,2,4)
        end if

        nijkl = iBasn*jBasn*kBasn*lBasn*nComp ! *nComp is a fix for BP integrals

        !                                                              *
        !***************************************************************
        !                                                              *
        ! Compute SO/AO-integrals

        call Do_TwoEl(Coor,NoInts,SOInt,nijkl,nSO,AOInt,Mem2,iSD4)

        nijkl = iBasn*jBasn*kBasn*lBasn

#       ifdef _DEBUGBREIT_
        if (nOrdOp /= 0) then
          if (nIrrep == 1) then
            call ReSort_Int(AOInt,nijkl,6,nAO)
          else
            call ReSort_Int(SOInt,nijkl,6,nSO)
          end if
        end if
#       endif
#       ifdef _DEBUGPRINT_
        if (nIrrep == 1) then
          call RecPrt('AOInt',' ',AOInt,nijkl,nAO)
        else
          call RecPrt('SOInt',' ',SOInt,nijkl,nSO)
        end if
#       endif
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Process SO/AO-integrals

        if (DoIntegrals .and. (.not. NoInts)) then
          ! Get max AO/SO integrals
          if (nIrrep == 1) then
            n = nijkl*nAO
            Tmax = max(Tmax,abs(AOInt(iDAMax_(n,AOInt,1))))
          else
            n = nijkl*nSO
            Tmax = max(Tmax,abs(SOInt(iDAMax_(n,SOInt,1))))
          end if
          if (Tmax > CutInt) then
            call Int_PostProcess(nijkl,AOInt,SOInt,nSO,iSOSym,nSOs,TInt,nTInt,nIrrep,nSD,iSD4)
          else
            Tmax = Zero
          end if
        end if

      end do
    end do
  end do
end do
nullify(SOInt,AOInt)
call Destroy_BraKet()
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGBREIT_
call Set_Breit(0)
# endif

contains

subroutine Dens_Infos(nMethod)

  use Dens_stuff, only: ipDDij, ipDDik, ipDDil, ipDDjk, ipDDjl, ipDDkl, ipDij, ipDik, ipDil, ipDjk, ipDjl, ipDkl, mDCRij, mDCRik, &
                        mDCRil, mDCRjk, mDCRjl, mDCRkl
  use k2_arrays, only: ipDijS

  integer(kind=iwp), intent(in) :: nMethod
  integer(kind=iwp) :: Dum1, Dum2, Dum3, ijS, ikS, ilS, ipTmp, iS, jkS, jlS, jS, klS, kS, lS
  integer(kind=iwp), parameter :: Nr_of_D = 1

  iS = iSD4(11,1)
  jS = iSD4(11,2)
  kS = iSD4(11,3)
  lS = iSD4(11,4)

  ijS = iTri(iS,jS)
  klS = iTri(kS,lS)
  ikS = iTri(iS,kS)
  ilS = iTri(iS,lS)
  jkS = iTri(jS,kS)
  jlS = iTri(jS,lS)
  ipTmp = ipDijs
  call Dens_Info(ijS,ipDij,ipDum,mDCRij,ipDDij,ipTmp,Nr_of_D,nMethod,Dum1,Dum2,Dum3)
  call Dens_Info(klS,ipDkl,ipDum,mDCRkl,ipDDkl,ipTmp,Nr_of_D,nMethod,Dum1,Dum2,Dum3)
  call Dens_Info(ikS,ipDik,ipDum,mDCRik,ipDDik,ipTmp,Nr_of_D,nMethod,Dum1,Dum2,Dum3)
  call Dens_Info(ilS,ipDil,ipDum,mDCRil,ipDDil,ipTmp,Nr_of_D,nMethod,Dum1,Dum2,Dum3)
  call Dens_Info(jkS,ipDjk,ipDum,mDCRjk,ipDDjk,ipTmp,Nr_of_D,nMethod,Dum1,Dum2,Dum3)
  call Dens_Info(jlS,ipDjl,ipDum,mDCRjl,ipDDjl,ipTmp,Nr_of_D,nMethod,Dum1,Dum2,Dum3)

end subroutine Dens_Infos

#ifdef _DEBUGBREIT_
subroutine ReSort_Int(IntRaw,nijkl,nComp,nA)

# ifdef _DEBUGPRINT_
  use Definitions, only: u6
# endif

  integer(kind=iwp), intent(in) :: nijkl, nComp, nA
  real(kind=wp), target, intent(inout) :: IntRaw(nijkl*nComp*nA)
  real(kind=wp), pointer :: IntIn(:,:,:), IntOut(:,:)
  integer(kind=iwp) :: i_ijkl, iA

  IntIn(1:nijkl,1:nComp,1:nA) => IntRaw(:)
  IntOut(1:nijkl,1:nA) => IntRaw(1:nijkl*nA)
# ifdef _DEBUGPRINT_
  write(u6,*) 'nijkl,nComp,nA=',nijkl,nComp,nA
  call RecPrt('IntRaw',' ',IntRaw,nijkl,nComp*nA)
# endif

  IntOut(:,:) = IntIn(:,:)+IntIn(:,4,:)+IntIn(:,6,:)

  nullify(IntIn,IntOut)

end subroutine ReSort_Int
#endif

end subroutine Eval_ijkl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrSSTab(SSTAB)

use Cntrl, only: MORSBITS
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: SSTAB(*)
integer(kind=iwp) :: I, IMRS, IMRSEND, IMRSSTA, ISBS, ISBSEND, ISBSSTA, ISPART, ISSTP, ISYM, KMRSSBS, KSBSANN, KSBSCRE, KSBSMRS, &
                     KSSTANN, KSSTCRE, KSSTP, LPOS, MS2, NASPRT, NMORS, NPOP, NRSBST, NSBS, NSBSTOT, NSSTP

write(u6,*)
write(u6,*) '============================================='
write(u6,*) ' Substring table printout.'
write(u6,*) ' (A) Header and TOC:'
write(u6,'(a,i16)') '            Table size:',SSTAB(1)
write(u6,'(a,i16)') '       Table type code:',SSTAB(2)
write(u6,'(a,i16)') ' Orbital Table        :',SSTAB(3)
write(u6,'(a,i16)') ' Nr of symmetry labels:',SSTAB(4)
write(u6,'(a,i16)') ' Nr of active subpart :',SSTAB(5)
write(u6,'(a,i16)') ' Nr of bits/morsel    :',SSTAB(6)
write(u6,'(a,i16)') ' Nr of Substring Types:',SSTAB(7)
write(u6,'(a,i16)') ' Nr of Substrings     :',SSTAB(8)
write(u6,'(a,i16)') ' Substr Type Ann Table:',SSTAB(9)
write(u6,'(a,i16)') ' Substr Type Cre Table:',SSTAB(10)
write(u6,'(a,i16)') ' Substr/Morsel Table  :',SSTAB(11)
write(u6,'(a,i16)') ' Morsel/Substr Table  :',SSTAB(12)
write(u6,'(a,i16)') ' Substring Annih Table:',SSTAB(13)
write(u6,'(a,i16)') ' Substring Creat Table:',SSTAB(14)
write(u6,*) '---------------------------------------------'
write(u6,*) ' (B) Substring Types:'
write(u6,*) ' NSBS  = Nr of substrings of each type.'
write(u6,*) ' NPOP  = Electron population of each type.'
write(u6,*) ' ISYM  = Combined symmetry of each type.'
write(u6,*) ' MS2   = Twice spin proj of each type.'
write(u6,*) ' ISPART= Subpartition of each type.'
write(u6,*) '---------------------------------------------'
write(u6,*) '           NSBS   NPOP   ISYM    MS2  ISBPRT'
NSSTP = SSTAB(7)
NSBSTOT = SSTAB(8)
KSSTP = 15
do ISSTP=1,NSSTP
  NSBS = SSTAB(KSSTP+0+5*(ISSTP-1))
  NPOP = SSTAB(KSSTP+1+5*(ISSTP-1))
  ISYM = SSTAB(KSSTP+2+5*(ISSTP-1))
  MS2 = SSTAB(KSSTP+3+5*(ISSTP-1))
  ISPART = SSTAB(KSSTP+4+5*(ISSTP-1))
  write(u6,'(1x,6I7)') ISSTP,NSBS,NPOP,ISYM,MS2,ISPART
end do
write(u6,*) '---------------------------------------------'
write(u6,*) ' (C1) Morsels to Substrings:'
NASPRT = SSTAB(5)
KSBSMRS = SSTAB(11)
KMRSSBS = SSTAB(12)
NMORS = 2**MORSBITS
do IMRSSTA=0,NMORS-1,15
  IMRSEND = min(NMORS-1,IMRSSTA+14)
  write(u6,*)
  write(u6,'(1x,a,3x,15I5)') 'MRS:',(IMRS,IMRS=IMRSSTA,IMRSEND)
  do ISPART=1,NASPRT
    write(u6,'(1x,a,i3,15I5)') 'SBS:',ISPART,(SSTAB(KMRSSBS+2*(IMRS+NMORS*(ISPART-1))),IMRS=IMRSSTA,IMRSEND)
  end do
end do

NRSBST = SSTAB(8)
write(u6,*) ' (C2) Substrings to Morsels:'
do ISBSSTA=1,NRSBST,15
  ISBSEND = min(NRSBST,ISBSSTA+14)
  write(u6,*)
  write(u6,'(1x,a,15I5)') 'SBS:',(ISBS,ISBS=ISBSSTA,ISBSEND)
  write(u6,'(1x,a,15I5)') 'MRS:',(SSTAB(KSBSMRS+2*(ISBS-1)),ISBS=ISBSSTA,ISBSEND)
end do
write(u6,*) '---------------------------------------------'
write(u6,*) ' (D1) Substring Type Annihilation Table:'
KSSTANN = SSTAB(9)
KSSTCRE = SSTAB(10)
do ISSTP=1,NSSTP
  LPOS = KSSTANN+MORSBITS*(ISSTP-1)
  write(u6,'(1x,I8,5X,8I8)') ISSTP,(SSTAB(LPOS-1+I),I=1,MORSBITS)
end do
write(u6,*) ' (D2) Substring Type Creation Table:'
do ISSTP=1,NSSTP
  LPOS = KSSTCRE+MORSBITS*(ISSTP-1)
  write(u6,'(1x,I8,5X,8I8)') ISSTP,(SSTAB(LPOS-1+I),I=1,MORSBITS)
end do
write(u6,*) '---------------------------------------------'
write(u6,*) ' (E1) Substring Annihilation Table:'
KSBSANN = SSTAB(13)
KSBSCRE = SSTAB(14)
do ISBS=1,NSBSTOT
  LPOS = KSBSANN+MORSBITS*(ISBS-1)
  write(u6,'(1x,I8,5X,8I8)') ISBS,(SSTAB(LPOS-1+I),I=1,MORSBITS)
end do
write(u6,*) '---------------------------------------------'
write(u6,*) ' (E2) Substring Creation Table:'
do ISBS=1,NSBSTOT
  LPOS = KSBSCRE+MORSBITS*(ISBS-1)
  write(u6,'(1x,I8,5X,8I8)') ISBS,(SSTAB(LPOS-1+I),I=1,MORSBITS)
end do
write(u6,*) '============================================='

end subroutine PrSSTab

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Luis Manuel Frutos                               *
*               2015, Alessio Valentini                                *
************************************************************************

C This module calculates an external force applied to the system.

      Subroutine extf(ireturn)

#include "real.fh"
#include "constants.fh"
      integer aN, atomNumberx3, nsAtom, efatom1, efatom2, ext
      real*8  gradient(1000), ExtGrad(1000), modgrad(1000)
      real*8  coord(1000), posvect12(3)
      real*8  efmodul, efmodulAU, norm
      real*8  nnewt
      parameter (nnewt = CONV_AU_TO_KJ_/CONST_BOHR_RADIUS_IN_SI_*1D12)
      logical linear
      CHARACTER*180  Key, Line
      CHARACTER*180  Get_Ln
      EXTERNAL       Get_Ln

C get initial values

C      call Mem_Info('EXTF')

      call Get_iScalar('Unique atoms',nsAtom)

      atomNumberx3 = 3 * nsAtom

      call get_darray('GRAD',gradient,atomNumberx3)
      call Get_dArray('Unique Coordinates',coord,atomNumberx3)
* read molcas input

      LuSpool=isfreeunit(21)
      call SpoolInp(LuSpool)

      REWIND(LuSpool)
      call RdNLst(LuSpool,'extf')
  999 CONTINUE
      Key = Get_Ln(LuSpool)
      Line = Key
      call UpCase(Line)
      IF (Line(1:4).EQ.'LINE') GOTO 1100
      IF (Line(1:3).EQ.'END')  GOTO 9000

*>>>>>>>>>>>>>>>>>>>> FORCe *<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1100 CONTINUE
      linear=.true.
      write(6,*) 'Linear forces between two atoms selected'
      Line = Get_Ln(LuSpool)
      call Get_I1(1, efatom1)
      Line = Get_Ln(LuSpool)
      call Get_I1(1, efatom2)
      Line = Get_Ln(LuSpool)
      call Get_F1(1, efmodul)
      Line = Get_Ln(LuSpool)
      call Get_I1(1, ext)
      write(6,*) 'atom1:', efatom1
      write(6,*) 'atom2:', efatom2
      write(6,*) 'Force:', efmodul, ' nN'
      if (ext.eq.1) then
         write(6,*) 'Compression force'
      else
         write(6,*) 'Extension force'
      end if
      GOTO 999
*>>>>>>>>>>>>>>>>>>>> END <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 9000 CONTINUE
C>>>>>>>>>>>>>>>>>>>>> LINEAR CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<
      IF (linear) then
      aN=1
      write(6,*) 'Gradient Found:'
      do i=1, atomNumberx3, 3
      write(6,*) aN, gradient(i), gradient(i+1), gradient(i+2)
      aN=aN+1
      end do
      write(6,*) '  '

C from nN to atomic units
      efmodulAU=efmodul/nnewt

C initialize the external gradient vector
      do i=1, atomNumberx3
       ExtGrad(i)=Zero
      end do

C posvect is the position vector from atom2 respect atom1
      posvect12(1)=coord((efatom2-1)*3+1)-coord((efatom1-1)*3+1)
      posvect12(2)=coord((efatom2-1)*3+2)-coord((efatom1-1)*3+2)
      posvect12(3)=coord((efatom2-1)*3+3)-coord((efatom1-1)*3+3)

C creating "norm": the norm of the posvect12 vector
      norm=sqrt((posvect12(1))**2+(posvect12(2))**2+(posvect12(3))**2)
      posvect12(1)=posvect12(1)/norm
      posvect12(2)=posvect12(2)/norm
      posvect12(3)=posvect12(3)/norm

      ExtGrad((efatom1-1)*3+1)=posvect12(1)*efmodulAU
      ExtGrad((efatom1-1)*3+2)=posvect12(2)*efmodulAU
      ExtGrad((efatom1-1)*3+3)=posvect12(3)*efmodulAU
      ExtGrad((efatom2-1)*3+1)=-posvect12(1)*efmodulAU
      ExtGrad((efatom2-1)*3+2)=-posvect12(2)*efmodulAU
      ExtGrad((efatom2-1)*3+3)=-posvect12(3)*efmodulAU
C Extension gradient vector created.

C Checking if it is a compression or extension force. In the former case
C the direction of the ExtGrad vector will be changed
      if (ext.eq.1) then
        ExtGrad((efatom1-1)*3+1)=-ExtGrad((efatom1-1)*3+1)
        ExtGrad((efatom1-1)*3+2)=-ExtGrad((efatom1-1)*3+2)
        ExtGrad((efatom1-1)*3+3)=-ExtGrad((efatom1-1)*3+3)
        ExtGrad((efatom2-1)*3+1)=-ExtGrad((efatom2-1)*3+1)
        ExtGrad((efatom2-1)*3+2)=-ExtGrad((efatom2-1)*3+2)
        ExtGrad((efatom2-1)*3+3)=-ExtGrad((efatom2-1)*3+3)
      end if

      write(6,*) '  '
      aN=1
      write(6,*) 'External Force'
      do i=1, atomNumberx3, 3
      write(6,*) aN, -ExtGrad(i), -ExtGrad(i+1), -ExtGrad(i+2)
      aN=aN+1
      end do
      write(6,*) '  '


C Creating the final modified external gradient vector (modgrad)
      do i=1,atomNumberx3
       modgrad(i)=gradient(i)+ExtGrad(i)
      end do

      end if
C>>>>>>>>>>>>>>>>>>>>>>> end of linear code <<<<<<<<<<<

      write(6,*) '  '
      aN=1
      write(6,*) 'Gradient after force application:'
      do i=1, atomNumberx3, 3
      write(6,*) aN, modgrad(i), modgrad(i+1), modgrad(i+2)
      aN=aN+1
      end do
      write(6,*) '  '

      call put_darray('GRAD',modgrad,atomNumberx3)


      CLOSE(LuSpool)


      ireturn=0
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995,2001,2008, Roland Lindh                           *
!***********************************************************************

subroutine PCMHss( &
#                 define _CALLING_
#                 include "hss_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of nuclear attraction     *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, May 1995                                *
!                                                                      *
!             Modified to PCM gradients September 2001, Lund, by       *
!             R. Lindh.                                                *
!             Modified to PCM Hessian February 2008, Lund by           *
!             R. Lindh.                                                *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use PCM_arrays, only: PCM_SQ, PCMTess
use Center_Info, only: dc
use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
#include "hss_interface.fh"
integer(kind=iwp) :: iAlpha, iAnga(4), iAtom, iBeta, iCar, iDAO, iDCRT(0:7), iIrrep, idx(3,4), ipA, ipAOff, ipB, ipBOff, ipDAO, &
                     iPrint, iRout, iStb(0:7), iTs, iuvwx(4), iZeta, jAtom, jCar, JndGrd(0:2,0:3,0:7), &
                     JndHss(0:3,0:2,0:3,0:2,0:7), lDCRT, LmbdT, mOp(4), mRys, nArray, nDAO, nDCRT, nDiff, nFinal, nip, nla, nlb, &
                     nOOp, nStb
real(kind=wp) :: Coori(3,4), CoorAC(3,2), C(3), EInv, Eta, Fact, TC(3), q_i
logical(kind=iwp) :: IfG(0:3), JfGrd(0:2,0:3), JfHss(0:3,0:2,0:3,0:2), NoLoop, Tr(0:3)
integer(kind=iwp), external :: NrOpr
external :: Fake, TNAI1, XCff2D
#include "print.fh"
#include "rctfld.fh"

#include "macros.fh"
unused_var(rFinal)
unused_var(nHer)
unused_var(Ccoor)
unused_var(lOper)

!                                                                      *
!***********************************************************************
!                                                                      *
! We will have five terms here!
!
! 1) Sum(i) q_i V_ie^xy
! 2) Sum(ij) V_in^y Q_ij V_je^x
! 3) Sum(ij) V_ie^y Q_ij V_je^x
! Maurizio to add comments for the last two terms!

iRout = 151
iPrint = nPrint(iRout)

nla = (la+1)*(la+2)/2
nlb = (lb+1)*(lb+2)/2
nOOp = (nOrdOp+1)*(nOrdOp+2)/2

nip = 1
ipA = nip
nip = nip+nAlpha*nBeta
ipB = nip
nip = nip+nAlpha*nBeta
ipDAO = nip
nip = nip+nAlpha*nBeta*nla*nlb*nOOp
if (nip-1 > nZeta*nArr) then
  write(u6,*) 'nip-1 > nZeta*nArr'
  call ErrTra()
  call Abend()
end if
nArray = nZeta*nArr-nip+1

iAnga(1) = la
iAnga(2) = lb
iAnga(3) = nOrdOp
iAnga(4) = 0
call dcopy_(3,A,1,Coori(1,1),1)
call dcopy_(3,RB,1,Coori(1,2),1)
if (la >= lb) then
  call dcopy_(3,A,1,CoorAC(1,1),1)
else
  call dcopy_(3,RB,1,CoorAC(1,1),1)
end if
iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
mOp(1) = nOp(1)
mOp(2) = nOp(2)

ipAOff = ipA
do iBeta=1,nBeta
  call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB
do iAlpha=1,nAlpha
  call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
  ipBOff = ipBOff+1
end do

! Modify the density matrix with the prefactor

nDAO = nla*nlb
do iDAO=1,nDAO
  do iZeta=1,nZeta
    Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
    DAO(iZeta,iDAO) = Fact*DAO(iZeta,iDAO)
  end do
end do
if (iPrint >= 99) call RecPrt('DAO',' ',DAO,nZeta,nDAO)

! Generate stabilizer of C, i.e. a center of a tile.

nStb = 1
iStb(0) = 0

! Loop over the tiles

do iTs=1,nTs
  q_i = PCM_SQ(1,iTs)+PCM_SQ(2,iTs)
  NoLoop = q_i == Zero
  if (NoLoop) cycle
  ! Pick up the tile coordinates
  C(1:3) = PCMTess(1:3,iTs)

  if (iPrint >= 99) call RecPrt('C',' ',C,1,3)
  call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
  Fact = -q_i*real(nStabM,kind=wp)/real(LmbdT,kind=wp)

  Array(ipDAO:ipDAO+nZeta*nDAO-1) = Fact*pack(DAO,.true.)

  iuvwx(3) = nStb
  iuvwx(4) = nStb

  do lDCRT=0,nDCRT-1
    mOp(3) = NrOpr(iDCRT(lDCRT))
    mOp(4) = mOp(3)
    call OA(iDCRT(lDCRT),C,TC)
    call dcopy_(3,TC,1,CoorAC(1,2),1)
    call dcopy_(3,TC,1,Coori(1,3),1)
    call dcopy_(3,TC,1,Coori(1,4),1)

    ! Initialize JfGrd, JndGrd, JfHss, and JndHss.

    JfGrd(:,:) = .false.
    JndGrd(:,:,0:nSym-1) = 0
    JfHss(:,:,:,:) = .false.
    JndHss(:,:,:,:,0:nSym-1) = 0

    ! Overwrite with information in IfGrd, IndGrd, IfHss,
    ! and IndHss. This sets up the info for the first two
    ! centers! Make sure that no translational invariance
    ! is used.

    do iAtom=0,1
      do iCar=0,2
        JfGrd(iCar,iAtom) = Ifgrd(iCar,iAtom)
        do iIrrep=0,nSym-1
          JndGrd(iCar,iAtom,iIrrep) = abs(IndGrd(iCar,iAtom,iIrrep))
        end do
        do jAtom=0,1
          do jCar=0,2
            JfHss(iAtom,iCar,jAtom,jCar) = IfHss(iAtom,iCar,jAtom,jCar)
            do iIrrep=0,nSym-1
              JndHss(iAtom,iCar,jAtom,jCar,iIrrep) = abs(IndHss(iAtom,iCar,jAtom,jCar,iIrrep))
            end do
          end do
        end do
      end do
    end do

    ! Derivatives with respect to the operator is computed via
    ! the translational invariance.
    ! Note: We want no such thing!
    !
    ! The third center is calculated by translational invariance.
    ! This requires the 2nd derivatives on the other centers.
    ! Note: We want no such thing!

    Tr(:) = .false.
    IfG(:) = [.true.,.true.,.false.,.false.]
    JfGrd(:,:) = .false.

    ! Compute integrals with the Rys quadrature.

    nDiff = 2
    mRys = (la+lb+2+nDiff+nOrdOp)/2
    Eta = One
    EInv = One
    nFinal = 0
    call Rysg2(iAnga,mRys,nZeta,Array(ipA),Array(ipB),[One],[One],Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,TC,1,Coori,Coori,CoorAC, &
               Array(nip),nArray,TNAI1,Fake,XCff2D,Array(ipDAO),nDAO*nOOp,Hess,nHess,JfGrd,JndGrd,JfHss,JndHss,mOp,iuvwx,IfG, &
               nFinal,idx,.false.,.true.,Tr)

    !call RecPrt(' In PCMHss:Hess',' ',Hess,nHess,1)
  end do  ! End loop over DCRs

end do    ! End loop over centers in the external field

return

end subroutine PCMHss

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE HSHGET(KEY,KEYDIM,NCOMP,ITEM,NSIZE,ITAB,ITEMID)
      use definitions, only: iwp, u6
      IMPLICIT NONE
      INTEGER(kind=iwp), intent(in):: KEYDIM,NCOMP,NSIZE
      INTEGER(kind=iwp), intent(in):: KEY(KEYDIM),ITEM(NCOMP,*)
      INTEGER(kind=iwp), intent(in):: ITAB(NSIZE,2)
      INTEGER(kind=iwp), intent(out):: ITEMID
C These parameters determine the hash function:
      INTEGER(kind=iwp), PARAMETER :: MULT=37, NHASH=997
      INTEGER(kind=iwp) NULL, IND, I, LOOKAT
      LOGICAL(kind=iwp) FAILED_ID

      IF(NSIZE.LT.NHASH) THEN
        WRITE(u6,*)' HSHGET: Table size must be at least as'
        WRITE(u6,*)'         big as NHASH, presently =', NHASH
        CALL ABEND()
      END IF
      NULL=ITAB(NSIZE,1)
C Evaluate hash index:
      IND=MOD(KEY(1),NHASH)
      DO I=2,KEYDIM
        IND=MOD(KEY(I)+MULT*IND,NHASH)
      END DO
      IND=IND+1
C IND is a hashed index in interval 1..NHASH < NSIZE
C Find the item with this key:

      LOOKAT=IND

      Outer: DO

C Are there (more) items with that hash signature?
      IF(ITAB(LOOKAT,1)==NULL) THEN
C Here, if we have failed to find such an item.
         ITEMID=0
         RETURN
       END IF

C Try to identify an item which has the given key:
      ITEMID=ITAB(LOOKAT,2)
      FAILED_ID=.FALSE.
      DO I=1,KEYDIM
        IF (ITEM(I,ITEMID)/=KEY(I)) THEN
           FAILED_ID=.TRUE.
           EXIT
        END IF
      END DO

      IF (FAILED_ID) THEN
C Here, if we have not yet identified the item.
         LOOKAT=ITAB(LOOKAT,1)
      ELSE
C Here, if we have identified the item.
         RETURN
      END IF

      END DO Outer


      END SUBROUTINE HSHGET

      SUBROUTINE HSHPUT(KEYDIM,NCOMP,ITEM,NSIZE,ITAB,ITEMID)
      use definitions, only: iwp
      IMPLICIT NONE
      integer(kind=iwp), intent(in):: KEYDIM,NCOMP,NSIZE,ITEMID
      integer(kind=iwp), intent(inout):: ITAB(NSIZE,2)
      integer(kind=iwp), intent(in):: ITEM(NCOMP,*)

C These parameters determine the hash function:
      integer(kind=iwp), parameter:: MULT=37,NHASH=997
      integer(kind=iwp) IND,I,IFREE,LOOKAT,NULL,NEXT

      IF(NSIZE.LT.NHASH) THEN
        WRITE(6,*)' HSHPUT: Table size must be at least as'
        WRITE(6,*)'         big as NHASH, presently =', NHASH
        CALL ABEND()
      END IF
      NULL=ITAB(NSIZE,1)
      IFREE=ITAB(NSIZE,2)
      IF(ITAB(IFREE,1).EQ.NULL) THEN
        WRITE(6,*)' HSHPUT: Table is already full.'
        WRITE(6,*)' Size NSIZE is too small, NSIZE =', NSIZE
        CALL ABEND()
      END IF
C Evaluate hash index:
      IND=MOD(ITEM(1,ITEMID),NHASH)
      DO I=2,KEYDIM
        IND=MOD(ITEM(I,ITEMID)+MULT*IND,NHASH)
      END DO
      IND=IND+1
C IND is a hashed index in interval 1..NHASH < NSIZE
C Find the last item with this key:

      LOOKAT=IND
      DO
C Are there already items with that hash signature?
      IF(ITAB(LOOKAT,1).EQ.NULL) EXIT
      LOOKAT=ITAB(LOOKAT,1)
      END DO

C No more items with the same signature.
C Put the new item in the table at a free location.
      ITAB(LOOKAT,1)=IFREE
      ITAB(LOOKAT,2)=ITEMID
      NEXT=ITAB(IFREE,1)
      ITAB(IFREE,1)=NULL
      ITAB(NSIZE,2)=NEXT

      END SUBROUTINE HSHPUT

      SUBROUTINE HSHINI(NSIZE,ITAB,NULL)
      use definitions, only: iwp, u6
      IMPLICIT NONE
      integer(kind=iwp), intent(In):: NSIZE, NULL
      integer(kind=iwp), intent(out):: ITAB(NSIZE,2)
C These parameters determine the hash function
      integer(kind=iwp), PARAMETER:: NHASH=997
      integer(kind=iwp) I, IFREE

      IF (NSIZE.LT.NHASH) THEN
         WRITE(u6,*)' HSHINI: Table size must be at least as'
         WRITE(u6,*)'         big as NHASH, presently =', NHASH
         CALL ABEND()
      END IF
      DO I=1,NHASH
        ITAB(I,1)=NULL
        ITAB(I,2)=NULL
      END DO
      IFREE=NHASH+1
      DO I=IFREE,NSIZE-1
        ITAB(I,1)=I+1
        ITAB(I,2)=NULL
      END DO
      ITAB(NSIZE,1)=NULL
      ITAB(NSIZE,2)=IFREE

      END SUBROUTINE HSHINI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_Shanks(E1,E2,EOrb,lthEOrb,nBas,nFro,nOcc,nSym,E0,Shanks1_E)

use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lthEOrb, nSym, nBas(nSym), nFro(nSym), nOcc(nSym)
real(kind=wp), intent(in) :: E1, E2, EOrb(lthEOrb)
real(kind=wp), intent(out) :: E0, Shanks1_E
integer(kind=iwp) :: ioff, iorb, iSym, jorb, nOrb
real(kind=wp) :: PotNuc

E0 = Zero
ioff = 0
do iSym=1,nSym
  nOrb = nFro(iSym)+nOcc(iSym)
  do iorb=1,nOrb
    jorb = ioff+iorb
    E0 = E0+EOrb(jorb)
  end do
  ioff = ioff+nBas(iSym)
end do
E0 = Two*E0

call Peek_dScalar('PotNuc',PotNuc)
E0 = E0+PotNuc

! Shanks formula

Shanks1_E = (E2*E0-E1**2)/(E2-Two*E1+E0)

return

end subroutine Compute_Shanks

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************

subroutine Get_dScalar_(Label,rData)

use RunFile_data, only: i_run_DS_used, lw, nTocDS, sSpecialField
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: Label
real(kind=wp), intent(out) :: rData
integer(kind=iwp) :: i, item, RecIdx(nTocDS)
real(kind=wp) :: RecVal(nTocDS)
character(len=lw) :: CmpLab1, CmpLab2, RecLab(nTocDS)

!----------------------------------------------------------------------*
! Read info from runfile.                                              *
!----------------------------------------------------------------------*
call cRdRun('dScalar labels',RecLab,lw*nTocDS)
call dRdRun('dScalar values',RecVal,nTocDS)
call iRdRun('dScalar indices',RecIdx,nTocDS)
!----------------------------------------------------------------------*
! Locate item                                                          *
!----------------------------------------------------------------------*
item = -1
CmpLab1 = Label
call UpCase(CmpLab1)
do i=1,nTocDS
  CmpLab2 = RecLab(i)
  call UpCase(CmpLab2)
  if (CmpLab1 == CmpLab2) then
    item = i
    exit
  end if
end do

if (item /= -1) then
  if (Recidx(item) == sSpecialField) then
    write(u6,*) '***'
    write(u6,*) '*** Warning, reading temporary dScalar field'
    write(u6,*) '***   Field: ',Label
    write(u6,*) '***'
#   ifndef _DEVEL_
    call AbEnd()
#   endif
  end if
end if
!----------------------------------------------------------------------*
! Transfer data to arguments                                           *
!----------------------------------------------------------------------*
i_run_DS_used(item) = i_run_DS_used(item)+1
if (item == -1) call SysAbendMsg('get_dScalar','Could not locate: ',Label)
if (RecIdx(item) == 0) call SysAbendMsg('get_dScalar','Data not defined: ',Label)
rData = RecVal(item)
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine Get_dScalar_

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines :
c     intermezzo
c     getw3
c
c     ---------------------------------------------------------
c
       subroutine intermezzo (wrk,wrksize,
     & lunw3aaaa,lunw3bbbb,lunw3abba,
     & lunw3baab,lunw3aabb,lunw3bbaa,lunt2o1,lunt2o2,lunt2o3,
     & lunabij1,lunabij2,lunabij3)
c
c     this routine calculate contributions
c     WIII3, WIII4 and T26
c
c     assigment of spin combinations:
c
c     WIII(m,e,b,j)aaaa  - I
c     WIII(m,e,b,j)bbbb  - K
c     WIII(m,e,b,j)aabb  - L
c     WIII(m,e,b,j)abba  - M
c     WIII(m,e,b,j)baab  - N
c     WIII(m,e,b,j)bbaa  - J
c
c     WIII3
c     WIII(m,e,b,j)aaaa <- sum(n-a) [ <mn||je>aaaa . T1o(n,b)aa ]
c     WIII(m,e,b,j)bbbb <- sum(n-b) [ <mn||je>bbbb . T1o(n,b)bb ]
c     WIII(m,e,b,j)aabb <- sum(n-b) [ <mn||je>abba . T1o(n,b)bb ]
c     WIII(m,e,b,j)abba <- sum(n-b) [ <mn||je>abab . T1o(n,b)bb ]
c     WIII(m,e,b,j)baab <- -sum(n-a) [ <nm||je>abba . T1o(n,b)aa ]
c     WIII(m,e,b,j)bbaa <- -sum(n-a) [ <je||nm>abab . T1o(n,b)aa ]
c
c     WIII4
c     Q(f,b,j,n)aaaa   <= 0.5 T2o(f,b,j,n)aaaa + T1o(f,j)aa . T1o(b,n)aa
c     WIII(m,e,b,j)aaaa <- -sum(n,f-aa)     [ Q(f,b,j,n)aaaa   . <ef||mn>aaaa ]
c     <- 0.5 sum(n,f-bb)  [ T2o(b,f,j,n)abab . <ef||mn>abab ]
c     WIII(m,e,b,j)aabb <- 0.5 sum(n,f-aa)  [ T2o(f,b,n,j)abab . <ef||mn>aaaa ]
c     <- -sum(n,f-bb)     [ Q(f,b,j,n)bbbb   . <ef||mn>abab ]
c     Q(f,b,j,n)bbbb   <= 0.5 T2o(f,b,j,n)bbbb + T1o(f,j)nn . T1o(b,n)bb
c     WIII(m,e,b,j)bbbb <- -sum(n,f-bb)     [ Q(f,b,j,n)bbbb   . <ef||mn>bbbb ]
c     <- 0.5 sum(n,f-aa)  [ T2o(f,b,n,j)abab . <fe||nm>abab ]
c     WIII(m,e,b,j)bbaa <- 0.5 sum(n,f-bb)  [ T2o(b,f,j,n)abab . <ef||mn>bbbb ]
c     <- - sum(n,f-aa)    [ Q(f,b,j,n)aaaa   . <fe||nm>abab ]
c     Q(f,b,j,n)abab   <= 0.5 T2o(f,b,j,n)abab + T1o(f,j)aa . T1o(b,n)bb
c     WIII(m,e,b,j)abba <- sum(n,f-ba)      [ Q(f,b,j,n)abab   . <fe||mn>abab ]
c     Q(b,f,n,j)abab   <= 0.5 T2o(b,f,n,j)abab + T1o(b,n)aa . T1o(fmj)bb
c     WIII(m,e,b,j)baab <- sum(n,f-ab)      [ Q(b,f,n,j)abab   . <ef||nm>abab ]
c
c
c     T26
c     R1(a,i,b,j)aaaa <= sum(m,e-aa) [ T2o(a,e,i,m)aaaa . WIII(m,e,b,j)aaaa ]
c     <- sum(m,e-bb) [ T2o(a,e,i,m)abab . WIII(m,e,b,j)bbaa ]
c     T2n(ab,ij)aaaa   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}aaaa
c     R1(a,i,b,j)bbbb <= sum(m,e-bb) [ T2o(a,e,i,m)bbbb . WIII(m,e,b,j)bbbb ]
c     <- sum(m,e-aa) [ T2o(e,a,m,i)abab . WIII(m,e,b,j)aabb ]
c     T2n(ab,ij)bbbb   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}bbbb
c     T2n(a,b,i,j)abab <- sum(m,e-aa) [ T2o(a,e,i,m)aaaa . WIII(m,e,b,j)aabb ]
c     <- sum(m,e-aa) [ T2o(e,b,m,j)abab . WIII(m,e,a,i)aaaa ]
c     <- sum(m,e-bb) [ T2o(a,e,i,m)abab . WIII(m,e,b,j)bbbb ]
c     <- sum(m,e-bb) [ T2o(b,e,j,m)bbbb . WIII(m,e,a,i)bbaa ]
c     <- sum(m,e-ab) [ T2o(a,e,m,j)abab . WIII(m,e,b,i)abba ]
c     <- sum(m,e-ab) [ T2o(e,b,i,m)abab . WIII(m,e,a,j)baab ]
c
c     N.B. use and destry : V1,V2,V3,V4,M1,M2
c     N.B. # of read      : 30 + 6
c     # of write     : 2
c
        implicit none
#include "ccsd2.fh"
#include "wrk.fh"
#include "paralell.fh"
c
       integer lunw3aaaa,lunw3bbbb,lunw3abba,lunw3baab,lunw3aabb,
     & lunw3bbaa
       integer lunt2o1,lunt2o2,lunt2o3,lunabij1,lunabij2,lunabij3
c
c     help variableas
c
       integer posst,rc,ssc,lunqaaaa,lunqbbbb
c
c
cA.1  rewind nw3 files
cpar
        if (myRank.eq.idaaaa) then
       call filemanager (2,lunw3aaaa,rc)
        end if
c
        if (myRank.eq.idbaab) then
       call filemanager (2,lunw3baab,rc)
        end if
c
        if (myRank.eq.idbbaa) then
       call filemanager (2,lunw3bbaa,rc)
        end if
c
        if (myRank.eq.idbbbb) then
       call filemanager (2,lunw3bbbb,rc)
        end if
c
        if (myRank.eq.idabba) then
       call filemanager (2,lunw3abba,rc)
        end if
c
        if (myRank.eq.idaabb) then
       call filemanager (2,lunw3aabb,rc)
        end if
c
c0.1  map M1(i,a) <- T1o(a,i)aa
       call map (wrk,wrksize,
     & 2,2,1,0,0,mapdt11,mapit11,1,mapdm1,mapim1,possm10,
     &           posst,rc)
c0.2  map M2(i,a) <- T1o(a,i)bb
       call map (wrk,wrksize,
     & 2,2,1,0,0,mapdt12,mapit12,1,mapdm2,mapim2,possm20,
     &           posst,rc)
c
c
c     part I - W3aaaa
cpar  all contributions are calculated for idaaaa only,
c     just Qaaaa is calculated both on idaaaa and idbbaa
c
c     par
      if (idaaaa.eq.myRank) then
c
cI.1  get V1(m,e,a,j) <- W3aaaa(m,e,a,j)
       call getw3 (wrk,wrksize,
     & lunw3aaaa,1)
c
cI.2  WIII(m,e,b,j)aaaa <- sum(n-a) [ <mn||je>aaaa . T1o(n,b)aa ]
c
cI.2.1expand V2(j,e,m,n) <- <je||mn>aaaa
       call expand (wrk,wrksize,
     & 4,3,mapdw11,mapiw11,1,possv20,mapdv2,mapiv2,rc)
cI.2.2map V3(m,e,j,n) <- V2(j,e,m,n)
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.2.3mult V2(m,e,j,b) <- V3(m,e,j,n) . M1(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm1,mapim1,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cI.2.4map V3(m,e,b,j) <- V2(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.2.5add V1(m,e,b,j) <- 1.0d0 . V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
cparend
        end if
c
cI.3  WIII4
c     Q(f,b,j,n)aaaa   <= 0.5 T2o(f,b,j,n)aaaa + T1o(f,j)aa . T1o(b,n)aa
c     WIII(m,e,b,j)aaaa <- -sum(n,f-aa)     [ Q(f,b,j,n)aaaa   . <ef||mn>aaaa ]
c     <- 0.5 sum(n,f-bb)  [ T2o(b,f,j,n)abab . <ef||mn>abab ]
c
cpar
        if ((myRank.eq.idaaaa).or.(myRank.eq.idbbaa)) then
cI.3.1get V3(fb,jn) <- T2o(fb,jn)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv30,mapdv3,mapiv3,rc)
cI.3.2expand V2(f,b,j,n) <- V3(fb,jn)
       call expand (wrk,wrksize,
     & 4,4,mapdv3,mapiv3,1,possv20,mapdv2,mapiv2,rc)
cI.3.3mkQ V2(f,b,j,n) <- 0.5 V2(f,b,j,n) + T1o(f,j)aa . T1o(b,n)aa
       call mkq(wrk,wrksize,
     & mapdv2,mapiv2,mapdt11,mapit11,mapdt11,mapit11,0.5d0,rc)
cI.3.4map V3(f,n,b,j) <- V2(f,b,j,n)
       call map (wrk,wrksize,
     & 4,1,3,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cparend
        end if
cpar
        if (myRank.eq.idbbaa) then
cI.3.5write V3(f,n,b,j) to lunqaaaa
       call filemanager (1,lunqaaaa,rc)
       call wrtmediate (wrk,wrksize,
     & lunqaaaa,mapdv3,mapiv3,rc)
        end if
c
cpar
        if (myRank.eq.idaaaa) then
cI.3.6get V2(ef,mn) = <ef||mn>aaaa from luna file
       call filemanager (2,lunabij1,rc)
       call getmediate (wrk,wrksize,
     & lunabij1,possv20,mapdv2,mapiv2,rc)
cI.3.7expand V4(e,f,m,n) <- V2(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv40,mapdv4,mapiv4,rc)
cI.3.8map V2(m,e,f,n) <- V4(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cI.3.9mult V4(m,e,b,j) <- V2(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cI.3.10 add V1(m,e,b,j) <- -1.0d0 . V4(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv4,1,mapdv1,mapiv1,1,rc)
cI.3.11 get V2(e,f,m,n) <- <ef||mn>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
cI.3.12 map V3(m,e,f,n) <- V2(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.3.13 get V2(b,f,j,n) <- T2o(b,f,j,n)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cI.3.14 map V4(f,n,b,j) <- V2(b,f,j,n)
       call map (wrk,wrksize,
     & 4,3,1,4,2,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cI.3.15 mult V2(m,e,b,j) <- V3(m,e,f,n) . V4(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv3,mapiv3,1,mapdv4,mapiv4,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cI.3.16 add V1(m,e,b,j) <- 0.5d0 . V2(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,0.5d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
cI.4  R1(a,i,b,j)aaaa <= sum(m,e-aa) [ T2o(a,e,i,m)aaaa . WIII(m,e,b,j)aaaa ]
c     T2n(ab,ij)aaaa   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}aaaa
cI.4.1get V2(ae,im) <- T2o(ae,im)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv20,mapdv2,mapiv2,rc)
cI.4.2expand V3(a,e,i,m) <- V2(ae,im)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv30,mapdv3,mapiv3,rc)
cI.4.3map V2(a,i,m,e) <- V3(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cI.4.4mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cI.4.5map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.4.6pack V3(ab,ij) <- V2(ab,i,j) <- V3(a,b,i,j)
       call fack (wrk,wrksize,
     & 4,1,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
       call fack (wrk,wrksize,
     & 4,4,mapdv2,1,mapiv2,mapdv3,mapiv3,possv30,rc)
cI.4.7add T2n(ab,ij)aaaa <- 1.0d0 V3(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt21,mapit21,1,rc)
c
cI.5  T2n(a,b,i,j)abab <- sum(m,e-aa) [ T2o(e,b,m,j)abab . WIII(m,e,a,i)aaaa ]
cI.5.1get V4(e,b,m,j) <- T2o(e,b,m,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv40,mapdv4,mapiv4,rc)
cI.5.2map V2(b,j,m,e) <- V4(e,b,m,j)
       call map (wrk,wrksize,
     & 4,4,1,3,2,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cI.5.3mult V4(b,j,a,i) <- V2(b,j,m,e) . V1(m,e,a,i)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cI.5.4map V3(a,b,i,j) <- V4(b,j,a,i)
       call map (wrk,wrksize,
     & 4,2,4,1,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.5.5add T2n(a,b,i,j)abab <- 1.0d0 . V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     J part W3bbaa
c
c     par
      if (myRank.eq.idbbaa) then
c
cJ.1  get V1(m,e,a,j) <- W3bbaa(m,e,a,j)
       call getw3 (wrk,wrksize,
     & lunw3bbaa,6)
c
cJ.2  WIII(m,e,b,j)bbaa <- -sum(n-a) [ <je||nm>abab . T1o(n,b)aa ]
cJ.2.1map V3(m,e,j,n) <- <j,e||n,m>abab
       call map (wrk,wrksize,
     & 4,3,2,4,1,mapdw13,mapiw13,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
cJ.2.2mult V4(m,e,j,b) <- V3(m,e,j,n) . M1(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm1,mapim1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cJ.2.3map V3(m,e,b,j) <- V4(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cJ.2.4add V1(m,e,b,j) <- -1.0d0 V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
cJ.2  WIII(m,e,b,j)bbaa <- 0.5 sum(n,f-bb)  [ T2o(b,f,j,n)abab . <ef||mn>bbbb ]
c     <- - sum(n,f-aa)    [ Q(f,b,j,n)aaaa   . <fe||nm>abab ]
cJ.2.1get V2(f,n,b,j) from lunqaaaa (produced in I step) and close it
       call filemanager (2,lunqaaaa,rc)
       call getmediate (wrk,wrksize,
     & lunqaaaa,possv20,mapdv2,mapiv2,rc)
       call filemanager (3,lunqaaaa,rc)
cJ.2.2get V3(f,e,n,m) <- <fe||nm>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv30,mapdv3,mapiv3,rc)
cJ.2.3map V4(m,e,f,n) <- V3(f,e,n,m)
       call map (wrk,wrksize,
     & 4,3,2,4,1,mapdv3,mapiv3,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cJ.2.4mult V3(m,e,b,j) <- V4(m,e,f,n) . V2(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
cJ.2.5add V1(m,e,b,j) <- -1.0d0 . V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
cJ.2.6get V2(b,f,j,n) <- T2o(b,f,j,n)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cJ.2.7map V3(f,n,b,j) <- V2(b,f,j,n)
       call map (wrk,wrksize,
     & 4,3,1,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cJ.3.8get V2(ef,mn) = <ef||mn>bbbb from lunb file
       call filemanager (2,lunabij2,rc)
       call getmediate (wrk,wrksize,
     & lunabij2,possv20,mapdv2,mapiv2,rc)
cJ.3.9exp V4(e,f,m,n) <- V2(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv40,mapdv4,mapiv4,rc)
cJ.3.10        map V2(m,e,f,n) <- V4(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cJ.3.11 mult V4(m,e,b,j) <- V2(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cJ.3.12        add V1(m,e,b,j) <- 0.5d0 . V4(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,0.5d0,mapdv4,1,mapdv1,mapiv1,1,rc)
c
cJ.4  R1(a,i,b,j)aaaa <= sum(m,e-bb) [ T2o(a,e,i,m)abab . WIII(m,e,b,j)bbaa ]
c     T2n(ab,ij)aaaa   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}aaaa
cJ.4.1get V3(a,e,i,m) <- T2o(a,e,i,m)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv30,mapdv3,mapiv3,rc)
cJ.4.2map V2(a,i,m,e) <- V3(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cJ.4.3mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cJ.4.4map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cJ.4.5pack V3(ab,ij) <- V2(ab,i,j) <- V3(a,b,i,j)
       call fack (wrk,wrksize,
     & 4,1,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
       call fack (wrk,wrksize,
     & 4,4,mapdv2,1,mapiv2,mapdv3,mapiv3,possv30,rc)
cJ.4.6add T2n(ab,ij)aaaa <- 1.0d0 V2(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt21,mapit21,1,rc)
c
cJ.5  T2n(a,b,i,j)abab <- sum(m,e-aa) [ T2o(b,e,j,m)bbbb . WIII(m,e,a,i)bbaa ]
cJ.5.1get V4(be,jm) <- T2o(be,jm)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv40,mapdv4,mapiv4,rc)
cJ.5.2expand V3(b,e,j,m) <-  V4(be,jm)
       call expand (wrk,wrksize,
     & 4,4,mapdv4,mapiv4,1,possv30,mapdv3,mapiv3,rc)
cJ.5.2map V2(b,j,m,e) <- V3(b,e,j,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cJ.5.3mult V3(b,j,a,i) <- V2(b,j,m,e) . V1(m,e,a,i)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
cJ.5.4map V2(a,b,i,j) <- V3(b,j,a,i)
       call map (wrk,wrksize,
     & 4,2,4,1,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cJ.5.5add T2n(a,b,i,j)abab <- 1.0d0 . V2(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     part K - W3bbbb
cpar  all contributions are calculated for idbbbb only,
c     just Qbbbb is calculated both on idbbbb and idaabb
c
cpar
      if (myRank.eq.idbbbb) then
c
cK.1  get V1(m,e,a,j) <- W3bbbb(m,e,a,j)
       call getw3 (wrk,wrksize,
     & lunw3bbbb,2)
c
cK.2  WIII(m,e,b,j)bbbb <- sum(n-b) [ <mn||je>bbbb . T1o(n,b)bb ]
cK.2.1expand V2(j,e,m,n) <- <je||mn>bbbb
       call expand (wrk,wrksize,
     & 4,3,mapdw12,mapiw12,1,possv20,mapdv2,mapiv2,rc)
cK.2.2map V3(m,e,j,n) <- V2(j,e,m,n)
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.2.3mult V2(m,e,j,b) <- V3(m,e,j,n) . M2(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm2,mapim2,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cK.2.4map V3(m,e,b,j) <- V2(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.2.5add V1(m,e,b,j) <- 1.0d0 . V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
cparend
        end if
c
cK.3  WIII4
c     Q(f,b,j,n)bbbb   <= 0.5 T2o(f,b,j,n)bbbb + T1o(f,j)bb . T1o(b,n)bb
c     WIII(m,e,b,j)bbbb <- -sum(n,f-bb)     [ Q(f,b,j,n)bbbb   . <ef||mn>bbbb ]
c     <- 0.5 sum(n,f-aa)  [ T2o(f,b,n,j)abab . <fe||nm>abab ]
c
cpar
        if ((myRank.eq.idbbbb).or.(myRank.eq.idaabb)) then
cK.3.1get V3(fb,jn) <- T2o(fb,jn)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv30,mapdv3,mapiv3,rc)
cK.3.2expand V2(f,b,j,n) <- V3(fb,jn)
       call expand (wrk,wrksize,
     & 4,4,mapdv3,mapiv3,1,possv20,mapdv2,mapiv2,rc)
cK.3.3mkQ V2(f,b,j,n) <- 0.5 V2(f,b,j,n) + T1o(f,j)bb . T1o(b,n)bb
       call mkq(wrk,wrksize,
     & mapdv2,mapiv2,mapdt12,mapit12,mapdt12,mapit12,0.5d0,rc)
cK.3.4map V3(f,n,b,j) <- V2(f,b,j,n)
       call map (wrk,wrksize,
     & 4,1,3,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cparend
        end if
cpar
        if (myRank.eq.idaabb) then
cK.3.5write V3(f,n,b,j) to lunqbbbb
       call filemanager (1,lunqbbbb,rc)
       call wrtmediate (wrk,wrksize,
     & lunqbbbb,mapdv3,mapiv3,rc)
        end if
cpar
        if (myRank.eq.idbbbb) then
cK.3.6get V2(ef,mn) = <ef||mn>bbbb from luna file
       call filemanager (2,lunabij2,rc)
       call getmediate (wrk,wrksize,
     & lunabij2,possv20,mapdv2,mapiv2,rc)
cK.3.7expand V4(e,f,m,n) <- V2(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv40,mapdv4,mapiv4,rc)
cK.3.8map V2(m,e,f,n) <- V4(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cK.3.9mult V4(m,e,b,j) <- V2(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cK.3.10 add V1(m,e,b,j) <- -1.0d0 . V4(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv4,1,mapdv1,mapiv1,1,rc)
cK.3.11 get V2(f,e,n,m) <- <fe||nm>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
cK.3.12 map V3(m,e,f,n) <- V2(f,e,n,m)
       call map (wrk,wrksize,
     & 4,3,2,4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.3.13 get V2(f,b,n,j) <- T2o(f,b,n,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cK.3.14 map V4(f,n,b,j) <- V2(f,b,n,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cK.3.15 mult V2(m,e,b,j) <- V3(m,e,f,n) . V4(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv3,mapiv3,1,mapdv4,mapiv4,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cK.3.16 add V1(m,e,b,j) <- 0.5d0 . V2(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,0.5d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
cK.4  R1(a,i,b,j)bbbb <= sum(m,e-bb) [ T2o(a,e,i,m)bbbb . WIII(m,e,b,j)bbbb ]
c     T2n(ab,ij)bbbb   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}bbbb
cK.4.1get V2(ae,im) <- T2o(ae,im)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv20,mapdv2,mapiv2,rc)
cK.4.2expand V3(a,e,i,m) <- V2(ae,im)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv30,mapdv3,mapiv3,rc)
cK.4.3map V2(a,i,m,e) <- V3(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cK.4.4mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cK.4.5map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.4.6pack V3(ab,ij) <- V2(ab,i,j) <- V3(a,b,i,j)
       call fack (wrk,wrksize,
     & 4,1,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
       call fack (wrk,wrksize,
     & 4,4,mapdv2,1,mapiv2,mapdv3,mapiv3,possv30,rc)
cK.4.7add T2n(ab,ij)bbbb <- 1.0d0 V3(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt22,mapit22,1,rc)
c
c
cK.5  T2n(a,b,i,j)abab <- sum(m,e-bb) [ T2o(a,e,i,m)abab . WIII(m,e,b,j)bbbb ]
cK.5.1get V4(a,e,i,m) <- T2o(a,e,i,m)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv40,mapdv4,mapiv4,rc)
cK.5.2map V2(a,i,m,e) <- V4(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cK.5.3mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cK.5.4map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.5.5add T2n(a,b,i,j)abab <- 1.0d0 . V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     L part W3aabb
c
cpar
      if (myRank.eq.idaabb) then
c
cL.1  get V1(m,e,a,j) <- W3aabb(m,e,a,j)
       call getw3 (wrk,wrksize,
     & lunw3aabb,3)
c
cL.2  WIII(m,e,b,j)aabb <- sum(n-b) [ <mn||je>abba . T1o(n,b)bb ]
cL.2.1map V3(m,e,j,n) <- <j,e||m,n>baab
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdw14,mapiw14,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
cL.2.2mult V4(m,e,j,b) <- V3(m,e,j,n) . M2(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm2,mapim2,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cL.2.3map V3(m,e,b,j) <- V4(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cL.2.4add V1(m,e,b,j) <- 1.0d0 V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
cL.2  WIII(m,e,b,j)aabb <- 0.5 sum(n,f-aa)  [ T2o(f,b,n,j)abab . <ef||mn>aaaa ]
c     <- - sum(n,f-bb)    [ Q(f,b,j,n)bbbb   . <ef||mn>abab ]
cL.2.1get V2(f,n,b,j) from lunqbbbb (produced in K step) and close it
       call filemanager (2,lunqbbbb,rc)
       call getmediate (wrk,wrksize,
     & lunqbbbb,possv20,mapdv2,mapiv2,rc)
       call filemanager (3,lunqbbbb,rc)
cL.2.2get V3(e,f,m,n) <- <ef||mn>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv30,mapdv3,mapiv3,rc)
cL.2.3map V4(m,e,f,n) <- V3(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv3,mapiv3,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cL.2.4mult V3(m,e,b,j) <- V4(m,e,f,n) . V2(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
cL.2.5add V1(m,e,b,j) <- -1.0d0 . V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
cL.2.6get V2(f,b,n,j) <- T2o(f,b,n,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cL.2.7map V3(f,n,b,j) <- V2(f,b,n,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cL.3.8get V2(ef,mn) = <ef||mn>aaaa from lunb file
       call filemanager (2,lunabij1,rc)
       call getmediate (wrk,wrksize,
     & lunabij1,possv20,mapdv2,mapiv2,rc)
cL.3.9exp V4(e,f,m,n) <- V2(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv40,mapdv4,mapiv4,rc)
cL.3.10        map V2(m,e,f,n) <- V4(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cL.3.11 mult V4(m,e,b,j) <- V2(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cL.3.12        add V1(m,e,b,j) <- 0.5d0 . V4(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,0.5d0,mapdv4,1,mapdv1,mapiv1,1,rc)
c
cL.4  R1(a,i,b,j)bbbb <- sum(m,e-aa) [ T2o(e,a,m,i)abab . WIII(m,e,b,j)aabb ]
c     T2n(ab,ij)bbbb   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}bbbb
cL.4.1get V3(e,a,m,i) <- T2o(e,a,m,i)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv30,mapdv3,mapiv3,rc)
cL.4.2map V2(a,i,m,e) <- V3(e,a,m,i)
       call map (wrk,wrksize,
     & 4,4,1,3,2,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cL.4.3mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cL.4.4map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cL.4.5pack V3(ab,ij) <- V2(ab,i,j) <- V3(a,b,i,j)
       call fack (wrk,wrksize,
     & 4,1,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
       call fack (wrk,wrksize,
     & 4,4,mapdv2,1,mapiv2,mapdv3,mapiv3,possv30,rc)
cL.4.6add T2n(ab,ij)aaaa <- 1.0d0 V2(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt22,mapit22,1,rc)
c
cL.5  T2n(a,b,i,j)abab <- sum(m,e-aa) [ T2o(a,e,i,m)aaaa . WIII(m,e,b,j)aabb ]
cL.5.1get V4(ae,im) <- T2o(ae,im)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv40,mapdv4,mapiv4,rc)
cL.5.2expand V3(a,e,i,m) <-  V4(ae,im)
       call expand (wrk,wrksize,
     & 4,4,mapdv4,mapiv4,1,possv30,mapdv3,mapiv3,rc)
cL.5.2map V2(a,i,m,e) <- V3(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cL.5.3mult V3(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
cL.5.4map V2(a,b,i,j) <- V3(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cL.5.5add T2n(a,b,i,j)abab <- 1.0d0 . V2(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     M part W3abba
c
cpar
      if (myRank.eq.idabba) then
c
cM.1  get V1(m,e,a,j) <- W3abba
       call getw3 (wrk,wrksize,
     & lunw3abba,4)
c
cM.2  WIII(m,e,b,j)abba <- sum(n-b) [ <mn||je>abab . T1o(n,b)bb ]
cM.2.1map V3(m,e,j,n) <- <j,e||m,n>abab
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdw13,mapiw13,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
cM.2.2mult V4(m,e,j,b) <- V3(m,e,j,n) . M2(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm2,mapim2,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cM.2.3map V3(m,e,b,j) <- V4(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cM.2.4add V1(m,e,b,j) <- 1.0d0 V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
cM.3  Q(f,b,j,n)abab   <= 0.5 T2o(f,b,j,n)abab + T1o(f,j)aa . T1o(b,n)bb
c     WIII(m,e,b,j)abba <- sum(n,f-ba)      [ Q(f,b,j,n)abab   . <fe||mn>abab ]
cM.3.1get V4(f,b,j,n) <- T2o(f,b,j,n)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv40,mapdv4,mapiv4,rc)
cM.3.2mkQ V4(f,b,j,n) <- 0.5 V4(f,b,j,n) + T1o(f,j)aa . T1o(b,n)bb
       call mkq(wrk,wrksize,
     & mapdv4,mapiv4,mapdt11,mapit11,mapdt12,mapit12,0.5d0,rc)
cM.3.3map V3(f,n,b,j) <- V4(f,b,j,n)
       call map (wrk,wrksize,
     & 4,1,3,4,2,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cM.3.4get V2(f,e,m,n) <- <fe||mn>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
cM.3.5map V4(m,e,f,n) <- V2(f,e,m,n)
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cM.3.6mult V2(m,e,b,j) <- V4(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv3,mapiv3,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cM.3.7add V1(m,e,b,j) <- 1.0d0 V2(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
cM.4  T2n(a,b,i,j)abab <- sum(m,e-ab) [ T2o(a,e,m,j)abab . WIII(m,e,b,i)abba ]
cM.4.1get V2(a,e,m,j) <- T2o(a,e,m,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cM.4.2map V3(a,j,m,e) <- V2(a,e,m,j)
       call map (wrk,wrksize,
     & 4,1,4,3,2,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cM.4.3mult V4(a,j,b,i) <- V3(a,j,m,e) . V1(m,e,b,i)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv3,mapiv3,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cM.4.4map V3(a,b,i,j) <- V4(a,j,b,i)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cM.4.5add T2n(a,b,i,j)abab <- 1.0d0 V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     N part W3baab
c
cpar
      if (myRank.eq.idbaab) then
c
cN.1  get V1(m,e,a,j) <- W3baab
       call getw3 (wrk,wrksize,
     & lunw3baab,5)
c
cN.2  WIII(m,e,b,j)baab <- - sum(n-a) [ <je||nm>baab . T1o(n,b)aa ]
cN.2.1map V3(m,e,j,n) <- <j,e||n,m>baab
       call map (wrk,wrksize,
     & 4,3,2,4,1,mapdw14,mapiw14,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
cN.2.2mult V4(m,e,j,b) <- V3(m,e,j,n) . M1(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm1,mapim1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cN.2.3map V3(m,e,b,j) <- V4(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cN.2.4add V1(m,e,b,j) <- -1.0d0 V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
cN.3  Q(b,f,n,j)abab   <= 0.5 T2o(b,f,n,j)abab + T1o(b,n)aa . T1o(f,j)bb
c     WIII(m,e,b,j)baab <- sum(n,f-ab)      [ Q(b,f,n,j)abab   . <ef||nm>abab ]
cN.3.1get V4(b,f,n,j) <- T2o(b,f,n,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv40,mapdv4,mapiv4,rc)
cN.3.2mkQ V4(b,f,n,j) <- 0.5 V4(b,f,n,j) + T1o(b,n)aa . T1o(f,j)bb
       call mkq(wrk,wrksize,
     & mapdv4,mapiv4,mapdt11,mapit11,mapdt12,mapit12,0.5d0,rc)
cN.3.3map V3(f,n,b,j) <- V4(b,f,n,j)
       call map (wrk,wrksize,
     & 4,3,1,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cN.3.4get V2(e,f,n,m) <- <ef||nm>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
cN.3.5map V4(m,e,f,n) <- V2(e,f,n,m)
       call map (wrk,wrksize,
     & 4,2,3,4,1,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cN.3.6mult V2(m,e,b,j) <- V4(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv3,mapiv3,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cN.3.7add V1(m,e,b,j) <- 1.0d0 V2(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
cN.4  T2n(a,b,i,j)abab <- sum(m,e-ab) [ T2o(e,b,i,m)abab . WIII(m,e,a,j)baab ]
cN.4.1get V2(e,b,i,m) <- T2o(e,b,i,m)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cN.4.2map V3(b,i,m,e) <- V2(e,b,i,m)
       call map (wrk,wrksize,
     & 4,4,1,2,3,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cN.4.3mult V4(b,i,a,j) <- V3(b,i,m,e) . V1(m,e,a,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv3,mapiv3,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cN.4.4map V3(a,b,i,j) <- V4(b,i,a,j)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cN.4.5add T2n(a,b,i,j)abab <- 1.0d0 V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
       return
       end
c
c     --------------------------
c
       subroutine getw3 (wrk,wrksize,
     & lunw3xxxx,nxxxx)
c
c     This routine reconstruct W3(m,e,a,j)xxxx from lunw3xxxx file
c     to V1(m,e,a,j) and define corresponding mapdv1 and mapiv1
c     This routine also close lunw3xxxx file
c
c     lunw3xxxx - lun of opened w3xxxx file
c     nxxxx     - xxxx identifier
c     1 - aaaa
c     2 - bbbb
c     3 - aabb
c     4 - abba
c     5 - baab
c     6 - bbaa
c
c     the structure of lunw3xxxx is:
c
c     do syma=1,nsym
c     map of H _a(m,e,j)bbbb (W3(m,e,a,j))
c     skip cycle over a if lenght of all files is zero
c     do a=1,nvx(syma) [ x is a or b ]
c     if (h1lenght.gt.0) then
c     write H(m,e,j)
c     end if
c     end do
c     end do
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer lunw3xxxx,nxxxx
c
c     help variables
c
       integer rc,syma,a,h1lenght,posst,aup,aalfayes,iiv1,v1lenght
c
c0    def aalfayes
c
       if ((nxxxx.eq.1).or.(nxxxx.eq.5).or.(nxxxx.eq.6)) then
       aalfayes=1
       else
       aalfayes=0
       end if
c
c1.1  def maps of V1(m,e,a,j)
c
       if (nxxxx.eq.1) then
       call grc0 (4,0,1,3,3,1,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.2) then
       call grc0 (4,0,2,4,4,2,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.3) then
       call grc0 (4,0,1,3,4,2,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.4) then
       call grc0 (4,0,1,4,4,1,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.5) then
       call grc0 (4,0,2,3,3,2,1,possv10,posst,mapdv1,mapiv1)
       else if (nxxxx.eq.6) then
       call grc0 (4,0,2,4,3,1,1,possv10,posst,mapdv1,mapiv1)
       end if
c
c1.2  vanish V1
       iiv1=mapdv1(0,5)
       v1lenght=mapdv1(iiv1,1)+mapdv1(iiv1,2)-possv10
       call mv0zero (v1lenght,v1lenght,wrk(possv10))
c
c2    rewind tape lunw3xxxx
       call filemanager (2,lunw3xxxx,rc)
c
c3    loop over symA
c
       do 3000 syma=1,nsym
c
c3.1  get map of H _a(m,e,j) to mapd,i H1
       call getmap (lunw3xxxx,possh10,h1lenght,mapdh1,mapih1,rc)
c
c3.2  skip cycle over a if lenght of H1 is 0
       if (h1lenght.eq.0) goto 3000
c
c3.3  loop over all a in this symmetry
c
       if (aalfayes.eq.1) then
       aup=nva(syma)
       else
       aup=nvb(syma)
       end if
c
       do 2500 a=1,aup
c
       if (h1lenght.gt.0) then
c
c3.3.1read H1 if any
       call rea (lunw3xxxx,h1lenght,wrk(possh10))
c
c3.3.2insert H1 into V1 for given a and syma
       call add (wrk,wrksize,
     & 3,4,1,3,a,0,syma,1,1.0d0,mapdh1,syma,mapdv1,mapiv1,1,
     &           rc)
c
       end if
c
 2500   continue
c
 3000   continue
c
c4    close lunw3xxxx file
       call filemanager (3,lunw3xxxx,rc)
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************

subroutine Rot_st(cMO_s,cMO_t,nBasis,Gamma_rot,Debug)
! Author: Y. Carissan.

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBasis
real(kind=wp), intent(inout) :: cMO_s(nBasis), cMO_t(nBasis)
real(kind=wp), intent(in) :: Gamma_rot
logical(kind=iwp), intent(in) :: Debug
integer(kind=iwp) :: iBas
real(kind=wp) :: cosGamma_rot, cs, ct, sinGamma_rot

if (Gamma_rot == Zero) return

cosGamma_rot = cos(Gamma_rot)
sinGamma_rot = sin(Gamma_rot)
if (Debug) then
  write(u6,*) 'cos(Gamma)=',cosGamma_rot
  write(u6,*) 'sin(Gamma)=',sinGamma_rot
end if

do iBas=1,nBasis
  cs = cMO_s(iBas)
  ct = cMO_t(iBas)
  cMO_s(iBas) = cosGamma_rot*cs+sinGamma_rot*ct
  cMO_t(iBas) = -sinGamma_rot*cs+cosGamma_rot*ct
end do

return

end subroutine Rot_st

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine IIJJ_CPF(ICASE,JSY,HDIAG,FC,FIJ,FJI)

use cpf_global, only: ILIM, IRC, IROW, LN, LSYM, Lu_27, NSM, NSYS, NVIRT
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICASE(*), JSY(*)
real(kind=wp), intent(_OUT_) :: HDIAG(*)
real(kind=wp), intent(in) :: FC(*), FIJ(*), FJI(*)
integer(kind=iwp) :: I, IA, IAD27, IAV, IB, IBV, II, IJ, IND, IOC(55), IR, IRL, J, JOJ, NA, NA1, NA2, NB, NB1, NB2, NSA, NSS
real(kind=wp) :: SUM1, SUM2, TERM
integer(kind=iwp), external :: ICUNP, JSUNP

IAD27 = 0
IRL = IRC(ILIM)

do IR=1,IRL
  do I=1,LN
    JOJ = ICUNP(ICASE,I+LN*(IR-1))
    IOC(I) = (JOJ+1)/2
  end do
  NSS = MUL(JSUNP(JSY,IR),LSYM)

  SUM1 = Zero
  do I=1,LN
    if (IOC(I) /= 0) then
      do J=1,I-1
        IJ = (I*(I-1))/2+J
        if (IOC(J) /= 0) then
          TERM = IOC(I)*(IOC(J)*FIJ(IJ)-FJI(IJ))
          SUM1 = SUM1+TERM
        end if
      end do
      II = (I*(I+1))/2
      TERM = (IOC(I)-1)*FIJ(II)+IOC(I)*FC(II)
      SUM1 = SUM1+TERM
    end if
  end do

  if (IR <= IRC(1)) then

    ! IR=1..IRC(1), HDIAG(IR)=SUM1
    HDIAG(IR) = SUM1
    if (IR == IRC(1)) call dDAFILE(Lu_27,1,HDIAG,IRC(1),IAD27)

  else if (IR <= IRC(2)) then

    ! IR=IRC(1)+1 ... IRC(2)
    IND = 0
    NA1 = NSYS(NSS)+1
    NA2 = NSYS(NSS+1)
    if (NA2 >= NA1) then
      do NA=NA1,NA2
        IND = IND+1
        IA = IROW(LN+NA)
        SUM2 = SUM1+FC(IA+LN+NA)
        do I=1,LN
          if (IOC(I) /= 0) SUM2 = SUM2+IOC(I)*FIJ(IA+I)-FJI(IA+I)
        end do
        HDIAG(IND) = SUM2
      end do
      call dDAFILE(Lu_27,1,HDIAG,IND,IAD27)
    end if

  else

    ! IR=IRC(2)+1 ... IRC(ILIM)
    IND = 0
    do NA=1,NVIRT
      NSA = MUL(NSS,NSM(LN+NA))
      NB1 = NSYS(NSA)+1
      NB2 = NSYS(NSA+1)
      if (NB2 > NA) NB2 = NA
      if (NB2 >= NB1) then
        IA = IROW(LN+NA)
        IAV = IA+LN
        do NB=NB1,NB2
          IND = IND+1
          IB = IROW(LN+NB)
          IBV = IB+LN
          TERM = SUM1+FIJ(IAV+NB)+FC(IAV+NA)+FC(IBV+NB)
          if (IR <= IRC(3)) SUM2 = TERM-FJI(IAV+NB)
          if (IR > IRC(3)) SUM2 = TERM+FJI(IAV+NB)
          do I=1,LN
            if (IOC(I) /= 0) then
              TERM = IOC(I)*(FIJ(IA+I)+FIJ(IB+I))-FJI(IA+I)-FJI(IB+I)
              SUM2 = SUM2+TERM
            end if
          end do
          HDIAG(IND) = SUM2
        end do
      end if
    end do
    if (IND > 0) call dDAFILE(Lu_27,1,HDIAG,IND,IAD27)

  end if
end do

return

end subroutine IIJJ_CPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!**********************************************************************

subroutine caxpy(n,ca,cx,incx,cy,incy)
use link_blas, only: lb_caxpy
use Definitions, only: BLASInt, BLASR4
implicit none
complex(kind=BLASR4) :: ca
integer(kind=BLASInt) :: incx, incy, n
complex(kind=BLASR4) :: cx(*), cy(*)
call lb_caxpy(n,ca,cx,incx,cy,incy)
end subroutine caxpy

subroutine cgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
use link_blas, only: lb_cgemm
use Definitions, only: BLASInt, BLASR4
implicit none
complex(kind=BLASR4) :: alpha, beta
integer(kind=BLASInt) :: k, lda, ldb, ldc, m, n
character :: transa, transb
complex(kind=BLASR4) :: a(lda,*), b(ldb,*), c(ldc,*)
call lb_cgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine cgemm

function dasum(n,dx,incx)
use link_blas, only: lb_dasum
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
real(kind=BLASR8) :: dx(*)
real(kind=BLASR8) :: dasum
dasum = lb_dasum(n,dx,incx)
end function dasum

subroutine daxpy(n,da,dx,incx,dy,incy)
use link_blas, only: lb_daxpy
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: da
integer(kind=BLASInt) :: incx, incy, n
real(kind=BLASR8) :: dx(*), dy(*)
call lb_daxpy(n,da,dx,incx,dy,incy)
end subroutine daxpy

function dcabs1(z)
use link_blas, only: lb_dcabs1
use Definitions, only: BLASR8
implicit none
complex(kind=BLASR8) :: z
real(kind=BLASR8) :: dcabs1
dcabs1 = lb_dcabs1(z)
end function dcabs1

subroutine dcopy(n,dx,incx,dy,incy)
use link_blas, only: lb_dcopy
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, incy, n
real(kind=BLASR8) :: dx(*), dy(*)
call lb_dcopy(n,dx,incx,dy,incy)
end subroutine dcopy

function ddot(n,x,dx,y,dy)
use link_blas, only: lb_ddot
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: n, dx, dy
real(kind=BLASR8) :: x(*), y(*)
real(kind=BLASR8) :: ddot
ddot = lb_ddot(n,x,dx,y,dy)
end function ddot

subroutine dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
use link_blas, only: lb_dgemm
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: k, lda, ldb, ldc, m, n
character :: transa, transb
real(kind=BLASR8) :: a(lda,*), b(ldb,*), c(ldc,*)
call lb_dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine dgemm

subroutine dgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
use link_blas, only: lb_dgemv
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: incx, incy, lda, m, n
character :: trans
real(kind=BLASR8) :: a(lda,*), x(*), y(*)
call lb_dgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
end subroutine dgemv

subroutine dger(m,n,alpha,x,incx,y,incy,a,lda)
use link_blas, only: lb_dger
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: incx, incy, lda, m, n
real(kind=BLASR8) :: a(lda,*), x(*), y(*)
call lb_dger(m,n,alpha,x,incx,y,incy,a,lda)
end subroutine dger

function dnrm2(n,x,incx)
use link_blas, only: lb_dnrm2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
real(kind=BLASR8) :: x(*)
real(kind=BLASR8) :: dnrm2
dnrm2 = lb_dnrm2(n,x,incx)
end function dnrm2

subroutine drot(n,dx,incx,dy,incy,c,s)
use link_blas, only: lb_drot
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: c, s
integer(kind=BLASInt) :: incx, incy, n
real(kind=BLASR8) :: dx(*), dy(*)
call lb_drot(n,dx,incx,dy,incy,c,s)
end subroutine drot

subroutine dscal(n,da,dx,incx)
use link_blas, only: lb_dscal
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: da
integer(kind=BLASInt) :: incx, n
real(kind=BLASR8) :: dx(*)
call lb_dscal(n,da,dx,incx)
end subroutine dscal

subroutine dspmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
use link_blas, only: lb_dspmv
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: incx, incy, n
character :: uplo
real(kind=BLASR8) :: ap(*), x(*), y(*)
call lb_dspmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
end subroutine dspmv

subroutine dspr(uplo,n,alpha,x,incx,ap)
use link_blas, only: lb_dspr
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: incx, n
character :: uplo
real(kind=BLASR8) :: ap(*), x(*)
call lb_dspr(uplo,n,alpha,x,incx,ap)
end subroutine dspr

subroutine dspr2(uplo,n,alpha,x,incx,y,incy,ap)
use link_blas, only: lb_dspr2
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: incx, incy, n
character :: uplo
real(kind=BLASR8) :: ap(*), x(*), y(*)
call lb_dspr2(uplo,n,alpha,x,incx,y,incy,ap)
end subroutine dspr2

subroutine dswap(n,dx,incx,dy,incy)
use link_blas, only: lb_dswap
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, incy, n
real(kind=BLASR8) :: dx(*), dy(*)
call lb_dswap(n,dx,incx,dy,incy)
end subroutine dswap

subroutine dsymm(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
use link_blas, only: lb_dsymm
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: lda, ldb, ldc, m, n
character :: side, uplo
real(kind=BLASR8) :: a(lda,*), b(ldb,*), c(ldc,*)
call lb_dsymm(side,uplo,m,n,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine dsymm

subroutine dsymv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
use link_blas, only: lb_dsymv
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: incx, incy, lda, n
character :: uplo
real(kind=BLASR8) :: a(lda,*), x(*), y(*)
call lb_dsymv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
end subroutine dsymv

subroutine dsyr2(uplo,n,alpha,x,incx,y,incy,a,lda)
use link_blas, only: lb_dsyr2
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: incx, incy, lda, n
character :: uplo
real(kind=BLASR8) :: a(lda,*), x(*), y(*)
call lb_dsyr2(uplo,n,alpha,x,incx,y,incy,a,lda)
end subroutine dsyr2

subroutine dsyr2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
use link_blas, only: lb_dsyr2k
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: k, lda, ldb, ldc, n
character :: trans, uplo
real(kind=BLASR8) :: a(lda,*), b(ldb,*), c(ldc,*)
call lb_dsyr2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine dsyr2k

subroutine dsyrk(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
use link_blas, only: lb_dsyrk
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: k, lda, ldc, n
character :: trans, uplo
real(kind=BLASR8) :: a(lda,*), c(ldc,*)
call lb_dsyrk(uplo,trans,n,k,alpha,a,lda,beta,c,ldc)
end subroutine dsyrk

subroutine dtpmv(uplo,trans,diag,n,ap,x,incx)
use link_blas, only: lb_dtpmv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
character :: diag, trans, uplo
real(kind=BLASR8) :: ap(*), x(*)
call lb_dtpmv(uplo,trans,diag,n,ap,x,incx)
end subroutine dtpmv

subroutine dtpsv(uplo,trans,diag,n,ap,x,incx)
use link_blas, only: lb_dtpsv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
character :: diag, trans, uplo
real(kind=BLASR8) :: ap(*), x(*)
call lb_dtpsv(uplo,trans,diag,n,ap,x,incx)
end subroutine dtpsv

subroutine dtrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
use link_blas, only: lb_dtrmm
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: lda, ldb, m, n
character :: diag, side, transa, uplo
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dtrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
end subroutine dtrmm

subroutine dtrmv(uplo,trans,diag,n,a,lda,x,incx)
use link_blas, only: lb_dtrmv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, lda, n
character :: diag, trans, uplo
real(kind=BLASR8) :: a(lda,*), x(*)
call lb_dtrmv(uplo,trans,diag,n,a,lda,x,incx)
end subroutine dtrmv

subroutine dtrsm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
use link_blas, only: lb_dtrsm
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: lda, ldb, m, n
character :: diag, side, transa, uplo
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dtrsm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
end subroutine dtrsm

subroutine dtrsv(uplo,trans,diag,n,a,lda,x,incx)
use link_blas, only: lb_dtrsv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, lda, n
character :: diag, trans, uplo
real(kind=BLASR8) :: a(lda,*), x(*)
call lb_dtrsv(uplo,trans,diag,n,a,lda,x,incx)
end subroutine dtrsv

function dznrm2(n,x,incx)
use link_blas, only: lb_dznrm2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
complex(kind=BLASR8) :: x(*)
real(kind=BLASR8) :: dznrm2
dznrm2 = lb_dznrm2(n,x,incx)
end function dznrm2

function idamax(n,dx,incx)
use link_blas, only: lb_idamax
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
real(kind=BLASR8) :: dx(*)
integer(kind=BLASInt) :: idamax
idamax = lb_idamax(n,dx,incx)
end function idamax

function lsame(ca,cb)
use link_blas, only: lb_lsame
implicit none
character :: ca, cb
logical :: lsame
lsame = lb_lsame(ca,cb)
end function lsame

subroutine saxpy(n,sa,sx,incx,sy,incy)
use link_blas, only: lb_saxpy
use Definitions, only: BLASInt, BLASR4
implicit none
real(kind=BLASR4) :: sa
integer(kind=BLASInt) :: incx, incy, n
real(kind=BLASR4) :: sx(*), sy(*)
call lb_saxpy(n,sa,sx,incx,sy,incy)
end subroutine saxpy

function scabs1(z)
use link_blas, only: lb_scabs1
use Definitions, only: BLASR4
implicit none
complex(kind=BLASR4) :: z
real(kind=BLASR4) :: scabs1
scabs1 = lb_scabs1(z)
end function scabs1

subroutine scopy(n,sx,incx,sy,incy)
use link_blas, only: lb_scopy
use Definitions, only: BLASInt, BLASR4
implicit none
integer(kind=BLASInt) :: incx, incy, n
real(kind=BLASR4) :: sx(*), sy(*)
call lb_scopy(n,sx,incx,sy,incy)
end subroutine scopy

subroutine sgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
use link_blas, only: lb_sgemm
use Definitions, only: BLASInt, BLASR4
implicit none
real(kind=BLASR4) :: alpha, beta
integer(kind=BLASInt) :: k, lda, ldb, ldc, m, n
character :: transa, transb
real(kind=BLASR4) :: a(lda,*), b(ldb,*), c(ldc,*)
call lb_sgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine sgemm

subroutine xerbla(srname,info)
use link_blas, only: lb_xerbla
use Definitions, only: BLASInt
implicit none
character(len=*) :: srname
integer(kind=BLASInt) :: info
call lb_xerbla(srname,info)
end subroutine xerbla

subroutine zaxpy(n,za,zx,incx,zy,incy)
use link_blas, only: lb_zaxpy
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: za
integer(kind=BLASInt) :: incx, incy, n
complex(kind=BLASR8) :: zx(*), zy(*)
call lb_zaxpy(n,za,zx,incx,zy,incy)
end subroutine zaxpy

subroutine zcopy(n,zx,incx,zy,incy)
use link_blas, only: lb_zcopy
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, incy, n
complex(kind=BLASR8) :: zx(*), zy(*)
call lb_zcopy(n,zx,incx,zy,incy)
end subroutine zcopy

function zdotc(n,zx,incx,zy,incy)
use link_blas, only: lb_zdotc
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, incy, n
complex(kind=BLASR8) :: zx(*), zy(*)
complex(kind=BLASR8) :: zdotc
zdotc = lb_zdotc(n,zx,incx,zy,incy)
end function zdotc

subroutine zdscal(n,da,zx,incx)
use link_blas, only: lb_zdscal
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: da
integer(kind=BLASInt) :: incx, n
complex(kind=BLASR8) :: zx(*)
call lb_zdscal(n,da,zx,incx)
end subroutine zdscal

subroutine zdrot(n,cx,incx,cy,incy,c,s)
use link_blas, only: lb_zdrot
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, incy, n
real(kind=BLASR8) :: c, s
complex(kind=BLASR8) :: cx(*), cy(*)
call lb_zdrot(n,cx,incx,cy,incy,c,s)
end subroutine zdrot

subroutine zgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
use link_blas, only: lb_zgemm
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: k, lda, ldb, ldc, m, n
character :: transa, transb
complex(kind=BLASR8) :: a(lda,*), b(ldb,*), c(ldc,*)
call lb_zgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine zgemm

subroutine zgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
use link_blas, only: lb_zgemv
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: incx, incy, lda, m, n
character :: trans
complex(kind=BLASR8) :: a(lda,*), x(*), y(*)
call lb_zgemv(trans,m,n,alpha,a,lda,x,incx,beta,y,incy)
end subroutine zgemv

subroutine zgerc(m,n,alpha,x,incx,y,incy,a,lda)
use link_blas, only: lb_zgerc
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: incx, incy, lda, m, n
complex(kind=BLASR8) :: a(lda,*), x(*), y(*)
call lb_zgerc(m,n,alpha,x,incx,y,incy,a,lda)
end subroutine zgerc

subroutine zhemv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
use link_blas, only: lb_zhemv
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: incx, incy, lda, n
character :: uplo
complex(kind=BLASR8) :: a(lda,*), x(*), y(*)
call lb_zhemv(uplo,n,alpha,a,lda,x,incx,beta,y,incy)
end subroutine zhemv

subroutine zher2(uplo,n,alpha,x,incx,y,incy,a,lda)
use link_blas, only: lb_zher2
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: incx, incy, lda, n
character :: uplo
complex(kind=BLASR8) :: a(lda,*), x(*), y(*)
call lb_zher2(uplo,n,alpha,x,incx,y,incy,a,lda)
end subroutine zher2

subroutine zher2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
use link_blas, only: lb_zher2k
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: alpha
real(kind=BLASR8) :: beta
integer(kind=BLASInt) :: k, lda, ldb, ldc, n
character :: trans, uplo
complex(kind=BLASR8) :: a(lda,*), b(ldb,*), c(ldc,*)
call lb_zher2k(uplo,trans,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
end subroutine zher2k

subroutine zhpmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
use link_blas, only: lb_zhpmv
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: incx, incy, n
character :: uplo
complex(kind=BLASR8) :: ap(*), x(*), y(*)
call lb_zhpmv(uplo,n,alpha,ap,x,incx,beta,y,incy)
end subroutine zhpmv

subroutine zhpr2(uplo,n,alpha,x,incx,y,incy,ap)
use link_blas, only: lb_zhpr2
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: incx, incy, n
character :: uplo
complex(kind=BLASR8) :: ap(*), x(*), y(*)
call lb_zhpr2(uplo,n,alpha,x,incx,y,incy,ap)
end subroutine zhpr2

subroutine zscal(n,za,zx,incx)
use link_blas, only: lb_zscal
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: za
integer(kind=BLASInt) :: incx, n
complex(kind=BLASR8) :: zx(*)
call lb_zscal(n,za,zx,incx)
end subroutine zscal

subroutine zswap(n,zx,incx,zy,incy)
use link_blas, only: lb_zswap
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, incy, n
complex(kind=BLASR8) :: zx(*), zy(*)
call lb_zswap(n,zx,incx,zy,incy)
end subroutine zswap

subroutine ztrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
use link_blas, only: lb_ztrmm
use Definitions, only: BLASInt, BLASR8
implicit none
complex(kind=BLASR8) :: alpha
integer(kind=BLASInt) :: lda, ldb, m, n
character :: diag, side, transa, uplo
complex(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_ztrmm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
end subroutine ztrmm

subroutine ztrmv(uplo,trans,diag,n,a,lda,x,incx)
use link_blas, only: lb_ztrmv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, lda, n
character :: diag, trans, uplo
complex(kind=BLASR8) :: a(lda,*), x(*)
call lb_ztrmv(uplo,trans,diag,n,a,lda,x,incx)
end subroutine ztrmv

subroutine ztrsm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
use link_blas, only: lb_ztrsm
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, uplo, transa, diag
integer(kind=BLASInt) :: m, n, lda, ldb
complex(kind=BLASR8) :: alpha, a(lda,*), b(ldb,*)
call lb_ztrsm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
end subroutine ztrsm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine compute_txy(DM1,nDM,Txy,nTxy,nAuxVec,nIrrep,Diag,
     &                       DMTmp,nAct)
************************************************************************
*                                                                      *
*     Compute the matrices needed for CD-CASSCF gradients              *
*                                                                      *
*     input : G2    = 2-body density matrix                           *
*             nDM    = size of the one-body DM                         *
*                                                                      *
************************************************************************
      use pso_stuff, only: lsa, G2, nnP
      Implicit none
#include "real.fh"
      Integer nTxy,nAct(0:7),nCumAct(0:7),nCumAct2(0:7)
      Integer nDM,i,j,icol,iline
      Integer ista,iend,jsta,jend,ksta,kend,lsta,lend,isym,jsym,
     &        ksym,lsym,klsym,it,iu,iv,ix,itu,ivx,ituvx,ituvx2,
     &        nvx,itx,itv,iuv,iux,nkl,Txy_sta,Txy_sta2
      Integer nAuxVec,iVec,nIrrep
      Real*8 Fac,Fac2,tmp
      Real*8 DM1(nDM,nAuxVec),
     &       Txy(nTxy,nAuxVec),Diag(nDM,nAuxVec),
     &       DMtmp(nDM*(nDM+1)/2)
      Logical debug
      debug=.true.
      debug=.false.
*
      nCumAct(0)=0
      Do i=1,nIrrep-1
        nCumAct(i)=nCumAct(i-1)+nAct(i-1)
      End Do
*
      Do iVec=1,nAuxVec
************************************************************************
*                                                                      *
*     Remove Coulomb and exchange contribution from the 2DM            *
*                                                                      *
************************************************************************
         Txy_sta=1
         Txy_sta2=1
         Do klsym=0,nIrrep-1 ! compound symmetry
           nkl=0
*
           Do lSym=0,nIrrep-1
             lsta=nCumAct(lsym)+1
             lend=nCumAct(lsym)+nAct(lSym)

             ksym=iEOR(lsym,klsym)
             If (ksym.gt.lsym) Go To 100
             ksta=nCumAct(ksym)+1
             kend=nCumAct(ksym)+nAct(ksym)
             If (kSym.eq.lSym) Then
                nvx=nAct(lSym)*(nAct(lSym)+1)/2
             Else
                nvx=nAct(lSym)*nAct(ksym)
             EndIf
             nCumAct2(lSym)=nkl
*
             Do jsym=0,lSym
*
               jsta=nCumAct(jsym)+1
               jend=nCumAct(jsym)+nAct(jSym)

               isym=iEOR(jsym,klsym)
               If (isym.gt.jsym) Go To 101
               ista=nCumAct(iSym)+1
               iend=nCumAct(iSym)+nAct(iSym)
*
               iline=nkl
*
               Do ix=lsta,lend
                 If (kSym.eq.lSym) kend=ix
                 Do iv=ksta,kend
                   ivx=max(ix,iv)*(max(ix,iv)-1)/2+min(ix,iv)
                   If (jSym.eq.lSym) jend=ix
                   iline=iline+1
                   icol=nCumAct2(jSym)
                   Do iu=jsta,jend
                     iux=max(ix,iu)*(max(ix,iu)-1)/2+min(ix,iu)
                     iuv=max(iu,iv)*(max(iu,iv)-1)/2+min(iu,iv)
                     If (iSym.eq.jSym) iend=iu
                     Do it=ista,iend
                       itu=max(iu,it)*(max(iu,it)-1)/2+min(iu,it)
                       If (itu.gt.ivx) Go to 102
                       itx=max(ix,it)*(max(ix,it)-1)/2+min(ix,it)
                       itv=max(iv,it)*(max(iv,it)-1)/2+min(iv,it)
                       ituvx=max(ivx,itu)*(max(ivx,itu)-1)/2+
     &                      min(itu,ivx)
                       icol=icol+1
                       ituvx2=iline*(iline-1)/2+icol
*
                       Fac=One
                       If (ix.ne.iv) Fac=Two*Fac
                       If (it.ne.iu) Fac=Two*Fac
                       Fac2=One
                       If (it.eq.iu) Fac2=Two
*
                       DMTmp(ituvx2)=Fac*(Fac2*G2(ituvx,iVec))
                       If (.Not.lSA) Then
*For SA-CASSCF, don't remove Coulomb and exchange
                         If (iSym.eq.jSym)
     &                      DMTmp(ituvx2)=DMTmp(ituvx2)-
     &                         Fac*(DM1(itu,iVec)*DM1(ivx,iVec))
                         If (iSym.eq.kSym)
     &                      DMTmp(ituvx2)=DMTmp(ituvx2)+
     &                         Fac*(Quart*DM1(itv,iVec)*DM1(iux,iVec))
                         If (iSym.eq.lSym)
     &                      DMTmp(ituvx2)=DMTmp(ituvx2)+
     &                         Fac*(Quart*DM1(itx,iVec)*DM1(iuv,iVec))
                       EndIf
*
 102                   Continue
*
                     End Do
                   End Do
                 End Do
               End Do
*
 101           Continue
             End Do
             nkl=nkl+nvx
 100         Continue
           End Do
*
************************************************************************
*                                                                      *
*     Eigen-decompose the density                                      *
*                                                                      *
************************************************************************
*
**       Diagonalize G2
*
           Call Cho_DZero(Txy(Txy_sta2,iVec),nkl**2)
           call dcopy_(nkl,[One],0,Txy(Txy_sta2,iVec),nkl+1)
*
           Call NIdiag(DMTmp,Txy(Txy_sta2,iVec),nkl,nkl,0)
*
**       Multiply by Sqrt[eigenvalue]
*
           Do i=1,nkl
             Diag(i+Txy_sta-1,iVec)=DMTmp(i*(i+1)/2)
             tmp=Sqrt(abs(DMTmp(i*(i+1)/2)))
             Do j=1,nkl
                Txy(Txy_sta2+(i-1)*nkl+j-1,iVec)=
     &              Txy(Txy_sta2+(i-1)*nkl+j-1,iVec)*tmp
             End Do
           End Do
*
**       Since there is no screening yet
*
           nnP(klsym)=nkl
*
           Txy_sta=Txy_sta+nkl
           Txy_sta2=Txy_sta2+nkl**2
         End Do
      End Do
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_DBGINT_CHO(XINT,NCD,NAB,WRK,LWRK,
     &                          ERRMAX,ERRMIN,ERRRMS,NCMP,
     &                          ISHLCD,ISHLAB)
C
C     Purpose: calculate integrals in shell quadruple (CD|AB) from
C              Cholesky vectors on disk and compare to those in
C              XINT (for debugging).
C
C     NOTE: this is *only* for debugging.
C
      use ChoArr, only: nBstSh, iSP2F
      use ChoSwp, only: nnBstRSh, iiBstRSh, IndRed
#include "implicit.fh"
      DIMENSION XINT(NCD,NAB), WRK(LWRK)
#include "cholesky.fh"

      CHARACTER*14 SECNAM
      PARAMETER (SECNAM = 'CHO_DBGINT_CHO')

      INTEGER  CHO_LREAD
      EXTERNAL CHO_LREAD

C     Initializations.
C     ----------------


      CALL CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.TRUE.)
      CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.TRUE.)
      ERRMAX = -1.0D12
      ERRMIN =  1.0D12
      ERRRMS = 0.0D0
      NCMP   = 0
      LCDABT = NCD*NAB

      IF (ISHLC .EQ. ISHLD) THEN
         NCDL = NBSTSH(ISHLC)*(NBSTSH(ISHLC) + 1)/2
      ELSE
         NCDL = NBSTSH(ISHLC)*NBSTSH(ISHLD)
      END IF
      IF (ISHLA .EQ. ISHLB) THEN
         NABL = NBSTSH(ISHLA)*(NBSTSH(ISHLA) + 1)/2
      ELSE
         NABL = NBSTSH(ISHLA)*NBSTSH(ISHLB)
      END IF
      IF (NCDL .GT. NCD) CALL CHO_QUIT('NCD error in '//SECNAM,104)
      IF (NABL .GT. NAB) CALL CHO_QUIT('NAB error in '//SECNAM,104)
      IF (NAB.LT.1 .OR. NCD.LT.1) RETURN

C     Save read-call counter.
C     -----------------------

      NSCALL = NSYS_CALL

C     Get a copy of XINT.
C     -------------------

      KXINT = 1
      KEND0 = KXINT + LCDABT
      LWRK0 = LWRK  - KEND0
      IF (LWRK0 .LE. 0) THEN
         CALL CHO_QUIT('Insufficient memory in '//SECNAM//' [0]',101)
      END IF

      CALL DCOPY_(LCDABT,XINT,1,WRK(KXINT),1)

C     Start symmetry loop.
C     --------------------

      DO ISYM = 1,NSYM

         NUMCD = NNBSTRSH(ISYM,ISHLCD,2)
         NUMAB = NNBSTRSH(ISYM,ISHLAB,2)

         IF (NUMCD.GT.0 .AND. NUMAB.GT.0 .AND. NUMCHO(ISYM).GT.0) THEN

C           Allocate space for integrals and for Cholesky reading.
C           ------------------------------------------------------

            LENint = NUMCD*NUMAB
            LREAD  = CHO_LREAD(ISYM,LWRK)
            LVEC1  = NNBSTR(ISYM,2)

            KINT  = KEND0
            KREAD = KINT  + LENint
            KVEC1 = KREAD + LREAD
            KEND1 = KVEC1 + LVEC1
            LWRK1 = LWRK  - KEND1 + 1

            IF (LWRK1 .LE. 0) THEN
               CALL CHO_QUIT('Insufficient memory in '//SECNAM,104)
            END IF

C           Initialize integral array.
C           --------------------------

            CALL FZERO(WRK(KINT),LENint)

C           Set up batch over Cholesky vectors.
C           -----------------------------------

            MINM = NUMCD + NUMAB
            NVEC = MIN(LWRK1/MINM,NUMCHO(ISYM))
            IF (NVEC .LT. 1) THEN
               CALL CHO_QUIT('Batch problem in '//SECNAM,104)
            END IF
            NBATCH = (NUMCHO(ISYM) - 1)/NVEC + 1

C           Start batch loop.
C           -----------------

            DO IBATCH = 1,NBATCH

               IF (IBATCH .EQ. NBATCH) THEN
                  NUMV = NUMCHO(ISYM) - NVEC*(NBATCH - 1)
               ELSE
                  NUMV = NVEC
               END IF
               JVEC1 = NVEC*(IBATCH - 1) + 1

               KCHOCD = KEND1
               KCHOAB = KCHOCD + NUMCD*NUMV
               KEND2  = KCHOAB + NUMAB*NUMV
               LWRK2  = LWRK   - KEND2 + 1

               IF (LWRK2 .LT. 0) THEN
                  CALL CHO_QUIT('Batch error in '//SECNAM,104)
               END IF

C              Read vectors.
C              -------------

               DO IVEC = 1,NUMV
                  JVEC = JVEC1 + IVEC - 1
                  CALL CHO_GETVEC(WRK(KVEC1),LVEC1,1,JVEC,ISYM,
     &                            WRK(KREAD),LREAD)
                  KOFF1 = KVEC1  + IIBSTRSH(ISYM,ISHLCD,2)
                  KOFF2 = KCHOCD + NUMCD*(IVEC - 1)
                  CALL DCOPY_(NUMCD,WRK(KOFF1),1,WRK(KOFF2),1)
                  KOFF1 = KVEC1  + IIBSTRSH(ISYM,ISHLAB,2)
                  KOFF2 = KCHOAB + NUMAB*(IVEC - 1)
                  CALL DCOPY_(NUMAB,WRK(KOFF1),1,WRK(KOFF2),1)
               END DO

C              Calculate contribution.
C              -----------------------

               CALL DGEMM_('N','T',NUMCD,NUMAB,NUMV,
     &                    1.0D0,WRK(KCHOCD),NUMCD,WRK(KCHOAB),NUMAB,
     &                    1.0D0,WRK(KINT),NUMCD)

            END DO

C           Subtract contribution from full shell pair.
C           -------------------------------------------

            DO IAB = 1,NUMAB
               JAB = IIBSTR(ISYM,2) + IIBSTRSH(ISYM,ISHLAB,2) + IAB
               KAB = INDRED(INDRED(JAB,2),1)
               DO ICD = 1,NUMCD
                  JCD = IIBSTR(ISYM,2) + IIBSTRSH(ISYM,ISHLCD,2) + ICD
                  KCD = INDRED(INDRED(JCD,2),1)
                  ICDAB = KINT  + NUMCD*(IAB - 1) + ICD - 1
                  KCDAB = KXINT + NCD*(KAB - 1)   + KCD - 1
                  WRK(KCDAB) = WRK(KCDAB) - WRK(ICDAB)
               END DO
            END DO

         END IF

      END DO

C     Compare full shell pair.
C     ------------------------

      DO KAB = 1,NAB
         DO KCD = 1,NCD
            KCDAB = KXINT + NCD*(KAB - 1) + KCD - 1
            DIFF  = WRK(KCDAB)
            NCMP  = NCMP + 1
            IF (NCMP .EQ. 1) THEN
               ERRMAX = DIFF
               ERRMIN = DIFF
            ELSE
               IF (ABS(DIFF) .GT. ABS(ERRMAX)) THEN
                  ERRMAX = DIFF
               END IF
               IF (ABS(DIFF) .LT. ABS(ERRMIN)) THEN
                  ERRMIN = DIFF
               END IF
            END IF
            ERRRMS = ERRRMS + DIFF*DIFF
         END DO
      END DO

C     Restore read-call counter.
C     --------------------------

      NSYS_CALL = NSCALL

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gencoul(l1,l2,l3,l4,makemean,bonn,breit,sameorb,cont4SO,cont4OO,icont4,powexp,coulovlp)
!bs SUBROUTINE to generate all required radial
!bs integrals for the four angular momenta l1-l4

use AMFI_global, only: exponents, Lblocks, Lfirst, Llast, Lmax, Lstarter, Lvalues, MxprimL, nblock, ncontrac, nprimit
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: l1, l2, l3, l4, icont4
logical(kind=iwp), intent(in) :: makemean, bonn, breit, sameorb
real(kind=wp), intent(_OUT_) :: cont4SO(*), cont4OO(*)
real(kind=wp), intent(in) :: powexp(MxprimL,MxprimL,0:Lmax,0:Lmax,0:(Lmax+Lmax+5)), coulovlp(*)
integer(kind=iwp) :: incl1, incl3, ipow1, ipow2, istart, istart2, Lanf, Lend, Lrun, nanz, nprimprod
real(kind=wp), allocatable :: Prim(:), Quot1(:), Quot2(:), QuotP1(:), QuotP2(:), Scr1(:), Scr2(:)

!bs first of all, this routine determines, for which L
!bs values the radial integrals have to be solved
!bs initialize the number of blocks for the different
!bs l-combinations
!bs no (ss|ss) contributions
if ((l1 == 0) .and. (l2 == 0) .and. (l3 == 0) .and. (l4 == 0)) return
! no integrals for <ss|ss>
if (makemean) then
  nblock = 1  ! sp sp are the first, so the first block
  Lstarter(1) = 1
else
  call SysAbendMsg('gencoul','only mean-field with this version',' ')
end if
!bs keep track of L-values for later purposes
Lvalues(1) = l1
Lvalues(2) = l2
Lvalues(3) = l3
Lvalues(4) = l4
!bs now nanz is given the new value
nanz = ncontrac(l1)*ncontrac(l2)*ncontrac(l3)*ncontrac(l4)
nprimprod = nprimit(l1)*nprimit(l2)*nprimit(l3)*nprimit(l4)

call mma_allocate(Quot1,nPrimProd,Label='Quot1')
call mma_allocate(Quot2,nPrimProd,Label='Quot2')
call mma_allocate(QuotP1,nPrimProd,Label='QuotP1')
call mma_allocate(QuotP2,nPrimProd,Label='QuotP2')
call mma_allocate(Prim,nPrimProd,Label='Prim')
call mma_allocate(Scr1,nPrimProd,Label='Scr1')
call mma_allocate(Scr2,nPrimProd,Label='Scr2')

call initfrac(nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4),Quot1,Quot2,exponents(:,l1),exponents(:,l2),exponents(:,l3), &
              exponents(:,l4))
!bs prepare the powers needed for cfunctx
!
! There are seven different CASES of integrals following
!   (   A  --  C)
!
! The structure is the same for all cases, therefore comments can be found only on case A

!bs ####################################################################
!bs   the (+2) cases          CASE A
!bs ####################################################################
incl1 = 1  !  Those increments define the case
incl3 = 1
!bs determine the possible L-values for the integrals by checking for triangular equation

call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)

!bs returns first and last L-values (Lanf,Lend), for which
!bs radial integrals have to be calculated
if (Lend-Lanf >= 0) then
  !bs if there are blocks
  Lblocks(1) = (Lend-Lanf)/2+1 ! L increases in steps of 2, due to parity conservation
  Lfirst(1) = Lanf
  Llast(1) = Lend
else
  Lblocks(1) = 0
end if
if (Lblocks(1) > 0) then    ! integrals have to be calculated
  !bs### check, whether integrals fit on array ################
  if (Lstarter(1)+nanz*Lblocks(1) > icont4) then
    write(u6,*) 'end at: ',Lstarter(1)+nanz*Lblocks(1)
    call SysAbendMsg('gencoul','increase icont4 in amfi.f',' ')
  end if
  !bs### check, whether integrals fit on array ################
  istart = Lstarter(1)
  ! gives the address, where to write the contracted integrals
  !bs ipow1 and ipow2 are the the numbers of powers in the prefactor
  !bs of the function Cfunct
  !bs now loop over possible L-values
  do Lrun=Lfirst(1),Llast(1),2
    ipow1 = 2+(l2+l4+Lrun)/2
    ipow2 = 2+(l1+l3+incl1+incl3+Lrun)/2
    !b those powers have to be generated...
    QuotP1(:) = Quot1(:)**(real(ipow1,kind=wp)-Half)
    !bs those powers have to be generated...
    QuotP2(:) = Quot2(:)**(real(ipow2,kind=wp)-Half)
    ! in buildcoul the radial integrals are calculated
    call buildcoul(l1,l2,l3,l4,incl1,incl3,Lrun,Prim,nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4),exponents(:,l1), &
                   exponents(:,l2),exponents(:,l3),exponents(:,l4),powexp(:,:,l3,l1,lrun),powexp(:,:,l4,l2,lrun),QuotP1,QuotP2, &
                   coulovlp)
    !bs in the contcas_ routines the integrals are contracted, including exponents as prefactors...
    if (bonn .or. breit .or. sameorb) then
      call contcasASO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4SO)
    else
      call contcasASO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4SO)
      call contcasAOO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4OO)
    end if
    istart = istart+nanz! start for next block  contr integr.
  end do
end if
!bs ####################################################################
!bs   the (0) cases         CASE  B
!bs ####################################################################
incl1 = 0
incl3 = 0
call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
if (Lend-Lanf >= 0) then
  Lblocks(2) = (Lend-Lanf)/2+1
  Lfirst(2) = Lanf
  Llast(2) = Lend
  Lblocks(3) = (Lend-Lanf)/2+1
  Lfirst(3) = Lanf
  Llast(3) = Lend
else
  Lblocks(2) = 0
  Lblocks(3) = 0
end if
Lstarter(2) = Lstarter(1)+nanz*Lblocks(1)
Lstarter(3) = Lstarter(2)+nanz*Lblocks(2)
!bs primitive integrals are the same for type 2 and 3  !!!!!
if (Lblocks(2) > 0) then
  !bs### check, whether integrals fit on array ################
  if (Lstarter(2)+2*nanz*Lblocks(2) > icont4) then
    write(u6,*) 'end at: ',Lstarter(2)+2*nanz*Lblocks(2)
    call SysAbendMsg('gencoul','increase icont4 in amfi.f',' ')
  end if
  !bs### check, whether integrals fit on array ################
  istart = Lstarter(2)
  istart2 = Lstarter(3)
  do Lrun=Lfirst(2),Llast(2),2
    ipow1 = 2+(l2+l4+Lrun)/2
    ipow2 = 2+(l1+l3+incl1+incl3+Lrun)/2
    QuotP1(:) = Quot1(:)**(real(ipow1,kind=wp)-Half)
    QuotP2(:) = Quot2(:)**(real(ipow2,kind=wp)-Half)
    call buildcoul(l1,l2,l3,l4,incl1,incl3,Lrun,Prim,nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4),exponents(:,l1), &
                   exponents(:,l2),exponents(:,l3),exponents(:,l4),powexp(:,:,l3,l1,lrun),powexp(:,:,l4,l2,lrun),QuotP1,QuotP2, &
                   coulovlp)
    if (bonn .or. breit .or. sameorb) then
      call contcasB1SO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4SO)
      call contcasB2SO(l1,l2,l3,l4,istart2,Prim,Scr1,Scr2,cont4SO)
    else
      call contcasB1SO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4SO)
      call contcasB2SO(l1,l2,l3,l4,istart2,Prim,Scr1,Scr2,cont4SO)
      call contcasB1OO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4OO)
      call contcasB2OO(l1,l2,l3,l4,istart2,Prim,Scr1,Scr2,cont4OO)
    end if
    istart = istart+nanz
    istart2 = istart2+nanz
  end do
end if
!bs ####################################################################
!bs   the (-2) cases      CASE C
!bs ####################################################################
if ((l1 == 0) .or. (l3 == 0)) then
  Lblocks(4) = 0
else
  incl1 = -1
  incl3 = -1
  call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
  if (Lend-Lanf >= 0) then
    Lblocks(4) = (Lend-Lanf)/2+1
    Lfirst(4) = Lanf
    Llast(4) = Lend
  else
    Lblocks(4) = 0
  end if
end if
Lstarter(4) = Lstarter(3)+nanz*Lblocks(3)
if (Lblocks(4) > 0) then
  !bs### check, whether integrals fit on array ################
  if (Lstarter(4)+nanz*Lblocks(4) > icont4) then
    write(u6,*) 'end at: ',Lstarter(4)+nanz*Lblocks(4)
    call SysAbendMsg('gencoul','increase icont4 in amfi.f',' ')
  end if
  !bs### check, whether integrals fit on array ################
  istart = Lstarter(4)
  do Lrun=Lfirst(4),Llast(4),2
    ipow1 = 2+(l2+l4+Lrun)/2
    ipow2 = 2+(l1+l3+incl1+incl3+Lrun)/2
    QuotP1(:) = Quot1(:)**(real(ipow1,kind=wp)-Half)
    QuotP2(:) = Quot2(:)**(real(ipow2,kind=wp)-Half)
    call buildcoul(l1,l2,l3,l4,incl1,incl3,Lrun,Prim,nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4),exponents(:,l1), &
                   exponents(:,l2),exponents(:,l3),exponents(:,l4),powexp(:,:,l3,l1,lrun),powexp(:,:,l4,l2,lrun),QuotP1,QuotP2, &
                   coulovlp)
    if (bonn .or. breit .or. sameorb) then
      call contcasCSO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4SO)
    else
      call contcasCSO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4SO)
      call contcasCOO(l1,l2,l3,l4,istart,prim,Scr1,Scr2,cont4OO)
    end if
    istart = istart+nanz
  end do
end if

call mma_deallocate(Quot2)
call mma_deallocate(Quot1)
call mma_deallocate(QuotP2)
call mma_deallocate(QuotP1)
call mma_deallocate(Prim)
call mma_deallocate(Scr2)
call mma_deallocate(Scr1)

return

end subroutine gencoul

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine realz_cvb(arr,nmax,nread,ifc)
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
      dimension arr(nmax)
      save nbuf
      data nbuf/100/

      i1 = mstackr_cvb(nbuf)
      nread=0
100   call fzero(work(i1),nbuf)
      nleft=nmax-nread
      call real_cvb(work(i1),min(nbuf,nleft),nread1,ifc)
      call fmove_cvb(work(i1),arr(1+nread),nread1)
      nread=nread+nread1
      if(nread1.gt.0)goto 100
      call mfreer_cvb(i1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Markus P. Fuelscher                              *
************************************************************************
      Subroutine CRecPrt(Title,FmtIn,A,nRow,nCol,Type)
************************************************************************
* CRecPrt
*
*> @brief
*>   Write out a matrix on standard output
*> @author M. P. F&uuml;lscher, Lund, 1992
*>
*> @details
*> The matrix \p A of dimension \p nRow &times; \p nCol is printed
*> in output preceded by the character line \p Title. Format of the numerical
*> output is given by \p FmtIn. If \p FmtIn = ``''`` the utility will decide on format
*> for optimal output.
*>
*> @param[in] Title   Title card
*> @param[in] FmtIn   Format statement
*> @param[in] A       A matrix
*> @param[in] nRow    number of rows of \p A
*> @param[in] nCol    number of columns of \p A
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "standard_iounits.fh"
      Character*(*) Title
      Character*(*) FmtIn
      Character*1 Type
      Complex*16 A(nRow,nCol)
      Integer StrnLn
      Parameter (lPaper=120,lMaxTitle=60)
      Character*(lMaxTitle) Line
      Character*20 FMT
*----------------------------------------------------------------------*
      If (nRow*nCol.eq.0) Return
#ifdef _DEBUGPRINT_
C     Call CTrcPrt(Title,FmtIn,A,nRow,nCol,'R')
C     Call CTrcPrt(Title,FmtIn,A,nRow,nCol,'I')
      Return
#endif
*----------------------------------------------------------------------*
*     print the title                                                  *
*----------------------------------------------------------------------*
      lTitle=StrnLn(Title)
      If ( lTitle.gt.0 ) then
         Do 10 i=1,lMaxTitle
             Line(i:i)=' '
10       Continue
         lLeft=1
         Do 20 i=lTitle,1,-1
            If ( Title(i:i).ne.' ' ) lLeft=i
20       Continue
         lLeft=lLeft-1
         Do 25 i=1,lMaxTitle
            If ( i+lLeft.le.lTitle ) Line(i:i)=Title(i+lLeft:i+lLeft)
25       Continue
         Write(LuWr,*)
         If (Type.eq.'R') Then
            Write(LuWr,'(2X,A,A)') Line,' Real Component'
         Else
            Write(LuWr,'(2X,A,A)') Line,' Imaginary Component'
         End If
c         Do 30 i=1,StrnLn(Line)
c            Line(i:i)='-'
c30       Continue
c         Write(LuWr,'(2X,A)') Line
         Write(LuWr,'(2X,A,I5,A,I5)') 'mat. size = ',nRow,'x',nCol
      End If
*----------------------------------------------------------------------*
*     determine the printing format                                    *
*----------------------------------------------------------------------*
      lFmt=Strnln(FmtIn)
      If ( lFmt.ne.0 ) then
         FMT=FmtIn
      Else
         If (Type.eq.'R') Then
         Amax=DBLE(A(1,1))
         Amin=DBLE(A(1,1))
         Do j=1,nCol
            Do i=1,nRow
               Amax=Max(Amax,DBLE(A(i,j)))
               Amin=Min(Amin,DBLE(A(i,j)))
            End Do
         End Do
         Else
         Amax=DIMAG(A(1,1))
         Amin=DIMAG(A(1,1))
         Do j=1,nCol
            Do i=1,nRow
               Amax=Max(Amax,DIMAG(A(i,j)))
               Amin=Min(Amin,DIMAG(A(i,j)))
            End Do
         End Do
         End If
         Pmax=0.0D0
         If ( Abs(Amax).gt.1.0D-72 ) Pmax=Log10(Abs(Amax))
         iPmax=1+INT(Pmax)
         iPmax=Max(1,iPmax)
         Pmin=0.0D0
         If ( Abs(Amin).gt.1.0D-72 ) Pmin=Log10(Abs(Amin))
         iPmin=1+INT(Pmin)
         iPmin=Max(1,iPmin)
         nDigit=15
         nDecim=Min(9,nDigit-Max(iPmin,iPmax))
         nDecim=Max(nDecim,1)
         If ( Amax.lt.0.0D0 ) iPmax=iPmax+1
         If ( Amin.lt.0.0D0 ) iPmin=iPmin+1
         lNumbr=Max(iPmin,iPmax)+nDecim+2
         nCols=9
         lLine=nCols*lNumbr
         If ( lLine.gt.lPaper ) then
            If ( lLine.le.lPaper+nCols .and. nDecim.gt.1 ) then
               nDecim=nDecim-1
               lNumbr=Max(iPmin,iPmax)+nDecim
               lItem=Max(lNumbr,lPaper/nCols)
            Else
               nCols=5
               lItem=Max(lNumbr,lPaper/nCols)
            End If
         Else
            lItem=lNumbr
         End If
         Write(FMT,'(A,   I4.4,  A, I4.4,  A, I4.4,   A)')
     &             '(2X,',nCols,'F',lItem,'.',nDecim,')'
      End if
*----------------------------------------------------------------------*
*     print the data                                                   *
*----------------------------------------------------------------------*
c      Write(LuWr,*)
      If (Type.eq.'R') Then
      Do i=1,nRow
         Write(LuWr,FMT)(DBLE(A(i,j)),j=1,nCol)
      End Do
      Else
      Do i=1,nRow
         Write(LuWr,FMT)(DIMAG(A(i,j)),j=1,nCol)
      End Do
      End If
*----------------------------------------------------------------------*
*     End procedure                                                    *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RDCMO_RASSI(JOB,CMO)
      IMPLICIT NONE
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='RDCMO_RASSI')
#include "rasdim.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "symmul.fh"
#include "rassi.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#ifdef _HDF5_
#  include "mh5.fh"
      integer :: refwfn_id
#endif

      INTEGER JOB
      REAL*8 CMO(NCMO)

      INTEGER I, IAD, IDISK, ISY, L1, L2, LBUF, LEN, NB, NBUF

      CMO(:)=0.0D0
      IF(JOB.LT.1 .OR. JOB.GT.NJOB) THEN
        WRITE(6,*)' RDCMO_RASSI: Invalid JOB parameter.'
        WRITE(6,*)' JOB, NJOB:',JOB,NJOB
        CALL ABEND()
      END IF
      IF(IPGLOB.GE.DEBUG) THEN
        WRITE(6,*)' RDCMO_RASSI called for file '//TRIM(JBNAME(JOB))
      END IF
C READ ORBITAL COEFFICIENTS FROM INTERFACE. ORIGINALLY ALL
C CMO COEFFS, INCLUDING VIRTUALS, WERE WRITTEN CONTIGUOUSLY.
      NBUF=0
      DO I=1,NSYM
        NBUF=NBUF+NBASF(I)**2
      END DO
      CALL GETMEM('BUF   ','ALLO','REAL',LBUF,NBUF)

#ifdef _HDF5_
************************************************************************
*
* For HDF5 formatted job files
*
************************************************************************
      If (mh5_is_hdf5(jbname(job))) Then
        refwfn_id = mh5_open_file_r(jbname(job))
        call mh5_fetch_dset_array_real(refwfn_id,
     &         'MO_VECTORS', WORK(LBUF))
        call mh5_close_file(refwfn_id)
      Else
#endif
************************************************************************
*
* For JOBIPH/JOBMIX formatted job files
*
************************************************************************
        CALL DANAME(LUIPH,JBNAME(JOB))
        IAD=0
        CALL IDAFILE(LUIPH,2,ITOC15,30,IAD)
        IDISK=IDCMO(JOB)
        CALL DDAFILE(LUIPH,2,WORK(LBUF),NBUF,IDISK)
        CALL DACLOS(LUIPH)
************************************************************************
#ifdef _HDF5_
      End If
#endif

      IF(IPGLOB.GE.INSANE) THEN
        write(6,*)' Reading CMO'
        write(6,*)' NBUF=',NBUF
        write(6,*)' Array read in:'
        write(6,'(1x,5f16.8)')(work(lbuf-1+i),i=1,nbuf)
      END IF
      L1=LBUF
      L2=1
      DO ISY=1,NSYM
        NB=NBASF(ISY)
        LEN=NOSH(ISY)*NB
        IF(LEN.GT.0) CALL DCOPY_(LEN,WORK(L1),1,CMO(L2),1)
        L2=L2+LEN
        L1=L1+NB**2
      END DO
      IF(IPGLOB.GE.INSANE) THEN
        write(6,*)' Gathered CMO from array.'
        write(6,*)' NCMO=',NCMO
        write(6,'(1x,5f16.8)')(CMO(i),i=1,ncmo)
      END IF
      CALL GETMEM('      ','FREE','REAL',LBUF,NBUF)

      IF (IPGLOB.gt.SILENT .and. PRORB) THEN
        WRITE(6,*)
        CALL WRMAT('MO ORBITAL COEFFICIENTS:',
     *               1,NBASF,NOSH,NCMO,CMO)
      END IF

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_DEcorr(nh1,Grad,nGrad,DFTFOCK)
      use SCF_Arrays, only: CMO
      use SpinAV
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "stdalloc.fh"
#include "infscf.fh"
      Real*8  Grad(nGrad), Ec_AB(2)
      Character*4 DFTFOCK
#include "addcorr.fh"
      Real*8, Allocatable :: F_DFT(:,:), D_DS(:,:)
      nD=2
*
      Call mma_allocate(F_DFT,nBT,nD,Label='F_DFT')
      Call mma_allocate(D_DS ,nBT,nD,Label='D_DS')
*
      Do iAB=1,2
       iOff=1
       jOff=1
       lOff=0
       Do iSym=1,nSym
          If (iAB.eq.1) Then
             nXoX=nOcc(iSym,1)
             iXoX=0
          Else
             nXoX=nConstr(iSym)
             iXoX=nOcc(iSym,1)-nConstr(iSym)
          EndIf
          mAdCMOO=iOff+nBas(iSym)*iXoX
          Call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nXoX,
     &                     1.0d0,CMO(mAdCMOO,1),nBas(iSym),
     &                           CMO(mAdCMOO,1),nBas(iSym),
     &                     0.0d0,D_DS(jOff,1),nBas(iSym))
          If (iAB.eq.1) Then
             nXoX=nOcc(iSym,2)
             iXoX=0
          Else
             nXoX=nConstr(iSym)
             iXoX=nOcc(iSym,2)-nConstr(iSym)
          EndIf
          mAdCMOO=iOff+nBas(iSym)*iXoX
          Call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nXoX,
     &                     1.0d0,CMO(mAdCMOO,2),nBas(iSym),
     &                           CMO(mAdCMOO,2),nBas(iSym),
     &                     0.0d0,D_DS(jOff,2),nBas(iSym))
*
          If (Do_SpinAV) Then
             Do j=1,nBas(iSym)
                Do i=1,j
                   iDSc=nBas(iSym)*(j-1)+i
                   ji=j*(j-1)/2+i
                   iDij=jOff-1+ji
                   D_DS(iDij,1)=D_DS(iDij,1)-DSc(iDSc)
                   D_DS(iDij,2)=D_DS(iDij,2)+DSc(iDSc)
                End Do
             End Do
             lOff=lOff+nBas(iSym)**2
          EndIf
*
          Do j=1,nBas(iSym)
             Do i=1,j-1
                ji=j*(j-1)/2+i
                iDij=jOff-1+ji
                D_DS(iDij,1)=2.0d0*D_DS(iDij,1)
                D_DS(iDij,2)=2.0d0*D_DS(iDij,2)
             End Do
          End Do
          iOff=iOff+nBas(iSym)*nOrb(iSym)
          jOff=jOff+nBas(iSym)*(nBas(iSym)+1)/2
       End Do
*
       Call Get_Ecorr_dft(nh1,Grad,nGrad,DFTFOCK,F_DFT,D_DS,nBT,nD,
     &                        ADDC_KSDFT,Ec_AB(iAB))
      End Do
*----------------------------------------------------------------------*
      DE_KSDFT_c=Ec_AB(1)-Ec_AB(2)
*----------------------------------------------------------------------*
*
      Call mma_deallocate(D_DS)
      Call mma_deallocate(F_DFT)
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine Get_Ecorr_dft(nh1,Grad,nGrad,DFTFOCK,F_DFT,D_DS,
     &                         nBT,nD,KSDFT,Ec_AB)
      use OFembed, only: dFMD, Do_Core
      use nq_Info, only: Dens_I, Grad_I, Tau_I
      Implicit Real*8 (a-h,o-z)

#include "real.fh"
#include "debug.fh"
      Real*8  Grad(nGrad)
      Logical Do_MO,Do_TwoEl,Do_Grad
      Character(LEN=4) DFTFOCK
      Character(LEN=80)  KSDFT
      Real*8 :: F_DFT(nBT,nD), D_DS(nBT,nD)

      Debug=.False.
*                                                                      *
************************************************************************
*                                                                      *
*     DFT functionals, compute integrals over the potential
*
      Func            =Zero
      Dens_I          =Zero
      Grad_I          =Zero
      Tau_I           =Zero
      Do_MO           =.False.
      Do_TwoEl        =.False.
      Do_Grad=.false.
*
      nFckDim=2
      dFMD_=dFMD
      dFMD=1.0d0
*                                                                      *
************************************************************************
*                                                                      *
      Do_Core=.True.
      Call Driver(KSDFT,Do_Grad,Func,Grad,nGrad,
     &            Do_MO,Do_TwoEl,D_DS,F_DFT,nh1,nFckDim,DFTFOCK)
      Do_Core=.False.
*                                                                      *
************************************************************************
*                                                                      *
      Ec_AB=Func
*
#ifdef _DEBUGPRINT_
      write(6,*) ' Correlation energy: ',Ec_AB
      write(6,*)
      write(6,*) ' Correlation potentials: (itri,F_alpha,F_beta)'
      write(6,*)
      Do i=1,nh1
        Write(6,'(i4,3f22.16)') i,F_DFT(i,1),F_DFT(i,2)
      End Do
#endif
*
      dFMD=dFMD_
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Lasse Kragh Soerensen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine I_AM_SO_EXCITED(NBATCH,IBATCH,LBATCH,I1BATCH)
! Subroutine by Lasse from October 2015
!
! Updated March 2018 for doubly excited states
!
! Will give single excited states in from the desired GAS (or GAS's)
! And now also doubly excited states
!
! The difference between the HEXS and DEXS is controlled by
! I_ELIMINATE_GAS
! Notice that for the doubly excited states (DEXS) all
! singly excited states (HEXS) are in effect.

use lucia_data, only: I2ELIMINATED_IN_GAS, I_AM_OUT, I_ELIMINATE_GAS, IBSPGPFTP, IELIMINATED_IN_GAS, ISPGPFTP, MXPSTT, &
                      N_2ELIMINATED_GAS, N_ELIMINATED_BATCHES, N_ELIMINATED_GAS, NELFGP, NGAS, NSPGPFTP
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NBATCH, IBATCH(8,*), LBATCH(NBATCH), I1BATCH(NBATCH)
integer(kind=iwp) :: I, IBLOCK, IEL, IGAS, IGAS_ELIM, IITYPE, IMATCH_ALPHA, IMATCH_ALPHAM1, IMATCH_BETA, IMATCH_BETAM1, &
                     IMATCH_BLOCK, IMAX_OCC(2,NGAS,2), IOFF, ISPGP, ITYPE_A, ITYPE_B, J, JBATCH, MAX_E_GAS_ALPHA(2,MXPSTT), &
                     MAX_E_GAS_BETA(2,MXPSTT), MAXM1_E_GAS_ALPHA(2,MXPSTT), MAXM1_E_GAS_BETA(2,MXPSTT), NALPHA, NALPHAM1, NBETA, &
                     NBETAM1

#ifdef _DEBUGPRINT_
write(u6,*) ' Oh I am so excited'
write(u6,*)
write(u6,*) ' Number of GAS without max (max-1) occupation = ',N_ELIMINATED_GAS+N_2ELIMINATED_GAS
write(u6,*)
if ((I_ELIMINATE_GAS == 1) .or. (I_ELIMINATE_GAS == 3)) then
  write(u6,*) ' GAS without maximum occupation (HEXS)'
  write(u6,*)
  do I=1,N_ELIMINATED_GAS
    write(u6,*) IELIMINATED_IN_GAS(I)
  end do
end if
if (I_ELIMINATE_GAS > 1) then
  write(u6,*) ' GAS without maximum-1 occupation (DEXS)'
  write(u6,*)
  do I=1,N_2ELIMINATED_GAS
    write(u6,*) I2ELIMINATED_IN_GAS(I)
  end do
end if
#endif

! First we need to find the GAS spaces for which we will eliminate
! the maximum occupation.

IMAX_OCC = 0

do JBATCH=1,min(NBATCH,2) ! only alpha and beta
  do IBLOCK=I1BATCH(JBATCH),I1BATCH(JBATCH)+LBATCH(JBATCH)-1
    do ISPGP=1,NSPGPFTP(JBATCH)
      IOFF = IBSPGPFTP(JBATCH)
      do IGAS=1,NGAS
        IITYPE = ISPGPFTP(IGAS,IOFF-1+ISPGP)
        IEL = NELFGP(IITYPE)
        if (IEL > IMAX_OCC(JBATCH,IGAS,1)) then
          IMAX_OCC(JBATCH,IGAS,1) = IEL
          IMAX_OCC(JBATCH,IGAS,2) = IITYPE
        end if
      end do
    end do
  end do
end do

#ifdef _DEBUGPRINT_
do JBATCH=1,min(NBATCH,2)
  if (JBATCH == 1) then
    write(u6,*) ' Maximum number of alpha electrons in each GAS'
  else
    write(u6,*) ' Maximum number of beta electrons in each GAS'
  end if
  write(u6,*)
  write(u6,*) ' GAS, Electrons, Group'
  do IGAS=1,NGAS
    write(u6,*) IGAS,IMAX_OCC(JBATCH,IGAS,1),IMAX_OCC(JBATCH,IGAS,2)
  end do
  write(u6,*)
end do
#endif

! Find which types contains the groups with a maximum number
! of alpha or beta electrons in a GAS

NALPHA = 0
NBETA = 0
NALPHAM1 = 0
NBETAM1 = 0
do JBATCH=1,min(NBATCH,2) ! only alpha and beta
  do IBLOCK=I1BATCH(JBATCH),I1BATCH(JBATCH)+LBATCH(JBATCH)-1
    do ISPGP=1,NSPGPFTP(JBATCH)
      IOFF = IBSPGPFTP(JBATCH)
      do IGAS=1,NGAS
        IITYPE = ISPGPFTP(IGAS,IOFF-1+ISPGP)
        IEL = NELFGP(IITYPE)
        if (IEL == IMAX_OCC(JBATCH,IGAS,1)) then
          if (JBATCH == 1) then
            NALPHA = NALPHA+1
            MAX_E_GAS_ALPHA(1,NALPHA) = IGAS
            MAX_E_GAS_ALPHA(2,NALPHA) = ISPGP
          else
            NBETA = NBETA+1
            MAX_E_GAS_BETA(1,NBETA) = IGAS
            MAX_E_GAS_BETA(2,NBETA) = ISPGP
          end if
        end if
        if (I_ELIMINATE_GAS > 1) then ! DEXS
          if (IEL == IMAX_OCC(JBATCH,IGAS,1)-1) then
            if (JBATCH == 1) then
              NALPHAM1 = NALPHAM1+1
              MAXM1_E_GAS_ALPHA(1,NALPHAM1) = IGAS
              MAXM1_E_GAS_ALPHA(2,NALPHAM1) = ISPGP
            else
              NBETAM1 = NBETAM1+1
              MAXM1_E_GAS_BETA(1,NBETAM1) = IGAS
              MAXM1_E_GAS_BETA(2,NBETAM1) = ISPGP
            end if
          end if
        end if
      end do
    end do
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'Maximum number of alpha supergroups that can be eliminated',NALPHA+NALPHAM1
write(u6,*)
write(u6,*) ' GAS Supergroup for HEXS'
write(u6,*)
do IGAS=1,NGAS
  do I=1,NALPHA
    if (MAX_E_GAS_ALPHA(1,I) == IGAS) write(u6,*) MAX_E_GAS_ALPHA(1,I),MAX_E_GAS_ALPHA(2,I)
  end do
end do
if (I_ELIMINATE_GAS > 1) then ! DEXS
  write(u6,*)
  write(u6,*) ' GAS Supergroup for DEXS'
  write(u6,*)
  do IGAS=1,NGAS
    do I=1,NALPHAM1
      if (MAXM1_E_GAS_ALPHA(1,I) == IGAS) write(u6,*) MAXM1_E_GAS_ALPHA(1,I),MAXM1_E_GAS_ALPHA(2,I)
    end do
  end do
end if
write(u6,*)
write(u6,*) 'Maximum number of beta supergroups that can be eliminated',NBETA+NBETAM1
write(u6,*)
write(u6,*) ' GAS Supergroup for HEXS'
write(u6,*)
do IGAS=1,NGAS
  do I=1,NBETA
    if (MAX_E_GAS_BETA(1,I) == IGAS) write(u6,*) MAX_E_GAS_BETA(1,I),MAX_E_GAS_BETA(2,I)
  end do
end do
if (I_ELIMINATE_GAS > 1) then ! DEXS
  write(u6,*)
  write(u6,*) ' GAS Supergroup for DEXS'
  write(u6,*)
  do IGAS=1,NGAS
    do I=1,NBETAM1
      if (MAXM1_E_GAS_BETA(1,I) == IGAS) write(u6,*) MAXM1_E_GAS_BETA(1,I),MAXM1_E_GAS_BETA(2,I)
    end do
  end do
end if
write(u6,*)
#endif

! Now find the batches to possibly eliminate

N_ELIMINATED_BATCHES = 0

do JBATCH=1,NBATCH
  do IBLOCK=I1BATCH(JBATCH),I1BATCH(JBATCH)+LBATCH(JBATCH)-1
    ITYPE_A = IBATCH(1,IBLOCK)
    ITYPE_B = IBATCH(2,IBLOCK)
    IMATCH_BLOCK = 0
    if ((I_ELIMINATE_GAS == 1) .or. (I_ELIMINATE_GAS == 3)) then
      ! HEXS
      do I=1,N_ELIMINATED_GAS
        IGAS_ELIM = IELIMINATED_IN_GAS(I)
        ! Will first check if it matches a beta type
        IMATCH_BETA = 0
        do J=1,NBETA
          if ((ITYPE_B == MAX_E_GAS_BETA(2,J)) .and. (IGAS_ELIM == MAX_E_GAS_BETA(1,J))) then
            IMATCH_BETA = 1
            exit
          end if
        end do
        ! Now check it also matches an alpha type
        IMATCH_ALPHA = 0
        do J=1,NALPHA
          if ((ITYPE_A == MAX_E_GAS_ALPHA(2,J)) .and. (IGAS_ELIM == MAX_E_GAS_ALPHA(1,J))) then
            IMATCH_ALPHA = 1
            exit
          end if
        end do
        if ((IMATCH_BETA == 1) .and. (IMATCH_ALPHA == 1)) IMATCH_BLOCK = 1
      end do
      if (IMATCH_BLOCK == 1) then
        N_ELIMINATED_BATCHES = N_ELIMINATED_BATCHES+1
        I_AM_OUT(N_ELIMINATED_BATCHES) = iblock
        cycle
      end if
    end if
    if (I_ELIMINATE_GAS > 1) then
      ! DEXS
      do I=1,N_2ELIMINATED_GAS
        IGAS_ELIM = I2ELIMINATED_IN_GAS(I)
        ! Will first check if it matches a beta type
        IMATCH_BETA = 0
        do J=1,NBETA
          if ((ITYPE_B == MAX_E_GAS_BETA(2,J)) .and. (IGAS_ELIM == MAX_E_GAS_BETA(1,J))) then
            IMATCH_BETA = 1
            exit
          end if
        end do
        ! Now check it also matches an alpha type
        IMATCH_ALPHA = 0
        do J=1,NALPHA
          if ((ITYPE_A == MAX_E_GAS_ALPHA(2,J)) .and. (IGAS_ELIM == MAX_E_GAS_ALPHA(1,J))) then
            IMATCH_ALPHA = 1
            exit
          end if
        end do
        ! Check if OCC matches a DEXS beta type
        IMATCH_BETAM1 = 0
        do J=1,NBETAM1
          if ((ITYPE_B == MAXM1_E_GAS_BETA(2,J)) .and. (IGAS_ELIM == MAXM1_E_GAS_BETA(1,J))) then
            IMATCH_BETAM1 = 1
            exit
          end if
        end do
        IMATCH_ALPHAM1 = 0
        do J=1,NALPHAM1
          if ((ITYPE_A == MAXM1_E_GAS_ALPHA(2,J)) .and. (IGAS_ELIM == MAXM1_E_GAS_ALPHA(1,J))) then
            IMATCH_ALPHAM1 = 1
            exit
          end if
        end do
        if (((IMATCH_BETA == 1) .and. (IMATCH_ALPHA == 1)) .or. ((IMATCH_BETAM1 == 1) .and. (IMATCH_ALPHA == 1)) .or. &
            ((IMATCH_BETA == 1) .and. (IMATCH_ALPHAM1 == 1))) IMATCH_BLOCK = 1
      end do
    end if
    if (IMATCH_BLOCK == 1) then
      N_ELIMINATED_BATCHES = N_ELIMINATED_BATCHES+1
      I_AM_OUT(N_ELIMINATED_BATCHES) = iblock
    end if
  end do
end do

if (N_ELIMINATED_BATCHES > MXPSTT) then
  write(u6,*) ' Increase MXPSTT to ',N_ELIMINATED_BATCHES
  call SYSABENDMSG('lucia_util/i_am_so_excited','Dimension of I_AM_OUT is too small','Increase MXPSTT')
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Number of eliminated blocks ',N_ELIMINATED_BATCHES
write(u6,*)
write(u6,*) ' The blocks eliminated'
write(u6,*)
do I=1,N_ELIMINATED_BATCHES
  write(u6,*) I_AM_OUT(I)
end do
write(u6,*)
#endif

end subroutine I_AM_SO_EXCITED

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine replace2(length,coeff,operator,wordercounter,wopsleng,
     *                    dwops,wops,sused,stimes,wstimes,s,scrchar,
     *                    scrleng,ttimes,termcounter,termleng,termleng2,
     *                    dtcoeff,dtcoeff2,
     *                    term)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 12.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer length
      character*(maxlength) operator
      REAL*8 coeff
c
      integer wordercounter(maxorder),wopsleng(maxuops),sused,
     *        stimes(maxsnumber),wstimes(maxuops,maxsnumber),
     *        scrleng(maxsnumber),ttimes(maxsnumber)
      REAL*8 dwops(maxuops)
      character*(maxlength) wops(maxuops)
      character*(4) s(maxsnumber)
      character*(9) scrchar(maxsnumber)
c
      integer termcounter,termleng(maxoperators),
     *        termcounter2,termleng2(maxoperators)
      REAL*8 dtcoeff(maxoperators),dtcoeff2(maxoperators)
#if defined(_MOLCAS_) || defined(MOLPRO)
#include "WrkSpc.fh"
      character*(maxlength) termstr
      integer term(*)
      integer term2,lwop,nwop,intrea
#else
      character*(maxlength) term(maxoperators),term2(maxoperators)
Cfrueher_benutzt      common/cdkhops2/ term2
#endif
c
C     integer i,k,l,m,pos,posw,poso,pose,reslengl,reslengr,dummyleng,
C    *        tmpleng,hit,istart,iposs,
C    *        idum,idum1,idum2,wstart,dkh_char2int
      integer i,k,    pos,posw,          reslengl,reslengr,dummyleng,
     *                hit,istart,
     *        idum,idum1,      wstart,dkh_char2int
      character*(maxlength) rescharl,rescharr,dummychar
c
      dummyleng=0
      do 10 k=1,maxlength
        dummychar(k:k)=' '
  10  continue
#if defined(_MOLCAS_) || defined(MOLPRO)
      lwop=8/intrea()
      nwop=(maxlength-1)/lwop+1
      call getmem('term2','Allo','Inte',term2,maxoperators*nwop)
      termstr=' '
#endif
      termcounter=1
      termcounter2=0
      do 20 i=1,maxoperators
        termleng(i)=0
        dtcoeff(i)=0.0d0
        termleng2(i)=0
        dtcoeff2(i)=0.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
        call put_dkoperators_i(i,termstr,iwork(term2))
        call put_dkoperators_i(i,termstr,term)
#else
        do 30 k=1,maxlength
          term(i)(k:k)=' '
          term2(i)(k:k)=' '
  30    continue
#endif
  20  continue
      termleng(1)=length
      dtcoeff(1)=coeff
#if defined(_MOLCAS_) || defined(MOLPRO)
      call put_dkoperators_i(1,operator,term)
#else
      term(1)(1:termleng(1))=operator(1:length)
#endif
2050  continue
      termcounter2=0
      hit=0
c
      do 200 i=1,termcounter
        dummyleng=2
        pos=0
        posw=0
        idum=0
        istart=1
2063    continue
#if defined(_MOLCAS_) || defined(MOLPRO)
        call get_dkoperators_i(i,termstr,term)
        posw=index(termstr(istart:termleng(i)),'W')
#else
        posw=index(term(i)(istart:termleng(i)),'W')
#endif
        if (posw.gt.0) then
#if defined(_MOLCAS_) || defined(MOLPRO)
          idum1=dkh_char2int(dummyleng,
     *                       termstr(istart+posw:istart+posw+1))
#else
          idum1=dkh_char2int(dummyleng,
     *                       term(i)(istart+posw:istart+posw+1))
#endif
          if (idum1.gt.idum) then
            idum=idum1
            pos=istart+posw-1
          endif
          istart=istart+pos+2
          goto 2063
        endif
        if (pos.eq.0) then
c  term(i) does not contain a 'W':  copy term --> term2 without any modification
          termcounter2=termcounter2+1
          termleng2(termcounter2)=termleng(i)
          dtcoeff2(termcounter2)=dtcoeff(i)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call put_dkoperators_i(termcounter2,termstr,iwork(term2))
#else
          term2(termcounter2)(1:termleng2(termcounter2))
     *      =term(i)(1:termleng(i))
#endif
c
        else
c
          hit=hit+1
          wstart=1
          do 341 k=1,idum-1
            wstart=wstart+wordercounter(k)
 341      continue
          dummyleng=3
#if defined(_MOLCAS_) || defined(MOLPRO)
          call store_reschar (termleng(i),termstr,pos,dummyleng,
     *                        reslengl,reslengr,rescharl,rescharr)
#else
          call store_reschar (termleng(i),term(i),pos,dummyleng,
     *                        reslengl,reslengr,rescharl,rescharr)
#endif
          do 351 k=1,wordercounter(idum)
            termcounter2=termcounter2+1
            termleng2(termcounter2)=termleng(i)-3+wopsleng(k+wstart-1)
            if (termleng2(termcounter2).gt.maxlength) then
              write (stdout,3034) termleng2(termcounter2)
3034          format (/2X,'ERROR3 in subroutine "replace2": termleng =',
     *              I3,' is larger than maxlength.',//2X,'Increase ',
     *              'parameter maxlength in "dkhparameters.fh".',//2X,
     *              'STOP.',/)
              CALL Abend
            endif
            dtcoeff2(termcounter2)=dtcoeff(i)*dwops(k+wstart-1)
#if defined(_MOLCAS_) || defined(MOLPRO)
            call concatenate (termleng2(termcounter2),
     *                        termstr,reslengl,rescharl,
     *                        wopsleng(k+wstart-1),
     *                        wops(k+wstart-1)(1:wopsleng(k+wstart-1)),
     *                        reslengr,rescharr)
            call put_dkoperators_i(termcounter2,termstr,iwork(term2))
#else
            call concatenate (termleng2(termcounter2),
     *                        term2(termcounter2),reslengl,rescharl,
     *                        wopsleng(k+wstart-1),
     *                        wops(k+wstart-1)(1:wopsleng(k+wstart-1)),
     *                        reslengr,rescharr)
#endif
            call calc_stimes1 (k,wstart,sused,stimes,wstimes,ttimes,
     *                         reslengl,reslengr,rescharl,rescharr)
c
 351      continue
        endif
 200  continue
      do 400 i=1,termcounter2
        termleng(i)=termleng2(i)
        dtcoeff(i)=dtcoeff2(i)
#if defined(_MOLCAS_) || defined(MOLPRO)
        call copy_dkoperators_i(i,iwork(term2),i,term)
#else
        term(i)(1:termleng(i))=term2(i)(1:termleng2(i))
#endif
 400  continue
      termcounter=termcounter2
c
      if (hit.gt.0) goto 2050
2060  continue
      termcounter2=0
      hit=0
      do 1200 i=1,termcounter
        pos=0
#if defined(_MOLCAS_) || defined(MOLPRO)
        call get_dkoperators_i(i,termstr,term)
        pos=index(termstr(1:termleng(i)),'O01')
#else
        pos=index(term(i)(1:termleng(i)),'O01')
#endif
c
        if (pos.eq.0) then
          termcounter2=termcounter2+1
          termleng2(termcounter2)=termleng(i)
          dtcoeff2(termcounter2)=dtcoeff(i)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call copy_dkoperators_i(i,term,termcounter2,iwork(term2))
#else
          term2(termcounter2)(1:termleng2(termcounter2))
     *      =term(i)(1:termleng(i))
#endif
        else
          hit=hit+1
          dummyleng=3
#if defined(_MOLCAS_) || defined(MOLPRO)
          call store_reschar (termleng(i),termstr,pos,dummyleng,
     *                        reslengl,reslengr,rescharl,rescharr)
#else
          call store_reschar (termleng(i),term(i),pos,dummyleng,
     *                        reslengl,reslengr,rescharl,rescharr)
#endif
          termcounter2=termcounter2+1
          termleng2(termcounter2)=termleng(i)
          dtcoeff2(termcounter2)=dtcoeff(i)
          dummyleng=3
          dummychar(1:dummyleng)='BPV'
#if defined(_MOLCAS_) || defined(MOLPRO)
          call concatenate (termleng2(termcounter2),termstr,
     *                      reslengl,rescharl,dummyleng,
     *                      dummychar(1:dummyleng),reslengr,rescharr)
          call put_dkoperators_i(termcounter2,termstr,iwork(term2))
#else
          call concatenate (termleng2(termcounter2),term2(termcounter2),
     *                      reslengl,rescharl,dummyleng,
     *                      dummychar(1:dummyleng),reslengr,rescharr)
#endif
          termcounter2=termcounter2+1
          termleng2(termcounter2)=termleng(i)
          dtcoeff2(termcounter2)=-1.0d0*dtcoeff(i)
          dummychar(1:dummyleng)='BVP'
#if defined(_MOLCAS_) || defined(MOLPRO)
          call concatenate (termleng2(termcounter2),termstr,
     *                      reslengl,rescharl,dummyleng,
     *                      dummychar(1:dummyleng),reslengr,rescharr)
          call put_dkoperators_i(termcounter2,termstr,iwork(term2))
#else
          call concatenate (termleng2(termcounter2),term2(termcounter2),
     *                      reslengl,rescharl,dummyleng,
     *                      dummychar(1:dummyleng),reslengr,rescharr)
#endif
          call calc_stimes2 (stimes,ttimes,reslengl,reslengr,rescharl,
     *                       rescharr)
c
        endif
1200  continue
      do 1400 i=1,termcounter2
        termleng(i)=termleng2(i)
        dtcoeff(i)=dtcoeff2(i)
#if defined(_MOLCAS_) || defined(MOLPRO)
        call copy_dkoperators_i(i,iwork(term2),i,term)
#else
        term(i)(1:termleng(i))=term2(i)(1:termleng2(i))
#endif
1400  continue
      termcounter=termcounter2
c
      if (hit.gt.0) goto 2060
c
c
3060  continue
      termcounter2=0
      hit=0
      do 1270 i=1,termcounter
        pos=0
#if defined(_MOLCAS_) || defined(MOLPRO)
        call get_dkoperators_i(i,termstr,term)
        pos=index(termstr(1:termleng(i)),'CO0')
#else
        pos=index(term(i)(1:termleng(i)),'CO0')
#endif
c
        if (pos.eq.0) then
          termcounter2=termcounter2+1
          termleng2(termcounter2)=termleng(i)
          dtcoeff2(termcounter2)=dtcoeff(i)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call put_dkoperators_i(termcounter2,termstr,iwork(term2))
#else
          term2(termcounter2)(1:termleng2(termcounter2))
     *      =term(i)(1:termleng(i))
#endif
        else
          hit=hit+1
          dummyleng=3
#if defined(_MOLCAS_) || defined(MOLPRO)
          call store_reschar (termleng(i),termstr,pos,dummyleng,
     *                        reslengl,reslengr,rescharl,rescharr)
#else
          call store_reschar (termleng(i),term(i),pos,dummyleng,
     *                        reslengl,reslengr,rescharl,rescharr)
#endif
          termcounter2=termcounter2+1
          termleng2(termcounter2)=termleng(i)
          dtcoeff2(termcounter2)=dtcoeff(i)
          dummyleng=3
          dummychar(1:dummyleng)='BPX'
#if defined(_MOLCAS_) || defined(MOLPRO)
          call concatenate (termleng2(termcounter2),termstr,
     *                      reslengl,rescharl,dummyleng,
     *                      dummychar(1:dummyleng),reslengr,rescharr)
          call put_dkoperators_i(termcounter2,termstr,iwork(term2))
#else
          call concatenate (termleng2(termcounter2),term2(termcounter2),
     *                      reslengl,rescharl,dummyleng,
     *                      dummychar(1:dummyleng),reslengr,rescharr)
#endif
          termcounter2=termcounter2+1
          termleng2(termcounter2)=termleng(i)
          dtcoeff2(termcounter2)=-1.0d0*dtcoeff(i)
          dummychar(1:dummyleng)='BXP'
#if defined(_MOLCAS_) || defined(MOLPRO)
          call concatenate (termleng2(termcounter2),termstr,
     *                      reslengl,rescharl,dummyleng,
     *                      dummychar(1:dummyleng),reslengr,rescharr)
          call put_dkoperators_i(termcounter2,termstr,iwork(term2))
#else
          call concatenate (termleng2(termcounter2),term2(termcounter2),
     *                      reslengl,rescharl,dummyleng,
     *                      dummychar(1:dummyleng),reslengr,rescharr)
#endif
          call calc_stimes2 (stimes,ttimes,reslengl,reslengr,
     *                       rescharl,rescharr)
c
        endif
1270  continue
      do 1470 i=1,termcounter2
        termleng(i)=termleng2(i)
        dtcoeff(i)=dtcoeff2(i)
#if defined(_MOLCAS_) || defined(MOLPRO)
        call copy_dkoperators_i(i,iwork(term2),i,term)
#else
        term(i)(1:termleng(i))=term2(i)(1:termleng2(i))
#endif
1470  continue
      termcounter=termcounter2
c
      if (hit.gt.0) goto 3060
c
#if defined(_MOLCAS_) || defined(MOLPRO)
      call getmem('term2','Free','Inte',term2,maxoperators*nwop)
#endif
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_character(s)
        call Unused_character(scrchar)
        call Unused_integer_array(scrleng)
      end if
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE CUPDATE(JSY,INDEX,C,S,AP,BST,T2,ENP)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION JSY(*),INDEX(*),C(*),S(*),AP(*),BST(*),
     *          T2(*),ENP(*)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
*
      JSYM(L)=JSUNP_CPF(JSY,L)
C

      W=WLEV

C VALENCE
      IP=IRC(1)
      DO 6 I=1,IP
        C(I)=AP(I)*C(I)-S(I)
6     CONTINUE

C SINGLES
      IP=IRC(2)-IRC(1)
      IN=IRC(1)
      DO 5 I=1,IP
        NS1=JSYM(IN+I)
        NSIL=MUL(NS1,LSYM)
        INUM=NVIR(NSIL)
        IST=INDEX(IN+I)+1
        CALL VSMSB(C(IST),1,AP(IN+I),S(IST),1,C(IST),1,INUM)
5     CONTINUE

C DOUBLES
      IP=IRC(4)-IRC(2)
      IN=IRC(2)
      DO 10 I=1,IP
        NS1=JSYM(IN+I)
        NSIL=MUL(NS1,LSYM)
        INUM=NNS(NSIL)
        IST=INDEX(IN+I)+1
        CALL VSMSB(C(IST),1,AP(IN+I),S(IST),1,C(IST),1,INUM)
10    CONTINUE

C WRITE GRADIENT ONTO DISK, UNIT=30
      IAD=IADDP(ITPUL)
      CALL dDAFILE(Lu_30,1,C,NCONF,IAD)

C Reuse array S for HCOUT that was written in IJIJ.
      IAD=IAD25S
      DO 77 III=1,NCONF,nCOP
        JJJ=MIN(nCOP,NCONF+1-III)
        CALL dDAFILE(Lu_25,2,S(III),JJJ,IAD)
77    CONTINUE

C VALENCE
      IP=IRC(1)
      DO 7 I=1,IP
        APW=W-AP(I)
        T2(I)=S(I)+APW
        C(I)=C(I)/T2(I)
        EMP=SQRT(ENP(I))
        C(I)=C(I)*EMP
        IF(I.EQ.IREF0)C(I)=0.0D0
7     CONTINUE

C SINGLES
      IP=IRC(2)-IRC(1)
      IN=IRC(1)
      DO 8 I=1,IP
        NS1=JSYM(IN+I)
        NSIL=MUL(NS1,LSYM)
        INUM=NVIR(NSIL)
        IST=INDEX(IN+I)+1
        APW=W-AP(IN+I)
        CALL VSADD(S(IST),1,APW,T2,1,INUM)
        CALL VDIV(T2,1,C(IST),1,C(IST),1,INUM)
        EMP=SQRT(ENP(IN+I))
        CALL VSMUL(C(IST),1,EMP,C(IST),1,INUM)
8     CONTINUE

C DOUBLES
      IP=IRC(4)-IRC(2)
      IN=IRC(2)
      DO 11 I=1,IP
        NS1=JSYM(IN+I)
        NSIL=MUL(NS1,LSYM)
        INUM=NNS(NSIL)
        IST=INDEX(IN+I)+1
        APW=W-AP(IN+I)
        CALL VSADD(S(IST),1,APW,T2,1,INUM)
        CALL VDIV(T2,1,C(IST),1,C(IST),1,INUM)
        EMP=SQRT(ENP(IN+I))
        CALL VSMUL(C(IST),1,EMP,C(IST),1,INUM)
11    CONTINUE
C
      IAD=IADDP(ITPUL+1)
      CALL dDAFILE(Lu_CI,1,C,NCONF,IAD)
      IADDP(ITPUL+2)=IAD
      IF(IPRINT.GE.15)WRITE(6,999)(C(I),I=1,NCONF)
999   FORMAT(6X,'C(UPD)',5F10.6)
      A=DDOT_(NCONF,C,1,C,1)
      IF(A.GT.D2) THEN
        WRITE(6,*)'CUPDATE Error: A>2.0D0 (See code.)'
        CALL Abend
      END IF
      IF(ITPUL.EQ.1)BST(1)=A
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Routine to give base vectors of the plane with v as normal.
subroutine PlaneVectors(u,w,v,Rinv)

use Constants, only: Zero, One, Half
use Definitions, only: wp

implicit none
real(kind=wp), intent(out) :: u(3), w(3)
real(kind=wp), intent(in) :: v(3), Rinv
real(kind=wp) :: const, dLu, p(3), Scal, Shitx, Shity, Shitz

! Construct an arbitrary normalized vector orthogonal to the v-vector.

const = Zero
Shitx = One
Shity = Zero
Shitz = Zero
do
  p(1) = Shitx+const
  p(2) = Shity+Half*const
  p(3) = Shitz-const
  Scal = p(1)*v(1)+p(2)*v(2)+p(3)*v(3)
  u(:) = p-Scal*Rinv**2*v
  if ((abs(u(1)) >= 1.0e-6_wp) .or. (abs(u(2)) >= 1.0e-6_wp) .or. (abs(u(3)) >= 1.0-6_wp)) exit
  const = const+One
end do
dLu = sqrt(u(1)**2+u(2)**2+u(3)**2)
u(:) = u/dLu

! Construct the final pi-vector, which is orthogonal to the v-vector
! and the recently constructed pi-vector.

w(1) = Rinv*(u(2)*v(3)-u(3)*v(2))
w(2) = Rinv*(u(3)*v(1)-u(1)*v(3))
w(3) = Rinv*(u(1)*v(2)-u(2)*v(1))

return

end subroutine PlaneVectors

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine SBDIAG_SER(ISYM,ICASE,CONDNR,CPU)
! On entry, the file LUSBT contains overlap matrices SMAT at disk
! addresses IDSMAT(ISYM,ICASE), ISYM=1..NSYM, ICASE=1..11, and
! similarly BMAT matrices at IDBMAT(ISYM,ICASE).
! These matrices are stored in a triangular format.
! The rectangular matrices TRANS are computed, such that
!    Sum(J) of BMAT(I,J)*TRANS(J,MU) =
!       Sum(J) of  SMAT(I,J)*TRANS(J,MU)*BDIAG(MU)
! where I,J are in 1..NASUP(ISYM,ICASE)
!        MU is in 1..NINDEP(ISYM,ICASE)
! NINDEP is the numerically effective rank of SMAT, and the
! columns of TRANS are orthonormal:
!    Sum(I,J) of  SMAT(I,J)*TRANS(J,MU)*TRANS(J,NU) = Kron(MU,NU)
! BMAT is destroyed, and is overwritten by BDIAG(MU) and
! TRANS(I,MU), with addresses IDBMAT(ISYM,ICASE) and
! IDTMAT(ISYM,ICASE). Enough file space was thus originally
! reserved on LUSBT to allow this overlay.
! LUSOLV is assumed not to be in use yet, so we use it
! for temporary storage.

use Index_Functions, only: nTri_Elem
use PrintLevel, only: INSANE
use EQSOLV, only: IDBMAT, IDSMAT, IDSTMAT, IDTMAT
use caspt2_global, only: do_grad, do_lindep, idBoriMat, iPrGlb, LUSBT, LUSOLV, LUSTD, nStpGrd
use caspt2_module, only: BMatrix, BSpect, BTrans, Cases, IfDOrtho, nASup, nG3, nInDep, nISup, ThrShn, ThrShs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, ItoB

implicit none
integer(kind=iwp), intent(in) :: iSym, iCase
real(kind=wp), intent(out) :: CondNr, CPU
integer(kind=iwp) :: I, IDB, IDB2, IDIAG, IDS, IDST, IDT, IDTMP, IDTMP0, IJ, INFO, iPad, J, JOFF, KEND, KSTA, LTRANS1, NAS, NAUX, &
                     NB, NBNEW, NCOEF, NCOL, NIN, NIS, NS, NSCRATCH
real(kind=wp) :: CPU1, CPU2, CPUE, FP, SDIAG, SZ, SZMAX, SZMIN, TIO, TIOE, WGRONK(2)
real(kind=wp), allocatable :: AUX(:), B(:), BD(:), BX(:), EIG(:), S(:), SCA(:), SCRATCH(:), SD(:), ST(:), TRANS(:), VEC(:,:), XBX(:)
real(kind=wp), external :: DNRM2_

SDiag = Zero ! dummy initialize

CPU = Zero
CONDNR = Zero
NAS = NASUP(ISYM,ICASE)
NIS = NISUP(ISYM,ICASE)
NCOEF = NAS*NIS

if (NCOEF == 0) return

if (IPRGLB >= INSANE) &
  write(u6,'("DEBUG> ",A12,A7,I2,A2,A6,A2,A5,I1)') 'SBDIAG_SER: ','CASE ',ICASE,' (',CASES(ICASE),') ','SYM ',ISYM

IDTMP0 = 0
if (do_grad .or. (nStpGrd == 2)) then
  !! correct?
  iPad = ItoB-mod(6*NG3,ItoB)
  IDTMP0 = 6*NG3+iPad
end if

NS = nTri_Elem(NAS)
call mma_allocate(S,NS,Label='S')
IDS = IDSMAT(ISYM,ICASE)
call DDAFILE(LUSBT,2,S,NS,IDS)
if (IPRGLB >= INSANE) then
  FP = DNRM2_(NS,S,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'SMAT NORM: ',FP
end if

! For some purposes, we need to save the diagonal elements:
if (BMATRIX == 'YES') then
  if (BTRANS /= 'YES') then
    call mma_allocate(SD,NAS,Label='SD')
    IDIAG = 0
    do I=1,NAS
      IDIAG = IDIAG+I
      SD(I) = S(IDIAG)
    end do
  end if
end if

! FIRST, FIND NIN ORTHONORMAL VECTORS BY SCALED SYMMETRIC ON.
! Addition, for the scaled symmetric ON: the S matrix is scaled
! to make the diagonal elements close to 1.
! Extremely small values give scale factor exactly zero.
call mma_allocate(SCA,NAS,Label='SCA')
IDIAG = 0
do I=1,NAS
  IDIAG = IDIAG+I
  SDiag = S(IDIAG)
  if (IFDORTHO) then
    SCA(I) = One
  else
    if (SDiag > THRSHN) then
      ! Small variations of the scale factor were beneficial
      SCA(I) = (One+real(I,kind=wp)*3.0e-6_wp)/sqrt(SDiag)
    else
      SCA(I) = Zero
    end if
  end if
end do
IJ = 0
do J=1,NAS
  S(IJ+1:IJ+J) = S(IJ+1:IJ+J)*SCA(1:J)*SCA(J)
  IJ = IJ+J
end do
! End of addition.
if (IPRGLB >= INSANE) then
  FP = DNRM2_(NS,S,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'SMAT NORM AFTER SCALING: ',FP
end if

! DIAGONALIZE THE SCALED S MATRIX:
call mma_allocate(VEC,NAS,NAS,Label='VEC')
call mma_allocate(EIG,NAS,Label='EIG')

call TIMING(CPU1,CPUE,TIO,TIOE)
IJ = 0
do J=1,NAS
  VEC(1:J,J) = S(IJ+1:IJ+J)
  IJ = IJ+J
end do
INFO = 0
call dsyev_('V','L',NAS,VEC,NAS,EIG,WGRONK,-1,INFO)
NSCRATCH = int(WGRONK(1))
call mma_allocate(SCRATCH,NSCRATCH,Label='SCRATCH')
call dsyev_('V','U',NAS,VEC,NAS,EIG,SCRATCH,NSCRATCH,INFO)
call mma_deallocate(SCRATCH)
call mma_deallocate(S)

call TIMING(CPU2,CPUE,TIO,TIOE)
CPU = CPU+CPU2-CPU1
! fingerprint eigenvalues
if (iprglb >= insane) then
  fp = dnrm2_(nas,eig,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'Smat eigval norm: ',fp
end if

! Form orthonormal vectors by scaling eigenvectors
NIN = 0
do I=1,NAS
  if (EIG(I) > THRSHS) then
    NIN = NIN+1
    VEC(:,NIN) = VEC(:,I)/sqrt(EIG(I))
  end if
end do
NINDEP(ISYM,ICASE) = NIN
call mma_deallocate(EIG)
! Addition, for the scaled symmetric ON.
do I=1,NIN
  VEC(:,I) = SCA(:)*VEC(:,I)
end do

call mma_deallocate(SCA)
! The condition number, after scaling, disregarding linear dep.
if (NIN >= 2) then
  SZMIN = 1.0e99_wp
  SZMAX = Zero
  do I=1,NIN
    SZ = DNRM2_(NAS,VEC(:,I),1)
    SZMIN = min(SZMIN,SZ)
    SZMAX = max(SZMAX,SZ)
  end do
  CONDNR = (SZMAX/SZMIN)**2
end if
! End of addition.
if (NIN == 0) then
  call mma_deallocate(VEC)
  return
end if

if (BMATRIX == 'NO') then
  ! In some calculations, we do not use B matrices.
  ! Just write the transformation matrix and branch out:
  IDT = IDTMAT(ISYM,ICASE)
  call DDAFILE(LUSBT,1,VEC,NAS*NIN,IDT)
  call mma_deallocate(VEC)
  if (IPRGLB >= INSANE) write(u6,'("DEBUG> ",A)') 'SBDIAG: skip B matrix'
  return
else if (BTRANS /= 'YES') then
  ! In other calculations, B matrix is used, but not transformed.
  ! We may need the diagonal active energies: the diagonal values of
  ! B divided by the diagonal values of S. These are placed where
  ! the eigenvalues would go in ordinary CASPT2.
  ! NOTE: On LUSBT, the transformation matrices partly overwrite
  ! and destroy the B matrices. The diagonal elements of B must be
  ! extracted before the transformation matrix is written.
  call mma_allocate(BD,NAS,Label='BD')
  NB = nTri_Elem(NAS)
  call mma_allocate(B,NB,Label='B')
  IDB = IDBMAT(ISYM,ICASE)
  call DDAFILE(LUSBT,2,B,NB,IDB)
  IDIAG = 0
  do I=1,NAS
    IDIAG = IDIAG+I
    BD(I) = B(IDIAG)
  end do
  call mma_deallocate(B)
  ! Now, the transformation matrix can be written out.
  IDT = IDTMAT(ISYM,ICASE)
  call DDAFILE(LUSBT,1,VEC,NAS*NIN,IDT)
  call mma_deallocate(VEC)
  BD(:) = BD(:)/(SD(:)+1.0e-15_wp)
  IDB = IDBMAT(ISYM,ICASE)
  call DDAFILE(LUSBT,1,BD,NAS,IDB)
  call mma_deallocate(SD)
  call mma_deallocate(BD)
  if (IPRGLB >= INSANE) then
    write(u6,'("DEBUG> ",A)') 'SBDIAG: skip B matrix transformation'
    write(u6,'("DEBUG> ",A)') '        but keep B_ii/S_ii values'
  end if
  return
end if

! TRANSFORM B MATRIX TO O-N BASIS. BUT FIRST, SAVE O-N VECTORS.
! USE LUSOLV AS TEMPORARY STORAGE. WE MAY NEED SECTIONING.
! NOTE: SECTIONING MUST BE  PRECISELY THE SAME AS WHEN LATER
! READ BACK (SEE BELOW).
NAUX = min(19,NIN)
IDTMP = IDTMP0
call DDAFILE(LUSOLV,1,VEC,NAS*NAUX,IDTMP)
do KSTA=NAUX+1,NIN,NAUX
  KEND = min(KSTA-1+NAUX,NIN)
  NCOL = 1+KEND-KSTA
  call DDAFILE(LUSOLV,1,VEC(:,KSTA:KEND),NAS*NCOL,IDTMP)
end do
if (IPRGLB >= INSANE) then
  FP = DNRM2_(NAS**2,VEC,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'EIGENVECTOR NORM BEFORE B TRANS: ',FP
end if

! TRANSFORM B. NEW B WILL OVERWRITE AND DESTROY VEC
IDB = IDBMAT(ISYM,ICASE)
NB = NS
call mma_allocate(B,NB,Label='B')
call DDAFILE(LUSBT,2,B,NB,IDB)
if ((do_grad .or. (nStpGrd == 2)) .and. do_lindep) then
  !! The original B matrix is needed in the LinDepLag subroutine
  IDB2 = idBoriMat(ISYM,ICASE)
  call DDAFILE(LUSTD,1,B,NB,IDB2)
end if
if (IPRGLB >= INSANE) then
  FP = DNRM2_(NB,B,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'BMAT NORM: ',FP
end if

call mma_allocate(BX,NAS,Label='BX')
call mma_allocate(XBX,NAS,Label='XBX')
do J=NIN,1,-1
  BX(:) = Zero
# ifdef _CRAY_C90_
  call SSPMV('U',NAS,One,B,VEC(:,J),1,One,BX,1)
# else
  !call DSLMX(NAS,One,B,VEC(:,J),1,BX,1)
  call DSPMV_('U',NAS,One,B,VEC(:,J),1,One,BX,1)
# endif
  ! BX: B * Vector number J.
  XBX(1:J) = Zero
  call DGEMM_('T','N',J,1,NAS,One,VEC,NAS,BX,NAS,Zero,XBX,J)
  ! XBX CONTAINS NOW THE UPPERTRIANGULAR
  ! ELEMENTS OF THE J-th COLUMN OF TRANSFORMED B MATRIX.
  VEC(1:J,J) = XBX(1:J)
end do
call mma_deallocate(BX)
call mma_deallocate(XBX)
call mma_deallocate(B)
! VEC HAS NOW BEEN DESTROYED (OVERWRITTEN BY NEW B).
! COPY TO TRIANGULAR STORAGE.
NBNEW = nTri_Elem(NIN)
call mma_allocate(B,NBNEW,Label='B')
do J=1,NIN
  JOFF = nTri_Elem(J-1)
  B(JOFF+1:JOFF+J) = VEC(1:J,J)
end do
call mma_deallocate(VEC)
if (IPRGLB >= INSANE) then
  FP = DNRM2_(NBNEW,B,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'BMAT NORM AFTER TRANS: ',FP
end if

! DIAGONALIZE THE TRANSFORMED B MATRIX.
call mma_allocate(EIG,NIN,Label='EIG')
call mma_allocate(VEC,NIN,NIN,Label='VEC')
call TIMING(CPU1,CPUE,TIO,TIOE)
! - Alt 0: Use diagonal approxim., if allowed:
if (BSPECT /= 'YES') then
  IDIAG = 0
  write(u6,*) 'Sbdiag: THis code does not make sense!'
  write(u6,*) '        SDiag is not properly defined!'
  call Abend()
  do I=1,NIN
    IDIAG = IDIAG+I
    EIG(I) = B(IDIAG)/SDiag
  end do
else
  IJ = 0
  do J=1,NIN
    VEC(1:J,J) = B(IJ+1:IJ+J)
    IJ = IJ+J
  end do
  call DSYEV_('V','U',NIN,VEC,NIN,EIG,WGRONK,-1,INFO)
  NSCRATCH = int(WGRONK(1))
  call mma_allocate(SCRATCH,NSCRATCH,Label='SCRATCH')
  call DSYEV_('V','U',NIN,VEC,NIN,EIG,SCRATCH,NSCRATCH,INFO)
  call mma_deallocate(SCRATCH)
  call mma_deallocate(B)
end if
call TIMING(CPU2,CPUE,TIO,TIOE)
CPU = CPU+CPU2-CPU1
if (IPRGLB >= INSANE) then
  FP = DNRM2_(NIN,EIG,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'BMAT EIGENVALUE NORM: ',FP
end if

! The eigenvalues are written back at same position as the
! original B matrix, which is destroyed:
IDB = IDBMAT(ISYM,ICASE)
call DDAFILE(LUSBT,1,EIG,NIN,IDB)
call mma_deallocate(EIG)

! Finally, we must form the composite transformation matrix,
!  = (NAS*NIN matrix on disk) * (NIN*NIN matrix in core).
! Assume enough space since we got rid of S/B matrices.
! Specifically, assume we have enough space for the two
! full matrices, plus an additional 19 columns of results.
NAUX = min(19,NIN)
call mma_allocate(TRANS,NAS*NIN,Label='TRANS')
call mma_allocate(AUX,NAS*NAUX,Label='AUX')
IDTMP = IDTMP0
call DDAFILE(LUSOLV,2,AUX,NAS*NAUX,IDTMP)
if (BTRANS == 'YES') then
  call DGEMM_('N','N',NAS,NIN,NAUX,One,AUX,NAS,VEC,NIN,Zero,TRANS,NAS)
else
  TRANS(1:NAS*NAUX) = AUX(:)
end if
do KSTA=NAUX+1,NIN,NAUX
  KEND = min(KSTA-1+NAUX,NIN)
  NCOL = 1+KEND-KSTA
  call DDAFILE(LUSOLV,2,AUX,NAS*NCOL,IDTMP)
  if (BTRANS == 'YES') then
    call DGEMM_('N','N',NAS,NIN,NCOL,One,AUX,NAS,VEC(KSTA,1),NIN,One,TRANS,NAS)
  else
    LTRANS1 = NAS*(KSTA-1)
    TRANS(LTRANS1+1:LTRANS1+NAS*NCOL) = AUX(1:NAS*NCOL)
  end if
end do
call mma_deallocate(AUX)
call mma_deallocate(VEC)
IDT = IDTMAT(ISYM,ICASE)
call DDAFILE(LUSBT,1,TRANS,NAS*NIN,IDT)
if (IPRGLB >= INSANE) then
  FP = DNRM2_(NAS*NIN,TRANS,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'TMAT NORM: ',FP
end if

!-SVC: compute S*T and store on disk for later use by RHS vector utilities.
NS = nTri_Elem(NAS)
call mma_allocate(S,NS,Label='S')
IDS = IDSMAT(ISYM,ICASE)
call DDAFILE(LUSBT,2,S,NS,IDS)
call mma_allocate(ST,NAS*NIN,Label='ST')
ST(:) = Zero
call TRIMUL(NAS,NIN,One,S,TRANS,NAS,ST,NAS)
call mma_deallocate(S)
call mma_deallocate(TRANS)
IDST = IDSTMAT(ISYM,ICASE)
call DDAFILE(LUSBT,1,ST,NAS*NIN,IDST)
if (IPRGLB >= INSANE) then
  FP = DNRM2_(NAS*NIN,ST,1)
  write(u6,'("DEBUG> ",A,ES21.14)') 'STMAT NORM: ',FP
end if
call mma_deallocate(ST)

end subroutine SBDIAG_SER

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MATML4(C,A,B,NCROW,NCCOL,NAROW,NACOL,
     *                  NBROW,NBCOL,ITRNSP )
C
C     MULTIPLY A AND B TO GIVE C
C
C     C = A * B             FOR ITRNSP = 0
C     C = A(TRANSPOSED) * B FOR ITRNSP = 1
C     C = A * B(TRANSPOSED) FOR ITRNSP = 2
C
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION A(NAROW,NACOL)
      DIMENSION B(NBROW,NBCOL)
      DIMENSION C(NCROW,NCCOL)
C
      IZERO = 0
      IF ( (NAROW*NACOL*NBROW*NBCOL*NCROW*NCCOL).EQ.0 ) IZERO = 1
C
      IF ( ITRNSP.EQ.0 ) THEN
        IF ( IZERO.EQ.1 ) THEN
          CALL DCOPY_(NCROW*NCCOL,[0.0D0],0,C,1)
          DO J = 1,NCCOL
            DO K = 1,NBROW
              BKJ = B(K,J)
              CALL DAXPY_(NCROW,BKJ,A(1,K),1,C(1,J),1)
            END DO
          END DO
        ELSE
          CALL DGEMM_('N','N',
     &                NCROW,NCCOL,NACOL,
     &                1.0d0,A,NAROW,
     &                B,NBROW,
     &                0.0d0,C,NCROW)
        END IF
      END  IF
C
      IF ( ITRNSP.EQ.1 ) THEN
        IF ( IZERO.EQ.1 ) THEN
          DO J = 1, NCCOL
            DO I = 1, NCROW
              C(I,J) = DDOT_(NBROW,A(1,I),1,B(1,J),1)
            END DO
          END DO
        ELSE
          CALL DGEMM_('T','N',
     &                NCROW,NCCOL,NAROW,
     &                1.0d0,A,NAROW,
     &                B,NBROW,
     &                0.0d0,C,NCROW)
        END IF
      END IF
C
      IF ( ITRNSP.EQ.2 ) THEN
        IF ( IZERO.EQ.1 ) THEN
          CALL DCOPY_(NCROW*NCCOL,[0.0D0],0,C,1)
          DO J = 1,NCCOL
            DO K = 1,NBCOL
              BJK = B(J,K)
              CALL DAXPY_(NCROW,BJK,A(1,K),1,C(1,J),1)
            END DO
          END DO
        ELSE
          CALL DGEMM_('N','T',
     &                NCROW,NCCOL,NACOL,
     &                1.0d0,A,NAROW,
     &                B,NBROW,
     &                0.0d0,C,NCROW)
        END IF
      END IF
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

function MemSO1(lOper,iCmp,jCmp,iShell,jShell,iAO,jAO)
!***********************************************************************
!  Object: to compile the number of SO block which will be generated   *
!          by the current shell doublet.                               *
!          "lOper" is the irreducible representation of which the      *
!          operator of the one-electron matrix element belongs.        *
! Called from: OneEl                                                   *
!                                                                      *
! Calling    : None                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             February '90                                             *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden.                                         *
!             Modified to general non-symmetric operators January '91  *
!***********************************************************************

use SOAO_Info, only: iAOtSO
use Symmetry_Info, only: nIrrep
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: MemSO1
integer(kind=iwp), intent(in) :: lOper, iCmp, jCmp, iShell, jShell, iAO, jAO
integer(kind=iwp) :: j1, i1, j2, j12, jCmpMx, i2

MemSO1 = 0
do j1=0,nIrrep-1
  do i1=1,iCmp
    if (iAOtSO(iAO+i1,j1) < 0) cycle
    do j2=0,nIrrep-1
      j12 = ieor(j1,j2)
      if (.not. btest(lOper,j12)) cycle
      jCmpMx = jCmp
      if ((iShell == jShell) .and. (j1 == j2)) jCmpMx = i1
      do i2=1,jCmpMx
        if (iAOtSO(jAO+i2,j2) < 0) cycle
        MemSO1 = MemSO1+1
      end do
    end do
  end do
end do

return

end function MemSO1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine EvalERFun(ERFun,ERFunC,CMO,nOcc,nSym,Timing)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(out) :: ERFun
real(kind=wp), intent(_OUT_) :: ERFunC(*)
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp), intent(in) :: nSym, nOcc(nSym)
logical(kind=iwp), intent(in) :: Timing
integer(kind=iwp) :: irc
character(len=80) :: Txt
character(len=*), parameter :: SecNam = 'EvalERFun'

irc = 0
call Cho_Get_ER(irc,CMO,nOcc,ERFunC,ERFun,Timing)
if (irc /= 0) then
  write(Txt,'(A,I4)') 'Cho_Get_ER returned',irc
  call SysAbendMsg(SecNam,'ER evaluation failed!',Txt)
end if

end subroutine EvalERFun

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_XCV_RdVec(irc,Vec,l_Vec,NVT,myRankSP,n_myRankSP,J1,J2,iSym)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: Read partial Cholesky vectors J1 to J2 on disk.
!          (Parallel two-step algorithm)

#ifdef _DEBUGPRINT_
use Cholesky, only: Cho_Real_Par, nnBstRSh, nnShl, nSym, NumCho
#endif
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: l_Vec, NVT, n_myRankSP, myRankSP(n_myRankSP), J1, J2, iSym
real(kind=wp), intent(out) :: Vec(l_Vec)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, n
#endif

irc = 0
if ((n_myRankSP == 0) .or. (J2-J1+1 == 0)) return ! nothing to do

#ifdef _DEBUGPRINT_
if ((n_myRankSP < 1) .or. (n_myRankSP > nnShl) .or. (iSym < 1) .or. (iSym > nSym) .or. (NVT < 1)) then
  irc = -1
  return
end if
if ((J1 < 1) .or. (J1 > NVT) .or. (J2 < 1) .or. (J2 > NVT) .or. (J1 > J2) .or. (J2-J1+1 > NVT)) then
  irc = -2
  return
end if
n = nnBstRSh(iSym,myRankSP(1),2)*(J2-J1+1)
do i=2,n_myRankSP
  n = n+nnBstRSh(iSym,myRankSP(i),2)*(J2-J1+1)
end do
if (l_Vec < n) then
  irc = -3
  return
end if

if (.not. Cho_Real_Par) then
  if (NVT /= NumCho(iSym)) then
    irc = -4
    return
  end if
  n = 0
  do i=1,n_myRankSP
    if (myRankSP(i) /= i) n = n+1
  end do
  if (n /= 0) then
    irc = -5
    return
  end if
end if
#endif

! Block read on temp files
call Cho_XCV_RdVec_(irc,Vec,myRankSP,n_myRankSP,NVT,J1,J2,iSym)

end subroutine Cho_XCV_RdVec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Get_Orb_Select(irc,CMO,XMO,Eorb,Smat,Saa,Name,NamAct,
     &                          nSym,nActa,mOrb,nBas,ortho,ThrSel,n_OK)

************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
      Real*8  CMO(*), XMO(*), Eorb(*), Smat(*), Saa(*), ThrSel
      Integer irc, nSym, nActa, mOrb(nSym), nBas(nSym), n_OK(nSym)
      Character*(LENIN8)  Name(*)
      Character*(LENIN) NamAct(nActa)
      Logical ortho
#include "WrkSpc.fh"
      Character*(LENIN) tmp
************************************************************************
      jD(i) = iWork(ip_iD-1+i)
******
      kD(i) = iWork(ip_iD+nBmx-1+i)
******
      lD(i) = iWork(ip_iD+nBmx+nOrbmx-1+i)
************************************************************************
*
      irc=0
*
      nBmx=0
      nOrbmx=0
      Do iSym=1,nSym
         nBmx=Max(nBmx,nBas(iSym))
         nOrbmx=Max(nOrbmx,mOrb(iSym))
      End Do
      Call GetMem('iD','Allo','Inte',ip_iD,2*nOrbmx+nBmx)
      Call GetMem('Smx','Allo','Real',iSQ,nBmx**2)
      Call GetMem('LCMO','Allo','Real',ip_C,(5*nBmx+nOrbmx+3)*nOrbmx)
      lScr=nBmx*nOrbmx
      ip_CC=ip_C+lScr
      ip_X=ip_CC+lScr
      iZ=ip_X+lScr
      ipScr=iZ+lScr
      ip_U=ipScr+lScr
      iQ=ip_U+nOrbmx**2
      ip_Fock=iQ+nOrbmx
      jp_Fock=ip_Fock+nOrbmx
      Call Fzero(Work(iQ),nOrbmx)
*
      iOff=0
      jOff=0
      kOff=0
      lOff=0
      Do iSym=1,nSym

         nBa=0
         Do ia=1,nBas(iSym)
            ja=ia+iOff
            tmp=Name(ja)(1:LENIN)
            Do j=1,nActa
               If(NamAct(j).eq.tmp) Then
                  iWork(ip_iD+nBa)=ia
                  nBa=nBa+1
               EndIf
            End Do
         End Do
         Do ia=1,nBa
            ifr=jOff+jD(ia)
            ito=ip_C+ia-1
            call dcopy_(mOrb(iSym),Xmo(ifr),nBas(iSym),Work(ito),nBa)
         End Do
         iS=kOff+1
         Do ia=1,nBa
            jb=jD(ia)
            jfr=iS+nBas(iSym)*(jb-1)
            jto=iSQ+nBas(iSym)*(ia-1)
            call dcopy_(nbas(iSym),Smat(jfr),1,Work(jto),1)
         End Do
         nBx=Max(1,nBas(iSym))
         nBax=Max(1,nBa)
         Call DGEMM_('T','N',nBa,mOrb(iSym),nBas(iSym),
     &                    1.0d0,Work(iSQ),nBx,
     &                          Xmo(jOff+1),nBx,
     &                    0.0d0,Work(iZ),nBax)
         Do i=0,mOrb(iSym)-1
            jQ=iQ+i
            jC=ip_C+nBa*i
            jZ=iZ+nBa*i
            Work(jQ)=ddot_(nBa,Work(jC),1,Work(jZ),1)**2
         End Do
         n_OK(iSym)=0
         n_KO=0
         Do i=1,mOrb(iSym)
            ThrS=ThrSel*Saa(lOff+i)
            jQ=iQ+i-1
            jfr=jOff+nBas(iSym)*(i-1)+1
            If (sqrt(Work(jQ)).ge.ThrS) Then
               jX=ip_X+nBas(iSym)*n_OK(iSym)
               call dcopy_(nBas(iSym),Xmo(jfr),1,Work(jX),1)
               iWork(ip_iD+nBmx+n_OK(iSym))=i
               n_OK(iSym)=n_OK(iSym)+1
            Else
               jZ=iZ+nBas(iSym)*n_KO
               call dcopy_(nBas(iSym),Xmo(jfr),1,Work(jZ),1)
               iWork(ip_iD+nBmx+nOrbmx+n_KO)=i
               n_KO=n_KO+1
            EndIf
         End Do
*
         mOx=Max(1,mOrb(iSym))

         If (.not.ortho) Then

            Call Ortho_orb(Work(ip_X),Smat(iS),nBas(iSym),
     &                     n_OK(iSym),2,.false.)
            Call Ortho_orb(Work(iZ),Smat(iS),nBas(iSym),
     &                     n_KO,2,.false.)
         EndIf
*
         Call DGEMM_('T','N',mOrb(iSym),nBas(iSym),nBas(iSym),
     &                           1.0d0,Cmo(jOff+1),nBx,
     &                                 Smat(iS),nBx,
     &                           0.0d0,Work(ip_CC),mOx)

         If (n_KO .gt. 0) Then
           Call DGEMM_('N','N',mOrb(iSym),n_KO,nBas(iSym),
     &                             1.0d0,Work(ip_CC),mOx,
     &                                   Work(iZ),nBx,
     &                             0.0d0,Work(ip_U),mOx)

           Call Get_Can_Lorb(Eorb(lOff+1),Work(ip_Fock),n_KO,mOrb(iSym),
     &                     iWork(ip_iD+nBmx+nOrbmx),Work(ip_U),iSym)

           Call DGEMM_('N','N',nBas(iSym),n_KO,n_KO,
     &                  1.0d0,Work(iZ),nBx,
     &                        Work(ip_U),n_KO,
     &                  0.0d0,Work(ipScr),nBx)
*
*  Reorder the final MOs such that those of the active site come first
           km=jOff+nBas(iSym)*n_OK(iSym)+1
           call dcopy_(nBas(iSym)*n_KO,Work(ipScr),1,Cmo(km),1)
           call dcopy_(nOrbmx,Work(ip_Fock),1,Work(jp_Fock),1)
         EndIf
*
         Call DGEMM_('N','N',mOrb(iSym),n_OK(iSym),nBas(iSym),
     &                           1.0d0,Work(ip_CC),mOx,
     &                                 Work(ip_X),nBx,
     &                           0.0d0,Work(ip_U),mOx)
*
         Call Get_Can_Lorb(Eorb(lOff+1),Work(ip_Fock),n_OK(iSym),
     &                     mOrb(iSym),
     &                     iWork(ip_iD+nBmx),Work(ip_U),iSym)
*
         nOx=Max(1,n_OK(iSym))
         Call DGEMM_('N','N',nBas(iSym),n_OK(iSym),n_OK(iSym),
     &                1.0d0,Work(ip_X),nBx,
     &                      Work(ip_U),nOx,
     &                0.0d0,Work(ipScr),nBx)
*
         Do i=1,n_OK(iSym)
            j=kD(i)
            k=lOff+i
            l=ip_Fock+j-1
            Eorb(k)=Work(l)
         End Do
         km=jOff+1
         call dcopy_(nBas(iSym)*n_OK(iSym),Work(ipScr),1,Cmo(km),1)
*
         Do i=1,n_KO
            j=lD(i)
            k=lOff+n_OK(iSym)+i
            l=jp_Fock+j-1
            Eorb(k)=Work(l)
         End Do
*
         iOff=iOff+nBas(iSym)
         jOff=jOff+nBas(iSym)*mOrb(iSym)
         kOff=kOff+nBas(iSym)**2
         lOff=lOff+mOrb(iSym)
      End Do

      Call GetMem('LCMO','Free','Real',ip_C,(5*nBmx+nOrbmx+3)*nOrbmx)
      CALL GetMem('Smx','Free','Real',iSQ,nBmx**2)
      Call GetMem('iD','Free','Inte',ip_iD,2*nOrbmx+nBmx)

      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine Get_Can_Lorb(Ene,Fock,nO,nX,jOrb,Umat,iSym)

      Implicit Real*8 (a-h,o-z)
      Real*8  Ene(*), Fock(*), Umat(*)
      Integer nO, nX, jOrb(nO), iSym
#include "WrkSpc.fh"
*
*
      If (nO.lt.1)  Return
*
      Call GetMem('eta_ik','Allo','Real',ip_eta,2*nX**2+1)
      ip_Z=ip_eta+nX**2
      ip_ZZ=ip_Z+nX
      Call FZero(Work(ip_eta),nX**2)
      Do i=1,nX
         ii=ip_eta+nX*(i-1)+i-1
         Work(ii)=Ene(i)
      End Do
*
      nXx=Max(1,nX)
      nOx=Max(1,nO)
      Call DGEMM_('N','N',nX,nO,nX,1.0d0,Work(ip_eta),nXx,
     &                                  Umat(1),nXx,
     &                            0.0d0,Work(ip_Z),nXx)
      Call DGEMM_('T','N',nO,nO,nX,1.0d0,Umat(1),nXx,
     &                                  Work(ip_Z),nXx,
     &                            0.0d0,Work(ip_eta),nOx)

      Call Eigen_Molcas(nO,Work(ip_eta),Work(ip_Z),Work(ip_ZZ))

      call dcopy_(nO**2,Work(ip_eta),1,Umat,1)
      Do i=1,nO
         ii=ip_Z+i-1
         j=jOrb(i)
         Fock(j)=Work(ii)
         kk=ip_ZZ+i-1
      End Do
      Call GetMem('eta_ik','Free','Real',ip_eta,2*nX**2+1)

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iSym)
      End
************************************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine inidf
cbs   initializes the df on common block  with double facultatives
      implicit real*8 (a-h,o-z)
#include "para.fh"
#include "param.fh"
#include "dofuc.fh"
      df(0)=1.d0
      df(1)=1.d0
      do irun=2,ndfmx
      df(irun)=DBLE(irun)*df(irun-2)
      enddo
      do jbm=0,ndfmx-1
      do ibm=jbm,ndfmx
      dffrac(ibm,jbm)=df(ibm)/df(jbm)
      enddo
      enddo
      do jbm=1,ndfmx
      do ibm=0,jbm-1
      dffrac(ibm,jbm)=1d0/dffrac(jbm,ibm)
      enddo
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2002, Pawel Salek                                      *
!               2002, Mark A. Watson                                   *
!***********************************************************************

module fmm_tree_buffer
! Pawel Salek
! approx. 2002.05.13
! Mark Watson : Sep. 2002.
! Generalised to allow for translation pairs too.
! i.e. can store and evaluate on the fly W-pairs
! Also included field for dynamic LMAX
!
! fmm_tree_buffer packs together interaction pairs having same R vector
! to reduce the cost of generating interactions matrices T - the matrix
! is constructed only once for entire set.
! This module needs a routine that will evaluate entire set corresponding
! to same R vector.
!
! One limitation cast on the implementation is to use possibly
! large but limited memory resources. This requires an ability to evaluate
! and expunge occasionally the interaction sets as they are created.
!
! The pack_inter_tree is used to find out unique translation vectors.
! This is done by sorting all translation vectors first into
! surfaces, then into lines within surfaces, and finally into
! unique points.

use fmm_global_paras, only: INTK, REALK, T_paras, T_pair_single, T_pair_list, DISTINCT_T_TOL, MAX_AVG_PER_NODE, &
                            SORT_BY_RHS_MMS, START_LEN, One
use fmm_stats, only: stat_tpack_chunks, stat_tpack_total, stat_tpack_unique
use fmm_utils, only: fmm_quit

! Public functions:
public :: fmm_tree_buffer_init, &
          fmm_tree_buffer_finish, &
          fmm_tree_buffer_add

! Public types:
public :: PointNode

private
integer(INTK), save :: pack_sort_order

! PointNode: private structure used
! for on-the-fly packing of the interactions.
!
type PointNode
  integer(INTK)            :: level !for debugging:1-plane, 2-line, etc
  real(REALK)              :: coord ! normalized, the vector scale==1
  type(PointNode), pointer :: left, right
  ! the one below used by non-leaves only
  type(PointNode), pointer :: this ! for level==1: this plane,
  !     level==2: this line
  !     level==3: self (for consistency)
  ! the three below used by leaves only (i.e. ones with level==3)
  type(T_paras), pointer   :: abl1l2(:)
  ! largest LMAX in each abl1l2 set stored here
  integer(INTK)            :: entries_used
  integer(INTK)            :: LHS_LMAX, RHS_LMAX, LMAX
  ! For translations must know if qlm or Vff translation
  character                :: N_or_T
end type PointNode

! PRIVATE DATA
! pack_inter_tree is a pack-on-the-fly, evaluate-when-needed structure for
! efficient, memory-adapted, R-vector packed evaluation of the
! interaction pairs.
type(PointNode), allocatable, target, save :: pack_inter_tree(:)
integer(INTK), save :: pack_inter_tree_used
integer(INTK), save :: pack_total_in_current_chunk

contains

!---------------------------------------------------------------------------
! fmm_tree_buffer_init:
! initialize data structures and counters when starting packing the tree.
! interaction sorting depends on whether the contraction scheme is
! T-matrix driven or U-matrix driven.  Here we initialise a
! module-wide logical to determine this for all schemes
!
subroutine fmm_tree_buffer_init(t_size,sort_order)
  implicit none
  integer(INTK), intent(in) :: t_size
  integer(INTK), intent(in) :: sort_order

  allocate(pack_inter_tree(t_size))
  pack_inter_tree_used = 0
  pack_sort_order = sort_order
  pack_total_in_current_chunk = 0
end subroutine fmm_tree_buffer_init

!---------------------------------------------------------------------------

subroutine fmm_tree_buffer_finish(pack_ev)
  implicit none
  external :: pack_ev
  type(PointNode), pointer :: root

  if (pack_inter_tree_used > 0) then
    root => pack_inter_tree(1)
    call fmm_tpack_process(root,pack_ev)
    pack_inter_tree_used = 0
    pack_total_in_current_chunk = 0
  end if
  if (allocated(pack_inter_tree)) deallocate(pack_inter_tree)
end subroutine fmm_tree_buffer_finish

!---------------------------------------------------------------------------

subroutine fmm_tpack_process(root,pack_ev)
  implicit none
  type(PointNode), pointer :: root
  external                 :: pack_ev

  integer(INTK) :: i

  call node_evaluator(root,1,pack_ev)

  do i=1,pack_inter_tree_used
    if (associated(pack_inter_tree(i)%abl1l2)) deallocate(pack_inter_tree(i)%abl1l2)
    nullify(pack_inter_tree(i)%abl1l2) ! not strictly neccesary
  end do
  pack_inter_tree_used = 0
  pack_total_in_current_chunk = 0
  nullify(root)
end subroutine fmm_tpack_process

!====================================================================
! point_node_new:
! NOTE: we choose for conveninence that:
! a). non-leaves have abl1l2 not associated.
! b). leaves have leaf%this => leaf
recursive subroutine point_node_new(node,level,r,ll,lr,lm,NT,T_pair)
  implicit none
  type(PointNode), pointer  :: node
  type(T_paras), intent(in) :: T_pair
  real(REALK), intent(in)   :: r(3)
  integer(INTK), intent(in) :: level
  ! put these variables in a TYPE ??
  integer(INTK), intent(in) :: ll, lr, lm
  ! For translations must know if qlm or Vff translation
  character, intent(in)     :: NT

  pack_inter_tree_used = pack_inter_tree_used+1
  node => pack_inter_tree(pack_inter_tree_used)
  node%level = level
  node%coord = r(level)
  nullify(node%left)
  nullify(node%right)
  if (level < 3) then
    nullify(node%abl1l2)
    call point_node_new(node%this,level+1,r,ll,lr,lm,NT,T_pair)
  else
    stat_tpack_unique = stat_tpack_unique+1
    node%this => node
    node%entries_used = 1
    node%LMAX = lm
    node%LHS_LMAX = ll
    node%RHS_LMAX = lr
    node%N_or_T = NT
    allocate(node%abl1l2(START_LEN))
    node%abl1l2(1) = T_pair
  end if
end subroutine point_node_new

!---------------------------------------------------------------------------
! node_evaluator:
! walks over the tree and evaluates the interaction pairs.
!
recursive subroutine node_evaluator(node,level,pack_ev)
  implicit none
  type(PointNode), pointer  :: node
  integer(INTK), intent(in) :: level
  external                  ::  pack_ev   ! pair evaluator

  real(REALK), save :: r(3)

  if (.not. associated(node)) return
  if (associated(node%left)) call node_evaluator(node%left,level,pack_ev)
  if (associated(node%right)) call node_evaluator(node%right,level,pack_ev)
  r(level) = node%coord
  if (level < 3) then
    call node_evaluator(node%this,level+1,pack_ev)
  else
    ! evaluate current point using provided evaluator.
    ! We sort node%ratio node%abl1l2 wrt to abl1l2(:)%RHS_id first.
    if (node%entries_used > 1) then
      call momentsort(node%abl1l2,node%entries_used)
    end if
    call fmm_interface_T_pair_out(pack_ev,r,node)
  end if

end subroutine node_evaluator

!---------------------------------------------------------------------------

subroutine momentsort(abl1l2,N)
  implicit none
  type(T_paras), intent(inout) :: abl1l2(:)
  integer(INTK), intent(in)    :: N
  type(T_paras) :: idxs
  integer(INTK) :: i

  do i=N/2,1,-1
    call downheap(abl1l2,i,N)
  end do

  ! abl1l2[1..N] is a heap now

  do i=N,1,-1
    idxs = abl1l2(i)
    abl1l2(i) = abl1l2(1)
    abl1l2(1) = idxs
    call downheap(abl1l2,1,i-1) ! restore a[1..i-1] heap
  end do
end subroutine momentsort

!---------------------------------------------------------------------------

subroutine downheap(abl1l2,lo,hi)
  implicit none
  type(T_paras), intent(inout) :: abl1l2(:)
  integer(INTK), intent(in)    :: lo, hi

  !  PRE: a[lo+1..hi] is a heap
  ! POST:  a[lo..hi]  is a heap
  type(T_paras) :: idxs
  integer(INTK) :: idx, child

  idxs = abl1l2(lo)

  idx = lo
  makeheap: do while (idx <= hi/2) ! while k has child(s)
    child = 2*idx
    ! pick larger child...
    if (child < hi) then ! exists right branch
      if (pack_sort_order == SORT_BY_RHS_MMS) then
        if ((abl1l2(child)%RHS_id < abl1l2(child+1)%RHS_id) .or. &
            ((abl1l2(child)%RHS_id == abl1l2(child+1)%RHS_id) .and. &
             (abl1l2(child)%ratio < abl1l2(child+1)%ratio))) child = child+1
      else
        if ((abl1l2(child)%ratio < abl1l2(child+1)%ratio) .or. &
            ((abs(abl1l2(child)%ratio-abl1l2(child+1)%ratio) < DISTINCT_T_TOL) .and. &
             (abl1l2(child)%RHS_id < abl1l2(child+1)%RHS_id))) child = child+1
      end if
    end if
    if (pack_sort_order == SORT_BY_RHS_MMS) then
      if (idxs%RHS_id >= abl1l2(child)%RHS_id) exit makeheap
    else
      if (idxs%ratio >= abl1l2(child)%ratio) exit makeheap
    end if
    abl1l2(idx) = abl1l2(child)
    idx = child
  end do makeheap

  abl1l2(idx) = idxs
end subroutine downheap

!---------------------------------------------------------------------------
! fmm_tree_buffer_add:
! creates packed list of interactions corresponding to the same R.
! packing is done as-you-go, without creation of the intermediate
! unpacked list. Tree structure is used for sorting.
! Appends given data to specified tree.
! direction is a normalized r_pq with positive x component.
subroutine fmm_tree_buffer_add(pack_ev,T_pair_in)
  implicit none
  type(T_pair_single), intent(in) :: T_pair_in
  external                        ::  pack_ev ! packed pair evaluator

  ! Local variables.
  type(PointNode), pointer :: node
  type(T_paras), pointer :: newblock(:)
  type(T_paras) :: new_T_pair
  integer(INTK) :: level
  real(REALK) :: r_pq(3)
  real(REALK) :: direction(3), r_pq_scale
  ! orders of multipole expanions per node
  integer(INTK) :: ll, lr, lm
  ! for translations must know if qlm or Vff translation per node
  character :: NT

  r_pq = T_pair_in%r_ab
  new_T_pair = T_pair_in%paras
  NT = T_pair_in%N_or_T
  ll = T_pair_in%paras%LHS_LMAX
  lr = T_pair_in%paras%RHS_LMAX
  lm = T_pair_in%LMAX

  node => pack_inter_tree(1) ! root is the first element of pack_inter_tree
  if (pack_inter_tree_used+3 > size(pack_inter_tree) .or. pack_total_in_current_chunk > MAX_AVG_PER_NODE*size(pack_inter_tree)) then
    stat_tpack_chunks = stat_tpack_chunks+one
    call fmm_tpack_process(node,pack_ev)
  end if

  ! do the job
  stat_tpack_total = stat_tpack_total+1
  pack_total_in_current_chunk = pack_total_in_current_chunk+1
  r_pq_scale = sqrt(sum(r_pq*r_pq))
  if (r_pq(1) < 0.0) r_pq_scale = -r_pq_scale
  direction = r_pq/r_pq_scale
  ! update ratio (r_ab is now the normalised vector)
  new_T_pair%ratio = r_pq_scale

  if (pack_inter_tree_used == 0) then
    call point_node_new(node,1_INTK,direction,ll,lr,lm,NT,new_T_pair)
    return
  end if

  ! level = 1 - searching for plane, 2 - searching for line, 3 - for point
  do level=1,3
    nodesearch: do while (abs(direction(level)-node%coord) > DISTINCT_T_TOL)
      if (direction(level) < node%coord) then
        if (.not. associated(node%left)) then
          call point_node_new(node%left,level,direction,ll,lr,lm,NT,new_T_pair)
          return
        else
          node => node%left
        end if
      else
        if (.not. associated(node%right)) then
          call point_node_new(node%right,level,direction,ll,lr,lm,NT,new_T_pair)
          return
        else
          node => node%right
        end if
      end if
    end do nodesearch
    node => node%this ! node%this points to node for leaves
  end do

  ! append to the current point. It is guaranteed to be the final point
  ! expand first data block if needed.
  if (node%entries_used == size(node%abl1l2)) then
    allocate(newblock(node%entries_used*2))
    !node%abl1l2(1:node%entries_used): index removed to avoid crash on IBM
    newblock(1:node%entries_used) = node%abl1l2
    deallocate(node%abl1l2)
    node%abl1l2 => newblock
  end if
  node%entries_used = node%entries_used+1
  if (node%N_or_T /= NT) call fmm_quit('inconsistent data in buffer node!')
  node%N_or_T = NT
  node%LHS_LMAX = max(node%LHS_LMAX,ll)
  node%RHS_LMAX = max(node%RHS_LMAX,lr)
  node%LMAX = max(node%LMAX,lm)
  node%abl1l2(node%entries_used) = new_T_pair

end subroutine fmm_tree_buffer_add

!---------------------------------------------------------------------------
! Here we transform the data of this packer (old) into the new format

subroutine fmm_interface_T_pair_out(pack_ev,r,node)

  implicit none
  type(PointNode), intent(in) :: node
  real(REALK), intent(in)     :: r(3)
  external                    :: pack_ev

  type(T_pair_list) :: T_pairs_out

  T_pairs_out%N_or_T = node%N_or_T
  T_pairs_out%r_ab = r  ! normalised vector
  T_pairs_out%paras => node%abl1l2(1:node%entries_used)

  T_pairs_out%LMAX = node%LMAX
  T_pairs_out%lm_max = (1+node%LMAX)**2
  T_pairs_out%LHS_LMAX = node%LHS_LMAX
  T_pairs_out%RHS_LMAX = node%RHS_LMAX

  call pack_ev(T_pairs_out)

end subroutine fmm_interface_T_pair_out

!---------------------------------------------------------------------------

end module fmm_tree_buffer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

#include "compiler_features.h"

module Basis_Info

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
private

public :: Basis_Info_Dmp, Basis_Info_Free, Basis_Info_Get, Basis_Info_Init, dbsc, Distinct_Basis_set_Centers, Gaussian_Type, &
          iCnttp_Dummy, Max_Shells, mGaussian_Type, MolWgh, nBas, nBas_Aux, nBas_Frag, nCnttp, nFrag_LineWords, Nuclear_Model, &
          PAMExp, Point_Charge, Shells

#include "Molcas.fh"
#include "itmax.fh"

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! D E C L A R E   D E R I V E D   T Y P E S
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Work in progress
!
! nCntr     : number of centers associated with a dbsc
! Coor      : the coordinates of a dbsc
!
! nM1       : number of ECP M1 type terms on the ith unique center
! M1xp      : ECP M1-type exponents for ith unique center
! M1cf      : ECP M1 type coefficients for ith unique cntr
! nM2       : number of ECP M2 type terms on the ith unique center
! M2xp      : ECP M2-type exponents for ith unique center
! M2cf      : ECP M2 type coefficients for ith unique cntr
!
! nFragType : number of unique centers in a fragment (0=not a frag)
! nFragCoor : total number of centers in a fragment
! nFragEner : number of orbital energies/occupied orbitals in a given fragment
! nFragDens : size of the fragments density matrix
! FragType  : the data of the fragment's unique centers (associated basis set, size nFragType)
! FragCoor  : the data of all fragment's centers (atom type / relative coordinates, size nFragCoor)
! FragEner  : the fragment's orbital's energies (size nFragEner)
! FragCoef  : the fragment's MO coefficients (size nFragDens*nFragEner)
! ECP       : Flag if dbsc is a ECP basis set
! Frag      : Flag if dbsc is a Fragment basis set
! Aux       : Flag if dbsc is an auxiliary basis set
! FOp       : Flag if dbsc has a Fock Operator
! IsMM      : integer flag to indicate that associated centers are treated as MM centers in QM/MM calculations

type Distinct_Basis_set_centers
  real(kind=wp), pointer :: Coor(:,:) => null()
  real(kind=wp), allocatable :: Coor_Hidden(:,:)
  integer(kind=iwp) :: nCntr = 0
  integer(kind=iwp) :: nM1 = 0
  real(kind=wp), allocatable :: M1xp(:), M1cf(:)
  integer(kind=iwp) :: nM2 = 0
  real(kind=wp), allocatable :: M2xp(:), M2cf(:)
  integer(kind=iwp) :: nFragType = 0, nFragCoor = 0, nFragEner = 0, nFragDens = 0
  real(kind=wp), allocatable :: FragType(:,:), FragCoor(:,:), FragEner(:), FragCoef(:,:)
  logical(kind=iwp) :: lPAM2 = .false.
  integer(kind=iwp) :: nPAM2 = -1
  real(kind=wp), allocatable :: PAM2(:)
  logical(kind=iwp) :: ECP = .false.
  logical(kind=iwp) :: Aux = .false.
  logical(kind=iwp) :: Frag = .false.
  logical(kind=iwp) :: FOp = .false.
  integer(kind=iwp) :: IsMM = 0
  integer(kind=iwp) :: Parent_iCnttp = 0
  integer(kind=iwp) :: lOffAO = 0
  integer(kind=iwp) :: nOpt = 0
  integer(kind=iwp) :: mdci = 0
  integer(kind=iwp) :: iVal = 0, nVal = 0
  integer(kind=iwp) :: iPrj = 0, nPrj = 0
  integer(kind=iwp) :: iSRO = 0, nSRO = 0
  integer(kind=iwp) :: iSOC = 0, nSOC = 0
  integer(kind=iwp) :: kDel(0:iTabMx)
  integer(kind=iwp) :: iPP = 0, nPP = 0
  integer(kind=iwp) :: nShells = 0
  integer(kind=iwp) :: AtmNr = 0
  real(kind=wp) :: Charge = Zero
  logical(kind=iwp) :: NoPair = .false.
  logical(kind=iwp) :: SODK = .false.
  logical(kind=iwp) :: pChrg = .false.
  logical(kind=iwp) :: Fixed = .false.
  real(kind=wp) :: CrRep = Zero
  real(kind=wp) :: FragCharge = Zero
  real(kind=wp) :: aCD_Thr = One
  real(kind=wp) :: fmass = One
  real(kind=wp) :: CntMass = Zero
  real(kind=wp) :: ExpNuc = -One
  real(kind=wp) :: w_mGauss = One
# ifdef CHAR_MEMBER_INIT
  ! Some GCC versions give spurious warning with initialization of character members
  ! if there is more than one allocatable member...
  character(len=80) :: Bsl = '', Bsl_Old = ''
# else
  character(len=80) :: Bsl, Bsl_Old
# endif
end type Distinct_Basis_set_centers

! nExp   : number of exponents of the ith shell
! Exp    : the exponents of the ith shell
! nBasis : number of contracted radial functions of the ith shell
! Cff_c  : Contraction coefficients in processed and raw input form
! Cff_p  : Contraction coefficient in the case of no contraction, processed and raw
! Cff    : copy of Cff_c or Cff_p
! Transf : Cartesian transformed to real sphericals.
! Projct : real sphericals without contaminations (3s, 4d, etc.)
! Bk     : ECP proj shift parameters for ith shell, the number of parameters is given by nBasis
! Occ    : Occupation numbers for core ECP orbitals
! FockOp : the Fock operator matrix
! Aux    : Logical flag for auxiliary basis set shells
! Frag   : Logical flag for fragment shells

type Shell_Info
  integer(kind=iwp) :: nExp = 0
  real(kind=wp), allocatable :: Exp(:)
  integer(kind=iwp) :: nBasis = 0
  integer(kind=iwp) :: nBasis_c = 0
  real(kind=wp), allocatable :: pCff(:,:)
  real(kind=wp), allocatable :: Cff_c(:,:,:), Cff_p(:,:,:)
  logical(kind=iwp) :: Transf = .true.
  logical(kind=iwp) :: Prjct = .true.
  integer(kind=iwp) :: nBk = 0
  real(kind=wp), allocatable :: Bk(:)
  real(kind=wp), allocatable :: Occ(:)
  integer(kind=iwp) :: nAkl = 0
  real(kind=wp), allocatable :: Akl(:,:,:)
  integer(kind=iwp) :: nFockOp = 0
  real(kind=wp), allocatable :: FockOp(:,:)
  logical(kind=iwp) :: Aux = .false.
  logical(kind=iwp) :: Frag = .false.
  integer(kind=iwp) :: kOffAO = 0
end type Shell_Info

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! E N D   D E C L A R E   D E R I V E D   T Y P E S
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Actual content of Basis_Info

! MolWgh: integer flag to indicate the normalization of the symmetry transformation
!         0: double coset representative normalization
!         1: as in MOLECULE
!         2: as in MOLPRO

integer(kind=iwp), parameter :: Point_Charge = 0, Gaussian_Type = 1, mGaussian_Type = 2

real(kind=wp), allocatable :: PAMexp(:,:)
integer(kind=iwp) :: iCnttp_Dummy = 0, Max_Shells = 0, mFields = 11, MolWgh = 2, nBas(0:7) = 0, nBas_Aux(0:7) = 0, &
                     nBas_Frag(0:7) = 0, nCnttp = 0, nFields = 33+(1+iTabMx), nFrag_LineWords = 0, Nuclear_Model = Point_Charge
logical(kind=iwp) :: Initiated = .false.

type(Distinct_Basis_set_centers), allocatable, target :: dbsc(:)
type(Shell_Info), allocatable :: Shells(:)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Private extensions to mma interfaces

interface cptr2loff
  module procedure dbsc_cptr2loff
  module procedure shell_cptr2loff
end interface
interface mma_Allocate
  module procedure dbsc_mma_allo_1D, dbsc_mma_allo_1D_lim
  module procedure shell_mma_allo_1D, shell_mma_allo_1D_lim
end interface
interface mma_Deallocate
  module procedure dbsc_mma_free_1D
  module procedure shell_mma_free_1D
end interface

contains

!***********************************************************************
!***********************************************************************
!
! This to make either the initial allocation of dbsc and Shells according to the default sizes
! as defined by the parameters in Molcas.fh or according to the actual sizes as recorded on the
! run file.

subroutine Basis_Info_Init()

  use Definitions, only: u6

# include "macros.fh"
  unused_proc(mma_allocate(dbsc,[0,0]))
  unused_proc(mma_allocate(Shells,[0,0]))

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Enter Basis_Info_Init'
  write(u6,*)
# endif
  if (Initiated) then
    write(u6,*) ' Basis_Info already initiated!'
    write(u6,*) ' Maybe there is missing a Basis_Info_Free call.'
    call Abend()
  end if
  if (nCnttp == 0) then
    call mma_allocate(dbsc,Mxdbsc,label='dbsc')
  else
    call mma_allocate(dbsc,nCnttp,label='dbsc')
  end if
# ifndef CHAR_MEMBER_INIT
  ! See above
  dbsc(:)%Bsl = ''
  dbsc(:)%Bsl_Old = ''
# endif
  if (Max_Shells == 0) then
    call mma_allocate(Shells,MxShll,label='Shells')
  else
    call mma_allocate(Shells,Max_Shells,label='Shells')
  end if
  Initiated = .true.
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Exit Basis_Info_Init'
  write(u6,*)
# endif

  return

end subroutine Basis_Info_Init

!***********************************************************************
!***********************************************************************

subroutine Basis_Info_Dmp()

  use stdalloc, only: mma_allocate, mma_deallocate
  use Definitions, only: u6

  integer(kind=iwp) :: i, j, lcDmp, nAkl, nAtoms, nAux, nAux2, nBasis, nBk, nExp, nFockOp, nFragCoor, nM1, nM2
  integer(kind=iwp), allocatable :: iDmp(:,:)
  real(kind=wp), allocatable, target :: rDmp(:,:)
  real(kind=wp), pointer :: qDmp(:,:)
  character(len=2*80), allocatable :: cDmp(:)

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Enter Basis_Info_Dmp'
  write(u6,*)
  write(u6,*) 'Coordinates:'
  do i=1,nCnttp
    do j=1,dbsc(i)%nCntr
      write(u6,*) dbsc(i)%Coor(:,j)
    end do
  end do
# endif

  ! Integer dbsc stuff

  call mma_Allocate(iDmp,nFields,nCnttp+1,Label='iDmp')
  nAtoms = 0
  nAux = 0
  do i=1,nCnttp
    iDmp(1,i) = dbsc(i)%nCntr
    iDmp(2,i) = dbsc(i)%nM1
    iDmp(3,i) = dbsc(i)%nM2
    iDmp(4,i) = dbsc(i)%nFragType
    iDmp(5,i) = dbsc(i)%nFragCoor
    iDmp(6,i) = dbsc(i)%nFragEner
    iDmp(7,i) = dbsc(i)%nFragDens
    iDmp(8,i) = 0
    if (dbsc(i)%ECP) iDmp(8,i) = 1
    iDmp(9,i) = 0
    if (dbsc(i)%Frag) iDmp(9,i) = 1
    iDmp(10,i) = 0
    if (dbsc(i)%Aux) iDmp(10,i) = 1
    iDmp(11,i) = 0
    if (dbsc(i)%FOp) iDmp(11,i) = 1
    iDmp(12,i) = dbsc(i)%IsMM
    iDmp(13,i) = dbsc(i)%Parent_iCnttp
    iDmp(14,i) = dbsc(i)%lOffAO
    iDmp(15,i) = dbsc(i)%nOpt
    iDmp(16,i) = dbsc(i)%mdci
    iDmp(17,i) = dbsc(i)%iVal
    iDmp(18,i) = dbsc(i)%nVal
    iDmp(19,i) = dbsc(i)%iPrj
    iDmp(20,i) = dbsc(i)%nPrj
    iDmp(21,i) = dbsc(i)%iSRO
    iDmp(22,i) = dbsc(i)%nSRO
    iDmp(23,i) = dbsc(i)%iSOC
    iDmp(24,i) = dbsc(i)%nSOC
    iDmp(25,i) = dbsc(i)%iPP
    iDmp(26,i) = dbsc(i)%nPP
    iDmp(27,i) = dbsc(i)%nShells
    iDmp(28,i) = dbsc(i)%AtmNr
    iDmp(29,i) = 0
    if (dbsc(i)%NoPair) iDmp(29,i) = 1
    iDmp(30,i) = 0
    if (dbsc(i)%SODk) iDmp(30,i) = 1
    iDmp(31,i) = 0
    if (dbsc(i)%pChrg) iDmp(31,i) = 1
    iDmp(32,i) = 0
    if (dbsc(i)%Fixed) iDmp(32,i) = 1
    iDmp(33,i) = 0
    if (dbsc(i)%lPAM2) iDmp(33,i) = 1
    do j=0,iTabMx
      iDmp(34+j,i) = dbsc(i)%kDel(j)
    end do
    if ((.not. dbsc(i)%Aux) .or. (i == iCnttp_Dummy)) then
      nAtoms = nAtoms+dbsc(i)%nCntr
    end if
    nFragCoor = max(0,dbsc(i)%nFragCoor)  ! Fix the misuse in FragExpand
    nAux = nAux+2*dbsc(i)%nM1+2*dbsc(i)%nM2+nFrag_LineWords*dbsc(i)%nFragType+5*nFragCoor+dbsc(i)%nFragEner+ &
           dbsc(i)%nFragDens*dbsc(i)%nFragEner
#   ifdef _DEBUGPRINT_
    write(u6,'(A,8I4)') 'iCnttp=',i,nFrag_LineWords,dbsc(i)%nFragType,dbsc(i)%nFragCoor,dbsc(i)%nFragEner,dbsc(i)%nFragDens,nAux, &
                        dbsc(i)%iVal
#   endif

    if (dbsc(i)%nPAM2 /= -1) then
      write(u6,*) 'Not yet implemented for PAM2 integrals.'
      call Abend()
    end if
  end do
  iDmp(1,nCnttp+1) = nFrag_LineWords
  iDmp(2,nCnttp+1) = nCnttp
  iDmp(3,nCnttp+1) = iCnttp_Dummy
  iDmp(4,nCnttp+1) = Max_Shells
  iDmp(5,nCnttp+1) = Nuclear_Model
  iDmp(6:13,nCnttp+1) = nBas(0:7)
  iDmp(14:21,nCnttp+1) = nBas_Aux(0:7)
  iDmp(22:29,nCnttp+1) = nBas_Frag(0:7)
  iDmp(30,nCnttp+1) = MolWgh
  call Put_iArray('iDmp',iDmp,nFields*(nCnttp+1))
  call mma_deallocate(iDmp)

  ! Integer shells stuffs

  call mma_Allocate(iDmp,mFields,Max_Shells-1,Label='iDmp')
  nAux2 = 0
  do i=1,Max_Shells-1
    iDmp(1,i) = Shells(i)%nBK
    iDmp(2,i) = Shells(i)%nAkl
    iDmp(3,i) = Shells(i)%nFockOp
    iDmp(4,i) = Shells(i)%nExp
    iDmp(5,i) = Shells(i)%nBasis
    iDmp(6,i) = Shells(i)%nBasis_c
    iDmp(7,i) = 0
    if (Shells(i)%Transf) iDmp(7,i) = 1
    iDmp(8,i) = 0
    if (Shells(i)%Prjct) iDmp(8,i) = 1
    iDmp(9,i) = 0
    if (Shells(i)%Frag) iDmp(9,i) = 1
    iDmp(10,i) = 0
    if (Shells(i)%Aux) iDmp(10,i) = 1
    iDmp(11,i) = Shells(i)%kOffAO
    nAux2 = nAux2+2*Shells(i)%nBK+2*Shells(i)%nAkl**2+Shells(i)%nFockOp**2+Shells(i)%nExp+2*Shells(i)%nExp*Shells(i)%nBasis+ &
            2*Shells(i)%nExp**2
#   ifdef _DEBUGPRINT_
    write(u6,'(A,7I4)') 'iShll=',i,Shells(i)%nBK,Shells(i)%nAkl,Shells(i)%nFockOp,Shells(i)%nExp,Shells(i)%nBasis
#   endif

  end do
  call Put_iArray('iDmp:S',iDmp,mFields*(Max_Shells-1))
  call mma_deallocate(iDmp)

  ! Real Stuff

  call mma_allocate(rDmp,3,nAtoms+3*nCnttp,Label='rDmp')
  nAtoms = 0
  do i=1,nCnttp
    !call RecPrt('dbsc(i)%Coor',' ',dbsc(i)%Coor(1,1),3,dbsc(i)%nCntr)
    if ((.not. dbsc(i)%Aux) .or. (i == iCnttp_Dummy)) then
      do j=1,dbsc(i)%nCntr
        nAtoms = nAtoms+1
        rDmp(1:3,nAtoms) = dbsc(i)%Coor(1:3,j)
      end do
    end if
    nAtoms = nAtoms+1
    rDmp(1,nAtoms) = dbsc(i)%Charge
    rDmp(2,nAtoms) = dbsc(i)%CrRep
    rDmp(3,nAtoms) = dbsc(i)%FragCharge
    nAtoms = nAtoms+1
    rDmp(1,nAtoms) = dbsc(i)%aCD_Thr
    rDmp(2,nAtoms) = dbsc(i)%fMass
    rDmp(3,nAtoms) = dbsc(i)%CntMass
    nAtoms = nAtoms+1
    rDmp(1,nAtoms) = dbsc(i)%ExpNuc
    rDmp(2,nAtoms) = dbsc(i)%w_mGauss
    rDmp(3,nAtoms) = Zero
  end do
  call Put_dArray('rDmp',rDmp,3*nAtoms)
  call mma_deallocate(rDmp)

  if (nAux > 0) then
    !write(u6,*) 'nAux=',nAux
    call mma_allocate(rDmp,nAux,1,Label='rDmp')
    nAux = 0
    do i=1,nCnttp
      nM1 = dbsc(i)%nM1
      if (nM1 > 0) then
        !call RecPrt('M1xp',' ',dbsc(i)%M1xp,1,nM1)
        !call RecPrt('M1cf',' ',dbsc(i)%M1cf,1,nM1)
        rDmp(nAux+1:nAux+nM1,1) = dbsc(i)%M1xp(:)
        nAux = nAux+nM1
        rDmp(nAux+1:nAux+nM1,1) = dbsc(i)%M1cf(:)
        nAux = nAux+nM1
      end if
      nM2 = dbsc(i)%nM2
      if (nM2 > 0) then
        !call RecPrt('M2xp',' ',dbsc(i)%M2xp,1,nM2)
        !call RecPrt('M2cf',' ',dbsc(i)%M2cf,1,nM2)
        rDmp(nAux+1:nAux+nM2,1) = dbsc(i)%M2xp(:)
        nAux = nAux+nM2
        rDmp(nAux+1:nAux+nM2,1) = dbsc(i)%M2cf(:)
        nAux = nAux+nM2
      end if

      !write(u6,*) 'iAux=',nAux
      !write(u6,*) nFrag_LineWords, dbsc(i)%nFragType
      if (dbsc(i)%nFragType > 0) then
        qDmp(1:nFrag_LineWords,1:dbsc(i)%nFragType) => rDmp(nAux+1:nAux+nFrag_LineWords*dbsc(i)%nFragType,1)
        qDmp(:,:) = dbsc(i)%FragType(:,:)
        nAux = nAux+nFrag_LineWords*dbsc(i)%nFragType
        nullify(qDmp)
      end if
      !write(u6,*) dbsc(i)%nFragCoor
      nFragCoor = max(0,dbsc(i)%nFragCoor)
      if (nFragCoor > 0) then
        qDmp(1:5,1:nFragCoor) => rDmp(nAux+1:nAux+5*nFragCoor,1)
        qDmp(:,:) = dbsc(i)%FragCoor(:,:)
        nAux = nAux+5*nFragCoor
        nullify(qDmp)
      end if
      !write(u6,*) dbsc(i)%nFragEner
      if (dbsc(i)%nFragEner > 0) then
        rDmp(nAux+1:nAux+dbsc(i)%nFragEner,1) = dbsc(i)%FragEner(:)
        nAux = nAux+dbsc(i)%nFragEner
      end if
      !write(u6,*) dbsc(i)%nFragDens
      if (dbsc(i)%nFragDens*dbsc(i)%nFragEner > 0) then
        qDmp(1:dbsc(i)%nFragDens,1:dbsc(i)%nFragEner) => rDmp(nAux+1:nAux+dbsc(i)%nFragDens*dbsc(i)%nFragEner,1)
        qDmp(:,:) = dbsc(i)%FragCoef(:,:)
        nAux = nAux+dbsc(i)%nFragDens*dbsc(i)%nFragEner
        nullify(qDmp)
      end if
    end do
    !call RecPrt('rDmp:A',' ',rDmp,1,nAux)
    call Put_dArray('rDmp:A',rDmp,nAux)
    call mma_deallocate(rDmp)
  end if

  if (nAux2 > 0) then
    call mma_allocate(rDmp,nAux2,1,Label='rDmp')
    nAux2 = 0
    do i=1,Max_Shells-1
      nBk = Shells(i)%nBk
      if (nBk > 0) then
        rDmp(nAux2+1:nAux2+nBK,1) = Shells(i)%Bk(:)
        nAux2 = nAux2+nBK
        rDmp(nAux2+1:nAux2+nBK,1) = Shells(i)%Occ(:)
        nAux2 = nAux2+nBK
      end if
      nAkl = Shells(i)%nAkl
      if (nAkl > 0) then
        call DCopy_(2*nAkl**2,Shells(i)%Akl,1,rDmp(nAux2+1,1),1)
        nAux2 = nAux2+2*nAkl**2
      end if
      nFockOp = Shells(i)%nFockOp
      if (nFockOp > 0) then
        call DCopy_(nFockOp**2,Shells(i)%FockOp,1,rDmp(nAux2+1,1),1)
        nAux2 = nAux2+nFockOp**2
      end if
      nExp = Shells(i)%nExp
      if (nExp > 0) then
        call DCopy_(nExp,Shells(i)%Exp,1,rDmp(nAux2+1,1),1)
        nAux2 = nAux2+nExp
      end if
      nBasis = Shells(i)%nBasis
      ! Note: the contraction coefficients are not always there.
      if (nExp*nBasis > 0) then
        call DCopy_(2*nExp**2,Shells(i)%Cff_p,1,rDmp(nAux2+1,1),1)
        nAux2 = nAux2+2*nExp**2
      end if
      if (nExp*nBasis > 0) then
        call DCopy_(2*nExp*nBasis,Shells(i)%Cff_c,1,rDmp(nAux2+1,1),1)
        nAux2 = nAux2+2*nExp*nBasis
      end if
    end do
    call Put_dArray('rDmp:S',rDmp,nAux2)
    call mma_deallocate(rDmp)
  end if

  ! Character Stuff

  call mma_allocate(cDmp,nCnttp,Label='cDmp')
  do i=1,nCnttp
    cDmp(i)(1:80) = dbsc(i)%Bsl
    cDmp(i)(81:160) = dbsc(i)%Bsl_Old
  end do
  lcDmp = 2*80*nCnttp
  call Put_cArray('cDmp',cDmp(1),lcDmp)
  call mma_deallocate(cDmp)

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Exit Basis_Info_Dmp'
  write(u6,*)
# endif

  return

end subroutine Basis_Info_Dmp

!***********************************************************************
!***********************************************************************

subroutine Basis_Info_Get()

  use stdalloc, only: mma_allocate, mma_deallocate
  use Definitions, only: u6

  integer(kind=iwp) :: i, j, lcDmp, Len1, Len2, nAkl, nAtoms, nAux, nAux2, nBasis, nBK, nExp, nFockOp, nFragCoor, nFragDens, &
                       nFragEner, nFragType, nM1, nM2
  logical(kind=iwp) :: Found
  integer(kind=iwp), allocatable :: iDmp(:,:)
  real(kind=wp), allocatable, target :: rDmp(:,:)
  real(kind=wp), pointer :: pDmp(:), qDmp(:,:)
  character(len=2*80), allocatable :: cDmp(:)

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Enter Basis_Info_Get'
  write(u6,*)
# endif

  call qpg_iArray('iDmp',Found,Len1)
  Len2 = Len1/nFields
  call mma_Allocate(iDmp,nFields,Len2,Label='iDmp')
  if (Found) then
    call Get_iArray('iDmp',iDmp,Len1)
  else
    write(u6,*) 'Basis_Info_Get: iDmp not found!'
    call Abend()
  end if
  nFrag_LineWords = iDmp(1,Len2)
  nCnttp = iDmp(2,Len2)
  iCnttp_Dummy = iDmp(3,Len2)
  Max_Shells = iDmp(4,Len2)
  Nuclear_Model = iDmp(5,Len2)
  nBas(0:7) = iDmp(6:13,Len2)
  nBas_Aux(0:7) = iDmp(14:21,Len2)
  nBas_Frag(0:7) = iDmp(22:29,Len2)
  MolWgh = iDmp(30,Len2)
  nAux = 0

  ! Initiate the memory allocation of dsbc and Shells

  if (.not. Initiated) call Basis_Info_Init()

  do i=1,nCnttp
    dbsc(i)%nCntr = iDmp(1,i)
    dbsc(i)%nM1 = iDmp(2,i)
    dbsc(i)%nM2 = iDmp(3,i)
    dbsc(i)%nFragType = iDmp(4,i)
    dbsc(i)%nFragCoor = iDmp(5,i)
    dbsc(i)%nFragEner = iDmp(6,i)
    dbsc(i)%nFragDens = iDmp(7,i)
    dbsc(i)%ECP = iDmp(8,i) == 1
    dbsc(i)%Frag = iDmp(9,i) == 1
    dbsc(i)%Aux = iDmp(10,i) == 1
    dbsc(i)%FOp = iDmp(11,i) == 1
    dbsc(i)%IsMM = iDmp(12,i)
    dbsc(i)%Parent_iCnttp = iDmp(13,i)
    dbsc(i)%lOffAO = iDmp(14,i)
    dbsc(i)%nOpt = iDmp(15,i)
    dbsc(i)%mdci = iDmp(16,i)
    dbsc(i)%iVal = iDmp(17,i)
    dbsc(i)%nVal = iDmp(18,i)
    dbsc(i)%iPrj = iDmp(19,i)
    dbsc(i)%nPrj = iDmp(20,i)
    dbsc(i)%iSRO = iDmp(21,i)
    dbsc(i)%nSRO = iDmp(22,i)
    dbsc(i)%iSOC = iDmp(23,i)
    dbsc(i)%nSOC = iDmp(24,i)
    dbsc(i)%iPP = iDmp(25,i)
    dbsc(i)%nPP = iDmp(26,i)
    dbsc(i)%nShells = iDmp(27,i)
    dbsc(i)%AtmNr = iDmp(28,i)
    dbsc(i)%NoPair = iDmp(29,i) == 1
    dbsc(i)%SODK = iDmp(30,i) == 1
    dbsc(i)%pChrg = iDmp(31,i) == 1
    dbsc(i)%Fixed = iDmp(32,i) == 1
    dbsc(i)%lPAM2 = iDmp(33,i) == 1
    do j=0,iTabMx
      dbsc(i)%kDel(j) = iDmp(34+j,i)
    end do
    nFragCoor = max(0,dbsc(i)%nFragCoor)
    nAux = nAux+2*dbsc(i)%nM1+2*dbsc(i)%nM2+nFrag_LineWords*dbsc(i)%nFragType+5*nFragCoor+dbsc(i)%nFragEner+ &
           dbsc(i)%nFragDens*dbsc(i)%nFragEner
#   ifdef _DEBUGPRINT_
    write(u6,'(A,8I4)') 'iCnttp=',i,nFrag_LineWords,dbsc(i)%nFragType,dbsc(i)%nFragCoor,dbsc(i)%nFragEner,dbsc(i)%nFragDens,nAux, &
                        dbsc(i)%iVal
#   endif
  end do
  call mma_deallocate(iDmp)

  call qpg_iArray('iDmp:S',Found,Len1)
  call mma_Allocate(iDmp,mFields,Len1/mFields,Label='iDmp')
  if (Found) then
    call get_iArray('iDmp:S',iDmp,Len1)
  else
    write(u6,*) 'Basis_Info_Get: iDmp:S not found!'
    call Abend()
  end if
  nAux2 = 0
  do i=1,Max_Shells-1
    Shells(i)%nBK = iDmp(1,i)
    Shells(i)%nAkl = iDmp(2,i)
    Shells(i)%nFockOp = iDmp(3,i)
    Shells(i)%nExp = iDmp(4,i)
    Shells(i)%nBasis = iDmp(5,i)
    Shells(i)%nBasis_c = iDmp(6,i)
    Shells(i)%Transf = iDmp(7,i) == 1
    Shells(i)%Prjct = iDmp(8,i) == 1
    Shells(i)%Frag = iDmp(9,i) == 1
    Shells(i)%Aux = iDmp(10,i) == 1
    Shells(i)%kOffAO = iDmp(11,i)
    nAux2 = nAux2+2*Shells(i)%nBK+2*Shells(i)%nAkl**2+Shells(i)%nFockOp**2+Shells(i)%nExp
    ! Coefficients only there is nBasis =/=0
    if (Shells(i)%nBasis > 0) then
      nAux2 = nAux2+2*Shells(i)%nExp*Shells(i)%nBasis+2*Shells(i)%nExp**2
    end if
  end do
  call mma_deallocate(iDmp)

  call qpg_dArray('rDmp',Found,Len1)
  if (.not. Found) then
    write(u6,*) 'rDMP not found on the run file.'
    call Abend()
  end if
  nAtoms = Len1/3
  call mma_allocate(rDmp,3,nAtoms,Label='rDmp')
  call Get_dArray('rDmp',rDmp,3*nAtoms)
  nAtoms = 0
  do i=1,nCnttp
    if ((.not. dbsc(i)%Aux) .or. (i == iCnttp_Dummy)) then
      if (dbsc(i)%nCntr > 0) then
        call mma_Allocate(dbsc(i)%Coor_Hidden,3,dbsc(i)%nCntr,Label='dbsc:C')
        dbsc(i)%Coor => dbsc(i)%Coor_Hidden(:,:)
      end if
      do j=1,dbsc(i)%nCntr
        nAtoms = nAtoms+1
        dbsc(i)%Coor(1:3,j) = rDmp(1:3,nAtoms)
      end do
    else
      j = dbsc(i)%Parent_iCnttp
      dbsc(i)%Coor => dbsc(j)%Coor(1:3,1:dbsc(j)%nCntr)
    end if
    nAtoms = nAtoms+1
    dbsc(i)%Charge = rDmp(1,nAtoms)
    dbsc(i)%CrRep = rDmp(2,nAtoms)
    dbsc(i)%FragCharge = rDmp(3,nAtoms)
    nAtoms = nAtoms+1
    dbsc(i)%aCD_Thr = rDmp(1,nAtoms)
    dbsc(i)%fMass = rDmp(2,nAtoms)
    dbsc(i)%CntMass = rDmp(3,nAtoms)
    nAtoms = nAtoms+1
    dbsc(i)%ExpNuc = rDmp(1,nAtoms)
    dbsc(i)%w_mGauss = rDmp(2,nAtoms)
  end do
  call mma_deallocate(rDmp)

  if (nAux > 0) then
    call qpg_dArray('rDmp:A',Found,Len1)
    !write(u6,*) 'nAux=',nAux
    call mma_allocate(rDmp,nAux,1,Label='rDmp')
    call Get_dArray('rDmp:A',rDmp,Len1)
    nAux = 0
    do i=1,nCnttp

      ! ECP stuff

      nM1 = dbsc(i)%nM1
      if (nM1 > 0) then
        if (.not. allocated(dbsc(i)%M1xp)) call mma_allocate(dbsc(i)%M1xp,nM1,Label='dbsc:M1xp')
        dbsc(i)%M1xp(:) = rDmp(nAux+1:nAux+nM1,1)
        nAux = nAux+nM1
        if (.not. allocated(dbsc(i)%M1cf)) call mma_allocate(dbsc(i)%M1cf,nM1,Label='dbsc:M1cf')
        dbsc(i)%M1cf(:) = rDmp(nAux+1:nAux+nM1,1)
        nAux = nAux+nM1
        !call RecPrt('M1xp',' ',dbsc(i)%M1xp,1,nM1)
        !call RecPrt('M1cf',' ',dbsc(i)%M1cf,1,nM1)
      end if
      nM2 = dbsc(i)%nM2
      if (nM2 > 0) then
        if (.not. allocated(dbsc(i)%M2xp)) call mma_allocate(dbsc(i)%M2xp,nM2,Label='dbsc:M2xp')
        dbsc(i)%M2xp(:) = rDmp(nAux+1:nAux+nM2,1)
        nAux = nAux+nM2
        if (.not. allocated(dbsc(i)%M2cf)) call mma_allocate(dbsc(i)%M2cf,nM2,Label='dbsc:M2cf')
        dbsc(i)%M2cf(:) = rDmp(nAux+1:nAux+nM2,1)
        nAux = nAux+nM2
        !call RecPrt('M2xp',' ',dbsc(i)%M2xp,1,nM2)
        !call RecPrt('M2cf',' ',dbsc(i)%M2cf,1,nM2)
      end if

      ! Fragment stuff

      nFragType = dbsc(i)%nFragType
      if (nFragType > 0) then
        if (.not. allocated(dbsc(i)%FragType)) call mma_allocate(dbsc(i)%FragType,nFrag_LineWords,nFragType,Label='FragType')
        qDmp(1:nFrag_LineWords,1:nFragType) => rDmp(nAux+1:nAux+nFrag_LineWords*nFragType,1)
        dbsc(i)%FragType(:,:) = qDmp(:,:)
        nAux = nAux+nFrag_LineWords*nFragType
        nullify(qDmp)
      end if
      nFragCoor = max(0,dbsc(i)%nFragCoor)
      if (nFragCoor > 0) then
        if (.not. allocated(dbsc(i)%FragCoor)) call mma_allocate(dbsc(i)%FragCoor,5,nFragCoor,Label='FragCoor')
        qDmp(1:5,1:nFragCoor) => rDmp(nAux+1:nAux+5*nFragCoor,1)
        dbsc(i)%FragCoor(:,:) = qDmp(:,:)
        nAux = nAux+5*nFragCoor
        nullify(qDmp)
      end if
      nFragEner = dbsc(i)%nFragEner
      if (nFragEner > 0) then
        if (.not. allocated(dbsc(i)%FragEner)) call mma_allocate(dbsc(i)%FragEner,nFragEner,Label='FragEner')
        pDmp(1:nFragEner) => rDmp(nAux+1:nAux+nFragEner,1)
        dbsc(i)%FragEner(:) = pDmp(:)
        nAux = nAux+nFragEner
        nullify(pDmp)
      end if
      nFragDens = dbsc(i)%nFragDens
      if (nFragDens*nFragEner > 0) then
        if (.not. allocated(dbsc(i)%FragCoef)) call mma_allocate(dbsc(i)%FragCoef,nFragDens,nFragEner,Label='FragCoef')
        qDmp(1:nFragDens,1:nFragEner) => rDmp(nAux+1:nAux+nFragDens*nFragEner,1)
        dbsc(i)%FragCoef(:,:) = qDmp(:,:)
        nAux = nAux+nFragDens*nFragEner
        nullify(qDmp)
      end if
    end do
    call mma_deallocate(rDmp)
  end if

  if (nAux2 > 0) then
    call qpg_dArray('rDmp:S',Found,Len1)
    call mma_allocate(rDmp,nAux2,1,Label='rDmp')
    call Get_dArray('rDmp:S',rDmp,Len1)
    nAux2 = 0
    do i=1,Max_Shells-1

      nBk = Shells(i)%nBK
      if (nBk > 0) then
        if (.not. allocated(Shells(i)%Bk)) call mma_allocate(Shells(i)%Bk,nBk,Label='Bk')
        Shells(i)%Bk(:) = rDmp(nAux2+1:nAux2+nBk,1)
        nAux2 = nAux2+nBk
        if (.not. allocated(Shells(i)%Occ)) call mma_allocate(Shells(i)%Occ,nBk,Label='Occ')
        Shells(i)%Occ(:) = rDmp(nAux2+1:nAux2+nBk,1)
        nAux2 = nAux2+nBk
      end if

      nAkl = Shells(i)%nAkl
      if (nAkl > 0) then
        if (.not. allocated(Shells(i)%Akl)) call mma_allocate(Shells(i)%Akl,nAkl,nAkl,2,Label='Akl')
        call DCopy_(2*nAkl**2,rDmp(nAux2+1,1),1,Shells(i)%Akl,1)
        nAux2 = nAux2+2*nAkl**2
      end if

      nFockOp = Shells(i)%nFockOp
      if (nFockOp > 0) then
        if (.not. allocated(Shells(i)%FockOp)) call mma_allocate(Shells(i)%FockOp,nFockOp,nFockOp,Label='FockOp')
        call DCopy_(nFockOp**2,rDmp(nAux2+1,1),1,Shells(i)%FockOp,1)
        nAux2 = nAux2+nFockOp**2
      end if

      nExp = Shells(i)%nExp
      if (nExp > 0) then
        if (.not. allocated(Shells(i)%Exp)) call mma_allocate(Shells(i)%Exp,nExp,Label='Exp')
        call DCopy_(nExp,rDmp(nAux2+1,1),1,Shells(i)%Exp,1)
        nAux2 = nAux2+nExp
      end if

      nBasis = Shells(i)%nBasis
      if (nExp*nBasis > 0) then
        if (.not. allocated(Shells(i)%Cff_p)) call mma_allocate(Shells(i)%Cff_p,nExp,nExp,2,Label='Cff_p')
        call DCopy_(2*nExp**2,rDmp(nAux2+1,1),1,Shells(i)%Cff_p,1)
        nAux2 = nAux2+2*nExp**2
      end if

      if (nExp*nBasis > 0) then
        if (.not. allocated(Shells(i)%Cff_c)) call mma_allocate(Shells(i)%Cff_c,nExp,nBasis,2,Label='Cff_c')
        call DCopy_(2*nExp*nBasis,rDmp(nAux2+1,1),1,Shells(i)%Cff_c,1)
        nAux2 = nAux2+2*nExp*nBasis

        if (.not. allocated(Shells(i)%pCff)) call mma_allocate(Shells(i)%pCff,nExp,nBasis,Label='Cff')
        Shells(i)%pCff(:,:) = Shells(i)%Cff_c(:,:,1)
      end if
    end do
    call mma_deallocate(rDmp)
  end if

  ! Character stuff

  call mma_allocate(cDmp,nCnttp,Label='cDmp')
  lcDmp = 2*80*nCnttp
  call Get_cArray('cDmp',cDmp,lcDmp)
  do i=1,nCnttp
    dbsc(i)%Bsl = cDmp(i)(1:80)
    dbsc(i)%Bsl_Old = cDmp(i)(81:160)
  end do
  call mma_deallocate(cDmp)
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Coordinates:'
  do i=1,nCnttp
    do j=1,dbsc(i)%nCntr
      write(u6,*) dbsc(i)%Coor(:,j)
    end do
  end do
  write(u6,*)
  write(u6,*) 'Exit Basis_Info_Get'
  write(u6,*)
# endif

  return

end subroutine Basis_Info_Get

!***********************************************************************
!***********************************************************************

subroutine Basis_Info_Free()

  use stdalloc, only: mma_deallocate
# ifdef _DEBUGPRINT_
  use Definitions, only: u6
# endif

  integer(kind=iwp) :: i

# ifdef _DEBUGPRINT_
  write(u6,*) 'Basis_Info_Free()'
# endif

  ! Deallocate all allocatable parts of dbsc.

  do i=1,nCnttp

    ! Molecular Coordinates

    if (dbsc(i)%nCntr > 0) then
      if ((.not. dbsc(i)%Aux) .or. (i == iCnttp_Dummy)) then
        call mma_deallocate(dbsc(i)%Coor_Hidden)
      end if
      nullify(dbsc(i)%Coor)
      dbsc(i)%nCntr = 0
    end if

    ! ECP stuff

    if (allocated(dbsc(i)%M1xp)) call mma_deallocate(dbsc(i)%M1xp)
    if (allocated(dbsc(i)%M1cf)) call mma_deallocate(dbsc(i)%M1cf)
    dbsc(i)%nM1 = 0
    if (allocated(dbsc(i)%M2xp)) call mma_deallocate(dbsc(i)%M2xp)
    if (allocated(dbsc(i)%M2cf)) call mma_deallocate(dbsc(i)%M2cf)
    dbsc(i)%nM2 = 0

    ! Fragment stuff

    if (allocated(dbsc(i)%FragType)) call mma_deallocate(dbsc(i)%FragType)
    dbsc(i)%nFragType = 0
    if (allocated(dbsc(i)%FragCoor)) call mma_deallocate(dbsc(i)%FragCoor)
    dbsc(i)%nFragCoor = 0
    if (allocated(dbsc(i)%FragEner)) call mma_deallocate(dbsc(i)%FragEner)
    dbsc(i)%nFragEner = 0
    if (allocated(dbsc(i)%FragCoef)) call mma_deallocate(dbsc(i)%FragCoef)
    dbsc(i)%nFragDens = 0

    ! PAM2 stuff

    if (allocated(dbsc(i)%PAM2)) call mma_deallocate(dbsc(i)%PAM2)
    dbsc(i)%nPAM2 = -1
  end do
  nCnttp = 0
  iCnttp_Dummy = 0

  ! Stuff on unique basis set shells

  do i=1,Max_Shells-1
    if (allocated(Shells(i)%Bk)) call mma_deallocate(Shells(i)%Bk)
    if (allocated(Shells(i)%Occ)) call mma_deallocate(Shells(i)%Occ)
    Shells(i)%nBk = 0
    if (allocated(Shells(i)%Akl)) call mma_deallocate(Shells(i)%Akl)
    Shells(i)%nAkl = 0
    if (allocated(Shells(i)%FockOp)) call mma_deallocate(Shells(i)%FockOp)
    Shells(i)%nFockOp = 0
    if (allocated(Shells(i)%Exp)) call mma_deallocate(Shells(i)%Exp)
    Shells(i)%nExp = 0
    if (allocated(Shells(i)%pCff)) call mma_deallocate(Shells(i)%pCff)
    if (allocated(Shells(i)%Cff_c)) call mma_deallocate(Shells(i)%Cff_c)
    if (allocated(Shells(i)%Cff_p)) call mma_deallocate(Shells(i)%Cff_p)
    Shells(i)%nBasis = 0
    Shells(i)%Transf = .true.
  end do
  Max_Shells = 0

  if (allocated(dbsc)) call mma_deallocate(dbsc)
  if (allocated(Shells)) call mma_deallocate(Shells)
  Initiated = .false.

  return

end subroutine Basis_Info_Free

!***********************************************************************
!***********************************************************************

! Private extensions to mma_interfaces, using preprocessor templates
! (see src/mma_util/stdalloc.f)

! Define dbsc_cptr2loff, dbsc_mma_allo_1D, dbsc_mma_allo_1D_lim, dbsc_mma_free_1D
! (using _NO_GARBLE_ because all members are initialized)
#define _TYPE_ type(Distinct_Basis_set_centers)
#  define _NO_GARBLE_
#  define _FUNC_NAME_ dbsc_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ dbsc_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'dbsc_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#  undef _NO_GARBLE_
#undef _TYPE_

! Define shell_cptr2loff, shell_mma_allo_1D, shell_mma_allo_1D_lim, shell_mma_free_1D
! (using _NO_GARBLE_ because all members are initialized)
#define _TYPE_ type(Shell_Info)
#  define _NO_GARBLE_
#  define _FUNC_NAME_ shell_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ shell_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'shell_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#  undef _NO_GARBLE_
#undef _TYPE_

end module Basis_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Sort_mck(A,B,iBas,jBas,kBas,lBas,iCmp,jCmp,kCmp,lCmp,
     &               iBasO,jBasO,kBasO,lBasO,
     &               iCmpO,jCmpO,kCmpO,lCmpO,
     &               nVec,nop,iAng,
     &               indgrd,indgrd2,ishll,C)
************************************************************************
*                                                                      *
*     This subroutine is a stupid solution on a easy problem, but it   *
*     should work and it doesnt take to much CPU time.                 *
*     eaw                                                              *
*                                                                      *
************************************************************************
      Use Basis_Info
      use Real_Spherical, only: iSphCr
      use Symmetry_Info, only: nIrrep, iOper, iChBas
      Implicit Real*8(a-h,o-z)
#include "real.fh"
c#include "print.fh"
*
      Integer nop(4),iAng(4),indgrd(3,4,0:nirrep-1),
     &          indgrd2(3,4,0:nirrep-1),ishll(4)
      Real*8 A(iBas*jBas*kBas*lBas,
     &         iCmp,jCmp,kCmp,lCmp,nVec)
      Real*8 B(kBasO*kcmpO,lBasO,lcmpO,
     &         iBasO,iCmpO,jBasO,jCmpO*nvec)

      Real*8 prmt(0:7)
      Real*8 C(*)
*
      Data Prmt/1.d0,-1.d0,-1.d0,1.d0,-1.d0,1.d0,1.d0,-1.d0/
*
*     Statement Function
*
      xPrmt(i,j) = Prmt(iAnd(i,j))
      iOff(ixyz) = ixyz*(ixyz+1)*(ixyz+2)/6
*
      ii = iOff(iAng(1))
      jj = iOff(iAng(2))
      kk = iOff(iAng(3))
      ll = iOff(iAng(4))
*
      rp=1.0d0
      Do iVec=1,nVec
        Do iC=1,iCmp
         ichbs=ichbas(ii+ic)
         If (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+ic))
         PrA= xPrmt(iOper(nOp(1)),iChBs)
         Do jC=1,jCmp
          jChBs = iChBas(jj+jc)
          If (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+jc))
          pRb = xPrmt(iOper(nOp(2)),jChBs)
          Do kC=1,kCmp
           kChBs = iChBas(kk+kc)
           If (Shells(iShll(3))%Transf) kChBs = iChBas(iSphCr(kk+kc))
           pTc = xPrmt(iOper(nOp(3)),kChBs)
           Do lC=1,lCmp
            lChBs = iChBas(ll+lC)
            If (Shells(iShll(4))%Transf) lChBs = iChBas(iSphCr(ll+lc))
            pTSd= xPrmt(iOper(nOp(4)),lChBs)
            qFctr=pTSd*pTc*pRb*pRa*rp
**EAW 970930
*
*        Some machines dont support more than 7 indexes, need to fool around
*        to make it work
*
*           Do iB=1,iBas
*            Do jB=1,jBas
*             Do kB=1,kBas
*              Do lB=1,lBas
*               B(kB,kC,lB,lC,iB,iC,jB,jC,iVec)=
*    &            qfctr*A(iB,jB,kB,lB,iC,jC,kC,lC,iVec)
*              End Do
*             End Do
*            End Do
*           End Do
            ijkl=0
            Do lB=1,lBas
             Do kB=1,kBas
              Do jB=1,jBas
               Do iB=1,iBas
                ijkl=ijkl+1
                B(kB+(kC-1)*kbaso,lB,lC,iB,iC,jB,jC+(iVec-1)*jcmpO)=
     &            qfctr*A(ijkl,iC,jC,kC,lC,iVec)
               End Do
              End Do
             End Do
            End Do

*EAW 970930
           End Do
          End Do
         End Do
        End Do
      End Do
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(indgrd)
         Call Unused_integer_array(indgrd2)
         Call Unused_real_array(C)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine P_Int( &
#                define _CALLING_
#                include "int_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: to compute the multipole moments integrals with the          *
!         Gauss-Hermite quadrature.                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!             Modified to multipole moments November '90               *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: ia, ib, iIC, iPrint, iRout
character(len=80) :: Label

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(P)
unused_var(A)
unused_var(RB)
unused_var(nHer)
unused_var(Array)
unused_var(Ccoor)
unused_var(nOrdOp)
unused_var(lOper)
unused_var(iChO)
unused_var(iStabM)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 122
iPrint = nPrint(iRout)
! Observe that this code does not make any sense in case of symmetry!
rFinal(:,:,:,:) = Zero

if (iPrint >= 99) then
  write(u6,*) ' Result in P_Int'
  do ia=1,nTri_Elem1(la)
    do ib=1,nTri_Elem1(lb)
      do iIC=1,nIC
        write(Label,'(A,I2,A,I2,A,I2,A)') ' rFinal(a=',ia,',b=',ib,',iIC=',iIC,')'
        call RecPrt(Label,' ',rFinal(:,ia,ib,iIC),nAlpha,nBeta)
      end do
    end do
  end do
end if

return

end subroutine P_Int

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
CSVC: print a banner with module name and runtime information
      subroutine print_module_header(modulename)
#ifdef _OPENMP
*$    use omp_lib
#endif
      implicit none
      character(len=*) :: modulename

      character(len=100) :: line
      integer :: i

#include "para_info.fh"
#include "unixinfo.fh"
#ifdef _MOLCAS_MPP_
      integer :: nprocs_global
      integer, external :: GAnNodes
      character(len=16) :: proc
#endif
#include "WrkSpc.fh"
      real*8 :: bytes
      integer :: order, group
      character(len=3) :: unit(0:8) =
     & ['  B',' kB',' MB',' GB',' TB', ' PB', ' EB', ' ZB', ' YB']
      character(len=16) :: memory
      integer :: nthreads
      character(len=16) :: threads

      write (6,*)
      write (6,'(50a)')('()',i=1,50)

      write(6,'(a)')
      line = '&' // trim(modulename)
      call upcase(line)
      call center_text(line)
      write(6,'(a)') trim(line)
      write(6,'(a)')

#ifdef _MOLCAS_MPP_
      nprocs_global = GAnNodes()
      write(proc,'(I16)') nprocs_global
      if (nprocs_global.gt.1) then
        if (nprocs.gt.1) then
          line = 'launched '//trim(adjustl(proc))//' MPI processes, '//
     &           'running in PARALLEL mode (work-sharing enabled)'
        else
          line = 'launched '//trim(adjustl(proc))//' MPI processes, '//
     &           'running in SERIAL mode (work-sharing disabled)'
        end if
      else
        line = 'only a single process is used, running in SERIAL mode'
      end if
#else
      line = 'only a single process is used'
#endif
      call center_text(line)
      write(6,'(a)') trim(line)

#ifdef _OPENMP
      nthreads = omp_get_max_threads()
#else
      nthreads = 1
#endif

* mxmem is the number of 8-byte words (real*8) we have available.
      bytes = 8*mxmem
      order = FLOOR(LOG10(bytes))
      group = MIN(order/3,8)
      if (MOD(order,3).eq.0) then
        write (memory,'(F3.1,A)') bytes/10**(3*group),unit(group)
      else
        write (memory,'(I3,A)') INT(bytes/10**(3*group)),unit(group)
      end if
* report the maximum number of threads available
      if (nthreads.eq.1) then
        write (threads,'(A)') '1 thread'
      else
        write (threads,'(I8,A8)') nthreads, ' threads'
      end if
* if OPENMP is not compiled in, we don't know how many threads
* could be available in linear algebra libraries...
#ifndef _OPENMP
      threads=trim(threads)//'?'
#endif

      line = 'available to each process: '//
     &        trim(adjustl(memory))//' of memory, '//
     &        trim(adjustl(threads))
      call center_text(line)
      write(6,'(a)') trim(line)

      line = 'pid:'
#ifdef _MOLCAS_MPP_
      nprocs_global = GAnNodes()
      write(proc,'(I16)') nprocs_global
      if (nprocs_global.gt.1) then
        if (nprocs.gt.1) line = 'master pid:'
      end if
#endif
      write(line,'(a,1x,i0)') trim(line),pid
      call center_text(line)
      write(6,'(a)') trim(line)

      write (6,'(50a)')('()',i=1,50)
      write (6,*)
      end

      subroutine center_text(line)
CSVC: centers the text of a line
      implicit none
      character(len=*) :: line
      character(len=100) :: text
      integer :: linewidth, textwidth, textoffset

      text = adjustl(line)
      linewidth = len(line)
      textwidth = len_trim(text)
      textoffset = (linewidth-textwidth)/2
      line = ' '
      line(textoffset+1:textoffset+textwidth)=text
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine fout_cvb(f,a1,a2)
      implicit real*8 (a-h,o-z)
      character*(*) a1,a2
      character*15 b1
      character*46 b2
      character*12 b3
      save huge
      data huge/1d20/

      b1=a1
      b2=a2
      if(abs(f).ne.huge)then
        write(b3,'(d12.4)')f
      else
        b3='    Disabled'
      endif
      write(6,'(1x,3a)')b1,b2,b3
      return
      end
      subroutine fouti_cvb(fi,ni,a1,a2)
      implicit real*8 (a-h,o-z)
c      logical l
      character*(*) a1,a2
      character*15 b1
      character*46 b2
      character*12 b3
      dimension fi(ni)
      save huge
      data huge/1d20/
      b1=a1
      b2=a2
      b3='     ......'
      write(6,'(/,1x,3a)')b1,b2,b3
      b2=' '
c  Find IPOS : position of I index in string
      ichar0=ichar('0')
      ichar9=ichar('9')
      do ipos=15,1,-1
      if(ichar(b1(ipos:ipos)).ge.ichar0.and.
     >   ichar(b1(ipos:ipos)).le.ichar9)goto 100
      enddo
      write(6,*)' Fatal error in FOUTI!'
      call abend_cvb()
100   continue
      do i=1,ni
      if(abs(fi(i)).ne.huge)then
        write(b1(ipos:ipos),'(i1)')i
        write(b3,'(d12.4)')fi(i)
        write(6,'(1x,3a)')b1,b2,b3
      endif
      enddo
      return
      end
      subroutine foutij_cvb(fij,ni,nj,a1,a2)
      implicit real*8 (a-h,o-z)
c      logical l
      character*(*) a1,a2
      character*15 b1
      character*46 b2
      character*12 b3
      dimension fij(ni,nj)
      save huge
      data huge/1d20/
      b1=a1
      b2=a2
      b3='     ......'
      write(6,'(/,1x,3a)')b1,b2,b3
      b2=' '
c  Find IPOS/JPOS : position of I/J indices in string
      ichar0=ichar('0')
      ichar9=ichar('9')
      do jpos=15,1,-1
      if(ichar(b1(jpos:jpos)).ge.ichar0.and.
     >   ichar(b1(jpos:jpos)).le.ichar9)goto 200
      enddo
      write(6,*)' Fatal error in FOUTIJ!'
      call abend_cvb()
200   continue
      do ipos=jpos-1,1,-1
      if(ichar(b1(ipos:ipos)).ge.ichar0.and.
     >   ichar(b1(ipos:ipos)).le.ichar9)goto 300
      enddo
      write(6,*)' Fatal error in FOUTIJ!'
      call abend_cvb()
300   continue
      do j=1,nj
      do i=1,ni
      if(abs(fij(i,j)).ne.huge)then
        write(b1(ipos:ipos),'(i1)')i
        write(b1(jpos:jpos),'(i1)')j
        write(b3,'(d12.4)')fij(i,j)
        write(6,'(1x,3a)')b1,b2,b3
      endif
      enddo
      enddo
      return
      end
      subroutine iout_cvb(ii,a1,a2)
      implicit real*8 (a-h,o-z)
c      logical l
      character*(*) a1,a2
      character*15 b1
      character*46 b2
      character*12 b3
c      save huge
c      data huge/1d20/
      b1=a1
      b2=a2
      write(b3,'(i12)')ii
      write(6,'(1x,3a)')b1,b2,b3
      return
      end
      subroutine lout_cvb(l,a1,a2)
      implicit real*8 (a-h,o-z)
      logical l
      character*(*) a1,a2
      character*15 b1
      character*46 b2
      character*12 b3
c      save huge
c      data huge/1d20/
      b1=a1
      b2=a2
      if(l)then
        b3='        TRUE'
      else
        b3='       FALSE'
      endif
      write(6,'(1x,3a)')b1,b2,b3
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine Check_Amp2(nSym,nOcc,nVir,iSkip)

use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, nOcc(nSym), nVir(nSym)
integer(kind=iwp), intent(out) :: iSkip
integer(kind=iwp) :: iSym, iSyma, iSymi, nT1amTot, nT1am(8)

iSkip = 0
nT1amTot = 0
do iSym=1,nSym
  nT1am(iSym) = 0
  do iSymi=1,nSym
    iSyma = Mul(iSymi,iSym)
    nT1am(iSym) = nT1am(iSym)+nVir(iSyma)*nOcc(iSymi)
  end do
  nT1amTot = nT1amTot+nT1am(iSym)
end do

if (nT1amTot > 0) iSkip = 1

return

end subroutine Check_Amp2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine SORT_CPF(BUFOUT,INDOUT,ICAD,IBUFL,FC,FIJ,FJI,TIBUF)

use cpf_global, only: IAD25S, ICH, IPRINT, IROW, ITOC17, LASTAD, LBUF, LN, Lu_25, Lu_TiABIJ, Lu_TraInt, Lu_TraOne, MADR, N, NORB, &
                      NORBT, NSM, NSYM, NSYS, NTIBUF, NVIR, NVIRT, POTNUC
use Symmetry_Info, only: Mul
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6, RtoI

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: BUFOUT(*), FC(*), FIJ(*), FJI(*), TIBUF(NTIBUF)
integer(kind=iwp), intent(_OUT_) :: INDOUT(*), ICAD(*), IBUFL(*)
#include "tratoc.fh"
integer(kind=iwp) :: I, IAD50, IADD17, IADD25, IBUF, ICP, ICPP, ICQ, ID, IDISK, IDIV, IEXP, II, IIJ, IIN, IJ, IJT, INAV, IND, &
                     IORBI, IOUT, IPOF(65), IREC, ISYM, IVEC(20), J, JDISK, JK, JNAV, JORBI, KORBI, LBUF0, LBUF1, LBUF2, M1, M2, &
                     M3, M4, N1, N2, N3, N4, NAV, NBV, NI, NJ, NK, NL, NOB2, NOP, NOQ, NOR, NORB0(9), NORBP, NORBTT, NOS, NOT2, &
                     NOTT, NOV, NOVST, NSA, NSB, NSIJT, NSP, NSPQ, NSPQR, NSQ, NSR, NSS, NSSM, NT, NTM, NTMP, NU, NUMAX, NUMIN, &
                     NV, NVT, NX, NXM
real(kind=wp) :: DFINI, EMY, FINI, ONEHAM

IAD50 = 0
call iDAFILE(Lu_TraInt,2,iTraToc,nTraToc,IAD50)
NVT = IROW(NVIRT+1)
do I=1,20
  IVEC(I) = 0
end do
IIN = 1
do I=1,NSYM
  call IPO_CPF(IPOF(IIN),NVIR,MUL,NSYM,I,-1)
  IIN = IIN+NSYM
end do
! ORDER OF RECORD-CHAINS IS
! 1. NOT2 CHAINS (AB/IJ)
! 2. NOT2 CHAINS (AI/BJ)
! 3. NOT2 CHAINS (AI/JK)
! RECORD STRUCTURE IS
! 1. LBUF INTEGRALS
! 2. LBUF INDICES
! 3. NUMBER OF INTEGRALS IN THIS RECORD
! 4. ADDRESS OF LAST RECORD
NOT2 = IROW(LN+1)
NOV = 3*NOT2
NOTT = 2*NOT2
NOVST = LN*NVIRT+1+NVT
IDISK = 0
LBUF0 = RTOI*LBUF
LBUF1 = LBUF0+LBUF+1
LBUF2 = LBUF1+1
IDIV = RTOI
ID = 0
do IREC=1,NOV
  IBUFL(IREC) = 0
  ICAD(IREC) = ID
  INDOUT(ID+LBUF2) = -1
  ID = ID+LBUF2
end do
NORB0(1) = 0
do I=1,NSYM
  NORB0(I+1) = NORB0(I)+NORB(I)
end do

! ONE-ELECTRON INTEGRALS

NORBTT = 0
do ISYM=1,nsym
  NORBTT = NORBTT+(NORB(ISYM)*(NORB(ISYM)+1))/2
end do
EMY = POTNUC
NOB2 = IROW(NORBT+1)
IADD17 = ITOC17(2)
call dDAFILE(Lu_TraOne,2,FIJ,NORBTT,IADD17)
FC(1:NOB2) = Zero
IBUF = 0
KORBI = 0
do ISYM=1,NSYM
  do JORBI=KORBI+1,KORBI+NORB(ISYM)
    do IORBI=KORBI+1,JORBI
      IBUF = IBUF+1
      ONEHAM = FIJ(IBUF)
      NI = ICH(IORBI)
      NJ = ICH(JORBI)
      if ((NI == 0) .or. (NJ == 0)) cycle
      if (NI < NJ) then
        NTMP = NI
        NI = NJ
        NJ = NTMP
      end if
      if (NJ > 0) then
        IJT = IROW(NI)+NJ
        FC(IJT) = FC(IJT)+ONEHAM
      else if (NI == NJ) then
        EMY = EMY+Two*ONEHAM
      end if
    end do
  end do
  KORBI = KORBI+NORB(ISYM)
end do
FIJ(1:NOB2) = Zero
FJI(1:NOB2) = Zero
if (IPRINT >= 20) then
  call TRIPRT('FC IN SORT BEFORE TWOEL',' ',FC,NORBT)
  write(u6,'(A,F20.8)') ' EMY:',EMY
end if

! TWO-ELECTRON INTEGRALS

do NSP=1,NSYM
  NOP = NORB(NSP)
  do NSQ=1,NSP
    NSPQ = MUL(NSP,NSQ)
    NOQ = NORB(NSQ)
    do NSR=1,NSP
      NSPQR = MUL(NSPQ,NSR)
      NOR = NORB(NSR)
      NSSM = NSR
      if (NSR == NSP) NSSM = NSQ
      do NSS=1,NSSM
        if (NSS /= NSPQR) cycle
        NOS = NORB(NSS)
        NORBP = NOP*NOQ*NOR*NOS
        if (NORBP == 0) cycle
        call dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
        IOUT = 0
        do NV=1,NOR
          NXM = NOS
          if (NSR == NSS) NXM = NV
          do NX=1,NXM
            NTM = 1
            if (NSP == NSR) NTM = NV
            do NT=NTM,NOP
              NUMIN = 1
              if ((NSP == NSR) .and. (NT == NV)) NUMIN = NX
              NUMAX = NOQ
              if (NSP == NSQ) NUMAX = NT
              do NU=NUMIN,NUMAX
                IOUT = IOUT+1
                if (IOUT > NTIBUF) then
                  call dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
                  IOUT = 1
                end if
                M1 = ICH(NORB0(NSP)+NT)
                M2 = ICH(NORB0(NSQ)+NU)
                M3 = ICH(NORB0(NSR)+NV)
                M4 = ICH(NORB0(NSS)+NX)
                if ((M1 == 0) .or. (M2 == 0) .or. (M3 == 0) .or. (M4 == 0)) cycle
                ! ORDER THESE INDICES CANONICALLY
                N1 = max(M1,M2)
                N2 = min(M1,M2)
                N3 = max(M3,M4)
                N4 = min(M3,M4)
                NI = N1
                NJ = N2
                NK = N3
                NL = N4
                if (NI <= NK) then
                  if (NI /= NK) then
                    NI = N3
                    NJ = N4
                    NK = N1
                    NL = N2
                  else if (NJ <= NL) then
                    NL = N2
                    NJ = N4
                  end if
                end if
                FINI = TIBUF(IOUT)
                if (abs(FINI) < 1.0e-9_wp) cycle
                if ((NI > 0) .and. (NJ > 0) .and. (NK > 0) .and. (NL > 0)) then
                  DFINI = abs(FINI)
                  IEXP = int(-log10(DFINI+1.0e-20_wp)+5)
                  if (IEXP > 20) IEXP = 20
                  if (IEXP < 1) IEXP = 1
                  IVEC(IEXP) = IVEC(IEXP)+1
                  if ((NI == NJ) .and. (NK == NL)) then
                    IJ = IROW(NI)+NK
                    FIJ(IJ) = FINI
                    ! SKIP (AA/II) INTEGRALS
                  else
                    if ((NI == NK) .and. (NJ == NL)) then
                      IJ = IROW(NI)+NJ
                      FJI(IJ) = FINI
                    end if
                    if (NI >= LN) then
                      if (NJ <= LN) then
                        if (NK <= LN) then
                          ! AIJK
                          JK = NOTT+IROW(NK)+NL
                          IBUFL(JK) = IBUFL(JK)+1
                          ICQ = ICAD(JK)
                          ICP = ICQ/IDIV+IBUFL(JK)
                          BUFOUT(ICP) = FINI
                          ICPP = ICQ+LBUF0+IBUFL(JK)
                          INDOUT(ICPP) = IROW(NI)+NJ
                          if (IBUFL(JK) >= LBUF) then
                            INDOUT(ICQ+LBUF1) = LBUF
                            JDISK = IDISK
                            call iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),LBUF2,IDISK)
                            INDOUT(ICQ+LBUF2) = JDISK
                            IBUFL(JK) = 0
                          end if
                        else if (NL <= LN) then
                          ! AIBJ
                          IIJ = NOT2+IROW(NJ)+NL
                          if (NL > NJ) IIJ = NOT2+IROW(NL)+NJ
                          IBUFL(IIJ) = IBUFL(IIJ)+1
                          ICQ = ICAD(IIJ)
                          ICP = ICQ/IDIV+IBUFL(IIJ)
                          BUFOUT(ICP) = FINI
                          NSA = NSM(NI)
                          NAV = NI-LN-NSYS(NSA)
                          NSB = NSM(NK)
                          NBV = NK-LN-NSYS(NSB)
                          NSIJT = (MUL(NSM(NJ),NSM(NL))-1)*NSYM
                          if (NL <= NJ) then
                            INAV = IPOF(NSIJT+NSA)+(NBV-1)*NVIR(NSA)+NAV
                          else
                            INAV = IPOF(NSIJT+NSB)+(NAV-1)*NVIR(NSB)+NBV
                          end if
                          ICPP = ICQ+LBUF0+IBUFL(IIJ)
                          INDOUT(ICPP) = INAV
                          if (IBUFL(IIJ) >= LBUF) then
                            INDOUT(ICQ+LBUF1) = LBUF
                            JDISK = IDISK
                            call iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),LBUF2,IDISK)
                            INDOUT(ICQ+LBUF2) = JDISK
                            IBUFL(IIJ) = 0
                          end if
                          if ((NJ == NL) .and. (NI /= NK)) then
                            JNAV = IROW(NI)+NK
                            FC(JNAV) = FC(JNAV)-FINI
                          end if
                        end if
                      else if (NK <= LN) then
                        ! ABIJ
                        IIJ = IROW(NK)+NL
                        IBUFL(IIJ) = IBUFL(IIJ)+1
                        ICQ = ICAD(IIJ)
                        ICP = ICQ/IDIV+IBUFL(IIJ)
                        BUFOUT(ICP) = FINI
                        NSA = NSM(NI)
                        NAV = NI-LN-NSYS(NSA)
                        NSB = NSM(NJ)
                        NBV = NJ-LN-NSYS(NSB)
                        NSIJT = (MUL(NSM(NK),NSM(NL))-1)*NSYM
                        INAV = IPOF(NSIJT+NSA)+(NBV-1)*NVIR(NSA)+NAV
                        ICPP = ICQ+LBUF0+IBUFL(IIJ)
                        INDOUT(ICPP) = INAV
                        if (IBUFL(IIJ) >= LBUF) then
                          INDOUT(ICQ+LBUF1) = LBUF
                          JDISK = IDISK
                          call iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),LBUF2,IDISK)
                          INDOUT(ICQ+LBUF2) = JDISK
                          IBUFL(IIJ) = 0
                        end if
                        if ((NK == NL) .and. (NI /= NJ)) then
                          JNAV = IROW(NI)+NJ
                          FC(JNAV) = FC(JNAV)+Two*FINI
                        end if
                      end if
                    end if
                  end if
                else
                  ! CHECK FOR FOCK-MATRIX CONTRIBUTION
                  if (NI == NJ) then
                    II = 1
                    call IFOCK(FC,NI,NK,NL,FINI,II)
                    if (NK == NL) then
                      if ((NI <= 0) .and. (NK <= 0)) then
                        EMY = EMY+Two*FINI
                        if (NI /= NK) EMY = EMY+Two*FINI
                      end if
                      if (NI /= NK) call IFOCK(FC,NK,NI,NJ,FINI,II)
                    end if
                  else if (NK == NL) then
                    II = 1
                    call IFOCK(FC,NK,NI,NJ,FINI,II)
                  end if
                  II = 0
                  if (NI == NK) then
                    call IFOCK(FC,NI,NJ,NL,FINI,II)
                    if (NJ == NL) then
                      if ((NI <= 0) .and. (NJ <= 0)) then
                        EMY = EMY-FINI
                        if (NI /= NJ) EMY = EMY-FINI
                      end if
                      if (NI /= NJ) call IFOCK(FC,NJ,NI,NK,FINI,II)
                    end if
                  else if (NI == NL) then
                    call IFOCK(FC,NI,NJ,NK,FINI,II)
                  else if (NJ == NK) then
                    call IFOCK(FC,NJ,NI,NL,FINI,II)
                  else if (NJ == NL) then
                    call IFOCK(FC,NJ,NI,NK,FINI,II)
                  end if
                end if
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end do
! EMPTY LAST BUFFERS
if ((NOVST+NOV) > MADR) then
  write(u6,*) 'SORT Error: NOVST+NOV>MADR (See code).'
  call Abend()
end if
do I=1,NOV
  ICQ = ICAD(I)
  INDOUT(ICQ+LBUF1) = IBUFL(I)
  JDISK = IDISK
  call iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),LBUF2,IDISK)
  LASTAD(NOVST+I) = JDISK
end do
do J=1,NORBT
  IND = IROW(J+1)
  FC(IND) = FC(IND)+EMY/N
end do
IADD25 = 0
call dDAFILE(Lu_25,1,FC,NOB2,IADD25)
IAD25S = IADD25
write(u6,154)
write(u6,155) (IVEC(I),I=1,20)

return

154 format(//6X,'STATISTICS FOR INTEGRALS, FIRST ENTRY 10**3-10**4',/)
155 format(6X,5I10)

end subroutine SORT_CPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_map32(a,b,dimp,dimq,dimr,dim_1,dim_2,dim_3,p,q,nfact)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dimr, dim_1, dim_2, dim_3, p, q, nfact
real(kind=wp), intent(in) :: a(dimp,dimq,dimr)
real(kind=wp), intent(out) :: b(dim_1,dim_2,dim_3)
integer(kind=iwp) :: pp, qq, rr !, indx(3)

if (nfact == 1) then

  ! fact = + 1

  !do rr=1,dimr
  !  indx(r) = rr
  !  do qq=1,dimq
  !    indx(q) = qq
  !    do pp=1,dimp
  !      indx(p) = pp
  !      b(indx(1),indx(2),indx(3)) = a(pp,qq,rr)
  !    end do
  !  end do
  !end do

  if (p == 1) then
    !1**
    if (q == 2) then
      !12* (3)
      b(1:dimp,1:dimq,1:dimr) = a
    else
      !13* (2)
      do qq=1,dimq
        b(1:dimp,1:dimr,qq) = a(:,qq,:)
      end do
    end if
  else if (p == 2) then
    !2**
    if (q == 1) then
      !21* (3)
      do pp=1,dimp
        b(1:dimq,pp,1:dimr) = a(pp,:,:)
      end do
    else
      !23* (1)
      do rr=1,dimr
        b(rr,1:dimp,1:dimq) = a(:,:,rr)
      end do
    end if
  else if (p == 3) then
    !3**
    if (q == 1) then
      !31* (2)
      do pp=1,dimp
        b(1:dimq,1:dimr,pp) = a(pp,:,:)
      end do
    else
      !32* (1)
      do qq=1,dimq
        do pp=1,dimp
          b(1:dimr,qq,pp) = a(pp,qq,:)
        end do
      end do
    end if
  end if

else

  ! factor = -1

  !do rr=1,dimr
  !  indx(r) = rr
  !  do qq=1,dimq
  !    indx(q) = qq
  !    do pp=1,dimp
  !      indx(p) = pp
  !      b(indx(1),indx(2),indx(3)) = -a(pp,qq,rr)
  !    end do
  !  end do
  !end do

  if (p == 1) then
    !1**
    if (q == 2) then
      !12* (3)
      b(1:dimp,1:dimq,1:dimr) = -a
    else
      !13* (2)
      do qq=1,dimq
        b(1:dimp,1:dimr,qq) = -a(:,qq,:)
      end do
    end if
  else if (p == 2) then
    !2**
    if (q == 1) then
      !21* (3)
      do pp=1,dimp
        b(1:dimq,pp,1:dimr) = -a(pp,:,:)
      end do
    else
      !23* (1)
      do rr=1,dimr
        b(rr,1:dimp,1:dimq) = -a(:,:,rr)
      end do
    end if
  else if (p == 3) then
    !3**
    if (q == 1) then
      !31* (2)
      do pp=1,dimp
        b(1:dimq,1:dimr,pp) = -a(pp,:,:)
      end do
    else
      !32* (1)
      do qq=1,dimq
        do pp=1,dimp
          b(1:dimr,qq,pp) = -a(pp,qq,:)
        end do
      end do
    end if
  end if

end if

return

end subroutine cct3_map32

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine SOAdd(SOInt,iBas,jBas,nSOInt,PrpInt,nPrp,lOper,
     &                  iCmp,jCmp,iShell,jShell,AeqB,iAO,jAO)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January '91                                              *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 SOInt(iBas*jBas,nSOInt), PrpInt(nPrp)
      Logical AeqB
*
      iRout = 130
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In SOAdd:SOInt',' ',SOInt,iBas*jBas,nSOInt)
      End If
*
      lSO = 0
      Do 100 j1 = 0, nIrrep-1
       Do 200 i1 = 1, iCmp
        If (iAOtSO(iAO+i1,j1)<0) Cycle
*
*       Scatter the SO's onto lower rectangular blocks and triangular
*       diagonal blocks.
*
        Do 300 j2 = 0, j1
         j12 = iEor(j1,j2)
         If (iAnd(lOper,2**j12).eq.0) Go To 300
         jjMx = jCmp
         If (iShell.eq.jShell .and. j1.eq.j2) jjMx = i1
         Do 400 i2 = 1, jjMx
          If (iAOtSO(jAO+i2,j2)<0) Cycle
          lSO = lSO + 1
          iSO1=iAOtSO(iAO+i1,j1)
          iSO2=iAOtSO(jAO+i2,j2)
*         Write (*,*) iSO1,iAO,i1,j1,iSO2,jAO,i2,j2
*
          iPnt = iPntSO(j1,j2,lOper,nbas)
          Do 500 indAO1 = 0, iBas-1
*         Diagonal block. Store only unique elements
           jBsMax = jBas - 1
           If (j1.eq.j2 .and. iSO1.eq.iSO2) jBsMax=indAO1
           Do 600 indAO2 = 0, jBsMax
            ip = indAO2*iBas + indAO1 + 1
*
*           Move one electron integral.
*
            If (j1.eq.j2) Then
*------------Diagonal symmetry block
             If (iSO1+indAO1.ge.iSO2+indAO2) Then
              Indi = iSO1+indAO1
              Indj = iSO2+indAO2
              PrpInt(iPnt + (Indi-1)*Indi/2 + Indj) =
     &        PrpInt(iPnt + (Indi-1)*Indi/2 + Indj) + SOInt(ip,lSO)
             Else
              Indj = iSO1+indAO1
              Indi = iSO2+indAO2
              PrpInt(iPnt + (Indi-1)*Indi/2 + Indj) =
     &        PrpInt(iPnt + (Indi-1)*Indi/2 + Indj) + SOInt(ip,lSO)
             End If
            Else
*------------Off-diagonal symmetry block j1>j2
             Indi = iSO1+indAO1
             Indj = iSO2+indAO2
             nRow = nBas(j1)
*            Write (*,'(11I4,E10.5)') iSO1,iAO,i1,j1,indAO1,
*    &                                iSO2,jAO,i2,j2,indAO2,
*    &                                ip,SOInt(ip,lSO)
             PrpInt(iPnt + nRow*(Indj-1) + Indi ) =
     &       PrpInt(iPnt + nRow*(Indj-1) + Indi ) + SOInt(ip,lSO)
            End If
*
 600       Continue
 500      Continue
*
 400     Continue
 300    Continue
*
 200   Continue
 100  Continue
*
      If (iPrint.ge.99) Call GetMem(' Exit SOAdd','CHECK','ALLO',
     &                              iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_logical(AeqB)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE HZLP2(CBUF,SBUF,DBUF,CSECT,RSECT,XI1,XI2,CNEW,ICI)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (ONE=1.0D00)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION CBUF(MBUF,MXVEC),SBUF(MBUF,MXVEC),DBUF(MBUF),ICI(MBUF)
      DIMENSION CSECT(NSECT,MXVEC),RSECT(NSECT,MXVEC)
      DIMENSION CNEW(NSECT,MXVEC)
      DIMENSION XI1(NSECT,MXVEC),XI2(NSECT,MXVEC)
      DIMENSION IDCR(MXVEC),IDCW(MXVEC),IDS(MXVEC)
C THIS SUBROUTINE LOOPS OVER SECTIONS OF PSI AND SIGMA ARRAYS
C ON DISK, AND FORMS A NEW SET OF PSI ARRAYS AS A LINEAR COMBINATION
C OF THE BASIS SET PSI, RHO, XI1 AND XI2. TO FORM THE NEW PSI
C ARRAY, THE FIRST (NRROOT-NNEW) COLUMNS ARE SKIPPED, SINCE THEY
C GIVE NO ESSENTIAL IMPROVEMENT.
      IVZSTA=1+NRROOT-NNEW
      IVZ1=1
      IVZ2=1+NRROOT
      IVZ3=1+2*NRROOT
      IVZ4=1+3*NRROOT
C     WRITE(6,*)
C     WRITE(6,*)' IN HZLP2. NNEW=',NNEW
C     IF(NVEC.LT.MXVEC) WRITE(6,*)' DUMMY WRITES OF NEW FUNCTIONS.'
C WE MAY NEED DUMMY WRITES TO PROVIDE DISK ADDRESSES:
      NNVEC=MIN(NVEC+NNEW,MXVEC)
      DO 16 K=NVEC+1,NNVEC
        IDISKC(K)=IDFREE
C       WRITE(6,'(A,I2,A,I8)')' IDISKC(',K,')=',IDFREE
        DO 15 ISTA=1,NCONF,MBUF
          IEND=MIN(NCONF,ISTA+MBUF-1)
          IBUF=1+IEND-ISTA
          CALL iDAFILE(LUEIG,0,ICI,IBUF,IDFREE)
15      CONTINUE
16    CONTINUE
C WE NEED COPIES OF THE DISK ADDRESSES. TWO COPIES FOR PSI BUFFERS.
      DO 10 K=1,NNVEC
        IDCR(K)= IDISKC(K)
        IDCW(K)= IDISKC(K)
        IDS(K)= IDISKS(K)
10    CONTINUE
      IDD=IDISKD
C LOOP OVER BUFFERS FOR READING PSI, SIGMA AND DBUF:
      DO 2000 ISTA=1,NCONF,MBUF
        IEND=MIN(NCONF,ISTA+MBUF-1)
        IBUF=1+IEND-ISTA
        CALL dDAFILE(LUEIG,2,DBUF,IBUF,IDD)
        DO 20 K=1,NVEC
          CALL iDAFILE(LUEIG,2,ICI,IBUF,IDCR(K))
          CALL UPKVEC(IBUF,ICI,CBUF(1,K))
          CALL dDAFILE(LUEIG,2,SBUF(1,K),IBUF,IDS(K))
20      CONTINUE
C LOOP OVER VECTOR SECTIONS, LENGTH AT MOST NSECT:
        DO 1000 JSTA=1,IBUF,NSECT
          JEND=MIN(IBUF,JSTA+NSECT-1)
          ISECT=1+JEND-JSTA
C TRANSFORM TO EIGENFUNCTIONS OF HSMALL: FIRST, CI SECTION.
        CALL DGEMM_('N','N',
     &              ISECT,NRROOT,NVEC,
     &              1.0d0,CBUF(JSTA,1),MBUF,
     &              VSMALL,MXVEC,
     &              0.0d0,CSECT,NSECT)
C THEN, SIGMA SECTION INTO RSECT.
        CALL DGEMM_('N','N',
     &              ISECT,NRROOT,NVEC,
     &              1.0d0,SBUF(JSTA,1),MBUF,
     &              VSMALL,MXVEC,
     &              0.0d0,RSECT,NSECT)
C AND THEN FORM RSECT=SECTION OF RESIDUAL ARRAY, AND XI1 AND XI2:
        DO 30 I=1,ISECT
          DO 31 K=1,NRROOT
            RSECT(I,K)=RSECT(I,K)-ESMALL(K)*CSECT(I,K)
            XI1(I,K)=CSECT(I,K)/(DBUF(I+JSTA-1)-ESMALL(K))
            XI2(I,K)=RSECT(I,K)/(DBUF(I+JSTA-1)-ESMALL(K))
31        CONTINUE
30      CONTINUE
C FORM NEW PSI ARRAYS IN CNEW SECTION:
          CALL DGEMM_('N','N',
     &                ISECT,NNEW,NRROOT,
     &                1.0d0,CSECT,NSECT,
     &                VZERO(IVZ1,IVZSTA),MXZ,
     &                0.0d0,CNEW,NSECT)
          CALL DGEMM_('N','N',ISECT,NNEW,NRROOT,ONE,RSECT,NSECT,
     *          VZERO(IVZ2,IVZSTA),MXZ,ONE,CNEW,NSECT)
          CALL DGEMM_('N','N',ISECT,NNEW,NRROOT,ONE,XI1  ,NSECT,
     *          VZERO(IVZ3,IVZSTA),MXZ,ONE,CNEW,NSECT)
          CALL DGEMM_('N','N',ISECT,NNEW,NRROOT,ONE,XI2  ,NSECT,
     *          VZERO(IVZ4,IVZSTA),MXZ,ONE,CNEW,NSECT)
C     IF(ISTA+JSTA.EQ.2) THEN
C       WRITE(6,*)' CONSTRUCTION OF NEW VECTOR IN HZLP2.'
C       WRITE(6,*)' CSECT:'
C       WRITE(6,'(1X,5F15.6)')((CSECT(I,J),I=1,5),J=1,NNEW)
C       WRITE(6,*)' RSECT:'
C       WRITE(6,'(1X,5F15.6)')((RSECT(I,J),I=1,5),J=1,NNEW)
C       WRITE(6,*)'   XI1:'
C       WRITE(6,'(1X,5F15.6)')((XI1(I,J),I=1,5),J=1,NNEW)
C       WRITE(6,*)'   XI2:'
C       WRITE(6,'(1X,5F15.6)')((XI2(I,J),I=1,5),J=1,NNEW)
C       WRITE(6,*)' VZERO:'
C       IIII=IVZSTA-1
C       WRITE(6,'(1X,4F15.6)')((VZERO(I,IIII+J),I=1,4*NNEW),J=1,NNEW)
C       WRITE(6,*)'  CNEW:'
C       WRITE(6,'(1X,5F15.6)')((CNEW(I,J),I=1,5),J=1,NNEW)
C     END IF
C INSERT THE NEW PSI SECTIONS IN BUFFER. THIS MAY IMPLY OVERWRITING
C OLD ENTRIES, BUT CAN ALSO LEAD TO AN INCREASED NUMBER OF VECTORS:
          DO 50 KK=1,NNEW
            NN=NVTOT+KK
            K=1+MOD(NN-1,MXVEC)
C         IF(ISTA+JSTA.EQ.2) THEN
C           WRITE(6,'(A,I2,A,I6)')' CNEW NR.',KK,' COPIED TO BUFFER ',K
C           WRITE(6,*)' IT CONTAINS:'
C           WRITE(6,'(1X,5F15.6)')(CNEW(I,KK),I=1,15)
C         END IF
            CALL DCOPY_(ISECT,CNEW(1,KK),1,CBUF(JSTA,K),1)
50        CONTINUE
C CONTINUE, NEXT SECTION.
1000    CONTINUE
        DO 60 KK=1,NNEW
          NN=NVTOT+KK
          K=1+MOD(NN-1,MXVEC)
C         IF(ISTA.EQ.1) THEN
C           WRITE(6,'(A,I2,A,I6)')' BUFFER NR.',K,' WRITTEN AT ',IDCW(K)
C           WRITE(6,*)' IT CONTAINS:'
C           WRITE(6,'(1X,5F15.6)')(CBUF(I,K),I=1,15)
C         END IF
          CALL PKVEC(IBUF,CBUF(1,K),ICI)
          CALL iDAFILE(LUEIG,1,ICI,IBUF,IDCW(K))
60      CONTINUE
C CONTINUE, NEXT BUFFER.
2000  CONTINUE
      NVTOT=NVTOT+NNEW
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkD_Q46(D,T2,T1a,T1b,dima,dimb,no)
! this routine does:
! Create D(a',j,b',i) [NB. D(a,b,i,j) =  t2(a,b,j,i)-T2(a,b,i,j)]
! from following available arrays (permuted as given):
! T2(a',j,b',i) [NB. T2abij = 1/2 t2abij + tai . tjb ]
! T1a(a',p)
! T1b(b',p)
!
! N.B. Kvajt odflaknute

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, no
real(kind=wp), intent(out) :: D(dima,no,dimb,no)
real(kind=wp), intent(in) :: T2(dima,no,dimb,no), T1a(dima,no), T1b(dimb,no)
integer(kind=iwp) :: b, i

do i=1,no
  do b=1,dimb
    D(:,:,b,i) = Two*(T2(:,i,b,:)-T1a(:,:)*T1b(b,i))-T2(:,:,b,i)
  end do
end do

return

end subroutine MkD_Q46

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!#define _DEBUGPRINT_

subroutine PrintQ(rK,qLbl,nq,nQQ,LuIC,rMult)

use PrintLevel, only: nPrint
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nq, nQQ, LuIC
real(kind=wp), intent(in) :: rK(nq,nQQ), rMult(nq)
character(len=14), intent(in) :: qLbl(nq)
integer(kind=iwp) :: iE, i_F, iiQQ, IncQQ, iPrint, iq, iQQ, iRout, istatus, jq, LuTmp, mQQ
real(kind=wp) :: temp
logical(kind=iwp) :: Start
character(len=80) :: Line
character(len=16) :: filnam
real(kind=wp), parameter :: Thr = 0.001_wp ! Threshold for printout.
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 122
iPrint = nPrint(iRout)

if (iPrint > 5) then
  write(u6,*)
  call CollapseOutput(1,'Internal coordinate section')

  if (iPrint >= 6) then
    write(u6,*)
    write(u6,'(A)') repeat('*',80)
    write(u6,*) ' Auto-Defined Internal coordinates'
    write(u6,'(A)') repeat('-',80)
    write(u6,'(A)') '  Primitive Internal Coordinates:'
  else
    write(u6,*)
    write(u6,'(A)') '  Redundant Internal Coordinates:'
    write(u6,*)
  end if

  rewind(LuIC)
  do
    read(LuIC,'(A)',iostat=istatus) Line
    if (istatus < 0) exit
    write(u6,'(A)') Line
  end do
  rewind(LuIC)
  if (iPrint >= 6) then

    write(u6,'(A)') '  Internal Coordinates:'
    do iQQ=1,nQQ
      write(Line,'(A,I3.3,A)') 'q',iQQ,' ='
      i_F = 7
      jq = 0
      Start = .true.
      do iq=1,nq
        temp = abs(rK(iq,iQQ))
        if (temp > Thr) then
          jq = jq+1
          if (jq > 4) then
            Line(80:80) = '&'
            write(u6,'(A)') Line
            Line = ' '
            i_F = 6
            jq = 1
            Start = .false.
          end if
          if ((jq == 1) .and. Start) then
            iE = i_F+16
            write(Line(i_F:iE),'(A,F10.8,4A)') ' ',rK(iq,iQQ),' ',qLbl(iq)(1:4),' '
          else
            iE = i_F+17
            write(Line(i_F:iE),'(A,F10.8,4A)') '+ ',rK(iq,iQQ),' ',qLbl(iq)(1:4),' '
          end if
          i_F = iE+1
        end if
      end do
      write(u6,'(A)') Line
    end do
    write(u6,'(A)') repeat('*',80)
    call CollapseOutput(0,'Internal coordinate section')
  end if
end if

! Write linear combinations to disc

LuTmp = 11
filnam = 'SPCINX'
call molcas_binaryopen_vanilla(luTmp,filnam)
!open(luTmp,File=filnam,Form='unformatted',Status='unknown')
rewind(LuTmp)

! put in degeneracy factor so that ddot will work.

write(LuTmp) nq,nQQ
do iq=1,nq
  write(LuTmp) qLbl(iq),rMult(iq)*rK(iq,:)
end do

close(LuTmp)

if ((iPrint >= 10) .and. (nQQ <= 12)) then
  write(u6,*)
  write(u6,*) ' Nonredundant internal coordinates'
end if
if ((iPrint >= 6) .and. (nQQ <= 12)) then
  write(u6,*)
  write(u6,*) ' Number of redundant coordinates:',nq
  write(u6,*)
end if
if ((iPrint >= 10) .and. (nQQ <= 12)) then
  write(u6,'(A,ES10.3)') ' Threshold for printout:',Thr
  IncQQ = 8
  do iiQQ=1,nQQ,IncQQ
    mQQ = min(nQQ,iiQQ+IncQQ-1)
    write(u6,*)
    write(u6,'(14X,8I10)') (iQQ,iQQ=iiQQ,mQQ)
    do iq=1,nq
      temp = sqrt(DDot_(nQQ,rK(iq,1),nq,rK(iq,1),nq))
      if (temp > Thr) write(u6,'(A,8F10.6)') qLbl(iq),rK(iq,iiQQ:mQQ)
    end do
    write(u6,*)
  end do
end if

return

end subroutine PrintQ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE INT61(I,K,L,IT1,IT2,II,IID,JJ,JJD,JTYP,ITAI,
     *L0,L1,L2,L3)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ITAI(*),L0(*),L1(*),L2(*),L3(*)
C     I.LT.K.LT.L  J.EQ.L
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      ITYP=0
      LJS=IJ(L+1)+1
      LJM=IJ(L)
      DO 10 LJ=LJS,LJM
      ITAIL=IX(IT2+LJ)
      IF(IT1.NE.IT2)CALL TAIL(L,LJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
      IWAY(L)=1
32    KM=L
      J2(KM+1)=LJ
      J1(KM+1)=LJ
      JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      CALL LOOP7(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 10
53    KM=KM-1
      IWAY(KM)=1
      IF(KM.EQ.K)GO TO 61
62    JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      CALL LOOP17(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 53
      KM=KM+1
      IF(KM.EQ.L)GO TO 32
      GO TO 62
61    IWAY(K)=1
72    KM=K
      CALL LOOP16(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 63
      KM=KM+1
      IF(KM.EQ.L)GO TO 32
      GO TO 62
63    KM=KM-1
      IF(KM.EQ.0)GO TO 20
      IWAY(KM)=1
      IF(KM.EQ.I)GO TO 74
82    CALL LOOP5(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 63
      KM=KM+1
      IF(KM.EQ.K)GO TO 72
      GO TO 82
74    IWAY(I)=1
71    KM=I
      CALL LOOP3(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 73
      IF(ABS(COUP(I)).LT.1.D-06)GO TO 71
      CALL COMP(I,LJ,ITYP,I,IT1,IT2)
      GO TO 71
73    KM=KM+1
      IF(KM.EQ.K)GO TO 72
      GO TO 82
20    CALL COMP1(LJ,ITYP,L,IT2,II,IID,JJ,JJD,JTYP,ITAI)
      KM=1
      IF(KM.EQ.K)GO TO 72
      GO TO 82
10    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Quan Phung                                       *
!***********************************************************************
! Subroutine to convert HFOC to Dice format
! Written by Quan Phung, Leuven, Apr 2018
!                        Nagoya, Oct 2022

subroutine molcas2dice(str)

use Definitions, only: iwp

implicit none
! This supports up to about 100 active orbitals
character(len=500), intent(inout) :: str
character(len=500) :: str2
character(len=8) :: TempStr
integer(kind=iwp) :: i, idxOrb

idxOrb = 0

! Convert DIOC to Dice format
str2 = ' '
do i=1,len(str)
  select case (str(i:i))
    case ('2')
      write(TempStr,'(2I4)') idxOrb,idxOrb+1
      str2 = adjustl(trim(str2))//' '//adjustl(trim(TempStr))
      idxOrb = idxOrb+2
    case ('u','a')
      write(TempStr,'(I4)') idxOrb
      str2 = adjustl(trim(str2))//' '//adjustl(trim(TempStr))
      idxOrb = idxOrb+2
    case ('d','b')
      write(TempStr,'(I4)') idxOrb
      str2 = adjustl(trim(str2))//' '//adjustl(trim(TempStr))
      idxOrb = idxOrb+2
    case (' ')
      ! do nothing
    case default
      idxOrb = idxOrb+2
  end select
end do

str = str2

end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine NADIAG()
! Set up non-active diagonal elements of H0.

use Symmetry_Info, only: Mul
use SUPERINDEX, only: MAGEB, MAGTB, MIGEJ, MIGTJ
use EQSOLV, only: IDBMAT
use caspt2_global, only: iStpGrd, LUSBT
use caspt2_module, only: EPSE, EPSI, NAGEB, NAGEBES, NAGEBES, NAGTB, NAGTBES, NASUP, NIES, NIGEJ, NIGEJES, NIGTJ, NIGTJES, NINDEP, &
                         NISH, NISUP, NSES, NSSH, NSYM
use SC_NEVPT2, only: Do_SC, SC_amplitude
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: I2, I2ABS, IA, IAABS, IAB, IABQ, IBABS, ICASE, IDID, II, IIABS, IIJ, IIJQ, IIQ, IIS, IJABS, ISYM, ISYMA, &
                     ISYMAB, ISYMI, ISYMIJ, NAS, NIN, NIS
real(kind=wp) :: Dummy(1)
real(kind=wp), allocatable :: BD(:), ID(:)

if (SC_amplitude .and. (iStpGrd == 2)) return

do ICASE=1,13
  do ISYM=1,NSYM

    NIN = NINDEP(ISYM,ICASE)
    if ((NIN == 0) .and. (.not. Do_SC)) cycle
    NIS = NISUP(ISYM,ICASE)
    NAS = NASUP(ISYM,ICASE)
    if (ICASE > 11) call mma_allocate(BD,NAS,LABEL='BD')
    call mma_allocate(ID,NIS,LABEL='ID')

    select case (ICASE)
      case (1)
        ! VJTU CASE:
        ID(1:NIS) = -EPSI(NIES(ISYM)+1:NIES(ISYM)+NIS)

      case (2)
        ! VJTIP CASE:
        do IIS=1,NIS
          IIQ = IIS+NIGEJES(ISYM)
          IIABS = MIGEJ(1,IIQ)
          IJABS = MIGEJ(2,IIQ)
          ID(IIS) = -EPSI(IIABS)-EPSI(IJABS)
        end do

      case (3)
        ! VJTIM CASE:
        do IIS=1,NIS
          IIQ = IIS+NIGTJES(ISYM)
          IIABS = MIGTJ(1,IIQ)
          IJABS = MIGTJ(2,IIQ)
          ID(IIS) = -EPSI(IIABS)-EPSI(IJABS)
        end do

      case (4)
        ! ATVX  CASE:
        ID(1:NIS) = EPSE(NSES(ISYM)+1:NSES(ISYM)+NIS)

      case (5)
        ! AIVX  CASE:
        IIS = 0
        do ISYMA=1,NSYM
          ISYMI = Mul(ISYMA,ISYM)
          do IA=1,NSSH(ISYMA)
            IAABS = IA+NSES(ISYMA)
            do II=1,NISH(ISYMI)
              IIABS = II+NIES(ISYMI)
              IIS = IIS+1
              ID(IIS) = -EPSI(IIABS)+EPSE(IAABS)
            end do
          end do
        end do

      case (6)
        ! VJAIP CASE:
        IIS = 0
        do ISYMA=1,NSYM
          ISYMIJ = Mul(ISYMA,ISYM)
          do I2=1,NIGEJ(ISYMIJ)
            I2ABS = I2+NIGEJES(ISYMIJ)
            IIABS = MIGEJ(1,I2ABS)
            IJABS = MIGEJ(2,I2ABS)
            do IA=1,NSSH(ISYMA)
              IAABS = IA+NSES(ISYMA)
              IIS = IIS+1
              ID(IIS) = -EPSI(IIABS)-EPSI(IJABS)+EPSE(IAABS)
            end do
          end do
        end do

      case (7)
        ! VJAIM CASE:
        IIS = 0
        do ISYMA=1,NSYM
          ISYMIJ = Mul(ISYMA,ISYM)
          do I2=1,NIGTJ(ISYMIJ)
            I2ABS = I2+NIGTJES(ISYMIJ)
            IIABS = MIGTJ(1,I2ABS)
            IJABS = MIGTJ(2,I2ABS)
            do IA=1,NSSH(ISYMA)
              IAABS = IA+NSES(ISYMA)
              IIS = IIS+1
              ID(IIS) = -EPSI(IIABS)-EPSI(IJABS)+EPSE(IAABS)
            end do
          end do
        end do

      case (8)
        ! BVATP CASE:
        do IIS=1,NIS
          IIQ = IIS+NAGEBES(ISYM)
          IAABS = MAGEB(1,IIQ)
          IBABS = MAGEB(2,IIQ)
          ID(IIS) = EPSE(IAABS)+EPSE(IBABS)
        end do

      case (9)
        ! BVATM CASE:
        do IIS=1,NIS
          IIQ = IIS+NAGTBES(ISYM)
          IAABS = MAGTB(1,IIQ)
          IBABS = MAGTB(2,IIQ)
          ID(IIS) = EPSE(IAABS)+EPSE(IBABS)
        end do

      case (10)
        ! BJATP CASE:
        IIS = 0
        do ISYMI=1,NSYM
          ISYMAB = Mul(ISYMI,ISYM)
          do I2=1,NAGEB(ISYMAB)
            I2ABS = I2+NAGEBES(ISYMAB)
            IAABS = MAGEB(1,I2ABS)
            IBABS = MAGEB(2,I2ABS)
            do II=1,NISH(ISYMI)
              IIABS = II+NIES(ISYMI)
              IIS = IIS+1
              ID(IIS) = -EPSI(IIABS)+EPSE(IAABS)+EPSE(IBABS)
            end do
          end do
        end do

      case (11)
        ! BJATM CASE:
        IIS = 0
        do ISYMI=1,NSYM
          ISYMAB = Mul(ISYMI,ISYM)
          do I2=1,NAGTB(ISYMAB)
            I2ABS = I2+NAGTBES(ISYMAB)
            IAABS = MAGTB(1,I2ABS)
            IBABS = MAGTB(2,I2ABS)
            do II=1,NISH(ISYMI)
              IIABS = II+NIES(ISYMI)
              IIS = IIS+1
              ID(IIS) = -EPSI(IIABS)+EPSE(IAABS)+EPSE(IBABS)
            end do
          end do
        end do

      case (12)
        ! BJAIP CASE:
        do IAB=1,NAGEB(ISYM)
          IABQ = IAB+NAGEBES(ISYM)
          IAABS = MAGEB(1,IABQ)
          IBABS = MAGEB(2,IABQ)
          IIS = IIS+1
          BD(IAB) = EPSE(IAABS)+EPSE(IBABS)
        end do
        do IIJ=1,NIGEJ(ISYM)
          IIJQ = IIJ+NIGEJES(ISYM)
          IIABS = MIGEJ(1,IIJQ)
          IJABS = MIGEJ(2,IIJQ)
          ID(IIJ) = -EPSI(IIABS)-EPSI(IJABS)
        end do

      case (13)
        ! BJAIM CASE:
        do IAB=1,NAGTB(ISYM)
          IABQ = IAB+NAGTBES(ISYM)
          IAABS = MAGTB(1,IABQ)
          IBABS = MAGTB(2,IABQ)
          IIS = IIS+1
          BD(IAB) = EPSE(IAABS)+EPSE(IBABS)
        end do
        do IIJ=1,NIGTJ(ISYM)
          IIJQ = IIJ+NIGTJES(ISYM)
          IIABS = MIGTJ(1,IIJQ)
          IJABS = MIGTJ(2,IIJQ)
          ID(IIJ) = -EPSI(IIABS)-EPSI(IJABS)
        end do

      case default
        write(u6,*) 'NADIAG: illegal case number'
        call ABEND()
    end select

    ! NOTE: BDIAG elements used in cases 12 & 13.
    IDID = IDBMAT(ISYM,ICASE)
    if (ICASE > 11) then
      call DDAFILE(LUSBT,1,BD,NAS,IDID)
      call mma_deallocate(BD)
    else
      ! Dummy read the BDIAG elements. NOTE: NAS, not NIN.
      call DDAFILE(LUSBT,0,Dummy,NAS,IDID)
    end if
    call DDAFILE(LUSBT,1,ID,NIS,IDID)
    call mma_deallocate(ID)

  end do
end do

end subroutine NADIAG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1998, Roland Lindh                                *
*               1998, Samuel Mikes                                     *
************************************************************************
      SubRoutine MVe(rV2Int,rV4Int,Sxyz,na,nb,Alpha,Beta,nZeta)
************************************************************************
*                                                                      *
* Object: to compute intermediate integrals for the evaluation of the  *
*          mass velocity integrals.                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*                                                                      *
*             Correct out of bound reference, February '98, Samuel     *
*             Mikes and Roland Lindh.                                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 rV2Int(nZeta,3,0:na,0:nb,2),
     &       rV4Int(nZeta,3,0:na,0:nb),
     &       Sxyz(nZeta,3,0:na+2,0:nb+2),
     &       Alpha(nZeta), Beta(nZeta)
      Character*80 Label
*
      iRout = 192
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In MVe: Alpha',' ',Alpha,nZeta,1)
         Call RecPrt(' In MVe: Beta ',' ',Beta ,nZeta,1)
         Do ib = 0, nb+2
            Do ia = 0, na+2
               Write (Label,'(A,I2,A,I2,A)')
     &               ' In MVe: Sxyz(',ia,',',ib,')'
               Call RecPrt(Label,' ',Sxyz(1,1,ia,ib),nZeta,3)
            End Do
         End Do
*
      End If
      Do ib = 0, nb
         Do ia = 0, na
               Do iCar = 1, 3
                  Do iZeta = 1, nZeta
*
                     rV2Int(iZeta,iCar,ia,ib,1) =
     &                  Four*Alpha(iZeta)**2*Sxyz(iZeta,iCar,ia+2,ib)
     &                 -Two*Alpha(iZeta)*(Two*Dble(ia)+One)*
     &                                       Sxyz(iZeta,iCar,ia,ib)
                     If (ia.ge.2) Then
                        rV2Int(iZeta,iCar,ia,ib,1) =
     &                     rV2Int(iZeta,iCar,ia,ib,1)
     &                     +Dble(ia*(ia-1))*  Sxyz(iZeta,iCar,ia-2,ib)
                     End If
*
                     rV2Int(iZeta,iCar,ia,ib,2) =
     &                  Four* Beta(iZeta)**2*Sxyz(iZeta,iCar,ia,ib+2)
     &                 -Two* Beta(iZeta)*(Two*Dble(ib)+One)*
     &                                       Sxyz(iZeta,iCar,ia,ib)
                     If (ib.ge.2) Then
                        rV2Int(iZeta,iCar,ia,ib,2) =
     &                     rV2Int(iZeta,iCar,ia,ib,2)
     &                     +Dble(ib*(ib-1))*  Sxyz(iZeta,iCar,ia,ib-2)
                     End If
*
                     rV4Int(iZeta,iCar,ia,ib) =
     &                  Four*Alpha(iZeta)**2*
     &                  Four* Beta(iZeta)**2*Sxyz(iZeta,iCar,ia+2,ib+2)
     &                 -Four*Alpha(iZeta)**2*
     &                  Two* Beta(iZeta)*(Two*Dble(ib)+One)*
     &                                       Sxyz(iZeta,iCar,ia+2,ib)
     &                 -Four* Beta(iZeta)**2*
     &                  Two*Alpha(iZeta)*(Two*Dble(ia)+One)*
     &                                        Sxyz(iZeta,iCar,ia,ib+2)
     &                 +Two*Alpha(iZeta)*(Two*Dble(ia)+One)*
     &                  Two* Beta(iZeta)*(Two*Dble(ib)+One)*
     &                                       Sxyz(iZeta,iCar,ia,ib)
                     If (ia.ge.2) Then
                        rV4Int(iZeta,iCar,ia,ib) =
     &                     rV4Int(iZeta,iCar,ia,ib) + Dble(ia*(ia-1))* (
     &                     Four* Beta(iZeta)**2 *
     &                                       Sxyz(iZeta,iCar,ia-2,ib+2)
     &                    -Two* Beta(iZeta)*(Two*Dble(ib)+One)*
     &                                       Sxyz(iZeta,iCar,ia-2,ib) )
                     End If
                     If (ib.ge.2) Then
                        rV4Int(iZeta,iCar,ia,ib) =
     &                     rV4Int(iZeta,iCar,ia,ib) + Dble(ib*(ib-1))* (
     &                     Four*Alpha(iZeta)**2 *
     &                                       Sxyz(iZeta,iCar,ia+2,ib-2)
     &                    -Two*Alpha(iZeta)*(Two*Dble(ia)+One)*
     &                                       Sxyz(iZeta,iCar,ia,ib-2) )
                     End If
                     If (ia.ge.2.and.ib.ge.2) Then
                        rV4Int(iZeta,iCar,ia,ib) =
     &                     rV4Int(iZeta,iCar,ia,ib)
     &                    +Dble(ia*(ia-1)*ib*(ib-1)) *
     &                                       Sxyz(iZeta,iCar,ia-2,ib-2)
                     End If
*
                  End Do
               End Do
         End Do
      End Do
*
      If (iPrint.ge.99) Then
         Do ib = 0, nb
            Do ia = 0, na
               Write (Label,'(A,I2,A,I2,A)')
     &            'In MVe: rV2Int(',ia,',',ib,',1)'
               Call RecPrt(Label,' ',rV2Int(1,1,ia,ib,1),nZeta,3)
               Write (Label,'(A,I2,A,I2,A)')
     &            'In MVe: rV2Int(',ia,',',ib,',2)'
               Call RecPrt(Label,' ',rV2Int(1,1,ia,ib,2),nZeta,3)
               Write (Label,'(A,I2,A,I2,A)')
     &            'In MVe: rV4Int(',ia,',',ib,')'
               Call RecPrt(Label,' ',rV4Int(1,1,ia,ib),nZeta,3)
            End Do
         End Do
      End If
*
*     Call GetMem(' Exit MVe   ','CHECK','REAL',iDum,iDum)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  CCD_InCore
*
*> @brief
*>   Complete Cholesky decomposition of the symmetric positive definite matrix \p X
*> @author Thomas Bondo Pedersen
*>
*> @details
*> The \p n &times; \p n matrix \p X is Cholesky decomposed and the resulting
*> Cholesky vectors are returned in the lower triangle of \p X.
*> A non-zero return code signals
*> that an error has occured (\p X might e.g. be non-positive
*> definite) and the output is ill-defined.
*>
*> @param[in,out] X   Matrix to be Cholesky decomposed;
*>                    on exit, lower triangle contains the vectors
*> @param[in]     n   Linear dimension of \p X
*> @param[out]    irc Return code
************************************************************************
      Subroutine CCD_InCore(X,n,irc)
      Implicit None
      Integer n
      Real*8  X(n,n)
      Integer irc

      Integer i, j, k
      Real*8  Fac

      irc = 0
      If (n .lt. 1) Return ! return (nothing to do)

      Do j=1,n
         ! Check for negative diagonal
         If (X(j,j).gt.0.0d0) Then
            Fac=1.0d0/sqrt(X(j,j))
         Else
            irc=1
            Return
         End If
         ! Compute vector j
         Do i=j,n
            X(i,j)=Fac*X(i,j)
         End Do
         ! Subtract from remaining columns
         Do k=j+1,n
            Fac=X(k,j)
            Do i=k,n
               X(i,k)=X(i,k)-X(i,j)*Fac
            End Do
         End DO
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine BitMap_Localisation_Atom(PreFix)
      Implicit Real*8 (a-h,o-z)
      Character*2 PreFix
#include "Molcas.fh"
#include "inflocal.fh"
#include "WrkSpc.fh"

      Character*24 SecNam
      Parameter (SecNam = 'BitMap_Localisation_Atom')

      Character*4  Typ(2)
      Character*12 BasNam

      Integer kC0(2)

      Logical Debug

      Debug = .False.

C     Symmetry is not allowed!
C     ------------------------

      If (nSym .ne. 1) Then
         Call SysAbendMsg(SecNam,'Symmetry not implemented!','Sorry!')
      End If

C     Allocate max. sym. block of density matrix
C     and atom based density and CMO matrices.
C     ------------------------------------------

      lDen  = nBas(1)**2
      lDAt  = nAtoms**2
      lCAt  = nAtoms*nOrb2Loc(1)
      lXAt  = lCAt
      Call GetMem('BMpLoc','Allo','Real',ipDen,lDen)
      Call GetMem('DAt','Allo','Real',ipDAt,lDAt)
      Call GetMem('CAt','Allo','Real',ipCAt,lCAt)
      Call GetMem('XAt','Allo','Real',ipXAt,lXAt)

C     Allocate and get index arrays for basis functions per atom.
C     -----------------------------------------------------------

      l_nBas_per_Atom = nAtoms
      l_nBas_Start    = nAtoms
      Call GetMem('nB_per_Atom','Allo','Inte',
     &            ip_nBas_per_Atom,l_nBas_per_Atom)
      Call GetMem('nB_Start','Allo','Inte',
     &            ip_nBas_Start,l_nBas_Start)
      Call BasFun_Atom(iWork(ip_nBas_per_Atom),iWork(ip_nBas_Start),
     &                 Name,nBas(1),nAtoms,Debug)

C     Compute density matrix, Den = CC^T, and set atom based matrices.
C     Generate bitmap and perform sparsity analysis.
C     ----------------------------------------------------------------

      kC1 = ipMOrig + nBas(1)*nFro(1)
      Call GetDens_Localisation(Work(ipDen),Work(kC1),nBas(1),
     &                          nOrb2Loc(1))
      Call GetAt_Localisation(Work(ipDen),nBas(1),nBas(1),
     &                        Work(ipDAt),nAtoms,2,
     &                        iWork(ip_nBas_per_Atom),
     &                        iWork(ip_nBas_Start),
     &                        AnaNrm)
      Call GetAt_Localisation(Work(kC1),nBas(1),nOrb2Loc(1),
     &                        Work(ipCAt),nAtoms,1,
     &                        iWork(ip_nBas_per_Atom),
     &                        iWork(ip_nBas_Start),
     &                        AnaNrm)
      kX1 = ipCMO + nBas(1)*nFro(1)
      Call GetAt_Localisation(Work(kX1),nBas(1),nOrb2Loc(1),
     &                        Work(ipXAt),nAtoms,1,
     &                        iWork(ip_nBas_per_Atom),
     &                        iWork(ip_nBas_Start),
     &                        AnaNrm)
      Call GenBMp_Localisation(Work(ipDAt),Work(ipCAt),Work(ipXAt),
     &                         nAtoms,1,'r','r','r',PreFix)
      Call Anasize_Localisation(Work(ipDAt),Work(ipCAt),Work(ipXAt),
     &                          nAtoms,nOrb2Loc(1),1)
      Write(6,*) 'Bitmap files have been generated. Norm: ',AnaNrm

C     Allocate memory for nuclear coordinates.
C     Read nuclear coordinates from the runfile.
C     Generate gnuplot files.
C     ------------------------------------------

      lCoord = 3*nAtoms
      Call GetMem('NucCoord','Allo','Real',ipCoord,lCoord)
      Call Get_dArray('Unique Coordinates',Work(ipCoord),lCoord)

      Call GetAt_Localisation(Work(ipDen),nBas(1),nBas(1),
     &                        Work(ipDAt),nAtoms,2,
     &                        iWork(ip_nBas_per_Atom),
     &                        iWork(ip_nBas_Start),
     &                        AnaNrm)
      Write(BasNam,'(A2,A10)') PreFix,'TotDensity'
      Call GenGnu_Localisation(BasNam,Work(ipDAt),Work(ipCoord),nAtoms)
      Typ(1) = 'Dini'
      Typ(2) = 'Dloc'
      kC0(1) = ipMOrig
      kC0(2) = ipCMO
      Do iTyp = 1,2
         kC1 = kC0(iTyp) + nBas(1)*nFro(1)
         Do i = 1,nOrb2Loc(1)
            kC2 = kC1 + nBas(1)*(i-1)
            Call GetDens_Localisation(Work(ipDen),Work(kC2),nBas(1),1)
            Call GetAt_Localisation(Work(ipDen),nBas(1),nBas(1),
     &                              Work(ipDAt),nAtoms,2,
     &                              iWork(ip_nBas_per_Atom),
     &                              iWork(ip_nBas_Start),
     &                              AnaNrm)
            Write(BasNam,'(A2,A4,I6)') PreFix,Typ(iTyp),i
            Call GenGnu_Localisation(BasNam,Work(ipDAt),Work(ipCoord),
     &                               nAtoms)
         End Do
      End Do
      Write(6,*) 'Gnuplot files have been generated. Norm: ',AnaNrm

C     De-allocations.
C     ---------------

      Call GetMem('NucCoord','Free','Real',ipCoord,lCoord)
      Call GetMem('nB_Start','Free','Inte',
     &            ip_nBas_Start,l_nBas_Start)
      Call GetMem('nB_per_Atom','Free','Inte',
     &            ip_nBas_per_Atom,l_nBas_per_Atom)
      Call GetMem('XAt','Free','Real',ipXAt,lXAt)
      Call GetMem('CAt','Free','Real',ipCAt,lCAt)
      Call GetMem('DAt','Free','Real',ipDAt,lDAt)
      Call GetMem('BMpLoc','Free','Real',ipDen,lDen)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1995, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE GSBBD1(RHO1,NACOB,ISCSM,ISCTP,ICCSM,ICCTP,IGRP,NROW,
     &                  NGAS,ISEL,ICEL,
     &                  SB,CB,
     &                  ADSXA,SXSTST,STSTSX,MXPNGAS,
     &                  NOBPTS,IOBPTS,ITSOB,MAXI,MAXK,
     &                  SSCR,CSCR,I1,XI1S,I2,XI2S,H,
     &                  NSMOB,NSMST,NSMSX,MXPOBS,RHO1S)
*


* Contributions to one electron density matrix from column excitations
*
* GAS version, August 95 , Jeppe Olsen
*
* =====
* Input
* =====
* RHO1  : One body density matrix to be updated
* NACOB : Number of active orbitals
* ISCSM,ISCTP : Symmetry and type of sigma columns
* ICCSM,ICCTP : Symmetry and type of C     columns
* IGRP : String group of columns
* NROW : Number of rows in S and C block
* NGAS : Number of active spaces
* ISEL : Number of electrons per AS for S block
* ICEL : Number of electrons per AS for C block
* CB   : Input C block
* ADASX : sym of a+, a => sym of a+a
* ADSXA : sym of a+, a+a => sym of a
* SXSTST : Sym of sx,!st> => sym of sx !st>
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
* MXPNGAS : Max number of AS spaces ( program parameter )
* NOBPTS  : Number of orbitals per type and symmetry
* IOBPTS : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* NSMOB,NSMST,NSMSX,NSMDX : Number of symmetries of orbitals,strings,
*       single excitations, double excitations
* MAXI   : Largest Number of ' spectator strings 'treated simultaneously
* MAXK   : Largest number of inner resolution strings treated at simult.
*
* ======
* Output
* ======
* RHO1 : Updated density block
*
* =======
* Scratch
* =======
*
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S   : MAXK*Max number of orbitals of given type and symmetry
* I2, XI2S   : MAXK*Max number of orbitals of given type and symmetry
*              type and symmetry
* RHO1S : Space for one electron density
*
* Jeppe Olsen, Winter of 1991
* Updated for GAS , August '95
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
      INTEGER ADSXA(MXPOBS,2*MXPOBS),SXSTST(NSMSX,NSMST),
     &        STSTSX(NSMST,NSMST)
      INTEGER NOBPTS(3,*), IOBPTS(3,*), ITSOB(*)
C     INTEGER NTSOB(3,*),IBTSOB(3,*),ITSOB(*)
*.Input
      INTEGER ISEL(NGAS),ICEL(NGAS)
      DIMENSION CB(*),SB(*)
*.Output
      DIMENSION RHO1(*)
*.Scatch
      DIMENSION SSCR(*),CSCR(*),RHO1S(*)
      DIMENSION I1(*),XI1S(*)
      DIMENSION I2(*),XI2S(*)
*
*.Local arrays
      DIMENSION ITP(3*3),JTP(3*3)
*
* Type of single excitations that connects the two column strings
      CALL SXTYP_GAS(NSXTP,ITP,JTP,3,ISEL,ICEL)
*.Symmetry of single excitation that connects IBSM and JBSM
      IJSM = STSTSX(ISCSM,ICCSM)
      IF(IJSM.EQ.0) GOTO 1001
      DO 900 IJTP=  1, NSXTP
        ITYP = ITP(IJTP)
        JTYP = JTP(IJTP)
        DO 800 ISM = 1, NSMOB
*. new i and j so new intermediate strings
          JSM = ADSXA(ISM,IJSM)
          IF(JSM.EQ.0) GOTO 800
          NIORB = NOBPTS(ITYP,ISM)
          NJORB = NOBPTS(JTYP,JSM)
          IBIORB = IOBPTS(ITYP,ISM)
          IBJORB = IOBPTS(JTYP,JSM)
          IF(NIORB.EQ.0.OR.NJORB.EQ.0) GOTO 800
*
COLD. Loop over partitionings of the row strings
          NIPART = NROW/MAXI
          IF(NIPART*MAXI.NE.NROW) NIPART = NIPART + 1
*. Loop over partitionings of N-1 strings
            KBOT = 1-MAXK
            KTOP = 0
  700       CONTINUE
              KBOT = KBOT + MAXK
              KTOP = KTOP + MAXK
*EAWBEGIN970207
*             -1 -> MAXK
*             KTOP -> -1
*             KTOP=-1
*. Single excitation information independent of I strings
*
*.set up I1(K) =  XI1S(K) a JORB !J STRING >
              CALL ADST(IBJORB,NJORB,ICCTP,ICCSM,IGRP,KBOT,KTOP,
     &             I1,XI1S,MAXK,NKBTC,KEND)
*.set up I2(K) =  XI1S(K) a JORB !J STRING >
              CALL ADST(IBIORB,NIORB,ISCTP,ISCSM,IGRP,KBOT,KTOP,
     &             I2,XI2S,MAXK,NKBTC,KEND)
*EAWEND
*. Appropriate place to start partitioning over I strings
*. Loop over partitionings of the row strings
          DO 701 IPART = 1, NIPART
            IBOT = (IPART-1)*MAXI+1
            ITOP = MIN(IBOT+MAXI-1,NROW)
            NIBTC = ITOP - IBOT + 1

* Obtain CSCR(I,K,JORB) = SUM(J)<K!A JORB!J>C(I,J)
*.Gather  C Block
              DO JJORB = 1,NJORB
                ICGOFF = 1 + (JJORB-1)*NKBTC*NIBTC
                CALL MATCG(CB,CSCR(ICGOFF),NROW,NIBTC,IBOT,
     &                     NKBTC,I1(1+(JJORB-1)*MAXK),
     &                         XI1S(1+(JJORB-1)*MAXK)     )
              END DO
*
*
* Obtain SSCR(I,K,IORB) = SUM(I)<K!A IORB!J>S(I,J)
              DO IIORB = 1,NIORB
*.Gather S Block
                ISGOFF = 1 + (IIORB-1)*NKBTC*NIBTC
                CALL MATCG(SB,SSCR(ISGOFF),NROW,NIBTC,IBOT,
     &                     NKBTC,I2(1+(IIORB-1)*MAXK),
     &                     XI2S(1+(IIORB-1)*MAXK) )
              END DO
              NKI = NKBTC*NIBTC
              If (NKI*NIORB*NJORB.ne.0)  Then
              CALL DGEMM_('T','N',NIORB,NJORB,NKI,1.0D0,SSCR,NKI,CSCR,
     &                    NKI,0.0D0,RHO1S,NIORB)
              Else
               call dcopy_(NIORB*NJORB,[0.0d0],0,RHO1S,1)
              End IF
*. Scatter out to complete matrix
              DO 610 JJORB = 1, NJORB
                JORB = IBJORB-1+JJORB
                DO 605 IIORB = 1, NIORB
                  IORB = IBIORB-1+IIORB
                  RHO1((JORB-1)*NACOB+IORB) =
     &            RHO1((JORB-1)*NACOB+IORB) +
     &            RHO1S((JJORB-1)*NIORB+IIORB)
 605            CONTINUE
 610         CONTINUE
*
*
  701     CONTINUE
*. /\ end of this I partitioning
*.end of this K partitioning
            IF(KEND.EQ.0) GOTO 700
*. End of loop over I partitioninigs
  800   CONTINUE
*.(end of loop over symmetries)
  900 CONTINUE
 1001 CONTINUE
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(SXSTST)
        CALL Unused_integer(MXPNGAS)
        CALL Unused_integer_array(ITSOB)
        CALL Unused_real(H)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION IWEYLF(NOPEN,MULTS)
C
C NUMBER OF CSF'S WITH NOPEN ORBITALS AND TOTAL MULTIPLICITY
C MULTS ACCORDING TO WEYLS FORMULAE
C
C     (2S+1)/(NOPEN+1) * BION(NOPEN+1/0.5NOPEN-S)
C
      IMPLICIT REAL*8           (A-H,O-Z)
C
      NTEST = 00

      IF(NOPEN.EQ.0 .AND. MULTS .EQ. 1 ) THEN
        NCSF = 1
      ELSEIF(MOD(MULTS-1,2) .NE. MOD(NOPEN,2) ) THEN
        NCSF = 0
      ELSEIF(MOD(MULTS-1,2) .EQ. MOD(NOPEN,2) ) THEN
        NCSF = MULTS*IBION_LUCIA(NOPEN+1,(NOPEN+1-MULTS)/2)/(NOPEN+1)
      END IF
C
      IWEYLF = NCSF
C
      IF(NTEST .NE. 0 ) THEN
        WRITE(6,'(A,4I4)')
     &  '  IWEYLF SAYS : NOPEN MULTS NCSF : ', NOPEN,MULTS,NCSF
      END IF
C
      RETURN
      END

*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine change_cvb()

use casvb_global, only: icnt_ci, iprm, kbasis, kbasiscvb, proj, projcas, projsym, strtint
use Constants, only: Ten
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: kbasisp
logical(kind=iwp), external :: chpcmp_cvb, & ! ... Change of dimensioning variables ...
                               up2date_cvb   ! ... Make: up to date? ...

! General settings:
proj = projsym

! Determine changes to memory assignment:
iprm = 0

call change1_cvb()
call change2_cvb()
call change3_cvb()
call change4_cvb()
call change5_cvb()
call change6_cvb()
call change7_cvb()

! Finished determining reassignment of memory, now determine
! what information must be evaluated/read again:

call chpcmp2_cvb(kbasis,kbasisp)
if (up2date_cvb('GUESS') .and. (kbasiscvb /= kbasis)) call touch_cvb('TRNSPN')
call symchk_cvb()
if (chpcmp_cvb(nint(strtint*Ten))) call touch_cvb('RDINT')

! Redo CIVB if definition has changed (from CVB or CIVECP):
if (chpcmp_cvb(merge(1,0,projcas))) icnt_ci(2:5) = 0

return

end subroutine change_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombOnly0_2(nD,ip_DBlocks,ip_WBlocks,AB,CD)
! Thomas Bondo Pedersen, September 2010.
!
!          OLD CODE
!
! Purpose: Compute
!
!      W(J_AB) = W(J_AB) + sum_[k_C l_D] (k_C l_D|J_AB)*D(k_C l_D)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nD, ip_DBlocks(nD), ip_WBlocks(nD), AB, CD
integer(kind=iwp) :: C, D, nkl, M, l_Int, iD, ipD, ipW
real(kind=wp), allocatable :: FuvJ2(:)
integer(kind=iwp), external :: LDF_nBas_Atom, LDF_nBasAux_Pair
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

! Get row and column dimensions of integrals
C = iWork(ip_AP_Atoms-1+2*(CD-1)+1)
D = iWork(ip_AP_Atoms-1+2*(CD-1)+2)
nkl = LDF_nBas_Atom(C)*LDF_nBas_Atom(D)
M = LDF_nBasAux_Pair(AB)

! Return if nothing to do
if ((nkl < 1) .or. (M < 1)) return

! Allocate integrals (k_C l_D | J_AB)
l_Int = nkl*M
call mma_allocate(FuvJ2,l_Int,label='LDFFuvJ2')

! Compute integrals (k_C l_D | J_AB)
call LDF_ComputeIntegrals_uvJ_2P(CD,AB,l_Int,FuvJ2)

! Compute contributions
do iD=1,nD
  ipD = iWork(ip_DBlocks(iD)-1+CD)
  ipW = iWork(ip_WBlocks(iD)-1+AB)
  call dGeMV_('T',nkl,M,One,FuvJ2,nkl,Work(ipD),1,One,Work(ipW),1)
end do

! Deallocate integrals
call mma_deallocate(FuvJ2)

end subroutine LDF_Fock_CoulombOnly0_2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DISKUN2()
! Assign logical unit numbers for LUCIA:
!
! All file with some kind of input information  :  10 - 19
! All files containing final results            :  90 - 99
! Scratch files                                 :  40 - 59
! Internal files (retained through job)         :  60 - 69

use lucia_data, only: IDISK, LUC, LUDIA, LUHC, LUMOUT, LUSC1, LUSC2, LUSC3, LUSC34, &
                      LUSC35, LUSC36, LUSC37, LUSC38, LUSC39, LUSC40
use Definitions, only: iwp

implicit none
integer(kind=iwp), external :: IsFreeUnit

! =========================
! Standard input and output
! =========================
! Input file
!LUIN = u5
! Output file
!LUOUT = u6
! =================
! Input information
! =================
! Input file containing MO-AO transformation matrix
!LUMOIN = 12
! Input file for CI-vectors
! restart from file 21 is assumed
! Input, two electron integrals - MOLCAS
!LU2INT = 13
! Input, one electron integrals - MOLCAS
!LU1INT = 14
! Input, property one-electron integral files
!LUPRP = 15
! File containing additional states for transition densities
!LUEXC = 17
! =================
! Internal files
! =================
! CI diagonal
LUDIA = IsFreeUnit(18)
call DANAME_WA(LUDIA,'CIDIA')

! CI vector
LUC = IsFreeUnit(Ludia)
call DANAME_WA(LUC,'LUCVECT')

! Sigma vector file
LUHC = IsFreeUnit(LuC)
call DANAME_WA(LUHC,'HCFILE')

! File collecting CC correction vectors, used for DIIS etc
!-jwk LU_CCVEC = 23
! File containing approximations to the CC solutions
!-jwk LU_CCVECT = 24
! File containing CC vector functions for the CC vectors on LU_CCVECT
!-jwk LU_CCVECF = 25
! File containing Last CC coefficients
!-jwk LU_CCVECL = 26
! File containing Last CC vector function
!-jwk LU_CCVECFL = 27
! =================
! Scratch files
! =================
LUSC1 = IsFreeUnit(LuHC)
call DANAME_WA(LUSC1,'LUSC1')

LUSC2 = IsFreeUnit(Lusc1)
call DANAME_WA(LUSC2,'LUSC2')

LUSC3 = IsFreeUnit(Lusc2)
call DANAME_WA(LUSC3,'LUSC3')

! Scratch space for subspace handling
LUSC34 = IsFreeUnit(Lusc3)
call DANAME_WA(LUSC34,'LUSC34')

LUSC35 = IsFreeUnit(Lusc34)
call DANAME_WA(LUSC35,'LUSC35')

LUSC36 = IsFreeUnit(Lusc35)
call DANAME_WA(LUSC36,'LUSC36')

LUSC37 = IsFreeUnit(Lusc36)
call DANAME_WA(LUSC37,'LUSC37')

LUSC38 = IsFreeUnit(Lusc37)
call DANAME_WA(LUSC38,'LUSC38')

LUSC39 = IsFreeUnit(Lusc38)
call DANAME_WA(LUSC39,'LUSC39')

LUSC40 = IsFreeUnit(Lusc39)
call DANAME_WA(LUSC40,'LUSC40')

! =================
! Output files
! =================
! output file for CI-vectors
! Not in use
!LUCIVO = 98
! Natural orbitals in terms of input orbitals
LUMOUT = IsFreeUnit(Lusc40)
call DANAME_WA(LUMOUT,'LUMOUT')

! Dumping 1- and 2- electron integrals in formatted form
! (LU90 just defined here, it is not exported)
!LU90  = 90
! Dumping symmmetry info, MO-AO expansion matrix and property integrals
!LU91 = 91
! CC amplitudes in formatted form
!LU_CCAMP = 92
! Result of CI=> CC conversion
!LU_CC_FROM_CI = 93
! Excitation operators, all symmetries
!LU_CCEXC_OP = 94
IDISK(:) = 0

end subroutine DISKUN2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MMCount(natom,nAtMM,ipIsMM)
      Implicit Real*8 (A-H,O-Z)
*
*     Count the number of MM atoms
*
#include "espf.fh"
*
      Logical Exist
*
      iPL = iPL_espf()
      ipIsMM = ip_iDummy
*
      Call Qpg_iArray('IsMM',Exist,nBla)
      If (.not.Exist) Then
         Write(6,'(A)') 'MMCount: IsMM not on the runfile'
         Call Abend
      End If
      If (nBla.le.0) Then
         Write(6,'(A,I5)') 'MMCount: IsMM bad length:',nBla
         Call Abend
      End If
      Call GetMem('Is MM','Allo','Inte',ipIsMM1,nBla)
      Call Get_iArray('IsMM',iWork(ipIsMM1),nBla)
      Call GetMem('AtoToBas','Allo','Inte',ipNTC,natom)
      Call Get_iArray('Atom -> Basis',iWork(ipNTC),natom)
      Call GetMem('IsMM for atoms','Allo','Inte',ipIsMM,natom)
      Do iAtom = 0, natom-1
         iWork(ipIsMM+iAtom) = iWork(ipIsMM1+iWork(ipNTC+iAtom)-1)
      End Do
      Call GetMem('AtoToBas','Free','Inte',ipNTC,natom)
      Call GetMem('Is MM','Free','Inte',ipIsMM1,nBla)
*
      nAtMM = 0
      Do iAt = 1, natom
         If (iWork(ipIsMM+iAt-1).eq.1) nAtMM = nAtMM + 1
      End Do
      If (nAtMM.lt.0) Then
         Write(6,'(A)') 'Error in MMCount: nAtMM < 0!'
         Call Quit_OnUserError()
      Else If (nAtMM.gt.natom) Then
         Write(6,'(A)') 'Error in MMCount: nAtMM >= natom!'
         Call Quit_OnUserError()
      Else If(nAtMM.ne.0.and.iPL.ge.3) Then
         Write(6,'(A,I5,A)') ' QM/MM: found ',nAtMM,' MM atoms'
      End If
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine rdline_cvb(nfield)
      implicit real*8 (a-h,o-z)
c  BLANKDELIM signifies whether blanks are used to delimit fields :
      logical blankdelim,variat
      logical debug
      logical isitanint_cvb,isitareal_cvb
      external isitanint_cvb,isitareal_cvb
#include "luinp_cvb.fh"
      parameter(nblank=2,ncomeol=3,neol=4,neofield=1,neof=2,nempty=1,
     >  nalias=2)
      character*300 line
      character*(*) string
      character*1 blanks(nblank)
c  COMEOL are comments that comment out the rest of the line
c  (might add 'bracketing' comments (e.g. /* ... */ ) later) :
      character*3 comeol(ncomeol)
      character*1 eol(neol)
      character*1 eofield(neofield)
      character*10 eof(neof)
      character*2 empty(nempty)
      character*5 alias(nalias,2)
      dimension ilv(300)
      save blankdelim
      save blanks,comeol,eof,eol,eofield,empty
      save line,lenline,ilv
      save iline,nline,nlold
      data iline/0/,nline/0/,nlold/0/
      data blankdelim/.true./
      data blanks/' ',','/,comeol/'***','!  ','*  '/
      data eof/'---       ','ENDOFINPUT'/
      data eol/';','=','{','}'/
      data eofield/' '/
      data empty/'--'/
      data alias/'={   ',';    ','}    ',';END;'/
      data debug/.false./

50    continue
      if(nline.eq.-1)then
        nfield=-1
        return
      endif
      if(iline.lt.nline)then
        iline=iline+1
        goto 899
      else
        iline=1
      endif
c  Read full input line from file and make preparations :
100   read(inp,'(a)',end=200)line
      lenline=len_trim_cvb(line)
      call strip_blanks_cvb(line,lenline,blanks,nblank,blankdelim)
      call upper_case_cvb(line,lenline)
c  Check for "end-of-file" character sequence :
      do 300 ieof=1,neof
      ilength=len_trim_cvb(eof(ieof))
      if(line(1:ilength).eq.eof(ieof)(1:ilength))goto 200
300   continue
c  Comment strings (skip rest of line ) :
      indmin=lenline+1
      do 500 icom=1,ncomeol
      ind=index(line(1:lenline),comeol(icom)
     >  (1:len_trim_cvb(comeol(icom))))
      if(ind.ne.0)indmin=min(indmin,ind)
500   continue
      lenline=len_trim_cvb(line(1:indmin-1))
      if(lenline.eq.0)goto 100
c  Aliases :
      do 550 ialias=1,nalias
560   ind=index(line(1:lenline),alias(ialias,1)
     >  (1:len_trim_cvb(alias(ialias,1))))
      if(ind.ne.0)then
        call charinsert_cvb(alias(ialias,2),
     >    len_trim_cvb(alias(ialias,2)),
     >    line,lenline,ind,len_trim_cvb(alias(ialias,1)))
        goto 560
      endif
550   continue
      lenline=len_trim_cvb(line(1:indmin-1))
      if(lenline.eq.0)goto 100
c  Split into lines :
      call izero(ilv,lenline)
      do 600 ieol=1,neol
      if=0
      ilength=len_trim_cvb(eol(ieol))
650   ind=index(line(if+1:lenline),eol(ieol)(1:ilength))
      if(ind.ne.0)then
        ilv(ind+if)=1
        if=ind+if
        goto 650
      endif
600   continue
      nlold=nline
      nline=1
      do 700 ich=1,lenline
      if(ilv(ich).eq.1)nline=nline+1
700   continue
c  Split into fields :
      do 800 ieofield=1,neofield
      if=0
      ilength=max(1,len_trim_cvb(eofield(ieofield)))
850   ind=index(line(if+1:lenline),eofield(ieofield)(1:ilength))
      if(ind.ne.0)then
        ilv(ind+if)=2
        if=ind+if
        goto 850
      endif
800   continue
c  Eliminate field separators at end of lines:
      do 873 ieofield=1,neofield
      ihadchar=0
      do 875 ich=lenline,1,-1
      if(ilv(ich).eq.1)then
        ihadchar=0
      elseif(ilv(ich).eq.2)then
        if(ihadchar.eq.0)ilv(ich)=0
        ilength=len_trim_cvb(eofield(ieofield))
        do 880 i=0,ilength-1
        line(i+ich:i+ich)=' '
880     continue
        ihadchar=1
      else
        ihadchar=1
      endif
875   continue
873   continue
c  Count the number of fields in present card (ILINE).
c  Also make sure line is not all empty :
899   continue
      nfield=1
      jline=1
      ilinebeg=0
      ilineend=-1
      do 900 ich=1,lenline
      if(jline.eq.iline-1)ilinebeg=ich+1
      if(ilv(ich).eq.1)jline=jline+1
      if(jline.eq.iline+1.and.ilineend.eq.-1)ilineend=ich-1
      if(jline.eq.iline.and.ilv(ich).eq.2)nfield=nfield+1
900   continue
      if(iline.eq.1)ilinebeg=1
      if(ilineend.eq.-1)ilineend=lenline
c  Go back and read a new line if this one is empty :
      if(ilinebeg.gt.ilineend)goto 50
      if(len_trim_cvb(line(ilinebeg:ilineend)).eq.0)goto 50
      return
200   nline=-1
      nfield=-1
      return
      entry pushline_cvb()
      if(iline.eq.1.or.nline.eq.-1)then
        backspace(inp)
        iline=nlold
        nline=nlold
      else
        iline=iline-1
      endif
      return
      entry gtany_cvb(string,int,real,ic,ifield,ierr)
c      ic=1
c      goto 1050
c      entry gtint_cvb(int,ifield,ierr)
c      ic=2
c      goto 1050
c      entry gtreal_cvb(real,ifield,ierr)
c      ic=3
c1050  continue
      if(ic.gt.1)ierr=0
      jfield=1
      jline=1
      do 1000 ich=1,lenline
      if(ilv(ich).eq.1)jline=jline+1
      if(jline.eq.iline.and.ilv(ich).eq.2)jfield=jfield+1
      if(jline.eq.iline.and.jfield.eq.ifield)then
        jch=ich
        if(ich.eq.1)jch=0
1100    jch=jch+1
        if(ilv(jch).eq.0.and.jch.ne.lenline+1)goto 1100
        ifirst=ich+1
        if(ich.eq.1)ifirst=1
c  Special character strings to signify empty field ?
        do 1125 iempty=1,nempty
        if(line(ifirst:jch-1).eq.empty(iempty)
     >    (1:len_trim_cvb(empty(iempty))))goto 1130
1125    continue
        if(debug)write(6,*)' Field=',line(ifirst:jch-1)
        if(ic.eq.1)then
          string=line(ifirst:jch-1)
          if(debug)write(6,*)' Field read as string :',string
        elseif(ic.eq.2)then
          if(ifirst.gt.jch-1)then
            ierr=2
            return
          endif
          if(.not.isitanint_cvb(line(ifirst:jch-1)))goto 1150
          read(line(ifirst:jch-1),*,err=1150)int
          if(debug)write(6,*)' Field read as int :',int
        elseif(ic.eq.3)then
          if(ifirst.gt.jch-1)then
            ierr=2
            return
          endif
          if(.not.isitareal_cvb(line(ifirst:jch-1)))goto 1150
          read(line(ifirst:jch-1),*,err=1150)real
          if(debug)write(6,*)' Field read as real :',real
        endif
        return
1130    continue
c  "Empty" field :
        if(ic.eq.1)then
          string=' '
        else
          ierr=2
        endif
        return
      endif
1000  continue
      write(6,*)' Error in input parsing !'
      call abend_cvb()
1150  ierr=1
      if(debug)then
        if(ic.eq.2)then
          write(6,*)' Could not read field as integer.'
        else
          write(6,*)' Could not read field as real.'
        endif
      endif
      return
      entry rdline_init_cvb(variat)
      if(variat)return
      rewind(inp)
2100  read(inp,'(a)',end=2200)line
      lenline=len_trim_cvb(line)
      call strip_blanks_cvb(line,lenline,blanks,nblank,blankdelim)
      call upper_case_cvb(line,lenline)
      if(line(1:6).ne.'&CASVB')goto 2100
C     if(.not.(((.not.blankdelim).and.line(1:10).eq.'&CASVB&END').or.
C    >   (blankdelim.and.line(1:11).eq.'&CASVB &END')))goto 2100
      return
2200  write(6,*)' WARNING: Initiation string not found in input file.'
      return
      end



      logical function isitanint_cvb(a)
      implicit real*8 (a-h,o-z)
      parameter(nallowed=12)
      character*(*) a
      character*(1) allowedchars(nallowed)
      data allowedchars/'+','-','0','1','2','3','4','5','6','7','8','9'/

      do 100 ich=1,len_trim_cvb(a)
      do 200 j=1,nallowed
      if(a(ich:ich).eq.allowedchars(j))goto 100
200   continue
      isitanint_cvb=.false.
      return
100   continue
      isitanint_cvb=.true.
      return
      end
      logical function isitareal_cvb(a)
      implicit real*8 (a-h,o-z)
      parameter(nallowed=17)
      character*(*) a
      character*(1) allowedchars(nallowed)
      data allowedchars/'+','-','0','1','2','3','4','5','6','7','8','9',
     >  '.','E','e','D','d'/

      do 100 ich=1,len_trim_cvb(a)
      do 200 j=1,nallowed
      if(a(ich:ich).eq.allowedchars(j))goto 100
200   continue
      isitareal_cvb=.false.
      return
100   continue
      isitareal_cvb=.true.
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SOOUT(label,cnt_ico,phase_ico)

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Symmetry_Info, only: iChBas, iChTbl, nIrrep
use Real_Spherical, only: iSphCr, LblCBs, LblSBs
use Molcas, only: LenIn, MaxBfn, MaxBfn_aux
use Definitions, only: iwp

#include "intent.fh"

implicit none
character(len=LenIn+8), intent(out) :: Label(MaxBfn+MaxBfn_Aux)
integer(kind=iwp), intent(_OUT_) :: cnt_ico(0:7,*), phase_ico(0:7,*)
integer(kind=iwp) :: iAng, iChBs, iCnt, iCntrc, iCnttp, iCo, iComp, iIrrep, iSh, iSO, jComp, kComp, lComp, mc, mdc, nBasisi, &
                     nExpi, NrOpr
character(len=8) :: ChTemp
integer(kind=iwp), external :: iPrmt
logical(kind=iwp), external :: TstFnc

! Generate list of symmetry adapted or petite list basis functions

! Loop over Irreps
iSO = 0

! Loop over irreducible representations and symmetry operations,
! respectively, for SO and Petite list, respectively.

do iIrrep=0,nIrrep-1

  ! Loop over distinct shell types

  mdc = 0
  mc = 1
  do iCnttp=1,nCnttp
    if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag) cycle

    ! Loop over distinct centers

    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1

      ! Loop over shells associated with this center
      ! Start with s type shells

      kComp = 0
      iSh = dbsc(iCnttp)%iVal-1
      do iAng=0,dbsc(iCnttp)%nVal-1
        kComp = kComp+nTri_Elem1(iAng-1)
        iSh = iSh+1
        nExpi = Shells(iSh)%nExp
        if (nExpi == 0) cycle
        nBasisi = Shells(iSh)%nBasis
        if (nBasisi == 0) cycle
        if (Shells(iSh)%Prjct) then
          jComp = 2*iAng+1
        else
          jComp = nTri_Elem1(iAng)
        end if
        do iComp=1,jComp
          lComp = kComp+iComp
          ! Get character of basis function
          iChBs = iChBas(lComp)
          if (Shells(iSh)%Transf) iChBs = iChBas(iSphCr(lComp))

          ! Skip if function not a basis of irreps.

          if (.not. TstFnc(dc(mdc)%iCoSet,iIrrep,iChBs,dc(mdc)%nStab)) cycle

          do iCntrc=1,nBasisi
            iSO = iSO+1
            if (iSO > size(Label)) then
              call WarningMessage(2,'SOout: iSO > size(Label)')
              call Abend()
            end if
            ChTemp = LblCBs(lComp)
            if (Shells(iSh)%Transf) ChTemp = LblSbs(lComp)
            do ico=0,nIrrep/dc(mdc)%nStab-1
              Cnt_ico(ico,iso) = mc+ico
              Phase_ico(ico,iso) = iPrmt(NrOpr(dc(mdc)%iCoSet(iCo,0)),iChbs)*iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0)))
            end do
            Label(iSO) = dc(mdc)%LblCnt(1:LenIn)//ChTemp(1:8)
          end do

        end do
      end do
      mc = mc+nIrrep/dc(mdc)%nStab
    end do

  end do
end do

end subroutine SOOUT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine read_prep()

use rhodyn_data, only: CSF2SO, dipole, DM0, flag_pulse, flag_test, HTOT_CSF, Nstate, prep_id, U_CI
use rhodyn_utils, only: dashes
use mh5, only: mh5_close_file, mh5_exists_dset, mh5_fetch_dset, mh5_is_hdf5, mh5_open_file_r
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, u6

implicit none
real(kind=wp), allocatable :: DIPI(:,:,:), DIPR(:,:,:), tmpi(:,:), tmpr(:,:)

if (mh5_is_hdf5('RDPREP')) then
  call dashes()
  write(u6,*) 'reading RDPREP file, opening'
  call dashes()
  prep_id = mh5_open_file_r('RDPREP')
  write(u6,*) 'RDPREP file opened'
else
  write(u6,*) 'RDPREP file is not of hdf5 format or not found'
  call abend()
end if

call mma_allocate(tmpr,Nstate,Nstate)
call mma_allocate(tmpi,Nstate,Nstate)

write(u6,*) 'hamiltonian extraction'
if (mh5_exists_dset(prep_id,'FULL_H_R') .and. mh5_exists_dset(prep_id,'FULL_H_I')) then
  call mh5_fetch_dset(prep_id,'FULL_H_R',tmpr)
  call mh5_fetch_dset(prep_id,'FULL_H_I',tmpi)
  HTOT_CSF(:,:) = cmplx(tmpr,tmpi,kind=wp)
else
  write(u6,*) 'RDPREP does not contain Hamiltonian'
  call abend()
end if

write(u6,*) 'dm extraction'
if (mh5_exists_dset(prep_id,'DM0_R') .and. mh5_exists_dset(prep_id,'DM0_I')) then
  call mh5_fetch_dset(prep_id,'DM0_R',tmpr)
  call mh5_fetch_dset(prep_id,'DM0_I',tmpi)
  DM0(:,:) = cmplx(tmpr,tmpi,kind=wp)
else
  write(u6,*) 'RDPREP does not contain density matrix'
  call abend()
end if

write(u6,*) 'csfso extraction'
if (mh5_exists_dset(prep_id,'CSF2SO_R') .and. mh5_exists_dset(prep_id,'CSF2SO_I')) then
  call mh5_fetch_dset(prep_id,'CSF2SO_R',tmpr)
  call mh5_fetch_dset(prep_id,'CSF2SO_I',tmpi)
  CSF2SO(:,:) = cmplx(tmpr,tmpi,kind=wp)
else
  write(u6,*) 'RDPREP does not contain CSF2SO matrix'
  write(u6,*) 'Propagation will be performed in the given basis!'
  flag_test = .true.
  flag_pulse = .false.
end if

write(u6,*) 'dipole real'
if (mh5_exists_dset(prep_id,'SOS_EDIPMOM_REAL') .and. mh5_exists_dset(prep_id,'SOS_EDIPMOM_IMAG')) then
  call mma_allocate(DIPR,Nstate,Nstate,3)
  call mma_allocate(DIPI,Nstate,Nstate,3)
  call mh5_fetch_dset(prep_id,'SOS_EDIPMOM_REAL',DIPR)
  call mh5_fetch_dset(prep_id,'SOS_EDIPMOM_IMAG',DIPI)
  dipole(:,:,:) = cmplx(DIPR,DIPI,kind=wp)
  call mma_deallocate(DIPR)
  call mma_deallocate(DIPI)
  flag_pulse = .true.
end if

write(u6,*) 'u_ci extraction'
if (mh5_exists_dset(prep_id,'U_CI')) then
  call mh5_fetch_dset(prep_id,'U_CI',U_CI)
end if

call mh5_close_file(prep_id)

call mma_deallocate(tmpr)
call mma_deallocate(tmpi)

call dashes()
write(u6,*) 'reading RDPREP has been finished'
call dashes()

end subroutine read_prep

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_dExcdRa(ipdExcdRa,ndExcdRa)
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"

      Character*24 Label
      Logical      Found

      Label='dExcdRa'
      Call qpg_dArray(Label,Found,ndExcdRa)
      If(.not.Found .or. ndExcdRa.eq.0) Then
         Call SysAbendmsg('Get_dExcdRa','Did not find:',Label)
      End If
      Call GetMem('dExcdRa','Allo','Real',ipdExcdRa,ndExcdRa)
      Call Get_dArray(Label,Work(ipdExcdRa),ndExcdRa)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine EPotPoint(Potte,nPick,Pick,DPick,T,Ti,NucNr,nB,iAtom,jAtom,Center)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nPick, Pick(nPick), NucNr, nB, iAtom, jAtom, Center(nB)
real(kind=wp), intent(out) :: Potte(nPick)
real(kind=wp), intent(in) :: DPick(nPick), T(nB,nB), Ti(nB,nB)
integer(kind=iwp) :: iB1, iB2, iC1, iC2, iComp, iOpt, iPo, iPoint, irc, iSmLbl, nB2, nDens
real(kind=wp) :: dEx
character(len=10) :: Label
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: D1ao(:), D_Sq(:,:), DTrans(:,:), PP(:), PSq(:,:), PTr(:,:), TEMP(:,:)

! Loop through all points, pick out the relevant ones, obtain the
! partial expectation value from the appropriate basis and return.

nB2 = nB*(nB+1)/2
call mma_allocate(D_Sq,nB,nB,label='DSq')
call Qpg_darray('D1ao',Found,nDens)
if (Found .and. (nDens /= 0)) then
  call mma_allocate(D1ao,nDens,Label='D1ao')
else
  write(u6,*) 'EPotPoint: D1ao not found.'
  call abend()
end if
call Get_D1ao(D1ao,nDens)
call Dsq(D1ao,D_Sq,1,nB,nB)
call mma_deallocate(D1ao)
call mma_allocate(TEMP,nB,nB,label='TEMP')
call mma_allocate(DTrans,nB,nB,label='DTrans')

! Contravariant transformation of density matrix.

call DGEMM_('N','N',nB,nB,nB,One,Ti,nB,D_Sq,nB,Zero,TEMP,nB)
call DGEMM_('N','T',nB,nB,nB,One,TEMP,nB,Ti,nB,Zero,DTrans,nB)
call mma_allocate(PP,nB2+4,label='Points')
call mma_allocate(PSq,nB,nB,label='PointsSq')
call mma_allocate(PTr,nB,nB,label='PointsTr')
do iPoint=1,nPick
  iPo = Pick(iPoint)
  write(Label,'(A3,I5)') 'EF0',iPo
  irc = -1
  iOpt = 0
  iSmLbl = 0
  iComp = 1
  call RdOne(irc,iOpt,Label,iComp,PP,iSmLbl)
  call Square(PP,PSq,1,nB,nB)

  ! Covariant transformation of the matrix for the potential in this particular point.

  call DGEMM_('T','N',nB,nB,nB,One,T,nB,PSq,nB,Zero,TEMP,nB)
  call DGEMM_('N','N',nB,nB,nB,One,TEMP,nB,T,nB,Zero,PTr,nB)
  dEx = Zero

  ! The usual stuff to get the localized value.

  do iB1=1,nB
    do iB2=1,nB
      iC1 = Center(iB1)
      iC2 = Center(iB2)
      if (((iC1 == iAtom) .and. (iC2 == jAtom)) .or. ((iC1 == jAtom) .and. (iC2 == iAtom))) then
        dEx = dEx+DTrans(iB2,iB1)*PTr(iB2,iB1)
      end if
    end do
  end do

  ! Accumulate in the return vector.

  if (iAtom == jAtom) then
    Potte(iPoint) = -dEx+real(NucNr,kind=wp)/DPick(iPoint)
  else
    Potte(iPoint) = -dEx
  end if
end do

! Deallocate.

call mma_deallocate(D_Sq)
call mma_deallocate(TEMP)
call mma_deallocate(DTrans)
call mma_deallocate(PP)
call mma_deallocate(PSq)
call mma_deallocate(PTr)

return

end subroutine EPotPoint

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine PipekMezey_Iter(Functional,CMO,Ovlp,Thrs,ThrRot,ThrGrad,PA,nBas_per_Atom,nBas_Start,BName,nBasis,nOrb2Loc,nAtoms, &
                           nMxIter,Maximisation,Converged,Debug,Silent)
! Author: T.B. Pedersen
!
! Based on the original routines by Y. Carissan.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nAtoms, nBas_per_Atom(nAtoms), nBas_Start(nAtoms), nBasis, nOrb2Loc, nMxIter
real(kind=wp), intent(out) :: Functional, PA(nOrb2Loc,nOrb2Loc,nAtoms)
real(kind=wp), intent(inout) :: CMO(nBasis,*)
real(kind=wp), intent(in) :: Ovlp(nBasis,*), Thrs, ThrRot, ThrGrad
character(len=LenIn8), intent(in) :: BName(nBasis)
logical(kind=iwp), intent(in) :: Maximisation, Debug, Silent
logical(kind=iwp), intent(out) :: Converged
integer(kind=iwp) :: nIter
real(kind=wp) :: C1, C2, Delta, FirstFunctional, GradNorm, OldFunctional, PctSkp, TimC, TimW, W1, W2
real(kind=wp), allocatable :: RMat(:,:), PACol(:,:)

! Print iteration table header.
! -----------------------------

if (.not. Silent) then
  write(u6,'(//,1X,A,/,1X,A)') '                                                        CPU       Wall', &
                               'nIter       Functional P        Delta     Gradient     (sec)     (sec) %Screen'
end if

! Initialization (iteration 0).
! -----------------------------

if (.not. Silent) call CWTime(C1,W1)
nIter = 0
call mma_Allocate(RMat,nOrb2Loc,nOrb2Loc,Label='RMat')
call GenerateP(Ovlp,CMO,BName,nBasis,nOrb2Loc,nAtoms,nBas_per_Atom,nBas_Start,PA,Debug)
call ComputeFunc(nAtoms,nOrb2Loc,PA,Functional,Debug)
call GetGrad_PM(nAtoms,nOrb2Loc,PA,GradNorm,RMat,Debug)
OldFunctional = Functional
FirstFunctional = Functional
Delta = Functional
if (.not. Silent) then
  call CWTime(C2,W2)
  TimC = C2-C1
  TimW = W2-W1
  write(u6,'(1X,I5,1X,F18.8,2(1X,D12.4),2(1X,F9.1),1X,F7.2)') nIter,Functional,Delta,GradNorm,TimC,TimW,Zero
end if

! Iterations.
! -----------

call mma_Allocate(PACol,nOrb2Loc,2,Label='PACol')
Converged = .false.
do while ((nIter < nMxIter) .and. (.not. Converged))
  if (.not. Silent) call CWTime(C1,W1)
  call RotateOrb(CMO,PACol,nBasis,nAtoms,PA,Maximisation,nOrb2Loc,BName,nBas_per_Atom,nBas_Start,ThrRot,PctSkp,Debug)
  call ComputeFunc(nAtoms,nOrb2Loc,PA,Functional,Debug)
  call GetGrad_PM(nAtoms,nOrb2Loc,PA,GradNorm,RMat,Debug)
  nIter = nIter+1
  Delta = Functional-OldFunctional
  OldFunctional = Functional
  if (.not. Silent) then
    call CWTime(C2,W2)
    TimC = C2-C1
    TimW = W2-W1
    write(u6,'(1X,I5,1X,F18.8,2(1X,D12.4),2(1X,F9.1),1X,F7.2)') nIter,Functional,Delta,GradNorm,TimC,TimW,PctSkp
  end if
  Converged = (GradNorm <= ThrGrad) .and. (abs(Delta) <= Thrs)
end do
call mma_Deallocate(PACol)
call mma_Deallocate(RMat)

! Print convergence message.
! --------------------------

if (.not. Silent) then
  if (.not. Converged) then
    write(u6,'(/,A,I4,A)') 'No convergence after',nIter,' iterations.'
  else
    write(u6,'(/,A,I4,A)') 'Convergence after',nIter,' iterations.'
    write(u6,*)
    write(u6,'(A,I8)') 'Number of localised orbitals  : ',nOrb2loc
    write(u6,'(A,1P,D20.10)') 'Value of P before localisation: ',FirstFunctional
    write(u6,'(A,1P,D20.10)') 'Value of P after localisation : ',Functional
  end if
end if

end subroutine PipekMezey_Iter

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TODSCP(A,NDIM,MBLOCK,IFIL)
*
C TRANSFER ARRAY REAL*8  A(LENGTH NDIM) TO DISCFIL IFIL IN
C RECORDS WITH LENGTH NBLOCK.
*
* Packed version : Store only nonzero elements
*. Small elements should be xeroed outside
      IMPLICIT REAL*8 (A-H,O-Z)
#include "io_util.fh"
      DIMENSION A(*)
C-jwk-cleanup      INTEGER START,STOP
      REAL*8 INPROD
      INTEGER ISCR(2), IDUMMY(1)
*
      PARAMETER(LPBLK=50000)
      INTEGER IPAK(LPBLK)
      DIMENSION XPAK(LPBLK)
*
*
C?    write(6,*) ' entering TODSCP, file = ', IFIL
C?    CALL XFLUSH(6)
      IPACK = 1
      IF(IPACK.NE.0) THEN
*. Check norm of A before writing
        XNORM = INPROD(A,A,NDIM)
        IF(XNORM.EQ.0.0D0) THEN
          IMZERO = 1
        ELSE
          IMZERO = 0
        END IF
        MMBLOCK = MBLOCK
        IF(MMBLOCK.GT.2) MMBLOCK = 2
*
        ISCR(1) = IMZERO
*. Packing
        ISCR(2) = 1
C       CALL ITODS(ISCR,2,MMBLOCK,IFIL)
        CALL ITODS(ISCR,2,2,IFIL)
        IF(IMZERO.EQ.1) GOTO 1001
      END IF
*
*. Loop over packed records of dimension LPBLK
      IELMNT = 0
 1000 CONTINUE
*. The next LPBLK elements
      LBATCH = 0
*. Obtain next batch of elemnts
  999 CONTINUE
       IF(NDIM.GE.1) THEN
       IELMNT = IELMNT+1
       IF(A(IELMNT).NE.0.0D0) THEN
         LBATCH=LBATCH+1
         IPAK(LBATCH) = IELMNT
         XPAK(LBATCH) = A(IELMNT)
       END IF
       END IF
       IF(LBATCH.EQ.LPBLK.OR.IELMNT.EQ.NDIM) goto 998
       GOTO 999
*. Send to DISC
 998   CONTINUE
       IDUMMY(1)=LBATCH
       CALL IDAFILE(IFIL,1,IDUMMY,1,IDISK(IFIL))
       IF(LBATCH.GT.0) THEN
         CALL IDAFILE(IFIL,1,IPAK,LBATCH,IDISK(IFIL))
         CALL DDAFILE(IFIL,1,XPAK,LBATCH,IDISK(IFIL))
       END IF
       IF(IELMNT.EQ.NDIM) THEN
         IDUMMY(1)=-1
         CALL IDAFILE(IFIL,1,IDUMMY,1,IDISK(IFIL))
       ELSE
         IDUMMY(1)=0
         CALL IDAFILE(IFIL,1,IDUMMY,1,IDISK(IFIL))
         GOTO 1000
       END IF
*. End of loop over records of truncated elements
c      END IF
 1001 CONTINUE
*
C?    CALL XFLUSH(6)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jonna Stalring                                         *
************************************************************************
      SubRoutine RInttd(ekappa,mkappa,isym)
c
c
*******************************************************
*            [2]                                      *
* Modifies  E    *kappa by subtracting Omega*S*kappa  *
* to make timedep PT possible.                        *
*                                                     *
*******************************************************
c
c     mkappa       is d/dx(kappa) in matrix form (derivative of orb rot mat w r t PT)
c     ekappa       is E*d/dx(kappa) in matrix form, REPLACED BY
c                  the entire timedep expression
c     isym         Rinttd is called once for each symmtry
c
c Local variables
c
c     Work(ipdens) The density matrix
c     Work(wDKt)   Omega*(density matrix)*(kappa transposed)
c     Work(wKtD)   As above but different order
c
c
      Implicit Real*8 (a-h,o-z)
c
#include "WrkSpc.fh"
#include "Input.fh"
#include "Pointers.fh"
      Parameter (zero=0.0d0)
      Parameter (one=1.0d0)
      Parameter (two=2.0d0)
      Real*8 ekappa(ndens2),mkappa(ndens2)
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
c
c---------------------------------------------------------
c
c  Allocate memory
c
      lDens = 0
      Do iS=1,nSym
         lDens = lDens + nBas(iS)**2
      End Do
      Call GetMem('densmat','Allo','Real',ipdens,lDens)
      Call GetMem('wDKt','Allo','Real',ipwDKt,ndens2)
      Call GetMem('wKtD','Allo','Real',ipwKtD,ndens2)
c
c---------------------------------------------------------
c***************************************
c Construct the density matrix
c***************************************
c
c For HF
c
      call dcopy_(lDens,[0.0d0],0,Work(ipDens),1)
      ip3 = 0
      Do iS=1,nSym
          inc = nBas(iS) + 1
          call dcopy_(nIsh(iS),[2.0d0],0,Work(ipDens+ip3),inc)
          ip3 = ip3 + nBas(iS)*nBas(iS)
      End Do
*
*         do is=1,nsym
*            size=nbas(is)*nbas(is)      ! The size of the sym i and j martix
*            do k=-1,(size-1)             ! Loop over the entire submatrix
*               residual=DMOD((k+1),(nbas(is)+1))
*               if ((residual.eq.zero).and.(k.lt.(nbas(is)*nIsh
*     &      (is))).and.(nIsh(is).ne.0)) then
*                     Work(ipdens+ipCM(is)+k)=two
*               else
*                     Work(ipdens+ipCM(is)+k)=zero
*               end if
*            end do
*          end do
c
c For a CASSCF wavefunc. From Anders subrut r2elint
c Add the active active dens
c
          Do iS=1,nSym
             Do iB=1,nAsh(iS)
                Do jB=1,nAsh(iS)
                   ip=ipCM(iS)+ib+nIsh(is)+(jB+nIsh(is)-1)*nBas(is)-1
                   iA=nA(is)+ib
                   jA=nA(is)+jb
                   ip2=itri(iA,jA)
                   Work(ipdens+ip-1)=Work(ipG1t+ip2-1)
                End Do
             End Do
          End Do
c*******************************************
c Multiply D and mkappa wDKt and wKtD
c*******************************************
*      Call RecPrt('dens ',' ',Work(ipdens),ldens,1)
*      Call RecPrt('ekappa ',' ',ekappa,ndens2,1)
      do is=1,nsym
           js=iEOr(is-1,isym-1)+1
C      wDKt
           If ( (nBas(iS).gt.0).and.(nBas(jS).gt.0) ) Then
             call DGEMM_('n','n',nbas(is),nbas(js),nbas(is),2.0d0*Omega,
     & Work(ipdens+ipCM(is)-1),nbas(is),
     & mkappa(ipmat(is,js)),nbas(is),zero,
     & Work(ipwDKt+ipmat(is,js)-1),nbas(is))
C      wKtD
             call DGEMM_('n','n',nbas(is),nbas(js),nbas(js),2.0d0*Omega,
     & mkappa(ipmat(is,js)),nbas(is),
     & Work(ipdens+ipCM(js)-1),nbas(js),zero,
     & Work(ipwKtD+ipmat(is,js)-1),nbas(is))

c*****************************************************
c            Replace ekappa ekappa=ekappa-wDKt+wKtD
c*****************************************************
             incx=1
             incy=incx
             lenght=nbas(is)*nbas(js)
             call daxpy_(lenght,1.0d0,Work(ipwDKt+ipmat(is,js)-1),
     &            incx,ekappa(ipmat(is,js)),incy)
             call daxpy_(lenght,-1.0d0,Work(ipwKtD+ipmat(is,js)-1),
     &            incx,ekappa(ipmat(is,js)),incy)
          End If
      end do
*      Call RecPrt('wDKt ',' ',Work(ipwDKt),ndens2,1)
*      Call RecPrt('wKtD ',' ',Work(ipwKtD),ndens2,1)
*      Call RecPrt('ekappa ',' ',ekappa,ndens2,1)
c
c  Free memory
c
      Call GetMem('densmat','Free','Real',ipdens,ldens)
      Call GetMem('wDKt','Free','Real',ipwDKt,ndens2)
      Call GetMem('wKtD','Free','Real',ipwKtD,ndens2)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Ignacio Fdez. Galvan                             *
!***********************************************************************

module Dens2HDF5

use Symmetry_Info, only: nIrrep, MUL
use rassi_data, only: NBASF
use Cntrl, only: NSTATE
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), allocatable :: IdxState(:,:)
real(kind=wp), parameter :: Thrs = 1.0e-14_wp

public :: UpdateIdx
#ifdef _HDF5_
public :: StoreDens
#endif

contains

!***********************************************************************
!  UpdateIdx
!
!> @brief
!>   Update index of TDMs to save to HDF5
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Update the table of indices of states for the TDMs that will be saved
!> on the HDF5 file. If SUBSets keyword is not used, all TDMs are saved,
!> otherwise only those for the selected transitions. Since the TDMs are
!> saved in SF basis, for a SO calculation we need to figure out which
!> SF TDMs contribute to the desired transitions.
!>
!> @param[in] IndexE  SF states sorted by energy
!> @param[in] nSS     number of SO states
!> @param[in] USOR    SO coefficients in SF basis (real part)
!> @param[in] USOI    SO coefficients in SF basis (imaginary part)
!> @param[in] MapSt   map of SF states expanded by multiplicity
!***********************************************************************
subroutine UpdateIdx(IndexE,nSS,USOR,USOI,MapSt)

  use Cntrl, only: LOOPDIVIDE, LOOPMAX, REDUCELOOP

  integer(kind=iwp), intent(in) :: IndexE(nState), nSS
  real(kind=wp), intent(in), optional :: USOR(nSS,nSS), USOI(nSS,nSS)
  integer(kind=iwp), intent(in), optional :: MapSt(nSS)
  integer(kind=iwp) :: i, i_, iEnd, iSS, iState, j, j_, jEnd, jSS, jStart, jState
  real(kind=wp) :: f1, f2

  if (.not. allocated(IdxState)) then
    call mma_Allocate(IdxState,nState,nState,Label='IdxState')
    IdxState(:,:) = 0
  end if
  jEnd = nState
  if (nSS > 0) jEnd = nSS
  if (ReduceLoop) then
    iEnd = LoopDivide
    jStart = LoopDivide+1
    if (LoopMax > 0) jEnd = min(jEnd,LoopDivide+LoopMax)
  else
    iEnd = nState
    if (nSS > 0) iEnd = nSS
    jStart = 1
  end if
  ! list states for/between which we want to store the density matrices
  if (nSS > 0) then
    do iSS=1,nSS
      do jSS=1,nSS
        if (jSS /= iSS) then
          if (jSS < jStart) cycle
          if (iSS > iEnd) cycle
          if (jSS > jEnd) cycle
        end if
        do i=1,nSS
          iState = MapSt(i)
          do j=1,i
            jState = MapSt(j)
            i_ = max(jState,iState)
            j_ = min(jState,iState)
            if (IdxState(i_,j_) > 0) cycle
            f1 = (USOR(i,iSS)*USOR(j,jSS)+USOI(i,iSS)*USOI(j,jSS))**2+(USOR(i,iSS)*USOI(j,jSS)-USOI(i,iSS)*USOR(j,jSS))**2
            f2 = (USOR(j,iSS)*USOR(i,jSS)+USOI(j,iSS)*USOI(i,jSS))**2+(USOR(j,iSS)*USOI(i,jSS)-USOI(j,iSS)*USOR(i,jSS))**2
            ! this should be Thrs**2, but let's be looser with SO states
            if (max(f1,f2) >= Thrs) IdxState(i_,j_) = 2
          end do
        end do
      end do
    end do
  else
    do i=1,nState
      iState = IndexE(i)
      IdxState(iState,iState) = 1
      if (i > iEnd) cycle
      do j=max(i+1,jStart),nState
        if (j > jEnd) cycle
        jState = IndexE(j)
        i_ = max(jState,iState)
        j_ = min(jState,iState)
        IdxState(i_,j_) = 1
      end do
    end do
  end if

end subroutine UpdateIdx

!***********************************************************************
!  StoreDens
!
!> @brief
!>   Store the density matrices to HDF5
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Save the selected state and transition density matrices to the HDF5
!> file. The TDMs were computed in input state basis, but will be stored
!> in SF eigen states, so a transformation is needed.
!>
!> @param[in] EigVec  coefficients of the SF eigen states in the input state basis
!***********************************************************************
#ifdef _HDF5_
subroutine StoreDens(EigVec)

  use mh5, only: mh5_put_dset
  use rassi_aux, only: iDisk_TDM
  use rassi_global_arrays, only: JbNum
  use rassi_data, only: NTDMZZ
  use Cntrl, only: IFSO, IRREP, LuTDM
  use RASSIWfn, only: wfn_SFS_TDM, wfn_SFS_TSDM, wfn_SFS_WETDM
  use Constants, only: Zero

  real(kind=wp), intent(in) :: EigVec(nState,nState)
  integer(kind=iwp) :: iDisk, iEmpty, iGo, iOpt, iState, iSy12, iSym1, iSym2, Job1, Job2, jState, k, l, nThisTDMZZ
  logical(kind=iwp) :: isZero(3)
  real(kind=wp) :: f1, f2
  real(kind=wp), allocatable :: TDMIJ(:), TDMZZ(:), TSDMIJ(:), TSDMZZ(:), WDMIJ(:), WDMZZ(:)

  if (.not. allocated(IdxState)) return
  ! Transform TDMs to SF eigenstates
  call mma_Allocate(TDMZZ,nTDMZZ,Label='TDMZZ')
  call mma_Allocate(TSDMZZ,nTDMZZ,Label='TSDMZZ')
  call mma_Allocate(WDMZZ,nTDMZZ,Label='WDMZZ')
  call mma_Allocate(TDMIJ,nTDMZZ,Label='TDMIJ')
  call mma_Allocate(TSDMIJ,nTDMZZ,Label='TSDMIJ')
  call mma_Allocate(WDMIJ,nTDMZZ,Label='WDMIJ')
  do iState=1,nState
    do jState=1,iState
      if (IdxState(iState,jState) == 0) cycle
      TDMIJ(:) = Zero
      TSDMIJ(:) = Zero
      WDMIJ(:) = Zero
      isZero = [.true.,.true.,.true.]
      do k=1,nState
        Job1 = JbNum(k)
        iSym1 = Irrep(Job1)
        do l=1,k
          f1 = EigVec(k,iState)*EigVec(l,jState)
          f2 = EigVec(l,iState)*EigVec(k,jState)
          if (max(abs(f1),abs(f2)) < Thrs) cycle
          Job2 = JbNum(l)
          iSym2 = Irrep(Job2)
          iSy12 = Mul(iSym1,iSym2)
          iDisk = iDisk_TDM(k,l,1)
          iEmpty = iDisk_TDM(k,l,2)
          iOpt = 2
          iGo = ibset(ibset(0,0),1)
          if (IfSO) iGo = ibset(iGo,2)
          call dens2file(TDMZZ,TSDMZZ,WDMZZ,nTDMZZ,LuTDM,iDisk,iEmpty,iOpt,iGo,k,l)
          if (btest(iEmpty,0)) then
            isZero(1) = .false.
            if (abs(f1) >= Thrs) TDMIJ(:) = TDMIJ(:)+f1*TDMZZ(:)
            if ((k /= l) .and. (abs(f2) >= Thrs)) then
              call Transpose_TDM(TDMZZ,iSy12)
              TDMIJ(:) = TDMIJ(:)+f2*TDMZZ(:)
            end if
          end if
          if (btest(iEmpty,1)) then
            isZero(2) = .false.
            if (abs(f1) >= Thrs) TSDMIJ(:) = TSDMIJ(:)+f1*TSDMZZ(:)
            if ((k /= l) .and. (abs(f2) >= Thrs)) then
              call Transpose_TDM(TSDMZZ,iSy12)
              TSDMIJ(:) = TSDMIJ(:)+f2*TSDMZZ(:)
            end if
          end if
          if (IFSO .and. btest(iEmpty,2)) then
            isZero(3) = .false.
            if (abs(f1) >= Thrs) WDMIJ(:) = WDMIJ(:)+f1*WDMZZ(:)
            if ((k /= l) .and. (abs(f2) >= Thrs)) then
              call Transpose_TDM(WDMZZ,iSy12)
              WDMIJ(:) = WDMIJ(:)+f2*WDMZZ(:)
            end if
          end if
        end do
      end do
      if (all(isZero)) cycle
      nThisTDMZZ = 0
      do iSym1=1,nIrrep
        iSym2 = Mul(iSy12,iSym1)
        nThisTDMZZ = nThisTDMZZ+NBASF(iSym1)*NBASF(iSym2)
      end do
      if (.not. isZero(1)) call mh5_put_dset(wfn_sfs_tdm,TDMIJ,[nThisTDMZZ,1,1],[0,iState-1,jState-1])
      if (.not. isZero(2)) call mh5_put_dset(wfn_sfs_tsdm,TSDMIJ,[nThisTDMZZ,1,1],[0,iState-1,jState-1])
      if (IFSO .and. (.not. isZero(3))) call mh5_put_dset(wfn_sfs_wetdm,WDMIJ,[nThisTDMZZ,1,1],[0,iState-1,jState-1])
    end do
  end do
  call mma_deAllocate(IdxState)
  call mma_deAllocate(TDMZZ)
  call mma_deAllocate(TSDMZZ)
  call mma_deAllocate(WDMZZ)
  call mma_deAllocate(TDMIJ)
  call mma_deAllocate(TSDMIJ)
  call mma_deAllocate(WDMIJ)

end subroutine StoreDens

!***********************************************************************
!  Transpose_TDM
!
!> @brief
!>   Transpose a transition density matrix in place.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Transpose a transition density matrix, stored in symmetry blocks,
!> replacing the original matrix. The matrices contain only the symmetry
!> blocks that match the total symmetry of the transition.
!>
!> @param[in,out] TDM       Transition density matrix
!> @param[in]     Symmetry  Symmetry of the transition
!***********************************************************************
subroutine Transpose_TDM(TDM,Symmetry)

  real(kind=wp), intent(inout) :: TDM(*)
  integer(kind=iwp), intent(in) :: Symmetry
  integer(kind=iwp) :: i, iBlock(0:8), iSym1, iSym2, j, nTot
  real(kind=wp), allocatable :: Tmp(:)

  ! Compute the location of all the stored symmetry blocks
  nTot = 0
  iBlock(0) = 0
  do iSym1=1,nIrrep
    iSym2 = Mul(Symmetry,iSym1)
    nTot = nTot+nBasF(iSym1)*nBasF(iSym2)
    iBlock(iSym1) = nTot
  end do
  ! Make a copy so we can transpose in place
  call mma_Allocate(Tmp,nTot,Label='Tmp')
  Tmp(:) = TDM(1:nTot)
  ! Transpose symmetry block (a,b) onto symmetry block (b,a)
  do iSym1=1,nIrrep
    iSym2 = Mul(Symmetry,iSym1)
    do i=1,nBasF(iSym2)
      do j=1,nBasF(iSym1)
        TDM(iBlock(iSym2-1)+(j-1)*nBasF(iSym2)+i) = Tmp(iBlock(iSym1-1)+(i-1)*nBasF(iSym1)+j)
      end do
    end do
  end do
  call mma_deAllocate(Tmp)

end subroutine Transpose_TDM
#endif

end module Dens2HDF5

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine o3v3chol(wrk,wrksize,NvGrp,maxdim,LunAux)
! This routine does:
!
! --- Part II - generation of Q3,K3,Gvv,Goo,T26-9 in X form
!
! T(be,u)      <<-
! T162 - sum(b,i)   [ (iu|be,b) . t(b,i) ]
! T17  + sum(a,b,i) [ 2(a,i|b,be) - (b,i|a,be) ] . Ta(a,b,i,u)
!    = + sum(a,b,i)  (a,i|b,be) . [ 2 Ta(a,b,i,u) - Ta(a,b,u,i) ]
!
! N.B. T17 implementede in expression:
! T(a,u)      <<-
! T17  + sum(be,b,i)  (b,i|be,a) . [ 2 Ta(b,be,i,u) - Ta(b,be,u,i) ]
!
! Q(be,u,i,a) <-
!        Q3     +   [ 2(b,be|a,i) - (b,i|a,be) ] . t(b,u )
!
! K(be,u,i,a) <-
!        K3     +   [  (b,i |a,be)             ] . t(b ,u)
!
! Gvv(be,a)    <-
! Gvv1  +           [ Hvv(a,be) ]
! Gvv2  - sum(i)    [ Fvo(a,i) . t1(be,i) ]
! Gvv3  + sum(b,i)  [ -(b,be|a,i) +2(b,i|a,be) ] . t(b,i )
!
! Goo(i,u) <-
! Goo1  +  <-       [ Hoo(i,u) ]
! Goo2  + sum(a)    [ Fvo(a,i) . t1(a,u) ]
! Goo3  + sum(a,j)  [ (2(aj|iu) - (ai|ju)) . t1(a,j) ]
!
! terms Goo2,3 implemented as:
! Goo2  + sum(be)   [ Fvo(be,i) . t1(be,u) ]
! Goo3  + sum(be,j) [ (2(be,j|iu) - (be,i|ju)) . t1(be,j) ]
!
! T2(be,ga,u,v) <<-
! T26  + sum(a)     [ (be,u|ga,a) . t1(a,v)         ]
! T27  - sum(a,i)   [ (iu|ga,a) . t1(be,i) . t1(a,v)]
! T28  - sum(i)     [ (be,u|iv)          . t1(ga,i) ]
! T29  - sum(a,i)   [ (be,u|ia). t1(a,v) . t1(ga,i) ]
!
! N.B. T26-T29 implementede in expression:
! T2(a,be,u,v)  <-
! T26  + sum(b)     [           (u,a|be,b) . t1(b,v)  ]
! T27  - sum(b,j)   [ t1(a,j) . (u,j|be,b) . t1(b,v)  ]
! T28  - sum(j)     [           (u,a|j,v)  . t1(be,j) ]
! T29  - sum(b,j)   [ t1(b,v) . (u,a|j,b)  . t1(be,j) ]
! T2(a,be,u,v) is stored as X(a,u,be,v) in Tmp2Name(a,be)
!
! N.B. Process V3(j,v,u,a') <- V1(m,j,v) . L1(T)(m,u,a') run
! for Na*Nbe times, ie. Nbe . o3mv competee with Nbe . I+O (o3v)
!
! Extra cost - multiple reading:
!              1) N_be . T;
!              2) N_ga . Q
!              3) N_ga . K
!
!1 intermediates Q and K will be temporarily stored in files
!  Tmp1Name(be,a)
!  do beGrp
!    do aGrp
!      Q(K) (be',u,i,a')
!    end do
!  end do
!
!2 Structure of files, where selected group of (pq|rs) are
!  stored (V'O|OO) - I1 ; (V'O|V'O) - I2 ; (V'V'|OO) - I3
!
!  (A'I|JK)  I1inxx xx - Group of A'
!
!  (A'I|B'J) I2xxyy xx - Group of A'
!                   yy - Group of B'
!
!  (A'B'|IJ) I3xxyy xx - Group of A'
!                   yy - Group of B'
!
!3 Structure of Cholesky vector files
!
!  L1(m,I ,A')  L1vcxx xx - Group of A'
!
!  L2(m,A',B')  L2xxyy xx - Group of A'
!                      yy - Group of B'
!
!4 Structure of Amplitude file
!  t2(A',B',IJ)  T2xxyy xx - Group of A'
!                       yy - Group of B'

use Index_Functions, only: nTri_Elem
use chcc_global, only: BeAID, BetaID, DimGrpv, I1Name, L0Name, L1Name, L2Name, nc, no, nv, PosFree, PosFvo, PosGoo, PosGvv, &
                       PosHoo, PosHvv, PosT1n, PosT1o, printkey, T2Name, TCpu, TCpu_l, Tmp1Name, Tmp2Name, TWall, TWall_l, TWall0, &
                       Xyes
use Para_Info, only: MyRank
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, NvGrp, maxdim, LunAux
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: adda, addb, addbe, aGrp, beGrp, bGrp, dim_1, dim_2, dima, dimb, dimbe, PosH1, PosH2, PosH3, PosH4, PosK, &
                     PosM1, PosM2, PosM3, PosM4, PosM5, PosQ, PosT, PosV1, PosV2, PosV3, PosV4
character(len=6) :: LunName

! --- introduction part ---

! Distribute memory
! @@ vyladit distmem, mozno netreba vsetko, toto je len prefackany
!   DistMemo3v3

PosT = PosFree
if (printkey >= 10) write(u6,*) 'PosFree',PosFree,NvGrp,maxdim
call DistMemo3v3chol(maxdim,PosV1,PosV2,PosV3,PosV4,PosH1,PosH2,PosH3,PosH4,PosM1,PosM2,PosM3,PosM4,PosM5,PosK,PosQ,PosT)

if (printkey >= 10) write(u6,*) ' Last Value :',PosT,wrksize
if (PosT > wrksize) then
  !mp write(u6,*) ' Nieje dobre, Dr. Ch.  Kokotopuloss',
  write(u6,*) ' Not Enough memory in o3v3chol step! Increase large and/or small segmentation ', &
              real(PosT,kind=wp)/real(wrksize,kind=wp)
  call abend()
end if

!@@
!call Chck_mkJ()
!call Chck_mkK()
!@@

! read V1(m,ij) <- L1(m,ij)
LunName = L0Name
dim_1 = nc*nTri_Elem(no)
call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

! Expand M4(m,i,j) <- V1(m,ij)
dim_1 = nTri_Elem(no)
call Exp1(wrk(PosV1),wrk(PosM4),nc,dim_1,no)

!G Vanish Gvv,Goo
dim_1 = nv*nv
wrk(PosGvv:PosGvv+dim_1-1) = Zero
dim_1 = no*no
wrk(PosGoo:PosGoo+dim_1-1) = Zero

!##G Vanish Xyes

Xyes(1:NvGrp,1:NvGrp) = 0

addbe = 0

do beGrp=1,NvGrp
  dimbe = DimGrpv(beGrp)

  !## test, if this beGrp is planed to be run on this node
  dim_1 = sum(BeAID(myRank,beGrp,1:NvGrp))
  dim_1 = dim_1+BetaID(myRank,beGrp)
  if (dim_1 /= 0) then
    if (printkey > 1) then
      write(u6,*) ' Chol PID, beGrp',myRank,beGrp
      !mp
      call CWTime(TCpu,TWall)
      write(u6,*)
      write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
      write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
      write(u6,*)
      write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
      write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
      write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
      write(u6,*)
    end if
    TCpu_l = TCpu
    TWall_l = TWall
    !mp

    ! Extract H1(be',I) <- T1(be,I)
    call ExtT1(wrk(PosH1),wrk(PosT1o),dimbe,addbe)

    ! vanish M1(m,i,u),M2(m,be',u),M3(m,be',u)
    dim_1 = nc*no*no
    wrk(PosM1:PosM1+dim_1-1) = Zero
    dim_1 = nc*no*dimbe
    wrk(PosM2:PosM2+dim_1-1) = Zero
    wrk(PosM3:PosM3+dim_1-1) = Zero

    !T1G vanish H4(be',u)
    dim_1 = dimbe*no
    wrk(PosH4:PosH4+dim_1-1) = Zero

    if (BetaID(myRank,beGrp) == 1) then
      !## contributions Goo2,3  must be taken only once per Beta'

      !Goo2.1 Extract H2(be',i) <- Fvo(be,i) (vlastnu rutinu netreba)
      call ExtT1(wrk(PosH2),wrk(PosFvo),dimbe,addbe)

      !Goo2.2f Goo(i,u) <<- H2(T)(be',i) . H1(be',u)
      call mc0c1at3b(dimbe,no,dimbe,no,no,no,no,dimbe,no,wrk(PosH2),wrk(PosH1),wrk(PosGoo))

      !Goo3.1 read V1(be',I,JK) <- I1(be',I,JK)
      dim_1 = dimbe*no*nTri_Elem(no)
      LunName = I1Name(beGrp)
      call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

      !Goo3.2 Make V2(be',j,i,u) <- 2 V1(be',j|iu) - V1(be',i|ju)
      call MkV_Goo3(wrk(PosV1),wrk(PosV2),dimbe,no)

      !Goo3.3f Goo(i,u) <<- V2(T)(be',j,i,u) . H1(be,j)
      dim_1 = dimbe*no
      !@x dorobit rutinu  mv0v1at3u
      !call mv0v1at3u (dim_1,no*no,dim_1,no*no,no*no,dim_1,1,1,wrk(PosV2),wrk(PosH1),wrk(PosGoo))

      ! zatial odflaknute takto
      call mc0c1at3b(dim_1,no*no,dim_1,1,no*no,1,no*no,dim_1,1,wrk(PosV2),wrk(PosH1),wrk(PosGoo))

      !@x
    end if

    addb = 0

    do bGrp=1,NvGrp
      dimb = DimGrpv(bGrp)

      !G Extract H2(b',I) <- T1(b,I)
      call ExtT1(wrk(PosH2),wrk(PosT1o),dimb,addb)

      !QK3.1 read V3(m,i,b') <- L1(m,i,b')
      LunName = L1Name(bGrp)
      dim_1 = nc*no*dimb
      call GetX(wrk(PosV3),dim_1,LunAux,LunName,1,1)

      !QK3.3 M1(m,i,u)   <<-  V3(m,i  ,b') . H2(b',u)
      call mc0c1a3b(nc*no,dimb,dimb,no,nc*no,no,nc*no,dimb,no,wrk(PosV3),wrk(PosH2),wrk(PosM1))

      !Q3.4 read V1(m,be',b')<- [V2(m,beb') or V2(m,b'be)]<- L2(m,be',b')
      !     in cases be <= b through interstep V2
      if (beGrp > bGrp) then
        LunName = L2Name(beGrp,bGrp)
        dim_1 = nc*dimb*dimbe
        call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
      else if (beGrp == bGrp) then
        LunName = L2Name(beGrp,bGrp)
        dim_1 = nc*dimb*(dimbe+1)/2
        call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
        dim_1 = dimb*(dimbe+1)/2
        call Exp1(wrk(PosV2),wrk(PosV1),nc,dim_1,dimb)
      else
        LunName = L2Name(bGrp,beGrp)
        dim_1 = nc*dimb*dimbe
        call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
        call Map3_132(wrk(PosV2),wrk(PosV1),nc,dimb,dimbe)
      end if

      !Q3.5 M2(m,be',u) <<-  V1(m,be',b') . H2(b',u)
      call mc0c1a3b(nc*dimbe,dimb,dimb,no,nc*dimbe,no,nc*dimbe,dimb,no,wrk(PosV1),wrk(PosH2),wrk(PosM2))

      ! read V2(be'b',I,J) <- T2(be',b,I,J)
      LunName = T2Name(beGrp,bGrp)
      if (bGrp == beGrp) then
        dim_1 = nTri_Elem(dimbe)*no*no
        call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
        ! Expand V2(be',b',I,J) <- V1(be'b',I,J)
        dim_1 = nTri_Elem(dimb)
        call ExpT2(wrk(posV1),wrk(PosV2),dimbe,dim_1,no)
      else
        dim_1 = dimbe*dimb*no*no
        call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
      end if

      ! Make Tau(be',b',I,J) in V2(be',b',I,J)
      call MkTau_chcc(wrk(PosV2),wrk(PosH1),wrk(PosH2),dimbe,dimb,no,One,One)

      ! Make V1(i,b',be',u) <- 2 V2(be',b',u,i) - V2(be',b',i,u)
      call MkT_T17(wrk(PosV1),wrk(PosV2),dimb,dimbe,no)

      ! M3(m,be',u) <<- V3(m,i,b') . V1(i,b',be',u)
      dim_1 = dimb*no
      dim_2 = dimbe*no
      call mc0c1a3b(nc,dim_1,dim_1,dim_2,nc,dim_2,nc,dim_1,dim_2,wrk(PosV3),wrk(PosV1),wrk(PosM3))

      addb = addb+dimb
    end do

    if (BetaID(myRank,beGrp) == 1) then
      !## contribution T16  must be taken only once per Beta'

      ! Map V1(be',m,i) <- M2(m,be',i)
      call Map3_213(wrk(PosM2),wrk(PosV1),nc,dimbe,no)

      !T162.f H4(be',u) <<- - V1(be',m,i) . M4(m,i,u)
      call mc0c2a3b(dimbe,nc*no,nc*no,no,dimbe,no,dimbe,nc*no,no,wrk(PosV1),wrk(PosM4),wrk(PosH4))

    end if

    !T27.1 V4(be',v,u,j ) <- M2(T)(m,be',v) . M4(m,u,j)
    dim_1 = dimbe*no*no*no
    wrk(PosV4:PosV4+dim_1-1) = Zero
    call mc0c1at3b(nc,dimbe*no,nc,no*no,dimbe*no,no*no,dimbe*no,nc,no*no,wrk(PosM2),wrk(PosM4),wrk(PosV4))

    adda = 0

    do aGrp=1,NvGrp
      dima = DimGrpv(aGrp)

      ! Test, if this Be' A' combination is to be run on this node
      if (BeAID(myRank,beGrp,aGrp) /= 0) then
        if (printkey >= 10) write(u6,*) ' Chol PID, be,a',myRank,beGrp,aGrp

        ! Extract H2(a',I) <- T1(a,I)
        call ExtT1(wrk(PosH2),wrk(PosT1o),dima,adda)

        ! read Q(be',u,i,a'),K(be',u,i,a')
        LunName = Tmp1Name(beGrp,aGrp)
        dim_1 = dimbe*dima*no*no
        call GetX(wrk(PosQ),dim_1,LunAux,LunName,1,0)
        call GetX(wrk(PosK),dim_1,LunAux,LunName,0,1)

        ! read V1(m,be',a')<- [V2(m,bea') or V2(m,a',be')] <- L2(m,be',a')
        ! in cases be <= b through interstep V2
        if (beGrp > aGrp) then
          LunName = L2Name(beGrp,aGrp)
          dim_1 = nc*dima*dimbe
          call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
        else if (beGrp == aGrp) then
          LunName = L2Name(beGrp,aGrp)
          dim_1 = nc*dima*(dimbe+1)/2
          call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
          dim_1 = dima*(dimbe+1)/2
          call Exp1(wrk(PosV2),wrk(PosV1),nc,dim_1,dimbe)
        else
          LunName = L2Name(aGrp,beGrp)
          dim_1 = nc*dima*dimbe
          call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
          call Map3_132(wrk(PosV2),wrk(PosV1),nc,dima,dimbe)
        end if

        ! V3(a',u) <- V1(T)(m,be',a')(L2) . M3(m,be',u)
        wrk(PosV3:PosV3+dima*no-1) = Zero
        call mc0c1at3b(nc*dimbe,dima,nc*dimbe,no,dima,no,dima,nc*dimbe,no,wrk(PosV1),wrk(PosM3),wrk(PosV3))

        !T17.f Add T1n(a',u) <<- V3(a',u)
        call AdT_T17(wrk(PosT1n),wrk(PosV3),nv,dima,no,adda,One)

        ! V3(be',a',i,u) <-  V1(m,be',a')(L2) . M1(m,i,u)
        dim_1 = dima*dimbe*no*no
        wrk(PosV3:PosV3+dim_1-1) = Zero
        call mc0c1at3b(nc,dimbe*dima,nc,no*no,dimbe*dima,no*no,dima*dimbe,nc,no*no,wrk(PosV1),wrk(PosM1),wrk(PosV3))

        ! map V2(be',u,i,a') <-  V3(be',a',i,u)
        call Map4_1432(wrk(PosV3),wrk(PosV2),dimbe,dima,no,no)

        ! Q(be',u,i,a')  <<- -V2(be',u,i,a')
        wrk(PosQ:PosQ+dim_1-1) = wrk(PosQ:PosQ+dim_1-1)-wrk(PosV2:PosV2+dim_1-1)

        ! Gvv(be',a') <<- 2 sum(i) [V2(be',i,i,a')
        call AdV_G2(wrk(PosGvv),wrk(PosV2),nv,dimbe,dima,no,addbe,adda,Two)

        ! K(be',u,i,a')  <<-  V2(be',u,i,a')
        wrk(PosK:PosK+dim_1-1) = wrk(PosK:PosK+dim_1-1)+wrk(PosV2:PosV2+dim_1-1)

        ! read M5(m,i,a') <- L1(m,i,a')
        LunName = L1Name(aGrp)
        dim_1 = dima*nc*no
        call GetX(wrk(PosM5),dim_1,LunAux,LunName,1,1)

        ! V2(be',u,i,a') <-  M2(m,be',u ) . M5(m,i,a')(L1)
        dim_1 = dima*dimbe*no*no
        wrk(PosV2:PosV2+dim_1-1) = Zero
        call mc0c1at3b(nc,dimbe*no,nc,no*dima,dimbe*no,dima*no,dimbe*no,nc,dima*no,wrk(PosM2),wrk(PosM5),wrk(PosV2))

        ! Q(be',u,i,a') <<- 2 V2(be',u,i,a')
        wrk(PosQ:PosQ+dim_1-1) = wrk(PosQ:PosQ+dim_1-1)+Two*wrk(PosV2:PosV2+dim_1-1)

        ! write Q and K submatrix to corresponding files
        LunName = Tmp1Name(beGrp,aGrp)
        dim_1 = dimbe*dima*no*no
        call SaveX(wrk(PosQ),dim_1,LunAux,LunName,1,0)
        call SaveX(wrk(PosK),dim_1,LunAux,LunName,0,1)
        !@@
        !call Chck_K(wrk(PosK),dimbe,addbe,dima,adda)
        !call Chck_Q(wrk(PosQ),dimbe,addbe,dima,adda)
        !@@

        ! Gvv(be',a') <<- - sum(i) [V2(be,i,i,a')
        call AdV_G2(wrk(PosGvv),wrk(PosV2),nv,dimbe,dima,no,addbe,adda,-One)

        ! Q array (already released) will be served for X

        !T26.1f Map Q(a',U,be',V) <-  2 . V2(be',V,U,a')
        !       i.e. here a' is a first index, that means X (Q) is saved
        !       in different order as K,Q
        call Map4_3421(wrk(PosV2),wrk(PosQ),dimbe,no,no,dima)
        dim_1 = dima*no*no*dimbe
        wrk(PosQ:PosQ+dim_1-1) = Two*wrk(PosQ:PosQ+dim_1-1)

        !T27.2 Map H3(j,a') <- H2(a',j)(T1)
        call Map2_21(wrk(PosH2),wrk(PosH3),dima,no)

        !T27.3f V2(be',v,u,a') <- - V4(be',v,u,j) . H3(j,a')
        dim_1 = dimbe*no*no*dima
        wrk(PosV2:PosV2+dim_1-1) = Zero
        dim_1 = dimbe*no*no
        call mc0c2a3b(dim_1,no,no,dima,dim_1,dima,dim_1,no,dima,wrk(PosV4),wrk(PosH3),wrk(PosV2))

        !T289.1 V1(m,j,v) <- M4(m,j,v) (L1)
        dim_1 = nc*no*no
        wrk(PosV1:PosV1+dim_1-1) = wrk(PosM4:PosM4+dim_1-1)

        !T289.2 V1(m,j,v) <<- M1(m,j,v)
        dim_1 = nc*no*no
        wrk(PosV1:PosV1+dim_1-1) = wrk(PosV1:PosV1+dim_1-1)+wrk(PosM1:PosM1+dim_1-1)

        !T289.3 V3(j,v,u,a') <- V1(T) (m,j,v) . M5(m,u,a')(L1)
        dim_1 = no*no*no*dima
        wrk(PosV3:PosV3+dim_1-1) = Zero
        call mc0c1at3b(nc,no*no,nc,no*dima,no*no,no*dima,no*no,nc,no*dima,wrk(PosV1),wrk(PosM5),wrk(PosV3))

        !T289.4f V2(be',v,u,a') <<- - H1(be',j)(T1) . V3(j,v,u,a')
        dim_1 = no*no*dima
        call mc0c2a3b(dimbe,no,no,dim_1,dimbe,dim_1,dimbe,no,dim_1,wrk(PosH1),wrk(PosV3),wrk(PosV2))

        !T2G Map V1(a',U,be',V) <- V2(be',V,U,a')
        call Map4_3421(wrk(PosV2),wrk(PosV1),dimbe,no,no,dima)

        !T2G Add Q(a',u,be',v)(X) <<- V1(a',U,be',V) (Faktor 2 koli X)
        dim_1 = dimbe*dima*no*no
        wrk(PosQ:PosQ+dim_1-1) = wrk(PosQ:PosQ+dim_1-1)+Two*wrk(PosV1:PosV1+dim_1-1)

        !T2G write X(a',u,be',v) = Q(a',u,be',v)
        LunName = Tmp2Name(aGrp,beGrp)
        dim_1 = dimbe*dima*no*no
        Xyes(aGrp,beGrp) = 1
        call SaveX(wrk(PosQ),dim_1,LunAux,LunName,1,1)

      end if
      adda = adda+dima
    end do

    !T1G Add T1n(be,u) <<- H4(be',u)
    call AdT_T17(wrk(PosT1n),wrk(PosH4),nv,dimbe,no,addbe,One)

  end if
  addbe = addbe+dimbe
end do

#ifdef _MOLCAS_MPP_
!## Synchronizacny bod:
! Allreduce Goo,Gvv
dim_1 = no*no
call gadgop(wrk(PosGoo),dim_1,'+')
dim_1 = nv*nv
call gadgop(wrk(PosGvv),dim_1,'+')
#endif

!Goo1.1f Add Goo(i,u) <<- Hoo(i,u)
dim_1 = no*no
wrk(PosGoo:PosGoo+dim_1-1) = wrk(PosGoo:PosGoo+dim_1-1)+wrk(PosHoo:PosHoo+dim_1-1)

!Gvv1.1 Map V1(be,a) <- Hvv(a,be)
call Map2_21(wrk(PosHvv),wrk(PosV1),nv,nv)

!Gvv1.2f Add Gvv(be,a) <<- V1(be,a)
dim_1 = nv*nv
wrk(PosGvv:PosGvv+dim_1-1) = wrk(PosGvv:PosGvv+dim_1-1)+wrk(PosV1:PosV1+dim_1-1)

!Gvv2.1 Map V2(i,a) <- Fvo(a,i)
call Map2_21(wrk(PosFvo),wrk(PosV2),nv,no)

!Gvv2.2 Calc V1(be,a) <- t1(be,i) . V2(i,a)
dim_1 = nv*nv
wrk(PosV1:PosV1+dim_1-1) = Zero
call mc0c1a3b(nv,no,no,nv,nv,nv,nv,no,nv,wrk(PosT1o),wrk(PosV2),wrk(PosV1))

!Gvv2.3f Add Gvv(be,a) <<- - V1(be,a)
dim_1 = nv*nv
wrk(PosGvv:PosGvv+dim_1-1) = wrk(PosGvv:PosGvv+dim_1-1)-wrk(PosV1:PosV1+dim_1-1)

!@@
!call Chck_Goo(wrk(PosGoo))
!call Chck_Gvv(wrk(PosGvv))
!@@

return

end subroutine o3v3chol

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This program generates generally contracted basis sets from multiple *
! atomic densities. The densities are averaged with weights and the    *
! resulting eigenvectors, Natural Orbitals (NO), are used as basis     *
! functions where the corresponding eigenvalues, occupation numbers,   *
! are used as measure of importance.                                   *
! It is also possible to project out the contributions of vectors      *
! from the averaged density before generating the NO's.                *
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine GenAno(ireturn)

use Genano_globals, only: isUHF, iProj, nSets
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: i

call MkType()
call InpCtl_GenANO()
do i=1,nSets
  call RdCmo()
  call UpDens()
  if (isUHF == 1) then
    call RdCmo()
    call UpDens()
    isUHF = 0
  end if
end do
call SphAve()
if (iProj == 1) call Proj1()
if (iProj == 2) call Proj2()
call MkAno()
call Free_GenANO()

ireturn = 0

return

end subroutine GenAno

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkcipre()

use Index_Functions, only: iTri
use MCLR_Data, only: ERAS, P1, P1Inv, SS
use input_mclr, only: ERASSCF, lRoots
use stdalloc, only: mma_allocate
use Constants, only: Zero, One
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, j

call mma_allocate(SS,2*lroots,2*lroots,Label='SS')
SS(:,:) = Zero
do I=1,lroots
  do J=1,lroots
    SS(2*i-1,2*j-1) = P1(iTri(i,j))
  end do
end do
do I=1,lroots
  SS(2*i-1,2*i-1) = SS(2*i-1,2*i-1)+ERAS(I)-ERASSCF(1)
  SS(2*i,2*i-1) = -One
  SS(2*i-1,2*i) = -One
end do
SS(2*lroots-1,2*lroots-1) = SS(2*lroots-1,2*lroots-1)+One
call MatInvert(SS,2*lroots)
do I=1,lroots
  do J=1,lroots
    SS(2*i-1,2*j-1) = SS(2*i-1,2*j-1)+P1INV(itri(i,j))
    SS(2*i,2*j) = SS(2*i,2*j)+P1(iTri(i,j))
  end do
end do
do I=1,lroots
  SS(2*i,2*i-1) = SS(2*i,2*i-1)+One
  SS(2*i-1,2*i) = SS(2*i-1,2*i)+One
end do
call MatInvert(SS,2*lroots)
SS(:,:) = -SS(:,:)
SS(2*lroots,2*lroots) = SS(2*lroots,2*lroots)-One

end subroutine mkcipre

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  Polins
*
*> @brief
*>   Add the field from the QM-region onto the solvent.
*>   Include the field from the polarizabilities in the solvent onto the QM-region.
*>   (The effect of the static field is taken care of in helstate.f)
*> @author A. Ohrn
*>
*> @details
*> First we compute the field from the QM-region onto the solvent. The
*> central quantity is the density matrix, which gives us how the
*> QM-region polarizes. The reaction field due to the QM-region is also
*> accounted for. Then we allow the polarized field from the solvent
*> to interact with the QM-region. The static field from the solvent,
*> in other word that from the charges, is already coupled in
*> ::helstate.
*>
*> @param[out]    Energy  The energy of the electrostatic interaction
*> @param[in,out] iCall   An integer that tells if this is the first call in the iteration.
*>                        Necessary for the copy of the one-particle Hamiltonian
*> @param[in]     iAtom2  Number of particles in the solvent, times number of polarizabilities per solvent molecule
*> @param[in]     iCi     Number of centers in QM-molecule
*> @param[in]     iFil    Pointer to the static field from the solvent
*> @param[out]    VpolMat The polarization matrix
*> @param[in,out] fil     The field from the induced dipoles in the solvent
*> @param[in]     polfac  A factor for the computation of the image
*> @param[out]    poli    The solvent polarized field on QM
*> @param[in]     xyzmyq  Total dipole of QM-region
*> @param[in]     xyzmyi  Total induced dipole of solvent
*> @param[in]     xyzmyp  Total permanent dipole of solvent
*> @param[in]     qtot    Total charge of QM-region
*> @param[in]     iCstart Number to keep track of solvent molecules
************************************************************************
      Subroutine Polins(Energy,iCall,iAtom2,iCi,iFil,VpolMat,fil,polfac
     &     ,poli,xyzmyq,xyzmyi,xyzmyp,iCstart,iQ_Atoms,qtot,ChaNuc
     &     ,RoMatSt,xyzQuQ,CT)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qm2.fh"
#include "WrkSpc.fh"

      Dimension Fil(npart*npol,3),Qm(MxQCen),Dm(MxQCen,3),QQm(MxQCen,6)
     &,Poli(MxQCen,10),Gunnar(10),ChaNuc(MxAt)
     &,Eil(MxPut*MxPol,3),xyzMyC(3),CofC(3),xyzmyq(3),xyzmyi(3)
     &,xyzmyp(3),VpolMat(MxStOt),RoMatSt(MxStOT)
      Dimension xyzQuQ(6),qQ(6),qD(6),qK(6),CT(3)
      Dimension iFil(MxQCen,10)

*----------------------------------------------------------------------*
* Begin with some zeros.                                               *
*----------------------------------------------------------------------*
      iCnum=iCStart/Ncent
      Do 2, i=1,iCi
        Qm(i)=0
        If(i.le.iQ_Atoms) Qm(i)=-ChaNuc(i)
        Do 3, j=1,3
          Dm(i,j)=0
          QQm(i,j)=0
          QQm(i,j+3)=0
3       Continue
2     Continue
      Do 6644, i=1,MxPut*MxPol
        Do 6645, j=1,3
          Eil(i,j)=0
6645    Continue
6644  Continue
*----------------------------------------------------------------------*
* Below we compute how the MME of the QM-molecule changes with the new *
* density matrix Romat. In this step we connect a state density with   *
* various multipoles, which will go on and interact with the solvent.  *
* This is one of the pivotal steps in coupling the QM-region with the  *
* classical region.                                                    *
*----------------------------------------------------------------------*
      kaunt=0
      Do 14, i=1,nState
        Do 15, j=1,i
          kaunt=kaunt+1
          Do 41, k=1,iCi
            Qm(k)=Qm(k)+RasCha(kaunt,k)*RomatSt(kaunt)
            Dm(k,1)=Dm(k,1)+RasDip(kaunt,1,k)*RomatSt(kaunt)
            Dm(k,2)=Dm(k,2)+RasDip(kaunt,2,k)*RomatSt(kaunt)
            Dm(k,3)=Dm(k,3)+RasDip(kaunt,3,k)*RomatSt(kaunt)
            QQm(k,1)=QQm(k,1)+RasQua(kaunt,1,k)*RomatSt(kaunt)
            QQm(k,3)=QQm(k,3)+RasQua(kaunt,3,k)*RomatSt(kaunt)
            QQm(k,6)=QQm(k,6)+RasQua(kaunt,6,k)*RomatSt(kaunt)
            QQm(k,2)=QQm(k,2)+RasQua(kaunt,2,k)*RomatSt(kaunt)
            QQm(k,4)=QQm(k,4)+RasQua(kaunt,4,k)*RomatSt(kaunt)
            QQm(k,5)=QQm(k,5)+RasQua(kaunt,5,k)*RomatSt(kaunt)
41        Continue
15      Continue
14    Continue
      Do 775, kk=1,3
        xyzMyQ(kk)=0
        xyzMyC(kk)=0
        CofC(kk)=0
775   Continue
      Do 776, kk=1,6
        xyzQuQ(kk)=0
        qQ(kk)=0
        qD(kk)=0
        qK(kk)=0
776   Continue
      Do 866,i=1,iCi
        Do 8661, kk=1,3
          xyzMyQ(kk)=xyzMyQ(kk)+Dm(i,kk)+Qm(i)*outxyzRAS(i,kk)
8661    Continue
        qQ(1)=qQ(1)+Qm(i)*(outxyzRAS(i,1)-CT(1))*(outxyzRAS(i,1)-CT(1))
        qQ(2)=qQ(2)+Qm(i)*(outxyzRAS(i,1)-CT(1))*(outxyzRAS(i,2)-CT(2))
        qQ(3)=qQ(3)+Qm(i)*(outxyzRAS(i,1)-CT(1))*(outxyzRAS(i,3)-CT(3))
        qQ(4)=qQ(4)+Qm(i)*(outxyzRAS(i,2)-CT(2))*(outxyzRAS(i,2)-CT(2))
        qQ(5)=qQ(5)+Qm(i)*(outxyzRAS(i,2)-CT(2))*(outxyzRAS(i,3)-CT(3))
        qQ(6)=qQ(6)+Qm(i)*(outxyzRAS(i,3)-CT(3))*(outxyzRAS(i,3)-CT(3))
        qD(1)=qD(1)+2*Dm(i,1)*(outxyzRAS(i,1)-CT(1))
        qD(2)=qD(2)+Dm(i,1)*(outxyzRAS(i,2)-CT(2))
     &             +Dm(i,2)*(outxyzRAS(i,1)-CT(1))
        qD(3)=qD(3)+Dm(i,1)*(outxyzRAS(i,3)-CT(3))
     &             +Dm(i,3)*(outxyzRAS(i,1)-CT(1))
        qD(4)=qD(4)+2*Dm(i,2)*(outxyzRAS(i,2)-CT(2))
        qD(5)=qD(5)+Dm(i,2)*(outxyzRAS(i,3)-CT(3))
     &             +Dm(i,3)*(outxyzRAS(i,2)-CT(2))
        qD(6)=qD(6)+2*Dm(i,3)*(outxyzRAS(i,3)-CT(3))
        qK(1)=qK(1)+QQm(i,1)
        qK(2)=qK(2)+QQm(i,2)
        qK(3)=qK(3)+QQm(i,4)
        qK(4)=qK(4)+QQm(i,3)
        qK(5)=qK(5)+QQm(i,5)
        qK(6)=qK(6)+QQm(i,6)
866   Continue
      Trace1=qQ(1)+qQ(4)+qQ(6)
      Trace2=qD(1)+qD(4)+qD(6)
      Trace1=Trace1/3
      Trace2=Trace2/3
      xyzQuQ(1)=1.5*(qQ(1)+qD(1)-Trace1-Trace2)+qK(1)
      xyzQuQ(2)=1.5*(qQ(2)+qD(2))+qK(2)
      xyzQuQ(3)=1.5*(qQ(3)+qD(3))+qK(3)
      xyzQuQ(4)=1.5*(qQ(4)+qD(4)-Trace1-Trace2)+qK(4)
      xyzQuQ(5)=1.5*(qQ(5)+qD(5))+qK(5)
      xyzQuQ(6)=1.5*(qQ(6)+qD(6)-Trace1-Trace2)+qK(6)
      If(ChargedQM) then  !If charged system, then do...
        qs=0
        Do 721, i=1,iCi
          CofC(1)=CofC(1)+abs(qm(i))*outxyzRAS(i,1) !Center of charge
          CofC(2)=CofC(2)+abs(qm(i))*outxyzRAS(i,2)
          CofC(3)=CofC(3)+abs(qm(i))*outxyzRAS(i,3)
          qs=qs+abs(qm(i))
721     Continue
        CofC(1)=CofC(1)/qs
        CofC(2)=CofC(2)/qs
        CofC(3)=CofC(3)/qs
        Gx=CofC(1)-outxyzRAS(1,1)+Cordst(1,1) !Where C-of-C is globally
        Gy=CofC(2)-outxyzRAS(1,2)+Cordst(1,2)
        Gz=CofC(3)-outxyzRAS(1,3)+Cordst(1,3)
        xyzMyC(1)=xyzMyC(1)+qtot*Gx !Dipole
        xyzMyC(2)=xyzMyC(2)+qtot*Gy
        xyzMyC(3)=xyzMyC(3)+qtot*Gz
      Endif
      Do 9977, i=1,3  !The energy of the induced dipole in its reaction
                      !field. It is ok since polfac*(xyzMyQ+xyzMyi) is
                      !the field from the induced dipole according to
                      !the image approximation. And the sought energy
                      !is -0.5*my_perm*R_ind, which is the thing below,
                      !see Boethcer p. 145.
        Energy=Energy+Polfac*xyzMyQ(i)*(xyzMyQ(i)+xyzMyi(i))
9977  Continue
*----------------------------------------------------------------------*
* The multipoles of the QM-region, modified due to the polarization,   *
* now interacts with each polarizability in the solvent.               *
*----------------------------------------------------------------------*
      Do 5, i=1,iCi
        Do 6, j=1+(nPol*iCnum),iAtom2
          Do 7, k=1,3
            Eil(j,k)=Eil(j,k)+Work(iFil(i,1)-1+j+(k-1)*nPart*nPol)*Qm(i)
            Do 8, l=1,3
              Eil(j,k)=Eil(j,k)+Work(iFil(i,l+1)-1+j+(k-1)*nPart*nPol)
     &                *Dm(i,l)
8           Continue
         Eil(j,k)=Eil(j,k)+Work(iFil(i,5)-1+j+(k-1)*nPart*nPol)*QQm(i,1)
         Eil(j,k)=Eil(j,k)+Work(iFil(i,7)-1+j+(k-1)*nPart*nPol)*QQm(i,3)
        Eil(j,k)=Eil(j,k)+Work(iFil(i,10)-1+j+(k-1)*nPart*nPol)*QQm(i,6)
       Eil(j,k)=Eil(j,k)+Work(iFil(i,6)-1+j+(k-1)*nPart*nPol)*QQm(i,2)*2
       Eil(j,k)=Eil(j,k)+Work(iFil(i,8)-1+j+(k-1)*nPart*nPol)*QQm(i,4)*2
       Eil(j,k)=Eil(j,k)+Work(iFil(i,9)-1+j+(k-1)*nPart*nPol)*QQm(i,5)*2
7         Continue
6       Continue
5     Continue
C...THIS IS LEBENSGEFAHRLICH (original comment says it all!)
*----------------------------------------------------------------------*
* We add up the field from the QM-region to the field on all the       *
* solvent polarizabilities.                                            *
*----------------------------------------------------------------------*
      Do 10, i=1+(nPol*iCNum),iAtom2
        Iu=i-((i-1)/nPol)*nPol
        Do 11, j=1,3  !Here we add the QM-molecule image to the solvent
                      !polarizabilities. Good old classical dielectric
                      !cavity model! Fil now contains the field on each
                      !solvent polarizability from all different
                      !sources.
          Fil(i,j)=Fil(i,j)+PolFac*xyzMyQ(j)+Eil(i,j)
          Energy=Energy+Fil(i,j)*Eil(i,j)*Pol(iu)
11      Continue
10    Continue
*----------------------------------------------------------------------*
* Now we wish to make the induced field from the solvent interact with *
* the QM-region. The static field has already interacted in helstate.f.*
* The reaction field of the QM-region in the dielectric cavity is      *
* also included, excluding the quadrupoles and higher; they are        *
* small anyway, so this is not a major restriction.                    *
*----------------------------------------------------------------------*
      Do 1801, i=1,10
        Gunnar(i)=0
1801  Continue
      Gunnar(2)=PolFac*(xyzMyP(1)+xyzMyQ(1)+xyzMyI(1)+xyzMyC(1))
      Gunnar(3)=PolFac*(xyzMyP(2)+xyzMyQ(2)+xyzMyI(2)+xyzMyC(2))
      Gunnar(4)=PolFac*(xyzMyP(3)+xyzMyQ(3)+xyzMyI(3)+xyzMyC(3))
      Do 1304, l=1,iCi
        Gunnar(1)=Gunnar(2)*outxyzRAS(l,1)+Gunnar(3)*outxyzRAS(l,2)
     &           +Gunnar(4)*outxyzRAS(l,3) !The potential from the
                                           !dipole (the 1/r*r*r is
                                           !in Work(iFil...).
        Do 1305, i=1,10
          Poli(l,i)=Gunnar(i)
          Do 1306, j=1+(nPol*iCnum),iAtom2
            Iu=j-((j-1)/nPol)*nPol
            Do 1307, k=1,3
       !Poli is the polarized field of the solvent. Remember that
       !Fil() is the total field on the polarizabilities.
              Poli(l,i)=Poli(l,i)-Fil(j,k)*Pol(iu)
     &                 *Work(iFil(l,i)-1+j+(k-1)*nPart*nPol)
1307        Continue
1306      Continue
1305    Continue
1304  Continue
      Do 299, i=1,nState*(nState+1)/2
        VpolMat(i)=0
299   Continue
      kaunt=0
      Do 300, iS=1,nState  !Attention! The reason we use RasCha etc. and
        Do 301, jS=1,iS   !not the computed Qm, Dm etc. from above is
          kaunt=kaunt+1  !that the density we want to describe is the
          Do 302, j=1,iCi !density of the basis-functions. Compare with
                          !ordinary <psi_i|V_el|psi_j>.
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,1)*RasCha(kaunt,j)
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,2)*RasDip(kaunt,1,j)
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,3)*RasDip(kaunt,2,j)
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,4)*RasDip(kaunt,3,j)
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,5)*RasQua(kaunt,1,j)
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,7)*RasQua(kaunt,3,j)
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,10)*RasQua(kaunt,6,j)
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,6)*RasQua(kaunt,2,j)*2
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,8)*RasQua(kaunt,4,j)*2
            Vpolmat(kaunt)=Vpolmat(kaunt)+Poli(j,9)*RasQua(kaunt,5,j)*2
302       Continue
301     Continue
300   Continue
      Do 400, i=1,iQ_Atoms  !This is how the nuclei interact with the
                      !induced field (in equil2 exists a corresponding
                      !term for the interaction with the static field).
                      !This way interaction between a charged molecule
                      !and the induced/permanent potential is included.
        Energy=Energy-2*Poli(i,1)*ChaNuc(i)
400   Continue

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iCall)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1994, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE CIDIA4(NAEL,IASTR,NBEL,IBSTR,
     &                  NORB,DIAG,NSMST,H,
     &                  ISMOST,IBLTP,XA,XB,SCR,RJ,RK,
     &                  NSSOA,NSSOB,IOCOC,NOCTPA,NOCTPB,
     &                  ISSOA,ISSOB,LUDIA,ECORE,
     &                  PLSIGN,PSSIGN,IPRNT,NTOOB,ICISTR)
*
* Calculate determinant diagonal
* Turbo-ras version
*
* ========================
* General symmetry version
* ========================
*
* Jeppe Olsen, Winter of 1991
* K => J - K moved outside, April 1994
*
      IMPLICIT REAL*8 (A-H,O-Z)
*.General input
      DIMENSION NSSOA(NOCTPA,*),NSSOB(NOCTPB,* )
      DIMENSION ISSOA(NOCTPA,*),ISSOB(NOCTPB,*)
      DIMENSION IASTR(NAEL,*),IBSTR(NBEL,*)
      DIMENSION H(NORB)
*. Specific input
      DIMENSION IOCOC(NOCTPA,NOCTPB)
      DIMENSION ISMOST(*),IBLTP(*)
*. Scratch
      DIMENSION RJ(NTOOB,NTOOB),RK(NTOOB,NTOOB)
      DIMENSION XA(NORB),XB(NORB),SCR(2*NORB)
*. Output
      DIMENSION DIAG(*)
*
*
      IF(PSSIGN.EQ.-1.0D0) THEN
         XADD = 1000000.0d0
      ELSE
         XADD = 0.0D0
      END IF
*
*
*
**3 Diagonal elements according to Handys formulae
*   (corrected for error)
*
*   DIAG(IDET) = HII*(NIA+NIB)
*              + 0.5 * ( J(I,J)-K(I,J) ) * NIA*NJA
*              + 0.5 * ( J(I,J)-K(I,J) ) * NIB*NJB
*              +         J(I,J) * NIA*NJB
*
*. K goes to J - K
*
      IDET = 0
      ITDET = 0
      IF(LUDIA.NE.0) REWIND LUDIA
      DO 1000 IASM = 1, NSMST
        IBSM = ISMOST(IASM)
        IF(IBSM.EQ.0.OR.IBLTP(IASM).EQ.0) GOTO 1000
        IF(IBLTP(IASM).EQ.2) THEN
          IREST1 = 1
        ELSE
          IREST1 = 0
        END IF
*
        DO 999  IATP = 1,NOCTPA
          IF(IREST1.EQ.1) THEN
            MXBTP = IATP
          ELSE
            MXBTP = NOCTPB
          END IF
          DO 900 IBTP = 1,MXBTP
          IF(IOCOC(IATP,IBTP) .EQ. 0 ) GOTO 900
          IBSTRT = ISSOB(IBTP,IBSM)
          IBSTOP = IBSTRT + NSSOB(IBTP,IBSM)-1
          DO 899 IB = IBSTRT,IBSTOP
            IBREL = IB - IBSTRT + 1
*
*. Terms depending only on IB
*
            ZERO = 0.0D0
*           CALL SETVEC(XB,ZERO,NORB)
            call dcopy_(NORB,[ZERO],0,XB,1)
            HB = 0.0D0
            RJBB = 0.0D0
*           CALL SETVEC(XB,ZERO,NORB)
*
            DO 990 IEL = 1, NBEL
              IBEL = IBSTR(IEL,IB)
              HB = HB + H(IBEL )
*
              DO 980 JEL = 1, NBEL
                RJBB = RJBB + RK(IBSTR(JEL,IB),IBEL )
  980         CONTINUE
*
              DO 970 IORB = 1, NORB
                XB(IORB) = XB(IORB) + RJ(IORB,IBEL)
  970         CONTINUE
  990       CONTINUE
            EB = HB + 0.5D0*RJBB + ECORE
*
            IF(IREST1.EQ.1.AND.IATP.EQ.IBTP) THEN
              IASTRT = ISSOA(IATP,IASM) - 1 + IBREL
            ELSE
              IASTRT = ISSOA(IATP,IASM)
            END IF
            IASTOP = ISSOA(IATP,IASM) + NSSOA(IATP,IASM) - 1
            DO 800 IA = IASTRT,IASTOP
              IDET = IDET + 1
              ITDET = ITDET + 1
              X1 = EB
              X2 = 0.0D0
              DO 890 IEL = 1, NAEL
                IAEL = IASTR(IEL,IA)
                X1 = X1 + ( H(IAEL )+XB(IAEL) )
                DO 880 JEL = 1, NAEL
                 X2 = X2 + RK(IASTR(JEL,IA),IAEL )
  880           CONTINUE
  890         CONTINUE
              DIAG(IDET) = X1 + 0.5D0*X2
              IF(IB.EQ.IA) DIAG(IDET) = DIAG(IDET) + XADD
  800       CONTINUE
  899     CONTINUE
*. Yet a RAS block of the diagonal has been constructed
          IF(ICISTR.GE.2) THEN
            CALL ITODS([IDET],1,-1,LUDIA)
            CALL TODSC_MCLR(DIAG,IDET,-1,LUDIA)
            IDET = 0
          END IF
  900   CONTINUE
  999   CONTINUE
*
 1000 CONTINUE
*
      IF ( ICISTR.GE.2 ) CALL ITODS([-1],1,-1,LUDIA)
*
      RETURN
c Avoid unused argument lines
      IF (.FALSE.) THEN
        CALL Unused_real_array(XA)
        CALL Unused_real_array(SCR)
        CALL Unused_real(PLSIGN)
        CALL Unused_integer(IPRNT)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Picky_(iBasi,iBsInc,iPrimi,iBasAO,iBasn,
     &                 jBasj,jBsInc,jPrimj,jBasAO,jBasn,
     &                 iCmpi,jCmpj,iShell,jShell,
     &                 mDCRij,ipDij,ipDDij,mDij,DeDe,nDeDe)
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
      Real*8 DeDe(nDeDe)
*
      If (nIrrep.eq.1) Then
         ii1=0
         ii2=1
         ii3=0
         jj1=0
         jj2=1
         jj3=0
      Else
         ii1=iBasi
         ii2=iBasAO
         ii3=iBasn
         jj1=jBasj
         jj2=jBasAO
         jj3=jBasn
      End If
      If (mDCRij.ne.0) Then
         If (iShell.ge.jShell) Then
            i1=ii1
            i2=ii2
            i3=ii3
            j1=jj1
            j2=jj2
            j3=jj3
         Else
            i1=jj1
            i2=jj2
            i3=jj3
            j1=ii1
            j2=ii2
            j3=ii3
         End If
         If (iBasi.eq.iBsInc.and.jBasj.eq.jBsInc) Then
            ipDDij=ipDij
         Else
            Call Picky(DeDe(ipDij),i1,j1,iPrimi*jPrimj,
     &                 iCmpi*jCmpj,mDCRij,
     &                 i2,i2+i3-1,j2,j2+j3-1,DeDe(ipDDij))
         End If
      End If
      mDij = (ii3*jj3+1)*iCmpi*jCmpj + iPrimi*jPrimj + 1
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine testconv_cvb(fx,npr,dx,w2,exp_tc,close2conv,converged,wrongstat)

use casvb_global, only: fxbest, ip, isaddleo, maxize
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: npr
real(kind=wp), intent(in) :: fx, dx(npr), w2(npr), exp_tc
logical(kind=iwp), intent(inout) :: close2conv
logical(kind=iwp), intent(out) :: converged, wrongstat
integer(kind=iwp) :: nnegeig, nposeig
real(kind=wp) :: act, eigmn, eigmna, eigmx, zz

if (maxize) then
  nposeig = min(isaddleo,npr)
else
  nposeig = max(npr-isaddleo,npr)
end if
nnegeig = npr-nposeig

! EIGMX is maximum of NNEGEIG first Hessian eigenvalues (which should
! all be negative) EIGMN the minimum of NPOSEIG last eigenvalues:
eigmx = -One
eigmn = One
eigmna = One

call zz_cvb(act,zz,fx,fxbest,exp_tc,ip)
fxbest = fx

! << Test for convergence or near-convergence >>
call testconv2_cvb(close2conv,converged,wrongstat,act,zz,dx,w2,npr,eigmn,eigmx,eigmna,nposeig,nnegeig)

return

end subroutine testconv_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine VECP(P1,P2,P3,DNORM3)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION P1(3),P2(3),P3(3)
C
C     Esegue il prodotto vettoriale P3 = P1 x P2
C
      P3(1) = P1(2)*P2(3) - P1(3)*P2(2)
      P3(2) = P1(3)*P2(1) - P1(1)*P2(3)
      P3(3) = P1(1)*P2(2) - P1(2)*P2(1)
      DNORM3 = sqrt(P3(1)*P3(1) + P3(2)*P3(2) + P3(3)*P3(3))
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE Pivot_mat(n,m,lu_A0,lu_A,iD_A,Scr,lScr)
************************************************************************
*
*     Author:  F. Aquilante
*
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Integer n, m, lu_A0, lu_A, iD_A(n), lScr
      Real*8  Scr(lScr)
#include "warnings.fh"

      lmax=lScr-n
      If (lmax .lt. n) Then
         Call WarningMessage(2,'Error in Pivot_mat')
         write(6,*) ' Pivot_mat: too little scratch space !!'
         Call Quit(_RC_CHO_LOG_)
      Endif
*
      nMem_Col = m
      mNeed = nMem_Col*(nMem_Col+1)/2
      Do while (mNeed .gt. lmax)
         mNeed = mNeed - nMem_Col
         nMem_Col = nMem_Col - 1
      End Do
*
      iScr=n
      Do kCol=1,nMem_Col
         jCol=iD_A(kCol)
         iAddr=n*(jCol-1)
         Call dDaFile(lu_A0,2,Scr(1),n,iAddr)
         Do i=1,kCol
            iCol=iD_A(i)
            iScr=iScr+1
            Scr(iScr)=Scr(iCol)
         End Do
      End Do
      kAddr=0
      ij=nMem_Col*(nMem_Col+1)/2
      Call dDaFile(lu_A,1,Scr(n+1),ij,kAddr)
*
      Do kCol=nMem_Col+1,m
         jCol=iD_A(kCol)
         iAddr=n*(jCol-1)
         Call dDaFile(lu_A0,2,Scr(1),n,iAddr)
         Do i=1,kCol
            iCol=iD_A(i)
            iScr=n+i
            Scr(iScr)=Scr(iCol)
         End Do
         Call dDaFile(lu_A,1,Scr(n+1),kCol,kAddr)
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine contf5 (wrk,wrksize,
     & lunt2o1,lunt2o2,lunt2o3)
c
c     this routine do : FV1,FV2,T23
c
c     FV1
c1    FV(m,j)aa  <= FII(m,j)aa
c2    FV(m,j)bb  <= FII(m,j)bb
c
c     FV2
c3    FV(m,j)aa  <- -0.5 sum (e-a) [ FIII(e,m)aa . T1o(e,j)aa ]
c4    FV(m,j)bb  <- -0.5 sum (e-b) [ FIII(e,m)bb . T1o(e,j)bb ]
c
c     T23
c5    Q(ab,k,l)aaaa   <= sum(m-a)   [ T2o(ab,k,m)aaaa . FV(m,l)aa ]
c5    T2n(ab,ij)aaaa   <- Q(ab,j,i)aaaa - Q(ab,i,j)aaaa
c6    Q(ab,k,l)bbbb   <= sum(m-b)   [ T2o(ab,k,m)bbbb . FV(m,l)bb ]
c6    T2n(ab,ij)bbbb   <- Q(ab,j,i)bbbb - Q(ab,i,j)bbbb
c7    T2n(a,b,i,j)abab <- - sum(m-b) [ T2o(a,b,i,m)abab . FV(m,j)bb ]
c8    T2n(a,b,i,j)abab <- - sum(m-a) [ T2o(a,b,m,j)abab . FV(m,i)aa ]
c
       use Para_Info, only: MyRank
#include "ccsd2.fh"
#include "parallel.fh"
#include "wrk.fh"
       integer lunt2o1,lunt2o2,lunt2o3
c
c     help variables
c
       integer posst,rc,ssc
c
c
c
cpar
       if ((myRank.eq.idbaab).or.(myRank.eq.idaabb)) then
c78.0 read V1(a,b,k,l) <= T2o(a,b,k,l)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv10,mapdv1,mapiv1,rc)
       end if
c
c
cpar
       if (myRank.eq.idbaab) then
c
c1    FV(m,j)aa  <= FII(m,j)aa
c
c1.1  map M1(m,j) <= F2(m,j)aa
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdf21,mapif21,1,mapdm1,mapim1,possm10,
     &           posst,rc)
c
c
c
c3    FV(m,j)aa  <- 0.5 sum (e-a) [ FIII(e,m)aa . T1o(e,j)aa ]
c
c3.1  map M2(m,e) <= F3(e,m)aa
       call map (wrk,wrksize,
     & 2,2,1,0,0,mapdf31,mapif31,1,mapdm2,mapim2,possm20,
     &           posst,rc)
c
c3.2  mult M3(m,j) <= M2(m,e) . T1o(e,j)aa
       call mult (wrk,wrksize,
     & 2,2,2,1,mapdm2,mapim2,1,mapdt11,mapit11,1,mapdm3,
     &            mapim3,ssc,possm30,rc)
c
c3.3  add M1(m,j) <- 0.5 M3(m,j)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,0.5d0,mapdm3,1,mapdm1,mapim1,1,rc)
c
c
c
c5    Q(ab,k,l)aaaa   <= sum(m-a)   [ T2o(ab,k,m)aaaa . FV(m,l)aa ]
c5    T2n(ab,ij)aaaa   <- Q(ab,j,i)aaaa - Q(ab,i,j)aaaa
c
c5.1  read V3(ab,kl) <= T2o(ab,kl)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv30,mapdv3,mapiv3,rc)
c
c5.2  expand V2(ab,k,l) <- V3(ab,kl)
       call expand (wrk,wrksize,
     & 4,6,mapdv3,mapiv3,1,possv20,mapdv2,mapiv2,rc)
c
c5.3  mult V3(ab,k,l) <= V2(a,b,k,m) . M1(m,l)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv2,mapiv2,1,mapdm1,mapim1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
c5.4  pack V2(ab,ij) <= V3(ab,i,j) - V3(ab,j,i)
       call fack (wrk,wrksize,
     & 4,4,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
c
c5.5  add T2n(ab,ij)aaaa <- - V2(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv2,1,mapdt21,mapit21,1,rc)
c
c
c
c8    T2n(a,b,i,j)abab <- - sum(m-a) [ T2o(a,b,m,j)abab . FV(m,i)aa ]
c
c8.1  map V2(a,b,j,m) <= V1(a,b,m,j)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv1,mapiv1,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
c
c8.2  mult V3(a,b,j,i) <= V2(a,b,j,m) . M1(m,i)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv2,mapiv2,1,mapdm1,mapim1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
c8.3  map V2(a,b,i,j) <= V3(a,b,j,i)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
c
c8.4  add T2n(a,b,i,j)abab <- - V2(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv2,1,mapdt23,mapit23,1,rc)
cpar
        end if
c
c
cpar
       if (myRank.eq.idaabb) then
c
c2    FV(m,j)bb  <= FII(m,j)bb
c
c2.1  map M1(m,j) <= F2(m,j)bb
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdf22,mapif22,1,mapdm1,mapim1,possm10,
     &           posst,rc)
c
c
c
c4    FV(m,j)bb  <- 0.5 sum (e-b) [ FIII(e,m)bb . T1o(e,j)bb ]
c
c4.1  map M2(m,e) <= F3(e,m)bb
       call map (wrk,wrksize,
     & 2,2,1,0,0,mapdf32,mapif32,1,mapdm2,mapim2,possm20,
     &           posst,rc)
c
c4.2  mult M3(m,j) <= M2(m,e) . T1o(e,j)bb
       call mult (wrk,wrksize,
     & 2,2,2,1,mapdm2,mapim2,1,mapdt12,mapit12,1,mapdm3,
     &            mapim3,ssc,possm30,rc)
c
c4.3  add M1(m,j) <- 0.5 M3(m,j)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,0.5d0,mapdm3,1,mapdm1,mapim1,1,rc)
c
c
c
c6    Q(ab,k,l)bbbb   <= sum(m-b)   [ T2o(ab,k,m)bbbb . FV(m,l)bb ]
c6    T2n(ab,ij)bbbb   <- Q(ab,j,i)bbbb - Q(ab,i,j)bbbb
c
c6.1  read V3(ab,kl) <= T2o(ab,kl)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv30,mapdv3,mapiv3,rc)
c
c6.2  expand V2(ab,k,l) <- V3(ab,kl)
       call expand (wrk,wrksize,
     & 4,6,mapdv3,mapiv3,1,possv20,mapdv2,mapiv2,rc)
c
c6.3  mult V3(ab,k,l) <= V2(a,b,k,m) . M1(m,l)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv2,mapiv2,1,mapdm1,mapim1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
c6.4  pack V2(ab,ij) <= V3(ab,i,j) - V3(ab,j,i)
       call fack (wrk,wrksize,
     & 4,4,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
c
c6.5  add T2n(ab,ij)bbbb <- - V2(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv2,1,mapdt22,mapit22,1,rc)
c
c
c
c7    T2n(a,b,i,j)abab <- - sum(m-b) [ T2o(a,b,i,m)abab . FV(m,j)bb ]
c
c7.1  mult V3(a,b,i,j) <= V1(a,b,i,m) . M1(m,j)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv1,mapiv1,1,mapdm1,mapim1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
c7.2  add T2n(a,b,i,j)abab <- - V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
cpar
        end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ABTD(ICSPCK,INTSYM,INDX,C1,C2,TDMO,A1,A2,F)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION ICSPCK(*),INTSYM(*),INDX(*),
     *          C1(*),C2(*),TDMO(NBAST,NBAST),
     *          A1(*),A2(*),F(*)
      DIMENSION IPOA(9),IPOF(9)
      DIMENSION IOC(55)
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CPAM97      JO(L)=UNPACK(CSPCK((L+29)/30), 2*L-(2*L-1)/60*60, 2)
      JO(L)=ICUNP(ICSPCK,L)
CPAM96      JSYM(L)=UNPACK(INTSYM((L+9)/10),3*MOD(L-1,10)+1,3)+1
      JSYM(L)=JSUNP(INTSYM,L)
C CALCULATE A) TRANSITION DENSITY ELEMENTS OF TYPE TDMO(A,B)
C           B) DIAGONAL ELEMENTS TDMO(I,I) AND TDMO(A,A)
C SCRATCH SPACES: A1(),A2(), SIZE NEEDED IS NVMAX**2
C                  ALSO F(), SIZE NEEDED IS NVSQ
      CALL CSCALE(INDX,INTSYM,C1,SQ2)
      CALL CSCALE(INDX,INTSYM,C2,SQ2)
      NCLIM=4
      IF(IFIRST.NE.0)NCLIM=2
C MOVE TRANSITION DENSITY MATRIX TO F IN SYMMETRY BLOCKS
      CALL IPO(IPOF,NVIR,MUL,NSYM,1,-1)
      DO 10 IASYM=1,NSYM
        IAB=IPOF(IASYM)
        NA1=NVIRP(IASYM)+1
        NA2=NVIRP(IASYM)+NVIR(IASYM)
        DO 15 NA=NA1,NA2
          DO 20 NB=NA1,NA2
            IAB=IAB+1
            F(IAB)=TDMO(LN+NA,LN+NB)
20        CONTINUE
15      CONTINUE
10    CONTINUE
      II1=0
      ITAIL=IRC(NCLIM)
      DO 40 INDA=1,ITAIL
        DO 110 I=1,LN
          II1=II1+1
          IOC(I)=(1+JO(II1))/2
110     CONTINUE
      IF(INDA.LE.IRC(1)) THEN
        TSUM=C1(INDA)*C2(INDA)
        GO TO 106
      END IF
      MYSYM=JSYM(INDA)
      MYL=MUL(MYSYM,LSYM)
      INMY=INDX(INDA)+1
      IF(INDA.GT.IRC(2))GO TO 25
C DOUBLET-DOUBLET INTERACTIONS
      IF(NVIR(MYL).EQ.0)GO TO 40
      IPF=IPOF(MYL)+1
      IN=IPOF(MYL+1)-IPOF(MYL)
      NVIRA=NVIR(MYL)
      CALL DGER(NVIRA,NVIRA,1.0D00,C1(INMY),1,
     *           C2(INMY),1,F(IPF),NVIRA)
      LNA=LN+NVIRP(MYL)
      TSUM=0.0D00
      DO 130 I=1,NVIRA
        TERM=C1(INMY-1+I)*C2(INMY-1+I)
        IA=LNA+I
        TDMO(IA,IA)=TDMO(IA,IA)+TERM
        TSUM=TSUM+TERM
130   CONTINUE
      GO TO 106
C TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
25    IFT=1
      IF(INDA.GT.IRC(3))IFT=0
      CALL IPO(IPOA,NVIR,MUL,NSYM,MYL,IFT)
      IN=0
      TSUM=0.0D00
      DO 70 IASYM=1,NSYM
      IAB=IPOF(IASYM+1)-IPOF(IASYM)
      IF(IAB.EQ.0)GO TO 70
      ICSYM=MUL(MYL,IASYM)
      NVIRA=NVIR(IASYM)
      NVIRC=NVIR(ICSYM)
      IF(NVIRC.EQ.0)GO TO 70
      IF(MYL.NE.1) THEN
        IF(IASYM.GT.ICSYM) THEN
          CALL MTRANS(C1(INMY+IPOA(IASYM)),1,A1,1,NVIRA,NVIRC)
          CALL MTRANS(C2(INMY+IPOA(IASYM)),1,A2,1,NVIRA,NVIRC)
        ELSE
          NAC=NVIRA*NVIRC
          IF(IFT.EQ.0) THEN
            CALL DCOPY_(NAC,C1(INMY+IPOA(ICSYM)),1,A1,1)
            CALL DCOPY_(NAC,C2(INMY+IPOA(ICSYM)),1,A2,1)
          ELSE
            CALL VNEG(C1(INMY+IPOA(ICSYM)),1,A1,1,NAC)
            CALL VNEG(C2(INMY+IPOA(ICSYM)),1,A2,1,NAC)
          END IF
        END IF
      ELSE
        IF(IFT.EQ.0)THEN
          CALL SQUAR(C1(INMY+IPOA(IASYM)),A1,NVIRA)
          CALL SQUAR(C2(INMY+IPOA(IASYM)),A2,NVIRA)
        ELSE
          CALL SQUARM(C1(INMY+IPOA(IASYM)),A1,NVIRA)
          CALL SQUARM(C2(INMY+IPOA(IASYM)),A2,NVIRA)
        END IF
      END IF
      IPF=IPOF(IASYM)+1
      CALL DGEMM_('N','T',NVIRA,NVIRA,NVIRC,1.0D00,A1,NVIRA,
     *            A2,NVIRA,1.0D00,F(IPF),NVIRA)
      INN=1
      LNC=LN+NVIRP(ICSYM)
      DO 105 I=1,NVIRC
        TERM=DDOT_(NVIRA,A1(INN),1,A2(INN),1)
        TSUM=TSUM+TERM
        IC=LNC+I
        TDMO(IC,IC)=TDMO(IC,IC)+TERM
        INN=INN+NVIRA
105   CONTINUE
70    CONTINUE
      TSUM=TSUM/2
106   CONTINUE
      DO 107 I=1,LN
        TDMO(I,I)=TDMO(I,I)+IOC(I)*TSUM
107   CONTINUE
40    CONTINUE
      DO 410 IASYM=1,NSYM
        IAB=IPOF(IASYM)
        NA1=NVIRP(IASYM)+1
        NA2=NVIRP(IASYM)+NVIR(IASYM)
        DO 415 NA=NA1,NA2
          DO 420 NB=NA1,NA2
            IAB=IAB+1
            IF(NA.EQ.NB) GOTO 420
            TDMO(LN+NA,LN+NB)=F(IAB)
420       CONTINUE
415     CONTINUE
410   CONTINUE
      CALL CSCALE(INDX,INTSYM,C1,SQ2INV)
      CALL CSCALE(INDX,INTSYM,C2,SQ2INV)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#include "macros.fh"
      SUBROUTINE PRPROP(PROP,USOR,USOI,ENSOR,NSS,OVLP,ENERGY,JBNUM,
     &                  EigVec)

      use rassi_aux, only: ipglob
      use rassi_global_arrays, only: SODYSAMPS
      USE kVectors
#ifdef _HDF5_
      USE mh5, ONLY: mh5_put_dset
      use RASSIWfn, only: wfn_sfs_angmom, wfn_sos_angmomr,
     &                    wfn_sos_angmomi, wfn_sos_spinr, wfn_sos_spini,
     &                    wfn_sfs_edipmom, wfn_sfs_amfi,
     &                    wfn_sos_edipmomr, wfn_sos_edipmomi,
     &                    wfn_sos_dys
      use Cntrl, only: RhoDyn
#endif
      use Constants, only: Pi, auTocm, auToeV, auTofs, auTokJ, auToT,
     &                     c_in_au, Debye, gElectron, kBoltzmann, mBohr,
     &                     rNAVO, Half, Two, Three, Zero, One, Six, Ten,
     &                     Nine
      use stdalloc, only: mma_allocate, mma_deallocate
      use Cntrl, only: NSTATE, NPROP, NTS, PRXVE, PRMEE, LPRPR,
     &                 PRMES, IFSO, NSOPR, DIPR, OSThr_DIPR, QIPR,
     &                 OSthr_QIPR, QIALL, RSPR, RSThr, ReduceLoop,
     &                 LoopDivide, LoopMax, Do_SK, PRDIPCOM, Tolerance,
     &                 DoCD, DYSO, Do_TMom, IfGCAL, EPrThr,
     &                 IfvanVleck, TMins, TMaxs, IfGTCALSA, IfGTSHSA,
     &                 MULTIP, IfACAL, IfXCal, BStart, NBSTep, BIncre,
     &                 TStart, nTStep, TIncre, IfMCal, BAngRes, iComp,
     &                 IPUSED, ISOCMP, MLTPLT, PNAME, PNUC, PORIG,
     &                 PTYPE, SOPRNM, SOPRTP

      IMPLICIT NONE
      Integer NSS, JBNUM(NSTATE)
      Real*8 USOR(NSS,NSS),USOI(NSS,NSS),ENSOR(NSS)
      Real*8 PROP(NSTATE,NSTATE,NPROP),OVLP(NSTATE,NSTATE),
     &       ENERGY(NSTATE), EigVec(NSTATE,NSTATE)

      Real*8, parameter:: THRSH=1.0D-10
      Character(LEN=1), Parameter :: xyzchr(3)=['x','y','z']
      Integer IPAMFI(3),IPAM(3)
      Real*8 DTENS(3,3),GTENS(3,3),GSTENS(3,3),SOSTERM(9)
      Real*8 TMPMAT(3,3),TMPVEC(3,3),EVR(3),EVI(3)
      COMPLEX*16 ZEKL(2,2,3,NSTATE),GCONT(9,NSTATE)
      COMPLEX*16 DIPSOm(3,NSS,NSS),Z(NSS,NSS),DIPSOn(3,NSS,NSS)
      COMPLEX*16 SPNSFS(3,NSS,NSS)
      REAL*8 GTOTAL(9),ANGMOME(3,NSTATE,NSTATE),ESO(NSS)
      REAL*8 EDIP1MOM(3,NSTATE,NSTATE),AMFIINT(3,NSTATE,NSTATE)
      Real*8 TMPm(NTS)!,TMPf(NTP)
      Real*8 c_1(3,3),c_2(3,3)!,Zstat1m(NTS),Zstat1f(NTP)
      Real*8 curit(3,3),paramt(3,3)
      Real*8 chiT_tens(NTS,3,3)!,PNMRT(NTP,3,3),PNMR(NTP,3,3)
      Real*8 chicuriT_tens(NTS,3,3),chiparamT_tens(NTS,3,3)
      REAL*8 DLTT,Zstat,p_Boltz!,DLTTA
      LOGICAL ISGS(NSS),IFANGM,IFDIP1,IFAMFI
      Real*8 RMAGM(3),Chi(3)
      INTEGER IFUNCT, SECORD(4)
      Complex*16 T0(3), TM1
      REAL*8 COMPARE
      REAL*8 Rtensor(6)
      REAL*8, Allocatable:: SOPRR(:,:), SOPRI(:,:)
#ifdef _HDF5_
      REAL*8, Allocatable:: TMP(:,:,:)
#endif
      Integer, allocatable:: PMAP(:)
! Dipole
      Real*8, allocatable:: DXR(:,:), DXI(:,:),
     &                      DYR(:,:), DYI(:,:),
     &                      DZR(:,:), DZI(:,:)
! Magnetic-Dipole
      Real*8, allocatable:: MDXR(:,:), MDXI(:,:),
     &                      MDYR(:,:), MDYI(:,:),
     &                      MDZR(:,:), MDZI(:,:)
! Electric-Quadrupole
      Real*8, allocatable:: QXXR(:,:), QXXI(:,:),
     &                      QXYR(:,:), QXYI(:,:),
     &                      QXZR(:,:), QXZI(:,:),
     &                      QYYR(:,:), QYYI(:,:),
     &                      QYZR(:,:), QYZI(:,:),
     &                      QZZR(:,:), QZZI(:,:)
! Magnetic-Quadrupole
      Real*8, allocatable:: MQZXR(:,:), MQZXI(:,:),
     &                      MQXZR(:,:), MQXZI(:,:),
     &                      MQXYR(:,:), MQXYI(:,:),
     &                      MQYXR(:,:), MQYXI(:,:),
     &                      MQYZR(:,:), MQYZI(:,:),
     &                      MQZYR(:,:), MQZYI(:,:)
! Octupole
      Real*8, allocatable:: DXXXR(:,:),DXXXI(:,:),
     &                      DXXYR(:,:),DXXYI(:,:),
     &                      DXXZR(:,:),DXXZI(:,:),
     &                      DYYXR(:,:),DYYXI(:,:),
     &                      DYYYR(:,:),DYYYI(:,:),
     &                      DYYZR(:,:),DYYZI(:,:),
     &                      DZZXR(:,:),DZZXI(:,:),
     &                      DZZYR(:,:),DZZYI(:,:),
     &                      DZZZR(:,:),DZZZI(:,:)
! Spin-Magnetic-Dipole
      Real*8, allocatable:: SXR(:,:), SXI(:,:),
     &                      SYR(:,:), SYI(:,:),
     &                      SZR(:,:), SZI(:,:)
! Spin-Magnetic-Quadrupole
      Real*8, allocatable:: SXYR(:,:), SXYI(:,:), SYXR(:,:), SYXI(:,:),
     &                      SYZR(:,:), SYZI(:,:), SZYR(:,:), SZYI(:,:),
     &                      SZXR(:,:), SZXI(:,:), SXZR(:,:), SXZI(:,:)

      Real*8, allocatable:: DV(:,:), DL(:,:), TOT2K(:,:)
      Real*8, Allocatable:: LXI(:,:), LYI(:,:), LZI(:,:)
      Real*8, Allocatable:: ZR(:,:), ZI(:,:)
      Type A2_Array
           Real*8, Pointer:: A2(:,:)
      End Type A2_Array
      Type (A2_array):: pZMR(3), pZMI(3)
      Type (A2_array):: pMR(3), pMI(3)
      Real*8, allocatable, Target:: ZXR(:,:), ZXI(:,:)
      Real*8, allocatable, Target:: ZYR(:,:), ZYI(:,:)
      Real*8, allocatable, Target:: ZZR(:,:), ZZI(:,:)
      Real*8, allocatable, Target:: MXR(:,:), MXI(:,:)
      Real*8, allocatable, Target:: MYR(:,:), MYI(:,:)
      Real*8, allocatable, Target:: MZR(:,:), MZI(:,:)
      Real*8, allocatable, Target:: UZR(:,:), UZI(:,:)

      Real*8, allocatable:: MAGM(:)

      Real*8, Parameter:: AU2J=auTokJ*1.0D3
      Real*8, Parameter:: J2CM=auTocm/AU2J
      Real*8, Parameter:: AU2JTM=(AU2J/auToT)*rNAVO
      Real*8, Parameter:: AU2REDR=2.0D2*Debye

      Real*8, Parameter:: BOLTZ_K=kBoltzmann*J2CM
      Real*8, Parameter:: coeff_chi=0.1D0*rNAVO/kBoltzmann*mBohr**2
      Real*8, Parameter:: FEGVAL=-gElectron
      Real*8, Parameter:: BOLTZ=kBoltzmann/AU2J
      Real*8, Parameter:: Rmu0=4.0D-7*Pi
      Real*8, Parameter:: Two3rds=Two/Three
      Real*8, Parameter:: ONEOVER6C2=One/(Six*c_in_au**2)
      Real*8, Parameter:: ONEOVER10C=One/(Ten*c_in_au**2)
      Real*8, Parameter:: ONEOVER30C=ONEOVER10C/Three
      Real*8, Parameter:: TWOOVERM45C=-Two/(45.0D0*c_in_au**2)
      REAL*8, Parameter:: ONEOVER9C2=One/(Nine*c_in_au**2)

      Integer nCol, iProp,               I, ISTA, IEND, J, ICMP, NPMSIZ,
     &        nMiss, iSOPr, JSTART, JEND, I_Have_DL, I_Have_DV, nVec,
     &      i_print,ISS, JSS, K, I_Print_Header, IfAnyM, IfAnyS, IfAnyQ,
     &        IfAnyO, I2Tot, iAMFIx, iAMFIy, iAMFIz, iXYZ, jXYZ, iState,
     &        MPLET1, jState, MPLET2, iAMx, iAMy, iAMz, MPLET, kXYZ,
     &        iERR, iMLTPL, iStart, iFinal, ijXYZ, IT, IC, JC, KDGN,
     &        ISO, JSO, LMStep, IBStep, ITStep, nPhiStep, nTheStep,
     &        NORIENT, ITHE, iPhiStep, iPhi, IfAnyD, iPrDXY, iPrDXZ,
     &        iPrDYZ, iVec
      Real*8 AFactor, OSthr, OSThr2, EDiff, DX2, DY2, DZ2, FX, FY, FZ,
     &       A, DLT, EDIFF3, DXX2, DYY2, DZZ2, FXX, FYY, FYZ, DXXDYY,
     &       DXXDZZ, DYYDZZ, FXXFYY, FXXFZZ, FYYFZZ, G, DXXXDX, DYYXDX,
     &       DZZXDX, FXXX, FYYY, FZZZ, DXXYDY, DYYYDY, DZZYDY, FXXY,
     &       FZZY, DXXZDZ, DYYZDZ, DZZZDZ, EDIFF2, DXYDZ, DYXDZ,
     &       FYX, DZXDY, DXZDY, FZX, DYZDX, DZYDX, FZY, D_XR, D_YR,
     &       D_ZR, D_XI, D_YI, D_ZI, D_MXR, D_MYR, D_MZR, D_MXI, D_MYI,
     &       D_MZI, RXX, RYY, RZZ, R, PLIMIT, PMAX,
     &       Q_XXR, Q_XYR, Q_XZR, Q_YYR, Q_YZR, Q_ZZR,
     &       Q_XXI, Q_XYI, Q_XZI, Q_YYI, Q_YZI, Q_ZZI,
     &       RXY, RXZ, RYX, RYZ, RZX, RZY,
     &       RXXY, RXXZ, RXYX, RXYZ, RXZX, RXZY, RXYY, RYYX, RYYZ,
     &       RYZX, RYZY, RXZZ, RZZX, RZZY, DysThr, S1, FACT0, FACTP,
     &       FACTM, DTIJ, S2, DELTA, CONTRIB, S, Factor, GTij, GSEnergy,
     &       DLT_E, BFinal, TFinal, B, HZer, T, RKT, RPart, Fact,
     &       rMagm2, rMagMO, GTR, bPhiRes, Phi, Bx, By, Bz, DIPSOM_SA,
     &       EEX, EEY, EEZ, ThreEJ, AX, AY, AZ, F, FZZ, DXY2, DXZ2,
     &       FXY, FXZ, FYYX, FZZX, FXXZ, FYYZ, DYZ2, RYZZ, THE

******************************************************
* printout of properties over the spin-free states
******************************************************

      IF(IPGLOB.LE.0) GOTO 400

      IF( PRXVE.OR.PRMEE ) THEN
      WRITE(6,*)
      WRITE(6,*)
      WRITE(6,'(6X,A)') repeat('*',100)
      WRITE(6,'(6X,A,98X,A)') '*','*'
      WRITE(6,'(6X,A,34X,A,34X,A)')
     &     '*',' Spin-free properties section ','*'
      WRITE(6,'(6X,A,98X,A)') '*','*'
      WRITE(6,'(6X,A)') repeat('*',100)
      WRITE(6,*)
      WRITE(6,*)
      END IF

* Did the user want printed expectation values?
      IF( PRXVE ) THEN
       Call CollapseOutput(1,'Expectation values')
       WRITE(6,*)
       WRITE(6,*)' ============================================'
       WRITE(6,*)'  EXPECTATION VALUES OF 1-ELECTRON OPERATORS'
       WRITE(6,*)'  FOR THE SPIN-FREE EIGENSTATES:'
       WRITE(6,*)' ============================================'
       WRITE(6,*)' (note: negative sign used for electronic multipoles)'
       WRITE(6,*)
       NCOL=4
       DO IPROP=1,NPROP
        IF(IPUSED(IPROP).EQ.0) GOTO 100

* Skip printing if all the diagonal values are very small
*  (presumed zero for reasons of selection rules)
        PLIMIT=1.0D-10
        PMAX=ZERO


        DO I=1,NSTATE
         PMAX=MAX(PMAX,ABS(PROP(I,I,IPROP)+PNUC(IPROP)*OVLP(I,I)))
        END DO
        IF(PMAX.LT.PLIMIT) GOTO 100

        DO ISTA=1,NSTATE,NCOL
          IEND=MIN(NSTATE,ISTA+NCOL-1)
          WRITE(6,*)
          WRITE(6,'(1X,A,A8,A,I4)')
     *  'PROPERTY: ',PNAME(IPROP),'   COMPONENT:',ICOMP(IPROP)
          WRITE(6,'(1X,A,3(1X,ES16.9))')
     *'ORIGIN    :',(PORIG(I,IPROP),I=1,3)
          WRITE(6,'(1X,A,I8,4I17)')
     *'STATE     :',(I,I=ISTA,IEND)
          WRITE(6,*)
          WRITE(6,'(1X,A,4(1X,ES16.9))')
     *'ELECTRONIC:',(PROP(I,I,IPROP),I=ISTA,IEND)
          WRITE(6,'(1X,A,4(1X,ES16.9))')
     *'NUCLEAR   :',(PNUC(IPROP),I=ISTA,IEND)
          WRITE(6,'(1X,A,4(1X,ES16.9))')
     *'TOTAL     :',(PROP(I,I,IPROP)+PNUC(IPROP),I=ISTA,IEND)
          WRITE(6,*)
        END DO
 100    CONTINUE
       END DO
       Call CollapseOutput(0,'Expectation values')
       WRITE(6,*)
      END IF

* include nuclear contribution
      DO IPROP=1,NPROP
        DO I=1,NSTATE
          PROP(I,I,IPROP)=PROP(I,I,IPROP)+PNUC(IPROP)
        END DO
      END DO

* Did the user want printed matrix elements?
      IF( PRMEE ) THEN
       Call CollapseOutput(1,'Matrix elements')
       WRITE(6,*)
       WRITE(6,*)' ========================================='
       WRITE(6,*)'  MATRIX ELEMENTS OF 1-ELECTRON OPERATORS'
       WRITE(6,*)'  FOR THE SPIN-FREE EIGENSTATES:'
       WRITE(6,*)' ========================================='
       WRITE(6,*)' (including nuclear contrib.)'
       WRITE(6,*)
       WRITE(6,*)' SELECTED PROPERTIES:'
       DO I=1,NPROP,5
         WRITE(6,'(1X,5(A8,1X,I2,4X))')
     &          (PNAME(IPROP),ICOMP(IPROP),IPROP=I,MIN(NPROP,I+4))
       END DO

       NCOL=4
       DO IPROP=1,NPROP
         IF(IPUSED(IPROP).EQ.0) GOTO 200
         WRITE(6,*)
         WRITE(6,'(1X,A,A8,A,I4)')
     *   'PROPERTY: ',PNAME(IPROP),'   COMPONENT:',ICOMP(IPROP)
         WRITE(6,'(1X,A,3(1X,ES16.9))')
     *   'ORIGIN: ',(PORIG(I,IPROP),I=1,3)
         DO ISTA=1,NSTATE,NCOL
           IEND=MIN(NSTATE,ISTA+NCOL-1)
           WRITE(6,*)
           WRITE(6,'(1X,A,I8,3I17)')
     *     ' STATE   ',(I,I=ISTA,IEND)
           WRITE(6,*)
           DO J=1,NSTATE
            WRITE(6,'(1X,I4,6X,4(1X,ES16.9))')
     *      J,(PROP(J,I,IPROP),I=ISTA,IEND)
           END DO
         END DO
 200     CONTINUE
       END DO

       Call CollapseOutput(0,'Matrix elements')
       WRITE(6,*)
      END IF
C Added by Ungur Liviu on 04.11.2009.
C Addition of ANGMOM to Runfile.

      IFANGM=.FALSE.
      IFDIP1=.FALSE.
      IFAMFI=.FALSE.
      ANGMOME(:,:,:) = 0.0D0
      EDIP1MOM(:,:,:) = 0.0D0
      AMFIINT(:,:,:) = 0.0D0
      DO IPROP=1,NPROP
         IF(PNAME(IPROP)(1:6).EQ.'ANGMOM') THEN
            IFANGM=.TRUE.
            DO I=1,NSTATE
               DO J=1,NSTATE
                  ANGMOME(ICOMP(IPROP),I,J)=PROP(I,J,IPROP)
               ENDDO
            ENDDO
         ENDIF
c add dipole moment integrals:
         IF(PNAME(IPROP).EQ.'MLTPL  1'.AND.
     &      PTYPE(IPROP).EQ.'HERMSING') THEN
            IFDIP1=.TRUE.
            DO I=1,NSTATE
               DO J=1,NSTATE
                  EDIP1MOM(ICOMP(IPROP),I,J)=PROP(I,J,IPROP)
               ENDDO
            ENDDO
         ENDIF
c add spin-orbit AMFI integrals:
         IF(PNAME(IPROP)(1:8).EQ.'AMFI    ') THEN
            IFAMFI=.TRUE.
            DO I=1,NSTATE
               DO J=1,NSTATE
                  AMFIINT(ICOMP(IPROP),I,J)=PROP(I,J,IPROP)
               ENDDO
            ENDDO
         ENDIF
      ENDDO
      IF(IFANGM) CALL Put_dArray('ANGM_SINGLE',ANGMOME,3*NSTATE*NSTATE)
      IF(IFDIP1) CALL Put_dArray('DIP1_SINGLE',EDIP1MOM,3*NSTATE*NSTATE)
      IF(IFAMFI) CALL Put_dArray('AMFI_SINGLE',AMFIINT,3*NSTATE*NSTATE)
#ifdef _HDF5_
      call mma_allocate(TMP,NSTATE,NSTATE,3,Label='TMP')
      if (IFANGM) then
        do i=1,3
          TMP(:,:,i) = ANGMOME(i,:,:)
        end do
        call mh5_put_dset(wfn_sfs_angmom,TMP,[NSTATE,NSTATE,3],[0,0,0])
      end if
      if (IFDIP1) then
        do i=1,3
          TMP(:,:,i) = EDIP1MOM(i,:,:)
        end do
        call mh5_put_dset(wfn_sfs_edipmom,TMP,[NSTATE,NSTATE,3],[0,0,0])
      end if
      if (IFAMFI) then
        do i=1,3
          TMP(:,:,i) = AMFIINT(i,:,:)
        end do
        call mh5_put_dset(wfn_sfs_amfi,TMP,[NSTATE,NSTATE,3],[0,0,0])
      end if
      call mma_deallocate(TMP)
#endif
*******************************************************
* printout of properties over the spin-orbit states
*******************************************************
c If PRPR requested, print the spin matrices
#ifdef _HDF5_
      IF (LPRPR.OR.PRMES) THEN
#else
      IF (LPRPR) THEN
#endif
         Call mma_Allocate(SOPRR,NSS,NSS,Label='SOPRR')
         Call mma_Allocate(SOPRI,NSS,NSS,Label='SOPRI')
         DO ICMP=1,3
            SOPRR(:,:)=0.0D0
            SOPRI(:,:)=0.0D0
            IF (ICMP.EQ.2) THEN
              CALL SMMAT(PROP,SOPRI,NSS,0,ICMP)
            ELSE
              CALL SMMAT(PROP,SOPRR,NSS,0,ICMP)
            END IF
            CALL ZTRNSF(NSS,USOR,USOI,SOPRR,SOPRI)
#ifdef _HDF5_
            Call mh5_put_dset(wfn_sos_spinr,
     &                        SOPRR,[NSS,NSS,1],[0,0,ICMP-1])
            Call mh5_put_dset(wfn_sos_spini,
     &                        SOPRI,[NSS,NSS,1],[0,0,ICMP-1])
#endif
            IF (LPRPR) CALL PRCMAT3(NSS,SOPRR,SOPRI,ICMP)
         END DO
         Call mma_deallocate(SOPRR)
         Call mma_deallocate(SOPRI)
      END IF

      IF(.not.IFSO) GOTO 300
      NPMSIZ=NSOPR
      IF(NSOPR.EQ.0) GOTO 300

      IF( PRMES ) THEN
* match the SO property list to the SF property list
       CALL mma_allocate(PMAP,NPMSIZ,Label='PMap')
       NMISS=0
       DO ISOPR=1,NSOPR
        PMAP(ISOPR)=0
        DO IPROP=1,NPROP
         IF(PNAME(IPROP).EQ.SOPRNM(ISOPR).AND.
     &     ICOMP(IPROP).EQ.ISOCMP(ISOPR)) THEN
          PMAP(ISOPR)=IPROP
          GOTO 10
         END IF
        END DO
        NMISS=NMISS+1
 10     CONTINUE
       END DO

c check for inconsistencies
       IF(NMISS.GT.0) THEN
         Call WarningMessage(1,'Missing data integrals.')
         WRITE(6,*)'WARNING: You have requested matrix elements'
         WRITE(6,*)'over spin states of some operators. The present'
         WRITE(6,*)'code uses matrix elements computed over spin-free'
         WRITE(6,*)'states to compute those over spin states.'
         WRITE(6,*)'Matrix elements of the following operator(s)'
         WRITE(6,*)'were never computed and must be skipped.'
         WRITE(6,*)'   (If you need these properties, change the'
         WRITE(6,*)'    input to SEWARD and recompute.)'
         DO ISOPR=1,NSOPR
          IF(PMAP(ISOPR).EQ.0)
     &       WRITE(6,*)'Property:',SOPRNM(ISOPR),
     &                 '      Component:',ISOCMP(ISOPR)
         END DO
        WRITE(6,*)
       END IF
       WRITE(6,*)
       WRITE(6,*)
       WRITE(6,'(6X,A)') repeat('*',100)
       WRITE(6,'(6X,A,98X,A)') '*','*'
       WRITE(6,'(6X,A,34X,A,34X,A)')
     &     '*','Spin-orbit properties section ','*'
       WRITE(6,'(6X,A,98X,A)') '*','*'
       WRITE(6,'(6X,A)') repeat('*',100)
       WRITE(6,*)
       WRITE(6,*)

       Call CollapseOutput(1,'Matrix elements over SO states')
       WRITE(6,*)
       WRITE(6,*)' ========================================='
       WRITE(6,*)'  MATRIX ELEMENTS OF 1-ELECTRON OPERATORS'
       WRITE(6,*)'  FOR THE SPIN-ORBIT EIGENSTATES:'
       WRITE(6,*)' ========================================='
       WRITE(6,*)
       WRITE(6,*)' SELECTED PROPERTIES:'
       DO I=1,NPROP,5
         WRITE(6,'(1X,5(A8,1X,I2,4X))')
     &          (SOPRNM(ISOPR),ISOCMP(ISOPR),ISOPR=I,MIN(NSOPR,I+4))
       END DO

C Remove zeroes to make SOPRNM and ISOCMP lists contiguous. New NSOPR.
       ISOPR=0
       DO I=1,NSOPR
        IPROP=PMAP(I)
        IF(IPROP.GT.0) THEN
         ISOPR=ISOPR+1
         SOPRNM(ISOPR)=SOPRNM(I)
         ISOCMP(ISOPR)=ISOCMP(I)
        END IF
       END DO
       CALL mma_deallocate(PMAP)
       NSOPR=ISOPR

       Call mma_Allocate(SOPRR,NSS,NSS,Label='SOPRR')
       Call mma_Allocate(SOPRI,NSS,NSS,Label='SOPRI')
C Print out the matrix elements:
       NCOL=4
       DO ISOPR=1,NSOPR
        WRITE(6,*)
        WRITE(6,'(1X,A,A8,A,I4)')
     &  'PROPERTY: ',SOPRNM(ISOPR),'   COMPONENT:',ISOCMP(ISOPR)
CIFG  should print the origin, but where is it stored (for SO properties)?
        SOPRR(:,:)=0.0D0
        SOPRI(:,:)=0.0D0

        CALL SMMAT(PROP,SOPRR,NSS,ISOPR,0)
        CALL ZTRNSF(NSS,USOR,USOI,SOPRR,SOPRI)
        CALL PRCMAT(NSS,SOPRR,SOPRI)
C prpr keyword: Print selected spin-orbit properties to ext. data files
        IF((LPRPR).AND.(SOPRNM(ISOPR)(1:5).EQ.'MLTPL')) THEN
          IF(SOPRTP(ISOPR).EQ.'HERMSING') THEN
            CALL PRCMAT2(ISOPR,NSS,SOPRR,SOPRI)
          ENDIF
        ELSE IF((LPRPR).AND.(SOPRNM(ISOPR)(1:6).EQ.'ANGMOM')) THEN
          IF(SOPRTP(ISOPR).EQ.'ANTISING') THEN
            CALL PRCMAT2(ISOPR,NSS,SOPRR,SOPRI)
          ENDIF
        ELSE IF((LPRPR).AND.(SOPRNM(ISOPR)(1:8).EQ.'VELOCITY')) THEN
          IF(SOPRTP(ISOPR).EQ.'ANTISING') THEN
            CALL PRCMAT2(ISOPR,NSS,SOPRR,SOPRI)
          ENDIF
        ELSE IF((LPRPR).AND.(SOPRNM(ISOPR)(1:5).EQ.'MLTPV')) THEN
          IF(SOPRTP(ISOPR).EQ.'ANTISING') THEN
            CALL PRCMAT2(ISOPR,NSS,SOPRR,SOPRI)
          ENDIF
! prpr end
        ENDIF

#ifdef _HDF5_
        IF( SOPRNM(ISOPR)(1:6) .EQ.'ANGMOM') THEN
           Call mh5_put_dset(wfn_sos_angmomr,
     $                SOPRR,[NSS,NSS,1],[0,0,ISOCMP(ISOPR)-1])
           Call mh5_put_dset(wfn_sos_angmomi,
     $                SOPRI,[NSS,NSS,1],[0,0,ISOCMP(ISOPR)-1])
        ENDIF

        IF( (SOPRNM(ISOPR)(1:8) .EQ.'MLTPL  1').AND.
     &      (SOPRTP(ISOPR).EQ.'HERMSING') ) THEN
           Call mh5_put_dset(wfn_sos_edipmomr,
     $                SOPRR,[NSS,NSS,1],[0,0,ISOCMP(ISOPR)-1])
           Call mh5_put_dset(wfn_sos_edipmomi,
     $                SOPRI,[NSS,NSS,1],[0,0,ISOCMP(ISOPR)-1])
        ENDIF
#endif

       END DO
       Call mma_deallocate(SOPRR)
       Call mma_deallocate(SOPRI)
       Call CollapseOutput(0,'Matrix elements over SO states')
       WRITE(6,*)

      END IF

 300  CONTINUE

 400  CONTINUE

******************************************************
* printout of special properties
******************************************************

       ! AFACTOR = 2*pi*e^2*E_h^2 / eps_0*m_e*c^3*h^2
       ! numerically: 2/c^3 (in a.u. of time ^ -1)
       AFACTOR = 2.0D0/c_in_au**3/(auTofs*1.0D-15)

      IF (IPGLOB.GE.2) THEN
        WRITE(6,*)
        WRITE(6,*)
        WRITE(6,'(6X,A)') repeat('*',100)
        WRITE(6,'(6X,A,98X,A)') '*','*'
        WRITE(6,'(6X,A,34X,A,34X,A)')
     &       '*','  Special properties section  ','*'
        WRITE(6,'(6X,A,98X,A)') '*','*'
        WRITE(6,'(6X,A)') repeat('*',100)
        WRITE(6,*)
        WRITE(6,*)
      END IF

C Compute transition strengths for spin-orbit states:
      IF(.not.IFSO) GOTO 500
*
* Initial setup for both dipole, quadrupole etc. and exact operator
*
C printing threshold
!     IF(IPGLOB.eq.2) OSTHR=1.0D-8 ! first order
!     IF(IPGLOB.eq.2) OSTHR2=1.0D-12 ! second order (weaker)
!     IF(IPGLOB.gt.2) OSTHR=0.0D0
!     IF(IPGLOB.gt.2) OSTHR2=0.0D0
      OSTHR=1.0D-5
      OSTHR2=1.0D-5
      IF(DIPR) OSTHR = OSTHR_DIPR
      IF(DIPR) WRITE(6,30) 'Dipole printing threshold changed to ',OSTHR
! Again to avoid total negative transition strengths
      IF(QIPR) OSTHR = OSTHR_QIPR
      IF(QIPR) THEN
        WRITE(6,49)  'Printing threshold changed to ',OSTHR,
     &              'since quadrupole threshold is given '
      END IF
      IF(QIPR) OSTHR2 = OSTHR_QIPR
      IF(QIPR) THEN
      WRITE(6,30) 'Quadrupole printing threshold changed to ',OSTHR2
      END IF
      IF(QIALL) WRITE(6,*) ' Will write all quadrupole contributions '

! Rotatory strength threshold
      IF(RSPR) THEN
        WRITE(6,30) 'Rotatory strength printing threshold changed '//
     &             'to ',RSTHR
      ELSE
        RSTHR = 1.0D-07 !Default
      END IF
!
!     Reducing the loop over states - good for X-rays
!     At the moment memory is not reduced
!
      JEND = NSS
      IF(REDUCELOOP) THEN
        IEND = LOOPDIVIDE
        JSTART = LOOPDIVIDE+1
        IF(LOOPMAX.GT.0) JEND=MIN(NSS, LOOPDIVIDE + LOOPMAX)
      ELSE
        IEND = NSS
        JSTART = 1
      END IF
!
      IF (IPGLOB.GE.1) THEN
!
!     Initialize arrays for indentifying problematic transitions
!     These stores all dipole oscillator strengths in
!     length and velocity gauge for a later comparison.
!
      CALL mma_allocate(DL,NSS,NSS,Label='DL')
      CALL mma_allocate(DV,NSS,NSS,Label='DV')
      DL(:,:)=0.0D0
      DV(:,:)=0.0D0
      I_HAVE_DL = 0
      I_HAVE_DV = 0

*Electric-Dipole Electric-Dipole transitions


        If (Do_SK) Then
           nVec = nk_Vector
        Else
           nVec = 1
        End If
*
        Call Allocate_and_Load_electric_dipoles(IFANYD)

        IF(IFANYD.NE.0) THEN
*
           Do iVec = 1, nVec
*
         i_Print=0

         DO ISS=1,IEND
          DO JSS=JSTART,JEND
           EDIFF=ENSOR(JSS)-ENSOR(ISS)
           IF (ABS(EDIFF).LE.1.0D-8) CYCLE
           IF(EDIFF.GT.0.0D0) THEN
            T0(1)=CMPLX(DXR(JSS,ISS),DXI(JSS,ISS),kind=8)
            T0(2)=CMPLX(DYR(JSS,ISS),DYI(JSS,ISS),kind=8)
            T0(3)=CMPLX(DZR(JSS,ISS),DZI(JSS,ISS),kind=8)
            If (Do_SK) Then
               TM1=k_vector(1,iVec)*T0(1)+
     &             k_vector(2,iVec)*T0(2)+
     &             k_vector(3,iVec)*T0(3)
               T0(1) = T0(1) - TM1 * k_vector(1,iVec)
               T0(2) = T0(2) - TM1 * k_vector(2,iVec)
               T0(3) = T0(3) - TM1 * k_vector(3,iVec)
            End If
            DX2=ABS(CONJG(T0(1))*T0(1))
            DY2=ABS(CONJG(T0(2))*T0(2))
            DZ2=ABS(CONJG(T0(3))*T0(3))
            FX=Two3rds*EDIFF*(DX2)
            FY=Two3rds*EDIFF*(DY2)
            FZ=Two3rds*EDIFF*(DZ2)
            F =FX+FY+FZ
            AX=(AFACTOR*EDIFF**2)*FX
            AY=(AFACTOR*EDIFF**2)*FY
            AZ=(AFACTOR*EDIFF**2)*FZ
            A =(AFACTOR*EDIFF**2)*F
! Store dipole oscillator strength
            DL(JSS,ISS) = F
            IF(ABS(F).GE.OSTHR) THEN
              If (i_Print.eq.0) Then
                 i_Print=1

! Print full COMPLEX transition dipole moment vectors?
! J. Norell 7/5 2020
         IF(PRDIPCOM) THEN

          Call CollapseOutput(1,
     & 'Complex transition dipole vectors (SO states):')
          WRITE(6,'(3X,A)') '----------------------------------------'
          IF(OSTHR.GT.0.0D0) THEN
           WRITE(6,30)'   for osc. strength at least ',OSTHR
           WRITE(6,*)
          END IF
          WRITE(6,*) '     From   To',
     &'       Re(Dx)       Im(Dx)',
     &'       Re(Dy)       Im(Dy)',
     &'       Re(Dz)       Im(Dz)'
          WRITE(6,32)
          GOTO 137 ! Skip past "regular" print
         END IF
! END print COMPLEX vectors

         Call CollapseOutput(1,
     &                     'Dipole transition strengths (SO states):')
         WRITE(6,'(3X,A)') '----------------------------------------'
         IF(OSTHR.GT.0.0D0) THEN
          WRITE(6,30)'   for osc. strength at least ',OSTHR
          WRITE(6,*)
         END IF
         If (Do_SK) Then
            WRITE(6,*)
            WRITE(6,'(4x,a,3F10.6,a)')
     &            'Direction of the k-vector: ',
     &             (k_vector(k,iVec),k=1,3),' (a.u.)'
            WRITE(6,'(4x,a)')
     &            'The light is assumed to be unpolarized.'
            WRITE(6,*)
         End If
         WRITE(6,31) 'From','To','Osc. strength',
     &               'Einstein coefficients Ax, Ay, Az (sec-1)   ',
     &               'Total A (sec-1)'
         WRITE(6,32)
               End If

! Print full COMPLEX transition dipole moment vectors?
137      IF(PRDIPCOM) THEN
             WRITE(6,'(5X,I5,I5,A,A,ES12.3,A,ES12.3,A,ES12.3,A,ES12.3,A,
     &       ES12.3,A,ES12.3)')
     &       ISS,JSS,'   ',
     &       ' ',REAL(T0(1)),' ',AIMAG(T0(1)),
     &       ' ',REAL(T0(2)),' ',AIMAG(T0(2)),
     &       ' ',REAL(T0(3)),' ',AIMAG(T0(3))
        ELSE
             WRITE(6,33) ISS,JSS,F,AX,AY,AZ,A ! "Regular" print instead
         END IF
! END print COMPLEX vectors

            END IF
            Call Add_Info('TMS(SO,Len)',[F],1,6)
            IF(PRDIPCOM) Call Add_Info('TVC(SO,Len)',[DX2+DY2+DZ2],1,6)

           END IF
          END DO
         END DO

         If (i_Print.eq.1) THEN
           WRITE(6,32)
           Call CollapseOutput(0,
     &                     'Dipole transition strengths (SO states):')
           WRITE(6,*)
         END IF
*
         End Do ! iVec
*
         I_HAVE_DL = 1
        END IF

        Call Deallocate_electric_dipoles()

*       Now the same in velocity representation

*
        If (Do_SK) Then
           nVec = nk_Vector
        Else
           nVec = 1
        End If
*
        Call Allocate_and_Load_velocities(IFANYD)

        IF(IFANYD.NE.0) THEN
*
        Do iVec = 1, nVec
*
         i_Print=0

         DO ISS=1,IEND
          DO JSS=JSTART,JEND
           EDIFF=ENSOR(JSS)-ENSOR(ISS)
           IF (ABS(EDIFF).LE.1.0D-8) CYCLE
           IF(EDIFF.GT.0.0D0) THEN
            T0(1)=CMPLX(DXR(JSS,ISS),DXI(JSS,ISS),kind=8)
            T0(2)=CMPLX(DYR(JSS,ISS),DYI(JSS,ISS),kind=8)
            T0(3)=CMPLX(DZR(JSS,ISS),DZI(JSS,ISS),kind=8)
            If (Do_SK) Then
               TM1=k_vector(1,iVec)*T0(1)+
     &             k_vector(2,iVec)*T0(2)+
     &             k_vector(3,iVec)*T0(3)
               T0(1) = T0(1) - TM1 * k_vector(1,iVec)
               T0(2) = T0(2) - TM1 * k_vector(2,iVec)
               T0(3) = T0(3) - TM1 * k_vector(3,iVec)
            End If
            DX2=ABS(CONJG(T0(1))*T0(1))
            DY2=ABS(CONJG(T0(2))*T0(2))
            DZ2=ABS(CONJG(T0(3))*T0(3))
            FX=Two3rds*(DX2)/EDIFF
            FY=Two3rds*(DY2)/EDIFF
            FZ=Two3rds*(DZ2)/EDIFF
            F =FX+FY+FZ
            AX=(AFACTOR*EDIFF**2)*FX
            AY=(AFACTOR*EDIFF**2)*FY
            AZ=(AFACTOR*EDIFF**2)*FZ
            A =(AFACTOR*EDIFF**2)*F
! Store dipole oscillator strength
            DV(JSS,ISS) = F
            IF(ABS(F).GE.OSTHR) THEN
              If (i_Print.eq.0) Then
                 i_Print=1
         Call CollapseOutput(1,
     &                     'Velocity transition strengths (SO states):')
         WRITE(6,'(3X,A)') '------------------------------------------'
         IF(OSTHR.GT.0.0D0) THEN
          WRITE(6,30)'   for osc. strength at least ',OSTHR
          WRITE(6,*)
         END IF
         If (Do_SK) Then
            WRITE(6,*)
            WRITE(6,'(4x,a,3F10.6,a)')
     &            'Direction of the k-vector: ',
     &             (k_vector(k,iVec),k=1,3),' (a.u.)'
            WRITE(6,'(4x,a)')
     &            'The light is assumed to be unpolarized.'
            WRITE(6,*)
         End If
         WRITE(6,31) 'From','To','Osc. strength',
     &               'Einstein coefficients Ax, Ay, Az (sec-1)   ',
     &               'Total A (sec-1)'
         WRITE(6,32)
               END IF
             WRITE(6,33) ISS,JSS,F,AX,AY,AZ,A
            END IF
            Call Add_Info('TMS(SO,Vel)',[F],1,6)
           END IF
          END DO
         END DO

         If (i_Print.eq.1) THEN
           WRITE(6,32)
           Call CollapseOutput(0,
     &                     'Velocity transition strengths (SO states):')
           WRITE(6,*)
         END IF
*
         End Do ! iVec
*
         I_HAVE_DV = 1
        END IF

        Call Deallocate_electric_dipoles()

!
!      Compare oscillator strengths in length and velocity gauge
!      All differences in oscillator strengths above the tolerance
!      of 0.1 (10 percent) will be printed.
!
       IF(I_HAVE_DL.EQ.1.AND.I_HAVE_DV.EQ.1) THEN
         CALL CollapseOutput(1,'Length and velocity gauge comparison '//
     &                         '(SO states):')
!
! I guess that I have to explain it when I print a warning
!
         WRITE(6,*)
         WRITE(6,*) "--------------------------------------------------"
         WRITE(6,*) "A comparison between the dipole oscillator "//
     &              "strengths in "
         WRITE(6,*) "length and velocity gauge "//
     &              "will be performed"
         WRITE(6,*)
         WRITE(6,49) "All dipole oscillator differences above the "//
     &              "tolerance of ",TOLERANCE," will be printed "
         WRITE(6,*)
         WRITE(6,*) "Due to basis set deficiency these oscillator "//
     &              "may be problematic "
         WRITE(6,*)
         WRITE(6,*) "The tolerance is defined as ABS(1-O_l/O_v) "
         WRITE(6,*) "O_l : dipole oscillator strength in length gauge"
         WRITE(6,*) "O_p : dipole oscillator strength in velocity gauge"
         WRITE(6,*) "--------------------------------------------------"
!
          I_PRINT_HEADER = 0
          DO I=1,IEND
            DO J=JSTART,JEND
               EDIFF=ENSOR(J)-ENSOR(I)
               IF(EDIFF.LT.0.0D0) CYCLE
             COMPARE=0.0D0
             dlt=1.0D-18 ! Add small value to avoid zero divide.
             IF(DL(J,I).GE.OSTHR+dlt .AND.
     &          DV(J,I).GE.OSTHR+dlt) THEN
               COMPARE = ABS(1-DL(J,I)/DV(J,I))
             ELSE IF((DL(J,I).GE.OSTHR+dlt).AND.
     &               (DL(J,I).GT.0.0D0)) THEN
               COMPARE = -1.5D0
             ELSE IF((DV(J,I).GE.OSTHR+dlt).AND.
     &               (DV(J,I).GT.0.0D0)) THEN
               COMPARE = -2.5D0
             END IF
             IF(ABS(COMPARE).GE.TOLERANCE) THEN
               I_PRINT_HEADER = I_PRINT_HEADER + 1
               IF(I_PRINT_HEADER.EQ.1) THEN
                 WRITE(6,*)
                 WRITE(6,*) " Problematic transitions have been found"
                 WRITE(6,*)
                 WRITE(6,39) "From","To","Difference (%)",
     &                       "Osc. st. (len.)","Osc. st. (vel.)"
                 WRITE(6,40)
               END IF
               IF (COMPARE.GE.0.0D0) THEN
                 WRITE(6,38) I,J,COMPARE*100D0,
     &                    DL(J,I),DV(J,I)
               ELSE IF (COMPARE.GE.-2.0D0) THEN
                 WRITE(6,36) I,J,DL(J,I),"below threshold"
               ELSE
                 WRITE(6,37) I,J,"below threshold",DV(J,I)
               END IF
             END IF
            END DO
          END DO
          IF(I_PRINT_HEADER.EQ.0) THEN
            WRITE(6,*)
            WRITE(6,*) "No problematic oscillator strengths above "//
     &                 "the tolerance ", TOLERANCE," have been found"
            WRITE(6,*)
          ELSE
            WRITE(6,40)
            WRITE(6,*)
            WRITE(6,*) "Number of problematic transitions = ",
     &                  I_PRINT_HEADER
            WRITE(6,*)
          END IF
         CALL CollapseOutput(0,'Length and velocity gauge comparison '//
     &                         '(SO states):')
         WRITE(6,*)
        END IF
*
* Free the memory
*
      CALL mma_deallocate(DL)
      CALL mma_deallocate(DV)
!
! We will first allocate a matrix for the total of the second order wave vector
!
        CALL mma_allocate(TOT2K,NSS,NSS,Label='TOT2K')
        TOT2K(:,:)=0.0D0
!
! Checking if all are in
        SECORD = 0

* Magnetic-Dipole - Magnetic-Dipole transitions and
* Spin-Magnetic-Dipole - Spin-Magnetic-Dipole transitions
!
! I will not separate these for SO states since there would then be
! M^2 + Ms^2 + 2*MMs (three terms to be programmed)
! M^2 and Ms^2 can be calculated separately but the cross term not directly
!
! Magnetic-Dipole
        Call Allocate_and_Load_Magnetic_Dipoles(IFANYM)
! Spin-Magnetic-Dipole ---- notice the S
        Call Allocate_and_Load_Spin_Magnetic_dipoles(IFANYS)

        IF(IFANYM.NE.0.OR.IFANYS.NE.0) THEN
!
! Only print the part calculated
!
         IF(QIALL) THEN
         IF(IFANYM.NE.0.AND.IFANYS.NE.0) THEN
          Call CollapseOutput(1,
     &                  'Magnetic-dipole - magnetic-dipole and '//
     &                  'spin-magnetic-dipole - spin-magnetic-dipole '//
     &                  'transition strengths (SO states):')
          WRITE(6,'(3X,A)')
     &                  '--------------------------------------'//
     &                  '--------------------------------------------'//
     &                  '---------------------------------'
         ELSE IF(IFANYM.NE.0.AND.IFANYS.EQ.0) THEN
          Call CollapseOutput(1,
     &                  'Magnetic-dipole - magnetic-dipole '//
     &                  'transition strengths (SO states):')
          WRITE(6,'(3X,A)')
     &                  '----------------------------------'//
     &                  '---------------------------------'
         ELSE IF(IFANYM.EQ.0.AND.IFANYS.NE.0) THEN
          Call CollapseOutput(1,
     &                  'Spin-magnetic-dipole - spin-magnetic-dipole '//
     &                  'transition strengths (SO states):')
          WRITE(6,'(3X,A)')
     &                  '--------------------------------------------'//
     &                  '---------------------------------'
         END IF
         IF(OSTHR2.GT.0.0D0) THEN
          WRITE(6,30)'   for osc. strength at least ',OSTHR2
          WRITE(6,*)
         END IF
         WRITE(6,31) 'From','To','Osc. strength'
         WRITE(6,35)
         END IF


! Magnetic-Dipole

! Spin-Magnetic-Dipole

         g = FEGVAL
         DO ISS=1,IEND
          DO JSS=JSTART,NSS
           EDIFF=ENSOR(JSS)-ENSOR(ISS)
           IF (ABS(EDIFF)<1.0D-8) Cycle
           IF(EDIFF.GT.0.0D0) THEN

            DX2=(MDXI(JSS,ISS)+g*SXR(JSS,ISS))**2
     &         +(MDXR(JSS,ISS)-g*SXI(JSS,ISS))**2
            DY2=(MDYI(JSS,ISS)+g*SYR(JSS,ISS))**2
     &         +(MDYR(JSS,ISS)-g*SYI(JSS,ISS))**2
            DZ2=(MDZI(JSS,ISS)+g*SZR(JSS,ISS))**2
     &         +(MDZR(JSS,ISS)-g*SZI(JSS,ISS))**2

            F = (DX2 + DY2 + DZ2)*EDIFF*ONEOVER6C2
! Add it to the total
            TOT2K(JSS,ISS) = TOT2K(JSS,ISS) + F
            IF(ABS(F).GE.OSTHR2) THEN
             IF(QIALL) WRITE(6,33) ISS,JSS,F
            END IF
           END IF
          END DO
         END DO

       IF(QIALL) THEN
         WRITE(6,35)
         IF(IFANYM.NE.0.AND.IFANYS.NE.0) THEN
          Call CollapseOutput(0,
     &                  'Magnetic-dipole - magnetic-dipole and '//
     &                  'spin-magnetic-dipole - spin-magnetic-dipole '//
     &                  'transition strengths (SO states):')
          WRITE(6,*)
         ELSE IF(IFANYM.NE.0.AND.IFANYS.EQ.0) THEN
          Call CollapseOutput(0,
     &                  'Magnetic-dipole - magnetic-dipole '//
     &                  'transition strengths (SO states):')
          WRITE(6,*)
         ELSE IF(IFANYM.EQ.0.AND.IFANYS.NE.0) THEN
          Call CollapseOutput(0,
     &                  'Spin-magnetic-dipole - Spin-magnetic-dipole '//
     &                  'transition strengths (SO states):')
          WRITE(6,*)
         END IF
        END IF
        SECORD(1) = 1
        END IF

! Magnetic-Dipole
        Call Deallocate_Magnetic_dipoles()

! Spin-Magnetic-Dipole
        Call Deallocate_Spin_Magnetic_dipoles()

*Electric-Quadrupole Electric-Quadrupole transitions

        Call Allocate_and_Load_Electric_Quadrupoles(IFANYQ)

        IF(IFANYQ.NE.0) THEN
        IF(QIALL) THEN
         Call CollapseOutput(1,
     &                 'Quadrupole transition strengths (SO states):')
         WRITE(6,'(3X,A)')
     &                 '--------------------------------------------'
         IF(OSTHR2.GT.0.0D0) THEN
          WRITE(6,30)'   for osc. strength at least ',OSTHR2
          WRITE(6,*)
         END IF
         WRITE(6,31) 'From','To','Osc. strength'
         WRITE(6,35)
         END IF


         DO ISS=1,IEND
          DO JSS=JSTART,NSS
           EDIFF=ENSOR(JSS)-ENSOR(ISS)
           IF (ABS(EDIFF)<1.0D-8) Cycle
           IF(EDIFF.GT.0.0D0) THEN
!
! D should be purely real since D is a real symmetric matrix
!
            EDIFF3=EDIFF**3

            DXX2=QXXR(JSS,ISS)**2+QXXI(JSS,ISS)**2
            DYY2=QYYR(JSS,ISS)**2+QYYI(JSS,ISS)**2
            DZZ2=QZZR(JSS,ISS)**2+QZZI(JSS,ISS)**2
            FXX=ONEOVER30C*EDIFF3*(DXX2)
            FYY=ONEOVER30C*EDIFF3*(DYY2)
            FZZ=ONEOVER30C*EDIFF3*(DZZ2)

            DXY2=QXYR(JSS,ISS)**2+QXYI(JSS,ISS)**2
            DXZ2=QXZR(JSS,ISS)**2+QXZI(JSS,ISS)**2
            DYZ2=QYZR(JSS,ISS)**2+QYZI(JSS,ISS)**2
            FXY=ONEOVER10C*EDIFF3*(DXY2)
            FXZ=ONEOVER10C*EDIFF3*(DXZ2)
            FYZ=ONEOVER10C*EDIFF3*(DYZ2)

            DXXDYY=QXXR(JSS,ISS)*QYYR(JSS,ISS)
     &            +QXXI(JSS,ISS)*QYYI(JSS,ISS)
            DXXDZZ=QXXR(JSS,ISS)*QZZR(JSS,ISS)
     &            +QXXI(JSS,ISS)*QZZI(JSS,ISS)
            DYYDZZ=QYYR(JSS,ISS)*QZZR(JSS,ISS)
     &            +QYYI(JSS,ISS)*QZZI(JSS,ISS)
            FXXFYY=-ONEOVER30C*EDIFF3*(DXXDYY)
            FXXFZZ=-ONEOVER30C*EDIFF3*(DXXDZZ)
            FYYFZZ=-ONEOVER30C*EDIFF3*(DYYDZZ)

            F =FXX+FXY+FXZ+FYY+FYZ+FZZ+FXXFYY+FXXFZZ+FYYFZZ
! Add it to the total
            TOT2K(JSS,ISS) = TOT2K(JSS,ISS) + F

            IF(ABS(F).GE.OSTHR2) THEN
             IF(QIALL) WRITE(6,33) ISS,JSS,F
            END IF
           END IF
          END DO
         END DO

        IF(QIALL) THEN
         WRITE(6,35)
         Call CollapseOutput(0,
     &                 'Quadrupole transition strengths (SO states):')
         WRITE(6,*)
        END IF
        SECORD(2) = 1
        END IF

        Call Deallocate_Electric_Quadrupoles()

*Electric-Dipole Electric-Octupole transitions

! Octupole
         Call Allocate_and_Load_Octupoles(IFANYO)
! Dipole
         Call Allocate_and_Load_electric_dipoles(IFANYD)

        IF(IFANYD.NE.0.AND.IFANYO.NE.0) THEN
        IF(QIALL) THEN
         Call CollapseOutput(1,
     &                     'Electric-dipole - electric-octupole '//
     &                     'transition strengths (SO states):')
         WRITE(6,'(3X,A)') '------------------------------------'//
     &                     '---------------------------------'
         IF(OSTHR2.GT.0.0D0) THEN
          WRITE(6,30)'   for osc. strength at least ',OSTHR2
          WRITE(6,*)
         END IF
         WRITE(6,31) 'From','To','Osc. strength'
         WRITE(6,35)
         END IF

         DO ISS=1,IEND
          DO JSS=JSTART,NSS
           EDIFF=ENSOR(JSS)-ENSOR(ISS)
           IF (ABS(EDIFF)<1.0D-8) Cycle
           IF(EDIFF.GT.0.0D0) THEN
!
            EDIFF3=EDIFF**3

            DXXXDX=DXXXR(JSS,ISS)*DXR(JSS,ISS)
     &            +DXXXI(JSS,ISS)*DXI(JSS,ISS)
            DYYXDX=DYYXR(JSS,ISS)*DXR(JSS,ISS)
     &            +DYYXI(JSS,ISS)*DXI(JSS,ISS)
            DZZXDX=DZZXR(JSS,ISS)*DXR(JSS,ISS)
     &            +DZZXI(JSS,ISS)*DXI(JSS,ISS)
            FXXX=TWOOVERM45C*EDIFF3*(DXXXDX)
            FYYX=TWOOVERM45C*EDIFF3*(DYYXDX)
            FZZX=TWOOVERM45C*EDIFF3*(DZZXDX)

            DXXYDY=DXXYR(JSS,ISS)*DYR(JSS,ISS)
     &            +DXXYI(JSS,ISS)*DYI(JSS,ISS)
            DYYYDY=DYYYR(JSS,ISS)*DYR(JSS,ISS)
     &            +DYYYI(JSS,ISS)*DYI(JSS,ISS)
            DZZYDY=DZZYR(JSS,ISS)*DYR(JSS,ISS)
     &            +DZZYI(JSS,ISS)*DYI(JSS,ISS)
            FXXY=TWOOVERM45C*EDIFF3*(DXXYDY)
            FYYY=TWOOVERM45C*EDIFF3*(DYYYDY)
            FZZY=TWOOVERM45C*EDIFF3*(DZZYDY)

            DXXZDZ=DXXZR(JSS,ISS)*DZR(JSS,ISS)
     &            +DXXZI(JSS,ISS)*DZI(JSS,ISS)
            DYYZDZ=DYYZR(JSS,ISS)*DZR(JSS,ISS)
     &            +DYYZI(JSS,ISS)*DZI(JSS,ISS)
            DZZZDZ=DZZZR(JSS,ISS)*DZR(JSS,ISS)
     &            +DZZZI(JSS,ISS)*DZI(JSS,ISS)
            FXXZ=TWOOVERM45C*EDIFF3*(DXXZDZ)
            FYYZ=TWOOVERM45C*EDIFF3*(DYYZDZ)
            FZZZ=TWOOVERM45C*EDIFF3*(DZZZDZ)

            F =FXXX+FYYX+FZZX+FXXY+FYYY+FZZY+FXXZ+FYYZ+FZZZ
! Add it to the total
            TOT2K(JSS,ISS) = TOT2K(JSS,ISS) + F

            IF(ABS(F).GE.OSTHR2) THEN
             IF(QIALL) WRITE(6,33) ISS,JSS,F
            END IF
           END IF
          END DO
         END DO

        IF(QIALL) THEN
         WRITE(6,35)
         Call CollapseOutput(0,
     &                     'Electric-dipole - electric-octupole '//
     &                     'transition strengths (SO states):')
         WRITE(6,*)
        END IF
        SECORD(3) = 1
        END IF

        Call Deallocate_Octupoles()

        Call Deallocate_electric_dipoles()

*Electric-Dipole - Magnetic-Quadrupole transitions and
*Electric-Dipole - Spin-Magnetic-Quadrupole transitions
!
! Again I will just include the spin-term so both terms are calculated
! (Can also be done separately)
! DM + DMs
!
! Magnetic-Quadrupole
! Spin-Magnetic-Quadrupole
! Spin-Magnetic-Quadrupole = M^s_ab = r_b * s_a

! Electric-Dipole
        Call Allocate_and_Load_electric_dipoles(IFANYD)
        IF(IFANYD.NE.0) THEN
! Magnetic-Quadrupole
        Call Allocate_and_Load_Magnetic_Quadrupoles(IFANYD)
! Spin-Magnetic-Quadrupole
        Call Allocate_and_Load_Spin_Magnetic_Quadrupoles(IFANYS)

        IF(IFANYD.NE.0.OR.IFANYS.NE.0) THEN
        IF(QIALL) THEN
         IF(IFANYD.NE.0.AND.IFANYS.NE.0) THEN
          Call CollapseOutput(1,
     &                  'Electric-dipole - magnetic-quadrupole and '//
     &                  'electric-dipole - spin-magnetic-quadrupole '//
     &                  'transition strengths (SO states):')
          WRITE(6,'(3X,A)')
     &                  '------------------------------------------'//
     &                  '-------------------------------------------'//
     &                  '---------------------------------'
         ELSE IF(IFANYD.NE.0.AND.IFANYS.EQ.0) THEN
          Call CollapseOutput(1,
     &                  'Electric-dipole - magnetic-quadrupole '//
     &                  'transition strengths (SO states):')
          WRITE(6,'(3X,A)')
     &                  '--------------------------------------'//
     &                  '---------------------------------'
         ELSE IF(IFANYD.EQ.0.AND.IFANYS.NE.0) THEN
          Call CollapseOutput(1,
     &                  'Electric-dipole - spin-magnetic-quadrupole '//
     &                  'transition strengths (SO states):')
          WRITE(6,'(3X,A)')
     &                  '-------------------------------------------'//
     &                  '---------------------------------'
         END IF

         IF(OSTHR2.GT.0.0D0) THEN
          WRITE(6,30)'   for osc. strength at least ',OSTHR2
          WRITE(6,*)
         END IF
         WRITE(6,31) 'From','To','Osc. strength'
         WRITE(6,35)
         END IF

         g = FEGVAL*Three/Two ! To remove the 2/3 factor in ONEOVER9C2
         g = g*2.0d0 ! Seem to be needed to agree with the exact term,
                     ! needs to be looked further into!
         DO ISS=1,IEND
          DO JSS=JSTART,NSS
           EDIFF=ENSOR(JSS)-ENSOR(ISS)
           IF (ABS(EDIFF)<1.0D-8) Cycle
           IF(EDIFF.GT.0.0D0) THEN
!
            EDIFF2=EDIFF**2
!
! Since the Spin-Magnetic-Quadrupole is made from the multiplication of two complex integrals we have
! M^s = (a+ib)(c+id) = ac-bd + i(ad+bc) hence the long expressions below
! Also, since the magnetic quadrupole terms are real and the electric dipole are imaginary
! we multiply the real components of MQ with the imaginary of the dipole term, and vice versa.
! However, the spin y component is imaginary
!
!                  Magnetic-Quadrupole   Spin-Magnetic-Quadrupole
!                  Electric-Dipole
            DXYDZ=-((MQXYI(JSS,ISS) + g*SXYI(JSS,ISS)) * DZI(JSS,ISS))
     &           +(( MQXYR(JSS,ISS) + g*SXYR(JSS,ISS)) * DZR(JSS,ISS))
            DYXDZ=-((MQYXI(JSS,ISS) + g*SYXR(JSS,ISS)) * DZI(JSS,ISS))
     &           +(( MQYXR(JSS,ISS) + g*SYXI(JSS,ISS)) * DZR(JSS,ISS))
            FXY=ONEOVER9C2*EDIFF2*(DXYDZ)
            FYX=-ONEOVER9C2*EDIFF2*(DYXDZ)

            DZXDY=-((MQZXI(JSS,ISS) + g*SZXR(JSS,ISS)) * DYI(JSS,ISS))
     &            +((MQZXR(JSS,ISS) + g*SZXI(JSS,ISS)) * DYR(JSS,ISS))
            DXZDY=-((MQXZI(JSS,ISS) + g*SXZR(JSS,ISS)) * DYI(JSS,ISS))
     &            +((MQXZR(JSS,ISS) + g*SXZI(JSS,ISS)) * DYR(JSS,ISS))
            FZX=ONEOVER9C2*EDIFF2*(DZXDY)
            FXZ=-ONEOVER9C2*EDIFF2*(DXZDY)

            DYZDX=-((MQYZI(JSS,ISS) + g*SYZR(JSS,ISS)) * DXI(JSS,ISS))
     &            +((MQYZR(JSS,ISS) + g*SYZI(JSS,ISS)) * DXR(JSS,ISS))
            DZYDX=-((MQZYI(JSS,ISS) + g*SZYI(JSS,ISS)) * DXI(JSS,ISS))
     &           + ((MQZYR(JSS,ISS) + g*SZYR(JSS,ISS)) * DXR(JSS,ISS))
            FYZ=ONEOVER9C2*EDIFF2*(DYZDX)
            FZY=-ONEOVER9C2*EDIFF2*(DZYDX)

            F =FYX+FXY+FZX+FXZ+FYZ+FZY
! Add it to the total
            TOT2K(JSS,ISS) = TOT2K(JSS,ISS) + F

            IF(ABS(F).GE.OSTHR2) THEN
             IF(QIALL) WRITE(6,33) ISS,JSS,F
            END IF
           END IF
          END DO
         END DO

        IF(QIALL) THEN
         WRITE(6,35)
         IF(IFANYD.NE.0.AND.IFANYS.NE.0) THEN
          Call CollapseOutput(0,
     &                  'Electric-dipole - magnetic-quadrupole and '//
     &                  'electric-dipole - spin-magnetic-quadrupole '//
     &                  'transition strengths (SO states):')
         WRITE(6,*)
         ELSE IF(IFANYD.NE.0.AND.IFANYS.EQ.0) THEN
          Call CollapseOutput(0,
     &                  'Electric-dipole - magnetic-quadrupole '//
     &                  'transition strengths (SO states):')
         WRITE(6,*)
         ELSE IF(IFANYD.EQ.0.AND.IFANYS.NE.0) THEN
          Call CollapseOutput(0,
     &                  'Electric-dipole - spin-magnetic-quadrupole '//
     &                  'transition strengths (SO states):')
         WRITE(6,*)
         END IF
        END IF
        SECORD(4) = 1
        END IF

! Magnetic-Quadrupole
        Call Deallocate_Magnetic_Quadrupoles()
! Spin-Magnetic-Quadrupole
        Call Deallocate_Spin_Magnetic_Quadrupoles()
        END IF
! Electric-Dipole
        Call Deallocate_electric_dipoles()
!
! Now write out the total
!
! Add it to the total
!
      I2TOT = 0
      DO I = 1, 4
        IF(SECORD(I).EQ.1) THEN
          I2TOT = I2TOT + 1
        END IF
      END DO
       IF(I2TOT.GE.1) THEN
         IF(SECORD(1).EQ.0)
     &   WRITE(6,*) 'Magnetic-dipole - magnetic-dipole not included'
         IF(SECORD(2).EQ.0)
     &   WRITE(6,*) 'Electric-quadrupole - electric-quadrupole not '//
     &              'included'
         IF(SECORD(3).EQ.0)
     &   WRITE(6,*) 'Electric-dipole - electric-octupole not included'
         IF(SECORD(4).EQ.0)
     &   WRITE(6,*) 'Electric-dipole - magnetic-quadrupole not included'
         i_Print=0
         DO ISS=1,IEND
          DO JSS=JSTART,JEND
           EDIFF=ENSOR(JSS)-ENSOR(ISS)
           IF (ABS(EDIFF)<1.0D-8) Cycle
           IF(EDIFF.GT.0.0D0) THEN
!
            F = TOT2K(JSS,ISS)
            IF(ABS(F).GE.OSTHR2) THEN
             IF(i_Print.eq.0) THEN
              i_Print=1
              Call CollapseOutput(1,
     &                  'Second-order contribution to the '//
     &                  'transition strengths (SO states):')
              WRITE(6,'(3X,A)')
     &                  '---------------------------------'//
     &                  '---------------------------------'
!
              IF(OSTHR2.GT.0.0D0) THEN
               WRITE(6,30)'   for osc. strength at least ',OSTHR2
               WRITE(6,*)
              END IF
              WRITE(6,31) 'From','To','Osc. strength'
              WRITE(6,35)
             END IF
             WRITE(6,33) ISS,JSS,F
             Call Add_Info('TMS(SO,2nd)',[F],1,6)
            END IF
           END IF
          END DO
         END DO
         If (i_Print.eq.1) THEN
           WRITE(6,35)
           Call CollapseOutput(0,
     &                  'Second-order contribution to the '//
     &                  'transition strengths (SO states):')
           WRITE(6,*)
         END IF
       END IF
! release the memory again
       CALL mma_deallocate(TOT2K)

      END IF
!
!
      IF(DOCD) THEN
* Lasse 2019
* New CD here with electric dipole and magnetic-dipole - velocity gauge


! Electric dipole (linear momentum, p)
        Call Allocate_and_Load_velocities(IFANYD)

! Magnetic-Dipole (angular momentum, l = r x p)
        Call Allocate_and_Load_Magnetic_Dipoles(IFANYM)

        IF((IFANYD.NE.0).AND.(IFANYM.NE.0)) THEN

! Spin-Magnetic-Dipole
         Call Allocate_and_Load_Spin_Magnetic_Dipoles(IFANYS)

! Electric quadrupole (r:p+p:r)

         Call Allocate_and_Load_Electric_Quadrupoles(IFANYQ)
!
! Only print the part calculated
!
         WRITE(6,*)
         Call CollapseOutput(1,
     &                 'Circular Dichroism - velocity gauge '//
     &                 'Electric-Dipole - Magnetic-Dipole '//
     &                 'rotatory strengths (SO states):')
         WRITE(6,'(3X,A)')
     &                 '------------------------------------'//
     &                 '----------------------------------'//
     &                 '-------------------------------'
         IF (DO_SK) THEN
           WRITE(6,30) 'For red. rot. strength at least',RSTHR
         ELSE
           WRITE(6,30) 'For isotropic red. rot. strength at least',RSTHR
         END IF
         WRITE(6,*)
*
         If (Do_SK.AND.(IFANYQ.NE.0)) Then
            nVec = nk_Vector
         Else
            nVec = 1
         End If
*
         Do iVec = 1, nVec
*
         If (Do_SK.AND.(IFANYQ.NE.0)) Then
            WRITE(6,*)
            WRITE(6,'(4x,a,3F10.6)')
     &         'Direction of the k-vector: ',
     &          (k_vector(k,iVec),k=1,3)
            WRITE(6,*)
            WRITE(6,31) 'From','To','Red. rot. str.'
         Else
            WRITE(6,31) 'From','To','Red. rot. str.'
            IF (IFANYQ.NE.0)
     &         WRITE(6,44) 'Rxx','Rxy','Rxz','Ryy','Ryz','Rzz'
         End If
         WRITE(6,35)
!
         g = FEGVAL
         DO ISS=1,IEND
          DO JSS=JSTART,JEND
           EDIFF=ENSOR(JSS)-ENSOR(ISS)
           IF (ABS(EDIFF)<1.0D-8) Cycle
           IF(EDIFF.GT.0.0D0) THEN

! These are all complex quantities, and their products are complex too,
! but eventually every piece will be:
!   <I|a|J> <J|b|I> + <I|b|J> <J|b|I>
! for a and b Hermitian operators, so it will be reduced to:
!   2*(Re(A_ij)*Re(B_ij)+Im(A_ij)*Im(B_ij))
! and the imaginary parts of the products can be ignored.

!           Note p = -i*hbar*nabla
            D_XR= DXI(JSS,ISS)
            D_YR= DYI(JSS,ISS)
            D_ZR= DZI(JSS,ISS)
            D_XI=-DXR(JSS,ISS)
            D_YI=-DYR(JSS,ISS)
            D_ZI=-DZR(JSS,ISS)
!           Note r x p = -i*hbar * (r x nabla)
            D_MXR= MDXI(JSS,ISS)+g*SXR(JSS,ISS)
            D_MYR= MDYI(JSS,ISS)+g*SYR(JSS,ISS)
            D_MZR= MDZI(JSS,ISS)+g*SZR(JSS,ISS)
            D_MXI=-MDXR(JSS,ISS)+g*SXI(JSS,ISS)
            D_MYI=-MDYR(JSS,ISS)+g*SYI(JSS,ISS)
            D_MZI=-MDZR(JSS,ISS)+g*SZI(JSS,ISS)

*           R = 1/3 tr(Rtensor)
            RXX=D_XR*D_MXR+D_XI*D_MXI
            RYY=D_YR*D_MYR+D_YI*D_MYI
            RZZ=D_ZR*D_MZR+D_ZI*D_MZI
            IF (ABS(EDIFF)>1.0D-8) THEN
               R = Half/EDIFF*AU2REDR*(RXX+RYY+RZZ)
            ELSE
               R = ZERO
            END IF
            WRITE(6,43) '1/3 Tr(RTensor): ',R
*
* Compute full rotatory strength tensor
* (see Hansen and Bak, 10.1021/jp001899+)
*
            IF (IFANYQ.NE.0) THEN
!            Note r:p+p:r = -i*hbar * (r:nabla+nabla:r)
             Q_XXR= QXXI(JSS,ISS)
             Q_XYR= QXYI(JSS,ISS)
             Q_XZR= QXZI(JSS,ISS)
             Q_YYR= QYYI(JSS,ISS)
             Q_YZR= QYZI(JSS,ISS)
             Q_ZZR= QZZI(JSS,ISS)
             Q_XXI=-QXXR(JSS,ISS)
             Q_XYI=-QXYR(JSS,ISS)
             Q_XZI=-QXZR(JSS,ISS)
             Q_YYI=-QYYR(JSS,ISS)
             Q_YZI=-QYZR(JSS,ISS)
             Q_ZZI=-QZZR(JSS,ISS)
             RXY=D_XR*D_MYR+D_XI*D_MYI
             RXZ=D_XR*D_MZR+D_XI*D_MZI
             RYX=D_YR*D_MXR+D_YI*D_MXI
             RYZ=D_YR*D_MZR+D_YI*D_MZI
             RZX=D_ZR*D_MXR+D_ZI*D_MXI
             RZY=D_ZR*D_MYR+D_ZI*D_MYI
             RXXY=Q_XXR*D_YR+Q_XXI*D_YI
             RXXZ=Q_XXR*D_ZR+Q_XXI*D_ZI
             RXYX=Q_XYR*D_XR+Q_XYI*D_XI
             RXYZ=Q_XYR*D_ZR+Q_XYI*D_ZI
             RXZX=Q_XZR*D_XR+Q_XZI*D_XI
             RXZY=Q_XZR*D_YR+Q_XZI*D_YI
             RXYY=Q_XYR*D_YR+Q_XYI*D_YI
             RYYX=Q_YYR*D_XR+Q_YYI*D_XI
             RYYZ=Q_YYR*D_ZR+Q_YYI*D_ZI
             RYZX=Q_YZR*D_XR+Q_YZI*D_XI
             RYZY=Q_YZR*D_YR+Q_YZI*D_YI
             RXZZ=Q_XZR*D_ZR+Q_XZI*D_ZI
             RYZZ=Q_YZR*D_ZR+Q_YZI*D_ZI
             RZZX=Q_ZZR*D_XR+Q_ZZI*D_XI
             RZZY=Q_ZZR*D_YR+Q_ZZI*D_YI
             ! xx, xy, xz, yy, yz, zz
             Rtensor(1) =  0.75D0 *(RYY+RZZ + (RXYZ-RXZY))
             Rtensor(2) = -0.375D0*(RXY+RYX + (RXXZ+RYZY-RXZX-RYYZ))
             Rtensor(3) = -0.375D0*(RXZ+RZX + (RXYX+RZZY-RXXY-RYZZ))
             Rtensor(4) =  0.75D0 *(RXX+RZZ + (RYZX-RXYZ))
             Rtensor(5) = -0.375D0*(RYZ+RZY + (RYYX+RXZZ-RXYY-RZZX))
             Rtensor(6) =  0.75D0 *(RXX+RYY + (RXZY-RYZX))
             If (ABS(EDIFF)>1.0D-8) Then
                CALL DSCAL_(6,AU2REDR/EDIFF,Rtensor,1)
             ELSE
                Rtensor(:)=ZERO
             END IF
             IF (Do_SK) THEN
              ! k^T R k
              R = k_vector(1,iVec)**2*Rtensor(1)+
     &            k_vector(2,iVec)**2*Rtensor(4)+
     &            k_vector(3,iVec)**2*Rtensor(6)+
     &            2.0D0*k_vector(1,iVec)*k_vector(2,iVec)*Rtensor(2)+
     &            2.0D0*k_vector(1,iVec)*k_vector(3,iVec)*Rtensor(3)+
     &            2.0D0*k_vector(2,iVec)*k_vector(3,iVec)*Rtensor(5)
             ELSE
                WRITE(6,43) 'tensor: ',Rtensor(:)
             END IF
            END IF
*
            IF (ABS(R).GT.RSTHR) THEN
              WRITE(6,33) ISS,JSS,R
            END IF
!
            Call Add_Info('CD_V(SO)',[R],1,6)
           END IF
          END DO
         END DO

         WRITE(6,35)
         End Do

         Call Deallocate_Spin_Magnetic_Dipoles()

         Call Deallocate_Electric_Quadrupoles()

         Call CollapseOutput(0,
     &                  'Circular Dichroism - velocity gauge '//
     &                  'Electric-Dipole - Magnetic-Dipole '//
     &                  'rotatory strengths (SO states):')
        END IF

        Call Deallocate_electric_dipoles()

        Call Deallocate_magnetic_dipoles()

* Lasse 2019
* New CD here with electric dipole and magnetic-dipole - mixed gauge

! Electric dipole (r)
        Call Allocate_and_Load_electric_dipoles(IFANYD)
! Magnetic-Dipole (angular momentum, l = r x p)
        Call Allocate_and_Load_Magnetic_dipoles(IFANYM)

        IF((IFANYD.NE.0).AND.(IFANYM.NE.0)) THEN

! Spin-Magnetic-Dipole
         Call Allocate_and_Load_Spin_Magnetic_Dipoles(IFANYS)

! Electric quadrupole (r:r)
         Call Allocate_and_Load_Electric_Quadrupoles(IFANYQ)
!
! Only print the part calculated
!
         WRITE(6,*)
         Call CollapseOutput(1,
     &                 'Circular Dichroism - mixed gauge '//
     &                 'Electric-Dipole - Magnetic-Dipole '//
     &                 'rotatory strengths (SO states):')
         WRITE(6,'(3X,A)')
     &                 '---------------------------------'//
     &                 '----------------------------------'//
     &                 '-------------------------------'
         WRITE(6,*)
         WRITE(6,*) ' WARNING WARNING WARNING !!! '
         WRITE(6,*)
         WRITE(6,*) ' Circular Dichroism in the mixed gauge '
         WRITE(6,*) ' is NOT origin independent - check your results '
         IF (DO_SK) THEN
           WRITE(6,30) 'For red. rot. strength at least',RSTHR
         ELSE
           WRITE(6,30) 'For isotropic red. rot. strength at least',RSTHR
         END IF
         WRITE(6,*)
*
         If (Do_SK.AND.(IFANYQ.NE.0)) Then
            nVec = nk_Vector
         Else
            nVec = 1
         End If
*
         Do iVec = 1, nVec
*
         If (Do_SK.AND.(IFANYQ.NE.0)) Then
            WRITE(6,*)
            WRITE(6,'(4x,a,3F10.6)')
     &         'Direction of the k-vector: ',
     &          (k_vector(k,iVec),k=1,3)
            WRITE(6,*)
            WRITE(6,31) 'From','To','Red. rot. str.'
         Else
            WRITE(6,31) 'From','To','Red. rot. str.'
            IF (IFANYQ.NE.0)
     &         WRITE(6,44) 'Rxx','Rxy','Rxz','Ryy','Ryz','Rzz'
         End If
         WRITE(6,35)
!
         g = FEGVAL
         DO ISS=1,IEND
          DO JSS=JSTART,JEND
           EDIFF=ENSOR(JSS)-ENSOR(ISS)
           IF (ABS(EDIFF)<1.0D-8) Cycle
           IF(EDIFF.GT.0.0D0) THEN

! These are all complex quantities, and their products are complex too,
! but eventually every piece will be:
!   <I|a|J> <J|b|I> + <I|b|J> <J|b|I>
! for a and b Hermitian operators, so it will be reduced to:
!   2*(Re(A_ij)*Re(B_ij)+Im(A_ij)*Im(B_ij))
! and the imaginary parts of the products can be ignored.

            D_XR=DXR(JSS,ISS)
            D_YR=DYR(JSS,ISS)
            D_ZR=DZR(JSS,ISS)
            D_XI=DXI(JSS,ISS)
            D_YI=DYI(JSS,ISS)
            D_ZI=DZI(JSS,ISS)
!           Note r x p = -i*hbar * (r x nabla),
!           but we will need i * (r x p) = hbar * r x nabla
            D_MXI=MDXI(JSS,ISS)+g*SXR(JSS,ISS)
            D_MYI=MDYI(JSS,ISS)+g*SYR(JSS,ISS)
            D_MZI=MDZI(JSS,ISS)+g*SZR(JSS,ISS)
            D_MXR=MDXR(JSS,ISS)+g*SXI(JSS,ISS)
            D_MYR=MDYR(JSS,ISS)+g*SYI(JSS,ISS)
            D_MZR=MDZR(JSS,ISS)+g*SZI(JSS,ISS)

*           R = 1/3 tr(Rtensor)
            RXX=D_XR*D_MXR+D_XI*D_MXI
            RYY=D_YR*D_MYR+D_YI*D_MYI
            RZZ=D_ZR*D_MZR+D_ZI*D_MZI
            R = Half*AU2REDR*(RXX+RYY+RZZ)
*
* Compute full rotatory strength tensor
* (see Hansen and Bak, 10.1021/jp001899+)
*
            IF (IFANYQ.NE.0) THEN
             Q_XXR=QXXR(JSS,ISS)
             Q_XYR=QXYR(JSS,ISS)
             Q_XZR=QXZR(JSS,ISS)
             Q_YYR=QYYR(JSS,ISS)
             Q_YZR=QYZR(JSS,ISS)
             Q_ZZR=QZZR(JSS,ISS)
             Q_XXI=QXXI(JSS,ISS)
             Q_XYI=QXYI(JSS,ISS)
             Q_XZI=QXZI(JSS,ISS)
             Q_YYI=QYYI(JSS,ISS)
             Q_YZI=QYZI(JSS,ISS)
             Q_ZZI=QZZI(JSS,ISS)
             RXY=D_XR*D_MYR+D_XI*D_MYI
             RXZ=D_XR*D_MZR+D_XI*D_MZI
             RYX=D_YR*D_MXR+D_YI*D_MXI
             RYZ=D_YR*D_MZR+D_YI*D_MZI
             RZX=D_ZR*D_MXR+D_ZI*D_MXI
             RZY=D_ZR*D_MYR+D_ZI*D_MYI
             RXXY=Q_XXR*D_YR+Q_XXI*D_YI
             RXXZ=Q_XXR*D_ZR+Q_XXI*D_ZI
             RXYX=Q_XYR*D_XR+Q_XYI*D_XI
             RXYZ=Q_XYR*D_ZR+Q_XYI*D_ZI
             RXZX=Q_XZR*D_XR+Q_XZI*D_XI
             RXZY=Q_XZR*D_YR+Q_XZI*D_YI
             RXYY=Q_XYR*D_YR+Q_XYI*D_YI
             RYYX=Q_YYR*D_XR+Q_YYI*D_XI
             RYYZ=Q_YYR*D_ZR+Q_YYI*D_ZI
             RYZX=Q_YZR*D_XR+Q_YZI*D_XI
             RYZY=Q_YZR*D_YR+Q_YZI*D_YI
             RXZZ=Q_XZR*D_ZR+Q_XZI*D_ZI
             RYZZ=Q_YZR*D_ZR+Q_YZI*D_ZI
             RZZX=Q_ZZR*D_XR+Q_ZZI*D_XI
             RZZY=Q_ZZR*D_YR+Q_ZZI*D_YI
             ! xx, xy, xz, yy, yz, zz
             Rtensor(1) =  0.75D0 *(RYY+RZZ+EDIFF*(RXYZ-RXZY))
             Rtensor(2) = -0.375D0*(RXY+RYX+EDIFF*(RXXZ+RYZY-RXZX-RYYZ))
             Rtensor(3) = -0.375D0*(RXZ+RZX+EDIFF*(RXYX+RZZY-RXXY-RYZZ))
             Rtensor(4) =  0.75D0 *(RXX+RZZ+EDIFF*(RYZX-RXYZ))
             Rtensor(5) = -0.375D0*(RYZ+RZY+EDIFF*(RYYX+RXZZ-RXYY-RZZX))
             Rtensor(6) =  0.75D0 *(RXX+RYY+EDIFF*(RXZY-RYZX))
             CALL DSCAL_(6,AU2REDR,Rtensor,1)
             IF (Do_SK) THEN
              ! k^T R k
              R = k_vector(1,iVec)**2*Rtensor(1)+
     &            k_vector(2,iVec)**2*Rtensor(4)+
     &            k_vector(3,iVec)**2*Rtensor(6)+
     &            2.0D0*k_vector(1,iVec)*k_vector(2,iVec)*Rtensor(2)+
     &            2.0D0*k_vector(1,iVec)*k_vector(3,iVec)*Rtensor(3)+
     &            2.0D0*k_vector(2,iVec)*k_vector(3,iVec)*Rtensor(5)
             ELSE
                WRITE(6,43) 'tensor: ',Rtensor(:)
             END IF
            END IF
*
            IF (ABS(R).GT.RSTHR) THEN
              WRITE(6,33) ISS,JSS,R
            END IF
!
            Call Add_Info('CD_M(SO)',[R],1,6)
           END IF
          END DO
         END DO
         WRITE(6,35)
         End Do

         Call Deallocate_Spin_Magnetic_Dipoles()

         Call Deallocate_Electric_Quadrupoles()

         Call CollapseOutput(0,
     &                  'Circular Dichroism - mixed gauge '//
     &                  'Electric-Dipole - Magnetic-Dipole '//
     &                  'rotatory strengths (SO states):')
        END IF

        Call Deallocate_electric_dipoles()
        Call Deallocate_Magnetic_Dipoles()
      END IF
* CD end

! +++ J. Norell 19/7 - 2018
! Dyson amplitudes for (1-electron) ionization transitions
      IF (DYSO) THEN
        Call Add_Info('SODYSAMPS',SODYSAMPS,NSS*NSS,4)
        DYSTHR=1.0D-5
        WRITE(6,*)
        CALL CollapseOutput(1,'Dyson amplitudes '//
     &                        '(SO states):')
        WRITE(6,'(3X,A)')     '----------------------------'//
     &                        '-------------------'
        IF (DYSTHR.GT.0.0D0) THEN
           WRITE(6,*) 'for Dyson intensities at least',DYSTHR
           WRITE(6,*)
        END IF
        WRITE(6,*) '       From      To        '//
     &   'BE (eV)       Dyson intensity'
              WRITE(6,'(3X,A)')
     &                  '---------------------------' //
     &                  '-------------------------------------------'//
     &                  '-------------------'
        DO I=1,NSS
         DO J=1,NSS
          F=SODYSAMPS(I,J)*SODYSAMPS(I,J)
          EDIFF=auToeV*(ENSOR(J)-ENSOR(I))
          IF (ABS(EDIFF)<1.0D-8) Cycle
          IF (F.GT.0.00001) THEN
           IF (EDIFF.GT.0.0D0) THEN
            WRITE(6,'(A,I8,I8,F15.3,ES22.5)') '    ',I,J,EDIFF,F
           END IF
          END IF
         END DO ! J
        END DO ! I
        WRITE(6,*)
        WRITE(6,*)
        CALL CollapseOutput(0,'Dyson amplitudes '//
     &                        '(SO states):')
        WRITE(6,*)
! VKochetov 2021 put SO Dyson amplitudes to hdf5
#ifdef _HDF5_
        if (rhodyn) then
            call mh5_put_dset(wfn_sos_dys, SODYSAMPS)
        endif
#endif
       END IF
! +++ J. Norell

*
************************************************************************
*                                                                      *
*     Start of section for transition moments using the exact operator *
*     for the vector potential.                                        *
*                                                                      *
************************************************************************
*
      If (Do_TMOM)
     &   Call PRPROP_TM_Exact(PROP,USOR,USOI,ENSOR,NSS,JBNUM,EigVec)
*
 500  CONTINUE


C CALCULATION OF THE D-TENSOR (experimental)
C IFDCAL to implement keyword that will activate computation
C of d-tensor
*     IF(.NOT.IFDCAL) GOTO 600
      GOTO 600

      WRITE(6,*)
      WRITE(6,*) '  D-Matrix'
      WRITE(6,*) '  ========================================='
      WRITE(6,*) '  calculated using 2nd order perturbation'
      WRITE(6,*) '  > any spin degeneracy, no spatial degeneracy'
      WRITE(6,*) '  > weak spin-orbit coupling'
      WRITE(6,*)

* SVC 2006: Compute D-tensor through second order perturbation theory.
* no orbitally-degenerate groundstates!
      IAMFIX=0
      IAMFIY=0
      IAMFIZ=0
      DO IPROP=1,NPROP
       IF(PNAME(IPROP)(1:4).EQ.'AMFI') THEN
         IF(ICOMP(IPROP).EQ.1) IAMFIX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMFIY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMFIZ=IPROP
       END IF
      END DO
      IPAMFI(1)=IAMFIX
      IPAMFI(2)=IAMFIY
      IPAMFI(3)=IAMFIZ
* initialisations
      DO IXYZ=1,3
       DO JXYZ=1,3
        DTENS(IXYZ,JXYZ)=0.0D0
       END DO
      END DO

* loop over all excited states, different factors will arise depending
* on the difference in spin between ground and excited states.
      ISTATE=1
      MPLET1=MLTPLT(JBNUM(ISTATE))
      S1=0.5D0*DBLE(MPLET1-1)
      FACT0=THREEJ(S1,1.0D0,S1,S1,0.0D0,-S1)*
     &       THREEJ(S1,1.0D0,S1,S1,0.0D0,-S1)/
     &       (S1*S1)
      FACTP=THREEJ(S1+1.0D0,1.0D0,S1,S1+1.0D0,-1.0D0,-S1)*
     &       THREEJ(S1,1.0D0,S1+1.0D0,S1,1.0D0,-(S1+1.0D0))/
     &       ((S1+1.0D0)*(2.0D0*S1+1.0D0))
      FACTM=THREEJ(S1-1.0D0,1.0D0,S1,S1-1.0D0,1.0D0,-S1)*
     &       THREEJ(S1,1.0D0,S1-1.0D0,S1,-1.0D0,-(S1-1.0D0))/
     &       (S1*(2.0D0*S1-1.0D0))
C     WRITE(6,*)
C     WRITE(6,*)'S1 ', S1
C     WRITE(6,*)'FACT0 ', FACT0
C     WRITE(6,*)'FACTP ', FACTP
C     WRITE(6,*)'FACTM ', FACTM
C     WRITE(6,*)
      DO IXYZ=1,3
       DO JXYZ=1,3
        DTIJ=0.0D0
         DO JSTATE=2,NSTATE
          MPLET2=MLTPLT(JBNUM(JSTATE))
          S2=0.5D0*DBLE(MPLET2-1)
          DELTA=ENERGY(JSTATE)-ENERGY(ISTATE)
          IF(DELTA.LT.1.0D-05) GOTO 600
          CONTRIB=0.0D0
          CONTRIB=PROP(ISTATE,JSTATE,IPAMFI(IXYZ))*
     &         PROP(JSTATE,ISTATE,IPAMFI(JXYZ))/DELTA
C         WRITE(6,*) 'ISTATE, JSTATE, IXYZ, JXYZ, DELTA ',
C    &                 ISTATE, JSTATE, IXYZ, JXYZ, DELTA
C         WRITE(6,*) 'CONTRIB ', CONTRIB
C         WRITE(6,*) 'PROP(ISTATE,JSTATE,IXYZ) ',
C    &                 PROP(ISTATE,JSTATE,IPAMFI(IXYZ))
C         WRITE(6,*) 'PROP(JSTATE,ISTATE,JXYZ) ',
C    &                 PROP(JSTATE,ISTATE,IPAMFI(JXYZ))
          IF(S2.EQ.S1) THEN
           DTIJ=DTIJ+FACT0*CONTRIB
          ELSE IF(S2.EQ.S1+1.0D0) THEN
           DTIJ=DTIJ+FACTP*CONTRIB
          ELSE IF(S2.EQ.S1-1.0D0) THEN
           DTIJ=DTIJ+FACTM*CONTRIB
          END IF
         END DO
         DTENS(IXYZ,JXYZ)=DTIJ
       END DO
      END DO

* diagonalisation of the D-tensor matrix
      DO I=1,3
      EVR(I)=0.0D0
      EVI(I)=0.0D0
      END DO
      DO IXYZ=1,3
       DO JXYZ=1,3
        TMPMAT(IXYZ,JXYZ)=DTENS(IXYZ,JXYZ)
        IF(IXYZ.EQ.JXYZ) THEN
         TMPVEC(IXYZ,JXYZ)=1.0D0
        ELSE
         TMPVEC(IXYZ,JXYZ)=0.0D0
        END IF
       END DO
      END DO
      CALL XEIGEN(1,3,3,TMPMAT,EVR,EVI,TMPVEC,IERR)

* D-factor printout
* D = D_zz - 1/2 * (D_xx + D_yy)
* E = 1/2 * (D_xx - D_yy)
      WRITE(6,*)
      WRITE(6,*) 'The D matrix and eigenvalues:'
      WRITE(6,*)
      WRITE(6,'(2x,2x,2x,3(5x,a2,5x),'//
     & '4x,4x,2x,10x,'//
     & '2x,2x,2x,3(4x,a2,i1,3x))')
     & (xyzchr(IXYZ),IXYZ=1,3),
     & ('D_',IXYZ,IXYZ=1,3)
      WRITE(6,*)
      DO IXYZ=1,3
      WRITE(6,'(2x,a2,2x,3(1x,f10.8,1x),'//
     & '4x,a2,i1,a1,2x,f10.8,'//
     & '2x,a2,2x,3(1x,f8.4,1x),'//
     & '3x,a2,i1,a1,2x,f8.3,2x,a5)')
     & xyzchr(IXYZ), (DTENS(IXYZ,JXYZ),JXYZ=1,3),
     & 'D_',IXYZ,':',EVR(IXYZ),
     & xyzchr(IXYZ), (TMPVEC(IXYZ,JXYZ),JXYZ=1,3),
     & 'D_',IXYZ,':',EVR(IXYZ)*auTocm,'cm^-1'
      ENDDO


 600  CONTINUE

C CALCULATION OF THE G-TENSOR
C IFGCAL is set by keyword EPRG
      IF(.NOT.IFGCAL) GOTO 800
* PAM 2005 Experimental: Compute g-tensor through 2-nd order
* perturbation approach, mixed ang mom / spin orbit terms
* Declarations for gtensor(3,3) and some other odds and ends
* for nice output have been added to declaration head above.

      IF(.not.IFSO) THEN
          WRITE(6,*) 'keyword SPIN needed together with EPRG'
          WRITE(6,*)
          GOTO 800
      ENDIF

      WRITE(6,*)
      WRITE(6,*) '  g-Matrix Approach I                               '
      WRITE(6,*) '  ========================================='
      WRITE(6,*) '  calculated using 2nd order perturbation'
      WRITE(6,*) '  > any spin degeneracy, no spatial degeneracy'
      WRITE(6,*) '  > weak spin-orbit coupling'
      WRITE(6,*)

      IAMFIX=0
      IAMFIY=0
      IAMFIZ=0
      IAMX=0
      IAMY=0
      IAMZ=0
      DO IPROP=1,NPROP
       IF(PNAME(IPROP)(1:4).EQ.'AMFI') THEN
         IF(ICOMP(IPROP).EQ.1) IAMFIX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMFIY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMFIZ=IPROP
       ELSE IF(PNAME(IPROP)(1:6).EQ.'ANGMOM') THEN
         IF(ICOMP(IPROP).EQ.1) IAMX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMZ=IPROP
       END IF
      END DO
      IPAMFI(1)=IAMFIX
      IPAMFI(2)=IAMFIY
      IPAMFI(3)=IAMFIZ
      IPAM(1)=IAMX
      IPAM(2)=IAMY
      IPAM(3)=IAMZ

C start loop over the states ISTATE:
      ISTATE=1
      DO WHILE (
     &          ((ENERGY(MIN(ISTATE,NSTATE))-ENERGY(1)).LE.EPRTHR)
     &  .AND. (ISTATE.LE.NSTATE)
     &          )

      DO IXYZ=1,3
       DO JXYZ=1,3
        GTENS(IXYZ,JXYZ)=0.0D0
       END DO
      END DO

      MPLET=MLTPLT(JBNUM(ISTATE))
      S=0.5D0*DBLE(MPLET-1)

      WRITE(6,*)
      WRITE(6,'(3x,A6,I4,3x,A4,F4.1,3x,A4,F18.8)')
     & 'STATE ',ISTATE,'S = ',S,'E = ',ENERGY(ISTATE)
      WRITE(6,'(3x,A46)')
     & '----------------------------------------------'

      IF(MPLET.NE.1) THEN
              FACTOR=1.0D0/SQRT(S*(S+1.0D0)*(2.0D0*S+1.0D0))
      ELSE
              GOTO 690
      END IF

C print separate contributions if verbose
      IF (IPGLOB.GE.3) THEN
       WRITE(6,*)
       WRITE(6,*) 'contributions from the SOS expansion'//
     &            ' to delta(g_pq) in *ppt* (p,q=x,y,z)'
       WRITE(6,*)
       WRITE(6,'(2x,a8,2x,9(4x,a2,3x))')
     &  ' states ','xx','xy','xz','yx','yy','yz','zx','zy','zz'
       WRITE(6,*)
       DO JSTATE=1,NSTATE
       IF (JSTATE.NE.ISTATE) THEN
       DELTA=ENERGY(JSTATE)-ENERGY(ISTATE)
        IF(ABS(DELTA).LT.1.0D-04) THEN
            WRITE(6,'(1x,i3,2x,i3,3x,A20,1x,A20,F18.8)')
     &       ISTATE,JSTATE,'possible degeneracy,',
     &       'energy difference = ',DELTA
             GOTO 610
        ENDIF
        DO IXYZ=1,3
         DO JXYZ=1,3
          CONTRIB=PROP(ISTATE,JSTATE,IPAMFI(IXYZ))*
     &             PROP(ISTATE,JSTATE,IPAM(JXYZ))
          CONTRIB=CONTRIB/DELTA
          SOSTERM(3*(IXYZ-1)+JXYZ)=-2.0D0*FACTOR*CONTRIB
         ENDDO
        ENDDO
        WRITE(6,'(1x,i3,2x,i3,3x,9(f8.3,1x))')
     &   ISTATE,JSTATE,(SOSTERM(I)*1.0D3,I=1,9)
       ENDIF
 610   CONTINUE
       ENDDO
      END IF

C calculate sum-over-states for each g_pq (p,q = x,y,z)
      DO IXYZ=1,3
       DO JXYZ=1,3
         GTIJ=0.0D0
         DELTA=0.0D0
         CONTRIB=0.0D0
         DO JSTATE=1,NSTATE
         IF (JSTATE.NE.ISTATE) THEN
          DELTA=ENERGY(JSTATE)-ENERGY(ISTATE)
C SVC 2008: no good criterium for spatial degeneracy, use rasscf
C energies ?
          IF(ABS(DELTA).LT.1.0D-04) THEN
              WRITE(6,*)
              WRITE(6,*) 'SPATIALLY DEGENERATE STATE: '//
     &                   'sum-over-states not applicable'
*             WRITE(6,*) '> lower the degeneracy treshold if this '//
*    &                   'is not a spatially degenerate state'
              WRITE(6,*)
              GOTO 690
          ENDIF
          CONTRIB=PROP(ISTATE,JSTATE,IPAMFI(IXYZ))*
     &             PROP(ISTATE,JSTATE,IPAM(JXYZ))
          CONTRIB=CONTRIB/DELTA
          GTIJ=GTIJ+CONTRIB
         ENDIF
         ENDDO
        GTENS(IXYZ,JXYZ)=-2.0D0*FACTOR*GTIJ
       END DO
      END DO

C put g_e on the diagonal
      DO IXYZ=1,3
       DO JXYZ=IXYZ,3
       IF (IXYZ.EQ.JXYZ) GTENS(IXYZ,JXYZ)=GTENS(IXYZ,JXYZ)+FEGVAL
       END DO
      END DO

C determine symmetric G = gg+ tensor, this is what can be measured
C experimentally, and store as GSTENS
      DO IXYZ=1,3
       DO JXYZ=1,3
        GSTENS(IXYZ,JXYZ)=0.0D0
        DO KXYZ=1,3
        GSTENS(IXYZ,JXYZ)=GSTENS(IXYZ,JXYZ)+
     &                     GTENS(IXYZ,KXYZ)*GTENS(JXYZ,KXYZ)
        END DO
       END DO
      END DO

C determine the eigenvalues of the g matrix
      DO I=1,3
      EVR(I)=0.0D0
      EVI(I)=0.0D0
      END DO
C XEIGEN alters the input matrix! copy GTENS to TMPMAT
      DO IXYZ=1,3
       DO JXYZ=1,3
       TMPMAT(IXYZ,JXYZ)=GTENS(IXYZ,JXYZ)
       IF(IXYZ.EQ.JXYZ) THEN
        TMPVEC(IXYZ,JXYZ)=1.0D0
       ELSE
        TMPVEC(IXYZ,JXYZ)=0.0D0
       END IF
       END DO
      ENDDO

      IERR=0
      CALL XEIGEN(1,3,3,TMPMAT,EVR,EVI,TMPVEC,IERR)
      IF (IERR.NE.0) THEN
          WRITE(6,*) 'Error: xEigen returned IERR = ', IERR
          RETURN
      END IF

      WRITE(6,*)
      WRITE(6,*) 'The g matrix and eigenvalues:'
      WRITE(6,*)
      WRITE(6,'(6x,3(5x,a2,5x))')
     & (xyzchr(IXYZ),IXYZ=1,3)
      WRITE(6,*)
      DO IXYZ=1,3
      WRITE(6,'(2x,a2,2x,3(1x,f10.8,1x),'//
     & '4x,a2,i1,a1,2x,f8.4,3x,a8,i1,a2,2x,f10.3,2x,a3)')
     & xyzchr(IXYZ), (GTENS(IXYZ,JXYZ),JXYZ=1,3),
     & 'g_',IXYZ,':',EVR(IXYZ),
     & 'delta(g_',IXYZ,'):',(EVR(IXYZ)-FEGVAL)*1.0D3,'ppt'
      ENDDO

*     WRITE(6,'(6x,3(5x,i1,4x))') (IXYZ,IXYZ=1,3)

C determine the eigenvalues of the G = gg* matrix
      DO I=1,3
      EVR(I)=0.0D0
      EVI(I)=0.0D0
      ENDDO
      DO IXYZ=1,3
       DO JXYZ=1,3
       TMPMAT(IXYZ,JXYZ)=GSTENS(IXYZ,JXYZ)
       IF(IXYZ.EQ.JXYZ) THEN
        TMPVEC(IXYZ,JXYZ)=1.0D0
       ELSE
        TMPVEC(IXYZ,JXYZ)=0.0D0
       END IF
       END DO
      ENDDO

      IERR=0
      CALL XEIGEN(1,3,3,TMPMAT,EVR,EVI,TMPVEC,IERR)
      IF (IERR.NE.0) THEN
          WRITE(6,*) 'Error: xEigen returned IERR = ', IERR
          RETURN
      END IF

C reconstruct g_s from the square root of the eigenvalues
C and the eigenvectors of G = gg+ by back transformation
      DO IXYZ=1,3
       DO JXYZ=1,3
       GSTENS(IXYZ,JXYZ)=0.0D0
        DO KXYZ=1,3
        GSTENS(IXYZ,JXYZ)=GSTENS(IXYZ,JXYZ)+
     &   TMPVEC(IXYZ,KXYZ)*SQRT(EVR(KXYZ))*TMPVEC(JXYZ,KXYZ)
        END DO
       END DO
      ENDDO

      WRITE(6,*)
      WRITE(6,*) 'The symmetric g matrix is the '//
     &           'actual experimentally determined g matrix.'
      WRITE(6,*) 'The sign of the eigenvalues is undetermined '//
     &           '(assumed positive).'
      WRITE(6,*)
      WRITE(6,'(2x,2x,2x,3(5x,a2,5x),'//
     & '4x,4x,2x,10x,'//
     & '2x,2x,2x,3(4x,a2,i1,3x))')
     & (xyzchr(IXYZ),IXYZ=1,3),
     & ('g_',IXYZ,IXYZ=1,3)
      WRITE(6,*)
      DO IXYZ=1,3
      WRITE(6,'(2x,a2,2x,3(1x,f10.8,1x),'//
     & '4x,a2,i1,a1,2x,f10.6,'//
     & '2x,a2,2x,3(1x,f8.4,1x),'//
     & '3x,a8,i1,a2,2x,f8.3,2x,a3)')
     & xyzchr(IXYZ), (GSTENS(IXYZ,JXYZ),JXYZ=1,3),
     & 'g_',IXYZ,':',SQRT(EVR(IXYZ)),
     & xyzchr(IXYZ), (TMPVEC(IXYZ,JXYZ),JXYZ=1,3),
     & 'delta(g_',IXYZ,'):',(SQRT(EVR(IXYZ))-FEGVAL)*1.0D3,'ppt'
      ENDDO
      DO I=1,3
      EVR(I)=SQRT(EVR(I))-FEGVAL
      ENDDO
      Call Add_Info('EPRGVAL',EVR,3,6)

 690  CONTINUE

      ISTATE=ISTATE+1

* end long loop over states ISTATE
      ENDDO

* SVC alternative approach for the g-tensor:
* using first order degenerate perturbation theory

      IF(IFVANVLECK) THEN
      WRITE(6,*)
      WRITE(6,*) '  VAN VLECK Tensor and g-Matrix Approach II        '
      WRITE(6,*) '  ========================================='
      WRITE(6,*) '  1st order degenerate perturbation theory '
      WRITE(6,*) '  within isolated kramers doublets.        '
      WRITE(6,*) '  > spatial degeneracy'
      WRITE(6,*) '  > strong spin-orbit coupling'
      WRITE(6,*)
      ELSE
      WRITE(6,*)
      WRITE(6,*) '  g-Matrix Approach II                     '
      WRITE(6,*) '  ========================================='
      WRITE(6,*) '  1st order degenerate perturbation theory '
      WRITE(6,*) '  within isolated kramers doublets.        '
      WRITE(6,*) '  > spatial degeneracy'
      WRITE(6,*) '  > strong spin-orbit coupling'
      WRITE(6,*)
      ENDIF

      IAMX=0
      IAMY=0
      IAMZ=0
      DO IPROP=1,NPROP
       IF(PNAME(IPROP)(1:6).EQ.'ANGMOM') THEN
        !write(6,*)"3****ANGMOM rassi/prprop.f "
         IF(ICOMP(IPROP).EQ.1) IAMX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMZ=IPROP
       END IF
      END DO

      Call mma_allocate(LXI,NSS,NSS,Label='LXI')
      LXI(:,:)=0.0D0
      Call mma_allocate(LYI,NSS,NSS,Label='LYI')
      LYI(:,:)=0.0D0
      Call mma_allocate(LZI,NSS,NSS,Label='LZI')
      LZI(:,:)=0.0D0

      IF(IAMX.GT.0) CALL SMMAT(PROP,LXI,NSS,IAMX,0)
      IF(IAMY.GT.0) CALL SMMAT(PROP,LYI,NSS,IAMY,0)
      IF(IAMZ.GT.0) CALL SMMAT(PROP,LZI,NSS,IAMZ,0)


      Call mma_allocate(ZXR,NSS,NSS,Label='ZXR')
      Call mma_allocate(ZXI,NSS,NSS,Label='ZXI')
      ZXR(:,:)=0.0D0
      ZXI(:,:)=0.0D0
      pZMR(1)%A2=>ZXR(:,:)
      pZMI(1)%A2=>ZXI(:,:)
      Call mma_allocate(ZYR,NSS,NSS,Label='ZYR')
      Call mma_allocate(ZYI,NSS,NSS,Label='ZYI')
      ZYR(:,:)=0.0D0
      ZYI(:,:)=0.0D0
      pZMR(2)%A2=>ZYR(:,:)
      pZMI(2)%A2=>ZYI(:,:)
      Call mma_allocate(ZZR,NSS,NSS,Label='ZZR')
      Call mma_allocate(ZZI,NSS,NSS,Label='ZZI')
      ZZR(:,:)=0.0D0
      ZZI(:,:)=0.0D0
      pZMR(3)%A2=>ZZR(:,:)
      pZMI(3)%A2=>ZZI(:,:)

      CALL SMMAT(PROP,ZXR,NSS,0,1)
      CALL SMMAT(PROP,ZYI,NSS,0,2)
      CALL SMMAT(PROP,ZZR,NSS,0,3)

      CALL DSCAL_(NSS**2,FEGVAL,ZXR,1)
      CALL DSCAL_(NSS**2,FEGVAL,ZYI,1)
      CALL DSCAL_(NSS**2,FEGVAL,ZZR,1)

      CALL DAXPY_(NSS**2,1.0D0,LXI,1,ZXI,1)
      CALL DAXPY_(NSS**2,1.0D0,LYI,1,ZYI,1)
      CALL DAXPY_(NSS**2,1.0D0,LZI,1,ZZI,1)

      Call mma_deallocate(LXI)
      Call mma_deallocate(LYI)
      Call mma_deallocate(LZI)

*     SVC 20090926 Experimental
*     Add analysis of different contributions

*     Establish which spin components of SFS belong to the ground state
      DO I=1,NSS
       ISGS(I)=.FALSE.
      ENDDO

      GSENERGY=ENERGY(1)
      DO ISTATE=2,NSTATE
       IF (ENERGY(ISTATE).LT.GSENERGY) THEN
        GSENERGY = ENERGY(ISTATE)
       ENDIF
      ENDDO

      IMLTPL=1
      DO ISTATE=1,NSTATE
       IF (ABS(ENERGY(ISTATE)-GSENERGY).LT.1.0d-6) THEN
        DO I=IMLTPL,IMLTPL-1+MLTPLT(JBNUM(ISTATE))
         ISGS(I)=.TRUE.
        ENDDO
       ELSE
        DO I=IMLTPL,IMLTPL-1+MLTPLT(JBNUM(ISTATE))
         ISGS(I)=.FALSE.
        ENDDO
       ENDIF
       IMLTPL=IMLTPL+MLTPLT(JBNUM(ISTATE))
      ENDDO

*     Analyze the different contributions to the GS Kramers doublet
*     Zeeman matrix elements.  There are 4 different ME's: <1|Ze|1>,
*     <1|Ze|2>, <2|Ze|1>, and <2|Ze|2>, stored in ZEKL.  Contributions
*     of SFS i,j to SOS k,l (k,l=1,2): <k|Ze|l> = Sum(i,j) U(i,k)*
*     <i|Ze|j> U(j,l).  This sum is decomposed into parts belonging to
*     each SFS state i as follows:
*     -> GS's contain only MEs with themselves and other GS's
*     -> ES's contain MEs with themselves, the GS's (2x) and other ES's
*        The ME's with the GS's are counted twice as they do not belong to
*        any GS's (they contain only ME's within their own GS group)
*        The contributions with other ES's are split between the ES's,
*        counting them double (<i|Ze|j> and <j|Ze|i>) and divide by two later.

      IMLTPL=1
      ZEKL(:,:,:,:)=CMPLX(0.0d0,0.0d0,kind=8)

      DO ISTATE=1,NSTATE

       ISTART=IMLTPL
       IFINAL=IMLTPL-1+MLTPLT(JBNUM(ISTATE))

       IF (ABS(ENERGY(ISTATE)-GSENERGY).LT.1.0d-6) THEN

* Contribution of the GS spin components
        DO IXYZ=1,3
         DO ISS=ISTART,IFINAL
          DO JSS=1,NSS
           IF (ISGS(JSS)) THEN
            CALL ZECON(NSTATE,NSS,USOR,USOI,
     &           pZMR(IXYZ)%A2,pZMI(IXYZ)%A2,
     &           ZEKL,IXYZ,ISTATE,ISS,JSS)
            CALL ZECON(NSTATE,NSS,USOR,USOI,
     &           pZMR(IXYZ)%A2,pZMI(IXYZ)%A2,
     &           ZEKL,IXYZ,ISTATE,JSS,ISS)
C     WRITE(6,FMT=710) 'ZEKL', ISTATE, IXYZ, ISS, JSS,
C     &                    ZEKL(:,:,IXYZ,ISTATE)
           ENDIF
          ENDDO
         ENDDO
        ENDDO

       ELSE

* Contributions of the ES spin components
        DO IXYZ=1,3
         DO ISS=ISTART,IFINAL
          DO JSS=1,NSS
           CALL ZECON(NSTATE,NSS,USOR,USOI,
     &          pZMR(IXYZ)%A2,pZMI(IXYZ)%A2,
     &          ZEKL,IXYZ,ISTATE,ISS,JSS)
           CALL ZECON(NSTATE,NSS,USOR,USOI,
     &          pZMR(IXYZ)%A2,pZMI(IXYZ)%A2,
     &          ZEKL,IXYZ,ISTATE,JSS,ISS)
           IF (ISGS(JSS)) THEN
            CALL ZECON(NSTATE,NSS,USOR,USOI,
     &           pZMR(IXYZ)%A2,pZMI(IXYZ)%A2,
     &           ZEKL,IXYZ,ISTATE,ISS,JSS)
            CALL ZECON(NSTATE,NSS,USOR,USOI,
     &           pZMR(IXYZ)%A2,pZMI(IXYZ)%A2,
     &           ZEKL,IXYZ,ISTATE,JSS,ISS)
           ENDIF
C     WRITE(6,FMT=710) 'ZEKL', ISTATE, IXYZ, ISS, JSS,
C     &                 ZEKL(:,:,IXYZ,ISTATE)
          ENDDO
         ENDDO
        ENDDO

       ENDIF

C       DO IXYZ=1,3
C        WRITE(6,FMT=720) 'ZEKL', IXYZ, ISTATE,
C     &      ZEKL(:,:,IXYZ,ISTATE)
C       ENDDO

C 710  FORMAT(A4,4I4,4(2X,'('F12.8','F12.8')'))
C 720  FORMAT(A4,2I4,4(2X,'('F12.8','F12.8')'))

       IMLTPL=IMLTPL+MLTPLT(JBNUM(ISTATE))
      ENDDO

*     We now have decomposed the <k|Ze|l> into terms belonging to either
*     a GS or an ES for each k,l=1,2 and p=x,y,z stored in ZEKL(k,l,p,SFS)
*     Now, these new decomposed terms of the ZEKL ME's are combined to
*     form the G tensor.  Consider e.g. that <k|Ze|l> is decomposed into
*     <k|GS|l> + <k|ES1|l> + <k|ES2|l>, then the contributions to G are given as:
*     -> G_pq/2 = <k|Ze_p|l> <l|Ze_q|k>
*             = (<k|GS_p|l> + <k|ES1_p|l> + <k|ES2_p|l>)
*             * (<l|GS_q|k> + <l|ES1_q|k> + <l|ES2_q|k>)
*
*     from GS: (<k|GS_p|l>/2 * <l|GS_q|k>/2)/2 + (<k|GS_p|l>/2 * <l|GS_q|k>/2)/2
*     from ES1: 2*((<k|ES1_p|l>/2 * <l|GS_q|k>/2)/2 + (<k|GS_q|l>/2 * <l|ES1_p|k>/2)/2)
*               + (<k|ES1_p|l>/2 * <l|ES1_q|k>/2)/2 + (<k|ES1_q|l>/2 * <l|ES2_p|k>/2)/2
*               + (<k|ES1_p|l>/2 * <l|ES2_q|k>/2)/2 + (<k|ES2_q|l>/2 * <l|ES1_p|k>/2)/2
*     In the end, the outer division by 2 cancels on both sides, and the
*     inner divisions by two combine to a division by 4.

      GCONT(:,:)=CMPLX(0.0d0,0.0d0,kind=8)
      GTOTAL(:)=0.0d0

      DO ISTATE=1,NSTATE
       DO IXYZ=1,3
        DO JXYZ=1,3
         IJXYZ=3*(IXYZ-1)+JXYZ

         IF (ABS(ENERGY(ISTATE)-GSENERGY).LT.1.0d-6) THEN

* Contributions for the GS's
          DO JSTATE=1,NSTATE
           IF (ABS(ENERGY(JSTATE)-GSENERGY).LT.1.0d-6) THEN
            DO I=1,2
             DO J=1,2
              GCONT(IJXYZ,ISTATE)=GCONT(IJXYZ,ISTATE)
     &             +(ZEKL(I,J,IXYZ,ISTATE)*
     &             ZEKL(J,I,JXYZ,JSTATE))/4
     &             +(ZEKL(I,J,IXYZ,JSTATE)*
     &             ZEKL(J,I,JXYZ,ISTATE))/4
             ENDDO
            ENDDO
           ENDIF
          ENDDO

         ELSE

* Contributions for the ES's
          DO JSTATE=1,NSTATE
           DO I=1,2
            DO J=1,2
             GCONT(IJXYZ,ISTATE)=GCONT(IJXYZ,ISTATE)
     &            +(ZEKL(I,J,IXYZ,ISTATE)*
     &            ZEKL(J,I,JXYZ,JSTATE))/4
     &            +(ZEKL(I,J,IXYZ,JSTATE)*
     &            ZEKL(J,I,JXYZ,ISTATE))/4
             IF (ABS(ENERGY(JSTATE)-GSENERGY).LT.1.0d-6) THEN
              GCONT(IJXYZ,ISTATE)=GCONT(IJXYZ,ISTATE)
     &             +(ZEKL(I,J,IXYZ,ISTATE)*
     &             ZEKL(J,I,JXYZ,JSTATE))/4
     &             +(ZEKL(I,J,IXYZ,JSTATE)*
     &             ZEKL(J,I,JXYZ,ISTATE))/4
             ENDIF
            ENDDO
           ENDDO
          ENDDO

         ENDIF

        ENDDO
       ENDDO

       DO IJXYZ=1,9
        GTOTAL(IJXYZ)=GTOTAL(IJXYZ)+DBLE(GCONT(IJXYZ,ISTATE))
       ENDDO
      ENDDO

       DIPSOm(:,:,:)=(0.0d0,0.0d0)
       DIPSOn(:,:,:)=(0.0d0,0.0d0)


*     Continue original calculation of G tensor (=gg^*)
      CALL get_dArray( 'ESO_SINGLE',ESO,NSS)
      CALL ZTRNSF(NSS,USOR,USOI,ZXR,ZXI)
      CALL MULMAT(NSS,ZXR,ZXI,eex,Z)
      DO ISS=1,NSS
      DO JSS=1,NSS
      DIPSOm(1,ISS,JSS)=0.5d0*Z(ISS,JSS)
      DIPSOn(1,ISS,JSS)=-Z(ISS,JSS)
      enddo
      enddo
      CALL ZTRNSF(NSS,USOR,USOI,ZYR,ZYI)
      CALL MULMAT(NSS,ZYR,ZYI,eey,Z)
      DO ISS=1,NSS
      DO JSS=1,NSS
      DIPSOm(2,ISS,JSS)=0.5d0*Z(ISS,JSS)
      DIPSOn(2,ISS,JSS)=-Z(ISS,JSS)
      enddo
      enddo
      CALL ZTRNSF(NSS,USOR,USOI,ZZR,ZZI)
      CALL MULMAT(NSS,ZZR,ZZI,eez,Z)
      DO ISS=1,NSS
      DO JSS=1,NSS
      DIPSOm(3,ISS,JSS)=0.5d0*Z(ISS,JSS)
      DIPSOn(3,ISS,JSS)=-Z(ISS,JSS)
      enddo
      enddo
      WRITE(6,*)''

      IF(IFVANVLECK) THEN

      iT=0
      do iT=1,NTS
      do ic=1,3
      do jc=1,3
      chiT_tens(iT,ic,jc)=0.d0
      chicuriT_tens(iT,ic,jc)=0.d0
      chiparamT_tens(iT,ic,jc)=0.d0
      enddo
      enddo
      enddo
      iT=0
      do iT=1,NTS
      if(iT.eq.1) then
      TMPm(iT)=TMINS+0.0001d0
      ELSE
      DLTT=(TMAXS-TMINS)/(dble(NTS-1))
      TMPm(iT)=TMINS+DLTT*dble(iT-1)
      ENDIF
      Zstat=0.d0
      do Iss=1,Nss
      p_Boltz=EXP(-ESO(Iss)/Boltz_k/TMPm(iT))
      Zstat=Zstat+p_Boltz
      do IC=1,3
      do JC=1,3
      c_2(IC,JC)   =0.d0
      curit(IC,JC) =0.d0
      paramt(IC,JC)=0.d0
      enddo
      enddo
      do Jss=1,Nss
      dlt_E=Eso(Iss)-Eso(Jss)
      do IC=1,3
      do JC=1,3
      c_1(IC,JC)=0.d0
      enddo
      enddo
      do ic=1,3
      do jc=1,3
      c_1(ic,jc)=DBLE(DIPSOn(ic,Iss,Jss)*CONJG(DIPSOn(jc,Iss,Jss)))
      if(ABS(dlt_E).LT.10.97d0) then
      c_2(ic,jc)=    c_2(ic,jc)  +  c_1(ic,jc)
      curit(ic,jc)= curit(ic,jc) +  c_1(ic,jc)
      paramt(ic,jc)=paramt(ic,jc)+  0.d0*c_1(ic,jc)
      else
      c_2(ic,jc)= c_2(ic,jc)-2.d0*Boltz_k*TMPm(iT)* c_1(ic,jc)/dlt_E
      curit(ic,jc)= curit(ic,jc)-0.d0*(2.d0*Boltz_k*TMPm(iT)*
     &c_1(ic,jc)/dlt_E)
      paramt(ic,jc)= paramt(ic,jc)-2.d0*Boltz_k*TMPm(iT)*
     &c_1(ic,jc)/dlt_E
      endif
      enddo
      enddo
      enddo !Jss
      do ic=1,3
      do jc=1,3
      chiT_tens(iT,ic,jc)=    chiT_tens(iT,ic,jc)+p_Boltz*
     & c_2(ic,jc)
      chicuriT_tens(iT,ic,jc)= chicuriT_tens(iT,ic,jc) +
     & p_Boltz*curit(ic,jc)
      chiparamT_tens(iT,ic,jc)= chiparamT_tens(iT,ic,jc) +
     & p_Boltz*paramt(ic,jc)
      enddo
      enddo
      enddo !Iss
      !Zstat1m(iT)=Zstat
      do ic=1,3
      do jc=1,3
      chiT_tens(iT,ic,jc)= coeff_chi*(chiT_tens(iT,ic,jc)/Zstat)
      chicuriT_tens(iT,ic,jc)=coeff_chi*(chicuriT_tens(iT,ic,jc)/
     & Zstat)
      chiparamT_tens(iT,ic,jc)=coeff_chi*(chiparamT_tens(iT,ic,jc)/
     & Zstat)
      enddo
      enddo
      enddo ! iT


      write(6,'(/)')
      write(6,'(10A)') (('------------'), K=1,10)
      write(6,'(30X,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR'//
     & '  (cm3*K/mol)'
      write(6,'(10A)') (('------------'), K=1,10)
      write(6,*)
C      write(6,'(8X,A,9(7X,A))') 'T','(1,1)','(1,2)','(1,3)','(2,1)',
C     & '(2,2)','(2,3)','(3,1)','(3,2)','(3,3)'
      write(6,'(6X,A,8X,9(A,9X))') 'T(K)','xx','xy','xz','yx','yy',
     & 'yz','zx','zy','zz'
      write(6,*)
      do iT=1,NTS
      write(6,'(4X,F6.1,3X,11(F9.4,2X),F8.4)') TMPm(iT),
     & ((chiT_tens(iT,ic,jc),jc=1,3),ic=1,3)
      enddo

      write(6,'(/)')
      write(6,'(10A)') (('------------'), K=1,10)
      write(6,'(30X,A)') 'Curie contrib. to VAN VLECK TENSOR'//
     & '  (cm3*K/mol)'
      write(6,'(10A)') (('------------'), K=1,10)
      write(6,*)
C      write(6,'(8X,A,9(7X,A))') 'T','(1,1)','(1,2)','(1,3)','(2,1)',
C     & '(2,2)','(2,3)','(3,1)','(3,2)','(3,3)'
      write(6,'(6X,A,8X,9(A,9X))') 'T(K)','xx','xy','xz','yx','yy',
     & 'yz','zx','zy','zz'
      write(6,*)
      do iT=1,NTS
      write(6,'(4X,F6.1,3X,11(F9.4,2X),F8.4)') TMPm(iT),
     & ((chicuriT_tens(iT,ic,jc),jc=1,3),ic=1,3)
      enddo
      write(6,'(/)')
      write(6,'(10A)') (('------------'), K=1,10)
      write(6,'(30X,A)') 'Parama. contrib. to VAN VLECK TENSOR'//
     & '  (cm3*K/mol)'
      write(6,'(10A)') (('------------'), K=1,10)
      write(6,*)
C      write(6,'(8X,A,9(7X,A))') 'T','(1,1)','(1,2)','(1,3)','(2,1)',
C     & '(2,2)','(2,3)','(3,1)','(3,2)','(3,3)'
      write(6,'(6X,A,8X,9(A,9X))') 'T(K)','xx','xy','xz','yx','yy',
     & 'yz','zx','zy','zz'
      write(6,*)
      do iT=1,NTS
      write(6,'(4X,F6.1,3X,11(F9.4,2X),F8.4)') TMPm(iT),
     & ((chiparamT_tens(iT,ic,jc),jc=1,3),ic=1,3)
      enddo
      WRITE(6,*)
      WRITE(6,*)
      WRITE(6,*) '  g-Matrix'
      WRITE(6,*) '  =========='
      ENDIF ! IFVANVLECK
      !do I=1,3
      !do J=1,3
      !do iT=1,NT
      !chiT_tens(iT,I,J)=0.d0
      !enddo
      !enddo
      !enddo

      ISS=1
      DO WHILE ((ISS.LE.NSS).AND.
     &          (ENSOR(MIN(ISS,NSS))-ENSOR(1).LE.EPRTHR))

      DO IXYZ=1,3
       DO JXYZ=1,3
        GTENS(IXYZ,JXYZ)=0.0D0
       END DO
      END DO

      KDGN=1
      DO JSS=ISS+1,NSS
      EDIFF=ENSOR(JSS)-ENSOR(ISS)
      IF (IFGTCALSA.AND.IFGTSHSA) THEN
      KDGN=MULTIP
      !WRITE(6,*) 'KDGN=',KDGN
      ELSE IF (ABS(EDIFF).LT.1.0D-06) THEN
      KDGN=KDGN+1
      ENDIF
      ENDDO

      WRITE(6,*)
      DO I=1,KDGN
      WRITE(6,'(3x,A9,I4,3x,A4,F18.8)')
     & 'SO-STATE ',ISS-1+I,'E = ',ENSOR(ISS-1+I)
      ENDDO
      WRITE(6,'(3x,A46)')
     &'----------------------------------------------'

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IF(.NOT.IFGTCALSA) GOTO 450
      IF(ISS.EQ.1) IFUNCT=0
      call SINANI(KDGN,IFUNCT,NSS,DIPSOn,SPNSFS,DIPSOm_SA)
      IFUNCT=IFUNCT+KDGN
  450 CONTINUE
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      IF (KDGN.NE.2) THEN
          WRITE(6,*) 'no twofold degeneracy'
          GOTO 780
      ENDIF

      IF ((ISS.EQ.1).AND.(KDGN.EQ.2).AND.(IPGLOB.GE.3)) THEN
       WRITE(6,*) 'Experimental: SFS contributions to G=gg+'
       WRITE(6,*)
       WRITE(6,'(a6,9(5x,a2,5x))')
     &      'state ','xx','xy','xz','yx','yy','yz','zx','zy','zz'
       WRITE(6,*)
       DO ISTATE=1,NSTATE
        WRITE(6,'(2x,I2,2x,9(F12.6))')
     &       ISTATE, (DBLE(GCONT(IJXYZ,ISTATE)),IJXYZ=1,9)
       ENDDO

       WRITE(6,*)
       WRITE(6,'(A6,9(F12.6))')
     &      'total ', (GTOTAL(IJXYZ),IJXYZ=1,9)
      ENDIF


      JSS=ISS+1

      DO IXYZ=1,3
       DO JXYZ=1,3
       GTIJ=0.0D0
       CONTRIB=0.0D0
       DO ISO=ISS,JSS
        DO JSO=ISS,JSS
        CONTRIB= pZMR(IXYZ)%A2(ISO,JSO)*pZMR(JXYZ)%A2(JSO,ISO)
     &          -pZMI(IXYZ)%A2(ISO,JSO)*pZMI(JXYZ)%A2(JSO,ISO)
        GTIJ=GTIJ+CONTRIB
        END DO
       END DO
       GTENS(IXYZ,JXYZ)=2.0D0*GTIJ
       END DO
      END DO

      IF(IPGLOB.GT.3) THEN
       WRITE(6,*) 'G tensor = gg+'
       WRITE(6,*)
       WRITE(6,'(6x,3(6x,a2,4x))')
     &  (xyzchr(IXYZ),IXYZ=1,3)
       DO IXYZ=1,3
       WRITE(6,'(2x,a2,2x,3(1x,f18.8,1x))')
     &  xyzchr(IXYZ), (GTENS(IXYZ,JXYZ),JXYZ=1,3)
       ENDDO
       END IF

      DO I=1,3
      EVR(I)=0.0D0
      EVI(I)=0.0D0
      END DO
      DO IXYZ=1,3
       DO JXYZ=1,3
       TMPMAT(IXYZ,JXYZ)=GTENS(IXYZ,JXYZ)
       IF(IXYZ.EQ.JXYZ) THEN
        TMPVEC(IXYZ,JXYZ)=1.0D0
       ELSE
        TMPVEC(IXYZ,JXYZ)=0.0D0
       END IF
       END DO
      ENDDO

      CALL XEIGEN(1,3,3,TMPMAT,EVR,EVI,TMPVEC,IERR)

C construct g_s matrix from G by back-transormation of the
C square root of the G eigenvalues
      DO IXYZ=1,3
       DO JXYZ=1,3
       GTENS(IXYZ,JXYZ)=0.0D0
        DO KXYZ=1,3
        GTENS(IXYZ,JXYZ)=GTENS(IXYZ,JXYZ)+
     &   TMPVEC(IXYZ,KXYZ)*SQRT(EVR(KXYZ))*TMPVEC(JXYZ,KXYZ)
        END DO
       END DO
      ENDDO

      WRITE(6,'(6x,3(5x,a2,5x),'//
     & '4x,4x,2x,8x,'//
     & '2x,2x,2x,3(4x,a2,i1,3x))')
     & (xyzchr(IXYZ),IXYZ=1,3), ('g_',IXYZ,IXYZ=1,3)
      WRITE(6,*)
      DO IXYZ=1,3
      WRITE(6,'(2x,a2,2x,3(1x,f10.6,1x),'//
     & '4x,a2,i1,a1,2x,f8.4,'//
     & '2x,a2,2x,3(1x,f8.4,1x))')
     & xyzchr(IXYZ), (GTENS(IXYZ,JXYZ),JXYZ=1,3),
     & 'g_',IXYZ,':',SQRT(EVR(IXYZ)),
     & xyzchr(IXYZ), (TMPVEC(IXYZ,JXYZ),JXYZ=1,3)
      ENDDO

 780  CONTINUE

      ISS=ISS+KDGN

      ENDDO

      Call mma_deallocate(ZXR)
      Call mma_deallocate(ZXI)
      Call mma_deallocate(ZYR)
      Call mma_deallocate(ZYI)
      Call mma_deallocate(ZZR)
      Call mma_deallocate(ZZI)
      nullify(pZMR(1)%A2,pZMI(1)%A2,pZMR(2)%A2,pZMI(2)%A2,pZMR(3)%A2,
     &        pZMI(3)%A2)

 800  CONTINUE


******************************************************
******************************************************
******************************************************
** Experimental hyperfine tensor stuff starts here
******************************************************
******************************************************
******************************************************

* Skip if not a hyperfine calculation
      IF(.NOT.IFACAL) GOTO 1801
        CALL HFCTS(PROP,USOR,USOI,ENSOR,NSS,ENERGY,JBNUM,
     &             DIPSOM,ESO,XYZCHR,BOLTZ_K)

1801  CONTINUE
******************************************************
******************************************************
******************************************************
** Experimental hyperfine tensor stuff ends here
******************************************************
******************************************************
******************************************************



C SVC20080312 calculation of magnetization

      IF(.NOT.IFXCAL) GOTO 900

      IF(.not.IFSO) THEN
          WRITE(6,*) 'keyword SPIN needed with MAGN'
          WRITE(6,*)
          GOTO 900
      ENDIF

      WRITE(6,*)
      WRITE(6,*) '  ========================================='
      WRITE(6,*) '  Magnetization and Magnetic Susceptibility'
      WRITE(6,*) '  ========================================='
      WRITE(6,*)

C initialization same as G-tensor, construct L+gS matrix elements
      IAMX=0
      IAMY=0
      IAMZ=0
      DO IPROP=1,NPROP
       IF(PNAME(IPROP)(1:6).EQ.'ANGMOM') THEN
        !write(6,*)"4****ANGMOM rassi/prprop.f "
         IF(ICOMP(IPROP).EQ.1) IAMX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMZ=IPROP
       END IF
      END DO

      Call mma_allocate(LXI,NSS,NSS,Label='LXI')
      LXI(:,:)=0.0D0
      Call mma_allocate(LYI,NSS,NSS,Label='LYI')
      LYI(:,:)=0.0D0
      Call mma_allocate(LZI,NSS,NSS,Label='LZI')
      LZI(:,:)=0.0D0

      IF(IAMX.GT.0) CALL SMMAT(PROP,LXI,NSS,IAMX,0)
      IF(IAMY.GT.0) CALL SMMAT(PROP,LYI,NSS,IAMY,0)
      IF(IAMZ.GT.0) CALL SMMAT(PROP,LZI,NSS,IAMZ,0)

      Call mma_allocate(MXR,NSS,NSS,Label='MXR')
      Call mma_allocate(MXI,NSS,NSS,Label='MXI')
      MXR(:,:)=0.0D0
      MXI(:,:)=0.0D0
      Call mma_allocate(MYR,NSS,NSS,Label='MYR')
      Call mma_allocate(MYI,NSS,NSS,Label='MYI')
      MYR(:,:)=0.0D0
      MYI(:,:)=0.0D0
      Call mma_allocate(MZR,NSS,NSS,Label='MZR')
      Call mma_allocate(MZI,NSS,NSS,Label='MZI')
      MZR(:,:)=0.0D0
      MZI(:,:)=0.0D0

      pMR(1)%A2=>MXR(:,:)
      pMI(1)%A2=>MXI(:,:)
      pMR(2)%A2=>MYR(:,:)
      pMI(2)%A2=>MYI(:,:)
      pMR(3)%A2=>MZR(:,:)
      pMI(3)%A2=>MZI(:,:)

      CALL SMMAT(PROP,MXR,NSS,0,1)
      CALL SMMAT(PROP,MYI,NSS,0,2)
      CALL SMMAT(PROP,MZR,NSS,0,3)

      CALL DSCAL_(NSS**2,FEGVAL,MXR,1)
      CALL DSCAL_(NSS**2,FEGVAL,MYI,1)
      CALL DSCAL_(NSS**2,FEGVAL,MZR,1)

      CALL DAXPY_(NSS**2,1.0D0,LXI,1,MXI,1)
      CALL DAXPY_(NSS**2,1.0D0,LYI,1,MYI,1)
      CALL DAXPY_(NSS**2,1.0D0,LZI,1,MZI,1)

      Call mma_deallocate(LXI)
      Call mma_deallocate(LYI)
      Call mma_deallocate(LZI)

      CALL ZTRNSF(NSS,USOR,USOI,MXR,MXI)
      CALL ZTRNSF(NSS,USOR,USOI,MYR,MYI)
      CALL ZTRNSF(NSS,USOR,USOI,MZR,MZI)

      Call mma_allocate(ZXR,NSS,NSS,Label='ZXR')
      Call mma_allocate(ZXI,NSS,NSS,Label='ZXI')
      ZXR(:,:)=0.0D0
      ZXR(:,:)=0.0D0
      pZMR(1)%A2=>ZXR(:,:)
      pZMI(1)%A2=>ZXI(:,:)
      Call mma_allocate(ZYR,NSS,NSS,Label='ZYR')
      Call mma_allocate(ZYI,NSS,NSS,Label='ZYI')
      ZYR(:,:)=0.0D0
      ZYR(:,:)=0.0D0
      pZMR(2)%A2=>ZYR(:,:)
      pZMI(2)%A2=>ZYI(:,:)
      Call mma_allocate(ZZR,NSS,NSS,Label='ZZR')
      Call mma_allocate(ZZI,NSS,NSS,Label='ZZI')
      ZZR(:,:)=0.0D0
      ZZR(:,:)=0.0D0
      pZMR(3)%A2=>ZZR(:,:)
      pZMI(3)%A2=>ZZI(:,:)

      Call mma_allocate(ZR,NSS,NSS,Label='ZR')
      Call mma_allocate(ZI,NSS,NSS,Label='ZI')
      CALL mma_allocate(UZR,NSS,NSS,Label='UZR')
      CALL mma_allocate(UZI,NSS,NSS,Label='UZI')

      BFINAL=BSTART+(NBSTEP-1)*BINCRE
      TFINAL=TSTART+(NTSTEP-1)*TINCRE

      WRITE(6,*) "Magnetic flux density range (T): "
      WRITE(6,'(2x,f6.2,a3,f6.2,a4,i4,a6)')
     & BSTART," - ",BFINAL," in ",NBSTEP," steps"
      WRITE(6,*)
      WRITE(6,*) "Temperature range (K): "
      WRITE(6,'(2x,f6.2,a3,f6.2,a4,i4,a6)')
     & TSTART," - ",TFINAL," in ",NTSTEP," steps"

      CALL mma_allocate(MAGM,9*NBSTEP*NTSTEP,Label='MAGM')

      LMSTEP=0

      DO IXYZ=1,3

      WRITE(6,*)
      WRITE(6,'(3x,a1,3x,8(1x,a12,1x))') "T",
     & "    B"//xyzchr(IXYZ)//" (T)  ","   M (J/T)  ",
     & "  Mx (J/T)  ","  My (J/T)  ","  Mz (J/T)  ",
     & "Xx"//xyzchr(IXYZ)//" (m3/mol)",
     & "Xy"//xyzchr(IXYZ)//" (m3/mol)",
     & "Xz"//xyzchr(IXYZ)//" (m3/mol)"
      WRITE(6,*)

       DO IBSTEP=1,NBSTEP
        B=BSTART+BINCRE*(IBSTEP-1)
        ZR(:,:)=0.0D0
        ZI(:,:)=0.0D0
        CALL DAXPY_(NSS**2,0.5D0*B/auToT,pMR(IXYZ)%A2,1,ZR,1)
        CALL DAXPY_(NSS**2,0.5D0*B/auToT,pMI(IXYZ)%A2,1,ZI,1)
        DO ISS=1,NSS
         HZER=ZR(ISS,ISS)
         ZR(ISS,ISS)=HZER+ENSOR(ISS)
        END DO
        CALL DCOPY_(NSS**2,[0.0D0],0,UZR,1)
        CALL DCOPY_(NSS   ,[1.0D0],0,UZR,NSS+1)
        CALL DCOPY_(NSS**2,[0.0D0],0,UZI,1)
        CALL ZJAC(NSS,ZR,ZI,NSS,UZR,UZI)
        DO JXYZ=1,3
         CALL DCOPY_(NSS**2,pMR(JXYZ)%A2,1,pZMR(JXYZ)%A2,1)
         CALL DCOPY_(NSS**2,pMI(JXYZ)%A2,1,pZMI(JXYZ)%A2,1)
         CALL DSCAL_(NSS**2,-0.5D0,pZMR(JXYZ)%A2,1)
         CALL DSCAL_(NSS**2,-0.5D0,pZMI(JXYZ)%A2,1)
         CALL ZTRNSF(NSS,UZR,UZI,pZMR(JXYZ)%A2,pZMI(JXYZ)%A2)
        ENDDO
        DO ITSTEP=1,NTSTEP
         T=TSTART+TINCRE*(ITSTEP-1)
         RkT=T*BOLTZ
         RMAGM(1)=0.0D0
         RMAGM(2)=0.0D0
         RMAGM(3)=0.0D0
         RPART=0.0D0
         IF(IPGLOB.GT.2) THEN
          WRITE(6,*)
          WRITE(6,'(2x,a14,3(4x,a4,4x),2x,a6)') "Energy (cm^-1)",
     &     "mu_x", "mu_y", "mu_z","weight"
          WRITE(6,*)
         ENDIF
         DO ISS=1,NSS
          DELTA=ZR(ISS,ISS)-ZR(1,1)
          FACT=EXP(-DELTA/RkT)
          RMAGM(1)=RMAGM(1)+pZMR(1)%A2(ISS,ISS)*FACT
          RMAGM(2)=RMAGM(2)+pZMR(2)%A2(ISS,ISS)*FACT
          RMAGM(3)=RMAGM(3)+pZMR(3)%A2(ISS,ISS)*FACT
          RPART=RPART+FACT
          IF(IPGLOB.GT.2) THEN
           WRITE(6,'(2x,f14.3,3(1x,f10.6,1x),2x,f6.3)')
     &      (ZR(ISS,ISS)-ZR(1,1))*auTocm,
     &      pZMR(1)%A2(ISS,ISS),
     &      pZMR(2)%A2(ISS,ISS),
     &      pZMR(3)%A2(ISS,ISS),FACT
          ENDIF
         ENDDO
         IF(IPGLOB.GT.2) THEN
          WRITE(6,*)
         ENDIF
         RMAGM(1)=(RMAGM(1)/RPART)*AU2JTM
         RMAGM(2)=(RMAGM(2)/RPART)*AU2JTM
         RMAGM(3)=(RMAGM(3)/RPART)*AU2JTM
         RMAGM2=RMAGM(1)*RMAGM(1)+RMAGM(2)*RMAGM(2)+RMAGM(3)*RMAGM(3)
         RMAGMO=SQRT(RMAGM2)
         DO JXYZ=1,3
          LMSTEP=LMSTEP+1
          MAGM(LMSTEP)=RMAGM(JXYZ)
          IF(IBSTEP.GT.1) THEN
              Chi(JXYZ)=RMAGM(JXYZ)-MAGM(LMSTEP-3*NTSTEP)
              Chi(JXYZ)=Chi(JXYZ)*Rmu0/BINCRE
          ENDIF
         ENDDO
          IF(IBSTEP.EQ.1) THEN
         WRITE(6,'(1x,f6.2,5(1x,es12.5,1x))')
     &    T,B,RMAGMO,RMAGM(1),RMAGM(2),RMAGM(3)
          ELSE
         WRITE(6,'(1x,f6.2,8(1x,es12.5,1x))')
     &    T,B,RMAGMO,RMAGM(1),RMAGM(2),RMAGM(3),Chi(1),Chi(2),Chi(3)
          ENDIF
        ENDDO
       ENDDO
      ENDDO

      CALL mma_deallocate(MAGM)

      WRITE(6,*)

C powder magnetization, useful in nonlinear cases

      IF(.NOT.IFMCAL) GOTO 810

      WRITE(6,*)
      WRITE(6,*) "Powder Magnetization"
      WRITE(6,*)
      WRITE(6,'(3x,a1,3x,5(1x,a12,1x))') "T",
     & "    B  (T)  ","   M (J/T)  ",
     & "  Mx (J/T)  ","  My (J/T)  ","  Mz (J/T)  "

      CALL mma_allocate(MAGM,3*NBSTEP*NTSTEP,Label='MAGM')
      MAGM(:)=0.0D0

      NPHISTEP=INT(360.0D0/BANGRES)
      NTHESTEP=INT(180.0D0/BANGRES)

      GTR=ACOS(-1.0D0)/180

C scale number of points on phi via sin(theta)
      NORIENT=0
      DO ITHE=1,NTHESTEP+1
       THE=BANGRES*(ITHE-1)*GTR
       IPHISTEP=INT((NPHISTEP-1)*SIN(THE)+1)
       BPHIRES=360/IPHISTEP
       DO IPHI=1,IPHISTEP
       PHI=BPHIRES*(IPHI-1)*GTR

       NORIENT=NORIENT+1

       LMSTEP=0
*      WRITE(6,*)
*      WRITE(6,'(1x,2(A6,I4))') ' ITHE ',ITHE,' IPHI',IPHI
*      WRITE(6,'(6(5x,A4,5x))')
*    &  ' B  ','THE ','PHI ',' Mx ',' My ',' Mz '
       DO IBSTEP=1,NBSTEP
        B=BSTART+BINCRE*(IBSTEP-1)
        BX=B*SIN(THE)*COS(PHI)
        BY=B*SIN(THE)*SIN(PHI)
        BZ=B*COS(THE)
        CALL DCOPY_(NSS**2,[0.0D0],0,ZR,1)
        CALL DAXPY_(NSS**2,0.5D0*BX/auToT,MXR,1,ZR,1)
        CALL DAXPY_(NSS**2,0.5D0*BY/auToT,MYR,1,ZR,1)
        CALL DAXPY_(NSS**2,0.5D0*BZ/auToT,MZR,1,ZR,1)
        CALL DCOPY_(NSS**2,[0.0D0],0,ZI,1)
        CALL DAXPY_(NSS**2,0.5D0*BX/auToT,MXI,1,ZI,1)
        CALL DAXPY_(NSS**2,0.5D0*BY/auToT,MYI,1,ZI,1)
        CALL DAXPY_(NSS**2,0.5D0*BZ/auToT,MZI,1,ZI,1)
        DO ISS=1,NSS
         HZER=ZR(ISS,ISS)
         ZR(ISS,ISS)=HZER+ENSOR(ISS)
        END DO
        CALL DCOPY_(NSS**2,[0.0D0],0,UZR,1)
        CALL DCOPY_(NSS   ,[1.0D0],0,UZR,NSS+1)
        CALL DCOPY_(NSS**2,[0.0D0],0,UZI,1)
        CALL ZJAC(NSS,ZR,ZI,NSS,UZR,UZI)
        DO IXYZ=1,3
         CALL DCOPY_(NSS**2,pMR(IXYZ)%A2,1,pZMR(IXYZ)%A2,1)
         CALL DCOPY_(NSS**2,pMI(IXYZ)%A2,1,pZMI(IXYZ)%A2,1)
         CALL DSCAL_(NSS**2,-0.5D0,pZMR(IXYZ)%A2,1)
         CALL DSCAL_(NSS**2,-0.5D0,pZMI(IXYZ)%A2,1)
         CALL ZTRNSF(NSS,UZR,UZI,pZMR(IXYZ)%A2,pZMI(IXYZ)%A2)
        ENDDO
        DO ITSTEP=1,NTSTEP
         T=TSTART+TINCRE*(ITSTEP-1)
         RkT=T*BOLTZ
         RMAGM(1)=0.0D0
         RMAGM(2)=0.0D0
         RMAGM(3)=0.0D0
         RPART=0.0D0
         DO ISS=1,NSS
          DELTA=ZR(ISS,ISS)-ZR(1,1)
          FACT=EXP(-DELTA/RkT)
          RMAGM(1)=RMAGM(1)+pZMR(1)%A2(ISS,ISS)*FACT
          RMAGM(2)=RMAGM(2)+pZMR(2)%A2(ISS,ISS)*FACT
          RMAGM(3)=RMAGM(3)+pZMR(3)%A2(ISS,ISS)*FACT
          RPART=RPART+FACT
         ENDDO
         RMAGM(1)=(RMAGM(1)/RPART)*AU2JTM
         RMAGM(2)=(RMAGM(2)/RPART)*AU2JTM
         RMAGM(3)=(RMAGM(3)/RPART)*AU2JTM
*        WRITE(6,'(6(1x,es12.5,1x))')
*    &    B,THE,PHI,RMAGM(1),RMAGM(2),RMAGM(3)
C backtransformation in two steps, -phi and -theta
         A=RMAGM(1)
         B=RMAGM(2)
         RMAGM(1)=A*COS(PHI)+B*SIN(PHI)
         RMAGM(2)=B*COS(PHI)-A*SIN(PHI)
         A=RMAGM(1)
         B=RMAGM(3)
         RMAGM(1)=A*COS(THE)-B*SIN(THE)
         RMAGM(3)=B*COS(THE)+A*SIN(THE)
         DO IXYZ=1,3
          LMSTEP=LMSTEP+1
          MAGM(LMSTEP)=MAGM(LMSTEP)+RMAGM(IXYZ)
         ENDDO
        ENDDO
       ENDDO

       ENDDO
      ENDDO

      WRITE(6,*)
      LMSTEP=0
      DO IBSTEP=1,NBSTEP
       B=BSTART+BINCRE*(IBSTEP-1)
       DO ITSTEP=1,NTSTEP
        T=TSTART+TINCRE*(ITSTEP-1)
        DO IXYZ=1,3
        LMSTEP=LMSTEP+1
          RMAGM(IXYZ)=MAGM(LMSTEP)/NORIENT
        ENDDO
        RMAGM2=RMAGM(1)*RMAGM(1)+RMAGM(2)*RMAGM(2)+RMAGM(3)*RMAGM(3)
        RMAGMO=SQRT(RMAGM2)
        WRITE(6,'(1x,f6.2,5(1x,es12.5,1x))')
     &   T,B,RMAGMO,RMAGM(1),RMAGM(2),RMAGM(3)
       ENDDO
      ENDDO

      CALL mma_deallocate(MAGM)

 810  CONTINUE

      WRITE(6,*)

      Call mma_deallocate(ZR)
      Call mma_deallocate(ZI)
      Call mma_deallocate(UZR)
      Call mma_deallocate(UZI)

      Call mma_deallocate(ZXR)
      Call mma_deallocate(ZXI)
      Call mma_deallocate(ZYR)
      Call mma_deallocate(ZYI)
      Call mma_deallocate(ZZR)
      Call mma_deallocate(ZZI)

      Call mma_deallocate(MXR)
      Call mma_deallocate(MXI)
      Call mma_deallocate(MYR)
      Call mma_deallocate(MYI)
      Call mma_deallocate(MZR)
      Call mma_deallocate(MZI)
      nullify(pMR(1)%A2,pMI(1)%A2,pMR(2)%A2,pMI(2)%A2,pMR(3)%A2,
     &        pMI(3)%A2)

 900  CONTINUE

30    FORMAT (5X,A,1X,ES15.8)
31    FORMAT (5X,2(1X,A4),6X,A15,1X,A47,1X,A15)
32    FORMAT (5X,95('-'))
33    FORMAT (5X,2(1X,I4),5X,5(1X,ES15.8))
35    FORMAT (5X,31('-'))
36    FORMAT (5X,2(1X,I4),6X,15('-'),1X,ES15.8,1X,A15)
37    FORMAT (5X,2(1X,I4),6X,15('-'),1X,A15,1X,ES15.8)
38    FORMAT (5X,2(1X,I4),6X,F15.6,4(1X,ES15.8))
39    FORMAT (5X,2(1X,A4),6X,A15,1X,A15,1X,A15)
40    FORMAT (5X,63('-'))
43    FORMAT (12X,A8,6(1X,ES15.6))
44    FORMAT (20X,6(1X,A15))
49    FORMAT (5X,A,1X,ES15.8,1X,A)

      Contains

      Subroutine Allocate_and_Load_electric_dipoles(IFANY)
      Integer ISOPR
      Integer IPRDX, IPRDY, IPRDZ, IFANY
         IPRDX=0
         IPRDY=0
         IPRDZ=0
         IFANY=0
         DO ISOPR=1,NSOPR
           IF(SOPRNM(ISOPR).EQ.'MLTPL  1'.AND.
     &        SOPRTP(ISOPR).EQ.'HERMSING') THEN
            IFANY=1
            IF(ISOCMP(ISOPR).EQ.1) IPRDX=ISOPR
            IF(ISOCMP(ISOPR).EQ.2) IPRDY=ISOPR
            IF(ISOCMP(ISOPR).EQ.3) IPRDZ=ISOPR
           END IF
         END DO
         CALL mma_allocate(DXR,NSS,NSS,Label='DXR')
         CALL mma_allocate(DXI,NSS,NSS,Label='DXI')
         CALL mma_allocate(DYR,NSS,NSS,Label='DYR')
         CALL mma_allocate(DYI,NSS,NSS,Label='DYI')
         CALL mma_allocate(DZR,NSS,NSS,Label='DZR')
         CALL mma_allocate(DZI,NSS,NSS,Label='DZI')
         DXR(:,:)=0.0D0
         DXI(:,:)=0.0D0
         DYR(:,:)=0.0D0
         DYI(:,:)=0.0D0
         DZR(:,:)=0.0D0
         DZI(:,:)=0.0D0
         IF(IPRDX.GT.0) THEN
          CALL SMMAT(PROP,DXR,NSS,IPRDX,0)
          CALL ZTRNSF(NSS,USOR,USOI,DXR,DXI)
         END IF
         IF(IPRDY.GT.0) THEN
          CALL SMMAT(PROP,DYR,NSS,IPRDY,0)
          CALL ZTRNSF(NSS,USOR,USOI,DYR,DYI)
         END IF
         IF(IPRDZ.GT.0) THEN
          CALL SMMAT(PROP,DZR,NSS,IPRDZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,DZR,DZI)
         END If
      End Subroutine Allocate_and_Load_electric_dipoles

      Subroutine Allocate_and_Load_velocities(IFANY)
      Integer ISOPR
      Integer IPRDX, IPRDY, IPRDZ, IFANY
         IPRDX=0
         IPRDY=0
         IPRDZ=0
         IFANY=0
         DO ISOPR=1,NSOPR
           IF(SOPRNM(ISOPR).EQ.'VELOCITY') THEN
            IFANY=1
            IF(ISOCMP(ISOPR).EQ.1) IPRDX=ISOPR
            IF(ISOCMP(ISOPR).EQ.2) IPRDY=ISOPR
            IF(ISOCMP(ISOPR).EQ.3) IPRDZ=ISOPR
           END IF
         END DO
         CALL mma_allocate(DXR,NSS,NSS,Label='DXR')
         CALL mma_allocate(DXI,NSS,NSS,Label='DXI')
         CALL mma_allocate(DYR,NSS,NSS,Label='DYR')
         CALL mma_allocate(DYI,NSS,NSS,Label='DYI')
         CALL mma_allocate(DZR,NSS,NSS,Label='DZR')
         CALL mma_allocate(DZI,NSS,NSS,Label='DZI')
         DXR(:,:)=0.0D0
         DXI(:,:)=0.0D0
         DYR(:,:)=0.0D0
         DYI(:,:)=0.0D0
         DZR(:,:)=0.0D0
         DZI(:,:)=0.0D0
         IF(IPRDX.GT.0) THEN
          CALL SMMAT(PROP,DXR,NSS,IPRDX,0)
          CALL ZTRNSF(NSS,USOR,USOI,DXR,DXI)
         END IF
         IF(IPRDY.GT.0) THEN
          CALL SMMAT(PROP,DYR,NSS,IPRDY,0)
          CALL ZTRNSF(NSS,USOR,USOI,DYR,DYI)
         END IF
         IF(IPRDZ.GT.0) THEN
          CALL SMMAT(PROP,DZR,NSS,IPRDZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,DZR,DZI)
         END If
      End Subroutine Allocate_and_Load_velocities

      Subroutine Deallocate_electric_dipoles()
         CALL mma_deallocate(DXR)
         CALL mma_deallocate(DXI)
         CALL mma_deallocate(DYR)
         CALL mma_deallocate(DYI)
         CALL mma_deallocate(DZR)
         CALL mma_deallocate(DZI)
      End Subroutine Deallocate_electric_dipoles

      Subroutine Allocate_and_Load_magnetic_dipoles(IFANY)
      Integer ISOPR
      Integer IPRMDX, IPRMDY, IPRMDZ, IFANY
         IPRMDX=0
         IPRMDY=0
         IPRMDZ=0

         IFANY=0
         DO ISOPR=1,NSOPR
           IF(SOPRNM(ISOPR).EQ.'ANGMOM  ') THEN
            IFANY=1
            IF(ISOCMP(ISOPR).EQ.1) IPRMDX=ISOPR
            IF(ISOCMP(ISOPR).EQ.2) IPRMDY=ISOPR
            IF(ISOCMP(ISOPR).EQ.3) IPRMDZ=ISOPR
           END IF
         END DO
         CALL mma_allocate(MDXR,NSS,NSS,Label='MDXR')
         CALL mma_allocate(MDXI,NSS,NSS,Label='MDXI')
         CALL mma_allocate(MDYR,NSS,NSS,Label='MDYR')
         CALL mma_allocate(MDYI,NSS,NSS,Label='MDYI')
         CALL mma_allocate(MDZR,NSS,NSS,Label='MDZR')
         CALL mma_allocate(MDZI,NSS,NSS,Label='MDZI')
         MDXR(:,:)=0.0D0
         MDXI(:,:)=0.0D0
         MDYR(:,:)=0.0D0
         MDYI(:,:)=0.0D0
         MDZR(:,:)=0.0D0
         MDZI(:,:)=0.0D0
         IF(IPRMDX.GT.0) THEN
          CALL SMMAT(PROP,MDXR,NSS,IPRMDX,0)
          CALL ZTRNSF(NSS,USOR,USOI,MDXR,MDXI)
         END IF
         IF(IPRMDY.GT.0) THEN
          CALL SMMAT(PROP,MDYR,NSS,IPRMDY,0)
          CALL ZTRNSF(NSS,USOR,USOI,MDYR,MDYI)
         END IF
         IF(IPRMDZ.GT.0) THEN
          CALL SMMAT(PROP,MDZR,NSS,IPRMDZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,MDZR,MDZI)
         END If
      End Subroutine Allocate_and_Load_magnetic_dipoles

      Subroutine Deallocate_magnetic_dipoles()
         CALL mma_deallocate(MDXR)
         CALL mma_deallocate(MDXI)
         CALL mma_deallocate(MDYR)
         CALL mma_deallocate(MDYI)
         CALL mma_deallocate(MDZR)
         CALL mma_deallocate(MDZI)
      End Subroutine Deallocate_magnetic_dipoles

      Subroutine Allocate_and_Load_Spin_Magnetic_dipoles(IFANY)
      Integer ISOPR
      Integer IPRSX, IPRSY, IPRSZ, IFANY
         IPRSX=0
         IPRSY=0
         IPRSZ=0

         IFANY=0
         DO ISOPR=1,NSOPR
            IF(SOPRNM(ISOPR).EQ.'MLTPL  0'.AND.
     &         SOPRTP(ISOPR).EQ.'ANTITRIP') THEN
            IFANY=1
            IF(ISOCMP(ISOPR).EQ.1) IPRSX=ISOPR
            IF(ISOCMP(ISOPR).EQ.1) IPRSY=ISOPR
            IF(ISOCMP(ISOPR).EQ.1) IPRSZ=ISOPR
           END IF
         END DO
         CALL mma_allocate(SXR,NSS,NSS,Label='SXR')
         CALL mma_allocate(SXI,NSS,NSS,Label='SXI')
         CALL mma_allocate(SYR,NSS,NSS,Label='SYR')
         CALL mma_allocate(SYI,NSS,NSS,Label='SYI')
         CALL mma_allocate(SZR,NSS,NSS,Label='SZR')
         CALL mma_allocate(SZI,NSS,NSS,Label='SZI')
         SXR(:,:)=0.0D0
         SXI(:,:)=0.0D0
         SYR(:,:)=0.0D0
         SYI(:,:)=0.0D0
         SZR(:,:)=0.0D0
         SZI(:,:)=0.0D0
         IF(IPRSX.GT.0) THEN
          CALL SMMAT(PROP,SXR,NSS,IPRSX,1)
          CALL ZTRNSF(NSS,USOR,USOI,SXR,SXI)
         END IF
         IF(IPRSY.GT.0) THEN
          CALL SMMAT(PROP,SYR,NSS,IPRSY,2)
          CALL ZTRNSF(NSS,USOR,USOI,SYR,SYI)
         END IF
         IF(IPRSZ.GT.0) THEN
          CALL SMMAT(PROP,SZR,NSS,IPRSZ,3)
          CALL ZTRNSF(NSS,USOR,USOI,SZR,SZI)
         END IF
      End Subroutine Allocate_and_Load_Spin_Magnetic_dipoles

      Subroutine Deallocate_Spin_Magnetic_dipoles()
         CALL mma_deallocate(SXR)
         CALL mma_deallocate(SXI)
         CALL mma_deallocate(SYR)
         CALL mma_deallocate(SYI)
         CALL mma_deallocate(SZR)
         CALL mma_deallocate(SZI)
      End Subroutine Deallocate_Spin_Magnetic_dipoles

      Subroutine Allocate_and_Load_Spin_Magnetic_Quadrupoles(IFANY)
      Integer ISOPR
      Integer IPRSXY, IPRSXZ, IPRSYX, IPRSYZ, IPRSZX, IPRSZY, IFANY
         IPRSXY=0
         IPRSXZ=0

         IPRSYX=0
         IPRSYZ=0

         IPRSZX=0
         IPRSZY=0
         IFANY=0
         DO ISOPR=1,NSOPR
           IF(SOPRNM(ISOPR).EQ.'MLTPL  1'.AND.
     &             SOPRTP(ISOPR).EQ.'ANTITRIP') THEN
            IFANY=1
            IF(ISOCMP(ISOPR).EQ.1) IPRSXY=ISOPR
            IF(ISOCMP(ISOPR).EQ.1) IPRSXZ=ISOPR

            IF(ISOCMP(ISOPR).EQ.2) IPRSYX=ISOPR
            IF(ISOCMP(ISOPR).EQ.2) IPRSYZ=ISOPR

            IF(ISOCMP(ISOPR).EQ.3) IPRSZX=ISOPR
            IF(ISOCMP(ISOPR).EQ.3) IPRSZY=ISOPR

           END IF
         END DO
         CALL mma_allocate(SZXR,NSS,NSS,Label='SZXR')
         CALL mma_allocate(SZXI,NSS,NSS,Label='SZXI')
         SZXR(:,:)=0.0D0
         SZXI(:,:)=0.0D0
         CALL mma_allocate(SXZR,NSS,NSS,Label='SXZR')
         CALL mma_allocate(SXZI,NSS,NSS,Label='SXZI')
         SXZR(:,:)=0.0D0
         SXZI(:,:)=0.0D0

         CALL mma_allocate(SXYR,NSS,NSS,Label='SXYR')
         CALL mma_allocate(SXYI,NSS,NSS,Label='SXYI')
         SXYR(:,:)=0.0D0
         SXYI(:,:)=0.0D0
         CALL mma_allocate(SYXR,NSS,NSS,Label='SYXR')
         CALL mma_allocate(SYXI,NSS,NSS,Label='SYXI')
         SYXR(:,:)=0.0D0
         SYXI(:,:)=0.0D0

         CALL mma_allocate(SYZR,NSS,NSS,Label='SYZR')
         CALL mma_allocate(SYZI,NSS,NSS,Label='SYZI')
         SYZR(:,:)=0.0D0
         SYZI(:,:)=0.0D0
         CALL mma_allocate(SZYR,NSS,NSS,Label='SZYR')
         CALL mma_allocate(SZYI,NSS,NSS,Label='SZYI')
         SZYR(:,:)=0.0D0
         SZYI(:,:)=0.0D0
         IF(IPRSXY.GT.0) THEN
          CALL SMMAT(PROP,SXYR,NSS,IPRSXY,2)
          CALL ZTRNSF(NSS,USOR,USOI,SXYR,SXYI)
         END IF
         IF(IPRSYX.GT.0) THEN
          CALL SMMAT(PROP,SYXR,NSS,IPRSYX,1)
          CALL ZTRNSF(NSS,USOR,USOI,SYXR,SYXI)
         END IF

         IF(IPRSXZ.GT.0) THEN
          CALL SMMAT(PROP,SXZR,NSS,IPRSXZ,3)
          CALL ZTRNSF(NSS,USOR,USOI,SXZR,SXZI)
         END IF
         IF(IPRSZX.GT.0) THEN
          CALL SMMAT(PROP,SZXR,NSS,IPRSZX,1)
          CALL ZTRNSF(NSS,USOR,USOI,SZXR,SZXI)
         END IF

         IF(IPRSYZ.GT.0) THEN
          CALL SMMAT(PROP,SYZR,NSS,IPRSYZ,3)
          CALL ZTRNSF(NSS,USOR,USOI,SYZR,SYZI)
         END IF
         IF(IPRSZY.GT.0) THEN
          CALL SMMAT(PROP,SZYR,NSS,IPRSZY,2)
          CALL ZTRNSF(NSS,USOR,USOI,SZYR,SZYI)
         END IF
      End Subroutine Allocate_and_Load_Spin_Magnetic_Quadrupoles

      Subroutine Deallocate_Spin_Magnetic_Quadrupoles()
         Call mma_deallocate(SXYR)
         Call mma_deallocate(SXYI)
         Call mma_deallocate(SYXR)
         Call mma_deallocate(SYXI)

         Call mma_deallocate(SYZR)
         Call mma_deallocate(SYZI)
         Call mma_deallocate(SZYR)
         Call mma_deallocate(SZYI)

         Call mma_deallocate(SZXR)
         Call mma_deallocate(SZXI)
         Call mma_deallocate(SXZR)
         Call mma_deallocate(SXZI)
      End Subroutine Deallocate_Spin_Magnetic_Quadrupoles

      Subroutine Allocate_and_Load_Electric_Quadrupoles(IFANY)
      Integer ISOPR
      Integer IPRDXX, IPRDXY, IPRDXZ, IPRDYY, IPRDYZ, IPRDZZ, IFANY
         IPRDXX=0
         IPRDXY=0
         IPRDXZ=0
         IPRDYY=0
         IPRDYZ=0
         IPRDZZ=0

         IFANY=0
         DO ISOPR=1,NSOPR
           IF(SOPRNM(ISOPR).EQ.'MLTPL  2') THEN
            IFANY=1
            IF(ISOCMP(ISOPR).EQ.1) IPRDXX=ISOPR
            IF(ISOCMP(ISOPR).EQ.2) IPRDXY=ISOPR
            IF(ISOCMP(ISOPR).EQ.3) IPRDXZ=ISOPR
            IF(ISOCMP(ISOPR).EQ.4) IPRDYY=ISOPR
            IF(ISOCMP(ISOPR).EQ.5) IPRDYZ=ISOPR
            IF(ISOCMP(ISOPR).EQ.6) IPRDZZ=ISOPR
           END IF
         END DO
         CALL mma_allocate(QXXR,NSS,NSS,Label='QXXR')
         CALL mma_allocate(QXXI,NSS,NSS,Label='DXXI')
         CALL mma_allocate(QXYR,NSS,NSS,Label='DXYR')
         CALL mma_allocate(QXYI,NSS,NSS,Label='DXYI')
         CALL mma_allocate(QXZR,NSS,NSS,Label='DXZR')
         CALL mma_allocate(QXZI,NSS,NSS,Label='DXZI')
         CALL mma_allocate(QYYR,NSS,NSS,Label='DYYR')
         CALL mma_allocate(QYYI,NSS,NSS,Label='DYYI')
         CALL mma_allocate(QYZR,NSS,NSS,Label='DYZR')
         CALL mma_allocate(QYZI,NSS,NSS,Label='DYZI')
         CALL mma_allocate(QZZR,NSS,NSS,Label='DZZR')
         CALL mma_allocate(QZZI,NSS,NSS,Label='DZZI')
         QXXR(:,:)=0.0D0
         QXXI(:,:)=0.0D0
         QXYR(:,:)=0.0D0
         QXYI(:,:)=0.0D0
         QXZR(:,:)=0.0D0
         QXZI(:,:)=0.0D0
         QYYR(:,:)=0.0D0
         QYYI(:,:)=0.0D0
         QYZR(:,:)=0.0D0
         QYZI(:,:)=0.0D0
         QZZR(:,:)=0.0D0
         QZZI(:,:)=0.0D0
         IF(IPRDXX.GT.0) THEN
          CALL SMMAT(PROP,QXXR,NSS,IPRDXX,0)
          CALL ZTRNSF(NSS,USOR,USOI,QXXR,QXXI)
         END IF
         IF(IPRDXY.GT.0) THEN
          CALL SMMAT(PROP,QXYR,NSS,IPRDXY,0)
          CALL ZTRNSF(NSS,USOR,USOI,QXYR,QXYI)
         END IF
         IF(IPRDXZ.GT.0) THEN
          CALL SMMAT(PROP,QXZR,NSS,IPRDXZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,QXZR,QXZI)
         END IF
         IF(IPRDYY.GT.0) THEN
          CALL SMMAT(PROP,QYYR,NSS,IPRDYY,0)
          CALL ZTRNSF(NSS,USOR,USOI,QYYR,QYYI)
         END IF
         IF(IPRDYZ.GT.0) THEN
          CALL SMMAT(PROP,QYZR,NSS,IPRDYZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,QYZR,QYZI)
         END IF
         IF(IPRDZZ.GT.0) THEN
          CALL SMMAT(PROP,QZZR,NSS,IPRDZZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,QZZR,QZZI)
         END IF
      End Subroutine Allocate_and_Load_Electric_Quadrupoles

      Subroutine Deallocate_Electric_Quadrupoles()
         CALL mma_deallocate(QXXR)
         CALL mma_deallocate(QXXI)
         CALL mma_deallocate(QXYR)
         CALL mma_deallocate(QXYI)
         CALL mma_deallocate(QXZR)
         CALL mma_deallocate(QXZI)
         CALL mma_deallocate(QYYR)
         CALL mma_deallocate(QYYI)
         CALL mma_deallocate(QYZR)
         CALL mma_deallocate(QYZI)
         CALL mma_deallocate(QZZR)
         CALL mma_deallocate(QZZI)
      End Subroutine Deallocate_Electric_Quadrupoles

      Subroutine Allocate_and_Load_Magnetic_Quadrupoles(IFANY)
      Integer ISOPR
      Integer IPRDZX, IPRDYX, IPRDZY, IFANY
         IPRDXY=0
         IPRDXZ=0
         IPRDYX=0
         IPRDYZ=0
         IPRDZX=0
         IPRDZY=0

         IFANY=0
         DO ISOPR=1,NSOPR
           IF(SOPRNM(ISOPR).EQ.'OMQ') THEN
            IFANY=1
            IF(ISOCMP(ISOPR).EQ.2) IPRDXY=ISOPR
            IF(ISOCMP(ISOPR).EQ.3) IPRDXZ=ISOPR

            IF(ISOCMP(ISOPR).EQ.4) IPRDYX=ISOPR
            IF(ISOCMP(ISOPR).EQ.6) IPRDYZ=ISOPR

            IF(ISOCMP(ISOPR).EQ.7) IPRDZX=ISOPR
            IF(ISOCMP(ISOPR).EQ.8) IPRDZY=ISOPR
           END IF
         END DO

         CALL mma_allocate(MQXYR,NSS,NSS,Label='MQXYR')
         CALL mma_allocate(MQXYI,NSS,NSS,Label='MQXYI')
         CALL mma_allocate(MQYXR,NSS,NSS,Label='MQYXR')
         CALL mma_allocate(MQYXI,NSS,NSS,Label='MQYXI')
         CALL mma_allocate(MQXZR,NSS,NSS,Label='MQXZR')
         CALL mma_allocate(MQXZI,NSS,NSS,Label='MQXZI')
         CALL mma_allocate(MQZXR,NSS,NSS,Label='MQZXR')
         CALL mma_allocate(MQZXI,NSS,NSS,Label='MQZXI')
         CALL mma_allocate(MQYZR,NSS,NSS,Label='MQYZR')
         CALL mma_allocate(MQYZI,NSS,NSS,Label='MQYZI')
         CALL mma_allocate(MQZYR,NSS,NSS,Label='MQZYR')
         CALL mma_allocate(MQZYI,NSS,NSS,Label='MQZYI')
         MQXYR(:,:)=0.0D0
         MQXYI(:,:)=0.0D0
         MQYXR(:,:)=0.0D0
         MQYXI(:,:)=0.0D0
         MQXZR(:,:)=0.0D0
         MQXZI(:,:)=0.0D0
         MQZXR(:,:)=0.0D0
         MQZXI(:,:)=0.0D0
         MQYZR(:,:)=0.0D0
         MQYZI(:,:)=0.0D0
         MQZYR(:,:)=0.0D0
         MQZYI(:,:)=0.0D0
         IF(IPRDXY.GT.0) THEN
          CALL SMMAT(PROP,MQXYR,NSS,IPRDXY,0)
          CALL ZTRNSF(NSS,USOR,USOI,MQXYR,MQXYI)
         END IF
         IF(IPRDYX.GT.0) THEN
          CALL SMMAT(PROP,MQYXR,NSS,IPRDYX,0)
          CALL ZTRNSF(NSS,USOR,USOI,MQYXR,MQYXI)
         END IF

         IF(IPRDXZ.GT.0) THEN
          CALL SMMAT(PROP,MQXZR,NSS,IPRDXZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,MQXZR,MQXZI)
         END IF
         IF(IPRDZX.GT.0) THEN
          CALL SMMAT(PROP,MQZXR,NSS,IPRDZX,0)
          CALL ZTRNSF(NSS,USOR,USOI,MQZXR,MQZXI)
         END IF

         IF(IPRDYZ.GT.0) THEN
          CALL SMMAT(PROP,MQYZR,NSS,IPRDYZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,MQYZR,MQYZI)
         END IF
         IF(IPRDZY.GT.0) THEN
          CALL SMMAT(PROP,MQZYR,NSS,IPRDZY,0)
          CALL ZTRNSF(NSS,USOR,USOI,MQZYR,MQZYI)
         END IF
      End Subroutine Allocate_and_Load_Magnetic_Quadrupoles

      Subroutine Deallocate_Magnetic_Quadrupoles()
         CALL mma_deallocate(MQXYR)
         CALL mma_deallocate(MQXYI)
         CALL mma_deallocate(MQYXR)
         CALL mma_deallocate(MQYXI)
         CALL mma_deallocate(MQXZR)
         CALL mma_deallocate(MQXZI)
         CALL mma_deallocate(MQZXR)
         CALL mma_deallocate(MQZXI)
         CALL mma_deallocate(MQYZR)
         CALL mma_deallocate(MQYZI)
         CALL mma_deallocate(MQZYR)
         CALL mma_deallocate(MQZYI)
      End Subroutine Deallocate_Magnetic_Quadrupoles

      Subroutine Allocate_and_Load_Octupoles(IFANY)
      Integer ISOPR
      Integer IPRDZZX, IPRDZZY, IPRDZZZ, IPRDXXX, IPRDXXY, IPRDXXZ,
     &        IPRDYYX, IPRDYYY, IPRDYYZ, IFANY
! This is a real symmetric rank 3 tensor so only 10 and not 27 is needed
! The order which comes in
         IPRDXXX=0 !
         IPRDXXY=0 !
         IPRDXXZ=0 !

!        IPRDXYX=0
!        IPRDXYY=0 ! YYX These are the same due to symmetry
!        IPRDXYZ=0 ! Not present

!        IPRDXZX=0
!        IPRDXZY=0
!        IPRDXZZ=0 ! ZZX

!        IPRDYXX=0
!        IPRDYXY=0
!        IPRDYXZ=0

         IPRDYYX=0 ! Taking the XYY order
         IPRDYYY=0 !
         IPRDYYZ=0 !

!        IPRDYZX=0
!        IPRDYZY=0
!        IPRDYZZ=0 ! ZZY

!        IPRDZXX=0
!        IPRDZXY=0
!        IPRDZXZ=0

!        IPRDZYX=0
!        IPRDZYY=0
!        IPRDZYZ=0

         IPRDZZX=0 ! Taking order from XZZ
         IPRDZZY=0 ! Taking order from YZZ
         IPRDZZZ=0 !

         IFANY=0
         DO ISOPR=1,NSOPR
           IF(SOPRNM(ISOPR).EQ.'MLTPL  3') THEN
            IFANY=1
            IF(ISOCMP(ISOPR).EQ.1) IPRDXXX=ISOPR
            IF(ISOCMP(ISOPR).EQ.2) IPRDXXY=ISOPR
            IF(ISOCMP(ISOPR).EQ.3) IPRDXXZ=ISOPR
            IF(ISOCMP(ISOPR).EQ.4) IPRDYYX=ISOPR ! Changed from XYY
            !IF(ISOCMP(ISOPR).EQ.5) IPRDXYZ=ISOPR
            IF(ISOCMP(ISOPR).EQ.6) IPRDZZX=ISOPR ! Changed from XZZ
            IF(ISOCMP(ISOPR).EQ.7) IPRDYYY=ISOPR
            IF(ISOCMP(ISOPR).EQ.8) IPRDYYZ=ISOPR
            IF(ISOCMP(ISOPR).EQ.9) IPRDZZY=ISOPR ! Changed from YZZ
            IF(ISOCMP(ISOPR).EQ.10) IPRDZZZ=ISOPR

           END IF
         END DO
         CALL mma_allocate(DXXXR,NSS,NSS,Label='DXXXR')
         CALL mma_allocate(DXXXI,NSS,NSS,Label='DXXXI')
         CALL mma_allocate(DXXYR,NSS,NSS,Label='DXXYR')
         CALL mma_allocate(DXXYI,NSS,NSS,Label='DXXYI')
         CALL mma_allocate(DXXZR,NSS,NSS,Label='DXXZR')
         CALL mma_allocate(DXXZI,NSS,NSS,Label='DXXZI')
         DXXXR(:,:)=0.0D0
         DXXXI(:,:)=0.0D0
         DXXYR(:,:)=0.0D0
         DXXYI(:,:)=0.0D0
         DXXZR(:,:)=0.0D0
         DXXZI(:,:)=0.0D0
         CALL mma_allocate(DYYXR,NSS,NSS,Label='DYYXR')
         CALL mma_allocate(DYYXI,NSS,NSS,Label='DYYXI')
         CALL mma_allocate(DYYYR,NSS,NSS,Label='DYYYR')
         CALL mma_allocate(DYYYI,NSS,NSS,Label='DYYYI')
         CALL mma_allocate(DYYZR,NSS,NSS,Label='DYYZR')
         CALL mma_allocate(DYYZI,NSS,NSS,Label='DYYZI')
         DYYXR(:,:)=0.0D0
         DYYXI(:,:)=0.0D0
         DYYYR(:,:)=0.0D0
         DYYYI(:,:)=0.0D0
         DYYZR(:,:)=0.0D0
         DYYZI(:,:)=0.0D0
         CALL mma_allocate(DZZXR,NSS,NSS,Label='DZZXR')
         CALL mma_allocate(DZZXI,NSS,NSS,Label='DZZXI')
         CALL mma_allocate(DZZYR,NSS,NSS,Label='DZZYR')
         CALL mma_allocate(DZZYI,NSS,NSS,Label='DZZYI')
         CALL mma_allocate(DZZZR,NSS,NSS,Label='DZZZR')
         CALL mma_allocate(DZZZI,NSS,NSS,Label='DZZZI')
         DZZXR(:,:)=0.0D0
         DZZXI(:,:)=0.0D0
         DZZYR(:,:)=0.0D0
         DZZYI(:,:)=0.0D0
         DZZZR(:,:)=0.0D0
         DZZZI(:,:)=0.0D0
         IF(IPRDXXX.GT.0) THEN
          CALL SMMAT(PROP,DXXXR,NSS,IPRDXXX,0)
          CALL ZTRNSF(NSS,USOR,USOI,DXXXR,DXXXI)
         END IF
         IF(IPRDXXY.GT.0) THEN
          CALL SMMAT(PROP,DXXYR,NSS,IPRDXXY,0)
          CALL ZTRNSF(NSS,USOR,USOI,DXXYR,DXXYI)
         END IF
         IF(IPRDXXZ.GT.0) THEN
          CALL SMMAT(PROP,DXXZR,NSS,IPRDXXZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,DXXZR,DXXZI)
         END IF

         IF(IPRDYYX.GT.0) THEN
          CALL SMMAT(PROP,DYYXR,NSS,IPRDYYX,0)
          CALL ZTRNSF(NSS,USOR,USOI,DYYXR,DYYXI)
         END IF
         IF(IPRDYYY.GT.0) THEN
          CALL SMMAT(PROP,DYYYR,NSS,IPRDYYY,0)
          CALL ZTRNSF(NSS,USOR,USOI,DYYYR,DYYYI)
         END IF
         IF(IPRDYYZ.GT.0) THEN
          CALL SMMAT(PROP,DYYZR,NSS,IPRDYYZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,DYYZR,DYYZI)
         END IF

         IF(IPRDZZX.GT.0) THEN
          CALL SMMAT(PROP,DZZXR,NSS,IPRDZZX,0)
          CALL ZTRNSF(NSS,USOR,USOI,DZZXR,DZZXI)
         END IF
         IF(IPRDZZY.GT.0) THEN
          CALL SMMAT(PROP,DZZYR,NSS,IPRDZZY,0)
          CALL ZTRNSF(NSS,USOR,USOI,DZZYR,DZZYI)
         END IF
         IF(IPRDZZZ.GT.0) THEN
          CALL SMMAT(PROP,DZZZR,NSS,IPRDZZZ,0)
          CALL ZTRNSF(NSS,USOR,USOI,DZZZR,DZZZI)
         END IF
      End Subroutine Allocate_and_Load_Octupoles

      Subroutine deallocate_Octupoles()
         CALL mma_deallocate(DXXXR)
         CALL mma_deallocate(DXXXI)
         CALL mma_deallocate(DXXYR)
         CALL mma_deallocate(DXXYI)
         CALL mma_deallocate(DXXZR)
         CALL mma_deallocate(DXXZI)
         CALL mma_deallocate(DYYXR)
         CALL mma_deallocate(DYYXI)
         CALL mma_deallocate(DYYYR)
         CALL mma_deallocate(DYYYI)
         CALL mma_deallocate(DYYZR)
         CALL mma_deallocate(DYYZI)
         CALL mma_deallocate(DZZXR)
         CALL mma_deallocate(DZZXI)
         CALL mma_deallocate(DZZYR)
         CALL mma_deallocate(DZZYI)
         CALL mma_deallocate(DZZZR)
         CALL mma_deallocate(DZZZI)
      End Subroutine deallocate_Octupoles

      END SUBROUTINE PRPROP

      SUBROUTINE SINANI(KDGN,IFUNCT,NSS,DIPSOm,SPNSFS,DIPSOm_SA)
      use definitions, only: iwp, wp, u6
      IMPLICIT NONE
      INTEGER(kind=iwp), intent(in):: KDGN,IFUNCT,NSS
      COMPLEX(kind=wp), intent(in):: DIPSOm(3,NSS,NSS)
      COMPLEX(kind=wp), intent(in):: SPNSFS(3,NSS,NSS)
      real(kind=wp), intent(in):: DIPSOm_SA

      COMPLEX(kind=wp) DIPSOmSA(3,KDGN,KDGN)
      INTEGER(kind=iwp) l,Iso1,Jso2,Ico1,i,j,jCo1
      COMPLEX(kind=wp) SPNSOSA(3,KDGN,KDGN)
      COMPLEX(kind=wp) Z(NSS,NSS),MATL(NSS,NSS),FINL(NSS,NSS)
      COMPLEX(kind=wp) SPNSO(3,NSS,NSS)
      real(kind=wp) UMATR(NSS,NSS),UMATI(NSS,NSS),gtens(3),maxes(3,3)
      CHARACTER(LEN=1) angm

      if(.FALSE.) then
      write(u6,'(/)')
      write(u6,'(10A)') (('############'),J=1,10)
      write(u6,'(25X,A)') 'MATRIX ELEMENTS OF THE MAGNETIC MOMENT IN '//
     &'THE BASIS OF SPIN ORBIT STATES'
      write(u6,'(10A)') (('############'),J=1,10)

      do l=1,3
      if(l.eq.1)  angm='X'
      if(l.eq.2)  angm='Y'
      if(l.eq.3)  angm='Z'
      write(u6,'(/)')
      write(u6,'(4X,A12,A2)') 'PROJECTION: ', angm
      write(u6,'(/)')
       do Iso1=1,NSS
      write(u6,'(20(2X,2F10.6))') (DIPSOm(l,Iso1,Jso2), Jso2=1,NSS)
       enddo
      enddo
      write(6,'(/)')

       endif !if(IPGLOB.GE.4)

         do l=1,3
         do Ico1=1,KDGN
         do Jco1=1,KDGN
        DIPSOmSA(l,Ico1,Jco1)=(0.d0,0.d0)
      !S_SOM( L,I,J)=(0.d0,0.d0)
         enddo
         enddo
         enddo


         do Iso1=1,KDGN
         do Jso2=1,KDGN
        Ico1=Iso1+IFUNCT
        Jco1=Jso2+IFUNCT
         do l=1,3
      !write(6,*)'DIPSOm',DIPSOm(l,Ico1,Jco1)
       DIPSOmSA(l,Iso1,Jso2)=-DIPSOm(l,Ico1,Jco1)
      !S_SOM( l,i,j)=S_SO(l,ic1,ic2)
        enddo
        enddo
        enddo

         if(.False.) then
      write(u6,*)
      write(u6,'(10X,A)') 'MATRIX ELEMENTS OF THE MAGNETIC MOMENT '//
     & 'IN THE BASIS OF SPIN-ORBIT FUNCTIONS'
      do l=1,3
      write(u6,'(/)')
      write(u6,'(5X,A6,I3)') 'AXIS= ',l
      write(u6,*)
       do Ico1=1,KDGN
      write(u6,'(16(2F12.8,2x))') (DIPSOmSA(l,Ico1,Jco1), Jco1=1,KDGN)
       enddo
      enddo

       endif ! if(IPGLOB.GE.4)

          CALL ATENS_RASSI(DIPSOmSA, KDGN, gtens, maxes, 3)

           if(.False.) then

          call get_dArray('UMATR_SINGLE',UMATR,NSS**2)
          call get_dArray('UMATI_SINGLE',UMATI,NSS**2)
       write(u6,'(/)')
       write(u6,'(5x,a)') 'umatr and umati'
       write(u6,'(/)')
       do i=1,NSS
       write(u6,'(5x,10(2f14.10,2x))') (UMATR(i,j),UMATI(i,j),j=1,NSS)
       enddo

        do I=1,NSS
         do J=1,NSS
          do L=1,3
       SPNSO(L,I,J)=(0.0d0,0.0d0)
          enddo
       Z(I,J)=(0.0d0,0.0d0)
         enddo
       enddo


        do i=1,NSS
        do j=1,NSS
        Z(i,j)=Z(i,j)+CMPLX(UMATR(i,j),UMATI(i,j),kind=8)
        enddo
        enddo

       do l=1,3
         do i=1,NSS
            do j=1,NSS
      MATL(i,j)=(0.0d0,0.0d0)
      MATL(i,j)=SPNSFS(L,i,j)
            enddo
         enddo


         do i=1,NSS
            do j=1,NSS
      FINL(i,j)=(0.0d0,0.0d0)
            enddo
         enddo

       call ADARASSI(NSS,Z,MATL,FINL)

         do i=1,NSS
            do j=1,NSS
      SPNSO(L,i,j) = FINL(i,j)
            enddo
         enddo
      enddo !l

      write(u6,'(/)')
      write(u6,'(10A)') (('############'),J=1,10)
      write(u6,'(30X,A)') 'MATRIX ELEMENTS OF THE SPIN MOMENT IN '//
     & 'THE BASIS OF SPIN ORBIT STATES'
      write(u6,'(10A)') (('############'),J=1,10)
      write(u6,'(/)')
      do l=1,3
      if(l.eq.1)  angm='X'
      if(l.eq.2)  angm='Y'
      if(l.eq.3)  angm='Z'
      write(u6,'(/)')
      write(u6,'(4X,A,A)') 'PROJECTION: ', angm
      write(u6,'(/)')
       do Iso1=1,NSS
      write(u6,'(20(2F10.6,2X))') (SPNSO(l,Iso1,Jso2), Jso2=1,NSS)
       enddo
      enddo

         do l=1,3
         do Ico1=1,KDGN
         do Jco1=1,KDGN
        SPNSOSA(l,Ico1,Jco1)=(0.d0,0.d0)
         enddo
         enddo
         enddo

         do Iso1=1,KDGN
         do Jso2=1,KDGN
        Ico1=Iso1+IFUNCT
        Jco1=Jso2+IFUNCT
         do l=1,3
       SPNSOSA(l,Iso1,Jso2)=SPNSO(l,Ico1,Jco1)
        enddo
        enddo
        enddo

      write(u6,*)
      write(u6,'(10X,A)') 'MATRIX ELEMENTS OF THE SPIN MOMENT '//
     & 'IN THE BASIS OF SPIN-ORBIT FUNCTIONS'
      do l=1,3
      write(u6,'(/)')
      write(u6,'(5X,A6,I3)') 'AXIS= ',l
      write(u6,*)
       do Ico1=1,KDGN
      write(u6,'(16(2F12.8,2x))') (SPNSOSA(l,Ico1,Jco1), Jco1=1,KDGN)
       enddo
      enddo

       endif! if(IPGLOB.GT.3)

       !!do l=1,3
       !!do Iso1=1,KDGN
       !!do Jso2=1,KDGN
      !!Ico1=Iso1+IFUNCT
      !!Jco1=Jso2+IFUNCT
       ! do l=1,3
       !!write(6,*)'DIPSOm',DIPSOm(l,Ico1,Jco1)
      !DIPSOm_SA(l,Iso1,Jso2)=-DIPSOm(l,Ico1,Jco1)
      !S_SOM( l,i,j)=S_SO(l,ic1,ic2)
        !!enddo
       !!enddo
      !!enddo

c Avoid unused argument warnings
      unused_var(DIPSOm_SA)
      END SUBROUTINE SINANI

      SUBROUTINE ADARASSI(N,A,D,DROT)
      use definitions, only: iwp, wp
      use constants, only: Zero,One

      IMPLICIT NONE
      INTEGER(kind=iwp), intent(in):: N
      COMPLEX(kind=wp), intent(in)::  A(N,N), D(N,N)
      COMPLEX(kind=wp), intent(out)::  DROT(N,N)

      INTEGER(kind=iwp) I, J
      COMPLEX(kind=wp)  TEMP(N,N)

C initialization
      do I=1,N
       do J=1,N
      DROT(I,J)=(Zero,Zero)
      TEMP(I,J)=(Zero,Zero)
       enddo
      enddo

C actual multiplication
      call ZGEMM('C','N',N,N,N,(One,Zero),A,N,D,N,(Zero,Zero),
     &TEMP,N)
      call ZGEMM('N','N',N,N,N,(One,Zero),TEMP,N,A,N,(Zero,Zero),
     &DROT,N)

      END SUBROUTINE ADARASSI

      SUBROUTINE ZECON(NSTATE,N,UR,UI,AR,AI,ZEKL,IXYZ,ISTATE,ISS,JSS)
      use definitions, only: iwp, wp
      IMPLICIT None
      integer(kind=iwp), intent(in):: NSTATE,N,IXYZ,ISTATE,ISS,JSS
      real(kind=wp), intent(in):: UR(N,N),UI(N,N)
      real(kind=wp), intent(in):: AR(N,N),AI(N,N)
      COMPLEX(kind=wp), intent(inout):: ZEKL(2,2,3,NSTATE)

      real(kind=wp) TMPR1,TMPR2,TMPI1,TMPI2

      TMPR1=AR(ISS,JSS)*UR(JSS,1)-AI(ISS,JSS)*UI(JSS,1)
      TMPR2=AR(ISS,JSS)*UR(JSS,2)-AI(ISS,JSS)*UI(JSS,2)
      TMPI1=AI(ISS,JSS)*UR(JSS,1)+AR(ISS,JSS)*UI(JSS,1)
      TMPI2=AI(ISS,JSS)*UR(JSS,2)+AR(ISS,JSS)*UI(JSS,2)

      ZEKL(1,1,IXYZ,ISTATE)=ZEKL(1,1,IXYZ,ISTATE)+
     $     CMPLX(UR(ISS,1)*TMPR1+UI(ISS,1)*TMPI1,
     $     UR(ISS,1)*TMPI1-UI(ISS,1)*TMPR1,kind=8)
      ZEKL(1,2,IXYZ,ISTATE)=ZEKL(1,2,IXYZ,ISTATE)+
     $     CMPLX(UR(ISS,1)*TMPR2+UI(ISS,1)*TMPI2,
     $     UR(ISS,1)*TMPI2-UI(ISS,1)*TMPR2,kind=8)
      ZEKL(2,1,IXYZ,ISTATE)=ZEKL(2,1,IXYZ,ISTATE)+
     $     CMPLX(UR(ISS,2)*TMPR1+UI(ISS,2)*TMPI1,
     $     UR(ISS,2)*TMPI1-UI(ISS,2)*TMPR1,kind=8)
      ZEKL(2,2,IXYZ,ISTATE)=ZEKL(2,2,IXYZ,ISTATE)+
     $     CMPLX(UR(ISS,2)*TMPR2+UI(ISS,2)*TMPI2,
     $     UR(ISS,2)*TMPI2-UI(ISS,2)*TMPR2,kind=8)

      END SUBROUTINE ZECON

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GEN_CONF_FOR_OCCLS(     IOCCLS,
     &                              IB_OCCLS,
     &                              INITIALIZE_CONF_COUNTERS,
     &                                NGAS,  ISYM, MINOP, MAXOP, NSMST,
     &                              IONLY_NCONF,
*
     &                               NTORB,
     &                               NOBPT,
     &                              NCONF_OP,
     &                               NCONF,
     &                              IBCONF_REO,
*
     &                              IBCONF_OCC,
     &                               ICONF,
     &                              IDOREO,
     &                              IZ_CONF,
     &                              NCONF_ALL_SYM,
*
     &                                ireo,
     &                              nconf_tot)
*
* IONLY_NCONF = 1 :
*
* Generate number of configurations of occclass IOCCLS and sym ISYM
*
* IONLY_NCONF = 0 :
*
* Generate number and actual configurations of occclass IOCCLS
* and sym ISYM
*
*
* Jeppe Olsen, Nov. 2001
*
#include "implicit.fh"
#include "mxpdim.fh"
*
*.. Input
*
*. Number of electrons per gas space
      INTEGER IOCCLS(NGAS)
*. Number of orbitals per gasspace
      INTEGER NOBPT(NGAS)
*. Arc weights for configurations
      INTEGER IZ_CONF(*)
*. Offset for reordering array and occupation array
      INTEGER IBCONF_REO(*), IBCONF_OCC(*)
*
*.. Output
*
*. Number of configurations per number of open shells, all symmetries
      INTEGER NCONF_OP(MAXOP+1)
*. And the actual configurations
      INTEGER ICONF(*)
*. Reorder array : Lex number => Actual number
c     INTEGER IREO(*)
      integer ireo(nconf_tot)
*. Local scratch
      INTEGER JCONF(2*MXPORB)

      INTEGER IDUM_ARR(1)
*
      NTEST = 00
*. Total number of electrons
       NEL = IELSUM(IOCCLS,NGAS)
       IF(INITIALIZE_CONF_COUNTERS.EQ.1) THEN
         IZERO = 0
         CALL ISETVC(NCONF_OP,IZERO,MAXOP+1)
         NCONF_ALL_SYM = 0
       END IF
*. Loop over configurations
       INI = 1
       NCONF = 0
       ISUM = 0
 1000  CONTINUE
         CALL NEXT_CONF_FOR_OCCLS          (JCONF,IOCCLS,NGAS,NOBPT,INI,
     &                                      NONEW)
         ISUM = ISUM + 1
*
         INI = 0
         IF(NONEW.EQ.0) THEN
*. Check symmetry and number of open orbitals for this space
           ISYM_CONF = ISYMST(JCONF,NEL)
           NOPEN     = NOP_FOR_CONF(JCONF,NEL)
C?         WRITE(6,*) ' Number of open shells ', NOPEN
           NOCOB =  NOPEN + (NEL-NOPEN)/2
           IF(NOPEN.GE.MINOP .OR. IONLY_NCONF .NE. 0)
     &           NCONF_ALL_SYM = NCONF_ALL_SYM + 1
           IF(ISYM_CONF.EQ.ISYM.AND.NOPEN.GE.MINOP) THEN
*. A new configuration to be included, reform and save in packed form
             NCONF = NCONF + 1
             NCONF_OP(NOPEN+1) = NCONF_OP(NOPEN+1) + 1
             IF(IONLY_NCONF .EQ. 0 ) THEN
*. Lexical number of this configuration
               IB_OCC = IBCONF_OCC(NOPEN+1)
     &                + (NCONF_OP(NOPEN+1)-1)*NOCOB
C?             WRITE(6,*) ' Offfset for storing conf =', IB_OCC
               CALL REFORM_CONF_OCC(JCONF,ICONF(IB_OCC),NEL,NOCOB,1)
C-jwk               CALL MEMCHK2('REFORM')
               IF(IDOREO.NE.0) THEN
C                           ILEX_FOR_CONF(ICONF,NOCC_ORB,NORB,NEL,
C                                         IARCW,IDOREO,IREO)
c                ILEXNUM =  ILEX_FOR_CONF(ICONF(IB_OCC),NOCOB,NTORB,
c    &                      NEL,IZ_CONF,0,IDUM)
c.. Giovanni and Dongxia 2011.1.31
                 ilexnum = ilex_for_conf_new(iconf(ib_occ),nocob,
     &                ntorb,nel,iz_conf,0,idum_arr,idum,idum)
C?               WRITE(6,*) ' Next configuration : '
C?               CALL IWRTMA(ICONF(IB_OCC),1,NOCOB,1,NOCOB)
                 JREO = IBCONF_REO(NOPEN+1) -1 + NCONF_OP(NOPEN+1)
c                IREO(IB_OCCLS-1+ILEXNUM) = JREO
c.. Giovanni and Dongxia 2011
                 ireo(jreo)=ib_occls-1+ilexnum
C?               WRITE(6,*) ' LEXCONF : JREO, ILEXNUM = ', JREO, ILEXNUM
C?               WRITE(6,*) ' IB_OCCLS, IB_OCCLS-1+ILEXNUM, JREO= ',
C?   &                        IB_OCCLS, IB_OCCLS-1+ILEXNUM, JREO
c                write(6,*)'ireo after first call of :'
c                call iwrtma(ireo,1,nconf_tot,1,conf_tot)
               END IF
             END IF
           END IF
C      IF(ISUM.LE.10) GOTO 1000
           GOTO 1000
         END IF
*        ^ End if nonew = 0
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*)  ' ====================================== '
        WRITE(6,*)  ' Results from configuration generator : '
        WRITE(6,*)  ' ====================================== '
        WRITE(6,*)
        WRITE(6,*) ' Occupation class in action : '
        CALL IWRTMA(IOCCLS,1,NGAS,1,NGAS)
        WRITE(6,*) ' Number of configurations of correct symmetry ',
     &       NCONF
        WRITE(6,*) ' Number of configurations of all symmetries   ',
     &       NCONF_ALL_SYM
        WRITE(6,*)
     &  ' Number of configurations for various number of open orbs'
        CALL IWRTMA(NCONF_OP,1,MAXOP+1,1,MAXOP+1)
        IF(IONLY_NCONF.EQ.0) THEN
          WRITE(6,*)
     &   ' Updated list of configurations (may not be the final...)'
          CALL WRT_CONF_LIST(ICONF,NCONF_OP,MAXOP,NCONF,NEL)
          WRITE(6,*)
     &   ' Updated reordering of conf, Lex=>Act (may not be the final'
          CALL IWRTMA(IREO,1,NCONF_tot,1,NCONF_tot)
        END IF
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NSMST)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_OPENVR(IOPT,ID)
C
C     Purpose: open (IOPT=1) or close (IOPT=2) files for vector
C              and reduced set storage as well as restart files.
C              ID=1: open local files (for parallel run)
C              ID=2: open global files (as in serial run)
C
#include "implicit.fh"
#include "cholesky.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_OPENVR')

      CHARACTER*5 FNRED
      CHARACTER*6 FNVEC(8), FRST, FMAP

      IF (IOPT .EQ. 1) THEN
         FMAP = 'CHOMAP'
         IF (ID .EQ. 1) THEN
            FNRED = 'CHRDL'
            DO ISYM = 1,NSYM
               WRITE(FNVEC(ISYM),'(A5,I1)') 'CHVCL',ISYM
            END DO
            FRST = 'CHRSTL'
         ELSE
            FNRED = 'CHRED'
            DO ISYM = 1,NSYM
               WRITE(FNVEC(ISYM),'(A5,I1)') 'CHVEC',ISYM
            END DO
            FRST = 'CHORST'
         END IF
         LURED = 7
         CALL DANAME_MF_WA(LURED,FNRED)
         IF (CHO_ADRVEC .EQ. 1) THEN
            DO ISYM = 1,NSYM
               LUCHO(ISYM) = 7
               CALL DANAME_MF_WA(LUCHO(ISYM),FNVEC(ISYM))
            END DO
         ELSE IF (CHO_ADRVEC .EQ. 2) THEN
            DO ISYM = 1,NSYM
               LUCHO(ISYM) = 7
               CALL DANAME_MF(LUCHO(ISYM),FNVEC(ISYM))
            END DO
         ELSE
            CALL CHO_QUIT('CHO_ADRVEC out of bounds in '//SECNAM,102)
         END IF
         LURST = 7
         CALL DANAME_MF_WA(LURST,FRST)
         LUMAP = 7
         CALL DANAME(LUMAP,FMAP)
      ELSE IF (IOPT .EQ. 2) THEN
         IF (LURED .GT. 0) THEN
            CALL DACLOS(LURED)
            LURED = 0
         END IF
         DO ISYM = 1,NSYM
            IF (LUCHO(ISYM) .GT. 0) THEN
               CALL DACLOS(LUCHO(ISYM))
               LUCHO(ISYM) = 0
            END IF
         END DO
         IF (LURST .GT. 0) THEN
            CALL DACLOS(LURST)
            LURST = 0
         END IF
         IF (LUMAP .GT. 0) THEN
            CALL DACLOS(LUMAP)
            LUMAP = 0
         END IF
      ELSE
         WRITE(LUPRI,*) SECNAM,': IOPT out of bounds: ',IOPT
         CALL CHO_QUIT('Error in '//SECNAM,104)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine MemRys(iAnga,MemPrm)
! This routine will compute the memory requirement of RYS
! Memory requirement is per primitive!

use Gateway_global, only: FMM_shortrange
use Index_Functions, only: nTri3_Elem1
use Breit, only: nOrdOp, nComp
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iAnga(4)
integer(kind=iwp), intent(out) :: MemPrm
integer(kind=iwp) :: la, labcd, labMax, labMin, lb, lB00, lB01, lB10, lc, lcdMax, lcdMin, ld, nabcd, nabMax, ncdMax, nRys, nabcdN

la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)

nRys = (la+lb+lc+ld+2)/2
if (nOrdOp == 0) then
  nRys = (la+lb+lc+ld+2)/2
  !nRys = (la+lb+lc+ld+4)/2
else if (nOrdOp == 1) then
  nRys = (la+lb+lc+ld+4)/2
else if (nOrdOp == 2) then
  nRys = (la+lb+lc+ld+4)/2
end if

labMin = nTri3_Elem1(max(la,lb)-1)
labMax = nTri3_Elem1(la+lb)-1
lcdMin = nTri3_Elem1(max(lc,ld)-1)
lcdMax = nTri3_Elem1(lc+ld)-1
labcd = (labMax-labMin+1)*(lcdMax-lcdMin+1)
#ifdef _DEBUGPRINT_
write(u6,*) ' labMin=',labMin
write(u6,*) ' labMax=',labMax
write(u6,*) ' lcdMin=',lcdMin
write(u6,*) ' lcdMax=',lcdMax
#endif
MemPrm = 0
! [a0|c0]
!  6 elements in the case of integrals for spin-spin coupling
MemPrm = MemPrm+nComp*labcd
!                                                                      *
!***********************************************************************
!                                                                      *
! For FMM, we only want short-range integrals, using twice the memory
! to store full and long-range components (which are subtracted)
! This option is not active for nOrdOp/=0

if (FMM_shortrange) MemPrm = MemPrm+nComp*labcd
!                                                                      *
!***********************************************************************
!                                                                      *
if (nOrdOp == 0) then
  nabMax = la+lb+nOrdOp
  !nabMin = max(la,lb)
  ncdMax = lc+ld+nOrdOp
  !ncdMin = max(lc,ld)
else
  nabMax = la+lb+2
  !nabMin = max(la,lb)
  ncdMax = lc+ld+2
  !ncdMin = max(lc,ld)
end if
nabcd = (nabMax+1)*(ncdMax+1)      ! ordinary 2D integrals
nabcdN = (nabMax-1+1)*(ncdMax-1+1)  ! extended 2D integrals
lB10 = max(min(nabMax-1,1),0)
lB01 = max(min(ncdMax-1,1),0)
lB00 = max(min(min(nabMax,ncdMax),1),0)
! Normalization
MemPrm = MemPrm+1
! Ordinary 2D-Integrals
MemPrm = MemPrm+nabcd*3*nRys
! Extended 2D-integrals
if (nOrdOp /= 0) MemPrm = MemPrm+nabcdN*3*2*nRys
! Coefficients for recurrence relations
MemPrm = MemPrm+3*nRys+3*nRys+3*nRys*(lB10+lB01+lB00)
! Roots
MemPrm = MemPrm+nRys
! The inverse of the arguments
MemPrm = MemPrm+1
! Arguments
MemPrm = MemPrm+1
! Expanded versions of Zeta, ZetInv, Eta, EtaInv, rKapab, rKapcd, P and Q
MemPrm = MemPrm+12
#ifdef _DEBUGPRINT_
write(u6,*) ' [e0|f0] integrals   :',labcd
write(u6,*) ' Normalization factor:',1
write(u6,*) ' 2D-integrals        :',nabcd*3*nRys
if (nOrdOp /= 0) write(u6,*) ' 2D-integrals extend :',nabcdN*3*nRys
write(u6,*) ' PAQP vector         :',3*nRys
write(u6,*) ' QCPQ vector         :',3*nRys
write(u6,*) ' B10 coefficients    :',nRys*3*lB10
write(u6,*) ' B00 coefficients    :',nRys*3*lB00
write(u6,*) ' B01 coefficients    :',nRys*3*lB01
write(u6,*) ' Roots               :',nRys
write(u6,*) ' Inverse arguments   :',1
write(u6,*) ' Arguments           :',1
#endif

return

end subroutine MemRys

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Module EFP_Module
      use iso_c_binding
      Integer(c_int) XYZABC_Type, Points_Type, RotMat_Type
      Parameter (XYZABC_Type=0, Points_Type=1, RotMat_Type=2)
      Integer(c_int) Coor_Type
*
      Integer nEFP_fragments, nEFP_Coor
      Logical lEFP
      Character*180, Dimension(:), Allocatable:: FRAG_Type
      Character*180, Dimension(:,:), Allocatable:: ABC
      Real*8, Dimension(:,:), Allocatable, Target:: EFP_COORS
*
      type(c_ptr) :: efp_instance
      End Module EFP_Module

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Tessera(IPRINT,MaxT,Nesf,NS,NV,XE,YE,ZE,RE,
     +           IntSph,PTS,CCC,PP,AREA)
      IMPLICIT REAL*8 (A-H,O-Z)
      Parameter(MxVert=20)
      Dimension XE(*),YE(*),ZE(*),RE(*),IntSph(MxVert,*)

      DIMENSION CCC(3,MxVert),P1(3),P2(3),P3(3),P4(3),PP(3),
     &          PTS(3,MxVert)
      DIMENSION PSCR(3,MxVert),CCCP(3,MxVert),IND(MxVert)
      DIMENSION LTYP(MxVert),POINT(3),POINTL(3,MxVert)
      DIMENSION INTSCR(MxVert)
C     Coord. del centro che sottende l`arco tra i vertici
C     n e n+1 (per i primi tre vertici e' sicuramente il centro della
C     sfera) e sfera alla cui intersezione con NS appartiene l'arco (se
C     appartiene alla sfera originaria INTSPH(N,MxTs)=NS)
C
      Small = 1.0d-12
      AREA = 0.D0
      DO 2000 J=1, 3
      CCC(1,J) = XE(NS)
      CCC(2,J) = YE(NS)
      CCC(3,J) = ZE(NS)
 2000 continue
C     INTSPH viene riferito alla tessera MxTs, e in seguito riceve il
C     numero corretto.
      DO 2010 N = 1, 3
        INTSPH(N,Maxt) = NS
 2010 continue
C     Loop sulle altre sfere
      DO 150 NSFE1=1,NESF
      IF(NSFE1.EQ.NS)GOTO 150
C     Memorizza i vertici e i centri che sottendono gli archi
      DO 2020 J =1, NV
      INTSCR(J) = INTSPH(J,MaxT)
      DO 2030 I = 1,3
      PSCR(I,J) = PTS(I,J)
      CCCP(I,J) = CCC(I,J)
 2030 continue
 2020 continue
      ICOP = 0
      DO 2040 J =1, MxVert
      IND(J) = 0
      LTYP(J) = 0
 2040 continue
C     Loop sui vertici della tessera considerata
      DO 100 I=1,NV
        DELR2=(PTS(1,I)-XE(NSFE1))**2+(PTS(2,I)-YE(NSFE1))**2+
     *  (PTS(3,I)-ZE(NSFE1))**2
        DELR=sqrt(DELR2)
        IF(DELR.LT.(RE(NSFE1)-Small))THEN
          IND(I) = 1
          ICOP = ICOP+1
        ENDIF
 100  CONTINUE
C     Se la tessera e' completamente coperta, la trascura
      IF(ICOP.EQ.NV) RETURN
C     Controlla e classifica i lati della tessera: LTYP = 0 (coperto),
C     1 (tagliato con il II vertice coperto), 2 (tagliato con il I
C     vertice coperto), 3 (bitagliato), 4 (libero)
C     Loop sui lati
      DO 2050 L = 1, NV
        IV1 = L
        IV2 = L+1
        IF(L.EQ.NV) IV2 = 1
        IF(IND(IV1).EQ.1.AND.IND(IV2).EQ.1) THEN
        LTYP(L) = 0
        ELSEIF(IND(IV1).EQ.0.AND.IND(IV2).EQ.1) THEN
        LTYP(L) = 1
        ELSEIF(IND(IV1).EQ.1.AND.IND(IV2).EQ.0) THEN
        LTYP(L) = 2
        ELSEIF(IND(IV1).EQ.0.AND.IND(IV2).EQ.0) THEN
        LTYP(L) = 4
        RC2 = (CCC(1,L)-PTS(1,L))**2 + (CCC(2,L)-PTS(2,L))**2 +
     &          (CCC(3,L)-PTS(3,L))**2
        RC = sqrt(RC2)
C     Su ogni lato si definiscono 11 punti equispaziati, che vengono
C     controllati
        TOL = - 1.D-10
        DO 2060 II = 1, 11
          POINT(1) = PTS(1,IV1) + II * (PTS(1,IV2)-PTS(1,IV1)) / 11
          POINT(2) = PTS(2,IV1) + II * (PTS(2,IV2)-PTS(2,IV1)) / 11
          POINT(3) = PTS(3,IV1) + II * (PTS(3,IV2)-PTS(3,IV1)) / 11
        POINT(1) = POINT(1) - CCC(1,L)
        POINT(2) = POINT(2) - CCC(2,L)
        POINT(3) = POINT(3) - CCC(3,L)
        DNORM = sqrt(POINT(1)**2 + POINT(2)**2 + POINT(3)**2)
        POINT(1) = POINT(1) * RC / DNORM + CCC(1,L)
        POINT(2) = POINT(2) * RC / DNORM + CCC(2,L)
        POINT(3) = POINT(3) * RC / DNORM + CCC(3,L)
        DIST = sqrt( (POINT(1)-XE(NSFE1))**2 +
     &    (POINT(2)-YE(NSFE1))**2 + (POINT(3)-ZE(NSFE1))**2 )
          IF((DIST - RE(NSFE1)) .LT. TOL) THEN
c         IF(DIST.LT.RE(NSFE1))THEN
          LTYP(L) = 3
          DO 2070 JJ = 1, 3
            POINTL(JJ,L) = POINT(JJ)
 2070 continue
          GOTO 160
          ENDIF
 2060 continue
        ENDIF
 160    CONTINUE
 2050 continue
C     Se la tessera e' spezzata in due o piu' tronconi, la trascura
      ICUT = 0
      DO 2080 L = 1, NV
      IF(LTYP(L).EQ.1.OR.LTYP(L).EQ.2) ICUT = ICUT + 1
      IF(LTYP(L).EQ.3) ICUT = ICUT + 2
 2080 continue
      ICUT = ICUT / 2
      IF(ICUT.GT.1) RETURN
C     Creazione dei nuovi vertici e lati della tessera
C     Loop sui lati
      N = 1
      DO 300 L = 1, NV
C     Se il lato L e' coperto:
        IF(LTYP(L).EQ.0) GOTO 300
      IV1 = L
      IV2 = L+1
      IF(L.EQ.NV) IV2 = 1
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     Se il lato L e' tagliato (con il I vertice scoperto):
      IF(LTYP(L).EQ.1) THEN
        DO 2090 JJ = 1, 3
          PTS(JJ,N) = PSCR(JJ,IV1)
          CCC(JJ,N) = CCCP(JJ,IV1)
 2090 continue
        INTSPH(N,MaxT) = INTSCR(IV1)
        N = N+1
C     Trova l'intersezione tra i due vertici del lato L
C
C     P1 = coord. del primo vertice
C     P2 = coord. del secondo vertice
C     P3 = coord. del centro dell`arco sotteso
C     P4 = coord. dell'intersezione
C
        DO 2100 JJ = 1, 3
          P1(JJ) = PSCR(JJ,IV1)
          P2(JJ) = PSCR(JJ,IV2)
          P3(JJ) = CCCP(JJ,IV1)
 2100 continue

        CALL INTER_PCM(XE,YE,ZE,RE,P1,P2,P3,P4,NSFE1,0,
     +             IPRINT)
C     Aggiorna i vertici della tessera e il centro dell'arco
        DO 2110 JJ = 1,3
          PTS(JJ,N) = P4(JJ)
 2110 continue
C
C     Il nuovo arco sara' sotteso tra questo e il prossimo punto
C     di intersezione: il centro che lo sottende
C     sara' il centro del cerchio di intersezione tra la sfera NS
C     e la sfera NSFE1.
C
        DE2 = (XE(NSFE1)-XE(NS))**2+(YE(NSFE1)-YE(NS))**2+
     *        (ZE(NSFE1)-ZE(NS))**2
        CCC(1,N)=XE(NS)+(XE(NSFE1)-XE(NS))*
     *           (RE(NS)**2-RE(NSFE1)**2+DE2)/(2.D0*DE2)
        CCC(2,N)=YE(NS)+(YE(NSFE1)-YE(NS))*
     *           (RE(NS)**2-RE(NSFE1)**2+DE2)/(2.D0*DE2)
        CCC(3,N)=ZE(NS)+(ZE(NSFE1)-ZE(NS))*
     *           (RE(NS)**2-RE(NSFE1)**2+DE2)/(2.D0*DE2)
        INTSPH(N,MaxT) = NSFE1
        N = N+1
      ENDIF
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     Se il lato L e' tagliato (con il II vertice scoperto):
      IF(LTYP(L).EQ.2) THEN
C     Trova l'intersezione tra i due vertici del lato L
C
C     P1 = coord. del primo vertice
C     P2 = coord. del secondo vertice
C     P3 = coord. del centro dell`arco sotteso
C     P4 = coord. dell'intersezione
C
        DO 2120 JJ = 1, 3
          P1(JJ) = PSCR(JJ,IV1)
          P2(JJ) = PSCR(JJ,IV2)
          P3(JJ) = CCCP(JJ,IV1)
 2120 continue

        CALL INTER_PCM(XE,YE,ZE,RE,P1,P2,P3,P4,NSFE1,1,
     +             IPRINT)
C     Aggiorna i vertici della tessera e il centro dell'arco
        DO 2130 JJ = 1,3
          PTS(JJ,N) = P4(JJ)
          CCC(JJ,N) = CCCP(JJ,IV1)
 2130 continue
        INTSPH(N,MaxT) = INTSCR(IV1)
        N = N+1
        ENDIF
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     Se il lato e' intersecato due volte:
      IF(LTYP(L).EQ.3) THEN
        DO 2140 JJ = 1, 3
          PTS(JJ,N) = PSCR(JJ,IV1)
          CCC(JJ,N) = CCCP(JJ,IV1)
 2140 continue
        INTSPH(N,MaxT) = INTSCR(IV1)
        N = N+1
C     Trova l'intersezione tra il primo vertice e un punto intermedio
C     coperto
C
C     P1 = coord. del primo vertice
C     P2 = coord. del secondo vertice
C     P3 = coord. del centro dell`arco sotteso
C     P4 = coord. dell'intersezione
C
        DO 2150 JJ = 1, 3
          P1(JJ) = PSCR(JJ,IV1)
          P2(JJ) = POINTL(JJ,L)
          P3(JJ) = CCCP(JJ,IV1)
 2150 continue
        CALL INTER_PCM(XE,YE,ZE,RE,P1,P2,P3,P4,NSFE1,0,
     +            IPRINT)
C     Aggiorna i vertici della tessera e il centro dell'arco
        DO 2160 JJ = 1,3
          PTS(JJ,N) = P4(JJ)
 2160 continue
C
C     Il nuovo arco sara' sotteso tra questo e il prossimo punto
C     di intersezione: il centro che lo sottende
C     sara' il centro del cerchio di intersezione tra la sfera NS
C     e la sfera NSFE1.
C
        DE2 = (XE(NSFE1)-XE(NS))**2+(YE(NSFE1)-YE(NS))**2+
     *        (ZE(NSFE1)-ZE(NS))**2
        CCC(1,N)=XE(NS)+(XE(NSFE1)-XE(NS))*
     *           (RE(NS)**2-RE(NSFE1)**2+DE2)/(2.D0*DE2)
        CCC(2,N)=YE(NS)+(YE(NSFE1)-YE(NS))*
     *           (RE(NS)**2-RE(NSFE1)**2+DE2)/(2.D0*DE2)
        CCC(3,N)=ZE(NS)+(ZE(NSFE1)-ZE(NS))*
     *           (RE(NS)**2-RE(NSFE1)**2+DE2)/(2.D0*DE2)
        INTSPH(N,MaxT) = NSFE1
        N = N+1
C
C     Trova l'intersezione tra un punto intermedio coperto e il
C     secondo vertice
C
C     P1 = coord. del primo vertice
C     P2 = coord. del secondo vertice
C     P3 = coord. del centro dell`arco sotteso
C     P4 = coord. dell'intersezione
C
        DO 2170 JJ = 1, 3
          P1(JJ) = POINTL(JJ,L)
          P2(JJ) = PSCR(JJ,IV2)
          P3(JJ) = CCCP(JJ,IV1)
 2170 continue

        CALL INTER_PCM(XE,YE,ZE,RE,P1,P2,P3,P4,NSFE1,1,
     +           IPRINT)
C     Aggiorna il vertice e il centro dell'arco
        DO 2180 JJ = 1,3
          PTS(JJ,N) = P4(JJ)
          CCC(JJ,N) = CCCP(JJ,IV1)
 2180 continue
      INTSPH(N,MaxT) = INTSCR(IV1)
      N = N + 1
        ENDIF
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C     Se il lato e' scoperto:
      IF(LTYP(L).EQ.4) THEN
        DO 2190 JJ = 1, 3
          PTS(JJ,N) = PSCR(JJ,IV1)
          CCC(JJ,N) = CCCP(JJ,IV1)
 2190 continue
        INTSPH(N,MaxT) = INTSCR(IV1)
        N = N+1
        ENDIF
C     Controlla che il numero di vertici creati non sia eccessivo
      If(N.GT.11) then
        Write(6,'(/,'' TESSERA: too many vertices in a tessera'')')
        Call Abend()
      EndIf
 300  CONTINUE
C
      NV = N - 1
 150  CONTINUE
C
C     Se la tessera non e' stata scartata, a questo punto ne troviamo
C     l'area e il punto rappresentativo
C
      CALL GAUBON(MaxT,XE,YE,ZE,RE,IntSph,NV,NS,
     +            PTS,CCC,PP,AREA,IPRINT)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine CHO_RASSCF_RDINP_m(DFonly,LuInput)
************************************************************************
*                                                                      *
*  Purpose:   If DFonly, use defaults only.                            *
*             Else, read and process input for Cholesky section        *
*             in RASSCF                                                *
*                                                                      *
************************************************************************
      Use Fock_util_global, only: ALGO, Deco, DensityCheck, dmpk,
     &                            DoLock, Estimate, Nscreen, Update
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "output_ras.fh"
#include "WrkSpc.fh"
      Character*180 KWord, Key, Get_Ln
      External Get_Ln
      Logical  DFonly
      character*16 SECNAM
      parameter (SECNAM = 'CHO_RASSCF_RDINP')
*
#include "chotime.fh"
#include "chopar.fh"

*
*
***** Algorithms for using Cholesky vectors in RASSCF ******************
*
*   ALGO:
*
*          1  --->  compute fock matrices in AO-basis from vectors
*                   read in reduced sets and transformed on the fly
*                   (PU|VX) integrals are also returned
*
*                   If DoLock=.true. then the Exchange terms are
*                   computed by emplpying the "Local K" scheme
*
*
*          2  --->  compute fock matrices in AO-basis from vectors
*                   read in reduced sets and transformed on the fly
*                   Only the (TU|VX) integrals are returned
*                   while the vectors are directly contracted
*                   with the 2-body density in order to construct
*                   the Q-matrix
*                                                                      *
************************************************************************
*                                                                      *
*     Default  parameters
#if defined (_MOLCAS_MPP_)
      ChFracMem=0.3D0
#else
      ChFracMem=0.0D0
#endif
*
*     set some parameters if not specified in ChoInput section
      ALGO  = 1
      DensityCheck=.false.
      Deco=.true.
      timings=.false.
      DoLock=.true.
      Nscreen=10
      dmpk=1.0d-1
      Update=.true.
      Estimate=.false.
      IF (DFonly) goto 999  !return flag

      dmpk_dfl=1.0d-1
************************************************************************
*                                                                      *
      iPrint=5
*                                                                      *
************************************************************************
*                                                                      *
*-----Process the input
*
*-------------------------------------------------------------------*
* The big turning point.                                            *
*-------------------------------------------------------------------*
1000  Continue
*-------------------------------------------------------------------*
* Use Get_Ln to read the lines.                                     *
*-------------------------------------------------------------------*
      Key=Get_Ln(LuInput)
      Kword=Key
      Call UpCase(Kword)
*-------------------------------------------------------------------*
* The keywords and their labels.                                    *
*-------------------------------------------------------------------*

      If (KWord(1:1).eq.'*')    Go To 1000
      If (KWord.eq.'')       Go To 1000
      If (KWord(1:4).eq.'ALGO') Go To 900
      If (KWord(1:4).eq.'LOCK') Go To 910
      If (KWord(1:4).eq.'LK  ') Go To 910
      If (KWord(1:4).eq.'NOLK') Go To 915
      If (KWord(1:4).eq.'DMPK') Go To 920
      If (KWord(1:4).eq.'NODE') Go To 930
      If (KWord(1:4).eq.'SCRN') Go To 940
      If (KWord(1:4).eq.'MEMF') Go To 950
      If (KWord(1:4).eq.'DCHK') Go To 820
      If (KWord(1:4).eq.'TIME') Go To 830
      If (KWord(1:4).eq.'ESTI') Go To 840
      If (KWord(1:4).eq.'UPDA') Go To 850
      If (KWord(1:4).eq.'PRIN') Go To 700
      If (KWord(1:4).eq.'ENDC') Go To 998
      If (KWord(1:4).eq.'END ') Go To 998
      If (KWord(1:4).eq.'ENDO') Go To 998

*-------------------------------------------------------------------*
* Control section
*-------------------------------------------------------------------*
      iChrct=Len(KWord)
      Last=iCLast(KWord,iChrct)
      Write(LF,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
      Call ErrTra
      Write(LF,*) SECNAM, ' Error in keyword.'
      Call Quit_OnUserError()
*                                                                      *
****** ALGO ************************************************************
*                                                                      *
*-----Read Cholesky algorithm parameters
*
 900  Continue
c      Call Get_F1(1,Eps)
c      Call Get_F1(2,rds)
c      Call Get_I1(1,ALGO)
C      If (nToken(KWord).gt.1) goto 988
*
       READ(LuInput,*) ALGO
*
      if(ALGO.eq.1)then
      Write(LF,*)
     &'Default RASSCF algorithm reset to  ',ALGO
      Write(LF,*)
      elseif(ALGO.eq.2)then
      Write(LF,*)
     &'Default RASSCF algorithm reset to  ',ALGO
      Write(LF,*)
      Write(LF,*)' !!! STILL UNDER DEBUGGING !!! '
      else
      Write(LF,*)
     &'The specified algorithm is not implemented. Option Ignored '
      Write(LF,*)
      endif
*
      Go To 1000
*                                                                      *
****** LOCK or LK ******************************************************
*                                                                      *
 910   Continue
      DoLocK=.true.
c      Write(LF,*)
c     &'Using Local K scheme for Exchange matrices '
*
      Go To 1000
*                                                                      *
****** NOLK ************************************************************
*                                                                      *
 915   Continue
      DoLocK=.false.
c      Write(LF,*)
c     &'LK screening for Exchange matrices turned off !'
*
      Go To 1000
*                                                                      *
****** DMPK ************************************************************
*                                                                      *
 920   Continue
       READ(LuInput,*) dmpk
       If (dmpk .lt. 0.0D0) Then
        write(6,*)'OBS! Specified Negative DMPK value. Restore Defaults'
        dmpk=dmpk_dfl
       EndIf
*
      Go To 1000
*                                                                      *
****** NODE ************************************************************
*                                                                      *
 930   Continue
      Deco=.false.
      Write(LF,*)
     &'Not-Using Cholesky decomposed Inactive density '
*
      Go To 1000
*                                                                      *
****** SCRN ************************************************************
*                                                                      *
 940   Continue
       READ(LuInput,*) Nscreen
*
      Go To 1000
*                                                                      *
****** MEMF ************************************************************
*                                                                      *
 950   Continue
       READ(LuInput,*) ChFracMem
*
      Go To 1000
*                                                                      *
****** DCHK ************************************************************
*                                                                      *
 820   Continue
       DensityCheck=.true.
      Write(LF,*)
     &'Non-valid option. IGNORED !! '
*
      Go To 1000
*                                                                      *
****** ESTI ************************************************************
*                                                                      *
 840   Continue
       Estimate=.true.
      Write(LF,*)
     &'Diagonal integrals estimated from the current Cholesky vectors'
*
      Go To 1000
*                                                                      *
****** UPDA ************************************************************
*                                                                      *
 850   Continue
       Update=.true.
      Write(LF,*)
     &'Updating of the true diagonal integrals'
*
      Go To 1000
*                                                                      *
****** TIME ************************************************************
*                                                                      *
 830   Continue
       timings=.true.
*
      Go To 1000
*                                                                      *
****** PRIN ************************************************************
*                                                                      *
*-----Print level
*
 700  Key=Get_Ln(LuInput)
      KWord=Key
      Call Get_I1(1,n)
      Do i = 1, n
         KWord=Get_Ln(LuInput)
         Call Get_I1(1,jRout)
         Call Get_I1(2,iPrint)
         nPrint(jRout)=iPrint
      End Do
      Go To 1000
*                                                                      *
****** END  ************************************************************
*                                                                      *
*-----End of input
*
 998  Continue
*                                                                      *
************************************************************************
*                                                                      *
999      Write(LF,'(1X,A,I4)')
c     &'Default Cholesky algorithm in RASSCF = ',ALGO
c       Write(LF,*)
       If(ALGO.eq.2)Then
         Write(LF,*)'Local K scheme not implemented for the chosen algo'
     &'rithm. LocK keyword ignored !'
         DoLocK=.false.
       EndIf

      Return
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Per Ake Malmqvist                                *
************************************************************************
*****************************************************************
*  PROGRAM RASSI        PER-AAKE MALMQVIST 2000-06-30
*  SUBROUTINE DIMAT
*  CONSTRUCT A DENSITY MATRIX DINAO FOR THE INACTIVE ORBITALS.
*  IT IS RETURNED IN SYMMETRY-BLOCKED SQUARED FORMAT.
*****************************************************************
      SUBROUTINE DIMAT(CMO1,CMO2,DINAO)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CMO1(NCMO),CMO2(NCMO),DINAO(NBSQ)
#include "rassi.fh"
#include "symmul.fh"
      CALL DCOPY_(NBSQ,[0.0D0],0,DINAO,1)
      ISTC=1
      ISTD=1
      DO ISYM=1,NSYM
       NI=NISH(ISYM)
       NO=NOSH(ISYM)
       NB=NBASF(ISYM)
       IF(NI.NE.0) THEN
        CALL  DGEMM_('N','T',NB,NB,NI,1.0D0,
     &               CMO1(ISTC),NB,
     &               CMO2(ISTC),NB,0.0D0,
     &               DINAO(ISTD),NB)
       END IF
       ISTC=ISTC+NO*NB
       ISTD=ISTD+NB**2
      END DO
      CALL DSCAL_(NBSQ,2.0D00,DINAO,1)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine unpckhelp9 (ap,am,b,dimp,dimq,dime,dimf,eadd,noe,fadd,
     &                        nof,bb,dimb)
c
c     this routine do:
c     b(e,f,_Bb) = a(pe,qf)-a(qf,pe) for symp>symq
c
       integer dimp,dimq,dime,dimf,eadd,noe,fadd,nof,bb,dimb
       real*8 ap(1:dimp,1:dimq)
       real*8 am(1:dimq,1:dimp)
       real*8 b(1:dime,1:dimf,1:dimb)
c
c     help variables
       integer pe,qf,f
c
       do 100 qf=fadd+1,fadd+nof
       f=qf-fadd
       do 101 pe=eadd+1,eadd+noe
       b(pe-eadd,f,bb)=ap(pe,qf)-am(qf,pe)
 101    continue
 100    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine hess_evb1_cvb(orbs,
     >   civbh,citmp,civb,
     >   sorbs,owrk,
     >   gjorb,gjorb2,gjorb3,
     >   dvbdet,
     >   grad1,grad2,hessorb,
     >   vec1,iorts,
     >   hessinp,hessout)
      implicit real*8 (a-h,o-z)
      logical orbopt2,strucopt2
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "fx_cvb.fh"
#include "malloc_cvb.fh"
      dimension orbs(norb,norb)
      dimension civbh(ndet),citmp(ndet),civb(ndet)
      dimension sorbs(norb,norb),owrk(norb,norb)
      dimension gjorb(*),gjorb2(*),gjorb3(*)
      dimension dvbdet(ndetvb)
      dimension grad1(npr),grad2(npr)
      dimension hessorb(nprorb,nprorb)

c  VEC1 dimension is MAX(NPRORB,NDETVB)
      dimension vec1(*)
      dimension hessinp(npr),hessout(npr)
      dimension iorts(2,nort)

      hess_orb_nrm=dnrm2_(nprorb,hessinp,1)
      orbopt2=hess_orb_nrm.gt.1d-10
      if(nprvb.gt.0) then
        hess_ci_nrm=dnrm2_(nprvb,hessinp(nprorb+1),1)
      else
        hess_ci_nrm=zero
      endif
      strucopt2=strucopt.and.hess_ci_nrm.gt.1d-10
      if(orbopt2.and..not.strucopt2)n_orbhess=n_orbhess+1
      if(strucopt2.and..not.orbopt2)n_cihess=n_cihess+1

      call transp_cvb(orbs,owrk,norb,norb)
      call mxattb_cvb(orbs,orbs,norb,norb,norb,sorbs)

      call fzero(hessout,npr)
      if(orbopt2)call mxatb_cvb(hessorb,hessinp,
     >  nprorb,nprorb,1,hessout)

c  Combinations of gradients :
      g1f=ddot_(npr,grad1,1,hessinp,1)
      g2f=ddot_(npr,grad2,1,hessinp,1)
      fac1=g1f*f4+g2f*f3
      fac2=g1f*f3
      call daxpy_(npr,fac1,grad1,1,hessout,1)
      call daxpy_(npr,fac2,grad2,1,hessout,1)

      if(orbopt2.and.strucopt)then
        call mxunfold_cvb(hessinp(1),owrk,norb)
        call transp_cvb(owrk,owrk,norb,norb)
        call cizero_cvb(citmp)
        call oneexc_cvb(civbh,citmp,owrk,.true.,2)
        call mkgrd_cvb(civb,citmp,vec1,dvbdet,npr,.false.)
        call daxpy_(nprvb,f1,vec1(nprorb+1),1,
     >    hessout(nprorb+1),1)
      endif
      if(strucopt2)then
        call str2vbf_cvb(hessinp(1+nprorb),dvbdet)
        call vb2cif_cvb(dvbdet,citmp)
        call mkgrd_cvb(citmp,civbh,vec1,dvbdet,nprorb,.true.)
        call daxpy_(nprorb,f1,vec1,1,hessout,1)
        call oneexc_cvb(civb,citmp,hessinp,.false.,1)
c  2nd-order term for structure coefficients
        if(nfrag.gt.1)then
          call str2vbf_cvb(hessinp(1+nprorb),dvbdet)
          i1 = mstackr_cvb(ndetvb)
          i2 = mstackr_cvb(nvb)
          call ci2ordr_cvb(civbh,dvbdet,w(i1))
          call vb2strg_cvb(w(i1),w(i2))
          call daxpy_(nvb,f1,w(i2),1,hessout(1+nprorb),1)
          call mfreer_cvb(i1)
        endif
      else
        call cizero_cvb(citmp)
        call oneexc_cvb(civb,citmp,hessinp,.false.,1)
      endif
      call applythmes_cvb(citmp,orbs,gjorb,gjorb2,gjorb3)
      call mkgrd_cvb(civb,citmp,vec1,dvbdet,npr,.true.)
      call daxpy_(npr,f1,vec1,1,hessout,1)

      if(orbopt2.and.nort.gt.0)then
c  Non-linear correction for orthogonality constraints :
        call fmove_cvb(sorbs,owrk,norb*norb)
        call mxinv_cvb(owrk,norb)
        do 100 iort=1,nort
        iorb=iorts(1,iort)
        jorb=iorts(2,iort)
        corr1=zero
        do 200 korb=1,norb
        ki=korb+(iorb-1)*(norb-1)
        if(korb.gt.iorb)ki=ki-1
        kj=korb+(jorb-1)*(norb-1)
        if(korb.gt.jorb)kj=kj-1
        if(korb.ne.iorb)corr1=corr1+owrk(jorb,korb)*
     >    (f1*grad2(ki)+f2*grad1(ki))
        if(korb.ne.jorb)corr1=corr1+owrk(iorb,korb)*
     >    (f1*grad2(kj)+f2*grad1(kj))
200     continue
        corr1=-.5d0*corr1
        do 300 korb=1,norb
        if(korb.eq.iorb)goto 300
        ki=korb+(iorb-1)*(norb-1)
        if(korb.gt.iorb)ki=ki-1
        do 400 lorb=1,norb
        if(lorb.eq.jorb)goto 400
        lj=lorb+(jorb-1)*(norb-1)
        if(lorb.gt.jorb)lj=lj-1
        hessout(ki)=hessout(ki)+sorbs(korb,lorb)*corr1*hessinp(lj)
        hessout(lj)=hessout(lj)+sorbs(korb,lorb)*corr1*hessinp(ki)
400     continue
300     continue
100     continue
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1992,2000,2007, Roland Lindh                 *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drvg1_2Center_RI(Grad,Temp,nGrad,ip_ij2,nij_Eff)
************************************************************************
*                                                                      *
*  Object: driver for 2-center two-electron integrals in the RI scheme.*
*                                                                      *
*   The integral derivative is formulated as                           *
*   -Sum(ML) X_ij^K   V_LM^(1) X_kl^L  where                           *
*                                                                      *
*  X_ij^K = Sum(L) R_ij_L  Q_L^K                                       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August '91                         *
*             Modified for gradient calculation. January '92           *
*             Modified for SetUp_Ints. January '00                     *
*             Modified for 2-center RI gradients, January '07          *
************************************************************************
      use k2_setup
      use iSD_data
      use pso_stuff
      use k2_arrays, only: ipZeta, ipiZet, Mem_DBLE, Aux, Sew_Scr
      use Basis_Info
      use Sizes_of_Seward, only:S
      use Real_Info, only: CutInt
      use RICD_Info, only: Do_RI
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Rsv_Tsk
#include "itmax.fh"
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "disp.fh"
#include "nsd.fh"
#include "setup.fh"
#include "exterm.fh"
#include "chomp2g_alaska.fh"
#include "para_info.fh"
*#define _CD_TIMING_
#ifdef _CD_TIMING_
#include "temptime.fh"
#endif
*     Local arrays
      Real*8  Coor(3,4), Grad(nGrad), Temp(nGrad)
      Integer iAnga(4), iCmpa(4), iShela(4),iShlla(4),
     &        iAOV(4), istabs(4), iAOst(4), JndGrd(3,4), iFnc(4)
      Integer nHrrTb(0:iTabMx,0:iTabMx,2)
      Logical EQ, Shijij, AeqB, CeqD,
     &        DoGrad, DoFock, Indexation, FreeK2, Verbose,
     &        JfGrad(3,4), ABCDeq, No_Batch, Rsv_Tsk
      Character Format*72
*
      Integer iSD4(0:nSD,4)
      Save MemPrm
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      TMax1(i)=Work(ipTMax-1+i)
      TMax2(i,j)=Work(ipTMax-1+(j-1)*nSkal+i)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 9
      iPrint = nPrint(iRout)
#ifdef _CD_TIMING_
      Twoel2_CPU = 0.0d0
      Twoel2_Wall = 0.0d0
      Pget2_CPU = 0.0d0
      Pget2_Wall = 0.0d0
#endif

      iFnc(1)=0
      iFnc(2)=0
      iFnc(3)=0
      iFnc(4)=0
      PMax=Zero
      idum=0
      idum1=0
      call dcopy_(nGrad,[Zero],0,Temp,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Handle only the auxiliary basis set.
*
      If (Do_RI) Then
         Call Set_Basis_Mode('Auxiliary')
      Else
         Call Set_Basis_Mode('Valence')
      End If
      Call Setup_iSD()

************************************************************************
*                                                                      *
*-----Precompute k2 entities.
*
      Indexation=.False.
      DoFock=.False.
      DoGrad=.True.
      ThrAO=Zero
      Call SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
      mSkal=nSkal
      nPairs=nSkal*(nSkal+1)/2
      nQuad =nPairs*(nPairs+1)/2
      Pren = Zero
      Prem = Zero
*                                                                      *
************************************************************************
*                                                                      *
      MxPrm = 0
      Do iAng = 0, S%iAngMx
         MxPrm = Max(MxPrm,S%MaxPrm(iAng))
      End Do
      nZeta = MxPrm * MxPrm
      nEta  = MxPrm * MxPrm
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      If (Do_RI) Then
         nTMax=nSkal
         Call GetMem('TMax','Allo','Real',ipTMax,nTMax)
         Call Allocate_Work(ip_Tmp,nSkal**2)
         Call Shell_MxSchwz(nSkal,Work(ip_Tmp))
        call dcopy_(nSkal,Work(ip_Tmp+(nSkal-1)*nSkal),1,Work(ipTMax),1)
         Call Free_Work(ip_Tmp)
         TMax_all=Zero
         Do iS = 1, nSkal-1
            TMax_all=Max(TMax_all,TMax1(iS))
         End Do
      Else
         nTMax=nSkal**2
         Call GetMem('TMax','Allo','Real',ipTMax,nTMax)
         Call Shell_MxSchwz(nSkal,Work(ipTMax))
         TMax_all=Zero
         Do ij = 1, nij_Eff
            iS = iWork(ip_ij2-1 +(ij-1)*2 + 1)
            jS = iWork(ip_ij2-1 +(ij-1)*2 + 2)
            TMax_all=Max(TMax_all,TMax2(iS,jS))
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate some scratch arrays to be used by the pget routines.
*     In particular we will have temporary arrays for A_IJ and C_ijK.
*
*     Lower case: valence basis set
*     Upper case: auxiliary basis sets
*
      If(DoCholExch) Then
*
*        Find the largest number of contractions in any given shell
*        of auxiliary functions.

         MxChVInShl = 1
         If(Do_RI) Then
            Do i = 1, nSkal
               MxChVInShl = max(MxChVInShl,iSD(3,i))
            End Do
         Else
            Write (6,*) 'Not Implemented for Cholesky yet!'
            Call Abend()
         End If
*
*        Scratch for A_IJ
*
         lA = MxChVInShl*MxChVInShl
         Call GetMem('A','Allo','Real',ip_A,lA)
         If (iMP2Prpt.eq.2) Then
            lA_MP2=MxChVInShl
            Call GetMem('A_MP2(1)','Allo','Real',ip_A_MP2(1),lA_MP2)
            Call GetMem('A_MP2(2)','Allo','Real',ip_A_MP2(2),lA_MP2)
         Else
            ip_A_MP2(1) = ip_Dummy
            ip_A_MP2(2) = ip_Dummy
         End If
*
*        Find the largest set of ij. The basis i and j is due to the
*        CD of the one-particle density.
*
         nIJRMax = 0
         Do jDen = 1,nKvec
            Do iSym1 = 1, nIrrep
               Do iSym2 = 1, nIrrep
                  nIJRMax = max(nIJRMax,nIJR(iSym1,iSym2,jDen))
               End Do
            End Do
         End Do
*
*        Get scratch for C_kl^I and C_kl^J.
*        Note that we need nDen arrays for C_kl^I and one for C_kl^J
*        A_IJ = Sum(kl) C_kl^I x C_kl^J
*
         lCijK = nIJRMax*MxChVInShl
         Call GetMem('CijK','Allo','Real',ip_CijK,(nKvec+1)*lCijK)
*
      Else
*
         lCijK = 0
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Create list of non-vanishing pairs
*
      If (Do_RI) Then
         mij=(nSkal-1)*2
         Call GetMem('ip_ij','Allo','Inte',ip_ij,mij)
         nij=0
         Do iS = 1, nSkal-1
            If (TMax_All*TMax1(iS).ge.CutInt) Then
               nij = nij + 1
               iWork(ip_ij + 2*(nij-1)  )=nSkal
               iWork(ip_ij + 2*(nij-1)+1)=iS
            End If
         End Do
      Else
         mij=2*nij_Eff
         Call GetMem('ip_ij','Allo','Inte',ip_ij,mij)
         nij=0
         Do ij = 1, nij_Eff
            iS = iWork(ip_ij2-1 +(ij-1)*2 + 1)
            jS = iWork(ip_ij2-1 +(ij-1)*2 + 2)
            If (TMax_All*TMax2(iS,jS).ge.CutInt) Then
               nij = nij + 1
               iWork((nij-1)*2+ip_ij  )=iS
               iWork((nij-1)*2+ip_ij+1)=jS
            End If
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute FLOP's for the transfer equation.
*
      Do iAng = 0, S%iAngMx
         Do jAng = 0, iAng
            nHrrab = 0
            Do i = 0, iAng+1
               Do j = 0, jAng+1
                  If (i+j.le.iAng+jAng+1) Then
                     ijMax = Min(iAng,jAng)+1
                     nHrrab = nHrrab + ijMax*2+1
                  End If
               End Do
            End Do
            nHrrTb(iAng,jAng,1)=nHrrab
            nHrrTb(jAng,iAng,1)=nHrrab
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     For a parallel implementation the iterations over shell-pairs
*     are parallelized.

      Call Init_Tsk(id,nij*(nij+1)/2)
*                                                                      *
************************************************************************
*                                                                      *
*     In MPP case dispatch one processor to do 1-el gradients first
*
      If (nProcs.gt.1.and.King()) Then
         If (Do_RI) Call Free_iSD()
         Call Drvh1(Grad,Temp,nGrad)
*        If (nPrint(1).ge.15)
*    &   Call PrGrad(' Gradient excluding two-electron contribution',
*    &               Grad,lDisp(0),ChDisp,iPrint)
         call dcopy_(nGrad,[Zero],0,Temp,1)
         If (Do_RI) Then
            Call Set_Basis_Mode('Auxiliary')
            Call Setup_iSD()
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_MaxDBLE(MemMax)
      Call mma_allocate(Sew_Scr,MemMax,Label='Sew_Scr')
      ipMem1=1
*                                                                      *
************************************************************************
*                                                                      *
C     Call Get_MyRank(MyRank_)
C     If (MyRank_.ne.0) Go To 11
*     big loop over individual tasks, distributed over individual nodes
   10 Continue
*     make reservation of a task on global task list and get task range
*     in return. Function will be false if no more tasks to execute.
      If (.Not.Rsv_Tsk(id,jlS)) Go To 11
*
*     Now do a quadruple loop over shells
*
      jS_= Int((One+sqrt(Eight*DBLE(jlS)-Three))/Two)
      iS = iWork((jS_-1)*2  +ip_ij)
      jS = iWork((jS_-1)*2+1+ip_ij)
      lS_= Int(DBLE(jlS)-DBLE(jS_)*(DBLE(jS_)-One)/Two)
      kS = iWork((lS_-1)*2  +ip_ij)
      lS = iWork((lS_-1)*2+1+ip_ij)
      Call CWTime(TCpu1,TWall1)
*
         If (Do_RI) Then
            Aint=TMax1(jS)*TMax1(lS)
         Else
            Aint=TMax2(iS,jS)*TMax2(kS,lS)
         End If
         If (AInt.lt.CutInt) Go To 10
C        If (is.eq.3.and.js.eq.3.and.ks.eq.1.and.ls.eq.1) Then
C           iPrint=15
C           nPrint(39)=15
C        Else
C           iPrint=nPrint(iRout)
C           nPrint(39)=5
C        End If
         If (iPrint.ge.15) Write (6,*) 'iS,jS,kS,lS=',iS,jS,kS,lS
*                                                                      *
************************************************************************
*                                                                      *
         Call Gen_iSD4(iS, jS, kS, lS,iSD,nSD,iSD4)
         Call Size_SO_block_g(iSD4,nSD,nSO,No_batch)
         If (No_batch) Go To 140
*
         Call Int_Prep_g(iSD4,nSD,Coor,Shijij,iAOV,iStabs)
*
*                                                                      *
************************************************************************
*                                                                      *
*       --------> Memory Managment <--------
*
*        Compute memory request for the primitives, i.e.
*        how much memory is needed up to the transfer
*        equation.
*
         Call MemRys_g(iSD4,nSD,nRys,MemPrm)
*                                                                      *
************************************************************************
*                                                                      *
         ABCDeq=EQ(Coor(1,1),Coor(1,2)) .and.
     &          EQ(Coor(1,1),Coor(1,3)) .and.
     &          EQ(Coor(1,1),Coor(1,4))
         ijklA=iSD4(1,1)+iSD4(1,2)
     &        +iSD4(1,3)+iSD4(1,4)
         If (nIrrep.eq.1.and.ABCDeq.and.Mod(ijklA,2).eq.1)
     &      Go To 140
*                                                                      *
************************************************************************
*                                                                      *
*        Decide on the partioning of the shells based on the
*        available memory and the requested memory.
*
*        Now check if all blocks can be computed and stored at
*        once.
*

         Call SOAO_g(iSD4,nSD,nSO,
     &               MemPrm, MemMax,
     &               iBsInc,jBsInc,kBsInc,lBsInc,
     &               iPrInc,jPrInc,kPrInc,lPrInc,
     &               ipMem1,ipMem2, Mem1,  Mem2,
     &               iPrint,iFnc, MemPSO)
         iBasi    = iSD4(3,1)
         jBasj    = iSD4(3,2)
         kBask    = iSD4(3,3)
         lBasl    = iSD4(3,4)
*                                                                      *
************************************************************************
*                                                                      *
         Call Int_Parm_g(iSD4,nSD,iAnga,
     &                 iCmpa,iShlla,iShela,
     &                 iPrimi,jPrimj,kPrimk,lPriml,
     &                 indij,k2ij,nDCRR,k2kl,nDCRS,
     &                 mdci,mdcj,mdck,mdcl,AeqB,CeqD,
     &                 nZeta,nEta,ipZeta,ipZI,
     &                 ipP,ipEta,ipEI,ipQ,ipiZet,ipiEta,
     &                 ipxA,ipxB,ipxG,ipxD,l2DI,nab,nHmab,ncd,nHmcd,
     &                 nIrrep)
*                                                                      *
************************************************************************
*                                                                      *
*        Scramble arrays (follow angular index)
*
         Do iCar = 1, 3
            Do iSh = 1, 4
               JndGrd(iCar,iSh) = iSD4(15+iCar,iSh)
               If ((iSh.eq.1 .or. iSh.eq.3).and.Do_RI) Then
                  JfGrad(iCar,iSh) = .False.
               Else If (iAnd(iSD4(15,iSh),2**(iCar-1)) .eq.
     &                                    2**(iCar-1)) Then
                  JfGrad(iCar,iSh) = .True.
               Else
                  JfGrad(iCar,iSh) = .False.
               End If
            End Do
         End Do
*
         Do 400 iBasAO = 1, iBasi, iBsInc
           iBasn=Min(iBsInc,iBasi-iBasAO+1)
           iAOst(1) = iBasAO-1
         Do 410 jBasAO = 1, jBasj, jBsInc
           jBasn=Min(jBsInc,jBasj-jBasAO+1)
           iAOst(2) = jBasAO-1
*
         Do 420 kBasAO = 1, kBask, kBsInc
           kBasn=Min(kBsInc,kBask-kBasAO+1)
           iAOst(3) = kBasAO-1
         Do 430 lBasAO = 1, lBasl, lBsInc
           lBasn=Min(lBsInc,lBasl-lBasAO+1)
           iAOst(4) = lBasAO-1
*
*----------Get the 2nd order density matrix in SO basis.
*
           nijkl = iBasn*jBasn*kBasn*lBasn
#ifdef _CD_TIMING_
           CALL CWTIME(Pget0CPU1,Pget0WALL1)
#endif
           Call PGet0(iCmpa,
     &                iBasn,jBasn,kBasn,lBasn,Shijij,
     &                iAOV,iAOst,nijkl,Sew_Scr(ipMem1),nSO,
     &                iFnc(1)*iBasn,iFnc(2)*jBasn,
     &                iFnc(3)*kBasn,iFnc(4)*lBasn,MemPSO,
     &                Sew_Scr(ipMem2),Mem2,iS,jS,kS,lS,nQuad,PMax)
#ifdef _CD_TIMING_
           CALL CWTIME(Pget0CPU2,Pget0WALL2)
           Pget2_CPU = Pget2_CPU + Pget0CPU2-Pget0CPU1
           Pget2_Wall = Pget2_Wall + Pget0WALL2-Pget0WALL1
#endif
            If (AInt*PMax.lt.CutInt) Go To 430
*
*----------Compute gradients of shell quadruplet
*
#ifdef _CD_TIMING_
           Call CWTIME(TwoelCPU1,TwoelWall1)
#endif
           Call TwoEl_g(Coor,
     &          iAnga,iCmpa,iShela,iShlla,iAOV,
     &          mdci,mdcj,mdck,mdcl,nRys,
     &          Data_k2(k2ij),nab,nHmab,nDCRR,
     &          Data_k2(k2kl),ncd,nHmcd,nDCRS,Pren,Prem,
     &          iPrimi,iPrInc,jPrimj,jPrInc,
     &          kPrimk,kPrInc,lPriml,lPrInc,
     &          Shells(iSD4(0,1))%pCff(1,iBasAO),iBasn,
     &          Shells(iSD4(0,2))%pCff(1,jBasAO),jBasn,
     &          Shells(iSD4(0,3))%pCff(1,kBasAO),kBasn,
     &          Shells(iSD4(0,4))%pCff(1,lBasAO),lBasn,
     &          Mem_DBLE(ipZeta),Mem_DBLE(ipZI),Mem_DBLE(ipP),nZeta,
     &          Mem_DBLE(ipEta), Mem_DBLE(ipEI),Mem_DBLE(ipQ),nEta,
     &          Mem_DBLE(ipxA),Mem_DBLE(ipxB),
     &          Mem_DBLE(ipxG),Mem_DBLE(ipxD),Temp,nGrad,
     &          JfGrad,JndGrd,Sew_Scr(ipMem1), nSO,Sew_Scr(ipMem2),Mem2,
     &          Aux,nAux,Shijij)
#ifdef _CD_TIMING_
           Call CWTIME(TwoelCPU2,TwoelWall2)
           Twoel2_CPU = Twoel2_CPU + TwoelCPU2-TwoelCPU1
           Twoel2_Wall = Twoel2_Wall + TwoelWall2-TwoelWall1
#endif
            If (iPrint.ge.15)
     &         Call PrGrad(' In Drvg1_2Center_RI: Grad',
     &                  Temp,nGrad,ChDisp,iPrint)
*
 430     Continue
 420     Continue
*
 410     Continue
 400     Continue
*
 140     Continue
*
         Go To 10
 11   Continue
*     End of big task loop
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Sew_Scr)
      Call Free_Tsk(id)
      Call GetMem('ip_ij','Free','Inte',ip_ij,mij)
      Call GetMem('TMax','Free','Real',ipTMax,nTMax)
*                                                                      *
************************************************************************
*                                                                      *
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*                                                                      *
************************************************************************
*                                                                      *
      Call Sync_Data(Pren,Prem,nBtch,mBtch,kBtch)
*
      iPren=3+Max(1,Int(Log10(Pren+0.001D+00)))
      iPrem=3+Max(1,Int(Log10(Prem+0.001D+00)))
      Write (Format,'(A,I2,A,I2,A)') '(A,F',iPren,
     &           '.0,A,F',iPrem,'.0,A)'
      If (iPrint.ge.6) Then
         Write (6,Format)
     &      ' A total of', Pren,' entities were prescreened and',
     &                     Prem,' were kept.'
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If(DoCholExch) Then
         Call GetMem('CijK','Free','Real',ip_CijK,2*lCijK)
         Call GetMem('A','Free','Real',ip_A,lA)
         If (iMP2Prpt.eq.2) Then
            Call GetMem('A_MP2(2)','Free','Real',ip_A_MP2(2),lA_MP2)
            Call GetMem('A_MP2(1)','Free','Real',ip_A_MP2(1),lA_MP2)
         End If
      End If
*
      Call Free_iSD()
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqagi(f,bound,inf,epsabs,epsrel,reslt,abserr,neval,ier,limit,lenw,last,iwork,work)
!***begin prologue  dqagi
!***date written   800101   (yymmdd)
!***revision date  830518   (yymmdd)
!***category no.  h2a3a1,h2a4a1
!***keywords  automatic integrator, infinite intervals,
!             general-purpose, transformation, extrapolation,
!             globally adaptive
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  the routine calculates an approximation result to a given
!            integral   i = integral of f over (bound,+infinity)
!            or i = integral of f over (-infinity,bound)
!            or i = integral of f over (-infinity,+infinity)
!            hopefully satisfying following claim for accuracy
!            abs(i-reslt) <= max(epsabs,epsrel*abs(i)).
!***description
!
!        integration over infinite intervals
!        standard fortran subroutine
!
!        parameters
!         on entry
!            f      - real*8
!                     function subprogram defining the integrand
!                     function f(x). the actual name for f needs to be
!                     declared e x t e r n a l in the driver program.
!
!            bound  - real*8
!                     finite bound of integration range
!                     (has no meaning if interval is doubly-infinite)
!
!            inf    - integer
!                     indicating the kind of integration range involved
!                     inf = 1 corresponds to  (bound,+infinity),
!                     inf = -1            to  (-infinity,bound),
!                     inf = 2             to (-infinity,+infinity).
!
!            epsabs - real*8
!                     absolute accuracy requested
!            epsrel - real*8
!                     relative accuracy requested
!                     if  epsabs <= 0
!                     and epsrel < max(50*rel.mach.acc.,0.5d-28),
!                     the routine will end with ier = 6.
!
!
!         on return
!            reslt  - real*8
!                     approximation to the integral
!
!            abserr - real*8
!                     estimate of the modulus of the absolute error,
!                     which should equal or exceed abs(i-reslt)
!
!            neval  - integer
!                     number of integrand evaluations
!
!            ier    - integer
!                     ier = 0 normal and reliable termination of the
!                             routine. it is assumed that the requested
!                             accuracy has been achieved.
!                   - ier > 0 abnormal termination of the routine. the
!                             estimates for result and error are less
!                             reliable. it is assumed that the requested
!                             accuracy has not been achieved.
!            error messages
!                     ier = 1 maximum number of subdivisions allowed
!                             has been achieved. one can allow more
!                             subdivisions by increasing the value of
!                             limit (and taking the according dimension
!                             adjustments into account). however, if
!                             this yields no improvement it is advised
!                             to analyze the integrand in order to
!                             determine the integration difficulties. if
!                             the position of a local difficulty can be
!                             determined (e.g. singularity,
!                             discontinuity within the interval) one
!                             will probably gain from splitting up the
!                             interval at this point and calling the
!                             integrator on the subranges. if possible,
!                             an appropriate special-purpose integrator
!                             should be used, which is designed for
!                             handling the type of difficulty involved.
!                         = 2 the occurrence of roundoff error is
!                             detected, which prevents the requested
!                             tolerance from being achieved.
!                             the error may be under-estimated.
!                         = 3 extremely bad integrand behaviour occurs
!                             at some points of the integration
!                             interval.
!                         = 4 the algorithm does not converge.
!                             roundoff error is detected in the
!                             extrapolation table.
!                             it is assumed that the requested tolerance
!                             cannot be achieved, and that the returned
!                             result is the best which can be obtained.
!                         = 5 the integral is probably divergent, or
!                             slowly convergent. it must be noted that
!                             divergence can occur with any other value
!                             of ier.
!                         = 6 the input is invalid, because
!                             (epsabs <= 0 and
!                              epsrel < max(50*rel.mach.acc.,0.5d-28))
!                              or limit < 1 or leniw < limit*4.
!                             reslt, abserr, neval, last are set to
!                             zero. exept when limit or leniw is
!                             invalid, iwork(1), work(limit*2+1) and
!                             work(limit*3+1) are set to zero, work(1)
!                             is set to a and work(limit+1) to b.
!
!         dimensioning parameters
!            limit - integer
!                    dimensioning parameter for iwork
!                    limit determines the maximum number of subintervals
!                    in the partition of the given integration interval
!                    (a,b), limit >= 1.
!                    if limit < 1, the routine will end with ier = 6.
!
!            lenw  - integer
!                    dimensioning parameter for work
!                    lenw must be at least limit*4.
!                    if lenw < limit*4, the routine will end
!                    with ier = 6.
!
!            last  - integer
!                    on return, last equals the number of subintervals
!                    produced in the subdivision process, which
!                    determines the number of significant elements
!                    actually in the work arrays.
!
!         work arrays
!            iwork - integer
!                    vector of dimension at least limit, the first
!                    k elements of which contain pointers
!                    to the error estimates over the subintervals,
!                    such that work(limit*3+iwork(1)),... ,
!                    work(limit*3+iwork(k)) form a decreasing
!                    sequence, with k = last if last <= (limit/2+2), and
!                    k = limit+1-last otherwise
!
!            work  - real*8
!                    vector of dimension at least lenw
!                    on return
!                    work(1), ..., work(last) contain the left
!                     end points of the subintervals in the
!                     partition of (a,b),
!                    work(limit+1), ..., work(limit+last) contain
!                     the right end points,
!                    work(limit*2+1), ...,work(limit*2+last) contain the
!                     integral approximations over the subintervals,
!                    work(limit*3+1), ..., work(limit*3)
!                     contain the error estimates.
!***references  (none)
!***routines called  dqagie,xerror
!***end prologue  dqagi

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
interface
  function f(x)
    import :: wp
    real(kind=wp) :: f
    real(kind=wp), intent(in) :: x
  end function f
end interface
real(kind=wp), intent(in) :: bound, epsabs, epsrel
integer(kind=iwp), intent(in) :: inf, limit, lenw
real(kind=wp), intent(out) :: reslt, abserr, work(lenw)
integer(kind=iwp), intent(out) :: neval, ier, last, iwork(limit)
integer(kind=iwp) lvl, l1, l2, l3

!***first executable statement  dqagi

! check validity of limit and lenw.

ier = 6
neval = 0
last = 0
reslt = Zero
abserr = Zero
if ((limit >= 1) .and. (lenw >= limit*4)) then

  ! prepare call for dqagie.

  l1 = limit+1
  l2 = limit+l1
  l3 = limit+l2

  call dqagie(f,bound,inf,epsabs,epsrel,limit,reslt,abserr,neval,ier,work(1),work(l1),work(l2),work(l3),iwork,last)

end if

! call error handler if necessary.

lvl = 0
if (ier == 6) lvl = 1
if (ier /= 0) call xerror('abnormal return from dqagi',26,ier,lvl)

return

end subroutine dqagi

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Giovanni Li Manni                                *
!               2019, Oskar Weser                                      *
!***********************************************************************
module fcidump_reorder
  use fcidump_tables, only :  FockTable, TwoElIntTable, OrbitalTable,&
    mma_deallocate, length
  use sorting_funcs, only : leq_i

  implicit none
  private
  public :: reorder, get_P_GAS, get_P_inp, ReOrFlag, ReOrInp, cleanup
  save
! n==0: Don't reorder.
! n>=2: User defined permutation with n non-fixed point elements.
! n==-1: Use GAS sorting scheme.
  integer :: ReOrFlag = 0
  integer, allocatable :: ReOrInp(:)

  interface reorder
    module procedure FockTable_reorder, TwoElIntTable_reorder, &
      OrbitalTable_reorder, ALL_reorder
  end interface

contains

  subroutine OrbitalTable_reorder(orbitals, P)
    type(OrbitalTable), intent(inout) :: orbitals
    integer, intent(in) :: P(:)
    integer :: i
    do i = 1, length(orbitals)
      orbitals%index(i) = P(orbitals%index(i))
    end do
  end subroutine

  subroutine FockTable_reorder(fock, P)
    type(FockTable), intent(inout) :: fock
    integer, intent(in) :: P(:)
    integer :: i, j
    do j = 1, length(fock)
      do i = 1, 2
        fock%index(i, j) = P(fock%index(i, j))
      end do
    end do
  end subroutine

  subroutine TwoElIntTable_reorder(two_el_table, P)
    type(TwoElIntTable), intent(inout) :: two_el_table
    integer, intent(in) :: P(:)
    integer :: i, j
    do j = 1, length(two_el_table)
      do i = 1, 4
        two_el_table%index(i, j) = P(two_el_table%index(i, j))
      end do
    end do
    do j = 1, length(two_el_table)
      do i = 1, 4
        two_el_table%index(i, j) = P(two_el_table%index(i, j))
      end do
    end do
  end subroutine

  function get_P_GAS(ngssh) result(P)
    use sorting, only : argsort
    use general_data, only : nSym
    use gas_data, only : nGAS
    integer, intent(in) :: ngssh(:, :)
    integer :: P(sum(ngssh)), X(sum(ngssh))
    integer :: iGAS, iSym, i
    X(:) = [(((iGAS, i = 1, ngssh(iGAS, iSym)), iGAS = 1, nGAS), iSym = 1, nSym)]
    P(:) = argsort(X, leq_i)
  end function

  function get_P_inp(ReOrInp) result(P)
    use sorting, only : sort
    use general_data, only : nAsh
    integer, intent(in) :: ReOrInp(:)
    integer :: P(sum(nAsh)), change_idx(size(ReOrInp)), i
    P(:) = [(i, i = 1, size(P))]
    change_idx(:) = ReOrInp
    call sort(change_idx, leq_i)
    P(change_idx) = ReOrInp
  end function

  subroutine ALL_reorder(orbitals, fock, two_el_table, orbsym, P)
    type(OrbitalTable), intent(inout) :: orbitals
    type(FockTable), intent(inout) :: fock
    type(TwoElIntTable), intent(inout) :: two_el_table
    integer, intent(inout) :: orbsym(:)
    integer, intent(in) :: P(:)
    call reorder(orbitals, P)
    call reorder(fock, P)
    call reorder(two_el_table, P)
    orbsym(:) = orbsym(P)
  end subroutine

  subroutine cleanup()
    if (allocated(ReOrInp)) call mma_deallocate(ReOrInp)
  end subroutine
end module fcidump_reorder

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
c  ************************************************
c  ** Subroutines to deal with CASSCF CI vectors **
c  ************************************************
c  ********************************
c  ** Routines involving CI only **
c  ********************************
      subroutine cird_cvb(cvec,recn)
      implicit real*8(a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension cvec(*)
      dimension idum(1)
c  *********************************************************************
c  *                                                                   *
c  *  CIRD   := Read CI vector.                                        *
c  *                                                                   *
c  *********************************************************************

      ivec=nint(cvec(1))
      iformat=iform_ci(ivec)
      if(iformat.eq.0)then
        ioffs=0
        call rdis_cvb(idum,1,recn,ioffs)
        iformat=idum(1)
        if(iformat.ne.iform_ci(ivec))then
          write(6,*)' Incompatible vector format on file.'
          write(6,*)' Read :',iformat,' present :',iform_ci(ivec)
          call abend_cvb()
        endif
        call rdis_cvb(icnt_ci(ivec),1,recn,ioffs)
        call rdrs_cvb(w(iaddr_ci(ivec)),ndet,recn,ioffs)
      else
        write(6,*)' Unsupported format in CIRD :',iformat
        call abend_cvb()
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DMInvKap_td(DigPrec,rIn,rOut)
! DigPrec  Diagonal Preconditioner from Prec_td
! rIn      nDensC long orb RHS
! rOut     Trial vector rOut = T^-1B^x

use MCLR_Data, only: nDensC
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: DigPrec(nDensC), rIn(nDensC)
real(kind=wp), intent(out) :: rOut(nDensC)

!-----------------------------------------------------------------------
! Multiply the 1/precond in vector form, rTemp, with RHS in vector form, rIn
! ---> New trial vector.
!-----------------------------------------------------------------------

rOut(:) = rIn(:)/DigPrec(:)

end subroutine DMInvKap_td

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!***********************************************************************

subroutine GSAXPY(AB,A,B,NABCOL,NACOL,NROW,IABCOL,IACOL)
! AB(I,IABCOL(J)) = AB(I,IABCOL(J)) + A(I,IACOL(K))*B(K,J)
!
! Jeppe Olsen, Spring of 94 Daughter of MSAXPY*

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NABCOL, NACOL, NROW, IACOL(NACOL), IABCOL(NABCOL)
real(kind=wp), intent(inout) :: AB(NROW,*)
real(kind=wp), intent(in) :: A(NROW,*), B(NACOL,NABCOL)
integer(kind=iwp) :: J, JACT, K, K1ACT, K2ACT, K3ACT, K4ACT, K5ACT, NRES, NROL

#define _METH_ 2
#if (_METH_ == 1)
! Straightforward sequence
do J=1,NABCOL
  do K=1,NACOL
    JACT = IABCOL(J)
    K1ACT = IACOL(K)
    AB(:,JACT) = AB(:,JACT)+B(K,J)*A(:,K1ACT)
  end do
end do
#elif (_METH_ == 2)
! Unrolling over columns of A
NROL = 5
NRES = mod(NACOL,NROL)
! overhead
select case (NRES)
  case (1)
    do J=1,NABCOL
      K1ACT = IACOL(1)
      JACT = IABCOL(J)
      AB(:,JACT) = AB(:,JACT)+B(1,J)*A(:,K1ACT)
    end do
  case (2)
    do J=1,NABCOL
      K1ACT = IACOL(1)
      K2ACT = IACOL(2)
      JACT = IABCOL(J)
      AB(:,JACT) = AB(:,JACT)+B(1,J)*A(:,K1ACT)+B(2,J)*A(:,K2ACT)
    end do
  case (3)
    do J=1,NABCOL
      K1ACT = IACOL(1)
      K2ACT = IACOL(2)
      K3ACT = IACOL(3)
      JACT = IABCOL(J)
      AB(:,JACT) = AB(:,JACT)+B(1,J)*A(:,K1ACT)+B(2,J)*A(:,K2ACT)+B(3,J)*A(:,K3ACT)
    end do
  case (4)
    do J=1,NABCOL
      K1ACT = IACOL(1)
      K2ACT = IACOL(2)
      K3ACT = IACOL(3)
      K4ACT = IACOL(4)
      JACT = IABCOL(J)
      AB(:,JACT) = AB(:,JACT)+B(1,J)*A(:,K1ACT)+B(2,J)*A(:,K2ACT)+B(3,J)*A(:,K3ACT)+B(4,J)*A(:,K4ACT)
    end do
  case default
end select
! (End of Overhead)
do K=NRES+1,NACOL,NROL
  do J=1,NABCOL
    K1ACT = IACOL(K)
    K2ACT = IACOL(K+1)
    K3ACT = IACOL(K+2)
    K4ACT = IACOL(K+3)
    K5ACT = IACOL(K+4)
    JACT = IABCOL(J)
    AB(:,JACT) = AB(:,JACT)+B(K,J)*A(:,K1ACT)+B(K+1,J)*A(:,K2ACT)+B(K+2,J)*A(:,K3ACT)+B(K+3,J)*A(:,K4ACT)+B(K+4,J)*A(:,K5ACT)
  end do
end do
#endif

return

end subroutine GSAXPY

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jeppe Olsen                                            *
************************************************************************
      SUBROUTINE STRTYP(MS2,NACTEL,MNRS10,MXRS30,IPRNT)
*
* construct input common blocks /STRINP/
* from /LUCINP/ and /ORBINP/
*
      IMPLICIT REAL*8 (A-H,O-Z)
      Logical Reduce_Prt
      External Reduce_Prt
#include "detdim.fh"
#include "orbinp_mclr.fh"
*========
* Output
*========
*   Common block /STRINP/
*
* Jeppe Olsen ,  Dec.24 ,Almaden
*                Last Revision March 31
*
#include "strinp_mclr.fh"
* Where INTXC is internal excitation level 1 => no int exc
*                                          2 => single int exc
*                                          3 => double int exc
* DELTA : number of electrons in string - reference + 5
* ISTTP = 0 => zero  order space
* ISTTP = 1 => reference  space ,no internal excitations
* ISTTP = 2 => reference  space ,single internal excitations
* ISTTP = 3 => reference  space ,single internal excitations
*
*
      NTEST = 0000
      NTEST = MAX(NTEST,IPRNT)
*. Number of alpha and beta electrons
      NAEL = (MS2 + NACTEL ) / 2
      NBEL = (NACTEL - MS2 ) / 2
      IF(NAEL + NBEL .NE. NACTEL ) THEN
        Write (6,*) 'STRTYP: NAEL + NBEL .NE. NACTEL'
        Write (6,*) 'NAEL,NBEL,NACTEL=',NAEL,NBEL,NACTEL
************************************************************************
*     The argument iPL was missing so I inserted this piece inside the
*     stars to calculate it the same way as in the start of mclr.f
*     //Jonas B
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=iPL-1
*                                                                      *
************************************************************************
        Call PrInp_MCLR(iPL)
        Call Abend()
      END IF
* Default on alternatice RAS limits
      MXRS10 = MAX(NACTEL,2*NORB1)
      MNRS30 = 0
* =============================
*. Strings in zero order space
* =============================
*. Type : alpha-strings
      NELEC(1) = NAEL
      MNRS1(1) = MAX(0,MNRS10-MIN(NBEL,NORB1))
      MXRS1(1) = MIN(NAEL,NORB1,MXRS10)
      MNRS3(1) = MAX(0,MNRS30-MIN(NBEL,NORB3))
      MXRS3(1) = MIN(NAEL,NORB3,MXRS30)
      ITYPE = 1
      IAZTP = 1
      IZORR(ITYPE) = 1
      ISTTP(ITYPE) = 0
*. Type : single annihilated alphastrings
      IF(NAEL.GE.1) THEN
        ITYPE = ITYPE + 1
        NELEC(ITYPE) = NAEL -1
        MNRS1(ITYPE) = MAX(0,MNRS1(1)-1)
        MXRS1(ITYPE) = MIN(NAEL-1,MXRS1(1))
        MNRS3(ITYPE) = MAX(0,MNRS3(1)-1)
        MXRS3(ITYPE) = MIN(NAEL-1,MXRS3(1))
        IZORR(ITYPE) = 1
        ISTTP(ITYPE) = 0
        IATPM1=ITYPE
      END IF
*. Type : double annihilated alphastrings
      IF(NAEL.GE.2) THEN
        ITYPE = ITYPE + 1
        NELEC(ITYPE) = NAEL -2
        MNRS1(ITYPE) = MAX(0,MNRS1(1)-2)
        MXRS1(ITYPE) = MIN(NAEL-2,MXRS1(1))
        MNRS3(ITYPE) = MAX(0,MNRS3(1)-2)
        MXRS3(ITYPE) = MIN(NAEL-2,MXRS3(1))
        IZORR(ITYPE) = 1
        ISTTP(ITYPE) = 0
        IATPM2=ITYPE
      END IF
*. Type : beta strings
      IF(NAEL.EQ.NBEL) THEN
        IBZTP = IAZTP
        IBTPM1=IATPM1
        IBTPM2=IATPM2
      ELSE
        ITYPE = ITYPE + 1
        IBZTP = ITYPE
        NELEC(ITYPE) = NBEL
        MNRS1(ITYPE) = MAX(0,MNRS10-MIN(NAEL,NORB1))
        MXRS1(ITYPE) = MIN(NBEL,NORB1,MXRS10)
        MNRS3(ITYPE) = MAX(0,MNRS30-MIN(NAEL,NORB3))
        MXRS3(ITYPE) = MIN(NBEL,NORB3,MXRS30)
        IZORR(ITYPE) = 1
        ISTTP(ITYPE) = 0
*. Type : single annihilated betastrings
        IF(NBEL.GE.1) THEN
          ITYPE = ITYPE + 1
          NELEC(ITYPE) = NBEL -1
          MNRS1(ITYPE) = MAX(0,MNRS1(IBZTP)-1)
          MXRS1(ITYPE) = MIN(NBEL-1,MXRS1(IBZTP))
          MNRS3(ITYPE) = MAX(0,MNRS3(IBZTP)-1)
          MXRS3(ITYPE) = MIN(NBEL-1,MXRS3(IBZTP))
          IZORR(ITYPE) = 1
          ISTTP(ITYPE) = 0
          IBTPM1=ITYPE
        END IF
*. Type : double annihilated alphastrings
        IF(NBEL.GE.2) THEN
          ITYPE = ITYPE + 1
          NELEC(ITYPE) = NBEL -2
          MNRS1(ITYPE) = MAX(0,MNRS1(IBZTP)-2)
          MXRS1(ITYPE) = MIN(NBEL-2,MXRS1(IBZTP))
          MNRS3(ITYPE) = MAX(0,MNRS3(IBZTP)-2)
          MXRS3(ITYPE) = MIN(NBEL-2,MXRS3(IBZTP))
          IZORR(ITYPE) = 1
          ISTTP(ITYPE) = 0
          IBTPM2=ITYPE
        END IF
      END IF
*
      NSTTYP = ITYPE
      IF(NTEST.GE.1) THEN
        WRITE(6,*) ' Information about string types generated '
        WRITE(6,*) ' ========================================='
        WRITE(6,*)
        WRITE(6,'(A,I3)') ' Number of types generated ', NSTTYP
        WRITE(6,*)
          WRITE(6,'(A)' )
     *    ' ============================================'
        WRITE(6,'(A)' )
     * '  Type  NELEC MNRS1 MXRS1 MNRS3 MXRS3 ISTTP '
          WRITE(6,'(A)' )
     *    ' ============================================'
        DO 100 ITYP = 1, NSTTYP
          WRITE(6,'(7I6)') ITYP,NELEC(ITYP),MNRS1(ITYP),MXRS1(ITYP),
     *                     MNRS3(ITYP),MXRS3(ITYP),ISTTP(ITYP)
100     CONTINUE
        IF(NTEST.GE.2) THEN
          WRITE(6,*) ' IARTP IBRTP '
          CALL IWRTMA(IARTP,3,7,3,10)
          CALL IWRTMA(IBRTP,3,7,3,10)
        END IF
      END IF
*
*EAW
         DO ITYP = 1, NSTTYP
           IUNIQMP(ITYP) = ITYP
           IUNIQTP(ITYP) = ITYP
         END DO
*EAW
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AGIN()

use AMatrix, only: DFAC, KOSUU, lp1, lp12, NYU, RCA
use Constants, only: Zero, One, Two, Three, Four, Five, Seven, Nine, Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: I, ICOL, IJ, IROW, IVAL, J, L

DFAC(1) = One
DFAC(2) = One
do I=3,lp12
  DFAC(I) = DFAC(I-2)*real(I-1,kind=wp)
end do

! RCA(i,j) = c(k) (la,0;lb,0) * sqrt((2*la+1)(2*lb+1))
!   j identifies la,lb:  ss,ps,pp,ds,dp,dd,... 1,2,3,4,5,6,...
!   i identifies k: i=1 for the lowest k whose c(k) is non-zero,
!                   i=2 for the next   k  "     "    "   ", etc.

RCA(:,:) = Zero
RCA(1,1) = One
RCA(1,2) = One/Three
RCA(1,3) = One/Three
RCA(2,3) = Two/15.0_wp
RCA(1,4) = One/Five
RCA(1,5) = Two/15.0_wp
RCA(2,5) = Three/35.0_wp
RCA(1,6) = One/Five
RCA(2,6) = Two/35.0_wp
RCA(3,6) = Two/35.0_wp
RCA(1,7) = One/Seven
RCA(1,8) = Three/35.0_wp
RCA(2,8) = Four/63.0_wp
RCA(1,9) = Three/35.0_wp
RCA(2,9) = Four/105.0_wp
RCA(3,9) = Ten/231.0_wp
RCA(1,10) = One/Seven
RCA(2,10) = Four/105.0_wp
RCA(3,10) = Two/77.0_wp
RCA(4,10) = 100.0_wp/3003.0_wp
RCA(1,11) = One/Nine
RCA(1,12) = Four/63.0_wp
RCA(2,12) = Ten/198.0_wp
RCA(1,13) = Two/35.0_wp
RCA(2,13) = 20.0_wp/693.0_wp
RCA(3,13) = Ten/286.0_wp
RCA(1,14) = Four/63.0_wp
RCA(2,14) = Two/77.0_wp
RCA(3,14) = 20.0_wp/1001.0_wp
RCA(4,14) = 70.0_wp/2574.0_wp
RCA(1,15) = One/Nine
RCA(2,15) = 20.0_wp/693.0_wp
RCA(3,15) = 162.0_wp/9009.0_wp
RCA(4,15) = 20.0_wp/1287.0_wp
RCA(5,15) = 490.0_wp/21879.0_wp

IJ = 0
do I=1,lp1
  do J=1,I
    IJ = IJ+1
    KOSUU(IJ) = J
  end do
end do

ICOL = 0
do L=1,lp1
  do I=1,L
    ICOL = ICOL+1
    IVAL = L-I-2
    do IROW=1,I
      IVAL = IVAL+2
      NYU(IROW,ICOL) = IVAL
    end do
  end do
end do

return

end subroutine AGIN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CSFGRad(Grad,nGrad)
************************************************************************
*                                                                      *
* Object: to compute the CSF component of the non-adiabatic derivative *
*         coupling                                                     *
*                                                                      *
* This routine assumes C1 symmetry and needs the 'D1ao-' matrix stored *
* in the runfile                                                       *
*                                                                      *
************************************************************************
      use Basis_Info, only: nBas
      Implicit None
#include "stdalloc.fh"
#include "real.fh"
#include "nac.fh"
      Integer nGrad
      Real*8 Grad(nGrad)
*
      Integer nD,nB,lOper(1)
      Real*8 CCoor(3)
      Real*8, Dimension(:), Allocatable :: aDAO
      Logical Found
      Character(Len=80) Label
      External OvrGrd, OvrMmG

      Call DCopy_(nGrad,[Zero],0,Grad,1)

      nB=nBas(0)
      Call Qpg_dArray('D1ao-',Found,nD)
      Call mma_allocate(aDAO,nD)
      Call Get_dArray('D1ao-',aDAO,nD)
*     Call TriPrt('DAO-','',aDAO,nB)

*IFG Compute the CSF contribution to the coupling vector.
*    Inner product of S[x] and D^A (antisymmetric component of transition density matrix)
*    This is the same as the product of S[x]^A and D
      isCSF=.True.
      Call DCopy_(3,[Zero],0,CCoor,1)
      lOper(1)=1
      Label='The CSF Contribution'
      Call OneEl_g(OvrGrd,OvrMmG,Grad,nGrad,.False.,CCoor,
     &           aDAO,nD,lOper,1,0,Label)
      isCSF=.False.

      Call mma_deallocate(aDAO)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DensAB(nBT,nDens,nD,Dens)
************************************************************************
*                                                                      *
*     purpose: calculate Density alpha+beta, alpha-beta and dump them  *
*              to runfile                                              *
*                                                                      *
************************************************************************
#include "real.fh"
#include "stdalloc.fh"

      Real*8 Dens(nBT,nD,nDens)
      Real*8, Dimension(:), Allocatable:: Dtemp
*
      If (nD.eq.1) Then
         Call Put_dArray('D1ao',Dens(1,1,nDens),nBT)
      Else
         Call mma_allocate(DTemp,nBT,Label='DTemp')
*
         Call DZAXPY(nBT,One,Dens(1,1,nDens),1,
     &                       Dens(1,2,nDens),1,DTemp,1)
         Call Put_dArray('D1ao',DTemp,nBT)
*
         Call DZAXPY(nBT,-One,Dens(1,2,nDens),1,
     &                        Dens(1,1,nDens),1,DTemp,1)
         Call Put_dArray('D1Sao',DTemp,nBT)
*
         Call mma_deallocate(DTemp)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, IBM                                              *
!***********************************************************************

#define _CHECK_
function iPrmt(jOper,iChct)
!***********************************************************************
!     Returns the phase factor of a basis function under a symmetry    *
!     operation, jOper. iChct contains the information about the       *
!     character of the basis function.                                 *
!***********************************************************************

use Symmetry_Info, only: iOper
use Definitions, only: iwp
#ifdef _CHECK_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: iPrmt
integer(kind=iwp), intent(in) :: jOper, iChct
integer(kind=iwp) :: i, iCom

#ifdef _CHECK_
if (size(iOper) < 1) then
  write(u6,*) 'iPrmt; iOper not defined.'
  call Abend()
end if
#endif
iPrmt = 1
iCom = iand(iOper(jOper),iChct)
do i=1,3
  if (btest(iCom,i-1)) iPrmt = -iPrmt
end do

return

end function iPrmt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine CD_Tester_Col( &
#                        define _CALLING_
#                        include "cdcol_interface.fh"
                        )

use CD_Tester_mod, only: Mat
use Definitions, only: wp, iwp

implicit none
#include "cdcol_interface.fh"
integer(kind=iwp) :: i, kOff

#include "macros.fh"
unused_var(Buf)

do i=1,nCol
  kOff = nDim*(iCol(i)-1)
  Col(:,i) = Mat(kOff+1:kOff+nDim)
end do

return

end subroutine CD_Tester_Col

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c this file contains :
c
c frankie_drv
c frankie_drv_fake
c
c ----------------------------------------------------------------
c
        subroutine frankie_drv (NChHere)
c
        implicit none
c
#include "chcc1.fh"
#include "cholesky.fh"
#include "WrkSpc.fh"
c
        integer NChHere
c
c ----------------------------------------------------------------
c
c - transform AO Cholesky vectors to MO basis localy on each node
c   with fragmented cholesky index. _AI1 -> _CDtmp1
c
        call frankie(nfr,no,nv,printkey)
c
c        take local # of Cholesky Vectors on this node
        NChHere=NumCho(1)
c
        return
        end
c
c -------------------------------------------------------------------
c
        subroutine frankie_drv_fake (NChHere)
c
        implicit none
c
#include "chcc1.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
c
        integer NChHere,rc
        real*8 FracMem
c
c ----------------------------------------------------------------
        FracMem=0.0d0
        Call Cho_X_init(rc,FracMem) ! initialize cholesky info
c
c        take local # of Cholesky Vectors on this node
        NChHere=NumCho(1)

        Call Cho_X_final(rc)
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Lucia_Ini
*
      implicit real*8 (a-h,o-z)
C Input from RASSCF
#include "cstate.fh"
#include "lucia_ini.fh"
*

#include "mxpdim.fh"
#include "cecore.fh"
#include "cgas.fh"
#include "cprnt.fh"
#include "crun.fh"
#include "irat.fh"
#include "lucinp.fh"
#include "oper.fh"
#include "orbinp.fh"
#include "gasstr.fh"
#include "WrkSpc.fh"
#include "rasscf_lucia.fh"
#include "memman.fh"
C Other definitions
      PARAMETER(MXPKW = 125)
      dimension isetkw(MXPKW)
*
C ==================================
C  Initialize marks in Lucia Memory
C ==================================
      Num_Marks = 0
C ===============================================
C  Some initialization to avoid compiler warnings
C ===============================================
c      MSCOMB_CC = 0
c      I_USE_NEWCCP = 0
C =======================
C  Some initial settings
C =======================
      INI_H0 = 1
*. Flag for compatibility with normal MOLCAS input format
*
      IEXPERT = 0
      NERROR = 0
      NWARN = 0
      EXTSPC = 0
* No cc as default
*. Start out with normal integrals
c      I_USE_SIMTRH = 0
* Initialize flag to be used by densi_master to check whether the
* sigma-vector is on disk.
      iSigma_on_disk = 0
*
C ===================
C  Initialize isetkw
C ===================
      Do i = 1, mxpkw
         isetkw(i) = 0
      ENDDO
*
C =========================
C  Point group of orbitals
C =========================
      pntgrp = 1
*
C ==============================
C  Number of irreps of orbitals
C ==============================
         nirrep = nsym_molcas
         nsmcmp = nsym_molcas
         nsmob = nsym_molcas
         maxml = -1
         maxl = -1
*
C ============================
C  Number of active electrons
C ============================
      nactel = nactel_Molcas
*
C =================
C  Inactive shells
C =================
      DO irrep = 1, nirrep
         ninash(irrep) = nish_molcas(irrep)
      ENDDO
*
C ==================
C  Secondary shells
C ==================

C ===========================
C  Two times spin projection
C ===========================
      ms2 = ms2_molcas

C ===================
C  Spin multiplicity
C ===================
      mults = iSpin_molcas
*
C ====================
C  Reference symmetry
C ====================
      irefsm = lsym_molcas
*
C =======
C  Roots
C =======
      nroot = nroots_molcas
      DO i = 1, nroot
         iroot(i) = iroot_molcas(i)
      ENDDO
*
C ============
C  Enviroment
C ============
      intimp = 6
      enviro(1:6) = 'RASSCF'
*
* ====================
* 27: Ms combinations
* ====================
      IF (MULTS .EQ. 1 .AND. ISPEED(1) .EQ. 1) THEN
         ISETKW(27) = 1
         PSSIGN = 1.0D0
      ELSE
         ISETKW(27) = 0
      ENDIF
*
*===========================================================
* 33 : Largest allowed number of Vectors in diagonalization
*===========================================================
      MXCIV = 2*NROOT
*
C ==========================
C  Storage mode for vectors
C ==========================
      icistr = 2
C =================================
C  Tell Lucia to use CSF-expansion
C =================================
c      noscf = 0
*
* ================================
* 39 : Define dimension of resolution matrices
* ================================
      MXINKA = 150
*
C ==========================================================
C  Generalized active space concept invoked, orbital spaces
C ==========================================================
      ngas=ngas_molcas
      ngssh=0
      do irrep = 1,nirrep
        do igas=1,ngas
          ngssh(irrep,igas)=ngssh_molcas(igas,irrep)
        end do
      end do
*
C ==================================================
C  Generalized active space occupation restrictions
C ==================================================
      ncispc = 1
      do i=1,ngas
        do j=1,2
          igsoccx(i,j,1)=igsoccx_molcas(i,j)
        end do
      end do
*
C ==========================
C  Energy convergence of CI
C ==========================
      thres_e = thre_molcas
*
C ==========================================
C  Sequency of calculations to wavefunction
C ==========================================
      ncmbspc = ncispc
      nseqci(1) = 1
      cseqci(1,1) = 'CI'
      iseqci(1,1) = itmax_molcas
*
C ======================================================
C  No calculation, save CI vector info, expand CI vector
C ======================================================
      INOCALC   = INOCALC_MOLCAS
      ISAVE_EXP = ISAVE_EXP_MOLCAS
      IEXPAND   = IEXPAND_MOLCAS
*
C ================================================
C  Length of smallest block og C an Sigma vectors
C ================================================
      lcsblk = 3000000
*
* =============================================================
* 66 : No MO-AO file
* =============================================================
*
*. No MO-AO file
      NOMOFL = 1
*
C =================================
C  Calculation of density matrices
C =================================
      idensi = 2
*
C ==================================================================
C  Isimsym: Treat all symmetryblocks with given type simultaneously
C ==================================================================

C ==============================================
C  Particle hole simplifications, default is no
C ==============================================
      IUSE_PH = 0
*
* ==============================================
* 87 : Allow the sigma routine to take advice
* ==============================================
*
      IADVICE = 1
*
C ============================================================
C  Transform CI vectors to alternative orbital representation
C ============================================================
      itraci     = 1
      itraci_cr  = 'REST'
      itraci_cn  = ' '
      If (ipt2_molcas .eq. 1) Then
         itraci_cn = 'CANO'
      Else
         itraci_cn = 'NATU'
      Endif
*
C ===========
C HEXS - Highly excited states
C DEXS - Doubly excited states
C ===========
      I_ELIMINATE_GAS = I_ELIMINATE_GAS_MOLCAS
      N_ELIMINATED_GAS = N_ELIMINATED_GAS_MOLCAS
*     WRITE(6,*) I_ELIMINATE_GAS_MOLCAS,N_ELIMINATED_GAS_MOLCAS
      DO IGAS = 1, N_ELIMINATED_GAS
        IELIMINATED_IN_GAS(IGAS) = IELIMINATED_IN_GAS_MOLCAS(IGAS)
      END DO
*
C =============
C  Printlevels
C =============
      iprcix = iprci_molcas-2
      iprorb = 0
      iprdia = 0
      iprxt = 0
      iprocc = 0
      iprden = (iprci_molcas-2)/2
      iprrsp = 0
      iprpro = 0
      iprcc = 0
*
C ==============
C  Set defaults
C ==============
*
************************************************************************
*                                                                      *
* Part 2 : Insert defaults for missing optional keywords               *
*          and print error messages for missing mandatory keywords     *
*                                                                      *
************************************************************************
*
      NMISS = 0
*
*
*
* 8 : Core orbitals, only of interest if EXTSPC .ne. 0
*
         CALL ISETVC(NRS0SH,0,NIRREP)
*
* 9 : RAS 1 orbitals
*
         CALL ISETVC(NRSSH(1,1),0,NIRREP)
*
* 10 : RAS 2 orbitals
*
         CALL ISETVC(NRSSH(1,2),0,NIRREP)
*
* 11 : RAS 3 orbitals
*
         CALL ISETVC(NRSSH(1,3),0,NIRREP)
*
* 13 : Secondary space
*
         MXR4TP = 1
         DO 210 IR4TP = 1, MXR4TP
            CALL ISETVC(NRS4SH(1,IR4TP),0,NIRREP)
 210     CONTINUE
         MXER4 = 0
*
* 14 : occupation restrictions for Reference space
*
         MNRS1R = MNRS10
         MXRS3R = MXRS30
*
* 15 : Selection of active configurations
*
*. Standard is no selection
         INTSEL = 0
*
* 20 : Diagonalization routine
*
*. Standard is currently MICDV*
         IDIAG = 1
*
* 21 : Explicit Hamiltonian
*
*. Default is no explicit Hamiltonian
         MXP1 = 0
         MXP2 = 0
         MXQ  = 0
*
* 22 : Largest allowed number of CI iterations per root
*
*. Default is 20 ( not active I expect )
         MAXIT = 20
*
* 23 : Restart option
*
*. Default is no explicit Hamiltonian
         IRESTR = 0
*
* 25 : INCORE option for integrals
*
         IF(EXTSPC.EQ.0 ) THEN
            INCORE = 1
         ELSE
            INCORE = 0
         END IF
*
* 26 : DELETEd shells
*
*. If CAS + Active have been set or RAS + Ras3 have been set,
*. obtain for MOLCAS Interface from number of basis functions
         IF(INTSPC.NE.1) THEN
            CALL ISETVC(NDELSH,0,NIRREP)
         END IF
*
* 27 : Ms combinations
*
      IF(ISETKW(27).EQ.0) THEN
         PSSIGN = 0.0D0
         ISETKW(27) = 2
      ELSE IF(MS2.NE.0) THEN
         WRITE(6,*) ' Spin combinations only allowed with MS2 = 0'
        WRITE(6,*) ' Your value of MS2 = ',MS2, ' differs from zero'
         WRITE(6,*) ' LUCIA will neglect your nice suggestion '
         WRITE(6,*)  ' to use spin combinations '
         PSSIGN = 0.0D0
         ISETKW(27) = 2
      END IF
*
* 28 : Ml combinations
*
         PLSIGN = 0.0D0

      IF(PSSIGN.EQ.0.0D0) THEN
         IDC = 1
      ELSE IF(PSSIGN.NE.0.0D0) THEN
         IDC = 2
      endif

C?    WRITE(6,* ) ' TEST readin IDC = ', IDC
*
* ====================================================================
* 44 : Use Minimal operatioon count method for alpha-alpha and beta-beta
* ====================================================================
* TEST OF PERFORMANCE
      MOCAA      = ISPEED(3)
      MOCAB      = ISPEED(4)


       IUSE_PA=0

*
* 33 : Number of Ci vectors in subspace
*
*
*
      IF(IDIAG.EQ.2 .AND. MXCIV.GT.2 ) THEN
        MXCIV = 2
        NWARN = NWARN + 1
        WRITE(6,*) ' Warning : You have specified TERACI '
        WRITE(6,*) '           I allow myself to set MXCIV = 2 '
        WRITE(6,*)
        WRITE(6,*) '                   Best Wishes    '
        WRITE(6,*) '                      Lucia       '
      END IF

*
* 34 : CI storage mode
*
*
* 35 : Employ CSF expansion ?
*
*. Default is no ( only possibility at the moment )
* CSF expansion must only be used when two vectors are stored in CORE
*
* 37 : Avoid any readin of integrals ( useful for obtaining
*      size of CI expansion etc.
*
        NOINT = 0
*
* 38 : Dump integrals in formatted form : Default is No
*
c        IDMPIN = 0

*
* 40 : Use CJKAKB intermediate matrices in alpha-beta loop,
*      Default is  YES !!!!!
*
        ICJKAIB = 1
*
*  41 : Initial CI in reference space, default is : No
*
         INIREF = 0
*
*  42 : Restart with CI in reference space
*
         IRESTRF = 0
*
*
* Core energy : Default is 0 / MOLCAS : Value read in !
*
         ECORE = 0.0D0
*
*. Use perturbation theory for zero order space . def is no !
*
      IF(ISETKW(47).EQ.0) THEN
        IPERT = 0
        NPERT = 0
        ISETKW(47) = 2
*. Else ensure that a CI in reference space is performed
      ELSE
        INIREF = 1
      END IF
*
*
*. 48 : Approximate Hamiltonian in reference space : NO !!
*
      IF(ISETKW(48).EQ.0) THEN
        IAPRREF = 0
        MNRS1RE = MNRS1R
        MXRS3RE = MXRS3R
        ISETKW(48) = 2
      END IF
*
*. 49 : Approximate Hamiltonian in zero order space : NO !!
*
      IF(ISETKW(49).EQ.0) THEN
        IAPRZER = 0
        MNRS1ZE = MNRS10
        MXRS3ZE = MXRS30
        ISETKW(49) = 2
      END IF
*
* 50 : GAS shells must be defined
*
*
* 52 : Combination of gasspaces : Default is just to take each  space
*      By itself
*
      IF(ISETKW(52).EQ.0) THEN
        NCMBSPC = NCISPC
        DO ICISPC = 1, NCISPC
          LCMBSPC(ICISPC) = 1
          ICMBSPC(1,ICISPC) = ICISPC
        END DO
        ISETKW(52) = 2
      END IF
*
* 53 : Convergence threshold for CI
*
*
* 54 : General sequencer : default is just straight sequence
*      of CI with default number of iterations
*
* 55 : EKT calculation : Default is no
*
      IF(ISETKW(55).EQ.0) THEN
        IEXTKOP = 0
        ISETKW(55) = 2
      END IF
*
*. 56 : Default Machine : Good old BIM machine
*
* 57 : Allow first order correction to be saved on DISC
*     (For vector free calculations )
*     Default is : NO !!
      IF(ISETKW(57).EQ.0) THEN
        IC1DSC = 0
        ISETKW(57) = 2
      END IF
*
* 58 : Restrictions on interactions of perturbation
*
*. Default is : no
      IF(ISETKW(58).EQ.0) THEN
        IH0SPC = 0
        ISETKW(58) = 2
      END IF
*
* 59 : Type of perturbation in subspaces spaces
*
* Default is specified by IPART from keyword PERTU
      IF(ISETKW(59).EQ.0) THEN
       ISETKW(59) = 2
       IF(IH0SPC.NE.0) THEN
         DO JPTSPC = 1, NPTSPC
           IH0INSPC(JPTSPC) = IPART
         END DO
       END IF
      END IF
*
* 60 : Reference Root, default is NROOT
*
*. Should be less or equal to NROOT
      IF(ISETKW(60).EQ.1) THEN
        IF(IRFROOT.GT.NROOT) THEN
          WRITE(6,*) ' Reference root (RFROOT) larger '
          WRITE(6,*) ' than total number of roots (NROOT) '
          WRITE(6,*) ' CHANGE NROOT or RFROOT '
          NMISS = NMISS + 1
        END IF
      END IF

      IF(ISETKW(60).EQ.0) THEN
       ISETKW(60) = 2
       IRFROOT = NROOT
      END IF
*
* 61 : H0EX : Orbital spaces in which exaxt Hamiltonian is used
*      No default
*.
*. Is H0EX required ( Has H0FRM = 5 been used )
      IUSED = 0
      IF(ISETKW(59).EQ.1) THEN
         IUSED = 0
         DO JPTSPC = 1, NPTSPC
           IF( IH0INSPC(JPTSPC) .EQ. 5 ) IUSED = 1
         END DO
       END IF
       IF(IUSED.EQ.0.AND.ISETKW(61).EQ.0) THEN
*. No exact spaces included and none have been defined !
         NH0EXSPC = 0
         IH0EXSPC(1) = -1
       END IF
       IF(IUSED.EQ.1.AND.ISETKW(61).EQ.0) THEN
*. Needed, but not supplied
          WRITE(6,*) ' You have specified that zero order operator'
          WRITE(6,*) ' Include exact Hamilton operator in subspace'
          WRITE(6,*) ' You should then also supply Keyword H0EX '
          NMISS = NMISS + 1
       END IF
*
*. If perturbation theory will be invoked be sure that the
*. form of perturbation theory has been specified through
* KEYWORD PERTU ( number 47 as you maybe know )
      IDOPERT = 0
      DO JCMBSPC = 1, NCMBSPC
        DO JSEQCI = 1, NSEQCI(JCMBSPC)
          IF(ISEQCI(JSEQCI,JCMBSPC).EQ.-5 ) IDOPERT = 1
        END DO
      END DO
*
      IF(IDOPERT.EQ.1 .AND. IPERT.EQ.0) THEN
        WRITE(6,*) ' Perturbation theory will be used '
        WRITE(6,*) ' Please specify form through PERTU keyword '
        NMISS = NMISS + 1
      END IF
*
*. 62 : Default Handling of degenrences of initial CI vectors
*.      Default is : No action
*
      IF(ISETKW(62).EQ.0) THEN
        INIDEG = 0
        ISETKW(62) = 2
      END IF
*
*. 63 : Use F + Lambda(H-F) as operator instead of H
*.      Default is : No i.e Lambda = 1
*
      IF(ISETKW(63).EQ.0) THEN
        XLAMBDA = 1.0D0
        ISETKW(63) = 2
      END IF
*
*. 64 : Smallest block in batch of C and sigma
*.      Default is zero
*
*
*. 66 : NO MO file : Default is no access to MO-AO file
*
*. 68 : Type of natural orbitals, default is natural orbitals
*
      IF(ISETKW(68).EQ.0) THEN
        ISETKW(68) = 2
        IFINMO = 1
      END IF
*
*. 69 : Default Threshold for individual energy correction = 0.0
*
      IF(ISETKW(69).EQ.0) THEN
        E_THRE = 0.0D0
        ISETKW(69) = 2
      END IF
*
*. 70 : Default Threshold for wave individual function corrections = 0.0
*
      IF(ISETKW(70).EQ.0) THEN
        C_THRE = 0.0D0
        ISETKW(70) = 2
      END IF
*
*. 71 : Default Threshold for total energy corrections = 0.0
*
      IF(ISETKW(71).EQ.0) THEN
        E_CONV = 0.0D0
        ISETKW(71) = 2
      END IF
*
*. 72 : Default Threshold for total wave function correction = 0.0
*
      IF(ISETKW(72).EQ.0) THEN
        C_CONV = 0.0D0
        ISETKW(72) = 2
      END IF
*
*. 73 : Perform Class selection : Default if Yes if TERACI is used
*
      IF(ISETKW(73).EQ.0) THEN
        IF(IDIAG.EQ.1) THEN
          ICLSSEL = 0
        ELSE IF (IDIAG.EQ.2) THEN
          ICLSSEL = 1
        END IF
        ISETKW(73) = 2
      END IF
*
* 74 : Calculation of density matrices : Default is
*       calculation of one-body density
*
*. If IDENSI was set to zero and properties were requested
*  overwrite input to obtain 1-el matrix
      IF(IDENSI.EQ.0.AND.ISETKW(80).EQ.1) THEN
        WRITE(6,*) ' You have specified calculation of'
        WRITE(6,*) ' one-electron properties, and this'
        WRITE(6,*) ' requires the calculation of the '
        WRITE(6,*) ' one-electron density. '
        WRITE(6,*)
        WRITE(6,*) ' You have, however, specified IDENSI=0'
        WRITE(6,*) ' corresponding  to no densities'
        WRITE(6,*)
        WRITE(6,*) ' I will allow myself to modify your'
        WRITE(6,*) ' input to allow calculation of the '
        WRITE(6,*) ' one-electron densities, so property'
        WRITE(6,*) ' calculation can proceed as planned '
        WRITE(6,*)
        WRITE(6,*)                        ' Lucia '
*. and do it
        IDENSI = 1
      END IF
*. If CC is performed, one- and two- particle densities are
*  used in current simple-minded implementation.
*. Two-electron density also needed for MCSCF
*
* 75 : Perturbation expansion of EKT, default is no
*
      IF(ISETKW(75).EQ.0) THEN
        IPTEKT = 0
        ISETKW(75) = 2
      END IF
*
* 76 : Root for zero order operator , default is NROOT
*
*. Should be less or equal to NROOT
      IF(ISETKW(76).EQ.1) THEN
        IF(IH0ROOT.GT.NROOT) THEN
          WRITE(6,*) ' Zero order operator root (H0ROOT) larger '
          WRITE(6,*) ' than total number of roots (NROOT) '
          WRITE(6,*) ' CHANGE NROOT or H0ROOT '
          NMISS = NMISS + 1
        END IF
      END IF
      IF(ISETKW(76).EQ.0) THEN
       ISETKW(76) = 2
       IH0ROOT = NROOT
      END IF
*
* 77 : NO restart from previous vectors in calculation 2
*      Deafault is NO NO, ie. restart in calc 2
*
      IF(ISETKW(77).EQ.0) THEN
        IRST2 = 1
        ISETKW(77) = 2
      END IF
*
* 78 : skip initial energy evaluations - if possible
*
      IF(ISETKW(78).EQ.0) THEN
        ISKIPEI = 1
        ISETKW(78) = 2
      END IF
*
* 79 : Symmetry of x,y,z - needed for property calculations
*
      IF(ISETKW(79).EQ.0) THEN
*. Problematic if Properties should be calculated
       IF(ISETKW(80).EQ.1.OR.ISETKW(81).EQ.1.OR.ISETKW(82).EQ.1)
     & THEN
         WRITE(6,*) ' Symmetry of X,Y,Z has not been given'
         WRITE(6,*) ' You have to specify this for property calc'
         WRITE(6,*) ' Please add KEYWORD XYZSYM '
         NMISS = NMISS + 1
         ISETKW(79) = -1
       ELSE
*. Is not needed, just supply zeroes
         DO ICOMP = 1, 3
           IXYZSYM(ICOMP) = 0
         END DO
         ISETKW(79) = 2
       END IF
      END IF
*
* 80 : Property calculation, default is no
*
      IF(ISETKW(80).EQ.0) THEN
        NPROP = 0
        ISETKW(80) = 2
      END IF
*
* 81 : Transition properties , default is no
*
      IF(ISETKW(81).EQ.0) THEN
        ITRAPRP = 0
        ISETKW(81) = 2
      END IF
*
* 82 : Response properties , default is no
*
      IF(ISETKW(82).EQ.0) THEN
        IRESPONS = 0
        ISETKW(82) = 2
        NRESP = 0
        N_AVE_OP = 0
      END IF
*. Properties should be defined if transition properties are
*. invoked
      IF(ITRAPRP.NE.0.AND.NPROP.EQ.0) THEN
        WRITE(6,*)
     &  ' You have specified transition property calculation'
        WRITE(6,*)
     &  ' (keyword TRAPRP) but no property labels have been supplied'
        WRITE(6,*)
     &  '(Keyword PROPER). Transition densities will be obtained '
      END IF
*
* 83 : Max number of iterations in linear equations
*
      IF(ISETKW(83).EQ.0) THEN
        MXITLE = 20
        ISETKW(83) = 2
      END IF
*
* 85 : Root homing, default is no
*
      IF(ISETKW(85).EQ.0) THEN
        IROOTHOMING = 0
        ISETKW(85) = 2
      END IF
*
* 90 : Perturbation expansion of Fock matrix : default is no
*
      IF(ISETKW(90).EQ.0) THEN
       IPTFOCK = 0
       ISETKW(90) = 2
      END IF
*
* 91 : Print final CI vectors : default is no
*
      IF(ISETKW(91).EQ.0) THEN
       IPRNCIV = 0
       ISETKW(91) = 2
      END IF
*
* 93 : End Calculation with integral transformation
*
      IF(ISETKW(93).EQ.0) THEN
       ITRA_FI = 0
       ISETKW(93) = 2
      END IF
*
* 94 : Initialize Calculation with integral transformation
*
      IF(ISETKW(94).EQ.0) THEN
       ITRA_IN = 0
       ISETKW(94) = 2
      END IF
*. Requires access to MO-AO file
       IF(ITRA_IN.EQ.1.AND.NOMOFL.EQ.1) THEN
         WRITE(6,*) ' Integral transformation required, '
         WRITE(6,*) ' but no mo-ao file accessible      '
         WRITE(6,*) ' REMOVE KEWORD NOMOFL '
         ISETKW(94) = -1
         NERROR = NERROR + 1
       END IF
*
* 95 : Multispace optimization in each run, default is no
*
      IF(ISETKW(95).EQ.0) THEN
        MULSPC = 0
        IFMULSPC = 0
        LPAT = 0
        ISETKW(95) = 2
      END IF
*
*
* Expert mode ( neglect mistyped keywords ) : default is no expert
*
      IF(ISETKW(97).EQ.0) THEN
        IEXPERT = 0
        ISETKW(97) = 2
      END IF
*
* Number of roots to be converged : default is total number of roots
*
      IF(ISETKW(98).EQ.0) THEN
        NCNV_RT = NROOT
        ISETKW(98) = 2
      END IF
*
* 100 : Do quantum dot calculation, default is no
*
c      IF(ISETKW(100).EQ.0) THEN
c        IDODQ = 0
c        ISETKW(100) = 2
c      END IF
*
* 101: Restrict MS2 at some intermediate level : default is no way
*
      IF(ISETKW(101).EQ.0) THEN
        I_RE_MS2_SPACE = 0
        I_RE_MS2_VALUE = 0
        ISETKW(101) = 2
      END IF
*
*
* 103 : Treat all TT blocks with given types simultaneously : Default is no
*

        ISIMSYM = 0

*
*. Thresholds only active in connection with IDIAG = 2,
*. Check and maybe issue a warning
      IF(IDIAG.EQ.2) THEN
*. Check to ensure that zero or two thresholds were  set,
        IF(ISETKW(69).NE.ISETKW(70)) THEN
          WRITE(6,*)
     &    ' Only a single threshold (E_THRE or C_THRE) '
          WRITE(6,*)
     &    ' on individual determinants given. '
          WRITE(6,*)
     &    ' One of the thresholds vanishes therefore and '
          WRITE(6,*)
     &    ' all determinants will therefore be included  '
          WRITE(6,*)
          WRITE(6,*) '                   Warns '
          WRITE(6,*)
          WRITE(6,*) '                   LUCIA  '
        END IF
      ELSE
*. Good old diagonalization, thrsholds not active
        IF(ISETKW(69).EQ.1.OR.ISETKW(70).EQ.1) THEN
          WRITE(6,*)
     &    ' Thresholds on selection of individual coefficients '
          WRITE(6,*)
     &    ' are only active in connection with keyword TERACI  '
          WRITE(6,*)
          WRITE(6,*) '                   Warns '
          WRITE(6,*)
          WRITE(6,*) '                   LUCIA  '
        END IF
      END IF
*
*
*
*
      IF(NMISS.NE.0) THEN
        WRITE(6,'(1H ,A,I9)')
     &  ' Number of missing required keyword ', NMISS
        WRITE(6,*)
     &  ' You have wounded me I give up '
        WRITE(6,*)
        WRITE(6,*)
        WRITE(6,*)
        WRITE(6,*)
     & '     An expert is a man who has made all the mistakes,'
        WRITE(6,*)
     &  '     which can be made, in a very narrow field        '
        WRITE(6,*)
     &  '                                                      '
        WRITE(6,*)
     &  '                                      Niels Bohr      '
        IF(IEXPERT.EQ.0) THEN
*          STOP
          CALL SYSABENDMSG('lucia_util/lucia_ini','Input error',' ')
        ELSE
          WRITE(6,*) ' Processing continues (EXPERT mode )'
        END IF
      END IF
*. Open one-electron file to obtain core energy and
*. Number of MO's and AO's
      IF(NOINT.EQ.0.AND.ENVIRO(1:4).NE.'NONE') THEN
         ecore_env = potnuc_molcas
* Manual setting of naos_env and nmos_env
         nmos_env(1) = nbas_molcas(1)
         nmos_env(2) = nbas_molcas(2)
         nmos_env(3) = nbas_molcas(4)
         nmos_env(4) = nbas_molcas(3)
         nmos_env(5) = nbas_molcas(7)
         nmos_env(6) = nbas_molcas(6)
         nmos_env(7) = nbas_molcas(8)
         nmos_env(8) = nbas_molcas(5)
         naos_env(1) = norb_molcas(1)
         naos_env(2) = norb_molcas(2)
         naos_env(3) = norb_molcas(4)
         naos_env(4) = norb_molcas(3)
         naos_env(5) = norb_molcas(7)
         naos_env(6) = norb_molcas(6)
         naos_env(7) = norb_molcas(8)
         naos_env(8) = norb_molcas(5)
         ECORE = ECORE_ENV
      ELSE
        WRITE(6,*) ' GETOBS and CHK_ORBDIM not called '
        ECORE = 0.0D0
      END IF
*. Check number of orbitals and insert occupations for ALL/REST

************************************************************
*                                                          *
* Part 3 : Print input                                     *
*                                                          *
************************************************************
*
*. Machine in use
*
*. Type of reference state
      IF (IPRCIX .GE. 100) THEN
         WRITE(6,*)
         WRITE(6,*) '*************************************'
         WRITE(6,*) '*  Symmetry and spin of CI vectors  *'
         WRITE(6,*) '*************************************'
         WRITE(6,*)
*. Point group
           WRITE(6,'(1H ,A)')
     &       '     Point group ............ D2H'
*.Spatial symmetry
           WRITE(6,'(1H ,A,I1)')
     &       '     Spatial symmetry ....... ', IREFSM
*.Spin
         WRITE(6,'(1H ,A,I2)')
     &      '     2 times spinprojection  ', MS2
*.Number of active electrons
         WRITE(6,'(1H ,A,I2)')
     &     '     Active electrons .....  ', NACTEL
         WRITE(6,*)
         WRITE(6,*) '*********************************************'
         WRITE(6,*) '*  Shell spaces and occupation constraints  *'
         WRITE(6,*) '********************************************* '
         WRITE(6,*)
*
*
      IF(XLAMBDA.NE.1.0D0) THEN
        WRITE(6,*)
        WRITE(6,'(A,F13.8)')
     &  ' Modified operator H(l) = l*F + l*(H-F) used with l =',XLAMBDA
c        IF(IUSEH0P.EQ.0) THEN
         WRITE(6,'(A)')  ' Zero-order operator without projection used '
c        ELSE
c         WRITE(6,'(A)')  ' Zero-order operator with projection used '
c        END IF
        IF(IRESTR.EQ.0) THEN
        WRITE(6,*)
     &  ' Notice : This madness starts  in second calculation'
        ELSE
         WRITE(6,*) ' You have specified a calculation with modified '
         WRITE(6,*) ' Hamiltonian (the LAMBDA option) and RESTART '
         WRITE(6,*) ' so this is what I will do '
         WRITE(6,*)
         WRITE(6,*) '   1:) Perform CI in space 1 to obtain Hamiltonian'
         WRITE(6,*) '       (no RESTART in this space )'
         WRITE(6,*) '   2:) CI calculation in space 2  with '
         WRITE(6,*) '       modified Hamiltonian and RESTART from LU21'
         WRITE(6,*) ' Space 2 should therefore correspond to the'
         WRITE(6,*) ' restarted calculation '
       END IF
      END IF
*
      WRITE(6,*)
      WRITE(6,*) '***********'
      WRITE(6,*) '*  Roots  *'
      WRITE(6,*) '*********** '
      WRITE(6,*)
      WRITE(6,'(1H ,A,I3)')
     &  '     Number of roots to be included  ', NROOT
      WRITE(6,'(1H ,A,(20I3))')
     &  '     Roots to be obtained ', (IROOT(I),I=1, NROOT )
      WRITE(6,'(1H ,A,I3)')
     &  '     Number of roots to be converged ', NCNV_RT

*
      WRITE(6,*)
      WRITE(6,*) '**************************'
      WRITE(6,*) '*  Run time definitions  *'
      WRITE(6,*) '************************** '
      WRITE(6,*)
*. Program environment
      WRITE(6,'(A,A6)')  '      Program environment... ', ENVIRO
*
*. Integral import
      IF(NOINT.EQ.1) THEN
        WRITE(6,'(1H ,A)')
     &  '     No integrals will be read in       '
      ELSE IF(NOINT.EQ.0) THEN
*. Integral storage
      IF(INCORE.EQ.1) WRITE(6,'(1H ,A)')
     &  '     All integrals stored in core'
      END IF
      WRITE(6,*)
* ( END IF for NOINT
*. CSF or SD expansion
      IF(NOCSF.EQ.0) THEN
        WRITE(6,'(1H ,A)')
     &  '     CI optimization performed with CSF''s '
      ELSE
        WRITE(6,'(1H ,A)')
     &  '     CI optimization performed with SD''s '
      END IF
*. Ms,Ml combinations
      IF(ISETKW(27).EQ.1) THEN
        WRITE(6,'(1H ,A,F8.3)')
     &  '     Spin combinations used with sign ',PSSIGN
      END IF
      IF(ISETKW(28).EQ.1) THEN
        WRITE(6,'(1H ,A,F8.3)')
     &  '     ML   combinations used with sign ',PLSIGN
      END IF
*. Initial approximation to vectors
      WRITE(6,*)
      IF(IRESTR.EQ.1.AND.IRESTRF.EQ.0) THEN
         WRITE(6,'(1H ,A)')
     &  '     Restarted calculation '
      ELSE IF(IRESTRF.EQ.1) THEN
         WRITE(6,'(1H ,A)')
     &  '     Restarted calculation from REFERENCE space expansion'
      ELSE
         IF(MXP1.NE.0) THEN
           WRITE(6,'(1H ,A)')
     &  '     Initial vectors obtained from explicit Hamiltonian'
         ELSE IF(MXP1.EQ.0) THEN
           WRITE(6,'(1H ,A)')
     &  '     Initial vectors obtained from diagonal'
         END IF
      END IF
*. Handling of degenerencies of initial vectors
      IF(INIDEG.EQ.1) THEN
        WRITE(6,'(1H ,A)')
     &  '     Symmetric combination of degenerate initial vectors'
      ELSE IF (INIDEG.EQ.-1) THEN
        WRITE(6,'(1H ,A)')
     &  '     Antiymmetric combination of degenerate initial vectors'
      ELSE IF (INIDEG.EQ.0) THEN
        WRITE(6,'(1H ,A)')
     &  '     No combination of degenerate initial vectors'
      END IF
*. No calculation, save CI vector information and expand CI vector
      IF(INOCALC.EQ.1) THEN
        WRITE(6,'(1H ,A)')
     &  ' No calculation will be performed '
      END IF
      IF(ISAVE_EXP.EQ.1) THEN
        WRITE(6,'(1H ,A)')
     &  ' Save CI vector information '
      END IF
      IF(IEXPAND.EQ.1) THEN
        WRITE(6,'(1H ,A)')
     &  ' Expand shorter CI vector in longer one '
      END IF
*. Ms,Ml combinations
C     IF(ISETKW(27).EQ.1) THEN
C       WRITE(6,'(1H ,A,F8.3)')
C    &  '     Spin combinations used with sign ',PSSIGN
C     END IF
C     IF(ISETKW(28).EQ.1) THEN
C       WRITE(6,'(1H ,A,F8.3)')
C    &  '     ML   combinations used with sign ',PLSIGN
C     END IF
*. CI storage mode
      WRITE(6,*)

        WRITE(6,*)
     &  '     3 symmetry blocks will be held in core '

      IF(LCSBLK.NE.0) WRITE(6,'(A,I10)')
     &  '      Smallest allowed size of sigma- and C-batch ',LCSBLK
      WRITE(6,'(1H ,A,I4)')
     &  '     Dimension of block of resolution strings ', MXINKA
c      IF(IUSE_PH.EQ.1) THEN
c        WRITE(6,'(1H ,A)')
c     &  '     Particle-hole separation used '
c      ELSE
        WRITE(6,'(1H ,A)')
     & '      Particle-hole separation not used '
c      END IF
*
      IF(IADVICE.EQ.1) THEN
        WRITE(6,'(1H ,A)')
     &  '     Advice routine call to optimize sigma generation'
      END IF
*
c      IF(IUSE_PA.EQ.1) THEN
c        WRITE(6,'(1H ,A)')
c     &  '     Strings divided into active and passive parts'
c      ELSE
        WRITE(6,'(1H ,A)')
     &  '     Strings not divided into active and passive parts'
c      END IF
c      IF(ISIMSYM.EQ.1) THEN
c        WRITE(6,'(1H ,A)')
c     &  '     ALl TTS blocks with given types treated in sigma'
c      END IF
c      IF(IUSE_HW .EQ. 1) THEN
c        WRITE(6,*) ' Hardwired routines in use '
c      END IF
*
      WRITE(6,*)
      IF(IDENSI.EQ.0) THEN
        WRITE(6,'(1H ,A)')
     &  '     No calculation of density matrices  '
      ELSE IF(IDENSI.EQ.1) THEN
        WRITE(6,'(1H ,A)')
     &  '     One-body density matrix calculated'
      ELSE IF(IDENSI.EQ.2) THEN
        WRITE(6,'(1H ,A)')
     &  '     One- and two-body density matrices  calculated'
      END IF
      WRITE(6,*)
C?    IF(MOCAA.NE.0) WRITE(6,'(1H ,A,I4)')
C?   &  '     MOC method used for alpha-alpha+beta-beta loop '
C?    IF(MOCAB.NE.0) WRITE(6,'(1H ,A,I4)')
C?   &  '     MOC method used for alpha-beta loop            '
*
*. Diagonalization information
      WRITE(6,'(1H ,A)')
     &  '     CI diagonalization : '
      WRITE(6,'(1H ,A)')
     &  '     ==================== '
*. Subspace Hamiltinian
      IF(MXP1+MXP2+MXQ .EQ.0) THEN
        WRITE(6,'(1H ,A)')
     &  '        No subspace Hamiltonian '
      ELSE
        WRITE(6,'(1H ,A,3I4)')
     &  '        Dimensions of subspace Hamiltonian ',MXP1,MXP2,MXQ
      END IF
*. Diagonalizer
      IF(IDIAG.EQ.1.AND.ICISTR.EQ.1) THEN
        WRITE(6,'(1H ,A)')
     &    '        Diagonalizer : MINDV4 '
      ELSE IF(IDIAG.EQ.1.AND.ICISTR.GE.2) THEN
        WRITE(6,'(1H ,A)')
     &    '        Diagonalizer : MICDV* '
      ELSE IF(IDIAG.EQ.2) THEN
      WRITE(6,'(1H ,A)')
     &    '        Diagonalizer : PICO*  '
      END IF
        WRITE(6,'(1H ,A)')
     &      '        Simple diagonal used as preconditioner  '
*. Root homing
      IF(IROOTHOMING.EQ.1) THEN
      WRITE(6,'(1H ,A)')
     &  '        Root homing will be used '
      ELSE
      WRITE(6,'(1H ,A)')
     &  '        No root homing '
      END IF
*. No restart in CI calc 2
      IF(IRST2.EQ.0) THEN
      WRITE(6,'(1H ,A)')
     &  '        No restart from previous vectors in second calc '
      END IF
      IF(ISKIPEI.EQ.1) THEN
      WRITE(6,'(1H ,A)')
     &  '        Initial energy evaluations skipped after first calc'
      WRITE(6,'(1H ,A)')
     &  '        (Only active in connection with TERACI )'
      END IF
*. Number of iterations
C     WRITE(6,'(1H ,A,I2)')
C    &  '        Allowed number of iterations    ',MAXIT
*. Number of CI vectors in subspace
      WRITE(6,'(1H ,A,I2)')
     &  '        Allowed Dimension of CI subspace',MXCIV
*
      WRITE(6,'(1H ,A,E12.5)')
     &  '        Convergence threshold for energy',THRES_E
*. Multispace (multigrid info )
c      IF(MULSPC.EQ.1) THEN
c        WRITE(6,'(1H ,A,I3)')
c     &    '        Multispace method in use from space ',
c     &             IFMULSPC
c        WRITE(6,*)
c     &    '        Pattern '
c        CALL IWRTMA(IPAT,1,LPAT,1,LPAT)
c      ELSE
        WRITE(6,'(1H ,A)')
     &    '        No multispace method in use '
c      END IF
*
      WRITE(6,*)
      IF(IDIAG.EQ.2) THEN
        WRITE(6,'(1H ,A,E12.5)')
     &   '        Individual second order energy threshold',E_THRE
        WRITE(6,'(1H ,A,E12.5)')
     &   '        Individual first order wavefunction threshold',C_THRE
        IF(ICLSSEL.EQ.1) THEN
         WRITE(6,*)
         WRITE(6,'(1H ,A)')
     &   '         Class selection will be performed : '
         WRITE(6,'(1H ,A)')
     &   '         =================================== '
         WRITE(6,'(1H ,A,E12.5)')
     &    '          Total second order energy threshold',E_CONV
         WRITE(6,'(1H ,A,E12.5)')
     &    '          Total first order wavefunction threshold',C_CONV
        ELSE
         WRITE(6,'(1H ,A)')
     &'            No class selection in iterative procedure '
        END IF
      END IF
*
      IF(IPERT.NE.0) THEN
        WRITE(6,'(1H ,A)')
     &    '     Perturbation calculation'
        WRITE(6,'(1H ,A)')
     &  '     ======================= '
        WRITE(6,*)
     &  '        Root Choosen as zero order state ', IRFROOT
        WRITE(6,*)
     &  '        Root used for zero order operator ', IH0ROOT
COLD    IF(MPORENP.EQ.1) THEN
COLD    WRITE(6,*)
COLD &  '        Moller Plesset partitioning '
COLD    ELSE IF (MPORENP.EQ.2) THEN
COLD    WRITE(6,*)
COLD &  '        Epstein-Nesbet partitioning '
COLD    ELSE IF  (MPORENP.EQ.0) THEN
COLD    WRITE(6,*)
COLD &  '        One-body Hamiltonian readin '
COLD    END IF
        IF(IE0AVEX.EQ.1) THEN
          WRITE(6,*)
     &  '        Expectation value of H0 used as zero order energy '
        ELSE IF( IE0AVEX.EQ.2) THEN
          WRITE(6,*)
     &  '        Exact energy of reference used as zero order energy'
        END IF
        WRITE(6,*)
     &  '        Correction vectors obtained through  order ', NPERT
        IF(IH0SPC.EQ.0) THEN
        WRITE(6,*)
     &  '        No restrictions on perturbation interactions '
        ELSE
        WRITE(6,*)
     &  '        Perturbation restricted to interactions in subspaces'
        END IF
*
        IF(IH0SPC.NE.0) THEN
        WRITE(6,*)
        WRITE(6,*)
     &  '        Number of perturbation subspaces ', NPTSPC
        WRITE(6,*)
        WRITE(6,*)
     &  '        ======================== '
        WRITE(6,*)
     &  '        Perturbation subspaces : '
        WRITE(6,*)
     &  '        ======================== '
        DO JPTSPC = 1, NPTSPC
COLD      WRITE(6,'(A)')
COLD &     ' ====================================================== '
          WRITE(6,'(A)')
          WRITE(6,'(7X,A)') '         Min. occ    Max. occ '
          WRITE(6,'(7X,A)') '         ========    ======== '
          DO IGAS = 1, NGAS
            WRITE(6,'(7X,A,I2,3X,I3,9X,I3)')
     &      '   GAS',IGAS,IOCPTSPC(1,IGAS,JPTSPC)
     &                   ,IOCPTSPC(2,IGAS,JPTSPC)
          END DO
        END DO
*
        WRITE(6,*)
        WRITE(6,'(7X,A)') ' ========================================'
        WRITE(6,'(7X,A)') ' Approximate Hamiltonian in CI subspaces '
        WRITE(6,'(7X,A)') ' ========================================'
        WRITE(6,'(7X,A)')
        WRITE(6,'(7X,A)') '    Subspace          H(apr)   '
        WRITE(6,'(7X,A)') '  ============================='
        WRITE(6,'(7X,A)')
        DO JPTSPC = 1, NPTSPC
          IF(IH0INSPC(JPTSPC).EQ.1) THEN
            WRITE(6,'(12X,I3,8X,A)')
     &      JPTSPC, ' Diagonal Fock operator '
          ELSE IF(IH0INSPC(JPTSPC).EQ.2) THEN
            WRITE(6,'(12X,I3,8X,A)')
     &      JPTSPC, ' Epstein-Nesbet operator'
          ELSE IF(IH0INSPC(JPTSPC).EQ.3) THEN
            WRITE(6,'(12X,I3,8X,A)')
     &      JPTSPC, ' Nondiagonal Fock operator '
          ELSE IF(IH0INSPC(JPTSPC).EQ.4) THEN
            WRITE(6,'(12X,I3,8X,A)')
     &      JPTSPC, ' Complete Hamiltonian  '
          ELSE IF(IH0INSPC(JPTSPC).EQ.5) THEN
            WRITE(6,'(12X,I3,8X,A)')
     &      JPTSPC, ' Mix of Fock and Exact operator '
          END IF
         END DO
         IF(ISETKW(61).GT.0) THEN
           WRITE(6,*)
           WRITE(6,'(7X,A)')
     &     ' Orbital subspaces where exact Hamiltonian is used : '
           WRITE(6,'(7X,A)')
     &      '===================================================='
           WRITE(6,*)
           WRITE(6,'(10X,10(2X,I3))') (IH0EXSPC(I),I=1, NH0EXSPC)
           WRITE(6,*)
         END IF
*
       END IF
       END IF
*
*
       IF(NPROP.EQ.0) THEN
       WRITE(6,*)
C        WRITE(6,*) '     No calculation of properties'
       ELSE
         WRITE(6,'(7X,A,I3)')
     &   ' Number of properties to be calculated', NPROP
         WRITE(6,*)
         WRITE(6,'(9X,A)')    ' Properties : '
         WRITE(6,'(9X,A)')   ' ============='
         DO IPROP = 1, NPROP
           WRITE(6,'(16X,A)') PROPER(IPROP)
         END DO
*
c         IF(IRELAX.EQ.0) THEN
           WRITE(6,'(7X,A)') ' No use of relaxed densities '
c         ELSE
c           WRITE(6,'(7X,A)')
c     &     ' Relaxed densities used for property evaluation'
C          WRITE(6,'(7X,A)') ' (implemented only for pert) '
c         END IF
       END IF
*
       IF(IEXTKOP.EQ.0.AND.IPTEKT.EQ.0) THEN
C        WRITE(6,'(5X,A)') ' No extended Koopmans'' calculations '
       ELSE IF(IEXTKOP.NE.0) THEN
         WRITE(6,'(5X,A)') ' Extended Koopmans'' calculations '
       ELSE IF(IPTEKT.NE.0) THEN
         WRITE(6,'(5X,A)') ' Perturbation expansion of EKT equations'
       END IF
*
       IF(IPTFOCK.EQ.1) THEN
         WRITE(6,*) ' Perturbation expansion of Fock matrix '
       ELSE
C        WRITE(6,*) 'No  Perturbation expansion of Fock matrix '
       END IF
*
      IF(ITRAPRP.EQ.0) THEN
C       WRITE(6,*)
C       WRITE(6,'(5X,A)')
C    &  ' No transition properties will be calculated'
      ELSE
        WRITE(6,*)
        WRITE(6,'(5X,A)')
     &  ' Transition properties will be calculated '
        WRITE(6,*)  ' Symmetry of additional states :', IEXCSYM
        WRITE(6,*)  ' Number   of additional states :', NEXCSTATE
        WRITE(6,*)
      END IF
*
*
      IF(IRESPONS.NE.0) THEN
      WRITE(6,*)
      WRITE(6,*) '**************************'
      WRITE(6,*) '*  Response Calculation  *'
      WRITE(6,*) '************************** '
      WRITE(6,*)
        WRITE(6,*)
     &  ' CI-Response will be called after each CI calculation'
        WRITE(6,*)
     &  ' Root used for response calculations (RFROOT) ',IRFROOT
        WRITE(6,*)
C       WRITE(6,*) ' Number of A-operators : ', N_AVE_OP
        WRITE(6,*) ' Labels of A-operators '
        WRITE(6,*) ' ======================='
        WRITE(6,*)
        DO IAVE = 1, N_AVE_OP
          WRITE(6,'(1H , 6X,A)') AVE_OP(IAVE)
        END DO
        WRITE(6,*)
C       WRITE(6,*) ' Number of response calculations ', NRESP
        WRITE(6,*) ' Perturbations : '
        WRITE(6,*) ' ================'
        WRITE(6,*)
        WRITE(6,*) ' Calc  Op1    Op2    Mxord1     Mxord2    Freq '
        DO IRESP = 1, NRESP
          WRITE(6,'(1H ,I2,2X,A,A,3X,I4,3X,I4,2X,F12.7)' )
     &    IRESP,RESP_OP(1,IRESP),RESP_OP(2,IRESP),MAXORD_OP(1,IRESP),
     &    MAXORD_OP(2,IRESP),RESP_W(IRESP)
        END DO
      END IF
*
C     IF(NOMOFL.EQ.0) THEN
        WRITE(6,*)
        WRITE(6,'(7X,A)') ' Final orbitals :'
        WRITE(6,'(7X,A)') ' ================'
        WRITE(6,*)
        IF(IFINMO.EQ.1) THEN
          WRITE(6,'(10X,A)') ' Natural orbitals'
        ELSE IF(IFINMO.EQ.2) THEN
          WRITE(6,'(10X,A)') ' Canonical orbitals'
        ELSE IF(IFINMO.EQ.3) THEN
          WRITE(6,'(10X,A)') ' Pseudo-natural orbitals'
          WRITE(6,'(10X,A)')
     &   ' (Density matrix diagonalized in orbital subspaces )'
        ELSE IF(IFINMO.EQ.4) THEN
          WRITE(6,'(10X,A)') ' Pseudo-canonical orbitals'
          WRITE(6,'(10X,A)')
     &   ' (FI+FA  diagonalized in orbital subspaces )'
         ELSE IF (IFINMO .EQ. 5 ) THEN
          WRITE(6,'(10X,A)')
     &   ' Pseudo-natural-canonical orbitals (sic)'
          WRITE(6,'(10X,A)')
     &   ' (Pseudo natural orbitals are first obtained'
          WRITE(6,'(10X,A)')
     &   '  by diagonalizing density matrix in orbital subpspaces.'
          WRITE(6,'(10X,A)')
     &   '  FI+FA is transformed to this basis, and the transformed'
          WRITE(6,'(10X,A)')
     &   '  matrix is block diagonalized) '
          WRITE(6,*)
          WRITE(6,'(10X,A)')
     &   ' Orbital spaces in which transformed FIFA is diagonalized'
          WRITE(6,'(10X,A)')
     &   ' ========================================================'
          DO IPSSPC = 1, NPSSPC
            WRITE(6,'(A,I2,A,10I4,6X,2I6)')
     &      '     SPACE',IPSSPC,'          ',
     &     (NPSSH(IRREP,IPSSPC),IRREP = 1, NIRREP)
          END DO
        END IF
C     END IF
*. Transformation of CI vectors
      IF(ITRACI.EQ.0) THEN
C       WRITE(6,'(5X,A)')  ' No transformation of CI vectors'
      ELSE
        WRITE(6,'(5X,A)')   ' CI vectors transformed in each run'
        WRITE(6,'(7X,A,A)')
     &        ' Complete or restricted rotations :',ITRACI_CR
        WRITE(6,'(7X,A,A)')
     &        ' Type of Final orbitals           :',ITRACI_CN
      END IF
*
* Integral Transformations
*
c      IF(ITRA_FI.EQ.1) THEN
c        WRITE(6,*) '      Integrals transformed to final MO''s '
c      END IF
      IF(ITRA_IN.EQ.1) THEN
        WRITE(6,*) '      Integrals transformed to initial  MO''s '
      END IF

*
*. Print levels
*
*
      WRITE(6,*)
      WRITE(6,'(1H ,A,E18.9)') '      Core energy : ', ECORE
*
c      IF(IDMPIN.EQ.1) THEN
c        WRITE(6,'(1H ,A)')
c        WRITE(6,*) '      Integrals written in formatted form (E22.15)'
c        WRITE(6,*) '      on file 90 '
c      END IF
*
      WRITE(6,*) ' IPART before leaving READIN = ', IPART
      END IF

C ================================================
C  Set ratio beteeen real and integer word length
C ================================================
      irat = rtoi_molcas
*
C =============================================
C  Find largest unused vector for use in Lucia
C =============================================
*
* Allocate memory for lucia
* Set up string info

      CALL lucia()
*
      return
      end

      SUBROUTINE COMBINATIONS(ICOMBI,SIGN)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "cstate.fh"
*
      ICOMBI = 0
      SIGN   = PSSIGN
      IF (PSSIGN .NE. 0.0D0) ICOMBI = 1
*
      RETURN
      END

!**********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022-2024, Arta Safari                                 *
!***********************************************************************

module fciqmc_interface

#ifdef _MOLCAS_MPP_
use mpi, only: MPI_COMM_WORLD, MPI_LOGICAL
use Para_Info, only: Is_Real_Par
use Definitions, only: MPIInt
#endif
use Definitions, only: wp, iwp, byte
#ifdef _HDF5_
use mh5, only: mh5_close_file, mh5_close_group, mh5_fetch_dset, mh5_get_dset_dims, mh5_open_dset, mh5_open_file_r, mh5_open_group
use Para_Info, only: MyRank
use caspt2_module, only: jstate, mstate, nActel
use pt2_guga, only: nG3
use linalg_mod, only: verify_
use fortran_strings, only: str
use filesystem, only: getcwd_
use Constants, only: Zero, One
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: u6
#endif

implicit none
private

logical(kind=iwp) :: DoFCIQMC = .false., NonDiagonal = .false., TransformToNormalOrder = .false.

public :: DoFCIQMC, load_fciqmc_g1, mkfg3fciqmc, NonDiagonal, TransformToNormalOrder

#include "macros.fh"

! new structure of GUGX module makes it necessary to pass nLev as function parameter every time :(

contains

!> @brief
!>   Load 1RDM into poly1 to compute the Fock matrix.
!>
!> @param[in]     nLev   number of levels
!> @param[inout]  g1     dense redundant 1RDM
!> @param[in]     iroot  CASSCF root number
subroutine load_fciqmc_g1(g1,iroot,nLev)

  integer(kind=iwp), intent(in) :: iroot, nLev
  real(kind=wp), intent(inout) :: g1(nLev,nLev)

# ifndef _HDF5_
  unused_var(nLev)
  unused_var(g1)
  unused_var(iroot)
# else
  call user_barrier()  ! copy required files into WorkDir
  call load_1RDM(g1)
  if (NonDiagonal) call transform_1rdm(g1)

contains

  !> @brief
  !>   Transform 1RDM to pseudo-canonical orbitals.
  subroutine transform_1rdm(g1)

    real(kind=wp), intent(inout) :: g1(nLev,nLev)
    real(kind=wp), allocatable :: fock_eigvecs(:,:), fockmat(:,:)

    call mma_allocate(fockmat,nLev,nLev,Label='fockmat')
    call mma_allocate(fock_eigvecs,nLev,nLev,Label='fock_eigvecs')
    call load_fockmat(fockmat,fock_eigvecs,nLev)
    call transmat(g1,fock_eigvecs,nLev)
    call mma_deallocate(fockmat)
    call mma_deallocate(fock_eigvecs)

  end subroutine transform_1rdm

  subroutine load_1RDM(g1)

    real(kind=wp), intent(inout) :: g1(nLev,nLev)
    integer(kind=iwp) :: hdf5_dset, hdf5_file, hdf5_group, i, len2index(2), t, u
    logical(kind=iwp) :: tExist
    integer(kind=iwp), allocatable :: indices(:,:)
    real(kind=wp), allocatable :: values(:)

    call f_Inquire('fciqmc.caspt2.'//str(iroot)//'.h5',tExist)
    call verify_(tExist,'fciqmc.caspt2.'//str(iroot)//'.h5 does not exist.')
    hdf5_file = mh5_open_file_r('fciqmc.caspt2.'//str(iroot)//'.h5')
    hdf5_group = mh5_open_group(hdf5_file,'/spinfree/1100/')
    hdf5_dset = mh5_open_dset(hdf5_group,'indices')
    len2index(:) = 0
    call mh5_get_dset_dims(hdf5_dset,len2index)
    call mma_allocate(indices,2,len2index(2))
    call mma_allocate(values,len2index(2))
    indices(:,:) = 0
    values(:) = Zero
    call mh5_fetch_dset(hdf5_group,'values',values)
    call mh5_fetch_dset(hdf5_group,'indices',indices)
    call mh5_close_group(hdf5_group)
    g1(:,:) = Zero
    do i=1,len2index(2)
      t = indices(1,i)+1
      u = indices(2,i)+1
      g1(t,u) = values(i)
      g1(u,t) = values(i)
    end do
    call mma_deallocate(indices)
    call mma_deallocate(values)
    call mh5_close_file(hdf5_file)

  end subroutine load_1RDM

# endif

end subroutine load_fciqmc_g1

!> @brief
!>   Wrapper to collect all required density and Fock matrices and feed
!>   them into poly3. Interface consistent with caspt2 mkfg3.f
!>
!> @param[out]  g1     dense redundant 1RDM
!> @param[out]  g2     dense redundant 2RDM
!> @param[out]  g3     sparse 3RDM
!> @param[out]  f1     dense contraction of Fockian with 2RDM
!> @param[out]  f2     dense contraction of Fockian with 3RDM
!> @param[out]  f3     sparse contraction of Fockian with 4RDM
!> @param[in]   idxG3  Table containing the active space indices
subroutine mkfg3fciqmc(g1,g2,g3,f1,f2,f3,idxG3,nLev)

  integer(kind=iwp), intent(in) :: nLev
  real(kind=wp), intent(inout) :: g1(nLev,nLev), g2(nLev,nLev,nLev,nLev), g3(*), f1(nLev,nLev), f2(nLev,nLev,nLev,nLev), f3(*)
  integer(kind=byte), intent(in) :: idxG3(6,*)

# ifndef _HDF5_
  unused_var(g1)
  unused_var(g2)
  unused_var(g3(1))
  unused_var(f1)
  unused_var(f2)
  unused_var(f3(1))
  unused_var(idxG3(1,1))
# else
  call load_fciqmc_mats(idxG3,g3,g2,g1,f3,f2,f1,mstate(jState),nLev)
# endif

end subroutine mkfg3fciqmc

!> @brief
!>   Read stochastically sampled 3RDMs and contracted Fock tensors
!>   stored in HDF5 format.
!>
!> @param[in]  nLev   Number of Levels in the GUGA formalism
!> @param[in]  idxG3  Table containing the active space indices
!> @param[in]  nG3    Number of 3RDM elements
!> @param[in]  g3     3RDM
!> @param[in]  g2     2RDM
!> @param[in]  g1     1RDM
!> @param[in]  f3     contracted Fock matrix with 4RDM
!> @param[in]  f2     contracted Fock matrix with 3RDM
!> @param[in]  f1     contracted Fock matrix with 2RDM
!> @param[in]  iroot  MCSCF root number.
#ifdef _HDF5_
subroutine load_fciqmc_mats(idxG3,g3,g2,g1,f3,f2,f1,iroot,nLev)

  integer(kind=iwp), intent(in) :: iroot, nLev
  integer(kind=byte), intent(in) :: idxG3(6,nG3)
  real(kind=wp), intent(inout) :: g3(*), g2(nLev,nLev,nLev,nLev), g1(nLev,nLev), f3(*), f2(nLev,nLev,nLev,nLev), f1(nLev,nLev)
  integer(kind=iwp) :: i, t, u, v, x, y, z
  real(kind=wp), allocatable :: f3_temp(:,:,:,:,:,:), g3_temp(:,:,:,:,:,:)

  write(u6,'(a)') "Initiate transfer of CASPT2 intermediates."
  call mma_allocate(f3_temp,nLev,nLev,nLev,nLev,nLev,nLev,Label='f3_temp')
  call mma_allocate(g3_temp,nLev,nLev,nLev,nLev,nLev,nLev,Label='g3_temp')
  call load_six_tensor(g3_temp,'/spinfree/3300/',iroot,nLev)
  call load_six_tensor(f3_temp,'/spinfree/4400f/',iroot,nLev)

  if (TransformToNormalOrder) then
    ! \sum_{ab} f_{ab} e_{tu,vx,yz} E_{ab} -> \sum_{ab} f_{ab} e_{tu,vx,yz,ab}
    write(u6,'(a)') "Transform F.4RDM from factorised to normal order."
    call transform_f4rdm_normal_order(f3_temp,g3_temp)
  end if

  if (NonDiagonal) then
    write(u6,'(a)') "Transform intermediates to pseudo-canonical orbitals."
    call transform_six_index(g3_temp)
    call transform_six_index(f3_temp)
  end if

  write(u6,'(a)') "Trace lower rank intermediates from 3RDM and F.4RDM."
  call calc_f2_and_g2(f3_temp,g3_temp,f2,g2)
  call calc_f1_and_g1(f2,g2,f1,g1)

  ! convert into flattened arrays
  do i=1,nG3
    t = idxG3(1,i)
    u = idxG3(2,i)
    v = idxG3(3,i)
    x = idxG3(4,i)
    y = idxG3(5,i)
    z = idxG3(6,i)
    g3(i) = g3_temp(t,u,v,x,y,z)
    f3(i) = f3_temp(t,u,v,x,y,z)
  end do
  call mma_deallocate(f3_temp)
  call mma_deallocate(g3_temp)

contains

  subroutine transform_f4rdm_normal_order(f3,g3)
    ! The transformation should be
    ! \sum_{ab} f_{ab} e_{tu,vx,yz,ab} =
    !   \sum_{ab} f_{ab} [ e_{tu,vx,yz} E_{ab} \
    !                      - \delta_{az} e_{tu,vx,yb} \ (1)
    !                      - \delta_{ax} e_{tu,vb,yz} \ (2)
    !                      - \delta_{au} e_{tb,vx,yz} ].(3)

    real(kind=wp), intent(inout) :: f3(nLev,nLev,nLev,nLev,nLev,nLev)
    real(kind=wp), intent(in) :: g3(nLev,nLev,nLev,nLev,nLev,nLev)
    integer(kind=iwp) :: t, u, v, x, y, z
    real(kind=wp), allocatable :: fock_eigvecs(:,:), fockmat(:,:)

    call mma_allocate(fockmat,nLev,nLev,Label='fockmat')
    call mma_allocate(fock_eigvecs,nLev,nLev,Label='fock_eigvecs')
    call load_fockmat(fockmat,fock_eigvecs,nLev)
    do z=1,nLev
      do y=1,nLev
        do x=1,nLev
          do v=1,nLev
            do u=1,nLev
              do t=1,nLev
                f3(t,u,v,x,y,z) = f3(t,u,v,x,y,z)-sum(fockmat(z,:)*g3(t,u,v,x,y,:))-sum(fockmat(x,:)*g3(t,u,v,:,y,z))- &
                                  sum(fockmat(u,:)*g3(t,:,v,x,y,z))
                ! (1)
                !f3(t,u,v,x,y,z) = f3(t,u,v,x,y,z)-DDOT_(nLev,fockmat(z,:),1,g3(t,u,v,x,y,:),1)
                ! (2)
                !f3(t,u,v,x,y,z) = f3(t,u,v,x,y,z)-DDOT_(nLev,fockmat(x,:),1,g3(t,u,v,:,y,z),1)
                ! (3)
                !f3(t,u,v,x,y,z) = f3(t,u,v,x,y,z)-DDOT_(nLev,fockmat(u,:),1,g3(t,:,v,x,y,z),1)
              end do
            end do
          end do
        end do
      end do
    end do
    call mma_deallocate(fockmat)
    call mma_deallocate(fock_eigvecs)

  end subroutine

  !> @brief
  !>   Transform 3RDM and F.4RDM to pseudo-canonical orbitals.
  !>
  !> @param[inout]  g3    dense redundant 3RDM
  !> @param[inout]  f3    dense redundant F.4RDM
  !> @param[in]     nLev  number of levels
  subroutine transform_six_index(six_index)

    real(kind=wp), intent(inout) :: six_index(nLev,nLev,nLev,nLev,nLev,nLev)
    integer(kind=iwp) :: iter, u2, v2, x2, y2, z2  ! prevent sharing scope with upper function
    real(kind=wp), allocatable :: buffer(:), buffer2(:), fock_eigvecs(:,:), fockmat(:,:)

    call mma_allocate(fockmat,nLev,nLev,Label='fockmat')
    call mma_allocate(fock_eigvecs,nLev,nLev,Label='fock_eigvecs')
    call mma_allocate(buffer,nLev,Label='buffer')
    call mma_allocate(buffer2,nLev,Label='buffer2')
    call load_fockmat(fockmat,fock_eigvecs,nLev)
    buffer(:) = Zero
    buffer2(:) = Zero
    do iter=1,6
      do z2=1,nLev
        do y2=1,nLev
          do x2=1,nLev
            do v2=1,nLev
              do u2=1,nLev
                select case (iter)
                  case (1)
                    buffer(:) = six_index(:,u2,v2,x2,y2,z2)
                    call dgemv_('T',nLev,nLev,One,fock_eigvecs,nLev,buffer,1,Zero,buffer2,1)
                    six_index(:,u2,v2,x2,y2,z2) = buffer2(:)
                  case (2)
                    buffer(:) = six_index(u2,:,v2,x2,y2,z2)
                    call dgemv_('T',nLev,nLev,One,fock_eigvecs,nLev,buffer,1,Zero,buffer2,1)
                    six_index(u2,:,v2,x2,y2,z2) = buffer2(:)
                  case (3)
                    buffer(:) = six_index(u2,v2,:,x2,y2,z2)
                    call dgemv_('T',nLev,nLev,One,fock_eigvecs,nLev,buffer,1,Zero,buffer2,1)
                    six_index(u2,v2,:,x2,y2,z2) = buffer2(:)
                  case (4)
                    buffer(:) = six_index(u2,v2,x2,:,y2,z2)
                    call dgemv_('T',nLev,nLev,One,fock_eigvecs,nLev,buffer,1,Zero,buffer2,1)
                    six_index(u2,v2,x2,:,y2,z2) = buffer2(:)
                  case (5)
                    buffer(:) = six_index(u2,v2,x2,y2,:,z2)
                    call dgemv_('T',nLev,nLev,One,fock_eigvecs,nLev,buffer,1,Zero,buffer2,1)
                    six_index(u2,v2,x2,y2,:,z2) = buffer2(:)
                  case (6)
                    buffer(:) = six_index(u2,v2,x2,y2,z2,:)
                    call dgemv_('T',nLev,nLev,One,fock_eigvecs,nLev,buffer,1,Zero,buffer2,1)
                    six_index(u2,v2,x2,y2,z2,:) = buffer2(:)
                end select
              end do
            end do
          end do
        end do
      end do
    end do
    call mma_deallocate(fockmat)
    call mma_deallocate(fock_eigvecs)
    call mma_deallocate(buffer)
    call mma_deallocate(buffer2)

  end subroutine transform_six_index

  pure subroutine calc_f2_and_g2(f3_temp,g3_temp,f2,g2)

    real(kind=wp), intent(in) :: f3_temp(nLev,nLev,nLev,nLev,nLev,nLev), g3_temp(nLev,nLev,nLev,nLev,nLev,nLev)
    real(kind=wp), intent(inout) :: f2(nLev,nLev,nLev,nLev), g2(nLev,nLev,nLev,nLev)
    integer(kind=iwp) :: t, u, v, x, w

    f2(:,:,:,:) = Zero
    g2(:,:,:,:) = Zero
    do w=1,nLev
      do x=1,nLev
        do v=1,nLev
          do u=1,nLev
            do t=1,nLev
              f2(t,u,v,x) = f2(t,u,v,x)+f3_temp(t,u,v,x,w,w)
              g2(t,u,v,x) = g2(t,u,v,x)+g3_temp(t,u,v,x,w,w)
            end do
          end do
        end do
      end do
    end do
    f2(:,:,:,:) = f2(:,:,:,:)/real(nActel-3,kind=wp)
    g2(:,:,:,:) = g2(:,:,:,:)/real(nActel-2,kind=wp)

  end subroutine calc_f2_and_g2

  pure subroutine calc_f1_and_g1(f2,g2,f1,g1)

    real(kind=wp), intent(in) :: f2(nLev,nLev,nLev,nLev), g2(nLev,nLev,nLev,nLev)
    real(kind=wp), intent(inout) :: f1(nLev,nLev), g1(nLev,nLev)
    integer(kind=iwp) :: t, u, w

    f1(:,:) = Zero
    g1(:,:) = Zero
    do w=1,nLev
      do u=1,nLev
        do t=1,nLev
          f1(t,u) = f1(t,u)+f2(t,u,w,w)
          g1(t,u) = g1(t,u)+g2(t,u,w,w)
        end do
      end do
    end do
    f1(:,:) = f1(:,:)/real(nActel-2,kind=wp)
    g1(:,:) = g1(:,:)/real(nActel-1,kind=wp)

  end subroutine calc_f1_and_g1

end subroutine load_fciqmc_mats

! required for MPI parallelisation
subroutine broadcast_filename(InFile)

  use filesystem, only: get_errno_, strerror_, symlink_

  character(len=*), intent(in) :: InFile
  character(len=1024) :: master
  integer(kind=iwp) :: lmaster1, err

  call prgmtranslate_master(InFile,master,lmaster1)
  call symlink_(trim(master),trim(InFile),err)
  if (err == 0) write(u6,*) strerror_(get_errno_())

end subroutine broadcast_filename

subroutine load_six_tensor(tensor,dataset,iroot,nLev)

  integer(kind=iwp), intent(in) :: iroot, nLev
  real(kind=wp), intent(inout) :: tensor(nLev,nLev,nLev,nLev,nLev,nLev)
  character(len=*), intent(in) :: dataset
  integer(kind=iwp) :: hdf5_dset, hdf5_file, hdf5_group, i, len6index(2), t, u, v, x, y, z
  logical(kind=iwp) :: tExist
  integer(kind=iwp), allocatable :: indices(:,:)
  real(kind=wp), allocatable :: values(:)

  if (myRank /= 0) call broadcast_filename('fciqmc.caspt2.'//str(iroot)//'.h5')
  call f_Inquire('fciqmc.caspt2.'//str(iroot)//'.h5',tExist)
  call verify_(tExist,'fciqmc.caspt2.'//str(iroot)//'.h5 does not exist.')
  hdf5_file = mh5_open_file_r('fciqmc.caspt2.'//str(iroot)//'.h5')
  hdf5_group = mh5_open_group(hdf5_file,trim(dataset))
  hdf5_dset = mh5_open_dset(hdf5_group,'indices')
  len6index(:) = 0
  call mh5_get_dset_dims(hdf5_dset,len6index)
  call mma_allocate(indices,6,len6index(2))
  call mma_allocate(values,len6index(2))
  indices(:,:) = 0
  values(:) = Zero
  call mh5_fetch_dset(hdf5_group,'values',values)
  call mh5_fetch_dset(hdf5_group,'indices',indices)
  call mh5_close_group(hdf5_group)

  tensor(:,:,:,:,:,:) = Zero
  do i=1,len6index(2)
    t = indices(1,i)+1
    u = indices(4,i)+1
    v = indices(2,i)+1
    x = indices(5,i)+1
    y = indices(3,i)+1
    z = indices(6,i)+1
    tensor(t,u,v,x,y,z) = values(i)
    ! pre-contracted F4RDM is no longer hermitian
    if (dataset == '/spinfree/4400f/' .and. TransformToNormalOrder) then
      call apply_6fold_symmetry(tensor,t,u,v,x,y,z,values(i))
    else
      call apply_12fold_symmetry(tensor,t,u,v,x,y,z,values(i))
    end if
  end do

  call mma_deallocate(indices)
  call mma_deallocate(values)
  call mh5_close_file(hdf5_file)

contains

  pure subroutine apply_12fold_symmetry(array,t,u,v,x,y,z,val)
    ! G3 has 12 permutational symmetries, since the spin indices of
    ! the (t,u), (v,x) and (y,z) indices have to match up.

    real(kind=wp), intent(inout) :: array(:,:,:,:,:,:)
    integer(kind=iwp), intent(in) :: t, u, v, x, y, z
    real(kind=wp), intent(in) :: val

    array(t,u,v,x,y,z) = val
    array(t,u,y,z,v,x) = val
    array(v,x,t,u,y,z) = val
    array(v,x,y,z,t,u) = val
    array(y,z,t,u,v,x) = val
    array(y,z,v,x,t,u) = val
    array(u,t,x,v,z,y) = val
    array(u,t,z,y,x,v) = val
    array(x,v,u,t,z,y) = val
    array(x,v,z,y,u,t) = val
    array(z,y,u,t,x,v) = val
    array(z,y,x,v,u,t) = val

  end subroutine apply_12fold_symmetry

  pure subroutine apply_6fold_symmetry(array,t,u,v,x,y,z,val)
    ! If F4RDM is calculated from a histogrammed wave function,
    ! the 4RDM is rewritten as
    !     <e_pq,rs,tu E_vx>
    ! such that E_vx can be precontracted with |hist>. This change voids
    ! the hermiticity property.

    real(kind=wp), intent(inout) :: array(:,:,:,:,:,:)
    integer(kind=iwp), intent(in) :: t, u, v, x, y, z
    real(kind=wp), intent(in) :: val

    array(t,u,v,x,y,z) = val
    array(t,u,y,z,v,x) = val
    array(v,x,t,u,y,z) = val
    array(v,x,y,z,t,u) = val
    array(y,z,t,u,v,x) = val
    array(y,z,v,x,t,u) = val

  end subroutine apply_6fold_symmetry

end subroutine load_six_tensor

subroutine user_barrier()

  integer(kind=iwp) :: err
  logical(kind=iwp) :: proceed_found
  character(len=1024) :: WorkDir
# ifdef _MOLCAS_MPP_
  integer(kind=MPIInt) :: error
  integer(kind=MPIInt), parameter :: ROOT = 0_MPIInt
# endif

  proceed_found = .false.
  call getcwd_(WorkDir,err)
  write(u6,'(4x,a)') 'Waiting for the 3RDM and contracted Fock matrix.'
  write(u6,'(4x,a)') 'First copy the required files into the M7 work directory:'
  if (NonDiagonal) then
    write(u6,'(8x,a)') 'cp '//trim(WorkDir)//'/fockdump.h5 $M7_WORKDIR'
    write(u6,'(4x,a)') 'Use the same FciDump as for the preceding CASCI.'
  else
    write(u6,'(8x,a)') 'cp '//trim(WorkDir)//'/{fockdump.h5,caspt2.FciDmp.h5} $M7_WORKDIR'
  end if
  write(u6,'(4x,a)') 'With these files run the FCIQMC dynamic.'
  write(u6,'(4x,a)') 'Copy the file M7.rdm.h5 as "fciqmc.caspt2.'//str(mstate(jState))//'.h5" into the run directory.'
  write(u6,'(4x,a)') 'Afterwards, create a file "PROCEED" in the same folder:'
  write(u6,'(8x,a)') 'cp $M7_WORKDIR/M7.rdm.h5 '//trim(WorkDir)//'/fciqmc.caspt2.'//str(mstate(jState))//'.h5'
  write(u6,'(8x,a)') 'touch '//trim(WorkDir)//'/PROCEED'

  do while (.not. proceed_found)
    call sleepf(1)
    if (myrank == 0) call f_Inquire('PROCEED',proceed_found)
#   ifdef _MOLCAS_MPP_
    if (is_real_par()) call MPI_Bcast(proceed_found,1_MPIInt,MPI_LOGICAL,ROOT,MPI_COMM_WORLD,error)
#   endif
  end do
  if (myrank == 0) then
    write(u6,'(a)') 'PROCEED file found. Continuing with CASPT2.'
  else if (myRank /= 0) then
    call broadcast_filename('fciqmc.caspt2.'//str(mstate(jstate))//'.h5')
  end if

end subroutine user_barrier

subroutine load_fockmat(fock_matrix,fock_eigenvectors,nLev)
  ! sometimes eigenvectors are superfluous, but I/O should stay in one place
  ! and loading them is basically for free.

  integer(kind=iwp), intent(in) :: nLev
  real(kind=wp), intent(inout) :: fock_matrix(nLev,nLev), fock_eigenvectors(nLev,nLev)
  integer(kind=iwp) :: hdf5_dset, hdf5_file, hdf5_group, i, len2index(2), t, u
  logical(kind=iwp) :: tExist
  integer(kind=iwp), allocatable :: indices(:,:)
  real(kind=wp), allocatable :: values(:)

  if (myRank /= 0) call broadcast_filename('fockdump.h5')
  call f_Inquire('fockdump.h5',tExist)
  call verify_(tExist,'fockdump.h5 does not exist.')
  hdf5_file = mh5_open_file_r('fockdump.h5')
  hdf5_group = mh5_open_group(hdf5_file,'/')
  call mh5_fetch_dset(hdf5_group,'ACT_FOCK_EIGVECS',fock_eigenvectors)
  hdf5_dset = mh5_open_dset(hdf5_group,'ACT_FOCK_INDEX')
  len2index(:) = 0
  call mh5_get_dset_dims(hdf5_dset,len2index)
  call mma_allocate(indices,2,len2index(2))
  call mma_allocate(values,len2index(2))
  indices(:,:) = 0
  values(:) = Zero
  call mh5_fetch_dset(hdf5_group,'ACT_FOCK_VALUES',values)
  call mh5_fetch_dset(hdf5_group,'ACT_FOCK_INDEX',indices)
  call mh5_close_group(hdf5_group)
  call mh5_close_file(hdf5_file)

  fock_matrix(:,:) = Zero
  do i=1,len2index(2)
    t = indices(1,i)
    u = indices(2,i)  ! unlike M7 hdf5 files, fockdump is 1-base indexed
    fock_matrix(t,u) = values(i)
    fock_matrix(u,t) = values(i)
  end do
  call mma_deallocate(indices)
  call mma_deallocate(values)

end subroutine load_fockmat
#endif

end module fciqmc_interface

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Chk_Unitary(irc,U,n,Thr)
! Thomas Bondo Pedersen, November 2005.
!
! Purpose: check that U is unitary.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: U(n,n), Thr
integer(kind=iwp) :: i, n2
real(kind=wp) :: RMS, x2
real(kind=wp), allocatable :: UTU(:,:)
real(kind=r8), external :: ddot_

if (n < 1) then
  irc = 0
  return
end if

n2 = n**2
call mma_allocate(UTU,n,n,label='UTU')

call DGEMM_('T','N',n,n,n,One,U,n,U,n,Zero,UTU,n)
do i=1,n
  UTU(i,i) = UTU(i,i)-One
end do

x2 = real(n2,kind=wp)
RMS = sqrt(dDot_(n2,UTU,1,UTU,1)/x2)
if (RMS > Thr) then
  irc = 1
else
  irc = 0
end if

call mma_deallocate(UTU)

end subroutine Chk_Unitary

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine BMtrx_Internal(nsAtom,nDimBC,nIter,mAtoms,iIter,mTR,TRVec,iTabAI,iTabAtoms,iTabBonds,nBonds,nMax,iRef,nQQ,nWndw)
!***********************************************************************
!                                                                      *
!     Objective: to handle curvilinear internal coordinates.           *
!                                                                      *
!                                                                      *
!     Authors: R. Lindh, Dept. of Theoretical Chemistry                *
!              University of Lund, SWEDEN.                             *
!              2004                                                    *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Slapaf_Info, only: Analytic_Hessian, BM, BMx, BSet, Cx, dBM, Degen, dqInt, dqInt_Aux, Gx, Gx0, HSet, HWRS, iBM, idBM, iOptC, &
                       KtB, lOld, MaxItr, mB_Tot, mdB_Tot, mq, NAC, nqBM, Numerical, PrQ, qInt, Smmtrc
use Kriging_Mod, only: nSet
use PrintLevel, only: nPrint
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Five, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nsAtom, nDimBC, nIter, mAtoms, iIter, mTR, iTabAI(2,mAtoms), nMax, iTabAtoms(2,0:nMax,nsAtom), &
                                 nBonds, iTabBonds(3,nBonds), iRef, nWndw
real(kind=wp), intent(in) :: TRVec(nDimBC,mTR)
integer(kind=iwp), intent(out) :: nQQ
integer(kind=iwp) :: i, i_Dim, iAtom, iB, iDum(6), iEnd, iGhi, iGlow, iPrint, iq, iqA, iQD, iqO, iQQ, iqR, iqRF, iqT, iRout, iSt, &
                     iX, ixyz, jIter, LuIC, M, mIter, N, nB, nB_Tot, ndB_Tot, nK, nq, nqA, nqB, nqO, nqRF, nqT, NRHS, nX
real(kind=wp) :: Alpha, Dum(1), Thr_ElRed, Thr_raw, Thr_small
logical(kind=iwp) :: g12K = .false., Proc, Proc_dB, Proc_H
character(len=32) :: filnam
character(len=14) :: cDum
integer(kind=iwp), allocatable :: Ind(:,:)
real(kind=wp), allocatable :: Degen2(:), EVal(:), F_c(:), G(:), GRef(:), GxR(:), K(:), KtBt(:,:), KtBu(:), KtM(:,:), Mult(:), &
                              Proj(:), qVal(:,:), Temp2(:,:)
character(len=14), allocatable :: qLbl(:)
integer(kind=iwp), external :: isfreeunit

#include "warnings.h"

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 128
iPrint = nPrint(iRout)+1
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(Proj,nDimBC,Label='Proj')
!                                                                      *
!***********************************************************************
!                                                                      *
Thr_raw = 3.0e-2_wp
if (HWRS) then
  Thr_ElRed = Thr_raw**2
else
  Thr_ElRed = Thr_raw
end if

i = 0
do iX=1,3*nsAtom
  iAtom = (iX+2)/3
  ixyz = iX-(iAtom-1)*3
  if (Smmtrc(ixyz,iAtom)) then
    i = i+1
    Proj(i) = One/Degen(ixyz,iAtom)
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! First some words about the handling of the symmetry. In this code
! I have selected to use only the unique components of the vectors.
! Hence, some care has to be taken to account for the degeneracy of
! some of the elements. This is handled by inserting the u matrix
! at appropriate places.

nQQ = nDimBC-mTR
if (allocated(qInt)) then
  if (size(qInt,1) /= nQQ) then
    call mma_deallocate(qInt)
    call mma_deallocate(dqInt)
  end if
end if
if (.not. allocated(qInt)) then
  call mma_allocate(qInt,nQQ,MaxItr,Label=' qInt')
  call mma_allocate(dqInt,nQQ,MaxItr,Label='dqInt')
  qInt(:,:) = Zero
  dqInt(:,:) = Zero
end if
if (allocated(dqInt_Aux)) then
  if (size(dqInt_Aux,1) /= nQQ) call mma_deallocate(dqInt_Aux)
end if
if ((.not. allocated(dqInt_Aux)) .and. (nSet > 1)) then
  call mma_allocate(dqInt_Aux,nQQ,MaxItr,nSet-1,Label='dqInt_Aux')
  dqInt_Aux(:,:,:) = Zero
end if

call mma_allocate(Degen2,nDimBC)
i = 0
do ix=1,3*nsAtom
  iAtom = (ix+2)/3
  ixyz = ix-(iAtom-1)*3
  if (Smmtrc(ixyz,iAtom)) then
    i = i+1
    Degen2(i) = Degen(ixyz,iAtom)
  end if
end do
#ifdef _DEBUGPRINT_
call RecPrt('Degen2',' ',Degen2,nDimBC,1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
filnam = 'INTCOR'
LuIC = isfreeunit(4)
call molcas_open(LuIC,filnam)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! nq: Number of redundant internal coordinates.

Proc = .false.     ! Flag for processing B
Proc_dB = .false.  ! Flag for processing dB

Thr_small = 30.0_wp*deg2rad
do while (Thr_small > 1.0e-6_wp)
  call Get_Curvil(nq,nqRF,nqB,nqA,nqT,nqO,nsAtom,iIter,nIter,Cx,Proc,Dum,1,cDum,iRef,Dum,Dum,LuIC,iDum,iIter,Dum,1,1,Proc_dB, &
                  iTabBonds,iTabAtoms,nBonds,nMax,iTabAI,mAtoms,mB_Tot,mdB_Tot,Dum,Dum,iDum,iDum,1,1,iDum,Thr_small)

  if (nq >= nQQ) exit
  Thr_small = Thr_small-Five*deg2rad
end do

rewind(LuIC)

if (nq == 0) then
  call WarningMessage(2,' BMtrx_internal: nq == 0')
  call Quit(_RC_INTERNAL_ERROR_)
end if

iGlow = nqRF+nqB+1
iGhi = nqRF+nqB+nqA
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'nq, nqB, nqA, nqT, nqO=',nq,nqB,nqA,nqT,nqO
#endif

! Now allocate some arrays which depend on nq

call mma_deallocate(BM,safe='*')
call mma_deallocate(iBM,safe='*')
call mma_deallocate(nqBM,safe='*')
call mma_allocate(BM,mB_Tot,Label='BM')
call mma_allocate(iBM,mB_Tot,Label='iBM')
call mma_allocate(nqBM,nq,Label='nqBM')
mq = nq

call mma_allocate(qVal,nq,nIter,Label='qVal')
call mma_allocate(qLbl,nq,Label='qLbl')
call mma_allocate(F_c,nq,Label='F_c')
call mma_allocate(Mult,nq,Label='Mult')
call mma_allocate(Ind,3,nq,Label='Ind')
call mma_allocate(GRef,9*nqA*nIter,Label='GRef')

F_c(:) = Zero
Mult(:) = Zero
qVal(:,:) = Zero
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Process the redundant internal coordinates for the current structure.

Proc = .true.
Proc_dB = .false.

call Get_Curvil(iq,iqRF,iqR,iqA,iqT,iqO,nsAtom,iIter,nIter,Cx,Proc,qVal,nq,qLbl,iRef,F_c,Mult,LuIC,Ind,iIter,GRef,iGlow,iGHi, &
                Proc_dB,iTabBonds,iTabAtoms,nBonds,nMax,iTabAI,mAtoms,nB_Tot,ndB_Tot,BM,Dum,iBM,iDum,mB_Tot,mdB_Tot,nqBM,Thr_small)
rewind(LuIC)

if (iq /= nq) then
  call WarningMessage(2,' Error in BMtrx_internal')
  write(u6,*) 'In BMtrx_internal: iq /= nq'
  write(u6,*) 'iq=',iq
  write(u6,*) 'nq=',nq
  call Abend()
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'nq, nqB, nqA, nqT, nqO=',nq,nqB,nqA,nqT,nqO
call RecPrt('q-values',' ',qVal,nq,nIter)
call RecPrt('Force Constant matrix in redundant basis',' ',F_c,1,nq)
call RecPrt('Multiplicity factors',' ',Mult,1,nq)
call RecPrt('Cx',' ',Cx,3*nsAtom,nIter)
call RecPrt('Gx',' ',Gx,3*nsAtom,nIter)
#endif

! Notation:
! X: cartesian coordinates
! q: redundant internal coordinates
! Q: nonredundant internal coordinates
! u: the degeneracy matrix
!
! dq = B u dx

! Start processing the B matrix for the current structure to
! generate the K matrix (dQ/dq).

call mma_allocate(K,nq**2,Label='K')
call mma_allocate(KtBu,nDimBC**2,Label='KtBu')
!                                                                      *
!***********************************************************************
!                                                                      *
! Stick in the metric of the force constants in the redundant
! space.

if (HWRS) then
  ! Scale each coordinate with the force constant

  i = 1
  do iq=1,nq
    nB = nqBM(iq)
    BM(i:i+nB-1) = F_c(iq)*BM(i:i+nB-1)
    i = i+nB
  end do
# ifdef _DEBUGPRINT_
  i = 1
  do iq=1,nq
    nB = nqBM(iq)
    call RecPrt('fcB',' ',BM(i),1,nB)
    i = i+nB
  end do
# endif
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Eliminate redundancy to produce the nonredundant internal coordinates.
!
!       t        t
! dQ = K M dq = K M B u dx

i = 1
do iq=1,nq
  nB = nqBM(iq)
  BM(i:i+nB-1) = Mult(iq)*BM(i:i+nB-1)
  i = i+nB
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (BSet) then
  call mma_allocate(G,nq*nq,Label='G')
  call mma_allocate(EVal,nTri_Elem(nq),Label='EVal')
  call ElRed2(nq,nDimBC,G,EVal,K,nK,Proj,g12K,Thr_ElRed,BM,iBM,mB_Tot,nqBM)

  if (nK > nQQ) call Remove_TR(nq,nDimBC,nQQ,K,nK,TRVec,mTR,BM,iBM,nqBM,mB_Tot)
  call mma_deallocate(EVal)
  call mma_deallocate(G)

  call Put_dArray('K',K,nq*nQQ)
else
  call Get_dArray('K',K,nq*nQQ)
end if
#ifdef _DEBUGPRINT_
call RecPrt('K',' ',K,nq,nQQ)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Print the nonreduntant coordinates.

if (PrQ) then
  call mma_allocate(Temp2,nq,nQQ,Label='Temp2')
  Temp2(:,:) = reshape(K(1:nq*nQQ),[nq,nQQ])
  do iq=1,nq
    Temp2(iq,:) = Temp2(iq,:)/Mult(iq)
  end do
  call PrintQ(Temp2,qLbl,nq,nQQ,LuIC,Mult)
  call mma_deallocate(Temp2)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (PrQ .and. (iPrint >= 6)) then
  write(u6,*)
  write(u6,'(A)') ' ******************************************'
  write(u6,'(A)') ' * Statistics of the internal coordinates *'
  write(u6,'(A)') ' ******************************************'
  write(u6,'(A,I5)') ' Translations and Rotations:     ',nqRF
  write(u6,'(A,I5)') ' Bonds                     :     ',nqB
  write(u6,'(A,I5)') ' Angles                    :     ',nqA
  write(u6,'(A,I5)') ' Torsions                  :     ',nqT
  write(u6,'(A,I5)') ' Out-of-plane angles       :     ',nqO
  write(u6,*)
end if
if (nq < nQQ) then
  call WarningMessage(2,' Error in BMtrx_internal')
  write(u6,*) 'In BMtrx_internal: nq < nQQ'
  write(u6,*) 'nq=',nq
  write(u6,*) 'nQQ=',nQQ
  call Abend()
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     The nonredundant internal coordinates are now defined!           *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Compute the values and the gradients of the nonredundant internal
! curvilinear coordinates for all the iterations.
!
! Loop over
! 1) the last to the first iteration if normal execusion
! 2) only the last if in transformation from internal to
!    cartesian

call mma_allocate(GxR,nDimBC,Label='GxR')

if (BSet) then
  iSt = nIter
  iEnd = iSt-min(nIter,nWndw+1)+1
else
  iEnd = nIter
  iSt = nIter
end if

! Note that the loop is in reverse order.

do jIter=iSt,iEnd,-1
  Proc_H = HSet .and. (jIter == iRef) .and. (.not. lOld)
  ! iOptC(8) = constrained optimization
  Proc_dB = Proc_H .and. (Analytic_Hessian .or. Numerical .or. btest(iOptC,8))
  ! Compute and store dBQQ in the reference structure
  if (Proc_dB) then
    call mma_deallocate(dBM,safe='*')
    call mma_deallocate(idBM,safe='*')
    call mma_allocate(dBM,mdB_Tot,Label='dBM')
    call mma_allocate(idBM,mdB_Tot*2,Label='idBM')
  else
    call mma_allocate(dBM,1,Label='dBM',safe='*')
    call mma_allocate(idBM,1*2,Label='idBM',safe='*')
  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  call Get_Curvil(iq,iqRF,iqR,iqA,iqT,iqO,nsAtom,jIter,nIter,Cx,Proc,qVal,nq,qLbl,iRef,F_c,Mult,LuIC,Ind,iIter,GRef,iGlow,iGHi, &
                  Proc_dB,iTabBonds,iTabAtoms,nBonds,nMax,iTabAI,mAtoms,nB_Tot,ndB_Tot,BM,dBM,iBM,idBM,mB_Tot,mdB_Tot,nqBM, &
                  Thr_small)
  rewind(LuIC)

  if (iq /= nq) then
    write(u6,*) 'In BMtrx_internal: iq /= nq'
    write(u6,*) 'iq=',iq
    write(u6,*) 'nq=',nq
    call Abend()
  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Form the gradients of Q
  !                                       T
  ! Form the K(t)MB matrix for dQ = K M B u dx

  i = 1
  do iq=1,nq
    nB = nqBM(iq)
    BM(i:i+nB-1) = Mult(iq)*BM(i:i+nB-1)
    i = i+nB
  end do
  KtBu(1:nQQ*nDimBC) = Zero
  do iQQ=0,nQQ-1
    i = 1
    do iq=1,nq
      nB = nqBM(iq)
      do iB=0,nB-1
        i_Dim = iBM(i)
        KtBu((i_Dim-1)*nQQ+iQQ+1) = KtBu((i_Dim-1)*nQQ+iQQ+1)+K(iQQ*nq+iq)*BM(i)
        i = i+1
      end do
    end do
  end do
# ifdef _DEBUGPRINT_
  call RecPrt(' The BM matrix',' ',BM(:),1,size(BM))
  call RecPrt(' The K matrix',' ',K,nq,nQQ)
  call RecPrt(' The K(t)B matrix',' ',KtBu,nQQ,nDimBC)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Store the B matrix for the last structure

  if (jIter == nIter) then
    nX = 3*nsAtom
    call mma_allocate(BMx,nX,nX,Label='BMx')
    BMx(:,:) = Zero

    ! modify from compact to full Cartesian storage.

    i_Dim = 0
    do iX=1,nX
      iAtom = (iX+2)/3
      ixyz = iX-(iAtom-1)*3
      if (Smmtrc(ixyz,iAtom)) then
        i_Dim = i_Dim+1
        do iQQ=1,nQQ
          iQD = (i_Dim-1)*nQQ+iQQ
          BMx(iX,iQQ) = KtBu(iQD)
        end do
      else
        BMx(iX,1:nQQ) = Zero
      end if
    end do

  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Branch out if only values are to be computed.

  if (BSet .or. Numerical) then
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Form the gradient for iteration jIter for the new definition
    ! of the K matrix.
    !
    ! dq/dx dE/dq = dE/dq
    !
    ! The B-matrix is stored (3*natom x nQQ)
    ! KtBu is stored nQQ, nDimBC

    call mma_allocate(KtBt,nDimBC,nQQ,Label='KtBt')
    call TRNSPS(nQQ,nDimBC,KtBu,KtBt)

    ! Strip KtB of the degeneracy factor (full).

    do iQQ=1,nQQ
      KtBt(1:nDimBC,iQQ) = KtBt(1:nDimBC,iQQ)/Degen2(1:nDimBC)
    end do

    M = nDimBC
    N = nQQ
    NRHS = 1

    call NRed(Gx(:,:,jIter),GxR,3*nsAtom,nDimBC,Smmtrc)
    call Eq_Solver('N',M,N,NRHS,KtBt,.false.,Degen2,GxR,dqInt(:,jIter))
    if (nSet > 1) then
      call NRed(Gx0(:,:,jIter),GxR,3*nsAtom,nDimBC,Smmtrc)
      call Eq_Solver('N',M,N,NRHS,KtBt,.false.,Degen2,GxR,dqInt_Aux(:,jIter,1))
    end if
    if (nSet > 2) then
      call NRed(NAC(:,:,jIter),GxR,3*nsAtom,nDimBC,Smmtrc)
      call Eq_Solver('N',M,N,NRHS,KtBt,.false.,Degen2,GxR,dqInt_Aux(:,jIter,2))
    end if
    !call RecPrt('GxR   ',' ',GxR,nDimBC,1)
    !call RecPrt('KtB   ',' ',KtBt,nQQ,nDimBC)
    !call RecPrt('drInt ',' ',dqInt(:,jIter),nQQ,1)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Save pointer to KtB to be used in backtransforming the
    ! Hessian to internal coordinates.

    if (Proc_H) then
      call mma_allocate(KtB,nDimBC,nQQ,Label='KtB')
      KtB(:,:) = KtBt(:,:)
      !call RecPrt('KtB',' ',KtB,nDimBC,nQQ)
    end if
    call mma_deallocate(KtBt)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Process the values
!      t
! Q = K M q

jIter = 1
mIter = nIter
if (.not. BSet) then
  jIter = nIter
  mIter = 1
end if
call mma_allocate(KtM,nQQ,nq,Label='KtM')
do iq=1,nq
  Alpha = Mult(iq)
  do iQQ=1,nQQ
    KtM(iQQ,iq) = K(iq+(iQQ-1)*nq)*Alpha
  end do
end do
call DGEMM_('N','N',nQQ,mIter,nq,One,KtM,nQQ,qVal(:,jIter),nq,Zero,qInt(:,jIter),nQQ)
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt(' The K Matrix',' ',K,nq,nQQ)
call RecPrt(' q-values',' ',qVal,nq,nIter)
call RecPrt('Q-values',' ',qInt,nQQ,nIter)
call RecPrt('Cx',' ',Cx,3*nsAtom,nIter)
if (BSet) then
  call RecPrt('Q-gradients',' ',dqInt,nQQ,nIter)
  call RecPrt('Gx',' ',Gx,3*nsAtom,nIter)
end if
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate memory

call mma_deallocate(KtM)
call mma_deallocate(GxR,safe='*')
call mma_deallocate(KtBu)
call mma_deallocate(K)
call mma_deallocate(GRef)
call mma_deallocate(Ind)
call mma_deallocate(Mult)
call mma_deallocate(F_c)
call mma_deallocate(qLbl)
call mma_deallocate(qVal)

call mma_deallocate(Degen2)
call mma_deallocate(Proj)

close(LuIC)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine BMtrx_Internal

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine UATM(IOut,ICharg,NAt,NSfe,m,Re,Alpha,C,IAn,NOrd,Chg,iPrint)
! New settings of radii for electrostatic cavity
! for HF/6-31(+)G* and ICOMP=4
! explicit values for C,N,O,F,S,Cl,Br,I, otherwise modified UFF radii

use Solvent_Data, only: Pauling
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Four, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IOut, ICharg, NAt, m, IAn(NAt), iPrint
integer(kind=iwp), intent(inout) :: NSfe, NOrd(m)
real(kind=wp), intent(in) :: Alpha, C(3,NAt)
real(kind=wp), intent(inout) :: Re(m), Chg(NAt)
logical(kind=iwp) :: AlBond, OKCHG, OKUAH
character(len=2) :: AtSymb
integer(kind=iwp) :: i1, IAddH, IAt, IEffbn, IQTot, IRX, IUSE, iverif, J, JE, JHAT, JJ, NH, NHI, NTotH, NUAH
real(kind=wp) :: area, DAr, DDHYb, DDX, DH, DId, DRQ, FrQ, GX, QTot, RX, surf
integer(kind=iwp), allocatable :: IBond(:,:), IBtype(:,:), IHNum(:), ITrBnd(:,:), ItrBtp(:,:), NBond(:), NTrBnd(:)
real(kind=wp), allocatable :: DAl(:), DHyb(:), DX(:), PBO(:,:)
integer(kind=iwp), parameter :: MxBond = 12, NOKUAH(9) = [6,7,8,9,15,16,17,35,53]
real(kind=wp), parameter :: Coeff(0:5) = [1.0_wp,0.9_wp,0.6_wp,0.3_wp,0.1_wp,0.0_wp], DRQM = 0.3_wp, &
                            Gmm(0:7) = [0.00_wp,0.00_wp,0.09_wp,0.13_wp,0.15_wp,0.15_wp,0.15_wp,0.15_wp], &
                            R0(0:7) = [0.00_wp,1.00_wp,1.50_wp,1.98_wp,2.08_wp,2.35_wp,2.35_wp,2.35_wp]
character, parameter :: BCH(3) = ['s','d','t'], HH1(10) = [' ','H','H','H','H','H','H','H','H','H'], &
                        HH2(10) = [' ',' ','2','3','4','5','6','7','8','9'], HY1(4) = ['*','s','s','s'], &
                        HY2(4) = [' ','p','p','p'], HY3(4) = [' ',' ','2','3']
integer(kind=iwp), external :: IRowAt
real(kind=wp), external :: AtNear, HybNew

! The number of explicitly parametrized atoms is NUAH and their atomic
! numbers are in NOKUAH

NUAH = size(NOKUAH)

! find bonds

call mma_allocate(NBond,NAt,label='NBond')
call mma_allocate(IBond,MxBond,NAt,label='IBond')
call mma_allocate(IBtype,MxBond,NAt,label='IBtype')
call mma_allocate(PBO,MxBond,NAt,label='PBO')
call mma_allocate(IHNum,NAt,label='IHNum')
call mma_allocate(NTrBnd,NAt,label='NTrBnd')
call mma_allocate(ITrBnd,MxBond,NAt,label='ITrBnd')
call mma_allocate(ITrBtp,MxBond,NAt,label='ITrBtp')
OkChg = .false.
AlBond = .false.
call FndBnd(IOut,AlBond,MxBond,NAt,IAn,C,NBond,IBond,IBtype,PBO)
NTotH = 0
IHNum(:) = 0
NTrBnd(:) = 0
do IAt=1,NAt
  if (IAn(IAt) == 1) NTotH = NTotH+1
  do JJ=1,NBond(IAt)
    JHAT = IBond(JJ,IAT)
    if (IAn(JHAT) == 1) then
      IHNum(IAt) = IHNum(IAt)+1
    else
      NTrBnd(IAt) = NTrBnd(IAt)+1
      ITrBnd(NTrBnd(IAt),IAt) = JHAT
      ITrBtp(NTrBnd(IAt),IAt) = IBType(JJ,IAt)
    end if
  end do
end do
area = Zero
do i1=1,nsfe
  iat = nord(i1)
  IEffbn = min(5,NTrBnd(IAt))
  surf = Four*Pi*re(I1)*re(I1)*coeff(IEffBn)
  area = area+surf
end do

if (iPrint > 5) then
  write(iOut,*)
  write(iOut,*)
  write(iOut,'(6X,A)') 'Polarized Continuum Model Cavity'
  write(iOut,'(6X,A)') '================================'
  write(iOut,*)
  write(iOut,'(6X,A)') ' Nord Group  Hybr  Charge Alpha Radius            Bonded to'
end if

! Assign Charge and Hybridization to atoms

call mma_allocate(DHyb,NAt,label='DHyb')
QTot = Zero
do IAt=1,NAt
  OKUAH = .false.
  do iverif=1,NUAH
    if (IAN(IAT) == NOKUAH(IVerif)) OKUAH = .true.
  end do
  DHYB(IAt) = HybNew(OKUAH,OKCHG,MxBond,IAt,IAn,NBond,IBond,IBtype,PBO,Chg(IAt))
  QTot = QTot+Chg(IAt)
end do
call mma_deallocate(IBtype)
call mma_deallocate(PBO)

! Verify and possibly correct charges

if (QTot >= 1.0e-5_wp) then
  IQTot = int(QTot+0.1_wp)
!else if (QTot < 1.0e-5_wp)
else
  IQtot = int(QTot-0.1_wp)
end if
if (IQTot /= ICharg) then
  FrQ = real(ICharg,kind=wp)/real(NAt-NTotH,kind=wp)
  do IAt=1,NAt
    !write(IOut,'(6X," Atom",I3," Old Q=",F5.2," New Q=",F5.2)') IAt,Chg(IAt),FrQ
    if (IAn(IAt) /= 1) Chg(IAt) = FrQ
  end do
end if
! Determine Re, Alpha
call mma_allocate(DAl,NAt,label='DAl')
call mma_allocate(DX,NAt,label='DX')
DX(:) = Zero
NSfe = 0
do IAt=1,NAt
  DDHYb = Zero
  DRQ = Zero
  DDX = Zero
  IRX = IRowAt(IAn(IAt))
  RX = R0(IRX)
  GX = Gmm(IRX)
  NHI = 1
  DH = Zero
  DAr = Zero
  DId = Zero
  OKUAH = .false.
  do iverif=1,NUAH
    if (IAN(IAT) == NOKUAH(IVerif)) then
      OKUAH = .true.
      DX(IAt) = AtNear(MxBond,IAt,IAn,NBond,IBond,DH,DId,DAr,Chg)
    end if
  end do
  DAl(IAt) = DAr-DId

  ! retain only H atoms not bonded to OKUAH atoms

  IUSE = 1
  if (IAn(IAt) == 1) IUSE = 0

  if (IUSE == 1) then
    NSfe = NSfe+1
    I1 = NSfe
    NOrd(I1) = IAt
    OKUAH = .false.
    Re(I1) = Pauling(IAn(IAt))
    IAddH = min(3,IHNum(IAt))
    Re(I1) = Re(I1)+real(IAddH,kind=wp)*Gx
    do iverif=1,NUAH
      if (IAN(IAT) == NOKUAH(IVerif)) OKUAH = .true.
    end do
    if (okuah) then
      if (Chg(IAt) < -1.0e-2_wp) then
        DRQ = CHg(IAt)*DrQM
        if (IAn(IAt) == 7) DrQ = Chg(IAT)*0.2_wp
      end if
      if (Chg(IAt) > 0.4_wp) then
        if (IAn(IAt) == 8) DRQ = -Chg(IAt)*0.26_wp
        if (IAn(IAt) == 15) DRQ = -Chg(IAt)*0.45_wp
        if (IAn(IAt) == 16) DRQ = -Chg(IAt)*0.55_wp
      end if
      NHI = int(DHyb(IAt))+1
      if (NHI < 4) then
        DDHyb = (Four-DHyb(IAt))*GX
        if (IAn(IAt) /= 6) DDHyb = DDHyb/Two
      end if
      DDX = GX*(DX(IAT)+DAl(IAt))
      Re(I1) = RX+DDX+DDHyb+DRQ
      ! protect for too small C atoms
      if ((IAn(IAT) == 6) .and. (Re(I1) < 1.5_wp)) Re(I1) = 1.5_wp
    end if
    NH = IHNum(IAt)+1
    JE = min(4,NTrBnd(IAt))
    if (iPrint > 5) write(IOut,100) IAt,AtSymb(IAn(IAt)),HH1(NH),HH2(NH),HY1(NHI),HY2(NHI),HY3(NHI),Chg(IAt),Alpha,Re(I1), &
                                    (AtSymb(IAn(ITrBnd(J,IAt))),BCH(ITrBtp(J,IAt)),J=1,JE)
    if (NTrBnd(IAt) > 4) then
      JE = min(8,NTrBnd(IAt))
      if (iPrint > 5) write(IOut,101) (AtSymb(IAn(ITRBnd(JJ,IAt))),BCH(ITrBtp(JJ,IAt)),JJ=5,JE)

      if (NTrBnd(IAt) > 8) then
        JE = NTrBnd(IAt)
        if (iPrint > 5) write(IOut,101) (AtSymb(IAn(ITRBnd(JJ,IAt))),BCH(ITrBtp(JJ,IAt)),JJ=9,JE)
      end if
    end if
  end if
end do
call mma_deallocate(NBond)
call mma_deallocate(IBond)
call mma_deallocate(IHNum)
call mma_deallocate(NTrBnd)
call mma_deallocate(ITrBnd)
call mma_deallocate(ITrBtp)
call mma_deallocate(DHyb)
call mma_deallocate(DAl)
call mma_deallocate(DX)
if (iPrint > 5) then
  write(IOut,'(6X,1X,78("-"))')
  write(IOut,*)
end if

return

100 format(6X,1X,I3,2X,A2,2A1,3X,3A1,2X,F5.2,3X,F4.2,2X,F5.3,3X,6(1X,A2,3X,'[',A1,']'))
101 format(6X,40X,4(1X,A2,3X,'[',A1,']'))

end subroutine UATM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FMUL2(A,B,C,NROW,NCOL,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NROW,N),B(NCOL,N),CJ(1000)
      DIMENSION C(NROW,NCOL)
#include "warnings.fh"

      If ( nRow.gt.1000 ) then
         WRITE(6,*)
      CALL XFLUSH(6)
         WRITE(6,*) ' *** Error in Subroutine FMUL2 ***'
      CALL XFLUSH(6)
         WRITE(6,*) ' row dimension exceeds local buffer size'
      CALL XFLUSH(6)
         WRITE(6,*)
      CALL XFLUSH(6)
         Call Quit(_RC_INTERNAL_ERROR_)
      End If

      DO 10 J=1,NCOL
      DO 15 I=1,NROW
      CJ(I)=0.0
15    CONTINUE
      IF(J.EQ.NCOL)GO TO 16
      J1=J+1
      DO 20 K=1,N
      FAC=B(J,K)
      IF(FAC.EQ.0.0)GO TO 20
      DO 25 I=J1,NROW
      CJ(I)=CJ(I)+FAC*A(I,K)
25    CONTINUE
20    CONTINUE
16    DO 30 I=1,NROW
      C(I,J)=CJ(I)
30    CONTINUE
10    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

subroutine RHSOD_E_NOSYM(IVEC)

use Symmetry_Info, only: Mul
use SUPERINDEX, only: MIGEJ, MIGTJ, MIREL, MIREL
use CHOVEC_IO, only: ChoVec_Read, ChoVec_Size, NVTOT_CHOSYM
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB
#else
use fake_GA, only: GA_Arrays
#endif
use caspt2_global, only: iPrGlb
use caspt2_module, only: NASH, NASUP, NIGEJ, NIGEJES, NIGTJ, NIGTJES, NISUP, NSSH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half, OneHalf
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: IA, IAEND, IAJ, IAJGEL, IAJGELEND, IAJGELSTA, IAJGTL, IAJGTLEND, IAJGTLSTA, IAL, IASTA, iCASE, IDX, IIEND, &
                     IISTA, IJ, IJABS, IJGEL, IJGELTOT, IJGTL, IJGTLTOT, IL, ILABS, IOBRA(8,8), IOFF, IOFFAJ, IOFFAL, IOFFVJ, &
                     IOFFVL, IOKET(8,8), ISYA, ISYJ, ISYJL, ISYL, ISYM, ISYV, IV, IVJ, IVL, lg_W, MW, NA, NAS, NBRABUF, NIS, NJL, &
                     NKETBUF, NV, NW
real(kind=wp) :: AJVL, ALVJ, EM, EP, SCL
real(kind=wp), allocatable :: BRABUF(:), KETBUF(:)
real(kind=wp), parameter :: SQRTA = sqrt(OneHalf), SQRTH = sqrt(Half)
real(kind=wp), external :: DDot_

if (iPrGlb >= DEBUG) write(u6,*) 'RHS on demand: case E'

!***********************************************************************
! Case E (6,7):
! EP(v,ajl)=((aj,vl)+(al,vj))/SQRT(2+2*Kron(j,l))
! EM(v,ajl)=((aj,vl)-(al,vj))*SQRT(3/2)
!***********************************************************************

! -SVC- Case E is slightly special, in that the inactive superindices are
! so large, that it is suboptimal to have a direct translation table for
! them. Instead, the code loops over symmetry blocks of A-JL and figures
! out if the indices on the processor fall within a block or not. Within
! a A-JL symmetry block, NA(ISYA) and NIGEJ(ISYJL) are known, so they can
! be determined by integer division. This could be optimized by combining
! it with loop peeling (on the todo list?).

!***********************************************************************
!SVC: read in all the cholesky vectors (need all symmetries)
!***********************************************************************
call CHOVEC_SIZE(4,NBRABUF,IOBRA)
call CHOVEC_SIZE(1,NKETBUF,IOKET)

call mma_allocate(BRABUF,NBRABUF,LABEL='BRABUF')
call mma_allocate(KETBUF,NKETBUF,LABEL='KETBUF')

call CHOVEC_READ(4,BRABUF,NBRABUF)
call CHOVEC_READ(1,KETBUF,NKETBUF)

iCASE = 6
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  ! find start and end block
  IOFF = 0
  do ISYA=1,NSYM
    ISYJL = Mul(ISYA,ISYM)
    ISYV = ISYM

    NA = NSSH(ISYA)
    NJL = NIGEJ(ISYJL)
    ! what is start/end in this block?
    IAJGELSTA = max(IISTA-IOFF,1)
    IAJGELEND = min(IIEND-IOFF,NA*NJL)

    do IAJGEL=IAJGELSTA,IAJGELEND
      IJGEL = (IAJGEL-1)/NA+1
      IA = IAJGEL-NA*(IJGEL-1)
      IJGELTOT = IJGEL+NIGEJES(ISYJL)
      IJABS = MIGEJ(1,IJGELTOT)
      ILABS = MIGEJ(2,IJGELTOT)
      IJ = MIREL(1,IJABS)
      ISYJ = MIREL(2,IJABS)
      IL = MIREL(1,ILABS)
      ISYL = MIREL(2,ILABS)
      do IV=IASTA,IAEND ! these are always all elements
        ! compute integrals (ajvl) and (alvj)
        NV = NVTOT_CHOSYM(Mul(ISYA,ISYJ))
        IAJ = IA-1+NSSH(ISYA)*(IJ-1)
        IVL = IV-1+NASH(ISYV)*(IL-1)
        IOFFAJ = 1+IOBRA(ISYA,ISYJ)+NV*IAJ
        IOFFVL = 1+IOKET(ISYV,ISYL)+NV*IVL
        AJVL = DDOT_(NV,BRABUF(IOFFAJ),1,KETBUF(IOFFVL),1)

        NV = NVTOT_CHOSYM(Mul(ISYA,ISYL))
        IAL = IA-1+NSSH(ISYA)*(IL-1)
        IVJ = IV-1+NASH(ISYV)*(IJ-1)
        IOFFAL = 1+IOBRA(ISYA,ISYL)+NV*IAL
        IOFFVJ = 1+IOKET(ISYV,ISYJ)+NV*IVJ
        ALVJ = DDOT_(NV,BRABUF(IOFFAL),1,KETBUF(IOFFVJ),1)

        ! EP(v,ajl)=((aj,vl)+(al,vj))/SQRT(2+2*Kron(j,l))
        if (ILABS == IJABS) then
          SCL = Half
        else
          SCL = SQRTH
        end if
        EP = SCL*(AJVL+ALVJ)
        ! write element EP
        IDX = IV+NAS*(IAJGEL+IOFF-IISTA)
#       ifdef _MOLCAS_MPP_
        DBL_MB(MW+IDX-1) = EP
#       else
        GA_Arrays(lg_w)%A(IDX) = EP
#       endif
      end do
    end do

    IOFF = IOFF+NA*NJL
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

iCASE = 7
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  ! find start and end block
  IOFF = 0
  do ISYA=1,NSYM
    ISYJL = Mul(ISYA,ISYM)
    ISYV = ISYM

    NA = NSSH(ISYA)
    NJL = NIGTJ(ISYJL)
    ! what is start/end in this block?
    IAJGTLSTA = max(IISTA-IOFF,1)
    IAJGTLEND = min(IIEND-IOFF,NA*NJL)

    do IAJGTL=IAJGTLSTA,IAJGTLEND
      IJGTL = (IAJGTL-1)/NA+1
      IA = IAJGTL-NA*(IJGTL-1)
      IJGTLTOT = IJGTL+NIGTJES(ISYJL)
      IJABS = MIGTJ(1,IJGTLTOT)
      ILABS = MIGTJ(2,IJGTLTOT)
      IJ = MIREL(1,IJABS)
      ISYJ = MIREL(2,IJABS)
      IL = MIREL(1,ILABS)
      ISYL = MIREL(2,ILABS)
      do IV=IASTA,IAEND ! these are always all elements
        ! compute integrals (ajvl) and (alvj)
        NV = NVTOT_CHOSYM(Mul(ISYA,ISYJ))
        IAJ = IA-1+NSSH(ISYA)*(IJ-1)
        IVL = IV-1+NASH(ISYV)*(IL-1)
        IOFFAJ = 1+IOBRA(ISYA,ISYJ)+NV*IAJ
        IOFFVL = 1+IOKET(ISYV,ISYL)+NV*IVL
        AJVL = DDOT_(NV,BRABUF(IOFFAJ),1,KETBUF(IOFFVL),1)

        NV = NVTOT_CHOSYM(Mul(ISYA,ISYL))
        IAL = IA-1+NSSH(ISYA)*(IL-1)
        IVJ = IV-1+NASH(ISYV)*(IJ-1)
        IOFFAL = 1+IOBRA(ISYA,ISYL)+NV*IAL
        IOFFVJ = 1+IOKET(ISYV,ISYJ)+NV*IVJ
        ALVJ = DDOT_(NV,BRABUF(IOFFAL),1,KETBUF(IOFFVJ),1)

        ! EM(v,ajl)=((aj,vl)-(al,vj))*SQRT(3/2)
        EM = SQRTA*(AJVL-ALVJ)
        ! write element EM
        IDX = IV+NAS*(IAJGTL+IOFF-IISTA)
#       ifdef _MOLCAS_MPP_
        DBL_MB(MW+IDX-1) = EM
#       else
        GA_Arrays(lg_w)%A(IDX) = EM
#       endif
      end do
    end do

    IOFF = IOFF+NA*NJL
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

call mma_deallocate(BRABUF)
call mma_deallocate(KETBUF)

end subroutine RHSOD_E_NOSYM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_DIACHO(DIAG,ISYM,WRK,LWRK)
!
! Purpose: update (i.e. subtract contributions from vectors on disk)
!          of symmetry block ISYM of diagonal in red. set 1.
!          This emulates the actual procedure during decomposition.

use Cholesky, only: Cho_DecAlg, iiBstR, IndRed, InfVec, nnBstR, nSys_call, NumCho, SCDIAG
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ISYM, LWRK
real(kind=wp), intent(inout) :: Diag(*), WRK(LWRK)
integer(kind=iwp) :: IAB, IABG, ILOC, IREDC, IVEC1, JAB, JRED, JVEC, KAB, KOFFV, MUSED, NCONV, NNEG, NNEGT, NSCALL, NVRD
real(kind=wp) :: DMX, XM, XMAX, XMIN
logical(kind=iwp) :: SCDIAG_SAVE
character(len=*), parameter :: SECNAM = 'CHO_DIACHO'

! Return if nothing to do.
! ------------------------

if (NNBSTR(ISYM,1) < 1) return
if (NUMCHO(ISYM) < 1) return

! Save read-call counter.
! -----------------------

NSCALL = NSYS_CALL

! Set pointer to scratch for reduced set indices.
! -----------------------------------------------

ILOC = 3

! Set up rs1 indices at location ILOC.
! Set IREDC to identify this.
! ------------------------------------

call CHO_RSCOPY(1,ILOC)
IREDC = 1

! Start read buffer batch loop.
! -----------------------------

IVEC1 = 1
do while (IVEC1 <= NUMCHO(ISYM))

  ! Read as many vectors as possible into buffer (entire WRK).
  ! ----------------------------------------------------------

  NVRD = 0
  MUSED = 0
  call CHO_VECRD(WRK,LWRK,IVEC1,NUMCHO(ISYM),ISYM,NVRD,IREDC,MUSED)
  if (NVRD < 1) call CHO_QUIT('Insufficient scratch space for read in '//SECNAM,101)

  ! Initialize vector offset.
  ! -------------------------

  KOFFV = 0

  ! Loop over vectors in core.
  ! --------------------------

  do JVEC=1,NVRD

    ! Set index arrays for current reduced set (if not already set).
    ! --------------------------------------------------------------

    JRED = INFVEC(IVEC1+JVEC-1,2,ISYM)
    if (JRED /= IREDC) then
      if (JRED == 1) then
        call CHO_RSCOPY(1,ILOC)
      else
        call CHO_GETRED(JRED,ILOC,.false.)
        call CHO_SETREDIND(ILOC)
      end if
      IREDC = JRED
    end if

    ! Compute contributions to diagonal.
    ! Zero the diagonal element associated with this vector.
    ! ------------------------------------------------------

    do JAB=1,NNBSTR(ISYM,ILOC)
      IAB = INDRED(IIBSTR(ISYM,ILOC)+JAB,ILOC) ! address in rs1
      KAB = KOFFV+JAB ! vector address
      DIAG(IAB) = DIAG(IAB)-WRK(KAB)*WRK(KAB)
    end do
    IABG = INFVEC(IVEC1+JVEC-1,1,ISYM)
    call CHO_P_ZERODIAG_RST(DIAG,ISYM,IABG)

    ! Check diagonal.
    ! ---------------

    if (CHO_DECALG == 4) then
      SCDIAG_SAVE = SCDIAG
      SCDIAG = .false. ! do NOT screen
      DMX = One
      call CHO_CHKDIA_A4(DIAG,DMX,ISYM,NNEG,NNEGT,NCONV,XMAX,XMIN,XM)
      SCDIAG = SCDIAG_SAVE
    else
      call CHO_CHKDIA(DIAG,ISYM,XMIN,XMAX,XM,NNEGT,NNEG,NCONV)
    end if

    ! Update vector offset.
    ! ---------------------

    KOFFV = KOFFV+NNBSTR(ISYM,ILOC)

  end do

  ! Check memory.
  ! -------------

  if (KOFFV /= MUSED) call CHO_QUIT('Memory error detected in '//SECNAM,101)

  ! Update vector counter.
  ! ----------------------

  IVEC1 = IVEC1+NVRD

end do

! Restore read-call counter.
! --------------------------

NSYS_CALL = NSCALL

end subroutine CHO_DIACHO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NATORB_MRCI(CMO,DMO,CNO,OCC,SCR)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CMO(NCMO),DMO(NBTRI),CNO(NCMO),OCC(NBAST)
      DIMENSION SCR( (NBMAX*(NBMAX+1))/2 )

#include "SysDef.fh"

#include "mrci.fh"
      CALL DCOPY_(NBAST,[0.0D00],0,OCC,1)
      CALL DCOPY_(NCMO,CMO,1,CNO,1)
C LOOP OVER SYMMETRY LABELS
C Present index of end of processed CMO block:
      IECMO=0
C Present end of index to MO-s, to be translated by ICH array:
      IEO=0
C Present end of index to basis functions:
      IEB=0
      DO 100 ISYM=1,NSYM
        NO=NORB(ISYM)
        NIAV=NISH(ISYM)+NASH(ISYM)+NVIR(ISYM)
        NB=NBAS(ISYM)
        If (NB.eq.0) Go To 100
        ISB=IEB+1
        IEB=IEB+NB
C ORBITALS PRE-FROZEN IN MOTRA, OR FROZEN IN MRCI:
        NF=NFMO(ISYM)+NFRO(ISYM)
        NBF=NB*NF
        ISCMO=IECMO+1
        IECMO=IECMO+NBF
C (DO NOTHING WITH THE FROZEN ORBITALS)
        IF(NF.GT.0) CALL DCOPY_(NF,[2.0D00],0,OCC(ISB),1)
        IEO=IEO+NFRO(ISYM)
C ORBITALS EXPLICITLY USED IN CI:
        NBO=NB*NIAV
        ISCMO=IECMO+1
        IECMO=IECMO+NBO
        ISO=IEO+1
        IEO=IEO+NIAV
C TRANSFER SYMMETRY BLOCK OF DMO TO TRIANGULAR SCRATCH MATRIX:
        I12=0
        DO 10 I=ISO,IEO
          IO1=ICH(I)
          DO 11 J=ISO,I
            IO2=ICH(J)
            IO12=(IO1*(IO1-1))/2+IO2
            IF(IO1.LT.IO2) IO12=(IO2*(IO2-1))/2+IO1
            I12=I12+1
            SCR(I12)=DMO(IO12)
11        CONTINUE
10      CONTINUE
C DIAGONALIZE AND TRANSFORM ORBITALS:
        CALL JACOB(SCR,CNO(ISCMO),NIAV,NB)
C PICK OCCUP NR FROM DIAGONAL:
        II=0
        DO 20 I=1,NIAV
          II=II+I
          OCC(ISB+NF-1+I)=SCR(II)
20      CONTINUE
C ORDER BY DECREASING NATURAL OCCUPANCY:
        NN=NO-NFRO(ISYM)
        DO 40 I=1,NN-1
          OMAX=OCC(ISB+NF-1+I)
          IMAX=I
          DO 30 J=I+1,NN
            OC=OCC(ISB+NF-1+J)
            IF(OMAX.GE.OC) GOTO 30
            IMAX=J
            OMAX=OC
30        CONTINUE
          IF(IMAX.EQ.I) GOTO 40
          OCC(ISB+NF-1+IMAX)=OCC(ISB+NF-1+I)
          OCC(ISB+NF-1+I)=OMAX
          ISTA1=ISCMO+NB*(I-1)
          ISTA2=ISCMO+NB*(IMAX-1)
          CALL DCOPY_(NB,CNO(ISTA1),1,SCR,1)
          CALL DCOPY_(NB,CNO(ISTA2),1,CNO(ISTA1),1)
          CALL DCOPY_(NB,SCR,1,CNO(ISTA2),1)
40      CONTINUE
C ORBITALS PRE-DELETED IN MOTRA OR DELETED IN MRCI:
        ND=NDMO(ISYM)+NDEL(ISYM)
        NBD=NB*ND
        ISCMO=IECMO+1
        IECMO=IECMO+NBD
        IEO=IEO+NDEL(ISYM)
C (DO NOTHING WITH THE DELETED ORBITALS)
100   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine projects out specified vectors from the density matrix. *
! The procedure is to read the projection orbitals and perform a       *
! sequence of rank-1 updated to zero out the contributions <c|D|c>.    *
! This procedure does not necessarily produce a complete projection    *
! of the density matrix, and routine 'proj1' is preferable.            *
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine Proj2

use Genano_globals, only: MxLqn, nPrim, iSymBk, tDsym, Ssym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: err, i, iB, iBlk, ij, iLqn, indS, indT, iO, iShell, j, jB, jk, kB, kl, lB, nB, nO, Lu
real(kind=wp) :: cnorm, eval, t
real(kind=wp), allocatable :: ProjOrb(:), TmpDens(:), TmpOvlp(:)
integer(kind=iwp), external :: IsFreeUnit

Lu = IsFreeUnit(17)
call molcas_open(Lu,'PROJ')
iBlk = 0
!--- Loop over l quantum number ---*
do iLqn=0,MxLqn
  !--- Read projection orbitals ---*
  read(Lu,*,iostat=err) nB,nO
  if (err /= 0) exit
  if (nB*nO <= 0) cycle
  if (nB /= nPrim(iLqn)) then
    write(u6,*) 'Project: inconsistency in number of functions'
    call Abend()
  end if
  call mma_allocate(ProjOrb,nB*nB,label='ProjOrb')
  call mma_allocate(TmpDens,nB*nB,label='TmpDens')
  call mma_allocate(TmpDens,nB*nB,label='TmpOvlp')
  do iB=1,nB
    read(Lu,*) (ProjOrb(iB+nB*(iO-1)),iO=1,nO)
  end do
  !write(u6,'(a,i5)') ' Projection orbitals',iLqn
  !do iB=1,nB
  !  write(u6,'(1x,6f12.6)') (ProjOrb(iB+nB*(iO-1)),iO=1,nO)
  !end do
  !--- Loop over m quantum number ---*
  do iShell=-iLqn,iLqn
    iBlk = iBlk+1
    !write(u6,'(a,2i5)') ' Density matrix block',iLqn,iShell
    !call Triprt(' ','(6f12.6)',tDsym(iSymBk(iBlk)),nPrim(iLqn))
    !write(u6,'(a,2i5)') ' Overlap matrix block',iLqn,iShell
    !call Triprt(' ','(6f12.6)',Ssym(iSymBk(iBlk)),nPrim(iLqn))
    !--- Copy S and D into square form ---*
    do i=1,nB
      do j=1,nB
        indT = min(i,j)+max(i,j)*(max(i,j)-1)/2
        indS = i+nB*(j-1)
        TmpDens(indS) = tDsym(iSymBk(iBlk)-1+indT)
        TmpOvlp(indS) = Ssym(iSymBk(iBlk)-1+indT)
        !write(u6,'(1x,4i5,2f12.6)') i,j,IndT,IndS,TmpDens(indS),TmpOvlp(indS)
      end do
    end do
    !--- Project ---*
    do iO=1,nO
      eval = Zero
      do iB=1,nB
        do jB=1,nB
          do kB=1,nB
            do lB=1,nB
              ij = iB+nB*(jB-1)
              jk = jB+nB*(kB-1)
              kl = kB+nB*(lB-1)
              t = ProjOrb(iB+nB*(iO-1))*ProjOrb(lB+nB*(iO-1))
              t = t*TmpOvlp(ij)
              t = t*TmpDens(jk)
              t = t*TmpOvlp(kl)
              eval = eval+t
            end do
          end do
        end do
      end do
      cnorm = Zero
      do iB=1,nB
        do jB=1,nB
          ij = iB+nB*(jB-1)
          t = ProjOrb(iB+nB*(iO-1))*ProjOrb(jB+nB*(iO-1))
          t = t*TmpOvlp(ij)
          cnorm = cnorm+t
        end do
      end do
      !write(u6,'(a,f12.6)') ' Eigenvalue ',eval
      !write(u6,'(a,f12.6)') ' Norm       ',cnorm
      eval = eval/cnorm/cnorm
      do iB=1,nB
        do jB=1,nB
          t = ProjOrb(iB+nB*(iO-1))*ProjOrb(jB+nB*(iO-1))
          TmpDens(iB+nB*(jB-1)) = TmpDens(iB+nB*(jB-1))-eval*t
        end do
      end do
    end do
    !--- Copy back D ---*
    do i=1,nB
      do j=1,nB
        indT = min(i,j)+max(i,j)*(max(i,j)-1)/2
        indS = i+nB*(j-1)
        tDsym(iSymBk(iBlk)-1+indT) = TmpDens(indS)
      end do
    end do
    call mma_deallocate(ProjOrb)
    call mma_deallocate(TmpDens)
    call mma_deallocate(TmpOvlp)
    !write(u6,'(a,2i5)') ' Density matrix block',iLqn,iShell
    !call Triprt(' ','(6f12.6)',tDsym(iSymBk(iBlk)),nPrim(iLqn))
  end do
end do
!--- ---*
close(Lu)

return

end subroutine Proj2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Ignacio Fdez. Galvan                             *
!***********************************************************************
!
! "False" is a wrapper program that calls an external program and reads
! its output into the runfile.
! It is named after False Island (not False Pass), Alaska.

subroutine False_Program(rc)

use False_Global, only: Run_Command, Will_Print
use Para_Info, only: King
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: rc
character(len=180) :: InFile, OutFile
integer(kind=iwp) :: n
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: Reduce_Prt

rc = 0

Will_Print = (iPrintLevel(-1) >= 2) .and. (.not. Reduce_Prt())

call Read_Input()

! only the master process calls the external program
if (King()) then
  call Write_Input()

  call PrgmTranslate('INPUT',InFile,n)
  call PrgmTranslate('OUTPUT',OutFile,n)
  if (Will_Print) then
    write(u6,100) 'Command to run:  '//trim(Run_Command)
    write(u6,100) 'First argument:  '//trim(InFile)
    write(u6,100) 'Second argument: '//trim(OutFile)
    write(u6,*)
  end if
  call CollapseOutput(1,'External program output')
  call SystemF(trim(Run_Command)//' '//trim(InFile)//' '//trim(OutFile),rc)
  call CollapseOutput(0,'External program output')
end if

#ifdef _MOLCAS_MPP_
! files of interest are broadcasted to all slaves
if (Is_Real_Par()) then
  call GA_Sync()
  call PFGet_ASCII('INPUT')
  call PFGet_ASCII('OUTPUT')
  call GA_Sync()
end if
#endif

call Write_Data()

return

100 format(a)

end subroutine False_Program

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!***********************************************************************

subroutine RSBB2A(ISCSM,ISCTP,ICCSM,ICCTP,IGRP,NROW,NGAS,ISOC,ICOC,SB,CB,NOBPTS,MAXI,MAXK,SSCR,CSCR,I1,XI1S,XINT,NSMOB,NSMST, &
                  SCLFAC,IPHGAS)
! SUBROUTINE RSBB2A --> 46
!
! two electron excitations on column strings
!
! =====
! Input
! =====
!
! ISCSM,ISCTP : Symmetry and type of sigma columns
! ICCSM,ICCTP : Symmetry and type of C     columns
! IGRP : String group of columns
! NROW : Number of rows in S and C block
! ISEL1(3) : Number of electrons in RAS1(3) for S block
! ICEL1(3) : Number of electrons in RAS1(3) for C block
! CB   : Input C block
! NTSOB  : Number of orbitals per type and symmetry
! IBTSOB : base for orbitals of given type and symmetry
! IBORB  : Orbitals of given type and symmetry
! NSMOB,NSMST : Number of symmetries of orbitals, strings
! MAXI   : Largest number of "spectator strings" treated simultaneously
! MAXK   : Largest number of inner resolution strings treated at simult.
!
! ======
! Output
! ======
!
! SB : updated sigma block
!
! =======
! Scratch
! =======
!
! SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
!              largest number of orbital pairs of given symmetries and
!              types.
! I1, XI1S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! I2, XI2S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! XINT : Space for two electron integrals
!
! Jeppe Olsen, Winter of 1991

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use Para_Info, only: MyRank, nProcs
use lucia_data, only: MXPNGAS, MXPTSOB
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ISCSM, ISCTP, ICCSM, ICCTP, IGRP, NROW, NGAS, ISOC(NGAS), ICOC(NGAS), NSMST, NOBPTS(MXPNGAS,*), &
                                 MAXI, MAXK, NSMOB, IPHGAS(NGAS)
real(kind=wp), intent(inout) :: SB(*)
real(kind=wp), intent(in) :: CB(*), SCLFAC
real(kind=wp), intent(_OUT_) :: SSCR(*), CSCR(*), XI1S(MAXK,*), XINT(*)
integer(kind=iwp), intent(_OUT_) :: I1(MAXK,*)
integer(kind=iwp) :: I, I1JL, I4_AC(4), I4_REO(4), I4_TP(4), IAC, IBOT, ICOUL, IDXSM, IDXTYP, IFIRST, IFRST, II12, IIPART, IJKL, &
                     IJL, IK, IKBOFF, IKBT(3,8), IKBTC, IKOBSM, IKOFF, IKPAIR, IKSM, IKSMBT(2,8), IOBSM, ISBOFF, ISCR(4), ISM, &
                     ISM_ORIG, ITOP, ITP(256), ITPSM_ORIG, ITYP, ITYP_ORIG, IXCHNG, J, JAC, JFRST, JL, JLBOFF, JLBT(3,8), JLBTC, &
                     JLOBSM, JLOFF, JLPAIR, JLSM, JLSMBT(2,8), JSM, JSM_ORIG, JTP(256), JTPSM_ORIG, JTYP, JTYP_ORIG, K, K12, KAC, &
                     KBOT, KEND, KFRST, KSM, KSM_ORIG, KTOP, KTP(256), KTPSM_ORIG, KTYP, KTYP_ORIG, L, LAC, LENGTH, LIKB, LSM, &
                     LSM_ORIG, LTP(256), LTPSM_ORIG, LTYP, LTYP_ORIG, MI, MJ, MK, ML, MXPAIR, NBLK, NBLKT, NDXTYP, NI, NIBTC, &
                     NIJKL1, NIK, NIKBT, NIKT, NJ, NJL, NJLBT, NJLT, NK, NKBTC, NL, NONEW, NPART, NPARTSZ
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: II, JIKBT, JJLBT
#endif
real(kind=wp) :: FACTORAB, FACTORC, FACX
real(kind=wp), allocatable :: SCR(:)

call mma_allocate(SCR,MXPTSOB**4,Label='SCR')
#ifdef _DEBUGPRINT_
write(u6,*) ' ==============='
write(u6,*) ' RSBB2A speaking'
write(u6,*) ' ==============='
write(u6,*) ' ISOC and ICOC :'
call IWRTMA(ISOC,1,NGAS,1,NGAS)
call IWRTMA(ICOC,1,NGAS,1,NGAS)
#endif
IFRST = 1
JFRST = 1
FACX = Zero

! Types of DX that connects the two strings

IDXSM = Mul(ISCSM,ICCSM)
if (IDXSM /= 0) then
  ! Connecting double excitations
  call DXTYP2_GAS(NDXTYP,ITP,JTP,KTP,LTP,NGAS,ISOC,ICOC,IPHGAS)
  do IDXTYP=1,NDXTYP
    ITYP = ITP(IDXTYP)
    JTYP = JTP(IDXTYP)
    KTYP = KTP(IDXTYP)
    LTYP = LTP(IDXTYP)
    ! Is this combination of types allowed
    !IJKL_ACT = 1
    !if (IJKL_ACT == 0) cycle

    !write(u6,*) ' test inserted in RSBB2A'
    !NPTOT = 0
    !if (ITYP == 3) NPTOT = NPTOT+1
    !if (JTYP == 3) NPTOT = NPTOT+1
    !if (KTYP == 3) NPTOT = NPTOT+1
    !if (LTYP == 3) NPTOT = NPTOT+1
    !if (NPTOT == 3) cycle
    ITYP_ORIG = ITYP
    JTYP_ORIG = JTYP
    KTYP_ORIG = KTYP
    LTYP_ORIG = LTYP

#   ifdef _DEBUGPRINT_
    write(u6,*) ' ITYP_ORIG, JTYP_ORIG, KTYP_ORIG, LTYP_ORIG',ITYP_ORIG,JTYP_ORIG,KTYP_ORIG,LTYP_ORIG
#   endif
    NIJKL1 = 0
    if (ITYP == 1) NIJKL1 = NIJKL1+1
    if (JTYP == 1) NIJKL1 = NIJKL1+1
    if (KTYP == 1) NIJKL1 = NIJKL1+1
    if (LTYP == 1) NIJKL1 = NIJKL1+1
    ! Optimal ordering of operators
    I4_AC(1) = 2
    I4_AC(2) = 2
    I4_AC(3) = 1
    I4_AC(4) = 1
    I4_TP(1) = ITYP
    I4_TP(2) = KTYP
    I4_TP(3) = LTYP
    I4_TP(4) = JTYP
    !if (IUSE_PH == 1) then
    !  NOP = 4
    !  call ALG_ROUTERX(ISOC,JSOC,NOP,I4_TP,I4_AC,I4_REO,SIGN4)
    !else
    I4_REO(:) = [1,2,3,4]
    !end if
    ! Type of operators : TP and AC
    do IJKL=1,4
      !ISCR(I4_REO(IJKL)) = I4_TP(IJKL)
      ISCR(IJKL) = I4_TP(I4_REO(IJKL))
    end do
    do IJKL=1,4
      I4_TP(IJKL) = ISCR(IJKL)
    end do
    ITYP = I4_TP(1)
    KTYP = I4_TP(2)
    LTYP = I4_TP(3)
    JTYP = I4_TP(4)
    do IJKL=1,4
      ISCR(IJKL) = I4_AC(I4_REO(IJKL))
    end do
    do IJKL=1,4
      I4_AC(IJKL) = ISCR(IJKL)
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) ' I4_AC, IT_TP  defined'
    write(u6,*) ' I4_AC, I4_TP'
    call IWRTMA(I4_AC,1,4,1,4)
    call IWRTMA(I4_TP,1,4,1,4)
#   endif

    !SVC: determine optimum number of partitions as the lowest multiple of
    !     NPROCS that satisfies a block size smaller than MAXI:
    NPART = 0
    do
      NPART = NPART+NPROCS
      NPARTSZ = max(NROW-1,0)/NPART+1
      if (NPARTSZ <= MAXI) exit
    end do

    if (I4_AC(1) == I4_AC(2)) then

      ! a+ a+ a a or a a a+ a+
      ! Largest possible number of orbital pairs
      MI = 0
      MJ = 0
      MK = 0
      ML = 0
      do IOBSM=1,NSMST
        MI = max(MI,NOBPTS(ITYP,IOBSM))
        MJ = max(MJ,NOBPTS(JTYP,IOBSM))
        MK = max(MK,NOBPTS(KTYP,IOBSM))
        ML = max(ML,NOBPTS(LTYP,IOBSM))
      end do
      MXPAIR = max(MI*MK,MJ*ML)
      ! Largest posssible
      ! Symmetry of allowed Double excitation,loop over excitations
      do IKOBSM=1,NSMOB
        JLOBSM = Mul(IKOBSM,IDXSM)
#       ifdef _DEBUGPRINT_
        write(u6,*) ' IKOBSM,JLOBSM',IKOBSM,JLOBSM
#       endif
        if (JLOBSM == 0) cycle
        ! types + symmetries defined => K strings are defined
        KFRST = 1

        ! Number of batchs of symmetry pairs IK

        LENGTH = 0
        NIKBT = 0
        NBLK = 0
        NBLKT = 0
        do ISM=1,NSMOB
          KSM = Mul(ISM,IKOBSM)
          NI = NOBPTS(ITYP,ISM)
          NK = NOBPTS(KTYP,KSM)
#         ifdef _DEBUGPRINT_
          write(u6,*) ' NI, NK',NI,NK
#         endif

          if ((ISM == KSM) .and. (ITYP == KTYP)) then
            NIK = nTri_Elem(NI)
          else if ((ITYP > KTYP) .or. ((ITYP == KTYP) .and. (ISM > KSM))) then
            NIK = NI*NK
          else
            NIK = 0
          end if
          if (NIK /= 0) then
            NBLKT = NBLKT+1
            if (LENGTH+NIK > MXPAIR) then
              ! The present batch is complete
              NIKBT = NIKBT+1
              IKBT(1,NIKBT) = NBLKT-NBLK
              IKBT(2,NIKBT) = NBLK
              IKBT(3,NIKBT) = LENGTH
              LENGTH = 0
              NBLK = 0
            end if
            NBLK = NBLK+1
            LENGTH = LENGTH+NIK
            IKSMBT(1,NBLKT) = ISM
            IKSMBT(2,NBLKT) = KSM
          end if
        end do
        ! The last batch
        if (NBLK /= 0) then
          NIKBT = NIKBT+1
          IKBT(1,NIKBT) = NBLKT-NBLK+1
          IKBT(2,NIKBT) = NBLK
          IKBT(3,NIKBT) = LENGTH
        end if

#       ifdef _DEBUGPRINT_
        write(u6,*) ' ITYP, KTYP, IKOBSM,  NIKBT = ',ITYP,KTYP,IKOBSM,NIKBT
        write(u6,*) ' IKBT : Offset, number, length'
        do JIKBT=1,NIKBT
          write(u6,'(3i3)') (IKBT(II,JIKBT),II=1,3)
        end do
        write(u6,*) ' IKSMBT'
        call IWRTMA(IKSMBT,2,NBLKT,2,8)
#       endif

        ! Number of batches of symmetry pairs JL

        LENGTH = 0
        NJLBT = 0
        NBLK = 0
        NBLKT = 0
        do JSM=1,NSMOB
          LSM = Mul(JSM,JLOBSM)
          NJ = NOBPTS(JTYP,JSM)
          NL = NOBPTS(LTYP,LSM)

          if ((JSM == LSM) .and. (JTYP == LTYP)) then
            NJL = nTri_Elem(NJ)
          else if ((JTYP > LTYP) .or. ((JTYP == LTYP) .and. (JSM > LSM))) then
            NJL = NJ*NL
          else
            NJL = 0
          end if
          if (NJL /= 0) then
            NBLKT = NBLKT+1
            if (LENGTH+NJL > MXPAIR) then
              ! The present batch is complete
              NJLBT = NJLBT+1
              JLBT(1,NJLBT) = NBLKT-NBLK
              JLBT(2,NJLBT) = NBLK
              JLBT(3,NJLBT) = LENGTH
              LENGTH = 0
              NBLK = 0
            end if
            NBLK = NBLK+1
            LENGTH = LENGTH+NJL
            JLSMBT(1,NBLKT) = JSM
            JLSMBT(2,NBLKT) = LSM
          end if
        end do
        ! The last batch
        if (NBLK /= 0) then
          NJLBT = NJLBT+1
          JLBT(1,NJLBT) = NBLKT-NBLK+1
          JLBT(2,NJLBT) = NBLK
          JLBT(3,NJLBT) = LENGTH
        end if

#       ifdef _DEBUGPRINT_
        write(u6,*) ' JTYP, LTYP, JLOBSM,  NJLBT = ',JTYP,LTYP,JLOBSM,NJLBT
        write(u6,*) ' JLBT : Offset, number, length'
        do JJLBT=1,NJLBT
          write(u6,'(3i3)') (JLBT(II,JJLBT),II=1,3)
        end do
        write(u6,*) ' JLSMBT'
        call IWRTMA(JLSMBT,2,NBLKT,2,8)
#       endif

        ! Loop over batches of IK strings
        do IKBTC=1,NIKBT
#         ifdef _DEBUGPRINT_
          write(u6,*) ' IKBTC = ',IKBTC
#         endif
          ! Loop over batches of JL strings
          do JLBTC=1,NJLBT
            IFIRST = 1
            ! Loop over batches of I strings
            do IIPART=1+MYRANK,NPART,NPROCS
              IBOT = 1+(IIPART-1)*NPARTSZ
              ITOP = min(IBOT+NPARTSZ-1,NROW)
              NIBTC = ITOP-IBOT+1
              if (NIBTC <= 0) exit
              ! Loop over batches of intermediate strings
              KBOT = 1-MAXK
              KTOP = 0
              outer: do
                KBOT = KBOT+MAXK
                KTOP = KTOP+MAXK

                JLBOFF = 1
                NJLT = JLBT(3,JLBTC)
                do JLPAIR=1,JLBT(2,JLBTC)
                  JSM = JLSMBT(1,JLBT(1,JLBTC)-1+JLPAIR)
                  LSM = JLSMBT(2,JLBT(1,JLBTC)-1+JLPAIR)
                  NJ = NOBPTS(JTYP,JSM)
                  NL = NOBPTS(LTYP,LSM)
                  if ((JSM == LSM) .and. (JTYP == LTYP)) then
                    NJL = nTri_Elem(NJ)
                    JLSM = 1
                  else
                    NJL = NJ*NL
                    JLSM = 0
                  end if

                  ! obtain cb(KB,IA,jl) = sum(JB)<KB!a lb a jb !IB>C(IA,JB)

                  ! Obtain all double excitations from this group of K strings
                  II12 = 1
                  K12 = 1
                  !write(u6,*) ' Before ADAADAST'
                  ! Creation / annihilation maps, conjugated of above
                  if (I4_AC(4) == 1) then
                    JAC = 2
                  else
                    JAC = 1
                  end if
                  if (I4_AC(3) == 1) then
                    LAC = 2
                  else
                    LAC = 1
                  end if
                  call ADAADAST_GAS(1,JSM,JTYP,NJ,JAC,1,LSM,LTYP,NL,LAC,ICCTP,ICCSM,IGRP,KBOT,KTOP,I1,XI1S,MAXK,NKBTC,KEND,JFRST, &
                                    KFRST,II12,K12,SCLFAC)

                  JFRST = 0
                  KFRST = 0

                  if  (NKBTC == 0) exit outer
                  ! Loop over jl in TS classes
                  J = 0
                  L = 1

                  do IJL=1,NJL
                    call NXTIJ(J,L,NJ,NL,JLSM,NONEW)
                    I1JL = (L-1)*NJ+J
                    ! CB(IA,KB,jl) = +/-C(IA,a+la+jIA)
                    JLOFF = (JLBOFF-1+IJL-1)*NKBTC*NIBTC+1
                    if ((JLSM == 1) .and. (J == L)) then
                      ! a+j a+j gives trivially zero
                      CSCR(JLOFF:JLOFF+NKBTC*NIBTC-1) = Zero
                    else
                      call MATCG(CB,CSCR(JLOFF),NROW,NIBTC,IBOT,NKBTC,I1(:,I1JL),XI1S(:,I1JL))
                    end if
                  end do

                  JLBOFF = JLBOFF+NJL
                end do

                ! (End of loop over jlpair in batch)
                !=============================================
                ! SSCR(I,K,ik) = CSR(I,K,jl)*((ij!kl)-(il!jk))
                !=============================================
                ! Obtain two electron integrals xint(ik,jl) = (ij!kl)-(il!kj)
                if (IFIRST == 1) then
                  IXCHNG = 1
                  ! Obtain integrals in ik batch
                  NIKT = IKBT(3,IKBTC)
                  NJLT = JLBT(3,JLBTC)
                  JLOFF = 1
                  do JLPAIR=1,JLBT(2,JLBTC)
                    IKOFF = 1
                    do IKPAIR=1,IKBT(2,IKBTC)

                      ISM = IKSMBT(1,IKBT(1,IKBTC)-1+IKPAIR)
                      KSM = IKSMBT(2,IKBT(1,IKBTC)-1+IKPAIR)
                      JSM = JLSMBT(1,JLBT(1,JLBTC)-1+JLPAIR)
                      LSM = JLSMBT(2,JLBT(1,JLBTC)-1+JLPAIR)

                      if ((ISM == KSM) .and. (ITYP == KTYP)) then
                        IKSM = 1
                        NIK = nTri_Elem(NOBPTS(ITYP,ISM))
                      else
                        IKSM = 0
                        NIK = NOBPTS(ITYP,ISM)*NOBPTS(KTYP,KSM)
                      end if

                      if ((JSM == LSM) .and. (JTYP == LTYP)) then
                        JLSM = 1
                        NJL = nTri_Elem(NOBPTS(JTYP,JSM))
                      else
                        JLSM = 0
                        NJL = NOBPTS(JTYP,JSM)*NOBPTS(LTYP,LSM)
                      end if
                      ! ===============================================================
                      ! Required form of integrals : Coulomb - Exchange of just Coulomb
                      ! ===============================================================
                      ICOUL = 0
                      ! Use coulomb - exchange
                      IXCHNG = 1
                      ! fetch integrals
                      ! Full conjugation symmetry, do do not worry
                      call GETINT(SCR,ITYP,ISM,JTYP,JSM,KTYP,KSM,LTYP,LSM,IXCHNG,IKSM,JLSM,ICOUL)
                      ! End if similarity transformed Hamiltonian is used
                      do JL=1,NJL
                        XINT(IKOFF+(JLOFF-1+JL-1)*NIKT:IKOFF+(JLOFF-1+JL-1)*NIKT+NIK-1) = SCR((JL-1)*NIK+1:JL*NIK)
                      end do
                      IKOFF = IKOFF+NIK
                    end do
                    JLOFF = JLOFF+NJL
                  end do
                end if
                ! End if integrals should be fetched
                IFIRST = 0
                ! and now, to the work
                LIKB = NIBTC*NKBTC
#               ifdef _DEBUGPRINT_
                write(u6,*) ' Integral block'
                call WRTMAT(XINT,NIKT,NJLT,NIKT,NJLT)
                write(u6,*) ' CSCR matrix'
                call WRTMAT(CSCR,LIKB,NJLT,LIKB,NJLT)
#               endif

                !!MXACIJO = MXACIJ
                !MXACIJ = MAX(MXACIJ,LIKB*NJLT,LIKB*NIKT)
                !!if (MXACIJ > MXACIJO) then
                !!  write(u6,*) ' New max MXACIJ = ', MXACIJ
                !!  write(u6,*) ' ISCTP,ICCTP', ISCTP,ICCTP
                !!  write(u6,*) ' ITYP,JTYP,KTYP,LTYP',ITYP,JTYP,KTYP,LTYP
                !!  write(u6,*) 'NIJT, NJLT, NIBTC NKBTC',NIJT,NJLT,NIBTC,NKBTC
                !!end if

                FACTORC = Zero
                FACTORAB = One
                call MATML7(SSCR,CSCR,XINT,LIKB,NIKT,LIKB,NJLT,NIKT,NJLT,FACTORC,FACTORAB,2)
#               ifdef _DEBUGPRINT_
                write(u6,*) ' SSCR matrix'
                call WRTMAT(SSCR,LIKB,NIKT,LIKB,NIKT)
#               endif
                ! ============================
                ! Loop over ik and scatter out
                ! ============================
                ! Generate double excitations from K strings
                ! I strings connected with K strings in batch <I!a+i a+k!K)
                II12 = 2

                IKBOFF = 1
                do IKPAIR=1,IKBT(2,IKBTC)
                  ISM = IKSMBT(1,IKBT(1,IKBTC)-1+IKPAIR)
                  KSM = IKSMBT(2,IKBT(1,IKBTC)-1+IKPAIR)
                  NI = NOBPTS(ITYP,ISM)
                  NK = NOBPTS(KTYP,KSM)
                  if ((ISM == KSM) .and. (ITYP == KTYP)) then
                    NIK = nTri_Elem(NI)
                    IKSM = 1
                  else
                    NIK = NI*NK
                    IKSM = 0
                  end if
                  if (IFRST == 1) KFRST = 1

                  IAC = I4_AC(1)
                  KAC = I4_AC(2)

                  call ADAADAST_GAS(1,ISM,ITYP,NI,IAC,1,KSM,KTYP,NK,KAC,ISCTP,ISCSM,IGRP,KBOT,KTOP,I1,XI1S,MAXK,NKBTC,KEND,IFRST, &
                                    KFRST,II12,K12,One)

                  IFRST = 0
                  KFRST = 0

                  I = 0
                  K = 1
                  do IK=1,NIK
                    call NXTIJ(I,K,NI,NK,IKSM,NONEW)
                    IKOFF = (K-1)*NI+I
                    ISBOFF = 1+(IKBOFF-1+IK-1)*NIBTC*NKBTC
                    if ((IKSM == 1) .and. (I == k)) then
                      ! a+ i a+i gives trivially zero
                    else
                      call MATCAS(SSCR(ISBOFF),SB,NIBTC,NROW,IBOT,NKBTC,I1(:,IKOFF),XI1S(:,IKOFF))
                    end if
                  end do
                  IKBOFF = IKBOFF+NIK

                end do
                ! End of loop over IKPAIRS in batch

                if (KEND /= 0) exit outer
              end do outer
              ! End of loop over partitionings of resolution strings
            end do
            ! End of loop over partitionings of I strings
          end do
          ! End of loop over batches of JL
        end do
        ! End of loop over batches of IK
      end do
      ! End of loop over IKOBSM

    else if (.not. (I4_AC(1) == I4_AC(2))) then

      ! Three types of operators :
      ! a+ a  a+ a
      ! a+ a  a  a+
      ! a  a+ a+ a
      !
      ! The first end up with
      ! -a+ i ak a+l aj X2(ik,jl)
      !
      ! Number two and three end up with
      ! -a i a k a l aj XC(ik,jl)  (In coulomb form)

      JLSM = 0
      IKSM = 0
      ! Symmetry of allowed Double excitation,loop over excitations
      do IKOBSM=1,NSMOB
        JLOBSM = Mul(IKOBSM,IDXSM)
        if (JLOBSM == 0) cycle
        ! types + symmetries defined => K strings are defined
        KFRST = 1
        do ISM=1,NSMOB
          KSM = Mul(ISM,IKOBSM)
          do JSM=1,NSMOB
            LSM = Mul(JSM,JLOBSM)
#           ifdef _DEBUGPRINT_
            write(u6,*) ' ISM KSM LSM JSM',ISM,KSM,LSM,JSM
#           endif
            ISCR(I4_REO(1)) = ISM
            ISCR(I4_REO(2)) = KSM
            ISCR(I4_REO(3)) = LSM
            ISCR(I4_REO(4)) = JSM

            ISM_ORIG = ISCR(1)
            KSM_ORIG = ISCR(2)
            LSM_ORIG = ISCR(3)
            JSM_ORIG = ISCR(4)

            !do ISM_ORIG=1,NSMOB
            !  KSM_ORIG = Mul(ISM_ORIG,IKOBSM)
            !  do JSM_ORIG=1,NSMOB
            !    LSM_ORIG = Mul(JSM_ORIG,JLOBSM)
            !
            !    ISCR(1) = ISM_ORIG
            !    ISCR(2) = KSM_ORIG
            !    ISCR(3) = LSM_ORIG
            !    ISCR(4) = JSM_ORIG
            !
            !    ISM = ISCR(I4_REO(1))
            !    KSM = ISCR(I4_REO(2))
            !    LSM = ISCR(I4_REO(3))
            !    JSM = ISCR(I4_REO(4))

            NI = NOBPTS(ITYP,ISM)
            NJ = NOBPTS(JTYP,JSM)
            NK = NOBPTS(KTYP,KSM)
            NL = NOBPTS(LTYP,LSM)
            NIK = NI*NK
            NJL = NJ*NL
            if ((NIK == 0) .or. (NJL == 0)) cycle

            ITPSM_ORIG = (ITYP_ORIG-1)*NSMOB+ISM_ORIG
            JTPSM_ORIG = (JTYP_ORIG-1)*NSMOB+JSM_ORIG
            KTPSM_ORIG = (KTYP_ORIG-1)*NSMOB+KSM_ORIG
            LTPSM_ORIG = (LTYP_ORIG-1)*NSMOB+LSM_ORIG

            if ((ITPSM_ORIG >= KTPSM_ORIG) .and. (JTPSM_ORIG >= LTPSM_ORIG)) then

              IFIRST = 1
              ! Loop over batches of I strings
              do IIPART=1+MYRANK,NPART,NPROCS
                IBOT = 1+(IIPART-1)*NPARTSZ
                ITOP = min(IBOT+NPARTSZ-1,NROW)
                NIBTC = ITOP-IBOT+1
                if (NIBTC <= 0) exit
                ! Loop over batches of intermediate strings
                KBOT = 1-MAXK
                KTOP = 0
                do
                  KBOT = KBOT+MAXK
                  KTOP = KTOP+MAXK

                  ! obtain cb(KB,IA,jl) = sum(JB)<KB!a lb a jb !IB>C(IA,JB)

                  ! Obtain all double excitations from this group of K strings
                  II12 = 1
                  K12 = 1
                  ! Creation / annihilation maps, conjugated of above
                  if (I4_AC(4) == 1) then
                    JAC = 2
                  else
                    JAC = 1
                  end if
                  if (I4_AC(3) == 1) then
                    LAC = 2
                  else
                    LAC = 1
                  end if
                  !KFRST = 1
                  call ADAADAST_GAS(1,JSM,JTYP,NJ,JAC,1,LSM,LTYP,NL,LAC,ICCTP,ICCSM,IGRP,KBOT,KTOP,I1,XI1S,MAXK,NKBTC,KEND,JFRST, &
                                    KFRST,II12,K12,SCLFAC)

                  JFRST = 0
                  KFRST = 0

                  if (NKBTC == 0) exit
                  ! Loop over jl in TS classes and gather
                  J = 0
                  L = 1
                  do IJL=1,NJL
                    call NXTIJ(J,L,NJ,NL,JLSM,NONEW)
                    I1JL = (L-1)*NJ+J
                    ! CB(IA,KB,jl) = +/-C(IA,a+la+jIA)
                    JLOFF = (IJL-1)*NKBTC*NIBTC+1
                    call MATCG(CB,CSCR(JLOFF),NROW,NIBTC,IBOT,NKBTC,I1(:,I1JL),XI1S(:,I1JL))
                  end do

                  !=============================================
                  ! SSCR(I,K,ik) = CSR(I,K,jl)*((ij!kl)-(il!jk))
                  !=============================================
                  ! Obtain two electron integrals as xint(ik,jl) = (ij!kl)-(il!kj)
                  IKSM = 0
                  JLSM = 0
                  if (IFIRST == 1) then
                    if (I4_AC(1) == I4_AC(3)) then
                      ! a+ a a+ a
                      ICOUL = 2
                    else
                      ! a+ a a a+ or a+ a a a+
                      ICOUL = 1
                    end if
                    ! Use coulomb - exchange or just coulomb integrals ?
                    if ((ITPSM_ORIG == KTPSM_ORIG) .and. (JTPSM_ORIG == LTPSM_ORIG)) then
                      ! No use of exchange
                      IXCHNG = 0
                    else
                      ! Exchange used, combines two terms
                      IXCHNG = 1
                    end if
                    if ((ITPSM_ORIG /= KTPSM_ORIG) .and. (JTPSM_ORIG /= LTPSM_ORIG)) then
                      ! Exchange used, combines four terms
                      FACX = -One
                    else
                      FACX = -Half
                    end if
#                   ifdef _DEBUGPRINT_
                    write(u6,*) ' ITPSM_ORIG,KTPSM_ORIG,JTPSM_ORIG,LTPSM_ORIG,FACX',ITPSM_ORIG,KTPSM_ORIG,JTPSM_ORIG,LTPSM_ORIG,FACX
#                   endif
                    ! fetch integrals
                    ! we want the operator in the form a+i ak a+l aj ((ij!lk)-(ik!lj))
                    if (ICOUL == 2) then
                      ! Obtain X2(ik,lj) = (ij!lk)
                      call GETINT(XINT,ITYP,ISM,JTYP,JSM,LTYP,LSM,KTYP,KSM,IXCHNG,IKSM,JLSM,ICOUL)
                    else if (ICOUL == 1) then
                      call GETINT(XINT,ITYP,ISM,KTYP,KSM,JTYP,JSM,LTYP,LSM,IXCHNG,IKSM,JLSM,ICOUL)
                    end if

                  end if
                  ! End if integrals should be fetched
                  IFIRST = 0
                  ! and now, to the work
                  LIKB = NIBTC*NKBTC
#                 ifdef _DEBUGPRINT_
                  write(u6,*) ' Integral block'
                  call WRTMAT(XINT,NIK,NJL,NIK,NJL)
                  write(u6,*) ' CSCR matrix'
                  call WRTMAT(CSCR,LIKB,NJL,LIKB,NJL)
#                 endif

                  !!MXACIJO = MXACIJ
                  !MXACIJ = MAX(MXACIJ,LIKB*NJL,LIKB*NIK)
                  !!if (MXACIJ > MXACIJO) then
                  !!  write(u6,*) ' New max MXACIJ = ', MXACIJ
                  !!  write(u6,*) ' ISCTP,ICCTP', ISCTP,ICCTP
                  !!  write(u6,*) ' ITYP,JTYP,KTYP,LTYP',ITYP,JTYP,KTYP,LTYP
                  !!  write(u6,*) 'NIJ NJL NIBTC NKBTC',NIJ,NJL,NIBTC,NKBTC
                  !!end if

                  FACTORC = Zero
                  FACTORAB = FACX
                  call MATML7(SSCR,CSCR,XINT,LIKB,NIK,LIKB,NJL,NIK,NJL,FACTORC,FACTORAB,2)
#                 ifdef _DEBUGPRINT_
                  write(u6,*) ' SSCR matrix'
                  call WRTMAT(SSCR,LIKB,NIK,LIKB,NIK)
#                 endif
                  ! ============================
                  ! Loop over ik and scatter out
                  ! ============================
                  ! Generate double excitations from K strings
                  ! I strings connected with K strings in batch <I!a+i a+k!K)
                  II12 = 2

                  if (IFRST == 1) KFRST = 1

                  IAC = I4_AC(1)
                  KAC = I4_AC(2)

                  !KFRST = 1
                  call ADAADAST_GAS(1,ISM,ITYP,NI,IAC,1,KSM,KTYP,NK,KAC,ISCTP,ISCSM,IGRP,KBOT,KTOP,I1,XI1S,MAXK,NKBTC,KEND,IFRST, &
                                  KFRST,II12,K12,One)

                  IFRST = 0
                  KFRST = 0

                  I = 0
                  K = 1
                  do IK=1,NIK
                    call NXTIJ(I,K,NI,NK,IKSM,NONEW)
                    IKOFF = (K-1)*NI+I
                    ISBOFF = 1+(IK-1)*NIBTC*NKBTC
                    call MATCAS(SSCR(ISBOFF),SB,NIBTC,NROW,IBOT,NKBTC,I1(:,IKOFF),XI1S(:,IKOFF))
                  end do
                  !write(u6,*) ' first element of updated SB',SB(1)

                  if (KEND /= 0) exit
                end do
                ! End of loop over partitionings of resolution strings
              end do
              ! End of loop over batches of I strings
            end if
            ! End of if I >= K, J >= L
          end do
          ! End of loop over KSM
        end do
        ! End of loop over ISM
      end do
    end if
    ! End of a+ a+ a a/a a a+ a+ versus a+ a a+ a switch

  end do

end if

call mma_deallocate(SCR)

end subroutine RSBB2A

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1994, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine vCff2D(nabMax,ncdMax,nRys,Zeta,ZInv,Eta,EInv,nT,Coori,CoorAC,P,Q,la,lb,lc,ld,U2,PAQP,QCPQ,B10,B00,lac,B01)
!***********************************************************************
!                                                                      *
! Object: to compute the coefficients in the three terms recurrence    *
!         relation of the 2D-integrals.                                *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Modified loop structure for RISC 1991                    *
!             Modified for decreased memory access January '94.        *
!***********************************************************************

use Constants, only: One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nabMax, ncdMax, nRys, nT, la, lb, lc, ld, lac
real(kind=wp), intent(in) :: Zeta(nT), ZInv(nT), Eta(nT), EInv(nT), Coori(3,4), CoorAC(3,2), P(nT,3), Q(nT,3), U2(nRys,nT)
real(kind=wp), intent(inout) :: PAQP(nRys,nT,3), QCPQ(nRys,nT,3), B10(nRys,nT), B00(nRys,nT), B01(nRys,nT)
integer(kind=iwp) :: iCar, iT, nabMax_, ncdMax_
logical(kind=iwp) :: AeqB, CeqD
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: PrintB00, PrintB01, PrintB10
#endif
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(nabMax)
unused_var(ncdMax)
unused_var(lac)

#ifdef _DEBUGPRINT_
call RecPrt(' In vCff2D: Coori',' ',Coori,3,4)
call RecPrt(' In vCff2D: U2',' ',U2,nRys,nT)
call RecPrt(' in vCff2d: Zeta',' ',Zeta,1,nT)
call RecPrt(' in vCff2d: Eta ',' ',Eta,1,nT)
call RecPrt(' in vCff2d: ZInv',' ',ZInv,1,nT)
call RecPrt(' in vCff2d: EInv',' ',EInv,1,nT)
#endif
AeqB = EQ(Coori(1,1),Coori(1,2))
CeqD = EQ(Coori(1,3),Coori(1,4))
#ifdef _DEBUGPRINT_
PrintB10 = .false.
PrintB01 = .false.
PrintB00 = .false.
#endif

nabMax_ = la+lb
ncdMax_ = lc+ld
if ((nabMax_ >= 2) .and. (ncdMax_ >= 2)) then
  B00(:,:) = Half*U2
  do iT=1,nT
    B10(:,iT) = Half*(One-U2(:,iT)*Eta(iT))*ZInv(iT)
    B01(:,iT) = Half*(One-U2(:,iT)*Zeta(iT))*EInv(iT)
  end do
# ifdef _DEBUGPRINT_
  PrintB10 = .true.
  PrintB01 = .true.
  PrintB00 = .true.
# endif
else if ((ncdMax_ == 0) .and. (nabMax_ >= 2)) then
  do iT=1,nT
    B10(:,iT) = Half*(One-U2(:,iT)*Eta(iT))*ZInv(iT)
  end do
# ifdef _DEBUGPRINT_
  PrintB10 = .true.
# endif
else if ((nabMax_ == 0) .and. (ncdMax_ >= 2)) then
  do iT=1,nT
    B01(:,iT) = Half*(One-U2(:,iT)*Zeta(iT))*EInv(iT)
  end do
# ifdef _DEBUGPRINT_
  PrintB01 = .true.
# endif
else if ((ncdMax_ == 1) .and. (nabMax_ >= 2)) then
  B00(:,:) = Half*U2
  do iT=1,nT
    B10(:,iT) = Half*(One-U2(:,iT)*Eta(iT))*ZInv(iT)
  end do
# ifdef _DEBUGPRINT_
  PrintB10 = .true.
  PrintB00 = .true.
# endif
else if ((nabMax_ == 1) .and. (ncdMax_ >= 2)) then
  B00(:,:) = Half*U2
  do iT=1,nT
    B01(:,iT) = Half*(One-U2(:,iT)*Zeta(iT))*EInv(iT)
  end do
# ifdef _DEBUGPRINT_
  PrintB01 = .true.
  PrintB00 = .true.
# endif
else if ((nabMax_ == 1) .and. (ncdMax_ == 1)) then
  B00(:,:) = Half*U2
# ifdef _DEBUGPRINT_
  PrintB00 = .true.
# endif
end if

if ((nabMax_ /= 0) .and. (ncdMax_ /= 0)) then
  if ((.not. AeqB) .and. (.not. CeqD)) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = P(iT,iCar)-CoorAC(iCar,1)+Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
        QCPQ(:,iT,iCar) = Q(iT,iCar)-CoorAC(iCar,2)-Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  else if (AeqB .and. (.not. CeqD)) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
        QCPQ(:,iT,iCar) = Q(iT,iCar)-CoorAC(iCar,2)-Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  else if ((.not. AeqB) .and. CeqD) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = P(iT,iCar)-CoorAC(iCar,1)+Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
        QCPQ(:,iT,iCar) = -Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  else
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
        QCPQ(:,iT,iCar) = -Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  end if
else if (nabMax_ /= 0) then
  if (.not. AeqB) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = P(iT,iCar)-CoorAC(iCar,1)+Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  else
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  end if
else if (ncdMax_ /= 0) then
  if (.not. CeqD) then
    do iCar=1,3
      do iT=1,nT
        QCPQ(:,iT,iCar) = Q(iT,iCar)-CoorAC(iCar,2)-Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  else
    do iCar=1,3
      do iT=1,nT
        QCPQ(:,iT,iCar) = -Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  end if
end if
#ifdef _DEBUGPRINT_
if (la+lb > 0) then
  !call RecPrt(' PAQP(x)',' ',PAQP(:,:,1),nRys,nT)
  !call RecPrt(' PAQP(y)',' ',PAQP(:,:,2),nRys,nT)
  !call RecPrt(' PAQP(z)',' ',PAQP(:,:,3),nRys,nT)
end if
if (lc+ld > 0) then
  !call RecPrt(' QCPQ(x)',' ',QCPQ(:,:,1),nRys,nT)
  !call RecPrt(' QCPQ(y)',' ',QCPQ(:,:,2),nRys,nT)
  !call RecPrt(' QCPQ(z)',' ',QCPQ(:,:,3),nRys,nT)
end if
if (PrintB10) call RecPrt(' B10',' ',B10(:,:),nRys,nT)
if (PrintB00) call RecPrt(' B00',' ',B00(:,:),nRys,nT)
if (PrintB01) call RecPrt(' B01',' ',B01(:,:),nRys,nT)
#endif

return

end subroutine vCff2D

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Fluctuating(AInv,nAtoms,Lambda,dQ,nij,nPert,
     &                       iANr,rMP,nElem,EC,Alpha)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "constants.fh"
      Real*8 AInv(nAtoms,nAtoms), Lambda(nAtoms), dQ(nAtoms), EC(3,nij),
     &       A(3), B(3), rMP(nij,0:nElem-1,0:nPert-1)
      Integer iANr(nAtoms)
*
      Do iPert = 1, 6
         Do iAtom = 1, nAtoms
            ii=iAtom*(iAtom+1)/2
            dQ(iAtom)=rMP(ii,0,0)-rMP(ii,0,iPert)
         End Do
c         Call RecPrt('dQ',' ',dQ,1,nAtoms)
         Call DGEMM_('N','N',
     &               nAtoms,1,nAtoms,
     &               1.0d0,AInv,nAtoms,
     &               dQ,nAtoms,
     &               0.0d0,Lambda,nAtoms)
c         Call RecPrt('Lambda',' ',Lambda,1,nAtoms)
*
         Do iAtom = 1, nAtoms
            R_BS_i=Bragg_Slater(iANr(iAtom))
            ii = iAtom*(iAtom+1)/2
            call dcopy_(3,EC(1,ii),1,A,1)
*
            Do jAtom = 1, iAtom-1
               R_BS_j=Bragg_Slater(iANr(jAtom))
               jj = jAtom*(jAtom+1)/2
               call dcopy_(3,EC(1,jj),1,B,1)
               rij2=(A(1)-B(1))**2 +(A(2)-B(2))**2 +(A(3)-B(3))**2
               ri=Lambda(iAtom)
               rj=Lambda(jAtom)
               rij02=((R_BS_i+R_BS_j))**2
               ij=iAtom*(iAtom-1)/2+jAtom
C              Write (6,*) ij,ri,rj,rij02
               rMP(ij,0,iPert)=-(ri-rj)*Exp(-Alpha*(rij2/rij02))/Two
C               Write (*,*) 'RMP',iAtom,jAtom,rMP(ij,0,iPert)
            End Do
*
         End Do
*
      End Do
c      Call RecPrt('rMP',' ',rMP,nij,nElem*nPert)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine RInt_ns(rkappa,rmo,Fock,Focki,idsym,reco,jspin)
!                              ~
!     Constructs  F  = <0|[E  ,H]|0>
! added in rinttd ( + <0|[[E  , Kappa],H]|0> )
!                  pq       pq                 pq
!
! Some modifications (subroutines that ends with _ns) to handle
! non anti-symmetric orbital rotations.
! Instead of using Q-Q^t as the "Q" contribution to the gradient
! Q^A-Q^{Bt} is used (see the paper). Major modifications in read2.
! Instead of constructing one set of MO integrals/particle we construct
! one set of integrals used for constructing Q^A and one for Q^B
!
! Fock is E*d/dx(lambda)
! rkappa is d/dx(lambda)

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use MCLR_Data, only: G1t, G2sq, ipMat, ipMatBA, nA, nDens, nMBA
use input_mclr, only: iMethod, nAsh, nBas, nIsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: rkappa(nDens), reco
real(kind=wp), intent(_OUT_) :: rMO(*)
real(kind=wp), intent(out) :: Fock(nDens), FockI(nDens)
integer(kind=iwp), intent(in) :: iDSym, jSpin
integer(kind=iwp) :: iAsh, ipF, ipFI, iS, jAsh, jS
real(kind=wp) :: Dij, Fact
real(kind=wp), allocatable :: FA(:), MT1(:), MT2(:), QA(:), QB(:)

call mma_allocate(FA,nDens,Label='FA')
! Fact controls the sign of H(k)
Fact = One
call mma_allocate(MT1,nmba,Label='MT1')
call mma_allocate(MT2,nmba,Label='MT2')
MT1(:) = Zero
MT2(:) = Zero

call R2ElInt_ns(rkappa,MT1,MT2,focki,FA,idSym,ReCo,Fact,jspin)

!if (idsym == 2) then
!  jpCMO = 1
!  do iSym=1,nSym
!    write(u6,'(A,i2.2)') 'Inactive fackmatrix = ',iSym
!    call RecPrt(' ',' ',focki(jpCMO),nBas(iSym),nBas(iSym))
!    jpCMO = jpCMO+nBas(iSym)*nBas(iSym)
!  end do
!  jpCMO = 1
!  do iSym=1,nSym
!    write(u6,'(A,i2.2)') 'Active fockmatrix     = ',iSym
!    call RecPrt(' ',' ',FA(jpCMO),nBas(iSym),nBas(iSym))
!    jpCMO = jpCMO+nBas(iSym)*nBas(iSym)
!  end do
!end if

Fock(:) = Zero

! Q  = sum(jkl)=(pj|kl)d(ijkl)
!  pi

if (iMethod == 2) then
  call mma_allocate(qA,nDens,Label='QA')
  call mma_allocate(qB,nDens,Label='QB')
  call CreQ_td(QB,MT1,G2sq,idsym)
  call CreQ_td(QA,MT2,G2sq,idsym)
end if

!call RECPRT('QB',' ',QB,nDens,1)
!call RECPRT('QA',' ',QA,nDens,1)

do iS=1,nSym
  jS = Mul(iS,idsym)

  !         I    A
  ! F  = 2 ( F  + F  )
  !  pi       pi   pi

  ! IFG This looks like a no-op. Should the second call be 'T'?
  call DGEACC(Two,Focki(ipMat(is,js)),nBas(is),'N',Fock(ipMat(is,js)),nBas(is),nBas(is),nIsh(js))
  call DGEACC(-Two,Focki(ipMat(is,js)),nBas(is),'N',Fock(ipMat(is,js)),nBas(is),nIsh(is),nBas(js))
  if (iMethod == 2) then

    ! 61-121 is all to do with multiconf

    ! IFG This looks like a no-op. Should the second call be 'T'?
    call DGEACC(Two,FA(ipMat(is,js)),nBas(is),'N',Fock(ipMat(is,js)),nBas(is),nBas(is),nIsh(js))
    call DGEACC(-Two,FA(ipMat(is,js)),nBas(is),'N',Fock(ipMat(is,js)),nBas(is),nIsh(is),nBas(js))

    do iAsh=1,nAsh(jS)
      do jAsh=1,nAsh(js)

        !         I
        ! F  = F - F  D
        !  ap   ap  ap ba

        Dij = G1t(iTri(iash+nA(js),jAsh+nA(js)))
        ipF = ipMat(is,js)+(Nish(js)+iAsh-1)*nBas(is)
        ipFI = ipMat(is,js)+(Nish(js)+jAsh-1)*nBas(is)

        !         I
        ! F  = F + F  D
        !  pa   pa  pb ab

        Fock(ipF:ipF+nBas(is)-1) = Fock(ipF:ipF+nBas(is)-1)+Dij*FockI(ipFI:ipFI+nBas(is)-1)
      end do
    end do
    do iAsh=1,nAsh(iS)
      do jAsh=1,nAsh(is)
        ipF = ipMat(is,js)+nIsh(is)+jAsh-1
        ipFI = ipMat(is,js)+nIsh(is)+iAsh-1
        Dij = G1t(iTri(iash+nA(is),jAsh+nA(is)))

        !         I
        ! F  = F - F  D
        !  pa   pa  pb ab

        Fock(ipF:ipF+nBas(js)*nBas(is)-1:nBas(is)) = Fock(ipF:ipF+nBas(js)*nBas(is)-1:nBas(is))- &
                                                     Dij*FockI(ipFI:ipFI+nBas(js)*nBas(is)-1:nBas(is))
      end do
    end do

    call DGEACC(One,QB(ipMatba(is,js)),nBas(is),'N',Fock(ipMat(is,js)+nbas(is)*nish(js)),nBas(is),nBas(is),nAsh(js))
    call DGESUB(Fock(ipMat(is,js)+nish(is)),nBas(is),'N',QA(ipMatba(js,is)),nBas(js),'T',Fock(ipMat(is,js)+nish(is)),nBas(is), &
                nash(is),nBas(js))
  end if
  ! Transpose ipsc2
  !call mma_allocate(T,nbas(iS)*nbas(jS),Label='T')
  !T(:) = Zero
  !call DGETMO(Fock(ipmat(is,js)),nbas(is),nbas(is),nbas(js),T,nbas(js))
  !Fock(ipmat(js,is):ipmat(js,is)+nBas(jS)*nBas(iS)-1) = T(:)
  !call mma_deallocate(T)

end do
if (imethod == 2) then
  call mma_deallocate(QA)
  call mma_deallocate(QB)
end if

Fock(:) = -Two*Fock(:)
call AddGrad(rKappa,Fock,idsym,-Two*fact)
call PickMO_td(MT1,rmo,idsym)

call mma_deallocate(MT2)
call mma_deallocate(MT1)
call mma_deallocate(FA)

end subroutine RInt_ns

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_PUTRED1(INFRED,NNBSTRSH,INDRED,INDRSH,ISP2F,
     &                       MRED,MSYM,MMSHL,LMMBSTRT,IPASS,ILOC)
C
C     Purpose: write index arrays for current reduced set (reduced set
C              IPASS).
C
#include "implicit.fh"
      INTEGER INFRED(MRED)
      INTEGER NNBSTRSH(MSYM,MMSHL), INDRED(LMMBSTRT), INDRSH(LMMBSTRT)
      INTEGER ISP2F(MMSHL)
#include "cholesky.fh"

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_PUTRED1')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

C     Test dimensions.
C     ----------------

      IF (ILOC.LT.1 .OR. ILOC.GT.3) THEN
         CALL CHO_QUIT('ILOC error in '//SECNAM,104)
      END IF

      IF (MSYM .NE. NSYM) THEN
         CALL CHO_QUIT('NSYM error in '//SECNAM,104)
      END IF

      IF (MMSHL .NE. NNSHL) THEN
         CALL CHO_QUIT('NNSHL error in '//SECNAM,104)
      END IF

      IF (LMMBSTRT .NE. NNBSTRT(1)) THEN
         CALL CHO_QUIT('NNBSTRT(1) error in '//SECNAM,104)
      END IF

      IF (LMMBSTRT .LT. NNBSTRT(ILOC)) THEN
         CALL CHO_QUIT('NNBSTRT(ILOC) error in '//SECNAM,104)
      END IF

      IF ((IPASS.LT.1) .OR. (IPASS.GT.MAXRED)) THEN
         CALL CHO_QUIT('IPASS error in '//SECNAM,104)
      END IF

C     Get first address.
C     ------------------

      IADR1 = INFRED(IPASS)
      IF (IADR1 .LT. 0) THEN
         WRITE(LUPRI,*) SECNAM,': negative address for reduced set ',
     &                  IPASS,': ',IADR1
         CALL CHO_QUIT('Error in '//SECNAM,104)
      END IF

      IF (LOCDBG) THEN
         WRITE(LUPRI,*) SECNAM,': putting reduced set ',IPASS,
     &                  ' at addr: ',IADR1
      END IF

C     Write index arrays.
C     -------------------

      IOPT = 1
      IADR = IADR1
      LTOT = NSYM*NNSHL
      CALL IDAFILE(LURED,IOPT,NNBSTRSH(1,1),LTOT,IADR)
      IOPT = 1
      IADR = IADR1 + NSYM*NNSHL
      LTOT = NNBSTRT(ILOC)
      CALL IDAFILE(LURED,IOPT,INDRED,LTOT,IADR)
      IF (IPASS .EQ. 1) THEN
         IOPT = 1
         IADR = IADR1 + NSYM*NNSHL + NNBSTRT(1)
         LTOT = NNBSTRT(1)
         CALL IDAFILE(LURED,IOPT,INDRSH,LTOT,IADR)
         IOPT = 1
         IADR = IADR1 + NSYM*NNSHL + 2*NNBSTRT(1)
         LTOT = NNSHL
         CALL IDAFILE(LURED,IOPT,ISP2F,LTOT,IADR)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Roland Lindh                                           *
!***********************************************************************

subroutine Get_Coord_All_(Coord_Unique,nUnique_Atoms,Coord_All,nAll_Atoms)

use Symmetry_Info, only: iOper, nIrrep, Symmetry_Info_Get
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nUnique_Atoms, nAll_Atoms
real(kind=wp), intent(in) :: Coord_Unique(3,nUnique_Atoms)
real(kind=wp), intent(out) :: Coord_All(3,nAll_Atoms)
integer(kind=iwp) :: Active = 0, iAll_Atom, iChAtom, iCo, iCoSet(0:7,0:7), iGen(3), iStab(0:7), iUnique_Atom, MaxDCR, nCoSet, &
                     nGen, nStab
integer(kind=iwp), external :: iChxyz

!write(u6,*) 'Enter Get_Coord_All_'
!                                                                      *
!***********************************************************************
!                                                                      *
if (Active == 0) then
  call Symmetry_Info_Get()
  Active = 1
end if
!write(u6,*) 'Get_Coord_All_: nIrrep=',nIrrep
!write(u6,*) 'Get_Coord_All_: iOper=',(iOper(i),i=0,nIrrep-1)
!                                                                      *
!***********************************************************************
!                                                                      *
nGen = 0
if (nIrrep == 2) nGen = 1
if (nIrrep == 4) nGen = 2
if (nIrrep == 8) nGen = 3
if (nGen >= 1) iGen(1) = iOper(1)
if (nGen >= 2) iGen(2) = iOper(2)
if (nGen == 3) iGen(3) = iOper(4)
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of all coordinates, index arrays, etc.

iAll_Atom = 0
MaxDCR = 0
do iUnique_Atom=1,nUnique_Atoms
  !write(u6,*) 'iUnique_Atom=',iUnique_Atom

  iChAtom = iChxyz(Coord_Unique(:,iUnique_Atom),iGen,nGen)
  !write(u6,*) 'iChAtom=',iChAtom
  call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
  nCoSet = nIrrep/nStab
  !write(u6,*) 'In Get_Coord_All'
  !write(u6,*) 'nCoset=',nCoset
  !write(u6,*) 'iCoset=',(iCoset(i,0),i=0,nCoset-1)

  do iCo=0,nCoSet-1
    !write(u6,*) 'In Get_Coord_All'
    !write(u6,*) 'iCo,iCoSet(iCo,0)=',iCo,iCoSet(iCo,0)
    iAll_Atom = iAll_Atom+1
    call OA(iCoSet(iCo,0),Coord_Unique(:,iUnique_Atom),Coord_All(:,iAll_Atom))
  end do

end do

!call RecPrt('Coord_Unique',' ',Coord_Unique,3,nUnique_Atoms)
!call RecPrt('Coord_All',' ',Coord_All,3,nAll_Atoms)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Get_Coord_All_

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_ANADIA(DIAG,BIN1,STEP,NUMBIN,FULL)
C
C     Purpose: analyze diagonal (histogram).
C
#include "implicit.fh"
      DIMENSION DIAG(*)
      LOGICAL   FULL
#include "cholesky.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_ANADIA')

      PARAMETER (MAXBIN = 50, NUMSTA = 7)
      DIMENSION BIN(MAXBIN), STAT(NUMSTA)

      LOGICAL FOUND

C     Print header.
C     -------------

      CALL CHO_HEAD('Histogram of Diagonal Elements','=',80,LUPRI)

C     Set up size bins for analysis of diagonal.
C     ------------------------------------------

      IF (NUMBIN .LT. 1) THEN
         MBIN = MIN(10,MAXBIN)
         BINLOC = 1.0D2
         STPLOC = 1.0D-2
      ELSE
         MBIN = MIN(NUMBIN,MAXBIN)
         BINLOC = BIN1
         STPLOC = STEP
      END IF

      BIN(1) = BINLOC
      DO IBIN = 2,MBIN
         BIN(IBIN) = BIN(IBIN-1)*STPLOC
      END DO

C     Set smallest BIN according to full.
C     -----------------------------------

      IF (FULL) THEN
         NBIN = MBIN
      ELSE
         NBIN  = MBIN
         IBIN  = MBIN
         FOUND = .FALSE.
         DO WHILE ((IBIN.GT.1) .AND. (.NOT.FOUND))
            IBIN = IBIN - 1
            IF (THRCOM .GE. BIN(IBIN)) THEN
               NBIN = IBIN + 1
            ELSE
               FOUND = .TRUE.
            END IF
         END DO
      END IF

C     Histogram.
C     ----------

      CALL CHO_ANASIZE(DIAG,NNBSTRT(1),BIN,NBIN,LUPRI)

C     Count converged.
C     ----------------

      NCONV = 0
      DO IAB = 1,NNBSTRT(1)
         IF (DIAG(IAB) .LE. THRCOM) NCONV = NCONV + 1
      END DO
      WRITE(LUPRI,'(/,1X,A,I10,/,1X,A,I10)')
     & 'Converged  : ',NCONV,'Unconverged: ',NNBSTRT(1)-NCONV

C     Print total number of negative zeroed diagonal as well as the most
C     negative one.
C     ------------------------------------------------------------------

      WRITE(LUPRI,'(/,1X,A,5X,I10)')
     & 'Total number of zeroed negative diagonals: ',NNZTOT
      IF (NNZTOT .GT. 0) THEN
         IF (IABMNZ .LT. 1) THEN
            WRITE(LUPRI,'(1X,A)')
     &     'WARNING: most negative zeroed diagonal has not been stored!'
         ELSE
            WRITE(LUPRI,'(1X,A,1P,D15.6)')
     &      '- most negative zeroed diagonal          : ',DIAMNZ
         END IF
      END IF

C     Print statistics.
C     -----------------

      CALL STATISTICS(DIAG,NNBSTRT(1),STAT,1,2,3,4,5,6,7)
      WRITE(LUPRI,'(/,1X,A,1P,D15.6)')
     & 'Minimum diagonal: ',STAT(3)
      WRITE(LUPRI,'(1X,A,1P,D15.6)')
     & 'Maximum diagonal: ',STAT(4)
      WRITE(LUPRI,'(1X,A,1P,D15.6)')
     & 'Mean value      : ',STAT(1)
      WRITE(LUPRI,'(1X,A,1P,D15.6)')
     & 'Mean abs. value : ',STAT(2)
      WRITE(LUPRI,'(1X,A,1P,D15.6)')
     & 'Biased variance : ',STAT(6)
      WRITE(LUPRI,'(1X,A,1P,D15.6,A)')
     & 'Standard dev.   : ',STAT(7),' (unbiased variance)'

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine EPSPRIM(JSY,INDX,C,S,EPP)

use cpf_global, only: IPRINT, IRC, LSYM, NNS, NVIR
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: JSY(*), INDX(*)
real(kind=wp), intent(in) :: C(*), S(*)
real(kind=wp), intent(inout) :: EPP(*)
integer(kind=iwp) :: I, IIN, INUM, IP, IST, NS1, NSIL
real(kind=wp) :: T
integer(kind=iwp), external :: JSUNP
real(kind=r8), external :: DDOT_

! VALENCE

IP = IRC(1)
do I=1,IP
  EPP(I) = EPP(I)+C(I)*S(I)
end do

! SINGLES

IP = IRC(2)-IRC(1)
IIN = IRC(1)
do I=1,IP
  NS1 = JSUNP(JSY,IIN+I)
  NSIL = MUL(NS1,LSYM)
  INUM = NVIR(NSIL)
  IST = INDX(IIN+I)+1
  T = DDOT_(INUM,C(IST),1,S(IST),1)
  EPP(IIN+I) = EPP(IIN+I)+T
end do

! DOUBLES

IP = IRC(4)-IRC(2)
IIN = IRC(2)
do I=1,IP
  NS1 = JSUNP(JSY,IIN+I)
  NSIL = MUL(NS1,LSYM)
  INUM = NNS(NSIL)
  IST = INDX(IIN+I)+1
  T = DDOT_(INUM,C(IST),1,S(IST),1)
  EPP(IIN+I) = EPP(IIN+I)+T
end do

IP = IRC(4)
if (IPRINT > 5) write(u6,998) (EPP(I),I=1,IP)

return

998 format(6X,'EPP ',5F10.6)

end subroutine EPSPRIM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Ben Swerts                                             *
*               2016, Liviu Ungur                                      *
************************************************************************
      Subroutine FragpCont(F1,mi,mK,ma,mC,F2,mL,mj,mD,mb,W,Final,Factor)
************************************************************************
*                                                                      *
* Object: Specialized contraction of 3 4D matrices.                    *
*         It is very inefficient and should be rewritten using BLAS    *
*                                                                      *
* Called from: FragPInt and FragPGrd                                   *
*                                                                      *
*     Author: Ben Swerts                                               *
*   Modified: Liviu Ungur                                              *
************************************************************************
      Implicit None
      Integer mi,mK,ma,mC
      Integer mL,mj,mD,mb
      Real*8     F1( mi, mK, ma, mC )
      Real*8     F2( mL, mj, mD, mb )
      Real*8      W( mK, mC, mL, mD )
      Real*8  Final( mi, mj, ma, mb )
      Real*8  Factor
c local variables
      Integer ib,ia,ij,ii,iC,iK,iD,iL
      Real*8  xt
      Logical DBG
cc
      Integer j1,j2,j12
      Real*8 xt2, WW1(mK*mC*mL*mD),F12(mK*mC*mL*mD)
      Real*8 ddot_, dnrm2_
      External ddot_, dnrm2_

cc
      DBG=.false.
cc
      if(DBG) write(6,'(A)') 'Enter FragpCont'
      if(DBG) write(6,'(A,i5)') 'FragpCont:  mi=',mi
      if(DBG) write(6,'(A,i5)') 'FragpCont:  mK=',mK
      if(DBG) write(6,'(A,i5)') 'FragpCont:  ma=',ma
      if(DBG) write(6,'(A,i5)') 'FragpCont:  mC=',mC
      if(DBG) write(6,'(A,i5)') 'FragpCont:  mL=',mL
      if(DBG) write(6,'(A,i5)') 'FragpCont:  mj=',mj
      if(DBG) write(6,'(A,i5)') 'FragpCont:  mD=',mD
      if(DBG) write(6,'(A,i5)') 'FragpCont:  mb=',mb
      if(DBG) write(6,'(A,F20.14)') 'FragpCont:  Factor=',Factor
c
      if(DBG) write(6,'(A,i5)') 'FragpCont: F1(mi,mK,ma,mC):'
      if(DBG)  then
      do ii=1,mi
        do iK=1,mK
          do ia=1,ma
            do iC=1,mC
            write(6,'(4(a,i3),a,e22.14)')
     & 'FragpCont: F1(',ii,',',iK,',',ia,',',iC,')=',F1(ii,iK,ia,iC)
            enddo
          enddo
        enddo
      enddo
c
      write(6,'(A,i5)') 'FragpCont: F2(mL,mj,mD,mb):'
      do iL=1,mL
        do ij=1,mj
          do iD=1,mD
            do ib=1,mb
            write(6,'(4(a,i3),a,e22.14)')
     & 'FragpCont: F2(',iL,',',ij,',',iD,',',ib,')=',F2(iL,ij,iD,ib)
            enddo
          enddo
        enddo
      enddo
c
      write(6,'(A,i5)') 'FragpCont: W(mK,mC,mL,mD):'
      do iK=1,mK
        do iC=1,mC
          do iL=1,mL
            do iD=1,mD
            write(6,'(4(a,i3),a,e22.14)')
     & 'FragpCont:  W(',iK,',',iC,',',iL,',',iD,')=',W(iK,iC,iL,iD)
            enddo
          enddo
        enddo
      enddo
      endif !DBG

c      print *, 'norm of FINAL in fragpcont',
c     &          dnrm2_(mi*mj*ma*mb, Final(1:mi,1:mj,1:ma,1:mb), 1 )
      ! T = F1*W
c              Call DGEMM_('T','N',
c     &                    iBas*nElem(la)*nAlpha,iSize,nElem(iAng),
c     &                    1.0d0,Array(ipTmp),nElem(iAng),
c     &                    RSph(ipSph(iAng)),nElem(iAng),
c     &                    0.0d0,Array(ipF1),nAlpha*iBas*nElem(la))
      ! Final=T*F2
c              Call DGEMM_('T','N',
c     &                    iBas*nElem(la)*nAlpha,iSize,nElem(iAng),
c     &                    1.0d0,Array(ipTmp),nElem(iAng),
c     &                    RSph(ipSph(iAng)),nElem(iAng),
c     &                    0.0d0,Array(ipF1),nAlpha*iBas*nElem(la))
c      print *,'factor=', factor
      do ib = 1, mb
        do ia = 1, ma
          do ij = 1, mj
            do ii = 1, mi
            xt = 0.d0
            xt2= 0.d0
            WW1= 0.d0
            F12= 0.d0


              j1=0
              j12=0
              do iC = 1, mC
                do iK = 1, mK
                j1=j1+1

                  j2=0
                  do iD = 1, mD
                    do iL = 1, mL
                   j2=j2+1
                   j12=j12+1

                 WW1(j12)=W(iK,iC,iL,iD)
                 F12(j12)=F1(ii,iK,ia,iC)*F2(iL,ij,iD,ib)

            xt = xt + F1(ii,iK,ia,iC) * W(iK,iC,iL,iD) * F2(iL,ij,iD,ib)
                    enddo
                  enddo
                enddo
              enddo

              xt2=xt2+ddot_(mC*mK*mD*mL, F12, 1, WW1, 1)

c              print *, 'factor, xt, xt2, diff,:',factor,xt,xt2,xt-xt2

c              TMP
c            call dgemm_('N',  m, n,
c     &                 1.d0, F1(ii,:,ia,:), lda,
c     &                       W(:,:,iL,iD), incx,
c     &                  beta, TMP, incy )
c
c            call daxpy_(n, a, x, incx, y, incy)


            Final(ii,ij,ia,ib) = Final(ii,ij,ia,ib) + Factor * xt

            enddo !ii
          enddo !ij
        enddo !ia
      enddo !ib

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Deriva(IPrint,ToAng,NAt,nTs,NEsf,NEsfP,RSolv,Tessera,
     $                  Vert,Centr,Sphere,ISphe,IntSph,NOrd,NVert,
     $                  NewSph,DerTes,DerPunt,DerRad,DerCentr)
      Implicit Real*8 (a-h,o-z)
      Parameter (MxVert=20)
      Integer AlGe(63), Casca(MxVert)
      Dimension DISTKI(3), DERP(3), DERPT(3)
      Dimension Tessera(4,*),Vert(3,MxVert,*),Centr(3,MxVert,*)
      Dimension Sphere(4,*),ISphe(*)
      Dimension IntSph(MxVert,*),NewSph(2,NEsf),NOrd(*),NVert(*)
      Dimension DerTes(nTs,NAt,3),DerPunt(nTs,NAt,3,3)
      Dimension DerRad(NEsf,NAt,3),DerCentr(NEsf,NAt,3,3)
      Save Zero, One
      DATA ZERO, One/0.0D0,1.0d0/
*
*     Compute the derivatives of area and of representative point position
*     for each tessera
*
C     Le derivate contengono termini dovuti direttamente allo spostamento
C     del centro della sfera NSJ, e termini "mediati" dagli
C     spostamenti del centro e dal cambiamento del raggio delle sfere
C     "aggiunte" (create da PEDRA, oltre a quelle originarie).
C     Chiamiamo ITS la tessera, I la sfera a cui ITS appartiene, J la sfera
C     che si muove. Le derivate che cerchiamo sono dS(ITS)/dx(J) e
C     dQ(ITS)/dx(J) (indicando con x(J) una qualsiasi coordinata di J.
C     Per prima cosa calcoliamo le derivate dell'area e del punto
C     rappresentativo delle tessere DIRETTAMENTE tagliate da J, poi di quelle
C     che appartengono a J e sono tagliate da altre sfere.
C     Poi consideriamo le "sfere aggiunte" che vengono modificate dal
C     movimento di J: per ogni sfera aggiunta si esaminano tutte le
C     tessere e caso per caso si calcolano le derivate.
C
C     In ogni caso le derivate totali dS/dx(J) e dQ/dx(J) si scrivono come una
C     combinazione delle seguenti derivate parziali:
C          dS/dR(I)  ;  dS/dz(I)  ;  dS/dR(K)  ;  dS/dz(K)
C          dQ/dR(I)  ;  dQ/dz(I)  ;  dQ/dR(K)  ;  dQ/dz(K)
C     dove, ancora una volta, z indica una qualunque coordinata e K un'altra
C     sfera (la stessa J o una sfera aggiunta modificata dal movimento
C     di J) che taglia S.
C
C     NESFJ e' la sfera che sta attorno all'atomo NSJ: se NSJ non ha
C     nessuna sfera, NESFJ = 0
*
*     Initiate the derivative arrays
      NDeg = 3 * NAt
      Call FZero(DerTes(1,1,1),nTs*NDeg)
      Call FZero(DerPunt(1,1,1,1),3*nTs*NDeg)
      Call FZero(DerRad(1,1,1),NEsf*NDeg)
      Call FZero(DerCentr(1,1,1,1),3*NEsf*NDeg)
*     The geometric quantities are expected to be in Angstrom
      Call DScal_(4*nTs,ToAng,Tessera(1,1),1)
      Call DScal_(  nTs,ToAng,Tessera(4,1),4)
      Call DScal_(4*NEsf,ToAng,Sphere(1,1),1)
      Call DScal_(3*MxVert*nTs,ToAng,Vert(1,1,1),1)
      Call DScal_(3*MxVert*nTs,ToAng,Centr(1,1,1),1)
*
      Do 1000 NSJ = 1, NAt
      Do 1010 ICoord = 1, 3
*
      NESFJ = 0
      DO 2000 I = 1, NESFP
        IF( NSJ.EQ.NORD(I) ) NESFJ = I
 2000 continue
C
C     Memorizza in DERRAD(NS,NSJ,ICOORD) la derivata del raggio di ogni
C     sfera NS e in DERCENTR(NS,NSJ,ICOORD,3) le derivate delle
C     coordinate del centro di NS rispetto alla coord. ICOORD della
C     sfera NSJ.
C
C     Se NS e' una sfera originaria queste derivate sono 0, tranne
C     DERCENTR(NESFJ,NSJ,ICOORD,ICOORD)=1 :
C
      DO 2010 NSFE = 1, NESFP
        DERRAD(NSFE,NSJ,ICOORD) = ZERO
        DO 2020 JJ = 1, 3
          DERCENTR(NSFE,NSJ,ICOORD,JJ) = ZERO
 2020 continue
 2010 continue
      IF( NESFJ.NE.0 )
     $ DERCENTR(NESFJ,NSJ,ICOORD,ICOORD) = 1.0D0
C
C     Se non c'e' nessuna sfera attorno all'atomo NSJ ...
      IF(NESFJ.EQ.0) Goto 1000
C
C     1) Effetti diretti.
C     Loop sulle tessere.
      DO 100 ITS= 1, NTS
      DERTS = ZERO
      DO 2030 JJ = 1, 3
        DERPT(JJ) = ZERO
 2030 continue
      NV = NVERT(ITS)
      NSI = ISPHE(ITS)
      IF(NSI.EQ.NESFJ) GOTO 200
C
C     Derivate nel caso I non = J
C
C               dS/dx(J), dQ/dx(J)
C     ITS ha un lato su J ?
      ICONT = 0
      DO 2040 N = 1, NV
        IF(INTSPH(N,ITs).EQ.NESFJ) ICONT = ICONT + 1
 2040 continue
      IF(ICONT.GE.1) THEN
      CALL dSd(0,ITS,ICOORD,NESFJ,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
      DERTS = DERTS + DERS
      DO 2050 JJ = 1, 3
        DERPT(JJ) = DERPT(JJ) + DERP(JJ)
 2050 continue
      ENDIF
      GOTO 150
 200  CONTINUE
C     Derivate nel caso I = J
C
C     Loop sulle sfere K che intersecano I
      DO 300 NSK = 1, NESF
      IF(NSK.EQ.NSI) GOTO 300
C     ITS ha un lato su K ?
      ICONT = 0
      DO 2060 N = 1, NV
      IF(INTSPH(N,ITs).EQ.NSK) ICONT = ICONT + 1
 2060 continue
      IF(ICONT.EQ.0) GOTO 300
      CALL dSd(0,ITS,ICOORD,NSK,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
      DERTS = DERTS - DERS
      DO 2070 JJ = 1, 3
        DERPT(JJ) = DERPT(JJ) - DERP(JJ)
 2070 continue
 300  CONTINUE
 150  DERTES(ITS,NSJ,ICOORD) = DERTS
      DO 2080 JJ = 1, 3
      DERPUNT(ITS,NSJ,ICOORD,JJ) = DERPT(JJ)
 2080 continue
 100  CONTINUE
C
C     2) Effetti indiretti.
C     Loop sulle sfere aggiunte
      DO 500 NSA = NESFP+1, NESF
      DO 2090 II = 1, 63
      ALGE(II) = 0
 2090 continue
C     Costruiamo l'"albero genealogico" della sfera NSA
      ALGE(1) = NSA
      ALGE(2) = ABS(NEWSPH(1,NSA))
      ALGE(3) = ABS(NEWSPH(2,NSA))
      LIVEL = 3
      NUMBER = 2
 510  NSUB = 1
      DO 2100 II = LIVEL-NUMBER+1, LIVEL
      IF(ALGE(II).GT.NESFP) THEN
        ALGE(LIVEL+NSUB)   = ABS(NEWSPH(1,ALGE(II)))
        ALGE(LIVEL+NSUB+1) = ABS(NEWSPH(2,ALGE(II)))
        ENDIF
        NSUB = NSUB + 2
 2100 continue
      NUMBER = NUMBER * 2
      LIVEL = LIVEL + NUMBER
      IF(NUMBER.LT.32) GOTO 510
C     Si accerta che nell'ultimo livello ci siano solo sfere originarie
      DO 2110 II = 34, 63
      IF(ALGE(II).GT.NESFP) THEN
        WRITE(6,10) NSA, ALGE(II)
 10       FORMAT(/,'SFERA ',I3,/,
     %    'AL LIVELLO 5 LA SFERA',I3,' E" AGGIUNTA')
      ENDIF
 2110 continue
C     Quando un elemento di ALGE e' = NESFJ, costruisce la corrispondente
C     "cascata" di sfere aggiunte che collega NESFJ a NSA
      DO 600 LIVEL = 2, 6
      MIN = 2**(LIVEL-1)
      MAX = 2**(LIVEL) - 1
      DO 700 II = MIN, MAX
      IF(ALGE(II).NE.NESFJ) GOTO 700
      DO 2120 K = 1, MxVert
      CASCA(K) = 0
 2120 continue
      CASCA(1) = NESFJ
      INDEX = II
      K = 2
      DO 2130 LL = LIVEL, 2, -1
        FACT = (INDEX - 2**(LL-1)) / 2.D0
        INDEX = 2**(LL-2) + iRToInt(FACT)
        CASCA(K) = ALGE(INDEX)
        K = K + 1
 2130 continue
C     Contiamo gli elementi diversi da 0 in CASCA
      ICONT = 0
      DO 2140 K = 1, MxVert
      IF(CASCA(K).NE.0) ICONT = ICONT + 1
 2140 continue
C
C     Costruiamo le derivate composte del raggio e delle coordinate di
C     NSA (ultimo elemento di CASCA)
C     rispetto alla coordinata ICOORD di NESFJ (primo elemento di CASCA)
      NS1 = CASCA(1)
      NS2 = CASCA(2)
      CALL dRdC(NS2,ICOORD,NS1,DR,RSolv,Sphere,NewSph)
      CALL dCdC(1,NS2,ICOORD,NS1,DX,Sphere,NewSph)
      CALL dCdC(2,NS2,ICOORD,NS1,DY,Sphere,NewSph)
      CALL dCdC(3,NS2,ICOORD,NS1,DZ,Sphere,NewSph)
      DO 800 I = 3, ICONT
      DDR = ZERO
      DDX = ZERO
      DDY = ZERO
      DDZ = ZERO
      NS1 = CASCA(I-1)
      NS2 = CASCA(I)
C
C     Derivata del raggio dell'elemento I di CASCA rispetto
C     alla coord. ICOORD dell'elemento 1 di CASCA
      CALL dRdR(NS2,NS1,DER,RSolv,Sphere,NewSph)
      DDR = DER * DR
      CALL dRdC(NS2,1,NS1,DER,RSolv,Sphere,NewSph)
      DDR = DDR + DER * DX
      CALL dRdC(NS2,2,NS1,DER,RSolv,Sphere,NewSph)
      DDR = DDR + DER * DY
      CALL dRdC(NS2,3,NS1,DER,RSolv,Sphere,NewSph)
      DDR = DDR + DER * DZ
C
C     Derivata della coord. X dell'elemento I di CASCA rispetto
C     alla coord. ICOORD dell'elemento 1 di CASCA
      CALL dCdR(1,NS2,NS1,DER,Sphere,NewSph)
      DDX = DER * DR
      CALL dCdC(1,NS2,1,NS1,DER,Sphere,NewSph)
      DDX = DDX + DER * DX
      CALL dCdC(1,NS2,2,NS1,DER,Sphere,NewSph)
      DDX = DDX + DER * DY
      CALL dCdC(1,NS2,3,NS1,DER,Sphere,NewSph)
      DDX = DDX + DER * DZ
C
C     Derivata della coord. Y dell'elemento I di CASCA rispetto
C     alla coord. ICOORD dell'elemento 1 di CASCA
      CALL dCdR(2,NS2,NS1,DER,Sphere,NewSph)
      DDY = DER * DR
      CALL dCdC(2,NS2,1,NS1,DER,Sphere,NewSph)
      DDY = DDY + DER * DX
      CALL dCdC(2,NS2,2,NS1,DER,Sphere,NewSph)
      DDY = DDY + DER * DY
      CALL dCdC(2,NS2,3,NS1,DER,Sphere,NewSph)
      DDY = DDY + DER * DZ
C
C     Derivata della coord. Z dell'elemento I di CASCA rispetto
C     alla coord. ICOORD dell'elemento 1 di CASCA
      CALL dCdR(3,NS2,NS1,DER,Sphere,NewSph)
      DDZ = DER * DR
      CALL dCdC(3,NS2,1,NS1,DER,Sphere,NewSph)
      DDZ = DDZ + DER * DX
      CALL dCdC(3,NS2,2,NS1,DER,Sphere,NewSph)
      DDZ = DDZ + DER * DY
      CALL dCdC(3,NS2,3,NS1,DER,Sphere,NewSph)
      DDZ = DDZ + DER * DZ
C
      DR = DDR
      DX = DDX
      DY = DDY
      DZ = DDZ
 800  CONTINUE
C
C     Se NS e' una sfera aggiunta, memorizza le derivate del raggio
C     e delle coordinate del centro:
      DERRAD(NSA,NSJ,ICOORD) = DR
      DERCENTR(NSA,NSJ,ICOORD,1) = DX
      DERCENTR(NSA,NSJ,ICOORD,2) = DY
      DERCENTR(NSA,NSJ,ICOORD,3) = DZ
C
C     Per ogni sfera aggiunta connessa a NESFJ, fa passare tutte le
C     tessere, calcolando, se e' il caso, le derivate
      DO 900 ITS = 1, NTS
      DERTS = ZERO
      DO 2150 JJ = 1, 3
      DERPT(JJ) = ZERO
 2150 continue
      NV = NVERT(ITS)
      NSI = ISPHE(ITS)
C     Derivate delle tessere appartenenti a NSA
      IF(NSI.EQ.NSA) THEN
C       Derivate relative al raggio di NSI: 1) scaling
        DERTS = 2.D0 * Tessera(4,ITS) * DR / Sphere(4,NSI)
      DERPT(1) = (Tessera(1,ITS) - Sphere(1,NSI)) * DR / Sphere(4,NSI)
      DERPT(2) = (Tessera(2,ITS) - Sphere(2,NSI)) * DR / Sphere(4,NSI)
      DERPT(3) = (Tessera(3,ITS) - Sphere(3,NSI)) * DR / Sphere(4,NSI)
C       Loop sulle altre sfere K che tagliano ITS
        DO 950 NSK = 1, NESF
          IF(NSK.EQ.NSI) GOTO 950
          ICONT = 0
          DO 2160 N = 1, NV
          IF(INTSPH(N,ITs).EQ.NSK) ICONT = ICONT + 1
 2160 continue
          IF(ICONT.EQ.0) GOTO 950
C         Derivate relative al raggio di NSI: 2) raggio delle altre sfere
          CALL dSd(1,ITS,IJunk,NSK,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
          DERTS = DERTS - DERS * Sphere(4,NSK) * DR / Sphere(4,NSI)
        DO 2170 JJ = 1, 3
          DERPT(JJ) = DERPT(JJ) -
     $                DERP(JJ) * Sphere(4,NSK) * DR / Sphere(4,NSI)
 2170 continue
C         Derivate relative al raggio di NSI: 3) coord. delle altre sfere
          DISTKI(1) = Sphere(1,NSK) - Sphere(1,NSI)
          DISTKI(2) = Sphere(2,NSK) - Sphere(2,NSI)
          DISTKI(3) = Sphere(3,NSK) - Sphere(3,NSI)
          FAC = DR / Sphere(4,NSI)
          DO 2180 JJ = 1, 3
            CALL dSd(0,ITS,JJ,NSK,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
                   IF(DISTKI(JJ).NE.ZERO) THEN
            DERTS = DERTS - FAC * DERS * DISTKI(JJ)
            DO 2190 LL = 1, 3
              DERPT(LL) = DERPT(LL) - FAC * DERP(LL) * DISTKI(JJ)
 2190 continue
          ENDIF
 2180 continue
C         Derivate relative alle coordinate di NSI
          CALL dSd(0,ITS,1,NSK,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
          DERTS = DERTS - DX * DERS
        DO 2200 JJ = 1, 3
          DERPT(JJ) = DERPT(JJ) - DX * DERP(JJ)
 2200 continue
          CALL dSd(0,ITS,2,NSK,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
          DERTS = DERTS - DY * DERS
        DO 2210 JJ = 1, 3
          DERPT(JJ) = DERPT(JJ) - DY * DERP(JJ)
 2210 continue
          CALL dSd(0,ITS,3,NSK,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
          DERTS = DERTS - DZ * DERS
        DO 2220 JJ = 1, 3
          DERPT(JJ) = DERPT(JJ) - DZ * DERP(JJ)
 2220 continue
 950    CONTINUE
        DERTES(ITS,NSJ,ICOORD) = DERTES(ITS,NSJ,ICOORD) + DERTS
      DO 2230 JJ = 1, 3
        DERPUNT(ITS,NSJ,ICOORD,JJ) = DERPUNT(ITS,NSJ,ICOORD,JJ) +
     *    DERPT(JJ)
 2230 continue
      ELSE
C       Derivate delle tessere tagliate da NSA
        ICONT = 0
        DO 2240 N = 1, NV
          IF(INTSPH(N,ITs).EQ.NSA) ICONT = ICONT + 1
 2240 continue
        IF(ICONT.EQ.0) GOTO 900
C       Derivate relative al raggio di NSA
      CALL dSd(1,ITS,IJunk,NSA,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
      DERTS = DERS * DR
      DO 2250 JJ = 1, 3
        DERPT(JJ) = DERP(JJ) * DR
 2250 continue
C       Derivate relative alle coordinate di NSA
        CALL dSd(0,ITS,1,NSA,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
        DERTS = DERTS + DX * DERS
      DO 2260 JJ = 1, 3
        DERPT(JJ) = DERPT(JJ) + DX * DERP(JJ)
 2260 continue
        CALL dSd(0,ITS,2,NSA,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
        DERTS = DERTS + DY * DERS
      DO 2270 JJ = 1, 3
        DERPT(JJ) = DERPT(JJ) + DY * DERP(JJ)
 2270 continue
        CALL dSd(0,ITS,3,NSA,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
        DERTS = DERTS + DZ * DERS
      DO 2280 JJ = 1, 3
        DERPT(JJ) = DERPT(JJ) + DZ * DERP(JJ)
 2280 continue
C
        DERTES(ITS,NSJ,ICOORD) = DERTES(ITS,NSJ,ICOORD) + DERTS
      DO 2290 JJ = 1, 3
        DERPUNT(ITS,NSJ,ICOORD,JJ) = DERPUNT(ITS,NSJ,ICOORD,JJ) +
     *    DERPT(JJ)
 2290 continue
      ENDIF
 900  CONTINUE
 700  CONTINUE
 600  CONTINUE
 500  CONTINUE
C
C     Controlla che nessuna derivata sia eccessiva (per imprecisioni numeriche)
      DO 2300 ITS = 1, NTS
      IF( abs(DERTES(ITS,NSJ,ICOORD)) .GT. 10.D0 ) THEN
        IF(IPrint.ge.2) THEN
          WRITE(6,*)'DERIVATA GEOMETRICA ECCESSIVA TRASCURATA'
          WRITE(6,*)'TESSERA, SFERA, COORDINATA',ITS,NESFJ,ICOORD
        ENDIF
        DERTES(ITS,NSJ,ICOORD) = 0.D0
        ENDIF
 2300 continue
*
*     End of loop on atoms and coordinates
*
 1010 Continue
 1000 Continue
*     Put the geometric quantities in Bohr again
      ToBohr = One / ToAng
      Call DScal_(4*nTs,ToBohr,Tessera(1,1),1)
      Call DScal_(  nTs,ToBohr,Tessera(4,1),4)
      Call DScal_(4*NEsf,ToBohr,Sphere(1,1),1)
      Call DScal_(30*nTs,ToBohr,Vert(1,1,1),1)
      Call DScal_(30*nTs,ToBohr,Centr(1,1,1),1)
*
      RETURN
      END
*
      SUBROUTINE DCDC(JJ,NSI,ICOORD,NESFJ,DC,Sphere,NewSph)
      IMPLICIT REAL*8 (A-H,O-Z)
      Dimension Sphere(4,*),NewSph(2,*)
      DIMENSION COORDJ(3), COORDK(3)
C
C     Trova la derivata della coordinata JJ del centro della sfera
C     NSI rispetto alla coordinata ICOORD di NSJ, che interseca NSI.
C
C     La sfera NSI (che appartiene alle sfere "aggiunte" da PEDRA)
C     dipende dalle due sfere "precedenti" NESFJ e NSK
C
C     Se NESFJ o NSK sono negativi, la sfera aggiunta e' di tipo C
C     e la generatrice "principale" corrisponde al label negativo
C     (cfr. JCC 11, 1047 (1990))
C
      IF(NEWSPH(1,NSI).LT.0.OR.NEWSPH(2,NSI).LT.0) GOTO 100
      K = NEWSPH(1,NSI)
      IF(K.EQ.NESFJ) K = NEWSPH(2,NSI)
      COORDJ(1) = Sphere(1,NESFJ)
      COORDJ(2) = Sphere(2,NESFJ)
      COORDJ(3) = Sphere(3,NESFJ)
      COORDK(1) = Sphere(1,K)
      COORDK(2) = Sphere(2,K)
      COORDK(3) = Sphere(3,K)
      D2 = (Sphere(1,NESFJ)-Sphere(1,K))**2
     $   + (Sphere(2,NESFJ)-Sphere(2,K))**2
     $   + (Sphere(3,NESFJ)-Sphere(3,K))**2
      D = sqrt(D2)
      DC = (Sphere(4,NESFJ) - Sphere(4,K))
     $   * (COORDJ(ICOORD) - COORDK(ICOORD))
     $   * (COORDJ(JJ) - COORDK(JJ)) / (2.D0 * D**3)
      IF(JJ.EQ.ICOORD)DC = DC + 0.5D0 - (Sphere(4,NESFJ)-Sphere(4,K))
     $                   / (2.D0*D)
      GOTO 200
C
 100  CONTINUE
      NSK = NEWSPH(1,NSI)
      IF(ABS(NSK).EQ.NESFJ) NSK = NEWSPH(2,NSI)
      COORDJ(1) = Sphere(1,NESFJ)
      COORDJ(2) = Sphere(2,NESFJ)
      COORDJ(3) = Sphere(3,NESFJ)
      COORDK(1) = Sphere(1,ABS(NSK))
      COORDK(2) = Sphere(2,ABS(NSK))
      COORDK(3) = Sphere(3,ABS(NSK))
      D2 = (COORDJ(1)-COORDK(1))**2 + (COORDJ(2)-COORDK(2))**2 +
     &     (COORDJ(3)-COORDK(3))**2
      D = sqrt(D2)
      IF(NSK.GT.0) THEN
      DC = Sphere(4,NESFJ) * (COORDJ(JJ) - COORDK(JJ))
     $   * (COORDJ(ICOORD) - COORDK(ICOORD)) / D**3
        IF(ICOORD.EQ.JJ) DC = DC + 1.D0 - Sphere(4,NESFJ) / D
      ELSE
      DC = - Sphere(4,ABS(NSK)) * (COORDK(JJ) - COORDJ(JJ))
     $     * (COORDK(ICOORD) - COORDJ(ICOORD)) / D**3
        IF(ICOORD.EQ.JJ) DC = DC + Sphere(4,ABS(NSK)) / D
      ENDIF
C
 200  CONTINUE
      RETURN
      END
*
      SUBROUTINE dCdR(JJ,NSI,NESFJ,DC,Sphere,NewSph)
      IMPLICIT REAL*8 (A-H,O-Z)
      Dimension Sphere(4,*),NewSph(2,*)
      DIMENSION COORDJ(3), COORDK(3)
      DATA ZERO/0.0D0/
C
C     Trova la derivata della coordinata JJ del centro della sfera
C     NSI rispetto al raggio dellla sfera NSJ.
C
C     La sfera NSI (che appartiene alle sfere "aggiunte" da PEDRA)
C     dipende dalle due sfere "precedenti" NESFJ e NSK
C
C     Se NESFJ o NSK sono negativi, la sfera aggiunta e' di tipo C
C     e la generatrice "principale" corrisponde al label negativo
C     (cfr. JCC 11, 1047 (1990))
C
      IF(NEWSPH(1,NSI).LT.0.OR.NEWSPH(2,NSI).LT.0) GOTO 100
      NSK = NEWSPH(1,NSI)
      IF(NSK.EQ.NESFJ) NSK = NEWSPH(2,NSI)
      COORDJ(1) = Sphere(1,NESFJ)
      COORDJ(2) = Sphere(2,NESFJ)
      COORDJ(3) = Sphere(3,NESFJ)
      COORDK(1) = Sphere(1,NSK)
      COORDK(2) = Sphere(2,NSK)
      COORDK(3) = Sphere(3,NSK)
      D2 = (Sphere(1,NESFJ)-Sphere(1,NSK))**2
     $   + (Sphere(2,NESFJ)-Sphere(2,NSK))**2
     $   + (Sphere(3,NESFJ)-Sphere(3,NSK))**2
      D = sqrt(D2)
      DC = - (COORDJ(JJ) - COORDK(JJ)) / (2.D0 * D)
      GOTO 200
C
 100  CONTINUE
      NSK = NEWSPH(1,NSI)
      IF(ABS(NSK).EQ.NESFJ) NSK = NEWSPH(2,NSI)
      DC = ZERO
      IF(NSK.LT.ZERO) GOTO 200
      COORDJ(1) = Sphere(1,NESFJ)
      COORDJ(2) = Sphere(2,NESFJ)
      COORDJ(3) = Sphere(3,NESFJ)
      COORDK(1) = Sphere(1,NSK)
      COORDK(2) = Sphere(2,NSK)
      COORDK(3) = Sphere(3,NSK)
      D2 = (Sphere(1,NESFJ)-Sphere(1,NSK))**2
     $   + (Sphere(2,NESFJ)-Sphere(2,NSK))**2
     $   + (Sphere(3,NESFJ)-Sphere(3,NSK))**2
      D = sqrt(D2)
      DC = - ( COORDJ(JJ) - COORDK(JJ) ) / D
C
 200  CONTINUE
      RETURN
      END
*
      SUBROUTINE dRdC(NSI,ICOORD,NESFJ,DR,RSolv,Sphere,NewSph)
      IMPLICIT REAL*8 (A-H,O-Z)
      Dimension Sphere(4,*),NewSph(2,*)
      DIMENSION COORDJ(3), COORDK(3)
C
C     Trova la derivata del raggio della sfera NSI rispetto alla
C     coordinata ICOORD (1=X, 2=Y, 3=Z) della sfera NSJ, che interseca
C     NSI.
C
C     La sfera NSI (che appartiene alle sfere "aggiunte" da PEDRA)
C     dipende dalle due sfere "precedenti" NESFJ e K
C
C     Se NESFJ o NSK sono negativi, la sfera aggiunta e' di tipo C
C     e la generatrice "principale" corrisponde al label negativo
C     (cfr. JCC 11, 1047 (1990))
C
      IF(NEWSPH(1,NSI).LT.0.OR.NEWSPH(2,NSI).LT.0) GOTO 100
      K = NEWSPH(1,NSI)
      IF(K.EQ.NESFJ) K = NEWSPH(2,NSI)
      COORDJ(1) = Sphere(1,NESFJ)
      COORDJ(2) = Sphere(2,NESFJ)
      COORDJ(3) = Sphere(3,NESFJ)
      COORDK(1) = Sphere(1,K)
      COORDK(2) = Sphere(2,K)
      COORDK(3) = Sphere(3,K)
      D2 = (Sphere(1,NESFJ)-Sphere(1,K))**2
     $   + (Sphere(2,NESFJ)-Sphere(2,K))**2
     $   + (Sphere(3,NESFJ)-Sphere(3,K))**2
      D = sqrt(D2)
      B = 0.5D0 * (D + Sphere(4,NESFJ) - Sphere(4,K))
      RS = RSOLV
      A = ((Sphere(4,NESFJ)+RS)**2 + D2 - (Sphere(4,K)+RS)**2) / D
      DR = (2.D0*A*B - 2.D0*B*D - A*D)
     $   * (COORDJ(ICOORD)-COORDK(ICOORD))
     $   / (4.D0*D2*(Sphere(4,NSI)+RS))
      GOTO 200
C
 100  CONTINUE
      NSK = NEWSPH(1,NSI)
      IF(ABS(NSK).EQ.NESFJ) NSK = NEWSPH(2,NSI)
      COORDJ(1) = Sphere(1,NESFJ)
      COORDJ(2) = Sphere(2,NESFJ)
      COORDJ(3) = Sphere(3,NESFJ)
      COORDK(1) = Sphere(1,ABS(NSK))
      COORDK(2) = Sphere(2,ABS(NSK))
      COORDK(3) = Sphere(3,ABS(NSK))
      RI = Sphere(4,NSI) + RSOLV
      RJ = Sphere(4,NESFJ) + RSOLV
      RK = Sphere(4,ABS(NSK)) + RSOLV
      DIFF = COORDJ(ICOORD) - COORDK(ICOORD)
      D2 = (COORDJ(1)-COORDK(1))**2 + (COORDJ(2)-COORDK(2))**2 +
     &     (COORDJ(3)-COORDK(3))**2
      D = sqrt(D2)
      FAC = Sphere(4,NESFJ) * ( RJ*RJ - D*D - RK*RK )
      IF(NSK.LT.0) FAC = Sphere(4,ABS(NSK)) * (RK*RK - D*D - RJ*RJ )
      DR = DIFF * FAC / ( 2.D0 * D**3 * RI )
C
 200  CONTINUE
      RETURN
      END
*
      SUBROUTINE dRdR(NSI,NESFJ,DR,RSolv,Sphere,NewSph)
      IMPLICIT REAL*8 (A-H,O-Z)
      Dimension Sphere(4,*),NewSph(2,*)
C
C     Trova la derivata del raggio della sfera NSI rispetto al raggio
C     della sfera NSJ.
C
C     La sfera NSI (che appartiene alle sfere "aggiunte" da PEDRA)
C     dipende dalle due sfere "precedenti" NESFJ e NSK
C     Se NESFJ o NSK sono negativi, la sfera aggiunta e' di tipo C
C     e la generatrice "principale" corrisponde al label negativo
C     (cfr. JCC 11, 1047 (1990))
C
      IF(NEWSPH(1,NSI).LT.0.OR.NEWSPH(2,NSI).LT.0) GOTO 100
      NSK = NEWSPH(1,NSI)
      IF(NSK.EQ.NESFJ) NSK = NEWSPH(2,NSI)
      RS = RSOLV
      RJ = Sphere(4,NESFJ) + RS
      RK = Sphere(4,NSK) + RS
      RI = Sphere(4,NSI) + RS
      D2 = (Sphere(1,NESFJ)-Sphere(1,NSK))**2
     $   + (Sphere(2,NESFJ)-Sphere(2,NSK))**2
     $   + (Sphere(3,NESFJ)-Sphere(3,NSK))**2
      D = sqrt(D2)
      DR = (-3.D0*RJ*RJ + RK*RK + 2.D0*RJ*RK + 3.D0*D*RJ - D*RK) /
     %      (4.D0*D*RI)
      GOTO 200
C
 100  CONTINUE
      NSK = NEWSPH(1,NSI)
      IF(ABS(NSK).EQ.NESFJ) NSK = NEWSPH(2,NSI)
C
      IF(NSK.GT.0) THEN
        RS = RSOLV
        RJ = Sphere(4,NESFJ) + RS
        RK = Sphere(4,NSK) + RS
        RI = Sphere(4,NSI) + RS
        D2 = (Sphere(1,NESFJ)-Sphere(1,NSK))**2
     $     + (Sphere(2,NESFJ)-Sphere(2,NSK))**2
     $     + (Sphere(3,NESFJ)-Sphere(3,NSK))**2
        D = sqrt(D2)
        DR = ( 2.D0*D*RJ + 2.D0*D*Sphere(4,NESFJ)
     $     - 2.D0*RJ*Sphere(4,NESFJ)
     $     + D*D - RJ*RJ - RK*RK ) / (2.D0*D*RI)
      ELSE
        RS = RSOLV
        RJ = Sphere(4,NESFJ) + RS
        RI = Sphere(4,NSI) + RS
        D2 = (Sphere(1,NESFJ)-Sphere(1,ABS(NSK)))**2 +
     %       (Sphere(2,NESFJ)-Sphere(2,ABS(NSK)))**2 +
     %       (Sphere(3,NESFJ)-Sphere(3,ABS(NSK)))**2
        D = sqrt(D2)
        DR = ( Sphere(4,ABS(NSK)) * RJ ) / ( D*RI)
      ENDIF
 200  CONTINUE
      RETURN
      END
*
      SUBROUTINE dSd(IOpt,ITS,ICOORD,NESFJ,DERS,DERP,Tessera,
     $         Vert,Centr,nTs,Sphere,ISphe,IntSph,NewSph,NVert)
      IMPLICIT REAL*8 (A-H,O-Z)
      Parameter (MxVert=20)
      Dimension Sphere(4,*),ISphe(*),NewSph(2,*)
      Dimension IntSph(MxVert,*),NVert(*)
      Dimension Tessera(4,*),Vert(3,MxVert,*),Centr(3,MxVert,*)
      DIMENSION DP(MxVert,3), DERP(3), SUMDER(3), SUMVERT(3),  PT(3)
      DATA ZERO/0.0D0/
C
C     Trova le derivate dell'area e del punto rappresentativo della
C     tessera ITS rispetto
C
C       IOpt = 0 : alla coordinata ICOORD(1=X, 2=Y, 3=Z) dell'atomo NSJ.
C                  (ex dsdx)
C       IOpt = 1 : al raggio della sfera NSJ. (ex dsdr)
C
C     NESFJ e' la sfera attorno all'atomo NSJ.
C     ITS appartiene alla sfera NSI (diversa da NESFJ, e intersecata
C     da NESFJ).
C
C
      DERTS = ZERO
      NSI = ISPHE(ITS)
      NV = NVERT(ITS)
      DO 2000 L = 1, NV
      DP(L,1) = ZERO
      DP(L,2) = ZERO
      DP(L,3) = ZERO
 2000 continue
      DO 100 L = 1, NV
      IF(INTSPH(L,ITs).NE.NESFJ) GOTO 100
C     L1 e' il lato di ITS che sta sulla sfera NESFJ
      L1 = L
      L0 = L - 1
      IF(L1.EQ.1) L0 = NV
      L2 = L1 + 1
      IF(L1.EQ.NV) L2 = 1
      L3 = L2 + 1
      IF(L2.EQ.NV) L3 = 1
C     Trova la derivata del vertice L1: DP(L1)
      CALL DVer(IOpt,ICOORD,ITS,L0,L1,L2,DP(L1,1),DP(L1,2),DP(L1,3),
     $          Vert,Centr,nTs,Sphere,IntSph)
C     Trova la derivata del vertice L2: DP(L2)
      CALL DVer(IOpt,ICOORD,ITS,L1,-L2,L3,DP(L2,1),DP(L2,2),DP(L2,3),
     $          Vert,Centr,nTs,Sphere,IntSph)
C
C     1) Derivata dell'area della tessera.
C
C     Calcola i contributi dovuti ai lati L0-L1, L1-L2, L2-L3
      IF(INTSPH(L0,ITs).NE.NSI) THEN
        CALL DerPhi(IOpt,ICOORD,NESFJ,ITS,L0,L1,DP,DA,
     $              Vert,Centr,nTs,Sphere,IntSph,ISphe)
        DERTS = DERTS + DA
      ENDIF
      CALL DerPhi(IOpt,ICOORD,NESFJ,ITS,L1,L2,DP,DA,
     $              Vert,Centr,nTs,Sphere,IntSph,ISphe)
      DERTS = DERTS + DA
      IF(INTSPH(L2,ITs).NE.ISPHE(ITS)) THEN
        CALL DerPhi(IOpt,ICOORD,NESFJ,ITS,L2,L3,DP,DA,
     $              Vert,Centr,nTs,Sphere,IntSph,ISphe)
        DERTS = DERTS + DA
      ENDIF
C
C     Calcola i contributi dovuti ai vertici L1 e L2
      CALL DerBet(IOpt,ICOORD,NESFJ,ITS,L0,L1,L2,DP,DA,
     $            Vert,Centr,nTs,Sphere,IntSph,ISphe)
      DERTS = DERTS - DA
      CALL DerBet(IOpt,ICOORD,NESFJ,ITS,L1,L2,L3,DP,DA,
     $            Vert,Centr,nTs,Sphere,IntSph,ISphe)
      DERTS = DERTS - DA
 100  CONTINUE
      DERS = DERTS
C
C     2) Derivata del punto rappresentativo.
C
C     Trova il punto rappresentativo riferito al centro della sfera
      PT(1) = Tessera(1,ITS) - Sphere(1,NSI)
      PT(2) = Tessera(2,ITS) - Sphere(2,NSI)
      PT(3) = Tessera(3,ITS) - Sphere(3,NSI)
C     Trova il modulo della somma dei vertici della tessera
      DO 2010 JJ = 1, 3
      SUMVERT(JJ) = ZERO
 2010 continue
      DO 2020 L = 1, NV
      SUMVERT(1) = SUMVERT(1) + (VERT(1,L,ITs) - Sphere(1,NSI))
      SUMVERT(2) = SUMVERT(2) + (VERT(2,L,ITs) - Sphere(2,NSI))
      SUMVERT(3) = SUMVERT(3) + (VERT(3,L,ITs) - Sphere(3,NSI))
 2020 continue
      SUM = ZERO
      DO 2030 JJ = 1, 3
      SUM = SUM + SUMVERT(JJ) * SUMVERT(JJ)
 2030 continue
      SUM = sqrt(SUM)
C     Trova la somma delle derivate dei vertici
      DO 2040 JJ = 1, 3
      SUMDER(JJ) = DP(L1,JJ) + DP(L2,JJ)
 2040 continue
C
      PROD = ZERO
      DO 2050 JJ = 1, 3
        PROD = PROD + PT(JJ) * SUMDER(JJ)
 2050 continue
      DO 2060 JJ = 1, 3
      DERP(JJ) = ( SUMDER(JJ) * Sphere(4,NSI) / SUM ) -
     *             ( PT(JJ) * PROD / (Sphere(4,NSI)*SUM) )
 2060 continue
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer_array(NewSph)
      END
*
      SUBROUTINE DVer(IOpt,IC,ITS,L0,L,L2,DX,DY,DZ,
     $                Vert,Centr,nTs,Sphere,IntSph)
      IMPLICIT REAL*8 (A-H,O-Z)
      Parameter (MxVert=20)
      Dimension Sphere(4,*),IntSph(MxVert,*)
      Dimension Vert(3,MxVert,*),Centr(3,MxVert,*)
      DIMENSION P(3),P1(3),P2(3),P3(3)
C
C     Trova la derivata della posizione del vertice L della tessera ITS
C
C     IOpt = 0 : rispetto alla coordinata IC della sfera che, intersecando
C                ISPHE(ITS), forma il lato in esame. (ex derver)
C     IOpt = 1 : rispetto al raggio della sfera aggiunta NSJ che,
C                intersecando la tessera ITS, crea il lato considerato.
C                (ex derver1, IC not referenced)
C
C     Se stiamo considerando il primo vertice del lato : L > 0,
C     il lato che si muove e' L-L2, e il vettore derivata e' diretto
C     lungo la tangente al lato precedente (L0-L).
C     Se stiamo considerando il secondo vertice del lato : L < 0,
C     il lato che si muove e' L0-L, e il vettore derivata e' tangente
C     al lato seguente (L-L2).
C
      ZERO = 0.d0
      IF(L.GT.0) THEN
      L1 = L
        NSJ = INTSPH(L1,ITs)
      ELSE
        L1 = - L
        NSJ = INTSPH(L0,ITs)
      ENDIF
C
C     Il vettore P indica la posizione del vertice rispetto al centro
C     della sfera NSJ
      P(1) = VERT(1,L1,ITs) - Sphere(1,NSJ)
      P(2) = VERT(2,L1,ITs) - Sphere(2,NSJ)
      P(3) = VERT(3,L1,ITs) - Sphere(3,NSJ)
C
C     Trova il versore tangente al lato L0-L1 se stiamo considerando il
C     primo vertice, L2-L1 se consideriamo il secondo
      IF(L.GT.0) THEN
      DO 2000 JJ = 1, 3
        P1(JJ) = VERT(JJ,L1,ITs) - CENTR(JJ,L0,ITs)
        P2(JJ) = VERT(JJ,L0,ITs) - CENTR(JJ,L0,ITs)
 2000 continue
      ELSE
      DO 2010 JJ = 1, 3
        P1(JJ) = VERT(JJ,L1,ITs) - CENTR(JJ,L1,ITs)
        P2(JJ) = VERT(JJ,L2,ITs) - CENTR(JJ,L1,ITs)
 2010 continue
      ENDIF
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2020 JJ = 1, 3
        P2(JJ) = P3(JJ)
 2020 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2030 JJ = 1, 3
        P3(JJ) = P3(JJ) / DNORM3
 2030 continue
C     Trova la derivata
      PROD = P(1)*P3(1) + P(2)*P3(2) + P(3)*P3(3)
      If(IOpt.eq.0) Then
        IF(PROD.EQ.ZERO.AND.P(IC).NE.ZERO) then
          write(6,'("Stop in DVer.")')
          Call Abend()
        EndIf
        IF(PROD.EQ.ZERO) PROD = 1.D0
        FACT = P(IC) / PROD
      Else If(IOpt.eq.1) Then
        IF(PROD.EQ.ZERO) then
          write(6,'("Stop in DVer.")')
          Call Abend()
        EndIf
        FACT = Sphere(4,NSJ) / PROD
      Else
        FACT = 0.0D0
        write(6,'("Illegal IOpt in DVer.")')
        Call Abend()
      EndIf
      DX = FACT * P3(1)
      DY = FACT * P3(2)
      DZ = FACT * P3(3)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(nTs)
      END
*
      SUBROUTINE DerPhi(IOpt,IC,NESFJ,ITS,L1,L2,DP,DA,
     $                  Vert,Centr,nTs,Sphere,IntSph,ISphe)
      IMPLICIT REAL*8 (A-H,O-Z)
      Parameter (MxVert=20)
      Dimension Sphere(4,*),ISphe(*),IntSph(MxVert,*)
      Dimension Vert(3,MxVert,*),Centr(3,MxVert,*)
      DIMENSION DP(MxVert,3),V1(3),V2(3),T12(3)
      DIMENSION VEC1(3),VEC2(3),VEC3(3),VEC4(3)
      Save Zero, One, Small1
      Data Zero/0.0d0/, One/1.0d0/, Small1/1.d-6/
C
C     Find the derivative of: Phi(L1) Cos[Theta(L1)]
C
C     IOpt = 0 : refers to the L1 side of tessera ITS, knowing the derivatives
C                of the position of the vertices by which is delimited
C
C     IOpt = 1 : refers to the L1 side of tessera ITS wrt the radius of the
C                NSJ sphere knowing the derivatives of the positions of the
C                vertices by which is delimited
C
C     NS1 is the sphere to which the tessera belongs, NS2 is the sphere that
C     creates the side L1 by intersecting NS1
C
      Small = 1.0d-12
      NS1 = ISPHE(ITS)
      NS2 = INTSPH(L1,ITs)
C
C     Finds the coordinates of the vertices wrt the center of the circle on
C     which is the arc L1 and the radius of the circle
C
      DO 2000 JJ = 1, 3
        V1(JJ) = VERT(JJ,L1,ITs) - CENTR(JJ,L1,ITs)
        V2(JJ) = VERT(JJ,L2,ITs) - CENTR(JJ,L1,ITs)
 2000 continue
      RC2 = V1(1)**2 + V1(2)**2 + V1(3)**2
      PROD = V1(1)*V2(1) + V1(2)*V2(2) + V1(3)*V2(3)
      COSPHI = PROD / RC2
C
C     If the tessera is intersected very near its vertex the numerical
C     approximation could lead to PROD>RC2 and COSPHI>1. Avoid this by:
C
      Delta = 1.d-12
      If(Abs(CosPhi).gt.One) CosPhi = Sign(One-Delta,CosPhi)
      SENPHI = SQRT(One - COSPHI*COSPHI)
C
C     Compute the derivative of Phi(L1)
C
      DO 2010 JJ = 1, 3
      VEC1(JJ) = V1(JJ) - COSPHI*V2(JJ)
      VEC2(JJ) = DP(L2,JJ)
      VEC3(JJ) = V2(JJ) - COSPHI*V1(JJ)
      VEC4(JJ) = DP(L1,JJ)
 2010 continue
C
C     If the side is just that created by the moving sphere some components
C     are corrected
C     IOpt = 0: due to the derivative of the distance between sphere centers
C     IOpt = 1: due to the derivative of the radius of sphere NESFJ
C
      IF(NS2.EQ.NESFJ) THEN
        T12(1) = Sphere(1,NESFJ) - Sphere(1,NS1)
        T12(2) = Sphere(2,NESFJ) - Sphere(2,NS1)
        T12(3) = Sphere(3,NESFJ) - Sphere(3,NS1)
        DIST2 = T12(1)*T12(1) + T12(2)*T12(2) + T12(3)*T12(3)
        If(IOpt.eq.0) Then
          FACT = (Sphere(4,NS1)**2 - Sphere(4,NESFJ)**2 + DIST2)
     $         / (2.d0 * DIST2)
          VEC2(IC) = VEC2(IC) - FACT
          VEC4(IC) = VEC4(IC) - FACT
        Else If(IOpt.eq.1) Then
            DO 2020 JJ = 1, 3
              VEC2(JJ) = VEC2(JJ) + Sphere(4,NESFJ) * T12(JJ) / DIST2
              VEC4(JJ) = VEC4(JJ) + Sphere(4,NESFJ) * T12(JJ) / DIST2
 2020 continue
        Else
          write(6,'("Illegal IOpt in DerPhi.")')
          Call Abend()
        EndIf
      ENDIF
C
      DPHI = 0.D0
      DO 2030 JJ = 1, 3
        DPHI = DPHI - (VEC1(JJ)*VEC2(JJ)+VEC3(JJ)*VEC4(JJ))
 2030 continue
      If(Abs(SenPhi).lt.Small) then
        If(Abs(DPhi).gt.Small1) then
          write(6,'("SenPhi small but not DPhi in DerPhi.")')
          Call Abend()
        EndIf
        DPhi = Zero
      else
        DPHI = DPHI / (RC2*SENPHI)
        endIf
C
C     Compute the cosine of the polar angle
C
      DNORM1 = 0.D0
      DNORM2 = 0.D0
      V1(1) = VERT(1,L1,ITs) - Sphere(1,NS1)
      V1(2) = VERT(2,L1,ITs) - Sphere(2,NS1)
      V1(3) = VERT(3,L1,ITs) - Sphere(3,NS1)
      V2(1) = Sphere(1,NS2) - Sphere(1,NS1)
      V2(2) = Sphere(2,NS2) - Sphere(2,NS1)
      V2(3) = Sphere(3,NS2) - Sphere(3,NS1)
      DO 2040 JJ = 1, 3
        DNORM1 = DNORM1 + V1(JJ)*V1(JJ)
        DNORM2 = DNORM2 + V2(JJ)*V2(JJ)
 2040 continue
      DNORM1 = SQRT(DNORM1)
      DNORM2 = SQRT(DNORM2)
      COSTH=(V1(1)*V2(1)+V1(2)*V2(2)+V1(3)*V2(3)) / (DNORM1*DNORM2)
C
C     If the side is not that formed by the moving sphere the derivative of
C     the polar angle vanishes
C
      DCOS = 0.D0
      IF(NS2.NE.NESFJ) GOTO 100
C
C     Otherwise:
C
      DO 2050 JJ = 1, 3
      DCOS = DCOS + V2(JJ) * DP(L1,JJ)
 2050 continue
      If(IOpt.eq.0) DCOS = DCOS + V1(IC) -
     $                     Sphere(4,NS1)*COSTH*V2(IC)/DNORM2
      DCOS = DCOS / ( Sphere(4,NS1) * DNORM2 )
 100  CONTINUE
      DA = COSTH * DPHI + ACOS(COSPHI) * DCOS
      DA = Sphere(4,NS1) * Sphere(4,NS1) * DA
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(nTs)
      END
*
      SUBROUTINE DerBet(IOpt,IC,NSFE,ITS,L0,L1,L2,DP,DA,
     $                  Vert,Centr,nTs,Sphere,IntSph,ISphe)
      IMPLICIT REAL*8 (A-H,O-Z)
      Parameter (MxVert=20)
      Dimension Sphere(4,*),ISphe(*),IntSph(MxVert,*)
      Dimension Vert(3,MxVert,*),Centr(3,MxVert,*)
      DIMENSION DP(MxVert,3)
      DIMENSION V1(3),V2(3),V3(3),V4(3),DV1(3),DV2(3),DV3(3),DV4(3)
      DIMENSION P1(3),P2(3),P3(3),T0(3),T1(3),T12(3),DT0(3),DT1(3)
C
C     Trova la derivata dell'angolo esterno del vertice L1 della tessera
C     ITS, formato dai lati L0-L1 e L1-L2,
C
C     IOpt = 0 : rispetto alla coordinata IC (ex derbeta)
C     IOpt = 1 : rispetto al raggio (ex derbeta1)
C
C     della sfera NSFE, conoscendo la derivata della posizione del vertice P1.
C
      PI   = 4.0d0*ATan(1.0d0)
      NS1 = ISPHE(ITS)
      NS2 = INTSPH(L0,ITs)
      NS3 = INTSPH(L1,ITs)
C
C     Trova i vettori posizione dei vertici L0, L1 rispetto al centro
C     dell'arco L0, e dei vertici L1, L2 rispetto al centro dell'arco L1
      DO 2000 JJ = 1, 3
        V1(JJ) = VERT(JJ,L0,ITs) - CENTR(JJ,L0,ITs)
        V2(JJ) = VERT(JJ,L1,ITs) - CENTR(JJ,L0,ITs)
        V3(JJ) = VERT(JJ,L1,ITs) - CENTR(JJ,L1,ITs)
        V4(JJ) = VERT(JJ,L2,ITs) - CENTR(JJ,L1,ITs)
 2000 continue
C     Trova la derivata dei vettori posizione
      DO 2010 JJ = 1, 3
        DV1(JJ) = DP(L0,JJ)
        DV2(JJ) = DP(L1,JJ)
        DV3(JJ) = DP(L1,JJ)
        DV4(JJ) = DP(L2,JJ)
 2010 continue
C
C     Corregge la derivata dei vettori posizione se il lato considerato
C     appartiene alla sfera che si muove (distinguendo se ITS appartiene
C     o no alla sfera che si muove)
      INDEX = 0
      IF(NS1.EQ.NSFE.AND.NS2.NE.NSFE) INDEX = 1
      IF(NS1.NE.NSFE.AND.NS2.EQ.NSFE) INDEX = 1
      IF(INDEX.EQ.1) THEN
        T12(1) = Sphere(1,NS2) - Sphere(1,NS1)
        T12(2) = Sphere(2,NS2) - Sphere(2,NS1)
        T12(3) = Sphere(3,NS2) - Sphere(3,NS1)
        DIST2 = T12(1)*T12(1) + T12(2)*T12(2) + T12(3)*T12(3)
        If(IOpt.eq.0) Then
          DO 2020 JJ = 1, 3
            DV1(JJ) = DV1(JJ) + (Sphere(4,NS1)**2 - Sphere(4,NS2)**2) *
     %                T12(IC) * T12(JJ) / (DIST2*DIST2)
            DV2(JJ) = DV2(JJ) + (Sphere(4,NS1)**2 - Sphere(4,NS2)**2) *
     %                T12(IC) * T12(JJ) / (DIST2*DIST2)
 2020 continue
          FACT = (Sphere(4,NS1)**2-Sphere(4,NS2)**2+DIST2)
     $         / (2.D0*DIST2)
          DV1(IC) = DV1(IC) - FACT
          DV2(IC) = DV2(IC) - FACT
        Else If(IOpt.eq.1) Then
          DO 2030 JJ = 1, 3
            DV1(JJ) = DV1(JJ) + Sphere(4,NS2) * T12(JJ) / DIST2
            DV2(JJ) = DV2(JJ) + Sphere(4,NS2) * T12(JJ) / DIST2
 2030 continue
        Else
          write(6,'("Illegal IOpt in DerBet.")')
          Call Abend()
        EndIf
      ENDIF
C
      INDEX = 0
      IF(NS1.EQ.NSFE.AND.NS3.NE.NSFE) INDEX = 1
      IF(NS1.NE.NSFE.AND.NS3.EQ.NSFE) INDEX = 1
      IF(INDEX.EQ.1) THEN
        T12(1) = Sphere(1,NS3) - Sphere(1,NS1)
        T12(2) = Sphere(2,NS3) - Sphere(2,NS1)
        T12(3) = Sphere(3,NS3) - Sphere(3,NS1)
        DIST2 = T12(1)*T12(1) + T12(2)*T12(2) + T12(3)*T12(3)
        If(IOpt.eq.0) Then
          DO 2040 JJ = 1, 3
            DV3(JJ) = DV3(JJ) + (Sphere(4,NS1)**2 - Sphere(4,NS3)**2) *
     %                T12(IC) * T12(JJ) / (DIST2*DIST2)
            DV4(JJ) = DV4(JJ) + (Sphere(4,NS1)**2 - Sphere(4,NS3)**2) *
     %                T12(IC) * T12(JJ) / (DIST2*DIST2)
 2040 continue
          FACT = (Sphere(4,NS1)**2-Sphere(4,NS3)**2+DIST2)
     $         / (2.D0*DIST2)
          DV3(IC) = DV3(IC) - FACT
          DV4(IC) = DV4(IC) - FACT
        Else If(IOpt.eq.1) Then
          DO 2050 JJ = 1, 3
            DV3(JJ) = DV3(JJ) + Sphere(4,NS3) * T12(JJ) / DIST2
            DV4(JJ) = DV4(JJ) + Sphere(4,NS3) * T12(JJ) / DIST2
 2050 continue
        Else
          write(6,'("Illegal IOpt in DerBet.")')
          Call Abend()
        EndIf
      ENDIF
C
C     Trova il vettore tangente al lato L0-L1: T0 = V2 x (V2 x V1)
      DO 2060 JJ = 1, 3
        P1(JJ) = V2(JJ)
        P2(JJ) = V1(JJ)
 2060 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2070 JJ = 1, 3
        P2(JJ) = P3(JJ)
 2070 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2080 JJ = 1, 3
        T0(JJ) = P3(JJ)
 2080 continue
      dnxxt0 = DNORM3
C     Trova il vettore tangente al lato L1-L2: T1 = V3 x (V3 x V4)
      DO 2090 JJ = 1, 3
        P1(JJ) = V3(JJ)
        P2(JJ) = V4(JJ)
 2090 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2100 JJ = 1, 3
        P2(JJ) = P3(JJ)
 2100 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2110 JJ = 1, 3
        T1(JJ) = P3(JJ)
 2110 continue
      dnxxt1 = DNORM3
C
C     Trova l'angolo Beta(L1)
      PROD = T0(1)*T1(1) + T0(2)*T1(2) + T0(3)*T1(3)
      BETA = PI - ACOS( PROD / (dnxxt0*dnxxt1) )
      COSBETA = cos(BETA)
      SENBETA = Sin(BETA)
C
C     Trova la derivata della tangente T0 :
C     DT0 = DV2 x (V2 x V1) + V2 x (DV2 x V1) + V2 x (V2 x DV1)
C
      DO 2120 JJ = 1, 3
        DT0(JJ) = 0.D0
 2120 continue
C
      DO 2130 JJ = 1, 3
        P1(JJ) = V2(JJ)
        P2(JJ) = V1(JJ)
 2130 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2140 JJ = 1, 3
        P1(JJ) = DV2(JJ)
        P2(JJ) = P3(JJ)
 2140 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2150 JJ = 1, 3
        DT0(JJ) = DT0(JJ) + P3(JJ)
 2150 continue
C
      DO 2160 JJ = 1, 3
        P1(JJ) = DV2(JJ)
        P2(JJ) = V1(JJ)
 2160 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2170 JJ = 1, 3
        P1(JJ) = V2(JJ)
        P2(JJ) = P3(JJ)
 2170 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2180 JJ = 1, 3
        DT0(JJ) = DT0(JJ) + P3(JJ)
 2180 continue
C
      DO 2190 JJ = 1, 3
        P1(JJ) = V2(JJ)
        P2(JJ) = DV1(JJ)
 2190 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2200 JJ = 1, 3
        P1(JJ) = V2(JJ)
        P2(JJ) = P3(JJ)
 2200 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2210 JJ = 1, 3
        DT0(JJ) = DT0(JJ) + P3(JJ)
 2210 continue
C
C     Trova la derivata della tangente T1 :
C     DT1 = DV3 x (V3 x V4) + V3 x (DV3 x V4) + V3 x (V3 x DV4)
C
      DO 2220 JJ = 1, 3
        DT1(JJ) = 0.D0
 2220 continue
C
      DO 2230 JJ = 1, 3
        P1(JJ) = V3(JJ)
        P2(JJ) = V4(JJ)
 2230 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2240 JJ = 1, 3
        P1(JJ) = DV3(JJ)
        P2(JJ) = P3(JJ)
 2240 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2250 JJ = 1, 3
        DT1(JJ) = DT1(JJ) + P3(JJ)
 2250 continue
C
      DO 2260 JJ = 1, 3
        P1(JJ) = DV3(JJ)
        P2(JJ) = V4(JJ)
 2260 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2270 JJ = 1, 3
        P1(JJ) = V3(JJ)
        P2(JJ) = P3(JJ)
 2270 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2280 JJ = 1, 3
        DT1(JJ) = DT1(JJ) + P3(JJ)
 2280 continue
C
      DO 2290 JJ = 1, 3
        P1(JJ) = V3(JJ)
        P2(JJ) = DV4(JJ)
 2290 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2300 JJ = 1, 3
        P1(JJ) = V3(JJ)
        P2(JJ) = P3(JJ)
 2300 continue
      CALL VECP(P1,P2,P3,DNORM3)
      DO 2310 JJ = 1, 3
        DT1(JJ) = DT1(JJ) + P3(JJ)
 2310 continue
C
C     Infine calcola la derivata dell'angolo Beta(L1)
      DO 2320 JJ = 1, 3
        P1(JJ) = T1(JJ) + COSBETA * dnxxt1 * T0(JJ) / dnxxt0
        P2(JJ) = T0(JJ) + COSBETA * dnxxt0 * T1(JJ) / dnxxt1
 2320 continue
      DO 2330 JJ = 1, 3
        DBETA = 0.D0
 2330 continue
      DO 2340 JJ = 1, 3
        DBETA = DBETA + ( P1(JJ) * DT0(JJ) + P2(JJ) * DT1(JJ) )
 2340 continue
      DBETA = DBETA / ( SENBETA * dnxxt0 * dnxxt1 )
      DA = Sphere(4,NS1) * Sphere(4,NS1) * DBETA
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(nTs)
      END
*
      Function iRToInt(r)
      implicit real*8 (a-h, o-z)
c
c     floating to integer conversion.
c
      iRToInt = int(r)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_W2p (W2)
c
c        test W2+
c
        implicit none
#include "chcc1.fh"
        real*8 W2(1:nv,1:nv*(nv+1)/2)
        integer a,be,ga,bega,bad
        real*8 s
c
        bad=0
c
          bega=0
          do be=1,nv
          do ga=1,be
          bega=bega+1
c
            do a=1,nv
c
            s=Q4(a,ga,a,be)/2
            if (abs(W2(a,bega)-s).gt.1.0d-10) then
              bad=bad+1
            end if
            W2(a,bega)=s
c
            end do
c
          end do
          end do
c
        write (6,*) ' W2+ chck ',bad
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine RInt_ns(rkappa,rmo,Fock,Focki,idsym,reco,jspin,rie)
*                              ~
*     Constructs  F  = <0|[E  ,H]|0>
* added in rinttd ( + <0|[[E  , Kappa],H]|0> )
*                  pq       pq                 pq
*
* Some modifications (subroutines that ends with _ns) to handle
* non anti-symmetric orbital rotations.
* Instead of using Q-Q^t as the "Q" contribution to the gradient
* Q^A-Q^{Bt} is used (see the paper). Major modifications in read2.
* Instead of constructing one set of MO integrals/particle we construct
* one set of integrals used for constructing Q^A and one for Q^B
*
c
c Fock is E*d/dx(lambda)
c rkappa is d/dx(lambda)
c
      use Arrays, only: G2sq, G1t
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
#include "real.fh"
#include "stdalloc.fh"
      Real*8 Fock(nDens2),rkappa(nDens2),
     &       Focki(ndens2),rMO(*)
      Real*8, Allocatable:: FA(:), MT1(:), MT2(:), QA(:), QB(:)
*
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
      Call mma_allocate(FA,ndens2,Label='FA')
c Fact controls the sign of H(k)
      Fact=One
      Call mma_allocate(MT1,nmba,Label='MT1')
      Call mma_allocate(MT2,nmba,Label='MT2')
      MT1(:) = Zero
      MT2(:) = Zero

      Call R2ElInt_ns(rkappa,MT1,MT2,focki,FA,
     &             nDens2,idSym,ReCo,Fact,jspin)
C
      If (.false.) Then  !If (idsym.eq.2) Then
      jpCMO=1
       Do iSym=1,nSym
            Write(6,'(A,i2.2)') 'Inactive fackmatrix = ',iSym
            Call RecPrt(' ' ,' ',focki(jpCMO),nBas(iSym),nBas(iSym))
            jpCMO=jpCMO+nBas(iSym)*nBas(iSym)
       End do
       jpCMO=1
       Do  iSym=1,nSym
            Write(6,'(A,i2.2)') 'Active fockmatrix     = ',iSym
            Call RecPrt(' ' ,' ',FA(jpCMO),nBas(iSym),nBas(iSym))
            jpCMO=jpCMO+nBas(iSym)*nBas(iSym)
       end do
      End If
C

      Fock(:) = Zero
*
*     Q  = sum(jkl)=(pj|kl)d(ijkl)
*      pi
*
      If (iMethod.eq.2) Then
       Call mma_allocate(qA,ndens2,Label='QA')
       Call mma_allocate(qB,ndens2,Label='QB')
       Call CreQ_td(QB,MT1,G2sq,idsym)
       Call CreQ_td(QA,MT2,G2sq,idsym)
      End If
*
*      Call RECPRT('QB',' ',QB,nDens2,1)
*      Call RECPRT('QA',' ',QA,nDens2,1)
*
      Do iS=1,nSym
       jS=iEOr(iS-1,idsym-1)+1
*
*            I    A
*      F  =2( F  + F  )
*       pi     pi   pi
*
       Call DGEADD2(Two,
     &              Focki(ipMat(is,js)),nBas(is),'N',
     &              Fock(ipMat(is,js)),nBas(is),'N',
     %              Fock(ipMat(is,js)),nBas(is),
     &              nbas(is),nish(js))
       Call DGEADD2(-Two,
     &             Focki(ipMat(is,js)),nBas(is),'N',
     &             Fock(ipMat(is,js)),nBas(is),'N',
     %             Fock(ipMat(is,js)),nBas(is),
     &             nish(is),nBas(js))
       If (iMethod.eq.2) Then
c
c 61-121 is all to do with multiconf
c
       Call DGEADD2(Two,
     &              FA(ipMat(is,js)),nBas(is),'N',
     &              Fock(ipMat(is,js)),nBas(is),'N',
     %              Fock(ipMat(is,js)),nBas(is),
     &              nbas(is),nIsh(js))
       Call DGEADD2(-Two,
     &             FA(ipMat(is,js)),nBas(is),'N',
     &             Fock(ipMat(is,js)),nBas(is),'N',
     %             Fock(ipMat(is,js)),nBas(is),
     &             nish(is),nBas(js))

       Do iAsh=1,nAsh(jS)
        Do jAsh=1,nAsh(js)

*                I
*        F  = F - F  D
*         ap   ap  ap ba
*
          Dij=G1t(itri(iash+nA(js),jAsh+nA(js)))
          ipF= ipMat(is,js)+(Nish(js)+iAsh-1)*nBas(is)
          ipFI=ipMat(is,js)+(Nish(js)+jAsh-1)*nBas(is)
*
*                I
*        F  = F + F  D
*         pa   pa  pb ab
*
          Call DaXpY_(nBas(is),Dij,
     &               focki(ipFI),1,
     &               Fock(ipF),1)
        End Do
       End Do
       Do iAsh=1,nAsh(iS)
        Do jAsh=1,nAsh(is)
         ipF=ipMat(is,js)+nIsh(is)+jAsh-1
         ipFI=ipMat(is,js)+nIsh(is)+iAsh-1
         Dij=G1t(itri(iash+nA(is),jAsh+nA(is)))

*
*                I
*        F  = F - F  D
*         pa   pa  pb ab
*
          Call DaXpY_(nBas(js),-Dij,
     &               focki(ipFI),nbas(is),
     &               Fock(ipF),nbas(is))
        End Do
       End Do

       Call DGEADD(Fock(ipMat(is,js)+nbas(is)*nish(js)),nBas(is),'N',
     &              QB(ipMatba(is,js)),nBas(is),'N',
     %              Fock(ipMat(is,js)+nbas(is)*nish(js)),nBas(is),
     &              nBas(is),nAsh(js))
       Call DGESUB(Fock(ipMat(is,js)+nish(is)),nBas(is),'N',
     &              QA(ipMatba(js,is)),nBas(js),'T',
     %              Fock(ipMat(is,js)+nish(is)),nBas(is),
     &              nash(is),nBas(js))
      End If
* Transpose ipsc2
*     Call mma_allocate(T,nbas(is)*nbas(jS),Label='T')
*     call dcopy_(nbas(is)*nbas(jS),[0.0d0],0,T,1)
*     Call DGETMO(Fock(ipmat(is,js)),nbas(is),
*    &                nbas(is),nbas(js),T,
*    &                nbas(js))
*     call dcopy_(nBas(jS)*nBas(iS),T,1,Fock(ipmat(js,is)),1)
*     Call mma_deallocate(T)
*
      End Do
      If (imethod.eq.2) Then
         Call mma_deallocate(QA)
         Call mma_deallocate(QB)
      End If
*
      Call DSCAL_(ndens2,-Two,fock,1)
      Call AddGrad(rKappa,Fock,idsym,Two*(-fact))
      Call PickMO_td(MT1,rmo,idsym)
*
      Call mma_deallocate(MT2)
      Call mma_deallocate(MT1)
      Call mma_deallocate(FA)
*
      return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(rie)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2007, Roland Lindh                                *
!***********************************************************************

subroutine PGet2_RI3(iCmp,jBas,kBas,lBas,iAO,iAOst,nijkl,PSO,nPSO,DSO,nDSO,ExFac,CoulFac,PMax,V_k,mV_k,ZpK,nSA,nAct)
!***********************************************************************
!  Object: to assemble the 2nd order density matrix of a SCF wave      *
!          function from the 1st order density matrix.                 *
!                                                                      *
!          The indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             January '92.                                             *
!                                                                      *
!             Modified for 3-center RI gradients, March 2007           *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use SOAO_Info, only: iAOtSO
use pso_stuff, only: AOrb, lPSO, nnP, Thpkl
use Basis_Info, only: nBas, nBas_Aux
use Symmetry_Info, only: Mul, nIrrep
use RI_glob, only: BklK, CijK, CilK, CMOi, iAdrCVec, iOff_Ymnij, LuCVector, nAvec, nChOrb, nIJR, nYmnij, tbvec, Yij, Ymnij
use Constants, only: Zero, One, Half, Quart
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: iCmp(4), jBas, kBas, lBas, iAO(4), iAOst(4), nijkl, nPSO, nDSO, mV_k, nSA, nAct(0:7)
real(kind=wp), intent(out) :: PSO(nijkl,nPSO), PMax
real(kind=wp), intent(in) :: DSO(nDSO,nSA), ExFac, CoulFac, V_k(mV_k,nSA), Zpk(*)
integer(kind=iwp) :: i, i2, i3, i4, iAdr, ij, ik, il, imo, iMO1, iMO2, Indkl, iSO, iThpkl, iVec, j, j2, j23, j3, j4, jAOj, jC, &
                     jmo, jp, js, jSO, jSO_off, jSOj, jSym(0:7), k, kAct, kAOk, kmo, ks, kSO, kSOk, kSym(0:7), l, lAct, lAOl, &
                     lCVec, lda, lmo, lOper, ls, lSO, lSOl, lSym(0:7), MemSO2, mijkl, n2j, nCumnnP(0:7), nCumnnP2(0:7), nJ, njSym, &
                     nk, nkSym, nl, nlSym, ntmp
real(kind=wp) :: Cpu, Cpu1, Cpu2, ExFac_, Fac, temp, tmp, Wall, Wall1, Wall2
real(kind=wp), pointer :: Xki(:), Xli(:)
integer(kind=iwp), external :: iPntSO
real(kind=r8), external :: ddot_

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
iComp = 1
call PrMtrx(' In PGET_RI3:DSO ',[iD0Lbl],iComp,1,D0)
call RecPrt('V_K',' ',V_K,1,mV_K)
write(u6,*)
write(u6,*) 'Distribution of Ymnij'
do iSym=1,nIrrep
  if (nYmnij(iSym,1) > 0) then
    write(u6,*) 'iSym=',iSym
    do i=iOff_Ymnij(iSym,1)+1,iOff_Ymnij(iSym,1)+nYmnij(iSym,1)
      write(u6,*) 'Ymnij=',Ymnij(1)%A(i)
    end do
  end if
end do
write(u6,*) 'jbas,kbas,lbas=',jBas,kBas,lBas
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(Cpu1,Wall1)

Fac = Quart
lOper = 1
PMax = Zero
iSO = 1
PSO(:,:) = Zero

if (lPSO) then
  nCumnnP(0) = 0
  nBas_Aux(0) = nBas_Aux(0)-1
  do i=1,nIrrep-1
    nCumnnP(i) = nCumnnP(i-1)+nnP(i-1)*nBas_Aux(i-1)
  end do
  nBas_Aux(0) = nBas_Aux(0)+1
end if

! i2, j2, jBas: auxiliary basis
! i3, j3, kBas: valence basis
! i4, j4, lBas: valence basis
!
! Note when j2 is symmetric then we can have both Coulomb and
! exchange contributions, while for j2 asymmetric we will
! only have exchange contributions

MemSO2 = 0
do i2=1,iCmp(2)
  njSym = 0
  do j=0,nIrrep-1
    if (iAOtSO(iAO(2)+i2,j) > 0) then
      jSym(njSym) = j
      njSym = njSym+1
    end if
  end do
  do i3=1,iCmp(3)
    nkSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(3)+i3,j) > 0) then
        kSym(nkSym) = j
        nkSym = nkSym+1
      end if
    end do
    do i4=1,iCmp(4)
      nlSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(4)+i4,j) > 0) then
          lSym(nlSym) = j
          nlSym = nlSym+1
        end if
      end do

      ! Loop over irreps which are spanned by the basis function.

      do js=0,njSym-1
        j2 = jSym(js)
        !nJ = nChOrb(j2,iSO)
        nJ = jBas

        if (lPSO) then
          ntmp = 0
          do j4=0,nIrrep-1
            j3 = Mul(j4+1,j2+1)-1
            if (j3 <= j4) nCumnnP2(j3) = ntmp
            if (j3 == j4) ntmp = ntmp+nTri_Elem(nAct(j3))
            if (j3 < j4) ntmp = ntmp+nAct(j3)*nAct(j4)
          end do
          do j4=0,nIrrep-1
            j3 = Mul(j4+1,j2+1)-1
            if (j3 > j4) nCumnnP2(j3) = nCumnnP2(j4)
          end do
        end if

        do ks=0,nkSym-1
          j3 = kSym(ks)
          j23 = Mul(j2+1,j3+1)-1
          nk = nYmnij(j3+1,1)
          kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)

          ! Pointers to the full list of the X_mu,i elements
          ! Note this list runs over all basis functions mu
          ! (kBas*iCmp(3)). Here we only want to pick up the
          ! subblock for a fixed iCmp(3) value.

          if ((nk < nChOrb(j3,iSO)) .and. (ExFac /= Zero) .and. (nk > 0)) then

            ! Offset to where the block starts (jbas,kbas,i3)

            lda = size(CMOi(1)%SB(j3+1)%A2,1)
            ik = 1+lda*(kSO-1)
            Xki(1:) => CMOi(1)%SB(j3+1)%A1(ik:)

            ! Loop over the auxiliary basis functions which has
            ! significant contributions to the k shell.

            imo = 1
            do k=1,nk
              kmo = Ymnij(1)%A(k+iOff_Ymnij(j3+1,1))

              call dcopy_(kBas,Xki(kmo:),nChOrb(j3,iSO),Yij(imo,1,1),nk)

              imo = imo+1
            end do
            ! Reset pointers
            Xki(1:nk*kBas) => Yij(1:nk*kBas,1,1)
            !call RecPrt('X(i,mu)C',' ',Xki,nk,kBas)
          else if ((ExFac /= Zero) .and. (nk > 0)) then
            lda = size(CMOi(1)%SB(j3+1)%A2,1)
            ik = 1+lda*(kSO-1)
            Xki(1:) => CMOi(1)%SB(j3+1)%A1(ik:)
            !call RecPrt('X(i,mu)R',' ',Xki,nk,kBas)
          else
            nullify(Xki)
          end if

          do ls=0,nlSym-1
            j4 = lSym(ls)
            if (j23 /= j4) cycle
            nl = nYmnij(j4+1,1)
            lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)

            ! Pointers to the full list of the X_mu,i elements

            if ((nl < nChOrb(j4,iSO)) .and. (ExFac /= Zero) .and. (nl > 0)) then

              lda = size(CMOi(1)%SB(j4+1)%A2,1)
              il = 1+lda*(lSO-1)
              Xli(1:) => CMOi(1)%SB(j4+1)%A1(il:)
              imo = 1
              do l=1,nl
                lmo = Ymnij(1)%A(l+iOff_Ymnij(j4+1,1))

                call dcopy_(lBas,Xli(lmo:),nChOrb(j4,iSO),Yij(imo,2,1),nl)

                imo = imo+1
              end do
              ! Reset pointers
              Xli(1:nl*lBas) => Yij(1:nl*lBas,2,1)
              !call RecPrt('X(j,nu)C',' ',Xli,nl,lBas)
            else if ((ExFac /= Zero) .and. (nl > 0)) then
              lda = size(CMOi(1)%SB(j4+1)%A2,1)
              il = 1+lda*(lSO-1)
              Xli(1:) => CMOi(1)%SB(j4+1)%A1(il:)
              !call RecPrt('X(j,nu)R',' ',Xli,nl,lBas)
            else
              nullify(Xli)
            end if

            MemSO2 = MemSO2+1

            jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
            jSO_off = jSO-nBas(j2)

            ExFac_ = ExFac
            if (nJ*nk*nl == 0) ExFac_ = Zero
            !                                                          *
            !***********************************************************
            !                                                          *
            ! Read a block of C_kl^J and transform it to AO basis.

            if (ExFac_ /= Zero) then

              ! Read C(i,j,J) for a fix i2 value

              lCVec = nIJR(j3+1,j4+1,iSO)*jBas
              iAdr = iAdrCVec(j2+1,j3+1,1)+nIJR(j3+1,j4+1,iSO)*(jSO_Off-1)
              call dDaFile(LuCVector(j2+1,1),2,Cijk,lCVec,iAdr)
              !call RecPrt('C(ij,K)',' ',CijK,nIJR(j3+1,j4+1,iSO),jBas)

              ! Extract only those C_kl^Js for which we deem k and l
              ! to belong to the shell-pair and to be of
              ! significance. Use temporary memory location at CilK.

              if (nk*nl < nChOrb(j3,iSO)*nChOrb(j4,iSO)) then
                ij = 1
                do j=1,nl
                  jmo = Ymnij(1)%A(j+iOff_Ymnij(j4+1,1))
                  do i=1,nk
                    imo = Ymnij(1)%A(i+iOff_Ymnij(j3+1,1))

                    jC = imo+nChOrb(j3,iSO)*(jmo-1)

                    ! For this particular ij combination pick the whole row.

                    call dcopy_(jBas,CijK(jC),nChOrb(j3,iSO)*nChOrb(j4,iSO),CilK(ij),nk*nl)
                    ij = ij+1
                  end do
                end do

                ! Copy back to original memory position.

                n2j = nk*nl*jBas
                CijK(1:n2j) = CilK(1:n2j)
              end if

              ! Transform according to Eq. 16 (step 4) and
              ! generate B_kl^J. This is a transformation from
              ! the MO basis, ij, to the AO basis mn.

              ! E(jK,m) = Sum_i C(i,jK)' * X(i,m)

              call dGEMM_('T','N',nl*jBas,kBas,nk,One,CijK,nk,Xki,nk,Zero,CilK,nl*jBas)

              ! B(Km,n) = Sum_j E(j, Km)' * X(j,n)

              call dGEMM_('T','N',jBas*kBas,lBas,nl,One,CilK,nl,Xli,nl,Zero,BklK,jBas*kBas)

            end if
            !                                                          *
            !***********************************************************
            !                                                          *
            ! Active term (CASSCF and SA-CASSCF)

            if (lPSO) then
              Thpkl(1:jBas*kBas*lBas) = Zero
              if (nAct(j3)*nAct(j4) /= 0) then
                do iVec=1,nAVec
                  iMO1 = 1
                  iMO2 = 1
                  if (iVec == 2) iMO2 = 2
                  if (iVec == 4) then
                    iMO1 = 2
                  end if

                  do jAOj=0,jBas-1
                    jSOj = jSO+jAOj-nBas(j2)
                    jp = nCumnnP(j2)+(jSOj-1)*nnP(j2)+nCumnnP2(j3)
                    do lAOl=0,lBas-1
                      lSOl = lSO+lAOl

                      if (j3 == j4) then
                        do kAct=1,nAct(j3)
                          ! Zpk(*,iVec)
                          tmp = ddot_(kAct,Zpk(jp+iTri(kAct,1)),1,AOrb(iMO1)%SB(j4+1)%A2(:,lSOl),1)
                          do lAct=kAct+1,nAct(j4)
                            tmp = tmp+Zpk(jp+iTri(lAct,kAct))*AOrb(iMO1)%SB(j4+1)%A2(lAct,lSOl)
                          end do
                          Cilk(kAct) = tmp
                        end do
                      else
                        if (j3 < j4) then
                          call dGeMV_('N',nAct(j3),nAct(j4),One,Zpk(jp+1),nAct(j3),AOrb(iMO1)%SB(j4+1)%A2(:,lSOl),1,Zero,CilK,1)
                        else
                          call dGeMV_('T',nAct(j4),nAct(j3),One,Zpk(jp+1),nAct(j4),AOrb(iMO1)%SB(j4+1)%A2(:,lSOl),1,Zero,CilK,1)
                        end if
                      end if

                      iThpkl = jAOj+lAOl*kBas*jBas+1
                      call dGeMV_('T',nAct(j3),kBas,One,AOrb(iMO2)%SB(j3+1)%A2(:,kSO),nAct(j3),Cilk,1,One,Thpkl(iThpkl),jBas)

                    end do
                  end do
                end do
              end if
            end if

            !                                                          *
            !***********************************************************
            !                                                          *
            if (ExFac_ /= Zero) then
            !                                                          *
            !***********************************************************
            !                                                          *

#             define _EXCHANGE_
              if (j3 /= j4) then
                if (lPSO) then
                  ! Exchange and active contributions
#                 define _ACTIVE_
#                 include "pget2_ri3.fh"
#                 undef _ACTIVE_
                else
                  ! Exchange contribution
#                 include "pget2_ri3.fh"
                end if
              else
#               define _COULOMB_
                if (lPSO) then
                  ! Coulomb, Exchange and active contributions
#                 define _ACTIVE_
#                 include "pget2_ri3.fh"
#                 undef _ACTIVE_
                else
                  ! Coulomb and Exchange contributions
#                 include "pget2_ri3.fh"
                end if
#               undef _COULOMB_
              end if
#             undef _EXCHANGE_
              !                                                        *
              !*********************************************************
              !                                                        *
            else if ((ExFac_ == Zero) .and. (j3 == j4)) then
              !                                                        *
              !*********************************************************
              !                                                        *

#             define _COULOMB_
              if (lPSO) then
                ! Coulomb and active contributions
#               define _ACTIVE_
#               include "pget2_ri3.fh"
#               undef _ACTIVE_
              else
                ! Coulomb only contribution
#               include "pget2_ri3.fh"
              end if
#             undef _COULOMB_
              !                                                        *
              !*********************************************************
              !                                                        *
            end if
            !                                                          *
            !***********************************************************
            !                                                          *

          end do
          nullify(Xki,Xli)
        end do
      end do

    end do
  end do
end do
if (nPSO /= MemSO2) then
  write(u6,*) ' PGET_RI3: nPSO /= MemSO2'
  write(u6,*) nPSO,MemSO2
  call Abend()
end if

#ifdef _DEBUGPRINT_
call RecPrt(' In PGET_RI3:PSO ',' ',PSO,nijkl,nPSO)
#endif

call CWTime(Cpu2,Wall2)
Cpu = Cpu2-Cpu1
Wall = Wall2-Wall1
tbvec(1) = tbvec(1)+Cpu
tbvec(2) = tbvec(2)+Wall

return

end subroutine PGet2_RI3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine pa_pseudo(M,S,dim,iopt,zfin,MF,SF,coord,iprint)
c dim - dimension of the pseuDospin
c M(3,dim,dim) -- magnetic moment in the initial basis
c S(3,dim,dim) -- spin moment in the initial basis
c iopt - option for choosing the quantization axis
c       = 1 : quantization axis is the main magnetic axis of the entire manIfold (dim)
c       = 2 : quantization axis is the main magnetic axis of the ground Doublet (low-lying two states)
c       = 3 : quantization axis is provided by the user by means of coord
c       = 4 : quantization axis is the unit matrix, i.e. the original Z axis
c  coord(3,3): matrix specIfying the rotation of initial coordinate system to the
c              coordinate system of used for determination of the quantization axis
c              by diagonalizing the Zeeman hamiltonian
c zfin - pseuDospin eigenfunctions
c MF(3,dim,dim) -- magnetic moment in the pseuDospin basis
c SF(3,dim,dim) -- spin moment in the pseuDospin basis


      Implicit None

      Integer, parameter :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer            :: dim,info,i,j,k,l,i1,i2,iopt
      Integer            :: iprint
      Real (kind=8) :: gtens(3),w(dim),maxes(3,3),det,FindDetR
      Real (kind=8) :: coord(3,3),coord2(3,3)
      Complex (kind=8) :: M( 3,dim,dim),S( 3,dim,dim),z(dim,dim)
      Complex (kind=8) :: MF(3,dim,dim),SF(3,dim,dim),zfin(dim,dim)
      Complex (kind=8) :: dipso2(3,dim,dim)
      Complex (kind=8) :: s_so2(3,dim,dim)
      Complex (kind=8) :: hzee(dim,dim)
      external FindDetR
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c set to zero important variables:
c  choose the quantization axis:
      If (    iopt .eq. 1 ) Then
        gtens=0.0_wp
        maxes=0.0_wp
        Call atens(M,dim,gtens,maxes,2)

      Else If( iopt .eq. 2 ) Then
        gtens=0.0_wp
        maxes=0.0_wp
        Call atens(M(1:3,1:2,1:2),2,gtens,maxes,2)

      Else If( iopt .eq. 3 ) Then
        Write(6,'(A)') 'User provided the COORD to the PA_PSEUDo:'

      Else If( iopt .eq. 4 ) Then
        Write(6,'(A)') 'COORD is set to unity'
        coord=0.0_wp
        Do i=1,3
        coord(i,i)=1.0_wp
        End Do
      Else
        Write(6,'(A)') 'check the iopt parameter to PA_PSEUDo!!!'
c        Call Abort()
      End If
cccccccccccccccccccccccccccccccccccc
      Write(6,'(A)') 'input "coord" matrix to PA_PSEUDo'
      Do i=1,3
      Write(6,'(3F20.14)') (coord(j,i),j=1,3)
      End Do
c check If "coord" is empty:
      Call rZeroMatrix(coord2,3)
      Do i=1,3
         Do j=1,3
         coord2(i,j)=coord(i,j)
         End Do
      End Do
      det=0.0_wp
      det=FindDetR(coord2,3)
      Write(6,'(A, f20.13)') 'det = ', det
      If ( abs(det-1.0_wp) .lt. 0.0001_wp) Then  ! 'coord is not empty'
      Call rZeroMatrix(maxes,3)
        Do i=1,3
           Do j=1,3
           maxes(i,j)=coord(i,j)
           End Do
        End Do
      Else                                     ! 'coord is empty'
      Call rZeroMatrix(coord,3)
        Do i=1,3
           Do j=1,3
           coord(i,j)=maxes(i,j)
           End Do
        End Do
      End If
      Write(6,'(A)') 'Employed  axes for diagonalization of the '//
     &               'Zeeman Hamiltonian:'
      Do i=1,3
      Write(6,'(3F20.14)') (maxes(j,i),j=1,3)
      End Do

      Call cZeroMoment( s_so2,dim)
      Call cZeroMoment(dipso2,dim)
      Do l=1,3
         Do i=1,dim
            Do j=1,dim
               Do k=1,3
      dipso2(l,i,j) = dipso2(l,i,j) + M(k,i,j) *
     &                          cmplx(maxes(k,l),0.0_wp,wp)
       s_so2(l,i,j) =  s_so2(l,i,j) + S(k,i,j) *
     &                          cmplx(maxes(k,l),0.0_wp,wp)
               End Do
            End Do
         End Do
      End Do

      Call cZeroMatrix(hzee,dim)
      Do i=1,dim
        Do j=1,dim
          hzee(i,j)=hzee(i,j) + (-1.0_wp,0.0_wp)*dipso2(3,i,j)
        End Do
      End Do
      info=0
      Call rZeroVector(w,dim)
      Call cZeroMatrix(z,dim)
      Call diag_c2(hzee,dim,info,w,z)
      If (info.ne.0) Then
      Write(6,'(5x,a)') 'diagonalization of the zeeman hamiltonian'//
     & ' failed.'
      Go To 199
      End If

      Call cZeroMatrix(zfin,dim)
      Call spin_phase(dipso2,dim,z,zfin)

      If(iprint.gt.2) Then
      Write(6,'(5X,A)') 'MAIN VALUES OF THE ZEEMAN HAMILTONIAN:'
      Write(6,*)
         If(MOD(dim,2).eq.1) Then
      Do I=1,dim
      Write(6,'(3X,A,I3,A,F17.3)') '|',(dim-1)/2+(1-I),'> = ',W(i)
      End Do
      Else
      Do I=1,dim
      Write(6,'(3X,A,I3,A,F17.3)') '|',(dim-1)-2*(I-1),'/2 > = ',W(i)
      End Do
         End If
      Write(6,*)
      Write(6,'(1X,A)') 'EIGENFUNCTIONS OF THE EFFECTIVE SPIN:'
      Write(6,*)
         If(mod(dim,2).eq.1) Then
      Do i=1,dim
      Write(6,'(10x,a,i2,a,10x,20(2f16.12,2x))') 'eigenvector of |',
     & (dim-1)/2+(1-i),' > :',(zfin(j,i),j=1,dim)
      End Do
         Else
      Do i=1,dim
      Write(6,'(10x,a,i2,a,10x,20(2f16.12,2x))') 'eigenvector of |',
     & (dim-1)-2*(i-1),'/2 > :',(zfin(j,i),j=1,dim)
      End Do
         End If
      End If ! printing of eigenfunctions with identical phase.

      Call cZeroMoment(MF,dim)
      Call cZeroMoment(SF,dim)
      Do l=1,3
        Do i=1,dim
          Do j=1,dim
            Do i1=1,dim
              Do i2=1,dim
      MF(l,i,j)=MF(l,i,j)+dipso2(l,i1,i2)*conjg(zfin(i1,i))*zfin(i2,j)
      SF(l,i,j)=SF(l,i,j)+ s_so2(l,i1,i2)*conjg(zfin(i1,i))*zfin(i2,j)
              End Do
            End Do
          End Do
        End Do
      End Do

      If(IPRINT.gt.2) Then
      Call prMom('PseudoSpin basis:  MAGNETIC MOMENT: MF :',MF,dim)
      Call prMom('PseudoSpin basis:      SPIN MOMENT: SF :',SF,dim)
      End If

 199  continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkGrid(natom,Cord,Grid,nGrdPt,iRMax,DeltaR,Forces,IsMM,iGrdTyp,DGrid,nAtQM)

use PCM_arrays, only: Centr, dCntr, DPnt, dRad, dTes, IntSph, NewSph, NVert, PCM_N, PCM_SQ, PCMDM, PCMiSph, PCMSph, PCMTess, SSph, &
                      Vert
use external_centers, only: iXPolType
use Data_Structures, only: Alloc2DArray_Type, Alloc4DArray_Type
use rctfld_module, only: DoDeriv, nPCM_Info, nTS, PCM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: natom, iRMax, IsMM(natom), iGrdTyp, nAtQM
real(kind=wp), intent(in) :: Cord(3,natom), DeltaR
type(Alloc2DArray_Type), intent(out) :: Grid
integer(kind=iwp), intent(inout) :: nGrdPt
logical(kind=iwp), intent(in) :: Forces
type(Alloc4DArray_Type), intent(out) :: DGrid
integer(kind=iwp) :: ibla, iPL, iPnt, iPrint, iPt, J, jPnt, New_nGrdPt, nGrdPt_old, nTmp
real(kind=wp) :: Dum(1), R, X, Y, Z
logical(kind=iwp) :: Dirty, Process
integer(kind=iwp), allocatable :: AN(:), Keep(:), LcANr(:)
real(kind=wp), allocatable :: Bla(:,:), Chrg(:), LcCoor(:,:), Tmp(:,:), TmpDG(:,:,:,:), TmpG(:,:)
integer(kind=iwp), external :: iPL_espf

iPL = iPL_espf()

iPrint = 5
if (iPL >= 3) iPrint = 50
if (iPL >= 4) iPrint = 99
call mma_allocate(AN,natom,label='Atomic Numbers')
call mma_allocate(Chrg,natom,label='Get_Atoms')
call Get_dArray('Nuclear charge',Chrg,natom)
AN(:) = int(Chrg)
call mma_deallocate(Chrg)
nGrdPt_old = nGrdPt

! PNT grid

if (abs(iGrdTyp) == 1) then
  Process = (iGrdTyp == 1)
  if (Process) then
    call mma_allocate(Grid%A,3,nGrdPt,label='ESPF_Grid')
    call PNT(u6,natom,Cord,iRMax,DeltaR,AN,nGrdPt,Grid%A,IsMM,Process)
  else
    call PNT(u6,natom,Cord,iRMax,DeltaR,AN,nGrdPt,Dum,IsMM,Process)
  end if
  if (nGrdPt <= 0) then
    write(u6,'(A)') ' Error in espf/mkgrid: nGrdPt < 0 !!!'
    call Quit_OnUserError()
  end if

  ! Printing the PNT point coordinates

  if (Process .and. (.not. DoDeriv)) then
    if (iPL >= 4) then
      write(u6,'(A,I5,A)') ' PNT grid (in angstrom) '
      do iPt=1,nGrdPt
        write(u6,'(A4,3F15.6)') ' X  ',Grid%A(:,iPt)*Angstrom
      end do
    end if
  end if

else

  ! GEPOL grid (made of iRMax surfaces)

  iXPolType = 0
  PCM = .true.
  DoDeriv = Forces
  nGrdPt = 0
  call mma_allocate(Tmp,3,nGrdPt,label='Tmp')
  do J=0,iRMax-1
    if (iPL >= 3) write(u6,'(A13,I1)') ' GEPOL shell ',J+1
    call mma_allocate(LcCoor,3,natom,label='LcCoor')
    call mma_allocate(LcANr,natom,label='LcANr')
    nPCM_info = 0
    call PCM_Cavity(iPrint,0,natom,Cord,AN,IsMM,LcCoor,LcANr,J)
    call mma_deallocate(LcCoor)
    call mma_deallocate(LcANr)
    nTmp = nGrdPt
    nGrdPt = nGrdPt+nTs
    call mma_allocate(Bla,3,nGrdPt,label='Bla')
    Bla(:,1:nTmp) = Tmp
    call move_alloc(Bla,Tmp)
    if (DoDeriv) call mma_allocate(DGrid%A,nGrdPt,nAtQM,3,3,label='ESPF_DGrid')
    Tmp(:,nTmp+1:nTmp+nTs-1) = PCMTess(1:3,:)
    if (DoDeriv) DGrid%A(:,:,:,:) = DPnt
    call mma_deallocate(NewSph)
    call mma_deallocate(IntSph)
    call mma_deallocate(NVert)
    call mma_deallocate(PCMiSph)
    call mma_deallocate(PCM_N)
    call mma_deallocate(PCMDM)
    call mma_deallocate(SSph)
    call mma_deallocate(Centr)
    call mma_deallocate(Vert)
    call mma_deallocate(PCMTess)
    call mma_deallocate(PCMSph)
    if (DoDeriv) then
      call mma_deallocate(dTes)
      call mma_deallocate(dPnt)
      call mma_deallocate(dRad)
      call mma_deallocate(dCntr)
      call mma_deallocate(PCM_SQ)
    end if
  end do
  call mma_allocate(Grid%A,3,nGrdPt,label='ESPF_Grid')
  Grid%A(:,:) = Tmp
  call mma_deallocate(Tmp)

  ! Cleaning the GEPOL grid:
  ! all grid points must be distant by 1 bohr at least

  Dirty = .true.
  do while (Dirty)
    Dirty = .false.
    call mma_allocate(Keep,nGrdPt,label='Keep')
    Keep(:) = 1
    do iPnt=1,nGrdPt-1
      if (Keep(iPnt) == 0) cycle
      do jPnt=iPnt+1,nGrdPt
        X = Grid%A(1,jPnt)-Grid%A(1,iPnt)
        Y = Grid%A(2,jPnt)-Grid%A(2,iPnt)
        Z = Grid%A(3,jPnt)-Grid%A(3,iPnt)
        R = sqrt(X*X+Y*Y+Z*Z)
        if (R < One) Keep(jPnt) = 0
      end do
    end do
    New_nGrdPt = 0
    do iPnt=1,nGrdPt
      if (Keep(iPnt) == 1) New_nGrdPt = New_nGrdPt+1
    end do
    Dirty = New_nGrdPt < nGrdPt
    if (Dirty) then
      call mma_allocate(TmpG,3,New_nGrdPt,label='TmpG')
      if (DoDeriv) call mma_allocate(TmpDG,New_nGrdPt,nAtQM,3,3,label='TmpDG')
      ibla = -1
      do iPnt=1,nGrdPt
        if (Keep(iPnt) == 1) then
          ibla = ibla+1
          Tmp(:,ibla) = Grid%A(:,iPnt)
          if (DoDeriv) TmpDG(ibla,:,:,:) = DGrid%A(iPnt,:,:,:)
        end if
      end do
      call mma_deallocate(Grid%A)
      call move_alloc(TmpG,Grid%A)
      if (DoDeriv) then
        call mma_deallocate(DGrid%A)
        call move_alloc(TmpDG,DGrid%A)
      end if
      nGrdPt = New_nGrdPt
    end if
    call mma_deallocate(Keep)
  end do

  ! Printing the GEPOL point coordinates

  if ((.not. DoDeriv) .and. (iPL >= 4)) then
    write(u6,'(A)') 'PCM grid (in angstroms):'
    do iPnt=0,nGrdPt-1
      write(u6,'(A4,3F15.6)') ' X  ',Grid%A(:,iPnt)*Angstrom
    end do
  end if
  PCM = .false.
end if
if ((nGrdPt_old /= 0) .and. (nGrdPt /= nGrdPt_old)) then
  write(u6,'(A,2i10)') 'MkGrid: inconsistency in nGrdPt:',nGrdPt_old,nGrdPt
  call Abend()
end if
call mma_deallocate(AN)

return

end subroutine MkGrid

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine sort_KQ(N,ARR,rank,proj,iopt)
! iopt = 1   => sort in ascending order
! iopt = 2   => sort in descending order

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, iopt
real(kind=wp), intent(inout) :: ARR(N)
integer(kind=iwp), intent(inout) :: rank(N), proj(N)
integer(kind=iwp) :: i, ip, ir, j
real(kind=wp) :: a

if (iopt == 1) then
  do j=2,N
    a = ARR(j)
    ir = rank(j)
    ip = proj(j)

    do i=j-1,1,-1
      if (ARR(i) <= a) exit
      ARR(i+1) = ARR(i)
      rank(i+1) = rank(i)
      proj(i+1) = proj(i)
    end do
    ARR(i+1) = a
    rank(i+1) = ir
    proj(i+1) = ip
  end do
else if (iopt == 2) then
  do j=2,N
    a = ARR(j)
    ir = rank(j)
    ip = proj(j)

    do i=j-1,1,-1
      if (ARR(i) >= a) exit
      ARR(i+1) = ARR(i)
      rank(i+1) = rank(i)
      proj(i+1) = proj(i)
    end do
    ARR(i+1) = a
    rank(i+1) = ir
    proj(i+1) = ip
  end do
else
  write(u6,'(A)') 'sort_KQ error:  iopt parameter is wrong.'
  write(u6,*) 'iopt = ',iopt
  write(u6,'(A)') 'iopt = 1, sort in ascending order'
  write(u6,'(A)') 'iopt = 2, sort in descending order'
  write(u6,'(A)') 'Return, wthout sorting'
  call xFlush(u6)
  return
end if

return

end subroutine sort_KQ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_MOtra(CMO,nCMOs,Do_int,ihdf5)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCMOs, ihdf5
real(kind=wp), intent(in) :: CMO(nCMOs)
logical(kind=iwp), intent(in) :: Do_int
integer(kind=iwp) :: nAsh(8), nBas(8), nDel(8), nFro(8), nIsh(8), nSsh(8), nSym
character(len=6), parameter :: BName = '_CHMOT'
logical(kind=iwp), parameter :: InitChoEnv = .true.

call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
call Get_iArray('nFro',nFro,nSym)
call Get_iArray('nIsh',nIsh,nSym)
call Get_iArray('nAsh',nAsh,nSym)
call Get_iArray('nDel',nDel,nSym)
nSsh(1:nSym) = nBas(1:nSym)-nDel(1:nSym)-nAsh(1:nSym)-nIsh(1:nSym)-nFro(1:nSym)
call Cho_MOTra_Inner(CMO,nCMOs,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,BName,Do_Int,ihdf5,InitChoEnv)

end subroutine Cho_MOTra

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine stat1_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"

      cpu0=tim0_cvb()
      if(((.not.variat).or.nmcscf.eq.1).or.(ip(3).ge.1.and.
     >  ((.not.endvar).or.ip(6).ge.2)))then
        cpu_prev=zero
        n_applyt=0
        n_applyh=0
        n_hess=0
        n_orbhess=0
        n_cihess=0
        n_2el=0
        ibase0=mstackr_cvb(0)
        call mfreer_cvb(ibase0)
        ibasemx=ibase0
      else
        ibase0=mstackr_cvb(0)
        call mfreer_cvb(ibase0)
        ibasemx=ibase0+memused
      endif
      n_iter=0
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Per Ake Malmqvist                                *
************************************************************************

! Print the transition density matrices in ASCII format.
!   Code written by P. A. Malmqvist.
! This code was moved from the main gtdmctl.f file for clarity.
! - F. Plasser
      SUBROUTINE TRD_PRINT(ISTATE, JSTATE, DO22, TDMAB, TDM2,
     &                     CMO1, CMO2, SIJ)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='TRD_PRINT')
#include "rasdim.fh"
!#include "rasdef.fh"
#include "symmul.fh"
#include "rassi.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "Files.fh"
#include "Struct.fh"
#include "stdalloc.fh"
! Variables passed
      INTEGER ISTATE, JSTATE
      REAL*8 TDMAB(*), TDM2(*), CMO1(*), CMO2(*), SIJ
      LOGICAL DO22
! Other variables
      CHARACTER*3 NUM1,NUM2
      CHARACTER*12 FNM
      DIMENSION WBUF(5)
! Subroutine starts
      LU=50
      LU=IsFreeUnit(LU)
      WRITE(NUM1,'(I3.3)') ISTATE
      WRITE(NUM2,'(I3.3)') JSTATE
      FNM='TRD2_'//NUM1//'_'//NUM2
      CALL Molcas_Open(LU,FNM)
      WRITE(LU,*)'#Transition density file from RASSI.'
      WRITE(LU,*)'#  States:'
      WRITE(LU,*) ISTATE, JSTATE
      WRITE(LU,*)'#  Nr of irreps:'
      WRITE(LU,*) NSYM
      WRITE(LU,*)'#  Basis functions:'
      WRITE(LU,'(8I5)') (NBASF(ISYM),ISYM=1,NSYM)
      WRITE(LU,*)'#  Frozen orbitals:'
      WRITE(LU,'(8I5)') (NFRO(ISYM),ISYM=1,NSYM)
      WRITE(LU,*)'#  Inactive orbitals:'
      WRITE(LU,'(8I5)') (NISH(ISYM),ISYM=1,NSYM)
      WRITE(LU,*)'#  Active orbitals:'
      WRITE(LU,'(8I5)') (NASH(ISYM),ISYM=1,NSYM)
      WRITE(LU,*)'#  State ',ISTATE,'    CMO coefficients:'
      LPOS=1
      DO ISYM=1,NSYM
        NO=NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
        NB=NBASF(ISYM)
        DO IO=1,NO
          WRITE(LU,*)'#  Symm ',ISYM,'   Orbital ',IO
          WRITE(LU,'(5D19.12)')(CMO1(LPOS+NB*(IO-1)+i),i=0,NB-1)
        END DO
        LPOS=LPOS+NB*NO
      END DO
      WRITE(LU,*)'#  State ',JSTATE,'    CMO coefficients:'
      LPOS=1
      DO ISYM=1,NSYM
        NO=NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
        NB=NBASF(ISYM)
        DO IO=1,NO
          WRITE(LU,*)'#  Symm ',ISYM,'   Orbital ',IO
          WRITE(LU,'(5D19.12)')(CMO2(LPOS+NB*(IO-1)+i),i=0,NB-1)
        END DO
        LPOS=LPOS+NB*NO
      END DO
      WRITE(LU,*)'#  States ',ISTATE,JSTATE,' Overlap:'
      WRITE(LU,'(5D19.12)') SIJ
      WRITE(LU,*)'#  States ',ISTATE,JSTATE,' Active TRD1:'
      LSYM12=MUL(LSYM1,LSYM2)
      LPOS=1
      DO ISYM1=1,NSYM
        NO1=NOSH(ISYM1)
        ISYM2=MUL(ISYM1,LSYM12)
        NO2=NOSH(ISYM2)
        IF (NO1*NO2 .gt. 0) THEN
          NA1=NASH(ISYM1)
          NA2=NASH(ISYM2)
          IF (NA1*NA2 .gt. 0) THEN
            NI1=NISH(ISYM1)
            NI2=NISH(ISYM2)
            WRITE(LU,*)'#  Symmetries ',ISYM1,ISYM2
            WRITE(LU,'(5D19.12)')((TDMAB(LPOS-1+II+NO1*(JJ-1)),
     &                                  JJ=NI2+1,NO2),II=NI1+1,NO1)
          END IF
          LPOS=LPOS+NO1*NO2
        END IF
      END DO

      IF (DO22) THEN
        WRITE(LU,*)'#  States ',ISTATE,JSTATE,' Active TRD2:'
        DO ISYT=1,NSYM
          DO ISYU=1,NSYM
            DO ISYV=1,ISYT
              LIMX=ISYV
              IF(ISYV.EQ.ISYT) LIMX=ISYU
              DO ISYX=1,LIMX
!               > Write out one symmetry block (4 indices!) of two-electron
!               > transition density matrix elements.
!               > Write a full 'rectangular' array, even if it could be made
!               > smaller by permutation symmetry.
                WRITE(LU,*)'#  Orbital symm:',ISYT,ISYU,ISYV,ISYX
                IWBUF=0
                DO IT=1,NASH(ISYT)
                  ITABS=NAES(ISYT)+IT
                  DO IU=1,NASH(ISYU)
                    IUABS=NAES(ISYU)+IU
                    ITU=ITABS+NASHT*(IUABS-1)
                    DO IV=1,NASH(ISYV)
                      IVABS=NAES(ISYV)+IV
                      DO IX=1,NASH(ISYX)
                        IXABS=NAES(ISYX)+IX
                        IVX=IVABS+NASHT*(IXABS-1)
                        IF(ITU.GE.IVX) THEN
                          ITUVX=(ITU*(ITU-1))/2+IVX
                        ELSE
                          ITUVX=(IVX*(IVX-1))/2+ITU
                        END IF
                        IWBUF=IWBUF+1
                        WBUF(IWBUF)=TDM2(ITUVX)
                        IF(IWBUF.EQ.5) THEN
                          WRITE(LU,'(5D19.12)')(WBUF(I),I=1,IWBUF)
                          IWBUF=0
                        END IF
                      END DO
                    END DO
                  END DO
                END DO
                IF(IWBUF.GT.0) THEN
                  WRITE(LU,'(5D19.12)')(WBUF(I),I=1,IWBUF)
                  IWBUF=0
                END IF
* End of writing a symmetry block.
              END DO
            END DO
          END DO
        END DO
      END IF
      CLOSE (LU)
      END SUBROUTINE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995,1998, Niclas Forsberg                             *
!               1995,1998, Anders Bernhardsson                         *
!               2009, Giovanni Ghigo                                   *
!***********************************************************************

!  Written by:
!    Niclas Forsberg & Anders Bernhardsson,
!    Dept. of Theoretical Chemistry, Lund University, 1995&1998.
!  Modified by:
!    Giovanni Ghigo for InterSystem Crossing
!    Dept. of Chimica Generale e Chimica Organica, University of Torino, 2009 June.
!
!  Purpose:
!    Create tables used in FCval.
!
!  Contains:
!    MakeTab   (m_max,maxOrd,maxIncOrd,mMat,mInc,mDec)
!    TabDim    (nDim,nOsc) Result(nTabDim)
!    iDetNr    (iocc,graph,nosc,m_max)  Result(iDetNr)
!
!  Input:
!    nOsc      : Integer - the the number of oscillators.
!    m_max     : Integer - the maximum sum of the quantum numbers.
!    maxOrd    : Integer - number of rows in mMat.
!    nTabDim   : Integer
!    Osc_Shift : Integer array
!
!  Output:
!    mMat      : Two dimensional integer array
!    mInc      : Two dimensional integer array
!    mDec      : Two dimensional integer array
subroutine ISC_MakeTab2(m_max,maxOrd,mSiz,mMat,Graph1,Graph2,nOsc)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: m_max, mSiz, nOsc
integer(kind=iwp), intent(out) :: maxOrd, mMat(0:mSiz,nOsc), Graph1(m_max+1,nOsc+1), Graph2(m_max+1,m_max+1,nOsc)
integer(kind=iwp) :: i, iDet, iDNR, iOsc, iQ, iQ1, iQ2, iQuanta, m, n, nd, nQuanta, nTabDim, nvTabDim
integer(kind=iwp), allocatable :: iVec(:), Num(:)
integer(kind=iwp), external :: iDetnr

!write(u6,*)
!write(u6,*) 'CGGt[ISC_MakeTab2] Infos:'
!write(u6,*) 'Graph1(',m_max+1,',',nOsc+1,')'
!write(u6,*) 'Graph2(',m_max+1,',',m_max+1,',',nOsc,')'
!write(u6,*) 'mInc,mDec,mMat(0:',msiz,',',nosc,')'
!write(u6,*) '-------------------------------------------'

! Initialize.

!write(u6,*)
!write(u6,*) '                 msiz,nosc==',msiz,nosc
!mInc(:,:) = 0
!mDec(:,:) = 0
mMat(:,:) = 0
if (m_max == 0) return
!write(u6,*) '                 Calling TabDim'
call TabDim(m_max,nOsc,nTabDim)
maxOrd = nTabDim-1

! Set up the vertex table
!write(u6,*) '                 Graph1,dim=',(m_max+1)*(nOsc+1)
Graph1(:,:) = 0
Graph1(:,2) = 1
Graph1(1,:) = 1
if (nOsc > 1) then
  do iOsc=2,nOsc
    n = 0
    do nQuanta=0,m_max
      n = n+Graph1(nQuanta+1,iOsc)
      Graph1(nQuanta+1,iOsc+1) = n
    end do
  end do
end if

! set up the arc table
!write(u6,*) '                 Num,dim=',m_max
call mma_allocate(Num,[0,m_max],label='Number')
Num(0) = 0
N = 0
do m=1,m_max
  N = N+Graph1(m,nosc+1)
  Num(m) = N
end do
!write(u6,*) '                 Graph2,dim=',nOsc*((m_max+1)**2)
Graph2(:,:,:) = 0
do iOsc=1,nosc
  do iQ1=0,m_max      ! Where we are going
    do iQ2=0,iQ1-1    ! Where we came from
      do i=iQ2+1,iq1  ! Sum over preceding paths
        Graph2(iQ1+1,iQ2+1,iOsc) = Graph1(i+1,iOsc)+Graph2(iQ1+1,iQ2+1,iOsc)
      end do
    end do
  end do
end do

do iQ1=0,m_max  ! Where we are going
  do iQ2=0,iq1  ! Where we came from
    Graph2(iQ1+1,iQ2+1,nOsc) = Graph2(iQ1+1,iQ2+1,nOsc)+Num(iQ1)
  end do
end do

call mma_deallocate(Num)

!write(u6,*) 'CGGt[MakeTab2] Vec,dim=',nOsc
call mma_allocate(iVec,nOsc,label='iVec')
do iQuanta=1,m_max
  !write(u6,*) 'CGGt[MakeTab2] iQuanta=',iQuanta
  iVec(:) = 0
  iQ = -1
  iVec(1) = -1

  !write(u6,*) 'CGGt[MakeTab2] Call TabDim - 1'
  !write(u6,*) '    iQuanta,nOsc,nd==',iQuanta,nOsc,nd
  call TabDim(iQuanta,nOsc,nd)
  !write(u6,*) 'CGGt[MakeTab2] Call TabDim - 2'
  !write(u6,*) '     iQuanta-1,nOsc,nvTabDim==',iQuanta-1,nOsc,nvTabDim
  call TabDim(iQuanta-1,nOsc,nvTabDim)

  nd = nd-nvTabDim

  do iDet=1,nD
    iVec(1) = iVec(1)+1
    iQ = iQ+1
    if (iQ > iQuanta) then
      do i=1,nOsc-1
        if (iQ <= iQuanta) exit
        iQ = iQ-iVec(i)+1
        iVec(i) = 0
        iVec(i+1) = iVec(i+1)+1
      end do
    end if
    iVec(nOsc) = iQuanta-iq
    iDNR = iDetnr(iVec,Graph2,nosc,m_max)
    mMat(iDNR,:) = iVec(:)
  end do
end do

call mma_deallocate(iVec)

return

end subroutine ISC_MakeTab2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3aphlp7(a2,a3,b,dimp,dimq,dimr,ns,szkey)
! this routine realizes following procedure
! for symp/=symq/=symr
!
! B(p,q,r)=B(p,q,r)+ns*(-A2(p,r,q)+A3(p,q,r))
!
! a2    - A2 matrix (I)
! a3    - A3 matrix (I)
! b     - B  matrix (I/O)
! dimp  - dimension of p index (I)
! dimq  - dimension of q index (I)
! dimr  - dimension of r index (I)
! ns    - signum of the permutation (+-1) (I)
! szkey - set zero key (I)
!         = 0 no vanishing
!         = 1 set B=0 at the beginning

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dimr, ns, szkey
real(kind=wp), intent(in) :: a2(dimp,dimr,dimq), a3(dimp,dimq,dimr)
real(kind=wp), intent(inout) :: b(dimp,dimq,dimr)
integer(kind=iwp) :: r

if (szkey == 1) b(:,:,:) = Zero

if (ns == 1) then
  ! phase +1

  b(:,:,:) = b+a3

  do r=1,dimr
    b(:,:,r) = b(:,:,r)-a2(:,r,:)
  end do

else
  ! phase -1

  b(:,:,:) = b-a3

  do r=1,dimr
    b(:,:,r) = b(:,:,r)+a2(:,r,:)
  end do

end if

return

end subroutine t3aphlp7

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE DEGVEC(VEC,NDIM,NDGVL,IDEG)
*
* A vector VEC is given with elements in ascending order
* group elements in degenerate pairs
*
*=======
* Input
*=======
* VEC : input vector
* NDIM : Number of elements in vec
*
*========
* Output
*========
* NDGVL : Number of degenerate values
* IDEG(I) : Number of elements in VEC with degenerate value I
*
* Jeppe Olsen , April 1990
*
      IMPLICIT REAL*8           ( A-H,O-Z)
*.Input
      DIMENSION VEC(*)
*.Output
      DIMENSION IDEG(*)
*.Threshold for defining degenerency
      THRES = 1.0D-8
C?      write(6,*) ' Input vector to DEGVEC '
C?      call wrtmat(VEC,1,NDIM,1,NDIM)
      XDGVL = VEC(1)
      NDEG = 1
      NDGVL = 0
      DO 100 I = 2, NDIM
        IF(ABS(VEC(I)-XDGVL).LE.THRES) THEN
          NDEG = NDEG + 1
        ELSE
          NDGVL = NDGVL + 1
          IDEG(NDGVL) = NDEG
          XDGVL = VEC(I)
          NDEG = 1
        END IF
  100 CONTINUE
*. Last group
      NDGVL = NDGVL + 1
      IDEG(NDGVL) = NDEG
*
      NTEST = 0
      IF(NTEST .GT. 0 ) THEN
        WRITE(6,*) ' Output from DEGVEC '
        WRITE(6,*) ' ================== '
        WRITE(6,*)
        WRITE(6,*) ' Number of degenerate values ' ,NDGVL
        WRITE(6,*) ' Degenerencies of each value '
        CALL IWRTMA(IDEG,1,NDGVL,1,NDGVL)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Jonna Stalring                                         *
!***********************************************************************

subroutine RInt_td(ekappa,mkappa,isym)
!******************************************************
!            [2]                                      *
! Modifies  E    *kappa by subtracting Omega*S*kappa  *
! to make timedep PT possible.                        *
!                                                     *
!******************************************************
!
!  mkappa    is d/dx(kappa) in matrix form (derivative of orb rot mat w r t PT)
!  ekappa    is E*d/dx(kappa) in matrix form, REPLACED BY
!            the entire timedep expression
!  isym      Rinttd is called once for each symmtry
!
! Local variables
!
!  dens The density matrix
!  wDKt   Omega*(density matrix)*(kappa transposed)
!  wKtD   As above but different order

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use MCLR_Data, only: G1t, ipCM, ipMat, nA, nDens
use input_mclr, only: nAsh, nBas, nIsh, nSym, Omega
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: ekappa(nDens)
real(kind=wp), intent(in) :: mkappa(nDens)
integer(kind=iwp), intent(in) :: iSym
integer(kind=iwp) :: iA, iB, ifin, iini, Inc, ip, ip2, ip3, iS, jA, jB, jS, lDens
real(kind=wp), allocatable :: Dens(:), wDKt(:), wKtD(:)

!-----------------------------------------------------------------------

! Allocate memory

lDens = sum(nBas(1:nSym)**2)
call mma_allocate(Dens,lDens,Label='Dens')
call mma_allocate(wDKt,nDens,Label='wDKt')
call mma_allocate(wKtD,nDens,Label='wKtD')

!******************************
! Construct the density matrix
!******************************

! For HF

Dens(:) = Zero
ip3 = 1
do iS=1,nSym
  inc = nBas(iS)+1
  Dens(ip3:ip3+nIsh(iS)*inc-1:inc) = Two
  ip3 = ip3+nBas(iS)*nBas(iS)
end do

!do is=1,nsym
!  size = nbas(is)*nbas(is)      ! The size of the sym i and j martix
!  do k=-1,(size-1)             ! Loop over the entire submatrix
!    residual = MOD((k+1),(nbas(is)+1))
!    if ((residual == zero) .and. (k < (nbas(is)*nIsh(is))) .and. (nIsh(is) /= 0)) then
!      Dens(1+ipCM(is)+k) = Two
!    else
!      Dens(1+ipCM(is)+k) = Zero
!    end if
!  end do
!end do

! For a CASSCF wavefunc. From Anders subrut r2elint
! Add the active active dens

do iS=1,nSym
  do iB=1,nAsh(iS)
    do jB=1,nAsh(iS)
      ip = ipCM(iS)+ib+nIsh(is)+(jB+nIsh(is)-1)*nBas(is)-1
      iA = nA(is)+ib
      jA = nA(is)+jb
      ip2 = iTri(iA,jA)
      Dens(ip) = G1t(ip2)
    end do
  end do
end do
!*************************************
! Multiply D and mkappa wDKt and wKtD
!*************************************
!call RecPrt('dens ',' ',dens,ldens,1)
!call RecPrt('ekappa ',' ',ekappa,nDens,1)
do is=1,nsym
  js = Mul(is,isym)
  ! wDKt
  if ((nBas(iS) > 0) .and. (nBas(jS) > 0)) then
    call DGEMM_('n','n',nbas(is),nbas(js),nbas(is),Two*Omega,Dens(ipCM(is)),nbas(is),mkappa(ipmat(is,js)),nbas(is),Zero, &
                wDKt(ipmat(is,js)),nbas(is))
    ! wKtD
    call DGEMM_('n','n',nbas(is),nbas(js),nbas(js),Two*Omega,mkappa(ipmat(is,js)),nbas(is),Dens(ipCM(js)),nbas(js),Zero, &
                wKtD(ipmat(is,js)),nbas(is))

    !****************************************
    ! Replace ekappa ekappa=ekappa-wDKt+wKtD
    !****************************************
    iini = ipmat(is,js)
    ifin = iini+nbas(is)*nbas(js)-1
    ekappa(iini:ifin) = ekappa(iini:ifin)+wDKt(iini:ifin)-wKtD(iini:ifin)
  end if
end do
!call RecPrt('wDKt ',' ',wDKt,nDens,1)
!call RecPrt('wKtD ',' ',wKtD,nDens,1)
!call RecPrt('ekappa ',' ',ekappa,nDens,1)

! Free memory

call mma_deallocate(Dens)
call mma_deallocate(wDKt)
call mma_deallocate(wKtD)

end subroutine RInt_td

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine defcommon(no,nv)
! this routine does:
!
! define commons needed in DIRCC routines

use ChT3_global, only: IOPT, IT, NNOAB, NNUAB, NOAB, NUAB
use Index_Functions, only: nTri_Elem
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: no, nv

! ----  UHF -----

noab(1) = no
noab(2) = no

nnoab(1) = nTri_Elem(noab(1)-1)
nnoab(2) = nTri_Elem(noab(2)-1)
nnoab(3) = noab(1)*noab(2)

nuab(1) = nv
nuab(2) = nv

nnuab(1) = nTri_Elem(nuab(1)-1)
nnuab(2) = nTri_Elem(nuab(2)-1)
nnuab(3) = nuab(1)*nuab(2)

! ----  PARAM ----

!??????????????????
it = 1

! ------ my_mpi_world_com --------

! zatial pre sekvencny chod

!mp !me = 0
!mp !nprocs = 1
!mp !llmpi = .false.
!mp !nws = 1
!mp !iws(1) = 1
!mp !lws(1) = .true.

! ------ pre Get3DM -----------

! ------    IOPT    -----------

IOPT(1) = 0

! sets IOPT(2) to an extreme number to force one file - temporary !!!  preskumat !!!
! in order to be compatible with RHF i=2^31-1
iopt(2) = 2147483647

! zatial tolko

return

end subroutine defcommon

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Per Ake Malmqvist                                *
************************************************************************
      SUBROUTINE PROTOT(NPORB,NPSDSZ,IPSDMS,NPCSFSZ,IPCSFCP,PCSFTOSD)
      use definitions, only: iwp, wp, u6
      use constants, only: One
      use rassi_aux, only: ipglob
      IMPLICIT NONE
      integer(kind=iwp), intent(in):: NPORB,NPCSFSZ,NPSDSZ
      Integer(kind=iwp), intent(in):: IPSDMS(NPORB,NPSDSZ),
     &                                IPCSFCP(NPORB,NPCSFSZ)
      real(kind=wp), intent(inout):: PCSFTOSD(NPSDSZ,NPCSFSZ)

      INTEGER(kind=iwp), PARAMETER ::UPCPL=1, DWNCPL=0,ASPIN=1,BSPIN=0
      real(kind=wp) COEF1, COEF2
      INTEGER(kind=iwp) IC,IM,INDSMM,INDSPM,IOPEN,JCSF,JDET
* Expand csf's in terms of determinants by the Grabenstetter method
*  (I.J.Q.C. 10, P142 (1976))
* Recoded by PAM 1999, after Jeppe Olsen.
*
* Input :
*         NPORB    : NUMBER OF OPEN ORBITALS
*         IPSDMS  : OCCUPATION OF PROTO-SDs
*         NPSDSZ   : NUMBER OF PROTOSD''s
*         NPCSFSZ  : NUMBER OF PROTOCSF''s
*         IPCSFCP  : SPIN COUPLINGS IN PROTO-CSFs
* Output :
*         PCSFTOSD :  NPSDSZ X NPCSFSZ MATRIX
*                GIVING EXPANSION FROM P-SD'S TO P-CSF'S


      DO JCSF = 1, NPCSFSZ
       IF( IPGLOB .GE. 5 ) WRITE(u6,*) ' ....Output for P-CSF ',JCSF
       DO JDET = 1, NPSDSZ
C EXPANSION COEFFICIENT OF DETERMINANT JDET FOR P-CSF JCSF
        COEF1=One
        COEF2=One
        INDSMM=0
        INDSPM=0
        DO IOPEN = 1, NPORB
         IC=0
         IF(IPCSFCP(IOPEN,JCSF).EQ.UPCPL) IC=1
         IM=0
         IF(IPSDMS(IOPEN,JDET).EQ.ASPIN) IM=1
         IF(IC.EQ.0) THEN
          IF(IM.EQ.0) THEN
            INDSPM=INDSPM-1
            COEF1=COEF1*SQRT(DBLE(INDSPM+1))
* If COEF1 has gone down to 0 exactly.
            IF (INDSPM+1.eq.0) exit
          ELSE
            INDSMM=INDSMM-1
            COEF1=-COEF1*SQRT(DBLE(INDSMM+1))
* If COEF1 has gone down to 0 exactly.
            IF (INDSMM+1.eq.0) exit
          END IF
          COEF2=COEF2*SQRT(DBLE(INDSPM+INDSMM+2))
         ELSE
          IF(IM.EQ.0) THEN
            INDSMM=INDSMM+1
            COEF1=COEF1*SQRT(DBLE(INDSMM))
          ELSE
            INDSPM=INDSPM+1
            COEF1=COEF1*SQRT(DBLE(INDSPM))
          END IF
          COEF2=COEF2*SQRT(DBLE(INDSPM+INDSMM))
         END IF
        END DO

        PCSFTOSD(JDET,JCSF)=COEF1/COEF2

       END DO
      END DO

      END SUBROUTINE PROTOT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine Gamma_new()
*                                                                      *
************************************************************************
*                                                                      *
      Implicit Real*8 (a-h,o-z)
*
#include "orbinf2.fh"
#include "corbinf.fh"
#include "WrkSpc.fh"
#include "mp2grad.fh"
#include "files_mbpt2.fh"
      Integer nTOrb(nSym),iOffCMO(nSym),iOffCMO_o(nSym),iOffCMO_v(nSym)
      Logical Triangular, Done, LoadZeros
      Logical NonZeroSym(4)
*                                                                      *
************************************************************************
*                                                                      *
*     Some statement functions
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      iTable(i,j)=iWork(ipiTab-1+(j-1)*6+i)
      iInt1(i,j,iSyI,iSyJ) =
     &             (nFro(iSyJ) + j-1)*nTOrb(iSyI) +
     &              nFro(iSyI) + nOcc(iSyI) + i-1
      iBinOff(iX,iY,iBin) =  iY-1 + (iX)*2 + (iBin-1)*iBinLength
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
      iAdrGam = 1
      LoadZeros = .false.
*
      iMaxBas = 0
      Do i = 1, nSym
         nTOrb(i) = nOrb(i) + nDel(i)
         iMaxBas = Max(iMaxBas,nBas(i))
      End Do
*
*     Setup one CMO for occupied and one for virtual orbitals together
*     with a corresponding symmetryoffset.
*
      iOffCMO(1) = 0
      iOffCMO_o(1) = 0
      iOffCMO_v(1) = 0
      Do iSym = 2 , nSym
         iOffCMO(iSym)   = iOffCMO(iSym-1)+nTOrb(iSym-1)*nBas(iSym-1)
         iOffCMO_o(iSym) = iOffCMO_o(iSym-1)+nOcc(iSym-1)*nBas(iSym-1)
         iOffCMO_v(iSym) = iOffCMO_v(iSym-1)+nExt(iSym-1)*nBas(iSym-1)
      End Do
*
*     Calculate total length of CMO-matrices in all irreps.
*
      lCMO_o = 0
      lCMO_v = 0
      Do i = 1, nSym
         lCMO_o = lCMO_o + nOcc(i)*nBas(i)
         lCMO_v = lCMO_v + nExt(i)*nBas(i)
      End Do
*
*     Allocate memory for a virtual and an occupied CMO-matrix
*
      Call GetMem('CMO_o','Allo','Real',ipCMO_o,lCMO_o)
      Call GetMem('CMO_v','Allo','Real',ipCMO_v,lCMO_v)
*
*     Copy CMO to CMO_o and CMO_v
*
      iOff = 0
      Do iSym = 1, nSym
         iOff = nBas(iSym)*nFro(iSym)
         nNO=nBas(iSym)*nOcc(iSym)
         nNV=nBas(iSym)*nExt(iSym)
*
         Call dCopy_(nNO,
     &        Work(ipCMO + iOffCMO(iSym)+iOff),1,
     &        Work(ipCMO_o + iOffCMO_o(iSym)),1)
*
         iOff = iOff + nNO
*
         Call dCopy_(nNV,
     &        Work(ipCMO + iOffCMO(iSym)+iOff),1,
     &        Work(ipCMO_v + iOffCMO_v(iSym)),1)
      End Do
*
#ifdef _DEBUGPRINT_
*     Print the elements of the Full CMO-matrices as well as CMO_o and
*     CMO_v.
      Do iSym = 1, nSym
         Call RecPrt('Full CMO',' ',Work(ipCMO + iOffCMO(iSym)),
     &               nBas(iSym),nTOrb(iSym))
      End Do
      Do iSym = 1, nSym
         Call RecPrt('Occupied CMO',' ',Work(ipCMO_o + iOffCMO_o(iSym)),
     &               nBas(iSym),nOcc(iSym))
      End Do
      Do iSym = 1, nSym
         Call RecPrt('Virtual CMO',' ',Work(ipCMO_v + iOffCMO_v(iSym)),
     &               nBas(iSym),nExt(iSym))
      End Do
#endif
*
*     Setup indeces for symmetryblocks to make it compatible with
*     the aces-routine used for reading the gammas later.
*
      If (nSym.eq.8) nBlocks=106
      If (nSym.eq.4) nBlocks= 19
      If (nSym.eq.2) nBlocks=  4
      If (nSym.eq.1) nBlocks=  1
*
*     Construct a table for block information.
*
      Call GetMem('iTable','Allo','Inte',ipiTab,6*nBlocks)
      Call Gamma_Blocks(iWork(ipiTab),nBlocks,nSym)
*
*     Open a file for writing gammas.
*
      iSeed = 10
      LuGam = IsFreeUnit(iSeed)
      FnGam='LuGam   '
      Call DaName_MF_WA(LuGam,FnGam)
*
*     Open a file to store bins of half-transformed gammas.
*
      iSeed = 11
      LuBin = IsFreeUnit(iSeed)
      FnBin='TmpBin  '
      Call DaName_MF_WA(LuBin,FnBin)
*
*     SETUP OF AMPLITUDE BATCHES
*     (The handling is somewhat simple when nBlocks=1 since we only have
*      blocks with one symmetry)
*
*     Check how large the occ*vir-products and bas**2-products may be.
*
      iMaxBasProd = 0
      iMaxOccVir = 0
      Do iSym1 = 1, nSym
         Do iSym2 = 1, iSym1
            iMaxBasProd = Max(iMaxBasProd,nBas(iSym1)*nBas(iSym2))
            iMaxOccVir  = Max(iMaxOccVir,nOcc(iSym1)*nExt(iSym2))
            iMaxOccVir  = Max(iMaxOccVir,nExt(iSym1)*nOcc(iSym2))
         End Do
      End Do
*
*     Setup two pairs of temporary vectors to use for transformation
*     and symmetrization
*
      lTemp = iMaxBasProd
      Call GetMem('Temp1','Allo','Real',ipTemp1,lTemp)
      Call GetMem('Temp2','Allo','Real',ipTemp2,lTemp)
      If(nBlocks .ne. 1) Then
         Call GetMem('Temp1_1','Allo','Real',ipTemp1_2,lTemp)
         Call GetMem('Temp2_2','Allo','Real',ipTemp2_2,lTemp)
      End If
*
*     Check max available memory
*
      Call GetMem('Max','Max','Real',ipMax,lMax)
*
*     Calculate how much space is needed to store all full bins
*     on disk.
*
      If(nBlocks .eq. 1) Then
         iMemNeeded = 2*iMaxBasProd*(iMaxOccVir+1)
      Else
         iMemNeeded = 4*iMaxBasProd*(iMaxOccVir+1)
      End If
*
*     Take maximum one third of the memory for each bin-complex
*     and leave one third for other tasks.
*
      If(nBlocks .eq. 1) Then
         iMemAvail = 2*lMax/3
      Else
         iMemAvail = lMax/3
      End If
*
*     Make the bins as large as possible but not larger than is
*     needed to keep all bins in memory.
*
      lAllBins = min(iMemAvail,iMemNeeded)
*
*     Allocate two bins
*
      Call GetMem('Bins1','Allo','Real',ipBin,lAllBins)
      If(nBlocks .ne. 1) Then
         Call GetMem('Bins2','Allo','Real',ipBin2,lAllBins)
      End If
*
      iBinLength = lAllBins/iMaxBasProd
*
*     The construction and transformation of Tiajb are now made
*     looping over symmetryblocks
*
      Do iBlock = 1, nBlocks
         iType = iTable(1,iBlock)
*
         If((iType.eq.1) .or. (iType.eq.2)) Then
            Triangular = .True.
         Else
            Triangular = .False.
         End If
*
*        nBas, nOcc etc. are defined as nBas(1:8) here in MBPT2
*        and as nBas(0:7) in integral_util and alaska. (which might not
*        be optimal...)
*        The weird order here is because I accidently constructed
*        (kap lam|mu nu) when I needed (mu nu|kap lam), with this order
*        it will be compatible with src/integral_util/read_blocks.f
         iSym_A=iTable(4,iBlock)+1
         iSym_B=iTable(5,iBlock)+1
         iSym_C=iTable(2,iBlock)+1
         iSym_D=iTable(3,iBlock)+1
*
*        Number of orbitals in (ia|jb)
         nI = nOcc(iSym_A)
         nA = nExt(iSym_B)
         nJ = nOcc(iSym_C)
         nB = nExt(iSym_D)
*
*        Number of orbitals in (ai|bj) (nX and nX1 can be
*        combined to get (ia|bj) and (ai|jb) which are needed for
*        full symmetrization)
         nI2 = nOcc(iSym_B)
         nA2 = nExt(iSym_A)
         nJ2 = nOcc(iSym_D)
         nB2 = nExt(iSym_C)
*
*        Initialize adress for storing Bins on disk.
         iAdrBin = 1
*        Setup the number of bins needed.
         If(Triangular) Then
            nBins = nBas(iSym_C)*(nBas(iSym_C)+1)/2
         Else
            nBins = nBas(iSym_C)*nBas(iSym_D)
         End If
*
*        Initialize the bins to have length 0 and adress -1 to
*        next element
         Do i = 1, nBins
            Work(ipBin+iBinOff(0,1,i)) = 0.0d0
            Work(ipBin+iBinOff(0,2,i)) = -1.0d0
            If(nBlocks .ne. 1) Then
               Work(ipBin2+iBinOff(0,1,i)) = 0.0d0
               Work(ipBin2+iBinOff(0,2,i)) = -1.0d0
            End If
         End Do
*
*        Check which symmetry combinations that are present.
         Do i = 1,4
            NonZeroSym(i) = .True.
         End Do
         If(nI*nA*nJ*nB .eq. 0) NonZeroSym(1) = .False.
         If(nI*nA*nJ2*nB2 .eq. 0) NonZeroSym(2) = .False.
         If(nI2*nA2*nJ*nB .eq. 0) NonZeroSym(3) = .False.
         If(nI2*nA2*nJ2*nB2 .eq. 0) NonZeroSym(4) = .False.
*
*        Skip cases where nABCD is zero. If nABCD is nonzero but
*        nIJAB (different A and B) is zero we jump to the end and load
*        some zeros.
*
         If(Triangular) Then
            nABCD = (nBas(iSym_A)*(nBas(iSym_A)+1)/2)*
     &              (nBas(iSym_C)*(nBas(iSym_C)+1)/2)
         Else
            nABCD = nBas(iSym_A)*nBas(iSym_B)*nBas(iSym_C)*nBas(iSym_D)
         End If
*
         If(nABCD .eq. 0) Go To 100
         If(((.not. NonZeroSym(1)) .and. Triangular) .or.
     &       (.not. (NonZeroSym(1) .or. NonZeroSym(2) .or.
     &               NonZeroSym(3) .or. NonZeroSym(4)))) Then
            LoadZeros = .True.
            Go To 500
         End If
*
*        Start the loop to construct Tiajb.
         Do iI = 1, nI
            Do iA = 1, nA
               If(NonZeroSym(1)) Then
                  Call Exch(iSym_D,iSym_A,iSym_C,iSym_B,
     &                 iI+nFro(iSym_A), iA+nFro(iSym_B)+nOcc(iSym_B),
     &                 Work(ipInt1),Work(ipScr1))
                  Call Coul(iSym_D,iSym_C,iSym_A,iSym_B,
     &                 iI+nFro(iSym_A),iA+nFro(iSym_B)+nOcc(iSym_B),
     &                 Work(ipInt2),Work(ipScr1))
#ifdef _DEBUGPRINT_
                  Write(6,*) ' *  I,A = ',iI, iA
                  Call RecPrt('Int1:','(8F10.6)',Work(ipInt1),
     &                 nOrb(iSym_D)+nDel(iSym_D),
     &                 nOrb(iSym_C)+nDel(iSym_C))
                  Write(6,*) ' *  I,A = ',iI, iA
                  Call RecPrt('Int2:','(8F10.6)',Work(ipInt2),
     &                 nOrb(iSym_D)+nDel(iSym_D),
     &                 nOrb(iSym_C)+nDel(iSym_C))
#endif
               End If
*
*              When Symmetry of I and A differs we need to load both
*              possible (IA|xx) to have (mu nu| xx) and (nu mu|xx)
*              available at the same time for symmetrization.
               If(NonZeroSym(2) .and. (.not. Triangular)) Then
                  Call Exch(iSym_C,iSym_A,iSym_D,iSym_B,
     &                 iI+nFro(iSym_A), iA+nFro(iSym_B)+nOcc(iSym_B),
     &                 Work(ipInt1_2),Work(ipScr1))
                  Call Coul(iSym_C,iSym_D,iSym_A,iSym_B,
     &                 iI+nFro(iSym_A),iA+nFro(iSym_B)+nOcc(iSym_B),
     &                 Work(ipInt2_2),Work(ipScr1))
#ifdef _DEBUGPRINT_
                  Write(6,*) ' *  I,A = ',iI, iA
                  Call RecPrt('Int1:','(8F10.6)',Work(ipInt1_2),
     &                 nOrb(iSym_C)+nDel(iSym_C),
     &                 nOrb(iSym_D)+nDel(iSym_D))
                  Write(6,*) ' *  I,A = ',iI, iA
                  Call RecPrt('Int2:','(8F10.6)',Work(ipInt2_2),
     &                 nOrb(iSym_C)+nDel(iSym_C),
     &                 nOrb(iSym_D)+nDel(iSym_D))
#endif
               End If
*
*     Construct Tiajb for a specific (i,a)-pair
               If(NonZeroSym(1)) Then
                  Do iJ = 1, nJ
                     Do iB = 1, nB
                        xiajb = Work(ipInt2 +iInt1(iB,iJ,iSym_D,iSym_C))
                        xibja = Work(ipInt1 +iInt1(iB,iJ,iSym_D,iSym_C))
                        EDenom =(work(mAdOcc(iSym_A)+iI-1)
     &                       + work(mAdOcc(iSym_C)+iJ-1)
     &                       - work(mAdVir(iSym_B)+iA-1)
     &                       - work(mAdVir(iSym_D)+iB-1)  )
                        Tiajb = (2.0d0*xiajb - xibja)/EDenom
                        Work(ipTemp1 + (iJ-1)*nB + iB-1) = Tiajb
                     End Do     !iSymB
                  End Do        !iSymJ
#ifdef _DEBUGPRINT_
               Call RecPrt('Tiajb',' ',Work(ipTemp1),nExt(iSym_D),
     &                     nOcc(iSym_C))
#endif
               End If
*
               If(NonZeroSym(2) .and. (.not. Triangular)) Then
                  Do iJ = 1, nJ2
                     Do iB = 1, nB2
                        xiajb =Work(ipInt2_2+iInt1(iB,iJ,iSym_C,iSym_D))
                        xibja =Work(ipInt1_2+iInt1(iB,iJ,iSym_C,iSym_D))
                        EDenom =(work(mAdOcc(iSym_A)+iI-1)
     &                         + work(mAdOcc(iSym_D)+iJ-1)
     &                         - work(mAdVir(iSym_B)+iA-1)
     &                         - work(mAdVir(iSym_C)+iB-1)  )
                        Tiajb = (2.0d0*xiajb - xibja)/EDenom
                        Work(ipTemp1_2 + (iJ-1)*nB2 + iB-1) = Tiajb
                     End Do     !iSymB
                  End Do        !iSymJ
#ifdef _DEBUGPRINT_
               Call RecPrt('Tiajb',' ',Work(ipTemp1),nExt(iSym_D),
     &                     nOcc(iSym_C))
#endif
               End If
*
*              Do first halftransformation.
               If(NonZeroSym(1)) Then
                  Call dGemm_('N','N',nBas(iSym_D),nOcc(iSym_C),
     &                 nExt(iSym_D),1.0d0,
     &                 Work(ipCMO_v+iOffCMO_v(iSym_D)),nBas(iSym_D),
     &                 Work(ipTemp1),nExt(iSym_D),0.0d0,
     &                 Work(ipTemp2),nBas(iSym_D))
                  Call dGemm_('N','T',nBas(iSym_D),nBas(iSym_C),
     &                 nOcc(iSym_C),1.0d0,
     &                 Work(ipTemp2),nBas(iSym_D),
     &                 Work(ipCMO_o+iOffCMO_o(iSym_C)),nBas(iSym_C),
     &                 0.0d0,Work(ipTemp1),nBas(iSym_D))
               End If
*
               If(NonZeroSym(2) .and. (.not. Triangular)) Then
                  Call dGemm_('N','N',nBas(iSym_C),nOcc(iSym_D),
     &                 nExt(iSym_C),1.0d0,
     &                 Work(ipCMO_v+iOffCMO_v(iSym_C)),nBas(iSym_C),
     &                 Work(ipTemp1_2),nExt(iSym_C),0.0d0,
     &                 Work(ipTemp2_2),nBas(iSym_C))
                  Call dGemm_('N','T',nBas(iSym_C),nBas(iSym_D),
     &                 nOcc(iSym_D),1.0d0,
     &                 Work(ipTemp2_2),nBas(iSym_C),
     &                 Work(ipCMO_o+iOffCMO_o(iSym_D)),nBas(iSym_D),
     &                 0.0d0,Work(ipTemp1_2),nBas(iSym_C))
               End If
*     Do a halfsymmetrization with respect to the two AO-indeces if they are
*     the same symmetry.
               If(Triangular) Then
                  Do iKap = 1,nBas(iSym_D)
                     Do iLam = 1,nBas(iSym_D)
                        iLamKap1 = iLam-1 + (iKap-1)*nBas(iSym_D)
                        iLamKap2 = iKap-1 + (iLam-1)*nBas(iSym_C)
                        Work(ipTemp2+iLamKap1) =
     &                       (Work(ipTemp1+iLamKap1)
     &                       + Work(ipTemp1+iLamKap2))/2
                     End Do
                  End Do
*     Do a halfsymmetrization with respect to the two AO-indeces if they are
*     different symmetries.
               Else
                  Do iKap = 1,nBas(iSym_C)
                     Do iLam = 1,nBas(iSym_D)
                        iLamKap1 = iLam-1 + (iKap-1)*nBas(iSym_D)
                        iLamKap2 = iKap-1 + (iLam-1)*nBas(iSym_C)
                        If(NonZeroSym(1) .and. NonZeroSym(2)) Then
                           Work(ipTemp2 + iLamKap1) =
     &                          (Work(ipTemp1+iLamKap1)
     &                          +  Work(ipTemp1_2 + iLamKap2))/2
                        Else If(NonZeroSym(1)) Then
                           Work(ipTemp2 + iLamKap1) =
     &                          Work(ipTemp1 + iLamKap1)/2
                        Else If(NonZeroSym(2)) Then
                           Work(ipTemp2 + iLamKap1) =
     &                          Work(ipTemp1_2 + iLamKap2)/2
                        End If
                     End Do
                  End Do
               End If
*
*     Place the result in a bin. A bin has fixed Lambda and Kappa and
*     includes Ti,a,lam,kap as well as i,a-adress
               iIA = iA-1 + (iI-1)*nA
               Do iKap = 1, nBas(iSym_C)
                  nLam = nBas(iSym_D)
                  If(Triangular) nLam = iKap
                  Do iLam = 1, nLam
                     iRec = iLam-1 + (iKap-1)*nBas(iSym_D)
                     If(Triangular) Then
                        iBin = iTri(iKap,iLam)
                     Else
                        iBin = iRec+1
                     End If
*                    Write (*,*) 'iKap,iLam,iBin=',iKap,iLam,iBin
                     iNextX = nInt(Work(ipBin+iBinOff(0,1,iBin)))
                     iNextX = iNextX + 1
                     iBinSize = iNextX*2 + 2
                     If(iBinSize .gt. iBinLength) Then
                        iLastAdr = iAdrBin
                        Call dDaFile(LuBin,1,
     &                               Work(ipBin+iBinOff(0,1,iBin)),
     &                               iBinLength,iAdrBin)
                        iNextX = 1
                        Work(ipBin+iBinOff(0,1,iBin)) = 0.0d0
                        Work(ipBin+iBinOff(0,2,iBin)) = dble(iLastAdr)
                     End If
*                    Write (*,*) Work(ipTemp2 + iRec), Dble(iIA), iBin
                     Work(ipBin + iBinOff(iNextX,2,iBin)) =
     &                    Work(ipTemp2 + iRec)
                     Work(ipBin + iBinOff(iNextX,1,iBin)) =
     &                    Dble(iIA)
                     Work(ipBin+iBinOff(0,1,iBin)) = dble(iNextX)
                  End Do
               End Do
            End Do              !iA
         End Do                 !iI
*
*     Now there is a second loop over everything to fix the mu-nu-symmetrization
*
         If(Triangular) Go To 300
         Do iI = 1, nI2
            Do iA =  1, nA2
               If(NonZeroSym(3)) Then
                  Call Exch(iSym_D,iSym_B,iSym_C,iSym_A,
     &                 iI+nFro(iSym_B), iA+nFro(iSym_A)+nOcc(iSym_A),
     &                 Work(ipInt1),Work(ipScr1))
                  Call Coul(iSym_D,iSym_C,iSym_B,iSym_A,
     &                 iI+nFro(iSym_B),iA+nFro(iSym_A)+nOcc(iSym_A),
     &                 Work(ipInt2),Work(ipScr1))
#ifdef _DEBUGPRINT_
                  Write(6,*) ' *  I,A = ',iI, iA
                  Call RecPrt('Int1_lap2:','(8F10.6)',Work(ipInt1),
     &                 nOrb(iSym_D)+nDel(iSym_D),
     &                 nOrb(iSym_C)+nDel(iSym_C))
                  Write(6,*) ' *  I,A = ',iI, iA
                  Call RecPrt('Int2_lap2:','(8F10.6)',Work(ipInt2),
     &                 nOrb(iSym_D)+nDel(iSym_D),
     &                 nOrb(iSym_C)+nDel(iSym_C))
#endif
               End If
*
               If(NonZeroSym(4)) Then
                  Call Exch(iSym_C,iSym_B,iSym_D,iSym_A,
     &                 iI+nFro(iSym_B), iA+nFro(iSym_A)+nOcc(iSym_A),
     &                 Work(ipInt1_2),Work(ipScr1))
                  Call Coul(iSym_C,iSym_D,iSym_B,iSym_A,
     &                 iI+nFro(iSym_B),iA+nFro(iSym_A)+nOcc(iSym_A),
     &                 Work(ipInt2_2),Work(ipScr1))
#ifdef _DEBUGPRINT_
                  Write(6,*) ' *  I,A = ',iI, iA
                  Call RecPrt('Int1_lap2:','(8F10.6)',Work(ipInt1_2),
     &                 nOrb(iSym_C)+nDel(iSym_C),
     &                 nOrb(iSym_D)+nDel(iSym_D))
                  Write(6,*) ' *  I,A = ',iI, iA
                  Call RecPrt('Int2_lap:','(8F10.6)',Work(ipInt2_2),
     &                 nOrb(iSym_C)+nDel(iSym_C),
     &                 nOrb(iSym_D)+nDel(iSym_D))
#endif
               End If
*     Construct Tiajb for a specific (i,a)-pair
               If(NonZeroSym(3)) Then
                  Do iJ = 1, nJ
                     Do iB = 1, nB
                        xiajb = Work(ipInt2 +iInt1(iB,iJ,iSym_D,iSym_C))
                        xibja = Work(ipInt1 +iInt1(iB,iJ,iSym_D,iSym_C))
                        EDenom =(work(mAdOcc(iSym_B)+iI-1)
     &                       +   work(mAdOcc(iSym_C)+iJ-1)
     &                       -   work(mAdVir(iSym_A)+iA-1)
     &                       -   work(mAdVir(iSym_D)+iB-1)  )
                        Tiajb = (2.0d0*xiajb - xibja)/EDenom
                        Work(ipTemp1 + (iJ-1)*nB + iB-1) = Tiajb
                     End Do     !iSymB
                  End Do        !iSymJ
               End If
*
               If(NonZeroSym(4)) Then
                  Do iJ = 1, nJ2
                     Do iB = 1, nB2
                        xiajb =Work(ipInt2_2+iInt1(iB,iJ,iSym_C,iSym_D))
                        xibja =Work(ipInt1_2+iInt1(iB,iJ,iSym_C,iSym_D))
                        EDenom =(work(mAdOcc(iSym_B)+iI-1)
     &                         + work(mAdOcc(iSym_D)+iJ-1)
     &                         - work(mAdVir(iSym_A)+iA-1)
     &                         - work(mAdVir(iSym_C)+iB-1)  )
                        Tiajb = (2.0d0*xiajb - xibja)/EDenom

                        Work(ipTemp1_2 + (iJ-1)*nB2 + iB-1) = Tiajb
                     End Do     !iSymB
                  End Do        !iSymJ
               End If
*     Do first halftransformation.
               If(NonZeroSym(3)) Then
                  Call dGemm_('N','N',nBas(iSym_D),nOcc(iSym_C),
     &                 nExt(iSym_D),1.0d0,
     &                 Work(ipCMO_v+iOffCMO_v(iSym_D)),nBas(iSym_D),
     &                 Work(ipTemp1),nExt(iSym_D),0.0d0,
     &                 Work(ipTemp2),nBas(iSym_D))
                  Call dGemm_('N','T',nBas(iSym_D),nBas(iSym_C),
     &                 nOcc(iSym_C),1.0d0,
     &                 Work(ipTemp2),nBas(iSym_D),
     &                 Work(ipCMO_o+iOffCMO_o(iSym_C)),nBas(iSym_C),
     &                 0.0d0,Work(ipTemp1),nBas(iSym_D))
               End If
*
               If(NonZeroSym(4)) Then
                  Call dGemm_('N','N',nBas(iSym_C),nOcc(iSym_D),
     &                 nExt(iSym_C),1.0d0,
     &                 Work(ipCMO_v+iOffCMO_v(iSym_C)),nBas(iSym_C),
     &                 Work(ipTemp1_2),nExt(iSym_C),0.0d0,
     &                 Work(ipTemp2_2),nBas(iSym_C))
                  Call dGemm_('N','T',nBas(iSym_C),nBas(iSym_D),
     &                 nOcc(iSym_D),1.0d0,
     &                 Work(ipTemp2_2),nBas(iSym_C),
     &                 Work(ipCMO_o+iOffCMO_o(iSym_D)),nBas(iSym_D),
     &                 0.0d0,Work(ipTemp1_2),nBas(iSym_C))
               End If
*     Do a halfsymmetrization with respect to the two AO-indeces if they are
*     the same symmetry.
               Do iKap = 1,nBas(iSym_C)
                  Do iLam = 1,nBas(iSym_D)
                     iLamKap1 = iLam-1 + (iKap-1)*nBas(iSym_D)
                     iLamKap2 = iKap-1 + (iLam-1)*nBas(iSym_C)
                     If(NonZeroSym(3) .and. NonZeroSym(4)) Then
                        Work(ipTemp2 + iLamKap1) =
     &                       (Work(ipTemp1+iLamKap1)
     &                       +  Work(ipTemp1_2 + iLamKap2))/2
                     Else If(NonZeroSym(3)) Then
                        Work(ipTemp2 + iLamKap1) =
     &                       Work(ipTemp1 + iLamKap1)/2
                     Else If(NonZeroSym(4)) Then
                        Work(ipTemp2 + iLamKap1) =
     &                       Work(ipTemp1_2 + iLamKap2)/2
                     End If
                  End Do
               End Do
*
               iIA = iA-1 + (iI-1)*nA2
               Do iKap = 1, nBas(iSym_C)
                  Do iLam = 1, nBas(iSym_D)
                     iRec = iLam-1 + (iKap-1)*nBas(iSym_D)
                     iBin = iRec+1
*                    Write (*,*) 'iKap,iLam,iBin=',iKap,iLam,iBin
                     iNextX = nInt(Work(ipBin2+iBinOff(0,1,iBin)))
                     iNextX = iNextX + 1
*
                     iBinSize = iNextX*2 + 2
                     If(iBinSize .gt. iBinLength) Then
                        Call dDaFile(LuBin,1,
     &                               Work(ipBin2+iBinOff(0,1,iBin)),
     &                               iBinLength,iAdrBin)
                        iNextX = 1
                        Work(ipBin2+iBinOff(0,1,i)) = 0.0d0
                        Work(ipBin2+iBinOff(0,2,i)) = dble(iAdrBin)
                     End If
*
*                    Write (*,*) Work(ipTemp2 + iRec), Dble(iIA), iBin
                     Work(ipBin2 + iBinOff(iNextX,2,iBin)) =
     &                    Work(ipTemp2 + iRec)
                     Work(ipBin2 + iBinOff(iNextX,1,iBin)) =
     &                    Dble(iIA)
                     Work(ipBin2+iBinOff(0,1,iBin)) = dble(iNextX)
                  End Do
               End Do
            End Do              !iA
         End Do                 !iI


 300     Continue

*     Read the halftransformed integrals from one bin at the time
*     and do the two remaining transformations.

*        Write (*,*) 'Do the second half transformation'
 500     Do iBin = 1, nBins
            If(NonZeroSym(1) .or. NonZeroSym(2)) Then
               Done = .false.
 200           If(.not.Done) Then
                  iLen = nInt(Work(ipBin+iBinOff(0,1,iBin)))
                  Do i = 1, iLen
                     iIA = nInt(Work(ipBin+iBinOff(i,1,iBin)))
                     Work(ipTemp1+ iIA) = Work(ipBin+iBinOff(i,2,iBin))
                  End Do

                  iNextAdr = nInt(Work(ipBin+iBinOff(0,2,iBin)))
                  If(iNextAdr.eq.-1) Then
                     Done = .True.
                  Else
                     iAdrRdBin = iNextAdr
                     Call dDaFile(LuBin,2,Work(ipBin+iBinOff(0,1,iBin)),
     &                            iBinLength,iAdrRdBin)
                  End If
                  Go To 200
               End If
*     Do second halftransformation
               Call dGemm_('N','N',nBas(iSym_B),nOcc(iSym_A),
     &              nExt(iSym_B),1.0d0,
     &              Work(ipCMO_v+iOffCMO_v(iSym_B)),nBas(iSym_B),
     &              Work(ipTemp1),nExt(iSym_B),0.0d0,
     &              Work(ipTemp2),nBas(iSym_B))
               Call dGemm_('N','T',nBas(iSym_B),nBas(iSym_A),
     &              nOcc(iSym_A),1.0d0,
     &              Work(ipTemp2),nBas(iSym_B),
     &              Work(ipCMO_o+iOffCMO_o(iSym_A)),nBas(iSym_A),
     &              0.0d0,Work(ipTemp1),nBas(iSym_B))
*              Call RecPrt('(m,n,i,k)',' ',Work(ipTemp1),
*    &                     nBas(iSym_B),nBas(iSym_A))
            End If
*
            If((NonZeroSym(3) .or. NonZeroSym(4)) .and.
     &          (.not.Triangular)) Then
               Done = .false.
 400           If(.not.Done) Then
                  iLen = nInt(Work(ipBin2+iBinOff(0,1,iBin)))
                  Do i = 1, iLen
                     iIA = nInt(Work(ipBin2+iBinOff(i,1,iBin)))
                     Work(ipTemp1_2+ iIA) =
     &                               Work(ipBin2+iBinOff(i,2,iBin))
                  End Do
*
                  iNextAdr = nInt(Work(ipBin2+iBinOff(0,2,iBin)))
                  If(iNextAdr.eq.-1) Then
                     Done = .True.
                  Else
                     iAdrRdBin = iNextAdr
                     Call dDaFile(LuBin,2,
     &                            Work(ipBin2+iBinOff(0,1,iBin)),
     &                            iBinLength,iAdrRdBin)
                  End If
                  Go To 400
               End If
               Call dGemm_('N','N',nBas(iSym_A),nOcc(iSym_B),
     &              nExt(iSym_A),1.0d0,
     &              Work(ipCMO_v+iOffCMO_v(iSym_A)),nBas(iSym_A),
     &              Work(ipTemp1_2),nExt(iSym_A),0.0d0,
     &              Work(ipTemp2_2),nBas(iSym_A))
               Call dGemm_('N','T',nBas(iSym_A),nBas(iSym_B),
     &              nOcc(iSym_B),1.0d0,
     &              Work(ipTemp2_2),nBas(iSym_A),
     &              Work(ipCMO_o+iOffCMO_o(iSym_B)),nBas(iSym_B),
     &              0.0d0,Work(ipTemp1_2),nBas(iSym_A))
            End If
*     Do the second symmetrization. (of the mu and nu-index)
            If(Triangular) Then
               Do iMu = 1,nBas(iSym_A)
                  nNu = nBas(iSym_B)
                  If(Triangular) nNu = iMu
                  Do iNu = 1,nNu
                     iTriMuNu = iTri(iNu,iMu) - 1
                     iMuNu1 = iNu-1 + (iMu-1)*nBas(iSym_B)
                     iMuNu2 = iMu-1 + (iNu-1)*nBas(iSym_A)
                     Work(ipTemp2+iTriMuNu) =
     &                    (Work(ipTemp1+iMuNu1)
     &                    + Work(ipTemp1+iMuNu2))/2
                  End Do
               End Do
            Else
               Do iMu = 1, nBas(iSym_A)
                  Do iNu = 1, nBas(iSym_B)
                     iMuNu1 = iNu-1 + (iMu-1)*nBas(iSym_B)
                     iMuNu2 = iMu-1 + (iNu-1)*nBas(iSym_A)
                     If((NonZeroSym(1) .or. NonZeroSym(2)) .and.
     &                  (NonZeroSym(3) .or. NonZeroSym(4))) Then
                        Work(ipTemp2 + iMuNu1) =
     &                       (Work(ipTemp1+iMuNu1)
     &                       + Work(ipTemp1_2+iMuNu2))/2
                     Else If(NonZeroSym(1) .or. NonZeroSym(2)) Then
                        Work(ipTemp2 + iMuNu1) =
     &                       Work(ipTemp1 + iMuNu1)/2
                     Else If(NonZeroSym(3) .or. NonZeroSym(4)) Then
                        Work(ipTemp2 + iMuNu1) =
     &                       Work(ipTemp1_2 + iMuNu2)/2
                     End If
                  End Do
               End Do
            End If
*           Fix the special case with empty iajb:s but "nonempty"
*           (mu nu|kap lam)
            If(LoadZeros) Then
               Call FZero(Work(ipTemp2), ltemp)
            End If
*
*     Store the result on disk.
            If(Triangular) Then
               iSize = nBas(iSym_A)*(nBas(iSym_A)+1)/2
#ifdef _DEBUGPRINT_
               Call TriPrt('(Gamma)',' ',Work(ipTemp2),
     &                     nBas(iSym_A))
#endif
            Else
               iSize = nBas(iSym_A)*nBas(iSym_B)
#ifdef _DEBUGPRINT_
               Call RecPrt('(Gamma)',' ',Work(ipTemp2),
     &                     nBas(iSym_A),nBas(iSym_B))
#endif
            End If
            Call dDaFile(LuGam,1,Work(ipTemp2),iSize,
     &                   iAdrGam)
         End Do
         LoadZeros = .false.
 100     Continue
      End Do
*
      Call DaClos(LuGam)
      Call DaClos(LuBin)
*
*     Deallocate memory
*
      Call GetMem('iTable','Free','Inte',ipiTab,6*nBlocks)
      Call GetMem('CMO_occ','Free','Real',ipCMO_o,lCMO_o)
      Call GetMem('CMO_vir','Free','Real',ipCMO_v,lCMO_v)
*
      Call GetMem('Temp1','Free','Real',ipTemp1,lTemp)
      Call GetMem('Temp2','Free','Real',ipTemp2,lTemp)
      Call GetMem('Bins','Free','Real',ipBin,lAllBins)
*
      If(nBlocks .ne. 1) Then
         Call GetMem('Temp1_1','Free','Real',ipTemp1_2,lTemp)
         Call GetMem('Temp2_2','Free','Real',ipTemp2_2,lTemp)
         Call GetMem('Bins2','Free','Real',ipBin2,lAllBins)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module RICD_Info

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: nLen = 10 ! number of elements
integer(kind=iwp) :: iRI_Type = -1
real(kind=wp) :: Thrshld_CD = 1.0e-4_wp
logical(kind=iwp) :: Cho_OneCenter = .false., &
                     Cholesky = .false., &
                     DiagCheck = .false., &
                     Do_acCD_Basis = .true., &
                     Do_RI = .false., &
                     LDF = .false., &
                     LocalDF = .false., &
                     Skip_High_AC = .false.

public :: Cho_OneCenter, Cholesky, DiagCheck, Do_acCD_Basis, Do_RI, iRI_Type, LDF, LocalDF, RICD_Info_Dmp, RICD_Info_Get, &
          Skip_High_AC, Thrshld_CD

contains

subroutine RICD_Info_Dmp()

  use stdalloc, only: mma_allocate, mma_deallocate
  use Constants, only: Zero, One

  real(kind=wp), allocatable :: rDmp(:)

  call mma_allocate(rDmp,nLen,Label='rDmp:RICD')

  rDmp(01) = real(iRI_Type,kind=wp)
  rDmp(02) = merge(One,Zero,LDF)
  rDmp(03) = merge(One,Zero,Do_RI)
  rDmp(04) = merge(One,Zero,Cholesky)
  rDmp(05) = merge(One,Zero,Do_acCD_Basis)
  rDmp(06) = merge(One,Zero,Skip_High_AC)
  rDmp(07) = merge(One,Zero,Cho_OneCenter)
  rDmp(08) = merge(One,Zero,DiagCheck)
  rDmp(09) = merge(One,Zero,LocalDF)
  rDmp(10) = Thrshld_CD

  call Put_dArray('RICD_Info',rDmp,nLen)
  call mma_deallocate(rDmp)

end subroutine RICD_Info_Dmp

subroutine RICD_Info_Get()

  use stdalloc, only: mma_allocate, mma_deallocate
  use Constants, only: Zero

  real(kind=wp), allocatable :: rDmp(:)

  call mma_allocate(rDmp,nLen,Label='rDmp:RICD')
  call Get_dArray('RICD_Info',rDmp,nLen)

  iRI_Type = nint(rDmp(1))
  LDF = rDmp(2) > Zero
  Do_RI = rDmp(3) > Zero
  Cholesky = rDmp(4) > Zero
  Do_acCD_Basis = rDmp(5) > Zero
  Skip_High_AC = rDmp(6) > Zero
  Cho_OneCenter = rDmp(7) > Zero
  DiagCheck = rDmp(8) > Zero
  LocalDF = rDmp(9) > Zero
  Thrshld_CD = rDmp(10)

  call mma_deallocate(rDmp)

end subroutine RICD_Info_Get

end module RICD_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!> Read information provided on runfile/jobiph files and
!> initialize pt2wfn file
subroutine pt2init(refwfn_in)

#ifdef _DMRG_
use qcmaquis_info, only: qcm_group_names
use qcmaquis_interface, only: qcmaquis_interface_measure_and_save_trans3rdm, qcmaquis_interface_get_3rdm_elements, &
                              qcmaquis_interface_get_4rdm_elements
use qcmaquis_interface_utility_routines, only: str
#endif
#ifdef _HDF5_QCM_
use hdf5_utils, only: hdf5_init, hdf5_close, hdf5_exit, hdf5_get_data, hdf5_open
use mh5, only: mh5_is_hdf5
#endif
use refwfn, only: refwfn_init, refwfn_info, refwfn_data, refwfn_close
use nevpt2_cfg, only: curr_dir, do_cholesky, igelo, molcas_project, MultGroup, nr_active_electrons, nr_frozen_orb, nr_states, nspin
use info_state_energy, only: e, init_energies                                                     ! energies
use info_orbital_space, only: datadim, file_id, ijklname, inforb_molcas, initialize_inforb_molcas ! orbital specifications read from JobIph
use nevpt2wfn, only: nevpt2wfn_init, nevpt2wfn_data
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: refwfn_in
character(len=:), allocatable :: refwfnfile
integer(kind=iwp) :: istate, ii, j, nDiff, nishprev, nfroprev
integer(kind=iwp), allocatable :: nCore_local(:)
real(kind=wp), allocatable :: readbuf(:,:)
#include "mxdm.fh"
#include "caspt2.fh"

! Save current directory into the CurrDir string
call GetEnvF('CurrDir',curr_dir)
call GetEnvF('Project',molcas_project)

! call the Molcas routine to check whether we're using Cholesky
call DecideOnCholesky(do_cholesky)
! read some stuff from RunFile, just as CASPT2 does
call Get_iScalar('nSym',nSym)
! Symmetry with Cholesky decomposition is not supported yet!
if ((nSym > 1) .and. do_cholesky) then
  call WarningMessage(1,'Symmetry with Cholesky decomposition is not supported yet!')
  call Quit_OnUserError()
end if
write(u6,*) 'Cholesky Decomposition: ',merge('Enabled ','Disabled',do_cholesky)

!> set up AO basis information (needed for post-NEVPT2 information transfer)
call Get_iArray('nBas',nBas,nSym)
nbast = sum(nbas(1:nsym))
nbsqt = sum(nbas(1:nsym)**2)

!> TODO: Read more stuff, such as the information about the active
!> space from the JobIph file, or at least add some consistency checks

!> open files in analogy to CASPT2
LUONEM = 16
call DANAME_wa(LUONEM,'MOLONE')

! We can only open HDF5 files, so if no HDF5 file is specified in the input
! or JOBIPH is not a HDF5 file, try to find the corresponding HDF5 file,
! if not found, exit

#ifdef _HDF5_

#ifdef _WARNING_WORKAROUND_
! fix a compiler warning/error about possibly uninitialized variables
allocate(character(len=0) :: refwfnfile)
#endif
refwfnfile = trim(refwfn_in)
if (.not. mh5_is_hdf5(refwfnfile)) then
  ! try $Project.dmrgscf.h5
  refwfnfile = trim(molcas_project)//'.dmrgscf.h5'
  if (.not. mh5_is_hdf5(refwfnfile)) then
    ! try $Project.rasscf.h5
    refwfnfile = trim(molcas_project)//'.rasscf.h5'
    if (.not. mh5_is_hdf5(refwfnfile)) then
      call WarningMessage(1,'Cannot find a HDF5 file with the reference wavefunction. Make sure that file '// &
                          trim(molcas_project)//'.rasscf.h5 or .dmrgscf.h5 exists')
      call Quit_OnUserError()
    end if
  end if
end if
#else
call WarningMessage(1,'Please compile OpenMolcas with HDF5 support for NEVPT2 to work')
call Quit_OnUserError()
#endif
call refwfn_init(refwfnfile)
call refwfn_info()
call refwfn_data()
call refwfn_close()

!> fill nevpt2 confuguration variables from caspt2.fh commons
!> ----------------------------------------------------------

!> check if nr_states has been requested as 'all'
if (nr_states == 0) then
  ! using standard allocate and deallocate because MultGroup%State
  ! is deallocated somewhere in the external library
  if (allocated(MultGroup%State)) deallocate(MultGroup%State)
  !> nstate from common block in caspt2.fh
  nr_states = nstate
  allocate(MultGroup%State(nr_states))
  do istate=1,nr_states
    MultGroup%State(istate) = istate
  end do
end if

!> spin & number of active electrons
nspin = ispin
nr_active_electrons = nactel

write(u6,'(/a)') ' Wavefunction parameters for NEVPT2'
write(u6,'(a )') ' ----------------------------------'
write(u6,'(a,i4)') ' Number of active electrons ....... ',nr_active_electrons
write(u6,'(a,i4)') ' Spin ............................. ',nspin

! read the info about orbital spaces and initialise
! the NEVPT2 inforb array

! Read orbital specifications and store them in the inforb_molcas
! variable from info_orbital_space

! nish, nash and nssh are in caspt2.fh (Common /INPI/ and have been
! read by the refwfn module
call initialize_inforb_molcas(nSym)

if (maxval(nfro) /= 0) then
  ! Leon: a workaround if frozen orbitals in MCSCF have been detected:
  ! MCSCF frozen orbitals MUST count as active here and then added
  ! to igelo(:) later, otherwise the orbital numbers do not match!
  write(u6,*) 'Frozen orbitals in MCSCF detected.'
  inforb_molcas%nish(1:nSym) = nfro(1:nSym)+nish(1:nSym)
else
  inforb_molcas%nish(1:nSym) = nish(1:nSym)
end if

! Read frozen orbitals from ijkl.h5 files produced by MOTRA
! we need this information now to calculate the number of frozen
! orbitals correctly

! warning! are we sure that nsym here is the same as nsym in hdf5?

! is norb from MOTRA the same as nBas or not? or is it nBas-nfro-ndel?
! In any case, we're reading the value from MOTRA just to be consistent
#ifdef _HDF5_QCM_
call hdf5_init()
call hdf5_open(ijklname,file_id(2)) ! open ijkl.h5
datadim(1) = nsym
call mma_allocate(readbuf,nsym,3,label='readbuf')
readbuf(:,:) = -1
call hdf5_get_data(file_id(2),'norb  ',datadim,readbuf(1,1))
call hdf5_get_data(file_id(2),'nfro  ',datadim,readbuf(1,2))
call hdf5_get_data(file_id(2),'ndel  ',datadim,readbuf(1,3))
inforb_molcas%norb(1:nSym) = nint(readbuf(1:nSym,1))
inforb_molcas%nfro(1:nSym) = nint(readbuf(1:nSym,2))
inforb_molcas%ndel(1:nSym) = nint(readbuf(1:nSym,3))
call mma_deallocate(readbuf)

call hdf5_close(file_id(2)) ! close ijkl.h5
call hdf5_exit()
#else
! Should never be the case!
call WarningMessage(1,'HDF5 QCMaquis interface not enabled, cannot continue!')
call Abend()
#endif
! Detect frozen orbitals from reference wavefunction, if there was
! no input wrt frozen orbitals

if (.not. allocated(igelo)) then
  if (nr_frozen_orb /= -1) then
    ! Autodetect frozen orbitals:

    ! If nr_frozen_orb is set to -1 in rdinput()
    ! it's to signal that # of frozen orbs has
    ! been forcibly set to 0
    ! no allocated frozen orbitals -> no frozen input
    ! hence try to guess frozen orbitals from reference wavefunction

    ! Correct the # of frozen orbitals just as it is done in CASPT2
    call mma_allocate(nCore_local,nSym,label='nCore_local')
    call Get_iArray('Non valence orbitals',nCore_local,nSym)
    do ii=1,nSym
      if (nCore_local(ii) > nFro(ii)) then
        nDiff = nCore_local(ii)-nFro(ii)
        nDiff = min(nDiff,nISh(ii))
        nFro(ii) = nFro(ii)+nDiff
        nISh(ii) = nISh(ii)-nDiff
      end if
    end do
    call mma_deallocate(nCore_local)

    ! Check if orbitals have been frozen in MOTRA
    if (maxval(inforb_molcas%nfro(1:nSym)) > 0) then
      do ii=1,nSym
        nFro(ii) = nFro(ii)-inforb_molcas%nfro(ii)
        if (nFro(ii) < 0) then
          call WarningMessage(1,'Warning: Additional frozen orbitals in MOTRA.')
          nFro(ii) = 0
        end if
      end do
    end if

    ! calculate total # of frozen orbitals
    nr_frozen_orb = 0
    do ii=1,nSym
      nr_frozen_orb = nr_frozen_orb+nFro(ii)
    end do

    ! using standard allocate because igelo
    ! is deallocated somewhere in the external library
    allocate(igelo(nr_frozen_orb))
    ! fill igelo by symmetry
    !! TODO: Check here for what has been frozen in MOTRA and subtract it (!!)
    do ii=1,nSym
      if (ii == 1) then
        nishprev = 0
        nfroprev = 0
      else
        nishprev = nfro(ii-1)+nish(ii-1)
        nfroprev = nfro(ii-1)
      end if
      do j=1,nfro(ii)
        igelo(nfroprev+j) = nishprev+j
      end do
    end do
  else
    ! Reset nr_frozen_orb back to 0, as we have been signalled with
    ! nr_frozen_orb = -1 from rdinput that frozen orbs have been forcibly
    ! reset to zero
    nr_frozen_orb = 0
  end if
else
  if (maxval(inforb_molcas%nfro(1:nSym)) > 0) then
    call WarningMessage(2,'Warning: Orbitals have been frozen in MOTRA and manual freeze specification has been provided in '// &
                        'NEVPT2 input. Make sure you are not double-counting the frozen orbitals!')
  end if
end if

inforb_molcas%nash(1:nSym) = nash(1:nSym)
inforb_molcas%nssh(1:nSym) = nssh(1:nSym)
inforb_molcas%nbas(1:nSym) = nbas(1:nSym)
inforb_molcas%nbast = nbast
inforb_molcas%ncmo = ncmo
inforb_molcas%nbsqt = nbsqt

if (maxval(inforb_molcas%nfro(1:nSym)) > 0) then
  write(u6,'(a,8(18i4))') ' Frozen orbitals from MOTRA ....... ',(inforb_molcas%nfro(ii),ii=1,nSym)
end if

write(u6,'(a,8(18i4))') ' Inactive orbitals ................ ',(inforb_molcas%nish(ii),ii=1,nSym)
write(u6,'(a,8(18i4))') ' Active orbitals .................. ',(inforb_molcas%nash(ii),ii=1,nSym)
write(u6,'(a,8(18i4))') ' Secondary orbitals ............... ',(inforb_molcas%nssh(ii),ii=1,nSym)

if (maxval(inforb_molcas%ndel(1:nSym)) > 0) then
  write(u6,'(a,8(18i4))') ' Deleted orbitals from MOTRA..... ',(inforb_molcas%ndel(ii),ii=1,nSym)
end if

write(u6,'(a/)') ' ----------------------------------'

call init_energies(nr_states)

write(u6,'(a)') ' Energies of zeroth-order DMRG wavefunction(s)'
write(u6,'(a)') ' ---------------------------------------------'
do istate=1,nr_states
  !> copy reference energies
  e(istate) = refene(MultGroup%State(istate))
  write(u6,'(a,i4,a,f18.8)') ' State ...',MultGroup%State(istate),' ... Energy = ',e(istate)
end do
write(u6,'(a/)') ' ---------------------------------------------'

#ifdef _DMRG_
if (allocated(qcm_group_names)) then
  write(u6,'(a)') ' DMRG wavefunction data will be read from'
  write(u6,'(a)') ' ----------------------------------------'
  if (.not. allocated(MultGroup%h5_file_name)) call mma_allocate(MultGroup%h5_file_name,nr_states,label='h5_file_name')
  MultGroup%h5_file_name = ''
  do istate=1,nr_states
    MultGroup%h5_file_name(istate) = trim(qcm_group_names(1)%states(MultGroup%State(istate)))
    !> copy reference wfn file names
    write(u6,'(a,i4,a,a)') ' State ...',MultGroup%State(istate),' .......................... ', &
                           trim(qcm_group_names(1)%states(MultGroup%State(istate)))
  end do
  write(u6,'(a/)') ' ----------------------------------------'
end if
#endif

!> Create the PT2 wavefunction file. The reference file should not be active,
!> as it might be the same file (in which case it is overwritten).
call nevpt2wfn_init(.true.)
call nevpt2wfn_data()

end subroutine pt2init

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Guess(CMO)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Diagonalize core Hamiltonian to get starting orbitals.           *
!                                                                      *
!     calling arguments:                                               *
!     CMO     : real*8, output                                         *
!               starting vectors                                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1998                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use general_data, only: NBAS, NSYM, NTOT1
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: CMO(*)
integer(kind=iwp) :: i1, i2, iBas, iComp, iOpt, iRC, iSyLbl, iSym
character(len=8) :: Label
real(kind=wp), allocatable :: Tmp1(:)
#include "warnings.h"

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! allocate work space
call mma_allocate(Tmp1,nTot1,Label='Tmp1')

! load bare nuclei Hamiltonian

iRc = -1
iOpt = ibset(ibset(0,sNoOri),sNoNuc)
iComp = 1
iSyLbl = 1
Label = 'OneHam  '
call RdOne(iRc,iOpt,Label,iComp,Tmp1,iSyLbl)
if (iRc /= 0) then
  write(u6,*) ' RASSCF tried to construct start orbitals from'
  write(u6,*) ' diagonalization of core Hamiltonian, but ran into'
  write(u6,*) ' a severe error: Failed to read the Hamiltonian'
  write(u6,*) ' from the ONEINT file. Something may be wrong with'
  write(u6,*) ' the file.'
  call Quit(_RC_IO_ERROR_READ_)
end if

! diagonalize bare nuclei Hamiltonian

i1 = 1
i2 = 1
do iSym=1,nSym
  iBas = nBas(iSym)
  call unitmat(CMO(i2),iBas)
  call Jacob(Tmp1(i1),CMO(i2),iBas,iBas)
  call JacOrd(Tmp1(i1),CMO(i2),iBas,iBas)
  i1 = i1+nTri_Elem(iBas)
  i2 = i2+iBas*iBas
end do

! deallocate work space
call mma_deallocate(Tmp1)

end subroutine Guess

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1999, Markus P. Fuelscher                         *
*               1993, Per Ake Malmqvist                                *
************************************************************************
      Subroutine PKI4(nData,nByte,InBuf,OutBuf)
************************************************************************
*                                                                      *
*     purpose: pack Integers                                           *
*                                                                      *
*    Calling parameters:                                               *
*    nData : number of unpacked integrals                              *
*    nByte : length of pack array in bytes                             *
*    InBuf : contains on input unpack integers                         *
*    OutBuf: contains packed integers on output                        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and P. A. Malmqvist                               *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     replace various older versions of the algorithm                  *
*     M.P. Fuelscher, University of Lund, Sweden, 1999                 *
*                                                                      *
************************************************************************
*
      Integer InBuf(nData)
      Integer OutBuf(*)
      Call cPKI4(OutBuf)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine cPKI4(OutBuf)
      Use Iso_C_Binding
      Integer, Target :: OutBuf(*)
      Character, Pointer :: cOutBuf(:)
*
*----------------------------------------------------------------------*
*
      iOpt = 1
      Call C_F_Pointer(C_Loc(OutBuf(1)),cOutBuf,[1])
      Call izip(iOpt,nData,nByte,InBuf,cOutBuf)
      Nullify(cOutBuf)
*
*----------------------------------------------------------------------*
*
      Return
      End Subroutine cPKI4
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!SVC: modified to convert to the use of byte lengths/offsets by the
!     underlying I/O routines (2016)

subroutine cDaFile(Lu,iOpt,Buf,lBuf_,iDisk_)

use Fast_IO, only: MBL
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: Lu, iOpt, lBuf_
character, intent(inout) :: Buf(lBuf_)
integer(kind=iwp), intent(inout) :: iDisk_
integer(kind=iwp) :: lBuf, iDisk

lBuf = lBuf_
iDisk = iDisk_*MBL(Lu)

call bDaFile(Lu,iOpt,Buf,lBuf,iDisk)

iDisk_ = (iDisk+MBL(Lu)-1)/MBL(Lu)

return

end subroutine cDaFile

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022-2023, Vladislav Kochetov                          *
!               2023, Thies Romig                                      *
!***********************************************************************

subroutine equation_sph(time,rhot,res)
!***********************************************************************
! Purpose : RHS of Liouville equation is obtained here in ITOs basis
!
!***********************************************************************
!
!  time   : current time
!  rhot   : density matrix at current time
!  res    : obtained RHS of Liouville equation d(rhot)/d(time)

use rhodyn_data, only: d, flag_pulse, hamiltonian, hamiltoniant, ipglob, k_max, k_ranks, len_sph, lroots, mirr, n, q_max, q_proj, &
                       Y1, Y2
use rhodyn_utils, only: get_kq_order
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cOne, cZero, Onei
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: time
complex(kind=wp), intent(in) :: rhot(len_sph,d,d)
complex(kind=wp), intent(out) :: res(len_sph,d,d)
integer(kind=iwp) :: c, i, k, K_prime, l, l_prime, m, n1, n2, q
complex(kind=wp), allocatable :: rhot_tmp(:), res_tmp(:)

if (ipglob > 3) write(u6,*) 'solve equation, time: ',time

! number of states with ground state spin to distinguish contributions to different spin manifolds
! now works only with 2 spin manifolds
!ngs = lroots(1)

! if pulse is enabled, modify Hamiltonian at time t:
if (flag_pulse) call pulse(hamiltonian,hamiltoniant,time,-1)

call mma_allocate(rhot_tmp,d**2)
call mma_allocate(res_tmp,d**2)

i = 1
do l=1,len_sph
  k = k_ranks(l)
  q = q_proj(l)
  if ((q >= -q_max) .and. (q <= 0)) then
    ! get right part of Liouville equation -i*(hamiltoniant*rhot - rhot*hamiltoniant)
    rhot_tmp(:) = pack(rhot(l,:,:),.true.)
    call zgemm_('N','N',d,d,d,-Onei,hamiltoniant,d,rhot_tmp,d,cZero,res_tmp,d)
    call zgemm_('N','N',d,d,d,Onei,rhot_tmp,d,hamiltoniant,d,cOne,res_tmp,d)
    res(l,:,:) = reshape(res_tmp,[d,d])
    ! Vsoc contribution
    do m=1,3
      do K_prime=k-1,k+1,1
        if ((K_prime < 0) .or. (K_prime > k_max)) cycle
        if ((q-m+2 > K_prime) .or. (q-m+2 < -K_prime)) cycle
        l_prime = get_kq_order(K_prime,q-m+2)
        do c=1,n
          ! set boundaries for slice multiplication
          if (c == 1) then
            n1 = 1
            n2 = lroots(1)
          else
            n1 = n1+lroots(c-1)
            n2 = n2+lroots(c)
          end if
          rhot_tmp(1:d*lroots(c)) = pack(rhot(l_prime,:,n1:n2),.true.)
          call zgemm_('N','N',d,lroots(c),d,-Onei,Y1(:,:,i),d,rhot_tmp,d,cZero,res_tmp,d)
          res(l,:,n1:n2) = res(l,:,n1:n2)+reshape(res_tmp(1:d*lroots(c)),[d,lroots(c)])
          rhot_tmp(1:d*lroots(c)) = pack(rhot(l_prime,n1:n2,:),.true.)
          call zgemm_('N','N',lroots(c),d,d,-Onei,rhot_tmp,lroots(c),Y2(:,:,i),d,cZero,res_tmp,lroots(c))
          res(l,n1:n2,:) = res(l,n1:n2,:)+reshape(res_tmp(1:d*lroots(c)),[lroots(c),d])
          i = i+1
        end do
      end do
    end do
  ! mirror from q=-1 to q=1
  else if (q == 1) then
    res(l,:,:) = transpose(conjg(res(l-2,:,:)))*mirr
  end if
end do

call mma_deallocate(rhot_tmp)
call mma_deallocate(res_tmp)

end subroutine equation_sph

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Bruno Tenorio                                    *
!***********************************************************************

subroutine SDCHS(IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,PSI1,PSI2,IF20,IF02,SDCHSM)
! Calculates the DCH  matrix elements between two states with
! N and N-1 electrons, defined as:
! IF02 D = < N-2 | anni_right anni_right | N >, or
! IF20 D = < N | anni_left anni_left  | N-2 >
! reduced 2-electron tdm in the space of active spin-orbitals

use Index_Functions, only: nTri_Elem
use rassi_global_arrays, only: FSBANN1, FSBANN2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IORBTAB(*), ISSTAB(*), IFSBTAB1(*), IFSBTAB2(*)
real(kind=wp), intent(in) :: PSI1(*), PSI2(*)
logical(kind=iwp), intent(in) :: IF20, IF02
real(kind=wp), intent(inout) :: SDCHSM(*)
integer(kind=iwp) :: IJ, IMODE, ISORB, JSORB, NASORB, ND1, ND2
real(kind=wp) :: COEFF, OVLP
real(kind=wp), allocatable :: ANN1(:), ANN2(:)
real(kind=wp), external :: OVERLAP_RASSI

NASORB = IORBTAB(4)

! IF02 = eliminte one electron to the right: < N-2 | anni_right
! anni_right | N >
if (IF02) then

  do ISORB=1,NASORB
    ! Symmetry properties:
    !ISMLAB = IORBTAB(KOINFO+1+8*(ISORB-1))
    !ISPLAB = IORBTAB(KOINFO+3+8*(ISORB-1))
    ! Annihilate a single spin orbital from PSI2, the spin orbital ISORB:
    IMODE = -1
    call FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB2,1)
    ND1 = FSBANN1(5)
    COEFF = One
    call mma_allocate(ANN1,ND1,Label='ANN1')
    ANN1(:) = Zero
    call PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,FSBANN1,IFSBTAB2,COEFF,ANN1,PSI2)

    do JSORB=1,ISORB-1
      ! Symmetry properties:
      !JSMLAB = IORBTAB(KOINFO+1+8*(JSORB-1))
      !JSPLAB = IORBTAB(KOINFO+3+8*(JSORB-1))
      ! Pair index J,L:

      OVLP = Zero
      ! Annihilate another spin orbital from PSI2, LSORB:
      IMODE = -1
      call FSBOP(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN1,2)
      ND2 = FSBANN2(5)
      COEFF = One
      call mma_allocate(ANN2,ND2,Label='ANN2')
      ANN2(:) = Zero
      call PRIMSGM(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN2,FSBANN1,COEFF,ANN2,ANN1)

      ! Compute the spin transition density matrix element:
      OVLP = OVERLAP_RASSI(IFSBTAB1,FSBANN2,PSI1,ANN2)

      IJ = nTri_Elem(ISORB-2)+JSORB
      SDCHSM(IJ) = SDCHSM(IJ)+OVLP

      call mma_deallocate(ANN2)
      call mma_deallocate(FSBANN2)
    end do
    call mma_deallocate(ANN1)
    call mma_deallocate(FSBANN1)
  end do

else if (IF20) then
  ! ################################################################################
  ! IF02 = Eliminate to the right (state 2)
  write(u6,*) 'Invalid state combination. Please, give PSI1=(N-2) and PSI2=(N)'
else
  write(u6,*) 'Invalid state combination in DCH states'
end if

end subroutine SDCHS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Dresselhaus                                     *
************************************************************************
      subroutine embPotInit(preparingOutput)
************************************************************************
*                                                                      *
* Object: routine to read in an embedding potential on a grid from a   *
*         file.                                                        *
*                                                                      *
* Called from: Seward                                                  *
*              DrvMO                                                   *
*              EmbPotOutput                                            *
*                                                                      *
* Calling    : GetMem                                                  *
*                                                                      *
*     Author: Thomas Dresselhaus                                       *
*                                                                      *
************************************************************************

      Implicit None

****** Includes
#include "WrkSpc.fh"

      ! Holds the data which is read in in this subroutine
#include "embpotdata.fh"

****** Variables

      ! Unit of input file (the embedding potential)
      Integer iunit, isFreeUnit

      ! Index
      Integer i

      ! Switch to toggle whether only information relevant for the
      ! output needs to be read
      Logical preparingOutput

******
      embDebug=.false.

      ! Open the file
      iunit = isFreeUnit(1)
      if (preparingOutput.and.outGridPathGiven) then
       call molcas_open(iunit, outGridPath)
      else
       call molcas_open(iunit, embPotPath)
      end if

      ! TODO MAKE THIS READING PROCEDURE SAFE!!!

      ! Read in header of the file (just a line with one integer)
      read(iunit,*) nEmbGridPoints

      ! Allocate memory for the grid points, potential and weights
      Call GetMem('embG','ALLO','REAL',posEmbGridCoord,nEmbGridPoints*3)
      Call GetMem('embP','ALLO','REAL',posEmbPotVal,nEmbGridPoints)
      Call GetMem('embW','ALLO','REAL',posEmbWeight,nEmbGridPoints)

      ! Read in data
      do i=1, nEmbGridPoints
       if (preparingOutput.and.outGridPathGiven) then
        read(iunit, *) Work(posEmbGridCoord+i*3-3),
     &                 Work(posEmbGridCoord+i*3-2),
     &                 Work(posEmbGridCoord+i*3-1)
       else
        read(iunit, *) Work(posEmbGridCoord+i*3-3),
     &                 Work(posEmbGridCoord+i*3-2),
     &                 Work(posEmbGridCoord+i*3-1),
     &                 Work(posEmbWeight+i-1),
     &                 Work(posEmbPotVal+i-1)
       end if
      end do

      close(iunit)

      if (embDebug) then
        write(6,*) "---------------------------------------------------"
        write(6,*) "---------------------------------------------------"
        write(6,*) "Potential has been read in. Coords:"
        do i=1, nEmbGridPoints
         if (mod(i,587).eq.0) then
          write(6,*) i, Work(posEmbGridCoord+i*3-3),
     &               Work(posEmbGridCoord+i*3-2),
     &               Work(posEmbGridCoord+i*3-1)
         end if
        end do
        write(6,*) "---------------------------------------------------"
        write(6,*) "Potential value, weight"
        do i=1, nEmbGridPoints
         if (mod(i,587).eq.0) then
          write(6,*) i, Work(posEmbPotVal+i-1),
     &               Work(posEmbWeight+i-1)
         end if
        end do
        write(6,*) "---------------------------------------------------"
        write(6,*) "---------------------------------------------------"
      end if

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3sglh211 (w,dima,dimab,dimc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma=symb;symc
c
c     W(ab,c) <-  + S1 _i(a) . D1 _jk(b,c)
c     - S1 _i(b) . D1 _jk(a,c)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a (b) index (I)
c     dimab  - dimension of ab  index (I)
c     dimc   - dimension of c index (I)
c     s1     - S1 matrix (I)
c     d1     - D1 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimab,dimc,ns
       real*8 w(1:dimab,1:dimc)
       real*8 s1(1:dima)
       real*8 d1(1:dima,1:dimc)
c
c     help variables
c
       integer a,b,c,ab
       real*8 s
c
       if (ns.eq.1) then
c     phase + 1
c
       do 100 c=1,dimc
       ab=0
       do 101 a=2,dima
       s=s1(a)
       do 102 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)+d1(b,c)*s
 102    continue
 101    continue
 100    continue
c
       do 110 c=1,dimc
       ab=0
       do 111 a=2,dima
       s=d1(a,c)
       do 112 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)-s1(b)*s
 112    continue
 111    continue
 110    continue
c
       else
c     phase - 1
c
       do 200 c=1,dimc
       ab=0
       do 201 a=2,dima
       s=s1(a)
       do 202 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)-d1(b,c)*s
 202    continue
 201    continue
 200    continue
c
       do 210 c=1,dimc
       ab=0
       do 211 a=2,dima
       s=d1(a,c)
       do 212 b=1,a-1
       ab=ab+1
       w(ab,c)=w(ab,c)+s1(b)*s
 212    continue
 211    continue
 210    continue
c
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Giovanni Ghigo                                   *
************************************************************************
*  Cho_TraCtl
*
*> @brief
*>   Driver for the generation of the two-electrons integrals file (``MOLINT``) from the AO-based Cholesky Full Vectors
*> @author Giovanni Ghigo
*>
*> @details
*> All programs that need the generation of the two-electrons
*> integrals file in MO basis must tell to the Cholesky routine
*> who they are through \p iTraType:
*>
*> - ``1``: MBPT2
*> - ``2``: CASPT2
*> - ``3``: MCLR
*> - ``4``: CC
*>
*> The AO-based Cholesky Full Vectors (CHFV) are first transformed
*> in a new set of MO-based Transformed Cholesky Full Vectors
*> (TCVx) then the two-electrons integrals files (``MOLINT``) is
*> generated. The integrals in the file (``MOLINT``) are differently
*> ordered but addresses can be read from ``IAD2M`` as usual.
*>
*> The main loop runs over all the symmetries \c iSymL and for each
*> \f$ \text{CHFV}_{pq} \f$ (\f$ p,q \f$ are AO indices) the following MO-based
*> Transformed Cholesky Full Vectors (TCVx) can be generated:
*>
*> 1. TCVA: \f$ L_{ij}, L_{ji} \f$ if \c Sym(p) &ne; \c Sym(q)
*> 2. TCVB: \f$ L_{tj}, L_{ui} \f$ if \c Sym(p) &ne; \c Sym(q)
*> 3. TCVC: \f$ L_{aj}, L_{bi} \f$ if \c Sym(p) &ne; \c Sym(q)
*> 4. TCVD: \f$ L_{tu}, L_{ut} \f$ if \c Sym(p) &ne; \c Sym(q)
*> 5. TCVE: \f$ L_{au}, L_{bt} \f$ if \c Sym(p) &ne; \c Sym(q)
*> 6. TCVF: \f$ L_{ab} \f$  Only if \c DoFull = ``.True.`` (Not implemented yet!)
*>
*> MO Indices \f$ i,j \f$: Inactive; \f$ t,u \f$: Active; \f$ a,b \f$: Secondary
*>
*> Which TCVx have to be generated is defined in the logical array
*> \c TCVXist by the routine ::Mem_Est and the memory pointer and length
*> are contained in the array \c iMemTCVX.
*>
*> Note that when \c Sym(p) &ne; \c Sym(q) the order of symmetry is
*> exchanged while the first index is always the MO we excite into
*> and the second index is always the MO we excite out.
*>
*> TCV type ``A`` and ``D``, \f$ L_{ji} \f$, and \f$ L_{ut} \f$, are not really generated
*> because they are just the transposed \f$ L_{ij} \f$ and \f$ L_{tu} \f$.
*> However, they are stored in memory.
*>
*> The main loop for the generation of the integrals (``MOLINT``) is
*> based on the total symmetry of the MO-based TCVx and for each
*> symmetry, a batch procedure is performed (\c nBatch). Within this
*> batch cycle, the TCVx are generated by ::Cho_TraS and ::Cho_TraA
*> depending if \c Sym(p) = \c Sym(q). In both these routines, a second
*> inner-batch procedure (\c nFBatch) is established reading the Full
*> Vectors and tranforming them in the TCVx.
*> Both the number of vectors
*> transformed in the two batch procedure are defined in ::Mem_Est
*> (\c nVec for \c nBatch and \c nFVec for \c nFBatch).
*>
*> The MO-based two-electron integrals generation is performed by
*> ::Cho_TwoEl. The integrals are \f$ (p,k|q,l) \f$ where \f$ p,q \f$: All MO; \f$ k,l \f$:
*> Occupied.
*> For MBPT2 integrals where \f$ p,q \f$ are occupied are not generated and
*> suitable routines called by ::ChoMP2_TraCtl are used.
*> For CC all \f$ p,q,k,l \f$ are all MO (not implemented yet).
*>
*> @note
*> The number of frozen and deleted MO used in the post-CASSFC/SCF
*> must be written in the RunFile in \c nFroPT and \c nDelPT arrays.
*>
*> @param[in] iTraType Caller program (see description)
*> @param[in] LUINTM   Unit number of two-electrons integrals file (``MOLINT``)
*> @param[in] CMO      MO coefficients
*> @param[in] NCMO     Total number of MO coefficients
*> @param[in] DoExch2  Flag for the generation of Exch-2 integrals
************************************************************************
      Subroutine Cho_TraCtl(iTraType,LUINTM,CMO,NCMO,DoExch2)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden                                    *
*           October 2004                                               *
*----------------------------------------------------------------------*
* This is the routine for the transformation from AO basis to MO basis *
* of the Cholesky Full Vectors & Two-electrons integral generation.    *
* Reads the Cholesky Full Vectors (CHFV), generate new Transformed     *
* Cholesky Full Vectors (TCVx) then generate the Two-electrons inte-   *
* gral file (MOLINT).                                                  *
*  <p,q|k,l>  where p,q: All MO; k,l: Occupied                         *
* If DoFull=.True also <p,q|r,s> where p,q,r,s: All MO (for CC)        *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Dimension CMO(NCMO)
      Character*4 CHNm
      Character*6 CHName
      Parameter (CHNm='CHFV')
      Logical DoExch2
      Logical Found

      MulD2h(i,j) = iEor(i-1,j-1)+1

CGG   ------------------------------------------------------------------
      IfTest=.False.
c      IfTest=.True.
c      DoExch2=.True.
CGG   ------------------------------------------------------------------

      Call Timing(CPU0,CPE,TIO0,TIOE)

***   INIZIALIZATION   *************************************************

      CALL CWTIME(TCR1,TWR1)
      Call Cho_X_init(irc,0.0)
      If (irc.ne.0) Then
        write(6,*) ' In Cho_TraCtl: Cho_X_Init returned non-zero'//
     &             ' rc = ',irc
        Call Abend()
      EndIf
      Call Cho_X_ReoVec(irc) ! get (if not there) CD vects in full stor
      If (irc.ne.0) Then
        write(6,*) ' In Cho_TraCtl: Cho_X_ReoVec returned non-zero'//
     &             ' rc = ',irc
        Call Abend()
      EndIf
      Call Cho_X_final(irc)
      CALL CWTIME(TCR2,TWR2)
      tcpu_reo=(TCR2-TCR1)
      twal_reo=(TWR2-TWR1)
      write(6,*) ' Reordering of the Cholesky vectors to full storage. '
      write(6,*) ' Elapsed time for the reordering section: ',tcpu_reo
      write(6,*) ' CPU time for the reordering section: ',tcpu_reo
      write(6,*)

* --- Define what has to be calculated. ---
*      DoExc2 flag for the generation of Exch-2 integrals
*      DoTCVA flag for the generation of TCVA
*      DoFull flag for the generation of TCVF
*      DoCoul flag for the generation of coulomb integrals

      DoExc2=DoExch2

*     MBPT2
      If (iTraType.EQ.1) then
        DoTCVA = .False.
        DoFull = .False.
        DoCoul = .False.
      EndIf

*     CASPT2
      If (iTraType.EQ.2) then
        DoTCVA = .True.
        DoFull = .False.
        DoCoul = .True.
      EndIf

*     MCLR
      If (iTraType.EQ.3) then
        DoTCVA = .True.
        DoFull = .False.
        DoCoul = .True.
      EndIf

*     CC
      If (iTraType.EQ.4) then
        DoTCVA = .True.
        DoFull = .True.
        DoCoul = .True.
      EndIf

*     If Tra is not recognized it is assumed is CASPT2 type.
      If (iTraType.GE.5) then
        DoTCVA = .True.
        DoFull = .False.
        DoCoul = .True.
      EndIf

* --- Get Informations from RunFile. ---
*      The following informations must be passed to the Cholesky
*      transformation routine through RunFile. COMMON blocks could
*      not be used due to several conflicts.
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      Call Get_iArray('nFroPT',nFro,nSym)
      Call Get_iArray('nDelPT',nDel,nSym)
      Call Get_iArray('nIsh',nIsh,nSym)
* PAM 2007      Call Get_iArray('nAsh',nAsh,nSym)
* Replaced by:
      Do i=1,nSym
        nAsh(i)=0
      End Do
      Call qpg_iArray('nAsh',Found,nData)
      If(Found .and. nData.eq.nSym) Then
        Call Get_iArray('nAsh',nAsh,nSym)
      End If
* End of replacement
      Call Get_NVnode(NumCho)
      nBasT=0
      Do i=1,nSym
        nBasT   = nBasT + nBas(i)
        nOrb(i) = nBas(i) - nFro(i) - nDel(i)
        nOsh(i) = nIsh(i) + nAsh(i)
        nSsh(i) = nOrb(i) - nOsh(i)
      EndDo

* --- Copy data to common ERI. ---
      NSYMZ=NSYM
      LUINTMZ=LUINTM
      DO I=1,NSYM
        NORBZ(I)=NORB(I)
        NOSHZ(I)=NOSH(I)
      END DO

* --- Inizialize information arrays. ---

*     The TCVx existing flag and the Memory Allocation & Length array:
      Do iType=1,MxTCVx
        Do iSym=1,MaxSym
          Do jSym=1,MaxSym
            TCVXist(iType,iSym,jSym)=.False. ! TCVx existing flag.
            iMemTCVX(iType,iSym,jSym,1)=0 ! Memory Address and
            iMemTCVX(iType,iSym,jSym,2)=0 ! Length in Work(TCVx)
          EndDo
        EndDo
      EndDo

*     The Address Field for MOLINT:
      LenIAD2M=3*36*36
      Do i=1,36*36
       IAD2M(1,i)=0
       IAD2M(2,i)=0
       IAD2M(3,i)=0
      EndDo
      iAddrIAD2M=0
      Call iDaFile(LUINTM,1,IAD2M,LenIAD2M,iAddrIAD2M)

*     The Timing:
      CPU_Tra=0.0d0
      TIO_Tra=0.0d0
      CPU_Gen=0.0d0
      TIO_Gen=0.0d0

CGG   ------------------------------------------------------------------
      If(IfTest) then
      Write(6,*)
      Write(6,'(A,8I5)')'           Symmetries :',(i,i=1,nSym)
      Write(6,*)
      Write(6,'(A,8I5)')'               Frozen :',(nFro(i),i=1,nSym)
      Write(6,'(A,8I5)')'         Inactive (I) :',(nIsh(i),i=1,nSym)
      Write(6,'(A,8I5)')'           Active (A) :',(nAsh(i),i=1,nSym)
      Write(6,'(A,8I5)')'        Secondary (S) :',(nSsh(i),i=1,nSym)
      Write(6,'(A,8I5)')'              Deleted :',(nDel(i),i=1,nSym)
      Write(6,*)
      Write(6,'(A,8I5)')'      Total correlated:',(nOrb(i),i=1,nSym)
      Write(6,*)
      Call XFlush(6)
      EndIf
CGG   ------------------------------------------------------------------


* *** START LOOP iSymL on TOTAL SYMMETRY of L (iSym * jSym)   **********
      DO iSymL=1,nSym

*       Re-Inizialize the TCVx & iMemTCVX
        Do iType=1,MxTCVx
          Do iSym=1,MaxSym
            Do jSym=1,MaxSym
              TCVXist(iType,iSym,jSym)=.False. ! TCVx existing flag.
              iMemTCVX(iType,iSym,jSym,1)=0 ! Memory Address and
              iMemTCVX(iType,iSym,jSym,2)=0 ! Length in Work(TCVx)
            EndDo
          EndDo
        EndDo
        Call Mem_Est(iSymL,nVec,nFVec)
CGG   ------------------------------------------------------------------
      If(IfTest) then
      Write(6,*)
      Write(6,*)' TCVx generated in Symmetry',iSymL
      Do i=1,nSym
      Do j=1,nSym
      Do k=1,6
      If (TCVXist(k,i,j)) Write(6,*)' Type=',k,' Symmetries:',i,j
      EndDo
      EndDo
      EndDo
      Call XFlush(6)
      EndIf
CGG   ------------------------------------------------------------------
        If (nVec.GT.0 .and. nFVec.GT.0) then
          nBatch =(NumCho(iSymL)-1)/nVec + 1
        else
          Write(6,*)
          Write(6,*) ' ************************************'
          Write(6,*) ' *  Insufficient memory for batch ! *'
          Write(6,*) ' ************************************'
          Write(6,*)
          Call XFlush(6)
          Call Abend()
        EndIf

*  ---  START LOOP iBatch  ---------------------------------------------
        DO iBatch=1,nBatch

          If (iBatch.EQ.nBatch) then
            NumV = NumCho(iSymL) -nVec * (nBatch-1)
          else
            NumV = nVec
          EndIf
          nFBatch = (NumV-1) / nFVec + 1
CGG   ------------------------------------------------------------------
c      If(IfTest) then
c      Write(6,*)
c      Write(6,*)' iBatch=',iBatch,' of',nBatch,' - NumV=',NumV,
c     &                                             ' - nFBatch=',nFBatch
c      Call XFlush(6)
c      EndIf
CGG   ------------------------------------------------------------------

*   ---   Start Transformation of Cholesy Vectors  CHFV -> TCVx
          Call Timing(CPU1,CPE,TIO1,TIOE)

*         Start Loop on CHFV-iSym-jSym
          Do iSym=1,nSym
          lUCHFV = -1
           If(nBas(iSym).GT.0) then
            Do jSym=1,iSym
            lUCHFV = -1
             If(nBas(jSym).GT.0 .and. MulD2h(iSym,jSym).EQ.iSymL) then
              lUCHFV=7
              iStrtVec_AB = nVec * (iBatch-1) + 1
              Write(CHName,'(A4,I1,I1)') CHNm,iSym,jSym
              Call dAName_MF_WA(lUCHFV,CHName)
CGG   ------------------------------------------------------------------
c      If(IfTest) then
c      Write(6,*) ' - Open ',CHName,' unit=',lUCHFV,' Vect=',iStrtVec_AB
c      Call XFlush(6)
c      EndIf
CGG   ------------------------------------------------------------------

              If (iSym.EQ.jSym) then
               Call Cho_TraS(iSymL, iSym,jSym, NumV, CMO,NCMO,
     &                      lUCHFV, iStrtVec_AB, nFVec,nFBatch)
              Else
               Call Cho_TraA(iSymL, iSym,jSym ,NumV, CMO,NCMO,
     &                      lUCHFV, iStrtVec_AB, nFVec,nFBatch)
              EndIf

              Call dAClos(lUCHFV)
CGG   ------------------------------------------------------------------
c      If(IfTest) then
c      Write(6,*) ' - Closed ',CHName
c      Call XFlush(6)
c      EndIf
CGG   ------------------------------------------------------------------
             EndIf
            EndDo
           EndIf
          EndDo
*         End Loop on CHFV-iSym-jSym

          Call Timing(CPU2,CPE,TIO2,TIOE)
          CPU_Tra=CPU_Tra+CPU2-CPU1
          TIO_Tra=TIO_Tra+TIO2-TIO1
*   ---   End Transformation of Cholesky Vectors  CHFV -> TCVx

*   ---   Start Generation of Integrals files  TCVx -> MOLINT
CGG   ------------------------------------------------------------------
      If(IfTest) then
      Write(6,*) ' - Generation of Integrals:'
      Call XFlush(6)
      EndIf
CGG   ------------------------------------------------------------------

*         Start Loop on I, J, A, B Symmetries
          nSymP=(nSym**2+nSym)/2
          Do iSymI = 1, nSym
            Do iSymJ = 1, iSymI
              Do iSymA = 1, nSym
                Do iSymB = 1, nSym
                  iSymAI = MulD2h(iSymA,iSymI)
                  iSymBJ = MulD2h(iSymB,iSymJ)

                  If (iSymAI.EQ.iSymL .and. iSymBJ.EQ.iSymL)
     &              Call Cho_TwoEl(iBatch,nBatch,NumV,LUINTM,iAddrIAD2M,
     &                                 iSymI,iSymJ,iSymA,iSymB, iSymL)

                EndDo
              EndDo
            EndDo
          EndDo
*         End Loop on I, J, A, B Symmetries

          Do iType=1,MxTCVx
           Do iSym=1,MaxSym
            Do jSym=1,MaxSym
             If(iMemTCVX(iType,iSym,jSym,1).GT.0) then
              iAddr=iMemTCVX(iType,iSym,jSym,1)
              iLen =iMemTCVX(iType,iSym,jSym,2)
              Call GetMem('iAddr','Free','Real',iAddr,iLen)
              iMemTCVX(iType,iSym,jSym,1)=0
              iMemTCVX(iType,iSym,jSym,2)=0
             EndIf
            EndDo
           EndDo
          EndDo
          Call Timing(CPU3,CPE,TIO3,TIOE)
          CPU_Gen=CPU_Gen+CPU3-CPU2
          TIO_Gen=TIO_Gen+TIO3-TIO2
*   ---   End Generation of Two-Electrons Integrals files

        ENDDO
*  ---  END LOOP iBatch  -----------------------------------------------

      ENDDO
* *** END MAIN LOOP iSymL on TOTAL SYMMETRY of L (iSym * jSym)   *******

      iAddrIAD2M=0
      Call iDaFile(LUINTM,1,IAD2M,LenIAD2M,iAddrIAD2M)

      Write(6,*)'TIMING INFORMATION:   CPU(s)   %CPU   Elapsed(s)'
      Write(6,'(A,F9.2,1X,F6.1,1X,F12.2)') ' Transformation     ',
     & CPU_Tra, 1.0d2*CPU_Tra/Max(1.0d0,TIO_Tra), TIO_Tra
      Write(6,'(A,F9.2,1X,F6.1,1X,F12.2)') ' Generation         ',
     & CPU_Gen, 1.0d2*CPU_Gen/Max(1.0d0,TIO_Gen), TIO_Gen
      Call Timing(CPU4,CPE,TIO4,TIOE)
      CPU_Tot=CPU4-CPU0
      TIO_Tot=TIO4-TIO0
      Write(6,'(A,F9.2,1X,F6.1,1X,F12.2)') ' TOTAL              ',
     & CPU_Tot, 1.0d2*CPU_Tot/Max(1.0d0,TIO_Tot), TIO_Tot
      write(6,*)
      Call XFlush(6)
CGG   ------------------------------------------------------------------
      If(IfTest) then
c      IPRX=0    ! Do not print Coulomb nor Exchange Integrals
      IPRX=1    ! Print only Coulomb Integrals
c      IPRX=2    ! Print all Integrals
c      IPRX=3    ! Print only Exchange Integrals
       Call RdInt2(IPRX,DoTCVA)
      EndIf
CGG   ------------------------------------------------------------------

      Call put_tra_comm(IAD2M,NSYMZ,NORBZ,NOSHZ,LUINTMZ)

      Return
      End

************************************************************************
      Subroutine put_tra_comm(IBD2M,NSYMX,NORBX,NOSHX,LUINTMX)

      Implicit Real*8 (a-h,o-z)
      Integer IBD2M(3,36*36),NSYMX,NORBX(8),NOSHX(8),LUINTMX
#include "intgrl.fh"

      Do j=1,36*36
         Do i=1,3
            IAD2M(i,j) = IBD2M(i,j)
         End Do
      End Do
      NSYMZ = NSYMX
      Do i=1,8
         NORBZ(i) = NORBX(i)
         NOSHZ(i) = NOSHX(i)
      End Do
      LUINTMZ = LUINTMX

      Return
      End

************************************************************************
      Subroutine Get_NVnode(NVEC)

      Integer NVEC(*)
#include "cholesky.fh"

      Do i=1,nSym
         NVEC(i) =  NumCho(i)
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  isSymmetric
!
!> @brief
!>   Return ``.True.`` if \p M is symmetric within tolerance \p Tol
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Test if matrix \p M is symmetric. If \f$ \forall i,j \; |M_{ij}-M_{ji}| \le \text{Tol} \f$
!> return ``.True.``
!>
!> @param[in] M   \p n &times; \p n square matrix to test
!> @param[in] n   Dimension of \p M
!> @param[in] Tol Tolerance
!>
!> @return ``.True.`` if \p M is symmetric within tolerance \p Tol
!***********************************************************************

function isSymmetric(M,n,Tol)

use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: isSymmetric
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: M(n,n), Tol
integer(kind=iwp) :: i, j

isSymmetric = .true.
outer: do j=1,n
  do i=j+1,n
    if (abs(M(i,j)-M(j,i)) > Tol) then
      isSymmetric = .false.
      exit outer
    end if
  end do
end do outer

return

end function isSymmetric

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine StartLight(ModuleName)
#ifndef _HAVE_EXTRA_
      Use Prgm
#endif
      Implicit None
      Character*(*) ModuleName
      External Get_SuperName
      Character*100 SuperName, Get_SuperName
#include "timtra.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Statistics
*
      nfld_tim =0
      nfld_stat=0
*                                                                      *
************************************************************************
*                                                                      *
      call prgmfree()
      call prgminit(ModuleName)
*                                                                      *
************************************************************************
*                                                                      *
*  Unix-related information must be set or checked here or later,
*  PID and master/slave status may not have been set before now.
*  (DO NOT MOVE FROM HERE)
*
      SuperName=Get_SuperName()
      Call UnixInfo(SuperName,ModuleName)

      close(5)
      call molcas_open(5,'stdin')
*                                                                      *
************************************************************************
*                                                                      *
*     Initiate I/O
*
      Call FIOInit()
*                                                                      *
************************************************************************
*                                                                      *
*     Statistics, release old fields
*
      Call IniTim()
      Call IniStat()

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      SubRoutine PrjHss(
#define _CALLING_
#include "hss_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of ECP integrals.         *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by ECPMem                 *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
*             Physics, University of Stockholm, Sweden, October 1993.  *
************************************************************************
      use Basis_Info
      use Center_Info
      use Real_Spherical
      use Symmetry_Info, only: iOper
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "disp.fh"
#include "disp2.fh"

#include "hss_interface.fh"

*     Local variables
      Real*8 C(3), TC(3), Coor(3,4), g2(78)
      Integer iDCRT(0:7), iuvwx(4), kOp(4), mOp(4),
     &        JndGrd(3,4,0:7), jndhss(4,3,4,3,0:7)
      Logical JfGrd(3,4),  EQ, jfhss(4,3,4,3),ifg(4),tr(4)
      Dimension Dum(1)

      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2

*
      nRys=nHer
*
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      call icopy(2,nop,1,mop,1)
      kOp(1) = iOper(nOp(1))
      kOp(2) = iOper(nOp(2))

*
      call dcopy_(3,A,1,Coor(1,1),1)
      call dcopy_(3,RB,1,Coor(1,2),1)

      kdc = 0
      Do 1960 kCnttp = 1, nCnttp
         If (.Not.dbsc(kCnttp)%ECP) Go To 1961
         Do 1965 kCnt = 1,dbsc(kCnttp)%nCntr
            C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
            iuvwx(3) = dc(kdc+kCnt)%nStab
            iuvwx(4) = dc(kdc+kCnt)%nStab


*
         Do 1967 lDCRT = 0, nDCRT-1
            kOp(3) = iDCRT(lDCRT)
            kOp(4) = kOp(3)
            mop(3) = nropr(kop(3))
            mop(4) = mop(3)
            Call OA(iDCRT(lDCRT),C,TC)
            call dcopy_(3,TC,1,Coor(1,3),1)

            If (EQ(A,RB).and.EQ(A,TC)) Go To 1967
            Call NucInd(coor,kdc+kCnt,ifgrd,ifhss,indgrd,indhss,
     &                  jfgrd,jfhss,jndgrd,jndhss,tr,ifg)
            Do 1966 iAng = 0, dbsc(kCnttp)%nPrj-1
               iShll = dbsc(kCnttp)%iPrj + iAng
               nExpi=Shells(iShll)%nExp
               nBasisi=Shells(iShll)%nBasis
               If (nExpi.eq.0 .or. nBasisi.eq.0) Go To 1966
*
               ip = 1

               ipFin = ip
               ip = ip + nZeta*nElem(la)*nElem(lb)*21

               ipFA1 = ip
               ip = ip + nAlpha*nExpi*nElem(la)*nElem(iAng)*4

               ipFA2 = ip
               ip = ip + nAlpha*nExpi*nElem(la)*nElem(iAng)*6

               ipFB1 = ip
               ip = ip + nExpi*nBeta*nElem(iAng)*nElem(lb)*4

               ipFB2 = ip
               ip = ip + nExpi*nBeta*nElem(iAng)*nElem(lb)*6

               call dcopy_(nArr,[0.0d0],0,Array,1)
*              <a|c>,<a'|c>,<a"|c>
               Call Acore(iang,la,ishll,nordop,TC,A,Array(ip),
     &                     narr-ip+1,Alpha,nalpha,Array(ipFA1),
     &                     array(ipfa2),jfgrd(1,1),jfhss,
     &                     2,.false.)
*              Transform to core orbital
               call LToCore(Array(ipFA1),nalpha,ishll,la,iAng, 4)
               call LToCore(Array(ipFA2),nalpha,ishll,la,iAng, 6)
*              <c|b>,<c|b'>,<c|b">
               Call coreB(iang,lb,ishll,nordop,TC,RB,Array(ip),
     &                    narr-ip+1,Beta,nbeta,Array(ipFB1),
     &                    array(ipfb2),jfgrd(1,2),jfhss,
     &                    2,.false.)
*              Transform to core orbital
               call RToCore(Array(ipFB1),nbeta,ishll,lb,iAng, 4)
               call RToCore(Array(ipFB2),nbeta,ishll,lb,iAng, 6)
*              Construct complete derivative (contract core)
               Call CmbnACB2(Array(ipFa1),Array(ipFa2),Array(ipFb1),
     &                        Array(ipFb2),Array(ipFin),Fact,
     &                        nalpha,nbeta,
     &                        Dum,nBasisi,
     &                        la,lb,iang,jfhss,dum,.false.)

*              contract density
               nt=nZeta*(la+1)*(la+2)/2*(lb+1)*(lb+2)/2
               call dcopy_(78,[0.0d0],0,g2,1)
               Call dGeMV_('T',nT,21,
     &                    One,Array(ipFin),nT,
     &                    DAO,1,
     &                    Zero,g2,1)

*              distribute in hessian
               Call Distg2(g2,Hess,nHess,JndGrd,
     &                  JfHss,JndHss,iuvwx,kOp,mop,
     &                  Tr,IfG)

*
 1966       Continue !iang
 1967    Continue !DCR
 1965    Continue !cnt
 1961    Continue !cont
         kdc = kdc + dbsc(kCnttp)%nCntr
 1960 Continue !cnttp
         Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Zeta)
         Call Unused_real_array(ZInv)
         Call Unused_real_array(rKappa)
         Call Unused_real_array(P)
         Call Unused_real_array(Final)
         Call Unused_integer(nRys)
         Call Unused_real_array(Ccoor)
         Call Unused_integer_array(lOper)
      End If
         End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_T_contractors

! Module containing routines to generate contributions to a
! multipole potential on the fly.
! Note that another module allows contraction of T-pairs to generate
! an energy or J-matrix directly (e.g.to exploit symmetry).

use fmm_global_paras, only: INTK, REALK, scheme_paras, T_pair_single, T_pair_list, T_pair_batch, T_CONTRACTOR_MULTI, &
                            T_CONTRACTOR_BOUNDARY, T_CONTRACTOR_DIRECT, T_CONTRACTOR_TREE, T_CONTRACTOR_SCALE_TREE, &
                            T_CONTRACTOR_SCALE, T_CONTRACTOR_FULL, NEAR_FIELD, DISTINCT_T_TOL, TMATM_DF, Zero, One, Half
use fmm_stats, only: stat_T_mat_builds, fmm_init_matrix_stats
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_init_T_contractors, &
          fmm_free_T_contractors, &
          fmm_select_T_con, &
          fmm_set_T_con_ptrs

! Public variable to stop the resetting of T_con pointers with open T-buffer
public :: fmm_lock_T_con

real(REALK), allocatable, save :: T_matrix(:,:)
integer(INTK), save :: TLDA
! when building multiple T matrices together
real(REALK), allocatable, save :: T_mats(:,:,:)

! Pointers to actual moments and potentials described elsewhere
real(REALK), pointer, save :: Vff_ptr(:,:)
real(REALK), pointer, save :: qlm_ptr(:,:)

! Diagnostic variables
character(len=11), save :: T_con_stat
logical, save :: fmm_lock_T_con

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_T_contractors(scheme)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  integer(INTK) :: LMAX, T_con
  integer(INTK) :: lm_max

  LMAX = scheme%trans_lmax
  lm_max = (LMAX+1)**2
  if (scheme%phase == NEAR_FIELD) then
    T_con = scheme%T_con%NF_id
  else
    T_con = scheme%T_con%FF_id
  end if

  select case (T_con)
    case (T_CONTRACTOR_MULTI)
      if (allocated(T_mats)) call fmm_quit('T_mats not deallocated!')
      !FIXME: will need to change TMATM_DF if changed elsewhere
      allocate(T_mats(TMATM_DF,lm_max,lm_max))
      T_mats = zero
    case (T_CONTRACTOR_BOUNDARY)
      if (allocated(T_matrix)) call fmm_quit('T_matrix not deallocated!')
      allocate(T_matrix(lm_max,1))
      T_matrix = zero
    case default
      if (allocated(T_matrix)) call fmm_quit('T_matrix not deallocated!')
      allocate(T_matrix(lm_max,lm_max))
      T_matrix = zero
  end select
  TLDA = lm_max

  ! code for statistics only
  call fmm_init_matrix_stats('T')

end subroutine fmm_init_T_contractors

!-------------------------------------------------------------------------------

subroutine fmm_free_T_contractors()

  implicit none

  if (allocated(T_matrix)) deallocate(T_matrix)
  if (allocated(T_mats)) deallocate(T_mats)

end subroutine fmm_free_T_contractors

!-------------------------------------------------------------------------------

subroutine fmm_set_T_con_ptrs(Vff,qlm)

  implicit none
  real(REALK), target, intent(in) :: Vff(:,:), qlm(:,:)

  if (T_con_stat /= 'initialised') call fmm_quit('no T_contractor preselected!')
  if (fmm_lock_T_con) call fmm_quit('T_buffer not empty! Cannot reset T_con!')
  nullify(Vff_ptr,qlm_ptr)
  Vff_ptr => Vff(:,:)
  qlm_ptr => qlm(:,:)

end subroutine fmm_set_T_con_ptrs

!-------------------------------------------------------------------------------
! Built for DIRECT scheme.  Can only take one T_pair at a time.
! Only generates a square T-matrix with dim = MAX(LHS_LMAX,RHS_LMAX)
! Generates local potential to order MAX(LHS_LMAX,RHS_LMAX)
! Adds to Vff only up to LHS_LMAX.
! FIXME: because T_matrix is only built for (l+j)<=LMAX then with dynamic
! contraction we need LEXTRA>0 even for primitive basis sets and FQUAD.

subroutine fmm_T_con_DIRECT(T_pair)

  use fmm_T_worker, only: fmm_get_SPLTSQ_T_matrix, &
                          fmm_contract_Tq

  implicit none
  type(T_pair_single), intent(in) :: T_pair

  real(REALK) :: Vff_tmp(T_pair%lm_max)
  integer(INTK) :: weight, iLHS, iRHS, hi

  stat_T_mat_builds = stat_T_mat_builds+one
  call fmm_get_SPLTSQ_T_matrix(T_pair%LMAX,T_pair%r_ab,T_matrix)

  iRHS = T_pair%paras%RHS_id
  hi = T_pair%lm_max

  Vff_tmp = fmm_contract_Tq(T_pair%LMAX,qlm_ptr(:hi,iRHS),T_matrix)
  iLHS = T_pair%paras%LHS_id
  hi = (1+T_pair%paras%LHS_LMAX)**2
  weight = T_pair%paras%weight
  !write(LUPRI,*) iRHS,qlm_ptr(1,iRHS),weight,Vff_tmp(:hi)
  Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS)+weight*Vff_tmp(:hi)

end subroutine fmm_T_con_DIRECT

!-------------------------------------------------------------------------------
! Modification of T_con_DIRECT for evaluation of boundary potential
! when only the first element of Vff needs to be built

subroutine fmm_T_con_BOUNDARY(T_pair)

  use fmm_T_worker, only: fmm_get_boundary_T_matrix

  implicit none
  type(T_pair_single), intent(in) :: T_pair

  real(REALK) :: Vff_tmp
  integer(INTK) :: weight, iLHS, iRHS, hi

  stat_T_mat_builds = stat_T_mat_builds+one
  call fmm_get_boundary_T_matrix(T_pair%LMAX,T_pair%r_ab,T_matrix)

  iRHS = T_pair%paras%RHS_id
  hi = T_pair%lm_max

  Vff_tmp = half*dot_product(qlm_ptr(:hi,iRHS),T_matrix(:hi,1))

  iLHS = T_pair%paras%LHS_id
  hi = (1+T_pair%paras%LHS_LMAX)**2
  weight = T_pair%paras%weight
  !write(LUPRI,*) iRHS,qlm_ptr(1,iRHS),weight,Vff_tmp

  Vff_ptr(1,iLHS) = Vff_ptr(1,iLHS)+weight*Vff_tmp

end subroutine fmm_T_con_BOUNDARY

!-------------------------------------------------------------------------------

subroutine fmm_T_con_TREE(T_pairs)

  use fmm_T_worker, only: fmm_get_SPLTSQ_T_matrix, &
                          fmm_contract_Tq

  implicit none
  type(T_pair_list), intent(in) :: T_pairs

  real(REALK) :: Vff_tmp(T_pairs%lm_max)
  real(REALK) :: lastlen, r_pq(3), r_pq_mod(3)
  integer(INTK) :: LMAX, weight, i, p, q, hi

  r_pq_mod(:) = T_pairs%r_ab(:)
  LMAX = T_pairs%LMAX
  lastlen = zero

  do i=1,size(T_pairs%paras)

    p = T_pairs%paras(i)%LHS_id
    q = T_pairs%paras(i)%RHS_id

    if (abs(T_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) then
      stat_T_mat_builds = stat_T_mat_builds+one
      r_pq = r_pq_mod*T_pairs%paras(i)%ratio
      call fmm_get_SPLTSQ_T_matrix(LMAX,r_pq,T_matrix)
      lastlen = T_pairs%paras(i)%ratio
    end if

    hi = T_pairs%lm_max
    Vff_tmp = fmm_contract_Tq(LMAX,qlm_ptr(:hi,q),T_matrix)
    hi = (1+T_pairs%paras(i)%LHS_LMAX)**2
    weight = T_pairs%paras(i)%weight
    Vff_ptr(:hi,p) = Vff_ptr(:hi,p)+weight*Vff_tmp(:hi)

  end do

end subroutine fmm_T_con_TREE

!-------------------------------------------------------------------------------

subroutine fmm_T_con_SCALE(T_pairs)

  use fmm_T_worker, only: fmm_get_SPLTSQ_T_matrix, &
                          fmm_contract_Tq, &
                          fmm_scale_vec

  implicit none
  type(T_pair_batch), intent(in) :: T_pairs

  integer(INTK) :: LMAX, i, p, q, hi, lastq
  real(REALK) :: ratio, lastlen, pref
  real(REALK) :: Vff_tmp(T_pairs%items(1)%lm_max)
  real(REALK) :: scaled_qlm(T_pairs%items(1)%lm_max)
  real(REALK) :: scale_vec(T_pairs%items(1)%lm_max)
  logical :: new_vec

  pref = one
  lastq = -1
  lastlen = one
  scale_vec(:) = one
  LMAX = T_pairs%items(1)%LMAX
  stat_T_mat_builds = stat_T_mat_builds+one
  call fmm_get_SPLTSQ_T_matrix(LMAX,T_pairs%items(1)%r_ab,T_matrix)

  iloop: do i=1,T_pairs%ndim

    p = T_pairs%items(i)%paras%LHS_id
    q = T_pairs%items(i)%paras%RHS_id

    new_vec = .false.
    ratio = T_pairs%items(i)%paras%ratio
    if (abs(ratio-lastlen) > DISTINCT_T_TOL) then
      call fmm_scale_vec(LMAX,ratio,scale_vec,pref)
      lastlen = ratio
      new_vec = .true.
    end if

    hi = T_pairs%items(i)%lm_max
    if (new_vec .or. (q /= lastq)) then
      scaled_qlm = scale_vec(:hi)*qlm_ptr(:hi,q)
      lastq = q
    end if

    Vff_tmp = fmm_contract_Tq(LMAX,scaled_qlm(:hi),T_matrix(:hi,:hi))

    hi = (1+T_pairs%items(i)%paras%LHS_LMAX)**2
    Vff_ptr(:hi,p) = Vff_ptr(:hi,p)+pref*scale_vec(:hi)*Vff_tmp(:hi)

  end do iloop

end subroutine fmm_T_con_SCALE

!-------------------------------------------------------------------------------

subroutine fmm_T_con_SCALE_TREE(T_pairs)

  use fmm_T_worker, only: fmm_get_SPLTSQ_T_matrix, &
                          fmm_contract_Tq, &
                          fmm_scale_vec

  implicit none
  type(T_pair_list), intent(in) :: T_pairs

  integer(INTK) :: LMAX, i, p, q, hi, lastq
  real(REALK) :: weight, lastlen, pref
  real(REALK) :: Vff_tmp(T_pairs%lm_max)
  real(REALK) :: scaled_qlm(T_pairs%lm_max)
  real(REALK) :: scale_vec(T_pairs%lm_max)
  logical :: new_vec

  pref = one
  lastq = -1
  lastlen = one
  scale_vec(:) = one
  LMAX = T_pairs%LMAX
  stat_T_mat_builds = stat_T_mat_builds+one
  call fmm_get_SPLTSQ_T_matrix(LMAX,T_pairs%r_ab,T_matrix)

  iloop: do i=1,size(T_pairs%paras)

    p = T_pairs%paras(i)%LHS_id
    q = T_pairs%paras(i)%RHS_id

    new_vec = .false.
    if (abs(T_pairs%paras(i)%ratio-lastlen) > DISTINCT_T_TOL) then
      call fmm_scale_vec(LMAX,T_pairs%paras(i)%ratio,scale_vec,pref)
      lastlen = T_pairs%paras(i)%ratio
      new_vec = .true.
    end if

    hi = T_pairs%lm_max
    if (new_vec .or. (q /= lastq)) then
      scaled_qlm = scale_vec(:hi)*qlm_ptr(:hi,q)
      lastq = q
    end if

    Vff_tmp = fmm_contract_Tq(LMAX,scaled_qlm(:hi),T_matrix(:hi,:hi))

    hi = (1+T_pairs%paras(i)%LHS_LMAX)**2
    weight = pref*T_pairs%paras(i)%weight
    Vff_ptr(:hi,p) = Vff_ptr(:hi,p)+weight*scale_vec(:hi)*Vff_tmp(:hi)

  end do iloop

end subroutine fmm_T_con_SCALE_TREE

!-------------------------------------------------------------------------------
! Special contractor designed to take batch of T-pairs ordered in pairs
! such that ( b T1 1; a -T1 2; c T2 1; a -T2 3 ....)
! to halve the number of T matrix builds (using fmm_scale...)
! But only the common RHS qlm can be contracted simultaneously which slows
! it down a lot.
!
!subroutine fmm_T_con_MULTI(T_pairs)
!
!  use fmm_T_worker_multi, only: fmm_get_SPLTSQ_T_matrices,    &
!                                fmm_contract_multi_Tq
!  use fmm_T_worker, only: fmm_contract_Tq, fmm_scale_vec
!
!  implicit none
!  type(T_pair_batch), intent(in) :: T_pairs
!
!  real(REALK), allocatable :: Vff_tmp(:,:)
!
!  real(REALK), allocatable :: scaled_qlm(:)
!  real(REALK), allocatable :: scale_vec(:)
!
!  real(REALK) :: T_vectors((T_pairs%ndim/2),3)
!  real(REALK) :: pref, weight
!  integer(INTK) :: i, j, iLHS, iRHS, iRHS_last, hi, LMAX, nT
!
!  ! FIRST DO MULTIPLE T contracted with SAME RHS
!  !---------------------------------------------
!
!  if (btest(T_pairs%ndim,0)) call fmm_quit('ndim not EVEN!')
!  nT = T_pairs%ndim/2
!
!  LMAX = 0
!  iRHS_last = T_pairs%items(1)%paras%RHS_id
!  do i=1,nT
!    j = 2*i-1
!    LMAX = max(LMAX,T_pairs%items(i)%LMAX)
!    iRHS = T_pairs%items(j)%paras%RHS_id
!    ! get *distinct* T-vectors as every second item in batch
!    T_vectors(i,:) = T_pairs%items(j)%r_ab(:)
!    if (iRHS /= iRHS_last) call fmm_quit('must have same qlm on RHS')
!    iRHS_last = iRHS
!  end do
!
!  stat_T_mat_builds = stat_T_mat_builds + nT
!  call fmm_get_SPLTSQ_T_matrices(nT,LMAX,T_vectors,T_mats(:nT,:,:))
!
!  hi = (1+LMAX)**2
!  allocate(Vff_tmp(nT,hi))
!  allocate(scaled_qlm(hi))
!  allocate(scale_vec(hi))
!  Vff_tmp(:,:) = zero
!  scale_vec(:) = one
!
!  iRHS = T_pairs%items(1)%paras%RHS_id
!
!  Vff_tmp(:,:hi) = fmm_contract_multi_Tq(LMAX,qlm_ptr(:hi,iRHS),T_mats(:nT,:,:),nT)
!
!  do i=1,nT
!    j = 2*i-1
!    iLHS = T_pairs%items(j)%paras%LHS_id
!    hi = (1+T_pairs%items(j)%paras%LHS_LMAX)**2
!    weight = T_pairs%items(j)%paras%weight
!    Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS)+weight*Vff_tmp(i,:hi)
!  end do
!
!  ! NOW DO remaining half of batched T-pairs corresponding to same LHS
!  !-------------------------------------------------------------------
!
!  iLHS = T_pairs%items(2)%paras%LHS_id
!  do i=1,nT
!    ! get T_matrix correpxonding to the minus T-vector
!    call fmm_scale_vec(LMAX,-one,scale_vec,pref)
!    iRHS = T_pairs%items(2*i)%paras%RHS_id
!    scaled_qlm = scale_vec(:hi)*qlm_ptr(:hi,iRHS)
!    Vff_tmp(1,:hi) = fmm_contract_Tq(LMAX,scaled_qlm(:hi),T_mats(i,:,:))
!    weight = pref
!    Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS)+weight*scale_vec(:hi)*Vff_tmp(1,:hi)
!  end do
!
!  deallocate(Vff_tmp)
!  deallocate(scaled_qlm)
!  deallocate(scale_vec)
!
!end subroutine fmm_T_con_MULTI

!-------------------------------------------------------------------------------
! Contractor designed to build multiple T matrices simultaneously.
! Exact performance will depend on architecture and choice of NDIM.
! Assumes RHS moments are the same, but T-vectors are different.

subroutine fmm_T_con_MULTI(T_pairs)

  use fmm_multiple_T_worker, only: fmm_get_SPLTSQ_T_matrices, &
                                   fmm_contract_multi_Tq

  implicit none
  type(T_pair_batch), intent(in) :: T_pairs

  real(REALK) :: Vff_tmp(T_pairs%ndim,T_pairs%items(1)%lm_max)
  real(REALK) :: T_vectors(T_pairs%ndim,3)
  integer(INTK) :: i, iLHS, iRHS, hi, LMAX, nT

  nT = T_pairs%ndim
  LMAX = T_pairs%items(1)%LMAX

  do i=1,nT
    T_vectors(i,:) = T_pairs%items(i)%r_ab
    iRHS = T_pairs%items(i)%paras%RHS_id
    if (iRHS /= T_pairs%items(max(i-1,1))%paras%RHS_id) then
      call fmm_quit('RHS moments not sorted in fmm_T_con_MULTI')
    end if
  end do

  stat_T_mat_builds = stat_T_mat_builds+nT
  call fmm_get_SPLTSQ_T_matrices(nT,LMAX,T_vectors,T_mats(:nt,:,:))

  iRHS = T_pairs%items(1)%paras%RHS_id
  hi = (1+LMAX)**2

  Vff_tmp(:,:hi) = fmm_contract_multi_Tq(LMAX,qlm_ptr(:hi,iRHS),T_mats(:nT,:,:),nT)

  do i=1,nT
    iLHS = T_pairs%items(i)%paras%LHS_id
    Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS)+Vff_tmp(i,:hi)
  end do

end subroutine fmm_T_con_MULTI

!-------------------------------------------------------------------------------
! Builds full T-matrix for exact contraction at low orders

subroutine fmm_T_con_FULL(T_pair)

  use fmm_T_worker, only: fmm_get_FLTSQ_T_matrix, fmm_postfac_Vff

  implicit none
  type(T_pair_single), intent(in) :: T_pair

  real(REALK) :: Vff_tmp(T_pair%lm_max)
  integer(INTK) :: iLHS, iRHS, hi

  stat_T_mat_builds = stat_T_mat_builds+one
  call fmm_get_FLTSQ_T_matrix(T_pair%LMAX,T_pair%r_ab,T_matrix)

  iRHS = T_pair%paras%RHS_id
  hi = T_pair%lm_max
  call DSYMV('L',hi,one,T_matrix,TLDA,qlm_ptr(:,iRHS),1,zero,Vff_tmp,1)

  iLHS = T_pair%paras%LHS_id
  hi = (1+T_pair%paras%LHS_LMAX)**2
  call fmm_postfac_Vff(T_pair%paras%LHS_LMAX,Vff_tmp)
  Vff_ptr(:hi,iLHS) = Vff_ptr(:hi,iLHS)+Vff_tmp(:hi)

end subroutine fmm_T_con_FULL

!-------------------------------------------------------------------------------

subroutine fmm_select_T_con(scheme)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  integer(INTK) :: T_con_ID
  external :: fmm_store_t_contractor

  if (scheme%phase == NEAR_FIELD) then
    T_con_ID = scheme%T_con%NF_id
  else
    T_con_ID = scheme%T_con%FF_id
  end if

  select case (T_con_ID)
    case (T_CONTRACTOR_DIRECT)
      call fmm_store_t_contractor(fmm_T_con_DIRECT)
    case (T_CONTRACTOR_BOUNDARY)
      call fmm_store_t_contractor(fmm_T_con_BOUNDARY)
    case (T_CONTRACTOR_TREE)
      call fmm_store_t_contractor(fmm_T_con_TREE)
    case (T_CONTRACTOR_SCALE_TREE)
      call fmm_store_t_contractor(fmm_T_con_SCALE_TREE)
    case (T_CONTRACTOR_SCALE)
      call fmm_store_t_contractor(fmm_T_con_SCALE)
    case (T_CONTRACTOR_MULTI)
      call fmm_store_t_contractor(fmm_T_con_MULTI)
    case (T_CONTRACTOR_FULL)
      call fmm_store_t_contractor(fmm_T_con_FULL)
    case default
      call fmm_quit('invalid T_contractor requested!')
  end select
  ! initialise diagnostics
  T_con_stat = 'initialised'
  fmm_lock_T_con = .false.

end subroutine fmm_select_T_con

!-------------------------------------------------------------------------------

end module fmm_T_contractors

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1997, Jeppe Olsen                                 *
*               2015, Lasse Kragh Soerensen                            *
************************************************************************
      SUBROUTINE RASSG3(      CB,      SB,   NBATS,   LBATS,  LEBATS,
     &                    I1BATS,   IBATS,     LUC,    LUHC,
     &                    I_AM_OUT,N_ELIMINATED_BATCHES)
*
* Direct RAS routine employing combined MOC/n-1 resolution method
*
* Jeppe Olsen   Winter of 1991
*               May 1997 : Connected to SBLOCK
*
* Lasse Soerensen October 2015
*                 Do not calculate unwanted batches for highly
*                 excited states.
*
* =====
* Input
* =====
*

      IMPLICIT REAL*8(A-H,O-Z)
#include "para_info.fh"
#include "WrkSpc.fh"
#include "io_util.fh"
*. Batches of sigma
      INTEGER LBATS(*),LEBATS(*),I1BATS(*),IBATS(8,*)
      DIMENSION I_AM_OUT(*)
*.Scratch
      DIMENSION SB(*),CB(*)
*
      NTEST = 00
C     NTEST = MAX(NTEST,IPRNT)
      IF(NTEST.GE.20) THEN
        WRITE(6,*) ' ================='
        WRITE(6,*) ' RASSG3 speaking :'
        WRITE(6,*) ' ================='
        WRITE(6,*) ' RASSG3 : NBATS = ',NBATS
      END IF
*
CSVC: Compute offsets of a sigma batch in the sigma array.
C     The batches used inside sblock(s) use a batch size corresponding
C     to the 'expanded form' as computed inside part_civ2. This is
C     stored inside 7th element of IBATS. Later, the size that needs to
C     be actually written to disc uses the 'packed form', stored inside
C     the 8th element of IBATS. This also computes the total size NSB.
      CALL GETMEM('SBSIZ','ALLO','INTE',LSBSIZ,NBATS)
      CALL GETMEM('SBOFF','ALLO','INTE',LSBOFF,NBATS)
      NSB=0
      DO JBATS = 1, NBATS
        ISTA=I1BATS(JBATS)
        IEND=I1BATS(JBATS)+LBATS(JBATS)-1
        IWORK(LSBSIZ+JBATS-1)=SUM(IBATS(7,ISTA:IEND))
        NSB=NSB+IWORK(LSBSIZ+JBATS-1)
      END DO
      IWORK(LSBOFF) = 1
      DO JBATS = 2, NBATS
        IWORK(LSBOFF+JBATS-1) = IWORK(LSBOFF+JBATS-2) +
     &                           IWORK(LSBSIZ+JBATS-2)
      END DO

CSVC: the entire sigma array is zeroed here, because each process will
C     zero only its own sigma blocks, and we need to do a global sum
C     operations later to combine blocks before writing.
      CALL DCOPY_(NSB,[0.0D0],0,SB,1)

      DO JBATS=1,NBATS
*
* Lasse addition start
* MGD here we try to remove the whole batch if possible
* later, we will put to zero individual blocks in case
* the batch had a mix of maximum and non-maximum occupation
* and thus survived this test
*
        I_AM_NOT_WANTED = 0
        DO ISBLK = I1BATS(JBATS),I1BATS(JBATS)+ LBATS(JBATS)-1
          I_AM_NOT_WANTED = 0
          DO I = 1, N_ELIMINATED_BATCHES
            IF(I_AM_OUT(I).EQ.ISBLK) THEN
              I_AM_NOT_WANTED = 1
              EXIT
            END IF
          END DO
          if (I_AM_NOT_WANTED.eq.0) exit
        EndDo
        IF(I_AM_NOT_WANTED.EQ.1) CYCLE
*
* Lasse addition end
*

      ISBOFF=IWORK(LSBOFF+JBATS-1)
*. Obtain sigma for batch of blocks
      CALL SBLOCK(LBATS(JBATS),IBATS(1,I1BATS(JBATS)),1,
     &            CB,SB(ISBOFF),LUC,0,0,0,0,0)

      END DO

      CALL GADSUM(SB,NSB)
CSVC: Write sigma array to disk here, after sum reduction.
C     The writing is done in consecutive blocks, but since I don't know
C     if this block structure is used internally, I didn't optimize this.
      IF(LUHC.GT.0) IDISK(LUHC)=0
      DO JBATS = 1, NBATS
        ISBOFF=IWORK(LSBOFF+JBATS-1)
        DO ISBLK = I1BATS(JBATS),I1BATS(JBATS)+ LBATS(JBATS)-1
          IOFF = IBATS(6,ISBLK)
          ILEN = IBATS(8,ISBLK)
          CALL ITODS([ILEN],1,-1,LUHC)
*MGD zero afterwards since it is easier
          I_AM_NOT_WANTED = 0
          DO I = 1, N_ELIMINATED_BATCHES
            IF(I_AM_OUT(I).EQ.ISBLK) THEN
               I_AM_NOT_WANTED = 1
               EXIT
             EndIf
          End Do
          If (I_AM_NOT_WANTED.eq.1) Call dzero(SB(ISBOFF-1+IOFF),ILEN)
*
          CALL TODSC(SB(ISBOFF-1+IOFF),ILEN,-1,LUHC)
        END DO
      END DO

      CALL GETMEM('SBOFF','FREE','INTE',LSBOFF,NBATS)
      CALL GETMEM('SBSIZ','FREE','INTE',LSBSIZ,NBATS)

      CALL ITODS([-1],1,-1,LUHC)
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Final S-vector on disc'
        CALL WRTVCD(SB,LUHC,1,-1)
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) Call Unused_integer_array(LEBATS)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,2015, Roland Lindh                                *
!               2015, Lasse Kragh Soerensen                            *
!***********************************************************************

subroutine Util3(Beta,nZeta,rFinal,la,lb,Slalbp,Slalb,Slalbm)
!***********************************************************************
!                                                                      *
! Object: to assemble the orbital magnetic quadrupole integrals from   *
!         the derivative integrals and dipole integrals.               *
!                                                                      *
!     Author: Roland Lindh, Lasse Kragh Soerensen                      *
!             Dept. of Theoretical Chemistry,                          *
!             University of Uppsala, SWEDEN                            *
!             February '15                                             *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two, Four
use Definitions, only: wp, iwp

! Notice CmbnMP has just 6 components instead of 9!!! (automatically assumes symmetry) Well fuck you CmbnMP
! This means Slalbp and Slalbm in reality only have 6 components....
! XX = 1, XY=YX=2, XZ=ZX=3, YY=4, YZ=ZY=5 and ZZ=6
! There are only six components since zy d/di = yz d/di
! We still keep the 9 components in rFinal
implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb
real(kind=wp), intent(in) :: Beta(nZeta), Slalbp(nZeta,nTri_Elem1(la),nTri_Elem1(lb+1),6), &
                             Slalb(nZeta,nTri_Elem1(la),nTri_Elem1(lb),3), Slalbm(nZeta,nTri_Elem1(la),nTri_Elem1(lb-1),6)
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),9)
integer(kind=iwp) :: ipa, ipb, ixa, ixb, iya, iyb, iza, izb
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
character(len=80) :: Label
#endif

#ifdef _DEBUGPRINT_
write(u6,*) ' In Util3 la,lb=',la,lb
call RecPrt('Beta',' ',Beta,nZeta,1)
do ia=1,nTri_Elem1(la)
  do ib=1,nTri_Elem1(lb+1)
    write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'xx)'
    call RecPrt(Label,' ',Slalbp(:,ia,ib,1),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'xy)'
    call RecPrt(Label,' ',Slalbp(:,ia,ib,2),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'xz)'
    call RecPrt(Label,' ',Slalbp(:,ia,ib,3),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'yx)'
    call RecPrt(Label,' ',Slalbp(:,ia,ib,2),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'yy)'
    call RecPrt(Label,' ',Slalbp(:,ia,ib,4),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'yz)'
    call RecPrt(Label,' ',Slalbp(:,ia,ib,5),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'zx)'
    call RecPrt(Label,' ',Slalbp(:,ia,ib,3),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'zy)'
    call RecPrt(Label,' ',Slalbp(:,ia,ib,5),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'zz)'
    call RecPrt(Label,' ',Slalbp(:,ia,ib,6),nZeta,1)
  end do
end do
do ia=1,nTri_Elem1(la)
  do ib=1,nTri_Elem1(lb)
    write(Label,'(A,I2,A,I2,A)') ' Slalb (',ia,',',ib,'x)'
    call RecPrt(Label,' ',Slalb(:,ia,ib,1),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalb (',ia,',',ib,'y)'
    call RecPrt(Label,' ',Slalb(:,ia,ib,2),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' Slalb (',ia,',',ib,'z)'
    call RecPrt(Label,' ',Slalb(:,ia,ib,3),nZeta,1)
  end do
end do
if (lb > 0) then
  do ia=1,nTri_Elem1(la)
    do ib=1,nTri_Elem1(lb-1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'xx)'
      call RecPrt(Label,' ',Slalbm(:,ia,ib,1),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'xy)'
      call RecPrt(Label,' ',Slalbm(:,ia,ib,2),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'xz)'
      call RecPrt(Label,' ',Slalbm(:,ia,ib,3),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'yx)'
      call RecPrt(Label,' ',Slalbm(:,ia,ib,2),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'yy)'
      call RecPrt(Label,' ',Slalbm(:,ia,ib,4),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'yz)'
      call RecPrt(Label,' ',Slalbm(:,ia,ib,5),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'zx)'
      call RecPrt(Label,' ',Slalbm(:,ia,ib,3),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'zy)'
      call RecPrt(Label,' ',Slalbm(:,ia,ib,5),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'zz)'
      call RecPrt(Label,' ',Slalbm(:,ia,ib,6),nZeta,1)
    end do
  end do
end if
#endif

do ixa=la,0,-1
  do iya=la-ixa,0,-1
    iza = la-ixa-iya
    ipa = C_Ind(la,ixa,iza)

    do ixb=lb,0,-1
      do iyb=lb-ixb,0,-1
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        ! xx term
        rFinal(:,ipa,ipb,1) = Four*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),2)-Slalbp(:,ipa,C_Ind(lb+1,ixb,izb),3))
        ! xy term
        rFinal(:,ipa,ipb,2) = Four*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),4)-Slalbp(:,ipa,C_Ind(lb+1,ixb,izb),5))- &
                              Slalb(:,ipa,C_Ind(lb,ixb,izb),3)
        ! xz term
        rFinal(:,ipa,ipb,3) = Four*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),5)-Slalbp(:,ipa,C_Ind(lb+1,ixb,izb),6))+ &
                              Slalb(:,ipa,C_Ind(lb,ixb,izb),2)
        ! yx term
        rFinal(:,ipa,ipb,4) = Four*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),3)-Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),1))+ &
                              Slalb(:,ipa,C_Ind(lb,ixb,izb),3)
        ! yy term
        rFinal(:,ipa,ipb,5) = Four*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),5)-Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),2))
        ! yz term
        rFinal(:,ipa,ipb,6) = Four*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),6)-Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),3))- &
                              Slalb(:,ipa,C_Ind(lb,ixb,izb),1)
        ! zx term
        rFinal(:,ipa,ipb,7) = Four*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb,izb),1)-Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),2))- &
                              Slalb(:,ipa,C_Ind(lb,ixb,izb),2)
        ! zy term
        rFinal(:,ipa,ipb,8) = Four*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb,izb),2)-Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),4))+ &
                              Slalb(:,ipa,C_Ind(lb,ixb,izb),1)
        ! zz term
        rFinal(:,ipa,ipb,9) = Four*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb,izb),3)-Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),5))

        if (ixb > 0) then
          rFinal(:,ipa,ipb,4) = rFinal(:,ipa,ipb,4)+Two*real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb),3)
          rFinal(:,ipa,ipb,5) = rFinal(:,ipa,ipb,5)+Two*real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb),5)
          rFinal(:,ipa,ipb,6) = rFinal(:,ipa,ipb,6)+Two*real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb),6)
          rFinal(:,ipa,ipb,7) = rFinal(:,ipa,ipb,7)-Two*real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb),2)
          rFinal(:,ipa,ipb,8) = rFinal(:,ipa,ipb,8)-Two*real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb),4)
          rFinal(:,ipa,ipb,9) = rFinal(:,ipa,ipb,9)-Two*real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb),5)
        end if

        if (iyb > 0) then
          rFinal(:,ipa,ipb,1) = rFinal(:,ipa,ipb,1)-Two*real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb),3)
          rFinal(:,ipa,ipb,2) = rFinal(:,ipa,ipb,2)-Two*real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb),5)
          rFinal(:,ipa,ipb,3) = rFinal(:,ipa,ipb,3)-Two*real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb),6)
          rFinal(:,ipa,ipb,7) = rFinal(:,ipa,ipb,7)+Two*real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb),1)
          rFinal(:,ipa,ipb,8) = rFinal(:,ipa,ipb,8)+Two*real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb),2)
          rFinal(:,ipa,ipb,9) = rFinal(:,ipa,ipb,9)+Two*real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb),3)
        end if

        if (izb > 0) then
          rFinal(:,ipa,ipb,1) = rFinal(:,ipa,ipb,1)+Two*real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1),2)
          rFinal(:,ipa,ipb,2) = rFinal(:,ipa,ipb,2)+Two*real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1),4)
          rFinal(:,ipa,ipb,3) = rFinal(:,ipa,ipb,3)+Two*real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1),5)
          rFinal(:,ipa,ipb,4) = rFinal(:,ipa,ipb,4)-Two*real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1),1)
          rFinal(:,ipa,ipb,5) = rFinal(:,ipa,ipb,5)-Two*real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1),2)
          rFinal(:,ipa,ipb,6) = rFinal(:,ipa,ipb,6)-Two*real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1),3)
        end if

      end do
    end do

  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' In Util3 la,lb=',la,lb
do iElem=1,nTri_Elem1(la)
  do jElem=1,nTri_Elem1(lb)
    write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',xx) '
    call RecPrt(Label,' ',rFinal(:,iElem,jElem,1),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',xy) '
    call RecPrt(Label,' ',rFinal(:,iElem,jElem,2),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',xz) '
    call RecPrt(Label,' ',rFinal(:,iElem,jElem,3),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',yx) '
    call RecPrt(Label,' ',rFinal(:,iElem,jElem,4),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',yy) '
    call RecPrt(Label,' ',rFinal(:,iElem,jElem,5),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',yz) '
    call RecPrt(Label,' ',rFinal(:,iElem,jElem,6),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',zx) '
    call RecPrt(Label,' ',rFinal(:,iElem,jElem,7),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',zy) '
    call RecPrt(Label,' ',rFinal(:,iElem,jElem,8),nZeta,1)
    write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',zz) '
    call RecPrt(Label,' ',rFinal(:,iElem,jElem,9),nZeta,1)
  end do
end do
#endif

return

end subroutine Util3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine NmHess(dq,nInter,g,nIter,Hess,Delta,q,FEq,Cubic,
     &                  DipM,dDipM)
************************************************************************
*                                                                      *
* Object: to numerically evaluate the molecular Hessian.               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             May '92                                                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 dq(nInter,nIter), g(nInter,nIter),Hess(nInter,nInter),
     &       q(nInter,nIter+1), FEq(nInter,nInter,nInter),
     &       DipM(3,nIter), dDipM(3,nInter)
      Logical Cubic
#include "print.fh"
#include "real.fh"
*
      iRout = 181
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt('NmHess:  g',' ',g,nInter,nIter)
         Call RecPrt('NmHess:  q',' ',q,nInter,nIter)
         Call RecPrt('NmHess: dq',' ',dq,nInter,nIter)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Form the derivative of the dipole moment
*
      Do iInter = 1, nInter
         kIter  = 1 + (iInter-1)*2
         kIter1 = kIter + 1
         kIter2 = kIter + 2
C        Write (*,*) kIter1,kIter2
         dDipM(1,iInter) = (DipM(1,kIter1)-DipM(1,kIter2))
     &                   / (Two*Delta)
         dDipM(2,iInter) = (DipM(2,kIter1)-DipM(2,kIter2))
     &                   / (Two*Delta)
         dDipM(3,iInter) = (DipM(3,kIter1)-DipM(3,kIter2))
     &                   / (Two*Delta)
      End Do
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('DipM',' ',DipM,3,nIter)
      Call RecPrt('dDipM',' ',dDipM,3,nInter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Evaluate the Hessian
*
      Do iInter = 1, nInter
         Do jInter = 1, nInter
            kIter = 1 + (jInter-1)*2
            kIter1 = kIter + 1
            kIter2 = kIter + 2
*           Write (*,*) iInter,jInter,kIter1,kIter2
*-----------Observe the sign convention due to the use of forces
*           rather than gradients!!!
            Hess(iInter,jInter) = -(g(iInter,kIter1) -
     &                              g(iInter,kIter2)) / (Two*Delta)
         End Do
      End Do
      If (iPrint.ge.99) Call RecPrt(' Numerical Hessian',' ',
     &   Hess,nInter,nInter)
*
*-----Symmetrize
*
      Do iInter = 1, nInter
         Do jInter = 1, iInter-1
            Hess(iInter,jInter) = (Hess(iInter,jInter) +
     &                             Hess(jInter,iInter) ) / Two
            Hess(jInter,iInter) =  Hess(iInter,jInter)
         End Do
      End Do
      If (iPrint.ge.99) Call RecPrt(' Symmetrized Hessian',' ',
     &   Hess,nInter,nInter)
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the numerical cubic constants if data is available.
*
      If (Cubic) Then
*
*------- F(i,j,j)
*
         Do iInter = 1, nInter
            Do jInter = 1, nInter
               kIter = 1 + (jInter-1)*2
               kIter1 = kIter + 1
               kIter2 = kIter + 2
*------------- Observe the sign convention due to the use of forces
*              rather than gradients!!!
               FEq(iInter,jInter,jInter) = -(g(iInter,kIter1)
     &                                   +   g(iInter,kIter2))
     &                                   /  (Delta**2)
            End Do
         End Do
*
*------- F(i,j,k); j>k
*
         Do iInter = 1, nInter
            iCount=0
            Do jInter = 1, nInter
               Do kInter = 1, jInter-1
                  iCount=iCount+1
                  kIter = 1 + 2*nInter + (iCount-1)*4
                  kIter1= kIter + 1
                  kIter2= kIter + 2
                  kIter3= kIter + 3
                  kIter4= kIter + 4
*---------------- Observe the sign convention due to the use of forces
*                 rather than gradients!!!
                  FEq(iInter,jInter,kInter) = -(g(iInter,kIter1)
     &                                      -   g(iInter,kIter2)
     &                                      -   g(iInter,kIter3)
     &                                      +   g(iInter,kIter4))
     &                                      /   (Two*Delta)**2
               End Do
            End Do
         End Do
*
*------- Symmetrize
*
         Do iInter = 1, nInter
            Do jInter = 1, iInter
               Do kInter = 1, jInter
                  FEq(iInter,jInter,kInter) = (
     &               FEq(iInter,jInter,kInter) +
     &               FEq(iInter,kInter,jInter) +
     &               FEq(jInter,iInter,kInter) +
     &               FEq(jInter,kInter,iInter) +
     &               FEq(kInter,jInter,iInter) +
     &               FEq(kInter,iInter,jInter) ) / Six
                  FEq(iInter,jInter,kInter) =
     &               FEq(iInter,jInter,kInter)
                  FEq(iInter,kInter,jInter) =
     &               FEq(iInter,jInter,kInter)
                  FEq(jInter,iInter,kInter) =
     &               FEq(iInter,jInter,kInter)
                  FEq(jInter,kInter,iInter) =
     &               FEq(iInter,jInter,kInter)
                  FEq(kInter,iInter,jInter) =
     &               FEq(iInter,jInter,kInter)
               End Do
            End Do
         End Do
*
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine TwoEl_mck(Coor,
     &     iAngV,iCmp,iShell,iShll,iAO,iAOst,
     &     iStb,jStb,kStb,lStb,nRys,
     &     Data1,nab,nData1,Data2,ncd,nData2,Pren,Prem,
     &     Alpha,nAlpha,iPrInc, Beta, nBeta,jPrInc,
     &     Gamma,nGamma,kPrInc,Delta,nDelta,lPrInc,
     &     Coeff1,iBasi,Coeff2,jBasj,Coeff3,kBask,Coeff4,lBasl,
     &     Zeta,ZInv,P,rKab,nZeta,Eta,EInv,Q,rKcd,nEta,
     &     xA,xB,xG,xD,xPre,Hess,nhess,
     &     IfGrd,IndGrd,ifHss,IndHss,IfG,
     &     PSO,nPSO,Work2,nWork2,Work3,nWork3,Work4,nWork4,
     &     Aux,nAux,WorkX,nWorkX,
     &     Shijij,
     &     Dij1,Dij2,mDij,nDij,Dkl1,Dkl2,mDkl,nDkl,
     &     Dik1,Dik2,mDik,nDik,Dil1,Dil2,mDil,nDil,
     &     Djk1,Djk2,mDjk,nDjk,Djl1,Djl2,mDjl,nDjl,
     &     icmpi,Fin,nfin,Temp,nTemp,nTwo2,nFt,
     &     IndZet,IndEta,TwoHam,ipdens,Buffer,nBuffer,
     &     lgrad,ldot,n8,ltri,Dan,Din,
     &     moip,naco,rMOIN,nMOIN,new_fock)
************************************************************************
*                                                                      *
*     Input:                                                           *
*     Data1     :                                                      *
*     Data2                                                            *
*     PSO                                                              *
*     Work2                                                            *
*     Work3                                                            *
*     Work4                                                            *
*     AUX                                                              *
*     Fin    : Area for cntrctd int in sph hmn                         *
*     Temp   : Working place for F gen and n8                          *
*     TwoHam : Final results fock matrix and MO's                      *
*                                                                      *
*     Object:      To construct the first order derivatives of the AO- *
*     integrals and add them up to the MO derivatives and              *
*     the Fock matrix derivatives and contract the second              *
*     order derivatives of the AO's with the second order              *
*     density matrix.                                                  *
*                                                                      *
*     Authors: Roland Lindh, IBM Almaden Research Center, San Jose, CA *
*     March '90                                                        *
*     Anders Bernhardsson Theoretical Chemistry 95                     *
************************************************************************
*                                                                      *
*     When we are calculating the second order derivatives we need     *
*     the derivatives of the two electron integrals in three ways:     *
*                                                                      *
*     (2)                                                              *
*     1)  To calculate the static term H                               *
*     -                                                                *
*     2)  To calculate the non-zero part of <0|[E  ,H]|0>              *
*     pq                                                               *
*                                                                      *
*                                                                      *
*     3)  To calculate the derivatives of the MO orbitals with all     *
*     four indexes in the active space.                                *
*                                                                      *
*     In this implementation all contributions are calculated at       *
*     the same time.                                                   *
*                                                                      *
*     (2)                                                              *
*     The H    is calculated by contracting the second order           *
*     derivatives on the flight with the second order density matrix   *
*                                                                      *
*     (1)  (1)       (1)                                               *
*     the    F  - F    and MO     are calculated by first contracting  *
*     pq   qp                                                          *
*                                                                      *
*     the primitives and transform the integrals to  spherical         *
*     harmonics and then construct the Fock matrix as a direct SCF     *
*     The Fock matrixes is transformed to MO base and then added up to *
*     total Fock matrix                                                *
*                                                                      *
************************************************************************
      use Real_Spherical
      use Basis_Info
      use Center_Info
      use Phase_Info
      use Real_Info, only: CutInt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External TERI1, ModU2, Cff2D
#include "Molcas.fh"
#include "ndarray.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "disp.fh"
#include "disp2.fh"
#include "buffer.fh"
#include "cputime.fh"
#include "print.fh"
*
      Real*8 Coor(3,4), CoorM(3,4), CoorAC(3,2),
     &     Alpha(nAlpha), Beta(nBeta), Gamma(nGamma), Delta(nDelta),
     &     xA(nZeta),xB(nZeta), xG(nEta), xD(nEta),
     &     Data1(nZeta*nDArray+nDScalar,nData1),Hess(*),
     &     Data2( nEta*nDArray+nDScalar,nData2),rKab(nZeta),rKcd(nEta),
     &     Zeta(nZeta), ZInv(nZeta),  P(nZeta,3),
     &     Eta(nEta),   EInv(nEta),    Q(nEta,3),
     &     Coeff1(nAlpha,iBasi), Coeff2(nBeta,jBasj),
     &     Coeff3(nGamma,kBask), Coeff4(nDelta,lBasl),
     &     PSO(iBasi*jBasj*kBask*lBasl,nPSO), Work2(nWork2),
     &     Work3(nWork3), Work4(nWork4),Aux(nAux),
     &     xpre(nGamma*nDelta*nAlpha*nBeta),Fin(nfin),
     &     Dij1(mDij,nDij),Dkl1(mDkl,nDkl),Dik1(mDik,nDik),
     &     Dil1(mDil,nDil),Djk1(mDjk,nDjk),Djl1(mDjl,nDjl),
     &     Dij2(mDij,nDij),Dkl2(mDkl,nDkl),Dik2(mDik,nDik),
     &     Dil2(mDil,nDil),Djk2(mDjk,nDjk),Djl2(mDjl,nDjl),
     &     WorkX(nWorkX),Temp(nTemp),TwoHam(nTwo2),
     &     Buffer(nBuffer),rMOIN(nMOIN),Din(*),Dan(* )
*
      Integer iDCRR(0:7), iDCRS(0:7), iDCRT(0:7), iStabN(0:7),
     &     iStabM(0:7),  IndGrd(3,4,0:7), iAO(4),
     &     iCmp(4), iShell(4), iShll(4),
     &     nOp(4), iAngV(4), iAOst(4),JndGrd(3,4,0:7),icmpi(4),
     &     IndZet(nAlpha*nBeta),Indeta(nGamma*nDelta), iuvwx(4),
     &     IndHss(4,3,4,3,0:7), JndHss(4,3,4,3,0:7),
     &     Index(3,4), moip(0:7)
*
      Logical Shijij, AeqB, CeqD, AeqC, ABeqCD,
     &     ABeq, CDeq, EQ, lEmpty, IfGrd(3,4),
     &     JfGrd(3,4), first,
     &     IfHss(4,3,4,3),JfHss(4,3,4,3),IfG(4),ltri,
     &     Tr(4),ldot,ldot2,
     &     lgrad,n8,log,no_integrals,new_fock
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function to compute canonical index
*
      nElem(i) = (i+1)*(i+2)/2
*                                                                      *
************************************************************************
*                                                                      *
*     P R O L O G
*                                                                      *
************************************************************************
*                                                                      *
      nGr=0
      ABeq = EQ(Coor(1,1),Coor(1,2))
      CDeq = EQ(Coor(1,3),Coor(1,4))
      la = iAngV(1)
      lb = iAngV(2)
      lc = iAngV(3)
      ld = iAngV(4)
      ldot2=ldot
      iSmAng=la+lb+lc+ld
      iCmpa = iCmp(1)
      jCmpb = iCmp(2)
      kCmpc = iCmp(3)
      lCmpd = iCmp(4)
      iShlla = iShll(1)
      jShllb = iShll(2)
      kShllc = iShll(3)
      lShlld = iShll(4)
      IncZet=nAlpha*jPrInc
      IncEta=nGamma*lPrInc
      LmbdT=0
      nijkl = iBasi*jBasj*kBask*lBasl
      nabcd=iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)
      mab = nElem(la)*nElem(lb)
      mcd = nElem(lc)*nElem(ld)
*
*     Scratch space for Fock Matrix construction
*
      ip=1
      ipS1=ip
      nS1=nijkl*nabcd
      ip=ip+nS1
      ipS2=ip
      nS2=max(nS1,nijkl+max(iBasi*lBasl,jBasj*lBasl,
     &     iBasi*kBask,jBasj*kBask))
      ip=ip+nS2
      ipFT=ip
      ip=ip+nFT
      ipTemp=ip
      nTe=nijkl*nabcd
      ip=ip+nTe
      If (ip-1.gt.nTemp) Then
         Write (6,*) 'TwoEl_McK: ip-1.gt.nTemp'
         Write (6,*) 'ip,nTemp=',ip,nTemp
         Call Abend()
      End If
*
      iuvwx(1) = dc(iStb)%nStab
      iuvwx(2) = dc(jStb)%nStab
      iuvwx(3) = dc(kStb)%nStab
      iuvwx(4) = dc(lStb)%nStab
*
      iffab = 9
      iffcd = 9
*                                                                      *
************************************************************************
*                                                                      *
*             - - - - - - E N D   P R O L O G - - - - - -
*                                                                      *
************************************************************************
*                                                                      *
*-----Find the Double Coset Representatives for center A and B
*
      If (nIrrep.eq.1) Then
         nDCRR=1
         iDCRR(0)=0
         LmbdR=1
      Else
         Call DCR(LmbdR,dc(iStb)%iStab,dc(iStb)%nStab,
     &                  dc(jStb)%iStab,dc(jStb)%nStab,
     &                  iDCRR,nDCRR)
      End If
      u = DBLE(dc(iStb)%nStab)
      v = DBLE(dc(jStb)%nStab)
*
*--------Find stabilizer for center A and B
*
      If (nIrrep.eq.1) Then
         lStabM=1
         iStabM(0)=0
      Else
         Call Inter(dc(iStb)%iStab,dc(iStb)%nStab,
     &              dc(jStb)%iStab,dc(jStb)%nStab,iStabM,lStabM)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Find the Double Coset Representatives for center C and D.
*
      If (nIrrep.eq.1) Then
         nDCRS=1
         iDCRS(0)=0
         LmbdS=1
      Else
         Call DCR(LmbdS,dc(kStb)%iStab,dc(kStb)%nStab,
     &                  dc(lStb)%iStab,dc(lStb)%nStab,
     &                  iDCRS,nDCRS)
      End If
      w = DBLE(dc(kStb)%nStab)
      x = DBLE(dc(lStb)%nStab)
*
*-----------Find stabilizer for center C and D
*
      If (nIrrep.eq.1) Then
         lStabN=1
         iStabN(0)=0
      Else
         Call Inter(dc(kStb)%iStab,dc(kStb)%nStab,
     &              dc(lStb)%iStab,dc(lStb)%nStab,iStabN,lStabN)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Find the Double Coset Representatives for the two charge
*     distributions.
*
      If (nIrrep.eq.1) Then
         nDCRT=1
         iDCRT(0)=0
         LmbdT=1
      Else
         Call DCR(LmbdT,iStabM,lStabM,iStabN,lStabN,iDCRT,nDCRT)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Factor due to summation over DCR
*
      If (MolWgh.eq.1) Then
         Fact = DBLE(nIrrep) / DBLE(LmbdT)
      Else If (MolWgh.eq.0) Then
         Fact = u*v*w*x / DBLE(nIrrep**3 * LmbdT)
      Else
         Fact = Sqrt(u*v*w*x)/DBLE(nIrrep*LmbdT)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      nOp(1)=NrOpr(0)
      call dcopy_(3,Coor(1,1),1,CoorM(1,1),1)
*                                                                      *
************************************************************************
*                                                                      *
*     - - - - Loop over first set
*                                                                      *
************************************************************************
*                                                                      *
      Do 100 lDCRR = 0, nDCRR-1
         nOp(2)=NrOpr(iDCRR(lDCRR))
         Call OA(iDCRR(lDCRR),Coor(1:3,2),CoorM(1:3,2))
         AeqB = EQ(CoorM(1,1),CoorM(1,2))
*                                                                      *
************************************************************************
*                                                                      *
*     - - - - Loop over second set
*                                                                      *
************************************************************************
*                                                                      *
         Do 200 lDCRS = 0, nDCRS-1
            call dcopy_(3,Coor(1,3),1,CoorM(1,3),1)
            Call OA(iDCRS(lDCRS),Coor(1:3,4),CoorM(1:3,4))
            CeqD = EQ(Coor(1,3),CoorM(1,4))
*                                                                      *
************************************************************************
*                                                                      *
*     - - - - Loop over third set
*                                                                      *
************************************************************************
*                                                                      *
            Do 300 lDCRT = nDCRT-1, 0, -1

               nOp(3) = NrOpr(iDCRT(lDCRT))
               nOp(4) = NrOpr(iEor(iDCRT(lDCRT),iDCRS(lDCRS)))
*
               iDCRTS=iEor(iDCRT(lDCRT),iDCRS(lDCRS))
               Call OA(iDCRTS,Coor(1:3,4),CoorM(1:3,4))
               Call OA(iDCRT(lDCRT),Coor(1:3,3),CoorM(1:3,3))
*
               AeqC = EQ(CoorM(1,1),CoorM(1,3))
               ABeqCD = AeqB .and. CeqD .and. AeqC
*--------------No contribution to geometric derivatives from one-center
*              integrals
               If (ABeqCD) Go To 302
*
*--------------Find the proper centers to start of with the angular
*              momentum on. If la.eq.lb there will excist an
*              ambiguity to which center that angular momentum should
*              be accumulated on. In that case we will use A and C of
*              the order as defined by the basis functions types.
*
               If (iAngV(1).ge.iAngV(2)) Then
                  call dcopy_(3,CoorM(1,1),1,CoorAC(1,1),1)
               Else
                  call dcopy_(3,CoorM(1,2),1,CoorAC(1,1),1)
               End If
               If (iAngV(3).ge.iAngV(4)) Then
                  call dcopy_(3,CoorM(1,3),1,CoorAC(1,2),1)
               Else
                  call dcopy_(3,CoorM(1,4),1,CoorAC(1,2),1)
               End If
*
*     Calculate the desymmetrized two-electron density matrix in
*     cartisian AO base.
*
               Call Timing(dum1,Time,dum2,dum3)
               If (ldot2)
     &              Call TwoDns(iAngV,iCmp,shijij,ishll,ishell,
     &                   iAO,nOp,iBasi,jBasj,kBask,lBasl,
     &                   Aux,nAux,Work2,nWork2,Work3,nWork3,work4,
     &                   nWork4,PSO,nPSO,Fact)
*
               Call Timing(dum1,Time,dum2,dum3)
               CpuStat(nTwoDens)=CpuStat(nTwoDens)+Time
*
*----------------------------------------------------------------*
*
*     Loops to partion the primitives
*
*----------------------------------------------------------------*
               lDCR1=NrOpr(iDCRR(lDCRR))+1
               lDCR2=NrOpr(iDCRS(lDCRS))+1
               ix2 = iPhase(1,iDCRT(lDCRT))
               iy2 = iPhase(2,iDCRT(lDCRT))
               iz2 = iPhase(3,iDCRT(lDCRT))
*
               ipIndZ=ip_of_iWork_d(Data1(ip_IndZ(1,nZeta),lDCR1))-1
               ipIndE=ip_of_iWork_d(Data2(ip_IndZ(1,nEta ),lDCR2))-1
               nZeta_Tot=iWork(ipIndZ+nZeta+1)
               nEta_Tot =iWork(ipIndE+nEta+1)
*
               no_integrals=.true.
               first=.true.
               nGr=0
               Do 400 iZeta = 1, nZeta_Tot, IncZet
                  mZeta=Min(IncZet,nZeta_Tot-iZeta+1)
*-----------------Check that subblock of contraction matrix has non-zero
*                 elements.
                  If (lEmpty(Coeff2,nBeta,nBeta,jBasj))
     &                 Go To 401
                  Do 410 iEta  = 1, nEta_Tot, IncEta
                     mEta=Min(IncEta,nEta_Tot-iEta+1)
*-----------------Check that subblock of contraction matrix has non-zero
*                 elements.
                     If (lEmpty(Coeff4,nDelta,nDelta,lBasl))
     &                    Go To 411
                     Pren = Pren + DBLE(mab*mcd*mZeta*mEta)
*-------------------------------------------------------------------------
*
*     Fix the control matrixes for derivatives
*     and try to use translation invariance as
*     efficient as possible.
*
*     OBS DETTA SKALL FLYTTAS UT UR INRE LOOPEN
*
*-------------------------------------------------------------------------
                     Call LCopy(144,IfHss,1,JfHss,1)
                     Call LCopy(12,IfGrd,1,JfGrd,1)
                     Call LCopy(4,[.true.],0,ifg,1)
                     Call LCopy(4,[.false.],0,Tr,1)
                     Call ICopy(144*nIrrep,IndHss,1,JndHss,1)
                     Call ICopy(12*nIrrep,IndGrd,1,JndGrd,1)
*
*     Delete one center that should be calculated with
*     translation invariance
*
                     call Translation(ifg,jfgrd,jfhss,tr,jndgrd,jndhss,
     &                                coorm, nirrep,indgrd,indhss)

                     if (.not.ldot)  Call LCopy(144,[.false.],0,JfHss,1)
                     if (.not.ldot)  Call iCopy(144*8,[0],0,JndHss,1)
*-------------------------------------------------------------*
*     PRE PRESCREENING                                        *
*-------------------------------------------------------------*
*
                     lZeta=mZeta
                     lEta =mEta
*
*-----------------Decontract the 2nd order density matrix
*
*     Work4->Work2  Work3:scratch
                     Call Timing(dum1,Time,dum2,dum3)
                     If (ldot2)
     &                    Call Tcrtnc_h(
     &                    Coeff1,nAlpha,iBasi,
     &                    Coeff2,nBeta,jBasj,
     &                    Coeff3,nGamma,kBask,
     &                    Coeff4,nDelta,lBasl,
     &                    Work4,mab*mcd,Work3,nWork3/2,Work2,
     &                    iWork(ipIndZ+iZeta),mZeta,
     &                    iWork(ipIndE+iEta),mEta)
                     Call Timing(dum1,Time,dum2,dum3)
                     CPUStat(nTwoDens)=CPUStat(nTwoDens)+Time
*
*-----------------Transfer k2 data and prescreen
*
*     Work2:PAO-> Work2
*     Work3 Scratch
                     Call Timing(dum1,Time,dum2,dum3)
                     Call Screen_mck(Work2,Work3,mab*mcd,nZeta,nEta,
     &                    mZeta,mEta,lZeta,lEta,
     &                    Zeta,ZInv,P,xA,xB,rKab,
     &                    Data1(ip_Z(iZeta,nZeta),lDCR1),
     &                    iWork(ipIndZ+iZeta),
     &                    Data1(ip_ZtMax(nZeta),ldcr1),
     &                    Data1(ip_abMax(nZeta),ldcr1),
     &                    Data1(ip_ZetaM(nZeta),ldcr1),
     &                    nAlpha,nBeta,
     &                    Eta, EInv,Q,xG,xD,rKcd,
     &                    Data2(ip_Z(iEta,nEta),lDCR2),
     &                    iWork(ipIndE+iEta),
     &                    Data2(ip_ZtMax(nEta),ldcr2),
     &                    Data2(ip_abMax(nEta),ldcr2),
     &                    Data2(ip_ZetaM(nEta),ldcr2),
     &                    nGamma,nDelta,
     &                    xpre,
     &                    1,1,1,ix2,iy2,iz2,
     &                    CutInt,
     &                    PreScr,
     &                    IndZet,IndEta,ldot2)
                     Call Timing(dum1,Time,dum2,dum3)
                     CPUStat(nScreen)=CPUStat(nScreen)+Time
*
                     Prem = Prem + DBLE(mab*mcd*lZeta*lEta)
                     If (lzeta*leta.ne.0) no_integrals=.false.
                     If (lZeta*lEta.eq.0) Go To 411
*
*-----------------Compute integral derivative and accumulate
*     contribution to the molecular gradient.
*
*     Work2:PAO
*     Work3:Work area  The PO integrals are stored in the begining
*     of Work3
*
                     Call Timing(dum1,Time,dum2,dum3)
*
                     Call Rysg2(iAngV,nRys,lZeta*lEta,
     &                    xA,xB,xG,xD,
     &                    Zeta,ZInv,lZeta,
     &                    Eta,EInv,lEta,
     &                    P,nZeta,Q,nEta,
     &                    CoorM,CoorM,CoorAC,Work3,nWork3,
     &                    TERI1,ModU2,Cff2D,
     &                    Work2,mab*mcd,
     &                    Hess,nHess,JfGrd,JndGrd,
     &                    JfHss,JndHss,nOp,iuvwx,IfG,
     &                    nGr,Index,lgrad,ldot,Tr)
                     Call Timing(dum1,Time,dum2,dum3)
                     CPUStat(nIntegrals)=CPUStat(nIntegrals)+Time

*     Work3 AO
*     Work3_3  Scratch
*     ->    Work3_2
*--------------------------------------------------------------*
*
*--------------Transform integrals ta AO base
*
*--------------------------------------------------------------*
                     ip2=nGr*mab*mcd*lZeta*lEta+1
                     Call Timing(dum1,Time,dum2,dum3)
                     Call Cntrct_mck(First,
     &                    Coeff1,nAlpha,iBasi,
     &                    Coeff2,nBeta ,jBasj,
     &                    Coeff3,nGamma,kBask,
     &                    Coeff4,nDelta,lBasl,
     &                    Work3,nGr*mab*mcd,
     &                    Work3(ip2),nwork3-ip2,
     &                    xpre,WorkX,nWorkX,
     &                    lZeta*lEta,
     &                    IndZet,nZeta,lZeta,IndEta,nEta,lEta)
 411                 Continue
 410              Continue
 401              Continue
 400           Continue
*
*
*     Mark which derivatives that should be calculated with translation
*     invarians.
*
               If (nGr.eq.0) goto 911
               Do iCNT=1,4
                  If (Tr(iCnt)) Then
                     Do iCar=1,3
                        log=.false.
                        Do iIrr=0,nIrrep-1
                           log=(log.or.indgrd(iCar,iCnt,iIrr).ne.0)
                        End Do
                        If (log) Index(iCar,iCnt)=-1
                     End Do
                  End If
               End Do
*
               If (MolWgh.eq.1) Then
                  FactNd = DBLE(nIrrep) / DBLE(LmbdT)
               Else If (MolWgh.eq.0) Then
                  FactNd = u*v*w*x / DBLE(nIrrep**3 * LmbdT)
               Else
                  factNd = sqrt(u*v*w*x)/DBLE(nirrep*lmbdt)
               End If
*
               If (FactNd.ne.One)
     &              Call DScal_(nGr*mab*mcd*nijkl,FactNd,WorkX,1)
*
*-----------------------------------------------------------------*
*
*     Transpose abcd,g,IJKL -> bcd,g,IJKL,A Work3 -> Work3_2
*
*-----------------------------------------------------------------*
*
               niag=nijkl*nElem(lb)*mcd*nGr
               Call CrSph_mck(WorkX,niag,(la+1)*(la+2)/2,
     &              RSph(ipSph(la)),la,
     &              Shells(iShlla)%Transf,
     &              Shells(iShlla)%Prjct,
     &              Work3,iCmpa)
               nw3=niag*iCmpa
               ip2=1+nw3
*-----------------------------------------------------------------*
*
*     Transpose   bcd,g,IJKL,A -> cd,g,IJKL,AB Work3_2->Work3
*
*-----------------------------------------------------------------*
               niag=nijkl*mcd*nGr*iCmpa
               nw3_2=niag*jCmpb
               If (nw3+nw3_2.gt.nWork3) Then
                  Write (6,*) '1: nw3+nw3_2.gt.nWork3'
                  Call Abend()
               End If
               Call CrSph_mck(Work3,niag,(lb+1)*(lb+2)/2,
     &              RSph(ipSph(lb)),lb,
     &              Shells(jShllb)%Transf,
     &              Shells(jShllb)%Prjct,
     &              Work3(ip2),jCmpb)
*-----------------------------------------------------------------*
*
*     Transpose  cd,g,IJKL,AB -> d,g,IJKL,ABC  Work3->Work3_2
*
*-----------------------------------------------------------------*
*
               niag=nijkl*nGr*nElem(ld)*iCmpa*jCmpb
               Call CrSph_mck(Work3(ip2),niag,(lc+1)*(lc+2)/2,
     &              RSph(ipSph(lc)),lc,
     &              Shells(kShllc)%Transf,
     &              Shells(kShllc)%Prjct,
     &              Work3,kCmpc)
               If (niag*kCmpc.gt.nw3) Then
                  Write (6,*) 'niag*kCmpc.gt.nw3'
                  Call Abend()
               End If
               nw3=niag*kCmpc
               ip2=nw3+1
*-----------------------------------------------------------------*
*
*     Transpose   d,g,IJKL,ABC -> g,IJKL,ABCD Work3_2->Work3
*
*-----------------------------------------------------------------*
               niag=nijkl*nGr*iCmpa*jCmpb*kCmpc
               nw3_2=niag*lCmpd
               If (nw3+nw3_2.gt.nWork3) Then
                  Write (6,*) '2: nw3+nw3_2.gt.nWork3'
                  Call Abend()
               End If
               Call CrSph_mck(Work3,niag,(ld+1)*(ld+2)/2,
     &              RSph(ipSph(ld)),ld,
     &              Shells(lShlld)%Transf,
     &              Shells(lShlld)%Prjct,
     &              Work3(ip2),lCmpd)
*-----------------------------------------------------------------*
*
*     Transpose g,IJKL,ABCD -> IJKL,ABCD,g Work3->Buffer
*
*-----------------------------------------------------------------*
               niag=nijkl*iCmpa*jCmpb*kCmpc*lCmpd
               Call DGetMO(Work3(ip2),nGr,nGr,niag,Fin,niag)
*
*     D E B U G  (calculates gradient from transformed integrals)
*
*
               Call Timing(dum1,Time,dum2,dum3)
               CPUStat(nTrans)=CPUStat(nTrans)+Time
*
*-----------------------------------------------------------------*
*
*     Send the integrals to clrbuffer for construction of
*
*-----------------------------------------------------------------*
*
*
               Call ClrBuf(idcrr(ldcrr),idcrs(ldcrs),
     &              idcrt(ldcrt),nGr,
     &              iStb,
     &              jStb,
     &              kStb,
     &              lStb,
     &              Shijij,iAngV,iCmpi,iCmp,
     &              iShll,iShell,iShell,
     &              iBasi,jBasj,kBask,lBasl,
     &              Dij1,Dij2,mDij,nDij,
     &              Dkl1,Dkl2,mDkl,nDkl,
     &              Dik1,Dik2,mDik,nDik,
     &              Dil1,Dil2,mDil,nDil,
     &              Djk1,Djk2,mDjk,nDjk,
     &              Djl1,Djl2,mDjl,nDjl,
     &              fin,nfin,
     &              Temp(ipFT),nFT,
     &              Temp(ipS1),nS1,Temp(ipS2),nS2,
     &              Temp(ipTemp),nTe,TwoHam,nTwo2,
     &              JndGrd,Index,iao,iaost,iuvwx,ifG,n8,ltri,
     &              moip,nAcO,rMoin,nmoin,ntemp,Buffer,
     &              coor,nOp,Din,Dan,new_fock)
 911           Continue
*
 302           Continue
*
 300        Continue
*
 200     Continue
*
 100  Continue
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nab)
         Call Unused_integer(ncd)
         Call Unused_real_array(Alpha)
         Call Unused_integer(iPrInc)
         Call Unused_real_array(Beta)
         Call Unused_real_array(Gamma)
         Call Unused_integer(kPrInc)
         Call Unused_real_array(Delta)
         Call Unused_integer(ipdens)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_Reorder_RI(Vec,lVec,nVec,iSym)

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use ChoArr, only: iRS2F
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lVec, nVec, iSym
real(kind=wp), intent(inout) :: Vec(lVec,nVec)
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: ia, ib, iRS, iRS_tot, iSyma, iSymb, iVec, kFrom, liF2RS, lScr, na, nab, nb
integer(kind=iwp), allocatable :: iF2RS(:)
real(kind=wp), allocatable :: Scr(:)

if (nVec < 1) return
if (lVec < 1) return
if ((lVec /= nnBstR(iSym,1)) .or. (nVec > NumCho(iSym))) then
  call SysAbendMsg('Cho_Reorder_RI','Input argument error!',' ')
end if
if (nnShl /= nnShl_Tot) then
  call SysAbendMsg('Cho_Reorder_RI','Screening is not allowed!','(nnShl /= nnShl_Tot)')
end if

! Set mapping from global address to reduced set.
! -----------------------------------------------

liF2RS = nTri_Elem(nBasT)
call mma_allocate(iF2RS,liF2RS,Label='iF2RS')
iF2RS(:) = 0
do iRS=1,nnBstR(iSym,1)
  iRS_tot = iiBstR(iSym,1)+iRS
  na = iRS2F(1,iRS_tot)
  nb = iRS2F(2,iRS_tot)
  nab = iTri(na,nb)
  iF2RS(nab) = iRS
end do

! Reorder.
! --------

lScr = lVec
call mma_allocate(Scr,lScr,Label='Scr')
do iVec=1,nVec

  Scr(:) = Vec(:,iVec)
  kFrom = 0
  do iSymb=1,nSym

    iSyma = Mul(iSymb,iSym)

    if (iSyma > iSymb) then
      do ib=1,nBas(iSymb)
        nb = iBas(iSymb)+ib
        do ia=1,nBas(iSyma)
          na = iBas(iSyma)+ia
          nab = iTri(na,nb)
          iRS = iF2RS(nab)
#         ifdef _DEBUGPRINT_
          if ((iRS < 1) .or. (iRS > nnBstR(iSym,1))) then
            call SysAbendMsg('Cho_Reorder_RI','Index out of bounds',' ')
          end if
#         endif
          kFrom = kFrom+1
          Vec(iRS,iVec) = Scr(kFrom)
        end do
      end do
    else if (iSyma == iSymb) then
      do ia=1,nBas(iSyma)
        na = iBas(iSyma)+ia
        do ib=1,ia
          nb = iBas(iSymb)+ib
          nab = iTri(na,nb)
          iRS = iF2RS(nab)
#         ifdef _DEBUGPRINT_
          if ((iRS < 1) .or. (iRS > nnBstR(iSym,1))) then
            call SysAbendMsg('Cho_Reorder_RI','Index out of bounds',' ')
          end if
#         endif
          kFrom = kFrom+1
          Vec(iRS,iVec) = Scr(kFrom)
        end do
      end do
    end if

  end do

end do
call mma_deallocate(Scr)
call mma_deallocate(iF2RS)

end subroutine Cho_Reorder_RI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Giovanni Ghigo                                   *
************************************************************************
      Subroutine Alter_MO(CMO)
************************************************************************
*                                                                      *
*    purpose:                                                          *
*    The new keyword ALTEr exchanges pair of MO taken from the files   *
*    INPORB or JOBOLD before to start the RASSCF calculation.          *
*    The keyword must be followed by the number of pairs to exchange   *
*    NAlter and, for each pair, by the symmetry specie MAlter(iAlter   *
*    ,1) and the two indices of the MO to exchange MAlter(iAlter,2-3). *
*    NALTEr and MAlter(MaxAlter,3) (the dimension is fixed) are passed *
*    through a common block in general.fh.                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     G. Ghigo                                                         *
*     University of Lund, Sweden, September 2003                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)
      Dimension       CMO(*)

#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
#include "rasscf.fh"

C Local print level (if any)
      Write(LF,*)
      Write(LF,'(6X,A)') 'Molecular orbitals exchanged:'

      Do iAlter=1,NAlter
      Write(LF,'(8X,A,I2,A,2I4)') 'In symmetry ',MAlter(iAlter,1),
     &                            ' :',MAlter(iAlter,2),MAlter(iAlter,3)
        iAlterI=0
        iAlterJ=0
        If(MAlter(iAlter,1).gt.1) then
          Do iSym=1,MAlter(iAlter,1)-1
            iAlterI=iAlterI+nBas(iSym)**2
            iAlterJ=iAlterJ+nBas(iSym)**2
          EndDo
        EndIf
        iAlterI=iAlterI+nBas(MAlter(iAlter,1))*(MAlter(iAlter,2)-1)
        iAlterJ=iAlterJ+nBas(MAlter(iAlter,1))*(MAlter(iAlter,3)-1)
        Do iCMO=1,nBas(MAlter(iAlter,1))
          CMOex=CMO(iAlterI+iCMO)
          CMO(iAlterI+iCMO)=CMO(iAlterJ+iCMO)
          CMO(iAlterJ+iCMO)=CMOex
        EndDo
      EndDo
      Write(LF,*)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

function n2Tri(lOper)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             February '91                                             *
!***********************************************************************

use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: n2Tri
integer(kind=iwp), intent(in) :: lOper
integer(kind=iwp), external :: iPntSO

n2Tri = iPntSO(nIrrep-1,nIrrep,lOper,nBas)

return

end function n2Tri

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_mkJ
c
c        make J(be,u,i,a)
c
        implicit none
#include "chcc1.fh"
c
        integer be,u,i,a
        integer j,b
        real*8 sj
c
        do a=1,nv
        do i=1,no
        do u=1,no
        do be=1,nv
c
          sj=0.0d0
c
          do j=1,no
           sj=sj-Q1(a,i,j,u)*T1c(be,j)
          end do
c
          do b=1,nv
           sj=sj+Q3(b,be,a,i)*T1c(b,u)
          end do
c
          do j=1,no
          do b=1,nv
           sj=sj+(2.0d0*Q21(a,i,b,j)-Q21(a,j,b,i))*T2c(be,b,u,j)/2
           sj=sj-Q21(a,i,b,j)*(T2c(b,be,u,j)/2+T1c(b,u)*T1c(be,j))
          end do
          end do
c
          sj=sj+Q21(be,u,a,i)
c
          Jc(be,i,u,a)=sj
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' J done'
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Logical Function Check_Bond(CXi,CXj,iANr,jANr,Factor)
* Returns true if the bond should be included, otherwise false
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 CXi(3),CXj(3)
*
      Check_Bond = .True.
      If (Factor .lt. Zero) Then
         Check_Bond = .True.
      Else
         Radius_i    = Bragg_Slater(iANr)
         Radius_j    = Bragg_Slater(jANr)
         Bond_Length = Sqrt((CXi(1)-CXj(1))**2
     &                     +(CXi(2)-CXj(2))**2
     &                     +(CXi(3)-CXj(3))**2)
         Bond_Max    = Factor*(Radius_i+Radius_j)
         If (Bond_Length .gt. Bond_Max) Check_Bond = .False.
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Victor P. Vysotskiy                                    *
************************************************************************
*  FSCB2UNIT
*
*> @brief
*>   Translate system (C)file descriptor into internal Molcas's one
*> @author V. Vysotskiy
*>
*> @details
*> Translate system (C)file descriptor into internal Molcas's one
*>
*> @param[in,out] cunit System (C)file descriptor
************************************************************************
       Subroutine FSCB2UNIT(cunit,LuP)
#include "fio.fh"
#include "pfio.fh"

       Integer cunit,i,Lu
*
       Lu=-1
       Do i=1,MxFile
C          print *,i,FSCB(i),cunit
          If(FSCB(i).eq.cunit) Then
          Lu=i
          End If
       End Do
#ifndef _I8_
       Lu=MPUnit(0,Lu)
#endif
       LuP=-1
       If(Lu.eq.-1) Call Abend()
       Do i=1,NProfFiles
C          print *, i,LuNameProf(i),LuName(Lu)
          If(LuNameProf(i).eq.LuName(Lu)) Then
             LuP=i
          End If
       End Do

       If(LuP.eq.-1) Call Abend()

       Return
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_Srt(Vec,Srt,nVec,iSym,iBatch)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: copy out subblock of vectors.
C
      use ChoMP2, only: iFirstS, LnOcc, LnT1am, LiT1am
      use ChoMP2, only: LnBatOrb
      use ChoMP2, only: LnPQprod, LiPQprod
#include "implicit.fh"
      Real*8  Vec(*), Srt(*)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"

      MulD2h(i,j)=iEor(i-1,j-1)+1

      If(.not.DoDens) Then
         Do iVec = 1,nVec

            kOff0 = nT1am(iSym)*(iVec-1) + 1
            kOff1 = LnT1am(iSym,iBatch)*(iVec-1) + 1

            Do iSymi = 1,nSym

               iSyma = MulD2h(iSymi,iSym)
               If (LnOcc(iSymi,iBatch).gt.0 .and. nVir(iSyma).gt.0) Then
                  lCp = nVir(iSyma)*LnOcc(iSymi,iBatch)
                  kOff2 = kOff0 + iT1am(iSyma,iSymi)
     &                  + nVir(iSyma)*(iFirstS(iSymi,iBatch)-1)
                  kOff3 = kOff1 + LiT1am(iSyma,iSymi,iBatch)
                  Call dCopy_(lCp,Vec(kOff2),1,Srt(kOff3),1)
               End If

            End Do

         End Do
      Else
*       Special sorting for Mp2-density calculations where all integrals
*       are used (for pure energy calculations only integrals of type
*       (occ,vir|occ,vir) are needed).
         Do iVec = 1,nVec
*
            kOff0 = nPQ_prod(iSym)*(iVec-1) + 1
            kOff1 = LnPQprod(iSym,iBatch)*(iVec-1) + 1
*
            Do iSymI = 1,nSym
*
               iSymA = MulD2h(iSymI,iSym)
               If (LnBatOrb(iSymI,iBatch).gt.0 .and.
     &             (nFro(iSymA) + nOcc(iSymA)
     &            + nVir(iSymA) + nDel(iSymA)).gt.0) Then
                  lCp = (nFro(iSymA) + nOcc(iSymA)
     &                +  nVir(iSymA) + nDel(iSymA))
     &                *  LnBatOrb(iSymI,iBatch)
                  kOff2 = kOff0 + iPQ_prod(iSymA,iSymI)
     &                  + (nFro(iSymA) + nOcc(iSymA)
     &                  +  nVir(iSymA) + nDel(iSymA))
     &                  * (iFirstS(iSymi,iBatch)-1)
                  kOff3 = kOff1 + LiPQprod(iSyma,iSymi,iBatch)
                  Call dCopy_(lCp,Vec(kOff2),1,Srt(kOff3),1)
               End If
            End Do
         End Do
      End If


      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GF_Print(EVal,EVec,dDipM,iel,nX,nDim,ictl,IRInt,RedM,
     &                    Lu_10,iOff)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "constants2.fh"
#include "WrkSpc.fh"
      Real*8 EVal(nDim), EVec(2,nX,nDim),dDipM(ndim,iel),IRInt(nDim),
     &       RedM(nDim)
      Parameter(Inc=6)
      Real*8 Tmp(Inc)
      Character*80 Format, Line*120
      Character*(LENIN6) ChDisp(3*MxAtom),Label
*
      LUt=6
*
      Call Get_iScalar('nChDisp',nChDisp)
      Call Get_cArray('ChDisp',ChDisp,(LENIN6)*nChDisp)
*
      iIRInt=0
      Do iHarm = 1, nDim, Inc
         Jnc=Min(Inc,nDim-iHarm+1)
         Label=' '
         Write(Format,'(A,I3,A)') '(5X,A,1x,',Jnc,'(I7,3X))'
         Write (LUt,Format) Label,(i,i=iHarm,iHarm+Jnc-1)
         Write (LUt,*)
*
         Label='Frequency:'
         Write(Format,'(A,I3,A)') '(5X,A,1x,',Jnc,'F10.2)'
         Line=' '
         Write (Line,Format) Label,(EVal(i),i=iHarm,iHarm+Jnc-1)
*
*------- Replace minus signs with sign for imaginary unit.
*
         Do i = 1, 120
            If (Line(i:i).eq.'-') Line(i:i)='i'
         End Do
         Write (LUt,'(A)') Line
         Write (LUt,*)
*
         If (ictl.ne.0) Then
            Label='Intensity:'
            Write(Format,'(A,I3,A)') '(5X,A,1x,',Jnc,'ES10.3)'
            call dcopy_(Jnc,[0.0d0],0,Tmp,1)
            Do k=1,Jnc
              Do l=1,iel
               Tmp(k)=tmp(k)+dDipM(k+iHarm-1,l)**2
              End Do
            End Do
            Write (6,Format) Label,(RF*tmp(i),i=1,Jnc)
            Do i=1,Jnc
               iIRInt=iIRInt+1
               IRInt(iIRInt)=RF*tmp(i)
            enddo
            Label='Red. mass:'
            Write(Format,'(A,I3,A)') '(5X,A,1x,',Jnc,'F10.5)'
            Write (6,Format) Label,(RedM(i),i=iHarm,iHarm+Jnc-1)
            write(6,*)
         Else
            Do i=1,Jnc
               iIRInt=iIRInt+1
               IRInt(iIRInt)=Zero
            enddo
         End if
*
         Write(Format,'(A,I3,A)') '(5X,A,1x,',Jnc,'F10.5)'
         Do iInt = 1, nX
            Write (LUt,Format) ChDisp(iInt+iOff)(1:LENIN6),
     &            (EVec(1,iInt,i),
     &            i=iHarm,iHarm+Jnc-1)
         End Do
         Write (LUt,*)
         Write (LUt,*)
      End Do
*
      Call GetMem('Temp','ALLO','REAL',ipT,nDim*nX)
      ij=-1
      Do i=1,nDim
         Do j=1,nX
            ij=ij+1
            Work(ipT+ij)=Evec(1,j,i)
         End Do
      End Do
      Call WRH(Lu_10,1,[nX],[nDim],Work(ipT),EVAL,1,'*FREQUENCIES')
      Call GetMem('Temp','FREE','REAL',ipT,nDim*nX)
*
      If (ictl.ne.0) Then
*        Write(Lu_10,*) '*BEGIN PROJECTED DIPOLE TRANSITIONS'
         rdum=Zero
         Do j=1,iel
            Call WRH(Lu_10,1,[ndim],[ndim],[rdum],dDipM(1,j),2,
     &               '*DIPOLE TRANSITIONS')
         End Do
*        Write(Lu_10,*) '*END PROJECTED DIPOLE TRANSITIONS'
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Sebastian Wouters                                *
!               2016, Quan Phung                                       *
!***********************************************************************
! CheMPS2-Molcas main interface
! Based on Block interface, written by N. Nakatani
! Written by Quan Phung and Sebastian Wouters, Leuven, Aug 2016
! Adapted for Molcas 8.1 by Quan Phung, Leuven, Oct 2016

subroutine Chemps2Ctl(W1,TUVX,IFINAL,IRST)

#ifdef _MOLCAS_MPP_
use MPI, only: MPI_COMM_WORLD
use Para_Info, only: Is_Real_Par, King
use Definitions, only: MPIInt
#endif
use rasscf_data, only: CBLBM, chemps2_blb, chemps2_lrestart, chemps2_noise, chemps2_restart, davidson_tol, Do3RDM, ENER, iCIonly, &
                       iOrbTyp, ITER, lroots, max_canonical, max_sweep, mxSym, MxDMRG, NAC, THRE, hfocc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Five, Ten, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: W1(*), TUVX(*)
integer(kind=iwp), intent(in) :: IFINAL, IRST
#include "general.fh"
integer(kind=iwp) :: iChMolpro(8), LINSIZE, NUM_TEI, dtemp, nooctemp, labelpsi4, conversion(8), activesize(8), chemroot, &
                     chemps2_info, iOper(0:7), ihfocc, iErr, iOrb, iSigma, iSym, jOrb, lSymMolpro, LUCHEMIN, LUCONV, LUTOTE, &
                     nIrrep, NRDM_ORDER
integer(kind=iwp), allocatable :: OrbSym(:)
#ifdef _MOLCAS_MPP_
integer(kind=MPIInt) :: IERROR
#endif
real(kind=wp) :: chemps2_totale_4d, revdiff, chemps2_conv
logical(kind=iwp) :: fiedler, Found, mps0
character(len=3) :: Label
character(len=10) :: rootindex
character(len=100) :: imp1, imp2
integer(kind=iwp), external :: isFreeUnit

! Quan: FIXME: Do we need this?
! Load symmetry info from RunFile
iOper = 0
call Get_iScalar('NSYM',nIrrep)
call Get_iArray('Symmetry operations',iOper,nIrrep)
call Get_iScalar('Rotational Symmetry Number',iSigma)

! Get character table to convert MOLPRO symmetry format
call MOLPRO_ChTab(nSym,Label,iChMolpro)

! Convert orbital symmetry into MOLPRO format
call mma_allocate(OrbSym,NAC,label='OrbSym')
iOrb = 1
do iSym=1,nSym
  do jOrb=1,NASH(iSym)
    OrbSym(iOrb) = iChMolpro(iSym)
    iOrb = iOrb+1
  end do
end do
lSymMolpro = iChMolpro(stSym)

NRDM_ORDER = 2
if (NACTEL == 1) NRDM_ORDER = 1

!*********************
!  WRITEOUT FCIDUMP  *
!*********************

LINSIZE = (NAC*(NAC+1))/2
NUM_TEI = (LINSIZE*(LINSIZE+1))/2
call FCIDUMP_OUTPUT(NAC,NACTEL,ISPIN-1,lSymMolpro,OrbSym,Zero,W1,TUVX,LINSIZE,NUM_TEI)

call mma_deallocate(OrbSym)

!*************************
!  WRITEOUT ACTIVE FOCK  *
!*************************

!write(u6,*) 'Currently the Fock matrix is printed in fckpt2.f'

!************************
!  WRITEOUT INPUT FILE  *
!************************

#ifdef _MOLCAS_MPP_
if (KING() .or. (.not. Is_Real_Par())) then
#endif
  if (IRST == 0) then
    ! Cleanup chemps2.log.total
    imp1 = 'chemps2.log.total'
    call f_inquire(imp1,Found)
    if (Found) call aixrm(imp1)
    ! Check if checkpoint files exist
    if (chemps2_restart) then
      call f_inquire('CHEMNATFIE',fiedler)
      call f_inquire('CHEMNATMPS0',mps0)
      if (fiedler .and. mps0) then
        write(u6,*) 'CHEMPS2> Found checkpoint files for DMRG-SCF'
        ! Copy CheMPS2_natorb_MPSxxx.h5 to CheMPS2_MPSxxx.h5
        call fcopy('CHEMNATFIE','CHEMFIE',iErr)
        do chemroot=1,lroots
          write(rootindex,'(i2)') chemroot-1
          imp1 = 'CheMPS2_natorb_MPS'//trim(adjustl(rootindex))//'.h5'
          imp2 = 'CheMPS2_MPS'//trim(adjustl(rootindex))//'.h5'
          call fcopy(imp1,imp2,iErr)
        end do
      else
        ! Reset chemps2_restart = .false. if not checkpoint files
        write(u6,*) 'CHEMPS2> No checkpoint files for DMRG-SCF'
        chemps2_restart = .false.
      end if
    end if
    ! Check if checkpoint files for 3RDM exist
    if (chemps2_lrestart == 1) then
      call f_inquire('CHEMCANFIE',fiedler)
      call f_inquire('CHEMCANMPS0',mps0)
      if (fiedler .and. mps0) then
        write(u6,*) 'CHEMPS2> Found checkpoint files for n-RDM'
      else
        write(u6,*) 'CHEMPS2> No checkpoint files for n-RDM'
        chemps2_lrestart = 0
      end if
    end if
  end if
#ifdef _MOLCAS_MPP_
end if
#endif

LUCHEMIN = isFreeUnit(29)
call molcas_open(LUCHEMIN,'chemps2.input')
write(LUCHEMIN,*) 'FCIDUMP = FCIDUMP_CHEMPS2'

call group_psi4number(Label,Labelpsi4)
write(LUCHEMIN,'(1x,a8,i1)') 'GROUP = ',Labelpsi4
write(LUCHEMIN,*)

write(LUCHEMIN,'(1x,a13,i2)') 'EXCITATION = ',lRoots-1
write(LUCHEMIN,*)

if (((abs(CBLBM) > chemps2_blb) .and. (IFINAL /= 2)) .or. &
    ((IRST == 0) .and. (.not. chemps2_restart)) .or. &
    ((IFINAL == 2) .and. Do3RDM .and. (chemps2_lrestart == 0)) .or. &
    ((IFINAL == 2) .and. (iOrbTyp == 2) .and. (chemps2_lrestart == 0))) then

  imp1 = 'molcas_fiedler.txt'
  call f_inquire(imp1,Found)
  if (Found) call aixrm(imp1)
  !Quan: FIXME: how to remove CheMPS2_MPS0.h5, etc with aixrm
  call systemf('rm -f CheMPS2_MPS*.h5',iErr)
  write(LUCHEMIN,*) 'MOLCAS_MPS     = TRUE'
  write(u6,*) 'CHEMPS2> Start DMRG from scratch'

  write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_STATES       = '
  dtemp = 500
  do
    write(LUCHEMIN,('(i7,a2)'),advance='NO') dtemp,','
    dtemp = dtemp+min(dtemp,1000)
    if (dtemp >= MxDMRG) then
      write(LUCHEMIN,'(i7,a2,i7)') MxDMRG,',',MxDMRG
      exit
    end if
  end do

  write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_ENERGY_CONV  = '
  dtemp = 500
  do
    if (dtemp == 500) then
      write(LUCHEMIN,'(es12.5,a3)',advance='NO') THRE*1.0e3_wp,','
    else
      write(LUCHEMIN,'(es12.5,a3)',advance='NO') THRE*1.0e2_wp,','
    end if

    dtemp = dtemp+min(dtemp,1000)
    if (dtemp >= MxDMRG) then
      write(LUCHEMIN,'(es12.5,a3,es12.5)') THRE*Five,',',THRE*Half
      exit
    end if
  end do

  write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_MAX_SWEEPS   = '
  dtemp = 500
  do
    if (dtemp == 500) then
      write(LUCHEMIN,'(i7,a3)',advance='NO') max_sweep,','
    else
      write(LUCHEMIN,'(i7,a3)',advance='NO') max_sweep/2,','
    end if

    dtemp = dtemp+min(dtemp,1000)
    if (dtemp >= MxDMRG) then
      if (IFINAL == 2) then
        if (Do3RDM .or. (iOrbTyp == 2)) then
          write(LUCHEMIN,'(i7,a3,i7)') max_sweep/2,',',max_canonical
        else
          write(LUCHEMIN,'(i7,a3,i7)') max_sweep/2,',',max_sweep*5
        end if
      else
        write(LUCHEMIN,'(i7,a3,i7)') max_sweep/2,',',max_sweep
      end if
      exit
    end if
  end do

  write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_NOISE_PREFAC = '
  dtemp = 500
  do
    write(LUCHEMIN,'(es12.5,a3)',advance='NO') chemps2_noise,','
    dtemp = dtemp+min(dtemp,1000)
    if (dtemp >= MxDMRG) then
      write(LUCHEMIN,'(es12.5,a10)') chemps2_noise,' ,   0.00'
      exit
    end if
  end do

  write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_DVDSON_RTOL  = '
  dtemp = 500
  do
    if (dtemp == 500) then
      write(LUCHEMIN,'(a9)',advance='NO') '1.0e-3 ,'
    else
      write(LUCHEMIN,'(a9)',advance='NO') '1.0e-4 ,'
    end if

    dtemp = dtemp+min(dtemp,1000)
    if (dtemp >= MxDMRG) then
      write(LUCHEMIN,'(a9,es12.5)') '1.0e-4 ,',davidson_tol
      exit
    end if
  end do
  write(LUCHEMIN,*)

else
  ! DMRG restart with fixed orbital order
  if (((abs(CBLBM) > chemps2_blb/Ten) .and. (IFINAL /= 2)) .or. ((IRST == 0) .and. chemps2_restart)) then
    write(u6,*) 'CHEMPS2> Partial restart DMRG from previous step'

    write(LUCHEMIN,*) 'MOLCAS_MPS     = TRUE'
    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_STATES       = '
    write(LUCHEMIN,'(i7,a2,i7)') MxDMRG,',',MxDMRG

    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_ENERGY_CONV  = '
    write(LUCHEMIN,'(es12.5,a3,es12.5)') THRE*Five,',',THRE*Half

    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_MAX_SWEEPS   = '
    if (IFINAL == 2) then
      if (Do3RDM .or. (iOrbTyp == 2)) then
        write(LUCHEMIN,'(i7,a3,i7)') max_sweep/2,',',max_canonical
      else
        write(LUCHEMIN,'(i7,a3,i7)') max_sweep/2,',',max_sweep*5
      end if
    else
      write(LUCHEMIN,'(i7,a3,i7)') max_sweep/2,',',max_sweep
    end if

    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_NOISE_PREFAC = '
    write(LUCHEMIN,'(es12.5,a10)') chemps2_noise,' ,   0.00'

    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_DVDSON_RTOL  = '
    write(LUCHEMIN,'(a9,es12.5)') '1.0e-4 ,',davidson_tol
    write(LUCHEMIN,*)
  else
    !write(u6,*) 'Full Restart'
    write(u6,*) 'CHEMPS2> Fully restart DMRG from previous step'
    write(LUCHEMIN,*) 'MOLCAS_MPS     = TRUE'
    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_STATES       = '
    write(LUCHEMIN,'(i7)') MxDMRG

    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_ENERGY_CONV  = '
    write(LUCHEMIN,'(es12.5)') THRE*Half

    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_MAX_SWEEPS   = '
    if ((IFINAL == 2) .or. ((IFINAL == 1) .and. (iCIonly == 1))) then
      if ((IFINAL == 2) .and. (Do3RDM .or. (iOrbTyp == 2))) then
        write(LUCHEMIN,'(i7)') max_canonical
      else
        write(LUCHEMIN,'(i7)') max_sweep*5
      end if
    else
      write(LUCHEMIN,'(i7)') max_sweep
    end if

    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_NOISE_PREFAC = '
    write(LUCHEMIN,'(a16)') '   0.00'

    write(LUCHEMIN,'(1x,a21)',advance='NO') 'SWEEP_DVDSON_RTOL  = '
    write(LUCHEMIN,'(es12.5)') davidson_tol
    write(LUCHEMIN,*)
  end if
end if

write(LUCHEMIN,'(a8)',advance='nO') 'NOCC = '
do nooctemp=1,NSYM-1
  write(LUCHEMIN,'(a5)',advance='NO') '0 ,'
end do
write(LUCHEMIN,'(a3)') '0'

write(LUCHEMIN,'(a8)',advance='NO') 'NACT = '
call molpro2psi(Label,conversion)
do iSym=1,nSym
  activesize(conversion(iChMolpro(iSym))) = NASH(iSym)
end do
do nooctemp=1,NSYM-1
  write(LUCHEMIN,'(i3,a2)',advance='NO') activesize(nooctemp),' ,'
end do
write(LUCHEMIN,'(i3)') activesize(NSYM)

write(LUCHEMIN,'(a8)',advance='NO') 'NVIR = '
do nooctemp=1,NSYM-1
  write(LUCHEMIN,'(a5)',advance='NO') '0 ,'
end do
write(LUCHEMIN,'(a3)') '0'
write(LUCHEMIN,*)

write(LUCHEMIN,*) 'MOLCAS_FIEDLER = TRUE'
write(LUCHEMIN,*) 'MOLCAS_STATE_AVG = TRUE'
write(LUCHEMIN,*) 'MOLCAS_2RDM    = molcas_2rdm.h5'

if (sum(hfocc) == NACTEL) then
  write(u6,*) 'CHEMPS2> Using user-specified ROHF guess'
  write(LUCHEMIN,'(a13)',advance='NO') 'MOLCAS_OCC ='
  do ihfocc=1,NAC-1
    write(LUCHEMIN,'(i3,a2)',advance='NO') HFOCC(ihfocc),', '
  end do
  write(LUCHEMIN,'(i3)') HFOCC(NAC)
else
  write(u6,*) 'CHEMPS2> Using noise guess'
end if

if ((IFINAL == 2) .and. Do3RDM .and. (NACTEL > 2)) then
  write(u6,*) 'CHEMPS2> Running 3-RDM and F.4-RDM'
  write(LUCHEMIN,*) 'MOLCAS_3RDM    = molcas_3rdm.h5'
  write(LUCHEMIN,*) 'MOLCAS_F4RDM   = molcas_f4rdm.h5'
  write(LUCHEMIN,*) 'MOLCAS_FOCK    = FOCK_CHEMPS2'
end if

write(LUCHEMIN,*)

write(LUCHEMIN,*) 'PRINT_CORR = TRUE'
write(LUCHEMIN,*) 'TMP_FOLDER = ./'

close(LUCHEMIN)

#ifdef _MOLCAS_MPP_
write(u6,'(1x,a21,i3)') 'CHEMPS2> ITERATION : ',ITER
if (KING() .or. (.not. Is_Real_Par())) then
#endif

  ! Quan: overwrite CheMPS2_xxxorb_MPSX.h5 to CheMPS2_MPSX.h5
  if (((IFINAL == 2) .and. Do3RDM .and. (chemps2_lrestart > 0)) .or. &
      ((IFINAL == 2) .and. (iOrbTyp == 2) .and. (chemps2_lrestart > 0))) then
    if (chemps2_lrestart == 1) then
      write(u6,*) 'CHEMPS2> Using user-supplied checkpoint files'
      call fcopy('CHEMCANFIE','CHEMFIE',iErr)
      do chemroot=1,lroots
        write(rootindex,'(i2)') chemroot-1
        imp1 = 'CheMPS2_canorb_MPS'//trim(adjustl(rootindex))//'.h5'
        imp2 = 'CheMPS2_MPS'//trim(adjustl(rootindex))//'.h5'
        call fcopy(imp1,imp2,iErr)
      end do
    end if

    if (chemps2_lrestart == 2) then
      write(u6,*) 'CHEMPS2> Using checkpoint files from previous step (not recommended)'
      call fcopy('CHEMNATFIE','CHEMFIE',iErr)
      do chemroot=1,lroots
        write(rootindex,'(i2)') chemroot-1
        imp1 = 'CheMPS2_natorb_MPS'//trim(adjustl(rootindex))//'.h5'
        imp2 = 'CheMPS2_MPS'//trim(adjustl(rootindex))//'.h5'
        call fcopy(imp1,imp2,iErr)
      end do
    end if
  end if

  ! Quan: save CANORB before actually calculating
  if (((IFINAL == 2) .and. Do3RDM) .or. ((IFINAL == 2) .and. (iOrbTyp == 2))) then
    write(u6,*) 'CHEMPS2> Save CANORB'
    ! Quan: FIXME: Bug!
    !call OrbFiles(JOBIPH,IPRLEV)
  end if

  call systemf('chemps2 --file=chemps2.input > chemps2.log',iErr)
  call systemf('cat chemps2.log >> chemps2.log.total',iErr)

  ! Quan: save natorb checkpoint file in all iteration
  if (IFINAL < 2) then
    if (IFINAL == 1) then
      write(u6,*) 'CHEMPS2> Save natorb checkpoint files'
    end if
    call fcopy('CHEMFIE','CHEMNATFIE',iErr)
    do chemroot=1,lroots
      write(rootindex,'(i2)') chemroot-1
      imp1 = 'CheMPS2_natorb_MPS'//trim(adjustl(rootindex))//'.h5'
      imp2 = 'CheMPS2_MPS'//trim(adjustl(rootindex))//'.h5'
      call fcopy(imp2,imp1,iErr)
    end do
  end if

  ! Quan: save canorb checkpoint file if possible
  if (((IFINAL == 2) .and. Do3RDM) .or. ((IFINAL == 2) .and. (iOrbTyp == 2))) then

    write(u6,*) 'CHEMPS2> Save canorb checkpoint files'
    call fcopy('CHEMFIE','CHEMCANFIE',iErr)
    do chemroot=1,lroots
      write(rootindex,'(i2)') chemroot-1
      imp1 = 'CheMPS2_canorb_MPS'//trim(adjustl(rootindex))//'.h5'
      imp2 = 'CheMPS2_MPS'//trim(adjustl(rootindex))//'.h5'
      call fcopy(imp2,imp1,iErr)
    end do
  end if

  ! Quan: Cleanup checkpoint files
  if (IFINAL == 2) then
    imp1 = 'molcas_fiedler.txt'
    call f_inquire(imp1,Found)
    if (Found) call aixrm(imp1)
    !Quan: FIXME: how to remove CheMPS2_MPS0.h5, etc with aixrm
    call systemf('rm -f CheMPS2_MPS*.h5',iErr)
  end if

#ifdef _MOLCAS_MPP_
end if

if (Is_Real_Par()) then
  call MPI_Barrier(MPI_COMM_WORLD,IERROR)
end if

!Quan: FIXME: softlink all the n-RDM files
if (Is_Real_Par() .and. (.not. KING())) then
  do chemroot=1,lroots
    write(rootindex,'(i2)') chemroot-1
    imp1 = 'ln -sf ../molcas_2rdm.h5.r'//trim(adjustl(rootindex))//' .'
    call systemf(imp1,iErr)
    imp1 = 'ln -sf ../molcas_3rdm.h5.r'//trim(adjustl(rootindex))//' .'
    call systemf(imp1,iErr)
    imp1 = 'ln -sf ../molcas_f4rdm.h5.r'//trim(adjustl(rootindex))//' .'
    call systemf(imp1,iErr)
    imp1 = 'ln -sf ../CheMPS2_natorb_MPS0.h5 .'
    call systemf(imp1,iErr)
    imp1 = 'ln -sf ../CheMPS2_canorb_MPS0.h5 .'
    call systemf(imp1,iErr)
    imp1 = 'ln -sf ../molcas_natorb_fiedler.txt .'
    call systemf(imp1,iErr)
    imp1 = 'ln -sf ../molcas_canorb_fiedler.txt .'
    call systemf(imp1,iErr)
  end do
  call systemf('ln -sf ../chemps2.log .',iErr)
end if
#endif

!Quan: a very dirty way to extract the total energy
call systemf('grep "***  2-RDM" -B 5 chemps2.log | grep "all instructions" | cut -c 61- > chemps2_totale_4d',iErr)

!Quan: fix bug E(FCI) != E(CASSCF)
call systemf('grep "Econst" chemps2.log | cut -c 39- > chemps2_totale',iErr)

LUTOTE = isFreeUnit(30)
call molcas_open(LUTOTE,'chemps2_totale')

!Quan: write energy to ENER
do chemroot=1,lroots
  read(LUTOTE,*) ENER(chemroot,ITER)
end do
close(LUTOTE)

!Quan: check the difference between ener and ener_4d
LUTOTE = isFreeUnit(30)
call molcas_open(LUTOTE,'chemps2_totale_4d')
do chemroot=1,lroots
  read(LUTOTE,*) chemps2_totale_4d
  revdiff = abs(chemps2_totale_4d-ENER(chemroot,ITER))/chemps2_totale_4d
  if (revdiff > 1.0e-9_wp) then
    write(u6,*) 'CHEMPS2> large (E(4m) - E(m))/E(4m) = ',revdiff,'for root',chemroot,', consider increasing m!'
  end if
end do
close(LUTOTE)

!Quan: check chemps2 convergence
write(rootindex,'(i2)') lroots+9
imp1 = ''
imp1 = 'grep "***  2-RDM" -B '//trim(adjustl(rootindex))//' chemps2.log | grep "Energy difference" | cut -c 69- > chemps2_conv'
call systemf(imp1,iErr)

LUCONV = isFreeUnit(30)
call molcas_open(LUCONV,'chemps2_conv')
do chemroot=1,lroots
  read(LUCONV,*) chemps2_conv
  write(u6,'(1x,a14,i3,a30,es10.2)') 'CHEMPS2> Root ',chemroot,' :: DMRG energy convergence : ',chemps2_conv
  if (abs(chemps2_conv) > THRE*Half) then
    write(u6,*) 'CHEMPS2> DMRG not converged, consider increasing MXSWeep'
  end if
end do
close(LUCONV)

!Quan: check if CheMPS2 finished without error
imp1 = 'grep "Info on DMRG" chemps2.log | cut -c 43- > chemps2_info'
call systemf(imp1,iErr)

LUCONV = isFreeUnit(30)
call molcas_open(LUCONV,'chemps2_info')
read(LUCONV,*) chemps2_info
close(LUCONV)
if (chemps2_info /= 0) then
  write(u6,*) 'CHEMPS2> CheMPS2 ends abnormally, check calculation'
end if

return

end subroutine Chemps2Ctl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ABD(ICSPCK,INTSYM,INDX,C,DMO,A,B,F,JREFX)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION ICSPCK(*),INTSYM(*),INDX(*),
     *          C(*),DMO(*),A(*),B(*),
     *          F(*),JREFX(*)
      DIMENSION IPOA(9),IPOF(9)
      DIMENSION IOC(55)
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CPAM97      JO(L)=UNPACK(CSPCK((L+29)/30), 2*L-(2*L-1)/60*60, 2)
      JO(L)=ICUNP(ICSPCK,L)
CPAM96      JSYM(L)=UNPACK(INTSYM((L+9)/10),3*MOD(L-1,10)+1,3)+1
      JSYM(L)=JSUNP(INTSYM,L)
C SCRATCH SPACE: A(),B(),F().
      CALL CSCALE(INDX,INTSYM,C,SQ2)
      NCLIM=4
      IF(IFIRST.NE.0)NCLIM=2
      ENPINV=1.0D00/ENP
C MOVE DENSITY MATRIX TO F IN SYMMETRY BLOCKS
      CALL IPO(IPOF,NVIR,MUL,NSYM,1,-1)
      DO 10 IASYM=1,NSYM
        IAB=IPOF(IASYM)
        NA1=NVIRP(IASYM)+1
        NA2=NVIRP(IASYM)+NVIR(IASYM)
        DO 15 NA=NA1,NA2
          DO 20 NB=NA1,NA2
            IAB=IAB+1
            NAB=IROW(LN+NA)+LN+NB
            IF(NB.GT.NA)NAB=IROW(LN+NB)+LN+NA
            F(IAB)=DMO(NAB)
20        CONTINUE
15      CONTINUE
10    CONTINUE
      II1=0
      ITAIL=IRC(NCLIM)
      DO 40 INDA=1,ITAIL
        DO 110 I=1,LN
          II1=II1+1
          IOC(I)=(1+JO(II1))/2
110     CONTINUE
      IF(INDA.LE.IRC(1)) THEN
        TSUM=ENPINV*C(INDA)**2
        GO TO 106
      END IF
      MYSYM=JSYM(INDA)
      MYL=MUL(MYSYM,LSYM)
      INMY=INDX(INDA)+1
      IF(INDA.GT.IRC(2))GO TO 25
C DOUBLET-DOUBLET INTERACTIONS
      IF(NVIR(MYL).EQ.0)GO TO 40
      CALL FMUL2(C(INMY),C(INMY),A,NVIR(MYL),NVIR(MYL),1)
      IPF=IPOF(MYL)+1
      IN=IPOF(MYL+1)-IPOF(MYL)
      CALL DAXPY_(IN,ENPINV,A,1,F(IPF),1)
      NVIRA=NVIR(MYL)
      LNA=LN+NVIRP(MYL)
      IIA=IROW(LNA+1)
      TSUM=0.0D00
      DO 130 I=1,NVIRA
        SUM=ENPINV*C(INMY)**2
        INMY=INMY+1
        TSUM=TSUM+SUM
        IIA=IIA+LNA+I
        DMO(IIA)=DMO(IIA)+SUM
130   CONTINUE
      GO TO 106
C TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
25    IFT=1
      IF(INDA.GT.IRC(3))IFT=0
      CALL IPO(IPOA,NVIR,MUL,NSYM,MYL,IFT)
      IN=0
      TSUM=0.0D00
      DO 70 IASYM=1,NSYM
      IAB=IPOF(IASYM+1)-IPOF(IASYM)
      IF(IAB.EQ.0)GO TO 70
      ICSYM=MUL(MYL,IASYM)
      IF(NVIR(ICSYM).EQ.0)GO TO 70
      IF(MYL.NE.1) THEN
        IF(IASYM.GT.ICSYM) THEN
          CALL MTRANS(C(INMY+IPOA(IASYM)),1,A,1,NVIR(IASYM),NVIR(ICSYM))
        ELSE
          NAC=NVIR(IASYM)*NVIR(ICSYM)
          IF(IFT.EQ.0)CALL DCOPY_(NAC,C(INMY+IPOA(ICSYM)),1,A,1)
          IF(IFT.EQ.1)CALL VNEG(C(INMY+IPOA(ICSYM)),1,A,1,NAC)
        END IF
      ELSE
        IF(IFT.EQ.0)CALL SQUAR(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
        IF(IFT.EQ.1)CALL SQUARM(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      END IF
      NVIRA=NVIR(IASYM)
      NVIRC=NVIR(ICSYM)
      CALL FMUL2(A,A,B,NVIR(IASYM),NVIR(IASYM),NVIR(ICSYM))
      IPF=IPOF(IASYM)+1
      CALL DAXPY_(IAB,ENPINV,B,1,F(IPF),1)
      INN=1
      LNC=LN+NVIRP(ICSYM)
      IIC=IROW(LNC+1)
      DO 105 I=1,NVIRC
        SUM=ENPINV*DDOT_(NVIRA,A(INN),1,A(INN),1)
        TSUM=TSUM+SUM
        IIC=IIC+LNC+I
        DMO(IIC)=DMO(IIC)+SUM
        INN=INN+NVIRA
105   CONTINUE
70    CONTINUE
      TSUM=TSUM/2
106   CONTINUE
      IJ=0
      DO 107 I=1,LN
        IJ=IJ+I
        DMO(IJ)=DMO(IJ)+IOC(I)*TSUM
107   CONTINUE
40    CONTINUE
      DO 410 IASYM=1,NSYM
        IAB=IPOF(IASYM)
        NA1=NVIRP(IASYM)+1
        NA2=NVIRP(IASYM)+NVIR(IASYM)
        DO 415 NA=NA1,NA2
          DO 420 NB=NA1,NA2
            IAB=IAB+1
            IF(NA.GE.NB) GOTO 420
            NAB=IROW(LN+NB)+LN+NA
            DMO(NAB)=F(IAB)
420       CONTINUE
415     CONTINUE
410   CONTINUE
      TR=0.0D00
      IJ=0
      DO 510 I=1,NCSHT
        IJ=IJ+I
        TR=TR+DMO(IJ)
510   CONTINUE
      IF(ABS(TR-DBLE(NELEC)) .GT. 1.0D-8) WRITE(6,310)TR
310   FORMAT(/,6X,'TRACE OF DENSITY MATRIX',F16.8)
      CALL CSCALE(INDX,INTSYM,C,SQ2INV)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer_array(JREFX)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRSM_DKH(A,B,C,N,H,W)
! TRANSFORM SYMMETRIC MATRIX A BY UNITARY TRANSFORMATION IN B.
! RESULT IS IN C

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: A(N*(N+1)/2), B(N,N)
real(kind=wp), intent(out) :: C(N*(N+1)/2), H(N,N), W(N,N)
integer(kind=iwp) :: I, IJ, J, K, L

IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    C(IJ) = Zero
    W(I,J) = A(IJ)
    W(J,I) = A(IJ)
    H(I,J) = Zero
    H(J,I) = Zero
  end do
end do
do I=1,N
  do L=1,N
    do K=1,N
      H(I,L) = B(K,I)*W(K,L)+H(I,L)
    end do
  end do
end do
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    do L=1,N
      C(IJ) = H(I,L)*B(L,J)+C(IJ)
    end do
  end do
end do

return

end subroutine TRSM_DKH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE JACOB_REL(A,B,EIG,N,RANGE,IC)
      IMPLICIT REAL*8(A-H,O-Z)
C     IC=1 EIGNEVALUES AND VECTORS REARRANGED
C       =0 LEFT AS THEY ARE
      DIMENSION A(N,N),B(N,N),EIG(N)
      ENUI=0.D0
      U1=DBLE(N)
      DO 5 I=1,N
      B(I,I)=1.D0
      EIG(I)=A(I,I)
      DO 6 J=1,I
      IF(I.EQ.J)GO TO 6
      B(I,J)=0.D0
      B(J,I)=0.D0
      ENUI=ENUI+A(I,J)*A(I,J)
    6 CONTINUE
    5 CONTINUE
      IF (ENUI.LE.0) THEN
        GO TO 200
      ELSE
        GO TO 10
      END IF
   10 ENUI=sqrt(2.D0*ENUI)
      ENUF=ENUI*RANGE/U1
      IND=0
      THR=ENUI
   15 THR=THR/U1
   20 L=1
   25 M=L+1
   30 IF (abs(A(M,L))-THR.LT.0) THEN
        GO TO 90
      ELSE
        GO TO 35
      END IF
   35 IND=1
      X=.5D0*(EIG(L)-EIG(M))
      Y=-A(M,L)/sqrt(A(M,L)*A(M,L)+X*X)
      IF (X.LT.0) THEN
        GO TO 40
      ELSE
        GO TO 45
      END IF
   40 Y=-Y
   45 IF(Y.GT.1.D0)Y=1.D0
      IF(Y.LT.-1.D0)Y=-1.D0
      XY=1.D0-Y*Y
      SINT=Y/sqrt(2.D0*(1.D0+sqrt(XY)))
      SINT2=SINT*SINT
      COST2=1.D0-SINT2
      COST=sqrt(COST2)
      SINCS=SINT*COST
      DO 85 I=1,N
      IF (I-M.LT.0) THEN
        GO TO 50
      ELSE IF (I-M.EQ.0) THEN
        GO TO 80
      ELSE
        GO TO 55
      END IF
   50 IM=M
      MM=I
      GO TO 60
   55 IM=I
      MM=M
   60 IF (I-L.LT.0) THEN
        GO TO 65
      ELSE IF (I-L.EQ.0) THEN
        GO TO 80
      ELSE
        GO TO 70
      END IF
   65 IL=L
      LL=I
      GO TO 75
   70 IL=I
      LL=L
   75 X=A(IL,LL)*COST-A(IM,MM)*SINT
      A(IM,MM)=A(IL,LL)*SINT+A(IM,MM)*COST
      A(IL,LL)=X
   80 X=B(I,L)*COST-B(I,M)*SINT
      B(I,M)=B(I,L)*SINT+B(I,M)*COST
      B(I,L)=X
   85 CONTINUE
      X=2.D0*A(M,L)*SINCS
      Y=EIG(L)*COST2+EIG(M)*SINT2-X
      X=EIG(L)*SINT2+EIG(M)*COST2+X
      A(M,L)=(EIG(L)-EIG(M))*SINCS+A(M,L)*(COST2-SINT2)
      EIG(L)=Y
      EIG(M)=X
   90 IF (M-N.EQ.0) THEN
        GO TO 100
      ELSE
        GO TO 95
      END IF
   95 M=M+1
      GO TO 30
  100 IF (L-M+1.EQ.0) THEN
        GO TO 110
      ELSE
        GO TO 105
      END IF
  105 L=L+1
      GO TO 25
  110 IF (IND-1.EQ.0) THEN
        GO TO 115
      ELSE
        GO TO 120
      END IF
  115 IND=0
      GO TO 20
  120 IF (THR-ENUF.LE.0) THEN
        GO TO 200
      ELSE
        GO TO 15
      END IF
  200 IF(IC.EQ.0)GO TO 230
      DO 225 I=1,N
      DO 226 J=I,N
      IF (EIG(I)-EIG(J).LE.0) THEN
        GO TO 226
      ELSE
        GO TO 210
      END IF
  210 X=EIG(I)
      EIG(I)=EIG(J)
      EIG(J)=X
      DO 220 K=1,N
      Y=B(K,I)
      B(K,I)=B(K,J)
      B(K,J)=Y
  220 CONTINUE
  226 CONTINUE
  225 CONTINUE
  230 CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine defvhlp22(r1,v,dimr1a,dimr1c,dimvab,dimva,dimvc,adda,addc)
! this routine does
! V(ab,c)xxx = R1(a,c,b)-R1(b,c,a) x=a,b
! for syma=symb<symc
!
! r1     - r1 matrix (I)
! v      - v matrix (O)
! dimr1a - dimension of a (b) in R1 (I)
! dimr1c - dimension of c in R1 (I)
! dimvab - dimension of ab in V (I)
! dimva  - dimension of a (b) in V (I)
! dimvc  - dimension of c in V (I)
! adda   - additional constant to a (b) (I)
! addc   - additional constant to c (I)

use CCT3_global, only: nshf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimr1a, dimr1c, dimvab, dimva, dimvc, adda, addc
real(kind=wp), intent(in) :: r1(dimr1a,dimr1c,dimr1a)
real(kind=wp), intent(out) :: v(dimvab,dimvc)
integer(kind=iwp) :: a, ab, ab0, ar1, b, c, cr1

do c=1,dimvc
  cr1 = c+addc
  do a=2,dimva
    ar1 = a+adda
    ab0 = nshf(a)
    v(ab0+1:ab0+a-1,c) = r1(ar1,cr1,adda+1:adda+a-1)
  end do
end do

do a=2,dimva
  ar1 = a+adda
  ab0 = nshf(a)
  do c=1,dimvc
    cr1 = c+addc
    do b=1,a-1
      ab = ab0+b
      v(ab,c) = v(ab,c)-r1(b+adda,cr1,ar1)
    end do
  end do
end do

return

end subroutine defvhlp22

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SymAdO(ArrIn,nZeta,la,lb,nComp,ArrOut,nIC,iDCRT,lOper,iChO,Factor)

use Index_Functions, only: nTri_Elem1
use Symmetry_Info, only: iChTbl, iOper, nIrrep, Prmt
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nComp, nIC, iDCRT, lOper(nComp), iChO(nComp)
real(kind=wp), intent(in) :: ArrIn(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nComp), Factor
real(kind=wp), intent(inout) :: ArrOut(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nIC)
integer(kind=iwp) :: iComp, iIC, iIrrep
real(kind=wp) :: pO, Xg

!nA = nTri_Elem1(la)
!nB = nTri_Elem1(lb)
!call RecPrt('SymAdO: ArrIn',' ',ArrIn,nZeta*nA*nB, nComp)

! Accumulate contributions

iIC = 0
do iComp=1,nComp
  pO = Prmt(iOper(iDCRT),iChO(iComp))
  do iIrrep=0,nIrrep-1
    if (.not. btest(lOper(iComp),iIrrep)) cycle
    iIC = iIC+1
    Xg = real(iChTbl(iIrrep,iDCRT),kind=wp)
    ArrOut(:,:,:,iIC) = ArrOut(:,:,:,iIC)+Xg*pO*Factor*ArrIn(:,:,:,iComp)
  end do
end do
if (iIC /= nIC) then
  call WarningMessage(2,' Abend in SymAdO: iIC /= nIC')
  write(u6,*) 'iIC,nIC=',iIC,nIC
  call Abend()
end if
!call RecPrt('SymAdO: ArrOut',' ',ArrOut,nZeta*nA*nB,nIC)

end subroutine SymAdO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mv0v1u (length,X,incX,Y,incY,f)
C
C      Y = Y + f . X
C
       implicit none
#include "chcc1.fh"
c
       integer length,incx,incy
       real*8  f
       real*8  X(*)
       real*8  Y(*)
C
C      help variables
C
       integer i
C
       if (mhkey.eq.1) then
c      ESSL
       call daxpy_(length,f,X(1),incx,Y(1),incY)
C
       else
c      Fotran
C
       if (incx*incy.eq.1) then
c
         do 10 i=1, length
         y(i) = y(i)+f*x(i)
 10      continue
       else
         do 20 i=0, length-1
         y(1+i*incy) = y(1+i*incy)+f*x(1+i*incx)
 20      continue
       end if
C
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SetDecAlg_Def()
C
C     Set default decomposition algorithm.
C
      Implicit None
#include "cholesky.fh"

CSVC This is what CHO_DECALG means according to TBP:
C     1 - serial one-step (the original algorithm)
C     2 - serial two-step (the original two-step algorithm)
C     3 - naive (mainly for test purposes; should never be used)
C     4 - parallel one-step (parallel modifications of the original one-step, can also run in serial - but gives a different result than the original serial one-step)
C     5 - parallel two-step (a two-step algorithm different from the serial one; can also run in serial)
C     6 - parallel naive (again, mainly for testing)

CSVC: the default used to be 5 (parallel two-step), but because of a problem
C with DGA where it hangs when using a largish number of processes, the default
C has been changed to 4, i.e. the parallel one-step algorithm. The default
C should be changed back to 5 if and when DGA and/or Cholesky have been adapted.

      Cho_DecAlg_Def=4

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine SaveX (X,length,Lun,LunName,keyopen,keyclose)
c
c       this routine do
c       1) keyopen = 1 - open LunName file with Lun
c                    2 - rewind Lun file
c                    3 - open LunName file with Lun with ACCESS='append'
c                 else - nothing (i.e) file is opened
c       2) write X  of dimension length
c       3) keyclose= 1 - close Lun file
c                 else - nothing
c
c
        implicit none
        integer length,Lun,keyopen,keyclose
        real*8 X(1)
        character*6 LunName
c
c1
        if (keyopen.eq.1) then
*         open (unit=Lun,file=LunName,form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
        else if (keyopen.eq.2) then
          rewind(Lun)
        else if (keyopen.eq.3) then
cmp!          open (unit=Lun,file=LunName,form='unformatted',
cmp!     c          ACCESS='append')

          Call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
          call append_file_u(Lun)

        end if
c
c2
        call wri_chcc (Lun,length,X(1))
c
c3
        if (keyclose.eq.1) then
          close (Lun)
        end if
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,1995, Per-Olof Widmark                            *
!               1992,1995, Markus P. Fuelscher                         *
!               1992,1995, Piotr Borowski                              *
!               1992,1995, Martin Schuetz                              *
!               2016,2017, Roland Lindh                                *
!***********************************************************************

subroutine MemAlo()
!***********************************************************************
!                                                                      *
!     purpose: allocate memory for density & fock matrices etc.        *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use LnkLst, only: NodSiz
use InfSCF, only: Aufb, CMO, CMO_Ref, Dens, DSCF, EDFT, EOrb, FockAO, FockMO, HDiag, MaxBas, MemRsv, mOV, MxIter, MxOptm, nBB, &
                  nBO, nBT, nD, nDens, nIter, nMem, nnB, nnOc, nOO, nOV, OccNo, OrbType, TrM, TwoHam, Vxc
use stdalloc, only: mma_allocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: lthCor, lthDii, lthGrd, lthH, lthLiS, lthPMt, lthRst, lthTot, Mx_nIter, MxMem, nIt0

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

call Setup_SCF()

! Allocate memory for TrMat, CMO and occupation numbers

call mma_allocate(TrM,nBB,nD,Label='TrM')
call mma_allocate(CMO,nBB,nD,Label='CMO')
call mma_allocate(CMO_Ref,nBB,nD,Label='CMO_Ref')

call mma_allocate(FockAO,nBT,nD,Label='FockAO')
FockAO(:,:) = Zero
call mma_allocate(FockMO,nOO,nD,Label='FockMO')
FockMO(:,:) = Zero

call mma_allocate(OccNo,nnB,nD,Label='OccNo')
OccNo(:,:) = Zero
call mma_allocate(EOrb,nnB,nD,Label='EOrb')
EOrb(:,:) = Zero
call mma_allocate(OrbType,nnB,nD,Label='OrbType')
OrbType(:,:) = 0

nIt0 = 0
Mx_nIter = max(nIter(0),nIter(1)+nIt0)

! Allocate Dens and TwoHam
! a) permanently in core (apart from Dens and TwoHam)
lthCor = 3*nBT+2*nBB+2*nnB+nnOc+MxOptm+1+(MxOptm+1)**2+MxIter+MxIter**2+nTri_Elem(Mx_nIter)+1
! b) space needed by PMat
if (DSCF) then
  lthPMt = 1024*1024+2*nBT
else
  lthPMt = nBB+2*(MaxBas**2)
end if
! c) the biggest scratch space is used by SubRoutine Diis
lthgrd = nOO+nOV+2*nBT+nBT+3*MaxBas**2+nBT+nnB
lthDii = max(2*nOO,lthgrd)
lthLiS = nOV+nBO+lthgrd

lthTot = lthCor+max(lthPMt,max(lthDii,lthLiS))+MxIter*NodSiz*5
!mgs   this has to be fixed once in a more reasonable way...
!MemRsv = lthTot
MemRsv = 0
!mgs
call mma_maxDBLE(MxMem)
lthTot = lthTot+5*nOV
lthRst = MxMem-lthTot
nDens = min(lthRst/(nBT*nD)/2,6)
! We need at least 2 Dens in core at the same time for computing
! the DIIS error vectors
if (nDens < 2) then
  write(u6,*) 'MemAlo: nDens < 2'
  write(u6,*) 'lthTot=',lthTot
  write(u6,*) 'nOV=',nOV
  write(u6,*) 'MxMem=',MxMem
  write(u6,*) 'nDens=',nDens
  write(u6,*) 'lthRst=',lthRst
  write(u6,*) 'nD=',nD
  write(u6,*) 'nBT=',nBT
  call Abend()
end if
! Francesco Aquilante
! for large basis sets reserve some extra memory for the
! auxiliary matrices in egrad.f (limit set to 400 bsf)
! We need at least 2 Dens in core... but the optimal performance
! happens when we can read and store in memory 5 densities
if (nBT >= 80200) nDens = min(nDens,6)

if (nDens > Mx_nIter+1) nDens = Mx_nIter+1
if (nDens < 2) nDens = 2

nMem = nDens-1

call mma_allocate(Dens,nBT,nD,nDens,Label='Dens  ')
Dens(:,:,:) = Zero
call mma_allocate(TwoHam,nBT,nD,nDens,Label='TwoHam')
TwoHam(:,:,:) = Zero
call mma_allocate(Vxc,nBT,nD,nDens,Label='Vxc')
Vxc(:,:,:) = Zero
call mma_allocate(EDFT,MxIter,Label='EDFT')
EDFT(:) = Zero

! Allocate memory for diagonal Hessian with respect to the elements
! of the anti-symmetric matrix kappa which represents the
! rotations. Note that in the aufbau section that the size of this
! matrix is not firmly know - the number of occupied orbitals in
! each irrep is not known. For the unrestricted option the number
! of alpha and beta orbitals may vary. Here we are generous and
! allocate memory with a size that fits all.

!lthH = 0
!do iSym=1,nSym
!  nB = nBas(iSym)
!  mB = nB/2
!  lthH = lthH+(nB-mB)*mB
!end do
if (Aufb) then
  lthH = nBB*nD
else
  lthH = mOV
end if
call mma_allocate(HDiag,lthH,Label='HDiag')

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine MemAlo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C calculate dd, ss and tt space
      subroutine dd_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)
      DATA VSQ2/0.7071067811865950D0/
      w0gdd=vsq2
!      w1gdd=-sq3vsq2
      w1gdd=-sqrt(3.d0)/sqrt(2.d0)
      idisk_lp=idisk_array(3)

      DO lpblock=1,lpblock_dd
        call read_lp()
        IpaeL=iml+1
        Ipae =imr+1
        int_dd_drl=int_dd_offset(iml,imr)
        call logicg_dd(iml,imr)
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
C        JMLR=MUL_TAB(JML,JMR)
        if(linelp.le.12)   then
          call dd_ext_head_in_act()
        else
          call dd_ext_head_in_dbl()
        endif
      enddo
      return
      end

      subroutine dd_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      LOGIC_DH=.TRUE.
      ISMA=MUL_TAB(IML,IMR)
      JMLR=MUL_TAB(JML,JMR)
      LPOK=JPADLR
      GOTO(101,102,103,104,105,106,10,108,10,10,111,112,
     :     113,10,115,10,10,10,119,120,121,122,123,124,125,10),LPOK
!====================================================================
!SD(6)    ACT: -B&L-
106   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      IF(JB_SYS.GT.0) THEN
        CALL SD_Ar_ACT_Bl_DD_EXT_SGT0(LRA)
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JMLR) CYCLE
        W0SD1=W0_SD(1)
        W0SD2=W0_SD(2)
        W0SD3=-W0_SD(3)
        W0SD4=-W0_SD(4)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1)W0SD1=-W0SD1
        IF(NI.EQ.1)W0SD2=-W0SD2
        IF(NI.EQ.1)W0SD3=-W0SD3
        IF(NI.EQ.1)W0SD4=-W0SD4
        IF(JML.EQ.1.AND.LMI.EQ.JMR) THEN
!SD(6-1) A&r(02)-
          IWDL=JUST(LRI,LRI)
          IWDR=JUD(LRI)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD1
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0SD1
          ENDDO
          CALL Ar_BL_DD_EXT(LRI,LRA,1)
        ENDIF
!SD(6-2) C(22)-A&r(13)-
        DO LRK=NORB_FRZ+1,LRI-1
          LMK=LSM_INN(LRK)
          LMKI=MUL_TAB(LMK,LMI)
          IF(LMKI.EQ.JML.AND.LMK.EQ.JMR) THEN
            IWDL=JUST(LRK,LRI)
            IWDR=JUD(LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
             ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD2
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0SD2
            ENDDO
            CALL Ar_BL_DD_EXT(LRI,LRA,1)
          ENDIF
        ENDDO
!SD(6-4) A&r(23)-C'(12)-
        DO LRK=LRI+1,NORB_DZ
          LMK=LSM_INN(LRK)
          LMKI=MUL_TAB(LMK,LMI)
          IF(LMKI.NE.JML.OR.LMK.NE.JMR) CYCLE
C..........................03_01.......................
!          IF(jroute_sys.GT.1) THEN
!SD(6-3) A&r(13)-C'(22)-
!            IWDL=JUST(LRK,LRI)
!            IWDR=JUD(LRK)
!            DO MPL=1,MHLP
!              IWAL=LPNEW_LWEI(MPL)
!              IWAR=LPNEW_RWEI(MPL)
!              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
!              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
!            ENDDO
!            DO MPL=1,MTYPE
!              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD3
!              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0SD3
!            ENDDO
!            CALL Ar_BL_DD_EXT(LRI,LRA,1)
!          ENDIF
C...........................03_01......................
          IWDL=JUST(LRI,LRK)
          IWDR=JUD(LRK)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD4
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0SD4
          ENDDO
          CALL Ar_BL_DD_EXT(LRI,LRA,1)
        ENDDO
      ENDDO
      GOTO 10
!====================================================================
!TD(13) ACT -B&L-
113   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JMLR) CYCLE
        W0TD1=W0_TD(1)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1)W0TD1=-W0TD1

        DO LRK=NORB_FRZ+1,LRI-1
          LMK=LSM_INN(LRK)
          IF(LMK.EQ.JMR) THEN
!TD(13-1) C(22)-A&r(23)-
            IWDL=JUST(LRK,LRI)    !
            IWDR=JUD(LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TD1
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0TD1
            ENDDO
          CALL Ar_BL_DD_EXT(LRI,LRA,1)
          ENDIF
        ENDDO
        DO LRK=LRI+1,NORB_DZ
          LMK=LSM_INN(LRK)
          IF(LMK.EQ.JMR) THEN
!TD(13-1) A&r(23)-C'(22)-
            IWDL=JUST(LRI,LRK)    !
            IWDR=JUD(LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0TD1
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W0TD1
            ENDDO
            CALL Ar_BL_DD_EXT(LRI,LRA,1)
          ENDIF
        ENDDO
      ENDDO
      GOTO 10
!=======================================================================
!DV(23) ACT -C'-..................................................
123   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JMLR) CYCLE
        W0DV1=W0_DV(1)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1)W0DV1=-W0DV1
!DV(23-1) A&r(23)-
        IWDL=JUD(LRI)
        IWDR=0
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DV1
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0DV1
        ENDDO
        CALL Ar_BL_DD_EXT(LRI,LRA,1)
      ENDDO
      GOTO 10
!=======================================================================
!SS(1)   ACT -C"-
!-------------------------------------------------------------------
!SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
!SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
!SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
!SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
!SS(1-16) (11)-Drl(22)-         ACT -C"-
!SS(1-18) Drl(11)-C"(22)-       ACT -C"-
!SS(1-19) Drl(12)-C"(21)-       ACT -C"-
!SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
!SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
!-------------------------------------------------------------------
!SS(1)   ACT 14: -C"-
101   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1011
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL SS2_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,1)
          CALL SS4_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,1)
          CALL SS5_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
          CALL SS10_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
          CALL SS14_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
!         IF(JROUTE_SYS.GT.1) THEN
!           CALL SS1_EXT(LRI,LRJ)
!           CALL Ar_BL_DD_EXT(LRI,LRJ,1)
!           CALL SS3_EXT(LRI,LRJ)
!           CALL Ar_BL_DD_EXT(LRI,LRJ,1)
!         ENDIF
        ENDDO
      ENDDO
      IF(JB_SYS.GT.0) THEN
        CALL SS_ArBr_ACT_C_DD_EXT_SGT0()
        CALL SS_S_Drl_ACT_C_DD_EXT_SGT0()
      ENDIF
      RETURN

1011  IF(JB_SYS.GT.0) THEN
      LRA=NLG1
      CALL SS_Drl_ACT_C_DD_EXT_SGT0()
      ENDIF
      W0SS15=W0_SS(15)
      W1SS15=W1_SS(15)
      W0SS17=W0_SS(17)
      W1SS17=W1_SS(17)
      W0SS20=W0_SS(20)
      IF(JML.EQ.1.AND.JMR.EQ.1) THEN
!SS(1-20) Drl(33)-C"(00)-       ACT -C"-
        DO LR0=NORB_FRZ+1,NORB_DZ
          IWDL=JUST(LR0,LR0)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL)=0.D0
          ENDDO
          DO LRK=1,NORB_DZ
            IF(LRK.EQ.LR0) CYCLE
            CALL Drl_DD_EXT(LRK)
          ENDDO
        ENDDO
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
          IWDL=JUST(LRI,LRJ)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
!SS(1-15) (22)-Drl(11)-         ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS15
          ENDDO
          CALL Drl_DD_EXT(LRJ)
!SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS17
          ENDDO
          CALL Drl_DD_EXT(LRI)
!SS(1-20) (22)(11)Drl(33)-      ACT -C"-
!SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
!SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL)=0.D0
          ENDDO
          DO LRK=1,NORB_DZ
            IF(LRK.EQ.LRI) CYCLE
            IF(LRK.EQ.LRJ) CYCLE
            CALL Drl_DD_EXT(LRK)
          ENDDO
        ENDDO
      ENDDO
      RETURN
!=======================================================================
!ST(2)   ACT -C"-
      IF(JB_SYS.GT.0) CALL ST_Drl_ACT_C_DD_EXT()
      IF(JB_SYS.GT.0) CALL ST_ArBl_ACT_C_DD_EXT_SGT0()

102   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      IF(JB_SYS.GT.0) CALL ST_Drl_ACT_C_DD_EXT_SGT0()
      IF(JB_SYS.GT.0) CALL ST_ArBl_ACT_C_DD_EXT_SGT0()
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL ST1_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,1)
          CALL ST2_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
          CALL ST4_EXT(LRI,LRJ,NK,1)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
          CALL ST4_EXT(LRI,LRJ,NK,-1)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
        ENDDO
      ENDDO

      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!ST(2-5) (22)Drl(12)-          ACT -C"-
            IWDL=JUST(LRI,LRJ)
            IWDR=JUST(LRI,LRJ)      !
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(5)
            ENDDO
            CALL Drl_DD_EXT(LRJ)
!ST(2-6) Drl(22)-C"(12)-       ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(6)
            ENDDO
            CALL Drl_DD_EXT(LRI)
!----------------------------------------------------------
!ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
!ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
!ST(2-7) Drl(12)-C"(22)-         ACT -C"-
!----------------------------------------------------------
          ENDDO
        ENDDO
      GOTO 10
!=======================================================================
!TS(3) D&R^L-  ACT -C"-
103   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      IF(JB_SYS.GT.0) THEN
        CALL TS_ArBl_ACT_C_DD_EXE_SGT0()
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL TS1_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,1)
          CALL TS2_EXT(LRI,LRJ,NK,1)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
          CALL TS2_EXT(LRI,LRJ,NK,-1)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
          CALL TS4_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
        ENDDO
      ENDDO
      GOTO 10
!=======================================================================
!STT(4) ArBl-  ACT -C"-
104   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      LRA=NLG1
      CALL STT_ArBl_ACT_C_DD_EXT_SGT1()
      RETURN
!=======================================================================
!TTS(3) ArBl-  ACT -C"-
105   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      CALL TTS_ArBl_ACT_C_DD_EXT_SGT1()
      CALL TTS_Drl_ACT_C_DD_EXT_SGT1()
      RETURN
!=======================================================================
!SDD(8) Ar- ACT -Bl-
108   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL SDD_Ar_ACT_Bl_DD_EXT_SGT0(LRA)
      RETURN
!=======================================================================
!TT(11-1) (22)Ar(23)-Bl(32)-      IGF=1   ACT -C"-
!TT(11-1) Ar(23)-Bl(32)-C"(22)-  IGF=1    ACT -C"-
!TT(11-1) Ar(23)-C'(22)-Bl(32)-  IGF=-1    ACT -C"-
111   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1111
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          CALL Ar_BL_DD_EXT(LRI,LRJ,NK)
        ENDDO
      ENDDO
      RETURN

1111  W0TT2=W0_TT(2)
      W1TT2=W1_TT(2)
      W0TT3=W0_TT(3)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!TT(11-2) (22)Drl(22)-
!TT(11-2) Drl(22)-C"(22)-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT2
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TT2
            ENDDO
            IWDL=JUST(LRI,LRJ)   !
            IWDR=IWDL
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Drl_DD_EXT(LRI)
            CALL Drl_DD_EXT(LRJ)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT3
              VPLP_W1(MPL)=0.D0
            ENDDO
            DO LRK=1,NORB_DZ
              IF(LRK.EQ.LRI) CYCLE
              IF(LRK.EQ.LRJ) CYCLE
              LMK=LSM_INN(LRK)
              LMKI=MUL_TAB(LMK,LMI)
              LMKJ=MUL_TAB(LMK,LMJ)
!TT(11-3) Drl(33)-C"(22)-C"(22)-
!TT(11-3) (22)Drl(33)-C"(22)-
!TT(11-3) (22)(22)Drl(33)-
              CALL Drl_DD_EXT(LRK)
            ENDDO
          ENDDO
        ENDDO
      RETURN
!=======================================================================
!TTTT(12) Drl- ArBl-  ACT -C"-
112   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL TTTT_Drl_ACT_C_DD_EXT_SGT1()
      ELSE
        CALL TTTT_ArBl_ACT_C_DD_EXT_SGT1()
      ENDIF
!=======================================================================
!T1D1(15) Ar- ACT -Bl-
115   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL TTDD_Ar_ACT_Bl_DD_EXT_SGT1(LRA)
      RETURN
!=======================================================================
!DD(19) ACT -C"- ....................................................
119   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1191
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JMLR) CYCLE
          W0DD1=W0_DD(1)
          W1DD1=W1_DD(1)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W0DD1=-W0DD1
            W1DD1=-W1DD1
          ENDIF
          IF(LMI.EQ.JML.AND.LMJ.EQ.JMR) THEN
!DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD1
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD1
            ENDDO
            IWDL=JUD(LRI)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_BL_DD_EXT(LRI,LRJ,1)
          ENDIF
        ENDDO
      ENDDO
      RETURN

1191  W0DD2=W0_DD(2)
      W1DD2=W1_DD(2)
      W0DD3=W0_DD(3)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JML) CYCLE
!DD(19-2) Drl(22)-
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD2
        ENDDO
        IWDL=JUD(LRI)
        IWDR=IWDL
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        CALL Drl_DD_EXT(LRI)
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD3
          VPLP_W1(MPL)=0.D0
        ENDDO
!DD(19-3) (22)Drl(33)-
!DD(19-3) Drl(33)-C"(22)-
        DO LRK=1,NORB_DZ
          IF(LRK.EQ.LRI) CYCLE
          LMK=LSM_INN(LRK)
          LMKI=MUL_TAB(LMK,LMI)
          CALL Drl_DD_EXT(LRK)
        ENDDO
      ENDDO
      GOTO 10
!=======================================================================
!DDDD(19) ACT -C"- ....................................................
120   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL DDDD_Drl_ACT_C_DD_EXT_SGT0()
      ELSE
        CALL DDDD_ArBl_ACT_C_DD_EXT_SGT0()
      ENDIF
      RETURN
!=======================================================================
!DD1(19) ACT -C"- ....................................................
121   IF(LINELP.NE.14.OR.NLG2.NE.2) RETURN
      CALL DD1_ArBl_ACT_C_DD_EXT_SGT0()
      RETURN
!=======================================================================
!D1D(19) ACT -C"- ....................................................
122   IF(LINELP.NE.14) RETURN
!      IF(NLG2.EQ.1) THEN
        CALL D1D_Drl_ACT_C_DD_EXT_SGT0()
!     ELSE
        CALL D1D_ArBl_ACT_C_DD_EXT_SGT0()
!     ENDIF
      RETURN
!=======================================================================
!D1V(24) Ar- ACT -Bl-..................................................
124   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL D1V_Ar_ACT_Bl_DD_EXT_SGT0(LRA)
      RETURN
!=======================================================================
!VV(25) ACT -BL- ....................................................
125   IF(LINELP.NE.14.OR.NLG2.NE.1) RETURN
      W0VV=W0_VV
!VV(25) Drl(33)-
      IWDL=0
      IWDR=0
      DO MPL=1,MTYPE
        VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_VV
        VPLP_W1(MPL)=0.D0
      ENDDO
      DO MPL=1,MHLP
        IWAL=LPNEW_LWEI(MPL)
        IWAR=LPNEW_RWEI(MPL)
        LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      ENDDO
      DO LRK=1,NORB_DZ
        CALL Drl_DD_EXT(LRK)
      ENDDO
      GOTO 10
C=======================================================================
10    return
      end

      subroutine DD_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      LOGIC_DH=.FALSE.
      LRAI=NLG1
      LRAJ=NLG2
      INTPOS=NLG1
      ISMA=MUL_TAB(IML,IMR)
!line=5 A&r-B&l<-->EXT
!5    CONTINUE
      IF(LINELP.EQ.5) THEN
        CALL Ar_BL_DD_EXT(lrai,lraj,1)
      ENDIF
!line=9 D&rl<-->EXT
!9    CONTINUE
      IF(LINELP.EQ.9) THEN
        call Drl_DD_EXT(lrai)
      endif
      return
      end

      subroutine ss_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)

      call external_space_plpmode_value_ss()
      idisk_lp=idisk_array(13)

      DO lpblock=1,lpblock_ss
        call read_lp()
        IpaeL=iml+17
        Ipae =imr+17
        imlr=mul_tab(iml,imr)
        nvalue_space_ss=iseg_downwei(9+imlr)
        idownwei_g131415=iseg_downwei(17+iml)
C        if(imlr.eq.1)imspace=iml
        call logicg_st(iml,imr,4,4)      ! irtype=4(S),lptype=5:ArBl-
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
C        JMLR=MUL_TAB(JML,JMR)
        if(linelp.le.12)   then
          call ss_ext_head_in_act()
        else
          call ss_ext_head_in_dbl()
        endif
      enddo
      return
      end

      subroutine ss_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      LOGIC_DH=.TRUE.
      ISMA=MUL_TAB(IML,IMR)
      JMLR=MUL_TAB(JML,JMR)
      LPOK=JPADLR
      GOTO(101,102,10,104,105,106,10,108,10,10,111,112,
     :     113,10,115,10,10,10,119,120,121,122,123,124,125,10),LPOK
!=======================================================================
!SD(6-1) ACT -B&L-
106   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL SD_AR_ACT_BL(1,LRA)
      IF(JB_SYS.GT.0) CALL SD_AR_ACT_BL_SGT0(1,LRA)
      GOTO 10
!=======================================================================
!TD(13) ACT -BL-
113   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL TD_AR_ACT_BL(1,LRA)
      RETURN
!=======================================================================
!DV(23) ACT -C'-..................................................
123   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JMLR) CYCLE
        W0DV1=W0_DV(1)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1)W0DV1=-W0DV1
!DV(23-1) A&r(23)-
        IWDL=JUD(LRI)
        IWDR=0
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DV1
        ENDDO
        CALL Ar_BL_EXT_SS(LRI,LRA,1)
      ENDDO
      GOTO 10
!=======================================================================
!SS(1)   ACT -C"-
!-------------------------------------------------------------------
!SS(1-1)  Ar(01)-Bl(32)-        ACT -C"-
!SS(1-3)  Ar(13)-Bl(20)-        ACT -C"-
!SS(1-6)  (11)-Ar(23)-Bl(32)-   ACT -C"-
!SS(1-7)  Ar(13)-C'(21)-Bl(32)- ACT -C"-
!SS(1-8)  Ar(13)-C'(22)-Bl(31)- ACT -C"-
!SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
!SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
!SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
!SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
!SS(1-16) (11)-Drl(22)-         ACT -C"-
!SS(1-18) Drl(11)-C"(22)-       ACT -C"-
!SS(1-19) Drl(12)-C"(21)-       ACT -C"-
!SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
!SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
!-------------------------------------------------------------------
!SS(1)   ACT 14: -C"-
101   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1011
      IF(JB_SYS.GT.0) THEN
       CALL SS_ArBl_ACT_C_EXT_AB_SGT0(1)
       CALL SS_S_Drl_ACT_C_EXT_AB_SGT0(1)
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL SS2_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_SS(LRI,LRJ,1)
          CALL SS4_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_SS(LRI,LRJ,1)
          CALL SS5_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_SS(LRI,LRJ,NK)
          CALL SS10_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_SS(LRI,LRJ,NK)
          CALL SS14_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_SS(LRI,LRJ,NK)
        ENDDO
      ENDDO
      RETURN

1011  IF(JB_SYS.GT.0) CALL SS_Drl_ACT_C_EXT_AB_SGT0(1)
      W0SS15=W0_SS(15)
      W1SS15=W1_SS(15)
      W0SS17=W0_SS(17)
      W1SS17=W1_SS(17)
      W0SS20=W0_SS(20)
      IF(JML.EQ.1.AND.JMR.EQ.1) THEN
!SS(1-20) Drl(33)-C"(00)-       ACT -C"-                     ! IPL(R)AD=
        DO LR0=NORB_FRZ+1,NORB_DZ
          IWDL=JUST(LR0,LR0)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL)=0.D0
          ENDDO
          CALL Drl_SS_SUM(LR0,0)
        ENDDO
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
          IWDL=JUST(LRI,LRJ)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
!SS(1-15) (22)-Drl(11)-         ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS15
          ENDDO
          CALL Drl_SS_EXT(LRJ)
!SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS17
          ENDDO
          CALL Drl_SS_EXT(LRI)
!SS(1-20) (22)(11)Drl(33)-      ACT -C"-
!SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
!SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL)=0.D0
          ENDDO
          CALL Drl_SS_SUM(LRI,LRJ)
        ENDDO
      ENDDO
      RETURN
!ST(2)   ACT -C"-
102   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      IF(JB_SYS.GT.0) CALL ST_Drl_ACT_C_EXT_AB_SGT0(1)
      IF(JB_SYS.GT.0) CALL ST_ArBl_ACT_C_EXT_AB_SGT0(1)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!ST(2-5) (22)Drl(12)-          ACT -C"-
            IWDL=JUST(LRI,LRJ)
            IWDR=IWDL             !
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(5)
            ENDDO
            CALL Drl_SS_EXT(LRJ)
!ST(2-6) Drl(22)-C"(12)-       ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(6)
            ENDDO
            CALL Drl_SS_EXT(LRI)
!----------------------------------------------------------
!ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
!ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
!ST(2-7) Drl(12)-C"(22)-         ACT -C"-
!----------------------------------------------------------
          ENDDO
        ENDDO
      GOTO 10
!=======================================================================
!TS(3)   ACT -C"-  no used
!======================================================
!ST1(4) Ar-Bl- Drl- ACT -C"-
104   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
        CALL STT_ArBl_ACT_C_EXT_AB_SGT1(1)
      RETURN
!=======================================================
!T1S(5) Ar-Bl- Drl ACT -C"-
105   IF(LINELP.NE.14.OR.NLG2.NE.2) RETURN
        CALL TTS_Drl_ACT_C_EXT_AB_SGT1(1)
        CALL TTS_ArBl_ACT_C_EXT_AB_SGT1(1)
      RETURN
!===========================================================
!SD1(8) Ar ACT -Bl-
108   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      IF(JB_SYS.GT.0) CALL SDD_AR_ACT_BL_SGT0(1,LRA)
      RETURN
!===========================================================
!TTTT(12) Ar-Bl- Drl- ACT -C"-
112   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL TTTT_Drl_ACT_C_EXT_AB_SGT0(1)
      ELSE
        CALL TTTT_ArBl_ACT_C_EXT_AB_SGT0(1)
      ENDIF
      RETURN
!=============================================================
!T1D1(15) Ar- ACT -Bl-
115   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL TTDD_AR_ACT_BL_SGT1(1,LRA)
      RETURN
!============================================================
!D1D1(20) Drl- Ar-Bl- ACT -C"-
120   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL D1D1_Drl_ACT_C_EXT_AB_SGT0(1)
      ELSE
        CALL D1D1_ArBl_ACT_C_EXT_AB_SGT0(1)
      ENDIF
      RETURN
!=================================================================
!DD1(21) Ar-Bl- ACT -C"-
121   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
      CALL DD1_ArBl_ACT_C_EXT_AB_SGT0(1)
      RETURN
!=================================================================
!D1D(22) Ar-Bl- Drl- ACT -C"-
122   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
      CALL D1D_ArBl_ACT_C_EXT_AB_SGT0(1)
      CALL D1D_Drl_ACT_C_EXT_AB_SGT0(1)
      RETURN
!=================================================================
!D1V(24) Ar- ACT -Bl-
124   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL D1V_Ar_ACT_Bl_EXT_AB_SGT0(1,LRA)
      RETURN
!=======================================================================
!TT(11) AR-BL   ACT -C"-
111   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1111
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          IF(NK.NE.0) CALL AR_BL_EXT_SS(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          IF(NK.NE.0) CALL AR_BL_EXT_SS(LRI,LRJ,NK)
        ENDDO
      ENDDO
      RETURN

1111  W0TT2=W0_TT(2)
      W1TT2=W1_TT(2)
      W0TT3=W0_TT(3)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!TT(11-2) (22)Drl(22)-
!TT(11-2) Drl(22)-C"(22)-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT2
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TT2
            ENDDO
            IWDL=JUST(LRI,LRJ)   !
            IWDR=IWDL
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Drl_SS_EXT(LRI)
            CALL Drl_SS_EXT(LRJ)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT3
              VPLP_W1(MPL)=0.D0
            ENDDO
!TT(11-3) Drl(33)-C"(22)-C"(22)-
!TT(11-3) (22)Drl(33)-C"(22)-
!TT(11-3) (22)(22)Drl(33)-
            CALL Drl_SS_SUM(LRI,LRJ)
          ENDDO
        ENDDO
      RETURN
!=======================================================================
!DD(19) ACT -C"- ....................................................
119   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1191
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JMLR) CYCLE
          W0DD1=W0_DD(1)
          W1DD1=W1_DD(1)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W0DD1=-W0DD1
            W1DD1=-W1DD1
          ENDIF
          IF(LMI.EQ.JML.AND.LMJ.EQ.JMR) THEN
!DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD1
            ENDDO
            IWDL=JUD(LRI)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_BL_EXT_SS(LRI,LRJ,1)
          ENDIF
        ENDDO
      ENDDO
      RETURN

1191  W0DD2=W0_DD(2)
      W1DD2=W1_DD(2)
      W0DD3=W0_DD(3)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JML) CYCLE
!DD(19-2) Drl(22)-
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD2
        ENDDO
        IWDL=JUD(LRI)
        IWDR=IWDL
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        CALL Drl_SS_EXT(LRI)
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD3
          VPLP_W1(MPL)=0.D0
        ENDDO
!DD(19-3) (22)Drl(33)-
!DD(19-3) Drl(33)-C"(22)-
        CALL Drl_SS_SUM(LRI,0)
      ENDDO
      GOTO 10
!=======================================================================
!VV(25) ACT -C"- .false.
125   IF(LINELP.NE.14.OR.NLG2.NE.1) RETURN
      W0VV=W0_VV
!VV(25) Drl(33)-
      IWDL=0
      IWDR=0
      DO MPL=1,MTYPE
        VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_VV
        VPLP_W1(MPL)=0.D0
      ENDDO
      DO MPL=1,MHLP
        IWAL=LPNEW_LWEI(MPL)
        IWAR=LPNEW_RWEI(MPL)
        LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      ENDDO
        CALL Drl_SS_SUM(0,0)
C      do lrk=1,norb_dz
C        CALL Drl_ss_ext(lrk)
C     enddo
      GOTO 10
C=======================================================================
10    return
      end

      subroutine ss_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      LOGIC_DH=.FALSE.
      LRAI=NLG1
      LRAJ=NLG2
      INTPOS=NLG1
      ISMA=MUL_TAB(IML,IMR)
!line=5 A&r-B&l<-->EXT
!5    CONTINUE
      IF(LINELP.EQ.5) THEN
        CALL Ar_BL_EXT_SS(lrai,lraj,1)
      ENDIF
!line=9 D&rl<-->EXT
!9    CONTINUE
      IF(LINELP.EQ.9) THEN
        call Drl_SS_EXT(lrai)
      endif
      return
      end

      subroutine st_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)

      call external_space_plpmode_value_ST()
      idisk_lp=idisk_array(12)

      DO lpblock=1,lpblock_st
        call read_lp()
        IpaeL=iml+17
        Ipae =imr+9
        imlr=mul_tab(iml,imr)
        idownwei_g131415=iseg_downwei(9+iml)    !(17+iml)???
        nvalue_space_ss=iseg_downwei(9+imlr)
        call logicg_st(iml,imr,4,3)             ! irtype=4(S),3(T)
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
C        JMLR=MUL_TAB(JML,JMR)
        if(linelp.le.12)   then
          call st_ext_head_in_act()
        else
          call st_ext_head_in_dbl()
        endif
      enddo
      return
      end

      subroutine st_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      LOGIC_DH=.TRUE.
      ISMA=MUL_TAB(IML,IMR)
      JMLR=MUL_TAB(JML,JMR)
      LPOK=JPADLR
!      GOTO(101,102,103,10,10,106,10,10,10,10,111,10,
!     :     113,10,10,10,10,10,119,10,10,10,123,10,125,10),LPOK
      GOTO(101,102,103,104,105,106,10,108,10,10,111,112,
     :     113,10,115,10,10,10,119,120,121,122,123,124,125,10),LPOK
!=======================================================================
!SD(6-1) ACT -B&L-
106   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL SD_AR_ACT_BL(2,LRA)
      IF(JB_SYS.GT.0) CALL SD_AR_ACT_BL_SGT0(2,LRA)
      GOTO 10
!=======================================================================
!TD(13) ACT -BL-
113   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL TD_AR_ACT_BL(2,LRA)
      RETURN
!=======================================================================
!DV(23) ACT -C'-..................................................
123   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JMLR) CYCLE
        W0DV1=W0_DV(1)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1)W0DV1=-W0DV1
!DV(23-1) A&r(23)-
        IWDL=JUD(LRI)
        IWDR=0
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        DO MPL=1,MTYPE
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0DV1
        ENDDO
        CALL Ar_BL_EXT_ST(LRI,LRA,1)
      ENDDO
      GOTO 10
!=======================================================================
!SS(1)   ACT -C"-
!-------------------------------------------------------------------
!SS(1-1)  Ar(01)-Bl(32)-        ACT -C"-
!SS(1-3)  Ar(13)-Bl(20)-        ACT -C"-
!SS(1-6)  (11)-Ar(23)-Bl(32)-   ACT -C"-
!SS(1-7)  Ar(13)-C'(21)-Bl(32)- ACT -C"-
!SS(1-8)  Ar(13)-C'(22)-Bl(31)- ACT -C"-
!SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
!SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
!SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
!SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
!SS(1-16) (11)-Drl(22)-         ACT -C"-
!SS(1-18) Drl(11)-C"(22)-       ACT -C"-
!SS(1-19) Drl(12)-C"(21)-       ACT -C"-
!SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
!SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
!-------------------------------------------------------------------
!SS(1)   ACT 14: -C"-
101   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1011
      LRA=NLG1
      IF(JB_SYS.GT.0) THEN
       CALL SS_ArBl_ACT_C_EXT_AB_SGT0(2)
       CALL SS_S_Drl_ACT_C_EXT_AB_SGT0(2)
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL SS2_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,1)
          CALL SS4_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,1)
          CALL SS5_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,NK)
          CALL SS10_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,NK)
          CALL SS14_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,NK)
        ENDDO
      ENDDO
      RETURN

1011  IF(JB_SYS.GT.0) CALL SS_Drl_ACT_C_EXT_AB_SGT0(2)
      W0SS15=W0_SS(15)
      W1SS15=W1_SS(15)
      W0SS17=W0_SS(17)
      W1SS17=W1_SS(17)
      W0SS20=W0_SS(20)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
          IWDL=JUST(LRI,LRJ)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
!SS(1-15) (22)-Drl(11)-         ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS15
          ENDDO
          CALL Drl_ST_EXT(LRJ)
!SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS17
          ENDDO
          CALL Drl_ST_EXT(LRI)
!SS(1-20) (22)(11)Drl(33)-      ACT -C"-
!SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
!SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL)=0.D0
          ENDDO
         DO LRK=1,NORB_DZ
            IF(LRK.EQ.LRI) CYCLE
            IF(LRK.EQ.LRJ) CYCLE
            CALL Drl_ST_EXT(LRK)
          ENDDO
        ENDDO
      ENDDO
      RETURN
!ST(2)   ACT -C"-
102   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      IF(JB_SYS.GT.0) CALL ST_Drl_ACT_C_EXT_AB_SGT0(2)
      IF(JB_SYS.GT.0) CALL ST_ArBl_ACT_C_EXT_AB_SGT0(2)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL ST1_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,1)
          CALL ST2_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,NK)
          CALL ST4_EXT(LRI,LRJ,NK,1)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,NK)
          CALL ST4_EXT(LRI,LRJ,NK,-1)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,NK)
        ENDDO
      ENDDO

      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!ST(2-5) (22)Drl(12)-          ACT -C"-
            IWDL=JUST(LRI,LRJ)
            IWDR=IWDL                !
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(5)
            ENDDO
            CALL Drl_ST_EXT(LRJ)
!ST(2-6) Drl(22)-C"(12)-       ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(6)
            ENDDO
            CALL Drl_ST_EXT(LRI)
!----------------------------------------------------------
!ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
!ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
!ST(2-7) Drl(12)-C"(22)-         ACT -C"-
!----------------------------------------------------------
          ENDDO
        ENDDO
      GOTO 10
!=======================================================================
!TS(3) A&R-B^L-  ACT -C"-
103   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      IF(JB_SYS.GT.0) THEN
        CALL TS_ArBl_ACT_C_EXT_AB_SGT0(2)
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL TS1_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,1)
          CALL TS2_EXT(LRI,LRJ,NK,1)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,NK)
          CALL TS2_EXT(LRI,LRJ,NK,-1)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,NK)
          CALL TS4_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_ST(LRI,LRJ,NK)
        ENDDO
      ENDDO
      GOTO 10
!=======================================================================
!TT(11) Drl-  ACT -C"-
111   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1111
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          CALL AR_BL_EXT_TS(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          CALL AR_BL_EXT_ST(LRI,LRJ,NK)
        ENDDO
      ENDDO
      RETURN

1111  W0TT2=W0_TT(2)
      W1TT2=W1_TT(2)
      W0TT3=W0_TT(3)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!TT(11-2) (22)Drl(22)-
!TT(11-2) Drl(22)-C"(22)-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT2
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TT2
            ENDDO
            IWDL=JUST(LRI,LRJ)     !
            IWDR=IWDL
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Drl_ST_EXT(LRI)
            CALL Drl_ST_EXT(LRJ)
          ENDDO
        ENDDO
      RETURN
!=======================================================================
!DD(19) ACT -C"- ....................................................
119   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1191
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JMLR) CYCLE
          W0DD1=W0_DD(1)
          W1DD1=W1_DD(1)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W0DD1=-W0DD1
            W1DD1=-W1DD1
          ENDIF
          IF(LMI.EQ.JML.AND.LMJ.EQ.JMR) THEN
!DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD1
            ENDDO
            IWDL=JUD(LRI)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_BL_EXT_ST(LRI,LRJ,1)
          ENDIF
        ENDDO
      ENDDO
      RETURN

1191  W0DD2=W0_DD(2)
      W1DD2=W1_DD(2)
      W0DD3=W0_DD(3)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JML) CYCLE
!DD(19-2) Drl(22)-
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD2
        ENDDO
        IWDL=JUD(LRI)
        IWDR=IWDL
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        CALL Drl_ST_EXT(LRI)
      ENDDO
      GOTO 10
!======================================================
!ST1(4) Ar-Bl- Drl- ACT -C"-
104   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
        CALL STT_ArBl_ACT_C_EXT_AB_SGT1(2)
      RETURN
!=======================================================
!T1S(5) Ar-Bl- Drl ACT -C"-
105   IF(LINELP.NE.14.OR.NLG2.NE.2) RETURN
        CALL TTS_Drl_ACT_C_EXT_AB_SGT1(2)
        CALL TTS_ArBl_ACT_C_EXT_AB_SGT1(2)
      RETURN
!===========================================================
!SD1(8) Ar ACT -Bl-
108   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      IF(JB_SYS.GT.0) CALL SDD_AR_ACT_BL_SGT0(2,LRA)
      RETURN
!===========================================================
!TTTT(12) Ar-Bl- Drl- ACT -C"-
112   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL TTTT_Drl_ACT_C_EXT_AB_SGT0(2)
      ELSE
        CALL TTTT_ArBl_ACT_C_EXT_AB_SGT0(2)
      ENDIF
      RETURN
!=============================================================
!T1D1(15) Ar- ACT -Bl-
115   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL TTDD_AR_ACT_BL_SGT1(2,LRA)
      RETURN
!============================================================
!D1D1(20) Drl- Ar-Bl- ACT -C"-
120   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL D1D1_Drl_ACT_C_EXT_AB_SGT0(2)
      ELSE
        CALL D1D1_ArBl_ACT_C_EXT_AB_SGT0(2)
      ENDIF
      RETURN
!=================================================================
!DD1(21) Ar-Bl- ACT -C"-
121   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
      CALL DD1_ArBl_ACT_C_EXT_AB_SGT0(2)
      RETURN
!=================================================================
!D1D(22) Ar-Bl- Drl- ACT -C"-
122   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
      CALL D1D_ArBl_ACT_C_EXT_AB_SGT0(2)
      CALL D1D_Drl_ACT_C_EXT_AB_SGT0(2)
      RETURN
!=================================================================
!D1V(24) Ar- ACT -Bl-
124   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL D1V_Ar_ACT_Bl_EXT_AB_SGT0(2,LRA)
      RETURN
!=======================================================================
!VV(25) ACT -BL- ....................................................
125   RETURN
C=======================================================================
10    return
      end

      subroutine ST_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      LOGIC_DH=.FALSE.
      LRAI=NLG1
      LRAJ=NLG2
      INTPOS=NLG1
      ISMA=MUL_TAB(IML,IMR)
!line=5 A&r-B&l<-->EXT
!5    CONTINUE
      IF(LINELP.EQ.5) THEN
        CALL Ar_BL_EXT_ST(lrai,lraj,1)
      ENDIF
!line=9 D&rl<-->EXT
!9    CONTINUE
      IF(LINELP.EQ.9) THEN
        call Drl_ST_EXT(lrai)
      endif
      return
      end

      subroutine ts_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)

      call external_space_plpmode_value_TS()
      idisk_lp=idisk_array(9)
      DO lpblock=1,lpblock_ts
        call read_lp()
        IpaeL=iml+9
        Ipae =imr+17
        imlr=mul_tab(iml,imr)
        idownwei_g131415=iseg_downwei(9+iml)    !(17+iml)???
        nvalue_space_ss=iseg_downwei(9+imlr)
        call logicg_st(iml,imr,3,4)             ! irtype=4(S),3(T)
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
C        JMLR=MUL_TAB(JML,JMR)
        if(linelp.le.12)   then
          call ts_ext_head_in_act()
        else
          call ts_ext_head_in_dbl()
        endif
      enddo
      return
      end

      subroutine ts_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      LOGIC_DH=.TRUE.
      ISMA=MUL_TAB(IML,IMR)
      JMLR=MUL_TAB(JML,JMR)
      LPOK=JPADLR
      GOTO(101,102,103,104,105,106,10,108,10,10,111,112,
     :     113,10,115,10,10,10,119,120,121,122,123,124,125,10),LPOK
!=======================================================================
!SD(6-1) ACT -B&L-
106   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL SD_AR_ACT_BL(3,LRA)
      IF(JB_SYS.GT.0) CALL SD_AR_ACT_BL_SGT0(3,LRA)
      GOTO 10
!=======================================================================
!TD(13) ACT -BL-
113   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL TD_AR_ACT_BL(3,LRA)
      RETURN
!=======================================================================
!DV(23) ACT -C'-..................................................
123   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JMLR) CYCLE
        W0DV1=W0_DV(1)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1)W0DV1=-W0DV1
!DV(23-1) A&r(23)-
        IWDL=JUD(LRI)
        IWDR=0
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        DO MPL=1,MTYPE
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0DV1
        ENDDO
        CALL Ar_BL_EXT_TS(LRI,LRA,1)
      ENDDO
      GOTO 10
!=======================================================================
!SS(1)   ACT -C"-
!-------------------------------------------------------------------
!SS(1-1)  Ar(01)-Bl(32)-        ACT -C"-
!SS(1-3)  Ar(13)-Bl(20)-        ACT -C"-
!SS(1-6)  (11)-Ar(23)-Bl(32)-   ACT -C"-
!SS(1-7)  Ar(13)-C'(21)-Bl(32)- ACT -C"-
!SS(1-8)  Ar(13)-C'(22)-Bl(31)- ACT -C"-
!SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
!SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
!SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
!SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
!SS(1-16) (11)-Drl(22)-         ACT -C"-
!SS(1-18) Drl(11)-C"(22)-       ACT -C"-
!SS(1-19) Drl(12)-C"(21)-       ACT -C"-
!SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
!SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
!-------------------------------------------------------------------
!SS(1)   ACT 14: -C"-
101   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1011
      IF(JB_SYS.GT.0) THEN
       CALL SS_ArBl_ACT_C_EXT_AB_SGT0(3)
       CALL SS_S_Drl_ACT_C_EXT_AB_SGT0(3)
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL SS2_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL AR_BL_EXT_TS(LRI,LRJ,1)
          CALL SS4_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL AR_BL_EXT_TS(LRI,LRJ,1)
          CALL SS5_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL AR_BL_EXT_TS(LRI,LRJ,NK)
          CALL SS10_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL AR_BL_EXT_TS(LRI,LRJ,NK)
          CALL SS14_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL AR_BL_EXT_TS(LRI,LRJ,NK)
        ENDDO
      ENDDO
      RETURN

1011  IF(JB_SYS.GT.0) CALL SS_Drl_ACT_C_EXT_AB_SGT0(3)
      W0SS15=W0_SS(15)
      W1SS15=W1_SS(15)
      W0SS17=W0_SS(17)
      W1SS17=W1_SS(17)
      W0SS20=W0_SS(20)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
          IWDL=JUST(LRI,LRJ)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
!SS(1-15) (22)-Drl(11)-         ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS15
          ENDDO
          CALL Drl_TS_EXT(LRJ)
!SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS17
          ENDDO
          CALL Drl_TS_EXT(LRI)
!SS(1-20) (22)(11)Drl(33)-      ACT -C"-
!SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
!SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL)=0.D0
          ENDDO
         DO LRK=1,NORB_DZ
            IF(LRK.EQ.LRI) CYCLE
            IF(LRK.EQ.LRJ) CYCLE
            CALL Drl_TS_EXT(LRK)
          ENDDO
        ENDDO
      ENDDO
      RETURN
!ST(2)   ACT -C"-
102   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      IF(JB_SYS.GT.0) CALL ST_Drl_ACT_C_EXT_AB_SGT0(3)
      IF(JB_SYS.GT.0) CALL ST_ArBl_ACT_C_EXT_AB_SGT0(3)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL ST1_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TS(LRI,LRJ,1)
          CALL ST2_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TS(LRI,LRJ,NK)
          CALL ST4_EXT(LRI,LRJ,NK,1)
          IF(NK.NE.0) CALL Ar_BL_EXT_TS(LRI,LRJ,NK)
          CALL ST4_EXT(LRI,LRJ,NK,-1)
          IF(NK.NE.0) CALL Ar_BL_EXT_TS(LRI,LRJ,NK)
        ENDDO
      ENDDO

      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!ST(2-5) (22)Drl(12)-          ACT -C"-
            IWDL=JUST(LRI,LRJ)
            IWDR=IWDL               !
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(5)
            ENDDO
            CALL Drl_TS_EXT(LRJ)
!ST(2-6) Drl(22)-C"(12)-       ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(6)
            ENDDO
            CALL Drl_TS_EXT(LRI)
!----------------------------------------------------------
!ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
!ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
!ST(2-7) Drl(12)-C"(22)-         ACT -C"-
!----------------------------------------------------------
          ENDDO
        ENDDO
      GOTO 10
!=======================================================================
!TS(3) D&R^L-  ACT -C"-
103   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      IF(JB_SYS.GT.0) THEN
        CALL TS_ArBl_ACT_C_EXT_AB_SGT0(3)
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL TS1_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TS(LRI,LRJ,1)
          CALL TS2_EXT(LRI,LRJ,NK,1)
          IF(NK.NE.0) CALL Ar_BL_EXT_TS(LRI,LRJ,NK)
          CALL TS2_EXT(LRI,LRJ,NK,-1)
          IF(NK.NE.0) CALL Ar_BL_EXT_TS(LRI,LRJ,NK)
          CALL TS4_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TS(LRI,LRJ,NK)
        ENDDO
      ENDDO
      GOTO 10
!======================================================
!ST1(4) Ar-Bl- Drl- ACT -C"-
104   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
        CALL STT_ArBl_ACT_C_EXT_AB_SGT1(3)
      RETURN
!=======================================================
!T1S(5) Ar-Bl- Drl ACT -C"-
105   IF(LINELP.NE.14.OR.NLG2.NE.2) RETURN
        CALL TTS_Drl_ACT_C_EXT_AB_SGT1(3)
        CALL TTS_ArBl_ACT_C_EXT_AB_SGT1(3)
      RETURN
!===========================================================
!SD1(8) Ar ACT -Bl-
108   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      IF(JB_SYS.GT.0) CALL SDD_AR_ACT_BL_SGT0(3,LRA)
      RETURN
!===========================================================
!TTTT(12) Ar-Bl- Drl- ACT -C"-
112   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL TTTT_Drl_ACT_C_EXT_AB_SGT0(3)
      ELSE
        CALL TTTT_ArBl_ACT_C_EXT_AB_SGT0(3)
      ENDIF
      RETURN
!=============================================================
!T1D1(15) Ar- ACT -Bl-
115   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL TTDD_AR_ACT_BL_SGT1(3,LRA)
      RETURN
!============================================================
!D1D1(20) Drl- Ar-Bl- ACT -C"-
120   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL D1D1_Drl_ACT_C_EXT_AB_SGT0(3)
      ELSE
        CALL D1D1_ArBl_ACT_C_EXT_AB_SGT0(3)
      ENDIF
      RETURN
!=================================================================
!DD1(21) Ar-Bl- ACT -C"-
121   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
      CALL DD1_ArBl_ACT_C_EXT_AB_SGT0(3)
      RETURN
!=================================================================
!D1D(22) Ar-Bl- Drl- ACT -C"-
122   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
      CALL D1D_ArBl_ACT_C_EXT_AB_SGT0(3)
      CALL D1D_Drl_ACT_C_EXT_AB_SGT0(3)
      RETURN
!=================================================================
!D1V(24) Ar- ACT -Bl-
124   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL D1V_Ar_ACT_Bl_EXT_AB_SGT0(3,LRA)
      RETURN
!=======================================================================
!TT(11) Drl-  ACT -C"-
111   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1111
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          CALL AR_BL_EXT_TS(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          CALL AR_BL_EXT_TS(LRI,LRJ,NK)
        ENDDO
      ENDDO
      RETURN

1111  W0TT2=W0_TT(2)
      W1TT2=W1_TT(2)
      W0TT3=W0_TT(3)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!TT(11-2) (22)Drl(22)-
!TT(11-2) Drl(22)-C"(22)-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT2
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TT2
            ENDDO
            IWDL=JUST(LRI,LRJ)
            IWDR=IWDL
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Drl_TS_EXT(LRI)
            CALL Drl_TS_EXT(LRJ)
          ENDDO
        ENDDO
      RETURN
!=======================================================================
!DD(19) ACT -C"- ....................................................
119   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1191
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JMLR) CYCLE
          W0DD1=W0_DD(1)
          W1DD1=W1_DD(1)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W0DD1=-W0DD1
            W1DD1=-W1DD1
          ENDIF
          IF(LMI.EQ.JML.AND.LMJ.EQ.JMR) THEN
!DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD1
            ENDDO
            IWDL=JUD(LRI)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL AR_BL_EXT_TS(LRI,LRJ,1)
          ENDIF
        ENDDO
      ENDDO
      RETURN

1191  W0DD2=W0_DD(2)
      W1DD2=W1_DD(2)
      W0DD3=W0_DD(3)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JML) CYCLE
!DD(19-2) Drl(22)-
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD2
        ENDDO
        IWDL=JUD(LRI)
        IWDR=IWDL
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        CALL Drl_TS_EXT(LRI)
      ENDDO
      GOTO 10
!=======================================================================
!VV(25) ACT -BL- ....................................................
125   GOTO 10
C=======================================================================
10    return
      end

      subroutine TS_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      LOGIC_DH=.FALSE.
      LRAI=NLG1
      LRAJ=NLG2
      INTPOS=NLG1
      ISMA=MUL_TAB(IML,IMR)
!line=5 A&r-B&l<-->EXT
!5    CONTINUE
      IF(LINELP.EQ.5) THEN
        CALL AR_BL_EXT_TS(lrai,lraj,1)
      ENDIF
!line=9 D&rl<-->EXT
!9    CONTINUE
      IF(LINELP.EQ.9) THEN
        call Drl_TS_EXT(lrai)
      endif
      return
      end


      subroutine tt_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)

      call external_space_plpmode_value_tt()
      idisk_lp=idisk_array(8)

      DO lpblock=1,lpblock_tt
        call read_lp()
        IpaeL=iml+9
        Ipae =imr+9
        call logicg_st(iml,imr,3,3)      ! irtype=3(T),lptype=5:ArBl-
        imlr=mul_tab(iml,imr)
C        if(imlr.eq.1)imspace=iml
        nvalue_space_ss=iseg_downwei(9+imlr)
        idownwei_g131415=iseg_downwei(9+iml)
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
C        JMLR=MUL_TAB(JML,JMR)
        if(linelp.le.12)   then
          call tt_ext_head_in_act()
        else
          call tt_ext_head_in_dbl()
        endif
      enddo
      return
      end

      subroutine tt_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      LOGIC_DH=.TRUE.
      ISMA=MUL_TAB(IML,IMR)
      JMLR=MUL_TAB(JML,JMR)
      LPOK=JPADLR
      GOTO(101,102,103,104,105,106,10,108,10,10,111,112,
     :     113,10,115,10,10,10,119,120,121,122,123,124,125,10),LPOK
!=======================================================================
!SD(6-1) ACT -B&L-
106   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL SD_AR_ACT_BL(11,LRA)
      IF(JB_SYS.GT.0) CALL SD_AR_ACT_BL_SGT0(11,LRA)
      GOTO 10
!====================================================================
!TD(13) ACT -B&L-
113   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL TD_AR_ACT_BL(11,LRA)
      GOTO 10
!=======================================================================
!DV(23) ACT -C'-..................................................
123   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JMLR) CYCLE
        W0DV1=W0_DV(1)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1)W0DV1=-W0DV1
!DV(23-1) A&r(23)-
        IWDL=JUD(LRI)
        IWDR=0
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DV1
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0DV1
        ENDDO
        CALL Ar_BL_EXT_TT(LRI,LRA,1)
      ENDDO
      GOTO 10
!=======================================================================
!SS(1)   ACT -C"-
!-------------------------------------------------------------------
!SS(1-1)  Ar(01)-Bl(32)-        ACT -C"-
!SS(1-3)  Ar(13)-Bl(20)-        ACT -C"-
!SS(1-6)  (11)-Ar(23)-Bl(32)-   ACT -C"-
!SS(1-7)  Ar(13)-C'(21)-Bl(32)- ACT -C"-
!SS(1-8)  Ar(13)-C'(22)-Bl(31)- ACT -C"-
!SS(1-9)  Ar(23)-C'(11)-Bl(32)- ACT -C"-
!SS(1-11) Ar(13)-Bl(31)-C"(22)- ACT -C"-
!SS(1-12) Ar(13)-Bl(32)-C"(21)- ACT -C"-
!SS(1-13) Ar(23)-Bl(31)-C"(12)- ACT -C"-
!SS(1-16) (11)-Drl(22)-         ACT -C"-
!SS(1-18) Drl(11)-C"(22)-       ACT -C"-
!SS(1-19) Drl(12)-C"(21)-       ACT -C"-
!SS(1-20) (11)-Drl(33)-C"(22)-  ACT -C"-
!SS(1-20) Drl(33)-C"(11)-C"(22)-ACT -C"-
!-------------------------------------------------------------------
!SS(1)   ACT 14: -C"-
101   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1011
      IF(JB_SYS.GT.0) THEN
       CALL SS_ArBl_ACT_C_EXT_AB_SGT0(11)
       CALL SS_S_Drl_ACT_C_EXT_AB_SGT0(11)
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL SS2_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,1)
          CALL SS4_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,1)
          CALL SS5_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
          CALL SS10_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
          CALL SS14_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
        ENDDO
      ENDDO
      RETURN

1011  IF(JB_SYS.GT.0) CALL SS_Drl_ACT_C_EXT_AB_SGT0(11)
      W0SS15=W0_SS(15)
      W1SS15=W1_SS(15)
      W0SS17=W0_SS(17)
      W1SS17=W1_SS(17)
      W0SS20=W0_SS(20)
      IF(JML.EQ.1.AND.JMR.EQ.1) THEN
!SS(1-20) Drl(33)-C"(00)-       ACT -C"-                     ! IPL(R)AD=
        DO LR0=NORB_FRZ+1,NORB_DZ
          IWDL=JUST(LR0,LR0)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL)=0.D0
          ENDDO
C      do lrk=1,norb_dz
C        if(lrk.eq.lr0) cycle
C        CALL Drl_tt_ext(lrk)
C     enddo
          CALL Drl_TT_SUM(LR0,0)
        ENDDO
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
          IWDL=JUST(LRI,LRJ)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
!SS(1-15) (22)-Drl(11)-         ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS15
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS15
          ENDDO
          CALL Drl_TT_EXT(LRJ)
!SS(1-17) Drl(22)-C"(11)-       ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS17
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS17
          ENDDO
          CALL Drl_TT_EXT(LRI)
!SS(1-20) (22)(11)Drl(33)-      ACT -C"-
!SS(1-20) (22)Drl(33)-C"(11)-   ACT -C"-
!SS(1-20) Drl(33)-C"(22)-C"(11)-ACT -C"-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS20
            VPLP_W1(MPL)=0.D0
          ENDDO
          CALL Drl_TT_SUM(LRI,LRJ)
        ENDDO
      ENDDO
      RETURN
!ST(2)   ACT -C"-
102   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      IF(JB_SYS.GT.0) CALL ST_Drl_ACT_C_EXT_AB_SGT0(11)
      IF(JB_SYS.GT.0) CALL ST_ArBl_ACT_C_EXT_AB_SGT0(11)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL ST1_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,1)
          CALL ST2_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
          CALL ST4_EXT(LRI,LRJ,NK,1)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
          CALL ST4_EXT(LRI,LRJ,NK,-1)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
        ENDDO
      ENDDO

      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!ST(2-5) (22)Drl(12)-          ACT -C"-
            IWDL=JUST(LRI,LRJ)
            IWDR=IWDL           !
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(5)
            ENDDO
            CALL Drl_TT_EXT(LRJ)
!ST(2-6) Drl(22)-C"(12)-       ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(6)
            ENDDO
            CALL Drl_TT_EXT(LRI)
!----------------------------------------------------------
!ST(2-3) Ar(13)-C'(22)-Bl(32)-   ACT -C"-
!ST(2-3) Ar(13)-Bl(32)-C'(22)-   ACT -C"-
!ST(2-7) Drl(12)-C"(22)-         ACT -C"-
!----------------------------------------------------------
          ENDDO
        ENDDO
      GOTO 10
!=======================================================================
!TS(3) D&R^L-  ACT -C"-
103   IF(LINELP.NE.14.OR.NLG2.EQ.1) RETURN
      IF(JB_SYS.GT.0) THEN
        CALL TS_ArBl_ACT_C_EXT_AB_SGT0(11)
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          CALL TS1_EXT(LRI,LRJ,NK)
         IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,1)
          CALL TS2_EXT(LRI,LRJ,NK,1)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
          CALL TS2_EXT(LRI,LRJ,NK,-1)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
          CALL TS4_EXT(LRI,LRJ,NK)
          IF(NK.NE.0) CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
        ENDDO
      ENDDO
      GOTO 10
!======================================================
!ST1(4) Ar-Bl- Drl- ACT -C"-
104   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
        CALL STT_ArBl_ACT_C_EXT_AB_SGT1(11)
      RETURN
!=======================================================
!T1S(5) Ar-Bl- Drl ACT -C"-
105   IF(LINELP.NE.14.OR.NLG2.NE.2) RETURN
        CALL TTS_Drl_ACT_C_EXT_AB_SGT1(11)
        CALL TTS_ArBl_ACT_C_EXT_AB_SGT1(11)
      RETURN
!===========================================================
!SD1(8) Ar ACT -Bl-
108   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      IF(JB_SYS.GT.0) CALL SDD_AR_ACT_BL_SGT0(11,LRA)
      RETURN
!===========================================================
!TTTT(12) Ar-Bl- Drl- ACT -C"-
112   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL TTTT_Drl_ACT_C_EXT_AB_SGT0(11)
      ELSE
        CALL TTTT_ArBl_ACT_C_EXT_AB_SGT0(11)
      ENDIF
      RETURN
!=============================================================
!T1D1(15) Ar- ACT -Bl-
115   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL TTDD_AR_ACT_BL_SGT1(11,LRA)
      RETURN
!============================================================
!D1D1(20) Drl- Ar-Bl- ACT -C"-
120   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) THEN
        CALL D1D1_Drl_ACT_C_EXT_AB_SGT0(11)
      ELSE
        CALL D1D1_ArBl_ACT_C_EXT_AB_SGT0(11)
      ENDIF
      RETURN
!=================================================================
!DD1(21) Ar-Bl- ACT -C"-
121   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
      CALL DD1_ArBl_ACT_C_EXT_AB_SGT0(11)
      RETURN
!=================================================================
!D1D(22) Ar-Bl- Drl- ACT -C"-
122   IF(LINELP.NE.14.or.nlg2.ne.2) RETURN
      CALL D1D_ArBl_ACT_C_EXT_AB_SGT0(11)
      CALL D1D_Drl_ACT_C_EXT_AB_SGT0(11)
      RETURN
!=================================================================
!D1V(24) Ar- ACT -Bl-
124   IF(LINELP.NE.17) RETURN
      LRA=NLG1
      CALL D1V_Ar_ACT_Bl_EXT_AB_SGT0(11,LRA)
      RETURN
!=======================================================================
!TT(11) Drl-  ACT -C"-
111   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1111
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        DO LRJ=LRI+1,NORB_DZ
          call TT1_EXT(LRI,LRJ,NK,1)
          CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
          call TT1_EXT(LRI,LRJ,NK,-1)
          CALL Ar_BL_EXT_TT(LRI,LRJ,NK)
        ENDDO
      ENDDO
      RETURN

1111  W0TT2=W0_TT(2)
      W1TT2=W1_TT(2)
      W0TT3=W0_TT(3)
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
!TT(11-2) (22)Drl(22)-
!TT(11-2) Drl(22)-C"(22)-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT2
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TT2
            ENDDO
            IWDL=JUST(LRI,LRJ)
            IWDR=IWDL
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Drl_TT_EXT(LRI)
            CALL Drl_TT_EXT(LRJ)
!TT(11-3) Drl(33)-C"(22)-C"(22)-
!TT(11-3) (22)Drl(33)-C"(22)-
!TT(11-3) (22)(22)Drl(33)-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT3
              VPLP_W1(MPL)=0.D0
            ENDDO
C      do lrk=1,norb_dz
C        if(lrk.eq.lri) cycle
C        if(lrk.eq.lrj) cycle
C        CALL Drl_tt_ext(lrk)
C     enddo
            CALL Drl_TT_SUM(LRI,LRJ)
          ENDDO
        ENDDO
      RETURN
!=======================================================================
!DD(19) ACT -C"- ....................................................
119   IF(LINELP.NE.14) RETURN
      IF(NLG2.EQ.1) GOTO 1191
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JMLR) CYCLE
          W0DD1=W0_DD(1)
          W1DD1=W1_DD(1)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W0DD1=-W0DD1
            W1DD1=-W1DD1
          ENDIF
          IF(LMI.EQ.JML.AND.LMJ.EQ.JMR) THEN
!DD(19-1) Ar(23)-Bl(32)-      ACT -C"-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD1
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD1
            ENDDO
            IWDL=JUD(LRI)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_BL_EXT_TT(LRI,LRJ,1)
          ENDIF
        ENDDO
      ENDDO
      RETURN

1191  W0DD2=W0_DD(2)
      W1DD2=W1_DD(2)
      W0DD3=W0_DD(3)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(LMI.NE.JML) CYCLE
!DD(19-2) Drl(22)-
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD2
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD2
        ENDDO
        IWDL=JUD(LRI)
        IWDR=IWDL
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        CALL Drl_TT_EXT(LRI)
!DD(19-3) (22)Drl(33)-
!DD(19-3) Drl(33)-C"(22)-
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD3
          VPLP_W1(MPL)=0.D0
        ENDDO
        CALL Drl_TT_SUM(LRI,0)
C      do lrk=1,norb_dz
C        if(lrk.eq.lri) cycle
C        CALL Drl_tt_ext(lrk)
C     enddo
      ENDDO
      GOTO 10
!=======================================================================
!VV(25) ACT -BL- ....................................................
125   IF(LINELP.NE.14.OR.NLG2.NE.1) RETURN
      W0VV=W0_VV
!VV(25) Drl(33)-
      IWDL=0
      IWDR=0
      DO MPL=1,MTYPE
        VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_VV
        VPLP_W1(MPL)=0.D0
      ENDDO
      DO MPL=1,MHLP
        IWAL=LPNEW_LWEI(MPL)
        IWAR=LPNEW_RWEI(MPL)
        LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
        LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
      ENDDO
!      CALL Drl_TT_SUM(0,0)
      do lrk=1,norb_dz
        CALL Drl_tt_ext(lrk)
      enddo
      GOTO 10
C=======================================================================
10    return
      end

      subroutine TT_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      LOGIC_DH=.FALSE.
      LRAI=NLG1
      LRAJ=NLG2
      INTPOS=NLG1
      ISMA=MUL_TAB(IML,IMR)
!line=5 A&r-B&l<-->EXT
!5    CONTINUE
      IF(LINELP.EQ.5) THEN
        CALL Ar_BL_EXT_TT(lrai,lraj,1)
      ENDIF
!line=9 D&rl<-->EXT
!9    CONTINUE
      IF(LINELP.EQ.9) THEN
        call Drl_TT_EXT(lrai)
      endif
      return
      end


      subroutine logicg_st(ilnodesm,irnodesm,iltype,irtype)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      ilrsm=mul_tab(ilnodesm,irnodesm)
      iii=1      !index to determine lwei rwei iposint and nlinkorb
!G2G4a G2G4b G1415 G13
      logic_g36a=.false.
      logic_g36b=.false.
      logic_g35a=.false.
      logic_g35b=.false.
      logic_g34a=.false.
      logic_g34b=.false.

      lpsta36a=iii
      call do_g36mode(ilrsm,ilnodesm,iii)
      lpend36a=iii-4
      if ( lpend36a .ge. lpsta36a ) logic_g36a=.true.
      lpsta35a=iii
      call do_g35mode(ilrsm,ilnodesm,iii)
      lpend35a=iii-4
      if ( lpend35a .ge. lpsta35a ) logic_g35a=.true.
      lpsta34a=iii
      call do_g34mode(ilrsm,ilnodesm,iii)
      lpend34a=iii-4
      if ( lpend34a .ge. lpsta34a ) logic_g34a=.true.
      if ( ilrsm .ne. 1 ) then
            lpsta36b=iii
            call do_g36mode(ilrsm,irnodesm,iii)
            lpend36b=iii-4
            if ( lpend36b .ge. lpsta36b ) logic_g36b=.true.
            lpsta35b=iii
            call do_g35mode(ilrsm,irnodesm,iii)
            lpend35b=iii-4
            if ( lpend35b .ge. lpsta35b ) logic_g35b=.true.
            lpsta34b=iii
            call do_g34mode(ilrsm,irnodesm,iii)
            lpend34b=iii-4
            if ( lpend34b .ge. lpsta34b ) logic_g34b=.true.
      else
            logic_g36b=logic_g36a
            lpsta36b=lpsta36a
            lpend36b=lpend36a
            logic_g35b=logic_g35a
            lpsta35b=lpsta35a
            lpend35b=lpend35a
            logic_g34b=logic_g34a
            lpsta34b=lpsta34a
            lpend34b=lpend34a
      endif
      logic_g2g4a=.false.
      logic_g2g4b=.false.
      logic_g1415=.false.
      logic_g13=.false.

      if ( irnodesm .eq. 1 .and. irtype .eq. 4 ) then        ! ir:S_1
            logic_g2g4a=.true.
            ism_g2g4=ilnodesm
      endif
      if ( ilnodesm .eq. 1 .and. iltype .eq. 4 ) then        ! il:S_1
            logic_g2g4b=.true.
            ism_g2g4=irnodesm
      endif
      if ( ilnodesm .eq. irnodesm) then        ! ir:S_1
        logic_g1415=.true.
        ism_g1415=ilnodesm
      endif
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine inidf()
!bs initializes the df on module with double factorials

use AMFI_global, only: df, dffrac
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: irun, jbm

df(0) = One
df(1) = One
do irun=2,ubound(df,1)
  df(irun) = real(irun,kind=wp)*df(irun-2)
end do
do jbm=0,ubound(df,1)
  dffrac(:,jbm) = df(:)/df(jbm)
end do

return

end subroutine inidf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992,2000,2025, Roland Lindh                      *
!               1990, IBM                                              *
!***********************************************************************

subroutine Eval_g1_ijkl(iS,jS,kS,lS,Temp,nGrad,A_Int)

use Index_Functions, only: nTri_Elem
use k2_arrays, only: Create_BraKet, Destroy_BraKet, Sew_Scr
use iSD_data, only: iSD, nSD
use Symmetry_Info, only: nIrrep
use Gateway_Info, only: CutInt
use setup, only: mSkal
use RICD_Info, only: RI_2C, RI_3C
use stdalloc, only: mma_allocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iS, jS, kS, lS, nGrad
real(kind=wp), intent(inout) :: Temp(nGrad)
real(kind=wp), intent(in) :: A_Int
integer(kind=iwp) :: iBasAO, iBasi, iBasn, iBsInc, iCar, iFnc(4), ijklA, ipMem1, ipMem2, iSD4(0:nSD,4), iSh, jBasAO, jBasj, jBasn, &
                     jBsInc, JndGrd(3,4), kBasAO, kBask, kBasn, kBsInc, lBasAO, lBasl, lBasn, lBsInc, Mem1, Mem2, MemMax, MemPrm, &
                     MemPSO, nijkl, nPairs, nQuad, nRys, nSO
real(kind=wp) :: Coor(3,4), PMax
real(kind=wp), pointer :: PSO(:), Wrk2(:)
logical(kind=iwp) :: ABCDeq, JfGrad(3,4), No_batch
integer(kind=iwp), external :: MemSO2_P
logical(kind=iwp), external :: EQ

iFnc(:) = 0
PMax = Zero
nPairs = nTri_Elem(mSkal)
nQuad = nTri_Elem(nPairs)

if (.not. allocated(Sew_Scr)) then
  call mma_MaxDBLE(MemMax)
  if (MemMax > 8000) MemMax = MemMax-8000
  call mma_allocate(Sew_Scr,MemMax,Label='Sew_Scr')
else
  MemMax = size(Sew_Scr)
end if
ipMem1 = 1

#ifdef _DEBUGPRINT_
write(u6,*) 'iS,jS,kS,lS=',iS,jS,kS,lS
#endif
!                                                                *
!*****************************************************************
!                                                                *
call Gen_iSD4(iS,jS,kS,lS,iSD,nSD,iSD4)

nSO = MemSO2_P(nSD,iSD4)
No_batch = (nSO == 0)
if (No_batch) return

call Coor_Setup(iSD4,nSD,Coor)
!                                                                      *
!***********************************************************************
!                                                                      *
! -------> Memory Managment <--------
!
! Compute memory request for the primitives, i.e.
! how much memory is needed up to the transfer
! equation.

call MemRys_g(iSD4,nSD,nRys,MemPrm)
!                                                                      *
!***********************************************************************
!                                                                      *
ABCDeq = EQ(Coor(1,1),Coor(1,2)) .and. EQ(Coor(1,1),Coor(1,3)) .and. EQ(Coor(1,1),Coor(1,4))
ijklA = iSD4(1,1)+iSD4(1,2)+iSD4(1,3)+iSD4(1,4)
if ((nIrrep == 1) .and. ABCDeq .and. (mod(ijklA,2) == 1)) return

!                                                                      *
!***********************************************************************
!                                                                      *
! partition memory for K2(ij)/K2(kl) temp spaces zeta,eta,kappa,P,Q

call Create_BraKet(iSD4(5,1)*iSD4(5,2),iSD4(5,3)*iSD4(5,4))

!                                                                      *
!***********************************************************************
!                                                                      *
! Decide on the partitioning of the shells based on the
! available memory and the requested memory.
!
! Now check if all blocks can be computed and stored at once.

call PSOAO1(nSO,MemPrm,MemMax,iFnc,ipMem1,ipMem2,Mem1,Mem2,MemPSO,nSD,iSD4)

PSO(1:Mem1) => Sew_Scr(ipMem1:ipMem1+Mem1-1)
Wrk2(1:Mem2) => Sew_Scr(ipMem2:ipMem2+Mem2-1)

iBasi = iSD4(3,1)
jBasj = iSD4(3,2)
kBask = iSD4(3,3)
lBasl = iSD4(3,4)

iBsInc = iSD4(4,1)
jBsInc = iSD4(4,2)
kBsInc = iSD4(4,3)
lBsInc = iSD4(4,4)

!                                                                      *
!***********************************************************************
!                                                                      *
! Scramble arrays (follow angular index)

do iCar=1,3
  do iSh=1,4
    JndGrd(iCar,iSh) = iSD4(15+iCar,iSh)
    if (RI_3C .and. (iSh == 1)) then
      JfGrad(iCar,iSh) = .false.
      JndGrd(iCar,iSh) = 0
    else if (RI_2C .and. ((iSh == 1) .or. (iSh == 3))) then
      JfGrad(iCar,iSh) = .false.
    else if (btest(iSD4(15,iSh),iCar-1)) then
      JfGrad(iCar,iSh) = .true.
    else
      JfGrad(iCar,iSh) = .false.
    end if
  end do
end do

do iBasAO=1,iBasi,iBsInc
  iBasn = min(iBsInc,iBasi-iBasAO+1)
  iSD4(8,1) = iBasAO-1
  iSD4(19,1) = iBasn

  do jBasAO=1,jBasj,jBsInc
    jBasn = min(jBsInc,jBasj-jBasAO+1)
    iSD4(8,2) = jBasAO-1
    iSD4(19,2) = jBasn

    do kBasAO=1,kBask,kBsInc
      kBasn = min(kBsInc,kBask-kBasAO+1)
      iSD4(8,3) = kBasAO-1
      iSD4(19,3) = kBasn

      do lBasAO=1,lBasl,lBsInc
        lBasn = min(lBsInc,lBasl-lBasAO+1)
        iSD4(8,4) = lBasAO-1
        iSD4(19,4) = lBasn

        ! Get the 2nd order density matrix in SO basis.

        nijkl = iBasn*jBasn*kBasn*lBasn

        ! Fetch the T_i,j,kappa, lambda corresponding to
        ! kappa = k, lambda = l

        call PGet0(nijkl,PSO,nSO,iFnc,MemPSO,Wrk2,Mem2,nQuad,PMax,iSD4)
        if (A_Int*PMax < CutInt) return

        ! Compute gradients of shell quadruplet

        call TwoEl_g(Coor,nRys,Temp,nGrad,JfGrad,JndGrd,PSO,nijkl,nSO,Sew_Scr(ipMem2),Mem2,iSD4)

#       ifdef _DEBUGPRINT_
        call PrGrad(' In Drvg1: Grad',Temp,nGrad)
#       endif

      end do
    end do

  end do
end do

call Destroy_BraKet()

end subroutine Eval_g1_ijkl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Misc_Seward(iBas,iBas_Aux,iBas_Frag)

use Basis_Info, only: dbsc, iCnttp_Dummy, nCnttp, Shells
use Center_Info, only: dc
use Sizes_of_Seward, only: S
use Gateway_Info, only: RadMax, cdMax, EtMax
use Symmetry_Info, only: nIrrep
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iBas, iBas_Aux, iBas_Frag
#include "Molcas.fh"
integer(kind=iwp) :: iAng, iCnt, iCnttp, iShell, jCnttp, jSh, kCmp, kdc, mc, mdc

!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over distinct shell types

iBas = 0
iBas_Aux = 0
iBas_Frag = 0

iShell = 0
mc = 1
kdc = 0
! Loop over basis sets
iCnttp = 0
do jCnttp=1,nCnttp

  ! Make sure that we process the dummy shell last

  if ((jCnttp == iCnttp_Dummy) .and. (jCnttp /= nCnttp)) then
    iCnttp = iCnttp+2
  else if ((jCnttp == nCnttp) .and. (iCnttp == jCnttp)) then
    iCnttp = iCnttp_Dummy
  else
    iCnttp = iCnttp+1
  end if

  ! Loop over distinct centers

  do iCnt=1,dbsc(iCnttp)%nCntr
    kdc = kdc+1
    mdc = iCnt+dbsc(iCnttp)%mdci
    if (max(mdc,kdc) > MxAtom) then
      call WarningMessage(2,'MxAtom too small:')
      write(u6,*) 'MxAtom=',MxAtom
      write(u6,*) 'Increase mxAtom in Molcas.fh and recompile the code!'
      call Abend()
    end if
    ! Loop over shells associated with this center
    ! Start with s type shells
    jSh = dbsc(iCnttp)%iVal
    do iAng=0,dbsc(iCnttp)%nVal-1
      iShell = iShell+1

      if (Shells(jSh)%nBasis_C > 0) call RdMx(RadMax,Shells(jSh)%Exp,Shells(jSh)%nExp,Shells(jSh)%Cff_c(1,1,1), &
                                              Shells(jSh)%nBasis_C,cdMax,EtMax)
      if (iShell > MxShll) then
        call WarningMessage(2,'iShell > MxShll; Change MxShll in Molcas.fh and recompile the code!')
        call Abend()
      end if
      kCmp = (iAng+1)*(iAng+2)/2
      if (Shells(jSh)%Prjct) kCmp = 2*iAng+1

      if (Shells(jSh)%nBasis /= 0) then
        if (Shells(jSh)%Aux) then
          iBas_Aux = iBas_Aux+Shells(jSh)%nBasis*kCmp*nIrrep/dc(mdc)%nStab
        else if (Shells(jSh)%Frag) then
          iBas_Frag = iBas_Frag+Shells(jSh)%nBasis*kCmp*nIrrep/dc(mdc)%nStab
        else
          iBas = iBas+Shells(jSh)%nBasis*kCmp*nIrrep/dc(mdc)%nStab
        end if
      end if
      jSh = jSh+1
    end do
    mc = mc+nIrrep/dc(mdc)%nStab
  end do

end do
S%nShlls = iShell
if (iBas >= 2*MaxBfn) then
  call WarningMessage(2,'MaxBfn too small')
  write(u6,*) 'Increase 2*MaxBfn to ',iBas
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Misc_Seward

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MEM(TEXT,JOB,TYPE,KPOINT,LENGTH)
C
C     Purpose: memory management using getmem. Only differences are that
C     'flush' flushes back to and including KPOINT, and 'max ' allocates
C     max. memory available. To get max. memory available without
C     allocating, specify JOB='GETM'.
C
      IMPLICIT NONE
      CHARACTER*(*) TEXT,JOB,TYPE
      INTEGER       KPOINT, LENGTH
      INTEGER       LJOB, I, LENDUM
      CHARACTER*4   MYJOB

      LJOB = LEN(JOB)
      IF (LJOB .LT. 4) THEN
         DO I = 1,LJOB
            MYJOB(I:I) = JOB(I:I)
         END DO
         DO I = LJOB+1,4
            MYJOB(I:I) = ' '
         END DO
      ELSE
         DO I = 1,4
            MYJOB(I:I) = JOB(I:I)
         END DO
      END IF
      CALL UPCASE(MYJOB)

      IF (MYJOB(1:4) .EQ. 'MAX ') THEN
         CALL GETMEM(TEXT,'MAX ',TYPE,KPOINT,LENGTH)
         CALL GETMEM(TEXT,'ALLO',TYPE,KPOINT,LENGTH)
      ELSE IF (MYJOB(1:4) .EQ. 'FLUS') THEN
         LENDUM = -1
         CALL GETMEM(TEXT,'FLUSH',TYPE,KPOINT,LENDUM)
         CALL GETMEM(TEXT,'FREE',TYPE,KPOINT,LENGTH)
      ELSE IF (MYJOB(1:4) .EQ. 'GETM') THEN
         CALL GETMEM(TEXT,'MAX ',TYPE,KPOINT,LENGTH)
      ELSE
         CALL GETMEM(TEXT,JOB,TYPE,KPOINT,LENGTH)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine EXPA1_UHF(ARR1,IDM,LI,NSP,ARR2)
! THIS SUBROUTINE EXPANDS THE FIRST INDEX OF A MATRIX ARR1
!
! LI*(LI+1)/2

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: ARR1(*)
integer(kind=iwp), intent(in) :: IDM, LI, NSP
real(kind=wp), intent(out) :: ARR2(LI,LI,IDM)
integer(kind=iwp) :: I, IJ, K

if (NSP > 0) then
  IJ = 1
  do K=1,IDM
    do I=1,LI
      ARR2(I,1:I,K) = ARR1(IJ:IJ+I-1)
      ARR2(1:I,I,K) = ARR1(IJ:IJ+I-1)
      IJ = IJ+I
    end do
  end do
else
  IJ = 1
  do K=1,IDM
    do I=1,LI
      ARR2(I,1:I-1,K) = ARR1(IJ:IJ+I-2)
      ARR2(1:I-1,I,K) = -ARR1(IJ:IJ+I-2)
      ARR2(I,I,K) = Zero
      IJ = IJ+I-1
    end do
  end do
end if

return

end subroutine EXPA1_UHF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
*               2010, Jonas Bostrom                                    *
*               2021, Roland Lindh                                     *
************************************************************************
      SubRoutine ChoMP2_deallocate(irc)
      use ChoMP2, only: ChoMP2_allocated
      use ChoMP2, only: iFirst, iFirstS, NumOcc, LnOcc, LnT1am, LiT1am
      use ChoMP2, only: LnMatij, LiMatij, lUnit, NumBatOrb, LnBatOrb
      use ChoMP2, only: LnPQprod, LiPQprod
C
C     Purpose: to deallocate memory of the  Cholesky MP2 program.
C
#include "implicit.fh"
#include "chomp2.fh"
#include "stdalloc.fh"

      irc = 0

      Call ChoMP2g_deallocate(irc)

      If (.NOT.ChoMP2_allocated) Return

      Call mma_deallocate(LiPQprod)
      Call mma_deallocate(LnPQprod)
      Call mma_deallocate(LnBatOrb)
      Call mma_deallocate(NumBatOrb)
      Call mma_deallocate(lUnit)
      Call mma_deallocate(LiMatij)
      Call mma_deallocate(LnMatij)
      Call mma_deallocate(LiT1am)
      Call mma_deallocate(LnT1am)
      Call mma_deallocate(LnOcc)
      Call mma_deallocate(NumOcc)
      Call mma_deallocate(iFirstS)
      Call mma_deallocate(iFirst)
*
      ChoMP2_allocated=.FALSE.

      End

      SubRoutine ChoMP2g_deallocate(irc)
      use ChoMP2, only: ChoMP2g_allocated, EFrozT, EOccuT, EVirtT
      use ChoMP2, only: AdrR1, AdrR2
      use ChoMP2, only: MP2D_full, MP2D
      use ChoMP2, only: MP2W_full, MP2W
      use ChoMP2, only: MP2D_e_full, MP2D_e
      use ChoMP2, only: MP2W_e_full, MP2W_e
*
*     Purpose: Deallocate memory needed for
*              MP2-gradients or properties.
*
#include "implicit.fh"
#include "chomp2g.fh"
#include "chomp2.fh"
#include "stdalloc.fh"

      irc = 0

      If (.NOT.ChoMP2g_allocated) Return

      Call mma_deallocate(MP2D_full)
      Call mma_deallocate(MP2W_full)
      Call mma_deallocate(MP2D_e_full)
      Call mma_deallocate(MP2W_e_full)
      Do iSym = 1, 8
         MP2D(iSym)%A=>Null()
         MP2W(iSym)%A=>Null()
         MP2D_e(iSym)%A=>Null()
         MP2W_e(iSym)%A=>Null()
      End Do
      Call mma_deallocate(AdrR2)
      Call mma_deallocate(AdrR1)
      Call mma_deallocate(EVirtT)
      Call mma_deallocate(EOccuT)
      Call mma_deallocate(EFrozT)

      ChoMP2g_allocated=.FALSE.

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine CalcDacc(Dacc,GDMat,M,nnA,nRoots,zx)

use Index_Functions, only: iTri, nTri_Elem
use Constants, only: Zero, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: M, nnA, nRoots
real(kind=wp), intent(out) :: Dacc(nnA,nnA)
real(kind=wp), intent(in) :: GDMat(nTri_Elem(nRoots),nnA,nnA), zx(nTri_Elem(nRoots-1))
integer(kind=iwp) :: IKM, IKM2, it, K
real(kind=wp) :: Fact

Dacc(:,:) = Zero

do K=1,nRoots
  if (K == M) cycle
  IKM = iTri(K,M)
  IKM2 = nTri_Elem(max(K,M)-2)+min(K,M)
  Fact = Four*zx(IKM2)
  if (K > M) Fact = -Fact
  do it=1,nnA
    Dacc(:,it) = Dacc(:,it)+Fact*GDMat(IKM,it,:)
  end do
end do

end subroutine CalcDacc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine complete_ext_loop()
!*****************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: icano_nnend, icano_nnsta, indx, isegdownwei, isegsta, isegupwei, mcroot, value_lpext, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ilpvalue, irot, irtidx, iupwei, lwei, mm, mm0, mmtmp, nn, nntmp
real(kind=wp) :: vetmp, vlptmp, vlptmp1

!write(u6,*) ' ext_test '
!return
do irot=1,mcroot
  irtidx = indx(irot)
  lwei = isegsta !+irtidx

  do iupwei=1,isegupwei
    ilpvalue = 0
    mm0 = lwei
    nn = lwei+icano_nnsta-1
    do nntmp=icano_nnsta,icano_nnend
      nn = nn+1
      mm = mm0
      vlptmp1 = vector1(nn+irtidx)
      vlptmp = vector2(nn+irtidx)
      do mmtmp=1,nntmp-1
        ilpvalue = ilpvalue+1
        vetmp = value_lpext(ilpvalue)
        mm = mm+1
        vector2(mm+irtidx) = vector2(mm+irtidx)+vlptmp1*vetmp
        vlptmp = vlptmp+vector1(mm+irtidx)*vetmp
      end do
      vector2(nn+irtidx) = vlptmp
    end do
    lwei = lwei+isegdownwei
  end do

end do
!...end of complete_ext_loop

end subroutine complete_ext_loop

subroutine complete_ext_loop_g()

use gugaci_global, only: dm1tmp, icano_nnend, icano_nnsta, index_lpext, index_lpext1, index_lpext2, isegdownwei, isegsta, &
                         isegupwei, value_lpext, value_lpext1, value_lpext2, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ilpvalue, indexlp, indexlp1, indexlp2, iupwei, lwei, mm, mm0, mmtmp, nn, nntmp
real(kind=wp) :: valuelp, valuelp1, valuelp2

lwei = isegsta
do iupwei=1,isegupwei
  ilpvalue = 0
  mm0 = lwei
  nn = lwei+icano_nnsta-1
  do nntmp=icano_nnsta,icano_nnend
    nn = nn+1
    mm = mm0
    do mmtmp=1,nntmp-1
      ilpvalue = ilpvalue+1
      mm = mm+1
      indexlp = index_lpext(ilpvalue)
      if (indexlp /= 0) then
        valuelp = value_lpext(ilpvalue)
        vector2(indexlp) = vector2(indexlp)+vector1(mm)*vector1(nn)*valuelp
      end if
      indexlp1 = index_lpext1(ilpvalue)
      if (indexlp1 /= 0) then
        valuelp1 = value_lpext1(ilpvalue)
        vector2(indexlp1) = vector2(indexlp1)+vector1(mm)*vector1(nn)*valuelp1
      end if
      indexlp2 = index_lpext2(ilpvalue)
      if (indexlp2 /= 0) then
        valuelp2 = value_lpext2(ilpvalue)
        dm1tmp(indexlp2) = dm1tmp(indexlp2)+vector1(mm)*vector1(nn)*valuelp2
      end if
    end do
  end do
  lwei = lwei+isegdownwei
end do

end subroutine complete_ext_loop_g

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine quaterreport(V1best,V2best,V1,V2)
      implicit none
#include "geoms.fh"
#include "options.fh"
      real*8 V1best(3),V2best(3),V1(3),V2(3)
      real*8 v1dot,v2dot
      real*8 ddot_

      Write(6,*) "Number of geometries generated : ",ngeoms

      if (rotate) then
        v1dot=ddot_(3,V1best,1,V1,1)
        v2dot=ddot_(3,V2best,1,V2,1)
c
        Call Add_Info("V1_dot_product",[v1dot],1,8)
        Call Add_Info("V2_dot_product",[v2dot],1,8)
c
        Write(6,*) "V1best.V1 = ",v1dot
        Write(6,*) "V2best.V2 = ",v2dot
      end if

      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SPINORB(D,CMO,OCC)
! Purpose: diagonalize the spin density matrix (D) to
! obtain the eigenvectors (EVEC) and the eigenvalues (EVAL).
! Then the natural spinorbitals (CMONSO) are computed
! (only active).

use Index_Functions, only: nTri_Elem
use PrintLevel, only: DEBUG
use output_ras, only: IPRLOC
use general_data, only: NASH, NBAS, NFRO, NISH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: D(*), CMO(*), OCC(*)
integer(kind=iwp) :: I, IDIAG, IPCMO, IPDEN, IPOCC, iPrLev, iSym, NA, NB, NF, NI
real(kind=wp), allocatable :: W1(:,:), W2(:)

! Local print level (if any)
IPRLEV = IPRLOC(6)
if (IPRLEV >= DEBUG) write(u6,*) ' Entering SPINORB'

IPDEN = 0
IPCMO = 0
IPOCC = 0
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  NF = NFRO(ISYM)
  NI = NISH(ISYM)
  if (NB /= 0) then
    NA = NASH(ISYM)
    if (NA /= 0) then
      call mma_allocate(W1,NA,NA,Label='W1')
      call mma_allocate(W2,NB*NA,Label='W2')
      call unitmat(W1,NA)
      call Jacob(D(IPDEN+1),W1,NA,NA)
      IDIAG = 0
      do I=1,NA
        IDIAG = IDIAG+I
        OCC(IPOCC+NF+NI+I) = D(IPDEN+IDIAG)
      end do
      call DGEMM_('N','N',NB,NA,NA,One,CMO(IPCMO+(NF+NI)*NB+1),NB,W1,NA,Zero,W2,NB)
      CMO(IPCMO+(NF+NI)*NB+1:IPCMO+(NF+NI+NA)*NB) = W2(:)
      call mma_deallocate(W2)
      call mma_deallocate(W1)
      IPDEN = IPDEN+nTri_Elem(NA)
    end if
    IPCMO = IPCMO+NB*NB
    IPOCC = IPOCC+NB
  end if
end do

end subroutine SPINORB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine driverBas(ireturn)

use desymmetrize_mod, only: desym
use info_expbas_mod, only: DoDesy, DoExpbas
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: ireturn

ireturn = 0

call Readinp_expbas()
if (DoExpbas) then
  call expbas(ireturn)
  if (ireturn /= 0) return
end if

if (DoDesy) then
  call desym(ireturn)
  if (ireturn /= 0) return
end if

end subroutine driverBas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE BLKFO_MIN(ISM,NBLK,LEN_BLK)
*
* Number of blocks and length of each block for CI expansion
*
* Jeppe Olsen, June 2001
*
*   Input
* =========
* ISM : Symmetry of CI expansion
*
* Output
* ======
*
* NBLK : Number of blocks in expansion
* LEN_BLK(IBLK) : Length of block IBLK
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "cicisp.fh"
#include "stinf.fh"
#include "cstate.fh"
#include "csm.fh"
#include "strbas.fh"
#include "crun.fh"
      COMMON/CANDS/ICSM,ISSM,ICSPC,ISSPC ! Jesper

*. Output : Should outside be dimensioned as MXNTTS
      INTEGER LEN_BLK(*)
      INTEGER IDUMMY(1)
*
      IDUMMY = 0 ! jwk-cleanup
      IATP = 1
      IBTP = 2
*
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*. Pointers to local arrays
      IDUM=0
      NTTS = MXNTTS
      CALL GETMEM('CLBT  ','ALLO','INTE',KPCLBT ,MXNTTS)
      CALL GETMEM('CLEBT ','ALLO','INTE',KPCLEBT,MXNTTS)
      CALL GETMEM('CI1BT ','ALLO','INTE',KPCI1BT,MXNTTS)
      CALL GETMEM('CIBT  ','ALLO','INTE',KPCIBT ,8*MXNTTS)
      CALL GETMEM('CBLTP ','ALLO','INTE',KPCBLTP,NSMST)
*. Info needed for generation of block info
      CALL GETMEM('CIOIO ','ALLO','INTE',KLCIOIO,NOCTPA*NOCTPB)
      CALL IAIBCM(ISSPC,iWORK(KLCIOIO)) ! Jesper
      CALL ZBLTP(ISMOST(1,ISM),NSMST,IDC,IWORK(KPCBLTP),IDUMMY)
*. Allowed length of each batch( not important for final output )
      LBLOCK = MAX(MXSOOB,LCSBLK)
*. Batches  of C vector
      CALL PART_CIV2(IDC,IWORK(KPCBLTP),IWORK(KNSTSO(IATP)),
     &              IWORK(KNSTSO(IBTP)),
     &              NOCTPA,NOCTPB,NSMST,LBLOCK,IWORK(KLCIOIO),
     &              ISMOST(1,ISM),
     &              NBATCH,IWORK(KPCLBT),IWORK(KPCLEBT),
     &              IWORK(KPCI1BT),IWORK(KPCIBT),0,ISIMSYM)
*. Number of BLOCKS
      NBLK = IFRMR(iWORK(KPCI1BT),1,NBATCH)
     &     + IFRMR(iWORK(KPCLBT),1,NBATCH) - 1
*. Length of each block
      CALL EXTRROW(iWORK(KPCIBT),8,8,NBLK,LEN_BLK)
*
      CALL GETMEM('CLBT  ','FREE','INTE',KPCLBT ,MXNTTS)
      CALL GETMEM('CLEBT ','FREE','INTE',KPCLEBT,MXNTTS)
      CALL GETMEM('CI1BT ','FREE','INTE',KPCI1BT,MXNTTS)
      CALL GETMEM('CIBT  ','FREE','INTE',KPCIBT ,8*MXNTTS)
      CALL GETMEM('CBLTP ','FREE','INTE',KPCBLTP,NSMST)
      CALL GETMEM('CIOIO ','FREE','INTE',KLCIOIO,NOCTPA*NOCTPB)
      RETURN
      END
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RESETCNF()
!
! Purpose: reset configuration of decomposition to that read from
!          restart file. Original configuration will be saved in
!          restart common block.

use Cholesky, only: DAMP, SCDIAG, SPAN, THRCOM, THRDIAG, THRNEG, TOONEG, WARNEG, XDAMP, XSCDIAG, XSPAN, XTHRCOM, XTHRDIAG, &
                    XTHRNEG, XTOONEG, XWARNEG
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: Tmp(8)
logical(kind=iwp) :: lTmp

Tmp(1) = XTHRCOM
Tmp(2) = XTHRDIAG
Tmp(3:4) = XDAMP(:)
Tmp(5) = XSPAN
Tmp(6) = XTHRNEG
Tmp(7) = XWARNEG
Tmp(8) = XTOONEG
lTmp = XSCDIAG

XTHRCOM = THRCOM
XTHRDIAG = THRDIAG
XDAMP(:) = DAMP(:)
XSPAN = SPAN
XTHRNEG = THRNEG
XWARNEG = WARNEG
XTOONEG = TOONEG
XSCDIAG = SCDIAG

THRCOM = Tmp(1)
THRDIAG = Tmp(2)
DAMP(:) = Tmp(3:4)
SPAN = Tmp(5)
THRNEG = Tmp(6)
WARNEG = Tmp(7)
TOONEG = Tmp(8)
SCDIAG = lTmp

end subroutine CHO_RESETCNF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Fold(nSym,nBas,A,B)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Fold up symmetry blocked matrix A stored as square blocks        *
!     into triangular matrices and scale the off-diagonal elements     *
!     by a factor of 2 (two). The input and output matrices may be     *
!     identical.                                                       *
!                                                                      *
!     calling arguments:                                               *
!     nSym    : input, integer                                         *
!               number of symmetry blocks                              *
!     nBas    : input, array of integers                               *
!               matrix dimension per symmetry block                    *
!     A       : input, array of real*8                                 *
!               Unfolded input matrix                                  *
!     B       : output, array of real*8                                *
!               Folded output matrix                                   *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Constants, only: Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym)
real(kind=wp), intent(in) :: A(*)
real(kind=wp), intent(_OUT_) :: B(*)
integer(kind=iwp) :: iBas, iOff1, iOff2, iSym, jBas, mBas

iOff1 = 0
iOff2 = 0
do iSym=1,nSym
  mBas = nBas(iSym)
  do iBas=1,mBas
    do jBas=1,iBas-1
      B(iOff2+jBas) = Two*A(iOff1+jBas)
    end do
    B(iOff2+iBas) = A(iOff1+iBas)
    iOff1 = iOff1+mBas
    iOff2 = iOff2+iBas
  end do
end do

return

end subroutine Fold

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Yoshio Nishimoto                                 *
************************************************************************

      Subroutine MS_Res(MODE,IST,JST,Scal)
      use caspt2_global, only: LUCIEX, IDTCEX
      use EQSOLV, only: IVECC, IVECC2, IVECW
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: STSYM, NCONF, NASHT, ISCF, NSTATE
      use pt2_guga, only: MXCI
      use Constants, only: Zero
!
!     Compute the derivative of E^PT2 with respct to the T amplitude
!
      implicit none

      integer(kind=iwp), intent(in) :: MODE, IST, JST
      real(kind=wp), intent(in) :: Scal

      integer(kind=iwp) :: I, NTG1, NTG2, NTG3, IDCI
      real(kind=wp) :: DVALUE, OVL, DUMMY(1)

      real(kind=wp),allocatable :: TG1(:),TG2(:),TG3(:),CI1(:),CI2(:)

! We evaluate the effective Hamiltonian matrix element in two steps.

      NTG1=NASHT**2
      NTG2=NASHT**4
      NTG3=(NTG1*(NTG1+1)*(NTG1+2))/6
! Note: Need proper allocation even if unused, sinced allocated
! arrays are in subroutine parameter lists of MKTG3, HCOUP.
      NTG1=MAX(1,NTG1)
      NTG2=MAX(1,NTG2)
      NTG3=MAX(1,NTG3)
      call mma_allocate(TG1,NTG1,Label='TG1')
      call mma_allocate(TG2,NTG2,Label='TG2')
      call mma_allocate(TG3,NTG3,Label='TG3')
      TG1(:) = Zero
      TG2(:) = Zero
      TG3(:) = Zero

      call mma_allocate(CI1,MXCI,Label='MCCI1')
      call mma_allocate(CI2,MXCI,Label='MCCI2')
      IF(ISCF == 0) THEN
! Read root vectors nr. IST and JST from LUCI.
        IDCI=IDTCEX
        DO I=1,NSTATE
          IF(I == IST) THEN
            CALL DDAFILE(LUCIEX,2,CI1,NCONF,IDCI)
            IF(I == JST) THEN
              CI2(1:NCONF) = CI1(1:NCONF)
            END IF
          ELSE IF(I == JST) THEN
            CALL DDAFILE(LUCIEX,2,CI2,NCONF,IDCI)
          ELSE
            CALL DDAFILE(LUCIEX,0,DUMMY,NCONF,IDCI)
          END IF
        END DO
      END IF

      CALL MKTG3(STSYM,STSYM,CI1,CI2,OVL,TG1,TG2,NTG3,TG3)
      call mma_deallocate(CI1)
      call mma_deallocate(CI2)

!! Do similar to RHS_STRANS. Multiply the solution vector (T) with
!! the overlap-like term constructe with transition density
!! matrices. The output is IVECC (MODE=1) or IVECC2 (MODE=2)
      IF (MODE == 1) THEN
        CALL MS_STRANS(IVECW,IVECC,OVL,TG1,TG2,TG3,DVALUE,SCAL)
      ELSE IF (MODE == 2) THEN
        CALL MS_STRANS(IVECC,IVECC2,OVL,TG1,TG2,TG3,DVALUE,SCAL)
      ELSE IF (MODE == 3) THEN
        CALL MS_STRANS(IVECW,IVECC,OVL,TG1,TG2,TG3,DVALUE,SCAL)
      END IF

      call mma_deallocate(TG1)
      call mma_deallocate(TG2)
      call mma_deallocate(TG3)

      End Subroutine MS_Res
!
!-----------------------------------------------------------------------
!
      SUBROUTINE MS_STRANS(IVEC,JVEC,OVL,TG1,TG2,TG3,HEL,SCAL)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: NSYM, NASHT, NASUP, NISUP, NINDEP, CASES
      use Constants, only: Zero
      use definitions, only: wp, iwp, u6

      implicit none
! Compute the coupling Hamiltonian element defined as
!     HEL = < ROOT1 | H * OMEGA | ROOT2 >
! assuming that IVEC contains a contravariant representation of
! H|ROOT1>, JVEC contains a contravariant representation of
! OMEGA|ROOT2>, and OVL, TG1, TG2, TG3 contain the overlap (normally
! expected to be 0 or 1) and active transition density matrices of ROOT1
! and ROOT2. See also subroutine TSVEC for explanations.

! SVC (March 2014): modification of original code to handle distributed
! RHS arrays. There is now a main HCOUP subroutine that loops over cases
! and irreps and gets access to the process-specific block of the RHS.
! The coupling for that block is computed by the subroutine HCOUP_BLK.

      integer(kind=iwp), intent(in) :: IVEC, JVEC
      real(kind=wp), intent(inout) :: OVL, TG1(NASHT,NASHT),
     &  TG2(NASHT,NASHT,NASHT,NASHT), TG3(*)
      real(kind=wp), intent(out) :: HEL
      real(kind=wp), intent(in) :: SCAL
! The dimension of TG3 is NTG3=(NASHT**2+2 over 3)

      real(kind=wp) :: HECOMP(14,9), HEBLK, SUMSYM, SUMCASE
      integer(kind=iwp) :: ICASE, ISYM, NAS, NIN, NIS, lg_V1, iLo1,
     &  iHi1, jLo1, jHi1, MV1, lg_V2, iLo2, iHi2, jLo2, jHi2, MV2,
     &  NHECOMP, i, IC, IS

#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

! Sketch of procedure:
!  Loop over every (case/symmetry)-block.
!           If (No such vector block) Skip to end of loop
!           Allocate two places for this block, VEC1 and VEC2
!           Read VEC1 as IVEC component from file.
!           Read VEC2 as JVEC component from file.
!           Loop nest, computing
!              HEL := HEL + VEC1*GOM*VEC2
!           End of loop nest
!           Deallocate VEC1 and VEC2
!  End of loop.

      HEL=Zero
      HECOMP=Zero
      DO ICASE=1,13
!     if (icase /= 12.and.icase /= 13) cycle ! H
!     if (icase /= 10.and.icase /= 11) cycle ! G
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIN=NINDEP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          HEBLK=Zero

          if (NAS*NIS /= 0 .and. NIN /= 0) then
            CALL RHS_ALLO (NAS,NIS,lg_V1)
            CALL RHS_ALLO (NAS,NIS,lg_V2)
            CALL RHS_READ (NAS,NIS,lg_V1,ICASE,ISYM,IVEC)
            CALL RHS_READ (NAS,NIS,lg_V2,ICASE,ISYM,JVEC)
            CALL RHS_ACCESS(NAS,NIS,lg_V1,iLo1,iHi1,jLo1,jHi1,MV1)
            CALL RHS_ACCESS(NAS,NIS,lg_V2,iLo2,iHi2,jLo2,jHi2,MV2)

            IF ((iLo1 /= iLo2) .OR. (iHi1 /= iHi2) .OR.
     &          (jLo1 /= jLo2) .OR. (jHi1 /= jHi2)) THEN
              WRITE(u6,'(1X,A)')'HCOUP: Error: block mismatch, abort...'
              CALL ABEND()
            END IF

#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              CALL MS_STRANS_BLK(ICASE,ISYM,NAS,jLo1,jHi1,
     &                        DBL_MB(MV1),DBL_MB(MV2),OVL,
     &                        TG1,TG2,TG3,SCAL)
            ELSE
#endif
              CALL MS_STRANS_BLK(ICASE,ISYM,NAS,jLo1,jHi1,
     &                        GA_Arrays(MV1)%A,
     &                        GA_Arrays(MV2)%A,OVL,
     &                        TG1,TG2,TG3,SCAL)
#ifdef _MOLCAS_MPP_
            END IF
#endif
            !! Save T*S
            CALL RHS_SAVE (NAS,NIS,lg_V2,ICASE,ISYM,JVEC)

            CALL RHS_RELEASE (lg_V1,iLo1,iHi1,jLo1,jHi1)
            CALL RHS_RELEASE (lg_V2,iLo2,iHi2,jLo2,jHi2)
            CALL RHS_FREE (lg_V1)
            CALL RHS_FREE (lg_V2)
          end if
          HECOMP(ICASE,ISYM)=HEBLK
          HEL=HEL+HEBLK
        END DO
      END DO

! Sum-reduce the per-process contributions
      CALL GADGOP_SCAL(HEL,'+')
      NHECOMP=14*9
      CALL GADGOP(HECOMP,NHECOMP,'+')

      IF(IPRGLB >= DEBUG) THEN
        DO ICASE=1,13
          SUMSYM=Zero
          DO ISYM=1,NSYM
            SUMSYM=SUMSYM+HECOMP(ICASE,ISYM)
          END DO
          HECOMP(ICASE,NSYM+1)=SUMSYM
        END DO

        DO ISYM=1,NSYM+1
          SUMCASE=Zero
          DO ICASE=1,13
            SUMCASE=SUMCASE+HECOMP(ICASE,ISYM)
          END DO
          HECOMP(14,ISYM)=SUMCASE
        END DO

        WRITE(u6,'(20a4)')('----',i=1,20)
       WRITE(u6,*)'HCOUP: The contributions to the Hamiltonian coupling'
        WRITE(u6,*)' elements, by case and by symmetry label.'
        DO IC=1,13
          WRITE(u6,'(1X,A8,9F12.8)')
     &      CASES(IC),(HECOMP(IC,IS),IS=1,NSYM+1)
        END DO
        CALL XFLUSH(u6)
        WRITE(u6,'(1X,A8,9F12.8)')
     &    'Summed: ', (HECOMP(14,IS),IS=1,NSYM+1)
        WRITE(u6,*)
      END IF

      end subroutine MS_STRANS
!
!-----------------------------------------------------------------------
!
      SUBROUTINE MS_STRANS_BLK(ICASE,ISYM,NAS,IISTA,IIEND,V1,V2,OVL,
     &                         TG1,TG2,TG3,SCAL)
      USE SUPERINDEX, only: MTU, MTUV, MTGEU, MTGTU
      use caspt2_module, only: NAES, NASHT, NTUVES, NTUES, NTGEUES,
     &                         NTGTUES
      use definitions, only: wp, iwp
      use Constants, only: Two, Four, Eight
! Compute a contribution to the coupling Hamiltonian element (HEL)
! defined as HEL = < ROOT1 | H * OMEGA | ROOT2 >. The contribution
! arises from the block V_(A,I), with A=1,NAS and I=IISTA,IIEND,
! with A the active superindex and I the inactive superindex. Since
! the inactive superindex is partitioned over processes, each process
! only computes part of the HEL value, which is then sum reduced in the
! calling subroutine.
      implicit none

      integer(kind=iwp), intent(in) :: ICASE, ISYM, NAS, IISTA, IIEND
      real(kind=wp), intent(in) :: V1(*), OVL, SCAL
      real(kind=wp), intent(inout) :: V2(*), TG1(NASHT,NASHT),
     &  TG2(NASHT,NASHT,NASHT,NASHT), TG3(*)
! The dimension of TG3 is NTG3=(NASHT**2+2 over 3)

      integer(kind=iwp) :: NISBLK, IAS, IASABS, ITABS, IUABS, IVABS,
     &  JAS, JASABS, IXABS, IYABS, IZABS, IND1, IND2, IND3, JND1,
     &  JND2, JND3, ITG3, NAS1, IAS1, IAS2, JAS1, JAS2
      real(kind=wp) :: TMP, SA, SC, SBtuxy, SBtuyx, SBP, SBM, GUTXY,
     &  SD11, SD12, SD21, SD22, GUY, SE, SFtuxy, SFtuyx, SFP, SFM, SG

      IF (IISTA <= 0) RETURN

      NISBLK=IIEND-IISTA+1
      SELECT CASE (ICASE)
************************************************************************
      CASE (1)
        DO IAS=1,NAS
          IASABS=NTUVES(ISYM)+IAS
          ITABS=MTUV(1,IASABS)
          IUABS=MTUV(2,IASABS)
          IVABS=MTUV(3,IASABS)
          DO JAS=1,NAS
            JASABS=NTUVES(ISYM)+JAS
            IXABS=MTUV(1,JASABS)
            IYABS=MTUV(2,JASABS)
            IZABS=MTUV(3,JASABS)
! Compute and use SA(ITABS IUABS IVABS, IXABS IYABS IZABS)
! Formulae used:
!  SA(tuv,xyz) =  -Gvuxtyz -dyu Gvzxt - dyt Gvuxz -
!         - dxu Gvtyz - dxu dyt Gvz +2 dtx Gvuyz + 2 dtx dyu Gvz
! Gvuxtyz is stored using full permutation symmetry of three pairs
! (vu),(xt), and (yz):
            IND1=IVABS+NASHT*(IUABS-1)
            IND2=IXABS+NASHT*(ITABS-1)
            IND3=IYABS+NASHT*(IZABS-1)
            IF(IND2 > IND3) THEN
              IF(IND1 > IND2) THEN
                JND1=IND1
                JND2=IND2
                JND3=IND3
              ELSE IF(IND1 > IND3) THEN
                JND1=IND2
                JND2=IND1
                JND3=IND3
              ELSE
                JND1=IND2
                JND2=IND3
                JND3=IND1
              END IF
            ELSE
              IF(IND1 > IND3) THEN
                JND1=IND1
                JND2=IND3
                JND3=IND2
              ELSE IF(IND1 > IND2) THEN
                JND1=IND3
                JND2=IND1
                JND3=IND2
              ELSE
                JND1=IND3
                JND2=IND2
                JND3=IND1
              END IF
            END IF
            ITG3=((JND1+1)*JND1*(JND1-1))/6+(JND2*(JND2-1))/2+JND3
!  SA(tuv,xyz) =  -Gvuxtyz -dyu Gvzxt - dyt Gvuxz -
!         - dxu Gvtyz - dxu dyt Gvz +2 dtx Gvuyz + 2 dtx dyu Gvz
! Compute TMP=Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
            TMP=TG3(ITG3)
            IF(IYABS == IUABS) THEN
              TMP=TMP+TG2(IVABS,IZABS,IXABS,ITABS)
            END IF
            IF(IYABS == ITABS) THEN
              TMP=TMP+TG2(IVABS,IUABS,IXABS,IZABS)
              IF(IXABS == IUABS) THEN
                TMP=TMP+TG1(IVABS,IZABS)
              END IF
            END IF
            IF(IXABS == IUABS) THEN
              TMP=TMP+TG2(IVABS,ITABS,IYABS,IZABS)
            END IF
! SA is the negative of this, and then some correction:
            SA=-TMP
            IF(IXABS == ITABS) THEN
              SA=SA+Two*TG2(IVABS,IUABS,IYABS,IZABS)
              IF(IYABS == IUABS) THEN
                SA=SA+Two*TG1(IVABS,IZABS)
              END IF
            END IF
! SA has been computed.

!           HEBLK=HEBLK+SA*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SA*SCAL,V1(IAS),NAS,V2(JAS),NAS)
!           Do i = 1, NAS
!             V2(JAS+i-1) = SA*V1(iAS-1)
!           End Do
          END DO
        END DO
************************************************************************
      CASE(4)
        DO IAS=1,NAS
          IASABS=NTUVES(ISYM)+IAS
          IXABS=MTUV(1,IASABS)
          IUABS=MTUV(2,IASABS)
          IVABS=MTUV(3,IASABS)
          DO JAS=1,NAS
            JASABS=NTUVES(ISYM)+JAS
            ITABS=MTUV(1,JASABS)
            IYABS=MTUV(2,JASABS)
            IZABS=MTUV(3,JASABS)
! Compute and use SC(IXABS IUABS IVABS, ITABS IYABS IZABS)
! In SBMAT, the formula is written as SC(tuv,xyz)
!    = Gvutxyz +dyu Gvztx + dyx Gvutz + dtu Gvxyz + dtu dyx Gvz
! Rewritten, in order to reuse same quantities as in SA:
!  SC(xuv,tyz)
!    = Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
! Gvuxtyz is stored using full permutation symmetry of three pairs
! (vu),(xt), and (yz):
            IND1=IVABS+NASHT*(IUABS-1)
            IND2=IXABS+NASHT*(ITABS-1)
            IND3=IYABS+NASHT*(IZABS-1)
            IF(IND2 > IND3) THEN
              IF(IND1 > IND2) THEN
                JND1=IND1
                JND2=IND2
                JND3=IND3
              ELSE IF(IND1 > IND3) THEN
                JND1=IND2
                JND2=IND1
                JND3=IND3
              ELSE
                JND1=IND2
                JND2=IND3
                JND3=IND1
              END IF
            ELSE
              IF(IND1 > IND3) THEN
                JND1=IND1
                JND2=IND3
                JND3=IND2
              ELSE IF(IND1 > IND2) THEN
                JND1=IND3
                JND2=IND1
                JND3=IND2
              ELSE
                JND1=IND3
                JND2=IND2
                JND3=IND1
              END IF
            END IF
            ITG3=((JND1+1)*JND1*(JND1-1))/6+(JND2*(JND2-1))/2+JND3
!  SC(xuv,tyz) (rewritten, swapping x and t)
!    = Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
            TMP=TG3(ITG3)
            IF(IYABS == IUABS) THEN
              TMP=TMP+TG2(IVABS,IZABS,IXABS,ITABS)
            END IF
            IF(IYABS == ITABS) THEN
              TMP=TMP+TG2(IVABS,IUABS,IXABS,IZABS)
              IF(IXABS == IUABS) THEN
                TMP=TMP+TG1(IVABS,IZABS)
              END IF
            END IF
            IF(IXABS == IUABS) THEN
              TMP=TMP+TG2(IVABS,ITABS,IYABS,IZABS)
            END IF
            SC= TMP

!           HEBLK=HEBLK+SC*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SC*SCAL,V1(IAS),NAS,V2(JAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(2)
        DO IAS=1,NAS
          IASABS=NTGEUES(ISYM)+IAS
          ITABS=MTGEU(1,IASABS)
          IUABS=MTGEU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGEUES(ISYM)+JAS
            IXABS=MTGEU(1,JASABS)
            IYABS=MTGEU(2,JASABS)
! Formulae used:
!    SB(tu,xy)=
!    = 2 Gxtyu -4dxt Gyu -4dyu Gxt +2dyt Gxu + 8 dxt dyu
!      -4dxu dyt + 2dxu Gyt
!    SB(tu,yx)=
!    = 2 Gytxu -4dyt Gxu -4dxu Gyt +2dxt Gyu + 8 dyt dxu
!      -4dyu dxt + 2dyu Gxt
!    SBP(tu,xy)=SB(tu,xy)+SB(tu,yx)
!    SBM(tu,xy)=SB(tu,xy)-SB(tu,yx)
            SBtuxy=Two*TG2(IXABS,ITABS,IYABS,IUABS)
            SBtuyx=Two*TG2(IYABS,ITABS,IXABS,IUABS)
            IF(IXABS == ITABS) THEN
              SBtuxy=SBtuxy-Four*TG1(IYABS,IUABS)
              SBtuyx=SBtuyx+Two*TG1(IYABS,IUABS)
              IF(IYABS == IUABS) THEN
                SBtuxy=SBtuxy+Eight*OVL
                SBtuyx=SBtuyx-Four*OVL
              END IF
            END IF
            IF(IYABS == IUABS) THEN
              SBtuxy=SBtuxy-Four*TG1(IXABS,ITABS)
              SBtuyx=SBtuyx+Two*TG1(IXABS,ITABS)
            END IF
            IF(IYABS == ITABS) THEN
              SBtuxy=SBtuxy+Two*TG1(IXABS,IUABS)
              SBtuyx=SBtuyx-Four*TG1(IXABS,IUABS)
              IF(IXABS == IUABS) THEN
                SBtuxy=SBtuxy-Four*OVL
                SBtuyx=SBtuyx+Eight*OVL
              END IF
            END IF
            IF(IXABS == IUABS) THEN
              SBtuxy=SBtuxy+Two*TG1(IYABS,ITABS)
              SBtuyx=SBtuyx-Four*TG1(IYABS,ITABS)
            END IF

            SBP=SBtuxy + SBtuyx

!           HEBLK=HEBLK+SBP*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SBP*SCAL,V1(IAS),NAS,V2(JAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(3)
        DO IAS=1,NAS
          IASABS=NTGTUES(ISYM)+IAS
          ITABS=MTGTU(1,IASABS)
          IUABS=MTGTU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGTUES(ISYM)+JAS
            IXABS=MTGTU(1,JASABS)
            IYABS=MTGTU(2,JASABS)
! Formulae used:
!    SB(tu,xy)=
!    = 2 Gxtyu -4dxt Gyu -4dyu Gxt +2dyt Gxu + 8 dxt dyu
!      -4dxu dyt + 2dxu Gyt
!    SB(tu,yx)=
!    = 2 Gytxu -4dyt Gxu -4dxu Gyt +2dxt Gyu + 8 dyt dxu
!      -4dyu dxt + 2dyu Gxt
!    SBP(tu,xy)=SB(tu,xy)+SB(tu,yx)
!    SBM(tu,xy)=SB(tu,xy)-SB(tu,yx)
            SBtuxy=Two*TG2(IXABS,ITABS,IYABS,IUABS)
            SBtuyx=Two*TG2(IYABS,ITABS,IXABS,IUABS)
            IF(IXABS == ITABS) THEN
              SBtuxy=SBtuxy-Four*TG1(IYABS,IUABS)
              SBtuyx=SBtuyx+Two*TG1(IYABS,IUABS)
              IF(IYABS == IUABS) THEN
                SBtuxy=SBtuxy+Eight*OVL
                SBtuyx=SBtuyx-Four*OVL
              END IF
            END IF
            IF(IYABS == IUABS) THEN
              SBtuxy=SBtuxy-Four*TG1(IXABS,ITABS)
              SBtuyx=SBtuyx+Two*TG1(IXABS,ITABS)
            END IF
            IF(IYABS == ITABS) THEN
              SBtuxy=SBtuxy+Two*TG1(IXABS,IUABS)
              SBtuyx=SBtuyx-Four*TG1(IXABS,IUABS)
              IF(IXABS == IUABS) THEN
                SBtuxy=SBtuxy-Four*OVL
                SBtuyx=SBtuyx+Eight*OVL
              END IF
            END IF
            IF(IXABS == IUABS) THEN
              SBtuxy=SBtuxy+Two*TG1(IYABS,ITABS)
              SBtuyx=SBtuyx-Four*TG1(IYABS,ITABS)
            END IF

            SBM=SBtuxy - SBtuyx

!           HEBLK=HEBLK+SBM*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SBM*SCAL,V1(IAS),NAS,V2(JAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(5)
        NAS1=NAS/2
        DO IAS1=1,NAS1
          IAS2=IAS1+NAS1
          IASABS=NTUES(ISYM)+IAS1
          ITABS=MTU(1,IASABS)
          IUABS=MTU(2,IASABS)
          DO JAS1=1,NAS1
            JAS2=JAS1+NAS1
            JASABS=NTUES(ISYM)+JAS1
            IXABS=MTU(1,JASABS)
            IYABS=MTU(2,JASABS)
! Formulae used:
!    SD11(tu1,xy1)=2*(Gutxy + dtx Guy)
!    SD12(tu2,xy1)= -(Gutxy + dtx Guy)
!    SD21(tu2,xy1)= -(Gutxy + dtx Guy)
!    SD22(tu2,xy2)= -Gxtuy +2*dtx Guy
            GUTXY= TG2(IUABS,ITABS,IXABS,IYABS)
            SD11=Two*GUTXY
            SD12= -GUTXY
            SD21= -GUTXY
            SD22= -TG2(IXABS,ITABS,IUABS,IYABS)
            IF(ITABS == IXABS) THEN
              GUY=TG1(IUABS,IYABS)
              SD11=SD11+Two*GUY
              SD12=SD12 -GUY
              SD21=SD21 -GUY
              SD22=SD22+Two*GUY
            END IF

!           HEBLK=HEBLK+SD11*DDOT_(NISBLK,V2(JAS1),NAS,V1(IAS1),NAS)
!           HEBLK=HEBLK+SD12*DDOT_(NISBLK,V2(JAS2),NAS,V1(IAS1),NAS)
!           HEBLK=HEBLK+SD21*DDOT_(NISBLK,V2(JAS1),NAS,V1(IAS2),NAS)
!           HEBLK=HEBLK+SD22*DDOT_(NISBLK,V2(JAS2),NAS,V1(IAS2),NAS)
            Call DaXpY_(NISBLK,SD11*SCAL,V1(IAS1),NAS,V2(JAS1),NAS)
            Call DaXpY_(NISBLK,SD12*SCAL,V1(IAS1),NAS,V2(JAS2),NAS)
            Call DaXpY_(NISBLK,SD21*SCAL,V1(IAS2),NAS,V2(JAS1),NAS)
            Call DaXpY_(NISBLK,SD22*SCAL,V1(IAS2),NAS,V2(JAS2),NAS)
          END DO
        END DO
************************************************************************
      CASE(6)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
! Formula used: SE(t,x)=2*dxt - Dxt
            SE=-TG1(IXABS,ITABS)
            IF(IXABS == ITABS) SE=SE+Two*OVL
!           HEBLK=HEBLK+SE*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SE*SCAL,V1(IAS),NAS,V2(JAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(7)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
! Formula used: SE(t,x)=2*dxt - Dxt
            SE=-TG1(IXABS,ITABS)
            IF(IXABS == ITABS) SE=SE+Two*OVL
!           HEBLK=HEBLK+SE*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SE*SCAL,V1(IAS),NAS,V2(JAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(8)
! ========================================================
! Compute and use SFP(ITABS IUABS , IXABS IYABS)
! and (later, similar) SFM(ITABS IUABS , IXABS IYABS)
        DO IAS=1,NAS
          IASABS=NTGEUES(ISYM)+IAS
          ITABS=MTGEU(1,IASABS)
          IUABS=MTGEU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGEUES(ISYM)+JAS
            IXABS=MTGEU(1,JASABS)
            IYABS=MTGEU(2,JASABS)
! Formulae used:
!    SF(tu,xy)= 2 Gtxuy
!    SFP(tu,xy)=SF(tu,xy)+SF(tu,yx)
!    SFM(tu,xy)=SF(tu,xy)-SF(tu,yx)
            SFtuxy=Two*TG2(ITABS,IXABS,IUABS,IYABS)
            SFtuyx=Two*TG2(ITABS,IYABS,IUABS,IXABS)

            SFP=SFtuxy + SFtuyx
!           HEBLK=HEBLK+SFP*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SFP*SCAL,V1(IAS),NAS,V2(JAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(9)
! ========================================================
! Compute and use SFM(ITABS IUABS, IXABS ,IYABS)
        DO IAS=1,NAS
          IASABS=NTGTUES(ISYM)+IAS
          ITABS=MTGTU(1,IASABS)
          IUABS=MTGTU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGTUES(ISYM)+JAS
            IXABS=MTGTU(1,JASABS)
            IYABS=MTGTU(2,JASABS)
! Formulae used:
!    SF(tu,xy)= 4 Ptxuy
!    SFP(tu,xy)=SF(tu,xy)+SF(tu,yx)
!    SFM(tu,xy)=SF(tu,xy)-SF(tu,yx)
            SFtuxy=Two*TG2(ITABS,IXABS,IUABS,IYABS)
            SFtuyx=Two*TG2(ITABS,IYABS,IUABS,IXABS)

            SFM=SFtuxy - SFtuyx
!           HEBLK=HEBLK+SFM*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SFM*SCAL,V1(IAS),NAS,V2(JAS),NAS)
          END DO
        END DO
************************************************************************
! CASES GP, GM
! Compute and use SG(ITABS , IXABS) (Same for cases GP and GM)
************************************************************************
      CASE(10)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
! Formula used: SG(t,x)= Gtx
            SG= TG1(ITABS,IXABS)

!           HEBLK=HEBLK+SG*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SG*SCAL,V1(IAS),NAS,V2(JAS),NAS)
!           Do i = 1, NISBLK
!             V2(JAS+NAS*(i-1)) = SG*V1(IAS+NAS*(i-1))
!           End Do
          END DO
        END DO
************************************************************************
      CASE(11)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
! Formula used: SG(t,x)= Gtx
            SG= TG1(ITABS,IXABS)

!           HEBLK=HEBLK+SG*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
            Call DaXpY_(NISBLK,SG*SCAL,V1(IAS),NAS,V2(JAS),NAS)
!           Do i = 1, NISBLK
!             V2(JAS+NAS*(i-1)) = SG*V1(IAS+NAS*(i-1))
!           End Do
          END DO
        END DO
************************************************************************
      CASE(12)
        IF(ABS(OVL) >= 1.0e-12_wp) THEN
!         HEBLK=HEBLK+OVL*DDOT_(NAS*NISBLK,V2,1,V1,1)
        END IF
************************************************************************
      CASE(13)
        IF(ABS(OVL) >= 1.0e-12_wp) THEN
!         HEBLK=HEBLK+OVL*DDOT_(NAS*NISBLK,V2,1,V1,1)
        END IF
************************************************************************
      END SELECT
      Return
      end subroutine MS_STRANS_BLK
!
!-----------------------------------------------------------------------
!
      Subroutine LoadCI_XMS(Bas,Mode,CI,iState,U0)

      use caspt2_global, only: LUCIEX, IDCIEX, IDTCEX
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: IFXMS, IFRMS, NCONF, NSTATE
      use Constants, only: Zero

      implicit none

      character(len=1), intent(in) :: Bas
      integer(kind=iwp), intent(in) :: Mode, iState
      real(kind=wp), intent(inout) :: CI(Nconf)
      real(kind=wp), intent(in) :: U0(nState,nState)

      integer(kind=iwp) :: ID, I
      real(kind=wp),allocatable :: WRK(:)
!
!     MODE=0 is equivalent to LoadCI (XMS basis)
!     MODE=1 constructs the CI vector in CASSCF basis (back-transformed)
!     CSF in natural (Bas=N) or quasi-canonical (Bas=C) orbital basis
!
      If (Bas == 'N' .or. Bas == 'n') Then
        ID = IDCIEX !! natural
      Else If (Bas == 'C' .or. Bas == 'c') Then
        ID = IDTCEX !! quasi-canonical
      ELse
        write (u6,*)'the first argument in LoadCI_XMS should be either',
     &              'N (natural) or C (quasi-canonical)'
        call abend()
      End If

      If (Mode == 0 .or. (.not.IFXMS .and. .not.IFRMS)) Then
        do I = 1, iState-1
          call ddafile(LUCIEX,0,CI,Nconf,ID)
        end do
        call ddafile(LUCIEX,2,CI,Nconf,ID)
      Else If (Mode == 1) Then
        CI(1:nconf) = Zero
        call mma_allocate(WRK,nconf,Label='WRK')
        do I = 1, nState
          call ddafile(LUCIEX,2,WRK,Nconf,ID)
          CI(1:nconf) = CI(1:nconf) + U0(iState,I)*WRK(1:nconf)
        end do
        call mma_deallocate(WRK)
      End If

      End Subroutine LoadCI_XMS
!
!-----------------------------------------------------------------------
!
      Subroutine XMS_Grad(H0,U0,UEFF,OMGDER)

      use caspt2_global, only: do_nac, do_csf, iRoot1, iRoot2,
     &                           CLag,CLagFull,OLag,DPT2_tot,
     &                           FIFA_all,FIFASA_all
      use caspt2_global, only: FIFA, TORB, NDREF
      use caspt2_global, only: CMOPT2, if_equalW, weight
      use gugx, only: SGS
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: ENERGY, IFXMS, IFRMS, IFDW, STSYM, NCONF,
     &                         NFRO, NISH, NASHT, NDEL, NBAS, NBAST,
     &                         NBSQT, NSTATE, ZETA, ORBIN
      use Constants, only: Zero, One, Half, Two, Quart
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif

      implicit none

      real(kind=wp), intent(in) :: H0(nState,nState), U0(nState,nState),
     &                             OMGDER(nState,nState)
      real(kind=wp), intent(inout) :: UEFF(nState,nState)

      real(kind=wp),allocatable :: CI1(:),CI2(:),SGM1(:),SGM2(:),TG1(:),
     &                             TG2(:),DG1(:),DG2(:),DG3(:),G1(:,:),
     &                             RDMEIG(:,:),DPT2(:),Trf(:),
     &                             RDMSA(:,:),WRK1(:),WRK2(:),DPT2_AO(:)

      real(kind=wp) :: SLag(nState*nState), Scal, OVL, EEI, EEJ, fact,
     &  Wgt, TRC, EINACT, EDIFF
      integer(kind=iwp) :: nLev, iStat, jStat, NTG1, NTG3, iState,
     &  kStat, lStat, nOrbI, nBasI, iAsh, jAsh, nCor, I, II
      real(kind=wp), external :: ddot_

      nLev = SGS%nLev
!
!     The XMS rotation applies to any variants: XMS-CASPT2, XDW-CASPT2,
!     and RMS-CASPT2.
!
      If (IFXMS .or. IFRMS) Then
        call mma_allocate(CI1,nConf,Label='CI1')
        call mma_allocate(CI2,nConf,Label='CI2')
        call mma_allocate(SGM1,nConf,Label='SGM1')
        call mma_allocate(SGM2,nConf,Label='SGM2')
        call mma_allocate(TG1,nAshT**2,Label='TG1')
        call mma_allocate(TG2,nAshT**4,Label='TG2')

        call mma_allocate(DG1,nAshT**2,Label='DG1')
        call mma_allocate(DG2,nAshT**4,Label='DG2')

!       ----- Construct pseudo-density matrix -----

        !! First, we need to consider the derivative of the rotation
        !! of the CASSCF energy (Heff[1]).

        !! Forward transformation of UEFF (CASSCF basis to XMS basis)
        !! SLag is used as a working array
        Call DGEMM_('T','N',nState,nState,nState,
     &              One,U0,nState,UEFF,nState,
     &              Zero,SLag,nState)
        Call DCopy_(nState**2,SLag,1,UEFF,1)

        !! Then actual calculation
        CLag(1:nconf,1:nstate) = Zero
        Do iStat = 1, nState
          Call LoadCI_XMS('C',0,CI1,iStat,U0)
          Do jStat = 1, nState
            Call LoadCI_XMS('C',0,CI2,jStat,U0)

            Call Dens2T_RPT2(CI1,CI2,SGM1,SGM2,
     &                       TG1,TG2,nAshT)
            TG1(:) = TG1(:)*Half
            TG2(:) = TG2(:)*Half
            DG1(:) = Zero
            DG2(:) = Zero
            Call CnstInt(1,DG1,DG2)

            If (do_nac) Then
              Scal =(UEFF(iStat,iRoot1)*UEFF(jStat,iRoot2)
     &             + UEFF(jStat,iRoot1)*UEFF(iStat,iRoot2))*Half
            Else
              Scal = UEFF(iStat,iRoot1)*UEFF(jStat,iRoot2)
            End If
!       write (*,*) ' scal in xms'
!       write (*,*) istat,jstat,scal
            if (IFDW .and. zeta >= Zero) then
              scal = scal + OMGDER(iStat,jStat)
            end if
            DG1(:) = DG1(:)*Scal
            DG2(:) = DG2(:)*Scal

            call mma_allocate(DG3,nAshT**6,Label='DG3')
            DG3(:) = Zero

            NTG1 = NASHT**2
            NTG3 = (NTG1*(NTG1+1)*(NTG1+2))/6
            OVL = Zero
            CALL DERTG3(.False.,STSYM,STSYM,CI1,CI2,OVL,
     &                  DG1,DG2,NTG3,DG3,CLag(1,iStat),CLag(1,jStat))
            call mma_deallocate(DG3)
          End Do
        End Do
        call mma_deallocate(SGM2)
        call mma_deallocate(TG2)

        !! Back transformation of UEFF (XMS basis to CASSCF basis)
        !! SLag is used as a working array
        Call DGEMM_('N','N',nState,nState,nState,
     &              One,U0,nState,UEFF,nState,
     &              Zero,SLag,nState)
        Call DCopy_(nState**2,SLag,1,UEFF,1)
!     write (u6,*) 'ueff in casscf basis'
!     call sqprt(ueff,nstate)

        call mma_deallocate(DG1)
        call mma_deallocate(DG2)

      !! Add to the full CI Lagrangian
      !! CLag is in quasi-canonical basis, so transformation
      !! to natural basis is required.
        IF(ORBIN == 'TRANSFOR') Then
          Do iState = 1, nState
            Call CLagX_TrfCI(CLag(1,iState))
          End Do
        End If
        CLagFull(:,:) = CLagFull(:,:) + CLag(:,:)

        !! Compute the Lagrange multiplier for XMS
        !! The diagonal element is always zero.
        !! The code has an additional scaling with 0.5,
        !! because some contributions are doubled.
!     write (*,*) 'istat,jstat,scal'
        SLag(:) = Zero
        Do iStat = 1, nState
          Call LoadCI_XMS('N',0,CI1,iStat,U0)
          EEI = H0(iStat,iStat)
          Do jStat = 1, iStat
            If (iStat == jStat) Then
              SLag(iStat+nState*(jStat-1)) = Zero
            Else
              Call LoadCI_XMS('N',0,CI2,jStat,U0)
              EEJ = H0(jStat,jStat)

              Scal = DDOT_(nConf,CI1,1,CLagFull(1,jStat),1)
     &             - DDOT_(nConf,CI2,1,CLagFull(1,iStat),1)
!      write (*,*) 'original scal = ', scal
              If (do_csf) Then
                !! JCTC 2017, 13, 2561: eq.(66)
                !! iStat and jStat: XMS
                !! kStat and lStat: CASSCF
                fact = Zero
                Do kStat = 1, nState
                  Do lStat = 1, nState
                    fact = fact
     &                   + (UEFF(kStat,iRoot1)*UEFF(lStat,iRoot2)
     &                   -  UEFF(kStat,iRoot2)*UEFF(lStat,iRoot1))*Half
     &                   * U0(kStat,iStat)*U0(lStat,jStat)
                  End Do
                End Do
                Scal = Scal+fact*(ENERGY(iRoot2)-ENERGY(iRoot1))*Two
!      write (*,*) 'scal after= ', scal
!      write (*,*) fact,energy(iroot2)-energy(iroot1)
              End If
              Scal = Quart*Scal/(EEJ-EEI)
!           write (*,*) istat,jstat,scal
              SLag(iStat+nState*(jStat-1)) = Scal
              SLag(jStat+nState*(iStat-1)) = Scal
            End If
          End Do
        End Do

      !! Either subtract the CI derivative of Heff(1)
      !! or add off-diagonal couplings in rhs_sa (Z-vector)
      !CLagFull = CLagFull - CLag

        !! Finally, construct the pseudo-density matrix
        !! d = \sum_{ST} w_{ST} * d_{ST}
        call mma_allocate(G1,nAshT,nAshT,Label='G1')
        G1(:,:) = Zero
        Do iStat = 1, nState
          Call LoadCI_XMS('C',0,CI1,iStat,U0)
          Do jStat = 1, nState
            If (ABS(SLag(iStat+nState*(jStat-1))) <= 1.0e-10_wp) Cycle
            Call LoadCI_XMS('C',0,CI2,jStat,U0)

            Call Dens1T_RPT2(CI1,CI2,
     &                       SGM1,TG1,nLev)
            Scal = SLag(iStat+nState*(jStat-1))*Two
!         write (*,*) 'istat,jstat=',istat,jstat
!         write (*,*) 'scal = ', scal
            Call DaXpY_(nAshT**2,Scal,TG1,1,G1,1)
          End Do
        End Do
!     write (*,*) 'G1'
!     call sqprt(G1,nasht)

        call mma_deallocate(CI1)
        call mma_deallocate(CI2)
        call mma_deallocate(SGM1)
        call mma_deallocate(TG1)
!
!       ----- Calculate orbital derivatives -----
!
        call mma_allocate(RDMEIG,nAshT,nAshT,Label='RDMEIG')
        call mma_allocate(DPT2,NBSQT,Label='DPT2')
        DPT2(:) = Zero

        call mma_allocate(Trf,NBSQT,Label='TRFMAT')
        call mma_allocate(RDMSA,nAshT,nAshT,Label='RDMSA')
        call mma_allocate(WRK1,NBSQT,Label='WRK1')
        call mma_allocate(WRK2,NBSQT,Label='WRK2')

        !! Construct always state-averaged density; XMS basis is always
        !! generated with the equally-averaged density.
        WRK1(1:nDRef) = Zero
        call mma_allocate(CI1,nConf,Label='CI1')
        Wgt  = One/nState
        Do iState = 1, nState
          Call LoadCI(CI1,iState)
          call POLY1(CI1,nConf)
          call GETDREF(WRK2,nDRef)
          WRK1(1:nDRef) = WRK1(1:nDRef) + Wgt*WRK2(1:nDRef)
        End Do
        call mma_deallocate(CI1)
        Call SQUARE(WRK1,RDMSA,1,nAshT,nAshT)

        nOrbI = nBas(1) - nDel(1) !! nOrb(1)
        nBasI = nBas(1)
!       Call SQUARE(FIFA,FIFA_all,1,nOrbI,nOrbI)
        !! FIFASA_all is in natural orbital basis
        Trf(1:NBSQT) = Zero
        Call CnstTrf(TOrb,Trf)

        !! FIFA: natural -> quasi-canonical
        If (IFDW .or. IFRMS) Then
          Call DGemm_('T','N',nOrbI,nOrbI,nOrbI,
     &                One,Trf,nBasI,FIFASA_all,nOrbI,
     &                Zero,WRK1,nOrbI)
          Call DGemm_('N','N',nOrbI,nOrbI,nOrbI,
     &                One,WRK1,nOrbI,Trf,nBasI,
     &                Zero,FIFASA_all,nOrbI)
        End If
!       Call DCopy_(NBSQT,FIFASA_all,1,FIFA_all,1)
        FIFA_all(1:NBSQT) = FIFASA_all(1:NBSQT)

        !! Orbital derivatives of FIFA
        !! Both explicit and implicit orbital derivatives are computed
        !! Also, compute G(D) and put the active contribution to RDMEIG
        OLag(:) = Zero
        Call EigDer2(RDMEIG,Trf,FIFA_all,RDMSA,G1,WRK1,WRK2)

        !! Add to PT2 density
        !! No inactive contributions. Correct as long as CASSCF CI
        !! vector are orthogonal.
        Call AddDEPSA(DPT2,G1)
        Call DPT2_TrfStore(One,DPT2,DPT2_tot,Trf,WRK1)

        !! Finalize OLag (anti-symetrize) and construct WLag
        Call OLagFinal(OLag,Trf)

        If (.not.if_equalW) then
          call mma_allocate(DPT2_AO,NBSQT,Label='DPT2_AO')

          !! AddDEPSA considers the frozen orbital, whereas DPT2_Trf
          !! does not. In any case, construct DPT2 again.
          DPT2(:) = Zero
          CALL DPT2_Trf(DPT2,DPT2_AO,CMOPT2,G1,WRK1)
          !! Construct the SCF density
          WRK1(1:nDRef) = Zero
          call mma_allocate(CI1,nConf,Label='CI1')
          Do iState = 1, nState
            Call LoadCI_XMS('N',1,CI1,iState,U0)
            call POLY1(CI1,nConf)
            call GETDREF(WRK2,nDRef)
            wgt = Weight(iState)
            WRK1(1:nDRef) = WRK1(1:nDRef) + Wgt*WRK2(1:nDRef)
          End Do
          call mma_deallocate(CI1)
          !! WRK2 is the SCF density (for nstate=nroots)
          Call SQUARE(WRK1,WRK2,1,nAshT,nAshT)
          Call DaXpY_(nAshT**2,-One,WRK2,1,RDMSA,1)
          !! Construct the SS minus SA density matrix in WRK1
          Call OLagFroD(WRK1,WRK2,RDMSA,Trf)
          !! Subtract the inactive part
          Call DaXpY_(nBasT**2,-One,WRK2,1,WRK1,1)
          !! Save
          Call CnstAB_SSDM(DPT2_AO,WRK1)
          call mma_deallocate(DPT2_AO)
        End If

        call mma_deallocate(RDMSA)
        call mma_deallocate(WRK1)
        call mma_deallocate(WRK2)

        call mma_deallocate(DPT2)
!
!       ----- Calculate CI derivatives -----
!
        !! use quasi-canonical CSF rather than natural CSF
!     ISAV = IDCIEX
!     IDCIEX = IDTCEX
        CLag(:,:) = Zero

        !! 1) Explicit CI derivative
        !! a: Extract FIFA in the AS for explicit CI derivative
        !!    Note that this FIFA uses state-averaged density matrix
!       call sqprt(fifa_all,nbast)
        Do iAsh = 1, nAshT
          Do jAsh = 1, nAshT
            G1(iAsh,jAsh) = FIFA_all( nFro(1)
     &          + nIsh(1) + iAsh + nBas(1)*(nFro(1)+nIsh(1)+jAsh-1))
          End Do
        End Do
!       call sqprt(g1),nasht)
        !! Transform quasi-canonical to natural
        nCor = nFro(1)+nIsh(1)
!     write (*,*) nfro(1),nish(1)
!     call sqprt(trf,nbast)
        Call DGemm_('N','N',nAshT,nAshT,nAshT,
     &              One,Trf(1+nBasT*nCor+nCor),nBasT,G1,nAshT,
     &              Zero,FIFA_all,nAshT)
!     call sqprt(FIFA_all,nasht)
        Call DGemm_('N','T',nAshT,nAshT,nAshT,
     &              One,FIFA_all,nAshT,Trf(1+nBasT*nCor+nCor),nBasT,
     &              Zero,G1,nAshT)
!     call sqprt(g1,nasht)
        Call DGemm_('N','N',nAshT,nAshT,nAshT,
     &              One,Trf(1+nBasT*nCor+nCor),nBasT,RDMEIG,nAshT,
     &              Zero,FIFA_all,nAshT)
        Call DGemm_('N','T',nAshT,nAshT,nAshT,
     &              One,FIFA_all,nAshT,Trf(1+nBasT*nCor+nCor),nBasT,
     &              Zero,RDMEIG,nAshT)
        call mma_deallocate(Trf)

        !! b: FIFA in the inactive space
        TRC=Zero
!     DO ISYM=1,NSYM
        DO I=1,NISH(1) ! ISYM)
!         II=IOFF(ISYM)+(I*(I+1))/2
          II=(I*(I+1))/2
          TRC=TRC+FIFA(II)
        END DO
!     END DO
* Contribution from inactive orbitals:
        EINACT=Two*TRC
        !! This EINACT may be wrong. Perhaps, FIFA has to be
        !! back-transformed to natural orbital basis. However, this does
        !! not contribute to the final gradient as long as all the
        !! (internal) CI vectors are orthogonal.

        !! c: Finally, compute explicit CI derivative
        !! y_{I,T} = w_{ST} <I|f|S>
        !! Here, G1 is FIFA = ftu
        Call CLagEigT(CLag,G1,SLag,EINACT)

        !! 2) Implicit CI derivative
        Call CLagEig(.False.,.True.,CLag,RDMEIG,nLev)

#ifdef _MOLCAS_MPP_
        if (is_real_par()) then
          call GADSUM(CLag,nConf*nState)
        end if
#endif

        call mma_deallocate(RDMEIG)
        call mma_deallocate(G1)

      End If

      If (do_csf) Then
        !! Eq (68)
        !! I think this contributes even in XMS-CASPT2.
        !! However, maybe I implemented other terms in a different way
        !! from BAGEL.
        call mma_allocate(CI1,nConf,Label='CI1')
        !! Do in the natural orbital in the XMS basis
        !! because CLag is like that
        !! CASSCF -> XMS
        Call DGEMM_('T','N',nState,nState,nState,
     &              One,U0,nState,UEFF,nState,
     &              Zero,SLag,nState)
        Call DCopy_(nState**2,SLag,1,UEFF,1)

        EDIFF = ENERGY(iRoot2)-ENERGY(iRoot1)
        Do iStat = 1, nState
          Call LoadCI_XMS('N',0,CI1,iStat,U0)
          Do jStat = 1, nState
            Scal = (UEFF(iStat,iRoot1)*UEFF(jStat,iRoot2)
     &           -  UEFF(iStat,iRoot2)*UEFF(jStat,iRoot1))*Half
            Scal = Scal * EDIFF
            Call DaXpY_(nConf,Scal,CI1,1,CLag(1,jStat),1)
          End Do
        End Do

        !! XMS -> CASSCF
        Call DGEMM_('N','N',nState,nState,nState,
     &              One,U0,nState,UEFF,nState,
     &              Zero,SLag,nState)
        Call DCopy_(nState**2,SLag,1,UEFF,1)

        call mma_deallocate(CI1)
      End If

      !! Finally, add to the total CI derivative array
      CLagFull(:,:) = CLagFull(:,:) + CLag(:,:)
!     IDCIEX = ISAV

      End Subroutine XMS_Grad
!
!-----------------------------------------------------------------------
!
      !! From poly3
      SUBROUTINE CLagEigT(CLag,RDMEIG,SLag,EINACT)

      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: NCONF, ISCF, NSTATE
      use Constants, only: One, Two
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: nProcs, Is_Real_Par
#endif

      implicit none

      real(kind=wp), intent(inout) :: CLag(nConf,nState)
      real(kind=wp), intent(in) :: RDMEIG(*), SLag(*), EINACT

      real(kind=wp),allocatable :: CI1(:),CI2(:)
      real(kind=wp) :: Scal
      integer(kind=iwp) :: iStat, jStat

      !! RDMEIG
      call mma_allocate(CI1,nConf,Label='CI1')
      call mma_allocate(CI2,nConf,Label='CI2')
      Do iStat = 1, nState
        If (ISCF == 0) Then
          Call LoadCI(CI1,iStat)
        Else
          CI1(1) = One
        End If
        !! Skip iStat = jStat because SLag is zero
        Do jStat = 1, nState !! iStat-1
          If (ISCF == 0) Then
            Call LoadCI(CI2,jStat)
          Else
            CI2(1) = One
          End If
          !! One of doubling is due to the scaling factor
          !! One of doubling is due to the symmetry of iStat and jStat
!         Scal = SLag(iStat+nState*(jStat-1))*4.0d+00
          Scal = SLag(iStat+nState*(jStat-1))*Two
          If (ABS(Scal) <= 1.0e-09_wp) Cycle

          Call Poly1_CLagT(CI1,CI2,
     &                     CLag(1,iStat),CLag(1,jStat),RDMEIG,Scal)
          !! Inactive terms
#ifdef _MOLCAS_MPP_
          !! The inactive contributions are computed in all processes,
          !! whereas GADSUM will be done later, so divide
          if (is_real_par()) Scal = Scal/real(nProcs,kind=wp)
#endif
          CLag(1:nconf,jStat) = CLag(1:nconf,jStat)
     &      + Scal*EINACT*CI1(1:nconf)
          CLag(1:nconf,iStat) = CLag(1:nconf,iStat)
     &      + Scal*EINACT*CI2(1:nconf)
        End Do
      End Do

      call mma_deallocate(CI1)
      call mma_deallocate(CI2)

      Return

      End Subroutine CLagEigT
!
!-----------------------------------------------------------------------
!
      SUBROUTINE POLY1_CLagT(CI1,CI2,CLag1,CLag2,RDMEIG,Scal)
      use gugx, only: SGS
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: nConf
      use pt2_guga, only: MxCI, iAdr10, cLab10

      IMPLICIT NONE
* PER-AAKE MALMQUIST, 92-12-07
* THIS PROGRAM CALCULATES THE 1-EL DENSITY
* MATRIX FOR A CASSCF WAVE FUNCTION.

      real(kind=wp), intent(in) :: CI1(NCONF), CI2(NCONF), RDMEIG(*),
     &                             Scal
      real(kind=wp), intent(inout) :: CLag1(*), CLag2(*)

      real(kind=wp),allocatable :: SGM1(:)
      integer(kind=iwp) :: nLev, I

      nLev = SGS%nLev

      IF(NLEV > 0) THEN
        call mma_allocate(SGM1,MXCI,Label='SGM1')
        CALL DENS1T_RPT2_CLag(CI1,CI2,SGM1,
     &                        CLag1,CLag2,RDMEIG,Scal,nLev)
      END IF

* REINITIALIZE USE OF DMAT.
* The fields IADR10 and CLAB10 are kept in pt2_guga.F90
* CLAB10 replaces older field called LABEL.
      DO I=1,64
        IADR10(I,1)=-1
        IADR10(I,2)=0
        CLAB10(I)='   EMPTY'
      END DO
      IADR10(1,1)=0
* HENCEFORTH, THE CALL PUT(NSIZE,LABEL,ARRAY) WILL ENTER AN
* ARRAY ON LUDMAT AND UPDATE THE TOC.
      IF(NLEV > 0) THEN
        call mma_deallocate(SGM1)
      END IF

      RETURN
      end subroutine POLY1_CLagT
!
!-----------------------------------------------------------------------
!
      SUBROUTINE DENS1T_RPT2_CLag(CI1,CI2,SGM1,CLag1,CLag2,RDMEIG,SCAL,
     &                            nLev)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
#endif
      use Symmetry_Info, only: Mul
      use gugx, only: SGS, L2ACT, CIS
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: nConf, STSym
      use pt2_guga, only: MxCI

      IMPLICIT NONE

      integer(kind=iwp), intent(in) :: nLev
      real(kind=wp), intent(in) :: CI1(MXCI), CI2(MXCI),
     &                             RDMEIG(NLEV,NLEV), SCAL
      real(kind=wp), intent(inout) :: SGM1(MXCI), CLag1(nConf),
     &                                CLag2(nConf)

      integer(kind=iwp),allocatable :: TASK(:,:)

      logical(kind=iwp), external :: RSV_TSK
      integer(kind=iwp) :: ID, IST, ISU, ISTU, IT, IU, LT, LU, ITASK,
     &                     NTASKS, ISSG, NSGM

* Purpose: Compute the 1-electron density matrix array G1.

* For the general cases, we use actual CI routine calls, and
* have to take account of orbital order.
* We will use level inices LT,LU... in these calls, but produce
* the density matrices with usual active orbital indices.
* Translation tables L2ACT and LEVEL, in pt2_guga.F90

* SVC20100311: set up a task table with LT,LU
* SB20190319: maybe it doesn't even make sense to parallelize the 1-RDM
      nTasks=(nLev**2+nLev)/2
      nTasks = nLev**2
      CALL mma_allocate (Task,nTasks,2,Label='TASK')

      iTask=0
      ! First, IL < JL pairs.
      Do LT = 1, nLev-1
        Do LU = LT+1, nLev
          iTask = iTask + 1
          TASK(iTask,1)=LT
          TASK(iTask,2)=LU
        End Do
      End Do
      ! Then, IL = JL pairs.
      Do LT = 1, nLev
        iTask = iTask + 1
        TASK(iTask,1)=LT
        TASK(iTask,2)=LT
      End Do
      ! Last, IL > JL pairs.
      Do LT = 2, nLev
        Do LU = 1, LT-1
          iTask = iTask + 1
          TASK(iTask,1)=LT
          TASK(iTask,2)=LU
        End Do
      End Do
      IF (iTask /= nTasks) WRITE(u6,*) 'ERROR nTasks'

      Call Init_Tsk(ID, nTasks)

* SVC20100311: BEGIN SEPARATE TASK EXECUTION
      do while (Rsv_Tsk(ID,iTask))
* Compute SGM1 = E_UT acting on CI, with T.ge.U,
* i.e., lowering operations. These are allowed in RAS.
        LT=TASK(iTask,1)
        IST=SGS%ISM(LT)
        IT=L2ACT(LT)
        LU=Task(iTask,2)
        ! LTU=iTask
        ISU=SGS%ISM(LU)
        IU=L2ACT(LU)
        ISTU=Mul(IST,ISU)
        ISSG=Mul(ISTU,STSYM)
        NSGM=CIS%NCSF(ISSG)
        IF(NSGM == 0) cycle
* GETSGM2 computes E_UT acting on CI and saves it on SGM1
        IF(ISTU == 1) THEN
          CALL GETSGM2(LU,LT,STSYM,CI1,SGM1)
          CLag2(1:NSGM) = CLag2(1:NSGM)
     &      + SCAL*RDMEIG(IT,IU)*SGM1(1:NSGM)
          CALL GETSGM2(LU,LT,STSYM,CI2,SGM1)
          CLag1(1:NSGM) = CLag1(1:NSGM)
     &      + SCAL*RDMEIG(IT,IU)*SGM1(1:NSGM)
        END IF
* SVC: The master node now continues to only handle task scheduling,
*      needed to achieve better load balancing. So it exits from the task
*      list. It has to do it here since each process gets at least one
*      task.
      end do
      CALL Free_Tsk(ID)
      CALL mma_deallocate(Task)

      end subroutine DENS1T_RPT2_CLag
!
!-----------------------------------------------------------------------
!
      Subroutine CnstInt(Mode,INT1,INT2)

      Use CHOVEC_IO, only: NVLOC_CHOBATCH
      use caspt2_global, only: FIMO_all
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: iwp,wp
      use caspt2_module, only: IfChol, NSYM, NFRO, NISH, NASH, NASHT,
     &                         NBAS, NBAST, NBSQT, NBTCH, NBTCHES
!     use caspt2_module, only: NSSH
      use Constants, only: Zero, One, Half
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif

      implicit none

      integer(kind=iwp), intent(in) :: Mode
      real(kind=wp), intent(out) :: INT1(nAshT,nAshT),
     &                              INT2(nAshT,nAshT,nAshT,nAshT)

      integer(kind=iwp),allocatable :: BGRP(:,:)
      real(kind=wp),allocatable :: WRK1(:),WRK2(:),KET(:)

      integer(kind=iwp), parameter :: Inactive=1, Active=2, Virtual=3
      integer(kind=iwp) ::  iSym, nFroI, nIshI, nCorI, nBasI,
     &  iAshI, jAshI, iSymA, iSymI, iSymB, iSymJ, JSYM, IB, IB1, IB2,
     &  MXBGRP, IBGRP, NBGRP, NCHOBUF, MXPIQK, NADDBUF, IBSTA, IBEND,
     &  NV, nKET, kAshI, lAshI, iT, iU, iTU, iV, iX, iVX, iOrb, jOrb
!     integer(kind=iwp) :: nSh(8,3)
      real(kind=wp) :: Val, SCAL

      INT1(:,:) = Zero
      Int2(:,:,:,:) = Zero

      iSym=1
      nFroI = nFro(iSym)
      nIshI = nIsh(iSym)
      nCorI = nFroI+nIshI
      nBasI = nBas(iSym)
      ! nOrbI = nOrb(iSym)

      call mma_allocate(WRK1,NBSQT,Label='WRK1')
      call mma_allocate(WRK2,NBSQT,Label='WRK2')
!
!     --- One-Electron Integral
!
      !! Read H_{\mu \nu}
      Do iAshI = 1, nAsh(iSym)
        Do jAshI = 1, nAsh(iSym)
          Val = FIMO_all(nCorI+iAshI+nBasI*(nCorI+jAshI-1))
          INT1(iAshI,jAshI) = INT1(iAshI,jAshI) + Val
        End Do
      End Do
!
!     --- Two-Electron Integral
!
      iSymA = 1
      iSymI = 1
      iSymB = 1
      iSymJ = 1

      If (IfChol) Then
!       nSh(1:nSym,Inactive) = NISH(1:nSym)
!       nSh(1:nSym,Active  ) = NASH(1:nSym)
!       nSh(1:nSym,Virtual ) = NSSH(1:nSym)
        DO JSYM=1,NSYM
          IB1=NBTCHES(JSYM)+1
          IB2=NBTCHES(JSYM)+NBTCH(JSYM)

          MXBGRP=IB2-IB1+1
          IF (MXBGRP <= 0) CYCLE
          call mma_allocate(BGRP,2,MXBGRP,Label='BGRP')
          IBGRP=1
          DO IB=IB1,IB2
           BGRP(1,IBGRP) = IB
           BGRP(2,IBGRP) = IB
           IBGRP=IBGRP+1
          END DO
          NBGRP=MXBGRP

          CALL MEMORY_ESTIMATE(JSYM,BGRP,NBGRP,
     &                         NCHOBUF,MXPIQK,NADDBUF)
          call mma_allocate(KET,NCHOBUF,Label='KETBUF')
          Do IBGRP=1,NBGRP

            IBSTA=BGRP(1,IBGRP)
            IBEND=BGRP(2,IBGRP)

            NV=0
            DO IB=IBSTA,IBEND
              NV=NV+NVLOC_CHOBATCH(IB)
            END DO

            !! int2(tuvx) = (tu|vx)/2
            !! This can be computed without frozen orbitals
            Call Get_Cholesky_Vectors(Active,Active,JSYM,
     &                                KET,nKet,
     &                                IBSTA,IBEND)

            If (IBGRP == 1) SCAL = Zero
            If (IBGRP /= 1) SCAL = One
            Call DGEMM_('N','T',NASH(JSYM)**2,NASH(JSYM)**2,NV,
     &                  Half,KET,NASH(JSYM)**2,KET,NASH(JSYM)**2,
     &                  SCAL   ,INT2,NASH(JSYM)**2)
          End Do
          call mma_deallocate(KET)
          call mma_deallocate(BGRP)
        End Do
      Else
        Do iAshI = 1, nAsh(iSym)
          iOrb = nCorI+iAshI
          Do jAshI = 1, nAsh(iSym)
            jOrb = nCorI+jAshI

            Call Coul(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,WRK1,WRK2)
            !! Put in INT2
            Do kAshI = 1, nAsh(iSym)
              Do lAshI = 1, nAsh(iSym)
                INT2(iAshI,jAshI,kAshI,lAshI)
     &        = INT2(iAshI,jAshI,kAshI,lAshI)
     &        + WRK1(nCorI+kAshI+nBasT*(nCorI+lAshI-1))*Half
              End Do
            End Do
          End Do
        End Do
      End If
      call mma_deallocate(WRK1)
      call mma_deallocate(WRK2)
      If (Mode == 0) Then
      Do IT = 1, nAshT
        Do iU = 1, nAshT
          iTU = iT + nAshT*(iU-1)
          Do iV = 1, nAshT
            Do iX = 1, nAshT
              iVX = iV + nAshT*(iX-1)
              If (iVX > iTU) Then
               INT2(iT,iU,iV,IX) = INT2(iT,iU,iV,iX) + INT2(iV,iX,iT,iU)
               INT2(iV,iX,iT,iU) = Zero
              End If
            End Do
          End Do
        End Do
      End Do
      End If

#ifdef _MOLCAS_MPP_
      if (is_real_par()) CALL GADSUM (INT2,nAshT**4)
#endif

      Return

      End Subroutine CnstInt
!
!-----------------------------------------------------------------------
!
      Subroutine CnstAntiC(DPT2Canti,UEFF,U0)

      use caspt2_global, only: iRoot1, iRoot2, OLagFull
      use gugx, only: SGS
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: ENERGY, NSYM, NCONF, NFRO, NISH, NASH,
     &                         NASHT, NDEL, NORB, NBAS, NBAST, NBSQT,
     &                         NSTATE
      use Constants, only: Zero, Half

      implicit none

      real(kind=wp), intent(inout) :: DPT2Canti(*)
      real(kind=wp), intent(in) :: UEFF(nState,nState), U0(*)

      real(kind=wp),allocatable :: CI1(:),CI2(:),SGM1(:),SGM2(:),TG1(:),
     &                             G1(:,:),WRK1(:),WRK2(:)
      integer(kind=iwp) :: nLev, iStat, jStat, iMO1, iMO2, iSym, nOrbI1,
     &  nOrbI2, iOrb0, iOrb2, jOrb0, jOrb2, i, j
      real(kind=wp) :: Scal

      nLev = SGS%nLev

      call mma_allocate(CI1,nConf,Label='CI1')
      call mma_allocate(CI2,nConf,Label='CI2')
      call mma_allocate(SGM1,nConf,Label='SGM1')
      call mma_allocate(SGM2,nConf,Label='SGM2')
      call mma_allocate(TG1,nAshT**2,Label='TG1')
      call mma_allocate(G1,nAshT,nAshT,Label='G1')

      G1(:,:) = Zero
      Do iStat = 1, nState
        !! UEFF is in the CASSCF basis, so the CI coefficient
        !! has to be transformed(-back) accordingly
        Call LoadCI_XMS('N',1,CI1,iStat,U0)
        Do jStat = 1, nState
          If (iStat == jStat) Cycle
          Call LoadCI_XMS('N',1,CI2,jStat,U0)

          Call Dens1T_RPT2(CI1,CI2,SGM1,TG1,nLev)
          Scal = UEFF(iStat,iRoot2)*UEFF(jStat,iRoot1)
     &         - UEFF(jStat,iRoot2)*UEFF(iStat,iRoot1)
          Scal = Scal*Half
!         write (*,*) istat,jstat,scal
!         call sqprt(tg1,5)
          Call DaXpY_(nAshT**2,Scal,TG1,1,G1,1)
        End Do
      End Do
!     call sqprt(g1,5)

      call mma_deallocate(CI1)
      call mma_deallocate(CI2)
      call mma_deallocate(SGM1)
      call mma_deallocate(SGM2)
      call mma_deallocate(TG1)

      !! The DPT2Canti computed so far has been doubled
      DPT2Canti(1:nBasT**2) = DPT2Canti(1:nBasT**2)*Half

      iMO1 = 1
      iMO2 = 1
      DO iSym = 1, nSym
        nOrbI1 = nOrb(iSym)
        nOrbI2 = nBas(iSym)-nDel(iSym)
        If (nOrbI2 > 0) Then
          !! Add active orbital density
          !! Probably incorrect if symmetry
          Do iOrb0 = 1, nAsh(iSym)
            ! iOrb1 = nIsh(iSym)+iOrb0
            iOrb2 = nFro(iSym)+nIsh(iSym)+iOrb0
            Do jOrb0 = 1, nAsh(iSym)
              ! jOrb1 = nIsh(iSym)+jOrb0
              jOrb2 = nFro(iSym)+nIsh(iSym)+jOrb0
              DPT2Canti(iMO2+iOrb2-1+nOrbI2*(jOrb2-1))
     &          = DPT2Canti(iMO2+iOrb2-1+nOrbI2*(jOrb2-1))
     &          + G1(iOrb0,jOrb0)
            End Do
          End Do
        END IF
        iMO1 = iMO1 + nOrbI1*nOrbI1
        iMO2 = iMO2 + nOrbI2*nOrbI2
      End Do
!     write (*,*) 'dpt2anti after'
!     call sqprt(dpt2canti,nbast)

      call mma_deallocate(G1)

      !! Add orbital response
      call mma_allocate(WRK1,NBSQT,Label='WRK1')
      call mma_allocate(WRK2,NBSQT,Label='WRK2')

      !! Scale with the CASPT2 energy difference
      Scal = ENERGY(iRoot2)-ENERGY(iRoot1)
      WRK1(1:nBasT**2) = Scal*DPT2Canti(1:nBasT**2)
      !! anti-symmetrize the orbital response
      Call DGeSub(WRK1,nBas(1),'N',
     &            WRK1,nBas(1),'T',
     &            WRK2,nBas(1),
     &            nBas(1),nBas(1))
!      write (*,*) 'wrk1'
!      call sqprt(wrk),nbast)

      !! Probably, the way CSF term is computed in MOLCAS is different
      !! from in BAGEL; see Eqs.(51)--(53). In the active space, i.e.
      !! for SA-CASSCF, the orbital response in the active space cancel
      !! (see JCP 2004, 120, 7322), but not in off-diagonal blocks.
      !! The way MOLCAS computes adds more than the one BAGEL does, so
      !! the orbital response has to be subtracted?
      OLagFull(1:nBasT**2) = OLagFull(1:nBasT**2) - WRK1(1:nBasT**2)

      call mma_deallocate(WRK1)
      call mma_deallocate(WRK2)

      !! S[x]^A:D = S[x]:D^A, according to alaska_util/csfgrad.f
      !! so antisymmetrize D
      Do i = 1, nBasT
        Do j = 1, i-1
          Scal = DPT2Canti(i+nBasT*(j-1))
     &         - DPT2Canti(j+nBasT*(i-1))
          DPT2Canti(i+nBasT*(j-1)) =  Scal*Half
          DPT2Canti(j+nBasT*(i-1)) = -Scal*Half
        End Do
      End Do
!     write (*,*) 'dpt2anti sym'
!     call sqprt(dpt2canti,nbast)
!     write (*,*) 'dpt2c'
!     call sqprt(dpt2c_tot,nbast)

      Return

      End Subroutine CnstAntiC
!
!-----------------------------------------------------------------------
!
      SUBROUTINE DENS1T_RPT2 (CI1,CI2,SGM1,G1,NLEV)

      use Symmetry_Info, only: Mul
      use caspt2_global, only:iPrGlb
      use gugx, only: SGS, L2ACT, CIS
      use PrintLevel, only: DEBUG
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: iSCF, nActEl, nAshT, STSym
      use pt2_guga, only: MxCI, nG1
      use Constants, only: Zero, One, Two

      IMPLICIT NONE

      integer(kind=iwp), intent(in):: nLev
      real(kind=wp), intent(in) :: CI1(MXCI), CI2(MXCI)
      real(kind=wp), intent(out) :: SGM1(MXCI), G1(NLEV,NLEV)

      integer(kind=iwp), allocatable :: TASK(:,:)

      integer(kind=iwp) :: ID, IST, ISU, ISTU, IT, IU, LT, LU, ITASK,
     &  NTASKS, ISSG, NSGM
      real(kind=wp) :: GTU

      logical(kind=iwp), external :: RSV_TSK
      real(kind=wp), external :: ddot_, dnrm2_

! Purpose: Compute the 1- and 2-electron density matrix
! arrays G1 and G2.
      G1(:,:) = Zero

! For the special cases, there is no actual CI-routines involved:
! Special code for hi-spin case:
      IF(ISCF == 2) THEN
        DO IT = 1, NASHT
          G1(IT,IT) = One
        END DO
      else if (ISCF == 1 .and. NACTEL > 0) then
! Special code for closed-shell:
        DO IT = 1, NASHT
          G1(IT,IT) = Two
        END DO
      else

* For the general cases, we use actual CI routine calls, and
* have to take account of orbital order.
* We will use level inices LT,LU... in these calls, but produce
* the density matrices with usual active orbital indices.
* Translation tables L2ACT and LEVEL, in pt2_guga.F90

!-SVC20100311: set up a task table with LT,LU
        nTasks=(nLev**2+nLev)/2
        nTasks= nLev**2
        CALL mma_allocate (Task,nTasks,2,Label='TASK')

        iTask=0
        DO LT=1,nLev
          DO LU=1,nLev!LT
            iTask=iTask+1
            TASK(iTask,1)=LT
            TASK(iTask,2)=LU
          ENDDO
        ENDDO
        IF (iTask /= nTasks) WRITE(u6,*) 'ERROR nTasks'

        Call Init_Tsk(ID, nTasks)

!-SVC20100311: BEGIN SEPARATE TASK EXECUTION
        do while (Rsv_Tsk(ID,iTask))
* Compute SGM1 = E_UT acting on CI, with T.ge.U,
* i.e., lowering operations. These are allowed in RAS.
!         LTU=0
!         DO LT=1,NLEV
          LT=TASK(iTask,1)
          IST=SGS%ISM(LT)
          IT=L2ACT(LT)
!         DO LU=1,LT
          LU=Task(iTask,2)
!         LTU=LTU+1
          ! LTU=iTask
          ISU=SGS%ISM(LU)
          IU=L2ACT(LU)
          ISTU=Mul(IST,ISU)
          ISSG=Mul(ISTU,STSYM)
          NSGM=CIS%NCSF(ISSG)
          IF(NSGM == 0) cycle
          CALL GETSGM2(LU,LT,STSYM,CI1,SGM1)
          IF(ISTU == 1) THEN
            GTU=DDOT_(NSGM,CI2,1,SGM1,1)
            G1(IT,IU)=G1(IT,IU)+GTU
          END IF

!SVC: The master node now continues to only handle task scheduling,
!     needed to achieve better load balancing. So it exits from the task
!     list.  It has to do it here since each process gets at least one
!     task.
        end do
        CALL Free_Tsk(ID)
        CALL mma_deallocate(Task)
        CALL GAdSUM (G1,NG1)
      end if

      IF(iPrGlb >= DEBUG) THEN
        WRITE(u6,'("DEBUG> ",A)')
     &   'DENS1_RPT2: norms of the density matrices:'
        WRITE(u6,'("DEBUG> ",A,1X,ES21.14)') 'G1:', DNRM2_(NG1,G1,1)
      ENDIF

      end subroutine DENS1T_RPT2
!
!-----------------------------------------------------------------------
!
      Subroutine DWDER(OMGDER,HEFF,SLag)

      use definitions, only: wp, iwp
      use caspt2_module, only: NSTATE, DWTYPE, ZETA
      use Constants, only: Zero, Two, Half

      implicit none

      real(kind=wp), intent(in) :: OMGDER(nState,nState),
     &  HEFF(nState,nState)
      real(kind=wp), intent(inout) :: SLag(nState,nState)

      integer(kind=iwp) :: ilStat, jlStat, klStat
      real(kind=wp) :: Ebeta, Ealpha, Factor, Egamma, Dag, Hag, DEROMG,
     &  Scal, DERAB, DERAC, Dbg, Hbg
!
!     Computes the derivative of weight factor in XDW-CASPT2
!
      Do ilStat = 1, nState
        Ebeta = HEFF(ilStat,ilStat)
        Do jlStat = 1, nState
          Ealpha = HEFF(jlStat,jlStat)

          Factor = Zero
          Do klStat = 1, nState
            Egamma = HEFF(klStat,klStat)
            If (DWType == 1) Then
              Factor = Factor + exp(-zeta*(Ealpha - Egamma)**2)
            Else If (DWType == 2) Then
              Factor = Factor
     &          + exp(-zeta*(Ealpha/HEFF(jlStat,klStat))**2)
            Else If (DWType == 3) Then
              Dag = abs(Ealpha - Egamma) + 1.0e-9_wp
              Hag = abs(HEFF(jlStat,klStat))
              Factor = Factor
     &          + exp(-zeta*Dag/(sqrt(Hag)+tiny(Hag)))
            End If
          End Do

          DEROMG = OMGDER(ilStat,jlStat)

          !! derivative of alpha-beta
          If (DWType == 1) Then
            DERAB = EXP(-ZETA*(Ealpha-Ebeta)**2)/Factor
            Scal = -Two*ZETA*DERAB*(Ealpha-Ebeta)*DEROMG
            SLag(jlStat,jlStat) = SLag(jlStat,jlStat) + Scal
            SLag(ilStat,ilStat) = SLag(ilStat,ilStat) - Scal
          Else If (DWType == 2) Then
            DERAB = EXP(-ZETA*(Ealpha/HEFF(jlStat,ilStat))**2)/Factor
            DERAB = DERAB*Two*DEROMG*ZETA
     &            *(Ealpha/HEFF(jlStat,ilStat))**2
            Scal  = -DERAB/Ealpha
            SLag(jlStat,jlStat) = SLag(jlStat,jlStat) + Scal
            Scal  = +DERAB/HEFF(jlStat,ilStat)
            SLag(jlStat,ilStat) = SLag(jlStat,ilStat) + Scal
          Else If (DWType == 3) Then
            Dag = abs(Ealpha - Ebeta) + 1.0e-9_wp
            Hag = abs(HEFF(jlStat,ilStat))
            DERAB = EXP(-ZETA*Dag/(sqrt(Hag)+Tiny(Hag)))/Factor
            DERAB = -ZETA*DERAB*Dag/(sqrt(Hag)+tiny(Hag))
     &              *DEROMG
            Scal = DERAB/Dag
            If (Ealpha-Ebeta <= Zero) Scal = -Scal
            SLag(jlStat,jlStat) = SLag(jlStat,jlStat) + Scal
            SLag(ilStat,ilStat) = SLag(ilStat,ilStat) - Scal
            Scal  = -DERAB/(sqrt(Hag)+tiny(Hag))/sqrt(Hag)*Half
            If (HEFF(jlStat,ilStat) <= Zero) Scal = -Scal
            SLag(jlStat,ilStat) = SLag(jlStat,ilStat) + Scal
          End If

          !! derivative of alpha-gamma
          Do klStat = 1, nState
            Egamma = HEFF(klStat,klStat)
            If (DWtype == 1) Then
              DERAC = EXP(-ZETA*(Ealpha-Ebeta)**2)/(Factor*Factor)
     &               *EXP(-ZETA*(Ealpha-Egamma)**2)
              Scal = Two*ZETA*DERAC*(Ealpha-Egamma)*DEROMG
              SLag(jlStat,jlStat) = SLag(jlStat,jlStat) + Scal
              SLag(klStat,klStat) = SLag(klStat,klStat) - Scal
            Else If (DWType == 2) Then
              DERAC = EXP(-ZETA*(Ealpha/HEFF(jlStat,klStat))**2)/Factor
     &              * EXP(-ZETA*(Ealpha/HEFF(jlStat,ilStat))**2)/Factor
              DERAC =-DERAC*Two*DEROMG*ZETA
     &              *(Ealpha/HEFF(jlStat,klStat))**2
              Scal  = -DERAC/Ealpha
              SLag(jlStat,jlStat) = SLag(jlStat,jlStat) + Scal
              Scal  = +DERAC/HEFF(jlStat,klStat)
              SLag(jlStat,klStat) = SLag(jlStat,klStat) + Scal
            Else IF (DWType == 3) Then
              Dbg = abs(Ealpha - Egamma) + 1.0e-9_wp
              Hbg = abs(HEFF(jlStat,klStat))
              DERAC =EXP(-ZETA*Dag/(sqrt(Hag)+tiny(Hag)))/Factor
     &              *EXP(-ZETA*Dbg/(sqrt(Hbg)+tiny(Hbg)))/Factor
              DERAC = ZETA*DERAC*Dbg/(sqrt(Hbg)+tiny(Hbg))
     &                *DEROMG
              Scal = DERAC/Dbg
              If (Ealpha-Egamma <= Zero) Scal = -Scal
              SLag(jlStat,jlStat) = SLag(jlStat,jlStat) + Scal
              SLag(klStat,klStat) = SLag(klStat,klStat) - Scal
              Scal  = -DERAC/(sqrt(Hbg)+tiny(Hbg))/sqrt(Hbg)*Half
              If (HEFF(jlStat,klStat) <= Zero) Scal = -Scal
              SLag(jlStat,klStat) = SLag(jlStat,klStat) + Scal
            End If
          End Do
        End Do
      End Do

      Return

      End Subroutine DWDER

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE JACSCF (A,B,C,NAA,NQQ,EPSLON)
      IMPLICIT real*8 (A-H,O-Z)
C VERSION 4 AUGUST 1971
C SUBROUTINE TO FIND ALL THE EIGENVALUES AND EIGENVECTORS OF A
C BY THE JACOBI METHOD
C THIS PROGRAM TREATS THE ORTHOGONAL CASE (S=1)
C NAA=DIMENSION OF A,B,C
C A TRIANGULAR, B MATRIX OF VECTORS, C EIGENVALUES
C B CLEARED TO UNIT MATRIX IF NQ=-1, NOT CLEARED IF NQ= NO. ROWS B
C NQ MUST NOT BE LESS THAN NAA
C EPSLON IS THE CONVERGENCE CRITERIA FOR OFF DIAGONAL ELEMENTS
      DIMENSION A(*),B(*),C(*)
*------
* POW: Unnecessary but warning stopping initialization
      term=1.0d30
*------
      NQ=NQQ
      LOOPC=0
      NA=NAA
      NN=(NA*(NA+1))/2
c      IF (NQ) 10,10,50
      IF (NQ.gt.0) goto 50
c10    CONTINUE
      K=1
      NQ=NA
      DO 40 I=1,NA
      DO 41 J=1,NA
c      IF (I-J) 20,30,20
      IF (I.eq.J) goto 30
c20    CONTINUE
      B(K)=0.0D00
      GO TO 42
30    B(K)=1.0D00
42    K=K+1
41    CONTINUE
40    CONTINUE
50    SUM=0.0D00
c      IF (NA-1) 330,310,60
      IF (NA-1.lt.0) goto 330
      IF (NA-1.eq.0) goto 310
c60    CONTINUE
      K=1
      AMAX=0.0D00
      DO 110 I=1,NA
      DO 100 J=1,I
c      IF (I-J) 70,90,70
      IF (I.eq.J) goto 90
c70    IF (ABS(A(K))-AMAX) 90,90,80
      IF (ABS(A(K))-AMAX.le.0) goto 90
c80    CONTINUE
      AMAX=ABS(A(K))
90    TERM=A(K)*A(K)
      SUM=SUM+TERM+TERM
      K=K+1
100   CONTINUE
      SUM=SUM-TERM
110   CONTINUE
      SUM=SQRT(SUM)
      THRESH=SUM/SQRT(dble(NA))
      THRSHG=THRESH*EPSLON
c      IF (THRSHG-AMAX) 120,310,310
      IF (THRSHG-AMAX.ge.0) goto 310
c120   CONTINUE
      THRESH=AMAX/3.
c      IF (THRESH-THRSHG) 130,140,140
      IF (THRESH-THRSHG.ge.0) goto 140
c130   CONTINUE
      THRESH=THRSHG
140   K=2
      N=0
      JD=1
      KDX=0
      DO 250 J=2,NA
      ID=0
      JD=JD+J
      JJ=J-1
      KC=0
      KDX=KDX+NQ
      DO 240 I=1,JJ
      ID=ID+I
      IF (ABS(A(K)).GT.THRESH) GO TO 150
      KC=KC+NQ
      GO TO 241
150   N=N+1
      ALPHA=(A(JD)-A(ID))/(2.*A(K))
      BETA=1.0D00/(1.0D00+ALPHA*ALPHA)
      ROOT=1.0D00+ABS(ALPHA)*SQRT(BETA)
      SSQ=BETA/(2*ROOT)
      CSQ=ROOT/2
      CC=SQRT(CSQ)
      S=-SQRT(SSQ)*SIGN(1.0D00,ALPHA)
      TWOSC=2*CC*S
      TEMPA=CSQ*A(ID)+TWOSC*A(K)+SSQ*A(JD)
      A(JD)=CSQ*A(JD)-TWOSC*A(K)+SSQ*A(ID)
      A(ID)=TEMPA
      A(K)=0.0D00
      KA=JD-J
      KB=ID-I
      KD=KDX
      DO 230 L=1,NQ
      KC=KC+1
      KD=KD+1
      TEMPA=CC*B(KC)+S*B(KD)
      B(KD)=-S*B(KC)+CC*B(KD)
      B(KC)=TEMPA
      IF (L.GT.NA) GO TO 230
c      IF (I-L) 180,160,200
      IF (I-L.lt.0) goto 180
      if (I-L.gt.0) goto 200
c160   CONTINUE
      KB=KB+1
170   KA=KA+1
      GO TO 230
180   KB=KB+L-1
c      IF (J-L) 190,170,210
      IF (J-L.eq.0) goto 170
      IF (J-L.gt.0) goto 210
c190   CONTINUE
      KA=KA+L-1
      GO TO 220
200   KB=KB+1
210   KA=KA+1
220   TEMPA=CC*A(KB)+S*A(KA)
      A(KA)=-S*A(KB)+CC*A(KA)
      A(KB)=TEMPA
230   CONTINUE
241   K=K+1
240   CONTINUE
      K=K+1
250   CONTINUE
      LOOPC=LOOPC+1
c      IF (LOOPC-50) 260,340,340
      IF (LOOPC-50.ge.0) goto 340
c260   IF (N-NN/8) 270,270,140
      IF (N-NN/8.gt.0) goto 140
c270   IF (THRESH-THRSHG) 280,300,280
      IF (THRESH-THRSHG.eq.0) goto 300
c280   CONTINUE
      THRESH=THRESH/3.
c      IF (THRESH-THRSHG) 290,140,140
      IF (THRESH-THRSHG.ge.0) goto 140
c290   CONTINUE
      THRESH=THRSHG
      GO TO 140
c300   IF (N) 140,310,140
300   IF (N.ne.0) goto 140
310   LL=0
      DO 320 L=1,NA
      LL=LL+L
      C(L)=A(LL)
320   CONTINUE
340   CONTINUE
330   RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Get_D1I_RASSCF_m(CMO,D1I)
************************************************************************
*                                                                      *
*     Compute one-body density (AO-basis)                              *
*     from frozen+inactive orbitals                                    *
*                                                                      *
*     calling arguments:                                               *
*     CMO     : input, array of real*8                                 *
*               MO-coefficients                                        *
*     D1I     : input, array of real*8                                 *
*               one-electron density matrix (frozen+inactive)          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension CMO(*), D1I(*)

#include "rasdim.fh"
#include "general.fh"

      Parameter ( Zero=0.0d0 , Two=2.0d0 )


* PAM Aug 2006, replace the following explicit code
* with the corresponding DGEMM calls.
*      iOff1 = 0
*      Do iSym = 1,nSym
*        iBas = nBas(iSym)
*        iOrb = nFro(iSym) + nIsh(iSym)
*        If ( iBas.ne.0 ) then
*          iOff2 = iOff1
*          Do i = 1,iBas
*            Do j = 1,iBas
*              Sum = Zero
*              Do k = 0,iOrb-1
*                Sum = Sum + Two * CMO(iOff1+k*iBas+i)
*     &                          * CMO(iOff1+k*iBas+j)
*              End Do
*              D1I(iOff2 + j) = Sum
*            End Do
*            iOff2 = iOff2 + iBas
*          End Do
*          iOff1 = iOff1 + iBas*iBas
*        End If
*      End Do
* Replaced by:
      ista=1
      do isym=1,nsym
        nb=nbas(isym)
        nbsq=nb**2
        nfi=nfro(isym)+nish(isym)
        if(nb.gt.0) then
          call dcopy_(nbsq,[0.0d0],0,d1i(ista),1)
          if(nfi.gt.0) then
            call DGEMM_('n','t',nb,nb,nfi,two,
     &           cmo(ista),nb,cmo(ista),nb,zero,d1i(ista),nb)
          end if
          ista=ista+nbsq
        end if
      end do


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mxinv_cvb(a,n)
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
      dimension a(n,n)
      save one,thresh
      data one/1.d0/,thresh/1.d-10/

      i1 = mstackr_cvb(n*n)
      i2 = mstackr_cvb(n*n)
      i3 = mstacki_cvb(n)
      ierr=0
      call fmove_cvb(a,work(i1),n*n)
      call dgetrf_(n,n,work(i1),n,iwork(i3),ierr)
      if(ierr.ne.0) then
        write(6,*)' Error in LU decomposition for inversion:',ierr
        call mxprint_cvb(a,n,n,0)
        call abend_cvb()
      endif
      call dgetri_(n,work(i1),n,iwork(i3),work(i2),n*n,ierr)
c  Check solution
      call mxatb_cvb(a,work(i1),n,n,n,work(i2))
      do 100 i=1,n
      work(i+(i-1)*n+i2-1)=work(i+(i-1)*n+i2-1)-one
100   continue
      rms=sqrt(ddot_(n*n,work(i2),1,work(i2),1)/DBLE(n*n))
      if(rms.gt.thresh)then
        write(6,*)' Fatal error in matrix inversion - error:',rms
        write(6,*)' Singular or near-singular matrix.'
        write(6,*)' Matrix :'
        call mxprint_cvb(a,n,n,0)
        write(6,*)' Inverted matrix :'
        call mxprint_cvb(work(i1),n,n,0)
        write(6,*)' Check :'
        call mxprint_cvb(work(i2),n,n,0)
        call mxdiag_cvb(a,work(i2),n)
        write(6,*)' Eigenvalues :'
        call mxprint_cvb(work(i2),1,n,0)
        write(6,*)' Eigenvectors :'
        call mxprint_cvb(a,1,n,0)
        call abend_cvb()
      endif
      call fmove_cvb(work(i1),a,n*n)
      call mfreer_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine initired(symmetry)
!bs initialize all information for irreducible representations
!bs later on, it might be useful to have a switch for
!bs changing to other orders of IREDs like e.g. in TURBOMOLE
!
! HOW2ADD another symmetry:
!
! 1. add it in readbas to be accepted. Add the number of IRs
!
! 2. copy one of the symmetry-blocks in this subroutine and
!    edit the nired for the group
!
! 3. assign the right IRs to L_X, L_Y and L_Z
!
! that is  all. Good luck!!!

use AMFI_global, only: ipow2ired
use Symmetry_Info, only: Mul
use Definitions, only: iwp, u6

implicit none
character(len=3), intent(in) :: symmetry
integer(kind=iwp) :: ired, iredorder(8), jred, nired
character(len=5) :: frmt

nired = 0

select case (symmetry)

  case ('D2H') ! MOLCAS-Version
    nired = 8
    !BS write(u6,*)
    !BS write(u6,*) 'multiplication table (Atkins,Child and Phillips)'
    !BS write(u6,*)
    !BS write(frmt,'("(",I1,"I5)")') nired
    !BS do ired=1,nired
    !BS   write(u6,frmt) (Mul(jred,ired),jred=1,nired)
    !BS   write(u6,*)
    !BS end do

    !IRLX = 4
    !IRLY = 3
    !IRLZ = 2
    !bs assume same order of ireds as Atkins Child and Phillips use..
    !bs would lead to an order with 1 to 1, 2 to 2 ...
    !bs however, this is the molecule/ seward order.
    iredorder(1) = 1
    iredorder(2) = 4
    iredorder(3) = 6
    iredorder(4) = 7
    iredorder(5) = 8
    iredorder(6) = 5
    iredorder(7) = 3
    iredorder(8) = 2
    !bs irreducible representation of the cartesian functions in D2H
    !bs order taken from Tables for Group theory:
    !bs Atkins, Child and Phillips   Oxford University Press 1970
    !bs 1. AG: only even powers (0,0,0)
    !bs 2. B1G: (1,1,0)    L_z
    !bs 3. B2G: (1,0,1)    L_y
    !bs 4. B3G: (0,1,1)    L_x
    !bs 5. AU:  (1,1,1)
    !bs 6. B1U: (0,0,1)
    !bs 7. B2U: (0,1,0)
    !bs 8. B3U: (1,0,0)
    ipow2ired(0,0,0) = iredorder(1)
    ipow2ired(1,1,0) = iredorder(2)
    ipow2ired(1,0,1) = iredorder(3)
    ipow2ired(0,1,1) = iredorder(4)
    ipow2ired(1,1,1) = iredorder(5)
    ipow2ired(0,0,1) = iredorder(6)
    ipow2ired(0,1,0) = iredorder(7)
    ipow2ired(1,0,0) = iredorder(8)

  case ('C2V')
    nired = 4
    !bs 1. A1 2. A2 3. B1 4. B2
    write(u6,*)
    write(u6,*) 'multiplication table '
    write(u6,*)
    write(frmt,'("(",I1,"I5)")') nired
    do ired=1,nired
      write(u6,frmt) (Mul(jred,ired),jred=1,nired)
      write(u6,*)
    end do

    !IRLX = 4
    !IRLY = 3
    !IRLZ = 2
    !bs this is the molecule/seward order.
    iredorder(1) = 1
    iredorder(2) = 4
    iredorder(3) = 2
    iredorder(4) = 3
    ipow2ired(0,0,0) = iredorder(1)
    ipow2ired(1,1,0) = iredorder(2)
    ipow2ired(1,0,1) = iredorder(3)
    ipow2ired(0,1,1) = iredorder(4)
    ipow2ired(1,1,1) = iredorder(2)
    ipow2ired(0,0,1) = iredorder(1)
    ipow2ired(0,1,0) = iredorder(4)
    ipow2ired(1,0,0) = iredorder(3)

  case ('D2 ')
    nired = 4
    !bs 1. A1 2. B1 3. B2 4. B3
    write(u6,*)
    write(u6,*) 'multiplication table '
    write(u6,*)
    write(frmt,'("(",I1,"I5)")') nired
    do ired=1,nired
      write(u6,frmt) (Mul(jred,ired),jred=1,nired)
      write(u6,*)
    end do

    !IRLX = 4
    !IRLY = 3
    !IRLZ = 2
    iredorder(1) = 1
    iredorder(2) = 2
    iredorder(3) = 3
    iredorder(4) = 4
    ipow2ired(0,0,0) = iredorder(1)
    ipow2ired(1,1,0) = iredorder(2)
    ipow2ired(1,0,1) = iredorder(3)
    ipow2ired(0,1,1) = iredorder(4)
    ipow2ired(1,1,1) = iredorder(1)
    ipow2ired(0,0,1) = iredorder(2)
    ipow2ired(0,1,0) = iredorder(3)
    ipow2ired(1,0,0) = iredorder(4)

  case ('C2H')
    nired = 4
    !bs assume 1.Ag 2.Au 3.Bg 4.Bu
    write(u6,*)
    write(u6,*) 'multiplication table '
    write(u6,*)
    write(frmt,'("(",I1,"I5)")') nired
    do ired=1,nired
      write(u6,frmt) (Mul(jred,ired),jred=1,nired)
      write(u6,*)
    end do

    !IRLX = 3
    !IRLY = 3
    !IRLZ = 1
    iredorder(1) = 1
    iredorder(2) = 2
    iredorder(3) = 3
    iredorder(4) = 4
    ipow2ired(0,0,0) = iredorder(1)
    ipow2ired(1,1,0) = iredorder(1)
    ipow2ired(1,0,1) = iredorder(3)
    ipow2ired(0,1,1) = iredorder(3)
    ipow2ired(1,1,1) = iredorder(2)
    ipow2ired(0,0,1) = iredorder(2)
    ipow2ired(0,1,0) = iredorder(4)
    ipow2ired(1,0,0) = iredorder(4)

  case ('CS ')
    nired = 2
    !bs assume 1.A' 2.A'
    write(u6,*)
    write(u6,*) 'multiplication table '
    write(u6,*)
    write(frmt,'("(",I1,"I5)")') nired
    do ired=1,nired
      write(u6,frmt) (Mul(jred,ired),jred=1,nired)
      write(u6,*)
    end do

    !IRLX = 2
    !IRLY = 2
    !IRLZ = 1
    iredorder(1) = 1
    iredorder(2) = 2
    ipow2ired(0,0,0) = iredorder(1)
    ipow2ired(1,1,0) = iredorder(1)
    ipow2ired(1,0,1) = iredorder(2)
    ipow2ired(0,1,1) = iredorder(2)
    ipow2ired(1,1,1) = iredorder(2)
    ipow2ired(0,0,1) = iredorder(2)
    ipow2ired(0,1,0) = iredorder(1)
    ipow2ired(1,0,0) = iredorder(1)
end select

!write(u6,*) 'interacting IRs '
!do ired=1,nired
!  iredorderinv(iredorder(ired)) = ired
!end do
!do ired=1,nired
!  IRwithLX(ired) = iredorder(Mul(IRLX,iredorderinv(ired)))
!  IRwithLY(ired) = iredorder(Mul(IRLY,iredorderinv(ired)))
!  IRwithLZ(ired) = iredorder(Mul(IRLZ,iredorderinv(ired)))
!  !write(u6,*) IRwithLX(ired),IRwithLY(ired),IRwithLZ(ired)
!end do

return

end subroutine initired

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  IniCho_RI
*
*> @brief
*>   Initialize Cholesky environment for RI calculations
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Initialize Cholesky environment for RI calculations.
*>
*> @note
*> Needs a call to ::SetUp_Ints with indexation turned on
*>
*> @param[in] nSkal    The number of shells (excl. aux. basis)
*> @param[in] nVec_Aux Number of aux. basis vectors per irrep
*> @param[in] nIrrep   Number of irreps
*> @param[in] iTOffs   Offset vector
*> @param[in] iShij    Index vector of shell pairs
*> @param[in] nShij    Number of shell pairs
************************************************************************
      SubRoutine IniCho_RI(nSkal,nVec_Aux,nIrrep,iTOffs,iShij,nShij)
      Implicit None
      Integer nSkal, nIrrep, nShij
      Integer nVec_Aux(0:nIrrep-1)
      Integer iTOffs(3,nIrrep)
      Integer iShij(2,nShij)
#include "cholesky.fh"
#include "choptr.fh"
#include "choprint.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#if defined (_MOLCAS_MPP_)
#include "choglob.fh"
#endif

      Logical SetDefaultsOnly, Skip_PreScreen, Alloc_Bkm
      Integer iDummy, LuOut, iSym, iVec, ijS
      Integer iTri, i, j

      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

C     Set defaults for those parameters that can normally be changed
C     through user input to the Cholesky decomposition.
C     -----------------------------------------------------------------

      SetDefaultsOnly = .True.
      iDummy = -1
      LuOut = 6
      Call Cho_Inp(SetDefaultsOnly,iDummy,LuOut)

C     Reset Cholesky Threshold for RI
C     -------------------------------
      Call Get_thrc_RI(ThrCom)

C     Reset parallel config.
C     ----------------------

      CHO_FAKE_PAR = .False.
      Call Cho_ParConf(CHO_FAKE_PAR)

C     Set run mode to "external" (should be irrelevant for RI).
C     ---------------------------------------------------------

      RUN_MODE = RUN_EXTERNAL

C     Silence the Cholesky routines.
C     ------------------------------

      iPrint = 0

C     Set number of shells (excl. aux. basis) in cholesky.fh
C     -------------------------------------------------------

      nShell = nSkal

C     To avoid unnecessary allocations of shell-pair-to-reduced-set
C     maps, set decomposition algorithm to 1 ("one-step") and the Seward
C     interface to "1" (full shell quadruple storage). Both values are,
C     obviously, irrelevant for RI. In parallel runs, use default values
C     to avoid warnings being printed in Cho_P_Check.
C     ------------------------------------------------------------------

      If (Is_Real_Par()) Then
         Cho_DecAlg = 4
         IfcSew = 2
      Else
         Cho_DecAlg = 1
         IfcSew = 1
      End If

C     Change MaxRed to 1 (all vectors have identical dimension, namely
C     full => only 1 reduced set).
C     ----------------------------------------------------------------

      MaxRed = 1

C     Set MaxVec to the largest number of vectors (= number of linearly
C     independent auxiliary basis functions). In this way we avoid
C     allocating more memory for InfVec than needed.
C     ------------------------------------------------------------------

      MaxVec = nVec_Aux(0)
      Do iSym = 1,nIrrep-1
         MaxVec = max(MaxVec,nVec_Aux(iSym))
      End Do

C     Other initializations. Most importantly, allocate InfRed and
C     InfVec arrays (pointers and dimensions stored in choptr.fh).
C     We skip diagonal prescreening, as it has already been done.
C     Instead, allocate and set the mapping from reduced to full shell
C     pairs here.
C     ----------------------------------------------------------------

      nnShl = nShij
      l_iSP2F = nnShl
      Call GetMem('SP2F','Allo','Inte',ip_iSP2F,l_iSP2F)
      Do ijS = 1,nnShl
         iWork(ip_iSP2F-1+ijS) = iTri(iShij(1,ijS),iShij(2,ijS))
      End Do
      Skip_PreScreen = .True.
      Alloc_Bkm = .False.
      Call Cho_Init(Skip_PreScreen,Alloc_Bkm)

C     Set number of vectors equal to the number of lin. indep. auxiliary
C     basis functions.
C     ------------------------------------------------------------------

      Do iSym = 1,nSym
         NumCho(iSym) = nVec_Aux(iSym-1)
      End Do
#if defined (_MOLCAS_MPP_)
      If (Is_Real_Par()) Then
         Call iCopy(nSym,NumCho,1,NumCho_G,1)
         Call iZero(myNumCho,nSym)
      End If
#endif

C     Do allocations that are normally done during or after the
C     computation of the diagonal (since the dimension of the 1st
C     reduced set is unknown until the screened diagonal is known).
C     -------------------------------------------------------------

      Call IniCho_RI_Xtras(iTOffs,nIrrep,iShij,nShij)

C     Set start disk addresses.
C     -------------------------

      XnPass = 0 ! it should be zeroed in Cho_Inp, but just in case.
      Call Cho_SetAddr(iWork(ip_InfRed),iWork(ip_infVec),MaxRed,MaxVec,
     &                 InfVec_N2,nSym)

C     Set vector info.
C     Parent diagonal is set equal to the vector number, parent pass
C     (i.e. reduced set) to 1.
C     --------------------------------------------------------------

      Do iSym = 1,nSym
         Do iVec = 1,NumCho(iSym)
            Call Cho_SetVecInf(iWork(ip_InfVec),MaxVec,InfVec_N2,nSym,
     &                         iVec,iSym,iVec,1,1)
         End Do
      End Do
*
      Return
      End
      SubRoutine IniCho_RI_Xtras(iTOffs,nIrrep,iShij,nShij)
      Implicit None
      Integer nIrrep, nShij
#include "cholesky.fh"
#include "choorb.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Logical DoDummy

      Integer iiBst(8), nnBst(8), iTOffs(3,nIrrep), iShij(2,nShij)
      Integer iSym, iCount, nnBstT

      Integer i

C     Define max. dimensions and offsets of the symmetry blocks of the
C     integrals matrix.
C     ----------------------------------------------------------------

      iCount = 0
      Do iSym = 1,nSym
         iiBst(iSym) = iCount
         nnBst(iSym) = iTOffs(3,iSym)
         iCount = iCount + nnBst(iSym)
      End Do

C     Set dimensions of reduced sets equal to full dimension.
C     -------------------------------------------------------

      Do i = 1,3
         nnBstT=0
         Do iSym = 1,nSym
            iiBstR(iSym,i) = iiBst(iSym)
            nnBstR(iSym,i) = nnBst(iSym)
            nnBstT=nnBstT+nnBstR(iSym,i)
         End Do
         nnBstRT(i) = nnBstT
      End Do
      mmBstRT = nnBstRT(1)

C     Allocate index arrays for reduced sets: IndRed and IndRsh.
C     ----------------------------------------------------------

      l_IndRed=nnBstRT(1)*3
      l_IndRSh=nnBstRT(1)
      Call GetMem('indred','Allo','Inte',ip_IndRed,l_IndRed)
      Call GetMem('indrsh','Allo','Inte',ip_IndRSh,l_IndRSh)

C     Allocate iScr array used by reading routines.
C     ---------------------------------------------

      DoDummy = .False.
      Call Cho_Allo_iScr(DoDummy)

C     Initialize reduced set dimensions used for reading vectors.
C     (Note: here they are all the same - there is one reduced sets!)
C     ---------------------------------------------------------------

      Do i = 1,MaxRed
         Do iSym = 1,nSym
            iWork(ip_nDimRS-1+nSym*(i-1)+iSym) = nnBstR(iSym,1)
         End Do
      End Do

C     Allocate and set mapping array from 1st reduced set to full
C     storage.
C     -----------------------------------------------------------

      l_iRS2F = 2*nnBstRT(1)
      Call GetMem('iRS2F','Allo','Inte',ip_iRS2F,l_iRS2F)

C     Set index arrays corresponding to full storage:
C     iiBstRSh, nnBstRSh, IndRed, IndRSh, and iRS2F.
C     -----------------------------------------------

      Call SetChoIndx_RI(iWork(ip_iiBstRSh),iWork(ip_nnBstRSh),
     &                   iWork(ip_IndRed),iWork(ip_IndRsh),
     &                   iWork(ip_iRS2F),
     &                   nSym,nnShl,nnBstRT(1),3,2,iShij,nShij)

      Return
      End
      SubRoutine SetChoIndx_RI(iiBstRSh,nnBstRSh,IndRed,IndRsh,iRS2F,
     &                         I_nSym,I_nnShl,I_mmBstRT,I_3,I_2,
     &                         iShij,nShij)
      Implicit Real*8 (a-h,o-z)
      Integer iiBstRSh(I_nSym,I_nnShl,I_3), nnBstRSh(I_nSym,I_nnShl,I_3)
      Integer IndRed(I_mmBstRT,I_3), IndRsh(I_mmBstRT)
      Integer iRS2F(I_2,I_mmBstRT), iShij(2,nShij)
#include "choorb.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer  Cho_iSAOSh
      External Cho_iSAOSh

      Integer iRS(8)

      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
      nBstSh(i)=iWork(ip_nBstSh-1+i)
      iBasSh(i,j)=iWork(ip_iBasSh-1+nSym*(j-1)+i)
      nBasSh(i,j)=iWork(ip_nBasSh-1+nSym*(j-1)+i)
      iSP2F(i)=iWork(ip_iSP2F-1+i)

C     nnBstRSh(iSym,iSh_ij,1) = #elements in compound sym. iSym of
C                               shell-pair ab in 1st reduced set.
C     IndRSh(jRS): shell-pair to which element jRS of first reduced set
C                  belongs.
C     IndRed(jRS,1): address (without symmetry) in shell-pair of element
C                    jRS of first reduced set.
C     ------------------------------------------------------------------

      Call iCopy(nSym*nnShl,[0],0,nnBstRSh(1,1,1),1)
      Call iCopy(nSym,iiBstR(1,1),1,iRS,1)
      Do iSh_ij= 1,nShij
         iShla=iShij(1,iSh_ij)
         iShlb=iShij(2,iSh_ij)
         iShlab=iTri(iShla,iShlb)
C        Write (*,*) 'iSh_ij,iShlab,iShla,iShlb=',
C    &               iSh_ij,iShlab,iShla,iShlb
         If (iShlab .ne. iSP2F(iSh_ij)) Then
            Call SysAbendMsg('SetChoIndx_RI','SP2F setup error',' ')
         End If
*
         If (iShla.gt.iShlb) Then
*
*        code for shell a > shell b
*
            Do iSymb = 1,nSym
               Do ibb = 1,nBasSh(iSymb,iShlb)
                  ib = iBasSh(iSymb,iShlb) + ibb
                  Do iSyma = 1,nSym
                     iSym = MulD2h(iSyma,iSymb)
                     Do iaa = 1,nBasSh(iSyma,iShla)
                        ia = iBasSh(iSyma,iShla) + iaa
                        iab = nBstSh(iShla)*(ib-1) + ia
                        nnBstRSh(iSym,iSh_ij,1) =
     &                     nnBstRSh(iSym,iSh_ij,1) + 1
                        iRS(iSym) = iRS(iSym) + 1
                        IndRSh(iRS(iSym)) = iShlab
                        IndRed(iRS(iSym),1) = iab
                     End Do
                  End Do
               End Do
            End Do
*
         Else
*
*            code for shell a = shell b follows
*
            Do ia = 1,nBstSh(iShla)
               iSyma = Cho_iSAOSh(ia,iShla)
               Do ib = 1,ia
                  iab = iTri(ia,ib)
                  iSymb = Cho_iSAOSh(ib,iShlb)
                  iSym = MulD2h(iSyma,iSymb)
                  nnBstRSh(iSym,iSh_ij,1) = nnBstRSh(iSym,iSh_ij,1) + 1
                  iRS(iSym) = iRS(iSym) + 1
                  IndRSh(iRS(iSym)) = iShlab
                  IndRed(iRS(iSym),1) = iab
               End Do
            End Do
*
         End If
      End Do   ! iSh_ij

C     Check.
C     ------

      nErr = 0
      Do iSym = 1,nSym
         iCount = nnBstRSh(iSym,1,1)
         Do iSh_ij = 2,nnShl
            iCount = iCount + nnBstRSh(iSym,iSh_ij,1)
         End Do
         If (iCount .ne. nnBstR(iSym,1)) Then
            nErr = nErr + 1
         End If
      End Do
      If (nErr .ne. 0) Then
         Call SysAbendMsg('SetChoIndx_RI','Setup error',
     &                    'iCount vs. nnBstR')
      End If
      Do iSym = 1,nSym
         If ((iRS(iSym)-iiBstR(iSym,1)) .ne. nnBstR(iSym,1)) Then
            nErr = nErr + 1
         End If
      End Do
      If (nErr .ne. 0) Then
         Call SysAbendMsg('SetChoIndx_RI','Setup error','ShP RS1 count')
      End If

C     iiBstRSh(iSym,iSh_ij,1) = offset to elements in compound sym. iSym
C                               of shell-pair ab in 1st reduced set.
C     ------------------------------------------------------------------

      Do iSym = 1,nSym
         iiBstRSh(iSym,1,1) = 0
         Do iSh_ij = 2,nnShl
            iiBstRSh(iSym,iSh_ij,1) = iiBstRSh(iSym,iSh_ij-1,1)
     &                              + nnBstRSh(iSym,iSh_ij-1,1)
         End Do
      End Do

C     Check.
C     ------

      nErr = 0
      Do iSym = 1,nSym
         Do iSh_ij = 1,nnShl
            jRS1 = iiBstR(iSym,1) + iiBstRSh(iSym,iSh_ij,1) + 1
            jRS2 = jRS1 + nnBstRSh(iSym,iSh_ij,1) - 1
            Do jRS = jRS1,jRS2
               If (IndRSh(jRS) .ne. iSP2F(iSh_ij)) Then
                  nErr = nErr + 1
               End If
            End Do
         End Do
      End Do
      If (nErr .ne. 0) Then
         Call SysAbendMsg('SetChoIndx_RI','Setup error','IndRSh')
      End If

C     Copy index arrays to "locations" 2 and 3.
C     Note: IndRed here returns the index in 1st reduced set.
C     -------------------------------------------------------

      Do i = 2,3
         Do jRS = 1,nnBstRT(1)
            IndRed(jRS,i) = jRS
         End Do
         Call iCopy(nSym*nnShl,iiBstRSh(1,1,1),1,iiBstRSh(1,1,i),1)
         Call iCopy(nSym*nnShl,nnBstRSh(1,1,1),1,nnBstRSh(1,1,i),1)
      End Do

      Call Cho_RStoF(iRS2F,2,nnBstRT(1),1)

      Return
      End
************************************************************
*
************************************************************
      Subroutine Get_thrc_RI(Thr_CD)
      use RICD_Info, only: Thrshld_CD
      Real*8 Thr_CD

      Thr_CD = Thrshld_CD

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, IBM                                              *
!               1991, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
function TstFnc(iCoSet,iIrrep,iBsFnc,nStab)
!***********************************************************************
!                                                                      *
! Object: to establish if a function is a basis function of a          *
!         irreducible representation.                                  *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             September 1991                                           *
!***********************************************************************

use Symmetry_Info, only: iChTbl, iOper, nIrrep
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp) :: TstFnc
integer(kind=iwp), intent(in) :: iCoSet(0:7,0:7), iIrrep, iBsFnc, nStab
integer(kind=iwp) :: i, iAcc(0:7), j, k, n, nCoSet
integer(kind=iwp), external :: iPrmt

TstFnc = .true.
nCoSet = nIrrep/nStab
iAcc(0:nCoSet-1) = 0

#ifdef _DEBUGPRINT_
write(u6,*) 'TstFnc'
write(u6,*)
write(u6,*) 'Coset:'
do i=0,nCoSet-1
  write(u6,'(8I4)') (iCoSet(i,j),j=0,nStab-1)
end do

write(u6,*)
write(u6,*) 'iOper:'
write(u6,'(8I4)') (iOper(i),i=0,nIrrep-1)
write(u6,*)
write(u6,*) 'iBsFnc=',iBsFnc
write(u6,*)
write(u6,*) 'iChTbl:'
write(u6,'(8I4)') (iChTbl(iIrrep,i),i=0,nIrrep-1)
#endif

! Loop over operators

do i=0,nIrrep-1

  ! Find index of the generated center

  n = -1
  do j=0,nCoSet-1
    if (n >= 0) cycle
    do k=0,nStab-1
      if (iOper(i) == iCoSet(j,k)) n = j
    end do
  end do

  if ((n < 0) .or. (n > nCoSet-1)) then
    call WarningMessage(2,'TstFnc: n < 0 .or. n > nCoSet-1')
    write(u6,*) ' Coset index',n,' is wrong!'
    call Abend()
  end if

  iAcc(n) = iAcc(n)+iChTbl(iIrrep,i)*iPrmt(i,iBsFnc)

end do
do i=0,nCoSet-1
  if (iAcc(i) == 0) then
    TstFnc = .false.
    exit
  end if
end do

return

end function TstFnc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine update2_cvb(orbs,cvb,orbsp,cvbp,sorbs,dxorg,ic,norb,nvb,nprorb,npr,orbopt,strucopt,sym,iorts,nort)

use casvb_global, only: ipr, wdx
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ic, norb, nvb, nprorb, npr, nort, iorts(2,nort)
real(kind=wp), intent(out) :: orbs(norb,norb), cvb(nvb), sorbs(norb,norb)
real(kind=wp), intent(in) :: orbsp(norb,norb), cvbp(nvb), dxorg(npr)
logical(kind=iwp), intent(in) :: orbopt, strucopt, sym
integer(kind=iwp) :: ierr, ij, iorb, iort, j, jorb, k, korb, l, lorb
real(kind=wp) :: dum(1), fac, sdidj
real(kind=wp), allocatable :: sorbsinv(:,:)

call free2all_cvb(dxorg,wdx,1)
if ((ipr(3) >= 3) .and. (ic == 1)) then
  write(u6,'(/,a)') ' Update vector :'
  call vecprint_cvb(wdx,npr)
end if

orbs(:,:) = orbsp(:,:)
cvb(:) = cvbp(:)

if (orbopt) then
  call mxattb_cvb(orbsp,orbsp,norb,norb,norb,sorbs)

  ij = 0
  do iorb=1,norb
    do jorb=1,norb
      if (jorb /= iorb) then
        ij = ij+1
        orbs(:,iorb) = orbs(:,iorb)+wdx(ij)*orbsp(:,jorb)
      end if
    end do
  end do

  ! 2nd-order correction for orthogonality constraints:
  call mma_allocate(sorbsinv,norb,norb,label='sorbsinv')
  sorbsinv(:,:) = sorbs(:,:)
  call mxinv_cvb(sorbsinv,norb)
  do iort=1,nort
    iorb = iorts(1,iort)
    jorb = iorts(2,iort)
    sdidj = zero
    do k=1,norb-1
      korb = k
      if (korb >= iorb) korb = korb+1
      do l=1,norb-1
        lorb = l
        if (lorb >= jorb) lorb = lorb+1
        sdidj = sdidj+sorbs(korb,lorb)*wdx(k+(iorb-1)*(norb-1))*wdx(l+(jorb-1)*(norb-1))
      end do
    end do
    fac = -Half*sdidj
    do j=1,norb
      orbs(:,iorb) = orbs(:,iorb)+fac*orbsp(:,j)*sorbsinv(j,jorb)
      orbs(:,jorb) = orbs(:,jorb)+fac*orbsp(:,j)*sorbsinv(j,iorb)
    end do
  end do
  call mma_deallocate(sorbsinv)
end if

if (strucopt) then
  cvb(:) = cvb(:)+wdx(nprorb+1:nprorb+nvb)
  call scalstruc_cvb(orbs,cvb)
  call cvbnrm_cvb(cvb)
end if

ierr = 0
call nize_cvb(orbs,norb,dum,norb,0,ierr)
if (sym) call symtriz_cvb(orbs,cvb)

return

end subroutine update2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine GrdCls(IRETURN,nState,UEFF,U0,H0)

use PrintLevel, only: VERBOSE
use caspt2_global, only: CLag, CLagFull, do_csf, do_nac, DPT2_AO_tot, DPT2_tot, DPT2C_AO_tot, DPT2C_tot, DPT2Canti_tot, FIFA_all, &
                         FIFASA_all, FIMO_all, iPrGlb, iRoot1, iRoot2, iTasks_grad, LuAPT2, LUGRAD, LuPT2, LUSTD, nOLag, nWLag, &
                         OLag, OLagFull, OMGDER, SLag, TraFro, WLag
use caspt2_module, only: DWTYPE, IfChol, IFDW, IFMSCOUP, IFRMS, IFXMS, iRlxRoot, NBAST, NBSQT, NBTRI, NCONF, nFroT, NROOTS, &
                         REFENE, RFPERT, Zeta
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, King
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IRETURN, nState
real(kind=wp), intent(inout) :: UEFF(nState,nState), U0(nState,nState)
real(kind=wp), intent(in) :: H0(nState,nState)
integer(kind=iwp) :: i, iGo, ilStat, j, jlStat
real(kind=wp) :: CPE, CPTF0, CPTF10, CPUT, Scal, TIOE, TIOTF0, TIOTF10, WALLT
logical(kind=iwp) :: DEB, Found
character(len=16) :: mstate1
real(kind=wp), allocatable :: CI1(:,:), HEFF1(:,:), WRK1(:,:), WRK2(:,:)
integer(kind=iwp), external :: isFreeUnit
logical(kind=iwp), external :: RF_On

!! In case convergence of CASPT2 equation failed
!! Call this subroutine just deallocate memory
if (IRETURN == 0) then

  call mma_allocate(HEFF1,nState,nState,Label='HEFF1')
  call mma_allocate(WRK1,nState,nState,Label='WRK1')
  call mma_allocate(WRK2,nState,nState,Label='WRK2')

  !! Add XMS specific terms
  !! Note that CLagFull is in natural CSF basis,
  !! so everything in this subroutine has to be done in natural
  SLag(:,:) = Zero
  WRK2(:,:) = Zero
  if (IFDW .and. (zeta >= Zero)) then
    !! Construct Heff[1] in XMS basis
    HEFF1(:,:) = Zero
    do ilStat=1,nState
      HEFF1(ilStat,ilStat) = REFENE(ilStat)
    end do
    call DGEMM_('T','N',nState,nState,nState,One,U0,nState,HEFF1,nState,Zero,WRK1,nState)
    call DGEMM_('N','N',nState,nState,nState,One,WRK1,nState,U0,nState,Zero,HEFF1,nState)

    !! Derivative of Heff[1] in XMS basis
    !! It is transformed with U0, so the contribution has to be
    !! considered when we construct the auxiliary density in the
    !! XMS-specific term
    call DWDER(OMGDER,HEFF1,SLag)
    call DGEMM_('N','N',nState,nState,nState,One,U0,nState,SLag,nState,Zero,WRK2,nState)
    call DGEMM_('N','T',nState,nState,nState,One,WRK2,nState,U0,nState,Zero,WRK1,nState)

    WRK2(:,:) = Zero
    do ilStat=1,nState
      if (DWTYPE == 1) then
        WRK2(ilStat,ilStat) = SLag(ilStat,ilStat)
      else if ((DWTYPE == 2) .or. (DWTYPE == 3)) then
        WRK2(ilStat,:) = SLag(ilStat,:)
      end if
      if (.not. do_nac) then
        WRK1(ilStat,1:ilStat-1) = WRK1(ilStat,1:ilStat-1)+WRK1(1:ilStat-1,ilStat)
        WRK1(1:ilStat-1,ilStat) = Zero
      end if
    end do
    SLag(:,:) = WRK1(:,:)
  end if

  if (IFXMS .or. IFRMS .or. (IFMSCOUP .and. do_nac .and. do_csf)) then
    if (.not. IFXMS .and. (.not. IFRMS)) then
      !! For MS-CASPT2, only the second term in eq.(68)
      call unitmat(U0,nState)
    end if

    call TIMING(CPTF0,CPE,TIOTF0,TIOE)
    call XMS_Grad(H0,U0,UEFF,WRK2)
    call TIMING(CPTF10,CPE,TIOTF10,TIOE)
    CPUT = CPTF10-CPTF0
    WALLT = TIOTF10-TIOTF0
    if (IPRGLB >= VERBOSE) write(u6,'(a,2f10.2)') ' XMS_Grad: CPU/WALL TIME=',cput,wallt
  end if

  !! Now, compute the state Lagrangian and do some projections
  !! If PCM, we have to obtain internal state rotation parameters
  !! self-consistently, so we should not call this subroutine
  if (.not. RF_On()) call CLagFinal(nConf,nRoots,nState,CLagFull,SLag)

  !! Add MS-CASPT2 contributions
  if (IFMSCOUP) then
    do ilStat=1,nState
      do jlStat=1,ilStat
        if (do_nac) then
          if ((.not. IFXMS) .and. (.not. IFRMS) .and. (ilstat /= jlstat)) cycle

          Scal = UEFF(ilStat,iRoot1)*UEFF(jlStat,iRoot2)+UEFF(jlStat,iRoot1)*UEFF(ilStat,iRoot2)
          Scal = Scal*Half
          SLag(ilStat,jlStat) = SLag(ilStat,jlStat)+Scal

          if (ilStat /= jlStat) SLag(jlStat,ilStat) = SLag(jlStat,ilStat)+Scal
        else
          if (IFXMS .or. IFRMS) then
            Scal = UEFF(ilStat,iRoot1)*UEFF(jlStat,iRoot2)
            if (ilStat /= jlStat) Scal = Scal*Two
            SLag(ilStat,jlStat) = SLag(ilStat,jlStat)+Scal
          else if (ilStat == jlStat) then
            Scal = UEFF(ilStat,iRoot1)*UEFF(jlStat,iRoot2)
            SLag(ilStat,jlStat) = SLag(ilStat,jlStat)+Scal
          end if
        end if
      end do
    end do
  end if

  !! Subtract the original rhs_sa or rhs_nac contribution
  !! For MS-type CASPT2, CASSCF part has to be determined by UEFF
  if (IFMSCOUP .and. (iRoot1 == iRoot2)) then
    ilStat = max(iRoot1,iRoot2)
    jlStat = min(iRoot1,iRoot2)
    SLag(ilStat,jlStat) = SLag(ilStat,jlStat)-One
  end if

  !! Finalize the first-order transition(-like) density matrix
  !! for the CSF derivative term
  if (do_nac) then
    if (do_csf) then
      call CnstAntiC(DPT2Canti_tot,UEFF,U0)
    else
      !! Clear just in case
      DPT2Canti_tot(:) = Zero
    end if
  end if

  !! Back-transform the CI Lagrangian
  !! It is in the XMS basis, so it has to be transformed to
  !! CASSCF basis to be used in Z-vector
  !! No need to do this for SLag.
  if (IFXMS .or. IFRMS) then
    call mma_allocate(CI1,nConf,nState,Label='CI1')
    call DGEMM_('N','T',nConf,nState,nState,One,CLagFull,nConf,U0,nState,Zero,CI1,nConf)
    CLagFull(:,:) = CI1(:,:)
    call mma_deallocate(CI1)
  end if

  !! Compute true unrelaxed properties for MS-CASPT2
  if ((.not. do_nac) .and. ifmscoup) call PRPCTL(1,UEFF,U0,nState)

  LuPT2 = isFreeUnit(LuPT2)
  call Molcas_Open(LuPT2,'PT2_Lag')

  DEB = .false.
  !! configuration Lagrangian (read in RHS_PT2)
  if (DEB) call RecPrt('CLagFull','',CLagFull,nConf,nState)
  do j=1,nState
    do i=1,nConf
      write(LuPT2,*) CLagFull(i,j)
    end do
  end do

  !! orbital Lagrangian (read in RHS_PT2)
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    if (.not. King()) OLagFull(:) = Zero
    call GADGOP(OLagFull,nOLag,'+')
  end if
# endif
  if (DEB) call RecPrt('OLagFull','',OLagFull,nBasT,nBasT)
  do i=1,nOLag
    write(LuPT2,*) OLagFull(i)
  end do

        !! state Lagrangian (read in RHS_PT2)
  if (DEB) call RecPrt('SLag','',SLag,nState,nState)
  do j=1,nState
    do i=1,nState
      write(LuPT2,*) SLag(i,j)
    end do
  end do

  !! renormalization contributions (read in OUT_PT2)
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    if (.not. King()) WLag(:) = Zero
    call GADGOP(WLag,nWLag,'+')
  end if
# endif
  if (DEB) call TriPrt('WLag','',WLag,nBast)
  do i=1,nWLag ! = NBTRI
    write(LuPT2,*) WLag(i)
  end do

  !! D^PT2 in MO (read in OUT_PT2)
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    if (.not. King()) DPT2_tot(:) = Zero
    call GADGOP(DPT2_tot,NBSQT,'+')
  end if
# endif
  if (DEB) call RecPrt('DPT2','',DPT2_tot,nBast,nBast)
  do i=1,NBSQT
    write(LuPT2,*) DPT2_tot(i)
  end do

  !! D^PT2(C) in MO (read in OUT_PT2)
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    if (.not. King()) DPT2C_tot(:) = Zero
    call GADGOP(DPT2C_tot,NBSQT,'+')
  end if
# endif
  if (DEB) call RecPrt('DPT2C','',DPT2C_tot,nBast,nBast)
  do i=1,NBSQT
    write(LuPT2,*) DPT2C_tot(i)
  end do

  !! NAC
  if (do_nac) then
    do i=1,NBSQT
      write(LuPT2,*) DPT2Canti_tot(i)
    end do
  end if

  !! D^PT2 in AO (not used?)
  !! Recompute DPT2AO and DPT2AO for PCM
  if (RFpert .and. IFMSCOUP) call Recompute_DPT2AO(NBSQT,DPT2_tot,DPT2C_tot,DPT2_AO_tot,DPT2C_AO_tot)
  if (DEB) call TriPrt('DPT2_AO_tot','',DPT2_AO_tot,nBast)
  do i=1,NBSQT
    write(LuPT2,*) DPT2_AO_tot(i)
  end do

  !! D^PT2(C) in AO (not used?)
  if (DEB) call TriPrt('DPT2C_AO','',DPT2C_AO_tot,nBast)
  do i=1,NBSQT
    write(LuPT2,*) DPT2C_AO_tot(i)
  end do

  if (RFpert) then
    !! For CASPT2/PCM gradient
    !! The implicit derivative contributions have not been
    !! considered in the CASPT2 module
    if (ifmscoup) then
      ! I do not remember why this should be halved
      DPT2_AO_tot(1:NBTRI) = DPT2_AO_tot(1:NBTRI)+Half*DPT2C_AO_tot(1:NBTRI)
    else
      DPT2_AO_tot(1:NBTRI) = DPT2_AO_tot(1:NBTRI)+DPT2C_AO_tot(1:NBTRI)
    end if
    call Put_dArray('D1aoVar',DPT2_AO_tot,NBTRI)
  else
    !! not sure this is OK
    call Put_dArray('D1aoVar',DPT2_AO_tot,0)
  end if

  ! close gradient files
  close(LuPT2)

  call mma_deallocate(HEFF1)
  call mma_deallocate(WRK1)
  call mma_deallocate(WRK2)
end if

call mma_deallocate(DPT2_tot)
call mma_deallocate(DPT2C_tot)
call mma_deallocate(DPT2_AO_tot)
call mma_deallocate(DPT2C_AO_tot)

call mma_deallocate(CLag)
call mma_deallocate(CLagFull)
call mma_deallocate(OLag)
call mma_deallocate(OLagFull)
call mma_deallocate(SLag)
call mma_deallocate(WLag)

call mma_deallocate(FIMO_all)
call mma_deallocate(FIFA_all)

if (IFXMS .or. IFRMS) call mma_deallocate(FIFASA_all)
if (IFDW .and. (zeta >= Zero)) call mma_deallocate(OMGDER)
if (do_nac) call mma_deallocate(DPT2Canti_tot)

! Prepare for MCLR
iGo = 3
call Put_iScalar('SA ready',iGo)
! overwrites whatever was set in CASSCF with the relax
! root that was chosen in CASPT2
if (do_nac) then
  !write(u6,*) 'NAC'
  !write(u6,*) 'CASSCF/Original = ',iRoot1,iRoot2
  call Put_iScalar('Relax CASSCF root',iRoot1)
  call Put_iScalar('Relax Original root',iRoot2)
  call Qpg_cArray('MCLR Root',Found,I)
  if (Found) then
    call Get_cArray('MCLR Root',mstate1,16)
    if ((mstate1(8:8) == '0') .and. (mstate1(16:16) == '0')) then
      !! NAC states have not been specified
      write(mstate1,'(1X,I7,1X,I7)') iRoot1,iRoot2
      call Put_cArray('MCLR Root',mstate1,16)
    end if
  else
    mstate1 = '****************'
    call Put_cArray('MCLR Root',mstate1,16)
  end if
else
  !write(u6,*) 'GRD'
  !write(u6,*) 'CASSCF/Original = ',irlxroot,irlxroot
  call Put_iScalar('Relax CASSCF root',irlxroot)
  call Put_iScalar('Relax Original root',irlxroot)
  mstate1 = '****************'
  call Put_cArray('MCLR Root',mstate1,16)
end if

call ModDip()

!! Close files
call DaClos(LUSTD)
if (IfChol) call DaClos(LUAPT2)
call DaClos(LUGRAD)

if (nFroT /= 0) call mma_deallocate(TraFro)
call mma_deallocate(iTasks_grad)

return

end subroutine GrdCls

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine redef
c
c        this routine redefine ideffab vector using infromation about
c        idle time on each nodes selected for sumoverab process
c
        use Para_Info, only: nProcs
        implicit none
#include "parallel.fh"
c
c        help variables
c
        integer i,ii
CLD        integer i,ii,rc
        REAL*8 tmin,eff,tabtot,tdisp,tdisptot,tidletot
        REAL*8 tminab,tdole
c
c0        escape, if nprocab=1, there is nothing to redistribute
c
        if (nprocab.eq.1) return
c
c1        distribute idtmab and ididle to all nodes
c
ctmp        do i=1,nProcs
ctmp    call MPI_BCAST (idtmab(i),1,
ctmp c  MPI_DOUBLE_PRECISION,(i-1),MPI_COMM_WORLD,rc)
ctmp    call MPI_BCAST (ididle(i),1,
ctmp c  MPI_DOUBLE_PRECISION,(i-1),MPI_COMM_WORLD,rc)
ctmp    end do
c        prepis pomocou GA, bcast ekvivalent nevieme
        call gadgop (idtmab(1),nProcs,'+')
        call gadgop (ididle(1),nProcs,'+')
c
c2        def real idle time for all nodes
c
        tmin=ididle(1)
        tminab=0.0d0
c
        do i=2,nProcs
        if (tmin.gt.ididle(i)) then
          tmin=ididle(i)
        end if
        end do
c
        do i=1,nProcs
          ididle(i)=ididle(i)-tmin
          if (tminab.lt.idtmab(i)) then
            tminab=idtmab(i)
          end if
        end do
c
c3        calc total time, used in prev. iteration for sumoverab process
c       + total idle time in prev. iter. (on nodes dedicated to ab
c         process)
c
        tabtot=0.0d0
        tidletot=0.0d0
        do ii=1,nprocab
        i=idab(ii)+1
          if (ideffab(ii).gt.0.0d0) then
            tabtot=tabtot+idtmab(i)
            tidletot=tidletot+ididle(i)
            if (tminab.gt.idtmab(i)) then
              tminab=idtmab(i)
            end if
          else
            tidletot=tidletot+ididle(i)
          end if
        end do
c
        tdole=tidletot/nprocab
c?      if (tdole.gt.tminab) tdole=tminab
c
c4        calc new redistribution
c
        tdisptot=0.0d0
        do ii=1,nprocab
        i=idab(ii)+1
          tdisp=idtmab(i)+ididle(i)-tdole
          if (tdisp.lt.0.0d0) tdisp=0.0d0
          if (ideffab(ii).eq.0.0d0) then
            eff=1.0d0
          else
            eff=ideffab(ii)/(idtmab(i)/tabtot)
          end if
cStare    tdisp=tdisp*eff
          tdisptot=tdisptot+tdisp
        end do
        write (6,*) 'Tab   ',tabtot
        write (6,*) 'Tidle ',tidletot
        write (6,*) 'Tdisp ',tdisptot
        write (6,*) 'Tddole',tdole
        write (6,*) 'Tminab',tminab
c
        do ii=1,nprocab
        i=idab(ii)+1
          tdisp=idtmab(i)+ididle(i)-tdole
          if (tdisp.lt.0.0d0) tdisp=0.0d0
          if (ideffab(ii).eq.0.0d0) then
            eff=1.0d0
          else
            eff=ideffab(ii)/(idtmab(i)/tabtot)
          end if
          write (6,*) ii,idtmab(i),ideffab(ii)
          write (6,*) eff,tdisp
c
cStare    tdisp=tdisp*eff
          ideffab(ii)=tdisp/tdisptot
c
           if (ideffab(ii).le.0.02) then
            ideffab(ii)=0.0d0
           end if
c
        end do
c
c5        renormalization of ideffab
c
        tabtot=0.0d0
        do ii=1,nprocab
             tabtot=tabtot+ideffab(ii)
        end do
        do ii=1,nprocab
             ideffab(ii)=ideffab(ii)/tabtot
          write (6,*) ii,ideffab(ii)
        end do
c

        ideffab(1)=0.116904633172297
        ideffab(2)=0.129270185505803
        ideffab(3)=0.140060191767431
        ideffab(4)=0.120813846670906
        ideffab(5)=0.086763031703814
        ideffab(6)=0.173676115414579
        ideffab(7)=0.232511995765169
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine POLY1_CLag(NCONF,NLEV,CI,CLag,RDMEIG)
! PER-AAKE MALMQUIST, 92-12-07
! THIS PROGRAM CALCULATES THE 1-EL DENSITY
! MATRIX FOR A CASSCF WAVE FUNCTION.

use caspt2_module, only: cLab10, iAdr10, MxCI
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NCONF, NLEV
real(kind=wp), intent(in) :: CI(NCONF), RDMEIG(NLEV**2)
real(kind=wp), intent(inout) :: CLag(NCONF)
real(kind=wp), allocatable :: SGM1(:)

if (NLEV > 0) then
  call MMA_ALLOCATE(SGM1,MXCI,LABEL='SGM1')
  call DENS1_RPT2_CLag(CI,NCONF,SGM1,MXCI,CLag,NCONF,RDMEIG,nLev)
end if
!return !! for test purpose

! REINITIALIZE USE OF DMAT.
! The fields IADR10 and CLAB10 are kept in caspt2_module
! CLAB10 replaces older field called LABEL.
IADR10(:,1) = -1
IADR10(:,2) = 0
CLAB10(:) = '   EMPTY'
IADR10(1,1) = 0
! HENCEFORTH, THE CALL PUT(NSIZE,LABEL,ARRAY) WILL ENTER AN
! ARRAY ON LUDMAT AND UPDATE THE TOC.
if (NLEV > 0) call MMA_DEALLOCATE(SGM1)

return

end subroutine POLY1_CLag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!***********************************************************************

subroutine COMP1(LJ,ITYP,L,IT2,II,IID,JJ,JJD,JTYP,ITAI)

use guga_global, only: COUP, IADD10, ICASE, ICOUP, ICOUP1, IOUT, IX, JNDX, LN, Lu_10, NBUF, NMAT
use guga_util_global, only: COP, ICOP1, nCOP
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LJ, ITYP, L, IT2, II, IID, JJ, JJD, JTYP, ITAI(*)
integer(kind=iwp) :: IC1, IC2, ICT, IN_, IN2, IND, ITAIL, JND1, JND2, JOJ, KK1, KTYP
real(kind=wp) :: FAC
integer(kind=iwp), external :: ICUNP

FAC = One
ITAIL = IX(IT2+LJ)
do IN_=1,ITAIL
  IC1 = ICOUP(1)+IN_
  JND1 = JNDX(II+IC1)
  if (JND1 == 0) cycle
  IN2 = ITAI(IN_)
  if (IN2 == 0) cycle
  IC2 = ICOUP1(1)+IN2
  if (ITYP == 1) then
    KK1 = (JND1-1)*LN+L
    JOJ = ICUNP(ICASE,KK1)
    if (JOJ > 1) JOJ = JOJ-1
    FAC = JOJ
    if (JOJ == 0) cycle
  end if
  IC1 = JND1-IID
  JND2 = JNDX(JJ+IC2)
  if (JND2 == 0) cycle
  IC2 = JND2-JJD
  IOUT = IOUT+1
  KTYP = JTYP
  if (JTYP > 3) then
    ICT = IC1
    IC1 = IC2
    IC2 = ICT
    KTYP = JTYP-3
  end if
  !IND = KTYP+2**6*IC2
  IND = ior(KTYP,ishft(IC2,6))
  !ICOP1(IOUT) = IND+2**19*IC1
  ICOP1(IOUT) = ior(IND,ishft(IC1,19))
  COP(IOUT) = FAC*COUP(1)
  if (IOUT < NBUF) cycle
  ICOP1(nCOP+1) = NBUF
  !write(u6,*) 'WRITING BUFFER IN COMP1'
  !write(u6,*) '======================='
  !write(u6,'(A,I6)') 'ICOP1(nCOP+1) ',ICOP1(nCOP+1)
  !write(u6,'(A,I6)') 'IADD10     ',IADD10
  call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
  call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
  NMAT = NMAT+NBUF
  IOUT = 0
end do

return

end subroutine COMP1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_MOReOrd(CMO,COrb1,COrb2,iMoType1,iMOType2)
!
! Jonas Bostrom, Jan. 2010. (modified from ChoMP2_MOReOrd)
!
! Purpose: Make CMO:s of appropriate length, transpose COrb2,
!
!          CMO(alpha,p) -> COrb1(p,alpha)
!          CMO(alpha,q) -> COrb2(alpha,q)

use Cholesky, only: nBas, nSym
use ChoMP2, only: iAoMo, iMoAo, nMo
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(_OUT_) :: COrb1(*), COrb2(*)
integer(kind=iwp), intent(in) :: iMoType1, iMOType2
integer(kind=iwp) :: i, iCount, iSym, jCount, kOff1, kOff2, nOffOrb1(8), nOffOrb2(8), nOrb1(8), nOrb2(8)

do iSym=1,nSym
  nOffOrb1(iSym) = sum(nMo(iSym,1:iMOType1-1))
  nOffOrb2(iSym) = sum(nMo(iSym,1:iMOType2-1))
  nOrb1(iSym) = nMo(iSym,iMOType1)
  nOrb2(iSym) = nMo(iSym,iMOType2)
end do

iCount = 0
do iSym=1,nSym

  jCount = iCount+nOffOrb1(iSym)*nBas(iSym)

  do i=1,nOrb1(iSym)
    kOff1 = jCount+nBas(iSym)*(i-1)+1
    kOff2 = iMoAo(iSym,iSym,iMoType1)+i
    call dCopy_(nBas(iSym),CMO(kOff1),1,COrb1(kOff2),nOrb1(iSym))
  end do

  kOff1 = iCount+nOffOrb2(iSym)*nBas(iSym)
  kOff2 = iAoMo(iSym,iSym,iMoType2)
  COrb2(kOff2+1:kOff2+nBas(iSym)*nOrb2(iSym)) = CMO(kOff1+1:kOff1+nBas(iSym)*nOrb2(iSym))

  iCount = iCount+nBas(iSym)*nBas(iSym)

end do

end subroutine ChoMP2g_MOReOrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_SetRed
*
*> @brief
*>   Read and set index arrays for reduced set \p iRed at location \p iLoc
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Reads information for reduced set \p iRed (= ``1``, ``2``, ..., \c MaxRed)
*> and sets up the index arrays
*>
*> - \p nnBstRT(iLoc)      &rarr; stored in cholesky.fh
*> - \p nnBstR(:,iLoc)     &rarr; stored in cholesky.fh
*> - \p iiBstR(:,iLoc)     &rarr; stored in cholesky.fh
*> - \p nnBstRSh(:,:,iLoc) &rarr; accesible via choswp.f90
*> - \p iiBstRSh(:,:,iLoc) &rarr; accesible via choswp.f90
*> - \p IndRed(:,iLoc)     &rarr; accesible via choswp.f90
*>
*> On succesful completion, \p irc = ``0`` is returned.
*> Note that the only allowed \p iLoc values are ``2`` and ``3``; any other
*> value gives rise to error code \p irc = ``1`` and nothing is done!
*> If \p iRed is out of bounds, \p irc = ``2`` is returned and nothing is done!
*>
*> @note
*> The Cholesky procedure must have been successfully initialized (by ::Cho_X_Init).
*>
*> @param[out] irc  return code
*> @param[in]  iLoc location in index arrays
*> @param[in]  iRed reduced set on disk
************************************************************************
      Subroutine Cho_X_SetRed(irc,iLoc,iRed)
      use ChoSwp, only: IndRed
#include "implicit.fh"
#include "cholesky.fh"

      If (iLoc.eq.2 .or. iLoc.eq.3) Then
         If (iRed.lt.1 .or. iRed.gt.MaxRed) Then
            irc = 2
         Else
            Call Cho_GetRed(iRed,iLoc,.false.)
            Call Cho_SetRedInd(iLoc)
            irc = 0
            If (iRed .eq. 1) Then ! set correct IndRed array
               Do iab = 1,SIZE(IndRed,1)
                  IndRed(iab,iLoc) = iab
               End Do
            End If
         End If
      Else
         irc = 1
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_Hoo(Hoo)
! check Hoo

use chcc_global, only: Hooc, no, nv, Q21, T1c, T2c
use stdalloc, only: mma_allocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Hoo(no,no)
integer(kind=iwp) :: a, b, bad, i, j, u
real(kind=wp) :: s

call mma_allocate(Hooc,no,no,label='Hooc')

bad = 0

do i=1,no
  do u=1,no

    s = Zero
    do j=1,no
      do a=1,nv
        do b=1,nv
          s = s+(Two*Q21(a,i,b,j)-Q21(a,j,b,i))*(T2c(a,b,u,j)+T1c(a,u)*T1c(b,j))
        end do
      end do
    end do

    Hooc(i,u) = s

    if (abs(Hoo(i,u)-s) > 1.0e-10_wp) then
      bad = bad+1
      !write(u6,*) Hoo(i,u),s
    end if

  end do
end do

write(u6,*) ' Hoo Chck :',bad

return

end subroutine Chck_Hoo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HSHPUT(KEYDIM,NCOMP,ITEM,NSIZE,ITAB,ITEMID)

use rassi_aux, only: MULT, NHASH
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: KEYDIM, NCOMP, ITEM(NCOMP,*), NSIZE, ITEMID
integer(kind=iwp), intent(inout) :: ITAB(NSIZE,2)
integer(kind=iwp) :: I, IFREE, IND, INULL, LOOKAT, NEXT

if (NSIZE < NHASH) then
  write(u6,*) ' HSHPUT: Table size must be at least as'
  write(u6,*) '         big as NHASH, presently =',NHASH
  call ABEND()
end if
INULL = ITAB(NSIZE,1)
IFREE = ITAB(NSIZE,2)
if (ITAB(IFREE,1) == INULL) then
  write(u6,*) ' HSHPUT: Table is already full.'
  write(u6,*) ' Size NSIZE is too small, NSIZE =',NSIZE
  call ABEND()
end if
! Evaluate hash index:
IND = mod(ITEM(1,ITEMID),NHASH)
do I=2,KEYDIM
  IND = mod(ITEM(I,ITEMID)+MULT*IND,NHASH)
end do
IND = IND+1
! IND is a hashed index in interval 1..NHASH < NSIZE
! Find the last item with this key:

LOOKAT = IND
do
  ! Are there already items with that hash signature?
  if (ITAB(LOOKAT,1) == INULL) exit
  LOOKAT = ITAB(LOOKAT,1)
end do

! No more items with the same signature.
! Put the new item in the table at a free location.
ITAB(LOOKAT,1) = IFREE
ITAB(LOOKAT,2) = ITEMID
NEXT = ITAB(IFREE,1)
ITAB(IFREE,1) = INULL
ITAB(NSIZE,2) = NEXT

end subroutine HSHPUT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine CrSph_mck(Win,nijx,nab,Coeff1,n1,Tr1,Pr1,Wout,mab)
!***********************************************************************
!                                                                      *
!  Object: to transform the one electron integrals from cartesian      *
!          basis to spherical basis.                                   *
!                                                                      *
! Called from: OneEl                                                   *
!                                                                      *
! Calling    : RecPrt                                                  *
!              DGEMM_   (ESSL)                                         *
!              DGeTMO   (ESSL)                                         *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             February '90                                             *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nijx, nab, n1, mab
real(kind=wp), intent(in) :: Win(nab*nijx), Coeff1(nTri_Elem1(n1),nTri_Elem1(n1))
real(kind=wp), intent(_OUT_) :: Wout(mab*nijx)
logical(kind=iwp), intent(in) :: Tr1, Pr1
integer(kind=iwp) :: k1, l1

!iRout = 26
!iPrint = nPrint(iRout)
l1 = nTri_Elem1(n1)
k1 = l1
if (Pr1) k1 = 2*n1+1

if (Tr1) then

  ! Starting with a,bIJx transforming to bIJx,A

  call DGEMM_('T','N',nijx,k1,l1,One,Win,l1,Coeff1,l1,Zero,Wout,nijx)

else

  ! Transpose from ab,IJ,x to b,IJ,x,a

  call DGeTmO(Win,l1,l1,nijx,Wout,nijx)

  ! Start transforming b,IJ,x,a to IJ,x,aB

end if

return

end subroutine CrSph_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Build_AMatrix(nAtoms,iANr,AMatrix,AInvMatrix,EC,
     &                         nij,Alpha)
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "constants.fh"
      Real*8 A(3), B(3), AMatrix(nAtoms,nAtoms),
     &       AInvMatrix(nAtoms,nAtoms), EC(3,nij)
      Integer iANr(nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
      Do iAtom = 1, nAtoms
         ii = iAtom*(iAtom+1)/2
         call dcopy_(3,EC(1,ii),1,A,1)
         R_BS_i=Bragg_Slater(iANr(iAtom))
         Do jAtom = 1, iAtom-1
            jj = jAtom*(jAtom+1)/2
            call dcopy_(3,EC(1,jj),1,B,1)
            R_BS_j=Bragg_Slater(iANr(jAtom))
            rij2=(A(1)-B(1))**2
     &          +(A(2)-B(2))**2
     &          +(A(3)-B(3))**2
            rij02=((R_BS_i+R_BS_j))**2
            AMatrix(iAtom,jAtom)= Exp(-Alpha*(rij2/rij02))/Two
            AMatrix(jAtom,iAtom)= Exp(-Alpha*(rij2/rij02))/Two
         End Do
*
         temp=zero
         Do jAtom = 1, nAtoms
            jj = jAtom*(jAtom+1)/2
            call dcopy_(3,EC(1,jj),1,B,1)
            R_BS_j=Bragg_Slater(iANr(jAtom))
            rij2=(A(1)-B(1))**2
     &          +(A(2)-B(2))**2
     &          +(A(3)-B(3))**2
            rij02=((R_BS_i+R_BS_j))**2
            If (jAtom.ne.iAtom) Then
               temp =temp- Exp(-Alpha*(rij2/rij02))/Two
            End If
         End Do
         AMatrix(iAtom,iAtom)=Temp
*
      End Do
c      Call RecPrt('A-matrix','(5G12.5)',AMatrix,nAtoms,nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
      Shift=Zero
      Do i = 1, nAtoms
         Do j = 1, i
            Shift=Max(Abs(AMatrix(i,j)),Shift)
         End Do
      End Do
      Shift=Two*Shift
C     Write (*,*) 'Shift=',Shift
      Call DaXpY_(nAtoms**2,Shift,[One],0,AMatrix,1)
c      Call RecPrt('A-matrix(Shifted)','(5G12.5)',AMatrix,nAtoms, nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
      Call MINV(AMatrix,AInvMatrix,ISING,DET,nAtoms)
c      Call RecPrt('AInv-matrix',' ',AIntMatrix,nAtoms,nAtoms)

*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Giovanni Li Manni                                *
!               2019, Oskar Weser                                      *
!***********************************************************************

module fcidump_reorder

use fcidump_tables, only: FockTable, length, OrbitalTable, TwoElIntTable
use sorting_funcs, only: leq_i
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
private

! n==0: Don't reorder.
! n>=2: User defined permutation with n non-fixed point elements.
! n==-1: Use GAS sorting scheme.
integer(kind=iwp) :: ReOrFlag = 0
integer(kind=iwp), allocatable :: ReOrInp(:)

public :: cleanup, get_P_GAS, get_P_inp, reorder, ReOrFlag, ReOrInp

interface reorder
  module procedure :: FockTable_reorder, TwoElIntTable_reorder, OrbitalTable_reorder, ALL_reorder
end interface reorder

contains

subroutine OrbitalTable_reorder(orbitals,P)

  type(OrbitalTable), intent(inout) :: orbitals
  integer(kind=iwp), intent(in) :: P(:)
  integer(kind=iwp) :: i

  do i=1,length(orbitals)
    orbitals%idx(i) = P(orbitals%idx(i))
  end do

end subroutine OrbitalTable_reorder

subroutine FockTable_reorder(fock,P)

  type(FockTable), intent(inout) :: fock
  integer(kind=iwp), intent(in) :: P(:)
  integer(kind=iwp) :: i, j

  do j=1,length(fock)
    do i=1,2
      fock%idx(i,j) = P(fock%idx(i,j))
    end do
  end do

end subroutine FockTable_reorder

subroutine TwoElIntTable_reorder(two_el_table,P)

  type(TwoElIntTable), intent(inout) :: two_el_table
  integer(kind=iwp), intent(in) :: P(:)
  integer(kind=iwp) :: i, j

  do j=1,length(two_el_table)
    do i=1,4
      two_el_table%idx(i,j) = P(two_el_table%idx(i,j))
    end do
  end do
  do j=1,length(two_el_table)
    do i=1,4
      two_el_table%idx(i,j) = P(two_el_table%idx(i,j))
    end do
  end do

end subroutine TwoElIntTable_reorder

function get_P_GAS(ngssh) result(P)

  use sorting, only: argsort
  use general_data, only: nSym
  use gas_data, only: nGAS

  integer(kind=iwp), intent(in) :: ngssh(:,:)
  integer(kind=iwp) :: P(sum(ngssh))
  integer(kind=iwp) :: i, iGAS, iSym
  integer(kind=iwp), allocatable :: X(:)

  call mma_allocate(X,sum(ngssh))
  X(:) = [(((iGAS,i=1,ngssh(iGAS,iSym)),iGAS=1,nGAS),iSym=1,nSym)]
  P(:) = argsort(X,leq_i)
  call mma_deallocate(X)

end function get_P_GAS

function get_P_inp(ReOrInp) result(P)

  use sorting, only: sort
  use general_data, only: nAsh

  integer(kind=iwp) :: P(sum(nAsh))
  integer(kind=iwp), intent(in) :: ReOrInp(:)
  integer(kind=iwp) :: i
  integer(kind=iwp), allocatable :: change_idx(:)

  call mma_allocate(change_idx,size(ReOrInp))
  P(:) = [(i,i=1,size(P))]
  change_idx(:) = ReOrInp
  call sort(change_idx,leq_i)
  P(change_idx) = ReOrInp
  call mma_deallocate(change_idx)

end function get_P_inp

subroutine ALL_reorder(orbitals,fock,two_el_table,orbsym,P)

  type(OrbitalTable), intent(inout) :: orbitals
  type(FockTable), intent(inout) :: fock
  type(TwoElIntTable), intent(inout) :: two_el_table
  integer(kind=iwp), intent(inout) :: orbsym(:)
  integer(kind=iwp), intent(in) :: P(:)

  call reorder(orbitals,P)
  call reorder(fock,P)
  call reorder(two_el_table,P)
  orbsym(:) = orbsym(P)

end subroutine ALL_reorder

subroutine cleanup()

  use fcidump_tables, only: mma_deallocate

  call mma_deallocate(ReOrInp,safe='*')

end subroutine cleanup

end module fcidump_reorder

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SONATORB_CPLOT(DENS,FILEBASE,CHARTYPE,ASS,BSS)

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri, sOpSiz
use rassi_aux, only: ipglob
use Symmetry_Info, only: nIrrep
use rassi_data, only: NBASF, NBMX, NBSQ, NBST, NBTRI
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: DENS(6,NBTRI)
character(len=*), intent(in) :: FILEBASE
character(len=8), intent(in) :: CHARTYPE
integer(kind=iwp), intent(in) :: ASS, BSS
integer(kind=iwp) :: I, I1, I1I, I2, ICMP, ID1, ID2, IDIR, IDUM(1), iDummy(7,8), IEND, II, II2, IJ, INV, INV2, IOCC, IOPT, IRC, &
                     ISCR, ISCRI, ISTART, ISYLAB, ISYM, ITYPE, J, JI, JOPT, LE, LE1, LS, LS1, LuXXVEC, LV, LV1, NB, NBMX2
real(kind=wp) :: Dummy(1), SUMI, SUMR
character(len=25) :: FNAME
character(len=16) :: FNUM, KNUM, XNUM
character(len=8) :: LABEL
character :: CDIR
real(kind=wp), allocatable :: DMAT(:), DMATI(:), EIG(:), OCC(:), SANG(:), SANGF(:), SANGTI(:), SANGTI2(:), SANGTR(:), SANGTR2(:), &
                              SCR(:), SCRI(:), SZZ(:), VEC(:), VEC2(:), VEC2I(:), VNAT(:), VNATI(:)
integer(kind=iwp), external :: IsFreeUnit

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! PLOTTING SECTION
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! Get the proper type of the property
select case (CHARTYPE)
  case ('HERMSING')
    ITYPE = 1
  case ('ANTISING')
    ITYPE = 2
  case ('HERMTRIP')
    ITYPE = 3
  case ('ANTITRIP')
    ITYPE = 4
  case default
    write(u6,*) 'RASSI/SONATORB internal error.'
    write(u6,*) 'Erroneous property type:',CHARTYPE
    call ABEND()
    ITYPE = 0
end select

NBMX2 = NBMX**2

! SZZ  - AO Overlap integral
! VEC  - AO Overlap eigenvectors
! EIG  - AO Overlap eigenvalues
! VEC2 - Eigenvectors of density matrix
! SCR  - Temporary for matrix multiplication
! NOTE: SCR COULD PROBABLY BE SOMETHING LIKE nTri_Elem(NBMX)
!       ALTHOUGH IT PROBABLY DOESN'T SAVE MUCH
!       (JACOB TAKES A TRIANGULAR MATRIX LIKE ZHPEV DOES?)
call mma_allocate(SZZ,NBTRI,Label='SZZ')
SZZ(:) = Zero
call mma_allocate(VEC,NBSQ,Label='VEC')
VEC(:) = Zero
call mma_allocate(VEC2,NBMX2,Label='VEC2')
VEC2(:) = Zero
call mma_allocate(VEC2I,NBMX2,Label='VEC2I')
VEC2I(:) = Zero
call mma_allocate(SCR,NBMX2,Label='SCR')
SCR(:) = Zero
call mma_allocate(SCRI,NBMX2,Label='SCRI')
SCRI(:) = Zero
call mma_allocate(EIG,NBST,Label='EIG')
EIG(:) = Zero

call mma_allocate(VNAT,NBSQ,Label='VNAT')
VNAT(:) = Zero
call mma_allocate(VNATI,NBSQ,Label='VNATI')
VNATI(:) = Zero
call mma_allocate(OCC,NBST,Label='OCC')
OCC(:) = Zero

! READ ORBITAL OVERLAP MATRIX.
IRC = -1

! IOPT=6, origin and nuclear contrib not read
IOPT = ibset(ibset(0,sNoOri),sNoNuc)
ICMP = 1
ISYLAB = 1
LABEL = 'MLTPL  0'
call RDONE(IRC,IOPT,LABEL,ICMP,SZZ,ISYLAB)
if (IRC /= 0) then
  write(u6,*)
  write(u6,*) '      *** ERROR IN SUBROUTINE  SONATORB ***'
  write(u6,*) '      OVERLAP INTEGRALS ARE NOT AVAILABLE'
  write(u6,*)
  call ABEND()
end if

! DIAGONALIZE EACH SYMMETRY BLOCK OF THE OVERLAP MATRIX.
LS = 1
LV = 1
LE = 1
do ISYM=1,nIrrep
  NB = NBASF(ISYM)
  call unitmat(VEC(LV:LV+NB**2-1),NB)
  call JACOB(SZZ(LS),VEC(LV),NB,NB)
  ! SCALE EACH VECTOR TO OBTAIN AN ORTHONORMAL BASIS.
  LS1 = LS
  LV1 = LV
  LE1 = LE
  do I=1,NB
    EIG(LE1) = SZZ(LS1)
    VEC(LV1:LV1+NB-1) = VEC(LV1:LV1+NB-1)/sqrt(max(SZZ(LS1),1.0e-14_wp))
    LS1 = LS1+I+1
    LV1 = LV1+NB
    LE1 = LE1+1
  end do
  LS = LS+nTri_Elem(NB)
  LV = LV+NB**2
  LE = LE+NB
end do

call mma_deallocate(SZZ)

call mma_allocate(DMAT,NBMX2,Label='DMAT')
call mma_allocate(DMATI,NBMX2,Label='DMATI')

if (ITYPE <= 2) then
  ISTART = 3
  IEND = 3
else
  ISTART = 1
  IEND = 3
end if

do IDIR=ISTART,IEND

  CDIR = '?'
  if (IDIR == 1) CDIR = 'X'
  if (IDIR == 2) CDIR = 'Y'
  if (IDIR == 3) CDIR = 'Z'

  !ccccccccccccccccccccccc
  !ccccccccccccccccccccccc
  !ccccccccccccccccccccccc
  !ccccccccccccccccccccccc
  ! read in ao matrix for angmom or mltpl
  call mma_allocate(SANG,NBTRI,Label='SANG')
  SANG(:) = Zero

  IRC = -1
  IOPT = ibset(ibset(0,sNoOri),sNoNuc)
  JOPT = ibset(0,sOpSiz)

  if ((ITYPE == 1) .or. (ITYPE == 3)) then
    ICMP = 1
    LABEL = 'MLTPL  0'
    call iRDONE(IRC,JOPT,LABEL,ICMP,IDUM,ISYLAB)
    call RDONE(IRC,IOPT,LABEL,ICMP,SANG,ISYLAB)

    if (IRC /= 0) then
      write(u6,*)
      write(u6,*) '      *** ERROR IN SUBROUTINE  SONATORB ***'
      write(u6,*) '      MLTPL0 INTEGRALS ARE NOT AVAILABLE'
      write(u6,*) '      IRC:',IRC
      write(u6,*)
      call ABEND()
    end if

  else if ((ITYPE == 2) .or. (ITYPE == 4)) then
    ICMP = 3
    LABEL = 'ANGMOM'
    call iRDONE(IRC,JOPT,LABEL,ICMP,IDUM,ISYLAB)
    call RDONE(IRC,IOPT,LABEL,ICMP,SANG,ISYLAB)

    if (IRC /= 0) then
      write(u6,*)
      write(u6,*) '      *** ERROR IN SUBROUTINE  SONATORB ***'
      write(u6,*) '      ANGMOM INTEGRALS ARE NOT AVAILABLE'
      write(u6,*) '      IRC:',IRC
      write(u6,*)
      call ABEND()
    end if

  end if

  !ccccccccccccccccccccccc
  !ccccccccccccccccccccccc
  !ccccccccccccccccccccccc
  !ccccccccccccccccccccccc
  INV = 1
  II2 = 0
  IOCC = 0
  LV = 1
  LE = 1
  do ISYM=1,nIrrep
    NB = NBASF(ISYM)
    if (NB == 0) cycle

    ! TRANSFORM TO ORTHONORMAL BASIS. THIS REQUIRES THE CONJUGATE
    ! BASIS, BUT SINCE WE USE CANONICAL ON BASIS THIS AMOUNTS TO A
    ! SCALING WITH THE EIGENVALUES OF THE OVERLAP MATRIX:

    ! expand the triangular matrix for this symmetry to a square matrix
    DMAT(:) = Zero
    DMATI(:) = Zero
    SCR(:) = Zero
    SCRI(:) = Zero

    do J=1,NB
      do I=1,J
        II2 = II2+1
        IJ = NB*(J-1)+I
        JI = NB*(I-1)+J
        if (I /= J) then
          DMAT(IJ) = DENS(IDIR,II2)/Two
          DMAT(JI) = DENS(IDIR,II2)/Two
          DMATI(IJ) = -DENS(IDIR+3,II2)/Two
          DMATI(JI) = DENS(IDIR+3,II2)/Two
        else
          DMAT(IJ) = DENS(IDIR,II2)
          DMATI(JI) = DENS(IDIR+3,II2)
        end if
      end do
    end do

    call DGEMM_('N','N',NB,NB,NB,One,DMAT,NB,VEC(LV),NB,Zero,SCR,NB)
    call DGEMM_('N','N',NB,NB,NB,One,DMATI,NB,VEC(LV),NB,Zero,SCRI,NB)

    call DGEMM_('T','N',NB,NB,NB,One,VEC(LV),NB,SCR,NB,Zero,DMAT,NB)
    call DGEMM_('T','N',NB,NB,NB,One,VEC(LV),NB,SCRI,NB,Zero,DMATI,NB)

    ID1 = 1
    ID2 = 1
    do I=1,NB
      call DSCAL_(NB,EIG(LE-1+I),DMAT(ID1),NB)
      DMAT(ID2:ID2+NB-1) = EIG(LE-1+I)*DMAT(ID2:ID2+NB-1)
      call DSCAL_(NB,EIG(LE-1+I),DMATI(ID1),NB)
      DMATI(ID2:ID2+NB-1) = EIG(LE-1+I)*DMATI(ID2:ID2+NB-1)
      ID1 = ID1+1
      ID2 = ID2+NB
    end do

    ! SYMMETRIZE THIS BLOCK INTO SCRATCH AREA, TRIANGULAR STORAGE:
    SCR(:) = Zero
    SCRI(:) = Zero

    ISCR = 1
    ISCRI = 1
    do I=1,NB
      do J=1,I
        IJ = I+NB*(J-1)
        JI = J+NB*(I-1)
        ! simple averaging
        SCR(ISCR) = (DMAT(JI)+DMAT(IJ))/Two
        SCRI(ISCRI) = (DMATI(JI)-DMATI(IJ))/Two
        ! add a factor of two to convert spin -> sigma
        if (ITYPE >= 3) SCR(ISCR) = SCR(ISCR)*Two
        if (ITYPE >= 3) SCRI(ISCRI) = SCRI(ISCRI)*Two
        ISCR = ISCR+1
        ISCRI = ISCRI+1
      end do
    end do

    ! DIAGONALIZE THE DENSITY MATRIX BLOCK:
    VEC2(:) = Zero
    VEC2I(:) = Zero

    call CPLOT_DIAG(SCR,SCRI,NB,VEC2,VEC2I)

    ! LAPACK ORDERS BY INCREASING EIGENVALUE. REVERSE THIS ORDER.
    II = 0
    do I=1,NB
      II = II+I
      OCC(IOCC+NB+1-I) = SCR(II)
    end do
    IOCC = IOCC+NB

    ! REEXPRESS THE EIGENVECTORS IN AO BASIS FUNCTIONS. REVERSE ORDER.
    call DGEMM_('N','N',NB,NB,NB,One,VEC(LV),NB,VEC2,NB,Zero,SCR,NB)
    call DGEMM_('N','N',NB,NB,NB,One,VEC(LV),NB,VEC2I,NB,Zero,SCRI,NB)

    I1 = 1
    I1I = 1
    I2 = INV+NB**2
    do I=1,NB
      I2 = I2-NB
      VNAT(I2:I2+NB-1) = SCR(I1:I1+NB-1)
      VNATI(I2:I2+NB-1) = SCRI(I1:I1+NB-1)
      I1 = I1+NB
      I1I = I1I+NB
    end do
    INV = INV+NB**2
    LV = LV+NB**2
    LE = LE+NB
  end do

  !CCCCCCCCCCCCCCCCCCCCCCCCCCCC
  !CCCCCCC TESTING
  !CCCCCCCCCCCCCCCCCCCCCCCCCCCC
  if (IPGLOB >= 4) then

    call mma_allocate(SANGF,NBMX**2,Label='SANGF')
    SANGF(:) = Zero
    call mma_allocate(SANGTR,NBMX**2,Label='SANGTR')
    call mma_allocate(SANGTI,NBMX**2,Label='SANGTI')
    SANGTR(:) = Zero
    SANGTI(:) = Zero
    call mma_allocate(SANGTR2,NBMX**2,Label='SANGTR2')
    call mma_allocate(SANGTI2,NBMX**2,Label='SANGTI2')
    SANGTR2(:) = Zero
    SANGTI2(:) = Zero

    INV = 0
    INV2 = 0
    II = 0
    SUMR = Zero
    SUMI = Zero

    do ISYM=1,nIrrep
      NB = NBASF(ISYM)
      if (NB /= 0) then

        ! Expand integrals for this symmetry to full storage
        SANGF(:) = Zero

        do J=1,NB
          do I=1,J
            IJ = NB*(J-1)+I-1
            JI = NB*(I-1)+J-1

            SANGF(1+JI) = SANG(1+II)

            if (I /= J) then
              if ((ITYPE == 2) .or. (ITYPE == 4)) then
                SANGF(1+IJ) = -SANG(1+II)
              else
                SANGF(1+IJ) = SANG(1+II)
              end if
            end if

            II = II+1

          end do
        end do

        if ((ITYPE == 1) .or. (ITYPE == 3)) then
          call DGEMM_('T','N',NB,NB,NB,One,SANGF,NB,VNAT(1+INV),NB,Zero,SANGTR,NB)
          call DGEMM_('T','N',NB,NB,NB,One,SANGF,NB,VNATI(1+INV),NB,Zero,SANGTI,NB)

          call DGEMM_('T','N',NB,NB,NB,One,VNAT(1+INV),NB,SANGTR,NB,Zero,SANGTR2,NB)
          call DGEMM_('T','N',NB,NB,NB,One,VNATI(1+INV),NB,SANGTI,NB,One,SANGTR2,NB)

          call DGEMM_('T','N',NB,NB,NB,-One,VNATI(1+INV),NB,SANGTR,NB,Zero,SANGTI2,NB)
          call DGEMM_('T','N',NB,NB,NB,One,VNAT(1+INV),NB,SANGTI,NB,One,SANGTI,NB)

        else if ((ITYPE == 2) .or. (ITYPE == 4)) then

          call DGEMM_('T','N',NB,NB,NB,One,SANGF,NB,VNAT(1+INV),NB,Zero,SANGTI,NB)
          call DGEMM_('T','N',NB,NB,NB,-One,SANGF,NB,VNATI(1+INV),NB,Zero,SANGTR,NB)

          call DGEMM_('T','N',NB,NB,NB,One,VNAT(1+INV),NB,SANGTR,NB,Zero,SANGTR2,NB)
          call DGEMM_('T','N',NB,NB,NB,One,VNATI(1+INV),NB,SANGTI,NB,One,SANGTR2,NB)

          call DGEMM_('T','N',NB,NB,NB,-One,VNATI(1+INV),NB,SANGTR,NB,Zero,SANGTI2,NB)
          call DGEMM_('T','N',NB,NB,NB,One,VNAT(1+INV),NB,SANGTI,NB,One,SANGTI2,NB)

        end if

        ! Sum over the trace
        do I=1,NB
          IJ = I+(I-1)*NB-1
          SUMR = SUMR+OCC(I+INV2)*SANGTR2(1+IJ)
          SUMI = SUMI+OCC(I+INV2)*SANGTI2(1+IJ)
        end do

      end if

      INV = INV+NB**2
      INV2 = INV2+NB

    end do

    write(u6,*) 'Ben P TEST for JA:'
    write(u6,*) 'REAL: ',SUMR
    write(u6,*) 'IMAG: ',SUMI

    call mma_deallocate(SANGF)
    call mma_deallocate(SANGTR)
    call mma_deallocate(SANGTI)
    call mma_deallocate(SANGTR2)
    call mma_deallocate(SANGTI2)
  end if ! IPGLOB >= 4

  call mma_deallocate(SANG)

  ! WRITE OUT THIS SET OF NATURAL SPIN ORBITALS
  ! REAL PART
  if (ITYPE <= 2) then
    write(KNUM,'(I2.2,A,I2.2,A,A)') ASS,'.',BSS,'.','R'
  else
    write(KNUM,'(I2.2,A,I2.2,A,A,A,A)') ASS,'.',BSS,'.',CDIR,'.','R'
  end if
  write(FNUM,'(I8)') BSS
  FNUM = adjustl(FNUM)
  if (ASS /= BSS) then
    write(XNUM,'(I8,A)') ASS,'_'//trim(FNUM)
    FNUM = adjustl(XNUM)
  end if
  if (ITYPE > 2) FNUM = CDIR//trim(FNUM)

  FNAME = FILEBASE//'.'//trim(FNUM)//'.R'
  select case (ITYPE)
    case (1)
      write(u6,'(A,A)') ' NATURAL ORBITALS FOR ',KNUM
    case (2)
      write(u6,'(A,A)') ' ANTISING NATURAL ORBITALS FOR  ',KNUM
    case (3)
      write(u6,'(A,A)') ' NATURAL SPIN ORBITALS FOR  ',KNUM
    case (4)
      write(u6,'(A,A)') ' ANTITRIP NATURAL ORBITALS FOR  ',KNUM
  end select

  write(u6,'(A,A)') ' ORBITALS ARE WRITTEN ONTO FILE ',FNAME

  LuxxVec = isfreeunit(50)

  call WRVEC(FNAME,LUXXVEC,'CO',nIrrep,NBASF,NBASF,VNAT,OCC,Dummy,iDummy,'* DENSITY FOR PROPERTY TYPE '//CHARTYPE//KNUM)

  ! IMAGINARY PART
  if (ITYPE <= 2) then
    write(KNUM,'(I2.2,A,I2.2,A,A)') ASS,'.',BSS,'.','I'
  else
    write(KNUM,'(I2.2,A,I2.2,A,A,A,A)') ASS,'.',BSS,'.',CDIR,'.','I'
  end if

  FNAME = FILEBASE//'.'//trim(FNUM)//'.I'
  select case (ITYPE)
    case (1)
      write(u6,'(A,A)') ' NATURAL ORBITALS FOR ',KNUM
    case (2)
      write(u6,'(A,A)') ' ANTISING NATURAL ORBITALS FOR  ',KNUM
    case (3)
      write(u6,'(A,A)') ' NATURAL SPIN ORBITALS FOR  ',KNUM
    case (4)
      write(u6,'(A,A)') ' ANTITRIP NATURAL ORBITALS FOR  ',KNUM
  end select

  write(u6,'(A,A)') ' ORBITALS ARE WRITTEN ONTO FILE ',FNAME

  LuxxVec = isfreeunit(LuxxVec)

  call WRVEC(FNAME,LUXXVEC,'CO',nIrrep,NBASF,NBASF,VNATI,OCC,Dummy,iDummy,'* DENSITY FOR PROPERTY TYPE '//CHARTYPE//KNUM)

  !Test a few values
  !call ADD_INFO('SONATORB_CPLOTR',VNAT,1,4)
  !call ADD_INFO('SONATORB_CPLOTI',VNATI,1,4)
  !call ADD_INFO('SONATORB_CPLOTO',OCC,1,4)

end do

call mma_deallocate(DMAT)
call mma_deallocate(DMATI)
call mma_deallocate(VEC)
call mma_deallocate(VEC2)
call mma_deallocate(VEC2I)
call mma_deallocate(SCR)
call mma_deallocate(SCRI)
call mma_deallocate(VNAT)
call mma_deallocate(VNATI)
call mma_deallocate(OCC)

end subroutine SONATORB_CPLOT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ext_o_32(A,B,nc,no,dima,occ_ind)
! this routine does:
!
! extract B (m,a')_i <- A (m,i,a')

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nc, no, dima, occ_ind
real(kind=wp), intent(in) :: A(nc,no,dima)
real(kind=wp), intent(out) :: B(nc,dima)
integer(kind=iwp) :: i2

do i2=1,dima
  B(:,i2) = A(:,occ_ind,i2)
end do

return

end subroutine ext_o_32

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADS1(NK,I1,XI1S,LI1,IORB,LORB,ICLS,ISM,IMAPO,IMAPS,IMPL,IMPO,IMPF,LMAP,IEL1,IEL3,I1EL1,I1EL3,ISSO,I1SSO,N1SSO,NOCTP, &
                N1OCTP,NORB1,NORB2,ORBSM,KMAX,KMIN,IEND)
! Obtain I1(KSTR) = +/- A+ IORB !KSTR>
!
! KSTR is restricted to strings with relative numbers in the
! range KMAX to KMIN

! =====
! Input
! =====
! IORB        : Firat orbital to be added
! LORB        : Number of orbitals to be added : IORB to IORB-1+LORB
!               are used. They must all be in the same TS group
! ICLS,ISM    : Class and symmetry of string with added electron
! IMAPO,IMAPS : map from Kstrings to Istrings
! IEL1(3)     : Number of electrons in RAS1(3) for I strings
! I1EL1(3)    : Number of electrons in RAS1(3) for K strings
! ISSO        : TS symmetry offset for I strings
! I1SSO       : TS symmetry offset for K strings
! N1SSO       : Number of TS strings for K strings
! NOCTP       : Number of occupation types for I strings
! N1OCTP      : Number of occupation types for K strings
! NORB1(2,3)  : Number of RAS1(2,3) orbitals
! IORBSM      : Orbital symmety array
! KMAX        : Largest allowed relative number for K strings
!               If Kmax is set to -1 all strings are searched
! KMIN        : Smallest allowed relative number for K strings
!
! ======
! Output
! ======
! NK              : Number of K strings
! I1(KSTR,JORB)   : /= 0 => a + JORB !KSTR> = +/-!ISTR>
! XI1S(KSTR,JORB) : above +/-
!                 : == 0    a + JORB !KSTR> = 0
! Offset is KMIN

use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: NK, IEND
integer(kind=iwp), intent(_OUT_) :: I1(*)
real(kind=wp), intent(_OUT_) :: XI1S(*)
integer(kind=iwp), intent(in) :: LI1, IORB, LORB, ICLS, ISM, IMAPO(*), IMAPS(*), IMPL(*), IMPO(*), IMPF, LMAP, IEL1(*), IEL3(*), &
                                 I1EL1(*), I1EL3(*), NOCTP, ISSO(NOCTP,*), N1OCTP, I1SSO(N1OCTP,*), N1SSO(N1OCTP,*), NORB1, NORB2, &
                                 ORBSM(*), KMAX, KMIN
integer(kind=iwp) :: IIIORB, IIORB, IOFF, IORBR, ISTR, KEL1, KEL3, KEND, KKTYPE, KOFF, KREL, KSM, KSTR, KSUB, KTYPE, LDIM
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IIORBR
#endif
logical(kind=iwp) :: Skip

LDIM = 0 ! dummy initialize
#ifdef _DEBUGPRINT_
write(u6,*) ' =============='
write(u6,*) ' ADSTS speaking'
write(u6,*) ' =============='
write(u6,*) ' IORB,ISM,ICLS',IORB,ISM,ICLS
write(u6,*) ' IMPF, LMAP ',IMPF,LMAP
write(u6,*) ' N1SSO :'
call IWRTMA(N1SSO,N1OCTP,8,N1OCTP,8)
#endif
NK = KMAX-KMIN+1
! Type of kstrings
if (IORB <= NORB1) then
  KEL1 = IEL1(ICLS)-1
  KEL3 = IEL3(ICLS)
else if (IORB <= NORB1+NORB2) then
  KEL1 = IEL1(ICLS)
  KEL3 = IEL3(ICLS)
else
  KEL1 = IEL1(ICLS)
  KEL3 = IEL3(ICLS)-1
end if
KTYPE = 0
!write(u6,*) ' N1OCTP ',N1OCTP
do KKTYPE=1,N1OCTP
  if ((I1EL1(KKTYPE) == KEL1) .and. (I1EL3(KKTYPE) == KEL3)) KTYPE = KKTYPE
end do
!write(u6,*) ' kel1 kel3 ktype ',KEL1,KEL3,KTYPE
Skip = .false.
if (KTYPE == 0) then
  NK = 0
  IEND = 1
  Skip = .true.
else
  ! Symmetry of K strings
  KSM = Mul(ORBSM(IORB),ISM)
  if (KSM == 0) then
    NK = 0
    IEND = 1
    Skip = .true.
  end if
end if
if (.not. Skip) then
  KOFF = I1SSO(KTYPE,KSM)
  !write(u6,*) ' KTYPE KSM ',KTYPE,KSM
  if (KMAX == -1) then
    KEND = N1SSO(KTYPE,KSM)
  else
    KEND = min(N1SSO(KTYPE,KSM),KMAX)
  end if
  if (KEND < N1SSO(KTYPE,KSM)) then
    IEND = 0
  else
    IEND = 1
  end if
  NK = KEND-KMIN+1
  if (KMAX == -1) then
    LDIM = NK
  else
    LDIM = LI1
  end if
  !if (KMAX == -1) write(u6,*) ' KMAX = -1, LDIM=',LDIM
  IOFF = ISSO(ICLS,ISM)
  KSUB = KOFF+KMIN-2
  do IIORB=IORB,IORB+LORB-1
    IORBR = IIORB-IORB+1
    do KSTR=KOFF+KMIN-1,KOFF+KEND-1
      !write(u6,*) ' KSTR = ',KSTR
      KREL = KSTR-KSUB

      ISTR = 0
      if (IMPF == 1) then
        if (IMAPO((KSTR-1)*LMAP+IIORB) == IIORB) ISTR = IMAPS((KSTR-1)*LMAP+IIORB)
      else
        !write(u6,*) ' IMPL = ',IMPL(KSTR)
        !write(u6,*) ' IMPO = ',IMPO(KSTR)
        do IIIORB=1,IMPL(KSTR)
          if (IMAPO(IMPO(KSTR)-1+IIIORB) == IIORB) ISTR = IMAPS(IMPO(KSTR)-1+IIIORB)
        end do
      end if
      if (ISTR > 0) then
        I1(KREL+(IORBR-1)*LDIM) = ISTR-IOFF+1
        XI1S(KREL+(IORBR-1)*LDIM) = One
      else if (ISTR < 0) then
        I1(KREL+(IORBR-1)*LDIM) = -ISTR-IOFF+1
        XI1S(KREL+(IORBR-1)*LDIM) = -One
      else if (ISTR == 0) then
        I1(KREL+(IORBR-1)*LDIM) = 0
        XI1S(KREL+(IORBR-1)*LDIM) = Zero
      end if
    end do
  end do
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from ASTR'
write(u6,*) ' ================'
write(u6,*) ' Number of K strings accessed ',NK
if (NK /= 0) then
  do IIORB=IORB,IORB+LORB-1
    IIORBR = IIORB-IORB
    write(u6,*) ' Info for orbital ',IIORB
    write(u6,*) ' Excited strings and sign'
    call IWRTMA(I1(IIORBR*LDIM+1),1,NK,1,NK)
    call WRTMAT(XI1S(IIORBR*LDIM+1),1,NK,1,NK)
  end do
end if
#endif

end subroutine ADS1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine GetInfo_Localisation_0()
C
C     Author: T.B. Pedersen
C
C     Purpose: read basic info from runfile and INPORB.
C
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "inflocal.fh"
#include "WrkSpc.fh"

      Character*22 SecNam
      Parameter (SecNam = 'GetInfo_Localisation_0')
      Character*80 Txt
      Character*512 FName

C     Read number of irreps.
C     ----------------------

      Call Get_iScalar('nSym',nSym)
      If (nSym.lt.1 .or. nSym.gt.MxSym) Then
         Write(Txt,'(A,I9)') 'nSym =',nSym
         Call SysAbendMsg(SecNam,'Number of irreps out of bounds!',Txt)
      End If

C     Read number of basis functions.
C     -------------------------------

      Call Get_iArray('nBas',nBas,nSym)
      nBasT = nBas(1)
      Do iSym = 2,nSym
         nBasT = nBasT + nBas(iSym)
      End Do
      If (nBasT.lt.1 .or. nBasT.gt.MxBas) Then
         Write(Txt,'(A,I9)') 'nBasT =',nBasT
         Call SysAbendMsg(SecNam,'Basis set limits exceeded!',Txt)
      End If

C     Set number of orbitals equal to nBas.
C     -------------------------------------

      Call Icopy(nSym,nBas,1,nOrb,1)
      nOrbT = nOrb(1)
      Do iSym = 2,nSym
         nOrbT = nOrbT + nOrb(iSym)
      End Do
      If (nOrbT.lt.1 .or. nOrbT.gt.MxBas) Then
         Write(Txt,'(A,I9)') 'nOrbT =',nOrbT
         Call SysAbendMsg(SecNam,'Orbital limits exceeded!',Txt)
      End If
      Do iSym=1,nSym
         If (nOrb(iSym) .gt. nBas(iSym)) Then
            Write(Txt,'(A,I2,2(1X,I9))')
     &      'iSym,nOrb,nBas:',iSym,nOrb(iSym),nBas(iSym)
            Call SysAbendMsg(SecNam,'#orb > #bas:',Txt)
         End If
      End Do

C     Read MO coefficients, orbital occupations, and orbital energies
C     from INPORB.
C     ---------------------------------------------------------------

      n2Bas = nBas(1)**2
      Do iSym = 2,nSym
         n2Bas = n2Bas + nBas(iSym)**2
      End Do

      nCMO = n2Bas
      lOcc = nBasT
      lEor = nBasT
      lInd = nBasT
      Call GetMem('CMO','Allo','Real',ipCMO,nCMO)
      Call GetMem('Occup','Allo','Real',ipOcc,lOcc)
      Call GetMem('OrbEn','Allo','Real',ipEor,lEor)
      Call GetMem('IndT','Allo','Inte',ipInd,lInd)
      FName=LC_FileOrb
      If (mylen(FName).eq.0) FName='INPORB' ! file name
      Call RdVec_Localisation(nSym,nBas,nOrb,iWork(ipInd),
     &                        Work(ipCMO),Work(ipOcc),Work(ipEor),
     &                        FName(:mylen(FName)))

C     Set number of occupied and virtual orbitals according to the
C     occupation numbers from INPORB (assuming that occupied orbitals
C     precede virtual ones on file).
C     ---------------------------------------------------------------

      kOff = ipOcc - 1
      Do iSym = 1,nSym
         nOccInp(iSym) = 0
         i = 0
         Do While (i .lt. nOrb(iSym))
            i = i + 1
            If (Work(kOff+i) .gt. 0.0d0) Then
               nOccInp(iSym) = nOccInp(iSym) + 1
            Else
               i = nOrb(iSym) ! break while loop
            End If
         End Do
         nVirInp(iSym) = nOrb(iSym) - nOccInp(iSym)
         If (nVirInp(iSym) .lt. 0) Then
            Write(Txt,'(3(A,I9))')
     &      'No. of occupied: ',nOccInp(iSym),
     &      ' No. of orbitals: ',nOrb(iSym),
     &      ' Symmetry: ',iSym
            Call SysAbendMsg(SecNam,'#occ > #orb:',Txt)
         End If
         kOff = kOff + nBas(iSym)
      End Do

C     Read number of atoms, atomic labels, and basis function labels
C     from runfile.
C     --------------------------------------------------------------

      Call Get_nAtoms_All(nAtoms)
      If (nAtoms.lt.1 .or. nAtoms.gt.MxAtom) Then
         Write(Txt,'(A,I9)') 'nAtoms =',nAtoms
         Call SysAbendMsg(SecNam,'Atom limit exceeded!',Txt)
      End If
c     Call Get_cArray('Unique Atom Names',AtomLbl,4*nAtoms)
      Call Get_cArray('Unique Basis Names',Name,(LENIN8)*nBasT)
      Do i = 1,nBasT
         Atom(i) = Name(i)(1:LENIN)
         Type(i) = Name(i)(LENIN1:LENIN8)
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TraCtl2(CMO,PUVX,TUVX,D1I,FI,D1A,FA,IPR,lSquare,ExFac)
!***********************************************************************
!                                                                      *
!     main control section for Cholesky-based vs conventional          *
!     - transformation of ERIs from AO to MO basis                     *
!     - Fock matrix generation                                         *
!                                                                      *
!***********************************************************************

use Fock_util_global, only: ALGO, DoCholesky
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
#endif
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*), D1I(*), D1A(*), ExFac
real(kind=wp), intent(inout) :: PUVX(*), FI(*), FA(*)
real(kind=wp), intent(_OUT_) :: TUVX(*)
integer(kind=iwp), intent(in) :: IPR
logical(kind=iwp), intent(in) :: lSquare
#include "rasdim.fh"
#include "general.fh"
#include "wadr.fh"
integer(kind=iwp) :: iDisk, irc
logical(kind=iwp) :: TraOnly

!call DecideOnCholesky(DoCholesky)

!)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

if (.not. DoCholesky) then

  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

  call TRA_CTL2(CMO,PUVX,TUVX,D1I,FI,D1A,FA,IPR,lSquare,ExFac)

  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

else if (ALGO == 1) then

  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

  TraOnly = .false.
  call CHO_CAS_DRV(irc,CMO,D1I,FI,D1A,FA,PUVX,TraOnly)

# ifdef _MOLCAS_MPP_
  ! --------------------------------------------------
  ! Synchronize Fock matrices if running parallel:
  if ((nProcs > 1) .and. Is_Real_Par()) then
    call GADsum(FI,nTot1)
    call GADsum(FA,nTot1)
    ! Synchronize PUVX if running parallel:
    call GADsum(PUVX,nPWXY)
  end if
# endif
  ! --------------------------------------------------
  ! select integrals TUVX
  call Get_TUVX(PUVX,TUVX)
  ! save integrals on disk
  ! nPWXY is computed in cho_eval_waxy and stored in wadr.fh
  iDisk = 0
  call DDaFile(LUINTM,1,PUVX,nPWXY,iDisk)

  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

else if (ALGO == 2) then

  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

  TraOnly = .false.
  call CHO_CAS_DRV(irc,CMO,D1I,FI,D1A,FA,PUVX,TraOnly)

  if (irc /= 0) then
    write(u6,*) 'TRACTL2: Cho_cas_drv non-Zero return code. rc= ',irc
    call Abend()
  end if

  ! Synchronization for parallel runs is done in cho_cas_drv

  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

end if

!)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()

return

end subroutine TraCtl2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cvbstart_rvb_lt9(icode)
      use definitions, only: iwp
      use constants, only: Zero
      use casvb_global, only: endvar, iprm, iunset, lstprm, recinp,
     &                        recinp_old, variat
      implicit none
      integer(kind=iwp), intent(in):: icode

      variat=(mod(icode,10).ne.0)
      endvar=(mod(icode,10).eq.2)
      recinp=Zero
      recinp_old=zero
      lstprm(:) = iunset
      iprm = 0
      if(.not.variat)call casinfo1_rvb()

      end subroutine cvbstart_rvb_lt9

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1992, Per Ake Malmqvist                                *
!***********************************************************************

subroutine SetUpR(nRys)
!***********************************************************************
!                                                                      *
! Object: to setup the coefficients for the Rys roots and weights.     *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             September '90                                            *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Cehmistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified to DaFile February '91                          *
!                                                                      *
!     Added: Call to READAB, P.-A. Malmqvist March 1992, to set up     *
!             the tables needed to calculate large-order roots and     *
!             weights on request.                                      *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW, MaxHer
use vRys_RW, only: HerR2, HerW2, iHerR2, iHerW2
use abdata, only: read_abdata
use stdalloc, only: mma_allocate
use Definitions, only: iwp
#ifdef _RYS_SCRATCH_
use RysScratch, only: SetAux
use Definitions, only: wp
#endif

implicit none
integer(kind=iwp), intent(in) :: nRys
integer(kind=iwp) :: iHer, iOffR, iRys, jRys, MemHer

if (allocated(iHerR2)) then
  call WarningMessage(2,'SetupR: Rys_Status is already active!')
  call Abend()
end if

#ifdef _RYS_SCRATCH_
call SetAux(1.0e-16_wp)
#endif

call Read_ABData()

call Read_RysRW()

! Set up the square of roots and the weights for Hermite polynomials
! We will only do this for the even numbered polynomials.

MemHer = nRys*(nRys+1)/2
call mma_allocate(iHerR2,nRys,label='iHerR2')
iHerR2(1) = 1
call mma_allocate(iHerW2,nRys,label='iHerW2')
iHerW2(1) = 1
call mma_allocate(HerR2,MemHer,label='HerR2')
call mma_allocate(HerW2,MemHer,label='HerW2')

if (2*nRys > MaxHer) then
  call WarningMessage(2,'SetupR: 2*nRys>MaxHer')
  call Abend()
end if
do iRys=1,nRys
  iHer = 2*iRys
  iOffR = (iRys*(iRys-1))/2
  iHerR2(iRys) = iHerR2(1)+iOffR
  iHerW2(iRys) = iHerW2(1)+iOffR
  do jRys=0,iRys-1
    HerR2(iHerR2(iRys)+jRys) = HerR(iHerR(iHer)+iRys+jRys)**2
    HerW2(iHerW2(iRys)+jRys) = HerW(iHerW(iHer)+iRys+jRys)
  end do
end do

!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call TriPrt(' Hermite squared roots',' ',HerR2(iHerR2(1)),nRys)
call TriPrt(' Hermite weights      ',' ',HerW2(iHerW2(1)),nRys)
#endif

return

end subroutine SetUpR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C Library of routines for Dynamix module
C
************************************************************************
*      SUBROUTINE DxRdNAtomStnd(natom)
*      SUBROUTINE DxRdNAtomHbrd(natom)
*      SUBROUTINE DxRdStnd(natom,atom,xyz,force)
*      SUBROUTINE DxRdHbrd(natom,atom,xyz,force)
*      SUBROUTINE DxPtTableCo(caption,time,natom,atom,xyz,lastline,M,fo)
*      SUBROUTINE DxPtTableWithoutMassForce(caption,time,natom,atom,xyz)
*      SUBROUTINE DxRdOut(pcoo,POUT,natom)
*      SUBROUTINE DxRdVel(vel,natom)
*      SUBROUTINE DxWtVel(vel,natom3)
*      SUBROUTINE DxCoord(natom,atom,xyz,hybrid)
*      SUBROUTINE DxEnergies(time,Epot,Ekin,Etot)
*      SUBROUTINE Put_Velocity(vel,natom3)
*      SUBROUTINE Get_Velocity(vel,natom3)
*      SUBROUTINE Get_NHC(NHC,nh)
*      SUBROUTINE Put_NHC(NHC,nh)
************************************************************************
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
C
C     Read the number of atoms. This needs to be done separately, because
C     dynamic-size matrices depend on the result.
C
      SUBROUTINE DxRdNAtomStnd(natom)
      IMPLICIT NONE
      INTEGER natom
      CALL Get_nAtoms_Full(natom)
      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
C
C     Read the number of atoms. This needs to be done separately, because
C     dynamic-size matrices depend on the result.
C
      SUBROUTINE DxRdNAtomHbrd(natom)
      IMPLICIT NONE
      EXTERNAL IsFreeUnit
      INTEGER natom,file,IsFreeUnit
      CHARACTER filname*80
      file=81
      file=IsFreeUnit(file)
      filname='fixforce.dmx'
      Call Molcas_Open(file,filname)
      READ(file,100) natom
      CLOSE(file)
 100  FORMAT(I6)
      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxRdStnd(natom,atom,xyz,force)
C
C     Read in the atom names, coordinates and forces from RUNFILE for
C     the standard QM molecular dynamics.
C
C     IS 14/06-2007
C
      IMPLICIT NONE
#include "Molcas.fh"
#include "WrkSpc.fh"
      INTEGER       natom
      REAL*8        xyz(natom*3),force(natom*3),conv
      CHARACTER     atom(natom)*2
      PARAMETER     (conv=-1.0d0)
C
C     The parameter conv converts the gradients (Hartree/Bohr)
C                                  to forces (Hartree/Bohr)
C
      CALL Get_Name_Full(atom)
      CALL Get_Coord_Full(xyz,natom)
C
C     Read the gradients from RUNFILE and convert them to forces.
C
      CALL Get_Grad_Full(force,natom)
      call dscal_(3*natom,conv,force,1)
*
      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxRdHbrd(natom,atom,xyz,force)
C
C     Read in the atom names, coordinates and forces from files
C     fixforce.dmx and prmcrd2.
C
      IMPLICIT NONE
#include "Molcas.fh"
#include "constants2.fh"
      External IsFreeUnit
      INTEGER       i,j,natom,natom2,file,IsFreeUnit
      REAL*8        xyz(natom*3),force(natom*3),conv,a2bohr
      CHARACTER     filname*80,atom(natom)*2
      PARAMETER     (a2bohr=1.0d0/Angstrom)
      PARAMETER     (conv=Angstrom/CONV_AU_TO_KJ_PER_MOLE_)
C
C     The parameter conv converts the forces from Hartree/Bohr
C                        to kJ/mole/Agstrom   => 1/4961.475514610d0
C                 a2bohr converts the coordinates from Angstrom
C                        to Bohr              => 1/0.52917720859
C
      file=81
      file=IsFreeUnit(file)
      filname='fixforce.dmx'
      Call Molcas_Open(file,filname)
      READ(file,*)
      DO i=1, natom
         READ(file,101)(force((i-1)*3+j),j=1,3),atom(i)
      END DO
      CLOSE(file)
C
C     Convert forces from kJ/mole/Angstrom to Hartree/Bohr
C
      call dscal_(3*natom,conv,force,1)
C
C     Read coordinates from fiel 'prmcrd2' and check for consistency
C     with forces.
C
      file=IsFreeUnit(file)
      filname='prmcrd2'
      Call Molcas_Open(file,filname)
      READ(file,'(/,I6)') natom2
      IF (natom2.ne.natom) STOP "Inconsistency between coordinates"
      READ(file,102)(xyz(i),i=1,natom*3)
      CLOSE(file)
C
C     Convert coordinates from Angstrom to Bohr
C
      call dscal_(3*natom,a2bohr,xyz,1)

 101  FORMAT(3E21.14,A)
 102  FORMAT(6F12.7)

      RETURN

      CALL Abend()

      END

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxPtTableCo(caption,time,natom,atom,xyz,lastline,M,fo)
C
C     Prints a nice table in the output file
C
      IMPLICIT NONE
#include "Molcas.fh"
      INTEGER     i,j,natom,k
      CHARACTER   caption*15, lastline*80, atom(natom)*2
      REAL*8      time,xyz(natom*3),M(natom),fo(natom*3)

      DO i=1, 3
        WRITE(6,*)
      END DO

      WRITE(6,100) caption,' (time = ',time,' a.u.):'
      WRITE(6,102)'-------------------------------------------------'//
     &            '---------------------------------------------'
      WRITE(6,102)'      No. Atom    X          Y          Z        '//
     &            'Mass       F(x)         F(y)         F(z)'
      WRITE(6,102)'-------------------------------------------------'//
     &            '---------------------------------------------'

      DO i=1, natom
        WRITE(6,101) i,atom(i),(xyz(3*(i-1)+j),j=1,3)
     &              ,M(i),(fo(3*(i-1)+k),k=1,3)
      END DO

      WRITE(6,102)'-------------------------------------------------'//
     &            '---------------------------------------------'
      WRITE(6,102) trim(lastline)

      DO i=1, 3
       WRITE(6,*)
      END DO

 100  FORMAT(A22,A7,F8.1,A)
 101  FORMAT(6X,I4,A3,3(1X,F10.6),1X,ES9.2,3(1X,ES12.5))
 102  FORMAT(1X,A)

      RETURN

      END

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxPtTableWithoutMassForce(caption,time,natom,atom,xyz)
C
C     Prints a nice table in the output file for the initial velcoities
C
      IMPLICIT NONE
#include "Molcas.fh"
      INTEGER     i,j,natom
      CHARACTER   caption*15, atom(natom)*2
      REAL*8      time,xyz(natom*3)

      DO i=1, 3
        WRITE(6,*)' '
      END DO

      WRITE(6,102) caption,' (time = ',time,' a.u.):'
      WRITE(6,*)'----------------------------------------------'
      WRITE(6,*)'     No.  Atom    X          Y          Z     '
      WRITE(6,*)'----------------------------------------------'

      DO i=1, natom
        WRITE(6,103) '      ',i,atom(i),(xyz(3*(i-1)+j),j=1,3)
      END DO

      WRITE(6,*)'----------------------------------------------'

      DO i=1, 3
       WRITE(6,*)' '
      END DO

 102  FORMAT(A22,A7,F8.1,A)
 103  FORMAT(A6,I4,A3,3F11.6)

      RETURN

      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxRdOut(pcoo,POUT,natom)
C
C     This Subroutine reads in the coordinates to project out from the file 'out.00N.xyz'
C
      IMPLICIT NONE
#include "stdalloc.fh"
#include "real.fh"
      EXTERNAL      IsFreeUnit
      INTEGER       i,j,p,file,natom,POUT,IsFreeUnit,mn
      REAL*8        pcoo(POUT,natom*3)
      CHARACTER*80  filname
      CHARACTER*180 OutLine, Get_Ln
      REAL*8, ALLOCATABLE :: UMat(:,:),VMat(:,:),S(:),SqrtM(:)
*
      file=81
      file=IsFreeUnit(file)
      DO P=1,POUT
        WRITE(filname,'(A,I3.3,A)') 'out.',p,'.xyz'
        CALL Molcas_Open(file,filname)
        DO i=1,natom
          OutLine = Get_Ln(file)
          DO j=1,3
            pcoo(p,3*(i-1)+j)=0.0D0
            CALL Get_F(j,pcoo(p,3*(i-1)+j),1)
          END DO
        END DO
      END DO
      CLOSE(file)
C
C Orthonormalize the vectors in mass-weighted coordinates
C
      CALL mma_Allocate(SqrtM,natom)
      CALL GetMassDx(SqrtM,natom)
      DO i=1, natom
        SqrtM(i)=Sqrt(SqrtM(i))
        j=3*(i-1)+1
        pcoo(:,j:j+2)=pcoo(:,j:j+2)*SqrtM(i)
      END DO
      mn=MIN(POUT,3*natom)
      CALL mma_Allocate(UMat,POUT,mn)
      CALL mma_Allocate(VMat,mn,3*natom)
      CALL mma_Allocate(S,mn)
      CALL large_svd(POUT,3*natom,pcoo,UMat,VMat,S)
      CALL dgemm_('N','N',POUT,3*natom,mn,One,UMat,POUT,VMat,mn,
     &                                    Zero,pcoo,POUT)
      DO i=1, natom
        j=3*(i-1)+1
        pcoo(:,j:j+2)=pcoo(:,j:j+2)/SqrtM(i)
      END DO
      CALL mma_deAllocate(UMat)
      CALL mma_deAllocate(VMat)
      CALL mma_deAllocate(S)
      CALL mma_deAllocate(SqrtM)
*
      RETURN

      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxRdIn(pcoo,PIN,natom)
C
C     This Subroutine reads in the coordinates to keep in from the file 'in.00N.xyz'
C
      IMPLICIT NONE
#include "stdalloc.fh"
#include "real.fh"
      EXTERNAL      IsFreeUnit
      INTEGER       i,j,p,file,natom,PIN,IsFreeUnit,mn
      REAL*8        pcoo(PIN,natom*3)
      CHARACTER*80  filname
      CHARACTER*180 OutLine, Get_Ln
      REAL*8, ALLOCATABLE :: UMat(:,:),VMat(:,:),S(:),SqrtM(:)
*
      file=81
      file=IsFreeUnit(file)
      DO P=1,PIN
        WRITE(filname,'(A,I3.3,A)') 'in.',p,'.xyz'
        CALL Molcas_Open(file,filname)
        DO i=1,natom
          OutLine = Get_Ln(file)
          DO j=1,3
            pcoo(p,3*(i-1)+j)=0.0D0
            CALL Get_F(j,pcoo(p,3*(i-1)+j),1)
          END DO
        END DO
      END DO
      CLOSE(file)
C
C Orthonormalize the vectors in mass-weighted coordinates
C
      CALL mma_Allocate(SqrtM,natom)
      CALL GetMassDx(SqrtM,natom)
      DO i=1, natom
        SqrtM(i)=Sqrt(SqrtM(i))
        j=3*(i-1)+1
        pcoo(:,j:j+2)=pcoo(:,j:j+2)*SqrtM(i)
      END DO
      mn=MIN(PIN,3*natom)
      CALL mma_Allocate(UMat,PIN,mn)
      CALL mma_Allocate(VMat,mn,3*natom)
      CALL mma_Allocate(S,mn)
      CALL large_svd(PIN,3*natom,pcoo,UMat,VMat,S)
      CALL dgemm_('N','N',PIN,3*natom,mn,One,UMat,PIN,VMat,mn,
     &                                    Zero,pcoo,PIN)
      DO i=1, natom
        j=3*(i-1)+1
        pcoo(:,j:j+2)=pcoo(:,j:j+2)/SqrtM(i)
      END DO
      CALL mma_deAllocate(UMat)
      CALL mma_deAllocate(VMat)
      CALL mma_deAllocate(S)
      CALL mma_deAllocate(SqrtM)
*
      RETURN

      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxRdVel(vel,natom)
C
C     This Subroutine reads in the velocities from the file 'velocity.xyz'
C
      IMPLICIT NONE
#include "Molcas.fh"
      EXTERNAL      IsFreeUnit
      INTEGER       i,j,file,natom,IsFreeUnit
      REAL*8        vel(natom*3)
      CHARACTER*80  filname
      CHARACTER*180 VelLine, Get_Ln
*
      file=81
      file=IsFreeUnit(file)
      filname='velocity.xyz'
      CALL Molcas_Open(file,filname)
      DO i=1,natom
         VelLine = Get_Ln(file)
         DO j=1,3
            vel(3*(i-1)+j)=0.0D0
            CALL Get_F(j,vel(3*(i-1)+j),1)
         END DO
      END DO
*      READ(file,100)(vel(i),i=1,3*natom3)
      CLOSE(file)
*
*100  FORMAT(3D18.10)

      RETURN

      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxWtVel(vel,natom3)
C
C     This Subroutine writes the velocities to the file 'velocity.xyz'
C
      IMPLICIT NONE
#include "Molcas.fh"
      EXTERNAL    IsFreeUnit
      INTEGER     i,file,natom3,IsFreeUnit
      REAL*8      vel(natom3)
      CHARACTER*80  filname

      file=81
      file=IsFreeUnit(file)
      filname='velocity.xyz'
      CALL Molcas_Open(file,filname)
      WRITE(file,100)(vel(i),i=1,natom3)
      CLOSE(file)

 100  FORMAT(3D18.10)

      RETURN

      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxCoord(natom,atom,xyz,hybrid)
C
C     Write the coordinates to a file in xyz format
C
      IMPLICIT NONE
#include "Molcas.fh"
#include "MD.fh"
#include "constants2.fh"
      External IsFreeUnit
      INTEGER     i,j,file,natom,IsFreeUnit
      REAL*8      xyz(natom*3)
      CHARACTER   atom(natom)*2,filename*9
      LOGICAL     hybrid,Exist
*
      IF (.NOT.hybrid) THEN
         file=82
         file=IsFreeUnit(file)
         filename='md.xyz'
         CALL OpnFl(filename,file,Exist)
         CALL Append_file(file)
         WRITE(file,'(I5,/)') natom
         DO i=1, natom
            WRITE(file,100) atom(i),(Angstrom*xyz(3*(i-1)+j),j=1,3)
         END DO
         CLOSE(file)
      ELSE
         file=IsFreeUnit(file)
         filename='md.prmcrd'
         CALL OpnFl(filename,file,Exist)
         CALL Append_file(file)
         WRITE(file,'(/,I6)') natom
         WRITE(file,'(6F12.7)') (Angstrom*xyz(i),i=1,3*natom)
         CLOSE(file)
         file=IsFreeUnit(file)
         filename='vmd.mdcrd'
         CALL OpnFl(filename,file,Exist)
         CALL Append_file(file)
         WRITE(file,'(10F8.3)') (Angstrom*xyz(i),i=1,3*natom)
         CLOSE(file)
      ENDIF
 100  FORMAT(1X,A2,3F15.8)
      RETURN

      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE DxEnergies(time,Epot,Ekin,Etot)
C
C     Write out a summary of energies in CSV format
C
      IMPLICIT NONE
      External IsFreeUnit
#include "WrkSpc.fh"
      INTEGER      file,nEnergies,i,n,ipEnergies
      INTEGER      IsFreeUnit
      REAL*8       time,Epot,Ekin,Etot
      CHARACTER    filename*12,frmt*24
      LOGICAL      Exist,RootCheck
*
      filename='md.energies'
*
      RootCheck=.False.
*
      CALL Qpg_iScalar('Relax CASSCF root',RootCheck)
*
      file=82
      file=IsFreeUnit(file)
      CALL OpnFl(filename,file,Exist)
      CALL Append_file(file)
      IF (.NOT.Exist) THEN
         WRITE(file,'(3X,A4,10X,A4,2(17X,A4))') 'time','Epot',
     &                                          'Ekin','Etot'
      END IF
      frmt='(F8.2, (2X,D19.12))'
*
      IF (RootCheck) THEN
         CALL Get_iScalar('Number of roots',nEnergies)
         CALL GetMem('MS energies','ALLO','REAL',ipEnergies,nEnergies)
         CALL Get_dArray('Last energies',Work(ipEnergies),nEnergies)
         n = nEnergies + 3
         WRITE(frmt(7:7),'(I1)') n
         WRITE(file,frmt) time,Epot,Ekin,Etot,
     &                   (Work(ipEnergies-1+i),i=1,nEnergies)
         CALL GetMem('MS energies','FREE','REAL',ipEnergies,nEnergies)
      ELSE
         n = 3
         WRITE(frmt(7:7),'(I1)') n
         WRITE(file,frmt) time,Epot,Ekin,Etot
      END IF
      CLOSE(file)
      RETURN

      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE Put_Velocity(vel,natom3)
      IMPLICIT NONE
#include "WrkSpc.fh"
#include "Molcas.fh"
      INTEGER      natom3
      REAL*8       vel(natom3)
C
C     Writes the velocities on RUNFILE
C
      CALL Put_dArray('Velocities',vel,natom3)
*      CALL GetMem('Velocities','FREE','REAL',vel,natom3)
      RETURN
*
      END
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE Get_Velocity(vel,natom3)
      IMPLICIT NONE
#include "WrkSpc.fh"
#include "Molcas.fh"
      INTEGER      natom3
      REAL*8       vel(natom3)
C
C     Reads the velocities from RUNFILE
C
*      CALL GetMem('Velocities','ALLO','REAL',vel,natom3)
      CALL Get_dArray('Velocities',vel,natom3)
*
      RETURN
*
      END
*

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE Get_NHC(NHC,nh)
      IMPLICIT NONE
#include "WrkSpc.fh"
#include "Molcas.fh"
      INTEGER      nh
      REAL*8       NHC(nh)
C
C     Reads the extra degrees of freedom from RUNFILE
C
*      CALL GetMem('NOSEHOOVER','ALLO','REAL',NHC,nh)
      CALL Get_dArray('NOSEHOOVER',NHC,nh)
*
      RETURN
*
      END
*
*
C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8
*
      SUBROUTINE Put_NHC(NHC,nh)
      IMPLICIT NONE
#include "WrkSpc.fh"
#include "Molcas.fh"
      INTEGER      nh
      REAL*8       NHC(nh)
C
C     Writes the extra degrees of Freedom on RUNFILE
C
      CALL Put_dArray('NOSEHOOVER',NHC,nh)
*      CALL GetMem('NOSEHOOVER','FREE','REAL',NHC,nh)
      RETURN
*
      END
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine setjobiph_cvb(nel_c,norb_c,i2s_c,isym_c,neltot_c)

use casvb_global, only: iorclos_c, iorcore_c, iorocc_c, istms2_c, istnel_c, istsy_c, mcore_c, mxstt_ci, nstats_c, nstsym_c, weight_c
use jobiph_j, only: iroot_j, ispin_j, lroots_j, lsym_j, nactel_j, nfro_j, nish_j, nroots_j, nrs2_j, weight_j
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: nel_c, norb_c, i2s_c, isym_c, neltot_c
integer(kind=iwp) :: i, j
real(kind=wp) :: wgt

! Orbitals  --  OCC, CLOSED and CORE cards
iorcore_c(:) = nfro_j(:)
iorclos_c(:) = nish_j(:)
iorocc_c(:) = nrs2_j(:)
! States  --  WF, STATE and WEIGHT cards
nstsym_c = 1
weight_c(:,:) = Zero
do i=1,lroots_j
  wgt = Zero
  do j=1,nroots_j
    if (iroot_j(j) == i) wgt = weight_j(j)
  end do
  if (wgt /= Zero) then
    if (i > mxstt_ci) then
      write(u6,*) ' Root number too large in casrecov_cvb :',i,mxstt_ci
      call abend_cvb()
    end if
  end if
  weight_c(i,1) = wgt
end do

istnel_c(1) = nactel_j
istsy_c(1) = lsym_j
istms2_c(1) = ispin_j-1
nstats_c(1) = lroots_j
! Set derived info
nel_c = nactel_j
i2s_c = ispin_j-1
isym_c = lsym_j
norb_c = sum(nrs2_j(:))
mcore_c = sum(nfro_j(:)+nish_j(:))
neltot_c = nel_c+2*mcore_c
! MO common block:
call setmocom_cvb()

return

end subroutine setjobiph_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ZSTINF_GAS(IPRNT)
*
* Set up common block /STINF/ from information in /STINP/
*
*=========
* Input
*=========
* Information in /CGAS/ and /GASSTR/
*
*======================
* Output ( in /STINF/ )
*======================
* ISTAC (MXPSTT,2) : string type obtained by creating (ISTAC(ITYP,2))
*                    or annihilating (ISTAC(ITYP,1)) an electron
*                    from a string of type  ITYP . A zero indicates
*                    that this mapping is not included
*                    Only strings belonging to the same
*                    Orbital group are mapped
*                    mapped
*. Input
#include "mxpdim.fh"
#include "cgas.fh"
#include "gasstr.fh"
*. Output
#include "stinf.fh"
*. Only the first element, i.e. ISTAC  is defined

*
      NTEST = 0
      NTEST = MAX(NTEST,IPRNT)
* ******************************************************************
* Mappings between strings with the same type ISTTP index , +/- 1 el
* ******************************************************************
      CALL ISETVC(ISTAC,0,2*MXPSTT)
      DO  IGAS = 1, NGAS
*. groups for a given gas spaces goes with increasing number of orbitals,
*  so the first space does not have any creation mapping
*  and the last space does not have any annihilation mapping
*
        MGRP = NGPSTR(IGAS)
        DO IGRP = 1, MGRP
          IIGRP = IGRP + IBGPSTR(IGAS) -1
          IF(IGRP.NE.1) THEN
*. Annihilation map is present : IIGRP => IIGRP - 1
            ISTAC(IIGRP,1) = IIGRP -1
          END IF
          IF(IGRP.NE.MGRP) THEN
*. Creation map is present : IIGRP => IIGRP + 1
             ISTAC(IIGRP,2) = IIGRP + 1
          END IF
        END DO
      END DO
*
      IF(NTEST .GE. 10 ) THEN
        WRITE(6,*) ' Type - type mapping array ISTAC '
        WRITE(6,*) ' =============================== '
        CALL IWRTMA(ISTAC,NGRP  ,2,MXPSTT,2)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine Util4(nZeta,Final,la,lb,Elalbp,Elalb,Bcoor,Dcoor)
************************************************************************
*                                                                      *
* Object: to assemble the diamagnetic shielding integrals from         *
*         electric field integrals.                                    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             February '91                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8  Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,9),
     &        Elalbp(nZeta,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2,3),
     &        Elalb(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,3),
     &        Bcoor(3), Dcoor(3), BD(3)
      Character*80 Label
*
*     Statement function for cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
      nElem(ix) = (ix+1)*(ix+2)/2
*
      iRout = 231
      iPrint = nPrint(iRout)
*
      BD(1) = Bcoor(1) - Dcoor(1)
      BD(2) = Bcoor(2) - Dcoor(2)
      BD(3) = Bcoor(3) - Dcoor(3)
      Fact = -1.D6 * One2C2
      If (iPrint.ge.99) Then
          Write (6,*) ' In Util4 la,lb=',la,lb
          Do 100 ia = 1, nElem(la)
             Do 200 ib = 1, nElem(lb+1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalbp(',ia,',',ib,',x)'
                Call RecPrt(Label,' ',Elalbp(1,ia,ib,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalbp(',ia,',',ib,',y)'
                Call RecPrt(Label,' ',Elalbp(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalbp(',ia,',',ib,',z)'
                Call RecPrt(Label,' ',Elalbp(1,ia,ib,3),nZeta,1)
 200         Continue
 100      Continue
          Do 101 ia = 1, nElem(la)
             Do 201 ib = 1, nElem(lb)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalb(',ia,',',ib,',x)'
                Call RecPrt(Label,' ',Elalb(1,ia,ib,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalb(',ia,',',ib,',y)'
                Call RecPrt(Label,' ',Elalb(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalb(',ia,',',ib,',z)'
                Call RecPrt(Label,' ',Elalb(1,ia,ib,3),nZeta,1)
 201         Continue
 101      Continue
      End If
*
      Do 10 ixa = la, 0, -1
         Do 11 iya = la-ixa, 0, -1
            iza = la-ixa-iya
            ipa = Ind(la,ixa,iza)
*
      Do 20 ixb = lb, 0, -1
         Do 21 iyb = lb-ixb, 0, -1
            izb = lb-ixb-iyb
            ipb = Ind(lb,ixb,izb)
*
            Do 30 iZeta = 1, nZeta
               xCxD = Elalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),1) + BD(1)*
     &              Elalb(iZeta,ipa,ipb,1)
               yCxD = Elalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),2) + BD(1)*
     &              Elalb(iZeta,ipa,ipb,2)
               zCxD = Elalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),3) + BD(1)*
     &              Elalb(iZeta,ipa,ipb,3)
               xCyD = Elalbp(iZeta,ipa,Ind(lb+1,ixb,izb),1) + BD(2)*
     &              Elalb(iZeta,ipa,ipb,1)
               yCyD = Elalbp(iZeta,ipa,Ind(lb+1,ixb,izb),2) + BD(2)*
     &              Elalb(iZeta,ipa,ipb,2)
               zCyD = Elalbp(iZeta,ipa,Ind(lb+1,ixb,izb),3) + BD(2)*
     &              Elalb(iZeta,ipa,ipb,3)
               xCzD = Elalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),1) + BD(3)*
     &              Elalb(iZeta,ipa,ipb,1)
               yCzD = Elalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),2) + BD(3)*
     &              Elalb(iZeta,ipa,ipb,2)
               zCzD = Elalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),3) + BD(3)*
     &              Elalb(iZeta,ipa,ipb,3)
               Final(iZeta,ipa,ipb,1) = Fact * (    +yCyD+zCzD)
               Final(iZeta,ipa,ipb,2) = Fact * (    -yCxD     )
               Final(iZeta,ipa,ipb,3) = Fact * (    -zCxD     )
               Final(iZeta,ipa,ipb,4) = Fact * (    -xCyD     )
               Final(iZeta,ipa,ipb,5) = Fact * (xCxD     +zCzD)
               Final(iZeta,ipa,ipb,6) = Fact * (    -zCyD     )
               Final(iZeta,ipa,ipb,7) = Fact * (    -xCzD     )
               Final(iZeta,ipa,ipb,8) = Fact * (    -yCzD     )
               Final(iZeta,ipa,ipb,9) = Fact * (xCxD+yCyD     )
 30         Continue
*
 21      Continue
 20   Continue
*
 11      Continue
 10   Continue
*
      If (iPrint.ge.49) Then
          Do 300 iComp = 1, 9
             Write (Label,'(A,I2,A)') ' Final (',iComp,') '
             Call RecPrt(Label,' ',Final(1,1,1,iComp),nZeta,
     &                   nElem(la)*nELem(lb))
 300      Continue
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!               2002, Roland Lindh                                     *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

module Spool

use Definitions, only: iwp, u5, u6

implicit none
private

logical(kind=iwp) :: Spool_On = .true.
integer(kind=iwp) :: LuRd = u5, LuWr = u6

public :: Close_LuSpool, Disable_Spool, LuRd, LuWr, Set_Spool, SpoolInp

contains

subroutine SpoolInp(LuSpool)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Copy all input to a local scratch file                           *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!     Modified by:  R. Lindh to allow for use of old input file.       *
!                   Tokyo, Japan, June 2002.                           *
!                   J.W. Krogh to make auto.plx create the old input   *
!                   file. Lund, Sweden, October 2005.                  *
!***********************************************************************

  use UnixInfo, only: ProgName
  use Definitions, only: iwp

  integer(kind=iwp), intent(out) :: LuSpool
  integer(kind=iwp) :: iEnd
  logical(kind=iwp) :: Exists
  character(len=len(ProgName)) :: PName
  character(len=128) :: FileName
  integer(kind=iwp) :: IsFreeUnit

  ! Get the name of the module

  PName = ProgName
  call Upcase(PName)
  PName = adjustl(PName)

  iEnd = 1
  do while (PName(iEnd:iEnd) /= ' ')
    iEnd = iEnd+1
  end do
  iEnd = min(iEnd-1,5)
  FileName = PName(1:iend)//'INP'

  ! If Spool_on is true, then the input in StdIn is just used.
  ! Else we'll use the latest input. This is created by auto.plx

  LuSpool = 17
  if (Spool_On) then
    LuSpool = LuRd
  else
    call f_inquire('LASTEN',Exists) ! customized Last_Energy input
    if (Exists) then
      LuSpool = IsFreeUnit(LuSpool)
      call Molcas_Open(LuSpool,'LASTEN')
    else
      call f_inquire(Filename,Exists)
      if (Exists) then
        LuSpool = IsFreeUnit(LuSpool)
        call Molcas_Open(LuSpool,Filename)
      end if
    end if
  end if

end subroutine SpoolInp

subroutine Set_Spool()

  Spool_on = .true.

end subroutine Set_Spool

subroutine Disable_Spool()

  Spool_on = .false.

end subroutine Disable_Spool

subroutine Close_LuSpool(LuSpool)

  integer(kind=iwp), intent(in) :: LuSpool

  if (.not. Spool_On) close(LuSpool)

end subroutine Close_LuSpool

end module Spool

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine NATCT(C,FC)

use cpf_global, only: BNAME, DETOT, ETOT, ICASE, ICPF, INCPF, INDX, ISDCI, ITOC17, JSY, Lu_CPFORB, Lu_TraOne, NBAS, NORB, NPFRO, &
                      NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: C(*)
real(kind=wp), intent(in) :: FC(*)
integer(kind=iwp) :: ICMO, IDISK, iDum, iDummy(7,8), iiRC, IOCC, iOpt, iSYM, M, N2SUM, n2Tri, nbMax, NSUM
real(kind=wp) :: dum, Dummy(1), EREL, ErelDC, ErelMV
character(len=72) :: Header
real(kind=wp), allocatable :: CAO(:), CMO(:), CMO2(:), D(:), DSYM(:), OCC(:), OP(:), S(:)

NSUM = 0
N2SUM = 0
n2Tri = 0
nbMax = 0
do ISYM=1,NSYM
  nbMax = max(nbMax,nBas(iSym))
  NSUM = NSUM+NBAS(ISYM)
  N2SUM = N2SUM+NBAS(ISYM)**2
  n2Tri = n2Tri+nBas(iSym)*(nBas(iSym)+1)/2
end do

! Read MO coefficients
IDISK = ITOC17(1)
call mma_allocate(CMO,N2SUM,label='CMO')
call dDAFILE(Lu_TraOne,2,CMO,N2SUM,IDISK)

! Loop over irreps and compute natural orbitals

call mma_allocate(OCC,NSUM,label='OCC')
call mma_allocate(CMO2,nbMax**2,label='CMO2')
call mma_allocate(DSYM,nbMax**2,label='DSYM')
call mma_allocate(CAO,nbMax**2,label='CAO')
IOCC = 1
ICMO = 1
do M=1,NSYM
  ! set occupation number of orbitals prefrozen in MOTRA
  OCC(IOCC:IOCC+NBAS(M)-1) = Zero
  ! skip orbitals prefrozen in MOTRA
  OCC(IOCC:IOCC+NPFRO(M)-1) = Two
  call NATORB_CPF(FC,CMO(ICMO+NBAS(M)*NPFRO(M)),CMO2,DSYM,CAO,OCC(IOCC+NPFRO(M)),M)
  call DCOPY_(NORB(M)*NBAS(M),CAO,1,CMO(ICMO+NBAS(M)*NPFRO(M)),1)
  ICMO = ICMO+NBAS(M)**2
  IOCC = IOCC+NBAS(M)
end do
call mma_deallocate(CMO2)
call mma_deallocate(DSYM)
call mma_deallocate(CAO)

call mma_allocate(D,n2Sum,label='D')
call mma_allocate(OP,n2Tri,label='OP')
call RelEne(ErelMV,ErelDC,nSym,nBas,CMO,OCC,D,OP)
call mma_deallocate(D)
call mma_deallocate(OP)

EREL = ERELMV+ERELDC
write(u6,'(/,5X,A)') 'FIRST ORDER RELATIVISTIC CORRECTIONS'
write(u6,'(5X,A,F17.8)') 'MASS-VELOCITY        ',ErelMV
write(u6,'(5X,A,F17.8)') '1-EL DARWIN CONTACT  ',ErelDC
write(u6,'(5X,A,F17.8)') 'TOTAL REL. CORRECTION',Erel
if (ISDCI == 1) then
  write(u6,'(5X,A,F17.8)') 'REL. CI ENERGY       ',ETOT+Erel
  write(u6,'(5X,A,F17.8)') 'REL. CI+Q ENERGY     ',DETOT+Erel
else
  write(u6,'(5X,A,F17.8)') 'TOTAL REL. ENERGY    ',ETOT+Erel
end if
call PRWF_CPF(ICASE,JSY,INDX,C)
if (iCPF == 1) then
  Header = ' CPF natural orbitals'
else if (iSDCI == 1) then
  Header = ' SDCI natural orbitals'
else if (iNCPF == 1) then
  Header = ' ACPF natural orbitals'
else
  Header = ' MCPF natural orbitals'
end if
call Primo(Header,.true.,.false.,1.0e-4_wp,dum,nSym,nBas,nBas,BName,Dummy,OCC,CMO,-1)

! Read the overlap matrix in ao basis
iiRC = -1
iOpt = 6
call mma_allocate(S,n2Tri,label='S')
call RdOne(iiRC,iOpt,'MLTPL  0',1,S,iDum)
if (iiRC /= 0) then
  write(u6,*) 'Natct: Error reading overlap matrix!'
  call Abend()
end if
call Charge(nSym,nBas,BName,CMO,OCC,S,2,.true.,.true.)
call Prpt_old(nSym,nBas,nSum,n2Sum,CMO,OCC)
call mma_deallocate(S)

if (iCPF == 1) then
  Header = '* CPF NO COEFS'
else if (iSDCI == 1) then
  Header = '* SDCI NO COEFS'
else if (iNCPF == 1) then
  Header = '* ACPF NO COEFS'
else
  Header = '* MCPF NO COEFS'
end if
call WrVec('CPFORB',Lu_CPFORB,'CO',nSym,nBas,nBas,CMO,OCC,Dummy,iDummy,Header)
call mma_deallocate(CMO)
call mma_deallocate(OCC)

return

end subroutine NATCT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Real*8 Function LDF_Charge(PackedD,ip_D)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: compute charge from density using only atom pair blocks
C              as defined by LDF.
C
      Implicit None
      Logical PackedD
      Integer ip_D
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      real*8 ddot_
      external ddot_

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Integer ip_DBlocks
      Integer ip_SBlocks
      Integer AB
      Integer A, B
      Integer nAB
      Integer ipD
      Integer ipS

      Real*8 Factor

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      LDF_Charge=0.0d0
      Call LDF_AllocateBlockMatrix('Den',ip_DBlocks)
      Call LDF_Full2Blocked(Work(ip_D),PackedD,ip_DBlocks)
      Call LDF_AllocateBlockMatrix('Ovl',ip_SBlocks)
      Call LDF_GetBlockedOverlapMatrix(0,ip_SBlocks)
      Do AB=1,NumberOfAtomPairs
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
         ipD=iWork(ip_DBlocks-1+AB)
         ipS=iWork(ip_SBlocks-1+AB)
         Factor=1.0d0+dble(min(abs(A-B),1))
         LDF_Charge=LDF_Charge+Factor*dDot_(nAB,Work(ipD),1,Work(ipS),1)
      End Do
      Call LDF_DeallocateBlockMatrix('Ovl',ip_SBlocks)
      Call LDF_DeallocateBlockMatrix('Den',ip_DBlocks)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE CONF_GRAPH(IOCC_MIN,IOCC_MAX, NORB,  NEL,IARCW,
     &                        NCONF,   ISCR)
*
* A group of configurations is described by the
* accumulated min and max, IOCC_MIN and IOCC_MAX.
*
* Find arcweights of corresponding graph and total number
* of configurations ( all symmetries)
*
* Jeppe Olsen, Oct. 2001
*
#include "implicit.fh"
*. Input
      INTEGER IOCC_MIN(NORB), IOCC_MAX(NORB)
*. Output
      INTEGER IARCW(NORB,NEL,2)
* IARCW(I,J,K) gives weight of arc ending at vertex (I,J)
* with occupation K (=1,2)
*. Local scratch : Length should be (NORB+1)*(NEL+1)
      INTEGER ISCR(NORB+1,NEL+1)
*. Set up vertex weights
      CALL CONF_VERTEX_W(IOCC_MIN,IOCC_MAX,NORB,NEL,ISCR)
      NCONF = ISCR(NORB+1,NEL+1)
*. Obtain arcweights from vertex weights
C?    WRITE(6,*) ' CONF_GRAPH, NORB, NEL = ', NORB, NEL
      CALL CONF_ARC_W( IOCC_MIN, IOCC_MAX,     NORB,      NEL,     ISCR,
     &                    IARCW)
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' IOCMIN and IOCMAX  '
        CALL IWRTMA(IOCC_MIN,1,NORB,1,NORB)
        CALL IWRTMA(IOCC_MAX,1,NORB,1,NORB)
        WRITE(6,*) ' Arcweights for single occupied arcs '
        CALL IWRTMA(IARCW(1,1,1),NORB,NEL,NORB,NEL)
        WRITE(6,*) ' Arcweights for double occupied arcs '
        CALL IWRTMA(IARCW(1,1,2),NORB,NEL,NORB,NEL)
        WRITE(6,*) ' Total number of configurations ', NCONF
      END IF
*
      RETURN
      END
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine GetOvlp_Localisation(S,Storage,nBas,nSym)
! Thomas Bondo Pedersen, Dec. 2005.
!
! Purpose: read the overlap matrix and return in S in lower triangular
! storage if Storage="Tri" else in full square storage.

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: S(*)
character(len=3), intent(in) :: Storage
integer(kind=iwp), intent(in) :: nSym, nBas(nSym)
integer(kind=iwp) :: iComp, iOpt, irc, iSyLbl, iSym, kSq, kTri, l_Tri
character(len=8) :: Label
character(len=3) :: myStorage
real(kind=wp), allocatable :: Scr(:)
logical(kind=iwp), parameter :: Debug = .false.
character(len=*), parameter :: SecNam = 'GetOvlp_Localisation'

l_Tri = nBas(1)*(nBas(1)+1)/2
do iSym=2,nSym
  l_Tri = l_Tri+nBas(iSym)*(nBas(iSym)+1)/2
end do
call mma_allocate(Scr,l_Tri+4,label='OvlpScr')

irc = -1
iOpt = 2
iComp = 1
iSyLbl = 1
Label = 'Mltpl  0'
call RdOne(irc,iOpt,Label,iComp,Scr,iSyLbl)
if (irc /= 0) then
  write(u6,*) SecNam,': RdOne returned ',irc
  write(u6,*) 'Label = ',Label,'  iSyLbl = ',iSyLbl
  call SysAbendMsg(SecNam,'I/O error in RdOne',' ')
end if

myStorage = Storage
call UpCase(myStorage)
if (myStorage == 'TRI') then
  S(1:l_Tri) = Scr(1:l_Tri)
else
  kTri = 1
  kSq = 1
  do iSym=1,nSym
    call Tri2Rec(Scr(kTri),S(kSq),nBas(iSym),Debug)
    kTri = kTri+nBas(iSym)*(nBas(iSym)+1)/2
    kSq = kSq+nBas(iSym)**2
  end do
end if

call mma_deallocate(Scr)

end subroutine GetOvlp_Localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine restart_check( Ifrestart, input_to_read,
     &                          input_file_name, nT, nH, nTempMagn,
     &                          nDir, nDirZee, nMult, GRAD)
c  this routine looks into the file "single_aniso.input" for the "RESTart" keyword
c
      Implicit None
      Integer, Parameter        :: wp=selected_real_kind(p=15,r=307)
      Integer ::  linenr, input_to_read, Input, nT, nH, nTempMagn
      Integer ::  nDir, nDirZee, nMult, i
      Logical ::  Ifrestart
      Logical ::  GRAD
      Real    ::  rdummy
      Character(Len=280) :: line, tmp
      Character(Len=180) :: input_file_name
      Integer :: ncut,nk,mg
      Real    :: encut_rate
      Logical :: KeyREST,KeyTEXP,KeyHEXP,KeyHINT,KeyTINT,KeyTMAG,
     &           KeyMVEC,KeyZEEM,KeyMLTP,KeyNCUT,KeyENCU,KeyERAT,KeyGRAD
      Logical :: DBG

      DBG=.false.

      nH=0
      nT=0
      nMult=0
      nDirZee=0
      nDir=0
      nk=0
      mg=0
      ncut=0
      encut_rate=0.0_wp
      nTempMagn=0
      Input=5

      KeyREST=.false.
      KeyTEXP=.false.
      KeyHEXP=.false.
      KeyHINT=.false.
      KeyTINT=.false.
      KeyTMAG=.false.
      KeyMVEC=.false.
      KeyZEEM=.false.
      KeyMLTP=.false.
      KeyNCUT=.false.
      KeyENCU=.false.
      KeyERAT=.false.
      KeyGRAD=.false.

C=========== End of default settings====================================
      REWIND(Input)
50    READ(Input,'(A180)',End=998) LINE
      Call NORMAL(LINE)
      If(LINE(1:7).ne.'&SINGLE') Go To 50
      LINENR=0
100   READ(Input,'(A280)',End=998) line
      LINENR=LINENR+1
      Call NORMAL(LINE)
      If (LINE(1:1).eq.'*') Go To 100
      If (LINE.eq.' ') Go To 100

      If((LINE(1:4).ne.'REST').AND.(LINE(1:4).ne.'TEXP').AND.
     &   (LINE(1:4).ne.'HEXP').AND.(LINE(1:4).ne.'END ').AND.
     &   (LINE(1:4).ne.'    ').AND.(LINE(1:4).ne.'HINT').AND.
     &   (LINE(1:4).ne.'TINT').AND.(LINE(1:4).ne.'TMAG').AND.
     &   (LINE(1:4).ne.'MVEC').AND.(LINE(1:4).ne.'ZEEM').AND.
     &   (LINE(1:4).ne.'MLTP').AND.(LINE(1:4).ne.'NCUT').AND.
     &   (LINE(1:4).ne.'ENCU').AND.(LINE(1:4).ne.'ERAT').AND.
     &   (LINE(1:4).ne.'GRAD')                          ) Go To 100
      If((LINE(1:4).eq.'END ').OR. (LINE(1:4).eq.'    ')) Go To 200

      If (line(1:4).eq.'REST') Then
         Ifrestart=.true.
         KeyREST=.true.
         READ(Input,*) input_to_read
         input_file_name='aniso.input'
         If(DBG) WRITE(6,*) input_to_read
         If ( (input_to_read==2) .OR. (input_to_read==3) .OR.
     &        (input_to_read==4) ) Then
           BACKSPACE(Input)
           READ(Input,*) input_to_read, tmp
           If(DBG) WRITE(6,*) tmp
           input_file_name=trim(tmp)
           If(DBG) WRITE(6,*) 'restart_check: REST, input_file_name='
           If(DBG) WRITE(6,*) input_file_name
         End If
         LINENR=LINENR+1
         Go To 100
      End If

      If (line(1:4).eq.'TEXP') Then
          READ(Input,*) nT
          IF(DBG) WRITE(6,*) 'restart_check: TEXP, nT=', nT
          KeyTEXP=.true.
          LINENR=LINENR+1
          Go To 100
      End If

      If (line(1:4).eq.'GRAD') Then
          KeyGRAD=.true.
          GRAD=.true.
          IF(DBG) WRITE(6,*) 'restart_check:  GRAD = ', GRAD
          LINENR=LINENR+1
          Go To 100
      End If

      If (line(1:4).eq.'HEXP') Then
          READ(Input,*) nTempMagn, (rdummy,i=1,nTempMagn)
          READ(Input,*) nH
          IF(DBG) WRITE(6,*) 'restart_check: HEXP, nH=', nH
          IF(DBG) WRITE(6,*) 'restart_check: HEXP, nTempMagn=',nTempMagn
          KeyHEXP=.true.
          LINENR=LINENR+2
          Go To 100
      End If

      If (line(1:4).eq.'HINT') Then
          READ(Input,*) rdummy, rdummy, nH
          IF(DBG) WRITE(6,*) 'restart_check: HINT, nH=', nH
          KeyHINT=.true.
          LINENR=LINENR+1
          Go To 100
      End If

      If (line(1:4).eq.'TINT') Then
          READ(Input,*) rdummy, rdummy, nT
          IF(DBG) WRITE(6,*) 'restart_check: HINT, nT=', nT
          KeyTINT=.true.
          LINENR=LINENR+1
          Go To 100
      End If

      If (line(1:4).eq.'TMAG') Then
          READ(Input,*) nTempMagn
          IF(DBG) WRITE(6,*) 'restart_check: TMAG, nTempMagn=',nTempMagn
          KeyTMAG=.true.
          LINENR=LINENR+1
          Go To 100
      End If

      If (line(1:4).eq.'MVEC') Then
          READ(Input,*) nDir
          IF(DBG) WRITE(6,*) 'restart_check: MVEC, nDir=',nDir
          KeyMVEC=.true.
          LINENR=LINENR+1
          Go To 100
      End If

      If (line(1:4).eq.'ZEEM') Then
          READ(Input,*) nDirZee
          IF(DBG) WRITE(6,*) 'restart_check: ZEEM, nDirZee=',nDirZee
          KeyZEEM=.true.
          LINENR=LINENR+1
          Go To 100
      End If

      If (line(1:4).eq.'MLTP') Then
          READ(Input,*) nMult
          IF(DBG) WRITE(6,*) 'restart_check: MLTP, nMult=',nMult
          KeyMLTP=.true.
          LINENR=LINENR+1
          Go To 100
      End If

      If (LINE(1:4).eq.'NCUT') Then
          READ(Input,*) NCUT
          IF(DBG) WRITE(6,*) 'restart_check: NCUT, NCUT=',NCUT
          KeyNCUT=.true.
          LINENR=LINENR+1
          Go To 100
      End If

      If (LINE(1:4).eq.'ENCU') Then
          READ(Input,*) NK, MG
          IF(DBG) WRITE(6,*) 'restart_check: ENCU, NK, MG=',NK,MG
          LINENR=LINENR+1
          KeyENCU=.true.
          Go To 100
      End If

      If (LINE(1:4).eq.'ERAT') Then
          READ(Input,*) encut_rate
          IF(DBG) WRITE(6,*) 'restart_check: ERAT, encut_rate=',
     &                        encut_rate
          KeyERAT=.true.
          LINENR=LINENR+1
          Go To 100
      End If

200   Continue
      Write(6,'(5X,A)') 'NO ERROR WAS LOCATED WHILE READING INPUT'

c      print *,'KeyREST=',KeyREST
c      print *,'KeyTEXP=',KeyTEXP
c      print *,'KeyHEXP=',KeyHEXP
c      print *,'KeyHINT=',KeyHINT
c      print *,'KeyTINT=',KeyTINT
c      print *,'KeyTMAG=',KeyTMAG
c      print *,'KeyMVEC=',KeyMVEC
c      print *,'KeyZEEM=',KeyZEEM
c      print *,'KeyMLTP=',KeyMLTP
c      print *,'KeyNCUT=',KeyNCUT
c      print *,'KeyENCU=',KeyENCU
c      print *,'KeyERAT=',KeyERAT
c      print *,'KeyGRAD=',KeyGRAD

c      print *,'LOGLINE=',KeyTMAG.OR.KeyZEEM.OR.KeyMVEC.OR.KeyHINT.OR.
c     &                   KeyHEXP.OR.KeyNCUT.OR.KeyENCU.OR.KeyERAT

      If( KeyTMAG.OR.KeyZEEM.OR.KeyMVEC.OR.KeyHINT.OR.KeyHEXP.OR.
     &    KeyNCUT.OR.KeyENCU.OR.KeyERAT ) Then
          If(nTempMagn==0) nTempMagn=1
          If(       nH==0) nH=21
      End If
          If(       nT==0) nT=301

c      print *, 'nTempMagn=',nTempMagn
c      print *, 'nH       =',nH
c      print *, 'nT       =',nT




      Go To 190
C------ errors ------------------------------
998   continue
      Write(6,*)' -- READIN: Unexpected End of input file.'


190   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine XClc()
! Compute the x parameters value as a function of Iter_ref

use LnkLst, only: GetNod, iVPtr, LLx, LstPtr, PutVec, SCF_V
use InfSCF, only: Iter, Iter_Ref, Iter_Start, mOV
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, inode, jpgrd
real(kind=wp), allocatable :: Scr(:)

call mma_allocate(Scr,mOV,Label='Scr')

jpgrd = LstPtr(Iter_Ref,LLx)   ! Pointer to X_old(i_ref)
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'iter=',iter
write(u6,*) 'iter_Start=',iter_Start
write(u6,*) 'iter_ref=',iter_ref
call NrmClc(SCF_V(jpgrd)%A(:),mOV,'XClc','X(i_ref)(:)')
write(u6,*)
#endif

! Loop over all iterations starting at Iter_Start+1

do i=Iter_Start,Iter

  !X_new(i) = X_old(i)-X_old(i_ref)

  call GetNod(i,LLx,inode)
  if (inode == 0) then
    write(u6,*) 'inode == 0'
    call Abend()
  end if
  call iVPtr(Scr,mOV,inode)
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'X(i) before  i=',i
  call NrmClc(Scr(:),mOV,'XClc','Scr(:)')
# endif
  Scr(:) = Scr(:)-SCF_V(jpgrd)%A(:)
# ifdef _DEBUGPRINT_
  write(u6,*) 'X(i) after  i=',i
  call NrmClc(Scr(:),mOV,'XClc','Scr(:)')
# endif

  call PutVec(Scr,mOV,i,'OVWR',LLx)
end do

call mma_deallocate(Scr)

return

end subroutine XClc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Roland Lindh                                     *
************************************************************************
      Subroutine GET_EFP()
      use EFP_Module
      Integer CoorType
      Call Get_lScalar('EFP',lEFP)
      If (lEFP) Then
         Call Get_iScalar('nEFP_fragments',nEFP_fragments)
         Call Get_iScalar('nEFP_Coor',nEFP_Coor)
         Call Get_iScalar('Coor_Type',CoorType)
         Coor_Type=INT(CoorType,c_int)
*
         Allocate (FRAG_type(nEFP_fragments))
         Call Get_cArray('FRAG_Type',FRAG_Type,180*nEFP_fragments)
*
         Allocate (ABC(3,nEFP_fragments))
         Call Get_cArray('ABC',ABC,180*3*nEFP_fragments)
*
         Allocate (EFP_Coors(nEFP_Coor,nEFP_fragments))
         Call Get_dArray('EFP_COORS',EFP_COORS,nEFP_Coor*nEFP_fragments)
      End If
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE EVEN3(N,V,G,E,A,R,TT,AUXF,AUXG,AUXH,
     $                 EVEN1,VEXTT,PVPT,RE1R,W1W1,AUXI)
C$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION V(N*(N+1)/2),G(N*(N+1)/2),E(N),R(N),A(N),TT(N),
     &          AUXF(N,N),AUXG(N,N),AUXH(N,N)
      DIMENSION EVEN1(N,N)
      DIMENSION RE1R(N,N)
      DIMENSION VEXTT(N*(N+1)/2),PVPT(N*(N+1)/2)
      DIMENSION AUXI(N,N)
      DIMENSION W1W1(N,N)
C
C     ----- CONSTRUCT RE1R -----
C
      CALL DKRE1R(A,R,E,TT,V,G,RE1R,VEXTT,PVPT,N)
C
      M=N
      IJ=0
      DO I=1,N
        DO J=1,I
          IJ=IJ+1
          AUXH(I,J)=0.D0
          AUXH(J,I)=0.D0
          V(IJ)=VEXTT(IJ)/(E(I)+E(J))
          G(IJ)=PVPT(IJ)/(E(I)+E(J))
        ENDDO
      ENDDO
C
C     ----- W1*W1*E1 -----
C
C     ------- 1/2 E1*W1*W1 + 1/2 W1*W1*E1
C
      DO I=1,N
        DO J=1,N
          AUXF(I,J)=0.5D0*EVEN1(I,J)
        ENDDO
      ENDDO
      CALL CpLabr(W1W1,AUXF,N,N,N,M,M,AUXH,M,IE)
      CALL CpLabr(AUXF,W1W1,N,N,N,M,M,AUXH,M,IE)
C
C     ----- W1*E1*W1 TERM -----
C
      IJ=0
      DO I=1,N
        DO J=1,I
          IJ=IJ+1
          AUXF(I,J)=A(I)*R(I)*G(IJ)*A(J)/R(J)/TT(J)*0.5D0
          AUXF(J,I)=A(J)*R(J)*G(IJ)*A(I)/R(I)/TT(I)*0.5D0
          AUXG(I,J)=-A(I)*V(IJ)*A(J)
          AUXG(J,I)=-A(J)*V(IJ)*A(I)
        ENDDO
      ENDDO
      CALL CZERO2(AUXI,N,N,N)
      CALL CpLabr(AUXF,RE1R,N,N,N,M,M,AUXI,M,IE)
      CALL CpLabr(AUXI,AUXG,N,N,N,M,M,AUXH,M,IE)
C
      IJ=0
      DO I=1,N
        DO J=1,I
          IJ=IJ+1
          AUXF(I,J)=A(I)*V(IJ)*A(J)
          AUXF(J,I)=A(J)*V(IJ)*A(I)
          AUXG(I,J)=-A(I)/R(I)*G(IJ)*A(J)*R(J)/TT(I)*0.5D0
          AUXG(J,I)=-A(J)/R(J)*G(IJ)*A(I)*R(I)/TT(J)*0.5D0
        ENDDO
      ENDDO
      CALL CZERO2(AUXI,N,N,N)
      CALL CpLabr(AUXF,RE1R,N,N,N,M,M,AUXI,M,IE)
      CALL CpLabr(AUXI,AUXG,N,N,N,M,M,AUXH,M,IE)
C
      IJ=0
      DO I=1,N
        DO J=1,I
          IJ=IJ+1
          AUXF(I,J)=A(I)*V(IJ)*A(J)
          AUXF(J,I)=A(J)*V(IJ)*A(I)
          AUXG(I,J)=A(I)*V(IJ)*A(J)
          AUXG(J,I)=A(J)*V(IJ)*A(I)
        ENDDO
      ENDDO
      CALL CZERO2(AUXI,N,N,N)
      CALL CpLabr(AUXF,RE1R,N,N,N,M,M,AUXI,M,IE)
      CALL CpLabr(AUXI,AUXG,N,N,N,M,M,AUXH,M,IE)
C
      IJ=0
      DO I=1,N
        DO J=1,I
          IJ=IJ+1
          AUXF(I,J)=A(I)*R(I)*G(IJ)*A(J)/R(J)/TT(J)*0.5D0
          AUXF(J,I)=A(J)*R(J)*G(IJ)*A(I)/R(I)/TT(I)*0.5D0
          AUXG(I,J)=A(I)/R(I)*G(IJ)*A(J)*R(J)/TT(I)*0.5D0
          AUXG(J,I)=A(J)/R(J)*G(IJ)*A(I)*R(I)/TT(J)*0.5D0
        ENDDO
      ENDDO
      CALL CZERO2(AUXI,N,N,N)
      CALL CpLabr(AUXF,RE1R,N,N,N,M,M,AUXI,M,IE)
      CALL CpLabr(AUXI,AUXG,N,N,N,M,M,AUXH,M,IE)
C
C     ----- SYMMETRISIEREN -----
C
      IJ=0
      DO I=1,N
        DO J=1,I
          IJ=IJ+1
          G(IJ)=0.5D0*(AUXH(I,J)+AUXH(J,I))
        ENDDO
      ENDDO
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE WEIGHT_SPGP(      Z, NORBTP, NELFTP,NORBFTP,   ISCR,
     &                         NTEST)
*
* construct vertex weights for given supergroup
*
* Reverse lexical ordering is used
*
      IMPLICIT REAL*8           ( A-H,O-Z)
*. Input
      INTEGER NELFTP(NORBTP),NORBFTP(NORBTP)
*. Ouput
      INTEGER Z(*)
*. Scratch length : 2 * NORB + (NEL+1)*(NORB+1)
       INTEGER ISCR(*)
*
       NORB = IELSUM(NORBFTP,NORBTP)
       NEL  = IELSUM(NELFTP,NORBTP)
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Subroutine WEIGHT_SPGP in action '
        WRITE(6,*) ' ================================='
        WRITE(6,*) 'NELFTP '
        CALL IWRTMA(NELFTP,1,NORBTP,1,NORBTP)
      END IF
*
      KLFREE = 1
      KLMAX = KLFREE
      KLFREE = KLFREE + NORB
*
      KLMIN = KLFREE
      KLFREE = KLFREE + NORB
*
      KW = KLFREE
      KLFREE = KW + (NEL+1)*(NORB+1)
*.Max and min arrays for strings
      CALL MXMNOC_SPGP(ISCR(KLMIN),ISCR(KLMAX),NORBTP,NORBFTP,NELFTP,
     &                         NTEST)
*. Arc weights
      CALL GRAPW(  ISCR(KW),         Z,ISCR(KLMIN),ISCR(KLMAX),    NORB,
     &                  NEL,     NTEST)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine make_close_rvb()

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, il, n
character(len=8) :: vec(11)
integer(kind=iwp), external :: find_lu

vec(1) = 'TMP01'
vec(2) = 'TMP02'
vec(3) = 'TMP03'
vec(4) = 'TMP04'
vec(5) = 'TMP05'
vec(6) = 'TMP06'
vec(7) = 'TMP07'
vec(8) = 'TMP08'
vec(9) = 'TMP09'
vec(10) = 'VBWFN'
il = 10
! Preassign some file names to identifiers :
do i=1,il
  n = find_lu(vec(i))
  if (n > 0) call daclos(n)
end do

end subroutine make_close_rvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine xflush(Lu)
!***********************************************************************
!                                                                      *
!   purpose:                                                           *
!   Dump buffers                                                       *
!                                                                      *
!   calling arguments:                                                 *
!   Lu      : integer                                                  *
!             Logical unit number                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!   written by:                                                        *
!   M.P. Fuelscher                                                     *
!   University of Lund, Sweden, 1996                                   *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!   history: Flush intrinsic available since Fortran 2003 (Jun. 2021)  *
!                                                                      *
!***********************************************************************

#define _F2003_

use Definitions, only: iwp
#if !defined(_F2003_) && defined(_CRAY_C90_)
use Definitions, only: u6
#endif

#ifdef _F2003_

implicit none
integer(kind=iwp), intent(in) :: Lu

flush(Lu)

#elif defined(_CRAY_C90_)
if (Lu == u6) then
  call flush(101)
else
  call flush(Lu)
end if
#elif defined(__INTEL_COMPILER) || defined(NAGFOR)
#include "macros.fh"
unused_var(Lu)
return
#elif defined(_SOLARIS_) || defined(_IRIX64_) || defined(_HP_UX_)
call flush(Lu)
#elif defined(_PRIMEPOWER_) || defined(_LINUX_)
call flush(Lu)
#endif

return

end subroutine xflush

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

function GetDr2(K_Lap,X,Coeff)
!-----------------------------------------------------------------------
! Function : Get 2nd derivative of error function
!
! K_Lap
!  SUM Omega(I)*Alpha(I)*Alpha(I)*Exp(-Alpha(I)*X)
!  I=1
!-----------------------------------------------------------------------

use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: GetDr2
integer(kind=iwp), intent(in) :: K_Lap
real(kind=wp), intent(in) :: X, Coeff(2,20)
integer(kind=iwp) :: I
real(kind=wp) :: Alpha, Dum, Omega

Dum = Zero
do I=1,K_Lap
  Omega = Coeff(1,I)
  Alpha = Coeff(2,I)
  Dum = Dum+Omega*Alpha*Alpha*exp(-Alpha*X)
end do

GetDr2 = Two/(X*X*X)-Dum

return

end function GetDr2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*                                                                      *
************************************************************************
*                                                                      *
*     The RHS for the MP2-gradients
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine RHS_MP2 ()
*
      Implicit real*8 (a-h,o-z)
#include "files_mbpt2.fh"
#include "trafo.fh"
#include "corbinf.fh"
*defining One etc.
#include "real.fh"
#include "WrkSpc.fh"
#include "mp2grad.fh"
#include "chomp2_cfg.fh"
*                                                                      *
************************************************************************
*                                                                      *
      IAD13=0
      LIADOUT=3*36*36
*
*     Read transformed integrals from a logical unit to a
*     buffer
*
      Call iDAFILE(LuIntM,2,IADOUT,LIADOUT,IAD13)
*
*     Sort startadresses for Virtual and occupied orbital
*     energies in nice vectors
*
      nVirTot=0
      nDelTot=0
      Do i = 1, nSym
         nVirTot = nVirTot + nExt(i)
         nDelTot = nDelTot + nDel(i)
      End Do
*
*     The frozen energies are stashed at the end!
*
      mAdOcc(1) = ipEOcc
      do iSym = 2, nSym
         mAdOcc(iSym) = mAdOcc(iSym-1) + nOcc(iSym-1)
      enddo
*
*     The deleted "energies" are stached at the end!
*
      mAdVir(1) = ipEVir
      do iSym=2, nSym
         mAdVir(iSym) = mAdVir(iSym-1) + nExt(iSym-1)
      enddo
*
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
*----- Print occupied and virtual energies
      Do iSym = 1, nSym
         If (nOcc(iSym).gt.0) Then
         Write(6,*)
         Write(6,*) 'Occupied energies, Sym', iSym
         Write(6,*)
         Do iOcc = 0, nOcc(iSym)-1
            Write(6,*) Work(mAdOcc(iSym)+iOcc)
         End Do
         End If
         If (nExt(iSym).gt.0) Then
         Write(6,*)
         Write(6,*) 'Virtual energies, Sym', iSym
         Write(6,*)
         Do iExt = 0, nExt(iSym)-1
            Write(6,*) Work(mAdVir(iSym)+iExt)
         End Do
         End If
         If (nFro(iSym).gt.0) Then
         Write(6,*)
         Write(6,*) 'Frozen energies, Sym', iSym
         Write(6,*)
         Do iFro = 0, nFro(iSym)-1
            Write(6,*) Work(mAdFro(iSym)+iFro)
         End Do
         End If
         If (nDel(iSym).gt.0) Then
         Write(6,*)
         Write(6,*) 'Deleted energies, Sym', iSym
         Write(6,*)
         Do iDel = 0, nDel(iSym)-1
            Write(6,*) Work(mAdDel(iSym)+iDel)
            Write(6,*)
         End Do
         End If
      End Do
#endif
*
      EMP2 = Zero
      VECL2= One
*
*     Find the largest block needed to store exchange integrals
*     either using IJ or AB as fix indeces.
*
      nMaxOrb=0
      Do iSym1 = 1,nSym
         Do iSym2 = 1,nSym
            nMaxOrb = Max(nMaxOrb,(nOrb(iSym1)+nDel(iSym1))
     &                               *(nOrb(iSym2)+nDel(iSym2)))
         End Do
      End Do
*
      lInt = nMaxOrb
*
*     Allocate space for the block of exchange integrals
*     type 1 and type 2 (ia|jb) and (ib|ja)
*
      Call GetMem('Int1','Allo','Real',ipInt1,lInt)
      Call GetMem('Int2','Allo','Real',ipInt2,lInt)
*
*     Allocate a scratchvector for Coul and Exch
*     subroutines.
*
      Call GetMem('Scr1','Allo','Real',ipScr1,lInt)
*
*     Refer to the three-index storing of the symmetryblocks
*     by this routine
*
#ifdef _DEBUGPRINT_
      Write (6,*) 'Before RHS_Mp2_help1'
      Do iSym = 1, nSym
         nI = nOcc(iSym) + nFro(iSym)
         nA = nExt(iSym) + nDel(iSym)
         nB = nOrb(iSym) + nDel(iSym)
         Call RecPrt('MP2Lagr',' ',Work(ip_Mp2Lagr(iSym)),
     &               nI,nA)
         Call RecPrt('Dens',' ',Work(ip_Density(iSym)),nB,nB)
      End Do
#endif
      Do iSymI = 1, nSym
         Do iSymJ = 1, iSymI
            Do iSymA = 1,nSym
               iSymB = IEOR(iSymA-1,(IEOR(iSymI-1,iSymJ-1))) + 1
               If (iSymB.le.iSymA) then
*                 Check if there is any doubly excited configurations in
*                 the current symmetry.
                  if((nOrb(iSymI)+nDel(iSymI))
     &              *(nOrb(iSymJ)+nDel(iSymJ))
     &              *(nOrb(iSymA)+nDel(iSymA))
     &              *(nOrb(iSymB)+nDel(iSymB)).ne.0) then
*
                     Call RHS_Mp2_help1(iSymA, iSymB, iSymI, iSymJ)
*
                  endif         !The constructed symmetry was empty
               Endif            !No <occ occ | vir vir> in this symmetry
            enddo               !ASym
         enddo                  !JSym
      enddo                     !ISym
#ifdef _DEBUGPRINT_
      Write (6,*) 'After RHS_Mp2_help1'
      Do iSym = 1, nSym
         nI = nOcc(iSym) + nFro(iSym)
         nA = nExt(iSym) + nDel(iSym)
         nB = nOrb(iSym) + nDel(iSym)
         Call RecPrt('MP2Lagr',' ',Work(ip_Mp2Lagr(iSym)),
     &               nI,nA)
         Call RecPrt('Dens',' ',Work(ip_Density(iSym)),nB,nB)
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Do iSym =1, nSym
         Do i = 1, nOcc(iSym)+nExt(iSym)
            Do j = 1, nFro(iSym)
               Work(ip_Density(iSym) + i+nFro(iSym)-1 +
     &              (j-1)*(nOrb(iSym) + nDel(iSym))) =
     &         Work(ip_Density(iSym) + j-1 +
     &              (i+nFro(iSym)-1)*(nOrb(iSym) + nDel(iSym)))
            End Do
            Do j= 1, nDel(iSym)
              Work(ip_Density(iSym) + j+nOrb(iSym)-1 +
     &              (i+nFro(iSym)-1)*(nOrb(iSym) + nDel(iSym))) =
     &           Work(ip_Density(iSym) + i+nFro(iSym)-1 +
     &              (j+nOrb(iSym)-1)*(nOrb(iSym) + nDel(iSym)))
            End Do
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Write (6,*) 'After RHS_Mp2_help1 xx'
      Do iSym = 1, nSym
         nI = nOcc(iSym) + nFro(iSym)
         nA = nExt(iSym) + nDel(iSym)
         nB = nOrb(iSym) + nDel(iSym)
         Call RecPrt('MP2Lagr',' ',Work(ip_Mp2Lagr(iSym)),
     &               nI,nA)
         Call RecPrt('Dens',' ',Work(ip_Density(iSym)),nB,nB)
      End Do
#endif
*
*     Since some terms in the Lagrangian is dependent of Pab and Pij we
*     have to loop through all the symmetries again since they are not done
*     until the loop is over.
*
      Do iSymI = 1, nSym
         Do iSymJ = 1, iSymI
            Do iSymA = 1,nSym
               iSymB = IEOR(iSymA-1,(IEOR(iSymI-1,iSymJ-1))) + 1
               if (iSymB.le.iSymA) then
*                 Check if there is any doubly excited configurations in
*                 the current symmetry.
                  if((nOrb(iSymI)+nDel(iSymI))
     &              *(nOrb(iSymJ)+nDel(iSymJ))
     &              *(nOrb(iSymA)+nDel(iSymA))
     &              *(nOrb(iSymB)+nDel(iSymB)).ne.0) then
                     Call RHS_Mp2_help2(iSymA,iSymB,iSymI,iSymJ)
                  endif         !The constructed symmetry was empty
               endif            !No <occ occ | vir vir> in this symmetry
            enddo               !ASym
         enddo                  !JSym
      enddo                     !ISym
#ifdef _DEBUGPRINT_
      Write (6,*) 'After RHS_Mp2_help1 yy'
      Do iSym = 1, nSym
         nI = nOcc(iSym) + nFro(iSym)
         nA = nExt(iSym) + nDel(iSym)
         nB = nOrb(iSym) + nDel(iSym)
         Call RecPrt('MP2Lagr',' ',Work(ip_Mp2Lagr(iSym)),
     &               nI,nA)
         Call RecPrt('Dens',' ',Work(ip_Density(iSym)),nB,nB)
      End Do
#endif
*
*     Need two extra integral fields due to symmetrization
*
      If(.not. NoGamma) Then
         Call GetMem('Int1_2','Allo','Real',ipInt1_2,lInt)
         Call GetMem('Int2_2','Allo','Real',ipInt2_2,lInt)
*
*        Construct and backtransform nonsep 2pdm.
*
         Call Gamma_new()
*
         Call GetMem('Int1_2','Free','Real',ipInt1_2,lInt)
         Call GetMem('Int2_2','Free','Real',ipInt2_2,lInt)
      End If
*
      Call GetMem('Int1','Free','Real',ipInt1,lInt)
      Call GetMem('Int2','Free','Real',ipInt2,lInt)
      Call GetMem('Scr1','Free','Real',ipScr1,lInt)
*
#ifdef _DEBUGPRINT_
      write (6,*) 'EMP2 is ', EMP2
      write (6,*) ' '
      Do iSym = 1, nSym
         Write(6,*) 'Density matrix for Symm:', iSym
         Call RecPrt('MP2Density','',Work(ip_Density(iSym)),
     &               nOrb(iSym) + nDel(iSym), nOrb(iSym) + nDel(iSym))
      End Do
      Do iSym = 1, nSym
         Write(6,*) 'WDensity matrix for Symm:', iSym
         Call RecPrt('MP2WDensity','',Work(ip_WDensity(iSym)),
     &               nOrb(iSym) + nDel(iSym), nOrb(iSym) + nDel(iSym))
      End Do
      Do iSym = 1, nSym
         Write(6,*) 'Lagrangian matrix for symm', iSym
         Call RecPrt('Lagr2','',Work(ip_Mp2Lagr(iSym)),
     &               nFro(iSym) + nOcc(iSym),
     &               nExt(iSym) + nDel(iSym))
      End Do
#endif
*
      VECL2=Sqrt(One/VECL2)
*
      Return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
c  ****************************************************
c  ** Routines that deal with spatial configurations **
c  ****************************************************
c  *********************************************************************
c  *                                                                   *
c  *  CNFCHECK := Check input configurations and convert to occ no     *
c  *              representation if necessary.                         *
c  *              Also sort in order of increasing ionicity.           *
c  *                                                                   *
c  *********************************************************************
      subroutine cnfcheck_cvb(iconfs,nconf1,nel1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"

#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "malloc_cvb.fh"
      dimension iconfs(noe,nconf1)

      i1 = mstacki_cvb(noe)
      call cnfcheck2_cvb(iconfs,nconf1,nel1,iw(i1))
      call mfreei_cvb(i1)
      ioncty = mstacki_cvb(nconf1)
      iconfs2 = mstacki_cvb(noe*nconf1)
      call cnfsort_cvb(iconfs,nconf1,nel1,iw(ioncty),iw(iconfs2))
      call mfreei_cvb(ioncty)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Jeppe Olsen                                      *
!               2011, Giovanni Li Manni                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADDDIA_TERM(FACTOR,CVEC,SVEC,IASPGP,IBSPGP,IASM,IBSM)
! Update Sigma vector with diagonal terms for a given block
!     SVEC(IASPGP,IBSPGP) = SVEC(IASPGP,IBSPGP)
!                         + (FACTOR+DIAG(IASPGP,IBSPGP))CVEC(IASPGP,IBSPGP)
!
! Jeppe Olsen and Giovanni Li Manni, September 2011

use lucia_data, only: ECORE, ECORE_ORIG, IREOST, MXNSTR, NACOB, NELEC, NIRREP, NOCTYP, NSTSO, NTOOB
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(in) :: FACTOR, CVEC(*)
real(kind=wp), intent(inout) :: SVEC(*)
integer(kind=iwp), intent(in) :: IASPGP, IBSPGP, IASM, IBSM
integer(kind=iwp) :: IATP, IBTP, MAXA, NAEL, NBEL, NOCTPA
real(kind=wp) :: ECOREP, FACTORX, SHIFT
integer(kind=iwp), allocatable :: LASTR(:), LBSTR(:)
real(kind=wp), allocatable :: LH1D(:), LJ(:), LK(:), LRJKA(:), LXB(:)
integer(kind=iwp), external :: IMNMX

IATP = 1
IBTP = 2
NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)
NOCTPA = NOCTYP(IATP)

#ifdef _DEBUGPRINT_
write(u6,*) ' =============================='
write(u6,*) ' ADDDIA_TERM for BK is speaking'
write(u6,*) ' =============================='
write(u6,*) ' NAEL NBEL =',NAEL,NBEL
write(u6,*) ' IASPGP, IBSPGP = ',IASPGP,IBSPGP
#endif
! A bit of scracth
call mma_allocate(LH1D,NTOOB,Label='LH1D')
call mma_allocate(LJ,NTOOB**2,Label='LJ')
call mma_allocate(LK,NTOOB**2,Label='LK')
call mma_allocate(LXB,NACOB,Label='LXB')
! Space for blocks of strings
call mma_allocate(LASTR,MXNSTR*NAEL,Label='LASTR')
call mma_allocate(LBSTR,MXNSTR*NBEL,Label='LBSTR')

MAXA = IMNMX(NSTSO(IATP)%A,NIRREP*NOCTPA,2)
call mma_allocate(LRJKA,MAXA,Label='LRJKA')
! Diagonal of one-body integrals and coulomb and exchange integrals
! Integrals assumed in place so :
call GT1DIA(LH1D)
call GTJK(LJ,LK,NTOOB,IREOST)
! Core energy not included
ECOREP = Zero
call GTJK(LJ,LK,NTOOB,IREOST)

SHIFT = ECORE_ORIG-ECORE
FACTORX = FACTOR+SHIFT

call ADDDIA_TERMS(NAEL,LASTR,NBEL,LBSTR,NACOB,CVEC,SVEC,NIRREP,LH1D,LXB,LJ,LK,NSTSO(IATP)%A,NSTSO(IBTP)%A,ECOREP,NTOOB,LRJKA, &
                  IASPGP,IASM,IBSPGP,IBSM,FACTORX)
! Flush local memory
call mma_deallocate(LH1D)
call mma_deallocate(LJ)
call mma_deallocate(LK)
call mma_deallocate(LXB)
call mma_deallocate(LASTR)
call mma_deallocate(LBSTR)
call mma_deallocate(LRJKA)

end subroutine ADDDIA_TERM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReadIn_Dynamix(Task,nTasks,mTasks)

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nTasks
integer(kind=iwp), intent(inout) :: Task(nTasks)
integer(kind=iwp), intent(out) :: mTasks
integer(kind=iwp) :: LuSpool
integer(kind=iwp), external :: IsFreeUnit

! Copy input from standard input to a local scratch file

LuSpool = IsFreeUnit(21)
call SpoolInp(LuSpool)

! Read input

#ifdef _DEBUGPRINT_
write(u6,*) ' Dynamix calls RdInp_Dynamix.'
#endif
call RdInp_Dynamix(LuSpool,Task,nTasks,mTasks)
#ifdef _DEBUGPRINT_
write(u6,*) ' Dynamix back from RdInp_Dynamix.'
#endif

! Remove local copy of standard input

close(LuSpool)

return

end subroutine ReadIn_Dynamix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Bruno Tenorio                                    *
!***********************************************************************

subroutine MKRTDM2(IFSBTAB1,IFSBTAB2,ISSTAB,MAPORB,DET1,DET2,IF21,IF12,NRT2M,RT2M,SPIN,OrbTab)
! Given two CI expansions, using a biorthonormal set of SD's,
! calculate the 2-particle transition density matrix
! in the biorthonormal active orbital basis.
! It will build the contribution from high spin (J->beta,L->beta)
! and low spin (J->beta,L->alpha).
! The spin coupling matrix elements have the following index-code:
!SPIN=1 means  K2V (AAB+BBB)
!SPIN=-1 means SDA (AAA+BBA)
!SPIN=2 means: bbb
!SPIN=3 means: aaa
!SPIN=4 means: aab
!SPIN=5 means: bba
!SPIN=6 means: aba
!SPIN=7 means: bab
! Notice, SPIN here has nothing to do with the spin quantum number. It
! is just a printing code.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IFSBTAB1(*), IFSBTAB2(*), ISSTAB(*), MAPORB(*), NRT2M, SPIN, OrbTab(*)
real(kind=wp), intent(in) :: DET1(*), DET2(*)
logical(kind=iwp), intent(in) :: IF21, IF12
real(kind=wp), intent(out) :: RT2M(NRT2M)
integer(kind=iwp) :: IAJALA, IAJALB, IAJBLA, IBJALB, IBJBLA, IBJBLB, IJLTABS, IORB, IORBA, IORBB, ITABS, JLTABS, JORB, JORBA, &
                     JORBB, JTABS, LORB, LORBA, LORBB, LTABS, NASHT, NASORB, NSRT2M
real(kind=wp) :: GAAA, GAAB, GABA, GBAB, GBBA, GBBB, GVAL
real(kind=wp), allocatable :: SRT2M(:)

! Pick out nr of active orbitals from orbital table:

NASORB = OrbTab(4)
NASHT = NASORB/2
!NASGEM = nTri_Elem(NASORB-1)
NSRT2M = NASORB**3
call mma_allocate(SRT2M,nSRT2M,Label='SRT2M')
SRT2M(:) = Zero
call SRTDM2(ORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,DET1,DET2,IF21,IF12,SRT2M)

! Mapping from active spin-orbital to active orbital in external order.
! Note that these differ, not just because of the existence of two
! spin-orbitals for each orbital, but also because the active orbitals
! (external order) are grouped by symmetry and then RAS space, but the
! spin orbitals are grouped by subpartition.
GVAL = Zero
IAJALA = 0 ! dummy initialize
IAJALB = 0 ! dummy initialize
IAJBLA = 0 ! dummy initialize
IBJALB = 0 ! dummy initialize
IBJBLA = 0 ! dummy initialize
IBJBLB = 0 ! dummy initialize

! For high spin density it will keep only beta,beta,beta.
! Notice that beta,beta,beta when J=L is zero.
! For low spin density it'll keep only alpha,beta,alpha.

do IORB=1,NASHT
  IORBA = 2*IORB-1
  IORBB = 2*IORB
  ITABS = MAPORB(IORBA)
  do JORB=1,NASHT
    JORBA = 2*JORB-1
    JORBB = 2*JORB
    JTABS = MAPORB(JORBA)
    do LORB=1,NASHT
      LORBA = 2*LORB-1
      LORBB = 2*LORB
      LTABS = MAPORB(LORBA)
      JLTABS = LTABS+NASHT*(JTABS-1)
      if (JORB > LORB) then ! When J>L
        IAJALB = IORBA+NASORB*(NASORB*(JORBA-1)+LORBB-1)
        IAJBLA = IORBA+NASORB*(NASORB*(JORBB-1)+LORBA-1)
        IBJBLB = IORBB+NASORB*(NASORB*(JORBB-1)+LORBB-1)
        IBJALB = IORBB+NASORB*(NASORB*(JORBA-1)+LORBB-1)
        IAJALA = IORBA+NASORB*(NASORB*(JORBA-1)+LORBA-1)
        IBJBLA = IORBB+NASORB*(NASORB*(JORBB-1)+LORBA-1)
        select case (SPIN)
          case (1)
            ! K^1/2,1/2= (AAB+BBB)
            GAAB = SRT2M(IAJALB)
            GBBB = SRT2M(IBJBLB)
            GVAL = (GAAB+GBBB)
          case (-1)
            ! SDA. K^1/2,-1/2
            GBBA = SRT2M(IBJBLA)
            GAAA = SRT2M(IAJALA)
            GVAL = (GAAA+GBBA)
          case (2)
            GBBB = SRT2M(IBJBLB)
            GVAL = GBBB
          case (3)
            GAAA = SRT2M(IAJALA)
            GVAL = GAAA
          case (4)
            GAAB = SRT2M(IAJALB)
            GVAL = GAAB
          case (5)
            GBBA = SRT2M(IBJBLA)
            GVAL = GBBA
          case (6)
            GABA = SRT2M(IAJBLA)
            GVAL = GABA
          case (7)
            GBAB = SRT2M(IBJALB)
            GVAL = GBAB
        end select
      else if (JORB == LORB) then
        IAJALB = IORBA+NASORB*(NASORB*(JORBA-1)+LORBB-1)
        IAJBLA = IORBA+NASORB*(NASORB*(JORBB-1)+LORBA-1)
        IBJBLB = IORBB+NASORB*(NASORB*(JORBB-1)+LORBB-1)
        IBJALB = IORBB+NASORB*(NASORB*(JORBA-1)+LORBB-1)
        IAJALA = IORBA+NASORB*(NASORB*(JORBA-1)+LORBA-1)
        IBJBLA = IORBB+NASORB*(NASORB*(JORBB-1)+LORBA-1)
        select case (SPIN)
          case (1)
            ! K^1/2,1/2
            GAAB = SRT2M(IAJALB)
            GBBB = SRT2M(IBJBLB)
            GVAL = (GAAB+GBBB)
          case (-1)
            ! SDA. K^1/2,-1/2
            GBBA = SRT2M(IBJBLA)
            GAAA = SRT2M(IAJALA)
            GVAL = (GAAA+GBBA)
          case (2)
            GBBB = SRT2M(IBJBLB)
            GVAL = GBBB
          case (3)
            GAAA = SRT2M(IAJALA)
            GVAL = GAAA
          case (4)
            GAAB = SRT2M(IAJALB)
            GVAL = GAAB
          case (5)
            GBBA = SRT2M(IBJBLA)
            GVAL = GBBA
          case (6)
            GABA = SRT2M(IAJBLA)
            GVAL = GABA
          case (7)
            GBAB = SRT2M(IBJALB)
            GVAL = GBAB
        end select
      else if (JORB < LORB) then ! When J<L
        IAJALB = IORBA+NASORB*(NASORB*(JORBA-1)+LORBB-1)
        IAJBLA = IORBA+NASORB*(NASORB*(JORBB-1)+LORBA-1)
        IBJBLB = IORBB+NASORB*(NASORB*(JORBB-1)+LORBB-1)
        IBJALB = IORBB+NASORB*(NASORB*(JORBA-1)+LORBB-1)
        IAJALA = IORBA+NASORB*(NASORB*(JORBA-1)+LORBA-1)
        IBJBLA = IORBB+NASORB*(NASORB*(JORBB-1)+LORBA-1)
        select case (SPIN)
          case (1)
            ! K^1/2,1/2
            GAAB = SRT2M(IAJALB)
            GBBB = SRT2M(IBJBLB)
            GVAL = (GAAB+GBBB)
          case (-1)
            ! SDA. K^1/2,-1/2
            GBBA = SRT2M(IBJBLA)
            GAAA = SRT2M(IAJALA)
            GVAL = (GAAA+GBBA)
          case (2)
            GBBB = SRT2M(IBJBLB)
            GVAL = GBBB
          case (3)
            GAAA = SRT2M(IAJALA)
            GVAL = GAAA
          case (4)
            GAAB = SRT2M(IAJALB)
            GVAL = GAAB
          case (5)
            GBBA = SRT2M(IBJBLA)
            GVAL = GBBA
          case (6)
            GABA = SRT2M(IAJBLA)
            GVAL = GABA
          case (7)
            GBAB = SRT2M(IBJALB)
            GVAL = GBAB
        end select
      end if
      IJLTABS = ITABS+NASHT*(JLTABS-1)
      RT2M(IJLTABS) = GVAL
    end do
  end do
end do

call mma_deallocate(SRT2M)

end subroutine MKRTDM2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MakeT2m (T2m,Tau,aGrp,bGrp,aSGrp,bSGrp,keyT)
c
c       this routine do:
c       Make T2p(i>,(a>b)")  = Tau(i,j,(a>=b)")-Tau(j,i,a>=b)")
c                     from     Tau((a>=b)',i,j)
c        or Transposed (T(ab",ij)
c
c       parameter description:
c       T2m    - T2- array (O)
c       Tau    - Tau array (I)
c       xGrp   - Group of a,b (I)
c       xSGrp  - SubGroup of a,b (I)
c        keyT   - 0 - make T(ij,ab")
c                1 - make T(ab",ij)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 T2m(1)
        real*8 Tau(1)
        integer aGrp,bGrp,aSGrp,bSGrp,keyT
c
c       help variables
        integer dimi,dimij,dimap,dimbp,dimapp,dimbpp,dimabp,dimabpp
c
        dimi=no
        dimij=no*(no-1)/2
c
        dimap=DimGrpa(aGrp)
        dimbp=DimGrpa(bGrp)
        if (aGrp.eq.bGrp) then
          dimabp=dimap*(dimap+1)/2
        else
          dimabp=dimap*dimbp
        end if
c
        dimapp=DimSGrpa(aSGrp)
        dimbpp=DimSGrpa(bSGrp)
        if (aSGrp.eq.bSGrp) then
          dimabpp=dimapp*(dimapp-1)/2
        else
          dimabpp=dimapp*dimbpp
        end if
c
        if (keyT.eq.0) then
c        T-(ij,ab") case
c
        if (aGrp.eq.bGrp) then
          if (aSGrp.eq.bSGrp) then
            call makeT2pHlp1 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                        dimi,dimij,dimapp,dimabpp,dimap,dimabp)
          else
            call makeT2pHlp2 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                        dimi,dimij,dimapp,dimbpp,dimapp,dimabp)
          end if
        else
          call makeT2pHlp3 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                      dimi,dimij,dimapp,dimbpp,dimap,dimbp)
        end if
c
        else
c        T-(ab",ij) case
c
        if (aGrp.eq.bGrp) then
          if (aSGrp.eq.bSGrp) then
            call makeT2ptHlp1 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                        dimi,dimij,dimapp,dimabpp,dimap,dimabp)
          else
            call makeT2ptHlp2 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                        dimi,dimij,dimapp,dimbpp,dimapp,dimabp)
          end if
        else
          call makeT2ptHlp3 (T2m(1),Tau(1),aGrp,bGrp,aSGrp,bSGrp,1,
     c                      dimi,dimij,dimapp,dimbpp,dimap,dimbp)
        end if
c
        end if
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3sglh142(w,dima,dimb,dimc,s2,d2,ns)
! this routine adds following contribution to W
! for syma>symb>symc
!
! W(a,b,c) <- - S2 _i(b) . D2 _jk(a,c)
!
! w    - W matrix (I/O)
! dima - dimension of a index (I)
! dimb - dimension of b index (I)
! dimc - dimension of c index (I)
! s2   - S2 matrix (I)
! d2   - D2 matrix (I)
! ns   - signum of the contribution (+-1) (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimc, ns
real(kind=wp), intent(inout) :: w(dima,dimb,dimc)
real(kind=wp), intent(in) :: s2(dimb), d2(dima,dimc)
integer(kind=iwp) :: b

if (ns == 1) then
  ! phase +1

  do b=1,dimb
    w(:,b,:) = w(:,b,:)-d2*s2(b)
  end do

else
  ! phase = -1

  do b=1,dimb
    w(:,b,:) = w(:,b,:)+d2*s2(b)
  end do

end if

return

end subroutine t3sglh142

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine buildcoul(l1,l2,l3,l4,! angular momenta of primitives
     *incl1,incl3, ! shifts for different radial integrals
     *Lrun, ! L-value for coulomb integrals
     *prmints,
     *nprim1,nprim2,nprim3,nprim4,  ! number of primitives
     *expo1,expo2,expo3,expo4, ! arrays with the exponents
     *power13,
     *power24,
     *quotpow1,quotpow2,coulovlp)
cbs ##################################################################
c
cbs  purpose: builds up the coulomb integrals
cbs  inbetween primitives and multiplies
cbs  with extra factors to correct the
cbs  normalization
c
cbs ##################################################################
      implicit real*8 (a-h,o-z)
#include "para.fh"
#include "param.fh"
#include "dofuc.fh"
#include "real.fh"
      dimension expo1(nprim1),
     *expo2(nprim2),
     *expo3(nprim3),
     *expo4(nprim4), ! the exponents
     *prmints(nprim1,nprim2,nprim3,nprim4),!scratch for prim integrals
     *power13(MxprimL,MxprimL),
     *power24(MxprimL,MxprimL),
     *quotpow1(nprim1,nprim2,nprim3,nprim4),
     *quotpow2(nprim1,nprim2,nprim3,nprim4),
     *fraclist1(0:Lmax+3),fraclist2(0:Lmax+3),fact(MxprimL),
     *frac(MxprimL),cfunctx1(MxprimL),cfunctx2(MxprimL)
     *,coulovlp(MxprimL,MxprimL,-1:1,-1:1,0:Lmax,0:Lmax)
      root8ovpi=sqrt(8d0/pi)
cbs ##################################################################
cbs        prepare indices for coulint
cbs ##################################################################
      n1=l1+incl1+1
      n2=l2+1
      n3=l3+incl3+1
      n4=l4+1
      n13=n1+n3
      n24=n2+n4
      index1=N13-Lrun-1
      index2=n24+Lrun
      index3=N24-Lrun-1
      index4=n13+Lrun
      do krun=0,(index1-1)/2
      fraclist1(krun)=dffrac(krun+krun+index2-1,krun+krun)*
     *dffrac(1,index2-1)
      enddo
      do krun=0,(index3-1)/2
      fraclist2(krun)=dffrac(krun+krun+index4-1,krun+krun)*
     *dffrac(1,index4-1)
      enddo
cbs ##################################################################
cbs   common factors including double factorials
cbs ##################################################################
      doff1=dffrac(index1-1,n13-1)*dffrac(n24+Lrun-1,n24-1)
      doff2=dffrac(index3-1,n24-1)*dffrac(n13+Lrun-1,n13-1)
      if (index1.eq.1) then
                do irun4=1,nprim4
                do irun3=1,nprim3
                if (l2.eq.l4) then
                limit2=irun4
                else
                limit2=nprim2
                endif
                  do irun2=1,limit2
                   pow24inv=doff1/power24(irun4,irun2)
                if (l1.eq.l3) then
                limit1=irun3
                else
                limit1=nprim1
                endif
                do irun1=1,limit1
                prmints(irun1,irun2,irun3,irun4)=
     *          quotpow1(irun1,irun2,irun3,irun4)*
     *          sqrt(0.5d0*(expo1(irun1)+expo3(irun3)))*
     *          power13(irun3,irun1)*pow24inv
                      enddo
                      enddo
                      enddo
                      enddo
      else
                do irun4=1,nprim4
                do irun3=1,nprim3
                if (l2.eq.l4) then
                limit2=irun4
                else
                limit2=nprim2
                endif
                  do irun2=1,limit2
                alpha24inv=1d0/(expo2(irun2)+expo4(irun4))
                pow24inv=doff1/power24(irun4,irun2)
                if (l1.eq.l3) then
                limit1=irun3
                else
                limit1=nprim1
                endif
                do irun1=1,limit1
                a1324= alpha24inv*(expo1(irun1)+expo3(irun3))
                   Cfunctx1(irun1)=fraclist1(0)
                   frac(irun1)=a1324/(1d0+a1324)
                   fact(irun1)=frac(irun1)
                enddo
*vocl    loop,repeat(Lmax+3)
                   do k=1,(index1-1)/2
                   do irun1=1,limit1
                   Cfunctx1(irun1)=Cfunctx1(irun1)+fraclist1(k)
     *            *fact(irun1)
                   enddo
                   do irun1=1,limit1
                   fact(irun1)=fact(irun1)*frac(irun1)
                   enddo
                   enddo
                do irun1=1,limit1
                alpha13=0.5d0*(expo1(irun1)+expo3(irun3))
                prmints(irun1,irun2,irun3,irun4)=
     *          quotpow1(irun1,irun2,irun3,irun4)*
     *          sqrt(alpha13)*power13(irun3,irun1)*pow24inv*
     *          Cfunctx1(irun1)
                enddo
                enddo
                enddo
                enddo
      endif
      if (index3.eq.1) then
                do irun4=1,nprim4
                do irun3=1,nprim3
                if (l2.eq.l4) then
                limit2=irun4
                else
                limit2=nprim2
                endif
                  do irun2=1,limit2
                pow24=doff2*power24(irun4,irun2)*
     *          sqrt(0.5d0*(expo2(irun2)+expo4(irun4)))
                if (l1.eq.l3) then
                limit1=irun3
                else
                limit1=nprim1
                endif
                do irun1=1,limit1
                prmints(irun1,irun2,irun3,irun4)=
     *          prmints(irun1,irun2,irun3,irun4)+
     *          pow24*quotpow2(irun1,irun2,irun3,irun4)/
     *          power13(irun3,irun1)
                enddo
                enddo
                enddo
                enddo
      else
                do irun4=1,nprim4
                do irun3=1,nprim3
                if (l2.eq.l4) then
                limit2=irun4
                else
                limit2=nprim2
                endif
                  do irun2=1,limit2
                alpha24=expo2(irun2)+expo4(irun4)
                pow24=doff2*power24(irun4,irun2)*
     *          sqrt(0.5d0*alpha24)
                if (l1.eq.l3) then
                limit1=irun3
                else
                limit1=nprim1
                endif
                do irun1=1,limit1
                a2413= alpha24/(expo1(irun1)+expo3(irun3))
                   Cfunctx2(irun1)=fraclist2(0)
                   frac(irun1)=a2413/(1d0+a2413)
                   fact(irun1)=frac(irun1)
                enddo
*vocl    loop,repeat(Lmax+3)
                   do k=1,(index3-1)/2
                   do irun1=1,limit1
                   Cfunctx2(irun1)=Cfunctx2(irun1)+
     *             fraclist2(k)*fact(irun1)
                   enddo
                   do irun1=1,limit1
                   fact(irun1)=fact(irun1)*frac(irun1)
                   enddo
                   enddo
                do irun1=1,limit1
                prmints(irun1,irun2,irun3,irun4)=
     *          prmints(irun1,irun2,irun3,irun4)+
     *          quotpow2(irun1,irun2,irun3,irun4)*
     *          Cfunctx2(irun1)*
     *          pow24/power13(irun3,irun1)
                enddo
                enddo
                enddo
                enddo
      endif
cbs   make some mirroring for identical l-values
cbs   for the case that l1=l3
      if (l1.eq.l3) then
      do irun4=1,nprim4
      do irun3=1,nprim3
      do irun2=1,nprim2
      do irun1=irun3+1,nprim1
      prmints(irun1,irun2,irun3,irun4)=
     *prmints(irun3,irun2,irun1,irun4)
      enddo
      enddo
      enddo
      enddo
      endif
cbs   for the case that l2=l4
      if (l2.eq.l4) then
      do irun4=1,nprim4
      do irun3=1,nprim3
      do irun2=irun4+1,nprim2
      do irun1=1,nprim1
      prmints(irun1,irun2,irun3,irun4)=
     *prmints(irun1,irun4,irun3,irun2)
      enddo
      enddo
      enddo
      enddo
      endif
cbs   some factors which are the same for all cases
      do irun4=1,nprim4
      do irun3=1,nprim3
      do irun2=1,nprim2
      do irun1=1,nprim1
      prmints(irun1,irun2,irun3,irun4)=
     *prmints(irun1,irun2,irun3,irun4)*
     *coulovlp(irun4,irun2,0,0,l4,l2)*
     *coulovlp(irun3,irun1,incl3,incl1,l3,l1)*
     *root8ovpi
      enddo
      enddo
      enddo
      enddo
cbs
cbs  look for additional factors, as the
cbs  coulomb integrals are calculated
cbs  for normalized functions with that
cbs  specific l
cbs
cbs  if l was increased by one, the factor is
cbs  0.5*sqrt((2l+3)/(exponent))
cbs  if l was decreased by one, the factor is
cbs  2d0*sqrt(exponent/(2l+1))
cbs
cbs
cbs   check for first function
cbs
cbs
      if (incl1.eq.1) then
      fact1=0.5d0*sqrt(DBLE(l1+l1+3))
      do irun4=1,nprim4
      do irun3=1,nprim3
      do irun2=1,nprim2
      do irun1=1,nprim1
      factor=fact1/sqrt(expo1(irun1))
      prmints(irun1,irun2,irun3,irun4)=
     *prmints(irun1,irun2,irun3,irun4)*factor
      enddo
      enddo
      enddo
      enddo
      elseif (incl1.eq.-1) then
      fact1=2d0/sqrt(DBLE(l1+l1+1))
      do irun4=1,nprim4
      do irun3=1,nprim3
      do irun2=1,nprim2
      do irun1=1,nprim1
      factor=fact1*sqrt(expo1(irun1))
      prmints(irun1,irun2,irun3,irun4)=
     *prmints(irun1,irun2,irun3,irun4)*factor
      enddo
      enddo
      enddo
      enddo
      endif
cbs
cbs
cbs   check for third function
cbs
cbs
      if (incl3.eq.1) then
      fact1=0.5d0*sqrt(DBLE(l3+l3+3))
      do irun4=1,nprim4
      do irun3=1,nprim3
      do irun2=1,nprim2
      do irun1=1,nprim1
      factor=fact1/sqrt(expo3(irun3))
      prmints(irun1,irun2,irun3,irun4)=
     *prmints(irun1,irun2,irun3,irun4)*factor
      enddo
      enddo
      enddo
      enddo
      elseif (incl3.eq.-1) then
      fact1=2d0/sqrt(DBLE(l3+l3+1))
      do irun4=1,nprim4
      do irun3=1,nprim3
      do irun2=1,nprim2
      do irun1=1,nprim1
      factor=fact1*sqrt(expo3(irun3))
      prmints(irun1,irun2,irun3,irun4)=
     *prmints(irun1,irun2,irun3,irun4)*factor
      enddo
      enddo
      enddo
      enddo
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_O(ZA,RA,nAtoms,T,O,Lambda)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

integer(kind=iwp), intent(in) :: nAtoms
real(kind=wp), intent(in) :: ZA(nAtoms), RA(3,nAtoms), T(3)
real(kind=wp), intent(out) :: O(3,3), Lambda(3)
real(kind=wp) :: EVal(6), M(3,3)

!                                                                      *
!***********************************************************************
!                                                                      *
! Form the nuclear charge moment tensor

call Compute_M(ZA,nAtoms,RA,T,M)
!                                                                      *
!***********************************************************************
!                                                                      *
! Diagonalize the nuclear charge momentum tensor to get
! the principal axis system.

O = reshape([One,Zero,Zero,Zero,One,Zero,Zero,Zero,One],[3,3])
EVal(1) = M(1,1)
EVal(2) = M(2,1)
EVal(3) = M(2,2)
EVal(4) = M(3,1)
EVal(5) = M(3,2)
EVal(6) = M(3,3)
call Jacob(EVal,O,3,3)
!call JacOrd(EVal,O,3,3)
#ifdef _DEBUGPRINT_
call TriPrt('RotGrd: EVal',' ',EVal,3)
call RecPrt('RotGrd: O',' ',O,3,3)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
Lambda(1) = EVal(1)
Lambda(2) = EVal(3)
Lambda(3) = EVal(6)
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Compute_O

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine diish2 (rdiis1,ndiis,cdiis,rc)
c
c     this rouine calculate diis coeficients by solving
c
c     B-1   c  =  0
c     -1 0   l    -1
c
c     and consequent normalization of coeficients
c
c
c     r1diis  - matrix of amp. overlap of ndiid+1 iterations (I)
c     ndiis   - size of diis (2-4) (I)
c     cdiis   - final diis coeficients (O)
c     rc      - return (error) code (O)
c     0 - OK
c     1 - singular DIIS matrix
c
c
       real*8 rdiis1(1:4,1:4)
       real*8 cdiis (1:4)
       integer ndiis,rc
c
c     help variables
c
       integer p,q
       real*8 scalar
       real*8 rdiis2(1:5,1:5)
       real*8 bb(1:5)
       real*8 ci(1:5)
c
c1    vanish rdiis2 file
       call mv0zero (25,25,rdiis2)
c
c2.1  make rdiis2 matrix
c
       do 10 p=1,ndiis
       do 11 q=1,ndiis
       rdiis2(p,q)=rdiis1(p,q)
 11     continue
 10     continue
c
       do 12 p=1,ndiis
       rdiis2(p,ndiis+1)=-1.0d0
       rdiis2(ndiis+1,p)=-1.0d0
       bb(p)=0.0d0
 12     continue
c
       bb(ndiis+1)=-1.0d0
c
c2.2  modify rdiis2 matrix
c
c     scale matrix
       scalar=sqrt(rdiis2(1,1)*rdiis2(ndiis,ndiis))
       do 13 q=1,ndiis
       do 14 p=1,ndiis
       rdiis2(p,q)=rdiis2(p,q)/scalar
 14     continue
 13     continue
c
c     add penalty function
       scalar=0.01d0*rdiis2(ndiis,ndiis)
c     rdiis2(ndiis,ndiis)=rdiis2(ndiis,ndiis)+scalar
c     bb(ndiis)=scalar
c
c
c3    solve SLE
c
c3.1  vanish ci
       do 20 p=1,ndiis+1
       ci(p)=0.0d0
 20     continue
c
c3.2  get cdiis
       call gauss (ndiis+1,5,rdiis2,ci,bb)
c
c4    final modification of cdiis coeficients
c
CFUE   if (rc.eq.1) then
c     matrix R2 was singular, no extrapolation
CFUE   write(6,*) ' SINGULAR DIIS MATRIX, NO EXTRAPOLATION'
CFUE   cdiis(1)=1.0d0
CFUE   do p=2,ndiis
CFUE   cdiis(p)=0.0d0
CFUE   end do
c
CFUE   else
c     DIIS procedure was succesfull, renormalize coef.
c
       scalar=0.0d0
       do 40 p=1,ndiis
       scalar=scalar+ci(p)
 40     continue
c
       do 50 p=1,ndiis
       cdiis(p)=ci(p)/scalar
 50     continue
c
       scalar=0.0d0
       do 60 p=1,ndiis
       scalar=scalar+cdiis(p)
 60     continue
c
CFUE   end if
c
CFUE   write(6,*) cdiis(1),cdiis(2),cdiis(3),cdiis(4),scalar
c51     format (5(i2,d12.7))
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(rc)
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SOGthr(SOInt,iBas,jBas,nSOInt,PrpInt,nPrp,lOper,iCmp,jCmp,iShell,jShell,iAO,jAO)
!***********************************************************************
!                                                                      *
! Object: to gather elements, from the Fock or 1st order density matrix*
!         in SO-basis, which are associated with a shell pair.         *
!         OBSERVE that the matrix is folded to triangular form, i.e.   *
!         the off diagonal elements has twice there value. This in     *
!         order to reduce the summation to i>=j. However, this will    *
!         not be used for the diagonal blocks. Hence, these elements   *
!         will only be assigned half the value from the original       *
!         matrix.                                                      *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!***********************************************************************

use Index_Functions, only: iTri
use SOAO_Info, only: iAOtSO
use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Constants, only: One, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iBas, jBas, nSOInt, nPrp, lOper, iCmp, jCmp, iShell, jShell, iAO, jAO
real(kind=wp), intent(out) :: SOInt(iBas*jBas,nSOInt)
real(kind=wp), intent(in) :: PrpInt(nPrp)
integer(kind=iwp) :: i1, i2, indAO1, indAO2, Indi, Indj, ipij, iPnt, iSO1, iSO2, j1, j12, j2, jjMx, lSO, nRow
real(kind=wp) :: Fact
integer(kind=iwp), external :: iPntSO

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt(' In SOGthr: PrpInt',' ',PrpInt,1,nPrp)
write(u6,*) ' iAO, jAO=',iAO,jAO
write(u6,*) ' iShell, jShell=',iShell,jShell
#endif
lSO = 0
do j1=0,nIrrep-1
  do i1=1,iCmp
    if (iAOtSO(iAO+i1,j1) < 0) cycle

    ! Gather the SO's from lower rectangular blocks and triangular
    ! diagonal blocks.

    do j2=0,j1
      j12 = ieor(j1,j2)
      if (.not. btest(lOper,j12)) cycle
      jjMx = jCmp
      if ((iShell == jShell) .and. (j1 == j2)) jjMx = i1
      do i2=1,jjMx
        if (iAOtSO(jAO+i2,j2) < 0) cycle
        lSO = lSO+1
        iSO1 = iAOtSO(iAO+i1,j1)
        iSO2 = iAOtSO(jAO+i2,j2)

        iPnt = iPntSO(j1,j2,lOper,nbas)
        !write(u6,*) iSO1,iSO2,iPnt,i1,j1,i2,j2
        do indAO1=0,iBas-1
          ! Diagonal block (only unique elements).
          do indAO2=0,jBas-1
            ipij = indAO2*iBas+indAO1+1
            Indi = iSO1+indAO1
            Indj = iSO2+indAO2

            ! Move one element and unfold.

            Fact = Half
            if (Indi == Indj) Fact = One

            if (j1 == j2) then
              SOInt(ipij,lSO) = Fact*PrpInt(iPnt+iTri(Indi,Indj))
            else
              nRow = nBas(j1)
              SOInt(ipij,lSO) = Fact*PrpInt(iPnt+nRow*(Indj-1)+Indi)
            end if

          end do
        end do

      end do
    end do

  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt(' In SOGthr: SOInt',' ',SOInt,iBas*jBas,nSOInt)
#endif

return

end subroutine SOGthr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE TRDNS1(IVEC,DPT1,NDPT1)
      use definitions, only: iwp, wp
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
#endif
      use stdalloc, only: mma_allocate, mma_deallocate
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: nActel, nSym, nIsh, nAsh, nSsh, nInDep,
     &                         nISup, nASup, nAsh, nOrb
#define RHS_ X_RHS_
      IMPLICIT none

      integer(kind=iwp), intent(in):: IVEC, NDPT1
      real(kind=wp), intent(inout):: DPT1(NDPT1)
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif
      real(kind=wp), ALLOCATABLE:: WTI(:), WAT(:), WAI(:)
#ifdef _MOLCAS_MPP_
      real(kind=wp), ALLOCATABLE:: TMP(:)
#endif
      real(kind=wp) FACT
      integer(kind=iwp) IA, ICASE, ID, IDOFF, II, IMLTOP, ISYM, IT,
     &                  ITTOT, IW, IWAI, IWAT, IWOFF, IWTI, lVec, NA,
     &                  NAS, NI, NIS, NO, NS, NVEC, NWAI, NWAT, NWTI

C Add to the transition density matrix DPT1,
C    DPT1(p,q) = Add <IVEC| E(p,q) |0>.
C where IVEC stands for the 1st-order perturbed CASPT2
C wave function stored as vector nr IVEC on LUSOLV.
C DPT1 is stored as symmetry-blocked array of square matrices.
C Each square matrix is actually lower block triangle, but is
C stored in full, including zero elements.

C Only cases A, C and D(Symm 1) contributes.

C Transform to standard representation, covariant form.
      CALL PTRTOC(1,IVEC,IVEC)

      NWTI=0
      NWAI=0
      NWAT=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NS=NSSH(ISYM)
        NWTI=NWTI+NA*NI
        NWAI=NWAI+NS*NI
        NWAT=NWAT+NS*NA
      END DO

      IMLTOP=1
      IF(NWTI.EQ.0) GOTO 110
      CALL mma_allocate(WTI,NWTI,LABEL='WTI')
      WTI(:)=0.0D0
      ICASE=1
      IWOFF=1
      DO 100 ISYM=1,NSYM
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 100
        NIS=NISUP(ISYM,ICASE)
        NAS=NASUP(ISYM,ICASE)
        NVEC=NIS*NAS
        IF(NVEC.EQ.0) GOTO 100
        CALL RHS_ALLO(NAS,NIS,LVEC)
        CALL RHS_READ_C(LVEC,ICASE,ISYM,IVEC)
        FACT=1.0D00/(DBLE(MAX(1,NACTEL)))
#ifdef _MOLCAS_MPP_
        IF (IS_REAL_PAR()) THEN
          IF (KING()) THEN
            CALL mma_allocate(TMP,NVEC,Label='TMP')
            CALL RHS_GET (NAS,NIS,LVEC,TMP)
            CALL SPEC1A(IMLTOP,FACT,ISYM,TMP,WTI(IWOFF))
            CALL mma_deallocate(TMP)
          END IF
        ELSE
#endif
          CALL SPEC1A(IMLTOP,FACT,ISYM,GA_Arrays(LVEC)%A,
     &                                 WTI(IWOFF))
#ifdef _MOLCAS_MPP_
        END IF
#endif
        CALL RHS_FREE(LVEC)
        IWOFF=IWOFF+NASH(ISYM)*NISH(ISYM)
 100  CONTINUE
 110  CONTINUE

      IF(NWAT.EQ.0) GOTO 210
      CALL mma_allocate(WAT,NWAT,Label='WAT')
      WAT(:)=0.0D0
      ICASE=4
      IWOFF=1
      DO 200 ISYM=1,NSYM
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 200
        NIS=NISUP(ISYM,ICASE)
        NAS=NASUP(ISYM,ICASE)
        NVEC=NIS*NAS
        IF(NVEC.EQ.0) GOTO 200
        IF(NSSH(ISYM)*NASH(ISYM).EQ.0) GOTO 200
        CALL RHS_ALLO(NAS,NIS,LVEC)
        CALL RHS_READ_C(LVEC,ICASE,ISYM,IVEC)
        FACT=1.0D00/(DBLE(MAX(1,NACTEL)))
#ifdef _MOLCAS_MPP_
        IF (IS_REAL_PAR()) THEN
          IF (KING()) THEN
            CALL mma_allocate(TMP,NVEC,LABEL='TMP')
            CALL RHS_GET (NAS,NIS,LVEC,TMP)
            CALL SPEC1C(IMLTOP,FACT,ISYM,TMP,WAT(IWOFF))
            CALL mma_deallocate(TMP)
          END IF
        ELSE
#endif
          CALL SPEC1C(IMLTOP,FACT,ISYM,GA_Arrays(LVEC)%A,WAT(IWOFF))
#ifdef _MOLCAS_MPP_
        END IF
#endif
        CALL RHS_FREE(LVEC)
        IWOFF=IWOFF+NSSH(ISYM)*NASH(ISYM)
 200  CONTINUE
 210  CONTINUE

      IF(NWAI.EQ.0) GOTO 300
      CALL mma_allocate(WAI,NWAI,Label='WAI')
      WAI(:)=0.0D0
      ICASE=5
      ISYM=1
      IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 300
      NIS=NISUP(ISYM,ICASE)
      NAS=NASUP(ISYM,ICASE)
      NVEC=NIS*NAS
      IF(NVEC.EQ.0) GOTO 300
      CALL RHS_ALLO(NAS,NIS,LVEC)
      CALL RHS_READ_C(LVEC,ICASE,ISYM,IVEC)
      FACT=1.0D00/(DBLE(MAX(1,NACTEL)))
#ifdef _MOLCAS_MPP_
      IF (IS_REAL_PAR()) THEN
        IF (KING()) THEN
          CALL mma_allocate(TMP,NVEC,LABEL='TMP')
          CALL RHS_GET (NAS,NIS,LVEC,TMP)
          CALL SPEC1D(IMLTOP,FACT,TMP,WAI)
          CALL mma_deallocate(TMP)
        END IF
      ELSE
#endif
        CALL SPEC1D(IMLTOP,FACT,GA_Arrays(LVEC)%A,WAI)
#ifdef _MOLCAS_MPP_
      END IF
#endif
      CALL RHS_FREE(LVEC)
 300  CONTINUE

C Transform vectors back to eigenbasis of H0(diag).
      CALL PTRTOSR(0,IVEC,IVEC)

      IF(NWTI.GT.0) CALL GADSUM(WTI,NWTI)
      IF(NWAI.GT.0) CALL GADSUM(WAI,NWAI)
      IF(NWAT.GT.0) CALL GADSUM(WAT,NWAT)
C Put transition density elements in temporaries W into
C proper positions, as subdiagonal matrices in DPT1:
      IDOFF=0
      IWTI=0
      IWAI=0
      IWAT=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NS=NSSH(ISYM)
        NO=NORB(ISYM)
        DO IT=1,NA
          ITTOT=IT+NI
          DO II=1,NI
            ID=IDOFF+ITTOT+NO*(II-1)
            IW=IWTI+IT+NA*(II-1)
            DPT1(ID)=DPT1(ID)+WTI(IW)
          END DO
        END DO
        DO IT=1,NA
          ITTOT=IT+NI
          ID=IDOFF+NI+NA+NO*(ITTOT-1)
          IW=IWAT+IT-NA
          DO IA=1,NS
            ID=ID+1
            IW=IW+NA
            DPT1(ID)=DPT1(ID)+WAT(IW)
          END DO
        END DO
        DO II=1,NI
          ID=IDOFF+NI+NA+NO*(II-1)
          IW=IWAI+II-NI
          DO IA=1,NS
            ID=ID+1
            IW=IW+NI
            DPT1(ID)=DPT1(ID)+WAI(IW)
          END DO
        END DO
        IWTI=IWTI+NA*NI
        IWAI=IWAI+NS*NI
        IWAT=IWAT+NS*NA
        IDOFF=IDOFF+NO**2
      END DO

      IF(NWTI.GT.0)CALL mma_deallocate(WTI)
      IF(NWAI.GT.0)CALL mma_deallocate(WAI)
      IF(NWAT.GT.0)CALL mma_deallocate(WAT)

      END SUBROUTINE TRDNS1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_PrintAtomPairInfo()
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: Print atom pair info.
C
      Implicit None
#include "localdf_print.fh"
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

      Character*2 Unt

      Integer iAtomPair, nAtomPair
      Integer iAtom, jAtom
      Integer ip, iD
      Integer l, n1, n2
      Integer n1max, n2max
      Integer n, M, iAddr, LenOfC

      Real*8 R, Rmax_All, Dmax, Dmax_All, x
      Real*8 DBmax, DBmax_All
      Real*8 LenTot, Byte

      Logical  LDF_AtomPairInfoIsSet, LDF_AtomPairInfoIsUnset
      External LDF_AtomPairInfoIsSet, LDF_AtomPairInfoIsUnset

      Integer  LDF_Coord_Atom
      Integer  LDF_DiskAddressOfC, LDF_nBas_Atom
      Integer  LDF_nAtom, LDF_nBasAux_Pair
      Integer  LDF_nAtomPair, LDF_AtomPair_DiagDim
      Integer  LDF_UniqueAtomPair, LDF_nUniqueAtomPair
      External LDF_Coord_Atom
      External LDF_DiskAddressOfC, LDF_nBas_Atom
      External LDF_nAtom, LDF_nBasAux_Pair
      External LDF_nAtomPair, LDF_AtomPair_DiagDim
      External LDF_UniqueAtomPair, LDF_nUniqueAtomPair

      Real*8   LDF_AtomicDistance, LDF_InteractionRange
      External LDF_AtomicDistance, LDF_InteractionRange

      Integer i,j
      Integer ip_D, ip_DB, n1CLinDep, n2CFunctions
      Integer AP_Atoms
      Logical isUnique
      ip_DB(i)=iWork(ip_AP_DiagBak-1+i)
      ip_D(i)=iWork(ip_AP_Diag-1+i)
      n1CLinDep(i)=iWork(ip_AP_1CLinDep+2*(i-1))
      n2CFunctions(i)=iWork(ip_AP_2CFunctions+2*(i-1))
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      isUnique(i)=iWork(ip_AP_Unique-1+i).eq.i

      If (.not.LDF_AtomPairInfoIsSet()) Then
         Write(6,'(A)')
     &   'LDF_PrintAtomPairInfo called but info not set....'
         If (.not.LDF_AtomPairInfoIsUnset()) Then
            Write(6,'(A)')
     &      '...but the Unset Flag is not raised !'
            Call WarningMessage(2,
     &           'LDF_PrintAtomPairInfo: Set and Unset Flags mismatch!')
            Call LDF_Quit(1)
         End If
         Return
      End If

      Call Cho_Head('LDF Atom Pair Info','=',80,6)
      n=NumberOfAtompairs
      x=dble(LDF_nAtom())
      x=x*(x+1.0d0)/2.0d0
      R=1.0d2*dble(n)/x
      Write(6,'(/,A,I10,A,F7.2,A)')
     & 'Number of atom pairs.................',n,' (',R,'%)'
      n=LDF_nUniqueAtomPair()
      R=1.0d2*dble(n)/x
      Write(6,'(A,I10,A,F7.2,A)')
     & 'Number of unique atom pairs..........',n,' (',R,'%)'
      If (iPrint.ge.5) Then
         Write(6,'(A,I10,1X,I10)')
     &   'ip_AP_Atoms, l_AP_Atoms..............',ip_AP_Atoms,l_AP_Atoms
         Write(6,'(A,I10,1X,I10)')
     &   'ip_AP_Unique, l_AP_Unique............',
     &   ip_AP_Unique,l_AP_Unique
         Write(6,'(A,I10,1X,I10)')
     &   'ip_AP_Diag,l_AP_Diag.................',ip_AP_Diag,l_AP_Diag
         Write(6,'(A,I10,1X,I10)')
     &   'ip_AP_DiagBak,l_AP_DiagBak...........',
     &    ip_AP_DiagBak,l_AP_DiagBak
         Write(6,'(A,I10,1X,I10)')
     &   'ip_AP_1CLinDep, l_AP_1CLinDep........',
     &   ip_AP_1CLinDep,l_AP_1CLinDep
         Write(6,'(A,I10,1X,I10)')
     &   'ip_AP_2CFunctions, l_AP_2CFunctions..',
     &   ip_AP_2CFunctions,l_AP_2CFunctions
         Write(6,'(A,I10,1X,I10)')
     &   'ip_AP_DiskC, l_AP_DiskC..............',ip_AP_DiskC,l_AP_DiskC
      End If

      nAtomPair=LDF_nAtomPair()
      If (nAtomPair.ne.NumberOfAtomPairs) Then
         Call WarningMessage(2,
     &      'LDF_PrintAtomPairInfo: Inconsistent number of atom pairs!')
         Call LDF_Quit(1)
      End If

      Call Cho_Head('Atom Pairs','-',80,6)
      Write(6,'(/,A,A)')
     & 'Atom Pair   Atom 1   Atom 2        Distance    Max Diagonal ',
     & ' Aux Bas 1CLinDep 2CFunctions DiskAddress DimensionC'
      Write(6,'(112A1)') ('-',i=1,112)
      Rmax_All=-9.9d9
      Dmax_All=-9.9d9
      DBmax_All=-9.9d9
      n1max=-9999999
      n2max=-9999999
      LenTot=0.0d0
      Do iAtomPair=1,nAtomPair
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         R=LDF_AtomicDistance(iAtom,jAtom)
         Rmax_All=max(Rmax_All,R)
         l=LDF_AtomPair_DiagDim(iAtomPair)
         ip=ip_D(iAtomPair)
         Dmax=Work(ip)
         Do iD=1,l-1
            Dmax=max(Dmax,Work(ip+iD))
         End Do
         Dmax_All=max(Dmax_All,Dmax)
         ip=ip_DB(iAtomPair)
         DBmax=Work(ip)
         Do iD=1,l-1
            DBmax=max(DBmax,Work(ip+iD))
         End Do
         DBmax_All=max(DBmax_All,DBmax)
         n1=n1CLinDep(iAtomPair)
         n1max=max(n1max,n1)
         n2=n2CFunctions(iAtomPair)
         n2max=max(n2max,n2)
         M=LDF_nBasAux_Pair(iAtomPair)
         iAddr=LDF_DiskAddressOfC(iAtomPair)
         LenOfC=LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)*M
         Call Cho_Word2Byte(LenOfC,8,Byte,Unt)
         If (isUnique(iAtomPair)) Then
            LenTot=LenTot+dble(LenOfC)
         End If
         Write(6,'(3(1X,I8),2(1X,D15.6),2(1X,I8),4X,I8,I12,F8.3,1X,A)')
     &   iAtomPair,iAtom,jAtom,R,Dmax,M,n1,n2,iAddr,Byte,Unt
      End Do
      Write(6,'(112A1)') ('-',i=1,112)
      Write(6,'(A,D15.6)')
     & 'Max Distance......................',Rmax_All
      Write(6,'(A,D15.6)')
     & 'Max Diagonal......................',Dmax_All
      Write(6,'(A,D15.6)')
     & 'Max Original Diagonal.............',DBmax_All
      Write(6,'(A,I8)')
     & 'Max 1CLinDep......................',n1max
      Write(6,'(A,I8)')
     & 'Max 2CFunctions...................',n2max
      Call Cho_RWord2Byte(LenTot,Byte,Unt)
      Write(6,'(A,F8.3,1X,A)')
     & 'Total Unique Coefficient Storage...',Byte,Unt

      Call Cho_Head('Unique Atom Pairs','-',80,6)
      Write(6,'(/,A,I10)')
     & 'Number of Unique Atom Pairs:',LDF_nUniqueAtomPair()
      Write(6,'(/,A)')
     & 'Atom Pair   Unique'
      Write(6,'(18A1)') ('-',i=1,18)
      Do iAtomPair=1,nAtomPair
         n=LDF_UniqueAtomPair(iAtomPair)
         Write(6,'(1X,I8,1X,I8)') iAtomPair,n
      End Do
      Write(6,'(18A1)') ('-',i=1,18)

      Call LDF_SetA2AP()
      Call LDF_PrintA2AP()
      Call Cho_Head('Interaction Ranges (Bohr)','-',80,6)
      Write(6,'(/,A,A)')
     & '    Atom          x               y               z',
     & '              Range'
      Write(6,'(72A1)') ('-',i=1,72)
      Do iAtom=1,LDF_nAtom()
         ip=LDF_Coord_Atom(iAtom)
         Write(6,'(I8,3(1X,F15.5),1X,1P,D15.5)')
     &   iAtom,(Work(ip+i),i=0,2),LDF_InteractionRange(iAtom)
      End Do
      Write(6,'(72A1)') ('-',i=1,72)
      Call LDF_UnsetA2AP()

      Call xFlush(6)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SGMOP(IMODE,IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,
     &                   COEFF,SGM,PSI)
      IMPLICIT NONE
      REAL*8 COEFF(*),PSI(*),SGM(*)
      REAL*8 CFFPHS,SCALE
      INTEGER IORBTAB(*),NASPRT,NASORB
      INTEGER ISSTAB(*)
      INTEGER IFSBTAB1(*),IFSBTAB2(*)
      INTEGER IFSB1,IBLKPOS1,ISST1,KSTARR1,NSBS1
      INTEGER IFSB2,IBLKPOS2,ISST2,KSTARR2,NSBS2
      INTEGER NSSTP,NHSH2,KHSH2,NFSB1,ISST,NSBS
      INTEGER IPH,NPOP1,IMODE,KSSTOP,KSBSOP
      INTEGER NDI,NDJ,KPOS,ISPART,KSSTTB
      INTEGER I,J,IPOS1,IPOS2,ISUM,LSBSET
      INTEGER ISSTARR(50),NDIARR(50),NDJARR(50),IPHARR(50)
      INTEGER ISBS1,ISBS2,ISORB,KOINFO,KSBSCR,KSBSAN
      INTEGER KSBS1,KSBS2,KSORB,KSSTCR,KSSTAN,MORSBITS
      INTEGER NDETS1,NDETS2,IERR
#include "WrkSpc.fh"

C Purpose: Add to the wave function SGM the result of applying
C an operator to PSI. The operator is a sum of creators (IMODE=1)
C or annihilators (IMODE=-1) multiplied by coefficients. Only the
C sector of SGM described by IFSBTAB1 will be updated.
C The orbital table:
      NASPRT= IORBTAB(9)
      NASORB= IORBTAB(4)
      KOINFO=19
C The substring table:
      MORSBITS=ISSTAB(6)
      NSSTP   =ISSTAB(7)
      KSSTTB=15
      KSSTAN=ISSTAB( 9)
      KSSTCR=ISSTAB(10)
      KSBSAN=ISSTAB(13)
      KSBSCR=ISSTAB(14)
      IF(IMODE.EQ.1) THEN
        KSSTOP=KSSTAN
        KSBSOP=KSBSAN
      ELSE
        KSSTOP=KSSTCR
        KSBSOP=KSBSCR
      END IF
C The FS blocks of the SGM wave function:
      NFSB1=IFSBTAB1(3)
      NDETS1=IFSBTAB1(5)
      KSTARR1=8
C The FS blocks of the PSI wave function:
      NDETS2=IFSBTAB2(5)
      NHSH2=IFSBTAB2(6)
      KHSH2=IFSBTAB2(7)
      KSTARR2=8
C Make an array with nr of earlier substrings for each
C substring type:
      CALL GETMEM('NSBSET','Allo','Inte',LSBSET,NSSTP)
      ISUM=0
      DO ISST=1,NSSTP
        IWORK(LSBSET-1+ISST)=ISUM
        NSBS=ISSTAB(KSSTTB+5*(ISST-1))
        ISUM=ISUM+NSBS
      END DO

C Loop over FS blocks of the SGM wave function
      DO IFSB1=1,NFSB1
        KPOS=KSTARR1+(NASPRT+2)*(IFSB1-1)
        DO ISPART=1,NASPRT
          ISSTARR(ISPART)=IFSBTAB1(KPOS-1+ISPART)
        END DO
        IBLKPOS1 =IFSBTAB1(KPOS+NASPRT+1)
CTEST      write(*,'(1x,a,8I8)')'SGM FSB1,IBLKPOS1=',IBLKPOS1
CTEST      write(*,'(1x,a,8I8)')'SGM FSB1=',(ISSTARR(I),I=1,NASPRT)
C Initial values for lower and higher dimensions.
C Also, extra phase factor due to spin orbitals in higher substrings.
        NDI=1
        DO ISPART=1,NASPRT
          NDIARR(ISPART)=NDI
          ISST1=ISSTARR(ISPART)
          NSBS1=ISSTAB(KSSTTB+5*(ISST1-1))
          NDI=NDI*NSBS1
        END DO
        NDJ=1
        IPH=1
        DO ISPART=NASPRT,1,-1
          NDJARR(ISPART)=NDJ
          IPHARR(ISPART)=IPH
          ISST1=ISSTARR(ISPART)
          NSBS1=ISSTAB(KSSTTB+0+5*(ISST1-1))
          NPOP1=ISSTAB(KSSTTB+1+5*(ISST1-1))
          NDJ=NDJ*NSBS1
          IF(NPOP1.NE.2*(NPOP1/2)) IPH=-IPH
        END DO
C Loop over active orbitals:
        DO ISORB=1,NASORB
          IF(COEFF(ISORB).EQ.0.0D0) GOTO 200
          ISPART=IORBTAB(KOINFO+6+8*(ISORB-1))
          CFFPHS=DBLE(IPHARR(ISPART))*COEFF(ISORB)
          KSORB =IORBTAB(KOINFO+7+8*(ISORB-1))
CTEST      write(*,'(1x,a,8I8)')'ISORB,ISPART,KSORB:',
CTEST     &                      ISORB,ISPART,KSORB
          ISST1=ISSTARR(ISPART)
          NSBS1=ISSTAB(KSSTTB+5*(ISST1-1))

C Modify the bra substring type by annih or creating ISORB
          ISST2=ISSTAB(KSSTOP-1+KSORB+MORSBITS*(ISST1-1))
          IF(ISST2.EQ.0) GOTO 200

CTEST      write(*,'(1x,a,8I8)')'ISST1,ISST2:',ISST1,ISST2
C Determine dimensions for multiple daxpy:
C Dimension for earlier subpartitions is NDI
C Dimension for later   subpartitions is NDJ
C Dimensions for present subpartition are NSBS1,NSBS2
          NDI=NDIARR(ISPART)
          NDJ=NDJARR(ISPART)

          NSBS2=ISSTAB(KSSTTB+5*(ISST2-1))
          ISSTARR(ISPART)=ISST2
C Get the corresponding FS block number
CTEST      write(*,'(1x,a,8I8)')'PSI FSB2=',(ISSTARR(I),I=1,NASPRT)
          CALL HSHGET(ISSTARR,NASPRT,NASPRT+2,IFSBTAB2(KSTARR2),
     &                NHSH2,IFSBTAB2(KHSH2),IFSB2)
CTEST      write(*,'(1x,a,8I8)')'IFSB1,IFSB2:',IFSB1,IFSB2
          ISSTARR(ISPART)=ISST1
          IF(IFSB2.EQ.0) GOTO 200
          KPOS=KSTARR2+(NASPRT+2)*(IFSB2-1)
          IBLKPOS2 =IFSBTAB2(KPOS+NASPRT+1)
C Now loop over ket substrings in this subpartition
          DO KSBS1=1,NSBS1
            ISBS1=KSBS1+IWORK(LSBSET-1+ISST1)
            ISBS2=ISSTAB(KSBSOP-1+KSORB+MORSBITS*(ISBS1-1))
            IF(ISBS2.EQ.0) GOTO 100
            IF(ISBS2.GT.0) THEN
              SCALE= CFFPHS
              ISBS2= ISBS2
            ELSE
              SCALE=-CFFPHS
              ISBS2=-ISBS2
            END IF
            KSBS2=ISBS2-IWORK(LSBSET-1+ISST2)

C CALL some multiple daxpy...
            DO I=0,NDI-1
             DO J=0,NDJ-1
              IPOS1=IBLKPOS1+I+NDI*(KSBS1-1+NSBS1*J)
              IPOS2=IBLKPOS2+I+NDI*(KSBS2-1+NSBS2*J)
              SGM(IPOS1)=SGM(IPOS1)+SCALE*PSI(IPOS2)
              IERR=0
              IF(IPOS1.LT.1 .OR. IPOS1.GT.NDETS1) IERR=1
              IF(IPOS2.LT.1 .OR. IPOS2.GT.NDETS2) IERR=1
              IF(IERR.NE.0) THEN
                WRITE(6,*)' SGMOP addressing error.'
                WRITE(6,'(1x,a,8I8)')' SGM dimension NDETS1=',NDETS1
                WRITE(6,'(1x,a,8I8)')' Position IPOS1=',IPOS1
                WRITE(6,'(1x,a,8I8)')' PSI dimension NDETS2=',NDETS2
                WRITE(6,'(1x,a,8I8)')' Position IPOS2=',IPOS2
                CALL ABEND()
              END IF
C Temporary test print:
CTEST              if(PSI(IPOS2).ne.0.0d0) then
CTEST                WRITE(*,'(1x,f16.8,2i8)')SCALE,IPOS1,IPOS2
CTEST                write(*,'(1x,a,8I8)')'IFSB1,IFSB2:',IFSB1,IFSB2
CTEST                write(*,'(1x,a,8I8)')'IBLKPOS1,NDI,NSBS1:',
CTEST     &                                IBLKPOS1,NDI,NSBS1
CTEST                write(*,'(1x,a,8I8)')'IBLKPOS2,NDI,NSBS2:',
CTEST     &                                IBLKPOS2,NDI,NSBS2
CTEST                write(*,'(1x,a,8I8)')'I,KSBS1,J:',I,KSBS1,J
CTEST                write(*,'(1x,a,8I8)')'I,KSBS2,J:',I,KSBS2,J
CTEST              end if
C End of test prints
             END DO
            END DO

 100        CONTINUE
          END DO

 200      CONTINUE
C End of loop over orbitals
        END DO
C End of loop over FS blocks
      END DO
      CALL GETMEM('NSBSET','Free','Inte',LSBSET,NSSTP)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine setifnss_cvb()

use casvb_global, only: ifnss1, ifnss2, ndetvbs, nel
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iretval1, iretval2, n, nalfa, nbeta

ifnss1(:,:) = 0
ifnss2(:,:) = 0
ndetvbs(:,:) = 0

do n=0,nel
  do nalfa=(n+1)/2,n
    nbeta = n-nalfa
    if (nbeta > nalfa) cycle
    call icomb_cvb(n,nbeta,iretval1)
    call icomb_cvb(n,nbeta-1,iretval2)
    ifnss1(n,nalfa-nbeta) = iretval1-iretval2
    call icomb_cvb(n,nalfa,ifnss2(n,nalfa-nbeta))
    if (nalfa == nbeta) ifnss2(n,nalfa-nbeta) = (ifnss2(n,nalfa-nbeta)+1)/2
    call icomb_cvb(n,nalfa,ndetvbs(n,nalfa))
  end do
end do

return

end subroutine setifnss_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_get_MO(iOK,nDen,nSym,nBas,nIsh,ipCM,ISLT,ISK,ipMSQ)

      Implicit Real*8 (a-h,o-z)
      Integer  iOK, nDen, nSym
      Integer  nBas(nSym), nIsh(nSym), ISLT(nSym), ISK(nSym)
      Integer  ipCM(nDen), ipMSQ(nDen)

#include "WrkSpc.fh"
************************************************************************

      irc=0
      ikc=0

      nBm=nBas(1)
      Do iSym=2,nSym
         nBm=Max(nBm,nBas(iSym))
      End Do
      Call GetMem('Dmat','Allo','Real',ipD,nBm**2)

      iSym=1
      Do while (iSym .le. nSym)

        If (nBas(iSym).gt.0 .and. nIsh(iSym).gt.0) then

C --- Inactive D(a,b) = sum_i C(a,i)*C(b,i)

         iCM = ipCM(1) + ISK(iSym)

         Call DGEMM_('N','T',nBas(iSym),nBas(iSym),nIsh(iSym),
     &                      1.0d0,Work(iCM),nBas(iSym),
     &                            Work(iCM),nBas(iSym),
     &                      0.0d0,Work(ipD),nBas(iSym))

         Ymax=0.0d0
         do ja=1,nBas(iSym)
            jaa=ipD-1+nBas(iSym)*(ja-1)+ja
            Ymax=Max(Ymax,Work(jaa))
         end do
         Thr=1.0d-13*Ymax

         iMSQ = ipMSQ(1) + ISK(iSym)

         CALL CD_InCore(Work(ipD),nBas(iSym),Work(iMSQ),nBas(iSym),
     &                  NumV,Thr,irc)

         If (NumV.ne.nIsh(iSym)) ikc=1

        EndIf

        If (irc.ne.0 .or. ikc.ne.0) iSym=nSym

        iSym=iSym+1

      End Do


      If (nDen.eq.2 .and. irc.eq.0 .and. ikc.eq.0) Then

         nnB = ISLT(nSym) + nBas(nSym)*(nBas(nSym)+1)/2

         Call GetMem('Smat','Allo','Real',ipS,nnB)
         Call GetMem('SXmat','Allo','Real',ipSX,nBm**2)

*        Read overlap integrals (LT-storage) and get Square-storage
         iRc=-1
         iOpt=2
         iComp=1
         iSyLbl=1
*         Label='Mltpl  0'
         Call RdOne(iRc,iOpt,'Mltpl  0',iComp,Work(ipS),iSyLbl)

*        Compute  X_b[a] = C_b U_a   where  U_a = C_a^T S X_a
*        ----------------------------------------------------
         Do i=1,nSym

           If (nBas(i).gt.0 .and. nIsh(i).gt.0) then

              CALL SQUARE(Work(ipS+ISLT(i)),Work(ipD),
     &                    1,NBas(i),NBas(i))

              iCM = ipCM(1) + ISK(i)
              iMSQ = ipMSQ(1) + ISK(i)

              call DGEMM_('N','N',nBas(i),nIsh(i),nBas(i),
     &                     1.0d0,Work(ipD),nBas(i),
     &                           Work(iMSQ),nBas(i),
     &                     0.0d0,Work(ipSX),nBas(i))

              call DGEMM_('T','N',nIsh(i),nIsh(i),nBas(i),
     &                     1.0d0,Work(iCM),nBas(i),
     &                           Work(ipSX),nBas(i),
     &                     0.0d0,Work(ipD),nIsh(i))

c           write(6,*) ' U_a = C_a^T S X_a   for symmetry block: ',i
c           call cho_output(Work(ipD),1,nIsh(i),1,nIsh(i),
c     &                               nIsh(i),nIsh(i),1,6)

              jCM = ipCM(2) + ISK(i)
              jMSQ = ipMSQ(2) + ISK(i)

              call DGEMM_('N','N',nBas(i),nIsh(i),nIsh(i),
     &                     1.0d0,Work(jCM),nBas(i),
     &                           Work(ipD),nIsh(i),
     &                     0.0d0,Work(jMSQ),nBas(i))

           EndIf

         End Do

         Call GetMem('SXmat','Free','Real',ipSX,nBm**2)
         Call GetMem('Smat','Free','Real',ipS,nnB)

      EndIf

      Call GetMem('Dmat','Free','Real',ipD,nBm**2)

      iOK=0
      If (irc.ne.0 .or. ikc.ne.0) iOK=1

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CalcDB(nMult,nGrdPt,natom,nAtQM,IsMM,TTT,DTTT,ExtPot,DB)
! dB = dTTT * V_ext + TTT * dV_ext

use espf_global, only: MxExtPotComp
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nMult, nGrdPt, natom, nAtQM, IsMM(natom)
real(kind=wp), intent(in) :: TTT(nGrdPt,nMult), DTTT(nMult,nGrdPt,3,nAtQM), ExtPot(MxExtPotComp,natom)
real(kind=wp), intent(out) :: DB(nGrdPt,3,nAtQM)
integer(kind=iwp) :: iAt, iMlt, iOrd, iPL, iPnt, iQM, jAt, jPnt, jQM, nOrd
integer(kind=iwp), external :: iPL_espf

iPL = iPL_espf()

if (iPL >= 4) call RecPrt('TTT in calcdb',' ',TTT,nMult,nGrdPt)
nOrd = nMult/nAtQM
do iPnt=1,nGrdPt
  iQM = 0
  do iAt=1,natom
    if (IsMM(iAt) /= 0) cycle
    iQM = iQM+1
    DB(iPnt,:,iQM) = TTT(iPnt,nOrd*(iQM-1)+1)*ExtPot(2:4,iAt)
    if (nOrd == 4) then
      DB(iPnt,1,iQM) = DB(iPnt,1,iQM)+TTT(iPnt,nOrd*(iQM-1)+2)*ExtPot(5,iAt)+ &
                                      TTT(iPnt,nOrd*(iQM-1)+3)*ExtPot(8,iAt)+ &
                                      TTT(iPnt,nOrd*(iQM-1)+4)*ExtPot(9,iAt)
      DB(iPnt,2,iQM) = DB(iPnt,2,iQM)+TTT(iPnt,nOrd*(iQM-1)+2)*ExtPot(8,iAt)+ &
                                      TTT(iPnt,nOrd*(iQM-1)+3)*ExtPot(6,iAt)+ &
                                      TTT(iPnt,nOrd*(iQM-1)+4)*ExtPot(10,iAt)
      DB(iPnt,3,iQM) = DB(iPnt,3,iQM)+TTT(iPnt,nOrd*(iQM-1)+2)*ExtPot(9,iAt)+ &
                                      TTT(iPnt,nOrd*(iQM-1)+3)*ExtPot(10,iAt)+ &
                                      TTT(iPnt,nOrd*(iQM-1)+4)*ExtPot(7,iAt)
    end if
    jQM = 0
    do jAt=1,natom
      if (IsMM(jAt) /= 0) cycle
      jQM = jQM+1
      do iOrd=1,nOrd
        iMlt = nOrd*(jQM-1)+iOrd
        DB(iPnt,:,iQM) = DB(iPnt,:,iQM)+DTTT(iMlt,iPnt,:,iQM)*ExtPot(iOrd,jAt)
      end do
    end do
  end do
end do

! Some printing for debug

if (iPL >= 4) then
  do iQM=1,nAtQM
    write(u6,*) 'dB/dq_i for i = ',iQM
    do jPnt=1,nGrdPt
      write(u6,1234) jPnt,DB(jPnt,:,iQM)
    end do
  end do
end if

return

1234 format(I6,3es13.6)

end subroutine CalcDB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Markus P. Fuelscher                              *
*               1991, Per Ake Malmqvist                                *
************************************************************************
      Subroutine SORT2B(iBin,nInts,iOrd,lSrtA,SrtArr,IOStk,lStk,nStk)
************************************************************************
*                                                                      *
*     Purpose: Store the sorted integrals on disk.                     *
*              Every record that is written contains a header of       *
*              length lTop which containd the number of integrals      *
*              on the record and its ordering number.                  *
*                                                                      *
*     Called from: Sort2                                               *
*                                                                      *
*     Calls to : PkI4,PkR8,DaFile                                      *
*                                                                      *
*     Calling parameters:                                              *
*     iBin   : Slice number                                            *
*     nInts  : no. of 2el integrals in slice                           *
*     iOrd   : ordering number of record                               *
*     SrtArr : Work space to keep the 2el integrals                    *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDef  : definitions of the record structure                    *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*     Srt1    : common block containing information the number of      *
*               bins and partitioning of symmetry blocks               *
*     Srt2    : common block containing information pertinent to       *
*               the bin sorting algorithm                              *
*     Srt3    : dynamic stack to control inout and output of           *
*               integral buffers                                       *
*                                                                      *
*     local data declarations:                                         *
*     PkVal  : I/O buffer contains packed integral values              *
*     IntLen : this buffer contains the length of the integrals        *
*              to be pack into the next buffer                         *
*                                                                      *
**** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****
*
      use srt2
      Implicit Real*8 (A-H,O-Z)
*
#include "TwoDat.fh"
#include "srt0.fh"
#include "srt1.fh"

#include "SysDef.fh"
#include "print.fh"
*
      Dimension PkVal(lStRec)
      Dimension IntLen(4*lStRec)
      Dimension SrtArr(lSrtA)
      Integer IOStk(lStk)
*
*----------------------------------------------------------------------*
*     pick up the print level                                          *
*----------------------------------------------------------------------*
*
#ifdef _DEBUGPRINT_
      iRout = 86
      iPrint = nPrint(iRout)
      If ( iPrint.gt.5 ) then
        Write (6,*) ' >>> Enter SORT2B <<<'
        Write (6,*) ' iBin  ',iBin
        Write (6,*) ' LSrtA ',lSrtA
        Write (6,*) ' nInts ',nInts
      End If
      If ( iPrint.ge.10 ) then
        Call iVcPrt('stack of free records',' ',IOStk,nStk)
      End If
#endif
*
*----------------------------------------------------------------------*
*     Transfer integrals from the sorting area to I/O buffer           *
*----------------------------------------------------------------------*
      nRec(iBin)=0
      kStk=0
      nSaved=0
      iOpt=iDVBin(4,iBin)
      Do while ( nSaved.lt.nInts )
         iStart=nSaved+1
         iEnd=Min(nSaved+4*lStRec,nInts)
         Call R8Len(iOpt,1+iEnd-iStart,SrtArr(iStart),IntLen)
         mxVRec=(lStRec-lTop-1)*RtoB
         nSave=0
         lVRec=0
         Do iSave=1,1+iEnd-iStart
            lVRec=lVRec+IntLen(iSave)
            If ( lVRec.lt.mxVRec ) nSave=iSave
         End Do
         If ( nSave.eq.0 ) then
            iRC=001
            Write(6,*)
            Write(6,'(2X,A,I3.3,A)')
     &      '*** Error in SORT2B ***'
            Write(6,'(2X,A)') 'nSave = 0'
            Write(6,*)
            Call xFlush(6)
            Call Abend()
         End If
         lVRec=0
         Do iSave=1,nSave
            lVRec=lVRec+IntLen(iSave)
         End Do
         If ( lVRec.gt.mxVRec ) then
            iRC=002
            Write(6,*)
            Write(6,'(2X,A,I3.3,A)')
     &      '*** Error in SORT2B ***'
            Write(6,'(2X,A)') 'An inconsistency has been deteced'
            Write(6,'(2X,A)') 'lVRec > mxVRec '
            Write(6,*)
            Call xFlush(6)
            Call Abend()
         End If
*----------------------------------------------------------------------*
*     Pack integrals                                                   *
*----------------------------------------------------------------------*
         Call PKR8(iOpt,nSave,llVRec,SrtArr(iStart),PkVal(lTop+1))
         If ( llVRec.ne.lVRec ) then
            iRC=003
            Write(6,*)
            Write(6,'(2X,A,I3.3,A)')
     &      '*** Error in SORT2B ***'
            Write(6,'(2X,A)') 'An inconsistency has been deteced'
            Write(6,'(2X,A)') 'llVBin # lVRec'
            Write(6,*)
            call xFlush(6)
            Call Abend()
         End If
         iOrd=iOrd+1
         PkVal(1)=0
         PkVal(2)=iOrd
         PkVal(3)=nSave
         PkVal(4)=iOpt
*----------------------------------------------------------------------*
*     Write out the new record                                         *
*----------------------------------------------------------------------*
         If ( kStk.lt.nStk) then
*---------- use an old record, get address from IOStk
            kStk=kStk+1
            iDaTwo=IOStk(kStk)
         Else
            iDaTwo=mDaTwo
            iOptIO=0
            Call dDAFILE(LuTwo,iOptIO,[0.0d0],lStRec,mDaTwo)
         End If
#ifdef _DEBUGPRINT_
         If ( iPrint.ge.10 ) then
           Write (6,*) ' write record: iOrd,iDaTwo ',iOrd,iDaTwo
         End If
#endif
*
*------- Write out the buffer
*
         iOptIO=1
         Call dDAFILE(LuTwo,iOptIO,PkVal,lStRec,iDaTwo)
*
         nRec(iBin)=nRec(iBin)+1
         nSaved=nSaved+nSave
*
      End Do
*----------------------------------------------------------------------*
*     cleanup the stack of Record addresses                            *
*----------------------------------------------------------------------*
      jStk=0
*
*     Do this only if the number of records was reduced
*
      If ( kStk.lt.nStk ) then
*
*        Move unused record addresses to the start of IOStk!
*
         Do iStk=kStk+1,nStk
            jStk=jStk+1
            IOStk(jStk)=IOStk(iStk)
         End Do
      End If
      nStk=jStk
*
*----------------------------------------------------------------------*
*     exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine WfCtl_sp(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,iRHSDisp,iRHSCIDISP)
!***********************************************************************
!                                                                      *
!     called from: MCLR                                                *
!                                                                      *
!***********************************************************************

use ipPage, only: ipclose, ipget, ipin, ipin1, ipnout, ipout, opout, W
use MCLR_Data, only: FIMO, G1m, G2mp, Int2, ipCI, ipDia, LuTemp, MS2P, n1Dens, nConf1, nDens, nDensC, nNA, RMS, SFock, XISPSM
use MCLR_procedures, only: CISigma
use input_mclr, only: Debug, Eps, ERASSCF, Fail, iBreak, iMethod, kPrint, nCSF, nDisp, nIter, PotNuc, rIn_Ene, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, OneHalf
use Definitions, only: wp, iwp, u5, u6

implicit none
integer(kind=iwp), intent(out) :: iKapDisp(nDisp), isigDisp(nDisp), iCIDisp(nDisp), iCIsigDisp(nDisp), iRHSDisp(nDisp), &
                                  iRHSCIDisp(nDisp)
integer(kind=iwp) :: i1, iDis, iDisp, iLen, ipCID, ipCIT, ipS1, ipS2, ipST, Iter, j1, Left, lLine, lPaper, nConf3
real(kind=wp) :: d_0, Delta, Delta0, DeltaC, DeltaK, Ec, rAlpha, rAlphaC, rAlphaK, rBeta, rCHC, rdum(1), Res, ResCI, ResK, rGrad
logical(kind=iwp) :: cnvrgd, lPrint
character(len=8) :: Fmt2
real(kind=wp), allocatable :: Dens(:), dKappa(:), Kappa(:), Pens(:), rmoaa(:), rmoaa2(:), Sc1(:), Sc2(:), Sc3(:), Sc4(:), &
                              Sigma(:), Temp1(:), Temp2(:), Temp4(:)
real(kind=wp), external :: DDot_

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

lPaper = 132
lLine = 120
left = (lPaper-lLine)/2
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'

fail = .false.
idis = 0
lprint = .false.
nconf1 = 0

if (btest(kprint,1)) lprint = .true.
if (iMethod == 2) call InCSFSD(State_Sym,State_sym)

nconf1 = ncsf(State_Sym)
nconf3 = nint(xispsm(State_SYM,1))
call Setup_MCLR(1)

!                            [2]
! Calculate the diagonal of E    and store in core/disc

if (imethod > 0) then
  if (nconf1 > 1) call CIDia_MCLR(State_Sym,rCHC)
  call ipout(ipdia)

  ! Allocate disk/memory space

  ! This areas should be addressed through ipin
  ! ipout will page them out to disk and free the memory area
  ! if page mode is used

  ! opout will release the memory area without update the disk

  ips1 = ipget(nconf3)
  ips2 = ipget(nconf3)
  ipst = ipget(nconf3)
  ipcit = ipget(nconf1)
  ipcid = ipget(nconf1)

else
  call Untested('WfCtl_sp')
  ! These are uninitialized!
  ips1 = -1
  ips2 = -1
  ipst = -1
  ipcid = -1
end if

idisp = 1

! Allocate areas for scratch and state variables

call mma_allocate(Kappa,nDensC,Label='Kappa')
call mma_allocate(SFock,nDens,Label='SFock')
call mma_allocate(dKappa,nDensC,Label='dKappa')
call mma_allocate(Sigma,nDensC,Label='Sigma')
call mma_allocate(Temp1,nDensC,Label='Temp1')
call mma_allocate(Temp2,nDensC,Label='Temp2')
call mma_allocate(Temp4,nDens,Label='Temp4')
call mma_allocate(Sc1,nDens,Label='Sc1')
call mma_allocate(Sc2,nDens,Label='Sc2')
call mma_allocate(Sc3,nDens,Label='Sc3')
call mma_allocate(Sc4,nDensC,Label='Sc4')
Kappa(:) = Zero
dKappa(:) = Zero
Sigma(:) = Zero
if (iMethod == 2) then
  call mma_allocate(Dens,n1Dens,Label='Dens')
  call mma_allocate(Pens,nna**4,Label='Pens')
  call mma_allocate(rmoaa,nna**4,Label='rmoaa')
  call mma_allocate(rmoaa2,nna**4,Label='rmoaa2')
end if

!-----------------------------------------------------------------------
!
! Calculate RHS
!
!-----------------------------------------------------------------------

!call Pre_SP(Pre2,1)
call FockGen_sp(Zero,G1m,G2mp,SFock,Temp4,1)
call ipin(ipST)
W(ipST)%A(1:nconf1) = Zero

if (lprint) write(u6,*) '       Iteration         Delta     Res(kappa) Res(CI)'
iLen = nDensC
iRHSDisp(iDisp) = iDis
call Compress(Temp4,Sigma,1)
Sigma(:) = -sqrt(OneHalf)*dble(ms2p)*Sigma(:)
call UnCompress(Sigma,Temp4,1)
call dDaFile(LuTemp,1,Sigma,iLen,iDis)
if (iMethod == 2) then
  call ipin(ipCIT)
  W(ipCIT)%A(1:nConf1) = Zero
end if
call ipout(ipcit)
call ipin(ipST)
if (iMethod == 2) then
  ilen = nconf1
  iRHSCIDisp(iDisp) = iDis
  call dDaFile(LuTemp,1,W(ipST)%A,iLen,iDis)
end if
W(ipST)%A(1:nConf1) = -W(ipST)%A(1:nConf1)
Sigma(:) = -Sigma(:)

call DMInvKap_sp(Sigma,dKappa)

call ipin(ipCId)
if (nconf1 > 1) then
  call DMinvCI(ipST,W(ipCId)%A,rCHC,1)
else
  call ipin(ipST)
  W(ipCid)%A(1:nConf1) = W(ipST)%A(1:nConf1)
end if

if ((iMethod == 2) .and. (nconf1 /= 0)) then
  call ipin(ipST)
  call ipin(ipCId)
  deltaC = ddot_(nConf1,W(ipST)%A,1,W(ipCId)%A,1)
  call ipout(ipcid)
else
  deltac = Zero
end if
deltaK = ddot_(nDensC,Kappa,1,Sigma,1)
Kappa(:) = Zero
delta = deltac+deltaK
delta0 = delta
iter = 1
!-----------------------------------------------------------------------

!**********************************************************
!          I   T   E   R   A   T   I   O   N   S          *
!**********************************************************

cnvrgd = .true.
do
  !if (delta == Zero) exit
  read(u5,*) i1,j1
  if (i1 > 0) then
    dKappa(:) = Zero
    dKappa(i1) = One
  else
    call ipin(ipCID)
    W(ipCID)%A(1:nConf1) = Zero
    W(ipCID)%A(i1) = One
    call ipout(ipcid)
  end if
  !************************************************************

  call RInt_SP(dKappa,rmoaa,rmoaa2,Temp4,Sc4)

  if ((i1 > 0) .and. (j1 > 0)) write(u6,*) 'Kap_sig',Sc4(j1)
  if (nconf1 > 1) then
    call opout(-1)
    call CISigma(1,State_Sym,state_sym,Temp4,nDens,rmoaa,nna**4,rmoaa2,nna**4,ipCI,ipS1,.true.)
    call opout(-1)
    call ipin(ipCI)
    call ipin(ipS1)
    rGrad = ddot_(nconf1,W(ipCI)%A,1,W(ipS1)%A,1)
    W(ipS1)%A(1:nConf1) = rms*sqrt(OneHalf)*Two*(rgrad*W(ipCI)%A(1:nConf1)-W(ipS1)%A(1:nConf1))

    if ((i1 > 0) .and. (j1 < 0)) write(u6,*) 'CI_sig',W(ipS1)%A(j1)

    call opout(-1)

    call CISigma(0,State_Sym,state_sym,FIMO,size(FIMO),Int2,size(Int2),rdum,1,ipCId,ipS2,.true.)
    call opout(-1)
    EC = rin_ene+potnuc-ERASSCF(1)

    call ipin(ipCId)
    call ipin(ipS2)
    W(ipS2)%A(1:nConf1) = Two*(W(ipS2)%A(1:nConf1)+EC*W(ipCId)%A(1:nConf1))
    if ((i1 < 0) .and. (j1 < 0)) write(u6,*) 'CI_sig',W(ipS2)%A(j1)

    call ipin(ipCI)
    call ipin(ipCid)
    call SpinDens(W(ipCI)%A,W(ipCid)%A,State_Sym,State_sym,Pens,rdum,rdum,rdum,rdum,Dens,rdum,1)

    d_0 = ddot_(nconf1,W(ipCid)%A,1,W(ipci)%A,1)
    call FockGen_sp(d_0,Dens,Pens,Sc3,Sc1,1)
    Sc2(:) = -rms*sqrt(OneHalf)*Sc1(:)

    call Compress(Sc1,Sc4,1)
    if ((i1 < 0) .and. (j1 > 0)) write(u6,*) 'CI_sig',Sc4(j1)
    cycle

  end if

  !*********************************************************************
  !
  ! Sc1  kappa-> kappa
  ! Sc3  CI -> kappa
  ! S1   kappa -> CI
  ! S2   CI -> CI
  ! dKap present step
  ! Kap  kappaX
  ! CIT  CIX
  ! CId  present step
  !
  ! Add together
  !
  !*********************************************************************

  call Untested('WfCtl_sp')
  ! IFG: Given the sizes assumed later, I think this assignment is wrong
  !      and it should use the Compress call instead
  !Temp4(:) = Sc2(:)
  call Compress(Sc2,Temp1,1)
  Temp2(:) = dKappa(:)
  if (nconf1 > 1) then
    call ipin1(ipS1,nconf1)
    call ipin1(ipS2,nconf1)
    W(ipS1)%A(1:nConf1) = W(ipS1)%A(1:nConf1)+W(ipS2)%A(1:nConf1)
  else
    call ipin1(ipS1,nconf1)
    W(ipS1)%A(1:nconf1) = Zero
  end if

  !---------------------------------------------------------------------
  !
  !                ######   #####   #####
  !                #     # #     # #     #
  !                #     # #       #
  !                ######  #       #  ####
  !                #       #       #     #
  !                #       #     # #     #
  !                #        #####   #####
  !
  !---------------------------------------------------------------------
  !*********************************************************************
  !
  !
  !            delta
  ! rAlpha=------------
  !        dKappa:dSigma
  !
  !---------------------------------------------------------------------
  rAlphaC = Zero
  rAlphaK = ddot_(nDensC,Temp1,1,Temp2,1)
  if (nconf1 /= 0) then
    call ipin(ipS1)
    call ipin(ipCId)
    rAlphaC = ddot_(nConf1,W(ipS1)%A,1,W(ipCId)%A,1)
  end if
  rAlpha = delta/(rAlphaK+ralphaC)

  !--------------------------------------------------------------------*

  ! Kappa=Kappa+rAlpha*dKappa
  ! Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa

  Kappa(:) = Kappa(:)+ralpha*Temp2(:)
  Sigma(:) = Sigma(:)-ralpha*Temp1(:)
  resk = sqrt(ddot_(nDensC,Temp1,1,Temp1,1))
  resci = Zero
  if (nconf1 /= 0) then
    call ipin(ipCId)
    call ipin(ipCIT)
    W(ipCIT)%A(1:nConf1) = W(ipCIT)%A(1:nConf1)+ralpha*W(ipCId)%A(1:nConf1)
    call ipout(ipcit)
    call ipin1(ipST,nconf1)
    call ipin(ipS1)
    W(ipST)%A(1:nConf1) = W(ipST)%A(1:nConf1)-ralpha*W(ipS1)%A(1:nConf1)
    call opout(ipS1)
    call ipin(ipST)
    resci = sqrt(ddot_(nconf1,W(ipST)%A,1,W(ipST)%A,1))
  end if

  ! Precondition......
  !    -1
  ! S=M  Sigma

  call opout(ipcid)
  call ipin(ipS2)
  if (nconf1 > 1) then
    call DMinvCI(ipST,W(ipS2)%A,rCHC,1)
  else
    call ipin(ipST)
    W(ipS2)%A(1:nconf1) = W(ipST)%A(1:nconf1)
  end if

  call opout(ipci)
  call opout(ipdia)

  call DMInvKap_sp(Sigma,Sc4)

  !--------------------------------------------------------------------*
  !      s:Sigma
  ! Beta=-------
  !       delta
  !
  ! delta=s:sigma
  !
  ! dKappa=s+Beta*dKappa

  if ((iMethod == 2) .and. (nconf1 /= 0)) then
    call ipin(ipST)
    call ipin(ipS2)
    deltaC = ddot_(nConf1,W(ipST)%A,1,W(ipS2)%A,1)
    call ipout(ipST)
  else
    deltaC = Zero
  end if

  deltaK = ddot_(nDensC,Sigma,1,Sc4,1)
  if (imethod /= 2) then
    rBeta = deltaK/delta
    delta = deltaK
    Temp2(:) = rBeta*Temp2(:)+Sc4(:)
  else
    rbeta = (deltac+deltaK)/delta
    delta = deltac+deltaK
    call ipin(ipCID)
    call ipin(ipS2)
    W(ipCID)%A(1:nConf1) = rBeta*W(ipCID)%A(1:nConf1)+W(ipS2)%A(1:nConf1)
    Temp2(:) = rBeta*Temp2(:)+Sc4(:)
    call opout(ipS2)
    call ipout(ipCID)
  end if

  !    ######  #    #  #####        #####    ####    ####
  !    #       ##   #  #    #       #    #  #    #  #    #
  !    #####   # #  #  #    #       #    #  #       #
  !    #       #  # #  #    #       #####   #       #  ###
  !    #       #   ##  #    #       #       #    #  #    #
  !    ######  #    #  #####        #        ####    ####
  !
  !--------------------------------------------------------------------*

  dKappa(:) = Temp2(:)

  res = Zero ! dummy initialize
  if (iBreak == 1) then
    if (abs(delta) < abs(Eps**2*delta0)) exit
  else if (ibreak == 2) then
    res = sqrt(resk**2+resci**2)
    if (res < abs(Eps)) exit
  else
    if ((abs(delta) < abs(Eps**2*delta0)) .and. (res < abs(Eps))) exit
  end if
  if (iter >= niter) then
    cnvrgd = .false.
    exit
  end if
  if (lprint) write(u6,Fmt2//'A,i2,A,F12.7,F12.7,F12.7,F12.7,F12.7)') '     ',iter,'       ',delta/delta0,resk,resci,deltac,deltak

  iter = iter+1

end do

!***********************************************************************

if (.not. cnvrgd) then
  write(u6,Fmt2//'A,I4,A)') 'No convergence for perturbation no: ',idisp,'. Increase Iter.'
  fail = .true.
else
  write(u6,Fmt2//'A,I4,A,I4,A)') 'Perturbation no: ',idisp,' converged in ',iter-1,' steps.'
  call ipnout(-1)
end if
write(u6,*)
iLen = nDensC
iKapDisp(iDisp) = iDis
call dDaFile(LuTemp,1,Kappa,iLen,iDis)
iSigDisp(iDisp) = iDis
call dDaFile(LuTemp,1,Sigma,iLen,iDis)
if (iMethod == 2) then
  ilen = nconf1
  iCIDisp(iDisp) = iDis
  call ipin(ipCIT)
  call dDaFile(LuTemp,1,W(ipCIT)%A,iLen,iDis)
  iCISigDisp(iDisp) = iDis
  call ipin(ipST)
  call dDaFile(LuTemp,1,W(ipST)%A,iLen,iDis)
end if

call mma_deallocate(Temp4)
call mma_deallocate(Temp2)
call mma_deallocate(Temp1)
call mma_deallocate(dKappa)
call mma_deallocate(Sigma)
call mma_deallocate(Kappa)
call mma_deallocate(Sc4)
call mma_deallocate(Sc3)
call mma_deallocate(Sc2)
call mma_deallocate(Sc1)
if (iMethod == 2) then
  call mma_deallocate(rmoaa2)
  call mma_deallocate(rmoaa)
  call mma_deallocate(Pens)
  call mma_deallocate(Dens)
end if

! Free all memory and remove from disk all data
! related to this symmetry

if (imethod == 2) call ipclose(ipci)

call Exp_Close()

if (debug) then
  write(u6,*) '********************************************************************************'
  write(u6,*)
end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine WfCtl_sp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Roland Lindh                                     *
!***********************************************************************

subroutine PXInt( &
#                define _CALLING_
#                include "int_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of  pX integrals          *
!                                                                      *
! Called from: OneEl                                                   *
!                                                                      *
! Author: Roland Lindh, Dept. Chem. Phys., Lund University,            *
!         June 2006                                                    *
!***********************************************************************

use Symmetry_Info, only: nIrrep, iChBas
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "property_label.fh"
integer(kind=iwp), parameter :: mComp = 200
integer(kind=iwp) :: iComp, ipar_p1, ipar_p2, ipar_p3, iSym_p1, iSym_p2, iSym_p3, iSym_px, iSym_X, jComp1, jComp2, jComp3, &
                     jpar_p1, jpar_p2, jpar_p3, jTemp1, jTemp2, jTemp3, kComp, kIC, kOrdOp, nRys
integer(kind=iwp), allocatable :: kChO(:), kOper(:)
integer(kind=iwp), external :: IrrFnc
external :: CntInt, EFInt, MltInt, NAInt

!                                                                      *
!***********************************************************************
!                                                                      *
! nIC: number of symmetry adapted blocks in total for the nComp
!      elements of the compund operator, pX.
! nComp: is the number of elements of the compund operator
!
! kIC: number of symmetry adapted blocks in total for the kComp
!      elements of the operator X
! kComp: is the number of elements of the operator X.
!                                                                      *
!***********************************************************************
!                                                                      *
! Note that the p operator's each element is only a basis function
! of a single irreducible representation. Hence, 3*kIC=nIC.
!
! In addition if the operator X has kComp elements pX has 3*kComp
! elements.
!                                                                      *
!***********************************************************************
!                                                                      *
nRys = nHer
kIC = nIC/3
kComp = nComp/3
kOrdOp = nOrdOp-1
!                                                                      *
!***********************************************************************
!                                                                      *
! Now produce the kOper array with kComp elements from the lOper
! array. Ditto kChO/iChO.
!
! lOper is an integer which bit pattern indicate to which irreps
! the component of the operator is a basis function. Note that the
! operator is not symmetry adapted, i.e. it can be a basis function
! in more than one irrep.
!
! iChO is an integer which describe the parity character of the
! operator with respect to X, Y, and Z coordinates. For example,
! if the first bit is set this means that the operator change sign
! under a reflection  in the yz-plane, etc.

call mma_allocate(kChO,kComp,label='kChO')
call mma_allocate(kOper,kComp,label='kOper')

! As we remove the p operator (three of them) X should be the same
! regardless of if we remove d/dx, d/dy, or d/dz.

iSym_p1 = IrrFnc(1)   ! d/dx
iSym_p2 = IrrFnc(2)   ! d/dy
iSym_p3 = IrrFnc(4)   ! d/dz
!write(u6,*)
!write(u6,*) 'pXInt******'
!write(u6,*) 'iSym_p=',iSym_p1,iSym_p2,iSym_p3
ipar_p1 = iChBas(2)
ipar_p2 = iChBas(3)
ipar_p3 = iChBas(4)
!write(u6,*) 'ipar_p=',ipar_p1,ipar_p2,ipar_p3
do iComp=1,kComp
  jComp1 = (iComp-1)*3+1
  jComp2 = (iComp-1)*3+2
  jComp3 = (iComp-1)*3+3
  jpar_p1 = iChO(jComp1)
  jpar_p2 = iChO(jComp2)
  jpar_p3 = iChO(jComp3)

  ! Look thru all irreps and check if pX is a basis function in
  ! irrep iSym_pX. If so find the symmetry to which X is a basis function

  jTemp1 = 0
  jTemp2 = 0
  jTemp3 = 0
  !write(u6,*) 'lOper=',lOper(jComp1),lOper(jComp2),lOper(jComp3)
  do iSym_pX=0,nIrrep-1
    if (btest(lOper(jComp1),iSym_pX)) then
      iSym_X = ieor(iSym_pX,iSym_p1)
      !write(u6,*) 'iSym_pX,iSym_X=',iSym_pX,iSym_X
      jTemp1 = ibset(jTemp1,iSym_X)
      !write(u6,*) 'jTemp1=',jTemp1
    end if
    if (btest(lOper(jComp2),iSym_pX)) then
      iSym_X = ieor(iSym_pX,iSym_p2)
      !write(u6,*) 'iSym_pX,iSym_X=',iSym_pX,iSym_X
      jTemp2 = ibset(jTemp2,iSym_X)
      !write(u6,*) 'jTemp2=',jTemp2
    end if
    if (btest(lOper(jComp3),iSym_pX)) then
      iSym_X = ieor(iSym_pX,iSym_p3)
      !write(u6,*) 'iSym_pX,iSym_X=',iSym_pX,iSym_X
      jTemp3 = ibset(jTemp3,iSym_X)
      !write(u6,*) 'jTemp3=',jTemp3
    end if
  end do

  ! Check for consistency!

  if ((jTemp1 /= jTemp2) .or. (jTemp1 /= jTemp3)) then
    call WarningMessage(2,'PXInt: corrupted jTemps!')
    write(u6,*) 'jTemp1,jTemp2,jTemp3=',jTemp1,jTemp2,jTemp3
    call Abend()
  end if

  ! Compute the parity of X

  jpar_p1 = ieor(jpar_p1,ipar_p1)
  jpar_p2 = ieor(jpar_p2,ipar_p2)
  jpar_p3 = ieor(jpar_p3,ipar_p3)

  if ((jpar_p1 /= jpar_p2) .or. (jpar_p1 /= jpar_p3)) then
    call WarningMessage(2,'PXInt: corrupted jpars!')
    call Abend()
  end if

  ! Store the data

  kOper(iComp) = jTemp1
  kChO(iComp) = jpar_p1
end do

!write(u6,*) 'pXpInt'
!do iComp=1,nComp
!  write(u6,*) lOper(iComp),iChO(iComp)
!end do
!write(u6,*)
!do iComp=1,kComp
!  write(u6,*) kOper(iComp),kChO(iComp)
!end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute now the integrals

if (PLabel == 'NAInt ') then
  call PVInt(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,rFinal,nZeta,kIC,kComp,la,lb,A,RB,nRys,Array,nArr,CCoor,kOrdOp,kOper,kChO, &
             iStabM,nStabM,PtChrg,nGrid,iAddPot,NAInt)
else if (PLabel == 'MltInt') then
  call PVInt(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,rFinal,nZeta,kIC,kComp,la,lb,A,RB,nRys,Array,nArr,CCoor,kOrdOp,kOper,kChO, &
             iStabM,nStabM,PtChrg,nGrid,iAddPot,MltInt)
else if (PLabel == 'EFInt ') then
  call PVInt(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,rFinal,nZeta,kIC,kComp,la,lb,A,RB,nRys,Array,nArr,CCoor,kOrdOp,kOper,kChO, &
             iStabM,nStabM,PtChrg,nGrid,iAddPot,EFInt)
else if (PLabel == 'CntInt') then
  call PVInt(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,rFinal,nZeta,kIC,kComp,la,lb,A,RB,nRys,Array,nArr,CCoor,kOrdOp,kOper,kChO, &
             iStabM,nStabM,PtChrg,nGrid,iAddPot,CntInt)
else
  call WarningMessage(2,'PXInt: Illegal type!')
  write(u6,*) '       PLabel=',PLabel
  call Abend()
end if

call mma_deallocate(kChO)
call mma_deallocate(kOper)

return

end subroutine PXInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DecideOn1CCD(Do1CCD)

      Implicit Real*8 (a-h,o-z)
      Logical Do1CCD


      Call Get_iScalar('System BitSwitch',iOption)
*
*     This is a logical variable (logical function)
      Do1CCD=iAnd(iOption,2**12).Eq.2**12
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine ABXpY(Array1,Array2,idsym)
      Implicit Real*8 (a-h,o-z)
      Real*8 Array1(*),Array2(*)
#include "Pointers.fh"

#include "Input.fh"
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      Do iS=1,nSym
       Do iA=1,Nash(is)
        iAsh=nA(is)+iA
        iiA=nIsh(is)+iA
        Do jS=1,nSym
         ijs=iEOR(is-1,js-1)+1
         Do jA=1,Nash(js)
          jAsh=nA(js)+jA
          ij=itri(iash,jash)
          If (iAsh.ge.jash) Then
          Do kS=1,nSym
           Do kA=1,Nash(ks)
            kAsh=nA(ks)+kA
             ls=ieor(iEOR(kS-1,ijs-1),idsym-1)+1
             Do lA=1,Nash(ls)
              lAsh=nA(ls)+lA
              If (kAsh.ge.lash) Then
              kl=itri(kAsh,lash)
              If (ij.ge.kl) Then
              ijkl=itri(ij,kl)
              ip1=ipMO(js,ks,ls)+
     &             nOrb(is)*nAsh(js)*((lA-1)*nAsh(kS)+kA-1)+
     &             nOrb(is)*(ja-1)+iia-1
              Array2(ijkl)=array1(ip1)+array2(ijkl)
*             Array2(ijkl)=array1(ip1)
              End If
              End If
            End Do
           End Do
          End Do
          End If
         End Do
        End Do
       End Do
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRPAD3(MAT,FACTOR,NDIM)
*
*  MAT(I,J) = MAT(I,J) + FACTOR*MAT(J,I)
*
*. With some considerations of effective cache use for large
*  matrices
*
      IMPLICIT REAL*8           (A-H,O-Z)
      REAL*8            MAT(NDIM,NDIM)
              FAC2 = 1.0D0 - FACTOR**2
*
C     IWAY = 1
      IWAY = 2
      IF(IWAY.EQ.1) THEN
*
*. No blocking
*
*. Lower half
        DO  J = 1, NDIM
          DO  I = J, NDIM
            MAT(I,J) =MAT(I,J) + FACTOR * MAT(J,I)
          END DO
        END DO
*. Upper half
        IF( ABS(FACTOR) .NE. 1.0D0 ) THEN
          FAC2 = 1.0D0 - FACTOR**2
          DO I = 1, NDIM
            DO J = 1, I - 1
              MAT(J,I) = FACTOR*MAT(I,J ) + FAC2 * MAT(J,I)
            END DO
          END DO
        ELSE IF(FACTOR .EQ. 1.0D0) THEN
          DO I = 1, NDIM
            DO J = 1, I - 1
              MAT(J,I) = MAT(I,J )
            END DO
          END DO
        ELSE IF(FACTOR .EQ. -1.0D0) THEN
          DO I = 1, NDIM
            DO J = 1, I - 1
              MAT(J,I) =-MAT(I,J )
            END DO
          END DO
        END IF
      ELSE IF(IWAY .EQ. 2 ) THEN
*. Simple blocking of matrix
        LBLK = 40
        NBLK = NDIM/LBLK
        IF(NBLK*LBLK.LT.NDIM) NBLK = NBLK + 1
        IOFF = 1-LBLK
C?      write(6,*) 'NBLK ',nblk
        DO IBLK = 1, NBLK
          IF(IBLK.EQ.-1) write(6,*) 'IBLK = ',IBLK
          IOFF = IOFF + LBLK
          IEND = MIN(IOFF+LBLK-1,NDIM)
          JOFF = 1 - LBLK
          DO JBLK = 1, IBLK
            JOFF = JOFF + LBLK
            JEND = MIN(JOFF+LBLK-1,NDIM)
*. Lower half
            DO  I = IOFF,IEND
              IF(IBLK.EQ.JBLK) JEND = I
              DO J = JOFF,JEND
                MAT(I,J) = MAT(I,J) + FACTOR*MAT(J,I)
              END DO
            END DO
*. Upper half
            IF( ABS(FACTOR) .NE. 1.0D0 ) THEN
              FAC2 = 1.0D0 - FACTOR**2
              DO I = IOFF, IEND
                IF(IBLK.EQ.JBLK) JEND = I
                DO J = JOFF, JEND
                  MAT(J,I) = FACTOR*MAT(I,J ) + FAC2 * MAT(J,I)
                 END DO
               END DO
            ELSE IF(FACTOR .EQ. 1.0D0) THEN
              DO I = IOFF, IEND
                IF(IBLK.EQ.JBLK) JEND = I -1
                DO J = JOFF, JEND
                  MAT(J,I) = MAT(I,J )
                END DO
              END DO
            ELSE IF(FACTOR .EQ. -1.0D0) THEN
              DO I = IOFF, IEND
                IF(IBLK.EQ.JBLK) JEND = I
                DO J = JOFF, JEND
                  MAT(J,I) = - MAT(I,J )
                END DO
              END DO
            END IF
*. ENd of loop over blocks
          END DO
        END DO
*. End of IWAY branching
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013,2014, Ignacio Fdez. Galvan                        *
!***********************************************************************
!> @file
!> @brief
!>   Subroutines for superposition of molecules.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Subroutines for superposition of molecules.
!> \cite The2005-ACSA-61-478
!> \cite Liu2010-JCC-31-1561
!***********************************************************************

!***********************************************************************
!  Get_RMSD_w
!
!> @brief
!>   Compute the optimal weighted RMSD between two structures.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Compute the optimal RMSD between two structures, with weights.
!> Coordinates are not changed, but the RMSD corresponds to the aligned structures.
!>
!> @param[in,out] x    Cartesian coordinates of the first structure
!> @param[in]     y    Cartesian coordinates of the second structure
!> @param[in]     w    Weights for each atom
!> @param[in]     nAt  Number of atoms in the structures
!> @param[out]    RMSD Minimum weighted RMSD between the two structures
!>
!> @see ::Get_RMSD
!***********************************************************************
subroutine Get_RMSD_w(x,y,w,nAt,RMSD)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(inout) :: x(3,nAt)
real(kind=wp), intent(in) :: y(3,nAt), w(nAt)
real(kind=wp), intent(out) :: RMSD

call get_rotation(x,y,w,nAt,RMSD,.false.)

end subroutine Get_RMSD_w

!***********************************************************************
!  Get_RMSD
!
!> @brief
!>   Compute the optimal RMSD between two structures.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Compute the optimal RMSD between two structures, with equal weights.
!> Coordinates are not changed, but the RMSD corresponds to the aligned structures.
!>
!> @param[in,out] x    Cartesian coordinates of the first structure
!> @param[in]     y    Cartesian coordinates of the second structure
!> @param[in]     nAt  Number of atoms in the structures
!> @param[out]    RMSD Minimum RMSD between the two structures
!>
!> @see ::Get_RMSD_w
!***********************************************************************
subroutine Get_RMSD(x,y,nAt,RMSD)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(inout) :: x(3,nAt)
real(kind=wp), intent(in) :: y(3,nAt)
real(kind=wp), intent(out) :: RMSD
real(kind=wp), allocatable :: w(:)

call mma_allocate(w,nAt)
w(:) = One
call Get_RMSD_w(x,y,w,nAt,RMSD)
call mma_deallocate(w)

end subroutine Get_RMSD

!***********************************************************************
!  Superpose_w
!
!> @brief
!>   Superpose two structures.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Superpose two structures, with weights.
!> The coordinates of the first structure are modified.
!>
!> @param[in,out]  x    Cartesian coordinates of the first structure
!> @param[in]      y    Cartesian coordinates of the second structure
!> @param[in]      w    Weights for each atom
!> @param[in]      nAt  Number of atoms in the structures
!> @param[out]     RMSD Weighted RMSD between the two final structures
!> @param[out]     RMax Maximum atom-wise (weighted) distance between the two structures
!>
!> @see ::Superpose
!***********************************************************************
subroutine Superpose_w(x,y,w,nAt,RMSD,RMax)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(inout) :: x(3,nAt)
real(kind=wp), intent(in) :: y(3,nAt), w(nAt)
real(kind=wp), intent(out) :: RMSD, RMax
integer(kind=iwp) :: iAt
real(kind=wp) :: r2

call get_rotation(x,y,w,nAt,RMSD,.true.)
! Calculate the maximum weighted distance between atoms
! (not sure what meaning it has with w!=1)
RMax = Zero
do iAt=1,nAt
  r2 = (x(1,iAt)-y(1,iAt))**2+(x(2,iAt)-y(2,iAt))**2+(x(3,iAt)-y(3,iAt))**2
  RMax = max(RMax,w(iAt)*r2)
end do
RMax = sqrt(RMax)

end subroutine Superpose_w

!***********************************************************************
!  Superpose_w
!
!> @brief
!>   Superpose two structures.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Superpose two structures, with equal weights.
!> The coordinates of the first structure are modified.
!>
!> @param[in,out]  x    Cartesian coordinates of the first structure
!> @param[in]      y    Cartesian coordinates of the second structure
!> @param[in]      nAt  Number of atoms in the structures
!> @param[out]     RMSD RMSD between the two final structures
!> @param[out]     RMax Maximum atom-wise distance between the two structures
!>
!> @see ::Superpose_w
!***********************************************************************
subroutine Superpose(x,y,nAt,RMSD,RMax)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(inout) :: x(3,nAt)
real(kind=wp), intent(in) :: y(3,nAt)
real(kind=wp), intent(out) :: RMSD, RMax
real(kind=wp), allocatable :: w(:)

call mma_allocate(w,nAt)
w(:) = One
call Superpose_w(x,y,w,nAt,RMSD,RMax)
call mma_deallocate(w)

end subroutine Superpose

!***********************************************************************
!> @name Internal
!>
!> These procedures are probably not very useful outside the file.
!> @{
!***********************************************************************
!  get_rotation
!
!> @brief
!>   Compute the RMSD and superpose two structures.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Calculate the minimum weighted RMSD between two structures and, optionally,
!> rotate and translate the first one to be superposed onto the other.
!>
!> @param[in,out] x      Cartesian coordinates of the first structure
!> @param[in]     y      Cartesian coordinates of the second structure
!> @param[in]     w      Weights for each atom
!> @param[in]     nAt    Number of atoms in the structures
!> @param[out]    RMSD   Minimum weighted RMSD between the two final structures
!> @param[in]     rotate Flag for changing the coordinates or not
!***********************************************************************
subroutine get_rotation(x,y,w,nAt,RMSD,rotate)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two
! if USE_QCD is defined, use the real QCD method, otherwise use conventional
! method to locate the largest eigenvalue (may be more robust in some cases)
!#define USE_QCD
#ifdef USE_QCD
use Constants, only: Half
#endif
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(inout) :: x(3,nAt)
real(kind=wp), intent(in) :: y(3,nAt), w(nAt)
real(kind=wp), intent(out) :: RMSD
logical(kind=iwp), intent(in) :: rotate
integer(kind=iwp) :: i, iAt
real(kind=wp) :: c_x(3), c_y(3), Gx, Gy, Kxy(4,4), lambda, Mxy(3,3), q(4), wTot
#ifdef USE_QCD
real(kind=wp) :: Poly(5)
#else
real(kind=wp) :: wTmp(100)
#endif
real(kind=wp), allocatable :: xCen(:,:), yCen(:,:)
real(kind=wp), external :: DDot_, inner_prod

call mma_allocate(xCen,3,nAt)
call mma_allocate(yCen,3,nAt)
! Center the two structures and calculate their inner products
call center_mol(x,w,nAt,c_x,xCen)
call center_mol(y,w,nAt,c_y,yCen)
Gx = inner_prod(xCen,w,nAt)
Gy = inner_prod(yCen,w,nAt)
call inner_mat(xCen,yCen,w,nAt,Mxy)
! Find the largest eigenvalue (always lower or equal to (Gx+Gy)/2)
#ifdef USE_QCD
call build_polynomial(Mxy,Poly)
lambda = Half*(Gx+Gy)
call find_lambda(Poly,lambda)
#else
call build_K_matrix(Mxy,Kxy)
i = 0
call dsyev_('N','U',4,Kxy,4,q,wTmp,100,i)
lambda = q(4)
#endif
! Calculate the optimized RMSD value
wTot = sum(w)
RMSD = sqrt(abs(Gx+Gy-Two*lambda)/wTot)
! The rotation is only performed if an actual superposition is requested
if (rotate) then
  ! The rotation quaternion is obtained as the eigenvector of K corresponding
  ! to the eigenvalue lambda.
  call build_K_matrix(Mxy,Kxy)
  call get_eigenvector(Kxy,lambda,q)
  ! Apply the rotation to the first structure. Before rotation, the quaternion
  ! must be normalized and the rotation inverted (change of sign in the 1st component)
  q(:) = q/sqrt(DDot_(4,q,1,q,1))
  q(1) = -q(1)
  call apply_rotation(xCen,nAt,q)
  ! Translate the structure to match the second (reference) one
  do iAt=1,nAt
    xCen(:,iAt) = xCen(:,iAt)+c_y
  end do
  ! Copy the aligned structures back in the original matrices
  x(:,:) = xCen
end if
call mma_deallocate(xCen)
call mma_deallocate(yCen)

end subroutine get_rotation

!***********************************************************************
!  center_mol
!
!> @brief
!>   Center a structure on its weighted geometric center.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Center a structure on its weighted geometric center.
!>
!> @param[in]  x    Cartesian coordinates of the structure
!> @param[in]  w    Weights for each atom
!> @param[in]  nAt  Number of atoms in the structures
!> @param[out] c    Weighted center
!> @param[out] xCen Centered Cartesian coordinates
!***********************************************************************
subroutine center_mol(x,w,nAt,c,xCen)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(in) :: x(3,nAt), w(nAt)
real(kind=wp), intent(out) :: c(3), xCen(3,nAt)
integer(kind=iwp) :: i, iAt
real(kind=wp) :: wTot

! Compute the total weight
wTot = sum(w)
do i=1,3
  ! Calculate the center in each dimension (x, y, z)
  c(i) = Zero
  do iAt=1,nAt
    c(i) = c(i)+w(iAt)*x(i,iAt)
  end do
  c(i) = c(i)/wTot
  ! Center the structure in each dimension
  xCen(i,:) = x(i,:)-c(i)
end do

end subroutine center_mol

!***********************************************************************
!  inner_prod
!
!> @brief
!>   Calculate the inner product of a single structure.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Returns the inner product of the weighted coordinates of a single structure:
!>  \f[P = \sum_{i=1,N} w_i ( x_i^2 + y_i^2 + z_i^2 ) \f]
!>
!> @param[in] x   Cartesian coordinates of the structure
!> @param[in] w   Weights for each atom
!> @param[in] nAt Number of atoms in the structures
!>
!> @return The inner product \f$ P \f$
!***********************************************************************
function inner_prod(x,w,nAt)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: inner_prod
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(in) :: x(3,nAt), w(nAt)
integer(kind=iwp) :: iAt
real(kind=wp) :: r

r = Zero
do iAt=1,nAt
  r = r+w(iAt)*(x(1,iAt)**2+x(2,iAt)**2+x(3,iAt)**2)
end do
inner_prod = r

end function inner_prod

!***********************************************************************
!  inner_mat
!
!> @brief
!>   Calculate the inner product matrix of two structures.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Calculate the inner product matrix of the weighted coordinates of two structures,
!> \f$ A, B \f$:
!>   \f[ M_{ij} = \sum_{k=1,N} w_i (A_i)_k (B_j)_k \quad i,j \in \{x, y, z\} \f]
!>
!> @param[in]  x   Cartesian coordinates of the first structure
!> @param[in]  y   Cartesian coordinates of the second structure
!> @param[in]  w   Weights for each atom
!> @param[in]  nAt Number of atoms in the structures
!> @param[out] M   Inner product matrix
!***********************************************************************
subroutine inner_mat(x,y,w,nAt,M)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(in) :: x(3,nAt), y(3,nAt), w(nAt)
real(kind=wp), intent(out) :: M(3,3)
integer(kind=iwp) :: i, iAt

M(:,:) = Zero
do iAt=1,nAt
  do i=1,3
    M(:,i) = M(:,i)+w(iAt)*x(:,iAt)*y(i,iAt)
  end do
end do

end subroutine inner_mat

!***********************************************************************
!  build_K_matrix
!
!> @brief
!>   Build the key matrix \f$ K \f$ from the \f$ M \f$ matrix.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Build the key matrix \f$ K \f$ from the inner product matrix \f$ M \f$ matrix.
!>
!> @param[in]  M Inner product matrix
!> @param[out] K Key matrix \f$ K \f$
!***********************************************************************
subroutine build_K_matrix(M,K)

use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: M(3,3)
real(kind=wp), intent(out) :: K(4,4)
integer(kind=iwp) :: i, j

! Compute the unique elements
K(1,1) = M(1,1)+M(2,2)+M(3,3)
K(1,2) = M(2,3)-M(3,2)
K(1,3) = M(3,1)-M(1,3)
K(1,4) = M(1,2)-M(2,1)
K(2,2) = M(1,1)-M(2,2)-M(3,3)
K(2,3) = M(1,2)+M(2,1)
K(2,4) = M(1,3)+M(3,1)
K(3,3) = M(2,2)-M(1,1)-M(3,3)
K(3,4) = M(2,3)+M(3,2)
K(4,4) = M(3,3)-M(1,1)-M(2,2)
! Make the matrix symmetric
do i=2,4
  do j=1,i-1
    K(i,j) = K(j,i)
  end do
end do

end subroutine build_K_matrix

!***********************************************************************
! build_polynomial
!
!> @brief
!>   Calculate the coefficients for the characteristic polynomial.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Calculate the coefficients for the characteristic polynomial of the \f$ K \f$
!> matrix directly from the elements of the \f$ M \f$ matrix.
!>
!> @param[in]  M Inner product matrix
!> @param[out] P The polynomial coefficients
!***********************************************************************
subroutine build_polynomial(M,P)

use Constants, only: Zero, One, Two, Eight
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: M(3,3)
real(kind=wp), intent(out) :: P(5)
real(kind=wp) :: a1, a2, a3, a4, a5, a6
real(kind=wp), external :: DDot_, determinant3

! The x^4 and x^3 coefficients are constant
P(5) = One
P(4) = Zero
! The x^2 coefficient is the sum of all squared elements, times -2
P(3) = -Two*DDot_(9,M,1,M,1)
! The x^1 coefficient is the determinant of M, times -8
P(2) = -Eight*determinant3(M)
! The x^0 coefficient has a rather cumbersome expansion
a1 = (M(1,2)**2+M(1,3)**2-M(2,1)**2-M(3,1)**2)**2
a2 = (-M(1,1)**2+M(2,2)**2+M(3,3)**2+M(2,3)**2+M(3,2)**2-Two*(M(2,2)*M(3,3)-M(2,3)*M(3,2)))* &
     (-M(1,1)**2+M(2,2)**2+M(3,3)**2+M(2,3)**2+M(3,2)**2+Two*(M(2,2)*M(3,3)-M(2,3)*M(3,2)))
a3 = (-(M(1,3)+M(3,1))*(M(2,3)-M(3,2))+(M(1,2)-M(2,1))*(M(1,1)-M(2,2)-M(3,3)))* &
     (-(M(1,3)-M(3,1))*(M(2,3)+M(3,2))+(M(1,2)-M(2,1))*(M(1,1)-M(2,2)+M(3,3)))
a4 = (-(M(1,3)+M(3,1))*(M(2,3)+M(3,2))-(M(1,2)+M(2,1))*(M(1,1)+M(2,2)-M(3,3)))* &
     (-(M(1,3)-M(3,1))*(M(2,3)-M(3,2))-(M(1,2)+M(2,1))*(M(1,1)+M(2,2)+M(3,3)))
a5 = ((M(1,2)+M(2,1))*(M(2,3)+M(3,2))+(M(1,3)+M(3,1))*(M(1,1)-M(2,2)+M(3,3)))* &
     (-(M(1,2)-M(2,1))*(M(2,3)-M(3,2))+(M(1,3)+M(3,1))*(M(1,1)+M(2,2)+M(3,3)))
a6 = ((M(1,2)+M(2,1))*(M(2,3)-M(3,2))+(M(1,3)-M(3,1))*(M(1,1)-M(2,2)-M(3,3)))* &
     (-(M(1,2)-M(2,1))*(M(2,3)+M(3,2))+(M(1,3)-M(3,1))*(M(1,1)+M(2,2)-M(3,3)))
P(1) = a1+a2+a3+a4+a5+a6

end subroutine build_polynomial

!***********************************************************************
!  find_lambda
!
!> @brief
!>   Find one root of a 4th degree polynomial.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Find one real root of a 4th degree polynomial using the Newton--Raphson method.
!> On input, the variable \p r contains the initial guess for the root.
!>
!> @param[in]     P The polynomial coefficients
!> @param[in,out] r The found root (initial guess on input)
!***********************************************************************
subroutine find_lambda(P,r)

use Constants, only: Zero, Two, Ten
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: P(5)
real(kind=wp), intent(inout) :: r
integer(kind=iwp) :: j, loop
real(kind=wp) :: df, f, r_old, thrr
integer(kind=iwp), parameter :: mxloop = 100
real(kind=wp), parameter :: thr = 1.0e-11_wp

r_old = max(Two*r,Ten)
! Find the root with the Newton-Raphson method, starting from the initial value
loop = 0
thrr = thr*r
do while ((abs(r-r_old) > thrr) .and. (loop < mxloop))
  r_old = r
  ! Compute the values of the polynomial (f) and its derivative (df)
  ! at the current value of r
  f = P(5)
  df = Zero
  do j=4,1,-1
    df = df*r+f
    f = f*r+P(j)
  end do
  ! Update the value of r from the values of f and df
  ! (special case if the derivative is zero)
  if (abs(df) < thrr) then
    if (abs(f) < thr) then
      r_old = r
    else
      ! If the df is zero and r is not a root, we are in trouble,
      ! just move the point a tad
      r = r-sign(Two*thrr,f)
    end if
  else
    r = r-f/df
  end if
  thrr = thr*r
  ! Increase count to avoid neverending loop
  loop = loop+1
end do

end subroutine find_lambda

!***********************************************************************
!  get_eigenvector
!
!> @brief
!>   Find an eigenvector of the \f$ K \f$ matrix, given its eigenvalue.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Compute the eigenvector of the \f$ K \f$ matrix corresponding to one eigenvalue.
!> @side_effects
!> The matrix \p K is destroyed on output.
!>
!> @param[in,out] K The \f$ K \f$ matrix
!> @param[in]     r The eigenvalue
!> @param[out]    V The eigenvector
!***********************************************************************
subroutine get_eigenvector(K,r,V)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: K(4,4)
real(kind=wp), intent(in) :: r
real(kind=wp), intent(out) :: V(4)
integer(kind=iwp) :: i, j
real(kind=wp) :: n
real(kind=wp), parameter :: thr = 1.0e-12_wp
real(kind=wp), external :: cofactor, DDot_

! Get the matrix K-rI
K(1,1) = K(1,1)-r
K(2,2) = K(2,2)-r
K(3,3) = K(3,3)-r
K(4,4) = K(4,4)-r
! Find the eigenvector as any non-zero column of adj(K-rI)
n = Zero
do j=1,4
  if (n < thr) then
    ! Since adj(X) is the transpose of the cofactors matrix, we take a row from K
    do i=1,4
      V(i) = cofactor(K,j,i)
    end do
    ! Get the norm of the vector, if not too small, no further vector will be computed
    n = DDot_(4,V,1,V,1)
  end if
end do
! If the norm is still too small, return the identity quaternion (no rotation)
if (n < thr) V(:) = [One,Zero,Zero,Zero]

end subroutine get_eigenvector

!***********************************************************************
!  cofactor
!
!> @brief
!>   Return a cofactor from a 4&times;4 matrix.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Returns a cofactor (determinant of a submatrix) from a 4&times;4 matrix.
!>
!> @param[in] M The matrix
!> @param[in] i The row of the cofactor
!> @param[in] j The column of the cofactor
!>
!> @return The \f$ C_{ij} \f$ cofactor of the matrix \p M
!***********************************************************************
function cofactor(M,i,j)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: cofactor
real(kind=wp), intent(in) :: M(4,4)
integer(kind=iwp), intent(in) :: i, j
integer(kind=iwp) :: ii, jj
real(kind=wp) :: A(3,3), f
real(kind=wp), external :: determinant3

! Get the submatrix as four blocks, depending on whether the indices are
! greater or smaller than the element position
do ii=1,i-1
  do jj=1,j-1
    A(ii,jj) = M(ii,jj)
  end do
end do
do ii=1,i-1
  do jj=j+1,4
    A(ii,jj-1) = M(ii,jj)
  end do
end do
do ii=i+1,4
  do jj=1,j-1
    A(ii-1,jj) = M(ii,jj)
  end do
end do
do ii=i+1,4
  do jj=j+1,4
    A(ii-1,jj-1) = M(ii,jj)
  end do
end do
! The cofactor is +1/-1 times the determinant of the submatrix
f = (-One)**(i+j)
cofactor = f*determinant3(A)

end function cofactor

!***********************************************************************
!  determinant3
!
!> @brief
!>   Return the determinant of a 3&times;3 matrix.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Returns the determinant of a 3&times;3 matrix.
!>
!> @param[in] M The matrix
!>
!> @return The determinant of \p M
!***********************************************************************
function determinant3(M)

use Definitions, only: wp

implicit none
real(kind=wp) :: determinant3
real(kind=wp), intent(in) :: M(3,3)

determinant3 = (M(1,1)*M(2,2)*M(3,3)+M(1,2)*M(2,3)*M(3,1)+M(1,3)*M(2,1)*M(3,2))- &
               (M(1,1)*M(2,3)*M(3,2)+M(1,2)*M(2,1)*M(3,3)+M(1,3)*M(2,2)*M(3,1))

end function determinant3

!***********************************************************************
!  apply_rotation
!
!> @brief
!>   Rotate a structure with a quaternion.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Apply a rotation, given by a unit quaternion, to all atoms in a structure.
!>
!> @param[in,out] x   Cartesian coordinates of the structure
!> @param[in]     nAt Number of atoms in the structure
!> @param[in]     q   A unit quaternion representing a rotation
!***********************************************************************
subroutine apply_rotation(x,nAt,q)

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(inout) :: x(3,nAt)
real(kind=wp), intent(in) :: q(4)
integer(kind=iwp) :: i, iAt
real(kind=wp) :: MRot(3,3), v(3)
real(kind=wp), external :: DDot_

! Compute the rotation matrix from the quaternion
! (transposed or not, that depends on the rotation direction
!  and storage order... this version seems to work)
MRot(1,1) = q(1)**2+q(2)**2-q(3)**2-q(4)**2
MRot(2,2) = q(1)**2-q(2)**2+q(3)**2-q(4)**2
MRot(3,3) = q(1)**2-q(2)**2-q(3)**2+q(4)**2
MRot(2,1) = Two*(q(2)*q(3)+q(1)*q(4))
MRot(1,2) = Two*(q(2)*q(3)-q(1)*q(4))
MRot(3,2) = Two*(q(3)*q(4)+q(1)*q(2))
MRot(2,3) = Two*(q(3)*q(4)-q(1)*q(2))
MRot(1,3) = Two*(q(2)*q(4)+q(1)*q(3))
MRot(3,1) = Two*(q(2)*q(4)-q(1)*q(3))
! Apply the matrix to every atom in the structure
do iAt=1,nAt
  v(:) = x(:,iAt)
  do i=1,3
    x(i,iAt) = DDot_(3,MRot(:,i),1,v,1)
  end do
end do

end subroutine apply_rotation

!***********************************************************************
!> @}
!***********************************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MAGN_NO_MF( EXCH,N,X,Y,Z,H,W,dM,sM,nT,T,sopt,WZ,ZB,
     &                       S,M, DBG )
c this Subroutine computes the magnetisation for zJ==0.0
c
c definition of the variables:
c   EXCH -- total number of exchange states, Integer, input
c      N -- size of the Zeeman matrix, Integer, input, NM .LE. EXCH !
c  X,Y,Z -- projections of the magnetic field, specIfying the orientation of the applied
c           magnetic field, Real(kind=8) ::, input;  rule: ( X**2 + Y**2 + Z**2 = 1);
c      H -- strength of the magnetic field in Tesla, Real(kind=8) ::, input;
c      W -- energies of the exchange states; Real(kind=8) :: array (EXCH);
c     dM -- matrix of the magnetic moment, Complex(kind=8) :: (3,EXCH,EXCH) array, input;
c     sM -- matrix of the     spin moment, Complex(kind=8) :: (3,EXCH,EXCH) array, input;
c     nT -- number of temperature points for which magnetisation is computed, input;
c      T -- temperature values(in Kelvin) for which magnetisation is computed, input;
c   sopt -- logical parameter. If sopt=.true. Then spin magnetisation is computed.
c                              If sopt=.false. Then spin part is skipped.
c
c     WZ -- Zeeman energies, true values (not shifted to 0), in cm-1, Real(kind=8) :: (N) array, output;
c     ZB -- statistical Boltzmann distribution, for each temperature, Real(kind=8) :: (nT) array, output;
c      S -- spin magnetisation, Real(kind=8) :: (3,nT) array, output;
c      M -- magnetisation, Real(kind=8) :: (3,nT) array, output;
c m_paranoid --  logical parameter.
c            If m_paranoid = .true.  Then the average spin is computed for each temperature point exactly
c            If m_paranoid = .false. Then  the average spin is computed only for the lowest temperature point
c---------
c  temporary (local) variables:
c    MZ -- matrix of the magnetic moment, Complex(kind=8) :: (3,EXCH,EXCH) array
c    SZ -- matrix of the     spin moment, Complex(kind=8) :: (3,EXCH,EXCH) array
c    WM -- array containing the Zeeman eigenstates and, If N<EXCH the exchange eigenstates
c          for the states higher in energy than N, Real(kind=8) ::, (EXCH) array;
c    ZM -- Zeeman eigenvectors, (N,N) Complex(kind=8) :: array,
c   i,j -- labers of the states;
c     l -- labels the cartesian component of the momentum (convention: x=1, y=2, z=3)
c    iT -- labes the temperature points;
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)          :: EXCH, N, nT
      Real(kind=8), intent(in)    :: X, Y, Z, H
      Real(kind=8), intent(in)    :: W(EXCH), T(nT)
      Real(kind=8), intent(out)   :: ZB(nT), WZ(N)
      Real(kind=8), intent(out)   :: S(3,nT), M(3,nT)
      Complex(kind=8), intent(in) :: dM(3,EXCH,EXCH)
      Complex(kind=8), intent(in) :: sM(3,EXCH,EXCH)
      Logical, intent(in)          :: sopt
c local variables:
      Integer          :: i, l, iT
      Real(kind=8)    :: zJ
      Real(kind=8), allocatable :: WM(:), ST(:), RWORK(:)
!                                   WM(EXCH), ST(3)
      Complex(kind=8), allocatable :: HZEE(:), WORK(:), W_c(:)
      Complex(kind=8), allocatable :: ZM(:,:) !ZM(N,N)
      Complex(kind=8), allocatable :: SZ(:,:,:), MZ(:,:,:)
!                                      SZ(3,EXCH,EXCH), MZ(3,EXCH,EXCH)
      Logical          :: DBG

c a few checks, before proceeding:
      Do iT=1,nT
        If (T(iT)==0.0_wp) Return
      End Do
      If(H==0.0_wp) Return
      If(N > EXCH) Return
      zJ = 0.0_wp ! it must be defined for ZEEM
c initialization:
      Call mma_allocate(WM,exch,'WM')
      Call mma_allocate(ZM,exch,exch,'ZM')
      Call mma_allocate(ST,3,'ST')
      Call mma_allocate(SZ,3,exch,exch,'SZ')
      Call mma_allocate(MZ,3,exch,exch,'MZ')

      ! temporary arrays used in ZEEM_SA:
      Call mma_allocate(RWORK,(3*N-2),'ZEEM_RWORK')
      Call mma_allocate(HZEE,(N*(N+1)/2),'ZEEM_HZEE')
      Call mma_allocate(WORK,(2*N-1),'ZEEM_WORK')
      Call mma_allocate(W_c,N,'ZEEM_W_c')

      ! zero everything:
      Call dcopy_(3*N-2,[0.0_wp],0,RWORK,1)
      Call zcopy_(N*(N+1)/2,[(0.0_wp,0.0_wp)],0,HZEE,1)
      Call zcopy_(2*N-1,[(0.0_wp,0.0_wp)],0,WORK,1)
      Call zcopy_(N,[(0.0_wp,0.0_wp)],0,W_c,1)

      Call dcopy_(   3,[0.0_wp],0,ST,1)
      Call dcopy_(   N,[0.0_wp],0,WZ,1)
      Call dcopy_(exch,[0.0_wp],0,WM,1)
      Call zcopy_(  exch*exch,[(0.0_wp,0.0_wp)],0,ZM,1)
      Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,SZ,1)
      Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,MZ,1)
c start calculations:
      If (DBG) Write(6,*) 'Enter ZEEM::'
      If (DBG) Write(6,*) 'Input data:   N = ', N
      If (DBG) Write(6,*) 'Input data:   H = ', H
      If (DBG) Write(6,*) 'Input data:   X = ', X
      If (DBG) Write(6,*) 'Input data:   Y = ', Y
      If (DBG) Write(6,*) 'Input data:   Z = ', Z
      If (DBG) Write(6,*) 'Input data:  zJ = ', zJ
      If (DBG) Write(6,*) 'Input data: W() = ', W(1:N)
      If (DBG) Write(6,*) 'Input data: ST()= ', ST(1:3)
      If (DBG) Call prmom('INput data dM:',dM,N)
      If (DBG) Call prmom('INput data sM:',sM,N)
      If (DBG) Call xFlush(6)

      ! Build and diagonalize the Zeeman Hamiltonian
      ! most important output are: WM (energies) and ZM (eigenvectors)
      Call ZEEM_SA( N, H, X,Y,Z, W(1:N), dM(1:3,1:N,1:N),
     &             sM(1:3,1:N,1:N), ST, zJ, WM(1:N), ZM,
     &             DBG, RWORK, HZEE, WORK, W_c )
      If (DBG) Write(6,*) 'Exit ZEEM::'
      If (DBG) Call xFlush(6)


      Call DCOPY_(N, WM(1:N), 1, WZ(1:N), 1)
      If(N.ne.EXCH) Then
        Do i=N+1,EXCH
          WM(i)=W(i)
        End Do
      End If


      ! transform the momenta
      Call UTMU( EXCH, N, ZM, sM, SZ )
      Call UTMU( EXCH, N, ZM, dM, MZ )


      ! compute magnetization at different temperatures:
      Call dcopy_(  nT,[0.0_wp],0,ZB,1)
      Call dcopy_(3*nT,[0.0_wp],0,M,1)
      Call dcopy_(3*nT,[0.0_wp],0,S,1)

      If (N==EXCH) Then
        Do iT=1,nT
          Do l=1,3
            If (sopt) Then
              Call calcmagn1( EXCH, WM, SZ(l,:,:), T(iT), S(l,iT),
     &                        ZB(iT) )
            End If
              Call calcmagn1( EXCH, WM, MZ(l,:,:), T(iT), M(l,iT),
     &                        ZB(iT) )
          End Do
        End Do
      Else
        Do iT=1,nT
          Do l=1,3
            If(sopt) Then
              Call calcmagn2( EXCH, N, WM, T(iT), H, SZ, X, Y, Z, l,
     &                        S(l,iT), ZB(iT) )
            End If
              Call calcmagn2( EXCH, N, WM, T(iT), H, MZ, X, Y, Z, l,
     &                        M(l,iT), ZB(iT) )
          End Do
        End Do !iT
      End If

      ! deallocate temporary arrays:
      Call mma_deallocate(RWORK)
      Call mma_deallocate(HZEE)
      Call mma_deallocate(WORK)
      Call mma_deallocate(W_c)

      Call mma_deallocate(WM)
      Call mma_deallocate(ZM)
      Call mma_deallocate(ST)
      Call mma_deallocate(SZ)
      Call mma_deallocate(MZ)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRMAT(IUOUT,R,N,M,HEAD)
      REAL*8 R
      CHARACTER*(*) HEAD
      DIMENSION R(*)
C     SUBROUTINE PRINTS MATRIX R,WHICH IS SUPPOSED
C     TO HAVE DIMENSION N,M  WHEN M IS NONZERO AND
C     ((N+1)*N)/2 WHEN M IS ZERO
      WRITE(IUOUT,1001) HEAD
      NKPB=4
      IF (M.LE.0) THEN
        GO TO 10
      ELSE
        GO TO 80
      END IF
C
   10 CONTINUE
      IBL=N/NKPB
      IR=N-IBL*NKPB
      J1=1
      K1S=1
      KD=0
      IF(IBL.EQ.0) GO TO 50
      J2=NKPB
      DO 40 I=1,IBL
      WRITE(IUOUT,1002)(J,J=J1,J2)
      K1=K1S
      K2=K1
      KK=0
      DO 20 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
      K2=K1+KK
   20 CONTINUE
      J1=J1+NKPB
      IF(J1.GT.N) RETURN
      J2=J2+NKPB
      K2=K1-1
      K1=K2+1
      K2=K1+(NKPB-1)
      K1S=K2+1
      KK=KD+NKPB
      DO 30 J=J1,N
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KK
      K2=K2+KK
   30 CONTINUE
      KD=KD+NKPB
   40 CONTINUE
   50 IF(IR.EQ.0) GO TO 70
      K1=K1S
      J2=J1+IR-1
      KK=0
      K2=K1
      WRITE(IUOUT,1002)(J,J=J1,J2)
      WRITE(IUOUT,1003)
      DO 60 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
      K2=K1+KK
   60 CONTINUE
   70 RETURN
   80 IBL=M/NKPB
      IR=M-IBL*NKPB
      I2=0
      K2=0
      IF(IBL.EQ.0) GO TO 100
      DO 90 I=1,IBL
      I1=(I-1)*N*NKPB+1
      I2=I1+(NKPB-1)*N
      K1=K2+1
      K2=K1+(NKPB-1)
      WRITE(IUOUT,1002)(K,K=K1,K2)
      DO 91 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
      I2=I1+(NKPB-1)*N
   91 CONTINUE
   90 CONTINUE
  100 IF(IR.EQ.0) GO TO 120
      I1=IBL*N*NKPB+1
      I2=I1+(IR-1)*N
      K1=K2+1
      K2=M
      WRITE(IUOUT,1002)(K,K=K1,K2)
      WRITE(IUOUT,1003)
      DO 110 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
      I2=I1+(IR-1)*N
  110 CONTINUE
  120 WRITE(IUOUT,1003)
      RETURN
 1001 FORMAT(' MATRIX PRINTED:',2X,A)
 1002 FORMAT(' ',4X,4(6X,I4,6X),/)
 1003 FORMAT(' ',I4,4D16.8)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Oskar Weser                                      *
!***********************************************************************
      module index_symmetry
        implicit none
        private
        public :: one_el_idx, one_el_idx_flatten, two_el_idx,
     &      two_el_idx_flatten
        save

        interface one_el_idx
          module procedure array_one_el_idx, tuple_one_el_idx
        end interface

        interface two_el_idx
          module procedure array_two_el_idx, tuple_two_el_idx
        end interface

        interface one_el_idx_flatten
          module procedure array_1el_idx_flatten, tuple_1el_idx_flatten
        end interface

        interface two_el_idx_flatten
          module procedure array_2el_idx_flatten,
     &        tuple_2el_idx_flatten, tuple_2el_idx_flatten_2
        end interface

      contains

        pure subroutine tuple_one_el_idx(n, i, j)
          integer, intent(in) :: n
          integer, intent(out) :: i, j

          i = ceiling(-0.5d0 + sqrt(2.0d0 * n))
          j = n - (i - 1) * i / 2
        end subroutine

        pure subroutine array_one_el_idx(n, idx)
          integer, intent(in) :: n
          integer, intent(out) :: idx(2)

          idx(1) = ceiling(-0.5d0 + sqrt(2.0d0 * n))
          idx(2) = n - (idx(1) - 1) * idx(1) / 2
        end subroutine

        pure function array_1el_idx_flatten(idx) result(n)
          integer, intent(in) :: idx(2)
          integer :: n
          n = tuple_1el_idx_flatten(idx(1), idx(2))
        end function

        pure function tuple_1el_idx_flatten(i, j) result(n)
          integer, intent(in) :: i, j
          integer :: n
          integer :: p, q
          p = max(i, j)
          q = min(i, j)
          n = q + p * (p - 1) / 2
        end function

        pure subroutine tuple_two_el_idx(n, iorb, jorb, korb, lorb)
          integer, intent(in) :: n
          integer, intent(out) :: iorb, jorb, korb, lorb

          integer :: ijidx, klidx

          ijidx = ceiling(-0.5d0 + sqrt(2.0d0 * n))
          klidx = n - (ijidx - 1) * ijidx / 2

          iorb = ceiling(-0.5d0 + sqrt(2.0d0 * ijidx))
          jorb = ijidx - (iorb - 1) * iorb / 2
          korb = ceiling(-0.5d0 + sqrt(2.0d0 * klidx))
          lorb = klidx - (korb - 1) * korb / 2
        end subroutine

        pure subroutine array_two_el_idx(n, idx)
          integer, intent(in) :: n
          integer, intent(out) :: idx(4)

          integer :: ijidx, klidx

          ijidx = ceiling(-0.5d0 + sqrt(2.0d0 * n))
          klidx = n - (ijidx - 1) * ijidx / 2

          idx(1) = ceiling(-0.5d0 + sqrt(2.0d0 * ijidx))
          idx(2) = ijidx - (idx(1) - 1) * idx(1) / 2
          idx(3) = ceiling(-0.5d0 + sqrt(2.0d0 * klidx))
          idx(4) = klidx - (idx(3) - 1) * idx(3) / 2
        end subroutine

        function array_2el_idx_flatten(idx) result(n)
          integer, intent(in) :: idx(4)
          integer :: n
          n = tuple_2el_idx_flatten(idx(1), idx(2), idx(3), idx(4))
        end function

        function tuple_2el_idx_flatten(p, q, r, s) result(pqrs)
          integer, intent(in) :: p, q, r, s
          integer :: pqrs
          integer :: pq, rs
          pqrs = tuple_2el_idx_flatten_2(p, q, r, s, pq, rs)
        end function

        function tuple_2el_idx_flatten_2(p, q, r, s, pq, rs)result(pqrs)
          integer, intent(in) :: p, q, r, s
          integer, intent(out) :: pq, rs
          integer :: pqrs
          if (p >= q) pq = p * (p - 1) / 2 + q
          if (p < q) pq = q * (q - 1) / 2 + p
          if (r >= s) rs = r * (r - 1) / 2 + s
          if (r < s) rs = s * (s - 1) / 2 + r
          if (pq >= rs) pqrs = pq * (pq - 1) / 2 + rs
          if (pq < rs) pqrs = rs * (rs - 1) / 2 + pq
        end function
      end module index_symmetry

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine wr_mpprop(nAtoms,nCenters,nMltPl,iPol)
      Implicit Real*8 (a-h,o-z)

#include "MpParam.fh"
#include "WrkSpc.fh"
#include "Address.fh"
#include "MolProp.fh"

      Parameter (mxComp=(mxMltPl+1)*(mxMltPl+2)/2)
!     "0:" added by EB
      Character*16 MltPlLab, MltPlLabs(0:mxMltpl,mxComp)
      Character*16 String(0:16), PolString
      Real*8 MolPol(6)

      iStdOut = 6

      Do j=1,6
         MolPol(j)=0.0D0
      EndDo
      String(0)='Charge          '
      String(1)='Dipole          '
      String(2)='Quadrupole      '
      String(3)='Octupole        '
      String(4)='Hexadecapole    '
*      Do i=5,16
*         Write(String(i),'(I2,A)') i, '-th       Cartesian'
*      EndDo
      String(5)='5-th       Carte' !sian
      String(6)='6-th       Carte' !sian
      String(7)='7-th       Carte' !sian
      String(8)='8-th       Carte' !sian
      String(9)='9-th       Carte' !sian
      String(10)='10-th       Car' !tesian
      String(11)='11-th       Car' !tesian
      String(12)='12-th       Car' !tesian
      String(13)='13-th       Car' !tesian
      String(14)='14-th       Car' !tesian
      String(15)='15-th       Car' !tesian
      String(16)='16-th       Car' !tesian
      PolString='Polarizability  '

      If(16.lt.mxMltPl) Then
         Write(6,*) 'Increase length of MltPlLab'
         Call Abend()
      EndIf
      Do iMltPl=0,nMltPl
      ilab=0
      Do ix=iMltpl,0,-1
         Do iy=iMltpl-ix,0,-1
            iz=iMltpl-ix-iy
            ilab=ilab+1
            Do i=1,16
               MltPlLab(i:i)=' '
            EndDo
            Do izz=iMltPl,iMltPl-iz+1,-1
               MltPlLab(izz:izz)='Z'
            End Do
            Do iyy=iMltPl-iz,iMltPl-iz-iy+1,-1
               MltPlLab(iyy:iyy)='Y'
            End Do
                               !max(               ,1)   added by EB
            Do ixx=iMltPl-iz-iy,max(iMltPl-nMltPl+1,1),-1
               MltPlLab(ixx:ixx)='X'
            End Do
            MltPlLabs(iMltPl,ilab)=MltPlLab
         End Do
      End Do
      EndDo

      WRITE(iStdOut,*)
      WRITE(iStdOut,*) ' The name of the molecule will be', Title
      WRITE(iStdOut,*)
      WRITE(iStdOut,*)
     &' THE MULTIPOLES AND POLARIZABILITY FOR THE EXPANSION'
      WRITE(iStdOut,*)
     &' ***************************************************',
     &'*************'
      WRITE(iStdOut,*)
      WRITE(iStdOut,*) ' TOTAL NUMBER OF CENTERS   : ',nCenters
      WRITE(iStdOut,*) ' OF WHICH THERE ARE ATOMS  : ',nAtoms
      WRITE(iStdOut,*) ' AND BONDS IN THE MOLECULE : ',nCenters-nAtoms
      WRITE(iStdOut,*)

      Write(iStdOut,'(1x,a16,3a16)')'Coord           ',
     &(MltPlLabs(1,iComp)(1:1),iComp=1,3)
      Do iMltPl=0,nMltPl
         nComp=(iMltPl+1)*(iMltPl+2)/2
         Do iComp=1,nComp,6
            Write(6,'(1x,a,6a16)') String(iMltPl),
     &      (MltPlLabs(iMltPl,jComp)(1:iMltPl),
     &      jComp=iComp,min(iComp+5,nComp))
         EndDo
      EndDo
      If(iPol.gt.0) Then
      Write(iStdOut,'(1x,a,6a16)') PolString,(MltPlLabs(2,iComp)(1:2),
     &iComp=1,6)
      EndIf
      iCount=0
      WRITE(iStdOut,*)
      WRITE(iStdOut,*)
      WRITE(iStdOut,*)
      WRITE(iStdOut,*) 'Multipole expansion for Atoms and Bonds'
      WRITE(iStdOut,*) '***************************************'
      Do i = 1,nAtoms
         iCount=iCount+1
         Write(iStdOut,*)
         Write(iStdOut,'(I5,A8,I5,A3,A10)')
     &   iCount,' Center ',i*(i+1)/2,'   ',CEN_LAB(i*(i+1)/2)
         Write(iStdOut,*)
     &   '**************************************************'
         WRITE(iStdOut,'(1x,a16,3f16.8)')'Coord           ',
     &   Cor(1,I,I),Cor(2,I,I),Cor(3,I,I)
         Do iMltPl=0,nMltPl
         nComp=(iMltPl+1)*(iMltPl+2)/2
         Do iComp=1,nComp,6
         Write(iStdOut,'(1x,a16,6f16.8)') String(iMltPl),
     &   (Work(iAtBoMltPlAd(iMltPl)+
     &   nCenters*(jComp-1)+i*(i+1)/2-1),
     &   jComp=iComp,min(iComp+5,nComp))
         EndDo
         EndDo
         If(iPol.gt.0) Then
         Write(iStdOut,'(1x,a16,6f16.8)')PolString,
     &   (Work(iAtBoPolAd+nCenters*(iComp-1)+i*(i+1)/2-1),
     &   iComp=1,6)
         EndIf
      EndDo
      Do i = 1,nAtoms
         Do j= 1,i-1
         If(BondMat(i,j)) Then
         iCount=iCount+1
         Write(iStdOut,*)
         Write(iStdOut,'(I5,A8,I5,A3,A10)')
     &   iCount,' Center ',i*(i-1)/2+j,'   ',CEN_LAB(i*(i-1)/2+j)
         Write(iStdOut,*)
     &   '**************************************************'
         WRITE(iStdOut,'(1x,a16,3f16.8)')'Coord           ',
     &   Cor(1,I,j),Cor(2,I,j),Cor(3,I,j)
         Do iMltPl=0,nMltPl
         nComp=(iMltPl+1)*(iMltPl+2)/2
         Do iComp=1,nComp,6
         Write(iStdOut,'(1x,a16,6f16.8)') String(iMltPl),
     &   (Work(iAtBoMltPlAd(iMltPl)+
     &   nCenters*(jComp-1)+i*(i-1)/2+j-1),
     &   jComp=iComp,min(iComp+5,nComp))
         EndDo
         EndDo
         If(iPol.gt.0) Then
         Write(iStdOut,'(1x,a16,6f16.8)')PolString,
     &   (Work(iAtBoPolAd+nCenters*(iComp-1)+i*(i-1)/2+j-1),
     &   iComp=1,6)
         EndIf
         EndIf
         EndDo
      EndDo
      Write(iStdOut,*)
      Write(iStdOut,*)
      Write(iStdOut,*)
      Write(iStdOut,*) 'Multipole expansion for Atoms'
      Write(iStdOut,*) '*****************************'

      Do i = 1,nAtoms
         Write(iStdOut,*)
         Write(iStdOut,'(I5,A8,I5,A3,A10)')i,' Atom   ',i,'   ',
     &   CEN_LAB(i*(i+1)/2)
         Write(iStdOut,*)
     &   '**************************************************'
         WRITE(iStdOut,'(1x,a16,3f16.8)')'Coord           ',
     &   Cor(1,I,I),Cor(2,I,I),Cor(3,I,I)
         Do iMltPl=0,nMltPl
         nComp=(iMltPl+1)*(iMltPl+2)/2
         Do iComp=1,nComp,6
         Write(iStdOut,'(1x,a16,6f16.8)') String(iMltPl),
     &   (Work(iAtMltPlAd(iMltPl)+
     &   nAtoms*(jComp-1)+i-1),
     &   jComp=iComp,min(iComp+5,nComp))
         EndDo
         EndDo
         If(iPol.gt.0) Then
         Write(iStdOut,'(1x,a16,6f16.8)')PolString,
     &   (Work(iAtPolAd+nAtoms*(iComp-1)+i-1),
     &   iComp=1,6)
         Do j=1,6
            MolPol(j)=MolPol(j)+Work(iAtPolAd+nAtoms*(j-1)+i-1)
         EndDo
         EndIf
      EndDo
      Write(iStdOut,*)
      Write(iStdOut,*)
      Write(iStdOut,*)
      Write(iStdOut,*)
     &' SUMMED MULTIPOLES AND POLARIZABILITY FOR THE MOLECULE'
      Write(iStdOut,*)
     &' *****************************************************'
      Write(iStdOut,*)
      WRITE(iStdOut,'(1x,a16,3f16.8)')'Coord              ',
     &0.0D0,0.0D0,0.0D0
      Do iMltPl=0,nMltPl
        nComp=(iMltPl+1)*(iMltPl+2)/2
        Do iComp=1,nComp,6
        Write(iStdOut,'(1x,a16,6f16.8)')String(iMltPl),
     &  (Work(iAtMltPlTotAd(iMltPl)+jComp-1),
     &  jComp=iComp,min(iComp+5,nComp))
        EndDo
      EndDo
      If(iPol.gt.0)Write(iStdOut,'(1x,a16,6f16.8)')
     &PolString,(MolPol(j),j=1,6)
      Write(iStdOut,*)
      Write(iStdOut,*)
      WRITE(iStdOut,'(1x,a16,3f16.8)')'Coord              ',
     &0.0D0,0.0D0,0.0D0
      Do iMltPl=0,nMltPl
        nComp=(iMltPl+1)*(iMltPl+2)/2
        Do iComp=1,nComp,6
        Write(iStdOut,'(1x,a16,6f16.8)')String(iMltPl),
     &  (Work(iAtBoMltPlTotAd(iMltPl)+jComp-1),
     &  jComp=iComp,min(iComp+5,nComp))
        EndDo
      EndDo

!EB 10000 format(F16.6)
!EB 10003 format(3F16.6 )
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!----------------------------------------------------------------------*
! With this function we wish to place the QM-molecule properly when we *
! run with solvetn configurations from the sampfile. This we do by     *
! making the center-of-masses to coincide.                             *
!----------------------------------------------------------------------*
subroutine PlaceIt9(Coord,Cordst,info_atom,iQ_Atoms)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms, info_atom(iQ_Atoms)
real(kind=wp), intent(in) :: Coord(3,iQ_Atoms)
real(kind=wp), intent(out) :: Cordst(3,iQ_Atoms)
integer(kind=iwp) :: i
real(kind=wp) :: CMSamx, CMSamy, CMSamz, CMSewx, CMSewy, CMSewz, Tx, Ty, Tz, Wtot

CMSewx = Zero
CMSewy = Zero
CMSewz = Zero
CMSamx = Zero
CMSamy = Zero
CMSamz = Zero
Wtot = Zero
do i=1,iQ_Atoms
  CMSewx = CMSewx+Coord(1,i)*info_atom(i)
  CMSewy = CMSewy+Coord(2,i)*info_atom(i)
  CMSewz = CMSewz+Coord(3,i)*info_atom(i)
  CMSamx = CMSamx+Cordst(1,i)*info_atom(i)
  CMSamy = CMSamy+Cordst(2,i)*info_atom(i)
  CMSamz = CMSamz+Cordst(3,i)*info_atom(i)
  Wtot = Wtot+real(info_atom(i),kind=wp)
end do
CMSewx = CMSewx/Wtot
CMSewy = CMSewy/Wtot
CMSewz = CMSewz/Wtot
CMSamx = CMSamx/Wtot
CMSamy = CMSamy/Wtot
CMSamz = CMSamz/Wtot
Tx = CMSewx-CMSamx
Ty = CMSewy-CMSamy
Tz = CMSewz-CMSamz
Cordst(1,:) = Coord(1,:)-Tx
Cordst(2,:) = Coord(2,:)-Ty
Cordst(3,:) = Coord(3,:)-Tz

return

end subroutine PlaceIt9

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine espf_analysis(lSave)

use espf_global, only: MxExtPotComp
use Index_Functions, only: nTri_Elem1
use Data_Structures, only: Alloc2DArray_Type, Alloc4DArray_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: lSave
integer(kind=iwp) :: iAt, ibla, iGrdTyp, ii, iPL, IPotFl, iRMax, jAt, MltOrd, natom, nAtMM, nAtQM, nChg, nGrdPt, nMult
real(kind=wp) :: DeltaR
logical(kind=iwp) :: DoDirect, DoGromacs, DoTinker, Exists, lMorok
character(len=180) :: ESPFLine
character(len=10) :: ESPFKey
type(Alloc2DArray_Type) :: Grid
type(Alloc4DArray_Type) :: DGrid
integer(kind=iwp), allocatable :: IsMM(:)
real(kind=wp), allocatable :: B(:), Cord(:,:), Ext(:,:), Mltp(:), T(:,:), TT(:,:), TTT(:,:)
integer(kind=iwp), external :: iPL_espf, IsFreeUnit
character(len=180), external :: Get_Ln

iPL = iPL_espf()

if (iPL >= 2) then
  write(u6,*)
  call CollapseOutput(1,'   ESPF analysis')
  write(u6,'(3X,A)') '   -------------'
end if

! Recover some ESPF data

MltOrd = 0
iRMax = 0
DeltaR = Zero
iGrdTyp = 0
nGrdPt = 0
DoTinker = .false.
DoGromacs = .false.
lMorok = .false.
DoDirect = .false.
call F_Inquire('ESPF.DATA',Exists)
if (Exists) then
  IPotFl = IsFreeUnit(1)
  call Molcas_Open(IPotFl,'ESPF.DATA')
  do
    ESPFLine = Get_Ln(IPotFl)
    ESPFKey = ESPFLine(1:10)
    if (ESPFKey == 'MLTORD    ') then
      call Get_I1(2,MltOrd)
      ibla = 0
      do ii=0,MltOrd
        ibla = ibla+nTri_Elem1(ii)
      end do
      MltOrd = ibla
    else if (ESPFKey == 'IRMAX     ') then
      call Get_I1(2,iRMax)
    else if (ESPFKey == 'DELTAR    ') then
      call Get_F1(2,DeltaR)
    else if (ESPFKey == 'GRIDTYPE  ') then
      call Get_I1(2,iGrdTyp)
    else if (ESPFKey == 'GRID      ') then
      call Get_I1(2,nGrdPt)
    else if (ESPFKey == 'TINKER    ') then
      DoTinker = .true.
    else if (ESPFKey == 'GROMACS   ') then
      DoGromacs = .true.
    else if (ESPFKey == 'LA_MOROK  ') then
      lMorok = .true.
    else if (ESPFKey == 'DIRECT    ') then
      DoDirect = .true.
    else if (ESPFKey == 'ENDOFESPF ') then
      exit
    end if
  end do
  close(IPotFl)
else
  write(u6,*) 'No ESPF.DATA file. Abort'
  call Quit_OnUserError()
end if

call Get_iScalar('Unique atoms',natom)
call mma_allocate(Cord,3,natom,label='AtomCoord')
call Get_dArray('Unique Coordinates',Cord,3*natom)
call mma_allocate(IsMM,natom,label='IsMM for atoms')
call mma_allocate(Ext,MxExtPotComp,natom,label='ExtPot')
Ext(:,:) = Zero
call MMCount(natom,nAtMM,IsMM)
nAtQM = natom-nAtMM
nMult = MltOrd*nAtQM

! Read the ESPF potential (and derivatives) from PotFile

IPotFl = IsFreeUnit(33)
IPotFl = IsFreeUnit(IPotFl)
call Molcas_Open(IPotFl,'ESPF.EXTPOT')
ESPFLine = Get_Ln(IPotFl)
call Get_I1(1,nChg)
if (nChg /= 0) then
  write(u6,*) 'ESPF: nChg /= 0 in espf_analysis'
  call Abend()
end if
do iAt=1,natom
  ESPFLine = Get_Ln(IPotFl)
  call Get_I1(1,jAt)
  call Get_F(2,Ext(:,jAt),MxExtPotComp)
end do
close(IPotFl)

! Compute the grid around the molecule

!nGrdPt = 0
call MkGrid(natom,Cord,Grid,nGrdPt,iRMax,DeltaR,.false.,IsMM,iGrdTyp,DGrid,nAtQM)

! Compute the cartesian tensor T, TtT^-1, [TtT^-1]Tt
! and B=ExtPot[TtT^-1]Tt
! Tt means the transpose of T

call mma_allocate(T,nMult,nGrdPt,label='CartTensor')
call mma_allocate(TT,nMult,nMult,label='TT')
call mma_allocate(TTT,nGrdPt,nMult,label='TTT')
call mma_allocate(B,nGrdPt,label='ExtPot*TTT')
call InitB(nMult,natom,nAtQM,nGrdPt,Cord,Grid%A,T,TT,TTT,Ext,B,IsMM)

! Now the analysis

call mma_allocate(Mltp,nMult,label='ESPFMltp')
call espf_mltp(natom,MltOrd,nMult,nGrdPt,TTT,Mltp,Grid%A,IsMM,Ext,iPL+1,Cord)
call Add_Info('ESPF multipoles',Mltp,nMult,6)

! Save some data

if (lSave) &
  call espf_write(MltOrd,iRMax,DeltaR,iGrdTyp,nGrdPt,DoTinker,DoGromacs,lMorok,Mltp,nMult,IsMM,natom,.false.,.false.,DoDirect)

! The end

if (iPL >= 2) then
  call CollapseOutput(0,'   ESPF analysis')
  write(u6,*)
end if
call mma_deallocate(T)
call mma_deallocate(TT)
call mma_deallocate(TTT)
call mma_deallocate(B)
call mma_deallocate(Cord)
call mma_deallocate(IsMM)
call mma_deallocate(Ext)
call mma_deallocate(Mltp)
call mma_deallocate(Grid%A)
call mma_deallocate(DGrid%A,safe='*')

call ClsSew()

return

end subroutine espf_analysis

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine multi_wridir(G,lg,ifile,ias,last)
! See multi_readir
!
! PV/LAOG, 22 may 2003.

use ChT3_global, only: IOPT, nblock
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lg, ifile, ias
real(kind=wp), intent(in) :: G(lg)
integer(kind=iwp), intent(out) :: last
integer(kind=iwp) :: iloc, irest, k, kas

iloc = 1
irest = lg
kas = ias

do while (irest > 0)
  k = min(irest,nblock)
  if (kas <= iopt(2)) then
    write(ifile,rec=kas) G(iloc:iloc+k-1)
  else
    write(ifile+1,rec=kas-iopt(2)) G(iloc:iloc+k-1)
  end if
  iloc = iloc+k
  irest = irest-k
  kas = kas+1
end do
last = kas-1

return

end subroutine multi_wridir

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE TAIL(LL,IJJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ITAI(*),L0(*),L1(*),L2(*),L3(*)
#include "integ.fh"
       L=LL+1
      IF(ITAIL.EQ.0)THEN
        RETURN
      END IF
      DO 5 I=1,ITAIL
      ITAI(I)=0
5     CONTINUE
      IF(L.EQ.LN+1)ITAI(1)=1
      KM=L
      J2(KM)=IJJ
      ICOUP(L)=1
      ICOUP1(L)=1
11    KM=KM+1
      IWAY(KM)=0
12    KM1=KM-1
      IF(IWAY(KM).GE.1)GO TO 14
      IF(L0(IT1+J2(KM1)).EQ.0.OR.L0(IT2+J2(KM1)).EQ.0)GO TO 14
      J2(KM)=L0(IT2+J2(KM1))
      IWAY(KM)=1
      ICOUP(KM)=ICOUP(KM1)
      ICOUP1(KM)=ICOUP1(KM1)
      GO TO 20
14    IF(IWAY(KM).GE.2)GO TO 15
      IF(L1(IT1+J2(KM1)).EQ.0.OR.L1(IT2+J2(KM1)).EQ.0)GO TO 15
      J2(KM)=L1(IT2+J2(KM1))
      IWAY(KM)=2
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM),1)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J2(KM),1)
      GO TO 20
15    IF(IWAY(KM).GE.3)GO TO 16
      IF(L2(IT1+J2(KM1)).EQ.0.OR.L2(IT2+J2(KM1)).EQ.0)GO TO 16
      J2(KM)=L2(IT2+J2(KM1))
      IWAY(KM)=3
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM),2)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J2(KM),2)
      GO TO 20
16    IF(IWAY(KM).GE.4)GO TO 17
      IF(L3(IT1+J2(KM1)).EQ.0.OR.L3(IT2+J2(KM1)).EQ.0)GO TO 17
      J2(KM)=L3(IT2+J2(KM1))
      IWAY(KM)=4
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM),3)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J2(KM),3)
      GO TO 20
17    KM=KM-1
      IF(KM.EQ.L)GO TO 10
      GO TO 12
20    IF(KM.NE.LN+1)GO TO 11
      ITAI(ICOUP(LN+1))=ICOUP1(LN+1)
      GO TO 12
10      Continue
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SCDTC2_MCLR(RASVEC,ISM,ICBLTP,NSM,NOCTPA,NOCTPB,NSASO,NSBSO,IOCOC,IDC,IWAY,IMMLST)
! Scale elements of a RAS vector to transfer between
! combinations and packed determinants
! IWAY = 1 : dets to combs
! IWAY = 2 : combs to dets
! Combination storage mode is defined BY IDC
!
! General symmetry version, Feb 1991

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Constants, only: One, Two, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(inout) :: RASVEC(*)
integer(kind=iwp), intent(in) :: ISM, ICBLTP(*), NSM, NOCTPA, NOCTPB, NSASO(NOCTPA,*), NSBSO(NOCTPB,*), IOCOC(NOCTPA,NOCTPB), IDC, &
                                 IWAY, IMMLST(*)
integer(kind=iwp) :: IASM, IATP, IBASE, IBSM, IBTP, IBTPMX, NELMNT, NIA, NIB
real(kind=wp) :: FACTOR
real(kind=wp), parameter :: SQ2 = sqrt(Two), SQ2I = sqrt(Half)

#ifdef _DEBUGPRINT_
write(u6,*) ' Information from SCDTC2'
write(u6,*) ' ======================='
write(u6,*) ' Input vector'
call WRTRS2_MCLR(RASVEC,ISM,ICBLTP,IOCOC,NOCTPA,NOCTPB,NSASO,NSBSO,NSM)
#endif

IBASE = 1
do IASM=1,NSM

  IBSM = Mul(IASM,ISM)
  if ((IBSM == 0) .or. (ICBLTP(IASM) == 0)) cycle
  do IATP=1,NOCTPA
    if (ICBLTP(IASM) == 2) then
      IBTPMX = IATP
    else
      IBTPMX = NOCTPB
    end if
    NIA = NSASO(IATP,IASM)
    do IBTP=1,IBTPMX
      if (IOCOC(IATP,IBTP) == 0) cycle
      ! Number of elements in this block
      NIB = NSBSO(IBTP,IBSM)
      if ((ICBLTP(IASM) == 2) .and. (IATP == IBTP)) then
        NELMNT = nTri_Elem(NIA)
      else
        NELMNT = NIA*NIB
      end if

      if (IDC == 2) then
        if (IWAY == 1) then
          FACTOR = SQ2
        else
          FACTOR = SQ2I
        end if
        RASVEC(IBASE:IBASE+NELMNT-1) = FACTOR*RASVEC(IBASE:IBASE+NELMNT-1)
        if ((IASM == IBSM) .and. (IATP == IBTP)) then
          FACTOR = One/FACTOR
          call SCLDIA(RASVEC(IBASE),FACTOR,NIA,1)
        end if
      else if ((IDC == 3) .and. (IMMLST(IASM) /= IASM)) then
        if (IWAY == 1) then
          FACTOR = SQ2
        else
          FACTOR = SQ2I
        end if
        RASVEC(IBASE:IBASE+NELMNT-1) = FACTOR*RASVEC(IBASE:IBASE+NELMNT-1)
      else if (IDC == 4) then
        !Ml Ms combinations
        if (IWAY == 1) then
          if (IASM == IBSM) then
            FACTOR = SQ2
          else
            FACTOR = Two
          end if
        else !if (IWAY == 2) then
          if (IASM == IBSM) then
            FACTOR = SQ2I
          else
            FACTOR = Half
          end if
        end if
        RASVEC(IBASE:IBASE+NELMNT-1) = FACTOR*RASVEC(IBASE:IBASE+NELMNT-1)
        if (IATP == IBTP) then
          if (IWAY == 1) then
            FACTOR = SQ2I
          else !if (IWAY == 2) then
            FACTOR = SQ2
          end if
          call SCLDIA(RASVEC(IBASE),FACTOR,NIA,1)
        end if
      end if

      IBASE = IBASE+NELMNT
    end do
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Scaled vector'
call WRTRS2_MCLR(RASVEC,ISM,ICBLTP,IOCOC,NOCTPA,NOCTPB,NSASO,NSBSO,NSM)
#endif

return

end subroutine SCDTC2_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE LUCIA()
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Parameters for dimensioning
#include "mxpdim.fh"
*.Memory
#include "WrkSpc.fh"
*.File numbers
#include "clunit.fh"
*.Print flags
#include "cprnt.fh"
#include "lucinp.fh"
#include "cstate.fh"
#include "crun.fh"
#include "cicisp.fh"
#include "oper.fh"
#include "cgas.fh"

#include "glbbas.fh"
#include "rasscf_lucia.fh"
#include "warnings.fh"
*.Scratch : A character line
*
*.    No floating point underflow
      CALL XUFLOW
*. Assign diskunits
c      IF (ENVIRO(1:6) .EQ. 'RASSCF') THEN
         CALL DISKUN2
c      ELSE
c         CALL DISKUN
c      ENDIF
*. Header
*. From shells to orbitals
      CALL ORBINF(IPRORB)
*. Number of string types
      CALL STRTYP_GAS(IPRSTR)
*. Divide orbital spaces into inactive/active/secondary
      CALL GASSPC
*. Symmetry information
      CALL SYMINF_LUCIA(IPRORB)
*. Number of integrals
      CALL INTDIM(IPRORB)
*. Static memory, initialization and  allocation
c      IF (ENVIRO(1:6) .NE. 'RASSCF') then
c         KBASE = 1
c         KADD = MXPWRD
c         CALL MEMMAN(KBASE,KADD,'INI   ',IDUMMY,'DUMMY')
c      ENDIF
      CALL ALLOC_LUCIA
*. Read in integrals
         IF(NOINT.EQ.0) THEN
            CALL INTIM
         ELSE
            WRITE(6,*) ' No integrals imported '
         END IF
*. READ in MO-AO matrix
c      IF(NOMOFL.EQ.0) CALL GET_CMOAO(WORK(KMOAOIN))
*. Internal string information (stored in WORK, bases in /STRBAS/)
c       CALL STRINF_GAS(WORK,IPRSTR)
      CALL STRINF_GAS(iWORK,IPRSTR) ! really iWORK??? in master?
*. Internal subspaces
      CALL LCISPC(IPRCIX)
*
*. Symmetry of reference
c      IF(PNTGRP.GT.1) CALL MLSM(IREFSM,IREFPA,IREFSM,'CI',1)
      IF(NOINT.EQ.1) THEN
        WRITE(6,*) ' End of calculation without integrals'
        CALL QUIT(_RC_ALL_IS_WELL_)
      END IF
*
*. Last space where CI vectors were stored
*
      ISTOSPC = 0
      IF(IRESTR.EQ.1) ISTOSPC = 1
      IRESTR_ORIG=IRESTR
*
      LBLOCK = MXSOOB
      LBLOCK = MAX(LBLOCK,LCSBLK)
* JESPER : Should reduce I/O
c         IF (ENVIRO(1:6).EQ.'RASSCF') THEN
      LBLOCK = MAX(INT(XISPSM(IREFSM,1)),MXSOOB)
      IF(PSSIGN.NE.0.0D0) LBLOCK = INT(2.0D0*XISPSM(IREFSM,1))

      CALL GETMEM('VEC1  ','ALLO','REAL',KCI_POINTER,LBLOCK)
      CALL GETMEM('VEC2  ','ALLO','REAL',KSIGMA_POINTER,LBLOCK)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     ----------------------
c
c
c     this file contains following routines
c     exppsb
c     zasun
c     inittemp
c     closetemp
c     mktempnam
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
       subroutine exppsb (symp,symq,symr,syms,
     &                    valn,jn,kn,ln)
c
c     this routine realize expansion of symmetry block
c     symp,symq,symr,syms <p,q|r,s>  <-> (IJ|KL), provided such integrals exists
c     It found corresponding (IJ|KL) and expand it to opened
c     NORB(symp) TEMP files with a structure
c     indq,indr,inds,value, each TEMP for one p
c
c     N.B. This process can be accelerated, if exppbs would be
c     divided into exppsb1-8, each for given typ, since this
c     routine is common for all types.
c
c     types of (ij|kl) NI,J,K,L defined in III
c
c     1 - si=sk, si=sj, sk=sl
c     2 - si=sk, si=sj, sk>sl
c     3 - si=sk, si>sj, sk=sl
c     4 - si=sk, si>sj, sk>sl
c     5 - si>sk, si=sj, sk=sl
c     6 - si>sk, si=sj, sk>sl
c     7 - si>sk, si>sj, sk=sl
c     8 - si>sk, si>sj, sk>sl
c
c
       implicit real*8 (a-h,o-z)


#include "SysDef.fh"
#include "reorg.fh"
#include "ccsort.fh"
c
       integer symp,symq,symr,syms
       real*8 valn(1:nsize,1:mbas)
       integer jn(1:nsize,1:mbas)
       integer kn(1:nsize,1:mbas)
       integer ln(1:nsize,1:mbas)
c
c     help variables
c
       integer idis13,indtemp
       integer ni,nj,nk,nl,nsi,nsj,nsk,nsl,i1,j1,k1,l1
       integer iup,ilow,jup,jlow,kup,lup,iold,jold,kold,lold
c
       integer nhelp1,nhelp2,m3
       integer yes1,yes234,yes5,yes678
       integer typp
       integer ind(1:4)
#include "tratoc.fh"
       integer INDMAX
       parameter (INDMAX=nTraBuf)
       REAL*8    TWO(INDMAX)
c
cI    get  adress
       idis13=idis(symp,symq,symr)
c
cII   prepairing nshow vector
c
       do nhelp1=1,norb(symp)
       nshow(nhelp1)=0
       end do
c
cIII.1define order of indices
c
       ni=np(symp,symq,symr)
       nj=nq(symp,symq,symr)
       nk=nr(symp,symq,symr)
       nl=ns(symp,symq,symr)
c
cIII.2def yes1-8
c
       typp=typ(symp,symq,symr)
c
c:1   combination (ij|kl) -> (ij|kl)
c     used in types: 1,2,3,4,5,6,7,8 (all)
       yes1=1
c
c:2   combination (ij|kl) -> (ji|kl)
c:3   combination (ij|kl) -> (ij|lk)
c:4   combination (ij|kl) -> (ji|lk)
c     used in types: 1,5 since 2,3,6,7 never appear
       if ((typp.eq.1).or.(typp.eq.5)) then
       yes234=1
       else
       yes234=0
       end if
c
c:5   combination (ij|kl) -> (kl|ij)
c     used in types: 1,2,3,4
       if ((typp.ge.1).and.(typp.le.4)) then
       yes5=1
       else
       yes5=0
       end if
c
c:6   combination (ij|kl) -> (lk|ij)
c:7   combination (ij|kl) -> (kl|ji)
c:8   combination (ij|kl) -> (lk|ji)
c     used in types: 1 (since 2,3 never appeard)
       if (typp.eq.1) then
       yes678=1
       else
       yes678=0
       end if
c
c
c     define NSI,NSJ,NSK,NSL
       ind(ni)=symp
       ind(nj)=symq
       ind(nk)=symr
       ind(nl)=syms
       NSI=ind(1)
       NSJ=ind(2)
       NSK=ind(3)
       NSL=ind(4)
C
       indtemp=indmax+1
       KUP=NORB(NSK)
       DO 401 KOLD=1,KUP
         if (fullprint.ge.3) write (6,*) ' * K ind ',KOLD
C
       LUP=NORB(NSL)
       IF (NSK.EQ.NSL) LUP=KOLD
       DO 402 LOLD=1,LUP
         if (fullprint.ge.3) write (6,*) ' ** L ind ',LOLD
C
       ILOW=1
       IF (NSI.EQ.NSK) ILOW=KOLD
       IUP=NORB(NSI)
       DO 403 IOLD=ILOW,IUP
         if (fullprint.ge.3) write (6,*) ' *** I ind ',IOLD
C
       JLOW=1
       IF (NSI.EQ.NSK.AND.IOLD.EQ.KOLD) JLOW=LOLD
       JUP=NORB(NSJ)
       IF (NSI.EQ.NSJ) JUP=IOLD
       DO 404 JOLD=JLOW,JUP
         if (fullprint.ge.3) write (6,*) ' **** J ind ',JOLD
C
c
c*    read block of integrals if necessary
c
       if (indtemp.eq.(indmax+1)) then
       indtemp=1
c     read block
       CALL dDAFILE(LUINTM,2,TWO,INDMAX,IDIS13)
       end if
c
c*    write integrals to appropriate positions
c
       val1=TWO(indtemp)
c
c:1   combination (ij|kl) -> (ij|kl)
c     since yes1 is always 1, if structure is skipped
       ind(1)=iold
       ind(2)=jold
       ind(3)=kold
       ind(4)=lold
       j1=ind(nj)
       l1=ind(nl)
       if (symq.eq.syms) then
       if (l1.gt.j1) then
       goto 21
       end if
       end if
       i1=ind(ni)
       k1=ind(nk)
c
       m3=nshow(i1)+1
       jn(m3,i1)=j1
       kn(m3,i1)=k1
       ln(m3,i1)=l1
       valn(m3,i1)=val1
       nshow(i1)=m3
c
       if (m3.eq.nsize) then
       call zasun (i1,nsize,
     &             valn,jn,kn,ln)
       nshow(i1)=0
       end if
c
 21     if (yes234.eq.1) then
c
c:2   combination (ij|kl) -> (ji|kl)
       ind(1)=jold
       ind(2)=iold
       ind(3)=kold
       ind(4)=lold
       j1=ind(nj)
       l1=ind(nl)
       if (symq.eq.syms) then
       if (l1.gt.j1) then
       goto 31
       end if
       end if
       i1=ind(ni)
       k1=ind(nk)
c
       m3=nshow(i1)+1
       jn(m3,i1)=j1
       kn(m3,i1)=k1
       ln(m3,i1)=l1
       valn(m3,i1)=val1
       nshow(i1)=m3
c
       if (m3.eq.nsize) then
       call zasun (i1,nsize,
     &             valn,jn,kn,ln)
       nshow(i1)=0
       end if
c
c:3   combination (ij|kl) -> (ij|lk)
 31     ind(1)=iold
       ind(2)=jold
       ind(3)=lold
       ind(4)=kold
       j1=ind(nj)
       l1=ind(nl)
       if (symq.eq.syms) then
       if (l1.gt.j1) then
       goto 41
       end if
       end if
       i1=ind(ni)
       k1=ind(nk)
c
       m3=nshow(i1)+1
       jn(m3,i1)=j1
       kn(m3,i1)=k1
       ln(m3,i1)=l1
       valn(m3,i1)=val1
       nshow(i1)=m3
c
       if (m3.eq.nsize) then
       call zasun (i1,nsize,
     &             valn,jn,kn,ln)
       nshow(i1)=0
       end if
c
c:4   combination (ij|kl) -> (ji|lk)
 41     ind(1)=jold
       ind(2)=iold
       ind(3)=lold
       ind(4)=kold
       j1=ind(nj)
       l1=ind(nl)
       if (symq.eq.syms) then
       if (l1.gt.j1) then
       goto 51
       end if
       end if
       i1=ind(ni)
       k1=ind(nk)
c
       m3=nshow(i1)+1
       jn(m3,i1)=j1
       kn(m3,i1)=k1
       ln(m3,i1)=l1
       valn(m3,i1)=val1
       nshow(i1)=m3
c
       if (m3.eq.nsize) then
       call zasun (i1,nsize,
     &             valn,jn,kn,ln)
       nshow(i1)=0
       end if
c
       end if
c
c:5   combination (ij|kl) -> (kl|ij)
 51     if (yes5.eq.1) then
       ind(1)=kold
       ind(2)=lold
       ind(3)=iold
       ind(4)=jold
       j1=ind(nj)
       l1=ind(nl)
       if (symq.eq.syms) then
       if (l1.gt.j1) then
       goto 61
       end if
       end if
       i1=ind(ni)
       k1=ind(nk)
c
       m3=nshow(i1)+1
       jn(m3,i1)=j1
       kn(m3,i1)=k1
       ln(m3,i1)=l1
       valn(m3,i1)=val1
       nshow(i1)=m3
c
       if (m3.eq.nsize) then
       call zasun (i1,nsize,
     &             valn,jn,kn,ln)
       nshow(i1)=0
       end if
       end if
c
 61     if (yes678.eq.1) then
c
c:6   combination (ij|kl) -> (lk|ij)
       ind(1)=lold
       ind(2)=kold
       ind(3)=iold
       ind(4)=jold
       j1=ind(nj)
       l1=ind(nl)
       if (symq.eq.syms) then
       if (l1.gt.j1) then
       goto 71
       end if
       end if
       i1=ind(ni)
       k1=ind(nk)
c
       m3=nshow(i1)+1
       jn(m3,i1)=j1
       kn(m3,i1)=k1
       ln(m3,i1)=l1
       valn(m3,i1)=val1
       nshow(i1)=m3
c
       if (m3.eq.nsize) then
       call zasun (i1,nsize,
     &             valn,jn,kn,ln)
       nshow(i1)=0
       end if
c
c:7   combination (ij|kl) -> (kl|ji)
 71     ind(1)=kold
       ind(2)=lold
       ind(3)=jold
       ind(4)=iold
       j1=ind(nj)
       l1=ind(nl)
       if (symq.eq.syms) then
       if (l1.gt.j1) then
       goto 81
       end if
       end if
       i1=ind(ni)
       k1=ind(nk)
c
       m3=nshow(i1)+1
       jn(m3,i1)=j1
       kn(m3,i1)=k1
       ln(m3,i1)=l1
       valn(m3,i1)=val1
       nshow(i1)=m3
c
       if (m3.eq.nsize) then
       call zasun (i1,nsize,
     &             valn,jn,kn,ln)
       nshow(i1)=0
       end if
c
c:8   combination (ij|kl) -> (lk|ji)
 81     ind(1)=lold
       ind(2)=kold
       ind(3)=jold
       ind(4)=iold
       j1=ind(nj)
       l1=ind(nl)
       if (symq.eq.syms) then
       if (l1.gt.j1) then
       goto 100
       end if
       end if
       i1=ind(ni)
       k1=ind(nk)
c
       m3=nshow(i1)+1
       jn(m3,i1)=j1
       kn(m3,i1)=k1
       ln(m3,i1)=l1
       valn(m3,i1)=val1
       nshow(i1)=m3
c
       if (m3.eq.nsize) then
       call zasun (i1,nsize,
     &             valn,jn,kn,ln)
       nshow(i1)=0
       end if
c
       end if
c
 100    indtemp=indtemp+1
c
 404    CONTINUE
 403    CONTINUE
 402    CONTINUE
 401    CONTINUE
C
c
cIV   write the rest integrals if needed
c
       do nhelp1=1,norb(symp)
       nhelp2=nshow(nhelp1)
       if (nhelp2.gt.0) then
       call zasun (nhelp1,nhelp2,
     &             valn,jn,kn,ln)
       end if
       end do
c
       return
       end
c
c     ----------------------------------------
c
       subroutine zasun  (i1,lenght,
     &                    valn,jn,kn,ln)
c
c      control routine over zasun process
c
c     i1 - number of pivot index (I)
c     lenght - number of valid integrals in block (I)
c
       integer lenght,i1
#include "reorg.fh"
       real*8 valn(1:nsize,1:mbas)
       integer jn(1:nsize,1:mbas)
       integer kn(1:nsize,1:mbas)
       integer ln(1:nsize,1:mbas)
c
       if (zrkey.eq.1) then
         call zasun_zr  (i1,lenght,
     &                   valn,jn,kn,ln)
       else
         call zasun_pck  (i1,lenght,
     &                    valn,jn,kn,ln)
       end if
c
       return
       end
c
c     ----------------------------------------
c
       subroutine zasun_zr  (i1,lenght,
     &                       valn,jn,kn,ln)
c
c     this routine write one block of 3-indices and appropriate
c     values of integrals into an opened TEMP-file
c
c     i1 - number of pivot index (I)
c     lenght - number of valid integrals in block (I)
c     this routine has also jn,kn,ln,valn
c     and stattemp and tmpnam as inputs, but they are
c     transpotred through commons  in reorg.fh
c
       implicit real*8 (a-h,o-z)
       integer lenght,i1
#include "reorg.fh"

#include "SysDef.fh"
       real*8 valn(1:nsize,1:mbas)
       integer jn(1:nsize,1:mbas)
       integer kn(1:nsize,1:mbas)
       integer ln(1:nsize,1:mbas)
c
c     help variable
c
       integer m2 ! ,iRec
c
       integer jkl(1:nsize)
       integer constj
       parameter (constj=1048576)
       integer constk
       parameter (constk=1024)
       integer f_iostat
       logical is_error
c
c*     pack indexes
c
       do m2=1,lenght
          jkl(m2)=ln(m2,i1)+constj*jn(m2,i1)
          jkl(m2)=jkl(m2)+constk*kn(m2,i1)
       end do
c
c*     open corresponding TEMP file in corresponding form
c
       if (iokey.eq.1) then
c
c      Fortran IO
c
       if (stattemp(i1).eq.0) then
c        file will be opened first time, it must be opened
c        whith the pointer at then first possition
         call molcas_binaryopen_vanilla(lunpublic,tmpnam(i1))
c         open (unit=lunpublic,
c     &         file=tmpnam(i1),
c     &         form='unformatted',
c     &         status='unknown')
         stattemp(i1)=1
c
       else
c        file was alredy used in expansion of this block, it must
c        be opened whith the pointer at the end of the file
c@#ifdef _DECAXP_
       call molcas_open_ext2(lunpublic,tmpnam(i1),'append',
     &   'unformatted',f_iostat,.false.,1,'unknown',is_error)
cvv         open (unit=lunpublic,
cvv     &         file=tmpnam(i1),
cvv     &         form='unformatted',
cvv     &         status='unknown',
cvv     &         access='append')
c@#else
c@      call molcas_binaryopen_vanilla(lunpublic,tmpnam(i1))
c         open (unit=lunpublic,
c     &         file=tmpnam(i1),
c     &         form='unformatted',
c     &         status='unknown')
c@       Do iRec = 1,nrectemp(i1)
c@         Read (lunpublic) m2
c@       End Do
c@#endif
c
       end if
c
       write (lunpublic) (valn(i,i1),i=1,lenght),
     &                   (jkl(i),i=1,lenght)
       close (lunpublic)
c
       else
c
c      MOLCAS IO
c
       call daname (lunpublic,tmpnam(i1))
       call ddafile (lunpublic,1,valn(1,i1),lenght,stattemp(i1))
       call idafile (lunpublic,1,jkl,       lenght,stattemp(i1))
       call daclos (lunpublic)
c
       end if
c
       nrectemp(i1)=nrectemp(i1)+1
       lrectemp(i1)=lenght
c
       return
       end
c
c     ----------------------------------------
c
       subroutine zasun_pck  (i1,lenght,
     &                        valn,jn,kn,ln)
c
c     this routine write one block of 3-indices and appropriate
c     values of integrals into an opened TEMP-file
c
c     i1 - number of pivot index (I)
c     lenght - number of valid integrals in block (I)
c     this routine has also jn,kn,ln,valn
c     and stattemp and tmpnam as inputs, but they are
c     transpotred through commons  in reorg.fh
c
       implicit real*8 (a-h,o-z)
       integer lenght,i1
#include "reorg.fh"

#include "SysDef.fh"
       real*8 valn(1:nsize,1:mbas)
       integer jn(1:nsize,1:mbas)
       integer kn(1:nsize,1:mbas)
       integer ln(1:nsize,1:mbas)
c
c     help variable
c
       integer m2,iRec
c
       integer jkl(1:nsize)
       integer constj
       parameter (constj=1048576)
       integer constk
       parameter (constk=1024)
c
       character*(RtoB+ItoB) pp(1:nsize),pphelp
       character*1 p1help(1:(RtoB+ItoB))
       real*8 rhelp
       integer ihelp
       equivalence (p1help(1),pphelp)
       equivalence (p1help(1),rhelp)
       equivalence (p1help(1+RtoB),ihelp)
c
c*     pack indexes and integral values
c
       do m2=1,lenght
       jkl(m2)=ln(m2,i1)+constj*jn(m2,i1)
       end do
       do m2=1,lenght
       jkl(m2)=jkl(m2)+constk*kn(m2,i1)
       end do
c
       do m2=1,lenght
       rhelp=valn(m2,i1)
       ihelp=jkl(m2)
       pp(m2)=pphelp
       end do
c
c*     open corresponding TEMP file in corresponding form
c
       if (iokey.eq.1) then
c
c      Fortran IO
c
       if (stattemp(i1).eq.0) then
c        file will be opened first time, it must be opened
c        whith the pointer at then first possition
         call molcas_binaryopen_vanilla(lunpublic,tmpnam(i1))
c         open (unit=lunpublic,
c     &         file=tmpnam(i1),
c     &         form='unformatted',
c     &         status='unknown')
         stattemp(i1)=1
c
       else
c        file was alredy used in expansion of this block, it must
c        be opened whith the pointer at the end of the file
#ifdef _DECAXP_
         call molcas_open_ext2(lunpublic,tmpnam(i1),'append',
     &   'unformatted',f_iostat,.false.,1,'unknown',is_error)

c         open (unit=lunpublic,
c     &         file=tmpnam(i1),
c     &         form='unformatted',
c     &         status='unknown',
c     &         access='append')
#else
         call molcas_binaryopen_vanilla(lunpublic,tmpnam(i1))
c         open (unit=lunpublic,
c     &         file=tmpnam(i1),
c     &         form='unformatted',
c     &         status='unknown')
         Do iRec = 1,nrectemp(i1)
           Read (lunpublic) m2
         End Do
#endif
c
       end if
c
       call zashlp1 (lunpublic,pp,lenght)
       close (lunpublic)
c
       else
c
c      MOLCAS IO
c
       call daname (lunpublic,tmpnam(i1))
       call cdafile (lunpublic,1,pp,(RtoB+ItoB)*lenght,stattemp(i1))
       call daclos (lunpublic)
c
       end if
c
       nrectemp(i1)=nrectemp(i1)+1
       lrectemp(i1)=lenght
c
       return
       end
c
c     ---------
c
        subroutine zashlp1 (lunpublic,pp,lenght)

#include "SysDef.fh"
        integer lunpublic,lenght
        character*(RtoB+ItoB) pp(1:lenght)
        write (lunpublic) pp
        return
        end
c
c     ----------------------
c
       subroutine inittemp (num)
c
c     this routine initialize status matrix
c     num - number of files to be used (I)
c
       implicit real*8 (a-h,o-z)
#include "reorg.fh"
       integer num
c
c     help variables
c
       integer nhelp
c
       do nhelp=1,num
       stattemp(nhelp)=0
       nrectemp(nhelp)=0
       lrectemp(nhelp)=0
       end do
c
       return
       end
c
c     ----------------------
c
#ifdef _NOTUSED_
       subroutine closetemp (num)
c
c     this routine close TEMP1 - TEMPnum Temporarry files
c     This routine scratch all files
c     num - number of files to be closed (I)
c
       implicit real*8 (a-h,o-z)
#include "reorg.fh"
       integer num
c
c     help variables
c
       integer nhelp
       real*8 scal
c
       scal=0.0d0
c
       do nhelp=1,num
c
       if (iokey.eq.1) then
c      Fortran IO
         call molcas_binaryopen_vanilla(lunpublic,tmpnam(nhelp))
c         open (unit=lunpublic,file=tmpnam(nhelp),form='unformatted')
         write (lunpublic) scal
         close (lunpublic)
c
       else
c      MOLCAS IO
         call daname (lunpublic,tmpnam(nhelp))
         call daeras (lunpublic)
       end if
c
       end do
c
       return
       end
#endif
c
c     ----------------------------------------
c
       subroutine mktempanam
c
c     this routine prepare names for TEMP and files as
c     TEMP001 - TEMPmbas and store them into
c     tmpnam and tmanam arrays (mbas-maximum number of basis functions)
c
c     variables used:
c     tmp-anam - array of TEMP file names (Transported through common /tmnames/)
c     this routine (I)
c
       implicit real*8 (a-h,o-z)
#include "reorg.fh"
       integer lun,itemp,k1
c
       lun=lunpublic
       call molcas_open(lun,'TEMP000')
c       open (unit=lun,file='TEMP000')
c
       itemp=0
       do 100 k1=1,9
       itemp=itemp+1
       if (itemp.gt.mbas) goto 500
       write (lun,99) k1
 99     format (6hTEMP00,i1)
 100    continue
c
       do 200 k1=10,99
       itemp=itemp+1
       if (itemp.gt.mbas) goto 500
       write (lun,199) k1
 199    format (5hTEMP0,i2)
 200    continue
c
       do 300 k1=100,mbas
       itemp=itemp+1
       if (itemp.gt.mbas) goto 500
       write (lun,299) k1
 299    format (4hTEMP,i3)
 300    continue
c
 500    rewind (lun)
c
       do 600 itemp=1,mbas
       read (lun,599) tmpnam(itemp)
 599    format (a7)
 600    continue
c
       rewind (lun)
       write (lun,*) ' File scratched'
       close (lun)
c
       return
       end
c
c     ----------------------------------------
c
       subroutine esb_ic_1 (symp,symq,symr,syms,
     c                      Vic,dimp,dimq,dimr,dims)
c
c     this routine realize expansion of symmetry block
c     symp,symq,symr,syms <p,q|r,s>  <-> (IJ|KL), provided such integrals exists
c     It found corresponding (IJ|KL) and expand it to
c     matrix vic (np,nq,nr,ns)
c

#include "SysDef.fh"
#include "reorg.fh"
#include "ccsort.fh"
c
        integer symp,symq,symr,syms
        integer dimp,dimq,dimr,dims
               real*8 Vic(1:dimp,1:dimq,1:dimr,1:dims)
        real*8 val1
c

       integer idis13,indtemp
       integer ni,nj,nk,nl,nsi,nsj,nsk,nsl,i1,j1,k1,l1
       integer iup,ilow,jup,jlow,kup,lup,iold,jold,kold,lold
c
c     help variables
       integer yes1,yes234,yes5,yes678
       integer typp
       integer ind(1:4)
#include "tratoc.fh"
       integer INDMAX
       parameter (INDMAX=nTraBuf)
       REAL*8    TWO(INDMAX)
c
cI    get  adress
       idis13=idis(symp,symq,symr)
c
cIII.1define order of indices
c
       ni=np(symp,symq,symr)
       nj=nq(symp,symq,symr)
       nk=nr(symp,symq,symr)
       nl=ns(symp,symq,symr)
c
cIII.2def yes1-8
c
       typp=typ(symp,symq,symr)
c
c:1   combination (ij|kl) -> (ij|kl)
c     used in types: 1,2,3,4,5,6,7,8 (all)
       yes1=1
c
c:2   combination (ij|kl) -> (ji|kl)
c:3   combination (ij|kl) -> (ij|lk)
c:4   combination (ij|kl) -> (ji|lk)
c     used in types: 1,5 since 2,3,6,7 never appear
       if ((typp.eq.1).or.(typp.eq.5)) then
       yes234=1
       else
       yes234=0
       end if
c
c:5   combination (ij|kl) -> (kl|ij)
c     used in types: 1,2,3,4
       if ((typp.ge.1).and.(typp.le.4)) then
       yes5=1
       else
       yes5=0
       end if
c
c:6   combination (ij|kl) -> (lk|ij)
c:7   combination (ij|kl) -> (kl|ji)
c:8   combination (ij|kl) -> (lk|ji)
c     used in types: 1 (since 2,3 never appeard)
       if (typp.eq.1) then
       yes678=1
       else
       yes678=0
       end if
c
c
c     define NSI,NSJ,NSK,NSL
       ind(ni)=symp
       ind(nj)=symq
       ind(nk)=symr
       ind(nl)=syms
       NSI=ind(1)
       NSJ=ind(2)
       NSK=ind(3)
       NSL=ind(4)
C
       indtemp=indmax+1
       KUP=NORB(NSK)
       DO 401 KOLD=1,KUP
C
       LUP=NORB(NSL)
       IF (NSK.EQ.NSL) LUP=KOLD
       DO 402 LOLD=1,LUP
C
       ILOW=1
       IF (NSI.EQ.NSK) ILOW=KOLD
       IUP=NORB(NSI)
       DO 403 IOLD=ILOW,IUP
C
       JLOW=1
       IF (NSI.EQ.NSK.AND.IOLD.EQ.KOLD) JLOW=LOLD
       JUP=NORB(NSJ)
       IF (NSI.EQ.NSJ) JUP=IOLD
       DO 404 JOLD=JLOW,JUP
C
c
c*    read block of integrals if neccesarry
c
       if (indtemp.eq.(indmax+1)) then
       indtemp=1
c     read block
       CALL dDAFILE(LUINTM,2,TWO,INDMAX,IDIS13)
       end if
c
c*    write integrals to appropriate possitions
c
       val1=TWO(indtemp)
c
c:1   combination (ij|kl) -> (ij|kl)
c     since yes1 is always 1, if structure is skipped
       ind(1)=iold
       ind(2)=jold
       ind(3)=kold
       ind(4)=lold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimr) then
             if (l1.le.dims) then
             Vic(i1,j1,k1,l1)=val1
             end if
           end if
         end if
       end if
c
       if (yes234.eq.1) then
c
c:2   combination (ij|kl) -> (ji|kl)
       ind(1)=jold
       ind(2)=iold
       ind(3)=kold
       ind(4)=lold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimr) then
             if (l1.le.dims) then
             Vic(i1,j1,k1,l1)=val1
             end if
           end if
         end if
       end if
c
c:3   combination (ij|kl) -> (ij|lk)
       ind(1)=iold
       ind(2)=jold
       ind(3)=lold
       ind(4)=kold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimr) then
             if (l1.le.dims) then
             Vic(i1,j1,k1,l1)=val1
             end if
           end if
         end if
       end if
c
c:4   combination (ij|kl) -> (ji|lk)
       ind(1)=jold
       ind(2)=iold
       ind(3)=lold
       ind(4)=kold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimr) then
             if (l1.le.dims) then
             Vic(i1,j1,k1,l1)=val1
             end if
           end if
         end if
       end if
c
       end if
c
c:5   combination (ij|kl) -> (kl|ij)
       if (yes5.eq.1) then
       ind(1)=kold
       ind(2)=lold
       ind(3)=iold
       ind(4)=jold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimr) then
             if (l1.le.dims) then
             Vic(i1,j1,k1,l1)=val1
             end if
           end if
         end if
       end if
c
       end if
c
       if (yes678.eq.1) then
c
c:6   combination (ij|kl) -> (lk|ij)
       ind(1)=lold
       ind(2)=kold
       ind(3)=iold
       ind(4)=jold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimr) then
             if (l1.le.dims) then
             Vic(i1,j1,k1,l1)=val1
             end if
           end if
         end if
       end if
c
c:7   combination (ij|kl) -> (kl|ji)
       ind(1)=kold
       ind(2)=lold
       ind(3)=jold
       ind(4)=iold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimr) then
             if (l1.le.dims) then
             Vic(i1,j1,k1,l1)=val1
             end if
           end if
         end if
       end if
c
c:8   combination (ij|kl) -> (lk|ji)
       ind(1)=lold
       ind(2)=kold
       ind(3)=jold
       ind(4)=iold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimr) then
             if (l1.le.dims) then
             Vic(i1,j1,k1,l1)=val1
             end if
           end if
         end if
       end if
c
       end if
c
        indtemp=indtemp+1
c
 404    CONTINUE
 403    CONTINUE
 402    CONTINUE
 401    CONTINUE
C
c
       return
       end
c
c     ----------------------------------------
c
       subroutine esb_ic_2 (symp,symq,Vic,dimp,dimq,pqind)
c
c     this routine realize expansion of symmetry block
c     symp,symq,symr,syms <p,q|r,s>  <-> (IJ|KL),
c     (for case symp=symr,symq=syms)
c     provided such integrals exists
c     It found corresponding (IJ|KL) and expand it to
c     matrix vic (pr,qs)
c

#include "SysDef.fh"
#include "reorg.fh"
#include "ccsort.fh"
c
        integer symp,symq
        integer dimp,dimq
               real*8 Vic(1:(dimp*(dimp+1)/2),1:(dimq*(dimq+1)/2))
        real*8 val1
c

       integer idis13,indtemp
       integer ni,nj,nk,nl,nsi,nsj,nsk,nsl,i1,j1,k1,l1
       integer iup,ilow,jup,jlow,kup,lup,iold,jold,kold,lold
       integer pqind(1:mbas,1:mbas)
c
c     help variables
       integer i,j,maxx
       integer yes1,yes234,yes5,yes678
       integer typp
       integer ind(1:4)
#include "tratoc.fh"
       integer INDMAX
       parameter (INDMAX=nTraBuf)
       REAL*8    TWO(INDMAX)
c
cI        calc pqind
c
        if (dimp.ge.dimq) then
          maxx=dimp
        else
          maxx=dimq
        end if
c
        do i=1,maxx
        do j=1,maxx
          if (i.ge.j) then
            pqind(i,j)=i*(i-1)/2+j
          else
            pqind(i,j)=j*(j-1)/2+i
          end if
        end do
        end do
c
cII    get  adress
       idis13=idis(symp,symq,symp)
c
cIII.1define order of indices
c
       ni=np(symp,symq,symp)
       nj=nq(symp,symq,symp)
       nk=nr(symp,symq,symp)
       nl=ns(symp,symq,symp)
c
cIII.2def yes1-8
c
       typp=typ(symp,symq,symp)
c
c:1   combination (ij|kl) -> (ij|kl)
c     used in types: 1,2,3,4,5,6,7,8 (all)
       yes1=1
c
c:2   combination (ij|kl) -> (ji|kl)
c:3   combination (ij|kl) -> (ij|lk)
c:4   combination (ij|kl) -> (ji|lk)
c     used in types: 1,5 since 2,3,6,7 never appear
       if ((typp.eq.1).or.(typp.eq.5)) then
       yes234=1
       else
       yes234=0
       end if
c
c:5   combination (ij|kl) -> (kl|ij)
c     used in types: 1,2,3,4
       if ((typp.ge.1).and.(typp.le.4)) then
       yes5=1
       else
       yes5=0
       end if
c
c:6   combination (ij|kl) -> (lk|ij)
c:7   combination (ij|kl) -> (kl|ji)
c:8   combination (ij|kl) -> (lk|ji)
c     used in types: 1 (since 2,3 never appeard)
       if (typp.eq.1) then
       yes678=1
       else
       yes678=0
       end if
c
c
c     define NSI,NSJ,NSK,NSL
       ind(ni)=symp
       ind(nj)=symq
       ind(nk)=symp
       ind(nl)=symq
       NSI=ind(1)
       NSJ=ind(2)
       NSK=ind(3)
       NSL=ind(4)
C
       indtemp=indmax+1
       KUP=NORB(NSK)
       DO 401 KOLD=1,KUP
C
       LUP=NORB(NSL)
       IF (NSK.EQ.NSL) LUP=KOLD
       DO 402 LOLD=1,LUP
C
       ILOW=1
       IF (NSI.EQ.NSK) ILOW=KOLD
       IUP=NORB(NSI)
       DO 403 IOLD=ILOW,IUP
C
       JLOW=1
       IF (NSI.EQ.NSK.AND.IOLD.EQ.KOLD) JLOW=LOLD
       JUP=NORB(NSJ)
       IF (NSI.EQ.NSJ) JUP=IOLD
       DO 404 JOLD=JLOW,JUP
C
c
c*    read block of integrals if neccesarry
c
       if (indtemp.eq.(indmax+1)) then
       indtemp=1
c     read block
       CALL dDAFILE(LUINTM,2,TWO,INDMAX,IDIS13)
       end if
c
c*    write integrals to appropriate possitions
c
       val1=TWO(indtemp)
c
c:1   combination (ij|kl) -> (ij|kl)
c     since yes1 is always 1, if structure is skipped
       ind(1)=iold
       ind(2)=jold
       ind(3)=kold
       ind(4)=lold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimp) then
             if (l1.le.dimq) then
             Vic(pqind(i1,k1),pqind(j1,l1))=val1
             end if
           end if
         end if
       end if
c
       if (yes234.eq.1) then
c
c:2   combination (ij|kl) -> (ji|kl)
       ind(1)=jold
       ind(2)=iold
       ind(3)=kold
       ind(4)=lold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimp) then
             if (l1.le.dimq) then
             Vic(pqind(i1,k1),pqind(j1,l1))=val1
             end if
           end if
         end if
       end if
c
c:3   combination (ij|kl) -> (ij|lk)
       ind(1)=iold
       ind(2)=jold
       ind(3)=lold
       ind(4)=kold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimp) then
             if (l1.le.dimq) then
             Vic(pqind(i1,k1),pqind(j1,l1))=val1
             end if
           end if
         end if
       end if
c
c:4   combination (ij|kl) -> (ji|lk)
       ind(1)=jold
       ind(2)=iold
       ind(3)=lold
       ind(4)=kold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimp) then
             if (l1.le.dimq) then
             Vic(pqind(i1,k1),pqind(j1,l1))=val1
             end if
           end if
         end if
       end if
c
       end if
c
c:5   combination (ij|kl) -> (kl|ij)
       if (yes5.eq.1) then
       ind(1)=kold
       ind(2)=lold
       ind(3)=iold
       ind(4)=jold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimp) then
             if (l1.le.dimq) then
             Vic(pqind(i1,k1),pqind(j1,l1))=val1
             end if
           end if
         end if
       end if
c
       end if
c
       if (yes678.eq.1) then
c
c:6   combination (ij|kl) -> (lk|ij)
       ind(1)=lold
       ind(2)=kold
       ind(3)=iold
       ind(4)=jold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimp) then
             if (l1.le.dimq) then
             Vic(pqind(i1,k1),pqind(j1,l1))=val1
             end if
           end if
         end if
       end if
c
c:7   combination (ij|kl) -> (kl|ji)
       ind(1)=kold
       ind(2)=lold
       ind(3)=jold
       ind(4)=iold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimp) then
             if (l1.le.dimq) then
             Vic(pqind(i1,k1),pqind(j1,l1))=val1
             end if
           end if
         end if
       end if
c
c:8   combination (ij|kl) -> (lk|ji)
       ind(1)=lold
       ind(2)=kold
       ind(3)=jold
       ind(4)=iold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
       if (i1.le.dimp) then
         if (j1.le.dimq) then
           if (k1.le.dimp) then
             if (l1.le.dimq) then
             Vic(pqind(i1,k1),pqind(j1,l1))=val1
             end if
           end if
         end if
       end if
c
       end if
c
        indtemp=indtemp+1
c
 404    CONTINUE
 403    CONTINUE
 402    CONTINUE
 401    CONTINUE
C
c
       return
       end
c
c     ----------------------------------------
c
       subroutine esb_ic_3 (symp,Vic,dimp,pqind)
c
c     this routine realize expansion of symmetry block
c     symp,symq,symr,syms <p,q|r,s>  <-> (IJ|KL),
c     (for case symp=symr=symq=syms)
c     provided such integrals exists
c     It found corresponding (IJ|KL) and expand it to
c     matrix vic (prqs)
c

#include "SysDef.fh"
#include "reorg.fh"
#include "ccsort.fh"
c
           integer symp,dimp
CLD           integer symp,dimp,dimq
               real*8 Vic(1:(dimp*(dimp+1)/2)*((dimp*(dimp+1)/2)+1)/2)
        real*8 val1
c

       integer idis13,indtemp
       integer ni,nj,nk,nl,nsi,nsj,nsk,nsl,i1,j1,k1,l1
       integer iup,ilow,jup,jlow,kup,lup,iold,jold,kold,lold
       integer pqind(1:mbas,1:mbas)
c
c     help variables
       integer i,j,maxx,ik,jl,ikjl
       integer ind(1:4)
#include "tratoc.fh"
       integer INDMAX
       parameter (INDMAX=nTraBuf)
       REAL*8    TWO(INDMAX)
c
cI        calc pqind
c
CLD        if (dimp.ge.dimp) then
          maxx=dimp
CLD        else
CLD          maxx=dimq
CLD        end if
c
        do i=1,maxx
        do j=1,maxx
          if (i.ge.j) then
            pqind(i,j)=i*(i-1)/2+j
          else
            pqind(i,j)=j*(j-1)/2+i
          end if
        end do
        end do
c
cII    get  adress
       idis13=idis(symp,symp,symp)
c
cIII.1define order of indices
c
       ni=np(symp,symp,symp)
       nj=nq(symp,symp,symp)
       nk=nr(symp,symp,symp)
       nl=ns(symp,symp,symp)
c
c
c     define NSI,NSJ,NSK,NSL
       ind(ni)=symp
       ind(nj)=symp
       ind(nk)=symp
       ind(nl)=symp
       NSI=ind(1)
       NSJ=ind(2)
       NSK=ind(3)
       NSL=ind(4)
C
       indtemp=indmax+1
       KUP=NORB(NSK)
       DO 401 KOLD=1,KUP
         if (fullprint.ge.3) write (6,*) ' * K ind ',KOLD
C
       LUP=NORB(NSL)
       IF (NSK.EQ.NSL) LUP=KOLD
       DO 402 LOLD=1,LUP
         if (fullprint.ge.3) write (6,*) ' ** L ind ',LOLD
C
       ILOW=1
       IF (NSI.EQ.NSK) ILOW=KOLD
       IUP=NORB(NSI)
       DO 403 IOLD=ILOW,IUP
         if (fullprint.ge.3) write (6,*) ' *** I ind ',IOLD
C
       JLOW=1
       IF (NSI.EQ.NSK.AND.IOLD.EQ.KOLD) JLOW=LOLD
       JUP=NORB(NSJ)
       IF (NSI.EQ.NSJ) JUP=IOLD
       DO 404 JOLD=JLOW,JUP
         if (fullprint.ge.3) write (6,*) ' **** J ind ',JOLD
C
c
c*    read block of integrals if neccesarry
c
       if (indtemp.eq.(indmax+1)) then
       indtemp=1
c     read block
       CALL dDAFILE(LUINTM,2,TWO,INDMAX,IDIS13)
       end if
c
c*    write integrals to appropriate possitions
c
       val1=TWO(indtemp)
c
c:1   combination (ij|kl) -> (ij|kl)
c     since yes1 is always 1, if structure is skipped
       ind(1)=iold
       ind(2)=jold
       ind(3)=kold
       ind(4)=lold
       j1=ind(nj)
       l1=ind(nl)
       i1=ind(ni)
       k1=ind(nk)
c
c:2    def iklj
       ik=pqind(i1,k1)
       jl=pqind(j1,l1)
       if (ik.ge.jl) then
         ikjl=ik*(ik-1)/2+jl
       else
         ikjl=jl*(jl-1)/2+ik
       end if
c
       Vic(ikjl)=val1
c
c
        indtemp=indtemp+1
c
 404    CONTINUE
 403    CONTINUE
 402    CONTINUE
 401    CONTINUE
C
c
       return
       end
c
c     ----------------------------------------
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine Loc_Nat_orb(irc,Cmo,Xmo,OccN,mOrb)
!***********************************************************************
!                                                                      *
!     Purpose: compute Localized Natural Orbitals (LNOs) to be used    *
!              for instance in Effective Bond Order (EBO) analysis     *
!                                                                      *
!              The density matrix in localized MO basis is             *
!              diagonalized separately in 2 subblocks defined by the   *
!              orbitals that extend within two distinct subregions     *
!              (atoms) of the molecule.                                *
!              The gross Mulliken population of each orbital on the    *
!              atoms of the two subregions determines the splitting    *
!              of the orbitals.                                        *
!              The atoms defining the "active subregion" are specified *
!              by the user with the keyword LOCN.                      *
!              The threshold used for the orbitals splitting criterion *
!              is also required within the keyword LOCN.               *
!                                                                      *
!     Author: F. Aquilante   (Geneva, Feb. 2008)                       *
!                                                                      *
!***********************************************************************

use Localisation_globals, only: nActa, NamAct, BName, nBas, nFro, nSym, ThrSel
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: Cmo(*)
real(kind=wp), intent(inout) :: Xmo(*), OccN(*)
integer(kind=iwp), intent(in) :: mOrb(*)
integer(kind=iwp) :: i, ia, iab, ifr, iOff, iSym, isymlbl, j, ja, jb, jC, jfr, jOcc, jOff, jto, jX, jZ, k, ka, kl, km, kOff, lScr, &
                     mOx, n_KO, n_OK, nBa, nBax, nBmx, nBx, nnB, nOrbmx, nOx
character(len=len(NamAct)) :: tmp
integer(kind=iwp), allocatable :: jD(:), kD(:), lD(:)
real(kind=wp), allocatable :: C(:), CC(:), FOcc(:), S(:), Scr(:), SQ(:), Q(:), U(:), X(:), Z(:)
real(kind=r8), external :: ddot_

irc = 0

!----------------------------------------------------------------------*
!     Read the overlap matrix                                          *
!----------------------------------------------------------------------*
nnB = 0
nBmx = 0
nOrbmx = 0
do iSym=1,nSym
  nnB = nnB+nBas(iSym)*(nBas(iSym)+1)/2
  nBmx = max(nBmx,nBas(iSym))
  nOrbmx = max(nOrbmx,mOrb(iSym))
end do
call mma_allocate(jD,nBmx,label='jD')
call mma_allocate(kD,nOrbmx,label='kD')
call mma_allocate(lD,nOrbmx,label='lD')
call mma_allocate(S,nnB,label='S')
call mma_allocate(SQ,nBmx**2,label='SQ')
isymlbl = 1
call RdOne(irc,6,'Mltpl  0',1,S,isymlbl)
if (irc /= 0) return
lScr = nBmx*nOrbmx
call mma_allocate(C,lScr,label='C')
call mma_allocate(CC,lScr,label='CC')
call mma_allocate(X,lScr,label='X')
call mma_allocate(Z,lScr,label='Z')
call mma_allocate(Scr,lScr,label='Scr')
call mma_allocate(U,nOrbmx**2,label='U')
call mma_allocate(Q,nOrbmx,label='Q')
call mma_allocate(FOcc,nOrbmx,label='FOcc')

iOff = 0
jOff = 0
kOff = 0
do iSym=1,nSym

  nBa = 0
  do ia=1,nBas(iSym)
    ja = ia+iOff
    tmp = BName(ja)(1:len(tmp))
    do j=1,nActa
      if (NamAct(j) == tmp) then
        nBa = nBa+1
        jD(nBa) = ia
      end if
    end do
  end do
  do ia=1,nBa
    ifr = jOff+jD(ia)
    call dcopy_(mOrb(iSym),Xmo(ifr),nBas(iSym),C(ia),nBa)
  end do
  do ia=1,nBa
    jb = jD(ia)
    jfr = kOff+jb*(jb-1)/2+1
    jto = nBas(iSym)*(ia-1)+1
    call dcopy_(jb,S(jfr),1,SQ(jto),1)
    jto = jto+jb
    do ka=jb+1,nBas(iSym)
      iab = kOff+ka*(ka-1)/2+jb
      SQ(jto) = S(iab)
      jto = jto+1
    end do
  end do
  nBx = max(1,nBas(iSym))
  nBax = max(1,nBa)
  call DGEMM_('T','N',nBa,mOrb(iSym),nBas(iSym),One,SQ,nBx,Xmo(jOff+1),nBx,Zero,Z,nBax)
  do i=1,mOrb(iSym)
    jC = nBa*(i-1)+1
    Q(i) = ddot_(nBa,C(jC),1,Z(jC),1)**2
  end do
  n_OK = 0
  n_KO = 0
  do i=1,mOrb(iSym)
    jfr = jOff+nBas(iSym)*(i-1)+1
    if (sqrt(Q(i)) >= ThrSel) then
      jX = nBas(iSym)*n_OK+1
      call dcopy_(nBas(iSym),Xmo(jfr),1,X(jX),1)
      n_OK = n_OK+1
      kD(n_OK) = i
    else
      jZ = nBas(iSym)*n_KO+1
      call dcopy_(nBas(iSym),Xmo(jfr),1,Z(jZ),1)
      n_KO = n_KO+1
      lD(n_KO) = i
    end if
  end do
  call Square(S(kOff+1),SQ,1,nBas(iSym),nBas(iSym))
  mOx = max(1,mOrb(iSym))
  call DGEMM_('T','N',mOrb(iSym),nBas(iSym),nBas(iSym),One,Cmo(jOff+1),nBx,SQ,nBx,Zero,CC,mOx)

  call DGEMM_('N','N',mOrb(iSym),n_OK,nBas(iSym),One,CC,mOx,X,nBx,Zero,U,mOx)
  jOcc = iOff+nFro(iSym)+1
  call Get_Nat_Lorb(OccN(jOcc),FOcc,n_OK,mOrb(iSym),kD,U)
  nOx = max(1,n_OK)
  call DGEMM_('N','N',nBas(iSym),n_OK,n_OK,One,X,nBx,U,nOx,Zero,Scr,nBx)
  do i=1,n_OK
    kl = nBas(iSym)*(i-1)+1
    km = jOff+nBas(iSym)*(kD(i)-1)+1
    call dcopy_(nBas(iSym),Scr(kl),1,Xmo(km),1)
  end do

  call DGEMM_('N','N',mOrb(iSym),n_KO,nBas(iSym),One,CC,mOx,Z,nBx,Zero,U,mOx)
  call Get_Nat_Lorb(OccN(jOcc),FOcc,n_KO,mOrb(iSym),lD,U)
  nOx = max(1,n_KO)
  call DGEMM_('N','N',nBas(iSym),n_KO,n_KO,One,Z,nBx,U,nOx,Zero,Scr,nBx)
  do i=1,n_KO
    kl = nBas(iSym)*(i-1)+1
    j = lD(i)
    km = jOff+nBas(iSym)*(j-1)+1
    call dcopy_(nBas(iSym),Scr(kl),1,Xmo(km),1)
    k = jOcc+j-1
    OccN(k) = FOcc(j)
  end do
  do i=1,n_OK
    j = kD(i)
    k = jOcc+j-1
    OccN(k) = FOcc(j)
  end do

  iOff = iOff+nBas(iSym)
  jOff = jOff+nBas(iSym)*mOrb(iSym)
  kOff = kOff+nBas(iSym)*(nBas(iSym)+1)/2
end do

call mma_deallocate(jD)
call mma_deallocate(kD)
call mma_deallocate(lD)
call mma_deallocate(S)
call mma_deallocate(SQ)
call mma_deallocate(C)
call mma_deallocate(CC)
call mma_deallocate(X)
call mma_deallocate(Z)
call mma_deallocate(Scr)
call mma_deallocate(U)
call mma_deallocate(Q)
call mma_deallocate(FOcc)

return

end subroutine Loc_Nat_orb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine rtrace(N,A,B)
! removes the trace of a Real array

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N ! size of the array
real(kind=wp), intent(in) :: A(N) ! input
real(kind=wp), intent(out) :: B(N) ! output
real(kind=wp) :: AS

! compute the equal-weighted average
AS = sum(A(:))/real(N,kind=wp)
! translate each of the elements
B(:) = A(:)-AS

return

end subroutine rtrace

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine SBDIAG()

use PrintLevel, only: USUAL, VERBOSE
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use caspt2_global, only: iPrGlb
use caspt2_module, only: Cases, nASup, nInDep, nISup, nSym, PT2Method, ThrShn, ThrShs
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: iCase, iPar0, iPar1, iSym
real(kind=wp) :: CondNr, CPU

if (IPRGLB >= VERBOSE) then
  write(u6,*)
  write(u6,*) ' Find transformation matrices to eigenbasis of block-diagonal part of H0.'
  write(u6,*) ' Eliminate linear dependency. Thresholds for:'
  write(u6,'(A,G12.4)') '   Initial squared norm  :',THRSHN
  write(u6,'(A,G12.4)') '   Eigenvalue of scaled S:',THRSHS
end if

! SVC.20100904: there are now two SBDIAG versions: a replicate
! subroutine expecting replicate S and B matrices (in upper triangular
! column-wise storage) and performing transformations on each process,
! and a global array subroutine expecting S and B matrices in global
! arrays (full column-wise storage) spread over processes.  The latter
! is currently used only for cases 1 (A) and 4 (C), for which global
! array mksmat and mkbmat routines have been implemented, as these can
! grow very big with increasing size of the active space.  For now, we
! still use the replicate routines for the other cases as they have more
! modest array sizes.

if (IPRGLB >= VERBOSE) then
  write(u6,*)
  write(u6,*) ' Condition numbers are computed after diagonal scaling and after removal of'
  write(u6,*) ' linear dependency. Resulting sizes, condition numbers, and times:'
  write(u6,'(3X,A10,4A12,A9)') 'CASE(SYM)','NASUP','NISUP','NINDEP','COND NR','CPU (s)'
end if

do iCASE=1,11
  do ISYM=1,NSYM
#   ifdef _MOLCAS_MPP_
    if (IS_REAL_PAR() .and. ((ICASE == 1) .or. (ICASE == 4))) then
      call SBDIAG_MPP(ISYM,ICASE,CONDNR,CPU)
    else
#   endif
      call SBDIAG_SER(ISYM,ICASE,CONDNR,CPU)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
    if (IPRGLB >= VERBOSE) write(u6,'(3X,A6,A1,I1,A1,1X,3I12,G11.2,I9)') &
      CASES(ICASE),'(',ISYM,')',NASUP(ISYM,ICASE),NISUP(ISYM,ICASE),NINDEP(ISYM,ICASE),CONDNR,nint(CPU)

  end do
end do

! usually print info on the total number of parameters
IPAR0 = 0
IPAR1 = 0
do ICASE=1,13
  IPAR0 = IPAR0+sum(NASUP(1:NSYM,ICASE)*NISUP(1:NSYM,ICASE))
  IPAR1 = IPAR1+sum(NINDEP(1:NSYM,ICASE)*NISUP(1:NSYM,ICASE))
end do
if (IPRGLB >= USUAL) then
  write(u6,*)
  write(u6,*) ' Total nr of '//trim(PT2Method)//' parameters:'
  write(u6,'(a,i12)') '   Before reduction:',IPAR0
  write(u6,'(a,i12)') '   After  reduction:',IPAR1
end if

end subroutine SBDIAG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_Energy_Fll(irc,Delete,EMP2,EOcc,EVir,Wrk,lWrk)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: compute MP2 energy contribution using original
C              Cholesky vectors on disk for the case nBatch=1.
C
      use ChoMP2, only: LiMatij
#include "implicit.fh"
      Logical Delete
      Real*8  EOcc(*), EVir(*), Wrk(lWrk)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"

      Character*10 ThisNm
      Character*17 SecNam
      Parameter (SecNam = 'ChoMP2_Energy_Fll', ThisNm = 'Energy_Fll')

      Integer nEnrVec(8), LnT2am, LiT2am(8)
      Integer nVaJi, iVaJi(8)

      Real*8 X(0:1)
      Data X /0.0D0,1.0D0/

      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      If (nBatch .ne. 1) Then
         irc = -1
         Return
      End If

      irc = 0

C     Determine if vector files are to be deleted after use.
C     ------------------------------------------------------

      If (Delete) Then
         iClos = 3
      Else
         iClos = 2
      End If

C     Set number and type of vectors.
C     -------------------------------

      If (DecoMP2) Then
         iTyp = 2
         Call iCopy(nSym,nMP2Vec,1,nEnrVec,1)
      Else
         iTyp = 1
         Call iCopy(nSym,NumCho,1,nEnrVec,1)
      End If

C     Set (ai|bj) indices.
C     --------------------

      Call ChoMP2_Energy_GetInd(LnT2am,LiT2am,1,1)

C     Allocate memory for integrals.
C     ------------------------------

      kXaibj = 1
      kEnd0  = kXaibj + LnT2am
      lWrk0  = lWrk   - kEnd0 + 1
      If (lWrk0 .lt. 0) Then
         Call ChoMP2_Quit(SecNam,'insufficient memory','[0]')
      End If

C     Initialize MP2 energy correction.
C     ---------------------------------

      EMP2 = 0.0D0

C     Special code for ChoAlg=2:
C     compute M(ab,ij) = (ai|bj) with i<=j using level 3 BLAS.
C     For ChoAlg=1: use strictly lower triangular storage (=>
C     level 2 BLAS).
C     --------------------------------------------------------

      If (ChoAlg .eq. 2) Then ! level 3 BLAS algorithm

         kMabij = kXaibj ! rename pointer
         Call FZero(Wrk(kMabij),LnT2am) ! initialize

C        Loop over Cholesky symmetries.
C        ------------------------------

         Do iSym = 1,nSym

            Nai = nT1am(iSym)
            If (Nai.gt.0 .and. nEnrVec(iSym).gt.0) Then

C              Reserve memory for reading a single vector.
C              -------------------------------------------

               kVecai = kEnd0
               kEnd1  = kVecai + Nai
               lWrk1  = lWrk   - kEnd1 + 1

               If (lWrk1 .lt. Nai) Then
                  Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                             '[ChoAlg.2.1]')
               End If

C              Set up batch over Cholesky vectors.
C              -----------------------------------

               nVec = min(lWrk1/Nai,nEnrVec(iSym))
               If (nVec .lt. 1) Then ! should not happen
                  Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                             '[ChoAlg.2.2]')
               End If
               nBat = (nEnrVec(iSym)-1)/nVec + 1

C              Open Cholesky vector files.
C              ---------------------------

               Call ChoMP2_OpenF(1,iTyp,iSym)

C              Start vector batch loop.
C              ------------------------

               Do iBat = 1,nBat

                  If (iBat .eq. nBat) Then
                     NumVec = nEnrVec(iSym) - nVec*(nBat-1)
                  Else
                     NumVec = nVec
                  End If
                  iVec1 = nVec*(iBat-1) + 1

C                 Set up index arrays for reordered vectors.
C                 ------------------------------------------

                  nVaJi = 0
                  Do iSymi = 1,nSym
                     iSyma = MulD2h(iSymi,iSym)
                     iVaJi(iSymi) = nVaJi
                     nVaJi = nVaJi
     &                    + nVir(iSyma)*NumVec*nOcc(iSymi)
                  End Do

C                 Pointer to reordered vectors: kVec.
C                 -----------------------------------

                  kVec  = kEnd1
                  kEnd2 = kVec  + nVaJi
                  lWrk2 = lWrk  - kEnd2 + 1
                  If (lWrk2 .lt. 0) Then ! should not happen
                     Call ChoMP2_Quit(SecNam,
     &                                'Insufficient memory',
     &                                '[ChoAlg.2.3]')
                  End If

C                 Read one vector at a time and reorder.
C                 --------------------------------------

                  iVec0 = iVec1 - 1
                  Do iVec = 1,NumVec

                     iOpt = 2
                     lTot = nT1am(iSym)
                     iAdr = nT1am(iSym)*(iVec0+iVec-1) + 1
                     Call ddaFile(lUnit_F(iSym,iTyp),iOpt,
     &                            Wrk(kVecai),lTot,iAdr)

                     Do iSymi = 1,nSym
                        iSyma = MulD2h(iSymi,iSym)
                        Do i = 1,nOcc(iSymi)
                           kOff1 = kVecai
     &                           + iT1am(iSyma,iSymi)
     &                           + nVir(iSyma)*(i-1)
                           kOff2 = kVec + iVaJi(iSymi)
     &                           + nVir(iSyma)*NumVec*(i-1)
     &                           + nVir(iSyma)*(iVec-1)
                           Call dCopy_(nVir(iSyma),Wrk(kOff1),1,
     &                                Wrk(kOff2),1)
                        End Do
                     End Do

                  End Do

C                 Compute M(ab,ij) for i<=j.
C                 First do iSymi=iSymj, then iSymi<iSymj.
C                 ---------------------------------------

                  Do iSymj = 1,nSym

                     iSymb = MulD2h(iSymj,iSym)

                     If (nVir(iSymb) .gt. 0) Then

                        Do j = 1,nOcc(iSymj)
                           Do i = 1,j

                              ij = LiMatij(iSymj,iSymj,1)
     &                           + iTri(i,j)

                              kOffi = kVec + iVaJi(iSymj)
     &                              + nVir(iSymb)*NumVec*(i-1)
                              kOffj = kVec + iVaJi(iSymj)
     &                              + nVir(iSymb)*NumVec*(j-1)
                              kOffM = kMabij + LiT2am(1)
     &                              + nMatab(1)*(ij-1)
     &                              + iMatab(iSymb,iSymb)

                              Call DGEMM_('N','T',
     &                             nVir(iSymb),nVir(iSymb),NumVec,
     &                             1.0d0,Wrk(kOffi),nVir(iSymb),
     &                                   Wrk(kOffj),nVir(iSymb),
     &                             1.0D0,Wrk(kOffM),nVir(iSymb))

                           End Do
                        End Do

                        Do iSymi = 1,iSymj-1

                           iSyma  = MulD2h(iSymi,iSym)
                           iSymab = MulD2h(iSyma,iSymb)
                           iSymij = iSymab

                           If (nOcc(iSymi).gt.0 .and.
     &                         nVir(iSyma).gt.0) Then

                              Do j = 1,nOcc(iSymj)
                                 Do i = 1,nOcc(iSymi)

                                    ij = LiMatij(iSymi,iSymj,1)
     &                                 + nOcc(iSymi)*(j-1) + i

                                    kOffi = kVec + iVaJi(iSymi)
     &                                    + nVir(iSyma)*NumVec*(i-1)
                                    kOffj = kVec + iVaJi(iSymj)
     &                                    + nVir(iSymb)*NumVec*(j-1)
                                    kOffM = kMabij
     &                                    + LiT2am(iSymij)
     &                                    + nMatab(iSymab)*(ij-1)
     &                                    + iMatab(iSyma,iSymb)

                                    Call DGEMM_('N','T',
     &                                   nVir(iSyma),nVir(iSymb),NumVec,
     &                                    1.0d0,Wrk(kOffi),nVir(iSyma),
     &                                          Wrk(kOffj),nVir(iSymb),
     &                                    1.0D0,Wrk(kOffM),nVir(iSyma))

                                 End Do
                              End Do

                           End If

                        End Do
                     End If

                  End Do

               End Do

C              Close (and possibly delete) Cholesky vector files.
C              --------------------------------------------------

               Call ChoMP2_OpenF(iClos,iTyp,iSym)

            End If

         End Do ! iSym

      Else ! level 2 BLAS algorithm

C        Loop over Cholesky symmetries.
C        ------------------------------

         Do iSym = 1,nSym
            If (nT1am(iSym).gt.0 .and. nEnrVec(iSym).gt.0) Then

C              Set up Cholesky batch.
C              ----------------------

               NumVec = min(lWrk0/nT1am(iSym),nEnrVec(iSym))
               If (NumVec .lt. 1) Then
                  Call ChoMP2_Quit(SecNam,'insufficient memory','[2]')
               End IF
               nBat = (nEnrVec(iSym) - 1)/NumVec + 1

C              Open Cholesky vector file.
C              --------------------------

               Call ChoMP2_OpenF(1,iTyp,iSym)

C              Start batch loop.
C              -----------------

               Do iBat = 1,nBat

                  If (iBat .eq. nBat) Then
                     NumV = nEnrVec(iSym) - NumVec*(nBat-1)
                  Else
                     NumV = NumVec
                  End If
                  iVec1 = NumVec*(iBat-1) + 1

C                 Read vectors.
C                 -------------

                  kVec = kEnd0

                  iOpt = 2
                  lTot = nT1am(iSym)*NumV
                  iAdr = nT1am(iSym)*(iVec1 - 1) + 1
                  Call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVec),lTot,
     &                         iAdr)

C                 Compute contribution.
C                 ---------------------

                  Fac   = X(min((iBat-1),1))
                  kXint = kXaibj + LiT2am(iSym)
                  Call dGeMM_Tri('N','T',nT1am(iSym),nT1am(iSym),NumV,
     &                           1.0D0,Wrk(kVec),nT1am(iSym),
     &                           Wrk(kVec),nT1am(iSym),
     &                           Fac,Wrk(kXint),nT1am(iSym))

               End Do

C              Close (and possibly delete) Cholesky vector file.
C              -------------------------------------------------

               Call ChoMP2_OpenF(iClos,iTyp,iSym)

            End If
         End Do

      End If ! ChoAlg

C     Compute energy contribution.
C     ----------------------------

      Call ChoMP2_Energy_Contr(EMP2,EOcc,EVir,Wrk(kXaibj),
     &                         LnT2am,LiT2am,1,1)

C     Change sign on energy.
C     ----------------------

      EMP2 = -EMP2

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine o123b_cvb( &
#                    define _CALLING_
#                    include "optb_interface.fh"
                    )

use casvb_global, only: cnrm, eigval, eigvec, isaddleo, maxize, odx, odxp, ogradp, owrk, safety, signtol
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
#include "optb_interface.fh"
integer(kind=iwp) :: ioptc, nnegeig, nposeig
real(kind=wp) :: alfastart, eig, eigmn, eigmx, safety_use
real(kind=wp), external :: dnrm2_

#include "macros.fh"
unused_var(grdnrm)
unused_var(close2conv)

if (maxize) then
  nposeig = min(isaddleo,nparm)
else
  nposeig = max(nparm-isaddleo,nparm)
end if
nnegeig = nparm-nposeig

eigmx = -One
eigmn = One
if (nnegeig > 0) eigmx = eigval(nnegeig)
if (nposeig > 0) eigmn = eigval(nnegeig+1)
safety_use = safety
!do
if ((eigmx < -signtol) .and. (eigmn > signtol)) then
  alfastart = Zero
else
  alfastart = max(eigmx,-eigmn,Zero)+safety_use
end if
call getdxp_cvb(odxp,ogradp,eigval,nnegeig,nparm,alfastart)
cnrm = dnrm2_(nparm,odxp,1)
!  Increased level shift not necessary when full Hessian is calculated:
!  if (alfastart == Zero) exit
!  gnrm = dnrm2_(nparm,ogradp,1)
!  if ((cnrm <= 1.0e-15_wp) .or. (gnrm <= 1.0e-15_wp) .or. (safety_use == 1.0e-4_wp)) exit
!  ovr_dx_grad = ddot_(nparm,odxp,1,ogradp,1)/(cnrm*gnrm)
!  if (ovr_dx_grad >= 0.3_wp) exit
!  safety_use = 1.0e-4_wp
!end do

ioptc = 0
call makedx_cvb(odx,nparm,ioptc,eigvec,eigval,odxp,ogradp,owrk,.false.,nposeig,.false.,.false.,nnegeig,.false.,alfastart,eig)
dxnrm = dnrm2_(nparm,odx,1)

return

end subroutine o123b_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mktrnspn2_cvb(cvb,cvbdet)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "spinb_cvb.fh"
      dimension cvb(nvb),cvbdet(ndetvb)

      if(ip(1).ge.1)
     >  write(6,'(/,4a)')' Changing spin basis : ',
     >  spinb(kbasiscvb)(1:len_trim_cvb(spinb(kbasiscvb))),' --> ',
     >  spinb(kbasis)(1:len_trim_cvb(spinb(kbasis)))
      call str2vbc_cvb(cvb,cvbdet)
      kbasiscvb=kbasis
      nvb=nvb_cvb(kbasiscvb)
      call vb2strc_cvb(cvbdet,cvb)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DefW4abdc (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (ab|dc)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:abLen,1:cdLen)
c
c        help variables
        integer a,b,c,d,ab,dc
c
        if (aSGrp.eq.bSGrp) then
c        case (a=b|d,c)
          dc=0
          do c=1,dimc
          do d=1,dimd
          dc=dc+1
            do a=2,dima
            ab=a*(a-1)/2
            do b=1,a-1
            ab=ab+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ab,dc)
              W(b,a,c,d)=W(b,a,c,d)+Wx(ab,dc)
            end do
            end do
            do a=1,dima
            ab=a*(a+1)/2
              W(a,a,c,d)=W(a,a,c,d)+Wx(ab,dc)
            end do
          end do
          end do
c
        else
c        case (a,b|d,c)
          dc=0
          do c=1,dimc
          do d=1,dimd
          dc=dc+1
            ab=0
            do b=1,dimb
            do a=1,dima
            ab=ab+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ab,dc)
            end do
            end do
          end do
          end do
c
        end if
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(cSGrp)
        call Unused_integer(dSGrp)
      end if
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_GetInf(lnOrb,lnOcc,lnFro,lnDel,lnVir)
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: get info from conventional MP2 common blocks.

use cOrbInf, only: nDel, nExt, nFro, nOcc, nOrb, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)

lnOrb(1:nSym) = nOrb(1:nSym)
lnOcc(1:nSym) = nOcc(1:nSym)
lnFro(1:nSym) = nFro(1:nSym)
lnDel(1:nSym) = nDel(1:nSym)
lnVir(1:nSym) = nExt(1:nSym)

end subroutine ChoMP2_GetInf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This module contains procedures that need an interface
module Do_Grid

implicit none
private

public :: Do_GGL, Do_Lebedev, Do_Lobatto

contains

#define _IN_MODULE_
#include "do_ggl.F90"
#include "do_lebedev.F90"
#include "do_lobatto.F90"

end module Do_Grid

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Jose Manuel Hermida Ramon                        *
!***********************************************************************

subroutine OneOverR_Sl(Fil,Ax,Ay,Az,BoMaH,BoMaO,EEDisp,iCNum,Eint,iQ_Atoms,outxyz,Eint_Nuc)
!----------------------------------------------------------------------*
!     Jose. Modification of the OneOverR subroutine to include the     *
!     electrostatic penetration of the charge density in the           *
!     electrostatic operator of the Hamiltonian. 2011-05-30            *
!----------------------------------------------------------------------*

use qmstat_global, only: CAFieldG, CBFieldG, CFexp, Cordst, Cut_Elc, DifSlExp, FieldDamp, lMltSlC, lQuad, MxMltp, nCent, nMlt, &
                         nPart, nPol, nSlSiteC, Qsta, SlExpC, SlExpQ, SlFactC, SlPC
use Index_Functions, only: nTri3_Elem1, nTri_Elem
use Constants, only: Zero, One, Two, Three, Five
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms, iCNum
real(kind=wp), intent(out) :: Fil(nPol*nPart,3,nTri_Elem(iQ_Atoms),10), EEDisp
real(kind=wp), intent(in) :: Ax, Ay, Az, BoMaH(iQ_Atoms), BoMaO(iQ_Atoms), outxyz(3,nTri_Elem(iQ_Atoms))
real(kind=wp), intent(inout) :: Eint(nTri_Elem(iQ_Atoms),10), Eint_Nuc(iQ_Atoms)
integer(kind=iwp) :: i, ijhr, ip, j, k, nMltTemp
real(kind=wp) :: distMin, EintSl(nTri3_Elem1(MxMltp)), EintSl_Nuc, EintSlTemp, G(3), R2(5), Rab3i(5), Rab(3,5), Rg(5), Se(5), U(3,5)
logical(kind=iwp) :: lAtom, Skip

EEdisp = Zero
!----------------------------------------------------------------------*
! Compute some distances and inverted distances etc. The potential,    *
! the field and etc. and when we already have the numbers, we also do  *
! the dispersion interaction.                                          *
!----------------------------------------------------------------------*
do k=1,nTri_Elem(iQ_Atoms)
  lAtom = (k <= iQ_atoms)
  G(1) = outxyz(1,k)+Ax
  G(2) = outxyz(2,k)+Ay
  G(3) = outxyz(3,k)+Az
  do j=iCnum+1,nPart
    i = (j-1)*nCent
    ip = (j-1)*nPol
    !Below follows a lot of distances to and fro.
    Rab(:,1) = Cordst(:,i+1)-G
    Rab(:,2) = Cordst(:,i+2)-G
    Rab(:,3) = Cordst(:,i+3)-G
    Rab(:,4) = Cordst(:,i+4)-G
    Rab(:,5) = Cordst(:,i+5)-G
    R2(:) = Rab(1,:)**2+Rab(2,:)**2+Rab(3,:)**2
    Rg(:) = sqrt(R2)
    Se(:) = One/Rg
    Rab3i(:) = Se/R2
    !------------------------------------------------------------------*
    ! The dispersion interaction between QM-atoms and solvent is       *
    ! computed, with or without damping. The initial if-clause sees to *
    ! that only atom-centers are included, while bonds and virtual     *
    ! centers are ignored.                                             *
    !------------------------------------------------------------------*
    if (lAtom) call DispEnergy(EEDisp,BoMaH(k),BoMaO(k),Rg(1),Rg(2),Rg(3),Rab3i(1),Rab3i(2),Rab3i(3),k)
    U(1,:) = Rab(1,:)*Se
    U(2,:) = Rab(2,:)*Se
    U(3,:) = Rab(3,:)*Se
    !------------------------------------------------------------------*
    ! Now we wrap up the electrostatics.                               *
    !------------------------------------------------------------------*
    ! Jose. First we check if distance with at least one of the centers*
    ! of the clasical molecule is inside the Cut-off                   *
    !------------------------------------------------------------------*
    distMin = minval(Rg)
    Skip = .false.
    if (distMin <= Cut_Elc) then
      if (lQuad) then
        ! this is done because for Sl_Grad charge is L=0, dipole is L=1 and
        ! quadrupole is L=2. In QmStat they are 1, 2 and 3, respectively.
        nMltTemp = nMlt-1

        call Sl_Grad(nSlSiteC,lMltSlC,Rab,Rg,Se,SlExpC,SlFactC,SlPC,nMltTemp,SlExpQ(:,k),DifSlExp,EintSl,EintSl_Nuc,lAtom)

        !--------------------------------------------------------------*
        ! Change in the order of field gradients because subroutine    *
        ! Sl_Grad has the same order as Molcas: xx=5, xy=6, xz=7, yy=8,*
        ! yz=9 and zz=10 and we need the QmStat order: xx=5, xy=6,     *
        ! yy=7, xz=8, yz=9 and zz=10                                   *
        !--------------------------------------------------------------*
        EintSlTemp = EintSl(7)
        EintSl(7) = EintSl(8)
        EintSl(8) = EintSlTemp

        Eint(k,:) = Eint(k,:)-EintSl(:) !Check below why it is a subtraction and not a sum
        if (lAtom) Eint_Nuc(k) = Eint_Nuc(k)-EintSl_Nuc
        Skip = .true.
      else
        ! this is done because for Sl_Grad charge is L=0, dipole is L=1 and
        ! quadrupole is L=2. In QmStat they are 1, 2 and 3, respectively.
        nMltTemp = nMlt-1

        ijhr = min(nMltTemp,1)
        call Sl_Grad(nSlSiteC,lMltSlC,Rab,Rg,Se,SlExpC,SlFactC,SlPC,ijhr,SlExpQ(:,k),DifSlExp,EintSl,EintSl_Nuc,lAtom)

        Eint(k,1:4) = Eint(k,1:4)-EintSl(1:4) ! Check below why it is a subtraction and not a sum
        if (lAtom) Eint_Nuc(k) = Eint_Nuc(k)-EintSl_Nuc
      end if
    else
      !----------------------------------------------------------------*
      ! The Eint(k,1) term will below turn into the interaction between*
      ! charges on water and the MME-charges on the QM-molecule. Plus  *
      ! the interaction between the charge densities in Water and the  *
      ! charge densities in QM-Molecule when the Penetration is        *
      ! evaluated                                                      *
      !----------------------------------------------------------------*
      Eint(k,1) = -Qsta(1)*Se(2)-Qsta(2)*Se(3)-Qsta(3)*Se(4)-Qsta(4)*Se(5)+Eint(k,1)
      if (lAtom) Eint_Nuc(k) = -Qsta(1)*Se(2)-Qsta(2)*Se(3)-Qsta(3)*Se(4)-Qsta(4)*Se(5)+Eint_Nuc(k)

      ! These three terms will below turn into the interaction
      ! between water charges and the MME-dipoles on the QM-mol.
      ! Change sign of charge, change sign of vector and then we
      ! should also change sign since when a dipole interacts with
      ! a field we have a minus sign, but this minus sign we have
      ! omitted in hel; therefore this calculation gives the right
      ! number eventually.
      Eint(k,2) = -Qsta(1)*Rab(1,2)*Rab3i(2)-Qsta(2)*Rab(1,3)*Rab3i(3)-Qsta(3)*Rab(1,4)*Rab3i(4)-Qsta(4)*Rab(1,5)*Rab3i(5)+Eint(k,2)
      Eint(k,3) = -Qsta(1)*Rab(2,2)*Rab3i(2)-Qsta(2)*Rab(2,3)*Rab3i(3)-Qsta(3)*Rab(2,4)*Rab3i(4)-Qsta(4)*Rab(2,5)*Rab3i(5)+Eint(k,3)
      Eint(k,4) = -Qsta(1)*Rab(3,2)*Rab3i(2)-Qsta(2)*Rab(3,3)*Rab3i(3)-Qsta(3)*Rab(3,4)*Rab3i(4)-Qsta(4)*Rab(3,5)*Rab3i(5)+Eint(k,4)
    end if

    if (.not. Skip) then
      ! And here it is the MME-quadrupoles that are prepared.
      ! Change sign of charges, change sign two times of the
      ! vector (in effect, zero times then) and then in the
      ! energy expression for the interaction between the field
      ! vector from a charge and a quarupole there is a plus
      ! sign, so a minus is the right sign below.
      Eint(k,5) = Eint(k,5)-Qsta(1)*U(1,2)**2*Rab3i(2)-Qsta(2)*U(1,3)**2*Rab3i(3)-Qsta(3)*U(1,4)**2*Rab3i(4)- &
                  Qsta(4)*U(1,5)**2*Rab3i(5)
      Eint(k,7) = Eint(k,7)-Qsta(1)*U(2,2)**2*Rab3i(2)-Qsta(2)*U(2,3)**2*Rab3i(3)-Qsta(3)*U(2,4)**2*Rab3i(4)- &
                  Qsta(4)*U(2,5)**2*Rab3i(5)
      Eint(k,10) = Eint(k,10)-Qsta(1)*U(3,2)**2*Rab3i(2)-Qsta(2)*U(3,3)**2*Rab3i(3)-Qsta(3)*U(3,4)**2*Rab3i(4)- &
                   Qsta(4)*U(3,5)**2*Rab3i(5)
      Eint(k,6) = Eint(k,6)-Qsta(1)*U(1,2)*U(2,2)*Rab3i(2)-Qsta(2)*U(1,3)*U(2,3)*Rab3i(3)-Qsta(3)*U(1,4)*Rab3i(4)*U(2,4)- &
                  Qsta(4)*U(1,5)*Rab3i(5)*U(2,5)
      Eint(k,8) = Eint(k,8)-Qsta(1)*U(1,2)*U(3,2)*Rab3i(2)-Qsta(2)*U(1,3)*U(3,3)*Rab3i(3)-Qsta(3)*U(1,4)*Rab3i(4)*U(3,4)- &
                  Qsta(4)*U(1,5)*Rab3i(5)*U(3,5)
      Eint(k,9) = Eint(k,9)-Qsta(1)*U(3,2)*U(2,2)*Rab3i(2)-Qsta(2)*U(3,3)*U(2,3)*Rab3i(3)-Qsta(3)*U(3,4)*Rab3i(4)*U(2,4)- &
                  Qsta(4)*U(3,5)*Rab3i(5)*U(2,5)
    end if

    !------------------------------------------------------------------*
    ! And now a whole lot of grad(1/r) and higher...                   *
    !------------------------------------------------------------------*
    ! Monopoles.
    Fil(ip+1:ip+3,1,k,1) = Rab(1,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,2,k,1) = Rab(2,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,3,k,1) = Rab(3,1:3)*Rab3i(1:3)
    ! Dipole -- x-component.
    Fil(ip+1:ip+3,1,k,2) = (Three*U(1,1:3)**2-One)*Rab3i(1:3)
    Fil(ip+1:ip+3,2,k,2) = Three*U(2,1:3)*U(1,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,3,k,2) = Three*U(3,1:3)*U(1,1:3)*Rab3i(1:3)
    ! Dipole -- y-component.
    Fil(ip+1:ip+3,1,k,3) = Three*U(2,1:3)*U(1,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,2,k,3) = (Three*U(2,1:3)**2-One)*Rab3i(1:3)
    Fil(ip+1:ip+3,3,k,3) = Three*U(3,1:3)*U(2,1:3)*Rab3i(1:3)
    ! Dipole -- z-component.
    Fil(ip+1:ip+3,1,k,4) = Three*U(3,1:3)*U(1,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,2,k,4) = Three*U(3,1:3)*U(2,1:3)*Rab3i(1:3)
    Fil(ip+1:ip+3,3,k,4) = (Three*U(3,1:3)**2-One)*Rab3i(1:3)
    ! Quadrupole -- xx-component.
    Fil(ip+1:ip+3,1,k,5) = U(1,1:3)*(Five*U(1,1:3)**2-Two)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,5) = Five*U(2,1:3)*U(1,1:3)**2*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,5) = Five*U(3,1:3)*U(1,1:3)**2*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- yy-component.
    Fil(ip+1:ip+3,1,k,7) = Five*U(2,1:3)**2*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,7) = U(2,1:3)*(Five*U(2,1:3)**2-Two)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,7) = Five*U(3,1:3)*U(2,1:3)**2*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- zz-component.
    Fil(ip+1:ip+3,1,k,10) = Five*U(3,1:3)**2*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,10) = Five*U(3,1:3)**2*U(2,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,10) = U(3,1:3)*(Five*U(3,1:3)**2-Two)*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- xy-component.
    Fil(ip+1:ip+3,1,k,6) = U(2,1:3)*(Five*U(1,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,6) = U(1,1:3)*(Five*U(2,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,6) = Five*U(3,1:3)*U(2,1:3)*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- xz-component.
    Fil(ip+1:ip+3,1,k,8) = U(3,1:3)*(Five*U(1,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,8) = Five*U(3,1:3)*U(2,1:3)*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,8) = U(1,1:3)*(Five*U(3,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    ! Quadrupole -- yz-component.
    Fil(ip+1:ip+3,1,k,9) = Five*U(3,1:3)*U(2,1:3)*U(1,1:3)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,2,k,9) = U(3,1:3)*(Five*U(2,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    Fil(ip+1:ip+3,3,k,9) = U(2,1:3)*(Five*U(3,1:3)**2-One)*Rab3i(1:3)*Se(1:3)
    !------------------------------------------------------------------*
    ! If damping of the field is requested, then do it.                *
    !------------------------------------------------------------------*
    if (FieldDamp) then
      Fil(ip+1,:,k,:) = Fil(ip+1,:,k,:)*(One-exp(CAFieldG*Rg(1)))**CFexp
      Fil(ip+2,:,k,:) = Fil(ip+2,:,k,:)*(One-exp(CBFieldG*Rg(2)))**CFexp
      Fil(ip+3,:,k,:) = Fil(ip+3,:,k,:)*(One-exp(CBFieldG*Rg(3)))**CFexp
    end if
  end do
end do

return

end subroutine OneOverR_Sl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CoSys(Cent,R,xyz)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 Cent(3,3), r(3), xyz(3,2)
      Integer iComp(3)
      Logical Linear
*
      iRout=221
      iPrint=nPrint(iRout)
      Lu=6
      If (iPrint.ge.99) Then
         Call RecPrt('CoSys: Cent',' ',Cent,3,3)
      End If
*
*---- Check if linear
*
      Co=Zero
      Crap=Zero
      RR1=Zero
      RR2=Zero
      ThrAcos=1.0D-6
      Do i = 1, 3
         Co = Co + (Cent(i,1)-Cent(i,2))*(Cent(i,3)-Cent(i,2))
         RR1=RR1+(Cent(i,1)-Cent(i,2))**2
         RR2=RR2+(Cent(i,3)-Cent(i,2))**2
      End Do
      RR1=Sqrt(RR1)
      RR2=Sqrt(RR2)
      Co=Co/(RR1*RR2)
      Do i = 1, 3
         Crap = Crap + ( (Cent(i,3)-Cent(i,2))/RR2
     &     -Sign(One,Co)*(Cent(i,1)-Cent(i,2))/RR1 )**2
      End Do
      Crap=Sqrt(Crap)
      If (iPrint.ge.99) Then
         Write (6,*) 'Co=',Co
         Write (6,*) 'Crap=',Crap
      End If
      If (Crap.lt.1.0D-6) Then
         Si=Crap
         If (Co.lt.Zero) Then
            Fi=Pi-ArSin(Si)
         Else
            Fi=ArSin(Si)
         End If
      Else
         If(Co.gt.One.and.Co.lt.One+ThrAcos) Co=One
         If(Co.lt.-One.and.Co.gt.-One-ThrAcos) Co=-One
         If(Co.gt.One+ThrAcos.or.Co.lt.-One-ThrAcos) then
            Call WarningMessage(2,'Error in CoSys')
            write(6,*) 'Error in cosys: arcos(',Co,')'
            Call Abend
         End If
         Fi=ArCos(Co)
         Si=Sqrt(One-Co**2)
      End If
      If (iPrint.ge.99) Then
         Write (6,*) 'Fi,Pi=',Fi,Pi
         Write (6,*) 'Pi-Fi=',Pi-Fi
      End If
*
      Linear=Abs(Si).lt.1.0D-13
*
*---- Form reference axis
*
      RR=Zero
      Do i = 1, 3
         R(i)=Cent(i,3)-Cent(i,1)
         RR=RR+R(i)**2
      End Do
      RR=Sqrt(RR)
      If ((RR1.ge.RR2).and.(RR1.ge.RR)) Then
        Do i = 1, 3
           R(i)=Cent(i,1)-Cent(i,2)
        End Do
        RR=RR1
      Else If (RR2.ge.RR) Then
        Do i = 1, 3
           R(i)=Cent(i,3)-Cent(i,2)
        End Do
        RR=RR2
      End If
      Call DScal_(3,One/RR,R,1)
*
      If (iPrint.ge.99) Then
         Write (6,*) 'Linear=',Linear
         Write (6,*) 'RR=',RR
         Call RecPrt('R',' ',R,3,1)
      End If
*
 99   Continue
      If (Linear) Then
*
      nComp=0
      Do i = 1, 3
         If (R(i).eq.Zero) Then
            nComp=nComp+1
            iComp(nComp)=i
         End If
      End Do
*
*---- Compute the WDC B-matrix
*
      call dcopy_(6,[Zero],0,xyz,1)
      If (nComp.eq.0) Then
*        Write (*,*) ' Case nComp.eq.0'
*
         xyz(1,1)=R(1)
         xyz(2,1)=R(2)
         xyz(3,1)=-R(3)
         r12=R(1)**2+R(2)**2-R(3)**2
         r11=R(1)**2+R(2)**2+R(3)**2
         xyz(1,1)=xyz(1,1)-(r12/r11)*R(1)
         xyz(2,1)=xyz(2,1)-(r12/r11)*R(2)
         xyz(3,1)=xyz(3,1)-(r12/r11)*R(3)
         r2=Sqrt(xyz(1,1)**2+xyz(2,1)**2+xyz(3,1)**2)
         xyz(1,1)=xyz(1,1)/r2
         xyz(2,1)=xyz(2,1)/r2
         xyz(3,1)=xyz(3,1)/r2
         xyz(1,2)=R(2)*xyz(3,1)-R(3)*xyz(2,1)
         xyz(2,2)=R(3)*xyz(1,1)-R(1)*xyz(3,1)
         xyz(3,2)=R(1)*xyz(2,1)-R(2)*xyz(1,1)
         r2=Sqrt(xyz(1,2)**2+xyz(2,2)**2+xyz(3,2)**2)
         xyz(1,2)=xyz(1,2)/r2
         xyz(2,2)=xyz(2,2)/r2
         xyz(3,2)=xyz(3,2)/r2
*
      Else If (nComp.eq.1) Then
*        Write (*,*) ' Case nComp.eq.1'
*
         i=iComp(1)
         xyz(i,1)=One
         xyz(1,2)=R(2)*xyz(3,1)-R(3)*xyz(2,1)
         xyz(2,2)=R(3)*xyz(1,1)-R(1)*xyz(3,1)
         xyz(3,2)=R(1)*xyz(2,1)-R(2)*xyz(1,1)
         r2=Sqrt(xyz(1,2)**2+xyz(2,2)**2+xyz(3,2)**2)
         xyz(1,2)=xyz(1,2)/r2
         xyz(2,2)=xyz(2,2)/r2
         xyz(3,2)=xyz(3,2)/r2
*
      Else If (nComp.eq.2) Then
*        Write (*,*) ' Case nComp.eq.2'
*
         i=iComp(1)
         xyz(i,1)=One
         i=iComp(2)
         xyz(i,2)=One
*
      Else
         Call WarningMessage(2,'Error in CoSys')
         Write (Lu,*) ' CoSys: nComp.eq.3'
         Call Abend()
      End If
*
      Else     ! Non-linear
*
*        Form the cross product R12xR32
         RR=Zero
         Do i = 1, 3
            j = Mod(i,3)+1
            k = Mod(i+1,3)+1
            R21j=Cent(j,1)-Cent(j,2)
            R21k=Cent(k,1)-Cent(k,2)
            R23j=Cent(j,3)-Cent(j,2)
            R23k=Cent(k,3)-Cent(k,2)
            xyz(i,2) = R21j*R23k-R21k*R23j
            RR = RR + xyz(i,2)**2
         End Do
         If (RR.eq.Zero) Then
            Linear=.True.
            If (iPrint.ge.99) Write (6,*) 'Linear=',Linear
            Go To 99
         End If
         Call DScal_(3,One/Sqrt(RR),xyz(1,2),1)
         If (iPrint.ge.99) Write (6,*) 'RR=',RR
*
         RR=Zero
         Do i = 1, 3
            j = Mod(i,3)+1
            k = Mod(i+1,3)+1
            xyz(i,1) = xyz(j,2)*R(k)-xyz(k,2)*R(j)
            RR = RR + xyz(i,1)**2
         End Do
         Call DScal_(3,One/Sqrt(RR),xyz(1,1),1)
         If (iPrint.ge.99) Write (6,*) 'RR=',RR
         If (iPrint.ge.99) Then
            Call RecPrt('xyz',' ',xyz,3,2)
         End If
*
      End if
      If (iPrint.ge.99) Then
         Call RecPrt(' Reference Axis',' ',R,3,1)
         Call RecPrt(' Perpendicular Axes',' ',xyz,3,2)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  exp_series2
!
!> @brief  Compute the exponential of the U matrix
!> @author Ignacio Fdez. Galvan
!>
!> @details
!> Computes the exponential of an antisymmetric real matrix U through
!> a Taylor expansion of the K matrix.
!>
!> @see ::exp_series, ::exp_svd, ::exp_schur, ::exp_eig
!>
!> @param[in]     N        Size of the square matrix
!> @param[in]     No       Number of Occupied Orbitals
!> @param[in,out] U        U matrix is replaced by its exponential
!***********************************************************************

subroutine exp_series2(N,No,U)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none

integer(kind=iwp), intent(in) :: N, No
real(kind=wp), intent(inout) :: U(N,N)
integer(kind=iwp) :: i, k, Nv
real(kind=wp) :: f1, f2, f3, mval
real(kind=wp), allocatable :: cosP(:,:), mcosP(:,:), sincP(:,:), P(:,:), tmp(:,:), Uaa(:,:), Uab(:,:), Ubb(:,:)
integer(kind=iwp), parameter :: maxorder=50
real(kind=wp), parameter :: thrs = 1.0e-16_wp

if (N < 1) return
Nv = N-No
if (No*Nv < 1) then
  call unitmat(U,N)
  return
end if

! initially:
!     ( 0  0 )        ( 0  -X^T )
! U = ( X  0 ) -> A = ( X    0  )
!
! P = X^T X
!
!          (  cos(P^(1/2))         -sinc(P^(1/2))     )
! exp(A) = ( X sinc(P^(1/2))  I - X mcos(P^(1/2)) X^T )
!
! mcos(x) = (1-cos(x))/x^2

k = min(No,Nv)
call mma_allocate(P,k,k,label='P')
call mma_allocate(cosP,k,k,label='cosP')
call mma_allocate(mcosP,k,k,label='mcosP')
call mma_allocate(sincP,k,k,label='sincP')
call mma_allocate(Uaa,k,k,label='Uaa')
call mma_allocate(Uab,k,k,label='Uab')
call mma_allocate(Ubb,k,k,label='Ubb')
call mma_allocate(tmp,k,k,label='tmp')

! Most of the time No < Nv, but just in case, we select the smaller matrices to multiply
! We include the minus sign here to take care of the alternating sign in the Taylor expansions
if (No <= Nv) then
  ! P = -X^T X
  call dgemm_('T','N',No,No,Nv,-One,U(No+1,1),N,U(No+1,1),N,Zero,P,No)
else
  ! P = -X X^T
  call dgemm_('N','T',Nv,Nv,No,-One,U(No+1,1),N,U(No+1,1),N,Zero,P,Nv)
end if
call unitmat(cosP,k)  ! cos(P^(1/2))
call unitmat(sincP,k) ! sinc(P^(1/2)) = sin(P^(1/2))*P^(-1/2)
mcosP(:,:) = Zero     ! (I-cos(P^(1/2)))*P^(-1)
call unitmat(Uaa,k)
call unitmat(Uab,k)
call unitmat(Ubb,k)
Ubb(:,:) = Ubb(:,:)*Half
do i=2,maxorder,2
  f1 = One/real((i-1)*i,kind=wp)
  call dgemm_('N','N',k,k,k,f1,Uaa,k,P,k,Zero,tmp,k)
  Uaa(:,:) = tmp(:,:)
  cosP(:,:) = cosP(:,:)+Uaa(:,:)
  f2 = One/real(i*(i+1),kind=wp)
  call dgemm_('N','N',k,k,k,f2,Uab,k,P,k,Zero,tmp,k)
  Uab(:,:) = tmp(:,:)
  sincP(:,:) = sincP(:,:)+Uab(:,:)
  mval = maxval(abs(Uaa(:,:)))
  mcosP(:,:) = mcosP(:,:)+Ubb(:,:)
  if (mval < thrs) exit
  ! This is done after checking for convergence, to ensure the order of expansion is consistent
  f3 = One/real((i+1)*(i+2),kind=wp)
  call dgemm_('N','N',k,k,k,f3,Ubb,k,P,k,Zero,tmp,k)
  Ubb(:,:) = tmp(:,:)
end do
call mma_deallocate(Uaa)
call mma_deallocate(Uab)
call mma_deallocate(Ubb)
call mma_deallocate(tmp)
if (No <= Nv) then
  call mma_allocate(tmp,Nv,No,label='tmp')
  ! OO block   cos(P^(1/2))
  U(1:No,1:No) = cosP(:,:)
  ! VV block   I - X (I-cos(P^(1/2)))*P^(-1) X^T
  call dgemm_('N','N',Nv,No,No,-One,U(No+1,1),N,mcosP,No,Zero,tmp,Nv)
  call dgemm_('N','T',Nv,Nv,No,One,tmp,Nv,U(No+1,1),N,Zero,U(No+1,No+1),N)
  do i=1,Nv
    U(No+i,No+i) = U(No+i,No+i)+One
  end do
  ! VO block   X sinc(P^(1/2))
  call dgemm_('N','N',Nv,No,No,One,U(No+1,1),N,sincP,No,Zero,tmp,Nv)
  U(No+1:,1:No) = tmp(:,:)
  ! OV block   -VO^T
  U(1:No,No+1:) = -transpose(tmp(:,:))
else
  call mma_allocate(tmp,No,Nv,label='tmp')
  ! VV block   cos(P^(1/2))
  U(No+1:,No+1:) = cosP(:,:)
  ! OO block   I - X (I-cos(P^(1/2)))*P^(-1) X^T
  call dgemm_('T','N',No,Nv,Nv,-One,U(No+1,1),N,mcosP,Nv,Zero,tmp,No)
  call dgemm_('N','N',No,No,Nv,One,tmp,No,U(No+1,1),N,Zero,U(1,1),N)
  do i=1,No
    U(i,i) = U(i,i)+One
  end do
  ! OV block   -X^T sinc(P^(1/2))
  call dgemm_('T','N',No,Nv,Nv,-One,U(No+1,1),N,sincP,Nv,Zero,tmp,No)
  U(1:No,No+1:) = tmp(:,:)
  ! VO block   -OV^T
  U(No+1:,1:No) = -transpose(tmp(:,:))
end if

call mma_deallocate(P)
call mma_deallocate(cosP)
call mma_deallocate(sincP)
call mma_deallocate(mcosP)
call mma_deallocate(tmp)

end subroutine exp_series2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE CIALL(LSYM,NREF,IOCR,nIOCR,L0,L1,L2,L3,LV)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IOCR(nIOCR),L0(*),L1(*),L2(*),L3(*)
#include "integ.fh"
      DIMENSION IOC(55)
*
      IIN=0
      NREF=0
      IJJ=IV0
      KM=1
      J2(KM)=IJJ
11    KM=KM+1
      IWAY(KM)=0
12    KM1=KM-1
      IF(L0(J2(KM1)).EQ.0.OR.IWAY(KM).GE.1)GO TO 14
      J2(KM)=L0(J2(KM1))
      IWAY(KM)=1
      IOC(KM1)=0
      GO TO 20
14    IF(L1(J2(KM1)).EQ.0.OR.IWAY(KM).GE.2)GO TO 15
      J2(KM)=L1(J2(KM1))
      IWAY(KM)=2
      IOC(KM1)=1
      GO TO 20
15    IF(L2(J2(KM1)).EQ.0.OR.IWAY(KM).GE.3)GO TO 16
      J2(KM)=L2(J2(KM1))
      IWAY(KM)=3
      IOC(KM1)=1
      GO TO 20
16    IF(L3(J2(KM1)).EQ.0.OR.IWAY(KM).GE.4)GO TO 17
      J2(KM)=L3(J2(KM1))
      IWAY(KM)=4
      IOC(KM1)=2
      GO TO 20
17    KM=KM-1
      IF(KM.EQ.1)GO TO 10
      GO TO 12
20    IF(KM.NE.LN+1)GO TO 11
      NSJ=1
      DO 110 I=1,LN
      IF(I.GT.LV)GO TO 113
      IF(IOC(I).NE.0)GO TO 12
      GO TO 110
113   IF(I.GT.NIORB+LV)GO TO 114
      IF(IOC(I).NE.2)GO TO 12
      GO TO 110
114   IF(IOC(I).EQ.1)NSJ=MUL(NSJ,NSM(I))
110   CONTINUE
      IF(NSJ.NE.LSYM)GO TO 12
      NREF=NREF+1
      DO 111 I=1,LN
         IF(I.LE.NIORB+LV)GO TO 111
         IIN=IIN+1
         IF (IIN.GT.nIOCR) Then
            Write (6,*) 'CIall: IIN.GT.nIOCR'
            Write (6,*) 'IIN=',IIN
            Write (6,*) 'nIOCR=',nIOCR
            Call Abend()
         End If
         IOCR(IIN)=IOC(I)
111   CONTINUE
      GO TO 12
*
10      Continue
      RETURN
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_utils

use fmm_global_paras, only: INTK, REALK, LUPRI, Zero

implicit none
private
! Public procedures
public :: fmm_second, &
          TIMTXT, &
          fmm_quit, &
          fmm_matrix_norm, &
          fmm_distance_between_lines

contains

!-------------------------------------------------------------------------------

function fmm_second()

  implicit none
  real(REALK) :: fmm_second
  integer :: cnt, count_rate, count_max ! note default integer kind for system_clock call
  integer(INTK) :: tmp
  integer(INTK), save :: prt = 0
  integer(INTK), save :: last_count = 0

  ! VV: order changed due to a bug in NAG compiler.
  call system_clock(cnt,count_rate,count_max)

  if (prt == 0) prt = 1  ! first call to fmm_second()
  prt = -prt
  ! must check if cnt has "cycled"
  tmp = cnt
  if (prt == 1) then  ! second of a paired call to fmm_second()
    if (cnt < last_count) tmp = cnt+(count_max-last_count)
  end if
  fmm_second = real(tmp,REALK)/real(count_rate,REALK)
  last_count = cnt

end function fmm_second

!-------------------------------------------------------------------------------

subroutine TIMTXT(TEXTIN,TIMUSD,IUNIT)

  ! TIMTXT based on TIMER by TUH //900709-hjaaj

  implicit none
  character(len=*) :: TEXTIN
  character(len=6) :: AHOUR
  character(len=8) :: ASEC, AMIN
  real(REALK) :: TIMUSD
  integer(INTK) :: ISECND, IUNIT, IHOURS, MINUTE
  character(len=45) :: TEXT

  TEXT = TEXTIN

  ISECND = int(TIMUSD)
  if (ISECND >= 60) then
    MINUTE = ISECND/60
    IHOURS = MINUTE/60
    MINUTE = MINUTE-60*IHOURS
    ISECND = ISECND-3600*IHOURS-60*MINUTE
    if (IHOURS == 1) then
      AHOUR = ' hour '
    else
      AHOUR = ' hours'
    end if
    if (MINUTE == 1) then
      AMIN = ' minute '
    else
      AMIN = ' minutes'
    end if
    if (ISECND == 1) then
      ASEC = ' second '
    else
      ASEC = ' seconds'
    end if
    if (IHOURS > 0) then
      write(IUNIT,100) TEXT,IHOURS,AHOUR,MINUTE,AMIN,ISECND,ASEC
    else
      write(IUNIT,200) TEXT,MINUTE,AMIN,ISECND,ASEC
    end if
  else
    write(IUNIT,300) TEXT,TIMUSD
  end if
  return
100 format(1x,a,i4,a,i3,a,i3,a)
200 format(1x,a,i3,a,i3,a)
300 format(1x,a,f7.2,' seconds')
end subroutine TIMTXT

!-------------------------------------------------------------------------------

subroutine fmm_quit(msg)
  implicit none
  character(len=*) msg
  write(LUPRI,*) msg
  write(LUPRI,*) '>>> FATAL ERROR'
  call Abend()
end subroutine fmm_quit

!------------------------------------------------------------------------------

subroutine fmm_matrix_norm(label,matrix,ndim)

  implicit none
  character(len=*), intent(in) :: label
  integer(INTK), intent(in)    :: ndim
  real(REALK), intent(in)      :: matrix(ndim)

  integer(INTK) :: i
  real(REALK) :: norm

  norm = zero
  do i=1,ndim
    norm = norm+matrix(i)*matrix(i)
  end do
  write(LUPRI,*) 'o fmm_matrix_norm: ',label,' = ',sqrt(norm)

end subroutine fmm_matrix_norm

!------------------------------------------------------------------------------

function fmm_cross_product(a,b)

  implicit none
  real(REALK), intent(in) :: a(3), b(3)
  real(REALK) :: fmm_cross_product(3)

  fmm_cross_product(1) = a(2)*b(3)-a(3)*b(2)
  fmm_cross_product(2) = -(a(1)*b(3)-a(3)*b(1))
  fmm_cross_product(3) = a(1)*b(2)-a(2)*b(1)

end function fmm_cross_product

!-------------------------------------------------------------------------------

function fmm_distance_between_lines(p,q,ep,eq)

  implicit none
  real(REALK), intent(in) :: p(3), q(3), ep(3), eq(3)
  real(REALK) :: fmm_distance_between_lines

  real(REALK) :: d1, d2, n(3)

  n = fmm_cross_product(ep,eq)

  d1 = dot_product(p,n)
  d2 = dot_product(q,n)

  fmm_distance_between_lines = abs(d1-d2)

end function fmm_distance_between_lines

!-------------------------------------------------------------------------------

end module fmm_utils

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FOCK_m(F,BM,FI,FP,D,P,Q,FINT,IFINAL,CMO)
C
C     RASSCF program version IBM-3090: SX section
c
c     Calculation of the MCSCF fock matrix F(eq.(7) in I.J.Q.C.S14,175)
c     FP is the matrix FI+FA (FP is FA at entrance)
c     F is stored as a symmetry blocked square matrix, by columns.
c     Note that F contains all elements, also the zero elements
c     occurring when the first index is secondary.
c     F is used to construct the Brillouin elements and the first row
c     of the super-CI Hamiltonian, while FP is used as the effective
c     one-electron operator in the construction of the super-CI
c     interaction matrix.
c
C          ********** IBM-3090 MOLCAS Release: 90 02 22 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FI(*),FP(*),D(*),P(*),Q(*),FINT(*),F(*),BM(*),CMO(*)
      integer ISTSQ(8),ISTAV(8)
      real*8 ECAS0

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='FOCK    ')
#include "WrkSpc.fh"
      Logical DoActive,DoQmat,DoCholesky
      Integer ALGO
      Dimension P2reo(1)

      COMMON /CHOTODO /DoActive,DoQmat,ipQmat
      COMMON /CHLCAS  /DoCholesky,ALGO
C
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
C
C *** Cholesky section ********************
c      Call DecideOnCholesky(DoCholesky)

      ISTSQ(1)=0
      ISTAV(1)=0
      DO iSym=2,nSym
         ISTSQ(iSym) = ISTSQ(iSym-1) + nBas(iSym-1)**2
         ISTAV(iSym) = ISTAV(iSym-1) + nBas(iSym-1)*nAsh(iSym-1)
      End Do
C *****************************************


      ipFint = ip_Dummy
      ipP2reo= ip_Dummy
      If(KSDFT(1:3).ne.'SCF'.and.
     &         DFTFOCK(1:4).eq.'DIFF'.and.
     &         nac.ne.0) Then
        Call GetMem('TmpPUVX','Allo','Real',ipFint,nFint)
c       Call Get_Temp('TmpPUVX ',Work(ipFint),nFint)
        Call Get_dArray('DFT_TwoEl',Work(ipFint),nFint)
        HALFQ=0.0d0
        HALFQ1=0.0d0
        If(Exfac.ne.1.0d0) Then
          Call Get_Temp('nP2reo  ',P2reo,1)
          nP2reo=Int(P2reo(1))
          CALL GETMEM('P2_reo','ALLO','REAL',ipP2reo,nP2reo)
          Call Get_Temp('P2_reo  ',Work(ipP2reo),nP2reo)
        End If
      End If
c
c     add FI to FA to obtain FP
      CALL DAXPY_(NTOT3,1.0D0,FI,1,FP,1)
C     LOOP OVER ALL SYMMETRY BLOCKS
C
      ISTFCK=0
      ISTFP=0
      ISTD=0
      ISTBM=0
      IX1=0
      ISTZ=0
      ioffQmat=0
      E2act=0.0d0
C
* A long loop over symmetry
      DO ISYM=1,NSYM
       IX=IX1+NFRO(ISYM)
       NIO=NISH(ISYM)
       NAO=NASH(ISYM)
       NEO=NSSH(ISYM)
       NIA=NIO+NAO
       NO=NORB(ISYM)
       NO2=(NO**2+NO)/2
       CSX=0.0D0
       N1=0
       N2=0
       IF(NO.EQ.0) GO TO 90
       CALL FZERO(F(ISTFCK+1),NO**2)
c
c      first index in F is inactive
c
       IF(NIO.NE.0) THEN
        DO NP=1,NO
         DO NI=1,NIO
          N1=MAX(NP,NI)
          N2=MIN(NP,NI)
          F(ISTFCK+NO*(NP-1)+NI)=2*FP(ISTFP+(N1**2-N1)/2+N2)
         END DO
        END DO
       ENDIF
c
c      first index in F active
c
       IF(NAO.NE.0) THEN

        ISTP=ISTORP(ISYM)+1
        JSTF=ISTORD(ISYM)+1
        NUVX=(ISTORP(ISYM+1)-ISTORP(ISYM))/NAO

        If (.not.DoCholesky .or. ALGO.eq.1) Then
c
c          first compute the Q-matrix (equation (19))
c
c          Q(m,v) = sum_wxy  (m|wxy) * P(wxy,v)
c
c          P is packed in xy and pre-multiplied by 2
c                            and reordered
c
c          write(6,*) 'PUVX integrals in FOCK'
c         call wrtmat(FINT(JSTF),1,nFInt,1,nFInt)
c         write(6,*) 'two-elec density mat OR DMAT*DMAT in FOCK'
c         call wrtmat(P(ISTP),1,nFint,1,nFint)
           CALL DGEMM_('N','N',
     &                 NO,NAO,NUVX,
     &                 1.0d0,FINT(JSTF),NO,
     &                 P(ISTP),NUVX,
     &                 0.0d0,Q,NO)

        ElseIf (ALGO.eq.2) Then

c --- the Q-matrix has been already computed as Q(a,v)
c --- where a is an AO index and v is an active index
c ---
c --- Transform the 1st index to MOs (one symmetry at the time)
c ---
c ---     Q(m,v) = C(a,m) * Q(a,v)

          ipQS = ipQmat + ISTAV(iSym)
          ipMOs= 1 + ISTSQ(iSym) + nBas(iSym)*nFro(iSym)

          CALL DGEMM_('T','N',nOrb(iSym),nAsh(iSym),nBas(iSym),
     &               1.0d0,CMO(ipMOs),nBas(iSym),
     &               Work(ipQS),nBas(iSym),
     &               0.0d0,Q(1),nOrb(iSym))

          write(6,*) 'transforming the Q-matrix'

        Else

          Write(LF,*)'FOCK: illegal Cholesky parameter ALGO= ',ALGO
          call abend()

        EndIf

CGLM        call recprt('Q-mat',' ',Q(1),NO,NAO)

c
c       active-active interaction term in the RASSCF energy
c
        ECAS0=ECAS
        DO NT=1,NAO
         NTT=(NT-1)*NO+NIO+NT
         ECAS=ECAS+0.5D0*Q(NTT)
         HALFQ1=HALFQ1+0.5D0*Q(NTT)
         E2act=E2act+0.5D0*Q(NTT)
        END DO
      IF(IPRLEV.ge.DEBUG) THEN
        write(6,*) 'Two-electron contribution (Q term):', ECAS-ECAS0
      END IF
C        write(6,*) 'ECAS aft adding Q in FOCK :', ECAS
*
        If(ipFint.ne.ip_Dummy) Then
          Call GetMem('TmpQ','Allo','Real',ipQ,NAO*NO)
          If (ipP2reo.ne.ip_Dummy) Then
             CALL DGEMM_('N','N',
     &                   NO,NAO,NUVX,
     &                   1.0d0,Work(ipFint+JSTF-1),NO,
     &                   Work(ipP2reo+ISTP-1),NUVX,
     &                   0.0d0,Work(ipQ),NO)
          Else
             CALL DGEMM_('N','N',
     &                   NO,NAO,NUVX,
     &                   1.0d0,Work(ipFint+JSTF-1),NO,
     &                   P(ISTP),NUVX,
     &                   0.0d0,Work(ipQ),NO)
          End If
          Call DaXpY_(NAO*NO,1.0d0,Work(ipQ),1,Q,1)
*
          DO NT=1,NAO
            NTT=(NT-1)*NO+NIO+NT
            HALFQ=HALFQ+0.5D0*Work(ipQ+NTT-1)
          END DO
          Call GetMem('TmpQ','Free','Real',ipQ,NAO*NO)
        End If

c
c       Fock matrix
c
        NTM=0
        DO NT=1,NAO
         DO NM=1,NO
          NTM=NTM+1
          QNTM=Q(NTM)
          DO NV=1,NAO
           NVI=NV+NIO
           NTV=ITRI(MAX(NT,NV))+MIN(NT,NV)+ISTD
           NVM=ITRI(MAX(NVI,NM))+MIN(NVI,NM)+ISTFP
           QNTM=QNTM+D(NTV)*FI(NVM)
          END DO
          F(ISTFCK+NO*(NM-1)+NT+NIO)=QNTM
         END DO
        END DO
       ENDIF
c
c       The Brillouin matrix BM(pq)=F(qp)-F(pq)
c
       NPQ=ISTBM
       DO NP=NIO+1,NO
        DO NQ=1,NIA
         NPQ=NPQ+1
         BM(NPQ)=F(ISTFCK+NO*(NP-1)+NQ)-F(ISTFCK+NO*(NQ-1)+NP)
c
c        Set zeroes to BM elements corresponding to rotations not allowed
c        as controlled by the array IZROT.
c
         IF(NP.LE.NIA.AND.NQ.GT.NIO) THEN
          NT=NP-NIO
          NU=NQ-NIO
          IF(NT.LE.NU) THEN
           BM(NPQ)=0.0D0
          ELSE
           NTU=ISTZ+ITRI(NT-1)+NU
           IF(IZROT(NTU).NE.0) THEN
            BM(NPQ)=0.0D0
C            Write(LF,*)'FOCK: IZROT=1 so BLB=0 for NP,NQ=',NP,NQ
           END IF
           IF(IXSYM(IX+NP).NE.IXSYM(IX+NQ)) THEN
            BM(NPQ)=0.0D0
C            Write(LF,*)'FOCK: IXSYM=1 so BLB=0 for NP,NQ=',NP,NQ
           END IF
          ENDIF
         ENDIF
c
c        check for largest Brillouin matrix element
c
         IF(ABS(BM(NPQ)).LT.ABS(CSX)) GO TO 20
         IF(IXSYM(IX+NP).NE.IXSYM(IX+NQ)) GO TO 20
         CSX=BM(NPQ)
         N1=NQ+NFRO(ISYM)
         N2=NP+NFRO(ISYM)
 20      CONTINUE
        END DO
       END DO
c
90     CONTINUE
       ISTFCK=ISTFCK+NO**2
       ISTFP=ISTFP+NO2
       ISTD=ISTD+(NAO**2+NAO)/2
       ISTBM=ISTBM+(NIO+NAO)*(NAO+NEO)
       IX1=IX1+NBAS(ISYM)
       ISTZ=ISTZ+(NAO**2-NAO)/2
       CBLB(ISYM)=CSX
       IBLB(ISYM)=N1
       JBLB(ISYM)=N2
c
* End of long loop over symmetry
      END DO
c
      If ( iPrLev.ge.DEBUG ) then
        CASDFT_En=0.0d0
        If(KSDFT(1:3).ne.'SCF'.and.KSDFT(1:3).ne.'PAM')
     &   Call Get_dScalar('CASDFT energy',CASDFT_En)
        Write(LF,'(A,2F22.16)') ' RASSCF energy: ',
     &                  ECAS+CASDFT_En,VIA_DFT
      End If
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,'(A)')' MCSCF Fock-matrix in MO-basis'
        ipFMCSCF=1
        Do iSym=1,nSym
           nOr=nOrb(iSym)
           Call RecPrt(' ',' ',F(ipFMCSCF),nOr,nOr)
           ipFMCSCF=ipFMCSCF+nOr*nOr
        End Do
        Write(LF,'(A)')' Brillouin matrix'
        ipBM=1
        Do iSym=1,nSym
           nIs=nIsh(iSym)
           nAs=nAsh(iSym)
           nSs=nSsh(iSym)
           Call RecPrt(' ',' ',BM(ipBM),(nAs+nIs),(nAs+nSs))
           ipBM=ipBM+(nAs+nIs)*(nAs+nSs)
        End Do
      End If
C
C     Maximum BLB matrix element all symmetries
C
      CBLBM=0.0D0
      ISYMBB=0
      DO ISYM=1,NSYM
       IF(ABS(CBLB(ISYM)).LT.ABS(CBLBM)) GO TO 150
       CBLBM=CBLB(ISYM)
       IBLBM=IBLB(ISYM)
       JBLBM=JBLB(ISYM)
       ISYMBB=ISYM
 150   CONTINUE
      END DO
C
c     Calculate Fock matrix for occupied orbitals.
C
      If (iFinal.eq.1) CALL FOCKOC_m(Q,F,CMO)
C
      If(ipFint.ne.ip_Dummy) Then
        Call GetMem('TmpPUVX','Free','Real',ipFint,nFint)
      End If

      If(ipP2reo.ne.ip_Dummy) Then
        CALL GETMEM('P2_reo','FREE','REAL',ipP2reo,nP2reo)
      End If

      If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' >>> Exit Fock <<< '
         Write(LF,*)
      End If
C
      RETURN
      END

      SUBROUTINE FOCK_update(F,BM,FI,FP,D,P,Q,FINT,IFINAL,CMO)
!This subroutine is supposed to add the dft portions of the mcpdft fock
!matrix to the Fock matrix pieces that have already been built for the
!CASSCF portion.

C
C     RASSCF program version IBM-3090: SX section
c
c     Calculation of the MCSCF fock matrix F(eq.(7) in I.J.Q.C.S14,175)
c     FP is the matrix FI+FA (FP is FA at entrance)
c     F is stored as a symmetry blocked square matrix, by columns.
c     Note that F contains all elements, also the zero elements
c     occurring when the first index is secondary.
c     F is used to construct the Brillouin elements and the first row
c     of the super-CI Hamiltonian, while FP is used as the effective
c     one-electron operator in the construction of the super-CI
c     interaction matrix.
c
C          ********** IBM-3090 MOLCAS Release: 90 02 22 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FI(*),FP(*),D(*),P(*),Q(*),FINT(*),F(*),BM(*),CMO(*)
      integer ISTSQ(8),ISTAV(8),iTF

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='FOCK    ')
#include "WrkSpc.fh"
      Logical DoActive,DoQmat,DoCholesky
      Integer ALGO

      COMMON /CHOTODO /DoActive,DoQmat,ipQmat
      COMMON /CHLCAS  /DoCholesky,ALGO
C
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF

      Call Unused_real_array(BM)
      Call Unused_integer(ifinal)
      Call GetMem('fockt','ALLO','REAL',iTF,NTOT4)
      Call dcopy_(ntot4,[0d0],0,Work(iTF),1)
C
C *** Cholesky section ********************
c      Call DecideOnCholesky(DoCholesky)

      ISTSQ(1)=0
      ISTAV(1)=0
      DO iSym=2,nSym
         ISTSQ(iSym) = ISTSQ(iSym-1) + nBas(iSym-1)**2
         ISTAV(iSym) = ISTAV(iSym-1) + nBas(iSym-1)*nAsh(iSym-1)
      End Do
C *****************************************

!      Call GetMem('ONTOPT','ALLO','Real',iTEOTP,NFINT)
!      Call GetMem('ONTOPO','ALLO','Real',iOEOTP,NTOT1)
      !Read in the one- and two- electron potentials.
!      Call Get_dArray('ONTOPT',work(iTEOTP),NFINT)
!      Call Get_dArray('ONTOPO',work(iOEOTP),NTOT1)


!I think the best way forward is to construct FI, FA (MO basis) using
!the potentials (v_pqrs and V_pq) instead of the integrals.  I think we
!want to use the full 2-body density matrix and ExFac = 1.  If we have
!FI, FA, and Q, then we can use the prescription from fock.f to
!construct the Focc term (the part of the fock matrix that we want).



!******************************************************************
!
! Build the FA terms using the potentials v.
!
!******************************************************************

!      ExFac_tmp = 1.0d0
!      Call Upd_FA_m(Work(iTEOTP),FP,D,ExFac_tmp)
!Check - does this regenerate FA if the regular integrals are passed?
!FP should contain the Fock matrix contribution that we want.


!******************************************************************
!
! Build the FI terms using the potentials v and V.
!
!******************************************************************


!      iOff1 = 0
!      Do ISYM=1,NSYM
!        Do iOrb=1,norb(iSym)
!          do jOrb=1,iOrb
!should we follow the guide of ftwo.f?
!for starters, I don't seem to have all the necessary 2-body potentials,
!right?

!          end do
!        end do
!      end do


c     add FI to FA to obtain FP
      CALL DAXPY_(NTOT3,1.0D0,FI,1,FP,1)
C     LOOP OVER ALL SYMMETRY BLOCKS

      ISTFCK=0
      ISTFP=0
      ISTD=0
      ISTBM=0
      IX1=0
      ISTZ=0
      ioffQmat=0
      E2act=0.0d0
C
* A long loop over symmetry
      DO ISYM=1,NSYM
       IX=IX1+NFRO(ISYM)
       NIO=NISH(ISYM)
       NAO=NASH(ISYM)
       NEO=NSSH(ISYM)
       NIA=NIO+NAO
       NO=NORB(ISYM)
       NO2=(NO**2+NO)/2
       CSX=0.0D0
       N1=0
       N2=0
       IF(NO.EQ.0) GO TO 90
       CALL FZERO(Work(iTF-1+ISTFCK+1),NO**2)

!    First index in F is inactive

       IF(NIO.NE.0) THEN
        DO NP=1,NO
         DO NI=1,NIO
          N1=MAX(NP,NI)
          N2=MIN(NP,NI)
          Work(iTF-1+ISTFCK+NO*(NP-1)+NI)=2*FP(ISTFP+(N1**2-N1)/2+N2)
         END DO
        END DO
       ENDIF
c
c      first index in F active
c
       IF(NAO.NE.0) THEN

        ISTP=ISTORP(ISYM)+1
        JSTF=ISTORD(ISYM)+1
        NUVX=(ISTORP(ISYM+1)-ISTORP(ISYM))/NAO

        If (.not.DoCholesky .or. ALGO.eq.1) Then
c
c          first compute the Q-matrix (equation (19))
c
c          Q(m,v) = sum_wxy  (m|wxy) * P(wxy,v)
c
c          P is packed in xy and pre-multiplied by 2
c                            and reordered
c
c          write(6,*) 'PUVX integrals in FOCK'
c         call wrtmat(FINT(JSTF),1,nFInt,1,nFInt)
c         write(6,*) 'two-elec density mat OR DMAT*DMAT in FOCK'
c         call wrtmat(P(ISTP),1,nFint,1,nFint)
           CALL DGEMM_('N','N',
     &                 NO,NAO,NUVX,
     &                 1.0d0,FINT(JSTF),NO,
     &                 P(ISTP),NUVX,
     &                 0.0d0,Q,NO)


!Now Q should contain the additional 2-electron part of the fock matrix
!for mcpdft, for the active region, at least.

!We should also have contributions from terms like FI and FA, too.
!FA takes care of the 1-RDM/2e- integral terms?
!FI takes care of the one-body hamiltonian and the occ/occ and occ/act
!contributions.

!        write(*,*) 'q-matrix'
!        do i=1,nO*nAO
!          write(*,*) Q(i)
!        end do

        Else

          Write(LF,*)'FOCK: illegal Cholesky parameter ALGO= ',ALGO
          call abend()

        EndIf

        E2eP=0d0
        DO NT=1,NAO
         NTT=(NT-1)*NO+NIO+NT
         E2eP=E2eP+0.5D0*Q(NTT)
         !ECAS=ECAS+Q(NTT)
        END DO
c
c       Fock matrix
c
        NTM=0
        DO NT=1,NAO
         DO NM=1,NO
          NTM=NTM+1
          QNTM=Q(NTM)
          DO NV=1,NAO
           NVI=NV+NIO
           NTV=ITRI(MAX(NT,NV))+MIN(NT,NV)+ISTD
           NVM=ITRI(MAX(NVI,NM))+MIN(NVI,NM)+ISTFP
           QNTM=QNTM+D(NTV)*FI(NVM)
          END DO
          Work(iTF-1+ISTFCK+NO*(NM-1)+NT+NIO)=QNTM
         END DO
        END DO
       ENDIF

CGLM        call recprt('Q-mat',' ',Q(1),NO,NAO)

c
c       active-active interaction term in the RASSCF energy
c
c
* End of long loop over symmetry
90     CONTINUE
       ISTFCK=ISTFCK+NO**2
       ISTFP=ISTFP+NO2
       ISTD=ISTD+(NAO**2+NAO)/2
       ISTBM=ISTBM+(NIO+NAO)*(NAO+NEO)
       IX1=IX1+NBAS(ISYM)
       ISTZ=ISTZ+(NAO**2-NAO)/2
       CBLB(ISYM)=CSX
       IBLB(ISYM)=N1
       JBLB(ISYM)=N2
      END DO


!Now, add all components to the original Fock matrix
!      Call DAXPY_()
!      Call DAXPY_()
c
C
c     Calculate Fock matrix for occupied orbitals.
C

      If ( iPrLev.ge.DEBUG ) then
      write(6,*) 'old fock terms:'
      do i=1,Ntot4
        write(6,*) F(i)
      end do
      write(6,*) 'new fock terms to add:'
      do i=1,Ntot4
        write(6,*) Work(itF-1+i)
      end do
      call xflush(6)
      end if
      Call DAXPY_(NTOT4,1.0d0,Work(iTF),1,F,1)
!      write(*,*) 'added new fock terms to old fock matrix'
!I am going to add the Fock matrix temporarily to the Runfile.  I don't
!want to construct it again in MCLR in the case of gradients.
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,'(A)')' MCSCF Fock-matrix in MO-basis'
        ipFMCSCF=1
        Do iSym=1,nSym
           nOr=nOrb(iSym)
           Call RecPrt(' ',' ',F(ipFMCSCF),nOr,nOr)
           ipFMCSCF=ipFMCSCF+nOr*nOr
        End Do
      End If

!What happens if we divide by two?
!      Call Dscal_(ntot4,0.5d0,F,1)

!For MCLR
      Call put_dArray('Fock_PDFT',F,ntot4)

      call xflush(6)
      CALL FOCKOC_m(Q,F,CMO)
C
      Call GetMem('fockt','Free','REAL',iTF,NTOT4)
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DENS1_RPT2_CLag(CI,NCI,SGM1,NSGM1,CLag,nConf,RDMEIG,nLev)
! Purpose: Compute the 1-electron density matrix array G1.

! For the general cases, we use actual CI routine calls, and
! have to take account of orbital order.
! We will use level inices LT,LU... in these calls, but produce
! the density matrices with usual active orbital indices.
! Translation tables L2ACT and LEVEL, in caspt2_module

use Symmetry_Info, only: Mul
use sguga, only: CIS, L2ACT, SGS
use caspt2_module, only: STSym
use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
#if defined (_MOLCAS_MPP_) && ! defined (_GA_)
use Para_Info, only: Is_Real_Par, King, nProcs
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NCI, NSGM1, nConf, nLev
real(kind=wp), intent(in) :: CI(NCI), RDMEIG(NLEV,NLEV)
real(kind=wp), intent(inout) :: SGM1(NSGM1), CLag(nConf)
integer(kind=iwp) :: ID, ISSG, IST, ISTU, ISU, IT, ITASK, IU, LT, LU, NSGM, NTASKS
integer(kind=iwp), allocatable :: TASK(:,:)

! SVC20100311: set up a task table with LT,LU
! SB20190319: maybe it doesn't even make sense to parallelize the 1-RDM
nTasks = nLev**2
call mma_allocate(Task,nTasks,2,Label='TASK')

iTask = 0
! First, IL < JL pairs.
do LT=1,nLev-1
  TASK(iTask+1:iTask+nLev-LT,1) = LT
  TASK(iTask+1:iTask+nLev-LT,2) = [(LU,LU=LT+1,nLev)]
  iTask = iTask+nLev-LT
end do
! Then, IL = JL pairs.
TASK(iTask+1:iTask+nLev,1) = [(LT,LT=1,nLev)]
TASK(iTask+1:iTask+nLev,2) = [(LT,LT=1,nLev)]
iTask = iTask+nLev
! Last, IL > JL pairs.
do LT=2,nLev
  TASK(iTask+1:iTask+LT-1,1) = LT
  TASK(iTask+1:iTask+LT-1,2) = [(LU,LU=1,LT-1)]
  iTask = iTask+LT-1
end do
if (iTask /= nTasks) write(u6,*) 'ERROR nTasks'

call Init_Tsk(ID,nTasks)

! SVC20100311: BEGIN SEPARATE TASK EXECUTION
do while (Rsv_Tsk(ID,iTask))

  ! Compute SGM1 = E_UT acting on CI, with T >= U,
  ! i.e., lowering operations. These are allowed in RAS.
  LT = TASK(iTask,1)
  IST = SGS%ISM(LT)
  IT = L2ACT(LT)
  LU = Task(iTask,2)
  ISU = SGS%ISM(LU)
  IU = L2ACT(LU)
  ISTU = Mul(IST,ISU)
  ISSG = Mul(ISTU,STSYM)
  NSGM = CIS%NCSF(ISSG)
  if (NSGM == 0) cycle
  ! GETSGM2 computes E_UT acting on CI and saves it on SGM1
  call GETSGM2(LU,LT,STSYM,CI,NCI,SGM1,NSGM)
  ! Symmetry not yet
  if (ISTU == 1) CLag(1:NSGM) = CLag(1:NSGM)+RDMEIG(IT,IU)*SGM1(1:NSGM)

  ! SVC: The master node now continues to only handle task scheduling,
  !     needed to achieve better load balancing. So it exits from the task
  !      list. It has to do it here since each process gets at least one
  !      task.
# if defined (_MOLCAS_MPP_) && ! defined (_GA_)
  if (IS_REAL_PAR() .and. KING() .and. (NPROCS > 1)) exit
# endif
end do

call Free_Tsk(ID)
call mma_deallocate(Task)

return

end subroutine DENS1_RPT2_CLag

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_PrintLB()
      Use Para_Info, Only: MyRank, nProcs
      Implicit None
#include "cholesky.fh"
#include "stdalloc.fh"

      Integer i
      Integer, Allocatable:: LB(:)

      Call mma_allocate(LB,[0,nProcs-1],Label='LB')
      LB(:)=0

      LB(myRank) = nnBstRT(1)
      Call Cho_GAIGop(LB,nProcs,'+')
      Call Cho_Head('Cholesky vector dimension on each node','=',80,
     &              LuPri)
      Do i = 0,nProcs-1
         Write(LuPri,'(2X,A,I4,5X,A,I7)')
     &   'Node:',i,'Dimension:',LB(i)
      End Do

      Call mma_deallocate(LB)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Mickael G. Delcey                                *
!***********************************************************************

subroutine Preci_cho(jS,nd,rOut,nbaj,fockii,fockai,focki,focka,fock,Sgn,A_J,nScr,iAdr)
!***********************************************************************
!                                                                      *
!     This routine remplaces preciaa, preciba and precibb              *
!     in case the new Cholesky algorithm is used,                      *
!     that is if only (ii|ab) and (ia|ib) integrals were computed      *
!                                                                      *
!     The code should be slightly more efficient as the integrals      *
!     are only read once and not for each distinct element             *
!                                                                      *
!     Written by M.G. Delcey, November 2014                            *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: G1t, G2t, nA
use input_mclr, only: LuChoInt, nAsh, nBas, nIsh, nOrb, nSym
use Constants, only: One, Two, Three, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: jS, nd, nbaj, nScr
real(kind=wp), intent(inout) :: rout(*)
real(kind=wp), intent(in) :: fockii, fockai, focki(nbaj,nbaj), focka(nbaj,nbaj), fock(nbaj,nbaj), Sgn
real(kind=wp), intent(out) :: A_J(nScr)
integer(kind=iwp), intent(inout) :: iAdr
integer(kind=iwp) :: i, iAC, iBC, ijk, ilB, ip, ip1, iSym, iVB, jA, jAA, jB, jBB, jC, jCC, jD, jjA, jjB, jjC, jjD, jVert, kB, nlB, &
                     nO, nTri, nVirt, nVirt2
real(kind=wp) :: AABB, ACBB, BCBB, Factor, rDens, rDens1, rDens2, rFock

!                                                                      *
!***********************************************************************
!                                                                      *
nTri = nTri_Elem(nd)
nO = nAsh(jS)+nIsh(jS)
jVert = nOrb(jS)-nAsh(jS)-nIsh(jS)
nvirt = nOrb(jS)-nIsh(jS)
!                                                                      *
!***********************************************************************
!                                                                      *
! Integral contribution

do iJK=1,2 ! 1=coulomb, 2=exchange
  factor = -One
  if (ijK == 2) factor = Three

  ! Read integrals

  do isym=1,nsym
    nvirt2 = nBas(isym)-nIsh(isym)
    call DDAFILE(LuChoInt(1),2,A_J,nvirt2**2,iAdr)

    ! iaa

    do jC=1,nAsh(isym)
      jjC = JC+nA(iSym)
      do jD=1,nAsh(isym)
        jjD = JD+nA(iSym)
        ip1 = (jD-1)*nvirt2+jC
        aabb = A_J(ip1) ! abab if exchange
        do jA=1,nAsh(jS)
          jjA = jA+nA(jS)
          do jB=1,jA
            jjB = jB+nA(jS)
            i = nTri-iTri(nd-jA+1,nd-jB+1)+1
            if (iJK == 1) then
              rDens1 = Two*Sgn*G2t(iTri(iTri(jjC,jjD),iTri(jjB,jjA)))
            else
              rDens1 = Four*Sgn*G2t((iTri(iTri(jjB,jjD),iTri(jjC,jjA))))
            end if
            rout(i) = rout(i)+rDens1*aabb
          end do
        end do
      end do
    end do

    if (iSym == jS) then
      do jA=1,nAsh(jS)
        jAA = jA+nA(jS)
        do jB=1,jA
          jBB = jB+nA(jS)
          i = nTri-iTri(nd-jA+1,nd-jB+1)+1
          do jC=1,nAsh(jS)
            jCC = jC+nA(jS)
            iBC = (jC-1)*nvirt+jB
            BCbb = A_J(iBC) ! BbCb if exchange
            iAC = (jC-1)*nvirt+jA
            ACbb = A_J(iAC) ! AbCb if exchange
            rDens1 = -Sgn*G1t(iTri(jAA,jCC))
            rDens2 = -Sgn*G1t(iTri(jBB,jCC))
            if (jAA == jCC) rDens1 = rdens1+Sgn
            if (jBB == jCC) rDens2 = rdens2+Sgn
            rout(i) = rout(i)+Two*rdens1*factor*BCbb+Two*rdens2*factor*ACbb

          end do
        end do
      end do

      ! iba

      do jA=1,nAsh(jS)
        ip = nTri-iTri(nd-ja+1,jVert)
        do jB=1,nAsh(jS)
          rDens = -Sgn*G1t(iTri(jA+nA(jS),jB+nA(jS)))
          if (jA == jB) rDens = rdens+Sgn*Two

          ivB = (jB-1)*nvirt+nAsh(jS)
          rOut(ip+1:ip+jVert) = rOut(ip+1:ip+jVert)+Two*factor*rDens*A_J(ivB+1:ivB+jVert)
        end do
      end do

      ! ibb

      i = nTri-nTri_Elem(jVert)+1
      do kB=nAsh(jS),nvirt-1
        nlB = nvirt-kb
        ilB = kB+1+nvirt*kb
        rout(i:i+nlB-1) = rout(i:i+nlB-1)+Sgn*Four*factor*A_J(ilB:ilB+nlB*nvirt-1:nvirt)
        i = i+nlB
      end do
    end if
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Fock matrix contribution

rFock = Sgn*(Fockii+FockAi)
!MGD tmp
!if (.false.) then
do jA=1,nAsh(jS)

  ! iaa

  jAA = jA+nA(jS)
  jjA = jA+nIsh(js)
  do jB=1,JA
    jBB = jB+nA(jS)
    jjB = jB+nIsh(js)
    i = nTri-iTri(nd-jA+1,nd-jB+1)+1
    rDens = G1t(iTri(jbb,jAA))
    rout(i) = rout(i)+Sgn*(Two*rdens*Fockii+Two*(Two*Focki(jjA,jjB)+Two*FockA(jjA,jjB)-Fock(jjB,jjA)))
  end do
  rout(i) = rout(i)-Four*rFock

  ! iba

  ip = nTri-iTri(nd-ja+1,nd-nAsh(js))
  rout(ip+1:ip+jVert) = rout(ip+1:ip+jVert)+Sgn*(Four*(FockI(nO+1:nO+jVert,ja+nIsh(js))+FockA(nO+1:nO+jVert,ja+nIsh(js)))- &
                                                 Fock(nO+1:nO+jVert,ja+nIsh(js)))
end do

! ibb

i = nTri-nTri_Elem(jVert)
do kB=nIsh(jS)+nAsh(jS),nOrb(jS)-1
  rOut(i+1) = rout(i+1)-Four*rFock
  rOut(i+1:i+nOrb(jS)-kB) = rout(i+1:i+nOrb(jS)-kB)+Sgn*Four*(Focki(kB+1,kB+1:nOrb(jS))+Focka(kB+1,kB+1:nOrb(jS)))
  i = i+nOrb(jS)-kB
end do
!end if

end subroutine Preci_cho

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine newjkqpar(n1,n2,H,J,B,S)

      Implicit none
      Integer, Parameter          :: wp=selected_real_kind(p=15,r=307)
#include "stdalloc.fh"
      Integer, intent(in)           :: n1, n2
      Complex(kind=8),intent(in)   :: H(n1,n1,n2,n2)
      Complex(kind=8), intent(out) ::
     &     J( (n1-1), -(n1-1):(n1-1), (n2-1), -(n2-1):(n2-1) )
      Complex(kind=8), intent(out) ::
     &     B( (n1-1), -(n1-1):(n1-1), (n2-1), -(n2-1):(n2-1) )
      Complex(kind=8), intent(out) ::
     &     S( (n1-1), -(n1-1):(n1-1), (n2-1), -(n2-1):(n2-1) )
      ! local variables:
      Integer                       :: k1,k2,q1,q2,m1,m2,m12,i1,i2,j1,j2
      Real(kind=8)                 :: cr1,cr2,C01,C02,r1,r2,F1,F2
      Complex(kind=8)              :: cf1,cf2,c1,c2,c12,ci,cc1,cc2,
     &                                 trace_exch2
      Complex(kind=8), allocatable :: O1(:,:), W1(:,:)
      Complex(kind=8), allocatable :: O2(:,:), W2(:,:)
      Complex(kind=8), allocatable :: OO(:,:,:,:), WO(:,:,:,:)
      Complex(kind=8), allocatable :: OW(:,:,:,:), WW(:,:,:,:)
      Complex(kind=8), allocatable :: HAM(:,:,:,:)
      Real(kind=8)                 :: knm(12,0:12),dznrm2_
      External                      :: dznrm2_,trace_exch2
      Logical                       :: dbg

!-------------------------------------------
      If( (n1<1).or.(n2<1)) Return
!-------------------------------------------
      dbg=.false.
      Call mma_allocate(O1,n1,n1,'operator O1')
      Call mma_allocate(W1,n1,n1,'operator W1')
      Call mma_allocate(O2,n2,n2,'operator O2')
      Call mma_allocate(W2,n2,n2,'operator W2')
      Call set_knm( knm )
!-------------------------------------------
      J(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1))=(0.0_wp,0.0_wp)
      B(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1))=(0.0_wp,0.0_wp)
      S(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1))=(0.0_wp,0.0_wp)
      Do k1=1,n1-1
       Do q1=0,k1
        Do k2=1,n2-1
         Do q2=0,k2
          cr1=0.0_wp
          cr2=0.0_wp
          m1=0
          m2=0
          r1=0.0_wp
          r2=0.0_wp
          cf1=(0.0_wp,0.0_wp)
          cf2=(0.0_wp,0.0_wp)

          m1 =(-1)**q1
          m2 =(-1)**q2
          m12=(-1)**(q1+q2)
          c1 =cmplx(m1,0.0_wp,wp)
          c2 =cmplx(m2,0.0_wp,wp)
          c12=cmplx(m12,0.0_wp,wp)
          ci =(0.0_wp,-1.0_wp)

          ! generate the operators for site 1 and 2:
          Call ITO(n1,k1,q1,C01,O1,W1)
          Call ITO(n2,k2,q2,C02,O2,W2)

          ! compute the scaling factors for various Operators
          Call coeff_redus_sub(n1,k1,cr1)
          Call coeff_redus_sub(n2,k2,cr2)
          cc1=cmplx(1.0_wp/(cr1*C01), 0.0_wp,wp)
          cc2=cmplx(1.0_wp/(cr2*C02), 0.0_wp,wp)
          r1=C01*C01*dble(2*k1+1)/dble(n1)
          r2=C02*C02*dble(2*k2+1)/dble(n2)
          cf1=c1*cmplx(r1,0.0_wp,wp)
          cf2=c2*cmplx(r2,0.0_wp,wp)

          If (dbg) Then
             ! use the old trace_exch function
             Call mma_allocate(OO,n1,n1,n2,n2,'operator OO')
             Call mma_allocate(WO,n1,n1,n2,n2,'operator WO')
             Call mma_allocate(OW,n1,n1,n2,n2,'operator OW')
             Call mma_allocate(WW,n1,n1,n2,n2,'operator WW')

             Do i1=1,n1
              Do j1=1,n1
               Do i2=1,n2
                Do j2=1,n2
                 OO(i1,j1,i2,j2)=O1(i1,j1)*O2(i2,j2)
                 OW(i1,j1,i2,j2)=O1(i1,j1)*W2(i2,j2)
                 WO(i1,j1,i2,j2)=W1(i1,j1)*O2(i2,j2)
                 WW(i1,j1,i2,j2)=W1(i1,j1)*W2(i2,j2)
                End Do
               End Do
              End Do
             End Do
             ! find the parameters:
             ! in the Naoya's operators
             J(k1,-q1, k2,-q2) = cf1*cf2*trace_exch2(n1,n2,H,O1,O2)
             J(k1,-q1, k2, q2) = cf1*cf2*trace_exch2(n1,n2,H,O1,W2)
             J(k1, q1, k2,-q2) = cf1*cf2*trace_exch2(n1,n2,H,W1,O2)
             J(k1, q1, k2, q2) = cf1*cf2*trace_exch2(n1,n2,H,W1,W2)

             Call mma_deallocate(OO)
             Call mma_deallocate(WO)
             Call mma_deallocate(OW)
             Call mma_deallocate(WW)
          Else
             ! find the parameters:
             ! in the Naoya's operators
             J(k1,-q1, k2,-q2) = cf1*cf2*trace_exch2(n1,n2,H,O1,O2)
             J(k1,-q1, k2, q2) = cf1*cf2*trace_exch2(n1,n2,H,O1,W2)
             J(k1, q1, k2,-q2) = cf1*cf2*trace_exch2(n1,n2,H,W1,O2)
             J(k1, q1, k2, q2) = cf1*cf2*trace_exch2(n1,n2,H,W1,W2)
          End If

          ! in the Liviu operators
          B(k1,-q1, k2,-q2) = J(k1,-q1, k2,-q2)*cc1*cc2
          B(k1,-q1, k2, q2) = J(k1,-q1, k2, q2)*cc1*cc2
          B(k1, q1, k2,-q2) = J(k1, q1, k2,-q2)*cc1*cc2
          B(k1, q1, k2, q2) = J(k1, q1, k2, q2)*cc1*cc2

!         generate real parameters for Extended Stevens Operators formalism:
          If((q1>0).and.(q2>0)) Then
! BB = (Jmm + (-1)^q2 Jmp + (-1)^q1 Jpm + (-1)^(q1 + q2) Jpp);
               S(k1, q1, k2, q2) =        B( k1,-q1, k2,-q2)
     &                             + c2 * B( k1,-q1, k2, q2)
     &                             + c1 * B( k1, q1, k2,-q2)
     &                             +c12 * B( k1, q1, k2, q2)
! BC = (Jmm - (-1)^q2 Jmp + (-1)^q1 Jpm - (-1)^(q1 + q2) Jpp) (-I);
               S(k1, q1, k2,-q2) = (      B( k1,-q1, k2,-q2)
     &                             - c2 * B( k1,-q1, k2, q2)
     &                             + c1 * B( k1, q1, k2,-q2)
     &                             -c12 * B( k1, q1, k2, q2) )*ci
! CB = (Jpp + (-1)^q2 Jpm - (-1)^q1 Jmp - (-1)^(q1 + q2) Jmm) (-I);
               S(k1,-q1, k2, q2) = (      B( k1,-q1, k2,-q2)
     &                             + c2 * B( k1,-q1, k2, q2)
     &                             - c1 * B( k1, q1, k2,-q2)
     &                             -c12 * B( k1, q1, k2, q2) )*ci
! CC = (-Jpp + (-1)^q2 Jpm + (-1)^q1 Jmp - (-1)^(q1 + q2) Jmm);
               S(k1,-q1, k2,-q2) =       -B( k1,-q1, k2,-q2)
     &                             + c2 * B( k1,-q1, k2, q2)
     &                             + c1 * B( k1, q1, k2,-q2)
     &                             -c12 * B( k1, q1, k2, q2)
          Else If ((q1==0).and.(q2>0))  Then
               S(k1, q1, k2, q2) = (      B( k1, q1, k2,-q2)
     &                             + c2 * B( k1, q1, k2, q2) )
               S(k1, q1, k2,-q2) = (      B( k1, q1, k2,-q2)
     &                             - c2 * B( k1, q1, k2, q2) )*ci
          Else If ((q1>0).and.(q2==0))  Then
               S(k1, q1, k2, q2) = (      B( k1,-q1, k2, q2)
     &                             + c1 * B( k1, q1, k2, q2) )
               S(k1,-q1, k2, q2) = (      B( k1,-q1, k2, q2)
     &                             - c1 * B( k1, q1, k2, q2) )*ci
          Else If ((q1==0).and.(q2==0))  Then
               S(k1, q1, k2, q2) =        B( k1, q1, k2, q2)
          End If

         End Do
        End Do
       End Do
      End Do

      ! scale the Stevens parameters to match the ESO operators:
      Do k1=1,n1-1
       Do q1=-k1,k1
        Do k2=1,n2-1
         Do q2=-k2,k2
           F1=0.0_wp
           F2=0.0_wp
           If(k1<=12) F1=knm(k1,abs(q1))
           If(k2<=12) F2=knm(k2,abs(q2))
           S(k1,q1,k2,q2) = S(k1,q1,k2,q2)*cmplx(F1*F2,0.0_wp,wp)
         End Do
        End Do
       End Do
      End Do

      ! in case verification is needed:
      If(dbg) Then
       Call mma_allocate(HAM,n1,n1,n2,n2,'recovered HAM_S')
       Write(6,'(A)') 'Extracted exchange parameters: J(k1,q1,k2,q2):'
       Write(6,'(A)') 'using Naoya ITO:'
       Do k1=1,n1-1
        Do q1=-k1,k1
         Do k2=1,n2-1
          Do q2=-k2,k2
!           If( ABS(S(k1,q1,k2,q2)).gt.1.0e-20_wp) Then
           Write(6,'(4(A,i2),A,2ES22.13)')
     &       'J(',k1,',',q1,',',k2,',',q2,') = ',J(k1,q1,k2,q2)
!           End If
          End Do
         End Do
        End Do
       End Do
       Call recover_exch_HAM_from_Naoya_ITO(n1,n2,J,HAM)
       Write(6,'(A,ES20.10)') 'recover from Naoya Jkqkq parameters'
       Write(6,'(A,ES24.14)') 'JKQP: total difference between HAM-H=',
     &                         dznrm2_(n1*n1*n2*n2,HAM-H,1)

       Write(6,'(A)') 'Extracted exchange parameters: B(k1,q1,k2,q2):'
       Write(6,'(A)') 'using Liviu ITO:'
       Do k1=1,n1-1
        Do q1=-k1,k1
         Do k2=1,n2-1
          Do q2=-k2,k2
!           If( ABS(S(k1,q1,k2,q2)).gt.1.0e-20_wp) Then
           Write(6,'(4(A,i2),A,2ES22.13)')
     &       'B(',k1,',',q1,',',k2,',',q2,') = ',B(k1,q1,k2,q2)
!           End If
          End Do
         End Do
        End Do
       End Do
       Call recover_exch_HAM_from_Liviu_ITO(n1,n2,B,HAM)
       Write(6,'(A,ES20.10)') 'recover from Liviu Bkqkq parameters'
       Write(6,'(A,ES24.14)') 'JKQP: total difference between HAM-H=',
     &                         dznrm2_(n1*n1*n2*n2,HAM-H,1)

       Write(6,'(A)') 'Extracted exchange parameters: S(k1,q1,k2,q2):'
       Write(6,'(A)') 'using Stevens ESO:'
       Do k1=1,n1-1
        Do q1=-k1,k1
         Do k2=1,n2-1
          Do q2=-k2,k2
!           If( ABS(S(k1,q1,k2,q2)).gt.1.0e-20_wp) Then
           Write(6,'(4(A,i2),A,2ES22.13)')
     &       'S(',k1,',',q1,',',k2,',',q2,') = ',S(k1,q1,k2,q2)
!           End If
          End Do
         End Do
        End Do
       End Do
       Call recover_exch_HAM_from_Stevens_ESO(n1,n2,S,HAM)
       Write(6,'(A,ES20.10)') 'recover from Stevens Skqkq parameters'
       Write(6,'(A,ES24.14)') 'JKQP: total difference between HAM-H=',
     &                         dznrm2_(n1*n1*n2*n2,HAM-H,1)
       Call mma_deallocate(HAM)
      End If

!==================================================================
      Call mma_deallocate(O1)
      Call mma_deallocate(O2)
      Call mma_deallocate(W1)
      Call mma_deallocate(W2)


      Return
      End subroutine newjkqpar

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013,2018, Ignacio Fdez. Galvan                        *
************************************************************************
*  Find_RFO_Root
*
*> @brief
*>   Find the \f$ \alpha \f$ value for the RS-RFO family of algorithms.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Find the \f$ \alpha \f$ value that produces a given step length in the
*> RS-RFO family of algorithms. \cite Bes1998-TCA-100-265
*> This routine assumes that a larger \f$ \alpha \f$ produces a smaller step.
*>
*> Use a *regula falsi*-like method, instead of diagonalization as in eqs.
*> (16) and (20). This subroutine is designed to be used in an iterative loop.
*>
*> (\p x1, \p y1) and (\p x2, \p y2) are two \f$ \alpha \f$ and step length
*> values bracketing the desired root. If \p x2 = `0.0`, an appropriate value
*> for \p x2 will first be searched. (\p x3, \p y3) is another point between
*> \p x1 and \p x2. On output a new value for \p x3 will be suggested (and
*> the bracketing points will be updated), the surrounding loop must calculate
*> the new \p y3 value.
*>
*> @param[in,out] x1,y1     Smaller \f$ \alpha \f$ and larger step length
*> @param[in,out] x2,y2     Larger \f$ \alpha \f$ and smaller step length
*> @param[in,out] x3        Middle \f$ \alpha \f$, new value on output
*> @param[in]     y3        Step length at \p x3
*> @param[in]     Val       Desired step length value
*>
*> @see ::RS_RFO
*> @see ::RS_I_RFO
*> @see ::RS_P_RFO
************************************************************************
      SUBROUTINE Find_RFO_Root(x1,y1,x2,y2,x3,y3,Val)
      IMPLICIT NONE
#include "real.fh"
      REAL*8 x1,x2,x3,y1,y2,y3,Val,xx1,yy1,xx2,yy2
      REAL*8 new,nnew,delta,denom,coefA,coefB,coefC,discr,Thr
      PARAMETER ( Thr = 1.0D-16 )
*
*---- First, we must find a value of alpha that gives a small enough step
*
      IF (y2 .GT. Val) THEN
        y2=y3
*
*       In the first iteration, simply try with alpha+1
        IF (x2 .EQ. Zero) THEN
          new=x1+One
          x2=new
*
*       If the step is below the threshold, a bracketing pair has been found.
*       Suggest an intermediate point (with secant method, or midpoint)
        ELSE IF (y3 .LT. Val) THEN
          new=x1+(Val-y1)/(y2-y1)*(x2-x1)
          IF ((new.LE.x1).OR.(new.GE.x2)) new=Half*(x1+x2)
*
*       If it is not there yet, extrapolate using a straight line (times an
*       arbitrary factor of 1.5, to overcome systematic undershooting), and
*       update the other end point
        ELSE
*
*         If y2 is very close to y1, or actually lower, just double the step.
*         However, don't get too ambitious -- thus the min function.
*
          IF (y1-y2 .GT. Thr) THEN
            delta=Min(x2,(Val-y2)*(x1-x2)/(y1-y2))
            new=x2+1.5D0*delta
          ELSE
            new=x2+Two*(x2-x1)
          END IF
          x1=x2
          y1=y2
          x2=new
        END IF
*
*---- Once a bracketing pair has been found, we arrive here with two end points
*     (long and short), and a middle point, for which the step length has just
*     been computed
*
      ELSE
*
*       Use the midpoint (bisection) or secant (regula falsi) as safety net
*       Do this in the subinterval where the root should be
        xx1=x1
        yy1=y1
        xx2=x2
        yy2=y2
        IF (y3 .LT. Val) THEN
          xx2=x3
          yy2=y3
        ELSE
          xx1=x3
          yy1=y3
        END IF
*       If the middle point is shorter than the "short" step, something went
*       wrong, start again from 1 (signal with -1),
*       maybe now we will get a better eigenvalue to start with
        IF ((y3 .LT. y2) .AND. (y3 .GT. Val)) THEN
          x3 = -One
          RETURN
        END IF
        new=xx1+(Val-yy1)/(yy2-yy1)*(xx2-xx1)
        IF ((new.LE.xx1).OR.(new.GE.xx2)) new=Half*(xx1+xx2)
        nnew=new
*
*       Define a quadratic fitting for the 3 points
        denom=(x1-x2)*(x1-x3)*(x2-x3)
        IF (ABS(denom) .GT. Thr) THEN
          coefA=(x3*(y2-y1)+x2*(y1-y3)+x1*(y3-y2))/denom
          coefB=(x3**2*(y1-y2)+x2**2*(y3-y1)+x1**2*(y2-y3))/denom
          coefC=(x2*x3*(x2-x3)*y1+
     &           x3*x1*(x3-x1)*y2+x1*x2*(x1-x2)*y3)/denom
          discr=coefB**2-Four*coefA*(coefC-Val)
        ELSE
          discr=Zero
        END IF
*
*       Find the point between x1 and x2 where the step would be exactly Val
        IF (discr .GT. Zero) THEN
*         Choose root depending on sign of y1-y2
          IF (y1-y2 .GT. Zero) THEN
            nnew=(-coefB-SQRT(discr))/(Two*coefA)
          ELSE IF (y1-y2 .LT. Zero) THEN
            nnew=(-coefB+SQRT(discr))/(Two*coefA)
          END IF
        END IF
*       Last check: make sure the new point is in the correct interval
        IF ((nnew.GT.xx1).AND.(nnew.LT.xx2)) new=nnew
*
*       Update the end points
        x1=xx1
        y1=yy1
        x2=xx2
        y2=yy2
      END IF
*
*     Update the suggested value
      x3=new
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine reajalovy (lun,length,vector)
c
c     this routine read blank card
c     with number lun form the given possition and update pointers
c
c     lun    - Logical unit number of file, where mediate is stored (Input)
c     length - # of R8 numbers to be read  (Input)
c     vector - space, where numbers are stored after reading  (Output)

c
#include "filemgr.fh"
#include "ccsd1.fh"

#include "SysDef.fh"
c
       integer lun,length
       real*8 vector(1:1)
c
       if (iokey.eq.1) then
c      Fortran IO
       read (lun)
c
       else
c      MOLCAS IO
       call ddafile (lun,0,vector,length,daddr(lun))
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqage(f,a,b,epsabs,epsrel,key,limit,reslt,abserr,neval,ier,alist,blist,rlist,elist,iord,last)
!***begin prologue  dqage
!***date written   800101   (yymmdd)
!***revision date  830518   (yymmdd)
!***category no.  h2a1a1
!***keywords  automatic integrator, general-purpose,
!             integrand examinator, globally adaptive,
!             gauss-kronrod
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  the routine calculates an approximation result to a given
!            definite integral   i = integral of f over (a,b),
!            hopefully satisfying following claim for accuracy
!            abs(i-reslt) <= max(epsabs,epsrel*abs(i)).
!***description
!
!        computation of a definite integral
!        standard fortran subroutine
!        real*8 version
!
!        parameters
!         on entry
!            f      - real*8
!                     function subprogram defining the integrand
!                     function f(x). the actual name for f needs to be
!                     declared e x t e r n a l in the driver program.
!
!            a      - real*8
!                     lower limit of integration
!
!            b      - real*8
!                     upper limit of integration
!
!            epsabs - real*8
!                     absolute accuracy requested
!            epsrel - real*8
!                     relative accuracy requested
!                     if  epsabs <= 0
!                     and epsrel < max(50*rel.mach.acc.,0.5d-28),
!                     the routine will end with ier = 6.
!
!            key    - integer
!                     key for choice of local integration rule
!                     a gauss-kronrod pair is used with
!                          7 - 15 points if key < 2,
!                         10 - 21 points if key = 2,
!                         15 - 31 points if key = 3,
!                         20 - 41 points if key = 4,
!                         25 - 51 points if key = 5,
!                         30 - 61 points if key > 5.
!
!            limit  - integer
!                     gives an upperbound on the number of subintervals
!                     in the partition of (a,b), limit >= 1.
!
!         on return
!            reslt  - real*8
!                     approximation to the integral
!
!            abserr - real*8
!                     estimate of the modulus of the absolute error,
!                     which should equal or exceed abs(i-reslt)
!
!            neval  - integer
!                     number of integrand evaluations
!
!            ier    - integer
!                     ier = 0 normal and reliable termination of the
!                             routine. it is assumed that the requested
!                             accuracy has been achieved.
!                     ier > 0 abnormal termination of the routine
!                             the estimates for result and error are
!                             less reliable. it is assumed that the
!                             requested accuracy has not been achieved.
!            error messages
!                     ier = 1 maximum number of subdivisions allowed
!                             has been achieved. one can allow more
!                             subdivisions by increasing the value
!                             of limit.
!                             however, if this yields no improvement it
!                             is rather advised to analyze the integrand
!                             in order to determine the integration
!                             difficulties. if the position of a local
!                             difficulty can be determined(e.g.
!                             singularity, discontinuity within the
!                             interval) one will probably gain from
!                             splitting up the interval at this point
!                             and calling the integrator on the
!                             subranges. if possible, an appropriate
!                             special-purpose integrator should be used
!                             which is designed for handling the type of
!                             difficulty involved.
!                         = 2 the occurrence of roundoff error is
!                             detected, which prevents the requested
!                             tolerance from being achieved.
!                         = 3 extremely bad integrand behaviour occurs
!                             at some points of the integration
!                             interval.
!                         = 6 the input is invalid, because
!                             (epsabs <= 0 and
!                              epsrel < max(50*rel.mach.acc.,0.5d-28),
!                             reslt, abserr, neval, last, rlist(1) ,
!                             elist(1) and iord(1) are set to zero.
!                             alist(1) and blist(1) are set to a and b
!                             respectively.
!
!            alist   - real*8
!                      vector of dimension at least limit, the first
!                       last  elements of which are the left
!                      end points of the subintervals in the partition
!                      of the given integration range (a,b)
!
!            blist   - real*8
!                      vector of dimension at least limit, the first
!                       last  elements of which are the right
!                      end points of the subintervals in the partition
!                      of the given integration range (a,b)
!
!            rlist   - real*8
!                      vector of dimension at least limit, the first
!                       last  elements of which are the
!                      integral approximations on the subintervals
!
!            elist   - real*8
!                      vector of dimension at least limit, the first
!                       last  elements of which are the moduli of the
!                      absolute error estimates on the subintervals
!
!            iord    - integer
!                      vector of dimension at least limit, the first k
!                      elements of which are pointers to the
!                      error estimates over the subintervals,
!                      such that elist(iord(1)), ...,
!                      elist(iord(k)) form a decreasing sequence,
!                      with k = last if last <= (limit/2+2), and
!                      k = limit+1-last otherwise
!
!            last    - integer
!                      number of subintervals actually produced in the
!                      subdivision process
!
!***references  (none)
!***routines called  d1mach,dqk15,dqk21,dqk31,
!                    dqk41,dqk51,dqk61,dqpsrt
!***end prologue  dqage

use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
interface
  function f(x)
    import :: wp
    real(kind=wp) :: f
    real(kind=wp), intent(in) :: x
  end function f
end interface
real(kind=wp), intent(in) :: a, b, epsabs, epsrel
integer(kind=iwp), intent(in) :: key, limit
real(kind=wp), intent(out) :: reslt, abserr, alist(limit), blist(limit), rlist(limit), elist(limit)
integer(kind=iwp), intent(out) :: neval, ier, iord(limit), last
real(kind=wp) :: area, area1, area12, area2, a1, a2, b1, b2, defabs, defab1, defab2, epmach, errbnd, errmax, error1, error2, &
                 erro12, errsum, resabs, uflow
integer(kind=iwp) :: iroff1, iroff2, k, keyf, maxerr, nrmax
real(kind=wp), external :: d1mach

!  list of major variables
!  -----------------------
!
! alist     - list of left end points of all subintervals
!             considered up to now
! blist     - list of right end points of all subintervals
!             considered up to now
! rlist(i)  - approximation to the integral over
!            (alist(i),blist(i))
! elist(i)  - error estimate applying to rlist(i)
! maxerr    - pointer to the interval with largest
!             error estimate
! errmax    - elist(maxerr)
! area      - sum of the integrals over the subintervals
! errsum    - sum of the errors over the subintervals
! errbnd    - requested accuracy max(epsabs,epsrel*
!             abs(reslt))
! *****1    - variable for the left subinterval
! *****2    - variable for the right subinterval
! last      - index for subdivision
!
!
! machine dependent constants
! ---------------------------
!
! epmach  is the largest relative spacing.
! uflow  is the smallest positive magnitude.
!
!***first executable statement  dqage

epmach = d1mach(4)
uflow = d1mach(1)

! test on validity of parameters
! ------------------------------

ier = 0
neval = 0
last = 0
reslt = Zero
abserr = Zero
alist(1) = a
blist(1) = b
rlist(1) = Zero
elist(1) = Zero
iord(1) = 0
if ((epsabs <= Zero) .and. (epsrel < max(50.0_wp*epmach,5.0e-29_wp))) ier = 6
if (ier == 6) return

! first approximation to the integral
! -----------------------------------

keyf = key
if (key <= 0) keyf = 1
if (key >= 7) keyf = 6
neval = 0
if (keyf == 1) call dqk15(f,a,b,reslt,abserr,defabs,resabs)
if (keyf == 2) call dqk21(f,a,b,reslt,abserr,defabs,resabs)
if (keyf == 3) call dqk31(f,a,b,reslt,abserr,defabs,resabs)
if (keyf == 4) call dqk41(f,a,b,reslt,abserr,defabs,resabs)
if (keyf == 5) call dqk51(f,a,b,reslt,abserr,defabs,resabs)
if (keyf == 6) call dqk61(f,a,b,reslt,abserr,defabs,resabs)
last = 1
rlist(1) = reslt
elist(1) = abserr
iord(1) = 1

! test on accuracy.

errbnd = max(epsabs,epsrel*abs(reslt))
if ((abserr <= 50.0_wp*epmach*defabs) .and. (abserr > errbnd)) ier = 2
if (limit == 1) ier = 1
if ((ier /= 0) .or. ((abserr <= errbnd) .and. (abserr /= resabs)) .or. (abserr == Zero)) then
  call finish()
  return
end if

! initialization
! --------------

errmax = abserr
maxerr = 1
area = reslt
errsum = abserr
nrmax = 1
iroff1 = 0
iroff2 = 0

! main do-loop
! ------------

do last=2,limit

  ! bisect the subinterval with the largest error estimate.

  a1 = alist(maxerr)
  b1 = Half*(alist(maxerr)+blist(maxerr))
  a2 = b1
  b2 = blist(maxerr)
  if (keyf == 1) call dqk15(f,a1,b1,area1,error1,resabs,defab1)
  if (keyf == 2) call dqk21(f,a1,b1,area1,error1,resabs,defab1)
  if (keyf == 3) call dqk31(f,a1,b1,area1,error1,resabs,defab1)
  if (keyf == 4) call dqk41(f,a1,b1,area1,error1,resabs,defab1)
  if (keyf == 5) call dqk51(f,a1,b1,area1,error1,resabs,defab1)
  if (keyf == 6) call dqk61(f,a1,b1,area1,error1,resabs,defab1)
  if (keyf == 1) call dqk15(f,a2,b2,area2,error2,resabs,defab2)
  if (keyf == 2) call dqk21(f,a2,b2,area2,error2,resabs,defab2)
  if (keyf == 3) call dqk31(f,a2,b2,area2,error2,resabs,defab2)
  if (keyf == 4) call dqk41(f,a2,b2,area2,error2,resabs,defab2)
  if (keyf == 5) call dqk51(f,a2,b2,area2,error2,resabs,defab2)
  if (keyf == 6) call dqk61(f,a2,b2,area2,error2,resabs,defab2)

  ! improve previous approximations to integral
  ! and error and test for accuracy.

  neval = neval+1
  area12 = area1+area2
  erro12 = error1+error2
  errsum = errsum+erro12-errmax
  area = area+area12-rlist(maxerr)
  if ((defab1 /= error1) .and. (defab2 /= error2)) then
    if ((abs(rlist(maxerr)-area12) <= 1.0e-5_wp*abs(area12)) .and. (erro12 >= 0.99_wp*errmax)) iroff1 = iroff1+1
    if ((last > 10) .and. (erro12 > errmax)) iroff2 = iroff2+1
  end if
  rlist(maxerr) = area1
  rlist(last) = area2
  errbnd = max(epsabs,epsrel*abs(area))
  if (errsum > errbnd) then

    ! test for roundoff error and eventually set error flag.

    if ((iroff1 >= 6) .or. (iroff2 >= 20)) ier = 2

    ! set error flag in the case that the number of subintervals
    ! equals limit.

    if (last == limit) ier = 1

    ! set error flag in the case of bad integrand behaviour
    ! at a point of the integration range.

    if (max(abs(a1),abs(b2)) <= (One+100.0_wp*epmach)*(abs(a2)+1000.0_wp*uflow)) ier = 3
  end if

  ! append the newly-created intervals to the list.

  if (error2 <= error1) then
    alist(last) = a2
    blist(maxerr) = b1
    blist(last) = b2
    elist(maxerr) = error1
    elist(last) = error2
  else
    alist(maxerr) = a2
    alist(last) = a1
    blist(last) = b1
    rlist(maxerr) = area2
    rlist(last) = area1
    elist(maxerr) = error2
    elist(last) = error1
  end if

  ! call subroutine dqpsrt to maintain the descending ordering
  ! in the list of error estimates and select the subinterval
  ! with the largest error estimate (to be bisected next).

  call dqpsrt(limit,last,maxerr,errmax,elist,iord,nrmax)
  ! ***jump out of do-loop
  if ((ier /= 0) .or. (errsum <= errbnd)) exit
end do

! compute final result.
! ---------------------

reslt = Zero
do k=1,last
  reslt = reslt+rlist(k)
end do
abserr = errsum

call finish()

return

contains

subroutine finish()
  if (keyf /= 1) neval = (10*keyf+1)*(2*neval+1)
  if (keyf == 1) neval = 30*neval+15
end subroutine finish

end subroutine dqage

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine touchdepend_cvb(chr1,chr2)
      implicit real*8 (a-h,o-z)
      character*(*) chr1,chr2
#include "make_cvb.fh"

      call undepend2_cvb(chr1,chr2,2)

      iobj=0
      jobj=0
      do 100 i=1,nobj
      if(charobj(i).eq.chr1)iobj=i
      if(charobj(i).eq.chr2)jobj=i
100   continue
      if(iobj.eq.0)then
        write(6,*)' Make object not found :',chr1
        call abend_cvb()
      endif
      if(jobj.eq.0)then
        write(6,*)' Make object not found :',chr2
        call abend_cvb()
      endif
      ndep_ji=ndep_ji+1
      if(ndep_ji.gt.mxdep)then
        write(6,*)' Too many make dependencies, max :',mxdep
        call abend_cvb()
      endif
      do 200 i=joffs(nobj+1),joffs(jobj+1)+1,-1
      j_dep_on_i(i+1)=j_dep_on_i(i)
200   continue
      j_dep_on_i(joffs(jobj+1)+1)=iobj
      do 300 i=jobj+1,nobj+1
      joffs(i)=joffs(i)+1
300   continue

      if(.not.up2date(jobj))up2date(iobj)=.false.
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module RI_glob

use Data_Structures, only: Alloc1DiArray_Type, DSBA_Type
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: iMP2prpt, iAdrCVec(8,8,2), iOff_Ymnij(8,5), iOffA(4,0:7), iOpt, ip_Chunk = 0, iRsv, klS, Lu_A(0:7), &
                     Lu_Q(0:7), LuAVector(2), LuBVector(2), LuCVector(8,2), MxChVInShl, nAdens, nAuxVe, nAvec, nChOrb(0:7,5), &
                     nChV(0:7), nIJ1(8,8,2), nIJR(8,8,2), nJdens, nKdens, nKvec, nScreen, nSO, nSkal_Valence, nTask, NumAuxVec(8), &
                     nYmnij(8,5)
real(kind=wp) :: dmpK = Zero, tavec(2), tbvec(2)
logical(kind=iwp) :: DoCholExch, Timings_default
type(Alloc1DiArray_Type) :: Ymnij(5)
type(DSBA_Type), target :: CMOi(5), DMLT(5)
integer(kind=iwp), allocatable :: iBDsh(:), iMap(:), iShij(:,:), iSSOff(:,:,:), nBasSh(:,:), ShlSO(:), SO2Ind(:), SOShl(:), &
                                  TskList(:)
real(kind=wp), allocatable :: A(:), AMP2(:,:), BMP2(:,:), Chunk(:)
real(kind=wp), allocatable, target :: BklK(:), CijK(:), CilK(:), VJ(:), Yij(:,:,:)

public :: A, AMP2, BklK, BMP2, Chunk, CijK, CilK, CMOi, DMLT, dmpK, DoCholExch, iAdrCVec, iBDsh, iMap, iMP2prpt, iOff_Ymnij, &
          iOffA, iOpt, ip_Chunk, iRsv, iShij, iSSOff, klS, Lu_A, Lu_Q, LuAVector, LuBVector, LuCVector, MxChVInShl, nAdens, &
          nAuxVe, nAvec, nBasSh, nChOrb, nChV, nIJ1, nIJR, nJdens, nKdens, nKvec, nScreen, nSkal_Valence, nSO, nTask, NumAuxVec, &
          nYmnij, ShlSO, SO2Ind, SOShl, tavec, tbvec, Timings_default, TskList, VJ, Yij, Ymnij

end module RI_glob

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function iChAtm(Coor)
! iChAtm is an integer function which will return an integer such
! that the three first bits will represent the characteristics of
! the Cartesian components. If the bit is set then the Cartesian
! component will change sign if the symmetry operator contains a
! part which operates on that particular Cartesian direction.

use Symmetry_Info, only: iChCar, iOper, nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iChAtm
real(kind=wp), intent(in) :: Coor(3)
integer(kind=iwp) :: i, iCar, j, nOper

if (nIrrep == 8) then
  nOper = 3
else if (nIrrep == 4) then
  nOper = 2
else if (nIrrep == 2) then
  nOper = 1
else
  nOper = 0
end if

! Default that none of the Cartesians will change sign.
iChAtm = 0

! Loop over the Cartesian components.

do iCar=1,3

  ! Test if component is not zero. If zero no operator will change
  ! the sign of the component.
  if (abs(Coor(iCar)) < 1.0e-12_wp) cycle

  ! Here if the Component is none zero.

  ! Loop over the group generators and check if there is an
  ! operator that will change the sign.

  ! The generators are stored in positions 1, 2, and 4.

  do i=1,nOper    ! skip the unit operator -- i=0
    j = 2**(i-1)

    ! Test if symoperation will permute component

    if (iand(iOper(j),iChCar(iCar)) /= 0) then
      iChAtm = iChAtm+2**(iCar-1)
      exit
    end if
  end do
end do

return

end function iChAtm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine defvhlp1 (r1,v,dimr1a,dimr1bc,dimvab,dimvc,add)
c
c     this routine do
c     V(ab,c)xxx = R1(a,bc)-R1(b,ac) x=a,b
c     for syma=symb=symc
c
c     r1        - r1 matrix (I)
c     v        - v matrix (O)
c     dimr1a         - dimension of a (b,c) in R1 (I)
c     dimr1bc        - dimension of bc (ac) in R1 (I)
c     dimvab        - dimension of ab in V (I)
c     dimvc        - dimension of c (a,b) in V (I)
c     add     - additional constat (I)
c     (#of singly occ in syma for alpha, 0 for beta)
c
#include "t31.fh"
       integer dimr1a,dimr1bc,dimvab,dimvc,add
       real*8 r1(1:dimr1a,1:dimr1bc)
       real*8 v(1:dimvab,1:dimvc)
c
c     help variables
c
       integer a,b,c,ab0,ab,ar1,cr1,acr1,bk
c      integer bcr1
c
c      do 100 c=1,dimvc
c      cr1=c+add
c      do 100 a=2,dimvc
c      ar1=a+add
c      ab0=nshf(a)
c      do 100 b=1,a-1
c      bcr1=indab(b+add,cr1)
c      v(ab0+b,c)=r1(ar1,bcr1)
c100    continue
c
       do 101 c=1,dimvc
       cr1=c+add
       do 102 a=2,dimvc
       ar1=a+add
       ab0=nshf(a)
       if (c.le.(a-2)) then
c       b1 <= c1
        bk=cr1*(cr1-1)/2+add
        do b=1,c
c       bcr1=cr1*(cr1-1)/2+add+b
        v(ab0+b,c)=r1(ar1,bk+b)
        end do
c       b1 > c1
        bk=(add+c+1)*(add+c)/2+cr1
        do b=c+1,a-1
c       bcr1=(add+b)*(add+b-1)/2+cr1
        v(ab0+b,c)=r1(ar1,bk)
        bk=bk+add+b
        end do
       else
        bk=cr1*(cr1-1)/2+add
        do b=1,a-1
c       b1 <= c1
c       bcr1=cr1*(cr1-1)/2+add+b
        v(ab0+b,c)=r1(ar1,bk+b)
        end do
       end if
 102   continue
 101   continue
c
       do 200 c=1,dimvc
       cr1=c+add
       do 201 a=2,dimvc
       ab0=nshf(a)
c      acr1=indab(a+add,cr1)
         if ((a+add).gt.cr1) then
           acr1=(a+add)*(a+add-1)/2+cr1
         else
           acr1=cr1*(cr1-1)/2+a+add
         end if
       do 202 b=1,a-1
       ab=ab0+b
       v(ab,c)=v(ab,c)-r1(b+add,acr1)
 202    continue
 201    continue
 200    continue
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine RWDTG(Num,DMat,lth,Option,DT,iDisk,MaxNum)
!***********************************************************************
!                                                                      *
! purpose: Read / write density matrix, two-electron hamiltonian       *
!          or gradient to the file if they are on disk / can't be      *
!          stored in core                                              *
!                                                                      *
! input:                                                               *
!   Num       - 'map number'                                           *
!   DMat(lth) - matrix to be written or read (Dens or TwoHam)          *
!   Option    - R- read, W- write                                      *
!   DT        - 'DENS  ', 'dVxcdR', 'TWOHAM', 'GRAD  '                 *
!   iDisk     - position in the file                                   *
!   MaxNum    - maximal number of density matrices that can be         *
!               stored on the disk                                     *
!                                                                      *
! output:                                                              *
!   DMat      - matrix read from the disk (if the option was read)     *
!                                                                      *
!***********************************************************************

use SCFFiles, only: LuDSt, LuGrd, LuOSt, LuTSt
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Num, lth, MaxNum
real(kind=wp), intent(inout) :: DMat(lth)
character, intent(in) :: Option
integer(kind=iwp), intent(inout) :: iDisk(MaxNum)
character(len=6) :: DT
integer(kind=iwp) :: jDisk, LU

! Check Num; Subroutine is called with Num = - MapDns(i)

if (Num <= 0) then
  write(u6,*) 'RWDTG: Num <= 0'
  write(u6,*) 'Num=',Num
  write(u6,*) 'Wrong density number supplied.'
  call Abend()
end if
if (Num > MaxNum) then
  write(u6,*) 'RWDTG: Num > MaxNum'
  write(u6,*) 'Num,MaxNum=',Num,MaxNum
  write(u6,*) 'Wrong density number supplied.'
  call Abend()
end if

select case (DT)
  case ('DENS')
    LU = LuDSt
  case ('TWOHAM')
    LU = LuTSt
  case ('GRAD')
    LU = LuGrd
  case ('dVxcdR')
    LU = LuOSt
  case default
    write(u6,*) 'RWDTG: invalid value of DT'
    write(u6,*) '->DT<-=->',DT,'<-'
    write(u6,*) 'Valid values: "DENS  "'
    write(u6,*) '              "dVxcdR"'
    write(u6,*) '              "TWOHAM"'
    write(u6,*) '              "GRAD  "'
    call Abend()
end select

select case (Option)

  case ('W')

    ! Write density matrix to DNS

    if (Num == 1) iDisk(Num) = 0
    jDisk = iDisk(Num)
    if (jDisk == -1) then
      write(u6,*) 'RWDTG: jDisk == -1'
      write(u6,*) 'Num,MaxNum=',Num,MaxNum
      write(u6,*) 'The preceding block was not written.'
      call Abend()
    end if
    call dDaFile(LU,1,DMat,lth,jDisk)
    if (Num+1 <= MaxNum) iDisk(Num+1) = jDisk

  case ('R')

    ! Read density matrix from DNS

    jDisk = iDisk(Num)
    call dDaFile(LU,2,DMat,lth,jDisk)

  case default

    write(u6,*) 'RWDTG: invalid Option'
    write(u6,*) '->Option<-=->',Option,'<-'
    write(u6,*) 'Valid Options: R'
    write(u6,*) '               W'

end select

end subroutine RWDTG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine InpPri_m(lOPTO)
************************************************************************
*                                                                      *
*     Echo input                                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Use Fock_util_global, only: DoLocK
      Use Functionals, only: Init_Funcs, Print_Info
      Use KSDFT_Info, only: CoefR, CoefX
      Implicit Real*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
#include "output_ras.fh"
#include "ciinfo.fh"
#include "rctfld.fh"
#include "WrkSpc.fh"
#include "splitcas.fh"
#include "mspdft.fh"
      Character*8   Fmt1,Fmt2, Label
      Character*120  Line,BlLine,StLine
      Character*3 lIrrep(8)
      Character*80 KSDFT2
      Logical DoCholesky
      Logical lOPTO

* Print level:
      IPRLEV=IPRLOC(1)
      DoDMRG=.False.
*----------------------------------------------------------------------*
*     Start and define the paper width                                 *
*----------------------------------------------------------------------*
      lPaper=132
      Zero = 0.0D0
*----------------------------------------------------------------------*
*     Initialize blank and header lines                                *
*----------------------------------------------------------------------*
      lLine=Len(Line)
      Do i=1,lLine
        BlLine(i:i)=' '
        StLine(i:i)='*'
      End Do
      lPaper=132
      left=(lPaper-lLine)/2
      Write(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
      IF (IPRLEV.EQ.SILENT) GOTO 900
*----------------------------------------------------------------------*
*     Print the project title                                          *
*----------------------------------------------------------------------*
      IF(IPRLEV.GE.USUAL) THEN
       If ( nTit.gt.0 ) then
         Write(LF,*)
         nLine=nTit+5
         Do i=1,nLine
           Line=BlLine
           If ( i.eq.1 .or. i.eq.nLine )
     &     Line=StLine
           If ( i.eq.3 )
     &     Line='Project:'
           If ( i.ge.4 .and. i.le.nLine-2 )
     &     Write(Line,'(A72)')Title(i-3)
           Call Center_Text(Line)
           Write(LF,Fmt1) '*'//Line//'*'
         End Do
       Write(LF,*)
       End If
      END IF
*----------------------------------------------------------------------*
*     Print the ONEINT file identifier                                 *
*----------------------------------------------------------------------*
      IF(IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
       Write(LF,*)
       Write(LF,Fmt1) 'Header of the ONEINT file:'
       Write(LF,Fmt1) '--------------------------'
       Write(Line,'(36A2)') (Header(i),i=1,36)
       Write(LF,Fmt1)  trim(adjustl(Line))
       Write(Line,'(36A2)') (Header(i),i=37,72)
       Write(LF,Fmt1)  trim(adjustl(Line))
       Write(LF,*)
*----------------------------------------------------------------------*
*     Print the status of ORDINT                                       *
*----------------------------------------------------------------------*
       Write(LF,*)
       If (lSquare) Then
         Write(LF,Fmt1) 'OrdInt status: squared'
       Else
         Write(LF,Fmt1) 'OrdInt status: non-squared'
       End If
       Write(LF,*)
*----------------------------------------------------------------------*
*     Print cartesian coordinates of the system                        *
*----------------------------------------------------------------------*
       Call PrCoor
      END IF
*----------------------------------------------------------------------*
*     Print orbital and wavefunction specifications                    *
*----------------------------------------------------------------------*
      IF(IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
      Write(LF,*)
      Line=' '
      Write(Line(left-2:),'(A)') 'Wave function specifications:'
      Call CollapseOutput(1,Line)
      Write(LF,Fmt1)'-----------------------------'
      Write(LF,*)
      If (NFR.gt.0)
     &Write(LF,Fmt2//'A,T45,I6)')'Number of frozen shell electrons',
     &                           2*NFR
      Write(LF,Fmt2//'A,T45,I6)')'Number of closed shell electrons',
     &                           2*NIN
      Write(LF,Fmt2//'A,T45,I6)')'Number of electrons in active shells',
     &                           NACTEL
C.. for RAS
      if (.not.idogas) then
      Write(LF,Fmt2//'A,T45,I6)')'Max number of holes in RAS1 space',
     &                           NHOLE1
      Write(LF,Fmt2//'A,T45,I6)')'Max nr of electrons in RAS3 space',
     &                           NELEC3
C.. for GAS
      else
        DO IGAS=1,NGAS
          Write(LF,Fmt2//'A,I1,A,T45,2I6)')
     &      'Min/Max nr of electrons up to GAS',IGAS,' space',
     &                           igsoccx(igas,1),igsoccx(igas,2)
        END DO
      end if

      If (NFR.gt.0)
     &Write(LF,Fmt2//'A,T45,I6)')'Number of frozen orbitals',
     &                           NFR
      Write(LF,Fmt2//'A,T45,I6)')'Number of inactive orbitals',
     &                           NIN
      Write(LF,Fmt2//'A,T45,I6)')'Number of active orbitals',
     &                           NAC
      Write(LF,Fmt2//'A,T45,I6)')'Number of secondary orbitals',
     &                           NSEC
      Write(LF,Fmt2//'A,T45,F6.1)')'Spin quantum number',
     &                           (DBLE(ISPIN-1))/2.0d0
      Write(LF,Fmt2//'A,T45,I6)')'State symmetry',
     &                           STSYM
      Call CollapseOutput(0,'Wave function specifications:')
*
      Call Get_cArray('Irreps',lIrrep,24)
      Do iSym = 1, nSym
         lIrrep(iSym) = adjustr(lIrrep(iSym))
      End Do
*
      Write(LF,*)
      Line=' '
      Write(Line(left-2:),'(A)') 'Orbital specifications:'
      Call CollapseOutput(1,Line)
      Write(LF,Fmt1)'-----------------------'
      Write(LF,*)
      Write(LF,Fmt2//'A,T47,8I4)') 'Symmetry species',
     &                            (iSym,iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8(1X,A))') '                ',
     &                            (lIrrep(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Frozen orbitals',
     &                            (nFro(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Inactive orbitals',
     &                            (nIsh(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Active orbitals',
     &                            (nAsh(iSym),iSym=1,nSym)
      IF(.not.iDoGas)then
        Write(LF,Fmt2//'A,T47,8I4)') 'RAS1 orbitals',
     &                            (nRs1(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'RAS2 orbitals',
     &                            (nRs2(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'RAS3 orbitals',
     &                            (nRs3(iSym),iSym=1,nSym)
      Else
        DO IGAS=1,NGAS
          Write(LF,Fmt2//'A,I1,A,T47,8I4)') 'GAS',IGAS,' orbitals',
     &                            (ngssh(igas,iSym),iSym=1,nSym)
        END DO
      End If

      Write(LF,Fmt2//'A,T47,8I4)') 'Secondary orbitals',
     &                            (nSsh(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Deleted orbitals',
     &                            (nDel(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Number of basis functions',
     &                            (nBas(iSym),iSym=1,nSym)
      Call CollapseOutput(0,'Orbital specifications:')
      Write(LF,*)

      If(.Not.DoDMRG) GoTo 113

      Line=' '
      Write(Line(left-2:),'(A)') 'DMRG sweep specifications:'
      Call CollapseOutput(1,Line)
      Write(LF,Fmt1)'--------------------------'
      Write(LF,*)
      Write(LF,Fmt2//'A,T45,I6)')'Number of renormalized basis',
     &                           MxDMRG
      Write(LF,Fmt2//'A,T45,I6)')'Number of root(s) required',
     &                           NROOTS
* NN.14 FIXME: haven't yet checked whether geometry opt. works correctly with DMRG
      Write(LF,Fmt2//'A,T45,I6)')'Root chosen for geometry opt.',
     &                           IRLXROOT
      Call CollapseOutput(0,'DMRG sweep specifications:')

*     Skip printing CI specifications in DMRG-CASSCF
      GoTo 114

 113  Continue

      Line=' '
      Write(Line(left-2:),'(A)') 'CI expansion specifications:'
      Call CollapseOutput(1,Line)
      Write(LF,Fmt1)'----------------------------'
      Write(LF,*)
      Write(LF,Fmt2//'A,T40,I11)')'Number of CSFs',
     &                           NCSASM(STSYM)
      Write(LF,Fmt2//'A,T40,I11)')'Number of determinants',
     &                           NDTASM(STSYM)
        n_Det=2
        n_unpaired_elec=(iSpin-1)
        n_paired_elec=nActEl-n_unpaired_elec
        If(n_unpaired_elec+n_paired_elec/2.eq.nac.or.
     &     NDTASM(STSYM).eq.1) n_Det = 1
        If(KSDFT.eq.'DIFF')   n_Det = 1
        If(KSDFT.eq.'ROKS')   n_Det = 1

      if(.not.DoSplitCAS) then  ! GLMJ
        Write(LF,Fmt2//'A,T45,I6)')'Number of root(s) required',
     &                             NROOTS
*TRS
      Call Get_iScalar('Relax CASSCF root',iRlxRoot)
*TRS
        If (irlxroot.ne.0)
     &  Write(LF,Fmt2//'A,T45,I6)')'Root chosen for geometry opt.',
     &                             IRLXROOT
        If ( ICICH.eq.0 ) then
          If ( nRoots.eq.1 ) then
            Write(LF,Fmt2//'A,(T45,10I6))')'CI root used',
     &                                 IROOT(1)
          Else
            Write(LF,Fmt2//'A,(T45,10I6))')'CI roots used',
     &                                  (IROOT(i),i=1,nRoots)
            Write(LF,Fmt2//'A,(T45,10F6.3))')'weights',
     &                                  (Weight(i),i=1,nRoots)
          End If
        Else
          Do i=1,nRoots
            Write(LF,Fmt2//'A,T45,I6)')'selected root',iRoot(i)
            Write(LF,Fmt2//'A,T45,10I6)')'Reference configurations',
     &                                (iCI(i,iRef),iRef=1,mxRef)
            Write(LF,Fmt2//'A,T45,10F6.3)')'CI-coeff',
     &                                (cCI(i,iRef),iRef=1,mxRef)
          End Do
        End If
        Write(LF,Fmt2//'A,T45,I6)')'highest root included in the CI',
     &                           LROOTS
        Write(LF,Fmt2//'A,T45,I6)')'max. size of the explicit '//
     &                          'Hamiltonian',NSEL
      else
        write(LF,Fmt2//'A,T45,I6)')  'Root required ', lrootSplit
        if (NumSplit)
     &  write(LF,Fmt2//'A,T45,I6)')'A-Block Size in '//
     &                            'SplitCAS',iDimBlockA
        if (EnerSplit)
     &  write(LF,Fmt2//'A,T44,F7.2)')'Energy Gap (eV) in SplitCAS',
     &                              GapSpli
        if (PerSplit)
     &  write(LF,Fmt2//'A,T44,F7.1)')'Percentage sought '//
     &                            'in SplitCAS',PercSpli
        Write(LF,Fmt2//'A,T45,E10.3)')'Threshold for SplitCAS',
     &                              ThrSplit
*       write(LF,Fmt2//'A,T49,G10.3)')'Thrs over the root to be '//
*     &                        'opt in SplitCAS', ThrSplit
        write(LF,Fmt2//'A,T47,I4)') 'Maximum number of SplitCAS '//
     &                       'iterations', MxIterSplit
        if (FordSplit) then
          write(LF,Fmt2//'A,T47)') 'CI coeff: 1st-order approximation'
        else
          write(LF,Fmt2//'A,T47)')'CI coeff: 0th-order approximation'
        end if
      end if
      Call CollapseOutput(0,'CI expansion specifications:')

 114  Continue

      END IF
      IF (lOPTO) THEN
        Write(LF,*)
        Line=' '
        Write(Line(left-2:),'(A)') 'RASSCF input specifications:'
        Call CollapseOutput(1,Line)
        Write(LF,Fmt1)'----------------------------'
        if(.not.DoSplitCAS) then
          Write(LF,Fmt2//'A,T45,I6)')'Number of root(s) required',
     &                             NROOTS
          If (irlxroot.ne.0)
     &      Write(LF,Fmt2//'A,T45,I6)')'Root chosen for geometry opt.',
     &                                 IRLXROOT
          If ( ICICH.eq.0 ) then
            If ( nRoots.eq.1 ) then
              Write(LF,Fmt2//'A,(T45,10I6))')'CI root used',
     &                                    IROOT(1)
            Else
              Write(LF,Fmt2//'A,(T45,10I6))')'CI roots used',
     &                                    (IROOT(i),i=1,nRoots)
              Write(LF,Fmt2//'A,(T45,10F6.3))')'weights',
     &                                     (Weight(i),i=1,nRoots)
            End If
          Else
           Do i=1,nRoots
              Write(LF,Fmt2//'A,T45,I6)')'selected root',iRoot(i)
              Write(LF,Fmt2//'A,T45,10I6)')'Reference configurations',
     &                                  (iCI(i,iRef),iRef=1,mxRef)
              Write(LF,Fmt2//'A,T45,10F6.3)')'CI-coeff',
     &                                  (cCI(i,iRef),iRef=1,mxRef)
            End Do
          End If
        end if
        Call CollapseOutput(0,'RASSCF input specifications:')
      ENDIF
* Check that the user doesn't try to calculate more roots than it's possible
* NN.14 FIXME: in DMRG-CASSCF, skip this check for the time
*              since Block DMRG code will check this internally
*     If (NROOTS .GT. NCSASM(STSYM)) Then
      If (.false.) Then
!      If (.NOT.DoDMRG .AND. NROOTS .GT. NCSASM(STSYM)) Then
         Write(LF,*) '************ ERROR ***********'
         Write(LF,*) ' You can''t ask for more roots'
         Write(LF,*) ' than there are configurations '
         Write(LF,*) '******************************'
         Write(LF,*)
!         Call Quit_OnUserError()
      End If
* If the calculation will be too big:
      call GetMem('ChkMx','Max','Real',iDum,MaxRem)
      WillNeedMB=(8.0D0*1.50D0*6.0D0*NDTASM(STSYM)/1.048D6)
      AvailMB=(8.0D0*MaxRem/1.048D6)
      if (WillNeedMB .gt. AvailMB) then
        write(6,*)
        write(6,*)' *************************************************'
        write(6,*)' Sorry, but your calculation will probably be too'
        write(6,*)' large for the available memory.'
        write(6,*)' The number of determinants is ',NDTASM(STSYM)
        write(6,*)' During CI equation solution, there will be'
        write(6,*)' up to six vectors of this size in memory.'
        write(6,*)' We estimate an additional 50% for other stuff.'
        write(6,*)
        write(6,'(A,F9.1,A)')' This alone will need at least ',
     &                                            WillNeedMB,' MB.'
        write(6,'(A,F9.1,A)')' Available at this point is ',
     &                                               AvailMB,' MB.'
        write(6,*)' Please increase MOLCAS_MEM, and try again.'
        write(6,*)' *************************************************'
        write(6,*)
        Call Quit_OnUserError()
      end if

      IF(IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
       Write(LF,*)
       Line=' '
       Write(Line(left-2:),'(A)') 'Optimization specifications:'
       Call CollapseOutput(1,Line)
       Write(LF,Fmt1)'----------------------------'
       Write(LF,*)
       call DecideOnCholesky(DoCholesky)
       If (DoCholesky) Then
        Call Get_iScalar('System BitSwitch',iDoRI)
        if (Iand(iDoRI,1024).Eq.1024) then
           if (DoLocK) then
             Write(LF,Fmt2//'A,T45,I6)')'RASSCF algorithm: LK RI/DF'
           else
             Write(LF,Fmt2//'A,T45,I6)')'RASSCF algorithm: RI/DF'
           endif
        else
           if (DoLocK) then
             Write(LF,Fmt2//'A,T45,I6)')'RASSCF algorithm: LK Cholesky'
           else
             Write(LF,Fmt2//'A,T45,I6)')'RASSCF algorithm: Cholesky'
           endif
        endif
       Else
        Write(LF,Fmt2//'A,T45,I6)')'RASSCF algorithm: Conventional'
       EndIf
       KSDFT2 = KSDFT
       IF(KSDFT(1:2).eq.'T:'.or.KSDFT(1:3).eq.'FT:') Then
        KSDFT2 = KSDFT(index(KSDFT,'T:')+2:)
        Write(LF,Fmt2//'A)') 'This is a MC-PDFT calculation '//
     &   'with functional: '//KSDFT
        Write(LF,Fmt2//'A,T45,E10.3)')'Exchange scaling factor',CoefX
        Write(LF,Fmt2//'A,T45,E10.3)')'Correlation scaling factor',
     &                                 CoefR
       end if
       If (dogradPDFT.or.dogradMSPD) then
        Write(LF,Fmt1) 'Potentials are computed for gradients'
       end if
       Write(LF,Fmt2//'A,T45,I6)')'Maximum number of macro iterations',
     &                           MAXIT
       Write(LF,Fmt2//'A,T45,I6)')'Maximum number of SX iterations',
     &                           ITMAX
       Write(LF,Fmt2//'A,T45,E10.3)')'Threshold for RASSCF energy',
     &                              THRE
       Call Put_dScalar('EThr',ThrE)
       Write(LF,Fmt2//'A,T45,E10.3)')'Threshold for max MO rotation',
     &                              THRTE
       Write(LF,Fmt2//'A,T45,E10.3)')'Threshold for max BLB element',
     &                              THRSX
       Write(LF,Fmt2//'A,T45,E10.3)')'Level shift parameter',
     &                              LVSHFT
       If ( NQUNE.ne.0 ) THEN
        Write(LF,Fmt1)'Make Quasi-Newton update'
       End If
       If ( ISUPSM.ne.0 ) then
         Write(LF,Fmt1)
     &   'Supersymmetry is used to disable selected orbital rotations'
         iEnd=0
         Do iSym=1,nSym
            iStart=iEnd+1
            iEnd=iEnd+nBas(iSym)
            iTemp=0
            Do i=iStart,iEnd
               iTemp=iTemp+IXSYM(i)
            End Do
            If ( iTemp.gt.0 ) then
               Write(LF,Fmt2//'A,I3)')
     &         'Supersymmetry vector for symmetry species',iSym
               Write(LF,Fmt2//'30I3)') (IXSYM(i),i=iStart,iEnd)
            End If
         End Do
       End If
       If ( lRF ) then
         Call GetMem('Ovrlp','Allo','Real',iTmp0,nTot1+4)
         iRc=-1
         iOpt=2
         iComp=1
         iSyLbl=1
         Label='Mltpl  0'
         Call RdOne(iRc,iOpt,Label,iComp,Work(iTmp0),iSyLbl)
         Tot_Nuc_Charge=Work(iTmp0+nTot1+3)
         If ( iRc.ne.0 ) then
            Write(LF,*) 'InpPri: iRc from Call RdOne not 0'
            Write(LF,*) 'Label = ',Label
            Write(LF,*) 'iRc = ',iRc
            Call Abend
         Endif
         Call GetMem('Ovrlp','Free','Real',iTmp0,nTot1+4)
         Tot_El_Charge=Zero
         Do iSym=1,nSym
            Tot_El_Charge=Tot_El_Charge
     &                   -2.0D0*DBLE(nFro(iSym)+nIsh(iSym))
         End Do
         Tot_El_Charge=Tot_El_Charge-DBLE(nActEl)
         Tot_Charge=Tot_Nuc_Charge+Tot_El_Charge
         iCharge=Int(Tot_Charge)
         Call PrRF(.False.,NonEq,iCharge,2)
         Write(LF,Fmt2//'A,T45,I2)')' Reaction field from state:',
     &                              IPCMROOT
       End If
       Call CollapseOutput(0,'Optimization specifications:')
       If ( RFpert ) then
         Write(LF,*)
         Write(LF,Fmt1)'Reaction field specifications:'
         Write(LF,Fmt1)'------------------------------'
         Write(LF,*)
         Write(LF,'(6X,A)')'The Reaction field is added as a '//
     &                    'perturbation and has been determined '//
     &                    'in a previous calculation'
         Write(LF,*)
       End If
       If (ICIRST.EQ.1) Then
        Write(LF,Fmt1)
     &  'Starting CI array(s) will be read from file'
       End If
      END IF
      Write(LF,*)

       Call Put_dScalar('EThr',ThrE)
*
*---- Print out grid information in case of DFT
*
       If (KSDFT.ne.'SCF') Then
         Call Put_dScalar('DFT exch coeff',CoefX)
         Call Put_dScalar('DFT corr coeff',CoefR)
         Call Funi_Print()
         IF(IPRLEV.GE.USUAL) THEN
            Write(6,*)
            Write(6,'(6X,A)') 'DFT functional specifications'
            Write(6,'(6X,A)') '-----------------------------'
            Call libxc_version()
            Call Init_Funcs(KSDFT2)
            Call Print_Info()
            Write(6,*)
         END IF
       End If
  900 CONTINUE
      Call XFlush(LF)
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine setmocom_cvb()
      implicit real*8 (a-h,o-z)
#include "rasdim.fh"
#include "jobiph_j.fh"
#include "mo_cvb.fh"
      logical debug
      data debug/.false./

      nsym_mo=nsym_j
      call imove_cvb(nbas_j,nbasi_mo,8)

      nbas_mo=0
      nbasisq_mo=0
      do 100 i=1,8
      nbassqi_mo(i)=nbasi_mo(i)*nbasi_mo(i)
      nbasf_mo(i)=nbas_mo
      nbassqf_mo(i)=nbasisq_mo
      nbas_mo=nbas_mo+nbasi_mo(i)
      nbasisq_mo=nbasisq_mo+nbassqi_mo(i)
100   continue

      nact_mo=0
      do 200 i=1,8
      do 201 j=1,nash_j(i)
      nact_mo=nact_mo+1
      iact_mo(nact_mo)=nbasf_mo(i)+nfro_j(i)+nish_j(i)+j
201   continue
200   continue

      if(debug)then
        write(6,*)' MO interface'
        write(6,*)' ------------'
        write(6,*)' nsym    :',nsym_mo
        write(6,*)' nbas    :',nbas_mo
        write(6,*)' nbasisq :',nbasisq_mo
        write(6,*)' nbasi   :',nbasi_mo
        write(6,*)' nbassqi :',nbassqi_mo
        write(6,*)' nbasf   :',nbasf_mo
        write(6,*)' nbassqf :',nbassqf_mo
        write(6,*)' nact    :',nact_mo
        write(6,*)' iact    :',(iact_mo(ii),ii=1,nact_mo)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine outmo(imo,ipower,cmo,clincomb,cout,nbas,nmo)
************************************************************************
* Adapted from SAGIT to work with OpenMolcas (October 2020)            *
************************************************************************
      implicit real*8 (a-h,o-z)
      dimension cmo(nbas,nmo),clincomb(nmo),cout(nbas)
#include "WrkSpc.fh"

      if(imo.ne.0)then
         call fmove(cmo(1,imo),cout,nbas)
         call power(cout,nbas,ipower)
         return
      else
        call fzero(cout,nbas)
        Call GetMem('TmpMo','ALLO','REAL',ipTmpMo,nbas)
        do 100 i=1,nmo
        if(clincomb(i).ne.0d0)then
          call fmove(cmo(1,i),Work(ipTmpMo),nbas)
          call power(Work(ipTmpMO),nbas,ipower)
          call daxpy_(nbas,clincomb(i),Work(ipTmpMo),1,cout,1)
        endif
100     continue
        Call GetMem('TmpMo','FREE','REAL',ipTmpMo,nbas)
      endif
      return
      end

      subroutine power(c,n,ipower)
      implicit real*8 (a-h,o-z)
      dimension c(n)

      if(ipower.eq.1)then
        return
      elseif(ipower.eq.2)then
        do 100 i=1,n
         c(i)=c(i)*c(i)
100     continue
      elseif(ipower.eq.-2)then
        do 200 i=1,n
          c(i)=sign(c(i)*c(i),c(i))
200     continue
      endif
      return
      end
      subroutine MakePab(cmo,occ,cout,nCMO,nMOs,nIrrep,nBas)
      implicit real*8 (a-h,o-z)
      dimension cmo(nCMO),occ(nMOs),cout(nMOs), nBas(0:7)
#include "WrkSpc.fh"
        Call GetMem('List','LIST','REAL',id,id)
        id=0
        id2=0
        call fzero(cout,nMOs)
        do iIrr=0,nIrrep-1
        nd=nBas(iIrr)
        nd2=nd*nd
        do 100 i=1,nd
c        if(occ(i+id).ne.0d0)then
        do 200 j=1,nd
        cout(i+id)=cout(i+id)+occ(i+id)*
     &                ( cmo(j+i*(nd-1)+id2) ** 2 )
200     continue
100     continue
        id=id+nd
        id2=id2+nd2
        enddo

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefW4abcd(W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)
! define W(a,b,c,d) from (ab|cd)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimc, dimd, abLen, cdLen, aSGrp, bSGrp, cSGrp, dSGrp
real(kind=wp), intent(inout) :: W(dima,dimb,dimc,dimd)
real(kind=wp), intent(in) :: Wx(abLen,cdLen)
integer(kind=iwp) :: a, ab, b, c, cd, d

if ((aSGrp == bSGrp) .and. (cSGrp == dSGrp)) then
  ! case (a=b|c=d)
  do c=1,dimc
    cd = nTri_Elem(c-1)
    do a=1,dima
      ab = nTri_Elem(a-1)
      W(a,1:a-1,c,1:c-1) = W(a,1:a-1,c,1:c-1)+Wx(ab+1:ab+a-1,cd+1:cd+c-1)
      W(a,1:a-1,1:c,c) = W(a,1:a-1,1:c,c)+Wx(ab+1:ab+a-1,cd+1:cd+c)
      W(1:a,a,c,1:c-1) = W(1:a,a,c,1:c-1)+Wx(ab+1:ab+a,cd+1:cd+c-1)
      W(1:a,a,1:c,c) = W(1:a,a,1:c,c)+Wx(ab+1:ab+a,cd+1:cd+c)
      ab = ab+a
    end do
    cd = cd+c
  end do

else if ((aSGrp == bSGrp) .and. (cSGrp /= dSGrp)) then
  ! case (a=b|c,d)
  cd = 0
  do d=1,dimd
    do a=1,dima
      ab = nTri_Elem(a-1)
      W(a,1:a-1,:,d) = W(a,1:a-1,:,d)+Wx(ab+1:ab+a-1,cd+1:cd+dimc)
      W(1:a,a,:,d) = W(1:a,a,:,d)+Wx(ab+1:ab+a,cd+1:cd+dimc)
      ab = ab+a
    end do
    cd = cd+dimc
  end do

else if ((aSGrp /= bSGrp) .and. (cSGrp == dSGrp)) then
  ! case (a,b|c=d)
  do c=1,dimc
    cd = nTri_Elem(c-1)
    ab = 0
    do b=1,dimb
      W(:,b,c,1:c-1) = W(:,b,c,1:c-1)+Wx(ab+1:ab+dima,cd+1:cd+c-1)
      W(:,b,1:c,c) = W(:,b,1:c,c)+Wx(ab+1:ab+dima,cd+1:cd+c)
      ab = ab+dima
    end do
    cd = cd+c
  end do

else
  ! case (a,b|c,d)
  cd = 0
  do d=1,dimd
    ab = 0
    do b=1,dimb
      W(:,b,:,d) = W(:,b,:,d)+Wx(ab+1:ab+dima,cd+1:cd+dimc)
      ab = ab+dima
    end do
    cd = cd+dimc
  end do

end if

return

end subroutine DefW4abcd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cre_gsswfn
*     SVC: Create a wavefunction file. If another .guessorb.h5 file already
*     exists, it will be overwritten.
      implicit none
#ifdef _HDF5_
#  include "Molcas.fh"
#  include "commgo.fh"
#  include "gsswfn.fh"
      integer :: nBasTot, nSqrTot, iSym

*     create a new wavefunction file!
      wfn_fileid = mh5_create_file('GSSWFN')

*     set module type
      call mh5_init_attr (wfn_fileid,'MOLCAS_MODULE', 'GUESSORB')

*     copy basic molecular information to the HDF5 file
      call run2h5_molinfo(wfn_fileid)
      call one2h5_ovlmat(wfn_fileid, nsym, nbas)
      call one2h5_fckint(wfn_fileid, nsym, nbas)

*     energy
      wfn_energy = mh5_create_dset_real (wfn_fileid,'ENERGY')
      call mh5_init_attr(wfn_energy, 'description',
     $        'Total energy (sum of orbital energies)')

      call mh5_init_attr (wfn_fileid,
     $        'ORBITAL_TYPE', 'GUESS')

      nBasTot=0
      nSqrTot=0
      Do iSym=1,nSym
         nSqrTot=nSqrTot+nBas(iSym)*nBas(iSym)
         nBasTot=nBasTot+nBas(iSym)
      End Do

*     typestring
      wfn_tpidx = mh5_create_dset_str(wfn_fileid,
     $        'MO_TYPEINDICES', 1, [nBasTot], 1)
      call mh5_init_attr(wfn_tpidx, 'description',
     $        'Type index of the molecular orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital coefficients
      wfn_mocoef = mh5_create_dset_real(wfn_fileid,
     $        'MO_VECTORS', 1, [nSqrTot])
      call mh5_init_attr(wfn_mocoef, 'description',
     $        'Coefficients of the molecular orbitals, '//
     $        'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')
*     molecular orbital occupation numbers
      wfn_occnum = mh5_create_dset_real(wfn_fileid,
     $        'MO_OCCUPATIONS', 1, [nBasTot])
      call mh5_init_attr(wfn_occnum, 'description',
     $        'Occupation numbers of the molecular orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital energies
      wfn_orbene = mh5_create_dset_real(wfn_fileid,
     $        'MO_ENERGIES', 1, [nBasTot])
      call mh5_init_attr(wfn_orbene, 'description',
     $        'Orbital energies of the molecular orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
#endif
      end

      subroutine cls_gsswfn
      implicit none
#ifdef _HDF5_
#  include "gsswfn.fh"
      call mh5_close_file(wfn_fileid)
#endif
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine UrobInt (W,maxa,maxbe,n,lun)
c
c       vyraba subor LunInt so simulovanymi (a"be"|b"ga") integralmi
c       kde je za sebou N blokov
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer maxa,maxbe,n,lun
        real*8 W(1)
c
c       help variables
        integer length,i
c
c       open (unit=Lun,file='IntFil',form='unformatted')
c
c1      def legth
c
        length=maxa*maxa*maxbe*maxbe
c
c2      cycle over N
c
        do i=1,n
c
c2.1    full W with random numbers
c
        call RNFill (length,W(1),1.0d-2)
c
c2.2    write block
c
        write (6,*) 'Vint',i,length
        call wri_chcc (lun,length,W(1))
c
        end do
c
c
        rewind(lun)
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FOCK_RASSI(DINAO,FOCKAO)
! Purpose:
!  ADD THE TWO-ELECTRON PART OF A FOCK MATRIX USING THE
!  INACTIVE DENSITY MATRIX. THE FOCK MATRIX SHOULD CONTAIN THE
!  ONE-ELECTRON HAMILTONIAN MATRIX BEFORE THE CALL. THE MATRICES
!  ARE STORED IN SYMMETRY-BLOCKED SQUARE FORMAT.

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: MUL, nIrrep
use rassi_data, only: NBASF, NBMX, NBSQ, NBSQPR, NBTRI, NISH
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: DINAO(NBSQ)
real(kind=wp), intent(inout) :: FOCKAO(NBSQ)
integer(kind=iwp) :: IDF, IDPQ, IDRS, IFPQ, IFRS, II, INTBUF, INUSE, IOPT, IPQ, IRC, IRSST, ISP, ISQ, ISR, ISS, ISSMX, ISYM, &
                     KEEP(8), KEEPP, KEEPQ, KEEPR, KEEPS, KEEPT, LPQ, NB, NBP, NBPQ, NBQ, NBR, NBRS, NBS, NBSX(8), NBT, NBTR, &
                     NBTRPR(8), NFTRI, NIP, NIQ, NIR, NIS, NP, NPQ, NPQM, NQ, NQM, NSPQ, NSPQR, NSQBUF, NSYMX
real(kind=wp) :: DF, FPQ
logical(kind=iwp) :: ISQARX
real(kind=wp), allocatable :: DTRI(:), FTRI(:), PQRS(:), SQBUF(:)

! RETRIEVE BASE DATA FROM UNIT LUORD:
IRC = 0
call GETORD(IRC,ISQARX,NSYMX,NBSX,KEEP)
! ALLOCATE WORK SPACE FOR FOLDED DENSITY MATRIX, FOR ONE
! TRIANGULAR SYMMETRY-BLOCK OF THE TWO-ELECTRON CONTRIBUTION,
! FOR AN INTEGRAL BUFFER, AND FOR EXPANDING TRIANGULAR INTEGRAL
! MATRICES INTO SQUARE FORMAT:
NSQBUF = NBMX**2
INTBUF = max(NSQBUF,256*256)
call mma_allocate(PQRS,INTBUF,Label='PQRS')
call mma_allocate(DTRI,NBTRI,Label='DTRI')
call mma_allocate(SQBUF,NSQBUF,Label='SQBUF')
!PAM00 Nr of triangular matrices in previous symmetry blocks
NBTR = 0
do ISYM=1,nIrrep
  NBTRPR(ISYM) = NBTR
  NB = NBASF(ISYM)
  NBTR = NBTR+nTri_Elem(NB)
end do
NFTRI = NBTR
call mma_allocate(FTRI,NFTRI,Label='FTRI')
FTRI(:) = Zero
! FOLD THE D MATRIX:
IDF = 1
do ISYM=1,nIrrep
  NB = NBASF(ISYM)
  NPQ = NBSQPR(ISYM)
  do NP=1,NB
    do NQ=1,NP
      DF = DINAO(NPQ+NB*(NP-1)+NQ)+DINAO(NPQ+NB*(NQ-1)+NP)
      if (NP == NQ) DF = Half*DF
      DTRI(IDF) = DF
      IDF = IDF+1
    end do
  end do
end do
! LOOP OVER ISP:
do ISP=1,nIrrep
  NBP = NBASF(ISP)
  NIP = NISH(ISP)
  KEEPP = KEEP(ISP)
  ! LOOP OVER ISQ:
  do ISQ=1,ISP
    NBQ = NBASF(ISQ)
    NIQ = NISH(ISQ)
    NSPQ = MUL(ISP,ISQ)
    KEEPQ = KEEP(ISQ)
    ! LOOP OVER ISR:
    do ISR=1,ISP
      NBR = NBASF(ISR)
      NIR = NISH(ISR)
      NSPQR = MUL(NSPQ,ISR)
      KEEPR = KEEP(ISR)
      ! LOOP OVER ISS:
      ISSMX = ISR
      if (ISP == ISR) ISSMX = ISQ
      do ISS=1,ISSMX
        if (ISS /= NSPQR) cycle
        NBS = NBASF(ISS)
        NIS = NISH(ISS)
        KEEPS = KEEP(ISS)
        KEEPT = KEEPP+KEEPQ+KEEPR+KEEPS
        NBT = NBP*NBQ*NBR*NBS
        if ((KEEPT /= 0) .and. (NBT /= 0)) call ABEND()
        if (NBT == 0) cycle
        INUSE = 0
        if ((ISP == ISQ) .and. (NBP > 0) .and. (NIR > 0)) INUSE = 1
        if ((ISP == ISQ) .and. (NIP > 0) .and. (NBR > 0)) INUSE = 1
        if ((ISP == ISR) .and. (NBP > 0) .and. (NIQ > 0)) INUSE = 1
        if ((ISP == ISR) .and. (NIP > 0) .and. (NBQ > 0)) INUSE = 1
        if (INUSE == 0) cycle

        ! SIZES OF INTEGRAL MATRICES:
        NBPQ = NBP*NBQ
        if (ISP == ISQ) NBPQ = nTri_Elem(NBP)
        NBRS = NBR*NBS
        if (ISR == ISS) NBRS = nTri_Elem(NBR)
        ! READ THE AO INTEGRALS INTO PQRS WHENEVER NEEDED.
        ! ACCUMULATE CONTRIBUTIONS TO FOCK MATRIX INTO FTRI, OR
        ! DIRECTLY INTO FOCKAO.
        IRC = 0
        IOPT = 1
        IPQ = 0
        LPQ = 0
        NPQ = 0
        IRSST = 1-NBRS
        do NP=1,NBP
          NQM = NBQ
          if (ISP == ISQ) NQM = NP
          do NQ=1,NQM
            IPQ = IPQ+1
            ! READ A NEW BUFFER OF INTEGRALS
            if (LPQ == NPQ) then
              call RDORD(IRC,IOPT,ISP,ISQ,ISR,ISS,PQRS,INTBUF,NPQ)
              IOPT = 2
              LPQ = 0
              IRSST = 1-NBRS
              ! COULOMB CONTRIBUTION:
              if (ISP == ISQ) then
                if (NIR > 0) then
                  IFPQ = NBTRPR(ISP)+IPQ
                  IDRS = NBTRPR(ISR)+1
                  NPQM = min(NPQ,NBPQ-IPQ+1)
                  call DGEMV_('T',NBRS,NPQM,One,PQRS,NBRS,DTRI(IDRS),1,One,FTRI(IFPQ),1)
                end if
                !PAM00 Added code, to obtain RSPQ contributions from the PQRS integrals
                if ((ISP > ISR) .and. (NIP > 0)) then
                  IFRS = NBTRPR(ISR)+1
                  IDPQ = NBTRPR(ISP)+IPQ
                  NPQM = min(NPQ,NBPQ-IPQ+1)
                  call DGEMV_('N',NBRS,NPQM,One,PQRS,NBRS,DTRI(IDPQ),1,One,FTRI(IFRS),1)
                end if
              end if
            end if
            LPQ = LPQ+1
            IRSST = IRSST+NBRS
            ! EXCHANGE CONTRIBUTIONS:
            if (ISP == ISR) then
              if (ISR == ISS) call SQUARE(PQRS(IRSST),SQBUF,1,NBR,NBR)
              if (((ISP /= ISQ) .or. (NP /= NQ)) .and. (NIR > 0)) then
                if (ISR == ISS) then
                  call DGEMV_('N',NBS,NBR,-Half,SQBUF,NBS,DINAO(NBSQPR(ISP)+NBR*(NP-1)+1),1,One,FOCKAO(NBSQPR(ISQ)+NQ),NBQ)
                else
                  call DGEMV_('N',NBS,NBR,-Half,PQRS(IRSST),NBS,DINAO(NBSQPR(ISP)+NBR*(NP-1)+1),1,One,FOCKAO(NBSQPR(ISQ)+NQ),NBQ)
                end if
              end if
              if (ISP == ISS) then
                if (NIR > 0) &
                  call DGEMV_('N',NBS,NBR,-Half,SQBUF,NBS,DINAO(NBSQPR(ISQ)+NBR*(NQ-1)+1),1,One,FOCKAO(NBSQPR(ISP)+NP),NBP)
              else if (NIS > 0) then
                call DGEMV_('T',NBS,NBR,-Half,PQRS(IRSST),NBS,DINAO(NBSQPR(ISQ)+NBS*(NQ-1)+1),1,One,FOCKAO(NBSQPR(ISP)+NP),NBP)
              end if
            end if
          end do  ! nq
        end do  ! np

      end do  ! iss
    end do  ! isr
  end do  ! isq
end do ! isp
! END OF QUADRUPLE SYMMETRY LOOP.
! ADD COULOMB CONTRIBUTIONS FROM TRIANGULAR STORAGE TO FOCKAO:
!PAM00 OK -- Now add Coulomb contributions:
IFPQ = 0
do ISP=1,nIrrep
  NBP = NBASF(ISP)
  do NP=1,NBP
    do NQ=1,NP
      IFPQ = IFPQ+1
      FPQ = FTRI(IFPQ)
      II = NBSQPR(ISP)+NBP*(NP-1)+NQ
      FOCKAO(II) = FOCKAO(II)+FPQ
      if (NQ /= NP) then
        II = NBSQPR(ISP)+NBP*(NQ-1)+NP
        FOCKAO(II) = FOCKAO(II)+FPQ
      end if
    end do
  end do
end do
call mma_deallocate(PQRS)
call mma_deallocate(DTRI)
call mma_deallocate(SQBUF)
call mma_deallocate(FTRI)

call GADGOp(FOCKAO,NBSQ,'+')

end subroutine FOCK_RASSI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine facab(binom,na1,nb1,crda,crdb,xab)
      implicit real*8 (a-h,o-z)
c     parameter (a1=1.0d0, a2=2.0d0, a3=3.0d0, a4=4.0d0, a6=6.0d0)
      dimension binom(*), crda(*), crdb(*), xab(*)
c
      call wzero(na1+nb1-1,xab,1)
      naind=(na1*(na1-1))/2
      nbind=(nb1*(nb1-1))/2
      do 12 ia1=1,na1
        do 10 ib1=1,nb1
          xab((ia1-1)+ib1)=xab((ia1-1)+ib1)+
     1                       (binom(naind+ia1)*crda((na1+1)-ia1))*
     2                        binom(nbind+ib1)*crdb((nb1+1)-ib1)
   10   continue
   12 continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine psym1_cvb(civec1,civec2,osym,ientry)

use casvb_global, only: mxirrep, nalf, nbet, nda, ndb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: civec1(nda,ndb), osym(mxirrep)
real(kind=wp), intent(in) :: civec2(nda,ndb)
integer(kind=iwp), intent(in) :: ientry
integer(kind=iwp) :: iasyind(0:mxirrep), ibsyind(0:mxirrep), irpdet(mxirrep)
integer(kind=iwp), allocatable :: isymalf(:), isymbet(:)

call mma_allocate(isymalf,nda,label='isymalf')
call mma_allocate(isymbet,ndb,label='isymbet')

call symgen_cvb(nalf,nbet,nda,ndb,isymalf,isymbet,iasyind,ibsyind,irpdet)

call psym2_cvb(civec1,civec2,isymalf,isymbet,iasyind,ibsyind,osym,ientry)

call mma_deallocate(isymalf)
call mma_deallocate(isymbet)

return

end subroutine psym1_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LDF_AddConstraint(Constraint)
      Implicit None
      Integer Constraint
#include "localdf.fh"
      If (Constraint.le.-1) Then
         LDF_Constraint=-1
      Else If (Constraint.le.LDF_MXCONSTRAINT) Then
         LDF_Constraint=Constraint
      Else
         Call WarningMessage(2,'LDF constraint not recognized')
         Write(6,'(A,I10,A,I10)')
     &   'Constraint=',Constraint,' > ',LDF_MXCONSTRAINT
         Call Quit_OnUserError()
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
*               2006, Giovanni Ghigo                                   *
************************************************************************
      SubRoutine TrGrd_Alaska_(CGrad,CNames,GradIn,nGrad,iCen)
************************************************************************
*                                                                      *
*      Transforms a symmetry adapted gradient to unsymmetric form.     *
*                                                                      *
*       Written by Anders Bernhardsson                                 *
*       Adapted by Giovanni Ghigo                                      *
*       University of Torino, July 2006                                *
************************************************************************
      Use Basis_Info
      Use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8(a-h,o-z)
      Parameter (tol=1d-8)
#include "Molcas.fh"
#include "disp.fh"
#include "real.fh"
#include "SysDef.fh"
      Real*8 CGrad(3,MxAtom)
      Dimension GradIn(nGrad)
      Character CNames(MxAtom)*(LENIN5)
      Logical, External :: TF
*
      mdc=0
      iIrrep=0
*
      call dcopy_(3*MxAtom,[Zero],0,CGrad,1)
      iCen=0
*     nCnttp_Valence=0
*     Do iCnttp = 1, nCnttp
*        If (dbsc(iCnttp)%Aux) Go To 999
*        nCnttp_Valence = nCnttp_Valence+1
*     End Do
*999  Continue
*
      Do iCnttp=1,nCnttp
         If (.Not.(dbsc(iCnttp)%pChrg.or.
     &             dbsc(iCnttp)%Frag.or.
     &             dbsc(iCnttp)%Aux)) Then
            Do iCnt=1,dbsc(iCnttp)%nCntr
               mdc=mdc+1
               Do iCo=0,nIrrep/dc(mdc)%nStab-1
                  kop=dc(mdc)%iCoSet(iCo,0)
                  nDispS = IndDsp(mdc,iIrrep)
                  iCen=iCen+1
                  Do iCar=0,2
                     iComp = 2**iCar
                     If ( TF(mdc,iIrrep,iComp)) Then
                        nDispS = nDispS + 1
                        XR=DBLE(iPrmt(NrOpr(kop),icomp))
                        CGrad(iCar+1,iCen)=XR*GradIn(nDispS)
                     End If
                  End Do
                  CNames(iCen)=dc(mdc)%LblCnt
               End Do
            End Do
         End If
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2006, Markus Reiher                               *
************************************************************************
      subroutine finalize2 (length,operator,uused,utimes,u,uscrleng,
     *                      uscrchar)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 11.10.2006 (MR, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer length,uused,utimes(maxunumber),uscrleng(maxunumber),
     *        i,k,pos,idum,dummyleng
      character*(maxlength) operator
      character*(3) uscrchar(maxunumber)
      character*(4) u(maxunumber)
c
c--------------------------------------------------------------------------
c
1010  continue
      do 10 i=1,uused
        idum=0
        dummyleng=3
        if (uscrleng(i).eq.2) dummyleng=2
        pos=0
        pos=index(operator(1:length),uscrchar(i)(1:dummyleng))
        if (pos.gt.0) then
          idum=4-uscrleng(i)
          if (length+idum.gt.maxlength) then
            write (stdout,1050)
1050        format (2X,'SR finalize2: Parameter maxlength not large',
     *              ' enough!',//2X,'STOP.',/2X)
            CALL Abend
          endif
          do 20 k=length,pos+uscrleng(i),-1
            operator(k+idum:k+idum)=operator(k:k)
  20      continue
          operator(pos:pos+3)=u(i)
          length=length+idum
          utimes(i)=utimes(i)+1
          goto 1010
        endif
  10  continue
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     mv0zero
c     mc0c1a3b
c     mv0v1a3u
c     mr0u3wt
c     mc0c1at3b
c
c     ---------------
c
       subroutine mv0zero (dd,length,mat)
C
c      mat = 0
c
#include "ccsd1.fh"
       integer dd
       integer length
       real*8  mat(1:dd)
C
C      help variables
C
       integer init
       real*8  zero
       data    zero/0.0d0/
C
C
       if (mhkey.eq.1) then
c      ESSL

       call dcopy_(length,[zero],0,mat,1)
c
       else
c      Fortran matrix handling
C
       do 10 init=1,length
       mat(init) = zero
 10    continue
C
       end if
c
       return
       end
C
C-------------------------------------
c
       subroutine mc0c1a3b
     & (rowa,cola,rowb,colb,rowc,colc,
     & row,sum,col,a,b,c)
C
C     C = C + A*B
C
#include "ccsd1.fh"
       integer rowa,cola,rowb,colb,rowc,colc
       integer row,sum,col
       real*8  A(1:rowa,1:cola)
       real*8  B(1:rowb,1:colb)
       real*8  C(1:rowc,1:colc)
C
C      help variables
C
       integer i,j,k
c
       if (mhkey.eq.1) then
c      ESSL
       call DGEMM_('N','N',row,col,sum,1.0d0,a,rowa,b,rowb,
     & 1.0d0,c,rowc)
C
       else
c      Fortran matrix handling
C
       do 50 j=1, col
       do 40 k=1, sum
       do 30 i=1, row
       c(i,j) = c(i,j) + a(i,k)*b(k,j)
 30    continue
 40    continue
 50    continue
C
       end if
c
       return
       end
C
C-------------------------------------
C
       subroutine mv0v1a3u
     & (rowa,cola,ddx,ddy,
     & nopi,nopj,incx,incy,
     & a,x,y)
C
C     Y(iy) = Y(iy) + A * X(ix)
C
#include "ccsd1.fh"
       integer rowa,cola
       integer ddx, ddy
       integer nopi, nopj, incx, incy
       real*8  a(1:rowa,1:cola)
       real*8  x(1:ddx), y(1:ddy)
C
C      help variables
C
       integer i, j, ix, iy
c
       if (mhkey.eq.1) then
c      ESSL
c      call  dgemx(nopi,nopj,1.0d0,a,rowa,x,incx,y,incy)
       call dgemv_('N',nopi,nopj,1.0d0,a,rowa,x,incx,1.0d0,y,incy)
C
       else
c      Fortran matrix handling
C
C
       if (incx.eq.1.and.incy.eq.1) then
C
C      Inc's = 1
C
       do 30 j = 1, nopj
       do 20 i = 1, nopi
C
       y(i) = y(i) + a(i,j)*x(j)
 20    continue
 30    continue
C
       else
C
C      Other type inc's
c
       ix = 1
       do 60 j = 1, nopj
       iy = 1
       do 50 i = 1, nopi
       y(iy) = a(i,j)*x(ix) + y(iy)
       iy = iy + incy
 50    continue
       ix = ix + incx
 60    continue
C
       end if
C
       end if
c
       return
       end
C
C-------------------------------------
c
       subroutine mr0u3wt
     & (ddx, ddy,
     & nop, incx, incy,
     & x, y,
     & scal)
C
C     scalar = sum (x(ix) * y(iy))
C
#include "ccsd1.fh"
       integer ddx, ddy
       integer nop, incx, incy
       real*8  x(1:ddx), y(1:ddy)
       real*8  scal
       real*8 ddot_
C
C      help vraiables
C
       integer i, ix, iy
C
       if (mhkey.eq.1) then
c      ESSL
       scal=ddot_(nop,x,incx,y,incy)
C
       else
c      Fortran matrix handling
C
C      return for no operations
C
       scal = 0.0d0
       if (nop.le.0) return
C
       if (incx.eq.1.and.incy.eq.1) then
C
C      inc's = 1
C
       do 10 i = 1, nop
       scal = scal + x(i)*y(i)
 10    continue
C
       else
C
c      other type increments
C
       ix = 1
       iy = 1
       if (incx.lt.0) ix = 1-(nop-1)*incx
       if (incy.lt.0) iy = 1-(nop-1)*incy
C
       do 20 i = 1,nop
       scal = scal + x(ix)*y(iy)
       ix = ix + incx
       iy = iy + incy
 20    continue
C
       end if
C
       end if
c
       return
       end
C
C---------------------------------------
C
       subroutine mc0c1at3b
     & (rowa,cola,rowb,colb,rowc,colc,
     & row,sum,col,
     & a,b,c)
C
C     C= A(T)*B
C
#include "ccsd1.fh"
       integer rowa,cola,rowb,colb,rowc,colc
       integer row,sum,col
       real*8  a(1:rowa,1:cola)
       real*8  b(1:rowb,1:colb)
       real*8  c(1:rowc,1:colc)
C
C      help variables
C
       integer i,j,k
C
       if (mhkey.eq.1) then
c      ESSL
       call DGEMM_('T','N',row,col,sum,1.0d0,a,rowa,b,rowb,
     & 1.0d0,c,rowc)
C
       else
c      Fotran
C
       do 30 j=1, col
       do 20 i=1, row
       do 10 k=1, sum
       c(i,j) = c(i,j) + a(k,i)*b(k,j)
 10    continue
 20    continue
 30    continue
C
       end if
c
       return
       end
C

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CSDTVC_MCLR_1(CSFVEC,DETVEC,DTOCMT,ICTSDT,IREFSM,ICOPY)
! CSF to DETERMINANT TRANSFORMATION
!
! ICOPY /= 0 : Copy output into input
!              so input becomes output while
!              output remains output

use MCLR_Data, only: NCNATS, NCPCNT, NDPCNT, NDTASM, NTYP
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: CSFVEC(*)
real(kind=wp), intent(_OUT_) :: DETVEC(*)
real(kind=wp), intent(in) :: DTOCMT(*)
integer(kind=iwp), intent(in) :: ICTSDT(*), IREFSM, ICOPY
integer(kind=iwp) :: ICNF, ICSF, IDET, IOFFCD, IOFFCS, IOFFDT, ITYP, NDET

NDET = NDTASM(IREFSM)

! ===========================
!  CSF to DET transformation
! ===========================

DETVEC(1:NDET) = Zero
! Multiply with  expansion matrix
IOFFCS = 1
IOFFDT = 1
IOFFCD = 1
do ITYP=1,NTYP
  IDET = NDPCNT(ITYP)
  ICSF = NCPCNT(ITYP)
  ICNF = NCNATS(ITYP,IREFSM)
  if (ITYP > 1) then
    IOFFCS = IOFFCS+NCNATS(ITYP-1,IREFSM)*NCPCNT(ITYP-1)
    IOFFDT = IOFFDT+NCNATS(ITYP-1,IREFSM)*NDPCNT(ITYP-1)
    IOFFCD = IOFFCD+NDPCNT(ITYP-1)*NCPCNT(ITYP-1)
  end if
  if (IDET*ICNF*ICSF > 0) call DGEMM_('N','N',IDET,ICNF,ICSF,ONE,DTOCMT(IOFFCD),IDET,CSFVEC(IOFFCS),ICSF,ZERO,DETVEC(IOFFDT),IDET)
end do
! Sign changes
CSFVEC(1:NDET) = DETVEC(1:NDET)
! Change to string ordering
call SCAVCS(DETVEC,CSFVEC,ICTSDT,NDET)
if (ICOPY /= 0) CSFVEC(1:NDET) = DETVEC(1:NDET)

end subroutine CSDTVC_MCLR_1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine PVMem(nHer,Mem,la,lb,lr,KrnMem)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: nHer, Mem
integer(kind=iwp), intent(in) :: la, lb, lr
external :: KrnMem
integer(kind=iwp) :: MemNA1, MemNA2

call KrnMem(nHer,MemNA1,la+1,lb,lr-1)

if (la /= 0) then
  call KrnMem(nHer,MemNA2,la-1,lb,lr-1)
else
  MemNA2 = 0
end if

Mem = max(MemNA1,MemNA2)

return

end subroutine PVMem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Make_Labels(LblCbs,LblSbs,MxFnc,lMax)
      Implicit Real*8 (a-h,o-z)
#include "angtp.fh"
      Character*8 LblCBs(MxFnc), LblSBs(MxFnc)
      Character Sgn*3
!#define _DEBUGPRINT_
*
*---- Generate cartesian labels
*
      lxyz=0
      Do ixyz = 0, lMax
         Do ix = ixyz, 0, -1
            iyMax=ixyz-ix
            Do iy = iyMax, 0 , -1
               lxyz=lxyz+1
               iz=ixyz-ix-iy
*              Form labels for cartesian basis functions
               Write (LblCBs(lxyz),'(A,3I2.2)') AngTp(ixyz),ix,iy,iz
            End Do
         End Do
      End Do
      If (lMax.ge.0) LblCBs(1) = '01s     '
      If (lMax.ge.1) Then
         LblCBs(2) = '02px    '
         LblCBs(3) = '02py    '
         LblCBs(4) = '02pz    '
      End If
*
*     Do the same for the spherical gaussians.
*
      i = 0
      Do n = 0, lMax
         Do l = n, 0, -2
            Do m = -l, l
               If (m.lt.0) Then
                  Sgn='-  '
               Else If (m.gt.0) Then
                  Sgn='+  '
               Else
                  Sgn='   '
               End If
               i=i+1
               Write (LblSbs(i),'(I2.2,A,I2.2,A)')
     &            n+1,AngTp(l),Abs(m),Sgn
            End Do
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'lMax,MxFnc=',lMax,MxFnc
      Write (6,*)
      Write (6,*) 'LblCBs:'
      Do ixyz = 1, lxyz
         Write (6,'(A)')LblCBs(ixyz)
      End Do
      Write (6,*) 'LblSBs:'
      Do ixyz = 1, i
         Write (6,'(A)')LblCBs(ixyz)
      End Do
      Write (6,*)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine VECSMDP(VEC1,VEC2,FAC1,FAC2,LU1,LU2,LU3,IREW,LBLK)
! DISC VERSION OF VECSUM :
!
! ADD BLOCKED VECTORS ON FILES LU1 AND LU2
! AND STORE ON LU3
!
! Packed version, May 1996
!
! LBLK DEFINES STRUCTURE OF FILE

use lucia_data, only: IDISK
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: VEC1(*), VEC2(*)
real(kind=wp), intent(in) :: FAC1, FAC2
integer(kind=iwp), intent(in) :: LU1, LU2, LU3, IREW, LBLK
integer(kind=iwp) :: IAMPACK, IDUMMY(1), IMZERO1, IMZERO2, KBLK, NBL1, NBL2, NO_ZEROING

if (IREW /= 0) then
  IDISK(LU1) = 0
  IDISK(LU2) = 0
  IDISK(LU3) = 0
end if

! LOOP OVER BLOCKS OF VECTOR

do

  if (LBLK > 0) then
    NBL1 = LBLK
    NBL2 = LBLK
  else if (LBLK == 0) then
    call IDAFILE(LU1,2,IDUMMY,1,IDISK(LU1))
    NBL1 = IDUMMY(1)
    call IDAFILE(LU2,2,IDUMMY,1,IDISK(LU2))
    NBL2 = IDUMMY(1)
    IDUMMY(1) = NBL1
    call IDAFILE(LU3,1,IDUMMY,1,IDISK(LU3))
  else if (LBLK < 0) then
    call IDAFILE(LU1,2,IDUMMY,1,IDISK(LU1))
    NBL1 = IDUMMY(1)
    call IDAFILE(LU1,2,IDUMMY,1,IDISK(LU1))
    call IDAFILE(LU2,2,IDUMMY,1,IDISK(LU2))
    NBL2 = IDUMMY(1)
    call IDAFILE(LU2,2,IDUMMY,1,IDISK(LU2))
    IDUMMY(1) = NBL1
    call IDAFILE(LU3,1,IDUMMY,1,IDISK(LU3))
    IDUMMY(1) = -1
    call IDAFILE(LU3,1,IDUMMY,1,IDISK(LU3))
  end if
  if (NBL1 /= NBL2) then
    write(u6,'(A,2I5)') 'DIFFERENT BLOCKSIZES IN VECSMD ',NBL1,NBL2
    !stop ' INCOMPATIBLE BLOCKSIZES IN VECSMF'
    call SYSABENDMSG('lucia_util/vecsmf','Different block sizes','')
  end if

  if (NBL1 >= 0) then
    if (LBLK >= 0) then
      KBLK = NBL1
    else
      KBLK = -1
    end if
    NO_ZEROING = 1
    call FRMDSC2(VEC1,NBL1,KBLK,LU1,IMZERO1,IAMPACK,NO_ZEROING)
    call FRMDSC2(VEC2,NBL1,KBLK,LU2,IMZERO2,IAMPACK,NO_ZEROING)
    if (NBL1 > 0) then
      if ((IMZERO1 == 1) .and. (IMZERO2 == 1)) then
        ! Simple zero record
        call ZERORC(LU3,IAMPACK)
      else
        ! Nonvanishing record
        if (IMZERO1 == 1) then
          VEC1(1:NBL1) = FAC2*VEC2(1:NBL1)
        else if (IMZERO2 == 1) then
          VEC1(1:NBL1) = FAC1*VEC1(1:NBL1)
        else
          VEC1(1:NBL1) = FAC1*VEC1(1:NBL1)+FAC2*VEC2(1:NBL1)
        end if
        call TODSCP(VEC1,NBL1,KBLK,LU3)
      end if
    else if (NBL1 == 0) then
      call TODSCP(VEC1,NBL1,KBLK,LU3)
    end if
  end if

  if ((NBL1 < 0) .or. (LBLK > 0)) exit

end do

end subroutine VECSMDP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_SetRed(Diag,Sync)
!
! Purpose: set next reduced set after synchronizing the global
!          diagonal (if requested through flag Sync).
!          Global as well as local reduced sets are set.
!          Diag is the local diagonal, whereas Diag_G (defined in
!          Cholesky) points to the global diagonal.
!          Note that Diag is not referenced if Sync=.False.

use Cholesky, only: Cho_Real_Par, Diag_G
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*)
logical(kind=iwp), intent(in) :: Sync
integer(kind=iwp) :: iLoc

if (Cho_Real_Par) then

  ! Sync global diagonal.
  ! ---------------------

  if (Sync) then
    iLoc = 2
    call Cho_P_SyncDiag(Diag,iLoc)
  end if

  ! Set next global reduced set. The original serial routines
  ! are used and so we must trick them by first swapping global
  ! and local index arrays (and then swap back, of course).
  ! -----------------------------------------------------------

  call Cho_P_IndxSwp()
  call Cho_SetRed(Diag_G)
  call Cho_P_IndxSwp()

  ! Set next local reduced set.
  ! ---------------------------

  call Cho_P_SetRed_L()

else

  call Cho_SetRed(Diag)

end if

end subroutine Cho_P_SetRed

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SODIAG(UMATR, UMATI, NSS)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "Morsel.fh"
#include "Struct.fh"
#include "SysDef.fh"
#include "WrkSpc.fh"
#include "rassi.fh"
#include "prgm.fh"
#include "rasdef.fh"
#include "jobin.fh"
#include "symmul.fh"
#include "constants.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='SODIAG')

C subroutine arguments
      REAL*8 UMATR(NSS,NSS),UMATI(NSS,NSS)


      COMPLEX*16 PROP(3,SODIAGNSTATE,SODIAGNSTATE)
      COMPLEX*16 PROP2(3,SODIAGNSTATE,SODIAGNSTATE)
      REAL*8 DEIGVAL(SODIAGNSTATE)
      COMPLEX*16 DEIGVEC(SODIAGNSTATE,SODIAGNSTATE)
      COMPLEX*16 BPTST(SODIAGNSTATE,SODIAGNSTATE)

      REAL*8 GTENS(3),MAXES(3,3),MAXES2(3,3)
      COMPLEX*16 H_ZEE(SODIAGNSTATE,SODIAGNSTATE)
      COMPLEX*16 ZOUT(SODIAGNSTATE,SODIAGNSTATE)

      REAL*8 RWORK(3*SODIAGNSTATE-2)
      COMPLEX*16 ZWORK(2*SODIAGNSTATE-1)

      REAL*8 IDENTMAT(3,3)
      REAL*8 LMATR(SODIAGNSTATE,SODIAGNSTATE,3,3)
      REAL*8 LMATI(SODIAGNSTATE,SODIAGNSTATE,3,3)
      REAL*8 SMATR(SODIAGNSTATE,SODIAGNSTATE,3,3)
      REAL*8 SMATI(SODIAGNSTATE,SODIAGNSTATE,3,3)
      REAL*8 MUMAT2R(SODIAGNSTATE,SODIAGNSTATE,3,3)
      REAL*8 MUMAT2I(SODIAGNSTATE,SODIAGNSTATE,3,3)

      REAL*8 MU_BOHR

C For creating the filename of the ORB file
      CHARACTER*11 FILEBASE
      CHARACTER*11 FILEBASEL

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C Matrices
C
C PROP, PROP2 Storage for expectation values (all directions)
C UMATR,I     Transformation matrix (real, imaginary parts)
C NSS         Number of spin states
C DEIGVAL     Storage for eigenvalues (REAL!)
C DEIGVEC     Storage for eigenvectors
C BPTST       Storage for some testing

      ge=-(CONST_ELECTRON_G_FACTOR_)
      MU_BOHR=CONST_BOHR_MAGNETON_IN_SI_*
     &        (CONV_AU_TO_CM1_/CONV_AU_TO_KJ_/1.0D3) ! in cm-1/T

      WRITE(6,*)
      WRITE(6,*)
      WRITE(6,*) "***********************************************"
      WRITE(6,*) "* STARTING SODIAG *****************************"
      WRITE(6,*) "***********************************************"
      WRITE(6,*)
      WRITE(6,*)

      N=SODIAGNSTATE
      WRITE(6,*) "Number of states to be diagonalized: ",N
      WRITE(6,*) "STATES:"
      DO I = 1,N
        WRITE(6,*) IWORK(LSODIAG-1+I)
      END DO

      CALL DCOPY_(9*N**2,[0.0d0],0,LMATR,1)
      CALL DCOPY_(9*N**2,[0.0d0],0,LMATI,1)
      CALL DCOPY_(9*N**2,[0.0d0],0,SMATR,1)
      CALL DCOPY_(9*N**2,[0.0d0],0,SMATI,1)
      CALL DCOPY_(9*N**2,[0.0d0],0,MUMAT2R,1)
      CALL DCOPY_(9*N**2,[0.0d0],0,MUMAT2I,1)

      CALL GETMEM('DMATTMPA','ALLO','REAL',LDMATTMP,3*(NBST*(NBST+1)))

      !> identity mat
      IDENTMAT(:,:)=0.0D0
      DO I = 1,3
        IDENTMAT(I,I)=1.0D0
      END DO

C First, we calculate the expectation values of
C  (L+ge*S)x (L+ge*S)y (L+ge*S)z
C These get stored in PROP()

C Only work with one triangle - this is a hermitian matrix
      DO J=1,N
      DO I=1,J

        ISTATE=IWORK(LSODIAG-1+I)
        JSTATE=IWORK(LSODIAG-1+J)
        WRITE(6,*) "States: ",ISTATE,JSTATE

        iOpt=0
        CALL SONATORBM('ANTISING',UMATR,UMATI,
     &                 ISTATE,JSTATE,NSS,iOpt,IDENTMAT,
     &                 WORK(LDMATTMP))

        IC=-1
        iOpt=1
        CALL SONATORBM_INT(WORK(LDMATTMP),'ANGMOM  ',IC,'ANTISING',
     &                     ISTATE,JSTATE,NSS,iOpt,IDENTMAT,
     &                     AXR,AYR,AZR,AXI,AYI,AZI)

        iOpt=1
        CALL SONATORBM('HERMTRIP',UMATR,UMATI,
     &                 ISTATE,JSTATE,NSS,iOpt,IDENTMAT,
     &                 WORK(LDMATTMP))

        IC=1
        iOpt=0
        CALL SONATORBM_INT(WORK(LDMATTMP),'MLTPL  0',IC,'HERMTRIP',
     &                    ISTATE,JSTATE,NSS,iOpt,IDENTMAT,
     &                    SXR,SYR,SZR,SXI,SYI,SZI)


c The first index of PROP is the direction
        PROP(1,I,J)=-1.0d0*DCMPLX(AXR+ge*SXR,AXI+ge*SXI)
        PROP(2,I,J)=-1.0d0*DCMPLX(AYR+ge*SYR,AYI+ge*SYI)
        PROP(3,I,J)=-1.0d0*DCMPLX(AZR+ge*SZR,AZI+ge*SZI)

        IF(I.NE.J) THEN
          PROP(1,J,I)=DCONJG(PROP(1,I,J))
          PROP(2,J,I)=DCONJG(PROP(2,I,J))
          PROP(3,J,I)=DCONJG(PROP(3,I,J))
        END IF


      END DO
      END DO

C      CALL ADD_INFO("SODIAG_PROP",PROP,3*SODIAGNSTATE**2,4)


c Calculate the atens as in single_aniso
      CALL ATENS_RASSI(PROP,N,GTENS,MAXES,IPGLOB)


      do l=1,3
         do i=1,N
            do j=1,N
      PROP2(l,i,j)=(0.d0,0.d0)
               do k=1,3
      PROP2(l,i,j) = PROP2(l,i,j) + PROP(k,i,j) * maxes(k,l)
               enddo
            enddo
         enddo
      enddo


      call atens_RASSI(PROP2, N, GTENS, MAXES2, 2)

c Diagonalize along each direction
C LOOP OVER THE DIRECTIONS
      DO IDIR=1,3



c  apply the magnetic field along the main iDir axis
      do I=1,N
        DEIGVAL(I)=0.d0

        do J=1,N
          H_ZEE(I,J)=(0.d0,0.d0)
          DEIGVEC(I,J)=(0.d0,0.d0)
        enddo
      enddo

      do I=1,N
        do J=1,N
          H_ZEE(I,J)=H_ZEE(I,J) - MU_BOHR * PROP2(IDIR,I,J)
        enddo
      enddo

      IF(IPGLOB.GE.DEBUG) THEN
        WRITE(6,*) "BP: H_ZEE: "
        WRITE(6,*) H_ZEE
        WRITE(6,*) "BP: PROP: "
        WRITE(6,*) "L+2S in main axis direction (after rotation)",IDIR
        DO I=1,N
        DO J=1,N

          WRITE(6,*) "I,J",IWORK(LSODIAG-1+I),IWORK(LSODIAG-1+J),
     &                PROP2(IDIR, I,J)

        END DO
        END DO

        WRITE(6,*)
        WRITE(6,*)
        WRITE(6,*)
        WRITE(6,*) "Direction: ",IDIR
        WRITE(6,*) "H_ZEE Before Diagonalization"

        DO I=1,N
        DO J=1,N
          ISTATE=IWORK(LSODIAG-1+I)
          JSTATE=IWORK(LSODIAG-1+J)
          WRITE(6,*) ISTATE,JSTATE,H_ZEE(I,J)
        END DO
        END DO
      END IF

c DIAGONALIZE
      lcwork = (2*n-1); info = 0
      call zheev('V','U',n,h_zee,n,deigval,zwork,lcwork,
     &           rwork,info)

      !> put eigenvectors in deigvec
      call zcopy(n**2,h_zee,1,deigvec,1)

      IF(INFO.NE.0) THEN
        WRITE(6,*) "DIAGONALIZATION FAILED! ERROR: ",INFO
        CALL ABEND()
      END IF


      IF(IPGLOB.GE.DEBUG) THEN
        WRITE(6,*) "EIGENVALUES OF L+ge*S in direction: ",IDIR
        WRITE(6,*) DEIGVAL
        WRITE(6,*) "EIGENVECTORS OF L+ge*S: "
        DO I=1,N
        DO J=1,N
          WRITE(6,*) I,J,DEIGVEC(I,J)
        END DO
        END DO


CCCCCCCCCCCCCCCC
C Test the eigenvectors
CCCCCCCCCCCCCCCC
      WRITE(6,*) "TESTING EIGENVECTORS"


        CALL ZGEMM('C','N',N,N,N,
     &           (1.0d0,0.0d0),DEIGVEC,N,DEIGVEC,N,(0.0d0,0.0d0),
     &            BPTST,N)


        WRITE(6,*) "V*V: Should be real unit matrix"
        DO I=1,N
        DO J=1,N
          ISTATE=IWORK(LSODIAG-1+I)
          JSTATE=IWORK(LSODIAG-1+J)
          WRITE(6,*) ISTATE,JSTATE,BPTST(I,J)
        END DO
        END DO

CCCCCCCCCCCCCCC
C END testing the eigenvectors
CCCCCCCCCCCCCCCC
      END IF ! IPGLOB >= DEBUG


C CALL SPIN_PHASE FROM THE OTHER CODE (at the bottom of this file)
c      SUBROUTINE SPIN_PHASE(IPGLOB,DIPSO2,GMAIN,DIM,ZIN,ZOUT)
      do i=1,N
        do j=1,N
        ZOUT(i,j) = (0.d0,0.d0)
        enddo
      enddo

      call SPIN_PHASE_RASSI(2,PROP2,GTENS,N,DEIGVEC,ZOUT)


c EXPAND EIGENVECTORS TO SEPARATE R,I MATRICES AND
c AS A PART OF AN IDENTITY MATRIX
      CALL GETMEM('SODEIGR','ALLO','REAL',LEIGVECR,NSS**2)
      CALL GETMEM('SODEIGI','ALLO','REAL',LEIGVECI,NSS**2)

      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LEIGVECR),1)
      CALL DCOPY_(NSS**2,[0.0D0],0,WORK(LEIGVECI),1)

      DO I=1,NSS
      DO J=1,NSS
        IJ=NSS*(J-1)+I
        WORK(LEIGVECI-1+IJ)=0.0d0
        IF(I.EQ.J) THEN
          WORK(LEIGVECR-1+IJ)=1.0d0
        ELSE
          WORK(LEIGVECR-1+IJ)=0.0d0
        END IF
      END DO
      END DO

      DO I=1,N
      DO J=1,N
        I2=IWORK(LSODIAG-1+I)
        J2=IWORK(LSODIAG-1+J)

        IJ=NSS*(J2-1)+I2
        WRITE(6,*) I2,J2,IJ
        WORK(LEIGVECR-1+IJ)=REAL(ZOUT(I,J))
        WORK(LEIGVECI-1+IJ)=AIMAG(ZOUT(I,J))
      END DO
      END DO

c      WRITE(6,*) "EIGENVECTORS SPLIT INTO REAL/IMAG PARTS"
c      DO I=1,NSS
c      DO J=1,NSS
c        IJ=NSS*(J-1)+I
c        WRITE(6,*) I,J,WORK(LEIGVECR-1+IJ)
c        WRITE(6,*) I,J,WORK(LEIGVECI-1+IJ)
c      END DO
c      END DO


c Multiply by SO eigenvectors to get new UW matrix

      CALL GETMEM('SONUWR','ALLO','REAL',LUWR,NSS**2)
      CALL GETMEM('SONUWI','ALLO','REAL',LUWI,NSS**2)

      CALL DGEMM_('N','N',NSS,NSS,NSS,1.0d0,
     &           UMATR,NSS,WORK(LEIGVECR),NSS,0.0d0,WORK(LUWR),NSS)
      CALL DGEMM_('N','N',NSS,NSS,NSS,1.0d0,
     &           UMATI,NSS,WORK(LEIGVECR),NSS,0.0d0,WORK(LUWI),NSS)
      CALL DGEMM_('N','N',NSS,NSS,NSS,1.0d0,
     &           UMATR,NSS,WORK(LEIGVECI),NSS,1.0d0,WORK(LUWI),NSS)
      CALL DGEMM_('N','N',NSS,NSS,NSS,-1.0d0,
     &           UMATI,NSS,WORK(LEIGVECI),NSS,1.0d0,WORK(LUWR),NSS)


c REDO USING SONATORB_MIX

      DO I=1,SODIAGNSTATE
      DO J=1,SODIAGNSTATE

        ISTATE=IWORK(LSODIAG-1+I)
        JSTATE=IWORK(LSODIAG-1+J)

        IJ=J*(J-1)/2+I

        WRITE(6,*) "State: ",ISTATE,JSTATE

c file name for the spin density orb file
        IF(IDIR.EQ.1) FILEBASE='SODISDENS.X'
        IF(IDIR.EQ.2) FILEBASE='SODISDENS.Y'
        IF(IDIR.EQ.3) FILEBASE='SODISDENS.Z'
        IF(IDIR.EQ.1) FILEBASEL='SODILDENS.X'
        IF(IDIR.EQ.2) FILEBASEL='SODILDENS.Y'
        IF(IDIR.EQ.3) FILEBASEL='SODILDENS.Z'


C For L, mix the AO integrals, leave the density alone
C    -> Call SONATORB then SONATORBM_INT
C For S, leave AO integrals alone, mix density matrices
c    -> Call SONATORBM, SONATORBM_INT


c store antising density in LDMATTMP
        iOpt=0
        CALL SONATORBM('ANTISING',WORK(LUWR),WORK(LUWI),
     &                 ISTATE,JSTATE,NSS,iOpt,IDENTMAT,
     &                 WORK(LDMATTMP))


c Expectation values of L -> LMAT{R,I}
        IC=-1
        iOpt=1
        CALL SONATORBM_INT(WORK(LDMATTMP),'ANGMOM  ',IC,'ANTISING',
     &                    ISTATE,JSTATE,NSS,iOpt,MAXES,
     &                    LMATR(I,J,IDIR,1),LMATR(I,J,IDIR,2),
     &                    LMATR(I,J,IDIR,3),
     &                    LMATI(I,J,IDIR,1),LMATI(I,J,IDIR,2),
     &                    LMATI(I,J,IDIR,3))

c Plot for generation of current density
        IF(IFCURD) THEN
          CALL SONATORB_CPLOT(WORK(LDMATTMP),FILEBASEL,'ANTISING',
     &                        ISTATE,JSTATE)
        END IF


c store hermtrip density in LDMATTMP
        iOpt=1
        CALL SONATORBM('HERMTRIP',WORK(LUWR),WORK(LUWI),
     &                 ISTATE,JSTATE,NSS,iOpt,MAXES,
     &                 WORK(LDMATTMP))

c Expectation values of S -> SMAT{R,I}
        IC=1
        iOpt=0
        CALL SONATORBM_INT(WORK(LDMATTMP),'MLTPL  0',IC,'HERMTRIP',
     &                     ISTATE,JSTATE,NSS,iOpt,IDENTMAT,
     &                     SMATR(I,J,IDIR,1),SMATR(I,J,IDIR,2),
     &                     SMATR(I,J,IDIR,3),
     &                     SMATI(I,J,IDIR,1),SMATI(I,J,IDIR,2),
     &                     SMATI(I,J,IDIR,3))

c plot the rotated density
        CALL SONATORB_PLOT(WORK(LDMATTMP),FILEBASE,'HERMTRIP',
     &                     ISTATE,JSTATE)

      END DO
      END DO

c write the magnetic axes to a file
      write(6,*) "Writing magnetic axes to file SODIAG.MAXES"
      LUMAXES=54
      LUMAXES=IsFreeUnit(LUMAXES)
      CALL Molcas_Open(LUMAXES,'SODIAG.MAXES')
      WRITE(LUMAXES,*) MAXES
      CLOSE(LUMAXES)

      CALL GETMEM('SONUWR','FREE','REAL',LUWR,NSS**2)
      CALL GETMEM('SONUWI','FREE','REAL',LUWI,NSS**2)
      CALL GETMEM('SODEIGR','FREE','REAL',LEIGVECR,2*N**2)
      CALL GETMEM('SODEIGI','FREE','REAL',LEIGVECI,2*N**2)

      END DO ! end loop over directions


c Final output
      CALL DCOPY_(9*SODIAGNSTATE**2,LMATR,1,MUMAT2R,1)
      CALL DCOPY_(9*SODIAGNSTATE**2,LMATI,1,MUMAT2I,1)
      CALL DSCAL_(9*SODIAGNSTATE**2,-1.0d0,MUMAT2R,1)
      CALL DSCAL_(9*SODIAGNSTATE**2,-1.0d0,MUMAT2I,1)
      CALL DAXPY_(9*SODIAGNSTATE**2,-1.0d0*ge,SMATR,1,MUMAT2R,1)
      CALL DAXPY_(9*SODIAGNSTATE**2,-1.0d0*ge,SMATI,1,MUMAT2I,1)

C we are only interested in the 1,1 state
      WRITE(6,*) '-----------------------------------------------------'
      WRITE(6,*) "Final output after diagonalizing along all directions"
      WRITE(6,'(A9,A15,A15,A15)') '','X','Y','Z'
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Re(Mux)',
     &             MUMAT2R(1,1,1,1),MUMAT2R(1,1,2,1),MUMAT2R(1,1,3,1)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Im(Mux)',
     &             MUMAT2I(1,1,1,1),MUMAT2I(1,1,2,1),MUMAT2I(1,1,3,1)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Re(Muy)',
     &             MUMAT2R(1,1,1,2),MUMAT2R(1,1,2,2),MUMAT2R(1,1,3,2)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Im(Muy)',
     &             MUMAT2I(1,1,1,2),MUMAT2I(1,1,2,2),MUMAT2I(1,1,3,2)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Re(Muz)',
     &             MUMAT2R(1,1,1,3),MUMAT2R(1,1,2,3),MUMAT2R(1,1,3,3)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Im(Muy)',
     &             MUMAT2I(1,1,1,3),MUMAT2I(1,1,2,3),MUMAT2I(1,1,3,3)
      WRITE(6,*)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Re(Lx)',
     &             LMATR(1,1,1,1),LMATR(1,1,2,1),LMATR(1,1,3,1)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Im(Lx)',
     &             LMATI(1,1,1,1),LMATI(1,1,2,1),LMATI(1,1,3,1)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Re(Ly)',
     &             LMATR(1,1,1,2),LMATR(1,1,2,2),LMATR(1,1,3,2)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Im(Ly)',
     &             LMATI(1,1,1,2),LMATI(1,1,2,2),LMATI(1,1,3,2)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Re(Lz)',
     &             LMATR(1,1,1,3),LMATR(1,1,2,3),LMATR(1,1,3,3)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Im(Ly)',
     &             LMATI(1,1,1,3),LMATI(1,1,2,3),LMATI(1,1,3,3)
      WRITE(6,*)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Re(Sx)',
     &             SMATR(1,1,1,1),SMATR(1,1,2,1),SMATR(1,1,3,1)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Im(Sx)',
     &             SMATI(1,1,1,1),SMATI(1,1,2,1),SMATI(1,1,3,1)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Re(Sy)',
     &             SMATR(1,1,1,2),SMATR(1,1,2,2),SMATR(1,1,3,2)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Im(Sy)',
     &             SMATI(1,1,1,2),SMATI(1,1,2,2),SMATI(1,1,3,2)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Re(Sz)',
     &             SMATR(1,1,1,3),SMATR(1,1,2,3),SMATR(1,1,3,3)
      WRITE(6,'(A9,F20.12,F20.12,F20.12)')'Im(Sy)',
     &             SMATI(1,1,1,3),SMATI(1,1,2,3),SMATI(1,1,3,3)
      WRITE(6,*) '-----------------------------------------------------'

C      CALL ADD_INFO("SODIAG_MUMAT2R",MUMAT2R,9*N*N,4)
C      CALL ADD_INFO("SODIAG_MUMAT2I",MUMAT2R,9*N*N,4)
C      CALL ADD_INFO("SODIAG_LMATR",LMATR,9*N*N,4)
C      CALL ADD_INFO("SODIAG_LMATI",LMATI,9*N*N,4)
C      CALL ADD_INFO("SODIAG_SMATR",SMATR,9*N*N,4)
C      CALL ADD_INFO("SODIAG_SMATI",SMATI,9*N*N,4)

      WRITE(6,*)
      WRITE(6,*) "***********************************************"
      WRITE(6,*) "* ENDING SODIAG *******************************"
      WRITE(6,*) "***********************************************"

      CALL GETMEM('DMATTMPA','FREE','REAL',LDMATTMP,3*(NBST*(NBST+1)))

      RETURN
      END





      SUBROUTINE SPIN_PHASE_RASSI(IPGLOB,DIPSO2,GMAIN,DIM,ZIN,ZOUT)
C
C     The RASSI program gives a random phase to the spin-orbit functions.
C
C     This routine performs a simple check with the obtained spin functions,
C     in order to determine the phase of the spin functions.
C     IF the phase is not the same, then the spin functions will be multiplied
C     with the correspondind coefficient that sets the same phase to all spin
C     eigenfunctions
C

      INTEGER  l,i,j,i1,i2,NPAR,ms1,ms2,DIM, IPGLOB

      REAL*8  GMAIN(3), ALFA(DIM)

      COMPLEX*16  PHS(3,DIM,DIM), ZIN(DIM,DIM), DIPSO2(3,DIM,DIM),
     & Spin2(3,DIM,DIM), PHSA(DIM,DIM), PHSA2(DIM,DIM),
     & ZOUT(DIM,DIM)

#include "spin.fh"

C Determine the Parity:
      NPAR=MOD(DIM,2)

C  Change the basis of the magnetic moment matrices from the RASSI functions to the
C  effective spin eigenfunctions-- eigenfunctions of the Mu_Z
C
      do L=1,3
       do I=1,DIM
        do J=1,DIM
      PHS(L,I,J)  =(0.d0,0.d0)
      SPIN2(L,I,J)=(0.d0,0.d0)
      PHSA(I,J)   =(0.d0,0.d0)
      PHSA2(I,J)  =(0.d0,0.d0)
        enddo
       enddo
      enddo

      do l=1,3
        do i=1,DIM
          do j=1,DIM
            do i1=1,DIM
              do i2=1,DIM
      PHS(l,i,j)=PHS(l,i,j)+DIPSO2(l,i1,i2)*DCONJG(ZIN(i1,i))*
     & ZIN(i2,j)
              enddo
            enddo
          enddo
        enddo
      enddo


CC Rewrite the Spin m.e. in a new basis:

      i=0
      do ms1=(DIM-NPAR)/2,-(DIM-NPAR)/2,-1
      if((ms1.eq.0).AND.(NPAR.EQ.0)) goto 18
      i=i+1
      j=0
      do ms2=(DIM-NPAR)/2,-(DIM-NPAR)/2,-1
      if((ms2.eq.0).AND.(NPAR.EQ.0)) goto 17
      j=j+1
      Spin2(1,i,j)=Spin(1,DIM,ms1,ms2)
      Spin2(2,i,j)=Spin(2,DIM,ms1,ms2)
      Spin2(3,i,j)=Spin(3,DIM,ms1,ms2)
17    continue
      enddo
18    continue
      enddo

      do i=1,DIM
         do j=1,DIM
      if(Spin2(1,i,j).EQ.(0.0d0,0.0d0)) goto 20
      PHSA2(i,j)=PHS(1,i,j)/(GMAIN(1)*Spin2(1,i,j))
      PHSA(i,j)=(0.0d0,-1.0d0)*LOG(PHSA2(i,j))
20    continue
         enddo
      enddo

      do I=1,DIM
      ALFA(I)=0.0d0
      enddo

      do I=2,DIM
      ALFA(I)=ALFA(I-1)+DBLE(PHSA(I-1,I))
      enddo

      do i=1,DIM
        do J=1,DIM
      ZOUT(J,I)=(0.0d0,0.0d0)
      ZOUT(J,I)=EXP((0.0d0,-1.0d0)*ALFA(i))*ZIN(j,i)
        enddo
      enddo

      if(IPGLOB.GT.2) then
      write(6,'(/)')
      write(6,'( 5x,a)')  'MAGNETIC MOMENT MATRIX ELEMENTS IN THE '//
     &'BASIS OF SPIN EIGENFUNCTIONS -- PHS(ic,i,j)'
      write(6,*)
      do l=1,3
      write(6,'(5x,a,i2)') 'PROJECTION=', l
      write(6,*)
        do i=1,DIM
        write(6,'(16(2F12.8,2x))') (PHS(l,i,j), j=1,DIM)
        enddo
      enddo
      write(6,'(5x,a)') 'Spin2(1,i,j)'
      do i=1,DIM
      write(6,'(3x,16(2F12.6,2x))') (Spin2(1,i,j),j=1,DIM)
      enddo
      write(6,'(5x,a)') 'Spin2(2,i,j)'
      do i=1,DIM
      write(6,'(3x,16(2F12.6,2x))') (Spin2(2,i,j),j=1,DIM)
      enddo
      write(6,'(5x,a)') 'PHSA2(i,j)'
      do i=1,DIM
      write(6,'(3x,16(2F12.6,2x))') (PHSA2(i,j),j=1,DIM)
      enddo
      write(6,'(5x,a)') 'PHSA(i,j)'
      do i=1,DIM
      write(6,'(3x,16(2F12.6,2x))') (PHSA(i,j),j=1,DIM)
      enddo
      write(6,'(5x,a)') 'ALFA'
      write(6,'(3x,16(2F12.6,2x))') (ALFA(j),j=1,DIM)
      write(6,'(5x,a)') 'ZOUT'
      do j=1,DIM
      write(6,'(3x,16(2F12.6,2x))') (ZOUT(i,j),i=1,DIM)
      enddo
      endif

      RETURN
      END




      SUBROUTINE ATENS_RASSI(moment, dim, gtens, maxes, IPGLOB)

      IMPLICIT NONE
      INTEGER dim,ic1,ic2,i,j,k,l,IPGLOB,info

      REAL*8  A_TENS_TERM(3,3),W(3),MAIN(3),Z(3,3),maxes(3,3),gtens(3)
      REAL*8 Det_gtens, diff12,diff23,ZR(3,3)
      COMPLEX*16 moment(3,dim,dim),AC_TENS(3,3),A_TEMP(3,3,dim,dim)
c------------------------------------------------
c  dim    -- size of the matrices
c  moment -- matrix of size (3,dim,dim) of the moment (magnetic, spin or angular)
c  gtens  -- array of size (3) keeping the main values of the A tensor ( dsqrt(main_values) )
c  maxes  -- array of size (3,3) keeping the main axes of the A tensor writen in
c            the right coordinate system (Determinant = +1)
c  IPGLOB -- the print level of the subroutine
c----------------------------------------------
C
C   initialization:
C

      do I=1,3
       do J=1,3
      AC_TENS(I,J)=(0.d0,0.d0)
      A_TENS_TERM(I,J)=0.d0
        do K=1,dim
         do L=1,dim
      A_TEMP(I,J,K,L)=(0.d0,0.d0)
         enddo
        enddo
       enddo
      enddo

      do ic1=1,3
         do ic2=1,3
            do i=1,dim
               do j=1,dim
                  do k=1,dim
      A_temp(ic1,ic2,i,j) = A_temp(ic1,ic2,i,j)+moment(ic1,i,k)*
     & moment(ic2,k,j)
                  enddo
               enddo
            enddo
         enddo
      enddo

      IF(IPGLOB.GE.4) THEN
      write(6,'(/)')
      write(6,'(5X,A)') 'BPMOMENT(ic1,ic2):'
      write(6,*)
      do ic1=1,3
      do i=1,dim
      do j=1,dim
      write(6,*) moment(ic1,i,j)
      end do
      end do
      end do

      write(6,'(/)')
      write(6,'(5X,A)') 'A_TEMP(ic1,ic2):'
      write(6,*)
      do ic1=1,3
      do ic2=1,3
      do i=1,dim
      do j=1,dim
      write(6,*) A_temp(ic1,ic2,i,j)
      end do
      end do
      end do
      end do
      END IF

      do ic1=1,3
         do ic2=1,3
            do k=1,dim
      Ac_tens(ic1,ic2)=Ac_tens(ic1,ic2)+A_temp(ic1,ic2,k,k)
            enddo
         enddo
      enddo
      do ic1=1,3
       do ic2=1,3
      A_TENS_TERM(ic1,ic2)=DBLE(Ac_tens(ic1,ic2)+Ac_tens(ic2,ic1))/2.d0
         enddo
      enddo
      do ic1=1,3
       do ic2=1,3
      A_TENS_TERM(ic1,ic2)=12.d0*A_TENS_TERM(ic1,ic2)/DBLE(dim**3-dim)
         enddo
      enddo

c      if(IPGLOB.GT.2) then
      write(6,'(/)')
      write(6,'(5X,A)') 'A_TENS_TERM(ic1,ic2):'
      write(6,*)
      do ic1=1,3
c      write(6,'(5X,3(2F14.7,3x))') (A_TENS_TERM(ic1,ic2),ic2=1,3)
      write(6,'(5X,3(2F21.14,3x))') (A_TENS_TERM(ic1,ic2),ic2=1,3)
      enddo
c      endif
C
C   Diagonalization of A_tens - g tensors
C
      do I=1,3
      main(I)=0.0D0
      w(I)=0.0D0
       do J=1,3
      z(I,J)=0.0D0
       enddo
      enddo
      info=0

      call DIAG_R2_RASSI(A_TENS_TERM,3,info,w,z)
      if(INFO.NE.0) goto 199
      if((w(1).LT.0.D0).AND.(w(2).LT.0.D0).AND.(w(3).LT.0.D0)) then
      write(6,'(2x,A)') 'ALL EIGENVALUES OF THE A-TENSOR ARE NEGATIVE'
      write(6,'(2X,A)') 'THIS IS A VERY UNUSUAL SITUATION. PLEASE'//
     & 'CHECK MANUALLY '
      write(6,'(2x,A)') 'THE FOLLOWING PART OF THE PSEUDOSPIN SECTION'
      write(6,'(2x,A)') 'MUST BE DISREGARDED. THE RESULTS ARE NOT' //
     & 'TRUSTABLE.'
      goto 199
      endif
c

      IF(IPGLOB.GE.4) THEN
      write(6,*)
      write(6,'(4x,A)') 'A_TENS_TERM TENSOR:'
      write(6,'(65a)') ('-',i=1,56),'|'
      write(6,'(4x,A,4x,A,13x,A,5x,a,3x,a)') 'MAIN VALUES','|',
     & 'MAIN MAGNETIC AXES','|', 'x , y , z  -- initial Cartesian axes'
      write(6,'(57a,3x,a)') ('-',i=1,19),'|',('-',i=1,36),'|',
     & 'Xm, Ym, Zm -- main magnetic axes'
      write(6,'(19x,a,4x,a,5x,a,9x,a,9x,a,5x,a)') '|','|','x','y','z',
     & '|'
      write(6,'(65a)') ('-',i=1,19),'|',('-',i=1,4),'|',('-',i=1,31),
     & '|'
      write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gX = ',w(1),' | Xm |',
     & (z(j,1),j=1,3),'|'
      write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gY = ',w(2),' | Ym |',
     & (z(j,2),j=1,3),'|'
      write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gZ = ',w(3),' | Zm |',
     & (z(j,3),j=1,3),'|'
      write(6,'(65a)') ('-',i=1,56),'|'
      END IF

      do I=1,3
      if(W(I).LT.0.d0) then
      W(I)=0.1d-14
      endif
      MAIN(i)=sqrt(W(i))
      enddo

      if(IPGLOB.GE.4) write(6,'(5x,a,3F9.5)') 'EIGenValues after DSPEV:'
     & , (W(I),I=1,3)

C  Check the sign of the coordinate system. if CS is Left-handed,
C  then change it to RIGHT-handed
      Det_gtens=0.d0
      do I=1,3
       do J=1,3
      ZR(I,J)=0.0D0
      ZR(I,J)=Z(I,J)
       enddo
      enddo
      Det_gtens=ZR(1,1)*(ZR(2,2)*ZR(3,3)-ZR(2,3)*ZR(3,2))
     &         -ZR(1,2)*(ZR(2,1)*ZR(3,3)-ZR(2,3)*ZR(3,1))
     &         +ZR(1,3)*(ZR(2,1)*ZR(3,2)-ZR(2,2)*ZR(3,1))
      if(Det_gtens.LT.0.0d0) then
      do i=1,3
      Z(i,1)=-Z(i,1)
      enddo
      if(IPGLOB.GT.2) write(6,'(a)') 'The original coordinate system '//
     & 'was LEFT-handed. It has been changed to the RIGHT-handed'
      endif
      diff12=0.d0
      diff23=0.d0
      diff12=MAIN(2)-MAIN(1)
      diff23=MAIN(3)-MAIN(2)
      if(IPGLOB.GE.4) then
      write(6,'(5x,a,3F19.15)') 'diff12 = ', diff12
      write(6,'(5x,a,3F19.15)') 'diff23 = ', diff23
      endif

      do i=1,3
      gtens(i)=0.0d0
         do j=1,3
         maxes(i,j)=0.0d0
         enddo
      enddo
c set the main Z axis:
      if(diff12.gt.diff23) then
      gtens(3)=MAIN(1)
      gtens(2)=MAIN(2)
      gtens(1)=MAIN(3)
         if(Z(3,1).ge.0.0d0) then
           do i=1,3
           maxes(i,3)=Z(i,1)
           maxes(i,1)=Z(i,3)
           enddo
         elseif(Z(3,1).lt.0.0d0) then
           do i=1,3
           maxes(i,3)=-1.d0*Z(i,1)
           maxes(i,1)=Z(i,3)
           enddo
         endif
           maxes(1,2)=maxes(2,3)*maxes(3,1)-maxes(2,1)*maxes(3,3)
           maxes(2,2)=maxes(1,1)*maxes(3,3)-maxes(1,3)*maxes(3,1)
           maxes(3,2)=maxes(1,3)*maxes(2,1)-maxes(1,1)*maxes(2,3)

      elseif(diff23.gt.diff12) then
      gtens(3)=MAIN(3)
      gtens(2)=MAIN(2)
      gtens(1)=MAIN(1)
         if(Z(3,3).ge.0.0d0) then
           do i=1,3
           maxes(i,3)=Z(i,3)
           maxes(i,1)=Z(i,1)
           enddo
         elseif(Z(3,3).lt.0.0d0) then
           do i=1,3
           maxes(i,3)=-1.d0*Z(i,3)
           maxes(i,1)=Z(i,1)
           enddo
         endif
           maxes(1,2)=maxes(2,3)*maxes(3,1)-maxes(2,1)*maxes(3,3)
           maxes(2,2)=maxes(1,1)*maxes(3,3)-maxes(1,3)*maxes(3,1)
           maxes(3,2)=maxes(1,3)*maxes(2,1)-maxes(1,1)*maxes(2,3)
      endif

      if(IPGLOB.GT.2) then
      write(6,*)
      write(6,'(20X,A)') 'A-TENSOR:'
      write(6,*)
      write(6,'(10X,A,10X,3(F11.5,2X))') '|  xx    xy    xz  |',
     & (A_TENS_TERM(1,ic2),ic2=1,3)
      write(6,'(10X,A,10X,3(F11.5,2X))') '|  yx    yy    yz  |',
     & (A_TENS_TERM(2,ic2),ic2=1,3)
      write(6,'(10X,A,10X,3(F11.5,2X))') '|  zx    zy    zz  |',
     & (A_TENS_TERM(3,ic2),ic2=1,3)
      endif

      if(IPGLOB.GT.2) then
      write(6,*)
      write(6,'(4x,A)') 'g TENSOR:'
      write(6,'(65a)') ('-',i=1,56),'|'
      write(6,'(4x,A,4x,A,13x,A,5x,a,3x,a)') 'MAIN VALUES','|',
     & 'MAIN MAGNETIC AXES','|', 'x , y , z  -- initial Cartesian axes'
      write(6,'(57a,3x,a)') ('-',i=1,19),'|',('-',i=1,36),'|',
     & 'Xm, Ym, Zm -- main magnetic axes'
      write(6,'(19x,a,4x,a,5x,a,9x,a,9x,a,5x,a)') '|','|','x','y','z',
     & '|'
      write(6,'(65a)') ('-',i=1,19),'|',('-',i=1,4),'|',('-',i=1,31),
     & '|'
      write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gX = ',gtens(1),' | Xm |',
     & (maxes(j,1),j=1,3),'|'
      write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gY = ',gtens(2),' | Ym |',
     & (maxes(j,2),j=1,3),'|'
      write(6,'(A,F12.9,A,3F10.6,1x,A)') ' gZ = ',gtens(3),' | Zm |',
     & (maxes(j,3),j=1,3),'|'
      write(6,'(65a)') ('-',i=1,56),'|'
C      Call Add_Info('GTENS_MAIN',gtens,3,5)
      endif

 199  continue

      RETURN
      END



      Subroutine DIAG_R2_RASSI(MATRIX,NBTOT,INFO,W1,Z1)
C
C   THIS ROUTINE PERFORMS THE DIAGONALIZATION OF A REAL SQUARE
C   MATRIX WITH THE DIMENSION NBTOT. THE EIGENVALUES OF THE DIAGONALIZATION
C   ARE DIRECTED INTO W1 AND THE REAL EIGENVECTORS ARE WRITTEN TO Z1.
C

      IMPLICIT NONE
      INTEGER   INFO,I,J,NBTOT
      REAL*8 AP(Nbtot*(Nbtot+1)/2), WORK(3*Nbtot),W1(NBTOT),
     & W(Nbtot),Z(Nbtot,Nbtot),Z1(NBTOT,NBTOT),MATRIX(NBTOT,NBTOT)

C initializations
      INFO=0
      Do j=1,Nbtot
        Do i=1,j
       AP(i+(j-1)*j/2)=0.0D0
        enddo
      enddo
      do i=1,3*Nbtot
      work(i)=0.0d0
      enddo
      Do I=1,Nbtot
      W1(I)=0.0D0
      W(i)=0.d0
       Do J=1,Nbtot
      Z1(J,I)=0.0D0
      Z(j,i)=0.0D0
       enddo
      enddo
      Do j=1,Nbtot
        Do i=1,j
       AP(i+(j-1)*j/2)=MATRIX(i,j)
        enddo
       enddo

      call dspev_('V','U',Nbtot,AP,W,Z,Nbtot,WORK,INFO)
      Do I=1,Nbtot
      W1(I)=W(I)
       Do J=1,Nbtot
      Z1(J,I)=Z(J,I)
       enddo
      enddo
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_CurviL(
     &              nq,nqRF,nqB,nqA,nqT,nqO,
     &              nAtoms,iIter,nIter,Cx,jStab,
     &              nStab,nDim,Smmtrc,Process,Value,nB,
     &              iANr,qLbl,iRef,
     &              fconst,rMult,iOptC,LuIC,Name,Indq,iPrv,
     &              dMass,iCoSet,Grad_all,iGlow,iGhi,Proc_dB,
     &              iTabBonds,iTabAtoms,nBonds,nMax,iTabAI,mAtoms,
     &              mB_Tot,mdB_Tot,
     &              BM,dBM,iBM,idBM,
     &              nB_Tot,ndB_Tot,mqB,Thr_small)
      Implicit Real*8 (a-h,o-z)
      Real*8 Cx(3,nAtoms,nIter), fconst(nB),
     &       Value(nB,nIter), rMult(nB), dMass(nAtoms),
     &       Grad_all(9,iGlow:iGhi,nIter),
     &       BM(nB_Tot),dBM(ndB_Tot)
      Integer nStab(nAtoms), iANr(nAtoms),
     &        jStab(0:7,nAtoms), Indq(3,nB), iCoSet(0:7,nAtoms),
     &        iTabBonds(3,nBonds), iTabAtoms(2,0:nMax,mAtoms),
     &        iTabAI(2,mAtoms), iBM(nB_Tot), idBM(2,ndB_Tot), mqB(nB)
      Logical Smmtrc(3,nAtoms), Process, Proc_dB
      Character*14 qLbl(nB)
#include "Molcas.fh"
      Character*(LENIN) Name(nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
      nq = 0
      mB_Tot = 0
      mdB_Tot = 0
      If (Process) Call FZero(BM,nB_Tot)
      If (Proc_dB) Call FZero(dBM,ndB_Tot)
*                                                                      *
************************************************************************
*                                                                      *
      nq_=nq
      Call RF_Coord(
     &              nq,
     &              nAtoms,iIter,nIter,Cx,jStab,
     &              nStab,nDim,Smmtrc,Process,Value,nB,
     &              iANr,qLbl,iRef,
     &              fconst,rMult,LuIC,Indq,
     &              dMass,iCoSet,Proc_dB,mB_Tot,mdB_Tot,
     &              BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB)
      nqRF=nq-nq_
*
      nq_=nq
      Call Bond_List(
     &              nq,
     &              nAtoms,iIter,nIter,Cx,jStab,
     &              nStab,nDim,Smmtrc,Process,Value,nB,
     &              iANr,qLbl,fconst,
     &              rMult,iOptC,LuIC,Name,Indq,
     &              Proc_dB,iTabBonds,nBonds,iTabAI,mAtoms,
     &              mB_Tot,mdB_Tot,
     &              BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB)
      nqB=nq-nq_
*
      nq_=nq
      Call Angle_List(
     &              nq,
     &              nAtoms,iIter,nIter,Cx,jStab,
     &              nStab,nDim,Smmtrc,Process,Value,nB,
     &              iANr,qLbl,iRef,
     &              fconst,rMult,LuIC,Name,Indq,
     &              Grad_all,iGlow,iGhi,iPrv,Proc_dB,
     &              iTabBonds,nBonds,iTabAI,mAtoms,iTabAtoms,nMax,
     &              mB_Tot,mdB_Tot,
     &              BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB,Thr_small)
      nqA=nq-nq_
*
      nq_=nq
      Call Torsion_List(
     &              nq,
     &              nAtoms,iIter,nIter,Cx,jStab,
     &              nStab,nDim,Smmtrc,Process,Value,nB,
     &              iANr,qLbl,iRef,
     &              fconst,rMult,LuIC,Name,Indq,iPrv,Proc_dB,
     &              iTabBonds,nBonds,iTabAI,mAtoms,iTabAtoms,nMax,
     &              mB_Tot,mdB_Tot,
     &              BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB)
      nqT=nq-nq_
*
      nq_=nq
      Call OutOfPlane_List(
     &              nq,
     &              nAtoms,iIter,nIter,Cx,jStab,
     &              nStab,nDim,Smmtrc,Process,Value,nB,
     &              iANr,qLbl,iRef,
     &              fconst,rMult,LuIC,Name,Indq,iPrv,Proc_dB,
     &              iTabBonds,nBonds,iTabAI,mAtoms,iTabAtoms,nMax,
     &              mB_Tot,mdB_Tot,
     &              BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB)
      nqO=nq-nq_
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mxsqrt_cvb(a,n,ipow)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n, ipow
real(kind=wp), intent(inout) :: a(n,n)
integer(kind=iwp) :: i, ifail, j, k
real(kind=wp), allocatable :: c(:,:), w(:), z(:,:)

call mma_allocate(w,n,label='w')
call mma_allocate(z,n,n,label='z')
call mma_allocate(c,n,n,label='c')
ifail = 0
call rs(n,n,a,w,1,z,ifail)
if (ifail /= 0) then
  write(u6,*) ' Fatal error in diagonalization (MXSQRT) :',ifail
  call abend_cvb()
end if
a(:,:) = Zero
do i=1,n
  a(i,i) = sqrt(w(i))**ipow
end do
call mxatb_cvb(z,a,n,n,n,c)
a(:,:) = Zero
do k=1,n
  do j=1,n
    a(:,j) = a(:,j)+c(:,k)*z(j,k)
  end do
end do
call mma_deallocate(w)
call mma_deallocate(z)
call mma_deallocate(c)

return

end subroutine mxsqrt_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SetUpHarmDip(DipMat,max_term,m_max,n_max,mMat,mInc,mDec,nMat,nInc,nDec,C1,W1,det1,r01,C2,W2,det2,r02,C,W,det0,TranDip, &
                        TranDipGrad,FC00,max_mOrd,max_nOrd,nOsc)
!  Purpose:
!    Calculate the matrix elements of the transition dipole moment at the location of the intermediate oscillator.
!
!  Input:
!    max_term   : Integer - maximum order of the transition dipole terms.
!    W1,W2      : Real two dimensional arrays - eigenvectors scaled by the square root of the eigenvalues.
!    C1,C2      : Real two dimensional arrays - inverses of W1 and W2.
!    det1,det2  : Real variables - determinants of C1 and C2.
!    r01,r02    : Real arrays - coordinates of the two oscillators.
!    Forcefield : Logical variable - whether or not to use transitio dipole from input.
!
!  Output:
!    DipMat     : Real two dimensional array - contains the matrix elements of the transition dipole.

use mula_global, only: mdim1, mdim2, ndim1, ndim2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: max_term, m_max, n_max, mMat(0:mdim1,mdim2), mInc(0:mdim1,mdim2), mDec(0:mdim1,mdim2), &
                                 nMat(0:ndim1,ndim2), nInc(0:ndim1,ndim2), nDec(0:ndim1,ndim2), max_mOrd, max_nOrd, nOsc
real(kind=wp), intent(out) :: DipMat(0:max_mOrd,0:max_nOrd,0:3), FC00
real(kind=wp), intent(in) :: C1(nOsc,nOsc), W1(nOsc,nOsc), det1, r01(nOsc), C2(nOsc,nOsc), W2(nOsc,nOsc), det2, r02(nOsc), &
                             C(nOsc,nOsc), W(nOsc,nOsc), det0, TranDip(3), TranDipGrad(3,nOsc)
integer(kind=iwp) :: iCar, m_max_ord, max_mInc, max_nInc, mx_max_ord, n_max_ord, nvTabDim, nx_max_ord
real(kind=wp), allocatable :: alpha1(:,:), alpha2(:,:), beta(:,:), F(:,:,:), L(:,:), Sij(:,:), Temp1(:,:), Temp2(:,:), U(:,:)

! Initialize.
call TabDim(m_max,nOsc,nvTabDim)
m_max_ord = nvTabDim-1
call TabDim(min(n_max,m_max+1),nOsc,nvTabDim)

mx_max_ord = nvTabDim-1
call TabDim(min(m_max,n_max+1),nOsc,nvTabDim)
nx_max_ord = nvTabDim-1
call TabDim(m_max-1,nOsc,nvTabDim)
max_mInc = nvTabDim-1
call TabDim(n_max,nOsc,nvTabDim)
n_max_ord = nvTabDim-1
call TabDim(n_max-1,nOsc,nvTabDim)
max_nInc = nvTabDim-1
call mma_allocate(L,[0,m_max_ord],[0,nx_max_ord],label='L')
call mma_allocate(U,[0,n_max_ord],[0,mx_max_ord],label='U')
call mma_allocate(Sij,[0,m_max_ord],[0,n_max_ord],label='Sij')

call mma_allocate(alpha1,nOsc,nOsc,label='alpha1')
call mma_allocate(alpha2,nOsc,nOsc,label='alpha2')
call mma_allocate(beta,nOsc,nOsc,label='beta')

! Calculate Franck-Condon factors.
call FCval(C1,W1,det1,r01,C2,W2,det2,r02,Sij,m_max_ord,n_max_ord,mx_max_ord,max_mInc,max_nInc,nx_max_ord,mMat,nMat,mInc,nInc,mDec, &
           nDec,C,W,det0,L,U,FC00,alpha1,alpha2,beta,nOsc)

call mma_deallocate(alpha1)
call mma_deallocate(alpha2)
call mma_deallocate(beta)

! Get the zeroth order contribution from transition dipole.
Dipmat(:,:,:) = Zero
do iCar=1,3
  DipMat(:,:,iCar) = TranDip(iCar)*Sij
end do
call mma_deallocate(Sij)

!rt = sqrt(TranDip(1)**2+TranDip(2)**2+TranDip(3)**2)
!if (rt > Zero) DipMat(:,:,0) = rt*Sij
!end if

! Calculate LFU (just valid for tdm first derivatives)
if (max_term == 1) then
  call mma_allocate(Temp1,[0,m_max_ord],[0,mx_max_ord],label='Temp1')
  call mma_allocate(Temp2,[0,m_max_ord],[0,n_max_ord],label='Temp2')
  if (n_max > m_max) then
    call mma_allocate(F,[0,m_max_ord],[0,mx_max_ord],[1,3],label='F')
    call Fgenerator(nmat,F,nInc,nDec,TranDipGrad,m_max_ord,mx_max_ord,nOsc)
    do iCar=1,3
      call DGEMM_('N','N',m_max_ord+1,mx_max_ord+1,m_max_ord+1,One,L,m_max_ord+1,F(:,:,iCar),m_max_ord+1,Zero,Temp1,m_max_ord+1)
      call DGEMM_('N','T',m_max_ord+1,n_max_ord+1,mx_max_ord+1,One,Temp1,m_max_ord+1,U,n_max_ord+1,Zero,Temp2,m_max_ord+1)

      DipMat(:,:,iCar) = DipMat(:,:,iCar)+Temp2*FC00
    end do
  else
    call mma_allocate(F,[0,n_max_ord],[0,nx_max_ord],[1,3],label='F')
    call Fgenerator(mmat,F,mInc,mDec,trandipgrad,n_max_ord,nx_max_ord,nOsc)
    do iCar=1,3
      call DGEMM_('N','T',m_max_ord+1,n_max_ord+1,nx_max_ord+1,One,L,m_max_ord+1,F(:,:,iCar),n_max_ord+1,Zero,Temp1,m_max_ord+1)
      call DGEMM_('N','T',m_max_ord+1,n_max_ord+1,n_max_ord+1,One,Temp1,m_max_ord+1,U,n_max_ord+1,Zero,Temp2,m_max_ord+1)
      DipMat(:,:,iCar) = DipMat(:,:,iCar)+Temp2*FC00
    end do
  end if
  call mma_deallocate(Temp1)
  call mma_deallocate(Temp2)
  call mma_deallocate(F)

end if

call mma_deallocate(L)
call mma_deallocate(U)

end subroutine SetUpHarmDip

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

#include "compiler_features.h"
#ifdef _MOLCAS_MPP_

subroutine MKBC_F3_MPP(ISYM,BC,iLo,NAS,LDC,NG3,F3,idxG3)

use GA_Wrapper, only: GA_NNodes
use Symmetry_Info, only: Mul
use MPI_Wrapper, only: MPI_AllToAll, MPI_AllToAllV, MPI_COMM_WORLD, MPI_INTEGER, MPI_REAL8
use SUPERINDEX, only: KTUV
use caspt2_module, only: IASYM, NASHT, NTUVES
use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Definitions, only: wp, iwp, byte, MPIInt

implicit none
integer(kind=iwp), intent(in) :: ISYM, iLo, NAS, LDC, NG3
real(kind=wp), intent(inout) :: BC(LDC,NAS)
real(kind=wp), intent(in) :: F3(NG3)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
real(kind=wp), allocatable :: SENDVAL(:), RECVVAL(:)
integer(kind=iwp) :: I, IBLOCK, ICOL, IG3, IG3END, IG3STA, IOFFSET, IP, IROW, iscal, IST, ISU, ISUP, ISV, ISX, ISY, ISZ, IT, ITU, &
                     ITUVS, IU, IV, IVX, IX, IXYZS, IY, IYZ, IZ, JSUP, JSYM, MAXBUF, MAXMEM, NBLOCKS, NBUF, NG3B, NG3MAX, NPROCS, &
                     NQOT, NRECV, NREM
integer(kind=MPIInt) :: IERROR4
real(kind=wp) :: F3VAL
integer(kind=iwp), allocatable :: IBUF(:)
integer(kind=MPIInt), allocatable :: RCOUNTS(:), RCOUNTS2(:), RDISPLS(:), RDISPLS2(:), RECVIDX(:), SCOUNTS(:), SCOUNTS2(:), &
                                     SDISPLS(:), SDISPLS2(:), SENDIDX(:)
integer(kind=iwp), external :: IPROW

! Since we are stuck with collective calls to MPI_Alltoallv in
! order to gather the elements, each process needs to loop over
! the same number of blocks.
NG3MAX = NG3
call GAIGOP_SCAL(NG3MAX,'max')
if (NG3MAX == 0) return

! basic information
NPROCS = GA_NNODES()

call MMA_ALLOCATE(SCOUNTS,NPROCS,Label='SCOUNTS')
call MMA_ALLOCATE(RCOUNTS,NPROCS,Label='RCOUNTS')
call MMA_ALLOCATE(SCOUNTS2,NPROCS,Label='SCOUNTS2')
call MMA_ALLOCATE(RCOUNTS2,NPROCS,Label='RCOUNTS2')
call MMA_ALLOCATE(SDISPLS,NPROCS,Label='SDISPLS')
call MMA_ALLOCATE(RDISPLS,NPROCS,Label='RDISPLS')
call MMA_ALLOCATE(SDISPLS2,NPROCS,Label='SDISPLS2')
call MMA_ALLOCATE(RDISPLS2,NPROCS,Label='RDISPLS2')

call MMA_ALLOCATE(IBUF,NPROCS,Label='IBUF')

! The global SC matrix has already been allocated, so we need to
! find out how much memory is left for buffering (4 equally sized
! buffers for sending and receiving values and indices)
call mma_MaxDBLE(MAXMEM)
iscal = (storage_size(SENDVAL)+2*storage_size(SENDIDX)+storage_size(RECVVAL)+2*storage_size(RECVIDX))/storage_size(1.0_wp)
MAXBUF = min(nint(0.95_wp*MAXMEM)/iscal,2000000000/8)

! Loop over blocks NG3B of NG3, so that 12*NG3B < MAXBUF/NPROCS.
! This guarantees that e.g. if all processes send all their data
! to one other, that process receives NPROCS*NG3B*12 elements
! in the receive buffer.
NG3B = MAXBUF/(NPROCS*12)
NG3B = min(NG3B,NG3MAX)
call GAIGOP_SCAL(NG3B,'min')
NBUF = 12*NG3B

call MMA_ALLOCATE(SENDVAL,NBUF,Label='SENDVAL')
call MMA_ALLOCATE(SENDIDX,2*NBUF,Label='SENDIDX')

! Finally, we need some info on the layout of the global array in
! order to compute the process row of the row index.
NQOT = NAS/NPROCS
NREM = NAS-NPROCS*NQOT

NBLOCKS = (NG3MAX-1)/NG3B+1
do IBLOCK=1,NBLOCKS
  IG3STA = 1+(IBLOCK-1)*NG3B
  IG3END = min(IG3STA+NG3B-1,NG3)

  SCOUNTS = 0
  ! First pass to determine how many values will need to be sent
  ! to other processes. This is necessary to be able to allocate
  ! the buffer size and offsets.
  do iG3=IG3STA,IG3END
    iT = idxG3(1,iG3)
    iU = idxG3(2,iG3)
    iV = idxG3(3,iG3)
    iX = idxG3(4,iG3)
    iY = idxG3(5,iG3)
    iZ = idxG3(6,iG3)
    iST = IASYM(iT)
    iSU = IASYM(iU)
    iSV = IASYM(iV)
    iSX = IASYM(iX)
    iSY = IASYM(iY)
    iSZ = IASYM(iZ)
    ituvs = Mul(IST,Mul(ISU,ISV))
    ixyzs = Mul(ISX,Mul(ISY,ISZ))
    if (ituvs /= ixyzs) cycle
    iTU = iT+NASHT*(iU-1)
    iVX = iV+NASHT*(iX-1)
    iYZ = iY+NASHT*(iZ-1)
    !-SVC20100829: 12 equivalent cases, of which the second
    !  half reflects the B(tuv,xyz)=B(xyz,tuv) symmetry:
    !  - F(tuvxyz) -> BC(vut,xyz)
    jSYM = Mul(IASYM(iV),Mul(IASYM(iU),IASYM(iT)))
    if (jSYM == iSYM) then
      IROW = KTUV(iV,iU,iT)-nTUVES(jSYM)
      IP = IPROW(IROW,NQOT,NREM)
      SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
    end if
    if (.not. ((iTU == iVX) .and. (iVX == iYZ))) then
      if (.not. ((iTU == iVX) .or. (iTU == iYZ) .or. (iVX == iYZ))) then
        !  - F(vxtuyz) -> BC(txv,uyz)
        jSYM = Mul(IASYM(iT),Mul(IASYM(iX),IASYM(iV)))
        if (jSYM == iSYM) then
          IROW = KTUV(iT,iX,iV)-nTUVES(jSYM)
          IP = IPROW(IROW,NQOT,NREM)
          SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
        end if
        !  - F(yzvxtu) -> BC(vzy,xtu)
        jSYM = Mul(IASYM(iV),Mul(IASYM(iZ),IASYM(iY)))
        if (jSYM == iSYM) then
          IROW = KTUV(iV,iZ,iY)-nTUVES(jSYM)
          IP = IPROW(IROW,NQOT,NREM)
          SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
        end if
        !  - F(tuyzvx) -> BC(yut,zvx)
        jSYM = Mul(IASYM(iY),Mul(IASYM(iU),IASYM(iT)))
        if (jSYM == iSYM) then
          IROW = KTUV(iY,iU,iT)-nTUVES(jSYM)
          IP = IPROW(IROW,NQOT,NREM)
          SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
        end if
      end if
      !  - F(yztuvx) -> BC(tzy,uvx)
      jSYM = Mul(IASYM(iT),Mul(IASYM(iZ),IASYM(iY)))
      if (jSYM == iSYM) then
        IROW = KTUV(iT,iZ,iY)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
      end if
      !  - F(vxyztu) -> BC(yxv,ztu)
      jSYM = Mul(IASYM(iY),Mul(IASYM(iX),IASYM(iV)))
      if (jSYM == iSYM) then
        IROW = KTUV(iY,iX,iV)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
      end if
    end if
    if ((iT == iU) .and. (iV == iX) .and. (iY == iZ)) cycle
    if ((iT == iU) .and. (iV == iZ) .and. (iX == iY)) cycle
    if ((iX == iV) .and. (iT == iZ) .and. (iU == iY)) cycle
    if ((iZ == iY) .and. (iV == iU) .and. (iX == iT)) cycle
    !  - F(utxvzy) -> BC(xtu,vzy)
    jSYM = Mul(IASYM(iX),Mul(IASYM(iT),IASYM(iU)))
    if (jSYM == iSYM) then
      IROW = KTUV(iX,iT,iU)-nTUVES(jSYM)
      IP = IPROW(IROW,NQOT,NREM)
      SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
    end if
    if ((iTU == iVX) .and. (iVX == iYZ)) cycle
    if (.not. ((iTU == iVX) .or. (iTU == iYZ) .or. (iVX == iYZ))) then
      !  - F(xvutzy) -> BC(uvx,tzy)
      jSYM = Mul(IASYM(iU),Mul(IASYM(iV),IASYM(iX)))
      if (jSYM == iSYM) then
        IROW = KTUV(iU,iV,iX)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
      end if
      !  - F(zyxvut) -> BC(xyz,vut)
      jSYM = Mul(IASYM(iX),Mul(IASYM(iY),IASYM(iZ)))
      if (jSYM == iSYM) then
        IROW = KTUV(iX,iY,iZ)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
      end if
      !  - F(utzyxv) -> BC(ztu,yxv)
      jSYM = Mul(IASYM(iZ),Mul(IASYM(iT),IASYM(iU)))
      if (jSYM == iSYM) then
        IROW = KTUV(iZ,iT,iU)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
      end if
    end if
    !  - F(zyutxv) -> BC(uyz,txv)
    jSYM = Mul(IASYM(iU),Mul(IASYM(iY),IASYM(iZ)))
    if (jSYM == iSYM) then
      IROW = KTUV(iU,iY,iZ)-nTUVES(jSYM)
      IP = IPROW(IROW,NQOT,NREM)
      SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
    end if
    !  - F(xvzyut) -> BC(zvx,yut)
    jSYM = Mul(IASYM(iZ),Mul(IASYM(iV),IASYM(iX)))
    if (jSYM == iSYM) then
      IROW = KTUV(iZ,iV,iX)-nTUVES(jSYM)
      IP = IPROW(IROW,NQOT,NREM)
      SCOUNTS(IP) = SCOUNTS(IP)+1_MPIInt
    end if
  end do

  ! At this point, SCOUNTS contains the number of values generated
  ! for each process. Use them to determine the send offsets.
  IOFFSET = 0
  do I=1,NPROCS
    SDISPLS(I) = int(IOFFSET,kind=MPIInt)
    IBUF(I) = IOFFSET
    IOFFSET = IOFFSET+SCOUNTS(I)
  end do

  ! Second pass fills the buffers with values and indices
  do iG3=IG3STA,IG3END
    iT = idxG3(1,iG3)
    iU = idxG3(2,iG3)
    iV = idxG3(3,iG3)
    iX = idxG3(4,iG3)
    iY = idxG3(5,iG3)
    iZ = idxG3(6,iG3)
    iST = IASYM(iT)
    iSU = IASYM(iU)
    iSV = IASYM(iV)
    iSX = IASYM(iX)
    iSY = IASYM(iY)
    iSZ = IASYM(iZ)
    ituvs = Mul(IST,Mul(ISU,ISV))
    ixyzs = Mul(ISX,Mul(ISY,ISZ))
    if (ituvs /= ixyzs) cycle
    iTU = iT+NASHT*(iU-1)
    iVX = iV+NASHT*(iX-1)
    iYZ = iY+NASHT*(iZ-1)
    F3VAL = F3(iG3)
    !-SVC20100829: 12 equivalent cases, of which the second
    !  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
    !  - F(tuvxyz) -> BC(vut,xyz)
    jSYM = Mul(IASYM(iV),Mul(IASYM(iU),IASYM(iT)))
    if (jSYM == iSYM) then
      IROW = KTUV(iV,iU,iT)-nTUVES(jSYM)
      ICOL = KTUV(iX,iY,iZ)-nTUVES(jSYM)
      IP = IPROW(IROW,NQOT,NREM)
      IBUF(IP) = IBUF(IP)+1
      SENDVAL(IBUF(IP)) = F3VAL
      SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
      SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
    end if
    if (.not. ((iTU == iVX) .and. (iVX == iYZ))) then
      if (.not. ((iTU == iVX) .or. (iTU == iYZ) .or. (iVX == iYZ))) then
        !  - F(vxtuyz) -> BC(txv,uyz)
        jSYM = Mul(IASYM(iT),Mul(IASYM(iX),IASYM(iV)))
        if (jSYM == iSYM) then
          IROW = KTUV(iT,iX,iV)-nTUVES(jSYM)
          ICOL = KTUV(iU,iY,iZ)-nTUVES(jSYM)
          IP = IPROW(IROW,NQOT,NREM)
          IBUF(IP) = IBUF(IP)+1
          SENDVAL(IBUF(IP)) = F3VAL
          SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
          SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
        end if
        !  - F(yzvxtu) -> BC(vzy,xtu)
        jSYM = Mul(IASYM(iV),Mul(IASYM(iZ),IASYM(iY)))
        if (jSYM == iSYM) then
          IROW = KTUV(iV,iZ,iY)-nTUVES(jSYM)
          ICOL = KTUV(iX,iT,iU)-nTUVES(jSYM)
          IP = IPROW(IROW,NQOT,NREM)
          IBUF(IP) = IBUF(IP)+1
          SENDVAL(IBUF(IP)) = F3VAL
          SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
          SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
        end if
        !  - F(tuyzvx) -> BC(yut,zvx)
        jSYM = Mul(IASYM(iY),Mul(IASYM(iU),IASYM(iT)))
        if (jSYM == iSYM) then
          IROW = KTUV(iY,iU,iT)-nTUVES(jSYM)
          ICOL = KTUV(iZ,iV,iX)-nTUVES(jSYM)
          IP = IPROW(IROW,NQOT,NREM)
          IBUF(IP) = IBUF(IP)+1
          SENDVAL(IBUF(IP)) = F3VAL
          SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
          SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
        end if
      end if
      !  - F(yztuvx) -> BC(tzy,uvx)
      jSYM = Mul(IASYM(iT),Mul(IASYM(iZ),IASYM(iY)))
      if (jSYM == iSYM) then
        IROW = KTUV(iT,iZ,iY)-nTUVES(jSYM)
        ICOL = KTUV(iU,iV,iX)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        IBUF(IP) = IBUF(IP)+1
        SENDVAL(IBUF(IP)) = F3VAL
        SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
        SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
      end if
      !  - F(vxyztu) -> BC(yxv,ztu)
      jSYM = Mul(IASYM(iY),Mul(IASYM(iX),IASYM(iV)))
      if (jSYM == iSYM) then
        IROW = KTUV(iY,iX,iV)-nTUVES(jSYM)
        ICOL = KTUV(iZ,iT,iU)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        IBUF(IP) = IBUF(IP)+1
        SENDVAL(IBUF(IP)) = F3VAL
        SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
        SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
      end if
    end if
    if ((iT == iU) .and. (iV == iX) .and. (iY == iZ)) cycle
    if ((iT == iU) .and. (iV == iZ) .and. (iX == iY)) cycle
    if ((iX == iV) .and. (iT == iZ) .and. (iU == iY)) cycle
    if ((iZ == iY) .and. (iV == iU) .and. (iX == iT)) cycle
    !  - F(utxvzy) -> BC(xtu,vzy)
    jSYM = Mul(IASYM(iX),Mul(IASYM(iT),IASYM(iU)))
    if (jSYM == iSYM) then
      IROW = KTUV(iX,iT,iU)-nTUVES(jSYM)
      ICOL = KTUV(iV,iZ,iY)-nTUVES(jSYM)
      IP = IPROW(IROW,NQOT,NREM)
      IBUF(IP) = IBUF(IP)+1
      SENDVAL(IBUF(IP)) = F3VAL
      SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
      SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
    end if
    if ((iTU == iVX) .and. (iVX == iYZ)) cycle
    if (.not. ((iTU == iVX) .or. (iTU == iYZ) .or. (iVX == iYZ))) then
      !  - F(xvutzy) -> BC(uvx,tzy)
      jSYM = Mul(IASYM(iU),Mul(IASYM(iV),IASYM(iX)))
      if (jSYM == iSYM) then
        IROW = KTUV(iU,iV,iX)-nTUVES(jSYM)
        ICOL = KTUV(iT,iZ,iY)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        IBUF(IP) = IBUF(IP)+1
        SENDVAL(IBUF(IP)) = F3VAL
        SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
        SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
      end if
      !  - F(zyxvut) -> BC(xyz,vut)
      jSYM = Mul(IASYM(iX),Mul(IASYM(iY),IASYM(iZ)))
      if (jSYM == iSYM) then
        IROW = KTUV(iX,iY,iZ)-nTUVES(jSYM)
        ICOL = KTUV(iV,iU,iT)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        IBUF(IP) = IBUF(IP)+1
        SENDVAL(IBUF(IP)) = F3VAL
        SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
        SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
      end if
      !  - F(utzyxv) -> BC(ztu,yxv)
      jSYM = Mul(IASYM(iZ),Mul(IASYM(iT),IASYM(iU)))
      if (jSYM == iSYM) then
        IROW = KTUV(iZ,iT,iU)-nTUVES(jSYM)
        ICOL = KTUV(iY,iX,iV)-nTUVES(jSYM)
        IP = IPROW(IROW,NQOT,NREM)
        IBUF(IP) = IBUF(IP)+1
        SENDVAL(IBUF(IP)) = F3VAL
        SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
        SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
      end if
    end if
    !  - F(zyutxv) -> BC(uyz,txv)
    jSYM = Mul(IASYM(iU),Mul(IASYM(iY),IASYM(iZ)))
    if (jSYM == iSYM) then
      IROW = KTUV(iU,iY,iZ)-nTUVES(jSYM)
      ICOL = KTUV(iT,iX,iV)-nTUVES(jSYM)
      IP = IPROW(IROW,NQOT,NREM)
      IBUF(IP) = IBUF(IP)+1
      SENDVAL(IBUF(IP)) = F3VAL
      SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
      SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
    end if
    !  - F(xvzyut) -> BC(zvx,yut)
    jSYM = Mul(IASYM(iZ),Mul(IASYM(iV),IASYM(iX)))
    if (jSYM == iSYM) then
      IROW = KTUV(iZ,iV,iX)-nTUVES(jSYM)
      ICOL = KTUV(iY,iU,iT)-nTUVES(jSYM)
      IP = IPROW(IROW,NQOT,NREM)
      IBUF(IP) = IBUF(IP)+1
      SENDVAL(IBUF(IP)) = F3VAL
      SENDIDX(2*IBUF(IP)-1) = int(IROW,kind=MPIInt)
      SENDIDX(2*IBUF(IP)) = int(ICOL,kind=MPIInt)
    end if
  end do

  ! Now we need to determine the receive counts.
  call MPI_ALLTOALL(SCOUNTS,1_MPIInt,MPI_INTEGER,RCOUNTS,1_MPIInt,MPI_INTEGER,MPI_COMM_WORLD,IERROR4)

  IOFFSET = 0
  do I=1,NPROCS
    RDISPLS(I) = int(IOFFSET,kind=MPIInt)
    IOFFSET = IOFFSET+RCOUNTS(I)
  end do
  SCOUNTS2(:) = 2_MPIInt*SCOUNTS(:)
  RCOUNTS2(:) = 2_MPIInt*RCOUNTS(:)
  SDISPLS2(:) = 2_MPIInt*SDISPLS(:)
  RDISPLS2(:) = 2_MPIInt*RDISPLS(:)
  NRECV = IOFFSET

  call MMA_ALLOCATE(RECVVAL,NRECV,Label='RECVVAL')
  call MMA_ALLOCATE(RECVIDX,2*NRECV,Label='RECVIDX')

  ! Now, it is time to collect the appropriate values and indices
  ! in their respective receive buffers.
  call MPI_ALLTOALLV(SENDVAL,SCOUNTS,SDISPLS,MPI_REAL8,RECVVAL,RCOUNTS,RDISPLS,MPI_REAL8,MPI_COMM_WORLD,IERROR4)
  call MPI_ALLTOALLV(SENDIDX,SCOUNTS2,SDISPLS2,MPI_INTEGER,RECVIDX,RCOUNTS2,RDISPLS2,MPI_INTEGER,MPI_COMM_WORLD,IERROR4)

  ! Finally, fill the local chunk of the SC matrix (block of rows)
  ! with the received values at their appropriate place.
  do I=1,NRECV
    ISUP = RECVIDX(2*I-1)
    JSUP = RECVIDX(2*I)
    BC(ISUP-ILO+1,JSUP) = BC(ISUP-ILO+1,JSUP)+RECVVAL(I)
  end do

  call MMA_DEALLOCATE(RECVVAL)
  call MMA_DEALLOCATE(RECVIDX)

end do ! end loop over blocks of G3 values

call MMA_DEALLOCATE(SENDVAL)
call MMA_DEALLOCATE(SENDIDX)

call MMA_DEALLOCATE(SCOUNTS)
call MMA_DEALLOCATE(RCOUNTS)
call MMA_DEALLOCATE(SCOUNTS2)
call MMA_DEALLOCATE(RCOUNTS2)
call MMA_DEALLOCATE(SDISPLS)
call MMA_DEALLOCATE(RDISPLS)
call MMA_DEALLOCATE(SDISPLS2)
call MMA_DEALLOCATE(RDISPLS2)

call MMA_DEALLOCATE(IBUF)

end subroutine MKBC_F3_MPP

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(MKBC_F3_MPP)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine icomb_cvb(i1,i2,icomb_cvbval)
      implicit real*8(a-h,o-z)
      save one,half
      data one/1.d0/,half/0.5d0/

      icomb_cvbval=0

c  Special cases - return ICOMB_CVB=0 :
      if(i1.lt.0.or.i2.lt.0.or.i1.lt.i2)then
        icomb_cvbval=0
        return
      endif
c  I3 is I2 but always less than I1/2 :
      i3=(i1-abs(i1-2*i2))/2
      comb=one
      do j=1,i3
      comb=comb/DBLE(j)
      comb=comb*DBLE(i1-j+1)
      enddo
      icomb_cvbval=nint(comb)
c  If integer overflow - return ICOMB_CVB=-1 :
      if(abs(DBLE(icomb_cvbval)-comb).gt.half)icomb_cvbval=-1
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Roland Lindh                                           *
!***********************************************************************
!  Get_Coord_New_All
!
!> @brief
!>   Get the new coordinates from RUNFILE
!> @author R. Lindh
!>
!> @details
!> Place Cartesian coordinates (in a.u.) into array \p Coord_All(3,*).
!>
!> @param[out] Coord_All  Array of coordinates
!> @param[in]  nAtoms_All Number of atoms
!***********************************************************************

subroutine Get_Coord_New_All(Coord_All,nAtoms_All)

use RunFile_procedures, only: Get_Coord_New
use stdalloc, only: mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms_All
real(kind=wp), intent(out) :: Coord_All(3,nAtoms_All)
integer(kind=iwp) :: nAtoms, nAtoms_Allx
real(kind=wp), allocatable :: CU(:,:)

call Get_nAtoms_All(nAtoms_Allx)
if (nAtoms_All /= nAtoms_Allx) then
  write(u6,*) 'Get_Coord_New_All: nAtoms_All /= nAtoms_Allx'
  write(u6,*) 'nAtoms_All=',nAtoms_All
  write(u6,*) 'nAtoms_Allx=',nAtoms_Allx
  call Abend()
end if
call Get_Coord_New(CU,nAtoms)
call Get_Coord_All_(CU,nAtoms,Coord_All,nAtoms_All)
call mma_deallocate(CU)

return

end subroutine Get_Coord_New_All

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mxunfold_cvb(avec,a,n)
      implicit real*8 (a-h,o-z)
      dimension avec(n*(n-1)),a(n,n)

      call fzero(a,n*n)
      iprm=0
      do 100 i=1,n
      do 101 j=1,n
      if(j.ne.i)then
        iprm=iprm+1
        a(j,i)=avec(iprm)
      endif
101   continue
100   continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************

subroutine Gradient_Kriging(x0_,dy_,ndimx)

use kriging_mod, only: gpred, x0
use Definitions, only: wp, iwp

!#define _Grad_Test
#ifdef _Grad_Test
use Constants, only: Two, u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ndimx
real(kind=wp), intent(in) :: x0_(ndimx)
real(kind=wp), intent(out) :: dy_(ndimx)
#ifdef _Grad_Test
integer(kind=iwp) :: i
real(kind=wp) :: Delta, tpred, thpred
real(kind=wp), parameter :: GradT = 1.0e-6_wp
#endif

!x0 is the n-dimensional vector of the coordinates at which the gradient is evaluated.
! subroutine
x0(:) = x0_(:)

! Write(u6,*) 'Entro grad'
call covarvector(1) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
call predict(1)
dy_(:) = gpred(:)

#ifdef _Grad_Test
! Numerical Gradient of GEK
write(u6,*) 'Begining Numerical Gradient'
Delta = 1.0e-4_wp !max(abs(x_(i,1)),1.0e-5_wp)*Scale
do i=1,nInter
  x0(:) = x0_(:)

  x0(i) = x0_(i)+Delta

  call covarvector(0) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
  call predict(0)
  tpred = pred

  x0(i) = x0_(i)-Delta

  call covarvector(0) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
  call predict(0)
  thpred = pred

  gpred(i) = (tpred-thpred)/(Two*Delta)

end do
write(u6,*) 'Gradient Threshold',GradT
do i=1,nInter
  write(u6,*) 'i',i
  write(u6,*) 'gpred, dy_',gpred(i),dy_(i)
  if (abs(dy_(i)-gpred(i)) > GradT) then
    write(u6,*) 'Error in entry',i,'of the gradient vector'
    call RecPrt('Anna Grad',' ',dy_,1,nInter)
    call RecPrt('Num Grad',' ',gpred,1,nInter)
    write(u6,*) 'abs(dy_(i,j)+ HessT)',abs(dy_(i)+GradT)
    write(u6,*) 'abs(dy_(i,j)- HessT)',abs(dy_(i)-GradT)
    write(u6,*) 'abs(gpred(i))',abs(gpred(i))
    call Abend()
  end if
end do
#endif

return

end subroutine Gradient_Kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function Cho_P_IndxParentDiag(iQ,iSym)
C
C     Purpose: return index in global 1st reduced set of qualified iQ,
C              sym. iSym.
C
      Implicit None
      Integer iQ, iSym
#include "cho_para_info.fh"
      Integer  Cho_IndxParentDiag_S
      External Cho_IndxParentDiag_S
      Integer  Cho_IndxParentDiag_P
      External Cho_IndxParentDiag_P

      If (Cho_Real_Par) Then
         Cho_P_IndxParentDiag = Cho_IndxParentDiag_P(iQ,iSym)
      Else
         Cho_P_IndxParentDiag = Cho_IndxParentDiag_S(iQ,iSym)
      End If

      End
      Integer Function Cho_IndxParentDiag_P(iQ,iSym)
      Implicit None
      Integer iQ, iSym
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
#include "choglob.fh"

      Integer i, j, iQuAB, IndRed
      IndRed(i,j)=iWork(ip_IndRed_G-1+mmBstRT_G*(j-1)+i)
      iQuAB(i,j)=iWork(ip_iQuAB-1+MaxQual*(j-1)+i)

      Cho_IndxParentDiag_P = IndRed(iQuAB(iQ,iSym),2)

      End
      Integer Function Cho_IndxParentDiag_S(iQ,iSym)
      Implicit None
      Integer iQ, iSym
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer i, j, iQuAB, IndRed
      IndRed(i,j)=iWork(ip_IndRed-1+mmBstRT*(j-1)+i)
      iQuAB(i,j)=iWork(ip_iQuAB-1+MaxQual*(j-1)+i)

      Cho_IndxParentDiag_S = IndRed(iQuAB(iQ,iSym),2)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!  breakpoint
!
!> @brief
!>   Set breakpoints in code.
!> @author Oskar Weser
!>
!> @details
!> Either you call explicitly
!> \code{.unparsed}
!>   break breakpoint
!> \endcode
!> when using gdb or you add the following commands
!> \code{.unparsed}
!>   set breakpoint pending on
!>   break breakpoint
!> \endcode
!> to your ~/.gdbinit.
!***********************************************************************

subroutine breakpoint()

implicit none

return

end subroutine breakpoint

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION IELSUM(IVEC,NELMNT)
*
* Sum elements of integer vector IVEC
*
      DIMENSION IVEC(*)
*
      ISUM = 0
      DO 100 IELMNT = 1, NELMNT
        ISUM = ISUM + IVEC(IELMNT)
  100 CONTINUE
*
      IELSUM = ISUM
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module refwfn

use Definitions, only: wp, iwp, u6

implicit none
private

logical(kind=iwp) :: refwfn_active = .false., refwfn_is_h5
character(len=128) :: refwfn_filename
integer(kind=iwp) :: refwfn_id, IADR15(30)
character(len=100) :: ProgName
character(len=100), external :: Get_ProgName

public :: refwfn_active, refwfn_is_h5, refwfn_filename, refwfn_id, IADR15
public :: refwfn_init, refwfn_close, refwfn_info, refwfn_data

contains

!***********************************************************************
subroutine refwfn_init(Filename)
!***********************************************************************

# ifdef _HDF5_
  use mh5, only: mh5_is_hdf5, mh5_open_file_r
# endif

  character(len=*), intent(in) :: Filename
  integer(kind=iwp) :: I, IAD15

  refwfn_is_h5 = .false.

  ProgName = Get_ProgName()
  if (refwfn_active) then
    write(u6,*) ' trying to activate refwfn twice, aborting!'
    call abend()
  else
    refwfn_active = .true.
  end if

  ! if not a standard filename, call fileorb??
  if (FileName /= 'JOBIPH') then
    call fileorb(Filename,refwfn_filename)
  else
    refwfn_filename = 'JOBIPH'
  end if

# ifdef _HDF5_
  if (mh5_is_hdf5(refwfn_filename)) then
    refwfn_is_h5 = .true.
    write(u6,'(1X,A)') 'wavefunction data from HDF5 file:'
    write(u6,'(3X,A)') trim(refwfn_filename)
    refwfn_id = mh5_open_file_r(refwfn_filename)
  else
# endif
    refwfn_is_h5 = .false.
    ! Assume reference wavefunction is stored as JobIph format
    refwfn_id = 15
    call DANAME(refwfn_id,refwfn_filename)
    ! Read table of contents into IADR15() array.
    ! There are two possible different layouts, 15 or 30 integers:
    IAD15 = 0
    call IDAFILE(refwfn_id,2,IADR15,15,IAD15)
    if (IADR15(15) == -1) then
      IAD15 = 0
      call IDAFILE(refwfn_id,2,IADR15,30,IAD15)
    else
      do I=16,30
        IADR15(I) = 0
      end do
      call WarningMessage(1,'Old JOBIPH file layout.')
    end if
# ifdef _HDF5_
  end if
# endif

end subroutine refwfn_init

!***********************************************************************
subroutine refwfn_close
!***********************************************************************

# ifdef _HDF5_
  use mh5, only: mh5_close_file

  if (refwfn_is_h5) then
    call mh5_close_file(refwfn_id)
  else
# endif
    call DaClos(refwfn_id)
# ifdef _HDF5_
  end if
# endif
  refwfn_active = .false.

end subroutine refwfn_close

!***********************************************************************
subroutine refwfn_info
!***********************************************************************
!SVC: initialize the reference wavefunction info

  use stdalloc, only: mma_allocate, mma_deallocate
# ifdef _DMRG_
  use qcmaquis_info, only: qcmaquis_info_init, qcm_group_names
# endif
# ifdef _HDF5_
  use mh5, only: mh5_fetch_attr, mh5_exists_dset, mh5_fetch_dset
# endif

# include "rasdim.fh"
# include "caspt2.fh"

# ifdef _HDF5_
  character(len=1), allocatable :: typestring(:)
# endif
  integer(kind=iwp) :: iSym, ref_nSym, ref_nBas(mxSym), IAD15
  real(kind=wp) :: Weight(mxRoot)

  if (.not. refwfn_active) then
    write(u6,*) ' refwfn not yet activated, aborting!'
    call abend()
  end if

# ifdef _HDF5_
  if (refwfn_is_h5) then
    ! general wavefunction attributes
    !call mh5_fetch_attr(refwfn_id, 'TITLE', Title)
    call mh5_fetch_attr(refwfn_id,'SPINMULT',iSpin)
    call mh5_fetch_attr(refwfn_id,'NSYM',ref_nSym)
    call mh5_fetch_attr(refwfn_id,'LSYM',stSym)
    call mh5_fetch_attr(refwfn_id,'NBAS',ref_nBas)

    call mh5_fetch_attr(refwfn_id,'NACTEL',nActEl)
    call mh5_fetch_attr(refwfn_id,'NHOLE1',nHole1)
    call mh5_fetch_attr(refwfn_id,'NELEC3',nEle3)
    call mh5_fetch_attr(refwfn_id,'NCONF',nConf)
    call mh5_fetch_attr(refwfn_id,'NSTATES',nRoots)
    call mh5_fetch_attr(refwfn_id,'NROOTS',lRoots)
    call mh5_fetch_attr(refwfn_id,'STATE_ROOTID',iRoot)
    call mh5_fetch_attr(refwfn_id,'STATE_WEIGHT',Weight)

    call mma_allocate(typestring,sum(ref_nbas(1:nsym)))
    call mh5_fetch_dset(refwfn_id,'MO_TYPEINDICES',typestring)
    call tpstr2orb(ref_nsym,ref_nbas,typestring,nfro,nish,nras1,nras2,nras3,nssh,ndel)
    nash = nras1+nras2+nras3
    call mma_deallocate(typestring)
    ! Leon 14/6/2017 -- do not read CI vectors if NEVPT2 is attempted
    ! because for now we only support DMRG-NEVPT2
    if (ProgName(1:6) == 'caspt2') then
      if (.not. mh5_exists_dset(refwfn_id,'CI_VECTORS')) then
        write(u6,'(1X,A)') 'The HDF5 file does not contain CI vectors,'
        write(u6,'(1X,A)') 'make sure it was created by rasscf/caspt2.'
        call AbEnd()
      end if
    end if
    if (.not. mh5_exists_dset(refwfn_id,'MO_VECTORS')) then
      write(u6,'(1X,A)') 'The HDF5 file does not contain MO vectors,'
      write(u6,'(1X,A)') 'make sure it was created by rasscf/caspt2/nevpt2.'
      call AbEnd()
    end if
    IFQCAN = 0
# ifdef _DMRG_
    if (mh5_exists_dset(refwfn_id,'QCMAQUIS_CHECKPOINT')) then
      call qcmaquis_info_init(1,nroots,-1)
      call mh5_fetch_dset(refwfn_id,'QCMAQUIS_CHECKPOINT',qcm_group_names(1)%states)
    end if
# endif
  else
# endif
    ! Sizes in the GSLIST is counted in INTEGERS.
    ! Note that the title field in the JOBIPH file is not used for anything
    ! in this program, it is just a dummy read.
    ! Another title field is read from input a little later, it is called
    ! TITLE2. That one is printed out in PRINP_CASPT2.
    IAD15 = IADR15(1)
    call WR_RASSCF_Info(refwfn_id,2,iAd15,NACTEL,ISPIN,REF_NSYM,STSYM,NFRO,NISH,NASH,NDEL,REF_NBAS,8,NAME,LENIN8*MXORB,NCONF, &
                        HEADER,144,TITLE,4*18*mxTit,POTNUC,LROOTS,NROOTS,IROOT,MXROOT,NRAS1,NRAS2,NRAS3,NHOLE1,NELE3,IFQCAN,Weight)
    nssh = ref_nbas-nfro-nish-nash-ndel
# ifdef _HDF5_
  end if
# endif
  if (nSym /= ref_nSym) then
    write(u6,*) ' Number of irreps of the reference wavefunction'
    write(u6,*) ' does not match the data on the RunFile, abort!'
    call AbEnd()
  else
    do iSym=1,nSym
      if (nBas(iSym) /= ref_nBas(iSym)) then
        write(u6,*) ' Number of basis functions of the reference'
        write(u6,*) ' wavefunction does not match the data on the'
        write(u6,*) ' RunFile, abort!'
        call AbEnd()
      end if
    end do
  end if

end subroutine refwfn_info

!***********************************************************************
subroutine refwfn_data
!***********************************************************************
!SVC: initialize the reference wavefunction data

  use stdalloc, only: mma_allocate, mma_deallocate
# ifdef _HDF5_
  use mh5, only: mh5_fetch_attr, mh5_fetch_dset
# endif

# include "rasdim.fh"
# include "caspt2.fh"
# include "pt2_guga.fh"

  integer(kind=iwp) :: I, IAD15, II, IDISK, ID, IAD, NEJOB, IT, NMAYBE, ISNUM
  real(kind=wp) :: Root_Energies(mxRoot), AEMAX, E
  real(kind=wp), allocatable :: tmp(:), ejob(:,:)

  if (.not. refwfn_active) then
    write(u6,*) ' refwfn not yet activated, aborting!'
    call abend()
  end if

  !---  Read the MO coefficients from HDF5/JOBIPH and store on LUONEM
  NCMO = NBSQT
  call mma_allocate(tmp,NCMO,label='LCMORAS')
# ifdef _HDF5_
  if (refwfn_is_h5) then
    call mh5_fetch_dset(refwfn_id,'MO_VECTORS',tmp)
  else
# endif
    IAD15 = IADR15(9)
    if (IFQCAN == 0) IAD15 = IADR15(2)
    call DDAFILE(refwfn_id,2,tmp,NCMO,IAD15)
# ifdef _HDF5_
  end if
# endif
  IEOF1M = 0
  IDISK = IEOF1M
  IAD1M(1) = IDISK
  call DDAFILE(LUONEM,1,tmp,NCMO,IDISK)
  call mma_deallocate(tmp)
  IEOF1M = IDISK

  ! IDCIEX: Present EOF on LUCIEX.
  ID = IDCIEX
  ! Skip when using cumulant reconstruction of (3-,) 4-RDM
  !     Leon 14/6/2017 -- do not read CI vectors if NEVPT2 is attempted
  !     because for now we only support DMRG-NEVPT2
  if (ProgName(1:6) == 'caspt2') then
    if ((.not. DoCumulant) .and. (ISCF == 0)) then
      call mma_allocate(tmp,NCONF,label='LCI')
      do I=1,NSTATE
        ISNUM = MSTATE(I)
#       ifdef _HDF5_
        if (refwfn_is_h5) then
          !---  Read the CI coefficients from the HDF5 file
          call mh5_fetch_dset(refwfn_id,'CI_VECTORS',tmp,[nconf,1],[0,ISNUM-1])
        else
#       endif
          !---  Read the CI coefficients from the JOBIPH file
          IDISK = IADR15(4)
          do II=1,ISNUM-1
            call DDAFILE(refwfn_id,0,tmp,NCONF,IDISK)
          end do
          call DDAFILE(refwfn_id,2,tmp,NCONF,IDISK)
#       ifdef _HDF5_
        end if
#       endif
        ! Copy selected vectors to LUCI:
        call DDAFILE(LUCIEX,1,tmp,NCONF,ID)
      end do
      ! Disk address = present EOF on LUCIEX.
      ! IDTCEX = Disk address to transformed CI.
      if (ORBIN == 'TRANSFOR') then
        IDTCEX = ID
        ! Dummy writes:
        do II=1,NSTATE
          call DDAFILE(LUCIEX,0,tmp,NCONF,ID)
        end do
      else
        IDTCEX = IDCIEX
      end if
      call mma_deallocate(tmp)
    else
      ! If this is Closed-shell or Hi-spin SCF case
      ! Just in case...
      if (.not. DoCumulant .and. (NSTATE /= 1 .or. NCONF /= 1)) then
        write(u6,*) ' readin_caspt2: A Closed-shell or Hi-spin SCF'
        write(u6,*) ' but nr of states is: NSTATE=',NSTATE
        write(u6,*) ' and nr of CSFs is    NCONF= ',NCONF
        write(u6,*) ' Program error?? Must stop.'
        call ABEND()
      end if
      ! This should be solved elsewhere in the code...just for the now,
      ! make a write of a CI vector to LUCIEX, so other routines do not get
      ! their knickers into a twist:
      NCONF = 1
      call mma_allocate(tmp,NCONF,label='LCI')
      tmp(1) = 1.0_wp
      call DDAFILE(LUCIEX,1,tmp,NCONF,ID)
      call mma_deallocate(tmp)
    end if
  end if
  ! Now, the selected original CASCI expansions are on LUCIEX
  ! beginning from disk address 0.

  !SVC: read the L2ACT and LEVEL arrays
# ifdef _HDF5_
  if (refwfn_is_h5) then
    call mh5_fetch_attr(refwfn_id,'L2ACT',L2ACT)
    call mh5_fetch_attr(refwfn_id,'A2LEV',LEVEL)
  else
# endif
    IAD15 = IADR15(18)
    call IDAFILE(refwfn_id,2,L2ACT,mxAct,IAD15)
    call IDAFILE(refwfn_id,2,LEVEL,mxAct,IAD15)
# ifdef _HDF5_
  end if
# endif

# ifdef _HDF5_
  if (refwfn_is_h5) then
    call mh5_fetch_dset(refwfn_id,'ROOT_ENERGIES',ROOT_ENERGIES)
  else
# endif
    !PAM 2015: We will no longer recompute the RASSCF energies
    ! but just assume they can be obtained from the JOBIPH file.
    ! There is table with unknown length with all energies from
    ! all iterations (!) there.
    NEJOB = MXROOT*MXITER
    call mma_allocate(ejob,MXROOT,MXITER,label='EJOB')
    IAD = IADR15(6)
    call DDAFILE(refwfn_id,2,ejob,NEJOB,IAD)
    ! Note that there is no info on nr of iterations
    ! so we cannot know what energies to pick...
    ! Let us make a guess: The correct set of energy values in the
    ! table of energies/iteration is the last one with not all zeroes.
    NMAYBE = 0
    do IT=1,MXITER
      AEMAX = 0.0_wp
      do I=1,MXROOT
        E = ejob(I,IT)
        AEMAX = max(AEMAX,abs(E))
      end do
      if (abs(AEMAX) < 1.0e-12_wp) exit
      NMAYBE = IT
    end do
    if (NMAYBE == 0) then
      write(u6,*) ' PT2INI tried to read energies from the'
      write(u6,*) ' JOBIPH file, but could not find any.'
      call ABEND()
    end if
    ! And then put the energies into the Hamiltonian matrix,
    ! unless already filled in by the EFFE keyword
    do I=1,mxRoot
      Root_Energies(I) = ejob(I,NMAYBE)
    end do
    ! No more use for the array EJOB.
    call mma_deallocate(ejob)
# ifdef _HDF5_
  end if
# endif
  ! Leon: MSTATE(I) is initialised only in caspt2
  ! if it's initialised somewhere else, feel free to change the line below
  if (ProgName(1:6) == 'caspt2') then
    do I=1,NSTATE
      REFENE(I) = ROOT_ENERGIES(MSTATE(I))
    end do
  else
    ! since it isn't initialised, we just assume that we need the states in the
    ! same order as they're written on JobIph
    ! Apparently, nstates is also initialised in caspt2 only, but nroots is
    ! available from here, so we use nroots
    ! > stknecht: initialize nstate here nevertheless - can be used in nevpt2 initialization as well
    nstate = nroots
    refene(1:nroots) = ROOT_ENERGIES(1:nroots)
  end if

end subroutine refwfn_data

end module refwfn

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_J_builder

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_get_E_from_Vff,       &
             fmm_get_E_from_pkd_Vff,   &
             fmm_get_J_from_Vff,       &
             fmm_get_J_from_pkd_Vff

CONTAINS

!-------------------------------------------------------------------------------
! Trivial check that the number of moments matches the number of potentials

   SUBROUTINE fmm_verify_Vff_input(scheme,LHS_mms,Vff,J_or_E)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      TYPE(raw_mm_data),  INTENT(IN) :: LHS_mms
      REAL(REALK),        INTENT(IN) :: Vff(:,:)
      CHARACTER(LEN=1),   INTENT(IN) :: J_or_E
      LOGICAL :: A,B,C

      A = (SIZE(LHS_mms%paras) /= SIZE(Vff,2))
      IF (A) CALL fmm_quit('incompatible SIZE of Vff and LHS moments!')

      IF (J_or_E == 'J') THEN
         A = (scheme%LHS_mm_range == NUCLEAR_ONLY)
         B = (scheme%RHS_mm_range == NUCLEAR_ONLY)
         C = (scheme%LHS_mm_range == ALL_MOMENTS )
         IF ( (A.AND.B) .OR. C ) CALL fmm_quit('mm_ranges invalid')
      END IF

   END SUBROUTINE fmm_verify_Vff_input

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_E_with_text(scheme,energy,text)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      REAL(REALK),        INTENT(INOUT) :: energy
      CHARACTER(LEN=*),   INTENT(OUT)   :: text
      LOGICAL :: A,B,C,D

      A = (scheme%LHS_mm_range == ELECTRONIC_ONLY)
      B = (scheme%RHS_mm_range == ELECTRONIC_ONLY)
      C = (scheme%LHS_mm_range == NUCLEAR_ONLY)
      D = (scheme%RHS_mm_range == NUCLEAR_ONLY)

      IF (scheme%LHS_mm_range == scheme%RHS_mm_range) THEN
         energy = half*energy
         text = "total classical Coulomb energy"
         IF (A) text = "classical Coulomb electronic energy"
         IF (C) text = "classical Coulomb nuclear repulsion"
      ELSE IF (A.OR.B) THEN
         IF (C.OR.D) THEN
            text = "classical Coulomb nuclear attraction"
         ELSE
            text = "e-n + 2*(e-e) energy"
         END IF
      ELSE
         ! range is different and neither is ELECTRONIC_ONLY
         text = "e-n + 2*(n-n) energy"
      END IF

   END SUBROUTINE fmm_get_E_with_text

!-------------------------------------------------------------------------------
! Get energy from full contraction of LHS moments and the potentials
!-------------------------------------------------------------------
! We assume Vff(lm,i) is the potential at i due to ALL the RHS moments
! (so that a simple contraction with the LHS moments will double count
!  interactions if the LHS and RHS moment ranges overlap).

   SUBROUTINE fmm_get_E_from_Vff(scheme,LHS_mms,Vff,energy,text)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)  :: scheme
      TYPE(raw_mm_data),  INTENT(IN)  :: LHS_mms
      REAL(REALK),        INTENT(IN)  :: Vff(:,:)
      REAL(REALK),        INTENT(OUT) :: energy
      CHARACTER(LEN=*),   INTENT(OUT) :: text

      REAL(REALK)   :: g
      INTEGER(INTK) :: u,v, lm_max

      CALL fmm_verify_Vff_input(scheme,LHS_mms,Vff,'E')

      ! although Vff should be the same size, we test for generality
      IF (SIZE(LHS_mms%qlm_T,1) /= SIZE(Vff,1)) STOP 'mm_get_E_from_Vff:2'
      lm_max = MIN(SIZE(LHS_mms%qlm_T,1),SIZE(Vff,1))
      DO u = 1, SIZE(LHS_mms%paras)
         v = LHS_mms%paras(u)%id
         g = DOT_PRODUCT(LHS_mms%qlm_T(:lm_max,v),Vff(:lm_max,v))
         energy = energy + g
      END DO

      CALL fmm_get_E_with_text(scheme,energy,text)

   END SUBROUTINE fmm_get_E_from_Vff

!-------------------------------------------------------------------------------
! Get energy from full contraction of LHS moments and the potentials
! on the basis that the LHS parameters and Vff may have been packed
! into batches (and must be "expanded").
!-------------------------------------------------------------------
! We assume Vff(lm,i) is the potential at i due to ALL the RHS moments
! (so that a simple contraction with the LHS moments will double count
!  interactions if the LHS and RHS moment ranges overlap).

   SUBROUTINE fmm_get_E_from_pkd_Vff(scheme,LHS_mms,Vff,energy,text)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)  :: scheme
      TYPE(raw_mm_data),  INTENT(IN)  :: LHS_mms
      REAL(REALK),        INTENT(IN)  :: Vff(:,:)
      REAL(REALK),        INTENT(OUT) :: energy
      CHARACTER(LEN=*),   INTENT(OUT) :: text

      REAL(REALK)   :: g
      INTEGER(INTK) :: u,v,w, lm_max
      TYPE(id_node), POINTER :: batch_map

      CALL fmm_verify_Vff_input(scheme,LHS_mms,Vff,'E')

      lm_max = MIN(SIZE(LHS_mms%qlm_T,1),SIZE(Vff,1))
      packed_loop: DO u = 1, SIZE(LHS_mms%paras)

         v = LHS_mms%paras(u)%id  ! LHS packed (batch) parameters
         batch_map => LHS_mms%batch_map(v)%head

         batch_members2: DO ! over batch list until pointer disassociated
            w = batch_map%id   ! raw LHS moment ID
            g = DOT_PRODUCT(LHS_mms%qlm_T(:lm_max,w),Vff(:lm_max,v))
            energy = energy + g
             ! only do next raw item in batch list if it exists
            IF (.NOT.ASSOCIATED(batch_map%next)) EXIT batch_members2
            batch_map => batch_map%next
         END DO batch_members2

      END DO packed_loop

      CALL fmm_get_E_with_text(scheme,energy,text)

   END SUBROUTINE fmm_get_E_from_pkd_Vff

!-------------------------------------------------------------------------------
! Build J_matrix components from contracion of the LHS moments and potentials
!----------------------------------------------------------------------------
! We assume Vff(lm,i) is the potential at i due to ALL the RHS moments
! This choice of Vff is fine here since the e-e interactions require a
! factor of 2 in the J-matrix, but NOT the e-n interactions.

   SUBROUTINE fmm_get_J_from_Vff(scheme,LHS_mms,Vff,J_matrix)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)  :: scheme
      TYPE(raw_mm_data),  INTENT(IN)  :: LHS_mms
      REAL(REALK),        INTENT(IN)  :: Vff(:,:)
      REAL(REALK),        INTENT(OUT) :: J_matrix(:,:)

      REAL(REALK)   :: g
      INTEGER(INTK) :: u,v, i,j, lm_max

      CALL fmm_verify_Vff_input(scheme,LHS_mms,Vff,'J')

      ! although Vff should be the same size, we test for generality
      IF (SIZE(LHS_mms%qlm_T,1) /= SIZE(Vff,1)) STOP 'mm_get_J_from_Vff:2'
      lm_max = MIN(SIZE(LHS_mms%qlm_T,1),SIZE(Vff,1))
      DO u = 1, SIZE(LHS_mms%paras)
         v = LHS_mms%paras(u)%id
         g = DOT_PRODUCT(LHS_mms%qlm_T(:lm_max,v),Vff(:lm_max,v))
         i = LHS_mms%J_indices(v)%i_indx
         j = LHS_mms%J_indices(v)%j_indx
         J_matrix(i,j) = J_matrix(i,j) + g
         IF (i/=j) J_matrix(j,i) = J_matrix(j,i) + g
      END DO

   END SUBROUTINE fmm_get_J_from_Vff

!-------------------------------------------------------------------------------
! Build J_matrix components from contracion of the LHS moments and potentials
! This routine recognises that the LHS parameters may have been packed
! and thus expands the potential over LHS batches.
!----------------------------------------------------------------------------
! We assume Vff(lm,i) is the potential at i due to ALL the RHS moments

   SUBROUTINE fmm_get_J_from_pkd_Vff(scheme,LHS_mms,Vff,J_matrix)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)  :: scheme
      TYPE(raw_mm_data),  INTENT(IN)  :: LHS_mms
      REAL(REALK),        INTENT(IN)  :: Vff(:,:)
      REAL(REALK),        INTENT(OUT) :: J_matrix(:,:)

      REAL(REALK)   :: g
      INTEGER(INTK) :: u,v,w, i,j, lm_max
      TYPE(id_node), POINTER :: batch_map

      CALL fmm_verify_Vff_input(scheme,LHS_mms,Vff,'J')

      ! Vff should now be the same size as the raw LHS parameters;
      ! However, the size of LHS %qlm_T will be larger;
      ! We need to "expand" Vff using the batch mapping.

      lm_max = MIN(SIZE(LHS_mms%qlm_T,1),SIZE(Vff,1))
      packed_loop: DO u = 1, SIZE(LHS_mms%paras)

         v = LHS_mms%paras(u)%id  ! LHS packed (batch) moments
         batch_map => LHS_mms%batch_map(v)%head

         batch_members: DO ! over batch list until pointer disassociated
            w = batch_map%id   ! raw LHS moment ID
            g = DOT_PRODUCT(LHS_mms%qlm_T(:lm_max,w),Vff(:lm_max,v))
            i = LHS_mms%J_indices(w)%i_indx
            j = LHS_mms%J_indices(w)%j_indx
            J_matrix(i,j) = J_matrix(i,j) + g
!            IF (i/=j) J_matrix(j,i) = J_matrix(j,i) + g

             ! only do next raw item in batch list if it exists
            IF (.NOT.ASSOCIATED(batch_map%next)) EXIT batch_members
            batch_map => batch_map%next
         END DO batch_members
      END DO packed_loop

   END SUBROUTINE fmm_get_J_from_pkd_Vff

!-------------------------------------------------------------------------------

END MODULE fmm_J_builder

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine SOLV2DRA(NAS,NIS,iCASE,iSYM,iVEC)
!SVC: FIXME: this temporary routine copies the RHS arrays from DRAs to
!     LUSOLV and should be removed once the full parallelization is in
!     place and transition is no longer needed.

use EQSOLV, only: MXSCT
use fake_GA, only: GA_Arrays
use caspt2_global, only: IDSCT, LUSOLV
use caspt2_module, only: MXCASE
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, King
use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Definitions, only: wp, u6
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NAS, NIS, iCASE, iSYM, iVEC
integer(kind=iwp) :: IDISK, lg_W, NW
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: IEND, iMax, ISTA, NCOL
real(kind=wp), allocatable :: TMPW(:)
#endif

call RHS_ALLO(NAS,NIS,lg_W)

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  !SVC: Read the global array from disk
  !SVC: Only the master process writes to LUSOLV!!
  !SVC: be careful to only call one-sided operations
  if (KING()) then
    !SVC: write the LUSOLV array to global RHS array
    !     later it should be completely removed when everything is parallel
    call mma_MaxDBLE(iMax)
    !-SVC: GA_Get does not like large buffer sizes, put upper limit at 1GB
    iMax = min(nint(0.95_wp*iMax),134217728)
    NCOL = min(iMAX,NAS*NIS)/NAS
    if (NCOL <= 0) then
      write(u6,*) 'Not enough memory in SOLV2DRA, aborting...'
      call AbEnd()
    end if
    NW = NAS*NCOL
    call mma_allocate(TMPW,NW,Label='TMPW')
    !SVC: Read local array from LUSOLV
    IDISK = IDSCT(1+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1))))
    do ISTA=1,NIS,NCOL
      IEND = min(ISTA+NCOL-1,NIS)
      call DDAFILE(LUSOLV,2,TMPW,NAS*(IEND-ISTA+1),IDISK)
      call GA_Put(lg_W,1,NAS,ISTA,IEND,TMPW,NAS)
    end do
    call mma_deallocate(TMPW)
  end if
  call GASync()
  !SVC: Destroy the global array
  !bStat = GA_Destroy(lg_W)
else
#endif
  NW = NAS*NIS
  IDISK = IDSCT(1+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1))))
  call DDAFILE(LUSOLV,2,GA_Arrays(lg_W)%A,NW,IDISK)
#ifdef _MOLCAS_MPP_
end if
#endif

call RHS_SAVE(NAS,NIS,lg_W,ICASE,ISYM,IVEC)
call RHS_FREE(lg_W)

end subroutine SOLV2DRA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Sebastian Wouters                                *
!               2016, Quan Phung                                       *
!***********************************************************************
! Subroutine to load 3-RDM and F4-RDM
! Written by Quan Phung and Sebastian Wouters, Leuven, Aug 2016

subroutine chemps2_load3pdm( NAC, idxG3, NG3, storage, doG3, EPSA, F2, chemroot )

  USE HDF5
  USE ISO_C_BINDING
#ifdef _MOLCAS_MPP_
  USE MPI
#endif

  IMPLICIT NONE
  INTEGER, INTENT(IN)   :: NAC, NG3, chemroot
  INTEGER*1, INTENT(IN) :: idxG3( 6, NG3 )
  REAL*8, INTENT(OUT)   :: storage(*)
  LOGICAL, INTENT(IN)   :: doG3
  REAL*8, INTENT(IN)    :: EPSA( NAC )
  REAL*8, INTENT(OUT)   :: F2 ( NAC, NAC, NAC, NAC )

  CHARACTER(LEN=30) :: file_3rdm
  CHARACTER(LEN=30) :: file_f4rdm
  LOGICAL           :: irdm, jrdm

  INTEGER( HID_T )   :: file_h5, group_h5, space_h5, dset_h5 ! Handles
  INTEGER(4)         :: hdferr
  TYPE( C_PTR )      :: f_ptr
  character(len=10) :: rootindex

#ifdef _MOLCAS_MPP_
  EXTERNAL Is_Real_Par, KING
  Logical KING
  Logical Is_Real_Par
#endif

  INTEGER :: ip1, ip2, ip3, iq1, iq2, iq3, idx, iG3

  REAL*8, DIMENSION( 1 : NAC * NAC * NAC * NAC * NAC * NAC ), TARGET :: buffer

  write(rootindex,"(I2)") chemroot-1
  file_3rdm="molcas_3rdm.h5.r"//trim(adjustl(rootindex))
  file_f4rdm="molcas_f4rdm.h5.r"//trim(adjustl(rootindex))
  file_3rdm=trim(adjustl(file_3rdm))
  file_f4rdm=trim(adjustl(file_f4rdm))
  call f_inquire(file_3rdm, irdm)
  call f_inquire(file_f4rdm, jrdm)
  if ((.NOT. irdm) .OR. (.NOT. jrdm)) then
     write(6,'(1X,A15,I3,A26)') 'CHEMPS2> Root: ',CHEMROOT,' :: No 3RDM or F.4RDM file'
     call abend()
  endif

!#ifdef _MOLCAS_MPP_
!if ( MPP().AND.KING() ) then
!#endif
  CALL h5open_f( hdferr )
  If (doG3.EQV..true.) Then
    CALL h5fopen_f( file_3rdm, H5F_ACC_RDONLY_F, file_h5, hdferr )
    CALL h5gopen_f( file_h5, "3-RDM", group_h5, hdferr )
  Else
    CALL h5fopen_f( file_f4rdm, H5F_ACC_RDONLY_F, file_h5, hdferr )
    CALL h5gopen_f( file_h5, "F.4-RDM", group_h5, hdferr )
  End If
  CALL h5dopen_f( group_h5, "elements", dset_h5, hdferr )
  CALL h5dget_space_f( dset_h5, space_h5, hdferr )
  f_ptr = C_LOC( buffer( 1 ) )
  CALL h5dread_f( dset_h5, H5T_NATIVE_DOUBLE, f_ptr, hdferr )
  CALL h5dclose_f( dset_h5 , hdferr )
  CALL h5sclose_f( space_h5, hdferr )
  CALL h5gclose_f( group_h5, hdferr )
  CALL h5fclose_f( file_h5,  hdferr )
!#ifdef _MOLCAS_MPP_
!end if
!call MPI_Bcast( buffer, NAC * NAC * NAC * NAC * NAC * NAC, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, IERROR4 )
!#endif

  do iG3=1,NG3
    ip1 = idxG3( 1, iG3 ) - 1
    iq1 = idxG3( 2, iG3 ) - 1
    ip2 = idxG3( 3, iG3 ) - 1
    iq2 = idxG3( 4, iG3 ) - 1
    ip3 = idxG3( 5, iG3 ) - 1
    iq3 = idxG3( 6, iG3 ) - 1
    idx = ip1 + NAC * ( ip2 + NAC * ( ip3 + NAC * ( iq1 + NAC * ( iq2 + NAC * iq3 ) ) ) )
    storage( iG3 ) = buffer( 1 + idx )
  end do

  if (doG3.EQV..true.) Then
    do iq2=1,NAC
      do ip2=1,NAC
        do iq1=1,NAC
          do ip1=1,NAC
            F2( ip1, iq1, ip2, iq2 ) = 0.0
            do ip3=1,NAC
              idx = ip1 + NAC * ( ip2 - 1 + NAC * ( ip3 - 1 + NAC * ( iq1 - 1 + NAC * ( iq2 - 1 + NAC * ( ip3 - 1 ) ) ) )  )
              F2( ip1, iq1, ip2, iq2 ) = F2( ip1, iq1, ip2, iq2 ) + EPSA( ip3 ) * buffer( idx )
            end do
          end do
        end do
      end do
    end do
  end if
end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine ReadIn_CPF()
! Read input and allocate memory

use cpf_global, only: BNAME, CTRSH, ETHRE, ETOT, ICASE, ICH, ICONV, ICPF, IFIRST, ILIM, INCPF, INDX, IPRINT, IR1, IRC, IREST, &
                      IROW, ISAB, ISC, ISDCI, ISMAX, ITOC17, IV0, IV1, JJS, JSY, LN, LSYM, Lu_CIGuga, Lu_TraOne, LWSP, MAXIT, &
                      MAXITP, N, NASH, NBAS, NFRO, NISH, NORB, NORBT, NPFRO, NREF, NSM, NSYM, NVIR, NVIRT, POTNUC, WLEV
use guga_util_global, only: IAD10, nIOCR
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u5, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), parameter :: mxTit = 10
integer(kind=iwp) :: I, IADD10, iCmd, IDISK, IIN, INTNUM, iOpt, IR, iRef, IRJ, istatus, iSym, IT, IU, IV, IVA, IX1, IX2, IX3, IX4, &
                     IY1, IY2, IY3, IY4, j, jCmd, jEnd, jStart, LN1, LN2, NAMSIZ, NASHI, NASHT, NBAST, NDEL(8), NDELI, NDELT, &
                     NFREF, NFROI, NFROT, nIRC, NISHI, NISHT, nJJS, NPDEL(8), NPDELT, NPFROT, NRLN1, nTit, NVAL(8), NVALI, NVALT, &
                     NVIR2, NVIRI, NVT, NVT2
real(kind=wp) :: S
logical(kind=iwp) :: Skip
character(len=88) :: ModLine
character(len=72) :: Line, Title(mxTit)
character(len=4) :: Command
integer(kind=iwp), allocatable :: IOCR(:), JREFX(:)
character(len=4), parameter :: Cmd(16) = ['TITL','MAXP','LEVS','THRP','PRIN','FROZ','DELE','MAXI','ECON','REST','MCPF','CPF ', &
                                          'SDCI','ACPF','LOW ','END ']

!---  Initialize arrays and variables ---------------------------------*
LWSP = .false.
ETHRE = 1.0e-6_wp
CTRSH = 5.0e-2_wp
IPRINT = 5
MAXIT = 20
IREST = 0
ICPF = 0
ISDCI = 0
INCPF = 0
ICONV = 0
MAXITP = 6
WLEV = 0.3_wp
ETOT = Zero
NPFRO(:) = 0
NFRO(:) = 0
NDEL(:) = 0
NPDEL(:) = 0
NISH(:) = 0
NASH(:) = 0
NVAL(:) = 0
NVIR(:) = 0
NORB(:) = 0
NBAS(:) = 0
NPFROT = 0
NFROT = 0
NDELT = 0
NPDELT = 0
NISHT = 0
NASHT = 0
NVALT = 0
NVIRT = 0
NORBT = 0
NBAST = 0
do I=1,size(IROW)
  IROW(I) = I*(I-1)/2
end do
nTit = 0

!---  read the header of TRAONE ---------------------------------------*
! Note: NORB(i)=NBAS(i)-NPFRO(i)-NPDEL(i)
NAMSIZ = LenIn8*MXORB
IDISK = 0
call WR_MOTRA_Info(Lu_TraOne,2,iDisk,ITOC17,64,POTNUC,NSYM,NBAS,NORB,NPFRO,NPDEL,8,BNAME,NAMSIZ)

!---  Read input from standard input ----------------------------------*
call RdNLst(u5,'CPF')
Skip = .false.
jCmd = 0
do
  if (Skip) then
    Skip = .false.
  else
    read(u5,'(A)',iostat=istatus) Line
    if (istatus < 0) call Error(1)
    Command = Line(1:4)
    call UpCase(Command)
    if (Command(1:1) == '*') cycle
    jCmd = 0
    do iCmd=1,size(Cmd)
      if (Command == Cmd(iCmd)) jCmd = iCmd
    end do
  end if
  select case (jCmd)

    case default
      write(u6,*) 'READIN Error: Command not recognized.'
      write(u6,*) 'The command is:'//''''//Command//''''
      call QUIT_OnUserError()

    case (1) !TITL
      !---  process TITL command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        Command = Line(1:4)
        call UpCase(Command)
        if (Command(1:1) == '*') cycle
        jCmd = 0
        do iCmd=1,size(Cmd)
          if (Command == Cmd(iCmd)) jCmd = iCmd
        end do
        if (jCmd /= 0) exit
        nTit = nTit+1
        if (nTit <= mxTit) Title(nTit) = Line
      end do
      Skip = .true.

    case (2) !MAXP
      !---  process MAXP command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) MaxItP
      if (istatus > 0) call Error(2)

    case (3) !LEVS
      !---  process LEVS command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) WLev
      if (istatus > 0) call Error(2)

    case (4) !THRP
      !---  process THRP command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) CTrsh
      if (istatus > 0) call Error(2)

    case (5) !PRIN
      !---  process PRIN command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) iPrint
      if (istatus > 0) call Error(2)

    case (6) !FROZ
      !---  process FROZ command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      ModLine = Line//' 0 0 0 0 0 0 0 0'
      read(ModLine,*,iostat=istatus) (nFro(i),i=1,8)
      if (istatus > 0) call Error(2)

    case (7) !DELE
      !---  process DELE command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      ModLine = Line//' 0 0 0 0 0 0 0 0'
      read(ModLine,*,iostat=istatus) (NDEL(i),i=1,8)
      if (istatus > 0) call Error(2)

    case (8) !MAXI
      !---  process MAXI command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) MaxIt
      if (istatus > 0) call Error(2)
      MaxIt = min(MaxIt,75)

    case (9) !ECON
      !---  process ECON command --------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) EThre
      if (istatus > 0) call Error(2)

    case (10) !REST
      !---  process REST command --------------------------------------*
      iRest = 1

    case (11) !MCPF
      !---  process MCPF command --------------------------------------*
      iCPF = 0
      iSDCI = 0
      iNCPF = 0

    case (12) !CPF
      !---  process CPF  command --------------------------------------*
      iCPF = 1
      iSDCI = 0
      iNCPF = 0

    case (13) !SDCI
      !---  process SDCI command --------------------------------------*
      iSDCI = 1
      iCPF = 0
      iNCPF = 0

    case (14) !ACPF
      !---  process ACPF command --------------------------------------*
      iNCPF = 1
      iCPF = 0
      iSDCI = 0

    case (15) !LOW
      !---  process LOW  command --------------------------------------*
      LWSP = .true.

    case (16) !END
      exit

  end select
end do
!---  The end of the input is reached, print the title ----------------*
if (ntit == 0) then
  ntit = 1
  title(1) = ' ( No title was given )'
end if
write(u6,*)
write(u6,'(6X,120A1)') ('*',i=1,120)
write(u6,'(6X,120A1)') '*',(' ',i=1,118),'*'
write(u6,'(6X,57A1,A6,57A1)') '*',(' ',i=1,56),'Title:',(' ',i=1,56),'*'
do i=1,nTit
  call Center_Text(Title(i))
  write(u6,'(6X,24A1,A72,24A1)') '*',(' ',j=1,23),Title(i),(' ',j=1,23),'*'
end do
write(u6,'(6X,120A1)') '*',(' ',i=1,118),'*'
write(u6,'(6X,120A1)') ('*',i=1,120)
write(u6,*)

!---  print the coordinates of the system -----------------------------*
call PrCoor()

!---  print the method used -------------------------------------------*
write(u6,*)
if (iSDCI == 1) then
  write(u6,'(6X,A)') 'This is an  S D C I  calculation'
else if (iCPF == 1) then
  write(u6,'(6X,A)') 'This is a  C P F  calculation'
else if (INCPF == 1) then
  write(u6,'(6X,A)') 'This is an  A C P F calculation'
else
  write(u6,'(6X,A)') 'This is an  M C P F  calculation'
end if
if (LWSP) write(u6,'(6X,A)') 'This is a LOW SPIN calculation'

!---  read the header of CIGUGA ---------------------------------------*
IADD10 = 0
call iDAFILE(Lu_CIGuga,2,IAD10,9,IADD10)
iOpt = 2
nJJS = 18
nIRC = 4
call mma_allocate(IOCR,nIOCR,label='IOCR')
call WR_GUGA(Lu_CIGuga,iOpt,IADD10,NFREF,S,N,LN,NSYM,IR1,IRJ,IFIRST,INTNUM,LSYM,NREF,LN1,NRLN1,NASH,NISH,8,IRC,nIRC,JJS,nJJS,NVAL, &
             IOCR,nIOCR)
if (LN >= MXORB) then
  write(u6,*) 'READIN Error: Too many orbitals.'
  write(u6,'(1X,A,2I5)') 'LN,MXORB:',LN,MXORB
  call QUIT_OnUserError()
end if
call mma_allocate(ICASE,IR1,label='ICASE')
call iDAFILE(Lu_CIGuga,2,ICASE,IR1,IADD10)
call mma_allocate(JSY,IRJ,label='JSY')
call iDAFILE(Lu_CIGuga,2,JSY,IRJ,IADD10)

!---  update orbital specifications -----------------------------------*
IV0 = 0
IV1 = 1
do I=1,NSYM
  NVIR(I) = NORB(I)-NFRO(I)-NISH(I)-NASH(I)-NVAL(I)-NDEL(I)
  NPFROT = NPFROT+NPFRO(I)
  NFROT = NFROT+NFRO(I)
  NISHT = NISHT+NISH(I)
  NASHT = NASHT+NASH(I)
  NVALT = NVALT+NVAL(I)
  NVIRT = NVIRT+NVIR(I)
  NDELT = NDELT+NDEL(I)
  NPDELT = NPDELT+NPDEL(I)
  NORBT = NORBT+NORB(I)
  NBAST = NBAST+NBAS(I)
end do
IIN = 0
IR = 0
IVA = 0
IU = NISHT+NVALT
IT = NVALT
IV = LN
NVIRT = 0
do I=1,NSYM
  NFROI = NFRO(I)
  NISHI = NISH(I)
  NASHI = NASH(I)
  NVALI = NVAL(I)
  NDELI = NDEL(I)
  !PAM97 NVIRDI = NORB(I)-NFROI-NASHI-NISHI-NVALI
  !PAM97 NVIR(I) = NVIRDI-NDEL(I)
  NVIRI = NVIR(I)
  NVIRT = NVIRT+NVIRI
  do J=1,NFROI
    IIN = IIN+1
    IR = IR-1
    ICH(IIN) = IR
  end do
  do J=1,NISHI
    IIN = IIN+1
    IT = IT+1
    ICH(IIN) = IT
    NSM(IT) = I
  end do
  do J=1,NASHI
    IIN = IIN+1
    IU = IU+1
    ICH(IIN) = IU
    NSM(IU) = I
  end do
  do J=1,NVALI
    IIN = IIN+1
    IVA = IVA+1
    ICH(IIN) = IVA
    NSM(IVA) = I
  end do
  do J=1,NVIRI
    IIN = IIN+1
    IV = IV+1
    ICH(IIN) = IV
    NSM(IV) = I
  end do
  do J=1,NDELI
    IIN = IIN+1
    ICH(IIN) = 0
  end do
end do
NVT = IROW(NVIRT+1)
NVT2 = IROW(NVIRT)

!---  report input specifications -------------------------------------*
write(u6,*)
write(u6,'(6X,A)') 'ONE-ELECTRON BASIS:'
write(u6,'(6X,A)') '----------------------------'
write(u6,*)
write(u6,'(6X,A,T47,4X,4X,8I4)') 'Symmetry species',(iSym,iSym=1,nSym)
write(u6,*)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Orbitals pre-frozen in MOTRA',nPFroT,(nPFro(iSym),iSym=1,nSym)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Orbitals used by this program',norbT,(nOrb(iSym),iSym=1,nSym)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Pre-deleted in MOTRA',nPDelT,(nPDel(iSym),iSym=1,nSym)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Sum: No. of basis functions',nBasT,(nBas(iSym),iSym=1,nSym)
write(u6,*)
write(u6,'(6X,A)') 'ORBITAL SPECIFICATION:'
write(u6,'(6X,A)') '-------------------------------'
write(u6,*)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Orbitals frozen here',nFroT,(nFro(iSym),iSym=1,nSym)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Inactive orbitals',nIShT,(nISh(iSym),iSym=1,nSym)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Active orbitals',nAShT,(nASh(iSym),iSym=1,nSym)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Additional valence orbitals',nValT,(nVal(iSym),iSym=1,nSym)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Virtual orbitals',nVirT,(nVir(iSym),iSym=1,nSym)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Orbitals deleted here',nDelT,(nDel(iSym),iSym=1,nSym)
write(u6,'(6X,A,T47,I4,4x,8I4)') 'Sum: Total no. of orbitals',norbT,(nOrb(iSym),iSym=1,nSym)
write(u6,*)
write(u6,*)
write(u6,'(6X,A)') 'WAVE FUNCTION SPECIFICATION:'
write(u6,'(6X,A)') '----------------------------'
write(u6,*)
write(u6,'(6X,A,T47,I4)') 'Number of electrons in CI',N
write(u6,'(6X,A,T47,I4)') 'Internal orbitals in CI',LN
write(u6,'(6X,A,T47,I4)') 'External orbitals in CI',NVIRT
write(u6,'(6X,A,T47,I4)') 'Number of irreps',NSYM
write(u6,'(6X,A,T47,F4.1)') 'Spin quantum number',S
write(u6,'(6X,A,T47,I4)') 'State symmetry',LSYM
write(u6,*)
write(u6,'(6X,A)') 'REFERENCE STATE:'
write(u6,'(6X,A)') '------------------------------'
write(u6,*)
write(u6,'(6X,A,T47,I4)') 'Number of reference states',NREF
LN2 = min(16,LN1)
if (LN1 == 0) then
  write(u6,'(6X,A,T47)') 'One closed shell reference state'
else
  write(u6,'(6X,A,T47)') 'Occupation of active orbitals in the reference state:'
  write(u6,'(6X,A,T25,16I4)') 'Active orbital nr.',(I,I=1,LN2)
  jEnd = 0
  do iRef=1,nRef
    jStart = jEnd+1
    jEnd = jEnd+LN1
    write(u6,'(6X,A,I3,T25,16I4)') 'Ref nr',IREF,(IOCR(j),j=jStart,jEnd)
  end do
end if
call mma_deallocate(IOCR)
write(u6,*)
write(u6,'(6X,A)') 'OPTIONS:'
write(u6,'(6X,A)') '--------'
write(u6,*)
write(u6,'(6X,A,T47,I4)') 'Print parameter',iPrint
write(u6,'(6X,A,T47)') 'Pulay diagonalization'
if (INTNUM /= 0) write(u6,'(6X,A,T47)') 'First order interacting space'
IX1 = IRC(1)
IX2 = IRC(2)-IRC(1)
ISC(1) = IX1
ISC(2) = ISC(1)+IX2*NVIRT
IY1 = ISC(1)
IY2 = ISC(2)-ISC(1)
write(u6,214)
if (IFIRST == 0) then
  IX3 = IRC(3)-IRC(2)
  IX4 = IRC(4)-IRC(3)
  ISC(3) = ISC(2)+IX3*NVT2
  ISC(4) = ISC(3)+IX4*NVT
  IY3 = ISC(3)-ISC(2)
  IY4 = ISC(4)-ISC(3)
  write(u6,215) IX1,IX2,IX3,IX4
  write(u6,213)
  write(u6,215) IY1,IY2,IY3,IY4
else
  write(u6,216) IX1,IX2
  write(u6,213)
  write(u6,216) IY1,IY2
end if
ILIM = 4
if (IFIRST /= 0) ILIM = 2
! ERROR CONDITIONS:
!if (LN /= NISHT+NASHT+NVALT) then
!  write(u6,*) ' ERROR: Orbital specifications do not match'
!  write(u6,*) ' input to GUGA. The number of internal'
!  write(u6,*) ' orbitals must equal the number of inactive,'
!  write(u6,*) ' active, and additional valence orbitals.'
!  call QUIT(20)
!end if
! ALLOCATION FOR INDEX VECTORS
! THESE VECTORS ARE PERMANENTLY IN CORE
! -- INDEX
call mma_allocate(INDX,IRC(ILIM),label='INDX')
NVIR2 = NVIRT*NVIRT
call mma_allocate(ISAB,NVIR2,label='ISAB')
call mma_allocate(JREFX,ISC(1),label='JREFX')
IADD10 = IAD10(2)
call iDAFILE(Lu_CIGuga,2,JREFX,ISC(1),IADD10)
call INDMAT_CPF(JSY,INDX,ISAB,ISMAX,JREFX)
call mma_deallocate(JREFX)
call ALLOC_CPF()

return

214 format(//,6X,'INTERNAL CONFIGURATIONS')
215 format(/,6X,'NUMBER OF VALENCE STATES',I16,/,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7, &
            /,6X,'NUMBER OF TRIPLET COUPLED DOUBLES',I7,/,6X,'NUMBER OF SINGLET COUPLED DOUBLES',I7)
213 format(//,6X,'FULL-SPACE CONFIGURATIONS (FORMAL)')
216 format(/,6X,'NUMBER OF VALENCE STATES',I16,/,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7)

contains

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  select case (code)
    case (1)
      write(u6,*) 'READIN Error: Premature end of file while reading.'
    case (2)
      write(u6,*) 'READIN Error: I/O error during internal read.'
      write(u6,*) 'The line that could not be read is:'
      write(u6,*) Line
  end select
  call Quit_OnUserError()

end subroutine Error

end subroutine ReadIn_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine reainput
c
c     this routine do:
c     1) read INPDAT file, produced by REORG with mul,nsym,noa,nob,nva,nvb,norb,eps
c     2) read input file for CCSD to read (parameters transported through cmm common)
c     ! title   - jobtitle
c     1-ntit rows with 72 characters
c     no default
c     ! ntit    - number of rows in jobtitle
c     ntit is limited to 10 !!! NOT ANY MORE !!! ntit is limited to 1
c     default (1)
c     ! maxiter - maximum number of iterations
c     default (10)
c     ! typt3   - type of T3 cpntribution
c     0 - CCSD
c     1 - CCSD+T(CCSD)
c     2 - CCSD(T)
c     default (0)
c     ! typden  - type of denominator (division of fok)
c     0 - diagonal elements
c     1 - average of faa and fbb
c     2 - orbital energies
c     default (0)
c     ! firstext- first iteration wnere extrapolation is used
c     (default-no) less than cycext is not possible
c     ! cycext  - cycle of extrapolation
c     (default-no) limited to 2-4
c     ! ccnonv  - energy convergence criterion
c     (default=1.0d-6)
c     ! keysa   - Spin adaptation key
c     0 - no adaptation
c     1 - T2 DDVV adaptation
c     2 - T2 DDVV + T1 DV adaptation
c     3 - full T1 and T2 adaptation (only for doublets)
c     4 - full T2 adaptation without SDVS (only for doublets)
c     (default=0)
c     ! keyrst  - restart key
c     0 - no saving restart informations (amplitudes)
c     1 - save amplitudes
c     2 - start from previous informations
c     (default=1)
c     ! filerst - name for restart informations file
c     (default=RSTART)
c     ! mchntyp - type of machine in matrix multiplication
c     1 - C=A*B is faster or comparable with C=AT*B
c     2 - C=AT*B is faster
c     (default=1)
c     ! slim    - limitation for usieng C=AT*B
c     no default (suitable=2.0d0)
c     ! shifhto - shift for occupied
c     (default=0.0)
c     ! shifhtv - shift for virtuals
c     (default=0.0)
c     ! maxspace - maximal allowed work space
c     (default=0 - unlimited)
c     ! fullprint - level of printing contrlo key
c     (default=0)
c     & noop  - no operation key
c     (default=no)
c     & iokey - I/O control key
c       1 - Fortran I/O system
c       2 - MOLCAS DA IO system
c     (default=2)
c     & mhkey - Matrix handling control key
c       1 - ESSL routines
c       2 - Fortran I/O system
c     & noccsd - key to supress CCSD run
c     (default=no)c     (default=1)
c     .....   - can be added
c
#include "ccsd1.fh"
c
c     help variables
c
       character*80 LINE
       integer nhelp
       integer f_iostat,f_recl
       logical is_error
c
c1    read INPDAT
c
       call molcas_open_ext2(1,'INPDAT','sequential','unformatted',
     &             f_iostat,.false.,f_recl,'unknown',is_error)
c       open (unit=1,file='INPDAT',form='unformatted')
       read (1) nactel,ispin,nsym,lsym,mmul,
     &          noa,nob,nva,nvb,norb,eps,Escf
       close (1)
c
c2    def dimm
c
       do 10 nhelp=1,nsym
c
       dimm(1,nhelp)=noa(nhelp)
       dimm(2,nhelp)=nob(nhelp)
       dimm(3,nhelp)=nva(nhelp)
       dimm(4,nhelp)=nvb(nhelp)
       dimm(5,nhelp)=norb(nhelp)
c
 10     continue
c
c3    define nshf
c
       do 20 nhelp=1,maxorb
       nshf(nhelp)=(nhelp-1)*(nhelp-2)/2
 20     continue

c
c4    define defaults
c
       maxiter=30
       typt3=0
       ntit=1
       typden=0
       yesext=0
       firstext=0
       cycext=0
       ccconv=1.0d-7
       keysa=0
       keyrst=1
       filerst='RSTART'
       mchntyp=1
       slim=1.0d0
       shifto=0.0d0
       shiftv=0.0d0
       maxspace=0
CGG       fullprint=0
       noop=0
       iokey=1
       mhkey=1
       noccsd=0
c
c5    read input file
c
      LuSpool = 17
      Call SpoolInp(LuSpool)
      Rewind(LuSpool)
 5      Read(LuSpool,'(A80)') LINE
       CALL UPCASE(LINE)
       IF( INDEX(LINE,'&CCSDT') .EQ. 0 ) GOTO 5
       TITLE=' '
 6     Read(LuSpool,'(A80)') LINE
       IF(LINE(1:1).EQ.'*') GOTO 6
       CALL UPCASE(LINE)
c
       IF (LINE(1:4).EQ.'TITL') THEN
       Read(LuSpool,'(A72)') TITLE
       ELSE IF (LINE(1:4).EQ.'ITER') THEN
       Read(LuSpool,*) maxiter
       ELSE IF (LINE(1:4).EQ.'DENO') THEN
       Read(LuSpool,*) typden
       if ((typden.lt.0).or.(typden.gt.2)) then
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Invalid type of denominators'
         write(6,*) ' parameter typden changed to 2'
         end if
       typden=2
       end if
       ELSE IF (LINE(1:4).EQ.'EXTR') THEN
       yesext=1
       Read(LuSpool,*) firstext,cycext
       if ((cycext.lt.2).or.(cycext.gt.4)) then
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Size of DIIS procedure out of range'
         write(6,*) ' parameter cycext changed to 4'
         end if
       cycext=4
       end if
       if (firstext.lt.cycext) then
       firstext=cycext
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, First DIIS iteration is smaller '//
     &              'then DIIS size'
         write(6,*) ' parameter firstext was changed to:',firstext
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'ACCU') THEN
       Read(LuSpool,*) ccconv
       ELSE IF (LINE(1:4).EQ.'ADAP') THEN
       Read(LuSpool,*) keysa
       if ((keysa.gt.4).or.(keysa.lt.0)) then
       keysa=0
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Adaptation key out of range'
         write(6,*) ' parameter keysa changed to 0'
         end if
       end if
       if ((keysa.ne.0).and.(typden.eq.0)) then
       typden=2
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, typden is incompatible with SA'
         write(6,*) ' type of denominators changed to 2 - Orb. energies'
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'REST') THEN
       Read(LuSpool,*) keyrst
       if ((keyrst.lt.0).or.(keyrst.gt.2)) then
       keyrst=1
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Restart key out of range'
         write(6,*) ' parameter keyrst changed to 1'
         end if
       end if
       Read(LuSpool,*) filerst
       ELSE IF (LINE(1:4).EQ.'MACH') THEN
       Read(LuSpool,*) mchntyp,slim
       if ((mchntyp.lt.1).or.(mchntyp.gt.2)) then
       mchntyp=1
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Machinetype out of range'
         write(6,*) ' parameter mchtyp changed to 1'
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'SHIF') THEN
       Read(LuSpool,*) shifto,shiftv
       ELSE IF (LINE(1:4).EQ.'PRIN') THEN
       Read(LuSpool,*) fullprint
       if ((fullprint.lt.0).or.(fullprint.gt.3)) then
       fullprint=0
       write(6,*) ' Warning!!!, Printing key out of range'
       write(6,*) ' parameter fullprint changed to 0'
       end if
       ELSE IF (LINE(1:4).EQ.'NOOP') THEN
       noop=1
       ELSE IF (LINE(1:4).EQ.'IOKE') THEN
       Read(LuSpool,*) iokey
       if ((iokey.lt.0).or.(iokey.gt.2)) then
       iokey=2
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, I/O key out of range'
         write(6,*) ' parameter iokey changed to 2'
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'MHKE') THEN
       Read(LuSpool,*) mhkey
       if ((mhkey.lt.0).or.(mhkey.gt.2)) then
       mhkey=1
         if (fullprint.ge.0) then
         write(6,*) ' Warning!!!, Matrix handling key out of range'
         write(6,*) ' parameter mhkey changed to 1'
         end if
       end if
       ELSE IF (LINE(1:4).EQ.'NOSD') THEN
       noccsd=1
       ELSE IF (LINE(1:4).EQ.'END ') THEN
       GOTO 7
       END IF
       GOTO 6
 7      CONTINUE
c
       Call Close_LuSpool(LuSpool)
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE SORT_CPF(BUFOUT,INDOUT,ICAD,IBUFL,FC,FIJ,FJI,TIBUF)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION BUFOUT(*),INDOUT(*)
      DIMENSION ICAD(*),FC(*),IBUFL(*),FIJ(*),FJI(*),TIBUF(*)
      DIMENSION IVEC(20),IPOF(65)
      DIMENSION NORB0(9)
*
      IAD50=0
      CALL iDAFILE(Lu_TraInt,2,iTraToc,nTraToc,IAD50)
      NVT=IROW(NVIRT+1)
      DO 50 I=1,20
      IVEC(I)=0
50    CONTINUE
      IN=1
      DO 3 I=1,NSYM
      CALL IPO_CPF(IPOF(IN),NVIR,MUL,NSYM,I,-1)
      IN=IN+NSYM
3     CONTINUE
C ORDER OF RECORD-CHAINS IS
C 1. NOT2 CHAINS (AB/IJ)
C 2. NOT2 CHAINS (AI/BJ)
C 3. NOT2 CHAINS (AI/JK)
C RECORD STRUCTURE IS
C 1. LBUF INTEGRALS
C 2. LBUF INDICES
C 3. NUMBER OF INTEGRALS IN THIS RECORD
C 4. ADDRESS OF LAST RECORD
      NOT2=IROW(LN+1)
      NOV=3*NOT2
      NOTT=2*NOT2
      NOVST=LN*NVIRT+1+NVT
      IDISK=0
      LBUF0=RTOI*LBUF
      LBUF1=LBUF0+LBUF+1
      LBUF2=LBUF1+1
      IDIV=RTOI
      ID=0
      DO 5 IREC=1,NOV
      IBUFL(IREC)=0
      ICAD(IREC)=ID
      INDOUT(ID+LBUF2)=-1
      ID=ID+LBUF2
5     CONTINUE
      NORB0(1)=0
      DO 2 I=1,NSYM
      NORB0(I+1)=NORB0(I)+NORB(I)
2     CONTINUE
C
C     ONE ELECTRON INTEGRALS
C
      NORBTT=0
      DO 7654 ISYM=1,nsym
        NORBTT=NORBTT+(NORB(ISYM)*(NORB(ISYM)+1))/2
 7654 CONTINUE
      EMY=POTNUC
      NOB2=IROW(NORBT+1)
      IADD17=ITOC17(2)
      CALL dDAFILE(Lu_TraOne,2,FIJ,NORBTT,IADD17)
      CALL DCOPY_(NOB2,[0.0D0],0,FC,1)
      IBUF=0
      KORBI=0
      DO 200 ISYM=1,NSYM
        DO 198 JORBI=KORBI+1,KORBI+NORB(ISYM)
          DO 199 IORBI=KORBI+1,JORBI
            IBUF=IBUF+1
            ONEHAM=FIJ(IBUF)
            NI=ICH(IORBI)
            NJ=ICH(JORBI)
            IF(NI.EQ.0.OR.NJ.EQ.0)GO TO 199
            IF(NI.LT.NJ) THEN
              NTMP=NI
              NI=NJ
              NJ=NTMP
            END IF
            IF(NJ.GT.0) THEN
              IJT=IROW(NI)+NJ
              FC(IJT)=FC(IJT)+ONEHAM
            ELSE IF(NI.EQ.NJ) THEN
              EMY=EMY+2.0D0*ONEHAM
            END IF
199       CONTINUE
198     CONTINUE
        KORBI=KORBI+NORB(ISYM)
200   CONTINUE
      CALL DCOPY_(NOB2,[0.0D0],0,FIJ,1)
      CALL DCOPY_(NOB2,[0.0D0],0,FJI,1)
      IF( IPRINT.GE.20 ) THEN
         CALL TRIPRT('FC IN SORT BEFORE TWOEL',' ',FC,NORBT)
         WRITE(6,'(A,F20.8)') ' EMY:',EMY
      CALL XFLUSH(6)
      END IF
C
C     TWO-ELECTRON INTEGRALS
C
      DO 313 NSP=1,NSYM
      NOP=NORB(NSP)
      DO 312 NSQ=1,NSP
      NSPQ=MUL(NSP,NSQ)
      NOQ=NORB(NSQ)
      DO 311 NSR=1,NSP
      NSPQR=MUL(NSPQ,NSR)
      NOR=NORB(NSR)
      NSSM=NSR
      IF(NSR.EQ.NSP)NSSM=NSQ
      DO 310 NSS=1,NSSM
      IF(NSS.NE.NSPQR)GO TO 310
      NOS=NORB(NSS)
      NORBP=NOP*NOQ*NOR*NOS
      IF(NORBP.EQ.0)GO TO 310
      CALL dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
      IOUT=0
      DO 309 NV=1,NOR
      NXM=NOS
      IF(NSR.EQ.NSS)NXM=NV
      DO 308 NX=1,NXM
      NTM=1
      IF(NSP.EQ.NSR)NTM=NV
      DO 307 NT=NTM,NOP
      NUMIN=1
      IF(NSP.EQ.NSR.AND.NT.EQ.NV)NUMIN=NX
      NUMAX=NOQ
      IF(NSP.EQ.NSQ)NUMAX=NT
      DO 306 NU=NUMIN,NUMAX
      IOUT=IOUT+1
      IF(IOUT.GT.NTIBUF) THEN
         CALL dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
         IOUT=1
      END IF
      M1=ICH(NORB0(NSP)+NT)
      M2=ICH(NORB0(NSQ)+NU)
      M3=ICH(NORB0(NSR)+NV)
      M4=ICH(NORB0(NSS)+NX)
      IF(M1.EQ.0.OR.M2.EQ.0)GO TO 306
      IF(M3.EQ.0.OR.M4.EQ.0)GO TO 306
C     ORDER THESE INDICES CANONICALLY
      N1=M1
      N2=M2
      IF(M1.GT.M2)GO TO 11
      N1=M2
      N2=M1
11    N3=M3
      N4=M4
      IF(M3.GT.M4)GO TO 12
      N3=M4
      N4=M3
12    NI=N1
      NJ=N2
      NK=N3
      NL=N4
      IF(NI.GT.NK)GO TO 502
      IF(NI.EQ.NK)GO TO 14
      NI=N3
      NJ=N4
      NK=N1
      NL=N2
      GO TO 502
14    IF(NJ.GT.NL)GO TO 502
      NL=N2
      NJ=N4
502   FINI=TIBUF(IOUT)
      IF(ABS(FINI).LT.1.D-09)GO TO 306
      IF(NI.LE.0 .OR. NJ.LE.0)GO TO 41
      IF(NK.LE.0 .OR. NL.LE.0)GO TO 41
      DFINI=ABS(FINI)
      IEXP=INT(-LOG10(DFINI+1.0D-20)+5)
      IF(IEXP.GT.20) IEXP=20
      IF(IEXP.LT.1) IEXP=1
      IVEC(IEXP)=IVEC(IEXP)+1
      IF(NI.NE.NJ.OR.NK.NE.NL)GO TO 42
      IJ=IROW(NI)+NK
      FIJ(IJ)=FINI
C     SKIP (AA/II) INTEGRALS
      GO TO 306
42    IF(NI.NE.NK.OR.NJ.NE.NL)GO TO 43
      IJ=IROW(NI)+NJ
      FJI(IJ)=FINI
43    IF(NI.LE.LN)GO TO 306
      IF(NJ.GT.LN)GO TO 102
      IF(NK.GT.LN)GO TO 103
C     AIJK
      JK=NOTT+IROW(NK)+NL
      IBUFL(JK)=IBUFL(JK)+1
      ICQ=ICAD(JK)
      ICP=ICQ/IDIV+IBUFL(JK)
      BUFOUT(ICP)=FINI
      ICPP=ICQ+LBUF0+IBUFL(JK)
      INDOUT(ICPP)=IROW(NI)+NJ
      IF(IBUFL(JK).LT.LBUF)GO TO 306
      INDOUT(ICQ+LBUF1)=LBUF
      JDISK=IDISK
      CALL iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),LBUF2,IDISK)
      INDOUT(ICQ+LBUF2)=JDISK
      IBUFL(JK)=0
      GO TO 306
103   IF(NL.GT.LN)GO TO 306
C     AIBJ
      IIJ=NOT2+IROW(NJ)+NL
      IF(NL.GT.NJ)IIJ=NOT2+IROW(NL)+NJ
      IBUFL(IIJ)=IBUFL(IIJ)+1
      ICQ=ICAD(IIJ)
      ICP=ICQ/IDIV+IBUFL(IIJ)
      BUFOUT(ICP)=FINI
      NSA=NSM(NI)
      NAV=NI-LN-NSYS(NSA)
      NSB=NSM(NK)
      NBV=NK-LN-NSYS(NSB)
      NSIJT=(MUL(NSM(NJ),NSM(NL))-1)*NSYM
      IF(NL.GT.NJ)GO TO 105
      INAV=IPOF(NSIJT+NSA)+(NBV-1)*NVIR(NSA)+NAV
      GO TO 104
105   INAV=IPOF(NSIJT+NSB)+(NAV-1)*NVIR(NSB)+NBV
104   ICPP=ICQ+LBUF0+IBUFL(IIJ)
      INDOUT(ICPP)=INAV
      IF(IBUFL(IIJ).LT.LBUF)GO TO 108
      INDOUT(ICQ+LBUF1)=LBUF
      JDISK=IDISK
      CALL iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),LBUF2,IDISK)
      INDOUT(ICQ+LBUF2)=JDISK
      IBUFL(IIJ)=0
108   IF(NJ.NE.NL)GO TO 306
      IF(NI.EQ.NK)GO TO 306
      JNAV=IROW(NI)+NK
      FC(JNAV)=FC(JNAV)-FINI
      GO TO 306
102   IF(NK.GT.LN)GO TO 306
C     ABIJ
      IIJ=IROW(NK)+NL
      IBUFL(IIJ)=IBUFL(IIJ)+1
      ICQ=ICAD(IIJ)
      ICP=ICQ/IDIV+IBUFL(IIJ)
      BUFOUT(ICP)=FINI
      NSA=NSM(NI)
      NAV=NI-LN-NSYS(NSA)
      NSB=NSM(NJ)
      NBV=NJ-LN-NSYS(NSB)
      NSIJT=(MUL(NSM(NK),NSM(NL))-1)*NSYM
      INAV=IPOF(NSIJT+NSA)+(NBV-1)*NVIR(NSA)+NAV
      ICPP=ICQ+LBUF0+IBUFL(IIJ)
      INDOUT(ICPP)=INAV
      IF(IBUFL(IIJ).LT.LBUF)GO TO 106
      INDOUT(ICQ+LBUF1)=LBUF
      JDISK=IDISK
      CALL iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),LBUF2,IDISK)
      INDOUT(ICQ+LBUF2)=JDISK
      IBUFL(IIJ)=0
106   IF(NK.NE.NL)GO TO 306
      IF(NI.EQ.NJ)GO TO 306
      JNAV=IROW(NI)+NJ
      FC(JNAV)=FC(JNAV)+D2*FINI
      GO TO 306
C     CHECK FOR FOCK-MATRIX CONTRIBUTION
41    IF(NI.NE.NJ)GO TO 51
      II=1
      CALL IFOCK(FC,NI,NK,NL,FINI,II)
      IF(NK.NE.NL)GO TO 52
      IF(NI.GT.0.OR.NK.GT.0)GO TO 57
      EMY=EMY+D2*FINI
      IF(NI.NE.NK)EMY=EMY+D2*FINI
57    IF(NI.EQ.NK)GO TO 52
      CALL IFOCK(FC,NK,NI,NJ,FINI,II)
      GO TO 52
51    IF(NK.NE.NL)GO TO 52
      II=1
      CALL IFOCK(FC,NK,NI,NJ,FINI,II)
52    II=0
      IF(NI.NE.NK)GO TO 53
      CALL IFOCK(FC,NI,NJ,NL,FINI,II)
      IF(NJ.NE.NL)GO TO 306
      IF(NI.GT.0.OR.NJ.GT.0)GO TO 58
      EMY=EMY-FINI
      IF(NI.NE.NJ)EMY=EMY-FINI
58    IF(NI.EQ.NJ)GO TO 306
      CALL IFOCK(FC,NJ,NI,NK,FINI,II)
      GO TO 306
53    IF(NI.NE.NL)GO TO 54
      CALL IFOCK(FC,NI,NJ,NK,FINI,II)
      GO TO 306
54    IF(NJ.NE.NK)GO TO 55
      CALL IFOCK(FC,NJ,NI,NL,FINI,II)
      GO TO 306
55    IF(NJ.NE.NL)GO TO 306
      CALL IFOCK(FC,NJ,NI,NK,FINI,II)
306   CONTINUE
307   CONTINUE
308   CONTINUE
309   CONTINUE
310   CONTINUE
311   CONTINUE
312   CONTINUE
313   CONTINUE
C     EMPTY LAST BUFFERS
      If ( (NOVST+NOV).gt.mAdr ) then
         WRITE(6,*)'SORT Error: NOVST+NOV>MADR (See code).'
         CALL Abend
      End If
      DO 150 I=1,NOV
      ICQ=ICAD(I)
      INDOUT(ICQ+LBUF1)=IBUFL(I)
      JDISK=IDISK
      CALL iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),LBUF2,IDISK)
      LASTAD(NOVST+I)=JDISK
150   CONTINUE
      DO 95 J=1,NORBT
      IND=IROW(J+1)
      FC(IND)=FC(IND)+EMY/N
95    CONTINUE
      IADD25=0
      CALL dDAFILE(Lu_25,1,FC,NOB2,IADD25)
      IAD25S=IADD25
      WRITE(6,154)
      CALL XFLUSH(6)
154   FORMAT(//6X,'STATISTICS FOR INTEGRALS, FIRST ENTRY 10**3-10**4',
     */)
      WRITE(6,155)(IVEC(I),I=1,20)
      CALL XFLUSH(6)
155   FORMAT(6X,5I10)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine o2v4 (wrk,wrksize,
     c                   NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c                   mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,
     c                   LunAux)
c
c       this routine do:
c
c       t(u,v,bega) <- sum(a,b) [ b(a,b,be,ga) . Tau(u,v,a,b) ]
c
c       b(a,b,be,ga) =             (a,be|b,ga)
c                    - sum (i)   [ (a,be|b,i) . t(i,ga) ]
c                    - sum (i)   [ (a,i|b,ga) . t(i,be) ]
c                    + sum (i,j) [ (a,i|b,j) . t(i,be) . t(j,ga) ]
c
c       Tau(u,v,ab) = t(u,v,ab) + t(i,a) . t(j,b) : stored for: i,j,a>=b
c
c
cA      List of main arrays:
c
c*      tau(i,j,(a,b)') - PossTau
c
c*      t2n1(ij,(bega)")- PossT2n1
c       t2n2(ij,(bega)")- PossT2n2
c       t2w(ij,(ab)")   - PossT2w - work file for T(+-)
c
c*      L21 (m,a',be')  - PossL21
c       L22 (m,a',ga')  - PossL22
c       L23 (m,b',be')  - PossL23
c       L24 (m,b',ga')  - PossL24
c        L2W (m,c',de')  - PossL2W - Used for Tmp file in GetCHV
c       some (or all) of L2s might be identical
c
c*      M1(m,a",be")  - PossM1, used also for M(m,b'',be'')
c       M2(m,b",ga")  - PossM2, used also for M(m,a'',ga'')
c       Both Ms might be identical (mozno + M3 ako manipulacne)
c
c*      W1(a",be",b",ga") - PossW1 - b(a",be"|b",ga")
c       W2(b",be",a",ga") - PossW2 - b(b",be"|a",ga")
c       Ww((ab)",(bega)") - PossWw - work file for b(+-)
c
c
cB      list of additional arrays
c
cC      list of used pre- and suffixes and assignements
c
c       _Grp         - Group
c       _SGrp        - SubGroup
c       Poss_        - Possition
c       PsAc_        - Actual Possition
c       (...)'       - Group, Block
c       (...)"       - SubGroup, SubBlock
c
cD      list of most important variables
c
        use Para_Info, only: MyRank
        implicit none
#include "wrk.fh"
#include "chcc1.fh"
#include "parcc.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
        integer NaGrp,NbeGrp,NaSGrp,NbeSgrp,LunAux

        integer PossTau,PossT2n1,PossT2n2,PossT2w
        integer PossL11,PossL12
        integer PossL21,PossL22,PossL23,PossL24,PossL2W
        integer PossH1,PossH2
        integer PossM1,PossM2,PossW1,PossW2,PossWw,PossWx
        integer PsAcL21,PsAcL22,PsAcL23,PsAcL24
c       integer PsAcM1,PsAcM2
        integer pL21,pL22,pL23,pL24
        integer L2Status(1:4,1:3)
        integer PossT,dim1,dim2,dim3,lent2n1,lent2n2
        integer mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,NL2
c
        integer aGrp,bGrp,gaGrp,beGrp,aSGrp,bSGrp,gaSGrp,beSGrp
        integer dima,dimb,adda,addb
        integer dimbe,dimga,addbe,addga,addbepp,addgapp
        integer bSGrpUp,gaSGrpUp
        integer i,j
        integer choleskykey
        integer FirstT2n(1:maxSGrp,1:maxSGrp)
        character*6 LunName
c
        if (intkey.eq.1) then
          choleskykey=0
        else
          choleskykey=1
        end if
c
cx      distribute memory
c
        PossT=PossFree
        call DistMemo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     &                 mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,
     &                 PossTau,PossT2n1,PossT2n2,PossT2w,
     &                 PossL11,PossL12,
     &                 PossL21,PossL22,PossL23,PossL24,PossL2W,
     &                 PossH1,PossH2,
     &                 PossM1,PossM2,PossW1,PossW2,PossWw,PossWx,
     &                 PossT,NL2)
        if (printkey.ge.10) then
        write (6,*) ' Last Value :',PossT,wrksize
        end if
        if (PossT.gt.wrksize) then
cmp!          write (6,*) ' Nieje dobre - o2v4, Dr. Ch. Kokotopuloss',
          write (6,*) ' Not Enough memory in o2v4 step!'//
     & 'Increase large and/or small segmentation ',
     &    (1.0d0*PossT)/(1.0d0*wrksize)
          call abend
        end if
c
c@@
c        call Calc_Bc
c@@
c
cx      initialize L2Status
c
        do i=1,NL2
        do j=1,3
          L2Status(i,j)=0
        end do
        end do
c
        if (NL2.eq.1) then
          L2Status(1,3)=possL21
        else if (NL2.eq.2) then
          if (NbeGrp.eq.1) then
            L2Status(1,3)=possL21
            L2Status(2,3)=possL23
          else
            L2Status(1,3)=possL21
            L2Status(2,3)=possL22
          end if
        else
          L2Status(1,3)=possL21
          L2Status(2,3)=possL22
          L2Status(3,3)=possL23
          L2Status(4,3)=possL24
        end if
c
c
cx        initialize FirstT2n and Generate Tmp3Name s
c##        initialize T2o2v4yes
c
c
        do beGrp=1,nbeGrp
        do gaGrp=1,beGrp
c
          do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)
          if (beGrp.eq.gaGrp) then
            gaSGrpUp=beSGrp
          else
            gaSGrpUp=GrpbeUp(gaGrp)
          end if
          do gaSGrp=GrpbeLow(gaGrp),gaSGrpUp
c
          FirstT2n(beSGrp,gaSGrp)=1
c
          T2o2v4yes(beSGrp,gaSGrp)=0
c
          end do
          end do
c
        end do
        end do
c
c
c*      cycle over all groups of (a>=b)
        adda=0
        do aGrp=1,naGrp
        dima=DimGrpa(aGrp)
c
c##        test, if on this node atleast one combination with this
c        aGrp is scheduled. Skip if no
        i=0
        do j=1,NaGrp
          i=i+ABID(myRank,aGrp,j)
        end do
        if (i.eq.0) goto 12
c
c
        if (choleskykey.eq.1) then
cx          read L2W(m,i,a') <- L1(m,i,a')
          LunName=L1Name(aGrp)
          dim1=nc*dima*no
          call GetX (wrk(PossL2W),dim1,LunAux,LunName,1,1)
cx          Map L11(m,a',i) <- L2W(m,i,a')
          call Map3_132(wrk(PossL2W),wrk(PossL11),nc,no,dima)
        end if
c
        addb=0
        do bGrp=1,aGrp
        dimb=DimGrpa(bGrp)
c
c##     test, if this a'b' combination is planed to be run on this node
        if (ABID(myRank,aGrp,bGrp).eq.0) goto 11
        if (printkey.ge.10) then
        write (6,*) ' O2V4 MyRank, aGrp, bGrp',myRank, aGrp,bGrp
        end if
c
c
          if (choleskykey.eq.1) then
cx            read L12(m,b',i) <- L1(m,b',i)
              LunName=L1Name(bGrp)
            dim1=nc*dimb*no
            if (NaGrp.gt.1) then
              if (aGrp.eq.bGrp) then
                call mv0u (dim1,wrk(PossL11),1,wrk(PossL12),1)
              else
                call GetX (wrk(PossL2W),dim1,LunAux,LunName,1,1)
                call Map3_132(wrk(PossL2W),wrk(PossL12),nc,no,dimb)
              end if
            end if
          end if
c
c
cx        read the block of  amplitudes T2((ab)',ij) for given aGrp,bGrp
c          and make Tau from them
          call getTau (wrk(PossTau),wrk(PossT1o),
     c                 aGrp,bGrp,dima,dimb,adda,addb,LunAux)
c
cx        cycle over all groups of (be>=ga)
          addbe=0
          do beGrp=1,nbeGrp
          dimbe=DimGrpbe(beGrp)
          addga=0
          do gaGrp=1,beGrp
          dimga=DimGrpbe(gaGrp)
c
            if (choleskykey.eq.1) then
cxx         read Cholesky vectors
c*          L21 (m,a',be')
c           L22 (m,a',ga')
c           L23 (m,b',be')
c           L24 (m,b',ga')
            call getChV (wrk,wrksize,
     c                     aGrp,bGrp,beGrp,gaGrp,NL2,L2Status,
     c                     pL21,pL22,pL23,pL24,PossL2W,
     c                     PossL11,PossL12,LunAux)
            PsAcL21=L2Status(pL21,3)
            PsAcL22=L2Status(pL22,3)
            PsAcL23=L2Status(pL23,3)
            PsAcL24=L2Status(pL24,3)
            else
            PsAcL21=0
            PsAcL22=0
            PsAcL23=0
            PsAcL24=0
            end if
c
cxx         cycle over all subgroups of (be>=ga)'
            addbepp=addbe
            do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)
c
            if (intkey.eq.1) then
cxx              get H1(i,be") <- t1o(be,i)
              call Mk_T1t (wrk(PossT1o),wrk(PossH1),
     c        DimSGrpbe(beSGrp),no,nv,addbepp)
            end if
c
            if (beGrp.eq.gaGrp) then
              gaSGrpUp=beSGrp
            else
              gaSGrpUp=GrpbeUp(gaGrp)
            end if
c
            addgapp=addga
            do gaSGrp=GrpbeLow(gaGrp),gaSGrpUp
c
              if (intkey.eq.1) then
cxxx                get H2(i,ga") <- t1o(ga,i)
                call Mk_T1t (wrk(PossT1o),wrk(PossH2),
     c          DimSGrpbe(gaSGrp),no,nv,addgapp)
              end if
c
cxxx          vanish arrays for new (final) amplitudes, if this is a
c               first use, or read from Tmp3Name(be",ga") actual stage
c             T2n1((bega)",ij)
c             T2n2((bega)",ij)
              if (FirstT2n(beSGrp,gaSgrp).eq.1) then
                call VanishT2n (wrk(PossT2n1),wrk(PossT2n2),
     c                          beSGrp,gaSGrp)
                FirstT2n(beSGrp,gaSgrp)=0
              else
                call GetT2n (wrk(PossT2n1),wrk(PossT2n2),
     c                       beSGrp,gaSGrp,LunAux)
              end if
c
c
cxxx          cycle over all subgroups of (a>=b)'
              do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
              if (aGrp.eq.bGrp) then
                bSGrpUp=aSGrp
              else
                bSGrpUp=GrpaUp(bGrp)
              end if
              do bSGrp=GrpaLow(bGrp),bSGrpUp
        if (printkey.ge.10) then
        write (6,99)aGrp,bGrp,beGrp,gaGrp,aSGrp,bSGrp,beSGrp,gaSGrp
        end if
99      format (8(i3,1x))
c
                if (choleskykey.eq.1) then
c
c*              cholesky generation of (VV|VV) integrals
c
cxxxx             Extract M1(m,a",be") from L21(m,a',be')
                  call  ExtractM (wrk(PossM1),wrk(PsAcL21),
     c                            aGrp,beGrp,aSGrp,beSGrp)
cxxxx             Extract M2(m,b",ga") from L24(m,b',ga')
                  if ((aSGrp.eq.bSGrp).and.(beSGrp.eq.gaSGrp)) then
                    if (PossM1.ne.PossM2) then
                      dim1=nc*DimSGrpa(aSGrp)*DimSGrpbe(beSGrp)
                      call mv0u (dim1,wrk(PossM1),1,wrk(PossM2),1)
                    end if
                  else
                    call  ExtractM (wrk(PossM2),wrk(PsAcL24),
     c                              bGrp,gaGrp,bSGrp,gaSGrp)
                  end if
cxxxx             Calc W1(a",be",b",ga")=M1(m,a",be")(T).M2(m,b",ga")
                  dim1=DimSGrpa(aSGrp)*DimSGrpbe(beSGrp)
                  dim2=DimSGrpa(bSGrp)*DimSGrpbe(gaSGrp)
                  call mv0zero (dim1*dim2,dim1*dim2,wrk(possW1))
                  call mc0c1at3b(nc,dim1,nc,dim2,dim1,dim2,dim1,nc,dim2,
     c                          wrk(possM1),wrk(possM2),wrk(possW1))
c
                  if (aSGrp.ne.bSGrp) then
cxxxx             Extract M1(m,b",be") from L23(m,b',be')
                  call  ExtractM (wrk(PossM1),wrk(PsAcL23),
     c                          bGrp,beGrp,bSGrp,beSGrp)
cxxxx             Extract M2(m,a",ga") from L22(m,a',ga')
                  call  ExtractM (wrk(PossM2),wrk(PsAcL22),
     c                          aGrp,gaGrp,aSGrp,gaSGrp)
cxxxx             Calc W2(b",be",a",ga")=M1(m,b",be")(T).M2(m,a",ga")
                  dim1=DimSGrpa(bSGrp)*DimSGrpbe(beSGrp)
                  dim2=DimSGrpa(aSGrp)*DimSGrpbe(gaSGrp)
                  call mv0zero (dim1*dim2,dim1*dim2,wrk(possW2))
                  call mc0c1at3b (nc,dim1,nc,dim2,dim1,dim2,
     c                          dim1,nc,dim2,
     c                          wrk(possM1),wrk(possM2),wrk(possW2))
                  end if
c
                else
c
c*              clasical reading or generating of (VV|VV) integrals
c
cxxxx                term W1(a",be",b",ga") <- -(b"ga"|a"i) . T1(i,be")
c                Def:W1 destroy:Ww
cxxxx1          Get Ww(b",ga",a",i) (Wx used as Aux)
                call ReaW3 (wrk(PossWw),wrk(PossWx),
     c                      bSGrp,gaSGrp,aSGrp,LunAux)
cxxxx2                Map V1(a",ga",b",i) <- Ww(b",ga",a",i)
                call Map4_3214 (wrk(PossWw),wrk(PossW1),
     c                          DimSGrpa(bSGrp),DimSGrpbe(gaSGrp),
     c                          DimSGrpa(aSGrp),no)
cxxxx3          Calc Ww(a",ga",b",be") <- - W1(a",ga",b",i) . H1(i,be")
                dim1=DimSGrpa(bSGrp)*DimSGrpa(aSGrp)*DimSGrpbe(gaSGrp)
                dim2=DimSGrpbe(beSGrp)
                call mv0zero (dim1*dim2,dim1*dim2,wrk(PossWw))
                call mc0c2a3b (dim1,no,no,dim2,dim1,dim2,dim1,no,dim2,
     c                         wrk(PossW1),wrk(PossH1),wrk(PossWw))
cxxxx4                Map W1(a",be",b",ga") <<- Ww(a",ga",b",be")
                call Map4_1432 (wrk(PossWw),wrk(PossW1),
     c                          DimSGrpa(aSGrp),DimSGrpbe(gaSGrp),
     c                          DimSGrpa(bSGrp),DimSGrpbe(beSGrp))
c
cxxxx                term W1(a",be",b",ga") <<- -(a"be"|b"i) . T1(i,ga")
c                Upgrade: W1, destroy: Ww
cxxxx1          Get Ww(a",be",b",i) (Wx used as Aux)
                call ReaW3 (wrk(PossWw),wrk(PossWx),
     c                      aSGrp,beSGrp,bSGrp,LunAux)
cxxxx2          Add W1(a",be",b",ga") <<- - Ww(a",be",b",i) . H2(i,ga")
                dim1=DimSGrpa(aSGrp)*DimSGrpa(bSGrp)*DimSGrpbe(beSGrp)
                dim2=DimSGrpbe(gaSGrp)
                call mc0c2a3b (dim1,no,no,dim2,dim1,dim2,dim1,no,dim2,
     c                         wrk(PossWw),wrk(PossH2),wrk(PossW1))
c
c
cxxxx           Upgrade W1(a",be",b",ga") <<- (a",be"|b",ga")
c                Upgrade:W1 destroy:Ww
                call ReaW4 (wrk(PossW1),wrk(PossWw),
     c                     aSGrp,beSGrp,bSGrp,gaSGrp,LunAux)
c
c
                if (aSGrp.ne.bSGrp) then

cxxxx                  term W2(b",be",a",ga") <- -(a"ga"|b"i) . T1(i,ga")
c                  Def:W2 destroy: Ww
cxxxx1            Get Ww(a",ga",b",i) (Wx used as Aux)
                  call ReaW3 (wrk(PossWw),wrk(PossWx),
     c                        aSGrp,gaSGrp,bSGrp,LunAux)
cxxxx2                  Map W2(b",ga",a",i) <- Ww(a",ga",b",i) @@Nepreskusany
                  call Map4_3214 (wrk(PossWw),wrk(PossW2),
     c                            DimSGrpa(aSGrp),DimSGrpbe(gaSGrp),
     c                            DimSGrpa(bSGrp),no)
cxxxx3            Calc Ww(b",ga",a",be") <- -W2(b",ga",a",i) . H1(i,be")
                  dim1=DimSGrpa(aSGrp)*DimSGrpbe(gaSGrp)*DimSGrpa(bSGrp)
                  dim2=DimSGrpbe(beSGrp)
                  call mv0zero (dim1*dim2,dim1*dim2,wrk(PossWw))
                  call mc0c2a3b (dim1,no,no,dim2,dim1,dim2,dim1,no,dim2,
     c                           wrk(PossW2),wrk(PossH1),wrk(PossWw))
cxxxx4                  Map W2 (b",be",a",ga") <- Ww(b",ga",a",be")
                  call Map4_1432 (wrk(PossWw),wrk(PossW2),
     c                            DimSGrpa(bSGrp),DimSGrpbe(gaSGrp),
     c                            DimSGrpa(aSGrp),DimSGrpbe(beSGrp))
c
cxxxx                  term W2(b",be",a",ga") <<- -(b"be"|a"i) . T1(i,ga")
c                  Upgrade:W2 destroy: 0
cxxxx1            Get Ww(b",be",a",i) (Wx used as Aux)
                  call ReaW3 (wrk(PossWw),wrk(PossWx),
     c                        bSGrp,beSGrp,aSGrp,LunAux)
cxxxx2            Add W2(b",be",a",ga") <<- - Ww(b",be",a",i) .H2(i,ga")
                  dim1=DimSGrpa(aSGrp)*DimSGrpa(bSGrp)*DimSGrpbe(beSGrp)
                  dim2=DimSGrpbe(gaSGrp)
                  call mc0c2a3b (dim1,no,no,dim2,dim1,dim2,dim1,no,dim2,
     c                           wrk(PossWw),wrk(PossH2),wrk(PossW2))
c
cxxxx             Add W2(b",be",a",ga") <<- (b",be"Ia",ga")
c                  Upgrade:W2, destroy:Ww
                  call ReaW4 (wrk(PossW2),wrk(PossWw),
     c                       bSGrp,beSGrp,aSGrp,gaSGrp,LunAux)
                end if
c
                end if
c
c
c
cxxxx           Make t2w(+)((ab)",ij) from Tau((ab)',ij)
                call MakeT2p (wrk(PossT2w),wrk(PossTau),
     c                        aGrp,bGrp,aSGrp,bSGrp,1)
cxxxx           Make  Ww(+)((ab)",(bega)") from W1(a",be",b",ga")
c                                           and W2(b",be",a",ga")
c                     N.B. for a"=b" we have only W1 defined (=W2)
c                          but never mind (solved within MakeWw)
                call MakeWw (wrk(PossWw),wrk(PossW1),wrk(PossW2),
     c                       aSGrp,bSGrp,beSGrp,gaSGrp,1)
cxxxx           Add T2n1((bega)",ij) <<-
cxxxxc              Ww(+)(T)((ab)",(bega)").t2w(+)((ab)",ij)
                dim1=no*(no+1)/2
                if (aSGrp.eq.bSGrp) then
                  dim2=DimSGrpa(aSGrp)*(DimSGrpa(bSGrp)-1)/2
                else
                  dim2=DimSGrpa(aSGrp)*DimSGrpa(bSGrp)
                end if
                if (beSGrp.eq.gaSGrp) then
                  dim3=DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/2
                else
                  dim3=DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
                end if
                call mc0c1at3b (dim2,dim3,dim2,dim1,dim3,dim1,
     c                         dim3,dim2,dim1,
     c                         wrk(possWw),wrk(possT2w),wrk(possT2n1))
c
c
                 if (aSGrp.eq.bSGrp) then
cxxxx           Make t2w(+)((aa)",ij) from Tau((ab)',ij)
                call MakeT2pd (wrk(PossT2w),wrk(PossTau),aGrp,aSGrp)
cxxxx           Make  Ww(+)((aa)",(bega)") from W1(a",be",a",ga")
                call MakeWwd (wrk(PossWw),wrk(PossW1),
     c                       aSGrp,beSGrp,gaSGrp)
cxxxx           Add T2n1((bega)",ij) <<-
cxxxxc              Ww(+)(T)((aa)",(bega)").t2w(+)((aa)",ij)
                dim1=no*(no+1)/2
                dim2=DimSGrpa(aSGrp)
                if (beSGrp.eq.gaSGrp) then
                  dim3=DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/2
                else
                  dim3=DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
                end if
                call mc0c1at3b (dim2,dim3,dim2,dim1,dim3,dim1,
     c                         dim3,dim2,dim1,
     c                         wrk(possWw),wrk(possT2w),wrk(possT2n1))
                end if
c
c
cxxxx           Make t2w(-)((ab)",ij) from Tau((ab)',ij)
                call MakeT2m (wrk(PossT2w),wrk(PossTau),
     c                        aGrp,bGrp,aSGrp,bSGrp,1)
cxxxx           Make  Ww(-)((ab)",(bega)") from W1(a",be",b",ga")
c                                           and W2(b",be",a",ga")
c                          but never mind (solved within MakeWw)
                call MakeWw (wrk(PossWw),wrk(PossW1),wrk(PossW2),
     c                       aSGrp,bSGrp,beSGrp,gaSGrp,2)
c       write (6,*) 'V'
cxxxx           Add T2n2((bega)",ij) <<-
c                   Ww(-)(T)((ab)",(bega)").t2w(-)((ab)",ij)
                dim1=no*(no-1)/2
                if (aSGrp.eq.bSGrp) then
                  dim2=DimSGrpa(aSGrp)*(DimSGrpa(bSGrp)-1)/2
                else
                  dim2=DimSGrpa(aSGrp)*DimSGrpa(bSGrp)
                end if
                if (beSGrp.eq.gaSGrp) then
                  dim3=DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)-1)/2
                else
                  dim3=DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
                end if
                call mc0c1at3b (dim2,dim3,dim2,dim1,dim3,dim1,
     c                         dim3,dim2,dim1,
     c                         wrk(possWw),wrk(possT2w),wrk(possT2n2))
c
c
cxxx          end cycle over all subgroups of (a>=b)'
              end do
              end do
c
cxxx          Save T2n1(bega)",ij) and T2n2((bega)",ij)
cxxxc              in recreated form, corresponding to standard
cxxxc              storage in T2 amplitudes
              LunName=Tmp3Name(beSGrp,gaSGrp)
              if (beSGrp.eq.gaSGrp) then
                lent2n1=no*(no+1)*
     c                  DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/4
                lent2n2=no*(no-1)*
     c                  DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)-1)/4
              else
                lent2n1=no*(no+1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)/2
                lent2n2=no*(no-1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)/2
              end if
              T2o2v4yes(beSGrp,gaSGrp)=1
              call SaveX (wrk(PossT2n1),lent2n1,LunAux,LunName,1,0)
              call SaveX (wrk(PossT2n2),lent2n2,LunAux,LunName,0,1)
c
cxx         end cycle over all subgroups of (be>=ga)'
            addgapp=addgapp+DimSGrpbe(gaSGrp)
            end do
            addbepp=addbepp+DimSGrpbe(beSGrp)
            end do
c
cx        end cycle over all groups of (be>=ga)
          addga=addga+dimga
          end do
          addbe=addbe+dimbe
          end do
c
c*      end cycle over all groups of (a>=b)
11        addb=addb+dimb
        end do
12        adda=adda+dima
        end do
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003, Valera Veryazov                                  *
!               2017, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PrFin(OneHam,Ovlp,Dens,TwoHam,nDT,EOrb,OccNo,nEO,CMO,nCMO,note,iCase,MssVlc,Darwin)
!***********************************************************************
!                                                                      *
!     purpose: Final printout                                          *
!                                                                      *
!     input:                                                           *
!       Dens    : the last total density                               *
!       TwoHam  : the last two-electron ham.                           *
!       OneHam  : one-electron hamiltonian of length nOOK              *
!       Ovlp    : overlap in AO basis of length nOOK                   *
!       EOrb    : orbital energies of length nEO                       *
!       OccNo   : occupation numbers of length nEO                     *
!       CMO     : molecular orbital coefficients of length nCMO        *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use SpinAV, only: Do_SpinAV
use InfSCF, only: BName, EneV, ExFac, iCoCo, InVec, iPrForm, iPrint, iPrOrb, jPrint, kIvo, KSDFT, lRel, nBas, nBB, nBT, nD, nIter, &
                  nIterP, nnB, NoProp, nOrb, nSYm, PotNuc, ThrEne, Tot_Charge
use rctfld_module, only: lRF
use NDDO, only: oneel_NDDO
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDT, nEO, nCMO, iCase
real(kind=wp), intent(in) :: OneHam(nDT), Ovlp(nDT), Dens(nDT), TwoHam(nDT), EOrb(nEO), OccNo(nEO), CMO(nCMO), MssVlc(nDT), &
                             Darwin(nDT)
character(len=80), intent(out) :: Note
integer(kind=iwp) :: iBs, iCharge, iCMO, ij, i_Or, iPL, iRC, iSpin, iSym, iv, iVec, jCase
real(kind=wp) :: EHomo, ELumo, ERelDC, ERelMV
logical(kind=iwp) :: DeBug, Dff, Do_DFT, Do_ESPF, First, FullMlk, get_BasisType, NonEq, PrEne, PrOcc
character(len=60) :: Frmt
character(len=30) :: AlphaLabel
real(kind=wp), allocatable :: RFfld(:), Scr2(:), Scr3(:)
real(kind=wp), parameter :: ThrOcc = -99999.0_wp
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: EFP_On, Reduce_Prt

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

jPrint = iPrint
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0
if (iPL <= 1) jPrint = 1

!----------------------------------------------------------------------*

#ifdef _DEBUGPRINT_
Debug = .true.
#else
Debug = .false.
if (jPrint >= 4) Debug = .true.
#endif

Frmt = '(6X,A,T50,F17.10)'
AlphaLabel = ' '
if (nD == 2) then
  if (iCase == 0) AlphaLabel = ' (alpha) '
  if (iCase == 1) AlphaLabel = ' (beta)  '
end if

if (Do_SpinAV) AlphaLabel = Alphalabel(1:9)//'and (spin-averaged)'

! Compute relativistic corrections
if (lRel) then
  call RelEny(ERelMV,ERelDC,Dens,MssVlc,Darwin,nBT)
  if (jPrint >= 2) then
    write(u6,*)
    write(u6,'(6X,A)') '1st order relativistic corrections'
    write(u6,Frmt) 'Total energy',EneV+ERelMV+ERelDC
    write(u6,Frmt) 'Mass-velocity correction',ERelMV
    write(u6,Frmt) '1-el Darwin correction',ERelDC
    write(u6,Frmt) 'Sum of relatvity corrections',ERelDC+ERelMV
    write(u6,*)
  end if
end if

! Print numerical quadrature information
iSpin = 1
if (nD == 2) iSpin = 2
if ((KSDFT /= 'SCF') .and. (iCase == 0)) call Print_NQ_Info()

! Write out last density matrix to output
if (DeBug) then
  write(u6,'(6x,A)') 'Last density matrix (interpolated) in AO basis'
  ij = 1
  do iSym=1,nSym
    write(u6,*) ' symmetry',iSym
    call TriPrt(' ',' ',Dens(ij),nBas(iSym))
    ij = ij+nTri_Elem(nBas(iSym))
  end do
  write(u6,*)
  write(u6,'(6x,A)') 'Last 2-el. Hamiltonian (interpolated) in AO basis'
  ij = 1
  do iSym=1,nSym
    write(u6,*) ' symmetry',iSym
    call TriPrt(' ',' ',TwoHam(ij),nBas(iSym))
    ij = ij+nTri_Elem(nBas(iSym))
  end do
  write(u6,*)
  write(u6,'(6x,A)') 'Last 1-el. Hamiltonian (interpolated) in AO basis'
  ij = 1
  do iSym=1,nSym
    write(u6,*) ' symmetry',iSym
    call TriPrt(' ',' ',OneHam(ij),nBas(iSym))
    ij = ij+nTri_Elem(nBas(iSym))
  end do
  write(u6,*)
end if

! Process the external potential with the total electronic density

!nf
call DecideOnESPF(Do_ESPF)
!nf if ((lRF .or. (KSDFT /= 'SCF')) .and. (.not. oneel_NDDO) .and.
if ((Do_ESPF .or. lRF .or. (KSDFT /= 'SCF') .or. EFP_On()) .and. (.not. oneel_NDDO) .and. (iCase == 0)) then
  iCharge = int(Tot_Charge)
  NonEq = .false.
  !call Get_PotNuc(PotNuc)
  !call Get_dScalar('PotNuc',PotNuc)
  call Peek_dScalar('PotNuc',PotNuc)
  call mma_allocate(RFfld,nBT,Label='RFfld')
  RFfld(:) = Zero
  First = .true.
  Dff = .false.
  Do_DFT = .false. ! We do not need to redo the DFT!
  call DrvXV(RFfld,RFfld,Dens,PotNuc,nBT,First,Dff,NonEq,lRF,KSDFT,ExFac,iCharge,iSpin,'SCF ',Do_DFT)
  call mma_deallocate(RFfld)

  ! Print multipole analysis of the reaction field contributions

  call RFmltp()

end if

! Print orbitals (the case InVec=3 and nIter=0 is set up in RdInp)
Frmt = '(6X,A)'
if (iPrOrb >= 1) then
  FullMlk = .true.
  PrEne = .true.
  PrOcc = .true.
  if (iPrOrb == 1) then
    EHomo = -99999.0_wp
    ELumo = 99999.0_wp
    ij = 1
    do iSym=1,nSym
      do iv=1,nOrb(iSym)
        if (OccNo(ij+iv-1) > 0.001_wp) then
          EHomo = max(EHomo,EOrb(ij+iv-1))
        else
          ELumo = min(ELumo,EOrb(ij+iv-1))
        end if
      end do
      ij = ij+nOrb(iSym)
    end do
    ThrEne = ELumo+Half
    if (jPrint >= 2) then
      write(u6,*)
      write(u6,Frmt) 'All orbitals with orbital energies smaller than  E(LUMO)+0.5 are printed'
    end if
  else
    if (jPrint >= 2) then
      write(u6,*)
      write(u6,'(6X,A,ES11.4,A)') 'All orbitals with orbital energies smaller than',ThrEne,' are printed'
    end if
  end if
  if (KSDFT == 'SCF') then
    if (nD == 1) then
      Note = 'SCF orbitals'//AlphaLabel
      if (kIvo /= 0) Note = 'SCF orbitals + IVO'
      if (iCoCo /= 0) Note = 'SCF orbitals + arbitrary occupations'
    else
      Note = 'UHF orbitals'//AlphaLabel
      if (kIvo /= 0) Note = 'UHF orbitals + IVO'
      if (iCoCo /= 0) Note = 'UHF orbitals + arbitrary occupations'
    end if
  else
    if (nD == 1) then
      Note = 'RKS-DFT orbitals'//AlphaLabel
      if (kIvo /= 0) Note = 'RKS-DFT orbitals + IVO'
      if (iCoCo /= 0) Note = 'RKS-DFT orbitals + arbitrary occupations'
    else
      Note = 'UKS-DFT orbitals'//AlphaLabel
      if (kIvo /= 0) Note = 'UKS-DFT orbitals + IVO'
      if (iCoCo /= 0) Note = 'UKS-DFT orbitals + arbitrary occupations'
    end if
  end if
  if (jPrint >= 2) call PriMO(Note,PrOcc,PrEne,ThrOcc,ThrEne,nSym,nBas,nOrb,BName,EOrb,OccNo,CMO,iPrForm)
else
  if (jPrint >= 2) write(u6,Frmt) 'No orbitals printed'
  FullMlk = .false.
end if

if ((InVec /= 3) .or. (nIter(nIterP) > 0)) then
  call mma_allocate(Scr2,nBB,Label='Scr2')
  call mma_allocate(Scr3,nnB,Label='Scr3')

  ! Prepare CMO in symmetry blocks nBas x nBas
  iVec = 0
  iCMO = 0
  do iSym=1,nSym
    Scr2(iVec+1:iVec+nBas(iSym)*nOrb(iSym)) = CMO(iCMO+1:iCMO+nBas(iSym)*nOrb(iSym))
    iVec = iVec+nBas(iSym)*nOrb(iSym)
    Scr2(iVec+1:iVec+nBas(iSym)*(nBas(iSym)-nOrb(iSym))) = Zero
    iVec = iVec+nBas(iSym)*(nBas(iSym)-nOrb(iSym))
    iCMO = iCMO+nOrb(iSym)*nBas(iSym)
  end do

  ! Prepare occupation numbers

  i_Or = 0
  iBs = 0
  do iSym=1,nSym
    Scr3(iBs+1:iBs+nOrb(iSym)) = OccNo(i_Or+1:i_Or+nOrb(iSym))
    Scr3(iBs+nOrb(iSym)+1:iBs+nBas(iSym)) = Zero
    i_Or = i_Or+nOrb(iSym)
    iBs = iBs+nBas(iSym)
  end do

  if (.not. NoProp) then

    ! Population analysis

    jCase = iCase
    if (nD == 1) jCase = 2
    call Charge(nSym,nBas,BName,Scr2,Scr3,Ovlp,jCase,FullMlk,.true.)

    if (get_BasisType('ANO')) then
      iRc = 0
      call LoProp(iRc)

      ! NBO analysis

      call Nat_Bond_Order(nSym,nBas,BName,jCase)
    end if
  end if

  ! ESPF analysis

  if (Do_ESPF) call espf_analysis(.true.)

  call mma_deallocate(Scr3)
  call mma_deallocate(Scr2)

end if

end subroutine PrFin

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Per Ake Malmqvist                                *
!***********************************************************************
!****************************************************************
!  PROGRAM RASSI        PER-AAKE MALMQVIST 2000-06-30
!  SUBROUTINE TRAINT
!  TRANSFORM TWO-ELECTRON INTEGRALS TO A MIXED ACTIVE ORBITAL
!  BASIS. THE RESULTING INTEGRALS ARE STORED IN ARRAY TUVX IN
!  THE SAME FORMAT AS THE 2-EL TRANSITION DENSITY MATRICES.
!****************************************************************

subroutine TRAINT(CMO1,CMO2,NGAM2,TUVX)

use Index_Functions, only: nTri_Elem
use TRNSFRM, only: IAPR, ISP, ISQ, ISR, ISS, LMOP1, LMOQ1, LMOR1, LMOS1, NAP, NAQ, NAR, NAS, NAVX, NBP, NBPQ, NBQ, NBR, NBRS, NBS, &
                   NVXPQ, NX1MX, NX2MX, NX3MX
use Symmetry_Info, only: MUL, nIrrep
use rassi_data, only: NASH, NBASF, NBMX, NCMO, NISH, NOSH
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NGAM2
real(kind=wp), intent(in) :: CMO1(NCMO), CMO2(NCMO)
real(kind=wp), intent(out) :: TUVX(NGAM2)
integer(kind=iwp) :: IA, INTBUF, IRC, IS, ISPQ, ISRS, KEEP(8), LMOP, LMOQ, LMOR, LMOS, NACT, NBSX(8), NSP, NSPQ, NSPQR, NSQ, NSR, &
                     NSRM, NSS, NSSM, NSYMX
logical(kind=iwp) :: ISQARX
real(kind=wp), allocatable :: VXPQ(:), X1(:), X2(:), X3(:)

! CLEAR THE ARRAY OF TRANSFORMED INTEGRALS.
TUVX(:) = Zero
! RETRIEVE STRUCTURE DATA FOR THE ORDERED INTEGRAL FILE.
! KEEP(IS) IS POSITIVE TO INDICATE THAT BASIS FUNCTIONS WITH
! SYMMETRY LABEL IS SHOULD BE SKIPPED. KEEP(2)=0 OR 1 TO SHOW
! IF SYMMETRY LABELS IJKL OF EACH SYMMETRY BLOCK ARE CANONICAL
! (ONLY CASES I>=J,K>=L,IJ>=KL PRESENT) OR IF LEFT AND RIGHT HAND
! PAIR ARE INDIVIDUALLY TREATED (I>=J,K>=L), RESPECTIVELY.
! THE IDATA ARRAY GIVES DISK ADDRESS, AND NUMBER OF INTEGRAL MATRICES
! PER BUFFER, FOR EACH SYMMETRY BLOCK. THERE ARE AT MOST 176 SUCH
! BLOCKS, AND THEIR ORDERING IS DETERMINED BY THE SYMMETRY
! LOOPS, WHICH MUST BE THE SAME AS IN THE ORDERING PROGRAM.
! RETRIEVE BASE DATA FROM UNIT LUORD:
! RETRIEVE BASE DATA FROM UNIT LUORD:
IRC = 0
call GETORD(IRC,ISQARX,NSYMX,NBSX,KEEP)
! SET UP IAPR(IS)=NR OF ACTIVES WITH PREVIOUS SYMMETRY LABEL.
IA = 0
do IS=1,nIrrep
  IAPR(IS) = IA
  IA = IA+NASH(IS)
end do
! LOOP OVER QUADRUPLES OF SYMMETRIES (NSP,NSQ,NSR,NSS) NSR>=NSS
! IN THE SAME ORDER AS IN THE INTORD PROGRAM.
INTBUF = max(NBMX**2,256*256)
LMOP = 1
do NSP=1,nIrrep
  if (NSP /= 1) LMOP = LMOP+NBASF(NSP-1)*NOSH(NSP-1)
  NAP = NASH(NSP)
  !KEEPP = KEEP(NSP)
  NBP = NBASF(NSP)
  ISP = NSP
  LMOP1 = LMOP+NISH(NSP)*NBP
  LMOQ = 1
  do NSQ=1,NSP
    if (NSQ /= 1) LMOQ = LMOQ+NBASF(NSQ-1)*NOSH(NSQ-1)
    NAQ = NASH(NSQ)
    !KEEPQ = KEEP(NSQ)
    NBQ = NBASF(NSQ)
    NSPQ = MUL(NSP,NSQ)
    ISQ = NSQ
    ISPQ = nTri_Elem(ISP-1)+ISQ
    LMOQ1 = LMOQ+NISH(NSQ)*NBQ
    LMOR = 1
    NSRM = nIrrep
    if (ISQARX) NSRM = NSP
    do NSR=1,NSRM
      if (NSR /= 1) LMOR = LMOR+NBASF(NSR-1)*NOSH(NSR-1)
      NAR = NASH(NSR)
      !KEEPR = KEEP(NSR)
      NBR = NBASF(NSR)
      LMOR1 = LMOR+NBR*NISH(NSR)
      NSPQR = MUL(NSPQ,NSR)
      ISR = NSR
      LMOS = 1
      NSSM = NSR
      do NSS=1,NSSM
        if (NSS /= 1) LMOS = LMOS+NBASF(NSS-1)*NOSH(NSS-1)
        if (NSPQR /= NSS) cycle
        NAS = NASH(NSS)
        !KEEPS = KEEP(NSS)
        NBS = NBASF(NSS)
        LMOS1 = LMOS+NBS*NISH(NSS)
        ISS = NSS
        ISRS = nTri_Elem(ISR-1)+ISS
        ! SHOULD THIS SYMMETRY BLOCK BE USED...?
        !KEEPT = KEEPP+KEEPQ+KEEPR+KEEPS
        NACT = NAP*NAQ*NAR*NAS
        ! ...WELL, IT IS PRESENT ON THE FILE
        if (ISPQ < ISRS) cycle
        if (NACT == 0) cycle
        ! ALLOCATE WORK AREAS FOR IN-CORE TRANSFORMATION ROUTINE TRACR:
        if (ISR == ISS) then
          NBPQ = nTri_Elem(NBP)
          NBRS = nTri_Elem(NBR)
        else
          NBPQ = NBP*NBQ
          NBRS = NBR*NBS
        end if
        NAVX = NAR*NAS
        NX1MX = max(INTBUF,NBP*NAQ,NBQ*NAP)
        NX2MX = max(NBR*NBS,NAP*NAQ)
        NX3MX = max(NBR*NAS,NAR*NBS,NBP*NBQ)
        NVXPQ = NAVX*NBPQ
        call mma_allocate(X1,NX1MX,Label='X1')
        call mma_allocate(X2,NX2MX,Label='X2')
        call mma_allocate(X3,NX3MX,Label='X3')
        call mma_allocate(VXPQ,NVXPQ,Label='VXPQ')
        call TRACR(INTBUF,CMO1,CMO2,NGAM2,TUVX,X1,X2,X3,VXPQ)
        call mma_deallocate(X1)
        call mma_deallocate(X2)
        call mma_deallocate(X3)
        call mma_deallocate(VXPQ)
      end do
    end do
  end do
end do
call GADGOp(TUVX,NGAM2,'+')

end subroutine TRAINT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_Col_cp(X,nRow,nCol,S,nSRow,iSRow)
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: copy subblock of matrix.

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nRow, nCol, nSRow, iSRow(nSRow)
real(kind=wp), intent(in) :: X(nRow,nCol)
real(kind=wp), intent(out) :: S(nSRow,nCol)
integer(kind=iwp) :: iR, iSR

do iSR=1,nSRow
  iR = iSRow(iSR)
  S(iSR,:) = X(iR,:)
end do

end subroutine ChoMP2_Col_cp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine rdi_cvb(ivec,n,file_id,ioffset)
      implicit real*8 (a-h,o-z)
#include "idbl_cvb.fh"
      dimension ivec(n),ibuf(8)

      call rdi_cvb_internal(ivec,ibuf)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine rdi_cvb_internal(ivec,ibuf)
      use iso_c_binding
      integer, target :: ivec(*),ibuf(*)
      real*8, pointer :: vec(:),buf(:)
      nreals=n/idbl
      nrem=n-nreals*idbl
      call c_f_pointer(c_loc(ivec(1)),vec,[nreals])
      call rdlow_cvb(vec,nreals,file_id,ioffset)
      nullify(buf)
      if(nrem.gt.0)then
        call c_f_pointer(c_loc(ibuf(1)),buf,[1])
        call rdlow_cvb(buf,1,file_id,nreals+ioffset)
        nullify(buf)
        call imove_cvb(ibuf,ivec(1+nreals*idbl),nrem)
      endif
      return
      end subroutine rdi_cvb_internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Jonas Bostrom                                          *
!***********************************************************************

subroutine Mult_with_Q_MP2(nBas_aux,nBas,nIrrep)
!*************************************************************************
!     Author: Jonas Bostrom
!
!     Purpose: Multiply MP2 A~_sep and B~_sep with inverse cholesky factors.
!
!*************************************************************************

use Symmetry_Info, only: Mul
use RI_glob, only: A, nAuxVe
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nIrrep, nBas_Aux(1:nIrrep), nBas(1:nIrrep)
#include "cholesky.fh"
integer(kind=iwp) :: i, iA_in, iA_Out, iAdr, iAdrA, iAdrA_in(8), iAdrA_Out(8), iAdrQ, iOffQ1, iOpt, ip_B, iSeed, iSym, iType, &
                     jSym, jVec, kSym, kVec, l_A, l_A_ht, l_A_t, l_B_t, l_Q, lTot, Lu_A(2), Lu_B(4), Lu_Q, MaxMem, nBas2, nLR, &
                     nLRb(8), NumAux, NumCV, NumVecJ, NumVecK, nVec
real(kind=wp) :: Fac, TotCPU1, TotWall1
character(len=6) :: FName, Name_Q
character(len=*), parameter :: SECNAM = 'Mult_with_Q_MP2'
real(kind=wp), allocatable :: A_ht(:), A_t(:), B_t(:), QVec(:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TotCPU1,TotWall1)

do i=1,2
  iSeed = 7
  Lu_A(i) = IsFreeUnit(iSeed)
  write(FName,'(A5,I1)') 'AMP2V',i
  call DaName_MF_WA(Lu_A(i),FName)
end do

do i=1,4
  iSeed = 7
  Lu_B(i) = IsFreeUnit(iSeed)
  write(FName,'(A5,I1)') 'BMP2V',i
  call DaName_MF_WA(Lu_B(i),FName)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
iA_in = 1
iA_Out = 1
do iSym=1,nSym
  NumCV = NumCho(iSym)
  NumAux = nBas_Aux(iSym)-1
  nLR = 0
  do jSym=1,nSym
    kSym = Mul(iSym,jSym)
    nLR = nLR+nBas(jSym)*nBas(kSym)
  end do
  nLRb(iSym) = nLR
  iAdrA_in(iSym) = iA_in
  iA_in = iA_in+NumCV*NumCV
  iAdrA_out(iSym) = iA_out
  iA_out = iA_out+NumAux*NumAux
end do
!                                                                      *
!***********************************************************************
!                                                                      *
do iSym=1,nSym

  nBas2 = nLRb(iSym)
  NumCV = NumCho(iSym)
  NumAux = nBas_Aux(iSym)-1
  nAuxVe = NumAux

  ! Get Q-vectors from disk
  ! -----------------------

  l_Q = NumCV*NumAux
  call mma_allocate(QVec,l_Q,Label='QVec')

  iSeed = 7
  Lu_Q = IsFreeUnit(iSeed)
  write(Name_Q,'(A4,I2.2)') 'QVEC',iSym-1
  call DaName_MF_WA(Lu_Q,Name_Q)

  iOpt = 2
  iAdrQ = 0
  call dDaFile(Lu_Q,iOpt,QVec,l_Q,iAdrQ)

  ! Get MP2 A-tilde vectors from disk
  ! ---------------------------------

  l_A_t = NumCV*NumCV
  l_A = NumAux*NumAux
  l_A_ht = NumAux*NumCV
  call mma_allocate(A_t,l_A_t,Label='A_t')
  call mma_allocate(A,l_A,Label='A')
  call mma_allocate(A_ht,l_A_ht,Label='A_ht')

  do iType=1,2

    iOpt = 2
    iAdrA = iAdrA_in(iSym)
    call dDaFile(Lu_A(iType),iOpt,A_t,l_A_t,iAdrA)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Q-vectors'
    do i=1,l_Q
      write(u6,*) QVec(i)
    end do

    write(u6,*) 'A-vectors'
    do i=1,l_A
      write(u6,*) A_t(i)
    end do
#   endif

    ! Make first halftransformation to cholesky-base
    ! ----------------------------------------------

    call dGemm_('N','N',NumAux,NumCV,NumCV,One,QVec,NumAux,A_t,NumCV,Zero,A_ht,NumAux)

    call dGemm_('N','T',NumAux,NumAux,NumCV,One,A_ht,NumAux,QVec,NumAux,Zero,A,NumAux)

    ! Put transformed A-vectors back on disk

    iOpt = 1
    iAdrA = iAdrA_out(iSym)
    call dDaFile(Lu_A(iType),iOpt,A,l_A,iAdrA)

  end do

  call mma_deallocate(A_t)
  call mma_deallocate(A)
  call mma_deallocate(A_ht)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call mma_maxDBLE(MaxMem)
  MaxMem = 9*(MaxMem/10)
  call mma_allocate(B_t,MaxMem,Label='B_t')

  nVec = MaxMem/(2*nLRb(iSym))
  nVec = min(max(NumCV,NumAux),nVec)
  if (nVec < 1) then
    call ChoMP2_Quit(SecNam,'nVec is non-positive','[1]')
  end if

  l_B_t = nLRb(iSym)*nVec
  ip_B = 1+l_B_t

  do iType=1,2

    ! The B-vectors should be read one batch at the time
    ! --------------------------------------------------

    do kVec=1,NumAux,nVec
      NumVecK = min(nVec,NumAux-(kVec-1))

      do jVec=1,NumCV,nVec
        NumVecJ = min(nVec,NumCV-(jVec-1))

        iOpt = 2
        lTot = NumVecJ*nLRb(iSym)
        iAdr = 1+nLRb(iSym)*(jVec-1)
        call dDaFile(Lu_B(iType),iOpt,B_t,lTot,iAdr)

        Fac = Zero
        if (jVec /= 1) Fac = One
        iOffQ1 = kVec+NumAux*(jVec-1)
        call dGemm_('N','T',nBas2,NumVecK,NumVecJ,One,B_t,nBas2,QVec(iOffQ1),NumAux,Fac,B_t(ip_B),nBas2)
      end do

      iOpt = 1
      lTot = NumVecK*nBas2
      iAdr = 1+nBas2*(kVec-1)
      call dDaFile(Lu_B(iType+2),iOpt,B_t(ip_B),lTot,iAdr)

    end do

  end do

  call mma_deallocate(B_t)
  call mma_deallocate(QVec)

  call DaClos(Lu_Q)

end do ! iSym

do i=1,2
  call DaClos(Lu_A(i))
end do
do i=1,4
  call DaClos(Lu_B(i))
end do

return

end subroutine Mult_with_Q_MP2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module CASPT2_Module

use Molcas, only: LenIn, MxAct, MxBas, MxIna, MxLev, MxOrb, MxRoot
use RASDim, only: MxTit
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: MXCASE = 13, MxExt = MxBas-MxAct, MxState = MxRoot

integer(kind=iwp) :: DWTYPE, IAD1M(64), IADR10(64,2), IASYM(MxAct), IEOF1M, IEXTIS(MXEXT), IFQCAN, IINAIS(MxIna), IISYM(MxIna), &
                     IOFFRHS(8,MXCASE), iRlxRoot, IROOT(MxRoot), ISCF, ISPIN, JSTATE, LROOTS, MAXIT, MSTATE(MXSTATE), MXCI, &
                     NACTEL, NAES(8), NAGEB(8), NAGEBES(8), NAGTB(8), NAGTBES(8), NAMX, NASH(8), NASHT, NASUP(8,MXCASE), NBAS(8), &
                     NBAST, NBMX, NBSQT, NBTCH(8), NBTCHES(8), NBTRI, NCASES, NCONF, NDEL(8), NDET, NELE3, NEXCES(8,MXCASE), &
                     NFRO(8), NFROT, NG1, NG2, NG3, NG3TOT, NGROUP, NGROUPSTATE(MXSTATE), NHOLE1, NIAES(8), NIES(8), NIGEJ(8), &
                     NIGEJES(8), NIGTJ(8), NIGTJES(8), NIMX, NINABX, NINDEP(8,MXCASE), NISH(8), NISHT, NISUP(8,MXCASE), NLYGROUP, &
                     NLYROOT, NOMX, NORB(8), NORBT, NOSH(8), NOSQT, NOTRI, NRAS1(8), NRAS1T, NRAS2(8), NRAS2T, NRAS3(8), NRAS3T, &
                     NROOTS, NSECBX, NSES(8), NSMX, NSSH(8), NSSHT, NSTATE, NSYM, NTGEU(8), NTGEUES(8), NTGTU(8), NTGTUES(8), &
                     NTU(8), NTUES(8), NTUV(8), NTUVES(8), ROOT2STATE(MxRoot), STSYM
real(kind=wp) :: CITHR, CPUEIG, CPUFG3, CPUFMB, CPUGIN, CPUGRD, CPUINT, CPULCS, CPUNAD, CPUOVL, CPUPCG, CPUPRP, CPUPT2, CPURHS, &
                 CPUSBM, CPUSCA, CPUSER, CPUSGM, CPUSIN, CPUVEC, DENORM, E2CORR, E2TOT, EASUM, ENERGY(MXSTATE), EPS(MXORB), &
                 EPSA(MxAct), EPSE(MXEXT), EPSI(MxIna), EREF, ERFSELF, ETA(MXLEV), POTNUC, REFENE(MXSTATE), RNORM, THRCONV, &
                 THRENE, THROCC, THRSHN, THRSHS, TIOEIG, TIOFG3, TIOFMB, TIOGIN, TIOGRD, TIOINT, TIOLCS, TIONAD, TIOOVL, TIOPCG, &
                 TIOPRP, TIOPT2, TIORHS, TIOSBM, TIOSCA, TIOSER, TIOSGM, TIOSIN, TIOVEC, ZETA
logical(kind=iwp) :: DMRG, DoCumulant, G1SECIN, IfChol, IFDENS, IFDORTHO, IFDW, IFMIX, IFMSCOUP, IFPROP, IFRMS, IFSADREF, IFXMS, &
                     JMS, PRORB, PRSD, RFPERT, RHSDIRECT
character(len=LenIn+8) :: BNAME(2*MXORB)
character(len=32) :: HZERO
character(len=12) :: PT2Method, CPT2Method
character(len=8) :: BMATRIX, BSPECT, BTRANS, CLAB10(64), FOCKTYPE, ISNAM(MXEXT), ORBIN, ORBNAM(MXORB), OUTFMT, SDECOM, SMATRIX
character(len=4) :: TITLE(18,MxTit)
character(len=2) :: HEADER(72)
character(len=*), parameter :: CASES(MXCASE) = [character(len=8) :: 'VJTU','VJTIP','VJTIM','ATVX','AIVX','VJAIP','VJAIM', &
                                                                    'BVATP','BVATM','BJATP','BJATM','BJAIP','BJAIM']


public :: BMATRIX, BNAME, BSPECT, BTRANS, CASES, CITHR, CLAB10, CPT2Method, CPUEIG, CPUFG3, CPUFMB, CPUGIN, CPUGRD, CPUINT, &
          CPULCS, CPUNAD, CPUOVL, CPUPCG, CPUPRP, CPUPT2, CPURHS, CPUSBM, CPUSCA, CPUSER, CPUSGM, CPUSIN, CPUVEC, DENORM, DMRG, &
          DoCumulant, DWTYPE, E2CORR, E2TOT, EASUM, ENERGY, EPS, EPSA, EPSE, EPSI, EREF, ERFSELF, ETA, FOCKTYPE, G1SECIN, HEADER, &
          HZERO, IAD1M, IADR10, IASYM, IEOF1M, IEXTIS, IfChol, IFDENS, IFDORTHO, IFDW, IFMIX, IFMSCOUP, IFPROP, IFQCAN, IFRMS, &
          IFSADREF, IFXMS, IINAIS, IISYM, IOFFRHS, iRlxRoot, IROOT, ISCF, ISNAM, ISPIN, JMS, JSTATE, LROOTS, MAXIT, MSTATE, &
          MXCASE, MXCI, MXEXT, NACTEL, NAES, NAGEB, NAGEBES, NAGTB, NAGTBES, NAMX, NASH, NASHT, NASUP, NBAS, NBAST, NBMX, NBSQT, &
          NBTCH, NBTCHES, NBTRI, NCASES, NCONF, NDEL, NDET, NELE3, NEXCES, NFRO, NFROT, NG1, NG2, NG3, NG3TOT, NGROUP, &
          NGROUPSTATE, NHOLE1, NIAES, NIES, NIGEJ, NIGEJES, NIGTJ, NIGTJES, NIMX, NINABX, NINDEP, NISH, NISHT, NISUP, NLYGROUP, &
          NLYROOT, NOMX, NORB, NORBT, NOSH, NOSQT, NOTRI, NRAS1, NRAS1T, NRAS2, NRAS2T, NRAS3, NRAS3T, NROOTS, NSECBX, NSES, NSMX, &
          NSSH, NSSHT, NSTATE, NSYM, NTGEU, NTGEUES, NTGTU, NTGTUES, NTU, NTUES, NTUV, NTUVES, ORBIN, ORBNAM, OUTFMT, POTNUC, &
          PRORB, PRSD, PT2Method, REFENE, RFPERT, RHSDIRECT, RNORM, ROOT2STATE, SDECOM, SMATRIX, STSYM, THRCONV, THRENE, THROCC, &
          THRSHN, THRSHS, TIOEIG, TIOFG3, TIOFMB, TIOGIN, TIOGRD, TIOINT, TIOLCS, TIONAD, TIOOVL, TIOPCG, TIOPRP, TIOPT2, TIORHS, &
          TIOSBM, TIOSCA, TIOSER, TIOSGM, TIOSIN, TIOVEC, TITLE, ZETA

end module CASPT2_Module

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Ext_L2s(V1,V2,dima,dimab,dimc,adda,addb,nbs)
! this routine does:
! V2(a'b',m') <- V1(p,q,m') for aGrp=bGrp

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimab, dimc, adda, addb, nbs
real(kind=wp), intent(in) :: V1(nbs,nbs,dimc)
real(kind=wp), intent(out) :: V2(dimab,dimc)
integer(kind=iwp) :: a, ab

ab = 0
do a=1,dima
  V2(ab+1:ab+a,:) = V1(adda+a,addb+1:addb+a,:)
  ab = ab+a
end do

return

end subroutine Ext_L2s

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017,2020, Roland Lindh                                *
************************************************************************
      Subroutine Fix_FockOp(LuRd)
************************************************************************
*                                                                      *
*    Objective: To compute the fock operator for basis sets which do   *
*               not carry this information explicitly in the basis set *
*               file or are inline basis sets.                         *
*                                                                      *
*    The Fock operator is defined as F=\sum_{k,m} |k>e_{k,m}<m|.       *
*                                                                      *
* Called from: Input                                                   *
*                                                                      *
* Calling    : GetBS                                                   *
*                                                                      *
*     Author:  Roland Lindh (thanks to Ben Swerts)                     *
*                                                                      *
*     Modified for muons by R. Lindh January 2017                      *
************************************************************************
      use Her_RW
      use Real_Spherical
      use Basis_Info
      use Sizes_of_Seward, only: S
      use Logical_Info, only: UnNorm, Do_FckInt, FNMC
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
#include "real.fh"
#include "print.fh"
#include "status.fh"
#include "periodic_table.fh"
      External MltPrm, KnEPrm, NAPrm
      Real*8, Allocatable :: FockOp_t(:)
      Real*8, Allocatable :: Scr1(:), Scr2(:), Scr3(:)
      Real*8, Allocatable :: S12i(:,:), EVec(:,:), EVal(:)
      Real*8, Allocatable :: FPrim(:,:), Temp(:,:), C(:,:)
      Real*8, Allocatable :: Hm1(:,:), Ovr(:,:)
      Real*8, Allocatable :: S_AA(:), S_AR(:), E_R(:)
      Real*8, Allocatable :: Tmp1(:), Tmp2(:), Tmp3(:)
      Real*8, Allocatable :: KnE(:), NAE(:), Ovrlp(:)
      Real*8, Allocatable :: SAA(:), SAR(:)
      Character*13 DefNm
      Character*80 Ref(2), Bsl_, BSLbl
      Character *256 Basis_lib, Fname
      Character*180, Allocatable :: STDINP(:) ! CGGn
      Integer BasisTypes(4)
      Integer List_AE(0:iTabMx), List(0:iTabMx), List_Add(0:iTabMx)
      Logical Try_Again, lPP
      Real*8 A(4)
      Data DefNm/'basis_library'/
*                                                                      *
************************************************************************
*                                                                      *
      Interface
#include "getbs_interface.fh"
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*                                                                      *
************************************************************************
*                                                                      *
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      nPrint(114)=99
      nPrint(116)=99
#endif
*                                                                      *
************************************************************************
*                                                                      *
      lPP = .False.
      Do i = 1, nCnttp
         lPP = lPP .or. dbsc(i)%nPP.ne.0
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Generate a dummy center. This is fine since we will only do
*     1-center overlap integrals here.
*
      A(:)=Zero
      Call mma_allocate(STDINP,mxAtom*2,label='STDINP')
*
      nOrdOp=2
      iComp = 1
*
      nPrp=Max(4,S%nMltpl)
      nDiff = 0
*
      List   (:)=0
      List_AE(:)=0
      BasisTypes(:)=0
      lSTDINP=0
*
*     Loop over all valence shell with a non-funtional FockOp
*
      mCnttp = nCnttp   ! to be restored at the end
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Do iCnttp = 1, mCnttp
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
         iFerm=1
         If (dbsc(iCnttp)%fMass.ne.1.0D0) iFerm=2
*
         If (dbsc(iCnttp)%FOp.and.dbsc(iCnttp)%Charge.eq.0.0D0) Then
            Do iAng = 0, dbsc(iCnttp)%nVal-1
               iShll_a    = dbsc(iCnttp)%iVal + iAng
               Shells(iShll_a)%FockOp(:,:)=Zero
            End Do
         End If
*
         If(dbsc(iCnttp)%Aux .or.
     &      dbsc(iCnttp)%Frag .or.
     &      dbsc(iCnttp)%nFragType.gt.0 .or.
     &      dbsc(iCnttp)%FOp) Then
           Cycle
         End If
*
*        Special treatment for muonic basis sets
*
         If (iFerm.eq.2) Then
*
            iShll = S%Mx_Shll-1
            jShll = iShll
*
*           The Fock operator will simply be the one-particle
*           Hamiltonian (kinetic + nuclear-attraction operator)
*
            xFactor=1.0D0/dbsc(iCnttp)%fMass
            If (FNMC) Then
               iAtom=dbsc(iCnttp)%AtmNr
*              Get the atom mass in au (me=1)
               xMass=dbsc(iCnttp)%CntMass
*              Substract the electron mass to get the nuclear mass.
               xMass=xMass-DBLE(iAtom)
               xfactor=xfactor+One/xMass
            End If
*
            Do iAng = 0, dbsc(iCnttp)%nVal-1
*
               iShll_a    = dbsc(iCnttp)%iVal + iAng
               nPrim_a  = Shells(iShll_a)%nExp
               If (nPrim_a.eq.0) Cycle
               nCntrc_a = Shells(iShll_a)%nBasis_C
               iCmp_a = (iAng+1)*(iAng+2)/2
               If (Shells(iShll_a)%Prjct) iCmp_a = 2*iAng+1
               naa = nElem(iAng)*nElem(iAng)
               nScr1 = Max(nPrim_a,nPrim_a)*Max(nCntrc_a,nCntrc_a)*naa
               nScr2 = Max(nCntrc_a,nCntrc_a)**2*naa
               Call mma_allocate(Scr1,nScr1,Label='Scr1')
               Call mma_allocate(Scr2,nScr2,Label='Scr2')
*                                                                      *
************************************************************************
*                                                                      *
*              Compute the kinetic integrals
*
               nOrdOp=2
               nSAA=nCntrc_a**2 * naa
*
               Call KnEMmP(nHer,MmKnEP,iAng,iAng,nOrdOp)
               nScr3=nPrim_a**2 * MmKnEP
               Call mma_allocate(Scr3,nScr3,Label='Scr1')
*
               Call mma_Allocate(KnE,NSAA,Label='KnE')
               Call One_Int(KnEPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,
     &                      Scr1,nScr1,Scr2,nScr2,naa,KnE,nSAA,
     &                      iShll_a,nPrim_a,Shells(iShll_a)%Exp,
     &                     nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,
     &                      iShll_a,nPrim_a,Shells(iShll_a)%Exp,
     &                     nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a)
               Call mma_deallocate(Scr3)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
               Call DScal_(nCntrc_a**2*iCmp_a**2,
     &                     xFactor,KnE,1)
               Call RecPrt('Kinetric Energy Integrals',' ',
     &                     KnE,nCntrc_a**2,iCmp_a**2)
               Call DScal_(nCntrc_a**2*iCmp_a**2,
     &                     1.0D0/xFactor,KnE,1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*              Compute the nuclear-attraction integrals
*
               nOrdOp=0
               A(4) = DBLE(iCnttp) ! Dirty tweak
               nSBB=nCntrc_a**2 * naa
               Call mma_Allocate(NAE,nSBB,Label='NAE')
*
               Call NAMem(nHer,MemNA ,iAng,iAng,nOrdOp)
               nScr3=nPrim_a**2 * MemNA
               Call mma_allocate(Scr3,nScr3,Label='Scr3')
*
               Call One_Int(NAPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,
     &                      Scr1,nScr1,Scr2,nScr2,naa,NAE,nSBB,
     &                      iShll_a,nPrim_a,Shells(iShll_a)%Exp,
     &                     nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,
     &                      iShll_a,nPrim_a,Shells(iShll_a)%Exp,
     &                     nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a)
               Call mma_deallocate(Scr3)
#ifdef _DEBUGPRINT_
               Call RecPrt('Nuclear-attraction Integrals',' ',
     &                     NAE,nCntrc_a**2,iCmp_a**2)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*              Add together the kinetic and nuclear-attraction
*
               Call DaXpY_(nCntrc_a**2*iCmp_a**2,
     &                     xFactor,
     &                     KnE,1,
     &                     NAE,1)
               Call mma_deallocate(KnE)
*
*              Change to proper order (nCntrc_a * iCmp_a)
*
               Call mma_allocate(Hm1,nCntrc_a**2,iCmp_a**2,Label='Hm1')
               Call Reorder_GW(NAE,Hm1,nCntrc_a,nCntrc_a,iCmp_a,iCmp_a)
*                                                                      *
************************************************************************
*                                                                      *
*              Compute the overlap integrals
*
               nOrdOp=0
               nSCC=nCntrc_a**2 * naa
               Call mma_allocate(Ovrlp,nSCC,Label='Ovrlp')
*
               Call MltMmP(nHer,MmMltp,iAng,iAng,nOrdOp)
               nScr3=nPrim_a**2 * MmMltp
               Call mma_allocate(Scr3,nScr3,Label='Scr3')
*
               Call One_Int(MltPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,
     &                      Scr1,nScr1,Scr2,nScr2,naa,Ovrlp,nSCC,
     &                      iShll_a,nPrim_a,Shells(iShll_a)%Exp,
     &                     nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,
     &                      iShll_a,nPrim_a,Shells(iShll_a)%Exp,
     &                     nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a)
               Call mma_deallocate(Scr3)
#ifdef _DEBUGPRINT_
               Call RecPrt('Overlap Integrals',' ',
     &                     Ovrlp,nCntrc_a**2,iCmp_a**2)
#endif
*
*              Change to proper order (nCntrc_a * iCmp_a)
*
               nBF = nCntrc_a*iCmp_a
               Call mma_allocate(Ovr,nBF,nBF,Label='Ovr')
               Call Reorder_GW(Ovrlp,Ovr,
     &                      nCntrc_a,nCntrc_a,iCmp_a,iCmp_a)
               Call mma_deallocate(Ovrlp)
*                                                                      *
************************************************************************
*                                                                      *
*              Now we need to convert it to the Fock operator!
*
*              Solve F C = e S C
*
*              S^(-1/2) F S^(-1/2) S^(1/2) C = e S^(1/2) C
*              Set F' = S^(-1/2) F S^(-1/2)
*                  C' = S^(1/2) C
*
*              Solve F' C' = e C' , generate C = S^-(1/2) C'
*
               Call mma_Allocate(S12i,nBF,nBF,Label='S')
               S12i(:,:)=Zero
*
*              1) Compute the eigenvectors and eigenvalues of the
*                 overlap matrix
*
               Call mma_allocate(EVal,nBF*(nBF+1)/2,Label='EVal')
               Call mma_allocate(EVec,nBF,nBF,Label='EVec')
               EVec(:,:)=Zero
               Do iBF = 1, nBF
                  EVec(iBF,iBF)=One
                  Do jBF = 1, iBF
                     ijTri = (iBF-1)*iBF/2 + jBF
                     EVal(ijTri) = Ovr(iBF,jBF)
                  End Do
               End Do
               Call mma_deallocate(Ovr)
               Call NIDiag_new(EVal,EVec,nBF,nBF,0)
*
*              2) Construct S^(1/2) and S^(-1/2)
*
               Do kEval = 1, nBF
                  e   = EVal(kEval*(kEval+1)/2)
                  e12i= 1.0D0/Sqrt(e)
                  Do iBF = 1, nBF
                     C_ik = EVec(iBF,kEVal)
                     Do jBF = 1, nBF
                        C_jk = EVec(jBF,kEVal)
                        S12i(iBF,jBF) = S12i(iBF,jBF)
     &                                + C_ik * e12i * C_jk
                     End Do
                  End Do
               End Do
*
*              3) Form F' =  S^(-1/2) F S^(-1/2)
*
               Call mma_allocate(FPrim,nBF,nBF,Label='FPrim')
               FPrim(:,:)=Zero
               Call mma_allocate(Temp,nBF,nBF,Label='Temp')
               Call DGEMM_('N','N',
     &                     nBF,nBF,nBF,
     &                     1.0d0,S12i,nBF,
     &                           Hm1,nBF,
     &                     0.0d0,Temp,nBF)
               Call DGEMM_('N','N',
     &                     nBF,nBF,nBF,
     &                     1.0d0,Temp,nBF,
     &                           S12i,nBF,
     &                     0.0d0,FPrim,nBF)
*
*              4) Compute C' and the eigenvalues
*
               EVec(:,:)=Zero
               Do iBF = 1, nBF
                  EVec(iBF,iBF)=One
                  Do jBF = 1, iBF
                     ij    = (jBF-1)*nBF   + iBF
                     ijTri = (iBF-1)*iBF/2 + jBF
                     EVal(ijTri) = FPrim(iBF,jBF)
                  End Do
               End Do
               Call mma_deallocate(Temp)
               Call mma_deallocate(FPrim)
               Call NIDiag_new(EVal,EVec,nBF,nBF,0)
*
*              5) Form C = S^(-1/2) C'
*
               Call mma_allocate(C,nBF,nBF,Label='C')
               C(:,:)=Zero
               Call DGEMM_('N','N',
     &                     nBF,nBF,nBF,
     &                     1.0d0,S12i,nBF,
     &                           EVec,nBF,
     &                     0.0d0,C,nBF)
#ifdef _DEBUGPRINT_
      Call RecPrt('Cs for F',' ',C,nBF,nBF)
#endif
*
*              6) Form the matrix representation of the Fock operator
*
               Call mma_deallocate(Hm1)
               Call mma_allocate(Hm1,nBF,nBF,Label='Hm1')
               Hm1(:,:)=Zero
               Do kEval = 1, nBF
                  e   = EVal(kEval*(kEval+1)/2)
                  Do iBF = 1, nBF
                     C_ik = C(iBF,kEVal)
                     Do jBF = 1, nBF
                        C_jk = C(jBF,kEVal)
                        ij = (jBF-1)*nBF + iBF
                        Hm1(iBF,jBF) = Hm1(iBF,jBF)
     &                                      + C_ik * e * C_jk
                     End Do
                  End Do
               End Do
               Call mma_deallocate(C)
*
               Call Reorder_GW(Hm1,NAE,
     &                      nCntrc_a,iCmp_a,nCntrc_a,iCmp_a)
               Call mma_deallocate(Hm1)
*
*              Make result isotropic and distribute
*
               Do iB = 1, nCntrc_a
                  Do jB = 1, nCntrc_a
                     ijB=(jB-1)*nCntrc_a+iB
                     Tmp = Zero
                     Do iC = 1, iCmp_a
                        ijC=(iC-1)*iCmp_a+iC
                        iFrom = (ijC-1)*nCntrc_a**2+ijB
                        Tmp = Tmp + NAE(iFrom)
                     End Do
                     Shells(iShll_a)%FockOp(iB,jB) = Tmp/DBLE(iCmp_a)
                  End Do
               End Do
               Call mma_deallocate(NAE)
#ifdef _DEBUGPRINT_
               Call RecPrt('Actual Fock operator',' ',
     &                     Shells(iShll_a)%FockOp,nCntrc_a,nCntrc_a)
#endif
               Call mma_deallocate(EVal)
               Call mma_deallocate(EVec)
               Call mma_deallocate(S12i)
               Call mma_deallocate(Scr1)
               Call mma_deallocate(Scr2)
            End Do
*
            dbsc(iCnttp)%FOp=.TRUE.
            Cycle
         End If
*
*
*        create a new basis set index (temporary)
*
         nCnttp = mCnttp + 1
         If (nCnttp.gt.Mxdbsc) Then
            Call WarningMessage(2,'Fix_FockOp: Increase Mxdbsc')
            Call Abend()
         End If
*
*        create the temporary basis set label for this element to
*        read the corresponding ANO-RCC basis set.
*
         BSLbl=' '
         BSLbl=PTab(dbsc(iCnttp)%AtmNr)
*
         If (BSLbl(1:1).eq.' ') Then
            BSLbl=BSLbl(2:2)//'.ANO-RCC.....'
         Else
            BSLbl=BSLbl(1:2)//'.ANO-RCC.....'
         End If
*
         LenBSL = Len(BSLbl)
         Last = iCLast(BSLbl,LenBSL)
         Indx = Index(BSLbl,'/')
*
         Bsl_=' '
         If (Indx.eq.0) Then
            Call WhichMolcas(Basis_lib)
            If (Basis_lib(1:1).ne.' ') then
               ib = index(Basis_lib,' ')-1
               If(ib.lt.1) Call SysAbendMsg('Read_ANO_RCC',
     &                     'Too long PATH to MOLCAS',' ')
               Fname=Basis_lib(1:ib)//'/basis_library'
            Else
               Fname=DefNm
            Endif
            Indx = Last+1
            Bsl_ = BSLbl
         Else
            Fname = BSLbl(Indx+2:Last)
            If (Fname.eq.' ') Then
               Call WarningMessage(2,
     &                     ' No basis set library specified for'
     &                         //',BSLbl='//BSLbl
     &                         //',Fname='//Fname)
               Call Quit_OnUserError()
            End If
 1001       If (Fname(1:1).eq.' ') Then
               Fname(1:79)=Fname(2:80)
               Fname(80:80) = ' '
               Go To 1001
            End If
            Bsl_=BSLbl(1:Indx-1)
         End If
*
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*)
         Write(6,'(1X,A,I5,A,A)')
     &         'Basis Set ',nCnttp,' Label: ', BSLbl(1:Indx-1)
         Write(6,'(1X,A,A)') 'Basis set is read from library:',Fname
#endif
*
*        Let's get the reference basis set (ANO-RCC).
*
         iShll = S%Mx_Shll-1
         jShll = iShll
         Call GetBS(Fname,Bsl_,iShll,Ref,UnNorm,LuRd,
     &              BasisTypes,STDINP,lSTDINP,.False.,.true.,' ')
*
         If (.Not.dbsc(nCnttp)%FOp) Then
            Write (6,*) 'Fix_FockOp: reference basis doesn''t contain a'
     &                //' proper Fock operator'
            Cycle
         End If
         Shells(jShll+1)%Transf=.False.
         Shells(jShll+1)%Prjct =.False.
         Shells(jShll+2)%Transf=.False.
         Shells(jShll+2)%Prjct =.False.
         dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal
     &                        + dbsc(nCnttp)%nPrj
     &                        + dbsc(nCnttp)%nSRO
     &                        + dbsc(nCnttp)%nSOC
     &                        + dbsc(nCnttp)%nPP
*                                                                      *
************************************************************************
*                                                                      *
*        Start processing shells of iCnttp and mCnttp. Loop only over
*        the shells of iCnttp (mCnttp might be larger!)
*
         Try_Again=.True.
         Call ICopy(1+iTabMx,[0],0,List_Add,1)
 777     Continue
*
         Test_Charge=Zero
         Do iAng = 0, dbsc(iCnttp)%nVal-1
*
*           Pointers to the actuall shell
*
            iShll_a    = dbsc(iCnttp)%iVal + iAng
            nPrim_a  = Shells(iShll_a)%nExp
            If (nPrim_a.eq.0) Cycle
            nCntrc_a = Shells(iShll_a)%nBasis_C
            iCmp_a = (iAng+1)*(iAng+2)/2
            If (Shells(iShll_a)%Prjct) iCmp_a = 2*iAng+1
*
*           Pointers to the reference shell
*
            iShll_r = dbsc(nCnttp)%iVal + iAng
            nPrim_r  = Shells(iShll_r)%nExp
            If (nPrim_r.eq.0) Then
               Write (6,*) 'GuessOrb option turned off!'
               dbsc(iCnttp)%FOp=.FALSE.
               Exit
            End If
            nCntrc_r = Shells(iShll_r)%nBasis_C
            iCmp_r = (iAng+1)*(iAng+2)/2
            If (Shells(iShll_r)%Prjct) iCmp_r = 2*iAng+1
*
*                                                                      *
************************************************************************
*                                                                      *
            If (dbsc(iCnttp)%ECP) Then
#ifdef _DEBUGPRINT_
               If (lPP) Then
                  Write (6,*) 'Reference is ECP (Pseudo Potential)'
               Else
                  Write (6,*) 'Reference is ECP (Huzinaga type)'
               End If
               Call RecPrt('Reference Exponents',' ',
     &                    Shells(iShll_r)%Exp,1,nPrim_r)
               Call RecPrt('Reference Coefficients',' ',
     &                    Shells(iShll_r)%Cff_c(1,1,1),nPrim_r,nCntrc_r)
               Call RecPrt('Reference Fock operator',' ',
     &                    Shells(iShll_r)%FockOp,nCntrc_r,nCntrc_r)
#endif
               Call OrbType(dbsc(nCnttp)%AtmNr,List_AE,31)
               Call ECP_Shells(dbsc(iCnttp)%AtmNr,List)
               If (lPP.or.dbsc(iCnttp)%nM1.eq.0) Then
*
*                 Pseud potential case
*
                  nRemove = List_AE(iAng)-List(iAng)
*
               Else
*
*                 Huzinaga type, remove according to the number of
*                 projected shells.
*
                  iAngMax_Proj=dbsc(iCnttp)%nPrj
                  If (iAng.le.iAngMax_Proj) Then
                     iShll_Proj_r = dbsc(iCnttp)%iPrj + iAng
                     nCntrc_Proj = Shells(iShll_Proj_r)%nBasis
                     nRemove = nCntrc_Proj
                  Else
                     nRemove=0
                  End If
*
*                 If too many try the default
*
                  If (nRemove.gt.nCntrc_r) Then
                     nRemove = List_AE(iAng)-List(iAng)
                  End If
*
               End If ! lPP
#ifdef _DEBUGPRINT_
               Write(6,*) 'nRemove=',nRemove
               Write(6,*) 'List_Add(iAng)=',List_Add(iAng)
#endif
               nRemove = nRemove - List_Add(iAng)
#ifdef _DEBUGPRINT_
               Write(6,*) 'nRemove=',nRemove
#endif
               Test_Charge=Test_Charge + DBLE(2*(2*iAng+1)*nRemove)
*
*              Update pointers in case of ECP
*
*              Update the number of contracted functions of ref.
               nCntrc_t = nCntrc_r - nRemove
*              Pick up relevant parts of the FockOp matrix of ref.
               Call mma_allocate(FockOp_t,nCntrc_t**2)
               ipFockOp_t=1
               iOff_t = ipFockOp_t
               Do i = 1, nCntrc_t
                  call dcopy_(nCntrc_t,
     &                    Shells(iShll_r)%FockOp(nRemove+1,nRemove+i),1,
     &                    FockOp_t(iOff_t),1)
                  iOff_t = iOff_t + nCntrc_t
               End Do
               nCntrc_r = nCntrc_t
            Else
               nRemove = 0
            End If
*                                                                      *
************************************************************************
*                                                                      *
*
#ifdef _DEBUGPRINT_
            Call RecPrt('Actual Exponents',' ',
     &                 Shells(iShll_a)%Exp,1,nPrim_a)
            Call RecPrt('Actual Coefficients',' ',
     &                 Shells(iShll_a)%Cff_c(1,1,1),nPrim_a,nCntrc_a)
            Call RecPrt('Reference Exponents',' ',
     &                 Shells(iShll_r)%Exp,1,nPrim_r)
            Call RecPrt('Reference Coefficients',' ',
     &                 Shells(iShll_r)%Cff_c(1,nRemove+1,1),
     &                                              nPrim_r,nCntrc_r)
            If (Allocated(FockOp_t)) Then
               Call RecPrt('Reference Fock operator',' ',
     &                     FockOp_t,nCntrc_r,nCntrc_r)
            Else
               Call RecPrt('Reference Fock operator',' ',
     &                     Shells(iShll_r)%FockOp,nCntrc_r,nCntrc_r)
            End If
#endif
            If (Allocated(FockOp_t)) Then
               Check=DDot_(nCntrc_r**2,FockOp_t,1,
     &                                FockOp_t,1)
            Else
               Check=DDot_(nCntrc_r**2,Shells(iShll_r)%FockOp,1,
     &                                 Shells(iShll_r)%FockOp,1)
            End If
            If (Check.eq.Zero .or.  dbsc(iCnttp)%Charge.eq.Zero) Then
               If (Allocated(FockOp_t)) Call mma_deallocate(FockOp_t)
               Cycle
            End If
*                                                                      *
************************************************************************
*                                                                      *
            naa = nElem(iAng)*nElem(iAng)
            nScr1 = Max(nPrim_a,nPrim_r)*Max(nCntrc_a,nCntrc_r)*naa
            nScr2 = Max(nCntrc_a,nCntrc_r)**2*naa
            Call mma_allocate(Scr1,nScr1,Label='Scr1')
            Call mma_allocate(Scr2,nScr2,Label='Scr2')
*                                                                      *
************************************************************************
*                                                                      *
*           Compute S_AA
*
            nOrdOp=0
            nSAA= nCntrc_a**2 * naa
            Call mma_allocate(SAA,nSAA,Label='SAA')
*
            Call MltMmP(nHer,MmMltp,iAng,iAng,nOrdOp)
            nScr3=nPrim_a**2 * MmMltp
            Call mma_allocate(Scr3,nScr3,Label='Scr3')
*
            Call One_Int(MltPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,
     &                   Scr1,nScr1,Scr2,nScr2,naa,SAA,nSAA,
     &                   iShll_a,nPrim_a,Shells(iShll_a)%Exp,
     &                   nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,
     &                   iShll_a,nPrim_a,Shells(iShll_a)%Exp,
     &                   nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a)
            Call mma_deallocate(Scr3)
*                                                                      *
************************************************************************
*                                                                      *
*           Compute S_AR
*
            nOrdOp=0
            nSAR=nCntrc_a*nCntrc_r * naa
            Call mma_allocate(SAR,nSAR,Label='SAR')
*
            Call MltMmP(nHer,MmMltp,iAng,iAng,nOrdOp)
            nScr3=nPrim_a*nPrim_r * MmMltp
            Call mma_allocate(Scr3,nScr3,Label='Scr3')
*
            Call One_Int(MltPrm,Scr3,nScr3,A,iAng,iComp,nOrdOp,
     &                   Scr1,nScr1,SCr2,nScr2,naa,SAR,nSAR,
     &                   iShll_a,nPrim_a,Shells(iShll_a)%Exp,
     &                   nCntrc_a,Shells(iShll_a)%Cff_c(1,1,1),iCmp_a,
     &                   iShll_r,nPrim_r,Shells(iShll_r)%Exp,
     &                   nCntrc_r,Shells(iShll_r)%Cff_c(1,1+nRemove,1),
     &                                                         iCmp_a)
            Call mma_deallocate(Scr3)
*
            nSRR = nCntrc_r**2 * naa
*                                                                      *
************************************************************************
*                                                                      *
*           Reorder and compute the inverse of SAA
*
            Call mma_allocate(S_AA,nSAA,Label='S_AA')
            Call Reorder_GW(SAA,S_AA,
     &                   nCntrc_a,nCntrc_a,iCmp_a,iCmp_a)
#ifdef _DEBUGPRINT_
            Call RecPrt('Reordered SAA',' ',S_AA,
     &                  nCntrc_a*iCmp_a,nCntrc_a*iCmp_a)
#endif
            Call MInv(S_AA,SAA,iSing,D,nCntrc_a*iCmp_a)
            Call mma_deallocate(S_AA)
#ifdef _DEBUGPRINT_
            Write (6,*) 'iSing=',iSing
            Write (6,*) 'Det=',D
            Call RecPrt('Inverse of SAA',' ',SAA,
     &                  nCntrc_a*iCmp_a,nCntrc_a*iCmp_a)
#endif
*
*           Reorder SAR
            Call mma_allocate(S_AR,nSAR,Label='S_AR')
            Call Reorder_GW(SAR,S_AR,
     &                   nCntrc_a,nCntrc_r,iCmp_a,iCmp_r)
            Call mma_deallocate(SAR)
#ifdef _DEBUGPRINT_
            Call RecPrt('Reordered SAR',' ',S_AR,
     &                  nCntrc_a*iCmp_a,nCntrc_r*iCmp_r)
#endif
*
*           Expand and reorder the reference fock operator
*
            Call mma_allocate(E_R,nSRR,Label='E_R')
            Call mma_allocate(Tmp1,nSRR,Label='Tmp1')
            Tmp1(:)=Zero
            If (Allocated(FockOp_t)) Then
               Do iB = 1, nCntrc_r
                  Do jB = 1, nCntrc_r
                     ijB=(jB-1)*nCntrc_r+iB
                     iFrom = ipFockOp_t-1 + (jB-1)*nCntrc_r+iB
                     Tmp = FockOp_t(iFrom)
                     Do iC = 1, iCmp_r
                        ijC=(iC-1)*iCmp_r+iC
                        iTo = (ijC-1)*nCntrc_r**2+ijB
                        Tmp1(iTo) = Tmp
                     End Do
                  End Do
               End Do
            Else
               Do iB = 1, nCntrc_r
                  Do jB = 1, nCntrc_r
                     ijB=(jB-1)*nCntrc_r+iB
                     Tmp = Shells(iShll_r)%FockOp(iB,jB)
                     Do iC = 1, iCmp_r
                        ijC=(iC-1)*iCmp_r+iC
                        iTo = (ijC-1)*nCntrc_r**2+ijB
                        Tmp1(iTo) = Tmp
                     End Do
                  End Do
               End Do
            End If
#ifdef _DEBUGPRINT_
            Call RecPrt('Expanded ER',' ',Tmp1,
     &                  nCntrc_r*nCntrc_r,iCmp_r*iCmp_r)
#endif
            Call Reorder_GW(Tmp1,E_R,
     &                   nCntrc_r,nCntrc_r,iCmp_r,iCmp_r)
#ifdef _DEBUGPRINT_
            Call RecPrt('Reordered ER',' ',E_R,
     &                  nCntrc_r*iCmp_r,nCntrc_r*iCmp_r)
#endif
            Call mma_deallocate(Tmp1)
*
*           Form (SAA)-1 SAR
*
            Call mma_allocate(Tmp1,nSAR,Label='Tmp1')
            Call DGEMM_('N','N',
     &                  nCntrc_a*iCmp_a,nCntrc_r*iCmp_r,nCntrc_a*iCmp_a,
     &                  1.0d0,SAA,nCntrc_a*iCmp_a,
     &                        S_AR,nCntrc_a*iCmp_a,
     &                  0.0d0,Tmp1,nCntrc_a*iCmp_a)
#ifdef _DEBUGPRINT_
            Call RecPrt('(SAA)^-1 SAR',' ',Tmp1,
     &                  nCntrc_a*iCmp_a,nCntrc_r*iCmp_r)
#endif
            Call mma_deallocate(S_AR)
*
*           Form (SAA)-1 SAR ER
*
            Call mma_allocate(Tmp2,nSAR,Label='Tmp2')
            Call DGEMM_('N','N',
     &                  nCntrc_a*iCmp_a,nCntrc_r*iCmp_r,nCntrc_r*iCmp_r,
     &                  1.0d0,Tmp1,nCntrc_a*iCmp_a,
     &                        E_R,nCntrc_r*iCmp_r,
     &                  0.0d0,Tmp2,nCntrc_a*iCmp_a)
#ifdef _DEBUGPRINT_
            Call RecPrt('(SAA)^-1 SAR ER',' ',Tmp2,
     &                  nCntrc_a*iCmp_a,nCntrc_r*iCmp_r)
#endif
            Call mma_deallocate(E_R)
*
*           Form (SAA)-1 SAR ER (SAR)^T (SAA)-1
*
            Call DGEMM_('N','T',
     &                  nCntrc_a*iCmp_a,nCntrc_a*iCmp_a,nCntrc_r*iCmp_r,
     &                  1.0d0,Tmp2,nCntrc_a*iCmp_a,
     &                        Tmp1,nCntrc_a*iCmp_a,
     &                  0.0d0,SAA,nCntrc_a*iCmp_a)
#ifdef _DEBUGPRINT_
            Call RecPrt('EA',' ',SAA,
     &                  nCntrc_a*iCmp_a,nCntrc_a*iCmp_a)
#endif
            Call mma_deallocate(Tmp2)
            Call mma_deallocate(Tmp1)
*                                                                      *
************************************************************************
*                                                                      *
*           Now we just need to reorder and put it into place!
*
            Call mma_allocate(Tmp3,nSAA,Label='Tmp3')
            Call Reorder_GW(SAA,Tmp3,
     &                   nCntrc_a,iCmp_a,nCntrc_a,iCmp_a)
            Call mma_deallocate(SAA)
#ifdef _DEBUGPRINT_
            Call RecPrt('Reordered EA',' ',Tmp3,
     &                  nCntrc_a*nCntrc_a,iCmp_a*iCmp_a)
#endif
*
            Do iB = 1, nCntrc_a
               Do jB = 1, nCntrc_a
                  ijB = iB + (jB-1)*nCntrc_a
                  Tmp=Zero
                  Do iC = 1, iCmp_a
                     ijC = iC + (iC-1)*iCmp_a
                     iFrom = ijB + (ijC-1)*nCntrc_a**2
                     Tmp = Tmp + Tmp3(iFrom)
                  End Do
                  Shells(iShll_a)%FockOp(iB,jB) = Tmp/DBLE(iCmp_a)
               End Do
            End Do
            If (Allocated(FockOp_t)) Call mma_deallocate(FockOp_t)
#ifdef _DEBUGPRINT_
            Call RecPrt('Actual Fock operator',' ',
     &                  Shells(iShll_a)%FockOp,nCntrc_a,nCntrc_a)
#endif
            Call mma_deallocate(Tmp3)
            Call mma_deallocate(Scr1)
            Call mma_deallocate(Scr2)
*                                                                      *
************************************************************************
*                                                                      *
         End Do  ! iAng
*                                                                      *
************************************************************************
*                                                                      *
*        Deallocate the memory for the reference Fock operator
*
         Do iShll_r = jShll+1, iShll
            If (Allocated(Shells(iShll_r)%Exp))
     &          Call mma_deallocate(Shells(iShll_r)%Exp)
            Shells(iShll_r)%nExp=0
            If (Allocated(Shells(iShll_r)%FockOp))
     &          Call mma_deallocate(Shells(iShll_r)%FockOp)
            Shells(iShll_r)%nFockOp=0
            If (Allocated(Shells(iShll_r)%pCff))
     &          Call mma_deallocate(Shells(iShll_r)%pCff)
            If (Allocated(Shells(iShll_r)%Cff_c))
     &          Call mma_deallocate(Shells(iShll_r)%Cff_c)
            If (Allocated(Shells(iShll_r)%Cff_p))
     &          Call mma_deallocate(Shells(iShll_r)%Cff_p)
            Shells(iShll_r)%nExp=0
            Shells(iShll_r)%nBasis=0
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*
         Charge_Actual=DBLE(dbsc(iCnttp)%AtmNr)
         Charge_Effective=dbsc(iCnttp)%Charge
         qTest=Test_Charge -
     &         (Charge_Actual-Charge_Effective)
c         write(6,*)'qtest, Test_Charge = ',qtest, Test_Charge
c         write(6,*)'Charge_Actual,Charge_Effective = ',
c     &               Charge_Actual,Charge_Effective
         If (qTest.eq.Zero.or.dbsc(iCnttp)%Charge.eq.Zero) Then
            dbsc(iCnttp)%FOp=.TRUE.
         Else If (Try_Again) Then
            If (qTest.eq.2.0D0) Then
*              s
               List_Add(0)=1
            Else If (qTest.eq.6.0D0) Then
*              p
               List_Add(1)=1
            Else If (qTest.eq.10.0D0) Then
*              d
               List_Add(2)=1
            Else If (qTest.eq.8.0D0) Then
*              s,p
               List_Add(0)=1
               List_Add(1)=1
            Else If (qTest.eq.12.0D0) Then
*              s,d
               List_Add(0)=1
               List_Add(2)=1
            Else If (qTest.eq.16.0D0) Then
*              p,d
               List_Add(1)=1
               List_Add(2)=1
            Else If (qTest.eq.18.0D0) Then
*              s,p,d
               List_Add(0)=1
               List_Add(1)=1
               List_Add(2)=1
            Else If (qTest.eq.26.0D0) Then
*              2s,2p,d
               List_Add(0)=2
               List_Add(1)=2
               List_Add(2)=1
            End If
            Try_Again=.False.
            Go To 777
         Else
            Write (6,*) 'GuessOrb option turned off!'
            dbsc(iCnttp)%FOp=.FALSE.
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      End Do ! iCnttp
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Restore the correct nCnttp value
*
      nCnttp=mCnttp
*
#ifdef _INSANE_DEBUGPRINT_
      nPrint(113)=5
      nPrint(114)=5
      nPrint(116)=5
      nPrint(122)=5
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Check if we can activate the computation of FckInt!
*
      Do_FckInt=.True.
      Do iCnttp = 1, nCnttp
         If(dbsc(iCnttp)%Aux .or.
     &      dbsc(iCnttp)%Frag .or.
     &      dbsc(iCnttp)%nFragType.gt.0 .or.
     &      dbsc(iCnttp)%FOp) Cycle
*
         Do_FckInt = Do_FckInt .and. dbsc(iCnttp)%FOp ! To be activated!
*
      End Do
      Call mma_deallocate(STDINP)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Gunnar Karlstrom                                 *
*               2000, Roland Lindh                                     *
************************************************************************
      Subroutine lattcr(Grid,nGrid_,nGrid_Eff_,PolEff,DipEff,
     &                  cord,maxato,atorad,nPolComp,
     &                  XF,nXF,nOrd_XF,XEle,iXPolType)

************************************************************************
*                                                                      *
*     Object: to compute effective polarizabilities and dipole moments *
*             on the Langevin grid.                                    *
*                                                                      *
*     Authors: G. Karlstroem                                           *
*              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
*                                                                      *
*              and                                                     *
*                                                                      *
*              R. Lindh                                                *
*              Dept. of Chem. Phys., Univ. of Lund, Sweden.            *
*                                                                      *
*              March 2000                                              *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "rctfld.fh"
*
      Real*8 Grid(3,nGrid_), PolEff(nPolComp,nGrid_), DipEff(nGrid_)
      Real*8 cord(3,maxato), atorad(maxato),XF(*)
      Integer XEle(nXF)


      Real*8 tr(3,3),co(3)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2

*     Calculate number of entries per XFIELD point
      Inc = 3
      Do iOrdOp = 0, nOrd_XF
         Inc = Inc + nElem(iOrdOp)
      End Do
      If(iXPolType.gt.0) Inc = Inc + 6
*
*     Write (*,*) 'lattcr: polsi,dipsi=',polsi,dipsi

*
*     Rotation matrix for the grid
      tr(1,1)=cos(rotGamma)*cos(rotBeta)*cos(rotAlpha)-sin(rotGamma)
     &     *sin(rotAlpha)
      tr(1,2)=cos(rotGamma)*cos(rotBeta)*sin(rotAlpha)+sin(rotGamma)
     &     *cos(rotAlpha)
      tr(1,3)=-cos(rotGamma)*sin(rotBeta)
      tr(2,1)=-sin(rotGamma)*cos(rotBeta)*cos(rotAlpha)-cos(rotGamma)
     &     *sin(rotAlpha)
      tr(2,2)=-sin(rotGamma)*cos(rotBeta)*sin(rotAlpha)+cos(rotGamma)
     &     *cos(rotAlpha)
      tr(2,3)= sin(rotGamma)*sin(rotBeta)
      tr(3,1)=sin(rotBeta)*cos(rotAlpha)
      tr(3,2)=sin(rotBeta)*sin(rotAlpha)
      tr(3,3)=cos(rotBeta)

      Do ii=-(maxa+1),maxa,nSparse
       Do jj=-(maxb+1),maxb,nSparse
        Do kk=-(maxc+1),maxc,nSparse
         ni=min(nSparse,maxa-ii+1)
         nj=min(nSparse,maxb-jj+1)
         nk=min(nSparse,maxc-kk+1)
         If(LSparse.and.(ni.eq.nSparse).and.(nj.eq.nSparse).and.
     &        (nk.eq.nSparse)) Then
            xs=(DBLE(ii)+(DBLE(nSparse-1)*0.5D0))*scala
            ys=(DBLE(jj)+(DBLE(nSparse-1)*0.5D0))*scala
            zs=(DBLE(kk)+(DBLE(nSparse-1)*0.5D0))*scalc
            nGridOld=nGrid_Eff
            Do l=1,latato
               co(1)=xs+cordsi(1,l)
               co(2)=ys+cordsi(2,l)
               co(3)=zs+cordsi(3,l)
               xp=Zero
               yp=Zero
               zp=Zero
               Do m=1,3
                  xp=xp+co(m)*tr(1,m)
                  yp=yp+co(m)*tr(2,m)
                  zp=zp+co(m)*tr(3,m)
               EndDo
               rp2=xp*xp+yp*yp+zp*zp
               If (rp2.gt.radlat**2) go to 13
               If (lRFCav) Then
                  rp=sqrt(rp2)
                  drp=rds-rp
                  If (drp.le.Zero) go to 13
                  ener1=(diedel/drp)**2
               Else
                  ener1=Zero
               EndIf
               ener=Zero
*
*------- Check if the QC system annhilates the grid point
*
               Do m=1,maxato
                  xa=cord(1,m)
                  ya=cord(2,m)
                  za=cord(3,m)
                  rrr=(atorad(m)*rsca)**2
                  dggx=xa-xp
                  dggy=ya-yp
                  dggz=za-zp
                  rpa2=dggx**2+dggy**2+dggz**2
                  if(rpa2.lt.distSparse**2) Goto 13
                  ener=ener+(rrr/rpa2)**nexpo
               End Do
*
*------- Check if the XFIELD multipoles annhilates the grid point
*
               Do iXF=1,nXF
                  xa=XF((iXF-1)*Inc+1)
                  ya=XF((iXF-1)*Inc+2)
                  za=XF((iXF-1)*Inc+3)
                  If(XEle(iXF).le.0) Then
                     atrad=-DBLE(XEle(iXF))/1000.0D0
                  Else
                     atrad=CovRadT(XEle(iXF))
                  EndIf
                  rrr=(atrad*rsca)**2
                  dggx=xa-xp
                  dggy=ya-yp
                  dggz=za-zp
                  rpa2=dggx**2+dggy**2+dggz**2
                  if(rpa2.lt.distSparse**2) Goto 13
                  ener=ener+(rrr/rpa2)**nexpo
c     If(rpa2.lt.6.0D0)
c     &           write(*,*)'DIST',iGrid,iXF,sqrt(rpa2),atrad
               EndDo

               ener=prefac*ener*500.0D0+ener1
               If (ener.gt.12.D0) Then
                  GoTo 13
               EndIf
               fac=exp(-ener)
               nGrid_Eff_=nGrid_Eff_+1
               Grid(1,nGrid_Eff_)=xp
               Grid(2,nGrid_Eff_)=yp
               Grid(3,nGrid_Eff_)=zp
               PolEff(1,nGrid_Eff_)=polsi*DBLE(nSparse)**3.0D0*fac*fac
               DipEff(nGrid_Eff_)=dipsi*DBLE(nSparse)**1.5D0*fac
               write(6,*)'DGRID',xp,yp,zp,fac
            EndDo
*     Every sparse lattice point in this cell is ok, so skip dense grid

            Goto 14

 13         continue
*     Not every sparse lattice point is ok, so delete the sparse and do dense
            nGrid_Eff_=nGridOld
         EndIf
*     Start the normal, dense grid
         Do i=0,ni-1
            Do j=0,nj-1
               Do k=0,nk-1
                  xs=DBLE(ii+i)*scala
                  ys=DBLE(jj+j)*scala
                  zs=DBLE(kk+k)*scalc
                  Do l=1,latato
                     co(1)=xs+cordsi(1,l)
                     co(2)=ys+cordsi(2,l)
                     co(3)=zs+cordsi(3,l)
                     xp=Zero
                     yp=Zero
                     zp=Zero
                     Do m=1,3
                        xp=xp+co(m)*tr(1,m)
                        yp=yp+co(m)*tr(2,m)
                        zp=zp+co(m)*tr(3,m)
                     EndDo
                     rp2=xp*xp+yp*yp+zp*zp
                     If (rp2.gt.radlat**2) go to 11
                     If (lRFCav) Then
                        rp=sqrt(rp2)
                        drp=rds-rp
                        If (drp.le.Zero) go to 11
                        ener1=(diedel/drp)**2
                     Else
                        ener1=Zero
                     EndIf
                     ener=Zero
*
*------- Check if the QC system annhilates the grid point
*
                     Do m=1,maxato
                        xa=cord(1,m)
                        ya=cord(2,m)
                        za=cord(3,m)
                        rrr=(atorad(m)*rsca)**2
                        dggx=xa-xp
                        dggy=ya-yp
                        dggz=za-zp
                        rpa2=dggx**2+dggy**2+dggz**2
                        ener=ener+(rrr/rpa2)**nexpo
c     If(rpa2.lt.6.0D0)
c     &           write(*,*)'DIST0',iGrid,sqrt(rpa2),atorad(m)
                     End Do

*
*------- Check if the XFIELD multipoles annhilates the grid point
*
                     Do iXF=1,nXF
                        xa=XF((iXF-1)*Inc+1)
                        ya=XF((iXF-1)*Inc+2)
                        za=XF((iXF-1)*Inc+3)
                        If(XEle(iXF).le.0) Then
                           atrad=-DBLE(XEle(iXF))/1000.0D0
                        Else
                           atrad=CovRadT(XEle(iXF))
                        EndIf
                        rrr=(atrad*rsca)**2
                        dggx=xa-xp
                        dggy=ya-yp
                        dggz=za-zp
                        rpa2=dggx**2+dggy**2+dggz**2
                        ener=ener+(rrr/rpa2)**nexpo
c     If(rpa2.lt.6.0D0)
c     &           write(*,*)'DIST',iGrid,iXF,sqrt(rpa2),atrad
                     EndDo

c         ener=prefac*ener*tk5+ener1
                     ener=prefac*ener*500.0D0+ener1
c         ener=prefac*ener*1000.0D0+ener1
                     If (ener.gt.12.D0) Then
                        Write(6,*)'REMOVED',xp,yp,zp
                        Go To 11
                     EndIf
*
                     fac=exp(-ener)
*
                     nGrid_Eff_=nGrid_Eff_+1
                     Grid(1,nGrid_Eff_)=xp
                     Grid(2,nGrid_Eff_)=yp
                     Grid(3,nGrid_Eff_)=zp
                     PolEff(1,nGrid_Eff_)=polsi*fac*fac
                     DipEff(nGrid_Eff_)=dipsi*fac
                     write(6,*)'GRID',xp,yp,zp,fac
 11                  Continue
                  EndDo  ! l
               EndDo  ! k
            EndDo  ! j
         End Do  ! i
 14      Continue
        EndDo  ! kk
       EndDo  ! jj
      EndDo  ! ii
*
*     Write (*,*) 'Grid...',Grid(1,1),Grid(2,1),Grid(3,1)
*     Write (*,*) 'DipEff...',DipEff(1),DipEff(101)
*     Write (*,*) 'PolEff...',PolEff(1),PolEff(101)
*     Write (*,*) 'Lattcr: nGrid_Eff=',nGrid_Eff
*     Call GetMem('Lattcr','Check','Real',idum,idum)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function iGet(A,n)
      Use Iso_C_Binding
      Real*8, Target :: A(*)
      Integer, Pointer :: iA(:)
      Call C_F_Pointer(C_Loc(A),iA,[n])
      iGet=iA(n)
      Nullify(iA)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CheckAllIntegrals(QuitOnError,Silent,Mode,tau_,
     &                               MaxErr,MaxAbsErr,AverageErr,RMSErr,
     &                               MaxErr_OffDiagonal,
     &                               MaxAbsErr_OffDiagonal,
     &                               DiffNorm,DiffSum,ConvNorm,LDFNorm,
     &                               ConvSum,LDFSum)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: compare two-electron integrals computed from LDF
C              coefficients (robust or nonrobust representation) to
C              conventional integrals. "All" means that all integrals
C              involving pairs of atom pairs, (AB|CD), are compared.
C
C     QuitOnError=T: quit if accuracy or CS violations are detected.
C     Silent=T: no printing (except for Cauchy-Schwarz and accuracy
C               violations).
C     Silent=F: print info for each pair of APs (AB|CD) as well as
C               total statistics (which is also returned to caller).
C     Mode=1: robust LDF integrals (2- and 3-index integrals)
C     Mode=2: nonrobust LDF integrals (2-index integrals)
C     Mode=3: half-and-half (3-index integrals)
C
      Implicit None
      Logical QuitOnError
      Logical Silent
      Integer Mode
      Real*8  tau_
      Real*8  MaxErr, MaxAbsErr, AverageErr, RMSErr
      Real*8  MaxErr_OffDiagonal, MaxAbsErr_OffDiagonal
      Real*8  DiffNorm, DiffSum
      Real*8  ConvNorm, LDFNorm
      Real*8  ConvSum, LDFSum
#include "WrkSpc.fh"
#include "localdf.fh"
#include "ldf_atom_pair_info.fh"

      Character*21 SecNam
      Parameter (SecNam='LDF_CheckAllIntegrals')

      Real*8 Tol, Tol2
      Parameter (Tol=1.0d-12)

      Logical  LDF_IntegralPrescreeningInfoIsSet, isSymmetric
      External LDF_IntegralPrescreeningInfoIsSet, isSymmetric

      Integer  LDF_nBas_Atom, LDF_AtomPair_DiagDim
      External LDF_nBas_Atom, LDF_AtomPair_DiagDim

      Logical Verbose
      Logical IPI_set_here

      Integer AB, CD
      Integer ABmax, CDmax
      Integer nAB, nCD, nABCD
      Integer ip_Diff, l_Diff
      Integer ip_TOC, l_TOC
      Integer ip_TOCS, l_TOCS
      Integer ip_TOCSI, l_TOCSI
      Integer ip_DMax, l_DMax
      Integer ip_Map, l_Map
      Integer ip, l
      Integer k, ip0
      Integer nDiagErr
      Integer i2CF, nD2C, iRow, iCol
      Integer nRow, nCol

      Real*8  tau
      Real*8  TotDim, xABCD
      Real*8  ME, MAE, RMSE, DS
      Real*8  CNrm, LNrm
      Real*8  CSm, LSm
      Real*8  Tst, DABCD
      Real*8  nCS, nCSI
      Real*8  PairType(4)
      Real*8  MxD2C

      Integer i, j
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      Real*8  DMax
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      DMax(i)=Work(ip_DMax-1+i)

      Verbose=.not.Silent
      If (.not.LDF_IntegralPrescreeningInfoIsSet()) Then
         Call LDF_SetIntegralPrescreeningInfo()
         IPI_set_here=.True.
      Else
         IPI_set_here=.False.
      End If

      l_TOC=NumberOfAtomPairs
      Call GetMem('TOC','Allo','Inte',ip_TOC,l_TOC)
      Call iZero(iWork(ip_TOC),l_TOC)
      l_TOCS=l_TOC
      Call GetMem('TOCS','Allo','Inte',ip_TOCS,l_TOCS)
      Call iZero(iWork(ip_TOCS),l_TOCS)
      l_TOCSI=l_TOC
      Call GetMem('TOCSI','Allo','Inte',ip_TOCSI,l_TOCSI)
      Call iZero(iWork(ip_TOCSI),l_TOCSI)

      l_DMax=NumberOfAtomPairs
      Call GetMem('Dmax','Allo','Real',ip_DMax,l_DMax)
      ip0=ip_DMax-1
      Do AB=1,NumberOfAtomPairs
         l=LDF_AtomPair_DiagDim(AB)
         ip=iWork(ip_AP_Diag-1+AB)
         Work(ip0+AB)=Work(ip)
         Do k=1,l-1
            Work(ip0+AB)=max(Work(ip0+AB),Work(ip+k))
         End Do
      End Do

      tau=max(tau_,0.0d0)

      MaxErr=0.0d0
      MaxAbsErr=0.0d0
      AverageErr=0.0d0
      RMSErr=0.0d0
      MaxErr_OffDiagonal=0.0d0
      MaxAbsErr_OffDiagonal=0.0d0
      DiffNorm=0.0d0
      DiffSum=0.0d0
      ConvNorm=0.0d0
      LDFNorm=0.0d0
      ConvSum=0.0d0
      LDFSum=0.0d0
      nCS=0.0d0
      nCSI=0.0d0
      PairType(1)=0.0d0
      PairType(2)=0.0d0
      PairType(3)=0.0d0
      PairType(4)=0.0d0
      ABmax=0
      CDmax=0
      nDiagErr=0

      TotDim=0.0d0
      Do AB=1,NumberOfAtomPairs
         nAB=LDF_nBas_Atom(AP_Atoms(1,AB))
     &      *LDF_nBas_Atom(AP_Atoms(2,AB))
         Do CD=1,AB
            nCD=LDF_nBas_Atom(AP_Atoms(1,CD))
     &         *LDF_nBas_Atom(AP_Atoms(2,CD))
            nABCD=nAB*nCD
            If (nABCD.gt.0) Then
               xABCD=dble(nABCD)
               TotDim=TotDim+xABCD
               l_Diff=nABCD
               Call GetMem('Diff','Allo','Real',ip_Diff,l_Diff)
               Call LDF_DiffIntegrals(Mode,tau,AB,CD,
     &                                l_Diff,Work(ip_Diff),
     &                                CNrm,LNrm,CSm,LSm)
               If (AB.eq.CD) Then
                  If (.not.isSymmetric(Work(ip_Diff),nAB,Tol)) Then
                     Call WarningMessage(2,
     &                               SecNam//': DiffInt not symmetric!')
                     Write(6,'(A,2I10,A)')
     &               'AB,CD=',AB,CD,'  DiffInt:'
                     Call Cho_Output(Work(ip_Diff),1,nAB,1,nAB,nAB,nAB,
     &                               1,6)
                     Call LDF_Quit(1)
                  End If
               End If
               If (AP_2CFunctions(1,AB).gt.0) Then
                  nRow=AP_2CFunctions(1,AB)
                  If (AP_Atoms(1,AB).eq.AP_Atoms(2,AB)) Then
                     nCol=2
                  Else
                     nCol=1
                  End If
                  l_Map=nRow*nCol
                  Call GetMem('ChkIMap','Allo','Inte',ip_Map,l_Map)
                  Call LDF_Map2CF(AB,nRow,nCol,iWork(ip_Map))
                  Tol2=min(Thr_Accuracy*1.0d-2,Tol)
                  nD2C=0
                  Do i2CF=1,AP_2CFunctions(1,AB)
                     iRow=iWork(ip_Map-1+i2CF)-1
                     MxD2C=0.0d0
                     Do k=0,nCD-1
                        MxD2C=max(MxD2C,abs(Work(ip_Diff+nAB*k+iRow)))
                     End Do
                     If (MxD2C.gt.Tol2) Then
                        Write(6,'(A,2I10,A,I10,A,1P,D20.10)')
     &                  'AB,CD=',AB,CD,
     &                  'Integrals corresponding to AB 2C function',
     &                  i2CF,' are not exact. Max abs error=',
     &                  MxD2C
                        nD2C=nD2C+1
                     End If
                  End Do
                  If (AP_Atoms(1,AB).eq.AP_Atoms(2,AB)) Then
                     Do i2CF=1,AP_2CFunctions(1,AB)
                        iRow=iWork(ip_Map-1+nRow+i2CF)-1
                        MxD2C=0.0d0
                        Do k=0,nCD-1
                           MxD2C=max(MxD2C,
     &                               abs(Work(ip_Diff+nAB*k+iRow)))
                        End Do
                        If (MxD2C.gt.Tol2) Then
                           Write(6,'(A,2I10,A,I10,A,1P,D20.10)')
     &                     'AB,CD=',AB,CD,
     &                     'Integrals corresponding to AB 2C function',
     &                     i2CF,' are not exact. Max abs error=',
     &                     MxD2C
                           nD2C=nD2C+1
                        End If
                     End Do
                  End If
                  Call GetMem('ChkIMap','Free','Inte',ip_Map,l_Map)
                  If (nD2C.ne.0) Then
                     Call WarningMessage(2,SecNam//
     &                    ': Integrals corresponding to 2C functions'//
     &                    ' are not exact!')
                     Call LDF_Quit(1)
                  End If
               End If
               If (AB.ne.CD .and. AP_2CFunctions(1,CD).gt.0) Then
                  nRow=AP_2CFunctions(1,CD)
                  If (AP_Atoms(1,CD).eq.AP_Atoms(2,CD)) Then
                     nCol=2
                  Else
                     nCol=1
                  End If
                  l_Map=nRow*nCol
                  Call GetMem('ChkIMap','Allo','Inte',ip_Map,l_Map)
                  Call LDF_Map2CF(CD,nRow,nCol,iWork(ip_Map))
                  Tol2=min(Thr_Accuracy*1.0d-2,Tol)
                  nD2C=0
                  Do i2CF=1,AP_2CFunctions(1,CD)
                     iCol=iWork(ip_Map-1+i2CF)-1
                     MxD2C=0.0d0
                     Do k=0,nAB-1
                        MxD2C=max(MxD2C,abs(Work(ip_Diff+nAB*iCol+k)))
                     End Do
                     If (MxD2C.gt.Tol2) Then
                        Write(6,'(A,2I10,A,I10,A,1P,D20.10)')
     &                  'AB,CD=',AB,CD,
     &                  'Integrals corresponding to AB 2C function',
     &                  i2CF,' are not exact. Max abs error=',
     &                  MxD2C
                        nD2C=nD2C+1
                     End If
                  End Do
                  If (AP_Atoms(1,CD).eq.AP_Atoms(2,CD)) Then
                     Do i2CF=1,AP_2CFunctions(1,CD)
                        iCol=iWork(ip_Map-1+nRow+i2CF)-1
                        MxD2C=0.0d0
                        Do k=0,nAB-1
                           MxD2C=max(MxD2C,
     &                               abs(Work(ip_Diff+nAB*iCol+k)))
                        End Do
                        If (MxD2C.gt.Tol2) Then
                           Write(6,'(A,2I10,A,I10,A,1P,D20.10)')
     &                     'AB,CD=',AB,CD,
     &                     'Integrals corresponding to AB 2C function',
     &                     i2CF,' are not exact. Max abs error=',
     &                     MxD2C
                           nD2C=nD2C+1
                        End If
                     End Do
                  End If
                  Call GetMem('ChkIMap','Free','Inte',ip_Map,l_Map)
                  If (nD2C.ne.0) Then
                     Call WarningMessage(2,SecNam//
     &                    ': Integrals corresponding to 2C functions'//
     &                    ' are not exact!')
                     Call LDF_Quit(1)
                  End If
               End If
               ME=0.0d0
               MAE=0.0d0
               RMSE=0.0d0
               DS=0.0d0
               ip0=ip_Diff-1
               Do k=1,nABCD
                  ME=max(ME,Work(ip0+k))
                  MAE=max(MAE,abs(Work(ip0+k)))
                  RMSE=RMSE+Work(ip0+k)**2
                  DS=DS+Work(ip0+k)
               End Do
               If (AB.ne.CD) Then
                  MaxErr_OffDiagonal=max(MaxErr_OffDiagonal,ME)
                  MaxAbsErr_OffDiagonal=max(MaxAbsErr_OffDiagonal,ME)
               End If
               MaxErr=max(MaxErr,ME)
               If (MAE.gt.MaxAbsErr) Then
                  MaxAbsErr=MAE
                  ABmax=AB
                  CDmax=CD
               End If
               AverageErr=AverageErr+DS
               RMSErr=RMSErr+RMSE
               DiffNorm=DiffNorm+RMSE
               DiffSum=DiffSum+DS
               ConvNorm=ConvNorm+CNrm**2
               LDFNorm=LDFNorm+LNrm**2
               ConvSum=ConvSum+CSm
               LDFSum=LDFSum+LSm
               If (Verbose) Then
                  Write(6,'(A,2I10,1X,A,4I10,A)')
     &            'LDF integral error analysis for AB,CD=',AB,CD,
     &            '(A,B,C,D=',AP_Atoms(1,AB),AP_Atoms(2,AB),
     &             AP_Atoms(1,CD),AP_Atoms(2,CD),'):'
                  Write(6,'(3X,A,10X,I10)')
     &            'Dimension...........',nABCD
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'Conventional norm...',CNrm,
     &            'Conventional sum....',CSm
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'LDF norm............',LNrm,
     &            'LDF sum.............',LSm
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'Difference norm.....',sqrt(RMSE),
     &            'Difference sum......',DS
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'Max Error...........',ME,
     &            'Max Abs Error.......',MAE
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'Average Error.......',DS/xABCD,
     &            'RMS Error...........',sqrt(RMSE/xABCD)
                  Call xFlush(6)
               End If
               If (AB.eq.CD) Then
                  Tst=MAE-DMax(AB)
                  If (abs(Tst).gt.1.0d-8) Then
                     Write(6,'(A,2I10,1P,3(1X,A,D20.10))')
     &               'AB,CD=',AB,CD,'MAE=',MAE,'DMax=',DMax(AB),
     &               'Difference=',Tst
                     Call xFlush(6)
                     nDiagErr=nDiagErr+1
                  End If
                  DABCD=DMax(AB)
               Else
                  DABCD=sqrt(DMax(AB)*DMax(CD))
               End If
               Tst=MAE-DABCD
               If (Tst.gt.0.0d0) Then
                  If (DABCD.gt.1.0d-8) Then ! DABCD>1d-8
                     If ((Tst/DABCD).gt.1.0d-2) Then ! 1 pct allowed
                        Write(6,
     &                  '(3X,A,2I10,1P,3(1X,A,D20.10),A)')
     &                  'CS violation: AB,CD=',AB,CD,
     &                  'MAE=',MAE,'CS upper bound=',DABCD,
     &                  'Difference=',Tst,' [SIGNIFICANT]'
                        nCS=nCS+1.0d0
                        iWork(ip_TOCS-1+AB)=iWork(ip_TOCS-1+AB)+1
                        If (CD.ne.AB) Then
                           iWork(ip_TOCS-1+CD)=iWork(ip_TOCS-1+CD)+1
                        End If
                     Else
                        Write(6,
     &                  '(3X,A,2I10,1P,3(1X,A,D20.10),A)')
     &                  'CS violation: AB,CD=',AB,CD,
     &                  'MAE=',MAE,'CS upper bound=',DABCD,
     &                  'Difference=',Tst,' [INSIGNIFICANT]'
                        nCSI=nCSI+1.0d0
                        iWork(ip_TOCSI-1+AB)=iWork(ip_TOCSI-1+AB)+1
                        If (CD.ne.AB) Then
                           iWork(ip_TOCSI-1+CD)=iWork(ip_TOCSI-1+CD)+1
                        End If
                     End If
                  Else If (DABCD.gt.1.0d-12) Then ! 1d-8>=DABCD>1d-12
                     If ((Tst/DABCD).gt.5.0d-1) Then ! 50 pct allowed
                        Write(6,
     &                  '(3X,A,2I10,1P,3(1X,A,D20.10),A)')
     &                  'CS violation: AB,CD=',AB,CD,
     &                  'MAE=',MAE,'CS upper bound=',DABCD,
     &                  'Difference=',Tst,' [SIGNIFICANT]'
                        nCS=nCS+1.0d0
                        iWork(ip_TOCS-1+AB)=iWork(ip_TOCS-1+AB)+1
                        If (CD.ne.AB) Then
                           iWork(ip_TOCS-1+CD)=iWork(ip_TOCS-1+CD)+1
                        End If
                     Else
                        Write(6,
     &                  '(3X,A,2I10,1P,3(1X,A,D20.10),A)')
     &                  'CS violation: AB,CD=',AB,CD,
     &                  'MAE=',MAE,'CS upper bound=',DABCD,
     &                  'Difference=',Tst,' [INSIGNIFICANT]'
                        nCSI=nCSI+1.0d0
                        iWork(ip_TOCSI-1+AB)=iWork(ip_TOCSI-1+AB)+1
                        If (CD.ne.AB) Then
                           iWork(ip_TOCSI-1+CD)=iWork(ip_TOCSI-1+CD)+1
                        End If
                     End If
                  Else If (DABCD.gt.1.0d-15) Then ! 1d-12>=DABCD>1d-15
                     If (Tst.gt.1.0d-10) Then
                        Write(6,
     &                  '(3X,A,2I10,1P,3(1X,A,D20.10),A)')
     &                  'CS violation: AB,CD=',AB,CD,
     &                  'MAE=',MAE,'CS upper bound=',DABCD,
     &                  'Difference=',Tst,' [SIGNIFICANT]'
                        nCS=nCS+1.0d0
                        iWork(ip_TOCS-1+AB)=iWork(ip_TOCS-1+AB)+1
                        If (CD.ne.AB) Then
                           iWork(ip_TOCS-1+CD)=iWork(ip_TOCS-1+CD)+1
                        End If
                     Else
                        Write(6,
     &                  '(3X,A,2I10,1P,3(1X,A,D20.10),A)')
     &                  'CS violation: AB,CD=',AB,CD,
     &                  'MAE=',MAE,'CS upper bound=',DABCD,
     &                  'Difference=',Tst,' [INSIGNIFICANT]'
                        nCSI=nCSI+1.0d0
                        iWork(ip_TOCSI-1+AB)=iWork(ip_TOCSI-1+AB)+1
                        If (CD.ne.AB) Then
                           iWork(ip_TOCSI-1+CD)=iWork(ip_TOCSI-1+CD)+1
                        End If
                     End If
                  Else ! 1d-15>=DABCD
                     If (Tst.gt.1.0d-11) Then
                        Write(6,
     &                  '(3X,A,2I10,1P,3(1X,A,D20.10),A)')
     &                  'CS violation: AB,CD=',AB,CD,
     &                  'MAE=',MAE,'CS upper bound=',DABCD,
     &                  'Difference=',Tst,' [SIGNIFICANT]'
                        nCS=nCS+1.0d0
                        iWork(ip_TOCS-1+AB)=iWork(ip_TOCS-1+AB)+1
                        If (CD.ne.AB) Then
                           iWork(ip_TOCS-1+CD)=iWork(ip_TOCS-1+CD)+1
                        End If
                     Else
                        Write(6,
     &                  '(3X,A,2I10,1P,3(1X,A,D20.10),A)')
     &                  'CS violation: AB,CD=',AB,CD,
     &                  'MAE=',MAE,'CS upper bound=',DABCD,
     &                  'Difference=',Tst,' [INSIGNIFICANT]'
                        nCSI=nCSI+1.0d0
                        iWork(ip_TOCSI-1+AB)=iWork(ip_TOCSI-1+AB)+1
                        If (CD.ne.AB) Then
                           iWork(ip_TOCSI-1+CD)=iWork(ip_TOCSI-1+CD)+1
                        End If
                     End If
                  End If
                  Call xFlush(6)
               End If
               If (LDF2) Then
                  If (MAE.gt.Thr_Accuracy) Then
                     Write(6,'(3X,A,2I10,A,1P,D20.10,A,A,D20.10)')
     &               'AB,CD=',AB,CD,' Max Abs Error=',MAE,' > ',
     &               'target accuracy=',Thr_Accuracy
                     Call xFlush(6)
                     iWork(ip_TOC-1+AB)=iWork(ip_TOC-1+AB)+1
                     If (CD.ne.AB) Then
                        iWork(ip_TOC-1+CD)=iWork(ip_TOC-1+CD)+1
                     End If
                     If (AP_2CFunctions(1,AB).gt.0 .or.
     &                   AP_2CFunctions(1,CD).gt.0) Then
                        If (AP_1CLinDep(1,AB).gt.0 .or.
     &                      AP_1CLinDep(1,CD).gt.0) Then
                           PairType(4)=PairType(4)+1.0d0
                        Else
                           PairType(3)=PairType(3)+1.0d0
                        End If
                     Else
                        If (AP_1CLinDep(1,AB).gt.0 .or.
     &                      AP_1CLinDep(1,CD).gt.0) Then
                           PairType(2)=PairType(2)+1.0d0
                        Else
                           PairType(1)=PairType(1)+1.0d0
                        End If
                     End If
                  End If
               End If
               Call GetMem('Diff','Free','Real',ip_Diff,l_Diff)
            Else
               If (Verbose) Then
                  Write(6,'(A,2I10,1X,A,4I10,A)')
     &            'LDF integral error analysis for AB,CD=',AB,CD,
     &            '(A,B,C,D=',AP_Atoms(1,AB),AP_Atoms(2,AB),
     &             AP_Atoms(1,CD),AP_Atoms(2,CD),'):'
                  Write(6,'(3X,A,10X,I10)')
     &            'Dimension...........',nABCD
                  xABCD=0.0d0
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'Conventional norm...',xABCD,
     &            'Conventional sum....',xABCD
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'LDF norm............',xABCD,
     &            'LDF sum.............',xABCD
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'Difference norm.....',xABCD,
     &            'Difference sum......',xABCD
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'Max Error...........',xABCD,
     &            'Max Abs Error.......',xABCD
                  Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &            'Average Error.......',xABCD,
     &            'RMS Error...........',xABCD
                  Call xFlush(6)
               End If
            End If
         End Do
      End Do

      If (TotDim.gt.0.0d0) Then
         AverageErr=AverageErr/TotDim
         RMSErr=sqrt(RMSErr/TotDim)
      End If
      DiffNorm=sqrt(DiffNorm)
      ConvNorm=sqrt(ConvNorm)
      LDFNorm=sqrt(LDFNorm)

      If (Verbose) Then
         Call Cho_Head('LDF Integral Error Analysis','-',80,6)
         If (Mode.eq.1) Then
            Write(6,'(3X,A)') 'LDF integral representation: ROBUST'
         Else If (Mode.eq.2) Then
            Write(6,'(3X,A)') 'LDF integral representation: NONROBUST'
         Else If (Mode.eq.3) Then
            Write(6,'(3X,A)')
     &      'LDF integral representation: HALF-AND-HALF'
         Else
            Write(6,'(3X,A)') 'LDF integral representation: UNKNOWN'
         End If
         Write(6,'(3X,A,1P,D20.10)')
     &   'LDF integral prescreening threshold:',tau
         Write(6,'(3X,A,1P,D20.10)')
     &   'Dimension...........',TotDim
         Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &   'Conventional norm...',ConvNorm,
     &   'Conventional sum....',ConvSum
         Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &   'LDF norm............',LDFNorm,
     &   'LDF sum.............',LDFSum
         Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &   'Difference norm.....',DiffNorm,
     &   'Difference sum......',DiffSum
         Write(6,'(3X,A,1P,D20.10,3X,A,D20.10,A,2I10,A)')
     &   'Max Error...........',MaxErr,
     &   'Max Abs Error.......',MaxAbsErr,'  (AB,CD=',ABmax,CDmax,')'
         Write(6,'(3X,A,1P,D20.10,3X,A,D20.10,A,2I10,A)')
     &   'Max OffD Error......',MaxErr_OffDiagonal,
     &   'Max Abs OffD Error..',MaxAbsErr_OffDiagonal
         Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &   'Average Error.......',AverageErr,
     &   'RMS Error...........',RMSErr
         Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &   'CS Violations.......',nCS,
     &   'CS Near-Violations..',nCSI
         If (LDF2) Then
            Write(6,'(3X,A,1P,D20.10)')
     &      'Accuracy violations.',PairType(1)+PairType(2)
     &                            +PairType(3)+PairType(4)
            Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &      '1C only, no LinDep..',PairType(1),
     &      '1C only, LinDep.....',PairType(2)
            Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &      '1C+2C, no LinDep....',PairType(3),
     &      '1C+2C, LinDep.......',PairType(4)
         End If
         Call xFlush(6)
      Else
         If (nCS.gt.0.0d0 .or.
     &       (PairType(1)+PairType(2)+PairType(3)+PairType(4)).gt.0.0d0)
     &   Then
            Call Cho_Head('LDF Integral Error Analysis','-',80,6)
            If (Mode.eq.1) Then
               Write(6,'(3X,A)') 'LDF integral representation: ROBUST'
            Else If (Mode.eq.2) Then
               Write(6,'(3X,A)')
     &         'LDF integral representation: NONROBUST'
            Else If (Mode.eq.3) Then
               Write(6,'(3X,A)')
     &         'LDF integral representation: HALF-AND-HALF'
            Else
               Write(6,'(3X,A)') 'LDF integral representation: UNKNOWN'
            End If
            Write(6,'(3X,A,1P,D20.10)')
     &      'LDF integral prescreening threshold:',tau
            Write(6,'(3X,A,1P,D20.10)')
     &      'Dimension...........',TotDim
            Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &      'CS Violations.......',nCS,
     &      'CS Near-Violations..',nCSI
            If (LDF2) Then
               Write(6,'(3X,A,1P,D20.10)')
     &         'Accuracy violations.',PairType(1)+PairType(2)
     &                               +PairType(3)+PairType(4)
               Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &         '1C only, no LinDep..',PairType(1),
     &         '1C only, LinDep.....',PairType(2)
               Write(6,'(3X,A,1P,D20.10,3X,A,D20.10)')
     &         '1C+2C, no LinDep....',PairType(3),
     &         '1C+2C, LinDep.......',PairType(4)
            End If
         End If
      End If

      If (nCSI.gt.0.0d0) Then
         Do AB=1,NumberOfAtomPairs
            If (iWork(ip_TOCSI-1+AB).gt.0) Then
               Write(6,'(3X,A,I10,A,I10,A)')
     &         'Atom pair',AB,' is involved in',iWork(ip_TOCSI-1+AB),
     &         ' insignificant Cauchy-Schwarz violations'
            End If
         End Do
         Write(6,*)
         Call xFlush(6)
      End If

      If (nCS.gt.0.0d0) Then
         Do AB=1,NumberOfAtomPairs
            If (iWork(ip_TOCS-1+AB).gt.0) Then
               Write(6,'(3X,A,I10,A,I10,A)')
     &         'Atom pair',AB,' is involved in',iWork(ip_TOCS-1+AB),
     &         ' Cauchy-Schwarz violations'
            End If
         End Do
         Write(6,*)
         Call xFlush(6)
      End If

      If ((PairType(1)+PairType(2)+PairType(3)+PairType(4)).gt.0.0d0)
     & Then
         Do AB=1,NumberOfAtomPairs
            If (iWork(ip_TOC-1+AB).gt.0) Then
               Write(6,'(3X,A,I10,A,I10,A)')
     &         'Atom pair',AB,' is involved in',iWork(ip_TOC-1+AB),
     &         ' accuracy violations'
            End If
         End Do
         Write(6,*)
         Call xFlush(6)
      End If

      Call GetMem('Dmax','Free','Real',ip_DMax,l_DMax)
      Call GetMem('TOCSI','Free','Inte',ip_TOCSI,l_TOCSI)
      Call GetMem('TOCS','Free','Inte',ip_TOCS,l_TOCS)
      Call GetMem('TOC','Free','Inte',ip_TOC,l_TOC)
      If (IPI_set_here) Then
         Call LDF_UnsetIntegralPrescreeningInfo()
      End If

      If (QuitOnError) Then
         If ((PairType(1)+PairType(2)+PairType(3)+PairType(4)).gt.0.0d0)
     &   Then
            Call WarningMessage(2,
     &                  SecNam//': Accuracy violations detected!')
            Call LDF_Quit(1)
         End If
         If (nCS.gt.0.0d0) Then
            Call WarningMessage(2,
     &                  SecNam//': Cauchy-Schwarz violations detected!')
            Call LDF_Quit(1)
         End If
         If (ABmax.ne.CDmax) Then
            Call WarningMessage(2,SecNam//
     &         ': Max Abs Error should be on the diagonal - it is not!')
            Call LDF_Quit(1)
         End If
         If (nDiagErr.ne.0) Then
            Call WarningMessage(2,SecNam//': off-diagonal MAEs found!')
            Call LDF_Quit(1)
         End If
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_DiffIntegrals(Mode,tau,AB,CD,l_DiffInt,DiffInt,
     &                             ConvNorm,LDFNorm,ConvSum,LDFSum)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: compute difference between conventional integrals and
C              two-electron integrals computed from LDF coefficients
C              (robust or nonrobust representation).
C
      Implicit None
      Integer Mode
      Real*8  tau
      Integer AB, CD
      Integer l_DiffInt
      Real*8  DiffInt(l_DiffInt)
      Real*8  ConvNorm, LDFNorm
      Real*8  ConvSum, LDFSum
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*17 SecNam
      Parameter (SecNam='LDF_DiffIntegrals')

      Logical  LDF_IntegralPrescreeningInfoIsSet
      External LDF_IntegralPrescreeningInfoIsSet

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      real*8 ddot_
      external ddot_

      Logical IPI_set_here

      Integer nABCD
      Integer ip_LDFInt, l_LDFInt
      Integer k, ip0

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      nABCD=LDF_nBas_Atom(AP_Atoms(1,AB))
     &     *LDF_nBas_Atom(AP_Atoms(2,AB))
     &     *LDF_nBas_Atom(AP_Atoms(1,CD))
     &     *LDF_nBas_Atom(AP_Atoms(2,CD))
      If (nABCD.gt.0) Then
         If (nABCD.gt.l_DiffInt) Then
            Call WarningMessage(2,
     &                         SecNam//': insufficient array dimension')
            Call LDF_Quit(1)
         End If
         Call LDF_ComputeValenceIntegrals(AB,CD,l_DiffInt,DiffInt)
         ConvNorm=sqrt(dDot_(nABCD,DiffInt,1,DiffInt,1))
         ConvSum=DiffInt(1)
         Do k=2,nABCD
            ConvSum=ConvSum+DiffInt(k)
         End Do
         If (.not.LDF_IntegralPrescreeningInfoIsSet()) Then
            Call LDF_SetIntegralPrescreeningInfo()
            IPI_set_here=.True.
         Else
            IPI_set_here=.False.
         End If
         l_LDFInt=nABCD
         Call GetMem('LDFInt','Allo','Real',ip_LDFInt,l_LDFInt)
         Call LDF_ComputeValenceIntegralsFromC(Mode,tau,AB,CD,
     &                                         l_LDFInt,Work(ip_LDFInt))
         LDFNorm=sqrt(dDot_(nABCD,Work(ip_LDFInt),1,Work(ip_LDFInt),1))
         ip0=ip_LDFInt-1
         LDFSum=Work(ip0+1)
         Do k=2,nABCD
            LDFSum=LDFSum+Work(ip0+k)
         End Do
         Call dAXPY_(nABCD,-1.0d0,Work(ip_LDFInt),1,DiffInt,1)
         Call GetMem('LDFInt','Free','Real',ip_LDFInt,l_LDFInt)
         If (IPI_set_here) Then
            Call LDF_UnsetIntegralPrescreeningInfo()
         End If
      Else
         ConvNorm=0.0d0
         LDFNorm=0.0d0
         ConvSum=0.0d0
         LDFSum=0.0d0
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SetShP2RS_2(irc,iLoc,iShlAB,nAB)
C
C     Purpose: set mapping from shell pair iShlAB to reduced shell pair
C              Based on reduced set stored at location iLoc = 2 or 3.
C              If a non-zero code (irc) is returned, nothing has been
C              set!!
C
#include "implicit.fh"
      Integer nAB(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "choptr2.fh"
#include "chosew.fh"
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      Character*15 SecNam
      Parameter (SecNam = 'Cho_SetShP2RS_2')
#endif

      IndRed(i,j)=iWork(ip_IndRed-1+mmBstRT*(j-1)+i)
      nnBstRSh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      iiBstRSh(i,j,k)=iWork(ip_iiBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      nBstSh(i)=iWork(ip_nBstSh-1+i)
      iSP2F(i)=iWork(ip_iSP2F-1+i)
      mySP(i)=iWork(ip_mySP-1+i)
      iOff_Batch(i,j)=iWork(ip_iOff_Batch-1+nSym*(j-1)+i)
#if defined (_DEBUGPRINT_)
      IndRsh(i)=iWork(ip_IndRSh-1+i)
#endif

C     Check allocations.
C     ------------------

      Call Cho_InvPck(iSP2F(mySP(iShlAB)),iShlA,iShlB,.True.)
      If (iShlA .eq. iShlB) Then
         NumAB = nBstSh(iShlA)*(nBstSh(iShlA)+1)/2
      Else
         NumAB = nBstSh(iShlA)*nBstSh(iShlB)
      End If
      lTst = 2*NumAB
      If (l_iShP2RS.lt.1 .or. l_iShP2RS.lt.lTst) Then
         irc = 102
         Return
      End If

C     Check iLoc.
C     -----------

      If (iLoc.lt.2 .or. iLoc.gt.3) Then
         irc = 104
         Return
      End If

C     Set mapping array.
C     iShP2RS(1,AB) = index in current reduced set, symmetry reduced.
C     iShP2RS(2,AB) = symmetry block.
C     Zeros are returned if the element AB is not a member of the
C     current reduced set.
C     ---------------------------------------------------------------

      Call Cho_iZero(iWork(ip_iShP2RS),lTst)

      Do iSym = 1,nSym
         If (nAB(iSym) .gt. 0) Then
            iAB1 = iiBstRSh(iSym,iShlAB,iLoc) + 1
            iAB2 = iAB1 + nnBstRSh(iSym,iShlAB,iLoc) - 1
            Do iAB = iAB1,iAB2
               jAB = IndRed(iiBstR(iSym,iLoc)+iAB,iLoc) ! addr in 1st rs
               kAB = IndRed(jAB,1) ! addr in full shell pair
#if defined (_DEBUGPRINT_)
               nErr = 0
               If (IndRSh(jAB).ne.iSP2F(mySP(iShlAB))) Then
                  Write(Lupri,*) SecNam,': inconsistent shell pairs!'
                  Write(Lupri,*) SecNam,': from input: ',
     &                           iSP2F(mySP(iShlAB)),
     &                           '  from IndRsh: ',IndRSh(jAB)
                  nErr = nErr + 1
               End If
               If (kAB.lt.1 .or. kAB.gt.NumAB) Then
                  Write(Lupri,*) SecNam,': shell pair address error!'
                  Write(Lupri,*) SecNam,': kAB = ',kAB
                  Write(Lupri,*) SecNam,': min and max allowed: 1 ',
     &                           NumAB
                  nErr = nErr + 1
               End If
               If (nErr .ne. 0) Then
                  Write(Lupri,*) SecNam,': Shell A, B, AB: ',
     &                           iShlA,iShlB,iShlAB
                  Write(Lupri,*) SecNam,': iLoc: ',iLoc
                  Write(Lupri,*) SecNam,': symmetry block: ',iSym
                  Write(Lupri,*) SecNam,': red. set address, ',
     &                           'first and current: ',
     &                           jAB,iiBstR(iSym,iLoc)+iAB
                  Call Cho_Quit('Error detected in '//SecNam,104)
               End If
#endif
               iWork(ip_iShP2RS+2*(kAB-1))   = iOff_Batch(iSym,iShlAB)
     &                                       + iAB - iAB1 + 1
               iWork(ip_iShP2RS+2*(kAB-1)+1) = iSym
            End Do
         End If
      End Do

C     Set return code 0: all ok!
C     --------------------------

      irc = 0

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SubRoutine ChoMP2_cphf_lhs(EOcc,EVir,EFro,EDel,Xaibj,
     &                          LnPQRSprod,LiPQRSprod,iBatch,jBatch,
     &                          ip_Ap,ip_P,nVec,iVecOff,
     &                          nOccLeftI,nOccLeftJ,
     &                          nOrbLeftI, nOrbLeftJ)
*     This will calculate a trial lefthandside of the cphf equations.
*
*
      use ChoMP2, only: iFirstS, LnBatOrb, LnPQprod, LiPQprod
#include "implicit.fh"
      Real*8 EOcc(*), Evir(*), EFro(*), EDel(*), Xaibj(LnPQRSprod)
      Integer LiPQRSprod(8)
      Integer iVecOff(8)
      Integer nOccLeftI(8),nOccLeftJ(8)
      Integer nOrbLeftI(8),nOrbLeftJ(8)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"
*
      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      iAp(i,j,k)= ip_Ap + iVecOff(k) + j-1 + (nOcc(k)+nFro(k))*(i-1)
      iPvec(i,j,k)=ip_P + iVecOff(k) + j-1 + (nOcc(k)+nFro(k))*(i-1)
*
      Do iSymJ = 1, nSym
         iSymB = iSymJ
         iSymBJ = MulD2h(iSymJ,iSymB)
         iSymAI = iSymBJ
         LjOrb = Min(LnBatOrb(iSymJ,jBatch),nOccLeftJ(iSymJ))
         Do Lj = 1,LjOrb
            iJ = iFirstS(iSymJ,jBatch) + Lj - 1
            Do iB = 1, nVir(iSymB) + nDel(iSymB)
               Lbj = LiPQprod(iSymB,iSymJ,jBatch)
     &             + (nFro(iSymB) + nOcc(iSymB)
     &             +  nVir(iSymB) + nDel(iSymB))
     &             * (Lj-1)
     &             + iB + nFro(iSymB) +  nOcc(iSymB)
               Do iSymI = 1, nSym
                  iSymA = iSymI
                  iSymAJ = MulD2h(iSymA,iSymJ)
                  iSymBI = iSymAJ
                  LiOrb = min(LnBatOrb(iSymI,iBatch),
     &                        nOccLeftI(iSymI))
                  Do Li = 1, LiOrb
                     iI  = iFirstS(iSymI,iBatch) + Li - 1
                     Lbi = LiPQprod(iSymB,iSymI,iBatch)
     &                   + (nFro(iSymB) + nOcc(iSymB)
     &                   +  nVir(iSymB) + nDel(iSymB))
     &                   * (Li-1)
     &                   + iB + nFro(iSymB) + nOcc(iSymB)
                     Do iA = 1, nVir(iSymA) + nDel(iSymA)
                        Lai = LiPQprod(iSymA,iSymI,iBatch)
     &                      + (nFro(iSymA) + nOcc(iSymA)
     &                      +  nVir(iSymA) + nDel(iSymA))
     &                      * (Li - 1)
     &                      + iA + nFro(iSymA) + nOcc(iSymA)
                        Laj = LiPQprod(iSymA,iSymJ,jBatch)
     &                      + (nFro(iSymA) + nOcc(iSymA)
     &                      +  nVir(iSymA) + nDel(iSymA))
     &                      * (Lj - 1)
     &                      + iA + nFro(iSymA) + nOcc(iSymA)
*
                        If(iBatch.eq.jBatch) Then
                           ip_aibj = LiPQRSprod(iSymAI)
     &                             + iTri(Lai,Lbj)
                           ip_biaj = LiPQRSprod(iSymBI)
     &                             + iTri(Lbi,Laj)
                        Else
                           ip_aibj = LiPQRSprod(iSymAI)
     &                             + LnPQprod(iSymAI,iBatch)
     &                             * (Lbj-1) + Lai
                           ip_biaj = LiPQRSprod(iSymBI)
     &                             + LnPQprod(iSymBI,iBatch)
     &                             * (Laj-1) + Lbi
                        End If
                        Diag1 = 4.0d0 * Xaibj(ip_aibj)
     &                        -         Xaibj(ip_biaj)
*
                        If((iI.eq.iJ).and.(iB.eq.iA) .and.
     &                     (iSymI.eq.iSymJ))         Then
                           If(iA .le. nVir(iSymA)) Then
                              E_Vir = EVir(iVir(iSymA) + iA)
                           Else
                              E_Vir = EDel(iDel(iSymA) + iA-nVir(iSymA))
                           End If
                           If(iI .gt. nFro(iSymI)) Then
                              E_Occ = EOcc(iOcc(iSymI) + iI-nFro(iSymI))
                           Else
                              E_Occ = EFro(iFro(iSymI) + iI)
                           End If
                           Ediff = E_Vir - E_Occ
                           Diag1 = Diag1 + Ediff
                        End If
*
                        Work(iAp(iB,iJ,iSymJ)) =
     &                       Work(iAp(iB,iJ,iSymJ)) +
     &                       Diag1*Work(iPvec(iA,iI,iSymI))
*-------------- Debug comments ---------------------------------------------
*                        Write(6,*) 'Symm A B', iSymA, iSymB
*                        Write(6,*) 'IAJB', iI,iA,iJ,iB
*                        Write(6,*) 'aibj', Xaibj(ip_aibj)
*                        Write(6,*) 'biaj', Xaibj(ip_biaj)
*                        Write(6,*) 'Ediff', Ediff
*                        Write(6,*) 'contr exch + Energy',
*     &                              Diag1*Work(iPvec(iA,iI,iSymI))
*                        Write(6,*) 'P',Work(iPVec(iA,iI,iSymI))
*                        Write(6,*) 'adress AP',
*     &                              iAp(iB,iJ,iSymJ)-ip_AP
*-----------------------------------------------------------------------------
                     End Do
                  End Do
               End Do
            End Do
*****************************************************************************
****     Coulomb part
*****************************************************************************
            Do iSymI = 1, nSym
               iSymA = iSymI
               iSymAJ = MulD2h(iSymA,iSymJ)
               iSymIJ = MulD2h(iSymI,iSymJ)
               Do iI = 1, nOcc(iSymI) + nFro(iSymI)
                  Lij = LiPQprod(iSymI,iSymJ,jBatch)
     &                + (nFro(iSymI) + nOcc(iSymI)
     &                +  nVir(iSymI) + nDel(iSymI))
     &                * (Lj-1) + iI
                  LbOrb = Min(LnBatOrb(iSymB,iBatch)
     &                     -  nOccLeftI(iSymB),
     &                        nOrbLeftI(iSymB)-nOccLeftI(iSymB))
                  Do Lb = 1, LbOrb
                     If(nOccLeftI(iSymB).gt.0) Then
                        iB = Lb
                     Else
                        iB = iFirstS(iSymB,iBatch)
     &                     - nOcc(iSymB) - nFro(iSymB) + Lb-1
                     End If
                     Do iA = 1, nVir(iSymA) + nDel(iSymA)
                        Lab = LiPQprod(iSymA,iSymB,iBatch)
     &                      + (nFro(iSymA) + nOcc(iSymA)
     &                      +  nVir(iSymA) + nDel(iSymA))
     &                      * (Lb + nOccLeftI(iSymB) - 1)
     &                      + iA + nFro(iSymA) + nOcc(iSymA)
*
                        If(iBatch.eq.jBatch) Then
                           ip_jiba = LiPQRSprod(iSymIJ)
     &                             + iTri(Lij,Lab)
                        Else
                           ip_jiba = LiPQRSprod(iSymIJ)
     &                             + LnPQprod(iSymIJ,iBatch)
     &                             * (Lij - 1) + Lab
                        End If
*
                        Diag2 = Xaibj(ip_jiba)
                        Work(iAp(iB,iJ,iSymJ)) =
     &                       Work(iAp(iB,iJ,iSymJ)) -
     &                       Diag2*Work(iPvec(iA,iI,iSymI))
*------------ Debug comments -------------------------------------------
*                        Write(6,*) 'Symm A B', iSymA, iSymB
*                        Write(6,*) 'IAJB', iI,iA,iJ,iB
*                        Write(6,*) 'jiba', Diag2
*                        Write(6,*) 'adress AP',
*     &                              iAp(iB,iJ,iSymJ)-ip_AP
*                        Write(6,*) 'Contr coul',
*     &                              Diag2*Work(iPvec(iA,iI,iSymI))
*------------------------------------------------------------------------
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nVec)
         Call Unused_integer_array(nOrbLeftJ)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION gammln(xx)
      REAL*8 gammln,xx
      INTEGER j
      REAL*8 ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*log(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+log(stp*ser/x)
      return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!               2021, Roland Lindh                                     *
!***********************************************************************

subroutine swap_full2rs(irc,iLoc,nRS,nDen,JSYM,XLT,Xab,add)

use ChoArr, only: iRS2F
use ChoSwp, only: IndRed
use Index_Functions, only: iTri
use Data_Structures, only: DSBA_Type
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iLoc, nRS, nDen, JSYM
type(DSBA_Type), intent(in) :: XLT(nDen)
real(kind=wp), intent(out) :: Xab(nRS,nDen)
logical(kind=iwp), intent(in) :: add
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: iab, iag, ias, ibg, ibs, iRab, iSyma, jDen, jRab, kRab
integer(kind=iwp), external :: cho_isao

#include "macros.fh"
unused_var(add)

!                                                                      *
!***********************************************************************
!                                                                      *
if (JSYM == 1) then ! TOTAL SYMMETRIC

  do jRab=1,nnBstR(jSym,iLoc)

    kRab = iiBstr(jSym,iLoc)+jRab
    iRab = IndRed(kRab,iLoc)

    iag = iRS2F(1,iRab) ! global address
    ibg = iRS2F(2,iRab)

    iSyma = cho_isao(iag) ! symmetry block; Sym(b)=Sym(a)

    ias = iag-ibas(iSyma) ! address within that symm block
    ibs = ibg-ibas(iSyma)
    iab = iTri(ias,ibs)

    do jDen=1,nDen

      Xab(jRab,jDen) = XLT(jDen)%SB(iSyma)%A1(iab)

    end do

  end do ! jRab loop

else

  write(u6,*) 'Wrong input parameters. JSYM = ',JSYM
  irc = 66
  call abend()

end if

irc = 0

return

end subroutine swap_full2rs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine PckInt(abab,mZeta,nab,ab,rKappa,Mode,Zeta,nZeta,
     &                  qKappa)
************************************************************************
*                                                                      *
* Object: to keep the diagonal angular indices of a integral batch.    *
*         The integrals are also stripped of the prefactor due to      *
*         the product of gaussians. In case of numerical different-    *
*         iation the prefactor will be due to the undifferentiated     *
*         charge densities.                                            *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             April '92                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 abab(mZeta,nab,nab), ab(nZeta,nab), rKappa(mZeta),
     &       Zeta(mZeta), qKappa(mZeta)
      Logical Mode
*
      iRout=399
      iPrint=nPrint(399)
*
      If (Mode) Then
*--------Integrals
         Do iab = 1, nab
            Do iZeta = 1, mZeta
               ab(iZeta,iab) =
     &             Sqrt(Sqrt(Two*Zeta(iZeta))*Abs(abab(iZeta,iab,iab)))
     &                       / rKappa(iZeta)
            End Do
         End Do
      Else
*--------Integrals for numerical estimation of the gradient.
         Do iab = 1, nab
            Do iZeta = 1, mZeta
               ab(iZeta,iab) = Sqrt(Two*Zeta(iZeta))*
     &                       abab(iZeta,iab,iab)
     &                       / (rKappa(iZeta)*qKappa(iZeta))
            End Do
         End Do
      End If
      If (iPrint.ge.99) Then
         Write (6,*) 'nZeta,mZeta=',nZeta,mZeta
         Call RecPrt(' abab','(5G20.10)',abab,mZeta,nab**2)
         Call RecPrt(' rKappa','(5G20.10)',rKappa,mZeta,1)
         Call RecPrt(' Zeta  ','(5G20.10)',Zeta  ,mZeta,1)
         Do iab = 1, nab
            Call RecPrt(' ab ','(5G20.10)',ab(1,iab),mZeta,1)
         End Do
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_INTCHK_ID_OF(LABEL,ID,IOPT)
!
! Purpose: for minimal integral checking,
!          IOPT=-1 : return label corresponding to id ID.
!          else    : return index of shell quadruple corresponding
!                    to check label LABEL.

use Definitions, only: iwp

implicit none
character(len=8), intent(inout) :: LABEL
integer(kind=iwp), intent(inout) :: ID
integer(kind=iwp), intent(in) :: IOPT
integer(kind=iwp), parameter :: NTABLE = 12
character(len=*), parameter :: TABLE(NTABLE) = ['EXCL RS1','MAX|XRS1','MIN|XRS1','NEG DIAG','MAX|NEG ','MIN|NEG ','NEG->ZER', &
                                                'MAX|NEGZ','MIN|NEGZ','MAX DIAG','MIN DIAG','MAX|MIN ']
integer(kind=iwp), external :: CHO_TABIND

if (IOPT == -1) then
  if ((ID < 1) .or. (ID > NTABLE)) then
    LABEL = 'UNKNOWN '
  else
    LABEL = TABLE(ID)
  end if
else
  ID = CHO_TABIND(TABLE,8,NTABLE,' ',0,0,LABEL)
end if

end subroutine CHO_INTCHK_ID_OF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine ChoLSOSMP2_Energy_Fll(N,w,t,EOcc,EVir,Delete,EMP2,irc)
C
C     Thomas Bondo Pedersen, December 2012.
C
C     Compute Laplace-SOS-MP2 energy correction from full Cholesky
C     vectors (i.e., not batched).
C
      Implicit None
      Integer N
      Real*8  w(N)
      Real*8  t(N)
      Real*8  EOcc(*)
      Real*8  EVir(*)
      Logical Delete
      Real*8  EMP2
      Integer irc
#include "WrkSpc.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "cholesky.fh"

      Character*21 SecNam
      Parameter (SecNam='ChoLSOSMP2_Energy_Fll')

      Integer nEnrVec(8)

      Integer l_X
      Integer l_V
      Integer iSym
      Integer Nai
      Integer need
      Integer ip, l

      ! check if there is enough memory to read through vector files
      ! only once
      If (DecoMP2) Then
         Call iCopy(nSym,nMP2Vec,1,nEnrVec,1)
      Else
         Call iCopy(nSym,NumCho,1,nEnrVec,1)
      End If
      l_X=0
      l_V=0
      Do iSym=1,nSym
         Nai=nT1am(iSym)
         If (Nai.gt.0 .and. nEnrVec(iSym).gt.0) Then
            l_X=max(l_X,min(Laplace_BlockSize,nEnrVec(iSym)))
            l_V=max(l_V,Nai*nEnrVec(iSym))
         End If
      End Do
      need=l_X+2*l_V
      Call GetMem('LSMTst','Max ','Real',ip,l)
      l=l-100
      If (l.lt.1 .or. need.ge.l) Then ! not enough memory for one read
         Call ChoLSOSMP2_Energy_Fll2(N,w,t,EOcc,EVir,Delete,EMP2,irc)
         If (irc.ne.0) Then
            Write(6,'(A,A,I10)')
     &      SecNam,': Cho_LSOSMP2_Energy_Fll2 returned',irc
         End If
      Else ! enough memory for one read through vector files
         Call ChoLSOSMP2_Energy_Fll1(N,w,t,EOcc,EVir,Delete,EMP2,irc)
         If (irc.ne.0) Then
            Write(6,'(A,A,I10)')
     &      SecNam,': Cho_LSOSMP2_Energy_Fll1 returned',irc
         End If
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine ChoLSOSMP2_Energy_Fll1(N,w,t,EOcc,EVir,Delete,EMP2,irc)
C
C     Thomas Bondo Pedersen, December 2012.
C
C     Compute Laplace-SOS-MP2 energy correction from full Cholesky
C     vectors (i.e., not batched), reading the vectors only once
C     at the expense of memory.
C
      Implicit None
      Integer N
      Real*8  w(N)
      Real*8  t(N)
      Real*8  EOcc(*)
      Real*8  EVir(*)
      Logical Delete
      Real*8  EMP2
      Integer irc
#include "WrkSpc.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "cholesky.fh"

      Character*22 SecNam
      Parameter (SecNam='ChoLSOSMP2_Energy_Fll1')

      Real*8   dDot_
      external ddot_

      Integer nEnrVec(8)

      Integer iClos
      Integer iTyp
      Integer iSym
      Integer ip_X, l_X
      Integer ip_V, l_V, ip_SV
      Integer Nai
      Integer nBlock
      Integer iOpt, iAddr, l_Tot
      Integer q
      Integer iBlock, jBlock
      Integer iSymi, iSyma
      Integer i, a
      Integer ipi, ipj
      Integer nVeci, nVecj
      Integer iVec
      Integer ip0, ip1

      Real*8  tq, Eq

      Integer j, k
      Real*8  epsi, epsa
      Integer MulD2h
      epsi(j,k)=EOcc(iOcc(k)+j)
      epsa(j,k)=EVir(iVir(k)+j)
      MulD2h(j,k)=iEOr(j-1,k-1)+1

      ! init return code
      irc=0

      ! init energy
      EMP2=0.0d0

      ! check input (incl. common block variables)
      If (nBatch.ne.1) Then
         irc=-1
         Return
      End If
      If (N.ne.Laplace_nGridPoints) Then
         irc=-2
         Return
      End If
      If (Laplace_BlockSize.lt.1) Then
         irc=-3
         Return
      End If

      ! determine if files are to be deleted after use
      If (Delete) Then
         iClos=3
      Else
         iClos=2
      End If

      ! set number and type of vectors
      If (DecoMP2) Then
         iTyp=2
         Call iCopy(nSym,nMP2Vec,1,nEnrVec,1)
      Else
         iTyp=1
         Call iCopy(nSym,NumCho,1,nEnrVec,1)
      End If

      ! compute energy correction
      Do iSym=1,nSym
         Nai=nT1am(iSym)
         If (Nai.gt.0 .and. nEnrVec(iSym).gt.0) Then
            ! set vector block size and allocate X matrix
            l_X=min(Laplace_BlockSize,nEnrVec(iSym))
            l_X=l_X**2
            Call GetMem('LSMX','Allo','Real',ip_X,l_X)
            ! compute number of vector blocks
            nBlock=(nEnrVec(iSym)-1)/Laplace_BlockSize+1
            ! open vector file
            Call ChoMP2_OpenF(1,iTyp,iSym)
            ! allocate memory for vectors
            l_Tot=Nai*nEnrVec(iSym)
            l_V=2*l_Tot
            Call GetMem('LSMV','Allo','Real',ip_V,l_V)
            ip_SV=ip_V+l_Tot
            ! Read all vectors
            iOpt=2
            iAddr=1
            Call dDAFile(lUnit_F(iSym,iTyp),iOpt,Work(ip_V),l_Tot,iAddr)
            ! loop over Laplace grid
            Do q=1,N
               ! init energy for this q
               Eq=0.0d0
               ! scale grid point by 1/2
               tq=0.5d0*t(q)
               ! scale vectors
               Call dCopy_(l_Tot,Work(ip_V),1,Work(ip_SV),1)
               Do iVec=1,nEnrVec(iSym)
                  ip0=ip_SV-1+Nai*(iVec-1)
                  Do iSymi=1,nSym
                     iSyma=MulD2h(iSym,iSymi)
                     ip1=ip0+iT1am(iSyma,iSymi)
                     Do i=1,nOcc(iSymi)
                        Call dScal_(nVir(iSyma),exp(epsi(i,iSymi)*tq),
     &                             Work(ip1+nVir(iSyma)*(i-1)+1),1)
                     End Do
                     Do a=1,nVir(iSyma)
                        Call dScal_(nOcc(iSymi),exp(-epsa(a,iSyma)*tq),
     &                             Work(ip1+a),nVir(iSyma))
                     End Do
                  End Do
               End Do
!              loop over vector blocks to compute
!              X(J,K) = sum_ai L(ai,J)*L(ai,K)*exp(-(e(a)-a(i))*t(q)/2)
!              Eq += w(q)*sum_JK [X(J,K)]**2
               Do jBlock=1,nBlock
                  ipj=ip_SV+Nai*Laplace_BlockSize*(jBlock-1)
                  If (jBlock.eq.nBlock) Then
                     nVecj=nEnrVec(iSym)-Laplace_BlockSize*(nBlock-1)
                  Else
                     nVecj=Laplace_BlockSize
                  End If
                  Do iBlock=jBlock,nBlock
                     ipi=ip_SV+Nai*Laplace_BlockSize*(iBlock-1)
                     If (iBlock.eq.nBlock) Then
                        nVeci=nEnrVec(iSym)-Laplace_BlockSize*(nBlock-1)
                     Else
                        nVeci=Laplace_BlockSize
                     End If
                     Call dGEMM_('T','N',nVeci,nVecj,Nai,
     &                           1.0d0,Work(ipi),Nai,Work(ipj),Nai,
     &                           0.0d0,Work(ip_X),nVeci)
                     If (iBlock.eq.jBlock) Then
                        Eq=Eq
     &               +0.5d0*dDot_(nVeci*nVecj,Work(ip_X),1,Work(ip_X),1)
                     Else
                        Eq=Eq
     &                     +dDot_(nVeci*nVecj,Work(ip_X),1,Work(ip_X),1)
                     End If
                  End Do
               End Do
               ! accumulate in EMP2
               EMP2=EMP2-w(q)*Eq
            End Do
            ! deallocate memory
            Call GetMem('LSMV','Free','Real',ip_V,l_V)
            Call GetMem('LSMX','Free','Real',ip_X,l_X)
            ! close (and possibly delete) vector file
            Call ChoMP2_OpenF(iClos,iTyp,iSym)
         End If
      End Do

      ! Scale energy (only half of X computed)
      EMP2=2.0d0*EMP2

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine ChoLSOSMP2_Energy_Fll2(N,w,t,EOcc,EVir,Delete,EMP2,irc)
C
C     Thomas Bondo Pedersen, December 2012.
C
C     Compute Laplace-SOS-MP2 energy correction from unsorted Cholesky
C     vectors (i.e., no batching). This uses the exact same loop
C     ordering as the sorted algorithm and thus reads through the
C     vector files once for each grid point.
C
      Implicit None
      Integer N
      Real*8  w(N)
      Real*8  t(N)
      Real*8  EOcc(*)
      Real*8  EVir(*)
      Logical Delete
      Real*8  EMP2
      Integer irc
#include "WrkSpc.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "cholesky.fh"

      Character*22 SecNam
      Parameter (SecNam='ChoLSOSMP2_Energy_Fll2')

      Real*8   dDot_
      external ddot_

#if !defined (_I8_) || defined (_DEBUGPRINT_)
      Character*2 Unt
      Real*8  Byte
#endif

      Integer nEnrVec(8)

      Integer iTyp
      Integer iSym
      Integer ip_X, l_X
      Integer ip_V, l_V
      Integer Nai
      Integer nBlock
      Integer iOpt, iAddr, l_Tot
      Integer q
      Integer iBlock, jBlock
      Integer iSymi, iSyma
      Integer i, a
      Integer ipi, ipj
      Integer nVeci, nVecj
      Integer iVec
      Integer ip0, ip1
      Integer ipX, lenX
      Integer bsize
      Integer blast

      Real*8  lX, xM, xn, xb, xbp
      Real*8  tq, Eq, wq

      Integer j, k
      Real*8  epsi, epsa
      Integer MulD2h
      epsi(j,k)=EOcc(iOcc(k)+j)
      epsa(j,k)=EVir(iVir(k)+j)
      MulD2h(j,k)=iEOr(j-1,k-1)+1

      ! init return code
      irc=0

      ! init energy
      EMP2=0.0d0

      ! check input (incl. common block variables)
      If (N.ne.Laplace_nGridPoints) Then
         irc=-2
         Return
      End If
      If (Laplace_BlockSize.lt.1) Then
         irc=-3
         Return
      End If

      ! set number and type of vectors
      If (DecoMP2) Then
         iTyp=2
         Call iCopy(nSym,nMP2Vec,1,nEnrVec,1)
      Else
         iTyp=1
         Call iCopy(nSym,NumCho,1,nEnrVec,1)
      End If

      ! allocate X
      lX=0.0d0
      Do iSym=1,nSym
         If (nT1am(iSym).gt.0 .and. nEnrVec(iSym).gt.0) Then
            bsize=min(Laplace_BlockSize,nEnrVec(iSym))
            nBlock=(nEnrVec(iSym)-1)/bsize+1
            blast=nEnrVec(iSym)-bsize*(nBlock-1)
            xM=dble(nEnrVec(iSym))
            xn=dble(nBlock)
            xb=dble(bsize)
            xbp=dble(blast)
            lX=max(lX,0.5d0*(xM*(xM+1.0d0)
     &                      +(xn-1.0d0)*xb*(xb-1.0d0)
     &                      +xbp*(xbp-1.0d0)))
         End If
      End Do
      l_X=int(lX)
#if !defined (_I8_) || defined (_DEBUGPRINT_)
      If (l_X .lt. 0) Then
         Write(Lupri,'(A,A)')
     &   SecNam,': dimension of X matrix is negative!'
         Write(Lupri,'(A,I15)') 'l_X=',l_X
         If (lX .gt. 0.0d0) Then
            Write(LuPri,'(A)') 'This seems to be an integer overflow!'
            Call Cho_RWord2Byte(lX,Byte,Unt)
            Write(LuPri,'(A,1P,D15.6,A,D15.6,1X,A,A)')
     &      'In double precision, lX=',lX,
     &      ' words (',Byte,Unt,')'
         End If
         irc=1
         Return
      End If
#endif
      Call GetMem('LSMX','Allo','Real',ip_X,l_X)

      ! allocate vector array
      Nai=nT1am(1)*nEnrVec(1)
      Do iSym=2,nSym
         Nai=max(Nai,nT1am(iSym)*nEnrVec(iSym))
      End Do
      l_V=Nai
      Call GetMem('LSMV','Allo','Real',ip_V,l_V)

      ! compute energy correction
      Do q=1,N
         ! init energy for this q
         Eq=0.0d0
         ! scale grid point by 1/2
         tq=0.5d0*t(q)
         ! scale weight by 2 (only lower blocks of X computed)
         wq=2.0d0*w(q)
         Do iSym=1,nSym
            Nai=nT1am(iSym)
            If (Nai.gt.0 .and. nEnrVec(iSym).gt.0) Then
               ! init X for this symmetry
               bsize=min(Laplace_BlockSize,nEnrVec(iSym))
               nBlock=(nEnrVec(iSym)-1)/bsize+1
               blast=nEnrVec(iSym)-bsize*(nBlock-1)
               lenX=nEnrVec(iSym)*(nEnrVec(iSym)+1)/2
     &             +(nBlock-1)*(bsize*(bsize-1)/2)
     &             +blast*(blast-1)/2
               Call fZero(Work(ip_X),lenX)
               ! open file, read vectors, close file
               ! do not delete file here - it may be needed later
               ! (because of the loop over q)
               Call ChoMP2_OpenF(1,iTyp,iSym)
               iOpt=2
               l_Tot=Nai*nEnrVec(iSym)
               iAddr=1
               Call dDAFile(lUnit_F(iSym,iTyp),iOpt,Work(ip_V),
     &                      l_Tot,iAddr)
               Call ChoMP2_OpenF(2,iTyp,iSym)
               ! scale vectors
               Do iVec=1,nEnrVec(iSym)
                  ip0=ip_V-1+Nai*(iVec-1)
                  Do iSymi=1,nSym
                     If (nOcc(iSymi).gt.0) Then
                        iSyma=MulD2h(iSym,iSymi)
                        ip1=ip0+iT1am(iSyma,iSymi)
                        Do i=1,nOcc(iSymi)
                           Call dScal_(nVir(iSyma),
     &                                exp(epsi(i,iSymi)*tq),
     &                                Work(ip1+nVir(iSyma)*(i-1)+1),1)
                        End Do
                        Do a=1,nVir(iSyma)
                           Call dScal_(nOcc(iSymi),
     &                                exp(-epsa(a,iSyma)*tq),
     &                                Work(ip1+a),nVir(iSyma))
                        End Do
                     End If
                  End Do
               End Do
               ! loop over vector blocks to compute
               ! X(J,K) +=
               ! sum_ai L(ai,J)*L(ai,K)*exp(-(e(a)-e(i))*t(q)/2)
               ipX=ip_X
               Do jBlock=1,nBlock
                  ipj=ip_V+Nai*Laplace_BlockSize*(jBlock-1)
                  If (jBlock.eq.nBlock) Then
                     nVecj=nEnrVec(iSym)
     &                    -Laplace_BlockSize*(nBlock-1)
                  Else
                     nVecj=Laplace_BlockSize
                  End If
                  Do iBlock=jBlock,nBlock
                     ipi=ip_V+Nai*Laplace_BlockSize*(iBlock-1)
                     If (iBlock.eq.nBlock) Then
                        nVeci=nEnrVec(iSym)
     &                       -Laplace_BlockSize*(nBlock-1)
                     Else
                        nVeci=Laplace_BlockSize
                     End If
                     Call dGEMM_('T','N',nVeci,nVecj,Nai,
     &                          1.0d0,Work(ipi),Nai,Work(ipj),Nai,
     &                          1.0d0,Work(ipX),nVeci)
                     ipX=ipX+nVeci*nVecj
                  End Do
               End Do
#if defined (_DEBUGPRINT_)
               If (lenX.ne.(ipX-ip_X)) Then
                  Call WarningMessage(2,
     &                          SecNam//': dimension problem [1]')
                  Write(6,'(A,I10,A,I10)')
     &            'lenX=',lenX,' ipX-ip_X=',ipX-ip_X
                  Call Abend()
               End If
#endif
               ! compute energy contribution
               ! Eq += sum_JK [X(J,K)]**2
               ipX=ip_X
               Do jBlock=1,nBlock
                  If (jBlock.eq.nBlock) Then
                     nVecj=nEnrVec(iSym)
     &                    -Laplace_BlockSize*(nBlock-1)
                  Else
                     nVecj=Laplace_BlockSize
                  End If
                  Do iBlock=jBlock,nBlock
                     If (iBlock.eq.nBlock) Then
                        nVeci=nEnrVec(iSym)
     &                       -Laplace_BlockSize*(nBlock-1)
                     Else
                        nVeci=Laplace_BlockSize
                     End If
                     If (iBlock.eq.jBlock) Then
                        Eq=Eq+0.5d0*dDot_(nVeci*nVecj,
     &                                   Work(ipX),1,Work(ipX),1)
                     Else
                        Eq=Eq+dDot_(nVeci*nVecj,
     &                             Work(ipX),1,Work(ipX),1)
                     End If
                     ipX=ipX+nVeci*nVecj
                  End Do
               End Do
#if defined (_DEBUGPRINT_)
               If (lenX.ne.(ipX-ip_X)) Then
                  Call WarningMessage(2,
     &                             SecNam//': dimension problem [2]')
                  Write(6,'(A,I10,A,I10)')
     &            'lenX=',lenX,' ipX-ip_X=',ipX-ip_X
                  Call Abend()
               End If
#endif
            End If
         End Do
         ! scale Eq
         Eq=-wq*Eq
         ! Accumulate in EMP2
         EMP2=EMP2+Eq
      End Do

      ! deallocations
      Call GetMem('LSMV','Free','Real',ip_V,l_V)
      Call GetMem('LSMX','Free','Real',ip_X,l_X)

      ! delete files if requested
      If (Delete) Then
         Do iSym=1,nSym
            Call ChoMP2_OpenF(1,iTyp,iSym)
            Call ChoMP2_OpenF(3,iTyp,iSym)
         End Do
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE TRDNS2O(IVEC,JVEC,DPT2,NDPT2,SCAL)
      use definitions, only: iwp, wp
      use constants, only: Zero, One
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_global, only: LISTS
      use EQSOLV, only: IfCoup
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: FockType, G1SecIn, nActEl, nSym, nOrb,
     &                         nInDep, nISup, nASup, nIsh, nSsh, nAsh

      IMPLICIT None

      Integer(kind=iwp), Intent(out):: NDPT2
      Integer(kind=iwp), Intent(in):: IVEC, JVEC
      real(kind=wp), intent(in):: SCAL
      real(kind=wp), intent(inout):: DPT2(*)

      real(kind=wp), Allocatable:: WEC1(:), SCR(:)
#ifdef _MOLCAS_MPP_
      real(kind=wp), Allocatable:: TMP1(:), TMP2(:)
#endif
      real(kind=wp) Fact
      Integer(kind=iwp) iCase1, iCase2, idoff, idpq, idqp, iLoop,
     &                  iMltOp, ip, iq, iSta, iSym, iSym1, iSym2,
     &                  lScr, lScr2, lVec1, lVec2, na, nas1, nas2,
     &                  ni, nis1, nis2, nLoop, no, nVec1, nVec2,
     &                  nWec1


C If the G1 correction to the Fock matrix is used, then the
C inactive/virtual coupling elements (which are non-zero for the
C case of average CASSCF) cannot be used in the CASPT2 equations.
      IF(FOCKTYPE.EQ.'G1      ' .AND. (.NOT. G1SECIN)) THEN
        IFCOUP(12,5)=0
        IFCOUP(13,5)=0
      END IF

C Add to the block-off-diag parts of transition density matrix,
C    DPT2(p,q) = Add <IVEC| E(p,q) |JVEC>.
C i.e. inact/act, inact/virt and act/virt submatrices only,
C where IVEC, JVEC stands for the 1st-order perturbed CASPT2
C wave functions stored as vectors nr IVEC, JVEC on LUSOLV.

      NDPT2=0
      DO ISYM=1,NSYM
        NDPT2=NDPT2+NORB(ISYM)**2
      END DO

C Loop over ordering: First, <IVEC|...|JVEC>, then reverse.
C For each order, compute the upper-triangular blocks.
C For true density matrices, use symmetry of D-matrix.

C Transform to standard representation, contravariant form.
      CALL PTRTOC(0,IVEC,IVEC)
      IF(IVEC.NE.JVEC) CALL PTRTOC(0,JVEC,JVEC)
      NLOOP=2
      IF(IVEC.EQ.JVEC) NLOOP=1
      DO ILOOP=1,NLOOP
        ! IF(ILOOP.EQ.1) THEN
        !   IBRA=IVEC
        !   IKET=JVEC
        ! ELSE
        !   IBRA=JVEC
        !   IKET=IVEC
        ! END IF

C Loop over types and symmetry block of VEC1 vector:
      DO ICASE1=1,13
        DO ISYM1=1,NSYM
          IF(NINDEP(ISYM1,ICASE1).EQ.0) Cycle
          NIS1=NISUP(ISYM1,ICASE1)
          NAS1=NASUP(ISYM1,ICASE1)
          NVEC1=NIS1*NAS1
          IF(NVEC1.EQ.0) Cycle
C Form VEC1 from the BRA vector, transformed to covariant form.
          CALL RHS_ALLO(NAS1,NIS1,LVEC1)
          CALL RHS_SCAL(NAS1,NIS1,LVEC1,Zero)
          IF(ICASE1.LE.11) THEN
           CALL RHS_ALLO(NAS1,NIS1,LSCR)
           CALL RHS_READ(NAS1,NIS1,LSCR,ICASE1,ISYM1,IVEC) !! IBRA)
           IF (IVEC.NE.JVEC.AND.ILOOP.EQ.1) THEN
            IF (SCAL.ne.One) CALL RHS_SCAL(NAS1,NIS1,LSCR,SCAL)
            CALL RHS_ALLO(NAS1,NIS1,LSCR2)
            CALL RHS_READ(NAS1,NIS1,LSCR2,ICASE1,ISYM1,JVEC)
            CALL RHS_DAXPY(NAS1,NIS1,One,LSCR2,LSCR)
            CALL RHS_FREE(LSCR2)
           END IF
           CALL RHS_STRANS (NAS1,NIS1,One,LSCR,LVEC1,ICASE1,ISYM1)
           CALL RHS_FREE(LSCR)
          ELSE
           CALL RHS_READ(NAS1,NIS1,LVEC1,ICASE1,ISYM1,IVEC) !! IBRA)
           IF (IVEC.NE.JVEC.AND.ILOOP.EQ.1) THEN
            IF (SCAL.ne.One) CALL RHS_SCAL(NAS1,NIS1,LVEC1,SCAL)
            CALL RHS_ALLO(NAS1,NIS1,LSCR2)
            CALL RHS_READ(NAS1,NIS1,LSCR2,ICASE1,ISYM1,JVEC)
            CALL RHS_DAXPY(NAS1,NIS1,One,LSCR2,LVEC1)
            CALL RHS_FREE(LSCR2)
           END IF
          END IF
C Form WEC1 from VEC1, if needed.
          NWEC1=0
          FACT=One/(DBLE(MAX(1,NACTEL)))
          IF(ICASE1.EQ.1) NWEC1=NASH(ISYM1)*NISH(ISYM1)
          IF(ICASE1.EQ.4) NWEC1=NASH(ISYM1)*NSSH(ISYM1)
          IF(ICASE1.EQ.5.AND.ISYM1.EQ.1) NWEC1=NIS1
          IF(NWEC1.GT.0) THEN
            CALL mma_allocate(WEC1,NWEC1,Label='WEC1')
            WEC1(:)=Zero
            IMLTOP=1
#ifdef _MOLCAS_MPP_
            IF (IS_REAL_PAR()) THEN
                CALL mma_allocate(TMP1,NVEC1,Label='TMP1')
                CALL RHS_GET(NAS1,NIS1,LVEC1,TMP1)
                IF(ICASE1.EQ.1) THEN
                  CALL SPEC1A(IMLTOP,FACT,ISYM1,TMP1,WEC1)
                ELSE IF(ICASE1.EQ.4) THEN
                  CALL SPEC1C(IMLTOP,FACT,ISYM1,TMP1,WEC1)
                ELSE IF(ICASE1.EQ.5.AND.ISYM1.EQ.1) THEN
                  CALL SPEC1D(IMLTOP,FACT,TMP1,WEC1)
                END IF
                CALL mma_deallocate(TMP1)
            ELSE
#endif
              IF(ICASE1.EQ.1) THEN
                CALL SPEC1A(IMLTOP,FACT,ISYM1,
     &                      GA_Arrays(LVEC1)%A,WEC1)
              ELSE IF(ICASE1.EQ.4) THEN
                CALL SPEC1C(IMLTOP,FACT,ISYM1,
     &                      GA_Arrays(LVEC1)%A,WEC1)
              ELSE IF(ICASE1.EQ.5.AND.ISYM1.EQ.1) THEN
                CALL SPEC1D(IMLTOP,FACT,GA_Arrays(LVEC1)%A,WEC1)
              END IF
#ifdef _MOLCAS_MPP_
            END IF
#endif
          ELSE
            CALL mma_allocate(WEC1,1,Label='WEC1')
          END IF
C Note: WEC1 is identical to <IBRA| E(p,q) |0> for the cases
C (p,q)=(t,i), (a,t), and (a,i), resp.
          DO ICASE2=ICASE1+1,13
            IF(IFCOUP(ICASE2,ICASE1).EQ.0) Cycle
            DO ISYM2=1,NSYM
              IF(NINDEP(ISYM2,ICASE2).EQ.0) Cycle
              NIS2=NISUP(ISYM2,ICASE2)
              NAS2=NASUP(ISYM2,ICASE2)
              NVEC2=NIS2*NAS2
              IF(NVEC2.EQ.0) Cycle
              CALL RHS_ALLO(NAS2,NIS2,LVEC2)
              CALL RHS_READ(NAS2,NIS2,LVEC2,ICASE2,ISYM2,IVEC) !! IKET)
              IF (IVEC.NE.JVEC.AND.ILOOP.EQ.2) THEN
               IF (SCAL.ne.One) CALL RHS_SCAL(NAS2,NIS2,LVEC2,SCAL)
               CALL RHS_ALLO(NAS2,NIS2,LSCR2)
               CALL RHS_READ(NAS2,NIS2,LSCR2,ICASE2,ISYM2,JVEC)
               CALL RHS_DAXPY(NAS2,NIS2,One,LSCR2,LVEC2)
               CALL RHS_FREE(LSCR2)
              END IF
#ifdef _MOLCAS_MPP_
              IF (IS_REAL_PAR()) THEN
                  CALL mma_allocate(TMP1,NVEC1,Label='TMP1')
                  CALL mma_allocate(TMP2,NVEC2,Label='TMP2')
                  CALL RHS_GET(NAS1,NIS1,LVEC1,TMP1)
                  CALL RHS_GET(NAS2,NIS2,LVEC2,TMP2)
                  CALL OFFDNS(ISYM1,ICASE1,ISYM2,ICASE2,
     &                        WEC1,TMP1,DPT2,TMP2,LISTS)
                  CALL mma_deallocate(TMP1)
                  CALL mma_deallocate(TMP2)
              ELSE
#endif
                CALL OFFDNS(ISYM1,ICASE1,ISYM2,ICASE2,
     &                      WEC1,GA_Arrays(LVEC1)%A,DPT2,
     &                           GA_Arrays(LVEC2)%A,LISTS)
#ifdef _MOLCAS_MPP_
              END IF
#endif
              CALL RHS_FREE(LVEC2)
            End Do
          End Do
          CALL RHS_FREE(LVEC1)
          Call mma_deallocate(WEC1)
        End Do
      End Do

      End Do

      CALL GADSUM(DPT2,NDPT2)

      IF(IVEC.NE.JVEC) THEN
C Transpose the density matrix.
        CALL mma_allocate(SCR,NDPT2,Label='SCR')
        ISTA=1
        DO ISYM=1,NSYM
          NO=NORB(ISYM)
          CALL TRNSPS(NO,NO,DPT2(ISTA),SCR)
          CALL DCOPY_(NO*NO,SCR,1,DPT2(ISTA),1)
          ISTA=ISTA+NO**2
        END DO
        CALL mma_deallocate(SCR)
      END IF

C Transform vectors back to eigenbasis of H0(diag).
      CALL PTRTOSR(1,IVEC,IVEC)
      IF(IVEC.NE.JVEC) CALL PTRTOSR(1,JVEC,JVEC)
      IF(IVEC.EQ.JVEC) THEN
C Fill in lower-triangular block elements by symmetry.
        IDOFF=0
        DO ISYM=1,NSYM
          NI=NISH(ISYM)
          NA=NASH(ISYM)
          NO=NORB(ISYM)
          DO IP=1,NI+NA
            DO IQ=NI+1,NO
              IDPQ=IDOFF+IP+NO*(IQ-1)
              IDQP=IDOFF+IQ+NO*(IP-1)
              DPT2(IDQP)=DPT2(IDPQ)
            END DO
          END DO
          IDOFF=IDOFF+NO**2
        END DO
      END IF

      END SUBROUTINE TRDNS2O

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Logical Function lEmpty(Coeff,n2,ld2,m2)
************************************************************************
*                                                                      *
* Object: to set if partial or whole contraction matrix is empty.      *
*                                                                      *
* Called from: TwoEl                                                   *
*                                                                      *
* Calling    : None                                                    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             June '91                                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Integer, Intent(In):: n2, ld2, m2
      Real*8, Intent(In):: Coeff(ld2,m2)
#include "real.fh"
*
      lEmpty = .True.
      Temp = Zero
      Do i = 1, n2
         Do j = 1, m2
            Temp = Temp + Abs(Coeff(i,j))
         End Do
      End Do
*
      lEmpty = Temp.eq.Zero
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine DECOMP(NN,A)

use cpf_global, only: IPS
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NN
real(kind=wp), intent(inout) :: A(NN,NN)
integer(kind=iwp) :: I, IDXPIV, IP, J, K, KP, KP1, N, NM1
real(kind=wp) :: BIG, EM, PIVOT, ROWNRM, SCALES(200), RSIZE

N = NN
IDXPIV = 0 ! dummy initialize
! INITIALIZE IPS AND SCALES
do I=1,N
  IPS(I) = I
  ROWNRM = Zero
  do J=1,N
    if (ROWNRM < abs(A(I,J))) ROWNRM = abs(A(I,J))
  end do
  if (ROWNRM == Zero) then
    call SING(1)
    SCALES(I) = Zero
  else
    SCALES(I) = One/ROWNRM
  end if
end do
! GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
NM1 = N-1
do K=1,NM1
  BIG = Zero
  do I=K,N
    IP = IPS(I)
    RSIZE = abs(A(IP,K))*SCALES(IP)
    if (RSIZE > BIG) then
      BIG = RSIZE
      IDXPIV = I
    end if
  end do
  if (BIG == 0) then
    call SING(2)
  else
    if (IDXPIV /= K) then
      J = IPS(K)
      IPS(K) = IPS(IDXPIV)
      IPS(IDXPIV) = J
    end if
    KP = IPS(K)
    PIVOT = A(KP,K)
    KP1 = K+1
    do I=KP1,N
      IP = IPS(I)
      EM = -A(IP,K)/PIVOT
      A(IP,K) = -EM
      do J=KP1,N
        A(IP,J) = A(IP,J)+EM*A(KP,J)
      end do
    end do
  end if
end do
KP = IPS(N)
if (A(KP,N) == 0) call SING(2)

return

end subroutine DECOMP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA(rc)

! Thomas Bondo Pedersen (CTCC,UiO), July 2013.
!
! Driver routine for the calculation of correlation energies in the
! random-phase approximation (RPA) using Cholesky/DF integrals.
!
! NOTE: conventional integrals are not implemented!

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: rc
#include "warnings.h"
integer(kind=iwp) :: irc
character(len=80) :: string
character(len=*), parameter :: SecNam = 'RPA'

!=======================================================================
! Enter
!=======================================================================

rc = _RC_ALL_IS_WELL_ ! init return code
irc = 0 ! init internal return code

!=======================================================================
! Setup: initialize data, read reference orbitals and process input
!=======================================================================

call StatusLine('RPA: ','Setup')
call RPA_Setup()

!=======================================================================
! Exit after cleanup
!=======================================================================

call StatusLine('RPA: ','Cleanup')
call RPA_Cleanup(irc)
if (irc /= 0) then
  write(string,'(A,A,I4)') SecNam,': Cleanup failed! rc=',irc
  call WarningMessage(2,string)
  if (rc == _RC_ALL_IS_WELL_) rc = _RC_INTERNAL_ERROR_
end if

end subroutine RPA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_INVPCK(IJ,I,J,LOW)
C
C     Purpose: invert triangular packing index ij to
C              rectangular indices i and j.
C              Flag LOW specifies packing convention:
C              LOW = T: i>=j
C              LOW = F: i<=j
C
#include "implicit.fh"
      LOGICAL LOW

      PARAMETER (ONE = 1.0D0, TWO = 2.0D0, THREE = 3.0D0, EIGHT = 8.0D0)

      IF (IJ .GT. 0) THEN

         XX = EIGHT*DBLE(IJ) - THREE
         XI = (ONE + SQRT(XX))/TWO
         I  = INT(XI)
         J  = IJ - I*(I - 1)/2

         IF (.NOT. LOW) THEN
            ITMP = I
            I = J
            J = ITMP
         END IF

      ELSE

         I = -1
         J = -2

      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine read_formatted_aniso_poly(input_file_name,nss,nstate,nLoc,eso,MM,MS,iReturn)
! nLoc is the maximal value of the array nss(1:nneq)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero
use Definitions, only: wp, iwp

implicit none
character(len=180), intent(in) :: input_file_name
integer(kind=iwp), intent(inout) :: nss, nstate
integer(kind=iwp), intent(in) :: nLoc
real(kind=wp), intent(out) :: eso(nLoc)
complex(kind=wp), intent(out) :: MM(3,nLoc,nLoc), MS(3,nLoc,nLoc)
integer(kind=iwp), intent(out) :: iReturn
integer(kind=iwp) :: j, j1, j2, l, LuAniso
integer(kind=iwp), allocatable :: multiplicity(:)
real(kind=wp), allocatable :: tmpR(:,:), tmpI(:,:)
integer(kind=iwp), external :: IsFreeUnit

#include "macros.fh"

! set to zero all arrays:
iReturn = 0
MM(:,:,:) = cZero
MS(:,:,:) = cZero
! read the file "aniso.input":
LuAniso = IsFreeUnit(40)
call molcas_open(LuAniso,input_file_name)
! compatibility with the present version: of aniso_i.input file
read(LuAniso,*) nstate,nss
read(LuAniso,*) (eso(j),j=1,nss)
call mma_allocate(multiplicity,nstate,label='multiplicity')
read(LuAniso,*) (multiplicity(j),j=1,nstate)
unused_var(multiplicity)

call mma_allocate(tmpR,nss,nss,'tmpR')
call mma_allocate(tmpI,nss,nss,'tmpI')
! magnetic moment
do l=1,3
  do j1=1,nss
    read(LuAniso,*) (tmpR(j1,j2),tmpI(j1,j2),j2=1,nss)
  end do
  MM(l,1:nss,1:nss) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)
end do

! spin moment
do l=1,3
  do j1=1,nss
    read(LuAniso,*) (tmpR(j1,j2),tmpI(j1,j2),j2=1,nss)
  end do
  MS(l,1:nss,1:nss) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)
end do
call mma_deallocate(tmpR)
call mma_deallocate(tmpI)

!if (iprint > 4) then
!  write(u6,'(10a12)') (('------------'),j=1,10)
!  write(u6,'(15x,a,i2,a)') 'aniso_.input'
!  write(u6,'(10a12)') (('------------'),j=1,10)
!  write(u6,'(5x,a,i6)') 'nstate = ',nstate
!  write(u6,'(5x,a,i6)') '   nss = ',nss
!  write(u6,'(5x,a)') ' eso(j): '
!  write(u6,'(10(f12.5,1x))') (eso(j),j=1,nss)
!  write(u6,'(5x,a,i2,a)') 'multiplicity(j):'
!  write(u6,'(40i3)') (multiplicity(j),j=1,nstate)
!  write(u6,'(5x,a,i2,a)') 'dipso(l,j1,j2):'
!  do l=1,3
!    write(u6,'(5x,a,i2)') 'axis= ',l
!    do j1=1,nss
!      write(u6,'(20(2f20.14,1x))') (MM(l,j1,j2),j2=1,nss)
!    end do
!  end do
!  write(u6,*)
!  write(u6,'(5x,a,i2,a)') 's_so(l,j1,j2):'
!  do l=1,3
!    write(u6,'(5x,a,i2)') 'axis= ',l
!    do j1=1,nss
!      write(u6,'(20(2f20.14,1x))') (MS(l,j1,j2),j2=1,nss)
!    end do
!  end do
!end if
close(LuAniso)

call mma_deallocate(multiplicity)

return

end subroutine read_formatted_aniso_poly

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ElRed2(nq,nx,Gmtrx,EVal,EVec,nK,uMtrx,g12K,Thr,BM,iBM,nB_Tot,nqB)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nq, nx, nB_Tot, iBM(nB_Tot), nqB(nq)
real(kind=wp), intent(out) :: Gmtrx(nq,nq), EVal(nTri_Elem(nq)), EVec(nq,nq)
integer(kind=iwp), intent(out) :: nK
real(kind=wp), intent(in) :: uMtrx(nX), Thr, BM(nB_Tot)
logical(kind=iwp), intent(in) :: g12K
integer(kind=iwp) :: i, iB, ii, ijTri, ik, Info, iQ, j, jB, jl, k, l, LDZ, mB, nB
real(kind=wp) :: B_ik, B_jl, rSum
logical(kind=iwp) :: Diagonal
real(kind=wp), allocatable :: W(:), Work(:)
real(kind=wp), parameter :: Zero_Approx = 1.0e-10_wp

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *

#ifdef _DEBUGPRINT_
call RecPrt('ElRed2: The u matrix','(5es21.12)',umtrx,nx,1)
#endif
if (nq == 0) then
  nK = 0
  return
end if

!                         T
! Form the G matrix, G=BuB

GMtrx(:,:) = Zero
iB = 0
do i=1,nq
  nB = nqB(i)
  do k=1,nB
    iB = iB+1
    ik = iBM(iB)
    B_ik = BM(iB)

    jB = 0
    do j=1,nq
      mB = nqB(j)
      do l=1,mB
        jB = jB+1
        jl = iBM(jB)
        if (ik == jl) then
          B_jl = BM(jB)
          GMtrx(i,j) = GMtrx(i,j)+B_ik*umtrx(ik)*B_jl
        end if
      end do
    end do

  end do
end do

Diagonal = .true.
do i=1,nq
  rSum = Zero
  do j=1,nq
    if (abs(Gmtrx(i,j)) < 1.0e-10_wp) Gmtrx(i,j) = Zero
    if (j /= i) rSum = rSum+GMtrx(i,j)
  end do
  Diagonal = Diagonal .and. (rSum == Zero)
end do

#ifdef _DEBUGPRINT_
call RecPrt('ElRed2: The G Matrix (nq x nq)','(5es21.12)',Gmtrx,nq,nq)
write(u6,*) 'Diagonal=',Diagonal
#endif

! Set up a unit matrix

call unitmat(EVec,nq)

! Set up the Hessian in lower triangular form, the elements are symmetrized.

do i=1,nQ
  do j=1,i
    ijTri = nTri_Elem(i-1)+j
    EVal(ijTri) = Half*(Gmtrx(i,j)+Gmtrx(j,i))
  end do
end do
#ifdef _DEBUGPRINT_
call TriPrt('Eval prediagonalization',' ',EVal,nQ)
#endif

!                                                    |g 0|
! Compute eigenvalues and eigenvectors G(K L) = (K L)|0 0|
! K: nonredundant vectors with eigenvalues g
! L: redundant vectors

if (.not. Diagonal) then
  LDZ = max(1,nq)
  call mma_allocate(Work,3*nq,Label='Work')
  Work(:) = Zero
  call mma_allocate(W,nq,Label='W')
  W(:) = Zero
  Info = 0
  call dspev_('V','U',nq,Eval,W,EVec,LDZ,Work,Info)
  if (Info /= 0) then
    write(u6,*) 'Info /= 0'
    write(u6,*) 'Info=',Info
    call Abend()
  end if
  EVal(:) = Zero
  do i=1,nq
    EVal(nTri_Elem(i)) = W(i)
  end do
  call mma_deallocate(W)
  call mma_deallocate(Work)
end if
EVal(:) = -Eval(:)
call JacOrd(EVal,EVec,nQ,nQ)
!Fix standard direction.
do iQ=1,nQ
  call VecPhase(EVec(:,iQ),nQ)
end do
EVal(:) = -Eval(:)
#ifdef _DEBUGPRINT_
call RecPrt('ElRed2: Eigenvectors',' ',EVec,nQ,nQ)
call TriPrt('ElRed2: Eigenvalues',' ',EVal,nQ)
#endif

!                                    -1/2
! Remove redundant vectors and form g     K

nK = 0
do i=1,nQ
  ii = nTri_Elem(i)
  if (EVal(ii) > Thr) nK = nK+1
  EVal(i) = EVal(ii)
  !if (g12K .and. (abs(EVal(i)) > Zero))
  if (g12K .and. (abs(EVal(i)) > Zero_Approx)) EVec(:,i) = EVec(:,i)/sqrt(EVal(i))
end do
#ifdef _DEBUGPRINT_
call RecPrt('ElRed2: The NonRedundant eigenvectors','(5es21.12)',EVec,nQ,nK)
call RecPrt('ElRed2: eigenvalues ','(8ES12.4)',EVal,1,nK)
#endif

return

end subroutine ElRed2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1994, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine RysEF(xyz2D,nArg,mArg,nRys,neMin,neMax,nfMin,nfMax,
     &                 EFInt,meMin,meMax,mfMin,mfMax,Scrtch,PreFct,
     &                 AeqB, CeqD)
************************************************************************
*                                                                      *
*     Object: to compute integrals corresponding to the primitive set  *
*             used for the HRR. The primitive integrals are generated  *
*             from the 2D-integrals according to the Rys quadrature.   *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90.                                             *
*                                                                      *
*             Modified for kernal routine RysEF0 August '90.           *
*             Modified for kernal routines RysS1, RysS2, and RysS3     *
*             September '90.                                           *
*             Modified for improved vectorization August '91.          *
*             Modified for decreased memory access January '94.        *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "TriInd.fh"
#include "real.fh"
#include "print.fh"
      Real*8 xyz2D(nRys,mArg,3,0:neMax,0:nfMax), PreFct(mArg),
     &       Scrtch(nRys,mArg), EFInt(nArg,meMin:meMax,mfMin:mfMax)
      Logical AeqB, CeqD
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Character*80 Label
#endif
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 16
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
      ne = (neMax+1)*(neMax+2)/2
      nf = (nfMax+1)*(nfMax+2)/2
*
      If (ne.gt.IJ_Max .or. nf.gt.IJ_Max) Then
         Write (6,*) 'ne,nf=',ne,nf
         Call WarningMessage(2,
     &               'Increase IJ_Max to the larger of the above!')
         Call Abend()
      End If
*
      Do ief = 1, ne*nf
         if = (ief-1)/ne + 1
         ie = ief - (if-1)*ne
*
         ixe = iTriInd(1,ie)
         iye = iTriInd(2,ie)
         ixye = ixe + iye
*
         ixf = iTriInd(1,if)
         iyf = iTriInd(2,if)
         ixyf = ixf + iyf
*                                                                      *
************************************************************************
*                                                                      *
         nzeMax=Max(0,neMax-ixe-iye)
         nzfMax=Max(0,nfMax-ixf-iyf)
         nzeMin=Max(0,neMin-ixe-iye)
         If (AeqB) nzeMin = nzeMax
         nzfMin=Max(0,nfMin-ixf-iyf)
         If (CeqD) nzfMin = nzfMax
*
         nItem=(nzeMax-nzeMin+1)*(nzfMax-nzfMin+1)
         If (nItem.gt.1) Then
*
*           Precompute for all arguments Ix*Iy, avoid multiplying
*           with ones.
*
*
*           Combine with possible Iz
*
            If (ixe+ixf+iye+iyf.eq.0) Then
*
               Call RysEF1(                     xyz2D,
     &                     nArg,mArg,nRys,neMin,neMax,nfMin,
     &                     nfMax,EFInt,meMin,meMax,mfMin,mfMax,
     &                     PreFct,ixe,ixf,ixye,ixyf,
     &                     nzeMin,nzeMax,nzfMin,nzfMax)
*
            Else If(ixe+ixf.eq.0) Then
*
               Call RysEF0(xyz2D(1,1,2,iye,iyf),xyz2D,
     &                     nArg,mArg,nRys,neMin,neMax,nfMin,
     &                     nfMax,EFInt,meMin,meMax,mfMin,mfMax,
     &                     PreFct,ixe,ixf,ixye,ixyf,
     &                     nzeMin,nzeMax,nzfMin,nzfMax)
*
            Else If(iye+iyf.eq.0) Then
*
               Call RysEF0(xyz2D(1,1,1,ixe,ixf),xyz2D,
     &                     nArg,mArg,nRys,neMin,neMax,nfMin,
     &                     nfMax,EFInt,meMin,meMax,mfMin,mfMax,
     &                     PreFct,ixe,ixf,ixye,ixyf,
     &                     nzeMin,nzeMax,nzfMin,nzfMax)
*
            Else
*
               Do iArg = 1, mArg
                  Do iRys=1,nRys
                     Scrtch(iRys,iArg) = xyz2D(iRys,iArg,1,ixe,ixf)
     &                                 * xyz2D(iRys,iArg,2,iye,iyf)
                  End Do
               End Do
               Call RysEF0(Scrtch,              xyz2D,
     &                     nArg,mArg,nRys,neMin,neMax,nfMin,
     &                     nfMax,EFInt,meMin,meMax,mfMin,mfMax,
     &                     PreFct,ixe,ixf,ixye,ixyf,
     &                     nzeMin,nzeMax,nzfMin,nzfMax)
*
            End If
*
         Else
*
*           Here if only one triplet of 2D-integrals
*
*           Contract over roots
*
            If (ixe+ixf+iye+iyf.eq.0) Then
*
               Call RysEF2(                     xyz2D,
     &                     nArg,mArg,nRys,neMin,neMax,nfMin,
     &                     nfMax,EFInt,meMin,meMax,mfMin,mfMax,
     &                     PreFct,ixe,ixf,ixye,ixyf,
     &                     nzeMin,nzeMax,nzfMin,nzfMax)
*
            Else If (ixe+ixf.eq.0) Then
*
               Call RysEF3(xyz2D(1,1,2,iye,iyf),xyz2D,
     &                     nArg,mArg,nRys,neMin,neMax,nfMin,
     &                     nfMax,EFInt,meMin,meMax,mfMin,mfMax,
     &                     PreFct,ixe,ixf,ixye,ixyf,
     &                     nzeMin,nzeMax,nzfMin,nzfMax)
*
            Else If (iye+iyf.eq.0) Then
*
               Call RysEF3(xyz2D(1,1,1,ixe,ixf),xyz2D,
     &                     nArg,mArg,nRys,neMin,neMax,nfMin,
     &                     nfMax,EFInt,meMin,meMax,mfMin,mfMax,
     &                     PreFct,ixe,ixf,ixye,ixyf,
     &                     nzeMin,nzeMax,nzfMin,nzfMax)
*
            Else
*
               Call RysEF4(                     xyz2D,
     &                     nArg,mArg,nRys,neMin,neMax,nfMin,
     &                     nfMax,EFInt,meMin,meMax,mfMin,mfMax,
     &                     PreFct,ixe,ixf,ixye,ixyf,
     &                     nzeMin,nzeMax,nzfMin,nzfMax)
*
            End If
*
         End If
*                                                                      *
************************************************************************
*                                                                      *
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*
#ifdef _DEBUGPRINT_
      Do iab = meMin, meMax
         Do icd = mfMin, mfMax
            Write (Label,'(A,I3,A,I3,A)') ' In RysEF: [', iab, ',0|',
     &                                      icd, ',0]'
            Call RecPrt(Label,' ',EFInt(1,iab,icd),1,nArg)
         End Do
      End Do
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkT_C78d (T2,Tp,Tm,dimbe,dimbepp,addbepp,no)
c
c        this routine do:
c       T2n(be',ga',u,v) <<-
c        C7                    T2+(bega",uv)
c        C8                    T2-(bega",uv)
c        for beGrp=gaGrp, beSGrp=gaSGrp
c        N.B. calc only contributions to be',ga' (not ga',be')
c
        implicit none
        integer dimbe,dimbepp,addbepp,no
        real*8 T2(1:dimbe,1:dimbe,1:no,1:no)
        real*8 Tp(1:dimbepp*(dimbepp+1)/2,1:no*(no+1)/2)
        real*8 Tm(1:dimbepp*(dimbepp-1)/2,1:no*(no-1)/2)
c
c        help variables
        integer u,v,be,ga,uv,bega,bep,gap
        real*8 fact
c
c
c1        Distribute symmetric T2+ on proper possitions
c
        uv=0
        do u=1,no
        do v=1,u
        uv=uv+1
        if (u.eq.v) then
          fact=0.5d0
        else
          fact=1.0d0
        end if
c
c          case be".ne.ga"
          bep=addbepp+1
          do be=2,dimbepp
          bega=be*(be-1)/2
          bep=bep+1
          gap=addbepp
          do ga=1,be-1
          bega=bega+1
          gap=gap+1
c
            T2(bep,gap,u,v)=T2(bep,gap,u,v)+Tp(bega,uv)*fact
            T2(bep,gap,v,u)=T2(bep,gap,v,u)+Tp(bega,uv)*fact
c             T2(gap,bep,u,v)=T2(gap,bep,u,v)+Tp(bega,uv)*fact
c            T2(gap,bep,v,u)=T2(gap,bep,v,u)+Tp(bega,uv)*fact
c
          end do
          end do
c
c          case be=ga
          bep=addbepp
          do be=1,dimbepp
          bega=be*(be+1)/2
          bep=bep+1
c
            T2(bep,bep,u,v)=T2(bep,bep,u,v)+Tp(bega,uv)*fact
            T2(bep,bep,v,u)=T2(bep,bep,v,u)+Tp(bega,uv)*fact
c
          end do
c
        end do
        end do
c
c
c2        Distribute anti-symmetric T2- on proper possitions
c
        uv=0
        do u=2,no
        do v=1,u-1
        uv=uv+1
c
          bep=addbepp+1
          bega=0
          do be=2,dimbepp
          bep=bep+1
          gap=addbepp
          do ga=1,be-1
          bega=bega+1
          gap=gap+1
c
            T2(bep,gap,u,v)=T2(bep,gap,u,v)+Tm(bega,uv)
            T2(bep,gap,v,u)=T2(bep,gap,v,u)-Tm(bega,uv)
c            T2(gap,bep,u,v)=T2(gap,bep,u,v)-Tm(bega,uv)
c            T2(gap,bep,v,u)=T2(gap,bep,v,u)+Tm(bega,uv)
c
          end do
          end do
c
        end do
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Size_SO_block_g(iSD4,nSD,nSO,No_batch)
      Implicit Real*8 (a-h,o-z)
      Integer iSD4(0:nSD,4)
      Logical No_batch
*
      nSO = MemSO2_P(iSD4( 2,1),iSD4( 2,2),iSD4( 2,3),iSD4( 2,4),
     &               iSD4( 7,1),iSD4( 7,2),iSD4( 7,3),iSD4( 7,4))
      No_batch=nSO.eq.0
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHO_FMCSCF(rc,FLT,nForb,nIorb,nAorb,FactXI,DLT,DoActive,POrb,nChM,W_PWXY,CMO,ExFac)
!***********************************************************************
!  Author : F. Aquilante
!
!**************** INACTIVE AO-BASIS FOCK MATRIX ************************
!
! FI(ab) = 2 * sum_J  Lab,J * V(J)  -  sum_Jk  Lka,J * Lkb,J
!
!****************   ACTIVE AO-BASIS FOCK MATRIX ************************
!
! FA(ab) = sum_J  Lab,J * U(J)  -  0.5 * sum_Jw  Lwa,J * Lwb,J
!
!****************   (WA|XY) integrals     ******************************
!
! (WA|XY) = sum_J  L(wa,J) * L(xy,J)
!
!***********************************************************************
!
! V(J) = sum_gd  Lgd,J * DI(gd)
! U(J) = sum_gd  Lgd,J * DA(gd)
!
! a,b,g,d:  AO-index
! k:        MO-index   belonging to (Frozen+Inactive)
! u,w,x,y:  MO-indices belonging to (Active)
!
!***********************************************************************

use ChoArr, only: nDimRS
use ChoSwp, only: InfVec
use Symmetry_Info, only: Mul
use Data_structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, SBA_Type, twxy_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: rc
type(DSBA_Type), intent(inout) :: FLT(2)
integer(kind=iwp), intent(in) :: nForb(8), nIorb(8), nAorb(8), nChM(8)
real(kind=wp), intent(in) :: FactXI, ExFac
type(DSBA_Type), intent(in) :: DLT(2), POrb(3), CMO
logical(kind=iwp), intent(in) :: DoActive
real(kind=wp), intent(_OUT_) :: W_PWXY(*)
#include "chotime.fh"
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: i, iBatch, iCase, iLoc, irc, IREDC, iSkip(8), iSwap, iSyma, iSymb, iSymk, iSymv, iSymw, IVEC2, iVrs, JNUM, &
                     JRED, JRED1, JRED2, jSym, JVC, JVEC, k, kMOs, l, LREAD, LWORK, mTvec, mTvec1, mTvec2, mTvec3, mTvec4, MUSED, &
                     NAch, nAux(8), nAv, nAw, nBatch, nDen, NK, nMOs, nnA(8,8), nPorb(8), nRS, NUMV, nVec, nVrs
real(kind=wp) :: TCC1, TCC2, TCINT1, TCINT2, tcoul(2), TCR1, TCR2, TCR3, TCR4, TCR5, TCR6, TCR7, TCR8, TCX1, TCX2, TCX3, TCX4, &
                 texch(2), tintg(2), TOTCPU, TOTCPU1, TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, tread(2), TWC1, TWC2, TWINT1, TWINT2, &
                 TWR1, TWR2, TWR3, TWR4, TWR5, TWR6, TWR7, TWR8, TWX1, TWX2, TWX3, TWX4, xfac
logical(kind=iwp) :: add, DoRead, DoTraInt
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: Debug
#endif
character(len=50) :: CFmt
type(SBA_Type), target :: Laq(3), Lxy
type(twxy_type) :: Scr
real(kind=wp), allocatable :: Lrs(:,:), Drs(:,:), Frs(:,:)
real(kind=wp), pointer :: VJ(:) => null()
real(kind=wp), parameter :: FactCI = One, FactCA = One, FactXA = -Half
character(len=*), parameter :: SECNAM = 'CHO_FMCSCF'

!***********************************************************************
#ifdef _DEBUGPRINT_
Debug = .false. ! to avoid double printing in CASSCF-debug
#endif
if (ExFac /= One) then
  write(u6,*) 'WARNING: if you are running MCPDFT calculations'
  write(u6,*) 'and end up with this message, you are in trouble.'
  write(u6,*) 'Tweaks are needed!! Please contact'
  write(u6,*) 'Giovanni Li Manni'
  write(u6,*) 'giovannilimanni@gmail.com'
end if
DoRead = .false.
DoTraInt = .false.
IREDC = -1 ! unknown reduced set in core

nDen = 1
if (DoActive) nDen = 2

call CWTIME(TOTCPU1,TOTWALL1) ! start clock for total time

do i=1,2          ! 1 --> CPU   2 --> Wall
  tread(i) = zero ! time read/transform vectors
  tcoul(i) = zero ! time for computing Coulomb
  texch(i) = zero ! time for computing Exchange
  tintg(i) = zero ! time for computing (pu|vx) integrals
end do

! Define MOs in the Primary space
! ( Frozen + Inactive + Active )
! -------------------------------
do i=1,nSym
  nPorb(i) = nForb(i)+nIorb(i)+nAorb(i)
end do

call set_nnA(nSym,nAorb,nnA)

! ==================================================================

iLoc = 3 ! use scratch location in reduced index arrays

! *************** BIG LOOP OVER VECTORS SYMMETRY *******************
do jSym=1,nSym

  if (NumCho(jSym) < 1) cycle

  iCase = 1 ! (wa|xy)
  call Allocate_DT(Scr,nAorb,nBas,JSYM,nSym,iCase)

  ! --- Set up the skipping flags --------
  ! -------------------------------------------------------------
  do i=1,nSym
    k = Mul(i,JSYM)
    iSkip(i) = min(1,nBas(i)*nBas(k)) ! skip Lik vector
    iSkip(i) = iSkip(i)*(nPorb(i)+nChM(i))
  end do
  ! -------------------------------------------------------------

  ! ****************     MEMORY MANAGEMENT SECTION    *****************
  ! --------------------------------------------------------------
  ! compute memory needed to store at least 1 vector of JSYM
  ! and do all the subsequent calculations
  ! --------------------------------------------------------------
  mTvec1 = 0 ! mem for storing the half-transformed vec
  mTvec2 = 0 ! mem for storing the half-transformed vec
  mTvec3 = 0 ! mem for storing the half-transformed vec
  mTvec4 = 0 ! mem for storing the half-transformed vec

  nAux(:) = nForb(:)+nIorb(:)
  do l=1,nSym
    k = Mul(l,JSYM)
    mTvec1 = mTvec1+nBas(k)*nAux(l)
    mTvec2 = mTvec2+nBas(k)*nChM(l)
    mTvec3 = mTvec3+nBas(k)*nAorb(l)
    mTvec4 = mTvec4+nnA(k,l)
  end do

  mTvec = max(mTvec1,mTvec2,mTvec3+mTvec4,1)

  ! ------------------------------------------------------------------
  ! ------------------------------------------------------------------

  JRED1 = InfVec(1,2,jSym)            ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) ! red set of the last vec

  do JRED=JRED1,JRED2

    call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

    if (nVrs == 0) cycle ! no vectors in that (jred,jsym)

    if (nVrs < 0) then
      write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
      call abend()
    end if

    call Cho_X_SetRed(irc,iLoc,JRED) ! set index arrays at iLoc
    if (irc /= 0) then
      write(u6,*) SECNAM//'cho_X_setred non-zero return code.    rc= ',irc
      call abend()
    end if

    IREDC = JRED

    nRS = nDimRS(JSYM,JRED)

    if (JSYM == 1) then

      if (DoActive) then
        call mma_allocate(Drs,nRS,2,Label='Drs')
        call mma_allocate(Frs,nRS,2,Label='Frs')
      else
        call mma_allocate(Drs,nRS,1,Label='Drs')
        call mma_allocate(Frs,nRS,1,Label='Frs')
      end if

    end if

    call mma_maxDBLE(LWORK)

    nVec = min(LWORK/(nRS+mTvec),nVrs)

    if (nVec < 1) then
      write(u6,*) SECNAM//': Insufficient memory for batch'
      write(u6,*) 'LWORK= ',LWORK
      write(u6,*) 'min. mem. need= ',nRS+mTvec
      write(u6,*) 'reading ',nRS,' and transforming to ',mTvec
      write(u6,*) 'of jsym= ',jsym,' and JRED= ',JRED
      rc = 33
      call Abend()
      nBatch = -9999 ! dummy assignment
    end if

    LREAD = nRS*nVec

    call mma_allocate(Lrs,nRS,nVec,Label='Lrs')

    if (JSYM == 1) then
      ! Transform the density to reduced storage
      add = .false.
      call swap_full2rs(irc,iLoc,nRS,nDen,JSYM,DLT,Drs,add)
    end if

    ! BATCH over the vectors ----------------------------

    nBatch = (nVrs-1)/nVec+1

    do iBatch=1,nBatch
      iSwap = 2 ! LpJ,b are returned
      call Allocate_DT(Laq(1),nAux,nBas,nVec,JSYM,nSym,iSwap)
      if (iBatch == nBatch) then
        JNUM = nVrs-nVec*(nBatch-1)
      else
        JNUM = nVec
      end if

      JVEC = nVec*(iBatch-1)+iVrs
      IVEC2 = JVEC-1+JNUM

      call CWTIME(TCR1,TWR1)

      call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

      if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
        rc = 77
        return
      end if

      call CWTIME(TCR2,TWR2)
      tread(1) = tread(1)+(TCR2-TCR1)
      tread(2) = tread(2)+(TWR2-TWR1)

      if (JSYM == 1) then

        ! ************ INACTIVE COULOMB CONTRIBUTION  ****************
        !
        ! Contraction with the density matrix
        ! -----------------------------------
        ! V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * DI(rs)
        !==========================================================

        call CWTIME(TCC1,TWC1)

        VJ(1:JNUM) => Laq(1)%A0(1:JNUM)

        call DGEMV_('T',nRS,JNUM,ONE,Lrs,nRS,Drs(:,1),1,ZERO,VJ,1)

        ! FI(rs){#J} <- FI(rs){#J} + FactCI * sum_J L(rs,{#J})*V{#J}
        !=============================================================

        xfac = real(min(jVec-iVrs,1),kind=wp)

        call DGEMV_('N',nRS,JNUM,FactCI,Lrs,nRS,VJ,1,xfac,Frs(:,1),1)

        if (DoActive) then
          ! ************ ACTIVE COULOMB CONTRIBUTION  ****************
          !
          ! Computing the intermediate vector V(J)
          ! -----------------------------------
          ! U{#J} <- U{#J}  +  sum_rs  L(rs,{#J}) * DA(rs)
          !==========================================================

          call DGEMV_('T',nRS,JNUM,ONE,Lrs,nRS,Drs(:,2),1,ZERO,VJ,1)

          ! FA(rs){#J} <- FA(rs){#J} + FactCA * sum_J L(rs,{#J})*U{#J}
          !===========================================================

          xfac = real(min(jVec-iVrs,1),kind=wp)

          call DGEMV_('N',nRS,JNUM,FactCA,Lrs,nRS,VJ,1,xfac,Frs(:,2),1)

        end if

        call CWTIME(TCC2,TWC2)
        tcoul(1) = tcoul(1)+(TCC2-TCC1)
        tcoul(2) = tcoul(2)+(TWC2-TWC1)

        VJ => null()

      end if  ! Coulomb (jsym=1)

      ! ************ BEGIN EXCHANGE CONTRIBUTIONS  ****************

      ! ***************** INACTIVE HALF-TRANSFORMATION  ****************

      kMOs = 1  ! inactive MOs
      nMOs = 1

      call CWTIME(TCR3,TWR3)

      call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,POrb,Laq,DoRead)

      call CWTIME(TCR4,TWR4)
      tread(1) = tread(1)+(TCR4-TCR3)
      tread(2) = tread(2)+(TWR4-TWR3)

      if (irc /= 0) then
        rc = irc
        return
      end if

      call CWTIME(TCX1,TWX1)

      do iSyma=1,nSym

        iSymk = Mul(JSYM,iSyma)

        ! ---------------------------------------------------------------------
        ! *** Compute only the LT part of the InActive exchange matrix ********
        !
        ! FI(ab) = FI(ab) + FactXI * sum_Jk  LkJ,a * LkJ,b
        ! ---------------------------------------------------------------------
        NK = nForb(iSymk)+nIorb(iSymk)

        if (iSkip(iSymk)*NK /= 0) then

          call DGEMM_TRI('T','N',nBas(iSyma),nBas(iSyma),NK*JNUM,FactXI,Laq(1)%SB(iSymk)%A3,NK*JNUM,Laq(1)%SB(iSymk)%A3,NK*JNUM, &
                         One,FLT(1)%SB(iSyma)%A1,nBas(iSyma))

          !write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYMA
          !call TRIPRT('FI: ',' ',FLT(1)%SB(iSyma)%A1,nBas(iSyma))

        end if

        ! --------------------------------------------------------------------
      end do  !loop over MOs symmetries

      call CWTIME(TCX2,TWX2)
      texch(1) = texch(1)+(TCX2-TCX1)
      texch(2) = texch(2)+(TWX2-TWX1)

      call Deallocate_DT(Laq(1))

      if (DoActive) then
        iSwap = 2  ! LxJ,b are returned
        call Allocate_DT(Laq(2),nChM,nBas,nVec,JSYM,nSym,iSwap)
        ! *********************** "CHOLESKY" HALF-TRANSFORMATION  ****************
        ! ----------------------------------------------------------------
        ! Using "Cholesky MOs" obtained by cholesky decomposing DA
        ! ----------------------------------------------------------------

        call CWTIME(TCR5,TWR5)

        kMOs = 2 ! Cholesky MOs
        nMOs = 2

        call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,POrb,Laq,DoRead)

        call CWTIME(TCR6,TWR6)
        tread(1) = tread(1)+(TCR6-TCR5)
        tread(2) = tread(2)+(TWR6-TWR5)

        if (irc /= 0) then
          rc = irc
          return
        end if

        call CWTIME(TCX3,TWX3)

        ! ---------------------------------------------------------------------
        ! *** Compute only the LT part of the Active exchange matrix **********
        !
        !     FA(ab) = FA(ab) + FactXA * sum_wJ  LwJ,a * LwJ,b
        ! ---------------------------------------------------------------------
        do iSyma=1,nSym

          iSymw = Mul(JSYM,iSyma)

          NAch = nChM(iSymw)

          if (iSkip(iSymw)*NAch /= 0) then

            call DGEMM_TRI('T','N',nBas(iSyma),nBas(iSyma),NAch*JNUM,FactXA,Laq(2)%SB(iSymw)%A3,NAch*JNUM,Laq(2)%SB(iSymw)%A3, &
                           NAch*JNUM,One,FLT(2)%SB(iSyma)%A1,nBas(iSyma))

            !write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYMA
            !call TRIPRT('FA: ',' ',FLT(2)%SB(iSyma)%A1,nBas(iSyma))

          end if

          ! --------------------------------------------------------------------
        end do ! loop over MOs symmetries

        call CWTIME(TCX4,TWX4)
        texch(1) = texch(1)+(TCX4-TCX3)
        texch(2) = texch(2)+(TWX4-TWX3)

        call Deallocate_DT(Laq(2))
      end if ! Do Active Exchange
      ! ************  END EXCHANGE CONTRIBUTIONS  ****************

      ! ----------------------------------------------------------------
      ! First half Active transformation  Lvb,J = sum_a  C(v,a) * Lab,J
      ! ----------------------------------------------------------------
      ! Lvw,J, LT-storage for the diagonal symmetry blocks
      iSwap = 4
      call Allocate_DT(Lxy,nAorb,nAorb,nVec,JSYM,nSym,iSwap)

      iSwap = 0 ! Lvb,J are returned
      call Allocate_DT(Laq(3),nAorb,nBas,nVec,JSYM,nSym,iSwap)

      call CWTIME(TCR7,TWR7)

      kMOs = 3 ! Active MOs
      nMOs = 3 ! Active MOs

      call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,POrb,Laq,DoRead)

      if (irc /= 0) then
        rc = irc
        return
      end if

      ! ----------------------------------------------------------------
      ! Active-Active transformation  Lvw,J = sum_b  Lvb,J * C(w,b)
      ! ----------------------------------------------------------------
      if (JSYM == 1) then ! Lvw,J in LT-storage

        do iSyma=1,nSym

          NAv = nAorb(iSyma)

          if (NAv /= 0) then

            do JVC=1,JNUM

              call DGEMM_Tri('N','T',NAv,NAv,nBas(iSyma),One,Laq(3)%SB(iSyma)%A3(:,:,JVC),NAv,POrb(3)%SB(iSyma)%A2,NAv,Zero, &
                             Lxy%SB(iSyma)%A2(:,JVC),NAv)

            end do

          end if

        end do

      else

        ! ----------------------------------------------------------------
        ! Active-Active transformation  Lvw,J = sum_b  Lvb,J * C(w,b)
        ! ----------------------------------------------------------------
        do iSymb=1,nSym

          iSymv = Mul(JSYM,iSymb)
          NAv = nAorb(iSymv)
          NAw = nAorb(iSymb) ! iSymb=iSymw

          if ((NAv*NAw /= 0) .and. (iSymv < iSymb)) then

            do JVC=1,JNUM

              call DGEMM_('N','T',NAv,NAw,nBas(iSymb),One,Laq(3)%SB(iSymv)%A3(:,:,JVC),NAv,POrb(3)%SB(iSymb)%A2,NAw,Zero, &
                          Lxy%SB(iSymv)%A2(:,JVC),NAv)

            end do

          end if

        end do

      end if ! jSym >=< 1

      call CWTIME(TCR8,TWR8)
      tread(1) = tread(1)+(TCR8-TCR7)
      tread(2) = tread(2)+(TWR8-TWR7)

      ! *************** EVALUATION OF THE (WA|XY) INTEGRALS ***********

      call CWTIME(TCINT1,TWINT1)

      DoTraInt = (JRED == JRED2) .and. (iBatch == nBatch)

      call CHO_eval_waxy(irc,Scr,Laq(3),Lxy,W_PWXY,nAorb,JSYM,JNUM,DoTraInt,CMO)

      call CWTIME(TCINT2,TWINT2)
      tintg(1) = tintg(1)+(TCINT2-TCINT1)
      tintg(2) = tintg(2)+(TWINT2-TWINT1)

      if (irc /= 0) then
        rc = irc
        return
      end if

      ! --------------------------------------------------------------------
      ! --------------------------------------------------------------------
      call Deallocate_DT(Lxy)
      call Deallocate_DT(Laq(3))

    end do  ! end batch loop

    if (JSYM == 1) then
      ! backtransform fock matrix in full storage
      add = .true.
      call swap_rs2full(irc,iLoc,nRS,nDen,JSYM,FLT,Frs,add)
    end if

    ! free memory
    call mma_deallocate(Lrs)

    if (JSYM == 1) then
      call mma_deallocate(Drs)
      call mma_deallocate(Frs)
    end if

  end do ! loop over red sets

  call Deallocate_DT(Scr)

end do ! loop over JSYM

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky CASSCF timing from '//SECNAM
  write(u6,CFmt) '----------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Fock matrix construction        CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ/TRANSFORM VECTORS                    ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COULOMB                                   ',tcoul(1),tcoul(2)
  write(u6,'(2x,A26,2f10.2)') 'EXCHANGE                                  ',texch(1),texch(2)
  write(u6,'(2x,A26,2f10.2)') '(WA|XY) INTEGRALS                         ',tintg(1),tintg(2)
  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

! Print the Fock-matrix
#ifdef _DEBUGPRINT_
if (Debug) then ! to avoid double printing in CASSCF-debug

  write(u6,'(6X,A)') 'TEST PRINT FROM '//SECNAM
  write(u6,'(6X,A)')
  write(u6,'(6X,A)') '***** INACTIVE FOCK MATRIX ***** '
  do ISYM=1,NSYM
    if (NBAS(ISYM) > 0) then
      write(u6,'(6X,A)')
      write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
      call TRIPRT('','',FLT(1)%SB(ISYM)%A1,NBAS(ISYM))
    end if
  end do
  if (DoActive) then
    write(u6,'(6X,A)')
    write(u6,'(6X,A)') '***** ACTIVE FOCK MATRIX ***** '
    do ISYM=1,NSYM
      if (NBAS(ISYM) > 0) then
        write(u6,'(6X,A)')
        write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
        call TRIPRT('','',FLT(2)%SB(ISYM)%A1,NBAS(ISYM))
      end if
    end do
  end if

end if
#endif

rc = 0

return

end subroutine CHO_FMCSCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_PRTHEAD(SKIPH)
C
C     Purpose: print Cholesky header.
C
#include "implicit.fh"
      LOGICAL SKIPH
#include "cholesky.fh"
#include "chosubscr.fh"
#include "choprint.fh"
#include "chosimri.fh"

      PARAMETER (NADRMODE = 2, NALG = 6)

      CHARACTER*12 ALGORITHM(0:NALG)
      CHARACTER*13 ADRMODE(0:NADRMODE)
      CHARACTER*15 USED(2)

      DATA ALGORITHM /'     unknown',
     &                '    one-step','    two-step','       naive',
     &                'par one-step','par two-step','   par naive'/
      DATA ADRMODE /'      unknown','   word addr.','  direct acc.'/
      DATA USED /'(screening off)','(screening on) '/

      IF (LUPRI .LT. 1) THEN
         CALL CHO_QUIT('LUPRI undefined in Cholesky decomposition',101)
      END IF

      IF (.NOT.SKIPH) THEN
         WRITE(LUPRI,'(//,80A)') ('*', I=1,80)
         WRITE(LUPRI,'(A,78X,A)') ('*',I=1,2)
         WRITE(LUPRI,'(A,10X,A,10X,A)')
     & '*','Cholesky Decomposition of Two-Electron Repulsion Integrals',
     &   '*'
         WRITE(LUPRI,'(A,78X,A)') ('*',I=1,2)
         WRITE(LUPRI,'(80A)') ('*', I=1,80)
         WRITE(LUPRI,*)
         WRITE(LUPRI,*)

         IF (RSTDIA) THEN
            WRITE(LUPRI,'(/,A)')
     &      '***** Using Restart Integral Diagonal *****'
         END IF
         IF (RSTCHO) THEN
            IF (RSTDIA) THEN
               WRITE(LUPRI,'(A)')
     &         '***** Using Restart Cholesky Vectors  *****'
            ELSE
               WRITE(LUPRI,'(/,A)')
     &         '***** Using Restart Cholesky Vectors  *****'
            END IF
         END IF
      END IF

      IF (IPRINT .GE. INF_INIT) THEN
         IF (SCDIAG) THEN
            IUSE = 2
         ELSE
            IUSE = 1
         END IF
         IF (CHO_DECALG.LT.1 .OR. CHO_DECALG.GT.NALG) THEN
            IALG = 0
         ELSE
            IALG = CHO_DECALG
         END IF
         IF (.NOT. SKIPH) CALL CHO_HEAD('Configuration','=',80,LUPRI)
         WRITE(LUPRI,'(A,A)')
     &   'Decomposition algorithm                   : ',ALGORITHM(IALG)
         IF (CHO_1CENTER) THEN
            WRITE(LUPRI,'(A)')
     &      '1-center decomposition                    :          Yes'
            IF (CHO_NO2CENTER) THEN
               WRITE(LUPRI,'(A)')
     &        'Exclusion of 2-center diagonals           :          Yes'
            ELSE
               WRITE(LUPRI,'(A)')
     &        'Exclusion of 2-center diagonals           :           No'
            END IF
            IF (CHO_SIMRI) THEN
               WRITE(LUPRI,'(A,1P,D12.4)')
     &         'Simulation of RI, threshold               : ',THR_SIMRI
            END IF
         ELSE
            WRITE(LUPRI,'(A)')
     &      '1-center decomposition                    :           No'
         END IF
         WRITE(LUPRI,'(A,1P,D12.4)')
     &   'Decomposition threshold                   : ',THRCOM
         IF (CHO_PRESCREEN) THEN
            WRITE(LUPRI,'(A,1P,D12.4)')
     &      'Initial diagonal prescreening             : ',THR_PRESCREEN
         END IF
         WRITE(LUPRI,'(A,1P,D12.4)')
     &   'Initial diagonal screening                : ',THRDIAG
         WRITE(LUPRI,'(A,1P,D12.4,1X,A)')
     &   'First  screening damping                  : ',DAMP(1),
     &                                                  USED(IUSE)
         WRITE(LUPRI,'(A,1P,D12.4,1X,A)')
     &   'Second screening damping                  : ',DAMP(2),
     &                                                  USED(IUSE)
         IF (CHO_USEABS) THEN
            WRITE(LUPRI,'(A)')
     &      'Absolute values used in diagonal screening:          Yes'
         ELSE
            WRITE(LUPRI,'(A)')
     &      'Absolute values used in diagonal screening:           No'
         END IF
         WRITE(LUPRI,'(A,1P,D12.4)')
     &   'Threshold for negative  diagonal zeroing  : ',THRNEG
         WRITE(LUPRI,'(A,1P,D12.4)')
     &   'Threshold for warning about neg. diagonal : ',WARNEG
         WRITE(LUPRI,'(A,1P,D12.4)')
     &   'Threshold for too negative diagonal       : ',TOONEG
         WRITE(LUPRI,'(A,1P,D12.4)')
     &   'Span factor                               : ',SPAN
         WRITE(LUPRI,'(A,I12)')
     &   'Max. #Cholesky vectors per symmetry       : ',MAXVEC
         WRITE(LUPRI,'(A,I12)')
     &   'Max. #reduced sets (i.e., integral passes): ',MAXRED
         WRITE(LUPRI,'(A,I12)')
     &   'Min. #qualified required for decomposition: ',MINQUAL
         WRITE(LUPRI,'(A,I12)')
     &   'Max. #qualified per symmetry              : ',MAXQUAL
         IF (N2_QUAL .EQ. 0) THEN
            XF = -9.99999999D15
         ELSE
            X1 = DBLE(N1_QUAL)
            X2 = DBLE(N2_QUAL)
            XF = 1.0D2*X1/X2
         END IF
         WRITE(LUPRI,'(A,5X,F7.4,A)')
     &   'Max. memory fraction for qualified columns: ',XF,'%'
         IF (MXSHPR .EQ. 0) THEN
            WRITE(LUPRI,'(A)')
     &      'Max. #shell pair allowed per integral pass:      generic'
         ELSE
            WRITE(LUPRI,'(A,I12)')
     &      'Max. #shell pair allowed per integral pass: ',MXSHPR
         END IF
         IF (IALQUA .EQ. 0) THEN
            WRITE(LUPRI,'(A)')
     &      'Qualification algorithm                   : dalton-style'
         ELSE IF (IALQUA .EQ. 1) THEN
            WRITE(LUPRI,'(A)')
     &      'Qualification algorithm                   :   sequential'
         ELSE
            WRITE(LUPRI,'(A)')
     &      'Qualification algorithm                   :      sorting'
         END IF
         IF (CHO_IOVEC .EQ. 1) THEN
            WRITE(LUPRI,'(A)')
     &      'Algorithm for Cholesky vector I/O         :  rs2rs/batch'
         ELSE IF (CHO_IOVEC .EQ. 2) THEN
            WRITE(LUPRI,'(A)')
     &      'Algorithm for Cholesky vector I/O         : buffer/rs2rs'
         ELSE IF (CHO_IOVEC .EQ. 3) THEN
            WRITE(LUPRI,'(A)')
     &      'Algorithm for Cholesky vector I/O         : lrgbuf/rs2rs'
         ELSE IF (CHO_IOVEC .EQ. 4) THEN
            WRITE(LUPRI,'(A)')
     &      'Algorithm for Cholesky vector I/O         : fxdbuf/rs2rs'
         ELSE
            WRITE(LUPRI,'(A)')
     &      'Algorithm for Cholesky vector I/O         : copy via rs1'
         END IF
         IADRMODE = MAX(MIN(CHO_ADRVEC,NADRMODE),0)
         WRITE(LUPRI,'(A,A13)')
     &   'Address mode for Cholesky vector I/O      : ',
     &   ADRMODE(IADRMODE)
         XF2 = 1.0D2*FRAC_CHVBUF
         WRITE(LUPRI,'(A,5X,F7.4,A)')
     &   'Memory fraction used as vector buffer     : ',XF2,'%'
         IF (CHO_SSCREEN) THEN
            WRITE(LUPRI,'(A,1P,D12.4)')
     &      'Screening threshold for vector subtraction: ',SSTAU
         END IF
         IF (CHO_DECALG .EQ. 5) THEN
            WRITE(LUPRI,'(A,I12)')
     &      'Block size (blocked Z vector array)       : ',BLOCKSIZE
         END IF
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_INIT(SKIP_PRESCREEN)
C
C     Purpose: initialization of Cholesky decomposition in MOLCAS.
C
      use index_arrays, only: iSO2Sh
      use ChoArr, only: iSOShl, iBasSh, nBasSh, nBstSh, iSP2F, iShlSO,
     &                  iShP2RS, iShP2Q
#include "implicit.fh"
      LOGICAL SKIP_PRESCREEN
#include "cholesky.fh"
#include "choorb.fh"
#include "stdalloc.fh"

      CHARACTER*12 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_INIT')

c     INTEGER  CHO_ISAO
c     EXTERNAL CHO_ISAO
c     INTEGER  CHO_ISAOSH
c     EXTERNAL CHO_ISAOSH

C     Check that the number of shells is within limits.
C     -------------------------------------------------

      IF (NSHELL .LT. 1) THEN
         WRITE(LUPRI,*) 'NSHELL out of bounds: ',NSHELL
         CALL CHO_QUIT('NSHELL out of bounds in '//SECNAM,102)
      END IF

C     Compute total #shell pair.
C     --------------------------

      NNSHL_TOT = NSHELL*(NSHELL + 1)/2
      IF (NNSHL_TOT .LT. 1) THEN
         WRITE(LUPRI,*)
     &   'NNSHL_TOT=NSHELL*(NSHELL+1)/2 is non-positive: ',
     &   NNSHL_TOT
         WRITE(LUPRI,*) 'Integer overflow ?'
         CALL CHO_QUIT('NNSHL_TOT out of bounds in '//SECNAM,102)
      END IF

C     Compute contributing #shell pair by prescreening (if requested).
C     iSP2F(k): returns global shell pair of contributing shell pair k.
C               (Allocated and defined in CHO_DIAPS.)
C     -----------------------------------------------------------------

      IF (SKIP_PRESCREEN) THEN
         IF (NNSHL.LT.1 .OR. NNSHL.GT.NNSHL_TOT) THEN
            WRITE(LUPRI,*) SECNAM,': flag SKIP_PRESCREEN is ',
     &                     SKIP_PRESCREEN
            WRITE(LUPRI,*) 'NNSHL is out-of-bounds: ',NNSHL
            WRITE(LUPRI,*) 'Condition: 0 < NNSHL < ',NNSHL_TOT
            CALL CHO_QUIT('Initialization error in '//SECNAM,102)
         END IF
         IF (SIZE(iSP2F) .NE. NNSHL) THEN
            WRITE(LUPRI,*) SECNAM,': flag SKIP_PRESCREEN is ',
     &                     SKIP_PRESCREEN
            WRITE(LUPRI,*) 'NNSHL is: ',NNSHL
            WRITE(LUPRI,*) 'SIZE(iSP2F) must be equal to NNSHL, ',
     &                     'SIZE(iSP2F)= ',SIZE(iSP2F)
            CALL CHO_QUIT('Initialization error in '//SECNAM,102)
         END IF
      ELSE
         CALL CHO_DIASP()
      END IF

C     Get the number of symmetries.
C     -----------------------------

      CALL GET_ISCALAR('nSym',NSYM)  ! Get # irreps.
      IF ((NSYM.LT.1) .OR. (NSYM.GT.8)) THEN
         WRITE(LUPRI,*) 'NSYM out of bounds: ',NSYM
         CALL CHO_QUIT('NSYM out of bounds in '//SECNAM,102)
      END IF

C     NBAS(ISYM): # basis functions (SOs) in symmetry ISYM
C     IBAS(ISYM): offset to basis functions in symmetry ISYM
C     NBAST     : total number of basis functions
C     ------------------------------------------------------

      CALL GET_IARRAY('nBas',NBAS,NSYM)
      IBAS(1) = 0
      NBAST   = NBAS(1)
      DO ISYM = 2,NSYM
         IBAS(ISYM) = NBAST
         NBAST = NBAST + NBAS(ISYM)
      END DO
      IF (NBAST .LT. 1) THEN
         WRITE(LUPRI,*) 'NBAST out of bounds: ',NBAST
         CALL CHO_QUIT('NBAST out of bounds in '//SECNAM,102)
      END IF

C     Allocate shell based index arrays.
C     ----------------------------------

      Call mma_allocate(iBasSh,nSym,nShell,Label='iBasSh')
      Call mma_allocate(nBasSh,nSym,nShell,Label='nBasSh')
      Call mma_allocate(nBstSh,nShell,Label='nBstSh')

C     ISOSHL(I): shell to which SO I belongs
C     --------------------------------------

      Call mma_allocate(iSOShl,NBAST,Label='iSOShl')
      DO ISYM = 1,NSYM
         DO IA = 1,NBAS(ISYM)
            I = IBAS(ISYM) + IA
            iSOShl(I) = ISO2SH(I)
         END DO
      END DO

C     NBASSH(ISYM,ISHL): total dimension of shell ISHL, sym. ISYM
C     NBSTSH(ISHL): total dimension of shell ISHL
C     MXORSH      : max. shell dimension
C     -----------------------------------------------------------

      CALL CHO_SETSH(IBASSH,NBASSH,NBSTSH,
     &               IBAS,NBAS,ISOSHL,NSYM,NSHELL,NBAST)

      MXORSH = NBSTSH(1)
      DO ISHL = 2,NSHELL
         MXORSH = MAX(MXORSH,NBSTSH(ISHL))
      END DO

C     MX2SH: max. dimension of contributing shell pair.
C     -------------------------------------------------

      MX2SH = -1
      DO IJSHL = 1,NNSHL
         IJ = iSP2F(IJSHL)
         CALL CHO_INVPCK(IJ,I,J,.TRUE.)
         IF (I .EQ. J) THEN
            NUMIJ = NBSTSH(I)*(NBSTSH(I) + 1)/2
         ELSE
            NUMIJ = NBSTSH(I)*NBSTSH(J)
         END IF
         MX2SH = MAX(MX2SH,NUMIJ)
      END DO
      IF (MX2SH .LT. 1) THEN
         WRITE(LUPRI,*) 'Max. shell pair dimension non-positive: ',
     &                  MX2SH
         CALL CHO_QUIT('Initialization problem in '//SECNAM,102)
      END IF

C     If needed, allocate memory for extracting qualified columns
C     directly in reduced set from Seward.
C     -----------------------------------------------------------

      IF (IFCSEW .EQ. 2) THEN
         Call mma_allocate(iShP2RS,2,Mx2Sh,Label='iShP2RS')
         Call mma_allocate(iShP2Q ,2,Mx2Sh,Label='iShP2Q ')
      END IF

C     ISHLSO(I): index of SO I within its shell
C     -----------------------------------------

      Call mma_allocate(iShlSO,nBasT,Label='iShlSO')
      CALL CHO_SETSH2(iShlSO,iSOShl,NBSTSH,NBAST,NSHELL)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine chop1_cvb()

use casvb_global, only: absym, i1alf, i1bet, i1c, ia12ind, iafrm, iapr, iapr1, iato, ib12ind, ibfrm, ibpr, ibpr1, ibto, icfrm, &
                        iconfs, icto, idetvb, ixapr, ixapr1, ixbpr, ixbpr1, n1a, n1b, nalf, nalf_fr, nam1, naprodvb, nbet, &
                        nbet_fr, nbm1, nbprodvb, ncivb, nconf, nda, nda_fr, ndb, ndb_fr, ndet, ndetvb, ndetvb_fr, nel, nfrag, noe, &
                        norb, npvb, phato, phbto, phcto, release
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, ifrag, ndavb, ndbvb

if (release(1)) then
  call mma_deallocate(i1alf)
  call mma_deallocate(iafrm)
  call mma_deallocate(iato)
  call mma_deallocate(phato)
  call mma_deallocate(i1c,safe='*')
  call mma_deallocate(icfrm,safe='*')
  call mma_deallocate(icto,safe='*')
  call mma_deallocate(phcto,safe='*')
  call mma_deallocate(iapr)
  call mma_deallocate(ixapr)
  call mma_deallocate(ibpr)
  call mma_deallocate(ixbpr)
  call mma_deallocate(iconfs)
  call mma_deallocate(idetvb)
  call mma_deallocate(ia12ind)
  call mma_deallocate(ib12ind)
  call mma_deallocate(iapr1)
  call mma_deallocate(ixapr1)
  call mma_deallocate(ibpr1)
  call mma_deallocate(ixbpr1)
  nullify(i1bet,ibfrm,ibto,phbto)
end if
release(1) = .true.
release(2) = .false.

! Dimensions
call icomb_cvb(norb,nalf,nda)
call icomb_cvb(norb,nbet,ndb)
!FIXME: There's some inconsistency in the *_fr indices,
!       the fragment index is supposed to be the second one
do i=1,nfrag
  call icomb_cvb(norb,nalf_fr(i,1),nda_fr(i,1))
  call icomb_cvb(norb,nbet_fr(i,1),ndb_fr(i,1))
end do
call icomb_cvb(norb-1,nalf-1,n1a)
call icomb_cvb(norb-1,nbet-1,n1b)
call icomb_cvb(norb,nalf-1,nam1)
call icomb_cvb(norb,nbet-1,nbm1)
ndet = nda*ndb
! Symmetry of determinant strings:
call getnci_cvb(ncivb,nel,nalf-nbet,0)
! Identical indexing arrays may share memory:
call mma_allocate(i1alf,n1a,norb,label='i1alf')
call mma_allocate(iafrm,norb,nda,label='iafrm')
call mma_allocate(iato,[1,norb],[0,nam1],label='iato')
call mma_allocate(phato,norb,nam1,label='phato')
if (absym(4)) then
  i1bet => i1alf
  ibfrm => iafrm
  ibto => iato
  phbto => phato
else
  call mma_allocate(i1c,n1b,norb,label='i1c')
  call mma_allocate(icfrm,norb,ndb,label='icfrm')
  call mma_allocate(icto,[1,norb],[0,nbm1],label='icto')
  call mma_allocate(phcto,norb,nbm1,label='phcto')
  i1bet => i1c
  ibfrm => icfrm
  ibto => icto
  phbto => phcto
end if

! Determinant dimensioning for VB wavefunction:
ndavb = 0
ndbvb = 0
naprodvb = 1
nbprodvb = 1
npvb = 1
do ifrag=1,nfrag
  ndavb = ndavb+nda_fr(1,ifrag)+1
  ndbvb = ndbvb+ndb_fr(1,ifrag)+1
  naprodvb = naprodvb*nda_fr(1,ifrag)
  nbprodvb = nbprodvb*ndb_fr(1,ifrag)
  npvb = npvb*ndetvb_fr(ifrag)
end do
if (nfrag <= 1) then
  naprodvb = 0
  nbprodvb = 0
end if

call mma_allocate(iapr,npvb,label='iapr')
call mma_allocate(ixapr,nda+1,label='ixapr')
call mma_allocate(ibpr,npvb,label='ibpr')
call mma_allocate(ixbpr,ndb+1,label='ixbpr')
call mma_allocate(iconfs,noe,nconf,label='iconfs')
call mma_allocate(idetvb,ndetvb,label='idetvb')
call mma_allocate(ia12ind,naprodvb,label='ia12ind')
call mma_allocate(ib12ind,nbprodvb,label='ib12ind')
call mma_allocate(iapr1,ndetvb,label='iapr1')
call mma_allocate(ixapr1,ndavb,label='ixapr1')
call mma_allocate(ibpr1,ndetvb,label='ibpr1')
call mma_allocate(ixbpr1,ndbvb,label='ixbpr1')

return

end subroutine chop1_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRSYM(A,MATDIM)
C PRINT LOWER HALF OF A SYMMETRIC MATRIX OF DIMENSION MATDIM.
C THE LOWER HALF OF THE MATRIX IS SUPPOSED TO BE IN VECTOR A.
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*)
      JSTART=1
      JSTOP=0
      DO 100 I=1,MATDIM
        JSTART=JSTART+I-1
        JSTOP=JSTOP +I
        WRITE(6,1010) I,(A(J),J=JSTART,JSTOP)
  100 CONTINUE
      RETURN
 1010 FORMAT(1H0,2X,I3,5(E14.7),/,(1H ,5X,5(E14.7)))
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Ignacio Fdez. Galvan                             *
*               2016, Roland Lindh                                     *
************************************************************************
*  Process_Weights
*
*> @brief
*>   Process and store the weights used for alignment
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Process the weights according to the `WEIG` option in `GATEWAY`.
*> These weights are used in alignment and in the "sphere" constraint.
*> The list of weights is stored in the runfile, first the symmetry-unique
*> atoms and then the symmetric images, in the manner of ::Expand_Coor.
*>
*> @param[in] iPrint Print level
************************************************************************
      SUBROUTINE Process_Weights(iPrint)
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      IMPLICIT REAL*8 (a-h,o-z)
#include "constants2.fh"
#include "real.fh"
#include "stdalloc.fh"
      Character(LEN=512) Align_Weights
      LOGICAL Small
      PARAMETER ( thr=1.0d-6 )
      REAL*8, DIMENSION(:), ALLOCATABLE :: W

      Call Get_cArray('Align_Weights',Align_Weights,512)
*
*---- Count the total and symmetry-unique number of atoms
      nAt=0
      nSymAt=0
      ndc=0
      DO i=1,nCnttp
        DO j=1,dbsc(i)%nCntr
          ndc=ndc+1
          IF (.NOT.(dbsc(i)%pChrg.OR.dbsc(i)%Frag.OR.dbsc(i)%Aux)) THEN
            nAt=nAt+nIrrep/dc(ndc)%nStab
            nSymAt=nSymAt+1
          END IF
        END DO
      END DO
      CALL mma_allocate(W,nAt,label='W')
*
*---- By default, all weights are 1
      call dcopy_(nAt,[One],0,W,1)
*
      IF (Align_Weights(1:4).EQ.'MASS') Then
*---- Set the weights to the mass of each atom
        j=1
        DO i=1,nCnttp
          IF (.NOT.(dbsc(i)%pChrg.OR.dbsc(i)%Frag.OR.dbsc(i)%Aux)) THEN
            DO iCnt=1,dbsc(i)%nCntr
              W(j)=dbsc(i)%CntMass/UTOAU
              j=j+1
            END DO
          END IF
        END DO
      ELSE IF (Align_Weights(1:5).EQ.'HEAVY') THEN
*---- Set the the weight to 1 for heavy atoms, 0 for hydrogens
        j=1
        DO i=1,nCnttp
          IF (.NOT.(dbsc(i)%pChrg.OR.dbsc(i)%Frag.OR.dbsc(i)%Aux)) THEN
            DO iCnt=1,dbsc(i)%nCntr
              IF (dbsc(i)%AtmNr.LE.1) W(j)=Zero
              j=j+1
            END DO
          END IF
        END DO
      ELSE IF (Align_Weights(1:5).EQ.'EQUAL') THEN
*---- EQUAL is already the default: 1 for all
        CONTINUE
      ELSE
*---- Read the weights from the input line
        READ(Align_Weights,*,IOSTAT=iErr) (W(i),i=1,nAt)
        IF (iErr.GT.0) THEN
          CALL WarningMessage(2,'Unable to read data from WEIG')
          CALL Quit_OnUserError()
        END IF
      END IF
*
*---- Unfold the symmetry
      iSymAt=1
      iAt=1+nSymAt
      ndc=0
      DO i=1,nCnttp
        DO j=1,dbsc(i)%ncntr
          ndc=ndc+1
          IF (.NOT.(dbsc(i)%pChrg.OR.dbsc(i)%Frag.OR.dbsc(i)%Aux)) THEN
            DO k=1,nIrrep/dc(ndc)%nStab-1
              W(iAt)=W(iSymAt)
              iAt=iAt+1
            END DO
            iSymAt=iSymAt+1
          END IF
        END DO
      END DO
*
*---- Check for zero total weight
      wTot=Zero
      DO i=1,nAt
        wTot=wTot+W(i)
      END DO
      IF (wTot.LT.thr) THEN
        CALL WarningMessage(1,
     &       'Total weight too small. Setting equal weights.')
        DO i=1,nAt
          W(i)=One
        END DO
      END IF
*---- Prevent zero weights, it could break the "sphere" constraint
*     (a value between 1e-6 and 1e-1 can still be used)
      Small=.FALSE.
      DO i=1,nAt
        IF (W(i).LT.thr) THEN
          W(i)=1.0d-1
          Small=.TRUE.
        END IF
      END DO
      IF (iPrint.GE.6) THEN
        IF (Small) THEN
          CALL WarningMessage(1,
     &         'Small weights were increased to avoid problems with'//
     &         ' constraints.')
        END IF
        CALL RecPrt('Weights used for alignment and distance',' ',
     &              W,nAt,1)
        WRITE(6,*)
      END IF
*
*---- Store weights in the runfile too
      CALL Put_dArray('Weights',W,nAt)
      CALL mma_deallocate(W)
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine Sort_mck(A,B,iBas,jBas,kBas,lBas,iCmp,jCmp,kCmp,lCmp,iBasO,jBasO,kBasO,lBasO,iCmpO,jCmpO,kCmpO,lCmpO,nVec,nop,iAng,ishll)
!***********************************************************************
!                                                                      *
!     This subroutine is a stupid solution on a easy problem, but it   *
!     should work and it doesnt take to much CPU time.                 *
!     eaw                                                              *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri3_Elem
use Basis_Info, only: Shells
use Real_Spherical, only: iSphCr
use Symmetry_Info, only: iChBas, iOper, Prmt
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iBas, jBas, kBas, lBas, iCmp, jCmp, kCmp, lCmp, iBasO, jBasO, kBasO, lBasO, iCmpO, jCmpO, kCmpO, &
                                 lCmpO, nVec, nop(4), iAng(4), ishll(4)
real(kind=wp), intent(in) :: A(iBas*jBas*kBas*lBas,iCmp,jCmp,kCmp,lCmp,nVec)
real(kind=wp), intent(out) :: B(kBasO*kCmpO,lBasO,lCmpO,iBasO,iCmpO,jBasO,jCmpO*nvec)
integer(kind=iwp) :: iC, ichbs, ii, ijkl, iVec, jB, jC, jChBs, jj, kB, kC, kChBs, kk, lB, lC, lChBs, ll
real(kind=wp) :: PrA, pRb, pTc, pTSd, qFctr, rp

ii = nTri3_Elem(iAng(1))
jj = nTri3_Elem(iAng(2))
kk = nTri3_Elem(iAng(3))
ll = nTri3_Elem(iAng(4))

rp = One
do iVec=1,nVec
  do iC=1,iCmp
    ichbs = ichbas(ii+ic)
    if (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+ic))
    PrA = Prmt(iOper(nOp(1)),iChBs)
    do jC=1,jCmp
      jChBs = iChBas(jj+jc)
      if (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+jc))
      pRb = Prmt(iOper(nOp(2)),jChBs)
      do kC=1,kCmp
        kChBs = iChBas(kk+kc)
        if (Shells(iShll(3))%Transf) kChBs = iChBas(iSphCr(kk+kc))
        pTc = Prmt(iOper(nOp(3)),kChBs)
        do lC=1,lCmp
          lChBs = iChBas(ll+lC)
          if (Shells(iShll(4))%Transf) lChBs = iChBas(iSphCr(ll+lc))
          pTSd = Prmt(iOper(nOp(4)),lChBs)
          qFctr = pTSd*pTc*pRb*pRa*rp
          !*EAW 970930

          ! Some machines don't support more than 7 indices, need to fool around to make it work

          !do iB=1,iBas
          !  do jB=1,jBas
          !    do lB=1,lBas
          !      B(1:kBas,kC,lB,lC,iB,iC,jB,jC,iVec) = qfctr*A(iB,jB,1:kBas,lB,iC,jC,kC,lC,iVec)
          !    end do
          !  end do
          !end do
          ijkl = 0
          do lB=1,lBas
            do kB=1,kBas
              do jB=1,jBas
                B(kB+(kC-1)*kBasO,lB,lC,1:iBas,iC,jB,jC+(iVec-1)*jCmpO) = qfctr*A(ijkl+1:ijkl+iBas,iC,jC,kC,lC,iVec)
                ijkl = ijkl+iBas
              end do
            end do
          end do

          !EAW 970930
        end do
      end do
    end do
  end do
end do

return

end subroutine Sort_mck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqk41(f,a,b,reslt,abserr,resabs,resasc)
!***begin prologue  dqk41
!***date written   800101   (yymmdd)
!***revision date  830518   (yymmdd)
!***category no.  h2a1a2
!***keywords  41-point gauss-kronrod rules
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  to compute i = integral of f over (a,b), with error
!                           estimate
!                       j = integral of abs(f) over (a,b)
!***description
!
!           integration rules
!           standard fortran subroutine
!           real*8 version
!
!           parameters
!            on entry
!              f      - real*8
!                       function subprogram defining the integrand
!                       function f(x). the actual name for f needs to be
!                       declared e x t e r n a l in the calling program.
!
!              a      - real*8
!                       lower limit of integration
!
!              b      - real*8
!                       upper limit of integration
!
!            on return
!              reslt  - real*8
!                       approximation to the integral i
!                       result is computed by applying the 41-point
!                       kronrod rule (resk) obtained by optimal addition
!                       of abscissae to the 20-point gauss rule (resg).
!
!              abserr - real*8
!                       estimate of the modulus of the absolute error,
!                       which should not exceed abs(i-reslt)
!
!              resabs - real*8
!                       approximation to the integral j
!
!              resasc - real*8
!                       approximation to the integral of abs(f-i/(b-a))
!                       over (a,b)
!
!***references  (none)
!***routines called  d1mach
!***end prologue  dqk41

use Constants, only: Zero, One, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
interface
  function f(x)
    import :: wp
    real(kind=wp) :: f
    real(kind=wp), intent(in) :: x
  end function f
end interface
real(kind=wp), intent(in) :: a, b
real(kind=wp), intent(out) :: reslt, abserr, resabs, resasc
real(kind=wp) :: absc, centr, dhlgth, epmach, fc, fsum, fval1, fval2, fv1(20), fv2(20), hlgth, resg, resk, reskh, uflow
integer(kind=iwp) :: j, jtw, jtwm1
real(kind=wp), external :: d1mach

! the abscissae and weights are given for the interval (-1,1).
! because of symmetry only the positive abscissae and their
! corresponding weights are given.
!
! xgk    - abscissae of the 41-point kronrod rule
!          xgk(2), xgk(4), ...  abscissae of the 20-point
!          gauss rule
!          xgk(1), xgk(3), ...  abscissae which are optimally
!          added to the 20-point gauss rule
!
! wgk    - weights of the 41-point kronrod rule
!
! wg     - weights of the 20-point gauss rule
!
!
! gauss quadrature weights and kronron quadrature abscissae and weights
! as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
! bell labs, nov. 1981.

real(kind=wp), parameter :: wg(10) = [0.017614007139152118311861962351853_wp, &
                                      0.040601429800386941331039952274932_wp, &
                                      0.062672048334109063569506535187042_wp, &
                                      0.083276741576704748724758143222046_wp, &
                                      0.101930119817240435036750135480350_wp, &
                                      0.118194531961518417312377377711382_wp, &
                                      0.131688638449176626898494499748163_wp, &
                                      0.142096109318382051329298325067165_wp, &
                                      0.149172986472603746787828737001969_wp, &
                                      0.152753387130725850698084331955098_wp]
real(kind=wp), parameter :: xgk(21) = [0.998859031588277663838315576545863_wp, &
                                       0.993128599185094924786122388471320_wp, &
                                       0.981507877450250259193342994720217_wp, &
                                       0.963971927277913791267666131197277_wp, &
                                       0.940822633831754753519982722212443_wp, &
                                       0.912234428251325905867752441203298_wp, &
                                       0.878276811252281976077442995113078_wp, &
                                       0.839116971822218823394529061701521_wp, &
                                       0.795041428837551198350638833272788_wp, &
                                       0.746331906460150792614305070355642_wp, &
                                       0.693237656334751384805490711845932_wp, &
                                       0.636053680726515025452836696226286_wp, &
                                       0.575140446819710315342946036586425_wp, &
                                       0.510867001950827098004364050955251_wp, &
                                       0.443593175238725103199992213492640_wp, &
                                       0.373706088715419560672548177024927_wp, &
                                       0.301627868114913004320555356858592_wp, &
                                       0.227785851141645078080496195368575_wp, &
                                       0.152605465240922675505220241022678_wp, &
                                       0.076526521133497333754640409398838_wp, &
                                       0.000000000000000000000000000000000_wp]
real(kind=wp), parameter :: wgk(21) = [0.003073583718520531501218293246031_wp, &
                                       0.008600269855642942198661787950102_wp, &
                                       0.014626169256971252983787960308868_wp, &
                                       0.020388373461266523598010231432755_wp, &
                                       0.025882133604951158834505067096153_wp, &
                                       0.031287306777032798958543119323801_wp, &
                                       0.036600169758200798030557240707211_wp, &
                                       0.041668873327973686263788305936895_wp, &
                                       0.046434821867497674720231880926108_wp, &
                                       0.050944573923728691932707670050345_wp, &
                                       0.055195105348285994744832372419777_wp, &
                                       0.059111400880639572374967220648594_wp, &
                                       0.062653237554781168025870122174255_wp, &
                                       0.065834597133618422111563556969398_wp, &
                                       0.068648672928521619345623411885368_wp, &
                                       0.071054423553444068305790361723210_wp, &
                                       0.073030690332786667495189417658913_wp, &
                                       0.074582875400499188986581418362488_wp, &
                                       0.075704497684556674659542775376617_wp, &
                                       0.076377867672080736705502835038061_wp, &
                                       0.076600711917999656445049901530102_wp]

! list of major variables
! -----------------------
!
! centr  - mid point of the interval
! hlgth  - half-length of the interval
! absc   - abscissa
! fval*  - function value
! resg   - result of the 20-point gauss formula
! resk   - result of the 41-point kronrod formula
! reskh  - approximation to the mean value of f over (a,b),
!          i.e. to i/(b-a)
!
! machine dependent constants
! ---------------------------
!
! epmach is the largest relative spacing.
! uflow is the smallest positive magnitude.
!
!***first executable statement  dqk41

epmach = d1mach(4)
uflow = d1mach(1)

centr = Half*(a+b)
hlgth = Half*(b-a)
dhlgth = abs(hlgth)

! compute the 41-point kronrod approximation to
! the integral, and estimate the absolute error.

fc = f(centr)
resg = Zero
resk = fc*wgk(21)
resabs = abs(resk)
do j=1,10
  jtw = j*2
  absc = hlgth*xgk(jtw)
  fval1 = f(centr-absc)
  fval2 = f(centr+absc)
  fv1(jtw) = fval1
  fv2(jtw) = fval2
  fsum = fval1+fval2
  resg = resg+wg(j)*fsum
  resk = resk+wgk(jtw)*fsum
  resabs = resabs+wgk(jtw)*(abs(fval1)+abs(fval2))
end do
do j=1,10
  jtwm1 = j*2-1
  absc = hlgth*xgk(jtwm1)
  fval1 = f(centr-absc)
  fval2 = f(centr+absc)
  fv1(jtwm1) = fval1
  fv2(jtwm1) = fval2
  fsum = fval1+fval2
  resk = resk+wgk(jtwm1)*fsum
  resabs = resabs+wgk(jtwm1)*(abs(fval1)+abs(fval2))
end do
reskh = resk*Half
resasc = wgk(21)*abs(fc-reskh)
do j=1,20
  resasc = resasc+wgk(j)*(abs(fv1(j)-reskh)+abs(fv2(j)-reskh))
end do
reslt = resk*hlgth
resabs = resabs*dhlgth
resasc = resasc*dhlgth
abserr = abs((resk-resg)*hlgth)
if ((resasc /= Zero) .and. (abserr /= Zero)) abserr = resasc*min(One,(200.0_wp*abserr/resasc)**OneHalf)
if (resabs > uflow/(50.0_wp*epmach)) abserr = max((epmach*50.0_wp)*resabs,abserr)

return

end subroutine dqk41

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               2024, Matthew R. Hennefarth                            *
!***********************************************************************

subroutine validate_wfn()

use rasscf_global, only: iRoot, lRoots, NAC, NIN, nRoots
use general_data, only: ispin, nactel, nash, nbas, nbas, ndel, nelec3, nfro, nhole1, nish, norb, nrs1, nrs1t, nrs2, nrs2t, nrs3, &
                        nrs3t, nssh, nsym, ntot, stsym
use Molcas, only: MxAct, MxBas, MxIna, MxOrb, MxRoot
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: ia0, ib0, ic0
logical(kind=iwp) :: is_negative, is_too_large

if ((NSYM /= 1) .and. (NSYM /= 2) .and. (NSYM /= 4) .and. (NSYM /= 8)) then
  call WarningMessage(2,'Wrong nr of symmetries.')
  write(u6,*) '*************** ERROR ***************'
  write(u6,'(1X,A,I8)') 'Nr of symmetries NSYM=',NSYM
  write(u6,*) ' Only possible values are 1,2,4 or 8.'
  write(u6,*) '*************************************'
  call Quit_OnUserError()
end if
if (STSYM > NSYM) then
  call WarningMessage(2,'Wrong symmetry.')
  write(u6,*) '***************** ERROR *****************'
  write(u6,'(1X,A,I8)') 'CHKINP Error: Wrong symmetry.'
  write(u6,'(1X,A,I8)') 'State symmetry   STSYM=',STSYM
  write(u6,'(1X,A,I8)') 'Point group order NSYM=',NSYM
  write(u6,*) '************************************************'
  call Quit_OnUserError()
end if
if (NTOT > mxOrb) then
  call WarningMessage(2,'Too many orbitals.')
  write(u6,*) '************ ERROR ******************'
  write(u6,'(1X,A,I8)') 'Too many orbitals NTOT=',NTOT
  write(u6,'(1X,A,I8)') 'Limit is MXORB=',MXORB
  write(u6,*) '*************************************'
  call Quit_OnUserError()
end if
if (NAC > mxAct) then
  call WarningMessage(2,'Too many active orbitals.')
  write(u6,*) '*************** ERROR ***************'
  write(u6,'(1X,A,I8)') 'Too many active orbitals NAC=',NAC
  write(u6,'(1X,A,I8)') 'Limit is MXACT=',MXACT
  write(u6,*) '*************************************'
  call Quit_OnUserError()
end if
if (NIN > mxIna) then
  call WarningMessage(2,'Too many inactive orbitals.')
  write(u6,*) '*************** ERROR ***************'
  write(u6,'(1X,A,I8)') 'Too many inactive orbitals NIN=',NIN
  write(u6,'(1X,A,I8)') 'Limit is MXINA=',MXINA
  write(u6,*) '*************************************'
  call Quit_OnUserError()
end if
if (NACTEL > 2*NAC) then
  call WarningMessage(2,'Too many active electrons.')
  write(u6,*) '********************* ERROR **********************'
  write(u6,'(1X,A,I6)') 'Too many active electrons NACTEL=',NACTEL
  write(u6,'(1X,A,I6)') 'Cannot be more than 2*Nr of active orbitals=',2*NAC
  write(u6,*) '**************************************************'
  call Quit_OnUserError()
end if
if (NHOLE1 > 2*NRS1T) then
  call WarningMessage(2,'Too many holes in Ras1.')
  write(u6,*) '******************** WARNING *********************'
  write(u6,'(1X,A,I6)') 'You allow too many holes in Ras1 NHOLE1=',NHOLE1
  write(u6,'(1X,A,I6)') 'Cannot be more than 2*Nr of Ras1 orbitals=',2*NRS1T
  write(u6,*) '**************************************************'
  call Quit_OnUserError()
end if
if (NELEC3 > 2*NRS3T) then
  call WarningMessage(1,'Too many electrons in Ras3.')
  write(u6,*) '******************** WARNING *********************'
  write(u6,'(1X,A,I6)') 'You allow too many electrons in Ras3 NELEC3=',NELEC3
  write(u6,'(1X,A,I6)') 'Cannot be more than 2*Nr of Ras3 orbitals=',2*NRS3T
  write(u6,*) '**************************************************'
  call Quit_OnUserError()
end if
if (NACTEL > 2*(NRS1T+NRS2T)+NELEC3) then
  call WarningMessage(2,'Too many active electrons.')
  write(u6,*) '********************* ERROR **********************'
  write(u6,'(1X,A,I8)') 'Too many active electrons NACTEL=',NACTEL
  write(u6,'(1X,A,I8)') '(Incompatible with RAS restrictions).'
  write(u6,*) '**************************************************'
  call Quit_OnUserError()
end if
if (NACTEL < 2*NRS1T-NHOLE1) then
  call WarningMessage(2,'Too few active electrons.')
  write(u6,*) '********************* ERROR **********************'
  write(u6,'(1X,A,I8)') 'Too few active electrons NACTEL=',NACTEL
  write(u6,'(1X,A,I8)') '(Incompatible with RAS restrictions).'
  write(u6,*) '**************************************************'
  call Quit_OnUserError()
end if

is_negative = .false.
if (any(nBas(1:nSym) < 0)) is_negative = .true.
if (any(nFro(1:nSym) < 0)) is_negative = .true.
if (any(nDel(1:nSym) < 0)) is_negative = .true.
if (any(nOrb(1:nSym) < 0)) is_negative = .true.
if (any(nISh(1:nSym) < 0)) is_negative = .true.
if (any(nASh(1:nSym) < 0)) is_negative = .true.
if (any(nSSh(1:nSym) < 0)) is_negative = .true.
if (any(nRS1(1:nSym) < 0)) is_negative = .true.
if (any(nRS2(1:nSym) < 0)) is_negative = .true.
if (any(nRS3(1:nSym) < 0)) is_negative = .true.
is_too_large = .false.
if (any(nBas(1:nSym) > mxBas)) is_too_large = .true.
if (any(nFro(1:nSym) > mxBas)) is_too_large = .true.
if (any(nDel(1:nSym) > mxBas)) is_too_large = .true.
if (any(nOrb(1:nSym) > mxBas)) is_too_large = .true.
if (any(nISh(1:nSym) > mxBas)) is_too_large = .true.
if (any(nASh(1:nSym) > mxBas)) is_too_large = .true.
if (any(nSSh(1:nSym) > mxBas)) is_too_large = .true.
if (any(nRS1(1:nSym) > mxBas)) is_too_large = .true.
if (any(nRS2(1:nSym) > mxBas)) is_too_large = .true.
if (any(nRS3(1:nSym) > mxBas)) is_too_large = .true.
if (is_negative .or. is_too_large) then
  write(u6,*)
  write(u6,*) '****************** ERROR *******************'
  call WarningMessage(2,'Erroneous nr of orbitals.')
  write(u6,*) 'Inappropriate nr of orbitals. One or more of'
  write(u6,*) 'these orbital counts is wrong or too large.'
  if (is_negative) write(u6,*) ' Negative values.'
  if (is_too_large) write(u6,*) ' Extremely large values.'
  write(u6,'(1X,A,8I4)') '   All orbitals:',NBAS(1:NSYM)
  write(u6,'(1X,A,8I4)') '         Frozen:',NFRO(1:NSYM)
  write(u6,'(1X,A,8I4)') '       Inactive:',NISH(1:NSYM)
  write(u6,'(1X,A,8I4)') '         Active:',NASH(1:NSYM)
  write(u6,'(1X,A,8I4)') '          RAS-1:',NRS1(1:NSYM)
  write(u6,'(1X,A,8I4)') '          RAS-2:',NRS2(1:NSYM)
  write(u6,'(1X,A,8I4)') '          RAS-3:',NRS3(1:NSYM)
  write(u6,'(1X,A,8I4)') '      Secondary:',NSSH(1:NSYM)
  write(u6,'(1X,A,8I4)') '        Deleted:',NDEL(1:NSYM)
  write(u6,'(1X,A,8I4)') 'Basis functions:',NBAS(1:NSYM)
  if (is_negative) write(u6,*) ' Have you used a too small basis set?'
  write(u6,*) '********************************************'
  call Quit_OnUserError()
end if

IB0 = ISPIN-1
IA0 = (NACTEL-IB0)/2
IC0 = (NAC-IA0-IB0)
if ((2*IA0+IB0 /= NACTEL) .or. (IA0 < 0) .or. (IB0 < 0) .or. (IC0 < 0)) then
  call WarningMessage(2,'No such wave function.')
  write(u6,*) '******************** ERROR *********************'
  write(u6,*) 'The following combined specifications are wrong.'
  write(u6,'(1X,A,8I4)') 'Nr of active electrons NACTEL=',NACTEL
  write(u6,'(1X,A,8I4)') 'Nr of active orbitals     NAC=',NAC
  write(u6,'(1X,A,8I4)') 'Spin degeneracy         ISPIN=',ISPIN
  write(u6,*) 'There can be no such wave function.'
  write(u6,*) '************************************************'
  call Quit_OnUserError()
end if

if ((NROOTS > mxRoot) .or. (LROOTS > mxROOT)) then
  call WarningMessage(2,'Max roots exceeded.')
  write(u6,*) '***************** ERROR *****************'
  write(u6,'(1X,A,I6)') 'Input Error: Max roots exceeded.',mxRoot
  write(u6,'(1X,A,I4)') 'Nr of CI roots        LROOTS=',LROOTS
  write(u6,'(1X,A,I4)') 'Nr of optimized roots NROOTS=',NROOTS
  write(u6,*) '************************************************'
  call Quit_OnUserError()
end if
if ((minval(IROOT(1:NROOTS)) < 0) .or. (maxval(IROOT(1:NROOTS)) > LROOTS)) then
  call WarningMessage(2,'Root specifications are wrong.')
  write(u6,*) '***************** ERROR *****************'
  write(u6,*) 'CHKINP Error: Root specifications are wrong.'
  write(u6,'(1X,A,I4)') 'Nr of CI roots        LROOTS=',LROOTS
  write(u6,'(1X,A,I4)') 'Nr of optimized roots NROOTS=',NROOTS
  write(u6,*) '************************************************'
  call Quit_OnUserError()
end if

if (((NHOLE1 < 0) .and. (NRS1T /= 0)) .or. ((NELEC3 < 0) .and. (NRS3T /= 0)) .or. ((NACTEL < 0) .and. (NRS2T /= 0))) then
  call WarningMessage(2,'Error in RAS specification.')
  write(u6,*) '***************** ERROR *****************'
  write(u6,*) 'Error in RAS specification.'
  write(u6,'(1X,A,I8)') 'Max holes in Ras1,     NHOLE1=',NHOLE1
  write(u6,'(1X,A,I8)') 'Max electrons in Ras3, NELEC3=',NELEC3
  write(u6,'(1X,A,I8)') 'Nr of active electrons NACTEL=',NACTEL
  write(u6,*) '*****************************************'
  call Quit_OnUserError()
end if

end subroutine validate_wfn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000,2002, Roland Lindh                                *
************************************************************************
      Subroutine d2Rho_dR2_LDA(Dens,nDens,nD,dRho_dR,d2Rho_dR2,ndRho_dR,
     &                         mGrid,list_s,nlist_s,
     &                         TabAO,ipTabAO,mAO,nTabAO,nSym,
     &                         nGrad_Eff,list_g,Maps2p,nShell,
     &                         Grid_type,Fixed_Grid,Fact,ndc,TabAOMax,
     &                         T_X,list_bas,Index,nIndex)
************************************************************************
*      Author:Roland Lindh, Department of Chemical Physics, University *
*             of Lund, SWEDEN.  2000                                   *
*                                                                      *
*             Modified May-June 2002 in Tokyo for DFT gradient by RL.  *
************************************************************************
      use iSD_data
      use k2_arrays, only: DeDe, ipDijS
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "disp.fh"
#include "real.fh"
#include "print.fh"
#include "debug.fh"
#include "nsd.fh"
#include "setup.fh"
      Integer On, Off
      Parameter (On=1, Off=0)
      Integer list_s(2,nlist_s), list_g(3,nlist_s),
     &        ipTabAO(nlist_s), Maps2p(nShell,0:nSym-1),
     &        list_bas(2,nlist_s), Index(nIndex)
      Integer Grid_Type, Fixed_Grid
      Real*8 Dens(nDens,nD), TabAO(nTabAO), Fact(ndc**2),
     &       dRho_dR(ndRho_dR,mGrid,nGrad_Eff), Phase(3,2),
     &       TabAOMax(nlist_s),
     &       d2Rho_dR2(ndRho_dR,mGrid,nGrad_Eff,nGrad_Eff)
      Integer IndGrd_Eff(3,2)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (Debug) Then
         Call RecPrt('d2Rho_dR2_LDA:Dens',' ',Dens,nDens,nD)
         Write (6,*) 'mAO=',mAO
         Write (6,*) 'mGrid=',mGrid
         Write (6,*) 'nTabAO=',nTabAO
         Write (6,*) 'nlist_s=',nlist_s
         Write (6,*) 'nD=',nD
         Do iList_s = 1, nList_s
            Write (6,*) 'iList_s=',iList_s
            iS = list_s(1,ilist_s)
            iCmp  = iSD( 2,iS)
            iBas_Eff  = list_bas(1,ilist_s)
            mTabAO=iBas_Eff*iCmp
            mdci  = iSD(10,iS)
            Call RecPrt('d2Rho_dR2_LDA: TabAO',' ',
     &                  TabAO(ipTabAO(iList_s)),mAO,mGrid*mTabAO)
         End Do
      End If
#endif
*
      Call FZero(dRho_dR,ndRho_dR*mGrid*nGrad_Eff)
      Call FZero(d2Rho_dR2,ndRho_dR*mGrid*nGrad_Eff**2)
*                                                                      *
************************************************************************
*                                                                      *
      Do ilist_s=1,nlist_s
         iS      =list_s(1,ilist_s)
         iCmp       =iSD( 2,iS)
         iBas_Eff  = list_bas(1,ilist_s)
         ix = iDAMax_(mAO*mGrid*iBas_Eff*iCmp,TabAO(ipTabAO(iList_s)),1)
         TabAOMax(ilist_s)=Abs(TabAO(ipTabAO(ilist_s)-1+ix))
         TMax_i=TabAOMax(ilist_s)
         If (TMax_i.le.T_X) Go To 999
         iBas       =iSD( 3,iS)
         kDCRE   =list_s(2,ilist_s)
         iShell     =iSD(11,iS)
         mdci       =iSD(10,iS)
         iPrim      =iSD( 5,iS)
         index_i    =list_bas(2,ilist_s)
*
         lDCRE=NrOpr(kDCRE)
         Phase(1,1)=DBLE(dc(mdci)%nStab)
         Phase(2,1)=DBLE(dc(mdci)%nStab)
         Phase(3,1)=DBLE(dc(mdci)%nStab)
*
         jNQ=Maps2p(iS,lDCRE)
         Call ICopy(3,list_g(1,ilist_s),1,IndGrd_Eff(1,1),1)
         n1 = IndGrd_Eff(1,1) + IndGrd_Eff(2,1) + IndGrd_Eff(3,1)
*
         Do jlist_s=1,ilist_s
            TMax_j=TabAOMax(jlist_s)
            If (TMax_j.le.T_X) Go To 98
            If (TMax_i*TMax_j.lt.T_X) Go To 98
            jS      =list_s(1,jlist_s)
            kDCRR   =list_s(2,jlist_s)
            jCmp       =iSD( 2,jS)
            jBas       =iSD( 3,jS)
            jBas_Eff   =list_bas(1,jlist_s)
            jPrim      =iSD( 5,jS)
            mdcj       =iSD(10,jS)
            jShell     =iSD(11,jS)
            index_j    =list_bas(2,jlist_s)
*
            lDCRR=NrOpr(kDCRR)
            Phase(1,2)=DBLE(dc(mdcj)%nStab)
            Phase(2,2)=DBLE(dc(mdcj)%nStab)
            Phase(3,2)=DBLE(dc(mdcj)%nStab)
*
            kNQ=Maps2p(jS,lDCRR)
            Call ICopy(3,list_g(1,jlist_s),1,IndGrd_Eff(1,2),1)
            n2 = IndGrd_Eff(1,2) + IndGrd_Eff(2,2) + IndGrd_Eff(3,2)
            If (n1+n2.eq.0) Go To 98
*
            mDij=iBas*jBas*iCmp*jCmp
*
*---------- Get the Density
*
            ijS=iTri(iShell,jShell)
            ipTmp=ipDijs
            Call Dens_Info(ijS,ipDij,ipDSij,mDCRij,ipDDij,ipTmp,nD)
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*)
               Write (6,*) 'iS,jS=',iS,jS
               Write (6,*) 'mDCRij,mDij=',mDCRij,mDij
               Write (6,*) 'ipDij,ipDSij,ipDDij=',ipDij,ipDSij,ipDDij
            End If
#endif
*
            ij = (mdcj-1)*ndc + mdci
*
            Deg=Two
            If (ilist_s.eq.jlist_s) Deg=One
*
            iER=iEOr(kDCRE,kDCRR)
            lDCRER=NrOpr(iER)
*
            ip_D_a=ipDij+lDCRER*mDij
            ip_D_b=ip_D_a
            If (nD.ne.1) ip_D_b=ipDSij+lDCRER*mDij
*
            ix=iDAMax_(mDij,DeDe(ip_D_a),1)
            DMax_ij=Abs(DeDe(ip_D_a-1+ix))
            If (nD.ne.1) Then
               ix=iDAMax_(mDij,DeDe(ip_D_b),1)
               DMax_ij=DMax_ij+Abs(DeDe(ip_D_a-1+ix))
            End If
            If (TMax_i*TMax_j*DMax_ij.lt.T_X) Go To 98
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*) 'd2Rho_dR2_LDA'
               nBB = iBas*jBas
               nCC = iCmp*jCmp
               Write (6,*) 'iShell,jShell=',iShell,jShell
               Write (6,*) 'kDCRE,kDCRR=',kDCRE,kDCRR
               Write (6,*) 'iER,lDCRER=',iER,lDCRER
               Call RecPrt('DAij',' ',DeDe(ip_D_a),nBB,nCC)
               If (nD.ne.1)
     &            Call RecPrt('DBij',' ',DeDe(ip_D_b),nBB,nCC)
            End If
#endif
*
            If (iShell.lt.jShell) Then
               itmp=IndGrd_Eff(1,1)
               IndGrd_Eff(1,1)=IndGrd_Eff(1,2)
               IndGrd_Eff(1,2)=itmp
               itmp=IndGrd_Eff(2,1)
               IndGrd_Eff(2,1)=IndGrd_Eff(2,2)
               IndGrd_Eff(2,2)=itmp
               itmp=IndGrd_Eff(3,1)
               IndGrd_Eff(3,1)=IndGrd_Eff(3,2)
               IndGrd_Eff(3,2)=itmp
               tmp = Phase(1,1)
               Phase(1,1)=Phase(1,2)
               Phase(1,2)=tmp
               tmp = Phase(2,1)
               Phase(2,1)=Phase(2,2)
               Phase(2,2)=tmp
               tmp = Phase(3,1)
               Phase(3,1)=Phase(3,2)
               Phase(3,2)=tmp
            End If
            If (nD.eq.1) Then
               If (iShell.ge.jShell) Then
               Call Do_Rho2ha(dRho_dR,d2Rho_dR2,mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),                  mAO,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,Phase,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               Else
               Call Do_Rho2ha(dRho_dR,d2Rho_dR2,mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),                  mAO,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,Phase,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               End If
            Else
               If (iShell.ge.jShell) Then
               Call Do_Rho2h_(dRho_dR,d2Rho_dR2,mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),DeDe(ip_D_b),     mAO,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,Phase,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               Else
               Call Do_Rho2h_(dRho_dR,d2Rho_dR2,mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),DeDe(ip_D_b),     mAO,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,Phase,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               End If
            End If
*
 98         Continue
*
         End Do                      ! jlist_s
 999     Continue
      End Do                         ! ilist_s
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (Debug) Call RecPrt('d2Rho_dR2_LDA: dRho_dR',' ',dRho_dR,
     &                       ndRho_dR*mGrid,nGrad_Eff)
*
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Dens)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(Grid_type)
         Call Unused_integer(Fixed_Grid)
      End If
      End
      Subroutine Do_Rho2ha(dRho_dR,d2Rho_dR2,mGrid,nGrad_Eff,
     &                     DAij,          mAO,
     &                     TabAO1,iBas,iBas_Eff,iCmp,
     &                     TabAO2,jBas,jBas_Eff,jCmp,
     &                     Fact,IndGrd_Eff,Phase,T_X,TMax_ij,
     &                     Index_i,Index_j)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 dRho_dR(   mGrid,nGrad_Eff), DAij(iBas*iCmp,jBas*jCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp),
     &       TabAO2(mAO,mGrid,jBas_Eff*jCmp),
     &       Phase(3,2), d2Rho_dR2(  mGrid,nGrad_Eff,nGrad_Eff)
      Integer IndGrd_Eff(3,2), Index_i(iBas_Eff*iCmp),
     &                         Index_j(jBas_Eff*jCmp)
      Integer Ind1(3), Ind2(3,3)
      Data Ind1/2,3,4/, Ind2/5, 6, 8,
     &                       6, 7, 9,
     &                       8, 9,10/
*                                                                      *
************************************************************************
*                                                                      *
      Do jCB_Eff = 1, jBas_Eff*jCmp
         jCB=Index_j(jCB_Eff)
*
         Do iCB_Eff = 1, iBas_Eff*iCmp
            iCB=Index_i(iCB_Eff)
*
            DAij_=DAij(iCB,jCB)*Fact
            If (TMax_ij*Abs(DAij_).lt.T_X) Go To 99
*
*---------- Loop over cartesian components
*
            Do iCar = 1, 3
               I_Ai=IndGrd_Eff(iCar,1)
               I_Bi=IndGrd_Eff(iCar,2)
               i = Ind1(iCar)
*
*              Do the gradient term
*
               If (I_Ai.ne.0.and.I_Bi.ne.0) Then
                  Do iGrid = 1, mGrid
                     Prod_ij_1=
     &                   TabAO1(i,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
                     Prod_ij_2=
     &                   TabAO1(1,iGrid,iCB_Eff)*TabAO2(i,iGrid,jCB_Eff)
                     dRho_dR(iGrid,I_Ai)=dRho_dR(iGrid,I_Ai)
     &                                   +Prod_ij_1*DAij_*Phase(iCar,1)
                     dRho_dR(iGrid,I_Bi)=dRho_dR(iGrid,I_Bi)
     &                                   +Prod_ij_2*DAij_*Phase(iCar,2)
                  End Do ! iGrid
               Else If (I_Ai.ne.0) Then
                  Do iGrid = 1, mGrid
                     Prod_ij_1=
     &                   TabAO1(i,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
                     dRho_dR(iGrid,I_Ai)=dRho_dR(iGrid,I_Ai)
     &                                   +Prod_ij_1*DAij_*Phase(iCar,1)
                  End Do ! iGrid
               Else If (I_Bi.ne.0) Then
                  Do iGrid = 1, mGrid
                     Prod_ij_2=
     &                   TabAO1(1,iGrid,iCB_Eff)*TabAO2(i,iGrid,jCB_Eff)
                     dRho_dR(iGrid,I_Bi)=dRho_dR(iGrid,I_Bi)
     &                                   +Prod_ij_2*DAij_*Phase(iCar,2)
                  End Do ! iGrid
               End If
*
*              Do the hessian term
*
               Do jCar = 1, 3
                  I_Aj=IndGrd_Eff(jCar,1)
                  I_Bj=IndGrd_Eff(jCar,2)
                  j = Ind1(jCar)
                  ij = Ind2(iCar,jCar)
*
                  If (I_Ai*I_Aj.ne.0) Then
                     Do iGrid = 1, mGrid
                        AAij=
     &                  TabAO1(ij,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
                        d2Rho_dR2(iGrid,I_Ai,I_Aj) =
     &                    d2Rho_dR2(iGrid,I_Ai,I_Aj)
     &                    + AAij*DAij_*Phase(iCar,1)*Phase(jCar,1)
                     End Do
                  End if
                  If (I_Ai*I_Bj.ne.0) Then
                     Do iGrid = 1, mGrid
                        ABij=
     &                   TabAO1(i,iGrid,iCB_Eff)*TabAO2(j,iGrid,jCB_Eff)
                        d2Rho_dR2(iGrid,I_Ai,I_Bj) =
     &                    d2Rho_dR2(iGrid,I_Ai,I_Bj)
     &                    + ABij*DAij_*Phase(iCar,1)*Phase(jCar,2)
                     End Do
                  End if
                  If (I_Aj*I_Bi.ne.0) Then
                     Do iGrid = 1, mGrid
                        ABji=
     &                   TabAO1(j,iGrid,iCB_Eff)*TabAO2(i,iGrid,jCB_Eff)
                        d2Rho_dR2(iGrid,I_Aj,I_Bi) =
     &                    d2Rho_dR2(iGrid,I_Aj,I_Bi)
     &                    + ABji*DAij_*Phase(jCar,1)*Phase(iCar,2)
                     End Do
                  End if
                  If (I_Bi*I_Bj.ne.0) Then
                     Do iGrid = 1, mGrid
                        BBij=
     &                  TabAO1(1,iGrid,iCB_Eff)*TabAO2(ij,iGrid,jCB_Eff)
                        d2Rho_dR2(iGrid,I_Bj,I_Bi) =
     &                    d2Rho_dR2(iGrid,I_Bj,I_Bi)
     &                    + BBij*DAij_*Phase(iCar,2)*Phase(jCar,2)
                     End Do
                  End if
*
               End Do  ! jCar
*
            End Do     ! iCar
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
      Return
      End
      Subroutine Do_Rho2h_(dRho_dR,d2Rho_dR2,mGrid,nGrad_Eff,
     &                     DAij,DBij,     mAO,
     &                     TabAO1,iBas,iBas_Eff,iCmp,
     &                     TabAO2,jBas,jBas_Eff,jCmp,
     &                     Fact,IndGrd_Eff,Phase,T_X,TMax_ij,
     &                     Index_i,Index_j)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 dRho_dR(2,mGrid,nGrad_Eff),
     &       DAij(iBas*iCmp,jBas*jCmp), DBij(iBas*iCmp,jBas*jCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp),
     &       TabAO2(mAO,mGrid,jBas_Eff*jCmp),
     &       Phase(3,2), d2Rho_dR2(2,mGrid,nGrad_Eff,nGrad_Eff)
      Integer IndGrd_Eff(3,2), Index_i(iBas_Eff*iCmp),
     &                         Index_j(jBas_Eff*jCmp)
      Integer Ind1(3), Ind2(3,3)
      Data Ind1/2,3,4/, Ind2/5, 6, 8,
     &                       6, 7, 9,
     &                       8, 9,10/
*                                                                      *
************************************************************************
*                                                                      *
      Do jCB_Eff = 1, jBas_Eff*jCmp
         jCB=Index_j(jCB_Eff)
*
         Do iCB_Eff = 1, iBas_Eff*iCmp
            iCB=Index_i(iCB_Eff)
*
            DAij_=DAij(iCB,jCB)*Fact
            DBij_=DBij(iCB,jCB)*Fact
            If (TMax_ij*Abs(DAij_).lt.T_X .and.
     &          TMax_ij*Abs(DBij_).lt.T_X) Go To 99
*
*---------- Loop over cartesian components
*
            Do iCar = 1, 3
               I_Ai=IndGrd_Eff(iCar,1)
               I_Bi=IndGrd_Eff(iCar,2)
               i = Ind1(iCar)
*
*              Do the gradient term
*
               If (I_Ai.ne.0.and.I_Bi.ne.0) Then
                  Do iGrid = 1, mGrid
                     Prod_ij_1=
     &                   TabAO1(i,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
                     Prod_ij_2=
     &                   TabAO1(1,iGrid,iCB_Eff)*TabAO2(i,iGrid,jCB_Eff)
                     dRho_dR(1,iGrid,I_Ai)=dRho_dR(1,iGrid,I_Ai)
     &                                   +Prod_ij_1*DAij_*Phase(iCar,1)
                     dRho_dR(2,iGrid,I_Ai)=dRho_dR(2,iGrid,I_Ai)
     &                                   +Prod_ij_1*DBij_*Phase(iCar,1)
                     dRho_dR(1,iGrid,I_Bi)=dRho_dR(1,iGrid,I_Bi)
     &                                   +Prod_ij_2*DAij_*Phase(iCar,2)
                     dRho_dR(2,iGrid,I_Bi)=dRho_dR(2,iGrid,I_Bi)
     &                                   +Prod_ij_2*DBij_*Phase(iCar,2)
                  End Do ! iGrid
               Else If (I_Ai.ne.0) Then
                  Do iGrid = 1, mGrid
                     Prod_ij_1=
     &                   TabAO1(i,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
                     dRho_dR(1,iGrid,I_Ai)=dRho_dR(1,iGrid,I_Ai)
     &                                   +Prod_ij_1*DAij_*Phase(iCar,1)
                     dRho_dR(2,iGrid,I_Ai)=dRho_dR(2,iGrid,I_Ai)
     &                                   +Prod_ij_1*DBij_*Phase(iCar,1)
                  End Do ! iGrid
               Else If (I_Bi.ne.0) Then
                  Do iGrid = 1, mGrid
                     Prod_ij_2=
     &                   TabAO1(1,iGrid,iCB_Eff)*TabAO2(i,iGrid,jCB_Eff)
                     dRho_dR(1,iGrid,I_Bi)=dRho_dR(1,iGrid,I_Bi)
     &                                   +Prod_ij_2*DAij_*Phase(iCar,2)
                     dRho_dR(2,iGrid,I_Bi)=dRho_dR(2,iGrid,I_Bi)
     &                                   +Prod_ij_2*DBij_*Phase(iCar,2)
                  End Do ! iGrid
               End If
*
*              Do the hessian term
*
               Do jCar = 1, 3
                  I_Aj=IndGrd_Eff(jCar,1)
                  I_Bj=IndGrd_Eff(jCar,2)
                  j = Ind1(jCar)
                  ij = Ind2(iCar,jCar)
*
                  If (I_Ai*I_Aj.ne.0) Then
                     Do iGrid = 1, mGrid
                        AAij=
     &                  TabAO1(ij,iGrid,iCB_Eff)*TabAO2(1,iGrid,jCB_Eff)
                        d2Rho_dR2(1,iGrid,I_Ai,I_Aj) =
     &                    d2Rho_dR2(1,iGrid,I_Ai,I_Aj)
     &                    + AAij*DAij_*Phase(iCar,1)*Phase(jCar,1)
                        d2Rho_dR2(2,iGrid,I_Ai,I_Aj) =
     &                    d2Rho_dR2(2,iGrid,I_Ai,I_Aj)
     &                    + AAij*DBij_*Phase(iCar,1)*Phase(jCar,1)
                     End Do
                  End if
                  If (I_Ai*I_Bj.ne.0) Then
                     Do iGrid = 1, mGrid
                        ABij=
     &                   TabAO1(i,iGrid,iCB_Eff)*TabAO2(j,iGrid,jCB_Eff)
                        d2Rho_dR2(1,iGrid,I_Ai,I_Bj) =
     &                    d2Rho_dR2(1,iGrid,I_Ai,I_Bj)
     &                    + ABij*DAij_*Phase(iCar,1)*Phase(jCar,2)
                        d2Rho_dR2(2,iGrid,I_Ai,I_Bj) =
     &                    d2Rho_dR2(2,iGrid,I_Ai,I_Bj)
     &                    + ABij*DBij_*Phase(iCar,1)*Phase(jCar,2)
                     End Do
                  End if
                  If (I_Aj*I_Bi.ne.0) Then
                     Do iGrid = 1, mGrid
                        ABji=
     &                   TabAO1(j,iGrid,iCB_Eff)*TabAO2(i,iGrid,jCB_Eff)
                        d2Rho_dR2(1,iGrid,I_Aj,I_Bi) =
     &                    d2Rho_dR2(1,iGrid,I_Aj,I_Bi)
     &                    + ABji*DAij_*Phase(jCar,1)*Phase(iCar,2)
                        d2Rho_dR2(2,iGrid,I_Aj,I_Bi) =
     &                    d2Rho_dR2(2,iGrid,I_Aj,I_Bi)
     &                    + ABji*DBij_*Phase(jCar,1)*Phase(iCar,2)
                     End Do
                  End if
                  If (I_Bi*I_Bj.ne.0) Then
                     Do iGrid = 1, mGrid
                        BBij=
     &                  TabAO1(1,iGrid,iCB_Eff)*TabAO2(ij,iGrid,jCB_Eff)
                        d2Rho_dR2(1,iGrid,I_Bj,I_Bi) =
     &                    d2Rho_dR2(1,iGrid,I_Bj,I_Bi)
     &                    + BBij*DAij_*Phase(iCar,2)*Phase(jCar,2)
                        d2Rho_dR2(2,iGrid,I_Bj,I_Bi) =
     &                    d2Rho_dR2(2,iGrid,I_Bj,I_Bi)
     &                    + BBij*DBij_*Phase(iCar,2)*Phase(jCar,2)
                     End Do
                  End if
*
               End Do  ! jCar
*
            End Do     ! iCar
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 12, 2022, created this file.               *
!*****************************************************************

subroutine CalcGradCMS(Grad,DDg,lRoots,nSPair)

use Index_Functions, only: iTri
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lRoots, nSPair
real(kind=wp), intent(out) :: Grad(nSPair)
real(kind=wp), intent(in) :: DDg(lRoots,lRoots,lRoots,lRoots)
integer(kind=iwp) :: iKL, K, L

do K=2,lRoots
  do L=1,K-1
    iKL = iTri(K-1,L)
    Grad(iKL) = DDg(K,K,K,L)-DDg(L,L,K,L)
  end do
end do
Grad(:) = Two*Grad(:)

return

end subroutine CalcGradCMS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine SPEC1C(IFC,FACT,ISYM,X,nX,Y,nY)
! If IFC=0, compute
! X(tuu,a) <- X(tuu,a)+FACT*Y(t,a), else
! the conjugate expression (summing into Y, values from X).

use SUPERINDEX, only: KTUV
use caspt2_module, only: nAES, nAsh, nAshT, nSsh, nTUV, nTUVES
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IFC, ISYM, nX, nY
real(kind=wp), intent(in) :: FACT
real(kind=wp), intent(inout) :: X(nX), Y(nY)
integer(kind=iwp) :: IT, ITQ, ITUU, IUQ, NA, NAS, NT

NA = NSSH(ISYM)
if (NA <= 0) return
NAS = NTUV(ISYM)
NT = NASH(ISYM)
do IT=1,NT
  ITQ = IT+NAES(ISYM)
  do IUQ=1,NASHT
    ITUU = KTUV(ITQ,IUQ,IUQ)-NTUVES(ISYM)
    if (IFC == 0) then
      call DAXPY_(NA,FACT,Y(IT),NT,X(ITUU),NAS)
    else
      call DAXPY_(NA,FACT,X(ITUU),NAS,Y(IT),NT)
    end if
  end do
end do

end subroutine SPEC1C

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine quaterreport(V1best,V2best,V1,V2)

use Quater_globals, only: rotate, ngeoms
use Definitions, only: wp, r8, u6

implicit none
real(kind=wp), intent(in) :: V1best(3), V2best(3), V1(3), V2(3)
real(kind=wp) :: v1dot, v2dot
real(kind=r8), external :: ddot_

write(u6,*) 'Number of geometries generated : ',ngeoms

if (rotate) then
  v1dot = ddot_(3,V1best,1,V1,1)
  v2dot = ddot_(3,V2best,1,V2,1)

  call Add_Info('V1_dot_product',[v1dot],1,8)
  call Add_Info('V2_dot_product',[v2dot],1,8)

  write(u6,*) 'V1best.V1 = ',v1dot
  write(u6,*) 'V2best.V2 = ',v2dot
end if

return

end subroutine quaterreport

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! complex number in runfile
subroutine Get_zArray(Label,zData,nData)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Onei
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: nData
complex(kind=wp), intent(out) :: zData(nData)
real(kind=wp), allocatable :: rData(:)

call mma_allocate(rData,nData,label='rData')
call Get_dArray('R'//Label,rData,nData)
zData(:) = rData
call Get_dArray('I'//Label,rData,nData)
zData(:) = zData+Onei*rData
call mma_deallocate(rData)

return

end subroutine Get_zArray

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Dens_stuff

! TODO: This should probably be changed to arrays and pointers at some later point.

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), target :: ipDDij, ipDDij2, ipDDik, ipDDik2, ipDDil, ipDDil2, ipDDjk, ipDDjk2, ipDDjl, ipDDjl2, ipDDkl, ipDDkl2, &
                             ipDij, ipDij2, ipDik, ipDik2, ipDil, ipDil2, ipDjk, ipDjk2, ipDjl, ipDjl2, ipDkl, ipDkl2, mDCRij = 1, &
                             mDCRik = 1, mDCRil = 1, mDCRjk = 1, mDCRjl = 1, mDCRkl = 1, mDij, mDik, mDil, mDjk, mDjl, mDkl

public :: ipDDij, ipDDij2, ipDDik, ipDDik2, ipDDil, ipDDil2, ipDDjk, ipDDjk2, ipDDjl, ipDDjl2, ipDDkl, ipDDkl2, ipDij, ipDij2, &
          ipDik, ipDik2, ipDil, ipDil2, ipDjk, ipDjk2, ipDjl, ipDjl2, ipDkl, ipDkl2, mDCRij, mDCRik, mDCRil, mDCRjk, mDCRjl, &
          mDCRkl, mDij, mDik, mDil, mDjk, mDjl, mDkl

end module Dens_stuff

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine ass1b(D1,PAO,tmp1_,nt,nrys)
      implicit real*8 (a-h,o-z)
      dimension D1(nrys,nt),PAO(nt)
c
      If (nRys.eq.1) Then
      tmp1=0.0D0
      do it=1,nt
        tmp1 = tmp1 + PAO(iT) * D1(1,iT)
      enddo
      tmp1_ = tmp1_ + tmp1
      return

      Else If (nRys.eq.2) Then
      tmp1=0.0D0
      do it=1,nt
        tmp1 = tmp1 + (D1(1,iT)
     >              +  D1(2,iT)) * PAO(It)
      enddo
      tmp1_ = tmp1_ + tmp1
      return
c
      Else If (nRys.eq.3) Then
      tmp1=0.0D0
      do it=1,nt
        tmp1 = tmp1 + (D1(1,iT)
     >              +  D1(2,iT)
     >              +  D1(3,iT)) * PAO(It)
      enddo
      tmp1_ = tmp1_ + tmp1
      return
c
      Else If (nRys.eq.4) Then
      tmp1=0.0D0
      do it=1,nt
        tmp1 = tmp1 + (D1(1,iT)
     >              +  D1(2,iT)
     >              +  D1(3,iT)
     >              +  D1(4,iT)) * PAO(It)
      enddo
      tmp1_ = tmp1_ + tmp1
      return

      Else If (nRys.eq.5) Then
      tmp1=0.0D0
      do it=1,nt
        tmp1 = tmp1 + (D1(1,iT)
     >              +  D1(2,iT)
     >              +  D1(3,iT)
     >              +  D1(4,iT)
     >              +  D1(5,iT)) * PAO(It)
      enddo
      tmp1_ = tmp1_ + tmp1
      return
c
      Else If (nRys.eq.6) Then
      tmp1=0.0D0
      do it=1,nt
        tmp1 = tmp1 + (D1(1,iT)
     >              +  D1(2,iT)
     >              +  D1(3,iT)
     >              +  D1(4,iT)
     >              +  D1(5,iT)
     >              +  D1(6,iT)) * PAO(It)
      enddo
      tmp1_ = tmp1_ + tmp1
      return
c
      Else If (nRys.eq.7) Then
      tmp1=0.0D0
      do it=1,nt
        tmp1 = tmp1 + (D1(1,iT)
     >              +  D1(2,iT)
     >              +  D1(3,iT)
     >              +  D1(4,iT)
     >              +  D1(5,iT)
     >              +  D1(6,iT)
     >              +  D1(7,iT)) * PAO(It)
      enddo
      tmp1_ = tmp1_ + tmp1
      return
c
      Else If (nRys.eq.8) Then
      tmp1=0.0D0
      do it=1,nt
        tmp1 = tmp1 + (D1(1,iT)
     >              +  D1(2,iT)
     >              +  D1(3,iT)
     >              +  D1(4,iT)
     >              +  D1(5,iT)
     >              +  D1(6,iT)
     >              +  D1(7,iT)
     >              +  D1(8,iT)) * PAO(It)
      enddo
      tmp1_ = tmp1_ + tmp1
      return
c
      Else If (nRys.eq.9) Then
      tmp1=0.0D0
      do it=1,nt
        tmp1 = tmp1 + (D1(1,iT)
     >              +  D1(2,iT)
     >              +  D1(3,iT)
     >              +  D1(4,iT)
     >              +  D1(5,iT)
     >              +  D1(6,iT)
     >              +  D1(7,iT)
     >              +  D1(8,iT)
     >              +  D1(9,iT)) * PAO(It)
      enddo
      tmp1_ = tmp1_ + tmp1
      return
      Else
      tmp1=0.0D0
      Do iT = 1, nT
         Do iRys = 1, nRys
          tmp1 = tmp1 + PAO(It)*D1(iRys,iT)
         End Do
      End Do
      tmp1_ = tmp1_ + tmp1
      return
      End If
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LToCore(F,nAlpha,iShll,la,iAng,nvecac)
!******************************************************************************
!
! Transformation kernel to atomic orbials in normalized spherical harmonics
!
!******************************************************************************
! @parameter F  The cartesian components of <A|core>
! @parameter nAlpha Number of exponents
! @parameter ishll Shell number for ECP
! @parameter la angular momenta LS
! @parameter iAng angular momenta core
! @parameter nVecAC Number of derivatives

use Index_Functions, only: nTri_Elem1
use Real_Spherical, only: ipSph, RSph
use Basis_Info, only: Shells
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: F(*)
integer(kind=iwp), intent(in) :: nAlpha, iShll, la, iAng, nVecAC
integer(kind=iwp) :: iBk, n, nac, nBasisi, nExpi
real(kind=wp), allocatable :: Tmp1(:), Tmp2(:)

nac = nTri_Elem1(la)*nTri_Elem1(iang)
nExpi = Shells(iShll)%nExp
nBasisi = Shells(iShll)%nBasis
call mma_allocate(Tmp1,nExpi*nac*nVecAC*nalpha,Label='Tmp1')
call mma_allocate(Tmp2,nExpi*nac*nVecAC*nalpha,Label='Tmp2')
! From the lefthandside overlap, form iKaC from ikac by
! 1) i,kac -> k,aci

n = nExpi*nac*nVecAC
call DgeTMo(F,nAlpha,nAlpha,n,Tmp1,n)

! 2) aciK =  k,aci * k,K (Contract over core orbital)

n = nac*nVecAC*nAlpha
call DGEMM_('T','N',n,nBasisi,nExpi,One,Tmp1,nExpi,Shells(iShll)%pCff,nExpi,Zero,Tmp2,n)

! 3) Mult by shiftoperators aci,K -> Bk(K) * aci,K

do iBk=1,nBasisi
  Tmp1((iBk-1)*n+1:iBk*n) = Shells(iShll)%Bk(iBk)*Tmp2((iBk-1)*n+1:iBk*n)
end do

! 4) a,ciK -> ciKa

call DgeTMo(Tmp1,nTri_Elem1(la),nTri_Elem1(la),nTri_Elem1(iAng)*nVecAC*nAlpha*nBasisi,Tmp2,nTri_Elem1(iAng)*nVecAC*nAlpha*nBasisi)

! 5) iKa,C = c,iKa * c,C

call DGEMM_('T','N',nVecAC*nAlpha*nBasisi*nTri_Elem1(la),(2*iAng+1),nTri_Elem1(iAng),One,Tmp2,nTri_Elem1(iAng),RSph(ipSph(iAng)), &
            nTri_Elem1(iAng),Zero,Tmp1,nVecAC*nAlpha*nBasisi*nTri_Elem1(la))

call DgeTMo(Tmp1,nVecAC,nVecAC,nAlpha*nBasisi*nTri_Elem1(la)*(2*iAng+1),F,nAlpha*nBasisi*nTri_Elem1(la)*(2*iAng+1))

call mma_deallocate(Tmp2)
call mma_deallocate(Tmp1)

return

end subroutine LToCore

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine max5 (wrk,wrksize,
     & nind,mapd,mapi,text)
c
c     this routine find and type:
c     a) note
c     b) 5 maximal elements with their indexes in given vector V
c     c) euclidian norm
c
c     nind  - number of indexes in V (I)
c     mapd  - direct map of V (I)
c     mapi  - inverese map of V (I)
c     text  - notice (I)
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer nind
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
       character*8 text
c
c     help variables
c
       integer nhelp1,nhelp2,i,j,a,b,it
       real*8 value
       integer imax(1:8,1:5)
       real*8 rmax (1:5)
c
c0    set rmax,imax=0
c
       do 10 nhelp1=1,5
       rmax(nhelp1)=0.0d0
       do 11 nhelp2=1,8
       imax(nhelp2,nhelp1)=0
 11     continue
 10     continue
c
c
       if (nind.eq.2) then
c
c1    T1aa or T1bb amplitudes
c
c1.1  find 5 max
c
       nhelp1=mapd(1,1)
       do 100 it=1,mapd(0,5)
       do 50 i=1,dimm(mapd(0,2),mapd(it,4))
       do 51 a=1,dimm(mapd(0,1),mapd(it,3))
       value=wrk(nhelp1)
       if (abs(value).ge.abs(rmax(5))) then
c     write this amplitude
       call max5h1 (imax,rmax,mapd(it,3),0,mapd(it,4),0,a,0,i,0,
     & value)
       end if
       nhelp1=nhelp1+1
 51     continue
 50     continue
 100    continue
c
c1.2  write output
       If (fullprint.ge.0) call max5h2 (wrk,wrksize,
     & nind,mapd,mapi,rmax,imax,text)
c
       else if (mapd(0,6).eq.0) then
c
c2    T2abab amplitudes
c
c2.1  find 5 max
c
       nhelp1=mapd(1,1)
       do 200 it=1,mapd(0,5)
       do 150 j=1,dimm(mapd(0,4),mapd(it,6))
       do 151 i=1,dimm(mapd(0,3),mapd(it,5))
       do 152 b=1,dimm(mapd(0,2),mapd(it,4))
       do 153 a=1,dimm(mapd(0,1),mapd(it,3))
       value=wrk(nhelp1)
       if (abs(value).ge.abs(rmax(5))) then
c     write this amplitude
       call max5h1 (imax,rmax,mapd(it,3),mapd(it,4),
     & mapd(it,5),mapd(it,6),a,b,i,j,value)
       end if
       nhelp1=nhelp1+1
 153    continue
 152    continue
 151    continue
 150    continue
 200    continue
c
c2.2  write output
       If (fullprint.ge.0) call max5h2 (wrk,wrksize,
     & nind,mapd,mapi,rmax,imax,text)
c
       else
c
c3    T2aaaa or T2bbbb amplitudes
c
c3.1  find 5 max
c
       nhelp1=mapd(1,1)
       do 300 it=1,mapd(0,5)
c
       if (mapd(it,3).eq.mapd(it,4)) then
c     case syma=symb, symi=symj
c
       do 230 i=2,dimm(mapd(0,3),mapd(it,5))
       do 231 j=1,i-1
       do 232 a=2,dimm(mapd(0,1),mapd(it,3))
       do 233 b=1,a-1
       value=wrk(nhelp1)
       if (abs(value).ge.abs(rmax(5))) then
c     write this amplitude
       call max5h1 (imax,rmax,mapd(it,3),mapd(it,4),
     & mapd(it,5),mapd(it,6),a,b,i,j,value)
       end if
       nhelp1=nhelp1+1
 233    continue
 232    continue
 231    continue
 230    continue
c
       else
c     case syma>symb, symi> symj
       do 250 j=1,dimm(mapd(0,4),mapd(it,6))
       do 251 i=1,dimm(mapd(0,3),mapd(it,5))
       do 252 b=1,dimm(mapd(0,2),mapd(it,4))
       do 253 a=1,dimm(mapd(0,1),mapd(it,3))
       value=wrk(nhelp1)
       if (abs(value).ge.abs(rmax(5))) then
c     write this amplitude
       call max5h1 (imax,rmax,mapd(it,3),mapd(it,4),
     & mapd(it,5),mapd(it,6),a,b,i,j,value)
       end if
       nhelp1=nhelp1+1
 253    continue
 252    continue
 251    continue
 250    continue
       end if
c
 300    continue
c
c3.2  write output
       If (fullprint.ge.0) call max5h2 (wrk,wrksize,
     & nind,mapd,mapi,rmax,imax,text)
c
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FUpdt(nInter,FEq,gi_2,gi_1,g_ref,qi_2,qi_1,q_ref,u,v,w)
!***********************************************************************
!                                                                      *
! Object: to do a rank-three update on the anharmonic constants.       *
!                                                                      *
!         Observe that SlapAf stores the forces rather than the        *
!         gradients.                                                   *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nInter
real(kind=wp), intent(inout) :: FEq(nInter,nInter,nInter)
real(kind=wp), intent(in) :: gi_2(nInter), gi_1(nInter), g_ref(nInter), qi_2(nInter), qi_1(nInter), q_ref(nInter)
real(kind=wp), intent(out) :: u(nInter), v(nInter), w(nInter)
integer(kind=iwp) :: i, k, l
real(kind=wp) :: lambda, RHS, rLHS, ux, uy, vx, vy, wx, wy
real(kind=wp), external :: DDot_

!call RecPrt(' FEq',' ',FEq,nInter**2,nInter)
!call RecPrt('  gi-2',' ', gi_2,1,nInter)
!call RecPrt('  gi-1',' ', gi_1,1,nInter)
!call RecPrt('  g_ref',' ', g_ref,1,nInter)
!call RecPrt('  qi-2',' ', qi_2,1,nInter)
!call RecPrt('  qi-1',' ', qi_1,1,nInter)
!call RecPrt('  q_ref',' ', q_ref,1,nInter)

u(:) = -(gi_1(:)-g_ref(:))
v(:) = -(gi_2(:)-g_ref(:))
rLHS = DDot_(nInter,qi_2,1,u,1)-DDot_(nInter,q_ref,1,u,1)-DDot_(nInter,qi_1,1,v,1)+DDot_(nInter,q_ref,1,v,1)
write(u6,*) 'FUpdt: LHS=',rLHS
RHS = Zero
do i=1,nInter
  do k=1,nInter
    do l=1,nInter
      RHS = RHS+FEq(i,k,l)*(qi_1(i)-q_ref(i))*(qi_2(k)-q_ref(k))*(qi_2(l)-qi_1(l))
    end do
  end do
end do
RHS = Half*RHS
write(u6,*) 'FUpdt: RHS=',RHS
lambda = rLHS-RHS
write(u6,*) ' FUpdt: lambda=',lambda
w(:) = v(:)-u(:)
call RecPrt('u',' ',u,1,nInter)
call RecPrt('v',' ',v,1,nInter)
call RecPrt('w',' ',w,1,nInter)

ux = DDot_(nInter,u,1,qi_1,1)-DDot_(nInter,u,1,q_ref,1)
uy = DDot_(nInter,u,1,qi_2,1)-DDot_(nInter,u,1,q_ref,1)
vx = DDot_(nInter,v,1,qi_1,1)-DDot_(nInter,v,1,q_ref,1)
vy = DDot_(nInter,v,1,qi_2,1)-DDot_(nInter,v,1,q_ref,1)
wx = DDot_(nInter,w,1,qi_1,1)-DDot_(nInter,w,1,q_ref,1)
wy = DDot_(nInter,w,1,qi_2,1)-DDot_(nInter,w,1,q_ref,1)
lambda = Two*lambda/(ux*vy*(wy-wx)+vx*wy*(uy-ux)+wx*uy*(vy-vx))
write(u6,*) ' FUpdt: lambda=',lambda
do l=1,nInter
  do k=1,nInter
    FEq(:,k,l) = FEq(:,k,l)+lambda*(u(:)*v(k)*w(l)+v(:)*w(k)*u(l)+w(:)*u(k)*v(l))
  end do
end do

! Check on the third order condition

u(:) = -(gi_1(:)-g_ref(:))
v(:) = -(gi_2(:)-g_ref(:))
rLHS = DDot_(nInter,qi_2,1,u,1)-DDot_(nInter,q_ref,1,u,1)-DDot_(nInter,qi_1,1,v,1)+DDot_(nInter,q_ref,1,v,1)
write(u6,*) 'FUpdt: LHS(qNR)=',rLHS
RHS = Zero
do i=1,nInter
  do k=1,nInter
    do l=1,nInter
      RHS = RHS+FEq(i,k,l)*(qi_1(i)-q_ref(i))*(qi_2(k)-q_ref(k))*(qi_2(l)-qi_1(l))
    end do
  end do
end do
RHS = Half*RHS
write(u6,*) 'FUpdt: RHS(qNR)=',RHS

return

end subroutine FUpdt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  SetVectTrans
!
!> @brief
!>   Computes the translation vector from geometry 2 to geometry 1
!> @author Y. Carissan
!>
!> @details
!> Computes the translation vector from geometry 2 to geometry 1.
!>
!> @param[in]  nat1  Number of atoms in \p geom1
!> @param[in]  Geom1 First Geometry to be considered, xyz coordinates
!> @param[in]  XYZ1  atom index array in the first geometry
!> @param[in]  nat2  Number of atoms in \p geom2
!> @param[in]  Geom2 Second Geometry to be considered, xyz coordinates
!> @param[in]  XYZ2  atom index array in the second geometry
!> @param[out] V     Output vector
!***********************************************************************

subroutine SetVectTrans(nat1,Geom1,XYZ1,nat2,Geom2,XYZ2,V)

use Quater_globals, only: debug
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nat1, nat2, XYZ1(3), XYZ2(3)
real(kind=wp), intent(in) :: Geom1(3,nat1), Geom2(3,nat2)
real(kind=wp), intent(out) :: V(3)
real(kind=wp) :: O1(3), O2(3)

O1(:) = Geom1(:,XYZ1(1))
O2(:) = Geom2(:,XYZ2(1))
V(:) = O1(:)-O2(:)

if (debug) then
  call RecPrt('Vtrans',' ',V,3,1)
end if

return

end subroutine SetVectTrans

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Get_Coord_New
*
*> @brief
*>   Get the updated/new symmetry-unique Cartesian coordinates of the basis set centers
*> @author R. Lindh
*>
*> @details
*> The utility will read the updated/new symmetry-unique Cartesian coordinates of the basis set centers from the runfile.
*>
*> @param[out] CN     Array of the symmetry-unique Cartesian coordinates of the basis set centers
*> @param[in]  nAtoms Number of symmetry-unique basis set centers
************************************************************************
      Subroutine Get_Coord_New(CN,nAtoms)
      Implicit Real*8 (a-h,o-z)
      Real*8, Dimension(:,:), Allocatable :: CN
#include "stdalloc.fh"

      Character*24 Label
      Logical      Found

      Label='GeoNew'
      Call qpg_dArray(Label,Found,nAtoms3)
      nAtoms=nAtoms3/3
      If(.not.Found .or. nAtoms3.eq.0) Return
      Call mma_allocate(CN,3,nAtoms)
      Call Get_dArray(Label,CN,nAtoms3)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine get_hcsf()
!***********************************************************************
!
! Purpose: Construct the H(RASSCF) matrix in the total CSF basis
! of different spin manifolds. H(RASSCF) has been already read
! in the matrix H_CSF(:,:,N) for different spin manifolds
!
!***********************************************************************

use rhodyn_data, only: flag_so, H_CSF, HTOT_CSF, HTOTRE_CSF, ipglob, int2real, ispin, N, nconf, nconftot, prep_fhi, prep_fhr, &
                       sint, threshold, V_CSF
use rhodyn_utils, only: dashes
use mh5, only: mh5_put_dset
use Constants, only: Zero, cZero
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i, j, k, l, ii, jj, kk

if (ipglob > 2) then
  call dashes()
  write(u6,*) 'Begin get_Hcsf'
  call dashes()
end if

! Construct the Hamiltonian matrix H(RASSCF) in CSF basis include all
! spin manifolds to HTOTRE_CSF
HTOTRE_CSF(:,:) = Zero
ii = 0
jj = 0
kk = 0
if (flag_so) then
  do i=1,N
    if (i /= 1) ii = ii+nconf(i-1)*ispin(i-1)
    do j=1,nconf(i)
      do k=1,nconf(i)
        do l=1,ispin(i)
          jj = ii+(j-1)*ispin(i)+l
          kk = ii+(k-1)*ispin(i)+l
          HTOTRE_CSF(jj,kk) = H_CSF(j,k,i)
        end do
      end do
    end do
  end do
else
  ! without accounting for spin-degeneracy
  do i=1,N
    if (i /= 1) ii = ii+nconf(i-1)
    do j=1,nconf(i)
      do k=1,nconf(i)
        jj = ii+j
        kk = ii+k
        HTOTRE_CSF(jj,kk) = H_CSF(j,k,i)
      end do
    end do
  end do
end if

if (ipglob > 2) then
  write(u6,*) 'Construct the full Hamiltonian with (possibly) SOC!'
  call dashes()
  write(u6,sint) 'number of NCSF:',nconftot
  call dashes()
end if
HTOT_CSF(:,:) = cZero

! If consider the spin-orbit coupling
! Computing the total Hamiltonian H(RASSCF)+H(SO) in CSF basis
! to HTOT_CSF
if (.not. flag_so) then
  HTOT_CSF(:,:) = HTOTRE_CSF
else
  HTOT_CSF(:,:) = HTOTRE_CSF+V_CSF
end if
if (ipglob > 2) write(u6,*) 'end constructing full Hamiltonian'

! Check whether total Hamiltonian is hermitian
if (ipglob > 3) then
  call dashes()
  write(u6,*) 'Check whether total Hamiltonian HTOT_CSF is Hermitian'
  call dashes()
  do i=1,nconftot
    do j=1,nconftot
      if (abs(real(HTOT_CSF(i,j)-HTOT_CSF(j,i))) >= threshold) then
        write(u6,int2real) 'WARNING!!!: HTOT_CSF matrix is not hermitian in real part:',i,j,real(HTOT_CSF(i,j)), &
                           real(HTOT_CSF(j,i))
      end if
      if (abs(aimag(HTOT_CSF(i,j)+HTOT_CSF(j,i))) >= threshold) then
        write(u6,int2real) 'WARNING!!!: HTOT_CSF matrix is not hermitian in imag part:',i,j,aimag(HTOT_CSF(i,j)), &
                           aimag(HTOT_CSF(j,i))
      end if
    end do
  end do

  write(u6,*) 'If there is no warning info, total Hamiltonian matrix HTOT_CSF is hermitian!'
end if

call mh5_put_dset(prep_fhr,real(HTOT_CSF))
call mh5_put_dset(prep_fhi,aimag(HTOT_CSF))

if (ipglob > 2) write(u6,*) 'end get_Hcsf'

end subroutine get_hcsf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,2001, Roland Lindh                                *
************************************************************************
      SubRoutine PCMInt(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &                  Final,nZeta,nIC,nComp,la,lb,A,RB,nRys,
     &                  Array,nArr,CCoor,nOrdOp,lOper,iChO,
     &                  iStabM,nStabM)
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of nuclear attraction     *
*         integrals.                                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, January '91                             *
*                                                                      *
*             Modified to PCM-integrals, by RL June '01, Napoli, Italy.*
************************************************************************
      use PCM_arrays
      Implicit Real*8 (A-H,O-Z)
*     Used for normal nuclear attraction integrals
      External TNAI, Fake, XCff2D, XRys2D
*     Used for finite nuclei
      External TERI, ModU2, vCff2D, vRys2D
#include "real.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nIC),
     &       Zeta(nZeta), ZInv(nZeta), Alpha(nAlpha), Beta(nBeta),
     &       rKappa(nZeta), P(nZeta,3), A(3), RB(3), CCoor(3,nComp),
     &       Array(nZeta*nArr)
      Integer iStabM(0:nStabM-1), lOper(nComp)
*-----Local arrys
      Real*8 C(3), TC(3), Coora(3,4), Coori(3,4), CoorAC(3,2)
      Logical EQ, NoSpecial
      Integer iAnga(4), iDCRT(0:7), iChO(nComp)
      Character ChOper(0:7)*3
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
      Dimension jStab_(0:0)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = 0
      iAnga(4) = 0
      call dcopy_(3,A,1,Coora(1,1),1)
      call dcopy_(3,RB,1,Coora(1,2),1)
      call dcopy_(2*3,Coora,1,Coori,1)
      mabMin = nabSz(Max(la,lb)-1)+1
      If (EQ(A,RB)) mabMin=nabSz(la+lb-1)+1
      mabMax = nabSz(la+lb)
*
*     Compute FLOP's and size of work array which Hrr will use.
*
      Call mHrr(la,lb,nFLOP,nMem)
*
*     Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
       call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
       call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
*---- The coordinates of the individual tiles are not stabilized by any
*     operator but the unit operator.
*
      nStab_=1
      jStab_=0
*
*     Loop over tiles.
*
      Do iTile = 1, nTiles
         QTessera = Q_Tessera(iTile)
         C(:)=C_Tessera(:,iTile)
#ifdef _DEBUGPRINT_
         Call RecPrt('C',' ',C,1,3)
#endif
*
*--------Find the DCR for M and S
*
         Call DCR(LmbdT,iStabM,nStabM,jStab_,nStab_,iDCRT,nDCRT)
         Fact = One / DBLE(LmbdT)
*
#ifdef _DEBUGPRINT_
         Write (6,*) ' m      =',nStabM
         Write (6,'(9A)') '(M)=',(ChOper(iStabM(ii)),
     &         ii = 0, nStabM-1)
         Write (6,*) ' s      =',nStab_
         Write (6,'(9A)') '(S)=',ChOper(jStab_)
         Write (6,*) ' LambdaT=',LmbdT
         Write (6,*) ' t      =',nDCRT
         Write (6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),
     &         ii = 0, nDCRT-1)
#endif

*
         Do lDCRT = 0, nDCRT-1
            Call OA(iDCRT(lDCRT),C,TC)
            call dcopy_(3,TC,1,CoorAC(1,2),1)
            call dcopy_(3,TC,1,Coori(1,3),1)
            call dcopy_(3,TC,1,Coori(1,4),1)
            call dcopy_(3,TC,1,Coora(1,3),1)
            call dcopy_(3,TC,1,Coora(1,4),1)
*
*           Compute integrals with the Rys quadrature.
*
            nT = nZeta
            NoSpecial=.True.
            Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &               [One],[One],1,P,nZeta,
     &               TC,1,rKappa,[One],Coori,Coora,CoorAC,
     &               mabmin,mabmax,0,0,Array,nArr*nZeta,
     &               TNAI,Fake,XCff2D,XRys2D,NoSpecial)
*
*-----------Use the HRR to compute the required primitive integrals.
*
            Call HRR(la,lb,A,RB,Array,nZeta,nMem,ipIn)
*
*-----------Accumulate contributions to the symmetry adapted operator
*
            nOp = NrOpr(iDCRT(lDCRT))
            Call SymAdO(Array(ipIn),nZeta,la,lb,nComp,Final,nIC,
     &                  nOp         ,lOper,iChO,-Fact*QTessera)
#ifdef _DEBUGPRINT_
            Write (6,*) Fact*QTessera
            Call RecPrt('PCMInt: Array(ipIn)',' ',Array(ipIn),
     &              nZeta,nElem(la)*nElem(lb)*nComp)
            Call RecPrt('PCMInt: Final',' ',Final,
     &              nZeta,nElem(la)*nElem(lb)*nIC)
#endif
*
         End Do
      End Do

#ifdef _WARNING_WORKAROUND_
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_integer(nRys)
         Call Unused_real_array(CCoor)
         Call Unused_integer(nOrdOp)
      End If
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
*               1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine AlloK2_Funi(nr_of_Densities)
************************************************************************
*                                                                      *
*  Object: Allocate space for K2 entities.                             *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, Sweden. November '92                 *
*             Martin Schuetz, Dept. of Theoretical Chemistry,          *
*             University of Lund, Sweden. Jun '95                      *
************************************************************************
      use iSD_data
      use k2_arrays
      use IOBUF
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
#include "real.fh"
#include "nsd.fh"
#include "setup.fh"
#include "status.fh"
*
*
      Call Nr_Shells(nSkal)
*
*     determine memory size nDeDe, MaxDe, and MaxDRC
      nDeDe_DFT = 0
      MaxDe     = 0
*
************************************************************************
*                                                                      *
*                                                                      *
*-----Double loop over shells. These loops decide the integral type
*
      Do iS = 1, nSkal
C        iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
C        mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
*
         Do jS = 1, iS
C           jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
C           mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
*
C           iDeSiz = 1 + iPrim*jPrim + (iBas*jBas+1)*iCmp*jCmp
            iDeSiz = iBas*jBas*iCmp*jCmp
            MaxDe = Max(MaxDe,iDeSiz)
            iSmLbl = 1
            nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            If (nSO.gt.0) Then
               nDeDe_DFT = nDeDe_DFT
     &                   + nr_of_Densities*iDeSiz*nIrrep
            End If
*
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine Cff2D(nabMax,ncdMax,nRys,Zeta,ZInv,Eta,EInv,nT,Coori,CoorAC,P,Q,la,lb,lc,ld,U2,PAQP,QCPQ,B10,B00,lac,B01)
!***********************************************************************
!                                                                      *
! Object: to compute the coefficients in the three terms recurrence    *
!         relation of the 2D-integrals.                                *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
! Modified loop structure for RISC 1991 R. Lindh, Dept. of Theoretical *
! Chemistry, University of Lund, Sweden.                               *
!***********************************************************************

use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nabMax, ncdMax, nRys, nT, la, lb, lc, ld, lac
real(kind=wp), intent(in) :: Zeta(nT), ZInv(nT), Eta(nT), EInv(nT), Coori(3,4), CoorAC(3,2), P(nT,3), Q(nT,3), U2(nRys,nT)
real(kind=wp), intent(inout) :: PAQP(nRys,nT,3), QCPQ(nRys,nT,3), B10(nRys,nT,3), B00(nRys,nT,3), B01(nRys,nT,3)
integer(kind=iwp) :: iCar, iT
real(kind=wp) :: h12
logical(kind=iwp) :: AeqB, CeqD, EQ

!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt(' In Cff2D: Coori',' ',Coori,3,4)
call RecPrt(' In Cff2D: U2',' ',U2,nRys,nT)
#endif
AeqB = EQ(Coori(1,1),Coori(1,2))
CeqD = EQ(Coori(1,3),Coori(1,4))

h12 = Half
if ((nabMax /= 0) .and. (ncdMax /= 0)) then
  B00(:,:,1) = h12*U2(:,:)
  do iT=1,nT
    B10(:,iT,1) = (h12-h12*U2(:,iT)*Eta(iT))*ZInv(iT)
    B01(:,iT,1) = (h12-h12*U2(:,iT)*Zeta(iT))*EInv(iT)
  end do
else if ((ncdMax == 0) .and. (nabMax /= 0) .and. (lac == 0)) then
  do iT=1,nT
    B10(:,iT,1) = (h12-h12*U2(:,iT)*Eta(iT))*ZInv(iT)
  end do
else if ((nabMax == 0) .and. (ncdMax /= 0) .and. (lac == 0)) then
  do iT=1,nT
    B01(:,iT,1) = (h12-h12*U2(:,iT)*Zeta(iT))*EInv(iT)
  end do
else if ((ncdMax == 0) .and. (nabMax /= 0)) then
  B00(:,:,1) = h12*U2(:,:)
  do iT=1,nT
    B10(:,iT,1) = (h12-h12*U2(:,iT)*Eta(iT))*ZInv(iT)
  end do
else if ((nabMax == 0) .and. (ncdMax /= 0)) then
  B00(:,:,1) = h12*U2(:,:)
  do iT=1,nT
    B01(:,iT,1) = (h12-h12*U2(:,iT)*Zeta(iT))*EInv(iT)
  end do
else if ((nabMax == 0) .and. (ncdMax == 0) .and. (lac /= 0)) then
  B00(:,:,1) = h12*U2(:,:)
end if
if (nabMax /= 0) then
  B10(:,:,2) = B10(:,:,1)
  B10(:,:,3) = B10(:,:,1)
end if
if (lac /= 0) then
  B00(:,:,2) = B00(:,:,1)
  B00(:,:,3) = B00(:,:,1)
end if
if (ncdMax /= 0) then
  B01(:,:,2) = B01(:,:,1)
  B01(:,:,3) = B01(:,:,1)
end if

if ((la+lb /= 0) .and. (lc+ld /= 0)) then
  if ((.not. AeqB) .and. (.not. CeqD)) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = P(iT,iCar)-CoorAC(iCar,1)+Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
        QCPQ(:,iT,iCar) = Q(iT,iCar)-CoorAC(iCar,2)-Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  else if (AeqB .and. (.not. CeqD)) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
        QCPQ(:,iT,iCar) = Q(iT,iCar)-CoorAC(iCar,2)-Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  else if ((.not. AeqB) .and. CeqD) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = P(iT,iCar)-CoorAC(iCar,1)+Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
        QCPQ(:,iT,iCar) = -Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  else
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
        QCPQ(:,iT,iCar) = -Zeta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  end if
else if (la+lb /= 0) then
  if (.not. AeqB) then
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = P(iT,iCar)-CoorAC(iCar,1)+Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  else
    do iCar=1,3
      do iT=1,nT
        PAQP(:,iT,iCar) = Eta(iT)*U2(:,iT)*(Q(iT,iCar)-P(iT,iCar))
      end do
    end do
  end if
else if (lc+ld /= 0) then
  if (.not. CeqD) then
    do iCar=1,3
      do iT=1,nT
        QCPQ(:,iT,iCar) = Q(iT,iCar)-CoorAC(iCar,2)+Zeta(iT)*U2(:,iT)*(P(iT,iCar)-Q(iT,iCar))
      end do
    end do
  else
    do iCar=1,3
      do iT=1,nT
        QCPQ(:,iT,iCar) = Zeta(iT)*U2(:,iT)*(P(iT,iCar)-Q(iT,iCar))
      end do
    end do
  end if
end if
#ifdef _DEBUGPRINT_
if (la+lb > 0) then
  call RecPrt(' PAQP(x)',' ',PAQP(:,:,1),nRys,nT)
  call RecPrt(' PAQP(y)',' ',PAQP(:,:,2),nRys,nT)
  call RecPrt(' PAQP(z)',' ',PAQP(:,:,3),nRys,nT)
end if
if (lc+ld > 0) then
  call RecPrt(' QCPQ(x)',' ',QCPQ(:,:,1),nRys,nT)
  call RecPrt(' QCPQ(y)',' ',QCPQ(:,:,2),nRys,nT)
  call RecPrt(' QCPQ(z)',' ',QCPQ(:,:,3),nRys,nT)
end if
if (nabMax /= 0) then
  call RecPrt(' B10(x)',' ',B10(:,:,1),nRys,nT)
  call RecPrt(' B10(y)',' ',B10(:,:,2),nRys,nT)
  call RecPrt(' B10(z)',' ',B10(:,:,3),nRys,nT)
end if
if (lac /= 0) then
  call RecPrt(' B00(x)',' ',B00(:,:,1),nRys,nT)
  call RecPrt(' B00(y)',' ',B00(:,:,2),nRys,nT)
  call RecPrt(' B00(z)',' ',B00(:,:,3),nRys,nT)
end if
if (ncdMax /= 0) then
  call RecPrt(' B01(x)',' ',B01(:,:,1),nRys,nT)
  call RecPrt(' B01(y)',' ',B01(:,:,2),nRys,nT)
  call RecPrt(' B01(z)',' ',B01(:,:,3),nRys,nT)
end if
#endif

return

end subroutine Cff2D

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine int_sort()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "files_gugaci.fh"
      dimension idx(4)
      data zero/0.d0/

      idx=0
      stime=c_time()

!estimate the largest block of integrals, notice we do not use symmetry
!here
      if(norb_ext.gt.norb_inn) then
! (ab|cd)
        numb=norb_ext*(norb_ext+1)/2
        numb=numb*(numb+1)/2+norb_ext*numb
      else
! (ii|ab)
        numb=norb_inn*(norb_inn+1)/2
        numb=numb*norb_ext*(norb_ext+1)/2
      endif
! (ia|bc)+(ij|ka)
      lra=norb_inn*norb_ext*(norb_ext+1)*norb_ext/2
     &   +norb_inn*(norb_inn+1)*norb_inn*norb_ext/2
      if(lra.gt.numb) numb=lra

      allocate(vint_ci(numb))
      vint_ci=0.d0
      numb=0
      write(6,900)
      call int_index(numb)
#ifdef MOLPRO
      call intrd
#else
      call intrd_molcas
#endif
c --------     vtint(*)-->vint_ci(*)    ------------
      numb=1
      call int_sort_inn(numb)         !_ext_0  (ijkl,ijkk,iijj)
      idisk=0
      call idafile(luciint,1,idx,4,idisk)
      idx(1)=idisk
      numb=numb-1
      call idafile(luciint,1,[numb],1,idisk)
      call ddafile(luciint,1,vint_ci,numb,idisk)
      write(6,902) numb
      maxintseg=numb

      vint_ci=0.d0
      numb=1
      call int_sort_inn_1(numb)       !_ext_3_1  (iabc and iaqq)
      call int_sort_inn_3(numb)       !_ext_1    (ijka)
      idx(2)=idisk
      numb=numb-1
      call idafile(luciint,1,[numb],1,idisk)
      call ddafile(luciint,1,vint_ci,numb,idisk)
      write(6,903) numb
      if(numb.gt.maxintseg) then
        maxintseg=numb
      endif

c  sum over iaqq
      viasum_0(1:norb_dz,1:norb_ext)=zero
      viasum_1(1:norb_dz,1:norb_ext)=zero
      do lri=norb_frz+1,norb_inn
        ia0=(lri-1)*norb_ext
        do lra=1,norb_ext
          ia=ia0+lra
          intposbase=intind_iaqq(ia)
          if(intposbase.eq.0) cycle
          do lrk=1,norb_dz
            idorbint=lrk*2-2
            intpos=intposbase+idorbint
            viasum_0(lri,lra)=viasum_0(lri,lra)+vint_ci(intpos)
            viasum_1(lri,lra)=viasum_1(lri,lra)+vint_ci(intpos+1)
          enddo
        enddo
      enddo

      vint_ci=0.d0
      numb=1
      call int_sort_inn_2(numb)   !_ext_2_1  (ijcc, ijab, abkk)
      idx(3)=idisk
      numb=numb-1
      call idafile(luciint,1,[numb],1,idisk)
      call ddafile(luciint,1,vint_ci,numb,idisk)
      write(6,904) numb
      if(numb.gt.maxintseg) then
        maxintseg=numb
      endif

c  sum over (abkk)
      intspace=intspace_abkk(1)
      intpos=intind_abkk(1)
      vijkk_0sum(1:intspace)=zero
      vijkk_1sum(1:intspace)=zero
      do lrk=1,norb_dz
        do ivalue=1,intspace
          vijkk_0sum(ivalue)=vijkk_0sum(ivalue)+vint_ci(intpos)
          vijkk_1sum(ivalue)=vijkk_1sum(ivalue)+vint_ci(intpos+1)
          intpos=intpos+2
        enddo
      enddo

      vint_ci=0.d0
      numb=1
      call int_sort_ext(numb)         !_ext_4_3_2  (abcd,abcc,aabb)
      idx(4)=idisk
      numb=numb-1
      call idafile(luciint,1,[numb],1,idisk)
      call ddafile(luciint,1,vint_ci,numb,idisk)
      write(6,905) numb
      if(numb.gt.maxintseg) then
        maxintseg=numb
      endif

      idisk=0
      call idafile(luciint,1,idx,4,idisk)

      write(6,910)
      deallocate(vint_ci)

      etime=c_time()
      time=etime-stime
      write(6,912) time

900   format(1x,"start integral sorting",/,
     *       1x,"start reading integral file",/)
c901   format(1x,"end reading integral file",/)
902   format(1x,"number of integrals in internal space is ",i8)
903   format(1x,"number of integrals which have one or three "
     *       ,"indexs in external space is ",i8)
904   format(1x,"number of integrals which have two indexs in "
     *       ,"external space is ",i8)
905   format(1x,"number of integrals in external space is ",i8)
910   format(1x,/,1x,"end of integral sorting")
912   format(1x,"total wall clock time for integral sorting=",
     *       f8.2," s",/)
      end

      subroutine blocks()
c**************************************
#include "drt_h.fh"
#include "intsort_h.fh"
c                              ----- 1 - electron integrals -----
      nint1=0
      do 1 ip=1,ng_sm
        nint1=nint1+((nlsm_all(ip)+1)*nlsm_all(ip))/2
  1   continue
c
c                              ----- 2 - electron integrals -----
      nint2=0
      nblock=0
      do 10 ip=1,ng_sm
        npp=(nlsm_all(ip)+1)*nlsm_all(ip)/2
        nintb=npp*(npp-1)/2
        nint2=nint2+nintb
        nblock=nblock+1
        do 11 i=1,4
        iblktb(i,nblock)=ip
  11    continue
        iblktb(5,nblock)=nint2
  10  continue
      do 20 ip=1,ng_sm
        npp=(nlsm_all(ip)+1)*nlsm_all(ip)/2
        irm=ip
      do 21 ir=1,irm-1
        nrr=(nlsm_all(ir)+1)*nlsm_all(ir)/2
        nintb=npp*nrr
        nint2=nint2+nintb
        nblock=nblock+1
        iblktb(1,nblock)=ip
        iblktb(2,nblock)=ip
        iblktb(3,nblock)=ir
        iblktb(4,nblock)=ir
        iblktb(5,nblock)=nint2
  21  continue
  20  continue
      do 30 ip=1,ng_sm
        iqm=ip
      do 31 iq=1,iqm-1
        ipq=nlsm_all(ip)*nlsm_all(iq)
        nintb=ipq*(ipq-1)/2
        nint2=nint2+nintb
        nblock=nblock+1
        iblktb(1,nblock)=ip
        iblktb(2,nblock)=iq
        iblktb(3,nblock)=ip
        iblktb(4,nblock)=iq
        iblktb(5,nblock)=nint2
  31  continue
  30  continue
      do 40 ip=4,8
        if(nlsm_all(ip).eq.0) goto 40
          iqm=ip
        do 41 iq=1,iqm-1
          if(nlsm_all(iq).eq.0) goto 41
          npq=nlsm_all(ip)*nlsm_all(iq)
          ispq=mul_tab(ip,iq)
          irm=ip
          do 42 ir=1,irm-1
            if(nlsm_all(ir).eq.0) goto 42
            ispqr=mul_tab(ispq,ir)
            ism=ir
            if(ip.eq.ir) ism=iq
            do 43 is=1,ism-1
              if(nlsm_all(is).eq.0) go to 43
              if(is.ne.ispqr) go to 43
              nrs=nlsm_all(ir)*nlsm_all(is)
              nintb=npq*nrs
              nint2=nint2+nintb
              nblock=nblock+1
              iblktb(1,nblock)=ip
              iblktb(2,nblock)=iq
              iblktb(3,nblock)=ir
              iblktb(4,nblock)=is
              iblktb(5,nblock)=nint2
  43        continue
  42      continue
  41    continue
  40  continue
      nint12=nint1+nint2

      write(6,100) nint1,nint2,nint12
c      write(12,100) nint1,nint2,nint12
  100 format(' ',1x/2x,
     -  'number of 1-electron integrals  :',i9/2x,
     -  'number of 2-electron integrals  :',i9/2x,
     -  'total number of integrals       :',i9)
      write(6,200) nint1
c      write(12,200) nint1
  200 format(' ',1x/2x,
     -  '1-electron blocks  :   1 to',i8/2x,29(1h*))
      write(6,300) (j,(iblktb(i,j),i=1,5),j=1,nblock)
c      write(12,300) (j,(iblktb(i,j),i=1,5),j=1,nblock)
  300 format(' ',1x/2x,
     -  '2-electron block description  :'/2x,
     -      40(1h*)/2x,50(3('(',i3,')',4i2,i8,3x)/2x))
      return
      end

      subroutine ff(i,j)
       i=0
       do 10 iq=1,j
       j0=iq*(iq-1)/2+iq
       if(j0.ne.j)goto 10
       i=iq
       goto 100
10     continue
100    return
       end

      subroutine int_sort_ext(ii)         !_ext_4_3_2
#include "drt_h.fh"
#include "intsort_h.fh"
      dimension lsmtmp(8)
!  _002_aa_
      ip2_aa_ext_base=ii
      do lsma=1,ng_sm
        iasta=ibsm_ext(lsma)
        ibsta=iasta+1
        ibend=iesm_ext(lsma)
        do ib=ibsta,ibend
          jb=norb_number(ib)
          do ia=iasta,ib-1
            ja=norb_number(ia)
            vint_ci(ii)=voint(jb,ja)          !(ja|jb)
!            write(10,'(2x,a20,i8,f16.8)')
!     *            '  int_sort_002',ii,vint_ci(ii)
            ii=ii+1
          enddo
        enddo
      enddo
!  _002_dd_
      ip2_dd_ext_base=ii
c     write(10,'(2x,a20,i8)')' ip2_dd_ext_base=',      ii
      do ib=2,norb_ext
        jb=norb_number(ib)
        do ia=1,ib-1
          ja=norb_number(ia)
          vint_ci(ii)=voint(ja,jb)   !(ja,jb|ja,jb)
!       write(6,'(i2,2x,i2)') ja,jb
!       write(6,'(2x,a20,i8,f16.8)')'  int_sort_002',ii,vint_ci(ii)
          ii=ii+1
        enddo
      enddo
!_003
      ip3_abd_ext_base=ii
c     write(10,'(2x,a20,i8)')' ip3_abd_ext_base=',      ii

      do ic=1,norb_ext
        lrc=norb_number(ic)
!       ip3_abd_ext_base(ic)=ii
      do lsma=1,ng_sm
        iasta=ibsm_ext(lsma)
!       iaend=iesm_ext(lsma)-1
        ibsta=iasta+1
        ibend=iesm_ext(lsma)
        do ib=ibsta,ibend
          lrb=norb_number(ib)
          do ia=iasta,ib-1
            lra=norb_number(ia)
            vint_ci(ii)=vfutei(lra,lrc,lrb,lrc)
            vint_ci(ii+1)=vfutei(lra,lrb,lrc,lrc)
!      write(10,'(2x,4i6,i8,2f16.8)')
!     :   lra,lrb,lrc,lrc,ii,vint_ci(ii),vint_ci(ii+1)
            ii=ii+2
          enddo
        enddo
      enddo
      enddo
      np3_abd_ext=0
      do isma=1,ng_sm
        na=nlsm_ext(isma)
        if ( na .le. 0 ) cycle
          np3_abd_ext=np3_abd_ext+na*(na-1)
      enddo
!_004
!      ==================================
!          la<lb<lc<ld
!      ===================================
!       1. ext _abcd_
!       ip4_abcd_ext_base=ii
      do lsmd=1,ng_sm
        idsta=ibsm_ext(lsmd)
        idend=iesm_ext(lsmd)
        do lsmc=1,lsmd
          icsta=ibsm_ext(lsmc)
          icend=iesm_ext(lsmc)
          if ( lsmc .eq. lsmd ) idsta=idsta+1
            lsmcd=mul_tab(lsmc,lsmd)
            do lsmb=1,lsmc
              lsma=mul_tab(lsmb,lsmcd)
              if ( lsma .gt. lsmb ) cycle
                ibsta=ibsm_ext(lsmb)
                ibend=iesm_ext(lsmb)
                iasta=ibsm_ext(lsma)
                iaend=iesm_ext(lsma)
              if ( lsmd .eq. lsmb ) idsta=idsta+1
              if ( lsmc .eq. lsmb ) icsta=icsta+1
              if ( lsmd .eq. lsma ) idsta=idsta+1
              if ( lsmc .eq. lsma ) icsta=icsta+1
              if ( lsmb .eq. lsma ) ibsta=ibsta+1
                lsmtmp=lsma+jp2(lsmb)+jp3(lsmc)
                ip4_abcd_ext_base(lsmtmp)=ii
c     write(10,'(2x,a20,2i8)')' ip4_abcd_ext_base=',  lsmtmp,ii
      do id=idsta,idend
        lrd=norb_number(id)
        do ic=icsta,min(id-1,icend)
          lrc=norb_number(ic)
          do ib=ibsta,min(ic-1,ibend)
            lrb=norb_number(ib)
            do ia=iasta,min(ib-1,iaend)
              lra=norb_number(ia)
              vint_ci(ii)=vfutei(lra,lrb,lrc,lrd)       !lra>lrb>lrc>lrd
              vint_ci(ii+1)=vfutei(lra,lrc,lrb,lrd)
              vint_ci(ii+2)=vfutei(lra,lrd,lrc,lrb)
              ii=ii+3
            enddo
          enddo
        enddo
      enddo

          enddo
        enddo
      enddo
      end

!===================== ext_2_1 sta ===================
      subroutine int_sort_inn_2(ii)
#include "drt_h.fh"
#include "intsort_h.fh"
c     (ijcc,ijab)
      do ismab=1,ng_sm
        ip2_ab_inn_base(ismab)=ii
        do lri=norb_frz+1,norb_inn-1
          lsmi=lsm_inn(lri)
          do lrj=lri+1,norb_inn
            lsmj=lsm_inn(lrj)
            lsmij=mul_tab(lsmi,lsmj)
            if ( ismab .ne. lsmij ) cycle
            call int_ext_2_1(lri,lrj,lsmij,ii)
          enddo
        enddo
      enddo

c     (abkk)
      do lri=1,norb_inn
        intind_abkk(lri)=ii
        intspace_abkk(lri)=0
        do lmb=1,ng_sm
          ibsta=ibsm_ext(lmb)
          ibend=iesm_ext(lmb)
          do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
              lra=norb_number(ira)
              intspace_abkk(lri)=intspace_abkk(lri)+1
              vint_ci(ii)=vfutei(lra,lri,lrb,lri)
              vint_ci(ii+1)=vint_ci(ii)-2*vfutei(lra,lrb,lri,lri)
!       write(6,'(2x,4i6,i8,3f16.8)')lra,lrb,lri,lri,ii,
!     *        vint_ci(ii),vint_ci(ii+1)
              ii=ii+2
            enddo
          enddo
        enddo
      enddo

      return
      end

      subroutine int_ext_2_1(lri,lrj,lsmij,ii)
#include "drt_h.fh"
#include "intsort_h.fh"
c      write(10,*)'     start intind_ijab',lri,lrj,ii
      ij=lri-norb_frz+ngw2(lrj-norb_frz)
      if ( lsmij .eq. 1 ) then       !ijcc
c        write(10,*)'     start intind_ijcc',ii
        intind_ijcc(ij)=ii
        intspace_ijcc(ij)=0
        do ic=1,norb_ext
          intspace_ijcc(ij)=intspace_ijcc(ij)+1
          lrc=norb_number(ic)
          vint_ci(ii)=vfutei(lrj,lrc,lri,lrc)
          vint_ci(ii+1)=vfutei(lrj,lri,lrc,lrc)
c      write(10,'(2x,4i6,i8,3f16.8)')lrj,lri,lrc,lrc,ii,
c     *          vint_ci(ii),vint_ci(ii+1)
          ii=ii+2
        enddo
      endif
      intind_ijab(ij)=ii
      intspace_ijab(ij)=0
      do lsmc=1,ng_sm
        lsmd=mul_tab(lsmij,lsmc)
        if ( lsmd .gt. lsmc ) cycle
        icsta=ibsm_ext(lsmc)
        icend=iesm_ext(lsmc)
        idsta=ibsm_ext(lsmd)
        idend=iesm_ext(lsmd)
        if ( lsmc .eq. lsmd ) icsta=icsta+1
        do ic=icsta,icend
          jc=norb_number(ic)
          do id=idsta,min(idend,ic-1)
            intspace_ijab(ij)=intspace_ijab(ij)+1
            jd=norb_number(id)
            vint_ci(ii)=vfutei(jd,jc,lrj,lri)
            vint_ci(ii+1)=vfutei(jd,lrj,jc,lri)
            vint_ci(ii+2)=vfutei(jd,lri,lrj,jc)
c      write(10,'(2x,4i6,i8,3f16.8)')jd,jc,lrj,lri,ii,
c     *          vint_ci(ii),vint_ci(ii+1),vint_ci(ii+2)
            ii=ii+3
          enddo
        enddo
      enddo
      return
      end
!===================== ext_2_1 end ===================
!===================== ext_1 sta ======================
      subroutine int_sort_inn_3(ii)
#include "drt_h.fh"
#include "intsort_h.fh"
c     write(10,'(2x,a20,i8)')' int_inn_3_base=',      ii
c      write(10,*)'     start intind_ijka',ii
      do lri=norb_frz+1,norb_inn-2
        lsmi=lsm_inn(lri)
        do lrj=lri+1,norb_inn-1
          lsmj=lsm_inn(lrj)
          lsmij=mul_tab(lsmi,lsmj)
          do lrk=lrj+1,norb_inn
            lsmk=lsm_inn(lrk)
            lsmd=mul_tab(lsmij,lsmk)
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrk-norb_frz)
            intind_ijka(ijk)=ii
            iasta=ibsm_ext(lsmd)
            iaend=iesm_ext(lsmd)
            do ia=iasta,iaend
              ja=norb_number(ia)
              vint_ci(ii)=vfutei(ja,lrk,lrj,lri)
              vint_ci(ii+1)=vfutei(ja,lrj,lrk,lri)
              vint_ci(ii+2)=vfutei(ja,lri,lrk,lrj)
c     write(10,'(2x,4i6,i8,3f16.8)')ja,lrk,lrj,lri,ii,
c    *       vint_ci(ii),vint_ci(ii+1),vint_ci(ii+2)
              ii=ii+3
            enddo
          enddo
        enddo
      enddo
      end

!===================== _ext_1 end ======================
      subroutine int_ext_3_2_1(lri,lsmi,ii)
#include "drt_h.fh"
#include "intsort_h.fh"
c      write(10,*)'   int_ext_3_2_1'
      iabc0=(lri-1)*nabc
c     write(10,*)'     start intind_iabc',ii
      do lsmd=1,ng_sm
        lsmbc=mul_tab(lsmi,lsmd)
        do lsmc=1,lsmd
          lsmb=mul_tab(lsmbc,lsmc)
          if ( lsmb .gt. lsmc ) cycle
            idsta=ibsm_ext(lsmd)
            idend=iesm_ext(lsmd)
            icsta=ibsm_ext(lsmc)
            icend=iesm_ext(lsmc)
            ibsta=ibsm_ext(lsmb)
            ibend=iesm_ext(lsmb)
            if ( lsmb .eq. lsmc ) icsta=icsta+1
            if ( lsmc .eq. lsmd ) idsta=idsta+1
            if ( lsmb .eq. lsmd ) idsta=idsta+1
            do ird=idsta,idend
              lrd=norb_number(ird)
              nd=ngw3(ird)
              do irc=icsta,min(icend,ird-1)
                lrc=norb_number(irc)
                nc=ngw2(irc)
                do irb=ibsta,min(ibend,irc-1)
                  lrb=norb_number(irb)
                  nb=irb
                  iabc=iabc0+nb+nc+nd
                  intind_iabc(iabc)=ii
                  vint_ci(ii)=vfutei(lrb,lrc,lrd,lri)
                  vint_ci(ii+1)=vfutei(lrb,lrd,lrc,lri)
                  vint_ci(ii+2)=vfutei(lrb,lri,lrd,lrc)
                  ii=ii+3
                enddo
              enddo
            enddo
          enddo
        enddo

c      write(10,*)'     start intind_iaqq',ii
      ib0=(lri-1)*norb_ext
      lsmb=lsmi                       !3_ibqq
      ibsta=ibsm_ext(lsmb)
      ibend=iesm_ext(lsmb)
      do irb=ibsta,ibend
        lrb=norb_number(irb)
        ib=ib0+irb
        intind_iaqq(ib)=ii
        do lrc=1,norb_inn
          vint_ci(ii)=vfutei(lrb,lrc,lri,lrc)
          vint_ci(ii+1)=vfutei(lrb,lri,lrc,lrc)
          ii=ii+2
        enddo
        do irc=norb_ext,1,-1
          lrc=norb_number(irc)
          vint_ci(ii)=vfutei(lrb,lrc,lri,lrc)
          vint_ci(ii+1)=vfutei(lrb,lri,lrc,lrc)
!      write(6,'(2x,4i6,i8,3f16.8)')lrb,lri,lrc,lrc,ii,
!     *      vint_ci(ii),vint_ci(ii+1)
          ii=ii+2
        enddo
      enddo

      end

      subroutine int_sort_inn_1(ii)
#include "drt_h.fh"
#include "intsort_h.fh"

      call determine_para_array_for_int1ind()

      do lri=norb_frz+1,norb_inn
        li=lri-norb_frz
        lsmi=lsm_inn(lri)
        call int_ext_3_2_1(lri,lsmi,ii)
      enddo
      end

!===================== ext_3_2_1 end ===================

      function list3(i,j,k)
#include "drt_h.fh"
#include "intsort_h.fh"
c            *****************
      nij   = i+ngw2(j)
      list3 = loij(nij)+2*(k-1)
c            *****************
      return
      end
c***********************************************************************
      function list4(ld,lc,lb,la)
#include "drt_h.fh"
#include "intsort_h.fh"
c                    ***************
      lra  = ncibl(la)
      njkl = ld+ngw2(lc)+ngw3(lb)
      list4= loijk(njkl)+3*(lra-1)
c                    ***************
      return
      end
************************************************************************
      subroutine int_sort_inn(numb)
#include "drt_h.fh"
#include "intsort_h.fh"
      dimension msob(120)

      msob=0
      do 12 lra=norb_inn,1,-1
        ms = lsm_inn(lra)
        msob(ms)=msob(ms)+1
        ncibl(lra) = msob(ms)
12    continue
c=======================================================================
!      write(6,'(1x,14i3)')(ncibl(i),i=1,norb_inn)

      numb = 1
      do 10  i = 1,norb_inn-1
        do 11  j = i+1,norb_inn
          if(lsm_inn(i).ne.lsm_inn(j)) goto 11

          nij=i+ngw2(j)
          loij(nij)=numb
          do 20  k = 1,norb_inn
            vint_ci(numb)=vfutei(j,k,i,k)
            vint_ci(numb+1)=vfutei(j,i,k,k)
!        write(6,'(2x,4i6,i8,3f16.8)')i,j,k,k, numb,
!     *        vint_ci(numb),vint_ci(numb+1)
            numb=numb+2
20        continue
11      continue
10    continue
!      write(6,*) "num_inn",numb
!      print*, loij(1:8)
!      stop 888

c=======================================================================
c      la<lb<lc<ld
      do 30 ld = 1,norb_inn-3
        do 31 lc = ld+1,norb_inn-2
          msd  = lsm_inn(ld)
          msc  = lsm_inn(lc)
          mscd = mul_tab(msd,msc)
          do 32 lb = lc+1,norb_inn-1
            msb = lsm_inn(lb)
            msa = mul_tab(mscd,msb)

            njkl=ld+ngw2(lc)+ngw3(lb)
            loijk(njkl) = numb

            nolra=0
            do 40 la = norb_inn,lb+1,-1
              if(lsm_inn(la).ne.msa) cycle
              nolra=nolra+1
              list = loijk(njkl)+3*(nolra-1)

c        write(6,'(2x,4i3,2i7)')  la,lb,lc,ld,list,numb

              vint_ci(numb)=vfutei(la,lc,lb,ld)        !tmp stop
              vint_ci(numb+1)=vfutei(la,lb,lc,ld)
              vint_ci(numb+2)=vfutei(la,ld,lc,lb)
c     write(10,'(2x,4i6,i8,3f16.8)')la,lb,lc,ld, numb,
c    *        vint_ci(numb),vint_ci(numb+1),vint_ci(numb+2)
              numb=numb+3
40          continue
32        continue
31      continue
30    continue
      return
c=======================================================================
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkfn_cvb(fileid,ibf)

use casvb_global, only: ifilio, fileids, filename, max_rec, nrec, thresh_io
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: fileid
integer(kind=iwp), intent(out) :: ibf
integer(kind=iwp) :: i, ifile, irec
logical(kind=iwp) :: done
character(len=20) :: fn_tmp
logical(kind=iwp), parameter :: debug = .false.

done = .false.
do i=1,nrec
  if (abs(fileid-fileids(i)) < thresh_io) then
    ibf = i
    done = .true.
    exit
  end if
end do
if (.not. done) then
  nrec = nrec+1
  if (nrec > max_rec) then
    write(u6,*) ' nrec > max_rec in mkfn :',nrec,max_rec
    call abend_cvb()
  end if
  ibf = nrec
  ! generate new file name
  ! -> must be at most 8 characters to use daname
  fn_tmp = ' '
  irec = int(fileid)
  ifile = nint(10*(fileid-irec))
  call appendint_cvb(fn_tmp,irec,0)
  call appendint_cvb(fn_tmp,ifile,0)
  filename(ibf) = trim(fn_tmp)
  fileids(ibf) = fileid
  ifilio(ibf) = 0
end if
if (debug) then
  write(u6,*) ' IO information for identifier :',fileid
  write(u6,*) ' IBF is :',ibf
  write(u6,*) ' File name is :',filename(ibf)
end if

return

end subroutine mkfn_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine read_mo (CMO,nfro,no,nv,ndel,nbas,nOrb)
      use Data_Structures, only: DSBA_Type
      Implicit Real*8 (A-H,O-Z)

*     declaration of calling arguments
      Type (DSBA_Type) CMO
      Integer lthCMO
      integer nfro_scf(8)
      integer nfro
#include "real.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: CMO_t(:,:)

#include "SysDef.fh"

*...  Read nSym, Energy, nBas, nOrb, nOcc, nFro, CMO and orbital energies from COMFILE
*
      Call Get_iArray('nFro',nFro_scf,1)
      If (nFro_scf(1).ne.0) Then
         Write (6,*) 'Some orbitals were frozen in SCF!'
         Call Abend()
      End If
c
      lthCMO=nBas*nBas
      Call mma_allocate(CMO_t,nBas,nBas,Label='CMO_t')
      Call Get_CMO(CMO_t,lthCMO)
c
c - transpose MO matrix, skip the frozen occupied orbitals
c
      call mo_transp(CMO%A0,CMO_t(:,1+nfro:nOrb),no,nv,ndel,nbas)
c
      Call mma_deallocate(CMO_t)
c
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2000, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PGet2_Aces(iCmp,iBas,jBas,kBas,lBas,iAO,iAOst,nijkl,PSO,nPSO,DSO,DSO_Var,DSSO,DSSO_Var,nDSO,Gmma,nGamma,iSO2cI,nSOs, &
                      iSO2Sh,PMax)
!***********************************************************************
!                                                                      *
!  Object: to assemble the 2nd order density matrix of a SCF wave      *
!          function from the 1st order density matrix.                 *
!                                                                      *
!          The indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!          DSO: HF 1st order density                                   *
!          DSO_Var: 1st order density of correlated wf.                *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             January '92.                                             *
!                                                                      *
!     Modified to Aces 2 by RL, July 2000, Gainesville, FL, USA        *
!***********************************************************************

use Index_Functions, only: iTri
use Basis_Info, only: nBas
use SOAO_Info, only: iAOtSO, iOffSO
use pso_stuff, only: Gamma_MRCISD
use Symmetry_Info, only: nIrrep
use Constants, only: Zero, One, Four, Quart
use Definitions, only: wp, iwp, u6
#ifdef _DEBUGPRINT_
use pso_stuff, only: D0, DVar, iD0Lbl
#endif

implicit none
integer(kind=iwp), intent(in) :: iCmp(4), iBas, jBas, kBas, lBas, iAO(4), iAOst(4), nijkl, nPSO, nDSO, nGamma, nSOs, &
                                 iSO2cI(2,nSOs), iSO2Sh(nSOs)
real(kind=wp), intent(out) :: PSO(nijkl,nPSO), PMax
real(kind=wp), intent(in) :: DSO(nDSO), DSO_Var(nDSO), DSSO(nDSO), DSSO_Var(nDSO), Gmma(nGamma)
integer(kind=iwp) :: i1, i2, i3, i4, iAOi, Index_A, Index_AB, Index_ABCD, Index_B, Index_C, Index_CD, Index_D, Indij, Indik, &
                     Indil, Indjk, Indjl, Indkl, iS, iShell_A, iShell_AB, iShell_B, iShell_C, iShell_CD, iShell_D, iSO_A, iSO_R, &
                     iSOi, iSOi_A, iSym(0:7), j, j1, j12, j123, j2, j3, j4, jAOj, jS, jSO_A, jSO_R, jSOj, jSOj_A, jSym(0:7), kAOk, &
                     kS, kSO_A, kSO_R, kSOk, kSOk_A, kSym(0:7), lAOl, lOper, lS, lSO_A, lSO_R, lSOl, lSOl_A, lSym(0:7), MemSO2, &
                     mijkl, nDim_A, nDim_AB, nDim_B, nDim_C, nDim_CD, nDim_D, niSym, njSym, nkSym, nlSym
real(kind=wp) :: T14, Temp
real(kind=wp), parameter :: exfac = One
integer(kind=iwp), external :: iPntSO
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iComp
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'nSOs=',nSOs
write(u6,*) 'iSO2Sh=',iSO2Sh
iComp = 1
call PrMtrx(' In PGet2:DSO ',[iD0Lbl],iComp,1,D0)
call PrMtrx(' In PGet2:DSO_Var ',[iD0Lbl],iComp,1,DVar)
#endif
lOper = 1
t14 = Quart*ExFac
PMax = Zero

! Quadruple loop over elements of the basis functions angular
! description.
! Observe that we will walk through the memory in AOInt in a
! sequential way.

MemSO2 = 0
do i1=1,iCmp(1)
  niSym = 0
  do j=0,nIrrep-1
    if (iAOtSO(iAO(1)+i1,j) > 0) then
      iSym(niSym) = j
      niSym = niSym+1
    end if
  end do
  do i2=1,iCmp(2)
    njSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) then
        jSym(njSym) = j
        njSym = njSym+1
      end if
    end do
    do i3=1,iCmp(3)
      nkSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(3)+i3,j) > 0) then
          kSym(nkSym) = j
          nkSym = nkSym+1
        end if
      end do
      do i4=1,iCmp(4)
        nlSym = 0
        do j=0,nIrrep-1
          if (iAOtSO(iAO(4)+i4,j) > 0) then
            lSym(nlSym) = j
            nlSym = nlSym+1
          end if
        end do

        ! Loop over irreps which are spanned by the basis function.

        do is=0,niSym-1
          j1 = iSym(is)

          do js=0,njSym-1
            j2 = jSym(js)
            j12 = ieor(j1,j2)

            do ks=0,nkSym-1
              j3 = kSym(ks)
              j123 = ieor(j12,j3)
              do ls=0,nlSym-1
                j4 = lSym(ls)
                if (j123 /= j4) cycle

                MemSO2 = MemSO2+1

                ! Unfold the way the eight indices have been reordered.
                iSO_r = iAOtSO(iAO(1)+i1,j1)+iAOst(1)
                jSO_r = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
                kSO_r = iAOtSO(iAO(3)+i3,j3)+iAOst(3)
                lSO_r = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
                iSO_a = iSO_r+iOffSO(j1)
                jSO_a = jSO_r+iOffSO(j2)
                kSO_a = kSO_r+iOffSO(j3)
                lSO_a = lSO_r+iOffSO(j4)

                mijkl = 0
                do lAOl=0,lBas-1
                  lSOl = lSO_r+lAOl
                  lSOl_a = lSO_a+lAOl
                  iShell_D = iSO2Sh(lSOl_a)
                  Index_D = iSO2cI(1,lSOl_a)
                  nDim_D = iSO2cI(2,lSOl_a)
                  do kAOk=0,kBas-1
                    kSOk = kSO_r+kAOk
                    kSOk_a = kSO_a+kAOk
                    iShell_C = iSO2Sh(kSOk_a)
                    Index_C = iSO2cI(1,kSOk_a)
                    nDim_C = iSO2cI(2,kSOk_a)
                    nDim_CD = nDim_C*nDim_D
                    iShell_CD = iTri(iShell_C,iShell_D)
                    if (iShell_C > iShell_D) then
                      Index_CD = (Index_D-1)*nDim_C+Index_C
                    else if (iShell_C == iShell_D) then
                      Index_CD = iTri(Index_C,Index_D)
                    else
                      Index_CD = (Index_C-1)*nDim_D+Index_D
                    end if
                    do jAOj=0,jBas-1
                      jSOj = jSO_r+jAOj
                      jSOj_a = jSO_a+jAOj
                      iShell_B = iSO2Sh(jSOj_a)
                      Index_B = iSO2cI(1,jSOj_a)
                      nDim_B = iSO2cI(2,jSOj_a)
                      do iAOi=0,iBas-1
                        iSOi = iSO_r+iAOi
                        iSOi_a = iSO_a+iAOi
                        iShell_A = iSO2Sh(iSOi_a)
                        Index_A = iSO2cI(1,iSOi_a)
                        nDim_A = iSO2cI(2,iSOi_a)
                        nDim_AB = nDim_A*nDim_B
                        iShell_AB = iTri(iShell_A,iShell_B)
                        if (iShell_A > iShell_B) then
                          Index_AB = (Index_B-1)*nDim_A+Index_A
                        else if (iShell_A == iShell_B) then
                          Index_AB = iTri(Index_A,Index_B)
                        else
                          Index_AB = (Index_A-1)*nDim_B+Index_B
                        end if
                        if (iShell_AB > iShell_CD) then
                          Index_ABCD = (Index_CD-1)*nDim_AB+Index_AB
                        else if (iShell_AB == iShell_CD) then
                          Index_ABCD = iTri(Index_AB,Index_CD)
                        else
                          Index_ABCD = (Index_AB-1)*nDim_CD+Index_CD
                        end if
                        mijkl = mijkl+1

                        !*********** columbus interface ****************************************
                        !do not reconstruct the two-particle density from the one-particle
                        !density or partial two-particle densities but simply read them from
                        !file

                        if (gamma_mrcisd) then
                          temp = Gmma(Index_ABCD)
                        else
                          ! Contribution D(ij)*D(kl) to P(ijkl)
                          if (j1 == j2) then
                            ! j3 == j4 also
                            Indij = iPntSO(j1,j2,lOper,nbas)+iTri(iSOi,jSOj)
                            Indkl = iPntSO(j3,j4,lOper,nbas)+iTri(kSOk,lSOl)
                            temp = DSO(Indij)*DSO(Indkl)+(DSO_Var(Indij)-DSO(Indij))*DSO(Indkl)+ &
                                   DSO(Indij)*(DSO_Var(Indkl)-DSO(Indkl))
                          else
                            temp = Zero
                          end if

                          ! Contribution -1/4*D(ik)*D(jl) to P(ijkl)
                          if (j1 == j3) then
                            ! j2 == j4 also
                            Indik = iPntSO(j1,j3,lOper,nbas)+iTri(iSOi,kSOk)
                            Indjl = iPntSO(j2,j4,lOper,nbas)+iTri(jSOj,lSOl)
                            temp = temp-t14*(DSO(Indik)*DSO(Indjl)+(DSO_Var(Indik)-DSO(Indik))*DSO(Indjl)+ &
                                             DSO(Indik)*(DSO_Var(Indjl)-DSO(Indjl))+DSSO(Indik)*DSSO(Indjl)+ &
                                             (DSSO_Var(Indik)-DSSO(Indik))*DSSO(Indjl)+DSSO(Indik)*(DSSO_Var(Indjl)-DSSO(Indjl)))
                          end if

                          ! Contribution -1/4*D(il)*D(jk) to P(ijkl)
                          if (j1 == j4) then
                            ! j2 == j3 also
                            Indil = iPntSO(j1,j4,lOper,nbas)+iTri(iSOi,lSOl)
                            Indjk = iPntSO(j2,j3,lOper,nbas)+iTri(jSOj,kSOk)
                            temp = temp-t14*(DSO(Indil)*DSO(Indjk)+(DSO_Var(Indil)-DSO(Indil))*DSO(Indjk)+ &
                                             DSO(Indil)*(DSO_Var(Indjk)-DSO(Indjk))+DSSO(Indil)*DSSO(Indjk)+ &
                                             (DSSO_Var(Indil)-DSSO(Indil))*DSSO(Indjk)+DSSO(Indil)*(DSSO_Var(Indjk)-DSSO(Indjk)))
                          end if

                          !write(u6,*) 'iSO:',iSOi_a,jSOj_a,kSOk_a,lSOl_a
                          !write(u6,*) 'iShell:',iShell_A,iShell_B,iShell_C,iShell_D
                          !write(u6,*) 'nDim:',nDim_A,nDim_B,nDim_C,nDim_D
                          !write(u6,*)  temp , Gmma(Index_ABCD),Index_ABCD
                          temp = temp+Four*Gmma(Index_ABCD)
                        end if

                        PMax = max(PMax,abs(Temp))
                        PSO(mijkl,MemSO2) = temp

                      end do
                    end do
                  end do
                end do

              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do
if (nPSO /= MemSO2) then
  call WarningMessage(2,'PGet2_Aces: nPSO /= MemSO2')
  write(u6,*) nPSO,MemSO2
  call Abend()
end if

#ifdef _DEBUGPRINT_
call RecPrt(' In PGet2:PSO ',' ',PSO,nijkl,nPSO)
#endif

return

end subroutine PGet2_Aces

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_PTRINI(irc)
C
C     Purpose: set all entries in /CHMIND/ zero.
C
      IMPLICIT NONE
      Integer irc
#include "choptr.fh"
      Integer nAlloc

      nAlloc = 0  ! allocation counter

      ip_INFRED = 0
      l_INFRED  = 0
      nAlloc    = nAlloc + 1

      ip_INFVEC = 0
      l_INFVEC  = 0
      nAlloc    = nAlloc + 1

      ip_INDRED = 0
      l_INDRED  = 0
      nAlloc    = nAlloc + 1

      ip_INDRSH = 0
      l_INDRSH  = 0
      nAlloc    = nAlloc + 1

      ip_ISCR = 0
      l_ISCR  = 0
      nAlloc  = nAlloc + 1

      ip_IIBSTRSH = 0
      l_IIBSTRSH  = 0
      nAlloc      = nAlloc + 1

      ip_NNBSTRSH = 0
      l_NNBSTRSH  = 0
      nAlloc      = nAlloc + 1

      ip_INTMAP = 0
      l_INTMAP  = 0
      nAlloc    = nAlloc + 1

      ip_NDIMRS = 0
      l_NDIMRS  = 0
      nAlloc    = nAlloc + 1

      ip_IRS2F = 0
      l_IRS2F  = 0
      nAlloc   = nAlloc + 1

      ip_iSOShl = 0
      l_iSOShl  = 0
      nAlloc    = nAlloc + 1

      ip_iShlSO = 0
      l_iShlSO  = 0
      nAlloc    = nAlloc + 1

      ip_iQuab = 0
      l_iQuab  = 0
      nAlloc   = nAlloc + 1

      ip_iBasSh = 0
      l_iBasSh  = 0
      nAlloc    = nAlloc + 1

      ip_nBasSh = 0
      l_nBasSh  = 0
      nAlloc    = nAlloc + 1

      ip_nBstSh = 0
      l_nBstSh  = 0
      nAlloc    = nAlloc + 1

      ip_iAtomShl = 0
      l_iAtomShl  = 0
      nAlloc      = nAlloc + 1

      ip_iSP2F = 0
      l_iSP2F  = 0
      nAlloc   = nAlloc + 1

      irc = CHO_NALLOC - nAlloc

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Fix_Symmetry
!
!> @brief
!>   Fix the symmetry of a structure by removing off-zero values
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Fix the symmetry of a structure, by making sure that the coordinates that
!> should be zero remain there, removing numerical inaccuracies.
!>
!> @param[in,out] Coord Cartesian coordinates of the structure to fix (unique atoms)
!> @param[in]     nAt   Number of atoms in the structure
!> @param[in]     Stab  Stabilizers for each atom
!***********************************************************************

subroutine Fix_Symmetry(Coord,nAt,Stab)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt, Stab(nAt)
real(kind=wp), intent(inout) :: Coord(3,nAt)
integer(kind=iwp) :: iAt, j
real(kind=wp), parameter :: thr = 1.0e-12_wp

do iAt=1,nAt
  do j=1,3
    if (btest(Stab(iAt),j-1)) then
      if (abs(Coord(j,iAt)) > thr) call WarningMessage(1,'Significant deviation from symmetry axis.')
      Coord(j,iAt) = Zero
    end if
  end do
end do

end subroutine Fix_Symmetry

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine AppFld(Cavxyz,radius,Eps,lmax,EpsInf,NonEq)

use Index_Functions, only: nTri3_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lMax
real(kind=wp), intent(inout) :: Cavxyz(nTri3_Elem1(lMax))
real(kind=wp), intent(in) :: Radius, Eps, EpsInf
logical(kind=iwp), intent(in) :: NonEq
integer(kind=iwp) :: ip, l
real(kind=wp) :: Fact, RInv, rPoti
real(kind=wp), allocatable :: CavSph(:)
real(kind=wp), external :: DblFac

#ifdef _DEBUGPRINT_
call RecPrt('Multipole Moments',' ',Cavxyz,nTri3_Elem1(lMax),1)
#endif

! Backtransform from cartesian to spherical harmonics

call mma_allocate(CavSph,(lmax+1)**2,Label='CavSph')
call Tranca(Cavxyz,Cavsph,lmax,.true.)
#ifdef _DEBUGPRINT_
call RecPrt(' CavSph',' ',Cavsph,(lMax+1),1)
#endif

! Evaluate the electric field components at the origin.
! This is identical to the charge distribution on the
! boundary of the cavity!

ip = 1
do l=0,lmax
  rinv = One/radius**(2*l+1)
  fact = f(Eps,l)
  if (NonEq) fact = Two*f(EpsInf,l)-f(EpsInf,l)**2/fact
  rpoti = rinv*fact*DblFac(2*l-1)
  CavSph(ip:ip+2*l) = rpoti*CavSph(ip:ip+2*l)
  ip = ip+2*l+1
end do

! Transform electric field components from spherical harmonics
! to cartesians.

call Tranca(Cavxyz,Cavsph,lmax,.false.)
call mma_deallocate(CavSph)

#ifdef _DEBUGPRINT_
call RecPrt('Electric Field',' ',Cavxyz,nTri3_Elem1(lMax),1)
#endif

return

contains

pure function f(Eps_,l)

  real(kind=wp) :: f
  real(kind=wp), intent(in) :: Eps_
  integer(kind=iwp), intent(in) :: l

  f = (real(1+l,kind=wp)*(Eps_-One))/(real(1+l,kind=wp)*Eps_+real(l,kind=wp))

end function f

end subroutine AppFld

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* Absolutely NOT to be used for production!!!!                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: Oct 2004                                                    *
*                                                                      *
************************************************************************
      Subroutine Fmod1s(StandAlone)
      Implicit None
#include "Molcas.fh"
#include "stdalloc.fh"
#include "commgo.fh"
*----------------------------------------------------------------------*
* Dummy arguments                                                      *
*----------------------------------------------------------------------*
      Logical StandAlone
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Logical Debug
      Logical Trace
* Basis set indices
      Integer iSym
      Integer iBas
      Integer jBas
      Integer kBas
* Dimensions
      Integer nBasMax
      Integer nBasTot
      Integer nTriTot
      Integer nSqrTot
      Integer n2Full
* Pointers
      Integer ipTmp1
      Integer ipTmp2
      Integer ipTmp3
      Integer ipTmp4
* Matrix elements
      Real*8  Sii
      real*8  Sjj
      Real*8  Sik
      Real*8  Sjk
      Real*8  Skk
* Various variables
      Character*32 Line
      Integer indx
      Integer iSymlb
      Integer irc
      Real*8  Det
      Real*8  sum
      Real*8  eps
      Integer Lu
      Integer iDummy(7,8)
      Integer RC
      Character*80 Title
      Real*8, Dimension(:), Allocatable :: SmTr, DeTr, Esym, Edes, Smat,
     &        Ovl, Aux1, Sdes, Fdes, FSym, Fock, CMOs, Evec, Fmo, Aux2
*----------------------------------------------------------------------*
* Some setup                                                           *
*----------------------------------------------------------------------*
      If(StandAlone) Then
         Debug=.false.
         Trace=.false.
      Else
         Debug=.false.
         Trace=.false.
      End If
      If(Trace) Write(6,*) '>>> Entering fmod1s'
*----------------------------------------------------------------------*
* Should only be called if symmetry is used.                           *
*----------------------------------------------------------------------*
      If(nSym.eq.1) Then
         Call SysAbendMsg('fmod1s','internal error 001',' ')
      End If
*----------------------------------------------------------------------*
* Setup various counters.                                              *
*----------------------------------------------------------------------*
      nBasMax=0
      nBasTot=0
      nTriTot=0
      nSqrTot=0
      Do iSym=1,nSym
         If(nBasMax.lt.nBas(iSym)) nBasMax=nBas(iSym)
         nTriTot=nTriTot+nBas(iSym)*(nBas(iSym)+1)/2
         nSqrTot=nSqrTot+nBas(iSym)*nBas(iSym)
         nBasTot=nBasTot+nBas(iSym)
      End Do
      n2Full=nBasTot*nBasTot
*----------------------------------------------------------------------*
* Get symmetry transformation matrix.                                  *
*----------------------------------------------------------------------*
      Call mma_allocate(SmTr,n2Full)
      Call mma_allocate(DeTr,n2Full)
      Call Get_dArray('SM',SmTr,n2Full)
      Call Minv(SmTr,DeTr,0,Det,nBasTot)
      If(Debug) Then
         Call RecPrt('Symmetrization transformation matrix',
     &               '(10f12.6)',
     &               SmTr,nBasTot,nBasTot)
         Call RecPrt('Desymmetrization transformation matrix',
     &               '(10f12.6)',
     &               DeTr,nBasTot,nBasTot)
      End If
*----------------------------------------------------------------------*
* Create model Fock operator.                                          *
*----------------------------------------------------------------------*
      Call mma_allocate(Esym,nBasTot)
      Call FockOper(RC,Esym)
      If(RC.ne.0) Then
         Call mma_deallocate(Esym)
         Call mma_deallocate(DeTr)
         Call mma_deallocate(SmTr)
         Return
      End If
      If(Debug) Then
         Call RecPrt('Diagonal of Fock','(10f12.6)',
     &               Esym,1,nBasTot)
      End If
*----------------------------------------------------------------------*
* Desymmetrize model Fock operator                                     *
*----------------------------------------------------------------------*
      Call mma_allocate(Edes,nBasTot)
      Do iBas=1,nBasTot
         Do kBas=1,nBasTot
            indx=kBas+nBasTot*(iBas-1)
            If(Abs(SmTr(indx)).gt.1.0d-3) Then
               Edes(kBas)=Esym(iBas)
            End if
         End Do
      End Do
      If(Debug) Then
         Call RecPrt('Desymmetrized diagonal of Fock','(10f12.6)',
     &               Edes,1,nBasTot)
      End If
*----------------------------------------------------------------------*
* Read and square overlap matrix.                                      *
*----------------------------------------------------------------------*
      Call mma_allocate(Smat,n2Full)
      Call mma_allocate(Ovl,nTriTot)
      iSymlb=1
      Call RdOne(irc,2,'Mltpl  0',1,Ovl,iSymlb)
      Call dCopy_(n2Full, [0.0d0],0, Smat,1)
      ipTmp1=1
      ipTmp2=1
      Do iSym=1,nSym
         Call Square(Ovl(ipTmp1),SMat(ipTmp2),1,nBasTot,nBas(iSym))
         ipTmp1=ipTmp1+nBas(iSym)*(nBas(iSym)+1)/2
         ipTmp2=ipTmp2+nBas(iSym)*nBasTot+nBas(iSym)
      End Do
      If(Debug) Then
         Call RecPrt('Full overlap matrix','(10f12.6)',
     &               Smat,nBasTot,nBasTot)
      End If
      Call mma_deallocate(Ovl)
*----------------------------------------------------------------------*
* Desymmetrize overlap matrix.                                         *
*----------------------------------------------------------------------*
      Call mma_allocate(Sdes,n2Full)
      Call mma_allocate(Aux1,n2Full)
      Call DGEMM_('N','N',
     &            nBasTot,nBasTot,nBasTot,
     &            1.0d0,Smat,nBasTot,
     &                  DeTr,nBasTot,
     &            0.0d0,Aux1,nBasTot)
      Call DGEMM_('T','N',
     &            nBasTot,nBasTot,nBasTot,
     &            1.0d0,DeTr,nBasTot,
     &                  Aux1,nBasTot,
     &            0.0d0,Sdes,nBasTot)
      If(Debug) Then
         Call RecPrt('Desymmetrized overlap matrix','(10f12.6)',
     &               Sdes,nBasTot,nBasTot)
      End If
      Call mma_deallocate(Aux1)
*----------------------------------------------------------------------*
* Build Fock matrix                                                    *
*----------------------------------------------------------------------*
      Call mma_allocate(Fdes,n2Full)
      Do iBas=1,nBasTot
         Sii=Sdes(iBas+nBasTot*(iBas-1))
         Do jBas=1,nBasTot
            Sjj=Sdes(jBas+nBasTot*(jBas-1))
            sum=0.0d0
            Do kBas=1,nBasTot
               eps=Edes(kBas)
               Skk=Sdes(kBas+nBasTot*(kBas-1))
               Sik=Sdes(iBas+nBasTot*(kBas-1))
               Sjk=Sdes(jBas+nBasTot*(kBas-1))
               sum=sum+eps*Sik*Sjk/Sqrt(Sii*Sjj*Skk*Skk)
            End Do
            Fdes(iBas+nBasTot*(jBas-1))=sum
         End Do
      End Do
      If(Debug) Then
         Call RecPrt('Desymmetrized Fock matrix','(10f12.6)',
     &               Fdes,nBasTot,nBasTot)
      End If
*----------------------------------------------------------------------*
* Symmetrize Fock matrix.                                              *
*----------------------------------------------------------------------*
      Call mma_allocate(Fsym,n2Full)
      Call mma_allocate(Aux1,n2Full)
      Call DGEMM_('N','N',
     &            nBasTot,nBasTot,nBasTot,
     &            1.0d0,Fdes,nBasTot,
     &                  SmTr,nBasTot,
     &            0.0d0,Aux1,nBasTot)
      Call DGEMM_('T','N',
     &            nBasTot,nBasTot,nBasTot,
     &            1.0d0,SmTr,nBasTot,
     &                  Aux1,nBasTot,
     &            0.0d0,Fsym,nBasTot)
      If(Debug) Then
         Call RecPrt('Symmetrized overlap matrix','(10f12.6)',
     &               Fsym,nBasTot,nBasTot)
      End If
      Call mma_deallocate(Aux1)
*----------------------------------------------------------------------*
* Compact the symmetrized Fock matrix.                                 *
*----------------------------------------------------------------------*
      Call mma_allocate(Fock,nTriTot)
      ipTmp1=1
      ipTmp2=1
      Do iSym=1,nSym
         indx=1
         Do iBas=1,nBas(iSym)
            Do jBas=1,iBas
               Fock(indx)=Fsym(iBas+nBasTot*(jBas-1))
               indx=indx+1
            End Do
         End Do
         If(Debug) Then
            Write(Line,'(a,i2)') 'Fock matrix, symmetry ',iSym
            Call TriPrt(Line,'(10f12.6)',Fock(ipTmp2),nBas(iSym))
         End If
         ipTmp1=ipTmp1+nBas(iSym)*nBasTot+nBas(iSym)
         ipTmp2=ipTmp2+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
*----------------------------------------------------------------------*
* Make ON basis                                                        *
*----------------------------------------------------------------------*
      Call mma_allocate(CMOs,nSqrTot)
      Call goLowdin(CMOs)
*----------------------------------------------------------------------*
* Transform Fock matrix to MO basis and diagonalize                    *
*----------------------------------------------------------------------*
      Call mma_allocate(Evec,nTriTot)
      Call mma_allocate(Fmo,nTriTot)
      Call mma_allocate(Aux1,nBasMax*nBasMax)
      Call mma_allocate(Aux2,nBasMax*nBasMax)

      ipTmp1=1
      ipTmp2=1
      ipTmp3=1
      ipTmp4=1
      Do iSym=1,nSym
         if(nBas(iSym).gt.0) Then
            Call Square(Fock(ipTmp1),Aux1,
     &                  1,nBas(iSym),nBas(iSym))
            Call DGEMM_('N','N',
     &                  nBas(iSym),nBas(iSym),nbas(iSym),
     &                  1.0d0,Aux1,nBas(iSym),
     &                        CMOs(ipTmp2),nBas(iSym),
     &                  0.0d0,Aux2,nBas(iSym))
            Call MxMt(CMOs(ipTmp2),nBas(iSym),1,
     &                Aux2,1,nBas(iSym),
     &                Fmo(ipTmp3),
     &                nBas(iSym),nBas(iSym))
            If(Debug) Then
               Write(Line,'(a,i2)')
     &            'MO Fock matrix, symmetry ',iSym
               Call TriPrt(Line,'(10f12.6)',Fmo(ipTmp3),nBas(iSym))
            End If
*           Call Jacob(Fmo(ipTmp3),CMOs(ipTmp2),nBas(iSym),nBas(iSym))
            Call NIdiag(Fmo(ipTmp3),CMOs(ipTmp2),
     &                  nBas(iSym),nBas(iSym),0)
            If(Debug) Then
               Write(Line,'(a,i2)')
     &            'Diagonal Fock matrix, symmetry ',iSym
               Call TriPrt(Line,'(10f12.6)',Fmo(ipTmp3),nBas(iSym))
            End If
            Call goPickup(Fmo(ipTmp3),Evec(ipTmp4),nBas(iSym))
            Call goSort(Evec(ipTmp4),CMOs(ipTmp2),nBas(iSym),nBas(iSym))
          End If
          ipTmp1=ipTmp1+nBas(iSym)*(nBas(iSym)+1)/2
          ipTmp2=ipTmp2+nBas(iSym)*nBas(iSym)
          ipTmp3=ipTmp3+nBas(iSym)*(nBas(iSym)+1)/2
          ipTmp4=ipTmp4+nBas(iSym)
      End Do
      Call mma_deallocate(Fmo)
      Call mma_deallocate(Aux2)
      Call mma_deallocate(Aux1)
*----------------------------------------------------------------------*
* Present data.                                                        *
*----------------------------------------------------------------------*
      If(PrintMOs) Then
         Call PriMO('Start orbitals',.false.,.true.,0.0d0,1.0d6,
     &              nSym,nBas,nBas,Label,Evec,Evec,CMOs,3)
      End If
      Call put_darray('Guessorb',CMOs,nSqrTot)
      Call put_darray('Guessorb energies',Evec,nBasTot)
      Call Put_iArray('nOrb',nBas,nSym)
      Call mma_allocate(Aux1,nBasTot)
      Do iBas=1,nBasTot
         Aux1(iBas)=0.0d0
      End Do
      Lu=20
      Title='Guess orbitals'
      Call WrVec('GSSORB',Lu,'COE',nSym,nBas,nBas,CMOs,
     &           Aux1,Evec,iDummy,Title)
      Call mma_deallocate(Aux1)
*----------------------------------------------------------------------*
* Done, deallocate the rest.                                           *
*----------------------------------------------------------------------*
      Call mma_deallocate(Evec)
      Call mma_deallocate(CMOs)
      Call mma_deallocate(Fock)
      Call mma_deallocate(Fsym)
      Call mma_deallocate(Fdes)
      Call mma_deallocate(Sdes)
      Call mma_deallocate(Smat)
      Call mma_deallocate(Edes)
      Call mma_deallocate(Esym)
      Call mma_deallocate(DeTr)
      Call mma_deallocate(SmTr)
      If(trace) Write(6,*) '<<< Exiting fmod1s'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "macros.fh"

subroutine READIN_RASSI()

use Cholesky, only: timings
use Cntrl, only: ALGO, ALPHZ, AngMom_idx, ASD_idx, Atens_Req, AutoSelect_GFac, BANGRES, BETAE, BINA, BINCRE, BSTART, CIH5, CIThr, &
                 DCHO, DCHS, DEGEN_ETHR, DIPR, dmpk, Do_Pol, Do_SK, DO_TMOM, DOCD, DOGSOR, DQVD, DYSEXPORT, DYSEXPSF, DYSEXPSO, &
                 DYSO, EPrThr, GNuc, GNuc_set, HOP, HypF_rms_Req, HypoIso, IBINA, ICOMP, IFARGU, IFCURD, IFDCPL, IFEJOB, IFGCAL, &
                 IFGTCALSA, IFGTSHSA, IFHAM, IfHCOM, IfHDia, IfHEff, IfHEXT, IfJ2, IfJZ, IFMCAL, IFNTO, IfShft, IFSO, IFTDM, &
                 IFTRD1, IFTRD2, IFVANVLECK, IFXCAL, ISOCMP, ISTAT, JBNAME, l_Eff, LCSTATES, lHami, LOOPDIVIDE, LOOPMAX, LPRPR, &
                 MULTIP, MXJOB, MXPROP, NATens_Calc, NATO, NAtoms, NBINA, NBSTEP, NCOUP, NJOB, NMass_set, NOHAM, NOSO, NPNMR_Calc, &
                 NPROP, NRNATO, Nscreen, NSOPR, nSOThr_Prt, NSpin_set, NSTAT, nState, NTP, NTS, NTSTEP, NucMass, NucSpin, OCAA, &
                 OCAN, ONLY_OVERLAPS, OSTHR_DIPR, OSTHR_QIPR, PNAME, pNMR_req, PRCI, PRDIPCOM, PRDIPVEC, PRMEE, PRMER, PRMES, &
                 PRORB, PRRAW, PRSXY, PRTRA, PRWEIGHT, PRXVE, PRXVR, PRXVS, PSO_idx, QDPT2EV, QDPT2SC, QIALL, QIPR, REDUCELOOP, &
                 RFPERT, RHODYN, RSPR, RSThr, SECOND_TIME, SODIAG, SODIAGNSTATE, SONAT, SONATNSTATE, SONTO, SONTOSTATES, SOPRNM, &
                 SOThr_Prt, TDIPMIN, TDYS, TINCRE, TMAXP, TMAXS, TMGR_Thrs, TMINP, TMINS, ToFile, TOLERANCE, TRACK, TSTART
use Fock_util_global, only: Deco, Estimate, PseudoChoMOs, Update
use frenkel_global_vars, only: DoCoul, doexch, DoExcitonics, excl, iTyp, labB, nestla, nestlb, valst
use kVectors, only: e_Vector, k_Vector, nk_Vector
use Lebedev_quadrature, only: available_table, rule_max
use HFC_logical, only: MagX2C_Req
use rassi_data, only: CHFRACMEM
use rassi_global_arrays, only: ESHFT, HAM, HDIAG, JBNUM, LROOT
use spool, only: Close_LuSpool, Spoolinp
#ifdef _DMRG_
use rasscf_global, only: doDMRG
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: corest, I, IJOB, ISTATE, istatus, iTmp, J, JSTATE, LINENR, LuIn, nesta, nestb, NFLS
real(kind=wp) :: tmp, tmp_gfac, tmp_spin
logical(kind=iwp) :: lExists
character(len=80) :: LINE
character(len=8) :: TRYNAME
character(len=7) :: input_id
integer(kind=iwp), allocatable :: iTemp_arr(:)
real(kind=wp), allocatable :: rTemp_arr(:)

call SpoolInp(LuIn)

! Default settings for Cholesky
Algo = 2
Nscreen = 10
dmpk = 0.1_wp
timings = .false.
Estimate = .false.
Update = .true.
Deco = .true.
PseudoChoMOs = .false.
#ifdef _MOLCAS_MPP_
ChFracMem = 0.3_wp
#else
ChFracMem = Zero
#endif

ITYP = 0
VALST = 1
COREST = 0
!> set some defaults for MPSSI
QDPT2SC = .true.
QDPT2EV = .false.
input_id = '&RASSI'
#ifdef _DMRG_
!> make sure that we read checkpoint names from xxx.h5 files, for example: rasscf.h5, nevpt2.h5, caspt2.h5, ...
if (doDMRG) input_id = '&MPSSI'
#endif

! Defaults for SI-PDFT runs:
Second_time = .false.
DoGSOR = .false.

! Find beginning of input:
LINENR = 0
do
  read(LuIn,'(A72)',iostat=istatus) LINE
  call LineCheck(istatus)
  call NORMAL(LINE)
  if (LINE(1:7) == input_id) exit
end do
LINENR = 0
do
  read(LuIn,'(A72)',iostat=istatus) LINE
  call LineCheck(istatus)
  call NORMAL(LINE)
  if (LINE(1:1) == '*') cycle
  if (LINE == '') cycle
  select case (LINE(1:4))

    case ('END ')
      exit

    case ('TEST')
      PRSXY = .true.
      PRORB = .true.
      PRTRA = .true.
      PRCI = .true.

    case ('SECO')
      SECOND_TIME = .true.

    case ('GSOR')
      DoGSOR = .true.

    case ('BINA')
      BINA = .true.
      NATO = .true.
      read(LuIn,*,iostat=istatus) NBINA
      call LineCheck(istatus)
      read(LuIn,*,iostat=istatus) (IBINA(1,I),IBINA(2,I),I=1,NBINA)
      call LineCheck(istatus)

    case ('NATO')
      NATO = .true.
      read(LuIn,*,iostat=istatus) NRNATO
      call LineCheck(istatus)

    case ('RFPE')
      RFPERT = .true.

    case ('CHOL')
      ! --- Cholesky with default settings
      call Cho_rassi_rdInp(.true.,LuIn)

    case ('CHOI')
      ! --- Cholesky with customized settings
      call Cho_rassi_rdInp(.false.,LuIn)

    case ('EXAL')
      EXCL = .true.
      NESTA = 0
      read(LuIn,*,iostat=istatus) NESTA
      call LineCheck(istatus)
      call mma_allocate(NESTLA,NESTA)
      read(LuIn,*,iostat=istatus) (NESTLA(I),I=1,NESTA)
      call LineCheck(istatus)
      !write(u6,*) 'list of excit. initial states'
      !write(u6,*) 'mon A nr states', NESTA
      !write(u6,'(I2)') (NESTLA(I),I=1,NESTA)

    case ('EXBL')
      EXCL = .true.
      NESTB = 0
      read(LuIn,*,iostat=istatus) NESTB
      call LineCheck(istatus)
      call mma_allocate(NESTLB,NESTB)
      read(LuIn,*,iostat=istatus) (NESTLB(I),I=1,NESTB)
      call LineCheck(istatus)
      !write(u6,*) 'list of excit. initial states'
      !write(u6,*) 'mon B nr states', NESTB
      !write(u6,'(I2)') (NESTLB(I),I=1,NESTB)

    case ('EXCI')
      DoExcitonics = .true.

    case ('KCOU')
      DoExch = .true.

    case ('MONA')
      DoCoul = .true.
      if (iTyp == 2) write(u6,*) ' Warning: switching to monomer-A.'
      iTyp = 1
      if (.not. IFTRD1) then
        IFTRD1 = .true.
        write(u6,*) ' TRD1 activated by MONA.'
      end if

    case ('MONB')
      labB = .true.
      DoCoul = .true.
      if (iTyp == 1) write(u6,*) ' Warning: switching to monomer-B.'
      iTyp = 2
      if (.not. IFTRD1) then
        IFTRD1 = .true.
        write(u6,*) ' TRD1 activated by MONB.'
      end if

    case ('RIXS')
      read(LuIn,*,iostat=istatus) valst,corest
      call LineCheck(istatus)
      unused_var(corest)

    case ('SOPR')
      read(LuIn,*,iostat=istatus) NSOPR,(SOPRNM(I),ISOCMP(I),I=1,min(MXPROP,NSOPR))
      call LineCheck(istatus)
      do I=1,min(MXPROP,NSOPR)
        call UPCASE(SOPRNM(I))
        if (SOPRNM(I)(1:5) == 'MLTPL') then
          if (SOPRNM(I)(7:8) == '  ') then
            SOPRNM(I) = 'MLTPL  '//SOPRNM(I)(6:6)
          else if (SOPRNM(I)(8:8) == ' ') then
            SOPRNM(I) = 'MLTPL '//SOPRNM(I)(6:7)
          end if
        end if
      end do

    case ('PROP')
      read(LuIn,*,iostat=istatus) NPROP,(PNAME(I),ICOMP(I),I=1,min(MXPROP,NPROP))
      call LineCheck(istatus)
      do I=1,min(MXPROP,NPROP)
        call UPCASE(PNAME(I))
        if (PNAME(I)(1:5) == 'MLTPL') then
          if (PNAME(I)(7:8) == '  ') then
            PNAME(I) = 'MLTPL  '//PNAME(I)(6:6)
          else if (PNAME(I)(8:8) == ' ') then
            PNAME(I) = 'MLTPL '//PNAME(I)(6:7)
          end if
        end if
      end do

    case ('OVER')
      PRSXY = .true.

    case ('TRDI')
      ! Print transition dipole vectors
      PRDIPVEC = .true.

    case ('TDMN')
      ! Print transition dipole vectors
      PRDIPVEC = .true.
      read(LuIn,*,iostat=istatus) TDIPMIN
      call LineCheck(istatus)

    case ('TRDC')
      ! Print COMPLEX transition dipole vectors
      PRDIPCOM = .true.

    case ('ORBI')
      PRORB = .true.

    case ('CIPR')
      PRCI = .true.

    case ('CIH5')
      if (NJOB <= 2) then
        CIH5 = .true.
      else
        call WarningMessage(2,'CIH5 allows no more than 2 JOBIPHs')
        call abend()
      end if

    case ('THRS')
      read(LuIn,*,iostat=istatus) CITHR
      call LineCheck(istatus)

    case ('ONEL')
      IFHAM = .false.

    case ('ONEE')
      IFHAM = .false.

    case ('SPIN')
      IFSO = .true.

    case ('NTOC')
      IFNTO = .true.

    case ('SOCO')
      ! PAM07 Added: Keyword for printing spin-orbit coupling matrix elements
      ! A threshold in reciprocal cm is entered.
      read(LuIn,*,iostat=istatus) SOTHR_PRT
      call LineCheck(istatus)
      if (SOTHR_PRT < Zero) SOTHR_PRT = Zero
      NSOTHR_PRT = 10000

    case ('NROF','NR O')
      NSTATE = 0
      read(LuIn,*,iostat=istatus) NJOB,TRYNAME
      call LineCheck(istatus)
      call UpCase(TRYNAME)
      if (TRYNAME /= 'ALL') then
        backspace(LuIn)
        LINENR = LINENR-1
        read(LuIn,*,iostat=istatus) NJOB,(NSTAT(I),I=1,NJOB)
        call LineCheck(istatus)
        NSTATE = sum(NSTAT(1:NJOB))
        call mma_allocate(JBNUM,nState,Label='JBNUM')
        call mma_allocate(LROOT,nState,Label='LROOT')
        NSTATE = 0
        do IJOB=1,NJOB
          ISTAT(IJOB) = NSTATE+1
          read(LuIn,*,iostat=istatus) (LROOT(NSTATE+J),J=1,NSTAT(IJOB))
          call LineCheck(istatus)
          JBNUM(NSTATE+1:NSTATE+NSTAT(IJOB)) = IJOB
          NSTATE = NSTATE+NSTAT(IJOB)
        end do
      end if

    case ('IPHN')
      !read(LuIn,'(9(A7,1X))',iostat=istatus) (JBNAME(I),I=1,NJOB)
      !call LineCheck(istatus)
      do I=1,NJOB
        read(LuIn,*,iostat=istatus) JBNAME(I)
        call LineCheck(istatus)
        call UpCase(JBNAME(I))
      end do

    case ('FILE')
      read(LuIn,*,iostat=istatus) NJOB
      call LineCheck(istatus)
      do I=1,NJOB
        read(LuIn,*,iostat=istatus) LINE
        call LineCheck(istatus)
        call FILEORB(LINE,JBNAME(I))
      end do

    case ('HEXT')
      if (nState == 0) then
        call WarningMessage(2,'HEXT needs an explicit NROFJOB')
        call abend()
      end if
      IFHEXT = .true.
      call mma_allocate(HAM,nState,nState,Label='HAM')
      read(LuIn,*,iostat=istatus) ((HAM(ISTATE,JSTATE),JSTATE=1,ISTATE),ISTATE=1,NSTATE)
      call LineCheck(istatus)
      do ISTATE=1,NSTATE-1
        do JSTATE=ISTATE+1,NSTATE
          HAM(ISTATE,JSTATE) = HAM(JSTATE,ISTATE)
        end do
      end do

    case ('HEFF')
      IFHEFF = .true.

    case ('HCOM')
      IFHCOM = .true.

    case ('EJOB')
      IFEJOB = .true.

    case ('HDIA')
      if (nState == 0) then
        call WarningMessage(2,'HDIA needs an explicit NROFJOB')
        call abend()
      end if
      IFHDIA = .true.
      call mma_allocate(HDIAG,nState,Label='nState')
      read(LuIn,*,iostat=istatus) (HDIAG(ISTATE),ISTATE=1,NSTATE)
      call LineCheck(istatus)

    case ('SHIF')
      if (nState == 0) then
        call WarningMessage(2,'SHIFT needs an explicit NROFJOB')
        call abend()
      end if
      IFSHFT = .true.
      call mma_allocate(ESHFT,nState,Label='ESHFT')
      read(LuIn,*,iostat=istatus) (ESHFT(ISTATE),ISTATE=1,NSTATE)
      call LineCheck(istatus)

    case ('TOFI')
      ToFile = .true.

    case ('J-VA')
      IFJ2 = 1

    case ('OMEG')
      IFJZ = 1

    case ('EPRG')
      !-SVC 2007-----------------------------------
      IFGCAL = .true.
      read(LuIn,*,iostat=istatus) EPRTHR
      call LineCheck(istatus)
      if (EPRTHR < Zero) EPRTHR = Zero

    case ('PRPR')
      ! tjd- BMII: Print out spin-orbit properties to files
      write(u6,*) 'SPIN-ORBIT PROPERTY PRINT ON'
      LPRPR = .true.

    case ('HAMI')
      ! tjd- Yoni: Force an identity SO hamiltonian
      write(u6,*) 'Identity Hamiltonian turned on'
      LHAMI = .true.

    case ('GTSA')
      IFGTCALSA = .true.

    case ('SHMP')
      IFGTSHSA = .true.
      read(LuIn,*,iostat=istatus) MULTIP
      call LineCheck(istatus)

    case ('VSUS')
      IFVANVLECK = .true.
      read(LuIn,*,iostat=istatus) TMINS,TMAXS,NTS
      call LineCheck(istatus)

    case ('NMRT')
      read(LuIn,*,iostat=istatus) TMINP,TMAXP,NTP
      call LineCheck(istatus)
      ! Kamal Sharkas end - PSO Hyperfine calculations

    case ('SONO')
      ! BP Natural orbitals options
      read(LuIn,*,iostat=istatus) SONATNSTATE
      call LineCheck(istatus)
      call mma_allocate(SONAT,SONATNSTATE,Label='SONAT')
      read(LuIn,*,iostat=istatus) (SONAT(I),I=1,SONATNSTATE)
      call LineCheck(istatus)

    case ('SODI')
      read(LuIn,*,iostat=istatus) SODIAGNSTATE
      call LineCheck(istatus)
      call mma_allocate(SODIAG,SODIAGNSTATE,Label='SODIAG')
      read(LuIn,*,iostat=istatus) (SODIAG(I),I=1,SODIAGNSTATE)
      call LineCheck(istatus)

    case ('NOSO')
      NOSO = .true.

    case ('CURD')
      IFCURD = .true.
      ! END BP OPTIONS

    case ('SONT')
      ! RF SO-NTO
      read(LuIn,*,iostat=istatus) SONTOSTATES
      call LineCheck(istatus)
      call mma_allocate(SONTO,2,SONTOSTATES,Label='SONTO')
      read(LuIn,*,iostat=istatus) (SONTO(1,I),SONTO(2,I),I=1,SONTOSTATES)
      call LineCheck(istatus)

    case ('ARGU')
      IFARGU = .true.
      ! END RF

    case ('MAGN')
      IFXCAL = .true.
      read(LuIn,*,iostat=istatus) NBSTEP,BSTART,BINCRE,BANGRES
      call LineCheck(istatus)
      read(LuIn,*,iostat=istatus) NTSTEP,TSTART,TINCRE
      call LineCheck(istatus)
      if (BANGRES > Zero) IFMCAL = .true.

    case ('XVIN')
      PRXVR = .true.

    case ('XVES')
      PRXVE = .true.

    case ('XVSO')
      PRXVS = .true.

    case ('MEIN')
      PRMER = .true.

    case ('MEES')
      PRMEE = .true.

    case ('MESO')
      PRMES = .true.

    case ('HOP ')
      HOP = .true.

    case ('TRAC')
      TRACK = .true.
      NOHAM = .true.

    case ('STOV')
      ONLY_OVERLAPS = .true.
      NOHAM = .true.

    case ('DCOU')
      IfDCpl = .true.

    case ('TRD1')
      !*PAM Nov 2011
      IFTRD1 = .true.

    case ('TRD2')
      IFTRD1 = .true.
      IFTRD2 = .true.

    case ('TDM ')
      IFTDM = .true.

    case ('DQVD')
      !CEH April 2015
      DQVD = .true.

    case ('ALPH')
      read(LuIn,*,iostat=istatus) ALPHZ
      call LineCheck(istatus)

    case ('BETA')
      read(LuIn,*,iostat=istatus) BETAE
      call LineCheck(istatus)

    case ('DIPR')
      !LKS Sep 2015
      ! Printing threshold for dipole intensities. Current default 1.0e-5
      DIPR = .true.
      read(LuIn,*,iostat=istatus) OSTHR_DIPR
      call LineCheck(istatus)

    case ('QIPR')
      ! Printing threshold for quadrupole intensities. Current default 1.0e-5
      QIPR = .true.
      read(LuIn,*,iostat=istatus) OSTHR_QIPR
      call LineCheck(istatus)

    case ('QIAL')
      ! Print all contributions for quadrupole intensities.
      QIALL = .true.

    case ('RSPR')
      ! Printing threshold for rotatory strength. Current default 1.0e-7
      RSPR = .true.
      read(LuIn,*,iostat=istatus) RSTHR
      call LineCheck(istatus)

    case ('CD  ')
      ! Perform regular circular dichroism - velocity and mixed gauge
      DOCD = .true.

    case ('DYSO')
      ! Enable Dyson orbital calculations
      DYSO = .true.

    case ('DYSE')
      ! Enable Dyson orbital calculations
      DYSEXPORT = .true.
      read(LuIn,*,iostat=istatus) DYSEXPSF,DYSEXPSO
      call LineCheck(istatus)

    case ('TDYS')
      ! Enable 2particle Dyson matrix calculations
      TDYS = .true.
      read(LuIn,*,iostat=istatus) OCAN
      call LineCheck(istatus)
      do I=1,OCAN
        read(LuIn,'(A)',iostat=istatus) OCAA(I)
        call LineCheck(istatus)
      end do

    case ('DCHS')
      ! Enable computation of DCH intensities
      DCHS = .true.
      read(LuIn,*,iostat=istatus) DCHO
      call LineCheck(istatus)

    case ('TINT')
      ! Calculate exact isotropically averaged semi-classical intensities
      ! Activate integration of transition intensities
      ! based on the exact non-relativistic Hamiltonian in the weak field
      ! approximation.
      Do_TMOM = .true.

    case ('TIGR')
      ! Group exact TINT to reduce computational cost
      ! TMGr_thrs is the tolerance in the relative energy (unitless)
      ! TMGr_thrs only works with SUBS keyword
      read(LuIn,*,iostat=istatus) TMGr_thrs
      call LineCheck(istatus)

    case ('PRRA')
      ! Print the raw directions for exact semi-classical intensities
      PRRAW = .true.

    case ('PRWE')
      ! Print the weighted directions for exact semi-classical intensities
      PRWEIGHT = .true.

    case ('TOLE')
      ! Set tolerance for different gauges - currently 10 percent (0.1)
      ! Defined as Tolerance = ABS(1-O_r/O_p)
      read(LuIn,*,iostat=istatus) TOLERANCE
      call LineCheck(istatus)

    case ('SUBS')
      ! Reduce looping in intensities. Set limit for the inner and outer loop
      REDUCELOOP = .true.
      read(LuIn,*,iostat=istatus) LOOPDIVIDE
      call LineCheck(istatus)

    case ('NFIN')
      ! Reduce looping in intensities. Set number of final states
      read(LuIn,*,iostat=istatus) LOOPMAX
      call LineCheck(istatus)

    case ('IIOR')
      ! Set the order of the Lebedev polynomials used for the numerical
      ! isotropic integration. Current default 5.
      read(LuIn,*,iostat=istatus) L_Eff
      call LineCheck(istatus)
      ! make sure it's an odd number
      ! and find the smallest grid that supports that degree
      if (mod(L_Eff,2) == 0) L_Eff = L_Eff+1
      do i=(L_Eff-1)/2,rule_max
        if (available_table(i) == 1) exit
        L_Eff = L_Eff+2
      end do
      if (L_Eff > rule_max) then
        call WarningMessage(2,'L_Eff too large, grid not supported')
        call abend()
      end if

    case ('DIRE')
      ! Set a specific direction of the incident light when computing
      ! the transition intensities in the use of
      ! the vector field (A) in the non-relativistic Hamiltonian.
      Do_SK = .true.
      read(LuIn,*,iostat=istatus) nk_Vector
      call LineCheck(istatus)
      call mma_allocate(k_Vector,3,nk_Vector,label='k-Vector')
      do j=1,nk_Vector
        read(LuIn,*,iostat=istatus) (k_Vector(i,j),i=1,3)
        call LineCheck(istatus)
        tmp = k_Vector(1,j)**2+k_Vector(2,j)**2+k_Vector(3,j)**2
        tmp = One/sqrt(tmp)
        k_Vector(1,j) = k_Vector(1,j)*tmp
        k_Vector(2,j) = k_Vector(2,j)*tmp
        k_Vector(3,j) = k_Vector(3,j)*tmp
      end do

    case ('POLA')
      Do_Pol = .true.
      read(LuIn,*,iostat=istatus) (e_Vector(i),i=1,3)
      call LineCheck(istatus)

    case ('RHOD')
      ! VKochetov 2021 enable saving more data to hdf5
      rhodyn = .true.

    case ('HFCA')
      call mma_allocate(Atens_req,NAtoms,Label='Atens_req')
      Atens_req(:) = .false.
      read(LuIn,*,iostat=istatus) Line
      call LineCheck(istatus)
      call UpCase(Line)
      if (Line == 'ALL') then
        NATens_Calc = NAtoms
        Atens_req(:) = .true.
      else
        read(line,*) NATens_Calc
        call mma_allocate(iTemp_arr,NATens_Calc,Label='iTemp_arr')
        read(LuIn,*,iostat=istatus) (iTemp_arr(i),i=1,NATens_Calc)
        call LineCheck(istatus)
        do I=1,NATens_Calc
          Atens_req(iTemp_arr(I)) = .true.
        end do
        call mma_deallocate(iTemp_arr)
      end if

    case ('NMRA')
      call mma_allocate(pNMR_req,NAtoms,Label='pNMR_req')
      pNMR_req(:) = .false.
      read(LuIn,*,iostat=istatus) LINE
      call LineCheck(istatus)
      call UpCase(LINE)
      if (line == 'ALL') then
        NPNMR_Calc = NAtoms
        pNMR_req(:) = .true.
      else
        read(line,*) NPNMR_Calc
        call mma_allocate(iTemp_arr,NPNMR_Calc,Label='iTemp_arr')
        Linenr = Linenr+1
        read(LuIn,*,iostat=istatus) (iTemp_arr(i),i=1,NPNMR_Calc)
        call LineCheck(istatus)
        do I=1,NPNMR_Calc
          pNMR_req(iTemp_arr(I)) = .true.
        end do
        call mma_deallocate(iTemp_arr)
      end if
      Linenr = Linenr+1

    case ('DETH')
      read(LuIn,*,iostat=istatus) DEGEN_ETHR
      call LineCheck(istatus)
      if (DEGEN_ETHR < Zero) DEGEN_ETHR = Zero

    case ('NCOU')
      read(LuIn,*,iostat=istatus) NCOUP
      call LineCheck(istatus)

    case ('COUP')
      if (NCOUP == 0) then
        write(u6,*) 'Keyword NCOUP must be preceded by keyword COUP'
        call Quit_OnUserError()
      end if
      call mma_allocate(LCSTATES,NCOUP,Label='LCSTATES')
      read(LuIn,*,iostat=istatus) (LCSTATES(i),i=1,NCOUP)
      call LineCheck(istatus)

    case ('HFCO')
      HypF_rms_Req = .true.

    case ('HISO')
      call mma_allocate(HypoIso,NAtoms,Label='HypoIso_inp')
      read(LuIn,*,iostat=istatus) iTmp
      if (istatus > 1) then
        HypoIso(:) = .true.
        backspace(LuIn)
      else
        HypoIso(:) = .false.
        if (.not. allocated(NucSpin)) then
          call mma_allocate(NucSpin,NAtoms,Label='NucSpin')
          NucSpin(:) = -100.0_wp
        end if
        if (.not. allocated(GNuc)) then
          call mma_allocate(GNuc,NAtoms,Label='GNuc')
          GNuc(:) = -100.0_wp
        end if
        do i=1,iTmp
          read(LuIn,*,iostat=istatus) j,tmp_spin,tmp_gfac
          call LineCheck(istatus)
          HypoIso(j) = .true.
          NucSpin(j) = tmp_spin
          GNuc(j) = tmp_gfac
        end do
      end if

    case ('AUNG')
      AutoSelect_GFac = .true.

    case ('GNUC')
      if (NATens_Calc == 0) then
        write(u6,*) 'Keyword HFCAt must be preceded by keyword GNUC'
        call Quit_OnUserError()
      end if
      GNuc_set = .true.
      call mma_allocate(GNuc,NAtoms,Label='gNuc')
      GNuc(:) = -100.0_wp
      call mma_allocate(rTemp_arr,NATens_Calc,Label='rTemp_arr')
      read(LuIn,*,iostat=istatus) (rTemp_arr(i),i=1,NATens_Calc)
      call LineCheck(istatus)
      read(LINE,*)
      j = 1
      do i=1,NAtoms
        if (Atens_req(I)) then
          GNuc(i) = rTemp_arr(j)
          j = j+1
        end if
      end do
      call mma_deallocate(rTemp_arr)

    case ('NMAS')
      if (NATens_Calc == 0) then
        write(u6,*) 'Keyword HFCAt must be preceded by keyword NMASs'
        call Quit_OnUserError()
      end if
      NMass_set = .true.
      call mma_allocate(NucMass,NAtoms,'NucMass')
      NucMass(:) = -100_iwp
      call mma_allocate(iTemp_arr,NATens_Calc,Label='iTemp_arr')
      read(LuIn,*,iostat=istatus) (iTemp_arr(i),i=1,NATens_Calc)
      j = 1
      do i=1,NAtoms
        if (Atens_req(I)) then
          NucMass(i) = iTemp_arr(j)
          j = j+1
        end if
      end do
      call mma_deallocate(iTemp_arr)

    case ('NSPI')
      if (NATens_Calc == 0) then
        write(u6,*) 'Keyword HFCAt must be preceded by keyword NSPIn'
        call Quit_OnUserError()
      end if
      NSpin_set = .true.
      call mma_allocate(NucSpin,NAtoms,Label='NucSpin')
      NucSpin(:) = -100.0_wp
      call mma_allocate(rTemp_arr,NATens_Calc,Label='rTemp_arr')
      read(LuIn,*,iostat=istatus) (rTemp_arr(i),i=1,NATens_Calc)
      j = 1
      do i=1,NAtoms
        if (Atens_req(I)) then
          NucSpin(i) = rTemp_arr(j)
          j = j+1
        end if
      end do
      call mma_deallocate(rTemp_arr)

#   ifdef _DMRG_
    case ('QDSC')
      QDPT2SC = .true.

    case ('QDPC')
      QDPT2SC = .false.
#   endif

    case ('EXTR')
      call WarningMessage(2,' Keyword EXTR is obsolete.')

    case ('TMOS')
      call WarningMessage(2,' Keyword TMOS is deprecated, use TINT instead.')

    case ('KVEC')
      call WarningMessage(2,' Keyword KVEC is deprecated, use DIRE instead.')

    case ('L-EF')
      call WarningMessage(2,' Keyword L-EF is deprecated, use IIOR instead.')

    case ('REDL')
      call WarningMessage(2,' Keyword REDL is deprecated, use SUBS instead.')

    case ('TMGR')
      call WarningMessage(2,' Keyword TMGR is deprecated, use TIGR instead.')

    case default
      write(u6,*) ' The following input line was not understood:'
      write(u6,'(A)') LINE
      call abend()

  end select

end do

!nf
if (IfDCpl .and. (.not. IfHam)) then
  call WarningMessage(1,'Input request was ignored.')
  write(u6,*) ' Cannot compute the approximate derivative coupling terms without the energies.'
  write(u6,*) ' Ignore them.'
  IfDCpl = .false.
end if
!nf
if (Do_Pol .and. (.not. Do_SK)) then
  call WarningMessage(1,'Input request was ignored.')
  write(u6,*) ' Polarization direction can only be used with'
  write(u6,*) ' specific k-vector directions.'
  Do_Pol = .false.
end if
! Prints warning if rot. str. threshold is defined without any calculations
if (RSPR) then
  if ((.not. DOCD) .and. (.not. Do_TMOM)) then
    call WarningMessage(1,'Input request was ignored.')
    write(u6,*) 'Warning: Rotatory strength threshold specified (RSPR) without calculating rotatory strength'
  end if
end if
! Determine file names, if undefined.
if (JBNAME(1) == 'UNDEFINE') then
  ! The first (perhaps only) jobiph file is named 'JOB001', or maybe 'JOBIPH'
  ! when no name has been issued by the user:
  NFLS = 0
  TRYNAME = 'JOB001'
  call F_INQUIRE(TRYNAME,LEXISTS)
  if (LEXISTS) then
    NFLS = 1
    JBNAME(NFLS) = TRYNAME
  else
    TRYNAME = 'JOBIPH'
    call F_INQUIRE(TRYNAME,LEXISTS)
    if (LEXISTS) then
      NFLS = 1
      JBNAME(NFLS) = TRYNAME
    else
      call WarningMessage(1,'RASSI lacks JobIph files.')
      write(u6,*) ' RASSI fails: No jobiph files found.'
      call ABEND()
    end if
  end if
  ! Subsequent (if any) jobfiles can be named according to old
  ! or new naming convention.
  ! Using new standard scheme for default jobiph names?
  do I=1,MXJOB-1
    if ((NJOB > 0) .and. (I > NJOB)) exit
    write(TRYNAME,'(A6,I2.2)') 'JOBIPH',I
    call F_INQUIRE(TRYNAME,LEXISTS)
    if (LEXISTS) then
      NFLS = NFLS+1
      JBNAME(NFLS) = TRYNAME
    else
      exit
    end if
  end do
  if (I > MXJOB-1) then
    call WarningMessage(1,'RASSI fails to identify JobIph files.')
    write(u6,*) ' Too many jobiph files in this directory.'
    call ABEND()
  end if
  if (NFLS == 1) then
    ! We may be using old standard scheme for default jobiph names?
    do I=1,MXJOB-1
      if ((NJOB > 0) .and. (I > NJOB)) exit
      write(TRYNAME,'(A3,I3.3)') 'JOB',I+1
      call F_INQUIRE(TRYNAME,LEXISTS)
      if (LEXISTS) then
        NFLS = NFLS+1
        JBNAME(NFLS) = TRYNAME
      else
        exit
      end if
    end do
    if (I > MXJOB-1) then
      call WarningMessage(1,'RASSI fails to identify JobIph files.')
      write(u6,*) ' Too many jobiph files in this directory.'
      call ABEND()
    end if
    ! Then we are definitely using the old default file name convention.
    !if (NFLS > 1) then
    !end if
  end if
  if (NJOB > 0) then
    ! Input has been given for NJOB, etc., and will be used.
    if (NFLS < NJOB) then
      call WarningMessage(1,'RASSI found too few JobIph files.')
      call ABEND()
    end if
  else
    ! Use defaults.
    NJOB = NFLS
  end if
end if

if (HypF_rms_Req .or. allocated(Atens_Req) .or. allocated(pNMR_req)) call gen_hfc_prop_labels()

call XFLUSH(u6)

call Close_LuSpool(LuIn)

contains

subroutine LineCheck(code)

  integer(kind=iwp), intent(in) :: code

  LineNr = LineNr+1
  select case (code)
    case (:-1)
      call WarningMessage(2,'I/O error.')
      write(u6,*) ' READIN: Unexpected end of input file.'
      call ABEND()
    case (0)
    case (1:)
      call WarningMessage(2,'Error reading standard input.')
      write(u6,*) ' RASSI input near line nr.',LINENR
      call ABEND()
  end select

end subroutine LineCheck

subroutine gen_proplab(prop_lab,iAtom,nComp,idx)
  !PURPOSE: Generate a specific property for iAtom with nComp

  character(len=4), intent(in) :: prop_lab
  integer(kind=iwp), intent(in) :: iAtom, nComp
  integer(kind=iwp), intent(out) :: idx(:,:)
  integer(kind=iwp) :: iC
  character(len=4) :: temp_lab

  do iC=1,nComp
    write(temp_lab,'(I4)') iAtom
    PNAME(NPROP+1) = prop_lab//temp_lab
    ICOMP(NPROP+1) = iC
    NPROP = NPROP+1
    idx(iAtom,iC) = NPROP
  end do

end subroutine gen_proplab

subroutine gen_hfc_prop_labels()
  ! PURPOSE: Generate PROP property labels for HFC and pNMR calculations.
  ! NOTE   : This subroutine may be deprecated if OpenMolcas stops using the PNAME label.
  !          In that case, property indices (ASD, PSOP) can be fed directly to the HFCOP subroutine.

  integer(kind=iwp) :: iAtom, iC
  logical(kind=iwp) :: do_calc, do_EPR, do_pNMR

  ! Check RX2C, MXTC to make sure that we don't calculate wrong numbers.
  call Get_iScalar('RX2C/MXTC_SEWARD',MagX2C_Req)
  if (MagX2C_Req == -1) call WarningMessage(2,'RX2C is used in SEWARD, but MXTC is not requested. '// &
                                            'Please use both keywords for relativistic HFC/pNMR calculation.')
  ! Note: For non-relativsitic calc, this subroutine can change the label to 'ASDO' instead of 'ASD'.
  !       However, PSOP is not calculated in SEWARD (without RX2C, MXTC), therefore only FC, SD are available.
  !       Furthermore, users are interested in FC+SD+PSO
  if (MagX2C_Req == -2) call WarningMessage(2,'For non-relativsitc HFC/pNMR calculations,'// &
                                            ' please use both keywords RX2C, MXTC in &SEWARD and set clight to a large value.')
  if (MagX2C_Req < 0) call Quit_OnUserError()

  call mma_allocate(ASD_idx,NAtoms,6,'LASD')
  call mma_allocate(PSO_idx,NAtoms,3,'LPSO')

  ASD_idx(:,:) = -1
  PSO_idx(:,:) = -1

  !NOTE  : This logic follows the same branching structure as route_calc in hfcop.F90, but skips iterator updates.
  do iAtom=1,NAtoms
    do_calc = .false.
    do_EPR = .false.
    do_pNMR = .false.

    if (allocated(Atens_Req)) do_EPR = Atens_Req(iAtom)
    if (allocated(pNMR_req)) do_pNMR = pNMR_req(iAtom)

    if (HypF_rms_Req) then
      do_calc = .true.
    else
      do_calc = do_EPR .or. do_pNMR
    end if

    if (do_calc) then
      call gen_proplab('ASD ',iAtom,6,ASD_idx)
      call gen_proplab('PSOP',iAtom,3,PSO_idx)
    end if
  end do

  if (allocated(pNMR_req)) then
    call mma_allocate(AngMom_idx,3,'AngMom_idx')
    do iC=1,3
      PNAME(NPROP+1) = 'AngMom'
      ICOMP(NPROP+1) = iC
      NPROP = NPROP+1
      AngMom_idx(iC) = NPROP
    end do
  end if

end subroutine gen_hfc_prop_labels

end subroutine READIN_RASSI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CSCALE(INDX,INTSYM,C,X)

use mrci_global, only: IRC, LSYM, NDIAG, NVIRT
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: INDX(*), INTSYM(*)
real(kind=wp), intent(inout) :: C(*)
real(kind=wp), intent(in) :: X
integer(kind=iwp) :: II1, MA, NA
integer(kind=iwp), external :: JSUNP

do II1=IRC(3)+1,IRC(4)
  if (JSUNP(INTSYM,II1) == LSYM) then
    NA = INDX(II1)
    do MA=1,NVIRT
      C(NA+NDIAG(MA)) = X*C(NA+NDIAG(MA))
    end do
  end if
end do

return

end subroutine CSCALE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Mickael G. Delcey                                      *
!***********************************************************************

subroutine CHO_Fock_MCLR(DA,G2,W_JA,W_KA,W_FkA,CVa,W_CMO,nIsh,nAsh,LuAChoVec)
!***********************************************************************
!                                                                      *
!  Author : M. G. Delcey                                               *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use Cholesky, only: InfVec, nBas, nBasSh, nDimRS, nShell, nSym, NumCho
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: DA(*), G2(*), W_CMO(*)
real(kind=wp), intent(_OUT_) :: W_JA(*), W_KA(*), W_FkA(*)
type(DSBA_type), intent(in) :: CVa
integer(kind=iwp), intent(in) :: nIsh(8), nAsh(8), LuAChoVec(8)
#include "warnings.h"
integer(kind=iwp) :: i, ia, iabg, iAdr, iag, iaSh, ib, iBatch, ibg, ibSh, iLoc, ioff, ioffa, ioffb, ipLpq(8,3), ipLtvb, ipLvb, &
                     ipLvtw, ipLvw, ipLwb, ipLxy, ipVJ, irc, IREDC, is, iSym, iSyma, iSymb, iSymv, IVEC2, iVrs, JNUM, JRED, JRED1, &
                     JRED2, jS, jSym, JVC, JVEC, k, l, lChoa, LREAD, lvec, LWORK, MaxVecPerBatch, mTvec, MUSED, NAv, NAw, nBatch, &
                     nMat, nRS, NumCV, NUMV, nVec, nVrs
logical(kind=iwp) :: add
type(DSBA_type) :: JA(1), KA, Fka, CMO, Scr
integer(kind=iwp), allocatable :: kOffSh(:,:)
real(kind=wp), allocatable :: Fab(:), LF(:), Lrs(:)
real(kind=wp), parameter :: FactCI = -Two, FactXI = Half
integer(kind=iwp), external :: Cho_LK_MaxVecPerBatch

call Allocate_DT(JA(1),nBas,nBas,nSym,aCase='TRI',Ref=W_JA)
call Allocate_DT(KA,nBas,nBas,nSym,Ref=W_KA)
call Allocate_DT(FkA,nBas,nBas,nSym,Ref=W_FkA)
call Allocate_DT(CMO,nBas,nBas,nSym,Ref=W_CMO)

! Compute Shell Offsets (MOs and transformed vectors)

call mma_allocate(kOffSh,nShell,nSym,Label='kOffSh')
do iSyma=1,nSym
  kOffSh(1,iSyma) = 0
  do iaSh=2,nShell ! kOffSh(iSh,iSym)
    kOffSh(iaSh,iSyma) = kOffSh(iaSh-1,iSyma)+nBasSh(iSyma,iaSh-1)
  end do
end do

! memory for the Q matrices --- temporary array
call Allocate_DT(Scr,nBas,nBas,nSym)
Scr%A0(:) = Zero

MaxVecPerBatch = Cho_LK_MaxVecPerBatch()

! Start looping!

do jSym=1,nSym
  NumCV = NumCho(jSym)
  call GAIGOP_SCAL(NumCV,'max')
  if (NumCV < 1) cycle

  iLoc = 3 ! use scratch location in reduced index arrays

  ! Estimate memory need

  mTvec = 0
  do l=1,nSym
    mTvec = mTvec+nAsh(Mul(l,JSYM))*nBas(l)*3
  end do

  JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) ! red set of the last vec

  ! entire red sets range for parallel run
  call GAIGOP_SCAL(JRED1,'min')
  call GAIGOP_SCAL(JRED2,'max')

  do JRED=JRED1,JRED2
    call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)
    if (nVrs == 0) cycle
    if (nVrs < 0) then
      write(u6,*) 'CHO_FOCK_MCLR: Cho_X_nVecRS returned nVrs<0. STOP!',nVrs
      call Abend()
    end if
    call Cho_X_SetRed(irc,iLoc,JRED)
    ! set index arrays at iLoc
    if (irc /= 0) then
      write(u6,*) 'CHO_FOCK_MCLR: cho_X_setred non-zero return code. rc= ',irc
      call Abend()
    end if
    IREDC = JRED

    nRS = nDimRS(JSYM,JRED)
    if (jSym == 1) then
      call mma_allocate(Fab,nRS,Label='Fab')
      Fab(:) = Zero
    end if

    call mma_MaxDBLE(LWORK)
    nVec = min(LWORK/(nRS+mTvec+1),min(nVrs,MaxVecPerBatch))
    if (nVec < 1) then
      write(u6,*) 'CHO_FOCK_MCLR: Insufficient memory for batch'
      write(u6,*) 'LWORK= ',LWORK
      write(u6,*) 'min. mem. need= ',nRS+mTvec+1
      write(u6,*) 'nRS= ',nRS
      write(u6,*) 'mTvec= ',mTvec
      write(u6,*) 'jsym= ',jsym
      call Quit(_RC_MEMORY_ERROR_)
      nBatch = -9999  ! dummy assignment
    end if
    LREAD = nRS*nVec

    call mma_allocate(Lrs,LREAD,Label='Lrs')
    call mma_allocate(LF,mTvec*nVec,Label='LF')

    nBatch = (nVrs-1)/nVec+1

    do iBatch=1,nBatch

      if (iBatch == nBatch) then
        JNUM = nVrs-nVec*(nBatch-1)
      else
        JNUM = nVec
      end if
      !*****************************************************************
      !                                                                *
      !     START WORKING                                              *
      !                                                                *
      !*****************************************************************

      ! Read Cholesky vector

      JVEC = nVec*(iBatch-1)+iVrs
      IVEC2 = JVEC-1+JNUM

      call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

      if ((NUMV <= 0) .or. (NUMV /= JNUM)) return

      !call CWTIME(TCINT1,TWINT1)

      ! Set up the skipping flags and the pointers ipLpq
      ! The memory used before for the full-dimension AO-vectors
      !     is now re-used to store half and full transformed
      !     vectors in the active space
      !-----------------------------------------------------------------
      lChoa = 0
      do i=1,nSym

        k = Mul(i,JSYM)

        ipLpq(k,1) = 1+lChoa   ! Lvb,J
        ipLpq(k,2) = ipLpq(k,1)+nAsh(k)*nBas(i)*JNUM ! Lvi,J i general MO index
        ipLpq(k,3) = ipLpq(k,2)+nAsh(k)*nBas(i)*JNUM ! L~vi,J ~ transformed index

        lChoa = lChoa+nAsh(k)*nBas(i)*3*JNUM

      end do

      !  Read half-transformed cho vectors

      ioff = 0
      do i=1,nSym
        k = Mul(i,JSYM)
        lvec = nAsh(k)*nBas(i)*JNUM
        iAdr = (JVEC-1)*nAsh(k)*nBas(i)+ioff
        call DDAFILE(LuAChoVec(Jsym),2,LF(ipLpq(k,1)),lvec,iAdr)
        ioff = ioff+nAsh(k)*nBas(i)*NumCho(jSym)
      end do
      !call CWTIME(TCINT2,TWINT2)
      !tint1(1) = tint1(1)+(TCINT2-TCINT1)
      !tint1(2) = tint1(2)+(TWINT2-TWINT1)
      !-----------------------------------------------------------------
      ! Active-Active transformation  Lvw,J = sum_b  Lvb,J * C2(w,b)
      !-----------------------------------------------------------------
      do iSymb=1,nSym

        iSymv = Mul(JSYM,iSymb)
        NAv = nAsh(iSymv)
        NAw = nAsh(iSymb)

        if (NAv*NBAS(iSymb) /= 0) then

          !call CWTIME(TCINT2,TWINT2)

          do JVC=1,JNUM
            ipLvb = ipLpq(iSymv,1)+NAv*NBAS(iSymb)*(JVC-1)
            ipLvw = ipLpq(iSymv,2)+NAv*Naw*(JVC-1)
            call DGEMM_('N','T',NAv,Naw,NBAS(iSymb),One,LF(ipLvb),NAv,CVa%SB(iSymb)%A2,Naw,Zero,LF(ipLvw),NAv)
          end do
          !call CWTIME(TCINT2,TWINT2)
          !tint1(1) = tint1(1)+(TCINT2-TCINT3)
          !tint1(2) = tint1(2)+(TWINT2-TWINT3)

          ! ********** EVALUATION OF THE ACTIVE FOCK MATRIX ************
          ! Coulomb term
          ipVJ = ipLpq(iSymv,3)
          ipLvtw = ipLpq(iSymv,2)

          call DGEMV_('T',Nav*Naw,JNUM,One,LF(ipLvtw),Nav*Naw,DA,1,Zero,LF(ipVJ),1)

          call DGEMV_('N',nRS,JNUM,-FactCI,Lrs,nRS,LF(ipVJ),1,One,Fab,1)

          !call CWTIME(TCINT2,TWINT2)
          !tact(1) = tact(1)+(TCINT2-TCINT3)
          !tact(2) = tact(2)+(TWINT2-TWINT3)
          !-------------------------------------------------------------
          ! Formation of the Q matrix Qpx = L~py Lvw Gxyvw
          !-------------------------------------------------------------
          do JVC=1,JNUM
            ! Lxy=Lvw Gxyvw
            !MGD probably additional nSym loop
            ipLvb = ipLpq(iSymv,1)+NAv*NBAS(iSymb)*(JVC-1)
            ipLvw = ipLpq(iSymv,2)+NAv*Naw*(JVC-1)
            ipLxy = ipLpq(iSymv,3)+NAv*Naw*(JVC-1)
            call DGEMV_('N',NAv*Naw,NAv*Naw,One,G2,NAv*Naw,LF(ipLvw),1,Zero,LF(ipLxy),1)
            ! Qpx=Lpy Lxy
            call DGEMM_('T','N',NBAS(iSymb),NAw,Nav,One,LF(ipLvb),NAv,LF(ipLxy),Naw,One,Scr%SB(iSymb)%A2,NBAS(iSymb))
          end do
          !call CWTIME(TCINT3,TWINT3)
          !tQmat(1) = tQmat(1)+(TCINT3-TCINT2)
          !tQmat(2) = tQmat(2)+(TWINT3-TWINT2)

          ! ********** EVALUATION OF THE ACTIVE FOCK MATRIX ************
          ! Exchange term
          do JVC=1,JNUM
            ipLvb = ipLpq(iSymv,1)+NAv*NBAS(iSymb)*(JVC-1)
            ipLwb = ipLpq(iSymv,2)+NAv*NBAS(iSymb)*(JVC-1)
            call DGEMM_('T','N',NBAS(iSymb),Nav,Nav,One,LF(ipLvb),Nav,DA,Nav,Zero,LF(ipLwb),NBAS(iSymb))
          end do
          !call CWTIME(TCINT2,TWINT2)
          !tact(1) = tact(1)+(TCINT2-TCINT3)
          !tact(2) = tact(2)+(TWINT2-TWINT3)
          do JVC=1,JNUM
            ipLwb = ipLpq(iSymv,2)+NAv*NBAS(iSymb)*(JVC-1)
            do is=1,NBAS(iSymb)
              ipLtvb = ipLpq(iSymv,1)+NAv*NBAS(iSymb)*(JVC-1)+Nav*(is-1)
              call DGEMV_('N',NBAS(iSymb),Nav,-FactXI,LF(ipLwb),NBAS(iSymb),LF(ipLtvb),1,One,KA%SB(iSymb)%A2(:,is),1)

            end do
          end do
          !call CWTIME(TCINT3,TWINT3)
          !tact(1) = tact(1)+(TCINT3-TCINT2)
          !tact(2) = tact(2)+(TWINT3-TWINT2)
        end if
      end do

      ! All good things come to an end

    end do  ! end batch loop

    ! backtransform fock matrix to full storage
    if (JSYM == 1) then
      add = .true.
      nMat = 1
      call swap_rs2full(irc,iLoc,nRS,nMat,JSYM,JA,Fab,add)
      call mma_deallocate(Fab)
    end if
    call mma_deallocate(Lrs)
    call mma_deallocate(LF)
  end do  ! loop over red sets
end do    ! loop over JSYM
!***********************************************************************
!                                                                      *
!     POST PROCESSING                                                  *
!                                                                      *
!***********************************************************************
!
! Accumulate Coulomb and Exchange contributions

do iSym=1,nSym

  do iaSh=1,nShell
    ioffa = kOffSh(iaSh,iSym)

    do ibSh=1,nShell

      ioffb = kOffSh(ibSh,iSym)

      do ib=1,nBasSh(iSym,ibSh)
        do ia=1,nBasSh(iSym,iaSh)
          !MGD warning with sym

          iag = ioffa+ia
          ibg = ioffb+ib
          iabg = iTri(iag,ibg)

          FkA%SB(iSym)%A2(iag,ibg) = JA(1)%SB(iSym)%A1(iabg)+KA%SB(iSym)%A2(iag,ibg)+KA%SB(iSym)%A2(ibg,iag)
        end do
      end do
    end do
  end do
end do

call Deallocate_DT(JA(1))
call Allocate_DT(JA(1),nBas,nBas,nSym,Ref=W_JA)

! Transform Fock and Q matrix to MO basis

do iS=1,nSym
  jS = iS
  if (nBas(iS) /= 0) then
    call DGEMM_('T','N',nBas(jS),nBas(iS),nBas(iS),One,FkA%SB(iS)%A2,nBas(iS),CMO%SB(iS)%A2,nBas(iS),Zero,JA(1)%SB(iS)%A2,nBas(jS))
    FkA%SB(is)%A2(:,:) = Zero
    call DGEMM_('T','N',nBas(jS),nIsh(jS),nBas(iS),One,JA(1)%SB(iS)%A2,nBas(iS),CMO%SB(jS)%A2,nBas(jS),Zero,FkA%SB(iS)%A2,nBas(jS))
    !ioff = nIsh(iS)+1
    iOff = 1+nIsh(iS)*nBas(iS)
    call DGEMM_('T','N',nBas(jS),nAsh(iS),nBas(jS),One,CMO%SB(iS)%A2,nBas(jS),Scr%SB(iS)%A2,nBas(jS),Zero,FkA%SB(iS)%A1(iOff:), &
                nBas(jS))
  end if
end do
!***********************************************************************
!                                                                      *
!     TERMINATING                                                      *
!                                                                      *
!***********************************************************************
call deallocate_DT(Scr)
call mma_deallocate(kOffSh)
call Deallocate_DT(CMO)
call Deallocate_DT(FkA)
call Deallocate_DT(KA)
call Deallocate_DT(JA(1))

return

end subroutine CHO_Fock_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine SroHss( &
#                 define _CALLING_
#                 include "hss_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of ECP integrals.         *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Symmetry_Info, only: iOper
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
#include "hss_interface.fh"
integer(kind=iwp) :: iang, iDCRT(0:7), ip, ipfa1, ipfa2, ipfb1, ipfb2, ipfin, iptmp, ishll, iuvwx(4), JndGrd(3,4,0:7), &
                     jndhss(4,3,4,3,0:7), kcnt, kCnttp, kdc, kOp(4), ldcrt, lmbdt, mop(4), nDCRT, nExpi, nt
real(kind=wp) :: C(3), Coor(3,4), fact, g2(78), TC(3)
logical(kind=iwp) :: ifg(4), jfgrd(3,4), jfhss(4,3,4,3), tr(4)
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(P)
unused_var(rFinal)
unused_var(nHer)
unused_var(Ccoor)
unused_var(lOper)

iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
mop(1:2) = nOp
kop(1) = ioper(nop(1))
kop(2) = ioper(nop(2))
coor(:,1) = A
coor(:,2) = RB

kdc = 0
do kCnttp=1,ncnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (.not. dbsc(kcnttp)%ECP) cycle
  if (dbsc(kcnttp)%nSRO <= 0) cycle
  do kcnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)

    call dcr(lmbdt,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    fact = real(nstabm,kind=wp)/real(LmbdT,kind=wp)

    iuvwx(3) = dc(kdc+kCnt)%nStab
    iuvwx(4) = dc(kdc+kCnt)%nStab

    do ldcrt=0,ndcRT-1

      kop(3) = idcrt(ldcrT)
      kop(4) = kop(3)
      mop(3) = nropr(kop(3))
      mop(4) = mop(3)

      call OA(iDCRT(lDCRT),C,TC)
      Coor(:,3) = TC

      if (eq(a,rb) .and. eq(A,TC)) cycle
      call nucind(coor,kdc+kCnt,ifgrd,ifhss,indgrd,indhss,jfgrd,jfhss,jndgrd,jndhss,tr,ifg)
      do iang=0,dbsc(kCnttp)%nSRO-1
        ishll = dbsc(kcnttp)%iSRO+iAng
        nExpi = Shells(iShll)%nExp
        if (nExpi == 0) cycle

        ip = 1
        ipfin = ip
        ip = ip+nzeta*nTri_Elem1(la)*nTri_Elem1(lb)*21
        ipfa1 = ip
        ip = ip+nalpha*nExpi*nTri_Elem1(la)*nTri_Elem1(iAng)*4
        iptmp = ip
        ip = ip+nalpha*nExpi
        ipfa2 = ip
        ip = ip+nalpha*nExpi*nTri_Elem1(la)*nTri_Elem1(iAng)*6
        ipfb1 = ip
        ip = ip+nExpi*nBeta*nTri_Elem1(iAng)*nTri_Elem1(lb)*4
        ipfb2 = ip
        ip = ip+nExpi*nBeta*nTri_Elem1(iAng)*nTri_Elem1(lb)*6

        Array(:) = Zero
        ! <a|c>, <a'|c>, <a",c>
        call Acore(iang,la,ishll,nordop,TC,A,Array(ip),narr-ip+1,Alpha,nalpha,Array(ipFA1),array(ipfa2),jfgrd(1,1),jfhss,2,.false.)
        ! Transform core orbital to spherical harmonics
        call LToSph(Array(ipFA1),nAlpha,ishll,la,iAng,4)
        call LToSph(Array(ipFA2),nAlpha,ishll,la,iAng,6)

        ! <c|b>,<c,b'>,<c|b">
        call coreB(iang,lb,ishll,nordop,TC,RB,Array(ip),narr-ip+1,Beta,nbeta,Array(ipFB1),array(ipfb2),jfgrd(1,2),jfhss,2,.false.)
        ! Transform core orbital to spherical harmonics
        call RToSph(Array(ipFB1),nBeta,ishll,lb,iAng,4)
        call RToSph(Array(ipFB2),nBeta,ishll,lb,iAng,6)

        ! Construct complete derivatives (contracting core)
        call CmbnACB2(Array(ipFa1),Array(ipFa2),Array(ipFb1),Array(ipFb2),Array(ipFin),Fact,nalpha,nbeta,Shells(iShll)%Akl,nExpi, &
                      la,lb,iang,jfhss,Array(ipTmp),.true.)

        ! contract density
        nt = nZeta*nTri_Elem1(la)*nTri_Elem1(lb)
        g2(:) = Zero
        call dGeMV_('T',nT,21,One,Array(ipFin),nT,DAO,1,Zero,g2,1)

        ! distribute in hessian
        call Distg2(g2,Hess,nHess,JndGrd,JfHss,JndHss,iuvwx,kOp,mop,Tr,IfG)

      end do
    end do
  end do
end do

return

end subroutine SroHss

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GETDREF(DREF,NDREF)
      use definitions, onlY: iwp, wp, u6
      use constants, only: Zero
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NASHT
      use pt2_guga, only: NG1
      IMPLICIT NONE
      integer(kind=iwp), intent(in):: NDREF
      real(kind=wp), intent(out):: DREF(NDREF)

      real(kind=wp), ALLOCATABLE:: G1(:)
      integer(kind=iwp) I, J, IJ

* Get active 1-el density matrix GAMMA1 and
* construct DREF in a tringular storage.

* Remember: NDREF=1 if NASHT=0.
      DREF(1)=Zero
      IF(NASHT==0) RETURN
* Active 1-el density matrix:
      CALL mma_allocate(G1,NG1,Label='G1')
      CALL PT2_GET(NG1,'GAMMA1',G1)
      DO I=1,NASHT
        DO J=1,I
          IJ=(I*(I-1))/2+J
          DREF(IJ)=G1(I+NASHT*(J-1))
        END DO
      END DO
      CALL mma_deallocate(G1)

      IF(IPRGLB.GE.DEBUG) THEN
        WRITE(u6,*)' GETDREF has constructed DREF.'
      END IF

      END SUBROUTINE GETDREF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  ChoDec
*
*> @brief
*>   Decompose a symmetric positive (semi-)definite matrix
*> @author Thomas Bondo Pedersen
*>
*> @details
*> ::ChoDec will Cholesky decompose a positive (semi-)definite
*> matrix without knowledge of all its elements (i.e., using a
*> matrix-direct approach).
*>
*> Given the diagonal, the idea is that ::ChoDec asks the caller
*> for specified columns of the matrix when needed during
*> decomposition. This is done by invoking the external routine
*> passed as \p CD_Col. Similarly, the caller must provide an
*> external routine, passed as \p CD_Vec, that handles the Cholesky
*> vector buffer---that is, empties or fills the buffer (\p CD_Vec
*> could e.g. do Cholesky vector I/O).
*>
*> The external subroutine \p CD_Col must have the following call
*> pattern:
*>
*> \code
*>   Call CD_Col(Col,nDim,iCol,nCol,Buf,lBuf)
*> \endcode
*>
*> where \p Col(nDim,nCol) contains the columns, \p iCol(nCol) specifies
*> the columns requested [i.e., column \p Col(*,i) should correspond
*> to column \p iCol(i) in the full matrix], and \p Buf(lBuf) can be
*> used as (perhaps additional) work space.
*>
*> The external subroutine \p CD_Vec must have the following call
*> pattern:
*>
*> \code
*>   Call CD_Vec(iVec1,nVec,Buf,lBuf,nDim,iOpt)
*> \endcode
*>
*> where \p iVec1 is the index of the first vector, \p nVec the number
*> of vectors, and \p nDim the vector dimension. The buffer \p Buf has
*> total dimension \p lBuf. For \p iOpt = ``1`` ("empty buffer option"),
*> the first \p nDim*\p nVec elements of \p Buf contain the vectors on
*> input---i.e. \p CD_Vec is expected to move the vectors to another
*> location so that all of \p Buf is again available for use.
*> For \p iOpt = ``2`` ("fill buffer option"), the process is reversed and
*> \p ChoDec expects \p CD_Vec to return vectors
*> \p iVec1, \p iVec1+1, ..., \p iVec1+\p nVec-1, in the first \p nDim*\p nVec elements
*> of \p Buf.
*>
*> The error code \p irc is ``0`` if success, while a non-zero number
*> is returned if some failure (or if the matrix is not positive
*> (semi-)definite) occurs. In the latter cases, the
*> decomposition is ill-defined and the data returned is junk!
*>
*> @note
*> \p Thr and \p Span may be reset in this routine (if they
*> are not properly defined on input).
*>
*> @param[in]     CD_Col  External subroutine for retrieving matrix columns
*> @param[in]     CD_Vec  External subroutine for filling and emptying Cholesky vector buffer
*> @param[in]     Restart Flag for restarting decomposition
*> @param[in,out] Thr     Decomposition threshold (precision)
*> @param[in,out] Span    Span factor
*> @param[in]     MxQual  Max. number of qualified columns per decomposition pass
*> @param[in]     Diag    Array containing the diagonal of the matrix to be decomposed
*> @param[in]     Qual    Storage array for matrix columns
*> @param[in]     Buf     Buffer for storing Cholesky vectors
*> @param[in]     iPivot  Pivoting array
*> @param[in]     iQual   Array for storing qualified indices
*> @param[in]     nDim    Linear dimension of matrix
*> @param[in]     lBuf    Buffer size
*> @param[out]    ErrStat Min, max, and RMS errors, respectively, for decomposition as judged
*>                        from the residual diagonal elements
*> @param[in,out] NumCho  Number of Cholesky vectors
*> @param[out]    irc     Return code
************************************************************************
      SubRoutine ChoDec(CD_Col,CD_Vec,
     &                  Restart,Thr,Span,MxQual,
     &                  Diag,Qual,Buf,
     &                  iPivot,iQual,
     &                  nDim,lBuf,
     &                  ErrStat,NumCho,
     &                  irc)
      Implicit Real*8 (a-h,o-z)
      External  CD_Col    ! external routine for matrix columns
      External  CD_Vec    ! external routine for Cholesky vectors
      Logical   Restart
      Dimension Diag(nDim), Qual(nDim,0:MxQual), Buf(lBuf)
      Integer   iPivot(nDim), iQual(MxQual)
      Dimension ErrStat(3)

      Logical   Converged

      Character*6 SecNam
      Parameter (SecNam = 'ChoDec')

      Parameter (DefThr = 1.0d-6, DefSpan = 1.0d-2) ! defaults
      Parameter (ThrNeg = -1.0d-13, ThrFail = -1.0d-8)


C     Initialize variables.
C     ---------------------

      irc = 0
      ErrStat(1) =  9.876543210d15
      ErrStat(2) = -9.876543210d15
      ErrStat(3) = -9.876543210d15
      If (.not. Restart) NumCho = 0
      Converged = .false.

C     Check dimensions.
C     -----------------

      If (nDim .lt. 1) Then
         irc = 0
         Go To 1  ! exit (nothing to do)
      End If
      If (MxQual .lt. 1) Then
         irc = -1
         Go To 1  ! exit (qualification not possible)
      End If
      mQual  = min(MxQual,nDim)
      MinBuf = nDim + mQual
      If (lBuf .lt. MinBuf) Then
         irc = -2
         Go To 1 ! exit (buffer too small)
      End If

C     Check configuration.
C     --------------------

      If (Thr .lt. 0.0d0) Then
         Thr = DefThr  ! reset threshold
      End If
      If (Span.lt.0.0d0 .or. Span.gt.1.0d0) Then
         Span = DefSpan ! reset span factor
      End If

C     Set up a (possibly updated) copy of the diagonal.
C     Test diagonal for negative elements.
C     -------------------------------------------------

      Call CD_Diag(CD_Vec,
     &             Restart,Converged,Thr,
     &             ThrNeg,ThrFail,
     &             Diag,Qual(1,0),Buf,
     &             nDim,lBuf,
     &             ErrStat,NumCho,
     &             irc)
      If (irc .ne. 0) Go To 1 ! exit (initial diagonal error)

C     Only do decomposition if not converged!
C     ---------------------------------------

      If (.not. Converged) Then

C        Cholesky decompose.
C        -------------------

         MxNumCho = nDim ! generate as many vectors as needed
         Call CD_Decomposer(CD_Col,CD_Vec,MxNumCho,
     &                      Thr,Span,mQual,
     &                      ThrNeg,ThrFail,
     &                      Qual(1,0),Qual(1,1),Buf,
     &                      iPivot,iQual,
     &                      nDim,lBuf,
     &                      NumCho,
     &                      irc)
         If (irc .ne. 0) Go To 1  ! exit (decomposition error)

C        Check diagonal and set up error statistics.
C        -------------------------------------------


         Call CD_Diag(CD_Vec,
     &                .true.,Converged,Thr,
     &                ThrNeg,ThrFail,
     &                Diag,Qual(1,0),Buf,
     &                nDim,lBuf,
     &                ErrStat,NumCho,
     &                irc)
         If (irc .ne. 0) Then
            irc = irc + 200 ! makes the error code 400 + n
            Go To 1 ! exit (check error)
         Else If (.not. Converged) Then
            irc = 1
            Go To 1 ! exit (decomposition failure)
         End If

      End If

C     That's it!
C     ----------

    1 Continue
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SQUARM(A,B,N)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: A(*)
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(out) :: B(N,N)
integer(kind=iwp) :: I, IIN

IIN = 2
do I=2,N
  B(1:I-1,I) = -A(IIN:IIN+I-2)
  B(I,1:I-1) = A(IIN:IIN+I-2)
  IIN = IIN+I
end do
call DCOPY_(N,[Zero],0,B,N+1)

return

end subroutine SQUARM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Set_Basis_Mode(Label)

use BasisMode, only: All_Mode, Atomic, Auxiliary_Mode, Basis_Mode, Fragment_Mode, kCnttp, Valence_Mode, With_Auxiliary_Mode, &
                     With_Fragment_Mode

implicit none
character(len=*), intent(in) :: Label
character(len=7) :: Lbl

Atomic = .false.
kCnttp = 0
Lbl = Label(1:7)
call UpCase(Lbl)
select case (Lbl)
  case ('VALENCE')
    Basis_Mode = Valence_Mode
  case ('AUXILIA')
    Basis_Mode = Auxiliary_Mode
  case ('FRAGMEN')
    Basis_Mode = Fragment_Mode
  case ('WITHAUX')
    Basis_Mode = With_Auxiliary_Mode
  case ('WITHFRA')
    Basis_Mode = With_Fragment_Mode
  case ('ALL')
    Basis_Mode = All_Mode
  case default
    call WarningMessage(2,'Set_Basis_Mode: illegal mode, Label='//Lbl)
    call Abend()
end select

end subroutine Set_Basis_Mode

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Niclas Forsberg                                  *
!***********************************************************************

subroutine WriteInt(IntMat,TermMat,mMat,nMat,OccNumMat2,MatEl,ForceField,E1,E2,T0,harmfreq1,harmfreq2,x_anharm1,x_anharm2, &
                    l_IntMat_1,l_IntMat_2,l_TermMat_1,l_TermMat_2,nDimTot,nOsc)
!  Purpose:
!    Write vibrational levels, intensities to log.
!
!  Input:
!    FC       : Real two dimensional array - Franck-Condon factors.
!    Int_Mat  : Real two dimensional array - Intensities.
!    Term_Mat : Real two dimensional array - Vibronic levels.
!    mMat     : Integer two dimensional array - oscillator quanta for ground state.
!    nMat     : Integer two dimensional array - oscillator quanta for excited state.
!    m_plot,
!    n_plot   : Integer array - transitions wanted in output.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use mula_global, only: broadplot, cmstart, cmend, hbarcm, LifeTime, m_plot, mdim1, mdim2, n_plot, ndim1, ndim2, OscStr, &
                       plotwindow, Use_cm, Use_nm, WriteVibLevels
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half, auTocm, auToeV
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mMat(0:mdim1,mdim2), nMat(0:ndim1,ndim2), l_IntMat_1, l_IntMat_2, l_TermMat_1, l_TermMat_2, &
                                 nDimTot, nOsc
real(kind=wp), intent(in) :: IntMat(0:l_IntMat_1,0:l_IntMat_2), TermMat(0:l_TermMat_1,0:l_TermMat_2), &
                             OccNumMat2(0:nDimTot-1,nOsc), E1(nDimTot), E2(nDimTot), T0, harmfreq1(nOsc), harmfreq2(nOsc), &
                             x_anharm1(nOsc,nOsc), x_anharm2(nOsc,nOsc)
logical(kind=iwp), intent(in) :: MatEl, ForceField
integer(kind=iwp) :: i, ifreq, iOrd, ipoint, iprintLevel, itemp(3), iTrans, iv, ivee_cm, ivee_nm, j, jOrd, k, l_harm, m_plot_max, &
                     max_mOrd, max_mQuanta, max_nOrd, max_nQuanta, maxQuanta, n, n_plot_max, nval, nvar, plotunit, TermMax, &
                     TermMin, nvTabDim
real(kind=wp) :: const, conv, FWHM, G1, G2, Intensity, max_Intensity, vee, vee_cm, vee_eV, vee_nm
character(len=23) :: CharTemp
character(len=12) :: frmt
integer(kind=iwp), allocatable :: level1(:), level2(:), mMatStart(:), mMatStop(:), TermSort(:,:), VibSort1(:,:), VibSort2(:,:)
real(kind=wp), allocatable :: plotvec(:), VibLevel1(:), VibLevel2(:)
character(len=23), allocatable :: mMatChar(:), nMatChar(:)
integer(kind=iwp), parameter :: nfreq = 2000
integer(kind=iwp), external :: isfreeunit

write(u6,*)
write(u6,*)
write(u6,*)
write(u6,*)
write(u6,'(a27,a)') ' ',' ================================================='
write(u6,'(a27,a)') ' ','|                                                 |'
write(u6,'(a27,a)') ' ','|       Results from intensity calculations       |'
write(u6,'(a27,a)') ' ','|                                                 |'
write(u6,'(a27,a)') ' ',' ================================================='
write(u6,*)
write(u6,*)

! Dimensions.
max_mOrd = l_IntMat_1
max_nOrd = l_IntMat_2
nvar = nOsc

call mma_allocate(mMatChar,[0,mdim1+1],label='mMatChar')
call mma_allocate(nMatChar,[0,ndim1+1],label='nMatChar')

if (nvar < 21) then
  if (nvar > 0) write(frmt,'(a,i2,a)') '(a1,',nvar,'i1,a2)'
  do i=0,mdim1
    write(CharTemp,fmt=frmt) '(',(mMat(i,j),j=1,nvar),')'
    mMatChar(i) = CharTemp
  end do
  do i=0,ndim1
    write(CharTemp,fmt=frmt) '(',(nMat(i,j),j=1,nvar),')'
    nMatChar(i) = CharTemp
  end do
else
  do i=0,max_mOrd
    write(CharTemp,'(i5)') i
    mMatChar(i) = CharTemp
  end do
  do i=0,max_nOrd
    write(CharTemp,'(i5)') i
    nMatChar(i) = CharTemp
  end do
  !vv
  iprintLevel = 0
  if (iprintLevel == 10) then
    write(u6,*)
    write(u6,*)
    write(u6,*) ' ','The meaning of n and nprime in FC-table below:'
    write(u6,fmt='(a1,a,40a3,a)') ' ','=============',('===',i=1,nvar),'='
    !write(u6,fmt='(40a3)',advance='no')  ('===',i=1,nvar)
    !write(u6,fmt='(   a)',advance='yes') '='
    write(u6,*)
    write(u6,*) ' ','     n                                  Oscillator quanta'
    write(u6,fmt='(a1,a,40a3,a)') ' ','-------------',('---',i=1,nvar),'-'
    !write(u6,fmt='(40a3)',advance='no')  ('---',i=1,nvar)
    !write(u6,fmt='(   a)',advance='yes') '-'
    if (max_mOrd > max_nOrd) then
      do i=0,max_mOrd
        write(u6,'(a4,i4,a5,40i3)') ' ',i,' ',(mMat(i,j),j=1,nvar)
      end do
    else
      do i=0,max_nOrd
        write(u6,'(a4,i4,a5,40i3)') ' ',i,' ',(nMat(i,j),j=1,nvar)
      end do
    end if
    write(u6,fmt='(a1,a,40a3,a)') ' ','=============',('===',i=1,nvar),'='
    !write(u6,fmt='(40a3)',advance='no')  ('===',i=1,nvar)
    !write(u6,fmt='(   a)',advance='yes') '='
  end if
end if

! Write vibrational levels.
if (WriteVibLevels) then
  call mma_allocate(VibLevel1,[0,max_mOrd],label='VibLevel1')
  call mma_allocate(VibLevel2,[0,max_nOrd],label='VibLevel2')
  if (MatEl) then
    k = 0
    do iOrd=1,max_mOrd+1
      VibLevel1(k) = E1(iOrd)-E1(1)
      VibLevel2(k) = T0+(E2(iOrd)-E2(1))
      k = k+1
    end do
  else
    call mma_allocate(level1,nvar,label='level1')
    call mma_allocate(level2,nvar,label='level2')

    G1 = Zero
    G2 = G1+T0
    k = 0
    VibLevel1(k) = Zero
    level1(:) = mMat(0,:)
    if (max_mOrd > 0) then
      do iOrd=1,max_mOrd
        k = k+1
        level2(:) = mMat(iOrd,:)
        l_harm = nOsc
        call TransEnergy(G1,x_anharm1,harmfreq1,level1,G1,x_anharm1,harmfreq1,level2,VibLevel1(k),l_harm)
      end do
    end if
    k = 0
    do iOrd=0,max_nOrd
      level2(:) = nMat(iOrd,:)
      l_harm = nOsc
      call TransEnergy(G1,x_anharm2,harmfreq2,level1,G2,x_anharm2,harmfreq2,level2,VibLevel2(k),l_harm)
      k = k+1
    end do
    call mma_deallocate(level1)
    call mma_deallocate(level2)
  end if

  call mma_allocate(VibSort1,[1,2],[0,max_mOrd],label='VibSort1')
  call mma_allocate(VibSort2,[1,2],[0,max_nOrd],label='VibSort2')

  do iOrd=0,max_mOrd
    VibSort1(1,iOrd) = int(VibLevel1(iOrd)*auTocm)
    VibSort1(2,iOrd) = iOrd
  end do
  do iOrd=0,max_nOrd
    VibSort2(1,iOrd) = int(VibLevel2(iOrd)*auTocm)
    VibSort2(2,iOrd) = iOrd
  end do
  call mma_deallocate(VibLevel1)
  call mma_deallocate(VibLevel2)

  if (max_mOrd > 0) then
    do i=0,max_mOrd
      do j=i+1,max_mOrd
        if (VibSort1(1,j) < VibSort1(1,i)) then
          itemp(1:2) = VibSort1(:,j)
          VibSort1(:,j) = VibSort1(:,i)
          VibSort1(:,i) = itemp(1:2)
        end if
      end do
    end do
  end if
  if (max_nOrd > 0) then
    do i=0,max_nOrd
      do j=i+1,max_nOrd
        if (VibSort2(1,j) < VibSort2(1,i)) then
          itemp(1:2) = VibSort2(:,j)
          VibSort2(:,j) = VibSort2(:,i)
          VibSort2(:,i) = itemp(1:2)
        end if
      end do
    end do
  end if

  write(u6,*)
  write(u6,*)
  write(u6,*) ' ','Vibrational levels for ground state'
  write(u6,*) ' ','=============================================='
  write(u6,*)
  write(u6,*) ' ','     Level                     Energy(cm-1)'
  write(u6,*) ' ','----------------------------------------------'
  do i=0,max_mOrd
    iOrd = VibSort1(2,i)
    write(u6,'(a4,a15,a15,i7)') ' ',mMatChar(iOrd),' ',VibSort1(1,i)
  end do
  write(u6,*) ' ','=============================================='

  write(u6,*)
  write(u6,*)
  write(u6,*) ' ','Vibrational levels for excited state'
  write(u6,*) ' ','=============================================='
  write(u6,*)
  write(u6,*) ' ','     Level                     Energy(cm-1)'
  write(u6,*) ' ','----------------------------------------------'
  do i=0,max_nOrd
    iOrd = VibSort2(2,i)
    write(u6,'(a4,a15,a15,i7)') ' ',nMatChar(iOrd),' ',VibSort2(1,i)
  end do
  write(u6,*) ' ','=============================================='
  call mma_deallocate(VibSort1)
  call mma_deallocate(VibSort2)

end if

! Find start and end points for a given total quanta in mMat and nMat.
m_plot_max = size(m_plot)
n_plot_max = size(n_plot)
max_mQuanta = maxval(m_plot)
max_nQuanta = maxval(n_plot)
maxQuanta = max(max_mQuanta,max_nQuanta)
call mma_allocate(mMatStart,[0,maxQuanta],label='mMatStart')
call mma_allocate(mMatStop,[0,maxQuanta],label='mMatStop')
mMatStart(0) = 0
mMatStop(0) = 0
do i=1,maxQuanta
  mMatStart(i) = mMatStop(i-1)+1
  call TabDim(i,nvar,nvTabDim)
  mMatStop(i) = nvTabDim-1
end do

! Intensities.
n = (l_TermMat_1+2)*(l_TermMat_2+2)
call mma_allocate(TermSort,[1,3],[0,n],label='TermSort')
nval = 0
max_Intensity = Zero

if (MatEl .and. (.not. ForceField)) then
  if (max_mQuanta <= max_nQuanta) then
    do i=1,m_plot_max
      do iOrd=mMatStart(m_plot(i)),mMatStop(m_plot(i))
        do jOrd=0,3*max_mOrd/4
          TermSort(1,nval) = int(TermMat(iOrd,jOrd)*auTocm)
          TermSort(2,nval) = iOrd
          TermSort(3,nval) = jOrd
          nval = nval+1
        end do
      end do
    end do
  else
    do iOrd=0,3*max_mOrd/4
      do j=1,n_plot_max
        do jOrd=mMatStart(n_plot(j)),mMatStop(n_plot(j))
          if (IntMat(iOrd,jOrd) > max_Intensity) max_Intensity = IntMat(iOrd,jOrd)
          TermSort(1,nval) = int(abs(TermMat(iOrd,jOrd))*auTocm)
          TermSort(2,nval) = iOrd
          TermSort(3,nval) = jOrd
          nval = nval+1
        end do
      end do
    end do
  end if
else
  do i=1,m_plot_max
    do j=1,n_plot_max
      do iOrd=mMatStart(m_plot(i)),mMatStop(m_plot(i))
        do jOrd=mMatStart(n_plot(j)),mMatStop(n_plot(j))
          if (IntMat(iOrd,jOrd) > max_Intensity) max_Intensity = IntMat(iOrd,jOrd)
        end do
      end do
    end do
  end do
  do i=1,m_plot_max
    do j=1,n_plot_max
      do iOrd=mMatStart(m_plot(i)),mMatStop(m_plot(i))
        do jOrd=mMatStart(n_plot(j)),mMatStop(n_plot(j))
          !if ((IntMat(iOrd,jOrd) > int_thrs*max_Intensity) .or. &
          !if ((IntMat(iOrd,jOrd) > 1.0e-3_wp*max_Intensity) .or. ((iOrd == 0 ) .and. (jOrd == 0))) then
          TermSort(1,nval) = int(abs(TermMat(iOrd,jOrd))*auTocm)
          TermSort(2,nval) = iOrd
          TermSort(3,nval) = jOrd
          nval = nval+1
          !end if
        end do
      end do
    end do
  end do
end if

nval = nval-1
do i=0,nval
  do j=i+1,nval
    if (TermSort(1,j) < TermSort(1,i)) then
      itemp(:) = TermSort(:,j)
      TermSort(:,j) = TermSort(:,i)
      TermSort(:,i) = itemp
    end if
  end do
end do

! MatEl,ForceField,m_plot_max,n_plot_max== F T 1 2/5

write(u6,*)
write(u6,'(90A)') ' ',('=',iv=1,89)
if (OscStr) then
  write(u6,'(A)') '  Ground                        Excited                         Energy         Oscillator'
  write(u6,'(A)') '  State                         State                      cm-1 /  eV / nm      Strength'
else
  write(u6,'(A)') '  Ground                        Excited                         Energy        Intensities'
  write(u6,'(A)') '  State                         State                      cm-1 /  eV / nm'
end if
write(u6,'(90A)') ' ',('-',iv=1,89)
const = One

do i=0,nval
  iOrd = TermSort(2,i)
  jOrd = TermSort(3,i)
  vee_cm = TermSort(1,i)
  vee_nm = 1.0e7_wp/vee_cm
  vee_eV = vee_cm*auToeV/auTocm
  vee = vee_eV
  if (Use_cm) vee = vee_cm
  if (Use_nm) vee = vee_nm
  ivee_cm = int(vee_cm+Half)
  ivee_nm = int(vee_nm+Half)
  Intensity = IntMat(iOrd,jOrd)/const
  if ((MatEl) .and. (.not. ForceField)) then
    if (m_plot_max < n_plot_max) then
      write(u6,'(a1,a15,a5,a1,f5.2,a1,f5.2,a1,f5.2,a1,a5,i7,a10,e12.3)') ' ',mMatChar(iOrd),'---> ','(',OccNumMat2(jOrd,1),',', &
                                                                         OccNumMat2(jOrd,2),',',OccNumMat2(jOrd,3),')',' ', &
                                                                         ivee_cm,' ',Intensity
      if (Intensity > 1.0e-6_wp) then
        call Add_Info('Energy',[vee_cm],1,5)
        call Add_Info('Intensity',[Intensity],1,5)
      end if
    else
      write(u6,'(a1,a15,a5,a1,f5.2,a1,f5.2,a1,f5.2,a1,a5,i7,a10,e12.3)') ' ',mMatChar(iOrd),'<--- ','(',OccNumMat2(jOrd,1),',', &
                                                                         OccNumMat2(jOrd,2),',',OccNumMat2(jOrd,3),')',' ', &
                                                                         ivee_cm,' ',Intensity
      if (Intensity > 1.0e-6_wp) then
        call Add_Info('Energy',[vee_cm],1,5)
        call Add_Info('Intensity',[Intensity],1,5)
      end if
    end if
  else
    if (m_plot_max < n_plot_max) then
      write(u6,'(a1,a23,a7,a23,a4,i6,a1,f5.2,a1,i4,a2,e12.3)') ' ',mMatChar(iOrd),' --->  ',nMatChar(jOrd),' ',ivee_cm,'/',vee_eV, &
                                                               '/',ivee_nm,'  ',Intensity
      if (Intensity > 1.0e-6_wp) then
        call Add_Info('Energy',[vee],1,5)
        call Add_Info('Intensity',[Intensity],1,5)
      end if
    else
      write(u6,'(a1,a23,a7,a23,a4,i6,a1,f5.2,a1,i4,a2,e12.3)') ' ',mMatChar(iOrd),' <---  ',nMatChar(jOrd),' ',ivee_cm,'/',vee_eV, &
                                                               '/',ivee_nm,'  ',Intensity
      if (Intensity > 1.0e-6_wp) then
        call Add_Info('Energy',[vee],1,5)
        call Add_Info('Intensity',[Intensity],1,5)
      end if
    end if
  end if
end do
write(u6,'(90A)') ' ',('=',iv=1,89)
write(u6,*)
write(u6,*)

call mma_deallocate(mMatChar)
call mma_deallocate(nMatChar)

!***********************************************************************

! Write to plot file.

conv = Zero
if ((.not. Use_nm) .and. (.not. Use_cm)) conv = 1.239842e-4_wp
if (Use_cm) conv = One
if (Use_nm) conv = 1.0e7_wp

! TermMin/Max must be in cm-1
if (plotwindow) then
  if (Use_nm) then                          ! nm -> cm-1
    TermMin = int(conv/cmend+0.999999_wp)   ! Note the inversion
    TermMax = int(conv/cmstart-0.999999_wp) ! cmstart <=> cmend
  else if (Use_cm) then                     ! already cm-1
    TermMin = int(cmstart)
    TermMax = int(cmend+0.999999_wp)
  else                                      ! eV -> cm-1
    TermMin = int(cmstart/conv+0.999999_wp)
    TermMax = int(cmend/conv-0.999999_wp)
  end if
else
  TermMin = int(TermSort(1,0))-nfreq
  TermMax = int(TermSort(1,nval))+nfreq
end if
call mma_allocate(plotvec,[TermMin,TermMax],label='plotvec')
plotvec(:) = Zero

plotUnit = isfreeunit(20)
call molcas_open(plotUnit,'plot.intensity')
!open(plotUnit,'plot.intensity')
if (broadplot) then
  FWHM = hbarcm/(Two*LifeTime)
  G2 = FWHM*Half
  do iTrans=0,nval
    iOrd = TermSort(2,iTrans)
    jOrd = TermSort(3,iTrans)
    ifreq = TermSort(1,iTrans)
    do ipoint=TermMin,TermMax
      plotVec(ipoint) = plotVec(ipoint)+IntMat(iOrd,jOrd)*(G2**2)/((G2**2)+(ipoint-ifreq)**2)
    end do
  end do
  do ipoint=TermMin,TermMax
    if (plotVec(ipoint) > Zero) then
      if (.not. Use_nm) then
        write(plotUnit,'(f12.6,e15.6)') ipoint*conv,plotVec(ipoint)
      else
        write(plotUnit,'(f12.6,e15.6)') conv/ipoint,plotVec(ipoint)
      end if
    end if
  end do
else
  do iTrans=0,nval
    iOrd = TermSort(2,iTrans)
    jOrd = TermSort(3,iTrans)
    ifreq = TermSort(1,iTrans)
    if ((TermMin <= ifreq) .and. (ifreq <= TermMax)) then
      plotVec(ifreq) = plotVec(ifreq)+IntMat(iOrd,jOrd)
    end if
  end do
  do ipoint=TermMin,TermMax
    if (plotVec(ipoint) > Zero) then
      if (.not. Use_nm) then
        write(plotUnit,'(f12.6,e15.6)') ipoint*conv,Zero
        write(plotUnit,'(f12.6,e15.6)') ipoint*conv,plotVec(ipoint)
        write(plotUnit,'(f12.6,e15.6)') ipoint*conv,Zero
      else
        write(plotUnit,'(f12.6,e15.6)') conv/ipoint,Zero
        write(plotUnit,'(f12.6,e15.6)') conv/ipoint,plotVec(ipoint)
        write(plotUnit,'(f12.6,e15.6)') conv/ipoint,Zero
      end if
    end if
  end do
end if
call mma_deallocate(plotvec)
close(plotUnit)

call mma_deallocate(TermSort)
call mma_deallocate(mMatStart)
call mma_deallocate(mMatStop)

end subroutine WriteInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MkEorb_Inner(FockAO,nFck,CMO,nCMO,Eorb,nEorb,nSym,nBas,nOrb)
!***********************************************************************
!                                                                      *
!  This routine calculates the diagonal elements of the MO Fock matrix *
!  (orbital energies).                                                 *
!                                                                      *
!  Input:                                                              *
!    FockAO  Fock matrix in AO basis                                   *
!    CMO     Orbitals                                                  *
!                                                                      *
!  Output:                                                             *
!    Eorb    Orbital energies.                                         *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nFck, nCMO, nEOrb, nSym, nBas(nSym), nOrb(nSym)
real(kind=wp), intent(in) :: FockAO(nFck), CMO(nCMO)
real(kind=wp), intent(out) :: EOrb(nEOrb)
integer(kind=iwp) :: iBas, indE, indF, indx, iOffCMO, iOffTri, iOrb, iSym, jBas, jndx, MaxSqr, MaxTri, npFckSqr
real(kind=wp) :: t
real(kind=wp), allocatable :: FckSqr(:)

!----------------------------------------------------------------------*
! Some preliminary setup.                                              *
!----------------------------------------------------------------------*
MaxTri = 0
MaxSqr = 0
do iSym=1,nSym
  MaxTri = max(MaxTri,nTri_Elem(nBas(iSym)))
  MaxSqr = max(MaxSqr,nBas(iSym)**2)
end do
!----------------------------------------------------------------------*
! Allocate matrices.                                                   *
!----------------------------------------------------------------------*
npFckSqr = MaxSqr
call mma_allocate(FckSqr,npFckSqr,Label='FckSqr')
!----------------------------------------------------------------------*
! Do compute orbital energies                                          *
!----------------------------------------------------------------------*
iOffTri = 0
iOffCMO = 0
indE = 1
do iSym=1,nSym
  if (nOrb(iSym) > 0) then
    call Square(FockAO(1+iOffTri),FckSqr,1,nBas(iSym),nBas(iSym))
    do iOrb=1,nOrb(iSym)
      t = Zero
      indF = 1
      do iBas=1,nBas(iSym)
        do jBas=1,nBas(iSym)
          indx = iBas+(iOrb-1)*nBas(iSym)+iOffCMO
          jndx = jBas+(iOrb-1)*nBas(iSym)+iOffCMO
          t = t+CMO(indx)*CMO(jndx)*FckSqr(indF)
          indF = indF+1
        end do
      end do
      EOrb(indE) = t
      indE = indE+1
    end do
  end if
  iOffTri = iOffTri+nTri_Elem(nBas(iSym))
  iOffCMO = iOffCMO+nBas(iSym)*nOrb(iSym)
end do
!----------------------------------------------------------------------*
! Debug print                                                          *
!----------------------------------------------------------------------*
#ifdef _DEBUGPRINT_
indE = 1
do iSym=1,nSym
  if (nOrb(iSym) > 0) call RecPrt('mkeor: Orbital energies','(20F10.4)',Eorb(indE),1,nOrb(iSym))
  indE = indE+nOrb(iSym)
end do
#endif
!----------------------------------------------------------------------*
! Deallocate matrices.                                                 *
!----------------------------------------------------------------------*
call mma_deallocate(FckSqr)
!----------------------------------------------------------------------*
! Done.                                                                *
!----------------------------------------------------------------------*
return

end subroutine MkEorb_Inner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PolSolv(DT,FI,FP,xx,yy,zz,rr3,xxi,yyi,zzi,Gri,FFp,iCNum,r2inv,difac,nSize)

use qmstat_global, only: Cordst, DipIm, nCent, nPart, nPol, Sqrs, Qimp
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iCNum, nSize
real(kind=wp), intent(in) :: DT(3,nPol*nPart), FP(3,nPol*nPart), xx(nSize,nSize), yy(nSize,nSize), zz(nSize,nSize), &
                             rr3(nSize,nSize), xxi(nSize,nSize), yyi(nSize,nSize), zzi(nSize,nSize), Gri(nSize,nSize), r2inv, difac
real(kind=wp), intent(out) :: FI(3,nPol*nPart), FFp(nSize,3)
integer(kind=iwp) :: i, idel1, idel2, IndCor, Inddt, j
real(kind=wp) :: Agr, Skal, Ta, Tal

! The fields between the solvent molecules are computed as well as
! the image charge contribution. Rather basic formulas, but keeping
! track on indices may be difficult.

do j=1,nPol
  IndCor = j+(iCnum-1)*nCent
  Inddt = j+(iCnum-1)*nPol
  do i=iCnum+1,nPart
    IndCor = IndCor+nCent
    Inddt = Inddt+nPol
    Agr = Sqrs(IndCor) !Sqrs come from geogen.
    Skal = DT(1,Inddt)*Cordst(1,IndCor)+DT(2,Inddt)*Cordst(2,IndCor)+DT(3,Inddt)*Cordst(3,IndCor)
    Ta = Skal*Agr**2*R2inv
    Tal = -Difac*Ta
    Qimp(Inddt) = tal*agr
    ! Image dipoles: Reflect dipole vector in radial vector. This is vector geometry at its best.
    DipIm(:,IndDt) = (Tal*Cordst(:,IndCor)*2+DiFac*DT(:,IndDt))*Agr**3
  end do
end do
FI(:,nPol*iCnum+1:nSize) = Zero

! Here the actual fields are computed, both from the explicit solvent and from its image.

do i=1+(nPol*iCNum),nPart*nPol !The real part.
  do j=1+(nPol*iCnum),nPart*nPol
    idel1 = (i-1)/nPol
    idel2 = (j-1)/nPol
    if (idel1 == idel2) cycle
    Skal = xx(i,j)*DT(1,i)+yy(i,j)*DT(2,i)+zz(i,j)*DT(3,i)
    Skal = Skal*3
    FI(1,j) = FI(1,j)-(DT(1,i)-Skal*xx(i,j))*rr3(i,j)
    FI(2,j) = FI(2,j)-(DT(2,i)-Skal*yy(i,j))*rr3(i,j)
    FI(3,j) = FI(3,j)-(DT(3,i)-Skal*zz(i,j))*rr3(i,j)
  end do
end do
do i=1+(nPol*iCnum),nPart*nPol !The image part.
  do j=1+(nPol*iCnum),nPart*nPol
    Skal = (xxi(i,j)*DipIm(1,i)+yyi(i,j)*DipIm(2,i)+zzi(i,j)*DipIm(3,i))
    Skal = Skal*3
    FI(1,j) = FI(1,j)-(DipIm(1,i)-Skal*xxi(i,j))*Gri(i,j)**3-Qimp(i)*xxi(i,j)*Gri(i,j)**2
    FI(2,j) = FI(2,j)-(DipIm(2,i)-Skal*yyi(i,j))*Gri(i,j)**3-Qimp(i)*yyi(i,j)*Gri(i,j)**2
    FI(3,j) = FI(3,j)-(DipIm(3,i)-Skal*zzi(i,j))*Gri(i,j)**3-Qimp(i)*zzi(i,j)*Gri(i,j)**2
  end do
end do

! Add up the things, and add also the part from the permanent charges.

do i=1+(nPol*iCnum),nSize
  FFp(i,:) = Fi(:,i)+FP(:,i)
end do

! The circle is now complete. I left you when I was about to learn and I meet you as the master.

return

end subroutine PolSolv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SOCtl_Seward(Mamn,nMamn)
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: iChTbl, iOper, iChBas, lIrrep, lBsFnc,
     &                         iSkip, nIrrep
      use SOAO_Info, only: SOAO_Info_Init, nSOInf, iSOInf, iAOtSO,
     &                     iOffSO
      use real_spherical, only: iSphCr, LblCBs, LblSBs
      use Temporary_Parameters, only: Primitive_Pass
      use Sizes_of_Seward, only: S
      Implicit Real*8 (a-h,o-z)
*
#include "itmax.fh"
#include "Molcas.fh"
#include "rinfo.fh"
#include "real.fh"
#include "print.fh"
#include "stdalloc.fh"
*
      Logical lFAIEMP
      Character ChOper(0:7)*3,ChTemp*8,Mamn(nMamn)*(LENIN8)
      Character LP_Names(MxAtom)*(LENIN4)
      Character*60 Fmt
      Logical Type(0:7), lSkip, kECP, TstFnc, output, Get_BasisType
      Logical IsBasisAE
      Logical IsBasisANO
      Logical IsBasisUNK
      Integer Occ, Vir
      Parameter(Occ=1,Vir=0)
      Integer List(0:iTabMx), nFCore(0:7), nCore_Sh(0:iTabMx),
     &        List_AE(0:iTabMx)
      Integer jOffSO(0:7)
      Integer, Dimension(:), Allocatable :: Index, Index2, IndC, iCI,
     &                                      jCI, iOT, LPA, LPMM
      Real*8, Dimension(:), Allocatable :: LPQ
      Real*8, Dimension(:,:), Allocatable :: SM, LPC
      Character*(LENIN8) Clean_BName,ChTmp
      External Clean_BName

CSVC: the basis ids are tuples (c,n,l,m) with c the center index,
C     n the shell index, l the angmom value, and m the angmom component.
C     the angmom components of p are mapped (x,y,z) -> (1,-1,0)
C     examples: 3d1+ on atom 1: (1,3,2,1); 2py on atom 5: (5,2,1,-1)
CIFG: for Cartesian shells, l -> -l, m -> T(ly+lz)-(lx+ly), where T(n)=n*(n+1)/2
      integer :: llab,mlab
      integer, allocatable :: basis_ids(:,:), desym_basis_ids(:,:)
      integer, allocatable :: fermion_type(:)
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*     LVAL end MVAL dimensioned for L = iTabMx
      dimension LVAL((iTabMx+1)*(iTabMx+1))
      dimension MVAL((iTabMx+1)*(iTabMx+1))
*                                                                      *
************************************************************************
*                                                                      *
      IsBasisAE=.false.
      IsBasisANO=.false.
      IsBasisUNK=.false.
      iRout=2
      iPrint = nPrint(iRout)
cvv LP_NAMES was used later without initialization.
      do i=1,MxAtom
       LP_NAMES(i)(1:LENIN)='crap'
       LP_NAMES(i)(LENIN1:LENIN4)='crap'
      enddo
      lFAIEMP = .False.
      Do i = 1, nCnttp
         lFAIEMP = lFAIEMP .or. dbsc(i)%Frag
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Compute iBas, iBas_Aux, and iBas_Frag used for double checking
*     in SOCtl.
*     Compute cdMax, EtMax, and S%nShlls.
*
      Call Misc_Seward(iBas,iBas_Aux,iBas_Frag)
      Call SOAO_Info_Init(iBas+iBas_Frag+iBas_Aux,nIrrep)
*                                                                      *
************************************************************************
*                                                                      *
*     initialize LVAL and MVAL
*     (note: this is wrong for Cartesian shells)
*
      k=0
      do i=0,iTabMx
         do j=-i,i
            k=k+1
            lval(k)=i
            mval(k)=j
         enddo
      enddo
C     write(6,*) ' lval',k,(iTabMx+1)**2
*     correct mval order for p-functions
      mval(2)=1
      mval(3)=-1
      mval(4)=0
      Call ICopy(MxAO,[-99],0,iCent,1)
      Call ICopy(MxAO,[-99],0,lnAng,1)
C     write(6,'(20i4)') (lval(i),i=1,k)
C     write(6,*) ' lval',k
C     write(6,'(20i4)') (mval(i),i=1,k)
*
      Call ICopy(1+iTabMx,[0],0,List   ,1)
      Call ICopy(1+iTabMx,[0],0,List_AE,1)
*
      isymunit=isfreeunit(58)
      call molcas_open(isymunit,'SYMINFO')
      rewind isymunit
      write(isymunit,'(A)') 'Symmetry information from seward'
      write(isymunit,'(A)')
     &'#of funct, unique centre, L, M , # of sym.ad.functions , Phases'
*                                                                      *
************************************************************************
*                                                                      *
*     Generate list of symmetry adapted or petite list basis functions
*                                                                      *
************************************************************************
*                                                                      *
      iSO = 0
      iSO_Aux=iBas+iBas_Frag
      iSO_Frag=iBas
      iSO_Tot=0
      S%n2Tot = 0
      S%nDim = 0
      iAO=0
      lSkip=.False.
*
      Call ICopy(8,[0],0,nFCore,1)

      Call mma_Allocate(iCI,iBas,label='iCI')       ! Stuff for LoProp
      Call mma_Allocate(jCI,iBas,label='jCI')
!     Stuff for LocalDKH/X2C/BSS
      Call mma_Allocate(iOT,iBas,label='iOT')       ! Stuff for LoProp
      Call mma_Allocate(LPC,3,S%mCentr,label='LPC')
!     Stuff (not just) for LoProp
      Call mma_Allocate(LPQ,S%mCentr,label='LPQ')
!     Stuff (not just) for LoProp
      Call mma_Allocate(LPMM,S%mCentr,label='LPMM')
!     Stuff (not just) for LoProp
      Call mma_Allocate(LPA,S%mCentr,label='LPA')
      call mma_allocate(basis_ids,4,maxbfn+maxbfn_aux)
      call mma_allocate(desym_basis_ids,4,maxbfn+maxbfn_aux)
      call mma_allocate(fermion_type,maxbfn+maxbfn_aux)
*
      IsBasisAE  = Get_BasisType('AE_')
      IsBasisANO = Get_BasisType('ANO')
      IsBasisUNK = Get_BasisType('UNK')
      If (Show.and.iPrint.ge.6) then
         Write (6,*)
         Call CollapseOutput(1,'   SO/AO info:')
         Write (6,'(3X,A)')    '   -----------'
      End If
      If (nIrrep.eq.1) Go To 199
*                                                                      *
************************************************************************
*                                                                      *
*---- Symmetry case.
*
      If (Show.and.iPrint.ge.6) then
         Write (6,*)
         Write (6,'(19x,a)')
     &            ' **************************************************'
         Write (6,'(19x,a)')
     &            ' ******** Symmetry adapted Basis Functions ********'
         Write (6,'(19x,a)')
     &            ' **************************************************'
         Write (6,*)
      End If
*
      Call mma_allocate(Index,5*iBas,label='Index')
      Call mma_allocate(Index2,5*iBas,label='Index2')
      Call ICopy(5*iBas,[0],0,Index,1)
      Call ICopy(5*iBas,[0],0,Index2,1)
      iCounter=0
      jCounter=0
      Call mma_Allocate(SM,iBas,iBas,label='SM')
      Call FZero(SM,iBas**2)
      Call mma_Allocate(IndC,2*S%mCentr)
      iAtoms=0
*
*     Loop over irreducible representations and symmetry operations,
*     respectively, for SO and Petite list, respectively.
*
      Do iIrrep = 0, 7
        jOffSO(iIrrep) = 0
      End Do
      kIrrep=0
      Do 200 iIrrep = 0, nIrrep-1
         iOffSO(iIrrep) = iSO_Tot
         jOffSO(iIrrep) = iSO
         iAO = 0
         jSO = 0
         nBas(iIrrep) = 0
         nBas_Aux(iIrrep) = 0
         nBas_Frag(iIrrep) = 0
         Type(iIrrep)=.True.
*
*        Loop over distinct shell types
*
         mc  = 1
         iShell = 0
         If (iSkip(iIrrep).ne.0) Then
            Write (6,*)
            Write (6,*) ' All basis functions of Irrep', iIrrep+1,
     &                  ' are removed!'
            Write (6,*)
            lSkip=.True.
            Go To 2011
         End If
         iCnttp = 0
         Do 201 jCnttp = 1, nCnttp
*
*           Make sure that we process the dummy shell last
*
            If (jCnttp.eq.iCnttp_Dummy .and. jCnttp.ne.nCnttp) Then
               iCnttp = iCnttp + 2
            Else If (jCnttp.eq.nCnttp .and. iCnttp.eq.jCnttp) Then
               iCnttp = iCnttp_Dummy
            Else
               iCnttp = iCnttp + 1
            End If
*
            output = show .and. iPrint.ge.6
            If (dbsc(iCnttp)%Aux) output=output .and. iPrint.ge.10
     &                            .and. iCnttp.ne.iCnttp_Dummy
            If (dbsc(iCnttp)%Frag) output=output .and. iPrint.ge.10
            kECP = dbsc(iCnttp)%ECP
            lMax=dbsc(iCnttp)%nVal-1
*
            Call OrbType(dbsc(iCnttp)%AtmNr,List_AE,31)
            If (kECP) Then
*
*              ECP case
*
               Call ECP_Shells(dbsc(iCnttp)%AtmNr,list)
*
*              No core to freeze!
*
               Call ICopy(lMax+1,[0],0,nCore_Sh,1)
            Else
*
*              Non-ECP case
*
*              Pick up the number of occupied orbitals in each shell type.
*
               Call ICopy(1+iTabMx,List_AE,1,List,1)
*
*              Pick up which orbitals should be frozen as default.
*
               If (dbsc(iCnttp)%Charge.ne.Zero) Then
                  Call Freeze_Default(dbsc(iCnttp)%AtmNr,nCore_Sh,lMax)
               Else
*
*                 If there charge is zero we presume that these are
*                 ghost orbitals or something else. In any case
*                 we do not freeze any orbitals!
*
                  Call Freeze_Default(0             ,nCore_Sh,lMax)
               End If
            End If
*
*           Loop over distinct centers
*
            Do 202 iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = iCnt + dbsc(iCnttp)%mdci
*
*              Loop over shells associated with this center
*              Start with s type shells
*
               kComp = 0
               kculf = 0
               iSh = dbsc(iCnttp)%iVal - 1
               If (dbsc(iCnttp)%nVal.lt.1) Then
                  Do iCo = 0, nIrrep/dc(mdc)%nStab-1
                     iyy=Index_Center(mdc,iCo,IndC,iAtoms,S%mCentr)
                     iR=NrOpr(dc(mdc)%iCoSet(iCo,0))

                     LPC(1:3,iyy)=dbsc(iCnttp)%Coor(1:3,iCnt)
                     If (iAnd(iOper(iR),1).ne.0) LPC(1,iyy)=-LPC(1,iyy)
                     If (iAnd(iOper(iR),2).ne.0) LPC(2,iyy)=-LPC(2,iyy)
                     If (iAnd(iOper(iR),4).ne.0) LPC(3,iyy)=-LPC(3,iyy)
                     LPQ(iyy)=dbsc(iCnttp)%Charge
                     LPA(iyy)=dbsc(iCnttp)%AtmNr
                     LPMM(iyy)=dbsc(iCnttp)%IsMM
                     LP_Names(iyy)=dc(mdc)%LblCnt(1:LENIN)//':'
     &                       //ChOper(iOper(iR))
                  End Do
               End If
               Do 203 iAng = 0, dbsc(iCnttp)%nVal-1
                  nCore=nCore_Sh(iAng)
                  iSh = iSh + 1
                  iShell = iShell + 1
                  nExpi=Shells(iSh)%nExp
                  nBasisi=Shells(iSh)%nBasis
                  If (Shells(iSh)%Prjct ) Then
                     jComp = 2*iAng + 1
                  Else
                     jComp = (iAng+1)*(iAng+2)/2
                  End If
                  If (nExpi.eq.0) Go To 2033
                  If (nBasisi.eq.0) Go To 2033

                  Do 204 iComp = 1, jComp
                     iAO = iAO + 1
                     If (iAO.gt.MxAO) Then
                        Call ErrTra
                        Write (6,*) ' Increase MxAO'
                        Call Abend
                     End If
                     lComp = kComp + iComp
                     lculf = kculf + icomp
*                    Get character of basis function
                     iChBs = iChBas(lComp)
                     If (Shells(iSh)%Transf) iChBs=iChBas(iSphCr(lComp))
*
*                    Skip if function not a basis of irreps.
*
                     If (.Not.TstFnc(dc(mdc)%iCoSet,
     &                          iIrrep,iChBs,dc(mdc)%nStab)) Go To 204
                     If(.not.Shells(iSh)%Frag .and.
     &                  .not.dbsc(iCnttp)%Aux)
     &                 nFCore(iIrrep)=nFCore(iIrrep)+nCore
                     If (output.and.Type(iIrrep)) Then
                        Write (6,*)
                        Write (6,'(10X,A,A)')
     &                    ' Irreducible representation : ',
     &                      lIrrep(iIrrep)
                        Write (6,'(10X,2A)')
     &                      ' Basis function(s) of irrep: ',
     &                       lBsFnc(iIrrep)
                        Write (6,*)
                        Write (6,'(A)')
     &                  ' Basis Label        Type   Center Phase'
                        Type(iIrrep)=.False.
                     End If
*
                     If (S%MaxBas(iAng).gt.0) iAOtSO(iAO,iIrrep) = jSO+1
                     S%m2Max = Max(S%m2Max,nExpi**2)
                     Do 205 iCntrc = 1, nBasisi
                        iSO_Tot = iSO_Tot + 1
                        If (Shells(iSh)%Aux) Then
                           iSO_Aux = iSO_Aux + 1
                           iSO_=iSO_Aux
                           nBas_Aux(iIrrep) = nBas_Aux(iIrrep) + 1
                        Else If (Shells(iSh)%Frag) Then
                           iSO_Frag = iSO_Frag + 1
                           iSO_=iSO_Frag
                           nBas_Frag(iIrrep) = nBas_Frag(iIrrep) + 1
                        Else
                           iSO = iSO + 1
                           iSO_=iSO
                           nBas(iIrrep) = nBas(iIrrep) + 1
                        End If
                        If (iSO_.gt.nMamn) Then
                           Write (6,*) ' iSO_.gt.nMamn'
                           Write (6,*) 'nMamn=',nMamn
                           Call Abend
                        End If
                        jSO = jSO + 1
*
                        ChTemp=LblCBs(lComp)
                        If (Shells(iSh)%Transf) ChTemp=LblSbs(lComp)
*
                        Call Name_to_lm(ChTemp,llab,mlab)
*
*                       Introduce a somewhat better labelling. Thnx LG!
*
                        If (IsBasisAE) Then
                           If (IsBasisANO) Then
                              Write (ChTemp(1:2),'(I2.2)') iAng+iCntrc
                           Else
                              If (nExpi.eq.nBasisi) Then
                                 Write (ChTemp(1:1),'(A1)') '*'
                                 If (llab.ge.0)
     &                              Write(ChTemp(2:2),'(A1)') '0'
                              Else If (iCntrc.le.list(iAng)) Then
                                 Write (ChTemp(1:2),'(I2.2)')
     &                                 iAng+iCntrc
                              Else
                                 Write (ChTemp(1:1),'(A1)') '*'
                                 If (llab.ge.0)
     &                              Write(ChTemp(2:2),'(A1)') '0'
                              End If
                           End If
                        Else If (.Not.IsBasisUNK) Then
                           If (nExpi.eq.nBasisi) Then
                              Write (ChTemp(1:1),'(A1)') '*'
                              If (llab.ge.0)
     &                           Write(ChTemp(2:2),'(A1)') '0'
                           Else If (iCntrc.le.list(iAng)) Then
                                 Write (ChTemp(1:2),'(I2.2)')
     &                                 iAng+iCntrc+
     &                                 (List_AE(iAng)-List(iAng))
                           Else
                              Write (ChTemp(1:1),'(A1)') '*'
                              If (llab.ge.0)
     &                           Write(ChTemp(2:2),'(A1)') '0'
                           End If
*
                        End If
                        ChTmp=Clean_BName(ChTemp,0)
*
                        If(output)
     &                  Write (6,'(I5,3X,A8,4X,A8,8(I3,4X,I2,4X))')
     &                        iSO_,dc(mdc)%LblCnt,ChTmp,
     &                        (mc+iCo,iPrmt(
     &                        NrOpr(dc(mdc)%iCoSet(iCo,0)),iChbs)*
     &                        iChTbl(iIrrep,
     &                        NrOpr(dc(mdc)%iCoSet(iCo,0))),
     &                        iCo=0,nIrrep/dc(mdc)%nStab-1 )
*
                        If (iSO_.gt.nSOInf) Then
                           Write (6,*) 'iSO_.gt.nSOInf'
                           Call Abend()
                        End If
                        iSOInf(1,iSO_)=iCnttp
                        iSOInf(2,iSO_)=iCnt
                        iSOInf(3,iSO_)=iAng
*
                        If (Shells(iSh)%Aux.or.
     &                      Shells(iSh)%Frag) Go To 205
*
                        If (.Not.Primitive_Pass) Then
                           Write (isymunit,'(13(I4,4X))')
     &                        iSO_,mdc,LVAL(lculf),MVAL(lculf),
     &                        nIrrep/dc(mdc)%nStab,
     &                        (iPrmt(
     &                        NrOpr(dc(mdc)%iCoSet(iCo,0)),iChbs)*
     &                        iChTbl(iIrrep,
     &                        NrOpr(dc(mdc)%iCoSet(iCo,0))),
     &                        iCo=0,nIrrep/dc(mdc)%nStab-1 )
                        End If
*                                                                      *
************************************************************************
*                                                                      *
*---------------------------- Stuff (not just) for LoProp
*
                         Do iCo = 0, nIrrep/dc(mdc)%nStab-1
                            ixxx = Index_NoSym(iCntrc,iComp,iAng,
     &                        mdc,iCo,Index,iCounter,iBas)
                            jxxx = Index_NoSym(iCntrc,iComp,iAng,
     &                        mdc,iirrep,Index2,jCounter,iBas)
                            fact =DBLE(iPrmt(NrOpr(
     &                                 dc(mdc)%iCoSet(iCo,0)),iChbs)*
     &                        iChTbl(iIrrep,NrOpr(
     &                                  dc(mdc)%iCoSet(iCo,0))))
*
                            FacN = One/DBLE(nIrrep/dc(mdc)%nStab)
                            If (MolWgh.eq.1) Then
                               FacN= One
                            Else If (MolWgh.eq.2) Then
                               FacN= Sqrt(FacN)
                            End If
                            SM(ixxx,iSO)=Fact*FacN
                            iyy=Index_Center(mdc,iCo,IndC,iAtoms,
     &                                       S%mCentr)
*
                            iCI(ixxx)=iyy
                            jCI(jxxx)=icnt
*
                            If (iCntrc.le.list(iAng)) Then
                               iOT(ixxx)=Occ
                            Else
                               iOT(ixxx)=Vir
                            End If
*
                            iR=NrOpr(dc(mdc)%iCoSet(iCo,0))
                            LPC(1:3,iyy)=dbsc(iCnttp)%Coor(1:3,iCnt)
                            If (iAnd(iOper(iR),1).ne.0)
     &                          LPC(1,iyy)=-LPC(1,iyy)
                            If (iAnd(iOper(iR),2).ne.0)
     &                          LPC(2,iyy)=-LPC(2,iyy)
                            If (iAnd(iOper(iR),4).ne.0)
     &                          LPC(3,iyy)=-LPC(3,iyy)
*
                            LPQ(iyy) =dbsc(iCnttp)%Charge
                            LPMM(iyy)=dbsc(iCnttp)%IsMM
                            LPA(iyy) =dbsc(iCnttp)%AtmNr
*
                            LP_Names(iyy)=dc(mdc)%LblCnt(1:LENIN)//':'
     &                                    //ChOper(iOper(iR))
                            desym_basis_ids(1,ixxx) = iyy
                            desym_basis_ids(2,ixxx) = iCntrc
                            desym_basis_ids(3,ixxx) = llab
                            desym_basis_ids(4,ixxx) = mlab
                        End Do
*                                                                      *
************************************************************************
*                                                                      *
                        Mamn(iSO)=dc(mdc)%LblCnt(1:LENIN)//ChTemp(1:8)
                        basis_ids(1,iSO) = mdc
                        basis_ids(2,iSO) = iCntrc
                        basis_ids(3,iSO) = llab
                        basis_ids(4,iSO) = mlab
                        fermion_type(iSO)=0
                        If (dbsc(iCnttp)%fMass.ne.1.0D0)
     &                     fermion_type(iSO)=1
                        if (.Not.Primitive_Pass) then
                           kIrrep=kIrrep+1
                           icent(kIrrep)=mdc
                           lnang(kIrrep)=lval(lculf)
                           lmag(kIrrep)=mval(lculf)
                           lant(kIrrep)=nIrrep/dc(mdc)%nStab
                        Endif
 205                 Continue
*
 204              Continue
 2033             kComp = kComp + (iAng+1)*(iAng+2)/2
                  kculf=kculf+ 2*iAng+1
 203           Continue ! iAng
               mc = mc + nIrrep/dc(mdc)%nStab
 202        Continue ! iCnt
*
 201     Continue ! jCnttp
 2011    Continue
culf
         nrSym=nIrrep
         nrBas(iIrrep+1)=nBas(iIrrep)
*        write(6,*) ' nBas(iIrrep)', iIrrep, nBas(iIrrep)
         S%nDim = S%nDim + nBas(iIrrep)
         S%n2Tot = S%n2Tot + nBas(iIrrep)**2
 200  Continue ! iIrrep
*     If (lSkip) S%nDim = iBas
      If (iBas.ne.iSO .and.
     &    iBas_Aux.ne.iSO_Aux-iSO .and.
     &    .Not.lSkip) Then
         Write (6,*) 'iBas=',iBas
         Write (6,*) 'iBas_Aux=',iBas_Aux
         Write (6,*) 'iSO=',iSO
         Write (6,*) 'iSO_Aux=',iSO_Aux-iSO
         Write (6,*) 'iSO_Tot=',iSO_Tot
         Call ErrTra
         Call Abend
      End If
C redefine iOffSO array in case of Fragment AIEMP
      If (lFAIEMP) Then
        Do iIrrep = 0, nIrrep-1
          iOffSO(iIrrep) = jOffSO(iIrrep)
        End Do
      End IF
#ifdef _DEBUGPRINT_
      Call RecPrt('Symmetrization Matrix','(20F5.2)',SM,iBas,iBas)
#endif
      Call Put_dArray('SM',SM,iBas**2)
*
CSVC: basis IDs of both symmetric and non-symmetric case
      if (.not.Primitive_Pass) then
        Call Put_iArray('Fermion IDs',fermion_type,iSO)
        Call Put_iArray('Basis IDs',basis_ids,4*iSO)
        Call Put_iArray('Desym Basis IDs',desym_basis_ids,4*iBas)
      end if
*
      Call mma_deallocate(IndC)
      Call mma_deallocate(SM)
      Call mma_deallocate(Index)
      Call mma_deallocate(Index2)
      Go To 198
*                                                                      *
************************************************************************
*                                                                      *
*---- No symmetry case.
*
199   Continue
      If (Show.and.iPrint.ge.6) Then
         Write (6,*)
         Write (6,'(19x,a)')
     &            ' **************************************************'
         Write (6,'(19x,a)')
     &            ' ********** Petite list Basis Functions ***********'
         Write (6,'(19x,a)')
     &            ' **************************************************'
         Write (6,*)
      End If
*
      kIrrep=0
      Do 300 iIrrep = 0, nIrrep-1
         iOffSO(iIrrep) = iSO_Tot
         iAO = 0
         jSO = 0
         nBas(iIrrep) = 0
         nBas_Aux(iIrrep) = 0
         nBas_Frag(iIrrep) = 0
         Type(iIrrep)=.True.
*
*        Loop over distinct shell types
*
         mc  = 1
         iShell = 0
         iCnttp = 0
         Do 301 jCnttp = 1, nCnttp
*
*           Make sure that we process the dummy shell last
*
            If (jCnttp.eq.iCnttp_Dummy .and. jCnttp.ne.nCnttp) Then
               iCnttp = iCnttp + 2
            Else If (jCnttp.eq.nCnttp .and. iCnttp.eq.jCnttp) Then
               iCnttp = iCnttp_Dummy
            Else
               iCnttp = iCnttp + 1
            End If
*
            output = show .and. iPrint.ge.6
            If (dbsc(iCnttp)%Aux.or.dbsc(iCnttp)%Frag)
     &        output = output.and.iPrint.ge.10
     &                       .and.iCnttp.ne.iCnttp_Dummy
            kECP = dbsc(iCnttp)%ECP
            lMax=dbsc(iCnttp)%nVal-1
            Call OrbType(dbsc(iCnttp)%AtmNr,List_AE,31)
            If (kECP) Then
               Call ECP_Shells(dbsc(iCnttp)%AtmNr,list)
               Call ICopy(lmax+1,[0],0,nCore_Sh,1)
            Else
               Call ICopy(1+iTabMx,List_AE,1,List,1)
               If (dbsc(iCnttp)%Charge.ne.Zero) Then
                  Call Freeze_Default(dbsc(iCnttp)%AtmNr,nCore_Sh,lMax)
               Else
                  Call Freeze_Default(0                 ,nCore_Sh,lMax)
               End If
            End If
*
*           Loop over distinct centers
*
            Do 302 iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = iCnt + dbsc(iCnttp)%mdci
*
*              Loop over shells associated with this center
*              Start with s type shells
*
               kComp = 0
               kculf = 0
               iSh = dbsc(iCnttp)%iVal - 1
               If (dbsc(iCnttp)%nVal.lt.1) Then
                  LPC(1:3,mdc)=dbsc(iCnttp)%Coor(1:3,iCnt)
                  LPQ(mdc) =dbsc(iCnttp)%Charge
                  LPMM(mdc)=dbsc(iCnttp)%IsMM
                  LPA(mdc) =dbsc(iCnttp)%AtmNr
                  LP_Names(mdc)=dc(mdc)%LblCnt(1:LENIN)//'    '
               End If
               Do 303 iAng = 0, dbsc(iCnttp)%nVal-1
                  nCore=nCore_Sh(iAng)
                  iSh = iSh + 1
                  iShell = iShell + 1
                  nExpi=Shells(iSh)%nExp
                  nBasisi=Shells(iSh)%nBasis
                  If (Shells(iSh)%Prjct ) Then
                     jComp = 2*iAng + 1
                  Else
                     jComp = (iAng+1)*(iAng+2)/2
                  End If
                  If (nExpi.eq.0) Go To 3033
                  If (nBasisi.eq.0) Go To 3033
                  Do 304 iComp = 1, jComp
                     iAO = iAO + 1
                     If (iAO.gt.MxAO) Then
                        Call ErrTra
                        Write (6,*) ' Increase MxAO'
                        Call Abend
                     End If
                     lComp = kComp + iComp
                     lculf = kculf + iComp
*
*                    Skip if symmetry operator is not in the coset of
*                    this center.
*
                     Do 308 imc = 0, (nIrrep/dc(mdc)%nStab)-1
                        If (dc(mdc)%iCoSet(imc,0).eq.iOper(iIrrep))
     &                     Go To 307
 308                 Continue
                     Go To 304
 307                 Continue
                     If (output.and.Type(iIrrep)) Then
                        Write (6,*)
                        Write (6,'(10X,2A)')
     &                      ' Basis functions generated by ',
     &                       ChOper(iIrrep)
                        Write (6,*)
                        Write (6,'(A)')
     &                  ' Basis Label        Type   Center'
                        Type(iIrrep)=.False.
                     End If
*
                     If (S%MaxBas(iAng).gt.0) iAOtSO(iAO,iIrrep) = jSO+1
                     S%m2Max = Max(S%m2Max,nExpi**2)
                     If(.not.Shells(iSh)%Frag .and.
     &                  .not.dbsc(iCnttp)%Aux)
     &                 nFCore(0)=nFCore(0)+nCore
*
*                    Loop over contracted basis functions
*
                     Do 305 iCntrc = 1, nBasisi
                        iSO_Tot = iSO_Tot + 1
                        If (Shells(iSh)%Aux) Then
                           iSO_Aux = iSO_Aux + 1
                           iSO_=iSO_Aux
                           nBas_Aux(iIrrep) = nBas_Aux(iIrrep) + 1
                        Else If (Shells(iSh)%Frag) Then
                           iSO_Frag = iSO_Frag + 1
                           iSO_=iSO_Frag
                           nBas_Frag(iIrrep) = nBas_Frag(iIrrep) + 1
                        Else
                           iSO = iSO + 1
                           iSO_=iSO
                           nBas(iIrrep) = nBas(iIrrep) + 1
                        End If
                        If (iSO_.gt.nMamn) Then
                           Write (6,*) ' iSO_.gt.nMamn'
                           Write (6,*) 'nMamn=',nMamn
                           Call Abend
                        End If
                        jSO = jSO + 1
*
                        ChTemp=LblCBs(lComp)
                        If (Shells(iSh)%Transf) ChTemp=LblSbs(lComp)
*
                        Call Name_to_lm(ChTemp,llab,mlab)
*
*                       Introduce a somewhat better labelling. Thnx LG!
*
                        If (IsBasisAE) Then
                           If (IsBasisANO) Then
                              Write (ChTemp(1:2),'(I2.2)') iAng+iCntrc
                           Else
                              If (nExpi.eq.nBasisi) Then
                                 Write (ChTemp(1:1),'(A1)') '*'
                                 If (llab.ge.0)
     &                              Write(ChTemp(2:2),'(A1)') '0'
                              Else If (iCntrc.le.list(iAng)) Then
                                 Write (ChTemp(1:2),'(I2.2)')
     &                                 iAng+iCntrc
                              Else
                                 Write (ChTemp(1:1),'(A1)') '*'
                                 If (llab.ge.0)
     &                              Write(ChTemp(2:2),'(A1)') '0'
                              End If
                           End If
                        Else If (.Not.IsBasisUNK) Then
                           If (nExpi.eq.nBasisi) Then
                              Write (ChTemp(1:1),'(A1)') '*'
                              If (llab.ge.0)
     &                           Write(ChTemp(2:2),'(A1)') '0'
                           Else If (iCntrc.le.list(iAng)) Then
                                 Write (ChTemp(1:2),'(I2.2)')
     &                                 iAng+iCntrc+
     &                                 (List_AE(iAng)-List(iAng))
                           Else
                              Write (ChTemp(1:1),'(A1)') '*'
                              If (llab.ge.0)
     &                           Write(ChTemp(2:2),'(A1)') '0'
                           End If
                        End If
                        ChTmp=Clean_BName(ChTemp,0)
*
                        if(output) Write (6,'(I5,2X,A8,5X,A8,I3)')
     &                        iSO_,dc(mdc)%LblCnt,ChTmp,mc+imc
*
                        If (iSO_.gt.nSOInf) Then
                           Write (6,*) 'iSO_.gt.nSOInf'
                           Call Abend()
                        End If
                        iSOInf(1,iSO_)=iCnttp
                        iSOInf(2,iSO_)=iCnt
                        iSOInf(3,iSO_)=iAng
*
                        If (Shells(iSh)%Aux.or.
     &                      Shells(iSh)%Frag) Go To 305
                        Write (isymunit,'(13(I4,4X))')
     &                     iSO,mdc,LVAL(lculf),MVAL(lculf),
     &                     nIrrep/dc(mdc)%nStab,
     &                     (iPrmt(NrOpr(dc(mdc)%iCoSet(iCo,0)),iChbs)*
     &                     iChTbl(iIrrep,NrOpr(dc(mdc)%iCoSet(iCo,0))),
     &                     iCo=0,nIrrep/dc(mdc)%nStab-1 )
*                                                                      *
************************************************************************
*                                                                      *
*---------------------------- Stuff (not just) for LoProp
*
                        iCI(iSO)=mdc
                        jCI(iSO)=mdc
                        If (iCntrc.le.list(iAng)) Then
                           iOT(iSO)=Occ
                        Else
                           iOT(iSO)=Vir
                        End If
                        LPC(1:3,mdc)=dbsc(iCnttp)%Coor(1:3,iCnt)
                        LPQ(mdc) =dbsc(iCnttp)%Charge
                        LPMM(mdc)=dbsc(iCnttp)%IsMM
                        LPA(mdc) =dbsc(iCnttp)%AtmNr
                        LP_Names(mdc)=dc(mdc)%LblCnt(1:LENIN)//'    '
*                                                                      *
************************************************************************
*                                                                      *
                        Mamn(iSO)=dc(mdc)%LblCnt(1:LENIN)//ChTemp(1:8)
                        basis_ids(1,iSO) = mdc
                        basis_ids(2,iSO) = iCntrc
                        basis_ids(3,iSO) = llab
                        basis_ids(4,iSO) = mlab
                        fermion_type(iSO)=0
                        If (dbsc(iCnttp)%fMass.ne.1.0D0)
     &                     fermion_type(iSO)=1
                        If (.Not.Primitive_Pass) Then
                           kIrrep=kIrrep+1
                           icent(kIrrep)=mdc
                           lnang(kIrrep)=lval(lculf)
                           lmag(kIrrep)=mval(lculf)
                           lant(kIrrep)=nIrrep/dc(mdc)%nStab
                        Endif
 305                 Continue
*
 304              Continue
 3033             kComp = kComp + (iAng+1)*(iAng+2)/2
                  kculf=kculf+ 2*iAng+1
 303           Continue
               mc = mc + nIrrep/dc(mdc)%nStab
 302        Continue
*
 301     Continue
         nrSym=nIrrep
         nrBas(iIrrep+1)=nBas(iIrrep)
         S%nDim = S%nDim + nBas(iIrrep)
         S%n2Tot = S%n2Tot + nBas(iIrrep)**2
 300  Continue
*
CSVC: basis IDs of non-symmetric case
      if (.not.Primitive_Pass) then
        Call Put_iArray('Fermion IDs',fermion_type,iBas)
        Call Put_iArray('Basis IDs',basis_ids,4*iBas)
      end if
*
      Do 310 jAO = 1, iAO
         Do 311 jIrrep = 0, nIrrep-1
            iAOtSO(jAO,jIrrep) = iAOtSO(jAO,jIrrep) + iOffSO(jIrrep)
 311     Continue
 310  Continue
*
*     Fix index list such that redundant operators will have the
*     same AO index.
*
      mc  = 1
      iShell = 0
      iAO = 0
      Do 401 iCnttp = 1, nCnttp
         kECP = dbsc(iCnttp)%ECP
*
*        Loop over distinct centers
*
         Do 402 iCnt = 1, dbsc(iCnttp)%nCntr
            mdc = iCnt + dbsc(iCnttp)%mdci
            iChxyz=dc(mdc)%iChCnt
*
*           Loop over shells associated with this center
*           Start with s type shells
*
            kComp = 0
            iSh = dbsc(iCnttp)%iVal - 1
            Do 403 iAng = 0, dbsc(iCnttp)%nVal-1
               iSh = iSh + 1
               iShell = iShell + 1
               nExpi=Shells(iSh)%nExp
               nBasisi=Shells(iSh)%nBasis
               If (nExpi.eq.0) Go To 4033
               If (nBasisi.eq.0) Go To 4033
               jComp = (iAng+1)*(iAng+2)/2
               If(Shells(iSh)%Prjct ) jComp = 2*iAng + 1
               Do 404 iComp = 1, jComp
                  iAO = iAO + 1
                  If (iAO.gt.MxAO) Then
                     Call ErrTra
                     Write (6,*) ' Increase MxAO'
                     Call Abend
                  End If
                  lComp = kComp + iComp
                  If (S%MaxBas(iAng).gt.0) Then
*
                     Do 408 imc = 0, (nIrrep/dc(mdc)%nStab)-1
                        itest1 = iAnd(dc(mdc)%iCoSet(imc,0),iChxyz)
                        Nr = NrOpr(dc(mdc)%iCoSet(imc,0))
                        Do 409 jIrrep = 0, nIrrep-1
                           itest2 = iAnd(iOper(jIrrep),iChxyz)
                           If (itest1.eq.itest2)
     &                        iAOtSO(iAO,jIrrep) = iAOtSO(iAO,Nr)
 409                    Continue
 408                 Continue
                  End If
 404           Continue
 4033          kComp = kComp + (iAng+1)*(iAng+2)/2
 403        Continue
            mc = mc + nIrrep/dc(mdc)%nStab
 402     Continue
*
 401  Continue
*
 198  Continue
*                                                                      *
************************************************************************
*                                                                      *
      If (Show) Then
        If (iPrint.ge.6) Then ! std print has been moved to seward.f
*
*        Print out basis set information
*
         Fmt='(6X,A,T30,8I4)'
         Write(6,*)
         Write(6,'(6X,A)')'Basis set specifications :'
         Write(6,'(6X,A,T30,8(1X,A))')
     &         'Symmetry species',         (lIrrep(i),i=0,nIrrep-1)
         Write(6,Fmt)'Basis functions',          (nBas(i),i=0,nIrrep-1)
*
        End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Write info (not just) for LoProp
*
      If (.Not.Primitive_Pass) Then
         Call Put_cArray('LP_L',LP_Names(1),(LENIN4)*S%mCentr)
         Call Put_iArray('LP_A',LPA,S%mCentr)
         Call Put_dArray('LP_Q',LPQ,S%mCentr)
         Call Put_dArray('LP_Coor',LPC,3*S%mCentr)
         Call Put_iScalar('LP_nCenter',S%mCentr)
         Call Put_iArray('IsMM Atoms',LPMM,S%mCentr)
         Call Put_iArray('Center Index',iCI,iBas)
         Call Put_iArray('Orbital Type',iOT,iBas)
         Call Put_iArray('Non valence orbitals',nFCore,nIrrep)
      Else
         Call Put_iArray('Ctr Index Prim',jCI,iBas)
*
      End If
      call mma_deallocate(fermion_type)
      call mma_deallocate(desym_basis_ids)
      call mma_deallocate(basis_ids)
      Call mma_deallocate(LPA)
      Call mma_deallocate(LPMM)
      Call mma_deallocate(LPQ)
      Call mma_deallocate(LPC)
      Call mma_deallocate(iCI)
      Call mma_deallocate(jCI)
      Call mma_deallocate(iOT)
*
      If (Show.and.iPrint.ge.6) Then
         Call CollapseOutput(0,'   SO/AO info:')
         Write (6,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*) ' *** iAOtSO ***'
      Do 555 jAO = 1, iAO
         Write (6,*) (iAOtSO(jAO,jIrrep),jIrrep=0,nIrrep-1)
 555  Continue
#endif
*
      write(isymunit,'(A3)') 'END'
      close(isymunit)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_AmpDiag(irc,Diag,EOcc,EVir)
!
! Jonas Bostrom, Jan. 2010.
!
! Purpose: Construct diagonal for decomposition of amplitude
!          vectors.

use Symmetry_Info, only: Mul
use Cholesky, only: nSym
use ChoMP2, only: iMoMo, iOcc, iVir, nMoMo, nOcc, nVir
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(inout) :: Diag(*)
real(kind=wp), intent(in) :: EOcc(*), EVir(*)
integer(kind=iwp) :: iA, iAI, iI, iSym, iSymA, iSymI, iVecType, kD0, kD1, kD2
real(kind=wp) :: DE, Ei

irc = 0

! Initialization.
! ---------------

iVecType = 6
kD0 = 0

! Construct Diagonal.
! -------------------

do iSym=1,nSym
  do iSymI=1,nSym
    iSymA = Mul(iSymI,iSym)
    kD1 = kD0+iMoMo(iSymA,iSymI,iVecType)
    do iI=1,nOcc(iSymI)
      kD2 = kD1+nVir(iSymA)*(iI-1)
      Ei = EOcc(iOcc(iSymI)+iI)
      do iA=1,nVir(iSymA)
        iAI = kD2+iA
        DE = Two*(EVir(iVir(iSymA)+iA)-Ei)
        Diag(iAI) = Diag(iAI)/DE
      end do
    end do
  end do
  kD0 = kD0+nMoMo(iSym,iVecType)
end do

return

end subroutine ChoMP2g_AmpDiag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GETSTR_TOTSM_SPGP(ISTRTP,ISPGRP,ISPGRPSM,NEL,NSTR,ISTR,NORBT,IDOREO,IZ,IREO)
! Obtain all super-strings of given total symmetry and given
! occupation in each GAS space
!
! If IDOREO /= 0 THEN reordering array : lexical => actual order is obtained
!
! Nomenclature of the day : superstring : string in complete
!                           orbital space, product of strings in
!                           each GAS space
! =====
! Input
! =====
!
! ISTRTP  : Type of of superstrings (alpha => 1, beta => 2)
! ISPGRP :  supergroup number, (relative to start of this type)
! ISPGRPSM : Total symmetry of superstrings
! NEL : Number of electrons
! IZ  : Reverse lexical ordering array for this supergroup
!
! ======
! Output
! ======
!
! NSTR : Number of superstrings generated
! ISTR : Occupation of superstring
! IREO : Reorder array (if IDOREO /= 0)
!
! Jeppe Olsen, July 1995

use Symmetry_Info, only: Mul
use lucia_data, only: IBSPGPFTP, ISPGPFTP, ISTSGP, MXPNGAS, MXPNSMST, NELFGP, NGAS, NIRREP, NSTSGP
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ISTRTP, ISPGRP, ISPGRPSM, NEL, NORBT, IDOREO, IZ(NORBT,NEL)
integer(kind=iwp), intent(out) :: NSTR
integer(kind=iwp), intent(inout) :: ISTR(*), IREO(*)
integer(kind=iwp) :: IEL, IFIRST, IGAS, IISTSGP(MXPNSMST,MXPNGAS), ISMFGS(MXPNGAS), ISMST, ISPGRPA, ISTRBS, ISTSMM1, &
                     ITPFGS(MXPNGAS), JSTR, LEX, MAXLEX, MNVAL(MXPNGAS), MXVAL(MXPNGAS), NELFGS(MXPNGAS), NGASL, &
                     NNSTSGP(MXPNSMST,MXPNGAS), NONEW

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ============================'
write(u6,*) ' Welcome to GETSTR_TOTSM_SPGP'
write(u6,*) ' ============================'
write(u6,*)
write(u6,'(A,3I3)') ' Strings to be obtained : Type, supergroup, symmetry ',ISTRTP,ISPGRP,ISPGRPSM
write(u6,*)
#endif
! Absolute number of this supergroup
ISPGRPA = IBSPGPFTP(ISTRTP)-1+ISPGRP
! Occupation per gasspace
! Largest occupied space
NGASL = 0
! Largest and lowest symmetries active in each GAS space
do IGAS=1,NGAS
  ITPFGS(IGAS) = ISPGPFTP(IGAS,ISPGRPA)
  NELFGS(IGAS) = NELFGP(ITPFGS(IGAS))
  if (NELFGS(IGAS) > 0) NGASL = IGAS
end do
if (NGASL == 0) NGASL = 1
! Number of strings per GAS space and offsets for strings of given sym
do IGAS=1,NGAS
  NNSTSGP(1:NIRREP,IGAS) = NSTSGP((ITPFGS(IGAS)-1)*NIRREP+1:ITPFGS(IGAS)*NIRREP)
  IISTSGP(1:NIRREP,IGAS) = ISTSGP((ITPFGS(IGAS)-1)*NIRREP+1:ITPFGS(IGAS)*NIRREP)
end do

do IGAS=1,NGAS
  do ISMST=1,NIRREP
    if (NNSTSGP(ISMST,IGAS) > 0) MXVAL(IGAS) = ISMST
  end do
  do ISMST=NIRREP,1,-1
    if (NNSTSGP(ISMST,IGAS) > 0) MNVAL(IGAS) = ISMST
  end do
end do
! Largest and lowest active symmetries for each GAS space
#ifdef _DEBUGPRINT_
write(u6,*) ' Type of each GAS space'
call IWRTMA(ITPFGS,1,NGAS,1,NGAS)
write(u6,*) ' Number of elecs per GAS space'
call IWRTMA(NELFGS,1,NGAS,1,NGAS)
#endif

! Loop over symmetries of each GAS

MAXLEX = 0
IFIRST = 1
ISTRBS = 1
do
  if (IFIRST == 1) then
    ISMFGS(1:NGASL-1) = MNVAL(1:NGASL-1)
  else
    ! Next distribution of symmetries in NGAS -1
    !     NXTNUM2(INUM,NELMNT,MNVAL,MXVAL,NONEW)
    !call NXTNUM2(ISMFGS,NGASL-1,1,MXVAL,NONEW)
    !call NXTNUM3(IOCA,NGAS,IGSMIN,IGSMAX,NONEW)
    call NXTNUM3(ISMFGS,NGASL-1,MNVAL,MXVAL,NONEW)
    if (NONEW /= 0) exit
  end if
  IFIRST = 0
# ifdef _DEBUGPRINT_
  write(u6,*) ' next symmetry of NGASL-1 spaces'
  call IWRTMA(ISMFGS,NGASL-1,1,NGASL-1,1)
# endif
  ! Symmetry of NGASL -1 spaces given, symmetry of total space
  ISTSMM1 = 1
  do IGAS=1,NGASL-1
    ISTSMM1 = Mul(ISTSMM1,ISMFGS(IGAS))
    !write(u6,*) ' ISTSMM1 : ',ISTSMM1
  end do
  ! required sym of SPACE NGASL
  ISMFGS(NGASL) = Mul(ISTSMM1,ISPGRPSM)

  ISMFGS(NGASL+1:NGAS) = 1
# ifdef _DEBUGPRINT_
  write(u6,*) ' Next symmetry distribution'
  call IWRTMA(ISMFGS,1,NGAS,1,NGAS)
# endif
  ! Obtain all strings of this symmetry
  call GETSTRN_GASSM_SPGP(ISMFGS,ITPFGS,ISTR(1+NEL*(ISTRBS-1)),NSTR,NEL,NNSTSGP,IISTSGP)
  ! Reorder Info : Lexical => actual number
  if (IDOREO /= 0) then
    ! Lexical number of NEL electrons
    ! Can be made smart by using common factor for first NGAS-1 spaces
    do JSTR=ISTRBS,ISTRBS+NSTR-1
      LEX = 1
      do IEL=1,NEL
        LEX = LEX+IZ(ISTR(IEL+NEL*(JSTR-1)),IEL)
      end do
      !write(u6,*) ' string'
      !call IWRTMA(ISTR(1,JSTR),1,NEL,1,NEL)
      !write(u6,*) ' JSTR and LEX ',JSTR,LEX

      MAXLEX = max(MAXLEX,LEX)
      IREO(LEX) = JSTR
    end do
  end if

  ISTRBS = ISTRBS+NSTR
  ! ready for next symmetry distribution
  if (NGAS == 1) exit
end do
! End of loop over symmetry distributions
NSTR = ISTRBS-1

#ifdef _DEBUGPRINT_
write(u6,*) ' Number of strings generated ',NSTR
write(u6,*)
write(u6,*) ' Strings :'
write(u6,*)
call PRTSTR(ISTR,NEL,NSTR)

if (IDOREO /= 0) then
  write(u6,*) 'Largest Lexical number obtained ',MAXLEX
  write(u6,*) ' Reorder array'
  call IWRTMA(IREO,1,NSTR,1,NSTR)
end if
#endif

end subroutine GETSTR_TOTSM_SPGP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Roland Lindh                                     *
************************************************************************
      Subroutine CurviL(nAtoms,nDim,Cx,Gx,nIter,iIter,iRef,nStab,
     &                  jStab,Degen,Smmtrc,mTR,TRVec,
     &                  ip_rInt,ip_drInt,HSet,BSet,ipBMx,Numerical,iANr,
     &                  HWRS,Analytic_Hessian,iOptC,Name,PrQ,Proj,
     &                  dMass,iCoSet,iTabBonds,
     &                  iTabAtoms, nBonds,nMax,iTabAI,mAtoms,lOld,
     &                  ip_KtB_Hessian,nQQ,nqInt,MaxItr,nWndw)
************************************************************************
*                                                                      *
*     Objective: to handle curvilinear internal coordinates.           *
*                                                                      *
*                                                                      *
*     Authors: R. Lindh, Dept. of Theoretical Chemistry                *
*              University of Lund, SWEDEN.                             *
*              2004                                                    *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "warnings.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "db.fh"
#include "print.fh"
      Real*8 Cx(3*nAtoms,nIter), Degen(3*nAtoms),
     &       Gx(3*nAtoms,nIter), Proj(nDim), dMass(nAtoms),
     &       TRVec(nDim,mTR)
      Integer nStab(nAtoms), iCoSet(0:7,nAtoms),
     &        jStab(0:7,nAtoms), iANr(nAtoms), iDum(6),
     &        iTabBonds(3,nBonds), iTabAtoms(0:nMax,nAtoms),
     &        iTabAI(2,mAtoms)
      Logical Smmtrc(3*nAtoms), HSet, BSet, Proc, Numerical, g12K,
     &        HWRS, Analytic_Hessian, PrQ,
     &        Proc_dB, lOld, Proc_H
      Character filnam*32
      Character*(LENIN) Name(nAtoms)
      Character*14 cDum
      Dimension Dum(1)
      Save g12K
      Data g12K/.False./
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      iPrint=99
#else
      iRout=128
      iPrint=nPrint(iRout)+1
#endif
*                                                                      *
************************************************************************
*                                                                      *
      ip_KtB_Hessian= ip_Dummy
      Thr_raw=3.0D-2
      If (HWRS) Then
         Thr_ElRed=Thr_raw**2
      Else
         Thr_ElRed=Thr_raw
      End If
*
      i=0
      Do iX = 1, 3*nAtoms
         If (Smmtrc(iX)) Then
            i = i + 1
            Proj(i)=One/Degen(iX)
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*.... First some words about the handling of the symmetry. In this code
*     I have selected to use only the unique components of the vectors.
*     Hence, some care has to be taken to account for the degeneracy of
*     some of the elements. This is handled by inserting the u matrix
*     at appropriate places.
*
      nQQ=nDim-mTR
      If (ip_rInt.eq.ip_Dummy) Then
         nqInt=nQQ*MaxItr
         Call GetMem(' qInt','Allo','Real',ip_rInt, nqInt)
         Call GetMem('dqInt','Allo','Real',ip_drInt,nqInt)
         Call FZero(Work(ip_rInt),nqInt)
         Call FZero(Work(ip_drInt),nqInt)
      End If
*
      Call Allocate_Work(ipDegen,nDim)
      i=0
      Do ix = 1, 3*nAtoms
         If (Smmtrc(ix)) Then
            Work(ipDegen+i) = Degen(ix)
            i = i + 1
         End If
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Work(ipDegen)',' ',Work(ipDegen),nDim,1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      filnam='INTCOR'
      LuIC=isfreeunit(4)
      call molcas_open(LuIC,filnam)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     nq: Number of redundant internal coordinates.
*
      Proc=.False.     ! Flag for processing B
      Proc_dB=.False.  ! Flag for processing dB
*
      Thr_small=(30.0D0/180.0D0)*Pi
      Do While (Thr_small.gt.1.0D-6)
         Call Get_Curvil
     &          (nq,nqRF,nqB,nqA,nqT,nqO,
     &           nAtoms,iIter,nIter,Cx,jStab,
     &           nStab,nDim,Smmtrc,Proc,Dum,1,iANr,cDum,
     &           iRef,Dum,Dum,iOptC,LuIC,
     &           Name,iDum,iIter,dMass,iCoSet,Dum,
     &           iDum(1),iDum(1),
     &           Proc_dB,
     &           iTabBonds,iTabAtoms,nBonds,nMax,iTabAI,mAtoms,
     &           mB_Tot,mdB_Tot,Dum,Dum,iDum,iDum,1,1,
     &           iDum,Thr_small)
         If (nq.ge.nQQ) Exit
         Thr_small=Thr_small-(5.0D0/180.0D0)*Pi
      End Do

      Rewind(LuIC)
*
      If (nq.eq.0) Then
         Call WarningMessage(2,' Curvil: nq.eq.0')
         Call Quit(_RC_INTERNAL_ERROR_)
      End If
*
      iGlow=1+nqRF+nqB
      iGhi =nqRF+nqB+nqA
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*) 'nq, nqB, nqA, nqT, nqO=',
     &             nq, nqB, nqA, nqT, nqO
#endif
*
*---- Now allocate some arrays which depend on nq
*
      If (ip_B.ne.ip_Dummy) Then
         Call Free_Work(ip_B)
         Call Free_iWork(ip_iB)
         Call Free_iWork(ip_nqB)
      End If
      Call GetMem('BM','Allo','Real',ip_B,mB_Tot)
      Call GetMem('iBM','Allo','Inte',ip_iB,mB_Tot)
      Call GetMem('nqB','Allo','Inte',ip_nqB,nq)
      mq=nq
*
      Call GetMem('q-Values','Allo','Real',ipqVal,nq*nIter)
      Call GetMem('q-Labels','Allo','Char',ipqLbl,14*nq)
      Call GetMem('F_const','Allo','Real',ipf_c,nq)
      Call GetMem('Mult','Allo','Real',ipMult,nq)
      Call GetMem('Ind','Allo','Inte',ipInd,3*nq)
      Call GetMem('GRef','Allo','Real',ipGRef,9*nqA*nIter)
*
      Call FZero(Work(ipf_c),nq)
      Call FZero(Work(ipMult),nq)
      Call FZero(Work(ipqVal),nq*nIter)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*---- Process the redundant internal coordinates for the current
*     structure.
*
      Proc=.True.
      Proc_dB=.False.
*
      Call Get_Curvil
     &          (iq,iqRF,iqR,iqA,iqT,iqO,
     &           nAtoms,iIter,nIter,Cx,jStab,
     &           nStab,nDim,Smmtrc,Proc,
     &           Work(ipqVal),nq,iANr,cWork(ipqLbl),
     &           iRef,Work(ipf_c),Work(ipMult),iOptC,
     &           LuIC,Name,iWork(ipInd),iIter,dMass,iCoSet,Work(ipGRef),
     &           iGlow,iGHi,
     &           Proc_dB,
     &           iTabBonds,iTabAtoms,nBonds,nMax,iTabAI,mAtoms,
     &           nB_Tot,ndB_Tot,
     &           Work(ip_B),Dum,iWork(ip_iB),iDum,
     &           mB_Tot,mdB_Tot,iWork(ip_nqB),Thr_small)
      Rewind(LuIC)
*
      If (iq.ne.nq) Then
         Call WarningMessage(2,' Error in Curvil')
         Write (6,*) 'In Curvil: iq.ne.nq'
         Write (6,*) 'iq=',iq
         Write (6,*) 'nq=',nq
         Call Abend
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (iPrint.ge.49) Then
         Write (6,*) 'nq, nqB, nqA, nqT, nqO=',
     &             nq, nqB, nqA, nqT, nqO
         Call RecPrt('q-values',' ',Work(ipqVal),nq,nIter)
         Call RecPrt('Force Constant matrix in redundant basis',' ',
     &            Work(ipf_c),1,nq)
         Call RecPrt('Multiplicity factors',' ',Work(ipMult),1,nq)
         Call RecPrt('Cx',' ',Cx,3*nAtoms,nIter)
         Call RecPrt('Gx',' ',Gx,3*nAtoms,nIter)
      End If
#endif
*
*     Notation:
*     X: cartesian coordinates
*     q: redundant internal coordinates
*     Q: nonredundant internal coordinates
*     u: the degeneracy matrix
*
*     dq = B u dx
*
*---- Start processing the B matrix for the current structure to
*     generate the K matrix (dQ/dq).
*
      Call GetMem('EVec','Allo','Real',ipK,nq**2)
      Call GetMem('K(t)B','Allo','Real',ipKtB,nDim**2)
*                                                                      *
************************************************************************
*                                                                      *
*---- Stick in the metric of the force constants in the redundant
*     space.
*
      If (HWRS) Then
*------- Scale each coordinate with the force constant
*
         i = 0
         Do iq = 0, nq-1
            nB = iWork(ip_nqB+iq)
            Call DScal_(nB,Work(ipf_c+iq),Work(ip_B+i),1)
            i = i + nB
         End Do
*ifdef _DEBUGPRINT_
         If (iPrint.ge.99) Then
            i = 0
            Do iq = 0, nq-1
               nB = iWork(ip_nqB+iq)
               Call RecPrt('fcB',' ',Work(ip_B+i),1,nB)
               i = i + nB
            End Do
         End If
*endif
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Eliminate redundancy to produce the nonredundant internal
*     coordinates.
*
*           t        t
*     dQ = K M dq = K M B u dx
*
      i = 0
      Do iq = 0, nq-1
         nB = iWork(ip_nqB+iq)
         Call DScal_(nB,Work(ipMult+iq),Work(ip_B+i),1)
         i = i + nB
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (BSet) Then
         Call GetMem('G','Allo','Real',ipG,nq*nq)
         Call GetMem('EVal','Allo','Real',ipEVal,nq*(nq+1)/2)
         Call ElRed2(nq,ndim,Work(ipG),Work(ipEVal),Work(ipK),nK,Proj,
     &               g12K,Thr_ElRed,Work(ip_B),iWork(ip_iB),mB_Tot,
     &               iWork(ip_nqB))

         If (nK.gt.nQQ) Then
            Call Remove_TR(nq,ndim,nQQ,Work(ipK),nK,TRVec,mTR,
     &                     Work(ip_B),iWork(ip_iB),iWork(ip_nqB),mB_Tot)
         End If
         Call GetMem('EVal','Free','Real',ipEVal,nq*(nq+1)/2)
         Call GetMem('G','Free','Real',ipG,nq*nq)
*
         Call Put_dArray('K',Work(ipK),nq*nQQ)
      Else
         Call Get_dArray('K',Work(ipK),nq*nQQ)
      End If
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt('K',' ',Work(ipK),nq,nQQ)
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Print the nonreduntant coordinates.
*
      If (PrQ) Then
         Call GetMem('Temp2','Allo','Real',ipTemp2,nq*nQQ)
         call dcopy_(nQQ*nq,Work(ipK),1,Work(ipTemp2),1)
         Do iq = 0, nq-1
            Call DScal_(nQQ,One/Work(ipMult+iq),Work(ipTemp2+iq),nq)
         End Do
         Call PrintQ(Work(ipTemp2),cWork(ipqLbl),nq,nQQ,LuIC,
     &               Work(ipMult))
         Call GetMem('Temp2','Free','Real',ipTemp2,nq*nQQ)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (PrQ.and.iPrint.ge.6) Then
         Write (6,*)
         Write (6,'(A)')   ' ******************************************'
         Write (6,'(A)')   ' * Statistics of the internal coordinates *'
         Write (6,'(A)')   ' ******************************************'
         Write (6,'(A,I5)')' Translations and Rotations:     ',nqRF
         Write (6,'(A,I5)')' Bonds                     :     ',nqB
         Write (6,'(A,I5)')' Angles                    :     ',nqA
         Write (6,'(A,I5)')' Torsions                  :     ',nqT
         Write (6,'(A,I5)')' Out-of-plane angles       :     ',nqO
         Write (6,*)
      End If
      If (nq.lt.nQQ) Then
         Call WarningMessage(2,' Error in Curvil')
         Write (6,*) 'In Curvil: nq.lt.nQQ'
         Write (6,*) 'nq=',nq
         Write (6,*) 'nQQ=',nQQ
         Call Abend
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     The nonredundant internal coordinates are now defined!           *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*---- Compute the values and the gradients of the nonredundant internal
*     curvilinear coordinates for all the iterations.
*
*     Loop over
*     1) the last to the first iteration if normal execusion
*     2) only the last if in transformation from internal to
*        cartesian
*
      If (BSet) Then
*------- Produce list of compressed cartesian gradients.
         Call GetMem('GxR','Allo','Real',ipGxR,nDim*nIter)
         iOff = ipGxR
         Do jIter = 1, nIter
            Call NRed(Gx(1,jIter),Work(iOff),3*nAtoms,nDim,Smmtrc)
            iOff = iOff + nDim
         End Do
*
         iSt = nIter
         iEnd = iSt - Min(nIter,nWndw+1) + 1
C        iEnd = 1
         iOff = (nIter-1)*nDim + ipGxR
      Else
         If (Numerical) Then
            Call GetMem('GxR','Allo','Real',ipGxR,nDim)
            iOff = ipGxR
            Call NRed(Gx(1,nIter),Work(iOff),3*nAtoms,nDim,Smmtrc)
         Else
            iOff = ip_Dummy
         End If
         iEnd=nIter
         iSt =nIter
      End If
*
*     Note that the loop is in reverse order.
*
      Do jIter = iSt, iEnd, -1
         Proc_H=HSet.and.jIter.eq.iRef.and..Not.lOld
         Proc_dB=Proc_H.and.Analytic_Hessian
*        Compute and store dBQQ in the reference structure
         Proc_dB=Proc_dB.or.(Proc_H.and.Numerical)
         If (Proc_dB) Then
            If (ip_dB.ne.ip_Dummy) Then
               Call Free_Work(ip_dB)
               Call Free_iWork(ip_idB)
            End If
            Call GetMem('dBM','Allo','Real',ip_dB,mdB_Tot)
            Call GetMem('idBM','Allo','Inte',ip_idB,mdB_Tot*2)
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
         Call Get_Curvil
     &             (iq,iqRF,iqR,iqA,iqT,iqO,
     &              nAtoms,jIter,nIter,Cx,jStab,
     &              nStab,nDim,Smmtrc,Proc,
     &              Work(ipqVal),nq,iANr,cWork(ipqLbl),
     &              iRef, Work(ipf_c),Work(ipMult),
     &              iOptC,LuIC,Name,iWork(ipInd),iIter,dMass,iCoSet,
     &              Work(ipGRef),iGlow,iGHi,
     &              Proc_dB,
     &              iTabBonds,iTabAtoms,nBonds,nMax,iTabAI,mAtoms,
     &              nB_Tot,ndB_Tot,
     &              Work(ip_B),Work(ip_dB),iWork(ip_iB),iWork(ip_idB),
     &              mB_Tot,mdB_Tot,iWork(ip_nqB),Thr_small)
         Rewind(LuIC)
*
         If (iq.ne.nq) Then
            Write (6,*) 'In Curvil: iq.ne.nq'
            Write (6,*) 'iq=',iq
            Write (6,*) 'nq=',nq
            Call Abend
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- Form the gradients of Q
*                                         T
*------- Form the K(t)MB matrix for dQ = K M B u dx
*
         i = 0
         Do iq = 0, nq-1
            nB = iWork(ip_nqB+iq)
            Call DScal_(nB,Work(ipMult+iq),Work(ip_B+i),1)
            i = i + nB
         End Do
         Call FZero(Work(ipKtB),nQQ*nDim)
         Do iQQ = 0, nQQ-1
            i = 0
            Do iq = 0, nq-1
               nB = iWork(ip_nqB+iq)
               Do iB = 0, nB-1
                  iDim = iWork(ip_iB+i)
                  Work((iDim-1)*nQQ + iQQ + ipKtB) =
     &                 Work((iDim-1)*nQQ + iQQ + ipKtB)
     &               + Work(iQQ*nq+iq+ipK)
     &               * Work(i+ip_B)
                  i = i + 1
               End Do
            End Do
         End Do
#ifdef _DEBUGPRINT_
         If (iPrint.ge.99) Then
            Call RecPrt(' The K matrix',' ',Work(ipK),nq,nQQ)
            Call RecPrt(' The K(t)B matrix',' ',Work(ipKtB),nQQ,nDim)
         End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*------- Store the B matrix for the last structure
*
         If (jIter.eq.nIter) Then
            nX = 3*nAtoms
            Call Allocate_Work(ipBmx,nX**2)
            Call FZero(Work(ipBMx),nX**2)
*
*           modify from compact to full Cartesian storage.
*
            iDim = 0
            Do iX = 1, nX
               If (Smmtrc(iX)) Then
                  iDim = iDim + 1
                  Do iQQ = 1, nQQ
                     iXQ = (iQQ-1)*nX + iX + ipBMx - 1
                     iQD = (iDim-1)*nQQ + iQQ + ipKtB -1
                     Work(iXQ) = Work(iQD)
                  End Do
               Else
                  Do iQQ = 1, nQQ
                     iXQ = (iQQ-1)*nX + iX + ipBMx - 1
                     Work(iXQ) = Zero
                  End Do
               End If
            End Do

         End If
*                                                                      *
************************************************************************
*                                                                      *
*------- Branch out if only values are to be computed.
*
         If (BSet .or. Numerical) Then
*                                                                      *
************************************************************************
*                                                                      *
*---------- Form the gradient for iteration jIter for the new definition
*           of the K matrix.
*
*           dq/dx dE/dq = dE/dq
*
*           The B-matrix is stored (3*natom x nQQ)
*           KtB is stored nQQ, nDim
*
            Call Allocate_Work(ip_KtB,nDim*nQQ)
            Call TRNSPS(nQQ,nDim,Work(ipKtB   ),Work(ip_KtB))
*
*           Strip KtB of the degeneracy factor (full).
*
            Do iQQ = 1, nQQ
               Do iDim = 1, nDim
                  ij = (iQQ-1)*nDim + iDim -1 + ip_KtB
                  Work(ij) = Work(ij) / Work(ipDegen+iDim-1)
               End Do
            End Do
*
            ip = ip_drInt + (jIter-1)*nQQ
            M = nDim
            N = nQQ
            NRHS=1
            Call Eq_Solver('N',M,N,NRHS,Work(ip_KtB   ),.False.,
     &                     Work(ipDegen),Work(iOff),Work(ip))
*           Call RecPrt('Work(iOff)',' ',Work(iOff),nDim,1)
*           Call RecPrt('KtB   ',' ',Work(ipKtB   ),nQQ,nDim)
*           Call RecPrt('drInt',' ',Work(ip),nQQ,1)

            iOff = iOff - nDim
*                                                                      *
************************************************************************
*                                                                      *
*---------- Save pointer to KtB to be used in backtransforming the
*           Hessian to internal coordinates.
*
            If (Proc_H) Then
               ip_KtB_Hessian=ip_KtB
*              Write (*,*) 'ip_KtB_Hessian=',ip_KtB_Hessian
*              Call RecPrt('KtB',' ',Work(ip_KtB),nDim,nQQ)
            Else
               Call Free_Work(ip_KtB)
            End If
*                                                                      *
************************************************************************
*                                                                      *
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Process the values
*          t
*     Q = K M q
*
      ipqV=ipqVal
      jIter = 1
      mIter = nIter
      If (.Not.BSet) Then
         ipqV = (nIter-1)*nq + ipqVal
         jIter = nIter
         mIter = 1
      End If
      Call GetMem('KtM','Allo','Real',ipKtM,nQQ*nq)
      Do iq = 0, nq-1
         Alpha=Work(ipMult+iq)
         Do iQQ = 0, nQQ-1
            temp = Work(ipK+iQQ*nq+iq)*Alpha
            Work(ipKtM+iq*nQQ+iQQ)=temp
         End Do
      End Do
      ip = ip_rInt + (jIter-1)*(nDim-mTR)
      Call DGEMM_('N','N',
     &            nQQ,mIter,nq,
     &            1.0d0,Work(ipKtM),nQQ,
     &                  Work(ipqV),nq,
     &            0.0d0,Work(ip),nQQ)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (iPrint.ge.49) Then
         Call RecPrt(' The K Matrix',' ',Work(ipK),nq,nQQ)
         Call RecPrt(' q-values',' ',Work(ipqVal),nq,nIter)
         Call RecPrt('Q-values',' ',Work(ip_rInt),nQQ,nIter)
         Call RecPrt('Cx',' ',Cx,3*nAtoms,nIter)
      End If
      If (BSet.and.iPrint.ge.49) Then
          Call RecPrt('Q-gradients',' ',Work(ip_drInt),nQQ,nIter)
          Call RecPrt('Gx',' ',Gx,3*nAtoms,nIter)
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Deallocate memory
*
      Call GetMem('KtM','Free','Real',ipKtM,nQQ*nq)
      If (BSet .or. Numerical)
     &   Call GetMem('GxR','Free','Real',ipGxR,nDim*nIter)
      Call GetMem('K(t)B','Free','Real',ipKtB,nQQ*nDim)
      Call GetMem('EVec','Free','Real',ipK,nq**2)
      Call GetMem('GRef','Free','Real',ipGRef,9*nqA*nIter)
      Call GetMem('Ind','Free','Inte',ipInd,3*nq)
      Call GetMem('Mult','Free','Real',ipMult,nq)
      Call GetMem('F_const','Free','Real',ipf_c,nq)
      Call GetMem('q-Labels','Free','Char',ipqLbl,14*nq)
      Call GetMem('Q-Values','Free','Real',ipQVal,nq*nIter)
*
      Call Free_Work(ipDegen)
*
      Close (LuIC)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996,1997, Bernd Schimmelpfennig                       *
!***********************************************************************

subroutine finite()
!bs subroutine to set up parameters for finite nucleus. The
!bs s-functions are replaced by just one exponent which models the nucleus.

use AMFI_global, only: charge, Exp_finite, exponents, Lmax_occ, ncontrac, ncontrac_keep, nprimit, noccorb, occup
use Constants, only: Half

implicit none

noccorb(0) = 1
noccorb(1:lmax_occ) = 0
occup(1,0) = -charge
ncontrac_keep = ncontrac(0)
nprimit(0) = 1
ncontrac(0) = 1
exponents(1,0) = Half*Exp_finite

return

end subroutine finite

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB)
      IMPLICIT NONE
      INTEGER IORBTAB(*),NASPRT
      INTEGER ISSTAB(*)
      INTEGER IFSBTAB(*)
      INTEGER IMODE,ISORB,KOINFO,ISPART,INSBPT,MORSBITS
      INTEGER KSSTAN,KSSTCR
      INTEGER KSSTOP,NTAB1,ITYPE,NFSB1,NASPRT1
      INTEGER KSTARR1,NTAB2,NTAB2NEW,NASPRT2
      INTEGER LFSBOP,KSTARR2,IFSB2,IDET2,IFSB1,KPOS1
      INTEGER ISST1,ISST2,KPOS2,NDETS2,NHEAD
      INTEGER LSSTARR2,NSSTARR2,NFSB2,LHSH2,NHSH2
      INTEGER KSSTTB,NSBS1,NSBS2,NDET1,NDET2
      INTEGER NULL,KHSH2,IERR,LPOS
#include "WrkSpc.fh"

C The orbital table:
      NASPRT= IORBTAB(9)
      KOINFO=19
C Needed properties of spin-orbital ISORB
      ISPART=IORBTAB(KOINFO+6+8*(ISORB-1))
      INSBPT=IORBTAB(KOINFO+7+8*(ISORB-1))
C The substring table:
      MORSBITS=ISSTAB(6)
      KSSTTB=15
      KSSTAN=ISSTAB( 9)
      KSSTCR=ISSTAB(10)
      IF(IMODE.EQ.1) THEN
        KSSTOP=KSSTCR
      ELSE
        KSSTOP=KSSTAN
      END IF

C The FS blocks of the PSI wave function:
      NTAB1  =IFSBTAB(1)
      ITYPE  =IFSBTAB(2)
      NFSB1  =IFSBTAB(3)
      NASPRT1=IFSBTAB(4)
      KSTARR1=8
C Count how big the new table will be:
      NASPRT2=NASPRT1
      KSTARR2=KSTARR1
      IFSB2=0
      IDET2=0
      DO IFSB1=1,NFSB1
CTEST        write(*,'(1x,a,8I8)')'FSBOP IFSB1=',IFSB1
        KPOS1=KSTARR1+(NASPRT1+2)*(IFSB1-1)
        NDET1=IFSBTAB(KPOS1+NASPRT)
CTEST        write(*,'(1x,a,8I8)')'NDET1:',NDET1
C The substring type to be annihilated from or created in:
        ISST1=IFSBTAB(KPOS1-1+ISPART)
C The resulting substring type:
        ISST2=ISSTAB(KSSTOP-1+INSBPT+MORSBITS*(ISST1-1))
        IF(ISST2.EQ.0) GOTO 99
        IFSB2=IFSB2+1
        KPOS2=KSTARR2+(NASPRT2+2)*(IFSB2-1)
C Replace substring type:
C Old vs. new nr of substrings:
        NSBS1=ISSTAB(KSSTTB+5*(ISST1-1))
        NSBS2=ISSTAB(KSSTTB+5*(ISST2-1))
        NDET2=(NDET1*NSBS2)/NSBS1
CTEST      write(*,'(1x,a,8I8)')'NSBS1,NSBS2:',NSBS1,NSBS2
CTEST      write(*,'(1x,a,8I8)')'NDET1,NDET2:',NDET1,NDET2
        IDET2=IDET2+NDET2
  99    CONTINUE
      END DO
      NFSB2=IFSB2
      NDETS2=IDET2
      NHEAD=7
*      LSSTARR2=LFSBOP+NHEAD
      NSSTARR2=(NASPRT2+2)*NFSB2
*      LHSH2=LSSTARR2+NSSTARR2
      NHSH2=997+2*NFSB2
      NTAB2=NHEAD+NSSTARR2+2*NHSH2
C NTAB2 is now known. Make a new FSB table:
CTEST      WRITE(*,*)' FSBOP: Here, NTAB2 should be known.'
CTEST      WRITE(*,*)'   NFSB2 =',NFSB2
CTEST      WRITE(*,*)'   NDETS2=',NDETS2
CTEST      WRITE(*,*)'   NHEAD =',NHEAD
CTEST      WRITE(*,*)' NSSTARR2=',NSSTARR2
CTEST      WRITE(*,*)'   NHSH2 =',NHSH2
CTEST      WRITE(*,*)'   NTAB2 =',NTAB2
      CALL GETMEM('FSBOP','Allo','Inte',LFSBOP,NTAB2)
      IWORK(LFSBOP+0)=NTAB2
      IWORK(LFSBOP+1)=ITYPE
      IWORK(LFSBOP+3)=NASPRT2
      KSTARR2=KSTARR1
      IFSB2=0
      IDET2=0
      DO IFSB1=1,NFSB1
CTEST        write(*,'(1x,a,8I8)')'FSBOP IFSB1=',IFSB1
        KPOS1=KSTARR1+(NASPRT1+2)*(IFSB1-1)
        NDET1=IFSBTAB(KPOS1+NASPRT)
CTEST        write(*,'(1x,a,8I8)')'NDET1:',NDET1
C The substring type to be annihilated from or created in:
        ISST1=IFSBTAB(KPOS1-1+ISPART)
C The resulting substring type:
        ISST2=ISSTAB(KSSTOP-1+INSBPT+MORSBITS*(ISST1-1))
        IF(ISST2.EQ.0) GOTO 100
        IFSB2=IFSB2+1
        KPOS2=KSTARR2+(NASPRT2+2)*(IFSB2-1)
        CALL ICOPY(NASPRT1,IFSBTAB(KPOS1),1,IWORK(LFSBOP-1+KPOS2),1)
C Replace substring type:
        IWORK(LFSBOP-1+KPOS2-1+ISPART)=ISST2
C Old vs. new nr of substrings:
        NSBS1=ISSTAB(KSSTTB+5*(ISST1-1))
        NSBS2=ISSTAB(KSSTTB+5*(ISST2-1))
        NDET2=(NDET1*NSBS2)/NSBS1
        IWORK(LFSBOP-1+KPOS2+NASPRT  )=NDET2
        IWORK(LFSBOP-1+KPOS2+NASPRT+1)=IDET2+1
CTEST      write(*,'(1x,a,8I8)')'NSBS1,NSBS2:',NSBS1,NSBS2
CTEST      write(*,'(1x,a,8I8)')'NDET1,NDET2:',NDET1,NDET2
        IDET2=IDET2+NDET2
 100    CONTINUE
      END DO
CTEST      write(*,'(1x,a,8I8)')'finished, with NFSB2=',NFSB2
CTEST      write(*,'(1x,a,8I8)')'              NDETS2=',NDETS2
C Store this block in the PSI2 hash structure.
      NHEAD=7
      LSSTARR2=LFSBOP+NHEAD
      NSSTARR2=(NASPRT2+2)*NFSB2
      LHSH2=LSSTARR2+NSSTARR2
      NHSH2=997+2*NFSB2
      NTAB2NEW=NHEAD+NSSTARR2+2*NHSH2
      IF(NTAB2.NE.NTAB2NEW) THEN
        WRITE(6,*)' FSBOP Error: NTAB2.NE.NTAB2NEW!'
        WRITE(6,*)' (This should be impossible!)'
        WRITE(6,*)' Program RASSI is forced to stop, sorry!'
        CALL ABEND()
      END IF
C Make the hash map: NULL is a null marker. Suggested value=-1.
      NULL=-1
      CALL HSHINI(NHSH2,IWORK(LHSH2),NULL)
      KHSH2=1+NHEAD+NSSTARR2
C Header data:
      IWORK(LFSBOP)=NTAB2
      IWORK(LFSBOP+1)=ITYPE
      IWORK(LFSBOP+2)=NFSB2
      IWORK(LFSBOP+3)=NASPRT2
      IWORK(LFSBOP+4)=NDETS2
      IWORK(LFSBOP+5)=NHSH2
      IWORK(LFSBOP+6)=KHSH2
C Store values in the map:
      DO IFSB2=1,NFSB2
        CALL HSHPUT(NASPRT2,NASPRT2+2,IWORK(LSSTARR2),
     &                         NHSH2,IWORK(LHSH2),IFSB2)
      END DO
      FSBOP=LFSBOP
      IERR=0
      DO IFSB2=1,NFSB2
        LPOS=LSSTARR2+(NASPRT+2)*(IFSB2-1)
        DO ISPART=1,NASPRT
          ISST2=IWORK(LPOS-1+ISPART)
          IF(ISST2.LT.1) IERR=IERR+1
        END DO
      END DO
      IF(IERR.GT.0) THEN
        WRITE(6,*)' Bad substrings in FSBOP!'
        WRITE(6,*)' IERR=',IERR
        CALL PRFSBTAB(IWORK(LFSBOP))
        CALL ABEND()
      END IF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Magic_Bonds(Coor,nAtoms,iTabBonds,nBondMax,nBonds,
     &                       iTabAtoms,nMax)
      Implicit real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Coor(3,nAtoms)
      Integer iTabBonds(3,nBondMax), iTabAtoms(2,0:nMax,nAtoms)
#include "bondtypes.fh"
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*
      Fi_limit = (165.0D0/180.D0)*Pi
      CosFi_limit=Cos(Fi_limit)
      Do iBond = 1, nBonds
         iBondType=iTabBonds(3,iBond)
         If (iBondType.eq.vdW_Bond) Go To 100
         If (iBondType.gt.Magic_Bond) Go To 100
*
         Do iCase = 1, 2
*
            If (iCase.eq.1) Then
               iAtom=iTabBonds(1,iBond)
               jAtom=iTabBonds(2,iBond)
            Else
               iAtom=iTabBonds(2,iBond)
               jAtom=iTabBonds(1,iBond)
            End If
*
            xij=Coor(1,iAtom)-Coor(1,jAtom)
            yij=Coor(2,iAtom)-Coor(2,jAtom)
            zij=Coor(3,iAtom)-Coor(3,jAtom)
            rij=Sqrt(xij**2+yij**2+zij**2)
*
            nNeighbor_j = iTabAtoms(1,0,jAtom)
            Do kNeighbor = 1, nNeighbor_j
               kAtom = iTabAtoms(1,kNeighbor,jAtom)
               jBond = iTabAtoms(2,kNeighbor,jAtom)
               If (jBond.ge.iBond) Go To 99
               jBondType=iTabBonds(3,jBond)
               If (jBondType.eq.vdW_Bond) Go To 99
               If (jBondType.gt.Magic_Bond) Go To 99
*
*              If this is close to a linear system we will form
*              a magic bond between iAtom and kAtom
*
               xkj=Coor(1,kAtom)-Coor(1,jAtom)
               ykj=Coor(2,kAtom)-Coor(2,jAtom)
               zkj=Coor(3,kAtom)-Coor(3,jAtom)
               rkj=Sqrt(xkj**2+ykj**2+zkj**2)
*
               CosFi=(xij*xkj+yij*ykj+zij*zkj)/(rij*rkj)
#ifdef _DEBUGPRINT_
               Write(6,*) 'iAtom,jAtom,kAtom=',iAtom,jAtom,kAtom
               Write(6,*) 'CosFi,CosFi_limit=',CosFi,CosFi_limit
#endif

*
*------------> Observe that this limit should be coordinated with
*              the limit for excluding torsions in torsion_list!
*
               If (CosFi.le.CosFi_Limit) Then
*
#ifdef _DEBUGPRINT_
                  Write (6,*) 'Forming a "magic" bond'
                  Write (6,*) 'iAtom,kAtom=',iAtom,kAtom
#endif
*                 Double check that this bond is not included already.
*                 If that is the case just update the bond type if it
*                 is not classified already as a covalent bond.
*
                  Do kBond = 1, nBonds
                     If ( (iTabBonds(1,kBond).eq.iAtom .and.
     &                     iTabBonds(2,kBond).eq.kAtom) .or.
     &                    (iTabBonds(1,kBond).eq.kAtom .and.
     &                     iTabBonds(2,kBond).eq.iAtom) .and.
     &                     iTabBonds(3,kBond).ne.Covalent_Bond) Then
                         iTabBonds(3,kBond)=jAtom + Magic_Bond
                         Go To 99
                     End If
                  End Do
*
                  If (nBonds+1.gt.nBondMax) Then
                     Call WarningMessage(2,'Error in Magic_Bonds')
                     Write (6,*) 'Magic_Bonds: nBonds.gt.nBondMax'
                     Write (6,*) 'iTabBonds:'
                     Do kBond = 1, nBonds
                        Write (6,*)
                        Write (6,*) 'kBond=',kBond
                        Write (6,*)
                        Write (6,*) 'Atoms=',iTabBonds(1,kBond),
     &                                       iTabBonds(2,kBond)
                        Write (6,*) 'Bondtype:',iTabBonds(3,kBond)
                     End Do
                     Call Abend()
                  End If
                  nBonds = nBonds + 1
                  iTabBonds(1,nBonds)=Max(iAtom,kAtom)
                  iTabBonds(2,nBonds)=Min(iAtom,kAtom)
                  iTabBonds(3,nBonds)=jAtom + Magic_Bond
*
                  nNeighbor_i=iTabAtoms(1,0,iAtom)+1
                  If (nNeighbor_i.gt.nMax) Then
                     Call WarningMessage(2,'Error in Magic_Bonds')
                     Write (6,*)
     &                  'Magic_Bonds: nNeighbor_i.gt.nMax'
                     Write (6,*) 'iAtom=',iAtom
                     Write (6,*) 'nNeighbor_i=',nNeighbor_i
                     Write (6,*) 'nMax=',nMax
                     Call Abend()
                  End If
                  iTabAtoms(1,0,iAtom)=nNeighbor_i
                  iTabAtoms(1,nNeighbor_i,iAtom)=kAtom
                  iTabAtoms(2,nNeighbor_i,iAtom)=nBonds
*
                  nNeighbor_k=iTabAtoms(1,0,kAtom)+1
                  If (nNeighbor_k.gt.nMax) Then
                     Call WarningMessage(2,'Error in Magic_Bonds')
                     Write (6,*)
     &                  'Magic_Bonds: nNeighbor_k.gt.nMax'
                     Write (6,*) 'kAtom=',kAtom
                     Write (6,*) 'nNeighbor_k=',nNeighbor_k
                     Write (6,*) 'nMax=',nMax
                     Call Abend()
                  End If
                  iTabAtoms(1,0,kAtom)=nNeighbor_k
                  iTabAtoms(1,nNeighbor_k,kAtom)=iAtom
                  iTabAtoms(2,nNeighbor_k,kAtom)=nBonds
               End If
*
 99            Continue
            End Do   ! kNeighbor
*
         End Do      ! iCase
*
 100     Continue
      End Do         ! iBond
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

function iPntSO(j1,j2,lOper,nbas)
!***********************************************************************
!                                                                      *
! Object: to compute the offset to an one-electron integral block.     *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             February '91                                             *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iPntSO
integer(kind=iwp), intent(in) :: j1, j2, lOper, nbas(0:7)
integer(kind=iwp) :: iIrrep, ij, iSmLbl, jIrrep, jMax

iPntSO = 0
iSmLbl = lOper
do iIrrep=0,j1
  jMax = iIrrep
  if (iIrrep == j1) jMax = j2-1
  do jIrrep=0,jMax
    ij = Mul(iIrrep+1,jIrrep+1)-1
    if (.not. btest(iSmLbl,ij)) cycle
    if (iIrrep == jIrrep) then
      iPntSO = iPntSO+nTri_Elem(nBas(iIrrep))
    else
      iPntSO = iPntSO+nBas(iIrrep)*nBas(jIrrep)
    end if
  end do
end do

return

end function iPntSO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine LOOP23(KM,ISTOP,IFAI,IT1,IT2)

use guga_global, only: BL1, BL2, COUP, COUP1, IA, IB, ICOUP, ICOUP1, IWAY, IY, J1, J2, JM, JM1, K0, K0F, K1, K1F, K2, K2F, K3, K3F
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: KM, IFAI, IT1, IT2
integer(kind=iwp), intent(out) :: ISTOP
integer(kind=iwp) :: IDIF, IWAYKM, KM1
real(kind=wp) :: WMM, WMP, WPM, WPP

ISTOP = 0
KM1 = KM+1
IDIF = IA(J1(KM1))-IA(J2(KM1))
if ((IDIF < -1) .or. (IDIF > 1)) then
  ISTOP = 1
else if (IDIF < 0) then
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    ! (NQ+,RK+)
    IWAY(KM) = 2
    if ((K1(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else if (K1F(JM(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP1(KM) = -COUP(KM1)/(IB(J2(KM1))+1)
      JM1(KM) = K1F(JM(KM1))
      if (K2F(JM(KM1)) /= 0) then
        COUP(KM) = COUP(KM1)/(IB(J2(KM1))+3)
        JM(KM) = K2F(JM(KM1))
      end if
    else if (K2F(JM(KM1)) == 0) then
      IWAYKM = 2
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
    end if
  end if
  if (IWAYKM == 2) then
    ! MI+
    IWAY(KM) = 3
    if ((K0(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else if (K0F(JM(KM1)) == 0) then
      IWAYKM = 3
    else
      J1(KM) = K0(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)
      ICOUP(KM) = ICOUP(KM1)
      COUP(KM) = COUP(KM1)
      JM(KM) = K0F(JM(KM1))
    end if
  end if
  if (IWAYKM == 3) then
    ! NJ+
    IWAY(KM) = 4
    if ((K1(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 4
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 4
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM) = -BL1(IB(J2(KM1))+2)*COUP(KM1)
      JM(KM) = K1F(JM(KM1))
    end if
  end if
  if (IWAYKM == 4) then
    ! OK+
    IWAY(KM) = 5
    if ((K2(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 5
    else if (K2F(JM(KM1)) == 0) then
      IWAYKM = 5
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM) = -BL2(IB(J2(KM1))+2)*COUP(KM1)
      JM(KM) = K2F(JM(KM1))
    end if
  end if
  if (IWAYKM == 5) then
    ! PL+
    IWAY(KM) = 6
    if ((K3(IT1+J1(KM1)) == 0) .or. (K3(IT2+J2(KM1)) == 0)) then
      IWAYKM = 6
    else if (K3F(JM(KM1)) == 0) then
      IWAYKM = 6
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K3(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP(KM) = COUP(KM1)
      JM(KM) = K3F(JM(KM1))
    end if
  end if
  if (IWAYKM == 6) ISTOP = 1
else if (IDIF == 0) then
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    ! (NN+,RR+JJ+)
    IWAY(KM) = 2
    WMP = Zero
    WPP = Zero
    if ((K1(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else if (K1F(JM1(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K1F(JM1(KM1))
      if (K2F(JM1(KM1)) /= 0) then
        WMP = One/((IB(J2(KM1))+1)**2)
        JM(KM) = K2F(JM1(KM1))
        if (K1F(JM(KM1)) /= 0) then
          WPP = BL1(IB(J2(KM1))+2)**2
          JM(KM) = K1F(JM(KM1))
        end if
        COUP(KM) = WMP*COUP1(KM1)+WPP*COUP(KM1)
      else if (K1F(JM(KM1)) /= 0) then
        WPP = BL1(IB(J2(KM1))+2)**2
        JM(KM) = K1F(JM(KM1))
        COUP(KM) = WPP*COUP(KM1)
      end if
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      WMP = One/((IB(J2(KM1))+1)**2)
      JM(KM) = K2F(JM1(KM1))
      if (K1F(JM(KM1)) /= 0) then
        WPP = BL1(IB(J2(KM1))+2)**2
        JM(KM) = K1F(JM(KM1))
      end if
      COUP(KM) = WMP*COUP1(KM1)+WPP*COUP(KM1)
    else if (K1F(JM(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      WPP = BL1(IB(J2(KM1))+2)**2
      JM(KM) = K1F(JM(KM1))
      COUP(KM) = WPP*COUP(KM1)
    else if (IFAI == 0) then
      IWAYKM = 2
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM) = Zero
      COUP(KM) = Zero
    end if
  end if
  if (IWAYKM == 2) then
    ! (KK+,OO+,QQ+)
    IWAY(KM) = 3
    WMM = Zero
    WPM = Zero
    if ((K2(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else if (K2F(JM(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM) = COUP(KM1)
      JM(KM) = K2F(JM(KM1))
      if (K2F(JM1(KM1)) /= 0) then
        WMM = BL2(IB(J2(KM1)))**2
        JM1(KM) = K2F(JM1(KM1))
        if (K1F(JM(KM1)) /= 0) then
          WPM = One/((IB(J2(KM1))+1)**2)
          JM1(KM) = K1F(JM(KM1))
        end if
        COUP1(KM) = WMM*COUP1(KM1)+WPM*COUP(KM1)
      else if (K1F(JM(KM1)) /= 0) then
        WPM = One/((IB(J2(KM1))+1)**2)
        JM1(KM) = K1F(JM(KM1))
        COUP1(KM) = WPM*COUP(KM1)
      end if
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      WMM = BL2(IB(J2(KM1)))**2
      JM1(KM) = K2F(JM1(KM1))
      if (K1F(JM(KM1)) /= 0) then
        WPM = One/((IB(J2(KM1))+1)**2)
        JM1(KM) = K1F(JM(KM1))
      end if
      COUP1(KM) = WMM*COUP1(KM1)+WPM*COUP(KM1)
    else if (K1F(JM(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      WPM = One/((IB(J2(KM1))+1)**2)
      JM1(KM) = K1F(JM(KM1))
      COUP1(KM) = WPM*COUP(KM1)
    else if (IFAI == 0) then
      IWAYKM = 3
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP1(KM) = Zero
      COUP(KM) = Zero
    end if
  end if
  if (IWAYKM == 3) then
    ! (MM+,II+)
    IWAY(KM) = 4
    if ((K0(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 4
    else if (K0F(JM1(KM1)) /= 0) then
      J1(KM) = K0(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)
      ICOUP(KM) = ICOUP(KM1)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K0F(JM1(KM1))
      if (K0F(JM(KM1)) /= 0) then
        COUP(KM) = COUP(KM1)
        JM(KM) = K0F(JM(KM1))
      end if
    else if (K0F(JM(KM1)) /= 0) then
      J1(KM) = K0(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)
      ICOUP(KM) = ICOUP(KM1)
      COUP(KM) = COUP(KM1)
      JM(KM) = K0F(JM(KM1))
    else if (IFAI == 0) then
      IWAYKM = 4
    else
      J1(KM) = K0(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)
      ICOUP(KM) = ICOUP(KM1)
      COUP1(KM) = Zero
      COUP(KM) = Zero
    end if
  end if
  if (IWAYKM == 4) then
    ! (PP+,LL+)
    IWAY(KM) = 5
    if ((K3(IT1+J1(KM1)) == 0) .or. (K3(IT2+J2(KM1)) == 0)) then
      IWAYKM = 5
    else if (K3F(JM1(KM1)) /= 0) then
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K3(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K3F(JM1(KM1))
      if (K3F(JM(KM1)) /= 0) then
        COUP(KM) = COUP(KM1)
        JM(KM) = K3F(JM(KM1))
      end if
    else if (K3F(JM(KM1)) /= 0) then
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K3(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP(KM) = COUP(KM1)
      JM(KM) = K3F(JM(KM1))
    else if (IFAI == 0) then
      IWAYKM = 5
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K3(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP1(KM) = Zero
      COUP(KM) = Zero
    end if
  end if
  if (IWAYKM == 5) then
    ! (OR+,QJ+)
    IWAY(KM) = 6
    if ((K2(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 6
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      WMP = -BL2(IB(J2(KM1)))/(IB(J2(KM1))+1)
      if (K1F(JM(KM1)) == 0) then
        WPP = Zero
        JM(KM) = K2F(JM1(KM1))
      else
        WPP = BL1(IB(J2(KM1))+2)/(IB(J2(KM1))+1)
        JM(KM) = K1F(JM(KM1))
      end if
      COUP(KM) = WMP*COUP1(KM1)+WPP*COUP(KM1)
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 6
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      WPP = BL1(IB(J2(KM1))+2)/(IB(J2(KM1))+1)
      JM(KM) = K1F(JM(KM1))
      COUP(KM) = WPP*COUP(KM1)
    end if
  end if
  if (IWAYKM == 6) then
    ! (RO+,JQ+)
    IWAY(KM) = 7
    if ((K1(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 7
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      WMM = -BL2(IB(J2(KM1)))/(IB(J2(KM1))+1)
      if (K1F(JM(KM1)) == 0) then
        WPM = Zero
        JM1(KM) = K2F(JM1(KM1))
      else
        WPM = BL1(IB(J2(KM1))+2)/(IB(J2(KM1))+1)
        JM1(KM) = K1F(JM(KM1))
      end if
      COUP1(KM) = WMM*COUP1(KM1)+WPM*COUP(KM1)
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 7
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      WPM = BL1(IB(J2(KM1))+2)/(IB(J2(KM1))+1)
      JM1(KM) = K1F(JM(KM1))
      COUP1(KM) = WPM*COUP(KM1)
    end if
  end if
  if (IWAYKM == 7) ISTOP = 1
else
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    ! (QN+,KR+)
    IWAY(KM) = 2
    if ((K2(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else if (K1F(JM1(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM) = -COUP1(KM1)/(IB(J2(KM1))-1)
      JM1(KM) = K1F(JM1(KM1))
      if (K2F(JM1(KM1)) /= 0) then
        COUP(KM) = COUP1(KM1)/(IB(J2(KM1))+1)
        JM(KM) = K2F(JM1(KM1))
      end if
    else if (K2F(JM1(KM1)) == 0) then
      IWAYKM = 2
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM) = COUP1(KM1)/(IB(J2(KM1))+1)
      JM(KM) = K2F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 2) then
    ! IM+
    IWAY(KM) = 3
    if ((K0(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else if (K0F(JM1(KM1)) == 0) then
      IWAYKM = 3
    else
      J1(KM) = K0(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)
      ICOUP(KM) = ICOUP(KM1)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K0F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 3) then
    ! JN+
    IWAY(KM) = 4
    if ((K1(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 4
    else if (K1F(JM1(KM1)) == 0) then
      IWAYKM = 4
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM) = -BL1(IB(J2(KM1)))*COUP1(KM1)
      JM1(KM) = K1F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 4) then
    ! KO+
    IWAY(KM) = 5
    if ((K2(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 5
    else if (K2F(JM1(KM1)) == 0) then
      IWAYKM = 5
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP1(KM) = -BL2(IB(J2(KM1)))*COUP1(KM1)
      JM1(KM) = K2F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 5) then
    ! LP+
    IWAY(KM) = 6
    if ((K3(IT1+J1(KM1)) == 0) .or. (K3(IT2+J2(KM1)) == 0)) then
      IWAYKM = 6
    else if (K3F(JM1(KM1)) == 0) then
      IWAYKM = 6
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K3(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K3F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 6) ISTOP = 1
end if

return

end subroutine LOOP23

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine permvb2_cvb(v1,iperm,vb,iapr,ixapr,
     >  xalf,xbet,mingrph,maxgrph,
     >  nk,locc,lunocc,inewocc,inocc2,negs,
     >  inda,phsa,indb,phsb,v2,ialg)
      implicit real*8 (a-h,o-w,y-z),integer(x)
      logical vb
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension iperm(norb)
      dimension iapr(ndetvb),ixapr(nda+1)
      dimension xalf(0:norb,0:nalf),xbet(0:norb,0:nbet)
      dimension mingrph(0:norb),maxgrph(0:norb)
      dimension nk(0:norb),locc(norb+1),lunocc(norb+1)
      dimension inewocc(norb),inocc2(norb),negs(norb)
      dimension inda(nda),phsa(nda),indb(ndb),phsb(ndb)
c  V1 is dimensioned either NDET or NDETVB according to CI/VB
c  V2 is dimensioned NDET/NDA or NDETVB according to CI/VB
      dimension v1(*),v2(*)

c  Some tests of permutation
c  Valid ?
      call izero(negs,norb)
      do 10 i=1,norb
      iprm=abs(iperm(i))
      if(iprm.lt.1.or.iprm.gt.norb)then
        write(6,*)' Illegal orbital permutation!'
        call abend_cvb()
      endif
      negs(iprm)=negs(iprm)+1
10    continue
      do 20 iorb=1,norb
      if(negs(iorb).ne.1)then
        write(6,*)' Illegal orbital permutation!'
        call abend_cvb()
      endif
20    continue
c  Return if identity
      do 30 iorb=1,norb
      if(iperm(iorb).ne.iorb)goto 35
30    continue
      return
35    continue
c  Use IALG=2 if only phase changes
      do 40 iorb=1,norb
      if(abs(iperm(iorb)).ne.iorb)goto 45
40    continue
      ialg=2
45    continue
      call izero(negs,norb)
      do 50 i=1,norb
      if(iperm(i).lt.0)negs(abs(iperm(i)))=1
50    continue
c Alpha loop:
      call izero(inocc2,norb)
      do 100 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nalf,0)
      maxgrph(iorb)=min(iorb,nalf)
100   continue
      call weight_cvb(xalf,mingrph,maxgrph,nalf,norb)
      call imove_cvb(maxgrph,nk,norb+1)
      call occupy_cvb(nk,norb,locc,lunocc)
      index=1
200   continue
      call izero(inewocc,norb)
      do 225 ialf=1,nalf
      inewocc(abs(iperm(locc(ialf))))=ialf
225   continue
      ineg=0
      ia=0
      do 250 iorb=1,norb
      if(inewocc(iorb).ne.0)then
        ia=ia+1
        inocc2(ia)=inewocc(iorb)
        inewocc(iorb)=1
        if(negs(iorb).eq.1)ineg=ineg+1
      endif
250   continue
      if(mod(ineg,2).eq.0)then
        phsa(index)= party_cvb(inocc2,nalf)
      else
        phsa(index)=-party_cvb(inocc2,nalf)
      endif
      inda(index)=indget_cvb(inewocc,nalf,norb,xalf)

      call loind_cvb(norb,nalf,nk,mingrph,maxgrph,
     >                       locc,lunocc,index,xalf,*200)
c Beta loop:
      call izero(inocc2,norb)
      do 400 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nbet,0)
      maxgrph(iorb)=min(iorb,nbet)
400   continue
      call weight_cvb(xbet,mingrph,maxgrph,nbet,norb)
      call imove_cvb(maxgrph,nk,norb+1)
      call occupy_cvb(nk,norb,locc,lunocc)
      index=1
500   continue
      call izero(inewocc,norb)
      do 525 ibet=1,nbet
      inewocc(abs(iperm(locc(ibet))))=ibet
525   continue
      ineg=0
      ib=0
      do 550 iorb=1,norb
      if(inewocc(iorb).ne.0)then
        ib=ib+1
        inocc2(ib)=inewocc(iorb)
        inewocc(iorb)=1
        if(negs(iorb).eq.1)ineg=ineg+1
      endif
550   continue
      if(mod(ineg,2).eq.0)then
        phsb(index)= party_cvb(inocc2,nbet)
      else
        phsb(index)=-party_cvb(inocc2,nbet)
      endif
      indb(index)=indget_cvb(inewocc,nbet,norb,xbet)

      call loind_cvb(norb,nbet,nk,mingrph,maxgrph,
     >                       locc,lunocc,index,xbet,*500)

      if(vb)then
        call fzero(v2,ndetvb)
        do 1000 ia=1,nda
        iato=inda(ia)
        do 1001 ixa=ixapr(ia),ixapr(ia+1)-1
        ib=iapr(ixa)
        ibto=indb(ib)
        do 1100 ixato=ixapr(iato),ixapr(iato+1)-1
        if(iapr(ixato).eq.ibto)goto 1200
1100    continue
c  Shouldn't get here ...
        write(6,'(a,100i3)')
     >    ' Error, VB determinants not closed under permutation :',iperm
        call abend_cvb()
1200    continue
        v2(ixa)=phsa(ia)*phsb(ib)*v1(ixato)
1001    continue
1000    continue
        call fmove_cvb(v2,v1,ndetvb)
      elseif(ialg.eq.1)then
c  Brute force strategy if enough memory (x1.5 faster) :
        do 2000 ib=1,ndb
        iboff=(ib-1)*nda
        inboff=(indb(ib)-1)*nda
        do 2001 ia=1,nda
        v2(ia+iboff)=phsa(ia)*phsb(ib)*v1(inda(ia)+inboff)
2001    continue
2000    continue
        call fmove_cvb(v2,v1,ndet)
      elseif(ialg.eq.2)then
c  More-or-less in-place update of V1 :
        do 3000 ia=1,nda
        if(ia.eq.inda(ia))then
          if(phsa(ia).eq.-one)then
            ioffs=ia-nda
            do 3100 ib=1,ndb
            v1(ib*nda+ioffs)=-v1(ib*nda+ioffs)
3100        continue
          endif
        elseif(inda(ia).ne.0)then
c  Cyclic permutation involving IA :
          ioffs=ia-nda
          do 3300 ib=1,ndb
          v2(ib)=v1(ib*nda+ioffs)
3300      continue
          iat=ia
3400      continue
          if(phsa(iat).eq.one)then
            ioffs1=iat-nda
            ioffs2=inda(iat)-nda
            do 3500 ib=1,ndb
            v1(ib*nda+ioffs1)=v1(ib*nda+ioffs2)
3500        continue
          else
            ioffs1=iat-nda
            ioffs2=inda(iat)-nda
            do 3600 ib=1,ndb
            v1(ib*nda+ioffs1)=-v1(ib*nda+ioffs2)
3600        continue
          endif
          iatold=iat
          iat=inda(iat)
          inda(iatold)=0
          if(inda(iat).ne.ia)goto 3400
          if(phsa(iat).eq.one)then
            ioffs=iat-nda
            do 3700 ib=1,ndb
            v1(ib*nda+ioffs)=v2(ib)
3700        continue
          else
            ioffs=iat-nda
            do 3800 ib=1,ndb
            v1(ib*nda+ioffs)=-v2(ib)
3800        continue
          endif
          inda(iat)=0
        endif
3000    continue
        do 4000 ib=1,ndb
        if(ib.eq.indb(ib))then
          if(phsb(ib).eq.-one)then
            ioffs=(ib-1)*nda
            do 4100 ia=1,nda
            v1(ia+ioffs)=-v1(ia+ioffs)
4100        continue
          endif
        elseif(indb(ib).ne.0)then
c  Cyclic permutation involving IB :
          ioffs=(ib-1)*nda
          do 4300 ia=1,nda
          v2(ia)=v1(ia+ioffs)
4300        continue
          ibt=ib
4400      continue
          if(phsb(ibt).eq.one)then
            ioffs1=(ibt-1)*nda
            ioffs2=(indb(ibt)-1)*nda
            do 4500 ia=1,nda
            v1(ia+ioffs1)=v1(ia+ioffs2)
4500        continue
          else
            ioffs1=(ibt-1)*nda
            ioffs2=(indb(ibt)-1)*nda
            do 4600 ia=1,nda
            v1(ia+ioffs1)=-v1(ia+ioffs2)
4600        continue
          endif
          ibtold=ibt
          ibt=indb(ibt)
          indb(ibtold)=0
          if(indb(ibt).ne.ib)goto 4400
          if(phsb(ibt).eq.one)then
            ioffs=(ibt-1)*nda
            do 4700 ia=1,nda
            v1(ia+ioffs)=v2(ia)
4700        continue
          else
            ioffs=(ibt-1)*nda
            do 4800 ia=1,nda
            v1(ia+ioffs)=-v2(ia)
4800        continue
          endif
          indb(ibt)=0
        endif
4000    continue
      endif
      return
      end
c  **********************************
c  ** Routines involving CI and VB **
c  **********************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
*               1994, Luis Seijo                                       *
************************************************************************
      SubRoutine SROInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of MP integrals.          *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by ECPMem                 *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, and Luis Seijo, Dept. of Applied Phys-  *
*             ical Chemistry, the Free University of Madrid, Spain,    *
*             September '94.                                           *
************************************************************************
      use Basis_Info
      use Center_Info
      use Real_Spherical
      use Symmetry_Info, only: nIrrep, iChTbl
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables
      Real*8 C(3), TC(3)
      Integer iDCRT(0:7), iTwoj(0:7)
      Character*80 Label
      Logical EQ
      Data iTwoj/1,2,4,8,16,32,64,128/
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 191
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In SROInt: A',' ',A,1,3)
         Call RecPrt(' In SROInt: RB',' ',RB,1,3)
         Call RecPrt(' In SROInt: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In SROInt: P',' ',P,nZeta,3)
         Write (6,*) ' In SROInt: la,lb=',' ',la,lb
      End If
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
      llOper = lOper(1)
      iComp = 1
      mdc = 0
      Do iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%ECP .or. dbsc(iCnttp)%nSRO.le.0) Then
            mdc = mdc + dbsc(iCnttp)%nCntr
            Cycle
         End If
         Do iCnt = 1,dbsc(iCnttp)%nCntr
            C(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
         Do lDCRT = 0, nDCRT-1
            Call OA(iDCRT(lDCRT),C,TC)
            Do iAng = 0, dbsc(iCnttp)%nSRO-1
               iShll = dbsc(iCnttp)%iSRO + iAng
               nExpi = Shells(iShll)%nExp
               If (nExpi.eq.0) Cycle
*
*
               ip = 1
               ipC = ip
               ip = ip + nExpi**2
*
               If (iPrint.ge.49)
     &            Call RecPrt(' The Akl matrix',' ',
     &                        Shells(iShll)%Akl(1,1,1),
     &                        nExpi,nExpi)
               call dcopy_(nExpi**2,Shells(iShll)%Akl(1,1,1),1,
     &                                    Array(ipC),1)
               If (EQ(A,RB).and.EQ(A,TC).and.dbsc(iCnttp)%NoPair) Then
                  If (iPrint.ge.49)
     &               Call RecPrt(' The Adl matrix',' ',
     &                           Shells(iShll)%Akl(1,1,2),
     &                           nExpi,nExpi)
                  Call DaXpY_(nExpi**2,One,
     &                                       Shells(iShll)%Akl(1,1,2),1,
     &                                       Array(ipC),1)
               End If
*
               ipF1 = ip
               nac = nElem(la)*nElem(iAng)
               ip = ip + nAlpha*nExpi*nac
               ipP1 = ip
               ip = ip + 3 * nAlpha*nExpi
               ipZ1 = ip
               ip = ip + nAlpha*nExpi
               ipK1 = ip
               ip = ip + nAlpha*nExpi
               ipZI1 = ip
               ip = ip + nAlpha*nExpi
               If (ip-1.gt.nArr*nZeta) Then
                  Call WarningMessage(2,'SROInt: ip-1.gt.nArr*nZeta(1)')
                  Write (6,*) ' nArr, nZeta=',nArr, nZeta
                  Write (6,*) ' nac, nAlpha=', nac, nAlpha
                  Write (6,*) ' nExpi=',nExpi
                  Call Abend()
               End If
               mArr = (nArr*nZeta-(ip-1))/nZeta
*
*--------------Calculate Effective center and exponent for <A|alm>
*
               Call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,nExpi,
     &                   Alpha,Shells(iShll)%Exp)
               Call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,
     &                     A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))
*
*--------------Calculate Overlap <A|alm>
*
               nHer = (la+iAng+2)/2
               Call MltPrm(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,
     &                   Array(ipZ1),Array(ipZI1),
     &                   Array(ipK1),Array(ipP1),
     &                   Array(ipF1),nAlpha*nExpi,iComp,
     &                   la,iAng,A,TC,nHer,Array(ip),
     &                   mArr,CCoor,nOrdOp)
               If (iPrint.ge.99) Call RecPrt('<a|srbs>',' ',
     &                   Array(ipF1),nAlpha*nExpi,nac)
               ip = ip - 6 * nAlpha*nExpi
*
               ipF2 = ip
               ncb = nElem(iAng)*nElem(lb)
               ip = ip + nExpi*nBeta*ncb
               ipP2 = ip
               ip = ip + 3 * nExpi*nBeta
               ipZ2 = ip
               ip = ip + nExpi*nBeta
               ipK2 = ip
               ip = ip + nExpi*nBeta
               ipZI2 = ip
               ip = ip + nExpi*nBeta
               If (ip-1.gt.nArr*nZeta) Then
                  Call WarningMessage(2,'SROInt: ip-1.gt.nArr*nZeta(2)')
                  Call Abend()
               End If
               mArr = (nArr*nZeta-(ip-1))/nZeta
*
*--------------Calculate Effective center and exponent for <blm|B>
*
               Call ZXia(Array(ipZ2),Array(ipZI2),nExpi,nBeta,
     &                   Shells(iShll)%Exp,Beta)
               Call SetUp1(Shells(iShll)%Exp,nExpi,Beta,nBeta,
     &                    TC,RB,Array(ipK2),Array(ipP2),Array(ipZI2))
*
*--------------Calculate Overlap <blm|B>
*
               nHer = (iAng+lb+2)/2
               Call MltPrm(Shells(iShll)%Exp,nExpi,Beta,nBeta,
     &                   Array(ipZ2),Array(ipZI2),
     &                   Array(ipK2),Array(ipP2),
     &                   Array(ipF2),nExpi*nBeta,iComp,
     &                   iAng,lb,TC,RB,nHer,Array(ip),
     &                   mArr,CCoor,nOrdOp)
               If (iPrint.ge.99) Call RecPrt('<srbs|b>',' ',
     &                   Array(ipF2),nExpi*nBeta,ncb)
               ip = ip - 6 * nExpi*nBeta
               ipTmp = ip
               ip = ip + Max(nAlpha*nExpi*nac,
     &                       nExpi*nBeta*ncb)
               If (ip-1.gt.nArr*nZeta) Then
                  Call WarningMessage(2,'SROInt: ip-1.gt.nArr*nZeta(3)')
                  Call Abend()
               End If
*
*--------------Calculate Contraction over the spectral resolvent basis
*              set of the type <A|alm>A(l;ab)<blm|B> where we now have in
*              Array(ipF1) the cartesian components of <A|alm>, and
*              similarily, in Array(ipF2), we have stored the cartesian
*              components of <alm|B>. Observe that as opposed to the
*              projection operator that this contraction is done in the
*              primitive basis.
*
*--------------From the lefthandside overlap, form ikaC from ikac by
*              1) ika,c -> c,ika
*
               Call DgeTMo(Array(ipF1),nAlpha*nExpi*nElem(la),
     &                     nAlpha*nExpi*nElem(la),
     &                     nElem(iAng),Array(ipTmp),nElem(iAng))
*
*--------------2) ika,C = c,ika * c,C
*
               Call DGEMM_('T','N',
     &                     nAlpha*nExpi*nElem(la),
     &                     (2*iAng+1),nElem(iAng),
     &                     1.0d0,Array(ipTmp),nElem(iAng),
     &                     RSph(ipSph(iAng)),nElem(iAng),
     &                     0.0d0,Array(ipF1),
     &                     nAlpha*nExpi*nElem(la))
               If (iPrint.ge.99) Call RecPrt('<A|srbs>',' ',
     &                   Array(ipF1),nAlpha*nExpi,
     &                   nElem(la)*(2*iAng+1))
*
*--------------And (almost) the same thing for the righthand side, form
*              kjCb from kjcb
*-------------1) kj,cb -> cb,kj
*
               Call DgeTMo(Array(ipF2),
     &                     nBeta*nExpi,nBeta*nExpi,
     &                     nElem(iAng)*nElem(lb),Array(ipTmp),
     &                     nElem(iAng)*nElem(lb))
*
*--------------2) bkj,C = c,bkj * c,C
*
               Call DGEMM_('T','N',
     &                  nElem(lb)*nExpi*nBeta,
     &                  (2*iAng+1),nElem(iAng),
     &                  1.0d0,Array(ipTmp),nElem(iAng),
     &                  RSph(ipSph(iAng)),nElem(iAng),
     &                  0.0d0,Array(ipF2),nElem(lb)*nExpi*nBeta)
*
*--------------3) b,kjC -> kjC,b
*
               Call DgeTMo(Array(ipF2),nElem(lb),nElem(lb),
     &                     nExpi*nBeta*(2*iAng+1),Array(ipTmp),
     &                     nExpi*nBeta*(2*iAng+1))
               call dcopy_(nExpi*nBeta*(2*iAng+1)*nElem(lb),
     &                    Array(ipTmp),1,Array(ipF2),1)
               If (iPrint.ge.99) Call RecPrt('<srbs|B>',' ',
     &                   Array(ipF2),nExpi*nBeta,
     &                   (2*iAng+1)*nElem(lb))
*
*--------------Next Contract (ikaC)*(klC)*(ljCb) over k,l and C,
*              producing ijab,
*              by the following procedure:
*              Loop over a and b
*                Loop over C
*                  Contract ik(aC)*kl(C), over k producing il(aC),
*                  Contract il(aC)*lj(Cb), over l producing ij(aCb)
*                    accumulate to ij(ab)
*                End loop C
*              End Loop b and a
*
               Do ib = 1, nElem(lb)
                  Do ia = 1, nElem(la)
                  If (iPrint.ge.99) Write (6,*) ' ia,ib=',ia,ib
*
                     Do iC = 1, (2*iAng+1)
                        If (iPrint.ge.99) Write (6,*) ' iC,=',iC
                        iaC = (iC-1)*nElem(la) + ia
                        ipaC = (iaC-1)*nAlpha*nExpi + ipF1
                        iCb = (ib-1)*(2*iAng+1) + iC
                        ipCb = (iCb-1)*nExpi*nBeta  + ipF2
*
                        iIC = 0
                        If (iPrint.ge.99) Then
                           Call RecPrt('<ia|iC>',' ',Array(ipaC),
     &                                  nAlpha,nExpi)
                           Call RecPrt('<iC|ib>',' ',Array(ipCb),
     &                                  nExpi,nBeta)
                        End If
                        Do iIrrep = 0, nIrrep-1
                           If (iAnd(llOper,iTwoj(iIrrep)).eq.0) Cycle
                           If (iPrint.ge.99) Write (6,*) ' iIC=',iIC
                           iIC = iIC + 1
                           nOp = NrOpr(iDCRT(lDCRT))
                           Xg=DBLE(iChTbl(iIrrep,nOp         ))
                           Factor=Xg*Fact
                           Call DGEMM_('N','N',
     &                                nAlpha,nExpi,nExpi,
     &                                One,Array(ipaC),nAlpha,
     &                                  Array(ipC),nExpi,
     &                                Zero,Array(ipTmp),nAlpha)
                           Call DGEMM_('N','N',
     &                                nAlpha,nBeta,nExpi,
     &                                Factor,Array(ipTmp),nAlpha,
     &                                    Array(ipCb),nExpi,
     &                                One,Final(1,ia,ib,iIC),nAlpha)
                        End Do
*
                     End Do
                  End Do
               End Do
*
            End Do
         End Do
         End Do
         mdc = mdc + dbsc(iCnttp)%nCntr
      End Do
*
      If (iPrint.ge.99) Then
         Write (6,*) ' Result in SROInt'
         Do ia = 1, (la+1)*(la+2)/2
            Do ib = 1, (lb+1)*(lb+2)/2
               Write (Label,'(A,I2,A,I2,A)')
     &               ' Final(',ia,',',ib,')'
               Call RecPrt(Label,' ',Final(1,ia,ib,1),nAlpha,nBeta)
            End Do
         End Do
      End If
*
*     Call GetMem(' Exit SROInt','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Zeta)
         Call Unused_real_array(ZInv)
         Call Unused_real_array(rKappa)
         Call Unused_integer(nRys)
         Call Unused_integer_array(iChO)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ChCar(iChCar,iGen,nGen)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: iChCar(3)
integer(kind=iwp), intent(in) :: nGen, iGen(nGen)
integer(kind=iwp) :: i, iCar

! Generate characteristics for x, y, and z.

do iCar=1,3
  iChCar(iCar) = 0
  do i=1,nGen
    if (btest(iGen(i),iCar-1)) then
      iChCar(iCar) = 2**(iCar-1)
      exit
    end if
  end do
end do

return

end subroutine ChCar

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine IniReord(NaGrp,NaSGrp,NchBlk,LunAux)
! nacitanie vsupu a inicializacia premnennych
! a tlac primitivnej hlavicky pre Reord procesz

use chcc_global, only: conv, generkey, intkey, JoinLkey, maxiter, maxGrp, maxSGrp, mhkey, nc, nfr, no, nv, printkey, restkey, &
                       W34DistKey
#ifdef _MOLCAS_MPP_
use chcc_global, only: NChLoc
use Para_Info, only: nProcs
#endif
use spool, only: Close_LuSpool, Spoolinp
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: NaGrp, NaSGrp, NchBlk, LunAux
integer(kind=iwp) :: intkey1, intkey2, LuSpool, NchBlk_tmp, NChLoc_max, NChLoc_min, nDel(8), ndelvirt, nFro(8), nOcc(8), nOrb(8)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: jal1
#endif
character(len=80) :: LINE
character(len=3) :: msg

! setup defaults

call Get_iArray('nBas',nOrb,1) ! must read always nBas!!
call Get_iArray('nIsh',nOcc,1)
call Get_iArray('nFroPT',nFro,1) ! = 'nFro' in previous step
call Get_iArray('nDelPT',nDel,1) ! = 'nDel' in previous step

#ifdef _MOLCAS_MPP_
!mp get min/max
NChLoc_min = nc
NChLoc_max = 0
do jal1=0,Nprocs-1
  if (NChLoc(jal1) <= NChLoc_min) NChLoc_min = NChLoc(jal1)
  if (NChLoc(jal1) >= NChLoc_max) NChLoc_max = NChLoc(jal1)
end do

!mp calc reasonable starting value (200-300)
if (NChLoc_min /= NChLoc_max) then
  NChBlk = int(NChLoc_min/2)
else
  NChBlk = NChLoc_min
end if

if (NChBlk >= 300) NChBlk = min(200,int(NChBlk/2))

!mp fix num of ChV blocks to be less then 100
if (int(NChLoc_max/NChBlk) >= 100) NChBlk = int(NChLoc_max/100)-1
#else
NChLoc_max = nc
!mp calc reasonable starting value (200-300)
if (nc >= 300) then
  NChBlk = min(200,nc/2)
else
  NChBlk = nc
end if

NChLoc_min = NChBlk
!mp fix num of ChV blocks to be less then 100
if (int(nc/NChBlk) >= 100) NChBlk = int(nc/100)-1
#endif

nfr = nFro(1)
no = nOcc(1)-nFro(1)
ndelvirt = nDel(1)

nv = nOrb(1)-nDel(1)-nOcc(1) ! nOrb defined as = to nBas, right!

LunAux = 13
mhkey = 1
generkey = 1
intkey1 = 0
intkey2 = 0

NaGrp = 0
NaSGrp = 0
W34DistKey = 1
JoinLkey = 2 ! toto este nemam domyslene
restkey = 0
conv = 1.0e-6_wp
printkey = 1
maxiter = 40

!mp read input file

LuSpool = 17
call SpoolInp(LuSpool)
rewind(LuSpool)
do
  read(LuSpool,'(A80)') LINE
  call UPCASE(LINE)
  if (index(LINE,'&CHCC') /= 0) exit
end do
do
  read(LuSpool,'(A80)') LINE
  if (LINE(1:1) == '*') cycle
  call UPCASE(LINE)

  select case (LINE(1:4))

    case ('TITL')
      read(LuSpool,*)

    case ('FROZ')
      read(LuSpool,*) nfr
      if ((nfr < 0) .or. (nfr >= no)) then
        write(u6,*)
        write(u6,*) 'Illegal value for FROZen keyword : ',nfr
        call abend()
      end if
      no = no+nFro(1)-nfr

    case ('DELE')
      read(LuSpool,*) ndelvirt
      if ((ndelvirt < 0) .or. (ndelvirt > nv)) then
        write(u6,*)
        write(u6,*) 'Illegal value for DELETED keyword : ',ndelvirt
        call abend()
      end if
      nv = nv+nDel(1)-ndelvirt

    case ('LARG')
      read(LuSpool,*) NaGrp
      if ((NaGrp < 0) .or. (NaGrp > maxGrp)) then
        write(u6,*)
        write(u6,*) 'Illegal value for LARGE keyword : ',NaGrp
        write(u6,*) 'Large segmentation must be <= ',maxGrp
        call abend()
      end if

    case ('SMAL')
      read(LuSpool,*) NaSGrp
      if ((NaSGrp < 0) .or. (NaSGrp > 8)) then
        write(u6,*)
        write(u6,*) 'Illegal value for SMALL keyword : ',NaSGrp
        write(u6,*) 'Small segmentation must be <= 8'
        call abend()
      end if

      ! large == 0, small != 0 => quit
      if ((NaGrp == 0) .and. (NaSGrp /= 0)) then
        write(u6,*)
        write(u6,*) 'Small segmentation must be specified'
        write(u6,*) 'with large segmentation, or both can'
        write(u6,*) 'be left unspecified'
        call abend()
      end if

      if (NaGrp /= 0) then
        ! large != 0, small == 0 => small = 1
        if (NaSGrp == 0) NaSGrp = 1

        ! large * small <= 64
        if ((NaGrp*NaSGrp) > maxSGrp) then
          write(u6,*)
          write(u6,*) 'Product of Large and Small segmen-'
          write(u6,*) 'tation must be less or equal to ',maxSGrp
          call abend()
        end if
      end if

    case ('CHSE')
      read(LuSpool,*) NchBlk_tmp
      if ((NchBlk_tmp < 1) .or. (NchBlk_tmp > NChLoc_min)) then
        write(u6,*)
        write(u6,*) 'Illegal value for CHSegment keyword  : ',NchBlk_tmp
        write(u6,*) 'Reseting to a reasonable value for    '
        write(u6,*) 'this system :                         ',NchBlk
      else if (int(NChLoc_max/NchBlk_tmp) >= 100) then
        write(u6,*) 'Number of block of the MO Cholesky vector'
        write(u6,*) 'exceeded the limit. Increasing value of  '
        write(u6,*) 'the CHSEgmentation keyword to : ',NchBlk
      else
        NchBlk = NchBlk_tmp
      end if

    !mp case ('LUNA')  ... toto sa nikdy nevyuzivalo
    !mp   read(LuSpool,*) LunAux

    case ('MHKE')
      read(LuSpool,*) mhkey
      if ((mhkey < 0) .or. (mhkey > 2)) then
        mhkey = 1
        write(u6,*)
        write(u6,*) ' Warning!!!  Matrix handling key out of range'
        write(u6,*) ' parameter mhkey changed to 1'
      end if

    case ('NOGE')
      generkey = 0

    case ('ONTH')
      intkey1 = 1

    case ('PREC')
      intkey2 = 1

    case ('NODI')
      W34DistKey = 0

    case ('JOIN')
      read(LuSpool,*) JoinLkey
      if ((JoinLkey < 0) .or. (JoinLkey > 3)) then
        write(u6,*)
        write(u6,*) 'Illegal value for Join keyword : ',JoinLkey
        write(u6,*) 'Use one of 0, 1, 2, 3'
        write(u6,*) 'For details, see the manual ...'
        call abend()
      end if

    case ('MAXI')
      read(LuSpool,*) maxiter
      if (maxiter <= 0) then
        write(u6,*)
        write(u6,*) 'Illegal value of the MAXITER keyword: ',maxiter
        write(u6,*) 'Use integer > 0'
        call abend()
      end if

    case ('REST')
      restkey = 1
      write(u6,*)
      write(u6,*) 'This option is temporary disabled'
      write(u6,*) 'No Restart possible (... yet).'
      call abend()

    case ('THRE')
      read(LuSpool,*) conv

    case ('PRIN')
      read(LuSpool,*) printkey
      if (((printkey < 0) .or. (printkey > 10)) .or. ((printkey > 2) .and. (printkey < 10))) then

        write(u6,*)
        write(u6,*) 'Illegal value of the PRINT keyword: ',printkey
        write(u6,*) ' Use: 1  (Minimal) '
        write(u6,*) '      2  (Minimal + Timings)'
        write(u6,*) '      10 (Debug) '
        call abend()
      end if

    case ('END ')
      exit

  end select
end do

call Close_LuSpool(LuSpool)

! take care of the algorithm keyword
if (intkey1 == intkey2) then
  if (intkey1 == 0) then
    write(u6,*)
    write(u6,*) 'None of OnTheFly/PreCalculate'
    write(u6,*) 'algorithm was selected. Using'
    write(u6,*) 'default: PreCalculate (1)'
    intkey = 1
  else
    write(u6,*)
    write(u6,*) 'OnTheFly and PreCalculate keywords'
    write(u6,*) 'are mutually exclusive'
    call abend()
  end if
else
  if (intkey1 == 1) then
    intkey = 0
  else
    intkey = 1
  end if
end if

!2 tlac hlavicky
write(u6,*)
write(u6,*) '    Cholesky Based Closed-Shell CCSD code'
!mp write(u6,*) ' Dedicated to the memory of Boris Jeltzin'
write(u6,*)
write(u6,*) '---------------------------------------------------'

write(u6,'(A,i9)') ' Frozen Orbitals                   : ',nfr
write(u6,'(A,i9)') ' Occupied Orbitals                 : ',no
write(u6,'(A,i9)') ' Virtual Orbitals                  : ',nv
write(u6,'(A,i9)') ' Total number of Cholesky Vectors  : ',nc

write(u6,*) '---------------------------------------------------'

if (NaGrp /= 0) then
  write(u6,'(A,i9)') ' Large Virtual Segmentation        : ',NaGrp
else
  write(u6,'(A,A9)') ' Large Virtual Segmentation        :  auto'
end if

if (NaSGrp /= 0) then
  write(u6,'(A,i9)') ' Small Virtual Segmentation        : ',NaSGrp
else
  write(u6,'(A,A9)') ' Small Vectors Segmentation        :  auto'
end if

write(u6,'(A,i9)') ' Cholesky Vectors Segmentation     : ',NchBlk

write(u6,*) '---------------------------------------------------'

msg = 'No'
if (generkey == 1) msg = 'Yes'

write(u6,'(A,A4)') ' Generate Scratch Files?                : ',msg
write(u6,'(A,i4)') ' Precalculate (1) / On-the-Fly (0) Alg. : ',intkey
write(u6,'(A,i4)') ' 3 and 4-ext. MO integrals distribute?  : ',W34DistKey
write(u6,'(A,i4)') ' Parallel Join of varios MO integrals   : ',JoinLkey

write(u6,*) '---------------------------------------------------'

write(u6,'(A,ES9.2)') ' Convergence Threshold             : ',conv
write(u6,'(A,i9)') ' Maximum number of Iterations      : ',maxiter

write(u6,*) '---------------------------------------------------'

write(u6,'(A,i9)') ' Lun Number for Aux. Matrixes      : ',LunAux
write(u6,'(A,i9)') ' BLAS/FTN Matrix Handling          : ',mhkey

msg = 'No'
if (restkey == 1) msg = 'Yes'

write(u6,'(A,A10)') ' Start from RstFil ?               : ',msg
write(u6,'(A,i9)') ' Print level                       : ',printkey

write(u6,*) '---------------------------------------------------'
write(u6,*)

return

end subroutine IniReord

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               1993, Per Ake Malmqvist                                *
!               Pavel Neogrady                                         *
!***********************************************************************

subroutine RdInpPN(run_triples,run_sort)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     - read input                                                     *
!     - set defaults                                                   *
!                                                                      *
!     calling parameters: none                                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher and P.-AA. Malmqvist                              *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!     reduced by P.N.                                                  *
!                                                                      *
!***********************************************************************

use ccsort_global, only: cckey, clopkey, fullprint, IADR15, iokey, IPT2, ISCF, ISPIN, JOBIPH, LROOT, LSYM, luna1, luna2, luna3, &
                         luna4, lunab, lunda1, lunda2, lunpublic, lunt3, NACTEL, NASH, NASHT, NBAS, NCONF, NDEL, ndelr, nDelX, &
                         NELE3, NFRO, nfror, nFroX, NHOLE1, NISH, NISHT, noop, NORB, NROOTS, NSSH, NSSHT, NSYM, t3key, zrkey
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(out) :: run_triples, run_sort
#include "rasdim.fh"
integer(kind=iwp) :: IAD15, iCmd, IROOT(mxRoot), istatus, isym, jCmd, LROOTS, LuSpool, nhelp, NOSH, NRAS1(8), NRAS2(8), NRAS3(8), &
                     ntAsh, nTit
real(kind=wp) :: POTNUC
character(len=72) :: Header(2), Line, Title(mxTit)
character(len=4) :: Command
real(kind=wp), allocatable :: Weights(:)
character(len=LenIn8), allocatable :: CName(:)
character(len=4), parameter :: Cmd(20) = ['TITL','END ','CCSD','CCT ','CLOS','OPEN','FROZ','DELE','PRIN','NOOP','IOKE','ZROF', &
                                          'DENO','SHIF','ACCU','ADAP','EXTR','TRIP','NOSO','ITER']

!---  Initialize -------------------------------------------------------*
LROOT = 0
nTit = 0

luna1 = 22
luna2 = 23
luna3 = 24
luna4 = 25
lunab = 50
lunt3 = 26
lunda1 = 9
lunda2 = 10
lunpublic = 29

!---  Open JOBIPH file ------------------------------------------------*

! Job interface
JOBIPH = 15
! Job interface
call DANAME(JOBIPH,'JOBIPH')

!---  Read input from JOBIPH file -------------------------------------*
IAD15 = 0
call iDAFILE(JOBIPH,2,IADR15,15,IAD15)
!DIVNUO
IAD15 = IADR15(1)
call mma_allocate(CName,mxOrb,label='CName')
call mma_allocate(Weights,mxRoot,label='Weights')
call WR_RASSCF_Info(JOBIPH,2,iAd15,NACTEL,ISPIN,NSYM,LSYM,NFRO,NISH,NASH,NDEL,NBAS,8,CName,LenIn8*MxOrb,NCONF,Header,2*72,Title, &
                    72*mxTit,POTNUC,LROOTS,NROOTS,IROOT,mxRoot,NRAS1,NRAS2,NRAS3,NHOLE1,NELE3,IPT2,Weights)
call mma_deallocate(CName)
call mma_deallocate(Weights)

! define defaults for REORG

ntAsh = 0
do isym=1,nSym
  ntAsh = ntAsh+nAsh(iSym)
end do
cckey = 1
t3key = 1
clopkey = 1
if (ntAsh == 0) clopkey = 2
ndelr(1:nsym) = NDEL(1:nsym)
nfror(1:nsym) = NFRO(1:nsym)
!GG fullprint = 0
noop = 0
iokey = 1
zrkey = 1
run_triples = .true.
run_sort = .true.

!---  Read input from TRAONE file -------------------------------------*
call RdTraOne()
nFror(1:nSym) = nFroX(1:nSym)
nDelr(1:nSym) = nDelX(1:nSym)

!---  Read input from LuSpool -----------------------------------------*
LuSpool = 17
call SpoolInp(LuSpool)
rewind(LuSpool)
Command = '&REO'
call RdNlst(LuSpool,'CCSDT')
do
  read(LuSpool,'(A)',iostat=istatus) Line
  if (istatus < 0) call Error(1)
  if ((Line(1:1) /= '*') .and. (Line /= '')) exit
end do
Command = Line(1:4)
call UpCase(Command)
jCmd = 0
do iCmd=1,size(Cmd)
  if (Command == Cmd(iCmd)) jCmd = iCmd
end do
if (jCmd == 0) call Error(2)
do
  select case (jCmd)
    case default !(1) !TITL
      !---  process TITLE command -------------------------------------*
      do
        read(LuSpool,'(A)',iostat=istatus) Line
        if (istatus < 0) call Error(1)
        Command = Line(1:4)
        call UpCase(Command)
        if (Command(1:1) == '*') cycle
        jCmd = 0
        do iCmd=1,size(Cmd)
          if (Command == Cmd(iCmd)) jCmd = iCmd
        end do
        if (jCmd /= 0) exit
        if (nTit >= mxTit) cycle
        nTit = nTit+1
        if (nTit <= mxTit) read(Line,'(A72)') Title(nTit)
      end do
    case (2) !END
      exit
    case (3) !CCSD
      !---  CCSD  command ---------------------------------------------*
      cckey = 1
      t3key = 0
      run_triples = .false.
      jCmd = 1
    case (4) !CCT
      !---  CCT  command ----------------------------------------------*
      cckey = 1
      t3key = 1
      run_triples = .true.
      jCmd = 1
    case (5) !CLOS
      !---  CLOSed  command -------------------------------------------*
      clopkey = 2
      jCmd = 1
    case (6) !OPEN
      !---  OPEN  command ---------------------------------------------*
      clopkey = 1
      jCmd = 1
    case (7) !FROZ
      !---  FROZen  command -------------------------------------------*
      read(LuSpool,*) (nfror(nhelp),nhelp=1,nsym)
      jCmd = 1
    case (8) !DELE
      !---  DELEte  command -------------------------------------------*
      read(LuSpool,*) (ndelr(nhelp),nhelp=1,nsym)
      jCmd = 1
    case (9) !PRIN
      !---  PRINt  command --------------------------------------------*
      read(LuSpool,*) fullprint
      jCmd = 1
    case (10) !NOOP
      !---  NOOPeration  command --------------------------------------*
      noop = 1
      jCmd = 1
    case (11) !IOKE
      !---  IOKEy  command --------------------------------------------*
      read(LuSpool,*) iokey
      if ((iokey < 1) .or. (iokey > 2)) iokey = 2
      jCmd = 1
    case (12) !ZROF
      !---  ZROFf  command --------------------------------------------*
      zrkey = 0
      jCmd = 1
    case (19) !NOSO
      !---  NOSOrt  command -------------------------------------------*
      run_sort = .false.
      jCmd = 1
    case (13:18,20) !DENO, SHIF, ACCU, ADAP, EXTR, TRIP, ITER
      !---  DENO  command ---------------------------------------------*
      !---  SHIF  command ---------------------------------------------*
      !---  ACCU  command ---------------------------------------------*
      !---  ADAP  command ---------------------------------------------*
      !---  EXTR  command ---------------------------------------------*
      !---  TRIP  command ---------------------------------------------*
      !---  ITER  command ---------------------------------------------*
      jCmd = 1
  end select
end do

!---  The end of the input section, complete input processing ---------*
NISHT = 0
NASHT = 0
NSSHT = 0
do ISYM=1,NSYM
  NOSH = NISH(ISYM)+NASH(ISYM)
  NSSH(ISYM) = NBAS(ISYM)-NFRO(ISYM)-NOSH-NDEL(ISYM)
  NORB(ISYM) = NOSH+NSSH(ISYM)
  NISHT = NISHT+NISH(ISYM)
  NASHT = NASHT+NASH(ISYM)
  NSSHT = NSSHT+NSSH(ISYM)
end do

!---  Identify the wave function type ---------------------------------*
ISCF = 0
if (NASHT == 0) ISCF = 1
if (NACTEL == 2*NASHT) ISCF = 1
if ((iSpin > 1) .and. (ISPIN == NACTEL+1) .and. (NACTEL == NASHT)) ISCF = 2

! test agreement between REORG input and JOBIPH
!if (clopkey /= (3-ISCF)) then
!  write(u6,*) ' Diference in closed/open specification'
!  write(u6,*) ' Plaese, correct REORG input file'
!  write(u6,*) clopkey,ISCF
!  call Quit(16)
!end if
!
!  Should not be necessary anymore, let's just hardwire it in.
!  This will save a keyword
clopkey = 3-ISCF
!---  Identify the reference function ---------------------------------*
if (ISCF > 0) then
  LROOT = 1
  NROOTS = 1
  IROOT(1) = 1
end if
if ((LROOT == 0) .and. (NROOTS == 1)) LROOT = IROOT(1)

call Close_LuSpool(LuSpool)

!---  Exit ------------------------------------------------------------*
return

contains

!---  Error exits -----------------------------------------------------*
subroutine Error(code)

  integer :: code

  write(u6,*)
  select case (code)
    case (1)
      write(u6,*) ' *** input error ***'
      write(u6,*) ' hitting end of file mark'
    case (2)
      write(u6,*) ' *** input error ***'
      write(u6,*) ' unknown input'
      write(u6,*) ' line: ',Line
  end select
  write(u6,*)
  call Quit_OnUserError()

end subroutine Error

end subroutine RdInpPN

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _MOLCAS_MPP_

module MPI_Wrapper

! This module offers a wrapper around the MPI module.
! Other routines should use this module instead of the bare MPI

use MPI, only: MPI_ADDRESS_KIND, MPI_COMM_WORLD, MPI_INTEGER, MPI_INTEGER4, MPI_INTEGER8, MPI_LOGICAL, MPI_REAL8

implicit none
private

! Not all implementations provide usable interfaces in the old-style MPI module,
! and not all implementations provide an usable MPI_F08 module
! External procedures should forgo TKR checks
external :: MPI_AllGather, MPI_AllGatherV, MPI_AllToAll, MPI_AllToAllV, MPI_Bcast

public :: MPI_ADDRESS_KIND, MPI_COMM_WORLD, MPI_INTEGER, MPI_INTEGER4, MPI_INTEGER8, MPI_LOGICAL, MPI_REAL8
public :: MPI_AllGatherV, MPI_AllToAll, MPI_AllToAllV, MPI_Bcast

end module MPI_Wrapper

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(MPI_Wrapper)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine AdV_A23 (V1,A,dimij,no)
c
c       this routine do:
c       A(ij,u,v) <<- V1(j,iu,v) + V1(i,jv,u)
c
c        Velmi odflaknute, da sa to urobit podstatne lepsie, ale
c        o4 proces osrat fok
c
        implicit none
        integer dimij,no
        real*8 A(1:dimij,1:no,1:no)
        real*8 V1(1:no,1:dimij,1:no)
c
c       help variables
        integer i,j,ij,u,v,iu,jv
c
        do v=1,no
        do u=1,no
c
          ij=0
c
          do i=1,no
          if (i.ge.u) then
          iu=i*(i-1)/2+u
          else
          iu=u*(u-1)/2+i
          end if
c
          do j=1,i
          ij=ij+1
          if (j.ge.v) then
          jv=j*(j-1)/2+v
          else
          jv=v*(v-1)/2+j
          end if
c
            A(ij,u,v)=A(ij,u,v)+V1(j,iu,v)+V1(i,jv,u)
c
          end do
          end do
c
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989-1992, Roland Lindh                                *
*               1990, IBM                                              *
*               1995, Anders Bernhardsson                              *
************************************************************************
      subroutine McKinley(ireturn)
************************************************************************
*                                                                      *
*  Object: Driver for the one and two electron integral second order   *
*          derivative program McKinley.                                *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA     *
*          July '89 - May '90                                          *
*                                                                      *
*          Roland Lindh, Dept. of Theoretical Chemistry, University of *
*          Lund, SWEDEN. Modified to gradient calculations September   *
*          1991 - February 1992.                                       *
*                                                                      *
*          Anders Bernhardsson, Dept. of Theoretical Chemistry,        *
*          University of  Lund, SWEDEN.                                *
*          Modified to  second order derivatives October '94 -         *
*          '95                                                         *
************************************************************************
      use Real_Spherical
      use Basis_Info
      use Temporary_Parameters
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
*
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "disp.fh"
#include "disp2.fh"
#include "cputime.fh"
#include "print.fh"
#include "etwas.fh"
cpcm_solvent
#include "rctfld.fh"
cpcm_solvent end
c      Parameter (nLines=12)
      Character*120 Lines
      Logical DoRys, Run_MCLR
#include "warnings.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Call McKinley_banner()
      Call CWTime(TCpu1,TWall1)
      iRout=1
      call dcopy_(9,[0.0d0],0,CpuStat,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Print program header
*                                                                      *
************************************************************************
*                                                                      *
c      Lines(1)=_MOLCAS_VERSION_
c#ifdef _DEMO_
c      Lines(2)='DEMO VERSION'
c#else
c      Lines(2)=' '
c#endif
c      Lines(3)=' '
c      Lines(4)=Vrsn
c      Lines(5)='A Vectorized Direct Integral Program for derivatives'
c      Lines(6)='of Cartesian and Spherical Harmonic Gaussians'
c      Lines(7)='Written by Anders Bernhardsson and Roland Lindh '
c      Lines(8)='Backtransformation of the 2nd order density matrix '//
c     &         'from MO to SO by Per-AAke Malmqvist'
c      Lines(9)='Dept. of Theoretical Chemistry, '//
c     &          'Chemical Centre, Lund (Sweden)'
c      Lines(10)=' '
c      Lines(11)=' '
c      Lines(12)='Compiled at '//
c     &           _BUILD_DATE_
c      lLine=Len(Lines(1))
C     Call Banner(Lines,nLines,lLine)
*                                                                      *
************************************************************************
*                                                                      *
*     Set error conditions
*
      Call XuFlow()
      Call ErrSet(209,1,1,2,1,209)
*                                                                      *
************************************************************************
*                                                                      *
*     Check if a numerical procedure will be used
*
      Call SuperMac()
*                                                                      *
************************************************************************
*                                                                      *
*
*     Get the input information as Seward dumped on INFO.
*     Set up some info
*     Read input
*
      nDiff=2
      DoRys=.True.
      Call IniSew(DoRys,nDiff)
cpcm_solvent
c check if there is a reaction field
c     write(6,*)'In mckinley PCM',pcm
      Call Init_RctFld(.False.,iCharge_ref)
cpcm_solvent end
      nsAtom=0
      Do  iCnttp = 1, nCnttp
            nsAtom=nsAtom+dbsc(iCnttp)%nCntr
      End Do
      Call Inputh(Run_MCLR)
      iPrint=nPrint(iRout)
      nGrad=0
      Do i=0,nIrrep-1
        nGrad=nGrad+lDisp(i)
      End Do
      Call OpnFls_Mckinley()
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate area for hessian etc
*
      nHess=nGrad*(nGrad+1)/2
*
      Call GetMem('Hess','Allo','Real',ipHess,nHess)
      Call GetMem('Temp','Allo','Real',ipTemp,nHess)
      call dcopy_(nHess,[Zero],0,Work(ipHess),1)
      call dcopy_(nHess,[Zero],0,Work(ipTemp),1)
*                                                                      *
************************************************************************
*                                                                      *
*    Calculate the second order derivatives of the one electron        *
*    integrals and contract with D.                                    *
*                                                                      *
************************************************************************
*                                                                      *
      If (lHss) Then
         If (iPrint.ge.6) Then
         Write(6,*)
         Write(6,'(A,A,A)')
     &    'The 2nd order derivatives of the one-electron',
     &    ' integrals are calculated and contracted with',
     &    ' the one-electron density matrix. '
         Write(6,*)
         End If
         Call Timing(dum1,Time,dum2,dum3)
         Call Drvh2(Work(ipHess),Work(ipTemp),nHess,show)
         Call DrvEtc(nGrad)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*        Compute contribution from the nuclear repulsion.              *
*                                                                      *
************************************************************************
*                                                                      *
      If (lHss) Then
         Call DrvN2(Work(ipTemp),nGrad)
         If (SHOW) Call HssPrt(Work(ipTemp),nHess)
         Call DaXpY_(nHess,One,Work(ipTemp),1,Work(ipHess),1)
         If (Show) Call HssPrt(Work(ipHess),nHess)
      End If
      If (lGrd) Then
          Call GetMem('Gradn','Allo','Real',ipGradn,nGrad)
          Call DrvN1_mck(Work(ipGradn),nGrad)
          iopt=0
          irc=-1
          Call dWrMCK(iRC,iOpt,'NUCGRAD',1,Work(ipGradn),1)
          If (irc.ne.0) Call SysAbendMsg('mckinley','Error in writing',
     &                                   'Option=NUCGRAD')
          Call GetMem('Gradn','Free','Real',ipGradn,nGrad)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*       Calculate the first order derivatives of the one electron      *
*       integrals and store on disc in file MCKINT                     *
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.6) Then
      Write(6,*)
      Write(6,'(A,A)')
     &          'The 1st order derivatives of the one-electron ',
     &          'integrals are calculated and stored on disk'
      Write(6,*)
      End If
      Call Drvh1_mck(nGrad,Nona)
*
************************************************************************
*                                                                      *
*      Calculate two electron integrals. First order is contracted     *
*      to Fock matrixes and MO (IJKl) on the fly. Second order         *
*      derivatives are contracted with P.                              *
*      Derivatives are stored in MCKINT.                               *
*                                                                      *
************************************************************************
*                                                                      *
      nhess=ngrad*(ngrad+1)/2
      Call Timing(dum1,Time,dum2,dum3)
      CPUStat(nOneel)=CPUStat(nOneel)+Time
      If (.Not.Onenly) Then
          Call GetMem('Grad','ALLO','Real',ipGrad,nGrad)
          call dcopy_(nGrad,[Zero],0,Work(ipGrad),1)
*
          Call ICopy(8,[0],0,nISh,1)
          Call ICopy(8,[0],0,nASh,1)
*
          Call PrepP
*
          iOpt = 0
          iRC = -1
          Call iWrMck(iRC,iOpt,'NISH',1,nish,iDummer)
          If (iRC.ne.0) Then
             Write (6,*) 'Mckinley: Error writing to MckInt!'
             Call Abend()
          End If
          iOpt = 0
          iRC = -1
          Call iWrMck(iRC,iOpt,'NASH',1,nash,iDummer)
          If (iRC.ne.0) Then
             Write (6,*) 'Mckinley: Error writing to MckInt!'
             Call Abend()
          End If
*
*
*         Call GetMem(' LIST ','LIST','REAL',iDum,iDum)

          Call Drvg2(Work(ipTemp),nhess, lGrd,lHss)
*
          Call GetMem('Grad','Free','Real',ipGrad,nGrad)
          Call CloseP
*
          If (lHss) Then
             Call GADSum(Work(ipTemp),nHess)
             Call DScal_(nHess,Half,Work(ipTemp),1)
             If (Show) Call HssPrt(Work(ipTemp),nHess)
*
*----------- Accumulate contribution to the hessian!
*
             Call DaXpY_(nhess,One,Work(ipTemp),1,
     &                  Work(ipHess),1)
*
             If (Show) Then
                Call Banner('Complete static Hessian',1,23)
                Call HssPrt(Work(ipHess),nHess)
             End If
             Call WrHDsk(Work(ipHess),ngrad)
          End If
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*...  Close 'MCKINT' file
      iRc=-1
      iOpt=0
      Call ClsMck(iRC,iOpt)
      If ( iRc.ne.0 ) Then
         Write (6,*) 'McKinley: Error closing MCKINT!'
         Call Abend()
      End If
      Call GetMem('Temp','Free','Real',ipTemp,nHess)
      Call GetMem('Hess','Free','Real',ipHess,nHess)
*
      Call ClsSew
*                                                                      *
************************************************************************
*                                                                      *
*     Epilogue
*
      Lines='All data is written to disk, and could be accessed '//
     &         'through the MCLR or RASSI program.'
      lLine=Len(Lines)
      Call Banner(Lines,1,lLine)
*
      Call CWTime(TCpu2,TWall2)
      Call SavTim(5,TCpu2-TCpu1,TWall2-TWall1)
*
C     Call DaTimm
      Call Timing(Time,dum,dum,dum)
      CPUStat(nTotal)=Time
      If (iPrint.ge.6) Call Sttstc
      If (Test) Then
         ireturn=_RC_INPUT_ERROR_
      Else
         Call Request_MCLR_Run(Run_MCLR,ireturn,iPrint)
      End If
*
      Return
      End
      Subroutine Request_MCLR_Run(Run_MCLR,ireturn,iPrint)
      Logical Run_MCLR
      Character*16 StdIn
#include "warnings.fh"
*
      If (Run_MCLR) Then
*
*        McKinley will automatically generate the input for MCLR
*        and signal to AUTO (iRC=2) to run the input file Stdin.x.
*
         If (iPrint.ge.6) Then
         Write (6,*)
         Write (6,*)
     &     ' McKinley requests the MCLR module to be executed!'
         Write (6,*)
         End If
*
         LuInput=11
         LuInput=IsFreeUnit(LuInput)
         Call StdIn_Name(StdIn)
         Call Molcas_Open(LuInput,StdIn)
         Write (LuInput,'(A)') ' &MCLR &End'
         Write (LuInput,'(A)') 'End of Input'
         Close(LuInput)
         ireturn=_RC_INVOKED_OTHER_MODULE_
      Else
         ireturn=_RC_ALL_IS_WELL_
      End if
*
      Return
*
      Write (6,*)
      Write (6,*) ' Error opening Stdin.x'
      Write (6,*)
      Call Quit(_RC_INPUT_EMIL_ERROR_)
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine GetChVHlp1 (cGrp,deGrp,yes,NL2,L2Status)
c
c       this routine do:
c       check, if Cholesky vector block cGrp,deGrp is actually situated
c       in the memory as one of L2x
c
c       descrition of parameters:
c       cGrp, deGrp - required Group of c, delta in L2(m,c',de') (I)
c       yes    -  0 - not loaded  (O)
c                 x - loaded, value of L2x (x=1-4)
c       NL2         - Number of L2 arrays really reserved in memory (I)
c       L2Status    - L2 status matrix (I)
c                     L2Status(i,1) - cGrp
c                     L2Status(i,2) - deGrp
c                     L2Status(i,3) - Poss
c
        implicit none
        integer cGrp,deGrp,yes,NL2
        integer L2Status(1:4,1:3)
c
c       help variables
        integer i
c
        yes=0
        do i=1,NL2
        if ((cGrp.eq.L2Status(i,1)).and.(deGrp.eq.L2Status(i,2))) then
        yes=i
        end if
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ORTHO2(S,U,V,N)
C
C     Purpose: normalize vector U and calculate V=S*U.
C
C     Called from: ORTHO1.
C
C          ****** IBM 3090 MOLCAS Release: 90 02 22 ******
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output_ras.fh"
#include "warnings.fh"
      Parameter (ROUTINE='ORTHO2  ')
      DIMENSION S(*),U(*),V(*)
      THR=1.D-10
      IF ( N.EQ.0 ) GOTO 90
      CALL DGEMM_('N','N',
     &             N,1,N,
     &             1.0d0,S,N,
     &             U,N,
     &             0.0d0,V,N)
      SUM=DDOT_(N,U,1,V,1)
      IF (SUM.LT.THR) THEN
        Write(LF,*)' TEST IN ORTHO2: N=',N
        Write(LF,'(1X,5G16.8)') (U(I),I=1,N)
        Write(LF,'(1X,5G16.8)') (V(I),I=1,N)
        Write(LF,*)' Error in ORTHO2. Norm=', SUM
        Write(LF,*)' RASSCF tried to orthonormalize orbitals, but'
        Write(LF,*)' failed due to a condition that should not be'
        Write(LF,*)' possible in a low-level subroutine. Either'
        Write(LF,*)' some extremely strange orbitals have been'
        Write(LF,*)' produced, or something is seriously wrong'
        Write(LF,*)' with the program. Please check, and consider'
        Write(LF,*)' issuing a bug report.'
        CALL QUIT(_RC_GENERAL_ERROR_)
      ENDIF
      X=1.0D0/SQRT(SUM)
      DO I=1,N
        U(I)=X*U(I)
        V(I)=X*V(I)
      END DO
  90  CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine nize_cvb(c,nnrm,s,n,metr,ierr)
c  Normalizes NNRM vectors in C.
      implicit real*8 (a-h,o-z)
      logical safe
#include "WrkSpc.fh"
      dimension c(n,nnrm),s(*)
      save one,thresh
      data one/1.d0/,thresh/1.d-8/

      if(metr.ne.0)i1=mstackr_cvb(n)
      safe=ierr.ne.0
      do 100 i=1,nnrm
      if(metr.eq.0)then
        cnrm=dnrm2_(n,c(1,i),1)
      else
        call saoon_cvb(c(1,i),work(i1),1,s,n,metr)
        cnrm=sqrt(ddot_(n,c(1,i),1,work(i1),1))
      endif
      if(safe.and.cnrm.lt.thresh)then
        ierr=ierr+1
      else
        call dscal_(n,one/cnrm,c(1,i),1)
      endif
100   continue
      if(metr.ne.0)call mfreer_cvb(i1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine initialize1 (dkhorder,xorder,paramtype,dkhscfflg,
     *         ordercounter,opcounter,operleng,oporder,evenodd,
     *         doperators,operators,xordercounter,xopcounter,xoperleng,
     *         xoporder,xevenodd,xdoperators,xoperators,wordercounter,
     *         wopscounter,wopsleng,woporder,eowops,dwops,wops,
     *         oddcounter,oddleng,oddorder,eoodd,dodd,odd,ducoeffs,
     *         dkhzerothrsh)

c
c************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 12.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,xorder,ordercounter(0:maxorder),opcounter,
     *        operleng(maxoperators),oporder(maxoperators,3),
     *        evenodd(maxoperators),
     *        xordercounter(0:maxorder),xopcounter,
     *        xoperleng(maxoperators),xoporder(maxoperators),
     *        xevenodd(maxoperators)
      REAL*8 doperators(maxoperators),
     *                 xdoperators(maxoperators)
#if defined(_MOLCAS_) || defined(MOLPRO)
      character operators(*),xoperators(*)
      character*(maxlength) opstring,xopstring
#else
      character*(maxlength) operators(maxoperators),
     *                        xoperators(maxoperators)
#endif
c
      integer wordercounter(maxorder),wopscounter,wopsleng(maxuops),
     *        woporder(maxuops,3),eowops(maxuops),
     *        oddcounter,oddleng(maxuops),oddorder(maxuops,3),
     *        eoodd(maxuops)
      REAL*8 dwops(maxuops),dodd(maxuops)
      character*(maxlength) wops(maxuops),odd(maxuops)
c
      character*(3) paramtype
      logical dkhscfflg
c
      integer i,j
      REAL*8 ducoeffs(maxorder),dkhzerothrsh(0:maxorder)
      intrinsic INT,DBLE
#ifdef _DEBUGPRINT_
#ifdef _MOLCAS_
      Integer IsFreeUnit,k
#endif
#endif
c
      if (DBLE(maxorder)/2.0d0.ne.DBLE(INT(DBLE(maxorder)/2.0d0))) then
        write (stdout,1002) maxorder
1002    format(5X,'Parameter  maxorder = ',I2,' has to be even.',//5X,
     *         'Adjust it in parameter file "dkhparameters.h"!',
     *         //5X,'STOP.')
        call Abend
      endif
      if (dkhorder.gt.maxorder .or. xorder.gt.maxorder) then
        write (stdout,1004) maxorder
1004    format(5X,'Parameter  maxorder = ',I2,' is too small.',//5X,
     *         'Increase it in parameter file "dkhparameters.h"!',
     *         //5X,'STOP.')
        call Abend
      endif
      if (paramtype .eq. 'EXP') then
        call exp_param (ducoeffs)
      else
        call other_param (ducoeffs,dkhorder,paramtype)
      endif
      opcounter=0
      xopcounter=0
      do 10 i=0,maxorder
        ordercounter(i)=0
        xordercounter(i)=0
  10  continue
      do 20 i=1,maxoperators
        operleng(i)=0
        do 21 j=1,3
          oporder(i,j)=0
  21    continue
#if defined(_MOLCAS_) || defined(MOLPRO)
      opstring=' '
      xopstring=' '
#endif
        evenodd(i)=0
        doperators(i)=0.0d0
        xoperleng(i)=0
        xoporder(i)=0
        xevenodd(i)=0
        xdoperators(i)=0.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
        call put_dkoperators(i,opstring,operators)
        call put_dkoperators(i,xopstring,xoperators)
#else
        do 25 k=1,maxlength
          operators(i)(k:k)=' '
          xoperators(i)(k:k)=' '
  25    continue
#endif
  20  continue
c
      wopscounter=0
      oddcounter=0
      do 40 i=1,maxorder
        wordercounter(i)=0
  40  continue
      do 50 i=1,maxuops
        wopsleng(i)=0
        eowops(i)=0
        dwops(i)=0.0d0
        oddleng(i)=0
        eoodd(i)=0
        dodd(i)=0.0d0
        do 51 j=1,3
          woporder(i,j)=0
          oddorder(i,j)=0
  51    continue
C        do 53 k=1,maxlength
CC         wops(i)(k:k)= ' '
CC         odd(i)(k:k)=  ' '
C          Write(wops(i)(k:k),'(A)') ' '
C          Write(odd(i)(k:k),'(A)')  ' '
C  53    continue
         wops(i)=' '
         odd(i)=' '
  50  continue
c
      do 60 i=0,maxorder
        dkhzerothrsh(i)=dkhzero
  60  continue
c
      dkhzerothrsh(5) =1.0d-3
      dkhzerothrsh(6) =1.0d-3
      dkhzerothrsh(7) =1.0d-2
      dkhzerothrsh(8) =1.0d-2
      dkhzerothrsh(9) =1.0d-2
      dkhzerothrsh(10)=1.0d-2
      dkhzerothrsh(11)=1.0d-2
      dkhzerothrsh(12)=1.0d-2
      dkhzerothrsh(13)=1.0d-2
      dkhzerothrsh(14)=1.0d-2
      dkhzerothrsh(15)=1.0d-2
      dkhzerothrsh(16)=1.0d-2
      dkhzerothrsh(17)=1.0d-2
      dkhzerothrsh(18)=1.0d-2
      dkhzerothrsh(19)=1.0d-2
      dkhzerothrsh(20)=1.0d-2
      dkhzerothrsh(21)=1.0d-2
      dkhzerothrsh(22)=1.0d-2
c
      opcounter=1
      ordercounter(0)=ordercounter(0)+1
      operleng(opcounter)=3
      oporder(opcounter,1)=0
      oporder(opcounter,2)=0
      oporder(opcounter,3)=oporder(opcounter,1)+oporder(opcounter,2)
      evenodd(opcounter)=+1
      doperators(opcounter)=1.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
      opstring='E00'
      call put_dkoperators(opcounter,opstring,operators)
#else
      operators(opcounter)='E00'
#endif
      opcounter=opcounter+1
      ordercounter(1)=ordercounter(1)+1
      operleng(opcounter)=3
      oporder(opcounter,1)=1
      oporder(opcounter,2)=0
      oporder(opcounter,3)=oporder(opcounter,1)+oporder(opcounter,2)
      evenodd(opcounter)=+1
      doperators(opcounter)=1.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
      opstring='E01'
      call put_dkoperators(opcounter,opstring,operators)
#else
      operators(opcounter)='E01'
#endif
      opcounter=opcounter+1
      ordercounter(1)=ordercounter(1)+1
      operleng(opcounter)=3
      oporder(opcounter,1)=1
      oporder(opcounter,2)=0
      oporder(opcounter,3)=oporder(opcounter,1)+oporder(opcounter,2)
      evenodd(opcounter)=-1
      doperators(opcounter)=1.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
      opstring='O01'
      call put_dkoperators(opcounter,opstring,operators)
#else
      operators(opcounter)='O01'
#endif
c
      if (dkhscfflg) then
        opcounter=opcounter+1
        ordercounter(1)=ordercounter(1)+1
        operleng(opcounter)=3
        oporder(opcounter,1)=0
        oporder(opcounter,2)=1
        oporder(opcounter,3)=oporder(opcounter,1)+oporder(opcounter,2)
        evenodd(opcounter)=+1
        doperators(opcounter)=1.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
      opstring='CE0'
      call put_dkoperators(opcounter,opstring,operators)
#else
      operators(opcounter)='CE0'
#endif
        opcounter=opcounter+1
        ordercounter(1)=ordercounter(1)+1
        operleng(opcounter)=3
        oporder(opcounter,1)=0
        oporder(opcounter,2)=1
        oporder(opcounter,3)=oporder(opcounter,1)+oporder(opcounter,2)
        evenodd(opcounter)=-1
        doperators(opcounter)=1.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
      opstring='CO0'
      call put_dkoperators(opcounter,opstring,operators)
#else
      operators(opcounter)='CO0'
#endif
      endif
      if (.not.dkhscfflg) then
        xopcounter=1
        xordercounter(0)=xordercounter(0)+1
        xoperleng(xopcounter)=3
        xoporder(xopcounter)=0
        xevenodd(xopcounter)=+1
        xdoperators(xopcounter)=1.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
        xopstring='CE0'
        call put_dkoperators(xopcounter,xopstring,xoperators)
#else
        xoperators(xopcounter)='CE0'
#endif
        xopcounter=xopcounter+1
        xordercounter(0)=xordercounter(0)+1
        xoperleng(xopcounter)=3
        xoporder(xopcounter)=0
        xevenodd(xopcounter)=-1
        xdoperators(xopcounter)=1.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
        xopstring='CO0'
        call put_dkoperators(xopcounter,xopstring,xoperators)
#else
        xoperators(xopcounter)='CO0'
#endif
      endif
c
#ifdef _DEBUGPRINT_
      if (dbgflg.ge.1) then
#ifdef _MOLCAS_
        dbgunit=32
        dbgunit=IsFreeUnit(dbgunit)
        Call Molcas_Open(dbgunit,'dbgout.32')
#else
        open (dbgunit, file='dbgout.32', status='UNKNOWN',
     *        form='FORMATTED')
#endif
        rewind(dbgunit)
        write (dbgunit,1012) dkhorder,xorder,dkhscfflg,paramtype,
     *                       dynthrsh
1012    format (/2X,'dkhorder  = ',I2,/2X,'xorder',4X,'= ',I2,/2X,
     *          'dkhscfflg =  ',L1,/2X,'paramtype = ',A3,/2X,'dynthrsh',
     *          '  =  ',I1,//2X,'Form of the initial fpFW ',
     *          'transformed Hamiltonian H1:',/2X,52('-'))
        call output3 (dbgunit,opcounter,operleng,oporder,evenodd,
     *                doperators,operators)
        if (.not.dkhscfflg) then
          write (dbgunit,1013)
1013      format (//2X,'Form of the initial fpFW transformed property',
     *          ' operator X1:',/2X,58('-'))
          call output3b (dbgunit,xopcounter,xoperleng,xoporder,xevenodd,
     *                  xdoperators,xoperators)
        endif
      endif

      if (dbgflg.ge.1) then
        write (dbgunit,1019)
1019    format (//2X,'Coefficients for the parametrization',10X,
     *          'zero thresholds',/4X,'of the unitary transformations:',
     *       17X,'dkhzero(k):',/2X,36('-'),8X,23('-'))
        write (dbgunit,1021)
1021    format (5X,'a_0   =   1.0000000000')
        do 80 k=1,maxorder
          if (k.le.9) then
            write (dbgunit,1025) k, ducoeffs(k), k, dkhzerothrsh(k)
1025        format (5X,'a_',I1,'   =  ',F13.10,19X,'dkhzero(',I1,
     *              ')  = ',D9.2)
          endif
          if (k.gt.9) then
            write (dbgunit,1029) k, ducoeffs(k), k, dkhzerothrsh(k)
1029        format (5X,'a_',I2,'  =  ',D13.6,19X,'dkhzero(',I2,
     *              ') = ',D9.2)
          endif
  80    continue
        write (dbgunit,1033)
1033    format(2X/)
      endif
c
      if (dbgflg.ge.1) write (dbgunit,1037)
1037  format (/2X,145('*'),//2X,'Step 1: Enter subroutine',
     *        ' "get_dkhstring"')
c
#endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Francesco Aquilante                              *
!***********************************************************************

subroutine Cho_SOSmp2_Setup_Prt(irc)
! Francesco Aquilante  May 2007
!
! Purpose: print setup for SOS-MP2.

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
#include "chomp2_cfg.fh"
#include "chomp2.fh"

irc = 0

call Cho_Head('Cholesky SOS-MP2 Setup','=',80,u6)
write(u6,*)

if (nBatch > 1) then
  write(u6,'(A,I6,A,I6,A)') 'The list of',nOccT,' occupied orbitals has been split in',nBatch,' batches:'
  write(u6,*) 'Batching is not allowed in SOS-MP2 : I stop here! '
  call Abend()
else if (nBatch == 1) then
  write(u6,'(A,I6,A)') 'The list of',nOccT,' occupied orbitals is not split:'
else
  write(u6,*) 'Oops, #batches over occupied orbitals is non-positive: ',nBatch
  irc = -101
  return
end if

write(u6,'(//,A)') 'The following tasks will be performed:'
write(u6,'(A)') ' * AO-to-MO transformation of original Cholesky vectors.'
if (DecoMP2) then
  write(u6,'(A)') ' * Cholesky decomposition of M=(ai|bj)^2 matrix.'
end if
write(u6,*) ' * Calculation of SOS-MP2 correlation energy.'

call xFlush(u6)

end subroutine Cho_SOSmp2_Setup_Prt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DIAGC(INTSYM,C,S)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION INTSYM(*),C(*),S(*)
*
      JSYM(L)=JSUNP(INTSYM,L)
*
      IADD25=IAD25S
      CALL dDAFILE(Lu_25,2,COP,nCOP,IADD25)
      IIC=0
      IND=0
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      IRL=IRC(ILIM)
      DO 100 INDA=1,IRL
      NSS=MUL(JSYM(INDA),LSYM)
      IF(INDA.GT.IRC(1))GO TO 120
      IIC=IIC+1
      IND=IND+1
      S(IND)=S(IND)+COP(IIC)*C(IND)
      IF(IIC.LT.nCOP)GO TO 100
      CALL dDAFILE(Lu_25,2,COP,nCOP,IADD25)
      IIC=0
      GO TO 100
120   IF(INDA.GT.IRC(2))GO TO 130
      NA1=NVIRP(NSS)+1
      NA2=NVIRP(NSS)+NVIR(NSS)
      IF(NA2.LT.NA1)GO TO 100
      DO 121 NA=NA1,NA2
      IIC=IIC+1
      IND=IND+1
      S(IND)=S(IND)+COP(IIC)*C(IND)
      IF(IIC.LT.nCOP)GO TO 121
      CALL dDAFILE(Lu_25,2,COP,nCOP,IADD25)
      IIC=0
121   CONTINUE
      GO TO 100
130   DO 141 NA=1,NVIRT
      NSA=MUL(NSS,NSM(LN+NA))
      NB1=NVIRP(NSA)+1
      NB2=NVIRP(NSA)+NVIR(NSA)
      IF(NB2.GT.NA)NB2=NA
      IF(NB2.LT.NB1)GO TO 141
      DO 142 NB=NB1,NB2
      IIC=IIC+1
      IND=IND+1
      S(IND)=S(IND)+COP(IIC)*C(IND)
      IF(IIC.LT.nCOP)GO TO 142
      CALL dDAFILE(Lu_25,2,COP,nCOP,IADD25)
      IIC=0
142   CONTINUE
141   CONTINUE
100   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MomentMod(Re,NRe,Cmo,nBRe,nBNRe,LindMOs,iS1,iS2,First,DiffMax)

use qmstat_global, only: iPrint
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nBRe, nBNRe, iS1, iS2
real(kind=wp), intent(in) :: Re(nTri_Elem(nBRe)), NRe(nBNRe,nBNRe), Cmo(nBNRe,nBNRe)
logical(kind=iwp), intent(in) :: LindMOs(nBNRe)
logical(kind=iwp), intent(inout) :: First
real(kind=wp), intent(out) :: DiffMax
integer(kind=iwp) :: i, icomp, iopt, irc, iSmLbl, j, kaunt1, nSize1, nSize2
real(kind=wp) :: Diffx, Diffy, Diffz, DipRe(3), DipNRe(3)
real(kind=wp), allocatable :: D(:), Dsq(:,:), DxM(:,:), DxRe(:), DyM(:,:), DyRe(:), DzM(:,:), DzRe(:), TEMP(:,:)
real(kind=r8), external :: Ddot_

if (First .and. (iPrint >= 5)) then
  write(u6,*)
  write(u6,*) '     Modifications of dipoles by renormalization and basis reduction.'
  write(u6,*)
  write(u6,*) '     State pair    |  Difference '
  write(u6,*) '     --------------|---------------------'
  First = .false.
end if

nSize1 = nTri_Elem(nBNRe)
nSize2 = nTri_Elem(nBRe)
call mma_allocate(D,nSize1,label='Dip')
call mma_allocate(DxRe,nSize2,label='DipXre')
call mma_allocate(DyRe,nSize2,label='DipYre')
call mma_allocate(DzRe,nSize2,label='DipZre')
call mma_allocate(Dsq,nBNRe,nBNre,label='Dipsq')
call mma_allocate(DxM,nBNRe,nBNRe,label='DipXm')
call mma_allocate(DyM,nBNRe,nBNRe,label='DipYm')
call mma_allocate(DzM,nBNRe,nBNRe,label='DipZm')
call mma_allocate(TEMP,nBNRe,nBNRe,label='TEMP')
irc = -1
iopt = 6
iSmLbl = 0
! X
icomp = 1
call RdOne(irc,iopt,'Mltpl  1',icomp,D,iSmLbl)
call Square(D,Dsq,1,nBNRe,nBNRe)
call Dgemm_('T','N',nBNRe,nBNRe,nBNRe,One,Cmo,nBNRe,Dsq,nBNRe,Zero,TEMP,nBNRe)
call Dgemm_('N','N',nBNRe,nBNRe,nBNRe,One,TEMP,nBNRe,Cmo,nBNRe,Zero,DxM,nBNRe)
! Y
icomp = 2
call RdOne(irc,iopt,'Mltpl  1',icomp,D,iSmLbl)
call Square(D,Dsq,1,nBNRe,nBNRe)
call Dgemm_('T','N',nBNRe,nBNRe,nBNRe,One,Cmo,nBNRe,Dsq,nBNRe,Zero,TEMP,nBNRe)
call Dgemm_('N','N',nBNRe,nBNRe,nBNRe,One,TEMP,nBNRe,Cmo,nBNRe,Zero,DyM,nBNRe)
! Z
icomp = 3
call RdOne(irc,iopt,'Mltpl  1',icomp,D,iSmLbl)
call Square(D,Dsq,1,nBNRe,nBNRe)
call Dgemm_('T','N',nBNRe,nBNRe,nBNRe,One,Cmo,nBNRe,Dsq,nBNRe,Zero,TEMP,nBNRe)
call Dgemm_('N','N',nBNRe,nBNRe,nBNRe,One,TEMP,nBNRe,Cmo,nBNRe,Zero,DzM,nBNRe)
! Triangularize and reduce.
kaunt1 = 0
do i=1,nBNRe
  if (.not. LindMOs(i)) cycle
  do j=1,i
    if (.not. LindMOs(j)) cycle
    kaunt1 = kaunt1+1
    DxRe(kaunt1) = DxM(j,i)
    DyRe(kaunt1) = DyM(j,i)
    DzRe(kaunt1) = DzM(j,i)
  end do
end do
! Density
DipNRe(1) = Ddot_(nBNRe**2,DxM,1,NRe,1)
DipNRe(2) = Ddot_(nBNRe**2,DyM,1,NRe,1)
DipNRe(3) = Ddot_(nBNRe**2,DzM,1,NRe,1)
DipRe(1) = Ddot_(nSize2,DxRe,1,Re,1)
DipRe(2) = Ddot_(nSize2,DyRe,1,Re,1)
DipRe(3) = Ddot_(nSize2,DzRe,1,Re,1)
Diffx = abs(DipRe(1)-DipNRe(1))
Diffy = abs(DipRe(2)-DipNRe(2))
Diffz = abs(DipRe(3)-DipNRe(3))
if (iPrint >= 5) write(u6,99) iS1,iS2,'(',Diffx,',',Diffy,',',Diffz,')'
! Return number
DiffMax = Diffy
if (Diffx >= Diffy) DiffMax = Diffx
if ((Diffz >= Diffx) .and. (Diffz >= Diffy)) DiffMax = Diffz
! Deallocate en masse.
call mma_deallocate(D)
call mma_deallocate(DxRe)
call mma_deallocate(DyRe)
call mma_deallocate(DzRe)
call mma_deallocate(Dsq)
call mma_deallocate(DxM)
call mma_deallocate(DyM)
call mma_deallocate(DzM)
call mma_deallocate(TEMP)

return

99 format('     ',2I3,'          ',3(A,F10.7),A)

end subroutine MomentMod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ICOPMT(    MATI,     NRI,     NCI,    MATO,     NRO,
     &                       NCO)
*
* Copy integer matrix MATI to MATO
*
*. Input
      INTEGER  MATI(NRI,NCI)
*. Output
      INTEGER MATO(NRO,NCO)
*
      NREFF = MIN(NRI,NRO)
      NCEFF = MIN(NCI,NCO)
*
      DO IC = 1, NCEFF
        DO IR = 1, NREFF
          MATO(IR,IC) = MATI(IR,IC)
        END DO
      END DO
*
      RETURN
      END
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Localisation_globals

use Molcas, only: LenIn, MxSym
use Definitions, only: wp, iwp
use Constants, only: Zero

implicit none
private

! CMO     : the MO coefficients
! nCMO    : size of CMO
! Occ     : occupancy vector
! Eor     : orbital energy vector
! ipInd   : orbital type info vector
! nSym    : number of Irrep
! nBas    : number of basis function per Irrep
! nOrb    : number of occ orb per irrep
! LuSpool : Unit number of the input
! nOrb2Loc: Number of orbital to localise
!
! BName   : Basis function names
!
! LC_FileOrb: orbital file for Seward to read

integer(kind=iwp) :: fileorb_id, iWave, LocModel, LuSpool, MxConstr, nActa, nAtoms, nBas(MxSym), nCMO, nConstr(MxSym), &
                     nFro(MxSym), nMxIter, nOccInp(MxSym), nOrb(MxSym), nOrb2Loc(MxSym), nSym, nVirInp(MxSym), OptMeth, &
                     ChargeType, LocOrb
#ifdef _HDF5_
integer(kind=iwp) :: wfn_fileid, wfn_mocoef, wfn_occnum, wfn_orbene, wfn_tpidx
#endif
real(kind=wp) :: Thrs, ThrRot, ThrGrad, ThrDomain(2), ThrPairDomain(3), ThrSel
logical(kind=iwp) :: AnaAtom, AnaDomain, Analysis, AnaPAO, AnaPAO_Save, ChoStart, DoCNOs, DoDomain, EvalER, isHDF5 = .false., &
                     LocCanOrb, LocNatOrb, LocPAO, Maximisation, Order, PrintMOs, Silent, Skip, Test_Localisation, Timing,&
                     Wave,Thrs_UsrDef, LocModel_UsrDef, nFro_UsrDef, nOrb2Loc_UsrDef,Freeze, Debug = .false.
character(len=512) :: LC_FileOrb
character(len=3) :: AnaNrm
integer(kind=iwp), allocatable :: Ind(:)
character(len=LenIn+8), allocatable :: BName(:)
character(len=LenIn), allocatable :: NamAct(:)
real(kind=wp), allocatable :: CMO(:), EOrb(:), MOrig(:), Occ(:)
real(kind=wp) :: ScrFac=Zero

public :: AnaAtom, AnaDomain, Analysis, AnaNrm, AnaPAO, AnaPAO_Save, BName, ChoStart, CMO, DoCNOs, DoDomain, EOrb, EvalER, &
          fileorb_id, Ind, isHDF5, iWave, LC_FileOrb, LocCanOrb, LocModel, LocNatOrb, LocPAO, LuSpool, Maximisation, MOrig, &
          MxConstr, nActa, NamAct, nAtoms, nBas, nCMO, nConstr, nFro, nMxIter, nOccInp, nOrb, nOrb2Loc, nSym, nVirInp, Occ, Order, &
          PrintMOs, Silent, Skip, Test_Localisation, ThrDomain, ThrGrad, ThrPairDomain, ThrRot, Thrs, ThrSel, Timing, Wave,&
          ScrFac,Debug, OptMeth, ChargeType, LocOrb, Thrs_UsrDef, LocModel_UsrDef, nFro_UsrDef, nOrb2Loc_UsrDef,&
          Freeze
#ifdef _HDF5_
public :: wfn_fileid, wfn_mocoef, wfn_occnum, wfn_orbene, wfn_tpidx
#endif

end module Localisation_globals

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GenGnu_Localisation(FilNam,Den,Coord,n)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
character(len=12), intent(in) :: FilNam
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: Den(n,n), Coord(3,n)
integer(kind=iwp) :: i, j, Lu
real(kind=wp) :: Dist, D, Fac
character(len=16) :: FName
character(len=4) :: Postfix = '.dat'
integer(kind=iwp), external :: isFreeUnit

! Open data file.
! ---------------

Lu = isFreeUnit(11)
write(FName,'(A12,A4)') FilNam,Postfix
if (FName(1:1) == ' ') FName(1:1) = 'G'
do i=2,12
  if (FName(i:i) == ' ') FName(i:i) = '_'
end do
call Molcas_Open(Lu,FName)
rewind(Lu)

! Write data file.
! ----------------

Fac = One/log(10.0_wp)
do j=1,n
  do i=j,n
    Dist = sqrt((Coord(1,j)-Coord(1,i))**2+(Coord(2,j)-Coord(2,i))**2+(Coord(3,j)-Coord(3,i))**2)
    if (abs(Den(i,j)) < 1.0e-16_wp) then
      D = -40.0_wp
    else
      D = Fac*log(abs(Den(i,j)))
    end if
    write(Lu,'(1X,1P,D20.10,1X,D20.10)') Dist,D
  end do
end do

! Close data file.
! ----------------

close(Lu,status='Keep')

end subroutine GenGnu_Localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine OCHRR(Target,nPrim,nTrgt,la,lb,ipRs)
************************************************************************
* Object: this is a One Center HRR routine.                            *
*                                                                      *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             May '90                                                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
      Real*8 Target(nPrim,nTrgt)
*
*     Statment functions
*
      nElem(i) = (i+1)*(i+2)/2
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
      iRout = 63
      iPrint = nPrint(iRout)
      If (la.eq.0 .or. lb.eq.0) Then
         ipRs = 1
         Return
      End If
      iab = 0
      iout = nElem(la+lb)
      ipRs = iout*nPrim + 1
      Do 100 ixb = 0, lb
         iybMax = lb - ixb
         Do 110 iyb = 0, iybMax
            izb = iybMax - iyb
            ixyzb = Ind(lb,ixb,izb)
*
            Do 200 ixa = 0, la
               iyaMax = la - ixa
               ixab = ixa + ixb
               Do 210 iya = 0, iyaMax
                  iyab = iya + iyb
                  iza = iyaMax - iya
                  izab = iza + izb
                  ixyza = Ind(la,ixa,iza)
                  iTo = iout + nElem(la)*(ixyzb-1) + ixyza
                  iFrom = iab + Ind(la+lb,ixab,izab)
*
                  call dcopy_(nPrim,Target(1,iFrom),1,Target(1,iTo),1)
*
 210           Continue
 200        Continue
 110     Continue
 100  Continue
*
*     Call GetMem(' Exit OCHRR','CHECK','REAL',iDum,iDum)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_DECOM(DIAG,WRK,LWRK,IPASS,NUM)
!
! Purpose: calculate Cholesky vectors from qualified integral
!          columns (from disk).

use Cholesky, only: Cho_1Center, Cho_DiaChk, Cho_Simp, DiaMin, iiBstR, IndRed, INF_PASS, INF_PROGRESS, IPRINT, iQuAB, LuPri, &
                    LuSel, nnBstR, nnZTot, nQual, nSym, NumCho, NumChT, nVec_in_Buf, Span, TDECOM, ThrCom, Tol_DiaChk
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LWRK, IPASS, NUM
real(kind=wp), intent(inout) :: Diag(*), WRK(LWRK)
integer(kind=iwp) :: I, IAB, IABG, IADR, ICHO, IDUMP, II, IOPT, ISYM, IVEC, IVEC1, IVECT, JJ, KAB, KCHO1, KEND0, KEND1, KINT1, &
                     KOFF, KOFF0, KOFF2, KOFF3, LINT1, LTOT, LWRK0, LWRK1, NCONV, NERR, NNEG, NNEGT, NUMBUF, NUMCHO_OLD(8)
real(kind=wp) :: C1, C2, FAC, OLDIAG, TOL, W1, W2, XC, XM, XMAX, XMIN, YM
logical(kind=iwp) :: LAST
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_DECOM'

if (IPRINT >= INF_PROGRESS) then
  call CHO_HEAD(SECNAM//': Decomposition of Qualified Diagonals','=',80,LUPRI)
  write(LUPRI,'(/,A,I5,A,I4,A)') 'Integral pass number',IPASS,' (',NUM,' shell pair distributions calculated)'
  write(LUPRI,'(A,8I8)') '#Cholesky vec.: ',(NUMCHO(ISYM),ISYM=1,NSYM)
  write(LUPRI,'(A,8I8)') '#vec. in buff.: ',(NVEC_IN_BUF(ISYM),ISYM=1,NSYM)
  write(LUPRI,'(A,8I8)') '#qualified    : ',(NQUAL(ISYM),ISYM=1,NSYM)
  write(LUPRI,'(A,8I8)') 'Current  dim. : ',(NNBSTR(ISYM,2),ISYM=1,NSYM)
  write(LUPRI,'(A,8I8)') 'Original dim. : ',(NNBSTR(ISYM,1),ISYM=1,NSYM)
  write(LUPRI,'(/,A,/,A)') '           #Vectors             Treated Diagonal', &
                           'Sym.     Sym.     Total     Index     Before      After   Conv. Neg.   New Max'
  write(LUPRI,'(A)') repeat('-',79)
  call XFLUSH(LUPRI)
  NUMCHO_OLD(1:NSYM) = NUMCHO(1:NSYM)
else if (IPRINT >= INF_PASS) then
  write(LUPRI,'(/,A,I4)') 'Number of shell pair distributions calculated:',NUM
  write(LUPRI,'(A,8I8)') '#Cholesky vec.: ',(NUMCHO(ISYM),ISYM=1,NSYM)
  write(LUPRI,'(A,8I8)') '#vec. in buff.: ',(NVEC_IN_BUF(ISYM),ISYM=1,NSYM)
  write(LUPRI,'(A,8I8)') '#qualified    : ',(NQUAL(ISYM),ISYM=1,NSYM)
  call XFLUSH(LUPRI)
  NUMCHO_OLD(1:NSYM) = NUMCHO(1:NSYM)
end if

! Decompose each symmetry block.
! ------------------------------

do ISYM=1,NSYM

  ! Cycle loop if nothing to do in this symmetry.
  ! ---------------------------------------------

  if ((NQUAL(ISYM) >= 1) .and. (NNBSTR(ISYM,2) >= 1)) then

    ! Reserve space for qualified integral columns.
    ! ---------------------------------------------

    LINT1 = NNBSTR(ISYM,2)*NQUAL(ISYM) ! integrals

    KINT1 = 1
    KEND0 = KINT1+LINT1
    LWRK0 = LWRK-KEND0+1
    if (LWRK0 <= 0) call CHO_QUIT('[0] Insufficient memory in '//SECNAM,101)

    ! Determine size of Cholesky vector (output) buffer.
    ! --------------------------------------------------

    NUMBUF = min(LWRK0/NNBSTR(ISYM,2),NQUAL(ISYM))
    if (NUMBUF < 1) call CHO_QUIT('[1] Insufficient memory in '//SECNAM,101)
    KCHO1 = KEND0
    KEND1 = KCHO1+NNBSTR(ISYM,2)*NUMBUF
    LWRK1 = LWRK-KEND1+1
    if (LWRK1 < 0) call CHO_QUIT('Buffer allocation error in '//SECNAM,101)  ! should be redundant...

    ! Read qualified integral columns.
    ! --------------------------------

    call CWTIME(C1,W1)
    IOPT = 2
    LTOT = NNBSTR(ISYM,2)*NQUAL(ISYM)
    IADR = 0
    call DDAFILE(LUSEL(ISYM),IOPT,WRK(KINT1),LTOT,IADR)
    call CWTIME(C2,W2)
    TDECOM(1,1) = TDECOM(1,1)+C2-C1
    TDECOM(2,1) = TDECOM(2,1)+W2-W1

    ! Subtract contributions from previous vectors.
    ! ---------------------------------------------

    call CHO_SUBTR(WRK(KINT1),WRK(KEND0),LWRK0,ISYM)

    ! Debug: check diagonal elements in updated integrals.
    ! ----------------------------------------------------

    if (CHO_DIACHK .or. LOCDBG) then
      TOL = TOL_DIACHK
      NERR = 0
      call CHO_CHKINT(WRK(KINT1),DIAG,ISYM,NERR,TOL,.true.)
      if (NERR /= 0) then
        write(LUPRI,*) SECNAM,': ',NERR,' diagonal errors found!'
        write(LUPRI,*) '          #tests: ',NQUAL(ISYM)
        !write(LUPRI,*) '          Printing integrals:'
        !call CHO_OUTPUT(WRK(KINT1),1,NNBSTR(ISYM,2),1,NQUAL(ISYM),NNBSTR(ISYM,2),NQUAL(ISYM),1,LUPRI)
        call CHO_QUIT('Diagonal errors in '//SECNAM,104)
      else
        write(LUPRI,*) SECNAM,': comparison of qual. integrals and current diagonal: no errors !'
      end if
    end if

    ! Decompose in loop over qualified columns.
    ! -----------------------------------------

    IVEC = NUMCHO(ISYM)
    IVECT = NUMCHT
    IDUMP = 0
    do ICHO=1,NQUAL(ISYM)

      ! Find max. diagonal among qualified.
      ! -----------------------------------

      IAB = 1
      IABG = INDRED(IQUAB(IAB,ISYM),2)
      XC = DIAG(IABG)
      do I=2,NQUAL(ISYM)
        KAB = INDRED(IQUAB(I,ISYM),2)
        if (DIAG(KAB) > XC) then
          IAB = I
          IABG = KAB
          XC = DIAG(KAB)
        end if
      end do

      ! Decompose if max. diagonal is still qualified.
      ! ----------------------------------------------

      LAST = (XC < DIAMIN(ISYM)) .or. (XC < THRCOM)
      if (.not. LAST) then

        ! Offset to max. diagonal column.
        ! -------------------------------

        KOFF0 = KINT1+NNBSTR(ISYM,2)*(IAB-1)-1

        ! Scale column corresponding to max. diagonal to obtain
        ! the Cholesky vector.
        ! -----------------------------------------------------

        FAC = One/sqrt(XC)
        KOFF = KOFF0
        WRK(KOFF+1:KOFF+NNBSTR(ISYM,2)) = FAC*WRK(KOFF+1:KOFF+NNBSTR(ISYM,2))

        ! Zero entries in Cholesky vector corresponding to zero diagonals.
        ! ----------------------------------------------------------------

        do I=1,NNBSTR(ISYM,2)
          II = IIBSTR(ISYM,2)+I
          JJ = INDRED(II,2)
          if (DIAG(JJ) == Zero) then
            KOFF = KOFF0+I
            WRK(KOFF) = Zero
          end if
        end do

        ! Update diagonal.
        ! ----------------

        do I=1,NNBSTR(ISYM,2)
          II = IIBSTR(ISYM,2)+I
          JJ = INDRED(II,2)
          KOFF = KOFF0+I
          DIAG(JJ) = DIAG(JJ)-WRK(KOFF)*WRK(KOFF)
        end do

        ! Zero treated diagonal element and analyze updated diagonal.
        ! -----------------------------------------------------------

        OLDIAG = DIAG(IABG)
        DIAG(IABG) = Zero
        call CHO_CHKDIA(DIAG,ISYM,XMIN,XMAX,XM,NNEGT,NNEG,NCONV)

        ! Update total number of zeroed negative diagonals.
        ! -------------------------------------------------

        NNZTOT = NNZTOT+NNEG

        ! Update DIAMIN from max. abs. diagonal element XM.
        ! CHO_1CENTER: update from max. diagonal element among
        !              qualified.
        ! CHO_SIMP   : "simulate parallel algorithm" = do not
        !              update DIAMIN.
        ! ----------------------------------------------------

        if (.not. CHO_SIMP) then
          if (CHO_1CENTER) then
            YM = DIAG(INDRED(IQUAB(1,ISYM),2))
            do I=2,NQUAL(ISYM)
              YM = max(YM,DIAG(INDRED(IQUAB(I,ISYM),2)))
            end do
          else
            YM = XM
          end if
          DIAMIN(ISYM) = max(YM*SPAN,THRCOM)
        end if

        ! Subtract this Cholesky vector from integrals. If
        ! the corresponding diagonal element is zero, the
        ! column will no longer be qualified and subtraction
        ! can safely be skipped.
        ! --------------------------------------------------

        do I=1,NQUAL(ISYM)
          II = IQUAB(I,ISYM)
          JJ = INDRED(II,2)
          if (DIAG(JJ) /= Zero) then
            KOFF2 = KINT1+NNBSTR(ISYM,2)*(I-1)-1
            KOFF3 = KOFF0+II-IIBSTR(ISYM,2)
            FAC = -WRK(KOFF3)
            WRK(KOFF2+1:KOFF2+NNBSTR(ISYM,2)) = WRK(KOFF2+1:KOFF2+NNBSTR(ISYM,2))-WRK(KOFF3)*WRK(KOFF0+1:KOFF0+NNBSTR(ISYM,2))
          end if
        end do

        ! Store Cholesky vector in buffer.
        ! --------------------------------

        IDUMP = IDUMP+1

        KOFF2 = KCHO1+NNBSTR(ISYM,2)*(IDUMP-1)-1
        WRK(KOFF2+1:KOFF2+NNBSTR(ISYM,2)) = WRK(KOFF0+1:KOFF0+NNBSTR(ISYM,2))

        ! Update Cholesky vector counters.
        ! --------------------------------

        IVEC = IVEC+1
        IVECT = IVECT+1

        ! Set info for this vector.
        ! -------------------------

        call CHO_SETVECINF(IVEC,ISYM,IABG,IPASS,2)

        ! Print progress report.
        ! ----------------------

        if (IPRINT >= INF_PROGRESS) write(LUPRI,'(I3,3(1X,I9),2(1X,ES11.3),2(1X,I4),1X,ES11.3)') ISYM,IVEC,IVECT,IABG,XC,OLDIAG, &
                                                                                                 NCONV,NNEG,XM

      end if

      ! Dump vectors to disk when there is no more to be done, or
      ! when the buffer is full.
      ! ---------------------------------------------------------

      if (LAST .or. (IDUMP == NUMBUF)) then
        call CWTIME(C1,W1)
        IVEC1 = NUMCHO(ISYM)+1
        call CHO_PUTVEC(WRK(KCHO1),NNBSTR(ISYM,2),IDUMP,IVEC1,ISYM)
        call CHO_VECBUF_COPY(WRK(KCHO1),IDUMP,ISYM)
        NUMCHO(ISYM) = NUMCHO(ISYM)+IDUMP
        NUMCHT = NUMCHT+IDUMP
        call CWTIME(C2,W2)
        TDECOM(1,2) = TDECOM(1,2)+C2-C1
        TDECOM(2,2) = TDECOM(2,2)+W2-W1
        if (LAST) then
          exit  ! cycle symmetry loop
        else
          IVEC = NUMCHO(ISYM)
          IVECT = NUMCHT
          IDUMP = 0
        end if
      end if

    end do
  end if

  ! Cycle point: go to next symmetry.
  ! ---------------------------------

  if (IPRINT >= INF_PROGRESS) call XFLUSH(LUPRI)

end do

if (IPRINT >= INF_PROGRESS) then
  NUMCHO_OLD(1:NSYM) = NUMCHO(1:NSYM)-NUMCHO_OLD(1:NSYM)
  write(LUPRI,'(A)') repeat('-',79)
  write(LUPRI,'(A,8I8)') '#vec. gener.  : ',(NUMCHO_OLD(ISYM),ISYM=1,NSYM)
else if (IPRINT >= INF_PASS) then
  NUMCHO_OLD(1:NSYM) = NUMCHO(1:NSYM)-NUMCHO_OLD(1:NSYM)
  write(LUPRI,'(A,8I8)') '#vec. gener.  : ',(NUMCHO_OLD(ISYM),ISYM=1,NSYM)
end if

end subroutine CHO_DECOM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_density2(irc,EOcc,EVir,EFro,Wrk,lWrk)
!
! Jonas Bostrom, Mars 2010
!
! Purpose: Solve the CPHF-equations to obtain occ-vir
!          contributions to the 1-pdm.

use Cholesky, only: nSym, NumCho
use ChoMP2, only: iAdrOff, iFro, iOcc, iVir, kFLagr, kLagr, kPab, kPai, kPaK, kPij, kPik, kWab, kWai, kWaK, kWij, kWiK, kWJK, &
                  lFLagr, lUnit_F, LuVVec, LuWVec, MP2D, MP2W, nFro, nMoMo, nOcc, nOrb, nVir
use Constants, only: Zero, One, Two, Three, Four, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: EOcc(*), EVir(*), EFro(*)
integer(kind=iwp), intent(in) :: lWrk
real(kind=wp), intent(inout) :: Wrk(lWrk)
integer(kind=iwp) :: i, iA, iAdr, iB, iBat, iClos, iI, iIter, iJ, indx, index1, iOff, iOff1, iOff2, iOffL, iOpt, iOrb, iOrbI, &
                     iSeed, iSym, iSym1, iSymOffOV, iTypL, iVec, iVec1, iVecFF, iVecFO, iVecFV, iVecOF, iVecOO, iVecOV, iVecVF, &
                     iVecVO, iVecVV, j, jOrb, kCGVec(9), kDiag(2), kEndCGVec(9), kEndDiag, kEndFDiag, kEndLab, kEndLfa, kEndLia, &
                     kEndLij, kEndLiK, kEndLip, kEndLJK, kEndLKa, kEndLKi, kEndU, kEndVip, kLab, kLfa, kLia, kLij, kLiK, kLip, &
                     kLJK, kLKa, kLKi, kU, kVip, kWij2, lCGFVec, lCGOVec, lCGVec, lDiag, lFDiag, lLab, lLfa, lLia, lLij, lLiK, &
                     lLip, lLJK, lLKa, lLKi, lScr, lTot, lU, lVip, lWij2, maxvalue, nA, nBatL, nCGvec, nI, nIter, nOccAll(8), &
                     NumVec, nVec
real(kind=wp) :: Ea, Eb, Ei, Ej, Eps, Res, term
logical(kind=iwp) :: Done
character(len=5) :: Fname
character(len=*), parameter :: SecNam = 'ChoMP2g_Density2'
integer(kind=iwp), external :: IsFreeUnit

! Do not delete vectors after use.
! --------------------------------
iClos = 2
iTypL = 1
iVecFF = 1
iVecOV = 6
iVecVV = 9
iVecOO = 5
iVecFV = 3
iVecFO = 2
iVecOF = 4

! Setup the conjugate gradient procedure
! --------------------------------------
Eps = 1.0e-8_wp
Done = .false.
nIter = 100

! Allocate memory for Frozen Diagonal of A
! ----------------------------------------
lFDiag = nMoMo(1,iVecFV)
kDiag(1) = kFLagr(1)+lFLagr
kEndFDiag = kDiag(1)+lFDiag
Wrk(kDiag(1):kEndFDiag-1) = Zero

! Allocate memory for Occupied Diagonal of A
! ------------------------------------------
lDiag = nMoMo(1,iVecOV)
kDiag(2) = kEndFDiag
kEndDiag = kDiag(2)+lDiag
Wrk(kDiag(2):kEndDiag-1) = Zero

iSym = 1
nOccAll(iSym) = nFro(iSym)+nOcc(iSym)

! Open Cholesky vector files.
! ---------------------------
call ChoMP2_OpenF(1,1,iSym)

maxvalue = 200
nVec = min(NumCho(iSym),maxvalue)
nBatL = (NumCho(iSym)-1)/nVec+1
if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[1]')

! Allocate memory for Lia-vector and LIa-vector
! ---------------------------------------------

lLfa = nMoMo(iSym,iVecFV)*nVec
kLfa = kEndDiag
kEndLfa = kLfa+lLfa

lLia = nMoMo(iSym,iVecOV)*nVec
kLia = kEndLfa
kEndLia = kLia+lLia

do iBat=1,nBatL
  if (iBat == nBatL) then
    NumVec = NumCho(iSym)-nVec*(nBatL-1)
  else
    NumVec = nVec
  end if
  iVec = nVec*(iBat-1)+1

  ! Read Lfa-vectors
  ! ----------------
  iOpt = 2
  lTot = nMoMo(iSym,iVecFV)*NumVec
  iAdr = nMoMo(iSym,iVecFV)*(iVec-1)+1+iAdrOff(iSym,iVecFV)
  call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLfa),lTot,iAdr)

  ! Read Lia-vectors
  ! ----------------
  iOpt = 2
  lTot = nMoMo(iSym,iVecOV)*NumVec
  iAdr = nMoMo(iSym,iVecOV)*(iVec-1)+1+iAdrOff(iSym,iVecOV)
  call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLia),lTot,iAdr)

  ! Construct Diagonal of A
  ! -----------------------
  do iVec1=1,NumVec
    do i=1,nMoMo(iSym,iVecFV)
      iOffL = (iVec1-1)*nMoMo(iSym,iVecFV)
      Wrk(kDiag(1)+i-1) = Wrk(kDiag(1)+i-1)+Three*Wrk(kLfa+i-1+iOffL)**2
    end do
  end do
  do iVec1=1,NumVec
    do i=1,nMoMo(iSym,iVecOV)
      iOffL = (iVec1-1)*nMoMo(iSym,iVecOV)
      Wrk(kDiag(2)+i-1) = Wrk(kDiag(2)+i-1)+Three*Wrk(kLia+i-1+iOffL)**2
    end do
  end do

  index1 = 0
  do iSym1=1,nSym
    nA = nVir(iSym1)
    nI = nFro(iSym1)
    do iI=1,nI
      Ei = EFro(iFro(iSym1)+iI)
      do iA=1,nA
        indx = iA-1+(iI-1)*nA+index1
        Ea = EVir(iVir(iSym1)+iA)
        Wrk(kDiag(1)+indx) = Wrk(kDiag(1)+indx)+Ea-Ei
      end do
    end do
    nI = nOcc(iSym1)
    do iI=1,nI
      Ei = EOcc(iOcc(iSym1)+iI)
      do iA=1,nA
        indx = iA-1+(iI-1)*nA+index1
        Ea = EVir(iVir(iSym1)+iA)
        Wrk(kDiag(2)+indx) = Wrk(kDiag(2)+indx)+Ea-Ei
      end do
    end do
    index1 = index1+nOcc(iSym1)*nVir(iSym1)
  end do
  do i=1,lFDiag
    Wrk(kDiag(1)+i-1) = One/Wrk(kDiag(1)+i-1)
  end do
  do i=1,lDiag
    Wrk(kDiag(2)+i-1) = One/Wrk(kDiag(2)+i-1)
  end do
end do

call ChoMP2_OpenF(iClos,1,iSym)

! Allocate vectors needed for the PCG
! -----------------------------------
lCGFVec = sum(nFro(1:nSym)*nVir(1:nSym))
lCGOVec = sum(nOcc(1:nSym)*nVir(1:nSym))
lCGVec = lCGOVec+lCGFVec
! Vector Legend (as they are named in Conj_Grad):
!                Z = 1, Ztemp = 2
!                R = 3, Rtemp = 4
!                P = 5, Ptemp = 6
!                X = 7, Xtemp = 8
!                AP = 9

kCGVec(1) = kEndDiag
kEndCGVec(1) = kCGVec(1)+lCGVec
Wrk(kCGVec(1):kEndCGVec(1)-1) = Zero
nCGvec = 9

do i=2,nCGVec
  kCGVec(i) = kEndCGVec(i-1)
  kEndCGVec(i) = kCGVec(i)+lCGVec
  Wrk(kCGVec(i):kEndCGVec(i)-1) = Zero
end do

! Calculate initial values for the CG-vectors needing that
! --------------_-----------------------------------------

do i=1,lCGFVec
  Wrk(kCGVec(1)+i-1) = Wrk(kFLagr(1)+i-1)*Wrk(kDiag(1)+i-1)
  Wrk(kCGVec(3)+i-1) = Wrk(kFLagr(1)+i-1)
  Wrk(kCGVec(5)+i-1) = Wrk(kCGVec(1)+i-1)
end do
iOff = lCGFVec
do i=1,lCGOVec
  Wrk(kCGVec(1)+i-1+iOff) = Wrk(kLagr(1)+i-1)*Wrk(kDiag(2)+i-1)
  Wrk(kCGVec(3)+i-1+iOff) = Wrk(kLagr(1)+i-1)
  Wrk(kCGVec(5)+i-1+iOff) = Wrk(kCGVec(1)+i-1+iOff)
end do

do iIter=1,nIter
  Wrk(kCGVec(9):kCGVec(9)+lCGVec-1) = Zero

  ! Calculate A*p
  ! -------------
  do iSym=1,nSym

    ! Open Cholesky vector files.
    ! ---------------------------
    call ChoMP2_OpenF(1,1,iSym)

    iSeed = 7
    LuVVec = IsFreeUnit(iSeed)
    write(Fname,'(A4,I1)') 'TMPV',2
    call DaName_MF_WA(LuVVec,Fname)

    iSeed = 7
    LuWVec = IsFreeUnit(iSeed)
    write(Fname,'(A4,I1)') 'TMPV',3
    call DaName_MF_WA(LuWVec,Fname)

    nVec = min(NumCho(iSym),maxvalue)
    if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[1]')

    lScr = lWrk-kEndCGVec(9)
    iOff = lCGFVec

    ! Construct The Frozen part of A*P
    ! --------------------------------
    call ChoMP2g_Constrap(irc,Wrk(kEndCGVec(9)),lScr,'fvvf',iSym,nVec,Wrk(kCGVec(9)),lCGFVec,Wrk(kCGVec(5)),lCGFVec,One)
    call ChoMP2g_Constrap(irc,Wrk(kEndCGVec(9)),lScr,'ovvf',iSym,nVec,Wrk(kCGVec(9)),lCGFVec,Wrk(kCGVec(5)+iOff),lCGOVec,One)
    ! Construct The Occupied part of A*P
    ! ----------------------------------
    call ChoMP2g_Constrap(irc,Wrk(kEndCGVec(9)),lScr,'fvvo',iSym,nVec,Wrk(kCGVec(9)+iOff),lCGOVec,Wrk(kCGVec(5)),lCGFVec,One)
    call ChoMP2g_Constrap(irc,Wrk(kEndCGVec(9)),lScr,'ovvo',iSym,nVec,Wrk(kCGVec(9)+iOff),lCGOVec,Wrk(kCGVec(5)+iOff),lCGOVec,One)

    call ChoMP2_OpenF(iClos,1,iSym)
    call DaClos(LuVVec)
    call DaClos(LuWVec)

  end do

  index1 = 0
  do iSym1=1,nSym
    nA = nVir(iSym1)
    nI = nFro(iSym1)
    do iI=1,nI
      Ei = EFro(iFro(iSym1)+iI)
      do iA=1,nA
        indx = iA-1+(iI-1)*nA+index1
        Ea = EVir(iVir(iSym1)+iA)
        Wrk(kCGVec(9)+indx) = Wrk(kCGVec(9)+indx)+(Ea-Ei)*Wrk(kCGVec(5)+indx)
      end do
    end do
    nI = nOcc(iSym1)
    do iI=1,nI
      Ei = EOcc(iOcc(iSym1)+iI)
      do iA=1,nA
        indx = iA-1+(iI-1)*nA+index1
        Ea = EVir(iVir(iSym1)+iA)
        Wrk(kCGVec(9)+indx+iOff) = Wrk(kCGVec(9)+indx+iOff)+(Ea-Ei)*Wrk(kCGVec(5)+indx+iOff)
      end do
    end do
    index1 = index1+(nFro(iSym1)+nOcc(iSym1))*nVir(iSym1)
  end do

  call Conj_Grad(Done,lCGVec,Wrk(kDiag(1)),Wrk(kCGVec(7)),Wrk(kCGVec(8)),Wrk(kCGVec(3)),Wrk(kCGVec(4)),Wrk(kCGVec(5)), &
                 Wrk(kCGVec(6)),Wrk(kCGVec(1)),Wrk(kCGVec(2)),Wrk(kCGVec(9)),Eps,Res)
  if (Done) exit
end do
if (.not. Done) then
  write(u6,*) '***************WARNING************************'
  write(u6,*) ''
  write(u6,*) 'Too many iterations, this is what you get after:'
  write(u6,*) nIter,' Iterations'
  write(u6,*) 'The residual is',res,'and not',Eps
  write(u6,*) '**********************************************'
end if

! Construct MP2 Density contribution from parts of the matrix
! -----------------------------------------------------------
iSymOffOV = 0
do iSym=1,nSym
  do i=1,nOcc(iSym)
    iOrb = nFro(iSym)+i
    do j=1,nFro(iSym)
      jOrb = j
      MP2D(iSym)%A(jOrb,iOrb) = Wrk(kPiK(iSym)+i-1+nOcc(iSym)*(j-1))
      MP2D(iSym)%A(iOrb,jOrb) = MP2D(iSym)%A(jOrb,iOrb)
    end do
  end do

  do i=1,nOcc(iSym)
    iOrb = nFro(iSym)+i
    do j=1,nOcc(iSym)
      jOrb = nFro(iSym)+j
      MP2D(iSym)%A(jOrb,iOrb) = Wrk(kPij(iSym)+j-1+nOcc(iSym)*(i-1))
    end do
  end do

  do iI=1,nFro(iSym)
    do iA=1,nVir(iSym)
      Wrk(kPaK(iSym)+iA-1+nVir(iSym)*(iI-1)) = Wrk(kCGVec(7)+iA-1+nVir(iSym)*(iI-1)+iSymOffOV)
    end do
  end do
  do iI=1,nOcc(iSym)
    iOrbI = nFro(iSym)+iI
    do iA=1,nVir(iSym)
      Wrk(kPai(iSym)+iA-1+nVir(iSym)*(iI-1)) = Wrk(kCGVec(7)+iA-1+nVir(iSym)*(iOrbI-1)+iSymOffOV)
    end do
  end do

  do i=1,nFro(iSym)+nOcc(iSym)
    iOrb = i
    do j=1,nVir(iSym)
      jOrb = nFro(iSym)+nOcc(iSym)+j
      MP2D(iSym)%A(jOrb,iOrb) = Wrk(kCGVec(7)+j-1+(nVir(iSym))*(i-1)+iSymOffOV)
      MP2D(iSym)%A(iOrb,jOrb) = MP2D(iSym)%A(jOrb,iOrb)

    end do
  end do

  do i=1,nVir(iSym)
    iOrb = nFro(iSym)+nOcc(iSym)+i
    do j=1,nVir(iSym)
      jOrb = nFro(iSym)+nOcc(iSym)+j
      MP2D(iSym)%A(jOrb,iOrb) = Wrk(kPab(iSym)+j-1+nVir(iSym)*(i-1))
    end do
  end do
  iSymOffOV = iSymOffOV+(nOcc(iSym)+nFro(iSym))*nVir(iSym)
end do

! Add type (II) terms to W-matrix
! -------------------------------

do iSym=1,nsym
  do iI=1,nOcc(iSym)
    Ei = EOcc(iOcc(iSym)+iI)
    do iJ=1,nFro(iSym)
      Ej = EFro(iFro(iSym)+iJ)
      Wrk(kWiK(iSym)+iI-1+nOcc(iSym)*(iJ-1)) = Wrk(kWiK(iSym)+iI-1+nOcc(iSym)*(iJ-1))-Wrk(kPiK(iSym)+iI-1+nOcc(iSym)*(iJ-1))*(Ei+Ej)
    end do
  end do
  do iI=1,nOcc(iSym)
    Ei = EOcc(iOcc(iSym)+iI)
    do iJ=1,nOcc(iSym)
      Ej = EOcc(iOcc(iSym)+iJ)
      Wrk(kWij(iSym)+iJ-1+nOcc(iSym)*(iI-1)) = Wrk(kWij(iSym)+iJ-1+nOcc(iSym)*(iI-1))- &
                                               Half*Wrk(kPij(iSym)+iJ-1+nOcc(iSym)*(iI-1))*(Ei+Ej)
    end do
  end do
  do iA=1,nVir(iSym)
    Ea = EVir(iVir(iSym)+iA)
    do iB=1,nVir(iSym)
      Eb = EVir(iVir(iSym)+iB)
      Wrk(kWab(iSym)+iB-1+nVir(iSym)*(iA-1)) = Wrk(kWab(iSym)+iB-1+nVir(iSym)*(iA-1))- &
                                               Half*Wrk(kPab(iSym)+iB-1+nVir(iSym)*(iA-1))*(Ea+Eb)
    end do
  end do
  do iI=1,nFro(iSym)
    Ei = Efro(iFro(iSym)+iI)
    iOrbI = iI
    do iA=1,nVir(iSym)
      Wrk(kWak(iSym)+iA-1+nVir(iSym)*(iI-1)) = Wrk(kWak(iSym)+iA-1+nVir(iSym)*(iI-1))-Two*Wrk(kPaK(iSym)+iA-1+nVir(iSym)*(iI-1))*Ei
    end do
  end do
  do iI=1,nOcc(iSym)
    Ei = EOcc(iOcc(iSym)+iI)
    iOrbI = nFro(iSYm)+iI
    do iA=1,nVir(iSym)
      Wrk(kWai(iSym)+iA-1+nVir(iSym)*(iI-1)) = Wrk(kWai(iSym)+iA-1+nVir(iSym)*(iI-1))-Two*Wrk(kPai(iSym)+iA-1+nVir(iSym)*(iI-1))*Ei
    end do
  end do

end do

iSym = 1

! Add type (III) terms to W-matrix
! -------------------------------

! Open Cholesky vector files.
! ---------------------------
call ChoMP2_OpenF(1,1,iSym)

nVec = min(NumCho(iSym),maxvalue)
if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[1]')
nBatL = (NumCho(iSym)-1)/nVec+1

! Allocate memory for U-vector
! ----------------------------

lU = nVec
kU = kEndDiag
kEndU = kU+lU

! Allocate memory for Lia-vector and LIa-vector
! ---------------------------------------------

lLfa = nMoMo(iSym,iVecFV)*nVec
kLfa = kEndU
kEndLfa = kLfa+lLfa

lLia = nMoMo(iSym,iVecOV)*nVec
kLia = kEndLfa
kEndLia = kLia+lLia

lLij = nMoMo(iSym,iVecOO)*nVec
kLij = kEndLia
kEndLij = kLij+lLij

lLiK = nMoMo(iSym,iVecOF)*nVec
kLiK = kEndLij
kEndLiK = kLiK+lLiK

lLKi = nMoMo(iSym,iVecFO)*nVec
kLKi = kEndLiK
kEndLKi = kLKi+lLKi

lLab = nMoMo(iSym,iVecVV)*nVec
kLab = kEndLKi
kEndLab = kLab+lLab

lLJK = nMoMo(iSym,iVecFF)*nVec
kLJK = kEndLab
kEndLJK = kLJK+lLJK

do iBat=1,nBatL
  if (iBat == nBatL) then
    NumVec = NumCho(iSym)-nVec*(nBatL-1)
  else
    NumVec = nVec
  end if
  iVec = nVec*(iBat-1)+1
  Wrk(kU:kU+lU-1) = Zero

  ! Read Lij^J-vectors from disk
  ! ----------------------------

  if (NumVec > 0) then
    iOpt = 2
    lTot = nMoMo(iSym,iVecOO)*NumVec
    iAdr = 1+nMoMo(iSym,iVecOO)*(iVec-1)+iAdrOff(iSym,iVecOO)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLij),lTot,iAdr)
  end if

  ! Read LiK^J-vectors from disk
  ! ----------------------------

  if (NumVec > 0) then
    iOpt = 2
    lTot = nMoMo(iSym,iVecOF)*NumVec
    iAdr = 1+nMoMo(iSym,iVecOF)*(iVec-1)+iAdrOff(iSym,iVecOF)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLiK),lTot,iAdr)
  end if

  ! Read LKi^J-vectors from disk
  ! ----------------------------

  if (NumVec > 0) then
    iOpt = 2
    lTot = nMoMo(iSym,iVecFO)*NumVec
    iAdr = 1+nMoMo(iSym,iVecFO)*(iVec-1)+iAdrOff(iSym,iVecFO)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLKi),lTot,iAdr)
  end if

  ! Read LIK^J-vectors from disk
  ! ----------------------------

  if (NumVec > 0) then
    iOpt = 2
    lTot = nMoMo(iSym,iVecFF)*NumVec
    iAdr = 1+nMoMo(iSym,iVecFF)*(iVec-1)+iAdrOff(iSym,iVecFF)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLJK),lTot,iAdr)
  end if

  ! Read Lia^J-vectors from disk
  ! ----------------------------

  if (NumVec > 0) then
    iOpt = 2
    lTot = nMoMo(iSym,iVecOV)*NumVec
    iAdr = 1+nMoMo(iSym,iVecOV)*(iVec-1)+iAdrOff(iSym,iVecOV)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLia),lTot,iAdr)
  end if

  ! Read Lfa^J-vectors from disk
  ! ----------------------------

  if (NumVec > 0) then
    iOpt = 2
    lTot = nMoMo(iSym,iVecFV)*NumVec
    iAdr = 1+nMoMo(iSym,iVecFV)*(iVec-1)+iAdrOff(iSym,iVecFV)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLfa),lTot,iAdr)
  end if

  ! Read Lab^J-vectors from disk
  ! ----------------------------

  if (NumVec > 0) then
    iOpt = 2
    lTot = nMoMo(iSym,iVecVV)*NumVec
    iAdr = 1+nMoMo(iSym,iVecVV)*(iVec-1)+iAdrOff(iSym,iVecVV)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLab),lTot,iAdr)
  end if

  ! Construct U^J intermediate vectors
  ! ----------------------------------
  if (NumVec*nMoMo(iSym,iVecOO) /= 0) call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecOO),One,Wrk(kPij(iSym)),1,Wrk(kLij), &
                                                  nMoMo(iSym,iVecOO),One,Wrk(kU),1)

  if (NumVec*nMoMo(iSym,iVecFO) /= 0) call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecFO),Two,Wrk(kPiK(iSym)),1,Wrk(kLKi), &
                                                  nMoMo(iSym,iVecFO),One,Wrk(kU),1)

  if (NumVec*nMoMo(iSym,iVecOV) /= 0) call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecOV),Two,Wrk(kPai(iSym)),1,Wrk(kLia), &
                                                  nMoMo(iSym,iVecOV),One,Wrk(kU),1)

  if (NumVec*nMoMo(iSym,iVecFV) /= 0) call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecFV),Two,Wrk(kPaK(iSym)),1,Wrk(kLfa), &
                                                  nMoMo(iSym,iVecFV),One,Wrk(kU),1)

  if (NumVec*nMoMo(iSym,iVecVV) /= 0) call dGemm_('N','N',1,NumVec,nMoMo(iSym,iVecVV),One,Wrk(kPab(iSym)),1,Wrk(kLab), &
                                                  nMoMo(iSym,iVecVV),One,Wrk(kU),1)

  ! Construct contribution to Wij
  ! -----------------------------

  if (nMoMo(iSym,iVecOO) /= 0) call dGemm_('N','N',nMoMo(iSym,iVecOO),1,NumVec,-Two,Wrk(kLij),nMoMo(iSym,iVecOO),Wrk(kU),NumVec, &
                                           One,Wrk(kWij(iSym)),nMoMo(iSym,iVecOO))

  ! Construct Contribution to WiK
  ! -----------------------------

  if (nMoMo(iSym,iVecOF) /= 0) call dGemm_('N','N',nMoMo(iSym,iVecOF),1,NumVec,-Four,Wrk(kLKi),nMoMo(iSym,iVecOF),Wrk(kU),NumVec, &
                                           One,Wrk(kWiK(iSym)),nMoMo(iSym,iVecOF))

  ! Construct Contribution to WJK
  ! -----------------------------

  if (nMoMo(iSym,iVecFF) /= 0) call dGemm_('N','N',nMoMo(iSym,iVecFF),1,NumVec,-Two,Wrk(kLJK),nMoMo(iSym,iVecFF),Wrk(kU),NumVec, &
                                           One,Wrk(kWJK(iSym)),nMoMo(iSym,iVecFF))

end do

iVecFF = 1
iVecOF = 2
iVecVF = 3
iVecFO = 4
iVecOO = 5
iVecVO = 6
iVecFV = 7
iVecOV = 8
iVecVV = 9

! Allocate memory for Lia-vector and LIa-vector
! ---------------------------------------------

lLJK = nMoMo(iSym,iVecFF)*nVec
kLJK = kEndDiag
kEndLJK = kLJK+lLJK

lLKi = nMoMo(iSym,iVecOF)*nVec
kLKi = kEndLJK
kEndLKi = kLKi+lLKi

lLKa = nMoMo(iSym,iVecVF)*nVec
kLKa = kEndLKi
kEndLKa = kLKa+lLKa

lLiK = nMoMo(iSym,iVecFO)*nVec
kLiK = kEndLKa
kEndLiK = kLiK+lLiK

lLij = nMoMo(iSym,iVecOO)*nVec
kLij = kEndLiK
kEndLij = kLij+lLij

lLia = nMoMo(iSym,iVecVO)*nVec
kLia = kEndLij
kEndLia = kLia+lLia

lLip = nOccAll(iSym)*nOrb(iSym)*nVec
kLip = kEndLia
kEndLip = kLip+lLip

lVip = nOccAll(iSym)*nOrb(iSym)*nVec
kVip = kEndLip
kEndVip = kVip+lVip

lWij2 = nOccAll(iSym)*nOccAll(iSym)
kWij2 = kEndVip
Wrk(kWij2:kWij2+lWij2-1) = Zero

do iBat=1,nBatL
  if (iBat == nBatL) then
    NumVec = NumCho(iSym)-nVec*(nBatL-1)
  else
    NumVec = nVec
  end if
  iVec = nVec*(iBat-1)+1

  ! Read Lpq^J-vectors from disk
  ! ----------------------------

  if (NumVec > 0) then
    iOpt = 2
    lTot = nMoMo(iSym,iVecFF)*NumVec
    iAdr = 1+nMoMo(iSym,iVecFF)*(iVec-1)+iAdrOff(iSym,iVecFF)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLJK),lTot,iAdr)

    lTot = nMoMo(iSym,iVecOF)*NumVec
    iAdr = 1+nMoMo(iSym,iVecOF)*(iVec-1)+iAdrOff(iSym,iVecOF)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLKi),lTot,iAdr)

    lTot = nMoMo(iSym,iVecVF)*NumVec
    iAdr = 1+nMoMo(iSym,iVecVF)*(iVec-1)+iAdrOff(iSym,iVecVF)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLKa),lTot,iAdr)

    lTot = nMoMo(iSym,iVecFO)*NumVec
    iAdr = 1+nMoMo(iSym,iVecFO)*(iVec-1)+iAdrOff(iSym,iVecFO)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLiK),lTot,iAdr)

    lTot = nMoMo(iSym,iVecOO)*NumVec
    iAdr = 1+nMoMo(iSym,iVecOO)*(iVec-1)+iAdrOff(iSym,iVecOO)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLij),lTot,iAdr)

    lTot = nMoMo(iSym,iVecVO)*NumVec
    iAdr = 1+nMoMo(iSym,iVecVO)*(iVec-1)+iAdrOff(iSym,iVecVO)
    call dDaFile(lUnit_F(iSym,iTypL),iOpt,Wrk(kLia),lTot,iAdr)
  end if

  ! Put the Lpq-vectors together to one large vector
  ! ------------------------------------------------

  iOff2 = kLip
  do iVec1=1,NumVec
    do i=1,nFro(iSym)
      iOff1 = kLJK+nMoMo(iSym,iVecFF)*(iVec1-1)+(i-1)*nFro(iSym)
      Wrk(iOff2:iOff2+nFro(iSym)-1) = Wrk(iOff1:iOff1+nFro(iSym)-1)
      iOff2 = iOff2+nFro(iSym)
      iOff1 = kLKi+nMoMo(iSym,iVecOF)*(iVec1-1)+(i-1)*nOcc(iSym)
      Wrk(iOff2:iOff2+nOcc(iSym)-1) = Wrk(iOff1:iOff1+nOcc(iSym)-1)
      iOff2 = iOff2+nOcc(iSym)
      iOff1 = kLKa+nMoMo(iSym,iVecVF)*(iVec1-1)+(i-1)*nVir(iSym)
      Wrk(iOff2:iOff2+nVir(iSym)-1) = Wrk(iOff1:iOff1+nVir(iSym)-1)
      iOff2 = iOff2+nVir(iSym)
    end do
    do i=1,nOcc(iSym)
      iOff1 = kLiK+nMoMo(iSym,iVecFO)*(iVec1-1)+(i-1)*nFro(iSym)
      Wrk(iOff2:iOff2+nFro(iSym)-1) = Wrk(iOff1:iOff1+nFro(iSym)-1)
      iOff2 = iOff2+nFro(iSym)
      iOff1 = kLij+nMoMo(iSym,iVecOO)*(iVec1-1)+(i-1)*nOcc(iSym)
      Wrk(iOff2:iOff2+nOcc(iSym)-1) = Wrk(iOff1:iOff1+nOcc(iSym)-1)
      iOff2 = iOff2+nOcc(iSym)
      iOff1 = kLia+nMoMo(iSym,iVecVO)*(iVec1-1)+(i-1)*nVir(iSym)
      Wrk(iOff2:iOff2+nVir(iSym)-1) = Wrk(iOff1:iOff1+nVir(iSym)-1)
      iOff2 = iOff2+nVir(iSym)
    end do
  end do

  do iVec1=1,NumVec
    iOff = nOrb(iSym)*nOccAll(iSym)*(iVec1-1)
    call dGemm_('N','N',nOrb(iSym),nOccAll(iSym),nOrb(iSym),One,MP2D(iSym)%A,nOrb(iSym),Wrk(kLip+iOff),nOrb(iSym),Zero, &
                Wrk(kVip+iOff),nOrb(iSym))
  end do

  ! Construct exchange contribution to Wij
  ! --------------------------------------

  do iVec1=1,NumVec
    iOff = nOrb(iSym)*nOccAll(iSym)*(iVec1-1)
    call dGemm_('T','N',nOccAll(iSym),nOccAll(iSym),nOrb(iSym),One,Wrk(kLip+iOff),nOrb(iSym),Wrk(kVip+iOff),nOrb(iSym),One, &
                Wrk(kWij2),nOccAll(iSym))
  end do
end do

call ChoMP2_OpenF(iClos,1,iSym)

! Add SCF-density to MP2-density contribution
! -------------------------------------------
do iSym1=1,nSym
  do i=1,nOcc(iSym1)+nFro(iSym1)
    MP2D(iSym1)%A(i,i) = MP2D(iSym1)%A(i,i)+Two
  end do
end do

! Construct Mp2 + SCF W-density
! -----------------------------

do i=1,nFro(iSym)
  iOrb = i
  do j=1,nFro(iSym)
    jOrb = j
    term = Zero
    if (i == j) term = Efro(iFro(iSym)+i)
    MP2W(iSym)%A(jOrb,iOrb) = -Wrk(kWJK(iSym)+j-1+nFro(iSym)*(i-1))+Two*term-Wrk(kWij2+j-1+nOccAll(iSym)*(i-1))
  end do
end do
do i=1,nOcc(iSym)
  iOrb = nFro(iSym)+i
  do j=1,nFro(iSym)
    jOrb = j
    MP2W(iSym)%A(jOrb,iOrb) = -Half*Wrk(kWiK(iSym)+i-1+nOcc(iSym)*(j-1))-Wrk(kWij2+jOrb-1+nOccAll(iSym)*(iOrb-1))
    MP2W(iSym)%A(iOrb,jOrb) = MP2W(iSym)%A(jOrb,iOrb)
  end do
end do
do i=1,nOcc(iSym)
  iOrb = nFro(iSym)+i
  do j=1,nOcc(iSym)
    jOrb = nFro(iSym)+j
    term = Zero
    if (i == j) term = EOcc(iOcc(iSym)+i)
    MP2W(iSym)%A(jOrb,iOrb) = -Wrk(kWij(iSym)+j-1+nOcc(iSym)*(i-1))+Two*term-Wrk(kWij2+jOrb-1+nOccAll(iSym)*(iOrb-1))
  end do
end do

do i=1,nFro(iSym)
  iOrb = i
  do j=1,nVir(iSym)
    jOrb = nFro(iSym)+nOcc(iSym)+j
    MP2W(iSym)%A(jOrb,iOrb) = -Half*Wrk(kWaK(iSym)+j-1+nVir(iSym)*(i-1))
    MP2W(iSym)%A(iOrb,jOrb) = MP2W(iSym)%A(jOrb,iOrb)
  end do
end do

do i=1,nOcc(iSym)
  iOrb = nFro(iSym)+i
  do j=1,nVir(iSym)
    jOrb = nFro(iSym)+nOcc(iSym)+j
    MP2W(iSym)%A(jOrb,iOrb) = -Half*Wrk(kWai(iSym)+j-1+nVir(iSym)*(i-1))
    MP2W(iSym)%A(iOrb,jOrb) = MP2W(iSym)%A(jOrb,iOrb)
  end do
end do

do i=1,nVir(iSym)
  iOrb = nFro(iSym)+nOcc(iSym)+i
  do j=1,nVir(iSym)
    jOrb = nFro(iSym)+nOcc(iSym)+j
    MP2W(iSym)%A(jOrb,iOrb) = -Wrk(kWab(iSym)+j-1+nVir(iSym)*(i-1))
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'Full One-electron Density Matrix'
do iSym=1,nSym
  call RecPrt('MP2D',' ',MP2D(iSym)%A,nOrb(iSym),nOrb(iSym))
end do
write(u6,*) 'Full One-electron energy weighted D Matrix'
do iSym=1,nSym
  call RecPrt('MP2W',' ',MP2W(iSym)%A,nOrb(iSym),nOrb(iSym))
end do
#endif

return

end subroutine ChoMP2g_density2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Select_Hidden(mTtAtm,nHidden,Coord,HiddenCoord,
     &                         iHiddenAN,nKept,rHidden,iPL)
      Implicit Real*8 (a-h,o-z)
*
*  Select among the hidden atoms the ones to be kept
*
#include "real.fh"
      Dimension Coord(3,mTtAtm),HiddenCoord(3,nHidden)
      Dimension iHiddenAN(nHidden)
*
*
*  Criteria: dMin < distance < rHidden
*
      dMax = rHidden ! bohr
      Do iHid = 1, nHidden
         X = HiddenCoord(1,iHid)
         Y = HiddenCoord(2,iHid)
         Z = HiddenCoord(3,iHid)
         iAN = iHiddenAN(iHid)
         iAtom = 0
10       iAtom = iAtom + 1
         Dist = sqrt((X-Coord(1,iAtom))**2+(Y-Coord(2,iAtom))**2+
     &               (Z-Coord(3,iAtom))**2)
         If(Dist .le. dMax) Then
            iHiddenAN(iHid) = - iAN
            nKept = nKept + 1
         End If
         If(iAtom.lt.mTtAtm .and. iHiddenAN(iHid).le.0) Goto 10
      End Do
*
*  The end
*
      If(iPL .gt. 3 .and. nKept .gt. 0) Write(6,'(A,i3,A)')
     &                ' Select_Hidden: ',nKept,' hidden atoms are kept'
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine o12ea_cvb(nparm1)
      implicit real*8 (a-h,o-z)
c ... Content of CI vectors ...
      logical, external :: tstcnt_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "opt2_cvb.fh"
#include "WrkSpc.fh"

      call ddnewopt_cvb()
      have_solved_it=.false.

c  Find CIVBS & CIVBH :
      ivuse_s=0
      ivuse_h=0
      do 10 iv=1,nv
      if(tstcnt_cvb(work(lc(iv)),4))ivuse_s=iv
      if(tstcnt_cvb(work(lc(iv)),5))ivuse_h=iv
10    continue
      ivuse2=3
      if(ivuse_h.eq.3.or.ivuse_s.eq.3)ivuse2=2
      if(ivuse_h.eq.2.or.ivuse_s.eq.2)ivuse2=4
      if(ivuse2.gt.nv)ivuse2=1
      if(ivuse_s.ne.0.and.ivuse_h.ne.0)then
        i1 = mstackr_cvb(nparm1)
        i2 = mstackr_cvb(nparm1)
        i3 = mstackr_cvb(nparm1)
        i4 = mstackr_cvb(nvb+nprorb)
        call o12ea2_cvb(work(i1),work(i2),work(i3),nparm1,
     >    work(lc(ivuse2)),work(lc(ivuse_s)),work(lc(ivuse_h)),
     >    work(lw(9)),work(lv(2)),work(i4))
        call mfreer_cvb(i1)
      else
        if(strucopt)then
          call ddguess_cvb(work(lv(2)),nvb,nprorb)
        else
          call ddguess_cvb([one],1,0)
        endif
      endif
      call str2vbc_cvb(work(lv(2)),work(lw(9)))
      call vb2cic_cvb(work(lw(9)),work(lc(3)))
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Diff_Numerical(nAt,nB,ipMP,ipC,nij,EC,iANr
     &                         ,ip_Ttot,ip_Ttot_Inv
     &                         ,lMax,iTP,dLimmo
     &                         ,Thrs1,Thrs2,nThrs,iPrint
     &                         ,ThrsMul,Pot_Expo,Pot_Point,Pot_Fac
     &                         ,Diffed)
      Implicit real*8 (a-h,o-z)

#include "WrkSpc.fh"

      Dimension EC(3,nij),dMullig((lMax*(lMax**2+6*lMax+11)+6)/6)
      Dimension A(2),dLimmo(2),Pot_Expo(nij*2),Pot_Point(nij)
      Dimension Pot_Fac(nij*4)
      Dimension iANr(nAt)

      Logical AboveThr,Diffed(nij*2),AboveMul(2)

      Character*50 UtChar
      Character*10 OneFile

*
*-- Pick up some auxiliary stuff.
*
      Write(OneFile,'(A)')'ONEINT'
      Call Diff_Aux1(nEPP,ipEPCo,nB,OneFile)
      Call GetMem('BasIndCent','Allo','Inte',ip_Center,nB)
      Call Get_iArray('Center Index',iWork(ip_Center),nB)
      Call GetMem('PickPoints','Allo','Inte',ipPick,nEPP)
      Call GetMem('DistPick','Allo','Real',ipDPick,nEPP)
      nB2=nB*(nB+1)/2

*
*-- Do a 'clever' determination of the threshold for the multipole
*   magnitude.
*
*      Call Diff_ThrsMul(ipMP,ThrsMul,ThrsMul_Clever,nAt,nij,lMax)
      ThrsMul_Clever=ThrsMul

*
*-- Run a numerical fit for each active centre.
*
      kauntA=0
      nAbove=0
      Do iAtom=1,nAt
        ii=iAtom*(iAtom+1)/2
        Do jAtom=1,iAtom
          ij=iAtom*(iAtom-1)/2+jAtom
          jj=jAtom*(jAtom+1)/2
*
*-- Pick up the nuclei+core charge.
*
          If(iAtom.eq.jAtom) then
            chPoint=Work(iTP+iAtom-1)
          Else
            chPoint=0.0d0
          Endif
*
*---- Pick out the multipole, the prefactors. If none is above a
*     certain threshold, then it is not meaningful to make them
*     diffuse. Also check which individual multipoles that should
*     be made diffuse.
*
          kaunt=0
          AboveThr=.false.
          Do l=0,lMax
            kComp=(l+1)*(l+2)/2
            dMag=0.0d0
            Do k=1,kComp
              dM=Work(ipMP+nij*kaunt+kauntA)
              dMullig(kaunt+1)=dM
              dMag=dMag+dM**2
              kaunt=kaunt+1
            Enddo
            dMag=sqrt(dMag)
            If((dMag.gt.ThrsMul_Clever).and.l.le.1) then
              AboveThr=.true.
              AboveMul(l+1)=.true.
            Elseif((dMag.le.ThrsMul_Clever).and.l.le.1) then
              AboveMul(l+1)=.false.
            Endif
          Enddo

          If(AboveThr) then
            nAbove=nAbove+1
*
*---- Select the potential points which should be used for this centre.
*
*            BS=0.5d0*(Bragg_Slater(iANr(iAtom))
*     &               +Bragg_Slater(iANr(jAtom)))
            BS=0.5d0*(vdWRad(iANr(iAtom))+vdWRad(iANr(jAtom)))
            Call PickPoints(nPick,ipPick,ipDPick,nEPP,ipEPCo,EC(1,ij)
     &                     ,dLimmo,BS)
*
*---- Compute the true potential from the density assigned to
*     this centre.
*
            Call GetMem('Potential','Allo','Real',iPotte,nPick)
            Call EPotPoint(iPotte,nPick,ipPick,ipDPick,nEPP
     &                    ,ip_Ttot,ip_Ttot_Inv,iANr(iAtom)
     &                    ,nB,iAtom,jAtom,ip_Center)

*
*---- Print the true potential for given centre if requested.
*
            If(iPrint.ge.5) then
              Write(UtChar,'(A,2I3)')'Partial density potential, centre'
     &                               ,iAtom,jAtom
              Call RecPrt(UtChar,' ',Work(iPotte),nPick,1)
            Endif

*
*---- All hail to the chiefs, i.e. Levenberg and Marquardt.
*
            Call LevMarquart(iPotte,nPick,ipPick,nEPP,ipEPCo,EC(1,ij)
     &                      ,dMullig,lMax,A,iAtom,jAtom,chPoint
     &                      ,Thrs1,Thrs2,nThrs,Chi2B,iPrint,AboveMul)
            Call GetMem('Potential','Free','Real',iPotte,nPick)
          Endif
*
*---- Store things for later.
*
          kaunt=0
          Pot_Point(kauntA+1)=chPoint
          Do iDC=1,2
            nK=iDC*(iDC+1)/2
            Do iK=1,nK
              kaunt=kaunt+1
              Pot_Fac(4*kauntA+kaunt)=dMullig(kaunt)
            Enddo
            If(.not.AboveThr) then
              Diffed(2*kauntA+iDC)=.false.
            Else
              If(A(iDC).lt.3.0d0.and.AboveMul(iDC)) then
                Diffed(2*kauntA+iDC)=.true.
                Pot_Expo(2*kauntA+iDC)=A(iDC)
              Else
                Diffed(2*kauntA+iDC)=.false.
                Pot_Expo(2*kauntA+iDC)=1.0d1 !Dummy
              Endif
            Endif
          Enddo
*
*---- Step the atom-pair counter.
*
          kauntA=kauntA+1
        Enddo
      Enddo

*
*-- Deallocations.
*
      Call GetMem('BasIndCent','Free','Inte',ip_Center,nB)
      Call GetMem('PickPoints','Free','Inte',ipPick,nEPP)
      Call GetMem('DistPick','Free','Real',ipDPick,nEPP)
      Call GetMem('PotPointCoord','Free','Real',ipEPCo,3*nEPP)
      irc=-1
      Call ClsOne(irc,0)

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(ipC)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Roland Lindh                                     *
!***********************************************************************

subroutine Get_Fmat_nondyn(Dma,Dmb,nBDT,DFTX)

use Fock_util_global, only: Deco
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use SpinAV, only: Do_SpinAV, DSC
use InfSCF, only: dmpk, E_nondyn, Erest_xc, KSDFT, nBas, nBB, nScreen, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBDT
real(kind=wp), intent(inout) :: Dma(nBDT), Dmb(nBDT)
logical(kind=iwp), intent(in) :: DFTX
integer(kind=iwp) :: i, iOff, ipDai, ipDbi, iRC, nDMat, nForb(8,2), nIorb(8,2)
real(kind=wp) :: dFMat, E2act(1), FactXI
type(DSBA_Type) :: FLT(2), KLT(2), PLT(2), POrb(2)
real(kind=wp), allocatable :: Dm(:,:)
real(kind=wp), external :: DDot_, Get_ExFac

nDMat = 2
nForb(1:nSym,:) = 0
if (DFTX) then
  FactXI = Get_ExFac(KSDFT)-One ! note this trick
else
  FactXI = One
end if

call Allocate_DT(PLT(1),nBas,nBas,nSym,aCase='TRI')
call Allocate_DT(PLT(2),nBas,nBas,nSym,aCase='TRI',Ref=PLT(1)%A0)
if (DFTX) then
  PLT(1)%A0(:) = Zero
else
  PLT(1)%A0(:) = Dma(:)+Dmb(:)
end if

call Allocate_DT(POrb(1),nBas,nBas,nSym)
call Allocate_DT(POrb(2),nBas,nBas,nSym)

call mma_allocate(Dm,nBB,2,Label='Dm')
call UnFold(Dma,nBDT,Dm(:,1),nBB,nSym,nBas)
call UnFold(Dmb,nBDT,Dm(:,2),nBB,nSym,nBas)

if (Do_SpinAV) then
  if (.not. DECO) then
    write(u6,*) ' Keywords NODE and SAVE are incompatible. '
    write(u6,*) ' NODE will be reset to default. '
    DECO = .true.
  end if
  Dm(:,1) = Dm(:,1)-DSc(:)
  Dm(:,2) = Dm(:,1)+DSc(:)
end if

iOff = 0
do i=1,nSym
  ipDai = 1+iOff
  call CD_InCore(Dm(ipDai,1),nBas(i),Porb(1)%SB(i)%A2,nBas(i),nIorb(i,1),1.0e-12_wp,irc)
  if (irc /= 0) then
    write(u6,*) ' Alpha density. Sym= ',i,'   rc= ',irc
    call RecPrt('Dm',' ',Dm(ipDai,1),nBas(i),nBas(i))
    call Abend()
  end if
  ipDbi = 1+iOff
  call CD_InCore(Dm(ipDbi,2),nBas(i),Porb(2)%SB(i)%A2,nBas(i),nIorb(i,2),1.0e-12_wp,irc)
  if (irc /= 0) then
    write(u6,*) ' Beta density. Sym= ',i,'   rc= ',irc
    call RecPrt('Dm',' ',Dm(ipDbi,1),nBas(i),nBas(i))
    call Abend()
  end if
  iOff = iOff+nBas(i)**2
end do

call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI')
call Allocate_DT(FLT(2),nBas,nBas,nSym,aCase='TRI')
FLT(1)%A0(:) = Zero
FLT(2)%A0(:) = Zero

call Allocate_DT(KLT(1),nBas,nBas,nSym,aCase='TRI')
call Allocate_DT(KLT(2),nBas,nBas,nSym,aCase='TRI')
KLT(1)%A0(:) = Zero
KLT(2)%A0(:) = Zero

dFmat = Zero
call CHO_LK_SCF(irc,nDMat,FLT,KLT,nForb,nIorb,Porb,PLT,FactXI,nSCReen,dmpk,dFmat)
if (irc /= 0) then
  call WarningMessage(2,'Start6. Non-zero rc in Cho_LK_scf.')
  call Abend()
end if

if (Do_SpinAV) then
  call UnFold(Dma,nBDT,Dm(:,1),nBB,nSym,nBas)
  call UnFold(Dmb,nBDT,Dm(:,2),nBB,nSym,nBas)
  Dm(:,1) = Dm(:,1)-DSc(:)
  Dm(:,2) = Dm(:,2)+DSc(:)
  call Fold(nSym,nBas,Dm(:,1),Dma)
  call Fold(nSym,nBas,Dm(:,2),Dmb)
end if

E2act(1) = Half*(ddot_(nBDT,Dma,1,FLT(1)%A0,1)+ddot_(nBDT,Dmb,1,FLT(2)%A0,1))
call GADSum(E2act(1),1)

if (DFTX) then
  Erest_xc = Erest_xc-E2act(1)
else
  E_nondyn = E_nondyn-E2act(1)
end if

call Deallocate_DT(KLT(2))
call Deallocate_DT(KLT(1))
call Deallocate_DT(FLT(2))
call Deallocate_DT(FLT(1))
call mma_deallocate(Dm)
call Deallocate_DT(POrb(2))
call Deallocate_DT(POrb(1))
call Deallocate_DT(PLT(2))
call Deallocate_DT(PLT(1))

return

end subroutine Get_Fmat_nondyn

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKCXA(NSYM,NOSH,NCXA,TRA,CXA)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NSYM, NOSH(NSYM), NCXA
real(kind=wp), intent(in) :: TRA(NCXA)
real(kind=wp), intent(out) :: CXA(NCXA)
integer(kind=iwp) :: I, ISTA, NDIMEN

ISTA = 1
do I=1,NSYM
  NDIMEN = NOSH(I)
  if (NDIMEN > 0) then
    call MKCXAL(NDIMEN,TRA(ISTA),CXA(ISTA))
    ISTA = ISTA+NDIMEN**2
  end if
end do

end subroutine MKCXA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

subroutine Get_PUVXLen(NPUVX)
! Rewritten from mcpdft/alloc.f

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use input_mclr, only: nAsh, nOrb, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: NPUVX
integer(kind=iwp) :: iSp, iSpq, iSpqr, iSq, iSr, iSs, nAq, nAr, nAs, nOp, nRS

NPUVX = 0
do iSp=1,nSym
  nOp = NORB(iSp)
  do iSq=1,nSym
    nAq = NASH(iSq)
    iSpq = Mul(iSp,iSq)
    do iSr=1,nSym
      iSpqr = Mul(iSpq,iSr)
      nAr = NASH(iSr)
      do iSs=1,iSr
        if (iSpqr /= iSs) exit
        nAs = NASH(iSs)
        nRS = nAr*nAs
        if (iSs == iSr) nRS = nTri_Elem(nAr)
        NPUVX = NPUVX+nOp*nAq*nRS
      end do
    end do
  end do
end do

end subroutine Get_PUVXLen

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Gen_GeoList()
      use GeoList
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iChCar
      use Sizes_of_Seward, only: S
      use Real_Info, only: TMass, qNuc, CoM, CoC
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "stdalloc.fh"
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(Centr,3,S%mCentr,label='Centr')
      Call mma_allocate(Mass,S%mCentr,label='Mass')
      Call mma_allocate(Chrg,S%mCentr,label='Chrg')
*                                                                      *
************************************************************************
*                                                                      *
*     Generate the center list.
*
      S%kCentr=0
*
      nc = 1
      Do jCnttp = 1, nCnttp
         mCnt = dbsc(jCnttp)%nCntr
*
*        Do not include Auxiliary basis sets, or fragment basis sets
*
         If (dbsc(jCnttp)%Aux.or.dbsc(jCnttp)%Frag) Cycle
*
*        Do not include ECP basis sets which does not have any valence
*        basis set.
*
         If (dbsc(jCnttp)%ECP.and.dbsc(jCnttp)%nVal.eq.0) Cycle
*
         Do jCnt = 1, mCnt
            ndc = jCnt + dbsc(jCnttp)%mdci
            Do i = 0, nIrrep/dc(ndc)%nStab - 1
               Call OA(dc(ndc)%iCoSet(i,0),dbsc(jCnttp)%Coor(1:3,jCnt),
     &                 Centr(1:3,nc))
               nchr=dbsc(jCnttp)%AtmNr
               If (nchr.ge.0) Then
                  Mass(nc) = dbsc(jCnttp)%CntMass
               Else
                  Mass(nc) = Zero
               End If
               nchr=dbsc(jCnttp)%AtmNr
               If (nchr.ge.0) Then
                  Chrg(nc) = DBLE(nchr)
               Else
                  Chrg(nc) = Zero
               End If
               nc = nc + 1
            End Do
            S%kCentr = S%kCentr + nIrrep/dc(ndc)%nStab
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Compute Total Charge and Center of Charge centroid
*
      Call CoW(Centr,CoC,Chrg,S%kCentr,qNuc)
      If (iChCar(1).ne.0) CoC(1)=Zero
      If (iChCar(2).ne.0) CoC(2)=Zero
      If (iChCar(3).ne.0) CoC(3)=Zero
*                                                                      *
************************************************************************
*                                                                      *
*     Modify charges to effective charges.
*
      nc = 1
      Do jCnttp = 1, nCnttp
         Z = dbsc(jCnttp)%Charge
         mCnt = dbsc(jCnttp)%nCntr
         If (dbsc(jCnttp)%Aux.or.dbsc(jCnttp)%Frag) Cycle
         Do jCnt = 1, mCnt
            ndc = jCnt + dbsc(jCnttp)%mdci
            Do i = 0, nIrrep/dc(ndc)%nStab - 1
               nchr=dbsc(jCnttp)%AtmNr
               Chrg(nc) = Z
               nc = nc + 1
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Compute Total Mass and Center of Mass
*
      Call CoW(Centr,CoM,Mass,S%kCentr,TMass)
      If (iChCar(1).ne.0) CoM(1)=Zero
      If (iChCar(2).ne.0) CoM(2)=Zero
      If (iChCar(3).ne.0) CoM(3)=Zero
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Put_CMO
*
*> @brief
*>   Write the symmetry blocked MO coefficients on the runfile
*> @author R. Lindh
*>
*> @details
*> The utility will write the symmetry blocked MO coefficients on the runfile.
*>
*> @param[in] CMO  Array of symmetry blocked MO coefficients
*> @param[in] nCMO Number of elements in \p CMO
************************************************************************
      Subroutine Put_CMO(CMO,nCMO)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"

      Real*8    CMO(nCMO)
      Character Label*24

      Label='Last orbitals'
      Call Put_dArray(Label,CMO,nCMO)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_multy0 (wrk,wrksize,
     & mvec,ix,mapdy,key)
c
c     This routine realize multiplying according mvec
c     for Y=A*B
c     N.B. if key=0, Y file is not vanished (ie can be used for
c     adding to some existing file)
c
#include "t31.fh"
#include "wrk.fh"
       integer mvec(1:4096,1:7)
       integer ix,key
       integer mapdy(0:512,1:6)

c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4,nhelp5
       integer iix,iy
c
c1    set C=0
c
       if (key.eq.1) then
c
c     Y vector must be vanished
c
       do 100 iy=1,mapdy(0,5)
       nhelp1=mapdy(iy,1)
       nhelp2=mapdy(iy,2)
       call cct3_mv0zero (nhelp2,nhelp2,wrk(nhelp1))
 100    continue
c
       end if
c
c2    Y=Y+A*B
c
       if (ix.eq.0) then
       return
       end if
c
       do 200 iix=1,ix
c
c     skip this sumation if yes/no=0
       if (mvec(iix,1).eq.0) goto 200
c
c     realize individial sumation
c
c     def possitions of A,B,Y
       nhelp1=mvec(iix,2)
       nhelp2=mvec(iix,3)
       nhelp3=mvec(iix,4)
c
c     def rowA(rowY), colA(sum)
       nhelp4=mvec(iix,5)
       nhelp5=mvec(iix,6)
c
       call cct3_mv0v1a3u (nhelp4,nhelp5,nhelp5,nhelp4,
     & nhelp4,nhelp5,1,1,
     & wrk(nhelp1),wrk(nhelp2),wrk(nhelp3))
c
 200    continue
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  CIDOT  := Analogous to the blas routine DDOT                       *
!*                                                                     *
!***********************************************************************
subroutine cidot_cvb(cvec1,cvec2,ret)

use casvb_global, only: iform_ci, ndet
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: cvec1(0:ndet), cvec2(0:ndet)
real(kind=wp), intent(out) :: ret
integer(kind=iwp) :: iformat1, iformat2, ivec1, ivec2
real(kind=wp), external :: ddot_

ivec1 = nint(cvec1(0))
ivec2 = nint(cvec2(0))
iformat1 = iform_ci(ivec1)
iformat2 = iform_ci(ivec2)
if (iformat1 /= iformat2) then
  write(u6,*) ' Format discrepancy in CIDOT :',iformat1,iformat2
  call abend_cvb()
end if
if (iformat1 == 0) then
  ret = ddot_(ndet,cvec1(1:),1,cvec2(1:),1)
else
  write(u6,*) ' Unsupported format in CIDOT :',iformat1
  call abend_cvb()
end if

return

end subroutine cidot_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grow_t2_blocked(t2,tmp,dima,dimb,no,lasta,lastb,length1,length2,sym)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, no, lasta, lastb, length1, length2
real(kind=wp), intent(inout) :: t2(length1,length2,no,no)
real(kind=wp), intent(in) :: tmp(dima,dimb,no,no)
logical(kind=iwp) :: sym
integer(kind=iwp) :: b, i, j

!mp write(u6,*) 'grow_t2neq dima , dimb  ',dima,dimb
!mp write(u6,*) 'grow_t2neq lasta, lastb ',lasta,lastb
!mp write(u6,*) 'grow_t2neq no           ',no

!mp if (lasta == lastb) then
!? if (grpa == grpb) then
!?   do j=1,no
!?     do i=1,no
!?       do a=1,dima
!?         do b=1,a
!?           t2(lasta+a,lastb+b,i,j) = tmp(a,b,i,j)
!?           if (a /= b) t2(lastb+b,lasta+a,j,i) = tmp(a,b,i,j)
!?         end do
!?       end do
!?     end do
!?   end do

!? else

do j=1,no
  do i=1,no
    do b=1,dimb
      !if (switch) then
      !  !mp !t2(lasta+1:lasta+dima,lastb+b,i,j) = tmp(:,b,j,i)
      !  t2(lasta+1:lasta+dima,lastb+b,i,j) = tmp(:,b,i,j)
      !else
      t2(lasta+1:lasta+dima,lastb+b,i,j) = tmp(:,b,i,j)
      !end if
      !mpn t2(lastb+b,lasta+a,j,i) = tmp(a,b,i,j)

      if (sym) t2(lastb+b,lasta+1:lasta+dima,j,i) = tmp(:,b,i,j)
    end do
  end do
end do

!? end if

return

end subroutine grow_t2_blocked

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,2020,  Roland Lindh                               *
*               1990, IBM                                              *
************************************************************************
************************************************************************
*                                                                      *
*    Object: to read basis set Exponents and Contraction Coefficients  *
*            from a library file.                                      *
*            The contraction coefficients will at this point be radial *
*            normalized.                                               *
*                                                                      *
* Called from: Input                                                   *
*                                                                      *
*                                                                      *
*            DDName is the path to the library directory               *
*                                                                      *
*                                                                      *
* Calling    : RecPrt, Rdbsl                                           *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
************************************************************************
#define _ACTUAL_
#include "getbs_interface.fh"
*     Local variables
      Character(LEN=80)  MPLbl*20, Filenm, Atom, Type
      Character(LEN=256) DirName
*
      Character Basis_Lib*256, Filename*263, DefNm*13
      Integer StrnLn
      External StrnLn
      Logical UnContracted
*
      Character*180 Line, Get_Ln
      External Get_Ln
      Character*24 Words(2)                     ! CGGn
      Logical inLn1, inLn2, inLn3, Hit, IfTest,
     &        isEorb,isFock
      Integer nCGTO(0:iTabMx),mCGTO(0:iTabMx)
      Logical Found
      Real*8, Allocatable:: ExpMerged(:),Temp(:,:)
      Data DefNm/'basis_library'/
*
#include "relmp.fh"
*     IRELMP =0  .... NOPAIR (DK2)
*     IRELMP =1  .... NOPAIR (DK1)
*     IRELMP =2  .... NOPAIR (DK2)
*     IRELMP =3  .... NOPAIR (DK3)
*     IRELMP =4  .... full NOPAIR (DK3)
*     IRELMP =11 .... RESC
*     IRELMP =21 .... ZORA
*     IRELMP =22 .... ZORA-FP
*     IRELMP =23 .... IORA
*                                                                      *
************************************************************************
*                                                                      *
      Interface
#include "getecp_interface.fh"
         Subroutine RecPrt(Title,FmtIn,A,nRow,nCol)
         Character*(*) Title
         Character*(*) FmtIn
         Integer nRow,nCol
         Real*8 A(nRow,nCol)
         End Subroutine RecPrt
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      IfTest=.True.
      iPrint=99
#else
      IfTest=.False.
      iPrint=5
#endif
      If (IfTest) iPrint=99
      ip_Dummy=-1
      dbsc(nCnttp)%FOp = .True.
      nM1=0
      nM2=0
      lAng=0
*
      If (IfTest) Write (6,'(A,A)') 'DDName=',DDName
      Line=DDName
      call UpCase(Line)
      If (Index(Line,'INLINE').ne.0.and.Index(Line,'EXPERT').eq.0) Then
         if(.not.Expert) then
           Write(6,*) 'INLINE keyword is detected'
           Write(6,*) 'EXPERT keyword is not set...'
           Write(6,*) '       We better abort right now!'
           call abend()
         endif
      EndIf
*-----Locate the first word
      iFrst = 1
      Call NxtWrd(DDName,iFrst,iEnd)
      Filenm=DDName(iFrst:iEnd)
      DirName=DDName(iFrst:iEnd)
      Call UpCase(Filenm)
      If (Index(Filenm,'INLINE').ne.0) Then
         inLn1 = .true.
         inLn2 = .true.
         inLn3 = .true.
      Else If (Index(Filenm,'MM').ne.0) Then
         dbsc(nCnttp)%IsMM = 1
         inLn1 = .True.
         inLn2 = .false.
         inLn3 = .false.
      Else
         inLn1 = .false.
         inLn2 = .false.
         inLn3 = .false.
      End If
      iFrst = iEnd + 1
      iEnd = Len(DDName)
*-----Check the 2nd and the 3rd field
      If (Index(DDName(iFrst:iEnd),'INLINE').ne.0) Then
*        Here if T T or F T
         inLn3 = .true.
*--------Locate the 2nd field
         Call NxtWrd(DDName,iFrst,iEnd)
*        Check the 2nd field
         If (Index(DDName(iFrst:iEnd),'INLINE').ne.0) Then
            inLn2 = .true.
         Else
            inLn2 = .false.
         End If
      End If
      If (IfTest) Write (6,*) inLn1, inLn2, inLn3
*
      If (.Not.inLn1) Then
         lUnit=11
*
*        Find and decode basis set label
*
         Call Rdbsl(DirName,BSLbl,Type,nCGTO,mCGTO,lAng,Itabmx,lUnit,
     &              dbsc(nCnttp)%AtmNr,BasisTypes,ExtBasDir)
         Line=Get_Ln(lUnit)
         Ref(1)=Line(1:80)
         Line=Get_Ln(lUnit)
         Ref(2)=Line(1:80)
      Else
         Hit=.True.
         Call Decode(BSLbl,atom,1,Hit)
         dbsc(nCnttp)%AtmNr=Lbl2Nr(atom)
         lUnit=LuRd
         Ref(1) = ''
         Ref(2) = ''
         Hit=.True.
         Call Decode(BSLBl(1:80),type,2,Hit)
         Basis_Lib=' '
         i=1
         Basis_Lib=DefNm
         Call Find_Basis_Set(Basis_Lib,' ',' ')
         i = StrnLn(Basis_Lib)
         Call BasisType(Basis_Lib(1:i)//'/'//type,0,BasisTypes)
      End If
      Line(1:3)=Type(1:3)
      Call UpCase(Line(1:3))
      If (Line(1:3).eq.'AUX') dbsc(nCnttp)%Aux=.True.
      If (IfTest) Then
         Write (6,'(A,A)') 'Ref(1):',Ref(1)
         Write (6,'(A,A)') 'Ref(2):',Ref(2)
      End If
      Uncontracted = BasisTypes(1).eq.6
      If (dbsc(nCnttp)%IsMM .eq. 1) Then
         lAng = 0
         dbsc(nCnttp)%Charge = Zero
         Return
      End If
*
*--- begin parsing options
      isEorb=.false.
      isFock=.false.
      If (L_STDINP.AND.inLn1) then ! CGGn
        iSTDINP = iSTDINP + 1      ! CGGn
        Line = STDINP(iSTDINP)     ! CGGn
      else                         ! CGGn
        Line = Get_Ln(lUnit)
      EndIf                        ! CGGn
      If(Line.eq.'Options') Then
         Do
         Line=Get_Ln(lUnit)
         If(Line.ne.'EndOptions') Then
            If(Line.eq.'OrbitalEnergies') Then
               If (IfTest)
     &         Write(6,*) 'Orbital energies are included'
               isEorb=.true.
            Else If(Line.eq.'FockOperator') Then
               If (IfTest)
     &         Write(6,*) 'Fock operator is included'
               isEorb=.true.
               isFock=.true.
            Else
               Write(6,*) 'Illegal option: ',Line
               Call Abend()
            End If
         Else
            Exit
         End If
         End Do
         Line=Get_Ln(lUnit)
      End If
*--- end parsing options
      If (IfTest) Write (6,'(A,A)') 'Line=',Line
      If (L_STDINP.AND.inLn1) then              ! CGGn
        Call Pick_Words(Line,2,Nwords,Words)    ! CGGn
        If (Nwords.NE.2) Call Abend()           ! CGGn
        Call Get_dNumber(Words(1),dbsc(nCnttp)%Charge,iErr)  ! CGGn
        If (iErr.NE.0) Call Abend()             ! CGGn
        Call Get_iNumber(Words(2),lAng,iErr)    ! CGGn
        If (iErr.NE.0) Call Abend()             ! CGGn
      else                                      ! CGGn
        call get_f1(1,dbsc(nCnttp)%Charge)
        if (inLn1) call get_i1(2,lAng)
      EndIf                                     ! CGGn
      If (iPrint.ge.99) Then
         Write (6,*) 'lAng, Charge=',lAng, dbsc(nCnttp)%Charge
         Write (6,*) ' Start reading valence basis'
      End If
      If (lAng.gt.iTabMx) Then
         Write (6,*) 'GetBS: lAng.gt.iTabMx'
         Write (6,*) 'lAng,iTabMx=',lAng,iTabMx
         Call Abend()
      End If
*     Loop over each shell type (s,p,d,etc....)
      iValSh=iShll
      dbsc(nCnttp)%nVal=lAng+1
      mVal=0
      dbsc(nCnttp)%iVal=iShll+1
      Do 10 iAng = 0, lAng
         If (IfTest) Write (6,*) 'iAng=',iAng
         iShll = iShll + 1
         If (iShll.gt.MxShll) Then
            Write (6,*) 'GetBS: iShll.gt.MxShll'
            Write (6,*) 'iShll,MxShll=',iShll,MxShll
            Call Abend()
         End If
         If (IfTest) Then
            Write (6,'(A,A)') 'Line=',Line
            Write (6,*) L_STDINP,inLn1
         End If
         If (L_STDINP.AND.inLn1) then                   ! CGGn
           iSTDINP = iSTDINP + 1                        ! CGGn
           Line = STDINP(iSTDINP)                       ! CGGn
           Call Pick_Words(Line,2,Nwords,Words)         ! CGGn
           If (Nwords.NE.2) Call Abend()                ! CGGn
           Call Get_iNumber(Words(1),nPrim,iErr)        ! CGGn
           If (iErr.NE.0) Call Abend()                  ! CGGn
           Call Get_iNumber(Words(2),nCntrc,iErr)       ! CGGn
           If (iErr.NE.0) Call Abend()                  ! CGGn
           nCGTO(iAng)=0                                ! CGGn
           mCGTO(iAng)=0                                ! CGGn
         else                                           ! CGGn
           Line = Get_Ln(lUnit)
           If (IfTest) Write (6,'(A,A)') 'Line=',Line
           Call Get_i1(1,nPrim)
           If (inLn1) then
              Call Get_i1(2,nCntrc)
              nCGTO(iAng)=0
              mCGTO(iAng)=0
           Else
              nCntrc=nCGTO(iAng)
           Endif
         EndIf                                          ! CGGn
         If (IfTest) Write(6,*) ' nPrim, nCntrc=',nPrim, nCntrc
*
         Shells(iShll)%nExp=nPrim
         Shells(iShll)%nBasis_c = nCntrc
         Call mma_allocate(Shells(iShll)%Exp,nPrim,Label='Exp')
*        Read gaussian exponents
         If (nPrim.gt.0) then
            If (IfTest) Write(6,*) 'Read gaussian exponents'
            Call Read_v(lUnit,Shells(iShll)%Exp,1,nPrim,1,Ierr)
            If (Ierr.ne.0) Then
               Call WarningMessage(2,
     &                     'GetBS: Error while reading the exponents')
               Call Quit_OnUserError()
            End If
            If (IfTest) Write(6,*) 'Done with exponents'
         End If
         If (iPrint.ge.99)
     &      Call RecPrt(' Exponents',' ',Shells(iShll)%Exp,nPrim,1)
*
*        Storage of coefficients for both contracted and uncontracted case.
*
         Call mma_allocate(Shells(iShll)%Cff_c,nPrim,nCntrc,2,
     &                     Label='Cff_c')
         Shells(iShll)%Cff_c(:,:,1)=Zero
         Call mma_allocate(Shells(iShll)%pCff,nPrim,nCntrc,
     &                     Label='pCff')
         Shells(iShll)%nBasis=nCntrc
         Call mma_allocate(Shells(iShll)%Cff_p,nPrim,nPrim,2,
     &                     Label='Cff_p')
*        Read contraction coefficients
*        Observe that the matrix will have nPrim rows and
*        nCntrc columns
         If (IfTest) Then
            Write (6,'(2A)') ' Type=',Type
            Write (6,*) 'mCGTO(iAng)=',mCGTO(iAng)
            Write (6,*) 'nCGTO(iAng)=',nCGTO(iAng)
            Write (6,*) 'nCntrc=',nCntrc
         End If
         If (IfTest) Write (6,*) ' Read/Process coefficients'
*
         If ((inLn1 .or. mCGTO(iAng).eq.nCntrc).or. nCntrc.eq.0) Then
*           Read in coeffs. in GC format, as the standard case
            If (IfTest) Write (6,*) ' Standard case'
            Shells(iShll)%Cff_c(:,:,:)=Zero
            If (UnContracted) Then
               Do i=1,nPrim
                  Shells(iShll)%Cff_c(i,i,1)=One
               End Do
            Else
               Do iPrim = 1, nPrim
                  Call Read_v(lUnit,Shells(iShll)%Cff_c(1,1,1),
     &                        iPrim,nCntrc*nPrim,nPrim,Ierr)
                  If (Ierr.ne.0) Then
                     Call WarningMessage(2,
     &                      'GetBS: Error reading coeffs in GC format')
                     Call Quit_OnUserError()
                  End If
               End Do
            End If
*
         Else
*
*           Here, we want nCntrc generally contracted functions (gcf)
*           of nPrim primitives resulting from the mCGTO(iAng) gcfs
*           of the library plus the nCntrc-mCGTO(iAng) outermost
*           primitive functions of the unextended basis set, that is,
*           of the basis set which excludes any added polarization or
*           diffuse functions.
*           (Note that everything is in generally contraction format.)
*           Example:  library:.6s.3s.  + input:.6s.5s.   -->   result
*                            x x 0                          x x 0 0 0
*                            x x 0                          x x 0 0 0
*                            x x 0                          x x 0 0 0
*                            x x 0                          x x 1 0 0
*                            x x 0                          x x 0 1 0
*                            0 0 1                          0 0 0 0 1
*
            If (IfTest) Write (6,*) ' Initial GC + outermost primitives'
            If (nCntrc.gt.nPrim) Then
               Call WarningMessage(2,
     &                     'Number of contracted more than the number'
     &             //' of primitive: correct the basis set label!')
               Call Quit_OnUserError()
            End If
            Call mma_allocate(Temp,nPrim,Max(nCntrc,mCGTO(iAng)),
     &                        Label='Temp')
            Temp(:,:)=Zero
*           read the block in the library as it is
            Do iPrim = 1, nPrim
               Call Read_v(lUnit,Temp,
     &                     iPrim,nPrim*mCGTO(iAng),nPrim,Ierr)
               If (Ierr.ne.0) Then
                  Call WarningMessage(2,
     &                        'GetBS: Error reading the block')
                  Call Quit_OnUserError()
               End If
            End Do
*
*           Order the exponents
*
            Call OrdExp1(nPrim,Shells(iShll)%Exp,mCGTO(iAng),Temp)
*
*           identify the presence of added polarization and diffusse
*           functions;
            iAdded = 0
*           Examine all the contracted functions starting with the last
      Outer:Do jNow = mCGTO(iAng), 1, -1
               iFlgOne = 0
               ! Examine the primitives
               Do iNow = 1, nPrim
                  Coeff=Temp(iNow,jNow)
                  ! Stop if it is obvious that this is not a diffuse
                  ! or polarization function.
                  If (Coeff.ne.Zero.and.Coeff.ne.One) Exit Outer
                  If (Coeff.eq.One) Then
                     If (iFlgOne.eq.1)  Cycle Outer
                     iFlgOne = 1
                  End If
               End Do
               iAdded = iAdded + 1
               If (IfTest) Write (6,*)
     &                          'function',jNow,' is an added one'
            End Do Outer
*
            nAdded = iAdded
            If (nAdded.eq.mCGTO(iAng)) nAdded=0
            If (IfTest) Write (6,*) ' nAdded=',nAdded
            If (nAdded.gt.0) Then
*              shift the added polarization and diffuse functions to
*              the right
               Do jNow = 1, nAdded
                  j1= nCntrc     -jNow+1
                  j2= mCGTO(iAng)-jNow+1
                  Do iNow = 1, nPrim
                     Temp(iNow,j1)=Temp(iNow,j2)
                  End Do
               End Do
            End If
*           insert/append the outermost primitives (in GC format)
            Do jNow = mCGTO(iAng) + 1 - nAdded, nCntrc - nAdded
               If (IfTest) write (6,*) 'jNow=',jNow
               Temp(:,jNow)=Zero
               j = jNow - (mCGTO(iAng)-nAdded)
               iPrevNow = nPrim - nAdded - (nCntrc - mCGTO(iAng))
               iNow = iPrevNow + j
               Temp(iNow,jNow) = One
            End Do
            Shells(iShll)%Cff_c(:,:,1)=Temp(:,1:nCntrc)
            Call mma_deallocate(Temp)
         End If
*
         If (IfTest) Write (6,*) ' Done! Now Process.'
*
*        Order the exponents
*
         Call OrdExp(nPrim,Shells(iShll)%Exp,nCntrc,
     &                     Shells(iShll)%Cff_c(1,1,1))
         If (nPrim*nCntrc.ne.0) mVal = mVal + 1
*
*        Decontract if integrals required in the primitive basis
*
         If (nPrim.eq.0) Go To 777
         Shells(iShll)%Cff_p(:,:,1)=Zero
         Do i=1,nPrim
            Shells(iShll)%Cff_p(i,i,1)=One
         End Do
*
*------- Save the contraction coefficients once more after the coefficients.
*        The second set will not be normalized!
*
         Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
         Shells(iShll)%Cff_c(:,:,2)=Shells(iShll)%Cff_c(:,:,1)
         Shells(iShll)%Cff_p(:,:,2)=Shells(iShll)%Cff_p(:,:,1)
*
*        The normalization coefficients are assumed to be for
*        normalized Gaussians. In Nrmlz the contraction coefficients are
*        multiplied with the normalization coefficient of each primitive
*        Gaussian. The contracted Gaussian are then normalized with respect
*        the radial overlap.
*
         If (.Not.UnNorm) Then
            Call Nrmlz(Shells(iShll)%Exp,nPrim,
     &                 Shells(iShll)%Cff_c(1,1,1),nCntrc,iAng)
            Call Nrmlz(Shells(iShll)%Exp,nPrim,
     &                 Shells(iShll)%Cff_p(1,1,1),nPrim,iAng)
         End If
*
         If (iPrint.ge.99) Then
            nPrim = Shells(iShll)%nExp
            nCntrc= Shells(iShll)%nBasis_C
            Call RecPrt(' Coefficients (normalized)',' ',
     &                  Shells(iShll)%Cff_c(1,1,1),nPrim,nCntrc)
            Call RecPrt(' Coefficients (unnormalized)',' ',
     &                  Shells(iShll)%Cff_c(1,1,2),nPrim,nCntrc)
         End If
 777     Continue
         If (nPrim.eq.0) Go To 778
*                                                                      *
************************************************************************
*                                                                      *
*        Begin read orbital energies
*
         Call mma_allocate(Shells(iShll)%FockOp,nCntrc,nCntrc,
     &                     Label='FockOp')
         Shells(iShll)%nFockOp=nCntrc
         Shells(iShll)%FockOp(:,:)=Zero

         If (isFock) Then
            dbsc(nCnttp)%FOp=dbsc(nCnttp)%FOp .and. .True.
            Line=Get_Ln(lUnit)
            Call Get_i1(1,nEorb)
            Call mma_allocate(Temp,nEorb,nEorb,Label='Temp')
            Do i=1,nEorb
               Line=Get_Ln(lUnit)
               Call Get_F(1,Temp(1,i),nEOrb)
            End Do
            Shells(iShll)%FockOp(1:Min(nEorb,nCntrc),
     &                           1:Min(nEorb,nCntrc))
     &                = Temp(1:Min(nEorb,nCntrc),
     &                       1:Min(nEorb,nCntrc))
            Call mma_deallocate(Temp)
#ifdef _DEBUGPRINT_
            Call RecPrt('Fock',' ',Shells(iShll)%FockOp,nCntrc,nCntrc)
#endif
         Else If(isEorb) Then
            dbsc(nCnttp)%FOp=dbsc(nCnttp)%FOp .and. .True.
            Line=Get_Ln(lUnit)
            Call Get_i1(1,nEorb)
            Call mma_allocate(Temp,nEorb,1,Label='Temp')
            If(nEorb.gt.0) Then
               Line=Get_Ln(lUnit)
               Call Get_F(1,Temp(1,1),nEorb)
            End If
            Do i=1,Min(nEOrb,nCntrc)
               Shells(iShll)%FockOp(i,i)=Temp(i,1)
            End Do
            Call mma_deallocate(Temp)
#ifdef _DEBUGPRINT_
            Call RecPrt('Eorb',' ',Shells(iShll)%FockOp,nCntrc,nCntrc)
#endif
         Else
            dbsc(nCnttp)%FOp=.False.
#ifdef _DEBUGPRINT_
            Call RecPrt('Empty',' ',Shells(iShll)%FockOp,nCntrc,nCntrc)
#endif
         End If
*
*        End read orbital energies
*                                                                      *
************************************************************************
*                                                                      *
*
 778     Continue
 10   Continue
      If (mVal.eq.0) dbsc(nCnttp)%nVal=0
***************************************************************************
*-----If PAM basis set read the potentials and coefficient!
*
      If (inLn2.and. .Not.inLn1) Then
         If (IfTest) Write (6,*) ' Close library and start to read from'
     &            //' standard input'
         Close(lUnit)
         lUnit = 5
      End If
      If ( Index(BSLBl,'.PAM.').ne.0) then
         If (IfTest) Write (6,*) ' Process PAM'
         dbsc(nCnttp)%lPAM2 = .True.
         If (iPrint.ge.99) Write (6,*) ' Start reading PAMs'
         Call GetPAM(lUnit,nCnttp)
*
         If (inLn3.and. .not.inLn2) Then
            Close(lUnit)
            lUnit=5
         End If
      End If
************************************************************************
*
*-----If FRAGMENT basis set read the fragment's coordinates, basis sets,
*     orbital energies and density matrix
*
      If (inLn2.and. .Not.inLn1) Then
         If (IfTest) Write (6,*) ' Close library and start to read from'
     &            //' standard input'
         Close(lUnit)
         lUnit = 5
      End If
      If ( Index(BSLBl,'.FRAGMENT.').ne.0) then
         If (IfTest) Write (6,*) ' Process FRAGMENT'
         If (iPrint.ge.99)
     &      Write (6,*) ' Start reading fragment data'
         Call GetFragment(lUnit,nCnttp)
*
         If (inLn3.and. .not.inLn2) Then
            Close(lUnit)
            lUnit=5
         End If
      End If
************************************************************************
*
*-----If ECP basis set read the rest!
*
      If (inLn2.and. .Not.inLn1) Then
         If (IfTest) Write (6,*) ' Close library and start to read from'
     &            //' standard input'
         Close(lUnit)
         lUnit = 5
      End If
*
      nProj = -1
      nAIMP = -1
      mSOC  = -1
      If ( Index(BSLBl,'.ECP.').ne.0  .or.
     &     Index(BSLBl,'.REL.').ne.0 ) then
         If (IfTest) Write (6,*) ' Process ECPs/RELs'
         dbsc(nCnttp)%ECP = .True.
         iPrSh=iShll
         If (iPrint.ge.99)
     &      Write (6,*) ' Start reading ECPs/RELs'
         dbsc(nCnttp)%iPrj=iShll+1
         Call GetECP(lUnit,iShll,nProj,UnNorm)
         dbsc(nCnttp)%nPrj=nProj+1
*
         If (inLn3.and. .not.inLn2) Then
            Close(lUnit)
            lUnit=5
         End If
*
*--------Now read the spectral resolvent basis set
*        Line=GetLn(lUnit)
         Line=Get_Ln(lUnit)
         Call UpCase(Line)
         If (Index(Line,'SPEC').eq.0) Then
            Call WarningMessage(2,
     &                 'ERROR: Keyword SPECTRAL expected,'
     &                 //' offending line : '//Line)
            Call Quit_OnUserError()
         Endif
*
         iMPShll=iShll
 9988    Continue
         Line=Get_Ln(lUnit)
         Call UpCase(Line)
         If (Line(1:4).eq.'END ') Go To 999
         If (Line(1:4).eq.'VALE') Go To 1001
         If (Line(1:4).eq.'CORE') Go To 1011
         If (Line(1:4).eq.'EXTE') Go To 1012
         If (Line(1:4).eq.'EXCH') Go To 1002
         If (Line(1:4).eq.'1STO') Go To 1003
         If (Line(1:4).eq.'NOPA') Go To 1005
*
         If (Line(1:4).eq.'NOP1') Go To 1006
         If (Line(1:4).eq.'NOP2') Go To 1007
         If (Line(1:4).eq.'NOP3') Go To 1008
         If (Line(1:4).eq.'NOPF') Go To 1010
         If (Line(1:4).eq.'RESC') Go To 1009
         If (Line(1:4).eq.'RA0H') Go To 9001
         If (Line(1:4).eq.'RA0F') Go To 9002
         If (Line(1:4).eq.'RAIH') Go To 9003
*
         If (Line(1:4).eq.'MIXE') Go To 1013
         If (Line(1:4).eq.'SOC ') Go To 1014
         If (Line(1:4).eq.'DKSO') Go To 1015
         Call WarningMessage(2,' Invalid keyword in GetBS;'//
     &                   Line)
         Call Quit_OnUserError()
*
*--------Valence basis set
*
 1001    Continue
         If (nAIMP.ne.-1) Then
            Call WarningMessage(2,
     &                  ' SR basis set is already defined!')
            Call Quit_OnUserError()
         End If
         nAIMP = lAng
         dbsc(nCnttp)%nSRO=nAIMP+1
         dbsc(nCnttp)%iSRO=iShll+1
         jValSh=iValSh
         Do iAIMP = 0, nAIMP
            iShll = iShll + 1
            If (iShll.gt.MxShll) Then
               Write (6,*) 'GetBS: iShll.gt.MxShll'
               Write (6,*) 'iShll,MxShll=',iShll,MxShll
               Call Abend()
            End If
            jValSh = jValSh + 1
            Call mma_allocate(Shells(iShll)%Exp,Shells(jValSh)%nExp,
     &                        Label='Exp')
            Shells(iShll)%Exp(:) = Shells(jValSh)%Exp(:)
            Shells(iShll)%nExp = Shells(jValSh)%nExp
            Shells(iShll)%nBasis  = 0
         End Do
         Go To 9988
*
*--------Core basis set
*
 1011    Continue
         If (nAIMP.ne.-1) Then
            Call WarningMessage(2,
     &                  ' SR basis set is already defined!')
            Call Quit_OnUserError()
         End If
         nAIMP = nProj
         dbsc(nCnttp)%nSRO=nAIMP+1
         dbsc(nCnttp)%iSRO=iShll+1
         jPrSh = iPrSh
         Do iAIMP = 0, nAIMP
            iShll = iShll + 1
            If (iShll.gt.MxShll) Then
               Write (6,*) 'GetBS: iShll.gt.MxShll'
               Write (6,*) 'iShll,MxShll=',iShll,MxShll
               Call Abend()
            End If
            jPrSh = jPrSh + 1
            Call mma_allocate(Shells(iShll)%Exp,Shells(jPrSh)%nExp,
     &                        Label='Exp')
            Shells(iShll)%Exp(:)=Shells(jPrSh)%Exp(:)
            Shells(iShll)%nExp=Shells(jPrSh)%nExp
            Shells(iShll)%nBasis  = 0
         End Do
         Go To 9988
*
*--------External basis set
*
 1012    Continue
         If (nAIMP.ne.-1) Then
            Call WarningMessage(2,
     &                  ' SR basis set is already defined!')
            Call Quit_OnUserError()
         End If
*        Line = GetLn(lUnit)
         Line = Get_Ln(lUnit)
         Call Get_i1(1,nAIMP)
         dbsc(nCnttp)%nSRO=nAIMP+1
         dbsc(nCnttp)%iSRO=iShll+1
         Do iAIMP = 0, nAIMP
            iShll = iShll + 1
            If (iShll.gt.MxShll) Then
               Write (6,*) 'GetBS: iShll.gt.MxShll'
               Write (6,*) 'iShll,MxShll=',iShll,MxShll
               Call Abend()
            End If
            Line = Get_Ln(lUnit)
            Call Get_i1(1,nPrim)
            Call mma_allocate(Shells(iShll)%Exp,nPrim,Label='Exp')
            Shells(iShll)%nExp=nPrim
            Shells(iShll)%nBasis=0
*
            If (nPrim.gt.0) then
               Call read_v(lUnit,Shells(iShll)%Exp,1,nPrim,1,Ierr)
               If (Ierr.ne.0) Then
                  Call WarningMessage(2,
     &                        'GetBS: Error reading SRO exponents')
                  Call Quit_OnUserError()
               End If
            End If
*
         End Do
         Go To 9988
*---------- Mixed basis set (valence + core), with dominance of the
*           valence basis set, i.e. the valence basis set plus those
*           exponents in the core primitives not too close to the
*           valence ones.

 1013    Continue
         If (nAIMP.ne.-1) Then
            Call WarningMessage(2,
     &                  ' SR basis set is already defined!')
            Call Quit_OnUserError()
         End If

*---------- Threshold for the ratio between consecutive exponents
*           (if the ratio between two consecutive exponents is lower
*           than the threshold, the exponent of the core basis set
*           will be removed)

         Line = Get_Ln(lUnit)
         Call Get_F1(1,RatioThres)
*
         nAIMP  = lAng
         dbsc(nCnttp)%iSRO=iShll+1
         dbsc(nCnttp)%nSRO=nAIMP+1
         jValSh = iValSh
         jPrSh  = iPrSh
*
         Do iAIMP = 0, nAIMP
            iShll = iShll + 1
            If (iShll.gt.MxShll) Then
               Write (6,*) 'GetBS: iShll.gt.MxShll'
               Write (6,*) 'iShll,MxShll=',iShll,MxShll
               Call Abend()
            End If
*
            jValSh = jValSh + 1
            nCntrc   = Shells(jValSh)%nBasis
*
*
            If (iAIMP.le.nProj) Then
               jPrSh = jPrSh + 1
*
               iDominantSet = 2
               Call mma_allocate(ExpMerged,
     &                           Shells(jPrSh)%nExp
     &                          +Shells(jValSh)%nExp,
     &                           Label='ExpMerged')
               Call MergeBS (Shells(jPrSh)%Exp,Shells(jPrSh)%nExp,
     &                       Shells(jValSh)%Exp,Shells(jValSh)%nExp,
     &                       ExpMerged,Shells(iShll)%nExp, RatioThres,
     &                       iDominantSet)
               Call mma_allocate(Shells(iShll)%Exp,Shells(iShll)%nExp,
     &                           Label='Exp')
               Shells(iShll)%Exp(:)=ExpMerged(1:Shells(iShll)%nExp)
               Call mma_deallocate(ExpMerged)

*
            Else
*
               Shells(iShll)%nExp=Shells(jValSh)%nExp
               Call mma_allocate(Shells(iShll)%Exp,Shells(iShll)%nExp,
     &                           Label='Exp')
               Shells(iShll)%Exp(:)=Shells(jValSh)%Exp(:)
*
            End If
*
            Shells(iShll)%nBasis=0
*
         End Do
         Go To 9988
*
*---------- SOC basis set
*
 1014    Continue
*
         If (mSOC.ne.-1) Then
            Call WarningMessage(2,
     &                  ' SOC basis set is already defined!')
            Call Quit_OnUserError()
         End If
*
      dbsc(nCnttp)%iSOC=iShll+1
      Line = Get_Ln(lUnit)
      Call Get_I1(1,mSOC)
      dbsc(nCnttp)%nSOC=mSOC+1
      IF (IfTest) Write(6,'(A,I4)') 'dbsc(nCnttp)%nSOC =',
     &                               dbsc(nCnttp)%nSOC
      If (mSOC.lt.0) Go To 990
      Do 12 iAng = 0, mSOC
         If (IfTest) Write (6,'(A,I4)') ' iAng=',iAng
         iShll = iShll + 1
         If (iShll.gt.MxShll) Then
            Call WarningMessage(2,
     &                      'Abend in GetBS: Increase MxShll')
            Call Quit_OnUserError()
         End If
         Line = Get_Ln(lUnit)
         Call Get_I1(1,nPrim)
         Call Get_I1(2,nCntrc)
         Call Get_I1(3,mDel)
         dbsc(nCnttp)%kDel(iAng)=mDel
         If (IfTest) Write(6,*) 'nPrim = ',nPrim,' nCntrc = ',nCntrc
         If (IfTest) Write(6,*) 'nDeleted = ', mDel
         Call mma_allocate(Shells(iShll)%Exp,nPrim,Label='Exp')
         Shells(iShll)%nExp=nPrim
         Shells(iShll)%nBasis = nCntrc
         If (IfTest) Write (6,*) 'getBS: ishll,nCntrc',ishll,nCntrc
         If (IfTest) Write (6,'(A)') ' Reading Exponents'
         If (nPrim.gt.0) Call Read_v(lUnit,Shells(iShll)%Exp,1,nPrim,1,
     &                               ierr)
         If (IfTest)
     &      Call RecPrt('Exponents',' ',Shells(iShll)%Exp,1,nPrim)
         Call mma_allocate(Shells(iShll)%Cff_c,nPrim,nCntrc,2,
     &                     Label='Cff_c')
         Call mma_allocate(Shells(iShll)%pCff,nPrim,nCntrc,
     &                     Label='pCff')
         Shells(iShll)%nBasis=nCntrc
         Call mma_allocate(Shells(iShll)%Cff_p,nPrim,nPrim,2,
     &                     Label='Cff_p')
         Shells(iShll)%Cff_p(:,:,:)=Zero
         If (IfTest) Write (6,'(A)') ' Reading coefficients'
         Do 20 iPrim = 1, nPrim
            Call Read_v(lUnit,Shells(iShll)%Cff_c(1,1,1),
     &                  iPrim,nPrim*nCntrc,nPrim,ierr)
 20      Continue
*
         Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
         Shells(iShll)%Cff_c(:,:,2)=Shells(iShll)%Cff_c(:,:,1)
         Shells(iShll)%Cff_p(:,:,2)=Shells(iShll)%Cff_p(:,:,1)
*
         If (IfTest)
     &      Call RecPrt('Coefficients',' ',Shells(iShll)%Cff_c(1,1,1),
     &                  nPrim,nCntrc)
*
 12   Continue
 990     Continue
         Go To 9988
*
*------  Use DKSO on request
*
 1015    Continue
         dbsc(nCnttp)%SODK=.True.
         Go To 9988
*
*--------Exchange operator
*
 1002    Continue
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**0)
         Go To 9988
*
*--------1st order relativistic correction
*
 1003    Continue
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**1)
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**2)
         Line=Get_Ln(lUnit)
         MPLbl=Line(1:20)
         Go To 9988
*
*
*        one-centre no-pair operators
*
 1005    Continue
         dbsc(nCnttp)%NoPair=.True.
         dbsc(nCnttp)%SODK=.True.
         IRELMP=0
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**3)
         Go To 9988
*
*        one-centre no-pair operators (DK1)
*
 1006    Continue
         dbsc(nCnttp)%NoPair=.True.
         dbsc(nCnttp)%SODK=.True.
         IRELMP=1
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**3)
         Go To 9988
*
*        one-centre no-pair operators (DK2)
*
 1007    Continue
         dbsc(nCnttp)%NoPair=.True.
         dbsc(nCnttp)%SODK=.True.
         IRELMP=2
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**3)
         Go To 9988
*
*        one-centre no-pair operators (DK3)
*
 1008    Continue
         dbsc(nCnttp)%NoPair=.True.
         dbsc(nCnttp)%SODK=.True.
         IRELMP=3
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**3)
         Go To 9988
*
*        one-centre no-pair operators (DK3)
*
 1010    Continue
         dbsc(nCnttp)%NoPair=.True.
         dbsc(nCnttp)%SODK=.True.
         IRELMP=4
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**3)
         Go To 9988
*
*        one-centre RESC operators
*
 1009    Continue
         dbsc(nCnttp)%NoPair=.True.
         IRELMP=11
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**3)
         Go To 9988
*
*        one-centre ZORA operators
*
 9001    Continue
         dbsc(nCnttp)%NoPair=.True.
         IRELMP=21
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**3)
         Go To 9988
*
*        one-centre ZORA-FP operators
*
 9002    Continue
         dbsc(nCnttp)%NoPair=.True.
         dbsc(nCnttp)%SODK=.True.
         IRELMP=22
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**3)
         Go To 9988
*
*        one-centre IORA operators
*
 9003    Continue
         dbsc(nCnttp)%NoPair=.True.
         dbsc(nCnttp)%SODK=.True.
         IRELMP=23
         dbsc(nCnttp)%nOpt = iOr(dbsc(nCnttp)%nOpt,2**3)
         Go To 9988
*
 999     Continue
         If (iAnd(dbsc(nCnttp)%nOpt,2**1).ne.0 .and.
     &       iAnd(dbsc(nCnttp)%nOpt,2**3).ne.0) Then
            Call WarningMessage(2,
     &                  ' 1st order relativistic correction and '
     &                //' no-pair approximation can not be used'
     &                //' simultaneously!')
            Call Quit_OnUserError()
         End If
         If (nAIMP.ge.0) Then
            Basis_Lib=DefNm
            Call Find_Basis_Set(Basis_Lib,' ',' ')
            Filename=Trim(Basis_Lib)//'/QRPLIB'
            Call f_Inquire(Filename,Found)
            If (.not. Found) Then
               Write(6,*) 'File '//Trim(Filename)//' not found'
               call abend()
            End If
            LUQRP=33
            call molcas_open(LUQRP,Filename)
c            Open(LUQRP,file='QRPLIB',form='formatted')
            Call CalcAMt(dbsc(nCnttp)%nOpt,LUQRP,MPLbl,nAIMP,iMPShll+1,
     &                   nProj,iPrSh+1,DBLE(dbsc(nCnttp)%AtmNr))
            Close (LUQRP)
         End If
      End If
*
      lAng = Max(lAng,nProj,nAIMP)
      If (.not.inLn3) Close(lUnit)
      Return
      End
      Subroutine Check_Info()
      Call Free_Work(LctInf)
      Call Abend()
      End Subroutine Check_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module casvb_interfaces

implicit none
private

abstract interface
  subroutine ddasonc_sub( &
#                        define _CALLING_
#                        include "ddasonc_interface.fh"
                        )
    use Definitions, only: wp, iwp
#   include "ddasonc_interface.fh"
  end subroutine ddasonc_sub

  subroutine ddsol_sub( &
#                      define _CALLING_
#                      include "ddsol_interface.fh"
                      )
    use Definitions, only: wp, iwp
#   include "ddsol_interface.fh"
  end subroutine ddsol_sub

  subroutine ddres_sub( &
#                      define _CALLING_
#                      include "ddres_interface.fh"
                      )
    use Definitions, only: wp, iwp
#   include "ddres_interface.fh"
  end subroutine ddres_sub

  subroutine ddres2upd_sub( &
#                          define _CALLING_
#                          include "ddres2upd_interface.fh"
                          )
    use Definitions, only: wp, iwp
#   include "ddres2upd_interface.fh"
  end subroutine ddres2upd_sub

  subroutine opta_sub( &
#                     define _CALLING_
#                     include "opta_interface.fh"
                     )
    use Definitions, only: iwp
#   include "opta_interface.fh"
  end subroutine opta_sub

  subroutine optb_sub( &
#                     define _CALLING_
#                     include "optb_interface.fh"
                     )
    use Definitions, only: wp, iwp
#   include "optb_interface.fh"
  end subroutine optb_sub
end interface

public :: ddasonc_sub, ddsol_sub, ddres_sub, ddres2upd_sub, opta_sub, optb_sub

end module casvb_interfaces

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!----------------------------------------------------------------------*
! A small function to compute the Nemo exchange repulsion.             *
!----------------------------------------------------------------------*
function ExNemo(i,j,a)

use qmstat_global, only: Sexre1, Sexre2, Sexrep
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: ExNemo
integer(kind=iwp), intent(in) :: i, j
real(kind=wp), intent(in) :: a

!The function
ExNemo = exp(-Sexrep(i,j)/a)*Sexre1(i,j)+Sexre2(i,j)*(a**20)

return

end function ExNemo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DMinvCI_td(rin,rout,rome,idsym)

use ipPage, only: ipin, W
use MCLR_Data, only: ipCI, ipDia, nConf1
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: rin(nConf1), rome
real(kind=wp), intent(out) :: rout(nConf1)
integer(kind=iwp), intent(in) :: idSym
real(kind=wp) :: r1, r2
real(kind=wp), external :: DDot_

!                                  -1           -1
!                             (H -E) |0><0|(H -E) |Sigma>
!                -1             0            0
! |rNew> = (H - E) |Sigma> - -----------------------------
!            0                               -1
!                                    <0|(H -E) |0>
!                                         0

if (nconf1 > 1) then
  call ipin(ipdia)
  rout(:) = rin(:)/(W(ipdia)%A(1:nConf1)+rome)

  ! To ensure orthogonal response if response is in same symmetry as wavefunction

  if (idsym == 1) then
    call ipin(ipCI)
    r1 = ddot_(nConf1,W(ipCI)%A,1,rout,1)

    call ipin(ipDia)
    r2 = sum(W(ipCI)%A(1:nConf1)**2/(W(ipDia)%A(1:nConf1)+rome))

    rout(:) = rout(:)-r1/r2*W(ipCI)%A(1:nConf1)/(W(ipDia)%A(1:nConf1)+rome)
  end if

else

  rout(:) = rin(:)

end if

rout(:) = Half*rout(:)

end subroutine DMinvCI_td

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ORBINF()
! Obtain information about orbitals from shell information
!
! =====
! input
! =====
! Shell and symmetry information in /LUCINP/
!
! ======
! Output
! ======
! Orbital information in /ORBINP/
!
! Jeppe Olsen, Winter of 1991

use lucia_data, only: IBSO, IOBPTS, IREOST, IREOTS, ISMFSO, ISMFTO, ITOOBS, ITOOBS, MXPIRR, MXPNGAS, MXPOBS, MXTSOB, NACOB, &
                      NACOBS, NDEOB, NDEOB, NGAS, NGSOBT, NGSSH, NINOB, NINOB, NINOBS, NIRREP, NOBPT, NOBPTS, NOCOB, NSMOB, NTOOB, &
                      NTOOBS
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IGAS, IGSDEL, IGSINA, IOBSM, IOBTP, IOSPIR(MXPOBS,MXPIRR), ISMOB, LTOB, NGSOB(MXPOBS,MXPNGAS), NOSPIR(MXPIRR)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I
#endif

!***********************************************
!                                              *
! Part 1 : From shell format to orbital format *
!                                              *
!***********************************************
call OSPIR(NOSPIR,IOSPIR,MXPIRR,MXPOBS)

! 2 : Shell information to orbital information for each group of orbital

! ===============
!     GAS case
! ===============

do IGAS=1,NGAS
  ! Shell => orbitals for each GAS space
  call SHTOOB(NGSSH(:,IGAS),NIRREP,MXPOBS,NSMOB,NOSPIR,IOSPIR,NGSOB(:,IGAS),NGSOBT(IGAS))
end do

! ======================================================
! Number of inactive, active, occupied, deleted orbitals
! ======================================================

! current inactive and deleted orbitals are not identified so
IGSINA = 0
IGSDEL = 0

NTOOBS(1:NSMOB) = 0
!NOCOBS(1:NSMOB) = 0
NACOBS(1:NSMOB) = 0

NTOOB = 0
NACOB = 0
NOCOB = 0
do IGAS=1,NGAS
  ! Inactive orbitals
  if (IGAS == IGSINA) then
    NINOBS(1:NSMOB) = NGSOB(1:NSMOB,IGAS)
    NINOB = NGSOBT(IGAS)
  end if
  ! Deleted orbitals
  if (IGAS == IGSDEL) then
    !NDEOBS(1:NSMOB) = NGSOB(1:NSMOB,IGAS)
    NDEOB = NGSOBT(IGAS)
  end if
  ! Add to total number of orbitals
  NTOOBS(1:NSMOB) = NTOOBS(1:NSMOB)+NGSOB(1:NSMOB,IGAS)
  NTOOB = NTOOB+NGSOBT(IGAS)
  ! Add to occupied orbitals
  if (IGAS /= IGSDEL) then
    !NOCOBS(1:NSMOB) = NOCOBS(1:NSMOB)+NGSOB(1:NSMOB,IGAS)
    NOCOB = NOCOB+NGSOBT(IGAS)
  end if
  ! Add to active orbitals
  if ((IGAS /= IGSINA) .and. (IGAS /= IGSDEL)) then
    NACOBS(1:NSMOB) = NACOBS(1:NSMOB)+NGSOB(1:NSMOB,IGAS)
    NACOB = NACOB+NGSOBT(IGAS)
  end if
end do
#ifdef _DEBUGPRINT_
! =================
! Well, report back
! =================
write(u6,*)
write(u6,*) ' Number of orbitals per symmetry :'
write(u6,*) ' ================================='
write(u6,*)
write(u6,'(1X,A,10I4,A)') '            Symmetry  ',(I,I=1,NSMOB)
write(u6,'(1X,A,2X,10A)') '           ========== ',('====',I=1,NSMOB)
do IGAS=1,NGAS
  write(u6,'(1X,A,I3,7X,A,10I4,8X,I3)') '   GAS',IGAS,'      ',(NGSOB(I,IGAS),I=1,NSMOB),NGSOBT(IGAS)
end do

write(u6,*) ' Total number of orbitals ',NTOOB
write(u6,*) ' Total number of occupied orbitals ',NOCOB
#endif
! Offsets for orbitals of given symmetry
ITOOBS(1) = 1
do ISMOB=2,NSMOB
  ITOOBS(ISMOB) = ITOOBS(ISMOB-1)+NTOOBS(ISMOB-1)
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Offsets for orbital of given symmetry'
call IWRTMA(ITOOBS,1,NSMOB,1,NSMOB)
#endif

!*******************************************
!                                          *
! Part 2 : Reordering arrays for orbitals  *
!                                          *
!*******************************************
call ORBORD_GAS(NSMOB,MXPOBS,MXPNGAS,NGAS,NGSOB,NGSOBT,NTOOBS,NTOOB,IREOST,IREOTS,ISMFTO,IBSO,NOBPTS,IOBPTS,ISMFSO,NOBPT)

! Largest number of orbitals of given sym and type
MXTSOB = 0
do IOBTP=1,NGAS
  LTOB = 0
  do IOBSM=1,NSMOB
    MXTSOB = max(MXTSOB,NOBPTS(IOBTP,IOBSM))
    LTOB = LTOB+NOBPTS(IOBTP,IOBSM)
  end do
end do
#ifdef _DEBUGPRINT_
write(u6,*) ' MXTSOB from ORBINF = ',MXTSOB
#endif

end subroutine ORBINF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DefParReord (NaGrpR,maxdim)

c
c       This routine do:
c       define parameters in chcc_reord.fh using NaGrpR,maxdim
c
c       I/O parameter description:
c       NxGrpR   - # of groups in a (=b) set (I)
c       maxdim   - # maximal dimension of a (=b) Groups(O)
c
        implicit none
#include "chcc1.fh"
#include "chcc_reord.fh"
#include "chcc_files.fh"
c
        integer NaGrpR,maxdim
c
c       help variables
c
        real*8 rdim
        integer i,j
        integer Up(1:MaxGrp),Low(1:MaxGrp)
c
c
c1      define parameters of Groups of a set
c
        rdim=1.0d0*nv/(1.0d0*NaGrpR)
c
        do i=1,NaGrpR
c
           if (i.eq.1) then
             Up(i)=int(rdim*i)
             Low(i)=1
           else if (i.eq.NaGrpR) then
             Up(i)=nv
             Low(i)=Up(i-1)+1
           else
             Up(i)=int(rdim*i)
             Low(i)=Up(i-1)+1
           end if
c
           DimGrpaR(i)=(Up(i)-Low(i))+1
c
        end do
c
c
c2      find maximal dimensions of a'
c
        maxdim=DimGrpaR(1)
        do i=1,NaGrpR
          if (DimGrpaR(i).gt.maxdim) then
          maxdim=DimGrpaR(i)
          end if
        end do
c
c
c3.1    def L2Name, T2Name, I2Name,I3Name
c
        do i=1,MaxGrp
        do j=1,MaxGrp
          call DefParo3v3Hlp1(i,j,'L2',L2Name(i,j))
          call DefParo3v3Hlp1(i,j,'T2',T2Name(i,j))
          call DefParo3v3Hlp1(i,j,'I2',I2Name(i,j))
          call DefParo3v3Hlp1(i,j,'I3',I3Name(i,j))
        end do
        end do
c
c3.2    def L1Name,I1Name
c
        do i=1,MaxGrp
          call DefParo3v3Hlp2 (i,'L1vc',L1Name(i))
          call DefParo3v3Hlp2 (i,'I1in',I1Name(i))
        end do
c
c3.3    def L0Name,I0Name
c
        L0Name='L0vctr'
        I0Name='I0intg'
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine hrecur(pn,dpn,pn1,x,nn)
c
      implicit real*8 (a-h,o-z)
c
      p1 = 1.0d0
      p  = x
      dp1 = 0.0d0
      dp  = 1.0d0
      do 20 j=2,nn
        fj = (j)
        fj2 = 0.5d0*(fj-1.0d0)
        q  = x*p - fj2*p1
        dq = x*dp + p - fj2*dp1
        p1 = p
        p  = q
        dp1 = dp
        dp  = dq
   20 continue
      pn  = p
      dpn = dp
      pn1 = p1
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

program Main

#ifdef _FPE_TRAP_
use, intrinsic :: IEEE_Exceptions, only: IEEE_Set_Halting_Mode, IEEE_Usual
use Definitions, only: DefInt
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: rc

#ifdef _FPE_TRAP_
call IEEE_Set_Halting_Mode(IEEE_Usual,.true._DefInt)
#endif

call Start('mckinley')
call mckinley(rc)
call Finish(rc)

end program Main

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contt12(wrk,wrksize)
! this routine does T12 contribution:
! t1n(a,i) <- sum(e) [FI(a,e) . T1o(e,i)
!
! N.B. use and destroy : M1
! N.B. Parallel : in the case where idaaaa /= idbaab and
!      idaaaa /= idbaab this routine runs contributions to
!      T1n also on idaaaa and idbbbb nodes, since on these
!      nodes there is a specific
!      part of contributions F13 (see notes in sumoverb routine)
!      which are not presented on pilot nodes

use ccsd_global, only: f11, f12, idaaaa, idaabb, idbaab, idbbbb, m1, t11, t12, t13, t14
use Para_Info, only: MyRank
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: rc, ssc

!1 t1n(a,i)aa <- sum(e-a) [F1(a,e)aa . T1o(e,i)aa ]

!par
if ((myRank == idbaab) .or. (myRank == idaaaa)) then
  !1.1 mult M1(a,i) <= F1(a,e)aa . T1o(e,i)aa
  call ccmult(wrk,wrksize,2,2,2,1,f11,1,t11,1,m1,ssc,rc)

  !1.2 add t1n(a,i)aa <- M1(a,i)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,One,m1,1,t13,1,rc)
end if

!2 t1n(a,i)bb <- sum(e-a) [F1(a,e)bb . T1o(e,i)bb ]

!par
if ((myRank == idaabb) .or. (myRank == idbbbb)) then
  !2.1 mult M1(a,i) <= F1(a,e)bb . T1o(e,i)bb
  call ccmult(wrk,wrksize,2,2,2,1,f12,1,t12,1,m1,ssc,rc)

  !2.2 add t1n(a,i)bb <- M1(a,i)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,One,m1,1,t14,1,rc)
end if

return

end subroutine contt12

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SETPASS(DIAG,DIASH,ISYSH,IRED,CONV,NPOTSH)
!
! Purpose: Check convergence and, if not converged, set up
!          integral pass.

use Cholesky, only: DiaMax, DiaMin, nnShl, nSym, Span, ThrCom
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: Diag(*)
real(kind=wp), intent(_OUT_) :: DIASH(*)
integer(kind=iwp), intent(_OUT_) :: ISYSH(*)
integer(kind=iwp), intent(in) :: IRED
logical(kind=iwp), intent(out) :: CONV
integer(kind=iwp), intent(out) :: NPOTSH
integer(kind=iwp) :: ISHLAB, ISYM
real(kind=wp) :: DGMAX

! Initialize the potential number of shell pairs that can
! contribute.
! -------------------------------------------------------

NPOTSH = 0

! Find max. abs. diagonal in each symmetry and the global max.
! ------------------------------------------------------------

DGMAX = -1.0e15_wp
call CHO_MAXABSDIAG(DIAG,IRED,DGMAX)

! If not converged, set next integral pass.
! -----------------------------------------

CONV = DGMAX < THRCOM
if (.not. CONV) then
  call CHO_SETMAXSHL(DIAG,DIASH,ISYSH,IRED)
  do ISYM=1,NSYM
    DIAMIN(ISYM) = max(DIAMAX(ISYM)*SPAN,THRCOM)
  end do
  do ISHLAB=1,NNSHL
    if (DIASH(ISHLAB) > THRCOM) then
      NPOTSH = NPOTSH+1
    else
      DIASH(ISHLAB) = Zero
    end if
  end do
end if

end subroutine CHO_SETPASS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReMap_V_k(iSym,V_k,nV_k,V_k_New,nV_k_New,iSO_ab,ij2K,m_ij2K)

use Index_Functions, only: nTri_Elem
use Constants, only: Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iSym, nV_k, nV_k_New, iSO_ab(2,nV_k), m_ij2K
real(kind=wp), intent(in) :: V_k(nV_k)
real(kind=wp), intent(_OUT_) :: V_k_New(nV_k_New)
integer(kind=iwp), intent(out) :: ij2K(m_ij2K)
integer(kind=iwp) :: i, ij, j, k

if (iSym == 1) then
  do k=1,nV_k
    i = iSO_ab(1,k)
    j = iSO_ab(2,k)
    ij = nTri_Elem(i-1)+j
    if (i == j) then
      V_k_New(ij) = V_k(k)
    else
      V_k_New(ij) = Half*V_k(k)
    end if
    ij2K(ij) = k
  end do

  !write(u6,*) 'Triang <Vk|Vk> : ',ddot_(nV_k_New,V_k_New,1,V_k_New,1)

else

  do k=1,nV_k
    i = iSO_ab(1,k)
    j = iSO_ab(2,k)
    ij = nTri_Elem(i-1)+j
    ij2K(ij) = k
  end do
end if

return

end subroutine ReMap_V_k

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine getSeed(iseed)
      Implicit None
      Integer,Intent(Out) :: iseed
      Integer   i
      External  datimx
      Character Line*72
      Integer*8 hours,minutes,seconds,days
      Character*100, External :: Get_ProgName
*
*     Externally defined seed
      Call getenvf('MOLCAS_RANDOM_SEED',Line)
      If (Line.ne.' ') Then
        Read(Line,*) iseed
        Return
      End If
*
*     Somewhat reproducible if inside verification
      Call getenvf('MOLCAS_TEST',Line)
      If (Line.ne.' ') Then
        Call getenvf('MOLCAS_ITER',Line)
        Read(Line,*) iseed
        Call getenvf('MOLCAS_PRINT',Line)
        Do i=1,Len_Trim(Line)
          iseed = iseed+iChar(Line(i:i))
        End Do
        Line=Trim(Get_ProgName())
        Do i=1,Len_Trim(Line)
          iseed = iseed+iChar(Line(i:i))
        End Do
        Return
      End If
*
*     Default: based on time and project name
      Call datimx(Line)
      Read(Line,'(8x,i2,1x,i2,1x,i2,1x,i2)') days,hours,minutes,seconds
      iseed=Int(((days*24+hours)*60+minutes)*60+seconds,Kind(iseed))
      Call getenvf('Project',Line)
      Do i=1,Len_Trim(Line)
        iseed = iseed+iChar(Line(i:i))
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************

subroutine CalcPUVXOff()

use nq_Info, only: mIrrep, mOrb, nAsh, nPot2, nUVX, nUVXt, nVX, nVXt, OffPUVX, OffUVX, OffVX
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iIrrep, ijIrrep, IOff1, iOrb, jAct, jIrrep, kAct, kIrrep, klIrrep, lAct, lIrrep, nklAct

IOff1 = 0
do kIrrep=0,mIrrep-1
  kAct = nAsh(kIrrep)
  do lIrrep=0,kIrrep
    lAct = nAsh(lIrrep)
    nklAct = kAct*lAct
    if (kIrrep == lIrrep) nklAct = kAct*(kAct+1)/2
    OffVX(lIrrep,kIrrep) = IOff1
    nVX(lIrrep,kIrrep) = nklAct
    IOff1 = IOff1+nklAct
  end do
end do
nVXt = iOff1

IOff1 = 0
do jIrrep=0,mIrrep-1
  jAct = nAsh(jIrrep)
  do kIrrep=0,mIrrep-1
    kAct = nAsh(kIrrep)
    do lIrrep=0,kIrrep
      lAct = nAsh(lIrrep)
      nklAct = kAct*lAct
      if (kIrrep == lIrrep) nklAct = kAct*(kAct+1)/2
      OffUVX(lIrrep,kIrrep,jIrrep) = IOff1
      nUVX(lIrrep,kIrrep,jIrrep) = jAct*nklAct
      IOff1 = iOff1+jAct*nklAct
    end do
  end do
end do
nUVXt = IOff1

IOff1 = 0
do iIrrep=0,mIrrep-1
  OffPUVX(iIrrep) = IOff1
  iOrb = mOrb(iIrrep)
  do jIrrep=0,mIrrep-1
    jAct = nAsh(jIrrep)
    ijIrrep = 1+ieor(iIrrep,jIrrep)
    do kIrrep=0,mIrrep-1
      kAct = nAsh(kIrrep)
      do lIrrep=0,kIrrep
        lAct = nAsh(lIrrep)
        klIrrep = 1+ieor(kIrrep,lIrrep)
        if (ijIrrep == klIrrep) then
          iOff1 = iOff1+iOrb*nUVX(lIrrep,kIrrep,jIrrep)
        end if
      end do
    end do
  end do
end do
nPot2 = IOff1

!write(u6,*) 'OffPUVX new method',nPot2,MaxUVX
!write(u6,'(8(I5,2X))') (OffPUVX(iIrrep),iIrrep=0,mIrrep-1)

return

end subroutine CalcPUVXOff

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_CHKDIA(DIAG,ISYM,XM,YM,ZM,NNEGT,NNEG,NCONV)
C
C     Purpose: 1) find min. in updated diagonal, XM (sym. ISYM only)
C              2) find max. in updated diagonal, YM (sym. ISYM only)
C              3) find abs. max. in updated diagonal, ZM (sym. ISYM only)
C              4) count #diagonals < 0.0D0, NNEGT
C              5) count #diagonals < THRNEG, NNEGT
C              6) count #screenable diagonals, NCONV
C
C     -- also: a) zero negative diagonals < THRNEG (from cholesky.fh)
C              b) screen diagonal if requested (flag SCDIAG from cholesky.fh)
C              c) Keep track of most negative zeroed diagonal.
C
#include "implicit.fh"
      DIMENSION DIAG(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_CHKDIA')

      PARAMETER (ZERO = 0.0D0)

      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)

C     Initialization.
C     ---------------

      NNEGT = 0
      NNEG  = 0
      NCONV = 0

      IF (NNBSTR(ISYM,2) .GT. 0) THEN
         JAB1 = IIBSTR(ISYM,2) + 1
         JAB2 = JAB1 + NNBSTR(ISYM,2) - 1
         XM   = DIAG(INDRED(JAB1,2))
         YM   = DIAG(INDRED(JAB1,2))
         ZM   = ABS(YM)
      ELSE
         XM = ZERO
         YM = ZERO
         ZM = ZERO
         RETURN
      END IF

C     Find min. and max. diagonal and zero too negative diagonals.
C     ------------------------------------------------------------

      DO JAB = JAB1,JAB2
         IAB = INDRED(JAB,2)  ! get address in first red. set
         XM  = MIN(XM,DIAG(IAB))
         YM  = MAX(YM,DIAG(IAB))
         IF (DIAG(IAB) .LT. ZERO) THEN
            NNEGT = NNEGT + 1
            IF (DIAG(IAB) .LT. THRNEG) THEN
               NNEG   = NNEG + 1
               IF (DIAG(IAB) .LT. TOONEG) THEN
                  WRITE(LUPRI,'(A,A,I12,1X,1P,D16.8)')
     &            SECNAM,': diagonal too negative: ',IAB,DIAG(IAB)
                  WRITE(LUPRI,'(A,A)')
     &            SECNAM,': shutting down Cholesky decomposition!'
                  CALL CHO_QUIT('Diagonal too negative in '//SECNAM,104)
               END IF
               IF (DIAG(IAB) .LT. WARNEG) THEN
                  WRITE(LUPRI,'(A,A,I12,1X,1P,D16.8,A)')
     &            SECNAM,': Negative diagonal: ',IAB,DIAG(IAB),
     &            ' (zeroed)'
               END IF
               IF (DIAG(IAB) .LT. DIAMNZ) THEN
                  DIAMNZ = DIAG(IAB)
                  IABMNZ = IAB
               END IF
               DIAG(IAB) = ZERO
            END IF
         END IF
      END DO
      ZM = MAX(ABS(XM),ABS(YM))

C     Screen diagonal (if requested) and count the screenables as
C     converged.
C     NOTE: the screening is actually identical to setting up
C           reduced sets. However, doing the screening here will
C           force entries in later vectors of this integral pass
C           to have zero entries at screened diagonals.
C     -----------------------------------------------------------

      IF (SCDIAG) THEN
         DO JAB = JAB1,JAB2
            IAB = INDRED(JAB,2)  ! get address in first red. set
            TST = SQRT(ABS(DIAG(IAB))*ZM)*DAMP(2)
            IF (TST .LE. THRCOM) THEN
               NCONV     = NCONV + 1
               DIAG(IAB) = ZERO
            END IF
         END DO
      ELSE
         DO JAB = JAB1,JAB2
            IAB = INDRED(JAB,2)  ! get address in first red. set
            TST = SQRT(ABS(DIAG(IAB))*ZM)*DAMP(2)
            IF (TST .LE. THRCOM) THEN
               NCONV = NCONV + 1
            END IF
         END DO
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MSP(B,rGamma,Delta,nDim)

use Constants, only: One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Constants, only: Two
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(inout) :: B(nDim,nDim)
real(kind=wp), intent(in) :: rGamma(nDim), Delta(nDim)
integer(kind=iwp) :: i
real(kind=wp) :: dd, gd, gg, phi
real(kind=wp), external :: DDot_

!                          T       T            ( T)
!                |(1-phi)/d g phi/d d|        | (g )
!                |     T       T    T         | ( T)
! B = B + (g  d )|phi/d d    -Phi*d g/(d d)**2| (d )

gd = DDot_(nDim,rGamma,1,Delta,1)
dd = DDot_(nDim,Delta,1,Delta,1)
gg = DDot_(nDim,rGamma,1,rGamma,1)
phi = (One-((gd**2)/(dd*gg)))

#ifdef _DEBUGPRINT_
call RecPrt(' MSP: Hessian',' ',B,nDim,nDim)
call RecPrt(' MSP: Delta',' ',Delta,nDim,1)
call RecPrt(' MSP: Gamma',' ',rGamma,nDim,1)
write(u6,*) 'MSP: Phi=',Phi
write(u6,*) 'gd,dd,gg=',gd,dd,gg
write(u6,*) 'MSP: a=',sqrt(Phi)
write(u6,*) 'MSP: E_msp=',(gd/dd)**2*((Two/(One-Phi*sqrt(Phi)))-One)
#endif

do i=1,nDim
  B(:,i) = B(:,i)+((One-phi)/gd)*rGamma(:)*rGamma(i)+phi*((rGamma(:)*Delta(i)+Delta(:)*rGamma(i))/dd-gd*Delta(:)*Delta(i)/dd**2)
end do

#ifdef _DEBUGPRINT_
call RecPrt(' MSP: Updated Hessian',' ',B,nDim,nDim)
#endif

end subroutine MSP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ReadUnconstrainedCoefficients(AB,l_C,C,irc)
C
C     Thomas Bondo Pedersen, March 2011.
C
C     Purpose: read unconstrained coefficients (1C lin dep removed).
C              This routine is used only for debugging purposes, and
C              the file may not exist (in which case irc=-1 is
C              returned).
C
      Implicit None
      Integer AB
      Integer l_C
      Real*8  C(l_C)
      Integer irc
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_AtomPair_DiagDim, LDF_nBasAux_Pair
      External LDF_AtomPair_DiagDim, LDF_nBasAux_Pair

      Character*5 FileName
      Parameter (FileName='LDFUC')

      Logical FileExists
      Integer l
      Integer Lu_UC
      Integer iAddr
      Integer i
      Integer iOpt

      Integer j
      Integer Unique
      Logical isUnique
      Unique(j)=iWork(ip_AP_Unique-1+j)
      isUnique(j)=Unique(j).eq.j

      FileExists=.False.
      Call f_Inquire(FileName,FileExists)
      If (FileExists) Then
         l=LDF_AtomPair_DiagDim(AB)*LDF_nBasAux_Pair(AB)
         If (l_C.lt.l) Then
            irc=1
         Else
            Lu_UC=7
            Call DAName_mf_wa(Lu_UC,FileName)
            iAddr=0
            Do i=1,Unique(AB)-1
               If (isUnique(i)) Then
                  iAddr=iAddr
     &                 +LDF_AtomPair_DiagDim(i)*LDF_nBasAux_Pair(i)
               End If
            End Do
            iOpt=2
            Call dDAFile(Lu_UC,iOpt,C,l,iAddr)
            Call DAClos(Lu_UC)
            irc=0
         End If
      Else
         irc=-1
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_WriteUnconstrainedCoefficients(AB,l_C,C,irc)
C
C     Thomas Bondo Pedersen, March 2011.
C
C     Purpose: write unconstrained coefficients to disk (for debugging).
C
      Implicit None
      Integer AB
      Integer l_C
      Real*8  C(l_C)
      Integer irc
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_AtomPair_DiagDim, LDF_nBasAux_Pair
      External LDF_AtomPair_DiagDim, LDF_nBasAux_Pair

      Character*5 FileName
      Parameter (FileName='LDFUC')

      Integer l
      Integer Lu_UC
      Integer iAddr
      Integer i
      Integer iOpt

      Integer j
      Logical isUnique
      isUnique(j)=iWork(ip_AP_Unique-1+j).eq.j

      If (.not.isUnique(AB)) Then
         irc=-1
      Else
         l=LDF_AtomPair_DiagDim(AB)*LDF_nBasAux_Pair(AB)
         If (l_C.lt.l) Then
            irc=1
         Else
            Lu_UC=7
            Call DAName_mf_wa(Lu_UC,FileName)
            iAddr=0
            Do i=1,AB-1
               If (isUnique(i)) Then
                  iAddr=iAddr
     &                 +LDF_AtomPair_DiagDim(i)*LDF_nBasAux_Pair(i)
               End If
            End Do
            iOpt=1
            Call dDAFile(Lu_UC,iOpt,C,l,iAddr)
            Call DAClos(Lu_UC)
            irc=0
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_F(icol,val,n)

use getline_mod, only: iEnd, iStrt, Line, nCol
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCol, n
real(kind=wp), intent(out) :: val(n)
integer(kind=iwp) :: i, i1, i2, ic, istatus
character(len=80) :: string

ic = icol
do i=1,n
  if (ic <= ncol) then
    i1 = istrt(ic)
    i2 = iend(ic)
    if (i1 <= i2) then
      string = ' '
      string(len(string)+i1-i2:) = line(i1:i2)
      read(string,'(F80.0)',iostat=istatus) val(i)
      if (istatus /= 0) exit
    else
      val(i) = Zero
    end if
    ic = ic+1
  else
    write(u6,110) icol+n-1,line
    exit
  end if
end do

if (i <= n) then
  call FindErrorLine()
  call WarningMessage(2,'Error in Get_F')
  call Quit_OnUserError()
end if

return

110 format(/' ERROR IN GET_F: TRYING TO READ',i4,' VALUES'/1x,a)

end subroutine Get_F

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine natureorb(nsbas,nsall,nsdel,ngsm,den1,lden,cmo,lcmo,bsbl,lenb,cno,occ,nmo,pror)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nsbas(8), nsall(8), nsdel(8), ngsm, lden, lcmo, lenb, nmo
real(kind=wp), intent(in) :: den1(lden), cmo(lcmo), pror
real(kind=wp), intent(out) :: cno(lcmo), occ(nmo)
character, intent(in) :: bsbl(lenb)
integer(kind=iwp) :: i, im, j, nc, nc0, nc1, nc2, nc3, nc4, nc5, nsfrz(8)
real(kind=wp) :: val
integer(kind=iwp), allocatable :: nsort(:)
real(kind=wp), allocatable :: buff(:)
character(len=128), parameter :: header = 'MRCISD Natural orbital'

nc0 = 1
do im=1,ngsm
  if (nsall(im) == 0) cycle
  nc1 = nsall(im)*(nsall(im)+1)/2
  nc0 = nc0+nc1
end do
!open(100,file='dat2')
!open(200,file='dat1')
!do i=1,1293
!  read(100,*) den1(i)
!  write(200,'(f14.8)') den1(i)
!end do
!close(100)
!close(200)

call mma_allocate(buff,nmo**2,label='buff')
call mma_allocate(nsort,nmo,label='nsort')

val = 0
cno(:) = cmo(:)
nc0 = 1
nc1 = 1
nc2 = 1
do im=1,ngsm
  if (nsbas(im) == 0) cycle
  nsfrz(im) = nsbas(im)-nsall(im)-nsdel(im)
  ! For density matrix, we only have correlated orbital density matrix
  buff(:) = Zero
  nc = nsall(im)*(nsall(im)+1)/2
  ! Diagonalize density matrix in symmetry block im and transform MO
  ! Copy density matrix
  buff(1:nc) = den1(nc2:nc2+nc-1)
  nc3 = nc1+nsfrz(im)*nsbas(im)
  call jacob(buff,cno(nc3),nsall(im),nsbas(im))
  ! OCC num from diagonal element
  nc3 = nc0
  occ(nc3:nc3+nsfrz(im)-1) = Two
  nc3 = nc3+nsfrz(im)
  do i=1,nsall(im)
    nc = i*(i+1)/2
    occ(nc3) = buff(nc)
    nc3 = nc3+1
  end do

  ! Sort natural orbital in OCC num decreasing order
  ! Sort and copy correlated natural orb
  do i=1,nsall(im)
    nsort(i) = i
  end do
  nc = nc0+nsfrz(im)-1
  do i=1,nsall(im)
    nc3 = i
    do j=i+1,nsall(im)
      if (occ(nc+j) > occ(nc+i)) then
        val = occ(nc+j)
        occ(nc+j) = occ(nc+i)
        occ(nc+i) = val
        nc3 = j
      end if
    end do
    nsort(i) = nc3
  end do

  buff(:) = Zero
  nc3 = nsbas(im)**2
  buff(1:nc3) = cno(nc1:nc1+nc3-1)
  ! Copy sorted orbital
  nc = nc1+nsfrz(im)*nsbas(im)
  nc5 = 1+nsfrz(im)*nsbas(im)
  do i=1,nsall(im)
    j = nsort(i)
    nc3 = nc+(i-1)*nsbas(im)
    nc4 = nc5+(j-1)*nsbas(im)
    cno(nc3:nc3+nsbas(im)-1) = buff(nc4:nc4+nsbas(im)-1)
  end do

  ! Do nothing for deleted orbital
  !nc3 = 1+(nsfrz(im)+nsall(im))*nsbas(im)
  !nc = nsdel(im)*nsbas(im)-1
  !cno(nc3:nc3+nc) = buff(nc3:nc3+nc)

  nc0 = nc0+nsbas(im)
  nc1 = nc1+nsbas(im)**2
  nc2 = nc2+nsall(im)*(nsall(im)+1)/2
end do

call mma_deallocate(buff)
call mma_deallocate(nsort)

!nc0 = 1
!do im=1,ngsm
!  if (nsbas(im) == 0) cycle
!  write(u6,*) ' '
!  write(u6,*) 'SYM',im
!  write(u6,'(10(1xf8.4))') occ(nc0:nc0+nsbas(im)-1)
!  nc0 = nc0+nsbas(im)
!end do

call primo(Header,.true.,.false.,pror,Zero,ngsm,nsbas,nsbas,bsbl,[val],occ,cno,-1)

return

end subroutine natureorb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine drl_bl_ext_ar_new(lin,lrk,lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      lptype=12
      isma=lsm_inn(lri)
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        w1_sdplp=vplpnew_w1(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        if(logic_dh) w1_sdplp=vplp_w1(iw0)
        if(logic_grad)   then
          call lp9_drlbl_ext_calcuvalue_g(lri,lrk,isma)
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.6)  call gsd_sequence_extspace_g(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace_g(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace_g(ilw,irw)
            else
              ihypos=jphy(iplp)
              ndim =ihy(ihypos)
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihypos+in)
                iwar=iwar0+ihy(ihypos+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
              if(lin.eq.6)  call gsd_sequence_extspace_g(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace_g(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace_g(ilw,irw)
                enddo
              enddo
            endif
          enddo
        else
          call lp9_drlbl_ext_calcuvalue_wyb(lri,lrk,isma)
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.6)  call gsd_sequence_extspace(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace(ilw,irw)
            else
              if(log_prod.eq.3) then
                lphead=lpnew_head(iplp)
                ihyposl=jphyl(lphead)
                ihyposr=jphy(lphead)
                ndim =ihyl(ihyposl)
              else
                ihyposl=jphy(iplp)
                ihyposr=ihyposl
                ndim =ihy(ihyposl)
              endif
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihyposl+in)
                iwar=iwar0+ihy(ihyposr+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
                  if(lin.eq.6)  call gsd_sequence_extspace(ilw,irw)
                  if(lin.eq.13) call gtd_sequence_extspace(ilw,irw)
                  if(lin.eq.23) call gdv_sequence_extspace(ilw,irw)
                enddo
              enddo
            endif
          enddo

        endif
      enddo
      return
      end

      subroutine drl_br_ext_al_new(lin,lrk,lri )   !to be reviced
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/

      lptype=8
      iwuplwei=jpad_upwei(jpad)
      iwuprwei=jpad_upwei(jpadl)
      ilsegdownwei=iseg_downwei(ipae)
      irsegdownwei=iseg_downwei(ipael)
      isma=lsm_inn(lri)

      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)-vplpnew_w1(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)-vplp_w1(iw0)
        if(abs(w0_sdplp).lt.crl) cycle
        if(logic_grad) then
          call lp678_ext_calcuvalue_g(lri,lrk,isma,nlp_value)
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.7)  call gsd_sequence_extspace_g(irw,ilw)
              if(lin.eq.14) call gtd_sequence_extspace_g(irw,ilw)
              if(lin.eq.26) call gdv_sequence_extspace_g(irw,ilw)
            else
              ihypos=jphy(iplp)
              ndim =ihy(ihypos)
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihypos+in)
                iwar=iwar0+ihy(ihypos+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
              if(lin.eq.7)  call gsd_sequence_extspace_g(irw,ilw)
              if(lin.eq.14) call gtd_sequence_extspace_g(irw,ilw)
              if(lin.eq.26) call gdv_sequence_extspace_g(irw,ilw)
                enddo
              enddo
            endif
          enddo

        else
          call lp678_ext_wyb_calcuvalue(lri,lrk,isma,nlp_value)
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.7)  call gsd_sequence_extspace(irw,ilw)
              if(lin.eq.14) call gtd_sequence_extspace(irw,ilw)
              if(lin.eq.26) call gdv_sequence_extspace(irw,ilw)
            else
              if(log_prod.eq.3) then
                lphead=lpnew_head(iplp)
                ihyposl=jphyl(lphead)
                ihyposr=jphy(lphead)
                ndim =ihyl(ihyposl)
              else
                ihyposl=jphy(iplp)
                ihyposr=ihyposl
                ndim =ihy(ihyposl)
              endif
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihyposl+in)
                iwar=iwar0+ihy(ihyposr+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
                  if(lin.eq.7)  call gsd_sequence_extspace(irw,ilw)
                  if(lin.eq.14) call gtd_sequence_extspace(irw,ilw)
                  if(lin.eq.26) call gdv_sequence_extspace(irw,ilw)
                enddo
              enddo
            endif
          enddo
        endif
      enddo
      return
      end

      subroutine ar_bl_br_ext_al_new(lin,intentry,isma,nk)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
c      if(lin.eq.14.and.intentry.eq.15195.and.isma
c     :    .eq.1.and.jpad.eq.20.and.jpad.eq.jpadl) then
c      write(6,*) "bbs_tmp"
c      endif

      lptype=11
      iwuplwei=jpad_upwei(jpad)
      iwuprwei=jpad_upwei(jpadl)
      ilsegdownwei=iseg_downwei(ipae)
      irsegdownwei=iseg_downwei(ipael)
      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        w1_sdplp=vplpnew_w1(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        if(logic_dh) w1_sdplp=vplp_w1(iw0)

        if(logic_grad) then
          call lp11_arblbr_ext_calcuvalue_g(intentry,isma,nlp_value)
          ilpsta=nstaval(iw0)*nk+1
          ilpend=(nstaval(iw0)+nvalue(iw0))*nk
          do iplp=ilpsta,ilpend
            if(logic_dh) then                     !lp_head is in dbl_spa
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.7)  call gsd_sequence_extspace_g(irw,ilw)
              if(lin.eq.14) call gtd_sequence_extspace_g(irw,ilw)
              if(lin.eq.26) call gdv_sequence_extspace_g(irw,ilw)
            else                                    !lp_head is in act_s
              ihypos=jphy(iplp)
              ndim =ihy(ihypos)
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihypos+in)
                iwar=iwar0+ihy(ihypos+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
              if(lin.eq.7)  call gsd_sequence_extspace_g(irw,ilw)
              if(lin.eq.14) call gtd_sequence_extspace_g(irw,ilw)
              if(lin.eq.26) call gdv_sequence_extspace_g(irw,ilw)
                enddo
              enddo
            endif
          enddo
        else
          call lp11_arblbr_ext_calcuvalue(intentry,isma,nlp_value)
          ilpsta=nstaval(iw0)*nk+1
          ilpend=(nstaval(iw0)+nvalue(iw0))*nk
          do iplp=ilpsta,ilpend
            if(logic_dh) then                     !lp_head is in dbl_spa
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.7)  call gsd_sequence_extspace(irw,ilw)
              if(lin.eq.14) call gtd_sequence_extspace(irw,ilw)
              if(lin.eq.26) call gdv_sequence_extspace(irw,ilw)
            else                                    !lp_head is in act_s
              if(log_prod.eq.3) then
                lphead=lpnew_head(iplp)
                ihyposl=jphyl(lphead)
                ihyposr=jphy(lphead)
                ndim =ihyl(ihyposl)
              else
                ihyposl=jphy(iplp)
                ihyposr=ihyposl
                ndim =ihy(ihyposl)
              endif

              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihyposl+in)
                iwar=iwar0+ihy(ihyposr+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
                  if(lin.eq.7)  call gsd_sequence_extspace(irw,ilw)
                  if(lin.eq.14) call gtd_sequence_extspace(irw,ilw)
                  if(lin.eq.26) call gdv_sequence_extspace(irw,ilw)
                enddo
              enddo
            endif
          enddo
        endif
      enddo
      return
      end


      subroutine ar_drl_ext_al_new(lin,lri,lrk )
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/

      lptype=6
      isma=lsm_inn(lri)
      iwuplwei=jpad_upwei(jpad)
      iwuprwei=jpad_upwei(jpadl)
      ilsegdownwei=iseg_downwei(ipae)
      irsegdownwei=iseg_downwei(ipael)
      w0_sdplp=vplpnew_w0(1)
      if(logic_dh) w0_sdplp=vplp_w0(1)

      if(logic_grad) then
      call lp678_ext_calcuvalue_g(lri,lrk,isma,nlp_value)
      w0_sdold=w0_sdplp
      do iw0=1,mtype
        if(iw0.eq.1) goto 201
        w0_sdplp=vplpnew_w0(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        if(abs(w0_sdplp).lt.crl) cycle
        w0multi=w0_sdplp/w0_sdold
        w0_sdold=w0_sdplp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
         value_lpext1(iiext)=value_lpext1(iiext)*w0multi
        enddo
201     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            if(lin.eq.7)  call gsd_sequence_extspace_g(irw,ilw)
            if(lin.eq.14) call gtd_sequence_extspace_g(irw,ilw)
            if(lin.eq.26) call gdv_sequence_extspace_g(irw,ilw)
          else
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
            if(lin.eq.7)  call gsd_sequence_extspace_g(irw,ilw)
            if(lin.eq.14) call gtd_sequence_extspace_g(irw,ilw)
            if(lin.eq.26) call gdv_sequence_extspace_g(irw,ilw)
              enddo
            enddo
          endif
        enddo
      enddo

      else
      call lp678_ext_wyb_calcuvalue(lri,lrk,isma,nlp_value)
      w0_sdold=w0_sdplp
      do iw0=1,mtype
        if(iw0.eq.1) goto 202
        w0_sdplp=vplpnew_w0(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        if(abs(w0_sdplp).lt.crl) cycle
        w0multi=w0_sdplp/w0_sdold
        w0_sdold=w0_sdplp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
        enddo
202     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            if(lin.eq.7)  call gsd_sequence_extspace(irw,ilw)
            if(lin.eq.14) call gtd_sequence_extspace(irw,ilw)
            if(lin.eq.26) call gdv_sequence_extspace(irw,ilw)
          else
            if(log_prod.eq.3) then
              lphead=lpnew_head(iplp)
              ihyposl=jphyl(lphead)
              ihyposr=jphy(lphead)
              ndim =ihyl(ihyposl)
            else
              ihyposl=jphy(iplp)
              ihyposr=ihyposl
              ndim =ihy(ihyposl)
            endif

            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihyposl+in)
              iwar=iwar0+ihy(ihyposr+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                if(lin.eq.7)  call gsd_sequence_extspace(irw,ilw)
                if(lin.eq.14) call gtd_sequence_extspace(irw,ilw)
                if(lin.eq.26) call gdv_sequence_extspace(irw,ilw)
              enddo
            enddo
          endif
        enddo
      enddo
      endif
      return
      end

      subroutine drr_br_ext_ar(lin,lrk,lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/

      lptype=7
      isma=lsm_inn(lri)
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)

      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        if(abs(w0_sdplp).lt.crl) cycle
        if(logic_grad) then
          call lp678_ext_calcuvalue_g(lri,lrk,isma,nlp_value)
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.6)  call gsd_sequence_extspace_g(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace_g(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace_g(ilw,irw)
            else
              ihypos=jphy(iplp)
              ndim =ihy(ihypos)
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihypos+in)
                iwar=iwar0+ihy(ihypos+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
              if(lin.eq.6)  call gsd_sequence_extspace_g(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace_g(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace_g(ilw,irw)
                enddo
              enddo
            endif
          enddo

        else
          call lp678_ext_wyb_calcuvalue(lri,lrk,isma,nlp_value)
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.6)  call gsd_sequence_extspace(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace(ilw,irw)
            else
              if(log_prod.eq.3) then
                lphead=lpnew_head(iplp)
                ihyposl=jphyl(lphead)
                ihyposr=jphy(lphead)
                ndim =ihyl(ihyposl)
              else
                ihyposl=jphy(iplp)
                ihyposr=ihyposl
                ndim =ihy(ihyposl)
              endif

              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihyposl+in)
                iwar=iwar0+ihy(ihyposr+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
                  if(lin.eq.6)  call gsd_sequence_extspace(ilw,irw)
                  if(lin.eq.13) call gtd_sequence_extspace(ilw,irw)
                  if(lin.eq.23) call gdv_sequence_extspace(ilw,irw)
                enddo
              enddo
            endif
          enddo
        endif
      enddo
      return
      end

      subroutine ar_br_br_ext_ar_new(lin,intentry,isma)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      lptype=10
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        w1_sdplp=vplpnew_w1(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        if(logic_dh) w1_sdplp=vplp_w1(iw0)
      if(logic_grad) then
          call lp10_arbrbr_ext_calcuvalue_g(intentry,isma,nlp_vlue)
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.6)  call gsd_sequence_extspace_g(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace_g(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace_g(ilw,irw)
            else
              ihypos=jphy(iplp)
              ndim =ihy(ihypos)
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihypos+in)
                iwar=iwar0+ihy(ihypos+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
              if(lin.eq.6)  call gsd_sequence_extspace_g(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace_g(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace_g(ilw,irw)
                enddo
              enddo
            endif
          enddo

        else
          call lp10_arbrbr_ext_calcuvalue(intentry,isma,nlp_vlue)
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.6)  call gsd_sequence_extspace(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace(ilw,irw)
            else
              if(log_prod.eq.3) then
                lphead=lpnew_head(iplp)
                ihyposl=jphyl(lphead)
                ihyposr=jphy(lphead)
                ndim =ihyl(ihyposl)
              else
                ihyposl=jphy(iplp)
                ihyposr=ihyposl
                ndim =ihy(ihyposl)
              endif

              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihyposl+in)
                iwar=iwar0+ihy(ihyposr+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
                  if(lin.eq.6)  call gsd_sequence_extspace(ilw,irw)
                  if(lin.eq.13) call gtd_sequence_extspace(ilw,irw)
                  if(lin.eq.23) call gdv_sequence_extspace(ilw,irw)
                enddo
              enddo
            endif
          enddo
        endif
      enddo
      return
      end

      subroutine ar_bl_bl_ext_ar_new(lin,intentry,isma,nk)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      lptype=12
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        w1_sdplp=vplpnew_w1(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        if(logic_dh) w1_sdplp=vplp_w1(iw0)
        if(logic_grad) then
          call lp12_arblbl_ext_calcuvalue_g(intentry,isma,nlp_value)
          ilpsta=nstaval(iw0)*nk+1
          ilpend=(nstaval(iw0)+nvalue(iw0))*nk
          do iplp=ilpsta,ilpend
            if(logic_dh) then                     !lp_head is in dbl_spa
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.6)  call gsd_sequence_extspace_g(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace_g(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace_g(ilw,irw)
            else                                    !lp_head is in act_s
              ihypos=jphy(iplp)
                ndim =ihy(ihypos)
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihypos+in)
                iwar=iwar0+ihy(ihypos+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
              if(lin.eq.6)  call gsd_sequence_extspace_g(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace_g(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace_g(ilw,irw)
                enddo
              enddo
            endif
          enddo

        else
          call lp12_arblbl_ext_calcuvalue(intentry,isma,nlp_value)
          ilpsta=nstaval(iw0)*nk+1
          ilpend=(nstaval(iw0)+nvalue(iw0))*nk
          do iplp=ilpsta,ilpend
            if(logic_dh) then                     !lp_head is in dbl_spa
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.6)  call gsd_sequence_extspace(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace(ilw,irw)
            else                                    !lp_head is in act_s
              if(log_prod.eq.3) then
                lphead=lpnew_head(iplp)
                ihyposl=jphyl(lphead)
                ihyposr=jphy(lphead)
                ndim =ihyl(ihyposl)
              else
                ihyposl=jphy(iplp)
                ihyposr=ihyposl
                ndim =ihy(ihyposl)
              endif

              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihyposl+in)
                iwar=iwar0+ihy(ihyposr+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
                  if(lin.eq.6)  call gsd_sequence_extspace(ilw,irw)
                  if(lin.eq.13) call gtd_sequence_extspace(ilw,irw)
                  if(lin.eq.23) call gdv_sequence_extspace(ilw,irw)
                enddo
              enddo
            endif
          enddo
        endif
      enddo
      return
      end

      subroutine drl_br_sum_al_new(lin,lrp,lrq,lri)   !to be reviced
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/
      if(logic_grad) then
      do lrk=1,norb_dz
        if(lrp.eq.lrk) cycle
        if(lrq.eq.lrk) cycle
        lptype=8
        iwuplwei=jpad_upwei(jpad)
        iwuprwei=jpad_upwei(jpadl)
        ilsegdownwei=iseg_downwei(ipae)
        irsegdownwei=iseg_downwei(ipael)
        isma=lsm_inn(lri)
        w0_sdplp=vplp_w0(1)
        call lp8_drlbr_sum_calcuvalue_g(lri,lrk,isma,nlp_value)
        w0_sdold=w0_sdplp
        do iw0=1,mtype
          if(iw0.eq.1) goto 201
          w0_sdplp=vplp_w0(iw0)
          if(abs(w0_sdplp).lt.crl) cycle
          w0multi=w0_sdplp/w0_sdold
          w0_sdold=w0_sdplp
          do iiext=1,nlp_value
           value_lpext(iiext)=value_lpext(iiext)*w0multi
           value_lpext1(iiext)=value_lpext1(iiext)*w0multi
          enddo
201       ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.7)  call gsd_sequence_extspace_g(irw,ilw)
              if(lin.eq.14) call gtd_sequence_extspace_g(irw,ilw)
              if(lin.eq.26) call gdv_sequence_extspace_g(irw,ilw)
          enddo
        enddo
      enddo

      else
        lptype=8
        iwuplwei=jpad_upwei(jpad)
        iwuprwei=jpad_upwei(jpadl)
        ilsegdownwei=iseg_downwei(ipae)
        irsegdownwei=iseg_downwei(ipael)
        isma=lsm_inn(lri)
        w0_sdplp=vplp_w0(1)
        call lp8_drlbr_sum_calcuvalue_wyb(lri,lrp,lrq,isma,nlp_value)
        w0_sdold=w0_sdplp
        do iw0=1,mtype
          if(iw0.eq.1) goto 202
          w0_sdplp=vplp_w0(iw0)
          if(abs(w0_sdplp).lt.crl) cycle
          w0multi=w0_sdplp/w0_sdold
          w0_sdold=w0_sdplp
          do iiext=1,nlp_value
           value_lpext(iiext)=value_lpext(iiext)*w0multi
          enddo
202     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            if(lin.eq.7)  call gsd_sequence_extspace(irw,ilw)
            if(lin.eq.14) call gtd_sequence_extspace(irw,ilw)
            if(lin.eq.26) call gdv_sequence_extspace(irw,ilw)
        enddo
      enddo
      endif

      return
      end


      subroutine drl_bl_sum_ar_new(lin,lrp,lrq,lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/
      if(logic_grad) then
        do lrk=1,norb_dz
          if(lrp.eq.lrk) cycle
          if(lrq.eq.lrk) cycle
          lptype=9
          isma=lsm_inn(lri)
          iwuplwei=jpad_upwei(jpadl)
          iwuprwei=jpad_upwei(jpad)
          ilsegdownwei=iseg_downwei(ipael)
          irsegdownwei=iseg_downwei(ipae)
          w0_sdplp=vplp_w0(1)
          call lp9_drlbl_sum_calcuvalue_g(lri,lrk,isma,nlp_value)
          w0_sdold=w0_sdplp
          do iw0=1,mtype
            if(iw0.eq.1) goto 201
            w0_sdplp=vplp_w0(iw0)
            if(abs(w0_sdplp).lt.crl) cycle
            w0multi=w0_sdplp/w0_sdold
            w0_sdold=w0_sdplp
            do iiext=1,nlp_value
             value_lpext(iiext)=value_lpext(iiext)*w0multi
             value_lpext1(iiext)=value_lpext1(iiext)*w0multi
            enddo
201         ilpsta=nstaval(iw0)+1
            ilpend=nstaval(iw0)+nvalue(iw0)
            do iplp=ilpsta,ilpend
                ilw=lp_lwei(iplp)
                irw=lp_rwei(iplp)
                if(lin.eq.6)  call gsd_sequence_extspace_g(ilw,irw)
                if(lin.eq.13) call gtd_sequence_extspace_g(ilw,irw)
                if(lin.eq.23) call gdv_sequence_extspace_g(ilw,irw)
            enddo
          enddo
        enddo

      else
        lptype=9
        isma=lsm_inn(lri)
        iwuplwei=jpad_upwei(jpadl)
        iwuprwei=jpad_upwei(jpad)
        ilsegdownwei=iseg_downwei(ipael)
        irsegdownwei=iseg_downwei(ipae)
        w0_sdplp=vplp_w0(1)

        call lp9_drlbl_sum_calcuvalue_wyb(lri,lrp,lrq,isma,nlp_value)
        w0_sdold=w0_sdplp
        do iw0=1,mtype
          if(iw0.eq.1) goto 202
          w0_sdplp=vplp_w0(iw0)
          if(abs(w0_sdplp).lt.crl) cycle
          w0multi=w0_sdplp/w0_sdold
          w0_sdold=w0_sdplp
          do iiext=1,nlp_value
           value_lpext(iiext)=value_lpext(iiext)*w0multi
          enddo
202       ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              if(lin.eq.6)  call gsd_sequence_extspace(ilw,irw)
              if(lin.eq.13) call gtd_sequence_extspace(ilw,irw)
              if(lin.eq.23) call gdv_sequence_extspace(ilw,irw)
          enddo
        enddo
      endif
      return
      end

      subroutine ar_bl_ext_ss(lri,lrj,nk)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/

      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      imlr=mul_tab(iml,imr)
      if (imlr.eq.1) then
        logic_g1415=.true.
        if(iml.eq.1) logic_g13=.true.
        if(iml.eq.1) logic_g2g4b=.true.
        logic_g36b=.true.
        logic_g35b=.true.
        logic_g34b=.true.
      endif

      w0_plp=vplpnew_w0(1)
      w1_plp=0.d0
      if(logic_dh) w0_plp=vplp_w0(1)

      if(logic_grad) then
      call lp_arbl_ext_st_calcuvalue_g(lri,lrj,nlp_value)
      w0_old=w0_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 201
        w0_plp=vplpnew_w0(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(abs(w0_plp).lt.crl) cycle
        w0multi=w0_plp/w0_old
        w0_old=w0_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
         value_lpext1(iiext)=value_lpext1(iiext)*w0multi
        enddo

201     ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ss_loop_unpack_g(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_ss_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo
      else
      call lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
      w0_old=w0_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 202
        w0_plp=vplpnew_w0(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(abs(w0_plp).lt.crl) cycle
        w0multi=w0_plp/w0_old
        w0_old=w0_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
        enddo

202     ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ss_loop_unpack(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_ss_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo
      endif

      return
      end

      subroutine ar_bl_ext_st(lri,lrj,nk)     !w0=0
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      imlr=mul_tab(iml,imr)
      w0_plp=0.d0
      w1_plp=vplpnew_w1(1)
      if(logic_dh) w1_plp=vplp_w1(1)

      if(logic_grad) then
      call lp_arbl_ext_st_calcuvalue_g(lri,lrj,nlp_value)
      w1_old=w1_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 201
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)
        if(abs(w1_plp).lt.crl) cycle
        w0multi=w1_plp/w1_old
        w1_old=w1_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
         value_lpext1(iiext)=value_lpext1(iiext)*w0multi
        enddo

201     ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_st_loop_unpack_g(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_st_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo
      else
      call lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
      w1_old=w1_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 202
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)
        if(abs(w1_plp).lt.crl) cycle
        w0multi=w1_plp/w1_old
        w1_old=w1_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
        enddo

202     ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_st_loop_unpack(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_st_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo
      endif

      return
      end

      subroutine ar_bl_ext_ts(lri,lrj,nk)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      imlr=mul_tab(iml,imr)
      w0_plp=0.d0
      w1_plp=vplpnew_w1(1)
      if(logic_dh) w1_plp=vplp_w1(1)

      if(logic_grad) then
      call lp_arbl_ext_st_calcuvalue_g(lri,lrj,nlp_value)
      w1_old=w1_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 201
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)
        if(abs(w1_plp).lt.crl) cycle
        w0multi=w1_plp/w1_old
        w1_old=w1_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
         value_lpext1(iiext)=value_lpext1(iiext)*w0multi
        enddo

201     ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ts_loop_unpack_g(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_ts_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo
      else
      call lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
      w1_old=w1_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 202
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)
        if(abs(w1_plp).lt.crl) cycle
        w0multi=w1_plp/w1_old
        w1_old=w1_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
        enddo

202     ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ts_loop_unpack(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_ts_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo
      endif

      return
      end

      subroutine ar_bl_ext_tt(lri,lrj,nk)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      imlr=mul_tab(iml,imr)
      if (imlr.eq.1) then
        logic_g1415=.true.
        logic_g36b=.true.
        logic_g35b=.true.
        logic_g34b=.true.
      endif
      do iw0=1,mtype
        w0_plp=vplpnew_w0(iw0)
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)

      if(logic_grad) then
        call lp_arbl_ext_st_calcuvalue_g(lri,lrj,nlp_value)
        ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_tt_loop_unpack_g(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_tt_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      else
        call lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
        ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_tt_loop_unpack(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_tt_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo

       endif
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module EQSOLV

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: MXCASE = 13
integer(kind=iwp) :: IDBMAT(8,MXCASE), IDSMAT(8,MXCASE), IDSTMAT(8,MXCASE), IDTMAT(8,MXCASE), IRHS, IVECC, IVECC2, IVECR, IVECW, &
                     IVECX, LLIST(8,8,17), MODVEC(8,MXCASE), MXSCT, NLIST(8,8,17), NLSTOT
! This is not a parameter, because the G1 correction modifies it
integer(kind=iwp) :: IFCOUP(MXCASE,MXCASE) = reshape( &
                     [ 0, 1, 2, 0, 3, 4, 5, 0, 0, 0, 0, 0, 0, &
                       0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, &
                       0, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, &
                       0, 0, 0, 0, 8, 0, 0, 9,10,11,12, 0, 0, &
                       0, 0, 0, 0, 0,13,14, 0, 0,15,16,23,24, &
                       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,17, 0, &
                       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,18, &
                       0, 0, 0, 0, 0, 0, 0, 0, 0,19, 0, 0, 0, &
                       0, 0, 0, 0, 0, 0, 0, 0, 0, 0,20, 0, 0, &
                       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,21, 0, &
                       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,22, &
                       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, &
                       0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], &
                     [MXCASE,MXCASE])

public :: IDBMAT, IDSMAT, IDSTMat, IDTMAT, IFCOUP, iRHS, iVecC, iVecC2, iVecR, iVecW, iVecX, LLIST, MODVEC, MXSCT, NLIST, NLSTOT

end module EQSOLV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SCDTC2_MCLR(RASVEC,ISMOST,ICBLTP,NSMST,NOCTPA,NOCTPB,
     &                  NSASO,NSBSO,IOCOC,IDC,IWAY,IMMLST,IPRNT)
*
* Scale elements of a RAS vector to transfer between
* combinations and packed determinants
* IWAY = 1 : dets to combs
* IWAY = 2 : combs to dets
* Combination storage mode is defined BY IDC
*
* General symmetry version , Feb 1991
*
      IMPLICIT real*8(A-H,O-Z)
      DIMENSION RASVEC(*),NSASO(NOCTPA,*),NSBSO(NOCTPB,*)
      DIMENSION IOCOC(NOCTPA,NOCTPB)
      DIMENSION ISMOST(*),ICBLTP(*),IMMLST(*)
*

      NTEST = 0000
      NTEST = MAX(NTEST,IPRNT)
      IF( NTEST .GT. 10 ) THEN
        WRITE(6,*) ' Information from SCDTC2 '
        WRITE(6,*) ' ======================= '
        WRITE(6,*) ' Input vector '
        CALL WRTRS2_MCLR(RASVEC,ISMOST,ICBLTP,IOCOC,
     &              NOCTPA,NOCTPB,NSASO,NSBSO,NSMST)
      END IF
*
      SQ2 = SQRT(2.0D0)
      SQ2I = 1.0D0/SQ2
*
      IBASE = 1
      DO 200 IASM = 1, NSMST
*
        IBSM = ISMOST(IASM)
        IF(IBSM.EQ.0.OR.ICBLTP(IASM).EQ.0) GOTO 200
        DO  100 IATP = 1, NOCTPA
          IF(ICBLTP(IASM).EQ.2) THEN
            IBTPMX = IATP
          ELSE
            IBTPMX = NOCTPB
          END IF
          NIA   = NSASO(IATP,IASM)
          DO 50 IBTP = 1,IBTPMX
            IF(IOCOC(IATP,IBTP).EQ.0) GOTO   50
*. Number of elements in this block
          call xflush(6)
            NIB = NSBSO(IBTP,IBSM)
            IF(ICBLTP(IASM).EQ.2.AND.IATP.EQ.IBTP) THEN
                NELMNT =  NIA*(NIA+1)/2
            ELSE
                NELMNT =  NIA*NIB
            END IF

          IF(IDC.EQ.2) THEN
            IF(IWAY.EQ.1) THEN
              FACTOR = SQ2
            ELSE
              FACTOR = SQ2I
            END IF
            CALL DSCAL_(NELMNT,FACTOR,RASVEC(IBASE),1)
            IF(IASM.EQ.IBSM.AND.IATP.EQ.IBTP) THEN
              FACTOR = 1.0D0/FACTOR
              CALL SCLDIA(RASVEC(IBASE),FACTOR,NIA,1)
            END IF
          ELSE IF(IDC.EQ.3.AND.IMMLST(IASM).NE.IASM) THEN
            IF(IWAY.EQ.1) THEN
              FACTOR = SQ2
            ELSE
              FACTOR = SQ2I
            END IF
            CALL DSCAL_(NELMNT,FACTOR,RASVEC(IBASE),1)
*Ml Ms combinations
          call xflush(6)
          ELSE IF(IDC.EQ.4) THEN
            IF(IWAY.EQ.1) THEN
              IF(IASM.EQ.IBSM) THEN
                FACTOR = SQ2
              ELSE
                FACTOR = 2.0D0
              END IF
            ELSE IF(IWAY.EQ.2) THEN
              IF(IASM.EQ.IBSM) THEN
                FACTOR = SQ2I
              ELSE
                FACTOR = 0.5D0
              END IF
            END IF
            CALL DSCAL_(NELMNT,FACTOR,RASVEC(IBASE),1)
            IF(IATP.EQ.IBTP) THEN
              IF(IWAY.EQ.1) THEN
                FACTOR = SQ2I
              ELSE IF(IWAY.EQ.2) THEN
                FACTOR = SQ2
              END IF
              CALL SCLDIA(RASVEC(IBASE),FACTOR,NIA,1)
            END IF
          END IF
*
          IBASE = IBASE + NELMNT
  50      CONTINUE
 100    CONTINUE
 200  CONTINUE

*
      IF( NTEST .GT. 10 ) THEN
        WRITE(6,*) ' Scaled vector '
        call xflush(6)
        CALL WRTRS2_MCLR(RASVEC,ISMOST,ICBLTP,IOCOC,
     &              NOCTPA,NOCTPB,NSASO,NSBSO,NSMST)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine OpnFls_McKinley()
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep, lIrrep
      Implicit Real*8(a-h,o-z)
#include "Molcas.fh"
#include "disp.fh"
#include "disp2.fh"
#include "etwas.fh"
      Character*8 Method, MckLbl
      Character*288 Header
      iOpt = 1
      iRC = -1
      MckLbl='Title'
      Call cWrMck(iRC,iOpt,MckLbl,1,Header,iDummer)
      If (iRC.ne.0) Then
         Write (6,*) 'OpnFls: Error writing to MCKINT'
         Write (6,'(A,A)') 'MckLbl=',MckLbl
         Call Abend()
      End If
      iOpt = 1
      iRC = -1
      MckLbl='nSym'
      Call iWrMck(iRC,iOpt,MckLbl,1,[nIrrep],iDummer)
      If (iRC.ne.0) Then
         Write (6,*) 'OpnFls: Error writing to MCKINT'
         Write (6,'(A,A)') 'MckLbl=',MckLbl
         Call Abend()
      End If
      iOpt = 0
      iRC = -1
      MckLbl='nBas'
      Call iWrMck(iRC,iOpt,MckLbl,1,nBas,iDummer)
      If (iRC.ne.0) Then
         Write (6,*) 'OpnFls: Error writing to MCKINT'
         Write (6,'(A,A)') 'MckLbl=',MckLbl
         Call Abend()
      End If
      iOpt = 0
      iRC = -1
      MckLbl='SymOp'
      Call cWrMck(iRC,iOpt,MckLbl,1,lirrep(0),iDummer)
      If (iRC.ne.0) Then
         Write (6,*) 'OpnFls: Error writing to MCKINT'
         Write (6,'(A,A)') 'MckLbl=',MckLbl
         Call Abend()
      End If
      iOpt = 0
      iRC = -1
      MckLbl='ldisp'
      Call iWrMck(iRC,iOpt,MckLbl,1,ldisp,iDummer)
      If (iRC.ne.0) Then
         Write (6,*) 'OpnFls: Error writing to MCKINT'
         Write (6,'(A,A)') 'MckLbl=',MckLbl
         Call Abend()
      End If
      ngrad=0
      Do i=0,nIrrep-1
       nGrad=nGrad+ldisp(i)
      End Do
      iOpt = 0
      iRC = -1
      MckLbl='chdisp'
      Call cWrMck(iRC,iOpt,MckLbl,1,chdisp(1),iDummer)
      If (iRC.ne.0) Then
         Write (6,*) 'OpnFls: Error writing to MCKINT'
         Write (6,'(A,A)') 'MckLbl=',MckLbl
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*...  Get the method label
*
      Call Get_cArray('Relax Method',Method,8)
      If ( Method.eq.'RHF-SCF ' ) then
         nMethod=SCF
      Else if ( Method.eq.'CASSCF  ' ) then
         nMethod=RASSCF
      Else if ( Method.eq.'CASSCFSA' ) then
         nMethod=RASSCF
         Call Get_iScalar('SA ready',iGo)
         If (lHss.and.iGo.ne.2) Then
            Write (6,*)
            Write (6,*) ' Wavefunction type: RASSCF-SA'
            Write (6,*)
            Write (6,*) ' This option is not allowed when computing'//
     &                  ' the Hessian. Use the RHS option!'
            Call Quit_OnUserError()
         End If
      Else
         Write (6,*) ' OpnFls: Wavefunction type:',Method
         Write (6,*) '         Illegal type of wave function!'
         Write (6,*) '         McKinley can not continue'
         Write (6,*)
         Call Quit_OnUserError()
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Giovanni Li Manni                                      *
!***********************************************************************

subroutine print_MCPDFT(CASDFT_E)
!*****************************************************************
! Purpose:
! This routine is called from RASSCF when performing MC-PDFT jobs,
! for printing out some densities information and some functionals
! as computed in DRVNQ and children routines.
!
! Author:
! G. Li Manni (GLM)
!*****************************************************************

use KSDFT_Info, only: Funcaa, Funcbb, Funccc
use nq_Info, only: Dens_a1, Dens_a2, Dens_b1, Dens_b2, Dens_I
use PrintLevel, only: USUAL
use output_ras, only: IPRLOC
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CASDFT_E
integer(kind=iwp) :: IPRLEV, left
character(len=120) :: Line
character(len=6) :: Fmt2

IPRLEV = IPRLOC(6)
if (IPRLEV >= USUAL) then

  left = 6
  write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
  Line = ''
  write(Line(left-2:),'(A)') 'MC-PDFT run print out'
  write(u6,'(6X,80A)')
  call CollapseOutput(1,Line)
  write(u6,Fmt2//'A)') repeat('-',len_trim(Line)-3)
  write(u6,'(6X,80A)')

  write(u6,'(6X,A25,45X,F10.3)') 'Integrated total density:',Dens_I
  write(u6,'(6X,A58,12X,F10.3)') 'Integrated alpha density before functional transformation:',Dens_a1
  write(u6,'(6X,A58,12X,F10.3)') 'Integrated  beta density before functional transformation:',Dens_b1
  write(u6,'(6X,A58,12X,F10.3)') 'Integrated alpha density  after functional transformation:',Dens_a2
  write(u6,'(6X,A58,12X,F10.3)') 'Integrated  beta density  after functional transformation:',Dens_b2
  write(u6,'(6X,80A)')
  write(u6,'(6X,A32,30X,F18.6)') 'Integrated alpha exchange energy',Funcaa
  write(u6,'(6X,A32,30X,F18.6)') 'Integrated beta  exchange energy',Funcbb
  write(u6,'(6X,A32,30X,F18.6)') 'Integrated  correlation   energy',Funccc
  write(u6,'(6X,80A)')
  write(u6,'(6X,A20,42X,F18.8)') 'Total CAS-DFT energy',CASDFT_E

  call CollapseOutput(0,Line)
  write(u6,'(6X,80A)')
end if

call Add_Info('dens_tt',[Dens_I],1,6)
call Add_Info('dens_a1',[Dens_a1],1,6)
call Add_Info('dens_b1',[Dens_b1],1,6)
call Add_Info('dens_a2',[Dens_a2],1,6)
call Add_Info('dens_b2',[Dens_b2],1,6)
call Add_Info('excha_a',[Funcaa],1,6)
call Add_Info('excha_b',[Funcbb],1,6)
call Add_Info('corr_e',[Funccc],1,6)
call Add_Info('CASDFTE',[CASDFT_E],1,8)

end subroutine print_MCPDFT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE REF_NATO(DREF,CMO,OCC,CNAT)
      use definitions, only: iwp, wp
      use constants, only: Zero, One, Two
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM,NFRO,NISH,NASH,NBAS

      IMPLICIT None

      real(kind=wp), intent(In):: DREF(*),CMO(*)
      real(kind=wp), intent(out):: OCC(*),CNAT(*)

      real(kind=wp), ALLOCATABLE:: TMP(:)
      integer(kind=iwp) IDREF, IOCC, ICMO, ISYM, NF, NI, NA, NB, I, II,
     &                  J, JJ, LIJ, NFI, NSD, NTMP
      real(kind=wp) OC

* Purpose: compute natural orbitals and natural occupation numbers
* for the reference wave function.
* Given DREF, a triangular density matrix
* in active/active MO basis, and symmetry-blocked array CMO of MO
* coefficients, return array of  natural occupation numbers and MO
* coefficients of  natural orbitals. Frozen, inactive and virtual
C orbitals are copied unchanged.


      IDREF=0
      IOCC=0
      ICMO=0
      DO ISYM=1,NSYM
        NF=NFRO(ISYM)
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NB=NBAS(ISYM)
C Frozen and inactive orbitals:
        NFI=NF+NI
        IF(NFI>0) THEN
          CALL DCOPY_(NFI,[Two],0,OCC(IOCC+1),1)
          IOCC=IOCC+NFI
          CALL DCOPY_(NB*NFI,CMO(ICMO+1),1,CNAT(ICMO+1),1)
          ICMO=ICMO+NB*NFI
        END IF
C Active orbitals:
        IF(NA>0) THEN
          NTMP=(NA*(NA+1))/2
          CALL mma_allocate(TMP,NTMP,LABEL='TMP')
          CALL DCOPY_(NB*NA,CMO(ICMO+1),1,CNAT(ICMO+1),1)
C For correct ordering, change sign.
          LIJ=1
          DO I=1,NA
           II=I+IDREF
           DO J=1,I
            JJ=J+IDREF
            TMP(LIJ)=-DREF((II*(II-1))/2+JJ)
            LIJ=LIJ+1
           END DO
          END DO
          CALL NIDiag(TMP,CNAT(ICMO+1),NA,NB)
          CALL JACORD(TMP,CNAT(ICMO+1),NA,NB)
          CALL VEIG(NA,TMP,OCC(IOCC+1))
          CALL mma_deallocate(TMP)
C Change back to positive sign.
          CALL DSCAL_(NA,-One,OCC(IOCC+1),1)
* Certain CAS or RAS wave functions can legitimately have
* occupation numbers that are exactly 0 or 2. These may become
* inappropriate by rounding. Fix that as well.
          DO I=1,NA
           OC=OCC(IOCC+I)
           IF(OC<Zero) OC=Zero
           IF(OC>Two) OC=Two
           OCC(IOCC+I)=OC
          END DO
          IDREF=IDREF+NA
          IOCC=IOCC+NA
          ICMO=ICMO+NB*NA
        END IF
C Secondary and deleted orbitals:
        NSD=NB-(NFI+NA)
        IF(NSD>0) THEN
          CALL DCOPY_(NSD,[Zero],0,OCC(IOCC+1),1)
          IOCC=IOCC+NSD
          CALL DCOPY_(NB*NSD,CMO(ICMO+1),1,CNAT(ICMO+1),1)
          ICMO=ICMO+NB*NSD
        END IF
      END DO

      END SUBROUTINE REF_NATO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2003, Valera Veryazov                                  *
************************************************************************
      SubRoutine PMat_SCF(Dens,OneHam,TwoHam,nDT,NumDT,nXCf,FstItr,XCf,
     &                    nD,E_DFT,nE_DFT,Vxc,Fock)
************************************************************************
*                                                                      *
*     purpose: Compute two-electron part of the Fock matrix            *
*                                                                      *
*     input:                                                           *
*       Dens    : see SubRoutine DMat                                  *
*                                                                      *
*     output:                                                          *
*       TwoHam  : two-electron part of the Fock matrix constructed by  *
*                 contraction of proper density matrix difference with *
*                 two-electron integrals i) in conventional way ii) in *
*                 direct way                                           *
*                                                                      *
*     called from: WfCtl, Final                                        *
*                                                                      *
*     calls to: UnFold, FTwoa, Drv2El, RctFld                          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: UHF - V.Veryazov, 2003                                  *
*                                                                      *
************************************************************************
      use OFembed, only: Do_OFemb
      Implicit Real*8 (a-h,o-z)
      External EFP_On
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
#include "rctfld.fh"
#include "file.fh"
*
      Real*8, Target:: Dens(nDT,nD,NumDT), TwoHam(nDT,nD,NumDT)
      Real*8 OneHam(nDT)
      Real*8 XCf(nXCf,nD), E_DFT(nE_DFT), Vxc(nDT,nD,NumDT)
      Real*8 Fock(nDT,nD)
      Logical FstItr, NoCoul
*
#include "choscf.fh"
*
      Logical Found, EFP_On
*
*---- Define local variables
      Logical First, NonEq, ltmp1, ltmp2, Do_DFT
      Logical Do_ESPF
      Character NamRFil*16
      Data First /.true./
      Save First
      Real*8, Dimension(:), Allocatable:: RFfld, D
      Real*8, Dimension(:,:), Allocatable:: DnsS
      Real*8, Allocatable, Target:: Temp(:,:)
      Real*8, Dimension(:,:), Allocatable, Target:: Aux
      Real*8, Dimension(:,:), Pointer:: pTwoHam
      Real*8, Allocatable :: tVxc(:)
      Dimension Dummy(1),Dumm0(1),Dumm1(1)
#include "SysDef.fh"
*
      Interface
        SubRoutine Drv2El_dscf(Dens,TwoHam,nDens,nDisc,Thize,PreSch,
     &                         FstItr,NoCoul,ExFac)
        Integer nDens, nDisc
        Real*8, Target:: Dens(nDens), TwoHam(nDens)
        Real*8 Thize, ExFac
        Logical NoCoul
        Logical FstItr, PreSch
        End Subroutine Drv2El_dscf
      End Interface


      If (PmTime) Call CWTime(xCPM1,xWPM1)
      Call Timing(Cpu1,Tim1,Tim2,Tim3)
#ifdef _DEBUGPRINT_
      Call NrmClc(TwoHam(1,1,nDens),nBT*nD,'PMat: Enter','T in nDens')
      Call NrmClc(Vxc   (1,1,nDens),nBT*nD,'PMat: Enter','T in nDens')
      Call NrmClc(TwoHam(1,1,nDens),nBT*nD,'PMat: Enter','T in iPsLst')
      Call NrmClc(Vxc   (1,1,nDens),nBT*nD,'PMat: Enter','T in iPsLst')
#endif
*
      iter_d=iter-iter0
*
* --- Copy the (abs.) value of the Max Offdiag Fmat to a Common Block
* --- Used in the LK Cholesky algorithm
      dFKmat = abs(FMOmax)
*
*---- Add contribution due to external potential
*
      Call DCopy_(nBT*nD,[Zero],0,TwoHam(1,1,iPsLst),1)
      iSpin=1
      If (iUHF.eq.1) iSpin=2
      Call Put_iScalar('Multiplicity',iSpin)
*                                                                      *
************************************************************************
*                                                                      *
      Call DecideOnESPF(Do_ESPF)
      If ( Do_ESPF .or. lRF .or. KSDFT.ne.'SCF' .or. Do_OFemb .or.
     &     EFP_On()) Then
*
*------- Observe that this call always has to be prior to the calls
*        to Drv2El_dScf and/or FTwoa. This since DrvXV will redefine
*        ExFac!!!!!
*
*        Note, the linear (Oneham) and bilinear (TwoHam) contributions
*        can be computed with partial densities, as supplied with the
*        arguments to the routine. For the DFT contributions, however,
*        not being linear or bilinears, the total density is read from
*        the runfile (as put there by dmat).
*
         iCharge=Int(Tot_Charge)
         NonEq=.False.
         Do_DFT=.True.
         iDumm=1
         ltmp1=iter_d.eq.1
         ltmp2=iter_d.ne.1
         If (iUHF.eq.0) Then
            Call DrvXV(OneHam,TwoHam(1,1,iPsLst),Dens(1,1,iPsLst),
     &                  PotNuc,nBT,ltmp1,ltmp2,NonEq,
     &                  lRF,KSDFT,ExFac,iCharge,iSpin,
     &                  Dumm0,Dumm1,iDumm,'SCF ',Do_DFT)
         Else
            Call mma_allocate(D,nBT,Label='D')
            call dcopy_(nBT,Dens(1,1,iPsLst),1,D,1)
            Call DaXpY_(nBT,One,Dens(1,2,iPsLst),1,D,1)
            Call DrvXV(OneHam,TwoHam(1,1,iPsLst),D,
     &                 PotNuc,nBT,ltmp1,ltmp2,NonEq,
     &                 lRF,KSDFT,ExFac,iCharge,iSpin,
     &                 Dumm0,Dumm1,iDumm,'SCF ',Do_DFT)
            Call mma_deallocate(D)
            call dcopy_(nBT,TwoHam(1,1,iPsLst),1,TwoHam(1,2,iPsLst),1)
            If (MxConstr.gt.0 .and. klockan.eq.1) Then
               Call SetUp_iSD()
               Call Get_Enondyn_dft(nBT,Dummy,iDumm,'SCF ')
               Call Free_iSD()
               klockan=24
            EndIf
         End If
*
*        Pick up the integrated energy contribution of the external
*        potential to the total energy.
*
         Call Peek_dScalar('KSDFT energy',E_DFT(iter_d))
*
*        Pick up the contribution to the Fock matrix due to the
*        external field. Note that for some external field the
*        potential is neither linear nor bi-linear.
*
         If (KSDFT.ne.'SCF') Then
            nVxc=Size(Vxc,1)*Size(Vxc,2)
            Call mma_allocate(tVxc,nVxc,Label='tVxc')
            Call Get_dExcdRa_x(tVxc,nVxc)
            Call DCopy_(nVxc,tVxc,1,Vxc(1,1,iPsLst),1)
            Call mma_deallocate(tVxc)
         Else
            Call FZero(Vxc(1,1,iPsLst),nBT*nD)
         End If
*
         If (Do_OFemb) Then
            Call Get_NameRun(NamRfil) ! save the old RUNFILE name
            Call NameRun('AUXRFIL')   ! switch the RUNFILE name
            nVxc=Size(Vxc,1)*Size(Vxc,2)
            Call mma_allocate(tVxc,nVxc,Label='tVxc')
            Call Get_dExcdRa_x(tVxc,nVxc)
            Call DaXpY_(nDT*nD,One,tVxc,1,Vxc(1,1,iPsLst),1)
            Call mma_deallocate(tVxc)
            Call NameRun(NamRfil)   ! switch back RUNFILE name
         End If
#ifdef _DEBUGPRINT_
         Call NrmClc(Vxc   (1,1,iPsLst),nDT*nD,'PMat','Optimal V ')
#endif
*
      Else If ( RFpert.and.First ) Then
*
         If (iUHF.eq.1) Then
            write(6,*) ' UHF+RF: Not implemented'
            call Abend()
         End If
         Call mma_allocate(RFfld,nBT,Label='RFfld')
         Call f_Inquire('RUNOLD',Found)
         If (Found) Call NameRun('RUNOLD')
         Call Get_dScalar('RF Self Energy',ERFself)
         Call Get_dArray('Reaction field',RFfld,nBT)
         If (Found) Call NameRun('RUNFILE')
         PotNuc=PotNuc+ERFself
         Call Daxpy_(nBT,1.0d0,RFfld,1,OneHam,1)
         Do iD = 1, nD
            Call DCopy_(nBT,OneHam,1,Fock(1,iD),1)
         End Do
         Call mma_deallocate(RFfld)
*
      Else
*
         Call FZero(Vxc(1,1,iPsLst),nBT*nD)
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      First=.false.
*
*---- Compute the two-electron contribution to the Fock matrix
*
      Backup_ExFac=ExFac
      If (NoExchange) Then
         ExFac=0.0d0
      End If
      nT = 1
      If (nD.eq.2) nT=3
      Call mma_allocate(Temp,nBT,nT,Label='Temp')
      Call FZero(Temp,nBT*nT)
      If (PmTime) Call CWTime(tCF2,tWF2)
      If (DSCF) Then
         If (iUHF.eq.0) Then
            NoCoul=.False.
            Call Drv2El_dscf(Dens(1,1,iPsLst),Temp(1,1),nBT,
     &                       Max(nDisc*1024,nCore),Thize,PreSch,FstItr,
     &                       NoCoul,ExFac)
         Else
*
*           Compute the Coulomb potential for the total density and
*           exchange of alpha and beta, respectively. Add together
*           to get the correct contributions to the alpha and beta
*           Fock matrices.
*
*           Set exchange factor to zero and compute only Coulomb
*           for the total electron density.
*
            NoCoul=.False.
            Call DCopy_(nBT,Dens(1,1,iPsLst),1,Temp(1,2),1)
            Call DaXpY_(nBT,1.0D0,Dens(1,2,iPsLst),1,Temp(1,2),1)
*
            Call Drv2El_dscf(Temp(1,2),Temp(1,3),nBT,
     &                       Max(nDisc*1024,nCore),Thize,PreSch,FstItr,
     &                       NoCoul,0.0D0)
*
*           alpha exchange
            NoCoul=.TRUE.
            Call FZero(Temp(1,2),nBT)
            Call Drv2El_dscf(Dens(1,1,iPsLst),Temp(1,1),nBT,
     &                       Max(nDisc*1024,nCore),Thize,PreSch,FstItr,
     &                       NoCoul,ExFac)
            Call DScal_(nBT,2.0D0,Temp(1,1),1)
*
*           beta exchange
            Call Drv2El_dscf(Dens(1,2,iPsLst),Temp(1,2),nBT,
     &                       Max(nDisc*1024,nCore),Thize,PreSch,FstItr,
     &                       NoCoul,ExFac)
            Call DScal_(nBT,2.0D0,Temp(1,2),1)
*
*           Add together J and K contributions to form the correct
*           alpha and beta Fock matrices.
*
            Call DaXpY_(nBT,1.0D0,Temp(1,3),1,Temp(1,1),1)
            Call DaXpY_(nBT,1.0D0,Temp(1,3),1,Temp(1,2),1)
         End If
      Else
*------- Allocate memory for squared density matrix
         Call mma_allocate(DnsS,nBB,nD,Label='DnsS')
*------- Expand the 1-density matrix
         Do iD = 1, nD
            Call Unfold(Dens(1,iD,iPsLst),nBT,DnsS(1,iD),nBB,nSym,nBas)
         End Do
         If (nD==1) Then
            Call FockTwo_Drv_scf(nSym,nBas,nBas,nSkip,
     &                     Dens(:,:,iPsLst),DnsS(:,:),Temp(1,1),
     &                     nBT,ExFac,nBB,MaxBas,nD,
     &                     Dummy,nOcc(:,:),Size(nOcc,1),
     &                     iDummy_run)
         Else
            Call FockTwo_Drv_scf(nSym,nBas,nBas,nSkip,
     &                     Dens(:,:,iPsLst),DnsS(:,:),Temp(1,1),
     &                     nBT,ExFac,nBB,MaxBas,nD,
     &                     Temp(1,2),nOcc(:,:),Size(nOcc,1),
     &                     iDummy_run)
         End If
*
*------- Deallocate memory for squared density matrix
         Call mma_deallocate(DnsS)
      End If
      If (PmTime) Then
         Call CWTime(tCF2_1,tWF2_1)
         tCF2=tCF2_1-tCF2
         tWF2=tWF2_1-tWF2
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Add on FMM contributions to Fock matrix, only works for HF
*
      If (DoFMM) Call FMMFck(Dens(1,1,iPsLst),Temp(1,1),nDens)
*                                                                      *
************************************************************************
*                                                                      *
      Call DaXpY_(nBT*nD,One,Temp,1,TwoHam(1,1,iPsLst),1)
#ifdef _DEBUGPRINT_
      Call NrmClc(Temp,nBT*nD,'PMat_SCF','Temp')
      Call NrmClc(TwoHam(1,1,iPsLst),nBT*nD,'PMat_SCF','T in iPsLst')
#endif
      Call mma_deallocate(Temp)
*                                                                      *
************************************************************************
*                                                                      *
*     Now compute the total two-electron contribution
*
*     Generate the two-electron contribution corresponding to the total
*     density.
*
      If(MiniDn.and. Max(0,nIter(nIterP)-1).gt.0) Then
*
*        Minimized density option
*
*        D(k+1) = Sum_i_k C_i D_i + delta(k+1)
*
*        G(D(k+1)) = G(delta(k+1)) + Sum_i_k C_i G(D_i)
*
         Call mma_allocate(Aux,nDT,nD,Label='Aux')
         Do iMat = 1, iter_d-1
*
            tmp = 0.0D0
            Do iD = 1, nD
               tmp = tmp + Abs(XCf(iMat,iD))
            End Do
            If (tmp.eq.0.0D0) Cycle

            iM = MapDns(iMat)
            If (iM.lt.0) Then
               Call RWDTG(-iM,Aux,nDT*nD,'R','TWOHAM',iDisk,MxDDsk)
               pTwoHam => Aux
            Else
               pTwoHam => TwoHam(1:nDT,1:nD,iM)
            End If
*
            Do iD = 1, nD
               If (Xcf(iMat,iD).eq.0.0D0) Cycle
               Call DaXpY_(nBT,Xcf(iMat,iD),pTwoHam(:,iD),1,
     &                              TwoHam(1,iD,iPsLst),1)
            End Do
*
            Nullify(pTwoHam)
*
         End Do
         Call mma_deallocate(Aux)
*
      Else If (.not.DDnOFF) Then
*
*        Normal density difference
*
*        G(D(k+1)) = G(D(k)) + G(D(k+1)-D(k))
*
         Call DaXpY_(nBT*nD,One,TwoHam(1,1,nDens ),1,
     &                          TwoHam(1,1,iPsLst),1)
*
      End If
*
*     Restore the total density in position iPsLst
*
      Call DCopy_(nBT*nD,Dens  (1,1,nDens ),1,Dens  (1,1,iPsLst),1)
      Call DCopy_(nBT*nD,TwoHam(1,1,iPsLst),1,TwoHam(1,1,nDens ),1)
      Call DCopy_(nBT*nD,Vxc   (1,1,iPsLst),1,Vxc   (1,1,nDens ),1)
*
      ! Restore ExFac (if it was changed)
      If (NoExchange) Then
         ExFac=Backup_ExFac
      End If
*                                                                      *
************************************************************************
*                                                                      *
      TNorm = DDot_(nBT*nD,TwoHam(1,1,iPsLst),1,TwoHam(1,1,iPsLst),1)
     &      / DBLE(nD)
*
*
#ifdef _DEBUGPRINT_
      Call NrmClc(Dens  (1,1,iPsLst),nBT*nD,'PMat  ','D iPsLst  ')
      Call NrmClc(Dens  (1,1,nDens), nBT*nD,'PMat  ','D nDens   ')
      Call NrmClc(TwoHam(1,1,iPsLst),nBT*nD,'PMat  ','T iPsLst  ')
      Call NrmClc(TwoHam(1,1,nDens), nBT*nD,'PMat  ','T nDens   ')
      Call NrmClc(Vxc   (1,1,iPsLst),nBT*nD,'PMat  ','V iPsLst  ')
      Call NrmClc(Vxc   (1,1,nDens), nBT*nD,'PMat  ','V nDens   ')
*
#endif
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld( 5) = TimFld( 5) + (Cpu2 - Cpu1)
      If (PmTime) Then
         Call CWTime(xCPM2,xWPM2)
         xCPM = xCPM2 - xCPM1
         xWPM = xWPM2 - xWPM1
         Write(6,'(1X,A,F15.2,A,A,F15.2,A,/,1X,A,F15.2,A,A,F15.2,A)')
     &   '>>> PMat_SCF: CPU  time:',xCPM,' seconds ',
     &   ' (2-el contributions: ',tCF2,' seconds) <<<',
     &   '>>> PMat_SCF: Wall time:',xWPM,' seconds ',
     &   ' (2-el contributions: ',tWF2,' seconds) <<<'
         Call xFlush(6)
      End If

      End subroutine PMat_SCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakePab(cmo,occ,cout,nCMO,nMOs,nIrrep,nBas)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCMO, nMOs, nIrrep, nBas(0:7)
real(kind=wp), intent(in) :: cmo(nCMO), occ(nMOs)
real(kind=wp), intent(out) :: cout(nMOs)
integer(kind=iwp) :: i, id, id2, iIrr, j, nd, nd2

id = 0
id2 = 0
cout(:) = Zero
do iIrr=0,nIrrep-1
  nd = nBas(iIrr)
  nd2 = nd*nd
  do i=1,nd
    !if (occ(i+id) /= Zero) then
    do j=1,nd
      cout(i+id) = cout(i+id)+occ(i+id)*(cmo(j+i*(nd-1)+id2)**2)
    end do
  end do
  id = id+nd
  id2 = id2+nd2
end do

return

end subroutine MakePab

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Markus P. Fuelscher                              *
*               1991, Per Ake Malmqvist                                *
************************************************************************
      Subroutine MkOrd(iDisk)
*
************************************************************************
*                                                                      *
*    Purpose: Create the table of content of the OrdInt file           *
*                                                                      *
*    Called from: Sort0 ans Sort3                                      *
*                                                                      *
*    Calls to : DaFile                                                 *
*                                                                      *
*    Calling parameters:                                               *
*    iDisk  : First free entry on disk after table of contents         *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    TwoDat  : table of contents and auxiliary information             *
*              on the ordered 2el file                                 *
*    TowID   : Table of file identifiers                               *
*    TwoDef  : definitions of the record structure                     *
*    Srt0    : common block containing information pertinent to        *
*              the calculation of 2el integral sequence numbers        *
*    Srt1    : common block containing information the number of       *
*              bins and partitioning of symmetry blocks                *
*    Srt2    : common block containing information pertinent to        *
*              the bin sorting algorithm                               *
*    PkCtl   : packing table                                           *
*                                                                      *
*    Local data declarations: none                                     *
*                                                                      *
**** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****
*
      use srt2
      use Integral_Parameters, only: iPack
      Implicit Integer (A-Z)
*

#include "FileIDs.fh"
#include "TwoDat.fh"
#include "srt0.fh"
#include "srt1.fh"
#include "PkCtl.fh"
*
*---------------------------------------------------------------------*
*     Initialize table of content                                     *
*---------------------------------------------------------------------*
*
      Do iToc=1,lTocTwo
         TocTwo(iToc)=iNoNum
      End Do
*
*---------------------------------------------------------------------*
*     Write file identifier                                           *
*---------------------------------------------------------------------*
*
      TocTwo(isId)=IDtwo
      TocTwo(isVer)=VNtwo
      TocTwo(isForm)=0
*
*---------------------------------------------------------------------*
*     Write ordring mode                                              *
*---------------------------------------------------------------------*
*
      TocTwo(isOrd)=0
*
*---------------------------------------------------------------------*
*     Write symmetry and basis set information                        *
*---------------------------------------------------------------------*
*
      TocTwo(isSym)=nSyOp
      Do iSymi=0,nSyOp-1
        TocTwo(isSkip+iSymi)=nSkip(iSymi+1)
      End Do
      nPairs=nSyOp*(nSyOp+1)/2
      iBatch=0
      Do iSymi=1,nSyOp
        Do jSymj=1,iSymi
          Do kSymk=1,nSyOp
            Do lSyml=1,kSymk
              If ( ieor(iSymi-1,jSymj-1).eq.ieor(kSymk-1,lSyml-1) ) then
                ijPair=jSymj+iSymi*(iSymi-1)/2
                klPair=lSyml+kSymk*(kSymk-1)/2
                iSyBlk=(ijPair-1)*nPairs+klPair
                iBatch=iBatch+1
                nBatch(iSyBlk)=iBatch
              End If
            End Do
          End Do
        End Do
      End Do
*
*---------------------------------------------------------------------*
*     Write the skip parameters                                       *
*---------------------------------------------------------------------*
*
      TocTwo(isSym)=nSyOP
      Do iSymi=0,nSyOp-1
        TocTwo(isBas+iSymi)=nBs(iSymi+1)
      End Do
*
*---------------------------------------------------------------------*
*     Write disk access table                                         *
*---------------------------------------------------------------------*
*
      Do iBatch=0,175
         TocTwo(isDAdr+iBatch)=0
      End Do
*
      iBin=1
      Do iSymi=1,nSyOp
         iFlit=nSkip(iSymi)
         Do jSymj=1,iSymi
            jFlit=nSkip(jSymj)
            iSymj=1+ieor(iSymi-1,jSymj-1)
            iSyblj=jSymj+iSymi*(iSymi-1)/2
            kSymMx=iSymi
            If ( Square ) kSymMx=nSyOp
            Do kSymk=1,kSymMx
               kFlit=nSkip(kSymk)
               lSymMx=jSymj
               If( kSymk.ne.iSymi .or. Square ) lSymMx=kSymk
               Do lSyml=1,lSymMx
                  lFlit=nSkip(lSyml)
                  kSyml=1+ieor(kSymk-1,lSyml-1)
*
                  kSybll=lSyml+kSymk*(kSymk-1)/2
                  If ( ieor(iSymj-1,kSyml-1).eq.0 ) then
                     If ( (iFlit+jFlit+kFlit+lFlit).eq.0 ) then
                        iSyBlk=kSybll+mxSyP*(iSyblj-1)
                        iBatch=nBatch(iSyBlk)
                        TocTwo(isDAdr+iBatch-1)=iDVBin(2,iBin)
                        iBin=iBin+nSln(iSyBlk)
                     End If
                  End If
               End Do
            End Do
         End Do
      End Do
*
      TocTwo(isMxDa)=mDaTwo
*
*---------------------------------------------------------------------*
*     Write packing information                                       *
*---------------------------------------------------------------------*
*
      Call Real2Int(PkThrs,TocTwo(isPkTh))
      Call Real2Int(PkCutof,TocTwo(isPkCt))
      Call Real2Int(PkScal,TocTwo(isPkSc))
      iPack=1
      If ( Pack ) iPack=0
      TocTwo(isPkPa)=iPack
      iAssm=1
      If ( Assm ) iAssm=0
      TocTwo(isPkAs)=iAssm
      Do iExp=0,4095
        TocTwo(isPkTb+iExp)=PkTab(iExp)
      End Do
*
*---------------------------------------------------------------------*
*     Transfer table of content to disk                               *
*---------------------------------------------------------------------*
*
      iDisk=0
      iOpt=1
      LuTwo=AuxTwo(isUnit)
      Call iDAFILE(LuTwo,iOpt,TocTwo,lTocTwo,iDisk)
      AuxTwo(isDaDa)=iDisk
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrePro(nAtom,Coor)

use Slapaf_Info, only: Atom, Grd, iInt, iRow, iter, lNmHss, lOld, lOld_Implicit, mRowH, mTROld, nDimBC, nFix, nSup, Redundant
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtom
real(kind=wp), intent(in) :: Coor(3,nAtom)
integer(kind=iwp) :: mTR, nQQ, nRowH
logical(kind=iwp) :: CofM
real(kind=wp), allocatable :: TR(:)

CofM = (Iter == 1) .and. lNmHss
call mma_allocate(TR,18*nAtom,Label='TR')
TR(:) = Zero
call TRPGen(nDimBC,nAtom,Coor,mTR,CofM,TR)
call mma_deallocate(TR)
if (lNmHss) then
  if (Iter == 1) mTROld = mTR
  if ((iter <= 2*(nDimBC-mTROld)+1) .and. (iter /= 1)) mTR = mTROld
else
  mTROld = mTR
end if

! Operate according to two modes
! iRow > 0 : user supplied internal coordinates
! iRow <= 0 : Cartesian or Internal Coordinates

nRowH = 0
if (iRow > 0) then

  ! Find the number of active and frozen internal coordinates.

  call Rd_UDIC(iInt,nFix,nRowH)
  nQQ = iInt+nFix
  if (nRowH > 0) then
    call mma_allocate(mRowH,nRowH,Label='mRowH')
    call Rd_UDIC_RowH(nQQ,nRowH,mRowH)
  end if
  if (nQQ > nDimBC-mTR) Redundant = .true.

else

  nFix = 0
end if

! Initiate the force constant matrix in internal coordinate
! basis, excluding rotation and translation.
! Write to runfile only on the first iteration and that there
! was not an already defined Hessian.

if (iter == 1) call IntFcm(lOld_Implicit)
if ((.not. lOld) .and. lOld_Implicit) lOld = .true.

! Symmetrize forces

if (allocated(nSup)) then
  call SupSym(Grd,nAtom,Coor,size(nSup),nSup,Atom)
  call mma_deallocate(Atom)
  call mma_deallocate(nSup)
end if

return

end subroutine PrePro

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine intermezzo (wrk,wrksize,
     & lunw3aaaa,lunw3bbbb,lunw3abba,
     & lunw3baab,lunw3aabb,lunw3bbaa,lunt2o1,lunt2o2,lunt2o3,
     & lunabij1,lunabij2,lunabij3)
c
c     this routine calculate contributions
c     WIII3, WIII4 and T26
c
c     assigment of spin combinations:
c
c     WIII(m,e,b,j)aaaa  - I
c     WIII(m,e,b,j)bbbb  - K
c     WIII(m,e,b,j)aabb  - L
c     WIII(m,e,b,j)abba  - M
c     WIII(m,e,b,j)baab  - N
c     WIII(m,e,b,j)bbaa  - J
c
c     WIII3
c     WIII(m,e,b,j)aaaa <- sum(n-a) [ <mn||je>aaaa . T1o(n,b)aa ]
c     WIII(m,e,b,j)bbbb <- sum(n-b) [ <mn||je>bbbb . T1o(n,b)bb ]
c     WIII(m,e,b,j)aabb <- sum(n-b) [ <mn||je>abba . T1o(n,b)bb ]
c     WIII(m,e,b,j)abba <- sum(n-b) [ <mn||je>abab . T1o(n,b)bb ]
c     WIII(m,e,b,j)baab <- -sum(n-a) [ <nm||je>abba . T1o(n,b)aa ]
c     WIII(m,e,b,j)bbaa <- -sum(n-a) [ <je||nm>abab . T1o(n,b)aa ]
c
c     WIII4
c     Q(f,b,j,n)aaaa   <= 0.5 T2o(f,b,j,n)aaaa + T1o(f,j)aa . T1o(b,n)aa
c     WIII(m,e,b,j)aaaa <- -sum(n,f-aa)     [ Q(f,b,j,n)aaaa   . <ef||mn>aaaa ]
c     <- 0.5 sum(n,f-bb)  [ T2o(b,f,j,n)abab . <ef||mn>abab ]
c     WIII(m,e,b,j)aabb <- 0.5 sum(n,f-aa)  [ T2o(f,b,n,j)abab . <ef||mn>aaaa ]
c     <- -sum(n,f-bb)     [ Q(f,b,j,n)bbbb   . <ef||mn>abab ]
c     Q(f,b,j,n)bbbb   <= 0.5 T2o(f,b,j,n)bbbb + T1o(f,j)nn . T1o(b,n)bb
c     WIII(m,e,b,j)bbbb <- -sum(n,f-bb)     [ Q(f,b,j,n)bbbb   . <ef||mn>bbbb ]
c     <- 0.5 sum(n,f-aa)  [ T2o(f,b,n,j)abab . <fe||nm>abab ]
c     WIII(m,e,b,j)bbaa <- 0.5 sum(n,f-bb)  [ T2o(b,f,j,n)abab . <ef||mn>bbbb ]
c     <- - sum(n,f-aa)    [ Q(f,b,j,n)aaaa   . <fe||nm>abab ]
c     Q(f,b,j,n)abab   <= 0.5 T2o(f,b,j,n)abab + T1o(f,j)aa . T1o(b,n)bb
c     WIII(m,e,b,j)abba <- sum(n,f-ba)      [ Q(f,b,j,n)abab   . <fe||mn>abab ]
c     Q(b,f,n,j)abab   <= 0.5 T2o(b,f,n,j)abab + T1o(b,n)aa . T1o(fmj)bb
c     WIII(m,e,b,j)baab <- sum(n,f-ab)      [ Q(b,f,n,j)abab   . <ef||nm>abab ]
c
c
c     T26
c     R1(a,i,b,j)aaaa <= sum(m,e-aa) [ T2o(a,e,i,m)aaaa . WIII(m,e,b,j)aaaa ]
c     <- sum(m,e-bb) [ T2o(a,e,i,m)abab . WIII(m,e,b,j)bbaa ]
c     T2n(ab,ij)aaaa   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}aaaa
c     R1(a,i,b,j)bbbb <= sum(m,e-bb) [ T2o(a,e,i,m)bbbb . WIII(m,e,b,j)bbbb ]
c     <- sum(m,e-aa) [ T2o(e,a,m,i)abab . WIII(m,e,b,j)aabb ]
c     T2n(ab,ij)bbbb   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}bbbb
c     T2n(a,b,i,j)abab <- sum(m,e-aa) [ T2o(a,e,i,m)aaaa . WIII(m,e,b,j)aabb ]
c     <- sum(m,e-aa) [ T2o(e,b,m,j)abab . WIII(m,e,a,i)aaaa ]
c     <- sum(m,e-bb) [ T2o(a,e,i,m)abab . WIII(m,e,b,j)bbbb ]
c     <- sum(m,e-bb) [ T2o(b,e,j,m)bbbb . WIII(m,e,a,i)bbaa ]
c     <- sum(m,e-ab) [ T2o(a,e,m,j)abab . WIII(m,e,b,i)abba ]
c     <- sum(m,e-ab) [ T2o(e,b,i,m)abab . WIII(m,e,a,j)baab ]
c
c     N.B. use and destry : V1,V2,V3,V4,M1,M2
c     N.B. # of read      : 30 + 6
c     # of write     : 2
c
        use Para_Info, only: MyRank
        implicit none
#include "ccsd2.fh"
#include "wrk.fh"
#include "parallel.fh"
c
       integer lunw3aaaa,lunw3bbbb,lunw3abba,lunw3baab,lunw3aabb,
     & lunw3bbaa
       integer lunt2o1,lunt2o2,lunt2o3,lunabij1,lunabij2,lunabij3
c
c     help variableas
c
       integer posst,rc,ssc,lunqaaaa,lunqbbbb
c
c
cA.1  rewind nw3 files
cpar
        if (myRank.eq.idaaaa) then
       call filemanager (2,lunw3aaaa,rc)
        end if
c
        if (myRank.eq.idbaab) then
       call filemanager (2,lunw3baab,rc)
        end if
c
        if (myRank.eq.idbbaa) then
       call filemanager (2,lunw3bbaa,rc)
        end if
c
        if (myRank.eq.idbbbb) then
       call filemanager (2,lunw3bbbb,rc)
        end if
c
        if (myRank.eq.idabba) then
       call filemanager (2,lunw3abba,rc)
        end if
c
        if (myRank.eq.idaabb) then
       call filemanager (2,lunw3aabb,rc)
        end if
c
c0.1  map M1(i,a) <- T1o(a,i)aa
       call map (wrk,wrksize,
     & 2,2,1,0,0,mapdt11,mapit11,1,mapdm1,mapim1,possm10,
     &           posst,rc)
c0.2  map M2(i,a) <- T1o(a,i)bb
       call map (wrk,wrksize,
     & 2,2,1,0,0,mapdt12,mapit12,1,mapdm2,mapim2,possm20,
     &           posst,rc)
c
c
c     part I - W3aaaa
cpar  all contributions are calculated for idaaaa only,
c     just Qaaaa is calculated both on idaaaa and idbbaa
c
c     par
      if (idaaaa.eq.myRank) then
c
cI.1  get V1(m,e,a,j) <- W3aaaa(m,e,a,j)
       call getw3 (wrk,wrksize,
     & lunw3aaaa,1)
c
cI.2  WIII(m,e,b,j)aaaa <- sum(n-a) [ <mn||je>aaaa . T1o(n,b)aa ]
c
cI.2.1expand V2(j,e,m,n) <- <je||mn>aaaa
       call expand (wrk,wrksize,
     & 4,3,mapdw11,mapiw11,1,possv20,mapdv2,mapiv2,rc)
cI.2.2map V3(m,e,j,n) <- V2(j,e,m,n)
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.2.3mult V2(m,e,j,b) <- V3(m,e,j,n) . M1(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm1,mapim1,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cI.2.4map V3(m,e,b,j) <- V2(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.2.5add V1(m,e,b,j) <- 1.0d0 . V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
cparend
        end if
c
cI.3  WIII4
c     Q(f,b,j,n)aaaa   <= 0.5 T2o(f,b,j,n)aaaa + T1o(f,j)aa . T1o(b,n)aa
c     WIII(m,e,b,j)aaaa <- -sum(n,f-aa)     [ Q(f,b,j,n)aaaa   . <ef||mn>aaaa ]
c     <- 0.5 sum(n,f-bb)  [ T2o(b,f,j,n)abab . <ef||mn>abab ]
c
cpar
        if ((myRank.eq.idaaaa).or.(myRank.eq.idbbaa)) then
cI.3.1get V3(fb,jn) <- T2o(fb,jn)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv30,mapdv3,mapiv3,rc)
cI.3.2expand V2(f,b,j,n) <- V3(fb,jn)
       call expand (wrk,wrksize,
     & 4,4,mapdv3,mapiv3,1,possv20,mapdv2,mapiv2,rc)
cI.3.3mkQ V2(f,b,j,n) <- 0.5 V2(f,b,j,n) + T1o(f,j)aa . T1o(b,n)aa
       call mkq(wrk,wrksize,
     & mapdv2,mapiv2,mapdt11,mapit11,mapdt11,mapit11,0.5d0,rc)
cI.3.4map V3(f,n,b,j) <- V2(f,b,j,n)
       call map (wrk,wrksize,
     & 4,1,3,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cparend
        end if
cpar
        if (myRank.eq.idbbaa) then
cI.3.5write V3(f,n,b,j) to lunqaaaa
       call filemanager (1,lunqaaaa,rc)
       call wrtmediate (wrk,wrksize,
     & lunqaaaa,mapdv3,mapiv3,rc)
        end if
c
cpar
        if (myRank.eq.idaaaa) then
cI.3.6get V2(ef,mn) = <ef||mn>aaaa from luna file
       call filemanager (2,lunabij1,rc)
       call getmediate (wrk,wrksize,
     & lunabij1,possv20,mapdv2,mapiv2,rc)
cI.3.7expand V4(e,f,m,n) <- V2(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv40,mapdv4,mapiv4,rc)
cI.3.8map V2(m,e,f,n) <- V4(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cI.3.9mult V4(m,e,b,j) <- V2(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cI.3.10 add V1(m,e,b,j) <- -1.0d0 . V4(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv4,1,mapdv1,mapiv1,1,rc)
cI.3.11 get V2(e,f,m,n) <- <ef||mn>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
cI.3.12 map V3(m,e,f,n) <- V2(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.3.13 get V2(b,f,j,n) <- T2o(b,f,j,n)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cI.3.14 map V4(f,n,b,j) <- V2(b,f,j,n)
       call map (wrk,wrksize,
     & 4,3,1,4,2,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cI.3.15 mult V2(m,e,b,j) <- V3(m,e,f,n) . V4(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv3,mapiv3,1,mapdv4,mapiv4,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cI.3.16 add V1(m,e,b,j) <- 0.5d0 . V2(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,0.5d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
cI.4  R1(a,i,b,j)aaaa <= sum(m,e-aa) [ T2o(a,e,i,m)aaaa . WIII(m,e,b,j)aaaa ]
c     T2n(ab,ij)aaaa   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}aaaa
cI.4.1get V2(ae,im) <- T2o(ae,im)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv20,mapdv2,mapiv2,rc)
cI.4.2expand V3(a,e,i,m) <- V2(ae,im)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv30,mapdv3,mapiv3,rc)
cI.4.3map V2(a,i,m,e) <- V3(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cI.4.4mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cI.4.5map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.4.6pack V3(ab,ij) <- V2(ab,i,j) <- V3(a,b,i,j)
       call fack (wrk,wrksize,
     & 4,1,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
       call fack (wrk,wrksize,
     & 4,4,mapdv2,1,mapiv2,mapdv3,mapiv3,possv30,rc)
cI.4.7add T2n(ab,ij)aaaa <- 1.0d0 V3(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt21,mapit21,1,rc)
c
cI.5  T2n(a,b,i,j)abab <- sum(m,e-aa) [ T2o(e,b,m,j)abab . WIII(m,e,a,i)aaaa ]
cI.5.1get V4(e,b,m,j) <- T2o(e,b,m,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv40,mapdv4,mapiv4,rc)
cI.5.2map V2(b,j,m,e) <- V4(e,b,m,j)
       call map (wrk,wrksize,
     & 4,4,1,3,2,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cI.5.3mult V4(b,j,a,i) <- V2(b,j,m,e) . V1(m,e,a,i)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cI.5.4map V3(a,b,i,j) <- V4(b,j,a,i)
       call map (wrk,wrksize,
     & 4,2,4,1,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cI.5.5add T2n(a,b,i,j)abab <- 1.0d0 . V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     J part W3bbaa
c
c     par
      if (myRank.eq.idbbaa) then
c
cJ.1  get V1(m,e,a,j) <- W3bbaa(m,e,a,j)
       call getw3 (wrk,wrksize,
     & lunw3bbaa,6)
c
cJ.2  WIII(m,e,b,j)bbaa <- -sum(n-a) [ <je||nm>abab . T1o(n,b)aa ]
cJ.2.1map V3(m,e,j,n) <- <j,e||n,m>abab
       call map (wrk,wrksize,
     & 4,3,2,4,1,mapdw13,mapiw13,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
cJ.2.2mult V4(m,e,j,b) <- V3(m,e,j,n) . M1(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm1,mapim1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cJ.2.3map V3(m,e,b,j) <- V4(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cJ.2.4add V1(m,e,b,j) <- -1.0d0 V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
cJ.2  WIII(m,e,b,j)bbaa <- 0.5 sum(n,f-bb)  [ T2o(b,f,j,n)abab . <ef||mn>bbbb ]
c     <- - sum(n,f-aa)    [ Q(f,b,j,n)aaaa   . <fe||nm>abab ]
cJ.2.1get V2(f,n,b,j) from lunqaaaa (produced in I step) and close it
       call filemanager (2,lunqaaaa,rc)
       call getmediate (wrk,wrksize,
     & lunqaaaa,possv20,mapdv2,mapiv2,rc)
       call filemanager (3,lunqaaaa,rc)
cJ.2.2get V3(f,e,n,m) <- <fe||nm>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv30,mapdv3,mapiv3,rc)
cJ.2.3map V4(m,e,f,n) <- V3(f,e,n,m)
       call map (wrk,wrksize,
     & 4,3,2,4,1,mapdv3,mapiv3,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cJ.2.4mult V3(m,e,b,j) <- V4(m,e,f,n) . V2(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
cJ.2.5add V1(m,e,b,j) <- -1.0d0 . V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
cJ.2.6get V2(b,f,j,n) <- T2o(b,f,j,n)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cJ.2.7map V3(f,n,b,j) <- V2(b,f,j,n)
       call map (wrk,wrksize,
     & 4,3,1,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cJ.3.8get V2(ef,mn) = <ef||mn>bbbb from lunb file
       call filemanager (2,lunabij2,rc)
       call getmediate (wrk,wrksize,
     & lunabij2,possv20,mapdv2,mapiv2,rc)
cJ.3.9exp V4(e,f,m,n) <- V2(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv40,mapdv4,mapiv4,rc)
cJ.3.10        map V2(m,e,f,n) <- V4(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cJ.3.11 mult V4(m,e,b,j) <- V2(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cJ.3.12        add V1(m,e,b,j) <- 0.5d0 . V4(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,0.5d0,mapdv4,1,mapdv1,mapiv1,1,rc)
c
cJ.4  R1(a,i,b,j)aaaa <= sum(m,e-bb) [ T2o(a,e,i,m)abab . WIII(m,e,b,j)bbaa ]
c     T2n(ab,ij)aaaa   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}aaaa
cJ.4.1get V3(a,e,i,m) <- T2o(a,e,i,m)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv30,mapdv3,mapiv3,rc)
cJ.4.2map V2(a,i,m,e) <- V3(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cJ.4.3mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cJ.4.4map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cJ.4.5pack V3(ab,ij) <- V2(ab,i,j) <- V3(a,b,i,j)
       call fack (wrk,wrksize,
     & 4,1,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
       call fack (wrk,wrksize,
     & 4,4,mapdv2,1,mapiv2,mapdv3,mapiv3,possv30,rc)
cJ.4.6add T2n(ab,ij)aaaa <- 1.0d0 V2(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt21,mapit21,1,rc)
c
cJ.5  T2n(a,b,i,j)abab <- sum(m,e-aa) [ T2o(b,e,j,m)bbbb . WIII(m,e,a,i)bbaa ]
cJ.5.1get V4(be,jm) <- T2o(be,jm)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv40,mapdv4,mapiv4,rc)
cJ.5.2expand V3(b,e,j,m) <-  V4(be,jm)
       call expand (wrk,wrksize,
     & 4,4,mapdv4,mapiv4,1,possv30,mapdv3,mapiv3,rc)
cJ.5.2map V2(b,j,m,e) <- V3(b,e,j,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cJ.5.3mult V3(b,j,a,i) <- V2(b,j,m,e) . V1(m,e,a,i)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
cJ.5.4map V2(a,b,i,j) <- V3(b,j,a,i)
       call map (wrk,wrksize,
     & 4,2,4,1,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cJ.5.5add T2n(a,b,i,j)abab <- 1.0d0 . V2(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     part K - W3bbbb
cpar  all contributions are calculated for idbbbb only,
c     just Qbbbb is calculated both on idbbbb and idaabb
c
cpar
      if (myRank.eq.idbbbb) then
c
cK.1  get V1(m,e,a,j) <- W3bbbb(m,e,a,j)
       call getw3 (wrk,wrksize,
     & lunw3bbbb,2)
c
cK.2  WIII(m,e,b,j)bbbb <- sum(n-b) [ <mn||je>bbbb . T1o(n,b)bb ]
cK.2.1expand V2(j,e,m,n) <- <je||mn>bbbb
       call expand (wrk,wrksize,
     & 4,3,mapdw12,mapiw12,1,possv20,mapdv2,mapiv2,rc)
cK.2.2map V3(m,e,j,n) <- V2(j,e,m,n)
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.2.3mult V2(m,e,j,b) <- V3(m,e,j,n) . M2(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm2,mapim2,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cK.2.4map V3(m,e,b,j) <- V2(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.2.5add V1(m,e,b,j) <- 1.0d0 . V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
cparend
        end if
c
cK.3  WIII4
c     Q(f,b,j,n)bbbb   <= 0.5 T2o(f,b,j,n)bbbb + T1o(f,j)bb . T1o(b,n)bb
c     WIII(m,e,b,j)bbbb <- -sum(n,f-bb)     [ Q(f,b,j,n)bbbb   . <ef||mn>bbbb ]
c     <- 0.5 sum(n,f-aa)  [ T2o(f,b,n,j)abab . <fe||nm>abab ]
c
cpar
        if ((myRank.eq.idbbbb).or.(myRank.eq.idaabb)) then
cK.3.1get V3(fb,jn) <- T2o(fb,jn)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv30,mapdv3,mapiv3,rc)
cK.3.2expand V2(f,b,j,n) <- V3(fb,jn)
       call expand (wrk,wrksize,
     & 4,4,mapdv3,mapiv3,1,possv20,mapdv2,mapiv2,rc)
cK.3.3mkQ V2(f,b,j,n) <- 0.5 V2(f,b,j,n) + T1o(f,j)bb . T1o(b,n)bb
       call mkq(wrk,wrksize,
     & mapdv2,mapiv2,mapdt12,mapit12,mapdt12,mapit12,0.5d0,rc)
cK.3.4map V3(f,n,b,j) <- V2(f,b,j,n)
       call map (wrk,wrksize,
     & 4,1,3,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cparend
        end if
cpar
        if (myRank.eq.idaabb) then
cK.3.5write V3(f,n,b,j) to lunqbbbb
       call filemanager (1,lunqbbbb,rc)
       call wrtmediate (wrk,wrksize,
     & lunqbbbb,mapdv3,mapiv3,rc)
        end if
cpar
        if (myRank.eq.idbbbb) then
cK.3.6get V2(ef,mn) = <ef||mn>bbbb from luna file
       call filemanager (2,lunabij2,rc)
       call getmediate (wrk,wrksize,
     & lunabij2,possv20,mapdv2,mapiv2,rc)
cK.3.7expand V4(e,f,m,n) <- V2(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv40,mapdv4,mapiv4,rc)
cK.3.8map V2(m,e,f,n) <- V4(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cK.3.9mult V4(m,e,b,j) <- V2(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cK.3.10 add V1(m,e,b,j) <- -1.0d0 . V4(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv4,1,mapdv1,mapiv1,1,rc)
cK.3.11 get V2(f,e,n,m) <- <fe||nm>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
cK.3.12 map V3(m,e,f,n) <- V2(f,e,n,m)
       call map (wrk,wrksize,
     & 4,3,2,4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.3.13 get V2(f,b,n,j) <- T2o(f,b,n,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cK.3.14 map V4(f,n,b,j) <- V2(f,b,n,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cK.3.15 mult V2(m,e,b,j) <- V3(m,e,f,n) . V4(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv3,mapiv3,1,mapdv4,mapiv4,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cK.3.16 add V1(m,e,b,j) <- 0.5d0 . V2(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,0.5d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
cK.4  R1(a,i,b,j)bbbb <= sum(m,e-bb) [ T2o(a,e,i,m)bbbb . WIII(m,e,b,j)bbbb ]
c     T2n(ab,ij)bbbb   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}bbbb
cK.4.1get V2(ae,im) <- T2o(ae,im)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv20,mapdv2,mapiv2,rc)
cK.4.2expand V3(a,e,i,m) <- V2(ae,im)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv30,mapdv3,mapiv3,rc)
cK.4.3map V2(a,i,m,e) <- V3(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cK.4.4mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cK.4.5map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.4.6pack V3(ab,ij) <- V2(ab,i,j) <- V3(a,b,i,j)
       call fack (wrk,wrksize,
     & 4,1,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
       call fack (wrk,wrksize,
     & 4,4,mapdv2,1,mapiv2,mapdv3,mapiv3,possv30,rc)
cK.4.7add T2n(ab,ij)bbbb <- 1.0d0 V3(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt22,mapit22,1,rc)
c
c
cK.5  T2n(a,b,i,j)abab <- sum(m,e-bb) [ T2o(a,e,i,m)abab . WIII(m,e,b,j)bbbb ]
cK.5.1get V4(a,e,i,m) <- T2o(a,e,i,m)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv40,mapdv4,mapiv4,rc)
cK.5.2map V2(a,i,m,e) <- V4(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cK.5.3mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cK.5.4map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cK.5.5add T2n(a,b,i,j)abab <- 1.0d0 . V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     L part W3aabb
c
cpar
      if (myRank.eq.idaabb) then
c
cL.1  get V1(m,e,a,j) <- W3aabb(m,e,a,j)
       call getw3 (wrk,wrksize,
     & lunw3aabb,3)
c
cL.2  WIII(m,e,b,j)aabb <- sum(n-b) [ <mn||je>abba . T1o(n,b)bb ]
cL.2.1map V3(m,e,j,n) <- <j,e||m,n>baab
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdw14,mapiw14,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
cL.2.2mult V4(m,e,j,b) <- V3(m,e,j,n) . M2(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm2,mapim2,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cL.2.3map V3(m,e,b,j) <- V4(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cL.2.4add V1(m,e,b,j) <- 1.0d0 V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
cL.2  WIII(m,e,b,j)aabb <- 0.5 sum(n,f-aa)  [ T2o(f,b,n,j)abab . <ef||mn>aaaa ]
c     <- - sum(n,f-bb)    [ Q(f,b,j,n)bbbb   . <ef||mn>abab ]
cL.2.1get V2(f,n,b,j) from lunqbbbb (produced in K step) and close it
       call filemanager (2,lunqbbbb,rc)
       call getmediate (wrk,wrksize,
     & lunqbbbb,possv20,mapdv2,mapiv2,rc)
       call filemanager (3,lunqbbbb,rc)
cL.2.2get V3(e,f,m,n) <- <ef||mn>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv30,mapdv3,mapiv3,rc)
cL.2.3map V4(m,e,f,n) <- V3(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv3,mapiv3,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cL.2.4mult V3(m,e,b,j) <- V4(m,e,f,n) . V2(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
cL.2.5add V1(m,e,b,j) <- -1.0d0 . V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
cL.2.6get V2(f,b,n,j) <- T2o(f,b,n,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cL.2.7map V3(f,n,b,j) <- V2(f,b,n,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cL.3.8get V2(ef,mn) = <ef||mn>aaaa from lunb file
       call filemanager (2,lunabij1,rc)
       call getmediate (wrk,wrksize,
     & lunabij1,possv20,mapdv2,mapiv2,rc)
cL.3.9exp V4(e,f,m,n) <- V2(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv2,mapiv2,1,possv40,mapdv4,mapiv4,rc)
cL.3.10        map V2(m,e,f,n) <- V4(e,f,m,n)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cL.3.11 mult V4(m,e,b,j) <- V2(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv3,mapiv3,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cL.3.12        add V1(m,e,b,j) <- 0.5d0 . V4(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,0.5d0,mapdv4,1,mapdv1,mapiv1,1,rc)
c
cL.4  R1(a,i,b,j)bbbb <- sum(m,e-aa) [ T2o(e,a,m,i)abab . WIII(m,e,b,j)aabb ]
c     T2n(ab,ij)bbbb   <= {1(a,i,b,j)-R1(b,i,a,j)-R1(a,j,b,i)+R1(b,j,a,i)}bbbb
cL.4.1get V3(e,a,m,i) <- T2o(e,a,m,i)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv30,mapdv3,mapiv3,rc)
cL.4.2map V2(a,i,m,e) <- V3(e,a,m,i)
       call map (wrk,wrksize,
     & 4,4,1,3,2,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cL.4.3mult V4(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cL.4.4map V3(a,b,i,j) <- V4(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cL.4.5pack V3(ab,ij) <- V2(ab,i,j) <- V3(a,b,i,j)
       call fack (wrk,wrksize,
     & 4,1,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
       call fack (wrk,wrksize,
     & 4,4,mapdv2,1,mapiv2,mapdv3,mapiv3,possv30,rc)
cL.4.6add T2n(ab,ij)aaaa <- 1.0d0 V2(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt22,mapit22,1,rc)
c
cL.5  T2n(a,b,i,j)abab <- sum(m,e-aa) [ T2o(a,e,i,m)aaaa . WIII(m,e,b,j)aabb ]
cL.5.1get V4(ae,im) <- T2o(ae,im)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv40,mapdv4,mapiv4,rc)
cL.5.2expand V3(a,e,i,m) <-  V4(ae,im)
       call expand (wrk,wrksize,
     & 4,4,mapdv4,mapiv4,1,possv30,mapdv3,mapiv3,rc)
cL.5.2map V2(a,i,m,e) <- V3(a,e,i,m)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cL.5.3mult V3(a,i,b,j) <- V2(a,i,m,e) . V1(m,e,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
cL.5.4map V2(a,b,i,j) <- V3(a,i,b,j)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
cL.5.5add T2n(a,b,i,j)abab <- 1.0d0 . V2(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     M part W3abba
c
cpar
      if (myRank.eq.idabba) then
c
cM.1  get V1(m,e,a,j) <- W3abba
       call getw3 (wrk,wrksize,
     & lunw3abba,4)
c
cM.2  WIII(m,e,b,j)abba <- sum(n-b) [ <mn||je>abab . T1o(n,b)bb ]
cM.2.1map V3(m,e,j,n) <- <j,e||m,n>abab
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdw13,mapiw13,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
cM.2.2mult V4(m,e,j,b) <- V3(m,e,j,n) . M2(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm2,mapim2,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cM.2.3map V3(m,e,b,j) <- V4(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cM.2.4add V1(m,e,b,j) <- 1.0d0 V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
cM.3  Q(f,b,j,n)abab   <= 0.5 T2o(f,b,j,n)abab + T1o(f,j)aa . T1o(b,n)bb
c     WIII(m,e,b,j)abba <- sum(n,f-ba)      [ Q(f,b,j,n)abab   . <fe||mn>abab ]
cM.3.1get V4(f,b,j,n) <- T2o(f,b,j,n)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv40,mapdv4,mapiv4,rc)
cM.3.2mkQ V4(f,b,j,n) <- 0.5 V4(f,b,j,n) + T1o(f,j)aa . T1o(b,n)bb
       call mkq(wrk,wrksize,
     & mapdv4,mapiv4,mapdt11,mapit11,mapdt12,mapit12,0.5d0,rc)
cM.3.3map V3(f,n,b,j) <- V4(f,b,j,n)
       call map (wrk,wrksize,
     & 4,1,3,4,2,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cM.3.4get V2(f,e,m,n) <- <fe||mn>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
cM.3.5map V4(m,e,f,n) <- V2(f,e,m,n)
       call map (wrk,wrksize,
     & 4,3,2,1,4,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cM.3.6mult V2(m,e,b,j) <- V4(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv3,mapiv3,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cM.3.7add V1(m,e,b,j) <- 1.0d0 V2(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
cM.4  T2n(a,b,i,j)abab <- sum(m,e-ab) [ T2o(a,e,m,j)abab . WIII(m,e,b,i)abba ]
cM.4.1get V2(a,e,m,j) <- T2o(a,e,m,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cM.4.2map V3(a,j,m,e) <- V2(a,e,m,j)
       call map (wrk,wrksize,
     & 4,1,4,3,2,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cM.4.3mult V4(a,j,b,i) <- V3(a,j,m,e) . V1(m,e,b,i)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv3,mapiv3,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cM.4.4map V3(a,b,i,j) <- V4(a,j,b,i)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cM.4.5add T2n(a,b,i,j)abab <- 1.0d0 V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
c
c     N part W3baab
c
cpar
      if (myRank.eq.idbaab) then
c
cN.1  get V1(m,e,a,j) <- W3baab
       call getw3 (wrk,wrksize,
     & lunw3baab,5)
c
cN.2  WIII(m,e,b,j)baab <- - sum(n-a) [ <je||nm>baab . T1o(n,b)aa ]
cN.2.1map V3(m,e,j,n) <- <j,e||n,m>baab
       call map (wrk,wrksize,
     & 4,3,2,4,1,mapdw14,mapiw14,1,mapdv3,mapiv3,possv30,
     &           posst,rc)
cN.2.2mult V4(m,e,j,b) <- V3(m,e,j,n) . M1(n,b)
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv3,mapiv3,1,mapdm1,mapim1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cN.2.3map V3(m,e,b,j) <- V4(m,e,j,b)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cN.2.4add V1(m,e,b,j) <- -1.0d0 V3(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
cN.3  Q(b,f,n,j)abab   <= 0.5 T2o(b,f,n,j)abab + T1o(b,n)aa . T1o(f,j)bb
c     WIII(m,e,b,j)baab <- sum(n,f-ab)      [ Q(b,f,n,j)abab   . <ef||nm>abab ]
cN.3.1get V4(b,f,n,j) <- T2o(b,f,n,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv40,mapdv4,mapiv4,rc)
cN.3.2mkQ V4(b,f,n,j) <- 0.5 V4(b,f,n,j) + T1o(b,n)aa . T1o(f,j)bb
       call mkq(wrk,wrksize,
     & mapdv4,mapiv4,mapdt11,mapit11,mapdt12,mapit12,0.5d0,rc)
cN.3.3map V3(f,n,b,j) <- V4(b,f,n,j)
       call map (wrk,wrksize,
     & 4,3,1,2,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cN.3.4get V2(e,f,n,m) <- <ef||nm>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
cN.3.5map V4(m,e,f,n) <- V2(e,f,n,m)
       call map (wrk,wrksize,
     & 4,2,3,4,1,mapdv2,mapiv2,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
cN.3.6mult V2(m,e,b,j) <- V4(m,e,f,n) . V3(f,n,b,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv3,mapiv3,1,mapdv2,mapiv2,
     &            ssc,possv20,rc)
cN.3.7add V1(m,e,b,j) <- 1.0d0 V2(m,e,b,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
cN.4  T2n(a,b,i,j)abab <- sum(m,e-ab) [ T2o(e,b,i,m)abab . WIII(m,e,a,j)baab ]
cN.4.1get V2(e,b,i,m) <- T2o(e,b,i,m)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
cN.4.2map V3(b,i,m,e) <- V2(e,b,i,m)
       call map (wrk,wrksize,
     & 4,4,1,2,3,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cN.4.3mult V4(b,i,a,j) <- V3(b,i,m,e) . V1(m,e,a,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv3,mapiv3,1,mapdv1,mapiv1,1,mapdv4,mapiv4,
     &            ssc,possv40,rc)
cN.4.4map V3(a,b,i,j) <- V4(b,i,a,j)
       call map (wrk,wrksize,
     & 4,2,3,1,4,mapdv4,mapiv4,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
cN.4.5add T2n(a,b,i,j)abab <- 1.0d0 V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
cparend
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ZBASE(NVEC,IVEC,NCLASS)
*
*  Some class division exists with NVEC(ICLASS) members in
*  class ICLASS.
*
*  Construct array IVEC(ICLASS) giving first element of
*  class ICLASS in full adressing
*
      IMPLICIT REAL*8          (A-H,O-Z)
      DIMENSION NVEC(*),IVEC(*)
*
       DO ICLASS = 1,NCLASS
          If (ICLASS.EQ.1) Then
             IVEC(1) = 1
          Else
             IVEC(ICLASS) = IVEC(ICLASS-1)+NVEC(ICLASS-1)
          End If
       End Do
*
      NTEST = 0
      IF( NTEST .NE. 0 ) THEN
        WRITE(6,'(A)') '  ZBASE : NVEC and IVEC '
        WRITE(6,'(A)') '  ===================== '
        CALL IWRTMA(NVEC,1,NCLASS,1,NCLASS)
        CALL IWRTMA(IVEC,1,NCLASS,1,NCLASS)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Ignacio Fdez. Galvan                             *
!***********************************************************************
! Print_Mode_Components
!
!> @brief
!> Print the contributions from the primitive internal coordinates to the
!> vibrational modes.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Compute and print the contributions from the primitive internal coordinates
!> (stretches, angles, dihedrals, out-of-planes) to the vibrational modes
!>
!> @param[in] Modes Vibrational modes, as computed by e.g. ::freqanal
!> @param[in] Freq Vibrational frequencies
!> @param[in] nModes Number of modes
!> @param[in] lModes Size of \p Modes
!> @param[in] lDisp Number of displacements per irrep
!***********************************************************************

subroutine Print_Mode_Components(Modes,Freq,nModes,lModes,lDisp)

use Symmetry_Info, only: nIrrep, VarR, VarT
use Slapaf_Info, only: Analytic_Hessian, ANr, ApproxNADC, AtomLbl, Baker, Beta, Beta_Disp, BM, BMx, BSet, CallLast, CnstWght, &
                       Coor, Cubic, Curvilinear, Cx, dBM, ddV_Schlegel, Degen, Delta, DipM, dMass, dMEPStep, dqInt, EDiffZero, &
                       eMEPTest, Energy, Energy0, FindTS, GNrm, GNrm_Threshold, Grd, Gx, Gx0, Header, HrmFrq_Show, HSet, HUpMet, &
                       HWRS, iBM, iCoSet, idBM, iInt, iOptC, iOptH, IRC, iRef, iRow, iRow_c, isFalcon, iState, iter, jStab, &
                       Lambda, Lbl, lCtoF, lDoubleIso, Line_Search, lNmHss, lOld, lOld_Implicit, lSoft, lTherm, Max_Center, &
                       MaxItr, mB_Tot, mdB_Tot, MEP, MEP_Algo, MEP_Type, MEPCons, MEPNum, MF, Mode, mq, mRowH, mTROld, mTtAtm, &
                       MxItr, NAC, NADC, nBVec, nDimBC, nFix, nLambda, nMEP, NmIter, nqBM, nsRot, nStab, Numerical, nUserPT, &
                       nWndw, PrQ, Q_nuclear, qInt, Redundant, RefGeo, Request_Alaska, Request_RASSI, rFuzz, rHidden, rMEP, &
                       RootMap, RtRnc, Shift, SlStop, Smmtrc, ThrCons, ThrEne, ThrGrd, ThrMEP, Track, TSConstraints, TwoRunFiles, &
                       UpMeth, User_Def, UserP, UserT, WeightedConstraints, Weights
use Molcas, only: LenIn, MxAtom
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Modes(*), Freq(*)
integer(kind=iwp), intent(in) :: nModes, lModes, lDisp(nIrrep)
integer(kind=iwp) :: Bk_iInt, Bk_iOptC, Bk_iOptH, Bk_IRC, Bk_iRef, Bk_iRow, Bk_iRow_c, Bk_iState(2), Bk_iter, Bk_Max_Center, &
                     Bk_mB_Tot, Bk_mdB_Tot, Bk_MEPnum, Bk_mode, Bk_mq, Bk_mTROld, Bk_mTtAtm, Bk_MxItr, Bk_nBVec, Bk_nDimBC, &
                     Bk_nFix, Bk_nLambda, Bk_nMEP, Bk_NmIter, Bk_nsRot, Bk_nUserPT, Bk_nWndw, i, iB, iErr, ii, im, iq, j, LuIC, &
                     LuInput, nAll_Atoms, nB, nK, nQQ, nsAtom, nUnique_Atoms, nX, PLback
real(kind=wp) :: Bk_Beta, Bk_Beta_Disp, Bk_CnstWght, Bk_Delta, Bk_dMEPStep, Bk_GNrm_Threshold, Bk_rFuzz, Bk_rHidden, Bk_Rtrnc, &
                 Bk_ThrCons, Bk_ThrEne, Bk_ThrGrd, Bk_ThrMEP, Bk_UserP, Bk_UserT(64), Mx, MinComp, rDum(1)
logical(kind=iwp) :: Bk_Analytic_Hessian, Bk_ApproxNADC, Bk_Baker, Bk_BSet, Bk_CallLast, Bk_Cubic, Bk_CurviLinear, &
                     Bk_DDV_Schlegel, Bk_EDiffZero, Bk_eMEPtest, Bk_FindTS, Bk_HrmFrq_Show, Bk_HSet, Bk_HWRS, Bk_isFalcon, &
                     Bk_lCtoF, Bk_lDoubleIso, Bk_Line_Search, Bk_lNmHss, Bk_lOld, Bk_lOld_Implicit, Bk_lSoft, Bk_lTherm, Bk_MEP, &
                     Bk_MEPCons, Bk_NADC, Bk_Numerical, Bk_Redundant, Bk_Request_Alaska, Bk_Request_RASSI, Bk_rMEP, Bk_SlStop, &
                     Bk_Track, Bk_TSConstraints, Bk_TwoRunFiles, Bk_User_Def, Bk_VarR, Bk_VarT, Bk_WeightedConstraints, Found
character(len=180) :: Line
character(len=16) :: StdIn
character(len=10) :: Bk_MEP_Type
character(len=8) :: Filename
character(len=6) :: Bk_HUpMet, Bk_UpMeth
character(len=2) :: Bk_MEP_Algo
character :: Bk_Header(144)
integer(kind=iwp), allocatable :: Bk_ANr(:), Bk_iBM(:), Bk_iCoSet(:,:), Bk_idBM(:), Bk_jStab(:,:), Bk_mRowH(:), Bk_nqBM(:), &
                                  Bk_nStab(:), Bk_RootMap(:), Sort(:)
real(kind=wp), allocatable :: Bk_BM(:), Bk_BMx(:,:), Bk_Coor(:,:), Bk_Cx(:,:,:), Bk_dBM(:), Bk_Degen(:,:), Bk_DipM(:,:), &
                              Bk_dMass(:), Bk_dqInt(:,:), Bk_Energy(:), Bk_Energy0(:), Bk_GNrm(:), Bk_Grd(:,:), Bk_Gx(:,:,:), &
                              Bk_Gx0(:,:,:), Bk_Lambda(:,:), Bk_MF(:,:), Bk_NAC(:,:,:), Bk_Q_nuclear(:), Bk_qInt(:,:), &
                              Bk_RefGeo(:,:), Bk_Shift(:,:), Bk_Weights(:), IntMod(:,:), KKtB(:,:), KMtrx(:,:), KTrsp(:,:), &
                              NMod(:,:)
logical(kind=iwp), allocatable :: Bk_Smmtrc(:,:)
character(len=LenIn), allocatable :: Bk_AtomLbl(:)
character(len=24), allocatable :: Label(:)
character(len=8), allocatable :: Bk_Lbl(:)
integer(kind=iwp), parameter :: nLbl = 10*MxAtom
integer(kind=iwp), external :: AixRm, iPrintLevel, IsFreeUnit
real(kind=wp), external :: DDot_
character(len=180), external :: Get_Ln_EOF

! Ugly hack: backup all "global" slapaf variables in case this is
!            called from inside slapaf

! Note, this routine might be called from outside the Slapaf
! environment. In which case there is no backup to be made.

if (allocated(Cx)) then
  nsAtom = size(Cx,2)
  call mma_allocate(Bk_Cx,3,nsAtom,MaxItr+1,Label='Bk_Cx')
  Bk_Cx(:,:,:) = Cx(:,:,:)
  call mma_deallocate(Cx)
  if (allocated(Gx)) then
    call mma_allocate(Bk_Gx,3,nsAtom,MaxItr+1,Label='Bk_Gx')
    Bk_Gx(:,:,:) = Gx(:,:,:)
    call mma_deallocate(Gx)
  end if
  if (allocated(Gx0)) then
    call mma_allocate(Bk_Gx0,3,nsAtom,MaxItr+1,Label='Bk_Gx0')
    Bk_Gx0(:,:,:) = Gx0(:,:,:)
    call mma_deallocate(Gx0)
  end if
  if (allocated(NAC)) then
    call mma_allocate(Bk_NAC,3,nsAtom,MaxItr+1,Label='Bk_NAC')
    Bk_NAC(:,:,:) = NAC(:,:,:)
    call mma_deallocate(NAC)
  end if
  if (allocated(Q_nuclear)) then
    call mma_allocate(Bk_Q_nuclear,nsAtom,Label='Bk_Q_nuclear')
    Bk_Q_nuclear(:) = Q_nuclear(:)
    call mma_deallocate(Q_nuclear)
  end if
  if (allocated(dMass)) then
    call mma_allocate(Bk_dMass,nsAtom,Label='Bk_dMass')
    Bk_dMass(:) = dMass(:)
    call mma_deallocate(dMass)
  end if
  if (allocated(Coor)) then
    call mma_allocate(Bk_Coor,3,nsAtom,Label='Bk_Coor')
    Bk_Coor(:,:) = Coor(:,:)
    call mma_deallocate(Coor)
  end if
  if (allocated(Grd)) then
    call mma_allocate(Bk_Grd,3,nsAtom,Label='Bk_Grd')
    Bk_Grd(:,:) = Grd(:,:)
    call mma_deallocate(Grd)
  end if
  if (allocated(ANr)) then
    call mma_allocate(Bk_ANr,nsAtom,Label='Bk_ANr')
    Bk_ANr(:) = ANr(:)
    call mma_deallocate(ANr)
  end if
  if (allocated(Weights)) then
    call mma_allocate(Bk_Weights,size(Weights),Label='Bk_Weights')
    Bk_Weights(:) = Weights(:)
    call mma_deallocate(Weights)
  end if
  if (allocated(Shift)) then
    call mma_allocate(Bk_Shift,size(Shift,1),MaxItr,Label='Bk_Shift')
    Bk_Shift(:,:) = Shift(:,:)
    call mma_deallocate(Shift)
  end if
  if (allocated(GNrm)) then
    call mma_allocate(Bk_GNrm,MaxItr+1,Label='Bk_GNrm')
    Bk_GNrm(:) = GNrm(:)
    call mma_deallocate(GNrm)
  end if
  if (allocated(Lambda)) then
    call mma_allocate(Bk_Lambda,size(Lambda,1),MaxItr+1,Label='Bk_Lambda')
    Bk_Lambda(:,:) = Lambda(:,:)
    call mma_deallocate(Lambda)
  end if
  if (allocated(Energy)) then
    call mma_allocate(Bk_Energy,MaxItr+1,Label='Bk_Energy')
    Bk_Energy(:) = Energy(:)
    call mma_deallocate(Energy)
  end if
  if (allocated(Energy0)) then
    call mma_allocate(Bk_Energy0,MaxItr+1,Label='Bk_Energy0')
    Bk_Energy0(:) = Energy0(:)
    call mma_deallocate(Energy0)
  end if
  if (allocated(MF)) then
    call mma_allocate(Bk_MF,3,nsAtom,Label='Bk_MF')
    Bk_MF(:,:) = MF(:,:)
    call mma_deallocate(MF)
  end if
  if (allocated(DipM)) then
    call mma_allocate(Bk_DipM,3,MaxItr+1,Label='Bk_DipM')
    Bk_DipM(:,:) = DipM(:,:)
    call mma_deallocate(DipM)
  end if
  if (allocated(qInt)) then
    call mma_allocate(Bk_qInt,size(qInt,1),MaxItr,Label='Bk_qInt')
    Bk_qInt(:,:) = qInt(:,:)
    call mma_deallocate(qInt)
  end if
  if (allocated(dqInt)) then
    call mma_allocate(Bk_dqInt,size(dqInt,1),MaxItr,Label='Bk_dqInt')
    Bk_dqInt(:,:) = dqInt(:,:)
    call mma_deallocate(dqInt)
  end if
  if (allocated(RefGeo)) then
    call mma_allocate(Bk_RefGeo,3,nsAtom,Label='Bk_RefGeo')
    Bk_RefGeo(:,:) = RefGeo(:,:)
    call mma_deallocate(RefGeo)
  end if
  if (allocated(BM)) then
    call mma_allocate(Bk_BM,size(BM),Label='Bk_BM')
    Bk_BM(:) = BM(:)
    call mma_deallocate(BM)
  end if
  if (allocated(dBM)) then
    call mma_allocate(Bk_dBM,size(dBM),Label='Bk_dBM')
    Bk_dBM(:) = dBM(:)
    call mma_deallocate(dBM)
  end if
  if (allocated(iBM)) then
    call mma_allocate(Bk_iBM,size(iBM),Label='Bk_iBM')
    Bk_iBM(:) = iBM(:)
    call mma_deallocate(iBM)
  end if
  if (allocated(idBM)) then
    call mma_allocate(Bk_idBM,size(idBM),Label='Bk_idBM')
    Bk_idBM(:) = idBM(:)
    call mma_deallocate(idBM)
  end if
  if (allocated(nqBM)) then
    call mma_allocate(Bk_nqBM,size(nqBM),Label='Bk_nqBM')
    Bk_nqBM(:) = nqBM(:)
    call mma_deallocate(nqBM)
  end if
  if (allocated(BMx)) then
    call mma_allocate(Bk_BMx,size(BMx,1),size(BMx,2),Label='Bk_BMx')
    Bk_BMx(:,:) = BMx(:,:)
    call mma_deallocate(BMx)
  end if
  if (allocated(Degen)) then
    call mma_allocate(Bk_Degen,size(Degen,1),size(Degen,2),Label='Bk_Degen')
    Bk_Degen(:,:) = Degen(:,:)
    call mma_deallocate(Degen)
  end if
  if (allocated(jStab)) then
    call mma_allocate(Bk_jStab,[0,7],[1,size(jStab,2)],Label='Bk_jStab')
    Bk_jStab(:,:) = jStab(:,:)
    call mma_deallocate(jStab)
  end if
  if (allocated(iCoSet)) then
    call mma_allocate(Bk_iCoSet,[0,7],[1,size(iCoSet,2)],Label='Bk_iCoSet')
    Bk_iCoSet(:,:) = iCoSet(:,:)
    call mma_deallocate(iCoSet)
  end if
  if (allocated(nStab)) then
    call mma_allocate(Bk_nStab,size(nStab),Label='Bk_nStab')
    Bk_nStab(:) = nStab(:)
    call mma_deallocate(nStab)
  end if
  if (allocated(AtomLbl)) then
    call mma_allocate(Bk_AtomLbl,size(AtomLbl),Label='Bk_AtomLbl')
    Bk_AtomLbl(:) = AtomLbl(:)
    call mma_deallocate(AtomLbl)
  end if
  if (allocated(Smmtrc)) then
    call mma_allocate(Bk_Smmtrc,3,size(Smmtrc,2),Label='Bk_Smmtrc')
    Bk_Smmtrc(:,:) = Smmtrc(:,:)
    call mma_deallocate(Smmtrc)
  end if
  if (allocated(Lbl)) then
    call mma_allocate(Bk_Lbl,size(Lbl),Label='Bk_Lbl')
    Bk_Lbl(:) = Lbl(:)
    call mma_deallocate(Lbl)
  end if
  if (allocated(mRowH)) then
    call mma_allocate(Bk_mRowH,size(mRowH),Label='Bk_mRowH')
    Bk_mRowH(:) = mRowH(:)
    call mma_deallocate(mRowH)
  end if
  if (allocated(RootMap)) then
    call mma_allocate(Bk_RootMap,size(RootMap),Label='Bk_RootMap')
    Bk_RootMap(:) = RootMap(:)
    call mma_deallocate(RootMap)
  end if
end if

Bk_Header(:) = Header(:)
Bk_iRef = iRef
Bk_NmIter = NmIter
Bk_iter = iter
Bk_nDimBC = nDimBC
Bk_MxItr = MxItr
Bk_Max_Center = Max_Center
Bk_iOptC = iOptC
Bk_mode = mode
Bk_mTROld = mTROld
Bk_nWndw = nWndw
Bk_iOptH = iOptH
Bk_nLambda = nLambda
Bk_nMEP = nMEP
Bk_nBVec = nBVec
Bk_IRC = IRC
Bk_mTtAtm = mTtAtm
Bk_MEPnum = MEPnum
Bk_SlStop = SlStop
Bk_lOld = lOld
Bk_CurviLinear = CurviLinear
Bk_HSet = HSet
Bk_BSet = BSet
Bk_lNmHss = lNmHss
Bk_Cubic = Cubic
Bk_Baker = Baker
Bk_DDV_Schlegel = DDV_Schlegel
Bk_Line_Search = Line_Search
Bk_HWRS = HWRS
Bk_Analytic_Hessian = Analytic_Hessian
Bk_FindTS = FindTS
Bk_MEP = MEP
Bk_User_Def = User_Def
Bk_rMEP = rMEP
Bk_lOld_Implicit = lOld_Implicit
Bk_HrmFrq_Show = HrmFrq_Show
Bk_eMEPtest = eMEPtest
Bk_Redundant = Redundant
Bk_lCtoF = lCtoF
Bk_lSoft = lSoft
Bk_CallLast = CallLast
Bk_TwoRunFiles = TwoRunFiles
Bk_TSConstraints = TSConstraints
Bk_MEPCons = MEPCons
Bk_Track = Track
Bk_Request_Alaska = Request_Alaska
Bk_Request_RASSI = Request_RASSI
Bk_ThrEne = ThrEne
Bk_ThrGrd = ThrGrd
Bk_Beta = Beta
Bk_Beta_Disp = Beta_Disp
Bk_Delta = Delta
Bk_Rtrnc = Rtrnc
Bk_rHidden = rHidden
Bk_ThrCons = ThrCons
Bk_GNrm_Threshold = GNrm_Threshold
Bk_CnstWght = CnstWght
Bk_dMEPStep = dMEPStep
Bk_rFuzz = rFuzz
Bk_ThrMEP = ThrMEP
Bk_lTherm = lTherm
Bk_lDoubleIso = lDoubleIso
Bk_nUserPT = nUserPT
Bk_nsRot = nsRot
Bk_UserT(:) = UserT(:)
Bk_UserP = UserP
Bk_HUpMet = HUpMet
Bk_UpMeth = UpMeth
Bk_MEP_Type = MEP_Type
Bk_MEP_Algo = MEP_Algo
Bk_isFalcon = isFalcon
Bk_mB_Tot = mB_Tot
Bk_mdB_Tot = mdB_Tot
Bk_mq = mq
Bk_WeightedConstraints = WeightedConstraints
Bk_NADC = NADC
Bk_EDiffZero = EDiffZero
Bk_ApproxNADC = ApproxNADC
Bk_iState(:) = iState(:)
Bk_iRow = iRow
Bk_iRow_c = iRow_c
Bk_nFix = nFix
Bk_iInt = iInt
Bk_Numerical = Numerical
Bk_VarR = VarR
Bk_VarT = VarT

! Make a backup of the runfile, since we are going to change the
! internal coordinates definition.

call fCopy('RUNFILE','RUNBCK2',iErr)
if (iErr /= 0) call Abend()

! Remove the Hessian and disable translational and rotational invariance

call Put_dArray('Hess',rDum,0)
VarR = .true.
VarT = .true.
!                                                                      *
!***********************************************************************
! Call Slapaf to build the B matrix and get the displacement vectors   *
! corresponding to the primitive internal coordinates (bonds and       *
! angles)                                                              *
!***********************************************************************
!                                                                      *
! Process the input

PLback = iPrintLevel(-1)
i = iPrintLevel(0)
LuInput = 21
LuInput = IsFreeUnit(LuInput)
call StdIn_Name(StdIn)
call Molcas_open(LuInput,StdIn)

iRow = 0
iRow_c = 0
nFix = 0
iInt = 0
call RdCtl_Slapaf(LuInput,.true.)
Curvilinear = .true.
Numerical = .false.

close(LuInput)
i = iPrintLevel(PLback)
!                                                                      *
!***********************************************************************
!                                                                      *
BSet = .true.
HSet = .false.
PrQ = .false.
nWndw = iter
iRef = 0
call BMtrx(size(Coor,2),Coor,iter,mTtAtm,nWndw)
nQQ = size(Shift,1)
!                                                                      *
!***********************************************************************
!                                                                      *
! First get the (transposed) K matrix, (dQ/dq)^T

call mma_allocate(KMtrx,mq,nQQ,label='KMtrx')
call mma_allocate(KTrsp,nQQ,mq,label='KTrsp')
call Qpg_dArray('K',Found,nK)
if ((.not. Found) .or. (nK /= mq*nQQ)) call Abend()
call Get_dArray('K',KMtrx,nK)
KTrsp(:,:) = transpose(KMtrx)
call mma_deallocate(KMtrx)

! Form the full B matrix in the redundant internal coordinates
! (primitives) and multiply by KK(t) on the fly

nX = 3*mTtAtm
call mma_allocate(KKtB,mq,nX,label='KKtB')
KKtB(:,:) = Zero
i = 1
do iq=1,mq
  nB = nqBM(iq)
  do iB=i,i+nB-1
    j = iBM(iB)
    do ii=1,mq
      KKtB(ii,j) = KKtB(ii,j)+BM(iB)*DDot_(nQQ,KTrsp(1,ii),1,KTrsp(1,iq),1)
    end do
  end do
  i = i+nB
end do
call mma_deallocate(KTrsp)

! Get the Cartesian normal modes

call Get_iScalar('Unique atoms',nUnique_Atoms)
call Get_nAtoms_All(nAll_Atoms)
if (3*nAll_Atoms /= nX) call Abend()
call mma_allocate(NMod,nX,nModes,label='NMod')
NMod(:,:) = Zero
call Get_NMode_All(Modes,lModes,nModes,nUnique_Atoms,NMod,nAll_Atoms,lDisp)

! Compute the overlaps with the primitive displacements

call mma_allocate(IntMod,mq,nModes,label='IntMod')
call DGeMM_('N','N',mq,nModes,nX,One,KKtB,mq,NMod,nX,Zero,IntMod,mq)
call mma_deallocate(KKtB)
call mma_deallocate(NMod)

! "Normalize" the maximum value to 1

do i=1,nModes
  Mx = Zero
  do j=1,mq
    Mx = max(Mx,abs(IntMod(j,i)))
  end do
  if (Mx > 1.0e-10_wp) IntMod(:,i) = IntMod(:,i)/Mx
end do

! Print the overlaps

call mma_allocate(Label,nLbl,label='Label')
Filename = 'INTCOR'
LuIC = 21
LuIC = IsFreeUnit(LuIC)
call Molcas_open(LuIC,Filename)
i = 1
Line = Get_Ln_EOF(LuIC)
do while (Line /= 'EOF')
  j = index(Line,'=')+1
  Label(i) = adjustl(Line(j:))
  i = i+1
  Line = Get_Ln_EOF(LuIC)
end do
close(LuIC)

MinComp = Half
call CollapseOutput(1,'Principal components of the normal modes')
write(u6,'(3X,A)') '----------------------------------------'
write(u6,*)
write(u6,'(3X,A,F4.2,A)') '(Only contributions larger than ',MinComp,' times the maximum are printed)'
write(u6,*)
call mma_allocate(Sort,mq,label='Sort')
do i=1,nModes
  write(u6,*)
  write(u6,'(6X,A,1X,I6)') 'Mode',i
  write(Line,'(5X,F10.2)') Freq(i)
  j = index(Line,'-')
  if (j > 0) Line(j:j) = 'i'
  write(u6,'(8X,A)') 'Frequency: '//trim(Line)//' cm-1'
  write(u6,'(6X,A)') '---------------------------------'
  do j=1,mq
    Sort(j) = j
  end do
  do j=1,mq
    do ii=j+1,mq
      if (abs(IntMod(Sort(ii),i)) > abs(IntMod(Sort(j),i))) then
        im = Sort(j)
        Sort(j) = Sort(ii)
        Sort(ii) = im
      end if
    end do
    if (abs(IntMod(Sort(j),i)) < MinComp) exit
    write(u6,'(8X,A,F7.4)') Label(Sort(j)),IntMod(Sort(j),i)
  end do
  write(u6,'(6X,A)') '---------------------------------'
end do
call CollapseOutput(0,'Principal components of the normal modes')

! Clean up

call mma_deallocate(Label)
call mma_deallocate(IntMod)
call mma_deallocate(Sort)
!                                                                      *
!***********************************************************************
!                                                                      *
! Restore the runfile and the "global" variables

call fCopy('RUNBCK2','RUNFILE',iErr)
if (iErr /= 0) call Abend()
if (AixRm('RUNBCK2') /= 0) call Abend()

Header(:) = Bk_Header(:)
iRef = Bk_iRef
NmIter = Bk_NmIter
iter = Bk_iter
nDimBC = Bk_nDimBC
MxItr = Bk_MxItr
Max_Center = Bk_Max_Center
iOptC = Bk_iOptC
mode = Bk_mode
mTROld = Bk_mTROld
nWndw = Bk_nWndw
iOptH = Bk_iOptH
nLambda = Bk_nLambda
nMEP = Bk_nMEP
nBVec = Bk_nBVec
IRC = Bk_IRC
mTtAtm = Bk_mTtAtm
MEPnum = Bk_MEPnum
SlStop = Bk_SlStop
lOld = Bk_lOld
CurviLinear = Bk_CurviLinear
HSet = Bk_HSet
BSet = Bk_BSet
lNmHss = Bk_lNmHss
Cubic = Bk_Cubic
Baker = Bk_Baker
DDV_Schlegel = Bk_DDV_Schlegel
Line_Search = Bk_Line_Search
HWRS = Bk_HWRS
Analytic_Hessian = Bk_Analytic_Hessian
FindTS = Bk_FindTS
MEP = Bk_MEP
User_Def = Bk_User_Def
rMEP = Bk_rMEP
lOld_Implicit = Bk_lOld_Implicit
HrmFrq_Show = Bk_HrmFrq_Show
eMEPtest = Bk_eMEPtest
Redundant = Bk_Redundant
lCtoF = Bk_lCtoF
lSoft = Bk_lSoft
CallLast = Bk_CallLast
TwoRunFiles = Bk_TwoRunFiles
TSConstraints = Bk_TSConstraints
MEPCons = Bk_MEPCons
Track = Bk_Track
Request_Alaska = Bk_Request_Alaska
Request_RASSI = Bk_Request_RASSI
ThrEne = Bk_ThrEne
ThrGrd = Bk_ThrGrd
Beta = Bk_Beta
Beta_Disp = Bk_Beta_Disp
Delta = Bk_Delta
Rtrnc = Bk_Rtrnc
rHidden = Bk_rHidden
ThrCons = Bk_ThrCons
GNrm_Threshold = Bk_GNrm_Threshold
CnstWght = Bk_CnstWght
dMEPStep = Bk_dMEPStep
rFuzz = Bk_rFuzz
ThrMEP = Bk_ThrMEP
lTherm = Bk_lTherm
lDoubleIso = Bk_lDoubleIso
nUserPT = Bk_nUserPT
nsRot = Bk_nsRot
UserT(:) = Bk_UserT(:)
UserP = Bk_UserP
HUpMet = Bk_HUpMet
UpMeth = Bk_UpMeth
MEP_Type = Bk_MEP_Type
MEP_Algo = Bk_MEP_Algo
isFalcon = Bk_isFalcon
mB_Tot = Bk_mB_Tot
mdB_Tot = Bk_mdB_Tot
mq = Bk_mq
WeightedConstraints = Bk_WeightedConstraints
NADC = Bk_NADC
EDiffZero = Bk_EDiffZero
ApproxNADC = Bk_ApproxNADC
iState(:) = Bk_iState(:)
iRow = Bk_iRow
iRow_c = Bk_iRow_c
nFix = Bk_nFix
iInt = Bk_iInt
Numerical = Bk_Numerical
VarR = Bk_VarR
VarT = Bk_VarT

! Process arrays that are always allocated.

if (allocated(Bk_Cx)) then
  Cx(:,:,:) = Bk_Cx(:,:,:)
  call mma_deallocate(Bk_Cx)
else
  call mma_deallocate(Cx)
end if
if (allocated(Bk_Gx)) then
  Gx(:,:,:) = Bk_Gx(:,:,:)
  call mma_deallocate(Bk_Gx)
else
  call mma_deallocate(Gx)
end if
if (allocated(Bk_Gx0)) then
  Gx0(:,:,:) = Bk_Gx0(:,:,:)
  call mma_deallocate(Bk_Gx0)
else
  call mma_deallocate(Gx0)
end if
if (allocated(Bk_NAC)) then
  NAC(:,:,:) = Bk_NAC(:,:,:)
  call mma_deallocate(Bk_NAC)
else
  call mma_deallocate(NAC)
end if
if (allocated(Bk_Q_nuclear)) then
  Q_nuclear(:) = Bk_Q_nuclear(:)
  call mma_deallocate(Bk_Q_nuclear)
else
  call mma_deallocate(Q_nuclear)
end if
if (allocated(Bk_dMass)) then
  dMass(:) = Bk_dMass(:)
  call mma_deallocate(Bk_dMass)
else
  call mma_deallocate(dMass)
end if
if (allocated(Bk_Coor)) then
  Coor(:,:) = Bk_Coor(:,:)
  call mma_deallocate(Bk_Coor)
else
  call mma_deallocate(Coor,safe='*')
end if
if (allocated(Bk_Grd)) then
  Grd(:,:) = Bk_Grd(:,:)
  call mma_deallocate(Bk_Grd)
else
  call mma_deallocate(Grd,safe='*')
end if
if (allocated(Bk_ANr)) then
  ANr(:) = Bk_ANr(:)
  call mma_deallocate(Bk_ANr)
else
  call mma_deallocate(ANr)
end if
if (allocated(Bk_Weights)) then
  Weights(:) = Bk_Weights(:)
  call mma_deallocate(Bk_Weights)
else
  call mma_deallocate(Weights)
end if
if (allocated(Bk_Shift)) then

  if (size(Shift,1) /= size(Bk_Shift,1)) then
    call mma_deallocate(Shift)
    call mma_allocate(Shift,size(Bk_Shift,1),MaxItr,Label='Shift')
  end if
  Shift(:,:) = Bk_Shift(:,:)
  call mma_deallocate(Bk_Shift)
else
  call mma_deallocate(Shift)
end if
if (allocated(Bk_GNrm)) then
  GNrm(:) = Bk_GNrm(:)
  call mma_deallocate(Bk_GNrm)
else
  call mma_deallocate(GNrm)
end if
if (allocated(Bk_Energy)) then
  Energy(:) = Bk_Energy(:)
  call mma_deallocate(Bk_Energy)
else
  call mma_deallocate(Energy)
end if
if (allocated(Bk_Energy0)) then
  Energy0(:) = Bk_Energy0(:)
  call mma_deallocate(Bk_Energy0)
else
  call mma_deallocate(Energy0)
end if
if (allocated(Bk_MF)) then
  MF(:,:) = Bk_MF(:,:)
  call mma_deallocate(Bk_MF)
else
  call mma_deallocate(MF)
end if
if (allocated(Bk_DipM)) then
  DipM(:,:) = Bk_DipM(:,:)
  call mma_deallocate(Bk_DipM)
else
  call mma_deallocate(DipM,safe='*')
end if
if (allocated(Bk_RefGeo)) then
  RefGeo(:,:) = Bk_RefGeo(:,:)
  call mma_deallocate(Bk_RefGeo)
else
  call mma_deallocate(RefGeo,safe='*')
end if

! Process arrays that are allocated optionally.

if (allocated(Bk_Lambda)) then
  call mma_allocate(Lambda,size(Bk_Lambda,1),MaxItr+1,Label='Lambda',safe='*')
  Lambda(:,:) = Bk_Lambda(:,:)
  call mma_deallocate(Bk_Lambda)
else
  call mma_deallocate(Lambda,safe='*')
end if

call mma_deallocate(qInt,safe='*')
if (allocated(Bk_qInt)) then
  call mma_allocate(qInt,size(Bk_qInt,1),MaxItr,Label='qInt')
  qInt(:,:) = Bk_qInt(:,:)
  call mma_deallocate(Bk_qInt)
end if
call mma_deallocate(dqInt,safe='*')
if (allocated(Bk_dqInt)) then
  call mma_allocate(dqInt,size(Bk_dqInt,1),MaxItr,Label='dqInt')
  dqInt(:,:) = Bk_dqInt(:,:)
  call mma_deallocate(Bk_dqInt)
end if

call mma_deallocate(BM,safe='*')
if (allocated(Bk_BM)) then
  call mma_allocate(BM,size(Bk_BM),Label='BM')
  BM(:) = Bk_BM(:)
  call mma_deallocate(Bk_BM)
end if
call mma_deallocate(dBM,safe='*')
if (allocated(Bk_dBM)) then
  call mma_allocate(dBM,size(Bk_dBM),Label='dBM')
  dBM(:) = Bk_dBM(:)
  call mma_deallocate(Bk_dBM)
end if
call mma_deallocate(iBM,safe='*')
if (allocated(Bk_iBM)) then
  call mma_allocate(iBM,size(Bk_iBM),Label='iBM')
  iBM(:) = Bk_iBM(:)
  call mma_deallocate(Bk_iBM)
end if
call mma_deallocate(idBM,safe='*')
if (allocated(Bk_idBM)) then
  call mma_allocate(idBM,size(Bk_idBM),Label='idBM')
  idBM(:) = Bk_idBM(:)
  call mma_deallocate(Bk_idBM)
end if
call mma_deallocate(nqBM,safe='*')
if (allocated(Bk_nqBM)) then
  call mma_allocate(nqBM,size(Bk_nqBM),Label='nqBM')
  nqBM(:) = Bk_nqBM(:)
  call mma_deallocate(Bk_nqBM)
end if
call mma_deallocate(BMx,safe='*')
if (allocated(Bk_BMx)) then
  call mma_allocate(BMx,size(Bk_BMx,1),size(Bk_BMx,2),Label='BMx')
  BMx(:,:) = Bk_BMx(:,:)
  call mma_deallocate(Bk_BMx)
end if
call mma_deallocate(Degen,safe='*')
if (allocated(Bk_Degen)) then
  call mma_allocate(Degen,size(Bk_Degen,1),size(Bk_Degen,2),Label='Degen')
  Degen(:,:) = Bk_Degen(:,:)
  call mma_deallocate(Bk_Degen)
end if
call mma_deallocate(jStab,safe='*')
if (allocated(Bk_jStab)) then
  call mma_allocate(jStab,[0,7],[1,size(Bk_jStab,2)],Label='jStab')
  jStab(:,:) = Bk_jStab(:,:)
  call mma_deallocate(Bk_jStab)
end if
call mma_deallocate(iCoSet,safe='*')
if (allocated(Bk_iCoSet)) then
  call mma_allocate(iCoSet,[0,7],[1,size(Bk_iCoSet,2)],Label='iCoSet')
  iCoSet(:,:) = Bk_iCoSet(:,:)
  call mma_deallocate(Bk_iCoSet)
end if
call mma_deallocate(nStab,safe='*')
if (allocated(Bk_nStab)) then
  call mma_allocate(nStab,size(Bk_nStab,1),Label='nStab')
  nStab(:) = Bk_nStab(:)
  call mma_deallocate(Bk_nStab)
end if
call mma_deallocate(AtomLbl,safe='*')
if (allocated(Bk_AtomLbl)) then
  call mma_allocate(AtomLbl,size(Bk_AtomLbl,1),Label='AtomLbl')
  AtomLbl(:) = Bk_AtomLbl(:)
  call mma_deallocate(Bk_AtomLbl)
end if
call mma_deallocate(Smmtrc,safe='*')
if (allocated(Bk_Smmtrc)) then
  call mma_allocate(Smmtrc,3,size(Bk_Smmtrc,2),Label='Smmtrc')
  Smmtrc(:,:) = Bk_Smmtrc(:,:)
  call mma_deallocate(Bk_Smmtrc)
end if
call mma_deallocate(Lbl,safe='*')
if (allocated(Bk_Lbl)) then
  call mma_allocate(Lbl,size(Bk_Lbl),Label='Lbl')
  Lbl(:) = Bk_Lbl(:)
  call mma_deallocate(Bk_Lbl)
end if
call mma_deallocate(mRowH,safe='*')
if (allocated(Bk_mRowH)) then
  call mma_allocate(mRowH,size(Bk_mRowH),Label='mRowH')
  mRowH(:) = Bk_mRowH(:)
  call mma_deallocate(Bk_mRowH)
end if
call mma_deallocate(RootMap,safe='*')
if (allocated(Bk_RootMap)) then
  call mma_allocate(RootMap,size(Bk_RootMap),Label='RootMap')
  RootMap(:) = Bk_RootMap(:)
  call mma_deallocate(Bk_RootMap)
end if

end subroutine Print_Mode_Components

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************
subroutine ConvertTabSO(TabSO2,TabSO,mAO,mGrid,nMOs)

use nq_pdft, only: lft, lGGA
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mAO, mGrid, nMOs
real(kind=wp), intent(out) :: TabSO2(nMOs,mAO,mGrid)
real(kind=wp), intent(in) :: TabSO(mAO,mGrid,nMOs)
integer(kind=iwp) :: iEnd, iGrid, jAO

! TabSO : mAO*mGrid x nMOs
! TabSO2: nMOs x mAO*nGrid

! loop over first and optionally second derivatives of the SOs
! this defines the length of nAO to 3 or 9.
if (lft .and. lGGA) then
  iEnd = 9
else
  iEnd = 3
end if

do iGrid=1,mGrid
  do jAO=1,iEnd
    TabSO2(:,jAO,iGrid) = TabSO(jAO+1,iGrid,:)
  end do
end do

return

end subroutine ConvertTabSO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine WrInp_SCF(SIntTh)
************************************************************************
*                                                                      *
*     purpose: Write input                                             *
*                                                                      *
*     called from: Scf                                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*     modified by M. Schuetz @teokem.lu.se, 1995                       *
*                                                                      *
*     input: SIntTh: Threshold for Integral prescreening               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Use Functionals, only: Print_Info
      Use KSDFT_Info, only: CoefR, CoefX
      Use InfSO
*
      Implicit Real*8 (a-h,o-z)
*
      Real*8 SIntTh
*

#include "mxdm.fh"
#include "infscf.fh"
#include "rctfld.fh"
#include "ldfscf.fh"
*
*---- Define local variables
      Character*60 Fmt, FmtR, FmtI
      Character*72 Line
      Character*3 lIrrep(8)
      Logical NonEq

      If (jPrint.ge.2) Then
         Call CollapseOutput(1,'   Input section:')
         Write(6,'(3X,A)')     '   --------------'
         Write(6,*)
      End If
*
*---- Print out header of the integral file
      If (jPrint.ge.2) Then
         Write(6,'(6X,A)')  'Header of the integral files:'
         Write(Line,'(A72)') Header(1)
         Write(6,'(6X,A)') trim(Line)
         Write(Line,'(A72)') Header(2)
         Write(6,'(6X,A)') trim(Line)
         Write(6,*)
      End If
*
*---- Print out title (if any)
      If (nTit.gt.0) Then
         If (jPrint.ge.3) Then
             Call Banner(Title,nTit,lPaper-7)
             Write(6,*)
         Else If (jPrint.ge.2) Then
             Write (6,'(6X,A)') ' Title:'
             Do iTit = 1, nTit
                Write (6,'(8X,A)') trim(Title(iTit))
             End Do
         End If
      End If
*
*---- Print the coordinates of the system
      If (jPrint.ge.2) Call PrCoor
*
*---- Print out Print level
*     Write(*,'(1X,A,I3)') 'Print level=',iPrint
*     Write(*,*)
*
*
      Call Get_cArray('Irreps',lIrrep,24)
      Do iSym = 1, nSym
         lIrrep(iSym) = adjustr(lIrrep(iSym))
      End Do
*
      If (jPrint.ge.2) Then
        Call CollapseOutput(0,'   Input section:')
        Write(6,*)
      End If
*---- Print out orbital informations
      Fmt='(6X,A,T35,8I4)'
      If (jPrint.ge.2) Then
         Call CollapseOutput(1,'   Orbital specifications:')
         Write(6,'(3X,A)')     '   -----------------------'
         Write(6,*)
         Write(6,Fmt)'Symmetry species',         (i,i=1,nSym)
         Write(6,'(6X,A,T35,8(1X,A))')
     &         '                ',         (lIrrep(i),i=1,nSym)
         Write(6,Fmt)'Frozen orbitals',          (nFro(i),i=1,nSym)
      End If
*
      If (Aufb) Then
       if(iUHF.eq.0) Then
        If (nAufb(1).eq.-1) Then
           Tot_El_Charge=Tot_Charge-Tot_Nuc_Charge
*--------- Check that Tot_El_Charge is a multiple of two!
           mtmp=Int(-Tot_El_Charge+0.1D0)
           If (Mod(mtmp,2).ne.0) Then
              Write (6,*)
     &          'WrInp: Error in definition of molecular charge!'
              Write (6,*)
     &          'Current implementation only allows double occupations.'
              Write (6,*) 'Tot_Charge    :',Tot_Charge
              Write (6,*) 'Tot_El_Charge :',Tot_El_Charge
              Write (6,*) 'Tot_Nuc_Charge:',Tot_Nuc_Charge
              Call Abend()
           End If
           nAufb(1)=mtmp/2
        endif
       else
        If (nAufb(1).eq.-1) Then
           Tot_El_Charge=Tot_Charge-Tot_Nuc_Charge
*--------- Check that Tot_El_Charge is a multiple of two!
           mtmp=Int(-Tot_El_Charge+0.1D0)
c if ZSPIN is not set - make difference alpha-beta = 0 or 1
            nAufb(2)=(mtmp-iAu_ab)/2
            nAufb(1)=Int(-Tot_El_Charge-nAufb(2))
        endif
c          Write(6,*) ' CHARGE + UHF is un'
c           Call Abend()
        End If
        if(iUHF.eq.0.and.jPrint.ge.2) then
        Write(6,Fmt)'Aufbau',                 nAufb(1)
        else if (jPrint.ge.3) Then
        Write(6,Fmt)'Aufbau alpha',                 nAufb(1)
        Write(6,Fmt)'Aufbau beta ',                 nAufb(2)
        endif
        If (Teee.and.jPrint.ge.2) Then
           Write (6,'(a,f6.3)') '      Start temperature =',RTemp
           Write (6,'(a,f6.3)') '      End temperature   =',TStop
           Write (6,'(a,f6.3)') '      Temperature Factor=',TemFac
        End If
      Else
        if(iUHF.eq.0.and.jPrint.ge.2) then
        Write(6,Fmt)'Occupied orbitals',    (nOcc(i,1),i=1,nSym)
        Write(6,Fmt)'Secondary orbitals',   (nOrb(i)-nOcc(i,1),i=1,nSym)
        else if (jPrint.ge.2) Then
        Write(6,Fmt)'Occupied orbitals alpha',      (nOcc(i,1),i=1,nSym)
        Write(6,Fmt)'Occupied orbitals beta ',      (nOcc(i,2),i=1,nSym)
        Write(6,Fmt)'Secondary orbitals alpha',
     &              (nOrb(i)-nOcc(i,1),i=1,nSym)
        Write(6,Fmt)'Secondary orbitals beta',
     &              (nOrb(i)-nOcc(i,2),i=1,nSym)

        endif
      End If
*
      Tot_Charge=Tot_Nuc_Charge+Tot_El_Charge
      Call put_dscalar('Total Charge    ',Tot_Charge)
      If (jPrint.ge.2) Then
         Write(6,Fmt)'Deleted orbitals         ',(nDel(i),i=1,nSym)
         Write(6,Fmt)'Total number of orbitals ',(nOrb(i),i=1,nSym)
         Write(6,Fmt)'Number of basis functions',(nBas(i),i=1,nSym)
         Call CollapseOutput(0,'   Orbital specifications:')
         Write(6,*)
         Write(6,'(6X,A,T45,F10.3)') 'Molecular charge',Tot_Charge
         Write(6,*)
      End If
*
*---- Print out reaction field specifications
*
      iCharge=Int(Tot_Charge)
      NonEq=.False.
      Call PrRF(.False.,NonEq,iCharge,jPrint)
      If ( RFpert.and.jPrint.ge.2 ) then
         Write(6,'(6X,A)')'Reaction field specifications:'
         Write(6,'(6X,A)')'------------------------------'
         Write(6,*)
         Write(6,'(6X,A)')'The Reaction field is added as a '//
     &                    'perturbation and has been determined '//
     &                    'in a previos calculation'
         Write(6,*)
      End If
*
*---- Print out grid information in case of DFT
*
      If (KSDFT.ne.'SCF') Then
         Call Put_dScalar('DFT exch coeff',CoefX)
         Call Put_dScalar('DFT corr coeff',CoefR)
         Call Put_dScalar('EThr',EThr)
         Call Funi_Print()
         If (jPrint.ge.2) Then
            If (One_Grid) Then
               Write (6,'(6X,A)') 'The same grid will be used for all'
     &                          //' iterations.'
            Else
               Write (6,'(6X,A)') 'A smaller intermediate grid will b'
     &                          //'e used the first few iterations.'
            End If
            Write(6,*)
            Write(6,'(6X,A)') 'DFT functional specifications'
            Write(6,'(6X,A)') '-----------------------------'
            Call libxc_version()
            Call Print_Info()
            Write(6,*)
         End If
      End If
*
*---- Print out informations concerning Direct/Conventional scheeme
      FmtI= '(6X,A,T50,I8)'
      FmtR= '(6X,A,T50,E8.2)'
      If (jPrint.ge.2) Then
         Call CollapseOutput(1,'   Optimization specifications:')
         Write(6,'(3X,A)')     '   ----------------------------'
         Write(6,*)
      End If
      If (DSCF.and.jPrint.ge.2) Then
         If (nDisc.eq.0.and.nCore.eq.0) Then
            Write(6,'(6X,A)')'SCF Algorithm: Direct'
         Else If (nDisc*1024.ge.nCore) Then
            Write(6,'(6X,A)')'SCF Algorithm: Semi-direct'
*
*---------- The threshold to be used in the direct SCF procedure is
*           defined by the energy threshold.
            Write (6,FmtI)
     &        'Max MByte of integrals on disk/process:',nDisc
            Write(6,FmtR) 'Threshold for saving integrals on disc',
     &                    Thize
         Else
            Write(6,'(6X,A)')'SCF Algorithm: Semi-direct in-core'
*
*---------- The threshold to be used in the direct SCF procedure is
*           defined by the energy threshold.
            Write (6,FmtI)
     &        'Max kByte of integrals in memory/process:',nCore
            Write(6,FmtR) 'Threshold for saving integrals in memory',
     &                    Thize
         End If
         If (PreSch) Then
            Write(6,'(6X,A)')'Prescreening Scheme: '//
     &                       'Only Integral value'
         Else
            Write(6,'(6X,A)')'Prescreening Scheme: '//
     &                       'Integral*Density value'
         End If
      Else If (jPrint.ge.2) Then
         if(iUHF.eq.0) then
            if(.not.DoCholesky)then
              Write(6,'(6X,A)')'SCF Algorithm: Conventional'
            else
              If (DoLDF) Then
                 If (LDF_IntegralMode.eq.0) Then
                    Write(6,'(6X,A)')
     &          'SCF Algorithm: Direct LDF using conventional integrals'
                 Else If (LDF_IntegralMode.eq.1) Then
                    Write(6,'(6X,A)')
     &              'SCF Algorithm: Direct robust LDF'
                 Else If (LDF_IntegralMode.eq.2) Then
                    Write(6,'(6X,A)')
     &              'SCF Algorithm: Direct nonrobust LDF'
                 Else If (LDF_IntegralMode.eq.3) Then
                    Write(6,'(6X,A)')
     &              'SCF Algorithm: Direct half-and-half LDF'
                 Else
                    Write(6,'(6X,A,I6)') 'Unknown LDF integral mode:',
     &                                   LDF_IntegralMode
                    Call LDF_NotImplemented()
                 End If
                 If (LDF_IntegralPrescreening.lt.0.0d0) Then
                    Write(6,'(6X,A,A)')
     &              'Integral prescreening threshold determined from',
     &              ' target accuracy'
                 Else
                    Write(6,FmtR)
     &              'Integral prescreening threshold',
     &              LDF_IntegralPrescreening
                 End If
                 If (LDF_ContributionPrescreening.lt.0.0d0) Then
                    Write(6,'(6X,A,A)')
     &              'Contribution prescreening threshold determined',
     &              ' from target accuracy'
                 Else
                    Write(6,FmtR)
     &              'Contribution prescreening threshold',
     &              LDF_ContributionPrescreening
                 End If
              Else
                 Call Get_iScalar('System BitSwitch',iDoRI)
                 if (Iand(iDoRI,1024).Eq.1024) then
                    if (LKon) then
                       Write(6,'(6X,A)')'SCF Algorithm: LK-RI/DF'
                    else
                       Write(6,'(6X,A)')'SCF Algorithm: RI/DF'
                    endif
                 else
                    if (LKon) then
                       Write(6,'(6X,A)')'SCF Algorithm: LK-Cholesky'
                    else
                       Write(6,'(6X,A)')'SCF Algorithm: Cholesky'
                    endif
                 endif
              End If
            endif
         else
            if(.not.DoCholesky)then
              Write(6,'(6X,A)')'SCF Algorithm: Conventional USCF'
            else
              If (DoLDF) Then
                 If (LDF_IntegralMode.eq.0) Then
                    Write(6,'(6X,A)')
     &          'SCF Algorithm: Direct LDF using conventional integrals'
                 Else If (LDF_IntegralMode.eq.1) Then
                    Write(6,'(6X,A)')
     &              'SCF Algorithm: Direct robust LDF USCF'
                 Else If (LDF_IntegralMode.eq.2) Then
                    Write(6,'(6X,A)')
     &              'SCF Algorithm: Direct nonrobust LDF USCF'
                 Else If (LDF_IntegralMode.eq.3) Then
                    Write(6,'(6X,A)')
     &              'SCF Algorithm: Direct half-and-half LDF USCF'
                 Else
                    Write(6,'(6X,A,I6)') 'Unknown LDF integral mode:',
     &                                   LDF_IntegralMode
                    Call LDF_NotImplemented()
                 End If
                 If (LDF_IntegralPrescreening.lt.0.0d0) Then
                    Write(6,'(6X,A,A)')
     &              'Integral prescreening threshold determined from',
     &              ' target accuracy'
                 Else
                    Write(6,FmtR)
     &              'Integral prescreening threshold',
     &              LDF_IntegralPrescreening
                 End If
                 If (LDF_ContributionPrescreening.lt.0.0d0) Then
                    Write(6,'(6X,A,A)')
     &              'Contribution prescreening threshold determined',
     &              ' from target accuracy'
                 Else
                    Write(6,FmtR)
     &              'Contribution prescreening threshold',
     &              LDF_ContributionPrescreening
                 End If
              Else
                 Call Get_iScalar('System BitSwitch',iDoRI)
                 if (Iand(iDoRI,1024).Eq.1024) then
                    if (LKon) then
                       Write(6,'(6X,A)')'SCF Algorithm: LK-RI/DF USCF'
                    else
                       Write(6,'(6X,A)')'SCF Algorithm: RI/DF USCF'
                    endif
                 else
                    if (LKon) then
                       Write(6,'(6X,A)')
     &                               'SCF Algorithm: LK-Cholesky USCF'
                    else
                       Write(6,'(6X,A)')'SCF Algorithm: Cholesky USCF'
                    endif
                 endif
              End If
            endif
         endif
      End If
      If (NoExchange) Then
         Write(6,'(6X,A)')
     &   'NOTE: exchange contributions will not be computed'
      End If
*
      If (jPrint.ge.2) Then
*
*---- Print out informations concerning difference scheme used
      If (MiniDn) Then
         Write(6,'(6X,A)')'Minimized density differences are used'
      Else
        if(.not.DDnOFF)then
          Write(6,'(6X,A)')'D(i)-D(i-1) density differences are used'
        else
          Write(6,'(6X,A)')'The actual AO density is used'
        endif
      End If
      Write(6,FmtI)'Number of density matrices in core',nMem
*
*---- Print out number of iterations
      Write(6,FmtI) 'Maximum number of NDDO SCF iterations',nIter(0)
      Write(6,FmtI) 'Maximum number of HF SCF iterations',nIter(1)
*
*---- Print out thresholds for SCF
      Write(6,FmtR) 'Threshold for SCF energy change',EThr
      Write(6,FmtR) 'Threshold for density matrix',DThr
      Write(6,FmtR) 'Threshold for Fock matrix',FThr
      Write(6,FmtR) 'Threshold for linear dependence',DelThr
      If (Diis) Then
         Write(6,FmtR) 'Threshold at which DIIS is turned on',
     &                 DiisTh
         Write(6,FmtR) 'Threshold at which QNR/C2DIIS is turned on',
     &                 QNRTh
         Write(6,FmtR) 'Threshold for Norm(delta) (QNR/C2DIIS)',
     &                 DltNTh
      End If
      If (DSCF) Then
         Write(6,FmtR) 'Threshold for contribution to Fock matrix',
     &                 SIntTh
      End If
*
*---- Print out acceleration scheeme used in SCF
      Fmt = '(6x,A,A)'
      If (Diis) Then
         Write(6,Fmt) 'DIIS extrapolation of the SCF procedure'
      Else If (iDKeep.eq.0) Then
         Write(6,Fmt) 'No damping of the SCF procedure'
      Else If (iDKeep.ge.3) Then
         Write(6,Fmt) 'Extended dynamic damping of the SCF procedure'
      Else
         Write(6,Fmt) 'Dynamic damping of the SCF procedure'
      End If
*
*---- Print out IVO information (if any)
      If (kIvo.ne.0) Write(6,Fmt) 'Improved virtual orbitals.'
*
*---- Print out information about orbitals punched on the file
      If (jVOut.le.0) Then
         Write(6,Fmt) 'No vectors punched'
      Else If (jVOut.eq.1) Then
         If(iUHF.eq.0) Then
            Write(6,Fmt) 'All non deleted orbitals punched on: SCFORB'
         Else
            Write(6,Fmt) 'All non deleted orbitals punched on: UHFORB'
         End If
      Else
         If(iUHF.eq.0) Then
            Write(6,Fmt) 'All orbitals punched on: SCFORB'
         Else
            Write(6,Fmt) 'All orbitals punched on: UHFORB'
         End If
      End If
      Call CollapseOutput(0,'   Optimization specifications:')
      Write(6,*)
*
*---- Print out
      If (InVec.eq.0) Then
         Write(6,Fmt) 'Starting vectors from core diagonalization'
      Else If (InVec.eq.1) Then
         Write(6,Fmt)
     &         'NDDO MOs are generated before actual HF SCF computation'
      Else If (InVec.eq.2) Then
         If (isHDF5) Then
            Write(6,Fmt) 'Input vectors read from HDF5 file'
         Else
            Write(6,Fmt) 'Input vectors read from INPORB'
            Write(6,Fmt) 'Orbital file label: ',trim(VTitle)
         End If
      Else If (InVec.eq.3) Then
         Write(6,Fmt) 'Input density matrix read from RUNFILE'
      Else If (InVec.eq.4) Then
         Write(6,Fmt) 'Restart...'
      Else If (InVec.eq.5) Then
         Write(6,Fmt) 'Input vectors from NDDO calculation'
      Else
         Write(6,Fmt) StVec
      End If
      If (Scrmbl) Write(6,Fmt) 'Start orbitals are scrambled in order '
     &      //'to introduce symmetry breaking'
      Write(6,*)
*
      End If
*
*     LDF: print a warning message if nonrobust or half-n-half is used
*
      If (DoLDF) Then
         If (LDF_IntegralMode.eq.2 .or. LDF_IntegralMode.eq.3) Then
            Call WarningMessage(0,
     &      'WARNING: nonrobust and half-n-half LDF integral '//
     &      'representations may lead to large errors and '//
     &      'provide inferior numerical stability compared to '//
     &      'the robust representation')
         End If
      End If


      Call XFlush(6)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Logical Function LDF_TestBlockMatrix(ip_Blocks,Packed,FullMatrix)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: test block matrix routines.
C
      Implicit None
      Integer ip_Blocks
      Logical Packed
      Real*8  FullMatrix(*)
#include "WrkSpc.fh"
#include "localdf_bas.fh"

      real*8 ddot_
      external ddot_

      Real*8 Tol
      Parameter (Tol=1.0d-12)

      Real*8  z
      Integer ip, l

      ! Allocate a full matrix
      If (Packed) Then
         l=nBas_Valence*(nBas_Valence+1)/2
      Else
         l=nBas_Valence*nBas_Valence
      End If
      Call GetMem('TBMTst','Allo','Real',ip,l)

      ! Get full matrix from blocked
      Call LDF_Blocked2Full(ip_Blocks,Packed,Work(ip))

      ! Check that it is the same as FullMatrix
      Call dAXPY_(l,-1.0d0,FullMatrix,1,Work(ip),1)
      z=sqrt(dDot_(l,Work(ip),1,Work(ip),1))
      If (z.gt.Tol) Then
         LDF_TestBlockMatrix=.False.
      Else
         LDF_TestBlockMatrix=.True.
      End If

      ! Deallocate
      Call GetMem('TBMTst','Free','Real',ip,l)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SECULAR(NDIM,N,NRON,HMAT,SMAT,VEC,EVAL,SCR,THR)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NDIM, N
integer(kind=iwp), intent(out) :: NRON
real(kind=wp), intent(in) :: HMAT(NDIM,NDIM), SMAT(NDIM,NDIM), THR
real(kind=wp), intent(out) :: VEC(NDIM,NDIM), EVAL(NDIM)
real(kind=wp), intent(_OUT_) :: SCR(*)
integer(kind=iwp) :: I, IFROM, II, IOFF1, ITO, J, K, MAXLEN
real(kind=wp) :: RSUM, SCL, THR2

THR2 = THR**2
! PUT NORMALIZED VECTORS INTO VEC:
VEC(:,1:N) = Zero
do I=1,N
  VEC(I,I) = One/sqrt(SMAT(I,I))
end do
! GRAM-SCHMIDT ORTHONORMALIZING PROCEDURE:
NRON = 0
do I=1,N
  ! SMAT*(NORMALIZED VECTOR) INTO SCR:
  SCR(1:N) = VEC(I,I)*SMAT(1:N,I)
  ! PROJECT AWAY THE ALREADY ORTHONORMALIZED BASIS SET:
  do J=1,NRON
    MAXLEN = I-1-NRON+J
    RSUM = Zero
    do K=1,MAXLEN
      RSUM = RSUM+VEC(K,J)*SCR(K)
    end do
    do K=1,MAXLEN
      VEC(K,I) = VEC(K,I)-RSUM*VEC(K,J)
    end do
  end do
  ! NORMALIZE AND MOVE INTO POSITION:
  RSUM = Zero
  do K=1,I
    RSUM = RSUM+VEC(K,I)*SCR(K)
  end do
  if (RSUM >= THR2) then
    NRON = NRON+1
    SCL = One/sqrt(RSUM)
    do K=1,I
      VEC(K,NRON) = SCL*VEC(K,I)
    end do
  end if
end do
do I=NRON+1,N
  VEC(1:N,I) = Zero
end do
! TRANSFORM HAMILTONIAN INTO SCR:
IOFF1 = N*NRON
call DGEMM_('N','N',N,NRON,N,One,HMAT,NDIM,VEC,NDIM,Zero,SCR,N)
call DGEMM_('T','N',NRON,NRON,N,One,VEC,NDIM,SCR,N,Zero,SCR(IOFF1+1),NRON)
! COPY TRANSFORMED HMAT INTO TRIANGULAR STORAGE IN SCR:
IFROM = IOFF1+1
ITO = 1
do I=1,NRON
  call DCOPY_(I,SCR(IFROM),1,SCR(ITO),1)
  ITO = ITO+I
  IFROM = IFROM+NRON
end do
! DIAGONALIZE:
call Jacob(SCR,VEC,NRON,NDIM)
! COPY EIGENVALUES INTO EVAL:
II = 0
do I=1,NRON
  II = II+I
  EVAL(I) = SCR(II)
end do

return

end subroutine SECULAR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mktempanam()
! this routine prepares names for TEMP and files as
! TEMP001 - TEMPmbas and stores them into
! tmpnam and tmanam arrays (mbas-maximum number of basis functions)
!
! variables used:
! tmpnam - array of TEMP file names (imported from ccsort_global)
! this routine (I)

use ccsort_global, only: lunpublic, mbas, tmpnam
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: itemp, k1, lun

lun = lunpublic
call molcas_open(lun,'TEMP000')
!open(unit=lun,file='TEMP000')

do k1=1,mbas
  if (k1 < 10) then
    write(lun,99) k1
  else if (k1 < 100) then
    write(lun,199) k1
  else
    write(lun,299) k1
  end if
end do

rewind(lun)

do itemp=1,mbas
  read(lun,599) tmpnam(itemp)
end do

rewind(lun)
write(lun,*) ' File scratched'
close(lun)

return

99 format('TEMP00',i1)
199 format('TEMP0',i2)
299 format('TEMP',i3)
599 format(a7)

end subroutine mktempanam

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Per-Olof Widmark                            *
************************************************************************
************************************************************************
*                                                                      *
*                             A I X - I / O                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* rc=AixOpn(Handle,FileName)                                           *
*                                                                      *
* A file is opened for read/write operations. If the file does not     *
* exist it is automatically created.                                   *
*                                                                      *
* Input:  FileName - A character string specifying a complete path     *
*                    name or relative path name for the file. The      *
*                    name must be shorter than 128 characters.         *
*                                                                      *
* Output: Handle   - When a file is sucessfully opened, a unique file  *
*                    id is supplied by the routine. This is used for   *
*                    specifying the file to other routines.            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          S&TC, ACIS, IBM Sweden                                      *
* Written: November 1990                                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* History:                                                             *
* 911021 - If return code is 13 when opening file, try to open it as a *
*          read only file. Per-Olof Widmark.                           *
* 931217 - Flags obtained from system calls.                           *
* 010710 - Change using iRand to incremental number                    *
* 120304 - Use handle for the passing of 'Lu' value needed by FiM      *
*                                                                      *
************************************************************************
      Integer Function AixOpn(handle,name,translate)
      Implicit Integer (a-z)
#include "switch.fh"
#include "ctl.fh"
      Character*(*) name
      Character*256 tmp
      Logical Translate
c      Integer Length,Prog_Length
      Integer StrnLn
      External StrnLn
      Character*256 tmp1
      Character*80 ErrTxt
      External Get_Progname
      Character*100 Get_Progname
      save NVV
      data NVV /666/
*----------------------------------------------------------------------*
* Entry to AixOpn                                                      *
*----------------------------------------------------------------------*
      AixOpn=0
*----------------------------------------------------------------------*
* Check if slot in table is available                                  *
*----------------------------------------------------------------------*
      n=1
100   If(CtlBlk(pStat,n).ne.0) Then
         n=n+1
         If(n.gt.MxFile) Then
            AixOpn=eTmF
            Call SysWarnMsg('Aixopn','Too many opened files\n',
     *      'try to increase MxFile')
            Return
         End If
         Go To 100
      End If
      nFile=n
*----------------------------------------------------------------------*
* Strip file name and append string terminator                         *
*----------------------------------------------------------------------*
      n=Len(name)
200   If(name(n:n).eq.' ') Then
         n=n-1
         If(n.le.0) Then
            AixOpn=eBlNme
            Return
         End If
         Go To 200
      End If
      n=n+1
      If(n.ge.Len(tmp)) Then
         AixOpn=eTlFn
         Return
      End If
      tmp=name
      tmp(n:n)=Char(0)
*----------------------------------------------------------------------*
* Attempt to open file.                                                *
*----------------------------------------------------------------------*
      rc = 0
      tmp1=tmp
      ltmp=StrnLn(tmp1)
      if(translate) then
        call PrgmTranslate(tmp1,tmp,ltmp)
      endif
c       write(*,*) 'DEBUG AIXOPN: what would happen ',tmp(1:ltmp),'<'
       tmp=tmp(1:ltmp)
c
c        print *,'in=',tmp1
c        print *,'len=',ltmp
c        print *,'res=',tmp
      tmp(ltmp+1:ltmp+1)=Char(0)
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      If(handle.eq.0) Then
         rc=c_open(tmp)
      Else
         rc=c_FimOpen(tmp,handle)
         If(rc.lt.0) Then
            rc=-rc
            AixOpn=eFiMFo
         End If
      End If
      If(handle.eq.0) Then
#else
      rc=c_open(tmp)
#endif
      If(rc.lt.0) Then
         rc=AixErr(ErrTxt)
        Call SysWarnFileMsg('AixOpn',name,
     *            'MSG: open',ErrTxt)
      call SysPutsEnd()
      Call Abend()
      End If
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
      End If
#endif
      desc=rc
*----------------------------------------------------------------------*
* Attempt sucessful, update control blocks.                            *
*----------------------------------------------------------------------*
c      handle=iRand()
       NVV=NVV+100
       handle=NVV
      CtlBlk(pHndle,nFile)=handle
      CtlBlk(pDesc ,nFile)=desc
      CtlBlk(pStat ,nFile)=1
      CtlBlk(pWhere,nFile)=0
      FCtlBlk(nFile)=name
*----------------------------------------------------------------------*
* Finished so return to caller                                         *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine oohess_cvb(orbs,civecp,civbs,civb,
     >   orbinv,sorbs,owrk,
     >   grad2,gradx,hessorb,hesst)
c  Evaluate "cheap" orbital <-> orbital part of hessian :
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "fx_cvb.fh"
      dimension orbs(norb,norb)
      dimension civecp(ndet),civbs(ndet),civb(ndet)
      dimension orbinv(norb,norb),sorbs(norb,norb),owrk(norb,norb)
      dimension grad2(npr),gradx(norb,norb)
      dimension hessorb(nprorb,nprorb)
      dimension hesst(norb*norb,norb*norb)

      if(icrit.eq.1)then
        oaa2_use=oaa2
        aa1_use=aa1
      elseif(icrit.eq.2)then
        oaa2_use=f2
        aa1_use=f1
      endif

      call fzero(hessorb,nprorb*nprorb)
      if(icrit.eq.1.and..not.(proj.or.projcas))then
        call dev2b_cvb(civbs,civecp,civb,hessorb,hesst,
     >    oaa2_use,aa1_use,gradx,grad2)

        call mxattb_cvb(orbs,orbs,norb,norb,norb,sorbs)
        call fmove_cvb(sorbs,orbinv,norb*norb)
        call mxinv_cvb(orbinv,norb)

        do 100 jorb=1,norb
        do 101 iorb=1,norb
        iprm=iorb+(jorb-1)*norb
        call mxatb_cvb(orbinv,hesst(1,iprm),norb,norb,norb,owrk)
        call mxatb_cvb(owrk,sorbs,norb,norb,norb,hesst(1,iprm))
101     continue
100     continue
        iprm1=0
        do 200 iorb=1,norb
        do 201 jorb=1,norb
        if(jorb.eq.iorb)goto 201
        iprm1=iprm1+1
        ifr1=jorb+(iorb-1)*norb
        iprm2=0
        do 300 korb=1,norb
        do 301 lorb=1,norb
        if(lorb.eq.korb)goto 301
        iprm2=iprm2+1
        ifr2=korb+(lorb-1)*norb
        if(iprm2.le.iprm1)then
          hessorb(iprm2,iprm1)=hessorb(iprm2,iprm1)+
     >      oaa2_use*hesst(ifr2,ifr1)
          hessorb(iprm1,iprm2)=hessorb(iprm2,iprm1)
        endif
301     continue
300     continue
201     continue
200     continue
      elseif(icrit.eq.1)then
        call dev2a_cvb(civbs,civecp,civb,hessorb,oaa2_use,aa1_use)
      else
        call cidaxpy_cvb(-ww/ovraa,civbs,civecp)
        call cizero_cvb(civbs)
        call dev2c_cvb(civecp,civb,hessorb,aa1_use)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,2015, Roland Lindh                                *
*               2015, Lasse Kragh Soerensen                            *
************************************************************************
      SubRoutine Util3(Beta,nZeta,Final,la,lb,Slalbp,Slalb,Slalbm)
************************************************************************
*                                                                      *
* Object: to assemble the orbital magnetic quadrupole integrals from   *
*         the derivative integrals and dipole integrals.               *
*                                                                      *
*     Author: Roland Lindh, Lasse Kragh Soerensen                      *
*             Dept. of Theoretical Chemistry,                          *
*             University of Uppsala, SWEDEN                            *
*             February '15                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"

      Real*8  Final (nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,9),
     &        Slalbp(nZeta,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2,6),
     &        Slalb (nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,3),
     &        Slalbm(nZeta,(la+1)*(la+2)/2, lb   *(lb+1)/2,6),
     &        Beta(nZeta)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Character*80 Label
#endif
!
! Notice CmbnMP has just 6 components instead of 9!!! (automatically assumes symmetry) Well fuck you CmbnMP
! This means Slalbp and Slalbm in reality only have 6 components....
! XX = 1, XY=YX=2, XZ=ZX=3, YY=4, YZ=ZY=5 and ZZ=6
! There are only six components since zy d/di = yz d/di
! We still keep the 9 components in final
!
*
*     Statement function for cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
#ifdef _DEBUGPRINT_
      nElem(ix) = (ix+1)*(ix+2)/2
#endif
*
#ifdef _DEBUGPRINT_
       Write (6,*) ' In Util3 la,lb=',la,lb
       Call RecPrt('Beta',' ',Beta,nZeta,1)
       Do ia = 1, nElem(la)
          Do ib = 1, nElem(lb+1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalbp(',ia,',',ib,'xx)'
             Call RecPrt(Label,' ',Slalbp(1,ia,ib,1),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalbp(',ia,',',ib,'xy)'
             Call RecPrt(Label,' ',Slalbp(1,ia,ib,2),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalbp(',ia,',',ib,'xz)'
             Call RecPrt(Label,' ',Slalbp(1,ia,ib,3),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalbp(',ia,',',ib,'yx)'
             Call RecPrt(Label,' ',Slalbp(1,ia,ib,2),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalbp(',ia,',',ib,'yy)'
             Call RecPrt(Label,' ',Slalbp(1,ia,ib,4),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalbp(',ia,',',ib,'yz)'
             Call RecPrt(Label,' ',Slalbp(1,ia,ib,5),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalbp(',ia,',',ib,'zx)'
             Call RecPrt(Label,' ',Slalbp(1,ia,ib,3),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalbp(',ia,',',ib,'zy)'
             Call RecPrt(Label,' ',Slalbp(1,ia,ib,5),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalbp(',ia,',',ib,'zz)'
             Call RecPrt(Label,' ',Slalbp(1,ia,ib,6),nZeta,1)
          End Do
       End Do
       Do ia = 1, nElem(la)
          Do ib = 1, nElem(lb)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalb (',ia,',',ib,'x)'
             Call RecPrt(Label,' ',Slalb (1,ia,ib,1),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalb (',ia,',',ib,'y)'
             Call RecPrt(Label,' ',Slalb (1,ia,ib,2),nZeta,1)
             Write (Label,'(A,I2,A,I2,A)')
     &              ' Slalb (',ia,',',ib,'z)'
             Call RecPrt(Label,' ',Slalb (1,ia,ib,3),nZeta,1)
          End Do
       End Do
       If (lb.gt.0) Then
          Do ia = 1, nElem(la)
             Do ib = 1, nElem(lb-1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbm(',ia,',',ib,'xx)'
                Call RecPrt(Label,' ',Slalbm(1,ia,ib,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbm(',ia,',',ib,'xy)'
                Call RecPrt(Label,' ',Slalbm(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbm(',ia,',',ib,'xz)'
                Call RecPrt(Label,' ',Slalbm(1,ia,ib,3),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbm(',ia,',',ib,'yx)'
                Call RecPrt(Label,' ',Slalbm(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbm(',ia,',',ib,'yy)'
                Call RecPrt(Label,' ',Slalbm(1,ia,ib,4),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbm(',ia,',',ib,'yz)'
                Call RecPrt(Label,' ',Slalbm(1,ia,ib,5),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbm(',ia,',',ib,'zx)'
                Call RecPrt(Label,' ',Slalbm(1,ia,ib,3),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbm(',ia,',',ib,'zy)'
                Call RecPrt(Label,' ',Slalbm(1,ia,ib,5),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbm(',ia,',',ib,'zz)'
                Call RecPrt(Label,' ',Slalbm(1,ia,ib,6),nZeta,1)
             End Do
          End Do
       End If
#endif
*
      Do 10 ixa = la, 0, -1
         Do 11 iya = la-ixa, 0, -1
            iza = la-ixa-iya
            ipa = Ind(la,ixa,iza)
*
      Do 20 ixb = lb, 0, -1
         Do 21 iyb = lb-ixb, 0, -1
            izb = lb-ixb-iyb
            ipb = Ind(lb,ixb,izb)
*
            Do 30 iZeta = 1, nZeta
               temp_xx = Two*Beta(iZeta) * (
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),2)
     &                 -Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb  ),3) )
               temp_xy = Two*Beta(iZeta) * (
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),4)
     &                 -Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb  ),5) )
               temp_xz = Two*Beta(iZeta) * (
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),5)
     &                 -Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb  ),6) )
               temp_yx = Two*Beta(iZeta) * (
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),3)
     &                 -Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),1) )
               temp_yy = Two*Beta(iZeta) * (
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),5)
     &                 -Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),2) )
               temp_yz = Two*Beta(iZeta) * (
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),6)
     &                 -Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),3) )
               temp_zx = Two*Beta(iZeta) * (
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb  ),1)
     &                 -Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),2) )
               temp_zy = Two*Beta(iZeta) * (
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb  ),2)
     &                 -Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),4) )
               temp_zz = Two*Beta(iZeta) * (
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb  ),3)
     &                 -Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),5) )
*
               temp_x = Slalb (iZeta,ipa,Ind(lb,ixb,izb),1)
               temp_y = Slalb (iZeta,ipa,Ind(lb,ixb,izb),2)
               temp_z = Slalb (iZeta,ipa,Ind(lb,ixb,izb),3)
*
*              xx term
               Final(iZeta,ipa,ipb,1) = Two * temp_xx
*              xy term
               Final(iZeta,ipa,ipb,2) = Two * temp_xy - temp_z
*              xz term
               Final(iZeta,ipa,ipb,3) = Two * temp_xz + temp_y
*              yx term
               Final(iZeta,ipa,ipb,4) = Two * temp_yx + temp_z
*              yy term
               Final(iZeta,ipa,ipb,5) = Two * temp_yy
*              yz term
               Final(iZeta,ipa,ipb,6) = Two * temp_yz - temp_x
*              zx term
               Final(iZeta,ipa,ipb,7) = Two * temp_zx - temp_y
*              zy term
               Final(iZeta,ipa,ipb,8) = Two * temp_zy + temp_x
*              zz term
               Final(iZeta,ipa,ipb,9) = Two * temp_zz
 30         Continue
*
            If (ixb.gt.0) Then
               Do 31 iZeta = 1, nZeta
               temp_yx = Dble(ixb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),3)
               temp_yy = Dble(ixb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),5)
               temp_yz = Dble(ixb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),6)
               temp_zx =-Dble(ixb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),2)
               temp_zy =-Dble(ixb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),4)
               temp_zz =-Dble(ixb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),5)
*
               Final(iZeta,ipa,ipb,4) = Final(iZeta,ipa,ipb,4)
     &                                                   + Two * temp_yx
               Final(iZeta,ipa,ipb,5) = Final(iZeta,ipa,ipb,5)
     &                                                   + Two * temp_yy
               Final(iZeta,ipa,ipb,6) = Final(iZeta,ipa,ipb,6)
     &                                                   + Two * temp_yz
               Final(iZeta,ipa,ipb,7) = Final(iZeta,ipa,ipb,7)
     &                                                   + Two * temp_zx
               Final(iZeta,ipa,ipb,8) = Final(iZeta,ipa,ipb,8)
     &                                                   + Two * temp_zy
               Final(iZeta,ipa,ipb,9) = Final(iZeta,ipa,ipb,9)
     &                                                   + Two * temp_zz
 31            Continue
            End If
*
            If (iyb.gt.0) Then
               Do 32 iZeta = 1, nZeta
               temp_xx =-Dble(iyb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb  ),3)
               temp_xy =-Dble(iyb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb  ),5)
               temp_xz =-Dble(iyb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb  ),6)
               temp_zx = Dble(iyb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb  ),1)
               temp_zy = Dble(iyb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb  ),2)
               temp_zz = Dble(iyb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb  ),3)
*
               Final(iZeta,ipa,ipb,1) = Final(iZeta,ipa,ipb,1)
     &                                                   + Two * temp_xx
               Final(iZeta,ipa,ipb,2) = Final(iZeta,ipa,ipb,2)
     &                                                   + Two * temp_xy
               Final(iZeta,ipa,ipb,3) = Final(iZeta,ipa,ipb,3)
     &                                                   + Two * temp_xz
               Final(iZeta,ipa,ipb,7) = Final(iZeta,ipa,ipb,7)
     &                                                   + Two * temp_zx
               Final(iZeta,ipa,ipb,8) = Final(iZeta,ipa,ipb,8)
     &                                                   + Two * temp_zy
               Final(iZeta,ipa,ipb,9) = Final(iZeta,ipa,ipb,9)
     &                                                   + Two * temp_zz
*
 32            Continue
            End If
*
            If (izb.gt.0) Then
               Do 33 iZeta = 1, nZeta
               temp_xx = Dble(izb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),2)
               temp_xy = Dble(izb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),4)
               temp_xz = Dble(izb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),5)
               temp_yx =-Dble(izb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),1)
               temp_yy =-Dble(izb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),2)
               temp_yz =-Dble(izb) *
     &                  Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),3)
*
               Final(iZeta,ipa,ipb,1) = Final(iZeta,ipa,ipb,1)
     &                                                   + Two * temp_xx
               Final(iZeta,ipa,ipb,2) = Final(iZeta,ipa,ipb,2)
     &                                                   + Two * temp_xy
               Final(iZeta,ipa,ipb,3) = Final(iZeta,ipa,ipb,3)
     &                                                   + Two * temp_xz
               Final(iZeta,ipa,ipb,4) = Final(iZeta,ipa,ipb,4)
     &                                                   + Two * temp_yx
               Final(iZeta,ipa,ipb,5) = Final(iZeta,ipa,ipb,5)
     &                                                   + Two * temp_yy
               Final(iZeta,ipa,ipb,6) = Final(iZeta,ipa,ipb,6)
     &                                                   + Two * temp_yz
 33            Continue
            End If
*
 21      Continue
 20   Continue
*
 11      Continue
 10   Continue
*
#ifdef _DEBUGPRINT_
          Write (6,*) ' In Util3 la,lb=',la,lb
          Do 300 iElem = 1, nElem(la)
             Do 310 jElem = 1, nElem(lb)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',xx) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',xy) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',xz) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,3),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',yx) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,4),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',yy) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,5),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',yz) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,6),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',zx) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,7),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',zy) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,8),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',zz) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,9),nZeta,1)
 310         Continue
 300      Continue
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine asonc7_cvb(c,axc,dum1,nvec,nprm)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension c(nprm,nvec),axc(nprm,nvec)
      save igrad,iter,ipp
      save thresh
      data thresh/1d-15/

      iter=iter+1
      if(ipp.ge.2)then
        write(6,'(/,a,i5,a,f10.3,a)')' Davidson iteration',iter,
     >    ' at',tim_cvb(cpu0),' CPU seconds'
        write(6,'(a)')
     >    ' -----------------------------------------------'
      endif

      do 100 ivec=1,nvec
      axc(1,ivec)=ddot_(nprm-1,work(igrad),1,c(2,ivec),1)
      call fmove_cvb(c(2,ivec),axc(2,ivec),nprm-1)
c  Save Hessian application (& DNRM2 call) whenever possible :
c  (C assumed to be normalized)
      if(abs(abs(c(1,ivec))-one).gt.thresh)then
        call hess_cvb(axc(2,ivec))
      elseif(dnrm2_(nprm-1,axc(2,ivec),1).gt.thresh)then
        call hess_cvb(axc(2,ivec))
      endif
      call daxpy_(nprm-1,c(1,ivec),work(igrad),1,axc(2,ivec),1)
      call ddproj_cvb(axc(2,ivec),nprm-1)
100   continue
      return
      entry asonc7init_cvb(igradinp,ippinp)
      iter=0
      igrad=igradinp
      ipp=ippinp
      call orthcvb_init_cvb()
      return
c Avoid unused argument warnings
      if (.false.) call Unused_real(dum1)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grc43C(a,b,c,mvec,ssa,ssb,pbar,ix)

use ccsd_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
type(Map_Type), intent(in) :: a, b
type(Map_Type), intent(inout) :: c
integer(kind=iwp), intent(out) :: mvec(4096,7)
integer(kind=iwp), intent(in) :: ssa, ssb, pbar
integer(kind=iwp), intent(inout) :: ix
integer(kind=iwp) :: ia, ib, ic, nhelp1, nhelp2, nhelp21, nhelp22, nhelp3, nhelp4, nhelp41, nhelp42, nsyma2, ntest1, ntest2, &
                     posct, sa1, sa12, sa123, sa2, sa3, sa4, sb1, sb12, sb2, sb3

!1*

if (pbar == 1) then

  ! structure A(p,qrs)*B(qrs)=C(p)
  ! implemented in grc43y

else if (pbar == 2) then

  ! structure A(pq,rs)*B(rs,t)=C(pq,t)

  !1.1 define limitations - p>q,r,s must be tested - ntest1
  !                       - p,q,r>s must be tested - ntest2

  if ((a%d(0,6) == 1) .or. (a%d(0,6) == 4)) then
    ntest1 = 1
  else
    ntest1 = 0
  end if

  if ((a%d(0,6) == 3) .or. (a%d(0,6) == 4)) then
    ntest2 = 1
  else
    ntest2 = 0
  end if

  !1.0 prepare c%d,c%i

  call grc0(3,ntest1,a%d(0,1),a%d(0,2),b%d(0,3),0,mmul(ssa,ssb),posct,c)

  !1.2 def symm states and test the limitations

  ix = 1
  do sa1=1,nsym
    if (ntest1 == 1) then
      nsyma2 = sa1
    else
      nsyma2 = nsym
    end if

    do sa2=1,nsyma2
      sa12 = mmul(sa1,sa2)

      do sa3=1,nsym
        sa123 = mmul(sa12,sa3)
        sb1 = sa3

        sa4 = mmul(ssa,sa123)
        sb2 = sa4
        sb12 = mmul(sb1,sb2)
        ! Meggie out
        if ((ntest2 == 1) .and. (sa3 < sa4)) cycle

        sb3 = mmul(ssb,sb12)

        !1.3 def mvec,c%d and c%i

        ia = a%i(sa1,sa2,sa3)
        ib = b%i(sb1,sb2,1)
        ic = c%i(sa1,sa2,1)

        ! yes/no
        if ((a%d(ia,2) <= 0) .or. (b%d(ib,2) <= 0)) cycle
        nhelp1 = 1

        ! rowA
        nhelp21 = dimm(a%d(0,1),sa1)
        nhelp22 = dimm(a%d(0,2),sa2)
        if ((ntest1 == 1) .and. (sa1 == sa2)) then
          nhelp2 = nhelp21*(nhelp21-1)/2
        else
          nhelp2 = nhelp21*nhelp22
        end if

        ! colB
        nhelp3 = dimm(b%d(0,3),sb3)

        ! sum
        nhelp41 = dimm(a%d(0,2),sa2)
        nhelp42 = dimm(a%d(0,3),sa3)
        if ((ntest2 == 1) .and. (sa2 == sa3)) then
          nhelp4 = nhelp41*(nhelp41-1)
        else
          nhelp4 = nhelp41*nhelp42
        end if

        mvec(ix,1) = nhelp1
        mvec(ix,2) = a%d(ia,1)
        mvec(ix,3) = b%d(ib,1)
        mvec(ix,4) = c%d(ic,1)
        mvec(ix,5) = nhelp2
        mvec(ix,6) = nhelp4
        mvec(ix,7) = nhelp3

        ix = ix+1

      end do
    end do
  end do

end if
ix = ix-1

return

end subroutine grc43C

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine UATM(IOut,ICharg,NAt,NSfe,
     +                ToAng,Re,Alpha,C,IAn,NOrd,Chg,iPrint)
      Implicit real*8 (A-H,O-Z)
C
C New settings of radii for electrostatic cavity
C for HF/6-31(+)G* and ICOMP=4
C explicit values for C,N,O,F,S,Cl,Br,I, otherwise modified UFF radii
C
      Logical AlBond,OKUAH,OKCHG
C     Character AtSymb*2,AppNum*3,BCH*3,HH1*10,HH2*10,HY1*4,HY2*4,HY3*4
      Character AtSymb*2,         BCH*3,HH1*10,HH2*10,HY1*4,HY2*4,HY3*4
      Parameter (MxBond=12)

      Parameter (ISAX=1000)
      Dimension RE(*),C(3,NAt),IAn(*),NOrd(*),Chg(NAt)
      Dimension NBond(ISAX),IBond(MxBond,ISAX),IBtype(MxBond,ISAX)
      Dimension NTrBnd(ISAX),ITrBnd(MxBond,ISAX)
      Dimension ItrBtp(MxBond,ISAX)
      Dimension IHNum(ISAX),PBO(MxBond,ISAX)
      Dimension DHyb(ISAX),R0(0:7),Gamma(0:7),NOKUAH(20),Coeff(0:5)
      Dimension DX(ISAX),DAl(ISAX)
C     Save R0,Gamma,DRQM,DAlDon,DAlAcc,NOKUAH,Coeff
      Save R0,Gamma,DRQM,              NOKUAH,Coeff
      Data R0/0.0D+00,1.00D+00,1.50D+00,1.98D+00,2.08D+00,3*2.35D+00/
      Data Gamma/2*0.00D+00,9.00D-02,1.30D-01,4*1.50D-01/
C     Data DAlDon,DAlAcc,DRQM/2*1.0D-01,3.0D-01/
      Data               DRQM/          3.0D-01/
      Data NOKUAH/6,7,8,9,15,16,17,35,53,11*0/
      Data Coeff/1.0d+0,0.9d+0,0.6d+0,0.3d+0,0.1d+0,0.0d+0/
      BCH='sdt'
      HH1=' HHHHHHHHH'
      HH2='  23456789'
      HY1='*sss'
      HY2=' ppp'
      HY3='  23'
      Pi = 4.0d0*ATan(1.0d0)
C
C The number of explicitly parametrized atoms is NUAH and their atomic
C numbers are in NOKUAH
C
      NUAH=9
C
C find bonds
C
      OkChg = .False.
      AlBond=.False.
      call FndBnd(IOut,0,AlBond,ToAng,MxBond,NAt,
     +            IAn,C,NBond,IBond,IBtype,PBO,Re)
      NTotH=0
      Do 2010 IAt=1,NAt
       If(IAn(IAt).eq.1) NTotH=NTotH+1
       IHNum(IAt)=0
       NTrBnd(IAt)=0
       Do 2020 JJ=1,NBond(IAt)
        JHAT=IBond(JJ,IAT)
        If(IAn(JHAT).eq.1) then
         IHNum(IAt)=IHNum(IAt)+1
        Else
         NTrBnd(IAt)=NTrBnd(IAt)+1
         ITrBnd(NTrBnd(IAt),IAt)=JHAT
         ITrBtp(NTrBnd(IAt),IAt)=IBType(JJ,IAt)
        EndIf
 2020 continue
 2010 continue
      area=0.0d0
      do 2100 i1=1,nsfe
        iat=nord(i1)
        IEffbn=Min(5,NTrBnd(IAt))
        surf=4.0d0*Pi*re(I1)*re(I1)*coeff(IEffBn)
        area=area+surf
 2100 continue

      If (iPrint.gt.5) Then
         Write(iOut,*)
         Write(iOut,*)
         Write(iOut,'(6X,A)') 'Polarized Continuum Model Cavity'
         Write(iOut,'(6X,A)') '================================'
         Write(iOut,*)
         write(IOut,'(6X,'' Nord Group'','//
     $   '''  Hybr  Charge Alpha Radius            Bonded to'')')
      End If
C
C Assign Charge and Hybridization to atoms
C
      QTot=0.0D+00
      Do 2030 IAt=1,NAt
       OKUAH=.False.
       do 2040 iverif=1,NUAH
        if(IAN(IAT).eq.NOKUAH(IVerif)) OKUAH=.true.
 2040 continue
       DHYB(IAt)=HybNew(OKUAH,OKCHG,IAt,IAn,NBond,IBond,IBtype,PBO,
     $  Chg(IAt))
       QTot=QTot+Chg(IAt)
 2030 continue
C
C Verify and possibly correct charges
C
      If (QTot.ge.1.0D-05) Then
         IQTot=Int(QTot+1.0D-01)
*     Else If(QTot.lt.1.0D-05)
      Else
         IQtot=Int(QTot-1.0D-01)
      End If
      If(IQTot.ne.ICharg) then
        FrQ = DBLE(ICharg)/DBLE(NAt-NTotH)
        Do 2050 IAt=1,NAt
C         write(IOut,'(6X,'' Atom'',I3,'' Old Q='',F5.2,
C    >       '' New Q='',F5.2)') IAt,Chg(IAt),FrQ
          If(IAn(IAt).ne.1) Chg(IAt) = FrQ
 2050 continue
      EndIf
C Determine Re, Alpha
      NSfe = 0
      Do 2060 IAt=1,NAt
        DDHYb = 0.0D+00
        DRQ   = 0.0D+00
        DDX   = 0.0D+00
        IRX  = IRowAt(IAn(IAt))
        RX   = R0(IRX)
        GX   = Gamma(IRX)
        NH   = 0
        NHI  = 0
        DH   = 0.0D+00
        DAr  = 0.0D+00
        DId  = 0.0D+00
        DX(IAt)= 0.0D+00
        OKUAH=.False.
        do 2070 iverif=1,NUAH
         if(IAN(IAT).eq.NOKUAH(IVerif)) then
           OKUAH=.true.
           DX(IAt)=
     $      AtNear(IAt,IAn,NBond,IBond,DH,DId,DAr,Chg)
         endif
 2070 continue
        DAl(IAt)= DAr - DId
C
C retain only H atoms not bonded to OKUAH atoms
C
        IUSE=1
        IF(IAn(IAt).eq.1) IUSE=0
C
        If(IUSE.eq.1) then
           NSfe = NSfe + 1
           I1 = NSfe
           NOrd(I1) = IAt
           OKUAH=.False.
             Re(I1)=Pauling(IAn(IAt))
             IAddH=Min(3,IHNum(IAt))
             Re(I1)=Re(I1)+DBLE(IAddH)*Gx
             do 2080 iverif=1,NUAH
              if(IAN(IAT).eq.NOKUAH(IVerif)) OKUAH=.true.
 2080 continue
           If(.not.okuah) goto 10
           If(Chg(IAt).lt.-1.0D-02) then
             DRQ = CHg(IAt)*DrQM
             IF(IAn(IAt).eq.7) DrQ = Chg(IAT)*2.0D-01
           EndIf
           If(Chg(IAt).gt.4.0D-01) then
             If(IAn(IAt).eq.8)  DRQ = -Chg(IAt)*2.6D-01
             If(IAn(IAt).eq.15) DRQ = -Chg(IAt)*4.5D-01
             If(IAn(IAt).eq.16) DRQ = -Chg(IAt)*5.5D-01
           EndIf
           NHI=Int(DHyb(IAt))
           NH=IHNum(IAt)
           If(NHI.lt.3) then
             DDHyb = (4.0D+00-DHyb(IAt))*GX
             If(IAn(IAt).ne.6) DDHyb=DDHyb/2.0D+00
           EndIf
           DDX = GX*(DX(IAT) + DAl(IAt))
           Re(I1) = RX + DDX + DDHyb + DRQ
C protect for too small C atoms
           IF(IAn(IAT).eq.6.and.Re(I1).lt.1.5D+00) Re(I1)=1.5D+00
  10       NH=IHNum(IAt)
             JE=Min(4,NTrBnd(IAt))
             If (iPrint.gt.5)
     &          Write(IOut,'(6X,1X,I3,2X,A2,2A1,3X,3A1,2X,'//
     $        'F5.2,3X,F4.2,2X,F5.3,3X,6(1X,A2,A3,''['',A1,'']''))')
     $        IAt,AtSymb(IAn(IAt)),HH1(NH+1:NH+1),HH2(NH+1:NH+1),
     $        HY1(NHI+1:NHI+1),HY2(NHI+1:NHI+1),HY3(NHI+1:NHI+1),
     $        Chg(IAt),Alpha,Re(I1),
     $        (AtSymb(IAn(ITrBnd(J,IAt))),'   ',
     $        BCH(ITrBtp(J,IAt):ITrBtp(J,IAt)),J=1,JE)
             If(NTrBnd(IAt).le.4) goto 20
             JE=Min(8,NTrBnd(IAt))
             If (iPrint.gt.5)
     &         Write(IOut,'(6X,40X,4(1X,A2,A3,''['',A1,'']''))')
     $         (AtSymb(IAn(ITRBnd(JJ,IAt))),'   ',
     $         BCH(ITrBtp(JJ,IAt):ITrBtp(JJ,IAt)),JJ=5,JE)

             If(NTrBnd(IAt).le.8) goto 20
             JE=NTrBnd(IAt)
             If (iPrint.gt.5)
     &         Write(IOut,'(6X,40X,4(1X,A2,A3,''['',A1,'']''))')
     $         (AtSymb(IAn(ITRBnd(JJ,IAt))),'   ',
     $         BCH(ITrBtp(JJ,IAt):ITrBtp(JJ,IAt)),JJ=9,JE)
  20         continue
        EndIf
 2060 continue
      If (iPrint.gt.5) Then
         write(IOut,'(6X,1X,78(''-''))')
         write(IOut,*)
      End If
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function nMo(mIrr)
      use Symmetry_Info, only: nIrrep
      Implicit Integer (a-h,o-z)
#include "etwas.fh"
      nInt=0
      nA=0
      Do iS=0,nIrrep-1
       nA=nA+nAsh(is)
      End Do
      NMM=nA*(nA+1)/2
      nInt=nMM*(nMM+1)/2
      nMo=nInt
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(mIrr)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Untested(label)

implicit none
character(len=*), intent(in) :: label
#ifndef _DEVEL_
character(len=8) :: isdev
#endif

call WarningMessage(1,label//';This code is untested or experimental, and should be carefully verified.')
#ifndef _DEVEL_
isdev = ''
call getenvf('MOLCAS_ISDEV',isdev)
if (isdev == '') call abend()
#endif

end subroutine Untested

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DataSol(IDSolv)
! Database of optical and physical data for various solvent.

use Solvent_Data, only: Init_Solvent_Data, SolvData
use Constants, only: Zero, One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IDSolv
integer(kind=iwp) :: i
#include "rctfld.fh"

call Init_Solvent_Data()

!Tabs = SolvData(IDSolv)%Tabs
Eps = SolvData(IDSolv)%Eps
EpsInf = SolvData(IDSolv)%EpsInf
DerEps = SolvData(IDSolv)%DerEps
RSolv = SolvData(IDSolv)%RSolv
VMol = SolvData(IDSolv)%VMol
TCE = SolvData(IDSolv)%TCE
!STen = SolvData(IDSolv)%STen
!DSTen = SolvData(IDSolv)%DSTen
!CMF = SolvData(IDSolv)%CMF
! Atomic parameters for dispersion and repulsion
!Rho = SolvData(IDSolv)%Rho
if (size(SolvData(IDSolv)%Atoms) > MxA) then
  call WarningMessage(2,'DataSol: num. solv. atoms > MxA')
  call Abend()
end if
do i=1,size(SolvData(IDSolv)%Atoms)
  if (SolvData(IDSolv)%Atoms(i)%NTT == 0) then
    !NATyp = i-1
    exit
  end if
  NTT(i) = SolvData(IDSolv)%Atoms(i)%NTT
  RDiff(i) = SolvData(IDSolv)%Atoms(i)%RDiff
  KT(i) = SolvData(IDSolv)%Atoms(i)%KT
  RWT(i) = SolvData(IDSolv)%Atoms(i)%RWT
end do

! Use user specified value of the dielectric constant

if (Eps_User /= -One) Eps = Eps_User
if (EpsInf_User /= Zero) EpsInf = EpsInf_User

return

end subroutine DataSol

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1992, Per Ake Malmqvist                                *
************************************************************************
      SubRoutine SetUpR(nRys)
************************************************************************
*                                                                      *
* Object: to setup the coefficients for the Rys roots and weights.     *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             September '90                                            *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Cehmistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified to DaFile February '91                          *
*                                                                      *
*     Added: Call to READAB, P.-A. Malmqvist March 1992, to set up     *
*             the tables needed to calculate large-order roots and     *
*             weights on request.                                      *
************************************************************************
      use Her_RW
      use vRys_RW
      use Leg_RW
      implicit none
#include "real.fh"
#include "stdalloc.fh"
#include "status.fh"
#include "print.fh"
*
      integer :: nRys
*
      integer :: iRys, jRys
      integer :: MemHer, iHer, iOffR
*
      If (Allocated(iHerR2)) Then
         Call WarningMessage(2,
     &          'SetupR: Rys_Status is already active!')
         Call Abend()
      End If
*
#ifdef _RYS_SCRATCH_
      CALL SetAux(1.0D-16)
#endif
*
      CALL Read_ABData
*
      CALL Read_RysRW
*
*     Set up the square of roots and the weights for Hermite polynomials
*     We will only do this for the even numbered polynomials.
*
      MemHer=nRys*(nRys+1)/2
      Call mma_allocate(iHerR2,nRys,label='iHerR2')
      iHerR2(1)=1
      Call mma_allocate(iHerW2,nRys,label='iHerW2')
      iHerW2(1)=1
      Call mma_allocate(HerR2,MemHer,label='HerR2')
      Call mma_allocate(HerW2,MemHer,label='HerW2')
*
      If (2*nRys.gt.MaxHer) Then
         Call WarningMessage(2,'SetupR: 2*nRys>MaxHer')
         Call Abend()
      End If
      Do 110 iRys=1,nRys
         iHer=2*iRys
         iOffR=(iRys*(iRys-1))/2
         iHerR2(iRys) = iHerR2(1) + iOffR
         iHerW2(iRys) = iHerW2(1) + iOffR
         Do 105 jRys=0,iRys-1
            HerR2(iHerR2(iRys)+jRys) = HerR(iHerR(iHer)+iRys+jRys)**2
            HerW2(iHerW2(iRys)+jRys) = HerW(iHerW(iHer)+iRys+jRys)
 105     Continue
 110  Continue
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call TriPrt(' Hermite squared roots',' ',HerR2(iHerR2(1)),nRys)
      Call TriPrt(' Hermite weights      ',' ',HerW2(iHerW2(1)),nRys)
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2005  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE EQCTL1
      IMPLICIT REAL*8 (A-H,O-Z)
C On return, the following data sets will be defined and stored
C on LUSOLV.
C At position IVEC=IRHS, the RHS array, in SR representation.
C At position IVEC=IVECX, the solution array, in SR representation.
C At position IVEC=IVECR, the residual array, in SR representation.
C At position IVEC=IVECC, the solution array, in contravariant rep.
C At position IVEC=IVECC2, the solution array, in covariant repr.
C At position IVEC=IVECW, the RHS array, in contravariant repr.
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
      DIMENSION DUMMY(1),IDUM(1)

      IRHS  =1
      IVECX =2
      IVECR =3
      IVECC =4
      IVECC2=5
      IVECW =6

CSVC: MODVEC isn't used in the Cholesky version, and neither in the
C sigma routines any more. Probably only in MKRHS...
      MXSCT=1
      DO ICASE=1,NCASES
        DO ISYM=1,NSYM
          MODVEC(ISYM,ICASE)=0
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          NCOEF=NAS*NIS
          IF(NCOEF.GT.0) THEN
C Module lengths for reading/writing:
            MODVEC(ISYM,ICASE)=MAX(1,MIN(MXBLK/NAS,NIS))
            MXSCT=MAX(MXSCT,1+(NIS-1)/MODVEC(ISYM,ICASE))
          ENDIF
        END DO
      END DO
      NIDSCT=MXSCT*8*MXCASE*MXVEC
      CALL GETMEM('IDSCT','ALLO','INTE',LIDSCT,NIDSCT)

#ifdef _DEBUG
CSVC: when using Cholesky decomposition, the actual use of the RHS
C vector sizes is automatically controlled in RHSALL2. Furthermore, the
C sigma routines now use the full RHS size.
      IF (.NOT.IFCHOL) THEN
        WRITE(6,*)
        WRITE(6,*)' Size of vector buffers for coefficient arrays.'
        WRITE(6,*)' ICASE ISYM    NROW     NCOL     NBLK       Size'
        NVCMX=0
        DO ICASE=1,NCASES
          DO ISYM=1,NSYM
            NROW=NASUP(ISYM,ICASE)
            NCOL=MODVEC(ISYM,ICASE)
            NVC=NROW*NCOL
            NVCMX=MAX(NVCMX,NVC)
            NBLK=0
            IF(NVC.GT.0) NBLK=1+(NISUP(ISYM,ICASE)-1)/NCOL
            WRITE(6,'(2x,I2,3x,I2,3x,I16,3X,I16,3X,I16,3x,I16)')
     &                     ICASE,ISYM,NROW,NCOL,NBLK,NVC
          END DO
        END DO
        WRITE(6,*)
        WRITE(6,*)' Largest vector buffer size:',NVCMX
        WRITE(6,*)
      ELSE
        WRITE(6,*)
        WRITE(6,*)' Sizes of the coefficient arrays.'
        WRITE(6,'(2X,A4,2X,A4,2X,5X,A4,5X,2X,5X,A4,5X,2X,5X,A4,5X)')
     &          'CASE','SYM','NROW','NCOL','SIZE'
        NVCMX=0
        DO ICASE=1,NCASES
          DO ISYM=1,NSYM
            NROW=NASUP(ISYM,ICASE)
            NCOL=NISUP(ISYM,ICASE)
            NVC=NROW*NCOL
            NVCMX=MAX(NVCMX,NVC)
            WRITE(6,'(2x,I4,2x,I4,2x,I16,2X,I16,2X,I16)')
     &                     ICASE,ISYM,NROW,NCOL,NVC
          END DO
        END DO
        WRITE(6,*)
        WRITE(6,'(A,I14)')' Largest vector size: ',NVCMX
        WRITE(6,*)
      ENDIF
#endif

      IDV=0
      DO IVEC=1,MXVEC
        DO ICASE=1,NCASES
          DO ISYM=1,NSYM
            NAS=NASUP(ISYM,ICASE)
            NIS=NISUP(ISYM,ICASE)
C NINDEP() IS HERE SET PROVISIONALLY. IT WILL
C BE ADJUSTED FOR LINEAR DEPENDENCE LATER.
            NCOEF=NAS*NIS
            MXWRT=Max(1,NAS*MODVEC(ISYM,ICASE))
            NISCT=NCOEF/MXWRT+Min(1,Mod(NCOEF,MXWRT))
            LADDR=LIDSCT+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1)))
            IF (NISCT.eq.0) IWORK(LADDR)=IDV
            If (NISCT.gt.MXSCT) Then
              write(6,*) 'EQCTL1 : NISCT= ',NISCT,' > MXSCT= ',MXSCT
              write(6,*) 'Please, increase MXSCT in eqsolv.fh'
              write(6,*) 'Do not forget to recompile Molcas afterwards.'
              Call Abend()
            EndIf
            DO ISCT=1,NISCT
              LSTA=MXWRT*(ISCT-1)
              LENGTH=RtoI*MIN(NCOEF-LSTA,MXWRT)
              LADDR=LIDSCT-1+ISCT+MXSCT*(ISYM-1+8*
     &                         (ICASE-1+MXCASE*(IVEC-1)))
              IWORK(LADDR)=IDV
              CALL IDAFILE(LUSOLV,0,IDUM,LENGTH,IDV)
            END DO
          END DO
        END DO
      END DO

C IDSCT(ISCT,ISYM,ICASE,IVEC) now gives the disk address, on LUSOLV,
C to the ISCT section of the (ISYM,ICASE) block of a vector
C containing expansion C coefficients of excitation operators.
C IVEC=1..MXVEC enumerates the different vectors needed to solve
C the equations.
      IDS=0
      DO ICASE=1,NCASES
        DO ISYM=1,NSYM
          IDSMAT(ISYM,ICASE)=IDS
          NIN=NINDEP(ISYM,ICASE)
          IF(NIN.GT.0) THEN
            NAS=NASUP(ISYM,ICASE)
*           NS=(NAS*(NAS+1))/2
            NS=NAS**2
            IF(ICASE.EQ.12) NS=1
            IF(ICASE.EQ.13) NS=1
            CALL DDAFILE(LUSBT ,0,DUMMY,NS,IDS)
          END IF
        END DO
      END DO

C IDSMAT(ISYM,ICASE) gives the disk address on LUSBT to the
C (ISYM,ICASE) section of the overlap matrix for the basis
C of excitation wave function terms: those that result from
C the basic excitation operators acting on Psi0.
      DO ICASE=1,NCASES
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
*         NB=(NAS*(NAS+1))/2
          NB=NAS**2
          IF(ICASE.EQ.12) NB=1
          IF(ICASE.EQ.13) NB=1
          IDBMAT(ISYM,ICASE)=IDS
          NBD=NAS
          NID=NIS
          NT=NAS**2
          IF(ICASE.EQ.12) NT=1
          IF(ICASE.EQ.13) NT=1
          IDS1=IDS
         IF(NB.GT.0)then
         end if
          IF(NB.GT.0)CALL DDAFILE(LUSBT ,0,DUMMY,NB ,IDS1)
          IDS2=IDS
          IF(NBD.GT.0)CALL DDAFILE(LUSBT ,0,DUMMY,NBD,IDS2)
          IF(NID.GT.0)CALL DDAFILE(LUSBT ,0,DUMMY,NID,IDS2)
          IF(NBD.GT.0)CALL DDAFILE(LUSBT ,0,DUMMY,NBD,IDS2)
          IF(NID.GT.0)CALL DDAFILE(LUSBT ,0,DUMMY,NID,IDS2)
          IDTMAT(ISYM,ICASE)=IDS2
          IF(NT.GT.0)CALL DDAFILE(LUSBT ,0,DUMMY,NT,IDS2)
          IDSTMAT(ISYM,ICASE)=IDS2
          IF(NT.GT.0)CALL DDAFILE(LUSBT ,0,DUMMY,NT,IDS2)
          IDS=MAX(IDS1,IDS2)
        END DO
      END DO

C IDBMAT(ISYM,ICASE) is similar to IDSMAT() but gives disk address
C to the (ISYM,ICASE) diagonal block of matrix elements of H0
C over the excitation wave function terms.
C IDTMAT() similarly addresses transformation matrices that
C orthonormalize the S matrix blocks.

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine getIphInfo(JOBIPH,nconf,LROOTS,IADR15)
      Implicit Real*8 (a-h,o-z)
#include "rasdim.fh"
      Integer nFro(MxSym), nISh(MxSym), nASh(MxSym), nDel(MxSym),
     &        nBas(MxSym), iRoot(MxRoot),
     &        nRS1(MxSym), nRS2(MxSym), nRS3(MxSym)
      Character*(LENIN8) Name(mxOrb), Title(18,mxTit)
      Character*2 Header(72)
      Real*8 Weight(MxRoot)
      Dimension IADR15(*)
      IAD15=IADR15(1)
      CALL WR_RASSCF_Info(JOBIPH,2,IAD15,NACTEL,ISPIN,NSYM,LSYM,
     &            NFRO,NISH,NASH,NDEL,NBAS,MxSym,
     &            NAME,LENIN8*mxOrb,NCONF,HEADER,2*72,
     &            TITLE,4*18*mxTit,POTNUC,LROOTS,NROOTS,
     &            IROOT,MxRoot,NRS1,NRS2,NRS3,
     &            NHOLE1,NELEC3,IPT2,WEIGHT)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000-2016, Valera Veryazov                             *
************************************************************************
******************************************************************************
*                                                                            *
* Author:   Valera Veryazov 2000-2016                                        *
*           Theoretical Chemistry                                            *
*           Lund University                                                  *
*           Sweden                                                           *
*                                                                            *
******************************************************************************

      Subroutine WhichMolcas(Molcas)
c
c  if MOLCAS_STAMP='Alone'
c     get value of MOLCAS.
c
c
      Character*(*) Molcas
      Character Env*40
      Env='MOLCAS_STAMP'
*
      Molcas=' '
      Call getenvf(Env,Molcas)
      if (Molcas(1:1) .ne. 'A') then
      Molcas=' '
      Return
      endif
      Env='MOLCAS'
*
      Molcas=' '
      Call getenvf(Env,Molcas)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!***********************************************************************

subroutine XFdInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of nuclear attraction     *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, April '95                               *
!***********************************************************************

use external_centers, only: nXF, XF
use Phase_Info, only: iPhase
use Index_Functions, only: nTri3_Elem1, nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: i, iAnga(4), iChxyz, iDCRT(0:7), iDum, iFd, ii, iOrdOp, ip1, ip2, ip3, ipI, ipIn, iPrint, iRout, iStb(0:7), &
                     ix, iy, iz, jCoSet(8,8), jElem, kab, lab, labcd, lcd, lDCRT, LmbdT, mabMax, mabMin, mArr, mcdMax, mcdMin, &
                     nData, nDCRT, nFLOP, nMem, nOp, nStb, nT
real(kind=wp) :: C(3), CoorAC(3,2), Coori(3,4), Fact, Factx, Facty, Factz, TC(3)
logical(kind=iwp) :: NoLoop, NoSpecial
real(kind=wp), allocatable :: ZFd(:), ZRFd(:)
character(len=*), parameter :: ChOper(0:7) = ['E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz']
integer(kind=iwp), external :: iChAtm, NrOpr
logical(kind=iwp), external :: EQ
external TNAI, Fake, XCff2D, XRys2D

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(nHer)
unused_var(Ccoor)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 151
iPrint = nPrint(iRout)

rFinal(:,:,:,:) = Zero

call mma_allocate(ZFd,nTri_Elem1(nOrdOp),label='ZFd')
call mma_allocate(ZRFd,nTri_Elem1(nOrdOp),label='ZRFd')

! Loop over charges and dipole moments in the external field

nData = 3
do iOrdOp=0,nOrdOp

  iAnga(1) = la
  iAnga(2) = lb
  iAnga(3) = iOrdOp
  iAnga(4) = 0
  Coori(:,1) = A
  Coori(:,2) = RB
  mabMin = nTri3_Elem1(max(la,lb)-1)
  mabMax = nTri3_Elem1(la+lb)-1
  if (EQ(A,RB)) mabMin = nTri3_Elem1(la+lb-1)
  mcdMin = nTri3_Elem1(iOrdOp-1)
  mcdMax = nTri3_Elem1(iOrdOp)-1
  lab = (mabMax-mabMin+1)
  kab = nTri_Elem1(la)*nTri_Elem1(lb)
  lcd = (mcdMax-mcdMin+1)
  labcd = lab*lcd

  ! Compute FLOP's and size of work array which Hrr will use.

  call mHrr(la,lb,nFLOP,nMem)

  ! Distribute the work array

  ip2 = 1
  ip1 = ip2+nZeta*max(labcd,lcd*nMem)
  mArr = nArr-max(labcd,lcd*nMem)

  ! Find center to accumulate angular momentum on. (HRR)

  if (la >= lb) then
    CoorAC(:,1) = A
  else
    CoorAC(:,1) = RB
  end if

  ! Loop over centers of the external field.

  iDum = 0
  do iFd=1,nXF

    NoLoop = .true.
    do jElem=1,nTri_Elem1(iOrdOp)
      ZFd(jElem) = XF(nData+jElem,iFd)
      ! Divide quadrupole diagonal by 2 due to different normalisation
      if ((iOrdOp == 2) .and. ((jElem == 1) .or. (jElem == 4) .or. (jElem == 6))) ZFd(jElem) = ZFd(jElem)*Half
      NoLoop = NoLoop .and. (ZFd(jElem) == Zero)
    end do

    if (NoLoop) cycle
    ! Pick up the center coordinates
    C(1:3) = XF(1:3,iFd)

    if (iPrint >= 99) call RecPrt('C',' ',C,1,3)

    ! Generate stabilizer of C

    iChxyz = iChAtm(C)
    call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)

    !-Find the DCR for M and S

    call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    if (iPrint >= 99) then
      write(u6,*) ' m      =',nStabM
      write(u6,'(9A)') '(M)=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
      write(u6,*) ' s      =',nStb
      write(u6,'(9A)') '(S)=',(ChOper(iStb(ii)),ii=0,nStb-1)
      write(u6,*) ' LambdaT=',LmbdT
      write(u6,*) ' t      =',nDCRT
      write(u6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),ii=0,nDCRT-1)
    end if

    do lDCRT=0,nDCRT-1
      call OA(iDCRT(lDCRT),C,TC)

      jElem = 0
      do ix=iOrdOp,0,-1
        if (mod(ix,2) == 0) then
          Factx = One
        else
          Factx = real(iPhase(1,iDCRT(lDCRT)),kind=wp)
        end if
        do iy=iOrdOp-ix,0,-1
          if (mod(iy,2) == 0) then
            Facty = One
          else
            Facty = real(iPhase(2,iDCRT(lDCRT)),kind=wp)
          end if
          iz = iOrdOp-ix-iy
          if (mod(iz,2) == 0) then
            Factz = One
          else
            Factz = real(iPhase(3,iDCRT(lDCRT)),kind=wp)
          end if

          jElem = jElem+1
          ZRFd(jElem) = Factx*Facty*Factz*ZFd(jElem)
        end do
      end do

      CoorAC(:,2) = TC
      Coori(:,3) = TC
      Coori(:,4) = TC

      ! Compute integrals with the Rys quadrature.

      nT = nZeta
      NoSpecial = .true.
      call Rys(iAnga,nT,Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,rKappa,[One],Coori,Coori,CoorAC,mabmin,mabmax,mcdMin,mcdMax, &
               Array(ip1),mArr*nZeta,TNAI,Fake,XCff2D,XRys2D,NoSpecial)

      ! The integrals are now ordered as ijkl,e,f

      ! a) Change the order to f,ijkl,e
      ! b) Unfold e to ab, f,ijkl,ab
      ! c) Change the order back to ijkl,ab,f

      ! a)

      call DGeTMO(Array(ip1),nZeta*lab,nZeta*lab,lcd,Array(ip2),lcd)

      ! b) Use the HRR to unfold e to ab

      call HRR(la,lb,A,RB,Array(ip2),lcd*nZeta,nMem,ipIn)
      ip3 = ip2-1+ipIn

      ! c)

      call DGeTMO(Array(ip3),lcd,lcd,nZeta*kab,Array(ip1),nZeta*kab)

      ! Accumulate contributions to the symmetry adapted operator

      nOp = NrOpr(iDCRT(lDCRT))
      ipI = ip1

      do i=1,nTri_Elem1(iOrdOp)
        if (ZRFd(i) /= Zero) call SymAdO(Array(ipI),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,-Fact*ZRFd(i))
        ipI = ipI+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)
      end do

#     ifdef _DEBUGPRINT_
      write(u6,*) (Fact*ZFd(i),i=1,nTri_Elem1(iOrdOp))
      call RecPrt('Array(ip1)',' ',Array(ip1),nZeta,(la+1)*(la+2)/2*(lb+1)*(lb+2)/2*nTri_Elem1(iOrdOp))
      call RecPrt('rFinal',' ',rFinal,nZeta,(la+1)*(la+2)/2*(lb+1)*(lb+2)/2*nIC)
#     endif

    end do ! End loop over DCRs
  end do   ! iFd

  nData = nData+nTri_Elem1(iOrdOp)
end do     ! iOrdOp

call mma_deallocate(ZFd)
call mma_deallocate(ZRFd)

return

end subroutine XFdInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!***********************************************************************

subroutine read_rysrw()
!***********************************************************************
!                                                                      *
! Object: to setup the coefficients for the Rys roots and weights.     *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             September '90                                            *
!             Modified to DaFile February '91                          *
!***********************************************************************

use vRys_RW, only: Cff, ddx, iCffR, iCffW, iMap, ix0, Map, nMap, nMxRys, nx0, TMax, x0
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: i, io, iOff, iRys, lu_rysrw, mRys, nCff, nMap_Tot, nMem, nMem_Tot, nOrder, nx0_Tot
real(kind=wp) :: acc(size(iMap))
logical(kind=iwp) :: found_rysrw
character(len=*), parameter :: RYSRW_NAME = 'RYSRW'
integer(kind=iwp), external :: isFreeUnit

! Open file for data base

call f_Inquire(RYSRW_NAME,found_rysrw)
if (.not. found_rysrw) then
  call warningmessage(2,' the rysrw file does not exist.')
  call abend()
end if
lu_rysrw = isFreeUnit(22)
call molcas_open(lu_rysrw,RYSRW_NAME)

! Read initial data

io = 1
do while (io /= 0)
  read(lu_rysrw,*,iostat=io) mRys,nOrder
end do
if (mRys > size(iMap)) then
  call WarningMessage(2,' Database requires new code! Database and code are at incompatible levels!')
  call Abend()
end if
nMxRys = mRys
nCff = 2*(nOrder+1)
read(lu_rysrw,*) (Acc(i),i=1,mRys)
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' Reading tables for roots and weights of Rys poly.'
write(u6,*) ' Highest order is:',mRys
write(u6,*) ' Order of approximating polynomial:',nOrder
write(u6,*) ' Relative accuracy of computed values:',(Acc(i),i=1,mRys)
write(u6,*)
#endif

! Read value of T at which asymptotic formulas will be used

call mma_allocate(TMax,mRys,label='TMax')
read(lu_rysrw,*) (TMax(i),i=1,mRys)
#ifdef _DEBUGPRINT_
call RecPrt(' Tmax',' ',Tmax,mRys,1)
#endif

! Read increment of tables

call mma_allocate(ddx,mRys,label='ddx')
read(lu_rysrw,*) (ddx(i),i=1,mRys)
#ifdef _DEBUGPRINT_
call RecPrt(' ddx ',' ',ddx,mRys,1)
#endif

! Read size of map array

read(lu_rysrw,*) (nMap(i),i=1,mRys)
#ifdef _DEBUGPRINT_
write(u6,*) ' nMap=',nMap
#endif

! Read number of subranges

read(lu_rysrw,*) (nx0(i),i=1,mRys)
#ifdef _DEBUGPRINT_
write(u6,*) ' nx0=',nx0
#endif

! Read map array and x0 array for each order of Rys polynomials

nMap_Tot = 0
nx0_Tot = 0
do iRys=1,mRys
  iMap(iRys) = nMap_Tot+1
  nMap_Tot = nMap_Tot+nMap(iRys)
  ix0(iRys) = nx0_Tot+1
  nx0_Tot = nx0_Tot+nx0(iRys)
end do
call mma_allocate(Map,nMap_Tot,label='Map')
call mma_allocate(x0,nx0_Tot,label='x0')
do iRys=1,mRys
  iOff = iMap(iRys)-1
  read(lu_rysrw,*) (Map(i),i=iOff+1,iOff+nMap(iRys))

  iOff = ix0(iRys)-1
  read(lu_rysrw,*) (x0(i),i=iOff+1,iOff+nx0(iRys))
end do

! Allocate memory for coefficients

nMem_Tot = 0
do iRys=1,mRys
  iCffR(0,iRys) = nMem_Tot+1
  nMem = nx0(iRys)*iRys
  nMem_Tot = nMem_Tot+nCff*nMem
end do
call mma_allocate(Cff,nMem_Tot,label='Cff')
do iRys=1,mRys

  ! Read coefficients from file

  nMem = nx0(iRys)*iRys
  iCffR(1,iRys) = iCffR(0,iRys)+nMem
  iCffR(2,iRys) = iCffR(1,iRys)+nMem
  iCffR(3,iRys) = iCffR(2,iRys)+nMem
  iCffR(4,iRys) = iCffR(3,iRys)+nMem
  iCffR(5,iRys) = iCffR(4,iRys)+nMem
  iCffR(6,iRys) = iCffR(5,iRys)+nMem

  ICffW(0,iRys) = iCffR(6,iRys)+nMem
  iCffW(1,iRys) = iCffW(0,iRys)+nMem
  iCffW(2,iRys) = iCffW(1,iRys)+nMem
  iCffW(3,iRys) = iCffW(2,iRys)+nMem
  iCffW(4,iRys) = iCffW(3,iRys)+nMem
  iCffW(5,iRys) = iCffW(4,iRys)+nMem
  iCffW(6,iRys) = iCffW(5,iRys)+nMem

  iOff = iCffR(0,iRys)-1
  read(lu_rysrw,*) (Cff(i),i=iOff+1,iOff+nMem*nCff)

end do

close(lu_rysrw)

return
#ifdef _WARNING_WORKAROUND_
if (.false.) call Unusued_real_array(Acc)
#endif

end subroutine read_rysrw

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      Subroutine Fold_Mat(nSym,nBas,A,B)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Fold up symmetry blocked matrix A stored as SQUARE blocks        *
*     into TRIANGULAR matrices. The matrix A can be non-symmetric.     *
*     The input and output matrices CANNOT BE IDENTICAL !!!            *
*                                                                      *
*     calling arguments:                                               *
*     nSym    : input, integer                                         *
*               number of symmetry blocks                              *
*     nBas    : input, array of integers                               *
*               matrix dimension per symmetry block                    *
*     A       : input, array of real*8  (square storage)               *
*               Unfolded input matrix                                  *
*     B       : output, array of real*8 (triangular storage)           *
*               Folded output matrix                                   *
*                                                                      *
*----------------------------------------------------------------------*
*     Author:   F. Aquilante                                           *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension nBas(*) , A(*) , B(*)
*************************************
      iit(j) = j*(j+1)/2
*************************************
      ijt(i,j) = i*(i-1)/2 + j
*************************************
      iis(n,j) = n*(j-1) + j
*************************************
      ijs(n,i,j) = n*(j-1) + i
*************************************


      iOff1 = 0
      iOff2 = 0

      Do iSym=1,nSym

        Do j=1,nBas(iSym)

          B( iOff1 + iit(j) ) =  A( iOff2 + iis(nBas(iSym),j) )

          Do i=j+1,nBas(iSym)

            B( iOff1 + ijt(i,j) ) = A( iOff2 + ijs(nBas(iSym),i,j) )
     &                            + A( iOff2 + ijs(nBas(iSym),j,i) )

          End Do

        End Do

        iOff1 = iOff1 + iit(nBas(iSym))
        iOff2 = iOff2 + nBas(iSym)**2

      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Marcus Johansson                                 *
!***********************************************************************

subroutine fmsym_create_context(ctx)

use iso_c_binding, only: c_ptr
use Definitions, only: iwp

implicit none
type(c_ptr), intent(out) :: ctx
integer(kind=iwp) :: ret
interface
  subroutine cmsym_create_context(pctx,err) bind(C,name='cmsym_create_context_')
    use, intrinsic :: iso_c_binding, only: c_ptr
    use Definitions, only: MOLCAS_C_INT
    type(c_ptr), value :: pctx
    integer(kind=MOLCAS_C_INT) :: err
  end subroutine cmsym_create_context
end interface

! INT cmsym_create_context(msym_context *pctx, int *err)
call cmsym_create_context(ctx,ret)
if (ret /= 0) then
  call WarningMessage(2,'Failed to create symmetry context')
  call Abend()
end if

return

end subroutine fmsym_create_context

!***********************************************************************

subroutine fmsym_set_elements(ctx)

use, intrinsic :: iso_c_binding, only: c_ptr
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
type(c_ptr), intent(inout) :: ctx
integer(kind=iwp) :: nAtoms
real(kind=wp), allocatable :: Coord(:)

call Get_nAtoms_All(nAtoms)
call mma_allocate(Coord,3*nAtoms,label='Coord')
call Get_Coord_All(Coord,nAtoms)
call fmsym_set_ele_orb(ctx,nAtoms,Coord)
call mma_deallocate(Coord)

return

end subroutine fmsym_set_elements

!***********************************************************************

subroutine fmsym_release_context(ctx)

use iso_c_binding, only: c_ptr
use Definitions, only: iwp

implicit none
type(c_ptr), intent(inout) :: ctx
integer(kind=iwp) :: ret
interface
  function cmsym_release_context(pctx,err) bind(C,name='cmsym_release_context_')
    use, intrinsic :: iso_c_binding, only: c_ptr
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: cmsym_release_context
    type(c_ptr), value :: pctx
    integer(kind=MOLCAS_C_INT) :: err
  end function cmsym_release_context
end interface

! INT cmsym_release_context(msym_context *pctx, int*err)
ret = cmsym_release_context(ctx,ret)

return

end subroutine fmsym_release_context

!***********************************************************************

subroutine fmsym_set_ele_orb(ctx,nAtoms,Coord)

use iso_c_binding, only: c_ptr
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
type(c_ptr), intent(inout) :: ctx
integer(kind=iwp), intent(in) :: nAtoms
real(kind=wp), intent(in) :: Coord(3,nAtoms)
#include "LenIn.fh"
character(len=LenIn), allocatable :: AtomLabel(:)
integer(kind=iwp), allocatable :: basis_ids(:), nBas(:)
integer(kind=iwp) :: nSym, nMO, nCMO, iSym, ret
interface
  subroutine cmsym_set_elements(pctx,pel,puel,uelement,xyz,paol,basis_ids,err) bind(C,name='cmsym_set_elements_')
    use, intrinsic :: iso_c_binding, only: c_char, c_ptr
    use Definitions, only: MOLCAS_C_INT, MOLCAS_C_REAL
    type(c_ptr), value :: pctx
    integer(kind=MOLCAS_C_INT) :: pel, puel, paol, basis_ids(*), err
    character(kind=c_char) :: uelement(*)
    real(kind=MOLCAS_C_REAL) :: xyz(*)
  end subroutine cmsym_set_elements
end interface

call mma_allocate(AtomLabel,nAtoms,label='AtomLabel')
call Get_LblCnt_All(AtomLabel)
call Get_iScalar('nSym',nSym)
call mma_allocate(nBas,nSym,label='nBas')
call Get_iArray('nBas',nBas,nSym)

if (nSym /= 1) then
  call WarningMessage(2,'MSYM can only be used with group c1')
  call fmsym_release_context(ctx)
  call Abend()
end if

nMO = 0
nCMO = 0
do iSym=1,nSym
  nMO = nMO+nBas(iSym)
  nCMO = nCMO+nBas(iSym)**2
end do
call mma_deallocate(nBas)

call mma_allocate(basis_ids,4*nMO,label='basis_ids')
call Get_iArray('Basis IDs',basis_ids,4*nMO)
! INT cmsym_set_elements(msym_context *pctx, INT *pel, INT *puel, char *uelement, double xyz[][3], INT *paol, INT basis_ids[][4],
!                        int *err)
call cmsym_set_elements(ctx,nAtoms,(LENIN),AtomLabel,Coord,nMO,basis_ids,ret)
call mma_deallocate(basis_ids)
call mma_deallocate(AtomLabel)
call xflush(u6)
if (ret /= 0) then
  call WarningMessage(2,'Failed to set elements')
  call fmsym_release_context(ctx)
  call Abend()
end if

return

end subroutine fmsym_set_ele_orb

!***********************************************************************

subroutine fmsym_find_symmetry(ctx)

use iso_c_binding, only: c_ptr
use Definitions, only: iwp, u6

implicit none
type(c_ptr), intent(inout) :: ctx
integer(kind=iwp) :: ret
character(len=6) :: PGName

interface
  subroutine cmsym_find_symmetry(pctx,pgname,err) bind(C,name='cmsym_find_symmetry_')
    use, intrinsic :: iso_c_binding, only: c_char, c_ptr
    use Definitions, only: MOLCAS_C_INT
    type(c_ptr), value :: pctx
    character(kind=c_char) :: pgname(6)
    integer(kind=MOLCAS_C_INT) :: err
  end subroutine cmsym_find_symmetry
end interface

! INT cmsym_find_symmetry(msym_context *pctx, char pgname[6], int *err)
call cmsym_find_symmetry(ctx,PGName,ret)
if (ret /= 0) then
  call WarningMessage(2,'Failed to find symmetry')
  call fmsym_release_context(ctx)
  call Abend()
end if
write(u6,*) 'Found Point Group:'
write(u6,*) PGName

return

end subroutine fmsym_find_symmetry

!***********************************************************************

subroutine fmsym_symmetrize_molecule(ctx)

use iso_c_binding, only: c_ptr
use Definitions, only: iwp

implicit none
type(c_ptr), intent(inout) :: ctx
integer(kind=iwp) :: lFN, ret
character(len=256) :: FN
interface
  subroutine cmsym_symmetrize_molecule(pctx,outfile,err) bind(C,name='cmsym_symmetrize_molecule_')
    use, intrinsic :: iso_c_binding, only: c_char, c_ptr
    use Definitions, only: MOLCAS_C_INT
    type(c_ptr), value :: pctx
    character(kind=c_char) :: outfile(*)
    integer(kind=MOLCAS_C_INT) :: err
  end subroutine cmsym_symmetrize_molecule
end interface

call PrgmTranslate('MSYMOUT',FN,lFN)
FN = FN(1:lFN)//char(0)
! INT cmsym_symmetrize_molecule(msym_context *pctx, char *outfile, INT *err)
call cmsym_symmetrize_molecule(ctx,FN,ret)
if (ret /= 0) then
  call WarningMessage(2,'Failed to symmetrize molecule')
  call fmsym_release_context(ctx)
  call Abend()
end if

return

end subroutine fmsym_symmetrize_molecule

!***********************************************************************

subroutine fmsym_generate_orbital_subspaces(ctx)

use iso_c_binding, only: c_ptr
#ifdef _HDF5_
use mh5, only: mh5_create_file, mh5_init_attr, mh5_create_dset_real, mh5_create_dset_int, mh5_create_dset_str, mh5_put_dset, &
               mh5_close_dset, mh5_close_file
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
type(c_ptr), intent(inout) :: ctx
integer(kind=iwp) :: IndT(7,8), iSym, nSym, nMO, nCMO, nIrr, LuOrb, ret
real(kind=wp) :: Dummy(1)
integer(kind=iwp), allocatable :: nBas(:), IrrIds(:), IrrInd(:)
character(len=80) :: Title
character(len=8), allocatable :: irrep_strings(:)
real(kind=wp), allocatable :: CAO(:), Occ(:)
#ifdef _HDF5_
integer(kind=iwp) :: fileid, dsetid
#endif
integer(kind=iwp), external :: isfreeunit
interface
  subroutine cmsym_generate_orbital_subspaces(pctx,l,c,irrep_ids,irrep_ind,nirreps,lbl,err) &
             bind(C,name='cmsym_generate_orbital_subspaces_')
    use, intrinsic :: iso_c_binding, only: c_char, c_ptr
    use Definitions, only: MOLCAS_C_INT, MOLCAS_C_REAL
    type(c_ptr), value :: pctx
    integer(kind=MOLCAS_C_INT) :: l, irrep_ids(l), irrep_ind(l), nirreps, err
    real(kind=MOLCAS_C_REAL) :: c(l,l)
    character(kind=c_char) :: lbl(8,l)
  end subroutine cmsym_generate_orbital_subspaces
end interface

call Get_iScalar('nSym',nSym)
call mma_allocate(nBas,nSym,label='nBas')
call Get_iArray('nBas',nBas,nSym)

nMO = 0
nCMO = 0
do iSym=1,nSym
  nMO = nMO+nBas(iSym)
  nCMO = nCMO+nBas(iSym)**2
end do

call mma_allocate(CAO,nCMO,label='CAO')
call mma_allocate(Occ,nMO,label='Occ')
call mma_allocate(IrrIds,nMO,label='IrrIds')
call mma_allocate(IrrInd,nMO,label='IrrInd')
call mma_allocate(irrep_strings,nMO,label='irrep_strings')

! INT cmsym_generate_orbital_subspaces(msym_context *pctx, INT *l, double c[*l][*l], INT irrep_ids[*l], INT irrep_ind[*l],
!                                      INT* nirreps, char lbl[*l][8], INT *err){
call cmsym_generate_orbital_subspaces(ctx,nMO,CAO,IrrIds,IrrInd,nIrr,irrep_strings,ret)
write(u6,*) 'Irrep indices='
write(u6,'(5i3)') IrrInd(:)
write(u6,*) 'Irrep ids='
write(u6,'(5i3)') IrrIds(:)

if (ret /= 0) then
  call WarningMessage(2,'Failed to generate SALCs')
  call fmsym_release_context(ctx)
  call Abend()
end if

Occ(:) = Zero

Title = 'Orbital Subspaces'
LuOrb = isfreeunit(50)
IndT(:,:) = 0
call WrVec('MSYMAORB',LuOrb,'CO',nSym,nBas,nBas,CAO,Occ,Dummy,IndT,Title)
#ifdef _HDF5_
fileid = mh5_create_file('MSYMH5')
call run2h5_molinfo(fileid)
call one2h5_ovlmat(fileid,nSym,nBas)
call one2h5_fckint(fileid,nSym,nBas)
! mocoef
dsetid = mh5_create_dset_real(fileid,'MO_VECTORS',1,[nCMO])
call mh5_init_attr(dsetid,'DESCRIPTION', &
                   'Coefficients of the SALCs as produced by MSYM, arranged as blocks of size [NBAS(i)**2], i=1,#irreps')
call mh5_put_dset(dsetid,CAO)
call mh5_close_dset(dsetid)
! mooc
dsetid = mh5_create_dset_real(fileid,'MO_OCCUPATIONS',1,[nMO])
call mh5_init_attr(dsetid,'DESCRIPTION', &
                   'Dummy occupation numbers arranged as blocks of size [NBAS(i)], i=1,#irreps')
call mh5_put_dset(dsetid,Occ)
call mh5_close_dset(dsetid)
! moene
dsetid = mh5_create_dset_real(fileid,'MO_ENERGIES',1,[nMO])
call mh5_init_attr(dsetid,'DESCRIPTION', &
                   'Dummy orbital energies arranged as blocks of size [NBAS(i)], i=1,#irreps')
call mh5_put_dset(dsetid,Occ)
call mh5_close_dset(dsetid)
! supsym
dsetid = mh5_create_dset_int(fileid,'SUPSYM_IRREP_IDS',1,[nMO])
call mh5_init_attr(dsetid,'DESCRIPTION', &
                   'Super-symmetry ids as produced by MSYM, arranged as blocks of size [NBAS(i)], i=1,#irreps')
call mh5_put_dset(dsetid,IrrIds)
call mh5_close_dset(dsetid)
dsetid = mh5_create_dset_int(fileid,'SUPSYM_IRREP_INDICES',1,[nMO])
call mh5_init_attr(dsetid,'DESCRIPTION', &
                   'Super-symmetry indices as produced by MSYM, arranged as blocks of size [NBAS(i)], i=1,#irreps')
call mh5_put_dset(dsetid,IrrInd)
call mh5_close_dset(dsetid)
! irrep_labels
dsetid = mh5_create_dset_str(fileid,'SUPSYM_IRREP_LABELS',1,[nIrr],8)
call mh5_init_attr(dsetid,'DESCRIPTION', &
                   'Super-symmetry labels as produced by MSYM, arranged as array of size i=1,#supsym_irreps')
call mh5_put_dset(dsetid,irrep_strings)
call mh5_close_dset(dsetid)
call mh5_close_file(fileid)
#endif

call mma_deallocate(nBas)
call mma_deallocate(CAO)
call mma_deallocate(Occ)
call mma_deallocate(IrrInd)
call mma_deallocate(IrrIds)
call mma_deallocate(irrep_strings)

return

end subroutine fmsym_generate_orbital_subspaces

!***********************************************************************

subroutine fmsym_symmetrize_orbitals(ctx,CIO)

use iso_c_binding, only: c_ptr
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
type(c_ptr), intent(inout) :: ctx
real(kind=wp), intent(inout) :: CIO(*)
integer(kind=iwp) :: iSym, nSym, nMO, nCMO, ret
integer(kind=iwp), allocatable :: nBas(:)
interface
  subroutine cmsym_symmetrize_orbitals(pctx,l,c,err) bind(C,name='cmsym_symmetrize_orbitals_')
    use, intrinsic :: iso_c_binding, only: c_ptr
    use Definitions, only: MOLCAS_C_INT, MOLCAS_C_REAL
    type(c_ptr), value :: pctx
    integer(kind=MOLCAS_C_INT) :: l, err
    real(kind=MOLCAS_C_REAL) :: c(l,l)
  end subroutine cmsym_symmetrize_orbitals
end interface

call Get_iScalar('nSym',nSym)
call mma_allocate(nBas,nSym,label='nBas')
call Get_iArray('nBas',nBas,nSym)

if (nSym /= 1) then
  call WarningMessage(2,'MSYM can only be used with group c1')
  call fmsym_release_context(ctx)
  call Abend()
end if

nMO = 0
nCMO = 0
do iSym=1,nSym
  nMO = nMO+nBas(iSym)
  nCMO = nCMO+nBas(iSym)**2
end do
call mma_deallocate(nBas)

! INT cmsym_symmetrize_orbitals(msym_context *pctx, INT *l, double c[*l][*l], INT *err)
call cmsym_symmetrize_orbitals(ctx,nMO,CIO,ret)
if (ret /= 0) then
  call WarningMessage(2,'Failed to symmetrize orbitals')
  call fmsym_release_context(ctx)
  call Abend()
end if

return

end subroutine fmsym_symmetrize_orbitals

!***********************************************************************

subroutine fmsym_symmetrize_orb_file(ctx,INPORB)

use iso_c_binding, only: c_ptr
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
type(c_ptr), intent(inout) :: ctx
character(len=*), intent(in) :: INPORB
integer(kind=iwp) :: iSym, iBas, nSym, nMO, nCMO, LuOrb, iWarn, iErr, i, j, ret
integer(kind=iwp), allocatable :: nBas(:), indType(:,:), TIND(:)
real(kind=wp), allocatable :: CIO(:), Occ(:), E(:)
character(len=80) :: Title
integer(kind=iwp), external :: isfreeunit
interface
  subroutine cmsym_symmetrize_orbitals(pctx,l,c,err) bind(C,name='cmsym_symmetrize_orbitals_')
    use, intrinsic :: iso_c_binding, only: c_ptr
    use Definitions, only: MOLCAS_C_INT, MOLCAS_C_REAL
    type(c_ptr), value :: pctx
    integer(kind=MOLCAS_C_INT) :: l, err
    real(kind=MOLCAS_C_REAL) :: c(l,l)
  end subroutine cmsym_symmetrize_orbitals
end interface

call Get_iScalar('nSym',nSym)
call mma_allocate(nBas,nSym,label='nBas')
call mma_allocate(indType,7,nSym,label='indType')
call Get_iArray('nBas',nBas,nSym)

if (nSym /= 1) then
  call WarningMessage(2,'MSYM can only be used with group c1')
  call fmsym_release_context(ctx)
  call Abend()
end if

nMO = 0
nCMO = 0
do iSym=1,nSym
  nMO = nMO+nBas(iSym)
  nCMO = nCMO+nBas(iSym)**2
end do

call mma_allocate(CIO,nCMO,label='nCMO')
call mma_allocate(Occ,nMO,label='Occ')
call mma_allocate(E,nMO,label='E')
call mma_allocate(TIND,nMO,label='TIND')

LuOrb = isfreeunit(50)
call RdVec(INPORB,LuOrb,'COEI',nSym,nBas,nBas,CIO,Occ,E,TIND,Title,iWarn,iErr)
! INT cmsym_symmetrize_orbitals(msym_context *pctx, INT *l, double c[*l][*l], INT *err)
call cmsym_symmetrize_orbitals(ctx,nMO,CIO,ret)

if (ret /= 0) then
  call WarningMessage(2,'Failed to symmetrize orbitals')
  call fmsym_release_context(ctx)
  call Abend()
end if
indType(:,:) = 0
i = 1
do iSym=1,nSym
  do iBas=1,nBas(iSym)
    j = TIND(i)
    indType(j,iSym) = indType(j,iSym)+1
    i = i+1
  end do
end do
Title = 'Symmetrized Orbitals'
LuOrb = isfreeunit(50)
call WrVec('MSYMMORB',LuOrb,'COEI',nSym,nBas,nBas,CIO,Occ,E,indType,Title)

call mma_deallocate(CIO)
call mma_deallocate(Occ)
call mma_deallocate(E)
call mma_deallocate(TIND)
call mma_deallocate(nBas)
call mma_deallocate(indType)

return

end subroutine fmsym_symmetrize_orb_file

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE SMOST(NSMST,NSMCI,MXPCSM,ISMOST)
*
* ISMOST(ISYM,ITOTSM) : Symmetry of an internal state if ITOTSM
*                       if symmetry of 1 string is ISYM, the
*                       symmetry of the other string is
*                       ISMOST(ISYM,ITOTSM)
*
* Jeppe Olsen , Spring of 1991
*
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION ISMOST(MXPCSM,MXPCSM)
*
      DO 1000 ITOTSM = 1, NSMCI
       DO 900 ISTSM  = 1, NSMST
C            SYMCOM(ITASK,IOBJ,I1,I2,I12)
        CALL SYMCOM(2,1,ISTSM,JSTSM,ITOTSM)
        ISMOST(ISTSM,ITOTSM) = JSTSM
  900  CONTINUE
 1000 CONTINUE
*
      NTEST = 0
      IF( NTEST.NE. 0 ) THEN
        WRITE(6,*) ' ==============='
        WRITE(6,*) ' Info from SMOST '
        WRITE(6,*) ' ==============='
        DO 1010 ITOTSM = 1, NSMCI
          WRITE(6,*) ' ISMOST array for ITOTSM = ', ITOTSM
          CALL IWRTMA(ISMOST(1,ITOTSM),1,NSMST,1,NSMST)
 1010   CONTINUE
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE LOOP70(INTSYM,INDX,C,S,ABIJ,AIBJ,AJBI,BUF,
     *      IBUF,A,B,F,FSEC,IPOF,IPOA,IPOB,
     * MYL,NYL,INDA,INDB,INMY,INNY,IFTB,IFTA,FACS,
     * IAB,CPL,CPLA, NVIRA,NVIRC,NVIRB)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
#include "WrkSpc.fh"
      DIMENSION INTSYM(*),INDX(*),C(*),S(*),
     *          ABIJ(*),AIBJ(*),AJBI(*),
     *          BUF(NBITM3),IBUF(NBITM3+2),
     *          A(*),B(*),F(*),FSEC(*)
      DIMENSION IPOF(9),IPOA(9),IPOB(9)


      DO 70 IASYM=1,NSYM
      IAB=IPOF(IASYM+1)-IPOF(IASYM)
      IF(IAB.EQ.0)GO TO 70
      ICSYM=MUL(MYL,IASYM)
      IBSYM=MUL(NYL,ICSYM)
      IF(INDA.EQ.INDB.AND.IBSYM.GT.IASYM)GO TO 70
      NVIRC=NVIR(ICSYM)
      IF(NVIRC.EQ.0)GO TO 70
      NVIRA=NVIR(IASYM)
      NVIRB=NVIR(IBSYM)
      IF(ICSYM.GE.IASYM)GO TO 31
      IF(ICSYM.GE.IBSYM)GO TO 32
C     CASE 1, IASYM > ICSYM AND IBSYM > ICSYM
      IPF=IPOF(IASYM)+1
      CALL DYAX(IAB,CPL,AIBJ(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      IF(INDA.EQ.INDB)CALL SETZZ(F,NVIRA)
C     CALL FZERO(A,NBC)
C     CALL FMMM(C(INMY+IPOA(IASYM)),F,A,NVIRC,NVIRB,NVIRA)
C     CALL DAXPY_(NBC,FACS,A,1,S(INNY+IPOB(IBSYM)),1)
      CALL DGEMM_('N','N',NVIRC,NVIRB,NVIRA,
     *           FACS,C(INMY+IPOA(IASYM)),NVIRC,
     *           F,NVIRA,1.0D00,S(INNY+IPOB(IBSYM)),NVIRC)
      IF(INDA.EQ.INDB)GO TO 70
      IPF=IPOF(IBSYM)+1
      CALL FZERO(F,IAB)
      CALL DYAX(IAB,CPL,AJBI(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      CALL DGEMM_('N','N',NVIRC,NVIRA,NVIRB,
     *           FACS,C(INNY+IPOB(IBSYM)),NVIRC,
     *           F,NVIRB,1.0D00,S(INMY+IPOA(IASYM)),NVIRC)
      GO TO 70
C     CASE 2, IASYM > ICSYM AND ICSYM > OR = IBSYM
32    IPF=IPOF(IBSYM)+1
      CALL DYAX(IAB,CPL,AJBI(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
C
      IF(NYL.EQ.1) THEN
       CALL DGEMM_('N','T',NVIRB,NVIRC,NVIRA,
     *            FACS,F,NVIRB,C(INMY+IPOA(IASYM)),NVIRC,
     *            0.D0,A,NVIRB)
       IF(IFTB.EQ.1) THEN
        CALL TRADD(A,S(INNY+IPOB(ICSYM)),NVIRB)
        CALL SQUARN(C(INNY+IPOB(IBSYM)),A,NVIRB)
       ELSE
        CALL SIADD(A,S(INNY+IPOB(ICSYM)),NVIRB)
        CALL SQUAR(C(INNY+IPOB(IBSYM)),A,NVIRB)
       ENDIF
       CALL DGEMM_('N','N',NVIRC,NVIRA,NVIRB,
     *            FACS,A,NVIRC,F,NVIRB,
     *            1.D0,S(INMY+IPOA(IASYM)),NVIRC)
      ELSE
       FACSX=FACS
       IF(IFTB.EQ.1) FACSX=-FACS
       CALL DGEMM_('N','T',NVIRB,NVIRC,NVIRA,
     *            FACSX,F,NVIRB,C(INMY+IPOA(IASYM)),NVIRC,
     *            1.D0,S(INNY+IPOB(ICSYM)),NVIRB)
       CALL DGEMM_('T','N',NVIRC,NVIRA,NVIRB,
     *            FACSX,C(INNY+IPOB(ICSYM)),NVIRB,F,NVIRB,
     *            1.D0,S(INMY+IPOA(IASYM)),NVIRC)
      ENDIF
      GO TO 70
C UPDATED UNTIL HERE
31    IF(ICSYM.GE.IBSYM)GO TO 33
C     CASE 3, ICSYM > OR = IASYM AND IBSYM > ICSYM
      IPF=IPOF(IASYM)+1
      CALL DYAX(IAB,CPL,AIBJ(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      IF(MYL.EQ.1) THEN
       IF(IFTA.EQ.0)CALL SQUAR(C(INMY+IPOA(IASYM)),A,NVIRA)
       IF(IFTA.EQ.1)CALL SQUARN(C(INMY+IPOA(IASYM)),A,NVIRA)
       CALL DGEMM_('N','N',NVIRC,NVIRB,NVIRA,
     *            FACS,A,NVIRC,F,NVIRA,
     *            1.D0,S(INNY+IPOB(IBSYM)),NVIRC)
       CALL DGEMM_('N','T',NVIRA,NVIRC,NVIRB,
     *            FACS,F,NVIRA,C(INNY+IPOB(IBSYM)),NVIRC,
     *            0.D0,A,NVIRA)
       IF(IFTA.EQ.0) CALL SIADD(A,S(INMY+IPOA(IASYM)),NVIRA)
       IF(IFTA.EQ.1) CALL TRADD(A,S(INMY+IPOA(IASYM)),NVIRA)
      ELSE
       FACSX=FACS
       IF(IFTA.EQ.1) FACSX=-FACS
       CALL DGEMM_('T','N',NVIRC,NVIRB,NVIRA,
     *            FACSX,C(INMY+IPOA(ICSYM)),NVIRA,F,NVIRA,
     *            1.D0,S(INNY+IPOB(IBSYM)),NVIRC)
       CALL DGEMM_('N','T',NVIRA,NVIRC,NVIRB,
     *            FACSX,F,NVIRA,C(INNY+IPOB(IBSYM)),NVIRC,
     *            1.D0,S(INMY+IPOA(ICSYM)),NVIRA)
      ENDIF
      GO TO 70
C     CASE 4, ICSYM > OR = IASYM AND ICSYM > OR = IBSYM
33    IPF=IPOF(IBSYM)+1
      CALL DYAX(IAB,CPL,AJBI(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
      IF(INDA.EQ.INDB)CALL SETZZ(F,NVIRA)
      IF(MYL.EQ.1.AND.NYL.EQ.1) THEN
C
       IF(IFTA.EQ.0) CALL SQUAR(C(INMY+IPOA(IASYM)),A,NVIRA)
       IF(IFTA.EQ.1) CALL SQUARM(C(INMY+IPOA(IASYM)),A,NVIRA)
       CALL DGEMM_('N','N',NVIRB,NVIRC,NVIRA,
     *            FACS,F,NVIRB,A,NVIRA,
     *            0.D0,B,NVIRB)
       IF(IFTB.EQ.0) CALL SIADD(B,S(INNY+IPOB(ICSYM)),NVIRB)
       IF(IFTB.EQ.1) CALL TRADD(B,S(INNY+IPOB(ICSYM)),NVIRB)
C
      ELSE IF (MYL.EQ.1.AND.NYL.NE.1) THEN
       IF(IFTA.EQ.0) CALL SQUAR(C(INMY+IPOA(IASYM)),A,NVIRA)
       IF(IFTA.EQ.1) CALL SQUARM(C(INMY+IPOA(IASYM)),A,NVIRA)
       FACSX=FACS
       IF(IFTB.EQ.1) FACSX=-FACS
       CALL DGEMM_('N','N',NVIRB,NVIRC,NVIRA,
     *            FACSX,F,NVIRB,A,NVIRA,
     *            1.D0,S(INNY+IPOB(ICSYM)),NVIRB)
C
      ELSE IF (MYL.NE.1.AND.NYL.EQ.1) THEN
C
       FACSX=FACS
       IF(IFTA.EQ.1) FACSX=-FACS
       CALL DGEMM_('N','N',NVIRB,NVIRC,NVIRA,
     *            FACSX,F,NVIRB,C(INMY+IPOA(ICSYM)),NVIRA,
     *            0.D0,B,NVIRB)
       IF(IFTB.EQ.0) CALL SIADD(B,S(INNY+IPOB(ICSYM)),NVIRB)
       IF(IFTB.EQ.1) CALL TRADD(B,S(INNY+IPOB(ICSYM)),NVIRB)
      ELSE IF (MYL.NE.1.AND.NYL.NE.1) THEN
       FACSX=FACS
       IF(IFTA+IFTB.EQ.1) FACSX=-FACS
       CALL DGEMM_('N','N',NVIRB,NVIRC,NVIRA,
     *            FACSX,F,NVIRB,C(INMY+IPOA(ICSYM)),NVIRA,
     *            1.D0,S(INNY+IPOB(ICSYM)),NVIRB)
      ENDIF
      IF(INDA.EQ.INDB)GO TO 70
      IPF=IPOF(IASYM)+1
      CALL DYAX(IAB,CPL,AIBJ(IPF),1,F,1)
      CALL DAXPY_(IAB,CPLA,ABIJ(IPF),1,F,1)
C
      IF(NYL.EQ.1.AND.MYL.EQ.1) THEN
C
       IF(IFTB.EQ.0) CALL SQUAR(C(INNY+IPOB(IBSYM)),A,NVIRB)
       IF(IFTB.EQ.1) CALL SQUARM(C(INNY+IPOB(IBSYM)),A,NVIRB)
       CALL DGEMM_('N','N',NVIRA,NVIRC,NVIRB,
     *            FACS,F,NVIRA,A,NVIRB,
     *            0.D0,B,NVIRA)
       IF(IFTA.EQ.0) CALL SIADD(B,S(INMY+IPOA(ICSYM)),NVIRA)
       IF(IFTA.EQ.1) CALL TRADD(B,S(INMY+IPOA(ICSYM)),NVIRA)
C
      ELSE IF (NYL.EQ.1.AND.MYL.NE.1) THEN
       IF(IFTB.EQ.0) CALL SQUAR(C(INNY+IPOB(ICSYM)),A,NVIRB)
       IF(IFTB.EQ.1) CALL SQUARM(C(INNY+IPOB(ICSYM)),A,NVIRB)
       FACSX=FACS
       IF(IFTA.EQ.1) FACSX=-FACS
       CALL DGEMM_('N','N',NVIRA,NVIRC,NVIRB,
     *            FACSX,F,NVIRA,A,NVIRB,
     *            1.D0,S(INMY+IPOA(ICSYM)),NVIRA)
C
      ELSE IF (NYL.NE.1.AND.MYL.EQ.1) THEN
C
       FACSX=FACS
       IF(IFTB.EQ.1) FACSX=-FACS
       CALL DGEMM_('N','N',NVIRA,NVIRC,NVIRB,
     *            FACSX,F,NVIRA,C(INNY+IPOB(ICSYM)),NVIRB,
     *            0.D0,B,NVIRA)
       IF(IFTA.EQ.0) CALL SIADD(B,S(INMY+IPOA(ICSYM)),NVIRA)
       IF(IFTA.EQ.1) CALL TRADD(B,S(INMY+IPOA(ICSYM)),NVIRA)
C
      ELSE IF (NYL.NE.1.AND.MYL.NE.1) THEN
C
       FACSX=FACS
       IF(IFTA+IFTB.EQ.1) FACSX=-FACS
       CALL DGEMM_('N','N',NVIRA,NVIRC,NVIRB,
     *            FACSX,F,NVIRA,C(INNY+IPOB(ICSYM)),NVIRB,
     *            1.D0,S(INMY+IPOA(ICSYM)),NVIRA)
      ENDIF
C
70    CONTINUE
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(INTSYM)
        CALL Unused_integer_array(INDX)
        CALL Unused_integer_array(IBUF)
        CALL Unused_real_array(FSEC)
        CALL Unused_real_array(BUF)
      END IF
      END
      subroutine faibj5(LENBUF,JTURN,IBUF,BUF, AIBJ,ABIJ)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
#include "WrkSpc.fh"
      DIMENSION ABIJ(NVSQ),AIBJ(NVSQ),
     *          BUF(NBITM3),IBUF(NBITM3+2)
       IF(LENBUF.GT.0) THEN
           IF(JTURN.EQ.1) THEN
             do i=1,LENBUF
               aibj(IBUF(i))=buf(i)
             enddo
           ELSE
             do i=1,LENBUF
               abij(IBUF(i))=buf(i)
             enddo
           END IF
         END IF
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Sort_to_Box(Coor,nAtoms,iTab,nMax,nx,ny,nz,iBox,iANr,xmin,ymin,zmin,Box_Size)

use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nMax, nx, ny, nz, iANr(nAtoms)
real(kind=wp), intent(in) :: Coor(3,nAtoms), xmin, ymin, zmin, Box_Size
integer(kind=iwp), intent(out) :: iTab(0:nMax,nx,ny,nz), iBox(3,nAtoms)
integer(kind=iwp) :: iAtom, ix, iy, iz, Nr
real(kind=wp) :: x, y, z
integer(kind=iwp), external :: iTabRow

!                                                                      *
!***********************************************************************
!                                                                      *

iTab(:,:,:,:) = 0

do iAtom=1,nAtoms

  if (iTabRow(iAnr(iAtom)) == 0) cycle

  x = Coor(1,iAtom)-xmin
  ix = int(x/Box_Size)+1
  y = Coor(2,iAtom)-ymin
  iy = int(y/Box_Size)+1
  z = Coor(3,iAtom)-zmin
  iz = int(z/Box_Size)+1
  iBox(1,iAtom) = ix
  iBox(2,iAtom) = iy
  iBox(3,iAtom) = iz

  Nr = iTab(0,ix,iy,iz)+1
  if (Nr > nMax) then
    call WarningMessage(2,'Sort_to_Box: Nr > nMax')
    call Abend()
  end if
# ifdef _DEBUGPRINT_
  write(u6,*) 'Sort_to_Box: ix,iy,iz,Nr,iAtom=',ix,iy,iz,Nr,iAtom
# endif

  iTab(0,ix,iy,iz) = Nr
  iTab(Nr,ix,iy,iz) = iAtom

end do

return

end subroutine Sort_to_Box

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Thouless_T1(CMO,nSym,nBas,nFro,nOcc,nSsh,T1amp)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nFro(nSym), nOcc(nSym), nSsh(nSym)
real(kind=wp), intent(_OUT_) :: T1amp(*)
integer(kind=iwp) :: i, iDummy(1), iErr, ifr, iOff, iSym, ito, iU, j, jp_C, jp_S, jp_T, jp_X, jU, k, kk, kOff, l_O, l_O2, l_S, &
                     lScr, Lu, nOrb
real(kind=wp) :: Dummy(1), omega
character(len=40) :: OrbTit
real(kind=wp), allocatable :: R(:), S(:), Scr(:), U(:), W(:), X(:), Y(:), Z(:)

! Compute the T1 amplitudes according to Thouless formula
! -------------------------------------------------------

l_S = nBas(1)**2
lScr = nBas(1)*(nFro(1)+nOcc(1))
l_O = nOcc(1)
do iSym=2,nSym
  l_S = l_S+nBas(iSym)**2
  lScr = max(lScr,nBas(iSym)*(nFro(iSym)+nOcc(iSym)))
  l_O = max(l_O,nOcc(iSym))
end do
l_O2 = l_O**2

call mma_allocate(Scr,lScr,Label='Scr')
call mma_allocate(U,lScr,Label='U')

call mma_allocate(W,l_O2,Label='W')
call mma_allocate(Y,l_O2,Label='Y')
call mma_allocate(Z,l_O2,Label='Z')
call mma_allocate(R,l_O2,Label='R')

call mma_allocate(S,l_S,Label='S')
call mma_allocate(X,l_S,Label='X')

call GetOvlp_Localisation(S,'Sqr',nBas,nSym)

Lu = 12
call RdVec('INPORB',Lu,'C',nSym,nBas,nBas,X,Dummy,Dummy,iDummy,OrbTit,1,iErr)

write(u6,*)
write(u6,*) '      Thouless singles amplitudes from: '
write(u6,*) '      '//OrbTit
write(u6,*)

iOff = 0
kOff = 0
do iSym=1,nSym
  jp_S = 1+iOff
  jp_C = 1+iOff+nBas(iSym)*nFro(iSym)
  jp_X = 1+iOff+nBas(iSym)*nFro(iSym)
  nOrb = nOcc(iSym)+nSsh(iSym)

  call GetUmat_T1(U,CMO(jp_C),S(jp_S),X(jp_X),Scr,lScr,nBas(iSym),nOrb,nOcc(iSym))

  iU = 1
  do j=1,nOcc(iSym)
    ifr = 1+nOrb*(j-1)
    ito = 1+nOcc(iSym)*(j-1)
    call dcopy_(nOcc(iSym),U(ifr),1,Scr(ito),1)
    jU = ifr+nOcc(iSym)
    do i=1,nSsh(iSym)
      U(iU) = U(jU)
      iU = iU+1
      jU = jU+1
    end do
  end do

  ! SVD of U in the oo space:   U = Y * w * Z'

  call SVD(nOcc(iSym),nOcc(iSym),nOcc(iSym),Scr,W,.true.,Y,.true.,Z,ierr,R)

  if (ierr /= 0) then
    write(u6,*)
    write(u6,*) ' *** Warning: SVD failed to get singval: ',ierr
    write(u6,*) ' *** Located in Thouless_T1 -- call to SVD .'
    write(u6,*)
    write(u6,*) ' omega= ',(W(k),k=1,nOcc(iSym))
  end if

  call FZero(R,nOcc(iSym)**2)
  do k=1,nOcc(iSym)
    omega = W(k)
    kk = nOcc(iSym)*(k-1)+k
    if (omega > 1.0e-8_wp) then
      R(kk) = One/omega
    end if
  end do

  ! Compute U^-1 = Z * w^-1 * Y'

  call DGEMM_('N','T',nOcc(iSym),nOcc(iSym),nOcc(iSym),One,R,nOcc(iSym),Y,nOcc(iSym),Zero,W,nOcc(iSym))

  call DGEMM_('N','N',nOcc(iSym),nOcc(iSym),nOcc(iSym),One,Z,nOcc(iSym),W,nOcc(iSym),Zero,Scr,nOcc(iSym))

  jp_T = 1+kOff
  call DGEMM_('T','T',nOcc(iSym),nSsh(iSym),nOcc(iSym),One,Scr,nOcc(iSym),U,nSsh(iSym),Zero,T1amp(jp_T),nOcc(iSym))

  iOff = iOff+nBas(iSym)**2
  kOff = kOff+nOcc(iSym)*nSsh(iSym)
end do

call mma_deallocate(X)
call mma_deallocate(S)
call mma_deallocate(R)
call mma_deallocate(Z)
call mma_deallocate(Y)
call mma_deallocate(W)
call mma_deallocate(U)
call mma_deallocate(Scr)

return

end subroutine Thouless_T1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine casinfoprint_cvb()

use casvb_global, only: ipr, isym, isymv, ityp, mxirrep, nalf, nbet, nel, norb, nsym
use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, ii, incr, qisym(nsym)
logical(kind=iwp), external :: up2date_cvb ! ... Make: up to date? ...

if ((ipr(1) >= 0) .and. (.not. up2date_cvb('CASPRINT'))) then
  write(u6,'(/,a,i4)') ' Number of active electrons :',nel
  write(u6,'(a,i4)') ' Number of active orbitals  :',norb
  write(u6,'(a,f4.1)') ' Total spin                 :',real(nalf-nbet,kind=wp)*Half
  if (nsym == 1) then
    write(u6,'(a,i4)') ' State symmetry             :',isym
  else
    incr = 0
    do i=1,mxirrep
      if (isymv(i) == 1) then
        incr = incr+1
        qisym(incr) = i
      end if
    end do
    write(u6,'(a,i4,7i3)') ' State symmetries           :',(qisym(ii),ii=1,nsym)
  end if
  write(u6,'(/,a,100i3)') ' Symmetries of active MOs   : ',(ityp(ii),ii=1,norb)
  call make_cvb('CASPRINT')
end if

return

end subroutine casinfoprint_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RASSCF_RDINP(DFonly,LuInput)
!***********************************************************************
!                                                                      *
!  Purpose:   If DFonly, use defaults only.                            *
!             Else, read and process input for Cholesky section        *
!             in RASSCF                                                *
!                                                                      *
!***********************************************************************

use Fock_util_global, only: ALGO, Deco, DensityCheck, dmpK, DoLocK, Estimate, Nscreen, Update
use Cholesky, only: ChFracMem, timings
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: DFonly
integer(kind=iwp), intent(in) :: LuInput
integer(kind=iwp) :: iChrct, iCLast, Last
character(len=180) :: Key, KWord
real(kind=wp) :: DMPK_DFL
character(len=180), external :: Get_Ln

!**** Algorithms for using Cholesky vectors in RASSCF ******************
!
!   ALGO:
!
!          1  --->  compute fock matrices in AO-basis from vectors
!                   read in reduced sets and transformed on the fly
!                   (PU|VX) integrals are also returned
!
!                   If DoLock=.true. then the Exchange terms are
!                   computed by emplpying the "Local K" scheme
!
!
!          2  --->  compute fock matrices in AO-basis from vectors
!                   read in reduced sets and transformed on the fly
!                   Only the (TU|VX) integrals are returned
!                   while the vectors are directly contracted
!                   with the 2-body density in order to construct
!                   the Q-matrix
!                                                                      *
!***********************************************************************
!                                                                      *
! Default  parameters
#ifdef _MOLCAS_MPP_
ChFracMem = 0.3_wp
#else
ChFracMem = Zero
#endif

! set some parameters if not specified in ChoInput section
ALGO = 1
DensityCheck = .false.
Deco = .true.
timings = .false.
DoLock = .true.
Nscreen = 10
dmpk = 1.0e-1_wp
Update = .true.
Estimate = .false.
if (DFonly) return

dmpk_dfl = 1.0e-1_wp
!***********************************************************************
!                                                                      *
!-----Process the input

!----------------------------------------------------------------------*
! The big turning point.                                               *
!----------------------------------------------------------------------*
outer: do
  !--------------------------------------------------------------------*
  ! Use Get_Ln to read the lines.                                      *
  !--------------------------------------------------------------------*
  Key = Get_Ln(LuInput)
  Kword = Key
  call UpCase(Kword)
  !--------------------------------------------------------------------*
  ! The keywords and their labels.                                     *
  !--------------------------------------------------------------------*

  if ((KWord(1:1) == '*') .or. (KWord == '')) cycle outer
  select case (KWord(1:4))
    case ('ALGO')
      !                                                                *
      !***** ALGO ******************************************************
      !                                                                *
      !-----Read Cholesky algorithm parameters

      !call Get_F1(1,Eps)
      !call Get_F1(2,rds)
      !call Get_I1(1,ALGO)
      !if (nToken(KWord) > 1) exit outer

      read(LuInput,*) ALGO

      if (ALGO == 1) then
        write(u6,*) 'Default RASSCF algorithm reset to  ',ALGO
        write(u6,*)
      else if (ALGO == 2) then
        write(u6,*) 'Default RASSCF algorithm reset to  ',ALGO
        write(u6,*)
        write(u6,*) ' !!! STILL UNDER DEBUGGING !!! '
      else
        write(u6,*) 'The specified algorithm is not implemented. Option Ignored '
        write(u6,*)
      end if

    case ('LOCK','LK')
      !                                                                *
      !***** LOCK or LK ************************************************
      !                                                                *
      DoLocK = .true.
      !write(u6,*) 'Using Local K scheme for Exchange matrices'

    case ('NOLK')
      !                                                                *
      !***** NOLK ******************************************************
      !                                                                *
      DoLocK = .false.
      !write(u6,*) 'LK screening for Exchange matrices turned off!'

    case ('DMPK')
      !                                                                *
      !***** DMPK ******************************************************
      !                                                                *
      read(LuInput,*) dmpk
      if (dmpk < Zero) then
        write(u6,*) 'OBS! Specified Negative DMPK value. Restore Defaults'
        dmpk = dmpk_dfl
      end if

    case ('NODE')
      !                                                                *
      !***** NODE ******************************************************
      !                                                                *
      Deco = .false.
      write(u6,*) 'Not-Using Cholesky decomposed Inactive density'

    case ('SCRN')
      !                                                                *
      !***** SCRN ******************************************************
      !                                                                *
      read(LuInput,*) Nscreen

    case ('MEMF')
      !                                                                *
      !***** MEMF ******************************************************
      !                                                                *
      read(LuInput,*) ChFracMem

    case ('DCHK')
      !                                                                *
      !***** DCHK ******************************************************
      !                                                                *
      DensityCheck = .true.
      write(u6,*) 'Non-valid option. IGNORED !! '

    case ('TIME')
      !                                                                *
      !***** TIME ******************************************************
      !                                                                *
      timings = .true.

    case ('ESTI')
      !                                                                *
      !***** ESTI ******************************************************
      !                                                                *
      Estimate = .true.
      write(u6,*) 'Diagonal integrals estimated from the current Cholesky vectors'

    case ('UPDA')
      !                                                                *
      !***** UPDA ******************************************************
      !                                                                *
      Update = .true.
      write(u6,*) 'Updating of the true diagonal integrals'

    case ('END','ENDC','ENDO')
      !                                                                *
      !***** END  ******************************************************
      !                                                                *
      !-----End of input
      exit outer

    case default
      !----------------------------------------------------------------*
      ! Control section                                                *
      !----------------------------------------------------------------*
      iChrct = len(KWord)
      Last = iCLast(KWord,iChrct)
      write(u6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
      write(u6,*) 'CHO_RASSCF_RDINP Error in keyword.'
      call Quit_OnUserError()

  end select

end do outer
!                                                                      *
!***********************************************************************
!                                                                      *

!write(u6,'(1X,A,I4)') 'Default Cholesky algorithm in RASSCF = ',ALGO
write(u6,*)
if ((ALGO == 2) .and. (DoLocK)) then
  write(u6,*) 'Local K scheme not implemented for the chosen algorithm. LocK keyword ignored !'
  DoLocK = .false.
end if

end subroutine CHO_RASSCF_RDINP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Construct rotation matrix.
subroutine Revolution(v,Rinv,Rotte)

use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: v(3), Rinv
real(kind=wp), intent(out) :: Rotte(3,3)
real(kind=wp) :: u(3), w(3), t(3)

! Obtain base-vectors for the plane to which v in the normal vector.

call PlaneVectors(u,w,v,Rinv)

! Normalize v.

t(:) = Rinv*v

! Assemble rotation matrix

Rotte(1,:) = u
Rotte(2,:) = w
Rotte(3,:) = t

return

end subroutine Revolution

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_aux_qlm_builder

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_get_aux_qlm

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_aux_qlm(scheme,LHS_mms,RHS_mms)

      USE fmm_qlm_utils, ONLY: fmm_renormalise_qlm

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      TYPE(raw_mm_data),  INTENT(INOUT) :: LHS_mms, RHS_mms

      ! We use the SCALED solid harmonic formulation throughout
      CALL fmm_renormalise_qlm(scheme%raw_LMAX,LHS_mms%qlm)
      CALL fmm_renormalise_qlm(scheme%raw_LMAX,RHS_mms%qlm)

      ! Identify batches of unique centre/extent and sort them in
      ! preparation for packing
      CALL sort_centres_and_assign_batches(scheme,LHS_mms,RHS_mms)

      ! Get parameter mappings and preconditioned W and T moments
      CALL get_RHS_data(scheme,RHS_mms)
      CALL get_LHS_data(scheme,LHS_mms)

      ! All relevant data should now be held in %qlm_T and %qlm_W
      DEALLOCATE (LHS_mms%qlm, RHS_mms%qlm)
      NULLIFY (LHS_mms%qlm, RHS_mms%qlm)

   END SUBROUTINE fmm_get_aux_qlm

!-------------------------------------------------------------------------------

   SUBROUTINE sort_centres_and_assign_batches(scheme,LHS,RHS)

      USE fmm_qlm_utils, ONLY: fmm_sort_paras_wrt_centre, fmm_assign_batches

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      TYPE(raw_mm_data),  INTENT(INOUT) :: LHS, RHS

      IF (scheme%pack_LHS) THEN
         CALL fmm_sort_paras_wrt_centre(1_INTK,LHS%paras)
         CALL fmm_assign_batches(LHS%paras)
      END IF
      IF (scheme%pack_RHS) THEN
         CALL fmm_sort_paras_wrt_centre(1_INTK,RHS%paras)
         CALL fmm_assign_batches(RHS%paras)
      END IF

   END SUBROUTINE sort_centres_and_assign_batches

!-------------------------------------------------------------------------------

   SUBROUTINE get_LHS_data(scheme,LHS)

      USE fmm_qlm_utils, ONLY: fmm_factor_in_dens, fmm_pack_raw_parameters

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      TYPE(raw_mm_data),  INTENT(INOUT) :: LHS
      INTEGER(INTK) :: i, ndim, qlm_dim, alloc_error

      ! Get LHS parameters from raw data
      IF (scheme%pack_LHS) THEN
         CALL fmm_pack_raw_parameters(LHS)
      END IF

      ! Sync (packed)parameters:(packed)moments mappings
      DO i = 1, SIZE(LHS%paras)
         LHS%paras(i)%id = i
      END DO

      ! LHS preconditioning for T-matrix
      SELECT CASE (scheme%T_con%LHS_mm_type)
         CASE (USE_RAW_QLM)
            ! Note that dimensions of paras and qlm,2 may be different
            qlm_dim = SIZE(LHS%qlm,2)
            ndim = SIZE(LHS%qlm,1)
            WRITE(LUPRI,*) 'LHS%qlm_T: Attempting to allocate',  &
                           MAX(1,qlm_dim*ndim*8/1000000), 'MB of memory...'
            ALLOCATE (LHS%qlm_T(ndim,qlm_dim), STAT=alloc_error)
            IF (alloc_error /= 0) WRITE(LUPRI,*) '... Failed!'
            LHS%qlm_T(:,:) = LHS%qlm(:,:)
         CASE DEFAULT
            CALL fmm_quit('cannot reconcile LHS_mm_type')
      END SELECT

      ! Factorise in density if required
      IF ( scheme%LHS_dens ) THEN
         CALL fmm_factor_in_dens(LHS%dens,LHS%qlm_T)
         DEALLOCATE (LHS%dens)
         NULLIFY (LHS%dens)
      END IF

   END SUBROUTINE get_LHS_data

!-------------------------------------------------------------------------------

   SUBROUTINE get_RHS_data(scheme,RHS)

      USE fmm_qlm_utils, ONLY: fmm_get_T_sym_qlm,     &
                               fmm_pack_raw_moments,  &
                               fmm_factor_in_dens

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      TYPE(raw_mm_data),  INTENT(INOUT) :: RHS
      INTEGER(INTK) :: LMAX, i, qlm_dim, ndim, alloc_error
      LOGICAL :: dens
      REAL(REALK) :: thr

      LMAX = scheme%raw_LMAX

      IF ( scheme%pack_RHS ) THEN
         ! We now pack all moments belonging to
         ! the same batch (same centre,extent);
         ! Also factor in density and perform
         ! density-based screening if flagged
         dens = scheme%RHS_dens
         thr = scheme%dens_screen_thr
         CALL fmm_pack_raw_moments(RHS,dens,thr)
      END IF

      ndim = (1+LMAX)**2
      qlm_dim = SIZE(RHS%qlm,2)
      WRITE(LUPRI,*) 'RHS%qlm_W: Attempting to allocate',  &
                     MAX(1,qlm_dim*ndim*8/1000000), 'MB of memory...'
      ALLOCATE (RHS%qlm_W(ndim,qlm_dim), STAT=alloc_error)
      IF (alloc_error /= 0) WRITE(LUPRI,*) '... Failed!'
      RHS%qlm_W(:,:) = RHS%qlm(:,:)

      IF ( .NOT. scheme%pack_RHS ) THEN
         IF ( scheme%RHS_dens ) CALL fmm_factor_in_dens(RHS%dens,RHS%qlm_W)
      END IF

      ! Density nolonger required
      IF ( scheme%RHS_dens ) THEN
         DEALLOCATE(RHS%dens)
         NULLIFY(RHS%dens)
      END IF

      IF (qlm_dim /= SIZE(RHS%paras)) CALL fmm_quit('error in RHS data')
      ! Resync parameters:moments mappings
      DO i = 1, qlm_dim
         RHS%paras(i)%id = i
      END DO

      ! RHS preconditioning for T-matrix
      SELECT CASE (scheme%T_con%RHS_mm_type)
         CASE (USE_RAW_QLM)
            RHS%qlm_T => RHS%qlm_W(:,:)
         CASE (USE_T_SYM_QLM)
            ALLOCATE (RHS%qlm_T(ndim,qlm_dim))
             ! build %qlm_T by rescaling significant %qlm_W
            CALL fmm_get_T_sym_qlm(LMAX,RHS%qlm_W,RHS%qlm_T)
         CASE DEFAULT
            CALL fmm_quit('cannot reconcile RHS_mm_type')
      END SELECT

   END SUBROUTINE get_RHS_data

!-------------------------------------------------------------------------------

END MODULE fmm_aux_qlm_builder

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Unused_real(r)
      IMPLICIT NONE
      REAL*8 r,r2
#ifdef _WARNING_WORKAROUND_
      IF (.FALSE.) r2=r
#endif
      END SUBROUTINE Unused_real

      SUBROUTINE Unused_real_array(r)
      IMPLICIT NONE
      REAL*8 r(*),r2
#ifdef _WARNING_WORKAROUND_
      IF (.FALSE.) r2=r(1)
#endif
      END SUBROUTINE Unused_real_array

      SUBROUTINE Unused_integer(i)
      IMPLICIT NONE
      INTEGER i,i2
#ifdef _WARNING_WORKAROUND_
      IF (.FALSE.) i2=i
#endif
      END SUBROUTINE Unused_integer

      SUBROUTINE Unused_integer_array(i)
      IMPLICIT NONE
      INTEGER i(*),i2
#ifdef _WARNING_WORKAROUND_
      IF (.FALSE.) i2=i(1)
#endif
      END SUBROUTINE Unused_integer_array

      SUBROUTINE Unused_logical(l)
      IMPLICIT NONE
      LOGICAL l,l2
#ifdef _WARNING_WORKAROUND_
      IF (.FALSE.) l2=l
#endif
      END SUBROUTINE Unused_logical

      SUBROUTINE Unused_logical_array(l)
      IMPLICIT NONE
      LOGICAL l(*),l2
#ifdef _WARNING_WORKAROUND_
      IF (.FALSE.) l2=l(1)
#endif
      END SUBROUTINE Unused_logical_array

      SUBROUTINE Unused_character(c)
      IMPLICIT NONE
      CHARACTER c(*),c2
#ifdef _WARNING_WORKAROUND_
      IF (.FALSE.) c2=c(1)
#endif
      END SUBROUTINE Unused_character

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TranslateGeoms(Vtrans)

use Quater_globals, only: debug, ngeoms, list
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Vtrans(3)
integer(kind=iwp) :: igeom

do igeom=3,ngeoms+2
  if (debug) then
    write(u6,*) 'Before translation'
    call PrintGeom(u6,list(igeom)%nat,list(igeom)%title,list(igeom)%geo,list(igeom)%geolbl)
  end if
  call TranslateGeom(Vtrans,list(igeom)%nat,list(igeom)%geo)
  if (debug) then
    write(u6,*) 'After translation'
    call PrintGeom(u6,list(igeom)%nat,list(igeom)%title,list(igeom)%geo,list(igeom)%geolbl)
  end if
end do

return

end subroutine TranslateGeoms

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3sgl(wrk,wrksize,w,s1,s2,d1,d2,typdiv,i,j,k,symi,symj,symk,rc1,m1,h1,m2,h2,m3,h3)
! w         - W (Input)
! s1        - S1 (Input)
! s2        - S2 (Input)
! d1        - D1 (Input)
! d2        - D2 (Input)
!             (order is aa>ab>bb, if there is only one spin, use any map's for 2)
! typsgl    - type of operation (see Table) (Input)
! i         - value of occupied index i (Input)
! j         - value of occupied index j (Input)
! k         - value of occupied index k (Input)
! symi      - symmetry of index i (Input)
! symj      - symmetry of index j (Input)
! symk      - symmetry of index k (Input)
! rc1       - return (error) code (Output)
! m1-3,h1-3 - parameters for M1-3,H1-3 files (I)
!
! this routine adds contributions from disconnected
! singles, namely:
!
! W_ijk(abc) <- P [ U1(_i,a) . U2(_jk,bc) ]
!
! for following types of W
!
! typsgl         Operation                   Implemented
! 1     W(abc) <- +s1(_i,a) . d1(_jk,bc)
!                 -s1(_i,b) . d1(_jk,ac)
!                 +s1(_i,c) . d1(_jk,ab)
!
!                 -s1(_j,a) . d1(_ik,bc)
!                 +s1(_j,b) . d1(_ik,ac)
!                 -s1(_j,c) . d1(_ik,ab)
!
!                 +s1(_k,a) . d1(_ij,bc)
!                 -s1(_k,b) . d1(_ij,ac)
!                 +s1(_k,c) . d1(_ij,ab)        Yes
!
! 2     W(ab,c)<- +s1(_i,a) . d2(_j,_k,b,c)
!                 -s1(_i,b) . d2(_j,_k,a,c)
!
!                 -s1(_j,a) . d2(_i,_k,b,c)
!                 +s1(_j,b) . d2(_i,_k,a,c)
!
!                 +s2(_k,c) . d1(_ij,ab)        Yes
!
! 3     W(a,bc)<- +s1(_i,a) . d2(_jk,b,c)
!
!                 +s1(_j,b) . d2(_i,_k,a,c)
!                 -s1(_j,c) . d2(_i,_k,a,b)
!
!                 -s1(_k,b) . d2(_i,_j,a,c)
!                 +s1(_k,c) . d2(_i,_j,a,b)     Yes
!
! N.B. spin combinations aaa,bbb for 1; aab for 2; and abb for 3
! are automatically assumed

use CCT3_global, only: dimm, Map_Type, mmul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, typdiv, i, j, k, symi, symj, symk
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: w, s1, s2, d1, d2
integer(kind=iwp), intent(inout) :: rc1
type(Map_Type), intent(inout) :: m1, h1, m2, h2, m3, h3
integer(kind=iwp) :: dima, dimb, dimc, id1, id2, id3, is1, is2, is3, iw, nhelp1, nhelp2, posd1, posd2, posd3, poss1, poss2, poss3, &
                     posw, ssh1, ssh2, ssh3, ssm1, ssm2, ssm3, syma, symab, symac, symb, symbc, symc, symij, symik, symjk

!0.* some tests

if (typdiv == 1) then

  !1 case W(pqr)

  !1.* ext H1(a) <= S1(a,i) for given i
  call ext(wrk,wrksize,2,2,i,0,symi,0,0,s1,1,h1,ssh1,rc1)

  !1.* ext H2(a) <= S1(a,j) for given j
  call ext(wrk,wrksize,2,2,j,0,symj,0,0,s1,1,h2,ssh2,rc1)

  !1.* ext H3(a) <= S1(a,k) for given k
  call ext(wrk,wrksize,2,2,k,0,symk,0,0,s1,1,h3,ssh3,rc1)

  !1.* ext M1(bc) <= D1(bc,jk) for given jk
  call ext(wrk,wrksize,4,7,j,k,symj,symk,0,d1,1,m1,ssm1,rc1)

  !1.* ext M2(bc) <= D1(bc,ik) for given ik
  call ext(wrk,wrksize,4,7,i,k,symi,symk,0,d1,1,m2,ssm2,rc1)

  !1.* ext M3(bc) <= D1(bc,ij) for given ij
  call ext(wrk,wrksize,4,7,i,j,symi,symj,0,d1,1,m3,ssm3,rc1)

  do iw=1,w%d(0,5)

    !1.* def position of W
    posw = w%d(iw,1)

    !1.* def symmetry status
    syma = w%d(iw,3)
    symb = w%d(iw,4)
    symc = w%d(iw,5)

    !1.* def dimensions
    dima = dimm(w%d(0,1),syma)
    dimb = dimm(w%d(0,2),symb)
    dimc = dimm(w%d(0,3),symc)
    !1.*
    symij = mmul(symi,symj)
    symik = mmul(symi,symk)
    symjk = mmul(symj,symk)
    symab = mmul(syma,symb)
    symac = mmul(syma,symc)
    symbc = mmul(symb,symc)

    !1.* realize packing

    if (syma == symc) then
      !1.a case syma=symb=symc

      !1.a.1---- 1st. triade   W(abc) <- +s1(_i,a) . d1(_jk,bc)
      !                                  -s1(_i,b) . d1(_jk,ac)
      !                                  +s1(_i,c) . d1(_jk,ab)

      if ((symi == syma) .and. (symjk == symbc)) then
        !1.a.1.* find address for s1,d1
        is1 = h1%i(1,1,1)
        id1 = m1%i(symb,1,1)

        !1.a.1.* def position of s1,d1
        poss1 = h1%d(is1,1)
        posd1 = m1%d(id1,1)

        !1.a.1.* def additional dimensions
        nhelp1 = dima*(dima-1)/2
        nhelp2 = dima*(dima-1)*(dima-2)/6

        !1.a.1.* add singly
        call t3sglh11(wrk(posw),dima,nhelp1,nhelp2,wrk(poss1),wrk(posd1),1)
      end if

      !1.a.2---- 2nd. triade   W(abc) <- -s1(_j,a) . d1(_ik,bc)
      !                                  +s1(_j,b) . d1(_ik,ac)
      !                                  -s1(_j,c) . d1(_ik,ab)

      if ((symj == syma) .and. (symik == symbc)) then
        !1.a.2.* find address for s1,d1
        is1 = h2%i(1,1,1)
        id1 = m2%i(symb,1,1)

        !1.a.2.* def position of s1,d1
        poss1 = h2%d(is1,1)
        posd1 = m2%d(id1,1)

        !1.a.2.* def additional dimensions
        nhelp1 = dima*(dima-1)/2
        nhelp2 = dima*(dima-1)*(dima-2)/6

        !1.a.2.* add singly
        call t3sglh11(wrk(posw),dima,nhelp1,nhelp2,wrk(poss1),wrk(posd1),-1)
      end if

      !1.a.3---- 3rd. triade   W(abc) <- +s1(_k,a) . d1(_ij,bc)
      !                                  -s1(_k,b) . d1(_ij,ac)
      !                                  +s1(_k,c) . d1(_ij,ab)

      if ((symk == syma) .and. (symij == symbc)) then

        !1.a.3.* find address for s1,d1
        is1 = h3%i(1,1,1)
        id1 = m3%i(symb,1,1)

        !1.a.3.* def position of s1,d1
        poss1 = h3%d(is1,1)
        posd1 = m3%d(id1,1)

        !1.a.3.* def additional dimensions
        nhelp1 = dima*(dima-1)/2
        nhelp2 = dima*(dima-1)*(dima-2)/6

        !1.a.3.* add singly
        call t3sglh11(wrk(posw),dima,nhelp1,nhelp2,wrk(poss1),wrk(posd1),1)
      end if

    else if (syma == symb) then
      !1.b case syma=symb/=symc

      !1.b.1---- 1st. triade   W(abc) <- +s1(_i,a) . d1(_jk,bc)
      !                                  -s1(_i,b) . d1(_jk,ac)
      !                                  +s1(_i,c) . d1(_jk,ab)

      if ((symi == syma) .and. (symjk == symbc)) then
        ! if syma=symi, then obviously symc/=symi
        !1.b.1.* find address for s1,d1
        is1 = h1%i(1,1,1)
        id1 = m1%i(syma,1,1)

        !1.b.1.* def position of s1,d1
        poss1 = h1%d(is1,1)
        posd1 = m1%d(id1,1)

        !1.b.1.* def additional dimensions
        nhelp1 = dima*(dima-1)/2

        !1.b.1.* add singly
        call t3sglh121(wrk(posw),dima,nhelp1,dimc,wrk(poss1),wrk(posd1),1)
      else if ((symc == symi) .and. (symjk == symab)) then
        !1.b.1.* find address for s3,d3
        is3 = h1%i(1,1,1)
        id3 = m1%i(syma,1,1)

        !1.b.1.* def position of s1,d3
        poss3 = h1%d(is3,1)
        posd3 = m1%d(id3,1)

        !1.b.1.* def additional dimensions
        nhelp1 = dima*(dima-1)/2

        !1.b.1.* add singly
        call t3sglh122(wrk(posw),nhelp1,dimc,wrk(poss3),wrk(posd3),1)
      end if

      !1.b.2---- 2nd. triade   W(abc) <- -s1(_j,a) . d1(_ik,bc)
      !                                  +s1(_j,b) . d1(_ik,ac)
      !                                  -s1(_j,c) . d1(_ik,ab)

      if ((symj == syma) .and. (symik == symbc)) then
        ! if syma=symj, then obviously symc/=symj
        !1.b.2.* find address for s1,d1
        is1 = h2%i(1,1,1)
        id1 = m2%i(syma,1,1)

        !1.b.2.* def position of s1,d1
        poss1 = h2%d(is1,1)
        posd1 = m2%d(id1,1)

        !1.b.2.* def additional dimensions
        nhelp1 = dima*(dima-1)/2

        !1.b.2.* add singly
        call t3sglh121(wrk(posw),dima,nhelp1,dimc,wrk(poss1),wrk(posd1),-1)
      else if ((symc == symj) .and. (symik == symab)) then
        !1.b.2.* find address for s3,d3
        is3 = h2%i(1,1,1)
        id3 = m2%i(syma,1,1)

        !1.b.2.* def position of s1,d3
        poss3 = h2%d(is3,1)
        posd3 = m2%d(id3,1)

        !1.b.2.* def additional dimensions
        nhelp1 = dima*(dima-1)/2

        !1.b.2.* add singly
        call t3sglh122(wrk(posw),nhelp1,dimc,wrk(poss3),wrk(posd3),-1)
      end if

      !1.b.3---- 3rd. triade   W(abc) <- +s1(_k,a) . d1(_ij,bc)
      !                                  -s1(_k,b) . d1(_ij,ac)
      !                                  +s1(_k,c) . d1(_ij,ab)

      if ((symk == syma) .and. (symij == symbc)) then
        ! if syma=symk, then obviously symc/=symk
        !1.b.3.* find address for s1,d1
        is1 = h3%i(1,1,1)
        id1 = m3%i(syma,1,1)

        !1.b.3.* def position of s1,d1
        poss1 = h3%d(is1,1)
        posd1 = m3%d(id1,1)

        !1.b.3.* def additional dimensions
        nhelp1 = dima*(dima-1)/2

        !1.b.3.* add singly
        call t3sglh121(wrk(posw),dima,nhelp1,dimc,wrk(poss1),wrk(posd1),1)
      else if ((symc == symk) .and. (symij == symab)) then
        !1.b.3.* find address for s3,d3
        is3 = h3%i(1,1,1)
        id3 = m3%i(syma,1,1)

        !1.b.3.* def position of s1,d3
        poss3 = h3%d(is3,1)
        posd3 = m3%d(id3,1)

        !1.b.3.* def additional dimensions
        nhelp1 = dima*(dima-1)/2

        !1.b.3.* add singly
        call t3sglh122(wrk(posw),nhelp1,dimc,wrk(poss3),wrk(posd3),1)
      end if

    else if (symb == symc) then
      !1.c  case syma/=symb=symc

      !1.c.1---- 1st. triade   W(abc) <- +s1(_i,a) . d1(_jk,bc)
      !                                  -s1(_i,b) . d1(_jk,ac)
      !                                  +s1(_i,c) . d1(_jk,ab)

      if ((symi == syma) .and. (symjk == symbc)) then
        ! if syma=symi, then obviously symb(symc)/=symi
        !1.c.1.* find address for s1,d1
        is1 = h1%i(1,1,1)
        id1 = m1%i(symb,1,1)

        !1.c.1.* def position of s1,d1
        poss1 = h1%d(is1,1)
        posd1 = m1%d(id1,1)

        !1.c.1.* def additional dimensions
        nhelp1 = dimb*(dimb-1)/2

        !1.c.1.* add singly
        call t3sglh131(wrk(posw),dima,nhelp1,wrk(poss1),wrk(posd1),1)
      else if ((symb == symi) .and. (symjk == symac)) then
        !1.c.1.* find address for s3,d3
        is2 = h1%i(1,1,1)
        id2 = m1%i(syma,1,1)

        !1.c.1.* def position of s1,d3
        poss2 = h1%d(is2,1)
        posd2 = m1%d(id2,1)

        !1.c.1.* def additional dimensions
        nhelp1 = dimb*(dimb-1)/2

        !1.c.1.* add singly
        call t3sglh132(wrk(posw),dima,dimb,nhelp1,wrk(poss2),wrk(posd2),1)
      end if

      !1.c.2---- 2nd. triade   W(abc) <- -s1(_j,a) . d1(_ik,bc)
      !                                  +s1(_j,b) . d1(_ik,ac)
      !                                  -s1(_j,c) . d1(_ik,ab)

      if ((symj == syma) .and. (symik == symbc)) then
        ! if syma=symj, then obviously symb(symc)/=symi
        !1.c.2.* find address for s1,d1
        is1 = h2%i(1,1,1)
        id1 = m2%i(symb,1,1)

        !1.c.2.* def position of s1,d1
        poss1 = h2%d(is1,1)
        posd1 = m2%d(id1,1)

        !1.c.2.* def additional dimensions
        nhelp1 = dimb*(dimb-1)/2

        !1.c.2.* add singly
        call t3sglh131(wrk(posw),dima,nhelp1,wrk(poss1),wrk(posd1),-1)
      else if ((symb == symj) .and. (symik == symac)) then
        !1.c.2.* find address for s3,d3
        is2 = h2%i(1,1,1)
        id2 = m2%i(syma,1,1)

        !1.c.2.* def position of s1,d3
        poss2 = h2%d(is2,1)
        posd2 = m2%d(id2,1)

        !1.c.2.* def additional dimensions
        nhelp1 = dimb*(dimb-1)/2

        !1.c.2.* add singly
        call t3sglh132(wrk(posw),dima,dimb,nhelp1,wrk(poss2),wrk(posd2),-1)
      end if

      !1.c.3---- 3rd. triade   W(abc) <- +s1(_k,a) . d1(_ij,bc)
      !                                  -s1(_k,b) . d1(_ij,ac)
      !                                  +s1(_k,c) . d1(_ij,ab)

      if ((symk == syma) .and. (symij == symbc)) then
        ! if syma=symk, then obviously symb(symc)/=symk
        !1.c.3.* find address for s1,d1
        is1 = h3%i(1,1,1)
        id1 = m3%i(symb,1,1)

        !1.c.3.* def position of s1,d1
        poss1 = h3%d(is1,1)
        posd1 = m3%d(id1,1)

        !1.c.3.* def additional dimensions
        nhelp1 = dimb*(dimb-1)/2

        !1.c.3.* add singly
        call t3sglh131(wrk(posw),dima,nhelp1,wrk(poss1),wrk(posd1),1)
      else if ((symb == symk) .and. (symij == symac)) then
        !1.c.3.* find address for s3,d3
        is2 = h3%i(1,1,1)
        id2 = m3%i(syma,1,1)

        !1.c.3.* def position of s1,d3
        poss2 = h3%d(is2,1)
        posd2 = m3%d(id2,1)

        !1.c.3.* def additional dimensions
        nhelp1 = dimb*(dimb-1)/2

        !1.c.3.* add singly
        call t3sglh132(wrk(posw),dima,dimb,nhelp1,wrk(poss2),wrk(posd2),1)
      end if

    else
      !1.d case syma/=symb/=symc

      !1.d.1---- 1st. triade   W(abc) <- +s1(_i,a) . d1(_jk,bc)
      !                                  -s1(_i,b) . d1(_jk,ac)
      !                                  +s1(_i,c) . d1(_jk,ab)

      if ((symi == syma) .and. (symjk == symbc)) then
        !1.d.1.* find address for s1,d1
        is1 = h1%i(1,1,1)
        id1 = m1%i(symb,1,1)

        !1.d.1.* def position of s1,d1
        poss1 = h1%d(is1,1)
        posd1 = m1%d(id1,1)

        !1.d.1.* add singly
        call t3sglh141(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),1)
      else if ((symi == symb) .and. (symjk == symac)) then
        !1.d.1.* find address for s2,d2
        is2 = h1%i(1,1,1)
        id2 = m1%i(syma,1,1)

        !1.d.1.* def position of s1,d1
        poss2 = h1%d(is2,1)
        posd2 = m1%d(id2,1)

        !1.d.1.* add singly
        call t3sglh142(wrk(posw),dima,dimb,dimc,wrk(poss2),wrk(posd2),1)
      else if ((symi == symc) .and. (symjk == symab)) then
        !1.d.1.* find address for s1,d1
        is3 = h1%i(1,1,1)
        id3 = m1%i(syma,1,1)

        !1.d.1.* def position of s1,d1
        poss3 = h1%d(is3,1)
        posd3 = m1%d(id3,1)

        !1.d.1.* add singly
        call t3sglh143(wrk(posw),dima,dimb,dimc,wrk(poss3),wrk(posd3),1)
      end if

      !1.d.2---- 2nd. triade   W(abc) <- -s1(_j,a) . d1(_ik,bc)
      !                                  +s1(_j,b) . d1(_ik,ac)
      !                                  -s1(_j,c) . d1(_ik,ab)

      if ((symj == syma) .and. (symik == symbc)) then
        !1.d.2.* find address for s1,d1
        is1 = h2%i(1,1,1)
        id1 = m2%i(symb,1,1)

        !1.d.2.* def position of s1,d1
        poss1 = h2%d(is1,1)
        posd1 = m2%d(id1,1)

        !1.d.2.* add singly
        call t3sglh141(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),-1)
      else if ((symj == symb) .and. (symik == symac)) then
        !1.d.2.* find address for s2,d2
        is2 = h2%i(1,1,1)
        id2 = m2%i(syma,1,1)

        !1.d.2.* def position of s1,d1
        poss2 = h2%d(is2,1)
        posd2 = m2%d(id2,1)

        !1.d.2.* add singly
        call t3sglh142(wrk(posw),dima,dimb,dimc,wrk(poss2),wrk(posd2),-1)
      else if ((symj == symc) .and. (symik == symab)) then
        !1.d.2.* find address for s1,d1
        is3 = h2%i(1,1,1)
        id3 = m2%i(syma,1,1)

        !1.d.2.* def position of s1,d1
        poss3 = h2%d(is3,1)
        posd3 = m2%d(id3,1)

        !1.d.2.* add singly
        call t3sglh143(wrk(posw),dima,dimb,dimc,wrk(poss3),wrk(posd3),-1)
      end if

      !1.d.3---- 3rd. triade   W(abc) <- +s1(_k,a) . d1(_ij,bc)
      !                                  -s1(_k,b) . d1(_ij,ac)
      !                                  +s1(_k,c) . d1(_ij,ab)

      if ((symk == syma) .and. (symij == symbc)) then
        !1.d.3.* find address for s1,d1
        is1 = h3%i(1,1,1)
        id1 = m3%i(symb,1,1)

        !1.d.3.* def position of s1,d1
        poss1 = h3%d(is1,1)
        posd1 = m3%d(id1,1)

        !1.d.3.* add singly
        call t3sglh141(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),1)
      else if ((symk == symb) .and. (symij == symac)) then
        !1.d.3.* find address for s2,d2
        is2 = h3%i(1,1,1)
        id2 = m3%i(syma,1,1)

        !1.d.3.* def position of s1,d1
        poss2 = h3%d(is2,1)
        posd2 = m3%d(id2,1)

        !1.d.3.* add singly
        call t3sglh142(wrk(posw),dima,dimb,dimc,wrk(poss2),wrk(posd2),1)
      else if ((symk == symc) .and. (symij == symab)) then
        !1.d.3.* find address for s1,d1
        is3 = h3%i(1,1,1)
        id3 = m3%i(syma,1,1)

        !1.d.3.* def position of s1,d1
        poss3 = h3%d(is3,1)
        posd3 = m3%d(id3,1)

        !1.d.3.* add singly
        call t3sglh143(wrk(posw),dima,dimb,dimc,wrk(poss3),wrk(posd3),1)
      end if

    end if

  end do

else if (typdiv == 2) then
  !2 case W(pq,r)

  !2.* ext H1(a) <= S1(a,i) for given i
  call ext(wrk,wrksize,2,2,i,0,symi,0,0,s1,1,h1,ssh1,rc1)

  !2.* ext H2(a) <= S1(a,j) for given j
  call ext(wrk,wrksize,2,2,j,0,symj,0,0,s1,1,h2,ssh2,rc1)

  !2.* ext H3(a) <= S2(a,k) for given k
  call ext(wrk,wrksize,2,2,k,0,symk,0,0,s2,1,h3,ssh3,rc1)

  !2.* ext M1(bc) <= D2(bc,jk) for given jk
  call ext(wrk,wrksize,4,7,j,k,symj,symk,0,d2,1,m1,ssm1,rc1)

  !2.* ext M2(bc) <= D2(bc,ik) for given ik
  call ext(wrk,wrksize,4,7,i,k,symi,symk,0,d2,1,m2,ssm2,rc1)

  !2.* ext M3(bc) <= D1(bc,ij) for given ij
  call ext(wrk,wrksize,4,7,i,j,symi,symj,0,d1,1,m3,ssm3,rc1)

  do iw=1,w%d(0,5)

    !2.* def position of W
    posw = w%d(iw,1)

    !2.* def symmetry status
    syma = w%d(iw,3)
    symb = w%d(iw,4)
    symc = w%d(iw,5)

    !2.* def dimensions
    dima = dimm(w%d(0,1),syma)
    dimb = dimm(w%d(0,2),symb)
    dimc = dimm(w%d(0,3),symc)
    !2.*
    symij = mmul(symi,symj)
    symik = mmul(symi,symk)
    symjk = mmul(symj,symk)
    symab = mmul(syma,symb)
    symac = mmul(syma,symc)
    symbc = mmul(symb,symc)

    !2.* add singles
    if (syma == symb) then
      !2.a case syma=symb,symc

      !2.a.1 1st. diade  W(ab,c)<- +s1(_i,a) . d2(_j,_k,b,c)
      !                            -s1(_i,b) . d2(_j,_k,a,c)

      if ((syma == symi) .and. (symjk == symbc)) then
        !2.a.1.* find address for s1,d1
        is1 = h1%i(1,1,1)
        id1 = m1%i(syma,1,1)

        !2.a.1.* def position of s1,d1
        poss1 = h1%d(is1,1)
        posd1 = m1%d(id1,1)

        !2.a.1.* def additional dimensions
        nhelp1 = dima*(dima-1)/2

        !2.a.1.* add singly
        call t3sglh211(wrk(posw),dima,nhelp1,dimc,wrk(poss1),wrk(posd1),1)
      end if

      !2.a.2 2nd. diade        W(ab,c)<- -s1(_j,a) . d2(_i,_k,b,c)
      !                                  +s1(_j,b) . d2(_i,_k,a,c)

      if ((syma == symj) .and. (symik == symbc)) then
        !2.a.2.* find address for s1,d1
        is1 = h2%i(1,1,1)
        id1 = m2%i(syma,1,1)

        !2.a.2.* def position of s1,d1
        poss1 = h2%d(is1,1)
        posd1 = m2%d(id1,1)

        !2.a.1.* def additional dimensions
        nhelp1 = dima*(dima-1)/2

        !2.a.2.* add singly
        call t3sglh211(wrk(posw),dima,nhelp1,dimc,wrk(poss1),wrk(posd1),-1)
      end if

      !2.a.3 3rd. part  W(ab,c)<- +s2(_k,c) . d1(_ij,ab)

      if ((symc == symk) .and. (symij == symab)) then
        !2.a.3.* find address for s1,d1
        is1 = h3%i(1,1,1)
        id1 = m3%i(syma,1,1)

        !2.a.3.* def position of s1,d1
        poss1 = h3%d(is1,1)
        posd1 = m3%d(id1,1)

        !2.a.3.* def additional dimensions
        nhelp1 = dima*(dima-1)/2

        !2.a.3.* add singly
        call t3sglh212(wrk(posw),nhelp1,dimc,wrk(poss1),wrk(posd1),1)
      end if

    else
      !2.b case syma>symb,symc

      !2.b.1 1st.diade  W(a>b,c)<- +s1(_i,a) . d2(_j,_k,b,c)
      !                            -s1(_i,b) . d2(_j,_k,a,c)

      if ((syma == symi) .and. (symjk == symbc)) then
        !2.b.1.* find address for s1,d1
        is1 = h1%i(1,1,1)
        id1 = m1%i(symb,1,1)

        !2.b.1.* def position of s1,d1
        poss1 = h1%d(is1,1)
        posd1 = m1%d(id1,1)

        !2.b.1.* add singly
        call t3sglh221(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),1)
      else if ((symb == symi) .and. (symjk == symac)) then
        !2.b.1.* find address for s2,d2
        is2 = h1%i(1,1,1)
        id2 = m1%i(syma,1,1)

        !2.b.1.* def position of s1,d1
        poss2 = h1%d(is2,1)
        posd2 = m1%d(id2,1)

        !2.b.1.* add singly
        call t3sglh222(wrk(posw),dima,dimb,dimc,wrk(poss2),wrk(posd2),1)
      end if

      !2.a.2 2nd. diade        W(ab,c)<- -s1(_j,a) . d2(_i,_k,b,c)
      !                                  +s1(_j,b) . d2(_i,_k,a,c)

      if ((syma == symj) .and. (symik == symbc)) then
        !2.b.2.* find address for s1,d1
        is1 = h2%i(1,1,1)
        id1 = m2%i(symb,1,1)

        !2.b.2.* def position of s1,d1
        poss1 = h2%d(is1,1)
        posd1 = m2%d(id1,1)

        !2.b.2.* add singly
        call t3sglh221(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),-1)
      else if ((symb == symj) .and. (symik == symac)) then
        !2.b.2.* find address for s2,d2
        is2 = h2%i(1,1,1)
        id2 = m2%i(syma,1,1)

        !2.b.2.* def position of s1,d1
        poss2 = h2%d(is2,1)
        posd2 = m2%d(id2,1)

        !2.b.2.* add singly
        call t3sglh222(wrk(posw),dima,dimb,dimc,wrk(poss2),wrk(posd2),-1)
      end if

      !2.a.3 3rd. part  W(ab,c)<- +s2(_k,c) . d1(_ij,ab)

      if ((symc == symk) .and. (symij == symab)) then
        !2.b.3.* find address for s1,d1
        is3 = h3%i(1,1,1)
        id3 = m3%i(syma,1,1)

        !2.b.3.* def position of s1,d1
        poss3 = h3%d(is3,1)
        posd3 = m3%d(id3,1)

        !2.b.3.* add singly
        call t3sglh223(wrk(posw),dima,dimb,dimc,wrk(poss3),wrk(posd3),1)
      end if

    end if

  end do

else if (typdiv == 3) then
  !3 case B(p,qr)

  !3.* ext H1(a) <= S1(a,i) for given i
  call ext(wrk,wrksize,2,2,i,0,symi,0,0,s1,1,h1,ssh1,rc1)

  !3.* ext H2(a) <= S2(a,j) for given j
  call ext(wrk,wrksize,2,2,j,0,symj,0,0,s2,1,h2,ssh2,rc1)

  !3.* ext H3(a) <= S2(a,k) for given k
  call ext(wrk,wrksize,2,2,k,0,symk,0,0,s2,1,h3,ssh3,rc1)

  !3.* ext M1(bc) <= D2(bc,jk) for given jk
  call ext(wrk,wrksize,4,7,j,k,symj,symk,0,d2,1,m1,ssm1,rc1)

  !3.* ext M2(bc) <= D1(bc,ik) for given ik
  call ext(wrk,wrksize,4,7,i,k,symi,symk,0,d1,1,m2,ssm2,rc1)

  !3.* ext M3(bc) <= D1(bc,ij) for given ij
  call ext(wrk,wrksize,4,7,i,j,symi,symj,0,d1,1,m3,ssm3,rc1)

  do iw=1,w%d(0,5)

    !3.* def position of W,V
    posw = w%d(iw,1)

    !3.* def symmetry status
    syma = w%d(iw,3)
    symb = w%d(iw,4)
    symc = w%d(iw,5)

    !3.* def dimensions
    dima = dimm(w%d(0,1),syma)
    dimb = dimm(w%d(0,2),symb)
    dimc = dimm(w%d(0,3),symc)

    !3.* realize packing

    if (symb == symc) then
      !3.a case syma,symb=symc

      !3.a.1 1st. part  W(a,bc)<- +s1(_i,a) . d2(_jk,b,c)

      if (symi == syma) then
        !3.a.1.* find address for s1,d1
        is1 = h1%i(1,1,1)
        id1 = m1%i(symb,1,1)

        !3.a.1.* def position of s1,d1
        poss1 = h1%d(is1,1)
        posd1 = m1%d(id1,1)

        !3.a.1.* def additional dimensions
        nhelp1 = dimb*(dimb-1)/2

        !3.a.1.* add singly
        call t3sglh312(wrk(posw),dima,nhelp1,wrk(poss1),wrk(posd1),1)
      end if

      !3.a.2 2nd. diade        W(a,bc)<- +s1(_j,b) . d2(_i,_k,a,c)
      !                                  -s1(_j,c) . d2(_i,_k,a,b)

      if (symj == symb) then
        !3.a.2.* find address for s1,d1
        is1 = h2%i(1,1,1)
        id1 = m2%i(syma,1,1)

        !3.a.2.* def position of s1,d1
        poss1 = h2%d(is1,1)
        posd1 = m2%d(id1,1)

        !3.a.2.* def additional dimensions
        nhelp1 = dimb*(dimb-1)/2

        !3.a.2.* add singly
        call t3sglh311(wrk(posw),dima,dimb,nhelp1,wrk(poss1),wrk(posd1),1)
      end if

      !3.a.3 3rd. diade  W(a,bc)<- -s1(_k,b) . d2(_i,_j,a,c)
      !                            +s1(_k,c) . d2(_i,_j,a,b)

      if (symk == symb) then
        !3.a.3.* find address for s1,d1
        is1 = h3%i(1,1,1)
        id1 = m3%i(syma,1,1)

        !3.a.3.* def position of s1,d1
        poss1 = h3%d(is1,1)
        posd1 = m3%d(id1,1)

        !3.a.3.* def additional dimensions
        nhelp1 = dimb*(dimb-1)/2

        !3.a.3.* add singly
        call t3sglh311(wrk(posw),dima,dimb,nhelp1,wrk(poss1),wrk(posd1),-1)
      end if

    else
      !3.b case syma,symb/=symc

      !3.b.1 1st. part  W(a,bc)<- +s1(_i,a) . d2(_jk,b,c)

      if (symi == syma) then
        !3.b.1.* find address for s1,d1
        is1 = h1%i(1,1,1)
        id1 = m1%i(symb,1,1)

        !3.b.1.* def position of s1,d1
        poss1 = h1%d(is1,1)
        posd1 = m1%d(id1,1)

        !3.b.1.* add singly
        call t3sglh323(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),1)
      end if

      !3.b.2 2nd. diade        W(a,bc)<- +s1(_j,b) . d2(_i,_k,a,c)
      !                                  -s1(_j,c) . d2(_i,_k,a,b)

      if (symj == symb) then
        !3.b.2.* find address for s1,d1
        is1 = h2%i(1,1,1)
        id1 = m2%i(syma,1,1)

        !3.b.2.* def position of s1,d1
        poss1 = h2%d(is1,1)
        posd1 = m2%d(id1,1)

        !3.b.2.* add singly
        call t3sglh321(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),1)
      else if (symj == symc) then
        !3.b.2.* find address for s1,d1
        is1 = h2%i(1,1,1)
        id1 = m2%i(syma,1,1)

        !3.b.2.* def position of s1,d1
        poss1 = h2%d(is1,1)
        posd1 = m2%d(id1,1)

        !3.b.2.* add singly
        call t3sglh322(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),1)
      end if

      !3.b.3 3rd. diade  W(a,bc)<- -s1(_k,b) . d2(_i,_j,a,c)
      !                            +s1(_k,c) . d2(_i,_j,a,b)

      if (symk == symb) then
        !3.b.3.* find address for s1,d1
        is1 = h3%i(1,1,1)
        id1 = m3%i(syma,1,1)

        !3.b.3.* def position of s1,d1
        poss1 = h3%d(is1,1)
        posd1 = m3%d(id1,1)

        !3.b.3.* add singly
        call t3sglh321(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),-1)
      else if (symk == symc) then
        !3.b.3.* find address for s1,d1
        is1 = h3%i(1,1,1)
        id1 = m3%i(syma,1,1)

        !3.b.3.* def position of s1,d1
        poss1 = h3%d(is1,1)
        posd1 = m3%d(id1,1)

        !3.b.3.* add singly
        call t3sglh322(wrk(posw),dima,dimb,dimc,wrk(poss1),wrk(posd1),-1)
      end if

    end if

  end do

else
  ! RC=1 , typdiv is not 1,2,3 (NCI)
  return

end if

return

end subroutine t3sgl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_RDDBUF(DIAG,BUF,IBUF,INDRSH,INDRED,
     &                      LENBUF,LMMBSTRT,NDUMP)
C
C     Purpose: read diagonal from disk and set first reduced set
C              indices.
C
#include "implicit.fh"
      DIMENSION DIAG(*), BUF(LENBUF)
      INTEGER   IBUF(4,LENBUF)
      INTEGER   INDRSH(LMMBSTRT), INDRED(LMMBSTRT,3)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_RDDBUF')

      IIBSTRSH(I,J,K)=IWORK(ip_IIBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      ISP2F(I)=IWORK(ip_iSP2F-1+I)

      IF (LENBUF .LT. LBUF) THEN
         WRITE(LUPRI,'(//,1X,A,A)') SECNAM,
     &                              ': LENBUF >= LBUF required!'
         WRITE(LUPRI,'(1X,A,I10)')    'LENBUF = ',LENBUF
         WRITE(LUPRI,'(1X,A,I10,/)')  'LBUF   = ',LBUF
         CALL CHO_QUIT('Buffer error in '//SECNAM,102)
      END IF

      IUNIT = LUSCR
      LUSCR = -1
      REWIND(IUNIT)

      DO IDUMP = 1,NDUMP
         CALL CHO_RDBUF(LENGTH,BUF,IBUF,LBUF,IUNIT)
         IF (IDUMP .EQ. NDUMP) THEN
             CALL CHO_CLOSE(IUNIT,'DELETE')
         END IF
         DO L = 1,LENGTH
            IF (IBUF(2,L) .GT. 0) THEN
               ISHLAB = IBUF(1,L)
               ISYMAB = IBUF(3,L)
               IAB    = IIBSTR(ISYMAB,1) + IIBSTRSH(ISYMAB,ISHLAB,1)
     &                + IBUF(2,L)
               DIAG(IAB) = BUF(L)
               INDRSH(IAB) = ISP2F(ISHLAB)
               INDRED(IAB,1) = IBUF(4,L)
            END IF
         END DO
      END DO

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Anders Bernhardsson                              *
*               1991, Roland Lindh                                     *
************************************************************************
      SubRoutine M1Hss(
#define _CALLING_
#include "hss_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: to compute the gradient of the nuclear attraction integrals. *
*                                                                      *
*     Author: Anders Bernhardsson & Roland Lindh,                      *
*             Dept. of Theoretical Chemistry, University               *
*             of Lund, SWEDEN.                                         *
*             October 1991                                             *
************************************************************************
      use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "disp.fh"
#include "disp2.fh"

#include "hss_interface.fh"

*     Local variables
      Integer iDCRT(0:7)
      Real*8 C(3), TC(3)
      Logical TstFnc, TF, EQ, IfG(0:3),Tr(0:3)
      Real*8 Coora(3,4), Coori(3,4), CoorAC(3,2)
      Integer iAnga(4), JndGrd(0:2,0:3,0:7),
     &           JndHss(0:3,0:2,0:3,0:2,0:7),
     &           mOp(4), iuvwx(4)
      Logical JfHss(0:3,0:2,0:3,0:2),JfGrd(0:2,0:3)
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      IX(i1,i2)=i1*(i1-1)/2+i2
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*
c     If (iPrint.ge.99) Then
c        Write (6,*) ' In M1Hss: nArr=',nArr
c     End If
*
      nRys=nHer
*
      nip = 1
      ipA = nip
      nip = nip + nAlpha*nBeta
      ipB = nip
      nip = nip + nAlpha*nBeta
      ipArr = nip
      nArray = nArr - nip +1
*
      iIrrep = 0
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = 0
      iAnga(4) = 0
      call dcopy_(3,A,1,Coora(1,1),1)
      call dcopy_(3,RB,1,Coora(1,2),1)
      call dcopy_(3,A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
      If (la.ge.lb) Then
         call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
         call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      mOp(1) = nOp(1)
      mOp(2) = nOp(2)
*
      ipAOff = ipA
      Do 200 iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
 200  Continue
*
      ipBOff = ipB
      Do 210 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
 210  Continue
*
*     Modify the density matrix with the prefactor
*
      nDAO = nElem(la) * nElem(lb)
*     Do 300 iDAO = 1, nDAO
*        Do 310 iZeta = 1, nZeta
*           Fact = Two*rkappa(iZeta)*Pi*ZInv(iZeta)
*           DAO(iZeta,iDAO) = Fact * DAO(iZeta,iDAO)
*310     Continue
*300  Continue
c     If (iPrint.ge.99) Call RecPrt('DAO',' ',DAO,nZeta,nDAO)
*


*     Here we go
*
*-----Loop over nuclear centers
*
      kdc = 0
      Do 100 kCnttp = 1, nCnttp
         If (dbsc(kCnttp)%Charge.eq.Zero) Go To 111
         Do 101 kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3)=dbsc(kCnttp)%Coor(1:3,kCnt)
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Do 102 lDCRT = 0, nDCRT-1
               Call ICopy(nSym*16*9,[0],0,JndHss,1)
               Call iCopy(nSym*4*3,[0],0,JndGrd,1)
               Call LCopy(144,[.False.],0,jfHss,1)
               Call LCopy(4,[.False.],0,Tr,1)
               Call LCopy(12,[.False.],0,jfGrd,1)
               mOp(3) = NrOpr(iDCRT(lDCRT))
               mOp(4) = mOp(3)
               Call OA(iDCRT(lDCRT),C,TC)
               call dcopy_(3,TC,1,CoorAC(1,2),1)
               call dcopy_(3,TC,1,Coora(1,3),1)
               call dcopy_(3,TC,1,Coora(1,4),1)
               call dcopy_(3,TC,1,Coori(1,3),1)
               call dcopy_(3,TC,1,Coori(1,4),1)
               If (EQ(A,TC).and.EQ(A,RB)) Goto 102
*
*              COPY CNTLR MATRIXES
*
                Do  iAtom = 0, 1
                  Do iCar  = 0, 2
                    JfGrd(iCar,iAtom) = Ifgrd(iCar,iAtom)
                    Do iIrrep=0,nSym-1
                      JndGrd(iCar,iAtom,iIrrep)=
     &                   IndGrd(iCar,iAtom,iIrrep)
                    End Do
                    Do  jAtom = 0, 1
                      Do  jCar = 0, 2
                        JfHss(iAtom,iCar,jAtom,jCar) =
     &                    IfHss(iAtom,iCar,jAtom,jCar)
                        Do iIrrep=0,nSym-1
                          JndHss(iAtom,iCar,jAtom,jCar,iIrrep) =
     &                     IndHss(iAtom,iCar,jAtom,jCar,iIrrep)
                        End Do
                      End Do
                    End Do
                  End Do
                End Do

*
                Fact = -dbsc(kCnttp)%Charge*DBLE(nStabM) /
     &             DBLE(LmbdT)
*               Call DYaX(nZeta*nDAO,Fact,DAO,1,Array(ipDAO),1)
                iuvwx(3) = dc(kdc+kCnt)%nStab
                iuvwx(4) = dc(kdc+kCnt)%nStab
*
*-----------Derivatives with respect to the operator is computed via the
*           translational invariance.
*
                nnIrrep=nSym
                If (sIrrep) nnIrrep=1
                Do 230 iIrrep=0,nnIrrep-1
                 nDisp = IndDsp(kdc+kCnt,iIrrep)
                 Do 220 iCar = 0, 2
                    iComp = 2**iCar
                    If (TF(kdc+kCnt,iIrrep,iComp)) Then
                       nDisp = nDisp + 1
*
*--------------------Reset flags for the basis set centers so that we
*                    will explicitly compute the derivatives with
*                    respect to those centers. Activate flag for the
*                    third center so that its derivative will be comp-
*                    uted by the translational invariance.
*
                      JndGrd(iCar,0,iIrrep) = Abs(JndGrd(iCar,0,iIrrep))
                      JndGrd(iCar,1,iIrrep) = Abs(JndGrd(iCar,1,iIrrep))
                      JndGrd(iCar,2,iIrrep) = -nDisp
                      JfGrd(iCar,0) = .True.
                      JfGrd(iCar,1) = .True.
                      JfGrd(iCar,2) = .False.
                    Else
                      JndGrd(iCar,2,iIrrep) = 0
                    End If
 220             Continue
 230         Continue
*
*            The third center is claculated by translation invarians
*            This requires the 2nd derivatives on the other centers.
*

             Do iCar=0,2
              Do jAtom=0,2
                if (jAtom.eq.2) Then
                  iStop=iCar
                Else
                  iStop=2
                End If
                Do jCar=0,iStop
                 Do iIrrep=0,nSym-1
                  If ((JndGrd(iCar,2,iIrrep).ne.0).and.
     &                (JndGrd(jCar,jAtom,iIrrep).ne.0)) Then
                   JndHss(2,iCar,jAtom,jCar,iIrrep)=
     &                 -IX(Max(Abs(JndGrd(iCar,2,iIrrep)),
     &                 Abs(JndGrd(jCar,jAtom,iIrrep))),
     &                 Min(Abs(JndGrd(iCar,2,iIrrep)),
     &                 Abs(JndGrd(jCar,jAtom,iIrrep))))

                 Tr(2)=.true.
                 If (jAtom.eq.2) Then
                  Maxi=Max(iCar,jCar)
                  Mini=Min(iCar,jCar)
                  jfHss(0,Maxi,0,Mini)=.true.
                  jfHss(1,Maxi,1,Mini)=.true.
                  jfHss(1,iCar,0,jCar)=.true.
                  jfHss(1,jCar,0,iCar)=.true.
                 Else
                  Maxi=Max(iCar,jCar)
                  Mini=Min(iCar,jCar)
                  jfHss(jAtom,Maxi,jAtom,Mini)=.true.
                  jfHss(1,iCar,0,jCar)=.true.
                  jfHss(1,jCar,0,iCar)=.true.
                 End If
                 End If
                 End Do
                End Do
               End Do
              End Do
*
               IfG(0)=.true.
               IfG(1)=.true.
               IfG(2)=.false.
               IfG(3)=.false.
               Do iCent=0,1
                 If (EQ(Coori(1,iCent+1),Coori(1,3) ) ) Then
                 IfG(iCent)=.false.
                 Do iCar=0,2
                   jfGrd(iCar,iCent)=.false.
                   Do kCar=0,2
                    Do KCent=0,3
                     jfHss(iCent,iCar,kCent,kCar)=.false.
                     jfHss(kCent,kCar,iCent,iCar)=.false.
                     Do iIrrep=0,nSym-1
                      jndHss(iCent,iCar,kCent,kCar,iIrrep)=0
                      jndHss(kCent,kCar,iCent,iCar,iIrrep)=0
                     End Do
                    End Do
                   End Do
                   Do iIrrep=0,nSym-1
                      jndGrd(iCar,iCent,iIrrep)=0
                   End Do
                 End Do
                 End If
               End Do
               Call lCopy(12,[.false.],0,jfgrd,1)
*
               call M1Kernel(Final,Hess,nHess,DAO,nDAO,
     &                   iAnga,nRys,nZeta,
     &                   Array(ipA),Array(ipB),Zeta,ZInv,
     &                   rKappa,P,TC,Coori,Coorac,
     &                   Array(ipArr),nArray,
     &                   jfgrd,jndgrd,jfhss,jndhss,
     &                   ifg,tr,mop,iuvwx,
     &                   kCnttp,Fact,loper(1),0)

*
 102        Continue
 101     Continue
 111     kdc = kdc + dbsc(kCnttp)%nCntr
 100  Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Ccoor)
         Call Unused_integer(nOrdOp)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKGUGA_m(NSM,IPRINT)
C
C     PURPOSE: MAKE THE GUGA TABLES
C     NOTE:    TO RETAIN THE TABLES AVAILABLE FOR LATER PURPOSES
C              THE START ADRESSES OF OF THE ARRAYS ARE STORED IN
C              THE COMMON /GUGA/. THESE ARE:
C              LDRT,LDOWN,LDAW,LUP,LRAW,LNOW,LIOW,LNOCSF,LIOCSF
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
#include "gugx.fh"
#include "WrkSpc.fh"
C
      DIMENSION NSM(*)
C
C     SET UP A FULL PALDUS DRT TABLE:
C     (INITIALLY NO RESTRICTIONS ARE PUT UP)
C
      IAC=MIN(IA0,IC0)
      NVERT0=((IA0+1)*(IC0+1)*(2*IB0+IAC+2))/2-(IAC*(IAC+1)*(IAC+2))/6
      NDRT0=5*NVERT0
      NDOWN0=4*NVERT0
      NTMP=((NLEV+1)*(NLEV+2))/2
      CALL GETMEM('DRT0','ALLO','INTEGER',LDRT0,NDRT0)
      CALL GETMEM('DOWN','ALLO','INTEGER',LDOWN0,NDOWN0)
      CALL GETMEM('LTMP','ALLO','INTEGER',LTMP,NTMP)
      CALL DRT0_m (IA0,IB0,IC0,NVERT0,IWORK(LDRT0),IWORK(LDOWN0),
     *           NTMP,IWORK(LTMP))
      CALL GETMEM('LTMP','FREE','INTEGER',LTMP,NTMP)
C
      IF(IPRINT.ge.DEBUG) THEN
        Write(LF,*)
        Write(LF,*)' PALDUS DRT TABLE (UNRESTRICTED):'
        CALL PRDRT_m(NVERT0,IWORK(LDRT0),IWORK(LDOWN0))
      ENDIF
C
C     IF THIS IS A RAS CALCULATION PUT UP RESTRICTIONS BY DELETING
C     VERTICES WHICH VIOLATE THE FORMER.
C
      IF(IFCAS.NE.0) THEN
        CALL GETMEM('LV11','ALLO','INTEG',LV,NVERT0)
        CALL RESTR_m(IWORK(LDRT0),IWORK(LDOWN0),IWORK(LV))
C
C     REASSEMBLE THE DRT TABLE (REMOVE DISCONNECTED VERTICES)
C
        NDRT=5*NVERT
        NDOWN=4*NVERT
        CALL GETMEM('DRT1','ALLO','INTEG',LDRT,NDRT)
        CALL GETMEM('DWN1','ALLO','INTEG',LDOWN,NDOWN)
        CALL DRT_m(IWORK(LDRT0),IWORK(LDOWN0),IWORK(LV),
     *             IWORK(LDRT),IWORK(LDOWN))
        CALL GETMEM('LV11','FREE','INTEG',LV,NVERT0)
        CALL GETMEM('DRT0','FREE','INTEG',LDRT0,NDRT0)
        CALL GETMEM('DOWN','FREE','INTEG',LDOWN0,NDOWN0)
C
        IF(IPRINT.ge.DEBUG) THEN
          Write(LF,*)
          Write(LF,*)' PALDUS DRT TABLE (RESTRICTED):'
          CALL PRDRT_m(NVERT,IWORK(LDRT),IWORK(LDOWN))
        ENDIF
C
C     IF THIS IS A CAS CALCULATION PROCEED WITH THE UNRESTRICTED
C     DRT TABLE
C
      ELSE
        LDRT=LDRT0
        NDRT=NDRT0
        LDOWN=LDOWN0
        NDOWN=NDOWN0
        NVERT=NVERT0
      ENDIF
C
C     CALCULATE ARC WEIGHT AND LTV TABLES.
C
      NDAW=5*NVERT
      CALL GETMEM('DAW1','ALLO','INTEG',LDAW,NDAW)
      CALL MKDAW_m(IWORK(LDOWN),IWORK(LDAW),IPRINT)
C
C     COMPUTE UPCHAIN TABLE AND REVERSE ARC WEIGHTS
C
      NUP=4*NVERT
      NRAW=5*NVERT
      CALL GETMEM('LUP1','ALLO','INTEG',LUP,NUP)
      CALL GETMEM('RAW1','ALLO','INTEG',LRAW,NRAW)
      CALL MKRAW_m(IWORK(LDOWN),IWORK(LUP),IWORK(LRAW),IPRINT)
C
C     COMPUTE MIDLEVEL AND LIMITS ON MIDVERTICES
C
      NLTV=NLEV+2
      CALL GETMEM('LTV1','ALLO','INTEG',LLTV,NLTV)
      CALL MKMID_m(IWORK(LDRT),IWORK(LDAW),IWORK(LRAW),IWORK(LLTV),
     & IPRINT)
      CALL GETMEM('LTV1','FREE','INTEG',LLTV,NLTV)
C
C     FORM VARIOUS OFFSET TABLES:
C     NOTE: NIPWLK AND DOWNWLK ARE THE NUMER OF INTEGER WORDS USED
C           TO STORE THE UPPER AND LOWER WALKS IN PACKED FORM.
C
      NIPWLK=1+(MIDLEV-1)/15
      NIPWLK=MAX(NIPWLK,1+(NLEV-MIDLEV-1)/15)
      NNOW=2*NMIDV*NSYM
      NIOW=NNOW
      NNOCSF=NMIDV*(NSYM**2)
      NIOCSF=NNOCSF
      NSCR=MAX(6,3*(NLEV+1))
      CALL GETMEM('NOW1','ALLO','INTEG',LNOW,NNOW)
      CALL GETMEM('IOW1','ALLO','INTEG',LIOW,NIOW)
      CALL GETMEM('NCSF','ALLO','INTEG',LNOCSF,NNOCSF)
      CALL GETMEM('ICSF','ALLO','INTEG',LIOCSF,NIOCSF)
      CALL GETMEM('SCR1','ALLO','INTEG',LSCR,NSCR)
      CALL MKCOT_m(NSM,IWORK(LDOWN),IWORK(LNOW),IWORK(LIOW),
     *           IWORK(LIOCSF),IWORK(LNOCSF),IWORK(LSCR),IPRINT)
C
C     CONSTRUCT THE CASE LIST
C
      NICASE=NWALK*NIPWLK
      CALL GETMEM('CASE','ALLO','INTEG',LICASE,NICASE)
      CALL MKCLIST_m(NSM,IWORK(LDOWN),IWORK(LNOW),IWORK(LIOW),
     &             IWORK(LICASE),IWORK(LSCR))
      CALL GETMEM('SCR1','FREE','INTEG',LSCR,NSCR)
C
C     SET UP ENUMERATION TABLES
C
      NUSGN=MXUP*NMIDV
      NLSGN=MXDWN*NMIDV
      CALL GETMEM('IUSG','ALLO','INTEG',LUSGN,NUSGN)
      CALL GETMEM('ILSG','ALLO','INTEG',LLSGN,NLSGN)
      CALL MKSGNUM_m(IWORK(LDOWN),IWORK(LUP),IWORK(LDAW),IWORK(LRAW),
     *             IWORK(LNOW),IWORK(LIOW),IWORK(LUSGN),IWORK(LLSGN),
     *             IWORK(LICASE),IPRINT)
*     CALL GETMEM('CASE','FREE','INTEG',LICASE,NICASE)
C
C     EXIT
C
      RETURN
      END

      SUBROUTINE MKGUGA_FREE_m()
C
C     PURPOSE: FREE THE GUGA TABLES
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "gugx.fh"
#include "WrkSpc.fh"

      CALL GETMEM('DRT0/1','FREE','INTE',LDRT,NDRT)
      CALL GETMEM('DWN0/1','FREE','INTE',LDOWN,NDOWN)

      CALL GETMEM('DAW1','FREE','INTE',LDAW,NDAW)
      CALL GETMEM('LUP1','FREE','INTE',LUP,NUP)
      CALL GETMEM('RAW1','FREE','INTE',LRAW,NRAW)

      CALL GETMEM('NOW1','FREE','INTEG',LNOW,NNOW)
      CALL GETMEM('IOW1','FREE','INTEG',LIOW,NIOW)
      CALL GETMEM('NCSF','FREE','INTEG',LNOCSF,NNOCSF)
      CALL GETMEM('ICSF','FREE','INTEG',LIOCSF,NIOCSF)

      CALL GETMEM('CASE','FREE','INTEG',LICASE,NICASE)

      NUSGN=MXUP*NMIDV
      NLSGN=MXDWN*NMIDV
      CALL GETMEM('IUSG','FREE','INTEG',LUSGN,NUSGN)
      CALL GETMEM('ILSG','FREE','INTEG',LLSGN,NLSGN)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _Test_Numerical_

subroutine OutofP1(xyz,nCent,Teta,Bt,ldB)

use Constants, only: Zero, One, Two, Pi, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCent
real(kind=wp), intent(in) :: xyz(3,nCent)
real(kind=wp), intent(out) :: Teta, Bt(3,nCent)
logical(kind=iwp), intent(in) :: ldB
integer(kind=iwp) :: ix, iy, iz, mCent
real(kind=wp) :: BR14X(3,3), C14X(3,3), CosFi1, CosFi2, CosFi3, dBR14X(3,3,3,3), dFi1, dFi2, dFi3, dTeta, e41x, e41y, e41z, e42x, &
                 e42y, e42z, e43x, e43y, e43z, Fi1, Fi2, Fi3, Q41, Q42, Q43, R41KV, R42(3), R42KV, R43(3), R43KV, RX1, RX2, RX3, &
                 RY1, RY2, RY3, RZ1, RZ2, RZ3
character(len=8) :: Label
real(kind=wp), external :: ArCos

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
! First some diagnostics

! 4-->1 (Bond)
RX1 = xyz(1,1)-xyz(1,4)
RY1 = xyz(2,1)-xyz(2,4)
RZ1 = xyz(3,1)-xyz(3,4)
R41KV = RX1*RX1+RY1*RY1+RZ1*RZ1
Q41 = sqrt(R41KV)
e41x = RX1/Q41
e41y = RY1/Q41
e41z = RZ1/Q41
! 4-->2 (Bond in plane)
RX2 = xyz(1,2)-xyz(1,4)
RY2 = xyz(2,2)-xyz(2,4)
RZ2 = xyz(3,2)-xyz(3,4)
R42KV = RX2*RX2+RY2*RY2+RZ2*RZ2
Q42 = sqrt(R42KV)
e42x = RX2/Q42
e42y = RY2/Q42
e42z = RZ2/Q42
! 4-->3 (Bond in plane)
RX3 = xyz(1,3)-xyz(1,4)
RY3 = xyz(2,3)-xyz(2,4)
RZ3 = xyz(3,3)-xyz(3,4)
R43KV = RX3*RX3+RY3*RY3+RZ3*RZ3
Q43 = sqrt(R43KV)
e43x = RX3/Q43
e43y = RY3/Q43
e43z = RZ3/Q43

! Get the angle between e43 and e42

CosFi1 = e43x*e42x+e43y*e42y+e43z*e42z

Fi1 = ArCos(CosFi1)
if (abs(CosFi1) > One) call RecPrt('xyz(1)',' ',xyz,3,4)
dFi1 = Fi1/deg2rad
if ((dFi1 > 177.5_wp) .or. (dFi1 < 2.5_wp)) write(u6,*) 'Warning: auxiliary Angle close to end of range'

! Dirty exit! This happens when an earlier structure is ill defined.

if (abs(Fi1-Pi) < 1.0e-13_wp) then
  Teta = Zero
  Bt(:,:) = Zero
  return
end if

! Get the angle between e41 and e43

CosFi2 = e41x*e43x+e41y*e43y+e41z*e43z

Fi2 = ArCos(CosFi2)
if (abs(CosFi2) > One) call RecPrt('xyz(2)',' ',xyz,3,4)
dFi2 = Fi2/deg2rad
if ((dFi2 > 177.5_wp) .or. (dFi2 < 2.5_wp)) write(u6,*) 'Warning: auxiliary Angle close to end of range'

! Get the angle between e41 and e42

CosFi3 = e41x*e42x+e41y*e42y+e41z*e42z

Fi3 = ArCos(CosFi3)
if (abs(CosFi3) > One) call RecPrt('xyz(3)',' ',xyz,3,4)
dFi3 = Fi3/deg2rad
if ((dFi3 > 177.5_wp) .or. (dFi3 < 2.5_wp)) write(u6,*) 'Warning: auxiliary Angle close to end of range'
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('xyz',' ',xyz,3,nCent)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! The first two centers are trivially

C14X(:,1) = xyz(:,1)
C14X(:,2) = xyz(:,4)

! The 3rd is

R42(:) = xyz(:,2)-xyz(:,4)
R43(:) = xyz(:,3)-xyz(:,4)
C14X(1,3) = R42(2)*R43(3)-R42(3)*R43(2)
C14X(2,3) = R42(3)*R43(1)-R42(1)*R43(3)
C14X(3,3) = R42(1)*R43(2)-R42(2)*R43(1)

! Exit if 2-3-4 are collinear
! (equivalent to the above check, but this is more concrete)

if ((C14X(1,3)**2+C14X(2,3)**2+C14X(3,3)**2) < 1.0e-10_wp) then
  Teta = Zero
  Bt(:,:) = Zero
  return
end if
C14X(:,3) = C14X(:,3)+xyz(:,4)

mCent = 3
call Bend(C14X,mCent,Teta,BR14X,.false.,.false.,Label,dBR14X,ldB)

Teta = Teta-Pi/Two
dTeta = Teta/deg2rad
if ((dTeta > 87.5_wp) .or. (dTeta < -87.5_wp)) write(u6,*) 'Warning: Out of plane angle close to end of range'

! Compute the WDC matrix

do ix=1,3
  iy = mod(ix+1,4)+(ix+1)/4
  iz = mod(iy+1,4)+(iy+1)/4

  Bt(ix,1) = -BR14X(ix,1)
  Bt(ix,2) = R43(iz)*BR14X(iy,3)-R43(iy)*BR14X(iz,3)
  Bt(ix,3) = -R42(iz)*BR14X(iy,3)+R42(iy)*BR14X(iz,3)

  Bt(ix,4) = -(Bt(ix,1)+Bt(ix,2)+Bt(ix,3))

end do
#ifdef _DEBUGPRINT_
call RecPrt('Outofp: R43',' ',R43,1,3)
call RecPrt('Outofp: R43',' ',R42,1,3)
call RecPrt('Outofp: BR14X',' ',BR14X,3,3)
call RecPrt('Outofp: B matrix',' ',Bt,3,nCent)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine OutofP1

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(OutofP1)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cidenmat()

use gugaci_global, only: dm1tmp, LuCiVec, mroot, nci_dim, vector1, vector2
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i, neigen
real(kind=wp) :: sechc !, x1e(50000)
!character(len=256) :: filename
!logical(kind=iwp) :: logic_mulroot

!=======================================================================
! the main subroutine for ci gradient calculations.
! ican_a and ican_b save canonical order.
! e(*) save the scf orbital energies.
! xlgrn(*) save the lagrangian matrix.

!-----------------------------------------------------------------------
!  initialize the integral index nxo by canonical order
call init_canonical()

! calculate the frozen mo contribution to density matrix
!call density_scf_frz()
!-----------------------------------------------------------------------
! calculate the ci reduced one and two electron density matrix
!ncount1 = ican_a(norb_all)+norb_all
!ncount2 = ican_b(ncount1)+ncount1

!logic_mulroot = .false.
!ndim = mroot*nci_dim
!if (ndim <= max_vector) logic_mulroot = .true.

neigen = mroot
vector1(1:nci_dim) = Zero

! calculated ci density matrix
! need debug here, density matrix is saved in vector2, it is too large t
! keep it.
! read ci vector
!if (logic_mulroot) then
!  call read_ml(lucivec,vector1,neigen*nci_dim,1)
!end if
!write(u6,*) 'density matrix',neigen,ncount2
! should we calculated two-electronic density matrix ?
do i=1,neigen
  call read_ml(lucivec,vector1,nci_dim,i)
  vector2(:) = Zero
  dm1tmp = Zero
  call memcidiag_alloc()
  call diagonal_loop_wyb_g()
  call memcidiag_dealloc()
  call matrix_vector_multi_parallel_drt_g(sechc)
  call ci_density_label_sm(i)
  !call ci_dentest(i)
end do

return

end subroutine cidenmat

!subroutine ci_dentest(iroot)
!
!use gugaci_global, only: denm1, denm2, FnOneMO, FnTwoMO, lenintegral, LuCiDen, LuOneMO, LuTwoMO, max_root, ng_sm, nlsm_all, &
!                         nlsm_bas, ntrabuf, ntratoc
!use Symmetry_Info, only: Mul
!use stdalloc, only: mma_allocate, mma_deallocate
!use Constants, only: Zero, Two, Half
!use Definitions, only: wp, iwp, u6
!
!implicit none
!integer(kind=iwp), intent(in) :: iroot
!integer(kind=iwp) :: i, idisk, idisk0, idx, iout, lenrd, li, lj, lk, ll, lri, lrj, nbpq, nbrs, nc, nc1, nc2, nidx, nintb, nintone, &
!                     nism, nmob, noidx(8), nop, noq, nor, norb(8), nos, nsmint, nsp, nspq, nspqr, nsq, nsr, nss, nssm, ntj, ntk, &
!                     numax, numin
!real(kind=wp) :: buff(ntrabuf), cienergy, ecor, val, vnuc !, x(1024*1024)
!integer(kind=iwp), allocatable :: idisk_array(:), itratoc(:)
!real(kind=wp), allocatable :: x(:), xfock(:)
!integer(kind=iwp), external :: ipair
!
!#ifndef MOLPRO
!norb = nlsm_all
!nintone = 0
!nmob = 0
!nidx = 0
!call mma_allocate(itratoc,ntratoc,label='itratoc')
!do i=1,ng_sm
!  nism = nlsm_all(i)
!  nsmint = nism*(nism+1)/2
!  itratoc(i) = nism*nism
!  nmob = nmob+nlsm_bas(i)*nlsm_bas(i)
!  noidx(i) = nidx
!  nidx = nidx+nism
!  nintone = nintone+nsmint
!end do
!
!call mma_allocate(x,nmob,label='x')
!call daname(luonemo,fnonemo)
!!call copen_molcas(nft,filename,lenstr)
!call readtraonehead(luonemo,ecor,idisk)
!vnuc = ecor
!
!! read mo coeff, need debug, if frozen and delete orbitals are not zero
!!call ddatard(nft,x,nmob,idisk)
!call ddafile(luonemo,2,x,nmob,idisk)
!
!call mma_deallocate(x)
!
!! read one electron fock matrix
!call mma_allocate(xfock,nintone,label='xfock')
!call ddafile(luonemo,2,xfock,nintone,idisk)
!!call ddatard(nft,xfock,nintone,idisk)
!call daclos(luonemo)
!! read one electron kinetic integrals
!!call ddatard(nft,x1e,nintone,idisk)
!!call cclose_molcas(nft)
!! write one electron fock matrix into voint
!cienergy = Zero
!nidx = 0
!nc = 0
!do i=1,ng_sm
!  nism = nlsm_all(i)
!  idx = noidx(i)
!  nsmint = nism*(nism+1)/2
!  do lri=1,nism
!    do lrj=1,lri
!      nc = nc+1
!      val = xfock(nc)*denm1(nc)
!      if (lri /= lrj) val = Two*val
!      cienergy = cienergy+val
!      write(u6,'(1x,i3,1x,i3,2(1x,f18.9))') lri+idx,lrj+idx,xfock(nc),denm1(nc)
!    end do
!  end do
!  nidx = nidx+nsmint
!end do
!call mma_deallocate(xfock)
!
!idisk0 = 0
!call mma_allocate(idisk_array,max_root+1,label='idisk_array')
!call idafile(luciden,2,idisk_array,max_root+1,idisk0)
!idisk0 = idisk_array(iroot)
!call mma_deallocate(idisk_array)
!call ddafile(luciden,2,denm1,nc,idisk0)
!
!call daname(lutwomo,fntwomo)
!
!denm2 = Zero
!idisk = 0
!lenrd = ntratoc*lenintegral
!write(u6,*) lenrd
!call idafile(lutwomo,2,itratoc,ntratoc,idisk)
!call mma_deallocate(itratoc)
!write(u6,2000)
!do nsp=1,ng_sm
!  nop = norb(nsp)
!  do nsq=1,nsp
!    noq = norb(nsq)
!    nspq = Mul(nsp,nsq)
!    do nsr=1,nsp
!      nor = norb(nsr)
!      nspqr = Mul(nspq,nsr)
!      nssm = nsr
!      if (nsr == nsp) nssm = nsq
!      do nss=1,nssm
!        if (nspqr /= nss) cycle
!        nos = norb(nss)
!
!        if (nsr == nss) then
!          nbpq = (nop+nop**2)/2
!          nbrs = (nos+nos**2)/2
!          if (nsp == nsr) then
!            ! (ii|ii) type 1 int
!            nintb = (nbpq+nbpq**2)/2
!          else
!            ! (ii|jj) type 3 int
!            nintb = nbpq*nbrs
!          end if
!        else
!          nbpq = nop*noq
!          nbrs = nor*nos
!          if (nsp == nsr) then
!            ! (ij|ij) type 2 int
!            nintb = (nbpq+nbpq**2)/2
!          else
!            ! (ij|kl) type 4 int
!            nintb = nbpq*nbrs
!          end if
!        end if
!
!        if (nintb == 0) cycle
!        !write(u6,2100) nsp,nsq,nsr,nss,nop,noq,nor,nos,nintb
!
!        iout = 0
!        call ddafile(lutwomo,2,buff,ntrabuf,idisk)
!        call ddafile(luciden,2,denm2,nintb,idisk0)
!        idx = 0
!
!        do li=1,nor
!          ntj = nos
!          if (nsr == nss) ntj = li
!          do lj=1,ntj
!            ntk = 1
!            if (nsp == nsr) ntk = li
!            do lk=ntk,nop
!              numin = 1
!              if ((nsp == nsr) .and. (lk == li)) numin = lj
!              numax = noq
!              if (nsp == nsq) numax = lk
!              do ll=numin,numax
!                iout = iout+1
!                if (iout > ntrabuf) then
!                  !call ddatard(nft,buff,ntrabuf,idisk)
!                  call ddafile(lutwomo,2,buff,ntrabuf,idisk)
!                  iout = 1
!                end if
!                idx = idx+1
!                val = Half*buff(iout)*denm2(idx)
!                if (li /= lj) val = Two*val
!                if (lk /= ll) val = Two*val
!                nc1 = ipair(li,lj)
!                nc2 = ipair(lk,ll)
!                if (nc1 /= nc2) val = Two*val
!                cienergy = cienergy+val
!                !write(u6,'(5(1x,i4),2(1x,f18.9))') li,lj,lk,ll,iout,buff(iout),denm2(idx)
!              end do
!            end do
!          end do
!        end do
!        if (idx /= nintb) then
!          write(u6,*) 'in ci_dentest,count error'
!          call abend()
!        end if
!      end do
!    end do
!  end do
!end do
!
!call daclos(lutwomo)
!write(u6,'(a11,3(2x,f18.9))') 'ci energy=',cienergy,vnuc,cienergy+vnuc
!
!return
!
!2000 format(/7x,'symmetry',6x,' orbitals',8x,'integrals')
!!2100 format(7x,4i2,1x,4i4,2x,3x,i9)
!
!#endif
!
!end subroutine ci_dentest

subroutine init_canonical()

use gugaci_global, only: ican_a, ican_b, max_orb
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, l1, l2

!=======================================================================
! calculate the canonical order for index transform

l1 = max_orb
l2 = max_orb*(max_orb+1)/2
do i=1,l1
  ican_a(i) = (i*i-i)/2
end do
do i=1,l2
  ican_b(i) = (i*i-i)/2
end do

end subroutine init_canonical

!subroutine density_scf_frz()
!
!use gugaci_global, only: cf, naorbs, norb_frz, p
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp) :: i, j, k
!real(kind=wp) :: val
!
!do i=1,naorbs
!  do j=1,naorbs
!    val = Zero
!    do k=1,norb_frz
!      val = val+cf(i,k)*cf(j,k)
!    end do
!    p(i,j) = val
!    !write(2,'(2i8,f18.10)') i,j,p(i,j)
!  end do
!end do
!
!end subroutine density_scf_frz

subroutine matrix_vector_multi_parallel_drt_g(sechc)

use Definitions, only: wp, u6

implicit none
real(kind=wp), intent(out) :: sechc
real(kind=wp) :: sc1, sc2
real(kind=wp), external :: c_time

write(u6,*)
sc1 = c_time()
call ext_space_loop_g()
call inner_space_loop_g()
call vd_drt_ci_new()
call dv_drt_ci_new()
call dd_drt_ci_new()
call dt_drt_ci_new()
call ds_drt_ci_new()
call tv_drt_ci_new()
call td_drt_ci_new()
call tt_drt_ci_new()
call ts_drt_ci_new()
call sv_drt_ci_new()
call sd_drt_ci_new_den()
call st_drt_ci_new()
call ss_drt_ci_new()
sc2 = c_time()
sechc = sc2-sc1
!write(u6,'(a42,2x,f10.2,2x,a1)') 'End of calculating density',' matrix, takes',sechc,'s'

return

end subroutine matrix_vector_multi_parallel_drt_g

!subroutine matrix_vector_multi_parallel_prt_g(sechc)
!
!use Definitions, only: wp, u6
!
!implicit none
!real(kind=wp), intent(out) :: sechc
!real(kind=wp) :: sc1, sc10, sc11, sc12, sc13, sc14, sc15, sc16, sc2, sc3, sc4, sc5, sc6, sc7, sc8, sc9
!real(kind=wp), external :: c_time
!
!write(u6,*)
!sc1 = c_time()
!call ext_space_loop_g()
!sc2 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of ext, takes',sc2-sc1,'s'
!call inner_space_loop_g()
!sc3 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of inn, takes',sc3-sc2,'s'
!call vd_drt_ci_new()
!sc4 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of vd , takes',sc4-sc3,'s'
!call dv_drt_ci_new()
!sc5 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of dv , takes',sc5-sc4,'s'
!call dd_drt_ci_new()
!sc6 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of dd , takes',sc6-sc5,'s'
!call dt_drt_ci_new()
!sc7 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of dt , takes',sc7-sc6,'s'
!call ds_drt_ci_new()
!sc8 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of ds , takes',sc8-sc7,'s'
!call tv_drt_ci_new()
!sc9 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of tv , takes',sc9-sc8,'s'
!call td_drt_ci_new()
!sc10 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of td , takes',sc10-sc9,'s'
!call tt_drt_ci_new()
!sc11 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of tt , takes',sc11-sc10,'s'
!call ts_drt_ci_new()
!sc12 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of ts , takes',sc12-sc11,'s'
!call sv_drt_ci_new()
!sc13 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of sv , takes',sc13-sc12,'s'
!call sd_drt_ci_new_den()
!sc14 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of sd , takes',sc14-sc13,'s'
!call st_drt_ci_new()
!sc15 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of st , takes',sc15-sc14,'s'
!call ss_drt_ci_new()
!sc16 = c_time()
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of ss , takes',sc16-sc15,'s'
!sc2 = c_time()
!sechc = sc2-sc1
!write(u6,'(a16,2x,f10.2,2x,a1)') 'end of run, takes',sechc,'s'
!
!return
!
!end subroutine matrix_vector_multi_parallel_prt_g

subroutine ci_density_label_sm(iroot)

use gugaci_global, only: denm1, denm2, dm1tmp, LuCiDen, map_orb_order, max_root, ng_sm, nlsm_all, vector2
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iroot
integer(kind=iwp) :: i, ic, idisk, ii, ij, ijm, im, j, jc, je, jj, jm, k, kk, kl, klm, km, l, lc, le, ll, lm, nc0, nc1
real(kind=wp) :: val
integer(kind=iwp), allocatable :: indx_m(:), idisk_array(:)
integer(kind=iwp), external :: ipair

!=======================================================================
! transfer the ci density matrices (dm1 and dm2)
! based on the gamess save rule.
!vector1(1:ncount2) = Zero
!vector1(1:ncount2) = vector2(1:ncount2)
!vector2(1:ncount2) = Zero

denm1 = Zero
nc0 = 1
nc1 = 0
call mma_allocate(indx_m,ng_sm,label='indx_m')
do im=1,ng_sm
  if (nlsm_all(im) == 0) cycle
  do i=1,nlsm_all(im)
    do j=1,i
      ii = map_orb_order(i+nc1)
      jj = map_orb_order(j+nc1)
      ij = ipair(ii,jj)
      denm1(nc0) = dm1tmp(ij)
      nc0 = nc0+1
    end do
  end do
  indx_m(im) = nc1
  nc1 = nc1+nlsm_all(im)
end do
idisk = 0
call mma_allocate(idisk_array,max_root+1,label='idisk_array')
if (iroot == 1) then
  idisk_array(:) = 0
  call idafile(luciden,1,idisk_array,max_root+1,idisk)
  idisk_array(1) = idisk
else
  idisk = 0
  call idafile(luciden,2,idisk_array,max_root+1,idisk)
  idisk = idisk_array(iroot)
end if
call ddafile(luciden,1,denm1,nc0,idisk)

denm2 = Zero
! label 2-elc den matrix
! cycle on symmetry
do im=1,ng_sm
  if (nlsm_all(im) == 0) cycle
  do jm=1,im
    if (nlsm_all(jm) == 0) cycle
    ijm = Mul(im,jm)
    do km=1,im
      if (nlsm_all(km) == 0) cycle
      le = km
      if (km == im) le = jm
      do lm=1,le
        if (nlsm_all(lm) == 0) cycle
        klm = Mul(km,lm)
        if (ijm /= klm) cycle
        ! ityp 1 (ii|jj) 2 (ii|jj) 3 (ij|ij) 4 (ij|kl)

        ! cycle on mo index
        ! i>=j, k>=l, ij>=kl
        nc0 = 0
        do k=1,nlsm_all(km)
          kk = map_orb_order(k+indx_m(km))
          lc = nlsm_all(lm)
          if (km == lm) lc = k
          do l=1,lc
            ll = map_orb_order(l+indx_m(lm))
            kl = ipair(kk,ll)
            ic = 1
            if (im == km) ic = k
            do i=ic,nlsm_all(im)
              ii = map_orb_order(i+indx_m(im))
              jc = 1
              if ((im == km) .and. (i == k)) jc = l
              je = nlsm_all(jm)
              if (im == jm) je = i
              do j=jc,je
                jj = map_orb_order(j+indx_m(jm))
                nc0 = nc0+1
                ij = ipair(ii,jj)
                nc1 = ipair(ij,kl)

                val = vector2(nc1)*Half
                if ((ii /= jj) .and. (kk /= ll)) then
                  val = val*Half
                else if ((ii == jj) .and. (kk == ll) .and. (ii == kk)) then
                  val = val*Two
                end if
                denm2(nc0) = val
              end do
            end do
          end do
        end do
        call ddafile(luciden,1,denm2,nc0,idisk)
        ! end cycle on mo index
      end do
    end do
  end do
end do
call mma_deallocate(indx_m)

idisk_array(iroot+1) = idisk
idisk = 0
call idafile(luciden,1,idisk_array,max_root+1,idisk)
call mma_deallocate(idisk_array)

return

end subroutine ci_density_label_sm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Bernd Artur Hess                                 *
!***********************************************************************

subroutine SCFCLI4(idbg,S,H,SINVA,NA,NB,ISIZEA,VELIT,CMM1,CMM2,EV4,BU6,EIG4,EW4,P)
! $Id: relsewc.r,v 1.4 1995/05/08 14:08:53 hess Exp $
! calculate relativistic operators
!   Bernd Artur Hess, hess@uni-bonn.de

use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idbg, NA, NB, ISIZEA
real(kind=wp), intent(in) :: S(ISIZEA), VELIT, CMM2(NA,NB)
real(kind=wp), intent(inout) :: H(ISIZEA)
real(kind=wp), intent(out) :: SINVA(NA,NA), CMM1(NB,NA), EV4(ISIZEA), BU6(NA,NA), EIG4(NA,NA), EW4(NA), P(ISIZEA)
integer(kind=iwp) :: I, IJ, J, L

do I=1,NB
  do J=1,NA
    CMM1(I,J) = -CMM2(J,I)
  end do
end do

! Now we changed sign due to the imaginary character

IJ = 0
do I=1,NA
  do J=1,I
    IJ = IJ+1
    EV4(IJ) = Zero
    do L=1,NB
      EV4(IJ) = EV4(IJ)-CMM2(I,L)*CMM1(L,J)
    end do
  end do
end do

!write(u6,*)
!write(u6,*) 'Final BSS matrix no Hess part alpha**2 yet'
!write(u6,*) EV4

do IJ=1,ISIZEA
  EV4(IJ) = Half*(One/(VELIT*VELIT))*EV4(IJ)
end do

H(:) = H+EV4

!ulf
if (idbg > 0) call PRMAT(IDBG,h,na,nb,'h   oper')
call Sogr(idbg,NA,S,SINVA,P,BU6,EW4)

call Diagr(H,NA,EIG4,EW4,SINVA,BU6,EV4)

!if (idbg > 0) write(idbg,*) '--- EIGENVALUES OF H MATRIX ---'
!if (idbg > 0) write(idbg,'(4D20.12)') EW4

!write(u6,*) 'END OF SCFCLI4 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'

return

end subroutine SCFCLI4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DrvDFT(h1,TwoHam,D,RepNuc,nh1,First,Dff,
     &                  lRF,KSDFT,ExFac,Do_Grad,Grad,nGrad,iSpin,
     &                  D1I,D1A,nD1,DFTFOCK)
      use KSDFT_Info, only: KSDFA, funcaa, funcbb, funccc
      Implicit Real*8 (a-h,o-z)
      External LSDA, Overlap, BLYP, BPBE, B3LYP, HFS, HFB,
     &         XAlpha, LSDA5, B3LYP5, B2PLYP, TLYP, NLYP,
     &         NucAtt, NEWF, NEWF1, OLYP, O3LYP, OPBE,
     &         PBE, PBE0, PBEsol, M06L, M06, M062X, HFO,
     &         M06HF, Checker, SSBSW, SSBD, HFG, GLYP, GPBE,
     &         HFB86, B86LYP, B86PBE, BWIG, KT3,
     &         O2PLYP,  KT2,  RGE2, REVPBE,
     &         PTCA,S12G, S12H
#include "real.fh"
#include "stdalloc.fh"
#include "nq_info.fh"
#include "debug.fh"
#include "pamint.fh"
#include "ksdft.fh"
      Real*8 h1(nh1), TwoHam(nh1), D(nh1,2), Grad(nGrad), Vxc_ref(2)
      Real*8 D1I(nD1),D1A(nD1)
      Logical First, Dff, lRF,  Do_Grad
      Logical Do_MO,Do_TwoEl, Found
      Character*(*) KSDFT
      Character*4 DFTFOCK
      Real*8, Allocatable:: D_DS(:,:), F_DFT(:,:)
*
      KSDFA = KSDFT
      lKSDFT=LEN(KSDFT)
      Debug=.False.
*                                                                      *
************************************************************************
*                                                                      *
c     Call SetQue('Trace=on')
*                                                                      *
************************************************************************
*                                                                      *
      Call Put_iScalar('Multiplicity',iSpin)
      Call Get_iScalar('nSym',mIrrep)
      Call Get_iArray('nBas',mBas,mIrrep)
*
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
*                                                                      *
      Call Get_dScalar('DFT exch coeff',CoefX)
      Call Get_dScalar('DFT corr coeff',CoefR)
*
************************************************************************
*                                                                      *
      If (Do_Grad) Call FZero(Grad,nGrad)
*                                                                      *
************************************************************************
*                                                                      *
      If (iSpin.eq.1) Then
         nD=1
      Else
         nD=2
      End If
*
*     What is this?
*
      If (DFTFOCK.eq.'DIFF') nD=2
      If (DFTFOCK.eq.'ROKS') nD=2
      Call mma_allocate(D_DS,nh1,nD,Label='D_DS')
*
*---- Get the total density
*
      Call Get_D1ao(D_DS,nh1)
*     Call RecPrt('D1ao',' ',D_DS(:,1),nh1,1)
*
*
*---- Get the spin density
*
      If (nD.ne.1) Then
         Call Get_D1Sao(D_DS(:,2),nh1)
*        Call RecPrt('D1Sao',' ',D_DS(:,2),nh1,1)
      End If
*
*---- Compute alpha and beta densities
*
*     Call RecPrt('DTot',' ',D_DS(:,1),nh1,1)
*     Call RecPrt('DSpn',' ',D_DS(:,2),nh1,1)
      If (nD.eq.1) Then
        D_DS(:,1)=Half*D_DS(:,1)
      Else
         Do i = 1, nh1
            DTot=D_DS(i,1)
            DSpn=D_DS(i,2)
            d_Alpha=Half*(DTot+DSpn)
            d_Beta =Half*(DTot-DSpn)
            D_DS(i,1)=d_Alpha
            D_DS(i,2)=d_Beta
         End Do
      End If
*     Call RecPrt('Da',' ',D_DS(:,1),nh1,1)
*     Call RecPrt('Db',' ',D_DS(:,2),nh1,1)
*
      If(KSDFT(1:3).ne.'SCF') Then
        Call Get_iArray('nIsh',nIsh,mIrrep)
        Call Get_iArray('nFro',nFro,mIrrep)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     DFT functionals, compute integrals over the potential
*
      Func            =Zero
      Funcaa          =Zero
      Funcbb          =Zero
      Funccc          =Zero
      Dens_I          =Zero
      Dens_a1         =Zero
      Dens_b1         =Zero
      Dens_a2         =Zero
      Dens_b2         =Zero
      Dens_t1         =Zero
      Dens_t2         =Zero
      Grad_I          =Zero
      Tau_I           =Zero
      Do_MO           =.False.
      Do_TwoEl        =.False.
*
      If (nD.eq.2.and.DFTFOCK.eq.'DIFF') Then
         numAO=0
         If(KSDFT(1:3).ne.'SCF') Then
           Do iIrrep=0,mIrrep-1
             nAsh(iIrrep)=0
           End Do
           Call qpg_iArray('nAsh',Found,nData)
           If(Found .and. nData.eq.mIrrep) Then
             Call Get_iArray('nAsh',nAsh,mIrrep)
           End If
           Do iIrrep=0,mIrrep-1
             numAO=numAO+nAsh(iIrrep)
           End Do
        End If
        If (numAO.ne.0)
     &  Do_TwoEl        =.True.
        Do_MO           =.True.

      End If
*
*     nFckDim: number of different types of Fock matrices. Normally for
*     conventional functionals we have one Fock matrix for closed shell
*     calculations and two (F_alpha and F_beta) for open shell systems.
*     For CASDFT we have always two (F_inactive and F_active)
*
************************************************************************
*                                                                      *
*      LSDA LDA SVWN  GLM stuff                                        *
*                                                                      *
       If (KSDFT.eq.'LSDA ' .or.
     &     KSDFT.eq.'LDA '  .or.
     &     KSDFT.eq.'TLSDA'  .or. !GLM
     &     KSDFT.eq.'FTLSDA'  .or. !AMS
     &     KSDFT.eq.'SVWN ') Then
         If(KSDFT.eq.'TLSDA'
     &     .or.KSDFT.eq.'FTLSDA') Do_MO=.true. !GLM
         If(KSDFT.eq.'TLSDA'
     &     .or.KSDFT.eq.'FTLSDA') Do_TwoEl=.true. !GLM
         ExFac=Get_ExFac(KSDFT)
         Functional_type=LDA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(LSDA   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
c          write(6,*) 'Func in drvdft :', Func
*                                                                      *
************************************************************************
*                                                                      *
*      LSDA5 LDA5 SVWN5                                                *
*                                                                      *
       Else If (KSDFT.eq.'LSDA5' .or.
     &          KSDFT.eq.'LDA5'  .or.
     &          KSDFT.eq.'TLSDA5 '.or.
     &          KSDFT.eq.'SVWN5') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=LDA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(LSDA5  ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
c         write(6,*) 'Func in drvdft :', Func
*                                                                      *
************************************************************************
*                                                                      *
*     HFB                                                              *
*                                                                      *
       Else If (KSDFT.eq.'HFB') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(HFB    ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     HFO                                                              *
*                                                                      *
       Else If (KSDFT.eq.'HFO') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(HFO    ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     HFG                                                              *
*                                                                      *
       Else If (KSDFT.eq.'HFG') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(HFG    ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     HFB86                                                            *
*                                                                      *
       Else If (KSDFT.eq.'HFB86') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(HFB86   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      HFS                                                             *
*                                                                      *
       Else If (KSDFT.eq.'HFS') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=LDA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(HFS    ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      XALPHA                                                          *
*                                                                      *
       Else If (KSDFT.eq.'XALPHA') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=LDA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(XAlpha ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     Overlap                                                          *
*                                                                      *
      Else If (KSDFT.eq.'Overlap') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=LDA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(Overlap,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     NucAtt                                                           *
*                                                                      *
      Else If (KSDFT.eq.'NucAtt') Then
         ExFac=One
         Functional_type=LDA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(NucAtt,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     BWIG                                                             *
*                                                                      *
      Else If (KSDFT.eq.'BWIG') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(BWIG   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     BLYP                                                             *
*                                                                      *
      Else If (KSDFT.eq.'BLYP'
     &       .or.  KSDFT.eq.'TBLYP' !GLM
     &       .or.  KSDFT.eq.'FTBLYP' !AMS
     &        ) Then
       If(KSDFT.eq.'TBLYP'
     &       .or. KSDFT.eq.'FTBLYP') Do_MO=.true.
       If(KSDFT.eq.'TBLYP'
     &       .or. KSDFT.eq.'FTBLYP') Do_TwoEl=.true.
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(BLYP   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     OLYP                                                             *
*                                                                      *
      Else If (KSDFT.eq.'OLYP') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(OLYP   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     KT3                                                              *
*                                                                      *
      Else If (KSDFT.eq.'KT3') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(KT3   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     KT2                                                              *
*                                                                      *
      Else If (KSDFT.eq.'KT2') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(KT2   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     GLYP                                                             *
*                                                                      *
      Else If (KSDFT.eq.'GLYP') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(GLYP   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     B86LYP                                                           *
*                                                                      *
      Else If (KSDFT.eq.'B86LYP') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(B86LYP   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     BPBE                                                             *
*                                                                      *
      Else If (KSDFT.eq.'BPBE') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(BPBE   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     OPBE                                                             *
*                                                                      *
      Else If (KSDFT.eq.'OPBE'
     &     .or.KSDFT.eq.'TOPBE' !GLM
     &     .or.KSDFT.eq.'FTOPBE'!AMS
     &         ) then
         If(KSDFT.eq.'TOPBE'
     &     .or.KSDFT.eq.'FTOPBE') Do_MO=.true.
         If(KSDFT.eq.'TOPBE'
     &     .or.KSDFT.eq.'FTOPBE') Do_TwoEl=.true.
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(OPBE   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     GPBE                                                             *
*                                                                      *
      Else If (KSDFT.eq.'GPBE') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(GPBE   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     B86PBE                                                           *
*                                                                      *
      Else If (KSDFT.eq.'B86PBE') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(B86PBE  ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     TLYP                                                             *
*                                                                      *
      Else If (KSDFT.eq.'TLYP') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(TLYP   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     NLYP                                                             *
*                                                                      *
      Else If (KSDFT.eq.'NLYP') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(NLYP   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     B3LYP                                                            *
*                                                                      *
      Else If (KSDFT.eq.'B3LYP ') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(B3LYP  ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     O3LYP                                                            *
*                                                                      *
      Else If (KSDFT.eq.'O3LYP ') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(O3LYP  ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     B2PLYP                                                           *
*                                                                      *
      Else If (KSDFT.eq.'B2PLYP') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(B2PLYP  ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     O2PLYP                                                           *
*                                                                      *
      Else If (KSDFT.eq.'O2PLYP') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(O2PLYP  ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     B3LYP5                                                           *
*                                                                      *
      Else If (KSDFT.eq.'B3LYP5') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(B3LYP5 ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     PBE                                                              *
*                                                                      *
      Else If (KSDFT.eq.'PBE'
     &     .or.KSDFT.eq.'TPBE' !GLM
     &     .or.KSDFT.eq.'FTPBE'!AMS
     &         ) then
         If(KSDFT.eq.'TPBE'
     &     .or.KSDFT.eq.'FTPBE') Do_MO=.true.
         If(KSDFT.eq.'TPBE'
     &     .or.KSDFT.eq.'FTPBE') Do_TwoEl=.true.
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(PBE   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     revPBE                                                           *
*                                                                      *
      Else If (KSDFT.eq.'REVPBE'
     &     .or.KSDFT.eq.'TREVPBE' !GLM
     &     .or.KSDFT.eq.'FTREVPBE'!AMS
     &         ) then
         If(KSDFT.eq.'TREVPBE'
     &     .or.KSDFT.eq.'FTREVBPE') Do_MO=.true.
         If(KSDFT.eq.'TREVPBE'
     &     .or.KSDFT.eq.'FTREVPBE') Do_TwoEl=.true.
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(REVPBE,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     SSBSW                                                              *
*                                                                      *
      Else If (KSDFT.eq.'SSBSW'
     &     .or.KSDFT.eq.'TSSBSW') Then !GLM
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(SSBSW   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     SSBD                                                             *
*                                                                      *
      Else If (KSDFT.eq.'SSBD'
     &     .or.KSDFT.eq.'TSSBD') Then !GLM
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(SSBD ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     S12H                                                             *
*                                                                      *
      Else If (KSDFT.eq.'S12H') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(S12H  ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     S12G                                                             *
*                                                                      *
      Else If (KSDFT.eq.'S12G'
     &     .or.KSDFT.eq.'TS12G') Then !GLM
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(S12G  ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     PBEsol                                                           *
*                                                                      *
      Else If (KSDFT.eq.'PBESOL') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(PBEsol   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     RGE2                                                             *
*                                                                      *
      Else If (KSDFT.eq.'RGE2') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(RGE2   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     PTCA                                                             *
*                                                                      *
      Else If (KSDFT.eq.'PTCA') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(PTCA   ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     PBE0                                                             *
*                                                                      *
      Else If (KSDFT.eq.'PBE0') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=GGA_type
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(PBE0  ,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     M06-L                                                            *
*                                                                      *
      Else If (KSDFT.eq.'M06L') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=meta_GGA_type1
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(M06L,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     M06                                                              *
*                                                                      *
      Else If (KSDFT.eq.'M06 ') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=meta_GGA_type1
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(M06,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     M06-2X                                                           *
*                                                                      *
      Else If (KSDFT.eq.'M062X') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=meta_GGA_type1
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(M062X,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     M06-HF                                                           *
*                                                                      *
      Else If (KSDFT.eq.'M06HF') Then
         ExFac=Get_ExFac(KSDFT)
         Functional_type=meta_GGA_type1
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(M06HF,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     Checker                                                          *
*                                                                      *
      Else If (KSDFT.eq.'CHECKER') Then
         ExFac=Zero
         Functional_type=meta_GGA_type2
         nFckDim = nD
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         Call DrvNQ(Checker,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
*     CASDFT functionals:                                              *
*                                                                      *
      Else If (KSDFT(1:4).eq.'NEWF') Then
*                                                                      *
*        These functionals are still under construction.               *
*        The code, written by S.G. & C., will be now modified by       *
*                      Giovanni Ghigo (CGG)                            *
*                                                                      *
         If (DFTFOCK.ne.'DIFF') Then
            Call WarningMessage(2,
     &                 ' This is CASDFT type functional !!!;'
     &               //' You cannot use it in this calculation.')
            Call Quit_OnUserError()
         End If
         Do_Grad  = .False.
         Do_MO    = .True.
         Do_TwoEl = .True.
*
         ExFac=Get_ExFac(KSDFT)
         Functional_type=CASDFT_type
         nFckDim = 2
         Call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
         F_DFT(:,:)=Zero
         If ( KSDFT(5:5).eq.'0' )
     &      Call DrvNQ(NEWF ,F_DFT,nFckDim,Func,
     &                 D_DS,nh1,nD,Do_Grad,
     &                 Grad,nGrad,
     &                 Do_MO,Do_TwoEl,DFTFOCK)
         If ( KSDFT(5:5).eq.'1' )
     &      Call DrvNQ(NEWF1 ,F_DFT,nFckDim,Func,
     &                 D_DS,nh1,nD,Do_Grad,
     &                 Grad,nGrad,
     &                 Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
      Else
         Call WarningMessage(2,
     &               ' DrvDFT: Undefined functional type!')
         Write (6,*) '         Functional=',KSDFT(1:lKSDFT)
         Call Quit_OnUserError()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Energy_integrated=Func
*                                                                      *
************************************************************************
*                                                                      *
      If (KSDFT.eq.'Overlap'.or.KSDFT.eq.'NucAtt') Then
         call dcopy_(nh1,F_DFT,1,h1,1)
         If (KSDFT.eq.'NucAtt') Energy_integrated=Func
      Else
*
*        Put out the integrated DFT energy and the DFT Fock matrices
*        on the RUNFILE
*
*        Call Put_DFT_Energy(Energy_integrated)
         Call Poke_dScalar('KSDFT energy',Energy_integrated)
         Call Put_dScalar('CASDFT energy',Energy_integrated)
         Call Put_dExcdRa(F_DFT,nFckDim*nh1)
*         Write(6,'(a,f22.16)') " Energy in drvdft ",Energy_integrated
#ifdef _DEBUGPRINT_
         Write(6,'(a,f22.16)') " Energy ",Energy_integrated
         If (nFckDim.eq.1) Then
            Do i=1,nh1
               Write(6,'(i4,f22.16)') i,F_DFT(i,1)
            End Do
         Else
            Do i=1,nh1
              Write(6,'(i4,3f22.16)') i,F_DFT(i,1),
     &                                  F_DFT(i,2),
     &        F_DFT(i,1)+F_DFT(i,2))/2.0d0
            End Do
         End If
#endif

*
*        In the SCF program (traclc.f) the program computes the trace
*        of the one-electron hamiltonian over a set of densities. The
*        DFT contribution is not linear with respect to variations of
*        the density. However, with the following term we can include
*        the linear component in that code.
*
         Fact = Two
         If (nD.ne.1) Fact=One
         Vxc_ref(1)=Fact*DDot_(nh1,F_DFT(:,1),1,D_DS,1)
         If (nD.ne.1) Then
           Vxc_ref(2)=DDot_(nh1,F_DFT(:,2),1,D_DS(:,2),1)
         Else
            Vxc_ref(2)=Zero
         End If
         Call Put_Temp('Vxc_ref ',Vxc_ref,2)
      End If
*
      Call mma_deallocate(F_DFT)
      Call mma_deallocate(D_DS)
      Call Free_iSD()
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(TwoHam)
         Call Unused_real_array(D)
         Call Unused_real(RepNuc)
         Call Unused_logical(First)
         Call Unused_logical(Dff)
         Call Unused_logical(lRF)
         Call Unused_real_array(D1I)
         Call Unused_real_array(D1A)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DIAFCK(NO,FOCK,IOSTA,IOEND,TSCT,NB,CMO1SCT,CMO2SCT)
      use definitions, only: iwp, wp
      use constants, only: Zero, One
      use stdalloc, only: mma_allocate, mma_deallocate
      IMPLICIT None
      integer(kind=iwp), intent(in):: NO,IOSTA,IOEND,NB
      real(kind=wp), intent(inout):: FOCK(NO,NO)
      real(kind=wp), intent(out):: TSCT(IOSTA:IOEND,IOSTA:IOEND)
      real(kind=wp), intent(in):: CMO1SCT(NB,*)
      real(kind=wp), intent(out):: CMO2SCT(NB,*)

      real(kind=wp), Allocatable:: TMP(:)
      integer(kind=iwp) I, IJ, J, JMX, K, NSCT
      real(kind=wp) V, VMX, SWAP

* Use orbital rotations on a subblock of active orbitals
* in order to diagonalize that block of a Fock matrix, and
* in addition apply a counterrotation to the CI array that
* keeps the wave function invariant to the rotation.

* FOCK is the Fock matrix of this symmetry, in square form.
* to be tranformed. TSCT is a corresponding section of the
* transformation matrix, CMO1SCT is a section of the CMO array (in)
* and CMO2SCT the same, transformed.

* Size of orbital section to process:
      NSCT=IOEND+1-IOSTA
* Local scratch area:
      CALL mma_allocate(TMP,NO*NSCT,Label='TMP')
* Put part of FOCK to be diagonalized into triangular scratch area:
      IJ=0
      DO I=IOSTA,IOEND
       DO J=IOSTA,I
        IJ=IJ+1
        TMP(IJ)=FOCK(I,J)
       END DO
      END DO
* Put unit matrix into TSCT:
      CALL DCOPY_(NSCT**2,[Zero],0,TSCT,1)
      CALL DCOPY_(NSCT,[One],0,TSCT,NSCT+1)
C Diagonalize, and order for best submatrix condition:
      CALL Jacob(TMP,TSCT,NSCT,NSCT)
      DO I=IOSTA,IOEND
       JMX=I
       VMX=ABS(TSCT(I,JMX))
       DO J=I+1,IOEND
        V=ABS(TSCT(I,J))
        IF(V.GT.VMX) THEN
          JMX=J
          VMX=V
        END IF
       END DO
       IF(JMX.GT.I) THEN
        DO K=IOSTA,IOEND
         SWAP=TSCT(K,I)
         TSCT(K,I)=TSCT(K,JMX)
         TSCT(K,JMX)=SWAP
        END DO
       END IF
       IF(TSCT(I,I).LT.Zero) THEN
        DO K=IOSTA,IOEND
         TSCT(K,I)=-TSCT(K,I)
        END DO
       END IF
      END DO
C Transform the Fock matrix:
      CALL DGEMM_('N','N',NO,NSCT,NSCT,One,FOCK(1,IOSTA),NO,TSCT,NSCT,
     &              Zero,TMP,NO)
      CALL DCOPY_(NO*NSCT,TMP,1,FOCK(1,IOSTA),1)
      DO I=IOSTA,IOEND
       DO J=1,NO
        FOCK(I,J)=TMP(J+NO*(I-IOSTA))
       END DO
      END DO
      CALL DGEMM_('T','N',NSCT,NSCT,NSCT,One,TSCT,NSCT,
     &         TMP(IOSTA),NO,Zero,FOCK(IOSTA,IOSTA),NO)

C Then transform the CMO coeffs:
      CALL DGEMM_('N','N',NB,NSCT,NSCT,One,CMO1SCT,NB,TSCT,NSCT,
     &              Zero,CMO2SCT,NB)

      CALL mma_deallocate(TMP)

      END SUBROUTINE DIAFCK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RS2RS(IMAP,LMAP,IRS2,IRS3,IRED3,ISYM)
!
! Purpose: set up mapping between reduced sets stored at IRS2 and
!          IRS3 (IRED3 is the reduced set id of IRS3).
!
! WARNING: for IRED3 = 1, INDRED is reset here!!!!

use Cholesky, only: iiBstR, iiBstRSh, IndRed, nnBstR, nnBstRSh, nnShl
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LMAP, IRS2, IRS3, IRED3, ISYM
integer(kind=iwp), intent(out) :: IMAP(LMAP)
integer(kind=iwp) :: I, I1, I2, IAB, IAB1, IAB2, ISHLAB, JAB, KAB, LAB, LAB1, LAB2, LAST, MAB, N2, N3
character(len=*), parameter :: SECNAM = 'CHO_RS2RS'

! Check input.
! ------------

if ((IRS2 < 1) .or. (IRS2 > 3) .or. (IRS3 < 1) .or. (IRS3 > 3)) then
  call CHO_QUIT('Index error in '//SECNAM,104)
else if (LMAP < NNBSTR(ISYM,IRS2)) then
  call CHO_QUIT('Dimension error in '//SECNAM,104)
end if

! For IRED3 = 1, INDRED array addresses into shell pair. We hence
! need to reset it (as warned about above).
! ---------------------------------------------------------------

if (IRED3 == 1) then
  I1 = IIBSTR(ISYM,IRS3)+1
  I2 = I1+NNBSTR(ISYM,IRS3)-1
  do I=I1,I2
    IndRed(I,IRS3) = I
  end do
end if

! Set up mapping array.
! ---------------------

IMAP(1:NNBSTR(ISYM,IRS2)) = 0
do ISHLAB=1,NNSHL
  N2 = NNBSTRSH(ISYM,ISHLAB,IRS2)
  N3 = NNBSTRSH(ISYM,ISHLAB,IRS3)
  if ((N2 > 0) .and. (N3 > 0)) then
    if (N2 < N3) then
      IAB1 = IIBSTRSH(ISYM,ISHLAB,IRS2)+1
      IAB2 = IAB1+N2-1
      LAST = 0
      do IAB=IAB1,IAB2
        JAB = INDRED(IIBSTR(ISYM,IRS2)+IAB,IRS2)
        KAB = LAST
        do while (KAB < NNBSTRSH(ISYM,ISHLAB,IRS3))
          KAB = KAB+1
          LAB = IIBSTRSH(ISYM,ISHLAB,IRS3)+KAB
          MAB = INDRED(IIBSTR(ISYM,IRS3)+LAB,IRS3)
          if (MAB == JAB) then
            IMAP(IAB) = LAB
            LAST = KAB
            KAB = NNBSTRSH(ISYM,ISHLAB,IRS3)
          end if
        end do
      end do
    else
      LAB1 = IIBSTRSH(ISYM,ISHLAB,IRS3)+1
      LAB2 = LAB1+N3-1
      LAST = 0
      do LAB=LAB1,LAB2
        MAB = INDRED(IIBSTR(ISYM,IRS3)+LAB,IRS3)
        KAB = LAST
        do while (KAB < NNBSTRSH(ISYM,ISHLAB,IRS2))
          KAB = KAB+1
          IAB = IIBSTRSH(ISYM,ISHLAB,IRS2)+KAB
          JAB = INDRED(IIBSTR(ISYM,IRS2)+IAB,IRS2)
          if (JAB == MAB) then
            IMAP(IAB) = LAB
            LAST = KAB
            KAB = NNBSTRSH(ISYM,ISHLAB,IRS2)
          end if
        end do
      end do
    end if
  end if
end do

end subroutine CHO_RS2RS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Diag_Localisation(A,EVR,EVI,n,iGetVecs)
C
C     Thomas Bondo Pedersen, Dec. 2005.
C
C     Purpose: diagonalize a real general matrix A and return
C              the real and imaginary part of eigenvalues in EVR and
C              EVI. If iGetVecs=0 no eigenvectors are computed; else,
C              eigenvectors are returned in A (such that column one
C              corresponds to eigenvalue 1 in EVR and EVI). Uses XEIGEN
C              from the linalg_util directory (which uses LAPACK).
C              See LAPACK for details about the storage of real and
C              complex eigenvectors.
C
      Implicit None
      Integer n, iGetVecs
      Real*8  A(n,n), EVR(n), EVI(n)
#include "WrkSpc.fh"

      Character*17 SecNam
      Parameter (SecNam = 'Diag_Localisation')

      Integer iErr
      Integer ip_Vecs, l_Vecs

      l_Vecs = n*n
      Call GetMem('Vecs','Allo','Real',ip_Vecs,l_Vecs)

      iErr = 0
      Call xEigen(iGetVecs,n,n,A,EVR,EVI,Work(ip_Vecs),iErr)
      If (iErr .ne. 0) Then
         Write(6,*) SecNam,': xEigen returned ',iErr
         Call SysAbendMsg(SecNam,'Error in xEigen',' ')
      End If

      If (iGetVecs .ne. 0) Call dCopy_(n*n,Work(ip_Vecs),1,A,1)

      Call GetMem('Vecs','Free','Real',ip_Vecs,l_Vecs)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine write_stderr(msg)

use Para_Info, only: MyRank
use Definitions, only: u0

implicit none
character(len=*), intent(in) :: msg

write(u0,'(a,i6,a,1x,a)') '[ process ',myrank,']:',trim(msg)
call xflush(u0)

end subroutine write_stderr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GT1DIA(H1DIA)
! Obtain diagonal of one electron matrix over active orbitals
!
! Dec 97 : obtained from INT1O

use lucia_data, only: IBSO, INT1O, IREOTS, ISMFTO, NACOB, PINT1
use Definitions, only: wp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: H1DIA(*)

! Global pointers

!INA call GT1DIS(H1DIA,IREOTS(1+NINOB),PINT1,INT1,ISMFTO,IBSO,NACOB)
call GT1DIS(H1DIA,IREOTS,PINT1,INT1O,ISMFTO,IBSO,NACOB)

end subroutine GT1DIA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  rotategeom
*
*> @brief
*>   Performs the rotation of \p Geom1 with the \p Q quaternion and stores the result in \p Geom2
*> @author Y. Carissan
*>
*> @details
*> Performs the rotation of \p Geom1 with the \p Q quaternion
*> and stores the result in \p Geom2.
*>
*> @param[in]  Q     Input Quaternion
*> @param[in]  nat   Number of atoms
*> @param[in]  Geom1 Geometry to be rotated, xyz coordinates
*> @param[out] Geom2 Output geometry, xyz coordinates
************************************************************************
      subroutine rotategeom(Q, nat, Geom1, Geom2)
      implicit none
      Integer iat,nat
      Real*8 Q(0:3)
      Real*8 V(3)
      Real*8 Geom1(3,nat),Geom2(3,nat)

      Do iat=1,nat
        call dcopy_(3,Geom1(1,iat),1,V,1)
        Call QuaterRotation(Q,V,Geom2(1,iat))
      End do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1987, Jeppe Olsen                                      *
!               1989, Markus P. Fuelscher                              *
!***********************************************************************

subroutine WRTMAT(A,NROW,NCOL,NMROW,NMCOL)
! AUTHOR: J. OLSEN, UNIV. OF LUND, SWEDEN, APRIL 1987
! MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
!                M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
!
! PRINT REAL VALUED MATRIX

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NROW, NCOL, NMROW, NMCOL
real(kind=wp), intent(in) :: A(NMROW,NMCOL)
integer(kind=iwp) :: I

do I=1,NROW
  write(u6,1010) I,A(I,1:NCOL)
end do

return

1010 format('0',I3,2X,4(ES15.8),/,(6X,4(ES15.8)))

end subroutine WRTMAT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Store_Grad
!
!> @brief Store a vector in the gradients file
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Stores a gradient or coupling vector in the gradients file (GRADS).
!> For a gradient use \p iNAC, \p jNAC = 0. For a coupling vector use
!> \p iRoot = 0.
!>
!> @param[in] Grad  Gradient vector to store
!> @param[in] nGrad Length of \p Grad
!> @param[in] iRoot Root number to which the gradient belongs
!> @param[in] iNAC  First root of a coupling vector
!> @param[in] jNAC  Second root of a coupling vector
!***********************************************************************

subroutine Store_Grad(Grad,nGrad,iRoot,iNAC,jNAC)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nGrad, iRoot, iNAC, jNAC
real(kind=wp), intent(_IN_) :: Grad(nGrad)
integer(kind=iwp) :: iAd, idx, iSt, jSt, Length(1), LuGrad, nCoup, nRoots, TOC(5)
logical(kind=iwp) :: Found, BadFile
integer, allocatable :: i_grad(:), i_nac(:)
integer(kind=iwp), external :: AixRm
character(len=5), parameter :: Filename = 'GRADS'

! Create GRADS file if it does not exist

call Get_iScalar('Number of roots',nRoots)
LuGrad = 20
call f_Inquire(Filename,Found)
if (.not. Found) call Create_Grads(Filename,nRoots,nGrad)

! Read the header

BadFile = .false.
call DaName(LuGrad,Filename)
iAd = 0
call iDaFile(LuGrad,2,TOC,size(TOC),iAd)
iAd = TOC(1)
call iDaFile(LuGrad,2,Length,1,iAd)
if (Length(1) /= nRoots) BadFile = .true.
iAd = TOC(2)
call iDaFile(LuGrad,2,Length,1,iAd)
if (Length(1) /= nGrad) BadFile = .true.
if (BadFile) then
  call DaClos(LuGrad)
  if (AixRm(Filename) /= 0) call Abend()
  call WarningMessage(1,'Number of roots and/or length of gradients do not match, re-creating GRADS file')
  call Create_Grads(Filename,nRoots,nGrad)
  call DaName(LuGrad,Filename)
  iAd = 0
  call iDaFile(LuGrad,1,TOC,size(TOC),iAd)
end if
nCoup = max(1,nRoots*(nRoots-1)/2)
call mma_Allocate(i_grad,nRoots)
call mma_Allocate(i_nac,nCoup)
iAd = TOC(3)
call iDaFile(LuGrad,2,i_grad,nRoots,iAd)
iAd = TOC(4)
call iDaFile(LuGrad,2,i_nac,nCoup,iAd)

! Write the gradient or NAC vector

if (iRoot == 0) then
  if ((iNAC /= 0) .and. (jNAC /= 0)) then
    iSt = max(iNAC,jNAC)-1
    jSt = min(iNAC,jNAC)
    idx = iSt*(iSt-1)/2+jSt
    if (i_nac(idx) == 0) then
      i_nac(idx) = TOC(5)
      call dDaFile(LuGrad,1,Grad,nGrad,TOC(5))
      iAd = 0
      call iDaFile(LuGrad,1,TOC,size(TOC),iAd)
      iAd = TOC(4)
      call iDaFile(LuGrad,1,i_nac,nCoup,iAd)
    else
      iAd = i_nac(idx)
      call dDaFile(LuGrad,1,Grad,nGrad,iAd)
    end if
  end if
else
  idx = iRoot
  if (i_grad(idx) == 0) then
    i_grad(idx) = TOC(5)
    call dDaFile(LuGrad,1,Grad,nGrad,TOC(5))
    iAd = 0
    call iDaFile(LuGrad,1,TOC,size(TOC),iAd)
    iAd = TOC(3)
    call iDaFile(LuGrad,1,i_grad,nRoots,iAd)
  else
    iAd = i_grad(idx)
    call dDaFile(LuGrad,1,Grad,nGrad,iAd)
  end if
end if

#ifdef _DEBUGPRINT_
write(u6,*) 'iRoot, iNAC, jNAC:',iRoot,iNAC,jNAC
write(u6,*) 'grads:',i_grad
write(u6,*) 'nacs:',i_nac
#endif
call DaClos(LuGrad)
call mma_Deallocate(i_grad)
call mma_Deallocate(i_nac)

end subroutine Store_Grad

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE EXPA1_UHF(ARR1,IDM,LI,NSP,ARR2)
      implicit none
      REAL*8 ARR1,ARR2
      integer IDM,LI,NSP, IJ, I,J,K
C
C THIS SUBROUTINE EXPANDS THE FIRST INDEX OF A MATRIX ARR1
C
C    LI*(LI+1)/2
      DIMENSION ARR1(*),ARR2(LI,LI,*)
      IF(NSP.GT.0)THEN
         IJ=1
         DO K=1,IDM
            DO I=1,LI
               CALL DCOPY_(I,ARR1(IJ),1,ARR2(I,1,K),LI)
               CALL DCOPY_(I,ARR1(IJ),1,ARR2(1,I,K),1)
               IJ=IJ+I
            enddo
         enddo
      ELSE
         IJ=1
         DO K=1,IDM
            ARR2(1,1,K)=0.D0
            DO I=2,LI
               ARR2(I,I,K)=0.D0
               CALL DCOPY_(I-1,ARR1(IJ),1,ARR2(I,1,K),LI)
               DO J=1,I-1
                  ARR2(J,I,K)=-ARR1(IJ)
                  IJ=IJ+1
               ENDDO
            enddo
         enddo
      ENDIF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Domain_Localisation(irc)
C
C     Thomas Bondo Pedersen, January 2006.
C
C     Purpose: set up orbital domains and pair domains. Find number of
C              strong, weak, distant, and very distant pairs.
C
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "inflocal.fh"
#include "debug.fh"
#include "WrkSpc.fh"

      Character*19 SecNam
      Parameter (SecNam = 'Domain_Localisation')

      Integer iCount(0:3)
      Real*8  ThrPD(3)

C     Set return code.
C     ----------------

      irc = 0

C     Check for symmetry (not allowed).
C     ---------------------------------

      If (nSym .ne. 1) Then
         irc = -1
         Return
      End If

C     Initializations.
C     ----------------

      nBasT = nBas(1)
      nOcc  = nOrb2Loc(1)
      nnOcc = nOcc*(nOcc+1)/2
      nAtom = nAtoms

      l_nBas_per_Atom = 0
      l_nBas_Start = 0
      l_iDomain = 0
      l_QD = 0
      l_f = 0
      l_iPairDomain = 0
      l_iClass = 0
      l_Rmin = 0
      l_Coord = 0

C     There must be at least 2 atoms and 2 orbitals.
C     ----------------------------------------------

      If (nAtom.lt.2 .or. nOcc.lt.2) Then
         irc = -2
         Return
      End If

C     Allocate and get index arrays for indexation of basis functions on
C     each atom.
C     ------------------------------------------------------------------

      l_nBas_per_Atom = nAtom
      l_nBas_Start    = nAtom
      Call GetMem('nB_per_Atom','Allo','Inte',
     &            ip_nBas_per_Atom,l_nBas_per_Atom)
      Call GetMem('nB_Start','Allo','Inte',
     &            ip_nBas_Start,l_nBas_Start)
      Call BasFun_Atom(iWork(ip_nBas_per_Atom),iWork(ip_nBas_Start),
     &                 Name,nBasT,nAtom,Debug)

C     Define domains.
C     ---------------

      l_iDomain = (nAtom+1)*nOcc
      l_QD = nOcc
      l_f = nOcc
      Call GetMem('iDomain','Allo','Inte',ip_iDomain,l_iDomain)
      Call GetMem('QD','Allo','Real',ip_QD,l_QD)
      Call GetMem('f','Allo','Real',ip_f,l_f)

      kC = ipCMO + nBasT*nFro(1)
      Call DefineDomain(irc,iWork(ip_iDomain),Work(ip_QD),Work(ip_f),
     &                  Work(kC),ThrDomain,
     &                  iWork(ip_nBas_per_Atom),iWork(ip_nBas_Start),
     &                  nAtom,nBasT,nOcc)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': ERROR: DefineDomain returned ',irc
         Go To 1 ! return after deallocations
      End If

      If (Debug) Then
         Write(6,*) SecNam,': checking domain definitions...'
         Call CheckDomain(irc,iWork(ip_iDomain),nAtom,nOcc)
         If (irc .eq. 0) Then
            Write(6,*) '....OK!'
         Else
            Write(6,*) '....Ooops. Buggy domain definition!'
            irc = 2
            Go To 1 ! return after deallocations
         End If
      End If

C     Define pair domains.
C     Make sure that ThrPairDomain is in ascending order.
C     ---------------------------------------------------

      Call dCopy_(3,ThrPairDomain,1,ThrPD,1)
      Call Cho_Order(ThrPD,3,1)
      iChange = 0
      i = 0
      Do While (i.lt.2 .and. iChange.eq.0)
         i = i + 1
         Tst = ThrPairDomain(i) - ThrPD(i)
         If (abs(Tst) .gt. 1.0d-15) Then
            iChange = 1
         End If
      End Do

      l_iPairDomain = (nAtom+1)*nnOcc
      l_iClass = nnOcc
      l_Rmin = nnOcc
      l_Coord = 3*nAtom
      Call GetMem('iPairDomain','Allo','Inte',ip_iPairDomain,
     &                                        l_iPairDomain)
      Call GetMem('iClass','Allo','Inte',ip_iClass,l_iClass)
      Call GetMem('Rmin','Allo','Real',ip_Rmin,l_Rmin)
      Call GetMem('Coord','Allo','Real',ip_Coord,l_Coord)

      Call Get_dArray('Unique Coordinates',Work(ip_Coord),l_Coord)
      Call DefinePairDomain(irc,iWork(ip_iPairDomain),iWork(ip_iClass),
     &                      Work(ip_Rmin),iWork(ip_iDomain),ThrPD,
     &                      Work(ip_Coord),nAtom,nOcc,3)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': ERROR: DefinePairDomain returned ',irc
         Go To 1 ! return after deallocations
      End If

      If (Debug) Then
         Write(6,*) SecNam,': checking pair domain definitions...'
         Call CheckDomain(irc,iWork(ip_iPairDomain),nAtom,nnOcc)
         If (irc .eq. 0) Then
            Write(6,*) '....OK!'
         Else
            Write(6,*) '....Ooops. Buggy pair domain definition!'
            irc = 3
            Go To 1 ! return after deallocations
         End If
      End If

C     Print info.
C     -----------

      Call Domain_Histogram(iWork(ip_iDomain),nAtom,nOcc,
     &                      'Histogram of domain sizes')
      Call Domain_Histogram(iWork(ip_iPairDomain),nAtom,nnOcc,
     &                      'Histogram of pair domain sizes')

      Call Cho_Head('Pair domain classification','=',80,6)
      Do i = 0,3
         iCount(i) = 0
      End Do
      Do ij = 0,nnOcc-1
         iC = iWork(ip_iClass+ij)
         iCount(iC) = iCount(iC) + 1
      End Do
      Write(6,'(/,A)') 'Definition:'
      If (iChange .ne. 0) Then
         Write(6,'(A,A)')
     &   'Notice: the input thresholds were re-ordered to ascending ',
     &   'order'
         Write(6,'(A,1P,3(1X,D15.5))') 'Your input order was:',
     &   (ThrPairDomain(i),i=1,3)
      End If
      Write(6,'(A,1P,D15.5)')
     & 'Strong       pairs:                   R <= ',ThrPD(1)
      Write(6,'(A,1P,D15.5,A,D15.5)')
     & 'Weak         pairs: ',ThrPD(1),' < R <= ',ThrPD(2)
      Write(6,'(A,1P,D15.5,A,D15.5)')
     & 'Distant      pairs: ',ThrPD(2),' < R <= ',ThrPD(3)
      Write(6,'(A,1P,D15.5,A)')
     & 'Very distant pairs: ',ThrPD(3),' < R'
      Write(6,'(/,A)') 'Classification:'
      Fac = 1.0d2/dble(nnOcc)
      Write(6,'(A,I9,3X,F7.2,A)')
     & 'Number of strong       pairs: ',iCount(0),
     & Fac*dble(iCount(0)),'%'
      Write(6,'(A,I9,3X,F7.2,A)')
     & 'Number of weak         pairs: ',iCount(1),
     & Fac*dble(iCount(1)),'%'
      Write(6,'(A,I9,3X,F7.2,A)')
     & 'Number of distant      pairs: ',iCount(2),
     & Fac*dble(iCount(2)),'%'
      Write(6,'(A,I9,3X,F7.2,A,/)')
     & 'Number of very distant pairs: ',iCount(3),
     & Fac*dble(iCount(3)),'%'

C     Analysis of individual domains (if requested).
C     ----------------------------------------------

      If (AnaDomain) Then
         Call Analysis_Domain(iWork(ip_iDomain),Work(ip_QD),Work(ip_f),
     &                        Work(ip_Coord),Name,
     &                        iWork(ip_nBas_Start),nAtom,nBasT,nOcc)
      End If

C     Deallocations.
C     --------------

    1 If (l_Coord .gt. 0) Then
         Call GetMem('Coord','Free','Real',ip_Coord,l_Coord)
      End If
      If (l_Rmin .gt. 0) Then
         Call GetMem('Rmin','Free','Real',ip_Rmin,l_Rmin)
      End If
      If (l_iClass .gt. 0) Then
         Call GetMem('iClass','Free','Inte',ip_iClass,l_iClass)
      End If
      If (l_iPairDomain .gt. 0) Then
         Call GetMem('iPairDomain','Free','Inte',ip_iPairDomain,
     &                                        l_iPairDomain)
      End If
      If (l_f .gt. 0) Then
         Call GetMem('f','Free','Real',ip_f,l_f)
      End If
      If (l_QD .gt. 0) Then
         Call GetMem('QD','Free','Real',ip_QD,l_QD)
      End If
      If (l_iDomain .gt. 0) Then
         Call GetMem('iDomain','Free','Inte',ip_iDomain,l_iDomain)
      End If
      If (l_nBas_Start .gt. 0) Then
         Call GetMem('nB_Start','Free','Inte',
     &               ip_nBas_Start,l_nBas_Start)
      End If
      If (l_nBas_per_Atom .gt. 0) Then
         Call GetMem('nB_per_Atom','Free','Inte',
     &               ip_nBas_per_Atom,l_nBas_per_Atom)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Anders Bernhardsson                              *
!***********************************************************************

subroutine AddGrad_sp(rKappa,rMat,F,idsym,r1,r2)
! Purpose:
!   Adds the contribution from the gradient to
!    [2]
!   E   Kappa. This is done to insure us about
!   a beautiful convergence of the PCG,
!   which is just the case if E is symmetric.

use Symmetry_Info, only: Mul
use MCLR_Data, only: ipCM, ipMat, nDens, nDensC
use input_mclr, only: nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: rKappa(nDensC), F(nDens), r1, r2
real(kind=wp), intent(out) :: rMat(nDensC)
integer(kind=iwp), intent(in) :: idSym
integer(kind=iwp) :: iS, jS
real(kind=wp), allocatable :: K(:), M(:), Tempi(:), Tempj(:)

call mma_allocate(K,nDens,Label='K')
call mma_allocate(M,nDens,Label='M')
M(:) = Zero
call Unc(rkappa,K,idsym,r1)

do iS=1,nSym
  js = Mul(is,idsym)
  if (nOrb(is)*nOrb(js) == 0) cycle
  call mma_allocate(Tempi,nOrb(is)**2,Label='Tempi')
  call mma_allocate(Tempj,nOrb(js)**2,Label='Tempj')
  !  T=Brillouin matrix
  call DGeSub(F(ipCM(is)),nOrb(is),'N',F(ipCM(is)),nOrb(is),'T',Tempi,nOrb(is),nOrb(is),nOrb(is))
  call DGeSub(F(ipCM(js)),nOrb(js),'N',F(ipCM(js)),nOrb(js),'T',Tempj,nOrb(js),nOrb(js),nOrb(js))
  !        t             t
  ! { Kappa T  r2 T kappa  }
  call DGEMM_('T','N',nOrb(is),nOrb(js),nOrb(js),One,K(ipMat(js,is)),nOrb(js),Tempj,nOrb(js),Zero,M(ipMat(is,js)),nOrb(is))
  call DGEMM_('N','T',nOrb(is),nOrb(js),nOrb(is),r2,Tempi,nOrb(is),K(ipmat(js,is)),nOrb(js),One,M(ipMat(is,js)),nOrb(is))
  call mma_deallocate(Tempi)
  call mma_deallocate(Tempj)
end do
call COMPRESS(M,rmat,idsym)
call mma_deallocate(K)
call mma_deallocate(M)

end subroutine AddGrad_sp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Steven Vancoillie                                *
!***********************************************************************
MODULE FOCKMATRIX
  ! implements a type for a blocked Fock matrix and provides functions for
  ! allocating/freeing, printing, and transforming the Fock matrix
  !
  ! Steven Vancoillie, November 2013, Lund
  USE ISO_FORTRAN_ENV, ONLY: REAL64
  IMPLICIT NONE

  TYPE FMAT
    REAL(REAL64), ALLOCATABLE :: &
       & II(:,:), IA(:,:), IS(:,:), &
       & AI(:,:), AA(:,:), AS(:,:), &
       & SI(:,:), SA(:,:), SS(:,:), &
       & DI(:), DA(:), DS(:)
  END type FMAT

CONTAINS

  SUBROUTINE FMAT_INIT(F,NI,NA,NS,FTOT,NMO)
    ! allocate Fock matrix blocks
    IMPLICIT NONE
    TYPE(FMAT), INTENT(OUT) :: F
    INTEGER, INTENT(IN) :: NI, NA, NS, NMO
    REAL(REAL64), INTENT(IN) :: FTOT(NMO,NMO)
    INTEGER :: NISTA, NIEND, NASTA, NAEND, NSSTA, NSEND
    ALLOCATE(F%II(NI,NI))
    ALLOCATE(F%IA(NI,NA))
    ALLOCATE(F%IS(NI,NS))
    ALLOCATE(F%AI(NA,NI))
    ALLOCATE(F%AA(NA,NA))
    ALLOCATE(F%AS(NA,NS))
    ALLOCATE(F%SI(NS,NI))
    ALLOCATE(F%SA(NS,NA))
    ALLOCATE(F%SS(NS,NS))
    ALLOCATE(F%DI(NI))
    ALLOCATE(F%DA(NA))
    ALLOCATE(F%DS(NS))
    NISTA=1
    NIEND=NI
    NASTA=NIEND+1
    NAEND=NIEND+NA
    NSSTA=NAEND+1
    NSEND=NAEND+NS
    F%II(:,:) = FTOT(NISTA:NIEND,NISTA:NIEND)
    F%AI(:,:) = FTOT(NASTA:NAEND,NISTA:NIEND)
    F%SI(:,:) = FTOT(NSSTA:NSEND,NISTA:NIEND)
    F%IA(:,:) = FTOT(NISTA:NIEND,NASTA:NAEND)
    F%AA(:,:) = FTOT(NASTA:NAEND,NASTA:NAEND)
    F%SA(:,:) = FTOT(NSSTA:NSEND,NASTA:NAEND)
    F%IS(:,:) = FTOT(NISTA:NIEND,NSSTA:NSEND)
    F%AS(:,:) = FTOT(NASTA:NAEND,NSSTA:NSEND)
    F%SS(:,:) = FTOT(NSSTA:NSEND,NSSTA:NSEND)
  END SUBROUTINE FMAT_INIT

  SUBROUTINE FMAT_FREE(F)
    ! free Fock matrix blocks
    IMPLICIT NONE
    TYPE(FMAT) :: F
    DEALLOCATE(F%II)
    DEALLOCATE(F%IA)
    DEALLOCATE(F%IS)
    DEALLOCATE(F%AI)
    DEALLOCATE(F%AA)
    DEALLOCATE(F%AS)
    DEALLOCATE(F%SI)
    DEALLOCATE(F%SA)
    DEALLOCATE(F%SS)
    DEALLOCATE(F%DI)
    DEALLOCATE(F%DA)
    DEALLOCATE(F%DS)
  END SUBROUTINE FMAT_FREE

  SUBROUTINE FMAT_LOAD(F)
    IMPLICIT NONE
    TYPE(FMAT) :: F
    INTEGER :: I
    INTEGER :: IERR
    OPEN(UNIT=8,FILE='FOCK.DAT',STATUS='OLD',ACTION='READ',IOSTAT=IERR)
    IF (IERR.NE.0) STOP 'FMAT_LOAD: could not open Fock matrix file'
    DO I=1,SIZE(F%II,1)
      READ(8,*) F%II(I,:), F%IA(I,:), F%IS(I,:)
    END DO
    DO I=1,SIZE(F%AA,1)
      READ(8,*) F%AI(I,:), F%AA(I,:), F%AS(I,:)
    END DO
    DO I=1,SIZE(F%SS,1)
      READ(8,*) F%SI(I,:), F%SA(I,:), F%SS(I,:)
    END DO
    CLOSE(8)
  END SUBROUTINE FMAT_LOAD

  SUBROUTINE FMAT_COPY(F,FTOT,NMO)
    USE ISO_FORTRAN_ENV, ONLY: REAL64
    IMPLICIT NONE
    TYPE(FMAT), INTENT(IN) :: F
    INTEGER, INTENT(IN) :: NMO
    REAL(REAL64), INTENT(OUT) :: FTOT(NMO,NMO)
    INTEGER :: NI, NA, NS
    INTEGER :: NISTA, NIEND, NASTA, NAEND, NSSTA, NSEND
    NI=SIZE(F%II,1)
    NA=SIZE(F%AA,1)
    NS=SIZE(F%SS,1)
    NISTA=1
    NIEND=NI
    NASTA=NIEND+1
    NAEND=NIEND+NA
    NSSTA=NAEND+1
    NSEND=NAEND+NS
    FTOT(NISTA:NIEND,NISTA:NIEND) = F%II
    FTOT(NASTA:NAEND,NISTA:NIEND) = F%AI
    FTOT(NSSTA:NSEND,NISTA:NIEND) = F%SI
    FTOT(NISTA:NIEND,NASTA:NAEND) = F%IA
    FTOT(NASTA:NAEND,NASTA:NAEND) = F%AA
    FTOT(NSSTA:NSEND,NASTA:NAEND) = F%SA
    FTOT(NISTA:NIEND,NSSTA:NSEND) = F%IS
    FTOT(NASTA:NAEND,NSSTA:NSEND) = F%AS
    FTOT(NSSTA:NSEND,NSSTA:NSEND) = F%SS
  END SUBROUTINE FMAT_COPY

  SUBROUTINE FMAT_PRINT(F)
    IMPLICIT NONE
    TYPE(FMAT) :: F
    INTEGER :: I
    CHARACTER(LEN=64) :: FMT
    WRITE(*,*) 'FOCK MATRIX:'
    WRITE(FMT,*) '(F21.14,5X,2F21.14,2X,3F21.14,2X,2F21.14)'
    DO I=1,SIZE(F%II,1)
      WRITE(*,FMT) F%DI(I), F%II(I,:), F%IA(I,:), F%IS(I,:)
    END DO
    WRITE(*,*)
    DO I=1,SIZE(F%AA,1)
      WRITE(*,FMT) F%DA(I), F%AI(I,:), F%AA(I,:), F%AS(I,:)
    END DO
    WRITE(*,*)
    DO I=1,SIZE(F%SS,1)
      WRITE(*,FMT) F%DS(I), F%SI(I,:), F%SA(I,:), F%SS(I,:)
    END DO
    WRITE(*,*)
  END SUBROUTINE FMAT_PRINT

  SUBROUTINE FMAT_UDL(F)
    ! UDL decomposition of the Fock matrix.
    !
    ! The Fock matrix is brought into a diagonal form D, and upper and lower
    ! triangular matrices U and L. Intermediate changes in orbitals basis during
    ! the decomposition are collected in the orthogonal transformation matrices O,
    ! such that eventually, the original matrix F = O U D L O^T. The Fock matrix
    ! in the new basis is then F' = U D L, and F = O F' O^T. The storage of the
    ! new stuff overwrites the input blocked Fock matrix.
    !
    ! input: Fock matrix as blocks:
    !         FII FIA FIS
    !         FAI FAA FAS
    !         FSI FSA FSS
    ! output:
    !  - diagonal blocks FII, FAA, FSS contain the new orbital basis
    !  - new arrays DI, DS, DA contain the diagonal values that form the
    !    matrix D resulting from diagonalizing the diagonal blocks
    !  - off-diagonal blocks FIA, FIS, FAS contain the upper triangular
    !    blocks QIA, QIS, QAS that form the matrix U
    !  - off-diagonal blocks FAI, FSI, FSA contain the lower triangular
    !    blocks QAI, QSI, QSA that form the matrix L

    USE ISO_FORTRAN_ENV, ONLY: REAL64
    IMPLICIT NONE
    TYPE(FMAT), INTENT(INOUT) :: F

    INTEGER :: NI, NA, NS
#ifdef _DEBUG_
    INTEGER :: NTOT
#endif
    INTEGER :: IA, IS

    REAL(REAL64), ALLOCATABLE :: WORK(:)
    REAL(REAL64), ALLOCATABLE :: TMPII(:,:), TMPIA(:,:), TMPIS(:,:)
    REAL(REAL64), ALLOCATABLE :: TMPAI(:,:), TMPAA(:,:), TMPAS(:,:)
    REAL(REAL64), ALLOCATABLE :: TMPSI(:,:), TMPSA(:,:)
    INTEGER :: NWORK, INFO

    NI=SIZE(F%DI)
    NA=SIZE(F%DA)
    NS=SIZE(F%DS)
#ifdef _DEBUG_
    NTOT=NI+NA+NS
#endif
    ! allocate temporary scratch
    NWORK=1+MAX(MAX(NI,NA),NS)**2
    ALLOCATE(WORK(NWORK))
    ALLOCATE(TMPII(NI,NI),TMPIA(NI,NA),TMPIS(NI,NS))
    ALLOCATE(TMPAI(NA,NI),TMPAA(NA,NA),TMPAS(NA,NS))
    ALLOCATE(TMPSI(NS,NI),TMPSA(NS,NA))

    ! step 1: diagonalize the secondary-secondary subblock
    call dsyev_('V','U',NS,F%SS,NS,F%DS,WORK,NWORK,INFO)
    IF (INFO.NE.0) STOP 'Error: diagonalization of FSS failed'

    ! adjust off-diagonal blocks to basis change
    TMPIS(:,:) = MATMUL(F%IS,F%SS)
    F%IS(:,:) = TMPIS
    TMPAS(:,:) = MATMUL(F%AS,F%SS)
    F%AS(:,:) = TMPAS
    F%SI(:,:) = TRANSPOSE(F%IS)
    F%SA(:,:) = TRANSPOSE(F%AS)

    ! construct new QIS/QSI blocks
    DO IS=1,NS
      F%IS(:,IS) = F%IS(:,IS)/F%DS(IS)
    END DO
    TMPII(:,:) = MATMUL(F%IS,F%SI)
    F%II(:,:) = F%II - TMPII
    F%SI(:,:) = TRANSPOSE(F%IS)

    ! adjust off-diagonal blocks to elimination
    TMPAI(:,:) = MATMUL(F%AS,F%SI)
    F%AI(:,:) = F%AI - TMPAI
    F%IA(:,:) = TRANSPOSE(F%AI)

    ! construct new QAS/QSA blocks
    DO IS=1,NS
      F%AS(:,IS) = F%AS(:,IS)/F%DS(IS)
    END DO
    TMPAA(:,:) = MATMUL(F%AS,F%SA)
    F%AA(:,:) = F%AA - TMPAA
    F%SA(:,:) = TRANSPOSE(F%AS)

    ! step 2: diagonalize the active-active subblock
    call dsyev_('V','U',NA,F%AA,NA,F%DA,WORK,NWORK,INFO)
    IF (INFO.NE.0) STOP 'Error: diagonalization of FAA failed'

    ! adjust off-diagonal blocks to basis change
    TMPIA(:,:) = MATMUL(F%IA,F%AA)
    F%IA(:,:) = TMPIA
    TMPSA(:,:) = MATMUL(F%SA,F%AA)
    F%SA(:,:) = TMPSA
    F%AI(:,:) = TRANSPOSE(F%IA)
    F%AS(:,:) = TRANSPOSE(F%SA)

    ! construct new QIA/QAI blocks
    DO IA=1,NA
      F%IA(:,IA) = F%IA(:,IA)/F%DA(IA)
    END DO
    TMPII(:,:) = MATMUL(F%IA,F%AI)
    F%II(:,:) = F%II - TMPII
    F%AI(:,:) = TRANSPOSE(F%IA)

    ! step 3: diagonalize the inactive-inactive subblock
    call dsyev_('V','U',NI,F%II,NI,F%DI,WORK,NWORK,INFO)
    IF (INFO.NE.0) STOP 'Error: diagonalization of FII failed'

    ! adjust off-diagonal blocks to basis change
    TMPAI(:,:) = MATMUL(F%AI,F%II)
    F%AI(:,:) = TMPAI
    TMPSI(:,:) = MATMUL(F%SI,F%II)
    F%SI(:,:) = TMPSI
    F%IA(:,:) = TRANSPOSE(F%AI)
    F%IS(:,:) = TRANSPOSE(F%SI)

    DEALLOCATE(TMPII,TMPIA,TMPIS,TMPAI,TMPAA,TMPAS,TMPSI,TMPSA)

#ifdef _DEBUG_
    ! sanity test: we should be able to reconstruct the original fock matrix!!
    ALLOCATE(O(NTOT,NTOT))
    ALLOCATE(U(NTOT,NTOT))
    ALLOCATE(D(NTOT,NTOT))
    ALLOCATE(L(NTOT,NTOT))

    O = 0.0D0
    U = 0.0D0
    D = 0.0D0
    L = 0.0D0
    DO I=1,NTOT
      U(I,I) = 1.0D0
      L(I,I) = 1.0D0
    END DO

    NISTA=1
    NIEND=NI
    NASTA=NIEND+1
    NAEND=NIEND+NA
    NSSTA=NAEND+1
    NSEND=NAEND+NS

    O(NISTA:NIEND,NISTA:NIEND) = F%II
    O(NASTA:NAEND,NASTA:NAEND) = F%AA
    O(NSSTA:NSEND,NSSTA:NSEND) = F%SS

    WRITE(*,*) 'Orthogonal basis transform:'
    DO I=1,NTOT
      WRITE(*,'(10F10.6)') O(I,:)
    END DO

    U(NISTA:NIEND,NASTA:NAEND) = F%IA
    U(NISTA:NIEND,NSSTA:NSEND) = F%IS
    U(NASTA:NAEND,NSSTA:NSEND) = F%AS

    WRITE(*,*) 'Upper:'
    DO I=1,NTOT
      WRITE(*,'(10F10.6)') U(I,:)
    END DO

    L(NASTA:NAEND,NISTA:NIEND) = F%AI
    L(NSSTA:NSEND,NISTA:NIEND) = F%SI
    L(NSSTA:NSEND,NASTA:NAEND) = F%SA

    WRITE(*,*) 'Lower:'
    DO I=1,NTOT
      WRITE(*,'(10F10.6)') L(I,:)
    END DO

    DO II=1,NI
      D(II,II) = F%DI(II)
    END DO
    DO IA=1,NA
      D(NASTA+IA-1,NASTA+IA-1) = F%DA(IA)
    END DO
    DO IS=1,NS
      D(NSSTA+IS-1,NSSTA+IS-1) = F%DS(IS)
    END DO

    WRITE(*,*) 'Diagonal:'
    DO I=1,NTOT
      WRITE(*,'(10F10.6)') D(I,:)
    END DO

    O = MATMUL(MATMUL(MATMUL(MATMUL(O,U),D),L),TRANSPOSE(O))

    WRITE(*,*) 'Back to Fock matrix???'
    DO I=1,NTOT
      WRITE(*,'(10F10.6)') O(I,:)
    END DO
    DEALLOCATE(O,U,D,L)
#endif

  END SUBROUTINE FMAT_UDL

END MODULE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE INTPNT(IPNT1,ISL1,IPNT2,ISL2)
*
* Pointers to symmetry blocks of integrals
* IPNT1 : Pointer to given one-electron block, total symmetric
* ISL1  : Symmetry of last index for given first index, 1 e-
* IPNT2 : Pointer to given two-electron block
* ISL1  : Symmetry of last index for given first index, 1 e-
*
* In addition pointers to one-electron integrals with general
* symmetry is generated in WORK(KPGINT1(ISM))
*
* Pointers for similarity transformed Hamiltonian may also be
* generated
*
* Jeppe Olsen, Last Update : August 2000
      IMPLICIT REAL*8(A-H,O-Z)
*
* =====
*.Input
* =====
*
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "glbbas.fh"
#include "lucinp.fh"
#include "orbinp.fh"
#include "csm.fh"
#include "crun.fh"

*.CSMPRD
#include "csmprd.fh"
#include "cintfo.fh"
*
* =======
*. Output
* =======
*
      INTEGER IPNT1(NSMOB),ISL1(NSMOB)
      INTEGER IPNT2(NSMOB,NSMOB,NSMOB),ISL2(NSMOB,NSMOB,NSMOB)
*.0 : Pointers to one-integrals, all symmetries, Lower half matrices
      DO ISM = 1, NSMOB
        CALL PNT2DM(        1,    NSMOB,    NSMSX,    ADSXA,   NTOOBS,
     &                 NTOOBS,ISM  ,    ISL1,IWORK(KPGINT1(ISM)),MXPOBS)
      END DO
*.0.5 : Pointers to one-electron integrals, all symmetries, complete form
      DO ISM = 1, NSMOB
        CALL PNT2DM(        0,    NSMOB,    NSMSX,    ADSXA,   NTOOBS,
     &                 NTOOBS,ISM  ,   ISL1,IWORK(KPGINT1A(ISM)),MXPOBS)
      END DO
*.1 : Number of one-electron integrals
      CALL PNT2DM(        1,    NSMOB,    NSMSX,    ADSXA,   NTOOBS,
     &               NTOOBS,    ITSSX,     ISL1,    IPNT1,   MXPOBS)
*.2 : two-electron integrals
      CALL PNT4DM(    NSMOB,    NSMSX,   MXPOBS,   NTOOBS,   NTOOBS,
     &               NTOOBS,   NTOOBS,    ITSDX,    ADSXA,   SXDXSX,
     &                 I12S,     I34S,   I1234S,    IPNT2,     ISL2,
     &                ADASX)
*
c      IF(ISIMTRH.EQ.1) THEN
c*. Pointers for similarity transformed Hamiltonian
c        CALL PNT2DM(0,NSMOB,NSMSX,ADSXA,NTOOBS,NTOOBS,
c     &         1  ,ISL1,WORK(KPINT1_SIMTRH),MXPOBS)
c        I12 = 0
c        I34 = 0
c        I1234 = 1
c        CALL PNT4DM(NSMOB,NSMSX,MXPOBS,NTOOBS,NTOOBS,NTOOBS,NTOOBS,
c     &              ITSDX,ADSXA,SXDXSX,I12,I34,I1234,
c     &              WORK(KPINT2_SIMTRH),ISL2,ADASX)
c      END IF
C?    write(6,*) ' Memory check INTPNT 2 '
C?    CALL MEMCHK
      RETURN
      END
************************************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine real_cvb(arr,nmax,nread,ifc)
      implicit real*8 (a-h,o-z)
#include "inpmod_cvb.fh"
      dimension arr(nmax)

      call real_cvb_internal(arr)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine real_cvb_internal(arr)
      use iso_c_binding
      real*8, target :: arr(*)
      integer, pointer :: iarr(:)
      if(inputmode.eq.2)then
        call c_f_pointer(c_loc(arr(1)),iarr,[nread])
        call gethr_cvb(iarr,nread)
        nullify(iarr)
        return
      endif
      nread=0
      if(nmax.le.0)goto 2000

c  Treat first field differently
      ifcuse=mod(ifc,4)
      if(ifcuse.ge.2)ifcuse=2
      call popfield_cvb(ifcuse)
      call rdreal_cvb(arr(1),ierr)
      if(ierr.gt.0)goto 1000
      nread=nread+1

      ifcuse=mod(ifc,2)
      do 100 i=2,nmax
      call popfield_cvb(ifcuse)
      call rdreal_cvb(arr(i),ierr)
      if(ierr.gt.0)goto 1000
      nread=nread+1
100   continue
      goto 2000
1000  continue
c  Crash if invalid field and IFC +4 :
      if(ierr.eq.4.and.ifc.ge.4)then
        write(6,*)' Invalid field found while reading real!'
        call abend_cvb()
      endif
      call pushfield_cvb()
2000  continue
      if(inputmode.eq.1)then
        call c_f_pointer(c_loc(arr(1)),iarr,[nread])
        call sethr_cvb(iarr,nread)
        nullify(iarr)
      endif
      return
      end subroutine real_cvb_internal
*
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine ChoMP2_Energy_Srt(irc,Delete,EMP2,EOcc,EVir,Wrk,lWrk)
C
C     Thomas Bondo Pedersen, Dec. 2004 / Feb. 2005.
C
C     Purpose: compute MP2 energy contribution using presorted MO
C              Cholesky vectors on disk.
C
      use ChoMP2, only: LnOcc, LnT1am, LiT1am, LiMatij, lUnit
#include "implicit.fh"
      Logical Delete
      Real*8  EOcc(*), EVir(*), Wrk(lWrk)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"

      Character*10 ThisNm
      Character*17 SecNam
      Parameter (SecNam = 'ChoMP2_Energy_Srt', ThisNm = 'Energy_Srt')

      Integer nEnrVec(8), LnT2am, LiT2am(8)
      Integer nVaJi, iVaJi(8)
      Integer iDummy
      Parameter (iDummy = -999999)

      Real*8 X(0:1)
      Data X /0.0D0,1.0D0/

      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      irc = 0

C     Set number of vectors.
C     ----------------------

      If (DecoMP2) Then
         Call iCopy(nSym,nMP2Vec,1,nEnrVec,1)
      Else
         Call iCopy(nSym,NumCho,1,nEnrVec,1)
      End If

C     Initialize MP2 energy correction.
C     ---------------------------------

      EMP2 = 0.0D0

C     Print header of status table.
C     -----------------------------

      If (Verbose) Then
         Call ChoMP2_Energy_Prt(SecNam,0,iDummy)
      End If

C     Loop over occupied orbital batches.
C     Special handling of diagonal batches for ChoAlg=2.
C     --------------------------------------------------

      Do iBatch = 1,nBatch
         If (Verbose) Then
            Call ChoMP2_Energy_Prt(SecNam,1,iBatch)
         End If
         Do jBatch = iBatch,nBatch

            Call ChoMP2_Energy_GetInd(LnT2am,LiT2am,iBatch,jBatch)

            kXaibj = 1
            kEnd0  = kXaibj + LnT2am
            lWrk0  = lWrk   - kEnd0 + 1
            If (lWrk0 .lt. 1) Then
               Call ChoMP2_Quit(SecNam,'insufficient memory','[0]')
            End If

C           Special code for iBatch=jBatch and ChoAlg=2:
C           compute M(ab,ij) = (ai|bj) with i<=j using level 3 BLAS.
C           For ChoAlg=1: use strictly lower triangular storage (=>
C           level 2 BLAS).
C           --------------------------------------------------------

            If (jBatch.eq.iBatch .and. ChoAlg.eq.2) Then

               kMabij = kXaibj  ! rename pointer
               Call FZero(Wrk(kMabij),LnT2am) ! initialize

C              Loop over Cholesky vector symmetries.
C              -------------------------------------

               Do iSym = 1,nSym

                  Nai = LnT1am(iSym,iBatch)
                  If (Nai.gt.0 .and. nEnrVec(iSym).gt.0) Then

C                    Reserve memory for reading a single vector.
C                    -------------------------------------------

                     kVecai = kEnd0
                     kEnd1  = kVecai + Nai
                     lWrk1  = lWrk   - kEnd1 + 1

                     If (lWrk1 .lt. Nai) Then
                        Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                                   '[ChoAlg.2.1]')
                     End If

C                    Set up batch over Cholesky vectors.
C                    -----------------------------------

                     nVec = min(lWrk1/Nai,nEnrVec(iSym))
                     If (nVec .lt. 1) Then ! should not happen
                        Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                                   '[ChoAlg.2.2]')
                     End If
                     nBat = (nEnrVec(iSym)-1)/nVec + 1

C                    Open Cholesky vector files.
C                    ---------------------------

                     Call ChoMP2_OpenB(1,iSym,iBatch)

C                    Start vector batch loop.
C                    ------------------------

                     Do iBat = 1,nBat

                        If (iBat .eq. nBat) Then
                           NumVec = nEnrVec(iSym) - nVec*(nBat-1)
                        Else
                           NumVec = nVec
                        End If
                        iVec1 = nVec*(iBat-1) + 1

C                       Set up index arrays for reordered vectors.
C                       ------------------------------------------

                        nVaJi = 0
                        Do iSymi = 1,nSym
                           iSyma = MulD2h(iSymi,iSym)
                           iVaJi(iSymi) = nVaJi
                           nVaJi = nVaJi
     &                          + nVir(iSyma)*NumVec*LnOcc(iSymi,iBatch)
                        End Do

C                       Pointer to reordered vectors: kVec.
C                       -----------------------------------

                        kVec  = kEnd1
                        kEnd2 = kVec  + nVaJi
                        lWrk2 = lWrk  - kEnd2 + 1
                        If (lWrk2 .lt. 0) Then ! should not happen
                           Call ChoMP2_Quit(SecNam,
     &                                      'Insufficient memory',
     &                                      '[ChoAlg.2.3]')
                        End If

C                       Read one vector at a time and reorder.
C                       --------------------------------------

                        iVec0 = iVec1 - 1
                        Do iVec = 1,NumVec

                           iOpt = 2
                           lTot = Nai
                           iAdr = Nai*(iVec0+iVec-1) + 1
                           Call ddaFile(lUnit(iSym,iBatch),iOpt,
     &                                  Wrk(kVecai),lTot,iAdr)

                           Do iSymi = 1,nSym
                              iSyma = MulD2h(iSymi,iSym)
                              Do i = 1,LnOcc(iSymi,iBatch)
                                 kOff1 = kVecai
     &                                 + LiT1am(iSyma,iSymi,iBatch)
     &                                 + nVir(iSyma)*(i-1)
                                 kOff2 = kVec + iVaJi(iSymi)
     &                                 + nVir(iSyma)*NumVec*(i-1)
     &                                 + nVir(iSyma)*(iVec-1)
                                 Call dCopy_(nVir(iSyma),Wrk(kOff1),1,
     &                                      Wrk(kOff2),1)
                              End Do
                           End Do

                        End Do

C                       Compute M(ab,ij) for i<=j.
C                       First do iSymi=iSymj, then iSymi<iSymj.
C                       ---------------------------------------

                        Do iSymj = 1,nSym

                           iSymb = MulD2h(iSymj,iSym)

                           If (nVir(iSymb) .gt. 0) Then

                              Do j = 1,LnOcc(iSymj,iBatch)
                                 Do i = 1,j

                                    ij = LiMatij(iSymj,iSymj,iBatch)
     &                                 + iTri(i,j)

                                    kOffi = kVec + iVaJi(iSymj)
     &                                    + nVir(iSymb)*NumVec*(i-1)
                                    kOffj = kVec + iVaJi(iSymj)
     &                                    + nVir(iSymb)*NumVec*(j-1)
                                    kOffM = kMabij + LiT2am(1)
     &                                    + nMatab(1)*(ij-1)
     &                                    + iMatab(iSymb,iSymb)

                                    Call DGEMM_('N','T',
     &                                   nVir(iSymb),nVir(iSymb),NumVec,
     &                                   1.0d0,Wrk(kOffi),nVir(iSymb),
     &                                         Wrk(kOffj),nVir(iSymb),
     &                                   1.0D0,Wrk(kOffM),nVir(iSymb))

                                 End Do
                              End Do

                              Do iSymi = 1,iSymj-1

                                 iSyma  = MulD2h(iSymi,iSym)
                                 iSymab = MulD2h(iSyma,iSymb)
                                 iSymij = iSymab

                                 If (LnOcc(iSymi,iBatch).gt.0 .and.
     &                               nVir(iSyma).gt.0) Then

                                    Do j = 1,LnOcc(iSymj,iBatch)
                                       Do i = 1,LnOcc(iSymi,iBatch)

                                          ij =
     &                                    LiMatij(iSymi,iSymj,iBatch)
     &                                    + LnOcc(iSymi,iBatch)*(j-1)
     &                                    + i

                                          kOffi = kVec + iVaJi(iSymi)
     &                                    + nVir(iSyma)*NumVec*(i-1)
                                          kOffj = kVec + iVaJi(iSymj)
     &                                    + nVir(iSymb)*NumVec*(j-1)
                                          kOffM = kMabij
     &                                    + LiT2am(iSymij)
     &                                    + nMatab(iSymab)*(ij-1)
     &                                    + iMatab(iSyma,iSymb)

                                          Call DGEMM_('N','T',
     &                                   nVir(iSyma),nVir(iSymb),NumVec,
     &                                    1.0d0,Wrk(kOffi),nVir(iSyma),
     &                                          Wrk(kOffj),nVir(iSymb),
     &                                    1.0D0,Wrk(kOffM),nVir(iSyma))

                                       End Do
                                    End Do

                                 End If

                              End Do

                           End If

                        End Do

                     End Do

C                    Close Cholesky vector files.
C                    ----------------------------

                     Call ChoMP2_OpenB(2,iSym,iBatch)

                  End If

               End Do ! iSym

            Else ! level 2 BLAS for diagonal batches.

C              Loop over Cholesky vector symmetries.
C              -------------------------------------

               Do iSym = 1,nSym

                  Nai = LnT1am(iSym,iBatch)
                  Nbj = LnT1am(iSym,jBatch)
                  If (Nai.gt.0 .and. Nbj.gt.0 .and. nEnrVec(iSym).gt.0)
     &            Then

C                    Setup Cholesky vector batching.
C                    -------------------------------

                     If (jBatch .eq. iBatch) Then
                       MinMem = Nai
                     Else
                       MinMem = Nai + Nbj
                     End If
                     NumVec = min(lWrk0/MinMem,nEnrVec(iSym))
                     If (NumVec .lt. 1) Then
                        Call ChoMP2_Quit(SecNam,'insufficient memory',
     &                                   '[1]')
                     End If
                     nBat = (nEnrVec(iSym) - 1)/NumVec + 1

C                    Open Cholesky vector files.
C                    ---------------------------

                     Call ChoMP2_OpenB(1,iSym,iBatch)
                     If (jBatch .ne. iBatch) Then
                        Call ChoMP2_OpenB(1,iSym,jBatch)
                     End If

C                    Cholesky vector batch loop.
C                    ---------------------------

                     Do iBat = 1,nBat

                        If (iBat .eq. nBat) Then
                           NumV = nEnrVec(iSym) - NumVec*(nBat-1)
                        Else
                           NumV = NumVec
                        End If
                        iVec1 = NumVec*(iBat-1) + 1

                        kVai = kEnd0
                        kVbj = kVai + Nai*NumV
                        If (jBatch .eq. iBatch) Then
                           kEnd1 = kVbj
                           kVbj  = kVai
                        Else
                           kEnd1 = kVbj + Nbj*NumV
                        End If
                        lWrk1 = lWrk - kEnd1 + 1
                        If (lWrk1 .lt. 0) Then ! this would be a bug...
                           Call ChoMP2_Quit(SecNam,
     &                                      'insufficient memory','[2]')
                        End If

C                       Read vectors.
C                       -------------

                        iOpt = 2
                        lTot = Nai*NumV
                        iAdr = Nai*(iVec1-1) + 1
                        Call ddaFile(lUnit(iSym,iBatch),iOpt,
     &                               Wrk(kVai),lTot,iAdr)
                        If (jBatch .ne. iBatch) Then
                           iOpt = 2
                           lTot = Nbj*NumV
                           iAdr = Nbj*(iVec1-1) + 1
                           Call ddaFile(lUnit(iSym,jBatch),iOpt,
     &                                  Wrk(kVbj),lTot,iAdr)
                        End If

C                       Compute integral contribution.
C                       ------------------------------

                        Fac   = X(min((iBat-1),1))
                        kXint = kXaibj + LiT2am(iSym)
                        If (iBatch .eq. jBatch) Then
                           Call dGeMM_Tri('N','T',Nai,Nai,NumV,
     &                                1.0D0,Wrk(kVai),Nai,Wrk(kVai),Nai,
     &                                Fac,Wrk(kXint),Nai)
                        Else
                           Call DGEMM_('N','T',Nai,Nbj,NumV,
     &                                1.0D0,Wrk(kVai),Nai,Wrk(kVbj),Nbj,
     &                                Fac,Wrk(kXint),Nai)
                        End If

                     End Do ! Cholesky vector batch

C                    Close Cholesky vector files.
C                    ----------------------------

                     Call ChoMP2_OpenB(2,iSym,iBatch)
                     If (jBatch .ne. iBatch) Then
                        Call ChoMP2_OpenB(2,iSym,jBatch)
                     End If

                  End If

               End Do ! iSym

            End If

C           Compute contribution to MP2 energy correction.
C           ----------------------------------------------

            Call ChoMP2_Energy_Contr(EMP2,EOcc,EVir,Wrk(kXaibj),
     &                               LnT2am,LiT2am,iBatch,jBatch)

         End Do ! jBatch
         If (Verbose) Then
            Call ChoMP2_Energy_Prt(SecNam,2,iBatch)
         End If
      End Do ! iBatch

C     Finish table.
C     -------------

      If (Verbose) Then
         Call ChoMP2_Energy_Prt(SecNam,3,iBatch)
      End If

C     Delete files if requested.
C     --------------------------

      If (Delete) Then
         Do iBatch = 1,nBatch
            Do iSym = 1,nSym
               Call ChoMP2_OpenB(1,iSym,iBatch)
               Call ChoMP2_OpenB(3,iSym,iBatch)
            End Do
         End Do
      End If

C     Change sign on energy.
C     ----------------------

      EMP2 = -EMP2

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine ChoRPA_Drv()
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Driver routine for CD/DF-based RPA.
C
      Implicit None

      Character*10 SecNam
      Parameter (SecNam='ChoRPA_Drv')

      Call RPA_Warn(3,SecNam//': not implemented yet')

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine TRDNS2A(IVEC,JVEC,DPT2,NDPT2)
! Add to the diagonal blocks of transition density matrix,
!    DPT2(p,q) = Add <IVEC| E(p,q) |JVEC>,
! where p,q are active indices. Compare TRDNS2D.
! The present solution gives just a reasonable approximation,
! with correct trace.

use Index_Functions, only: iTri
use PrintLevel, only: VERBOSE
use caspt2_global, only: DREF, iPrGlb
use caspt2_module, only: nActEl, nAES, nAsh, nAshT, nInDep, nIsh, nISup, nOrb, nSym
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC, NDPT2
real(kind=wp), intent(inout) :: DPT2(NDPT2)
integer(kind=iwp) :: ICASE, IOFDPT, ISYM, IT, ITABS, ITQ, ITU, IU, IUABS, IUQ, IUT, lVec1, lVec2, NA, NADIFF, NAHOLE, NI, NIN, &
                     NIS, NO, nVec
real(kind=wp) :: COEF1, COEF2, D, DR, OVL
integer(kind=iwp), parameter :: NACTD(13) = [1,2,2,-1,0,1,1,-2,-2,-1,-1,0,0]
real(kind=wp), external :: RHS_DDOT

if (IPRGLB >= VERBOSE) then
  call WarningMessage(1,'Computing approximated density.')
  write(u6,*) ' The active/active submatrices of the density'
  write(u6,*) ' matrix is roughly approximated only.'
end if

COEF1 = Zero
COEF2 = Zero
NAHOLE = 2*NASHT-NACTEL
do ICASE=1,13
  NADIFF = NACTD(ICASE)
  if (NACTEL+NADIFF < 0) cycle
  if (NAHOLE-NADIFF < 0) cycle
  OVL = Zero
  do ISYM=1,NSYM
    NIN = NINDEP(ISYM,ICASE)
    if (NIN == 0) cycle
    NIS = NISUP(ISYM,ICASE)
    NVEC = NIN*NIS
    if (NVEC == 0) cycle
    call RHS_ALLO(NIN,NIS,LVEC1)
    call RHS_ALLO(NIN,NIS,LVEC2)
    call RHS_READ_SR(LVEC1,iCASE,iSYM,IVEC)
    call RHS_READ_SR(LVEC2,iCASE,iSYM,JVEC)
    OVL = OVL+RHS_DDOT(NIN,NIS,LVEC1,LVEC2)
    call RHS_FREE(LVEC1)
    call RHS_FREE(LVEC2)
  end do
  if (NADIFF > 0) then
    COEF1 = COEF1+OVL*real(NADIFF,kind=wp)/real(max(1,NAHOLE),kind=wp)
    COEF2 = COEF2+OVL*real(NAHOLE-NADIFF,kind=wp)/real(max(1,NAHOLE),kind=wp)
  else
    COEF2 = COEF2+OVL*real(NACTEL+NADIFF,kind=wp)/real(max(1,NACTEL),kind=wp)
  end if
end do

IOFDPT = 0
do ISYM=1,NSYM
  NI = NISH(ISYM)
  NA = NASH(ISYM)
  NO = NORB(ISYM)
  do IT=1,NA
    ITQ = NI+IT
    ITABS = NAES(ISYM)+IT
    do IU=1,IT
      IUQ = NI+IU
      IUABS = NAES(ISYM)+IU
      DR = DREF(iTri(ITABS,IUABS))
      D = COEF2*DR
      if (IT == IU) D = D+Two*COEF1
      ITU = ITQ+NO*(IUQ-1)
      IUT = IUQ+NO*(ITQ-1)
      DPT2(IOFDPT+ITU) = DPT2(IOFDPT+ITU)+D
      DPT2(IOFDPT+IUT) = DPT2(IOFDPT+ITU)
    end do
  end do
  IOFDPT = IOFDPT+NO**2
end do

end subroutine TRDNS2A

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  Hel
*
*> @brief
*>   Couple the electrostatic part of the solvent with the QM-region.
*>   Only include the static part, no polarization at this moment
*> @author A. Ohrn
*>
*> @details
*> (2) The electrostatics.
*>
*> @param[in]  Eint   The static field from the solvent on the QM molecule centers
*> @param[in]  itri   Number of elements in triangular \f$ H \f$-matrix
*> @param[in]  ici    Number of MME-centers
*> @param[in]  ql     MME-charges, obtained from the MME
*> @param[in]  dil    MME-dipoles
*> @param[in]  qqxxyy MME-quadrupoles.
*> @param[out] vmat   The electrostatic part of the solute-solvent interaction matrix
*> @param[in]  iprint Print parameter
************************************************************************
      Subroutine Hel(Eint,itri,ici,ql,dil,qqxxyy,vmat,iprint)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "WrkSpc.fh"

      Dimension Ql(MxOT,MxQCen),Dil(MxOT,3,MxQCen)
     &,QQxxyy(MxOT,6,MxQCen),Eint(MxQCen,10),Vmat(MxOT)


*Zeros
      Do 9, i=1,itri
        Vmat(i)=0.0d0
9     Continue

*The electrostatic perturbation: <psi_i|V_el|psi_j>
      Do 10, i=1,itri
        Do 11, k=1,ici
          Vmat(i)=Vmat(i)+Eint(k,1)*Ql(i,k)
          Do 12, j=1,3
            Vmat(i)=Vmat(i)+Eint(k,j+1)*Dil(i,j,k)
12        Continue
          Vmat(i)=Vmat(i)+Eint(k,5)*QQxxyy(i,1,k)
          Vmat(i)=Vmat(i)+Eint(k,7)*QQxxyy(i,3,k)
          Vmat(i)=Vmat(i)+Eint(k,10)*QQxxyy(i,6,k)
          Vmat(i)=Vmat(i)+Eint(k,6)*QQxxyy(i,2,k)*2.0d0
          Vmat(i)=Vmat(i)+Eint(k,8)*QQxxyy(i,4,k)*2.0d0
          Vmat(i)=Vmat(i)+Eint(k,9)*QQxxyy(i,5,k)*2.0d0
11      Continue
10    Continue

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iprint)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SetUpDipMat2(DipMat,max_term,C1,W1,det1,r01,C2,W2,det2,r02,max_mOrd,max_nOrd,max_nOrd2,max_mInc,max_nInc,max_nInc2, &
                        mMat,nMat,mInc,nInc,mDec,nDec,det0,base,TranDip,TranDipGrad,nOsc,nDimTot)
!  Purpose:
!    Performs a least squares fit of the transition dipole at the two
!    centers and at the intermediate oscillator. Calculates the matrix
!    elements of the transition dipole at these centers.
!
!  Input:
!    ipow       : Two dimensional integer array - terms of the polynomial.
!    var        : Real two dimensional array - coordinates to be used in the fit.
!    dip        : Real array - values of dipole at the coordinates contained in var.
!    trfName    : Character array - transformation associated with each internal coordinate.
!    use_weight : Logical
!    max_term   : Integer - maximum order of the transition dipole terms.
!    W1,W2      : Real two dimensional arrays - eigenvectors scaled by the square root of the eigenvalues.
!    C1,C2      : Real two dimensional arrays - inverses of W1 and W2.
!    det1,det2  : Real variables - determinants of C1 and C2.
!    r01,r02    : Real arrays - coordinates of the two oscillators.
!    max_mOrd,
!    max_nOrd,
!    max_nOrd2
!    max_mInc,
!    max_nInc,
!    max_nInc2  : Integer variables
!    mMat,nMat,
!    mInc,nInc,
!    mDec,nDec  : Two dimensional integer arrays
!
!  Output:
!    DipMat     : Real two dimensional array - contains the matrix elements of the transition dipole.

use mula_global, only: mdim1, mdim2, ndim1, ndim2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: max_term, max_mOrd, max_nOrd, max_nOrd2, max_mInc, max_nInc, max_nInc2, mMat(0:mdim1,mdim2), &
                                 nMat(0:ndim1,ndim2), mInc(0:mdim1,mdim2), nInc(0:ndim1,ndim2), mDec(0:mdim1,mdim2), &
                                 nDec(0:ndim1,ndim2), nOsc, nDimTot
real(kind=wp), intent(out) :: DipMat(0:nDimTot,0:nDimTot), det0
real(kind=wp), intent(in) :: C1(nOsc,nOsc), W1(nOsc,nOsc), det1, r01(nOsc), C2(nOsc,nOsc), W2(nOsc,nOsc), det2, r02(nOsc), &
                             Base(nOsc,nOsc), TranDip(3), TranDipGrad(nOsc)
integer(kind=iwp) :: l_C1
real(kind=wp) :: D0(3), FC00
real(kind=wp), allocatable :: alpha1(:,:), alpha2(:,:), beta(:,:), C(:,:), D1(:), D2(:,:), D3(:,:,:), D4(:,:,:,:), Dij(:,:), &
                              L(:,:), r0vec(:), Sij(:,:), U(:,:), W(:,:)

! Initialize.
call mma_allocate(Dij,[0,max_mOrd],[0,max_mOrd],label='Dij')

call mma_allocate(C,nOsc,nOsc,label='C')
call mma_allocate(W,nOsc,nOsc,label='W')

call mma_allocate(L,[0,max_mOrd],[0,max_mOrd],label='L')
call mma_allocate(U,[0,max_nOrd2],[0,max_nOrd2],label='U')
call mma_allocate(Sij,[0,max_mOrd],[0,max_nOrd],label='Sij')
call mma_allocate(r0vec,nOsc,label='r0vec')
call mma_allocate(alpha1,nOsc,nOsc,label='alpha1')
call mma_allocate(alpha2,nOsc,nOsc,label='alpha2')
call mma_allocate(beta,nOsc,nOsc,label='beta')
call mma_allocate(D1,nOsc,label='D1')
call mma_allocate(D2,nOsc,nOsc,label='D2')
call mma_allocate(D3,nOsc,nOsc,nOsc,label='D3')
call mma_allocate(D4,nOsc,nOsc,nOsc,nOsc,label='D4')

! Calculate terms of type
!
!                    dM  |
!                    --  | < i | Q  | j >,
!                    dQ  |        k
!                      k  Q
!                          0
! where M is the (transition) dipole moment, |i> and |j> are harmonic
! oscillator states, Q_0 is the equilibrium geometry and Q_k is the
! k:th normal coordinate.

l_C1 = nOsc
call Calc_r00(C1,C2,C,W,alpha1,alpha2,r0vec,r01,r02,det0,det1,det2,FC00,l_C1)
call FCval(C1,W1,det1,r01,C2,W2,det2,r02,Sij,max_mOrd,max_nOrd,max_nOrd2,max_mInc,max_nInc,max_nInc2,mMat,nMat,mInc,nInc,mDec, &
           nDec,C,W,det0,L,U,FC00,alpha1,alpha2,beta,l_C1)
D0(1) = TranDip(1)
D0(2) = TranDip(2)
D0(3) = TranDip(3)
D1(:) = TranDipGrad
D2(:,:) = Zero
D3(:,:,:) = Zero
D4(:,:,:,:) = Zero

call DipMatEl(Dij,W,L,U,FC00,nMat,nInc,nDec,D0(1),D1,D2,D3,D4,max_term,Base,ndim1,ndim2,max_mOrd,max_nOrd2)
DipMat(0:max_mOrd,0:max_mOrd) = Dij

call mma_deallocate(Dij)
call mma_deallocate(C)
call mma_deallocate(W)
call mma_deallocate(L)
call mma_deallocate(U)
call mma_deallocate(r0vec)
call mma_deallocate(alpha1)
call mma_deallocate(alpha2)
call mma_deallocate(beta)
call mma_deallocate(D1)
call mma_deallocate(D2)
call mma_deallocate(D3)
call mma_deallocate(D4)

end subroutine SetUpDipMat2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETVEC0(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,SCR,LSCR)
!=======================================================================
!==== DEPRECATED - USE CHO_X_GETVEC OR CHO_X_VECRD INSTEAD =============
!=======================================================================
!
! Purpose: read Cholesky vectors IVEC=IVEC1,...,IVEC1+NUMVEC-1
!          of symmetry ISYM from file. The vectors are returned
!          in the "current" reduced set.
!
! NOTE: array SCR(LSCR) is used for storing the vectors in the
!       red. set from disk and for a full first red. set vector.
!       Thus, to be certain that enough memory is available,
!       use LSCR = 2 x dimension of first reduced set.

use Cholesky, only: iiBstR, IndRed, InfVec, LuPri, nnBstR, nSys_call
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LENVEC, NUMVEC, IVEC1, ISYM, LSCR
real(kind=wp), intent(out) :: CHOVEC(LENVEC,NUMVEC)
real(kind=wp), intent(inout) :: SCR(LSCR)
integer(kind=iwp) :: IAB, ILOC, IRED, IREDC, IVEC, JAB, JNUM, JRED, JVEC, KAB, KEND1, KREAD, KRED1, KREDU, LSCR1, MUSED
real(kind=wp) :: XNRM
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_GETVEC0'
real(kind=wp), external :: ddot_

! Initialize output array.
! ------------------------

CHOVEC(:,:) = Zero

! Read reduced set index arrays for first vector.
! -----------------------------------------------

IRED = INFVEC(IVEC1,2,ISYM)
ILOC = 3
call CHO_GETRED(IRED,ILOC,.false.)
call CHO_SETREDIND(3)
KRED1 = 1
KREAD = KRED1+NNBSTR(ISYM,1)
KEND1 = KREAD+NNBSTR(ISYM,3)
LSCR1 = LSCR-KEND1+1
if (LSCR1 < 0) then
  write(LUPRI,*) 'Insufficient scratch space in ',SECNAM
  write(LUPRI,*) 'Available: ',LSCR,'   Need: ',KEND1-1
  write(LUPRI,*) '- needed for RED1: ',NNBSTR(ISYM,1)
  write(LUPRI,*) '- needed for READ: ',NNBSTR(ISYM,3)
  call CHO_QUIT('[1] Insufficient scratch space in '//SECNAM,102)
end if

! Read vectors and re-order into current reduced set via reduced set 1.
! NOTE: if the read vectors are already in red. set 1, don't resort.
! ---------------------------------------------------------------------

do JVEC=1,NUMVEC

  IVEC = IVEC1+JVEC-1
  JRED = INFVEC(IVEC,2,ISYM)
  if (JRED /= IRED) then   ! read new reduced set
    call CHO_GETRED(JRED,ILOC,.false.)
    call CHO_SETREDIND(3)
    KEND1 = KREAD+NNBSTR(ISYM,3)
    LSCR1 = LSCR-KEND1+1
    if (LSCR1 < 0) then
      write(LUPRI,*) 'Insufficient scratch space in ',SECNAM
      write(LUPRI,*) 'Available: ',LSCR,'   Need: ',KEND1-1
      write(LUPRI,*) '- needed for RED1: ',NNBSTR(ISYM,1)
      write(LUPRI,*) '- needed for READ: ',NNBSTR(ISYM,3)
      call CHO_QUIT('[2] Insufficient scratch space in '//SECNAM,102)
    end if
    IRED = JRED
  end if

  !IOPT = 2
  !IADR = INFVEC(IVEC,3,ISYM)
  !CALL DDAFILE(LUCHO(ISYM),IOPT,SCR(KREAD),NNBSTR(ISYM,3),IADR)
  !-tbp: replaced above code to make use of buffer through cho_vecrd.
  JNUM = 0
  IREDC = IRED
  MUSED = 0
  call CHO_VECRD(SCR(KREAD),NNBSTR(ISYM,3),IVEC,IVEC,ISYM,JNUM,IREDC,MUSED)
  if (JNUM /= 1) call CHO_QUIT('Logical error in '//SECNAM,103)
  NSYS_CALL = NSYS_CALL+1
  if (LOCDBG) then
    XNRM = sqrt(DDOT_(NNBSTR(ISYM,3),SCR(KREAD),1,SCR(KREAD),1))
    write(LUPRI,*) SECNAM,': Vector:',IVEC,' address: ',INFVEC(IVEC,3,ISYM),' norm: ',XNRM,' sym. ',ISYM,' red. set: ',IRED, &
                   ' dim.: ',NNBSTR(ISYM,3)
  end if

  SCR(KRED1:KRED1+NNBSTR(ISYM,1)-1) = Zero
  if (IRED > 1) then
    do JAB=1,NNBSTR(ISYM,3)   ! sort into rs1 ordering
      KAB = IIBSTR(ISYM,3)+JAB
      IAB = INDRED(KAB,3)-IIBSTR(ISYM,1)
      SCR(KRED1+IAB-1) = SCR(KREAD+JAB-1)
    end do
    KREDU = KRED1   ! point rs2 sort to red1 resort
  else if (IRED == 1) then
    KREDU = KREAD   ! point rs2 sort to read (already red1)
  else
    write(LUPRI,*) SECNAM,': ERROR: IRED is negative: ',IRED
    call CHO_QUIT('Reduced set error in '//SECNAM,104)
    KREDU = -999999 ! just to avoid compiler warnings
  end if

  do JAB=1,NNBSTR(ISYM,2)  ! sort into in rs2 ordering
    KAB = IIBSTR(ISYM,2)+JAB
    IAB = INDRED(KAB,2)-IIBSTR(ISYM,1)
    CHOVEC(JAB,JVEC) = SCR(KREDU+IAB-1)
  end do

end do

end subroutine CHO_GETVEC0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! drt related subroutines

subroutine active_drt()

use gugaci_global, only: iseg_downwei, iseg_sta, iseg_upwei, jd, jj, jpad_upwei, js, jt, jv, LuDrt, max_node, mxnode, nci_dim, &
                         ng_sm, no, norb_act, norb_inn, nu_ad, nu_ae !, logic_mr, logic_mrelcas
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i, im, iseg_dim(25), jde, jdim, jdn, jds, jji, jp, jpe, jpn, jsim, jtim, ndi
integer(kind=iwp), allocatable :: iin(:)

nci_dim = 0
iseg_dim(:) = 0
if (norb_act == 0) then
  !====================  norb_act=0 ====================================
  iseg_sta(1) = 0
  iseg_dim(1) = 1
  do im=1,ng_sm
    jdim = nu_ae(1+im)
    jtim = nu_ae(9+im)
    jsim = nu_ae(17+im)
    jd(im) = jdim
    jt(im) = jtim
    js(im) = jsim
    iseg_dim(jdim) = iseg_downwei(jdim)*jpad_upwei(jdim)
    iseg_dim(jtim) = iseg_downwei(jtim)*jpad_upwei(jtim)
    iseg_dim(jsim) = iseg_downwei(jsim)*jpad_upwei(jsim)
    if (iseg_dim(jdim) == 0) then
      jd(im) = 0
      nu_ad(jdim) = 0
      nu_ae(jdim) = 0
    end if
    if (iseg_dim(jtim) == 0) then
      jt(im) = 0
      nu_ad(jtim) = 0
      nu_ae(jtim) = 0
    end if
    if (iseg_dim(jsim) == 0) then
      js(im) = 0
      nu_ad(jsim) = 0
      nu_ae(jsim) = 0
    end if
  end do
  do jp=2,25
    iseg_sta(jp) = iseg_sta(jp-1)+iseg_dim(jp-1)
  end do
  nci_dim = iseg_sta(25)+iseg_dim(25)
  iseg_sta(26) = nci_dim
  do jp=1,25
    if (iseg_downwei(jp) == 0) cycle
    iseg_upwei(jp) = iseg_dim(jp)/iseg_downwei(jp)
  end do
else
  !====================  norb_act<>0 ===================================
  !if (logic_mr) call rst()         !npp=2
  !if (logic_mrelcas) call rcas()   !npp=3

  write(u6,*) ' '
  write(u6,*) ' now reading distinct row tableau'
  call readdrt(ludrt)

  nu_ae(1) = jv
  do im=1,ng_sm
    nu_ae(1+im) = jd(im)
    nu_ae(9+im) = jt(im)
    nu_ae(17+im) = js(im)
  end do
  jds = 1
  jde = mxnode
  jpe = no(norb_inn+1)

  jp = jv
  call mma_allocate(iin,[0,max_node],label='iin')
  !iin(1:jpe) = 0
  !iin(0) = 0
  iin(:) = 0
  iin(jp) = 1
  iseg_sta(1) = 0       ! for node_ext
  iseg_dim(1) = 0
  do jpn=jpe,1,-1
    do i=1,4
      jji = jj(i,jpn)
      if (iin(jji) == 0) cycle
      iin(jpn) = iin(jpn)+iin(jji)
    end do
  end do
  do jdn=jds,jde
    if (nu_ad(jdn) == 0) cycle
    ndi = iin(jdn)*iseg_downwei(1)*jpad_upwei(jdn)
    iseg_dim(1) = iseg_dim(1)+ndi
  end do
  do im=1,ng_sm
    jp = jd(im)
    iseg_sta(1+im) = nci_dim       ! for node_d_ext
    iseg_dim(1+im) = 0
    if (jp == 0) cycle
    iin(1:jpe) = 0
    iin(0) = 0
    iin(jp) = 1
    do jpn=jpe,1,-1
      do i=1,4
        jji = jj(i,jpn)
        if (iin(jji) == 0) cycle
        iin(jpn) = iin(jpn)+iin(jji)
      end do
    end do
    do jdn=jds,jde
      if (nu_ad(jdn) == 0) cycle
      ndi = iin(jdn)*iseg_downwei(1+im)*jpad_upwei(jdn)
      iseg_dim(1+im) = iseg_dim(1+im)+ndi
    end do
  end do

  do im=1,ng_sm
    jp = jt(im)
    iseg_sta(9+im) = nci_dim       ! for node_t_ext
    iseg_dim(9+im) = 0
    if (jp == 0) cycle
    iin(1:jpe) = 0
    iin(0) = 0
    iin(jp) = 1
    do jpn=jpe,1,-1
      do i=1,4
        jji = jj(i,jpn)
        if (iin(jji) == 0) cycle
        iin(jpn) = iin(jpn)+iin(jji)
      end do
    end do
    do jdn=jds,jde
      if (nu_ad(jdn) == 0) cycle
      ndi = iin(jdn)*iseg_downwei(9+im)*jpad_upwei(jdn)
      iseg_dim(9+im) = iseg_dim(9+im)+ndi
    end do
  end do
  do im=1,ng_sm
    jp = js(im)
    iseg_sta(17+im) = nci_dim       ! for node_s_ext
    iseg_dim(17+im) = 0
    if (jp == 0) cycle
    iin(1:jpe) = 0
    iin(0) = 0
    iin(jp) = 1
    do jpn=jpe,1,-1
      do i=1,4
        jji = jj(i,jpn)
        if (iin(jji) == 0) cycle
        iin(jpn) = iin(jpn)+iin(jji)
      end do
    end do
    do jdn=jds,jde
      if (nu_ad(jdn) == 0) cycle
      ndi = iin(jdn)*iseg_downwei(17+im)*jpad_upwei(jdn)
      iseg_dim(17+im) = iseg_dim(17+im)+ndi
    end do
  end do
  call mma_deallocate(iin)
  do jp=2,25
    iseg_sta(jp) = iseg_sta(jp-1)+iseg_dim(jp-1)
    !write(nf2,'(3i10)') jp-1,iseg_sta(jp-1),iseg_dim(jp-1)      !to
  end do
  !write(nf2,'(3i10)') 25,iseg_sta(25),iseg_dim(25)          !to de
  nci_dim = iseg_sta(25)+iseg_dim(25)
  iseg_sta(26) = nci_dim
  do jp=1,25
    if (iseg_downwei(jp) == 0) cycle
    iseg_upwei(jp) = iseg_dim(jp)/iseg_downwei(jp)
  end do
  !call get_ivy()
end if

! to the end of dbl,act,ext parts
call dbl_downwalk()
write(u6,*) '  end of drt,nci_dim= ',nci_dim
!write(u6,*) '-----------------------------------------------'
!write(u6,*) '         ci drt-information'
!write(u6,*) '       num.of orbitals:       ',nst
!write(u6,*) '       num.of froz-orbitals:  ',nzst
!write(u6,*) '       num.of active-orbitals:',ndh
!write(u6,*) '       num.of electrons:      ',nel
!write(u6,*) '       multiplicity:          ',mult
!write(u6,*) '       num.of configurations: ',ndime
!write(u6,*) '       symmetry:              ',zm
!write(u6,*) '-----------------------------------------------'

return

end subroutine active_drt

!subroutine rst()
!
!use gugaci_global, only: LuDrt
!use Definitions, only: u6
!
!implicit none
!
!write(u6,*) ' '
!write(u6,*) ' now reading distinct row tableau'
!call readdrt(ludrt)
!!open(21,file='fort.drt',form='unformatted')
!!read(21) id
!!write(u6,*) ' id=',id
!!read(21) ja(1:id),jb(1:id),jm(1:id)
!!read(21) jj(1:4,0:id)
!!read(21) kk(0:id)
!!read(21) no(0:norb_inn+1)
!!read(21) jv,jd(1:8),jt(1:8),js(1:8)
!!close(21)
!
!return
!
!end subroutine rst

!subroutine ref_gfs(nel,ndj,locu,nm)
!
!use gugaci_global, only: lsm_inn, max_ref, norb_dz, norb_inn, nstart_act, spin
!use Symmetry_Info, only: Mul
!use stdalloc, only: mma_allocate, mma_deallocate
!use Definitions, only: iwp, u6
!
!implicit none
!integer(kind=iwp), intent(in) :: nel, nm
!integer(kind=iwp), intent(out) :: ndj, locu(8,max_ref)
!integer(kind=iwp) :: i, l1, l2, l3, l4, l5, l6, l7, l8, ldj, lh, lhe, lhs, lhsm(8), lm, lpsum, m, m1, m2, m3, m4, m5, m6, m7, m8, &
!                     mdj, mys, ne_act, ne_s, nes, npair, nre
!integer(kind=iwp), allocatable :: lscu(:,:)
!
!ne_act = nel-2*norb_dz
!ne_s = nint(spin*2)
!lhs = nstart_act
!lhe = norb_inn
!lhsm(1:8) = 0
!do lh=lhs,lhe
!  lm = lsm_inn(lh)
!  lhsm(lm) = lhsm(lm)+1
!end do
!mdj = 0
!call mma_allocate(lscu,[0,8],[1,max_ref],label='lscu')
!do nes=ne_s,ne_act,2
!  do l1=0,lhsm(1)
!    do l2=0,lhsm(2)
!      do l3=0,lhsm(3)
!        do l4=0,lhsm(4)
!          do l5=0,lhsm(5)
!            do l6=0,lhsm(6)
!              do l7=0,lhsm(7)
!                do l8=0,lhsm(8)
!                  lpsum = l1+l2+l3+l4+l5+l6+l7+l8
!                  if (lpsum /= nes) cycle
!                  mys = 1
!                  if (mod(l1,2) == 1) mys = Mul(mys,1)
!                  if (mod(l2,2) == 1) mys = Mul(mys,2)
!                  if (mod(l3,2) == 1) mys = Mul(mys,3)
!                  if (mod(l4,2) == 1) mys = Mul(mys,4)
!                  if (mod(l5,2) == 1) mys = Mul(mys,5)
!                  if (mod(l6,2) == 1) mys = Mul(mys,6)
!                  if (mod(l7,2) == 1) mys = Mul(mys,7)
!                  if (mod(l8,2) == 1) mys = Mul(mys,8)
!                  if (mys /= nm) cycle
!                  mdj = mdj+1
!                  lscu(0,mdj) = lpsum
!                  lscu(1,mdj) = l1
!                  lscu(2,mdj) = l2
!                  lscu(3,mdj) = l3
!                  lscu(4,mdj) = l4
!                  lscu(5,mdj) = l5
!                  lscu(6,mdj) = l6
!                  lscu(7,mdj) = l7
!                  lscu(8,mdj) = l8
!                end do
!              end do
!            end do
!          end do
!        end do
!      end do
!    end do
!  end do
!end do
!ndj = 0
!do m=1,mdj
!  npair = (ne_act-lscu(0,m))/2
!  do l1=0,lhsm(1)-lscu(1,m)
!    do l2=0,lhsm(2)-lscu(2,m)
!      do l3=0,lhsm(3)-lscu(3,m)
!        do l4=0,lhsm(4)-lscu(4,m)
!          do l5=0,lhsm(5)-lscu(5,m)
!            do l6=0,lhsm(6)-lscu(6,m)
!              do l7=0,lhsm(7)-lscu(7,m)
!                outer: do l8=0,lhsm(8)-lscu(8,m)
!                  lpsum = l1+l2+l3+l4+l5+l6+l7+l8
!                  if (lpsum == npair) then
!                    m1 = l1*2+lscu(1,m)
!                    m2 = l2*2+lscu(2,m)
!                    m3 = l3*2+lscu(3,m)
!                    m4 = l4*2+lscu(4,m)
!                    m5 = l5*2+lscu(5,m)
!                    m6 = l6*2+lscu(6,m)
!                    m7 = l7*2+lscu(7,m)
!                    m8 = l8*2+lscu(8,m)
!                    do ldj=1,ndj
!                      if ((m1 == locu(1,ldj)) .and. (m2 == locu(2,ldj)) .and. (m3 == locu(3,ldj)) .and. (m4 == locu(4,ldj)) .and. &
!                          (m5 == locu(5,ldj)) .and. (m6 == locu(6,ldj)) .and. (m7 == locu(7,ldj)) .and. (m8 == locu(8,ldj))) &
!                        cycle outer
!                    end do
!                    ndj = ndj+1
!                    locu(1,ndj) = m1
!                    locu(2,ndj) = m2
!                    locu(3,ndj) = m3
!                    locu(4,ndj) = m4
!                    locu(5,ndj) = m5
!                    locu(6,ndj) = m6
!                    locu(7,ndj) = m7
!                    locu(8,ndj) = m8
!                  end if
!                end do outer
!              end do
!            end do
!          end do
!        end do
!      end do
!    end do
!  end do
!end do
!call mma_deallocate(lscu)
!
!do nre=1,ndj
!  write(u6,'(5x,i6,8i3)') nre,(locu(i,nre),i=1,8)
!end do
!
!return
!
!end subroutine ref_gfs

!subroutine rcas()
!
!use gugaci_global, only: LuDrt
!use Definitions, only: u6
!
!implicit none
!
!write(u6,*) ' '
!write(u6,*) ' now reading distinct row tableau'
!call readdrt(ludrt)
!
!!write(u6,*) 'bbs debug rcas,kk(27)',kk(27)
!
!!open(21,file='fort.drt',form='unformatted')
!!read(21) id
!!read(21) ja(1:id),jb(1:id),jm(1:id)
!!read(21) jj(1:4,0:id)
!!read(21) kk(0:id)
!!read(21) no(0:norb_inn+1)
!!read(21) jv,jd(1:8),jt(1:8),js(1:8)
!!close(21)
!
!return
!
!end subroutine rcas

!subroutine check_rcas3(jk,ind,inb,ndj,locu)
!
!use gugaci_global, only: ja, jb, max_node
!use stdalloc, only: mma_allocate, mma_deallocate
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: jk, ind(8,max_node), ndj, locu(8,ndj)
!integer(kind=iwp), intent(out) :: inb
!integer(kind=iwp) :: i, iex, lsym(8), m, nsumel
!integer(kind=iwp), allocatable :: iexcit(:)
!
!inb = 0
!nsumel = 0
!do i=1,8
!  lsym(i) = ind(i,jk)
!  nsumel = nsumel+lsym(i)
!end do
!call mma_allocate(iexcit,ndj,label='iexcit')
!do i=1,ndj
!  iexcit(i) = 0
!  do m=1,8
!    iex = lsym(m)-locu(m,i)
!    if (iex > 0) then
!      iexcit(i) = iexcit(i)+iex
!    end if
!  end do
!end do
!inb = iexcit(1)
!do i=2,ndj
!  inb = min(inb,iexcit(i))
!end do
!call mma_deallocate(iexcit)
!inb = inb+ja(jk)*2+jb(jk)
!
!return
!
!end subroutine check_rcas3

subroutine irfrst()
! ifrno(j)=i
! irfno(i)=j no. i ref is no. j cfs in h0

use gugaci_global, only: ifrno, iref_occ, irf, irfno, n_ref, nci_h0, norb_act, norb_all, norb_dz, nwalk
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i, icount, icsfocc, icsfwlk, ii, ij, im, j, ndimh0
integer(kind=iwp), allocatable :: iwalktmp(:)

icsfwlk = 0
ndimh0 = nci_h0 !iw_sta(2,1)
icount = 0
call mma_allocate(iwalktmp,norb_all,label='iwalktmp')
do i=1,n_ref
  outer: do j=1,ndimh0
    call found_a_config(j,One,0)
    do im=1,norb_all
      iwalktmp(im) = nwalk(norb_all-im+1)
    end do

    ij = norb_dz
    do ii=1,norb_act
      ij = ij+1
      icsfwlk = iwalktmp(ij)
      if (icsfwlk == 3) then
        icsfocc = 2
      else if (icsfwlk == 2) then
        icsfocc = 1
      else if (icsfwlk == 1) then
        icsfocc = 1
      else if (icsfwlk == 0) then
        icsfocc = 0
      else
        icsfocc = -1
      end if
      if (icsfocc /= iref_occ(ij,i)) cycle outer
    end do
    icount = icount+1
    irfno(icount) = j
    ifrno(j) = icount
    !write(u6,2000) iwalktmp(norb_dz+1:norb_dz+norb_act)
    !write(u6,*) 'icount',icount,j
  end do outer
end do
call mma_deallocate(iwalktmp)

irf = icount
write(u6,3000) irf

return

!1000 format(1x,'warnning!the selected csf is not in references states')
!2000 format(1x,'the selected csf is :',2x,32(i1))
3000 format(1x,'number of gelfand states in referance space:',1x,i4)
!...end of irfrst

end subroutine irfrst

!subroutine irfrst_bak(iselcsf_occ)
!
!use gugaci_global, only: ifrno, iref_occ, irf, irfno, max_innorb, max_ref, mjn, mroot, n_ref, nci_h0, norb_act, norb_all, norb_dz, &
!                         nwalk
!use stdalloc, only: mma_allocate, mma_deallocate
!use Constants, only: One
!use Definitions, only: iwp, u6
!
!implicit none
!integer(kind=iwp), intent(in) :: iselcsf_occ(max_innorb,max_ref)
!integer(kind=iwp) :: i, icount, icsfocc, icsfwlk, ii, ij, im, io, iocsf, ire, j, ndimh0, nocc
!logical(kind=iwp) :: log_exist
!integer(kind=iwp), allocatable :: iwalktmp(:)
!
!nocc = 0
!do i=1,mroot
!  log_exist = .false.
!  outer1: do ire=1,n_ref
!    ij = norb_dz
!    do io=1,norb_act
!      ij = ij+1
!      if (iselcsf_occ(io,i) == 3) nocc = 2
!      if (iselcsf_occ(io,i) == 2) nocc = 1
!      if (iselcsf_occ(io,i) == 1) nocc = 1
!      if (iselcsf_occ(io,i) == 0) nocc = 0
!      if (nocc /= iref_occ(io+norb_dz,ire)) cycle outer1
!    end do
!    log_exist = .true.
!    if (log_exist) exit
!  end do outer1
!  if (.not. log_exist) then
!    write(u6,1000)
!    write(u6,2000) iselcsf_occ(1:norb_act,i)
!    write(u6,*) ' please select this state as reference state'
!  end if
!end do
!icsfocc = 0
!ndimh0 = nci_h0 !iw_sta(2,1)
!icount = 0
!call mma_allocate(iwalktmp,norb_all,label='iwalktmp')
!do i=1,n_ref
!  outer2: do j=1,ndimh0
!    call found_a_config(j,One,0)
!    do im=1,norb_all
!      iwalktmp(im) = nwalk(norb_all-im+1)
!    end do
!
!    log_exist = .false.
!    ij = norb_dz
!    do ii=1,norb_act
!      ij = ij+1
!      icsfwlk = iwalktmp(ij)
!      if (icsfwlk == 3) icsfocc = 2
!      if (icsfwlk == 2) icsfocc = 1
!      if (icsfwlk == 1) icsfocc = 1
!      if (icsfwlk == 0) icsfocc = 0
!      if (icsfocc /= iref_occ(ij,i)) cycle outer2
!    end do
!    log_exist = .true.
!    icount = icount+1
!    irfno(icount) = j
!    ifrno(j) = icount
!    !write(u6,2000) iwalktmp(norb_dz+1:norb_dz+norb_act)
!    !write(u6,*) 'icount',icount,j
!  end do outer2
!end do
!call mma_deallocate(iwalktmp)
!
!irf = icount
!do i=1,2*mroot
!  iocsf = mjn(i)
!  log_exist = .false.
!  do j=1,icount
!    if (iocsf == irfno(j)) then
!      log_exist = .true.
!      exit
!    end if
!  end do
!  if (.not. log_exist) then
!    irf = irf+1
!    irfno(irf) = iocsf
!    ifrno(iocsf) = irf
!  end if
!end do
!
!write(u6,3000) irf
!
!return
!
!1000 format(1x,'warnning!the selected csf is not in references states')
!2000 format(1x,'the selected csf is :',2x,32(i1))
!3000 format(1x,'number of gelfand states in referance space:',1x,i4)
!!...end of irfrst_bak
!
!end subroutine irfrst_bak

!function min_itexcit(indjk)
!
!use gugaci_global, only: ndjgrop, ndjmod
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp) :: min_itexcit
!integer(kind=iwp), intent(in) :: indjk(4)
!integer(kind=iwp) :: indexcit, ixcit, lref, ngrop, nj
!! integer*4 indjk  =  00 00 00 00 00 00 00 00 00 00  00 00 00 00 00
!! indexcit=  ir1 ir2 ir3 ir4 ir5 ir6 ir7 ir8 ......... ir15
!
!!-----------------------------------------------------------------------
!min_itexcit = 3
!nj = 0
!do ngrop=1,ndjgrop-1         !1-(ndjgrop-1) grop
!  indexcit = indjk(ngrop)
!  do lref=1,15
!    ixcit = ishft(indexcit,-2*(lref-1))
!    ixcit = mod(ixcit,4)
!    !if (ixcit /= 0) ixcit = ixcit-1
!    !if (ixcit == 0) ixcit = 3
!    min_itexcit = min(min_itexcit,ixcit)
!    if (min_itexcit == 0) return
!  end do
!  nj = nj+15
!end do
!indexcit = indjk(ndjgrop)       !last grop
!do lref=1,ndjmod
!  ixcit = ishft(indexcit,-2*(lref-1))
!  ixcit = mod(ixcit,4)
!  !if (ixcit /= 0) ixcit = ixcit-1
!  !if (ixcit == 0) ixcit = 3
!  min_itexcit = min(min_itexcit,ixcit)
!  if (min_itexcit == 0) return
!end do
!!-----------------------------------------------------------------------
!return
!
!end function min_itexcit

!subroutine njexcit(idcc,indjk,locuk0,n_ref)
!
!use gugaci_global, only: ndjgrop, ndjmod
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: idcc, n_ref, locuk0(n_ref)
!integer(kind=iwp), intent(inout) :: indjk(4)
!integer(kind=iwp) :: indexcit, ixcit, lref, ngrop, nj
!
!nj = 0
!do ngrop=1,ndjgrop-1         !1-(ndjgrop-1) grop
!  indexcit = indjk(ngrop)
!  indjk(ngrop) = 0
!  do lref=1,15
!    ixcit = ishft(indexcit,-2*(lref-1))
!    ixcit = mod(ixcit,4)
!    if (idcc-locuk0(nj+lref) == 1) ixcit = ixcit+1
!    if (idcc-locuk0(nj+lref) == 2) ixcit = ixcit+2
!    if (ixcit >= 3) ixcit = 3
!    indjk(ngrop) = ishft(ixcit,2*(lref-1))+indjk(ngrop)
!  end do
!  nj = nj+15
!end do
!indexcit = indjk(ndjgrop)       !last grop
!indjk(ndjgrop) = 0
!do lref=1,ndjmod
!  ixcit = ishft(indexcit,-2*(lref-1))
!  ixcit = mod(ixcit,4)
!  if (idcc-locuk0(nj+lref) == 1) ixcit = ixcit+1
!  if (idcc-locuk0(nj+lref) == 2) ixcit = ixcit+2
!  if (ixcit >= 3) ixcit = 3
!  indjk(ngrop) = ishft(ixcit,2*(lref-1))+indjk(ngrop)
!end do
!
!return
!
!end subroutine njexcit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CASPT2_BTAMP(LuGAMMA,iS,jS,kS,lS,nBasI,nBasJ,nBasK,nBasL,iOffAO,nBasT,nOcc,CMOPT2,WRK1,WRK2,G_toc)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iS, jS, kS, lS, LuGAMMA, nBasI, nBasJ, nBasK, nBasL, iOffAO(*), nBasT, nOcc
real(kind=wp), intent(in) :: CMOPT2(*)
real(kind=wp), intent(_OUT_) :: WRK1(*), WRK2(*), G_toc(*)
integer(kind=iwp) :: iBas, iBas0, iRec, jBas, jBas0, kBas, kBas0, lBas, lBas0, Loc
real(kind=wp), parameter :: SCAL = 0.125_wp

! Transform T_{ij}^{rho sigma} to T_{mu nu}^{rho sigma}
! i- and k-shells correspond to rho and sigma (order?)
! The transformed amplitude is stored as D_{j,l,i,k},
! and it will be sorted in integral_util/pget3.f

! It is possible to reduce operations. The third transformation
! can be postponed until j-shell varies.

do kBas0=1,nBasK
  kBas = iOffAO(kS)+kBas0
  do iBas0=1,nBasI
    iBas = iOffAO(iS)+iBas0
    iRec = iBas+nBasT*(kBas-1)
    !! Read the half-transformed-amplitude
    read(unit=LuGamma,rec=iRec) WRK1(1:nOcc*nOcc)
    !! do the remaining (third and fourth) transformation
    call DGemm_('N','N',nBasJ,nOcc,nOcc,One,CMOPT2(1+iOffAO(jS)),nBasT,WRK1,nOcc,Zero,WRK2,nBasJ)
    Loc = nBasJ*nBasL*(iBas0-1+nBasI*(kBas0-1))
    call DGemm_('N','T',nBasJ,nBasL,nOcc,SCAL,WRK2,nBasJ,CMOPT2(1+iOffAO(lS)),nBasT,Zero,G_toc(1+Loc),nBasJ)
  end do
end do

do lBas0=1,nBasL
  lBas = iOffAO(lS)+lBas0
  do jBas0=1,nBasJ
    jBas = iOffAO(jS)+jBas0
    iRec = jBas+nBasT*(lBas-1)
    !! Read the half-transformed-amplitude
    read(unit=LuGamma,rec=iRec) WRK1(1:nOcc*nOcc)
    !! do the remaining (third and fourth) transformation
    call DGemm_('N','N',nBasI,nOcc,nOcc,One,CMOPT2(1+iOffAO(iS)),nBasT,WRK1,nOcc,Zero,WRK2,nBasI)
    call DGemm_('N','T',nBasI,nBasK,nOcc,SCAL,WRK2,nBasI,CMOPT2(1+iOffAO(kS)),nBasT,Zero,WRK1,nBasI)
    do kBas0=1,nBasK
      kBas = iOffAO(kS)+kBas0
      do iBas0=1,nBasI
        ibas = iOffAO(iS)+iBas0
        Loc = jBas0-1+nBasJ*(lBas0-1+nBasL*(iBas0-1+nBasI*(kBas0-1)))
        G_toc(1+Loc) = G_toc(1+Loc)+WRK1(iBas0+nBasI*(kBas0-1))
      end do
    end do
  end do
end do

do lBas0=1,nBasL
  lBas = iOffAO(lS)+lBas0
  do iBas0=1,nBasI
    iBas = iOffAO(iS)+iBas0
    iRec = iBas+nBasT*(lBas-1)
    !! Read the half-transformed-amplitude
    read(unit=LuGamma,rec=iRec) WRK1(1:nOcc*nOcc)
    !! do the remaining (third and fourth) transformation
    call DGemm_('N','N',nBasJ,nOcc,nOcc,One,CMOPT2(1+iOffAO(jS)),nBasT,WRK1,nOcc,Zero,WRK2,nBasJ)
    call DGemm_('N','T',nBasJ,nBasK,nOcc,SCAL,WRK2,nBasJ,CMOPT2(1+iOffAO(kS)),nBasT,Zero,WRK1,nBasJ)
    do kBas0=1,nBasK
      do jBas0=1,nBasJ
        Loc = jBas0-1+nBasJ*(lBas0-1+nBasL*(iBas0-1+nBasI*(kBas0-1)))
        G_toc(1+Loc) = G_toc(1+Loc)+WRK1(jBas0+nBasJ*(kBas0-1))
      end do
    end do
  end do
end do

do kBas0=1,nBasK
  kBas = iOffAO(kS)+kBas0
  do jBas0=1,nBasJ
    jBas = iOffAO(jS)+jBas0
    if (jBas >= kBas) then
      iRec = jBas+nBasT*(kBas-1)
    else
      iRec = kBas+nBasT*(jBas-1)
    end if
    !! Read the half-transformed-amplitude
    read(unit=LuGamma,rec=iRec) WRK1(1:nOcc*nOcc)
    !! do the remaining (third and fourth) transformation
    if (jbas >= kbas) then
      call DGemm_('N','N',nBasI,nOcc,nOcc,One,CMOPT2(1+iOffAO(iS)),nBasT,WRK1,nOcc,Zero,WRK2,nBasI)
    else
      call DGemm_('N','T',nBasI,nOcc,nOcc,One,CMOPT2(1+iOffAO(iS)),nBasT,WRK1,nOcc,Zero,WRK2,nBasI)
    end if
    call DGemm_('N','T',nBasI,nBasL,nOcc,SCAL,WRK2,nBasI,CMOPT2(1+iOffAO(lS)),nBasT,Zero,WRK1,nBasI)
    do lBas0=1,nBasL
      do iBas0=1,nBasI
        Loc = jBas0-1+nBasJ*(lBas0-1+nBasL*(iBas0-1+nBasI*(kBas0-1)))
        G_toc(1+Loc) = G_toc(1+Loc)+WRK1(iBas0+nBasI*(lBas0-1))
      end do
    end do
  end do
end do

return

end subroutine CASPT2_BTAMP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine EPSBIS(JSY,INDX,C,W,EPB)

use cpf_global, only: ICPF, INCPF, IPRINT, IRC, ISDCI, LSYM, NNS, NVIR
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JSY(*), INDX(*)
real(kind=wp), intent(in) :: C(*), W(*)
real(kind=wp), intent(_OUT_) :: EPB(*)
integer(kind=iwp) :: I, IIN, INUM, IP, IST, NS1, NSIL
integer(kind=iwp), external :: JSUNP
real(kind=wp), external :: DDOT_

EPB(1:IRC(4)) = Zero
if ((ICPF == 1) .or. (ISDCI == 1) .or. (INCPF == 1)) return

! VALENCE

IP = IRC(1)
do I=1,IP
  EPB(I) = C(I)*W(I)
end do

! SINGLES

IP = IRC(2)-IRC(1)
IIN = IRC(1)
do I=1,IP
  !FUE IND = IND+1
  NS1 = JSUNP(JSY,IIN+I)
  NSIL = MUL(NS1,LSYM)
  INUM = NVIR(NSIL)
  IST = INDX(IIN+I)+1
  EPB(IIN+I) = DDOT_(INUM,C(IST),1,W(IST),1)
end do

! DOUBLES

IP = IRC(4)-IRC(2)
IIN = IRC(2)
do I=1,IP
  NS1 = JSUNP(JSY,IIN+I)
  NSIL = MUL(NS1,LSYM)
  INUM = NNS(NSIL)
  IST = INDX(IIN+I)+1
  EPB(IIN+I) = DDOT_(INUM,C(IST),1,W(IST),1)
end do

IP = IRC(4)
if (IPRINT > 5) write(u6,998) (EPB(I),I=1,IP)

return

998 format(6X,'EPB ',5F10.6)

end subroutine EPSBIS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RICD_Helper(Do_nacCD_Basis,nTest,iAngMin_,iAngMax_,
     &                       jAngMin_,jAngMax_,nBS,iAng,jAng,list,
     &                       nBS_Max)
      Implicit Real*8 (a-h,o-z)
      Logical Do_nacCD_Basis
      Integer iAngMin_(0:nBS_Max-1),
     &        iAngMax_(0:nBS_Max-1)
      Parameter (iTabMx=15)
      Integer jAngMin_(0:nBS_Max-1,0:nBS_Max-1),
     &        jAngMax_(0:nBS_Max-1,0:nBS_Max-1)
      Integer list(2,0:((nTest+1)*(nTest+2))/2,0:nTest*2)
      Integer list2(0:nTest**2)
*                                                                      *
************************************************************************
*                                                                      *
      if(.Not.Do_nacCD_Basis) Then
*                                                                      *
************************************************************************
*                                                                      *
         nBS=(nTest+2)/2
         Do iBS=0, nBS-1
            iAngMin_(iBS)=iBS
            iAngMax_(iBS)=nTest-iBS
            Do iAng=0, iAngMax_(iBS)
               jAngMax_(iBS,iAng)=Min(iAng,iAngMin_(iBS))
               If (iAng.eq.iAngMax_(iBS))
     &             jAngMax_(iBS,iAng)=iAngMax_(iBS)
               If (iAng.lt.iAngMin_(iBS)) jAngMax_(iBS,iAng)=0
               jAngMin_(iBS,iAng)=iAngMin_(iBS)
               If (iAng.le.iAngMin_(iBS)) jAngMin_(iBS,iAng)=0
               Do jAng=jAngMin_(iBS,iAng), jAngMax_(iBS,iAng)
                  list(1,0,iAng)=iAng
                  list(2,0,iAng)=jAng
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
            nBS=1
            iPair=0
            Do iBS=0, nBS-1
            iAngMax_(iBS)=nTest*2
            Do iAng=iAngMin_(iBS), iAngMax_(iBS)
               jAngMax_(iBS,iAng)=0
               jAngMin_(iBS,iAng)=0
               Do jAng=jAngMin_(iBS,iAng), jAngMax_(iBS,iAng)
                  list2(iAng)=0
                  Do k=0, nTest
                     Do l=0, k
                        Do m=iAng,0,-2
                           n=k-l
                           If ((n.eq.m).and.((k+l).ge.iAng)) Then
                              iPair=list2(iAng)
                              list(1,iPair,iAng)=l
                              list(2,iPair,iAng)=k
                              list2(iAng)=list2(iAng)+1
                           End If
                        End Do ! m
                     End Do    ! l
                  End Do       ! k
              End Do           ! jAng
            End Do             ! iAng
         End Do                ! iBS
      End if
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
************************************************************************
      Subroutine sssp(EFInt,Zeta,nZeta,P,lP,rKappAB,A,B,
     &                       Eta, nEta,Q,lQ,rKappCD,C,D,
     &                CoorAC,TMax,
     &                iPntr,nPntr,x0,nMax,W6,W5,W4,W3,W2,W1,W0,
     &                                    R6,R5,R4,R3,R2,R1,R0,
     &                ddx,HerW,HerR2,IsChi,ChiI2)
************************************************************************
*                                                                      *
* Object: to compute the primitive integrals of type (ss|sp).          *
*                                                                      *
*  Author:    Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN. 1994                                    *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 EFInt(nZeta,nEta,3), Zeta(nZeta), Eta(nEta),
     &       CoorAC(3,2),
     &       P(lP,3), Q(lQ,3), A(3), B(3), C(3), D(3),
     &       rKappAB(nZeta), rKappCD(nEta),
     &       x0(nMax), W6(nMax), W5(nMax),
     &       W4(nMax), W3(nMax), W2(nMax), W1(nMax), W0(nMax),
     &       R6(nMax), R5(nMax),
     &       R4(nMax), R3(nMax), R2(nMax), R1(nMax), R0(nMax)
      Integer iPntr(nPntr)
      Logical ABeqCD, EQ
*
*
      xdInv=One/ddx
      dddx = ddx/10d0 + ddx
*
      ABeqCD = EQ(A,B) .and. EQ(A,C) .and. EQ(A,D)
      If (ABeqCD) Go To 300
      If (EQ(C,D)) Go To 200
*
*-----ABCD case
*
      Do 10 iEta = 1, nEta
         Do 20 iZeta = 1, nZeta
            ZEInv = One/(Eta(iEta)+Zeta(iZeta)
     >              +(Eta(iEta)*Zeta(iZeta)*ChiI2)*Dble(IsChi))
            ZE  = Zeta(iZeta)*Eta(iEta)
            rho = ZE*ZEInv
            PQx = P(iZeta,1)-Q(iEta,1)
            PQy = P(iZeta,2)-Q(iEta,2)
            PQz = P(iZeta,3)-Q(iEta,3)
            PQ2 = PQx**2 + PQy**2 + PQz**2
            T = rho*PQ2
            If (T.lt.TMax) Then
               n = iPntr(Int((T+dddx)*xdInv))
               z = T - x0(n)
               w =(((((W6(n)*z+W5(n))*z+W4(n))*z+W3(n))*z+W2(n))
     &           *z+W1(n))*z+w0(n)
               r =(((((R6(n)*z+R5(n))*z+R4(n))*z+R3(n))*z+R2(n))
     &           *z+R1(n))*z+R0(n)
               Zu2 = r * (Zeta(iZeta)*ZEInv)
               PreFct = rKappCD(iEta) * rKappAB(iZeta) * Sqrt(ZEInv) * w
            Else
               Zu2 = HerR2 / (Eta(iEta)*PQ2)
               PreFct = rKappCD(iEta) * rKappAB(iZeta)
     &                * HerW / Sqrt(ZE*PQ2)
            End If
            QCPQx = Q(iEta,1) - CoorAC(1,2) + Zu2 * PQx
            QCPQy = Q(iEta,2) - CoorAC(2,2) + Zu2 * PQy
            QCPQz = Q(iEta,3) - CoorAC(3,2) + Zu2 * PQz
            EFInt(iZeta,iEta,1) = PreFct * QCPQx
            EFInt(iZeta,iEta,2) = PreFct * QCPQy
            EFInt(iZeta,iEta,3) = PreFct * QCPQz
 20      Continue
 10   Continue
      Go To 99
*
*-----ABCC case
*
 200  Continue
      Do 11 iEta = 1, nEta
         Do 21 iZeta = 1, nZeta
            ZEInv = One/(Eta(iEta)+Zeta(iZeta)
     >              +(Eta(iEta)*Zeta(iZeta)*ChiI2)*Dble(IsChi))
            ZE  = Zeta(iZeta)*Eta(iEta)
            rho = ZE*ZEInv
            PQx =  (P(iZeta,1)-CoorAC(1,2))
            PQy =  (P(iZeta,2)-CoorAC(2,2))
            PQz =  (P(iZeta,3)-CoorAC(3,2))
            PQ2 = PQx**2 + PQy**2 + PQz**2
            T = rho*PQ2
            If (T.lt.TMax) Then
               n = iPntr(Int((T+dddx)*xdInv))
               z = T - x0(n)
               w =(((((W6(n)*z+W5(n))*z+W4(n))*z+W3(n))*z+W2(n))
     &           *z+W1(n))*z+w0(n)
               r =(((((R6(n)*z+R5(n))*z+R4(n))*z+R3(n))*z+R2(n))
     &           *z+R1(n))*z+R0(n)
               Zu2 = r * (Zeta(iZeta)*ZEInv)
               PreFct = rKappCD(iEta) * rKappAB(iZeta) * Sqrt(ZEInv) * w
            Else
               Zu2 = HerR2 / (Eta(iEta)*PQ2)
               PreFct = rKappCD(iEta) * rKappAB(iZeta)
     &                * HerW / Sqrt(ZE*PQ2)
            End If
            EFInt(iZeta,iEta,1) = PreFct * Zu2 * PQx
            EFInt(iZeta,iEta,2) = PreFct * Zu2 * PQy
            EFInt(iZeta,iEta,3) = PreFct * Zu2 * PQz
 21      Continue
 11   Continue
      Go To 99
*
*-----CCCC case
*
 300  Continue
      Do iEta = 1, nEta
         Do iZeta = 1, nZeta
            EFInt(iZeta,iEta,1) = Zero
            EFInt(iZeta,iEta,2) = Zero
            EFInt(iZeta,iEta,3) = Zero
         End Do
      End Do
*
 99   Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_CC_drv(rc,CMO)
!***********************************************************************
!
! a,b,g,d:  AO-index
! p,q,r,s:  MO-indices belonging to (probably frozen excluded ?)
!
!***********************************************************************

use Cholesky, only: InfVec, nBas, nDimRS, nSym, NumCho, timings
use Symmetry_Info, only: Mul
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, SBA_Type
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: rc
type(DSBA_Type), intent(in) :: CMO
integer(kind=iwp) :: i, iBatch, idisk, iE, iLoc, irc, IREDC, iS, iSwap, iSymb, iSymp, IVEC2, iVrs, JNUM, JRED, JRED1, JRED2, jSym, &
                     JVC, JVEC, k, l, LREAD, LunChVF, LWORK, mTTvec, mTvec, MUSED, mvec, NAp, NAq, nBatch, nPorb(8), nRS, NUMV, &
                     nVec, nVrs
real(kind=wp) :: TCM1, TCM2, TCM3, TCM4, TCR1, TCR2, TCR3, TCR4, tmotr1(2), tmotr2(2), TOTCPU, TOTCPU1, TOTCPU2, TOTWALL, &
                 TOTWALL1, TOTWALL2, tread(2), TWM1, TWM2, TWM3, TWM4, TWR1, TWR2, TWR3, TWR4
logical(kind=iwp) :: DoRead
character(len=50) :: CFmt
type(SBA_Type) :: Laq(1)
real(kind=wp), allocatable :: Lrs(:,:)
real(kind=wp), allocatable, target :: Lpq(:)
real(kind=wp), pointer :: pLpq(:,:,:)
character(len=*), parameter :: SECNAM = 'CHO_CC_drv'
integer(kind=iwp), external :: isFreeUnit

LunChVF = 80
LunChVF = isfreeunit(LunChVF)
call DaName_mf_wa(LunChVF,'CD1tmp')
idisk = 1
DoRead = .false.
IREDC = -1  ! unknown reduced set in core

iSwap = 0  ! Lpb,J are returned by cho_x_getVtra

call CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = zero   !time read/write vectors
tmotr1(:) = zero  !time 1st MO half-transf.
tmotr2(:) = zero  !time 2nd MO half-transf.

! --- Define MOs used in CC
! -----------------------------------
do i=1,nSym
  nPorb(i) = size(CMO%SB(i)%A2,1)
end do

! ======================================================================

! --- Various offsets & pointers
! ------------------------------

iLoc = 3 ! use scratch location in reduced index arrays

! *************** BIG LOOP OVER VECTORS SYMMETRY ***********************

do jSym=1,nSym

  if (NumCho(jSym) < 1) cycle

  ! --------------------------------------------------------------------

  ! **************     MEMORY MANAGEMENT SECTION    ********************
  !---------------------------------------------------------------------
  ! --- compute memory needed to store at least 1 vector of JSYM
  ! --- and do all the subsequent calculations
  ! --------------------------------------------------------------------
  mTvec = 0  ! mem for storing half-transformed vec Laq,J
  mTTvec = 0  ! mem for storing transformed vec Lpq,J

  do l=1,nSym
    k = Mul(l,JSYM)
    mTvec = mTvec+nPorb(l)*nBas(k)
    mTTvec = max(mTTvec,nPorb(l)*nPorb(k))
  end do

  mvec = mTvec+mTTvec

  ! --------------------------------------------------------------------
  ! --------------------------------------------------------------------

  JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

  do JRED=JRED1,JRED2

    call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

    if (nVrs == 0) cycle  ! no vectors in that (jred,jsym)

    if (nVrs < 0) then
      write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
      call abend()
    end if

    call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
    if (irc /= 0) then
      write(u6,*) SECNAM//'cho_X_setred non-zero return code. rc= ',irc
      call abend()
    end if

    IREDC = JRED

    nRS = nDimRS(JSYM,JRED)

    call mma_maxDBLE(LWORK)

    nVec = min(LWORK/(nRS+mvec),nVrs)

    if (nVec < 1) then
      write(u6,*) SECNAM//': Insufficient memory for batch'
      write(u6,*) 'LWORK= ',LWORK
      write(u6,*) 'min. mem. need= ',nRS+mTvec
      write(u6,*) 'reading ',nRS,' and transforming to ',mvec
      write(u6,*) 'of jsym= ',jsym,' and JRED= ',JRED
      rc = 33
      call Abend()
      nBatch = -9999  ! dummy assignment
    end if

    LREAD = nRS*nVec

    call mma_allocate(Lrs,nRS,nVec,Label='Lrs')
    call mma_allocate(Lpq,mTTVec*nVec,Label='Lpq')

    ! --- BATCH over the vectors ----------------------------

    nBatch = (nVrs-1)/nVec+1

    do iBatch=1,nBatch

      if (iBatch == nBatch) then
        JNUM = nVrs-nVec*(nBatch-1)
      else
        JNUM = nVec
      end if
      call Allocate_DT(Laq(1),nPorb,nBas,JNUM,jSym,nSym,iSwap)

      JVEC = nVec*(iBatch-1)+iVrs
      IVEC2 = JVEC-1+JNUM

      call CWTIME(TCR1,TWR1)

      call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

      if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
        rc = 77
        return
      end if

      call CWTIME(TCR2,TWR2)
      tread(1) = tread(1)+(TCR2-TCR1)
      tread(2) = tread(2)+(TWR2-TWR1)

      ! ----------------------------------------------------------------
      ! --- First half MO transformation  Lpb,J = sum_a  C(p,a) * Lab,J
      ! ----------------------------------------------------------------

      call CWTIME(TCM1,TWM1)

      call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,1,1,[CMO],Laq,DoRead)

      if (irc /= 0) then
        rc = irc
        return
      end if

      call CWTIME(TCM2,TWM2)
      tmotr1(1) = tmotr1(1)+(TCM2-TCM1)
      tmotr1(2) = tmotr1(2)+(TWM2-TWM1)

      ! ----------------------------------------------------------------
      ! --- 2nd half of MO transformation  Lpq,J = sum_b  Lpb,J * C(q,b)
      ! ----------------------------------------------------------------
      do iSymb=1,nSym

        iSymp = Mul(JSYM,iSymb)
        NAp = nPorb(iSymp)
        NAq = nPorb(iSymb) ! iSymb=iSymq
        iS = 1
        iE = NAp*NAq*JNUM

        pLpq(1:NAp,1:NAq,1:JNUM) => Lpq(iS:iE)

        call CWTIME(TCM3,TWM3)

        if (NAp*NAq /= 0) then

          do JVC=1,JNUM

            call DGEMM_('N','T',NAp,NAq,nBas(iSymb),One,Laq(1)%SB(iSymb)%A3(:,:,JVC),NAp,CMO%SB(iSymb)%A2,NAq,Zero,pLpq(:,:,JVC), &
                        NAp)

          end do

        end if

        call CWTIME(TCM4,TWM4)
        tmotr2(1) = tmotr2(1)+(TCM4-TCM3)
        tmotr2(2) = tmotr2(2)+(TWM4-TWM3)

        ! if u need to compute fock matrix elements this should be done probably here
        !     I can help you with that

        call CWTIME(TCR3,TWR3)
        ! --- WRITE transformed vectors to disk (each Jsym on a separate file!)

        call ddafile(LunChVF,1,Lpq,NAp*NAq*JNUM,idisk)

        ! --- remember that this is inside a batch over J, the vector index

        call CWTIME(TCR4,TWR4)
        tread(1) = tread(1)+(TCR4-TCR3)
        tread(2) = tread(2)+(TWR4-TWR3)

        nullify(pLpq)

      end do

      ! --------------------------------------------------------------------
      ! --------------------------------------------------------------------
      call Deallocate_DT(Laq(1))

    end do  ! end batch loop

    ! --- free memory
    call mma_deallocate(Lpq)
    call mma_deallocate(Lrs)

  end do   ! loop over red sets

end do   !loop over JSYM
call daclos(LunChVF)

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

!---- Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky-CC timing from '//SECNAM
  write(u6,CFmt) '----------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'MO transf. Cholesky vectors     CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ/WRITE VECTORS                        ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') '1st half-transf.                          ',tmotr1(1),tmotr1(2)
  write(u6,'(2x,A26,2f10.2)') '2nd half-transf.                          ',tmotr2(1),tmotr2(2)
  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

rc = 0

return

end subroutine CHO_CC_drv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  LDF_X_Init
*
*> @brief
*>   Initialize LDF (Local Density Fitting) environments
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Initialization of LDF environment. If \p Ini_Sew,
*> Seward is initialized as part of the LDF setup (if not, Seward
*> must be initialized before calling this routine). \p nDiff is only
*> used if Seward is to be initialized.
*>
*> \p BufFrac specifies the fraction of available memory (after all
*> other LDF data has been allocated) that can at most be used as
*> buffer for fitting coefficients. This buffer serves to minimize
*> the amount of I/O done in iterative procedures such as SCF.
*> A non-zero return code means that the initialization failed:
*>
*> Return codes:
*>
*> - \p irc = ``-2``: not LDF (according to Runfile)
*> - \p irc = ``-1``: illegal \p nDiff input parameter
*> - \p irc =  ``0``: initialization success
*> - \p irc =  ``1``: error in setup routine
*>
*> @note
*> Seward must have generated the LDF fitting coefficients.
*>
*> @param[in]  Ini_Sew Do initialization of Seward environment
*> @param[in]  nDiff   Initialize Seward to compute derivatives of order \p nDiff
*> @param[in]  BufFrac Memory fraction used for fitting coefficient buffer}
*> @param[out] irc     Return code
*>
*> @see ::LDF_X_Final
************************************************************************
      Subroutine LDF_X_Init(Ini_Sew,nDiff,BufFrac,irc)
      Implicit None
      Logical Ini_Sew
      Integer nDiff
      Real*8  BufFrac
      Integer irc
#include "localdf.fh"
#include "localdf_print.fh"

      Logical  LDF_X_IsSet, LDF_With2CF
      External LDF_X_IsSet, LDF_With2CF

      Integer  iPrintLevel
      External iPrintLevel

      Character*10 SecNam
      Parameter (SecNam='LDF_X_Init')

      Logical Verbose
      Parameter (Verbose=.False.)

      Logical isLocalDF
      Logical FirstCall
      Logical DoPairs
      Logical DoERI

      Integer LDF_Unset
      Integer iCLDF

      Save FirstCall
      Data FirstCall /.True./

      ! Init return code
      irc=0

      ! Define LDF_Unset
      LDF_Unset=LDF_Set-1

      ! Check that this is Local DF
      Call DecideOnLocalDF(isLocalDF)
      If (.not.isLocalDF) Then
         irc=-2
         Call WarningMessage(1,
     &                     'WARNING: '//SecNam//
     &                     ' called but this is not a Local DF run ?!?')
         Call LDF_SetStatusOnRunFile(LDF_Unset)
         Return
      End If

      ! Check if already initialized
      If (FirstCall) Then ! it cannot be already done
         FirstCall=.False.
      Else ! might be already done
         If (LDF_X_IsSet()) Then ! it is already done
            irc=0
            Return
         End If
      End If

      ! Define all variables in common blocks (dummy variables)
      Call LDF_SetInc()

      ! Set run mode to "external"
      LDF_Run_Mode=LDF_RUN_EXTERNAL

      ! Set LuPri in Cholesky (enables use of printing routines in
      ! Cholesky utility)
      Call LDF_Cho_SetLuPri(6)

      ! Initialize Seward if requested
      If (Ini_Sew) Then
         If (nDiff.lt.0) Then
            irc=-1
            Call WarningMessage(1,'WARNING: '//SecNam//': nDiff<0')
            Call LDF_SetStatusOnRunFile(LDF_Unset)
            Return
         Else
            DoERI=.True.
            Call IniSew(DoERI,nDiff)
         End If
      End If

      ! Get target accuracy from Runfile and set thresholds
      Call LDF_GetThrs()

      ! Get constraint type from Runfile
      Call Get_iScalar('LDF Constraint',iCLDF)
      Call LDF_AddConstraint(iCLDF) ! this also checks the value

      ! Initialize LDF, except pair information
      DoPairs=.False.
      Call LDF_Init(DoPairs,Verbose,irc)
      If (irc.ne.0) Then
         irc=1
         Call WarningMessage(1,
     &                       'WARNING: '//SecNam//': Error in LDF_Init')
         Call LDF_SetStatusOnRunFile(LDF_Unset)
         Return
      End If

      ! Read pair info from disk
      Call LDF_ReadAtomPairInfo(irc)
      If (irc.ne.0) Then
         irc=1
         Call WarningMessage(1,
     &           'WARNING: '//SecNam//': Error in LDF_ReadAtomPairInfo')
         Call LDF_SetStatusOnRunFile(LDF_Unset)
         Return
      End If

      ! Set flag LDF2 (.True. if two-center functions present)
      LDF2=LDF_With2CF()

      ! Initialize coefficient I/O:
      ! - open coefficient file
      ! - allocate and initialize coefficient buffer
      Call LDF_CIO_Init(BufFrac,irc)
      If (irc.ne.0) Then
         If (irc.eq.-1) Then
            Call WarningMessage(1,
     &             'WARNING: '//SecNam//': Coefficient file not found!')
            irc=0
         Else
            Call WarningMessage(1,
     &                   'WARNING: '//SecNam//': Error in LDF_CIO_Init')
            Call LDF_SetStatusOnRunFile(LDF_Unset)
         End If
      End If

      ! Set up info needed for constrained LDF
      ! TODO/FIXME: only really needed for debug options
      Call LDF_SetMltplCenters(max(LDF_Constraint,0))

      ! Get print level
      iPrint=iPrintLevel(-1)

      ! Set status on runfile
      Call LDF_SetStatusOnRunFile(LDF_Set)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine InpCtl_MCLR(iPL)
!***********************************************************************
!                                                                      *
!     Read all relevant input data and display them                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Str_Info, only: DTOC
use ipPage, only: ipget, ipin, ipout, ipopen, W
use gugx, only: CIS, EXS, SGS
use MCLR_Data, only: ipCI, ISTATE, LuPT2, nGP, SA
use MCLR_procedures, only: RdJobIph, RdJobIph_td
use input_mclr, only: iMCPD, iMethod, iRoot, iSpin, nActEl, nConf, nCSF, nDisp, nElec3, nHole1, nRoots, nRS1, nRS2, nRS3, nSym, &
                      Page, PT2, State_Sym, TimeDep
use dmrginfo, only: DoDMRG, DoMCLR, nDets_RGLR
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPL
integer(kind=iwp) :: i, ii, ipCII, iSSM
character(len=8) :: Method
integer(kind=iwp), allocatable :: index_SD(:) ! not final version
real(kind=wp), allocatable :: CITmp(:), CIVec(:,:), vector_cidmrg(:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
! Read in interesting info from RUNFILE and ONEINT
call Rd1Int_MCLR()
call RdAB()   ! Read in orbitals, perturbation type, etc.
!                                                                      *
!***********************************************************************
!                                                                      *
call Rd2Int(iPL) ! Read in 2el header
!                                                                      *
!***********************************************************************
!                                                                      *
call RdInp_MCLR()  ! Read in input
!                                                                      *
!***********************************************************************
!                                                                      *
! Default activate ippage utility

call ipopen(.true.)

PT2 = .false.
call Get_cArray('Relax Method',Method,8)
if (Method == 'CASPT2') then
  PT2 = .true.
  ! Read the states requested by CASPT2
  ! This means that the root(s) specified in &MCLR is usually
  ! ignored for CASPT2 gradient/NAC.
  call check_caspt2(1)
end if

!write(u6,*) 'iMethod:',iMethod,2
if (iMethod == 2) then
  if (TimeDep) then
    call RdJobIph_td(CIVec)
  else
    call RdJobIph(CIVec)
  end if

  !write(u6,*) 'Setup of Determinant tables'
  call DetCtl()   ! set up determinant tables
  ! Read in tables from disk
  call InCsfSD(State_sym,State_sym)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !write(u6,*) 'Transformation of CI vector to symmetric group from GUGA pepresentation'

  ! scratch  ! yma testing
  !if (doDMRG .and. doMCLR) then
  !  call xflush(117)
  !  close(117)
  !end if

  do i=1,nroots
    ! yma
    ! No need to copy,since there are no CI-vectors
    if (doDMRG .and. doMCLR) then
      call mma_allocate(CITmp,ndets_RGLR,Label='CITmp')
    else
      call mma_allocate(CITmp,nconf,Label='CITmp')
      CITmp(:) = CIVec(:,i)
    end if

    ! If doDMRG
    if (.not. (doDMRG .and. doMCLR)) then ! yma
      ! transform to sym. group
      call GugaNew(nSym,iSpin,nActEl,nHole1,nElec3,nRs1,nRs2,nRs3,SGS,CIS,EXS,CITmp,1,State_Sym,State_Sym)
      NCSF(1:nSym) = CIS%NCSF(1:nSym)
      NCONF = CIS%NCSF(State_Sym)
      call mkGuga_Free(SGS,CIS,EXS)

    end if

    ! Here should be the position for introducing the CI(SR) coefficients
    !iSSM = 1     ! yma
    !write(u6,*) 'Set ISSM == 1 ',ISSM

    if (doDMRG) then !yma
      call mma_allocate(index_SD,ndets_RGLR,label='index_SD')
      call mma_allocate(vector_cidmrg,ndets_RGLR,label='vector_cidmrg')
      call ci_reconstruct(i,ndets_RGLR,vector_cidmrg,index_SD)
      do ii=1,ndets_RGLR
        if (abs(vector_cidmrg(ii)) < Zero) vector_cidmrg(ii) = Zero
      end do
      call CSDTVC_dmrg(CITmp,vector_cidmrg,DTOC,index_SD,ISSM,1)
      call mma_deallocate(index_SD)
      call mma_deallocate(vector_cidmrg)
    end if

    CIVec(:,i) = CITmp(:)
    call mma_deallocate(CITmp)
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call ipopen(page)

  ! If we are computing Lagrangian multipliers we pick up all CI
  ! vectors. For Hessian calculations we pick up just one vector.

  !write(u6,*) 'iState,SA,nroots=',iState,SA,nroots
  if (SA .or. iMCPD .or. PT2) then
    ipcii = ipget(nconf*nroots)
    call ipin(ipcii)
    W(ipcii)%A(1:nconf*nroots) = pack(CIVec(:,:),.true.)
    nDisp = 1
  else
    ipcii = ipget(nconf)
    call ipin(ipcii)
    W(ipcii)%A(1:nConf) = CIVec(:,iState)
    if (iRoot(iState) /= 1) then
      write(u6,*) 'McKinley does not support computation of harmonic frequencies of excited states'
      call Abend()
    end if
  end if
  !call ipin(ipcii)
  !call RecPrt('CI vector',' ',W(ipcii)%A,1,nConf)
  call mma_deallocate(CIVec)

  ! At this point we change to ipci being the index of the CI
  ! vector in the ipage utility.

  ipci = ipcii
  call ipout(ipci)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (ngp) call rdciv()
  if (PT2) then
    LuPT2 = isFreeUnit(LuPT2)
    call Molcas_Open(LuPT2,'PT2_Lag')
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call InpOne()         ! read in oneham
call PrInp_MCLR(iPL)  ! Print all info
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine InpCtl_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Giovanni Ghigo                              *
************************************************************************
      Subroutine ChoMP2_TwoEl(iBatch,nBatch,numV, LUINTM,iAddrIAD2M,
     &                                   iSymI,iSymJ,iSymA,iSymB, iSymL)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden                                    *
* Written:  October-November 2004                                      *
* Modified for Cholesky-MP2 May 2005                                   *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"

      nSymP=(nSym**2+nSym)/2
      Call LenInt(iSymI,iSymJ,iSymA,iSymB,nN_IJ,nN_AB,nN_Ex1,nN_Ex2)

* *** START GENERATION of EXCHANGE-1 INTEGRALS  **********************
      IF (nN_IJ*nN_Ex1.GT.0) THEN
        iIJAB = ( (iSymI**2-iSymI)/2 + iSymJ-1 ) * nSymP +
     &                 (iSymA**2-iSymA)/2 + iSymB
        SubBlocks(3,3)=.True.
        If (iBatch.EQ.1) then
          IAD2M(2,iIJAB)=iAddrIAD2M
        else
          iAddrIAD2M=IAD2M(2,iIJAB)
        EndIf
*  ---  Start Loop on i, j
        iAddrIAD2Mij=iAddrIAD2M
        Do iI=1,nOsh(iSymI)
          If(iSymI.EQ.iSymJ) then
            iEndJ=iI
          else
            iEndJ=nOsh(iSymJ)
          EndIf
          Do iJ=1,iEndJ
            Call GetMem('Ex1','Allo','Real',iAddEx1,nN_Ex1)
            If (iBatch.GT.1) then
              Call dDaFile(LUINTM,2,Work(iAddEx1),nN_Ex1,
     &                                    iAddrIAD2Mij)   ! Reload Int
              iAddrIAD2Mij=iAddrIAD2Mij-nN_Ex1
            else
              call dcopy_(nN_Ex1,[0.0d0],0,Work(iAddEx1),1)
            EndIf
            Call ChoMP2_GenE(iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV,
     &                                            iAddEx1,nN_Ex1 )
            Call dDaFile(LUINTM,1,Work(iAddEx1),nN_Ex1,iAddrIAD2Mij)
            Call GetMem('Ex1','Free','Real',iAddEx1,nN_Ex1)
          EndDo
        EndDo
*  ---  End Loop on i, j
        iAddrIAD2M=iAddrIAD2Mij
      ENDIF
* *** END GENERATION of EXCHANGE-1 INTEGRALS  ************************


* *** START GENERATION of EXCHANGE-2 INTEGRALS  **********************
      IF (nN_IJ*nN_Ex2.GT.0) THEN
        iIJAB = ( (iSymI**2-iSymI)/2 + iSymJ-1 ) * nSymP +
     &                 (iSymB**2-iSymB)/2 + iSymA
        SubBlocks(3,3)=.True.
        If (iBatch.EQ.1) then
          IAD2M(3,iIJAB)=iAddrIAD2M
        else
          iAddrIAD2M=IAD2M(3,iIJAB)
        EndIf
*  ---  Start Loop on i, j
        iAddrIAD2Mij=iAddrIAD2M
        Do iI=1,nOsh(iSymI)
          If(iSymI.EQ.iSymJ) then
            iEndJ=iI
          else
            iEndJ=nOsh(iSymJ)
          EndIf
          Do iJ=1,iEndJ
            nA=nSsh(iSymA)
            nB=nSsh(iSymB)
            Call GetMem('Ex2','Allo','Real',iAddEx2,nN_Ex2)
            Call GetMem('Ex2t','Allo','Real',iAddEx2t,nN_Ex2)
            If (iBatch.GT.1) then
              Call dDaFile(LUINTM,2,Work(iAddEx2),nN_Ex2,
     &                                    iAddrIAD2Mij)   ! Reload Int
              iAddrIAD2Mij=iAddrIAD2Mij-nN_Ex2
              Call Trnsps(nA,nB,Work(iAddEx2),Work(iAddEx2t))
            else
              call dcopy_(nN_Ex2,[0.0d0],0,Work(iAddEx2t),1)
            EndIf
            Call ChoMP2_GenE(iSymI,iSymJ,iSymA,iSymB, iI,iJ, numV,
     &                                           iAddEx2t,nN_Ex2 )
            Call Trnsps(nB,nA,Work(iAddEx2t),Work(iAddEx2))
            Call dDaFile(LUINTM,1,Work(iAddEx2),nN_Ex2,iAddrIAD2Mij)
            Call GetMem('Ex2t','Free','Real',iAddEx2t,nN_Ex2)
            Call GetMem('Ex2','Free','Real',iAddEx2,nN_Ex2)
          EndDo
        EndDo
*  ---  End Loop on i, j
        iAddrIAD2M=iAddrIAD2Mij
      ENDIF
* *** END GENERATION of EXCHANGE-2 INTEGRALS  ************************

      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nBatch)
         Call Unused_integer(iSymL)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE LUCIA2MOLCAS(KDFTP_LUCIA, KCFTP_LUCIA, KDTOC_LUCIA,
     &     KICONF_OCC_LUCIA, KSDREO_I,
     &     NDET_LUCIA, NCSASM_LUCIA, NDTASM_LUCIA,
     &     NCNASM_LUCIA, MXPCSM, MXPORB, NCONF_PER_OPEN,
     &     NPDTCNF, NPCSCNF, MULTS_LUCIA, NSSOA, NSSOB, KICTS_POINTER,
     &     nCSF_HEXS_LUCIA)
*
C     Transfer arguments to the common blocks used by MOLCAS.
*
      IMPLICIT REAL*8 (A-H, O-Z)
#include "rasdim.fh"
#include "csfbas.fh"
#include "ciinfo.fh"
#include "spinfo.fh"
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
#include "splitcas.fh"
#include "strnum.fh"
#include "detbas.fh"
#include "lucia_ini.fh"
#include "WrkSpc.fh"
      DIMENSION NCSASM_LUCIA(MXPCSM), KICONF_OCC_LUCIA(*)
      DIMENSION KSDREO_I(*)
      DIMENSION NDTASM_LUCIA(MXPCSM), NCNASM_LUCIA(MXPCSM)
      DIMENSION NCONF_PER_OPEN(MXPORB+1,MXPCSM)
      DIMENSION NPDTCNF(MXPORB+1), NPCSCNF(MXPORB+1)
      DIMENSION NSSOA(*), NSSOB(*)
*
      DO I = 1, MXCISM
         NDTASM(I) = NDTASM_LUCIA(I)
         NCSASM(I) = NCSASM_LUCIA(I)
         NCNASM(I) = NCNASM_LUCIA(I)
      ENDDO
      If (NSEL .GT. NCSASM(LSYM)) NSEL=NCSASM(LSYM)
* For small calculations - Lasse/MGD
      nCSF_HEXS=nCSF_HEXS_LUCIA
      IF(N_ELIMINATED_GAS_MOLCAS.gt.0.AND.NSEL.GT.nCSF_HEXS) THEN
        NSEL =nCSF_HEXS
      END IF
*

      If (iDimBlockA .GT. NCSASM(LSYM)) then
          write(6,*) ''
          Write(6,*)'******************** WARNING *********************'
          Write(6,*) ' AA-Block dimension selected is bigger than the '
          write(6,*) ' number  of CSFs reachable  within the selected '
          write(6,*) ' Active Space. The code automatically  reset it '
          write(6,*) ' to the number  of  CSFs. You  are  allowed  to '
          write(6,*) ' decrease  this  number  in  your input and run '
          write(6,*) ' again the calculation.'
          Write(6,'(1X,A,I5)')' AA-Block dimension selected:',iDimBlockA
          iDimBlockA=NCSASM(LSYM)
          Write(6,'(1X,A,I5)')' AA-Block dimension reset:',iDimBlockA
          Write(6,*)'**************************************************'
          write(6,*) ''
      end if

*
C
C...  SET INITIAL VALUES FOR LOOP COUNTERS AND ARRAY SIZES
C
C     TOTAL NO. ORBITALS
      MS2=iSpin-1
      NORB1 = 0
      NORB2 = 0
      NORB3 = 0
      DO 10 ISYM = 1, NSYM
         NORB1 = NORB1 + NRS1(ISYM)
         NORB2 = NORB2 + NRS2(ISYM)
         NORB3 = NORB3 + NRS3(ISYM)
10    CONTINUE
C     FIRST AND LAST ORBITAL OF RAS1, RAS2 AND RAS3 SPACE
      IORB1F = 1
      IORB1L = IORB1F + NORB1 - 1
      IORB2F = IORB1L + 1
      IORB2L = IORB2F + NORB2 - 1
      IORB3F = IORB2L + 1
      IORB3L = IORB3F + NORB3 - 1
C     MIN. AND MAX. NO. OF EL IN RAS1,RAS2 AND RAS3
      NEL1MX = 2*NORB1
      NEL1MN = NEL1MX-NHOLE1
      NEL2MX = NACTEL-2*NORB1+NHOLE1
      NEL2MN = NACTEL-2*NORB1-NELEC3
      NEL2MX = MIN(NEL2MX,2*NORB2)
      IF( NEL2MN.LT.0 ) NEL2MN=0
      NEL3MX = NELEC3
      NEL3MN = 0
C     TOTAL NO. OF ALPHA AND BETA EL.
      NAEL = (MS2 + NACTEL ) / 2
      NBEL = (NACTEL - MS2 ) / 2
C     MIN. AND MAX. NO. OF PROTOTYPE CSFS (= MIN. AND. MAX. OPEN ORBS.)
      MINOP = ABS(MS2)
      maxop=maxop_lucia
*
      NTYP = MAXOP-MINOP + 1
      DO J = 1, MXSM
         DO ITYP = 1, NTYP
            LUCIA_TYPE  = ITYP+MINOP
            NCNFTP(ITYP,J) = NCONF_PER_OPEN(LUCIA_TYPE,J)
            NDTFTP(ITYP)   = NPDTCNF(LUCIA_TYPE)
            NCSFTP(ITYP)   = NPCSCNF(LUCIA_TYPE)
         ENDDO
      ENDDO
*
C     MIN. NO. OF EL. IN ALPHA AND BETA STRING
      NL1MNA = MAX(0,NEL1MN-MIN(NBEL,NORB1) )
      NL1MNB = MAX(0,NEL1MN-MIN(NAEL,NORB1) )
C     NO. OF SINGLE EXITATIONS FOR ALPHA AND BETA STRING
      NAEXCI = NAEL*(NAC-NAEL+1)
      NBEXCI = NBEL*(NAC-NBEL+1)

C     Memory needed to store ICONF array
      LCONF = 0
      LDET = 0
      DO 40 ISYM = 1,NSYM
        LLCONF = 0
        LDET = MAX(LDET,NDTASM(ISYM))
        DO 35 ITYP = 1, NTYP
          IOPEN = ITYP+MINOP-1
          ICL = (NACTEL-IOPEN)/2
          LLCONF = LLCONF + NCNFTP(ITYP,ISYM)*(IOPEN+ICL)
35      CONTINUE
        LCONF = MAX(LCONF,LLCONF)
40    CONTINUE
*
      Call GetMem('KICONF','Allo','Integer',KICONF(1),LCONF)
      Call GetMem('KICTS','Allo','Integer',KICTS(1),LDET)
      KICTS_POINTER = KICTS(1)
*
      DO I = 1, LCONF
         IWORK(KICONF(1)+I-1) = KICONF_OCC_LUCIA(I)
      ENDDO
*
      DO I = 1, LDET
         IWORK(KICTS(1)+I-1) = KSDREO_I(I)
      ENDDO
*
      NDET = NDET_LUCIA
      MULTS = MULTS_LUCIA
      MAXSYM = NSYM
*
      NEL1MNA = MAX(0,NEL1MN-MIN(NAEL,NORB1))
      NEL1MNB = MAX(0,NEL1MN-MIN(NBEL,NORB1))
      NOCTPA = (NORB1 - NEL1MNA + 1) * (NEL3MX + 1)
      NOCTPB = (NORB1 - NEL1MNB + 1) * (NEL3MX + 1)
*
      KDFTP = KDFTP_LUCIA
      KCFTP = KCFTP_LUCIA
      KDTOC = KDTOC_LUCIA
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(NSSOA)
        CALL Unused_integer_array(NSSOB)
      END IF
      END
*
      SUBROUTINE LUCIA2MOLCAS_FREE
      IMPLICIT REAL*8 (A-H, O-Z)
#include "rasdim.fh"
#include "csfbas.fh"
#include "ciinfo.fh"
#include "spinfo.fh"
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
#include "splitcas.fh"
#include "strnum.fh"
#include "detbas.fh"
#include "lucia_ini.fh"
#include "WrkSpc.fh"
C     Memory needed to store ICONF array
      LCONF = 0
      LDET = 0
      DO 40 ISYM = 1,NSYM
        LLCONF = 0
        LDET = MAX(LDET,NDTASM(ISYM))
        DO 35 ITYP = 1, NTYP
          IOPEN = ITYP+MINOP-1
          ICL = (NACTEL-IOPEN)/2
          LLCONF = LLCONF + NCNFTP(ITYP,ISYM)*(IOPEN+ICL)
35      CONTINUE
        LCONF = MAX(LCONF,LLCONF)
40    CONTINUE
*
      Call GetMem('KICONF','Free','Integer',KICONF(1),LCONF)
      Call GetMem('KICTS','Free','Integer',KICTS(1),LDET)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DistMemReord(maxdim,maxdimSG,NchBlk,PosV1,PosV2,PosV3,PosV4,PosM1,PosM2,PosT)
! This routine does:
! define initial positions of OE,V1-V4,M1,2 arrays
! described in Reord routine
!
! Memory requirements:
!  intkey=0
! V1   - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm;  oom}
! V2   - max {ov'ov'; v'v'm, ov'm; oom}
! V3   - max {ov'm; oom}
! V4   - oom
!  intkey=0
! V1   - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm; oom; V"V"V"V"}
! V2   - max {ov'ov'; v'v'm, ov'm; oom}
! V3   - max {ov'm; oom; V'V'M}
! V4   - oom
! M1   - V"V"m
! M2   - max {V"V"M; OV"M)
!
! I/O parameter description:
! NxGrp    - # of groups in a,b,be,ga set (I)
! maxdim   - maximal dimension of V' (I)
! NChBlk   - # of Cholesky vectors in one Block - m' (I)
! Posx     - initial positions of arrays (O-all)
! PosT     - initial and last position (I/O)

use chcc_global, only: intkey, nc, no, nv, printkey
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: maxdim, maxdimSG, NchBlk
integer(kind=iwp), intent(out) :: PosV1, PosV2, PosV3, PosV4, PosM1, PosM2
integer(kind=iwp), intent(inout) :: PosT
integer(kind=iwp) :: length, nbas

!2 V1 file
!  V1 - max {ov'ov'; nbas.nbas.m'; ov'm; v'v'm;  oom, V"V"V"V"}

nbas = no+nv

length = maxdim*maxdim*no*no
if ((nbas*nbas*NChBlk) > length) length = nbas*nbas*NChBlk
if ((no*maxdim*nc) > length) length = no*maxdim*nc
if ((maxdim*maxdim*nc) > length) length = maxdim*maxdim*nc
if ((no*no*nc) > length) length = no*no*nc
if ((intkey == 1) .and. (length <= maxdimSG**4)) length = maxdimSG**4

PosV1 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V1 ',PosV1,length

!3 V2 file
!  V2 - max {ov'ov'; v'v'm ; ov'm; oom}

length = maxdim*maxdim*no*no
if ((maxdim*maxdim*nc) > length) length = maxdim*maxdim*nc
if ((no*maxdim*nc) > length) length = no*maxdim*nc
if ((no*no*nc) > length) length = no*no*nc

PosV2 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V2 ',PosV2,length

!4 V3 file
!  V3 - max {ov'm; oom, V'V'M}

if ((no*no*nc) > length) length = no*no*nc
if ((intkey == 1) .and. (length <= maxdim*maxdim*nc)) length = maxdim*maxdim*nc

PosV3 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V3 ',PosV3,length

!5 V4 file
!  V4 - oom

length = no*no*nc

PosV4 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V4 ',PosV4,length

!6 M1 - V"V"m

length = maxdimSG*maxdimSG*nc
if (intkey == 0) length = 0
PosM1 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM M1 ',PosM1,length

!7 M2 - max {V"V"M; OV"M)

length = maxdimSG*maxdimSG*nc
if (length < no*nc*maxdimSG) length = no*nc*maxdimSG
if (intkey == 0) length = 0
PosM2 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM M2 ',PosM2,length

return

end subroutine DistMemReord

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Coen de Graaf                                    *
!               1999, Anders Bernhardsson                              *
!               1999, Roland Lindh                                     *
!               2018, Jesper Norell                                    *
!***********************************************************************

subroutine Molden_DysOrb(filename,ENE,OCC,CMO,NDO,NZ)
!***********************************************************************
!                                                                      *
!     Object: to generate MOLDEN files for Dyson orbitals              *
!                                                                      *
!     Modified from molden_interface by Jesper Norell 2018             *
!     (Since requirements for e.g. number of orbitals and              *
!     treament of symmetry differs from "normal" MOs)                  *
!                                                                      *
!     Authors: Coen de Graaf, Anders Bernardsson and R. Lindh, 1999    *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, nBas, MolWgh, nCnttp, Shells
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep, lIrrep
use Sizes_of_Seward, only: S
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: NDO, NZ
character(len=*), intent(in) :: filename
real(kind=wp), intent(in) :: ENE(NDO), OCC(NDO), CMO(NZ*NDO)
integer(kind=iwp) :: i, iAngMx_Valence, iatom, iB, iBtot, iCntr, iCnttp, icontr, iCount, iDeg, idx, iGTO, iIrrep, iLabel, iPL, &
                     iprim, iRc = 0, iS, isegm, ishell, iSymcent, jPL, k, kk, kk_Max, l, mdc, MF, nAtom, nB, nData, nDeg, nOrb(8), &
                     nTest, nTot, nTot2
real(kind=wp) :: COEF, coeff, prim
logical(kind=iwp) :: Exists, Found, y_cart, y_sphere
character(len=100) :: Supername
character(len=8) :: Env
integer(kind=iwp), allocatable :: Cent(:,:), Cent2(:), ibas_lab(:), Phase(:,:)
real(kind=wp), allocatable :: Coor(:,:), DESYM(:,:), r_Norm(:), Znuc(:)
character(len=LenIn8+1), allocatable :: gtolabel(:)
character(len=LenIn8), allocatable :: label(:)
character(len=LenIn), allocatable :: AtomLabel(:)
character(len=8), allocatable :: MO_Label(:)
real(kind=wp), parameter :: EorbThr = 50.0_wp
character, parameter :: shelllabel(7) = ['s','p','d','f','g','h','i'], &
                        cNumber(61) = ['1','2','3','4','5','6','7','8','9','0', &
                                       'a','b','c','d','e','f','g','h','i','j', &
                                       'k','l','m','n','o','p','q','r','s','t', &
                                       'u','v','w','x','y','z','A','B','C','D', &
                                       'E','F','G','H','I','J','K','L','M','N', &
                                       'O','P','Q','R','S','T','V','W','X','Y', &
                                       'Z']
integer(kind=iwp), external :: iPrintLevel
real(kind=r8), external :: DblFac
logical(kind=iwp), external :: Reduce_Prt
character(len=100), external :: Get_SuperName

if (iRc == 1) return

! Do nothing within numerical_gradient
SuperName = Get_Supername()
if (SuperName == 'numerical_gradient') then
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the print level

iPL = iPrintLevel(-1)
jPL = iPL
if (Reduce_Prt() .and. (iPL < 3)) jPL = 0
!                                                                      *
!***********************************************************************
!                                                                      *
if (MolWgh == 1) then
  if (jPL >= 2) then
    write(u6,*) 'Molden_Interface: Unsupported normalization,Molwgh=1!'
  end if
  iRc = 1
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call GetEnvf('MOLCAS_MOLDEN',Env)
!if ((Env == ' ') .or. (Env == 'OFF')) Then
if (Env == 'OFF') then
  if (jPL >= 2) then
    write(u6,*)
    write(u6,*) ' Molden files will not be produced'
    write(u6,*)
  end if
  iRC = 1
  return
end if
!VV: current version of Molden has no clear limit for MaxOrb
!if (MaxOrb > MaxOrb_Molden) then
!  if (jPL >= 2) then
!    write(u6,*)
!    write(u6,*) ' Molden_Interface: W A R N I N G !!!!'
!    write(u6,*)
!    write(u6,*) ' No Molden input file will be generated!'
!    write(u6,*)
!    write(u6,*) ' Calculation exceeds the max number of orbitals allowed for MOLDEN. To change this modify the'
!    write(u6,*) ' parameter MaxOrb_Molden in src/util/molden_interface.f and follow the instructions in Molden'
!    write(u6,*) ' on how to modify the parameter MaxOrb.'
!    write(u6,*)
!  end if
!  iRC = 1
!  return
!end if
!                                                                      *
!***********************************************************************
!                                                                      *
call f_Inquire('RUNFILE',Exists)
if (.not. Exists) then
  iRC = 1
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Read the characteristics of all different basis sets,
! provide each atom with a nuclear charge and establish
! a link between an atom and its basis set ---
!
! NOTICE!!!
! This call will also fill Basis_Info and Center_Info.

call mma_allocate(AtomLabel,MxAtom,label='AtomLabel')
call mma_allocate(iBas_Lab,MxAtom,label='iBas_Lab')
call mma_allocate(Coor,3,MxAtom,label='Coor')
call mma_allocate(Znuc,MxAtom,label='Znuc')
call Inter1(AtomLabel,iBas_Lab,Coor,Znuc,nAtom)
call Qpg_iArray('nOrb',Found,nData)
if (Found) then
  call Get_iArray('nOrb',nOrb,nData)
else
  nOrb(:) = nBas(:)
end if
call mma_deallocate(iBas_Lab)
!                                                                      *
!***********************************************************************
!                                                                      *
iAngMx_Valence = 0
do iCnttp=1,nCnttp
  if ((.not. dbsc(iCnttp)%Aux) .and. (.not. dbsc(iCnttp)%Frag)) then
    nTest = dbsc(iCnttp)%nVal-1
    iAngMx_Valence = max(iAngMx_Valence,nTest)
  end if
end do
if (iAngMx_Valence > 4) then
  if (jPL >= 2) then
    write(u6,*) 'Sorry, Molden does not know how to handle'
    write(u6,*) 'functions with angular momentum larger than g'
  end if
  call End1()
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Unnormalize contraction coefficients for the valence shells

do iCnttp=1,nCnttp
  if ((.not. dbsc(iCnttp)%Aux) .and. (.not. dbsc(iCnttp)%Frag)) then
    do l=0,dbsc(iCnttp)%nVal-1
      ishell = dbsc(iCnttp)%iVal+l
      call Unnrmlz(Shells(ishell)%Exp,Shells(ishell)%nExp,Shells(ishell)%pCff,Shells(ishell)%nBasis,l)
    end do
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute memory requirements and allocate memory

nB = 0
do iS=0,nirrep-1
  nB = nB+nBas(is)
end do
call mma_allocate(MO_Label,nB,label='MO_Label')
call mma_allocate(gtolabel,nB,label='gtolabel')
call mma_allocate(r_Norm,nB,label='r_Norm')
call mma_allocate(Cent,8,nB,label='ICENT')
call mma_allocate(Phase,8,nB,label='IPHASE')
call mma_allocate(Cent2,nB,label='nCENT')
!                                                                      *
!***********************************************************************
!                                                                      *
! Open input file for MOLDEN

MF = 9
call molcas_open(MF,filename)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write the atom information in MOLDEN format to unit MF

y_cart = .false.
y_sphere = .false.
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag) cycle
  do iCntr=1,dbsc(iCnttp)%nCntr
    do l=0,dbsc(iCnttp)%nVal-1
      ! Test for the appearance of cartesian functions with l=2,3,4
      ishell = dbsc(iCnttp)%iVal+l
      if ((l >= 2) .and. (.not. y_cart)) then
        if (.not. Shells(ishell)%Transf) y_cart = .true.
      end if
      if ((l >= 2) .and. (.not. y_sphere)) then
        if (Shells(ishell)%Transf) y_sphere = .true.
      end if
      if (y_sphere .and. y_cart) then
        if (jPL >= 2) then
          write(u6,*)
          write(u6,*) 'Failed to generate input file to MOLDEN'
          write(u6,*) 'No mixing allowed of spherical and cartesian d, f, g-functions'
        end if
        call End3()
        return
      end if
    end do
  end do
end do
write(MF,'(A)') '[Molden Format]'
!                                                                      *
!***********************************************************************
!                                                                      *
! Write atomic information

write(MF,'(A)') '[N_Atoms]'
write(MF,*) natom
write(MF,'(A)') '[Atoms] (AU)'
do iatom=1,natom
  write(MF,99) AtomLabel(iatom),iatom,int(Znuc(iatom)),(coor(i,iatom),i=1,3)
end do
if (.not. y_cart) then
  if (S%iAngMx > 1) write(MF,'(A)') '[5D]'
  if (S%iAngMx > 2) write(MF,'(A)') '[7F]'
  if (S%iAngMx > 3) write(MF,'(A)') '[9G]'
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Write Gaussian basis set information to MOLDEN input file.

write(MF,'(A)') '[GTO] (AU)'

! Read exponents and contraction coefficients of each unique basis.
! Write the present basis set (iCnttp) to the molden.input file for
! the appropriate atoms.
! Moreover, a list is constructed which contains a label for each
! GTO (gtolabel). This list follows the MOLDEN order of GTOs.
! Later this list will be used in the transformation of sabf (the
! symmetry adapted basis functions).

iatom = 0
mdc = 0
kk = 0

do iCnttp=1,nCnttp             ! loop over unique basis sets
  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag) cycle

  do iCntr=1,dbsc(iCnttp)%nCntr   ! loop over sym. unique centers
    mdc = mdc+1
    nDeg = nIrrep/dc(mdc)%nStab
    do iDeg=1,nDeg             ! loop over centers
      iAtom = iAtom+1
      write(MF,'(I4)') iAtom

      do l=0,dbsc(iCnttp)%nVal-1
        ishell = dbsc(iCnttp)%iVal+l
        if (Shells(iShell)%nBasis > size(cNumber)) then
          write(u6,*) 'Interf: too many contracted functions!'
          write(u6,*) 'nBasis(iShell)=',Shells(iShell)%nBasis
          call Abend()
        end if

        ! Iterate over each contracted GTO

        do icontr=1,Shells(ishell)%nBasis

          ! Find the number of exponents with non-zero exponents

          isegm = 0
          do iprim=1,Shells(ishell)%nExp
            coeff = Shells(ishell)%pCff(iprim,icontr)
            if (coeff /= Zero) then
              isegm = isegm+1
            end if
          end do

          write(MF,'(3x,A1,I4)') shelllabel(l+1),isegm

          ! Write exponents and contraction coefficients.

          do iprim=1,Shells(ishell)%nExp
            coeff = Shells(ishell)%pCff(iprim,icontr)
            prim = Shells(ishell)%Exp(iprim)
            if (coeff /= Zero) then
              write(MF,'(E17.9,E17.9)') prim,coeff
            end if
          end do

          ! Construction of gtolabel
          ! Molden order: for p-functions: px(1), py(1), pz(1),
          !                                px(2), py(2), pz(2), etc.
          ! for d-, and f-functions: similar

          if (l == 0) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'01s     '//cNumber(icontr)
            r_Norm(kk) = One
          end if
          if (l == 1) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'02px    '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'02py    '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'02pz    '//cNumber(icontr)
            r_Norm(kk) = One
          end if
          if ((l == 2) .and. (.not. y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d00   '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d01+  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d01-  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d02+  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d02-  '//cNumber(icontr)
            r_Norm(kk) = One
          end if
          if ((l == 2) .and. (y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d020000 '//cNumber(icontr)
            r_Norm(kk) = CC(2,0,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d000200 '//cNumber(icontr)
            r_Norm(kk) = CC(0,2,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d000002 '//cNumber(icontr)
            r_Norm(kk) = CC(0,0,2)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d010100 '//cNumber(icontr)
            r_Norm(kk) = CC(1,1,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d010001 '//cNumber(icontr)
            r_Norm(kk) = CC(1,0,1)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d000101 '//cNumber(icontr)
            r_Norm(kk) = CC(0,1,1)
          end if
          if ((l == 3) .and. (.not. y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f00   '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f01+  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f01-  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f02+  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f02-  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f03+  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f03-  '//cNumber(icontr)
            r_Norm(kk) = One
          end if
          if ((l == 3) .and. (y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f030000 '//cNumber(icontr)
            r_Norm(kk) = CC(3,0,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f000300 '//cNumber(icontr)
            r_Norm(kk) = CC(0,3,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f000003 '//cNumber(icontr)
            r_Norm(kk) = CC(0,0,3)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f010200 '//cNumber(icontr)
            r_Norm(kk) = CC(1,2,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f020100 '//cNumber(icontr)
            r_Norm(kk) = CC(2,1,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f020001 '//cNumber(icontr)
            r_Norm(kk) = CC(2,0,1)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f010002 '//cNumber(icontr)
            r_Norm(kk) = CC(1,0,2)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f000102 '//cNumber(icontr)
            r_Norm(kk) = CC(0,1,2)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f000201 '//cNumber(icontr)
            r_Norm(kk) = CC(0,2,1)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f010101 '//cNumber(icontr)
            r_Norm(kk) = CC(1,1,1)
          end if
          if ((l == 4) .and. (.not. y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g00   '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g01+  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g01-  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g02+  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g02-  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g03+  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g03-  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g04+  '//cNumber(icontr)
            r_Norm(kk) = One
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g04-  '//cNumber(icontr)
            r_Norm(kk) = One
          end if
          if ((l == 4) .and. (y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g040000 '//cNumber(icontr)
            r_Norm(kk) = CC(4,0,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000400 '//cNumber(icontr)
            r_Norm(kk) = CC(0,4,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000004 '//cNumber(icontr)
            r_Norm(kk) = CC(0,0,4)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g030100 '//cNumber(icontr)
            r_Norm(kk) = CC(3,1,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g030001 '//cNumber(icontr)
            r_Norm(kk) = CC(3,0,1)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g010300 '//cNumber(icontr)
            r_Norm(kk) = CC(1,3,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000301 '//cNumber(icontr)
            r_Norm(kk) = CC(0,3,1)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g010003 '//cNumber(icontr)
            r_Norm(kk) = CC(1,0,3)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000103 '//cNumber(icontr)
            r_Norm(kk) = CC(0,1,3)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g020200 '//cNumber(icontr)
            r_Norm(kk) = CC(2,2,0)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g020002 '//cNumber(icontr)
            r_Norm(kk) = CC(2,0,2)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000202 '//cNumber(icontr)
            r_Norm(kk) = CC(0,2,2)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g020101 '//cNumber(icontr)
            r_Norm(kk) = CC(2,1,1)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g010201 '//cNumber(icontr)
            r_Norm(kk) = CC(1,2,1)
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g010102 '//cNumber(icontr)
            r_Norm(kk) = CC(1,1,2)
          end if
        end do
      end do
      write(MF,'(A)') ' '
    end do
  end do
end do
kk_Max = kk
if (nB > kk_max) then
  if (jPL >= 2) then
    write(u6,*) 'Molden_Interface: nB.gt.kk_max'
    write(u6,*) 'nB,kk_Max=',nB,kk_Max
  end if
  call End2()
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
nTot = 0
nTot2 = 0
do iS=0,nIrrep-1
  nTot = nTot+nBas(iS)
  nTot2 = nTot2+nBas(iS)**2
end do
!                                                                      *
!***********************************************************************
!                                                                      *
!  Back 'transformation' of the symmetry adapted basis functions.
!  Probably somewhat clumsy, but it seems to work. If someone
!  knows a more elegant way to do it, please improve this part!
!
!  PART 1: Obtain symmetry information (soout), construct a label
!          for each sabf, which will be used in part 2 to find the
!          corresponding GTO in the MOLDEN list by comparing with
!          gtolabel
!
!  nB     --- Total number of contracted basis functions
!  cent2  --- degeneracy of a basis function
!  Cent   --- centres over which the basis function is delocalized
!  Phase  --- phase of the AO in the linear combination

call mma_allocate(label,MaxBfn+MaxBfn_Aux,label='label')
Phase(:,:) = 0
Cent(:,:) = 0
call SOout(label,Cent,Phase)
do iContr=1,nB
  Cent2(iContr) = 0
  do k=1,8
    if (Cent(k,iContr) /= 0) Cent2(iContr) = Cent2(iContr)+1
  end do
end do

!                                                                      *
!***********************************************************************
!                                                                      *
!  Construct a matrix which inverses the symmetry transformation
!  of the basis fuctions (DESYM)
!
!  NOTE: Also necessary for no symmetry calculations
!  to properly keep track of i.e. px vs py vs pz

call mma_allocate(DESYM,NZ,NZ,label='DESYM')
DESYM(:,:) = Zero
iBtot = 0
iCount = 0
do iIrrep=0,nIrrep-1 ! For all the irreps of symmetrized functions

  do iB=1,nBas(iIrrep) ! For each symmetrized function in the irrep
    iBtot = iBtot+1
    iSymcent = 1

    if (iB == 1) then ! Counter within functions with the same label (e.g. H1 1s 1, H1 1s 2, ...)
      iCount = 1
    else
      if (label(iBtot-1) == label(iBtot)) then
        iCount = iCount+1
      else
        iCount = 1
      end if
    end if

    write(MO_Label(iBtot),'(A3)') lirrep(iIrrep) ! Save label for later printing

    do iGTO=1,nB ! Find matching Gaussian (GTO)

      if (gtolabel(iGTO) == label(iBtot)//cNumber(iCount)) then
        ! GTO Found
        coeff = real(Phase(iSymcent,iBtot),kind=wp)*r_Norm(iGTO)/sqrt(real(Cent2(iBtot),kind=wp))
        DESYM(iBtot,iGTO) = DESYM(iBtot,iGTO)+coeff
        iSymcent = iSymcent+1 ! Keep track of symmetry centre
      end if ! GTO finding

    end do ! iGTO=1,nB
  end do ! iB=1,nBas(iIrrep)
end do ! iIrrep=0,nIrrep-1
call mma_deallocate(label)

!                                                                      *
!***********************************************************************
!                                                                      *
!  Dump vector in the molden.input file

write(MF,'(A)') '[MO]'

! For all Dyson orbitals
do I=1,NDO

  ! Symmetry = perform a backtransformation from symmetrized to
  ! original basis functions
  ! and to properly split up e.g. px vs py vs pz compoments
  ! also for no symmetry calculations

  ! Find the correct symmetry label from the symmetrized functions
  idx = (I-1)*NB+1
  iLabel = maxloc(abs(CMO(idx:idx+nB-1)),1)
  write(MF,'(A,I0,A)') 'Sym= ',I,MO_Label(iLabel)
  write(MF,103) ENE(I)
  write(MF,'(A)') 'Spin= Alpha'
  write(MF,104) OCC(I)

  ! Now backtransform the orbitals
  do iGTO=1,NB ! For each molden GTO
    COEF = 0
    do iB=1,NB ! Gather contributions from all symmetrized basis functions
      COEF = COEF+DESYM(iB,iGTO)*CMO((I-1)*NB+iB)
    end do
    write(MF,100) iGTO,COEF
  end do

end do ! I=1,NDO (i.e. Dyson orbitals)
call mma_deallocate(DESYM)

!                                                                      *
!***********************************************************************
!                                                                      *
call End3()

return

! -------------FORMATS-------------
99 format(A,2(3x,I4),5x,3F16.8,3I4)
100 format(I4,3x,F16.8)
103 format('Ene= ',F10.4)
104 format('Occup= ',F10.5)

contains

function CC(ix,iy,iz)
  real(kind=wp) :: CC
  integer(kind=iwp), intent(in) :: ix, iy, iz
  CC = sqrt(DblFac(2*ix-1)*DblFac(2*iy-1)*DblFac(2*iz-1))
end function CC

subroutine End1()
  call mma_deallocate(AtomLabel)
  call mma_deallocate(Coor)
  call mma_deallocate(Znuc)
  call ClsSew()
end subroutine End1

subroutine End2()
  close(MF)
  call End1()
end subroutine End2

subroutine End3()
  call mma_deallocate(MO_Label)
  call mma_deallocate(gtolabel)
  call mma_deallocate(r_Norm)
  call mma_deallocate(Cent)
  call mma_deallocate(Phase)
  call mma_deallocate(Cent2)
  call End2()
end subroutine End3

end subroutine Molden_DysOrb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_OrbCen(nPrim,NORBI,Q_MltPl,RCHC,CENTX,CENTY,CENTZ,oCof)
!EB subroutine Get_OrbCen(nPrim,nBas,NORBI,Q_MltPl,RCHC,

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nPrim, NORBI
real(kind=wp), intent(in) :: Q_MltPl(nPrim*(nPrim+1)/2), CENTX(nPrim*(nPrim+1)/2), CENTY(nPrim*(nPrim+1)/2), &
                             CENTZ(nPrim*(nPrim+1)/2), oCof(NORBI,nPrim)
real(kind=wp), intent(out) :: RCHC(3,NORBI)
integer(kind=iwp) :: I, J, K
real(kind=wp) :: OOQ, QMIN, QPOS
real(kind=wp), allocatable :: RCPO(:,:), RCMI(:,:)

! CALCULATE A CENTER OF CHARGE FOR EACH MOLECULAR ORBITAL

call mma_allocate(RCPO,3,NORBI,label='RCPO')
call mma_allocate(RCMI,3,NORBI,label='RCMI')

RCPO(:,:) = Zero
RCMI(:,:) = Zero
do I=1,NORBI
  QPOS = Zero
  QMIN = Zero
  do J=1,nPrim
    do K=1,J

      ! THE WEIGHTED AVERAGE OF THE POSITIVE AND NEGATIVE CONTRIBUTIONS

      OOQ = OCOF(I,J)*OCOF(I,K)*Q_MltPl(J*(J-1)/2+K)*Two
      if (OOQ >= Zero) then
        QPOS = QPOS+OOQ
        RCPO(1,I) = RCPO(1,I)+OOQ*CENTX(J*(J-1)/2+K)
        RCPO(2,I) = RCPO(2,I)+OOQ*CENTY(J*(J-1)/2+K)
        RCPO(3,I) = RCPO(3,I)+OOQ*CENTZ(J*(J-1)/2+K)
      else
        QMIN = QMIN+OOQ
        RCMI(1,I) = RCMI(1,I)+OOQ*CENTX(J*(J-1)/2+K)
        RCMI(2,I) = RCMI(2,I)+OOQ*CENTY(J*(J-1)/2+K)
        RCMI(3,I) = RCMI(3,I)+OOQ*CENTZ(J*(J-1)/2+K)
      end if
    end do
    OOQ = OCOF(I,J)*OCOF(I,J)*Q_MltPl(J*(J+1)/2)
    if (OOQ >= Zero) then
      QPOS = QPOS-OOQ
      RCPO(1,I) = RCPO(1,I)-OOQ*CENTX(J*(J+1)/2)
      RCPO(2,I) = RCPO(2,I)-OOQ*CENTY(J*(J+1)/2)
      RCPO(3,I) = RCPO(3,I)-OOQ*CENTZ(J*(J+1)/2)
    else
      QMIN = QMIN-OOQ
      RCMI(1,I) = RCMI(1,I)-OOQ*CENTX(J*(J+1)/2)
      RCMI(2,I) = RCMI(2,I)-OOQ*CENTY(J*(J+1)/2)
      RCMI(3,I) = RCMI(3,I)-OOQ*CENTZ(J*(J+1)/2)
    end if
  end do
  RCHC(:,I) = (RCPO(:,I)-RCMI(:,I))/(QPOS-QMIN)
end do

call mma_deallocate(RCPO)
call mma_deallocate(RCMI)

return

!EB 96 format(I5,3E15.8)

end subroutine Get_OrbCen

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRDTMP(DPT2,NDPT2)
      use definitions, only: iwp, wp
      use constants, only: Zero
      USE Para_Info, ONLY: King
      use stdalloc, only: mma_allocate, mma_deallocate
      use EQSOLV, only: iVecc
      use caspt2_module, only: nSym, nIsh, nAsh, nOrb, nAES, nAshT
      IMPLICIT None


      integer(kind=iwp), intent(in)::  NDPT2
      real(kind=wp), intent(inout):: DPT2(NDPT2)

      real(kind=wp), Allocatable:: DTemp(:,:)
      integer(kind=iwp) idpt, iofdpt, isym, it, itabs, itq, iu, iuabs,
     &                  iuq, na, ndtemp, ni, no
      real(kind=wp) Value

      if(nasht==0) return


      ndtemp=nasht**2
      call mma_allocate(dtemp,nAshT,nAshT,Label='DTemp')
      DTemp(:,:)=Zero
CSVC: trdact is still serial and expects to work on the LUSOLV file,
C which is only on the master node. As long as the MKWW subroutines are
C not functioning in parallel, this part should be done only on the
C master node:
      IF (KING()) call trdact(IVECC,IVECC,dtemp)

      call GADSUM(DTEMP,NDTEMP)

      iofdpt=0
      do isym=1,nsym
        ni=nish(isym)
        na=nash(isym)
        no=norb(isym)
        do it=1,na
          itq=ni+it
          itabs=naes(isym)+it
          do iu=1,na
            iuq=ni+iu
            iuabs=naes(isym)+iu
            value=dtemp(itabs,iuabs)
            idpt=iofdpt+itq+no*(iuq-1)
            DPT2(idpt)=DPT2(idpt)+value
          end do
        end do
        iofdpt=iofdpt+no**2
      end do
      call mma_deallocate(dtemp)

      end SUBROUTINE TRDTMP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module gugaci_global

use Constants, only: Two, Three, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
private

#include "Molcas.fh"

integer(kind=iwp), parameter :: lenintegral = 4, loputmp = 10000, max_atom = 200, max_extorb = 300, max_h0 = 13000, &
                                max_innorb = 100, max_iter = 100, max_kspace = 40, max_lpext_mode = 60000, max_node = 36000, &
                                max_orb = 500, max_ref = 128, max_root = 20, max_tmpvalue = 1000000, max_vector = 800000000, &
                                max_wei = 208000, maxpl = 300000, mtmp = max_orb*(max_orb-1)/2, ntrabuf = 9600, ntratoc = 106, &
                                nvaltype = 200000
integer(kind=iwp), parameter :: istep_occ(4) = [0,1,1,2], &
                                map_jplr(6,6) = reshape([25,23,17,10,24,18, &  !v
                                                         26,19,13, 6,22, 0, &  !d
                                                          0,14,11, 2, 0, 0, &  !t
                                                          0, 7, 3, 1, 9, 5, &  !s
                                                          0,21, 0, 8,20,15, &  !dd
                                                          0, 0, 0, 4,16,12], & !tt
                                                        shape(map_jplr))
real(kind=wp), parameter :: v_onevsqtwo = sqrt(Half), v_sqthree = sqrt(Three), v_sqthreevsqtwo = sqrt(OneHalf), v_sqtwo = sqrt(Two)

integer(kind=iwp) :: ibsm_ext(mxSym), ican_a(max_orb), ican_b(mtmp+max_orb), icano_nnend, icano_nnsta, icnt_base, idisk_array(13), &
                     idisk_lp, idownwei_g131415, iesm_ext(mxSym), ifrno(max_h0), ildownwei_segdd, ilsegdownwei, iml, imr, &
                     index_lpext3(max_extorb,max_innorb), index_lpext4(max_extorb,max_innorb), index_lpext5(max_extorb), &
                     indx(max_kspace), int_dd_drl, int_dd_offset(8,8), ip2_aa_ext_base, ip2_dd_ext_base, ip3_abd_ext_base, &
                     ip4_abcd_ext_base(180), ipae, ipael, ipaety, irdownwei_segdd, iref_occ(max_innorb,max_ref), irf, &
                     irfno(max_ref), irsegdownwei, iseg_downwei(25), iseg_sta(26), iseg_upwei(25), isegdownwei, isegsta, &
                     isegupwei, ism_g1415, ism_g2g4, ivaluesta_g26, iw_downwei(41,25), iw_sta(41,25), iweista_g25, iweista_g26, &
                     iweista_g28, iwt_orb_ext(max_extorb,max_extorb), iwt_sm_s_ext, jb_sys, jd(8), jml, jmr, jp2(max_orb), &
                     jp3(max_orb), jpad, jpad_upwei(82), jpadl, jpadlr, jpae, jpae_downwei(25), jpael, jpel, jper, jph_, &
                     jroute_sys, js(8), jt(8), jud(max_innorb), just(max_innorb,max_innorb), jv, jwl, jwr, lenvec, line, linelp, &
                     log_prod, lp_count(22), lpblock, lpblock_dd, lpblock_ds, lpblock_dt, lpblock_dv, lpblock_sd, lpblock_ss, &
                     lpblock_st, lpblock_sv, lpblock_td, lpblock_ts, lpblock_tt, lpblock_tv, lpblock_vd, lpend34a, lpend34b, &
                     lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei(max_lpext_mode*3), lpsta34a, lpsta34b, lpsta35a, lpsta35b, &
                     lpsta36a, lpsta36b, lrg, lrs, lsm(max_orb), lsm_inn(max_innorb), lsmorb(max_orb), LuCiDen, LuCiDia, LuCiInt, &
                     LuCiMO, LuCiTv1, LuCiTv2, LuCiVec, LuDrt, LuLoop, LuOneMO, LuTwoMO, m_jc, m_jd, map_orb_order(max_orb), &
                     maxciiter, maxintseg, mcroot, mhlp, mhlpmax, mhsum, mjn(2*max_root), mroot, mth_eigen, mtype, mxnode, n_ref, &
                     nabc, nci_dim, nci_h0, ncibl(max_orb), ncibl_all(max_orb), ndim, ndim_h0, ndr, ng_sm, ngw2(max_orb), &
                     ngw3(max_orb), ngw4(max_orb), nint_g25, nint_g28, nlg1, nlg2, nlsm_all(mxSym), nlsm_bas(mxSym), &
                     nlsm_dbl(mxSym), nlsm_ext(mxSym), nlsm_frz(mxSym), no(0:max_innorb), nohy, noidx(8), norb_act, norb_all, &
                     norb_dbl, norb_dz, norb_ext, norb_frz, norb_inn, norb_number(max_orb), np3_abd_ext, ns_sm, nstart_act, &
                     nstaval(nvaltype), nu_ad(41), nu_ae(25), nvalue(nvaltype), nvalue_space_ss, nwalk(0:max_orb), nwei_g25, &
                     nwei_g26, nwei_g28 !, jpadlrel(26), len_str, naorbs, ndjgrop, ndjmod, numat
real(kind=wp) :: cm_cri, dm1tmp(max_orb*(max_orb+1)/2), ecih0(max_root), escf(max_root), fg, pd, pdd, pror, ps1, ps2, ps3, ps4, &
                 pt, ptt, spin, value_lpext3(max_extorb,max_innorb), value_lpext4(max_extorb,max_innorb), &
                 value_lpext5(max_extorb), vd(max_kspace), vdint(0:max_orb,0:max_orb), ve(max_kspace), &
                 viasum_0(max_innorb,max_extorb), viasum_1(max_innorb,max_extorb), vijkk_0sum(max_tmpvalue), &
                 vijkk_1sum(max_tmpvalue), voint(0:max_orb,0:max_orb), vp(max_kspace*(max_kspace+1)/2), vpotnuc, vthrealp, &
                 vthreen, vthreresid, vu(max_kspace,max_kspace), w0, w0_d1d(2), w0_d1d1(3), w0_d1s(4), w0_d1t1, w0_d1v(2), &
                 w0_dd(3), w0_dd1, w0_ds(3), w0_dt, w0_dv(2), w0_plp, w0_sd(16), w0_sd1(13), w0_sdplp, w0_sdplp25, w0_ss(20), &
                 w0_sv(3), w0_t1d1(5), w0_t1t1(3), w0_td(5), w0_tt(3), w0_vv, w0g13a, w0g14a, w0g15a, w0g25, w0g25a, w0g25b, &
                 w0g26a, w0g26b, w0g27, w0g28a, w0g28b, w0g29, w0g2a, w0g2b, w0g30, w0g31, w0g32, w0g34a, w0g34b, w0g35a, w0g35b, &
                 w0g36a, w0g36b, w0g4a, w0g4b, w0gdd, w0plp25, w0plp26, w0plp27, w0plp28, w0plp29, w0plp30, w0plp31, w0plp32, w1, &
                 w1_d1d(2), w1_d1d1(3), w1_d1s(4), w1_d1t1, w1_d1v(2), w1_dd(3), w1_dd1, w1_ds(3), w1_dt, w1_plp, w1_sd(16), &
                 w1_sd1(13), w1_sdplp, w1_sdplp25, w1_ss(20), w1_st(7), w1_st1(4), w1_sv(3), w1_t1d1(5), w1_t1s(7), w1_t1t1(3), &
                 w1_t1v, w1_td(5), w1_ts(4), w1_tt(3), w1_tv, w1g14a, w1g15a, w1g25a, w1g25b, w1g26a, w1g26b, w1g27, w1g28a, &
                 w1g28b, w1g2a, w1g2b, w1g31, w1g32, w1g34a, w1g34b, w1g35a, w1g35b, w1g36a, w1g36b, w1g4a, w1g4b, w1gdd, w1plp27, &
                 w1plp31, w1plp32
                 !, cf(max_orb,max_orb), dm1(max_orb,max_orb), dxyz(3,max_atom), p(max_orb,max_orb), xlgrn(max_orb,max_orb)
logical(kind=iwp) :: logic_assign_actorb, logic_calpro, logic_dh, logic_g13, logic_g1415, logic_g25a, logic_g25b, logic_g26, &
                     logic_g28a, logic_g2g4a, logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, &
                     logic_g49a, logic_g49b, logic_g50, logic_grad, logic_inivec_read, logic_mr !, logic_mrelcas , logic_tdav
!character(len=256) :: tmpdir
character(len=8) :: FnOneMO, FnTwoMO
integer(kind=iwp), allocatable :: ihy(:), ihyl(:), index_lpext(:), index_lpext1(:), index_lpext2(:), intind_abkk(:), &
                                  intind_iabc(:), intind_iaqq(:), intind_ijab(:), intind_ijcc(:), intind_ijka(:), &
                                  intspace_abkk(:), intspace_ijab(:), intspace_ijcc(:), iy(:,:), iyl(:,:), ja(:), jb(:), jeh(:), &
                                  jj(:,:), jj_sub(:,:), jjl_sub(:,:), jm(:), jph(:), jphy(:), jphyl(:), jwh(:), kk(:), loij(:), &
                                  loij_all(:), loijk(:), loijk_all(:), lp_coe(:,:), lp_head(:), lp_ltail(:), lp_lwei(:), &
                                  lp_rtail(:), lp_rwei(:), lpnew_coe(:,:), lpnew_head(:), lpnew_ltail(:), lpnew_lwei(:), &
                                  lpnew_rtail(:), lpnew_rwei(:)
real(kind=wp), allocatable :: denm1(:), denm2(:), th(:), thh(:), value_lpext(:), value_lpext1(:), value_lpext2(:), vcm(:), &
                              vector1(:), vector2(:), vint_ci(:), vplp_w0(:), vplp_w1(:), vplpnew_w0(:), vplpnew_w1(:)
logical(kind=iwp), allocatable :: logic_br(:), logic_newbr(:)

public :: cm_cri, denm1, denm2, dm1tmp, ecih0, escf, fg, FnOneMO, FnTwoMO, ibsm_ext, ican_a, ican_b, icano_nnend, icano_nnsta, &
          icnt_base, idisk_array, idisk_lp, idownwei_g131415, iesm_ext, ifrno, ihy, ihyl, ildownwei_segdd, ilsegdownwei, iml, imr, &
          index_lpext, index_lpext1, index_lpext2, index_lpext3, index_lpext4, index_lpext5, indx, int_dd_drl, int_dd_offset, &
          intind_abkk, intind_iabc, intind_iaqq, intind_ijab, intind_ijcc, intind_ijka, intspace_abkk, intspace_ijab, &
          intspace_ijcc, ip2_aa_ext_base, ip2_dd_ext_base, ip3_abd_ext_base, ip4_abcd_ext_base, ipae, ipael, ipaety, &
          irdownwei_segdd, iref_occ, irf, irfno, irsegdownwei, iseg_downwei, iseg_sta, iseg_upwei, isegdownwei, isegsta, &
          isegupwei, ism_g1415, ism_g2g4, istep_occ, ivaluesta_g26, iw_downwei, iw_sta, iweista_g25, iweista_g26, iweista_g28, &
          iwt_orb_ext, iwt_sm_s_ext, iy, iyl, ja, jb, jb_sys, jd, jeh, jj, jj_sub, jjl_sub, jm, jml, jmr, jp2, jp3, jpad, &
          jpad_upwei, jpadl, jpadlr, jpae, jpae_downwei, jpael, jpel, jper, jph, jph_, jphy, jphyl, jroute_sys, js, jt, jud, just, &
          jv, jwh, jwl, jwr, kk, lenintegral, lenvec, line, linelp, log_prod, logic_assign_actorb, logic_br, logic_calpro, &
          logic_dh, logic_g13, logic_g1415, logic_g25a, logic_g25b, logic_g26, logic_g28a, logic_g2g4a, logic_g2g4b, logic_g34a, &
          logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, logic_g49a, logic_g49b, logic_g50, logic_grad, &
          logic_inivec_read, logic_mr, logic_newbr, loij, loij_all, loijk, loijk_all, loputmp, lp_coe, lp_count, lp_head, &
          lp_ltail, lp_lwei, lp_rtail, lp_rwei, lpblock, lpblock_dd, lpblock_ds, lpblock_dt, lpblock_dv, lpblock_sd, lpblock_ss, &
          lpblock_st, lpblock_sv, lpblock_td, lpblock_ts, lpblock_tt, lpblock_tv, lpblock_vd, lpend34a, lpend34b, lpend35a, &
          lpend35b, lpend36a, lpend36b, lpext_wei, lpnew_coe, lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, &
          lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, lpsta36b, lrg, lrs, lsm, lsm_inn, lsmorb, LuCiDen, LuCiDia, LuCiInt, &
          LuCiMO, LuCiTv1, LuCiTv2, LuCiVec, LuDrt, LuLoop, LuOneMO, LuTwoMO, m_jc, m_jd, map_jplr, map_orb_order, max_extorb, &
          max_h0, max_innorb, max_iter, max_kspace, max_node, max_orb, max_ref, max_root, max_tmpvalue, max_vector, max_wei, &
          maxciiter, maxintseg, maxpl, mcroot, mhlp, mhlpmax, mhsum, mjn, mroot, mth_eigen, mtype, mxnode, n_ref, nabc, nci_dim, &
          nci_h0, ncibl, ncibl_all, ndim, ndim_h0, ndr, ng_sm, ngw2, ngw3, ngw4, nint_g25, nint_g28, nlg1, nlg2, nlsm_all, &
          nlsm_bas, nlsm_dbl, nlsm_ext, nlsm_frz, no, nohy, noidx, norb_act, norb_all, norb_dbl, norb_dz, norb_ext, norb_frz, &
          norb_inn, norb_number, np3_abd_ext, ns_sm, nstart_act, nstaval, ntrabuf, ntratoc, nu_ad, nu_ae, nvaltype, nvalue, &
          nvalue_space_ss, nwalk, nwei_g25, nwei_g26, nwei_g28, pd, pdd, pror, ps1, ps2, ps3, ps4, pt, ptt, spin, th, thh, &
          v_onevsqtwo, v_sqthree, v_sqthreevsqtwo, v_sqtwo, value_lpext, value_lpext1, value_lpext2, value_lpext3, value_lpext4, &
          value_lpext5, vcm, vd, vdint, ve, vector1, vector2, viasum_0, viasum_1, vijkk_0sum, vijkk_1sum, vint_ci, voint, vp, &
          vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, vpotnuc, vthrealp, vthreen, vthreresid, vu, w0, w0_d1d, w0_d1d1, w0_d1s, &
          w0_d1t1, w0_d1v, w0_dd, w0_dd1, w0_ds, w0_dt, w0_dv, w0_plp, w0_sd, w0_sd1, w0_sdplp, w0_sdplp25, w0_ss, w0_sv, w0_t1d1, &
          w0_t1t1, w0_td, w0_tt, w0_vv, w0g13a, w0g14a, w0g15a, w0g25, w0g25a, w0g25b, w0g26a, w0g26b, w0g27, w0g28a, w0g28b, &
          w0g29, w0g2a, w0g2b, w0g30, w0g31, w0g32, w0g34a, w0g34b, w0g35a, w0g35b, w0g36a, w0g36b, w0g4a, w0g4b, w0gdd, w0plp25, &
          w0plp26, w0plp27, w0plp28, w0plp29, w0plp30, w0plp31, w0plp32, w1, w1_d1d, w1_d1d1, w1_d1s, w1_d1t1, w1_d1v, w1_dd, &
          w1_dd1, w1_ds, w1_dt, w1_plp, w1_sd, w1_sd1, w1_sdplp, w1_sdplp25, w1_ss, w1_st, w1_st1, w1_sv, w1_t1d1, w1_t1s, &
          w1_t1t1, w1_t1v, w1_td, w1_ts, w1_tt, w1_tv, w1g14a, w1g15a, w1g25a, w1g25b, w1g26a, w1g26b, w1g27, w1g28a, w1g28b, &
          w1g2a, w1g2b, w1g31, w1g32, w1g34a, w1g34b, w1g35a, w1g35b, w1g36a, w1g36b, w1g4a, w1g4b, w1gdd, w1plp27, w1plp31, w1plp32

end module gugaci_global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GT1DIS(H1DIA,IREOTS,IPNT,H,ISMFTO,IBSO,NACOB)
! diagonal of one electron integrals over active orbitals

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: H1DIA(*)
integer(kind=iwp), intent(in) :: NACOB, IREOTS(NACOB), IPNT(*), ISMFTO(NACOB), IBSO(*)
real(kind=wp), intent(in) :: H(*)
integer(kind=iwp) :: IIOB, IOB, IOBREL, ISM

do IIOB=1,NACOB
  IOB = IREOTS(IIOB)
  ISM = ISMFTO(IIOB)
  IOBREL = IOB-IBSO(ISM)+1
  !write(u6,*) ' IIOB IOB ISM IOBREL'
  !write(u6,*) IIOB,IOB,ISM,IOBREL
  H1DIA(IIOB) = H(IPNT(ISM)-1+nTri_Elem(IOBREL))
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Diagonal one electron integrals'
call WRTMAT(H1DIA,1,NACOB,1,NACOB)
#endif

end subroutine GT1DIS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine compl2_cvb(a,nvec,n,awrk,bwrk,cwrk)
      implicit real*8 (a-h,o-z)
      dimension a(n,n),awrk(n,nvec+n),bwrk(n,n),cwrk(n),dum(1)

      call fmove_cvb(a,awrk,n*nvec)
      call mxunit_cvb(awrk(1,1+nvec),n)
      call schmidt_cvb(awrk,nvec,dum,n,0)
      call schmidtd_cvb(awrk,nvec,awrk(1,nvec+1),n,dum,n,0)
c  Sort N vectors in order of decreasing norms
      do 100 i=1,n
      cwrk(i)=ddot_(n,awrk(1,i+nvec),1,awrk(1,i+nvec),1)
100   continue
      do 200 j=1,n
      cmx=cwrk(1)
      imx=1
      do 300 i=2,n
      if(cwrk(i).gt.cmx)then
        cmx=cwrk(i)
        imx=i
      endif
300   continue
      cwrk(imx)=-DBLE(j)
      call fmove_cvb(awrk(1,imx+nvec),bwrk(1,j),n)
200   continue
      call schmidt_cvb(bwrk,n,dum,n,0)
c  Extract N-NVEC remaining vectors with largest norms
      do 400 i=1,n
      cwrk(i)=ddot_(n,bwrk(1,i),1,bwrk(1,i),1)
400   continue
      do 500 j=1,n-nvec
      cmx=cwrk(1)
      imx=1
      do 600 i=2,n
      if(cwrk(i).gt.cmx)then
        cmx=cwrk(i)
        imx=i
      endif
600   continue
      cwrk(imx)=-DBLE(j)
      call fmove_cvb(bwrk(1,imx),a(1,nvec+j),n)
500   continue
      call nize_cvb(a(1,nvec+1),n-nvec,dum,n,0,0)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mk_Indkl(Indkl_OnOff,Indkl,nkl)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nkl, Indkl_OnOff(nkl)
integer(kind=iwp), intent(out) :: Indkl(nkl)
integer(kind=iwp) :: ikl, jkl

!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call iVcPrt('Mk_Indkl: Indkl_OnOff',' ',Indkl_OnOff,nkl)
#endif
ikl = 0
do jkl=1,nkl
  if (Indkl_OnOff(jkl) == 1) then
    ikl = ikl+1
    Indkl(jkl) = ikl
  else
    Indkl(jkl) = 0
  end if
end do
#ifdef _DEBUGPRINT_
call iVcPrt('Mk_Indkl: Indkl',' ',Indkl,nkl)
#endif

return

end subroutine Mk_Indkl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_P_Distrib_SP_byDim(mySP,N_mySP)
!
! Thomas Bondo Pedersen, June 2007.
!
! Determine distribution of ShellPairs by dimension.

use Index_Functions, only: nTri_Elem
use Para_Info, only: MyRank, nProcs
use Cholesky, only: Cho_Real_Par, iSP2F, nBstSh, nnShl
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: mySP(*)
integer(kind=iwp), intent(out) :: N_mySP
integer(kind=iwp) :: iA, iAB, iB, iNode, iSP, n
integer(kind=iwp), allocatable :: ProcDim(:)
integer(kind=iwp), external :: Cho_iFindSmallest

if (Cho_Real_Par) then

  call mma_allocate(ProcDim,[0,nProcs-1],Label='ProcDim')
  ProcDim(:) = 0

  N_mySP = 0
  do iSP=1,nnShl
    iAB = iSP2F(iSP)
    call Cho_InvPck(iAB,iA,iB,.true.)
    if (iA == iB) then
      n = nTri_Elem(nBstSh(iA))
    else
      n = nBstSh(iA)*nBstSh(iB)
    end if
    iNode = Cho_iFindSmallest(ProcDim,size(ProcDim))-1
    ProcDim(iNode) = ProcDim(iNode)+n
    if (iNode == myRank) then
      N_mySP = N_mySP+1
      mySP(N_mySP) = iSP
    end if
  end do

  call mma_deallocate(ProcDim)

else

  N_mySP = nnShl
  do iSP=1,N_mySP
    mySP(iSP) = iSP
  end do

end if

end subroutine Cho_P_Distrib_SP_byDim

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine TransMu(SqMu,nDim,TTot,Temp)
*                                                                      *
************************************************************************
*                                                                      *
*     Transform with TTOT the multipole moment integral matrix
*
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 SqMu(nDim*nDim),TTot(nDim*nDim),Temp(nDim*nDim)
*                                                                      *
************************************************************************
*                                                                      *
      Call DGEMM_('N','N',
     &            nDim,nDim,nDim,
     &            1.0d0,SqMu,nDim,
     &            TTot,nDim,
     &            0.0d0,Temp,nDim)
      Call DGEMM_('T','N',
     &            nDim,nDim,nDim,
     &            1.0d0,Ttot,nDim,
     &            Temp,nDim,
     &            0.0d0,SqMu,nDim)
C     Call RecPrt('Overout',' ',SqMu,nDim,nDim)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AtmLst(Cart,nAtom,Coor,mAtom)

use Symmetry_Info, only: nIrrep, iOper
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtom, mAtom
real(kind=wp), intent(in) :: Cart(3,nAtom)
real(kind=wp), intent(out) :: Coor(3,mAtom)
integer(kind=iwp) :: iAtom, iEnd, ig, iGo, iSt
real(kind=wp) :: r(3), x, y, z
logical(kind=iwp) :: New

!call RecPrt(' In AtmLst:Cart',' ',Cart,3,nAtom)

! Loop over list of symmetry unique centers

iSt = 1
do iAtom=1,nAtom
  iEnd = iSt
  Coor(:,iSt) = Cart(:,iAtom)

  ! Loop over the operators of the point group

  do ig=1,nIrrep-1
    r(1) = merge(-One,One,btest(iOper(ig),0))
    r(2) = merge(-One,One,btest(iOper(ig),1))
    r(3) = merge(-One,One,btest(iOper(ig),2))
    x = r(1)*Cart(1,iAtom)
    y = r(2)*Cart(2,iAtom)
    z = r(3)*Cart(3,iAtom)

    New = .true.
    do iGo=iSt,iEnd
      if (New .and. (x == Coor(1,iGo)) .and. (y == Coor(2,iGo)) .and. (z == Coor(3,iGo))) New = .false.
    end do
    if (New) then
      iEnd = iEnd+1
      Coor(1,iEnd) = x
      Coor(2,iEnd) = y
      Coor(3,iEnd) = z
    end if
  end do      ! End loop over operators
  iSt = iEnd+1
end do        ! End loop over centers

!call RecPrt(' In AtmLst: Coor',' ',Coor,3,mAtom)

return

end subroutine AtmLst

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine CoW(Coor,CoF,W,nAtom,T)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January '91                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Coor(3,nAtom), CoF(3), T, W(nAtom)
*
      iRout = 140
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In CoW: Coor',' ',Coor,3,nAtom)
         Call RecPrt(' In CoW: W',' ',W,nAtom,1)
      End If
      T = Zero
      Do 10 iAtom = 1, nAtom
         T=T+W(iAtom)
 10   Continue
      Do 20 iCar = 1, 3
         CoF(iCar) = Zero
         Do 21 iAtom = 1, nAtom
            CoF(iCar)=CoF(iCar) + Coor(iCar,iAtom)*W(iAtom)
 21      Continue
         If (T.ne.Zero) Then
            CoF(iCar)= CoF(iCar) / T
         Else
            CoF(iCar)= Zero
         End If
 20   Continue
      If (iPrint.ge.99) Then
         Call RecPrt(' In CoW: CoF',' ',CoF,1,3)
         Call RecPrt(' In CoW: T',' ',[T],1,1)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993,2000, Markus P. Fuelscher                         *
!               1993, Per-Olof Widmark                                 *
!***********************************************************************

subroutine PKR8(iOpt,nData,nByte,InBuf,OutBuf)
!***********************************************************************
!                                                                      *
!     purpose: pack the incoming buffer of double precision floating   *
!              point number into the outgoing buffer.                  *
!                                                                      *
!    Calling parameters:                                               *
!    iOpt  : Bit switch                                                *
!            bits 0-3 used for packing algorithm                       *
!    nData : number of unpacked integrals                              *
!    nByte : length of pack array in bytes                             *
!    InBuf : on input unpacked double precision floating point numbers *
!            (the content of this buffer is destroyed on output!)      *
!    OutBuf: contains packed numbers  on output                        *
!                                                                      *
!    Local data declarations:                                          *
!    Round : Table of constant used for rounding                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher and P. O. Widmark                                 *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     replacement of packing routines                                  *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 2000                                 *
!                                                                      *
!***********************************************************************

use, intrinsic :: iso_c_binding, only: c_loc
use Pack_mod, only: Init_do_setup_e, isPack, PkThrs
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iOpt, nData
integer(kind=iwp), intent(out) :: nByte
real(kind=wp), intent(in) :: InBuf(*)
real(kind=wp), intent(_OUT_) :: OutBuf(*)
integer(kind=iwp) :: Kase, nComp

!----------------------------------------------------------------------*
! If no packing is desired copy the data from                          *
! the input buffer to the output buffer                                *
!----------------------------------------------------------------------*

if (.not. isPack) then
  OutBuf(1:nData) = InBuf(1:nData)
  nByte = 8*nData
  return
end if

!----------------------------------------------------------------------*
! Pack the data and transfer the result from                           *
! the input buffer to the output buffer                                *
!----------------------------------------------------------------------*

!call pkERI(nData,PkThrs,nByte,InBuf,OutBuf)
Kase = ibits(iOpt,0,4)
if (Kase == 0) then
  call tce_r8_wrapper(InBuf,nData,OutBuf,nComp,PkThrs,Init_do_setup_e)
  Init_do_setup_e = 0
  nByte = nComp
else
  call rle_r8(InBuf,nData,OutBuf,nComp,PkThrs)
  nByte = 8*nComp
end if

!----------------------------------------------------------------------*
!     exit                                                             *
!----------------------------------------------------------------------*

return

contains

subroutine tce_r8_wrapper(in_,n_in,out_,n_out,thr,Init_do_setup_e)

  real(kind=wp), intent(in) :: in_(*), thr
  integer(kind=iwp), intent(in) :: n_in, Init_do_setup_e
  real(kind=wp), target, intent(_OUT_) :: out_(*)
  integer(kind=iwp), intent(out) :: n_out
  interface
    subroutine tce_r8(in_,n_in,out_,n_out,thr,Init_do_setup_e) bind(C,name='tce_r8_')
      use, intrinsic :: iso_c_binding, only: c_ptr
      use Definitions, only: MOLCAS_C_INT, MOLCAS_C_REAL
      real(kind=MOLCAS_C_REAL) :: in_(*), thr
      integer(kind=MOLCAS_C_INT) :: n_in, n_out, Init_do_setup_e
      type(c_ptr), value :: out_
    end subroutine tce_r8
  end interface

  call tce_r8(in_,n_in,c_loc(out_),n_out,thr,Init_do_setup_e)

end subroutine tce_r8_wrapper

end subroutine PKR8

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine read_binary_aniso( nss, nstate, multiplicity, eso,
     &                              esfs, U, MM, MS, ML, DM, angmom,
     &                              edmom, amfi, HSO )
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer            :: nss, nstate
      Integer            :: multiplicity(nstate)
      Real(kind=8)      :: eso(nss), esfs(nstate)
      Real(kind=8)      :: angmom(3,nstate,nstate)
      Real(kind=8)      ::  edmom(3,nstate,nstate)
      Real(kind=8)      ::   amfi(3,nstate,nstate)
      Complex(kind=8)   :: MM(3,nss,nss), MS(3,nss,nss), ML(3,nss,nss)
      Complex(kind=8)   :: DM(3,nss,nss)
      Complex(kind=8)   ::   U(nss,nss)
      Complex(kind=8)   :: HSO(nss,nss)
      ! local variables:
#include "stdalloc.fh"
      Integer            :: i, j, l
      Integer            :: luaniso, idisk, idum(1)
      Real(kind=8)      :: g_e
      Real(kind=8), allocatable :: tmpR(:,:), tmpI(:,:)

      g_e=2.0023193043718_wp
      ! initialize:
      multiplicity=0
      eso=0.0_wp
      esfs=0.0_wp
      angmom=0.0_wp
       edmom=0.0_wp
        amfi=0.0_wp
      U =(0.0_wp,0.0_wp)
      MS=(0.0_wp,0.0_wp)
      ML=(0.0_wp,0.0_wp)
      MM=(0.0_wp,0.0_wp)
      DM=(0.0_wp,0.0_wp)
      HSO=(0.0_wp,0.0_wp)
      luaniso=8
      idisk=0
      ! get the information from binary "$project.aniso" file:
      Call daname(luaniso,'POLYFILE')
      Call idafile(luaniso,2,idum,1,idisk)
      nstate=idum(1)
      Call idafile(luaniso,2,idum,1,idisk)
      nss=idum(1)

      Call mma_allocate(tmpR,nss,nss,'tmpR')
      Call mma_allocate(tmpI,nss,nss,'tmpI')

      Call idafile(luaniso,2,multiplicity,nstate,idisk)
      Call ddafile(luaniso,2,eso,nss,idisk)
      Call ddafile(luaniso,2,esfs,nstate,idisk)

      ! spin-orbit mixing coefficients:
      tmpR=0.0_wp
      tmpI=0.0_wp
      Call ddafile(luaniso,2,tmpR,nss**2,idisk)
      Call ddafile(luaniso,2,tmpI,nss**2,idisk)
      Do i=1,nss
        Do j=1,nss
          U(i,j)=cmplx(tmpR(i,j),tmpI(i,j),wp)
        End Do
      End Do

      ! spin-orbit Hamiltonian
      tmpR=0.0_wp
      tmpI=0.0_wp
      Call ddafile(luaniso,2,tmpR,nss**2,idisk)
      Call ddafile(luaniso,2,tmpI,nss**2,idisk)
      Do i=1,nss
        Do j=1,nss
          HSO(i,j)=cmplx(tmpR(i,j),tmpI(i,j),wp)
        End Do
      End Do

      ! angmom
      Call ddafile(luaniso,3,angmom,3*nstate*nstate,idisk)
      ! edmom
      Call ddafile(luaniso,3, edmom,3*nstate*nstate,idisk)
      ! amfi
      Call ddafile(luaniso,3,  amfi,3*nstate*nstate,idisk)

      ! magnetic moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Call ddafile(luaniso,2,tmpR,nss**2,idisk)
        Call ddafile(luaniso,2,tmpI,nss**2,idisk)
        Do i=1,nss
          Do j=1,nss
            MM(l,i,j)=cmplx(tmpR(i,j),tmpI(i,j),wp)
          End Do
        End Do
      End Do

      ! spin moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Call ddafile(luaniso,2,tmpR,nss**2,idisk)
        Call ddafile(luaniso,2,tmpI,nss**2,idisk)
        Do i=1,nss
          Do j=1,nss
            MS(l,i,j)=cmplx(tmpR(i,j),tmpI(i,j),wp)
          End Do
        End Do
      End Do
      ! generate magnetic moment on the fly:
      Do l=1,3
        Do i=1,nss
          Do j=1,nss
            ML(l,i,j)=-MM(l,i,j)-g_e*MS(l,i,j)
          End Do
        End Do
      End Do

      ! electric dipole moment
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Call ddafile(luaniso,2,tmpR,nss**2,idisk)
        Call ddafile(luaniso,2,tmpI,nss**2,idisk)
        Do i=1,nss
          Do j=1,nss
            DM(l,i,j)=cmplx(tmpR(i,j),tmpI(i,j),wp)
          End Do
        End Do
      End Do

      Call mma_deallocate(tmpR)
      Call mma_deallocate(tmpI)
      Call daclos(luaniso)

      Return
      End Subroutine read_binary_aniso



      Subroutine write_binary_aniso( nss, nstate, multiplicity, eso,
     &                               esfs, U, MM, MS, DM, ANGMOM,
     &                               EDMOM, AMFI, HSO )
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Integer            :: nss, nstate
      Integer            :: multiplicity(nstate)
      Real(kind=8)      :: eso(nss), esfs(nstate)
      Real(kind=8)      :: angmom(3,nstate,nstate)
      Real(kind=8)      ::  edmom(3,nstate,nstate)
      Real(kind=8)      ::   amfi(3,nstate,nstate)
      Complex(kind=8)   :: U(nss,nss), HSO(nss,nss)
      Complex(kind=8)   :: MM(3,nss,nss), MS(3,nss,nss), DM(3,nss,nss)
      ! local variables:
#include "stdalloc.fh"
      Integer            :: i, j, l
      Integer            :: luaniso, idisk, idum(1)
      Real(kind=8), allocatable :: tmpR(:,:), tmpI(:,:)

      LUANISO=8
      ! open the binary $Project.aniso file
      Call DANAME(LUANISO,'POLYFILE')
      ! writing data to it:
      idisk=0
      idum(1)=nstate
      Call idafile(luaniso,1,idum,1,idisk)
      idum(1)=nss
      Call idafile(luaniso,1,idum,1,idisk)
      ! spin multiplicity ofthe spin free states:
      Call idafile(luaniso,1,multiplicity,nstate,idisk)
      ! spin-orbit energies:
      Call ddafile(luaniso,1,eso,nss,idisk)
      ! spin-free energies:
      Call ddafile(luaniso,1,esfs,nstate,idisk)

      Call mma_allocate(tmpR,nss,nss,'tmpR')
      Call mma_allocate(tmpI,nss,nss,'tmpI')
      ! spin-orbit mixing coefficients:
      tmpR=0.0_wp
      tmpI=0.0_wp
      Do i=1,nss
        Do j=1,nss
          tmpR(i,j)= dble( U(i,j) )
          tmpI(i,j)=aimag( U(i,j) )
        End Do
      End Do
      Call ddafile(luaniso,1,tmpR,nss*nss,idisk)
      Call ddafile(luaniso,1,tmpI,nss*nss,idisk)

      ! spin-orbit Hamiltonian
      tmpR=0.0_wp
      tmpI=0.0_wp
      Do i=1,nss
        Do j=1,nss
          tmpR(i,j)= dble( HSO(i,j) )
          tmpI(i,j)=aimag( HSO(i,j) )
        End Do
      End Do
      Call ddafile(luaniso,1,tmpR,nss*nss,idisk)
      Call ddafile(luaniso,1,tmpI,nss*nss,idisk)

      ! angmom
      Call ddafile(luaniso,1,angmom,3*nstate*nstate,idisk)
      ! edmom
      Call ddafile(luaniso,1, edmom,3*nstate*nstate,idisk)
      ! amfi
      Call ddafile(luaniso,1,  amfi,3*nstate*nstate,idisk)

      ! magnetic moment:
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do i=1,nss
          Do j=1,nss
            tmpR(i,j)= dble( MM(l,i,j) )
            tmpI(i,j)=aimag( MM(l,i,j) )
          End Do
        End Do
        Call ddafile(luaniso,1,tmpR,nss*nss,idisk)
        Call ddafile(luaniso,1,tmpI,nss*nss,idisk)
      End Do

      ! spin moment:
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do i=1,nss
          Do j=1,nss
            tmpR(i,j)= dble( MS(l,i,j) )
            tmpI(i,j)=aimag( MS(l,i,j) )
          End Do
        End Do
        Call ddafile(luaniso,1,tmpR,nss*nss,idisk)
        Call ddafile(luaniso,1,tmpI,nss*nss,idisk)
      End Do

      ! electric dipole moment:
      Do l=1,3
        tmpR=0.0_wp
        tmpI=0.0_wp
        Do i=1,nss
          Do j=1,nss
            tmpR(i,j)= dble( DM(l,i,j) )
            tmpI(i,j)=aimag( DM(l,i,j) )
          End Do
        End Do
        Call ddafile(luaniso,1,tmpR,nss*nss,idisk)
        Call ddafile(luaniso,1,tmpI,nss*nss,idisk)
      End Do

      Call mma_deallocate(tmpR)
      Call mma_deallocate(tmpI)
      ! close the binary $Project.aniso file
      Call daclos(luaniso)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Jonas Bostrom                                    *
************************************************************************

      SubRoutine Construct_WDensIII(Xaibj,LnPQRSprod,LiPQRSprod,iBatch,
     &                              jBatch,nOccLeftI,nOccLeftJ)
*
*     Jonas Bostrom, October 2008
*
*     Purpose: Construct the piece of the energy-weighted density
*              usually labeled III.
*
      use ChoMP2, only: iFirstS, LnBatOrb, LnPQprod, LiPQprod
#include "implicit.fh"
      Integer LnPQRSprod
      Real*8  Xaibj(LnPQRSprod)
      Integer LiPQRSprod(8)
      Integer iBatch, jBatch
      Integer nOccLeftI(8),nOccLeftJ(8)
#include "cholesky.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"
*
      Character*20 ThisNm
      Character*25 SecNam
      Parameter (SecNam = 'Construct_WDensIII',
     &           ThisNm = 'Construct_WDensIII')
*
      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
      iDensAllAll(i,j,k) = ip_Density(k)
     &                   +  j-1
     &                   + (nOrb(k) + nDel(k))
     &                   * (i-1)
      iWDensOccOcc(i,j,k) = ip_WDensity(k)
     &                    +  j-1
     &                    + (nOrb(k) + nDel(k))
     &                    * (i-1)
*
      iSymPQ = 1
      iSymIJ = 1
      Do iSymJ = 1, nSym
         LjOrb = Min(LnBatOrb(iSymJ,jBatch),
     &                  nOccLeftJ(iSymJ))
         Do Lj = 1, LjOrb
            iJ = iFirstS(iSymJ,jBatch) + Lj-1
            Do iSymQ = 1,nSym
               Do iQ = 1, nOrb(iSymQ) + nDel(iSymQ)
                  iSymP = MulD2h(iSymPQ,iSymQ)
                  iSymQJ = MulD2h(iSymQ,iSymJ)
                  iSymPI = iSymQJ
                  iSymP = MulD2h(iSymPQ,iSymQ)
                  Ljq = LiPQProd(iSymQ,iSymJ,jBatch)
     &                + (nFro(iSymQ) + nOcc(iSymQ)
     &                +  nVir(iSymQ) + nDel(iSymQ))
     &                * (Lj-1)
     &                + iQ
                  LpOrb = LnBatOrb(iSymP,iBatch)
                  Do Lp = 1, LpOrb
                     iP = iFirstS(iSymP,iBatch) + Lp-1
                     iSymI = MulD2h(iSymIJ,iSymJ)
                     Lpq = LiPQProd(iSymQ,iSymP,iBatch)
     &                   + (nFro(iSymQ) + nOcc(iSymQ)
     &                   +  nVir(iSymQ) + nDel(iSymQ))
     &                   * (Lp-1)
     &                   + iQ
                     Do iI = 1, nFro(iSymI) + nOcc(iSymI)
                        Lpi = LiPQProd(iSymI,iSymP,iBatch)
     &                      + (nFro(iSymI) + nOcc(iSymI)
     &                      +  nVir(iSymI) + nDel(iSymI))
     &                      * (Lp-1)
     &                      + iI
                        Lji = LiPQProd(iSymI,iSymJ,jBatch)
     &                      + (nFro(iSymI) + nOcc(iSymI)
     &                      +  nVir(iSymI) + nDel(iSymI))
     &                      * (Lj-1)
     &                      + iI
*
                        If(iBatch.eq.jBatch) Then
                           ip_pqij = LiPQRSprod(iSymPQ)
     &                             + iTri(Lji,Lpq)
                           ip_piqj = LiPQRSprod(iSymPI)
     &                             + iTri(Ljq,Lpi)
                        Else
                           ip_pqij = LiPQRSprod(iSymPQ)
     &                             + LnPQprod(iSymPQ,iBatch)
     &                             * (Lji-1) + Lpq
                           ip_piqj = LiPQRSprod(iSymPI)
     &                             + LnPQprod(iSymPI,iBatch)
     &                             * (Ljq-1) + Lpi
                        End If
*
                        X = 2.0d0 * Xaibj(ip_pqij) - Xaibj(ip_piqj)
                        Work(iWDensOccOcc(iI,iJ,iSymJ)) =
     &                       Work(iWDensOccOcc(iI,iJ,iSymJ))
     &                     - X * Work(iDensAllAll(iP,iQ,iSymQ))
*----------- Debug Comments -------------------------------------------
*                        Write(6,*) 'IJPQ', iI, iJ, iP, iQ
*                        Write(6,*) 'Symm',iSymI, iSymJ, iSymP, iSymQ
*                        Write(6,*) 'pqij', Xaibj(ip_pqij)
*                        Write(6,*) 'piqj', Xaibj(ip_piqj)
*                        Write(6,*) 'Dens',Work(iDensAllAll(iP,iQ,iSymQ))
*-----------------------------------------------------------------------

                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(nOccLeftI)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jesper Wisborg Krogh                                   *
************************************************************************
*  Set_Do_Parallel
*
*> @brief
*>   Set the variable \c Do_Real_Par (in the \c do_sync common block) to the value of \p Status
*> @author Jesper Wisborg Krogh
*>
*> @details
*> Set the variable \c Do_Real_Par (in the \c do_sync common block) to the value of \p Status.
*> Setting this variable to ``.False.`` will ensure that the code afterwards will be run
*> in serial mode even if the job is started with ``$MOLCAS_NPROCS > 1``, i.e. all tasks are done
*> on each node, and no synchronization. Setting \c Do_Real_Par to ``.True.`` will cause the
*> code to run in parallel again. The variable is initially set in the subroutine
*> ::start, where the value is ``.True.``.
*>
*> @param[in] Status Variable with the new value for \c Do_Real_Par
************************************************************************
      Subroutine Set_Do_Parallel(Status)
      Implicit None
      Logical Status
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "mpp_info.fh"
      mpp_workshare = Status .and. (mpp_nprocs.gt.1)
      If (mpp_workshare) Then
        myRank = mpp_procid
        nProcs = mpp_nprocs
      Else
        myRank = 0
        nProcs = 1
      End If
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(Status)
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2001, Jeppe Olsen                                 *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CSDTMT_GAS()
! Construct in IDTFTP list of proto type combinations in IDFTP
! Construct in ICFTP list of proto type CSF's in ICFTP
! Construct in DTOC matrix expanding proto type CSF's in terms of
! prototype combinations in DTOC
!
! Construct also array for going from lexical address of prototype det
! to address in IDFTP
!
! where MXPDBL is size of largest prototype combination block .
!
! Jeppe Olsen
!
! Changed to Combination form, June 92
! Adapted to LUCIA December 2001

use lucia_data, only: CFTP, DFTP, DTOC, IPRCIX, MAXOP, MINOP, MS2, MULTS, NPCMCNF, NPCSCNF, PSSIGN, REO_PTDT, Z_PTDT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: IALPHA, ICDCBS, ICSBS, IDET, IDTBS, IFLAG, IOPEN, IOPEN_, ITP, LSCR, MAX_DC, NNDET
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: NNCM, NNCS
#endif
integer(kind=iwp), allocatable :: iSCR2(:)
real(kind=wp), allocatable :: SCR1(:)

! Size of largest csf-sd block
MAX_DC = max(0,maxval(NPCMCNF(1:MAXOP+1)))
#ifdef _DEBUGPRINT_
write(u6,*) ' Size of largest D to C block ',MAX_DC
#endif
LSCR = max(MAX_DC,MAXOP)
LSCR = MAX_DC*MAXOP+MAXOP
call mma_allocate(SCR1,LSCR,Label='SCR1')

! Set up combinations and upper determinants

if (IPRCIX >= 5) then
  write(u6,*)
  write(u6,*) ' *************************************'
  write(u6,*) ' Generation of proto type determinants'
  write(u6,*) ' *************************************'
  write(u6,*)
end if
! Still tired of stupid compiler warnings
IDTBS = 0
ICSBS = 0
do IOPEN=0,MAXOP
  ITP = IOPEN+1
  if (IPRCIX >= 5) then
    write(u6,*)
    write(u6,'(A,I3,A)') '       Type with ',IOPEN,' open orbitals'
    write(u6,'(A)') '       **********************************'
    write(u6,*)
  end if
  if (ITP == 1) then
    IDTBS = 1
    ICSBS = 1
  else
    IDTBS = IDTBS+(IOPEN-1)*NPCMCNF(ITP-1)
    ICSBS = ICSBS+(IOPEN-1)*NPCSCNF(ITP-1)
  end if

  if (IOPEN /= 0) then
    ! Proto type combinations and branching diagram for
    ! proto type combinations
    if (MS2+1 == MULTS) then
      IFLAG = 2
      call SPNCOM(IOPEN,MS2,NNDET,DFTP(IDTBS),CFTP(ICSBS),IFLAG,PSSIGN)
      !    SPNCOM(NOPEN,MS2,NDET,IABDET,IABUPP,IFLAG,PSSIGN)
    else
      IFLAG = 1
      call SPNCOM(IOPEN,MS2,NNDET,DFTP(IDTBS),CFTP(ICSBS),IFLAG,PSSIGN)
      IFLAG = 3
      call SPNCOM(IOPEN,MULTS-1,NNDET,DFTP(IDTBS),CFTP(ICSBS),IFLAG,PSSIGN)
    end if
  end if
end do
! End of loop over number of open orbitals

! Set up z-matrices for addressing prototype determinants with
! a given number of open orbitals, and for readdressing to
! the order given in IDCNF
! Scr : largest block of 2*NOPEN + (NALPHA+1)*(NOPEN+1)
LSCR = 0
do IOPEN=MINOP,MAXOP
  if (mod(IOPEN-MS2,2) == 0) then
    IALPHA = (IOPEN+MS2)/2
    LSCR = max(2*IOPEN+(IALPHA+1)*(IOPEN+1),LSCR)
  end if
end do
call mma_allocate(iSCR2,LSCR,Label='iSCR2')

IDTBS = 1
!-jwk do IOPEN=0,MAXOP
do IOPEN=MINOP,MAXOP
  ITP = IOPEN+1
  if (ITP == 1) then
    IDTBS = 1
  else
    IDTBS = IDTBS+(IOPEN-1)*NPCMCNF(ITP-1)
  end if

  IALPHA = (IOPEN+MS2)/2
  IDET = NPCMCNF(IOPEN+1)
  !write(u6,*) ' IOPEN, IDET = ',IOPEN,IDET
  IOPEN_ = IOPEN
  call REO_PTDET(IOPEN_,IALPHA,Z_PTDT(ITP)%A,REO_PTDT(ITP)%A,DFTP(IDTBS),IDET,iSCR2)
end do

! matrix expressing csf's in terms of determinants

! Tired of compiler warnings
IDTBS = 0
ICSBS = 0
ICDCBS = 0
do IOPEN=0,MAXOP
  ITP = IOPEN+1
  if (ITP == 1) then
    IDTBS = 1
    ICSBS = 1
    ICDCBS = 1
  else
    IDTBS = IDTBS+(IOPEN-1)*NPCMCNF(ITP-1)
    ICSBS = ICSBS+(IOPEN-1)*NPCSCNF(ITP-1)
    ICDCBS = ICDCBS+NPCMCNF(ITP-1)*NPCSCNF(ITP-1)
  end if
  !if (NPCMCNF(ITP)*NPCSCNF(ITP) == 0) goto 30
  if (IPRCIX >= 5) then
    write(u6,*)
    write(u6,*) ' ***********************************'
    write(u6,*) ' CSF - SD/COMB transformation matrix'
    write(u6,*) ' ***********************************'
    write(u6,'(A)')
    write(u6,'(A,I3,A)') '  Type with ',IOPEN,' open orbitals'
    write(u6,'(A)') '  ************************************'
    write(u6,*)
  end if
  if (IOPEN == 0) then
    DTOC(ICDCBS) = One
  else
    call CSFDET(IOPEN,DFTP(IDTBS),NPCMCNF(ITP),CFTP(ICSBS),NPCSCNF(ITP),DTOC(ICDCBS),SCR1,size(SCR1),PSSIGN)
    !    CSFDET(NOPEN,IDET,NDET,ICSF,NCSF,CDC,WORK,PSSIGN)
  end if
end do
! End of loop over number of open shells

call mma_deallocate(SCR1)
call mma_deallocate(iSCR2)

#ifdef _DEBUGPRINT_
write(u6,*) ' List of CSF-SD transformation matrices'
write(u6,*) ' ======================================'
write(u6,*)
IDTBS = 1
ICSBS = 1
ICDCBS = 1
do IOPEN=0,MAXOP
  ITP = IOPEN+1
  if (ITP == 1) then
    IDTBS = 1
    ICSBS = 1
    ICDCBS = 1
  else
    IDTBS = IDTBS+(IOPEN-1)*NPCMCNF(ITP-1)
    ICSBS = ICSBS+(IOPEN-1)*NPCSCNF(ITP-1)
    ICDCBS = ICDCBS+NPCMCNF(ITP-1)*NPCSCNF(ITP-1)
  end if
  NNCS = NPCSCNF(ITP)
  NNCM = NPCMCNF(ITP)
  if ((NNCS > 0) .and. (NNCM > 0)) then
    write(u6,*) ' Number of open shells : ',IOPEN
    write(u6,*) ' Number of combinations per conf ',NNCM
    write(u6,*) ' Number of CSFs per conf         ',NNCS
    call WRTMAT(DTOC(ICDCBS),NNCM,NNCS,NNCM,NNCS)
  end if
end do
#endif

end subroutine CSDTMT_GAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine FNO_CASPT2(irc,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,vfrac,IFQCAN,DoMP2,EMP2,CMO,NCMO)
!***********************************************************************
!                                                                      *
!     Purpose:  setup of Frozen Natural Orbitals CASPT2 (FNO-CASPT2).  *
!                                                                      *
!     Author:   F. Aquilante  (Geneva, May  2008)                      *
!                                                                      *
!***********************************************************************

use InputData, only: Input
use ChoMP2, only: DeMP2, MP2_small, shf
use Molcas, only: MxBas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nFro(nSym), nIsh(nSym), nAsh(nSym), NCMO
integer(kind=iwp), intent(inout) :: nSsh(nSym), nDel(nSym), IFQCAN
real(kind=wp), intent(in) :: vfrac
logical(kind=iwp), intent(in) :: DoMP2
real(kind=wp), intent(inout) :: EMP2, CMO(NCMO)
integer(kind=iwp) :: i, iAoff, ifr, ioff, ip_X, ip_Y, ipOrbE, iSkip, iSym, ito, j, jD, joff, k, kfr, kij, koff, kto, lij, &
                     lnDel(8), lnFro(8), lnOcc(8), lnOrb(8), lnVir(8), lOff, nAct(8), nBasT, nBx, nOA, nOrb, ns_V(8), nSx, nVV
real(kind=wp) :: Delta_TrD, Dummy, STrDF, STrDP, tmp, TrDF(8), TrDP(8)
integer(kind=iwp), allocatable :: ID(:)
real(kind=wp), allocatable :: CMOX(:,:), DMAT(:), OrbE(:,:)

irc = 0
MP2_small = .false.
shf = Input%RegFNO

!----------------------------------------------------------------------*
!     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
!----------------------------------------------------------------------*

nAct(:) = 0
ns_V(:) = 0
nBasT = sum(nBas(:))
nOrb = sum(nFro(:)+nIsh(:)+nAsh(:)+nSsh(:)+nDel(:))
nVV = sum(nSsh(:)**2)
if (nBasT > mxBas) then
  write(u6,'(/6X,A)') 'The number of basis functions exceeds the present limit'
  call Abend()
end if

!----------------------------------------------------------------------*
!     Read the molecular orbitals from JobIph                          *
!----------------------------------------------------------------------*
if (IFQCAN == 0) write(u6,'(/6X,A)') 'No pseudocanonical RASSCF orbitals found! I will proceed with FDIAG values.'
call mma_allocate(CMOX,NCMO,2,Label='CMOX')
! This is not the best solution, but I wanted to avoid having to rewrite
! the indexing code below just to use the CMO array directly
CMOX(:,1) = CMO(:)
call mma_allocate(OrbE,nOrb,4,Label='OrbE')
call Get_darray('RASSCF OrbE',OrbE(:,1),nOrb)
iAoff = 0
do iSym=1,nSym
  ipOrbE = iAoff+nFro(iSym)+nIsh(iSym)
  nAct(iSym) = count(OrbE(ipOrbE+1:ipOrbE+nAsh(iSym),1) < Zero)
  iAoff = iAoff+nBas(iSym)
end do

! setup info
lnOrb(1:nSym) = nBas(:)
lnFro(1:nSym) = nFro(:)
lnOcc(1:nSym) = nIsh(:)+nAct(1:nSym)
lnVir(1:nSym) = nSsh(:)
lnDel(1:nSym) = nDel(:)
nOA = sum(lnOcc(1:nSym))

ioff = 1
joff = 1
koff = 1
do iSym=1,nSym
  ifr = ioff+nFro(iSym)
  ito = joff
  OrbE(ito:ito+lnOcc(iSym)-1,3) = OrbE(ifr:ifr+lnOcc(iSym)-1,1)
  ifr = ioff+nFro(iSym)+nIsh(iSym)+nAsh(iSym)
  ito = koff
  OrbE(ito:ito+nSsh(iSym)-1,4) = OrbE(ifr:ifr+nSsh(iSym)-1,1)
  ioff = ioff+nBas(iSym)
  joff = joff+lnOcc(iSym)
  koff = koff+nSsh(iSym)
end do
call mma_allocate(Dmat,nVV+nOA,LABEL='DMAT')
DMAT(:) = Zero
ip_X = 1
ip_Y = ip_X+nVV

call FnoCASPT2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir)
CMOX(:,2) = Zero
iOff = 0
do iSym=1,nSym
  kfr = 1+iOff+nBas(iSym)*nFro(iSym)
  kto = 1+iOff+nBas(iSym)*lnFro(iSym)
  CMOX(kto:kto+nBas(iSym)*lnOcc(iSym)-1,2) = CMOX(kfr:kfr+nBas(iSym)*lnOcc(iSym)-1,1)
  kfr = 1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
  kto = kto+nBas(iSym)*lnOcc(iSym)
  CMOX(kto:kto+nBas(iSym)*lnVir(iSym)-1,2) = CMOX(kfr:kfr+nBas(iSym)*lnVir(iSym)-1,1)
  iOff = iOff+nBas(iSym)**2
end do
call Check_Amp(nSym,lnOcc,lnVir,iSkip)
if (iSkip > 0) then
  call ChoMP2_Drv(irc,Dummy,CMOX(:,2),OrbE(:,3),OrbE(:,4),DMAT(ip_X),DMAT(ip_Y))
  if (irc /= 0) then
    write(u6,*) 'MP2 pseudodensity calculation failed !'
    call Abend()
  end if
else
  write(u6,*)
  write(u6,*) 'There are ZERO amplitudes T(ai,bj) with the given '
  write(u6,*) 'combinations of inactive and virtual orbitals !! '
  write(u6,*) 'Check your input and rerun the calculation! Bye!!'
  call Abend()
end if

! Diagonalize the pseudodensity to get natural virtual orbitals
! -------------------------------------------------------------
iOff = 0
jOff = 0
do iSym=1,nSym
  if (nSsh(iSym) > 0) then
    jD = ip_X+iOff
    ! Eigenvectors will be in increasing order of eigenvalues
    call Eigen_Molcas(nSsh(iSym),DMAT(jD),OrbE(:,2),OrbE(:,1))
    ! Reorder to get relevant eigenpairs first
    do j=1,nSsh(iSym)/2
      do i=1,nSsh(iSym)
        lij = jD-1+nSsh(iSym)*(j-1)+i
        kij = jD-1+nSsh(iSym)**2-(nSsh(iSym)*j-i)
        tmp = DMAT(lij)
        DMAT(lij) = DMAT(kij)
        DMAT(kij) = tmp
      end do
      tmp = OrbE(j,2)
      OrbE(j,2) = OrbE(nSsh(iSym)-j+1,2)
      OrbE(nSsh(iSym)-j+1,2) = tmp
    end do

    ! Compute new MO coeff. : X=C*U
    kfr = 1+jOff+nBas(iSym)*(nFro(iSym)+lnOcc(iSym))
    kto = 1+jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
    call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym),One,CMOX(kfr,2),nBas(iSym),DMAT(jD),nSsh(iSym),Zero,CMOX(kto,1),nBas(iSym))
    iOff = iOff+nSsh(iSym)**2
    TrDF(iSym) = sum(OrbE(1:nSsh(iSym),2))
    if (vfrac >= Zero) then
      ns_V(iSym) = int(vfrac*nSsh(iSym))
      TrDP(iSym) = sum(OrbE(1:ns_V(iSym),2))
    else
      ns_V(iSym) = nSsh(iSym)-1
      TrDP(iSym) = sum(OrbE(1:ns_V(iSym),2))
      Delta_TrD = TrDP(iSym)-TrDF(iSym) ! this is negative
      Delta_TrD = Delta_TrD/TrDF(iSym)
      do while (Delta_TrD > vfrac)
        ns_V(iSym) = ns_V(iSym)-1
        TrDP(iSym) = sum(OrbE(1:ns_V(iSym),2))
        Delta_TrD = (TrDP(iSym)-TrDF(iSym))/TrDF(iSym)
      end do
    end if
  end if
  jOff = jOff+nBas(iSym)**2
end do
write(u6,*) '------------------------------------------------------'
write(u6,*) '   Symm.     Trace     (Full Dmat)     (Partial Dmat) '
write(u6,*) '------------------------------------------------------'
STrDF = Zero
STrDP = Zero
do iSym=1,nSym
  write(u6,'(4X,I4,15X,G13.6,4X,G13.6)') iSym,TrDF(iSym),TrDP(iSym)
  STrDF = STrDF+TrDF(iSym)
  STrDP = STrDP+TrDP(iSym)
end do
write(u6,*) '------------------------------------------------------'
write(u6,'(A,G13.6,4X,G13.6)') '   Sum :               ',STrDF,STrDP
write(u6,*) '------------------------------------------------------'

! Update the nSsh, nDel for FNO-CASPT2
nDel(:) = nDel(:)+nSsh(:)-ns_V(1:nSym)
nSsh(:) = ns_V(1:nSym)

! Write the resorted MOs back to JobIph

IFQCAN = 0 ! MOs need to be recanonicalized on exit
CMO(:) = CMOX(:,1)

! Reset MP2_small for this new call to ChoMP2_Drv
call Check_Amp(nSym,lnOcc,nSsh,iSkip)
MP2_small = DoMP2 .and. (iSkip > 0)
if (MP2_small) then

  call FnoCASPT2_putInf(nSym,lnOrb,lnOcc,lnFro,nDel,nSsh)

  call mma_allocate(iD,nOrb,Label='iD')
  iD(:) = [(k,k=1,nOrb)]
  lOff = 1
  kOff = 1
  jOff = 1
  iOff = 0
  do iSym=1,nSym  ! canonical orb. in the reduced virtual space
    jD = ip_X+iOff
    call Get_Can_Lorb(OrbE(lOff,4),OrbE(jOff,1),nSsh(iSym),lnVir(iSym),iD,DMAT(jD))

    kfr = kOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
    kto = kOff+nBas(iSym)*(nFro(iSym)+lnOcc(iSym))
    nBx = max(1,nBas(iSym))
    nSx = max(1,nSsh(iSym))
    call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym),One,CMOX(kfr,1),nBx,DMAT(jD),nSx,Zero,CMOX(kto,2),nBx)

    lOff = lOff+lnVir(iSym)
    kOff = kOff+nBas(iSym)**2
    jOff = jOff+nSsh(iSym)
    iOff = iOff+lnVir(iSym)**2
  end do
  call mma_deallocate(iD)

  EMP2 = DeMP2
  DeMP2 = Zero
  call ChoMP2_Drv(irc,Dummy,CMOX(:,2),OrbE(:,3),OrbE(:,1),DMAT(ip_X),DMAT(ip_Y))
  if (irc /= 0) then
    write(u6,*) 'MP2 in truncated virtual space failed !'
    call Abend()
  end if
  EMP2 = -One*(EMP2-DeMP2)
end if
call mma_deallocate(Dmat)
call mma_deallocate(OrbE)

call mma_deallocate(CMOX)

end subroutine FNO_CASPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Rs2Dmm(xyz2D,nArg,lRys,nabMax,ncdMax,PAWP,QCWQ,
     &                 B10,laa,B00,lac,B01,lcc,
     &                 la,lb,lc,ld,IfHss,ifgrd)
************************************************************************
*                                                                      *
* Object: to compute the 2-dimensional integrals of the Rys            *
*         quadrature. The z components are assumed to be pre-          *
*         conditioned with the weights of the roots of the             *
*         Rys polynomial.                                              *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
* Modified loop structure for RISC 1991 R. Lindh Dept. of Theoretical  *
* Chemistry, University of Lund, Sweden.                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
c#include "print.fh"
      Real*8 xyz2D(nArg*lRys,3,0:nabMax,0:ncdMax),
     &       PAWP(nArg*lRys,3), QCWQ(nArg*lRys,3),
     &       B10(nArg*lRys,3), B00(nArg*lRys,3),
     &       B01(nArg*lRys,3)
      Logical IfGrd(3,4),ifhss(4,3,4,3)
*     Character*30 Label
*
c     iRout = 15
c     iPrint = nPrint(iRout)
*     If (iPrint.ge.99) Then
*        If (nabMax.gt.0) Call RecPrt('PAWP',' ',PAWP,nArg,lRys*3)
*        If (ncdMax.gt.0) Call RecPrt('QCWQ',' ',QCWQ,nArg,lRys*3)
*        If (laa.ne.0) Call RecPrt(' B10',' ',B10,nArg*lRys,3)
*        If (lac.ne.0) Call RecPrt(' B00',' ',B00,nArg*lRys,3)
*        If (lcc.ne.0) Call RecPrt(' B01',' ',B01,nArg*lRys,3)
*     End If
*
*     Compute 2D integrals with index (0,0). Observe that the z
*     component already contains the weight factor.
*
      call dcopy_(2*nArg*lRys,[One],0,xyz2D(1,1,0,0),1)
*
*     Compute 2D integrals with index (i,0)
*
      Do 200 iCar = 1, 3
      llab = 0
      llcd = 0
      if (IfHss(2,iCar,2,iCar).or.
     &               IfHss(1,iCar,1,iCar)) llab=2
      if (IfGrd(iCar,2).or.IfGrd(iCar,1))
     &                llab=Max(llab,1)
      if (IfHss(3,iCar,3,iCar).or.
     &               IfHss(4,iCar,4,iCar)) llcd=2
      if (IfGrd(iCar,3).or.IfGrd(iCar,4))
     &                llcd=Max(llcd,1)

      mabMax = la + lb + llab
      mcdMax = lc + ld + llcd
*
      If (mabMax.ne.0) Then
         Do 201 i = 1, nArg*lRys
            xyz2D(i,iCar,1,0) = PAWP(i,iCar) * xyz2D(i,iCar,0,0)
 201     Continue
      End If
      If (mabMax-1.eq.1) Then
         Do 210 i = 1, nArg*lRys
            xyz2D(i,iCar,2,0) = PAWP(i,iCar) * xyz2D(i,iCar,1,0)
     &                       + B10(i,iCar) * xyz2D(i,iCar,0,0)
 210     Continue
      Else If (mabMax-1.gt.1) Then
         Fact = One
         Do 250 iab = 1, mabMax-1
            Do 260 i = 1, nArg*lRys
               temp1 = PAWP(i,iCar) * xyz2D(i,iCar,iab,0)
               temp2 = Fact * B10(i,iCar) * xyz2D(i,iCar,iab-1,0)
               xyz2D(i,iCar,iab+1,0) = temp1 + temp2
 260        Continue
            Fact = Fact + One
 250     Continue
      End If
*
*     Compute 2D integrals with index (0,i)
*
      If (mcdMax.ne.0) Then
         Do 301 i = 1, nArg*lRys
            xyz2D(i,iCar,0,1) = QCWQ(i,iCar) * xyz2D(i,iCar,0,0)
 301     Continue
      End If
      If (mcdMax-1.eq.1) Then
         Do 310 i = 1, nArg*lRys
            xyz2D(i,iCar,0,2) = QCWQ(i,iCar) * xyz2D(i,iCar,0,1)
     &                       + B01(i,iCar) * xyz2D(i,iCar,0,0)
 310     Continue
      Else If (mcdMax-1.gt.1) Then
         Fact = One
         Do 350 icd = 1, mcdMax-1
            Do 360 i = 1, nArg*lRys
               temp1 = QCWQ(i,iCar) * xyz2D(i,iCar,0,icd)
               temp2 = Fact * B01(i,iCar) * xyz2D(i,iCar,0,icd-1)
               xyz2D(i,iCar,0,icd+1) = temp1 + temp2
 360        Continue
            Fact = Fact + One
 350     Continue
      End If
*
*     Compute 2D integrals with index (i,iCar,j)
*
      If (mcdMax.le.mabMax) Then
         Fac1 = One
         Do 400 icd = 1, mcdMax
            Do 425 i = 1, nArg*lRys
               xyz2D(i,iCar,1,icd)=PAWP(i,iCar)*xyz2D(i,iCar,0,icd)
     &                     + Fac1 * B00(i,iCar)*xyz2D(i,iCar,0,icd-1)
 425        Continue
            If (mabMax-1.eq.1) Then
               Do 420 i = 1, nArg*lRys
                  xyz2D(i,iCar,2,icd)=PAWP(i,iCar)*xyz2D(i,iCar,1,icd)
     &                              +  B10(i,iCar)*xyz2D(i,iCar,0,icd)
     &                         + Fac1 *B00(i,iCar)*xyz2D(i,iCar,1,icd-1)
 420           Continue
            Else If (mabMax-1.gt.1) Then
               Fac2 = One
               Do 450 iab = 1, mabMax-1
                  Do 460 i = 1, nArg*lRys
                     temp1 = PAWP(i,iCar) * xyz2D(i,iCar,iab,icd)
                     temp2 = Fac2 *B10(i,iCar) *xyz2D(i,iCar,iab-1,icd)
                     temp3 = Fac1 *B00(i,iCar) *xyz2D(i,iCar,iab,icd-1)
                     xyz2D(i,iCar,iab+1,icd) = temp1 + temp2 + temp3
 460              Continue
                  Fac2 = Fac2 + One
 450           Continue
            End If
            Fac1 = Fac1 + One
 400     Continue
      Else
         Fac1 = One
         Do 500 iab = 1, mabMax
            Do 525 i = 1, nArg*lRys
               xyz2D(i,iCar,iab,1)=QCWQ(i,iCar)*xyz2D(i,iCar,iab,0)
     &                      + Fac1 *B00(i,iCar)*xyz2D(i,iCar,iab-1,0)
 525        Continue
            If (mcdMax-1.eq.1) Then
               Do 520 i = 1, nArg*lRys
                  xyz2D(i,iCar,iab,2)=QCWQ(i,iCar)*xyz2D(i,iCar,iab,1)
     &                              + B01(i,iCar) *xyz2D(i,iCar,iab,0)
     &                         + Fac1 *B00(i,iCar)*xyz2D(i,iCar,iab-1,1)
 520           Continue
            Else If (mcdMax-1.gt.1) Then
               Fac2 = One
               Do 550 icd = 1, mcdMax-1
                  Do 560 i = 1, nArg*lRys
                     temp1 = QCWQ(i,iCar) *xyz2D(i,iCar,iab,icd)
                     temp2 = Fac2 *B01(i,iCar) *xyz2D(i,iCar,iab,icd-1)
                     temp3 = Fac1 *B00(i,iCar) *xyz2D(i,iCar,iab-1,icd)
                     xyz2D(i,iCar,iab,icd+1) = temp1 + temp2 + temp3
 560              Continue
                  Fac2 = Fac2 + One
 550           Continue
            End If
            Fac1 = Fac1 + One
 500     Continue
      End If
 200  Continue
*
*     If (iPrint.ge.99) Then
*        Do 600 iab = 0, nabMax
*           Do 610 icd = 0, ncdMax
*              Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(x)'
*              Call RecPrt(Label,' ',xyz2D(1,1,iab,icd),nArg,lRys)
*              Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(y)'
*              Call RecPrt(Label,' ',xyz2D(1,2,iab,icd),nArg,lRys)
*              Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(z)'
*              Call RecPrt(Label,' ',xyz2D(1,3,iab,icd),nArg,lRys)
*610        Continue
*600     Continue
*     End If
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(laa)
         Call Unused_integer(lac)
         Call Unused_integer(lcc)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Convrg(iter,kIter,nInter,iStop,MxItr,mIntEff,mTtAtm,GoOn,Step_Trunc,Just_Frequencies)

use Slapaf_Info, only: Analytic_Hessian, ApproxNADC, Baker, Coor, Cx, dqInt, E_Delta, EDiffZero, eMEPTest, Energy, FindTS, GNrm, &
                       GrdMax, Gx, HUpMet, iNeg, iOptC, Lbl, MaxItr, MEP, NADC, nLambda, nMEP, Numerical, qInt, rMEP, SlStop, &
                       ThrCons, ThrEne, ThrGrd, ThrMEP

#ifdef _DEBUGPRINT_
use Slapaf_Info, only: Shift
#endif
use Chkpnt, only: Chkpnt_update_MEP
use PrintLevel, only: nPrint
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Four, Six, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iter, kIter, nInter, MxItr, mIntEff, mTtAtm
integer(kind=iwp), intent(out) :: iStop
logical(kind=iwp), intent(in) :: GoOn, Just_Frequencies
character, intent(in) :: Step_Trunc
integer(kind=iwp) :: i, iFile, iMEP, iOff_Iter, iPrint, IRC, iRout, iSaddle, iSaddle_p, iSaddle_r, iter_S, j, jSaddle, kkIter, &
                     LuInput, nAtom, nBackward, nConst, nForward, nIRC, nSaddle, nSaddle_Max
real(kind=wp) :: CumLen, E, E0, E1, E2, E_Prod, E_Reac, echng, eDiffMEP, Fabs, Maxed, MaxErr, prevDist, rDum(1,1,1,1), refDist, &
                 ResGrad, RMS, RMSMax, Thr1, Thr2, Thr3, Thr4, Thr5, Val1, Val2, Val3, Val4, Val5
logical(kind=iwp) :: BadConstraint, Conv1, Conv2, ConvTmp, eTest, Found, IRCRestart, Last_Energy, Saddle, Terminate, TSReg, TurnBack
character(len=80) :: Point_Desc
character(len=16) :: MEP_Text, StdIn
character(len=5) :: ConLbl(5)
character(len=8) :: Temp
integer(kind=iwp), allocatable :: Information(:)
real(kind=wp), allocatable :: C_IRC(:,:,:), C_P(:,:), C_R(:,:), C_S(:,:,:), Coor1(:,:), Coor2(:,:), Cu_MEP(:), E_IRC(:), E_MEP(:), &
                              E_P(:), E_R(:), E_S(:), G_IRC(:,:,:), G_MEP(:,:,:), G_P(:,:), G_R(:,:), G_S(:,:,:), L_MEP(:), Tmp(:)
real(kind=wp), allocatable, target :: C_MEP(:,:,:), OfRef(:,:)
integer(kind=iwp), external :: IsFreeUnit

#include "warnings.h"

!                                                                      *
!***********************************************************************
!                                                                      *
nAtom = size(Cx,2)
TSReg = btest(iOptC,13)
!                                                                      *
!***********************************************************************
!                                                                      *
nSaddle_Max = 100
iRout = 116
iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
call RecPrt('Convrg: Energy',' ',Energy,1,iter)
call RecPrt('Convrg: Shift',' ',Shift,nInter,iter)
call RecPrt('Convrg: qInt',' ',qInt,nInter,iter+1)
call RecPrt('Convrg: dqInt',' ',dqInt,nInter,iter)
call RecPrt('Convrg: Cx',' ',Cx,3*nAtom,iter+1)
call RecPrt('Convrg: Gx',' ',Gx,3*nAtom,iter+1)
#endif

call Get_iScalar('Saddle Iter',iter_S)
if (iter_S == 0) then
  iter_S = 1
  call Put_iScalar('Saddle Iter',iter_S)
  call f_Inquire('RUNFILE2',Found)
  if (Found) then
    call NameRun('RUNFILE2')
    call Put_iScalar('Saddle Iter',iter_S)
    call NameRun('#Pop')
  end if
end if
Temp = ' '
if (Analytic_Hessian) then
  if ((HUPMET == '  No  ') .or. (HUPMET == ' None ')) then
    !Temp = 'Analytic'
    Temp = 'Computed'
  else
    Temp(1:6) = HUPMET(1:6)
  end if
else
  Temp(1:6) = HUPMET(1:6)
end if

call mma_allocate(Coor1,3,mTtAtm,Label='Coor1')
call mma_allocate(Coor2,3,mTtAtm,Label='Coor2')
call AtmLst(Cx(:,:,iter),nAtom,Coor1,mTtAtm)
call AtmLst(Cx(:,:,iter+1),nAtom,Coor2,mTtAtm)
call OptRMS_Slapaf(Coor1,Coor2,mTtAtm,RMS,RMSMax)
call mma_deallocate(Coor1)
call mma_deallocate(Coor2)

if ((kIter /= iter) .and. (kIter == 1)) then
  Fabs = GNrm(kiter)
  E = Energy(kiter)
else
  Fabs = GNrm(iter)
  E = Energy(iter)
end if
Fabs = max(Zero,Fabs)
E0 = E+E_delta
Energy(iter+1) = E0
Gx(:,:,iter+1) = Zero
if (kiter == 1) then
  eChng = Zero
else
  if ((kIter /= iter) .and. (kIter == 2)) then
    eChng = Energy(iter)-Energy(1)
  else
    eChng = Energy(iter)-Energy(iter-1)
  end if
end if

eDiffMEP = Zero
if (MEP .or. rMEP) then
  Saddle = .false.
  iMEP = 0
  call Qpg_iScalar('nMEP',Found)
  if (Found) call Get_iScalar('nMEP',iMEP)
  if (iMEP == 0) then
    iOff_Iter = 0
    call Put_iScalar('iOff_Iter',iOff_Iter)
  else
    call Get_iScalar('iOff_Iter',iOff_Iter)
  end if
else
  iOff_Iter = 0
  iSaddle = 0
  call qpg_dArray('Saddle',Saddle,nSaddle)
  Saddle = Saddle .and. (.not. Just_Frequencies)
  if (Saddle) then
    call Qpg_iScalar('nMEP',Found)
    if (Found) call Get_iScalar('nMEP',iSaddle)
    call Get_iScalar('iOff_Iter',iOff_Iter)
  end if
end if

! Convergence criteria
!
! Too many iterations
!
! or
!
! 1) a la Baker
!      Abs(GrdMax) < ThrGrd
!      and
!      Abs(eChng) < ThrEne or RMSMax < ThrGrd
!
! 2) a la Gaussian
!      Abs(Fabs/Sqrt(mIntEff)) < ThrGrd
!      and
!      Abs(GrdMax) < ThrGrd*1.5
!      and
!      ((RMS < ThrGrd*4
!        and
!        RMSMax < ThrGrd*6)
!       or
!       Abs(eChng) < ThrEne)

if (Baker) then
  Val1 = abs(eChng)
  Thr1 = ThrEne
  if (kIter <= 1) then
    ConLbl(1) = ' --- '
  else if (Val1 < Thr1) then
    ConLbl(1) = ' Yes '
  else
    ConLbl(1) = ' No  '
  end if
  Val2 = RMSMax
  Thr2 = ThrGrd
  if (Val2 < Thr2) then
    if (Step_Trunc /= ' ') then
      ConLbl(2) = ' No *'
    else
      ConLbl(2) = ' Yes '
    end if
  else
    ConLbl(2) = ' No  '
  end if
  Val3 = abs(GrdMax)
  Thr3 = ThrGrd
  if (Val3 < Thr3) then
    ConLbl(3) = ' Yes '
  else
    ConLbl(3) = ' No  '
  end if
  Conv1 = (Val1 < Thr1) .and. (kIter > 1)
  Conv1 = Conv1 .or. ((Val2 < Thr2) .and. (Step_Trunc == ' '))
  Conv1 = Conv1 .and. (Val3 < Thr3)
else
  Val2 = abs(Fabs/sqrt(real(mIntEff,kind=wp)))
  Thr2 = ThrGrd
  Conv1 = Val2 < Thr2
  if (Conv1) then
    ConLbl(2) = ' Yes '
  else
    ConLbl(2) = ' No  '
  end if
  Conv1 = Conv1 .and. (abs(GrdMax) < ThrGrd*1.5_wp)
  Val4 = abs(GrdMax)
  Thr4 = ThrGrd*1.5_wp
  ConvTmp = Val4 < Thr4
  Conv1 = Conv1 .and. ConvTmp
  if (ConvTmp) then
    ConLbl(4) = ' Yes '
  else
    ConLbl(4) = ' No  '
  end if
  Conv2 = (RMS < ThrGrd*Four) .and. (Step_Trunc == ' ')
  Val1 = RMS
  Thr1 = ThrGrd*Four
  ConvTmp = Val1 < Thr1
  Conv2 = ConvTmp .and. (Step_Trunc == ' ')
  if (ConvTmp) then
    if (Step_Trunc /= ' ') then
      ConLbl(1) = ' No *'
    else
      ConLbl(1) = ' Yes '
    end if
  else
    ConLbl(1) = ' No  '
  end if
  Val3 = RMSMax
  Thr3 = ThrGrd*Six
  ConvTmp = Val3 < Thr3
  Conv2 = Conv2 .and. ConvTmp
  if (ConvTmp) then
    if (Step_Trunc /= ' ') then
      ConLbl(3) = ' No *'
    else
      ConLbl(3) = ' Yes '
    end if
  else
    ConLbl(3) = ' No  '
  end if
  Val5 = abs(eChng)
  Thr5 = ThrEne
  ConvTmp = (Val5 < Thr5) .and. (kIter > 1)
  if (ConvTmp) then
    ConLbl(5) = ' Yes '
  else
    if (kIter > 1) then
      ConLbl(5) = ' No  '
    else
      ConLbl(5) = ' --- '
    end if
  end if
  Conv2 = Conv2 .or. ConvTmp
  Conv1 = Conv1 .and. Conv2
end if

SlStop = Conv1 .or. (kIter-iOff_Iter >= MxItr) ! CGG
iStop = 1
if (kIter-iOff_Iter >= MxItr) iStop = 16     ! CGG
if (Conv1 .or. Just_Frequencies) iStop = 0

if (GoOn) then
  SlStop = .false.
  iStop = 1
else
  if (Just_Frequencies) SlStop = .true.
  nPrint(52) = nPrint(52)+1
  nPrint(54) = nPrint(54)+1
  iPrint = iPrint+1
  nPrint(53) = nPrint(53)+1
end if
if (.not. Just_Frequencies) call SlStatus(kIter-iOff_Iter,E,Fabs,E0,MaxItr-1,eChng,Temp,Step_Trunc,.not. Numerical)

if (Baker) then
  if (iPrint >= 5) then
    write(u6,'(A)') '                +----------------------------------+'
    write(u6,'(A)') '                +  Value      Threshold Converged? +'
    write(u6,'(A)') '+---------------+----------------------------------+'
    write(u6,4) '+ Max. gradient +',Val3,' ',Thr3,'    ',ConLbl(3),'  +'
    write(u6,'(A)') '+---------------+----------------------------------+'
    write(u6,4) '+ Max. disp.    +',Val2,' ',Thr2,'    ',ConLbl(2),'  +'
    write(u6,'(A)') '+---------------+----------------------------------+'
    write(u6,4) '+ Energy diff.  +',Val1,' ',Thr1,'    ',ConLbl(1),'  +'
    write(u6,'(A)') '+---------------+----------------------------------+'
  end if
else
  if (iPrint >= 5) then
    write(u6,'(A)') '       +----------------------------------+----------------------------------+'
    write(u6,'(A)') '       +    Cartesian Displacements       +    Gradient in internals         +'
    write(u6,'(A)') '       +  Value      Threshold Converged? +  Value      Threshold Converged? +'
    write(u6,'(A)') ' +-----+----------------------------------+----------------------------------+'
    write(u6,5) ' + RMS +',Val1,' ',Thr1,'    ',ConLbl(1),'  +',Val2,' ',Thr2,'    ',ConLbl(2),'  +'
    write(u6,'(A)') ' +-----+----------------------------------+----------------------------------+'
    write(u6,5) ' + Max +',Val3,' ',Thr3,'    ',ConLbl(3),'  +',Val4,' ',Thr4,'    ',ConLbl(4),'  +'
    write(u6,'(A)') ' +-----+----------------------------------+----------------------------------+'
    if (ThrEne > Zero) then
      write(u6,5) ' + dE  +',Val5,' ',Thr5,'    ',ConLbl(5),'  +'
      write(u6,'(A)') ' +-----+----------------------------------+'
    end if
    write(u6,*)
  end if
end if

if (SlStop .and. Conv1) then
  call Qpg_dScalar('Max error',Found)
  if (Found) call Get_dScalar('Max error',MaxErr)
  if (MaxErr > ThrCons) then
    iStop = 1
    Conv1 = .false.
    SlStop = .false.
    write(u6,'(A,ES11.4)') 'Maximum constraint error: ',MaxErr
    write(u6,*)
  end if
end if

nConst = 0
if (iNeg(1) == 0) then
  if (EDiffZero) then
    if (NADC) then
      nConst = 2
    else
      nConst = 1
    end if
    Point_Desc = 'Minimum Energy Crossing Point Structure'
  else
    Point_Desc = 'Minimum Structure'
  end if
else if (iNeg(1) == 1) then
  Point_Desc = 'Transition State Structure'
else
  Point_Desc = 'Higher Order Saddle Point Structure'
end if
if (nLambda > nConst) Point_Desc = 'Constrained '//trim(Point_Desc)
if (iPrint >= 5) then
  if (SlStop) then
    if (Conv1) then
      write(u6,'(A,I3,A)') ' Geometry is converged in ',kIter-iOff_iter,' iterations to a '//trim(Point_Desc)
    else
      write(u6,'(A)') ' No convergence after max iterations'
      if (u6 /= u6) write(u6,'(/A)') ' No convergence after max iterations'
    end if
  else
    write(u6,'(A)') ' Convergence not reached yet!'
  end if
end if
if (FindTS .and. SlStop .and. Conv1) then
  if (.not. TSReg) then
    if (iPrint >= 5) then
      write(u6,*)
      write(u6,'(A)') ' FindTS was requested, but the TS regime was not reached.'
      write(u6,'(A)') ' The converged structure is probably not the desired TS.'
    end if
    iStop = 16
  end if
end if
!if (iPrint == 7) then
!  write(u6,*)
!  write(u6,'(A)') '********************************* Geometry Statistics for Geometry Optimization '// &
!                  '*********************************'
!  nPrint(118) = 7
!  call List(' Internal coordinates ',Lbl,qInt,nInter,iter+1)
!  call List(' Internal forces    ',Lbl,dqInt,nInter,iter)
!end if

! The energy change should not be too large
Maxed = 1.0e2_wp
if (abs(E_Delta) > Maxed) then
  write(u6,*) 'The predicted energy change is too large: ',E_Delta
  write(u6,'(A)') ' This can''t be right!'
  write(u6,'(A)') ' This job will be terminated.'
  iStop = 8
  SlStop = .true.
end if
if (iPrint >= 5) then
  write(u6,*)
  write(u6,'(A)') '********************************************************'// &
                  '*********************************************************'
  write(u6,'(A)') '********************************************************'// &
                  '*********************************************************'
end if
!                                                                      *
!***********************************************************************
!                                                                      *
Terminate = .false.
IRCRestart = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
! Write summary of conical intersection characterization data

if (Conv1 .and. NADC .and. EDiffZero) then
  if (iPrint >= 5) then
    if (.not. ApproxNADC) call CI_Summary(u6)
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Book keeping for Saddle optimization for a TS. Note that this will
! have to be done on both of the runfiles!

if (Conv1 .and. Saddle) then

  ! Here if a macro iteration in the Saddle TS optimization is completed.

  !ENew = Energy(iter)+E_Delta
  call mma_allocate(Tmp,nSaddle,Label='Tmp')

  ! Store the info for later generation of MOLDEN formated files

  call Get_dArray('Saddle',Tmp,nSaddle)
  E_Reac = Tmp(6*nAtom+1)
  E_Prod = Tmp(6*nAtom+2)

  call mma_allocate(E_S,nSaddle_Max,Label='E_S')
  call mma_allocate(C_S,3,nAtom,nSaddle_Max,Label='C_S')
  call mma_allocate(G_S,3,nAtom,nSaddle_Max,Label='G_S')
  if (iSaddle == 0) then

    ! Initiate with data from the starting points

    E_S(:) = Zero
    C_S(:,:,:) = Zero
    G_S(:,:,:) = Zero
    iSaddle = 1
    if (E_Reac <= E_Prod) then
      E_S(iSaddle) = E_Reac
      C_S(:,:,iSaddle) = reshape(Tmp(1:3*nAtom),[3,nAtom])
    else
      E_S(iSaddle) = E_Prod
      C_S(:,:,iSaddle) = reshape(Tmp(3*nAtom+1:6*nAtom),[3,nAtom])
    end if

  else

    call Get_dArray('MEP-Energies',E_S,nSaddle_Max)
    call Get_dArray('MEP-Coor',C_S,3*nAtom*nSaddle_Max)
    call Get_dArray('MEP-Grad',G_S,3*nAtom*nSaddle_Max)

  end if

  ! Add the new data

  iSaddle = iSaddle+1
  E_S(iSaddle) = Energy(iter)
  C_S(:,:,iSaddle) = Cx(:,:,iter)
  G_S(:,:,iSaddle) = Gx(:,:,iter)

  ! Put data on RUNFILE

  call Put_dArray('MEP-Energies',E_S,nSaddle_Max)
  call Put_dArray('MEP-Coor',C_S,3*nAtom*nSaddle_Max)
  call Put_dArray('MEP-Grad',G_S,3*nAtom*nSaddle_Max)
  call Put_iScalar('nMEP',iSaddle)

  call mma_deallocate(G_S)
  call mma_deallocate(C_S)
  call mma_deallocate(E_S)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Now update the "Saddle" field on both runfiles.

  do iFile=1,2

    if (iFile == 1) then
      call NameRun('RUNREAC')
    else
      call NameRun('RUNPROD')
    end if

    ! Update info on the runfile.

    call Get_dArray('Saddle',Tmp,nSaddle)
    E1 = Tmp(6*nAtom+1)
    E2 = Tmp(6*nAtom+2)
    !write(u6,*) 'ENew=',ENew
    !write(u6,*) 'E1,E2=',E1,E2
    if (E1 <= E2) then
      !write(u6,*) 'Update reactant'
      Tmp(6*nAtom+1) = Energy(iter)
      E1 = Energy(iter)
      Tmp(1:3*nAtom) = reshape(Cx(:,:,iter),[3*nAtom])
    else
      !write(u6,*) 'Update product'
      Tmp(6*nAtom+2) = Energy(iter)
      E2 = Energy(iter)
      Tmp(3*nAtom+1:6*nAtom) = reshape(Cx(:,:,iter),[3*nAtom])
    end if
    ! Set flag that seward should process the info! This should not
    ! be done for the final macro iteration.
    if (.not. FindTS) Tmp(6*nAtom+5) = One
    call Put_dArray('Saddle',Tmp,nSaddle)

  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Converged or not, create the saddle.molden file
  ! after each macro iteration

  call NameRun('RUNREAC')
  call mma_allocate(E_r,nSaddle_Max,Label='E_r')
  call mma_allocate(C_r,3*nAtom,nSaddle_Max,Label='C_r')
  call mma_allocate(G_r,3*nAtom,nSaddle_Max,Label='G_r')
  call Qpg_iScalar('nMEP',Found)
  if (Found) then
    call Get_dArray('MEP-Energies',E_r,nSaddle_Max)
    call Get_dArray('MEP-Coor',C_r,3*nAtom*nSaddle_Max)
    call Get_dArray('MEP-Grad',G_r,3*nAtom*nSaddle_Max)
    call Get_iScalar('nMEP',iSaddle_r)
  else
    E_r(1) = E_Reac
    C_r(:,1) = Tmp(1:3*nAtom)
    G_r(:,:) = Zero
    iSaddle_r = 1
  end if

  call NameRun('RUNPROD')
  call mma_allocate(E_p,nSaddle_Max,Label='E_p')
  call mma_allocate(C_p,3*nAtom,nSaddle_Max,Label='C_p')
  call mma_allocate(G_p,3*nAtom,nSaddle_Max,Label='G_p')
  call Qpg_iScalar('nMEP',Found)
  if (Found) then
    call Get_dArray('MEP-Energies',E_p,nSaddle_Max)
    call Get_dArray('MEP-Coor',C_p,3*nAtom*nSaddle_Max)
    call Get_dArray('MEP-Grad',G_p,3*nAtom*nSaddle_Max)
    call Get_iScalar('nMEP',iSaddle_p)
  else
    E_p(1) = E_Prod
    C_p(:,1) = Tmp(3*nAtom+1:6*nAtom)
    G_p(:,:) = Zero
    iSaddle_p = 1
  end if

  ! Merge the two lists

  jSaddle = iSaddle_r
  do iSaddle=iSaddle_p,1,-1
    jSaddle = jSaddle+1
    E_r(jSaddle) = E_p(iSaddle)
    C_r(:,jSaddle) = C_p(:,iSaddle)
    G_r(:,jSaddle) = G_p(:,iSaddle)
  end do
  call mma_deallocate(G_p)
  call mma_deallocate(C_p)
  call mma_deallocate(E_p)

  ! Align the structures sequentially, only for visualization
  ! (gradients are not changed, though)
  ! TODO: Rotate the gradients too

  do iSaddle=1,iSaddle_r+iSaddle_p-1
    call Align(C_r(:,iSaddle+1),C_r(:,iSaddle),nAtom)
  end do

  call Intergeo('MD_SADDLE',E_r,C_r,G_r,nAtom,iSaddle_r+iSaddle_p)

  call mma_deallocate(G_r)
  call mma_deallocate(C_r)
  call mma_deallocate(E_r)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! If the Saddle TS optimization is not yet completed set up
  ! data for the next macro iteration.

  if (.not. FindTS) then
    call mma_deallocate(Tmp)
    !write(u6,*) 'Reset $SubProject'

    ! Reset $SubProject for the next macro iteration.

    LuInput = 11
    LuInput = IsFreeUnit(LuInput)
    call StdIn_Name(StdIn)
    call Molcas_Open(LuInput,StdIn)
    if (E1 <= E2) then
      write(LuInput,'(A)') '> EXPORT SubProject=.Reac'
      !write(u6,*) 'SubProject=.Reac'
      call NameRun('RUNREAC')
    else
      write(LuInput,'(A)') '> EXPORT SubProject=.Prod'
      !write(u6,*) 'SubProject=.Prod'
      call NameRun('RUNPROD')
    end if

    ! Signal whether next iteration will be the first in the branch

    call Qpg_iScalar('nMEP',Found)
    if (.not. Found) write(LuInput,'(A)') '> EXPORT SADDLE_FIRST=1'
    write(LuInput,'(A,I3)') '> EXIT ',_RC_CONTINUE_LOOP_
    close(LuInput)

    ! Set flags to request yet another macro iteration.

    Terminate = .false.
    iStop = 6
    SlStop = .false.
  else
    call NameRun('RUNFILE')
    call mma_deallocate(Tmp)
    nSaddle = 0
    call Put_dArray('Saddle',[Zero],nSaddle)
    call Put_iScalar('nMEP',nSaddle)
  end if

  ! Update the active runfile wrt the total number of micro
  ! iterations done in all macro iterations of this branch.

  call NameRun('RUNFILE')
  call Put_iScalar('iOff_Iter',iter)
end if

! Disable first iteration signal right after the first iteration
! (in each branch)

if ((.not. Conv1) .and. Saddle) then
  if ((iter == 1) .and. (iStop == 1)) then
    LuInput = 11
    LuInput = IsFreeUnit(LuInput)
    call StdIn_Name(StdIn)
    call Molcas_Open(LuInput,StdIn)
    write(LuInput,'(A)') '> EXPORT SADDLE_FIRST=0'
    write(LuInput,'(A,I3)') '> EXIT ',_RC_CONTINUE_LOOP_
    close(LuInput)
    iStop = 6
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Book keeping for minimum energy path search

IRC = 0
call Qpg_iScalar('IRC',Found)
if (Found) call Get_iScalar('IRC',IRC)

TurnBack = .false.
if (MEP .or. rMEP) then
  if (Conv1) then

    ! Is this the first iteration or not?

    iMEP = iMEP+1

    ! Save information for the current step

    call mma_allocate(E_MEP,nMEP+1,Label='E_MEP')
    call mma_allocate(C_MEP,3,nAtom,nMEP+1,Label='C_MEP')
    call mma_allocate(G_MEP,3,nAtom,nMEP+1,Label='G_MEP')
    if (iMEP > 1) then
      call Get_dArray('MEP-Energies',E_MEP,nMEP+1)
      call Get_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
      call Get_dArray('MEP-Grad',G_MEP,3*nAtom*(nMEP+1))
    else
      E_MEP(:) = Zero
      C_MEP(:,:,:) = Zero
      G_MEP(:,:,:) = Zero
      E_MEP(iMEP) = Energy(iOff_iter+1)
      C_MEP(:,:,iMEP) = Cx(:,:,iOff_iter+1)
      G_MEP(:,:,iMEP) = Gx(:,:,iOff_iter+1)
    end if

    E_MEP(iMEP+1) = Energy(iter)
    C_MEP(:,:,iMEP+1) = Cx(:,:,iter)
    G_MEP(:,:,iMEP+1) = Gx(:,:,iter)
    call Put_dArray('MEP-Energies',E_MEP,nMEP+1)
    call Put_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
    call Put_dArray('MEP-Grad',G_MEP,3*nAtom*(nMEP+1))
    call Put_iScalar('nMEP',iMEP)

    ! Save the path so far (energies, coordinates and forces)

    call Intergeo('MD_MEP',E_MEP,C_MEP,G_MEP,nAtom,iMEP+1)

    ! Compute energy difference and RMS between last two structures

    eDiffMEP = E_MEP(iMEP+1)-E_MEP(iMEP)
    call mma_allocate(Coor1,3,mTtAtm,Label='Coor1')
    call mma_allocate(Coor2,3,mTtAtm,Label='Coor2')
    call AtmLst(C_MEP(:,:,iMEP),nAtom,Coor1,mTtAtm)
    call AtmLst(C_MEP(:,:,iMEP+1),nAtom,Coor2,mTtAtm)
    call OptRMS_Slapaf(Coor1,Coor2,mTtAtm,RMS,RMSMax)
    call mma_deallocate(Coor1)
    call mma_deallocate(Coor2)

    call mma_deallocate(G_MEP)
    call mma_deallocate(C_MEP)
    call mma_deallocate(E_MEP)

  else

    ! Test for "turn back", i.e. when the trial structure
    ! is getting too close to the previous converged structure,
    ! this may be an indication of an ill-behaved constraint
    if (iMEP >= 1) then
      call mma_allocate(C_MEP,3,nAtom,nMEP+1,Label='C_MEP')
      call mma_allocate(OfRef,3,nAtom,Label='OfRef')
      call mma_Allocate(Tmp,3*nAtom,Label='Tmp')
      call Get_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
      OfRef(:,:) = C_MEP(:,:,iMEP+1)

      ! Using hypersphere measure, even with "transverse" MEPs,
      ! this should not be a problem
      call SphInt(Cx(:,:,iter),nAtom,OfRef,.false.,refDist,Tmp,.false.,'dummy   ',rDum,.false.)
      call SphInt(Cx(:,:,iter),nAtom,OfRef,.true.,prevDist,Tmp,.false.,'dummy   ',rDUm,.false.)
      if (prevDist < Half*refDist) then
        TurnBack = .true.
        Conv1 = .true.
        SlStop = .true.
        iStop = 0
        Terminate = .true.
      end if
      call mma_deallocate(Tmp)
      call mma_deallocate(OfRef)
      call mma_deallocate(C_MEP)
    end if

  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! List internal coordinates and gradients

kkIter = iter+1
if (iPrint >= 8) then
  call List(' Internal coordinates ',Lbl,qInt,nInter,kkIter)
  call List(' Internal forces    ',Lbl,dqInt,nInter,iter)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Put out the new reference structure and the new starting
! structure to be used for the next MEP point.
! For rMEP keep the reference structure!
! Note that this is done in weighted Cartesian coordinates!

if ((Conv1 .or. (iter == 1)) .and. (MEP .or. rMEP)) then
  if ((iMEP >= 1) .and. (iPrint >= 5)) then
    write(u6,*)
    call CollapseOutput(1,'IRC/Minimum Energy Path Information')
  end if

  ResGrad = huge(ResGrad)
  if (.not. Terminate) then
    BadConstraint = .false.
    call MEP_Dir(Cx,Gx,nAtom,iMEP,iOff_iter,iPrint,IRCRestart,ResGrad,BadConstraint)
    Coor(:,:) = Cx(:,:,iter+1)
    call Put_iScalar('iOff_Iter',iter)
  end if

  if (MEP) then
    if (IRC == 0) then
      MEP_Text = 'MEP'
    else if (IRC == 1) then
      MEP_Text = 'IRC(forward)'
    else
      MEP_Text = 'IRC(backward)'
    end if
  else if (rMEP) then
    MEP_Text = 'rMEP'
  else
    MEP_Text = ''
  end if

  ! Should we terminate or not? Not done on the first iteration.

  if (iMEP > 0) then

    ! Test for energy increase (optionally disabled).
    eTest = eMEPTest .and. (eDiffMEP > Zero)
    if ((MEP .and. eTest) .and. (.not. Terminate)) then
      Terminate = .true.
      if (iPrint >= 5) then
        write(u6,*)
        write(u6,'(A)') ' '//trim(MEP_Text)//'-search terminated due to energy increase!'
        write(u6,*)
      end if
    end if

    ! Test for energy decrease (optionally disabled).
    eTest = eMEPTest .and. (eDiffMEP < Zero)
    if ((rMEP .and. eTest) .and. (.not. Terminate)) then
      Terminate = .true.
      if (iPrint >= 5) then
        write(u6,*)
        write(u6,'(A)') ' '//trim(MEP_Text)//'-search terminated due to energy decrease!'
        write(u6,*)
      end if
    end if

    ! Test for small gradient.
    if ((iMEP > 1) .or. (IRC == 0)) then
      if ((ResGrad < ThrMEP) .and. (.not. Terminate)) then
        Terminate = .true.
        if (iPrint >= 5) then
          write(u6,*)
          write(u6,'(A)') ' '//trim(MEP_Text)//'-search terminated due to small gradient!'
          write(u6,*)
        end if
      end if
    end if

    ! Test for small step.
    if ((RMS < ThrGrd*Four) .and. (.not. Terminate)) then
      Terminate = .true.
      if (iPrint >= 5) then
        write(u6,*)
        write(u6,'(A)') ' '//trim(MEP_Text)//'-search terminated due to small geometry change!'
        write(u6,*)
      end if
    end if

    ! Test for max number of points.
    if ((iMEP >= nMEP) .and. (.not. Terminate)) then
      Terminate = .true.
      if (iPrint >= 5) then
        write(u6,*)
        write(u6,'(A)') ' '//trim(MEP_Text)//'-search terminated due to max number of path points!'
        write(u6,*)
      end if
    end if

    ! Test for constraint misbehavior.
    if ((BadConstraint .and. (.not. Terminate)) .or. TurnBack) then
      Terminate = .true.
      if (iPrint >= 5) then
        write(u6,*)
        write(u6,'(A)') ' '//trim(MEP_Text)//'-search terminated due to problematic constraint!'
        write(u6,*)
      end if
    end if

    ! If IRC reset for backward IRC search.

    if (Terminate .and. (IRC == 1)) IRCRestart = .true.

  end if

  if (Conv1) call Chkpnt_update_MEP(.not. TurnBack,IRCRestart)

  if (Conv1 .and. Terminate) then
    if (IRC /= 0) then
      call mma_allocate(E_MEP,nMEP+1,Label='E_MEP')
      call mma_allocate(C_MEP,3,nAtom,nMEP+1,Label='C_MEP')
      call mma_allocate(G_MEP,3,nAtom,nMEP+1,Label='G_MEP')
      call Get_dArray('MEP-Energies',E_MEP,nMEP+1)
      call Get_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
      call Get_dArray('MEP-Grad',G_MEP,3*nAtom*(nMEP+1))
      if (IRC == 1) then
        IRCRestart = .true.
        IRC = -1
        call Put_iScalar('IRC',IRC)

        ! Store away data for IRC molden file. Forward part.

        call Put_dArray('IRC-Energies',E_MEP,iMEP+1)
        call Put_dArray('IRC-Coor',C_MEP,3*nAtom*(iMEP+1))
        call Put_dArray('IRC-Grad',G_MEP,3*nAtom*(iMEP+1))
        call Put_dArray('Ref_Geom',Cx,3*nAtom)

        ! Write a temporary file
        ! (will be overwritten when the backward part is done)

        call Intergeo('MD_IRC',E_MEP,C_MEP,G_MEP,nAtom,iMEP+1)

        Terminate = .false.

      else if (IRC == -1) then

        ! Assemble molden file for IRC

        nBackward = iMEP+1
        call qpg_dArray('IRC-Energies',Found,nForward)
        nIRC = nForward+nBackward-1
        call mma_allocate(E_IRC,nIRC,Label='E_IRC')
        call mma_allocate(C_IRC,3,nAtom,nIRC,Label='C_IRC')
        call mma_allocate(G_IRC,3,nAtom,nIRC,Label='G_IRC')

        j = 0
        do i=nBackward,1,-1
          j = j+1
          E_IRC(j) = E_MEP(i)
          C_IRC(:,:,j) = C_MEP(:,:,i)
          G_IRC(:,:,j) = G_MEP(:,:,i)
        end do

        call Get_dArray('IRC-Energies',E_IRC(nBackward),nForward)
        call Get_dArray('IRC-Coor',C_IRC(:,:,nBackward:nIRC),nForward*3*nAtom)
        call Get_dArray('IRC-Grad',G_IRC(:,:,nBackward:nIRC),nForward*3*nAtom)

        call Intergeo('MD_IRC',E_IRC,C_IRC,G_IRC,nAtom,nIRC)

        call mma_deallocate(G_IRC)
        call mma_deallocate(C_IRC)
        call mma_deallocate(E_IRC)
      end if

      call mma_deallocate(G_MEP)
      call mma_deallocate(C_MEP)
      call mma_deallocate(E_MEP)
    end if
  end if

  if (.not. Terminate) then
    iStop = 1
    SlStop = .false.
  end if

  ! Print out the path so far

  if ((iMEP >= 1) .and. (iPrint >= 5)) then
    call mma_allocate(E_MEP,nMEP+1,Label='E_MEP')
    call mma_allocate(C_MEP,3,nAtom,nMEP+1,Label='C_MEP')
    call mma_allocate(L_MEP,nMEP+1,Label='L_MEP')
    call mma_allocate(Cu_MEP,nMEP+1,Label='Cu_MEP')
    call Get_dArray('MEP-Energies',E_MEP,nMEP+1)
    call Get_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
    call Get_dArray('MEP-Lengths',L_MEP,nMEP+1)
    call Get_dArray('MEP-Curvatures',Cu_MEP,nMEP+1)
    write(u6,*)
    CumLen = Zero
    if (Cu_MEP(1+iMEP) >= Zero) then
      write(u6,*) '         Cumul.'
      write(u6,*) 'Point  Length (bohr)       Energy  Curvature'
      write(u6,*) '--------------------------------------------'
      do i=0,iMEP
        CumLen = CumLen+L_MEP(1+i)
        write(u6,200) i,CumLen,E_MEP(1+i),Cu_MEP(1+i)
      end do
    else
      write(u6,*) '         Cumul.'
      write(u6,*) 'Point  Length (bohr)       Energy'
      write(u6,*) '---------------------------------'
      do i=0,iMEP
        CumLen = CumLen+L_MEP(1+i)
        write(u6,200) i,CumLen,E_MEP(1+i)
      end do
    end if
    if (iPrint > 6) then
      write(u6,*)
      do i=0,iMEP
        call RecPrt(' Coordinates',' ',C_MEP(:,:,i+1),3,nAtom)
      end do
    end if
    call CollapseOutput(0,'IRC/Minimum Energy Path Information')
    write(u6,*)
    call mma_deallocate(E_MEP)
    call mma_deallocate(C_MEP)
    call mma_deallocate(L_MEP)
    call mma_deallocate(Cu_MEP)
  end if

end if

if (IRCRestart) then

  ! Prepare the runfile to start from Scratch

  iMEP = 0
  call Put_iScalar('nMEP',iMEP)
  call mma_allocate(Information,7,Label='Information')
  Information(:) = 0
  Information(1) = -99     ! Deactivate the record
  call Put_iArray('Slapaf Info 1',Information,7)
  call mma_deallocate(Information)
  iOff_Iter = 0
  call Put_iScalar('iOff_Iter',iOff_Iter)

  ! Restore data

  call Put_dScalar('Last Energy',Energy(1))
  call Put_dArray('GRAD',Gx,3*nAtom)
  call Put_dArray('Unique Coordinates',Cx,3*nAtom)
  call Put_Coord_New(Cx,nAtom)
  Coor(:,:) = Cx(:,:,1)
  Cx(:,:,iter+1) = Cx(:,:,1)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Figure out if the last energy should be computed!

Last_Energy = SlStop .and. (iStop /= 16) .and. (iStop /= 8)
Last_Energy = Last_Energy .and. (.not. MEP) .and. (.not. rMEP)
Last_Energy = Last_Energy .and. (.not. (Numerical .and. (kIter == 1)))
if (Last_Energy) iStop = 2
!                                                                      *
!***********************************************************************
!                                                                      *
! Write geometry file for MOLDEN. Note that this file should not be
! generated if Slapaf is running new geometries for any numerical
! procedure!

if ((.not. Just_Frequencies) .and. (.not. Numerical)) then
  call Write_QMMM(Cx,nAtom,iter)
  call Intergeo('MD_GEO',Energy,Cx,Gx,nAtom,iter+1)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

4 format(A,2(ES11.4,A),A,A)
5 format(A,2(2(ES11.4,A),A,A))
200 format(1X,I5,1X,F10.6,1X,F16.8,1X,F10.6)

end subroutine Convrg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE DIATERM2_GAS( FACTOR,  ITASK,    VEC, NBLOCK, IBLOCK,
     &                           IOFF,  JPERT,    J12,    JDC)
* = DIATERM_GAS, just J12 added !
*
* Obtain VEC = (DIAGONAL + FACTOR) ** -1 VEC (ITASK = 1)
* Obtain VEC = (DIAGONAL + FACTOR)       VEC (ITASK = 2)
*
* For the NBLOCKS givem in IBLOCK starting from BLOCK IOFF
*
* If JPERT.NE.0, the perturbation operator as defined by IPART is used.
*
* Jeppe Olsen, August 1995
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "mxpdim.fh"
#include "orbinp.fh"
#include "cicisp.fh"
#include "strbas.fh"
#include "cstate.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "csm.fh"
#include "WrkSpc.fh"
#include "cprnt.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "glbbas.fh"
#include "oper.fh"
#include "cecore.fh"
*
#include "cintfo.fh"
*
      INTEGER IBLOCK(8,*)
*
      DIMENSION VEC(*)
*
      IDUM=0
*
      NTEST = 000
      NTEST = MAX(NTEST,IPRDIA)
*
      IATP = 1
      IBTP = 2
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*
*. Offsets for alpha and beta supergroups
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
*
C     IF(JPERT.EQ.0) THEN
*. Use full Hamiltonian
C       I12 = 2
C       IPERTOP = 0
C     ELSE
*. Use perturbation operator
C       IF(IPART.EQ.1) THEN
*. Moller-Plesset partitioning
C         I12 = 1
C         IPERTOP = 1
C       ELSE IF(IPART.EQ.2) THEN
*. Epstein-Nesbet Partitioning
C         I12 = 2
C         IPERTOP = 0
C       END IF
C     END IF

      IF(NTEST.GE.10) THEN
        WRITE(6,*) ' ========================='
        WRITE(6,*) '   DIATERM2_GAS speaking '
        WRITE(6,*) ' ========================='
        WRITE(6,*) ' IATP IBTP NAEL NBEL ',IATP,IBTP,NAEL,NBEL
        write(6,*) ' NOCTPA NOCTPB  : ', NOCTPA,NOCTPB
        write(6,*) ' IOCTPA IOCTPB  : ', IOCTPA,IOCTPB
        WRITE(6,*) ' JPERT,IPART,J12,IPERTOP',JPERT,J12,IPERTOP
      END IF
*. A bit of scracth
      CALL GETMEM('KLJ   ','ALLO','REAL',KLJ   ,NTOOB**2)
      CALL GETMEM('KLK   ','ALLO','REAL',KLK   ,NTOOB**2)
      CALL GETMEM('KLSC2 ','ALLO','REAL',KLSCR2,2*NTOOB**2)
      CALL GETMEM('KLXB  ','ALLO','REAL',KLXB  ,NACOB)
      CALL GETMEM('KLH1D ','ALLO','REAL',KLH1D ,NACOB)
*. Space for blocks of strings
      CALL GETMEM('KLASTR','ALLO','INTE',KLASTR,MXNSTR*NAEL)
      CALL GETMEM('KLBSTR','ALLO','INTE',KLBSTR,MXNSTR*NAEL)
      MAXA = IMNMX(IWORK(KNSTSO(IATP)),NSMST*NOCTPA,2)
      CALL GETMEM('KLRJKA','ALLO','REAL',KLRJKA,MAXA)
*. Diagonal of one-body integrals and coulomb and exchange integrals
*. Integrals assumed in place so :
C!    IF(IPERTOP.NE.0) CALL SWAPVE(WORK(KFI),WORK(KINT1),NINT1)
      CALL GT1DIA(WORK(KLH1D))
C!    IF(IPERTOP.NE.0) CALL SWAPVE(WORK(KFI),WORK(KINT1),NINT1)
      IF(J12.EQ.2)
     &CALL GTJK(WORK(KLJ),WORK(KLK),NTOOB,WORK(KLSCR2),IREOTS,IREOST)
*. Core energy not included
      ECOREP = 0.0D0
      SHIFT = ECORE_ORIG-ECORE
      FACTORX = FACTOR + SHIFT
      CALL DIATERMS_GAS(NAEL,IWORK(KLASTR),NBEL,IWORK(KLBSTR),
     &                  NACOB,VEC,NSMST,
     &                  WORK(KLH1D),JDC,WORK(KLXB),WORK(KLJ),WORK(KLK),
     &                  iWORK(KNSTSO(IATP)),iWORK(KNSTSO(IBTP)),
     &                  ECOREP,0,0,IPRDIA,NTOOB,WORK(KLRJKA),J12,
     &                  IBLOCK(1,IOFF),NBLOCK,ITASK, FACTORX,0,[0])
*
C    &                  IBLOCK,NBLOCK,ITASK,FACTOR,I0CHK,I0BLK)
*.Flush local memory
      CALL GETMEM('KLJ   ','FREE','REAL',KLJ   ,NTOOB**2)
      CALL GETMEM('KLK   ','FREE','REAL',KLK   ,NTOOB**2)
      CALL GETMEM('KLSC2 ','FREE','REAL',KLSCR2,2*NTOOB**2)
      CALL GETMEM('KLXB  ','FREE','REAL',KLXB  ,NACOB)
      CALL GETMEM('KLH1D ','FREE','REAL',KLH1D ,NACOB)
      CALL GETMEM('KLASTR','FREE','INTE',KLASTR,MXNSTR*NAEL)
      CALL GETMEM('KLBSTR','FREE','INTE',KLBSTR,MXNSTR*NAEL)
      CALL GETMEM('KLRJKA','FREE','REAL',KLRJKA,MAXA)
*
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*)  ' output vector from DIATRM '
        CALL WRTTTS(      VEC,IBLOCK(1,IOFF),NBLOCK,  NSMST,
     &                 IWORK(KNSTSO(IATP)),IWORK(KNSTSO(IBTP)),IDC)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pr_ito_int(npair,i_pair,lmax,nexch,nneq,neqv,itype,neq,nmax,soe,MM,SM,rot,Dipol,AnisoLines1,AnisoLines3,AnisoLines9, &
                      DM_exchange,JITO_exchange,HLIN1,HLIN3,HLIN9,HDIP,HDMO,HITO)
! this function prints the parameters of the exchange interaction in an accessible format

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: npair, i_pair(npair,2), lmax, nneq, nexch(nneq), neqv, neq(nneq), nmax
character, intent(in) :: itype(nneq)
real(kind=wp), intent(in) :: soe(nneq,nmax), rot(nneq,neqv,3,3)
complex(kind=wp), intent(in) :: MM(nneq,3,nmax,nmax), SM(nneq,3,nmax,nmax), HLIN1(npair,nmax,nmax,nmax,nmax), &
                                HLIN3(npair,nmax,nmax,nmax,nmax), HLIN9(npair,nmax,nmax,nmax,nmax), &
                                HDIP(npair,nmax,nmax,nmax,nmax), HDMO(npair,nmax,nmax,nmax,nmax), HITO(npair,nmax,nmax,nmax,nmax)
logical(kind=iwp), intent(in) :: Dipol, AnisoLines1, AnisoLines3, AnisoLines9, DM_exchange, JITO_exchange
! local variables
integer(kind=iwp) :: i, i1, i2, ibuf, j, k, k1, k2, l, lb1, lb2, lp, n1, n2, nind(lmax,2), q1, q2
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: is1, is2, js1, js2
#endif
real(kind=wp) :: g1(3), g2(3), J1C(3,3), J1Cr(3,3), mg1(3,3), mg2(3,3), RDI, RDM, RIT, RL1, RL3, RL9
complex(kind=wp) :: J_tmp(-1:1,-1:1)
complex(kind=wp), allocatable :: HTMP(:,:,:,:), JB(:,:,:,:), JN(:,:,:,:), JS(:,:,:,:), MM_tmp1(:,:,:), MM_tmp2(:,:,:)
!real(kind=wp), parameter :: cm_to_MHz = cm_s*1.0e-6_wp
real(kind=wp), external :: dznrm2_

#include "macros.fh"
unused_var(SM)
#ifndef _DEBUGPRINT_
unused_var(itype)
unused_var(soe)
unused_var(rot)
#endif

! some initializations:
l = 0
do i=1,nneq
  do j=1,neq(i)
    l = l+1
    nind(l,1) = i
    nind(l,2) = j
  end do
end do
nind(l+1:,:) = 0

ibuf = npair*nmax*nmax*nmax*nmax
if (ibuf == 0) then
  write(u6,'(A)') 'in UTMU:   ibuf=0 !!!'
  write(u6,*) 'npair= ',npair
  write(u6,*) 'nmax = ',nmax
  call xFlush(u6)
  call xquit(128)
end if
RL1 = dznrm2_(ibuf,HLIN1,1)
RL3 = dznrm2_(ibuf,HLIN3,1)
RL9 = dznrm2_(ibuf,HLIN9,1)
RDI = dznrm2_(ibuf,HDIP,1)
RDM = dznrm2_(ibuf,HDMO,1)
RIT = dznrm2_(ibuf,HITO,1)
!ccccccccccccccccccccccccccccccc
#ifdef _DEBUGPRINT_
write(u6,'(A,i6)') ' nmax =',nmax
write(u6,'(A,i6)') ' lmax =',lmax
write(u6,'(A,i6)') 'npair =',nmax
write(u6,'(A,i6)') ' nneq =',nneq
write(u6,'(20A)') ' itype =',(itype(i),i=1,nneq)
write(u6,'(A)') 'i_pair'
do i=1,npair
  write(u6,'(2I5)') i_pair(i,1),i_pair(i,2)
end do
write(u6,'(A)') 'equivalent sites'
do i=1,nneq
  write(u6,'(A,i2,A,i4)') 'neq(',i,') =',neq(i)
end do
write(u6,'(A)') 'exchange basis'
do i=1,nneq
  write(u6,'(A,i2,A,i4)') 'nexch(',i,') =',nexch(i)
end do
write(u6,'(A)') 'rotation matrix'
do i=1,nneq
  write(u6,'(A,i3)') 'site',i
  do j=1,neq(i)
    do l=1,3
      write(u6,'(3F12.6)') (rot(i,j,l,i1),i1=1,3)
    end do
  end do
end do
write(u6,'(A,i3)') 'site',i
write(u6,'(A)') 'magnetic moment, initial'
do i=1,nneq
  write(u6,'(A ,i3)') 'site',i
  call prMom('pr_ito_int:: magnetic moment, initial',mm(i,:,:,:),nmax)
end do
write(u6,'(A)') 'spin-orbit energies'
do i=1,nmax
  write(u6,'(1 5F14.5)') (soe(j,i),j=1,nneq)
end do

do lp=1,npair
  lb1 = i_pair(lp,1)
  lb2 = i_pair(lp,2)
  i1 = nind(lb1,1) ! indices of non-equivalent sites
  i2 = nind(lb2,1) ! indices of non-equivalent sites
  !j1 = nind(lb1,2) ! indices of equivalent sites
  !j2 = nind(lb2,2) ! indices of equivalent sites
  if (AnisoLines1 .and. (RL1 > Zero)) then
    write(u6,'(A,i5)') 'HLIN1,  interacting pair ',lp
    do is1=1,nexch(i1)
      do is2=1,nexch(i1)
        do js1=1,nexch(i2)
          write(u6,'(10(2F10.6,2x))') (HLIN1(lp,is1,is2,js1,js2),js2=1,nexch(i2))
        end do
      end do
    end do
  end if

  if (AnisoLines3 .and. (RL3 > Zero)) then
    write(u6,'(A,i5)') 'HLIN3,  interacting pair ',lp
    do is1=1,nexch(i1)
      do is2=1,nexch(i1)
        do js1=1,nexch(i2)
          write(u6,'(10(2F10.6,2x))') (HLIN3(lp,is1,is2,js1,js2),js2=1,nexch(i2))
        end do
      end do
    end do
  end if

  if (AnisoLines9 .and. (RL9 > Zero)) then
    write(u6,'(A,i5)') 'HLIN9,  interacting pair ',lp
    do is1=1,nexch(i1)
      do is2=1,nexch(i1)
        do js1=1,nexch(i2)
          write(u6,'(10(2F10.6,2x))') (HLIN9(lp,is1,is2,js1,js2),js2=1,nexch(i2))
        end do
      end do
    end do
  end if

  if (Dipol .and. (RDI > Zero)) then
    write(u6,'(A,i5)') 'HDIP,  interacting pair ',lp
    do is1=1,nexch(i1)
      do is2=1,nexch(i1)
        do js1=1,nexch(i2)
          write(u6,'(10(2F10.6,2x))') (HDIP(lp,is1,is2,js1,js2),js2=1,nexch(i2))
        end do
      end do
    end do
  end if

  if (DM_exchange .and. (RDM > Zero)) then
    write(u6,'(A,i5)') 'HDMO,  interacting pair ',lp
    do is1=1,nexch(i1)
      do is2=1,nexch(i1)
        do js1=1,nexch(i2)
          write(u6,'(10(2F10.6,2x))') (HDMO(lp,is1,is2,js1,js2),js2=1,nexch(i2))
        end do
      end do
    end do
  end if

  if (JITO_exchange .and. (RIT > Zero)) then
    write(u6,'(A,i5)') 'HITO,  interacting pair ',lp
    do is1=1,nexch(i1)
      do is2=1,nexch(i1)
        do js1=1,nexch(i2)
          write(u6,'(10(2F10.6,2x))') (HITO(lp,is1,is2,js1,js2),js2=1,nexch(i2))
        end do
      end do
    end do
  end if

end do !lp
!call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
!call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
!SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
!SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
!call prMom('SM(i1) bf Lines1',SM_tmp1,n1)
!call prMom('SM(i2) bf Lines1',SM_tmp2,n2)
!call mma_deallocate(SM_tmp1)
!call mma_deallocate(SM_tmp2)
#endif

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
write(u6,*)
write(u6,'(a)') repeat('%',100)
if ((.not. AnisoLines1) .and. (.not. AnisoLines3) .and. (.not. AnisoLines9) .and. (.not. Dipol) .and. (.not. DM_exchange) .and. &
    (.not. JITO_exchange)) then
  write(u6,'(20x,A)') 'ITO decomposition of exchange and/or dipolar couplings.'
  write(u6,'(A)') 'AnisoLines1 =  FALSE.'
  write(u6,'(A)') 'AnisoLines3 =  FALSE.'
  write(u6,'(A)') 'AnisoLines9 =  FALSE.'
  write(u6,'(A)') 'Dipol       =  FALSE.'
  write(u6,'(A)') 'JITO_exch   =  FALSE.'
  write(u6,'(A)') 'DM_exchange =  FALSE.'
  write(u6,'(A)') 'Nothing to Do.'
  return

else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. (.not. DM_exchange) .and. &
         (.not. JITO_exchange)) then
  write(u6,'(20x,A)') 'ITO decomposition of the Lines exchange interactions.'

else if ((.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9)) .and. Dipol .and. (.not. DM_exchange) .and. &
         (.not. JITO_exchange)) then
  write(u6,'(20x,A)') 'ITO decomposition of the dipolar interactions.'

else if ((AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. (.not. DM_exchange) .and. (.not. JITO_exchange)) then
  write(u6,'(20x,A)') 'ITO decomposition of exchange and/or dipolar couplings.'
else if (.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. (.not. Dipol) .and. (.not. DM_exchange) .and. &
         JITO_exchange) then
  write(u6,'(20x,A)') 'ITO decomposition of anisotropic exchange interaction. '
else if (.not. (AnisoLines1 .or. AnisoLines3 .or. AnisoLines9) .and. Dipol .and. (.not. DM_exchange) .and. JITO_exchange) then
  write(u6,'(20x,A)') 'ITO decomposition of anisotropic exchange interaction and dipolar couplings.'

end if
write(u6,'(a)') repeat('%',100)
write(u6,*)

! decompose the exchange interaction in products of ITO
! first rotate the magnetic moments to the general coordinate system:
do lp=1,npair
  lb1 = i_pair(lp,1)
  lb2 = i_pair(lp,2)
  i1 = nind(lb1,1) ! indices of non-equivalent sites
  i2 = nind(lb2,1) ! indices of non-equivalent sites
  !j1 = nind(lb1,2) ! indices of equivalent sites
  !j2 = nind(lb2,2) ! indices of equivalent sites

  n1 = nexch(i1)
  n2 = nexch(i2)
  write(u6,'(A)') 'PART 1: Magnetic exchange is written in the coordinate systems of the LOCAL main magnetic axes of the '// &
                  'interacting sites.'
  write(u6,'(A)')
  write(u6,'(A)') repeat('-',100)
  write(u6,'(A,i2)') 'Interacting pair',lp

  call mma_allocate(MM_tmp1,3,n1,n1,label='MM_tmp1')
  call mma_allocate(MM_tmp2,3,n2,n2,label='MM_tmp2')
  MM_tmp1(:,:,:) = MM(i1,:,1:n1,1:n1)
  MM_tmp2(:,:,:) = MM(i2,:,1:n2,1:n2)

  ! JN= exch. parameters in Naoya's ITO operators
  ! JL= exch. parameters in Liviu's ITO operators
  ! JS= exch. parameters in Stevens ESO operators
  call mma_allocate(JN,[1,n1-1],[-(n1-1),n1-1],[1,n2-1],[-(n2-1),n2-1],'JN')
  call mma_allocate(JB,[1,n1-1],[-(n1-1),n1-1],[1,n2-1],[-(n2-1),n2-1],'JB')
  call mma_allocate(JS,[1,n1-1],[-(n1-1),n1-1],[1,n2-1],[-(n2-1),n2-1],'JS')

  !=====================================================================
  if (AnisoLines1 .and. (RL1 > Zero)) then

    call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
    HTMP(:,:,:,:) = HLIN1(lp,1:n1,1:n1,1:n2,1:n2)
    call newjkqpar(n1,n2,HTMP,JN,JB,JS)
    call mma_deallocate(HTMP)

    ! re-write the first rank tensor in cartesian representation:
    ! using Naoya's ITO parameters
    J1Cr(:,:) = Zero
    J_tmp(:,:) = JB(1,-1:1,1,-1:1)
    call tensor2cart(J_tmp,J1C)

    ! rotate cartesian J1C matrix by mg1 and mg2, in order to represent
    ! the interaction matrix in the original coordinate system:
    call atens(MM_tmp1,n1,g1,mg1,2)
    call atens(MM_tmp2,n2,g2,mg2,2)
    do j=1,3
      do l=1,3
        do k=1,3
          J1Cr(:,j) = J1Cr(:,j)+mg1(:,l)*mg2(j,k)*J1C(l,k)
        end do
      end do
    end do

    write(u6,'(A)')
    write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction: LINES-1'
    write(u6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
    write(u6,'(A)') 'LOCAL AXES:::'
    write(u6,'(A)') 'To be used directly in exchange Hamiltonian of the kind:'
    write(u6,'(A)') ' H = -J * S1 * S2'
    write(u6,'(A)') '     (  xx   xy  xz  )  '
    write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
    write(u6,'(A)') '     (  zx   zy  zz  )  '
    do i=1,3
      write(u6,'(3ES22.14)') (-J1Cr(i,j),j=1,3)
    end do

    ! print out the data:
    write(u6,'(A)')
    write(u6,'(10x,A)') 'Parameters of the ITOs: (Liviu ITO)'
    write(u6,'( 5x,A)') 'with absolute values larger than:  0.5e-14 '
    write(u6,'(A)') '--- SITE 1 --|--- SITE 2 --|-----------------------------------------------|'
    write(u6,'(A)') ' rank | proj.| rank | proj.|           Lines  Exchange  Interaction        |'
    write(u6,'(A)') '------|------|------|------|---------- Real ----------------- Imag --------|'

    do k1=1,n1-1,2
      do q1=-k1,k1
        do k2=1,n2-1,2
          do q2=-k2,k2
            write(u6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)') k1,'|',q1,'|',k2,'|',q2,'|',JN(k1,q1,k2,q2),'|'
          end do
        end do
      end do
    end do
    write(u6,'(A)') '------|------|------|------|-----------------------------------------------|'

    !-------------------------------------------------------------------
    ! verify the back transform for HAM!:
    !call mma_allocate(HAM,n1,n1,n2,n2,'HAM')
    !
    !S1a(:,:,:) = cZero
    !S2a(:,:,:) = cZero
    !
    !call mma_allocate(tmp1,n1,n1,label='tmp1')
    !call mma_allocate(tmp2,n1,n1,label='tmp2')
    !call ESO(n1,1,1,tmp1,tmp2,redME)
    !S1b(1,1:n1,1:n1) = tmp1(:,:)
    !S1b(2,1:n1,1:n1) = tmp2(:,:)
    !call ESO(n1,1,0,tmp1,tmp2,redME)
    !S1b(3,1:n1,1:n1) = tmp1(:,:)
    !W1b(1:n1,1:n1) = tmp2(:,:)
    !S2b(:,:,:) = S1b(:,:,:)
    !call mma_deallocate(tmp1)
    !call mma_deallocate(tmp2
    !
    !call mma_allocate(SM_tmp1,3,n1,n1,label='SM_tmp1')
    !call mma_allocate(SM_tmp2,3,n2,n2,label='SM_tmp2')
    !SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
    !SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
    !call prmom('SM(i1) bf recover HAM',SM_tmp,n1)
    !call prmom('SM(i2) bf recover HAM',SM_tmp,n2)
    !
    !J1C_trans(:,:) = -J1Cr(:,:)
    !write(u6,'(/)')
    !SM_tmp1(:,:,:) = S1b(:,1:n1,1:n1)
    !SM_tmp2(:,:,:) = S2b(:,1:n2,1:n2)
    !call Aniso_Lines_Exchange9(J1C_trans,n1,n2,SM_tmp1,SM_tmp2,HAM)
    !SM_tmp1(:,:,:) = SM(i1,:,1:n1,1:n1)
    !SM_tmp2(:,:,:) = SM(i2,:,1:n2,1:n2)
    !call Aniso_Lines_Exchange9(J1C_trans,n1,n2,SM_tmp1,SM_tmp2,HAM)
    !call mma_deallocate(SM_tmp1)
    !call mma_deallocate(SM_tmp2)
    !
    !write(u6,'(A,i5)') 'HLIN1: ORIG, REGEN, DIFF:'
    !do is1=1,n1
    !  do is2=1,n1
    !    do js1=1,n2
    !      do js2=1,n2
    !        write(u6,'(4I3,3(2ES22.13,3x))') is1,is2,js1,js2,HLIN1(lp,is1,is2,js1,js2),HAM(is1,is2,js1,js2), &
    !                                         HLIN1(lp,is1,is2,js1,js2)-HAM(is1,is2,js1,js2)
    !      end do
    !    end do
    !  end do
    !end do
    !
    !call mma_deallocate(HAM)
  end if

  !====================================================================
  if (AnisoLines3 .and. (RL3 > Zero)) then

    call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
    HTMP(:,:,:,:) = HLIN3(lp,1:n1,1:n1,1:n2,1:n2)
    call newjkqpar(n1,n2,HTMP,JN,JB,JS)
    call mma_deallocate(HTMP)

    J1Cr(:,:) = Zero
    ! using Liviu's ITO parameters
    J_tmp(:,:) = JB(1,-1:1,1,-1:1)
    call tensor2cart(J_tmp,J1C)

    ! rotate cartesian JLinC1 by mg1 and mg2, in order to represent
    ! the interaction matrix in the original coordinate system:
    call atens(MM_tmp1,n1,g1,mg1,2)
    call atens(MM_tmp2,n2,g2,mg2,2)
    do j=1,3
      do l=1,3
        do k=1,3
          J1Cr(:,j) = J1Cr(:,j)+mg1(:,l)*mg2(j,k)*J1C(l,k)
        end do
      end do
    end do

    write(u6,'(A)')
    write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction: LINES-3'
    write(u6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
    write(u6,'(A)') 'LOCAL AXES:::'
    write(u6,'(A)') 'To be used directly in exchange Hamiltonian of the kind:'
    write(u6,'(A)') ' H = -J * S1 * S2'
    write(u6,'(A)') '     (  xx   xy  xz  )  '
    write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
    write(u6,'(A)') '     (  zx   zy  zz  )  '
    do i=1,3
      write(u6,'(3ES22.14)') (-J1Cr(i,j),j=1,3)
    end do

    ! print out the data:
    write(u6,'(A)')
    write(u6,'(10x,A)') 'Parameters of the ITOs: (Liviu ITO)'
    write(u6,'( 5x,A)') 'with absolute values larger than:  1.0e-21 '
    write(u6,'(A)') '--- SITE 1 --|--- SITE 2 --|-----------------------------------------------|'
    write(u6,'(A)') ' rank | proj.| rank | proj.|        Lines-3  Exchange  Interaction         |'
    write(u6,'(A)') '------|------|------|------|---------- Real ----------------- Imag --------|'
    do k1=1,N1-1,2
      do q1=-k1,k1
        do k2=1,N2-1,2
          do q2=-k2,k2
            !if (ABS(JLin3(lp,k1,q1,k2,q2)) > 1.0e-21_wp) then
            write(u6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)') k1,'|',q1,'|',k2,'|',q2,'|',JN(k1,q1,k2,q2),'|'
            !end if
          end do
        end do
      end do
    end do
    write(u6,'(A)') '------|------|------|------|-----------------------------------------------|'
  end if

  !=====================================================================
  if (AnisoLines9 .and. (RL9 > Zero)) then

    call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
    HTMP(:,:,:,:) = HLIN9(lp,1:n1,1:n1,1:n2,1:n2)
    call newjkqpar(n1,n2,HTMP,JN,JB,JS)
    call mma_deallocate(HTMP)

    J1Cr(:,:) = Zero
    J_tmp(:,:) = JB(1,-1:1,1,-1:1)
    call tensor2cart(J_tmp,J1C)

    ! rotate cartesian JLinC1 by mg1 and mg2, in order to represent
    ! the interaction matrix in the original coordinate system:
    call atens(MM_tmp1,n1,g1,mg1,2)
    call atens(MM_tmp2,n2,g2,mg2,2)
    do j=1,3
      do l=1,3
        do k=1,3
          J1Cr(:,j) = J1Cr(:,j)+mg1(:,l)*mg2(j,k)*J1C(l,k)
        end do
      end do
    end do

    write(u6,'(A)')
    write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction: LINES-9'
    write(u6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
    write(u6,'(A)') 'LOCAL AXES:::'
    write(u6,'(A)') 'To be used directly in exchange Hamiltonian of the kind:'
    write(u6,'(A)') ' H = -J * S1 * S2'
    write(u6,'(A)') '     (  xx   xy  xz  )  '
    write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
    write(u6,'(A)') '     (  zx   zy  zz  )  '
    do i=1,3
      write(u6,'(3ES22.14)') (-J1Cr(i,j),j=1,3)
    end do

    ! print out the data:
    write(u6,'(A)')
    write(u6,'(10x,A)') 'Parameters of the ITOs:'
    write(u6,'( 5x,A)') 'with absolute values larger than:  1.0e-21 '
    write(u6,'(A)') '--- SITE 1 --|--- SITE 2 --|-----------------------------------------------|'
    write(u6,'(A)') ' rank | proj.| rank | proj.|        Lines-9  Exchange  Interaction         |'
    write(u6,'(A)') '------|------|------|------|---------- Real ----------------- Imag --------|'
    do k1=1,N1-1,2
      do q1=-k1,k1
        do k2=1,N2-1,2
          do q2=-k2,k2
            write(u6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)') k1,'|',q1,'|',k2,'|',q2,'|',JN(k1,q1,k2,q2),'|'
          end do
        end do
      end do
    end do
    write(u6,'(A)') '------|------|------|------|-----------------------------------------------|'
  end if

  !=====================================================================

  if (Dipol .and. (RDI > Zero)) then

    call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
    HTMP(:,:,:,:) = HDIP(lp,1:n1,1:n1,1:n2,1:n2)
    call newjkqpar(n1,n2,HTMP,JN,JB,JS)
    call mma_deallocate(HTMP)

    J1Cr(:,:) = Zero
    J_tmp(:,:) = JB(1,-1:1,1,-1:1)
    call tensor2cart(J_tmp,J1C)

    ! rotate cartesian JLinC1 by mg1 and mg2, in order to represent
    ! the interaction matrix in the original coordinate system:
    call atens(MM_tmp1,n1,g1,mg1,2)
    call atens(MM_tmp2,n2,g2,mg2,2)
    do j=1,3
      do l=1,3
        do k=1,3
          J1Cr(:,j) = J1Cr(:,j)+mg1(:,l)*mg2(j,k)*J1C(l,k)
        end do
      end do
    end do

    write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction: DIPOL'
    write(u6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
    write(u6,'(A)') 'LOCAL AXES:::'
    write(u6,'(A)') 'To be used directly in exchange Hamiltonian of the kind:'
    write(u6,'(A)') ' H = -J * S1 * S2'
    write(u6,'(A)') '     (  xx   xy  xz  )  '
    write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
    write(u6,'(A)') '     (  zx   zy  zz  )  '
    do i=1,3
      write(u6,'(3ES24.14)') (-J1Cr(i,j),j=1,3)
    end do
    write(u6,'(A)') '--- SITE 1 --|--- SITE 2 --|-----------------------------------------------|'
    write(u6,'(A)') ' rank | proj.| rank | proj.|      Dipolar  Exchange  Interaction           |'
    write(u6,'(A)') '------|------|------|------|---------- Real ----------------- Imag --------|'
    do k1=1,N1-1,2
      do q1=-k1,k1
        do k2=1,N2-1,2
          do q2=-k2,k2
            write(u6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)') k1,'|',q1,'|',k2,'|',q2,'|',JN(k1,q1,k2,q2),'|'
          end do
        end do
      end do
    end do
    write(u6,'(A)') '------|------|------|------|-----------------------------------------------|'
  end if

  !=====================================================================

  if (DM_exchange .and. (RDM > Zero)) then

    call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
    HTMP(:,:,:,:) = HDMO(lp,1:n1,1:n1,1:n2,1:n2)
    call newjkqpar(n1,n2,HTMP,JN,JB,JS)
    call mma_deallocate(HTMP)

    J1Cr(:,:) = Zero
    J_tmp(:,:) = JB(1,-1:1,1,-1:1)
    call tensor2cart(J_tmp,J1C)

    call atens(MM_tmp1,n1,g1,mg1,2)
    call atens(MM_tmp2,n2,g2,mg2,2)

    ! rotate cartesian JLinC1 by mg1 and mg2, in order to represent
    ! the interaction matrix in the original coordinate system:
    do j=1,3
      do l=1,3
        do k=1,3
          J1Cr(:,j) = J1Cr(:,j)+mg1(:,l)*mg2(j,k)*J1C(l,k)
        end do
      end do
    end do

    write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction: Dzyaloshinski-Morya'
    write(u6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
    write(u6,'(A)') 'LOCAL AXES:::'
    write(u6,'(A)') 'To be used directly in exchange Hamiltonian of the kind:'
    write(u6,'(A)') ' H = -J * S1 * S2'
    write(u6,'(A)') '     (  xx   xy  xz  )  '
    write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
    write(u6,'(A)') '     (  zx   zy  zz  )  '
    do i=1,3
      write(u6,'(3ES24.14)') (-J1Cr(i,j),j=1,3)
    end do
    write(u6,'(A)') '--- SITE 1 --|--- SITE 2 --|-----------------------------------------------|'
    write(u6,'(A)') ' rank | proj.| rank | proj.|     Dzyaloshinsky - Morya Interaction         |'
    write(u6,'(A)') '------|------|------|------|---------- Real ----------------- Imag --------|'
    do k1=1,N1-1,2
      do q1=-k1,k1
        do k2=1,N2-1,2
          do q2=-k2,k2
            write(u6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)') k1,'|',q1,'|',k2,'|',q2,'|',JN(k1,q1,k2,q2),'|'
          end do
        end do
      end do
    end do
    write(u6,'(A)') '------|------|------|------|-----------------------------------------------|'
  end if

  !=====================================================================

  if (JITO_exchange .and. (RIT > Zero)) then

    call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
    HTMP(:,:,:,:) = HITO(lp,1:n1,1:n1,1:n2,1:n2)
    call newjkqpar(n1,n2,HTMP,JN,JB,JS)
    call mma_deallocate(HTMP)

    J_tmp(:,:) = JB(1,-1:1,1,-1:1)
    call tensor2cart(J_tmp,J1C)

    J1Cr(:,:) = Zero
    call atens(MM_tmp1,n1,g1,mg1,2)
    call atens(MM_tmp2,n2,g2,mg2,2)

    ! rotate cartesian JLinC1 by mg1 and mg2, in order to represent
    ! the interaction matrix in the original coordinate system:
    do j=1,3
      do l=1,3
        do k=1,3
          J1Cr(:,j) = J1Cr(:,j)+mg1(:,l)*mg2(j,k)*J1C(l,k)
        end do
      end do
    end do

    write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction: Anisotropic ITO exchange'
    write(u6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
    write(u6,'(A)') 'LOCAL AXES:::'
    write(u6,'(A)') '     (  xx   xy  xz  )  '
    write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
    write(u6,'(A)') '     (  zx   zy  zz  )  '
    do i=1,3
      write(u6,'(3ES24.14)') (-J1Cr(i,j),j=1,3)
    end do
    write(u6,'(A)') '--- SITE 1 --|--- SITE 2 --|-----------------------------------------------|'
    write(u6,'(A)') ' rank | proj.| rank | proj.|     Anisotropic ITO Exchange Interaction      |'
    write(u6,'(A)') '------|------|------|------|---------- Real ----------------- Imag --------|'
    do k1=1,N1-1,2
      do q1=-k1,k1
        do k2=1,N2-1,2
          do q2=-k2,k2
            write(u6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)') k1,'|',q1,'|',k2,'|',q2,'|',JN(k1,q1,k2,q2),'|'
          end do
        end do
      end do
    end do
    write(u6,'(A)') '------|------|------|------|-----------------------------------------------|'
  end if

  !=====================================================================

  !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

  !write(u6,'(A)') repeat('-',100)
  !write(u6,*)
  !write(u6,'(A)') 'PART 2: Magnetic exchange is written in the GENERAL coordinate systems of the computed system.'
  !write(u6,'(A)') 'The cartesian Z axis of the system is chosen the quantisation axis for the local pseudospins of the two '// &
  !                'interacting sites.'
  !write(u6,'(A)')
  !
  !iopt = 2
  !call unitmat(unity,3)
  !
  !if (Lines .or. AnisoLines) then
  !
  !  call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
  !  call mma_allocate(HTMP3,n1,n1,n2,n2,label='HTMP3')
  !  call mma_allocate(J_tmp2,[1,n1-1],[-(n1-1),n1-1],[1,n2-1],[-(n2-1),n2-1],label='J_tmp2')
  !  HTMP(:,:,:,:) = HLIN(lp,1:n1,1:n1,1:n2,1:n2)
  !  call transHam(n1,n2,unity,unity,MM_tmp1,MM_tmp2,itype(i1),itype(i2),HTMP,HTMP3),iopt)
  !  HLIN3(lp,1:n1,1:n1,1:n2,1:n2) = HTMP3(:,:,:,:)
  !  call JKQPar(n1,n2,HTMP3,J_tmp2)
  !  JLinG(lp,1:n1-1,-(n1-1):n1-1,1:n2-1,-(n2-1):n2-1) = J_tmp2(:,:,:,:)
  !  J_tmp(:,:) = JLinG(lp,1,-1:1,1,-1:1)
  !  call tensor2cart(1,1,J_tmp,J1C)
  !  JLinCG(lp,:,:) = J1C(:,:)
  !  call mma_deallocate(HTMP)
  !  call mma_deallocate(HTMP3)
  !  call mma_deallocate(J_tmp2)
  !  write(u6,'(A)')
  !  write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction: LINES'
  !  write(u6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
  !  write(u6,'(A)') 'GENERAL COORD:::'
  !  write(u6,'(A)') '     (  xx   xy  xz  )  '
  !  write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
  !  write(u6,'(A)') '     (  zx   zy  zz  )  '
  !  do i=1,3
  !    write(u6,'(3ES22.14)') (JLinCG(lp,i,j),j=1,3)
  !  end do
  !end if
  !
  !if (Dipol) then
  !  call mma_allocate(HTMP,n1,n1,n2,n2,label='HTMP')
  !  call mma_allocate(HTMP3,n1,n1,n2,n2,label='HTMP3')
  !  call mma_allocate(J_tmp2,[1,n1-1],[-(n1-1),n1-1],[1,n2-1],[-(n2-1),n2-1],label='J_tmp2')
  !  HDIP(:,:,:,:) = HLIN(lp,1:n1,1:n1,1:n2,1:n2)
  !  call transHam(n1,n2,unity,unity,MM_tmp1,MM_tmp2,itype(i1),itype(i2),HTMP,HTMP3),iopt)
  !  HDIP3(lp,1:n1,1:n1,1:n2,1:n2) = HTMP3(:,:,:,:)
  !  call JKQPar(n1,n2,HTMP3,J_tmp2)
  !  JDipG(lp,1:n1-1,-(n1-1):n1-1,1:n2-1,-(n2-1):n2-1) = J_tmp2(:,:,:,:)
  !  J_tmp(:,:) = JDipG(lp,1,-1:1,1,-1:1)
  !  call tensor2cart(1,1,J_tmp,JDipCG(lp,:,:))
  !  JDipCG(lp,:,:) = J1C(:,:)
  !  call mma_deallocate(HTMP)
  !  call mma_deallocate(HTMP3)
  !  call mma_deallocate(J_tmp2)
  !  write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction: DIPOL'
  !  write(u6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
  !  write(u6,'(A)') 'GENERAL COORD:::'
  !  write(u6,'(A)') '     (  xx   xy  xz  )  '
  !  write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
  !  write(u6,'(A)') '     (  zx   zy  zz  )  '
  !  do i=1,3
  !    write(u6,'(3ES22.14)') (JDipCG(lp,i,j),j=1,3)
  !  end do
  !end if
  !
  !write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction: LINES+DIPOL'
  !write(u6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
  !write(u6,'(A)') 'GENERAL COORD:::'
  !write(u6,'(A)') '     (  xx   xy  xz  )  '
  !write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
  !write(u6,'(A)') '     (  zx   zy  zz  )  '
  !do i=1,3
  !  write(u6,'(3F24.14)') ((JLinCG(lp,i,j)+JDipCG(lp,i,j))*cm_to_MHz,j=1,3)
  !end do
  !
  ! print out the data:
  !write(u6,'(A)')
  !write(u6,'(10x,A)') 'Parameters of the ITOs:'
  !write(u6,'( 5x,A)') 'with absolute values larger than:  0.5e-14 '
  !if ((Lines .or. AnisoLines) .and. (.not. Dipol)) then
  !  write(u6,'(A)') '--- SITE 1 --|--- SITE 2 --|-------------------------------------|'
  !  write(u6,'(A)') ' rank | proj.| rank | proj.|    Lines  Exchange  Interaction     |'
  !  write(u6,'(A)') '------|------|------|------|------ Real ----------- Imag --------|'
  !  do k1=1,N1-1,2
  !    do q1=-k1,k1
  !      do k2=1,N2-1,2
  !        do q2=-k2,k2
  !          if (abs(JLinG(lp,k1,q1,k2,q2)) > 0.5e-14_wp) &
  !            write(u6,'(4(i4,2x,A),2(1x,ES17.10),1x,A)') k1,'|',q1,'|',k2,'|',q2,'|',JLinG(lp,k1,q1,k2,q2),'|'
  !        end do
  !      end do
  !    end do
  !  end do
  !  write(u6,'(A)') '------|------|------|------|-------------------------------------|'
  !else if ((.not. (Lines .or. AnisoLines)) .and. Dipol) then
  !  write(u6,'(A)') '--- SITE 1 --|--- SITE 2 --|-------------------------------------|'
  !  write(u6,'(A)') ' rank | proj.| rank | proj.|  Dipolar  Exchange  Interaction     |'
  !  write(u6,'(A)') '------|------|------|------|------ Real ----------- Imag --------|'
  !  do k1=1,N1-1,2
  !    do q1=-k1,k1
  !      do k2=1,N2-1,2
  !        do q2=-k2,k2
  !          if (abs(JDipG(lp,k1,q1,k2,q2)) > 0.5e-14_wp) &
  !            write(u6,'(4(i4,2x,A),2(1x,ES17.10),1x,A)') k1,'|',q1,'|',k2,'|',q2,'|',JDipG(lp,k1,q1,k2,q2),'|'
  !        end do
  !      end do
  !    end do
  !  end do
  !  write(u6,'(A)') '------|------|------|------|-------------------------------------|'
  !else if ((Lines .or. AnisoLines) .and. Dipol) then
  !  write(u6,'(A)') '--- SITE 1 --|--- SITE 2 --|-------------------------------------|-------------------------------------|'
  !  write(u6,'(A)') ' rank | proj.| rank | proj.|    Lines  Exchange  Interaction     |  Dipolar  Exchange  Interaction     |'
  !  write(u6,'(A)') '------|------|------|------|------ Real ----------- Imag --------|------ Real ----------- Imag --------|'
  !  do k1=1,N1-1,2
  !    do q1=-k1,k1
  !      do k2=1,N2-1,2
  !        do q2=-k2,k2
  !          if ((abs(JLinG(lp,k1,q1,k2,q2)) > 0.5e-14_wp) .or. (abs(JDipG(lp,k1,q1,k2,q2)) > 0.5e-14_wp)) &
  !            write(u6,'(4(i4,2x,A),2(1x,ES17.10),1x,A,2(1x,ES17.10),1x,A)') k1,'|',q1,'|',k2,'|',q2,'|',JLinG(lp,k1,q1,k2,q2), &
  !                                                                           '|',JDipG(lp,k1,q1,k2,q2),'|'
  !        end do
  !      end do
  !    end do
  !  end do
  !  write(u6,'(A)') '------|------|------|------|-------------------------------------|-------------------------------------|'
  !end if
  !
  !write(u6,'(A)')
  !write(u6,'(A)') 'Cartesian representation of the (rank-1)*(rank-1) exchange interaction'
  !Write(u6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
  !Write(u6,'(A)') '     (  xx   xy  xz  )  '
  !Write(u6,'(A)') 'J =  (  yx   yy  yz  )  '
  !Write(u6,'(A)') '     (  zx   zy  zz  )  '
  !
  ! express the rank-1 tensors in the sum of
  ! Isotrop part    C * unit matrix
  ! Symmetric part
  ! Antisymmetric part
  ! print out the data:
  !
  !JDipCG(lp,:,:) = Zero
  !if(Lines .or. AnisoLines) then
  !  write(u6,'(A)') 'Lines matrix:'
  !  do i=1,3
  !    write(u6,'(3F12.6)') (JLinCG(lp,i,j),j=1,3)
  !  end do
  !
  !  ELin(lp,:,:) = Zero
  !  ALin(lp,:,:) = Zero
  !  SLin(lp,:,:) = Zero
  !  ELin(lp,1,1) = (JLinCG(lp,1,1)+JLinCG(lp,2,2)+JLinCG(lp,3,3))/Three
  !  ELin(lp,2,2) = (JLinCG(lp,1,1)+JLinCG(lp,2,2)+JLinCG(lp,3,3))/Three
  !  ELin(lp,3,3) = (JLinCG(lp,1,1)+JLinCG(lp,2,2)+JLinCG(lp,3,3))/Three
  !  ALin(lp,:,:) = (JLinCG(lp,:,:)-JLinCG(lp,:,:))*Half
  !  tsum = Zero
  !  do l=1,3
  !    tsum = tsum+JLinCG(lp,l,l)
  !  end do
  !  test(:,:) = Zero
  !  do is1=1,3
  !    test(is1,is1) = tsum/OneHalf
  !  end do
  !
  !  SLin(lp,:,:) = (JLinCG(lp,:,:)+JLinCG(lp,:,:)-test(:,:))*Half
  !  write(u6,'(A)') 'Elin * unit'
  !  do is1=1,3
  !    write(u6,'(3F12.6)') (ELin(lp,is1,is2),is2=1,3)
  !  end do
  !  write(u6,'(A)') '-2/3 * test'
  !  do is1=1,3
  !    write(u6,'(3F12.6)') (-test(is1,is2)/OneHalf,is2=1,3)
  !  end do
  !
  !  write(u6,'(A)') 'ALin:'
  !  do is1=1,3
  !    write(u6,'(3F12.6)') (ALin(lp,is1,is2),is2=1,3)
  !  end do
  !  write(u6,'(A)') 'SLin:'
  !  do is1=1,3
  !    write(u6,'(3F12.6)') (SLin(lp,is1,is2),is2=1,3)
  !  end do
  !end if
  !
  !if (Dipol) then
  !  write(u6,'(A)') 'Dipolar exchange matrix:'
  !  do i=1,3
  !    write(u6,'(3F12.6)') (JDipCG(lp,i,j),j=1,3)
  !  end do
  !
  !  EDip(lp,:,:) = Zero
  !  ADip(lp,:,:) = Zero
  !  SDip(lp,:,:) = Zero
  !  EDip(lp,1,1) = (JDipCG(lp,1,1)+JDipCG(lp,2,2)+JDipCG(lp,3,3))/Three
  !  EDip(lp,2,2) = (JDipCG(lp,1,1)+JDipCG(lp,2,2)+JDipCG(lp,3,3))/Three
  !  EDip(lp,3,3) = (JDipCG(lp,1,1)+JDipCG(lp,2,2)+JDipCG(lp,3,3))/Three
  !  ADip(lp,:,:) = (JDipCG(lp,:,:)-JDipCG(lp,:,:))*Half
  !  tsum = Zero
  !  do l=1,3
  !    tsum = tsum+JDipCG(lp,l,l)
  !  end do
  !  test(:,:) = Zero
  !  do is1=1,3
  !    test(is1,is1) = tsum/OneHalf
  !  end do
  !  SDip(lp,:,:) = (JDipCG(lp,:,:)+JDipCG(lp,:,:)-test(:,:))*Half
  !  write(u6,'(A)') 'EDip * unit'
  !  do is1=1,3
  !    write(u6,'(3F12.6)') (EDip(lp,is1,is2),is2=1,3)
  !  end do
  !  write(u6,'(A)') '-2/3 * test'
  !  do is1=1,3
  !    write(u6,'(3F12.6)') (-test(is1,is2)/OneHalf,is2=1,3)
  !  end do
  !  write(u6,'(A)') 'ADip:'
  !  do is1=1,3
  !    write(u6,'(3F12.6)') (ADip(lp,is1,is2),is2=1,3)
  !  end do
  !  write(u6,'(A)') 'SDip:'
  !  do is1=1,3
  !    write(u6,'(3F12.6)') (SDip(lp,is1,is2),is2=1,3)
  !  end do
  !end if

  call mma_deallocate(MM_tmp1)
  call mma_deallocate(MM_tmp2)

  call mma_deallocate(JN)
  call mma_deallocate(JB)
  call mma_deallocate(JS)
end do ! lp, interacting pairs

return

end subroutine pr_ito_int

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine transHam( n1, n2, rot1, rot2, MM1, MM2, typ1, typ2,
     &                     H, HT, iopt)
c purpose:  transform the exchange Hamiltonian
c           matrices to the basis of their local pseudospins
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
!     exchange basis of both sites
      Integer, intent(in)           :: n1, n2, iopt
      Real(kind=8), intent(in)     :: rot1(3,3)
      Real(kind=8), intent(in)     :: rot2(3,3)
      Complex(kind=8), intent(in)  :: MM1(3,n1,n1)
      Complex(kind=8), intent(in)  :: MM2(3,n2,n2)
      Complex(kind=8), intent(in)  :: H( n1,n1,n2,n2)
      Complex(kind=8), intent(out) :: HT(n1,n1,n2,n2)
      Character(Len=1), intent(in)  :: typ1, typ2
      ! local variables
      Integer                       :: i1,i2,j1,j2,i
      Real(kind=8), allocatable    :: gt1(:), gt2(:)
      Real(kind=8), allocatable    :: ax1(:,:), ax2(:,:)
      Complex(kind=8), allocatable :: M1(:,:,:),   M2(:,:,:)
      Complex(kind=8), allocatable :: MR1(:,:,:), MR2(:,:,:)
      Complex(kind=8), allocatable ::   Z1(:,:), Z2(:,:)
      Complex(kind=8), allocatable :: TMP1(:,:), TMP2(:,:)
      Complex(kind=8), allocatable :: HI(:,:,:,:) !HI(n1,n1,n2,n2)
      Logical ::  DBG

      DBG= .false.

!-----------------------------------------------------------------------
      Call mma_allocate(gt1,3,'gt1')
      Call mma_allocate(gt2,3,'gt2')
      Call mma_allocate(ax1,3,3,'ax1')
      Call mma_allocate(ax2,3,3,'ax2')
      If(n1>0) Then
         Call mma_allocate(M1,3,n1,n1,'M1')
         Call mma_allocate(MR1,3,n1,n1,'MR1')
         Call mma_allocate(Z1,n1,n1,'Z1')
         Call mma_allocate(TMP1,n1,n1,'TMP1')
      End If
      If(n2>0) Then
         Call mma_allocate(M2,3,n2,n2,'M2')
         Call mma_allocate(MR2,3,n2,n2,'MR2')
         Call mma_allocate(Z2,n2,n2,'Z2')
         Call mma_allocate(TMP2,n2,n2,'TMP2')
      End If
      If((n1>0).AND.(n2>0)) Then
         Call mma_allocate(HI,n1,n1,n2,n2,'HI')
      End If
      Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,HT,1)
!-----------------------------------------------------------------------


      ! rotate the magnetic moments to their general coordinate system
      Call zcopy_(3*n1*n1,[(0.0_wp,0.0_wp)],0,M1,1)
      Call zcopy_(3*n2*n2,[(0.0_wp,0.0_wp)],0,M2,1)
      Call rotmom( MM1, n1, rot1, M1 )
      Call rotmom( MM2, n2, rot2, M2 )

      If (iopt.eq.1) Then ! local coordinate system
         Call dcopy_(3,[0.0_wp],0,gt1,1)
         Call dcopy_(3,[0.0_wp],0,gt2,1)
         Call dcopy_(3*3,[0.0_wp],0,ax1,1)
         Call dcopy_(3*3,[0.0_wp],0,ax2,1)
         If(DBG) Then
            Write(6,'(A)') 'TRANSHAM:: local g tensors and axes:'
            Call atens( M1, n1, gt1, ax1, 2)
            Call atens( M2, n2, gt2, ax2, 2)
         Else
            Call atens( M1, n1, gt1, ax1, 1)
            Call atens( M2, n2, gt2, ax2, 1)
         End If

      Else If (iopt==2) Then ! general coordinate system
         Call dcopy_(3*3,[0.0_wp],0,ax1,1)
         Call dcopy_(3*3,[0.0_wp],0,ax2,1)
         Do i1=1,3
           ax1(i1,i1)=1.0_wp
           ax2(i1,i1)=1.0_wp
         End Do
      End If



c----------------------------------------------------------------------
      ! rotate magnetic moments to their local magnetic axes:
      Call zcopy_(3*n1*n1,[(0.0_wp,0.0_wp)],0,MR1,1)
      Call zcopy_(3*n2*n2,[(0.0_wp,0.0_wp)],0,MR2,1)
      If (  ((typ1.eq.'A').AND.(typ2.eq.'A')) .OR.
     &      ((typ1.eq.'B').AND.(typ2.eq.'B')) .OR.
     &      ((typ1.eq.'B').AND.(typ2.eq.'C')) .OR.
     &      ((typ1.eq.'C').AND.(typ2.eq.'B')) .OR.
     &      ((typ1.eq.'C').AND.(typ2.eq.'C')) )  Then
         ! both sites have been computed ab initio
         Call rotmom2( M1, n1, ax1, MR1 )
         Call rotmom2( M2, n2, ax2, MR2 )
      Else If( ((typ1.eq.'A').AND.(typ2.eq.'B')).OR.
     &         ((typ1.eq.'A').AND.(typ2.eq.'C')) ) Then
         !  site 2 is generated isotropic
         !  use axes of site 1
         Call rotmom2( M1, n1, ax1, MR1 )
         Call rotmom2( M2, n2, ax1, MR2 )
      Else If( ((typ1.eq.'B').AND.(typ2.eq.'A')).OR.
     &         ((typ1.eq.'C').AND.(typ2.eq.'A')) ) Then
         !  site 1 is generated isotropic
         !  use axes of site 2
         Call rotmom2( M1, n1, ax2, MR1 )
         Call rotmom2( M2, n2, ax2, MR2 )
      End If

      If(DBG) Then
        If(iopt.eq.1) Then
          Write(6,'(A,i3)') 'site 1'
          Call prMom('transHam:: magnetic moment, coordinate '//
     &               'system of LOCAL main magnetic axes, site 1',
     &                MR1, n1)
          Write(6,'(A,i3)') 'site 2'
          Call prMom('transHam:: magnetic moment, coordinate '//
     &               'system of LOCAL main magnetic axes, site 2',
     &                MR2, n2)
        Else
          Write(6,'(A,i3)') 'site 1'
          Call prMom('transHam:: magnetic moment, coordinate '//
     &               'system of GENERAL main magnetic axes, site 1',
     &                MR1, n1)
          Write(6,'(A,i3)') 'site 2'
          Call prMom('transHam:: magnetic moment, coordinate '//
     &               'system of GENERAL main magnetic axes, site 2',
     &                MR2, n2)
        End If
      End If



c----------------------------------------------------------------------
      ! find local pseudospin on each site:
      Call zcopy_(n1*n1,[(0.0_wp,0.0_wp)],0,Z1,1)
      Call zcopy_(n2*n2,[(0.0_wp,0.0_wp)],0,Z2,1)
      Call pseudospin( MR1, n1, Z1, 3,1, 1 )
      Call pseudospin( MR2, n2, Z2, 3,1, 1 )


      If (DBG) Then
         Call pa_prmat('Matrix Z1',Z1,n1)
         Call zcopy_(n1*n1,[(0.0_wp,0.0_wp)],0,TMP1,1)
         Call zgemm_('C','N', n1, n1, n1, (1.0_wp,0.0_wp),
     &               Z1, n1,
     &               Z1, n1,(0.0_wp,0.0_wp),
     &               TMP1, n1 )
         Write(6,'(A)') 'transHam:  Verify unitarity of Z1'
         Do i=1,n1
            Write(6,'(A,i2,A,i2,A,2ES20.10)')
     &               'conjg(Z1)*Z1:  (',i,',',i,')=', TMP1(i,i)
         End Do
         Call pa_prmat('Matrix Z2',Z2,n2)
         Call zcopy_(n2*n2,[(0.0_wp,0.0_wp)],0,TMP2,1)
         Call zgemm_('C','N', n2, n2, n2, (1.0_wp,0.0_wp),
     &               Z2, n2,
     &               Z2, n2,(0.0_wp,0.0_wp),
     &               TMP2, n2 )
         Write(6,'(A)') 'transHam:  Verify unitarity of Z2'
         Do i=1,n2
            Write(6,'(A,i2,A,i2,A,2ES20.10)')
     &               'conjg(Z2)*Z2:  (',i,',',i,')=', TMP2(i,i)
         End Do
         Call UTMU2( n1, n1, Z1, MR1 )
         Call UTMU2( n2, n2, Z2, MR2 )
         Call prMom('transHam:: magnetic moment, coordinate '//
     &              'MR1, site 1',
     &               MR1, n1)
         Call prMom('transHam:: magnetic moment, coordinate '//
     &              'MR2, site 2',
     &               MR2, n2)
      End If


      ! save a local copy:
      Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,HI,1)
      Call zcopy_(n1*n1*n2*n2,H,1,HI,1)

      Do i1=1,n1
        Do j1=1,n1
          Do i2=1,n2
            Do j2=1,n2
!              If (DBG.AND.(ABS(H(i1,j1,i2,j2)).gt.0.5d-13)) Then
                 Write(6,'(A,4(i2,A),2ES22.14)')
     &              'H (',i1,',',j1,',',i2,',',j2,')=',H(i1,j1,i2,j2)
!              End If
            End Do
          End Do
        End Do
      End Do

      ! transform the Hamiltonian to local pseudospins:
      Do i2=1,n2
        Do j2=1,n2
          Call zcopy_(n1*n1,[(0.0_wp,0.0_wp)],0,TMP1,1)
          Call zgemm_('C','N', n1, n1, n1, (1.0_wp,0.0_wp),
     &                Z1, n1,
     &                HI(1:n1,1:n1, i2,j2), n1,(0.0_wp,0.0_wp),
     &                TMP1, n1 )


          Call zcopy_(n1*n1,[(0.0_wp,0.0_wp)],0,HI(1:n1,1:n1, i2,j2),1)
          Call zgemm_('N','N', n1, n1, n1, (1.0_wp,0.0_wp),
     &                TMP1, n1,
     &                Z1, n1, (0.0_wp,0.0_wp),
     &                HI(1:n1,1:n1, i2,j2), n1 )
        End Do
      End Do

      Do i1=1,n1
        Do j1=1,n1
          Call zcopy_(n2*n2,[(0.0_wp,0.0_wp)],0,TMP2,1)
          Call zgemm_( 'C','N', n2, n2, n2, (1.0_wp,0.0_wp),
     &                Z2, n2,
     &                HI(i1,j1, 1:n2,1:n2), n2, (0.0_wp,0.0_wp),
     &                TMP2, n2 )

          Call zcopy_(n2*n2,[(0.0_wp,0.0_wp)],0,HI(i1,j1,1:n2,1:n2),1)
          Call zgemm_('N','N', n2, n2, n2, (1.0_wp,0.0_wp),
     &                TMP2, n2,
     &                Z2, n2, (0.0_wp,0.0_wp),
     &                HI(i1,j1,1:n2,1:n2), n2 )
        End Do
      End Do

      Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,HT,1)
      Call zcopy_(n1*n1*n2*n2,HI,1,HT,1)


      Do i1=1,n1
        Do j1=1,n1
          Do i2=1,n2
            Do j2=1,n2
!              If (DBG.AND.(ABS(HT(i1,j1,i2,j2)).gt.0.5d-13)) Then
                 Write(6,'(A,4(i2,A),2ES22.14)')
     &              'HT(',i1,',',j1,',',i2,',',j2,')=',HT(i1,j1,i2,j2)
!              End If
            End Do
          End Do
        End Do
      End Do

!-----------------------------------------------------------------------
      Call mma_deallocate(gt1)
      Call mma_deallocate(gt2)
      Call mma_deallocate(ax1)
      Call mma_deallocate(ax2)
      If(n1>0) Then
         Call mma_deallocate(M1)
         Call mma_deallocate(MR1)
         Call mma_deallocate(Z1)
         Call mma_deallocate(TMP1)
      End If
      If(n2>0) Then
         Call mma_deallocate(M2)
         Call mma_deallocate(MR2)
         Call mma_deallocate(Z2)
         Call mma_deallocate(TMP2)
      End If
      If((n1>0).AND.(n2>0)) Then
         Call mma_deallocate(HI)
      End If

      Return
      End Subroutine transHam

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PopAnalysis(nneq,neq,exch,nexch,nmax,lmax,
     & NmaxPop,Z)
c  computes the density matrix of each interacting site in the coupled eigenstate Zi
c  N - (Integer) - total number of the exchange states ( total number of basis functions )
c  Z - (Complex*16 array, size N) - contains the coupled eigenvector (a given column of the
c       entire exchange Z array)
c  Nsites - total number of interacting magnetic sites
c  ibas(N,Nsites) - Integer array denoting the coupled basis
c  nneq -- number of non equivalent sites
c  neq(Nneq) number of equivalent sites of type i
c
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
c main input variables
      Integer, intent(in)          :: nneq, exch, nmax, lmax
      Integer, intent(in)          :: neq(nneq), nexch(nneq)
      Integer, intent(in)          :: NmaxPop
      Complex(kind=8), intent(in) :: Z(exch,exch)
c local variables
      Integer          :: i,j,l,isite,i1,i2,nb1,nb2,nb3,tmp,il,nb
      Integer          :: nind(lmax,2),intc(lmax)
      Integer          :: ibas(exch,lmax)
!     pop(exch,lmax,nmax,nmax)
      Complex(kind=8), allocatable :: pop(:,:,:,:)
      Character(len=50):: fmtline
      Logical          :: DBG
      DBG=.false.

      If(DBG) Then
         Write(6,'(A)') 'enter POPULATION ANALYSIS Subroutine'
         Write(6,'(A, i3)') '      nmax = ',nmax
         Write(6,'(A, i3)') '      exch = ',exch
         Write(6,'(A, i3)') '   NmaxPop = ',NmaxPop
         Write(6,'(A, i3)') '      lmax = ',lmax
         Write(6,'(A, i3)') '      nneq = ',nneq
         Write(6,'(A,8i3)') '    neq(i) = ',(neq(i),i=1,nneq)
         Write(6,'(A,8i3)') '  nexch(i) = ',(nexch(i),i=1,nneq)
      End If
      Call mma_allocate(pop,exch,lmax,nmax,nmax,'pop')
      Call zcopy_(exch*lmax*nmax*nmax,[(0.0_wp,0.0_wp)],0,pop,1)
c fill some general arrays:
c generate the tables:
      nind(:,:)=0
      l=0
      Do i=1,nneq
         Do j=1,neq(i)
         l=l+1
         nind(l,1)=i
         nind(l,2)=j
         End Do
      End Do
      intc(:)=0
      ibas(:,:)=0
      intc(1)=1
      If (lmax.gt.1) Then
        Do i=2,lmax
        i1=nind(i-1, 1)
        intc(i)=intc(i-1)*nexch(i1)
        End Do
      End If
      Do nb=1,exch
      nb1=nb-1
         Do i=1,lmax
         ibas(nb, lmax-i+1)= nb1 / intc(lmax-i+1)
         nb1=nb1-ibas(nb,lmax-i+1)*intc(lmax-i+1)
         End Do
      End Do
      isite=0
c
      pop=(0.0_wp,0.0_wp)
      i=int(24+13*lmax)
      Write(fmtline,'(A,i3,A,i2,A)') '(',i,'A)'
      Write(6,fmtline) ('-',j=1,i)
      i=int((24+13*lmax-19)/2)
      Write(fmtline,'(A,i3,A,i3,A)') '(',i,'X,A,',i,'X)'
      Write(6,fmtline)   'POPULATION ANALYSIS'
      i=int((8+13*lmax-19)/2)
      Write(fmtline,'(A,i3,A,i3,A)') '(',i,'X,A,',i,'X)'
      Write(6,fmtline)   '(i.e. diagonal value of density'//
     & ' matrices of the interacting sites)'
      i=int(24+13*lmax)
      Write(fmtline,'(A,i3,A)') '(',i,'A)'
      Write(6,fmtline) ('-',j=1,i)
      Write(fmtline,'(A,i3,A)') '(A,',lmax,'A)'
      Write(6,fmtline) '--------|-----|',
     & ('------------|',i=1,lmax)
      Write(6,fmtline) 'Exchange|Basis|',
     & ('   center   |', i=1,lmax)
      Write(fmtline,'(A,i3,A)') '(A,',lmax,'(A,i2,A))'
      Write(6,fmtline) ' state  | set |',
     & ('     ',i,'     |',i=1,lmax)
      Write(fmtline,'(A,i3,A)') '(A,',lmax,'A)'
      Write(6,fmtline) '--------|-----|',
     & ('------------|',i=1,lmax)

!     loop over all states for which we want density matrices and
!     expectation values to be calculated
      Do nb1=1,NmaxPop
         Do l=1,lmax
         isite=nind(l,1)
            Do i1=1,nexch(isite)
               Do i2=1,nexch(isite)
c     sum over all other components of other sites
                  Do nb2=1,exch
                     Do nb3=1,exch
                        If(ibas(nb2,l)+1 .ne. i1) Go To 11
                        If(ibas(nb3,l)+1 .ne. i2) Go To 11
                           tmp=0
                           Do il=1,lmax
                           If (il.eq.l) Go To 10
                   tmp=tmp+(ibas(nb2,il)-ibas(nb3,il))**2
 10                        continue
                           End Do

                        If(tmp.gt.0 ) Go To 11

      pop(nb1,l,i1,i2)=pop(nb1,l,i1,i2)+conjg(Z(nb2,nb1))*Z(nb3,nb1)

 11                     continue
                     End Do
                  End Do
               End Do
            End Do
         End Do

         Do i=1,nmax ! maxim local basis
         Write(fmtline,'(A,i2,A)') '(2x,i4,2x,A,1x,i2,2x,A,',
     &                              lmax,'(1x,F10.8,1x,A))'
         Write(6,fmtline) nb1,'|',i,'|',
     & ( dble(pop(nb1,l,i,i)),'|',l=1,lmax)
         End Do
      Write(fmtline,'(A,i2,A)') '(A,',lmax,'A)'
      Write(6,fmtline) '--------|-----|',
     & ('------------|',i=1,lmax)
      End Do ! nb1


      call mma_deallocate(pop)

      Return
      End


c compute and print the calculated expectation values:
c      Write(6,*)
c      Write(6,'(A)') 'EXPECTATION VALUES'
c      Write(6,'(5A)') '--------|----|',
c     & ('------------------------------|',i=1,4)
c      Write(6,'(5A)') 'Exchange|Site|',
c     & '   MAGNETIC MOMENT (M=-L-2S)  |',
c     & '        SPIN MOMENT (S)       |',
c     & '      ORBITAL MOMENT (L)      |',
c     & '     TOTAL MOMENT (J=L+S)     |'
c      Write(6,'(5A)') ' state  | Nr.|',
c     & ('     X         Y         Z    |',i=1,4)
c      Write(6,'(5A)') '--------|----|',
c     & ('------------------------------|',i=1,4)
c      Do nb1=1,NmaxPop
cc  we proceed to compute expectation values for this nb1 exchange state
c      Call CZeroVector(Mx,lmax)
c      Call CZeroVector(My,lmax)
c      Call CZeroVector(Mz,lmax)
c      Call CZeroVector(Sx,lmax)
c      Call CZeroVector(Sy,lmax)
c      Call CZeroVector(Sz,lmax)
c      Call CZeroVector(Jx,lmax)
c      Call CZeroVector(Jy,lmax)
c      Call CZeroVector(Jz,lmax)
c      Call CZeroVector(Lx,lmax)
c      Call CZeroVector(Ly,lmax)
c      Call CZeroVector(Lz,lmax)

c         Do l=1,lmax
c         isite = nind(ind_exch(l),1)
c           Do i1=1,nexch(isite)
c              Do i2=1,nexch(isite)
c       Mx(l)=Mx(l)+pop(nb1,l,i1,i2)*M(isite,1,i1,i2)
c       My(l)=My(l)+pop(nb1,l,i1,i2)*M(isite,2,i1,i2)
c       Mz(l)=Mz(l)+pop(nb1,l,i1,i2)*M(isite,3,i1,i2)
c       Sx(l)=Sx(l)+pop(nb1,l,i1,i2)*S(isite,1,i1,i2)
c       Sy(l)=Sy(l)+pop(nb1,l,i1,i2)*S(isite,2,i1,i2)
c       Sz(l)=Sz(l)+pop(nb1,l,i1,i2)*S(isite,3,i1,i2)
c              End Do
c            End Do
c       Lx(l)=-Mx(l)-g_e*Sx(l)
c       Ly(l)=-My(l)-g_e*Sy(l)
c       Lz(l)=-Mz(l)-g_e*Sz(l)
c       Jx(l)= Lx(l)+Sx(l)
c       Jy(l)= Ly(l)+Sy(l)
c       Jz(l)= Lz(l)+Sz(l)
c         End Do
c
c         Do l=1,lmax
c         If(l.eq.int((lmax+1)/2)) Then
c      Write(6,'(i5,3x,A,1x,i2,1x,A,4(3(F9.5,1x),A))')
c     & nb1,'|',l,'|',
c     & dble(Mx(l)),dble(My(l)),dble(Mz(l)),'|',
c     & dble(Sx(l)),dble(Sy(l)),dble(Sz(l)),'|',
c     & dble(Lx(l)),dble(Ly(l)),dble(Lz(l)),'|',
c     & dble(Jx(l)),dble(Jy(l)),dble(Jz(l)),'|'
c         Else
c      Write(6,'(8x,A,1x,i2,1x,A,4(3(F9.5,1x),A))')
c     & '|',l,'|',
c     & dble(Mx(l)),dble(My(l)),dble(Mz(l)),'|',
c     & dble(Sx(l)),dble(Sy(l)),dble(Sz(l)),'|',
c     & dble(Lx(l)),dble(Ly(l)),dble(Lz(l)),'|',
c     & dble(Jx(l)),dble(Jy(l)),dble(Jz(l)),'|'
c         End If
c         End Do
c      Write(6,'(5A)') '--------|----|',
c     & ('------------------------------|',i=1,4)
c      End Do
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefW34y(aGrp,bGrp,w3y,w4y,NaGrp)
! this routine does:
! define w3y and w4y keys, which indicates, if at least one
! W3/W4 file needs to be calculated on this node for given a',b'

#ifdef _MOLCAS_MPP_
use Index_Functions, only: nTri_Elem
use chcc_global, only: GrpaLow, GrpaUp, InqW3, InqW4
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: aGrp, bGrp, NaGrp
integer(kind=iwp), intent(out) :: w3y, w4y
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: abSGrp, aSGrp, bSGrp, bSGrpUp, cdSGrp, cSGrp, NSGrp

w3y = 0
w4y = 0

! cycle over a">=b" subgroups for a',b'
do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
  if (aGrp == bGrp) then
    bSGrpUp = aSGrp
  else
    bSGrpUp = GrpaUp(bGrp)
  end if
  do bSGrp=GrpaLow(bGrp),bSGrpUp
    abSGrp = nTri_Elem(aSGrp-1)+bSGrp

    ! cycle over all c"
    NSGrp = GrpaUp(NaGrp)
    do cSGrp=1,NSGrp
      if (InqW3(abSGrp,cSGrp)) w3y = w3y+1
    end do

    ! cycle over all c">=d"
    do cdSGrp=1,nTri_Elem(NSGrp)
      if (InqW4(abSGrp,cdSGrp)) w4y = w4y+1
    end do

    ! end cycle over a">=b" subgroups
  end do
end do

#else

#include "macros.fh"
unused_var(aGrp)
unused_var(bGrp)
unused_var(NaGrp)

w3y = 1
w4y = 1
#endif

return

end subroutine DefW34y

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE AIJK(ITAI,L0,L1,L2,L3)
      IMPLICIT REAL*8 (A-H,O-Z)
      External Int8, Int2, int1, int4
#include "SysDef.fh"
#include "files_guga.fh"
      DIMENSION ITAI(*),L0(*),L1(*),L2(*),L3(*)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
*
      IOUT=0
      NMAT=0
      L=0
      DO 10 NI=1,LN
      DO 20 NJ=1,NI
      I=ICH(NI)
      J=ICH(NJ)
      IF(I.GT.J)GO TO 29
      I=ICH(NJ)
      J=ICH(NI)
29    DO 30 NK=1,LN
      IOUT=IOUT+1
      ICOP1(IOUT)=0
      IF(IOUT.LT.NBUF)GO TO 460
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
460   K=ICH(NK)
      IOUT=IOUT+1
*      IND=I+2**10*J
      IND=IOR(I,ISHFT(J,10))
*      ICOP1(IOUT)=IND+2**20*K
      ICOP1(IOUT)=IOR(IND,ISHFT(K,20))
      IF(IOUT.LT.NBUF)GO TO 31
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
C     DOUBLET-VALENCE INTERACTIONS
31    ITURN=1
      ITT1=1
      ITT2=0
150   IT1=ITT1*MXVERT
      IT2=ITT2*MXVERT
      JJ=0
      IF(ITT1.NE.0)JJ=IRC(ITT1)
      JJD=0
      IF(ITT1.NE.0)JJD=JRC(ITT1)
      II=0
      IF(ITT2.NE.0)II=IRC(ITT2)
      IID=0
      IF(ITT2.NE.0)IID=JRC(ITT2)
      IF(I.NE.K)GO TO 520
      IF(J.EQ.K)GO TO 524
      CALL INT61(L,J,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,
     *L0,L1,L2,L3)
      CALL INT62(L,J,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,
     *L0,L1,L2,L3)
      GO TO 35
524   CALL INT9(L,K,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,
     *L0,L1,L2,L3)
      GO TO 35
520   IF(J.NE.K)GO TO 535
      CALL INT4(L,K,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,
     *L0,L1,L2,L3)
      GO TO 35
535   IF(I.NE.J)GO TO 546
      CALL INT8(L,K,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,
     *L0,L1,L2,L3)
      GO TO 35
546   IF(K.LT.I)GO TO 540
      CALL INT3(J,I,L,K,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,
     *L0,L1,L2,L3)
      GO TO 35
540   IF(K.LT.J)GO TO 545
      CALL INT2(L,K,J,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,
     *L0,L1,L2,L3)
      GO TO 35
545   CALL INT1(L,K,J,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,
     *L0,L1,L2,L3)
35    GO TO (101,102,103,104,105,30),ITURN
C     TRIPLET-DOUBLET INTERACTIONS
101   ITURN=2
      ITT1=2
      ITT2=1
      GO TO 150
C     SINGLET-DOUBLET INTERACTIONS
102   ITURN=3
      ITT1=3
      ITT2=1
      GO TO 150
C     VALENCE-DOUBLET INTERACTIONS
103   ITURN=4
      ITT1=0
      ITT2=1
      GO TO 150
C     DOUBLET-TRIPLET INTERACTIONS
104   ITURN=5
      ITT1=1
      ITT2=2
      GO TO 150
C     DOUBLET-SINGLET INTERACTIONS
105   ITURN=6
      ITT1=1
      ITT2=3
      GO TO 150
30    CONTINUE
20    CONTINUE
10    CONTINUE
      ICOP1(nCOP+1)=IOUT
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+IOUT
      ICOP1(nCOP+1)=-1
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      WRITE(IW,600)NMAT
600   FORMAT(/6X,'COEFFICIENTS FOR AIJK',I9)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_ChkInt(xInt,Diag,iSym,nErr,Tol,Report)
C
C     Purpose: check diagonals in qualified integral columns.
C
      Implicit None
      Real*8  xInt(*), Diag(*)
      Integer iSym, nErr
      Real*8  Tol
      Logical Report
#include "cho_para_info.fh"

      If (Cho_Real_Par) Then
         Call Cho_P_QualSwp()
         Call Cho_ChkInt(xInt,Diag,iSym,nErr,Tol,Report)
         Call Cho_P_QualSwp()
      Else
         Call Cho_ChkInt(xInt,Diag,iSym,nErr,Tol,Report)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Roland Lindh                                     *
!***********************************************************************

subroutine Trsn(xyz,nCent,Tau,Bt,lWrite,lWarn,Label,dBt,ldB)
!***********************************************************************
!                                                                      *
! Reference: Molecular Vibrations, E. Bright Wilson, Jr, J. C. Decicius*
!            and Paul C. Cross, Sec. 4-1, Eq. 20-24                    *
!                                                                      *
! R.Lindh May-June '96                                                 *
!***********************************************************************

use Constants, only: Zero, One, Two, Pi, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCent
real(kind=wp), intent(in) :: xyz(3,nCent)
real(kind=wp), intent(out) :: Tau, Bt(3,nCent)
logical(kind=iwp), intent(in) :: lWrite, lWarn, ldB
character(len=8), intent(in) :: Label
real(kind=wp), intent(inout) :: dBt(3,nCent,3,nCent)
integer(kind=iwp) :: ix, iy, iz, jx, jy, jz, mCent
real(kind=wp) :: Bf2(3,3), Bf3(3,3), BRij(3,2), BRjk(3,2), BRkl(3,2), CosFi2, CosFi3, CosTau, dBRij(3,2,3,2), dBRjk(3,2,3,2), &
                 dBRkl(3,2,3,2), dFi2, dFi3, dTau, Dum(1), Fac, Fi2, Fi3, Rij1, Rjk1, Rkl1, SinFi2, SinFi3, SinTau

mCent = 2
call Strtch(xyz(1,1),mCent,Rij1,BRij,.false.,Label,dBRij,ldB)
call Strtch(xyz(1,2),mCent,Rjk1,BRjk,.false.,Label,dBRjk,ldB)
call Strtch(xyz(1,3),mCent,Rkl1,BRkl,.false.,Label,dBRkl,ldB)
mCent = 3
call Bend(xyz(1,1),mCent,Fi2,Bf2,.false.,.false.,Label,Dum,.false.)
SinFi2 = sin(Fi2)
CosFi2 = cos(Fi2)
call Bend(xyz(1,2),mCent,Fi3,Bf3,.false.,.false.,Label,Dum,.false.)
SinFi3 = sin(Fi3)
CosFi3 = cos(Fi3)

if (SinFi2*SinFi3 < 1.0e-13_wp) then
  Tau = Zero
  dTau = Zero
  if (lWrite) write(u6,1) Label,-dTau,-Tau
  return
end if

! Get the angle between the two planes, i.e. the
! angle between the normal vectors.
!
! r123 * r234 = CosTau

CosTau = ((BRij(2,1)*BRjk(3,2)-BRij(3,1)*BRjk(2,2))*(BRjk(2,1)*BRkl(3,2)-BRjk(3,1)*BRkl(2,2))+ &
          (BRij(3,1)*BRjk(1,2)-BRij(1,1)*BRjk(3,2))*(BRjk(3,1)*BRkl(1,2)-BRjk(1,1)*BRkl(3,2))+ &
          (BRij(1,1)*BRjk(2,2)-BRij(2,1)*BRjk(1,2))*(BRjk(1,1)*BRkl(2,2)-BRjk(2,1)*BRkl(1,2)))/(SinFi2*SinFi3)

! For the vector product of the two vectors. This
! will give a vector parallel to e23. The direction
! relative to e23 defines the sign.
!
! e123 X e234 = SinTau * e23

SinTau = (BRij(1,2)*(BRjk(2,1)*BRkl(3,2)-BRjk(3,1)*BRkl(2,2))+BRij(2,2)*(BRjk(3,1)*BRkl(1,2)-BRjk(1,1)*BRkl(3,2))+ &
          BRij(3,2)*(BRjk(1,1)*BRkl(2,2)-BRjk(2,1)*BRkl(1,2)))/(SinFi2*SinFi3)

! (-Pi < Tau <= Pi)

Tau = atan2(SinTau,CosTau)
if (abs(Tau) == Pi) Tau = Pi

dTau = Tau/deg2rad
dFi2 = Fi2/deg2rad
dFi3 = Fi3/deg2rad
if (lWarn) then
  if ((dTau > 177.5_wp) .or. (dTau < -177.5_wp)) call WarningMessage(1,' Warning: dihedral angle close to end of range')
  if ((dFi2 > 177.5_wp) .or. (dFi2 < 2.5_wp)) call WarningMessage(1,' Warning: bond angle 2 close to end of range')
  if ((dFi3 > 177.5_wp) .or. (dFi3 < 2.5_wp)) call WarningMessage(1,' Warning: bond angle 3 close to end of range')
end if
if (lWrite) write(u6,1) Label,-dTau,-Tau

! Compute the WDC matrix.

do ix=1,3
  iy = ix+1
  if (iy > 3) iy = iy-3
  iz = iy+1
  if (iz > 3) iz = iz-3
  Bt(ix,1) = (BRij(iy,2)*BRjk(iz,2)-BRij(iz,2)*BRjk(iy,2))/(Rij1*SinFi2**2)
  Bt(ix,4) = (BRkl(iy,1)*BRjk(iz,1)-BRkl(iz,1)*BRjk(iy,1))/(Rkl1*SinFi3**2)
  Bt(ix,2) = -((Rjk1-Rij1*CosFi2)*Bt(ix,1)+Rkl1*CosFi3*Bt(ix,4))/Rjk1
  Bt(ix,3) = -(Bt(ix,1)+Bt(ix,2)+Bt(ix,4))
end do

if (ldB) then

  ! Compute the derivative of the WDC matrix.

  do ix=1,3
    iy = ix+1
    if (iy > 3) iy = iy-3
    iz = iy+1
    if (iz > 3) iz = iz-3
    do jx=1,ix
      jy = jx+1
      if (jy > 3) jy = jy-3
      jz = jy+1
      if (jz > 3) jz = jz-3

      dBt(ix,1,jx,1) = (dBRij(ix,1,jy,2)*BRjk(jz,2)-dBRij(ix,1,jz,2)*BRjk(jy,2)- &
                        Bt(jx,1)*(BRij(ix,1)*SinFi2**2+Rij1*Two*SinFi2*CosFi2*Bf2(ix,1)))/(Rij1*SinFi2**2)
      dBt(ix,1,jx,2) = -((-BRij(ix,1)*CosFi2+Rij1*SinFi2*Bf2(ix,1))*Bt(jx,1)+(Rjk1-Rij1*CosFi2)*dBt(ix,1,jx,1))/Rjk1
      dBt(jx,2,ix,1) = dBt(ix,1,jx,2)
      dBt(ix,1,jx,4) = Zero
      dBt(jx,4,ix,1) = dBt(ix,1,jx,4)
      dBt(ix,1,jx,3) = -(dBt(ix,1,jx,1)+dBt(ix,1,jx,2))
      dBt(jx,3,ix,1) = dBt(ix,1,jx,3)
      dBt(ix,4,jx,4) = (dBRkl(ix,2,jy,1)*BRjk(jz,1)-dBRkl(ix,2,jz,1)*BRjk(jy,1)- &
                        Bt(jx,4)*(BRkl(ix,2)*SinFi3**2+Rkl1*Two*SinFi3*CosFi3*Bf3(ix,3)))/(Rkl1*SinFi3**2)
      dBt(ix,4,jx,3) = -((-BRkl(ix,2)*CosFi3+Rkl1*SinFi3*Bf3(ix,3))*Bt(jx,4)+(Rjk1-Rkl1*CosFi3)*dBt(ix,4,jx,4))/Rjk1
      dBt(jx,3,ix,4) = dBt(ix,4,jx,3)
      dBt(ix,4,jx,2) = -(dBt(ix,4,jx,4)+dBt(ix,4,jx,3))
      dBt(jx,2,ix,4) = dBt(ix,4,jx,2)
      if (ix /= jx) then
        dBt(jx,1,ix,1) = dBt(ix,1,jx,1)
        dBt(ix,4,jx,1) = Zero
        dBt(jx,4,ix,4) = dBt(ix,4,jx,4)
        dBt(jx,1,ix,4) = dBt(ix,4,jx,1)
        dBt(jx,1,ix,2) = -((-BRij(jx,1)*CosFi2+Rij1*SinFi2*Bf2(jx,1))*Bt(ix,1)+(Rjk1-Rij1*CosFi2)*dBt(jx,1,ix,1))/Rjk1
        dBt(ix,2,jx,1) = dBt(jx,1,ix,2)
        dBt(ix,3,jx,1) = -(dBt(ix,1,jx,1)+dBt(ix,2,jx,1)+dBt(ix,4,jx,1))
        dBt(jx,1,ix,3) = dBt(ix,3,jx,1)
        dBt(jx,4,ix,3) = -((-BRkl(jx,2)*CosFi3+Rkl1*SinFi3*Bf3(jx,3))*Bt(ix,4)+(Rjk1-Rkl1*CosFi3)*dBt(jx,4,ix,4))/Rjk1
        dBt(ix,3,jx,4) = dBt(jx,4,ix,3)
        dBt(ix,2,jx,4) = -(dBt(ix,4,jx,4)+dBt(ix,3,jx,4))
        dBt(jx,4,ix,2) = dBt(ix,2,jx,4)
      end if
      dBt(ix,2,jx,3) = -((BRjk(ix,1)+Rkl1*SinFi3*Bf3(ix,1))*Bt(jx,4)+(Rjk1-Rkl1*CosFi3)*dBt(ix,2,jx,4)+ &
                         (BRij(ix,2)*CosFi2-Rij1*SinFi2*Bf2(ix,2))*Bt(jx,1)+Rij1*CosFi2*dBt(ix,2,jx,1)+Bt(jx,3)*BRjk(ix,1))/Rjk1
      dBt(jx,3,ix,2) = dBt(ix,2,jx,3)
      dBt(ix,2,jx,2) = -(dBt(ix,2,jx,1)+dBt(ix,2,jx,4)+dBt(ix,2,jx,3))
      dBt(ix,3,jx,3) = -(dBt(ix,2,jx,3)+dBt(ix,1,jx,3)+dBt(ix,4,jx,3))
      if (ix /= jx) then
        dBt(ix,3,jx,2) = -(dBt(ix,2,jx,2)+dBt(ix,1,jx,2)+dBt(ix,4,jx,2))
        dBt(jx,2,ix,3) = dBt(ix,3,jx,2)
        dBt(jx,2,ix,2) = dBt(ix,2,jx,2)
        dBt(jx,3,ix,3) = dBt(ix,3,jx,3)
      end if

    end do
  end do

end if

Fac = -One
Tau = Fac*Tau
Bt(:,:) = Fac*Bt(:,:)
if (ldB) dBt(:,:,:,:) = Fac*dBt(:,:,:,:)

return

1 format(1X,A,' : Dihedral= ',F10.4,'   / degree  ',F10.6,' / rad')

end subroutine Trsn

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,1994, Per Ake Malmqvist                           *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine POLY1(CI,NCI)
! PER-AAKE MALMQUIST, 92-12-07
! THIS PROGRAM CALCULATES THE 1-EL DENSITY
! MATRIX FOR A CASSCF WAVE FUNCTION.

use sguga, only: SGS
use caspt2_module, only: cLab10, iAdr10, nG1
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NCI
real(kind=wp), intent(in) :: CI(NCI)
integer(kind=iwp) :: nLev
real(kind=wp), allocatable :: G1TMP(:), SGM1(:)

nLev = SGS%nLev

if (NLEV > 0) then
  call mma_allocate(SGM1,NCI,LABEL='SGM1')
  call mma_allocate(G1TMP,NG1,LABEL='G1TMP')
  call DENS1_RPT2(CI,nCI,SGM1,nCI,G1TMP,nLev)
end if

! REINITIALIZE USE OF DMAT.
! The fields IADR10 and CLAB10 are kept in caspt2_module
IADR10(:,1) = -1
IADR10(:,2) = 0
CLAB10(:) = '   EMPTY'
IADR10(1,1) = 0
! HENCEFORTH, THE CALL PUT(NSIZE,LABEL,ARRAY) WILL ENTER AN
! ARRAY ON LUDMAT AND UPDATE THE TOC.
if (NLEV > 0) then
  call PT2_PUT(NG1,' GAMMA1',G1TMP)

  call mma_deallocate(SGM1)
  call mma_deallocate(G1TMP)
end if

end subroutine POLY1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2008  PER-AKE MALMQUIST                    *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE RDSCTC(ISCT,ISYM,ICASE,IVEC,VSCT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VSCT(*)

#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

C Read coefficient vector from LUSOLV (C repres).
#ifdef _DEBUGPRINT_
        WRITE(6,*)' RDSCTC (Normal repres.)'
        WRITE(6,'(a,i2,a,a,a,i2,a,i2)')' Vector nr.',IVEC,
     &          '  Case ',CASES(ICASE),' Symm ',ISYM,
     &          ' Section ',ISCT
#endif
      NAS=NASUP(ISYM,ICASE)
      NIS=NISUP(ISYM,ICASE)
      NCOEF=NAS*NIS
      IF(NCOEF.EQ.0) RETURN
      MDVEC=MODVEC(ISYM,ICASE)
*      IDS=IDSCT(ISCT,ISYM,ICASE,IVEC)
      IDS=IWORK(LIDSCT-1+ISCT+MXSCT*(ISYM-1+8*
     &                         (ICASE-1+MXCASE*(IVEC-1))))
      NCOL=MIN(NIS-MDVEC*(ISCT-1),MDVEC)
      NSCT=NAS*NCOL
      CALL DDAFILE(LUSOLV,2,VSCT,NSCT,IDS)
#ifdef _DEBUGPRINT_
        WRITE(6,*)' First few elements:'
        WRITE(6,'(1x,5f15.6)')(VSCT(I),I=1,MIN(NSCT,10))
#endif
      RETURN
      END

      SUBROUTINE RDBLKC(ISYM,ICASE,IVEC,VEC)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VEC(*)

#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

C Read coefficient vector from LUSOLV (C repres).
#ifdef _DEBUGPRINT_
        WRITE(6,*)' RDBLKC (Normal repres.)'
        WRITE(6,'(a,i2,a,a,a,i2)')' Vector nr.',IVEC,
     &          '  Case ',CASES(ICASE),' Symm ',ISYM
#endif
      NAS=NASUP(ISYM,ICASE)
      NIS=NISUP(ISYM,ICASE)
      NCOEF=NAS*NIS
      IF(NCOEF.EQ.0) RETURN
      MDVEC=MODVEC(ISYM,ICASE)
*      IDV=IDSCT(1,ISYM,ICASE,IVEC)
      IDV=IWORK(LIDSCT+MXSCT*(ISYM-1+8*
     &                         (ICASE-1+MXCASE*(IVEC-1))))
      LVEC=1
      DO 10 IISTA=1,NIS,MDVEC
        NCOL=MIN(NIS+1-IISTA,MDVEC)
        NBLK=NAS*NCOL
        CALL DDAFILE(LUSOLV,2,VEC(LVEC),NBLK,IDV)
        LVEC=LVEC+NBLK
  10  CONTINUE
#ifdef _DEBUGPRINT_
        WRITE(6,*)' First few elements:'
        WRITE(6,'(1x,5f15.6)')(VEC(I),I=1,MIN(NCOEF,10))
#endif
      RETURN
      END

************************************************************************
* New VECTOR UTILITIES, written by Steven Vancoillie, May 2011
* A set of subroutines that can transform RHS arrays using the parallel
* aware subroutines
************************************************************************

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE PSCAVEC (FACT,IVEC,JVEC)
      IMPLICIT NONE

#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"

      REAL*8 FACT
      INTEGER IVEC,JVEC

      REAL*8 CPU0,CPU1,CPU,TIO0,TIO1,TIO
      INTEGER ICASE,ISYM,NIN,NIS
      INTEGER lg_V

C Scale vector nr IVEC with scale factor FACT and put the result in
C vector nr JVEC: |JVEC> <- FACT * |IVEC>
      CALL TIMING(CPU0,CPU,TIO0,TIO)

      IF(FACT.EQ.1.0D00.AND.IVEC.EQ.JVEC) RETURN
      DO ICASE=1,NCASES
        DO ISYM=1,NSYM
          NIN=NINDEP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF (NIN*NIS.NE.0) THEN
            CALL RHS_ALLO (NIN,NIS,lg_V)
            CALL RHS_READ (NIN,NIS,lg_V,ICASE,ISYM,IVEC)
            CALL RHS_SCAL (NIN,NIS,lg_V,FACT)
            CALL RHS_SAVE (NIN,NIS,lg_V,ICASE,ISYM,JVEC)
            CALL RHS_FREE (NIN,NIS,lg_V)
          END IF
        END DO
      END DO

      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUSCA=CPUSCA+(CPU1-CPU0)
      TIOSCA=TIOSCA+(TIO1-TIO0)

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE POVLVEC (IVEC,JVEC,OVLAPS)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"

      DIMENSION OVLAPS(0:8,0:MXCASE)

C Compute overlaps of vectors nr IVEC and JVEC in SR format!, for each
C individual case and symmetry block, in OVLAPS(ISYM,ICASE), summed over
C symmetry in OVLAPS(0,ICASE), summed over case in OVLAPS(ISYM,0), total
C sum in OVLAPS(0,0).
      CALL TIMING(CPU0,CPU,TIO0,TIO)

      OVLTOT=0.0D0
      DO ISYM=1,NSYM
        OVLAPS(ISYM,0)=0.0D0
      END DO
      DO ICASE=1,NCASES
        OVLSUM=0.0D0
        DO ISYM=1,NSYM
          OVL=0.0D0
          NIN=NINDEP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF (NIN*NIS.NE.0) THEN
            CALL RHS_ALLO (NIN,NIS,lg_V1)
            CALL RHS_READ (NIN,NIS,lg_V1,ICASE,ISYM,IVEC)
            IF (IVEC.NE.JVEC) THEN
              CALL RHS_ALLO (NIN,NIS,lg_V2)
              CALL RHS_READ (NIN,NIS,lg_V2,ICASE,ISYM,JVEC)
            ELSE
              lg_V2=lg_V1
            END IF
            OVL=RHS_DDOT(NIN,NIS,lg_V1,lg_V2)
            CALL RHS_FREE (NIN,NIS,lg_V1)
            IF (IVEC.NE.JVEC) THEN
              CALL RHS_FREE (NIN,NIS,lg_V2)
            END IF
          END IF
          OVLAPS(ISYM,ICASE)=OVL
          OVLAPS(ISYM,0)=OVLAPS(ISYM,0)+OVL
          OVLSUM=OVLSUM+OVL
        END DO
        OVLAPS(0,ICASE)=OVLSUM
        OVLTOT=OVLTOT+OVLSUM
      END DO
      OVLAPS(0,0)=OVLTOT

      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUOVL=CPUOVL+(CPU1-CPU0)
      TIOOVL=TIOOVL+(TIO1-TIO0)

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE PLCVEC (ALPHA,BETA,IVEC,JVEC)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"

C |JVEC> := BETA*|JVEC> + ALPHA*|IVEC>, IVEC and JVEC in SR format!

      IF(BETA.EQ.1.0D0.AND.ALPHA.EQ.0.0D0) RETURN

      CALL TIMING(CPU0,CPU,TIO0,TIO)

      DO 100 ICASE=1,NCASES
        DO 101 ISYM=1,NSYM
          NIN=NINDEP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF(NIN*NIS.EQ.0) GOTO 101

          CALL RHS_ALLO (NIN,NIS,lg_V2)
          IF(BETA.NE.0.0D0.AND.ALPHA.NE.0.0D0) THEN
            CALL RHS_ALLO (NIN,NIS,lg_V1)
          END IF

          IF(BETA.EQ.0.0D0.AND.ALPHA.EQ.0.0D0) THEN
              CALL RHS_SCAL (NIN,NIS,lg_V2,0.0D0)
          ELSE IF(BETA.NE.0.0D0) THEN
            CALL RHS_READ (NIN,NIS,lg_V2,ICASE,ISYM,JVEC)
            IF (ALPHA.NE.0.0D0) THEN
              CALL RHS_SCAL (NIN,NIS,lg_V2,BETA)
              CALL RHS_READ (NIN,NIS,lg_V1,ICASE,ISYM,IVEC)
              CALL RHS_DAXPY (NIN,NIS,ALPHA,lg_V1,lg_V2)
            ELSE
              CALL RHS_SCAL (NIN,NIS,lg_V2,BETA)
            END IF
          ELSE IF(ALPHA.NE.0.0D0) THEN
            CALL RHS_READ (NIN,NIS,lg_V2,ICASE,ISYM,IVEC)
            CALL RHS_SCAL (NIN,NIS,lg_V2,ALPHA)
          END IF

          CALL RHS_SAVE (NIN,NIS,lg_V2,ICASE,ISYM,JVEC)

          CALL RHS_FREE (NIN,NIS,lg_V2)
          IF(ALPHA.NE.0.0D0) THEN
            CALL RHS_FREE (NIN,NIS,lg_V1)
          END IF
 101    CONTINUE
 100  CONTINUE

      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPULCS=CPULCS+(CPU1-CPU0)
      TIOLCS=TIOLCS+(TIO1-TIO0)

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE PTRTOC (ITYPE,IVEC,JVEC)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"

C Transform RHS vectors from SR format to C format.
C ITYPE=0 uses only T matrix, ITYPE=1 uses S*T matrix

      CALL TIMING(CPU0,CPU,TIO0,TIO)

      DO 200 ICASE=1,NCASES
        IF(IVEC.EQ.JVEC .AND. ICASE.EQ.12) GOTO 200
        IF(IVEC.EQ.JVEC .AND. ICASE.EQ.13) GOTO 200
        DO 100 ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          IF(NAS.EQ.0) GOTO 100
          NIN=NINDEP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF(NIS.EQ.0) GOTO 100
          CALL RHS_ALLO (NAS,NIS,lg_V2)
          IF(ICASE.NE.12 .AND. ICASE.NE.13) THEN
            IF(NIN.GT.0) THEN
              CALL RHS_ALLO (NIN,NIS,lg_V1)
              CALL RHS_READ (NIN,NIS,lg_V1,ICASE,ISYM,IVEC)
              CALL RHS_SR2C (ITYPE,0,NAS,NIS,NIN,lg_V1,lg_V2,ICASE,ISYM)
              CALL RHS_FREE (NIN,NIS,lg_V1)
            ELSE
              CALL RHS_SCAL (NAS,NIS,lg_V2,0.0D0)
            END IF
          ELSE
            CALL RHS_READ (NAS,NIS,lg_V2,ICASE,ISYM,IVEC)
          END IF

          CALL RHS_SAVE (NAS,NIS,lg_V2,ICASE,ISYM,JVEC)

          CALL RHS_FREE (NAS,NIS,lg_V2)

 100    CONTINUE
 200  CONTINUE

      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUVEC=CPUVEC+(CPU1-CPU0)
      TIOVEC=TIOVEC+(TIO1-TIO0)

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE PTRTOSR (ITYPE,IVEC,JVEC)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"

C Transform RHS vectors from SR format to C format.
C ITYPE=0 uses only T matrix, ITYPE=1 uses S*T matrix

      CALL TIMING(CPU0,CPU,TIO0,TIO)

      DO 200 ICASE=1,NCASES
        IF(IVEC.EQ.JVEC .AND. ICASE.EQ.12) GOTO 200
        IF(IVEC.EQ.JVEC .AND. ICASE.EQ.13) GOTO 200
        DO 100 ISYM=1,NSYM
          NIN=NINDEP(ISYM,ICASE)
          IF(NIN.EQ.0) GOTO 100
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF(NIS.EQ.0) GOTO 100
          CALL RHS_ALLO (NIN,NIS,lg_V1)
          IF(ICASE.NE.12 .AND. ICASE.NE.13) THEN
            IF(NAS.GT.0) THEN
              CALL RHS_ALLO (NAS,NIS,lg_V2)
              CALL RHS_READ (NAS,NIS,lg_V2,ICASE,ISYM,IVEC)
              CALL RHS_SR2C (ITYPE,1,NAS,NIS,NIN,lg_V1,lg_V2,ICASE,ISYM)
              CALL RHS_FREE (NAS,NIS,lg_V2)
            ELSE
              CALL RHS_SCAL (NIN,NIS,lg_V1,0.0D0)
            END IF
          ELSE
            CALL RHS_READ (NIN,NIS,lg_V1,ICASE,ISYM,IVEC)
          END IF

          CALL RHS_SAVE (NIN,NIS,lg_V1,ICASE,ISYM,JVEC)

          CALL RHS_FREE (NIN,NIS,lg_V1)

 100    CONTINUE
 200  CONTINUE

      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUVEC=CPUVEC+(CPU1-CPU0)
      TIOVEC=TIOVEC+(TIO1-TIO0)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetA2AP()
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Set up atom to atom pair mapping
C              (stored in ldf_a2ap.fh).
C              To unset, call LDF_UnsetA2AP.
C
C     The mapping can be used as follows:
C


C
C     Integer  LDF_nAtom
C     External LDF_nAtom
C
C     Integer A, AB, iAB
C     Integer NumberOfAtomPairsContainingA
C     Integer PointerToListOfAtomPairsContainingA
C
C     Integer i, j
C     Integer A2AP
C     A2AP(i,j)=iWork(ip_A2AP-1+2*(j-1)+i)
C
C     Do A=1,LDF_nAtom()
C        NumberOfAtomPairsContainingA=A2AP(1,A)
C        PointerToListOfAtomPairsContainingA=A2AP(2,A)
C        Do iAB=1,NumberOfAtomPairsContainingA
C           AB=iWork(PointerToListOfAtomPairsContainingA-1+iAB)
C           ....do stuff for atom pair AB....
C        End Do
C     End Do
C
      Implicit None
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_a2ap.fh"

      Character*11 SecNam
      Parameter (SecNam='LDF_SetA2AP')

      Integer  LDF_nAtom
      External LDF_nAtom

#if defined (_DEBUGPRINT_)
      Integer n, iAB
#endif
      Integer nAtoms
      Integer ip, l
      Integer AB, A, B

      Character*8 Label

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      If (l_A2AP.gt.0) Then
#if defined (_DEBUGPRINT_)
         Call WarningMessage(0,
     &                SecNam//': atom to atom pair map already set up!')
#endif
         Return
      End If

      nAtoms=LDF_nAtom()

      l_A2AP=2*nAtoms
      Call GetMem('LDFA2AP','Allo','Inte',ip_A2AP,l_A2AP)
      Call iZero(iWork(ip_A2AP),l_A2AP)

      Do AB=1,NumberOfAtomPairs
         A=AP_Atoms(1,AB)-1
         B=AP_Atoms(2,AB)-1
         iWork(ip_A2AP+2*A)=iWork(ip_A2AP+2*A)+1
         If (B.ne.A) Then
            iWork(ip_A2AP+2*B)=iWork(ip_A2AP+2*B)+1
         End If
      End Do

      Do A=0,nAtoms-1
         l=iWork(ip_A2AP+2*A)
         If (l.lt.1) Then
            Call WarningMessage(2,
     &                SecNam//': An atom is not part of any atom pair!')
            Call LDF_Quit(1)
         Else
            Write(Label,'(A3,I5.5)') 'A2P',A
            Call GetMem(Label,'Allo','Inte',ip,l)
            iWork(ip_A2AP+2*A+1)=ip
         End If
      End Do

      Do A=0,nAtoms-1
         iWork(ip_A2AP+2*A)=0
      End Do
      Do AB=1,NumberOfAtomPairs
         A=AP_Atoms(1,AB)-1
         B=AP_Atoms(2,AB)-1
         ip=iWork(ip_A2AP+2*A+1)
         iWork(ip+iWork(ip_A2AP+2*A))=AB
         iWork(ip_A2AP+2*A)=iWork(ip_A2AP+2*A)+1
         If (B.ne.A) Then
            ip=iWork(ip_A2AP+2*B+1)
            iWork(ip+iWork(ip_A2AP+2*B))=AB
            iWork(ip_A2AP+2*B)=iWork(ip_A2AP+2*B)+1
         End If
      End Do

#if defined (_DEBUGPRINT_)
      n=0
      Do A=1,nAtoms
         l=iWork(ip_A2AP+2*(A-1))
         If (l.lt.1) Then
            Call WarningMessage(1,
     &                SecNam//': an atom is not part of any atom pair!')
            Write(6,'(A,I9)') 'Atom=',A
            Call xFlush(6)
            n=n+1
         Else
            ip=iWork(ip_A2AP+2*(A-1)+1)
            Do iAB=1,l
               AB=iWork(ip-1+iAB)
               If (AP_Atoms(1,AB).ne.A .and. AP_Atoms(2,AB).ne.A) Then
                  n=n+1
               End If
            End Do
         End If
      End Do
      If (n.ne.0) Then
         Call WarningMessage(2,SecNam//': Error detected!')
         Call LDF_Quit(1)
      End If
#endif

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_UnsetA2AP()
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: shut down atom to atom pair mapping.
C
      Implicit None
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_a2ap.fh"

      Character*13 SecNam
      Parameter (SecNam='LDF_UnsetA2AP')

      Integer  LDF_nAtom
      External LDF_nAtom

      Character*8 Label

      Integer A, ip, l

      If (l_A2AP.lt.1) Then
#if defined (_DEBUGPRINT_)
         Call WarningMessage(0,
     &                 SecNam//' called, but A2AP has not been set up!')
         Call xFlush(6)
#endif
         Return
      End If

      Do A=0,LDF_nAtom()-1
         l=iWork(ip_A2AP+2*A)
         If (l.lt.1) Then
            Call WarningMessage(2,
     &                SecNam//': an atom is not part of any atom pair!')
            Call LDF_Quit(1)
         Else
            ip=iWork(ip_A2AP+2*A+1)
            Write(Label,'(A3,I5.5)') 'A2P',A
            Call GetMem(Label,'Free','Inte',ip,l)
         End If
      End Do
      Call GetMem('LDFA2AP','Free','Inte',ip_A2AP,l_A2AP)
      ip_A2AP=0
      l_A2AP=0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_PrintA2AP()
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: print atom to atom pair mapping.
C
      Implicit None
#include "WrkSpc.fh"
#include "ldf_a2ap.fh"

#if defined (_DEBUGPRINT_)
      Character*13 SecNam
      Parameter (SecNam='LDF_PrintA2AP')
#endif

      Integer  LDF_nAtom
      External LDF_nAtom

      Integer A, n, ip

      Integer i, j
      Integer A2AP
      A2AP(i,j)=iWork(ip_A2AP-1+2*(j-1)+i)

      If (l_A2AP.lt.1) Then
#if defined (_DEBUGPRINT_)
         Call WarningMessage(0,
     &         SecNam//' called, but atom to atom pair map not set up!')
         Call xFlush(6)
#endif
         Return
      End If

      Call Cho_Head('Atom to Atom Pair Map','-',80,6)
      Write(6,'(/,A)') '    Atom   #Pairs           List of Pairs'
      Write(6,'(118A1)') ('-',i=1,118)
      Do A=1,LDF_nAtom()
         n=A2AP(1,A)
         ip=A2AP(2,A)
         Call LDF_PrintAtomInfo_(A,n,iWork(ip))
      End Do
      Write(6,'(118A1)') ('-',i=1,118)
      Call xFlush(6)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine RdNLst_(iUnit,NameIn,No_Input_OK)
!***********************************************************************
!                                                                      *
!     Locate the beginning of an input stream                          *
!     (similar to FORTRAN NAMELIST read known to some systems)         *
!                                                                      *
!     calling arguments:                                               *
!     iUnit  : Type integer, input                                     *
!              FORTRAN unit number                                     *
!     NameIn : Type character string, input                            *
!              Character string marking the beginning of the input     *
!     No_Input_OK: Logical                                             *
!                  On input determines if an input has to be found     *
!                  On exit determines if an input was found.           *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher and P.O. Widmark                                  *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iUnit
character(len=*), intent(in) :: NameIn
logical(kind=iwp), intent(inout) :: No_Input_OK
integer(kind=iwp) :: istatus, lStdNam
character(len=80) :: Line
character(len=8) :: StdNam

call ResetErrorLine()
!----------------------------------------------------------------------*
! push the entry name on the calling stack                             *
!----------------------------------------------------------------------*
!----------------------------------------------------------------------*
! convert the Name to internal standard format.                        *
!----------------------------------------------------------------------*
call StdFmt(NameIn,StdNam)
lStdNam = len_trim(StdNam)
!----------------------------------------------------------------------*
! read until an input Line is located which starts with                *
! the string, Name, not before the second column                       *
!----------------------------------------------------------------------*
do
  read(iUnit,'(A)',iostat=istatus) Line
  call Error(istatus)
  call UpCase(Line)
  Line = adjustl(Line)
  if ((Line(1:1) == '&') .and. (Line(2:lStdNam+1) == StdNam(1:lStdNam))) exit
end do

contains

!----------------------------------------------------------------------*
! error exit                                                           *
!----------------------------------------------------------------------*
subroutine Error(rc)

  integer(kind=iwp), intent(in) :: rc

  select case (rc)
    case (0)
      ! do nothing
    case (:-1)
      if (No_Input_OK) then
        No_Input_OK = .false.
      else
        write(u6,*) 'RdNLst: Input section not found in input file'
        write(u6,*) '        Looking for:',StdNam(1:lStdNam)
        call Quit_OnUserError()
      end if
    case default
      call Abend()
  end select

end subroutine Error

end subroutine RdNLst_

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************
!  ParaRoot
!
!> @brief
!>   Manage the parallel tempering routine
!> @author A. Ohrn
!>
!> @details
!> If our system is difficult and has small transition elements
!> in the Markov chain, we can use the parallel tempering to
!> boost sampling. This routine is the root for this; it
!> mainly handles the various configurations for the different
!> temperature ensembles; also, manages the ensemble switch.
!>
!> @param[out]    Ract
!> @param[out]    BetaBol
!> @param[out]    Etot
!> @param[in,out] CalledBefore
!> @param[out]    SampleThis
!***********************************************************************

subroutine ParaRoot(Ract,BetaBol,Etot,CalledBefore,SampleThis)

use qmstat_global, only: Cordst, iLuStIn, iLuStUt, iSeed, nCent, nPart, nStFilT, nTemp, ParaTemps, StFilIn, StFilUt
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, auTokJ, KBoltzmann
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: Ract, BetaBol, Etot
logical(kind=iwp), intent(inout) :: CalledBefore
logical(kind=iwp), intent(out) :: SampleThis
integer(kind=iwp) :: iEnsemb, iPa, iTemp = 0, mTemp
real(kind=wp) :: B1, B2, BigDelta, Dum, Dum1, E1, E2, Expe, Expran, PerType, R1, R2, T1, T2
logical(kind=iwp) :: WeiterBitte, Accept
integer(kind=iwp), allocatable :: iPermutation(:,:)
real(kind=wp), allocatable :: CordstTEMP(:,:)
real(kind=wp), parameter :: BoltzK = 1.0e-3_wp*KBoltzmann/auTokJ
real(kind=wp), external :: Random_Molcas

Dum1 = Zero

! If this is first time to call on this routine.

if (.not. CalledBefore) then
  iTemp = 0
  CalledBefore = .true.
end if

! See what to do.

call mma_allocate(CordstTEMP,3,nCent*nPart,label='CordstTEMP')
call mma_allocate(iPermutation,2,nTemp,label='iPermutation')

do
  if (iTemp < nTemp) then
    WeiterBitte = .true.
    iTemp = iTemp+1
    write(u6,*)
    write(u6,*) '    Run a new temperature ensemble...',iTemp

    ! A logical variable to make parallel tempering sampling correct.
    if (iTemp == 1) then
      SampleThis = .true.
    else
      SampleThis = .false.
    end if

  else
    WeiterBitte = .false.
    iTemp = 0
    write(u6,*)
    write(u6,*) '    Evaluate temperature ensemble interchanges.'
  end if

  if (WeiterBitte) then
    ! If we are to run a new ensemble.

    iLuStIn = 8+nStFilT(iTemp)
    iLuStUt = 16+nStFilT(iTemp)
    write(StFilIn(6:6),'(i1.1)') nStFilT(iTemp)
    write(StFilUt(6:6),'(i1.1)') nStFilT(iTemp)

    ! Collect coordinates from proper startfile.
    call Get8(Ract,Etot)

    ! Set temperature.
    BetaBol = One/(ParaTemps(iTemp)*BoltzK)
    exit

  else
    ! If we are to attempt interchanges.

    do iPa=1,nTemp
      iPermutation(:,iPa) = iPa
    end do

    ! Construct permutations, treat nTemp == 2 as special case, the others
    ! are obtained with general algorithm.
    if (nTemp == 2) then
      iPermutation(2,1) = 2
      iPermutation(2,2) = 1
    else

      PerType = Random_Molcas(iSeed)
      if (PerType < Half) then

        if (mod(nTemp,2) == 1) then
          mTemp = nTemp-1
        else
          mTemp = nTemp
        end if

        ! Construct permutation for odd iMac
        do iPa=1,mTemp,2
          iPermutation(2,iPa) = iPermutation(1,iPa+1)
          iPermutation(2,iPa+1) = iPermutation(1,iPa)
        end do

      else

        mTemp = 2*((nTemp-1)/2)
        ! Construct permutation for even iMac
        do iPa=2,mTemp,2
          iPermutation(2,iPa) = iPermutation(1,iPa+1)
          iPermutation(2,iPa+1) = iPermutation(1,iPa)
        end do
      end if

    end if

    ! Now attempt interchange.

    iEnsemb = 1
    do
      if (iPermutation(1,iEnsemb) == iPermutation(2,iEnsemb)) then
        iEnsemb = iEnsemb+1
        cycle
      end if

      ! Collect energies for the permutations.
      iLuStIn = 8+nStFilT(iPermutation(1,iEnsemb))
      iLuStUt = 16+nStFilT(iPermutation(1,iEnsemb))
      write(StFilIn(6:6),'(i1.1)') nStFilT(iPermutation(1,iEnsemb))
      write(StFilUt(6:6),'(i1.1)') nStFilT(iPermutation(1,iEnsemb))
      call Get8(Dum,E1)
      iLuStIn = 8+nStFilT(iPermutation(2,iEnsemb))
      iLuStUt = 16+nStFilT(iPermutation(2,iEnsemb))
      write(StFilIn(6:6),'(i1.1)') nStFilT(iPermutation(2,iEnsemb))
      write(StFilUt(6:6),'(i1.1)') nStFilT(iPermutation(2,iEnsemb))
      call Get8(Dum,E2)
      T1 = ParaTemps(iPermutation(1,iEnsemb))
      T2 = ParaTemps(iPermutation(2,iEnsemb))
      B1 = One/(BoltzK*T1)
      B2 = One/(BoltzK*T2)

      ! Make the Metropolis thing.
      BigDelta = (B2-B1)*(E2-E1)
      Expe = exp(BigDelta)
      Accept = .true.
      if (Expe < One) then
        Expran = Random_Molcas(iSeed)
        if (Expe < Expran) Accept = .false.
      end if

      if (Accept) then
        ! Ct=C2
        iLuStIn = 8+nStFilT(iPermutation(2,iEnsemb))
        iLuStUt = 16+nStFilT(iPermutation(2,iEnsemb))
        write(StFilIn(6:6),'(i1.1)') nStFilT(iPermutation(2,iEnsemb))
        write(StFilUt(6:6),'(i1.1)') nStFilT(iPermutation(2,iEnsemb))
        call Get8(R2,E2)
        CordstTEMP(:,:) = Cordst
        ! C2=C1
        iLuStIn = 8+nStFilT(iPermutation(1,iEnsemb))
        iLuStUt = 16+nStFilT(iPermutation(1,iEnsemb))
        write(StFilIn(6:6),'(i1.1)') nStFilT(iPermutation(1,iEnsemb))
        write(StFilUt(6:6),'(i1.1)') nStFilT(iPermutation(1,iEnsemb))
        call Get8(R1,E1)
        iLuStIn = 8+nStFilT(iPermutation(2,iEnsemb))
        iLuStUt = 16+nStFilT(iPermutation(2,iEnsemb))
        write(StFilIn(6:6),'(i1.1)') nStFilT(iPermutation(2,iEnsemb))
        write(StFilUt(6:6),'(i1.1)') nStFilT(iPermutation(2,iEnsemb))
        call Put8(R1,E1,Dum1,Dum1,Dum1)
        ! C1=Ct
        Cordst(:,:) = CordstTEMP
        iLuStIn = 8+nStFilT(iPermutation(1,iEnsemb))
        iLuStUt = 16+nStFilT(iPermutation(1,iEnsemb))
        write(StFilIn(6:6),'(i1.1)') nStFilT(iPermutation(1,iEnsemb))
        write(StFilUt(6:6),'(i1.1)') nStFilT(iPermutation(1,iEnsemb))
        call Put8(R2,E2,Dum1,Dum1,Dum1)
      end if

      iEnsemb = iEnsemb+2
      if (Accept) write(u6,*) '            accepted!'
      if (.not. Accept) write(u6,*) '            not accepted!'
      if (iEnsemb >= nTemp) exit
    end do
    write(u6,*)

    ! Do some stuff before exit. The reason we go back up is that this
    ! way we will collect the right coordinates from first startfile.
    ! Observe that iTemp has been reset hence we are back at the
    ! square one again.

  end if
end do

call mma_deallocate(CordstTEMP)
call mma_deallocate(iPermutation)

return

end subroutine ParaRoot

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3reaintsta(wrk,wrksize)
! this routine reads integral file INTSTA (reorg), which contains
! following integrals: foka,fokb,
! <kl||ij>aaaa,<kl||ij>bbbb,<kl||ij>abab - naplano
! <ka||ij>aaaa,<ka||ij>bbbb,<ka||ij>abab,<ka||ij>baab
! <ab||ij>aaaa,<ab||ij>bbbb,<ab||ij>abab
!
! two electron integrals are read to their fix files,
! foka,fokb are read to N,P help files
!
! use and destroy : N,P

use CCT3_global, only: daddr, iokey, n, px, w11, w12, w13, w14, w21, w22, w23
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
integer(kind=iwp) :: lunsta, rc

!* open INTSTA file
lunsta = 1
if (iokey == 1) then
  ! Fortran IO
  !open(unit=lunsta,file='INTSTA',form='unformatted')
  call molcas_binaryopen_vanilla(lunsta,'INTSTA')

else
  ! MOLCAS IO
  call daname(lunsta,'INTSTA')
  daddr(lunsta) = 0
end if

!1 read foka to N
call cct3_getmediate(wrk,wrksize,lunsta,n,rc)

!2 read fokb to P
call cct3_getmediate(wrk,wrksize,lunsta,px,rc)

!3 read <kl||ij>aaaa to W23 - naplano
call cct3_getmediate(wrk,wrksize,lunsta,w23,rc)

!4 read <kl||ij>bbbb to W23 - naplano
call cct3_getmediate(wrk,wrksize,lunsta,w23,rc)

!5 read <kl||ij>abab to W23 - naplano
call cct3_getmediate(wrk,wrksize,lunsta,w23,rc)

!6 read <ie||mn>aaaa to W11
call cct3_getmediate(wrk,wrksize,lunsta,w11,rc)

!7 read <ie||mn>bbbb to W12
call cct3_getmediate(wrk,wrksize,lunsta,w12,rc)

!8 read <ie||mn>abab to W13
call cct3_getmediate(wrk,wrksize,lunsta,w13,rc)

!9 read <ie||mn>baab to W14
call cct3_getmediate(wrk,wrksize,lunsta,w14,rc)

!10 read <ab||ij>aaaa to W21
call cct3_getmediate(wrk,wrksize,lunsta,w21,rc)

!11 read <ab||ij>bbbb to W22
call cct3_getmediate(wrk,wrksize,lunsta,w22,rc)

!12 read <ab||ij>abab to W23
call cct3_getmediate(wrk,wrksize,lunsta,w23,rc)

!* close INTSTA file

if (iokey == 1) then
  ! Fortran IO
  close(lunsta)

else
  ! MOLCAS IO
  call daclos(lunsta)
end if

return

end subroutine t3reaintsta

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE NATORB_CPF(D,CM,CMO,DSYM,CAO,OCC,M)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION D(*),CM(*),CMO(*),DSYM(*),CAO(*),OCC(*)

#include "SysDef.fh"

#include "cpfmcpf.fh"
C     FORM DENSITY MATRIX BY SYMMETRY
      NBM=NBAS(M)
      IF(NBM.EQ.0)RETURN
      IF(NORB(M).EQ.0)RETURN
      IF(IPRINT.GE.15)WRITE(6,1)M
1     FORMAT(///,5X,'SYMMETRY NUMBER',I3)
      NBP=0
      M1=M-1
      DO 7 I=1,M1
      NBP=NBP+NORB(I)
7     CONTINUE
      NFR=NFRO(M)
      NORBM=NFR+NISH(M)+NASH(M)+NVIR(M)
      IF(NORBM.EQ.0) Return
      NORBM2=IROW(NORBM+1)
      DO 5 I=1,NORBM2
         DSYM(I)=0.0D0
5     CONTINUE
      IF(NFR.EQ.0)GO TO 10
      II=0
      DO 11 I=1,NFR
         II=II+I
         DSYM(II)=2.0D0
11    CONTINUE
C     REST OF DENSITY MATRIX
10    IJ=0
      DO 15 I=1,NORBM
         DO 20 J=1,I
            IJ=IJ+1
            NI=ICH(NBP+I)
            IF(NI.LT.0)GO TO 20
            NJ=ICH(NBP+J)
            IF(NJ.LT.0)GO TO 20
            NIJ=IROW(NI)+NJ
            IF(NJ.GT.NI)NIJ=IROW(NJ)+NI
            DSYM(IJ)=D(NIJ)
20       CONTINUE
15    CONTINUE
C     DIAGONALIZE
      CALL JACSCF(DSYM,CMO,OCC,NORBM,-1,1.D-11)
      DO 80 I=1,NORBM
      OCC(I)=-OCC(I)
80    CONTINUE
      CALL ORDER_CPF(CMO,OCC,NORBM)
      IF(IPRINT.GE.15)WRITE(6,30)
30    FORMAT(//,5X,'NATURAL ORBITALS IN MO-BASIS',//,
     *7X,'OCCUPATION NUMBER',5X,'COEFFICIENTS')
      ILAS=0
      DO 35 I=1,NORBM
      ISTA=ILAS+1
      ILAS=ILAS+NORBM
      OCC(I)=-OCC(I)
      IF(IPRINT.GE.15)WRITE(6,40)I,OCC(I),(CMO(J),J=ISTA,ILAS)
40    FORMAT(/,5X,I4,F10.6,5F10.6,/(19X,5F10.6))
35    CONTINUE
C     TRANSFORM TO AO-BASIS
      IF(IPRINT.GE.15)WRITE(6,45)
45    FORMAT(//,5X,'NATURAL ORBITALS IN AO-BASIS',//,
     *11X,'OCCUPATION NUMBER',5X,'COEFFICIENTS')
      IJ0=-NORBM
      kp = 1
      DO 50 I=1,NORBM
         IJ0=IJ0+NORBM
*
         DO 60 IP=1,NBM
            TERM=D0
            IJ=IJ0
            JP=IP-NBM
            DO 70 J=1,NORBM
               IJ=IJ+1
               JP=JP+NBM
               TERM=TERM+CMO(IJ)*CM(JP)
70          CONTINUE
            CAO(kp+IP-1)=TERM
60       CONTINUE
*
         IF(IPRINT.GE.15)WRITE(6,40)I,OCC(I),(CAO(IP),IP=kp,kp+nbm-1)
         kp = kp + NBM
50    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DrvXV(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq,lRF,KSDFT,ExFac,iCharge,iSpin,DFTFOCK,Do_DFT)

use OFembed, only: Do_OFemb, OFE_KSDFT
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nh1, iSpin
real(kind=wp), intent(inout) :: h1(nh1), TwoHam(nh1), RepNuc, ExFac
real(kind=wp), intent(in) :: D(nh1,2)
integer(kind=iwp), intent(inout) :: iCharge
logical(kind=iwp), intent(in) :: First, Dff, NonEq, lRF, Do_DFT
character(len=*), intent(in) :: KSDFT
character(len=4) :: DFTFOCK
integer(kind=iwp) :: nGrad
real(kind=wp) :: Grad(1), RN(1)
logical(kind=iwp) :: Do_ESPF, Do_Grad
character(len=8) :: Label
#ifdef _EFP_
logical(kind=iwp) :: EFP_On
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
! If first iterations save original h1 and RepNuc, the reaction
! field and/or the dft section might later modify these. Any static
! contributions to these are updated internally in the subroutine
! rctfld.

! We also save one set which are not to be modified at all.

if (First) then
  Label = 'PotNuc00'
  call Put_Temp(Label,[RepNuc],1)
  Label = 'h1_raw  '
  call Put_Temp(Label,h1,nh1)

  Label = 'PotNucXX'
  call Put_Temp(Label,[RepNuc],1)
  Label = 'h1    XX'
  call Put_Temp(Label,h1,nh1)
end if

! Start always with the original h1 and RepNuc! Observe that they
! now might contain static updates from the RF or the Langevin
! codes through the action of the subroutine rctfld.

Label = 'PotNuc00'
call Get_Temp(Label,RN,1)
RepNuc = RN(1)
Label = 'h1_raw  '
call Get_Temp(Label,h1,nh1)
!nf
!                                                                      *
!***********************************************************************
!                                                                      *
!                        ESPF section                                  *
!                                                                      *
!***********************************************************************
!                                                                      *
call DecideOnESPF(Do_ESPF)
if (Do_ESPF) call h1_espf(h1,RepNuc,nh1,First,Do_DFT)
!nf
!                                                                      *
!***********************************************************************
!                                                                      *
!              Reaction Field section                                  *
!                                                                      *
!***********************************************************************
!                                                                      *
if (lRF) call DrvRF(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq,iCharge)
!                                                                      *
!***********************************************************************
!                                                                      *
!                         DFT section                                  *
!                                                                      *
!***********************************************************************
!                                                                      *
Do_Grad = .false.
Grad = Zero
nGrad = 1
if ((KSDFT /= 'SCF') .and. Do_DFT) call DrvDFT(h1,nh1,KSDFT,ExFac,Do_Grad,Grad,nGrad,iSpin,DFTFOCK)
!                                                                      *
!***********************************************************************
!                                                                      *
!                         Orbital-Free Embedding section               *
!                                                                      *
!***********************************************************************
!                                                                      *
if (Do_OFemb) call DrvEMB(nh1,OFE_KSDFT,Do_Grad,Grad,nGrad,DFTFOCK)
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _EFP_
if (EFP_On()) call DrvEFP(First)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine DrvXV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mkiconfs_cvb()
      implicit real*8 (a-h,o-z)
      logical need_cas
c ... Make: up to date? ...
      logical, external :: up2date_cvb
c ... Files/Hamiltonian available ...
      logical, external :: valid_cvb,ifcasci_cvb,ifhamil_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "formats_cvb.fh"
#include "WrkSpc.fh"

c  ICONFS
      call rdioff_cvb(4,recinp,ioffs)
      call rdis_cvb(iwork(ll(15)),nconf*noe,recinp,ioffs)
      return
      entry mksymelm_cvb()
      call rdioff_cvb(8,recinp,ioffs)
      call rdr_cvb(work(ls(1)),nsyme*norb*norb,recinp,ioffs)
      if(ip(2).ge.1.and..not.up2date_cvb('PRSYMELM'))then
        do 300 isyme=1,nsyme
        write(6,'(/,a,i4,3x,a)')' Symmetry element no.',
     >    isyme,tags(isyme)
        ishft=norb*norb*(isyme-1)
        call mxprint_cvb(work(ishft+ls(1)),norb,norb,0)
300     continue
        if(nsyme.gt.0)write(6,*)' '
        call untouch_cvb('PRSYMELM')
      endif
      return
      entry mkconstruc_cvb()
      call construc_cvb(work(ls(15)),iwork(ls(16)))
      return
      entry mkrdint_cvb()
      return
      entry mkrdcas_cvb()
      if(ifinish.eq.0)then
        need_cas=icrit.eq.1.or.projcas
      else
        need_cas=ifcasci_cvb().and.(.not.variat)
      endif
      if(.not.need_cas)return
c  Get CASSCF eigenvector
      if(.not.ifcasci_cvb())then
        if(ip(1).ge.0.and.valid_cvb(strtci))
     >    call prtfid_cvb(' Warning: CI vector not found - no ',
     >    strtci)
        if(icrit.eq.1)then
          write(6,*)' No optimization without CASSCF vector!'
          call abend_cvb()
        endif
      else
        if(ip(3).ge.2)
     >    write(6,'(/,a)') ' Read CASSCF eigenvector:'
        call getci_cvb(work(lc(1)))
      endif
      call cinorm2_cvb(work(lc(1)),cnrm)
      cnrm=one/cnrm
      call ciscale2_cvb(work(lc(1)),cnrm,iscf,cscf)
      if((.not.up2date_cvb('CASCHECK')).or.ip(3).ge.2)then
        call untouch_cvb('CASCHECK')
c  Some checks
        if(abs(cnrm-one).gt.1.d-3)then
          if(ip(3).ge.0)write(6,formE)
     >      ' WARNING: Norm of CI vector read differs from one :',cnrm
        elseif(ip(3).ge.2)then
          write(6,formE)' Norm of CI vector read ',cnrm
        endif
        if(ip(3).ge.2.and.iscf.ne.0)then
          write(6,'(a,i6)')' SCF determinant:',iscf
          write(6,formE) '     coefficient:',cscf
        endif
        if(ifhamil_cvb())then
          call cicopy_cvb(work(lc(1)),work(lc(2)))
          call applyh_cvb(work(lc(2)))
          call cidot_cvb(work(lc(1)),work(lc(2)),eexp)
          if(ip(3).ge.1)write(6,formE)' CASSCF energy :',eexp+corenrg
          if(ip(3).ge.1)write(6,'(a)')' '
        endif
      endif
      if(.not.memplenty)call ciwr_cvb(work(lc(1)),61001.2d0)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_SetGlob()
!
! Purpose: define entries in Cholesky.

use Cholesky, only: iiBstR_G, LuCho_G, LuRed_G, LuRst_G, mmBstRT_G, nnBstR_G, nnBstRT_G, nnShl_G, NumCho_G, NumChT_G
use Definitions, only: iwp

implicit none
integer(kind=iwp), parameter :: iLarge = 999999

nnShl_G = 0
mmBstRT_G = 0

iiBstR_G(:,:) = 0
nnBstR_G(:,:) = 0
nnBstRT_G(:) = 0
NumCho_G(:) = 0
NumChT_G = 0

LuCho_G(:) = -iLarge
LuRed_G = -iLarge
LuRst_G = -iLarge

end subroutine Cho_SetGlob

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mreorg1(symp,symq,symr,typp,typq,typr,pospv1,posqv1,posrv1,typpv1,typqv1,typrv1,typv2,v1,v2,fact,dimp,dimqr,dimt, &
                   dimu,dimv)
! this routine maps v2(p,qr) <+ fact . v1 (t,u,v)
! v2 may be of type 0,2 (typv2) while type v1 is always 0
! symp-symr and typp-typr are symmetries and types of p-r indices
! pospv1-posrv1 are corresponding positions of p-r indices in v1
! N.B. v1 and v2 have no direct relation to #1 or #2, since they
! are not imported, v1,v2 corresponds to arbitrary matrices
!
! symp-r     - symmetries of p-r (I)
! typp-r     - types of indices p-r in V2 (I)
! posp-rv1   - positions of p-r ind. in v1 (I)
! typp-rv1   - types of indices, corresponding to p-r in V1 (I)
! typv2      - type of V2 (0,1,2,4) (I)
! v1,v2      - arrays V1 and V2  (I,O)
! fact       - multiplication factors (usually +-1.0) (I)
! dimp,qr    - dimensions of V2 (I)
! dimt-s     - dimensions of V1 (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: symp, symq, symr, typp, typq, typr, pospv1, posqv1, posrv1, typpv1, typqv1, typrv1, typv2, dimp, &
                                 dimqr, dimt, dimu, dimv
real(kind=wp), intent(in) :: v1(dimt,dimu,dimv), fact
real(kind=wp), intent(inout) :: v2(dimp,dimqr)
integer(kind=iwp) :: ind(4), p, paddv1, pup, q, qaddv1, qr, qryes, qup, r, raddv1, rc, rup

! def additional constants

call ireorg3(symp,typp,typpv1,paddv1,rc)
call ireorg3(symq,typq,typqv1,qaddv1,rc)
call ireorg3(symr,typr,typrv1,raddv1,rc)

! def sumation limits

call ireorg2(symp,typp,pup,rc)
call ireorg2(symq,typq,qup,rc)
call ireorg2(symr,typr,rup,rc)

! def qryes, rsyes (i.e. if there is a reduced sumations)

if (typv2 == 2) then
  if (symq == symr) then
    qryes = 1
  else
    qryes = 0
  end if
else
  qryes = 0
end if

if (qryes == 1) then

  ! case p, q>s

  qr = 0
  do q=2,qup
    ind(posqv1) = qaddv1+q
    do r=1,q-1
      ind(posrv1) = raddv1+r
      qr = qr+1

      do p=1,pup
        ind(pospv1) = paddv1+p

        v2(p,qr) = v2(p,qr)+fact*v1(ind(1),ind(2),ind(3))

      end do
    end do
  end do

else

  ! case p q,r

  qr = 0
  do r=1,rup
    ind(posrv1) = raddv1+r
    do q=1,qup
      ind(posqv1) = qaddv1+q
      qr = qr+1

      do p=1,pup
        ind(pospv1) = paddv1+p

        v2(p,qr) = v2(p,qr)+fact*v1(ind(1),ind(2),ind(3))

      end do
    end do
  end do

end if

return

end subroutine mreorg1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SUBROUTINE Scf_Mcontrol(id_call)

      Implicit Real*8 (a-h,o-z)
#include "mxdm.fh"
#include "infscf.fh"
#include "para_info.fh"
*
      Integer ALGO,NSCREEN
      Logical REORD,DECO,timings
      Real*8  dmpk,dFKmat
*
      Common /CHOSCF / REORD,DECO,dmpk,dFKmat,ALGO,NSCREEN
      COMMON /CHOTIME / timings
*
      Integer id_call
      Character*512 List
      Character*32  Value
*******************************************************

      icount=0

      If (id_call .eq. 1) Then

* --- Label definitions

         write(List,100) 'SCF_started_OK:(-:-):',ALGO,timings,dmpK,
     &                   EThr,DThr,FThr,nIter(1),nScreen


* --- Initialize the control system

         Call MolcasControlInit(List)
         Return

      Else

* --- Read the molcas control file

*1
         Call MolcasControl('Cho_ALGO',Value)
         If (Value(1:4).ne.'    ') Then
            read(Value,*,err=101,end=102) ALGO
            write(6,*)'--- Warning: Cho_ALGOrithm changed by user to ',
     & 'the value ',ALGO
            icount = icount + 1
         EndIf
*2
         Call MolcasControl('Chotime',Value)
         If (Value(1:4).ne.'    ') Then
            read(Value,*,err=101,end=102) timings
            write(6,*)'--- Warning: Cholesky timings visualization ',
     &'changed by user to the value ',timings
            icount = icount + 1
         EndIf
*3
         Call MolcasControl('En_thr',Value)
         If (Value(1:4).ne.'    ') Then
            read(Value,*,err=101,end=102) Ethr
            write(6,*)'--- Warning: SCF Energy threshold changed by ',
     &'user to the value ',Ethr
            icount = icount + 1
         EndIf
*4
         Call MolcasControl('D_thr',Value)
         If (Value(1:4).ne.'    ') Then
            read(Value,*,err=101,end=102) Dthr
            write(6,*)'--- Warning: SCF Density threshold changed by ',
     &'user to the value ',Dthr
            icount = icount + 1
         EndIf
*5
         Call MolcasControl('F_thr',Value)
         If (Value(1:4).ne.'    ') Then
            read(Value,*,err=101,end=102) Fthr
            write(6,*)'--- Warning: SCF Fmat threshold changed by user',
     &' to the value ',Fthr
            icount = icount + 1
         EndIf
*6
         Call MolcasControl('MaxIter',Value)
         If (Value(1:4).ne.'    ') Then
            read(Value,*,err=101,end=102) nIter(1)
            write(6,*)'--- Warning: SCF Max # iterations changed by ',
     &'user to the value ',nIter(1)
            icount = icount + 1
         EndIf
*7
         Call MolcasControl('nScreen',Value)
         If (Value(1:4).ne.'    ') Then
            read(Value,*,err=101,end=102) nScreen
            write(6,*)'--- Warning: Cholesky LK option nSCREEN changed',
     &' by user to the value ',nScreen
            icount = icount + 1
         EndIf
*8
         Call MolcasControl('dmpK',Value)
         If (Value(1:4).ne.'    ') Then
            read(Value,*,err=101,end=102) dmpK
            write(6,*)'--- Warning: Cholesky LK option DMPK changed by',
     &' user to the value ',dmpK
            icount = icount + 1
         EndIf

      EndIf

      icount0=icount

* --- Get the true updated counter in parallel runs
*
      Call gaIgOP_SCAL(icount,'max')

      If (MyRank.eq.0) Then
         If (icount.gt.icount0) Then
           write(6,*)' Steering will NOT be activated this time because'
           write(6,*)' molcas.control file must be changed on node_0 !!'
           Call gaIgOP_SCAL(icount,'min')
         EndIf
      EndIf

      If (icount.gt.0) Then

* --- Trick to broadcast the values across nodes
*
         If (MyRank.ne.0) Then
            ALGO=0
            nIter(1)=0
            nScreen=0
            dmpK=0.0d0
            EThr=0.0d0
            DThr=0.0d0
            FThr=0.0d0
         EndIf
         Call gaIgOP_SCAL(ALGO,'+')
         Call gaIgOP_SCAL(nScreen,'+')
         Call gaIgOP(nIter(1),1,'+')
         Call gadgOP_SCAL(dmpK,'+')
         Call gadgOP_SCAL(EThr,'+')
         Call gadgOP_SCAL(DThr,'+')
         Call gadgOP_SCAL(FThr,'+')

* --- Update label values (note that "timings" is locally updated!)
*
         write(List,100) 'SCF_modified_by_user:',ALGO,timings,dmpK,
     &                   EThr,DThr,FThr,nIter(1),nScreen


* --- Initialize the control system with the new values
*
         Call MolcasControlInit(List)
         Return

      EndIf

      Return

100   FORMAT(A21,
     &',Cho_ALGO=',I2,
     &',Chotime=',L2,
     &',dmpK=',E11.4,
     &',En_thr=',E11.4,
     &',D_thr=',E11.4,
     &',F_thr=',E11.4,
     &',MaxIter=',I4,
     &',nScreen=',I4)

101   write(6,*) 'Scf_Mcontrol: error in data Input. ( icount= ',
     &           icount,' )'
102   write(6,*) 'Scf_Mcontrol: reached end of file. ( icount= ',
     &           icount,' )'

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_Vec( &
#                     define _CALLING_
#                     include "cdvec_interface.fh"
                     )
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: write (iOpt=1) or read (iOpt=2) "new" vectors to buffer.

use ChoMP2, only: lUnit_F, NowSym
use Definitions, only: wp, iwp, u6

implicit none
#include "cdvec_interface.fh"
integer(kind=iwp) :: iAdr, iJob, iSym, lTot
logical(kind=iwp) :: DoClose
character(len=*), parameter :: SecNam = 'ChoMP2_Vec'

iSym = NowSym
DoClose = .false.

if (iOpt == 1) then

  if (lUnit_F(iSym,2) < 1) then
    call ChoMP2_OpenF(1,2,iSym)
    DoClose = .true.
  end if

  iJob = 1
  lTot = nDim*nVec
  iAdr = nDim*(iVec1-1)+1
  call ddaFile(lUnit_F(iSym,2),iJob,Buf,lTot,iAdr)

else if (iOpt == 2) then

  if (lUnit_F(iSym,2) < 1) then
    call ChoMP2_OpenF(1,2,iSym)
    DoClose = .true.
  end if

  iJob = 2
  lTot = nDim*nVec
  iAdr = nDim*(iVec1-1)+1
  call ddaFile(lUnit_F(iSym,2),iJob,Buf,lTot,iAdr)

else

  write(u6,*) SecNam,': illegal option: iOpt = ',iOpt
  call SysAbendMsg(SecNam,'illegal option',' ')

end if

if (DoClose) then
  call ChoMP2_OpenF(2,2,iSym)
  DoClose = .false.
end if

end subroutine ChoMP2_Vec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine v_size_t3(vblock,nprocs,krem,printkey)

use ChT3_global, only: NNOAB, NNUAB, NOAB, NUAB
use Index_Functions, only: nTri_Elem
use Constants, only: One, Three
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: vblock
integer(kind=iwp), intent(in) :: nprocs, krem, printkey
integer(kind=iwp) :: isp, maxnu, N, nuga, nugc, rest, t3_size, t3_size_a, tmp, vblock_isp(2)

! number of elementary subprocesses: nugc*nTri_Elem(nuga)
!                                   + nuga*nTri_Elem(nugc)
!                                   + nugc**3/6
!                                   + nuga**3/6
! check this:
maxnu = max(nuab(1),nuab(2))
vblock_isp(1) = maxnu/nprocs

!mp
tmp = 1
if (maxnu >= 100) tmp = int((2*nprocs)**(One/Three))

do while (tmp*nTri_Elem(tmp) < nprocs)
  tmp = tmp+1
end do
vblock_isp(1) = maxnu/tmp
!mp

!mp if (vblock_isp(1) < 40) then
!mp    if (maxnu >= 160) vblock_isp(1) = 40
!mp end if

! adjusting to reasonably full last block
vblock_isp(2) = vblock_isp(1)
t3_size = krem+1

! brute force

t3_size_a = 0
do isp=1,2
  vblock = vblock_isp(isp)+1
  N = noab(isp)+nuab(isp)
  ! this is a first entry - initialization (makes no harm if repeated)
  do while (krem < t3_size)
    vblock = vblock-1
    !!write(u6,*) 'whiblock',vblock,krem,t3_size
    t3_size = 0
    nuga = nuab(isp)/vblock
    if ((nuga*vblock) < nuab(isp)) nuga = nuga+1
    nugc = nuab(3-isp)/vblock
    if ((nugc*vblock) < nuab(3-isp)) nugc = nugc+1
    ! dummy allocations
    if (nuga /= 1) then
      !call w_alloc(kab,noab(isp)*vblock*vblock*n,'kaT3loopb')
      t3_size = t3_size+noab(isp)*vblock*vblock*n+1
      !call w_alloc(kcb,noab(isp)*vblock*vblock*n,'kbT3loopb')
      t3_size = t3_size+noab(isp)*vblock*vblock*n+1

      !call w_alloc(kbc,vblock*vblock*n,'kcT3loopb')
      t3_size = t3_size+vblock*vblock*n+1
      !call w_alloc(kbc,vblock*vblock*n,'kcT3loopb')
      t3_size = t3_size+vblock*vblock*n+1

    else
      !call w_alloc(kab,noab(isp)*N*nnuab(isp),'kaT3loopb')
      t3_size = t3_size+noab(isp)*N*nnuab(isp)+1

    end if
    !call w_alloc(kac,vblock*vblock*n,'kcT3loopb')
    t3_size = t3_size+vblock*vblock*n+1

    !call w_alloc(kca,noab(isp)*vblock*vblock*n,'kbT3loopb')
    t3_size = t3_size+noab(isp)*vblock*vblock*n+1

    !call w_alloc(kc,vblock*vblock*n,'kcT3loopb')
    t3_size = t3_size+vblock*vblock*n+1

    !call w_alloc(la,nnoab(isp)*vblock*n,'laT3loopb')
    t3_size = t3_size+nnoab(isp)*vblock*n+1

    !call w_alloc(lxa,nnoab(3)*vblock*n,'lbaT3loopb')
    t3_size = t3_size+nnoab(3)*vblock*n+1

    if (nuga /= 1) then
      !call w_alloc(lb,nnoab(isp)*vblock*n,'lbT3loopb')
      t3_size = t3_size+nnoab(isp)*vblock*n+1

      !call w_alloc(lxb,nnoab(3)*vblock*n,'labT3loopb')
      t3_size = t3_size+nnoab(3)*vblock*n+1
    end if
    !call w_alloc(lxc,nnoab(3)*vblock*n,'lacT3loopb')
    t3_size = t3_size+nnoab(3)*vblock*n+1

    !call w_alloc(t3a,vblock*vblock*vblock,'t3aT3loopb')
    t3_size = t3_size+vblock*vblock*vblock+1
    !call w_alloc(t3b,vblock*vblock*vblock,'t3bT3loopb')
    t3_size = t3_size+vblock*vblock*vblock+1

    !call w_alloc(vac,vblock*vblock*nnoab(3),'vbcT3loopb')
    t3_size = t3_size+vblock*vblock*nnoab(3)+1
    if (nuga /= 1) then
      !call w_alloc(vab,vblock*vblock*nnoab(isp),'vabT3loopb')
      t3_size = t3_size+vblock*vblock*nnoab(isp)+1

      !call w_alloc(vbc,vblock*vblock*nnoab(3),'vacT3loopb')
      t3_size = t3_size+vblock*vblock*nnoab(3)+1
    else
      !call w_alloc(vab,nnoab(isp)*nnuab(isp),'vabT3loopb')
      t3_size = t3_size+nnoab(isp)*nnuab(isp)+1
    end if
    !call w_alloc(mi,noab(isp)*(vblock**3),'miT3loopb')
    t3_size = t3_size+noab(isp)*(vblock**3)+1
    !call w_alloc(mij,N*vblock,'mijT3loopb')
    t3_size = t3_size+N*vblock+1

  end do    ! while
  vblock_isp(isp) = vblock
  if (isp == 1) t3_size_a = t3_size
end do
vblock = min(vblock_isp(1),vblock_isp(2))
nuga = maxnu/vblock
if (nuga*vblock < maxnu) nuga = nuga+1
if (mod(maxnu,vblock) /= 0) vblock = min(vblock,maxnu/nuga+mod(maxnu,nuga))
! adjusting to reasonably full last block
rest = mod(maxnu,vblock)
do while ((rest /= 0) .and. (rest <= vblock-nuga))
  vblock = vblock-1
  rest = mod(maxnu,vblock)
end do
do isp=1,2
  t3_size = 0
  nuga = nuab(isp)/vblock
  if ((nuga*vblock) < nuab(isp)) nuga = nuga+1
  nugc = nuab(3-isp)/vblock
  if ((nugc*vblock) < nuab(3-isp)) nugc = nugc+1
  ! dummy allocations
  if (nuga /= 1) then
    !call w_alloc(kab,noab(isp)*vblock*vblock*n,'kaT3loopb')
    t3_size = t3_size+noab(isp)*vblock*vblock*n+1
    !call w_alloc(kcb,noab(isp)*vblock*vblock*n,'kbT3loopb')
    t3_size = t3_size+noab(isp)*vblock*vblock*n+1

    !call w_alloc(kbc,vblock*vblock*n,'kcT3loopb')
    t3_size = t3_size+vblock*vblock*n+1
    !call w_alloc(kbc,vblock*vblock*n,'kcT3loopb')
    t3_size = t3_size+vblock*vblock*n+1

  else
    !call w_alloc(kab,noab(isp)*N*nnuab(isp),'kaT3loopb')
    t3_size = t3_size+noab(isp)*N*nnuab(isp)+1

  end if
  !call w_alloc(kac,vblock*vblock*n,'kcT3loopb')
  t3_size = t3_size+vblock*vblock*n+1

  !call w_alloc(kca,noab(isp)*vblock*vblock*n,'kbT3loopb')
  t3_size = t3_size+noab(isp)*vblock*vblock*n+1

  !call w_alloc(kc,vblock*vblock*n,'kcT3loopb')
  t3_size = t3_size+vblock*vblock*n+1

  !call w_alloc(la,nnoab(isp)*vblock*n,'laT3loopb')
  t3_size = t3_size+nnoab(isp)*vblock*n+1

  !call w_alloc(lxa,nnoab(3)*vblock*n,'lbaT3loopb')
  t3_size = t3_size+nnoab(3)*vblock*n+1

  if (nuga /= 1) then
    !call w_alloc(lb,nnoab(isp)*vblock*n,'lbT3loopb')
    t3_size = t3_size+nnoab(isp)*vblock*n+1

    !call w_alloc(lxb,nnoab(3)*vblock*n,'labT3loopb')
    t3_size = t3_size+nnoab(3)*vblock*n+1
  end if
  !call w_alloc(lxc,nnoab(3)*vblock*n,'lacT3loopb')
  t3_size = t3_size+nnoab(3)*vblock*n+1

  !call w_alloc(t3a,vblock*vblock*vblock,'t3aT3loopb')
  t3_size = t3_size+vblock*vblock*vblock+1
  !call w_alloc(t3b,vblock*vblock*vblock,'t3bT3loopb')
  t3_size = t3_size+vblock*vblock*vblock+1

  !call w_alloc(vac,vblock*vblock*nnoab(3),'vbcT3loopb')
  t3_size = t3_size+vblock*vblock*nnoab(3)+1
  if (nuga /= 1) then
    !call w_alloc(vab,vblock*vblock*nnoab(isp),'vabT3loopb')
    t3_size = t3_size+vblock*vblock*nnoab(isp)+1

    !call w_alloc(vbc,vblock*vblock*nnoab(3),'vacT3loopb')
    t3_size = t3_size+vblock*vblock*nnoab(3)+1
  else
    !call w_alloc(vab,nnoab(isp)*nnuab(isp),'vabT3loopb')
    t3_size = t3_size+nnoab(isp)*nnuab(isp)+1
  end if
  !call w_alloc(mi,noab(isp)*(vblock**3),'miT3loopb')
  t3_size = t3_size+noab(isp)*(vblock**3)+1
  !call w_alloc(mij,N*vblock,'mijT3loopb')
  t3_size = t3_size+N*vblock+1
  if (isp == 1) t3_size_a = t3_size
end do
write(u6,*)
write(u6,'(2x,A,I5)') 'Virtual orbitals will be treated in blocks of:',vblock
if (printkey >= 10) write(u6,'(2x,A,I11,A,I11,A)') 'Memory requirement:',max(t3_size,t3_size_a),' Words;    remaining:', &
                                                   krem-max(t3_size,t3_size_a),' Words'
call xflush(u6)

return

end subroutine v_size_t3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine pseud2_molcas( a, anga, angb, ccr, gout, ipt,
     &  lambu, ltot1, mproju, ncr, nkcrl, nkcru, qsum,
     &  zcr, lit, ljt, ai, aj, xi, yi, zi, xj, yj, zj, xc, yc, zc,
     &  kcrs, lcru, lproju1,crda,crdb)
      implicit real*8 (a-h,o-z)
      dimension llt(7,2)
c
c  compute type 2 core potential integrals
c
      dimension a(*),anga(lit,mproju,*),angb(ljt,mproju,*),ccr(*),
     &  crda(lit,3),crdb(ljt,3),gout(*),ipt(*),ncr(*),
     &  nkcrl(lproju1,*),nkcru(lproju1,*),qsum(ltot1,lambu,*),zcr(*)
      data llt /1,2,5,11,21,36,57,1,4,10,20,35,56,84/
      data      a0   ,a4     /        0.0d0,      4.0d0       /
*     data eps1,a0,a1,a4,a50 /1.0d-15,0.0d0,1.0d0,4.0d0,50.0d0/

      call pseud2_molcas_internal(a)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine pseud2_molcas_internal(a)
      use iso_c_binding
      real*8, target :: a(*)
      integer, pointer :: ia1(:),ia13(:),ia14(:),ia15(:),ia16(:),ia17(:)
      tol=20.*log(10.d0)
      fctr2=a4
      itl=llt(lit,1)
      itu=llt(lit,2)
      jtl=llt(ljt,1)
      jtu=llt(ljt,2)
      tai=ai+ai
      taj=aj+aj
      aa=ai+aj
      do 120 i=1,3
      crda(1,i)=1.d0
      crdb(1,i)=1.d0
  120 continue
      xka=xc-xi
      yka=yc-yi
      zka=zc-zi
      ca=sqrt(xka*xka+yka*yka+zka*zka)
      if(lit.eq.1) go to 220
      crda(2,1)=xka
      crda(2,2)=yka
      crda(2,3)=zka
      if(lit.eq.2) go to 220
      do 210 i=1,3
      do 211 j=3,lit
      crda(j,i)=crda(2,i)*crda(j-1,i)
  211 continue
  210 continue
  220 xkb=xc-xj
      ykb=yc-yj
      zkb=zc-zj
      cb=sqrt(xkb*xkb+ykb*ykb+zkb*zkb)
      if(ljt.eq.1) go to 240
      crdb(2,1)=xkb
      crdb(2,2)=ykb
      crdb(2,3)=zkb
      if(ljt.eq.2) go to 240
      do 230 i=1,3
      do 231 j=3,ljt
      crdb(j,i)=crdb(2,i)*crdb(j-1,i)
  231 continue
  230 continue
  240 continue
      aarr2=(ai*aj/aa)*(ca-cb)**2
c*
      if(ca.eq.a0) then
        rka=a0
        lmau=1
      else
        xka=-xka/ca
        yka=-yka/ca
        zka=-zka/ca
        rka=tai*ca
        lmau=lcru+(lit-1)
      endif
      if(cb.eq.a0) then
        rkb=a0
        lmbu=1
      else
        xkb=-xkb/cb
        ykb=-ykb/cb
        zkb=-zkb/cb
        rkb=taj*cb
        lmbu=lcru+(ljt-1)
      endif
      if((ca.eq.a0).and.(cb.eq.a0)) then
        lhi=min(lcru,lit,ljt)
        llo=mod((lit-1),2)+1
        if(llo.ne.mod((ljt-1),2)+1.or.llo.gt.lhi) return
        inc=2
      elseif(ca.eq.a0) then
        lhi=min(lcru,lit)
        llo=mod((lit-1),2)+1
        if(llo.gt.lhi) return
        inc=2
      elseif(cb.eq.a0) then
        lhi=min(lcru,ljt)
        llo=mod((ljt-1),2)+1
        if(llo.gt.lhi) return
        inc=2
      else
        lhi=lcru
        llo=1
        inc=1
      endif
      do 88 l=llo,lhi,inc
      mhi=l+l-1
      lmalo=max(l-(lit-1),1)
      lmahi=min(lmau,l+(lit-1))
      lmblo=max(l-(ljt-1),1)
      lmbhi=min(lmbu,l+(ljt-1))
c
c  compute radial integrals
c
      kcrl=nkcrl(l+1,kcrs)
      kcru=nkcru(l+1,kcrs)
            call rad2_molcas( a,          ccr,        ipt,        kcrl,
     &                 kcru,       l,          lambu,      lmahi,
     &                 lmalo,      lmbhi,      lmblo,      ltot1,
     &                 ncr,        qsum,       rka,        rkb,
     &                 zcr,        lit,        ljt,        ca,
     &                 cb,         tai,        taj,        aa,
     &                 aarr2,      fctr2 )
c
c  compute angular integrals and combine with radial integrals
c
      ijt=0
      do 84 it=itl,itu
      call c_f_pointer(c_loc(a(ipt(1))),ia1,[1])
      call c_f_pointer(c_loc(a(ipt(1))),ia1,[1])
      call c_f_pointer(c_loc(a(ipt(13))),ia13,[1])
      call c_f_pointer(c_loc(a(ipt(14))),ia14,[1])
      call c_f_pointer(c_loc(a(ipt(15))),ia15,[1])
      call c_f_pointer(c_loc(a(ipt(16))),ia16,[1])
      call c_f_pointer(c_loc(a(ipt(17))),ia17,[1])
      call ang2_molcas(anga,a(ipt(12)),crda,a(ipt(11)),it,
     &  l,lit,lmalo,lmahi,
     &  ia13,ia14,ia15,ia16,ia17,
     &  ia1,mproju,xka,yka,zka,a(ipt(18)))
      nullify(ia1,ia13,ia14,ia15,ia16,ia17)
      do 80 jt=jtl,jtu
      ijt=ijt+1
      s=a0
      call c_f_pointer(c_loc(a(ipt(1))),ia1,[1])
      call c_f_pointer(c_loc(a(ipt(1))),ia1,[1])
      call c_f_pointer(c_loc(a(ipt(13))),ia13,[1])
      call c_f_pointer(c_loc(a(ipt(14))),ia14,[1])
      call c_f_pointer(c_loc(a(ipt(15))),ia15,[1])
      call c_f_pointer(c_loc(a(ipt(16))),ia16,[1])
      call c_f_pointer(c_loc(a(ipt(17))),ia17,[1])
      call ang2_molcas(angb,a(ipt(12)),crdb,a(ipt(11)),jt,
     &  l,ljt,lmblo,lmbhi,
     &  ia13,ia14,ia15,ia16,ia17,
     &  ia1,mproju,xkb,ykb,zkb,a(ipt(18)))
      nullify(ia1,ia13,ia14,ia15,ia16,ia17)
      do 76 lama=lmalo,lmahi
        ldifa1=abs(l-lama)+1
        nlmau=lit-mod(lit-ldifa1,2)
        do 72 lamb=lmblo,lmbhi
          ldifb=abs(l-lamb)
          nlmbu=(ljt-1)-mod((ljt-1)-ldifb,2)
          nlo=ldifa1+ldifb
          nhi=nlmau+nlmbu
          do 68 n=nlo,nhi,2
            nlmalo=max(ldifa1,n-nlmbu)
            nlmahi=min(nlmau,n-ldifb)
            angp=a0
            do 60 m=1,mhi
              do 56 nlma=nlmalo,nlmahi,2
                angp=angp+anga(nlma,m,lama)*angb((n+1)-nlma,m,lamb)
   56         continue
   60       continue
            s=s+angp*qsum(n,lamb,lama)
   68     continue
   72   continue
   76 continue
      gout(ijt)=gout(ijt)+s
   80 continue
   84 continue
   88 continue
      return
      end subroutine pseud2_molcas_internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Pack_mod

use Definitions, only: wp, iwp

implicit none
private

!----------------------------------------------------------------------*
!                                                                      *
!     Entries of the packing table:                                    *
!                                                                      *
!     PkThrs : desired accuracy of packing                             *
!     isPack : Flag to indicate desired mode of action                 *
!              (isPack=.true. : packing is desired )                   *
!              (isPack=.false.: no packing desired )                   *
!                                                                      *
!----------------------------------------------------------------------*

real(kind=wp) :: PkThrs
integer(kind=iwp) :: Init_do_setup_d, Init_do_setup_e, Init_do_setup_l
logical(kind=iwp) :: isPack

public :: Init_do_setup_d, Init_do_setup_e, Init_do_setup_l, isPack, PkThrs

end module Pack_mod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine crprod(a,b,c)
c
c       calculates cross product:   a x b = c
c                                   -   -   -
      Implicit real*8 (a-h,o-z)
      Dimension a(3),b(3),c(3)
c
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      Return
      End


      Subroutine vec(threshold,u,j,k,iErr)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension r(3),u(3)
#include "g_zmatconv.fh"

      iErr = 0
      r2 = 0.0d0

      Do i = 1, 3
        r(i) = Coords(j,i) - Coords(k,i)
        r2 = r2 + r(i)*r(i)
      EndDo
      r2 = sqrt(r2)
      If (r2.LT.threshold) then
        iErr = 1
        Return
      EndIf
      Do i = 1, 3
       u(i) = r(i)/r2
      EndDo
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MLTSCA(IMLTOP,LST1,LST2,X,F,Y)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: MyRank, nProcs, Is_Real_Par
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(*),F(*),Y(*)
      DIMENSION LST1(4,NLST1), LST2(4,NLST2)
#include "sigma.fh"

C Given two lists with entries LST1(4,ITEM), ITEM=1,NLST1, the
C four entries called L11,L12,L13,L14 for short, for a given
C item, and with V1=VAL1(L14), and similar for the other list,
C compute, for IMLTOP=0 or 1 respectively,
C     X(L11,L21) := Add V1*V2*F(L12,L22)*Y(L13,L23)
C  or Y(L13,L23) := Add V1*V2*F(L12,L22)*X(L11,L21)
C or for IMLTOP=2, compute
C     F(L12,L22) := Add V1*V2*X(L11,L21)*Y(L13,L23)

CSVC: determine outer loop properties
#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        ILST1_IOFF=MYRANK+1
        ILST1_SKIP=NPROCS
      ELSE
        ILST1_IOFF=1
        ILST1_SKIP=1
      ENDIF
#else
      ILST1_IOFF=1
      ILST1_SKIP=1
#endif

      IF(IMLTOP.EQ.0) THEN
        DO ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
          L11=LST1(1,ILST1)
          L12=LST1(2,ILST1)
          L13=LST1(3,ILST1)
          L14=LST1(4,ILST1)
          V1=VAL1(L14)
          DO ILST2=1,NLST2
            L21=LST2(1,ILST2)
            L22=LST2(2,ILST2)
            L23=LST2(3,ILST2)
            L24=LST2(4,ILST2)
            V2=VAL2(L24)
            IX=1+INCX1*(L11-1)+INCX2*(L21-1)
            IF=1+INCF1*(L12-1)+INCF2*(L22-1)
            IY=1+INCY1*(L13-1)+INCY2*(L23-1)
            X(IX)=X(IX)+V1*V2*F(IF)*Y(IY)
          END DO
        END DO
      ELSE IF(IMLTOP.EQ.1) THEN
        DO ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
          L11=LST1(1,ILST1)
          L12=LST1(2,ILST1)
          L13=LST1(3,ILST1)
          L14=LST1(4,ILST1)
          V1=VAL1(L14)
          DO ILST2=1,NLST2
            L21=LST2(1,ILST2)
            L22=LST2(2,ILST2)
            L23=LST2(3,ILST2)
            L24=LST2(4,ILST2)
            V2=VAL2(L24)
            IX=1+INCX1*(L11-1)+INCX2*(L21-1)
            IF=1+INCF1*(L12-1)+INCF2*(L22-1)
            IY=1+INCY1*(L13-1)+INCY2*(L23-1)
            Y(IY)=Y(IY)+V1*V2*F(IF)*X(IX)
          END DO
        END DO
      ELSE
        DO ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
          L11=LST1(1,ILST1)
          L12=LST1(2,ILST1)
          L13=LST1(3,ILST1)
          L14=LST1(4,ILST1)
          V1=VAL1(L14)
          DO ILST2=1,NLST2
            L21=LST2(1,ILST2)
            L22=LST2(2,ILST2)
            L23=LST2(3,ILST2)
            L24=LST2(4,ILST2)
            V2=VAL2(L24)
            IX=1+INCX1*(L11-1)+INCX2*(L21-1)
            IF=1+INCF1*(L12-1)+INCF2*(L22-1)
            IY=1+INCY1*(L13-1)+INCY2*(L23-1)
            F(IF)=F(IF)+V1*V2*X(IX)*Y(IY)
          END DO
        END DO
      END IF

      NFSCA=NFSCA+4*NLST1*NLST2
      RETURN
      END
      SUBROUTINE PMLTSCA(KOD,IMLTOP,LST1,LST2,
     &                   X,NXI,NXA,F,NFI,NFA,
     &                   lg_Y,NAS2,NIS2)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif
      DIMENSION X(NXI,NXA),F(NFI,NFA)
      DIMENSION LST1(4,NLST1), LST2(4,NLST2)
#include "sigma.fh"

#ifdef _MOLCAS_MPP_
C SVC: Determine the index ranges of the local chunks of lg_Y.
C The boundaries and leading dimension are stored in a common block for
C access inside the lower-level routines.
C For now, only case H is handled as a distributed array, which is
C always the Y array.
      IF (Is_Real_Par()) THEN
        CALL GA_Sync()
        myRank = GA_NodeID()
*     CALL GA_Distribution (lg_X,myRank,iXLo,iXHi,jXLo,jXHi)
*     IF (iXLo.NE.0.AND.jXLo.NE.0) THEN
*       CALL GA_Access (lg_X,iXLo,iXHi,jXLo,jXHi,mX,LDX)
*     END IF
        CALL GA_Distribution (lg_Y,myRank,iYLo,iYHi,jYLo,jYHi)
        IF (iYLo.NE.0.AND.jYLo.NE.0) THEN
          CALL GA_Access (lg_Y,iYLo,iYHi,jYLo,jYHi,mY,LDY)
          IF (KOD.EQ.23 .OR. KOD.EQ.24) THEN
            CALL MLTSCA_DH(IMLTOP,LST1,LST2,
     &                   X,NXI,NXA,F,NFI,NFA,
     &                   DBL_MB(mY),NAS2,jYLo,jYHi)
          ELSE
            WRITE(6,*) 'PMLTSCA: not supposed to be here'
            CALL AbEnd()
          END IF
          CALL GA_Release_Update (lg_Y,iYLo,iYHi,jYLo,jYHi)
        END IF
        CALL GA_Sync()
      ELSE
        IF (KOD.EQ.23 .OR. KOD.EQ.24) THEN
          CALL MLTSCA_DH(IMLTOP,LST1,LST2,
     &                   X,NXI,NXA,F,NFI,NFA,
     &                   WORK(lg_Y),NAS2,1,NIS2)
        ELSE
          WRITE(6,*) 'PMLTSCA: not supposed to be here'
          CALL AbEnd()
        END IF
      END IF
#else
      IF (KOD.EQ.23 .OR. KOD.EQ.24) THEN
        CALL MLTSCA_DH(IMLTOP,LST1,LST2,
     &                 X,NXI,NXA,F,NFI,NFA,
     &                 WORK(lg_Y),NAS2,1,NIS2)
      ELSE
        WRITE(6,*) 'PMLTSCA: not supposed to be here'
        CALL AbEnd()
      END IF
#endif
      RETURN
      END
      SUBROUTINE MLTSCA_DH(IMLTOP,LST1,LST2,
     &                     X,NXI,NXA,F,NFI,NFA,
     &                     Y,NAS2,jYLo,jYHi)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(NXI,NXA),F(NFI,NFA),Y(NAS2,jYHi-jYLo+1)
      DIMENSION LST1(4,NLST1), LST2(4,NLST2)
#include "sigma.fh"

C Given two lists with entries LST1(4,ITEM), ITEM=1,NLST1, the
C four entries called L11,L12,L13,L14 for short, for a given
C item, and with V1=VAL1(L14), and similar for the other list,
C compute, for IMLTOP=0 or 1 respectively,
C     X(L11,L21) := Add V1*V2*F(L12,L22)*Y(L13,L23)
C  or Y(L13,L23) := Add V1*V2*F(L12,L22)*X(L11,L21)
C or for IMLTOP=2, compute
C     F(L12,L22) := Add V1*V2*X(L11,L21)*Y(L13,L23)

      IF(IMLTOP.EQ.0) THEN
        DO ILST1=1,NLST1
        L11=LST1(1,ILST1)
        L12=LST1(2,ILST1)
        L13=LST1(3,ILST1)
        L14=LST1(4,ILST1)
        V1=VAL1(L14)
        IF (L13.GE.jYLo .AND. L13.LE.jYHi) THEN
          JY=L13-jYLo+1
          DO ILST2=1,NLST2
          L21=LST2(1,ILST2)
          L22=LST2(2,ILST2)
          L23=LST2(3,ILST2)
          L24=LST2(4,ILST2)
          V2=VAL2(L24)
          X(L11,L21)=X(L11,L21)+V1*V2*F(L12,L22)*Y(L23,JY)
          END DO
        END IF
        END DO
      ELSE IF(IMLTOP.EQ.1) THEN
        DO ILST1=1,NLST1
        L11=LST1(1,ILST1)
        L12=LST1(2,ILST1)
        L13=LST1(3,ILST1)
        L14=LST1(4,ILST1)
        V1=VAL1(L14)
        IF (L13.GE.jYLo .AND. L13.LE.jYHi) THEN
          JY=L13-jYLo+1
          DO ILST2=1,NLST2
          L21=LST2(1,ILST2)
          L22=LST2(2,ILST2)
          L23=LST2(3,ILST2)
          L24=LST2(4,ILST2)
          V2=VAL2(L24)
          Y(L23,JY)=Y(L23,JY)+V1*V2*F(L12,L22)*X(L11,L21)
          END DO
        END IF
        END DO
      ELSE
        DO ILST1=1,NLST1
        L11=LST1(1,ILST1)
        L12=LST1(2,ILST1)
        L13=LST1(3,ILST1)
        L14=LST1(4,ILST1)
        V1=VAL1(L14)
        IF (L13.GE.jYLo .AND. L13.LE.jYHi) THEN
          JY=L13-jYLo+1
          DO ILST2=1,NLST2
          L21=LST2(1,ILST2)
          L22=LST2(2,ILST2)
          L23=LST2(3,ILST2)
          L24=LST2(4,ILST2)
          V2=VAL2(L24)
          F(L12,L22)=F(L12,L22)+V1*V2*X(L11,L21)*Y(L23,JY)
          END DO
        END IF
        END DO
      END IF

*     NFSCA=NFSCA+4*NLST1*NLST2
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRCEVC(NSS,FRAC,SOENE,MAPST,MAPSP,MAPMS,UMATR,UMATI)
      IMPLICIT NONE
#include "Molcas.fh"
#include "cntrl.fh"
#include "prgm.fh"
#include "stdalloc.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='PRCEVC')

      INTEGER NSS
      REAL*8 FRAC,SOENE(NSS),UMATR(NSS,NSS),UMATI(NSS,NSS)
      INTEGER MAPST(NSS),MAPSP(NSS),MAPMS(NSS)

      real*8, allocatable :: weight(:),sstate(:)
      real*8 :: wmax(5),smax(5)
      integer :: nmax(5)

      INTEGER I
      INTEGER ISFS,IMAXSTATE,ISTATE,ISS,JSS,JSTA,JEND,NW
      REAL*8 CFFLIM,S,SSMAX,SZ,TST,WGTMAX,XMAX

      call mma_allocate(weight,nss)
      call mma_allocate(sstate,nss)

C Write out the complex eigenvectors of the spin-orbit states.
C Four states at a time are written out.
C They are written as complex numbers, four on each line.
C Coefficients are written out if any of the four complex coeffs
C on the same line have absolute value at least as large as
C a certain fraction (FRAC) of the largest such value for the
C foursome of states.


      If(IPGLOB.ge.verbose) then
      DO JSTA=1,NSS,4
       JEND=MIN(NSS,JSTA+3)
       WRITE(6,*)
       WRITE(6,'(1X,A16,F16.8,3(2X,F16.8))')
     &            '    Energy (au) ',(SOENE(JSS),JSS=JSTA,JEND)
       WRITE(6,'(1X,A16,6X,I4,3(14X,I4))')
     &            ' SFS  S     Ms  ',(JSS,JSS=JSTA,JEND)
* Scan coefficients to pick out the largest:
       WGTMAX=0.0D0
       DO ISS=1,NSS
        DO JSS=JSTA,JEND
         WGTMAX=MAX(WGTMAX,UMATR(ISS,JSS)**2+UMATI(ISS,JSS)**2)
        END DO
       END DO

* Scan coefficients, write if large enough:
       CFFLIM=FRAC*SQRT(WGTMAX)
       DO ISS=1,NSS
        ISTATE=MAPST(ISS)
        S=DBLE(MAPSP(ISS)-1)*0.5D0
        SZ=DBLE(MAPMS(ISS))*0.5D0
        TST=0.0D0
        DO JSS=JSTA,JEND
         TST=MAX(TST,UMATR(ISS,JSS)**2+UMATI(ISS,JSS)**2)
        END DO
        IF(TST.GE.CFFLIM**2) THEN
         WRITE(6,
     &        '(I4,1X,F4.1,1X,F5.1,3X,4(A1,F7.4,A1,F7.4,A1,1x))')
     &         ISTATE,S,SZ,('(',UMATR(ISS,JSS),','
     &                            ,UMATI(ISS,JSS),')',JSS=JSTA,JEND)
        END IF
       END DO
      END DO
      else If(IPGLOB.ge.usual) then
*     Write out the weights of the five most important spin-free states
*     For each spin-orbit state (BOR in Krapperup 070226)
*
      Write(6,*)
      Write(6,*)
      Write(6,*)'Weights of the five most important'//
     &         ' spin-orbit-free states for each spin-orbit state.'
      Write(6,*)
      Write(6,*) 'SO State  Total energy (au)           Spin-free '//
     & 'states, spin, and weights'
      Write(6,*)'----------------------------------------------------'//
     &          '---------------------------------------------------'
      Do iss=1,nss
       Do isfs=1,nstate
        weight(isfs)=0.d0
       Enddo
       Do jss=1,nss
        istate=mapst(jss)
        sstate(istate)=dble(mapsp(jss)-1)*0.5D0
        weight(istate)=weight(istate)+
     &  umatr(jss,iss)**2+umati(jss,iss)**2
       Enddo
*      Sort the weights
       imaxstate=0
  100  Continue
        xmax=0.d0
        ssmax=0.d0
        nw=0
       Do istate=1,nstate
        if(weight(istate).ge.xmax) then
         nw=istate
         xmax=weight(istate)
         ssmax=sstate(istate)
        Endif
       Enddo
       weight(nw)=-1.d0
       imaxstate=imaxstate+1
       nmax(imaxstate)=nw
       wmax(imaxstate)=xmax
       smax(imaxstate)=ssmax
       if(imaxstate.lt.min(nstate,5)) go to 100
*
       write(6,'(i5,1x,f16.6,3x,5(i5,f4.1,f8.4))')
     &  iss,soene(iss),(nmax(i),smax(i),wmax(i),i=1,(min(nstate,5)))

      Enddo
      Write(6,*)'----------------------------------------------------'//
     &          '---------------------------------------------------'
      Endif

C Added by Ungur Liviu on 04.11.2009
C Addition of UMATR and UMATI on RunFile

      CALL Put_dArray('UMATR_SINGLE',UMATR,NSS**2)
      CALL Put_dArray('UMATI_SINGLE',UMATI,NSS**2)

      call mma_deallocate(weight)
      call mma_deallocate(sstate)


      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETDIAG(LCONV)
C
C     Purpose: get diagonal in first reduced set. On exit, DIAG
C              points to the diagonal and flag LCONV tells
C              if the diagonal is converged.
C
      use ChoArr, only: iSP2F, MySP, n_MySP, iSimRI
      use ChoSwp, only: IndRSh, IndRSh_Hidden
      use ChoSwp, only: IndRed, IndRed_Hidden
      use ChoSwp, only: Diag, Diag_Hidden
#include "implicit.fh"
      LOGICAL LCONV
#include "cholesky.fh"
#include "choprint.fh"
#include "choorb.fh"
#include "stdalloc.fh"

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_GETDIAG')

      LOGICAL LOCDBG, DODUMMY, SYNC
      PARAMETER (LOCDBG = .FALSE.)

      INTEGER ISYLST(8)

      Integer, Allocatable:: KIBUF(:)
      Real*8, Allocatable:: KBUF(:), KSCR(:), KWRK(:)

      IF (RSTDIA) THEN

C        Set mySP list.
C        Always the trivial list for serial runs (restart not possible
C        in parallel runs).
C        -------------------------------------------------------------

         N_MYSP = NNSHL
         l_MySP=0
         If (Allocated(MYSP)) l_MySP=SIZE(MySP)
         IF (l_MYSP .EQ. NNSHL) THEN
            DO ISP = 1,N_MYSP
               MYSP(ISP) = ISP
            END DO
         ELSE
            CALL CHO_QUIT('MYSP allocation error in '//SECNAM,101)
         END IF

C        Read index array NNBSTRSH and set IIBSTRSH etc.
C        -----------------------------------------------

         CALL CHO_RSTD_GETIND1()

C        Allocate mapping arrays between reduced sets.
C        ---------------------------------------------

         MMBSTRT  = NNBSTRT(1)

         Call mma_allocate(IndRed_Hidden,NNBSTRT(1),3,
     &                     Label='IndRed_Hidden')
         IndRed => IndRed_Hidden

         Call mma_allocate(IndRSh_Hidden,NNBSTRT(1),
     &                     Label='IndRSh_Hidden')
         IndRSh => IndRSh_Hidden

C        Read mapping arrays.
C        --------------------

         CALL CHO_RSTD_GETIND2()

C        Check reduced to full shell pair mapping with the one on disk.
C        --------------------------------------------------------------

         NERR = -1
         CALL CHO_RSTD_CHKSP2F(iSP2F,SIZE(iSP2F),NERR)
         IF (NERR .NE. 0) THEN
            WRITE(LUPRI,*) SECNAM,': ',NERR,' errors detected in ',
     &                     'reduced-to-full shell pair mapping!'
            CALL CHO_QUIT('SP2F error in '//SECNAM,102)
         END IF

C        Allocation: diagonal.
C        ---------------------

         NEEDR = 1
         NEEDI = 4*NEEDR

         CALL mma_allocate(Diag_Hidden,NNBSTRT(1),Label='Diag_Hidden')
         Call mma_allocate(KBUF,NEEDR,Label='KBUF')
         Call mma_allocate(KIBUF,NEEDI,Label='KIBUF')

C        Read diagonal.
C        --------------

         CALL CHO_GETDIAG1(Diag_Hidden,KBUF,KIBUF,NEEDR,NDUMP)

         Call mma_deallocate(KIBUF)
         Call mma_deallocate(KBUF)

      ELSE

C        Calculate diagonal and get 1st reduced set.
C        -------------------------------------------

         Call mma_maxDBLE(LMAX)
         LMAX = LMAX/2 - MX2SH
         IF (LMAX .LT. 5*LBUF) THEN
            LBUF = MAX(LMAX/5,1)
         END IF

         LSCR  = MX2SH
         NEEDR = LBUF
         NEEDI = 4*LBUF

         Call mma_allocate(KBUF,NEEDR,Label='KBUF')
         Call mma_allocate(KSCR,LSCR ,Label='KSCR')
         Call mma_allocate(KIBUF,NEEDI,Label='KIBUF')

         NDUMP = 0

         CALL CHO_CALCDIAG(KBUF,KIBUF,LBUF,KSCR,LSCR,NDUMP)

         Call mma_deallocate(KIBUF)
         Call mma_deallocate(KBUF)
         Call mma_deallocate(KSCR)

C        Allocate diagonal and mapping array between reduced sets.
C        Reallocate buffer.
C        ---------------------------------------------------------

         MMBSTRT  = NNBSTRT(1)
         Call mma_allocate(IndRed_Hidden,NNBSTRT(1),3,
     &                     Label='IndRed_Hidden')
         IndRed => IndRed_Hidden
         Call mma_allocate(IndRSh_Hidden,NNBSTRT(1),
     &                     Label='IndRSh_Hidden')
         IndRSh => IndRSh_Hidden
         CALL mma_allocate(Diag_Hidden,NNBSTRT(1),Label='Diag_Hidden')

         NEEDR = LBUF
         NEEDI = 4*LBUF
         Call mma_allocate(KBUF,NEEDR,Label='KBUF')
         Call mma_allocate(KIBUF,NEEDI,Label='KIBUF')

C        Get diagonal in first reduced set.
C        ----------------------------------

         CALL CHO_GETDIAG1(Diag_Hidden,KBUF,KIBUF,LBUF,NDUMP)

C        Deallocate back to and including buffer.
C        ----------------------------------------

         Call mma_deallocate(KIBUF)
         Call mma_deallocate(KBUF)

      END IF

C     Set local and global info. On exit, Diag points to the local
C     diagonal.
C     -------------------------------------------------------------

      CALL CHO_P_SETGL()

C     Write local diagonal to disk.
C     -----------------------------

      IOPT = 1
      CALL CHO_IODIAG(Diag,IOPT)

C     Allocate memory for iscratch array for reading vectors.
C     -------------------------------------------------------

      DODUMMY = .NOT.(CHO_IOVEC.EQ.1 .OR. CHO_IOVEC.EQ.2 .OR.
     &                CHO_IOVEC.EQ.3 .OR. CHO_IOVEC.EQ.4 .OR.
     &                (FRAC_CHVBUF.GT.0.0D0 .AND. FRAC_CHVBUF.LT.1.0D0))
      CALL CHO_ALLO_ISCR(DODUMMY)

C     Initialize reduced set dimension(s) used for reading vectors.
C     -------------------------------------------------------------

      CALL CHO_INIRSDIM()

C     For RI simulation, zero 1-center diagonals smaller than
C     THR_SIMRI. Indices of zeroed diagonals are stored in ip_ISIMRI.
C     ---------------------------------------------------------------

      IF (CHO_SIMRI) THEN
         Call mma_allocate(iSimRI,NNBSTRT(1),Label='iSimRI')
         CALL CHO_SIMRI_Z1CDIA(Diag,THR_SIMRI,ISIMRI)
      END IF

C     Update diagonal if restart, else just do analysis.
C     --------------------------------------------------

      LCONV = .FALSE.
      IF (RSTCHO) THEN
         Call mma_maxDBLE(LWRK)
         Call mma_allocate(KWRK,LWRK,Label='KWRK')
         IF (LOCDBG) THEN
            WRITE(LUPRI,*) SECNAM,': restart diagonal:'
            DO ISYM = 1,NSYM
               ISYLST(ISYM) = ISYM
            END DO
            CALL CHO_PRTDIA(Diag,ISYLST,NSYM,1)
         END IF
         CALL CHO_RESTART(Diag,KWRK,LWRK,.FALSE.,LCONV)
         Call mma_deallocate(KWRK)
         IPRTRED = 2  ! print flag for cho_prtred
      ELSE
         IF (IPRINT .GE. INF_PASS) THEN
            BIN1 = 1.0D2
            STEP = 1.0D-1
            NBIN = 18
            SYNC = .FALSE.
            CALL CHO_P_ANADIA(Diag,SYNC,BIN1,STEP,NBIN,.TRUE.)
         END IF
         IPRTRED = 1  ! print flag for cho_prtred
      END IF
      IF (IPRINT .GE. INF_PASS) THEN
         CALL CHO_P_PRTRED(IPRTRED)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Anders Bernhardsson                              *
!***********************************************************************

subroutine Niclas(H,coor,LUT)

use Index_Functions, only: iTri, nTri_Elem
use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: iChTbl, nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: H(*), Coor(*)
integer(kind=iwp), intent(in) :: LUT
integer(kind=iwp) :: i, iCar, iCnt, iCnttp, iCo, iComp, idsp, ii, iii, iIrrep, inddsp(100,0:7), iPERT, iS, j, jCar, jCnt, jCnttp, &
                     jCo, jComp, jDsp, jPERT, kop_m, kop_n, ldisp(0:7), mdc, nCenti, nCentj, nCnti, nCntj, nd, ndc, nDeg(200), &
                     nop_m, nop_n
real(kind=wp) :: Dummy(1), HE, riPh, rjPh
character(len=40) :: Label
real(kind=wp), allocatable :: Htmp(:,:), Tmp(:)
integer(kind=iwp), external :: iPrmt, nropr
logical(kind=iwp), external :: TF

idsp = 0
ldisp(0:nirrep-1) = 0
do iIrrep=0,nIrrep-1
  mdc = 0
  do iCnttp=1,nCnttp
    nCnti = dbsc(iCnttp)%nCntr
    do iCnt=1,nCnti
      mdc = mdc+1
      IndDsp(mdc,iIrrep) = idsp
      do iCar=0,2
        iComp = ibset(0,iCar)
        if (TF(mdc,iIrrep,iComp)) then
          idsp = idsp+1
          ldisp(iirrep) = ldisp(iirrep)+1
          ndeg(idsp) = nIrrep/dc(mdc)%nStab
        end if
      end do
    end do
  end do
end do

!***********************************************************************
!
! Steady
!
! Make the symmetrized Hessian correct for degenerated geometries
!
!***********************************************************************

nD = sum(lDisp(0:nIrrep-1))
call mma_allocate(TMP,nd**2,Label='Tmp')
call mma_allocate(HTMP,nd,nd,Label='Htmp')
Htmp(:,:) = Zero
ii = 0
iii = 0
do iS=1,Nirrep
  do i=1,ldisp(iS-1)
    do j=1,i
      Tmp(iTri(iii+i,iii+j)) = sqrt(real(nDeg(i+iii)*nDeg(j+iii),kind=wp))*H(ii+iTri(i,j))
      !write(u6,*) H(ii+iTri(i,j)),Tmo(iTri(iii+i,iii+j))
    end do
  end do
  ii = ii+nTri_Elem(ldisp(is-1))
  iii = iii+ldisp(is-1)
end do

!***********************************************************************
!
! Go
!
!***********************************************************************

call FCOOR(LUT,Coor)
mdc = 0
iPERT = 0
do iCnttp=1,nCnttp
  nCnti = dbsc(iCnttp)%nCntr
  do iCnt=1,nCnti
    mdc = mdc+1

    nCenti = nIrrep/dc(mdc)%nStab

    ndc = 0
    jPERT = 0
    do jCnttp=1,nCnttp
      nCntj = dbsc(jCnttp)%nCntr
      do jCnt=1,nCntj
        ndc = ndc+1

        nCentj = nIrrep/dc(ndc)%nStab
        do iIrrep=0,nIrrep-1
          iDsp = IndDsp(mdc,iIrrep)
          do iCar=0,2
            iComp = ibset(0,iCar)
            if (TF(mdc,iIrrep,iComp)) then
              idsp = idsp+1
              jDsp = IndDsp(ndc,iIrrep)
              do jCar=0,2
                jComp = ibset(0,jCar)
                if (TF(ndc,iIrrep,jComp)) then
                  jdsp = jdsp+1
                  HE = Tmp(iTri(idsp,jdsp))
                  do iCo=0,Ncenti-1
                    do jCo=0,Ncentj-1
                      i = iPert+ico*3+icar+1
                      j = jPert+jco*3+jcar+1
                      kop_m = dc(mdc)%iCoSet(iCo,0)
                      nop_m = nropr(kop_m)
                      kop_n = dc(ndc)%iCoSet(jCo,0)
                      nop_n = nropr(kop_n)
                      riPh = real(iPrmt(nop_m,icomp)*iChTbl(iIrrep,nop_m),kind=wp)/sqrt(real(nCENTI,kind=wp))
                      rjPh = real(iPrmt(nop_n,jcomp)*ichtbl(iirrep,nop_n),kind=wp)/sqrt(real(nCENTJ,kind=wp))
                      Htmp(i,j) = Htmp(i,j)+riph*rjph*HE
                    end do ! jco
                  end do ! ico
                end if
              end do ! jcar
            end if
          end do ! icar
        end do ! irrep
        jPert = jpert+ncentj*3
      end do ! jcnt
    end do ! jcnttp
    iPert = ipert+ncenti*3
  end do ! icnt
end do ! icnttp

Label = 'Unsymmetrized Hessian'
write(LUT,'(A)') Label
write(LUT,'(A)') '*BEGIN HESSIAN'
write(LUT,'(A,I5)') '*Number of pert. ',nd
call WRH(LUT,1,[nd],[nd],Htmp,Dummy,0,Label)
write(LUT,'(A)') '*END HESSIAN'

call Put_dArray('FC-Matrix',Htmp,nd**2)

call mma_deallocate(HTMP)
call mma_deallocate(TMP)

return

end subroutine Niclas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_INP(DFONLY,LUNIT,LUOUT)
C
C     Purpose: If DFONLY, set defaults only.
C              Else, read and process input for Cholesky decomposition
C              from unit LUNIT. LUOUT is the unit of the output file
C              which is stored internally in the Cholesky program as
C              LUPRI (in cholesky.fh).
C
#include "implicit.fh"
      LOGICAL DFONLY
#include "cholesky.fh"
#include "chosubscr.fh"
#include "choprint.fh"
#include "chosimri.fh"

      CHARACTER*7 SECNAM
      PARAMETER (SECNAM = 'CHO_INP')

      LOGICAL DECALG_USRDEF, MXSHPR_USRDEF, FAKE_USRDEF
      LOGICAL FORCEPARALLEL

      CHARACTER*180 LINE
      CHARACTER*180 GET_LN
      EXTERNAL GET_LN

      INTEGER  IPRINTLEVEL
      EXTERNAL IPRINTLEVEL

      PARAMETER (LINTSCR = 2)
      INTEGER INTSCR(LINTSCR)

      PARAMETER (NOPTION = 58, LOPTION = 50)  ! #options
      CHARACTER*(LOPTION) OPTION(NOPTION)

      DATA OPTION /'set decomposition threshold                       ',
     &             'set print level                                   ',
     &             'set buffer length for diagonal calculation        ',
     &             'set threshold for discarding initial diag. elem.  ',
     &             'set damping factor for first reduced set          ',
     &             'set damping factor for later reduced sets         ',
     &             'set span                                          ',
     &             'set minimum number of qualifieds for decomposition',
     &             'set maximum number of shell pair distributions    ',
     &             'turn on diag. screening (using damping factors)   ',
     &             'turn off diag. screening                          ',
     &             'set qualification algorithm                       ',
     &             'set threshold for zeroing negative diagonals      ',
     &             'set threshold for warning about negative diagonals',
     &             'set threshold for shutdown due to negative diag.  ',
     &             'check configuration only                          ',
     &             'check all integrals (debug)                       ',
     &             'diagonal restart                                  ',
     &             'decomposition restart with default restart model  ',
     &             'set restart model                                 ',
     &             'set maximum #qualifieds per symmetry              ',
     &             'set maximum #Cholesky vectors per symmetry        ',
     &             'set max. #reduced sets (i.e., integral passes)    ',
     &             'check specified #columns (debug)                  ',
     &             'minimal integral check (debug)                    ',
     &             'use abs. value to set up reduced sets             ',
     &             'do not use abs. value to set up red. sets         ',
     &             'turn on tracing of negative diagonals (debug)     ',
     &             'set algorithm for reading Cholesky vectors        ',
     &             'set vector reordering (for int. re-generation)    ',
     &             'halt execution after decomposition                ',
     &             'set memory fraction used as buffer for vec. read  ',
     &             'set fraction of memory to be used for qual. col.  ',
     &             'set maximum number of vectors in subtraction      ',
     &             'set file address mode (WA or DA for vector files) ',
     &             'set model used to interface to integral code      ',
     &             'one-step (conventional) decomposition             ',
     &             'two-step (generate map, then vectors) decomp.     ',
     &             'naive decomposition                               ',
     &             'set memory fraction used for global vector buffer ',
     &             'set diagonal checking and set tolerance (debug)   ',
     &             'test vector subtraction screening (statistics)    ',
     &             'use screening in vector subtraction               ',
     &             'do not use screening in vector subtraction        ',
     &             'threshold for screening in vector subtraction     ',
     &             'norm to use in vector subtraction screening       ',
     &             'decompose 1-center diagonals only                 ',
     &             'decompose 1-center diagonals only; excl. 2-center ',
     &             'turn off diagonal prescreening                    ',
     &             'turn on diagonal prescreening                     ',
     &             'set diagonal prescreening threshold               ',
     &             'use parallel decomposition algorithm              ',
     &             'simulate parallel algorithm (i.e. modified span)  ',
     &             'simulate RI (input 1-center threshold)            ',
     &             'activate fake parallel decomposition              ',
     &             'activate true parallel decomposition (deact. fake)',
     &             'set block size for Z vectors (parallel two-step)  ',
     &             'activate tracing of idle nodes (parallel run)     '/

C     Define all entries in common blocks.
C     Set output unit.
C     Set run mode to "internal".
C     ------------------------------------

      IRC = 0
      CALL CHO_X_SETINC(IRC)
      LUPRI = LUOUT
      RUN_MODE = RUN_INTERNAL
      IF (IRC .NE. 0) THEN
         WRITE(LUPRI,*) SECNAM,': CHO_X_SETINC returned error code ',IRC
         WRITE(LUPRI,*) '(most likely due to a programming error...)'
         CALL CHO_QUIT('Include file initialization error in '//SECNAM,
     &                 102)
      END IF
      CALL CHO_SETPTR2()
      CALL CHO_SETGLOB()

C     Set default parallel configuration.
C     CHO_FAKE_PAR = .TRUE. : fake parallel.
C     CHO_FAKE_PAR = .FALSE.: true parallel.
C     --------------------------------------

      CHO_FAKE_PAR = .FALSE.
      CALL CHO_PARCONF(CHO_FAKE_PAR)

C     Set default decomposition algorithm (depends on parallel or serial
C     installation).
C     ------------------------------------------------------------------

      CALL CHO_SETDECALG_DEF()

C     Set default MXSHPR (depends on parallel or serial).
C     ---------------------------------------------------

      CALL CHO_SETMXSHPR_DEF(MXSHPR_DEF)

C     Set defaults.
C     -------------

      DECALG_USRDEF = .FALSE.
      MXSHPR_USRDEF = .FALSE.
      FAKE_USRDEF = .FALSE.

      CHO_DECALG = CHO_DECALG_DEF ! default decomposition algorithm
      CHO_SIMP = .FALSE. ! do not simulate parallel algorithm
      THRCOM  = THRDEF   ! default decomposition threshold
      LBUF    = 1000000  ! buffer length for initial diagonal
      THRDIAG = 0.0D0    ! threshold for initial diag. screening
      XLDIAG  = 0.0D0    ! just an initialization
      DAMP(1) = -1.0D9   ! damping for initial screening (neg.=>generic)
      DAMP(2) = -1.0D9   ! damping for later screenings (neg.=>generic)
      SPAN    = 1.0D-2   ! span factor
      MINQUAL = 50       ! min. #qual. needed for proceeding
      MAXQUAL = 100      ! max. #qual. per symmetry
      MXSHPR  = MXSHPR_DEF ! max. #sh. pairs for proceeding (0=>generic)
      SCDIAG  = .TRUE.   ! screen diagonal during decom.
      IALQUA  = 2        ! qualification algorithm
      THRNEG  = -1.0D-40 ! diag<THRNEG => diag=0
      WARNEG  = -1.0D-10 ! diag<WARNEG => diag=0, issue warning
      TOONEG  = -1.0D-8  ! diag<TOONEG => shutdown
      CHKONLY = .FALSE.  ! flag for "check input only"
      RSTDIA  = .FALSE.  ! flag for diagonal restart
      RSTCHO  = .FALSE.  ! flag for decomposition restart
      MODRST  = -1       ! default restart model (if restart at all)
      MAXVEC  = 0        ! max. #Cholesky vectors (0=>generic)
      MAXRED  = 0        ! max. #reduced sets (0=>generic)
      NCOL_CHK= 0        ! #columns to check (0=>all if requested)
      CHO_USEABS = .FALSE. ! do not use abs. value to set up red. sets
      CHO_ADRVEC = 1       ! use WA addressing of vector files
      CHO_IOVEC  = 3       ! i/o model for reading Cholesky vectors
      CHO_REORD  = .FALSE. ! reorder Cholesky vectors to full storage
      N1_VECRD   = 2       ! nominator for fraction of mem. for iovec
      N2_VECRD   = 3       ! denominator for fraction of mem. for iovec
      N1_QUAL    = 1       ! nominator for fraction of mem. for qual.
      N2_QUAL    = 3       ! denominator for fraction of mem. for qual.
      N_SUBTR    = MAXQUAL ! max. #vectors in subtraction of prev. vecs.
      HALTIT     = .FALSE. ! halt execution after decomposition
      IFCSEW     = 2       ! get integrals directly in reduced set
      FRAC_CHVBUF = 0.35D0 ! memory fraction used for vector buffer
      CHO_SSCREEN = .FALSE. ! screening in vector subtraction
      SSTAU = -1.0d9    ! threshold in vector subtraction (neg=>generic)
      SSNORM = 'Max' ! norm used for vector screening
      SUBSCRSTAT(1) = 0.0D0 ! vector screening statistics
      SUBSCRSTAT(2) = 0.0D0 ! vector screening statistics
      CHO_1CENTER = .FALSE. ! do not decompose 1-center diagonals only
      CHO_NO2CENTER = .FALSE. ! do not exclude 2-center diagonals
      CHO_PRESCREEN = .TRUE.  ! prescreen diagonal
      THR_PRESCREEN = -1.0d9 ! diag. prescreen threshold (neg=>generic)
      CHO_SIMRI = .FALSE.    ! simulate RI
      THR_SIMRI = -1.0D9     ! threshold for qualifying diags. in RI sim
#if defined (_DEBUGPRINT_)
      CHO_INTCHK = .TRUE.  ! check integrals after decomposition
      CHO_MINCHK = .TRUE.  ! minimal integral check
      CHO_TRCNEG = .TRUE.  ! tracing of negative diagonals
      CHO_DIACHK = .TRUE.  ! check diagonals in qualified columns
      TOL_DIACHK = 1.0D-10 ! tolerance for dia. checking (if requested)
      CHO_TSTSCREEN = .TRUE. ! test vector subtraction screening
#else
      CHO_INTCHK = .FALSE. ! check integrals after decomposition
      CHO_MINCHK = .FALSE. ! minimal integral check
      CHO_TRCNEG = .FALSE. ! tracing of negative diagonals
      CHO_DIACHK = .FALSE. ! check diagonals in qualified columns
      TOL_DIACHK = 1.0D-14 ! tolerance for dia. checking (if requested)
      CHO_TSTSCREEN = .FALSE. ! test vector subtraction screening
#endif
      BLOCKSIZE = 500  ! #vecs in each Z vector block
      TRACE_IDLE = .FALSE. ! trace idle processes

C     Set default print level using molcas environment (or whatever was
C     set in seward initially).
C     -----------------------------------------------------------------

      IPRINT = IPRINTLEVEL(-1)
      IF (IPRINT .LE. 2) IPRINT = 1
      IPRINT = IPRINT - 1

C     Return if defaults only.
C     ------------------------

      FORCEPARALLEL = .FALSE.
      IF (DFONLY) GO TO 2000

C     Loop through keyword input.
C     ---------------------------

 1000 CONTINUE

C        Read next keyword and get corresponding ID.
C        -------------------------------------------

         IDKEY = 0
         CALL CHO_MCA_GETKEY(LUNIT,OPTION,LOPTION,NOPTION,IDKEY,LUPRI)

         IF (IDKEY.GE.1 .AND. IDKEY.LE.NOPTION) THEN  ! key found

C           Branch for further processing.
C           ------------------------------

            IF (IDKEY .EQ.  1) GO TO  1
            IF (IDKEY .EQ.  2) GO TO  2
            IF (IDKEY .EQ.  3) GO TO  3
            IF (IDKEY .EQ.  4) GO TO  4
            IF (IDKEY .EQ.  5) GO TO  5
            IF (IDKEY .EQ.  6) GO TO  6
            IF (IDKEY .EQ.  7) GO TO  7
            IF (IDKEY .EQ.  8) GO TO  8
            IF (IDKEY .EQ.  9) GO TO  9
            IF (IDKEY .EQ. 10) GO TO 10
            IF (IDKEY .EQ. 11) GO TO 11
            IF (IDKEY .EQ. 12) GO TO 12
            IF (IDKEY .EQ. 13) GO TO 13
            IF (IDKEY .EQ. 14) GO TO 14
            IF (IDKEY .EQ. 15) GO TO 15
            IF (IDKEY .EQ. 16) GO TO 16
            IF (IDKEY .EQ. 17) GO TO 17
            IF (IDKEY .EQ. 18) GO TO 18
            IF (IDKEY .EQ. 19) GO TO 19
            IF (IDKEY .EQ. 20) GO TO 20
            IF (IDKEY .EQ. 21) GO TO 21
            IF (IDKEY .EQ. 22) GO TO 22
            IF (IDKEY .EQ. 23) GO TO 23
            IF (IDKEY .EQ. 24) GO TO 24
            IF (IDKEY .EQ. 25) GO TO 25
            IF (IDKEY .EQ. 26) GO TO 26
            IF (IDKEY .EQ. 27) GO TO 27
            IF (IDKEY .EQ. 28) GO TO 28
            IF (IDKEY .EQ. 29) GO TO 29
            IF (IDKEY .EQ. 30) GO TO 30
            IF (IDKEY .EQ. 31) GO TO 31
            IF (IDKEY .EQ. 32) GO TO 32
            IF (IDKEY .EQ. 33) GO TO 33
            IF (IDKEY .EQ. 34) GO TO 34
            IF (IDKEY .EQ. 35) GO TO 35
            IF (IDKEY .EQ. 36) GO TO 36
            IF (IDKEY .EQ. 37) GO TO 37
            IF (IDKEY .EQ. 38) GO TO 38
            IF (IDKEY .EQ. 39) GO TO 39
            IF (IDKEY .EQ. 40) GO TO 40
            IF (IDKEY .EQ. 41) GO TO 41
            IF (IDKEY .EQ. 42) GO TO 42
            IF (IDKEY .EQ. 43) GO TO 43
            IF (IDKEY .EQ. 44) GO TO 44
            IF (IDKEY .EQ. 45) GO TO 45
            IF (IDKEY .EQ. 46) GO TO 46
            IF (IDKEY .EQ. 47) GO TO 47
            IF (IDKEY .EQ. 48) GO TO 48
            IF (IDKEY .EQ. 49) GO TO 49
            IF (IDKEY .EQ. 50) GO TO 50
            IF (IDKEY .EQ. 51) GO TO 51
            IF (IDKEY .EQ. 52) GO TO 52
            IF (IDKEY .EQ. 53) GO TO 53
            IF (IDKEY .EQ. 54) GO TO 54
            IF (IDKEY .EQ. 55) GO TO 55
            IF (IDKEY .EQ. 56) GO TO 56
            IF (IDKEY .EQ. 57) GO TO 57
            IF (IDKEY .EQ. 58) GO TO 58

C           If this section is executed, it's most likely a bug.
C           ----------------------------------------------------

            WRITE(LUPRI,*) 'IDKEY = ',IDKEY,' is formally legal, but:'
            WRITE(LUPRI,*) 'Did you forget to change the ',
     &                     'computed goto in ',SECNAM,'?'
            CALL CHO_QUIT('Illegal address in computed GOTO in '
     &                    //SECNAM,105)

C           Read decomposition threshold.
C           -----------------------------

    1       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,THRCOM)
            GO TO 1000

C           Read print level.
C           -----------------

    2       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,IPRINT)
            GO TO 1000

C           Read buffer length for diagonal calculation.
C           --------------------------------------------

    3       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,LBUF)
            GO TO 1000

C           Read threshold for discarding initial diagonal elements.
C           --------------------------------------------------------

    4       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,THRDIAG)
            GO TO 1000

C           Read damping factor for 1st reduced set.
C           ----------------------------------------

    5       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,DAMP(1))
            GO TO 1000

C           Read damping factor for later reduced set.
C           ------------------------------------------

    6       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,DAMP(2))
            GO TO 1000

C           Read span factor.
C           -----------------

    7       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,SPAN)
               SPAN=MIN(ABS(SPAN),1.0d0)
            GO TO 1000

C           Read minimum number of qualifieds for decomposition.
C           ----------------------------------------------------

    8       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,MINQUAL)
            GO TO 1000

C           Read maximum number of shell pair distributions that should
C           be calculated before passing to decomposition.
C           -----------------------------------------------------------

    9       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,MXSHPR)
            GO TO 1000

C           Turn on screening.
C           ------------------

   10       CONTINUE
               SCDIAG = .TRUE.
            GO TO 1000

C           Turn off screening.
C           -------------------

   11       CONTINUE
               SCDIAG = .FALSE.
            GO TO 1000

C           Read algorithm ID for qualification procedure,
C           1: qualify from 1 to max.
C           2: qualify the largest qualifiables
C           ----------------------------------------------

   12       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,IALQUA)
            GO TO 1000

C           Read threshold for zeroing (small) negative diagonals.
C           Diag < THRNEG => Diag = 0.
C           ------------------------------------------------------

   13       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,THRNEG)
            GO TO 1000

C           Read threshold for warning about negative diagonals.
C           Diag < WARNEG => Diag = 0, but issue warning.
C           ----------------------------------------------------

   14       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,WARNEG)
            GO TO 1000

C           Read threshold for shutdown due to negative diagonals.
C           Diag < TOONEG => shutdown.
C           ------------------------------------------------------

   15       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,TOONEG)
            GO TO 1000

C           Check configuration only.
C           -------------------------

   16       CONTINUE
               CHKONLY = .TRUE.
            GO TO 1000

C           Check all integrals after decomposition.
C           ----------------------------------------

   17       CONTINUE
               CHO_INTCHK = .TRUE.
               CHO_MINCHK = .FALSE.
               NCOL_CHK   = 0  ! => all
            GO TO 1000

C           Restart diagonal.
C           -----------------

   18       CONTINUE
               RSTDIA = .TRUE.
            GO TO 1000

C           Restart decomposition using default model.
C           ------------------------------------------

   19       CONTINUE
               IF (.NOT. RSTCHO) THEN
                  RSTCHO = .TRUE.
                  MODRST = -1  ! use configuration from restart file
               END IF
            GO TO 1000

C           Read restart model and set restart.
C           -----------------------------------

   20       CONTINUE
               RSTCHO = .TRUE.
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,MODRST)
               IF (MODRST .LT. 0) THEN
                  MODRST = -1  ! use configuration from restart file
               ELSE IF (MODRST .GT. 0) THEN
                  MODRST = 1   ! use configuration from input
               END IF
            GO TO 1000

C           Read max. #qualifieds per symmetry.
C           -----------------------------------

   21       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,MAXQUAL)
            GO TO 1000

C           Read max. #Cholesky vectors per symmetry.
C           -----------------------------------------

   22       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,MAXVEC)
            GO TO 1000

C           Read max. #reduced sets.
C           ------------------------

   23       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,MAXRED)
            GO TO 1000

C           Read number of integral columns to check.
C           -----------------------------------------

   24       CONTINUE
               CHO_INTCHK = .TRUE.
               CHO_MINCHK = .FALSE.
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,NCOL_CHK)
            GO TO 1000

C           Minimal integral check.
C           -----------------------

   25       CONTINUE
               CHO_INTCHK = .TRUE.
               CHO_MINCHK = .TRUE.
            GO TO 1000

C           Use abs. value to set up reduced sets.
C           --------------------------------------

   26       CONTINUE
               CHO_USEABS = .TRUE.
            GO TO 1000

C           Do not use abs. value to set up reduced sets.
C           ---------------------------------------------

   27       CONTINUE
               CHO_USEABS = .FALSE.
            GO TO 1000

C           Turn on tracing of negative diagonals.
C           --------------------------------------

   28       CONTINUE
               CHO_TRCNEG = .TRUE.
            GO TO 1000

C           Read I/O model used for reading Cholesky vectors.
C           -------------------------------------------------

   29       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,CHO_IOVEC)
            GO TO 1000

C           Set vector reordering.
C           ----------------------

   30       CONTINUE
               CHO_REORD = .TRUE.
            GO TO 1000

C           Halt execution after decomposition.
C           -----------------------------------

   31       CONTINUE
               HALTIT = .TRUE.
            GO TO 1000

C           Set fraction of memory to be used as vector buffer during
C           subtraction.
C           ---------------------------------------------------------

   32       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I(1,INTSCR,2)
               N1_VECRD = INTSCR(1)
               N2_VECRD = INTSCR(2)
            GO TO 1000

C           Set fraction of memory to be used for qualified columns.
C           --------------------------------------------------------

   33       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I(1,INTSCR,2)
               N1_QUAL = INTSCR(1)
               N2_QUAL = INTSCR(2)
            GO TO 1000

C           Set max. #vectors in subtraction of prev. vectors.
C           --------------------------------------------------

   34       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,N_SUBTR)
            GO TO 1000

C           Set address mode for vector I/O: WA (=1) or DA (=2).
C           ----------------------------------------------------

   35       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,CHO_ADRVEC)
            GO TO 1000

C           Set model used to interface to integral code.
C           ---------------------------------------------

   36       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_I1(1,IFCSEW)
               IF (IFCSEW .LT. 1) THEN
                  IFCSEW = 1
               ELSE IF (IFCSEW .GT. 2) THEN
                  IFCSEW = 2
               END IF
            GO TO 1000

C           One-step (conventional) decomposition.
C           --------------------------------------

   37       CONTINUE
               CHO_DECALG = 1
               DECALG_USRDEF = .TRUE.
            GO TO 1000

C           Two-step (generate map, then vectors) decomposition.
C           ----------------------------------------------------

   38       CONTINUE
               CHO_DECALG = 2
               DECALG_USRDEF = .TRUE.
            GO TO 1000

C           Naive decomposition (remove diagonals as soon as smaller
C           than threshold).
C           --------------------------------------------------------

   39       CONTINUE
               CHO_DECALG = 3
               DECALG_USRDEF = .TRUE.
            GO TO 1000

C           Set memory fraction used for vector buffer.
C           -------------------------------------------

   40       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,FRAC_CHVBUF)
            GO TO 1000

C           Turn on diagonal checking of qualified columns both before
C           and after subtraction of previous vectors. Set tolerance in
C           checking.
C           -----------------------------------------------------------

   41       CONTINUE
               CHO_DIACHK = .TRUE.
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,TOL_DIACHK)
            GO TO 1000

C           Test vector subtraction screening.
C           ----------------------------------

   42       CONTINUE
               CHO_TSTSCREEN = .TRUE.
            GO TO 1000

C           Use screening in vector subtraction.
C           ------------------------------------

   43       CONTINUE
               CHO_SSCREEN = .TRUE.
            GO TO 1000

C           Do not use screening in vector subtraction.
C           -------------------------------------------

   44       CONTINUE
               CHO_SSCREEN = .FALSE.
            GO TO 1000

C           Threshold for screening in vector subtraction.
C           ----------------------------------------------

   45       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,SSTAU)
            GO TO 1000

C           Threshold for screening in vector subtraction.
C           ----------------------------------------------

   46       CONTINUE
               LINE = GET_LN(LUNIT)
               CALL GET_S(1,SSNORM,1)
            GO TO 1000

C           Decompose 1-center diagonals only. 2-center diagonals are
C           still included, but never explicitly decomposed.
C           ---------------------------------------------------------

   47       CONTINUE
               CHO_1CENTER = .TRUE.
            GO TO 1000

C           Decompose 1-center diagonals only. 2-center diagonals are
C           never included.
C           ---------------------------------------------------------

   48       CONTINUE
               CHO_1CENTER = .TRUE.
               CHO_NO2CENTER = .TRUE.
            GO TO 1000

C           Turn off diagonal prescreening.
C           -------------------------------

   49       CONTINUE
               CHO_PRESCREEN = .FALSE.
            GO TO 1000

C           Turn on diagonal prescreening.
C           ------------------------------

   50       CONTINUE
               CHO_PRESCREEN = .TRUE.
            GO TO 1000

C           Set diagonal prescreening threshold.
C           ------------------------------------

   51       CONTINUE
               CHO_PRESCREEN = .TRUE.
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,THR_PRESCREEN)
            GO TO 1000

C           Use "parallel" decomposition algorithm.
C           ---------------------------------------

   52       CONTINUE
               FORCEPARALLEL = .TRUE.
            GO TO 1000

C           Use "parallel" decomposition algorithm.
C           ---------------------------------------

   53       CONTINUE
               CHO_SIMP = .TRUE.
            GO TO 1000

C           Simulate RI.
C           Activate 1-center decomposition.
C           Read threshold for removing 1-center diagonals in map
C           generation.
C           -----------------------------------------------------

   54       CONTINUE
               CHO_SIMRI = .TRUE.
               CHO_1CENTER = .TRUE.
               LINE = GET_LN(LUNIT)
               CALL GET_F1(1,THR_SIMRI)
            GO TO 1000

C           Activate fake parallel:
C           Run parallel decomposition, then distribute vectors if
C           parallel.
C           ------------------------------------------------------

   55       CONTINUE
               CHO_FAKE_PAR = .TRUE.
               FAKE_USRDEF = .TRUE.
            GO TO 1000

C           Activate true parallel decomposition (deactivate fake).
C           -------------------------------------------------------

   56       CONTINUE
               CHO_FAKE_PAR = .FALSE.
               FAKE_USRDEF = .TRUE.
            GO TO 1000

C           Read BlockSize (Z vectors).
C           ---------------------------

   57       CONTINUE
                LINE = GET_LN(LUNIT)
                CALL GET_I1(1,BLOCKSIZE)
            GO TO 1000

C           Turn on tracing of idle nodes.
C           ------------------------------

   58       CONTINUE
               TRACE_IDLE = .TRUE.
            GO TO 1000

         ELSE IF (IDKEY .EQ. NOPTION+1) THEN  ! end of input
            GO TO 2000
         ELSE IF (IDKEY .EQ. -5) THEN ! some internal error
            GO TO 1300
         ELSE IF (IDKEY .EQ. -1) THEN ! keyword error
            GO TO 1200
         ELSE  ! catch all out-of-bound errors
            GO TO 1100
         END IF

C     Post processing.
C     ----------------

 2000 CONTINUE
      IF (FAKE_USRDEF) THEN
         CALL CHO_PARCONF(CHO_FAKE_PAR) ! reset parallel configuration
         IF (.NOT.DECALG_USRDEF) THEN ! reset default decomposition alg
            CALL CHO_SETDECALG_DEF()
            CHO_DECALG = CHO_DECALG_DEF
         END IF
         IF (.NOT.MXSHPR_USRDEF) THEN ! reset default MXSHPR
            CALL CHO_SETMXSHPR_DEF(MXSHPR_DEF)
            MXSHPR = MXSHPR_DEF
         END IF
      END IF
      CALL CHO_INP_SETDECALG(FORCEPARALLEL)
      IF (.NOT.MXSHPR_USRDEF) THEN
         IF (CHO_DECALG.EQ.4 .OR. CHO_DECALG.EQ.5 .OR.
     &       CHO_DECALG.EQ.6) THEN
            MXSHPR=1
         ELSE
            MXSHPR=0
         END IF
      END IF

C     Put decomposition threshold in info.fh.
C     ---------------------------------------

      CALL PUT_THR_CHO(THRCOM)

C     Normal exit.
C     ------------

      RETURN

C     Error exits.
C     ------------

 1100 CONTINUE ! IDKEY out of bounds
      WRITE(LUPRI,*) SECNAM,': IDKEY out of bounds: ',IDKEY
      IRC = 104
      GO TO 9999

 1200 CONTINUE ! keyword error
      WRITE(LUPRI,*) SECNAM,': keyword error detected, IDKEY = ',IDKEY
      IRC = 105
      GO TO 9999

 1300 CONTINUE ! some internal error
      WRITE(LUPRI,*) SECNAM,': internal error detected, IDKEY = ',IDKEY
      IRC = 103
      GO TO 9999

 9999 CALL CHO_QUIT('Error in '//SECNAM,IRC)
      END
************************************************************************
*                                                                      *
************************************************************************
      Subroutine Put_thr_Cho(ThrCom)
      use RICD_Info, only: Do_RI, Thrshld_CD
      Implicit Real*8 (a-h,o-z)
*
      If (.not. Do_RI) Thrshld_CD = ThrCom
*
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      SubRoutine Cho_Inp_SetDecAlg(ForceParallel)
      Implicit None
      Logical ForceParallel
#include "cholesky.fh"
#include "cho_para_info.fh"

      If (Cho_Real_Par .or. ForceParallel) Then
         If (Cho_DecAlg .eq. 1) Then
            Cho_DecAlg = 4  ! parallel one-step
         Else If (Cho_DecAlg .eq. 2) Then
            Cho_DecAlg = 5 ! parallel two-step
         Else If (Cho_DecAlg .eq. 3) Then
            Cho_DecAlg = 6  ! parallel naive
         End If
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine intchk_cvb(iarr,nmax,nread,ifc,a,lflag)
      implicit real*8 (a-h,o-z)
      parameter (nkeyw=3,ncmp=4)
      character*8 keyword(nkeyw)
      character*(*) a
#include "malloc_cvb.fh"
      dimension iarr(*),ito(1)
      save keyword
      data keyword/'NONE    ','ALL     ','TO      '/

      nread=0
      lf=lflag
1000  call fstring_cvb(keyword,nkeyw,istr,ncmp,1)
      if(istr.gt.0)lf=lflag
      if(istr.eq.1)then
c 'NONE'
        nread=0
      elseif(istr.eq.2)then
c 'ALL'
        if(lflag.eq.-1)then
          nread=nmax
          do 100 i=1,nmax
          iarr(i)=i
100       continue
        else
          nread=0
          lf=1-lflag
        endif
      elseif(istr.eq.3)then
c 'TO'
        if(nread.eq.nmax)then
          write(6,'(3a)')' Too many numbers specified in ',a,
     >      ' keyword!'
          call abend_cvb()
        elseif(nread.eq.0)then
          write(6,'(3a)')' No number before ',a,' -- TO keyword!'
          call abend_cvb()
        endif
        call int_cvb(ito,1,nr,ifc)
        if(nr.eq.-1)then
          write(6,'(3a)')' No number after ',a,' -- TO keyword!'
          call abend_cvb()
        endif
        ifrom=iarr(nread)
        if(ifrom.gt.ito(1))then
          write(6,*)' From greater than to:',ifrom,ito(1)
          call abend_cvb()
        elseif(nread+ito(1)-ifrom.gt.nmax)then
          write(6,'(3a)')' Too many numbers specified in ',a,
     >      ' keyword!'
          call abend_cvb()
        endif
        do 150 i=ifrom+1,ito(1)
        nread=nread+1
        iarr(nread)=i
150     continue
      else
        call int_cvb(iarr(1+nread),nmax-nread,nr,ifc)
        if(nread.gt.0)lf=lflag
        if(nr.eq.-1)then
          write(6,'(3a)')' Too many numbers specified in ',a,
     >      ' keyword!'
          call abend_cvb()
        endif
        nread=nread+nr
      endif
      if(istr.gt.0.or.nr.gt.0)goto 1000

      if(lflag.ne.-1)lflag=lf

      do 200 i=1,nread
      if(iarr(i).lt.1.or.iarr(i).gt.nmax)then
        write(6,'(3a,i5)')' Illegal ',a,' number read!',iarr(i)
        write(6,'(a,i3)')' Must be in the range 1 --',nmax
        call abend_cvb()
      endif
200   continue

c  Sort numbers and ensure uniqueness :
      call sorti_cvb(nread,iarr)
      ncnt=1
      do 300 i=2,nread
      if(iarr(i).ne.iarr(ncnt))then
        ncnt=ncnt+1
        iarr(ncnt)=iarr(i)
      endif
300   continue
      nread=min(ncnt,nread)

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine creates a list of basis function labels.                *
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine MkType()

use Genano_globals, only: MxLqn, symlab
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iFrom, iTo, l, m
integer(kind=iwp), parameter :: MxLst = MxLqn*(MxLqn*(MxLqn+6)+11)/6+1
character(len=8) :: CrtLst(0:MxLst), SphLst(0:MxLst)

!----------------------------------------------------------------------*
! Get labels from utility routine                                      *
!----------------------------------------------------------------------*
call Make_Labels(CrtLst,SphLst,MxLst,MxLqn)
!write(u6,*) 'Cartesian label'
!ind = 0
!do l=0,MxLqn
!  write(u6,'(15(1x,a4))') (CrtLst(ind+m),m=0,l*(l+3)/2)
!  ind = ind+l*(l+3)/2+1
!end do
!write(u6,*) 'Spherical label'
!ind = 0
!do i=0,MxLqn
!  do l=i,0,-2
!    write(u6,'(15(1x,a4))') (SphLst(ind+m),m=0,2*l)
!    ind = ind+2*l+1
!  end do
!end do
!----------------------------------------------------------------------*
! Copy labels                                                          *
!----------------------------------------------------------------------*
iFrom = 0
iTo = 1
do l=0,MxLqn
  if (l < 2) then
    do m=0,2*l
      symlab(iTo+m) = CrtLst(iFrom+m)
    end do
  else
    do m=0,2*l
      symlab(iTo+m) = SphLst(iFrom+m)
    end do
  end if
  iFrom = iFrom+l*(l+3)/2+1
  iTo = iTo+2*l+1
end do
!write(u6,*) 'Local labels'
!ind=1
!do l=0,MxLqn
!   write(u6,'(15(1x,a4))') (symlab(ind+m),m=0,2*l)
!   ind = ind+2*l+1
!end do

return

end subroutine Mktype

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995,1997, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE ADAADAST_GAS(    IOB,  IOBSM,  IOBTP,   NIOB,    IAC,
     &                            JOB,  JOBSM,  JOBTP,   NJOB,    JAC,
     &                          ISPGP,    ISM,    ITP,   KMIN,   KMAX,
     &                             I1,   XI1S,    LI1,     NK,   IEND,
     &                          IFRST,  KFRST,    I12,    K12, SCLFAC)
*
*
* Obtain two-operator mappings
* a+/a IORB a+/a JORB !KSTR> = +/-!ISTR>
*
* Whether creation- or annihilation operators are in use depends
* upon IAC, JAC : 1=> Annihilation,
*                 2=> Creation
*
* In the form
* I1(KSTR) =  ISTR if a+/a IORB a+/a JORB !KSTR> = +/-!ISTR> , ISTR is in
* ISPGP,ISM,IGRP.
* (numbering relative to TS start)
*. Only excitations IOB. GE. JOB are included
* The orbitals are in GROUP-SYM IOBTP,IOBSM, JOBTP,JOBSM respectively,
* and IOB (JOB) is the first orbital to be used, and the number of orbitals
* to be checked is NIOB ( NJOB).
*
* Only orbital pairs IOB .gt. JOB are included (if the types are identical)
*
* The output is given in I1(KSTR,I,J) = I1 ((KSTR,(J-1)*NIOB + I)
*
* Above +/- is stored in XI1S
* Number of K strings checked is returned in NK
* Only Kstrings with relative numbers from KMIN to KMAX are included
*
* If IEND .ne. 0 last string has been checked
*
* Jeppe Olsen , August of 95   ( adadst)
*               November 1997 : annihilation added
*
*
* ======
*. Input
* ======
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
*./BIGGY
#include "WrkSpc.fh"
!      COMMON/BIGGY/WORK(MXPWRD)
*./ORBINP/
#include "orbinp.fh"
#include "strinp.fh"
#include "strbas.fh"
#include "cgas.fh"
#include "gasstr.fh"
*. Local scratch
      COMMON/HIDSCR/KLOCSTR(4),KLREO(4),KLZ(4),KLZSCR
      COMMON/SSAVE/NELIS(4), NSTRKS(4)
      COMMON/UMMAGUMMA/NSTRIA(4)
C-jwk-cleanup      INTEGER KELFGRP(MXPNGAS)
      INTEGER KGRP(MXPNGAS)
      DIMENSION IDUM(1)
c      COMMON/COMJEP/MXACJ,MXACIJ,MXAADST
*
* =======
*. Output
* =======
*
      INTEGER I1(*)
      DIMENSION XI1S(*)
* Some dummy initializations
      IIGRP = 0 ! jwk-cleanup
      JJGRP = 0 ! jwk-cleanup
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' ====================== '
        WRITE(6,*) ' ADAADST_GAS in service '
        WRITE(6,*) ' ====================== '
        WRITE(6,*)
        WRITE(6,*) ' IOB,IOBSM,IOBTP,IAC ', IOB,IOBSM,IOBTP,IAC
        WRITE(6,*) ' JOB,JOBSM,JOBTP,JAC ', JOB,JOBSM,JOBTP,JAC
        WRITE(6,*) ' I12, K12 ', I12, K12
        WRITE(6,*) ' IFRST,KFRST', IFRST,KFRST
      END IF
*
*
*. Internal affairs
*
      IF(I12.LE.4.AND.K12.LE.1) THEN
        KLLOC = KLOCSTR(K12)
        KLLZ = KLZ(I12)
        KLLREO = KLREO(I12)
      ELSE
        WRITE(6,*)
     &  ' ADST_GAS : Illegal value of I12 or K12 ', I12, K12
*        STOP' ADST_GAS : Illegal value of I12 or K12  '
        CALL SYSABENDMSG('lucia_util/adst_gas',
     &                    'Internal error',' ')
        RETURN
      END IF
      IF(NTEST.GE.1000) THEN
        WRITE(6,*) ' KLLOC KLLREO',KLLOC,KLLREO
      END IF

*
*. Supergroup and symmetry of K strings
*
      CALL SYMCOM(2,0,IOBSM,K1SM,ISM)
      CALL SYMCOM(2,0,JOBSM,KSM,K1SM)
      IF(NTEST.GE.100) WRITE(6,*) ' K1SM,KSM : ',  K1SM,KSM
      ISPGPABS = IBSPGPFTP(ITP)-1+ISPGP
      IACADJ = 2
      IDELTA =-1
      IF(IAC.EQ.2) THEN
        IACADJ = 1
        IDELTA = 1
      END IF
      JACADJ = 2
      JDELTA =-1
      IF(JAC.EQ.2) THEN
        JACADJ = 1
        JDELTA = 1
      END IF
      IF(NTEST.GE.100) THEN
       WRITE(6,*) ' IACADJ, JACADJ', IACADJ,JACADJ
       WRITE(6,*) ' IDELTA, JDELTA', IDELTA, JDELTA
      END IF
*. Occupation of K-strings
      IF(IOBTP.EQ.JOBTP) THEN
        IEL = NELFSPGP(IOBTP,ISPGPABS)-IDELTA-JDELTA
        JEL = IEL
      ELSE
        IEL = NELFSPGP(IOBTP,ISPGPABS)-IDELTA
        JEL = NELFSPGP(JOBTP,ISPGPABS)-JDELTA
      END IF
      IF(NTEST.GE.100) WRITE(6,*) ' IEL, JEL', IEL,JEL
*. Trivial zero ? (Nice, then mission is complete )
      ITRIVIAL = 0
      IF(IEL.LT.0.OR.JEL.LT.0.OR.
     &   IEL.GT.NOBPT(IOBTP).OR.JEL.GT.NOBPT(JOBTP)) THEN
*. No strings with this number of elecs - be happy : No work
        NK = 0
        KACT = 0
        KACGRP = 0
        IF(NTEST.GE.100) WRITE(6,*) ' Trivial zero excitations'
        ITRIVIAL = 1
C       GOTO 9999
      ELSE
*. Find group with IEL electrons in IOBTP, JEL in JOBTP
        IIGRP = 0
        DO IGRP = IBGPSTR(IOBTP),IBGPSTR(IOBTP)+NGPSTR(IOBTP)-1
          IF(NELFGP(IGRP).EQ.IEL) IIGRP = IGRP
        END DO
        JJGRP = 0
        DO JGRP = IBGPSTR(JOBTP),IBGPSTR(JOBTP)+NGPSTR(JOBTP)-1
          IF(NELFGP(JGRP).EQ.JEL) JJGRP = JGRP
        END DO
C?      WRITE(6,*) ' ADAADA : IIGRP, JJGRP', IIGRP,JJGRP
*
        IF(IIGRP.EQ.0.OR.JJGRP.EQ.0) THEN
          WRITE(6,*)' ADAADAST : cul de sac, active K groups not found'
          WRITE(6,*)' Active GAS spaces  ' ,IOBTP, JOBTP
          WRITE(6,*)' Number of electrons', IEL, JEL
*          STOP      ' ADAADAST : cul de sac, active K groups not found'
        CALL SYSABENDMSG('lucia_util/adaadast_gas',
     &                    'Internal error',' ')
        END IF
*
      END IF
*. Groups defining Kstrings
      IF(ITRIVIAL.NE.1) THEN
      CALL ICOPVE(ISPGPFTP(1,ISPGPABS),KGRP,NGAS)
      KGRP(IOBTP) = IIGRP
      KGRP(JOBTP) = JJGRP
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Groups in KGRP '
        CALL IWRTMA(KGRP,1,NGAS,1,NGAS)
      END IF
      END IF
*
* In ADADS1_GAS we need : Occupation of KSTRINGS
*                         lexical => Actual order for I strings
* Generate if required
*
      IF(IFRST.NE.0) THEN
*.. Generate information about I strings
*. Arc weights for ISPGP
        NTEST2 = NTEST
        CALL WEIGHT_SPGP(iWORK(KLLZ),
     &                       NGAS,
     &                   NELFSPGP(1,ISPGPABS),
     &                      NOBPT,
     &                   iWORK(KLZSCR),
*
     &                     NTEST2)
        NELI = NELFTP(ITP)
        NELIS(I12) = NELI
*. Reorder array for I strings
        CALL GETSTR_TOTSM_SPGP(    ITP,  ISPGP,    ISM,   NELI,  NSTRI,
     &                         IWORK(KLLOC),
     &                           NOCOB,
     &                               1,
     &                         IWORK(KLLZ),
*
     &                         IWORK(KLLREO))
        IF(NTEST.GE.1000) THEN
         write(6,*) ' Info on I strings generated '
         write(6,*) ' NSTRI = ', NSTRI
         WRITE(6,*) ' REORDER array '
         CALL IWRTMA(iWORK(KLLREO),1,NSTRI,1,NSTRI)
       END IF
       NSTRIA(I12) = NSTRI
*
      END IF
      IF(NTEST.GE.1000) THEN
       WRITE(6,*) ' REORDER array for I STRINGS'
       CALL IWRTMA(iWORK(KLLREO),1,NSTRI,1,NSTRI)
      END IF
*
      IF(ITRIVIAL.EQ.1) GOTO 9999
      NELK = NELIS(I12)
      IF(IAC.EQ.1) THEN
        NELK = NELK + 1
      ELSE
        NELK = NELK - 1
      END IF
      IF(JAC.EQ.1) THEN
        NELK = NELK + 1
      ELSE
        NELK = NELK - 1
      END IF
      IF(NTEST.GE.100) WRITE(6,*) ' NELK = ' , NELK
      IF(KFRST.NE.0) THEN
*. Generate occupation of K STRINGS
       IDUM(1)=0
       CALL GETSTR2_TOTSM_SPGP(   KGRP,   NGAS,    KSM,   NELK,  NSTRK,
     &                         iWORK(KLLOC),NOCOB,    0, IDUM, IDUM)
C     GETSTR2_TOTSM_SPGP(IGRP,NIGRP,ISPGRPSM,NEL,NSTR,ISTR,
C    &                              NORBT,IDOREO,IZ,IREO)
       NSTRKS(K12) = NSTRK
       IF(NTEST.GE.1000) THEN
         WRITE(6,*) ' K strings generated '
         WRITE(6,*) ' Reorder array after generation of K strings'
         CALL IWRTMA(iWORK(KLLREO),1,NSTRI,1,NSTRI)
       END IF
      END IF
*
      NSTRK = NSTRKS(K12)
*
      IIOB = IOBPTS(IOBTP,IOBSM) + IOB - 1
      JJOB = IOBPTS(JOBTP,JOBSM) + JOB - 1
*
      IZERO = 0
      ZERO = 0.0D0
      CALL ISETVC(I1  ,IZERO,LI1*NIOB*NJOB)
COLD  CALL SETVEC(XI1S,ZERO ,LI1*NIOB*NJOB)
*
      CALL ADAADAS1_GAS(      NK,      I1,    XI1S,     LI1,    IIOB,
     &                      NIOB,     IAC,    JJOB,    NJOB,     JAC,
     &                  iWORK(KLLOC), NELK,NSTRK,
     &                  iWORK(KLLREO),iWORK(KLLZ),
     &                     NOCOB,    KMAX,    KMIN,    IEND,  SCLFAC,
     &                  NSTRIA(I12))
*
*
       IF(NTEST.GE.1000) THEN
         WRITE(6,*) ' Reorder array after ADAADAS1'
         CALL IWRTMA(iWORK(KLLREO),1,NSTRI,1,NSTRI)
       END IF
 9999 CONTINUE
*
C     WRITE(6,*) ' Memcheck at end of ADAADAS1 '
C     CALL MEMCHK
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine g_high(esom,GRAD,s_som,dipsom,imltpl,d,Do_structure_abc,cryst,coord,gtens,maxes,iprint)
! this routine calculates the g-tensor and d-tensor in the basis of the any effective spin,
! (coming from 1 molecular term)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: imltpl, d, iprint
real(kind=wp), intent(in) :: esom(d), cryst(6), coord(3)
logical(kind=iwp), intent(in) :: GRAD, Do_structure_abc
real(kind=wp), intent(out) :: gtens(3), maxes(3,3)
complex(kind=wp), intent(in) :: s_som(3,d,d), dipsom(3,d,d)
integer(kind=iwp) :: i

! intializations
if (Iprint > 2) then
  call prMom('G_HIGH:  DIPSOM(l,i,j):',dipsom,d)
  call prMom('G_HIGH:   S_SOM(l,i,j):',s_som,d)
end if
!-----------------------------------------------------------------------
write(u6,'(/)')
write(u6,'(A)') repeat('%',95)
if (mod(d,2) == 0) then
  write(u6,'(5X,A,I2,A,I2,A)') 'CALCULATION OF PSEUDOSPIN HAMILTONIAN TENSORS FOR THE MULTIPLET',iMLTPL, &
                               ' ( effective S = ',d-1,'/2)'
else
  write(u6,'(5X,A,I2,A,I1,A)') 'CALCULATION OF PSEUDOSPIN HAMILTONIAN TENSORS FOR THE MULTIPLET',iMLTPL, &
                               ' ( effective S = ',(d-1)/2,')'
end if
write(u6,'(A)') repeat('%',95)
write(u6,'(A)') 'The pseudospin is defined in the basis of the following spin-orbit states:'
do i=1,d
  if (d > 9) then
    write(u6,'(a,i2,a,i2,a,f11.3,a)') 'spin-orbit state',i,'; energy(',i,') = ',ESOM(i),' cm-1.'
  else
    write(u6,'(a,i1,a,i1,a,f11.3,a)') 'spin-orbit state ',i,'; energy(',i,') = ',ESOM(i),' cm-1.'
  end if
end do
if (d == 2) write(u6,'(a,f17.10,a)') 'Tunnelling splitting:',ESOM(2)-ESOM(1),' cm-1.'

call G_HIGH_1(iMLTPL,d,ESOM,GRAD,S_SOM,dipsom,Do_structure_abc,cryst,coord,gtens,maxes,iprint)

return

end subroutine g_high

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ang1(ang,dfac,nanb,lalb,mamb,lamu,lmf,lml,lmx,lmy,lmz,ltot1,xab,yab,zab,xk,yk,zk,zlm)
! compute type 1 angular integrals

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ltot1, nanb, lalb, mamb, lamu, lmf(*), lml(*), lmx(*), lmy(*), lmz(*)
real(kind=wp), intent(out) :: ang(ltot1,lamu)
real(kind=wp), intent(in) :: dfac(*), xab(*), yab(*), zab(*), xk, yk, zk, zlm(*)
integer(kind=iwp) :: i, iend, indx, indy, indz, istart, l, l2, lam, lamhi, lamlo, loc, m, mu1, n, nlm
real(kind=wp) :: a_int, angt, pre, xkp, ykp, zkp

ang(:,:) = Zero
do n=1,nanb
  if (xab(n) == Zero) cycle
  do l=1,lalb
    if (yab(l) == Zero) cycle
    do m=1,mamb
      if (zab(m) == Zero) cycle
      nlm = ((n-2)+l)+m
      lamlo = mod(nlm-1,2)+1
      lamhi = min(nlm,lamu)
      if (lamlo > lamhi) cycle
      do lam=lamlo,lamhi,2
        l2 = lam+lam-1
        angt = Zero
        loc = (lam-1)**2
        do mu1=1,l2
          istart = lmf(loc+mu1)
          if ((mod(n,2) == mod(lmx(istart),2)) .or. &
              (mod(l,2) == mod(lmy(istart),2)) .or. &
              (mod(m,2) == mod(lmz(istart),2))) cycle
          pre = Zero
          a_int = Zero
          iend = lml(loc+mu1)
          do i=istart,iend
            indx = lmx(i)
            indy = lmy(i)
            indz = lmz(i)
            if (indx == 0) then
              xkp = One
            else
              xkp = xk**indx
            end if
            if (indy == 0) then
              ykp = One
            else
              ykp = yk**indy
            end if
            if (indz == 0) then
              zkp = One
            else
              zkp = zk**indz
            end if
            pre = pre+zlm(i)*xkp*ykp*zkp
            a_int = a_int+zlm(i)*dfac(n+indx)*dfac(l+indy)*dfac(m+indz)/dfac((n+indx)+(l+indy)+(m+indz))
          end do
          angt = angt+pre*a_int
        end do
        ang(nlm,lam) = ang(nlm,lam)+((xab(n)*yab(l))*zab(m))*angt
      end do
    end do
  end do
end do

return

end subroutine ang1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Set_Basis_Mode_Atomic(i,j)
      use Basis_Info, only: dbsc
#include "Basis_Mode.fh"
*
      If (dbsc(i)%Aux) Then
         Basis_Mode = Auxiliary_Mode
      Else
         Basis_Mode = Valence_Mode
      End If
*
      Do k = i+1, j
         If (dbsc(i)%Aux.neqv.dbsc(k)%Aux) Then
            Call WarningMessage(2,
     &              'dbsc(i)%Aux.ne.dbsc(k)%Aux')
            Call Abend()
         End If
      End Do
*
      Atomic=.True.
      kCnttp = i
      lCnttp = j
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine seg_drt()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "stdalloc.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      dimension j(4)
      allocatable jpihy(:)
      jpmax=no(norb_inn+1)
      iy=0
      ihy=0
      jj_sub=0
      jphy=0

      iy(1,jpad)=1
      ndim=0
      if(norb_act.eq.0) then
        if(jpad.ne.ipae) return
        ndim=1
        jj_sub(1,jpad)=jpae
        return
      endif
      do i=1,4
        j(i)=jj(i,jpad)
        if(j(i).ne.0) then
          iy(1,j(i))=1
          jj_sub(i,jpad)=j(i)
        endif
      enddo

      jps=1
      jpe=no(norb_inn+1)
      do jp=jps,jpe
        jj_sub(1:4,jp)=0                 !!!!!
        if(iy(1,jp).eq.0) cycle
        do i=1,4
          j(i)=jj(i,jp)
          if(j(i).eq.0) cycle
          iy(1,j(i))=1
          jj_sub(i,jp)=j(i)
        enddo
      enddo

      if(iy(1,jpae).eq.0) then
        ndim=0
        nohy=0
        return
      endif

      iy(1,1:jpmax)=0
      iy(1,jpae)=1

      do jp0=no(norb_inn-1)+1,no(norb_inn)
        if(jj_sub(1,jp0).ne.jpae) jj_sub(1,jp0)=0
        if(jj_sub(2,jp0).ne.jpae) jj_sub(2,jp0)=0
        if(jj_sub(3,jp0).ne.jpae) jj_sub(3,jp0)=0
        if(jj_sub(4,jp0).ne.jpae) jj_sub(4,jp0)=0
      enddo
      do 20 lr=norb_inn-1,norb_dz+1,-1
        jps=no(lr)+1
        jpe=no(lr+1)
        do 21 jde=jps,jpe
          j1=jj_sub(1,jde)
          j2=jj_sub(2,jde)
          j3=jj_sub(3,jde)
          j4=jj_sub(4,jde)
          iy(1,jde)=iy(1,j1)+iy(1,j2)+iy(1,j3)+iy(1,j4)
          if(iy(1,jde).ne.0) goto 304
          do jp0=no(lr-1)+1,no(lr)
            if(jj_sub(1,jp0).eq.jde) jj_sub(1,jp0)=0
            if(jj_sub(2,jp0).eq.jde) jj_sub(2,jp0)=0
            if(jj_sub(3,jp0).eq.jde) jj_sub(3,jp0)=0
            if(jj_sub(4,jp0).eq.jde) jj_sub(4,jp0)=0
          enddo
          goto 21
304       if(j2.eq.0.or.iy(1,j2).eq.0) goto 31
          iy(2,jde)=iy(1,j1)
31        if(j3.eq.0.or.iy(1,j3).eq.0) goto 32
          iy(3,jde)=iy(1,j1)+iy(1,j2)
32        if(j4.eq.0.or.iy(1,j4).eq.0) goto 303
          iy(4,jde)=iy(1,jde)-iy(1,j4)
303       if(jde.eq.1) goto 21
21      continue
20    continue
      lr=norb_dz+1
      jde=jpad
          j1=jj_sub(1,jde)
          j2=jj_sub(2,jde)
          j3=jj_sub(3,jde)
          j4=jj_sub(4,jde)
          iy(1,jde)=iy(1,j1)+iy(1,j2)+iy(1,j3)+iy(1,j4)
          if(iy(1,jde).ne.0) goto 404
            do jp0=no(lr)+1,no(lr+1)
              if(jj_sub(1,jp0).eq.jde) jj_sub(1,jp0)=0
              if(jj_sub(2,jp0).eq.jde) jj_sub(2,jp0)=0
              if(jj_sub(3,jp0).eq.jde) jj_sub(3,jp0)=0
              if(jj_sub(4,jp0).eq.jde) jj_sub(4,jp0)=0
            enddo
         goto 40
404      if(j2.eq.0.or.iy(1,j2).eq.0) goto 41
         iy(2,jde)=iy(1,j1)
41       if(j3.eq.0.or.iy(1,j3).eq.0) goto 42
         iy(3,jde)=iy(1,j1)+iy(1,j2)
42       if(j4.eq.0.or.iy(1,j4).eq.0) goto 403
         iy(4,jde)=iy(1,jde)-iy(1,j4)
403      if(jde.eq.1) goto 40
40    continue

      ndim=iy(1,jpad)
!===========================================================
      jphy(jpad)=1
      ihy(1)=1
      ihy(2)=0

      ihypos=3
      do i=1,4
        j(i)=jj_sub(i,jpad)
        if(j(i).eq.0) cycle
        iw=0
        if(i.ne.1) iw=iy(i,jpad)
        jphy(j(i))=1
        ihy(ihypos)=1
        ihy(ihypos+1)=iw
        ihypos=ihypos+2
      enddo

      call mma_allocate(jpihy,max_wei,label='jpihy')
      lr=norb_dz+1
      jpsta=no(lr)+1
      jpend=jpae
      do jp=jpsta,jpend
        if(iy(1,jp).eq.0) cycle
        call ajphy(jp,in,jpihy)
        jphy(jp)=ihypos
        ihy(ihypos)=in
        do ij1=1,in
          ihypos=ihypos+1
          ihy(ihypos)=jpihy(ij1)
        enddo
        ihypos=ihypos+1
      enddo
      nohy=ihypos-1
      !write(6,'(3x,4i10)')jpad,jpae,ndim,nohy
      call mma_deallocate(jpihy)
      return
      end

      function iwalk_ad(jdbl,jext,iwa,iwd)
#include "drt_h.fh"
#include "intsort_h.fh"
      if(log_prod.eq.3) then
        ! mrpt2
        ioff=0
        if(jext.eq.1) ioff=iw_sta(jdbl,jext)
        iwup=jpad_upwei(jdbl)
        isegdown=iseg_downwei(jext)
        iwalk_ad=(iwa*iwup+iwd)*isegdown+ioff
      else
        ! mrci
        iwup=jpad_upwei(jdbl)
        isegdown=iseg_downwei(jext)
        iwalk_ad=(iwa*iwup+iwd)*isegdown+iw_sta(jdbl,jext)
      endif
      return
      end

      function iwalk_ad_mrso(jdbl,jext,iwa,iwd)
#include "drt_h.fh"
#include "intsort_h.fh"
      iwup=jpad_upwei(jdbl)
      isegdown=iseg_downwei(jext)
      iwalk_ad_mrso=(iwa*iwup+iwd)*isegdown+isub_sta(jdbl,jext)
      return
      end

      subroutine ajphy(jp,in,jpihy)
#include "drt_h.fh"
#include "pl_structure_h.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      dimension iin(0:max_node),jpihy(max_wei)

      iin(0)=0
      if(jp.eq.jpad) then
      in=1
      jpihy(1)=0
      return
      endif
      lr=kk(jp)
c     write(6,*)'  ajphy,jp,start,end',jp,no(nst-lr)+1,no(nst-lr+1)
      jpe=no(lr+1)
      iin(jpad:jpe)=0
      iin(jp)=1
      do 10 jpn=no(lr-1),jpad,-1
      iin(jpn)=iin(jj_sub(1,jpn))+iin(jj_sub(2,jpn))+iin(jj_sub(3,jpn))
     :        +iin(jj_sub(4,jpn))
10    continue
      in=iin(jpad)
      idr=0
      do 30 l=1,in
        jpihy(l)=0
        jy=l
        nn=jpad
        do 349 i=norb_dz+1,lr-1
          do 40 j=1,4
            if(jj(j,nn).eq.0) goto 40
            if(jy.gt.iin(jj_sub(j,nn))) goto 353
            idr=j
            goto 350
353         jy=jy-iin(jj_sub(j,nn))
40        continue
350       if(idr.ne.1)jpihy(l)=jpihy(l)+iy(idr,nn)
          nn=jj_sub(idr,nn)
349     continue
30    continue
      return
      end

      FUNCTION K_COE(JBL,JBR,IDDL,IDDR)
      K_COE=0
      IDL=IDDL-1
      IDR=IDDR-1
      IF(IDL.EQ.3.AND.IDR.EQ.3) K_COE=200
      IF(IDL.EQ.1.AND.IDR.EQ.1.AND.(JBR-JBL).EQ.-1) K_COE=-1
      IF(IDL.EQ.1.AND.IDR.EQ.1.AND.(JBR-JBL).EQ. 1) K_COE= 100
      IF(IDL.EQ.2.AND.IDR.EQ.2.AND.(JBR-JBL).EQ. 1) K_COE=-1
      IF(IDL.EQ.2.AND.IDR.EQ.2.AND.(JBR-JBL).EQ.-1) K_COE= 100
      IF(IDL.EQ.2.AND.IDR.EQ.1) K_COE= JBR
      IF(IDL.EQ.1.AND.IDR.EQ.2) K_COE=-JBR-2
      RETURN
      END

      subroutine copy_to_drtl()
#include "drt_h.fh"
#include "pl_structure_h.fh"
      jpadl=jpad
      jpael=jpae
      ipael=ipae
      ndiml=ndim
      nohyl=nohy
      ihyl(1:nohyl)=ihy(1:nohy)

      knode=no(norb_inn+1)
      do nod=1,knode
        jjl_sub(1:4,0:knode)=jj_sub(1:4,0:knode)
        iyl(1:4,nod)=iy(1:4,nod)
        jphyl(nod) =jphy(nod)
      enddo
      return
      end

      subroutine get_jpadty(jp,ity,jp_ms)
#include "drt_h.fh"
      if(jp.eq.1) then
        ity=1
        jp_ms=ns_sm
        return
      endif
      jpp=jp+15
      if(mod(jpp,8).eq.0) then
         ity=jpp/8-1
         jp_ms=8
      else
         ity=jpp/8
         jp_ms=mod(jpp,8)
      endif
      return
      end

      subroutine get_jpty(jpadlr,jptyl,jptyr)
      goto(1,2,3,4,5,6,7,8,9,10,
     :     11,12,13,14,15,16,17,18,19,20,
     :     21,22,23,24,25),jpadlr
1     jptyl=4
      jptyr=4
      return
2     jptyl=4
      jptyr=3
      return
3     jptyl=3
      jptyr=4
      return
4     jptyl=4
      jptyr=6
      return
5     jptyl=6
      jptyr=4
      return
6     jptyl=4
      jptyr=2
      return
7     jptyl=2
      jptyr=4
      return
8     jptyl=4
      jptyr=5
      return
9     jptyl=5
      jptyr=4
      return
10    jptyl=4
      jptyr=1
      return
11    jptyl=3
      jptyr=3
      return
12    jptyl=6
      jptyr=6
      return
13    jptyl=3
      jptyr=2
      return
14    jptyl=2
      jptyr=3
      return
15    jptyl=6
      jptyr=5
      return
16    jptyl=5
      jptyr=6
      return
17    jptyl=3
      jptyr=1
      return
18    jptyl=6
      jptyr=1
      return
19    jptyl=2
      jptyr=2
      return
20    jptyl=5
      jptyr=5
      return
21    jptyl=2
      jptyr=5
      return
22    jptyl=5
      jptyr=2
      return
23    jptyl=2
      jptyr=1
      return
24    jptyl=5
      jptyr=1
      return
25    jptyl=1
      jptyr=1
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine IniReord(NaGrp,NaSGrp,NchBlk,LunAux,wrksize)
c
c       nacitanie vsupu a inicializacia premnennych
c       a tlac primitivnej hlavicky pre Reord procesz
c
#ifdef _MOLCAS_MPP_
        use Para_Info, only: nProcs
#endif
        implicit none
#include "chcc1.fh"
#include "chcc_reord.fh"
cmp!
#include "parcc.fh"
cmp!

c
        integer NaGrp,NaSGrp,NchBlk
        integer LunAux,wrksize
cmp!
        integer nOrb(8),nOcc(8),nFro(8),nDel(8)
        integer intkey1,intkey2
        integer ndelvirt

        integer LuSpool
        character*80 LINE

#ifdef _MOLCAS_MPP_
        integer jal1
#endif
        integer NChLoc_min,NChLoc_max,NchBlk_tmp

        character*3 msg
cmp!

c setup defaults

        Call Get_iArray('nBas',nOrb,1) ! must read always nBas!!
        Call Get_iArray('nIsh',nOcc,1)
        Call Get_iArray('nFroPT',nFro,1) ! = 'nFro' in previous step
        Call Get_iArray('nDelPT',nDel,1) ! = 'nDel' in previous step
c
#ifdef _MOLCAS_MPP_
cmp     get min/max
        NChLoc_min=nc
        NChLoc_max=0
        do jal1=0,Nprocs-1
          if (NChLoc(jal1).le.NChLoc_min) NChLoc_min = NChLoc(jal1)
          if (NChLoc(jal1).ge.NChLoc_max) NChLoc_max = NChLoc(jal1)
        end do

cmp     calc reasonable starting value (200-300)
        if (NChLoc_min.ne.NChLoc_max) then
          NChBlk = int(NChLoc_min/2)
        else
          NChBlk = NChLoc_min
        end if

        if (NChBlk.ge.300) then
          NChBlk=min(200,int(NChBlk/2))
        end if

cmp     fix num of ChV blocks to be less then 100
        if (int(NChLoc_max/NChBlk).ge.100)
     & NChBlk = int(NChLoc_max/100) - 1
#else
        NChLoc_max=nc
cmp     calc reasonable starting value (200-300)
        if (nc.ge.300) then
          NChBlk=min(200,nc/2)
        else
          NChBlk=nc
        endif

        NChLoc_min=NChBlk
cmp     fix num of ChV blocks to be less then 100
        if (int(nc/NChBlk).ge.100)
     & NChBlk = int(nc/100) - 1
#endif

        nfr= nFro(1)
        no = nOcc(1)-nFro(1)
        ndelvirt = nDel(1)

        nv = nOrb(1)-nDel(1)-nOcc(1) ! nOrb defined as = to nBas, right!

        LunAux = 13
        mhkey = 1
        generkey = 1
        intkey1 = 0
        intkey2 = 0

        NaGrp = 0
        NaSGrp = 0
        W34DistKey = 1
        JoinLkey = 2 ! toto este nemam domyslene
        restkey = 0
        conv = 1.0d-6
        printkey = 1
        maxiter = 40

c
cmp!    read input file
c
      LuSpool = 17
      Call SpoolInp(LuSpool)
      Rewind(LuSpool)
 5      Read(LuSpool,'(A80)') LINE
       CALL UPCASE(LINE)
       IF( INDEX(LINE,'&CHCC') .EQ. 0 ) GOTO 5
 6     Read(LuSpool,'(A80)') LINE
       IF(LINE(1:1).EQ.'*') GOTO 6
       CALL UPCASE(LINE)
c
       IF (LINE(1:4).EQ.'TITL') THEN
       Read(LuSpool,*)

       ELSE IF (LINE(1:4).EQ.'FROZ') THEN
       Read(LuSpool,*) nfr
             if ((nfr.lt.0).or.(nfr.ge.no)) then
               write (6,*)
               write (6,*) 'Ilegal value for FROZen keyword : ',
     &                      nfr
               call abend()
             end if
             no = no + nFro(1) - nfr

       ELSE IF (LINE(1:4).EQ.'DELE') THEN
       Read(LuSpool,*) ndelvirt
             if ((ndelvirt.lt.0).or.(ndelvirt.gt.nv)) then
               write (6,*)
               write (6,*) 'Ilegal value for DELETED keyword : ',
     &                      ndelvirt
               call abend()
             end if
             nv = nv + nDel(1) - ndelvirt

       ELSE IF (LINE(1:4).EQ.'LARG') THEN
       Read(LuSpool,*) NaGrp
           if ((NaGrp.lt.0).or.(NaGrp.gt.maxGrp)) then
               write (6,*)
               write (6,*) 'Ilegal value for LARGE keyword : ',
     &                      NaGrp
               write (6,*) 'Large segmentation must be -le 32'
               call abend()
           end if

       ELSE IF (LINE(1:4).EQ.'SMAL') THEN
       Read(LuSpool,*) NaSGrp
           if ((NaSGrp.lt.0).or.(NaSGrp.gt.8)) then
               write (6,*)
               write (6,*) 'Ilegal value for SMALL keyword : ',
     &                      NaSGrp
               write (6,*) 'Small segmentation must be -le 8'
               call abend()
           end if

c          large == 0, small != 0 => quit
           if ((NaGrp.eq.0).and.(NaSGrp.ne.0)) then
               write (6,*)
               write (6,*) 'Small segmentation must be specified'
               write (6,*) 'with large segmentation, or both can'
               write (6,*) 'be left unspecified'
               call abend()
           end if

           if (NaGrp.ne.0) then
c             large != 0, small == 0 => small = 1
              if (NaSGrp.eq.0) then
                 NaSGrp = 1
              endif

c             large * small <= 64
              if ((NaGrp*NaSGrp).gt.maxSGrp) then
                write (6,*)
                write (6,*) 'Product of Large and Small segmen-'
                write (6,*) 'tation must be less or equal to 64'
                call abend()
              endif
           end if

       ELSE IF (LINE(1:4).EQ.'CHSE') THEN
       Read(LuSpool,*) NchBlk_tmp
           if ((NchBlk_tmp.lt.1).or.(NchBlk_tmp.gt.NChLoc_min)) then
               write (6,*)
               write (6,*) 'Ilegal value for CHSegment keyword  : ',
     &                      NchBlk_tmp
               write (6,*) 'Reseting to a reasonable value for    '
               write (6,*) 'this system :                         ',
     & NchBlk
           else if (int(NChLoc_max/NchBlk_tmp).ge.100) then
               write (6,*) 'Number of block of the MO Cholesky vector'
               write (6,*) 'exceeded the limit. Increasing value of  '
               write (6,*) 'the CHSEgmentation keyword to : ',
     & NchBlk
           else
              NchBlk = NchBlk_tmp
           end if

cmp!       ELSE IF (LINE(1:4).EQ.'LUNA') THEN  ... toto sa nikdy nevyuzivalo
cmp!       Read(LuSpool,*) LunAux

       ELSE IF (LINE(1:4).EQ.'MHKE') THEN
       Read(LuSpool,*) mhkey
           if ((mhkey.lt.0).or.(mhkey.gt.2)) then
              mhkey=1
              write(6,*)
              write(6,*) ' Warning!!!',
     &                   '  Matrix handling key out of range'
              write(6,*) ' parameter mhkey changed to 1'
           end if

       ELSE IF (LINE(1:4).EQ.'NOGE') THEN
            generkey = 0

       ELSE IF (LINE(1:4).EQ.'ONTH') THEN
            intkey1 = 1

       ELSE IF (LINE(1:4).EQ.'PREC') THEN
            intkey2 = 1

       ELSE IF (LINE(1:4).EQ.'NODI') THEN
            W34DistKey = 0

       ELSE IF (LINE(1:4).EQ.'JOIN') THEN
       Read(LuSpool,*) JoinLkey
            if ((JoinLkey.lt.0).or.(JoinLkey.gt.3)) then
               write (6,*)
               write (6,*) 'Ilegal value for Join keyword : ',
     &                      JoinLkey
               write (6,*) 'Use one of 0, 1, 2, 3'
               write (6,*) 'For details, see the manual ...'
               call abend()
            end if


       ELSE IF (LINE(1:4).EQ.'MAXI') THEN
       Read(LuSpool,*) maxiter
            if (maxiter.le.0) then
               write (6,*)
               write (6,*) 'Ilegal value of the MAXITER keyword: ',
     &                      maxiter
               write (6,*) 'Use integer > 0'
               call abend()
            end if

       ELSE IF (LINE(1:4).EQ.'REST') THEN
            restkey = 1
            write (6,*)
            write (6,*) 'This option is temporary disabled'
            write (6,*) 'No Restart possible (... yet).'
            call abend()

       ELSE IF (LINE(1:4).EQ.'THRE') THEN
       Read(LuSpool,*) conv

       ELSE IF (LINE(1:4).EQ.'PRIN') THEN
       Read(LuSpool,*) printkey
            if (((printkey.lt.0).or.(printkey.gt.10)).or.
     & ((printkey.gt.2).and.(printkey.lt.10))) then

               write (6,*)
               write (6,*) 'Ilegal value of the PRINT keyword: ',
     &                      printkey
               write (6,*) ' Use: 1  (Minimal) '
               write (6,*) '      2  (Minimal + Timings)'
               write (6,*) '      10 (Debug) '
               call abend()
            end if

       ELSE IF (LINE(1:4).EQ.'END ') THEN
       GOTO 7
       END IF
       GOTO 6
7      CONTINUE

       Call Close_LuSpool(LuSpool)

c! take care of the algorithm keyword
        if (intkey1.eq.intkey2) then
           if (intkey1.eq.0) then
              write (6,*)
              write (6,*) 'None of OnTheFly/PreCalculate'
              write (6,*) 'algorithm was selected. Using'
              write (6,*) 'default: PreCalculate (1)'
              intkey = 1
           else
              write (6,*)
              write (6,*) 'OnTheFly and PreCalculate keywords'
              write (6,*) 'are mutually exclusive'
              call abend()
           end if
        else
           if (intkey1.eq.1) then
               intkey = 0
           else
               intkey = 1
           end if
        end if

c2      tlac hlavicky
        write (6,*)
        write (6,*) '    Cholesky Based Closed-Shell CCSD code'
cmp!        write (6,*) ' Dedicated to the memory of Boris Jeltzin'
        write (6,*)
      write (6,*) '---------------------------------------------------'

        write (6,'(A,i9)') ' Frozen Orbitals                   : ',
     & nfr
        write (6,'(A,i9)') ' Occupied Orbitals                 : ',
     & no
        write (6,'(A,i9)') ' Virtual Orbitals                  : ',
     & nv
        write (6,'(A,i9)') ' Total number of Cholesky Vectors  : ',
     & nc

      write (6,*) '---------------------------------------------------'

        if (NaGrp.ne.0) then
          write (6,'(A,i9)') ' Large Virtual Segmentation        : ',
     & NaGrp
        else
          write (6,'(A,A9)') ' Large Virtual Segmentation        : ',
     & ' auto'
        end if

        if (NaSGrp.ne.0) then
          write (6,'(A,i9)') ' Small Virtual Segmentation        : ',
     & NaSGrp
        else
          write (6,'(A,A9)') ' Small Vectors Segmentation        : ',
     & ' auto'
        end if

        write (6,'(A,i9)') ' Cholesky Vectors Segmentation     : ',
     & NchBlk

      write (6,*) '---------------------------------------------------'

        msg = 'No'
        if (generkey.eq.1) msg = 'Yes'

        write (6,'(A,A4)') ' Generate Scratch Files?                : ',
     & msg
        write (6,'(A,i4)') ' Precalculate (1) / On-the-Fly (0) Alg. : ',
     & intkey
        write (6,'(A,i4)') ' 3 and 4-ext. MO integrals distribute?  : ',
     & W34DistKey
        write (6,'(A,i4)') ' Parallel Join of varios MO integrals   : ',
     & JoinLkey

      write (6,*) '---------------------------------------------------'

        write (6,'(A,E9.2)') ' Convergence Threshold             : ',
     & conv
        write (6,'(A,i9)') ' Maximum number of Iterations      : ',
     & maxiter

      write (6,*) '---------------------------------------------------'

        write (6,'(A,i9)') ' Lun Number for Aux. Matrixes      : ',
     & LunAux
        write (6,'(A,i9)') ' BLAS/FTN Matrix Handling          : ',
     & mhkey

        msg = 'No'
        if (restkey.eq.1) msg = 'Yes'

        write (6,'(A,A10)') ' Start from RstFil ?               : ',
     & msg
        write (6,'(A,i9)') ' Print level                       : ',
     & printkey

      write (6,*) '---------------------------------------------------'
        write (6,*)

c
        return
c Avoid unused argument warnings
        if (.false.) Call Unused_integer(wrksize)
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!***********************************************************************

subroutine MEMSTR_GAS()
! Construct pointers for saving information about strings and
! their mappings
!
! GAS version
!
!========
! Input :
!========
! Number and groups of strings defined by /GASSTR/
! Symmetry information stored in          /CSM/
! String information stored in            /STINF/
!=========
! Output
!=========
! Pointers stored in Module STRBAS
!
! Jeppe Olsen, Winter of 1994

use lucia_data, only: IGSFGP, IOCLS, ISTAC, ISTSGP, ISTSO, NACOB, NELFGP, NGAS, NGRP, NIRREP, NMXOCCLS, NOBPT, NSPGPFTP, NSTFGP, &
                      NSTSGP, NSTSO, NSTTP, NTSPGP, OCCSTR, SPGPAN, SPGPCR, STREO, STSTM, ZMAT
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IEL, IGAS, IGRP, IORB, ISTRIN, ITP, LENGTH, LSTRIN, NSTRIN

! Start of string information

! Offsets for occupation and reorder array of strings

do IGRP=1,NGRP
  NSTRIN = NSTFGP(IGRP)
  LSTRIN = NSTRIN*NELFGP(IGRP)
  call mma_allocate(OCCSTR(IGRP)%A,LSTRIN,Label='OCCSTR()')
  call mma_allocate(STREO(IGRP)%A,NSTRIN,Label='STREO()')
end do

! Number of strings per symmetry and offset for strings of given sym
! for groups

call mma_allocate(NSTSGP,NIRREP*NGRP,Label='NSTSGP')
call mma_allocate(ISTSGP,NIRREP*NGRP,Label='ISTSGP')

! Number of strings per symmetry and offset for strings of given sym
! for types

do ITP=1,NSTTP
  call mma_allocate(NSTSO(ITP)%A,NSPGPFTP(ITP)*NIRREP,Label='NSTSO(ITP)')
  call mma_allocate(ISTSO(ITP)%A,NSPGPFTP(ITP)*NIRREP,Label='ISTSO(ITP)')
end do

! Lexical addressing of arrays : use array indices for complete active space

! Not in use so
do IGRP=1,NGRP
  call mma_allocate(Zmat(IGRP)%A,NACOB*NELFGP(IGRP),Label='ZMat()')
end do

! Mappings between different groups

do IGRP=1,NGRP
  IEL = NELFGP(IGRP)
  IGAS = IGSFGP(IGRP)
  IORB = NOBPT(IGAS)
  ISTRIN = NSTFGP(IGRP)
  ! If creation is involve : Use full orbital notation
  ! If only annihilation is involved, compact form will be used
  LENGTH = 1
  if (ISTAC(IGRP,2) /= 0) then
    LENGTH = IORB*ISTRIN
  else if (ISTAC(IGRP,1) /= 0) then
    ! Only annihilation map so
    LENGTH = IEL*ISTRIN
  end if
  call mma_allocate(STSTM(IGRP,1)%A,LENGTH,LABEL='STSTM(IGRP,1)')
  call mma_allocate(STSTM(IGRP,2)%A,LENGTH,LABEL='STSTM(IGRP,2)')
end do

! Occupation classes

call mma_allocate(IOCLS,NMXOCCLS*NGAS,Label='IOCLS')
! Annihilation/Creation map of supergroup types
call mma_allocate(SPGPAN,NTSPGP*NGAS,Label='SPGPAN')
call mma_allocate(SPGPCR,NTSPGP*NGAS,Label='SPGPCR')

end subroutine MEMSTR_GAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Luis Serrano-Andres                              *
!***********************************************************************

subroutine SUPSCH(SMAT,CMOO,CMON)
! Program RASSCF
!
! Objective: To check the order of the input of natural orbitals
!            to obtain the right labels for the Supersymmetry matrix.
!
! Called from ortho, neworb, fckpt2, and natorb.
!
! Luis Serrano-Andres
! University of Lund, Sweden, 1997
! **** Molcas-4 *** Release 97 04 01 **********

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use rasscf_global, only: FDIAG, iSupSM, Iter, ixsym
use PrintLevel, only: DEBUG
use output_ras, only: IPRLOC
use general_data, only: NBAS, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: SMAT(*)
real(kind=wp), intent(in) :: CMOO(*), CMON(*)
integer(kind=iwp) :: i_Component, i_Opt, i_RC, i_SymLbl, iGroup, iLabel, iOrb, iOrder, iPrLev, iSafe, iSym, jOrb, kCof, kGroup, &
                     kOrb, nBs, nnOrb, nOGr1, nOGr2, nOrb_Tot, nOrbMX, pSij
real(kind=wp) :: DUM(1), OldOvlp, Ovlp1, Ovlp2, xOvlp
character(len=8) :: Label
integer(kind=iwp), allocatable :: IxSym2(:)
real(kind=wp), allocatable :: Temp1(:), Temp2(:)
#include "warnings.h"

! Local print level (if any)
IPRLEV = IPRLOC(4)
if (IPRLEV >= DEBUG) write(u6,*) ' Entering SUPSCH_INNER'

nOrbMX = maxval(nBas(1:nSym))
nOrb_tot = sum(nBas(1:nSym))
call mma_allocate(Temp1,nOrbMX*nOrbMX,Label='Temp1')
call mma_allocate(Temp2,nOrbMX*nOrbMX,Label='Temp2')
call mma_allocate(IxSym2,nOrb_tot,Label='IxSym2')

! Read overlap matrix SMAT:

i_Rc = 0
i_Opt = ibset(ibset(0,sNoOri),sNoNuc)
i_Component = 1
i_SymLbl = 1
Label = 'Mltpl  0'
call RdOne(i_Rc,i_Opt,Label,i_Component,Smat,i_SymLbl)
if (i_Rc /= 0) then
  write(u6,*)
  write(u6,*) ' ********************* ERROR **********************'
  write(u6,*) ' SUPSCH: Failed to read overlap from ONEINT.       '
  write(u6,*) ' RASSCF is using overlaps to compare old and new   '
  write(u6,*) ' orbitals, but could not read overlaps from ONEINT.'
  write(u6,*) ' Something is wrong with the file, or possibly with'
  write(u6,*) ' the program. Please check.                        '
  write(u6,*) ' **************************************************'
  call Quit(_RC_IO_ERROR_READ_)
end if

! Check order of the orbitals for supersymmetry option

if ((ISupsm == 1) .and. (Iter >= 1)) then

  if (IPRLEV >= DEBUG) then
    call PRIMO_RASSCF('Testing old orb for supersymmetry',FDIAG,DUM,CMOO)
    call PRIMO_RASSCF('Testing new orb for supersymmetry',FDIAG,DUM,CMON)
  end if

  kOrb = 0
  kCof = 0
  pSij = 0
  do iOrb=1,nOrb_tot
    IxSym2(iOrb) = 0
  end do
  do iSym=1,nSym
    iSafe = 0
    nBs = nBas(iSym)
    if (nBs <= 0) cycle

    ! Computing orbital overlaping Sum(p,q) C1kp* C2lq Spq

    call Square(SMat(pSij+1),Temp1,1,nBs,nBs)
    call DGEMM_('N','N',nBs,nBs,nBs,One,Temp1,nBs,CMON(kCof+1),nBs,Zero,Temp2,nBs)
    call DGEMM_('T','N',nBs,nBs,nBs,One,CMOO(kCof+1),nBs,Temp2,nBs,Zero,Temp1,nBs)

    ! Checking the maximum overlap between the orbitals
    ! and building the new supersymmetry matrix

    nnOrb = 1
    do iOrb=1,nBs
      iLabel = IxSym(kOrb+iOrb)
      iOrder = 1
      xOvlp = Zero
      do jOrb=0,nBs-2
        Ovlp1 = abs(Temp1(nnOrb+(jOrb*nBs)))
        Ovlp2 = abs(Temp1(nnOrb+((jOrb+1)*nBs)))
        OldOvlp = xOvlp
        xOvlp = max(Ovlp1,Ovlp2,xOvlp)
        if (jOrb == 0) then
          if (Ovlp1 < Ovlp2) iOrder = 2
        else
          if (xOvlp /= OldOvlp) iOrder = jOrb+2
        end if
      end do
      IxSym2(kOrb+iOrder) = iLabel
      nnOrb = nnOrb+1
    end do

    ! Number of orbital groups on the symmetry

    kGroup = 0
    do iOrb=1,nBs-1
      kGroup = max(IxSym(kOrb+iOrb),IxSym(kOrb+iOrb+1),kGroup)
    end do
    do iGroup=0,kGroup
      nOGr1 = 0
      nOGr2 = 0
      do iOrb=1,nBs
        if (IxSym(kOrb+iOrb) == iGroup) nOGr1 = nOGr1+1
        if (IxSym2(kOrb+iOrb) == iGroup) nOGr2 = nOGr2+1
      end do

      ! Checking if we have the same number of orbitals per group

      if ((nOGr2 /= nOGr1) .and. (iGroup /= 0)) then
        iSafe = 1
        call WarningMessage(1,'Supersymmetry may have failed.')
        write(u6,*) ' Check orbital order or try cleaning orbitals.'
      end if
    end do

    ! New matrix replaces the old one

    if (iSafe == 0) then
      do iOrb=1,nBs
        IxSym(kOrb+iOrb) = IxSym2(kOrb+iOrb)
      end do
    end if
    kCof = kCof+(nBs*nBs)
    pSij = pSij+nTri_Elem(nBs)
    kOrb = kOrb+nBs
  end do
end if

call mma_deallocate(Temp1)
call mma_deallocate(Temp2)
call mma_deallocate(IxSym2)

end subroutine SUPSCH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2006, Markus Reiher                               *
*               2004, Alexander Wolf                                   *
************************************************************************
      subroutine get_dkhstring (dkhorder,xorder,paramtype,dkhscfflg,
     *             ordercounter,opcounter,operleng,oporder,evenodd,
     *             doperators,operators,xordercounter,xopcounter,
     *             xoperleng,xoporder,xevenodd,xdoperators,xoperators,
     *             wordercounter,wopscounter,wopsleng,woporder,eowops,
     *             dwops,wops,dkhzerothrsh)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  M. Reiher and A. Wolf  (Univ. Jena)
c
c   version:  2.0.3
c
c   last modified: 19.10.2006 (MR, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,xorder
      character*(3) paramtype
      logical dkhscfflg
c
      integer ordercounter(0:maxorder),opcounter,
     *        operleng(maxoperators),oporder(maxoperators,3),
     *        Evenodd(Maxoperators),
     *        xordercounter(0:maxorder),xopcounter,
     *        xoperleng(maxoperators),xoporder(maxoperators),
     *        xevenodd(maxoperators)
      REAL*8 doperators(maxoperators),
     *                 xdoperators(maxoperators)
#if defined(_MOLCAS_) || defined(MOLPRO)
#include "WrkSpc.fh"
      character operators(*),xoperators(*)
      REAL*8 dwops(maxuops)
      character*(maxlength) wops(maxuops)
      integer wordercounter(maxorder),wopscounter,wopsleng(maxuops),
     *        woporder(maxuops,3),eowops(maxuops),
     *        oddcounter
      Integer dodd, odd, oddleng, oddorder, eoodd
      Integer uops,uopsleng,uoporder,eouops,duops
      integer ucounter, puop
#else
      character*(maxlength) operators(maxoperators),
     *                        xoperators(maxoperators)
      REAL*8 dwops(maxuops),dodd(maxuops)
      character*(maxlength) wops(maxuops),odd(maxuops)
      integer wordercounter(maxorder),wopscounter,wopsleng(maxuops),
     *        woporder(maxuops,3),eowops(maxuops),
     *        oddcounter,oddleng(maxuops),oddorder(maxuops,3),
     *        eoodd(maxuops)
      integer ucounter,uopsleng(maxuops),uoporder(maxuops),
     *        eouops(maxuops),puop(maxuops)
      REAL*8 duops(maxuops)
      character*(maxlength) uops(maxuops)
#endif
c
      REAL*8 ducoeffs(maxorder)
c
      REAL*8 dkhzerothrsh(0:maxorder)
      integer i,uniorder
      intrinsic DBLE,INT
c
CMR      write (stdout,1017)
CMR1017  format (5X,'|',70('-'),'|',/5X,'|',6X,'STEP 1: Symbolic ',
CMR     *        'high-level evaluation of DKH Hamiltonians',
CMR     *        6X,'|',/5X,'|',70('-'),'|')
c
      Call GetMem('odd','Allo','Char',odd,maxuops*maxlength)
      Call GetMem('oddleng','Allo','Inte',oddleng,maxuops)
      Call GetMem('oddorder','Allo','Inte',oddorder,maxuops*3)
      Call GetMem('eoodd','Allo','Inte',eoodd,maxuops)
      Call GetMem('dodd','Allo','Real',dodd,maxuops)
      Call GetMem('uops','Allo','Char',uops,maxuops*maxlength)
      Call GetMem('uopsleng','Allo','Inte',uopsleng,maxuops)
      Call GetMem('uoporder','Allo','Inte',uoporder,maxuops)
      Call GetMem('eouops','Allo','Inte',eouops,maxuops)
      Call GetMem('duops','Allo','Real',duops,maxuops)
      Call GetMem('puop','Allo','Inte',puop,maxuops)

      call initialize1 (dkhorder,xorder,paramtype,dkhscfflg,
     *         ordercounter,opcounter,operleng,oporder,evenodd,
     *         doperators,operators,xordercounter,xopcounter,xoperleng,
     *         xoporder,xevenodd,xdoperators,xoperators,wordercounter,
     *         wopscounter,wopsleng,woporder,eowops,dwops,wops,
     *         oddcounter,iWork(oddleng),iWork(oddorder),iWork(eoodd),
     &         Work(dodd),cWork(odd),ducoeffs,
     *         dkhzerothrsh)
      if (dkhscfflg) then
        uniorder = INT(DBLE(dkhorder)/2.0d0)
      else
        uniorder = max(INT(DBLE(dkhorder)/2.0d0),xorder)
      endif
c
      do 10 i=1,uniorder
c
CMR        if (i.le.9) then
CMR          write (stdout,1021) i
CMR1021      format (/2X,'Start unitary transformation U_',I1,':'/2X,
CMR     *            33('-'))
CMR        endif
CMR        if (i.ge.10) then
CMR          write (stdout,1022) i
CMR1022      format (/2X,'Start unitary transformation U_',I2,':'/2X,
CMR     *            34('-'))
CMR        endif
        call build_U (i,uniorder,dkhorder,xorder,dkhscfflg,ucounter,
     *             iwork(uopsleng),iWork(uoporder),iWork(eouops),
     &             Work(duops),iWork(puop),cWork(uops),opcounter,
     *             operleng,oporder,evenodd,doperators,operators,
     *             wordercounter,wopscounter,wopsleng,woporder,eowops,
     *             dwops,wops,oddcounter,iWork(oddleng),iWork(oddorder),
     &             iWork(eoodd),Work(dodd),
     *             cWork(odd),ducoeffs)
        call U_operators (i,dkhorder,xorder,dkhscfflg,
     *               ordercounter,opcounter,operleng,oporder,evenodd,
     *               doperators,operators,xordercounter,xopcounter,
     *               xoperleng,xoporder,xevenodd,xdoperators,xoperators,
     *               ucounter,iwork(uopsleng),iWork(uoporder),
     &               iWork(eouops),Work(duops),cWork(uops))
        call operators_U (i,uniorder,dkhorder,xorder,dkhscfflg,
     *               ordercounter,opcounter,operleng,oporder,evenodd,
     *               doperators,operators,xordercounter,xopcounter,
     *               xoperleng,xoporder,xevenodd,xdoperators,xoperators,
     *               ucounter,iwork(uopsleng),iWork(uoporder),
     &               iWork(eouops),iWork(puop),Work(duops),cWork(uops))
        call simplify1 (i,uniorder,dkhorder,xorder,dkhscfflg,
     *               ordercounter,opcounter,operleng,oporder,evenodd,
     *               doperators,operators,xordercounter,xopcounter,
     *               xoperleng,xoporder,xevenodd,xdoperators,xoperators)
        call simplify2 (i,uniorder,dkhorder,ordercounter,opcounter,
     *               operleng,oporder,evenodd,doperators,operators,
     *               wordercounter,wopsleng,woporder,eowops,dwops,wops,
     *               oddcounter,iWork(oddleng),iWork(oddorder),
     &               iWork(eoodd),Work(dodd),cWork(odd))
        call simplify3 (i,uniorder,dkhorder,xorder,dkhscfflg,
     *               ordercounter,opcounter,operleng,oporder,evenodd,
     *               doperators,operators,xordercounter,xopcounter,
     *               xoperleng,xoporder,xevenodd,xdoperators,xoperators,
     *               wordercounter,wopsleng,woporder,eowops,dwops,wops,
     *               dkhzerothrsh)
c
  10  continue
      if (dbgflg.ge.1) then
c
        if (uniorder.le.8) then
          write (dbgunit,1029) uniorder+1,uniorder,uniorder
1029      format (/2X,'Terms of Hamiltonian H',I1,' = [U',I1,' * ',
     *          '(operators) * U',I1,'^t]:',
     *          /2X,52('-'))
        endif
        if (uniorder.eq.9) then
          write (dbgunit,1030) uniorder+1,uniorder,uniorder
1030      format (/2X,'Terms of Hamiltonian H',I2,' = [U',I1,' * ',
     *          '(operators) * U',I1,'^t]:',
     *          /2X,53('-'))
        endif
        if (uniorder.ge.10) then
          write (dbgunit,1031) uniorder+1,uniorder,uniorder
1031      format (/2X,'Terms of Hamiltonian H',I2,' = [U',I2,' * ',
     *          '(operators) * U',I2,'^t]:',
     *          /2X,55('-'))
        endif
        call output3 (dbgunit,opcounter,operleng,
     *                oporder,evenodd,doperators,operators)
c
        if (.not.dkhscfflg) then
          if (uniorder.le.8) then
            write (dbgunit,1033) uniorder+1,uniorder,uniorder
1033        format (/2X,'Terms of property X',I1,' = [U',I1,' * ',
     *              '(xoperators) * U',I1,'^t]:',/2X,50('-'))
          endif
          if (uniorder.eq.9) then
            write (dbgunit,1034) uniorder+1,uniorder,uniorder
1034        format (/2X,'Terms of property X',I2,' = [U',I1,' * ',
     *              '(xoperators) * U',I1,'^t]:',/2X,51('-'))
          endif
          if (uniorder.ge.10) then
            write (dbgunit,1035) uniorder+1,uniorder,uniorder
1035        format (/2X,'Terms of property X',I2,' = [U',I2,' * ',
     *             '(operators) * U',I2,'^t]:',/2X,53('-'))
          endif
          call output3b (dbgunit,xopcounter,xoperleng,xoporder,
     *                   xevenodd,xdoperators,xoperators)
        endif
c
        write (dbgunit,1043) paramtype
1043    format (//2X,'Number of high-level terms of DKH Hamiltonian ',
     *        'and property after step 1 (get_dkhstring):',2X,A3)
        call distribution (dbgunit,dkhorder,xorder,dkhscfflg,
     *              ordercounter,opcounter,operleng,oporder,evenodd,
     *              doperators,operators,xordercounter,xopcounter,
     *              xoperleng,xoporder,xevenodd,xdoperators,xoperators)
        write (dbgunit,1051)
1051    format (/2X,'Subroutine get_dkhstring (step1) has now been ',
     *          'completed.',//2X,145('*'))
c
      endif
c
      Call GetMem('puop','Free','Inte',puop,maxuops)
      Call GetMem('duops','Free','Real',duops,maxuops)
      Call GetMem('eouops','Free','Inte',eouops,maxuops)
      Call GetMem('uoporder','Free','Inte',uoporder,maxuops)
      Call GetMem('uopsleng','Free','Inte',uopsleng,maxuops)
      Call GetMem('uops','Free','Char',uops,maxuops*maxlength)
      call getmem('dodd','Free','Real',dodd,maxuops)
      call getmem('eoodd','Free','Inte',eoodd,maxuops)
      call getmem('oddorder','Free','Inte',oddorder,maxuops*3)
      call getmem('oddleng','Free','Inte',oddleng,maxuops)
      call getmem('odd','Free','Char',odd,maxuops)
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine PRWF_CPF(ICASE,JSY,INDX,C)

use cpf_global, only: CTRSH, ILIM, IRC, IREF0, ISDCI, JSC, LN, LSYM, NCONF, NSM, NSYS, NVIRT, SQ2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ICASE(*), INDX(*), JSY(*)
real(kind=wp), intent(inout) :: C(*)
integer(kind=iwp) :: I, II, II1, IIN, IJ, ILSYM(57), IOC(57), IORB(57), ISP(57), IX1, J, J1, J2, JCONF, JJ, JMIN, JOJ, JVIR, NA, &
                     NB, NSI, NSJ
real(kind=wp) :: CI, CNRM, THRC
integer(kind=iwp), external :: ICUNP, JSUNP
real(kind=wp), external :: DNRM2_

NA = 0 ! dummy initialized
NB = 0 ! dummy initialized
NCONF = JSC(ILIM)
if (ISDCI == 1) then
  CNRM = DNRM2_(NCONF,C,1)
  C(1:NCONF) = C(1:NCONF)/CNRM
end if
JCONF = JSC(1)
THRC = CTRSH
write(u6,5) THRC
if (ISDCI == 0) write(u6,6)

do J=1,LN
  IORB(J+2) = J
  ILSYM(J+2) = NSM(J)
end do

do I=1,NCONF
  JJ = I
  IJ = I
  if (I == IREF0) then
    write(u6,105) I,C(I),'REFERENCE'
  else
    CI = C(I)
    if (abs(CI) < THRC) cycle
    if (I <= JCONF) then
      write(u6,105) I,CI,'VALANCE'
    else
      if (I <= JSC(2)) then
        JMIN = IRC(1)+1
        write(u6,105) I,CI,'DOUBLET'
      else if (I <= JSC(3)) then
        JMIN = IRC(2)+1
      else
        JMIN = IRC(3)+1
      end if
      IX1 = IRC(ILIM)
      do J=JMIN,IX1
        JJ = J-1
        if (INDX(J) >= IJ) exit
      end do
    end if
  end if
  NSJ = MUL(JSUNP(JSY,JJ),LSYM)
  JVIR = I-INDX(JJ)
  if (I > JCONF) JVIR = IJ-INDX(JJ)
  II1 = (JJ-1)*LN
  do II=1,LN
    II1 = II1+1
    ISP(II+2) = ICUNP(ICASE,II1)
    JOJ = ISP(II+2)
    if (JOJ > 1) JOJ = JOJ-1
    IOC(II+2) = JOJ
  end do
  if (JJ <= IRC(1)) then
    IORB(1) = 0
    IOC(1) = 0
    ISP(1) = 0
    ILSYM(1) = 0
    IORB(2) = 0
    IOC(2) = 0
    ISP(2) = 0
    ILSYM(2) = 0
  else if (JJ <= IRC(2)) then
    IORB(2) = JVIR+NSYS(NSJ)+LN
    IOC(2) = 1
    ISP(2) = 1
    ILSYM(2) = NSJ
    IORB(1) = 0
    IOC(1) = 0
    ISP(1) = 0
    ILSYM(1) = 0
  else
    IIN = 0
    outer: do II=1,NVIRT
      NA = II
      NSI = MUL(NSJ,NSM(LN+II))
      J1 = NSYS(NSI)+1
      J2 = NSYS(NSI+1)
      if (J2 > II) J2 = II
      do J=J1,J2
        NB = J
        IIN = IIN+1
        if (IIN == JVIR) exit outer
      end do
    end do outer
    IORB(1) = LN+NB
    IOC(1) = 1
    ISP(1) = 1
    ILSYM(1) = NSM(IORB(1))
    if (NA == NB) then
      IORB(2) = IORB(1)
      IOC(2) = 2
      ISP(2) = 3
      ILSYM(2) = NSM(IORB(2))
      IORB(1) = 0
      IOC(1) = 0
      ISP(1) = 0
      ILSYM(1) = 0
      CI = CI/SQ2
      if (abs(CI) < THRC) cycle
    else
      IORB(2) = LN+NA
      IOC(2) = 1
      ISP(2) = 2
      ILSYM(2) = NSM(IORB(2))
    end if
    if (JJ <= IRC(3)) write(u6,105) I,CI,'TRIPLET'
    if (JJ > IRC(3)) write(u6,105) I,CI,'SINGLET'
  end if
  write(u6,*)
  if (LN+2 <= 36) then
    write(u6,120) 'ORBITALS     ',(IORB(J),J=1,LN+2)
    write(u6,120) 'OCCUPATION   ',(IOC(J),J=1,LN+2)
    write(u6,120) 'SPIN-COUPLING',(ISP(J),J=1,LN+2)
    write(u6,120) 'SYMMETRY     ',(ILSYM(J),J=1,LN+2)
  else
    write(u6,121) 'ORBITALS     ',(IORB(J),J=1,LN+2)
    write(u6,121) 'OCCUPATION   ',(IOC(J),J=1,LN+2)
    write(u6,121) 'SPIN-COUPLING',(ISP(J),J=1,LN+2)
    write(u6,121) 'SYMMETRY     ',(ILSYM(J),J=1,LN+2)
  end if
end do

return

5 format(//6X,'PRINTOUT OF CI-COEFFICIENTS LARGER THAN',F10.2,/)
6 format(/6X,'WAVE FUNCTION NOT NORMALIZED',/)
105 format(/6X,'CONFIGURATION',I7,3X,'COEFFICIENT',F10.6,3X,A)
120 format(6X,A,36I3)
121 format(6X,A,55I2)

end subroutine PRWF_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Compute_M(ZA,nAtoms,RA,Z_Tot,T,M)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 ZA(nAtoms), RA(3,nAtoms), T(3), M(3,3)
*                                                                      *
************************************************************************
*                                                                      *
*---- Form the nuclear charge moment tensor
*
      Call FZero(M,9)
      Do iAtom = 1, nAtoms
         RTx=RA(1,iAtom)-T(1)
         RTy=RA(2,iAtom)-T(2)
         RTz=RA(3,iAtom)-T(3)
         M(1,1) = M(1,1) + ZA(iAtom) * (RTy**2+RTz**2)
         M(2,2) = M(2,2) + ZA(iAtom) * (RTx**2+RTz**2)
         M(3,3) = M(3,3) + ZA(iAtom) * (RTx**2+RTy**2)
*
         M(1,2) = M(1,2) + ZA(iAtom) * (    -RTx*RTy)
         M(1,3) = M(1,3) + ZA(iAtom) * (    -RTx*RTz)
         M(2,1) = M(2,1) + ZA(iAtom) * (    -RTy*RTx)

         M(2,3) = M(2,3) + ZA(iAtom) * (    -RTy*RTz)
         M(3,1) = M(3,1) + ZA(iAtom) * (    -RTz*RTx)
         M(3,2) = M(3,2) + ZA(iAtom) * (    -RTz*RTy)
      End Do
*
*     Remove noise
*
      Do i = 1, 3
         Do j = 1, 3
            If (abs(M(i,j)).lt.1.0D-14) M(i,j)=Zero
         End Do
      End Do
C     Call RecPrt('Compute_M: M',' ',M,3,3)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(Z_Tot)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine Status(kIter,Energy,rGrad,
     &                  Ex,nLines,delE,HUpMet,
     &                  Step_Trunc,Print_Status)
************************************************************************
*                                                                      *
* Object:                                                              *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             May '91                                                  *
************************************************************************
      use Slapaf_Parameters, only: UpMeth, iNeg, StpLbl, GrdLbl,
     &                             StpMax, GrdMax
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
      Character HUpMet*8, Step_Trunc*1
      Character*8 lNeg
      Logical Print_Status
      Character(LEN=128), Allocatable:: Lines(:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      Subroutine Put_cArray(Label,Data,nData)
      Character*(*) Label
      Integer       nData
      Character*(*) Data
      End Subroutine Put_cArray
      End Interface
*                                                                      *
************************************************************************
*                                                                      *

      Lu=6
      iRout = 52
      iPrint = nPrint(iRout)
*
      Call mma_allocate(Lines,[-1,nLines],Label='Lines')
*
*     Pick up previous energy
*
      If (kIter.eq.1) Then
         Lines(:)=' '
         iter=1
         Write (Lines(-1),'(A)')
     &    '                       Energy '//
     &    '    Grad      Grad          '//
     &    '    Step                 Estimated   Geom'//
     &    '       Hessian'
         Write (Lines(0),'(A)')
     &    'Iter      Energy       Change '//
     &    '    Norm      Max    Element '//
     &    '   Max     Element     Final Energy Update'//
     &    ' Update   Index'
      Else
         Call Get_cArray('Slapaf Info 3',Lines,(nLines+2)*128)
*--------Find first blank line
         iter = kIter
      End If
*
      If (iter.gt.nLines) Then
         Call WarningMessage(2,'Status: iter.gt.nLines')
         Write (Lu,*) 'iter,nLines=',iter,nLines
         Call abend()
      Else If (iter.lt.1) Then
         Call WarningMessage(2,'Status: iter.lt.1')
         Call abend()
      End If
*
      Write(lNeg,'(I3)') iNeg(1)
      If (iNeg(2).ne.iNeg(1)) Then
         If (iNeg(2).gt.99) Then
            Write(lNeg(4:8),'("(",I3,")")') iNeg(2)
         Else If (iNeg(2).gt.9) Then
            Write(lNeg(4:7),'("(",I2,")")') iNeg(2)
         Else
            Write(lNeg(4:6),'("(",I1,")")') iNeg(2)
         End If
      End If
      Write (Lines(iter),
     &    '(I3,F16.8,F12.8,2(F9.6,1X),A8,F9.6,A1,1X,A8,F16.8,1X,'//
     &    'A,1X,A,1X,A)')
     &    iter,Energy,delE,rGrad,GrdMax,GrdLbl,StpMax,Step_Trunc,
     &    StpLbl,Ex,UpMeth,HUpMet,lNeg
*                                                                      *
************************************************************************
*                                                                      *
      Lu_file=isfreeunit(8)
*
*     Turn off updating the structure file during numerical
*     integrations steps.
*
      nvv = 1
      If (Print_Status) nvv=2
      Do ivv=1,nvv
         If (ivv.eq.1) then
           Lu_out=Lu
         Else
            Call Molcas_Open(Lu_File,'STRUCTURE')
           Lu_out=Lu_file
         End If
*
         If (ivv.eq.2.or.iPrint.ge.5) Then
            Write (Lu_out,*)
            Write (Lu_out,'(A)') '***********************'//
     &         '*******************************************************'
     &         //'****************************************'
            Write (Lu_out,'(A)') '*                              '//
     &         '      Energy Statistics for Geometry Optimization      '
     &                    //'                               *'
            Write (Lu_out,'(A)') '***********************'//
     &         '*******************************************************'
     &         //'****************************************'
            Do i = -1, iter
               Write (Lu_out,'(A118)') Lines(i)
            End Do
            Write (Lu_out,*)
         End If
         If (ivv.eq.2) Close(Lu_file)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call Put_cArray('Slapaf Info 3',Lines(-1),(nLines+2)*128)
      Call mma_deallocate(Lines)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkV_K22(W1,W2,dim_)
! this routine does
! W1(p) = -W2(p)
!
! N.B. toto je iba plytke copy s opacnym znamienkom,
!      da sa aj s blasmi spravit
! N.B. Kvajt odflaknute

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dim_
real(kind=wp), intent(out) :: W1(dim_)
real(kind=wp), intent(in) :: W2(dim_)

W1(:) = -W2(:)

return

end subroutine MkV_K22

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine InsL (Ll,Lg,ncLoc,nc,ncOff,dim1)
c
c        this routine do:
c        insert Llocal(ml,dim1) into Lglobal(m,dim1)
c        on a corresponding place
c
        implicit none
        integer ncLoc,nc,ncOff,dim1
        real*8 Ll(1:ncLoc,1:dim1)
        real*8 Lg(1:nc,1:dim1)
c
c        help variables
        integer m,p
c
        do p=1,dim1
          do m=1,ncLoc
            Lg(ncOff+m,p)=Ll(m,p)
          end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRPDET(IOPEN,ND,IDET)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IOPEN, ND, IDET(IOPEN,ND)
integer(kind=iwp) :: I, J, N
character(len=24) :: FRMT
character, parameter :: SPNSMB(0:1) = ['b','a']

if ((IOPEN < 0) .or. (ND < 0)) then
  call WarningMessage(2,'Program bug: Erroneous call to PRPDET.')
  write(u6,*) 'PRPDET error: Wrong arguments.'
  write(u6,*) 'PRPDET: IOPEN=',IOPEN
  write(u6,*) 'PRPDET: ND =',ND
  call ABEND()
end if
if ((IOPEN == 0) .or. (ND == 0)) then
  call WarningMessage(1,'Program bug? Strange call to PRPDET.')
  write(u6,*) 'PRPDET warning: Strange arguments.'
  write(u6,*) 'PRPDET: IOPEN=',IOPEN
  write(u6,*) 'PRPDET: ND =',ND
else
  N = 80/(7+IOPEN)
  write(FRMT,'(A1,I2,A,I2,A4)') '(',N,'(1X,I5,1X,',IOPEN,'A1))'
  write(u6,FRMT) (I,(SPNSMB(IDET(J,I)),J=1,IOPEN),I=1,ND)
end if

end subroutine PRPDET

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GETINC_ABS(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,IXCHNG,INTLST,ICOUL)
! Obtain integrals
! ICOUL = 0 :      XINT(IK,JL) = (IJ!KL) for IXCHNG = 0
!                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
! ICOUL = 1 :      XINT(IJ,KL) = (IJ!KL)
!
! Version for integrals stored in INTLST

use MCLR_Data, only: IBTSOB, NACOB, NTSOB
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: XINT(*)
integer(kind=iwp), intent(in) :: ITP, ISM, JTP, JSM, KTP, KSM, LTP, LSM, IXCHNG, ICOUL
real(kind=wp), intent(in) :: Intlst(*)
integer(kind=iwp) :: iInt, iOff, iOrb, jBas, jInt, jOff, jOrb, kBas, kOff, kOrb, lBas, lOff, lOrb

iOrb = NTSOB(ITP,ISM)
jOrb = NTSOB(JTP,JSM)
kOrb = NTSOB(KTP,KSM)
lOrb = NTSOB(LTP,LSM)
iOff = IBTSOB(ITP,ISM)
jOff = IBTSOB(JTP,JSM)
kOff = IBTSOB(KTP,KSM)
lOff = IBTSOB(LTP,LSM)

! Collect Coulomb terms

if (ICOUL == 0) then
  iInt = 1
  do lBas=lOff,lOff+lOrb-1
    do jBas=jOff,jOff+jOrb-1
      do kBas=kOff,kOff+kOrb-1
        jInt = (lBas-1)*nACOB**3+(kBas-1)*nACOB**2+(jBas-1)*nACOB
        Xint(iInt+iOff:iInt+iOff+iOrb-1) = Intlst(jInt+iOff:jInt+iOff+iOrb-1)
        iInt = iInt+iOrb
      end do
    end do
  end do

  ! Collect Exchange terms

  if (IXCHNG /= 0) then
    iInt = 1
    do lBas=lOff,lOff+lOrb-1
      do jBas=jOff,jOff+jOrb-1
        do kBas=kOff,kOff+kOrb-1
          jInt = (jBas-1)*nACOB**3+(kBas-1)*nACOB**2+(lBas-1)*nACOB
          XInt(iInt+iOff:iInt+iOff+iOrb-1) = XInt(iInt+iOff:iInt+iOff+iOrb-1)-Intlst(jInt+iOff:jInt+iOff+iOrb-1)
          iInt = iInt+iOrb
        end do
      end do
    end do
  end if
else
  iInt = 0
  do lBas=lOff,lOff+lOrb-1
    do kBas=kOff,kOff+kOrb-1
      do jBas=jOff,jOff+jOrb-1
        jInt = (lBas-1)*nACOB**3+(kBas-1)*nACOB**2+(jBas-1)*nACOB
        Xint(iInt+iOff:iInt+iOff+iOrb-1) = Intlst(jInt+iOff:jInt+iOff+iOrb-1)
        iInt = iInt+iOrb
      end do
    end do
  end do
end if

end subroutine GETINC_ABS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKTDZZ(CMOA,CMOB,TDMAB,TDMZZ,iRC)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TDMAB(NTDMAB),TDMZZ(NTDMZZ)
      DIMENSION CMOA(NCMO),CMOB(NCMO)
      DIMENSION ISTCMO(8)
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "symmul.fh"
#include "rassi.fh"
      If (iRC.eq.0) Then
         TDMZZ(:)=0.0D0
         Return
      End If
C ISTCMO()=START INDEX FOR CMO ARRAY SYMMETRY BLOCKS.
      ISY12=MUL(LSYM1,LSYM2)
C NSCR=SIZE NEEDED FOR TEMPORARY MATRIX PRODUCT.
      NSCR=0
      IST=1
      DO 10 ISY1=1,NSYM
        ISTCMO(ISY1)=IST
        NO1=NOSH(ISY1)
        IST=IST+NO1*NBASF(ISY1)
        ISY2=MUL(ISY1,ISY12)
        NSCR=MAX(NSCR,NO1*NBASF(ISY2))
10    CONTINUE
      CALL GETMEM('SCR   ','ALLO','REAL',LSCR,NSCR)
      ISTTA=1
      ISTCA=1
      ISTTZ=1
      DO 20 ISY1=1,NSYM
        ISY2=MUL(ISY1,ISY12)
        ISTCB=ISTCMO(ISY2)
        NO1=NOSH(ISY1)
        NO2=NOSH(ISY2)
        NB1=NBASF(ISY1)
        NB2=NBASF(ISY2)
        IF(NB1*NB2.EQ.0) GOTO 15
        IF(NO1*NO2.EQ.0) THEN
          CALL FZERO(TDMZZ(ISTTZ),NB1*NB2)
        ELSE
          CALL DGEMM_('N','T',NO1,NB2,NO2,1.0D0,
     &                TDMAB(ISTTA),NO1,CMOB(ISTCB),NB2,
     &         0.0D0,  WORK(LSCR),NO1)
          CALL DGEMM_('N','N',NB1,NB2,NO1,1.0D0,
     &                 CMOA(ISTCA),NB1,WORK(LSCR),NO1,
     &         0.0D0,  TDMZZ(ISTTZ),NB1)
          ISTTA=ISTTA+NO1*NO2
        END IF
15      CONTINUE
        ISTCA=ISTCA+NB1*NO1
        ISTTZ=ISTTZ+NB1*NB2
20    CONTINUE
      CALL GETMEM('      ','FREE','REAL',LSCR,NSCR)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GramSchmidt(S,C,nDim,Type,Center,iRestrict)
*
      Implicit ReaL*8 (A-H,O-Z)
#include "real.fh"
      Real*8 S(nDim,nDim),C(nDim,nDim)
      Integer Type(nDim), Occ, Vir,
     &        Center(nDim)
      Parameter(Occ=1,Vir=0)
*
c     write (*,*) 'nDim,nDim', nDim,nDim
C     Write (6,*) Center
      Do iOrb=1,nDim
         If (iRestrict .eq. 1 .AND. Type(iOrb).eq.Vir) Go To 99
         F = Zero
         If (S(iOrb,iOrb) .gt. Zero) F = One/Sqrt(S(iOrb,iOrb))
C
         Do ibas=1,nDim
            C(Ibas,Iorb)=F*C(Ibas,Iorb)
C        write (6,*) C(Ibas,Iorb), IBas, Iorb
         End Do
C
         Do Jorb=1,nDim
            S(Iorb,Jorb)=F*S(Iorb,Jorb)
         End Do
         Do Jorb=1,nDim
            S(Jorb,Iorb)=F*S(Jorb,Iorb)
         End Do
*
         iStart = 1
         If (iRestrict .eq. 0) iStart = iOrb+1
         Do jOrb=iStart,nDim
            If (iRestrict .eq. 1 .AND. Type(jOrb).eq.Occ) Go To 98
C           If (Center(iOrb).eq.Center(jOrb)) Go To 98
            A=S(Iorb,Jorb)
            Do Ibas=1,nDim
               C(Ibas,Jorb)=C(Ibas,Jorb)-A*C(Ibas,Iorb)
            End Do
            Do Korb=1,nDim
               S(Jorb,Korb)=S(Jorb,Korb)-A*S(Iorb,Korb)
            End Do
            Do Korb=1,nDim
               S(Korb,Jorb)=S(Korb,Jorb)-A*S(Korb,Iorb)
            End Do
 98         Continue
         End Do
 99      Continue
      End Do
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(Center)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
      subroutine coeff(ralpha,rbetaa,rbetas)
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "cstate_mclr.fh"
      Two=2.0d0
      rOne=1.0d0
      Zero=0.0d0
      Spin=DBLE(ispin-1)/Two
      rms=DBLE(ms2)/Two
      If (rms.eq.0.0d0.or.rms.ne.spin) then
      Write(6,*)
      Write(6,*) '====='
      Write(6,*)
      Write(6,*) 'Sorry, I am just able to calculate the'
      Write (6,*)'Spin polariztion for high spin states'
      Write(6,*) 'Welcome back after you have recalculated'
      write(6,*) 'your wave function'
      Write(6,*)
      Write(6,*)
      Call Quit_OnUserError()
      end if
      rcg21=clebsch_gordan(Two,rone,spin,rms-rone,spin,rms)
      rcg11=clebsch_gordan(rOne,rOne,spin,rms-rone,spin,rms)
      rcg20=clebsch_gordan(Two,Zero,spin,rms,spin,rms)
      rcg10=clebsch_gordan(rOne,Zero,spin,rms,spin,rms)
      rgamma=sqrt(spin*(spin+1.0D0)-rms*(rms-1.0D0))
*
      ralpha=rMS**2
      rBetaa=rMS/sqrt(8.0d0)*rgamma*rcg11/rcg10
      rbetaS=0.0d0
      If (abs(2.0d0-spin).le.spin) Then
      rAlpha=ralpha-rMS*rgamma*rcg21/(rcg20*sqrt(6.0d0))
      rBetas=-rMS*rgamma*rcg21/(sqrt(24.0d0)*rcg20)
      End If
*
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine CmpInt(XInt,n_Int,nBas,nIrrep,Label)
!***********************************************************************
!                                                                      *
! Object: to remove the off-diagonal nonzero blocks of matrix elements *
!         for an operator.                                             *
!                                                                      *
!         XInt(n_Int):array with nonzero elements                      *
!                                                                      *
!         nBas(0:nIrrep-1):number of basis functions in each irrep     *
!                                                                      *
!         Label: symmetry label of the operator for which the          *
!                matrix elements where computed.                       *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             March 1991                                               *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: n_Int
real(kind=wp), intent(inout) :: XInt(n_Int+4)
integer(kind=iwp), intent(in) :: nIrrep, nBas(0:nIrrep-1), Label
integer(kind=iwp) :: iCmp, iExp, iIrrep, ij, jIrrep, Len_

iCmp = 1
iExp = 1
do iIrrep=0,nIrrep-1
  do jIrrep=0,iIrrep
    ij = Mul(iIrrep+1,jIrrep+1)-1
    if (.not. btest(Label,ij)) cycle
    if (iIrrep == jIrrep) then
      Len_ = nTri_Elem(nBas(iIrrep))
      XInt(iCmp:iCmp+Len_-1) = Xint(iExp:iExp+Len_-1)
      iCmp = iCmp+Len_
      iExp = iExp+Len_
    else
      Len_ = nBas(iIrrep)*nBas(jIrrep)
      iExp = iExp+Len_
    end if
  end do
end do
XInt(iCmp:iCmp+3) = XInt(iExp:iExp+3)
n_Int = iCmp-1

return

end subroutine CmpInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE CMP_IVEC_ILIST(IVEC,ILIST,LLIST,NLIST,INUM)
* An integer IVEC of LLIST entries are given.
* compare with list of vectors in ILIST and find first
* vector in LLIST that is identical to IVEC.
*
* If INUM = 0, the list was not found
*
*  Jeppe Olsen, December 2001
*
#include "implicit.fh"
*. General input
      INTEGER ILIST(LLIST,NLIST)
*. Specific input
      INTEGER IVEC(LLIST)
*
      INUM = 0
      DO JLIST = 1, NLIST
        IFOUND = 1
        DO IELMNT = 1, LLIST
          IF(IVEC(IELMNT).NE.ILIST(IELMNT,JLIST))IFOUND = 0
        END DO
        IF(IFOUND.EQ.1) INUM = JLIST
        IF(INUM.NE.0) GOTO 1001
      END DO
*
 1001 CONTINUE
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Input list : '
        CALL IWRTMA(IVEC,1,LLIST,1,LLIST)
        WRITE(6,*) ' Address of list : ', INUM
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine MKBNEVAC_E3x(ISYM,nAshT,NG3,NBA,NBC,BA,BC,G1,G2,G3,Hact,Htilde,Gact,idxG3)

use caspt2_module, only: IASYM, NTUVES
use SUPERINDEX, only: KTUV
use Symmetry_Info, only: Mul
use nevpt2_mod, only: ex2, ex3
use Constants, only: Two
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: iSYM, nAshT, NG3, NBA, NBC
real(kind=wp), intent(inout) :: BA(NBA), BC(NBC)
real(kind=wp), intent(in) :: G1(nAshT,nAshT), G2(nAshT,nAshT,nAshT,nAshT), G3(*), Hact(nAshT,nAshT), Htilde(nAshT,nAshT), &
                             Gact(nAshT,nAshT,nAshT,nAshT)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: iG3, IT, ITU, IU, IV, IVX, IX, IY, IYZ, IZ
real(kind=wp) :: G3VAL

do IG3=1,NG3
  iT = idxG3(1,iG3)
  iU = idxG3(2,iG3)
  iV = idxG3(3,iG3)
  iX = idxG3(4,iG3)
  iY = idxG3(5,iG3)
  iZ = idxG3(6,iG3)
  !iST = IASYM(iT)
  !iSU = IASYM(iU)
  !iSV = IASYM(iV)
  !iSX = IASYM(iX)
  !iSY = IASYM(iY)
  !iSZ = IASYM(iZ)
  !ituvs = MUL(IST,MUL(ISU,ISV))
  !ixyzs = MUL(ISX,MUL(ISY,ISZ))
  !if (ituvs /= ixyzs) cycle
  iTU = iT+NASHT*(iU-1)
  iVX = iV+NASHT*(iX-1)
  iYZ = iY+NASHT*(iZ-1)

  ! G3(tuvxyz) = <Psi|t+ v+ y+ z x u|Psi>
  !G3VAL = tG3(IT,IU,IV,IX,IY,IZ,G1,G2,G3(iG3))

  ! D(tuvxyz)
  !if ((MUL(iST,iSU) == iSym) .or. (MUL(iSV,ISX) == iSym) .or. (MUL(iSY,iSZ) == iSym)) then
  G3VAL = ex3(IT,IU,IV,IX,IY,IZ,G1,G2,G3(iG3))
  call Add_MKBNEVAC(iT,iU,iV,iX,iY,iZ)
  !end if

  if ((iTU /= iVX) .or. (iVX /= iYZ)) then
    if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
      ! D(vxtuyz)
      !if ((MUL(iSX,iSV) == iSym) .or. (MUL(iSX,iST) == iSym) .or. (MUL(iSU,iSY) == iSym)) then
      G3VAL = ex3(IV,IX,IT,IU,IY,IZ,G1,G2,G3(iG3))
      call Add_MKBNEVAC(iV,iX,iT,iU,iY,iZ)
      !end if
      ! D(yzvxtu)
      !if ((MUL(iSZ,iSY) == iSym) .or. (MUL(iSZ,iSV) == iSym) .or. (MUL(iSX,iST) == iSym)) then
      G3VAL = ex3(IY,IZ,IV,IX,IT,IU,G1,G2,G3(iG3))
      call Add_MKBNEVAC(iY,iZ,iV,iX,iT,iU)
      !end if
      ! D(tuyzvx)
      !if ((MUL(iSU,iST) == iSym) .or. (MUL(iSU,iSY) == iSym) .or. (MUL(iSZ,iSV) == iSym)) then
      G3VAL = ex3(IT,IU,IY,IZ,IV,IX,G1,G2,G3(iG3))
      call Add_MKBNEVAC(iT,iU,iY,iZ,iV,iX)
      !end if
    end if
    ! D(yztuvx)
    !if ((MUL(iSZ,iSY) == iSym) .or. (MUL(iSZ,iST) == iSym) .or. (MUL(iSU,iSV) == iSym)) then
    G3VAL = ex3(IY,IZ,IT,IU,IV,IX,G1,G2,G3(iG3))
    call Add_MKBNEVAC(iY,iZ,iT,iU,iV,iX)
    !end if
    ! D(vxyztu)
    !if ((MUL(iSX,iSV) == iSym) .or. (MUL(iSX,iSY) == iSym) .or. (MUL(iSZ,iST) == iSym)) then
    G3VAL = ex3(IV,IX,IY,IZ,IT,IU,G1,G2,G3(iG3))
    call Add_MKBNEVAC(iV,iX,iY,iZ,iT,iU)
    !end if
  end if

  if ((iT == iU) .and. (iV == iX) .and. (iY == iZ)) cycle
  if ((iT == iU) .and. (iV == iZ) .and. (iX == iY)) cycle
  if ((iX == iV) .and. (iT == iZ) .and. (iU == iY)) cycle
  if ((iZ == iY) .and. (iV == iU) .and. (iX == iT)) cycle

  ! D(utxvzy)
  !if ((MUL(iST,iSU) == iSym) .or. (MUL(iST,iSX) == iSym) .or. (MUL(iSV,iSZ) == iSym)) then
  G3VAL = ex3(IU,IT,IX,IV,IZ,IY,G1,G2,G3(iG3))
  call Add_MKBNEVAC(iU,iT,iX,iV,iZ,iY)
  !end if

  if ((iTU == iVX) .and. (iVX == iYZ)) cycle
  if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
    ! D(xvutzy)
    !if ((MUL(iSV,iSX) == iSym) .or. (MUL(iSV,iSU) == iSym) .or. (MUL(iST,iSZ) == iSym)) then
    G3VAL = ex3(IX,IV,IU,IT,IZ,IY,G1,G2,G3(iG3))
    call Add_MKBNEVAC(iX,iV,iU,iT,iZ,iY)
    !end if
    ! D(zyxvut)
    !if ((MUL(iSY,iSZ) == iSym) .or. (MUL(iSY,iSX) == iSym) .or. (MUL(iSV,iSU) == iSym)) then
    G3VAL = ex3(IZ,IY,IX,IV,IU,IT,G1,G2,G3(iG3))
    call Add_MKBNEVAC(iZ,iY,iX,iV,iU,iT)
    !end if
    ! D(utzyxv)
    !if ((MUL(iST,iSU) == iSym) .or. (MUL(iST,iSZ) == iSym) .or. (MUL(iSY,iSX) == iSym)) then
    G3VAL = ex3(IU,IT,IZ,IY,IX,IV,G1,G2,G3(iG3))
    call Add_MKBNEVAC(iU,iT,iZ,iY,iX,iV)
    !end if
  end if
  ! D(zyutxv)
  !if ((MUL(iSY,iSZ) == iSym) .or. (MUL(iSY,iSU) == iSym) .or. (MUL(iST,iSX) == iSym)) then
  G3VAL = ex3(IZ,IY,IU,IT,IX,IV,G1,G2,G3(iG3))
  call Add_MKBNEVAC(iZ,iY,iU,iT,iX,iV)
  !end if
  ! D(xvzyut)
  !if ((MUL(iSV,iSX) == iSym) .or. (MUL(iSV,iSZ) == iSym) .or. (MUL(iSY,iSU) == iSym)) then
  G3VAL = ex3(IX,IV,IZ,IY,IU,IT,G1,G2,G3(iG3))
  call Add_MKBNEVAC(iX,iV,iZ,iY,iU,iT)
  !end if
end do

contains

subroutine Add_MKBNEVAC(ITABS_,IUABS_,IVABS_,IXABS_,IYABS_,IZABS_)

  use Index_Functions, only: iTri

  integer(kind=iwp), intent(in) :: ITABS_, IUABS_, IVABS_, IXABS_, IYABS_, IZABS_
  integer(kind=iwp) :: IAABS, IBABS, IBADR, ISAB, ITUV_, IWABS, IXYZ_

  iTUV_ = KTUV(IVABS_,IUABS_,ITABS_)-NTUVES(ISYM)
  if (MUL(IASYM(iVABS_),MUL(IASYM(IUABS_),IASYM(ITABS_))) == iSym) then
    do IWABS=1,nAshT
      ! C: A(vut,xwz) <-- +h_{yw} Etu*Evx*Eyz
      if (MUL(IASYM(IWABS),MUL(IASYM(IXABS_),IASYM(IZABS_))) == iSym) then
        iXYZ_ = KTUV(IXABS_,IWABS,IZABS_)-NTUVES(ISYM)
        if (iTUV_ >= iXYZ_) then
          IBADR = iTri(iTUV_,iXYZ_)
          BC(IBADR) = BC(IBADR)+G3VAL*Hact(IYABS_,IWABS)
        end if
      end if
      ! C: A(vut,xyw) <-- -htilde_{wz} Etu*Evx*Eyz
      if (MUL(IASYM(IWABS),MUL(IASYM(IXABS_),IASYM(IYABS_))) == iSym) then
        iXYZ_ = KTUV(IXABS_,IYABS_,IWABS)-NTUVES(ISYM)
        if (iTUV_ >= iXYZ_) then
          IBADR = iTri(iTUV_,iXYZ_)
          BC(IBADR) = BC(IBADR)-G3VAL*Htilde(IWABS,IZABS_)
        end if
      end if
      ! C: A(vut,wyz) <-- -htilde_{wx} Etu*Evx*Eyz
      if (MUL(IASYM(IWABS),MUL(IASYM(IYABS_),IASYM(IZABS_))) == iSym) then
        iXYZ_ = KTUV(IWABS,IYABS_,IZABS_)-NTUVES(ISYM)
        if (iTUV_ >= iXYZ_) then
          IBADR = iTri(iTUV_,iXYZ_)
          BC(IBADR) = BC(IBADR)-G3VAL*Htilde(IWABS,IXABS_)
        end if
      end if
    end do

    do IAABS=1,nAshT
      do IBABS=1,nAshT
        ISAB = MUL(IASYM(IAABS),IASYM(IBABS))
        ! C: A_{vut,abx} <-- -(ab|yz) * Etu Evx Eyz
        if (MUL(IASYM(IXABS_),ISAB) == iSym) then
          iXYZ_ = KTUV(IAABS,IBABS,IXABS_)-NTUVES(ISYM)
          if (iTUV_ >= iXYZ_) then
            IBADR = iTri(iTUV_,iXYZ_)
            BC(IBADR) = BC(IBADR)-G3VAL*Gact(IAABS,IBABS,IYABS_,IZABS_)
          end if
        end if
        ! C: A_{vut,xab} <-- -(ay|bz) * Etu Evx Eyz
        if (MUL(IASYM(IXABS_),ISAB) == iSym) then
          iXYZ_ = KTUV(IXABS_,IAABS,IBABS)-NTUVES(ISYM)
          if (iTUV_ >= iXYZ_) then
            IBADR = iTri(iTUV_,iXYZ_)
            BC(IBADR) = BC(IBADR)-G3VAL*Gact(IAABS,IYABS_,IBABS,IZABS_)
          end if
        end if
        ! C: A_{vut,abz} <-- -(ax|by) * Etu Evx Eyz
        if (MUL(IASYM(IZABS_),ISAB) == iSym) then
          iXYZ_ = KTUV(IAABS,IBABS,IZABS_)-NTUVES(ISYM)
          if (iTUV_ >= iXYZ_) then
            IBADR = iTri(iTUV_,iXYZ_)
            BC(IBADR) = BC(IBADR)-G3VAL*Gact(IAABS,IXABS_,IBABS,IYABS_)
          end if
        end if
        ! C: A_{vut,ayb} <-- +(ax|bz) * Etu Evx Eyz
        if (MUL(IASYM(IYABS_),ISAB) == iSym) then
          iXYZ_ = KTUV(IAABS,IYABS_,IBABS)-NTUVES(ISYM)
          if (iTUV_ >= iXYZ_) then
            IBADR = iTri(iTUV_,iXYZ_)
            BC(IBADR) = BC(IBADR)+G3VAL*Gact(IAABS,IXABS_,IBABS,IZABS_)
          end if
        end if
      end do
    end do
  end if

  do IAABS=1,nAshT
    do IBABS=1,nAshT
      ! (1.2.11) ERI(2)
      ! A: A_{aut,byz} <-- +2(vx|ab) * Etu Evx Eyz
      if ((MUL(IASYM(IAABS),MUL(IASYM(IUABS_),IASYM(ITABS_))) == iSym) .and. &
          (MUL(IASYM(IBABS),MUL(IASYM(IYABS_),IASYM(IZABS_))) == iSym)) then
        iTUV_ = KTUV(IAABS,IUABS_,ITABS_)-NTUVES(ISYM)
        iXYZ_ = KTUV(IBABS,IYABS_,IZABS_)-NTUVES(ISYM)
        if (iTUV_ >= iXYZ_) then
          IBADR = iTri(iTUV_,iXYZ_)
          BA(IBADR) = BA(IBADR)+Two*G3VAL*Gact(IAABS,IBABS,IVABS_,IXABS_)
        end if
      end if
    end do
  end do

  iTUV_ = KTUV(IXABS_,IUABS_,ITABS_)-NTUVES(ISYM)
  if (MUL(IASYM(IXABS_),MUL(IASYM(IUABS_),IASYM(ITABS_))) == iSym) then
    do IAABS=1,nAshT
      do IBABS=1,nAshT
        ISAB = MUL(IASYM(IAABS),IASYM(IBABS))
        ! (1.2.11) ERI(3)
        ! A: A_{xut,avb} <-- +(ab|yz) * Etu Evx Eyz
        if (MUL(IASYM(IVABS_),ISAB) == iSym) then
          iXYZ_ = KTUV(IAABS,IVABS_,IBABS)-NTUVES(ISYM)
          if (iTUV_ >= iXYZ_) then
            IBADR = iTri(iTUV_,iXYZ_)
            BA(IBADR) = BA(IBADR)+G3VAL*Gact(IAABS,IBABS,IYABS_,IZABS_)
          end if
        end if
        ! (1.2.11) ERI(4)
        ! A: A_{xut,abz} <-- -(va|yb) * Etu Evx Eyz
        if (MUL(IASYM(IZABS_),ISAB) == iSym) then
          iXYZ_ = KTUV(IAABS,IBABS,IZABS_)-NTUVES(ISYM)
          if (iTUV_ >= iXYZ_) then
            IBADR = iTri(iTUV_,iXYZ_)
            BA(IBADR) = BA(IBADR)-G3VAL*Gact(IAABS,IVABS_,IYABS_,IBABS)
          end if
        end if
        ! (1.2.11) ERI(5)
        ! A: A_{xut,ayb} <-- +(va|bz) * Etu Evx Eyz
        if (MUL(IASYM(IYABS_),ISAB) == iSym) then
          iXYZ_ = KTUV(IAABS,IYABS_,IBABS)-NTUVES(ISYM)
          if (iTUV_ >= iXYZ_) then
            IBADR = iTri(iTUV_,iXYZ_)
            BA(IBADR) = BA(IBADR)+G3VAL*Gact(IAABS,IVABS_,IZABS_,IBABS)
          end if
        end if
      end do
    end do

    G3VAL = -G3VAL
    if (IVABS_ == IXABS_) G3VAL = Two*ex2(ITABS_,IUABS_,IYABS_,IZABS_,G1,G2)+G3VAL

    do IWABS=1,nAshT
      ! A: A(xut,vwz) <-- +h_{yw} EtuEvxEyz
      if (MUL(IASYM(IWABS),MUL(IASYM(IVABS_),IASYM(IZABS_))) == iSym) then
        iXYZ_ = KTUV(IVABS_,IWABS,IZABS_)-NTUVES(ISYM)
        if (iTUV_ >= iXYZ_) then
          IBADR = iTri(iTUV_,iXYZ_)
          BA(IBADR) = BA(IBADR)+G3VAL*Hact(IYABS_,IWABS)
        end if
      end if
      ! A: A(xut,vyw) <-- -h_{wz} EtuEvxEyz
      if (MUL(IASYM(IWABS),MUL(IASYM(IVABS_),IASYM(IYABS_))) == iSym) then
        iXYZ_ = KTUV(IVABS_,IYABS_,IWABS)-NTUVES(ISYM)
        if (iTUV_ >= iXYZ_) then
          IBADR = iTri(iTUV_,iXYZ_)
          BA(IBADR) = BA(IBADR)-G3VAL*Htilde(IWABS,IZABS_)
        end if
      end if
      ! A: A(xut,wyz) <-- +h_{wv} EtuEvxEyz
      if (MUL(IASYM(IWABS),MUL(IASYM(IYABS_),IASYM(IZABS_))) == iSym) then
        iXYZ_ = KTUV(IWABS,IYABS_,IZABS_)-NTUVES(ISYM)
        if (iTUV_ >= iXYZ_) then
          IBADR = iTri(iTUV_,iXYZ_)
          BA(IBADR) = BA(IBADR)+G3VAL*Hact(IWABS,IVABS_)
        end if
      end if
    end do

    do IAABS=1,nAshT
      do IBABS=1,nAshT
        ISAB = MUL(IASYM(IAABS),IASYM(IBABS))
        ! (1.2.11) ERI(1)
        ! A: A_{xut,vab} <-- +(ya|zb) * Etu Evx Eyz
        if (MUL(IASYM(IVABS_),ISAB) == iSym) then
          iXYZ_ = KTUV(IVABS_,IAABS,IBABS)-NTUVES(ISYM)
          if (iTUV_ >= iXYZ_) then
            IBADR = iTri(iTUV_,iXYZ_)
            BA(IBADR) = BA(IBADR)-G3VAL*Gact(IAABS,IYABS_,IBABS,IZABS_)
          end if
        end if
      end do
    end do
  end if

end subroutine Add_MKBNEVAC

end subroutine MKBNEVAC_E3x

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Drvel1(Grad)

use Basis_Info
use Center_Info
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: Grad(*)
integer(kind=iwp) :: iCar, iCnt, iCnttp, iComp, idisp, iirrep, jCar, jIrrep, mdc
real(kind=wp) :: ZA
integer(kind=iwp), external :: irrfnc
logical(kind=iwp), external :: TF

idisp = 0
do jIrrep=0,nirrep-1
  do jCar=1,3
    iirrep = irrfnc(2**(jcar-1))
    if (jirrep == iirrep) then
      mdc = 0
      do iCnttp=1,nCnttp
        ZA = dbsc(iCnttp)%Charge
        do iCnt=1,dbsc(iCnttp)%nCntr
          mdc = mdc+1
          do iCar=1,3
            iComp = 2**(iCar-1)
            if (TF(mdc,jIrrep,iComp)) then
              idisp = idisp+1
              if (icar == jcar) Grad(idisp) = ZA
            end if
          end do
        end do
      end do
    end if
  end do
end do

return

end subroutine Drvel1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GSAXPY(AB,A,B,NABCOL,NACOL,NROW,IABCOL,IACOL)
*
* AB(I,IABCOL(J)) = AB(I,IABCOL(J)) + A(I,IACOL(K))*B(K,J)
*
*
* Jeppe Olsen, Spring of 94 Daughter of MSAXPY*
*

      IMPLICIT REAL*8 (A-H,O-Z)
*. Input
      DIMENSION A(NROW,*),B(NACOL,NABCOL)
      DIMENSION IACOL(NACOL),IABCOL(NABCOL)
*. Output
      DIMENSION AB(NROW,*)
*
      IWAY = 2
      ICRAY = 0
      IF(IWAY.EQ.1) THEN
*. Straightforward sequence of SAXPY's
         DO 1100 J = 1, NABCOL
           DO 1200 K = 1, NACOL
             JACT = IABCOL(J)
             KACT = IACOL(K)
             FACTOR = B(K,J)
C             IF(ICRAY.EQ.1) THEN
C               CALL SAXPY(NROW,FACTOR,A(1,KACT),1,AB(1,JACT),1)
C             ELSE
               DO 1000 I = 1, NROW
                 AB(I,JACT) = AB(I,JACT) + FACTOR*A(I,KACT)
 1000          CONTINUE
C             END IF
 1200      CONTINUE
 1100    CONTINUE
*
      ELSE IF (IWAY .EQ. 2 ) THEN
*. Unrolling over columns of A
       NROL = 5
       NRES = MOD(NACOL,NROL)
*. overhead
       IF(NRES.EQ.1) THEN
         DO 2201 J = 1, NABCOL
          JACT = IABCOL(J)
          K1ACT = IACOL(1)
          B1J = B(1,J)
C          IF(ICRAY.EQ.1) THEN
C            CALL SAXPY(NROW,B1J,A(1,K1ACT),1,AB(1,JACT),1)
C          ELSE
            DO 2101 I = 1, NROW
              AB(I,JACT) = AB(I,JACT) + A(I,K1ACT)*B1J
 2101       CONTINUE
C          END IF
 2201    CONTINUE
       ELSE IF (NRES .EQ. 2 ) THEN
         DO 2202 J = 1, NABCOL
           K1ACT = IACOL(1)
           K2ACT = IACOL(2)
           B1J   = B(1,J)
           B2J   = B(2,J)
           JACT =  IABCOL(J)
           DO 2102 I = 1, NROW
            AB(I,JACT) = AB(I,JACT)
     &    + A(I,K1ACT)*B1J + A(I,K2ACT)*B2J
 2102      CONTINUE
 2202    CONTINUE
       ELSE IF (NRES .EQ. 3 ) THEN
         DO 2203 J = 1, NABCOL
           K1ACT = IACOL(1)
           K2ACT = IACOL(2)
           K3ACT = IACOL(3)
           JACT =  IABCOL(J)
           B1J   = B(1,J)
           B2J   = B(2,J)
           B3J   = B(3,J)
           DO 2103 I = 1, NROW
            AB(I,JACT) = AB(I,JACT)
     &    + A(I,K1ACT)*B1J + A(I,K2ACT)*B2J
     &    + A(I,K3ACT)*B3J
 2103      CONTINUE
 2203    CONTINUE
       ELSE IF (NRES .EQ. 4 ) THEN
         DO 2204 J = 1, NABCOL
           K1ACT = IACOL(1)
           K2ACT = IACOL(2)
           K3ACT = IACOL(3)
           K4ACT = IACOL(4)
           JACT =  IABCOL(J)
           B1J   = B(1,J)
           B2J   = B(2,J)
           B3J   = B(3,J)
           B4J   = B(4,J)
           DO 2104 I = 1, NROW
            AB(I,JACT) = AB(I,JACT)
     &    + A(I,K1ACT)*B1J + A(I,K2ACT)*B2J
     &    + A(I,K3ACT)*B3J + A(I,K4ACT)*B4J
 2104      CONTINUE
 2204    CONTINUE
        END IF
*. ( End of Overhead )
        DO 2305 K = NRES+1,NACOL,NROL
          DO 2205 J = 1, NABCOL
            K1ACT = IACOL(K)
            K2ACT = IACOL(K+1)
            K3ACT = IACOL(K+2)
            K4ACT = IACOL(K+3)
            K5ACT = IACOL(K+4)
            JACT =  IABCOL(J)
            B1J   = B(K,J)
            B2J   = B(K+1,J)
            B3J   = B(K+2,J)
            B4J   = B(K+3,J)
            B5J   = B(K+4,J)
            DO 2105 I = 1, NROW
             AB(I,JACT) = AB(I,JACT)
     &     + A(I,K1ACT)*B1J + A(I,K2ACT)*B2J
     &     + A(I,K3ACT)*B3J + A(I,K4ACT)*B4J
     &     + A(I,K5ACT)*B5J
 2105       CONTINUE
 2205     CONTINUE
 2305   CONTINUE
      END IF
*( End of IWAY branching )
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Diff_Aux1(nEPotPoints,EPCo,nB,OneFile)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: nEPotPoints
real(kind=wp), allocatable, intent(out) :: EPCo(:,:)
integer(kind=iwp), intent(in) :: nB
character(len=10), intent(in) :: OneFile
character(len=10) :: Label
integer(kind=iwp) :: i, iopt, irc, iSmLbl, Lu_One, maxCen, n_int(1)
real(kind=wp), allocatable :: idiot(:), Tmp(:,:)
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

! Open One-electron file.

irc = -1
Lu_One = 49
Lu_One = IsFreeUnit(Lu_One)
call OpnOne(irc,0,OneFile,Lu_One)
if (irc /= 0) then
  write(u6,*)
  write(u6,*) 'ERROR! Could not open one-electron integral file.'
  call Quit(_RC_IO_ERROR_READ_)
end if

! Loop over all EF0, terminate when return-code is non-zero.

nEPotPoints = 0
maxCen = 99999
call mma_allocate(Tmp,3,maxCen,label='Temporary')
call mma_allocate(idiot,nB*(nB+1)/2+4,label='Idiot')
do i=1,maxCen
  write(Label,'(A3,I5)') 'EF0',i
  irc = -1
  iopt = 1
  iSmLbl = 0
  call iRdOne(irc,iopt,label,1,n_Int,iSmLbl)
  if (irc /= 0) exit
  irc = -1
  iopt = 0
  iSmLbl = 0
  call RdOne(irc,iopt,label,1,idiot,iSmLbl)
  Tmp(:,i) = idiot(n_int(1)+1:n_int(1)+3)
  nEPotPoints = nEPotPoints+1
end do

! Put the coordinates and nuclear part in nice and tight vectors.

call mma_allocate(EPCo,3,nEPotPoints,label='PotPointCoord')
EPCo(:,:) = Tmp(:,1:nEPotPoints)

! Deallocate.

call mma_deallocate(Tmp)
call mma_deallocate(idiot)

return

end subroutine Diff_Aux1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine ClrBuf(idcrr,idcrs,idcrt,ngr,
     &                  istb,jstb,kstb,lstb,
     &                  Shijij,iAnga,iCmp,iCmpa,
     &                  iShll,iShell,jShell,
     &                  iBasi,jBasj,kBask,lBasl,
     &                  Dij1,Dij2,mDij,nDij,
     &                  Dkl1,Dkl2,mDkl,nDkl,
     &                  Dik1,Dik2,mDik,nDik,
     &                  Dil1,Dil2,mDil,nDil,
     &                  Djk1,Djk2,mDjk,nDjk,
     &                  Djl1,Djl2,mDjl,nDjl,
     &                  Final,nFinal,
     &                  FckTmp,nFT,Scrtch1,nS1,Scrtch2,nS2,
     &                  Temp,nTemp,
     &                  TwoHam,nTwo,IndGrd,Index,iAO,iAOst,
     &                  iuvwx,IfG,n8,ltri,moip,nAcO,
     &                  rmoin,nmoin,ntemptot,Buffer,c,nop,din,dan,
     &                  new_fock)
************************************************************************
*                                                                      *
*       Called from: Twoel                                             *
*       takes care of the integrals                                    *
*       integrals -> fckmatrix,MO                                      *
*       in the near feature a disk based version                       *
*                                                                      *
*       Calling:   CntrDens : Gets the indexes for d1                  *
*                  MkFck : Add up the integrals on the Fock Matrix     *
*                                                                      *
*       Author: Anders Bernhardsson, Theoretical Chemistry,            *
*               University of Lund, Sweden, June '95                   *
************************************************************************
      use Real_Spherical
      use pso_stuff
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "disp.fh"
#include "disp2.fh"
#include "buffer.fh"
#include "cputime.fh"
*
      Integer iAnga(4), iShll(4),iShell(4),jShell(4),
     &        jOp(6), iCmp(4),icmpa(4),
     &        nop(4),Index(3,4),iuvwx(4),
     &        moip(0:7),
     &        IndGrd(3,4,0:7),iAO(4),iAOst(4)
      Real*8 Dij1(mDij,nDij),Dkl1(mDkl,nDkl),
     &       Dik1(mDik,nDik),Dil1(mDil,nDil),
     &       Djk1(mDjk,nDjk),Djl1(mDjl,nDjl),
     &       Dij2(mDij,nDij),Dkl2(mDkl,nDkl),
     &       Dik2(mDik,nDik),Dil2(mDil,nDil),
     &       Djk2(mDjk,nDjk),Djl2(mDjl,nDjl),
     &       FckTmp(nFT),Scrtch1(nS1),Temp(nTemp),
     &       Scrtch2(nS2),TwoHam(nTwo),Final(nFinal),
     &       rmoin(nMOIN),c(12),buffer(*),din(*),dan(*)
      Logical   Shijij,n8,IfG(4),pert(0:7),ltri,new_fock
*
      nijkl=iBasi*jBasj*kBask*lBasl
      nabcd=iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)
      Call Timing(dum1,Time,dum2,dum3)
*
      ExFac=One
*
      If (ltri) Then
      if (.not.new_fock) then
*----------------------------------------------------------------*
*
*       Get the size of the work area that should be contracted
*
*----------------------------------------------------------------*
        If (jShell(1).ge.jShell(2)) Then
         ij1 = iBasi
         ij2 = jBasj
         ij3 = iCmp(1)
         ij4 = iCmp(2)
        Else
         ij1 = jBasj
         ij2 = iBasi
         ij3 = iCmp(2)
         ij4 = iCmp(1)
        End If
        If (jShell(3).ge.jShell(4)) Then
         kl1 = kBask
         kl2 = lBasl
         kl3 = iCmp(3)
         kl4 = iCmp(4)
        Else
         kl1 = lBasl
         kl2 = kBask
         kl3 = iCmp(4)
         kl4 = iCmp(3)
        End If
        If (jShell(1).ge.jShell(3)) Then
         ik1 = iBasi
         ik2 = kBask
         ik3 = iCmp(1)
         ik4 = iCmp(3)
        Else
         ik1 = kBask
         ik2 = iBasi
         ik3 = iCmp(3)
         ik4 = iCmp(1)
        End If
        If (jShell(1).ge.jShell(4)) Then
         il1 = iBasi
         il2 = lBasl
         il3 = iCmp(1)
         il4 = iCmp(4)
        Else
         il1 = lBasl
         il2 = iBasi
         il3 = iCmp(4)
         il4 = iCmp(1)
        End If
        If (jShell(2).ge.jShell(3)) Then
         jk1 = jBasj
         jk2 = kBask
         jk3 = iCmp(2)
         jk4 = iCmp(3)
        Else
         jk1 = kBask
         jk2 = jBasj
         jk3 = iCmp(3)
         jk4 = iCmp(2)
        End If
        If (jShell(2).ge.jShell(4)) Then
         jl1 = jBasj
         jl2 = lBasl
         jl3 = iCmp(2)
         jl4 = iCmp(4)
        Else
         jl1 = lBasl
         jl2 = jBasj
         jl3 = iCmp(4)
         jl4 = iCmp(2)
        End If
*
*    Here we go
*
        nao=iBasi*jBasj*kBask*lBasl*
     &    iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)
        Call CtlDns(iDCRR,iDCRS,iDCRT,jOp)
         end if
*
*             Add this contribution to the (Inactive) Fock Matrix
*
*                Out from  CD : jOp
*
        Do iCent=1,4
         Do iCar=1,3
            Call lCopy(8,[.false.],0,pert,1)
*
*           Too which irreps does this derivative contribute ?
*
            Do iIrrep=0,nIrrep-1
               If (indgrd(iCar,iCent,iirrep).ne.0)
     &          pert(iIrrep)=.true.
            End Do
*
           If (Index(iCar,iCent).gt.0) Then
            iGr=Index(iCar,iCent)-1
            ipFin=1+iGr*nijkl*nabcd
            If (.not.new_fock) Then
            Call MkFck(iAnga,iCmpa,iCmp,
     &                 Shijij,
     &                 iShll,iShell,
     &                 iBasi,jBasj,kBask,lBasl,
     &                 iAO,iAOst,nop,jop,
     &                 Dij1,mDij,nDij,ij1,ij2,ij3,ij4,
     &                 Dkl1,mDkl,nDkl,kl1,kl2,kl3,kl4,
     &                 Dik1,mDik,nDik,ik1,ik2,ik3,ik4,
     &                 Dil1,mDil,nDil,il1,il2,il3,il4,
     &                 Djk1,mDjk,nDjk,jk1,jk2,jk3,jk4,
     &                 Djl1,mDjl,nDjl,jl1,jl2,jl3,jl4,
     &                 Final(ipFin),
     &                 nAO,TwoHam,nTwo,
     &                 Scrtch1,nS1,Scrtch2,nS2,
     &                 iDCRR,iDCRS,iDCRT,
     &                 FckTmp,nFT,pert,iuvwx(iCent),
     &                 iCent,iCar,indgrd,ipdisp)
            If (nMethod.eq.RASSCF)
     &      Call MkFck(iAnga,iCmpa,iCmp,
     &                 Shijij,
     &                 iShll,iShell,
     &                 iBasi,jBasj,kBask,lBasl,
     &                 iAO,iAOst,nop,jop,
     &                 Dij2,mDij,nDij,ij1,ij2,ij3,ij4,
     &                 Dkl2,mDkl,nDkl,kl1,kl2,kl3,kl4,
     &                 Dik2,mDik,nDik,ik1,ik2,ik3,ik4,
     &                 Dil2,mDil,nDil,il1,il2,il3,il4,
     &                 Djk2,mDjk,nDjk,jk1,jk2,jk3,jk4,
     &                 Djl2,mDjl,nDjl,jl1,jl2,jl3,jl4,
     &                 Final(ipFin),
     &                 nAO,TwoHam,nTwo,
     &                 Scrtch1,nS1,Scrtch2,nS2,
     &                 iDCRR,iDCRS,iDCRT,
     &                 FckTmp,nFT,pert,iuvwx(iCent),
     &                 iCent,iCar,indgrd,ipdisp2)
        else
         ip=ipDisp(abs(indgrd(iCar,iCent,0)))
         Call FckAcc_NoSym(iAnga,
     &                  iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4), Shijij,
     &                  iShll, iShell, nijkl,
     &                  Final(ipFin),TwoHam(ip),dan,ndens,
     &                  iAO,iAOst,iBasi,jBasj,kBask,lBasl,ExFac)
         If (nMethod.eq.RASSCF) Then
         ip=ipDisp2(abs(indgrd(iCar,iCent,0)))
         Call FckAcc_NoSym(iAnga,
     &                  iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4), Shijij,
     &                  iShll, iShell, nijkl,
     &                  Final(ipFin),TwoHam(ip),din,nDens,
     &                  iAO,iAOst,iBasi,jBasj,kBask,lBasl,ExFac)
        end if
        end if
*
*
          Else If (Index(iCar,iCent).lt.0) Then
             call dcopy_(nabcd*nijkl,[Zero],0,Temp,1)
             Do iCnt=1,4
                iGr=Index(iCar,iCnt)
                If (iGr.gt.0)Then
                   ipFin=1+(iGr-1)*nijkl*nabcd
                   Do ii=1,nabcd*nijkl
                      Temp(ii)=Temp(ii)-Final(ipFin-1+ii)
                   End Do
                End If
             End Do
*
           if (.not.new_fock) Then
           Call MkFck(iAnga,iCmpa,iCmp,
     &                Shijij,
     &                iShll,iShell,
     &                iBasi,jBasj,kBask,lBasl,
     &                iAO,iAOst,nop,jop,
     &                Dij1,mDij,nDij,ij1,ij2,ij3,ij4,
     &                Dkl1,mDkl,nDkl,kl1,kl2,kl3,kl4,
     &                Dik1,mDik,nDik,ik1,ik2,ik3,ik4,
     &                Dil1,mDil,nDil,il1,il2,il3,il4,
     &                Djk1,mDjk,nDjk,jk1,jk2,jk3,jk4,
     &                Djl1,mDjl,nDjl,jl1,jl2,jl3,jl4,
     &                Temp,
     &                nAO,TwoHam,nTwo,
     &                Scrtch1,nS1,Scrtch2,nS2,
     &                iDCRR,iDCRS,iDCRT,
     &                FckTmp,nFT,pert,iuvwx(iCent),
     &                icent,iCar,indgrd,ipdisp)
           If (nMethod.eq.RASSCF)
     &     Call MkFck(iAnga,iCmpa,iCmp,
     &                Shijij,
     &                iShll,iShell,
     &                iBasi,jBasj,kBask,lBasl,
     &                iAO,iAOst,nop,jop,
     &                Dij2,mDij,nDij,ij1,ij2,ij3,ij4,
     &                Dkl2,mDkl,nDkl,kl1,kl2,kl3,kl4,
     &                Dik2,mDik,nDik,ik1,ik2,ik3,ik4,
     &                Dil2,mDil,nDil,il1,il2,il3,il4,
     &                Djk2,mDjk,nDjk,jk1,jk2,jk3,jk4,
     &                Djl2,mDjl,nDjl,jl1,jl2,jl3,jl4,
     &                Temp,
     &                nAO,TwoHam,nTwo,
     &                Scrtch1,nS1,Scrtch2,nS2,
     &                iDCRR,iDCRS,iDCRT,
     &                FckTmp,nFT,pert,iuvwx(iCent),
     &                icent,iCar,indgrd,ipdisp2)
*
         else
         ip=ipDisp(abs(indgrd(iCar,iCent,0)))
         Call FckAcc_NoSym(iAnga,
     &                  iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4), Shijij,
     &                  iShll, iShell, nijkl,
     &                  Temp,TwoHam(ip),dan,nDens,
     &                  iAO,iAOst,iBasi,jBasj,kBask,lBasl,ExFac)
            If (nMethod.eq.RASSCF) Then
         ip=ipDisp2(abs(indgrd(iCar,iCent,0)))
         Call FckAcc_NoSym(iAnga,
     &                  iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4), Shijij,
     &                  iShll, iShell, nijkl,
     &                  Temp,TwoHam(ip),din,nDens,
     &                  iAO,iAOst,iBasi,jBasj,kBask,lBasl,ExFac)
        end if
        end if
*
          End If
         End Do
        End Do
        Call Timing(dum1,Time,dum2,dum3)
        CPUStat(nFckAck)=CPUStat(nFckAck)+Time
      End If
*
      If (n8.and.nmethod.eq.RASSCF)
     &Call MakeMO(Final,Scrtch1,nTempTot,nFinal,
     &                  TwoHam,nTwo,
     &                  iCmp,iCmpa,
     &                  iBasi,jbasj,kbask,lbasl,
     &                  nGr,index,
     &                  moip,naco,nop,indgrd,
     &                  ishll,ishell,rmoin,nMOIN,
     &                  iuvwx,iao,iaost,Buffer,ianga,c)
*
*
      Call Timing(dum1,Time,dum2,dum3)
      CPUStat(nMOTrans)=CPUStat(nMOTrans)+Time
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(istb)
         Call Unused_integer(jstb)
         Call Unused_integer(kstb)
         Call Unused_integer(lstb)
         Call Unused_logical_array(IfG)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cht3(ireturn)
! main driver for (T)

use ChT3_global, only: DimGrpaR, L1Name, L2Name, maxdim, nfr, no, nv, NvGrp, printkey, T2Name, TCpu, TCpu_l, TCpu0, TWall, &
                       TWall_l, TWall0
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: i, maxspace, nBas(8), nOrb(8), nOrbE
character(len=24) :: Label
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: OE(:), oeh(:), oep(:)
real(kind=wp), parameter :: kb = 1024.0_wp

!mp
! vynuluj hodiny
call CWTime(TCpu,TWall)
TCpu0 = TCpu
TWall0 = TWall
TCpu_l = TCpu
TWall_l = TWall
!mp
!.0 read input

call IniReord_t3(NvGrp)

!.0.1 generate name convention for blocked integrals and T2 files

call DefParReord_t3(NvGrp,maxdim)
if (printkey >= 10) write(u6,*) 'Maxdim of virtual segment from CCSD = ',maxdim

!.0.2 def commons for DIRCC

call defcommon(no,nv)

!.2.2 regenerate integrals from the Cholesky vectors (L1) L1(m,I ,A'')

!.2.2.1 (vo|vo) for testing purpose

!isize = nc*no*nv
!!write(u6,*) 'size for l1_1 ',isize
!!write(u6,*) 'size for l1_2 ',isize
!call mma_allocate(l1_1,isize,label='cht3_l1_1')
!call mma_allocate(tmp,isize,label='cht3_itmp')
!isize = nv*nv*no*no
!!write(u6,*) 'size for W2 ',isize
!call mma_allocate(W2,isize,label='cht3_W2')
!call gen_vvoo(W2,l1_1,tmp)

!.2.2.2 get orbital energies

! Get Orbital energies

call Get_iArray('nBas',nBas,1)
call Get_iArray('nOrb',nOrb,1)

if (printkey >= 10) write(u6,*) 'Allocating memory for (tmp) OE files',nBas(1)

call mma_allocate(OE,nBas(1),label='cht3_oe')

Label = 'OrbE'
call qpg_dArray(Label,Found,nOrbE)
if (nOrbE /= nBas(1)) write(u6,*) 'Warning! in cht3 : (nOrbE /= nBas)!'
if ((.not. Found) .or. (nOrbE == 0)) call SysAbendMsg('get_orbe','Did not find:',Label)
if (printkey >= 10) then
  write(u6,*) 'nbas(1) = ',nBas(1)
  write(u6,*) 'norbe = ',norbe
end if
call Get_dArray(Label,OE,nOrbE)

! write out the orbital energies

if (printkey >= 10) then
  write(u6,*)
  write(u6,*) 'Orbital energies for nfr+no+nv'
  write(u6,*)
  do i=1,nfr+no+nv
    write(u6,'(A,2x,i5,2x,f18.10)') 'Orbital Energy ',i,OE(i)
  end do
end if

!2.2.3 make OEH, OEP

call mma_allocate(oeh,2*no,label='cht3_oeh')
call mma_allocate(oep,2*nv,label='cht3_oep')

call generate_juzekOE(OE(nfr+1),oeh,oep,no,nv)

!.2.3 Checkpoint. Calculate MP2 energy

!call calc_MP2(W2,OE(nfr+1),no,nv)
!call abend()

!.3 start (T) calculation

call mma_maxDBLE(maxspace)

write(u6,*)
write(u6,'(A,i13,A,f9.1,A,f5.1,A)') ' Memory available for (T) calc = ',maxspace-1,' in r*8 Words', &
                                    real((maxspace-1)*8,kind=wp)/kb**2,' Mb',real((maxspace-1)*8,kind=wp)/kb**3,' Gb'

!mp call GetMem('t3_ampl_bti','Allo','Real',ioff,1)
!mp ioff = ioff+1
!mp !write(u6,*) 'ioe   = ',ioe
!mp !write(u6,*) 'ioeh  = ',ioeh
!mp !write(u6,*) 'ioep  = ',ioep
!mp write(u6,*) 'ioff volny  = ',ioff
!mp kvir1 = ioff+1
!mp !kvir2 = kvir1+(maxspace-1)-1

! toto sa da vyhodit a nahradit iba natvrdo definovanim kvir
!mp call adapt_mem(Work(1),Work(ioff),(maxspace-1),kvir1,kvir2)

!!call alloc_vm(WORK,maxspace,KVIR1,KVIR2)

!mp write(u6,*) ' kvir1 = ',kvir1
!mp write(u6,*) ' kvir2 = ',kvir2

!mp call T3AMPL_BTI(Work(ioff),oeh,oep)

call T3AMPL_BTI(oeh,oep)

!.2.4 Free the unnecessary memory

!mp isize = nfr+no+nv
!mp isize = nOrb(1)
call mma_deallocate(OE)

call mma_deallocate(oeh)
call mma_deallocate(oep)
!mp ioff = ioff-1
!mp call GetMem('t3_ampl_bti','Free','Real',ioff,1)

call mma_deallocate(DimGrpaR)
call mma_deallocate(L1Name)
call mma_deallocate(L2Name)
call mma_deallocate(T2Name)

!Call EndGlb()

ireturn = 0

return

end subroutine cht3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine UnC(ArrayIn,ArrayOut,dsym,Sgn)
! Uncompresses the PCG vector to a orbital rotation matrix
!
! The redundant rotations are set to zero

use Symmetry_Info, only: Mul
use MCLR_Data, only: ipMat, nB, nDens, nDensC
use input_mclr, only: nIsh, nOrb, nRS1, nRS2, nRS3, nSym, TimeDep
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: ArrayIn(nDensC), Sgn
real(kind=wp), intent(out) :: ArrayOut(nDens)
integer(kind=iwp), intent(in) :: dsym
integer(kind=iwp) :: iBas, idsym, Index1, Index2, IndexC, iSym, iT, jBas, jSym, jT
real(kind=wp) :: Fact

indexC = 0
Fact = One
if (dsym < 0) Fact = -Fact
idsym = abs(dsym)
ArrayOut(:) = Zero
do iSym=1,nSym
  do jSym=1,nSym
    if (Mul(iSym,jSym) == idSym) then
      do jBas=1,nB(jSym)
        if (jBas <= nIsh(jsym)) then
          jT = 0
        else if (jBas <= nIsh(jsym)+nRs1(jsym)) then
          jT = 1
        else if (jBas <= nIsh(jsym)+nRs2(jsym)) then
          jT = 2
        else if (jBas <= nIsh(jsym)+nRs3(jsym)) then
          jT = 3
        else
          jT = 4
        end if
        do iBas=1,nOrb(iSym)
          if (iBas <= nIsh(isym)) then
            iT = 0
          else if (iBas <= nIsh(isym)+nRs1(isym)) then
            iT = 1
          else if (iBas <= nIsh(isym)+nRs2(isym)) then
            iT = 2
          else if (iBas <= nIsh(isym)+nRs3(isym)) then
            iT = 3
          else
            iT = 4
          end if
          if (Timedep) then
            if (iT /= jT) then
              indexC = indexc+1
              Index1 = ipMat(iSym,jSym)+(jBas-1)*nOrb(iSym)+iBas-1
              ArrayOut(Index1) = Fact*ArrayIn(indexC)
            end if
          else
            if (iT > jT) then
              indexC = indexc+1
              Index1 = ipMat(iSym,jSym)+(jBas-1)*nOrb(iSym)+iBas-1
              Index2 = ipMat(jSym,iSym)+(iBas-1)*nOrb(jSym)+jBas-1
              ArrayOut(Index1) = Fact*ArrayIn(indexC)
              ArrayOut(Index2) = Sgn*Fact*ArrayIn(indexC)
            end if
          end if
        end do
      end do
    end if
  end do
end do

end subroutine UnC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine GenBMp_Localisation(D,C,X,nShell,iSym,ColD,ColC,ColX,
     &                               PreFix)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
      Real*8 D(nShell,nShell), C(nShell,*), X(nShell,*)
      Character*1 ColD, ColC, ColX
      Character*2 PreFix
#include "inflocal.fh"

      Character*12 FilNam

C     Generate bitmap for density.
C     ----------------------------

      Write(FilNam,'(A2,A5,I1,A4)') PreFix,'Dnsty',iSym,'.bmp'
      Call GenBMp_Loc(D,nShell,nShell,FilNam,ColD)

C     Generate bitmap for original MOs.
C     ---------------------------------

      Write(FilNam,'(A2,A5,I1,A4)') PreFix,'MOrig',iSym,'.bmp'
      Call GenBMp_Loc(C,nShell,nOrb2Loc(iSym),FilNam,ColC)

C     Generate bitmap for localised MOs.
C     ----------------------------------

      Write(FilNam,'(A2,A5,I1,A4)') PreFix,'MOloc',iSym,'.bmp'
      Call GenBMp_Loc(X,nShell,nOrb2Loc(iSym),FilNam,ColX)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! From: D.R. Yarkony, J. Phys. Chem. A 105 (2001) 6277-6293
! and: J. Chem. Theory Comput. 12 (2016) 3636-3653
!***********************************************************************

subroutine CI_Summary(Lu)

use Slapaf_Info, only: CallLast, Energy, Gx, Gx0, iter, NAC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Half, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lu
integer(kind=iwp) :: i, n
real(kind=wp) :: aux, beta_ang, bif, deltagh, dgh, gg, gh, hh, norm_g, norm_h, peaked, sg, sh, shead, srel, st
character(len=40) :: Description
character(len=2) :: LabA
real(kind=wp), allocatable :: g(:), h(:), tmp(:,:)
real(kind=wp), external :: dDot_

n = size(Gx,1)*size(Gx,2)
call mma_Allocate(g,n)
call mma_Allocate(h,n)

! Compute the orthogonal branching vectors
! Note that d(E1-E0)/dx is stored, but we want to use d((E1-E0)/2)/dx
! (and forces instead of gradients)

gg = dDot_(n,Gx0(:,:,iter),1,Gx0(:,:,iter),1)*Quart
hh = dDot_(n,NAC(:,:,iter),1,NAC(:,:,iter),1)
gh = -dDot_(n,Gx0(:,:,iter),1,NAC(:,:,iter),1) !Factor 2 included
beta_ang = atan2(gh,gg-hh)*Half
g(:) = -cos(beta_ang)*Half*reshape(Gx0(:,:,iter),[n])+sin(beta_ang)*reshape(NAC(:,:,iter),[n])
h(:) = cos(beta_ang)*reshape(NAC(:,:,iter),[n])+sin(beta_ang)*Half*reshape(Gx0(:,:,iter),[n])
gg = dDot_(n,g,1,g,1)
hh = dDot_(n,h,1,h,1)
norm_g = sqrt(gg)
norm_h = sqrt(hh)
if (norm_g > 1.0e-12_wp) then
  g(:) = g(:)/norm_g
else
  g(:) = Zero
end if
if (norm_h > 1.0e-12_wp) then
  h(:) = h(:)/norm_h
else
  h(:) = Zero
end if
! Ensure that the asymmetry will be positive
! this fixes which vector is x and which is y
if (hh > gg) then
  call dSwap_(n,g,1,h,1)
  aux = gg
  gg = hh
  hh = aux
  aux = norm_g
  norm_g = norm_h
  norm_h = aux
end if
sg = -dDot_(n,Gx(1,1,iter),1,g,1)
sh = -dDot_(n,Gx(1,1,iter),1,h,1)
! Ensure that the tilt heading will be in the first quadrant
! this fixes the signs of the x and y vectors
if (sg < Zero) then
  sg = abs(sg)
  g(:) = -g(:)
end if
if (sh < Zero) then
  sh = abs(sh)
  h(:) = -h(:)
end if
st = sqrt(sg**2+sh**2)
dgh = sqrt((gg+hh)/Two)
LabA = ''
deltagh = gg-hh
if ((gg+hh) > 1.0e-12_wp) then
  deltagh = deltagh/(gg+hh)
else
  LabA = ' *'
end if
if (dgh > 1.0e-12_wp) then
  srel = st/dgh
else
  srel = Zero
end if
shead = atan2(sh,sg)

! peaked/sloped, bifurcating/single-path parameters

peaked = srel**2/(One-deltagh**2)*(One-deltagh*cos(Two*shead))
bif = ((One+deltagh)*cos(shead)**2)**(One/Three)
bif = bif+((One-deltagh)*sin(shead)**2)**(One/Three)
bif = (srel/(Two*deltagh))**(Two/Three)*bif
Description = ''
if (peaked < 1) then
  Description = trim(Description)//'peaked (P<1)'
else if (peaked > 1) then
  Description = trim(Description)//'sloped (P>1)'
else
  Description = trim(Description)//'* (P=1)'
end if
if (bif < 1) then
  Description = trim(Description)//' bifurcating (B<1)'
else if (bif > 1) then
  Description = trim(Description)//' single-path (B>1)'
else
  Description = trim(Description)//' * (B=1)'
end if

! Disable Last_Energy to prevent further rotations

CallLast = .false.

write(Lu,*)
call CollapseOutput(1,'Conical Intersection Characterization')
write(Lu,'(3X,A)') '-------------------------------------'
write(Lu,*)
write(Lu,*) 'See: J. Chem. Theory Comput. 12 (2016) 3636-3653'
write(Lu,*)
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt('Gradient difference','',Gx0(1,1,iter),n,1)
call RecPrt('Coupling vector','',NAC(1,1,iter),n,1)
call RecPrt('Average gradient','',Gx(1,1,iter),n,1)
write(Lu,100) 'Beta angle:',beta_ang
write(Lu,*)
#endif
write(Lu,100) 'Pitch (delta_gh):',dgh,' Eh/a0'
write(Lu,100) 'Asymmetry (Delta_gh):',deltagh,trim(LabA)
#ifdef _DEBUGPRINT_
write(Lu,100) 'Total tilt (s):',st,' Eh/a0'
#endif
write(Lu,100) 'Relative tilt (sigma=s/delta_gh):',srel
write(Lu,100) 'Tilt heading (theta_s):',shead
write(Lu,*)
write(Lu,101) 'P:',peaked
write(Lu,101) 'B:',bif
write(Lu,101) 'Type: '//trim(Description)
write(Lu,*)
write(Lu,*) 'Local linear representation:'
n = size(Gx,2)
call mma_Allocate(tmp,n,3)
do i=1,n
  tmp(i,:) = g((i-1)*3+1:i*3)
end do
call RecPrt('Local x','',tmp,n,3)
do i=1,n
  tmp(i,:) = h((i-1)*3+1:i*3)
end do
call RecPrt('Local y','',tmp,n,3)
write(Lu,*)
write(Lu,110) Energy(iter),sg,sh
write(Lu,120) Two*dgh,deltagh
call mma_Deallocate(tmp)
call CollapseOutput(0,'Conical Intersection Characterization')

call mma_Deallocate(g)
call mma_Deallocate(h)

return

100 format(5X,A,T40,ES12.5,A)
101 format(5X,A,T11,ES12.5)
110 format(5X,'Average energy: ',F15.8,' + ',F12.8,'*x + ',F12.8,'*y')
120 format(5X,'Energy difference: ',F12.8,'*sqrt(r^2 + ',F12.8,'*t)',/,10X,'r^2 = x^2 + y^2',/,10X,'t = x^2 - y^2')

end subroutine CI_Summary

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_local_search

   USE fmm_global_paras
   USE fmm_box_utils, ONLY: fmm_parent_box, fmm_same_box, fmm_RFF_boxes

   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_init_local_search,   &
             fmm_free_local_search,   &
             fmm_get_local_paras

   TYPE fmm_local_map
      TYPE(id_list), POINTER :: box_list(:)
   END TYPE fmm_local_map

   TYPE(fmm_local_map), ALLOCATABLE, SAVE :: map_at_level(:)
   INTEGER(INTK), SAVE :: deepest_level

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_local_search(scheme)

      USE fmm_box_builder, ONLY: fmm_get_box_paras_at_level
      USE fmm_box_utils,   ONLY: fmm_deepest_level

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme

      TYPE(fmm_local_map), ALLOCATABLE :: RHS_map(:)
      TYPE(box_mm_data),   ALLOCATABLE :: mm_paras(:)
      TYPE(box_mm_paras),  POINTER :: ptr(:)
      INTEGER(INTK) :: level, j

      IF ( .NOT. scheme%branch_free )  &
         CALL fmm_quit('local search module may not work with CFMM!')
      IF ( .NOT. scheme%algorithm == DO_FMM )  &
         CALL fmm_quit('local search module is only for FMM algorithm')

      deepest_level = fmm_deepest_level(scheme)
      NULLIFY (ptr)
      ALLOCATE (mm_paras(deepest_level))
      ALLOCATE (RHS_map(deepest_level))

      ! Get multipole moment box information over whole hierarchy
      DO level = TOP_LEVEL, deepest_level
         NULLIFY (RHS_map(level)%box_list)
         NULLIFY (mm_paras(level)%LHS_paras)
         NULLIFY (mm_paras(level)%RHS_paras)
         NULLIFY (mm_paras(level)%qlm_T)
         NULLIFY (mm_paras(level)%qlm_W)
         CALL fmm_get_box_paras_at_level(level,scheme,ptr,'LHS')
         mm_paras(level)%LHS_paras => ptr
         CALL fmm_get_box_paras_at_level(level,scheme,ptr,'RHS')
         mm_paras(level)%RHS_paras => ptr
      END DO

      ! Build parent:child map of RHS parameters and use it to make
      ! local interaction map of LHS-RHS pairs
      CALL fmm_init_local_map(mm_paras)
      CALL fmm_build_RHS_map(mm_paras,RHS_map)
      CALL fmm_build_local_map(mm_paras,RHS_map)

      ! Deallocations
      DO level = TOP_LEVEL, deepest_level
         IF (ASSOCIATED(RHS_map(level)%box_list)) THEN
            DO j = 1, SIZE(RHS_map(level)%box_list)
               CALL free_linked_list(RHS_map(level)%box_list(j)%head)
            END DO
            DEALLOCATE (RHS_map(level)%box_list)
         END IF
         NULLIFY (RHS_map(level)%box_list)
         NULLIFY (mm_paras(level)%LHS_paras)
         NULLIFY (mm_paras(level)%RHS_paras)
      END DO
      DEALLOCATE (mm_paras, RHS_map)

   END SUBROUTINE fmm_init_local_search

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_local_map(mm_paras)

      IMPLICIT NONE
      TYPE(box_mm_data), INTENT(IN) :: mm_paras(:)

      INTEGER(INTK) :: i,j, ndim

      ALLOCATE (map_at_level(deepest_level))

      DO i = TOP_LEVEL, deepest_level
         ndim = SIZE(mm_paras(i)%LHS_paras)
         NULLIFY (map_at_level(i)%box_list)
         ALLOCATE (map_at_level(i)%box_list(ndim))
         DO j = 1, ndim
            NULLIFY (map_at_level(i)%box_list(j)%head)
            map_at_level(i)%box_list(j)%occ = 0
         END DO
      END DO

   END SUBROUTINE fmm_init_local_map

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_free_local_search

      IMPLICIT NONE
      INTEGER(INTK) :: i,j,ndim

      IF ( deepest_level == TOP_LEVEL ) RETURN

      DO i = TOP_LEVEL, deepest_level
         IF (ASSOCIATED(map_at_level(i)%box_list)) THEN
            ndim = SIZE(map_at_level(i)%box_list)
            DO j = 1, ndim
               CALL free_linked_list(map_at_level(i)%box_list(j)%head)
            END DO
            DEALLOCATE (map_at_level(i)%box_list)
         END IF
         NULLIFY (map_at_level(i)%box_list)
      END DO

      IF (ALLOCATED(map_at_level)) DEALLOCATE (map_at_level)

   END SUBROUTINE fmm_free_local_search

!-------------------------------------------------------------------------------

   RECURSIVE SUBROUTINE free_linked_list(occ_node)

      TYPE(id_node), POINTER :: occ_node

      IF (.NOT. ASSOCIATED(occ_node)) RETURN

      ! traverse linked-list freeing from bottom up recursively
      IF (ASSOCIATED(occ_node%next)) THEN
         CALL free_linked_list(occ_node%next)
         IF (ASSOCIATED(occ_node)) DEALLOCATE(occ_node)
         NULLIFY(occ_node)
      END IF
      IF (ASSOCIATED(occ_node)) DEALLOCATE(occ_node)
      NULLIFY(occ_node)

   END SUBROUTINE free_linked_list

!-------------------------------------------------------------------------------
! For each box, a list of the children boxes is generated.
! Box occupancy is only computed for levels _above_ the deepest
! level since deepest level occupancy corresponds to raw moments,
! not boxed moments, which is done separately.

   SUBROUTINE fmm_build_RHS_map(mm_paras,RHS_map)

      IMPLICIT NONE
      TYPE(box_mm_data),   INTENT(IN)  :: mm_paras(:)
      TYPE(fmm_local_map), INTENT(OUT) :: RHS_map(:)

      TYPE(box_mm_paras) :: box
      INTEGER(INTK) :: i,id, level, ndim

      DO level = deepest_level-1, TOP_LEVEL, -1

         ndim = SIZE(mm_paras(level)%RHS_paras)
         ALLOCATE (RHS_map(level)%box_list(ndim))

         ! Initialise
         DO i = 1, ndim
            NULLIFY (RHS_map(level)%box_list(i)%head)
            RHS_map(level)%box_list(i)%occ = 0
         END DO

         ! We drive the loop over the child box level
         DO i = 1, SIZE(mm_paras(level+1)%RHS_paras)
            ! 'map_up' indexes moments but, if in sync, then also the para set
            id = mm_paras(level+1)%RHS_paras(i)%map_up
            box%box = fmm_parent_box(mm_paras(level+1)%RHS_paras(i)%box)
            box%level = level
            ! 'id' should point to RHS parent box parameters
            IF ( .NOT. fmm_same_box(mm_paras(level)%RHS_paras(id),box))  &
               CALL fmm_quit('RHS paras map-up to parent broken')
            ! Append item to linked list
            CALL fmm_add_item(RHS_map(level)%box_list(id),i)
         END DO

      END DO

   END SUBROUTINE fmm_build_RHS_map

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_add_item(box_map,raw_id)

      IMPLICIT NONE
      TYPE(id_list), INTENT(INOUT) :: box_map
      INTEGER(INTK), INTENT(IN) :: raw_id
      TYPE(id_node), POINTER :: new_node

      IF ( box_map%occ == 0 ) THEN
         ! Start new linked list for these boxes
         box_map%occ = 1
         ALLOCATE (box_map%head)
         box_map%head%id = raw_id
         NULLIFY (box_map%head%next)
         RETURN
      END IF

      box_map%occ = box_map%occ + 1

      ALLOCATE(new_node)
      new_node%id = raw_id
      IF (ASSOCIATED(box_map%head%next)) THEN
         ! More than one entry in list (including head)
         ! so point new_node to old second entry
         new_node%next => box_map%head%next
         ! Point head to new_node
         NULLIFY(box_map%head%next)
         box_map%head%next => new_node
      ELSE
         ! Only head so far; make new_node our second entry
         box_map%head%next => new_node
         NULLIFY(new_node%next)   ! end of list
      END IF

      END SUBROUTINE fmm_add_item

!-------------------------------------------------------------------------------
! Here we generate a list for each LHS box of all
! the RHS boxes spatially local to the LHS box.
! For now 'local' includes all the parent's near-field boxes.

   SUBROUTINE fmm_build_local_map(mm_paras,RHS_map)

      IMPLICIT NONE
      TYPE(box_mm_data),   INTENT(IN) :: mm_paras(:)
      TYPE(fmm_local_map), INTENT(IN) :: RHS_map(:)

      TYPE(box_mm_paras) :: LHS_box, RHS_box
      INTEGER(INTK) :: i,j,id, lev
      TYPE(id_node), POINTER :: LHS_ptr, RHS_ptr

      lev = TOP_LEVEL
      DO i = 1, SIZE(mm_paras(lev)%LHS_paras)
         DO j = 1, SIZE(mm_paras(lev)%RHS_paras)
            LHS_box = mm_paras(lev)%LHS_paras(i)
            RHS_box = mm_paras(lev)%RHS_paras(j)
            IF ( .NOT. fmm_RFF_boxes(LHS_box,RHS_box) )  THEN
               CALL fmm_add_item(map_at_level(lev)%box_list(i),j)
            END IF
         END DO
      END DO

      DO lev = TOP_LEVEL+1, deepest_level
         DO i = 1, SIZE(mm_paras(lev)%LHS_paras)

            ! 'map_up' indexes moments but, if in sync, then also the para set
            id = mm_paras(lev)%LHS_paras(i)%map_up
            LHS_box%box = fmm_parent_box(mm_paras(lev)%LHS_paras(i)%box)
            LHS_box%level = lev-1
            ! 'id' should point to LHS parent box parameters
            IF ( .NOT. fmm_same_box(mm_paras(lev-1)%LHS_paras(id),LHS_box)) &
               CALL fmm_quit('LHS paras map-up to parent broken')

            IF ( map_at_level(lev-1)%box_list(id)%occ == 0 ) CYCLE
            LHS_ptr => map_at_level(lev-1)%box_list(id)%head
            ! Loop over parent's near-field boxes
            parent: DO
               IF (RHS_map(lev-1)%box_list(LHS_ptr%id)%occ == 0) THEN
                  IF (.NOT.ASSOCIATED(LHS_ptr%next)) EXIT parent
                  LHS_ptr => LHS_ptr%next
                  CYCLE parent
               END IF
               RHS_ptr => RHS_map(lev-1)%box_list(LHS_ptr%id)%head
               ! Get children and add to list of local boxes
               LHS_box = mm_paras(lev)%LHS_paras(i)
               child: DO
                  RHS_box = mm_paras(lev)%RHS_paras(RHS_ptr%id)
                  IF ( .NOT. fmm_RFF_boxes(LHS_box,RHS_box) )  THEN
                    CALL fmm_add_item(map_at_level(lev)%box_list(i),RHS_ptr%id)
                  END IF
                  IF (.NOT.ASSOCIATED(RHS_ptr%next)) EXIT child
                  RHS_ptr => RHS_ptr%next
               END DO child

               IF (.NOT.ASSOCIATED(LHS_ptr%next)) EXIT parent
               LHS_ptr => LHS_ptr%next
            END DO parent

         END DO
      END DO

   END SUBROUTINE fmm_build_local_map

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_local_paras(id,RHS_all,pair_type,RHS_local,ndim)

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(OUT) :: RHS_local
      TYPE(gen_mm_paras), INTENT(IN)  :: RHS_all
      INTEGER(INTK),      INTENT(OUT) :: ndim
      INTEGER(INTK),      INTENT(IN)  :: pair_type
      INTEGER(INTK),      INTENT(IN)  :: id

      TYPE(id_node), POINTER :: ptr
      INTEGER(INTK) :: level, i

      SELECT CASE (pair_type)
         CASE (LHS_raw_RHS_raw)
            CALL fmm_quit ('local_paras: raw_raw NYI')

         CASE (LHS_box_RHS_box)

            IF (ASSOCIATED(RHS_local%box_paras)) CALL fmm_quit('RHS_local')
            level = RHS_all%box_paras(1)%level
            ndim = map_at_level(level)%box_list(id)%occ
            IF (ndim == 0) RETURN
            ALLOCATE (RHS_local%box_paras(ndim))

            ptr => map_at_level(level)%box_list(id)%head
            i = 0
            DO ! over linked-list of local boxes
               i = i+1
               RHS_local%box_paras(i) = RHS_all%box_paras(ptr%id)
               IF (.NOT.ASSOCIATED(ptr%next)) EXIT
               ptr => ptr%next
            END DO

         CASE DEFAULT
            CALL fmm_quit ('local_paras: requested T_pair type!')
      END SELECT

   END SUBROUTINE fmm_get_local_paras

!-------------------------------------------------------------------------------

END MODULE fmm_local_search

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE FBLOCK(FIFA,NO,NI,NA,NS,FIT,FTI,FIA,FAI,FTA,FAT)
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
      INTEGER NO,NI,NA,NS
      REAL*8 FIFA((NO*(NO+1))/2)
      REAL*8 FIT(NI,NA),FIA(NI,NS),FTA(NA,NS)
      REAL*8 FTI(NA,NI),FAI(NS,NI),FAT(NS,NA)

      INTEGER IT,II,IA,ITTOT,IATOT,ITI,IAI,IAT

C Extract three rectangular submatrices FIT, FIA and FTA from the
C triangular matrix FIFA.
C SVC: add transposed submatrices to avoid complicated strides in the
C low-level sgm subroutines

      DO IT=1,NA
        ITTOT=NI+IT
        DO II=1,NI
          ITI=(ITTOT*(ITTOT-1))/2+II
          FIT(II,IT)=FIFA(ITI)
          FTI(IT,II)=FIFA(ITI)
        END DO
      END DO
      DO IA=1,NS
        IATOT=NI+NA+IA
        DO II=1,NI
          IAI=(IATOT*(IATOT-1))/2+II
          FIA(II,IA)=FIFA(IAI)
          FAI(IA,II)=FIFA(IAI)
        END DO
      END DO
      DO IA=1,NS
        IATOT=NI+NA+IA
        DO IT=1,NA
          ITTOT=NI+IT
          IAT=(IATOT*(IATOT-1))/2+ITTOT
          FTA(IT,IA)=FIFA(IAT)
          FAT(IA,IT)=FIFA(IAT)
        END DO
      END DO

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SIGMADET_CVB(C,HC,IREFSM,PERMS2,NCI)
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL PERMS2
#include "WrkSpc.fh"
#include "rasscf_lucia.fh"
      DIMENSION C(NCI),HC(NCI)
      DIMENSION DUMMY(1)
C
C Export arguments to be used in sigma_master_cvb
C
      C_POINTER = KCI_POINTER
      CALL DCOPY_(NCI,C,1,WORK(C_POINTER),1)
C Call the sigma routine
      CALL LUCIA_UTIL('SIGMA_CVB',IREFSM,IDUMMY,DUMMY)
      CALL DCOPY_(NCI,WORK(KSIGMA_POINTER),1,HC,1)
C
      RETURN
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(PERMS2)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine add42 (a,b,q,dimq,dimpq,dimr,fact)

c     this routine do:
c     B(pq,r) <-- fact * A(p,r) for given q
c
#include "ccsd1.fh"
       integer dimq,dimpq,dimr,q
       real*8 fact
       real*8 b(1:dimpq,1:dimr)
       real*8 a(1:dimq,1:dimr)
c
c     help variable
c
       integer pq,qp,r,p
c
       if (q.eq.1) goto 101
c
       do 100 r=1,dimr
       qp=nshf(q)
c
       do 50 p=1,q-1
       qp=qp+1
       b(qp,r)=b(qp,r)-fact*a(p,r)
 50     continue
c
 100    continue
c
 101    if (q.eq.dimq) then
       return
       end if
c
       do 200 r=1,dimr
c
       do 150 p=q+1,dimq
       pq=nshf(p)+q
       b(pq,r)=b(pq,r)+fact*a(p,r)
 150    continue
c
 200    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine output5 (dkhscfflg,unit,sused,ttimes,sorder,t,tscrchar,
     *                    ttimestot)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 18.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer unit,sused,ttimes(maxsnumber),sorder(maxsnumber,3),
     *        ttimestot
      character*(4) t(maxsnumber)
      character*(11) tscrchar(maxsnumber)
      integer j,idum
c
      idum=0
      do 25 j=1,sused
        if (ttimes(j).gt.0) then
          idum=idum+1
          if (dkhscfflg) then
            write (unit,1081) idum,tscrchar(j),t(j),sorder(j,3),
     *                        ttimes(j)
1081        format (3X,I3,5X,A11,6X,A4,5X,I2,7X,I5)
          else
            write (unit,1083) idum,tscrchar(j),t(j),sorder(j,1),
     *                        sorder(j,2),sorder(j,3),ttimes(j)
1083        format (3X,I3,5X,A11,6X,A4,5X,I2,4X,I2,4X,I2,4X,I7)
          endif
        endif
  25  continue
c
      if (dkhscfflg) then
        write (unit,1091) ttimestot
1091    format (44X,7('-'),/44X,I7,/2X)
      else
        write (unit,1092) ttimestot
1092    format (54X,8('-'),/54X,I8,/2X)
      endif
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine ortelim_cvb(trprm,iorts,irots,sorbs,
     >  nc,npr1,norbprm,nrem)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension trprm(npr1,npr1),iorts(2,nort),irots(2,ndrot)
      dimension sorbs(norb,norb)
      dimension dum(1)

      i1 = mstackrz_cvb(norbprm*max(nc+nort+ndrot,norbprm))
      i1ff=i1-1
      do 100 i=1,nc
      call fmove_cvb(trprm(1,i),work(1+(i-1)*norbprm+i1ff),norbprm)
100   continue
      do 200 iort=1,nort
      iorb=iorts(1,iort)
      jorb=iorts(2,iort)
      do 201 korb=1,norb
      ki=korb+(iorb-1)*(norb-1)
      if(korb.gt.iorb)ki=ki-1
      kj=korb+(jorb-1)*(norb-1)
      if(korb.gt.jorb)kj=kj-1
      if(korb.ne.iorb)work(ki+(iort+nc-1)*norbprm+i1ff)=sorbs(korb,jorb)
      if(korb.ne.jorb)work(kj+(iort+nc-1)*norbprm+i1ff)=sorbs(korb,iorb)
201   continue
200   continue
      do 300 irot=1,ndrot
      iorb=irots(1,irot)
      jorb=irots(2,irot)
      do 301 korb=1,norb
      ki=korb+(iorb-1)*(norb-1)
      if(korb.gt.iorb)ki=ki-1
      kj=korb+(jorb-1)*(norb-1)
      if(korb.gt.jorb)kj=kj-1
      if(korb.ne.iorb)work(ki+(irot+nc+nort-1)*norbprm+i1ff)=
     >  sorbs(korb,jorb)
      if(korb.ne.jorb)work(kj+(irot+nc+nort-1)*norbprm+i1ff)=
     >  -sorbs(korb,iorb)
301   continue
300   continue
      call span_cvb(work(i1),nc+nort+ndrot,nrem,dum,norbprm,0)
      call compl_cvb(work(i1),nrem,norbprm)

      call fzero(trprm,npr1*npr1)
      do 400 i=1,norbprm
      call fmove_cvb(work(1+(i-1)*norbprm+i1ff),trprm(1,i),norbprm)
400   continue

      call mfreer_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine basis2run()

use Basis_Info, only: dbsc, iCnttp_Dummy, nCnttp, Shells
use Center_Info, only: dc
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iAng, iAtoms, iBasis, icnt, iCnttp, iCo, index_center, iPrim, iShSrt, iyy, jSh, kExp, mdc, nPrim
integer(kind=iwp), allocatable :: IndC(:), primitive_ids(:,:)
real(kind=wp), allocatable :: primitives(:,:)

iAtoms = 0
!***********************************************************************
! Generate list of primitive basis functions
!
! Loop over distinct shell types
nPrim = 0
! Loop over basis sets
do iCnttp=1,nCnttp
  if (iCnttp == iCnttp_Dummy) cycle
  if (dbsc(iCnttp)%iVal == 0) cycle
  mdc = dbsc(iCnttp)%mdci
  iShSrt = dbsc(iCnttp)%iVal
  ! Loop over distinct centers
  do icnt=1,dbsc(iCnttp)%nCntr
    mdc = mdc+1
    ! Loop over symmetry-related centers
    do iCo=0,nIrrep/dc(mdc)%nStab-1
      ! Loop over shells associated with this center
      ! Start with s type shells
      jSh = iShSrt
      if (Shells(jSh)%Aux .or. Shells(jSh)%Frag) cycle
      do iAng=0,dbsc(iCnttp)%nVal-1
        nPrim = nPrim+Shells(jSh)%nExp*Shells(jSh)%nBasis
        jSh = jSh+1
      end do
    end do
  end do
end do

call put_iScalar('nPrim',nPrim)

call mma_allocate(IndC,2*S%mCentr,label='IndC')
call mma_allocate(primitive_ids,3,nPrim,label='primitive_ids')
call mma_allocate(primitives,2,nPrim,label='primitives')

! Loop over distinct shell types
iPrim = 0
! Loop over basis sets
do iCnttp=1,nCnttp
  if (iCnttp == iCnttp_Dummy) cycle
  if (dbsc(iCnttp)%iVal == 0) cycle
  mdc = dbsc(iCnttp)%mdci
  iShSrt = dbsc(iCnttp)%iVal
  ! Loop over distinct centers
  do icnt=1,dbsc(iCnttp)%nCntr
    mdc = mdc+1
    ! Loop over symmetry-related centers
    do iCo=0,nIrrep/dc(mdc)%nStab-1
      ! Loop over shells associated with this center
      ! Start with s type shells
      jSh = iShSrt
      if (Shells(jSh)%Aux .or. ShellS(jSh)%Frag) cycle
      ! Get the flat, desymmetrized id of the center
      iyy = Index_Center(mdc,iCo,IndC,iAtoms,S%mCentr)
      do iAng=0,dbsc(iCnttp)%nVal-1
        ! Pointer to the untouched contraction matrix as after input.
        do iBasis=1,Shells(jSh)%nBasis
          do kExp=1,Shells(jSh)%nExp
            iPrim = iPrim+1
            primitive_ids(1,iPrim) = iyy
            primitive_ids(2,iPrim) = iAng
            primitive_ids(3,iPrim) = iBasis
            primitives(1,iPrim) = Shells(jSh)%Exp(kExp)
            primitives(2,iPrim) = Shells(jSh)%Cff_c(kExp,iBasis,2)
          end do
        end do
        jSh = jSh+1
      end do
    end do
  end do

end do

call put_iArray('primitive ids',primitive_ids,3*nPrim)
call put_dArray('primitives',primitives,2*nPrim)

call mma_deallocate(primitive_ids)
call mma_deallocate(primitives)
call mma_deallocate(IndC)

return

end subroutine basis2run

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Markus P. Fuelscher                              *
*               1991, Per Ake Malmqvist                                *
*               1998, Roland Lindh                                     *
************************************************************************
      Subroutine SaveBin(iBin,iOpt)
************************************************************************
*                                                                      *
*     Purpose: Phase 1 of the bin sorting algorithm                    *
*             Once a bin is filled it has to be dumped to disk.        *
*             First, however, we like to sort and pack the buffers.    *
*             A further complication arises due to the fact that a     *
*             bin is shorter than the records as used in the wave-     *
*             function codes.                                          *
*                                                                      *
*     Called from: SORT1A and SORT1B                                   *
*                                                                      *
*     Calls to : PKI4,PKR8,DaFile,SetVec,ErrTra,ISORTX,I4Len,R8Len     *
*                                                                      *
*     Calling Parameters:                                              *
*     iBin   : Bin number to be saved                                  *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDef  : definitions of the record structure                    *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*     Srt1    : common block containing information the number of      *
*               bins and partitioning of symmetry blocks               *
*     Srt2    : common block containing information pertinent to       *
*               the bin sorting algorithm                              *
*     WSpc    : dynamic work space                                     *
*                                                                      *
*     local data declarations:                                         *
*     IndBin : temporary array which contains the packed labels        *
*     IndBin : temporary array which contains the packed 2el integrals *
*     lIndx  : temporary array used to store the length                *
*              of the packed indices                                   *
*     lInts  : temporary array used to store the length                *
*              of the packed integral                                  *
*     Scr    : temporary array used for initializing records           *
*                                                                      *
*     Modified to remove sorting step, R. Lindh, March '98             *
*                                                                      *
**** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****
*
      use srt2
      Implicit Real*8 (A-H,O-Z)
*
#include "TwoDat.fh"
#include "srt0.fh"
#include "srt1.fh"

#include "SysDef.fh"
#include "PkCtl.fh"

      Integer iScr(lStRec)
      Real*8   Scr(lStRec)
      Integer rc
*
*----------------------------------------------------------------------*
*     Turn timing ON                                                   *
*----------------------------------------------------------------------*
*
*
*----------------------------------------------------------------------*
*         as the packed integral labels add an extra 1-2 Byte          *
*         disk space per integral we have to adjust the record         *
*         length of LuTmp to the different machines.                   *
*----------------------------------------------------------------------*
      idiv = ItoB/2
      If ( Pack ) idiv = idiv/2
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      nInts=nInt(iBin)
*----------------------------------------------------------------------*
*         precompute the packed length of a record                     *
*----------------------------------------------------------------------*
      Call I4LEN(nInts,lwIBin(1,iBin),lIndx)
      Call R8LEN(iOpt,nInts,lwVBin(1,iBin),lInts)
      mxIRec=((lDaRec/idiv)-lTop-1)*ItoB
      mxVRec=(lDaRec-lTop-1)*RtoB
      nSave=0
      lIRec=0
      lVRec=0
      Do iSave=1,nInts
         lIRec=lIRec+lIndx(iSave)
         lVRec=lVRec+lInts(iSave)
         If ( lIRec.lt.mxIRec .and. lVRec.lt.mxVRec ) nSave=iSave
      End Do
      lIRec=0
      lVRec=0
      Do iSave=1,nSave
         lIRec=lIRec+lIndx(iSave)
         lVRec=lVRec+lInts(iSave)
      End Do
*----------------------------------------------------------------------*
*         now pack and check the packed record length again            *
*----------------------------------------------------------------------*
      Call PKI4(nSave,lIBin,lwIBin(1,iBin),IndBin(lTop+1))
      mInds=(lIBin+ItoB-1)/ItoB
      mInt(3,iBin)=mInt(3,iBin)+mInds
      If ( lIBin.gt.mxIRec ) then
         rc=001
         Write(6,*)
         Write(6,'(2X,A,I3.3,A)')
     &   '*** Error in SAVEBIN ***'
         Write(6,'(2X,A)') 'An inconsistency has been deteced'
         Write(6,'(2X,A)') 'lIRec > mxIRec '
         Write(6,*)
         Call xFlush(6)
         Call Abend
      End If
      If ( lIBin.ne.lIRec ) then
         rc=002
         Write(6,*)
         Write(6,'(2X,A,I3.3,A)')
     &   '*** Error in SAVEBIN ***'
         Write(6,'(2X,A)') 'An inconsistency has been deteced'
         Write(6,'(2X,A)') 'lIBin # lIRec'
         Write(6,*)
         call xFlush(6)
         Call Abend
      End If
      Call PKR8(iOpt,nSave,lVBin,lwVBin(1,iBin),ValBin(lTop+1))
      mInts=(lVBin+RtoB-1)/RtoB
      mInt(2,iBin)=mInt(2,iBin)+mInts
      If ( lVBin.gt.mxVRec ) then
         rc=003
         Write(6,*)
         Write(6,'(2X,A,I3.3,A)')
     &   '*** Error in SAVEBIN ***'
         Write(6,'(2X,A)') 'An inconsistency has been deteced'
         Write(6,'(2X,A)') 'lVRec > mxVRec '
         Write(6,*)
         Call xFlush(6)
         Call Abend
      End If
      If ( lVBin.ne.lVRec ) then
         rc=004
         Write(6,*)
         Write(6,'(2X,A,I3.3,A)')
     &   '*** Error in SAVEBIN ***'
         Write(6,'(2X,A)') 'An inconsistency has been deteced'
         Write(6,'(2X,A)') 'lVBin # lVRec'
         Write(6,*)
         call xFlush(6)
         Call Abend()
      End If
*----------------------------------------------------------------------*
*     write the record header                                          *
*----------------------------------------------------------------------*
      IndBin(1)=iDIBin(2,iBin)
      IndBin(2)=lIBin+lTop*ItoB
      IndBin(3)=nSave
      ValBin(1)=iDVBin(2,iBin)
      ValBin(2)=lVBin+lTop*RtoB
      ValBin(3)=nSave
*----------------------------------------------------------------------*
*     save the record on disk                                          *
*----------------------------------------------------------------------*
      iDaTmp=iDIBin(1,iBin)
      iDaTwo=iDVBin(1,iBin)
      iOptIO=1
*
*     If a new sector mark it on the disk to make sure that it is
*     continuous.
*
      If ( mod(nRec(iBin),nSect).eq.0 ) then
         iDaTmp=mDaTmp
         iDaTwo=mDaTwo
         Zero=0.0d0
*
         Call ICopy(lStRec,[0],0,iScr,1)
         Call iDAFILE(LuTmp,iOptIO,iScr,(lStRec/idiv),mDaTmp)
*
         call dcopy_(lStRec,[Zero],0,Scr,1)
         Call dDAFILE(LuTwo,iOptIO,Scr,lStRec,mDaTwo)
*
         iDIBin(2,iBin)=iDaTmp
         iDVBin(2,iBin)=iDaTwo
         If ( iDVBin(3,iBin).lt.0 ) iDVBin(3,iBin)=iDaTwo
      End If
*
      Call iDAFILE(LuTmp,iOptIO,IndBin,(lDaRec/idiv),iDaTmp)
      iDIBin(1,iBin)=iDaTmp
      Call dDAFILE(LuTwo,iOptIO,ValBin,lDaRec,iDaTwo)
      iDVBin(1,iBin)=iDaTwo
      nRec(iBin)=nRec(iBin)+1
*----------------------------------------------------------------------*
*         cleanup                                                      *
*----------------------------------------------------------------------*
      nKeep=nInts-nSave
      If ( nKeep.gt.0 ) Then
         Do i=1,nKeep
            lwIBin(i,iBin)=lwIBin(nSave+i,iBin)
            lwVBin(i,iBin)=lwVBin(nSave+i,iBin)
         End Do
      End If
      nInt(iBin)=nKeep
*
*----------------------------------------------------------------------*
*     Turn timing OFF and exit                                         *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mkcifree2_cvb(cvb,ifxstr,tconstr)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension cvb(nvb),ifxstr(nfxvb),tconstr(nvb,nvb)

      if(strucopt)then
        nfrvb=nvb
      else
        nfrvb=0
      endif
      nfr=nfrorb+nfrvb
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real_array(cvb)
        call Unused_integer_array(ifxstr)
        call Unused_real_array(tconstr)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Exp_Schur
!
!> @brief Compute the exponential of an antisymmetric matrix
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Computes the exponential of an antisymmetric real matrix \f$ X \f$ through its Schur decomposition.
!> The exponential of \f$ X \f$ is an orthogonal matrix.
!> The Schur form of \f$ X \f$ is antisymmetric real, block-diagonal, with \f$ 2\times 2\f$ or \f$ 1\times 1\f$ diagonal blocks.
!> If \f$ X = Z T Z^T \f$, then \f$ \exp(X) = Z \exp(T) Z^T \f$, and \f$ exp(T) \f$ is trivial to compute since each block can
!> be treated separately: \f$ (0, \lambda) \to (\cos(\lambda), \pm\sin(\lambda) \f$.
!>
!> @param[in]     N        Size of the square matrix
!> @param[in,out] X        Antisymmetric real matrix, it is replaced by its exponential
!> @param[out]    maxtheta Maximum rotation angle (absolute value in the Schur form)
!***********************************************************************

subroutine Exp_Schur(N,X,maxtheta)

!define _USE_LAPACK_
#ifdef _USE_LAPACK_
use sorting_funcs, only: geq_r
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(inout) :: X(N,N)
integer(kind=iwp) :: i, info
real(kind=wp) :: c, maxtheta, s, theta
real(kind=wp), allocatable :: tmp(:,:), vs(:,:), work(:)
#ifdef _USE_LAPACK_
integer(kind=iwp) :: j, lwork, sdim
real(kind=wp) :: dwrk(1)
logical(kind=iwp) :: bwork(1), pair
real(kind=wp), allocatable :: wri(:,:)
#endif
real(kind=wp), parameter :: thrs = epsilon(thrs)

maxtheta = Zero
if (N < 1) return

#ifdef _USE_LAPACK_

! Ensure the matrix is antisymmetric
do i=1,N
  do j=i+1,N
    X(i,j) = -X(j,i)
  end do
end do

call mma_allocate(wri,N,2,label='wri')
call mma_allocate(vs,N,N,label='vs')

! Schur factorization of X: X = Z T Z^T, exp(X) = Z exp(T) Z^T
! (this, unfortunately, does not take advantage of the antisymmetry)
lwork = -1
call dgees_('V','N',geq_r,N,X,N,sdim,wri(:,1),wri(:,2),vs,N,dwrk,lwork,bwork,info)
lwork = int(dwrk(1),kind=iwp)
call mma_allocate(work,lwork,label='work')
call dgees_('V','N',geq_r,N,X,N,sdim,wri(:,1),wri(:,2),vs,N,work,lwork,bwork,info)
call mma_deallocate(work)
call mma_deallocate(wri)

if (info /= 0) call abend()

call mma_allocate(tmp,N,N,label='tmp')

! Compute tmp = Z exp(T)
!
! tmp will contain diagonal blocks that are either 0, and exp(0) = 1
! or of the form  C = [ 0 x], and exp(C) = [ cos(x) sin(x)]
!                     [-x 0]               [-sin(x) cos(x)]
i = 1
do while (i <= N)
  if (i == N) then
    pair = .false.
  else
    pair = abs(X(i+1,i)) > thrs
  end if
  if (pair) then
    theta = sign(sqrt(-X(i+1,i)*X(i,i+1)),X(i,i+1))
    maxtheta = max(maxtheta, abs(theta))
    c = cos(theta)
    s = sin(theta)
    tmp(:,i) = c*vs(:,i)-s*vs(:,i+1)
    tmp(:,i+1) = s*vs(:,i)+c*vs(:,i+1)
    i = i+2
  else
    tmp(:,i) = vs(:,i)
    i = i+1
  end if
end do

! Compute exp(X) = tmp Z^T
call dgemm_('N','T',N,N,N,One,tmp,N,vs,N,Zero,X,N)

call mma_deallocate(tmp)
call mma_deallocate(vs)

#else

call mma_allocate(work,N,label='work')
call mma_allocate(vs,N,N,label='vs')

! Since dgemm does not work in-place, and we want
! the result in-place, there must be a copy at some point
vs(:,:) = X
call schur_skew(N,vs,work,info)
if (info /= 0) call abend()

call mma_allocate(tmp,N,N,label='tmp')

i = 1
do while (i <= N)
  theta = work(i)
  if ((i < N) .and. (abs(theta) > thrs)) then
    maxtheta = max(maxtheta, abs(theta))
    c = cos(theta)
    s = sin(theta)
    tmp(:,i) = c*vs(:,i)-s*vs(:,i+1)
    tmp(:,i+1) = s*vs(:,i)+c*vs(:,i+1)
    i = i+2
  else
    tmp(:,i) = vs(:,i)
    i = i+1
  end if
end do

call mma_deallocate(work)

! Compute exp(X) = tmp Z^T
call dgemm_('N','T',N,N,N,One,tmp,N,vs,N,Zero,X,N)

call mma_deallocate(vs)
call mma_deallocate(tmp)

#endif

end subroutine Exp_Schur

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2005  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE EQCTL2(ICONV)
      IMPLICIT REAL*8 (A-H,O-Z)
C On return, the following data sets will be defined and stored
C on LUSOLV.
C At position IVEC=IRHS, the RHS array, in SR representation.
C At position IVEC=IVECX, the solution array, in SR representation.
C At position IVEC=IVECR, the residual array, in SR representation.
C At position IVEC=IVECC, the solution array, in contravariant rep.
C At position IVEC=IVECC2, the solution array, in covariant repr.
C At position IVEC=IVECW, the RHS array, in contravariant repr.
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "chocaspt2.fh"


      IF (IPRGLB.GE.VERBOSE) THEN
        WRITE(6,'(1X,A)')
        WRITE(6,'(1X,A)') 'Computing the S/B matrices'
        WRITE(6,'(1X,A)') '--------------------------'
      END IF

C Compute S and (possibly) B matrices and write them on LUSBT
C this uses previously stored data on LUSOLV!!
CPAM98      IF(SMATRIX.NE.'NO      ')CALL SBMAT
      CALL GASync
      CALL TIMING(CPU0,CPU,TIO0,TIO)
* PAM14 Necessary to reset NINDEP to conservative estimate. It gets its
* final value after SBDIAG call, but must have its original value when
* calling MKSMAT and MKBMAT.
      DO ICASE=1,13
       DO ISYM=1,NSYM
        NINDEP(ISYM,ICASE)=NASUP(ISYM,ICASE)
        IF(NISUP(ISYM,ICASE).EQ.0) NINDEP(ISYM,ICASE)=0
       END DO
      END DO
      IF(SMATRIX.NE.'NO      ') THEN
        CALL MKSMAT
        CALL MKBMAT
      END IF
C Modify B matrices, if necessary:
      IF(HZERO.EQ.'CUSTOM') THEN
        CALL NEWB
      END IF
      CALL GASync
      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUSBM=CPU1-CPU0
      TIOSBM=TIO1-TIO0

C Linear dependence removal, ON transformation of S matrix,
C and spectral resolution of H0:
      CALL GASync
      CALL TIMING(CPU0,CPU,TIO0,TIO)
      IF(SDECOM.NE.'NO      ') THEN
        CALL SBDIAG
      END IF
      CALL GASync
      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUEIG=CPU1-CPU0
      TIOEIG=TIO1-TIO0
C The transformation matrices have now been computed and
C written at disk addresses given by IDTMAT().
C The B matrices were destroyed here. In their place,
C at the IDBMAT() addresses, we find two sets of diagonal
C energy values. Each consists of: first the energies of
C the active combination, which are eigenvalues of the
C B matrix using overlap S; then the energies of the
C non-active combinations. Usually, only the first set of
C energies is used. The second is used, in a manner specific
C to future modifications, for additional energy parameters
C of more sophisticated H0 or resolvent definitions.
C Modif PAM 961022: If BMATRIX='YES     ', diagonal energies
C are put at IDBMAT(). If BTRANS='YES     ', these are the
C diagonal values of B after transformation to ON basis.
C If furthermore BSPECT='YES     ', the ON basis consists
C of eigenvectors. This is the usual CASPT2 situation.
C However, if only BMATRIX is 'YES     ', then the values
C are the diagonal values of B divided by diagonal values
C of S.

      CALL GASync
      CALL TIMING(CPU0,CPU,TIO0,TIO)
C Non-active part of diagonal elements of H0 are computed
C and written to LUSBT:
      CALL NADIAG
C Modify diagonal elements, if requested:
      IF(HZERO.EQ.'CUSTOM') THEN
        CALL NEWDIA
      END IF
C A second set of energy parameters may now have been
C computed and written to LUSBT.
      CALL GASync
      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUNAD=CPU1-CPU0
      TIONAD=TIO1-TIO0

      IF (IPRGLB.GE.VERBOSE) THEN
        WRITE(6,'(1X,A)')
        WRITE(6,'(1X,A)') 'Computing the right-hand side (RHS) elements'
        WRITE(6,'(1X,A)') '--------------------------------------------'
      END IF

      IRHS  =1
      IVECX =2
      IVECR =3
      IVECC =4
      IVECC2=5
      IVECW =6

      CALL GASync
      CALL TIMING(CPU0,CPU,TIO0,TIO)
C-SVC: initialize the RHS array offsets
      CALL RHS_INIT
C at this point LUSOLV is not used as a temporary disk anymore, so it's
C safe to initialize it (safe to write zeros to LUSOLV or delete it)

C Set up right-hand side matrix elements.
      IF(IfChol .AND. iALGO.eq.1) THEN
        IF (RHSDIRECT) THEN
          IF (NSYM.EQ.1) THEN
            CALL RHSOD_NOSYM(IVECW)
          ELSE
            CALL RHSOD(IVECW)
          END IF
        ELSE
          CALL RHS_ZERO(IVECW)
          CALL RHSALL2(IVECW)
        END IF
      ELSE
        CALL MKRHS(IVECW)
      END IF
      CALL GASync
      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPURHS=CPU1-CPU0
      TIORHS=TIO1-TIO0

      IF (IPRGLB.GE.INSANE) THEN
        WRITE(6,'("DEBUG> ")')
        WRITE(6,'("DEBUG> ",A)')
     &   'Norms of the RHS blocks:'
        CALL RHS_FPRINT('C',IVECW)
      END IF

C-SVC: start PCG routine, set timers.
      CALL GASync
      CALL TIMING(CPU0,CPU,TIO0,TIO)
      CPUSCA=0
      CPULCS=0
      CPUOVL=0
      CPUSGM=0
      CPUVEC=0

C Transform RHS of CASPT2 equations to eigenbasis for H0:
      CALL PTRTOSR(1,IVECW,IRHS)

      IF (IPRGLB.GE.INSANE) THEN
        WRITE(6,'("DEBUG> ")')
        WRITE(6,'("DEBUG> ",A)')
     &   'Norms of the RHS blocks (H0 eigenbasis):'
        CALL RHS_FPRINT('SR',IRHS)
      END IF

      CALL PCG(ICONV)

      IF (ICONV .NE. 0) GOTO 100
      CALL PTRTOC(0,IVECX,IVECC)
      CALL PTRTOC(1,IVECX,IVECC2)

C-SVC: end of PCG routine, compute total time.
      CALL GASync
      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUPCG=CPU1-CPU0
      TIOPCG=TIO1-TIO0

C-SVC: collect and print information on coefficients/denominators
      IF(IPRGLB.GE.USUAL) THEN
        CALL H0SPCT
      END IF

      CALL GASync
      CALL TIMING(CPU0,CPU,TIO0,TIO)
      CALL GASync
      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUSER=CPU1-CPU0
      TIOSER=TIO1-TIO0

  100 CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine CmbnS1(Rnxyz,nZeta,la,lb,Zeta,rKappa,rFinal,Alpha,Beta,Grad,nGrad,DAO,IfGrad,IndGrd,iStab,jStab,kOp)
!***********************************************************************
!                                                                      *
! Object: compute the gradient of the overlap matrix.                  *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91.                                             *
!***********************************************************************

use Symmetry_Info, only: iChBas, nIrrep
use Index_Functions, only: C_Ind
use Constants, only: Two, Three
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nGrad, IndGrd(3,2), iStab, jStab, kOp(2)
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la+1,0:lb+1), Zeta(nZeta), Alpha(nZeta), Beta(nZeta), &
                             DAO(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2)
real(kind=wp), intent(inout) :: rKappa(nZeta), Grad(nGrad)
real(kind=wp), intent(out) :: rFinal(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6)
logical(kind=iwp), intent(in) :: IfGrad(3,2)
integer(kind=iwp) :: i1, i2, iCar, iCn, iGrad, ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyaMax, iyb, iybMax, iza, izb, iZeta, nDAO
real(kind=wp) :: Fact, ps, xa, xb, ya, yb, za, zb
real(kind=wp), parameter :: exp32 = -Three/Two
integer(kind=iwp), external :: iPrmt
real(kind=r8), external :: DDot_
#include "print.fh"
#include "nac.fh"

iRout = 134
iPrint = nPrint(iRout)

!ii = la*(la+1)*(la+2)/6
!jj = lb*(lb+1)*(lb+2)/6
do iZeta=1,nZeta
  rKappa(iZeta) = rKappa(iZeta)*Zeta(iZeta)**exp32
end do
if (iPrint >= 99) then
  call RecPrt(' In CmbnS1: Zeta  ',' ',Zeta,1,nZeta)
  call RecPrt(' In CmbnS1: rKappa',' ',rKappa,1,nZeta)
  call RecPrt(' In CmbnS1: Alpha ',' ',Alpha,1,nZeta)
  call RecPrt(' In CmbnS1: Beta  ',' ',Beta,1,nZeta)
end if
do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      !iChBs = iChBas(ii+ipa)
      !pa = real(iPrmt(kOp(1),iChBs),kind=wp)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)
        !jChBs = iChBas(jj+ipb)
        !papb = real(iPrmt(kOp(2),jChBs),kind=wp)*pa

        ! Combine overlap integrals

        !write(u6,*) ' papb=', papb
        if (IfGrad(1,1)) then
          if (ixa > 0) then
            xa = real(-ixa,kind=wp)
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,1) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,1) = rKappa(iZeta)* &
                      (Two*Alpha(iZeta)*Rnxyz(iZeta,1,ixa+1,ixb)+ &
                                     xa*Rnxyz(iZeta,1,ixa-1,ixb))* &
                                        Rnxyz(iZeta,2,iya,iyb)* &
                                        Rnxyz(iZeta,3,iza,izb)
            end do
          else
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,1) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,1) = rKappa(iZeta)* &
                       Two*Alpha(iZeta)*Rnxyz(iZeta,1,ixa+1,ixb)* &
                                        Rnxyz(iZeta,2,iya,iyb)* &
                                        Rnxyz(iZeta,3,iza,izb)
            end do
          end if
        end if
        if (IfGrad(1,2)) then
          if (ixb > 0) then
            xb = real(-ixb,kind=wp)
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,4) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,4) = rKappa(iZeta)* &
                       (Two*Beta(iZeta)*Rnxyz(iZeta,1,ixa,ixb+1)+ &
                                     xb*Rnxyz(iZeta,1,ixa,ixb-1))* &
                                        Rnxyz(iZeta,2,iya,iyb)* &
                                        Rnxyz(iZeta,3,iza,izb)
            end do
          else
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,4) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,4) = rKappa(iZeta)* &
                        Two*Beta(iZeta)*Rnxyz(iZeta,1,ixa,ixb+1)* &
                                        Rnxyz(iZeta,2,iya,iyb)* &
                                        Rnxyz(iZeta,3,iza,izb)
            end do
          end if
        end if
        if (IfGrad(2,1)) then
          if (iya > 0) then
            ya = real(-iya,kind=wp)
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,2) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,2) = rKappa(iZeta)* &
                                        Rnxyz(iZeta,1,ixa,ixb)* &
                      (Two*Alpha(iZeta)*Rnxyz(iZeta,2,iya+1,iyb)+ &
                                     ya*Rnxyz(iZeta,2,iya-1,iyb))* &
                                        Rnxyz(iZeta,3,iza,izb)
            end do
          else
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,2) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,2) = rKappa(iZeta)* &
                                        Rnxyz(iZeta,1,ixa,ixb)* &
                       Two*Alpha(iZeta)*Rnxyz(iZeta,2,iya+1,iyb)* &
                                        Rnxyz(iZeta,3,iza,izb)
            end do
          end if
        end if
        if (IfGrad(2,2)) then
          if (iyb > 0) then
            yb = real(-iyb,kind=wp)
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,5) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,5) = rKappa(iZeta)* &
                                        Rnxyz(iZeta,1,ixa,ixb)* &
                       (Two*Beta(iZeta)*Rnxyz(iZeta,2,iya,iyb+1)+ &
                                     yb*Rnxyz(iZeta,2,iya,iyb-1))* &
                                        Rnxyz(iZeta,3,iza,izb)
            end do
          else
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,5) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,5) = rKappa(iZeta)* &
                                        Rnxyz(iZeta,1,ixa,ixb)* &
                        Two*Beta(iZeta)*Rnxyz(iZeta,2,iya,iyb+1)* &
                                        Rnxyz(iZeta,3,iza,izb)
            end do
          end if
        end if
        if (IfGrad(3,1)) then
          if (iza > 0) then
            za = real(-iza,kind=wp)
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,3) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,3) = rKappa(iZeta)* &
                                        Rnxyz(iZeta,1,ixa,ixb)* &
                                        Rnxyz(iZeta,2,iya,iyb)* &
                      (Two*Alpha(iZeta)*Rnxyz(iZeta,3,iza+1,izb)+ &
                                     za*Rnxyz(iZeta,3,iza-1,izb))
            end do
          else
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,3) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,3) = rKappa(iZeta)* &
                                        Rnxyz(iZeta,1,ixa,ixb)* &
                                        Rnxyz(iZeta,2,iya,iyb)* &
                       Two*Alpha(iZeta)*Rnxyz(iZeta,3,iza+1,izb)
            end do
          end if
        end if
        if (IfGrad(3,2)) then
          if (izb > 0) then
            zb = real(-izb,kind=wp)
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,6) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,6) = rKappa(iZeta)* &
                                        Rnxyz(iZeta,1,ixa,ixb)* &
                                        Rnxyz(iZeta,2,iya,iyb)* &
                       (Two*Beta(iZeta)*Rnxyz(iZeta,3,iza,izb+1)+ &
                                     zb*Rnxyz(iZeta,3,iza,izb-1))
            end do
          else
            do iZeta=1,nZeta
              !rFinal(iZeta,ipa,ipb,6) = papb*rKappa(iZeta)* &
              rFinal(iZeta,ipa,ipb,6) = rKappa(iZeta)* &
                                        Rnxyz(iZeta,1,ixa,ixb)* &
                                        Rnxyz(iZeta,2,iya,iyb)* &
                        Two*Beta(iZeta)*Rnxyz(iZeta,3,iza,izb+1)
            end do
          end if
        end if

      end do
    end do
  end do
end do

! Trace the gradient integrals

nDAO = nZeta*(la+1)*(la+2)/2*(lb+1)*(lb+2)/2
if (iPrint >= 99) then
  call RecPrt(' S(1)',' ',rFinal,nDAO,6)
  call RecPrt('   D ',' ',DAO,nDAO,1)
end if
do iCn=1,2
  do iCar=1,3
    if (IndGrd(iCar,iCn) /= 0) then
      ! Accumulate contribution to the gradient
      iGrad = abs(IndGrd(iCar,iCn))
      if (iCn == 1) then
        i1 = iCar
        i2 = iCar+3
        ps = real(iPrmt(kOp(1),iChBas(1+iCar)),kind=wp)
        Fact = real(iStab,kind=wp)/real(nIrrep,kind=wp)
      else
        i1 = iCar+3
        i2 = iCar
        ps = real(iPrmt(kOp(2),iChBas(1+iCar)),kind=wp)
        Fact = ps*real(jStab,kind=wp)/real(nIrrep,kind=wp)
      end if
      !write(u6,*) ' Fact=',Fact,ps
      if (IndGrd(iCar,iCn) < 0) then
        if (isCSF) then
          ! The CSF NADC component is not translation invariant,
          ! in fact, it is based on an antisymmetric matrix, so a + sign is needed here
          Grad(iGrad) = Grad(iGrad)+Fact*DDot_(nDAO,DAO,1,rFinal(1,1,1,i2),1)
        else
          ! Gradient via translational invariance.
          Grad(iGrad) = Grad(iGrad)-Fact*DDot_(nDAO,DAO,1,rFinal(1,1,1,i2),1)
        end if
      else
        Grad(iGrad) = Grad(iGrad)+Fact*DDot_(nDAO,DAO,1,rFinal(1,1,1,i1),1)
      end if
    end if
  end do
end do

return

end subroutine CmbnS1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Jeppe Olsen                                      *
!***********************************************************************

subroutine SPSPCLS(ISPSPCLS,ICLS,NCLS)
! Obtain mapping a-supergroup X b-supergroup => class

! Classes are specified by ICLS
!
! Jeppe Olsen, Jan 97

use lucia_data, only: IBSPGPFTP, ISPGPFTP, MXPNGAS, NELFGP, NGAS, NOCTYP
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: ISPSPCLS(*)
integer(kind=iwp), intent(in) :: ICLS(*), NCLS
integer(kind=iwp) :: IATP, IBTP, IOCTPA, IOCTPB, NOCTPA, NOCTPB

IATP = 1
IBTP = 2

NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)

IOCTPA = IBSPGPFTP(IATP)
IOCTPB = IBSPGPFTP(IBTP)

call SPSPCLS_GAS(NOCTPA,NOCTPB,ISPGPFTP(1,IOCTPA),ISPGPFTP(1,IOCTPB),NELFGP,MXPNGAS,NGAS,ISPSPCLS,ICLS,NCLS)

end subroutine SPSPCLS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE rotorb (cmoo, cmon, c, x, x2, y, vec, a, b, thmax,FA)
c
c     RASSCF program: version IBM-3090: SX section
c
c     PURPOSE: Calculation of the rotation matrix X from the super-CI
c              coefficient matrix C, formation of exp(x), and rotation
c              of the orbitals with this matrix.
c              These orbitals are used in the next
c              RASSCF iteration as starting orbitals.
c              Called from SXCTL
c
c          ********** IBM-3090 MOLCAS Release: 90 02 22 **********
c

      IMPLICIT REAL*8 (a-h,o-z)

#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
#include "gas.fh"
      Parameter (ROUTINE='ROTORB  ')
#include "rasscf.fh"
#include "WrkSpc.fh"

      DIMENSION cmoo(*), cmon(*), c(*), x(*), vec(*),  x2(*)
      DIMENSION y(*), a(*), b(*), FA(*)
      DIMENSION DAMPGAS(10),COREGAS(10)
      INTEGER IDAMPGAS(0:4,0:4),ICOREGAS(0:4,0:4)
      LOGICAL iFrzAct
c
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
         WRITE(LF,*)' Entering ',ROUTINE


        Write(LF,*)
        Write(LF,*)'FI+FA in RotOrb bf Unitary transform'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FA(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do

      END IF

      Acc=1.0D-13
      istbm=1
      istmo1=0
      ib=0
      rotmax=0.0D0
      cmax=0.0D0
      thmax=0.0d0
      iOff = 1
* A long loop over symmetry
      DO isym=1,nsym
        no=norb(isym)
        nb=nbas(isym)
        nf=nfro(isym)
        io=ib+nf
        nio=nish(isym)
        nao=nash(isym)
        noc=nio+nao
        neo=nssh(isym)
        nae=nao+neo
        IF (noc.eq.0.or.nae.eq.0 .or. nio+neo.eq.0) THEN
c
        IF(IPRLEV.ge.VERBOSE)
     & write(6,*) 'No rotations active for symmetry=',isym
c      No rotations active in this symmetry
c      Move orbitals from old to new set
c
          call dcopy_(nb*nb, cmoo(istmo1+1), 1, cmon(istmo1+1), 1)
          GO TO 100
        END IF
        istmo=istmo1+nf*nb
c
c      Form the quadratic matrix X from the coefficients C
c
        call dcopy_(no*no,[0.0D0],0,x,1)
        DO nr=1,noc
         DO np=max(nr+1,nio+1),no
          jpr=no*(nr-1)+np
          jrp=no*(np-1)+nr
          xx=c(istbm+nr+noc*(np-nio-1))
*
*         Any numerical information smaller than Acc is considered
*         numerical noise and is ignored.
*
          If (Abs(xx).lt.Acc) xx=0.0D0
*
          x(jpr)=xx
          x(jrp)=-xx
         END DO
        END DO
c
c      Set zero to matrix elements corresponding to orbitals
c      not allowed to rotate into each other.
c
        ij=0
        DO ni=1,no
         DO nj=1,no
          ij=ij+1
          IF (ixsym(ni+io).ne.ixsym(nj+io)) x(ij)=0.0D0
         END DO
        END DO
c
c  Freeze Active orbitals for difficult orbital optimization
c  This is activated by FRAC keyword in RASSCF module
c
        iFrzAct = .false.
        if(iFrzAct)then
          ij=0
          DO ni=1,no
           DO nj=1,no
            ij=ij+1
c io=ib+nf ! offeset counting all nbas of previous sym and nfro of current sym.
            IF( (ni.gt.nio) .and. (ni.lt.nio+nao) .or.
     &          (nj.gt.nio) .and. (nj.lt.nio+nao) ) x(ij)=0.0D0
           END DO
          END DO
        end if
c
c      For optimization of the core-hole we want to damp/eliminate
c      certain rotations to find the local minimum.
c
c      Damp/eliminate certain rotations inside RAS/GAS.
c
c      Only loop over the active spaces
c
c     DIMENSION DAMPGAS(10),COREGAS(10)
c     INTEGER IDAMPGAS(0:4,0:4),ICOREGAS(0:4,0:4)
      IDAMP = 0
      IDAMPGAS = 0
      DAMPGAS = 0.0D0
      ICORE = 0
      ICOREGAS = 0
      COREGAS = 0.1D0
C     COREGAS(1) = 0.0D0
C     COREGAS(2) = 0.0D0
      ICOREGAS(0,1) = 1
      ICOREGAS(1,0) = 2
C     ICOREGAS(0,2) = 1
C     ICOREGAS(2,0) = 2
      ICOREGAS(2,1) = 3
      ICOREGAS(1,2) = 4
      ICOREGAS(3,1) = 5
      ICOREGAS(1,3) = 6
      ICOREGAS(1,4) = 1
      ICOREGAS(4,1) = 2
C      write(6,*) 'NOC,NO',NOC,NO
       IF(ICORE.EQ.1.OR.IDAMP.EQ.1) THEN ! New keywords
c
         IJ = 0
         DO NACI = 1, NO ! Notice only loop over inactive and active
           IF(IDOGAS) THEN ! Find which GAS this index belong to
             ISPACE = 0
             IF(NACI.LE.NIO) THEN
               ISPACE = 0
             ELSE IF(NACI.GT.NOC) THEN
               ISPACE = NGAS + 1
             ELSE
               ISUM = 0
               DO IGAS = 1, NGAS
                 IF((NGSSH(IGAS,ISYM)+NIO+ISUM).GE.NACI) THEN
                   ISPACE = IGAS
                   EXIT
                 ELSE
                   ISUM = ISUM + NGSSH(IGAS,ISYM)
                 END IF
               END DO
             END IF
           ELSE ! Find which RAS this index belong to
             IF(NACI.LE.NIO) THEN
               ISPACE = 0
             ELSE IF(NACI.GT.NOC) THEN
               ISPACE = 4
             ELSE IF((NRS1(ISYM)+NIO).GE.NACI) THEN
               ISPACE = 1
             ELSE IF((NRS1(ISYM)+NRS2(ISYM)+NIO).GE.NACI) THEN
               ISPACE = 2
             ELSE
               ISPACE = 3
             END IF
           END IF
c
           DO NACJ = 1, NO ! Over all orbitals due to counting
C            write(6,*) 'NACI,NACJ',NACI,NACJ
             IF(IDOGAS) THEN ! Find which GAS this index belong to
               JSPACE = 0
               IF(NACJ.LE.NIO) THEN
                 JSPACE = 0
               ELSE IF(NACJ.GT.NOC) THEN
                 JSPACE = NGAS + 1
C                IJ = IJ + 1
C                CYCLE
               ELSE
                 ISUM = 0
                 DO IGAS = 1, NGAS
                   IF((NGSSH(IGAS,ISYM)+NIO+ISUM).GE.NACJ) THEN
                     JSPACE = IGAS
                     EXIT
                   ELSE
                     ISUM = ISUM + NGSSH(IGAS,ISYM)
                   END IF
                 END DO
               END IF
             ELSE ! Find which RAS this index belong to
               JSPACE = 0
               IF(NACJ.LE.NIO) THEN
                 JSPACE = 0
               ELSE IF(NACJ.GT.NOC) THEN
                 JSPACE = 4
C                IJ = IJ + 1
C                write(6,*) 'IJ',IJ
C                CYCLE
               ELSE IF((NRS1(ISYM)+NIO).GE.NACJ) THEN
                 JSPACE = 1
               ELSE IF((NRS1(ISYM)+NRS2(ISYM)+NIO).GE.NACJ) THEN
                 JSPACE = 2
               ELSE
                 JSPACE = 3
               END IF
             END IF
             IJ = IJ + 1
             write(6,*) 'NACI,NACJ',NACI,NACJ
             write(6,*) 'ISPACE,JSPACE',ISPACE,JSPACE
             write(6,*) 'IJ',IJ
             IF(IDAMP.EQ.1) THEN
               IF(IDAMPGAS(ISPACE,JSPACE).GT.0) THEN
                 X(IJ) = X(IJ)*DAMPGAS(IDAMPGAS(ISPACE,JSPACE))
               END IF
             ELSE IF(ICORE.EQ.1) THEN
               IF(ICOREGAS(ISPACE,JSPACE).GT.0) THEN
                 write(6,*) ' dampning'
             write(6,*)'ICOREGAS(ISPACE,JSPACE)',ICOREGAS(ISPACE,JSPACE)
             write(6,*) 'fac',COREGAS(ICOREGAS(ISPACE,JSPACE))
                 X(IJ) = X(IJ)*COREGAS(ICOREGAS(ISPACE,JSPACE))
               END IF
             END IF
           END DO
c
         END DO
c temp print
        ij=0
        DO ni=1,no
         DO nj=1,no
          ij=ij+1
          write(6,*) 'ij,x(ij)',ij,x(ij)
         END DO
        END DO
c
       END IF
c
c      Now form the unitary matrix exp(X)
c
        CALL expx (x, x2, y, vec, a, b, thm, no)
        thmax=max(thmax,thm)
c
c      Check for largest non diagonal element
c
        ij=0
        DO ni=1,no
          DO nj=1,no
            ij=ij+1
            IF (ni.eq.nj) GO TO 40
            IF (abs(x(ij)).gt.abs(rotmax)) rotmax=x(ij)
  40        CONTINUE
          END DO
        END DO
c
c      Check for large rotations and phase of new orbital
c
 1010   FORMAT (6x,'Molecular orbital',i4,
     &             ' of symmetry',i2,' MO space',i2,'  weight is',f12.6)
        ii=1
        ist=0
        DO ni=1,no
          IF (ni.le.nio) THEN
            motype=1
            xn=0.0D0
            DO nii=1,nio
              xn=xn+x(ist+nii)**2
            END DO
            IF (xn.lt.0.5D0) Then
             IF(IPRLEV.GE.TERSE) THEN
              Call WarningMessage(1,'Large orbital rotation.')
              Write(LF,1010) ni,isym,motype,xn
             END IF
            End If
          END IF
          IF (ni.gt.nio.and.ni.le.noc) THEN
            motype=2
            xn=0.0D0
            nio1=nio+1
            DO nii=nio1,noc
              xn=xn+x(ist+nii)**2
            END DO
            IF (xn.lt.0.5D0) Then
             IF(IPRLEV.GE.TERSE) THEN
              Call WarningMessage(1,'Large orbital rotation.')
              Write(LF,1010) ni,isym,motype,xn
             END IF
            End If
          END IF
          IF (ni.gt.noc) THEN
            motype=3
            noc1=noc+1
            xn=0.0D0
            DO nii=noc1,no
              xn=xn+x(ist+nii)**2
            END DO
            IF (xn.lt.0.5D0) Then
             IF(IPRLEV.GE.TERSE) THEN
              Call WarningMessage(1,'Large orbital rotation.')
              Write(LF,1010) ni,isym,motype,xn
             END IF
            End If
          END IF
          ii=ii+no+1
          ist=ist+no
        END DO
c
C Transformation of the Fock matrix according to the orbital rotation matrix.
C This step is not required other than for FCIQMC as orbital energies could be
c used for choosing the reference determinant.

        IF (iprlev.ge.debug) THEN
          CALL recprt ('X in RotOrb', ' ', x, no, no)
          write(6,*) 'FA for sym = ', iSym
          write(6,*) 'iOff is set to = ', iOff
          Call TriPrt(' ',' ',FA(iOff),no)
        END IF


        Call GetMem('Unit','Allo','Real',LUNIT,no*no)
        Call GetMem('SqFA','Allo','Real',iSqFA,no*no)
        call fzero(Work(Lunit),no*no)
        call fzero(Work(iSqFA),no*no)
        Call Square(FA(iOff),Work(iSqFA),1,no,no)
        IF (iprlev.ge.debug) THEN
          CALL recprt ('Square FA in RotOrb', ' ', Work(iSqFA), no, no)
        END IF
        CALL DGEMM_('N','N',
     &              no,no,no,
     &              1.0d0,x,no,
     &              Work(iSqFA),no,
     &              0.0d0,Work(LUNIT),no)

        CALL DGEMM_('N','T',
     &              no,no,no,
     &              1.0d0,Work(LUNIT),no,
     &              x,no,
     &              0.0d0,Work(iSqFA),no)

        call Fold_Mat(1,[no],Work(iSqFA),FA(iOff))

        iOff = iOff + (no*no+no)/2

        Call GetMem('Unit','Free','Real',LUNIT,no*no)
        Call GetMem('SqFA','Free','Real',iSqFA,no*no)

c
c     Print output in MO-basis
c
c      Transform new orbitals to AO-basis
c
        CALL DGEMM_('N','N',
     &              nb,no,no,
     &              1.0d0,cmoo(istmo+1),nb,
     &              x,no,
     &              0.0d0,cmon(istmo+1),nb)
c
c      Calculate max change in occupied molecular orbital coefficient
c
        nbo=noc*nb
        DO i=1,nbo
          term=cmon(istmo+i)-cmoo(istmo+i)
          IF (abs(term).gt.abs(cmax)) cmax=term
        END DO
c
 100    CONTINUE
c
c      Move frozen orbitals from old to new set of orbitals
c
        IF (nf.ne.0) THEN
          nfb=nf*nb
          call dcopy_(nfb, cmoo(istmo1+1), 1, cmon(istmo1+1), 1)
        END IF
c
c      MOVE DELETED ORBITALS.
c
        nd=ndel(isym)
        IF (nd.ne.0) THEN
          ist=istmo1+nb*(nf+no)+1
          ndb=nd*nb
          call dcopy_(ndb, cmoo(ist), 1, cmon(ist), 1)
        END IF
c
        istbm=istbm+noc*nae
        istmo1=istmo1+nb*nb
        ib=ib+nb
      END DO
*     ^ End of the long loop over symmetry

      IF(PURIFY(1:4).eq.'ATOM') CALL SPHPUR(CMON)
      IF(PURIFY(1:6).eq.'LINEAR') CALL LINPUR(CMON)
c
c     Orthogonalize new MO's and move them back to CMOO
c
      CALL supsch (x2, cmoo, cmon)
* PAM07: In ortho, cmoo is scratch and will be destroyed.
      CALL ortho_rasscf (x2, cmoo, cmon, y)
      call dcopy_(ntot2, cmon, 1, cmoo, 1)
c
      IF (iprlev.ge.debug) THEN
        Write(LF,*)
        Write(LF,*) ' >>> Exit RotOrb <<< '
        Write(LF,*)
      END IF
c
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Sttstc()

use McKinley_global, only: CPUStat, nFckAcc, nIntegrals, nMOTrans, nOneel, nScreen, nTotal, nTrans, nTwoDens, nTwoel
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: iFld
real(kind=wp) :: Diverse, TotCpu
character(len=*), parameter :: NamFld(nTotal+1) = ['1) Calculation of one electron integrals        :', &
                                                   '2) Calculation of two electron integrals        :', &
                                                   '     a) Decontraction of two electron density   :', &
                                                   '     b) Integral evalution 2nd derivatives      :', &
                                                   '     c) Screening                               :', &
                                                   '     d) Transformation of integrals             :', &
                                                   '     e) Direct Fock matrix generation           :', &
                                                   '     f) Direct MO transformation                :', &
                                                   '3)  Control and input                           :', &
                                                   '   T O T A L                                    :']

! Write out timing informations
write(u6,*)
call CollapseOutput(1,'Statistics and timing')
write(u6,'(3X,A)') '---------------------'
write(u6,*)
write(u6,100) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
write(u6,100) '   Part of the program                              CPU    fraction'
write(u6,100) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
if (CPUStat(nTotal) > 0.01_wp) then
  TotCpu = CPUStat(nTotal)
else
  TotCpu = 0.01_wp
end if
!TotCpu = max(0.01_wp,CPUStat(nTotal))
CPUStat(nTwoel) = CPUStat(nIntegrals)+CPUStat(nScreen)+CPUStat(nTrans)+CPUStat(nTwoDens)+CPUStat(nFckAcc)+CPUStat(nMOTrans)
Diverse = CPUStat(nTotal)-CPUStat(nTwoEl)-CPUStat(nOneel)

do iFld=1,nTotal-1
  write(u6,'(2x,A45,2f10.2)') NamFld(iFld),CPUStat(iFld),CPUStat(iFld)/TotCpu
end do
write(u6,'(2x,A45,2f10.2)') NamFld(nTotal),diverse,diverse/TotCpu

write(u6,*)
write(u6,'(2x,A45,2F10.2)') NamFld(nTotal+1),TotCpu
write(u6,100) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
call CollapseOutput(0,'Statistics and timing')
write(u6,*)

return

100 format(2x,a)

end subroutine Sttstc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Cho_VecBuf_Subtr(xInt,Wrk,lWrk,iSym,DoTime,DoStat)
!
! Purpose: subtract contributions to qualified columns from the
!          vectors stored in the buffer (if any).
!
! DoTime: time as vector subtraction.
! DpStat: update statistics info (#calls to dGeMM).

use Cholesky, only: Cho_SScreen, CHVBUF, DSPNm, DSubScr, iiBstR, iiBstRSh, ip_CHVBUF_SYM, iQuAB, l_CHVBUF_SYM, LQ, nDGM_call, &
                    nnBstR, nnBstRSh, nnShl, nQual, nVec_in_Buf, SSNorm, SSTau, SubScrStat, TDECOM
#ifdef _DEBUGPRINT_
use Cholesky, only: LuPri
#endif
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), target, intent(inout) :: xInt(*)
integer(kind=iwp), intent(in) :: lWrk, iSym
real(kind=wp), target, intent(out) :: Wrk(lWrk)
logical(kind=iwp), intent(in) :: DoTime, DoStat
integer(kind=iwp) :: iAB, iBatch, iE, iGD, iS, iShGD, iVec0, jAB, jVec, lCol, lRow, nBatch, nGD, NumV, nVec
real(kind=wp) :: C1, C2, Tst, W1, W2, xDon, xTot
real(kind=wp), pointer :: U(:,:), V(:,:), W(:,:)
character(len=*), parameter :: SecNam = 'Cho_VecBuf_Subtr'

! Return if nothing to do.
! ------------------------

if (l_ChVBuf_Sym(iSym) < 1) then
# ifdef _DEBUGPRINT_
  write(Lupri,*) SecNam,': returns immediately!'
  write(Lupri,*) ' -- no buffer allocated for sym. ',iSym
# endif
  return
end if
if (nVec_in_Buf(iSym) < 1) then
# ifdef _DEBUGPRINT_
  write(Lupri,*) SecNam,': returns immediately!'
  write(Lupri,*) ' -- buffer is empty for sym. ',iSym
# endif
  return
end if
if (nQual(iSym) < 1) then
# ifdef _DEBUGPRINT_
  write(Lupri,*) SecNam,': returns immediately!'
  write(Lupri,*) ' -- no qualified columns of sym. ',iSym
# endif
  return
end if
if (nnBstR(iSym,2) < 1) then
# ifdef _DEBUGPRINT_
  write(Lupri,*) SecNam,': returns immediately!'
  write(Lupri,*) ' -- empty symmetry block (sym. ',iSym,')'
# endif
  return
end if

! Start timing.
! -------------

if (DoTime) call CWTime(C1,W1)

! Initialize.
! -----------

xTot = Zero
xDon = Zero

! Set up vector batch.
! --------------------

nVec = min(lWrk/nQual(iSym),nVec_in_Buf(iSym))
if (nVec < 1) then
  call Cho_Quit('Insufficient memory for batch in '//SecNam,101)
  nBatch = -999999 ! avoid compiler warnings
else
  nBatch = (nVec_in_Buf(iSym)-1)/nVec+1
end if

! Map the integral array, xInt, onto the pointer U
! ------------------------------------------------

lRow = nnBstR(iSym,2)
lCol = nQual(iSym)
iS = 1
iE = iS-1+lRow*lCol

U(1:lRow,1:lCol) => xInt(iS:iE)

! Start batch loop.
! -----------------

do iBatch=1,nBatch

  ! Set info for this batch.
  ! ------------------------

  if (iBatch == nBatch) then
    NumV = nVec_in_Buf(iSym)-nVec*(nBatch-1)
  else
    NumV = nVec
  end if
  iVec0 = nVec*(iBatch-1)

# ifdef _DEBUGPRINT_
  Need = nQual(iSym)*NumV
  if (lWrk < Need) call Cho_Quit('Batch setup error in '//SecNam,104)
# endif

  lRow = nnBstR(iSym,2)
  lCol = iVec0+NumV
  iS = ip_ChVBuf_Sym(iSym)
  iE = iS-1+lRow*lCol

  V(1:lRow,1:lCol) => CHVBUF(iS:iE)

  ! Screened or unscreened subtraction section.
  ! The screened version uses level 2 blas, while the unscreened
  ! one employs level 3 blas.
  ! ------------------------------------------------------------

  if (Cho_SScreen) then

    lRow = NumV
    lCol = nQual(iSym)
    iS = 1
    iE = iS-1+lRow*lCol

    W(1:lRow,1:lCol) => Wrk(iS:iE)

    ! Copy out sub-blocks corresponding to qualified diagonals:
    ! L(#J,{ab})
    ! ---------------------------------------------------------

    do jVec=1,NumV
      do iAB=1,nQual(iSym)
        jAB = iQuAB(iAB,iSym)-iiBstR(iSym,2)
        W(jVec,iAB) = V(jAB,jVec+iVec0)
      end do
    end do

    ! Subtract:
    ! (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L(#J,{ab})
    ! for each ab in {ab}.
    ! ----------------------------------------------------

    call Cho_SubScr_Dia(V(:,iVec0+1),NumV,iSym,2,SSNorm)

    do iAB=1,nQual(iSym)
      do iShGD=1,nnShl
        nGD = nnBstRSh(iSym,iShGD,2)
        if (nGD < 1) cycle
        iGD = iiBstRSh(iSym,iShGD,2)
        xTot = xTot+One
        jAB = iQuab(iAB,iSym)-iiBstR(iSym,2)
        Tst = sqrt(DSPNm(iShGD)*DSubScr(jAB))
        if (Tst <= SSTau) cycle
        xDon = xDon+One
        call dGeMV_('N',nGD,NumV,-One,V(1+iGD:,iVec0+1),nnBstR(iSym,2),W(:,iAB),1,One,U(1+iGD:,iAB),1)
      end do
    end do

  else ! unscreened subtraction

    if (associated(LQ(iSym)%A)) then

      ! If the qualified block, L({ab},#J), is already in core,
      ! use this block.
      ! -------------------------------------------------------

      call DGEMM_('N','T',nnBstR(iSym,2),nQual(iSym),NumV,-One,V(:,iVec0+1),nnBstR(iSym,2),LQ(iSym)%A(:,iVec0+1), &
                  size(LQ(iSym)%A,1),One,U,nnBstR(iSym,2))

    else

      lRow = nQual(iSym)
      lCol = NumV
      iS = 1
      iE = iS-1+lRow*lCol

      W(1:lRow,1:lCol) => WrK(iS:iE)

      ! Copy out sub-blocks corresponding to qualified diagonals:
      ! L({ab},#J).
      ! ---------------------------------------------------------

      do jVec=1,NumV
        do iAB=1,nQual(iSym)
          jAB = iQuAB(iAB,iSym)-iiBstR(iSym,2)
          W(iAB,jVec) = V(jAB,jVec+iVec0)
        end do
      end do

      ! Subtract:
      ! (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L({ab},#J)
      ! ----------------------------------------------------

      call DGEMM_('N','T',nnBstR(iSym,2),nQual(iSym),NumV,-One,V(:,iVec0+1),nnBstR(iSym,2),W,nQual(iSym),One,U,nnBstR(iSym,2))

    end if

  end if

  nullify(V,W)

end do

nullify(U)

! Update statistics info.
! -----------------------

if (DoStat) nDGM_Call = nDGM_Call+nBatch
if (Cho_SScreen) then
  SubScrStat(1) = SubScrStat(1)+xTot
  SubScrStat(2) = SubScrStat(2)+xDon
end if

! Update global timing.
! ---------------------

if (DoTime) then
  call CWTime(C2,W2)
  tDecom(1,3) = tDecom(1,3)+C2-C1
  tDecom(2,3) = tDecom(2,3)+W2-W1
end if

end subroutine Cho_VecBuf_Subtr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  hasNonnegativeDiagonal
!
!> @brief
!>   Return ``.True.`` if all diagonal elements of \p M are non-negative
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Test if all diagonal elements of matrix \p M are non-negative.
!> If \f$ \forall i \; M_{ii} \ge 0 \f$ return ``.True.``.
!>
!> @param[in] M \p n &times; \p n square matrix
!> @param[in] n Dimension of \p M
!>
!> @return ``.True.`` if all diagonal elements of \p M are non-negative.
!***********************************************************************

function hasNonnegativeDiagonal(M,n)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: hasNonnegativeDiagonal
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: M(n,n)
integer(kind=iwp) :: i

hasNonnegativeDiagonal = .true.
do i=1,n
  if (M(i,i) < Zero) then
    hasNonnegativeDiagonal = .false.
    exit
  end if
end do

return

end function hasNonnegativeDiagonal

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine formats_cvb()
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "formats_cvb.fh"

      lenfld=4+iprec
      ix2=max(0,(lenfld-3)/2)
      ix1=max(0,lenfld-3-ix2)
c  iprec=8 => formMXP1='(4x,8(5x,i3,4x))'
      formMXP1='(4x,8('
      if(ix1.gt.0)then
        call appendint_cvb(formMXP1,ix1,0)
        call appendchr_cvb(formMXP1,'x,',0)
      endif
      call appendchr_cvb(formMXP1,'i3',0)
      if(ix2.gt.0)then
        call appendchr_cvb(formMXP1,',',0)
        call appendint_cvb(formMXP1,ix2,0)
        call appendchr_cvb(formMXP1,'x',0)
      endif
      call appendchr_cvb(formMXP1,'))',0)
c  iprec=8 => formMXP2='(4x,8(7x,i3,6x))'
      formMXP2='(4x,8('
      if(ix1.gt.0)then
        call appendint_cvb(formMXP2,ix1+2,0)
        call appendchr_cvb(formMXP2,'x,',0)
      endif
      call appendchr_cvb(formMXP2,'i3',0)
      if(ix2.gt.0)then
        call appendchr_cvb(formMXP2,',',0)
        call appendint_cvb(formMXP2,ix2+2,0)
        call appendchr_cvb(formMXP2,'x',0)
      endif
      call appendchr_cvb(formMXP2,'))',0)
c  iprec=8 => formMXP3='(1x,i3,8f12.8)'
      formMXP3='(1x,i3,8f'
      call appendint_cvb(formMXP3,lenfld,0)
      call appendchr_cvb(formMXP3,'.',0)
      call appendint_cvb(formMXP3,iprec,0)
      call appendchr_cvb(formMXP3,')',0)
c  iprec=8 => formMXP4='(1x,i3,8d16.8)'
      formMXP4='(1x,i3,8d'
      call appendint_cvb(formMXP4,lenfld+4,0)
      call appendchr_cvb(formMXP4,'.',0)
      call appendint_cvb(formMXP4,iprec,0)
      call appendchr_cvb(formMXP4,')',0)
c  iprec=8 => formMXP5='(4x,8f12.8)'
      formMXP5='(4x,8f'
      call appendint_cvb(formMXP5,lenfld,0)
      call appendchr_cvb(formMXP5,'.',0)
      call appendint_cvb(formMXP5,iprec,0)
      call appendchr_cvb(formMXP5,')',0)
c  iprec=8 => formMXP6='(4x,8d16.8)'
      formMXP6='(4x,8d'
      call appendint_cvb(formMXP6,lenfld+4,0)
      call appendchr_cvb(formMXP6,'.',0)
      call appendint_cvb(formMXP6,iprec,0)
      call appendchr_cvb(formMXP6,')',0)

c  iprec=8 => formE='(a,f16.10)'
      formE='(a,f'
      call appendint_cvb(formE,iprec+8,0)
      call appendchr_cvb(formE,'.',0)
      call appendint_cvb(formE,iprec+2,0)
      call appendchr_cvb(formE,')',0)
c  iprec=8 => formSymW='(a,i2,a,4e16.8)'
      formSymW='(a,i2,a,4e'
      call appendint_cvb(formSymW,iprec+8,0)
      call appendchr_cvb(formSymW,'.',0)
      call appendint_cvb(formSymW,iprec,0)
      call appendchr_cvb(formSymW,')',0)
c  iprec=8 => formVBWnorm='(a,f12.8,a)'
      formVBWnorm='(a,f'
      call appendint_cvb(formVBWnorm,iprec+4,0)
      call appendchr_cvb(formVBWnorm,'.',0)
      call appendint_cvb(formVBWnorm,iprec,0)
      call appendchr_cvb(formVBWnorm,',a)',0)

c  iprec=8 => formChk1='(a,d16.8)'
      formChk1='(a,d'
      call appendint_cvb(formChk1,iprec+8,0)
      call appendchr_cvb(formChk1,'.',0)
      call appendint_cvb(formChk1,iprec,0)
      call appendchr_cvb(formChk1,')',0)
c  iprec=8 => formChk2='(5(6x,a,1x))'
      lenfld=8+iprec
      ix1=max(0,min(lenfld-9,6))
      ix2=max(0,lenfld-9-ix1)
      formChk2='(5('
      call appendint_cvb(formChk2,ix1,0)
      call appendchr_cvb(formChk2,'x,a,',0)
      call appendint_cvb(formChk2,ix2,0)
      call appendchr_cvb(formChk2,'x))',0)
c  iprec=8 => formChk3='(5d16.8)'
      formChk3='(5d'
      call appendint_cvb(formChk3,iprec+8,0)
      call appendchr_cvb(formChk3,'.',0)
      call appendint_cvb(formChk3,iprec,0)
      call appendchr_cvb(formChk3,')',0)
c  iprec=8 => formcvp='(2(a,d16.8))'
      formcvp='(2(a,d'
      call appendint_cvb(formcvp,iprec+8,0)
      call appendchr_cvb(formcvp,'.',0)
      call appendint_cvb(formcvp,iprec,0)
      call appendchr_cvb(formcvp,'))',0)
c  iprec=8 => formAD='(a,10d16.8)'
      formAD='(a,10d'
      call appendint_cvb(formAD,iprec+8,0)
      call appendchr_cvb(formAD,'.',0)
      call appendint_cvb(formAD,iprec,0)
      call appendchr_cvb(formAD,')',0)
c  iprec=8 => formAF='(a,10f16.8)'
      formAF='(a,10f'
      call appendint_cvb(formAF,iprec+8,0)
      call appendchr_cvb(formAF,'.',0)
      call appendint_cvb(formAF,iprec,0)
      call appendchr_cvb(formAF,')',0)
c  iprec=8 => form2AD='(2(a,d16.8))'
      form2AD='(2(a,d'
      call appendint_cvb(form2AD,iprec+8,0)
      call appendchr_cvb(form2AD,'.',0)
      call appendint_cvb(form2AD,iprec,0)
      call appendchr_cvb(form2AD,'))',0)
c  iprec=8 => form2AF='(2(a,f16.8))'
      form2AF='(2(a,f'
      call appendint_cvb(form2AF,iprec+8,0)
      call appendchr_cvb(form2AF,'.',0)
      call appendint_cvb(form2AF,iprec,0)
      call appendchr_cvb(form2AF,'))',0)
c  iprec=8 => formroot='(/,a,i3,a,f16.10,a)'
      formroot='(/,a,i3,a,f'
      call appendint_cvb(formroot,iprec+8,0)
      call appendchr_cvb(formroot,'.',0)
      call appendint_cvb(formroot,iprec+2,0)
      call appendchr_cvb(formroot,',a)',0)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_O4_Drv(irc,EMP2,CMO,EOcc,EVir)
C
C     Thomas Bondo Pedersen, Jan. 2008.
C     - based on ChoMP2_Drv() by T. B. Pedersen.
C
C     Purpose: driver for computing the MP2 energy correction EMP2
C              using Cholesky decomposed two-electron integrals
C              in a quartic scaling fashion.
C              Input must have been processed and MO coefficients
C              and orbital energies must be passed as arguments.
C
C     Notes:
C
C       - all MO Cholesky vector files generated here are deleted before
C         exit, except for error terminations (i.e. no cleanup actions
C         are taken!)
C       - the amplitude decomposition does NOT use EOcc and EVir; these
C         are accessed through pointers ip_EOc and ip_EVir stored in
C         chomp2_dec.fh
C
#include "implicit.fh"
      Dimension CMO(*), EOcc(*), EVir(*)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      Character*6  ThisNm
      Character*13 SecNam
      Parameter (SecNam = 'ChoMP2_O4_Drv', ThisNm = 'O4_Drv')

      Parameter (Chk_Mem_ChoMP2 = 0.123456789D0, Tol = 1.0D-15)
      Parameter (iFmt = 0)

      Logical Delete, Delete_def, DoAmpDiag
      Parameter (Delete_def = .true.)

      Integer a, ai
      Integer lU_AO(8)

      Character*3 BaseName_AO

      MulD2h(k,l)=iEor(k-1,l-1)+1

#if defined (_DEBUGPRINT_)
      Verbose = .true.
#endif
      If (Verbose) Then
         Call CWTime(CPUTot1,WallTot1)
      End If

C     Initializations.
C     ----------------

      irc = 0

      EMP2 = 0.0d0

      If (Verbose) Then
         Call CWTime(CPUIni1,WallIni1)
      End If

      l_Dum = 1
      Call GetMem('Dummy','Allo','Real',ip_Dum,l_Dum)
      Work(ip_Dum) = Chk_Mem_ChoMP2

      FracMem = 0.0d0 ! no buffer allocated
      Call Cho_X_Init(irc,FracMem)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_X_Init returned ',irc
         Call ChoMP2_Quit(SecNam,'Cholesky initialization error',' ')
      End If

C-TBP:
C Frankie,
C The setup is still the same here (i.e. batching etc. is included)
C I don't use the batching info at all, though, so it should be save
C to remove it - unless you need it, of course.

      Call ChoMP2_Setup(irc)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': ChoMP2_Setup returned ',irc
         Go To 1  ! exit
      End If

      If (Verbose) Then
         Call ChoMP2_Setup_Prt(irc)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_Setup_Prt returned ',irc
            Go To 1  ! exit
         End If
         Call CWTime(CPUIni2,WallIni2)
         Call Cho_PrtTim('Cholesky MP2 initialization',CPUIni2,CPUIni1,
     &                   WallIni2,WallIni1,iFmt)
      End If

C     Transform Cholesky vectors directly from reduced set to MO
C     representation. Result vectors are stored on disk.
C     Compute also amplitude diagonal here.
C     ----------------------------------------------------------

      If (Verbose) Then
         Call CWTime(CPUTra1,WallTra1)
      End If

      lDiag = nT1am(1)
      Do iSym = 2,nSym
         lDiag = lDiag + nT1am(iSym)
      End Do
      Call GetMem('Diag','Allo','Real',ipDiag,lDiag)
      Call ChoMP2_TraDrv(irc,CMO,Work(ipDiag),.True.)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': ChoMP2_TraDrv returned ',irc
         Go To 1  ! exit
      End If
      kD0 = ipDiag - 1
      Do iSym = 1,nSym
         Do iSymi = 1,nSym
            iSyma = MulD2h(iSymi,iSym)
            kD1 = kD0 + iT1Am(iSyma,iSymi)
            Do i = 1,nOcc(iSymi)
               kD2 = kD1 + nVir(iSyma)*(i-1)
               Ei  = EOcc(iOcc(iSymi)+i)
               Do a = 1,nVir(iSyma)
                  ai = kD2 + a
                  DE = 2.0d0*(EVir(iVir(iSyma)+a)-Ei)
                  Work(ai) = Work(ai)/DE
               End Do
            End Do
         End Do
         kD0 = kD0 + nT1Am(iSym)
      End Do

      If (Verbose) Then
         Call CWTime(CPUTra2,WallTra2)
         Call Cho_PrtTim('Cholesky MP2 transformation',CPUTra2,CPUTra1,
     &                   WallTra2,WallTra1,iFmt)
      End If

C     Decompose MP2 amplitudes (times -1).
C     ------------------------------------

      If (Verbose) Then
         Call CWTime(CPUDec1,WallDec1)
      End If

C-TBP:
C Frankie,
C I just modified the decomposition slightly so that it treats
C amplitudes, too. You should be aware, though, that result vectors
C are always written on the same files, so if you do another
C decomposition of, say, integrals (or squared integrals), then
C the vector files will be overwritten!!
C The number of vectors is always written to nMP2Vec(iSym) in
C chomp2.fh - this is overwritten too, if you do another CD!!

      Delete = Delete_def ! delete transf. vector files after dec.
      Call ChoMP2_DecDrv(irc,Delete,Work(ipDiag),'Amplitudes')
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': ChoMP2_DecDrv returned ',irc
         Call ChoMP2_Quit(SecNam,'MP2 decomposition failed!',
     &                    ' ')
      End If
      Call GetMem('Diag','Free','Real',ipDiag,lDiag)

      If (Verbose) Then
         Call CWTime(CPUDec2,WallDec2)
         Call Cho_PrtTim('Cholesky MP2 decomposition',
     &                   CPUDec2,CPUDec1,
     &                   WallDec2,WallDec1,iFmt)
      End If

C     Backtransform amplitude vectors to AO basis.
C     Calculate also backtransformed amplitude diagonal.
C     --------------------------------------------------

      If (Verbose) Then
         Call CWTime(CPUBT1,WallBT1)
      End If

      iTyp = 2 ! type of MO vectors (i.e. amp. vectors)
      Delete = Delete_def ! delete amp. vectors after backtransf.
      BaseName_AO = 'AAO' ! basename for multifiles of AO vectors
      DoAmpDiag = .True. ! calculate backtransf. amp. diagonal
      lDiag = 0
      Do iSym = 1,nSym
         Do iSymb = 1,nSym
            iSyma = MulD2h(iSymb,iSym)
            lDiag = lDiag + nBas(iSyma)*nBas(iSymb)
         End Do
      End Do
      Call GetMem('AODiag','Allo','Real',ipDiag,lDiag)
      Call ChoMP2_VectorMO2AO(iTyp,Delete,BaseName_AO,CMO,DoAmpDiag,
     &                        Work(ipDiag),lDiag,lU_AO,irc)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': ChoMP2_VectorMO2AO returned ',irc
         Call ChoMP2_Quit(SecNam,
     &                'MP2 amplitude vector backtransformation failed!',
     &                ' ')
      End If
      Call GetMem('Diag','Free','Real',ipDiag,lDiag)

      If (Verbose) Then
         Call CWTime(CPUBT2,WallBT2)
         Call Cho_PrtTim('Cholesky MP2 backtransformation',
     &                   CPUBT2,CPUBT1,
     &                   WallBT2,WallBT1,iFmt)
      End If

C-TBP:
C Frankie,
C You can now read the AO vectors from the units lU_AO(iSym)
C using ddaFile(). The files are word-addressable so that it
C is possible to read from the file as if addressing an array.
C The number of vectors is nMP2Vec(iSym) stored in chomp2.fh.
C To save memory, you may want to finalize Cholesky info before
C continuing with the backtransformed vectors - but remember
C that all Cholesky information (from the AO integral CD) is
C then lost (f.ex. NumCho(iSym) becomes useless).

C     Finalize Cholesky info.
C     -----------------------

      Call Cho_X_Final(irc)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_X_Final returned ',irc
         Go To 1 ! exit
      End If

C     Close and delete files containing backtransformed amplitude
C     vectors.
C     -----------------------------------------------------------

      Do iSym = 1,nSym
         Call daEras(lU_AO(iSym))
      End Do

C     Exit.
C     -----

    1 Continue
      Diff = abs(Work(ip_Dum)-Chk_Mem_ChoMP2)
      If (Diff .gt. Tol) Then
         Write(6,*) SecNam,': Memory Boundary Error!'
         If (irc .eq. 0) irc = -9999
      End If
      If (Verbose) Then
         Call CWTime(CPUTot2,WallTot2)
         Call Cho_PrtTim('Cholesky MP2',CPUTot2,CPUTot1,
     &                   WallTot2,WallTot1,iFmt)
      End If
      Call GetMem('Flush','Flush','Real',ip_Dum,l_Dum)
      Call GetMem('Dummy','Free','Real',ip_Dum,l_Dum)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PCMDef(ISlPar,RSlPar,iPrint)
      Implicit Real*8 (A-H,O-Z)
*
*     Set PCM defaults.
*
      Integer ISlPar(100)
      Real*8 RSlPar(100)
*
*     Initialize the integer array.
*
      Do 10 I = 1, 100
        ISlPar(I) = 0
  10  Continue
*
      ISlPar(  1) =  0      ! SCRF flag
      ISlPar(  2) =  0      ! derivative level
      ISlPar(  3) =  0      ! 0-3=invqsep/invqtot/iterqsep/iterqtot
      ISlPar(  4) =  0      ! geomview
      ISlPar(  5) =  2      ! escaped charge compensation type
      ISlPar(  6) =  1      ! cavitation energy
      ISlPar(  7) =  1      ! repulsion energy
      ISlPar(  8) =  1      ! dispersion energy
      ISlPar(  9) =  1      ! type of atomic radii (UATM/Pauling/input)
      ISlPar( 10) =  2      ! type of polyhedra
      ISlPar( 11) = -400    ! initial number of tesserae
      ISlPar( 12) =  1      ! level of division in PolyGen
      ISlPar( 13) =  0      ! derivatives style (default/pcm/cond)
      ISlPar( 14) =  0      ! number of explicit spheres
      ISlPar( 15) =  1      ! solvent id number
      ISlPar( 16) =  1      ! PCM / Conductor
      ISlPar( 17) =  1      ! [unused]
      ISlPar( 18) =  1      ! [unused]
      ISlPar( 19) =  0      ! [unused]
      ISlPar( 20) =  0      ! non equilibrium solvation
      ISlPar( 21) =  0      ! fixed cavity gradients
      ISlPar( 22) =  0      ! fixed cavity 2nd derivative
      ISlPar( 23) =  0      ! number of spheres
      ISlPar( 24) =  3      ! atom types in solvent
      ISlPar( 25) =  0      ! [unused]
      ISlPar( 26) =  1      ! [unused]
      ISlPar( 27) =  0      ! explicit solute charges
      ISlPar( 28) =  0      ! gives PCM help
      ISlPar( 29) =  0      ! fits charges to electrostatic potential
      ISlPar( 30) =  0      ! [unused]
      ISlPar( 31) =  0      ! [unused]
      ISlPar( 32) =  0      ! [unused]
      ISlPar( 33) =  IPrint ! specific printing level for
                            !            solvent routines
      ISlPar( 34) =  0      ! number of spheres
      ISlPar( 35) =  0      ! number of tesserae
      ISlPar( 36) =  0      ! [unused]
      ISlPar( 37) =  0      ! read in radius and alpha for atom/element
      ISlPar( 38) =  0      ! read in element parameters for UA method
      ISlPar( 39) =  0      ! local field factor switch
      ISlPar( 40) =  0      ! [unused]
      ISlPar( 41) =  0      ! vacuum SCF flag
      ISlPar( 42) =  0      ! number of solute atoms

**     Initialize the real array.
*
      Do 20 I = 1, 100
        RSlPar(I) = 0.0d0
  20  Continue
*
      RSlPar(  1) =   0.0d0     ! XCosmo
      RSlPar(  2) =   4.0d+1    ! Omega
      RSlPar(  3) =   2.0d-1    ! Ret, minimum radius of added sphere
      RSlPar(  4) =   7.0d-1    ! Fro
      RSlPar(  5) =   1.0d-4    ! DR
      RSlPar(  6) =   1.0d-6    ! accuracy for PCM
      RSlPar(  7) =   4.0d-1    ! average tesserae area
      RSlPar(  8) =  78.39d0    ! dielectric constant
      RSlPar(  9) =   1.2d0     ! Alpha scaling of radii
      RSlPar( 10) =  78.39d0    ! Exx
      RSlPar( 11) =   0.0d0     ! Exy
      RSlPar( 12) =   0.0d0     ! Exz
      RSlPar( 13) =   0.0d0     ! Eyy
      RSlPar( 14) =   0.0d0     ! Eyz
      RSlPar( 15) =   0.0d0     ! Ezz
      RSlPar( 16) = 298.15d0    ! absolute temperature
      RSlPar( 17) =   1.776d0   ! limiting dielectric constant
      RSlPar( 18) =  -0.3562d0  ! derivative of eps wrt T
      RSlPar( 19) =   1.385d0   ! RSolv
      RSlPar( 20) =   2.57d-4   ! TCE
      RSlPar( 21) =  78.39d0    ! dielectric constant for shell  1
      RSlPar( 22) =   1.0d0     ! dielectric constant for shell  2
      RSlPar( 23) =   1.0d0     ! dielectric constant for shell  3
      RSlPar( 24) =   1.0d0     ! dielectric constant for shell  4
      RSlPar( 25) =   1.0d0     ! dielectric constant for shell  5
      RSlPar( 26) =   1.0d0     ! dielectric constant for shell  6
      RSlPar( 27) =   1.0d0     ! dielectric constant for shell  7
      RSlPar( 28) =   1.0d0     ! dielectric constant for shell  8
      RSlPar( 29) =   1.0d0     ! dielectric constant for shell  9
      RSlPar( 30) =   1.0d0     ! dielectric constant for shell 10
      RSlPar( 31) =   1.2d0     ! scaling factor for neutrals
      RSlPar( 32) =   1.0d0     ! scaling factor for acidic hydrogens
      RSlPar( 33) =   1.1d0     ! scaling factor for charged
      RSlPar( 34) =  18.07d0    ! solvent molecular volume
      RSlPar( 35) =  71.81d0    ! Sten
      RSlPar( 36) =   0.650d0   ! DSten
      RSlPar( 37) =   1.277d0   ! CMF
      RSlPar( 38) =   3.348d-2  ! solvent density
      RSlPar( 39) =   0.0d0     ! DK2
      RSlPar( 40) =   0.0d0     ! DAlp
      RSlPar( 41) =   0.0d0     ! DetEps
      RSlPar( 42) =  30.0d0     ! hard cutoff for iterative PCM
      RSlPar( 43) =  15.0d0     ! multiplier cutoff for iterative PCM
      RSlPar( 44) =   0.8d0     ! overlap factor for GePol
      RSlPar( 45) =   0.5d0     ! min radius for added spheres by GePol
      RSlPar( 46) =   0.0d0     ! GCavP
      RSlPar( 47) =   0.0d0     ! SCavP
      RSlPar( 48) =   0.0d0     ! HCavP
      RSlPar( 49) =   0.0d0     ! GDisp
      RSlPar( 50) =   0.0d0     ! GRep
      RSlPar( 51) =   0.0d0     ! Total Cavity surface (SCav)
      RSlPar( 52) =   0.0d0     ! Total Cavity volume (VCav)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************

      SUBROUTINE CHO_GetShFull(scr,lscr,JNUM,JSYM,
     &                         IREDC,ipChoV,SvShp,iShp_rs)
************************************************************
*   Author: F. Aquilante
*
*
************************************************************

      Implicit Real*8 (a-h,o-z)
      Real*8  Scr(lscr),SvShp(*)
      Integer iShp_rs(*)
      Logical Debug
      Integer cho_isao
      External cho_isao

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      Integer   ipChoV
      Parameter (zero = 0.0d0)

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
******
      iRS2F(i,j)  = iWork(ip_iRS2F-1+2*(j-1)+i)
******
      NBASSH(I,J)=IWORK(ip_NBASSH-1+NSYM*(J-1)+I)
******
      IBASSH(I,J)=IWORK(ip_IBASSH-1+NSYM*(J-1)+I)
******
      ISHLSO(I)=IWORK(ip_iShlSO-1+I)
******
      ISOSHL(I)=IWORK(ip_iSOShl-1+I)
******
      INDRSH(I)=IWORK(ip_INDRSH-1+I)
****** this is a trick to save memory. Memory in "location 2" is used
******      to store some offset arrays
      iOffShp(i,j) = iWork(ip_iiBstRSh+nSym*nnShl-1+nSym*(j-1)+i)
************************************************************************

#ifdef _DEBUGPRINT_
      Debug=.true.
#else
      Debug=.false.
#endif
**********************************************************
C
C    From Reduced sets to full storage
C    ---------------------------------
C
C     L{a,b,J} ---> L(a,J,b)
C
**********************************************************

      iLoc = 3 ! use scratch location in reduced index arrays


      IF (JSYM.eq.1) THEN

         NREAD = 0

         DO JVEC=1,JNUM

            kscr = NREAD
            NREAD= NREAD + nDimRS(jSym,IREDC)

            Do jRab=1,nnBstR(jSym,iLoc)

             kRab = iiBstr(jSym,iLoc) + jRab
             iRab = IndRed(kRab,iLoc) ! addr in 1st red set

             iShp = IndRSh(iRab) ! shell pair to which it belongs

             iag  = iRS2F(1,iRab)  !global address
             ibg  = iRS2F(2,iRab)

             iaSh = iSOShl(iag) ! shell to which it belongs
             ibSh = iSOShl(ibg) ! iaSh >= ibSh

             iaSg = iShlSO(iag) !index of SO within its shell
             ibSg = iShlSO(ibg)

             iSyma = cho_isao(iag)  !symmetry block sym(a)=sym(b)

             ias = iaSg - iBasSh(iSyma,iaSh) ! addr within its shell
             ibs = ibSg - iBasSh(isyma,ibSh)

             kscr  = kscr + 1

             kcho1 = nBasSh(iSyma,iaSh)*JNUM*(ibs-1)
     &             + nBasSh(iSyma,iaSh)*(JVEC-1) + ias

             kcho2 = nBasSh(iSyma,ibSh)*JNUM*(ias-1)
     &             + nBasSh(iSyma,ibSh)*(JVEC-1) + ibs

             ioffV = ipChoV + JNUM*iOffShp(iSyma,iShp_rs(iShp)) - 1

             Work(kcho1+ioffV) = Scr(kscr)

             ioffV = ioffV - nBasSh(iSyma,iaSh)*JNUM*nBasSh(iSyma,ibSh)
     &             *Min(0,(ibSh-iaSh))/Max(1,(iaSh-ibSh))

             Work(kcho2+ioffV) = Scr(kscr)

             SvShp(nnShl+iShp_rs(iShp)) = SvShp(nnShl+iShp_rs(iShp))
     &                                  + Scr(kscr)**2

            End Do

            Do jShp=1,nnShl_tot ! Maximize over vectors
               If (iShp_rs(jShp).gt.0) Then
                  SvShp(iShp_rs(jShp)) = Max( SvShp(iShp_rs(jShp)),
     &                                   SvShp(nnShl+iShp_rs(jShp)) )
                  SvShp(nnShl+iShp_rs(jShp)) = zero
               End If
            End Do

         END DO


      ELSE


         NREAD = 0

         DO JVEC=1,JNUM

            kscr = NREAD
            NREAD= NREAD + nDimRS(jSym,IREDC)

            Do jRab=1,nnBstR(jSym,iLoc)

              kRab = iiBstr(jSym,iLoc) + jRab
              iRab = IndRed(kRab,iLoc) ! addr in 1st red set

              iShp = IndRSh(iRab) ! shell pair to which it belongs

              iag  = iRS2F(1,iRab)  !global address
              ibg  = iRS2F(2,iRab)

              iaSh = iSOShl(iag) ! shell to which it belongs
              ibSh = iSOShl(ibg)

              iaSg = iShlSO(iag) !index of SO within its shell
              ibSg = iShlSO(ibg)

              iSyma = cho_isao(iag)  !symmetry block
              iSymb = muld2h(jSym,iSyma) ! iSyma >= iSymb

c               koff = iOffShp(iSyma,iShp_rs(iShp))

c               If (iaSh.lt.ibSh)   koff = koff
c     &                           + nBasSh(iSyma,ibSh)*nBasSh(iSymb,iaSh)

              koff = iOffShp(iSyma,iShp_rs(iShp)) - nBasSh(iSyma,ibSh)*
     &               nBasSh(iSymb,iaSh)*
     &               Min(0,(iaSh-ibSh))/Max(1,(ibSh-iaSh))

              ias = iaSg - iBasSh(iSyma,iaSh) !addr within its shell
              ibs = ibSg - iBasSh(iSymb,ibSh)

              kchov = nBasSh(iSyma,iaSh)*JNUM*(ibs-1)
     &              + nBasSh(iSyma,iaSh)*(JVEC-1) + ias
     &              + ipChoV + JNUM*kOff - 1

              kscr  = kscr + 1

              Work(kchov) = Scr(kscr)

              SvShp(nnShl+iShp_rs(iShp)) = SvShp(nnShl+iShp_rs(iShp))
     &                                   + Scr(kscr)**2

            End Do

            Do jShp=1,nnShl_tot
               If (iShp_rs(jShp).gt.0) Then
                  SvShp(iShp_rs(jShp)) = Max( SvShp(iShp_rs(jShp)),
     &                                      SvShp(nnShl+iShp_rs(jShp)) )
                  SvShp(nnShl+iShp_rs(jShp)) = zero
               EndIf
            End Do

         END DO


      ENDIF


      Return
      END

**************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine read_aniso_old_exch(input_file_name,nss,eso,MM,MS,ML)
! in this subroutine nss is input data

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: gElectron
use Definitions, only: wp, iwp

implicit none
character(len=180), intent(in) :: input_file_name
integer(kind=iwp), intent(in) :: nss
real(kind=wp), intent(out) :: eso(nss)
complex(kind=wp), intent(out) :: MM(3,nss,nss), MS(3,nss,nss), ML(3,nss,nss)
integer(kind=iwp) :: j, j1, j2, l, LuAniso, nss_local, nstate_local
real(kind=wp), allocatable :: tmp(:), tmpI(:,:), tmpR(:,:)
real(kind=wp), parameter :: g_e = -gElectron
integer(kind=iwp), external :: IsFreeUnit

! read the file "aniso.input":
LuAniso = IsFreeUnit(81)
call molcas_open(LuAniso,trim(input_file_name))
! compatibility with the present version: of aniso_i.input file
read(LuAniso,*) nstate_local,nss_local
!-----------------------------------------------------------------------
call mma_allocate(tmp,nss_local,'tmp')
! local spin-orbit energy
read(LuAniso,*) (tmp(j),j=1,nss_local)
! copy the lowest nss states to eso:
eso(:) = tmp(:)
call mma_deallocate(tmp)
!-----------------------------------------------------------------------
read(LuAniso,*) (l,j=1,nstate_local)
!-----------------------------------------------------------------------

call mma_allocate(tmpR,nss_local,nss_local,'tmpR')
call mma_allocate(tmpI,nss_local,nss_local,'tmpI')
! magnetic moment
do l=1,3
  do j1=1,nss_local
    read(LuAniso,*) (tmpR(j1,j2),tmpI(j1,j2),j2=1,nss_local)
  end do
  MM(l,:,:) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)
end do

! spin moment
do l=1,3
  do j1=1,nss_local
    read(LuAniso,*) (tmpR(j1,j2),tmpI(j1,j2),j2=1,nss_local)
  end do
  MS(l,:,:) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)
end do
call mma_deallocate(tmpR)
call mma_deallocate(tmpI)

! compute the orbital moment
ML(:,:,:) = -MM(:,:,:)-g_e*MS(:,:,:)

close(LuAniso)

return

end subroutine read_aniso_old_exch

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NDSD_Ts(mGrid,nDmat)
!***********************************************************************
!                                                                      *
! Object:  compute Func for Thomas-Fermi KE functional                 *
!          compute non-TF part (rho_B dependent) of NDSD potential     *
!                                                                      *
!          (see J.-M. Garcia Lastra, J. W. Kaminski, T. A. Wesolowski, *
!                                   J. Chem. Phys.  129 (2008) 074107.)*
!                                                                      *
!          Note: for a spin-polarized rho_B (environment density), the *
!                NDSD potential is computed using the alpha+beta       *
!                density, gradient and laplacian.                      *
!                                                                      *
!***********************************************************************

use nq_Grid, only: F_xc, GradRho, Lapl, Rho, vRho
use Constants, only: Zero, One, Two, Three, Five, Ten, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mGrid, nDmat
integer(kind=iwp) :: iGrid, k
real(kind=wp) :: Cf, d_sys, da_sys, db_sys, dfunc_NDSD, dfunc_NDSD_alpha, dfunc_NDSD_beta, DTot, functional, Rho_min, &
                 wGradRho(1:3), wLaplRho
real(kind=wp), parameter :: Coeff = One, Five3 = Five/Three, T_X = 1.0e-20_wp, Two3 = Two/Three
real(kind=wp), external :: Fexp, Vt_lim

!                                                                      *
!***********************************************************************
!                                                                      *
vRho(:,:) = Zero
Cf = (Three/Ten)*(three*Pi**Two)**Two3
Rho_min = T_X*1.0e-2_wp
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute value of energy and integrand on the grid
!                                                                      *
!***********************************************************************
!                                                                      *
if (nDmat == 1) then
  do iGrid=1,mGrid
    d_sys = Two*Rho(1,iGrid)
    if (d_sys < T_X) cycle

    ! Kinetic energy contributions

    functional = Cf*d_sys**Five3
    F_xc(iGrid) = F_xc(iGrid)+Coeff*functional

    ! Contributions to the potential

    do k=1,3
      wGradRho(k) = Two*GradRho(k,iGrid)
    end do
    wLaplRho = Two*Lapl(1,iGrid)

    dfunc_NDSD = Fexp(d_sys,wGradRho(1))*Vt_lim(d_sys,wGradRho(1),wLaplRho)
    vRho(1,iGrid) = vRho(1,iGrid)+Coeff*dfunc_NDSD

  end do

else if (nDmat == 2) then

  Cf = Cf*(Two**Two3)

  do iGrid=1,mGrid
    da_sys = max(Rho_Min,Rho(1,iGrid))
    db_sys = max(Rho_Min,Rho(2,iGrid))
    DTot = da_sys+db_sys
    if (DTot < T_X) cycle

    ! Kinetic energy contributions

    functional = Cf*(da_sys**Five3+db_sys**Five3)
    F_xc(iGrid) = F_xc(iGrid)+Coeff*functional

    ! Contributions to the potential

    do k=1,3
      wGradRho(k) = Rho(k,iGrid)+Rho(k+3,iGrid)
    end do
    wLaplRho = Lapl(1,iGrid)+Lapl(2,iGrid)

    dfunc_NDSD_alpha = Fexp(DTot,wGradRho(1))*Vt_lim(DTot,wGradRho(1),wLaplRho)
    dfunc_NDSD_beta = dfunc_NDSD_alpha

    vRho(1,iGrid) = vRho(1,iGrid)+Coeff*dfunc_NDSD_alpha
    vRho(2,iGrid) = vRho(2,iGrid)+Coeff*dfunc_NDSD_beta

  end do

else
  write(u6,*) 'In NDSD_Ts: invalid # of densities. nDmat=  ',nDmat
  call Abend()
end if

return

end subroutine NDSD_Ts

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine defs_cvb()

use casvb_global, only: iciweights, icrit, imethod, initial, ipr, isaddle, ishstruc, iunset, ivbweights, kbasis, lfxvb, lzrvb, &
                        mxiter, ndimrel, nfxorb, nfxvb, norbrel, nort, npcf, nzrvb, ploc, projcas, projsym, savvb, savvbci, &
                        service, sij, strtvb, variat
use Constants, only: Zero
use Definitions, only: iwp

implicit none
logical(kind=iwp), parameter :: ifploc = .false.

! Default settings:
strtvb = Zero
savvb = Zero
savvbci = Zero
kbasis = 1
mxiter = iunset
icrit = iunset
imethod = iunset
isaddle = iunset
initial = -1
projcas = .false.
projsym = .false.
npcf = iunset
ishstruc = iunset
! +1=CHIRGWIN +2=LOWDIN +4=INVERSE
ivbweights = iunset
iciweights = iunset
sij = .false.
service = .false.
ipr(:) = 1

call tunedefs_cvb()
if (variat) then
  ploc = ifploc
else
  ploc = .false.
end if

! Counters
norbrel = 0
ndimrel = 0
nfxorb = 0
nfxvb = 0
nzrvb = 0
nort = 0
lfxvb = 0
lzrvb = 0

return

end subroutine defs_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Ben Swerts                                             *
!               2016, Liviu Ungur                                      *
!***********************************************************************

subroutine FragPMmG( &
#                   define _CALLING_
#                   include "mem_interface.fh"
                   )
!***********************************************************************
!  Object: to compute the number of real*8 the kernel routine will     *
!          need for the computation of a matrix element between two    *
!          cartesian Gaussian functions with the total angular momentum*
!          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
!          lr is the order of the operator (this is only used when the *
!          integrals are computed with the Hermite-Gauss quadrature).  *
!                                                                      *
!  Called from: OneEl_g                                                *
!                                                                      *
!  author: Ben Swerts                                                  *
!  modified: Liviu Ungur                                               *
!  based on PrjMmG                                                     *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp, Shells
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: nOrder, maxDensSize, iCnttp, jCnttp, iAng, jAng, iShll, jShll, ip, nac, ncb, nExpi, nExpj, nBasisi, nBasisj

nOrder = 0
Mem = 0
maxDensSize = 0
! largest possible fragment energy weighted density matrix
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%nFragType > 0) maxDensSize = max(maxDensSize,dbsc(iCnttp)%nFragDens*(dbsc(iCnttp)%nFragDens+1)/2)
end do

do iCnttp=1,nCnttp
  if (.not. dbsc(iCnttp)%Frag) cycle

  do iAng=0,dbsc(iCnttp)%nVal-1
    iShll = dbsc(iCnttp)%iVal+iAng
    nExpi = Shells(iShll)%nExp
    nBasisi = Shells(iShll)%nBasis
    if (nExpi == 0 .or. nBasisi == 0) cycle

    do jCnttp=iCnttp,nCnttp
      ! still figure out how to loop only over the centers belonging to the
      ! same fragment (keep track of mdc?) ! still to be done !!!
      if (.not. dbsc(jCnttp)%Frag) cycle

      do jAng=0,dbsc(jCnttp)%nVal-1
        jShll = dbsc(jCnttp)%iVal+jAng
        nExpj = Shells(jShll)%nExp
        nBasisj = Shells(jShll)%nBasis
        if (nExpj == 0 .or. nBasisj == 0) cycle

        ip = 2*maxDensSize
        nac = 4*(la+1)*(la+2)/2*(iAng+1)*(iAng+2)/2
        ip = ip+nExpi*nac
        ip = ip+3*nExpi
        ip = ip+nExpi
        ip = ip+nExpi
        ip = ip+nExpi
        nHer = ((la+1)+iAng+2)/2
        nOrder = max(nHer,nOrder)
        ip = ip+nExpi*3*nHer*(la+2)
        ip = ip+nExpi*3*nHer*(iAng+1)
        ip = ip+nExpi*3*nHer*(lr+1)
        ip = ip+nExpi*3*nHer*(la+2)*(iAng+1)*(lr+1)
        ip = ip+nExpi

        Mem = max(Mem,ip)
        ip = ip-nExpi*(6+3*nHer*((la+2)+(iAng+1)+(lr+1)+(la+2)*(iAng+1)*(lr+1))+1)

        ncb = 4*(jAng+1)*(jAng+2)/2*(lb+1)*(lb+2)/2
        ip = ip+nExpj*ncb
        ip = ip+3*nExpj
        ip = ip+nExpj
        ip = ip+nExpj
        ip = ip+nExpj
        nHer = ((lb+1)+jAng+2)/2
        nOrder = max(nHer,nOrder)
        ip = ip+nExpj*3*nHer*(lb+2)
        ip = ip+nExpj*3*nHer*(jAng+1)
        ip = ip+nExpj*3*nHer*(lr+1)
        ip = ip+nExpj*3*nHer*(lb+2)*(jAng+1)*(lr+1)
        ip = ip+nExpj

        Mem = max(Mem,ip)
        ip = ip-nExpj*(6+3*nHer*((lb+2)+(jAng+1)+(lr+1)+(lb+2)*(jAng+1)*(lr+1))+1)

        ip = ip+max(max(nExpi,nBasisj)*nac,ncb*nBasisj)
        Mem = max(Mem,ip)
      end do  !jAng

    end do  !jCnttp

  end do !iAng

end do ! iCnttp
nHer = nOrder

return

end subroutine FragPMmG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ORTHO1(S,U,V,N,M)
C
C     Purpose: Orthonormalize N times N vector set U.
C
C     Called from ORTHO.
C
C     Subroutine calls: ORTHO2.
C
C     ********** IBM-3090 Release 88 10 10 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION S(*),U(*),V(*)
      THR=0.2D0
      IBASE=1
C
      DO I=1,M

10     CONTINUE
       CALL ORTHO2(S,U(IBASE),V(IBASE),N)
C     Normalize U and calculate V=S*U.
       XNORM=1.0D0
       JBASE=1
       DO J=1,I-1
        OVL=DDOT_(N,U(IBASE),1,V(JBASE),1)
        OVL1=-OVL
        CALL DAXPY_(N,OVL1,U(JBASE),1,U(IBASE),1)
        XNORM=XNORM-OVL**2
        IF (XNORM.LT.THR) GOTO 10
        JBASE=JBASE+N
       END DO
       CALL ORTHO2(S,U(IBASE),V(IBASE),N)
       IBASE=IBASE+N

      END DO

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************

!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*
subroutine SIGMA1(SGS,CIS,EXS,IP,IQ,CPQ,ISYCI,CI,SGM)

use Symmetry_Info, only: Mul
use gugx, only: CIStruct, EXStruct, SGStruct
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(in) :: CIS
type(EXStruct), intent(inout) :: EXS
integer(kind=iwp), intent(in) :: IP, IQ, ISYCI
real(kind=wp), intent(in) :: CPQ, CI(*)
real(kind=wp), intent(_OUT_) :: SGM(*)
integer(kind=iwp) :: I, IC, ICS, INDEO, IOC, IOLW, IOUW, IPPOW, IPSHFT, ISGSTA, ISTA, ISYDC, ISYDSG, ISYP, ISYPQ, ISYQ, ISYSGM, &
                     ISYUC, ISYUSG, J, JC, JSTA, LICP, LLW, LUW, MV1, MV2, MV4, MV5, MVSGM, NCP, NDWNC, NDWNSG, NS1, NTMP, NUPC, &
                     NUPSG
real(kind=wp) :: X

!***********************************************************************
!  GIVEN ACTIVE LEVEL INDICES IP AND IQ, AND INPUT CI ARRAYS
!  CI AND SGM, THIS ROUTINE ADDS TO SGM THE RESULT OF ACTING ON
!  CI WITH THE NUMBER CPQ TIMES THE EXCITATION OPERATOR E(IP,IQ).
!  THE ADDITIONAL ENTRIES IN THE PARAMETER LIST ARE TABLES THAT
!  WERE PREPARED BY GINIT AND ITS SUBROUTINES.
!***********************************************************************

if (abs(CPQ) < 1.0e-12_wp) return

! SYMMETRY OF ORBITALS:
ISYP = SGS%ISm(IP)
ISYQ = SGS%ISm(IQ)
ISYPQ = Mul(ISYP,ISYQ)
! SYMMETRY OF SIGMA ARRAY:
ISYSGM = Mul(ISYPQ,ISYCI)

if (IQ < IP) then
  ! THEN THIS IS AN EXCITING OPERATOR.
  if (IP <= SGS%MidLev) then

    ! EXCITING CASE, IQ<IP<=MIDLEV.
    do MVSGM=1,CIS%nMidV
      do ISYUSG=1,SGS%nSym
        NS1 = CIS%NOCSF(ISYUSG,MVSGM,ISYSGM)
        if (NS1 == 0) cycle
        ISYDSG = Mul(ISYUSG,ISYSGM)
        ISYDC = Mul(ISYPQ,ISYDSG)
        NDWNC = CIS%NOW(2,ISYDC,MVSGM)
        if (NDWNC == 0) cycle
        ISGSTA = 1+CIS%IOCSF(ISYUSG,MVSGM,ISYSGM)
        NUPSG = CIS%NOW(1,ISYUSG,MVSGM)
        IOC = CIS%IOCSF(ISYUSG,MVSGM,ISYCI)
        INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
        NCP = EXS%NOCP(INDEO,ISYDC,MVSGM)
        if (NCP > 0) then
          LICP = 1+EXS%IOCP(INDEO,ISYDC,MVSGM)
          ! CASE IS: LOWER HALF, EXCITE:
          call EXC1(CPQ,NUPSG,CI(IOC+1),SGM(ISGSTA),NCP,EXS%ICOUP(1,LICP))
        end if
      end do
    end do

  else if (SGS%MidLev < IQ) then

    ! EXCITING CASE, MIDLEV<IQ<IP
    do MVSGM=1,CIS%nMidV
      do ISYUSG=1,SGS%nSym
        NS1 = CIS%NOCSF(ISYUSG,MVSGM,ISYSGM)
        if (NS1 == 0) cycle
        ISYUC = Mul(ISYPQ,ISYUSG)
        NUPC = CIS%NOW(1,ISYUC,MVSGM)
        if (NUPC == 0) cycle
        ISGSTA = 1+CIS%IOCSF(ISYUSG,MVSGM,ISYSGM)
        NUPSG = CIS%NOW(1,ISYUSG,MVSGM)
        ISYDSG = Mul(ISYUSG,ISYSGM)
        NDWNSG = CIS%NOW(2,ISYDSG,MVSGM)
        IOC = CIS%IOCSF(ISYUC,MVSGM,ISYCI)
        INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
        NCP = EXS%NOCP(INDEO,ISYUC,MVSGM)
        if (NCP == 0) cycle
        LICP = 1+EXS%IOCP(INDEO,ISYUC,MVSGM)
        ! CASE IS: UPPER HALF, EXCITE:
        call EXC2(CPQ,NDWNSG,NUPC,CI(IOC+1),NUPSG,SGM(ISGSTA),NCP,EXS%ICOUP(1,LICP))
      end do
    end do

  else

    ! EXCITING CASE, IQ<=MIDLEV<IP
    do MVSGM=1,CIS%nMidV
      MV1 = EXS%MVL(MVSGM,2)
      MV2 = EXS%MVL(MVSGM,1)
      if ((MV1 == 0) .and. (MV2 == 0)) cycle
      do ISYUSG=1,SGS%nSym
        NS1 = CIS%NOCSF(ISYUSG,MVSGM,ISYSGM)
        if (NS1 == 0) cycle
        ISGSTA = 1+CIS%IOCSF(ISYUSG,MVSGM,ISYSGM)
        NUPSG = CIS%NOW(1,ISYUSG,MVSGM)
        ISYDSG = Mul(ISYUSG,ISYSGM)
        ISYUC = Mul(ISYP,ISYUSG)
        ISYDC = Mul(ISYQ,ISYDSG)
        if (MV2 /= 0) then
          NUPC = CIS%NOW(1,ISYUC,MV2)
          if (NUPC /= 0) then
            NDWNC = CIS%NOW(2,ISYDC,MV2)
            if (NDWNC /= 0) then
              INDEO = IP
              NCP = EXS%NOCP(INDEO,ISYUC,MV2)
              if (NCP /= 0) then
                NTMP = NUPSG*NDWNC
                EXS%SGTMP(1:NTMP) = Zero
                LICP = 1+EXS%IOCP(INDEO,ISYUC,MV2)
                IOC = CIS%IOCSF(ISYUC,MV2,ISYCI)
                ! CASE IS: UPPER HALF, EXCITE:
                call EXC2(CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,EXS%SGTMP,NCP,EXS%ICOUP(1,LICP))
                INDEO = IQ
                NCP = EXS%NOCP(INDEO,ISYDC,MV2)
                if (NCP /= 0) then
                  LICP = 1+EXS%IOCP(INDEO,ISYDC,MV2)
                  ! CASE IS: LOWER HALF, EXCITE:
                  call EXC1(One,NUPSG,EXS%SGTMP,SGM(ISGSTA),NCP,EXS%ICOUP(1,LICP))
                end if
              end if
            end if
          end if
        end if

        if (MV1 /= 0) then
          NUPC = CIS%NOW(1,ISYUC,MV1)
          if (NUPC /= 0) then
            NDWNC = CIS%NOW(2,ISYDC,MV1)
            if (NDWNC /= 0) then
              INDEO = SGS%nLev+IP
              NCP = EXS%NOCP(INDEO,ISYUC,MV1)
              if (NCP /= 0) then
                NTMP = NUPSG*NDWNC
                EXS%SGTMP(1:NTMP) = Zero
                LICP = 1+EXS%IOCP(INDEO,ISYUC,MV1)
                IOC = CIS%IOCSF(ISYUC,MV1,ISYCI)
                ! CASE IS: UPPER HALF, EXCITE:
                call EXC2(CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,EXS%SGTMP,NCP,EXS%ICOUP(1,LICP))
                INDEO = SGS%nLev+IQ
                NCP = EXS%NOCP(INDEO,ISYDC,MV1)
                if (NCP == 0) cycle
                LICP = 1+EXS%IOCP(INDEO,ISYDC,MV1)
                ! CASE IS: LOWER HALF, EXCITE:
                call EXC1(One,NUPSG,EXS%SGTMP,SGM(ISGSTA),NCP,EXS%ICOUP(1,LICP))
              end if
            end if
          end if
        end if
      end do
    end do

  end if
else if (IP < IQ) then
  ! THEN THIS IS A DEEXCITING OPERATOR.
  if (IQ <= SGS%MidLev) then

    ! DEEXCITING OPERATOR, IP<IQ<=MIDLEV.
    do MVSGM=1,CIS%nMidV
      do ISYUSG=1,SGS%nSym
        NS1 = CIS%NOCSF(ISYUSG,MVSGM,ISYSGM)
        if (NS1 == 0) cycle
        ISYDSG = Mul(ISYUSG,ISYSGM)
        ISYDC = Mul(ISYPQ,ISYDSG)
        NDWNC = CIS%NOW(2,ISYDC,MVSGM)
        if (NDWNC == 0) cycle
        ISGSTA = 1+CIS%IOCSF(ISYUSG,MVSGM,ISYSGM)
        NUPSG = CIS%NOW(1,ISYUSG,MVSGM)
        IOC = CIS%IOCSF(ISYUSG,MVSGM,ISYCI)
        INDEO = 2*SGS%nLev+(IQ*(IQ-1))/2+IP
        NCP = EXS%NOCP(INDEO,ISYDSG,MVSGM)
        if (NCP == 0) cycle
        LICP = 1+EXS%IOCP(INDEO,ISYDSG,MVSGM)
        ! CASE IS: LOWER HALF, DEEXCITE:
        call DEX1(CPQ,NUPSG,CI(IOC+1),SGM(ISGSTA),NCP,EXS%ICOUP(1,LICP))
      end do
    end do

  else if (SGS%MidLev < IP) then

    ! DEEXCITING OPERATOR, MIDLEV<IP<IQ
    do MVSGM=1,CIS%nMidV
      do ISYUSG=1,SGS%nSym
        NS1 = CIS%NOCSF(ISYUSG,MVSGM,ISYSGM)
        if (NS1 == 0) cycle
        ISYUC = Mul(ISYPQ,ISYUSG)
        NUPC = CIS%NOW(1,ISYUC,MVSGM)
        if (NUPC == 0) cycle
        ISGSTA = 1+CIS%IOCSF(ISYUSG,MVSGM,ISYSGM)
        NUPSG = CIS%NOW(1,ISYUSG,MVSGM)
        ISYDSG = Mul(ISYUSG,ISYSGM)
        NDWNSG = CIS%NOW(2,ISYDSG,MVSGM)
        IOC = CIS%IOCSF(ISYUC,MVSGM,ISYCI)
        INDEO = 2*SGS%nLev+(IQ*(IQ-1))/2+IP
        NCP = EXS%NOCP(INDEO,ISYUSG,MVSGM)
        if (NCP == 0) cycle
        LICP = 1+EXS%IOCP(INDEO,ISYUSG,MVSGM)
        ! CASE IS: UPPER HALF, DEEXCITE:
        call DEX2(CPQ,NDWNSG,NUPC,CI(IOC+1),NUPSG,SGM(ISGSTA),NCP,EXS%ICOUP(1,LICP))
      end do
    end do

  else

    ! DEEXCITING CASE, IP<=MIDLEV<IQ.
    do MVSGM=1,CIS%nMidV
      MV4 = EXS%MVR(MVSGM,1)
      MV5 = EXS%MVR(MVSGM,2)
      do ISYUSG=1,SGS%nSym
        NS1 = CIS%NOCSF(ISYUSG,MVSGM,ISYSGM)
        if (NS1 == 0) cycle
        ISGSTA = 1+CIS%IOCSF(ISYUSG,MVSGM,ISYSGM)
        NUPSG = CIS%NOW(1,ISYUSG,MVSGM)
        ISYDSG = Mul(ISYUSG,ISYSGM)
        ISYUC = Mul(ISYQ,ISYUSG)
        ISYDC = Mul(ISYP,ISYDSG)
        if (MV4 /= 0) then
          NUPC = CIS%NOW(1,ISYUC,MV4)
          if (NUPC /= 0) then
            NDWNC = CIS%NOW(2,ISYDC,MV4)
            if (NDWNC /= 0) then
              INDEO = IQ
              NCP = EXS%NOCP(INDEO,ISYUSG,MVSGM)
              if (NCP /= 0) then
                NTMP = NUPSG*NDWNC
                EXS%SGTMP(1:NTMP) = Zero
                LICP = 1+EXS%IOCP(INDEO,ISYUSG,MVSGM)
                IOC = CIS%IOCSF(ISYUC,MV4,ISYCI)
                ! CASE IS: UPPER HALF, DEEXCITE:
                call DEX2(CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,EXS%SGTMP,NCP,EXS%ICOUP(1,LICP))
                INDEO = IP
                NCP = EXS%NOCP(INDEO,ISYDSG,MVSGM)
                if (NCP /= 0) then
                  LICP = 1+EXS%IOCP(INDEO,ISYDSG,MVSGM)
                  ! CASE IS: LOWER HALF, DEEXCITE:
                  call DEX1(One,NUPSG,EXS%SGTMP,SGM(ISGSTA),NCP,EXS%ICOUP(1,LICP))
                end if
              end if
            end if
          end if
        end if

        if (MV5 == 0) cycle
        NUPC = CIS%NOW(1,ISYUC,MV5)
        if (NUPC == 0) cycle
        NDWNC = CIS%NOW(2,ISYDC,MV5)
        if (NDWNC == 0) cycle
        INDEO = SGS%nLev+IQ
        NCP = EXS%NOCP(INDEO,ISYUSG,MVSGM)
        if (NCP == 0) cycle
        NTMP = NUPSG*NDWNC
        EXS%SGTMP(1:NTMP) = Zero
        LICP = 1+EXS%IOCP(INDEO,ISYUSG,MVSGM)
        IOC = CIS%IOCSF(ISYUC,MV5,ISYCI)
        ! CASE IS: UPPER HALF, DEEXCITE:
        call DEX2(CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,EXS%SGTMP,NCP,EXS%ICOUP(1,LICP))
        INDEO = SGS%nLev+IP
        NCP = EXS%NOCP(INDEO,ISYDSG,MVSGM)
        if (NCP == 0) cycle
        LICP = 1+EXS%IOCP(INDEO,ISYDSG,MVSGM)
        ! CASE IS: LOWER HALF, DEEXCITE:
        call DEX1(One,NUPSG,EXS%SGTMP,SGM(ISGSTA),NCP,EXS%ICOUP(1,LICP))
      end do
    end do

  end if
else
  ! THEN THIS IS A SPECIAL CASE.
  if (IP > SGS%MidLev) then

    ! SPECIAL CASE: WEIGHT OPERATOR, IP=IQ.
    ! IP=IQ>MIDLEV
    do MVSGM=1,CIS%nMidV
      do ISYUSG=1,SGS%nSym
        NS1 = CIS%NOCSF(ISYUSG,MVSGM,ISYSGM)
        if (NS1 == 0) cycle
        ISGSTA = 1+CIS%IOCSF(ISYUSG,MVSGM,ISYSGM)
        NUPSG = CIS%NOW(1,ISYUSG,MVSGM)
        ISYDSG = Mul(ISYUSG,ISYSGM)
        NDWNSG = CIS%NOW(2,ISYDSG,MVSGM)
        IOUW = CIS%IOW(1,ISYUSG,MVSGM)
        IPSHFT = 2*(IP-1-SGS%MidLev)
        LUW = 1+IOUW-CIS%nIpWlk+IPSHFT/30
        IPSHFT = mod(IPSHFT,30)
        IPPOW = 2**IPSHFT
        do I=1,NUPSG
          IC = CIS%ICase(LUW+I*CIS%nIpWlk)
          ICS = mod(IC/IPPOW,4)
          if (ICS == 0) cycle
          X = CPQ*real((1+ICS)/2,kind=wp)
          ISTA = ISGSTA-1+I
          call DAXPY_(NDWNSG,X,CI(ISTA),NUPSG,SGM(ISTA),NUPSG)
        end do
      end do
    end do

  else

    ! SPECIAL CASE: WEIGHT OPERATOR, IP=IQ.
    ! IP=IQ < MIDLEV.
    do MVSGM=1,CIS%nMidV
      do ISYUSG=1,SGS%nSym
        NS1 = CIS%NOCSF(ISYUSG,MVSGM,ISYSGM)
        if (NS1 == 0) cycle
        ISGSTA = 1+CIS%IOCSF(ISYUSG,MVSGM,ISYSGM)
        NUPSG = CIS%NOW(1,ISYUSG,MVSGM)
        ISYDSG = Mul(ISYUSG,ISYSGM)
        NDWNSG = CIS%NOW(2,ISYDSG,MVSGM)
        IOLW = CIS%IOW(2,ISYDSG,MVSGM)
        IPSHFT = 2*(IP-1)
        LLW = 1+IOLW-CIS%nIpWlk+IPSHFT/30
        IPSHFT = mod(IPSHFT,30)
        IPPOW = 2**IPSHFT
        do J=1,NDWNSG
          JC = CIS%ICase(LLW+J*CIS%nIpWlk)
          ICS = mod(JC/IPPOW,4)
          if (ICS == 0) cycle
          X = CPQ*real((1+ICS)/2,kind=wp)
          JSTA = ISGSTA+NUPSG*(J-1)
          SGM(JSTA:JSTA+NUPSG-1) = SGM(JSTA:JSTA+NUPSG-1)+X*CI(JSTA:JSTA+NUPSG-1)
        end do
      end do
    end do

  end if
end if

contains

subroutine EXC1(CPQ,NUP,A,B,NCP,ICOUP)

  integer(kind=iwp), intent(in) :: NUP, NCP, ICOUP(3,NCP)
  real(kind=wp), intent(in) :: CPQ, A(NUP,*)
  real(kind=wp), intent(inout) :: B(NUP,*)
  integer(kind=iwp) :: ICP, JLFT, JRGT
  real(kind=wp) :: X

  ! CASE: ADD EPQ*A TO B, WHERE Q<P<=MIDLEV AND A AND B ARE SINGLE
  ! MATRIX BLOCKS.
  ! ONLY LOWER WALKS AFFECTED => COLUMN OPERATION.
  ! P>Q, EXCITING OPERATOR  => A IS  LEFTHAND WALK.
  ! USE VECTOR ROUTINE CALL IF LONG ENOUGH:
  if (NUP > 20) then
    do ICP=1,NCP
      JLFT = ICOUP(1,ICP)
      JRGT = ICOUP(2,ICP)
      X = CPQ*EXS%VTab(ICOUP(3,ICP))
      call DAXPY_(NUP,X,A(:,JLFT),1,B(:,JRGT),1)
    end do
  else
    do ICP=1,NCP
      JLFT = ICOUP(1,ICP)
      JRGT = ICOUP(2,ICP)
      X = CPQ*EXS%VTab(ICOUP(3,ICP))
      B(:,JRGT) = B(:,JRGT)+X*A(:,JLFT)
    end do
  end if

end subroutine EXC1

subroutine EXC2(CPQ,NDWN,NUPA,A,NUPB,B,NCP,ICOUP)

  integer(kind=iwp), intent(in) :: NDWN, NUPA, NUPB, NCP, ICOUP(3,NCP)
  real(kind=wp), intent(in) :: CPQ, A(NUPA,NDWN)
  real(kind=wp), intent(inout) :: B(NUPB,NDWN)
  integer(kind=iwp) :: ICP, ILFT, IRGT
  real(kind=wp) :: X

  ! CASE: ADD EPQ*A TO B, WHERE MIDLEV<Q<P AND A AND B ARE SINGLE
  ! MATRIX BLOCKS.
  ! ONLY UPPER WALKS AFFECTED =>    ROW OPERATION.
  ! Q<P, EXCITING OPERATOR  => A IS  LEFTHAND WALK.
  if (NDWN > 20) then
    do ICP=1,NCP
      ILFT = ICOUP(1,ICP)
      IRGT = ICOUP(2,ICP)
      X = CPQ*EXS%VTab(ICOUP(3,ICP))
      call DAXPY_(NDWN,X,A(ILFT,1),NUPA,B(IRGT,1),NUPB)
    end do
  else
    do ICP=1,NCP
      ILFT = ICOUP(1,ICP)
      IRGT = ICOUP(2,ICP)
      X = CPQ*EXS%VTab(ICOUP(3,ICP))
      B(IRGT,:) = B(IRGT,:)+X*A(ILFT,:)
    end do
  end if

end subroutine EXC2

subroutine DEX1(CPQ,NUP,A,B,NCP,ICOUP)

  integer(kind=iwp), intent(in) :: NUP, NCP, ICOUP(3,NCP)
  real(kind=wp), intent(in) :: CPQ, A(NUP,*)
  real(kind=wp), intent(inout) :: B(NUP,*)
  integer(kind=iwp) :: ICP, JLFT, JRGT
  real(kind=wp) :: X

  ! CASE: ADD EPQ*A TO B, WHERE P<Q<=MIDLEV AND A AND B ARE SINGLE
  ! MATRIX BLOCKS.
  ! ONLY LOWER WALKS AFFECTED => COLUMN OPERATION.
  ! P<Q, DEEXCITING OPERATOR  => A IS RIGHTHAND WALK.
  ! CHOSE DAXPY IF LARGE VECTOR LENGTH:
  if (NUP > 20) then
    do ICP=1,NCP
      JLFT = ICOUP(1,ICP)
      JRGT = ICOUP(2,ICP)
      X = CPQ*EXS%VTab(ICOUP(3,ICP))
      call DAXPY_(NUP,X,A(:,JRGT),1,B(:,JLFT),1)
    end do
  else
    do ICP=1,NCP
      JLFT = ICOUP(1,ICP)
      JRGT = ICOUP(2,ICP)
      X = CPQ*EXS%VTab(ICOUP(3,ICP))
      B(:,JLFT) = B(:,JLFT)+X*A(:,JRGT)
    end do
  end if

end subroutine DEX1

subroutine DEX2(CPQ,NDWN,NUPA,A,NUPB,B,NCP,ICOUP)

  integer(kind=iwp), intent(in) :: NDWN, NUPA, NUPB, NCP, ICOUP(3,NCP)
  real(kind=wp), intent(in) :: CPQ, A(NUPA,NDWN)
  real(kind=wp), intent(inout) :: B(NUPB,NDWN)
  integer(kind=iwp) :: ICP, ILFT, IRGT
  real(kind=wp) :: X

  ! CASE: ADD EPQ*A TO B, WHERE MIDLEV<P<Q AND A AND B ARE SINGLE
  ! MATRIX BLOCKS.
  ! ONLY UPPER WALKS AFFECTED =>    ROW OPERATION.
  ! P<Q, DEEXCITING OPERATOR  => A IS RIGHTHAND WALK.
  ! CHOSE DAXPY IF LARGE LENGTH.
  if (NDWN > 20) then
    do ICP=1,NCP
      ILFT = ICOUP(1,ICP)
      IRGT = ICOUP(2,ICP)
      X = CPQ*EXS%VTab(ICOUP(3,ICP))
      call DAXPY_(NDWN,X,A(IRGT,1),NUPA,B(ILFT,1),NUPB)
    end do
  else
    do ICP=1,NCP
      ILFT = ICOUP(1,ICP)
      IRGT = ICOUP(2,ICP)
      X = CPQ*EXS%VTab(ICOUP(3,ICP))
      B(ILFT,:) = B(ILFT,:)+X*A(IRGT,:)
    end do
  end if

end subroutine DEX2

end subroutine SIGMA1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION CHO_RS2F(LAB,ISHLAB,ISYMAB,IRED)
C
C     Purpose: return index in reduced set IRED (1,2,3) of
C              element LAB in shell pair ISHLAB (sym. ISYMAB).
C              If not included in this reduced set, 0 is returned.
C
      use ChoSwp, only: nnBstRSh, iiBstRSh, IndRed
#include "implicit.fh"
#include "cholesky.fh"

      CHARACTER*8 SECNAM
      PARAMETER (SECNAM = 'CHO_RS2F')

      INTEGER K, K2

      CHO_RS2F = 0

      K  = IIBSTR(ISYMAB,IRED) + IIBSTRSH(ISYMAB,ISHLAB,IRED)
      K2 = K + NNBSTRSH(ISYMAB,ISHLAB,IRED)
      IF (IRED .EQ. 1) THEN
         DO WHILE (K.LT.K2 .AND. CHO_RS2F.EQ.0)
            K = K + 1
            IF (INDRED(K,1) .EQ. LAB) THEN
               CHO_RS2F = K
            END IF
         END DO
      ELSE IF (IRED.EQ.2 .OR. IRED.EQ.3) THEN
         DO WHILE (K.LT.K2 .AND. CHO_RS2F.EQ.0)
            K = K + 1
            IF (INDRED(INDRED(K,IRED),1) .EQ. LAB) THEN
               CHO_RS2F = K
            END IF
         END DO
      ELSE
         CALL CHO_QUIT('IRED error in '//SECNAM,104)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRCNFTAB(CnfTab,MXPRT)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: CnfTab(*), MxPrt
integer(kind=iwp) :: ICNF, IERR, IFORM, IGAS, ISUM, ISYM, ITYPE, KCNFSTA, KSTA, LENCNF, LENGTH, LGASLIM, LGASORB, LIM1, LIM2, &
                     LINFO, LSYM, MAXOP, MINOP, NCLS, NCNF, NEL, NGAS, NOPN, NORB, NPRT, NSYM, NTAB
character(len=144) :: TEXT

! Sanity test:
NPRT = min(MXPRT,10000)
! header:
NTAB = CnfTab(1)
ITYPE = CnfTab(2)
NEL = CnfTab(3)
NORB = CnfTab(4)
MINOP = CnfTab(5)
MAXOP = CnfTab(6)
NSYM = CnfTab(7)
LSYM = CnfTab(8)
NGAS = CnfTab(9)
IFORM = CnfTab(10)
write(u6,*) '---------------------------------------------------'
write(u6,*) '       Configuration Table Printout'
write(u6,*) ' Table header:'
write(u6,'(1x,a,i16)') ' Table size             NTAB=',NTAB
write(u6,'(1x,a,i16)') ' Nr of electrons         NEL=',NEL
write(u6,'(1x,a,i16)') ' Nr of orbitals         NORB=',NORB
write(u6,'(1x,a,i16)') ' Min nr of open shells MINOP=',MINOP
write(u6,'(1x,a,i16)') ' Max nr of open shells MAXOP=',MAXOP
write(u6,'(1x,a,i16)') ' Point group order      NSYM=',NSYM
write(u6,'(1x,a,i16)') ' Selected symmetry      LSYM=',LSYM
write(u6,'(1x,a,i16)') ' Nr of GAS restrictions NGAS=',NGAS
write(u6,'(1x,a,i16)') ' Configuration format  IFORM=',IFORM
if (ITYPE /= 37) then
  write(u6,*) ' PRCNFTAB error: This is not a configuration table!'
  call ABEND()
end if
IERR = 0
if (NEL < 0) IERR = IERR+1
if (NEL > 99) IERR = IERR+1
if (NORB < 0) IERR = IERR+1
if (NORB > 199) IERR = IERR+1
if (MINOP < 0) IERR = IERR+1
if (MAXOP < MINOP) IERR = IERR+1
if (NSYM < 1) IERR = IERR+1
if (NSYM > 8) IERR = IERR+1
if (LSYM < 0) IERR = IERR+1
if (LSYM > NSYM) IERR = IERR+1
if (NGAS < 0) IERR = IERR+1
if (NGAS > 19) IERR = IERR+1
if (IFORM < 1) IERR = IERR+1
if (IFORM > 4) IERR = IERR+1
if (IERR > 0) then
  write(u6,*) ' PRCNFTAB error: Those values are unacceptable!'
  call ABEND()
end if
LGASORB = 11
LGASLIM = LGASORB+(NSYM+1)*(NGAS+1)
if (NGAS > 0) then
  write(u6,*)
  write(u6,*) ' Orbitals by symmetry in GAS partitions:'
  write(u6,'(A,8I5)') ' Space       Tot     ',(ISYM,ISYM=1,NSYM)
  write(u6,'(1X,A,5X,I5,5X,8I5)') 'Active',CnfTab(LGASORB),(CnfTab(LGASORB+ISYM),ISYM=1,NSYM)
  do IGAS=1,NGAS
    write(u6,'(1X,A,I2,5X,I5,5X,8I5)') 'GAS',IGAS,CnfTab(LGASORB+(NSYM+1)*IGAS),(CnfTab(LGASORB+ISYM+(NSYM+1)*IGAS),ISYM=1,NSYM)
  end do
  write(u6,*) ' GAS orbital partitions, min and max population:'
  do IGAS=1,NGAS
    ISUM = CnfTab(LGASORB+(NSYM+1)*IGAS)
    LIM1 = CnfTab(LGASLIM+2*(IGAS-1))
    LIM2 = CnfTab(LGASLIM+1+2*(IGAS-1))
    write(u6,'(1X,A,I2,5X,3I5)') 'GAS',IGAS,ISUM,LIM1,LIM2
  end do
end if
LINFO = LGASLIM+2*NGAS
write(u6,*)
write(u6,*) ' INFO table starts at LINFO=',LINFO
do NOPN=MINOP,MAXOP
  NCLS = (NEL-NOPN)/2
  do ISYM=1,NSYM
    NCNF = CnfTab(LINFO+0+3*(ISYM-1+NSYM*(NOPN-MINOP)))
    KCNFSTA = CnfTab(LINFO+1+3*(ISYM-1+NSYM*(NOPN-MINOP)))
    LENCNF = CnfTab(LINFO+2+3*(ISYM-1+NSYM*(NOPN-MINOP)))
    if (NCNF /= 0) then
      write(u6,*)
      write(u6,*) '  NOPN ISYM       Nr of conf Start point  Words/config'
      write(u6,'(1X,2I4,5X,3I12)') NOPN,ISYM,NCNF,KCNFSTA,LENCNF
      if (NCNF > NPRT) then
        write(u6,'(1X,A,I5)') ' The first NPRT configurations. NPRT=',NPRT
      else
        write(u6,*) ' Configurations:'
      end if
      KSTA = KCNFSTA
      do ICNF=1,min(NCNF,NPRT)
        call CNF2TXT(IFORM,NORB,NCLS,NOPN,CnfTab(KSTA),LENGTH,TEXT)
        KSTA = KSTA+LENCNF
        if (LENGTH <= 72) then
          write(u6,'(8X,A)') TEXT(1:LENGTH)
        else
          write(u6,'(8X,A)') TEXT(1:72)
          write(u6,'(8X,A)') TEXT(73:LENGTH)
        end if
      end do
      if (NCNF > NPRT) write(u6,*) ' ( ...and more. This list was truncated.)'
    end if
  end do
end do

end subroutine PRCNFTAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SUSCEPTIBILITY( NSS, ESO, S_SO, DIPSO, nT, nTempMagn,
     &                           T, tmin, tmax, XTexp, zJ, tinput,
     &                           chiT_theta, doplot, iPrint, mem )

      Implicit None
      Integer, Parameter            :: wp=kind(0.d0)
      Integer          , intent(in) ::  nss, iprint, nT, nTempMagn, mem
      Real (kind=8)   , intent(in) :: eso(nss)
      Real (kind=8)   , intent(in) :: zJ, tmin, tmax
      Real (kind=8)   , intent(in) ::          T(nT+nTempMagn)
      Real (kind=8)   , intent(in) ::      XTexp(nT+nTempMagn)
      Real (kind=8)   , intent(out):: chit_theta(nT+nTempMagn )
      Complex (kind=8), intent(in) ::   s_so(3,nss,nss)
      Complex (kind=8), intent(in) ::  dipso(3,nss,nss)
      Logical          , intent(in) :: tinput
      Logical          , intent(in) :: doplot
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      this routine calculates the magnetic susceptibility and all related to it values.
c      the units are cgsemu: cm^3*k/mol
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#include "stdalloc.fh"
      Integer :: ic,jc,it,im,jm,j,i,info,jT,mem_local,RtoB
      Real (kind=8) :: det, xxm, Zst
      Real (kind=8) :: coeff_X, boltz_k, dev
      Logical        :: DBG
      External       :: dev
      Real(kind=8)  :: gtens(3), maxes(3,3)
      Real (kind=8), allocatable ::        chit_tens(:,:,:)
      Real (kind=8), allocatable ::  chit_theta_tens(:,:,:)
      Real (kind=8), allocatable ::           zstat1(:)
      Real (kind=8), allocatable ::             chit(:)
      Real (kind=8), allocatable ::      chi_theta_1(:)
      Real (kind=8), allocatable :: XMM(:,:)
      ! tensors for zJ /= 0
      Real (kind=8), allocatable :: XSM(:,:), XSS(:,:), XZJ(:,:),
     &                               unity(:,:), a_dir(:,:), a_inv(:,:)
      ! main values and axes of XT tensors:
      Real (kind=8), allocatable :: WT(:), ZT(:,:)
      Character(len=50) :: label
c constants used in this subrutine
      RtoB=8
      mem_local=0
      coeff_X=0.125048612_wp*3.0_wp
      boltz_k=0.6950356_wp !boltzmann constant

      DBG=.false.
      If(iPrint.gt.2) DBG=.true.

      Write(6,*)
      Write(6,'(100A)') (('%'),J=1,95)
      Write(6,'(35X,A)') 'CALCULATION OF THE MAGNETIC SUSCEPTIBILITY'
      Write(6,'(100A)') (('%'),J=1,95)

      Write(6,*)
      If (TINPUT) Then
        Write(6,'(5X,A)') 'Temperature dependence of the magnetic '//
     &                    'susceptibility calculated according '
        Write(6,'(5X,A)') 'to experimental values provided in the '//
     &                    'input'
      Else
        Write(6,'(5X,A)') 'Temperature dependence of the '//
     &                    'magnetic susceptibility calculated in'
        Write(6,'(5x,I3,a,f4.1,a,f6.1,a)') nT,' points, equally '//
     &                    'distributed in temperature range',
     &                     Tmin,' ---', Tmax,' K.'
      End If
        Write(6,'(5X,A)') 'The algorithm employed for XT=f(T) in '//
     &                    'this section is based on the zero '//
     &                    'magnetic field limit.'
      If(doplot) Then
        Write(6,'(5X,A)') 'The GNUPLOT script and correponding '//
     &                    'images are generated in $WorkDir'
      End If
      Write(6,*)
!-----------------------------------------------------------------------
      If(dbg) Write(6,*) 'Tmin       =',tmin
      If(dbg) Write(6,*) 'Tmax       =',tmax
      If(dbg) Write(6,*) '  nT       =',nT
      If(dbg) Write(6,*) '  nTempMagn=',nTempMagn
      If(dbg) Write(6,*) 'Temperature:', T(1:nT+nTempMagn)
      If(dbg) Write(6,*) 'ESO:', ESO(1:nss)
      If(dbg) Call prMom('SUSC: input  S_SO(l,i,j):', S_SO,nss)
      If(dbg) Call prMom('SUSC: input DIPSO(l,i,j):',DIPSO,nss)
      If(dbg) gtens=0.0_wp
      If(dbg) maxes=0.0_wp
      If(dbg) Call atens(DIPSO, nss, gtens, maxes, 2)
!-----------------------------------------------------------------------
C   ***********************************************************
C   *     Powder averaged high-T limit of susceptibility      *
C   *                   and g-tensor                          *
C   ***********************************************************
c      ee=0.0_wp
c      ee_2=0.0_wp
c      Do Iss=1,NSS
c        Do Jss=1,NSS
c          Do ic=1,3
c      ee=ee+DBLE(conjg(DipSO(ic,Iss,Jss))*DipSO(ic,Iss,Jss))
c       If(Iss.LE.4.AND.Jss.LE.4) Then
c      ee_2=ee_2+DBLE(conjg(DipSO(ic,Iss,Jss))*DipSO(ic,Iss,Jss))
c       End If
c          End Do ! ic
c        End Do ! Jss
c      End Do ! Iss
c      chiT_high=coeff_X*ee/DBLE(NSS)/3.0_wp
c      SS1=(DBLE(IGSM)-1.0_wp)**2.0_wp/4.0_wp+(DBLE(IGSM)-1.0_wp)/2.0_wp
c      chiT_high_2=coeff_X*ee_2/12.0_wp
c      g_high  =sqrt(chiT_high  /(coeff_X*SS1/3.0_wp))
c      g_high_2=sqrt(chiT_high_2/(coeff_X*SS1/3.0_wp))
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Call mma_allocate(chiT,       (nT+nTempMagn),'chiT')
      Call mma_allocate(Zstat1,     (nT+nTempMagn),'Zstat1')
      Call mma_allocate(chi_theta_1,(nT+nTempMagn),'chi_theta_1')
      Call mma_allocate(chiT_tens,  (nT+nTempMagn),3,3,'chiT_tens')
      Call mma_allocate(wt,3,'wt')
      Call mma_allocate(zt,3,3,'zt')
      Call dcopy_(     (nT+nTempMagn), [0.0_wp], 0, chiT,1)
      Call dcopy_(     (nT+nTempMagn), [0.0_wp], 0, chiT_theta,1)
      Call dcopy_(     (nT+nTempMagn), [0.0_wp], 0, Zstat1,1)
      Call dcopy_(     (nT+nTempMagn), [0.0_wp], 0, chi_theta_1,1)
      Call dcopy_( 3*3*(nT+nTempMagn), [0.0_wp], 0, chiT_tens,1)
      mem_local=mem_local+4*(nT+nTempMagn)*RtoB+3*3*(nT+nTempMagn)*RtoB

      If(zJ.eq.0) Then
         If(dbg) Write(6,*) 'SUSC:  zJ = 0'
         Call mma_allocate(XMM,3,3,'XMM')
         mem_local=mem_local+9*RtoB

         If(dbg) Write(6,*) 'SUSC:  memory allocated (local):'
         If(dbg) Write(6,*) 'mem_local=', mem_local
         If(dbg) Write(6,*) 'SUSC:  memory allocated (total):'
         If(dbg) Write(6,*) 'mem_total=', mem+mem_local

         Do iT=1,nT+nTempMagn
           Zst=0.0_wp
           Call dcopy_(3*3,[0.0_wp], 0, XMM,1)
           ! compute XT tensor for this temperature:
           Call chi( DipSO, DipSO, Eso, Nss, T(iT), Zst, XMM)
           If(dbg) Write(6,'(A,9F12.6)') 'XMM:', XMM(1:3,1:3)
           If(dbg) Write(6,'(A,9F12.6)') 'chiT:',
     &              coeff_X*(XMM(1,1)+XMM(2,2)+XMM(3,3))/3.0_wp, Zst

           ! Call dscal_( 3*3, coeff_X, XMM, 1 )
           do i=1,3
             do j=1,3
               chiT_tens(iT,i,j)=coeff_X*XMM(i,j)
             end do
           end do

!           Call dcopy_( 3*3, XMM, 1, chiT_tens(iT,:,:),1)
           ! compute the powder XT for this temperature:
           chiT(iT)       =coeff_X*(XMM(1,1)+XMM(2,2)+XMM(3,3))/3.0_wp

           If( abs(chit(iT)) < 1.0d-20) Then
              chit(iT)=1.d-20
           End If

           chit_theta(iT) =chiT(iT)
           chi_theta_1(iT)=   T(iT)/chiT(iT)
           Zstat1(iT)     =Zst
         End Do
         Call mma_deallocate(XMM)
      Else  ! i.e. when zJ .ne. 0.0_wp
         If(dbg) Write(6,*) 'SUSC:  zJ \= 0'
         ! allocate matrices:
         Call mma_allocate(chiT_theta_tens,(nT+nTempMagn),3,3,'XTT')
         ! initialize:
         Call dcopy_( 3*3*(nT+nTempMagn),[0.0_wp], 0, chiT_theta_tens,1)
         Call mma_allocate(XMM,3,3,'XMM')
         Call mma_allocate(XSM,3,3,'XSM')
         Call mma_allocate(XSS,3,3,'XSS')
         Call mma_allocate(XZJ,3,3,'XZJ')
         Call mma_allocate(A_dir,3,3,'A_dir')
         Call mma_allocate(A_inv,3,3,'A_inv')
         Call mma_allocate(Unity,3,3,'Unity')
         mem_local=mem_local+3*3*3*(nT+nTempMagn)*RtoB+7*3*3*RtoB
         If(dbg) Write(6,*) 'SUSC:  memory allocated (local):'
         If(dbg) Write(6,*) 'mem_local=', mem_local
         If(dbg) Write(6,*) 'SUSC:  memory allocated (total):'
         If(dbg) Write(6,*) 'mem_total=', mem+mem_local

         Do iT=1,nT+nTempMagn
           ! initialize temporary matrices:
           Call dcopy_(3*3,[0.0_wp], 0, XMM,1)
           Call dcopy_(3*3,[0.0_wp], 0, XSM,1)
           Call dcopy_(3*3,[0.0_wp], 0, XSS,1)
           Call dcopy_(3*3,[0.0_wp], 0, XZJ,1)
           Call dcopy_(3*3,[0.0_wp], 0, A_dir,1)
           Call dcopy_(3*3,[0.0_wp], 0, A_inv,1)
           Call dcopy_(3*3,[0.0_wp], 0, Unity,1)
           Unity(1,1)=1.0_wp
           Unity(2,2)=1.0_wp
           Unity(3,3)=1.0_wp
           det=0.0_wp
           Zst=0.0_wp
           ! compute tensors:
           Call chi( DipSO, DipSO, Eso, Nss, T(it), Zst, XMM)
           Call chi(  S_SO, DipSO, Eso, Nss, T(it), Zst, XSM)
           Call chi(  S_SO,  S_SO, Eso, Nss, T(it), Zst, XSS)
          ! form the A_dir matrix:
          ! A_dir(:,:) = 1(:,:)* kB * T(iT) - zJ*XSS(:,:)
          Call daxpy_(3*3,Boltz_k*T(iT),Unity,1,A_dir,1)
          Call daxpy_(3*3,          -zJ,  XSS,1,A_dir,1)
          ! invert it:
          Call REVERSE(A_dir,A_inv,DET)

          Do ic=1,3
            Do jc=1,3
              ! compute the trace of the product XSM*A*XSM
              xxm=0.0_wp
              Do im=1,3
                Do jm=1,3
                  xxm = xxm + XSM(im,ic) * A_inv(im,jm) * XSM(jm,jc)
                End Do
              End Do
              ! add this contribution to the total susceptibility tensor
              XZJ(ic,jc) = XMM(ic,jc) + zJ*xxm
            End Do ! jc
          End Do ! ic

           ! Scale the tensors by coeff_X factor:
           Call dscal_( 3*3, coeff_X, XMM, 1 )
           Call dscal_( 3*3, coeff_X, XZJ, 1 )
!          place the tensors in the corresponding part of the "big" arrays:
           Call dcopy_( 3*3, XMM, 1, chiT_tens(iT,:,:),1)
           Call dcopy_( 3*3, XZJ, 1, chiT_theta_tens(iT,:,:),1)
           ! compute powder:
           chiT(iT)      =(XMM(1,1)+XMM(2,2)+XMM(3,3))/3.0_wp
           chiT_theta(iT)=(XZJ(1,1)+XZJ(2,2)+XZJ(3,3))/3.0_wp

           If( abs(chit(iT)) < 1.0d-20) Then
              chit(iT)=1.d-20
           End If
           If( abs(chiT_theta(iT)) < 1.0d-20) Then
              chiT_theta(iT)=1.d-20
           End If

           chi_theta_1(iT)=   T(iT)/chiT_theta(iT)
           Zstat1(iT)     =Zst
        End Do ! iT
        Call mma_deallocate(XMM)
        Call mma_deallocate(XSM)
        Call mma_deallocate(XSS)
        Call mma_deallocate(XZJ)
        Call mma_deallocate(A_dir)
        Call mma_deallocate(A_inv)
        Call mma_deallocate(Unity)
      End If !zJ

C
C  WRITING SOME OF THE OUTPUT...
C
      Write(6,'(/)')
      Write(6,'(A)') '     |     T      | Statistical |    CHI*T    '//
     &'|    CHI*T    |     CHI     |    1/CHI    |'
      Write(6,'(A)') '     |            |  Sum (Z)    |    (zJ=0)   '//
     &'|             |             |             |'
      Write(6,'(A)') '     |            |             |             '//
     &'|             |             |             |'
      Write(6,'(A)') '-----|----------------------------------------'//
     &'------------------------------------------|'
      Write(6,'(A)') 'Units|   Kelvin   |    ---      |  cm3*K/mol  '//
     &'|  cm3*K/mol  |   cm3/mol   |   mol/cm3   |'
      Write(6,'(A)') '-----|----------------------------------------'//
     &'------------------------------------------|'

      Do iT=1,nT
        jT=iT+nTempMagn
        Write(6,'(A,F11.6,A,E12.5,A,F12.8,A,F12.8,A,E12.5,A,E12.5,A)')
     &   '     |',         T(jT),       ' |',     zstat1(jT),
     &       ' |',      chiT(jT),       ' |', chiT_theta(jT),
     &       ' |',chiT_theta(jT)/T(jT), ' |',chi_theta_1(jT),' |'
      End Do
      Write(6,'(A)') '-----|----------------------------------------'//
     &'------------------------------------------|'



      If(TINPUT) Then
        Write(6,'(/)')
        Write(6,'(5X,A      )') 'STANDARD DEVIATION OF THE CALCULATED'//
     &                          ' MAGNETIC SUSCEPTIBILITY'
        Write(6,'(5X,A,F12.7)') 'FROM EXPERIMENTAL VALUES PROVIDED '//
     &                          'IN THE INPUT FILE IS:',
     &  dev( nT, chit_theta( (1+nTempMagn):(nT+nTempMagn) ),
     &                XTexp( (1+nTempMagn):(nT+nTempMagn) ))

      End If

!-------------------------  PLOTs -------------------------------------!
      WRITE(label,'(A)') "no_field"
      IF ( DoPlot ) THEN
         IF ( tinput ) THEN
            Call plot_XT_with_Exp(label, nT,
     &                           T((1+nTempMagn):(nT+nTempMagn) ),
     &                  chit_theta((1+nTempMagn):(nT+nTempMagn) ),
     &                       XTexp((1+nTempMagn):(nT+nTempMagn) ), zJ )
         ELSE
            Call plot_XT_no_Exp( label, nT,
     &                           T((1+nTempMagn):(nT+nTempMagn) ),
     &                  chit_theta((1+nTempMagn):(nT+nTempMagn) ), zJ )
         END IF
      END IF
!------------------------- END PLOTs -------------------------------------!



c print out the main VAN VLECK SUSCEPTIBILITY TENSOR, its main values and main axes:
      If(zJ.eq.0.0_wp) Then

        Write(6,'(/)')
        Write(6,'(111A)') ('-',i=1,110),'|'
        Write(6,'(31X,A,22x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR'//
     &                           ' FOR zJ = 0,  in cm3*K/mol','|'
        Write(6,'(111A)') ('-',i=1,110),'|'
        Write(6,'(A   )') '     T(K)   |   |          '//
     &                    'Susceptibility Tensor'//
     &                    '      |    Main Values  |'//
     &                    '               Main Axes             |'
        Do iT=1,nT
          jT=iT+nTempMagn
          info=0
          Call dcopy_(  3, [0.0_wp], 0, wt,1)
          Call dcopy_(3*3, [0.0_wp], 0, zt,1)
          Call DIAG_R2( chiT_tens(jT,:,:) ,3,info,wt,zt)
          Write(6,'(A)') '------------|---'//
     &                   '|------- x --------- y --------- z ---'//
     &                   '|-----------------'//
     &                   '|------ x --------- y --------- z ----|'
          Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &             '            | x |',(chiT_tens(jT,1,j),j=1,3),
     &             ' |  X:',wt(1),'|',(zt(j,1),j=1,3),'|'
          Write(6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),
     &             '| y |',            (chiT_tens(jT,2,j),j=1,3),
     &             ' |  Y:',wt(2),'|',(zt(j,2),j=1,3),'|'
          Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &             '            | z |',(chiT_tens(jT,3,j),j=1,3),
     &             ' |  Z:',wt(3),'|',(zt(j,3),j=1,3),'|'
        End Do
        Write(6,'(111A)') ('-',i=1,110),'|'

      Else ! zJ .ne. 0.0_wp

        Write(6,'(/)')
        Write(6,'(111A)') ('-',i=1,110),'|'
        Write(6,'(31X,A,F7.4,15x,A)')
     &                'VAN VLECK SUSCEPTIBILITY TENSOR FOR zJ = ',zJ,
     &                ',  in cm3*K/mol','|'
        Write(6,'(111A)') ('-',i=1,110),'|'
        Write(6,'(A)')'     T(K)   |   |          Susceptibility '//
     &                'Tensor      |    Main Values  '//
     &                '|               Main Axes             |'
        Do iT=1,nT
          jT=iT+nTempMagn
          info=0
          Call dcopy_(  3, [0.0_wp], 0, wt,1)
          Call dcopy_(3*3, [0.0_wp], 0, zt,1)
          Call DIAG_R2( chiT_theta_tens(jT,:,:) ,3,info,wt,zt)
          Write(6,'(A)') '------------|---'//
     &                   '|------- x --------- y --------- z ---'//
     &                   '|-----------------'//
     &                   '|------ x --------- y --------- z ----|'
          Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &          '            | x |',(chiT_theta_tens(jT,1,j),j=1,3),
     &          ' |  X:',wt(1),'|',(zt(j,1),j=1,3),'|'
          Write(6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),
     &                      '| y |',(chiT_theta_tens(jT,2,j),j=1,3),
     &          ' |  Y:',wt(2),'|',(zt(j,2),j=1,3),'|'
          Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &          '            | z |',(chiT_theta_tens(jT,3,j),j=1,3),
     &          ' |  Z:',wt(3),'|',(zt(j,3),j=1,3),'|'
        End Do
        Write(6,'(111A)') ('-',i=1,110),'|'
         Call mma_deallocate(chiT_theta_tens)
      End If ! zJ

c      Write(6,'(/)')
c      Write(6,'(10A)') (('------------'), K=1,10)
c      Write(6,'(5X,A)') 'MAGNETIC SUSCEPTIBILITY IN THE DIRECTION '//
c     &'OF THE MAIN MAGNETIC AXES'
c      Write(6,'(10A)') (('------------'), K=1,10)
c      Write(6,*)
c      Write(6,'(7X,A)') 'T(K)         gx          gy          gz'
c      Write(6,*)
c      Do iT=1,nT
c      Write(6,'(4X,F6.1,6X,3(F8.4,4X))') T(iT),(ChiT_main(iT,ic),ic=1,3)
c      End Do
C  saving some information for tests:

      Call Add_Info('Temperature',T         ,nT+nTempMagn,5)
      Call Add_Info('CHIT'       ,chiT      ,nT+nTempMagn,5)
      Call Add_Info('CHIT_THETA' ,chiT_theta,nT+nTempMagn,5)

      Call mma_deallocate(Zstat1)
      Call mma_deallocate(chiT_tens)
      Call mma_deallocate(chiT)
      Call mma_deallocate(chi_theta_1)
      Call mma_deallocate(wt)
      Call mma_deallocate(zt)

      Return
      End

C Calculation of susceptibility in the direction of main magnetic axes:

c         Do i=1,3
c           Do j=1,3
c             Do k=1,3
c               ChiT_main(iT,i)=ChiT_main(iT,i)+ ZMAGN(k,i)*ZMAGN(j,i)
c       &                                       *ChiT_tens(iT,k,j)
c             End Do
c           End Do
c         End Do

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine RHS(Temp1,Temp2,Temp3,Temp4,
     &               Temp5,Temp6,temp7,
     &               rKappa,ipst,iDisp,lOper,
     &               CMO,jdisp,jspin,CI)
********************************************************************
*                                                                  *
*    Purpose:                                                      *
*            Read the perturbed fock operator and one electron     *
*            hamiltonian from disk and add the connection part     *
*            to the hessian.                                       *
*                                                                  *
*     In :                                                         *
*                loper : Symmetry operator for perurbation         *
*                idisp : Perturbation component                    *
*     Out                                                          *
*                rKappa: Preconditioned RHS for the perturbation   *
*                                                                  *
*     Temporary                                                    *
*                Temp1,Temp2,Temp3                                 *
*                                                                  *
* Author: Anders Bernhardsson, 1995                                *
*         Theoretical Chemistry, University of Lund                *
********************************************************************
      use ipPage, only: W
      use Arrays, only: G2t, G1t
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "stdalloc.fh"
      Character(LEN=8) Label
      Logical CI
      Real*8 E2
      Real*8 Temp1(nDens),rKappa(nDens),Temp4(nDens),
     &       Temp2(nDens),Temp3(nDens),CMO(nCMO),Temp5(nDens),
     &       Temp6(nDens),temp7(ndens)
      Real*8 rDum(1)
      Real*8, Allocatable:: MOX(:), MOT(:), FIX(:), MOT2(:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      SubRoutine CISigma(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,
     &                   Int2a,nInt2a,ipCI1,ipCI2, Have_2_el)
       Integer iispin, iCsym, iSSym
       Integer nInt1, nInt2s, nInt2a
       Real*8, Target:: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
       Integer ipCI1, ipCI2
       Logical Have_2_el
      End SubRoutine CISigma
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      one=1.0d0
      debug=.true.
      iRC=-1
      idsym=loper+1
      iOpt=0
      iOp=2**loper
*                                                                      *
************************************************************************
*                                                                      *
*     Read in connection matrix
*     and transform it to MO basis
*
*
*
      If (iAnd(ntpert(idisp),2**3).eq.8) Then
      iRC=-1
      iOpt=0
      iOp=2**loper
      Label='OVRGRD  '
      Call dRdMCK(iRC,iOpt,Label,DspVec(iDisp),Temp7,iop)
      If (iRc.ne.0) Then
          Write (6,*) 'RHS: Error reading MCKINT'
          Write (6,*) 'Label=',Label
          Call Abend()
      End If

      ip=1
      Do iS=1,nSym
       Do jS=1,is
        If (iEOr(iS-1,jS-1).eq.loper) Then
        If (nOrb(is)*nOrb(js).ne.0) Then
           If (is.eq.js) Then
             Call Square(Temp7(ipMatLT(is,js)),
     &                   Temp6,
     &                   1,nBas(is),nBas(is))
             ip=ip+nBas(is)*(nBas(iS)+1)/2
           Else
             call dcopy_(nBas(iS)*nBas(jS),
     &                  Temp7(ipMatLt(is,js)),1,
     &                  Temp6,1)
           End If
           Call DGEMM_('T','N',
     &                 nOrb(iS),nBas(jS),nBas(iS),
     &                 1.0d0,CMO(ipCM(iS)),nBas(iS),
     &                 Temp6,nBas(iS),
     &                 0.0d0,Temp5,nOrb(iS))
           Call DGEMM_('N','N',
     &                 nOrb(is),nOrb(jS),nBAs(jS),
     &                 1.0d0,Temp5,nOrb(iS),
     &                 CMO(ipCM(jS)),nBas(jS),
     &                 0.0d0,Temp1(ipMat(iS,jS)),nOrb(is))
           If (is.ne.js) Then
           Call DGEMM_('T','T',
     &                 nOrb(jS),nBas(iS),nBAs(jS),
     &                 1.0d0,CMO(ipCM(jS)),nBas(js),
     &                 Temp6,nBas(iS),
     &                 0.0d0,Temp5,nOrb(jS))
           Call DGEMM_('N','N',
     &                 nOrb(js),nOrb(iS),nBas(iS),
     &                 1.0d0,Temp5,nOrb(jS),
     &                 CMO(ipCM(iS)),nBas(iS),
     &                 0.0d0,Temp1(ipMat(jS,iS)),nOrb(jS))
          End If

        End If
        End If
       End Do
      End Do
      End If
*
*-------------------------------------------------------------------*
*
*     Read in derivative of hamiltonian
*
      rone=0.0d0
      If ((iMethod.eq.2).and.(n2dens.ne.0)) Then
        Call mma_allocate(MOX,n2dens,Label='MOX')
      Else
        Call mma_allocate(MOX,1,Label='MOX')
      End If
      MOX(:)=0.0D0
      Call mma_allocate(FiX,nDens2,Label='FIX')

      Call IntX(FIX,temp7,temp6,temp5,temp4,rkappa,
     &          MOX,loper,idisp,rone)
*
*-------------------------------------------------------------------*
*
*
*                       C O N N E C T
*
*
*                  {kappa MO}           F({D,k}){F,k}
*                                                 ~
*     Area for one index transformed integrals (pj|kl)
*
      If (iAnd(ntpert(idisp),2**3).eq.8)  Then
       If (iMethod.eq.2) Then
          Call mma_allocate(MOT ,nmba,Label='MOT')
          Call mma_allocate(MOT2,nmba,Label='MOT2')
       Else
          Call mma_allocate(MOT ,   1,Label='MOT')
          Call mma_allocate(MOT2,   1,Label='MOT2')
       End If
       MOT(:)=0.0D0
       MOT2(:)=0.0D0
*
*      kappa rmo Fi Fa
*
       Call r2ElInt(Temp1,MOT,MOT2,
     &             Temp4,Temp5,ndens2,iDSym,1.0d0,-0.5d0,0)

       If (imethod.eq.2) Call DaXpY_(nmba,1.0d0,MOT2,1,MOT,1)
       Call mma_deallocate(MOT2)

*----- ix  ix  ~i
       call dcopy_(ndens2,[0.0d0],0,temp7,1)
*------ F  =F  + F
       Call DaXpY_(nDens2,One,Temp4,1,FIX,1)
*

       If (iMethod.eq.2) Call CreQ(Temp6,MOT,G2t,loper+1)
*
       Do iS=1,nSym
        jS=iEOr(iS-1,loper)+1
*------ F~=2*Fi~
        Call DaXpY_(nIsh(is)*nOrb(js),2.0d0,
     &            Temp4(ipMat(js,is)),1,Temp7(ipMat(js,is)),1)
        If (iMethod.eq.2) Then
*------- F~=F~+2*FA~
         Call DaXpY_(nIsh(is)*nOrb(js),2.0d0,
     &            Temp5(ipMat(js,is)),1,Temp7(ipMat(js,is)),1)
         Do iAsh=1,nAsh(iS)
          Do jAsh=1,nAsh(is)
           Dij=G1t(itri(iash+nA(is),jAsh+nA(is)))
*
*           F~=F~+DFi~
*
           Call DaXpY_(nOrb(jS),Dij,
     &               Temp4(ipMat(js,is)+nOrb(js)*(nish(is)+iAsh-1)),1,
     &               Temp7(ipMat(js,is)+nOrb(js)*(nish(is)+jAsh-1)),1)
          End Do
         End Do
*------- F~=F~+Q~
         Call DaXpY_(nAsh(is)*nOrb(js),1.0d0,
     &            Temp6(ipMatba(js,is)),1,
     &            Temp7(ipMat(js,is)+nOrb(js)*nIsh(is)),1)
        End If
       End Do ! is
*
*
*     Calculate connection contribution to hessian
*
      End If ! ntpert

      Call Hess(Temp7,rkappa,Temp1,temp4,Temp5,temp6,
     &            Temp3,loper+1,jdisp,idisp)
*
*----- F=F~+Fx
      If (iAnd(ntpert(idisp),2**3).eq.8)
     &    call daxpy_(nDens,One,Temp7,1,rKappa,1)

*
*     Add connection to 2el MO integrals
*
*---- Adds (pb|cd) to triangular (ab|cd)
      If (iMethod.eq.2.and.iAnd(ntpert(idisp),2**2).eq.4)
     &    Call ABXpY(MOT,MOX,idsym)
*
      If (CI) Then
*
       Call CiSigma(0,State_Sym,iEor(State_sym-1,idsym-1)+1,
     &              FIX,nDens2,MOX,SIZE(MOX),rdum,1,ipCI,ipst,.True.)
*
       irc=ipin(ipst)
       If (idsym.eq.1) Then
        EnA=E2(Fix,MOX,idsym-1,idisp)
        irc=ipin(ipCI)
        Call DaXpY_(nConf1,-Ena,W(ipCI)%Vec,1,W(ipST)%Vec,1)
       End If
       Call DSCAL_(nConf1,2.0d0,W(ipST)%Vec,1)
      End If
*
      Call DYAX(ndens2,2.0d0,rkappa,1,Temp1,1)
*
      Do iS=1,nSym
        js=iEOR(is-1,loper)+1
        If (nOrb(is)*nOrb(js).ne.0)
     &  Call DGESUB(Temp1(ipMat(is,js)),nOrb(is),'N',
     &              Temp1(ipMat(js,is)),nOrb(js),'T',
     %              rKappa(ipMat(is,js)),nOrb(is),
     &              nOrb(is),nOrb(js))
      End Do
*
      Call mma_deallocate(FIX)
      If (Allocated(MOX)) Call mma_deallocate(MOX)
      If (Allocated(MOT)) Call mma_deallocate(MOT)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Temp2)
         Call Unused_integer(jspin)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  Qfread
*
*> @brief
*>   Read in all data that comes from external Molcas routines and prepare various quantities, such as MME
*> @author A. Ohrn
*>
*> @details
*> This subroutine handles the interaction with the rest of Molcas.
*> Here orbitals and various matrices are stored and to some extent
*> modified to our purpose. We call on this subroutine even when
*> we are running classical stuff. The reason for this is that we
*> wish to collect some numbers, but really, we could easily have
*> constructed thing differently so that this subroutine only would
*> be called when quantum-classical stuff is running. For RASSI
*> implementation, we also read in and transform the transition density
*> matrix. At the end, we also call the routines that make the
*> multicenter multipole expansion.
*>
*> @note
*> Seward is mandatory for both SCF and RASSI. For SCF also,
*> Motra, Averd; for RASSI also, RASSCF and RASSI.
*>
*> @param[out] nAtomsCC Atoms in solvent
*> @param[out] Coord    Unique coordinates of the atoms in the molecule in the QM-region
*> @param[out] nBas     Number of basis functions in QM-region
*> @param[out] nBasCC   Like nBas but for a solvent molecule
*> @param[out] nCnC_C   Like nCnC, but for solvent
*> @param[out] nntyp    Number of basis-function types.
*> @param[out] nOcc     The total number of basis functions that belong to a certain basis-function type.
*> @param[out] natyp    Number of atoms of the i:th basis-function type
************************************************************************
*******JoseMEP the last three variables are included to the MEP calculation
      Subroutine Qfread(iQ_Atoms,nAtomsCC,Coord,nBas,nBasCC,nCnC_C
     &,nOcc,natyp,nntyp)
      Implicit Real*8 (a-h,o-z)

*-----------------------------------------------------------------------*
* Variables                                                             *
*-----------------------------------------------------------------------*
#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "qmcom.fh"
#include "qm1.fh"
#include "qm2.fh"
#include "integral.fh"
#include "numbers.fh"
#include "WrkSpc.fh"
#include "tratoc.fh"
#include "warnings.fh"

      Parameter (IndMax=nTraBuf) !nTraBuf definied in tratoc.fh

      Dimension Coord(MxAt*3),Chge(MxAt),CoordCC(3*3),ChgeCC(3)
      Dimension Cmo(MxBas**2),Cmo_S(MxBas**2),Occu(MxBas),Dummy(MxBas)

      Dimension nSh(MxAt),nfSh(MxAt,MxAngqNr),nCnC(MxBas),nCnC_C(MxBasC)
      Dimension nOcc(MxBas),natyp(MxAt),natypC(MxAt),iDumm(MxBas)
      Dimension nBas(MxSym),nBasCC(1),iCon(MxAt,MxPrCon)
      Dimension iC_icon(MxAt,MxPrCon)

      Character Line*120,BlLine*120,Title*100,OrbName*100,WhatGet*10
      Character StLine*120
      Dimension iDummy(1)
      Integer ipACC

*-----------------------------------------------------------------------*
* Enter                                                                 *
*-----------------------------------------------------------------------*

*------------------------------------------------------------------------*
* Print the joblabel. It is obtained in get_input.f                      *
*------------------------------------------------------------------------*
      If(ATitle) then
        lLine=Len(Line)
        Do 9990, i=1,lLine
          BlLine(i:i)=' '
          StLine(i:i)='*'
9990    Continue
        Write(6,*)
        Do 9991, i=1,6
          Line=BlLine
          If(i.eq.1.or.i.eq.6) Line=StLine
          If(i.eq.3) Line='Project:'
          If(i.eq.4) Write(Line,'(A72)')JobLab
          Call Center(Line)
          Write(6,*)'*'//Line//'*'
9991    Continue
        Write(6,*)
      Endif
      Write(6,*)'Auxiliary data being read and pre-processed.'
*----------------------------------------------------------------------*
* Collect some data from RUNFILE about the QM-region molecule.         *
*----------------------------------------------------------------------*
      Call Get_iScalar('nSym',nSym)
      If(nSym.ne.1) then !A minor restriction, no symmetry allowed,
                          !i.e. nSym=1.
        Write(6,*)
        Write(6,*)' QmStat does not run with symmetry!'
        Write(6,*)' The perturbation from the solvent breaks all symmet'
     &//'ry.'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif
      Call Get_iScalar('Unique atoms',iQ_Atoms)
      If(iQ_Atoms.gt.MxAt) then
        Write(6,*)
        Write(6,*)'Maximum number of atoms exceeded. Increase MxAt in '
     &//'maxi.fh in QmStat source directory.'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif
      Call Get_dArray('Nuclear charge',Chge,iQ_Atoms)
      Call Get_dArray('Unique Coordinates',Coord,3*iQ_Atoms)
      Call Get_dArray('Center of Mass',CT,3)
      Call Get_iArray('nBas',nBas,nSym)
      If(nBas(1).gt.MxBas) then
        Write(6,*)
        Write(6,*)'Maximum number of basis functions exceeded. Increase'
     &//' MxBas in maxi.fh in QmStat source directory.'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif

*------------------------------------------------------------------------*
* Print elementary information about molecule.                           *
*------------------------------------------------------------------------*
      Write(6,*)
      Write(6,*)'     ------------------------------'
      Write(6,*)'     |       QM-region data       |'
      Write(6,*)'     ------------------------------'
      Write(6,*)
      Write(6,'(A,15X,I5)')'      Number of basis functions:'
     &                    ,(nBas(i),i=1,nSym)
      Write(6,'(A,3F10.6)')'      Centre of mass =',(CT(kk),kk=1,3)
      Call PrCoor

*----------------------------------------------------------------------*
* If the Qmtype is SCF we now want the orbitals. On the other hand if  *
* we are running RASSI, another route must be taken, hence here we     *
* inquire which QM-method that is used.                                *
*----------------------------------------------------------------------*
      If(QmType(1:3).eq.'SCF') then
*----------------------------------------------------------------------*
*      SSS    CCC  FFFFFF                                              *
*     SS    CC     FF                                                  *
*      SS  CC      FFFF                                                *
*       SS  CC     FF                                                  *
*     SSS    CCC   FF                                                  *
*----------------------------------------------------------------------*

*----------------------------------------------------------------------*
* Print information about orbitals and store coefficients in new       *
* variable.                                                            *
*----------------------------------------------------------------------*
        iLu=15
        iLu=IsFreeUnit(iLu)
        Write(OrbName,'(A)')'AVEORB'
        Write(WhatGet,'(A)')'CO'
        iWarn=1
        Call RdVec(OrbName,iLu,WhatGet,nSym,nBas,nBas,Cmo,Occu,Dummy
     &,iDumm,Title,iWarn,iErr)
        If(iErr.ne.0) then
          Write(6,*)
          Write(6,*)'Error when reading AVEORB'
          Write(6,*)
          Call Quit(_RC_IO_ERROR_READ_)
        Endif
        kaunter=0
        Call GetMem('OrbCoeffQ','Allo','Real',iV1,iOrb(1)*nBas(1))
        Do 102,j=1,iOrb(1)
          Do 103,k=1,nBas(1)
            Work(iV1+kaunter)=Cmo(k+(j-1)*nBas(1))
            kaunter=kaunter+1
103       Continue
102     Continue
*        Write(6,'(A,I4)')'      Number of Orbitals:',iOrb(1)
        Call Get_dScalar('PotNuc',PotNuc)

      Elseif(QmType(1:4).eq.'RASS') then
*----------------------------------------------------------------------*
*     RRRR      AA      SSS   SSS   II                                 *
*     RR  R    A  A    SS    SS     II                                 *
*     RR R    AAAAAA    SS    SS    II                                 *
*     RRR     AA  AA     SS    SS   II                                 *
*     RR R    AA  AA   SSS   SSS    II                                 *
*----------------------------------------------------------------------*
        Call TdmTrans(nBas)
      Endif
      Write(6,*)
      Write(6,*)
*----------------------------------------------------------------------*
* Compute various information about system. This we use for computing  *
* integrals later. GiveMeInfo collects stuff from seward, somtime with *
* some recomputations.                                                 *
*----------------------------------------------------------------------*
      Call GiveMeInfo(nBas(1),nntyp,natyp,BasOri,Icon,nPrimus,nBA_Q
     &,nCBoA_Q,nBonA_Q,ipE,ipC,nsh,nfsh,nSize,iPrint,MxAt,MxPrCon,MxBas
     &,MxAngqNr,ipACC,nACCSizeQ)
      iBas=0
      iAtom=0
      kold=1
      iold=1
      indold=0
      diff=0
      Do 149, i=1,nntyp
        nOcc(i)=0
149   Continue
      Do 150, i=1,nntyp
        na=natyp(i)
        Do 151, j=1,na
          ind=0
          jnd=0
          iAtom=iAtom+1
          ChaNuc(iAtom)=Chge(iAtom)
          info_atom(iAtom)=int(Chge(iAtom))
          nShj=nSh(i)
          Do 152, k=1,nShj
            nnaa=nfsh(i,k)
            Do 153, l=1,nnaa
              ibas=ibas+1
              indold=indold+1
              nOcc(i)=nOcc(i)+2*k-1
              nCnC(ibas)=nnaa
              ind=ind+1
              iQang(ibas)=k
              icont=Icon(i,ind)
              iCharOnBasQ(ibas)=int(Chge(iAtom))
              Do 1531, ix=1,2*k-1  !Here we construct an array of
                If(k.ne.kold) then !indeces which is used to put right
                  If(i.ne.iold) then !AO-overlap in right matrix pos.
                    Indold=Indold+nfsh(iold,kold)*(2*kold-2)
                    iold=i
                  Else
                    Indold=Indold+nfsh(i,kold)*(2*kold-2)
                  Endif
                  kold=k
                Endif
                iWoGehenQ(ibas,ix)=indold+nnaa*(ix-1)
1531          Continue
              Do 154, m=1,icont
                jnd=jnd+1
                alfa(ibas,m)=Work(ipE+i-1+MxAt*(jnd-1))
                cont(ibas,m)=Work(ipC+i-1+MxAt*(jnd-1))
154           Continue
153         Continue
152       Continue
151     Continue
150   Continue
      Kmax=ibas
      call dcopy_(nACCSizeQ,Work(ipACC),iONE,Trans,iONE)
      Call GetMem('AccTransa','Free','Real',ipACC,nACCSizeQ)
      Call GetMem('Exponents','Free','Real',ipE,nSize*MxAt) !Now we
      Call GetMem('ContrCoef','Free','Real',ipC,nSize*MxAt) !do not
                                             !need them, so deallocate.

*------------------------------------------------------------------------*
* Obtain and print information about solvent. This requires a renaming   *
* of the runfile.                                                        *
*------------------------------------------------------------------------*
      Call NameRun('WRUNFIL')
      Call Get_iScalar('nSym',nSymCC)
      If(nSymCC.ne.1) then
        Write(6,*)
        Write(6,*)' QmStat does not run with symmetry!'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif
      Call Get_iScalar('Unique atoms',nAtomsCC)
      If(nAtomsCC.ne.3) then
        Write(6,*)
        Write(6,*)'Now now... what strange solvent molecule do you try'
     &//' to feed QmStat with?'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif
      Call Get_dArray('Nuclear charge',ChgeCC,nAtomsCC)
      Call Get_dArray('Unique Coordinates',CoordCC,3*nAtomsCC)
      Call Get_iArray('nBas',nBasCC,nSymCC)
      If(nBasCC(1).gt.MxBasC) then
        Write(6,*)
        Write(6,*)'Number of solvent molecule basis functions exceeded.'
     &//' Increase MxBasC in maxi.fh in QmStat source directory.'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif
      Write(6,*)
      Write(6,*)'     ------------------------------'
      Write(6,*)'     |   Solvent molecule data     |'
      Write(6,*)'     ------------------------------'
      Write(6,*)
      Write(6,'(A,15X,I5)')'      Number of basis functions:'
     &                    ,(nBasCC(i),i=1,nSymCC)
      Call PrCoor

*
*--- Collect information about the solvent orbitals.
*
      iLu=16
      iLu=IsFreeUnit(iLu)
      Write(OrbName,'(A)')'SOLORB'
      Write(WhatGet,'(A)')'CE'
      iWarn=1
      Call GetMem('OrbitalEnergy','Allo','Real',iOe,Sum(nBasCC))
      Call RdVec(OrbName,iLu,WhatGet,nSymCC,nBasCC,nBasCC,Cmo_S
     &,Dummy,Work(iOe),iDummy,Title,iWarn,iErr)
      Do 22, i=1,iOrb(2)
        c_orbene(i)=Work(iOe+i-1)
22    Continue
      Call GetMem('OrbitalEnergy','Free','Real',iOe,Sum(nBasCC))

*
*--- We should not need two solvent orbital vectors, so this should
*    be removed when the orbital rotation routine is fixed.
*
      Do 202,j=1,iOrb(2)
        Do 203,k=1,nBasCC(1)
          V3(k,j)=Cmo_S(k+(j-1)*nBasCC(1))
203     Continue
202   Continue
*      Write(6,'(A,I4)')'      Number of Orbitals:',iOrb(2)
      Write(6,*)
      Write(6,*)
*-----------------------------------------------------------------------*
* And now basis set information.                                        *
*-----------------------------------------------------------------------*
      Call GiveMeInfo(nBasCC(1),nntypC,natypC,SavOri,iC_Icon,mPrimus
     &,nBA_C,nCBoA_C,nBonA_C,ipE_C,ipC_C,nsh,nfsh,nSize,iPrint,MxAt
     &,MxPrCon,MxBas,MxAngqNr,ipACC,nACCSizeC)
      iBas=0
      iAtom=0
      mbash=0
      kold=1
      iold=1
      indold=0
      Do 250, i=1,nntypC  !Like the corresponding thing above for
        na=natypC(i)       !the QM-region.
        Do 251, j=1,na
          ind=0
          jnd=0
          nShj=nSh(i)
          iAtom=iAtom+1
          Do 252, k=1,nShj
            nnaa=nfsh(i,k)
            Do 253, l=1,nnaa
              ibas=ibas+1
              indold=indold+1
              nCnC_C(ibas)=nnaa
              ind=ind+1
              icont=iC_Icon(i,ind)
              iqn(ibas)=k
              iCharOnBasC(ibas)=int(ChgeCC(iAtom))
              Do 2531, ix=1,2*k-1  !Here we construct an array of
                If(k.ne.kold) then !indeces which is used to put right
                  If(i.ne.iold) then !AO-overlap in right matrix pos.
                    Indold=Indold+nfsh(iold,kold)*(2*kold-2)
                    iold=i
                  Else
                    Indold=Indold+nfsh(i,kold)*(2*kold-2)
                  Endif
                  kold=k
                Endif
                iWoGehenC(ibas,ix)=indold+nnaa*(ix-1)
2531          Continue
              Do 254, m=1,icont
                jnd=jnd+1
                beta(ibas,m)=Work(ipE_C+i-1+MxAt*(jnd-1))
                dont(ibas,m)=Work(ipC_C+i-1+MxAt*(jnd-1))
254           Continue
253         Continue
252       Continue
251     Continue
250   Continue
      Lmax=ibas
      If(nACCSizeC.gt.nACCSizeQ) then
        call dcopy_(nACCSizeC,Work(ipACC),iONE,Trans,iONE)
      Endif
      Call GetMem('AccTransa','Free','Real',ipACC,nACCSizeC)
      Call GetMem('Exponents','Free','Real',ipE_C,nSize*MxAt) !Now we
      Call GetMem('ContrCoef','Free','Real',ipC_C,nSize*MxAt) !do not
                                             !need them, so deallocate.
*
*----------------------------------------------------------------------*
* A small test to see if max-limits are violated.                      *
*----------------------------------------------------------------------*
      If(Kmax.gt.MxBB.or.Lmax.gt.MxBB) then
        Write(6,*)
        Write(6,*)'ERROR! MxBB too small!'
        Call Quit(_RC_INTERNAL_ERROR_)
      Endif
*----------------------------------------------------------------------*
* The multipoles and the Hamiltonian matrix are radically different    *
* between the QM-method alternatives, so once more an inquire.         *
*----------------------------------------------------------------------*
      Call NameRun('RUNFILE')
      If(QmType(1:3).eq.'SCF') then
        Call ScfHandM(Cmo,nBas,iQ_Atoms,nOcc,natyp,nntyp,Occu)
      Elseif(QmType(1:4).eq.'RASS') then
        Call RassiHandM(nBas,iQ_Atoms,nOcc,natyp,nntyp)
      Endif
*----------------------------------------------------------------------*
* Here is the end.                                                     *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PtOkt1(Oper,Temp1,Temp2)
*
************************************************************************
*                                                                      *
*     Objective: Construct the perturbation operator of the form       *
*                <X*R**2>=<XXX>+<XYY>+<XZZ>                            *
*                                                                      *
************************************************************************
*
      Implicit Real*8 ( A-H,O-Z )
*

#include "input.fh"
*
      Dimension Temp1(*),Temp2(*)
*
      Character*2 Oper
      Character*8 Label
      Character*20 PriLbl
      Dimension Cntr(3)
      Integer xrComp(3)
      Data    xrComp/1,4,6/
      Integer yrComp(3)
      Data    yrComp/2,7,9/
      Integer zrComp(3)
      Data    zrComp/3,8,10/
      Logical Debug,Orig
      Data    Debug/.False./
      Dimension idum(1)
*
*----------------------------------------------------------------------*
*     Start procedure                                                  *
*     Check if a origin has been specified                             *
*     The unspecified components of the origin are set to 0.0 !        *
*     If no origin has been given pick the center of mass!             *
*----------------------------------------------------------------------*
*
*
      Orig=.false.
      Orig=Orig.or.ComStk(2,6,2,1)
      Orig=Orig.or.ComStk(2,6,2,2)
      Orig=Orig.or.ComStk(2,6,2,3)
      Orig=Orig.or.ComStk(2,6,2,4)
*
      If ( Orig ) Then
        XOrig=0.0
        YOrig=0.0
        ZOrig=0.0
        If ( ComStk(2,6,2,1) ) XOrig=ComVal(2,6,2,1)
        If ( ComStk(2,6,2,2) ) YOrig=ComVal(2,6,2,2)
        If ( ComStk(2,6,2,3) ) ZOrig=ComVal(2,6,2,3)
        If ( ComStk(2,6,2,4) ) Then
          iAtm=INT(ComVal(2,6,2,4))
          If ( iAtm.lt.0 .or. iAtm.gt.nAtoms ) Then
             Write (6,*) 'PtOkt0: You specified a invalid atom number'
     &                 //' as the origin of the perturbation operator.'
             Call Abend()
          End If
          XOrig=Coor(1,iAtm)
          YOrig=Coor(2,iAtm)
          ZOrig=Coor(3,iAtm)
        End If
      Else
        Call Get_dArray('Center of Mass',Cntr,3)
        XOrig=Cntr(1)
        YOrig=Cntr(2)
        ZOrig=Cntr(3)
      End If
      If ( Debug )
     *  Write(6,'(6X,A,3F12.6)')'Origin of the perturbation operator =',
     *  XOrig,YOrig,ZOrig
*
*----------------------------------------------------------------------*
*     Loop over components                                             *
*----------------------------------------------------------------------*
*
      Do iComp=1,3
         If ( Oper.eq.'XR' ) jComp=xrComp(iComp)
         If ( Oper.eq.'YR' ) jComp=yrComp(iComp)
         If ( Oper.eq.'ZR' ) jComp=zrComp(iComp)
         Label='MltPl  3'
         PriLbl='MltPl  3; Comp =    '
         Write(PriLbl(19:20),'(I2)') jComp
         iRc=-1
         iOpt1=1
         iOpt2=0
         iSyLbl=0
         Call iRdOne(iRc,iOpt1,Label,jComp,idum,iSyLbl)
         nInts=idum(1)
         If ( iRc.ne.0 ) Goto 991
         Call RdOne(iRc,iOpt2,Label,jComp,Temp1,iSyLbl)
         Call CmpInt(Temp1,nInts,nBas,nSym,iSyLbl)
         X=Temp1(nInts+1)
         Y=Temp1(nInts+2)
         Z=Temp1(nInts+3)
         If ( X.ne.XOrig .or. Y.ne.YOrig .or. Z.ne.ZOrig ) Then
             Write (6,*) 'PtOkt1: Input error, no matching center'
     &                 //' is found.'
             Call Abend()
         End If
         If ( iComp.eq.1 ) Then
            call dcopy_(nInts,Temp1,1,Temp2,1)
            Temp2(nInts+4)=Temp1(nInts+4)
         Else
            Alpha=1.0d0
            call daxpy_(nInts,Alpha,Temp1,1,Temp2,1)
            Temp2(nInts+4)=Temp2(nInts+4)+Alpha*Temp1(nInts+4)
         End If
      End Do
*
*----------------------------------------------------------------------*
*     Normal Exit                                                      *
*----------------------------------------------------------------------*
*
      Return
*
*----------------------------------------------------------------------*
*     Error Exit                                                       *
*----------------------------------------------------------------------*
*
991   Write (6,*) 'PtOkt1: Error reading ONEINT'
      Write (6,'(A,A)') 'Label=',Label
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
! Library of routines for Dynamix module
!
!***********************************************************************
!      SUBROUTINE DxRdNAtomStnd(natom)
!      SUBROUTINE DxRdNAtomHbrd(natom)
!      SUBROUTINE DxRdStnd(natom,atom,xyz,force)
!      SUBROUTINE DxRdHbrd(natom,atom,xyz,force)
!      SUBROUTINE DxPtTableCo(caption,time,natom,atom,xyz,lastline,M,fo)
!      SUBROUTINE DxPtTableWithoutMassForce(caption,time,natom,atom,xyz)
!      SUBROUTINE DxRdOut(pcoo,POUT,natom)
!      SUBROUTINE DxRdVel(vel,natom)
!      SUBROUTINE DxWtVel(vel,natom3)
!      SUBROUTINE DxCoord(natom,atom,xyz,hybrid)
!      SUBROUTINE DxEnergies(time,Epot,Ekin,Etot)
!      SUBROUTINE Put_Velocity(vel,natom3)
!      SUBROUTINE Get_Velocity(vel,natom3)
!      SUBROUTINE Get_NHC(NHC,nh)
!      SUBROUTINE Put_NHC(NHC,nh)
!***********************************************************************
!
! Read the number of atoms. This needs to be done separately, because
! dynamic-size matrices depend on the result.

subroutine DxRdNAtomStnd(natom)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: natom

call Get_nAtoms_Full(natom)

end subroutine DxRdNAtomStnd

!***********************************************************************
!
! Read the number of atoms. This needs to be done separately, because
! dynamic-size matrices depend on the result.

subroutine DxRdNAtomHbrd(natom)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: natom
integer(kind=iwp) :: filenum
integer(kind=iwp), external :: IsFreeUnit
character(len=80) :: filename

filenum = IsFreeUnit(81)
filename = 'fixforce.dmx'
call Molcas_Open(filenum,filename)
read(filenum,100) natom
close(filenum)

return

100 format(i6)

end subroutine DxRdNAtomHbrd

!***********************************************************************
!
! Read in the atom names, coordinates and forces from RUNFILE for
! the standard QM molecular dynamics.
!
! IS 14/06-2007

subroutine DxRdStnd(natom,atom,xyz,force)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natom
character(len=2), intent(out) :: atom(natom)
real(kind=wp), intent(out) :: xyz(natom*3), force(natom*3)
real(kind=wp), parameter :: conv = -One

! The parameter conv converts the gradients (Hartree/Bohr)
!                              to forces (Hartree/Bohr)

call Get_Name_Full(atom)
call Get_Coord_Full(xyz,natom)

! Read the gradients from RUNFILE and convert them to forces.

call Get_Grad_Full(force,natom)
call dscal_(3*natom,conv,force,1)

end subroutine DxRdStnd

!***********************************************************************
!
! Read in the atom names, coordinates and forces from files
! fixforce.dmx and prmcrd2.

subroutine DxRdHbrd(natom,atom,xyz,force)

use Constants, only: Angstrom, auTokJ, rNAVO, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natom
character(len=2), intent(out) :: atom(natom)
real(kind=wp), intent(out) :: xyz(natom*3), force(natom*3)
integer(kind=iwp) :: filenum, i, j, natom2
character(len=80) :: filename
real(kind=wp), parameter :: a2bohr = One/Angstrom, conv = Angstrom/(rNAVO*auTokJ)
integer(kind=iwp), external :: IsFreeUnit

! The parameter conv converts the forces from Hartree/Bohr
!                    to kJ/mole/Angstrom  => 1/4961.47525891
!             a2bohr converts the coordinates from Angstrom
!                    to Bohr              => 1/0.52917721090

filenum = IsFreeUnit(81)
filename = 'fixforce.dmx'
call Molcas_Open(filenum,filename)
read(filenum,*)
do i=1,natom
  read(filenum,101) (force((i-1)*3+j),j=1,3),atom(i)
end do
close(filenum)

! Convert forces from kJ/mole/Angstrom to Hartree/Bohr

call dscal_(3*natom,conv,force,1)

! Read coordinates from fiel 'prmcrd2' and check for consistency
! with forces.

filenum = IsFreeUnit(filenum)
filename = 'prmcrd2'
call Molcas_Open(filenum,filename)
read(filenum,'(/,I6)') natom2
if (natom2 /= natom) call WarningMessage(2,'Inconsistency between coordinates')
read(filenum,102) (xyz(i),i=1,natom*3)
close(filenum)

! Convert coordinates from Angstrom to Bohr

call dscal_(3*natom,a2bohr,xyz,1)

return

101 format(3es21.14,a)
102 format(6f12.7)

end subroutine DxRdHbrd

!***********************************************************************
!
! Prints a nice table in the output file

subroutine DxPtTableCo(caption,time,natom,atom,xyz,lastline,M,fo)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: natom
real(kind=wp), intent(in) :: time, xyz(natom*3), M(natom), fo(natom*3)
character(len=15), intent(in) :: caption
character(len=2), intent(in) :: atom(natom)
character(len=80), intent(in) :: lastline
integer(kind=iwp) :: i, j, k

write(u6,*)
write(u6,*)
write(u6,*)

write(u6,100) caption,' (time = ',time,' a.u.):'
write(u6,102) '----------------------------------------------------------------------------------------------'
write(u6,102) '      No. Atom    X          Y          Z        Mass       F(x)         F(y)         F(z)'
write(u6,102) '----------------------------------------------------------------------------------------------'

do i=1,natom
  write(u6,101) i,atom(i),(xyz(3*(i-1)+j),j=1,3),M(i),(fo(3*(i-1)+k),k=1,3)
end do

write(u6,102) '----------------------------------------------------------------------------------------------'
write(u6,102) trim(lastline)

write(u6,*)
write(u6,*)
write(u6,*)

return

100 format(a22,a7,f8.1,a)
101 format(6x,i4,a3,3(1x,f10.6),1x,es9.2,3(1x,es12.5))
102 format(1x,a)

end subroutine DxPtTableCo

!***********************************************************************
!
! Prints a nice table in the output file for the initial velcoities
!
subroutine DxPtTableWithoutMassForce(caption,time,natom,atom,xyz)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: natom
real(kind=wp), intent(in) :: time, xyz(natom*3)
character(len=15), intent(in) :: caption
character(len=2), intent(in) :: atom(natom)
integer(kind=iwp) :: i, j

write(u6,*)
write(u6,*)
write(u6,*)

write(u6,102) caption,' (time = ',time,' a.u.):'
write(u6,*) '----------------------------------------------'
write(u6,*) '     No.  Atom    X          Y          Z     '
write(u6,*) '----------------------------------------------'

do i=1,natom
  write(u6,103) '      ',i,atom(i),(xyz(3*(i-1)+j),j=1,3)
end do

write(u6,*) '----------------------------------------------'

write(u6,*)
write(u6,*)
write(u6,*)

return

102 format(a22,a7,f8.1,a)
103 format(a6,i4,a3,3f11.6)

end subroutine DxPtTableWithoutMassForce

!***********************************************************************
!
! This Subroutine reads in the coordinates to project out from the file 'out.00N.xyz'
!
subroutine DxRdOut(pcoo,POUT,natom)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: POUT, natom
real(kind=wp), intent(out) :: pcoo(POUT,natom*3)
integer(kind=iwp) :: i, j, p, filenum, mn
character(len=80) :: filename
character(len=180) :: OutLine
real(kind=wp), allocatable :: UMat(:,:), VMat(:,:), S(:), SqrtM(:)
integer(kind=iwp), external :: IsFreeUnit
character(len=180), external :: Get_Ln

filenum = 81
do p=1,POUT
  pcoo(p,:) = Zero
  write(filename,'(A,I3.3,A)') 'out.',p,'.xyz'
  filenum = IsFreeUnit(filenum)
  call Molcas_Open(filenum,filename)
  do i=1,natom
    OutLine = Get_Ln(filenum)
    call UpCase(OutLine)
    do j=1,3
      call Get_F(j,pcoo(p,3*(i-1)+j),1)
    end do
  end do
  close(filenum)
end do

! Orthonormalize the vectors in mass-weighted coordinates

call mma_Allocate(SqrtM,natom)
call GetMassDx(SqrtM,natom)
do i=1,natom
  SqrtM(i) = sqrt(SqrtM(i))
  j = 3*(i-1)+1
  pcoo(:,j:j+2) = pcoo(:,j:j+2)*SqrtM(i)
end do
mn = min(POUT,3*natom)
call mma_Allocate(UMat,POUT,mn)
call mma_Allocate(VMat,mn,3*natom)
call mma_Allocate(S,mn)
call large_svd(POUT,3*natom,pcoo,UMat,VMat,S)
call dgemm_('N','N',POUT,3*natom,mn,One,UMat,POUT,VMat,mn,Zero,pcoo,POUT)
do i=1,natom
  j = 3*(i-1)+1
  pcoo(:,j:j+2) = pcoo(:,j:j+2)/SqrtM(i)
end do
call mma_deAllocate(UMat)
call mma_deAllocate(VMat)
call mma_deAllocate(S)
call mma_deAllocate(SqrtM)

return

end subroutine DxRdOut

!***********************************************************************
!
!     This Subroutine reads in the coordinates to keep in from the file 'in.00N.xyz'
!
subroutine DxRdIn(pcoo,PIN,natom)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: PIN, natom
real(kind=wp), intent(out) :: pcoo(PIN,natom*3)
integer(kind=iwp) :: i, j, p, filenum, mn
character(len=80) :: filename
character(len=180) :: InLine
real(kind=wp), allocatable :: UMat(:,:), VMat(:,:), S(:), SqrtM(:)
integer(kind=iwp), external :: IsFreeUnit
character(len=180), external :: Get_Ln

filenum = 81
do p=1,PIN
  pcoo(p,:) = Zero
  write(filename,'(A,I3.3,A)') 'in.',p,'.xyz'
  filenum = IsFreeUnit(filenum)
  call Molcas_Open(filenum,filename)
  do i=1,natom
    InLine = Get_Ln(filenum)
    call UpCase(InLine)
    do j=1,3
      call Get_F(j,pcoo(p,3*(i-1)+j),1)
    end do
  end do
  close(filenum)
end do

! Orthonormalize the vectors in mass-weighted coordinates

call mma_Allocate(SqrtM,natom)
call GetMassDx(SqrtM,natom)
do i=1,natom
  SqrtM(i) = sqrt(SqrtM(i))
  j = 3*(i-1)+1
  pcoo(:,j:j+2) = pcoo(:,j:j+2)*SqrtM(i)
end do
mn = min(PIN,3*natom)
call mma_Allocate(UMat,PIN,mn)
call mma_Allocate(VMat,mn,3*natom)
call mma_Allocate(S,mn)
call large_svd(PIN,3*natom,pcoo,UMat,VMat,S)
call dgemm_('N','N',PIN,3*natom,mn,One,UMat,PIN,VMat,mn,Zero,pcoo,PIN)
do i=1,natom
  j = 3*(i-1)+1
  pcoo(:,j:j+2) = pcoo(:,j:j+2)/SqrtM(i)
end do
call mma_deAllocate(UMat)
call mma_deAllocate(VMat)
call mma_deAllocate(S)
call mma_deAllocate(SqrtM)

return

end subroutine DxRdIn

!***********************************************************************
!
!     This Subroutine reads in the velocities from the file 'velocity.xyz'
!
subroutine DxRdVel(vel,natom)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natom
real(kind=wp), intent(out) :: vel(natom*3)
integer(kind=iwp) :: i, j, filenum
character(len=80) :: filename
character(len=180) :: VelLine
integer(kind=iwp), external :: IsFreeUnit
character(len=180), external :: Get_Ln

filenum = IsFreeUnit(81)
filename = 'velocity.xyz'
call Molcas_Open(filenum,filename)
vel(:) = Zero
do i=1,natom
  VelLine = Get_Ln(filenum)
  call UpCase(VelLine)
  do j=1,3
    call Get_F(j,vel(3*(i-1)+j),1)
  end do
end do
!read(filenum,100) (vel(i),i=1,3*natom3)
close(filenum)

return

!100 format(3es18.10)

end subroutine DxRdVel

!***********************************************************************
!
! This Subroutine writes the velocities to the file 'velocity.xyz'
!
subroutine DxWtVel(vel,natom3)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natom3
real(kind=wp), intent(in) :: vel(natom3)
integer(kind=iwp) :: i, filenum
character(len=80) :: filename
integer(kind=iwp), external :: IsFreeUnit

filenum = IsFreeUnit(81)
filename = 'velocity.xyz'
call Molcas_Open(filenum,filename)
write(filenum,100) (vel(i),i=1,natom3)
close(filenum)

return

100 format(3es18.10)

end subroutine DxWtVel

!***********************************************************************
!
! Write the coordinates to a file in xyz format
!
subroutine DxCoord(natom,atom,xyz,hybrid)

use Constants, only: Angstrom
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natom
character(len=2), intent(in) :: atom(natom)
real(kind=wp), intent(in) :: xyz(natom*3)
logical(kind=iwp), intent(in) :: hybrid
integer(kind=iwp) :: i, j, filenum
character(len=9) :: filename
logical(kind=iwp) :: exists
integer(kind=iwp), external :: IsFreeUnit

if (.not. hybrid) then
  filenum = IsFreeUnit(81)
  filename = 'md.xyz'
  call OpnFl(filename,filenum,exists)
  call Append_file(filenum)
  write(filenum,'(I5,/)') natom
  do i=1,natom
    write(filenum,100) atom(i),(Angstrom*xyz(3*(i-1)+j),j=1,3)
  end do
  close(filenum)
else
  filenum = IsFreeUnit(81)
  filename = 'md.prmcrd'
  call OpnFl(filename,filenum,exists)
  call Append_file(filenum)
  write(filenum,'(/,I6)') natom
  write(filenum,'(6F12.7)') (Angstrom*xyz(i),i=1,3*natom)
  close(filenum)
  filenum = IsFreeUnit(filenum)
  filename = 'vmd.mdcrd'
  call OpnFl(filename,filenum,exists)
  call Append_file(filenum)
  write(filenum,'(10F8.3)') (Angstrom*xyz(i),i=1,3*natom)
  close(filenum)
end if

return

100 format(1x,a2,3f15.8)

end subroutine DxCoord

!***********************************************************************
!
! Write out a summary of energies in CSV format
!
subroutine DxEnergies(time,Epot,Ekin,Etot)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: time, Epot, Ekin, Etot
integer(kind=iwp) filenum, i, n, nEnergies
logical(kind=iwp) :: exists, RootCheck
character(len=12) :: filename
character(len=24) :: frmt
real(kind=wp), allocatable :: Energies(:)
integer(kind=iwp), external :: IsFreeUnit

filename = 'md.energies'

RootCheck = .false.

call Qpg_iScalar('Relax CASSCF root',RootCheck)

filenum = IsFreeUnit(81)
call OpnFl(filename,filenum,exists)
call Append_file(filenum)
if (.not. exists) then
  write(filenum,'(3X,A4,10X,A4,2(17X,A4))') 'time','Epot','Ekin','Etot'
end if
frmt = '(f8.2,   (2x,es19.12))'

if (RootCheck) then
  call Get_iScalar('Number of roots',nEnergies)
  call mma_allocate(Energies,nEnergies,label='MS energies')
  call Get_dArray('Last energies',Energies,nEnergies)
  n = nEnergies+3
  write(frmt(7:9),'(i3)') n
  write(filenum,frmt) time,Epot,Ekin,Etot,(Energies(i),i=1,nEnergies)
  call mma_deallocate(Energies)
else
  n = 3
  write(frmt(7:9),'(i3)') n
  write(filenum,frmt) time,Epot,Ekin,Etot
end if
close(filenum)

return

end subroutine DxEnergies

!***********************************************************************
!
! Writes the velocities on RUNFILE
!
subroutine Put_Velocity(vel,natom3)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natom3
real(kind=wp), intent(in) :: vel(natom3)

call Put_dArray('Velocities',vel,natom3)

return

end subroutine Put_Velocity

!***********************************************************************
!
! Reads the velocities from RUNFILE
!
subroutine Get_Velocity(vel,natom3)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natom3
real(kind=wp), intent(out) :: vel(natom3)

call Get_dArray('Velocities',vel,natom3)

return

end subroutine Get_Velocity

!***********************************************************************
!
!     Reads the extra degrees of freedom from RUNFILE
!
subroutine Get_NHC(NHC,nh)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nh
real(kind=wp), intent(out) :: NHC(nh)

call Get_dArray('NOSEHOOVER',NHC,nh)

return

end subroutine Get_NHC

!***********************************************************************
!
! Writes the extra degrees of Freedom on RUNFILE
!
subroutine Put_NHC(NHC,nh)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nh
real(kind=wp), intent(in) :: NHC(nh)

call Put_dArray('NOSEHOOVER',NHC,nh)

return

end subroutine Put_NHC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************
!*****************************************************************
!
! This subroutine substitutes the previous version of the RdOrd
! to allow the generation of two-electron integrals from a set
! of Cholesky vectors
!
!     Data declarations:
!
!        First  : logical variable for identifying the 1st call
!                 to this subroutine
!
!   F. Aquilante
!
!*****************************************************************
!***********************************************************************
!  RdOrd
!
!> @brief
!>   Driver for the actual ::RdOrd_ routines and the Cholesky vector integral generator
!> @author F. Aquilante
!>
!> @note
!> The integrals are returned in the order \f$ (lk|ji) \f$.
!>
!> @param[out] rc   return code
!> @param[in]  iOpt option code (= ``1``: start reading at first shell distribution
!>                  in the given product symmetry. = ``2``: continue reading)
!> @param[in]  iSym irred. representation of "first" symmetry label
!> @param[in]  jSym irred. representation of "second" symmetry label
!> @param[in]  kSym irred. representation of "third" symmetry label
!> @param[in]  lSym irred. representation of "fourth" symmetry label
!> @param[out] Buf  contains on output the integrals
!> @param[in]  lBuf length of the integral buffer
!> @param[out] nMat number of submatrices read in
!***********************************************************************

subroutine RdOrd(rc,iOpt,iSym,jSym,kSym,lSym,Buf,lBuf,nMat)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: rc, nMat
integer(kind=iwp), intent(in) :: iOpt, iSym, jSym, kSym, lSym, lBuf
real(kind=wp), intent(_OUT_) :: Buf(*)
logical(kind=iwp) :: First = .true., DoCholesky = .false.

if (First) then
  call DecideOnCholesky(DoCholesky)
  if (DoCholesky) call INIT_GETINT(rc) ! initialize information
  First = .false.
end if

if (DoCholesky) then
  call Get_Int(rc,iOpt,iSym,jSym,kSym,lSym,Buf,lBuf,nMat)
else
  call RdOrd_(rc,iOpt,iSym,jSym,kSym,lSym,Buf,lBuf,nMat)
end if

! Debug printing
!
!call get_iscalar('nSym',nsym)
!call get_iarray('nbas',nbas,nsym)
!if (kSym == lSym) then
!  Nkl = nTri_Elem(nBas(kSym))
!else
!  Nkl = nBas(kSym)*nBas(lSym)
!end if
!write(u6,*)
!write(u6,*)'Integrals: symm(ij|kl), nMat ',iSym,jSym,kSym,lSym,nMat
!write(u6,*)'Nbask,Nbasl,Nkl= ',nBas(kSym),nBas(lSym),Nkl
!xnrm = sqrt(ddot_(Nkl*nMat,Buf,1,Buf,1))
!write(u6,*)'norm= ',xnrm
!call cho_output(Buf,1,nMat,1,Nkl,nMat,Nkl,1,u6)
!call xflush(u6)

return

end subroutine RdOrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine embPotWrRun

      implicit none

      ! Holds the data which is written in this subroutine
#include "embpotdata.fh"

      integer ioUnit, isFreeUnit

      ! Open the file
      ioUnit = isFreeUnit(1)
      call molcas_open(ioUnit, 'EMBPOT_RUNFILE')

      write(ioUnit,'(L1)') embPotInBasis
      write(ioUnit,'(A256)') embPotPath
      write(ioUnit,'(L1)') outGridPathGiven
      write(ioUnit,'(A256)') outGridPath
      write(ioUnit,'(L1)') embWriteDens
      write(ioUnit,'(A256)') embOutDensPath
      write(ioUnit,'(L1)') embWriteEsp
      write(ioUnit,'(A256)') embOutEspPath
      write(ioUnit,'(L1)') embWriteGrad
      write(ioUnit,'(A256)') embOutGradPath
      write(ioUnit,'(L1)') embWriteHess
      write(ioUnit,'(A256)') embOutHessPath

      close(ioUnit)

      return

      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dbdsdc( uplo, compq, n, d, e, u, ldu, vt, ldvt, q, iq, work, iwork, info )
  use link_blas
  implicit none
  character :: compq, uplo
  integer :: info, ldu, ldvt, n
  integer :: iq( * ), iwork( * )
  real*8 :: d( * ), e( * ), q( * ), u( ldu, * ), vt( ldvt, * ), work( * )
  call lb_dbdsdc( uplo, compq, n, d, e, u, ldu, vt, ldvt, q, iq, work, iwork, info )
end subroutine dbdsdc

subroutine dbdsqr( uplo, n, ncvt, nru, ncc, d, e, vt, ldvt, u, ldu, c, ldc, work, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, ldc, ldu, ldvt, n, ncc, ncvt, nru
  real*8 :: c( ldc, * ), d( * ), e( * ), u( ldu, * ), vt( ldvt, * ), work( * )
  call lb_dbdsqr( uplo, n, ncvt, nru, ncc, d, e, vt, ldvt, u, ldu, c, ldc, work, info )
end subroutine dbdsqr

subroutine dcombssq( v1, v2 )
  use link_blas
  real*8 :: v1( 2 ), v2( 2 )
  call lb_dcombssq( v1, v2 )
end subroutine dcombssq

subroutine dgebak( job, side, n, ilo, ihi, scale, m, v, ldv, info )
  use link_blas
  implicit none
  character :: job, side
  integer :: ihi, ilo, info, ldv, m, n
  real*8 :: scale( * ), v( ldv, * )
  call lb_dgebak( job, side, n, ilo, ihi, scale, m, v, ldv, info )
end subroutine dgebak

subroutine dgebal( job, n, a, lda, ilo, ihi, scale, info )
  use link_blas
  implicit none
  character :: job
  integer :: ihi, ilo, info, lda, n
  real*8 :: a( lda, * ), scale( * )
  call lb_dgebal( job, n, a, lda, ilo, ihi, scale, info )
end subroutine dgebal

subroutine dgebd2( m, n, a, lda, d, e, tauq, taup, work, info )
  use link_blas
  implicit none
  integer :: info, lda, m, n
  real*8 :: a( lda, * ), d( * ), e( * ), taup( * ), tauq( * ), work( * )
  call lb_dgebd2( m, n, a, lda, d, e, tauq, taup, work, info )
end subroutine dgebd2

subroutine dgebrd( m, n, a, lda, d, e, tauq, taup, work, lwork, info )
  use link_blas
  implicit none
  integer :: info, lda, lwork, m, n
  real*8 :: a( lda, * ), d( * ), e( * ), taup( * ), tauq( * ), work( * )
  call lb_dgebrd( m, n, a, lda, d, e, tauq, taup, work, lwork, info )
end subroutine dgebrd

subroutine dgecon( norm, n, a, lda, anorm, rcond, work, iwork, info )
  use link_blas
  implicit none
  character :: norm
  integer :: info, lda, n
  real*8 :: anorm, rcond
  integer :: iwork( * )
  real*8 :: a( lda, * ), work( * )
  call lb_dgecon( norm, n, a, lda, anorm, rcond, work, iwork, info )
end subroutine dgecon

subroutine dgeev( jobvl, jobvr, n, a, lda, wr, wi, vl, ldvl, vr, ldvr, work, lwork, info )
  use link_blas
  implicit none
  character :: jobvl, jobvr
  integer :: info, lda, ldvl, ldvr, lwork, n
  real*8 :: a( lda, * ), vl( ldvl, * ), vr( ldvr, * ), wi( * ), work( * ), wr( * )
  call lb_dgeev( jobvl, jobvr, n, a, lda, wr, wi, vl, ldvl, vr, ldvr, work, lwork, info )
end subroutine dgeev

subroutine dgehd2( n, ilo, ihi, a, lda, tau, work, info )
  use link_blas
  implicit none
  integer :: ihi, ilo, info, lda, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dgehd2( n, ilo, ihi, a, lda, tau, work, info )
end subroutine dgehd2

subroutine dgehrd( n, ilo, ihi, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  integer :: ihi, ilo, info, lda, lwork, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dgehrd( n, ilo, ihi, a, lda, tau, work, lwork, info )
end subroutine dgehrd

subroutine dgelq2( m, n, a, lda, tau, work, info )
  use link_blas
  implicit none
  integer :: info, lda, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dgelq2( m, n, a, lda, tau, work, info )
end subroutine dgelq2

subroutine dgelqf( m, n, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  integer :: info, lda, lwork, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dgelqf( m, n, a, lda, tau, work, lwork, info )
end subroutine dgelqf

subroutine dgels( trans, m, n, nrhs, a, lda, b, ldb, work, lwork, info )
  use link_blas
  implicit none
  character :: trans
  integer :: info, lda, ldb, lwork, m, n, nrhs
  real*8 :: a( lda, * ), b( ldb, * ), work( * )
  call lb_dgels( trans, m, n, nrhs, a, lda, b, ldb, work, lwork, info )
end subroutine dgels

subroutine dgeqr2( m, n, a, lda, tau, work, info )
  use link_blas
  implicit none
  integer :: info, lda, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dgeqr2( m, n, a, lda, tau, work, info )
end subroutine dgeqr2

subroutine dgeqrf( m, n, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  integer :: info, lda, lwork, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dgeqrf( m, n, a, lda, tau, work, lwork, info )
end subroutine dgeqrf

subroutine dgesdd( jobz, m, n, a, lda, s, u, ldu, vt, ldvt, work, lwork, iwork, info )
  use link_blas
  implicit none
  character :: jobz
  integer :: info, lda, ldu, ldvt, lwork, m, n
  integer :: iwork( * )
  real*8 :: a( lda, * ), s( * ), u( ldu, * ), vt( ldvt, * ), work( * )
  call lb_dgesdd( jobz, m, n, a, lda, s, u, ldu, vt, ldvt, work, lwork, iwork, info )
end subroutine dgesdd

subroutine dgesv( n, nrhs, a, lda, ipiv, b, ldb, info )
  use link_blas
  implicit none
  integer :: info, lda, ldb, n, nrhs
  integer :: ipiv( * )
  real*8 :: a( lda, * ), b( ldb, * )
  call lb_dgesv( n, nrhs, a, lda, ipiv, b, ldb, info )
end subroutine dgesv

subroutine dgesvd( jobu, jobvt, m, n, a, lda, s, u, ldu, vt, ldvt, work, lwork, info )
  use link_blas
  implicit none
  character :: jobu, jobvt
  integer :: info, lda, ldu, ldvt, lwork, m, n
  real*8 :: a( lda, * ), s( * ), u( ldu, * ), vt( ldvt, * ), work( * )
  call lb_dgesvd( jobu, jobvt, m, n, a, lda, s, u, ldu, vt, ldvt, work, lwork, info )
end subroutine dgesvd

subroutine dgetrf( m, n, a, lda, ipiv, info )
  use link_blas
  implicit none
  integer :: info, lda, m, n
  integer :: ipiv( * )
  real*8 :: a( lda, * )
  call lb_dgetrf( m, n, a, lda, ipiv, info )
end subroutine dgetrf

recursive subroutine dgetrf2( m, n, a, lda, ipiv, info )
  use link_blas
  implicit none
  integer :: info, lda, m, n
  integer :: ipiv( * )
  real*8 :: a( lda, * )
  call lb_dgetrf2( m, n, a, lda, ipiv, info )
end subroutine dgetrf2

subroutine dgetri( n, a, lda, ipiv, work, lwork, info )
  use link_blas
  implicit none
  integer :: info, lda, lwork, n
  integer :: ipiv( * )
  real*8 :: a( lda, * ), work( * )
  call lb_dgetri( n, a, lda, ipiv, work, lwork, info )
end subroutine dgetri

subroutine dgetrs( trans, n, nrhs, a, lda, ipiv, b, ldb, info )
  use link_blas
  implicit none
  character :: trans
  integer :: info, lda, ldb, n, nrhs
  integer :: ipiv( * )
  real*8 :: a( lda, * ), b( ldb, * )
  call lb_dgetrs( trans, n, nrhs, a, lda, ipiv, b, ldb, info )
end subroutine dgetrs

subroutine dhseqr( job, compz, n, ilo, ihi, h, ldh, wr, wi, z, ldz, work, lwork, info )
  use link_blas
  implicit none
  integer :: ihi, ilo, info, ldh, ldz, lwork, n
  character :: compz, job
  real*8 :: h( ldh, * ), wi( * ), work( * ), wr( * ), z( ldz, * )
  call lb_dhseqr( job, compz, n, ilo, ihi, h, ldh, wr, wi, z, ldz, work, lwork, info )
end subroutine dhseqr

function disnan( din )
  use link_blas
  implicit none
  real*8 :: din
  logical :: disnan
  disnan=lb_disnan( din )
end function disnan

subroutine dlabad( small, large )
  use link_blas
  implicit none
  real*8 :: large, small
  call lb_dlabad( small, large )
end subroutine dlabad

subroutine dlabrd( m, n, nb, a, lda, d, e, tauq, taup, x, ldx, y, ldy )
  use link_blas
  implicit none
  integer :: lda, ldx, ldy, m, n, nb
  real*8 :: a( lda, * ), d( * ), e( * ), taup( * ), tauq( * ), x( ldx, * ), y( ldy, * )
  call lb_dlabrd( m, n, nb, a, lda, d, e, tauq, taup, x, ldx, y, ldy )
end subroutine dlabrd

subroutine dlacn2( n, v, x, isgn, est, kase, isave )
  use link_blas
  implicit none
  integer :: kase, n
  real*8 :: est
  integer :: isgn( * ), isave( 3 )
  real*8 :: v( * ), x( * )
  call lb_dlacn2( n, v, x, isgn, est, kase, isave )
end subroutine dlacn2

subroutine dlacpy( uplo, m, n, a, lda, b, ldb )
  use link_blas
  implicit none
  character :: uplo
  integer :: lda, ldb, m, n
  real*8 :: a( lda, * ), b( ldb, * )
  call lb_dlacpy( uplo, m, n, a, lda, b, ldb )
end subroutine dlacpy

subroutine dladiv( a, b, c, d, p, q )
  use link_blas
  implicit none
  real*8 :: a, b, c, d, p, q
  call lb_dladiv( a, b, c, d, p, q )
end subroutine dladiv

subroutine dladiv1( a, b, c, d, p, q )
  use link_blas
  implicit none
  real*8 :: a, b, c, d, p, q
  call lb_dladiv1( a, b, c, d, p, q )
end subroutine dladiv1

function dladiv2( a, b, c, d, r, t )
  use link_blas
  implicit none
  real*8 :: a, b, c, d, r, t
  real*8 :: dladiv2
  dladiv2=lb_dladiv2( a, b, c, d, r, t )
end function dladiv2

subroutine dlae2( a, b, c, rt1, rt2 )
  use link_blas
  implicit none
  real*8 :: a, b, c, rt1, rt2
  call lb_dlae2( a, b, c, rt1, rt2 )
end subroutine dlae2

subroutine dlaebz( ijob, nitmax, n, mmax, minp, nbmin, abstol, reltol, pivmin, d, e, e2, nval, ab, c, mout, nab, work, iwork, info )
  use link_blas
  implicit none
  integer :: ijob, info, minp, mmax, mout, n, nbmin, nitmax
  real*8 :: abstol, pivmin, reltol
  integer :: iwork( * ), nab( mmax, * ), nval( * )
  real*8 :: ab( mmax, * ), c( * ), d( * ), e( * ), e2( * ), work( * )
  call lb_dlaebz( ijob, nitmax, n, mmax, minp, nbmin, abstol, reltol, pivmin, d, e, e2, nval, ab, c, mout, nab, work, iwork, info )
end subroutine dlaebz

subroutine dlaed0( icompq, qsiz, n, d, e, q, ldq, qstore, ldqs, work, iwork, info )
  use link_blas
  implicit none
  integer :: icompq, info, ldq, ldqs, n, qsiz
  integer :: iwork( * )
  real*8 :: d( * ), e( * ), q( ldq, * ), qstore( ldqs, * ), work( * )
  call lb_dlaed0( icompq, qsiz, n, d, e, q, ldq, qstore, ldqs, work, iwork, info )
end subroutine dlaed0

subroutine dlaed1( n, d, q, ldq, indxq, rho, cutpnt, work, iwork, info )
  use link_blas
  implicit none
  integer :: cutpnt, info, ldq, n
  real*8 :: rho
  integer :: indxq( * ), iwork( * )
  real*8 :: d( * ), q( ldq, * ), work( * )
  call lb_dlaed1( n, d, q, ldq, indxq, rho, cutpnt, work, iwork, info )
end subroutine dlaed1

subroutine dlaed2( k, n, n1, d, q, ldq, indxq, rho, z, dlamda, w, q2, indx, indxc, indxp, coltyp, info )
  use link_blas
  implicit none
  integer :: info, k, ldq, n, n1
  real*8 :: rho
  integer :: coltyp( * ), indx( * ), indxc( * ), indxp( * ), indxq( * )
  real*8 :: d( * ), dlamda( * ), q( ldq, * ), q2( * ), w( * ), z( * )
  call lb_dlaed2( k, n, n1, d, q, ldq, indxq, rho, z, dlamda, w, q2, indx, indxc, indxp, coltyp, info )
end subroutine dlaed2

subroutine dlaed3( k, n, n1, d, q, ldq, rho, dlamda, q2, indx, ctot, w, s, info )
  use link_blas
  implicit none
  integer :: info, k, ldq, n, n1
  real*8 :: rho
  integer :: ctot( * ), indx( * )
  real*8 :: d( * ), dlamda( * ), q( ldq, * ), q2( * ), s( * ), w( * )
  call lb_dlaed3( k, n, n1, d, q, ldq, rho, dlamda, q2, indx, ctot, w, s, info )
end subroutine dlaed3

subroutine dlaed4( n, i, d, z, delta, rho, dlam, info )
  use link_blas
  implicit none
  integer :: i, info, n
  real*8 :: dlam, rho
  real*8 :: d( * ), delta( * ), z( * )
  call lb_dlaed4( n, i, d, z, delta, rho, dlam, info )
end subroutine dlaed4

subroutine dlaed5( i, d, z, delta, rho, dlam )
  use link_blas
  implicit none
  integer :: i
  real*8 :: dlam, rho
  real*8 :: d( 2 ), delta( 2 ), z( 2 )
  call lb_dlaed5( i, d, z, delta, rho, dlam )
end subroutine dlaed5

subroutine dlaed6( kniter, orgati, rho, d, z, finit, tau, info )
  use link_blas
  implicit none
  logical :: orgati
  integer :: info, kniter
  real*8 :: finit, rho, tau
  real*8 :: d( 3 ), z( 3 )
  call lb_dlaed6( kniter, orgati, rho, d, z, finit, tau, info )
end subroutine dlaed6

subroutine dlaed7( icompq, n, qsiz, tlvls, curlvl, curpbm, d, q, ldq, indxq, rho, cutpnt, qstore, qptr, prmptr, perm, givptr, &
                   givcol, givnum, work, iwork, info )
  use link_blas
  implicit none
  integer :: curlvl, curpbm, cutpnt, icompq, info, ldq, n, qsiz, tlvls
  real*8 :: rho
  integer :: givcol( 2, * ), givptr( * ), indxq( * ), iwork( * ), perm( * ), prmptr( * ), qptr( * )
  real*8 :: d( * ), givnum( 2, * ), q( ldq, * ), qstore( * ), work( * )
  call lb_dlaed7( icompq, n, qsiz, tlvls, curlvl, curpbm, d, q, ldq, indxq, rho, cutpnt, qstore, qptr, prmptr, perm, givptr, &
                  givcol, givnum, work, iwork, info )
end subroutine dlaed7

subroutine dlaed8( icompq, k, n, qsiz, d, q, ldq, indxq, rho, cutpnt, z, dlamda, q2, ldq2, w, perm, givptr, givcol, givnum, indxp, &
                   indx, info )
  use link_blas
  implicit none
  integer :: cutpnt, givptr, icompq, info, k, ldq, ldq2, n, qsiz
  real*8 :: rho
  integer :: givcol( 2, * ), indx( * ), indxp( * ), indxq( * ), perm( * )
  real*8 :: d( * ), dlamda( * ), givnum( 2, * ), q( ldq, * ), q2( ldq2, * ), w( * ), z( * )
  call lb_dlaed8( icompq, k, n, qsiz, d, q, ldq, indxq, rho, cutpnt, z, dlamda, q2, ldq2, w, perm, givptr, givcol, givnum, indxp, &
                  indx, info )
end subroutine dlaed8

subroutine dlaed9( k, kstart, kstop, n, d, q, ldq, rho, dlamda, w, s, lds, info )
  use link_blas
  implicit none
  integer :: info, k, kstart, kstop, ldq, lds, n
  real*8 :: rho
  real*8 :: d( * ), dlamda( * ), q( ldq, * ), s( lds, * ), w( * )
  call lb_dlaed9( k, kstart, kstop, n, d, q, ldq, rho, dlamda, w, s, lds, info )
end subroutine dlaed9

subroutine dlaeda( n, tlvls, curlvl, curpbm, prmptr, perm, givptr, givcol, givnum, q, qptr, z, ztemp, info )
  use link_blas
  implicit none
  integer :: curlvl, curpbm, info, n, tlvls
  integer :: givcol( 2, * ), givptr( * ), perm( * ), prmptr( * ), qptr( * )
  real*8 :: givnum( 2, * ), q( * ), z( * ), ztemp( * )
  call lb_dlaeda( n, tlvls, curlvl, curpbm, prmptr, perm, givptr, givcol, givnum, q, qptr, z, ztemp, info )
end subroutine dlaeda

subroutine dlaev2( a, b, c, rt1, rt2, cs1, sn1 )
  use link_blas
  implicit none
  real*8 :: a, b, c, cs1, rt1, rt2, sn1
  call lb_dlaev2( a, b, c, rt1, rt2, cs1, sn1 )
end subroutine dlaev2

subroutine dlaexc( wantq, n, t, ldt, q, ldq, j1, n1, n2, work, info )
  use link_blas
  implicit none
  logical :: wantq
  integer :: info, j1, ldq, ldt, n, n1, n2
  real*8 :: q( ldq, * ), t( ldt, * ), work( * )
  call lb_dlaexc( wantq, n, t, ldt, q, ldq, j1, n1, n2, work, info )
end subroutine dlaexc

subroutine dlagtf( n, a, lambda, b, c, tol, d, in, info )
  use link_blas
  implicit none
  integer :: info, n
  real*8 :: lambda, tol
  integer :: in( * )
  real*8 :: a( * ), b( * ), c( * ), d( * )
  call lb_dlagtf( n, a, lambda, b, c, tol, d, in, info )
end subroutine dlagtf

subroutine dlagts( job, n, a, b, c, d, in, y, tol, info )
  use link_blas
  implicit none
  integer :: info, job, n
  real*8 :: tol
  integer :: in( * )
  real*8 :: a( * ), b( * ), c( * ), d( * ), y( * )
  call lb_dlagts( job, n, a, b, c, d, in, y, tol, info )
end subroutine dlagts

subroutine dlahqr( wantt, wantz, n, ilo, ihi, h, ldh, wr, wi, iloz, ihiz, z, ldz, info )
  use link_blas
  implicit none
  integer :: ihi, ihiz, ilo, iloz, info, ldh, ldz, n
  logical :: wantt, wantz
  real*8 :: h( ldh, * ), wi( * ), wr( * ), z( ldz, * )
  call lb_dlahqr( wantt, wantz, n, ilo, ihi, h, ldh, wr, wi, iloz, ihiz, z, ldz, info )
end subroutine dlahqr

subroutine dlahr2( n, k, nb, a, lda, tau, t, ldt, y, ldy )
  use link_blas
  implicit none
  integer :: k, lda, ldt, ldy, n, nb
  real*8 :: a( lda, * ), t( ldt, nb ), tau( nb ), y( ldy, nb )
  call lb_dlahr2( n, k, nb, a, lda, tau, t, ldt, y, ldy )
end subroutine dlahr2

function dlaisnan( din1, din2 )
  use link_blas
  implicit none
  real*8 :: din1, din2
  logical :: dlaisnan
  dlaisnan=lb_dlaisnan( din1, din2 )
end function dlaisnan

subroutine dlaln2( ltrans, na, nw, smin, ca, a, lda, d1, d2, b, ldb, wr, wi, x, ldx, scale, xnorm, info )
  use link_blas
  implicit none
  logical :: ltrans
  integer :: info, lda, ldb, ldx, na, nw
  real*8 :: ca, d1, d2, scale, smin, wi, wr, xnorm
  real*8 :: a( lda, * ), b( ldb, * ), x( ldx, * )
  call lb_dlaln2( ltrans, na, nw, smin, ca, a, lda, d1, d2, b, ldb, wr, wi, x, ldx, scale, xnorm, info )
end subroutine dlaln2

function dlamc3( a, b )
  use link_blas
  implicit none
  real*8 :: A, B
  real*8 :: dlamc3
  dlamc3=lb_dlamc3( a, b )
end function dlamc3

function dlamch( cmach )
  use link_blas
  implicit none
  character :: cmach
  real*8 :: dlamch
  dlamch=lb_dlamch( cmach )
end function dlamch

subroutine dlamrg( n1, n2, a, dtrd1, dtrd2, index )
  use link_blas
  implicit none
  integer :: dtrd1, dtrd2, n1, n2
  integer :: index( * )
  real*8 :: a( * )
  call lb_dlamrg( n1, n2, a, dtrd1, dtrd2, index )
end subroutine dlamrg

function dlaneg( n, d, lld, sigma, pivmin, r )
  use link_blas
  implicit none
  integer :: n, r
  real*8 :: pivmin, sigma
  real*8 :: d( * ), lld( * )
  integer :: dlaneg
  dlaneg=lb_dlaneg( n, d, lld, sigma, pivmin, r )
end function dlaneg

function dlange( norm, m, n, a, lda, work )
  use link_blas
  implicit none
  character :: norm
  integer :: lda, m, n
  real*8 :: a( lda, * ), work( * )
  real*8 :: dlange
  dlange=lb_dlange( norm, m, n, a, lda, work )
end function dlange

function dlansp( norm, uplo, n, ap, work )
  use link_blas
  implicit none
  character :: norm, uplo
  integer :: n
  real*8 :: ap( * ), work( * )
  real*8 :: dlansp
  dlansp=lb_dlansp( norm, uplo, n, ap, work )
end function dlansp

function dlanst( norm, n, d, e )
  use link_blas
  implicit none
  character :: norm
  integer :: n
  real*8 :: d( * ), e( * )
  real*8 :: dlanst
  dlanst=lb_dlanst( norm, n, d, e )
end function dlanst

function dlansy( norm, uplo, n, a, lda, work )
  use link_blas
  implicit none
  character :: norm, uplo
  integer :: lda, n
  real*8 :: a( lda, * ), work( * )
  real*8 :: dlansy
  dlansy=lb_dlansy( norm, uplo, n, a, lda, work )
end function dlansy

subroutine dlanv2( a, b, c, d, rt1r, rt1i, rt2r, rt2i, cs, sn )
  use link_blas
  implicit none
  real*8 :: a, b, c, cs, d, rt1i, rt1r, rt2i, rt2r, sn
  call lb_dlanv2( a, b, c, d, rt1r, rt1i, rt2r, rt2i, cs, sn )
end subroutine dlanv2

function dlapy2( x, y )
  use link_blas
  implicit none
  real*8 :: x, y
  real*8 :: dlapy2
  dlapy2=lb_dlapy2( x, y )
end function dlapy2

function dlapy3( x, y, z )
  use link_blas
  implicit none
  real*8 :: x, y, z
  real*8 :: dlapy3
  dlapy3=lb_dlapy3( x, y, z )
end function dlapy3

subroutine dlaqr0( wantt, wantz, n, ilo, ihi, h, ldh, wr, wi, iloz, ihiz, z, ldz, work, lwork, info )
  use link_blas
  implicit none
  integer :: ihi, ihiz, ilo, iloz, info, ldh, ldz, lwork, n
  logical :: wantt, wantz
  real*8 :: h( ldh, * ), wi( * ), work( * ), wr( * ), z( ldz, * )
  call lb_dlaqr0( wantt, wantz, n, ilo, ihi, h, ldh, wr, wi, iloz, ihiz, z, ldz, work, lwork, info )
end subroutine dlaqr0

subroutine dlaqr1( n, h, ldh, sr1, si1, sr2, si2, v )
  use link_blas
  implicit none
  real*8 :: si1, si2, sr1, sr2
  integer :: ldh, n
  real*8 :: h( ldh, * ), v( * )
  call lb_dlaqr1( n, h, ldh, sr1, si1, sr2, si2, v )
end subroutine dlaqr1

subroutine dlaqr2( wantt, wantz, n, ktop, kbot, nw, h, ldh, iloz, ihiz, z, ldz, ns, nd, sr, si, v, ldv, nh, t, ldt, nv, wv, ldwv, &
                   work, lwork )
  use link_blas
  implicit none
  integer :: ihiz, iloz, kbot, ktop, ldh, ldt, ldv, ldwv, ldz, lwork, n, nd, nh, ns, nv, nw
  logical :: wantt, wantz
  real*8 :: h( ldh, * ), si( * ), sr( * ), t( ldt, * ), v( ldv, * ), work( * ), wv( ldwv, * ), z( ldz, * )
  call lb_dlaqr2( wantt, wantz, n, ktop, kbot, nw, h, ldh, iloz, ihiz, z, ldz, ns, nd, sr, si, v, ldv, nh, t, ldt, nv, wv, ldwv, &
                  work, lwork )
end subroutine dlaqr2

subroutine dlaqr3( wantt, wantz, n, ktop, kbot, nw, h, ldh, iloz, ihiz, z, ldz, ns, nd, sr, si, v, ldv, nh, t, ldt, nv, wv, ldwv, &
                   work, lwork )
  use link_blas
  implicit none
  integer :: ihiz, iloz, kbot, ktop, ldh, ldt, ldv, ldwv, ldz, lwork, n, nd, nh, ns, nv, nw
  logical :: wantt, wantz
  real*8 :: h( ldh, * ), si( * ), sr( * ), t( ldt, * ), v( ldv, * ), work( * ), wv( ldwv, * ), z( ldz, * )
  call lb_dlaqr3( wantt, wantz, n, ktop, kbot, nw, h, ldh, iloz, ihiz, z, ldz, ns, nd, sr, si, v, ldv, nh, t, ldt, nv, wv, ldwv, &
                  work, lwork )
end subroutine dlaqr3

subroutine dlaqr4( wantt, wantz, n, ilo, ihi, h, ldh, wr, wi, iloz, ihiz, z, ldz, work, lwork, info )
  use link_blas
  implicit none
  integer :: ihi, ihiz, ilo, iloz, info, ldh, ldz, lwork, n
  logical :: wantt, wantz
  real*8 :: h( ldh, * ), wi( * ), work( * ), wr( * ), z( ldz, * )
  call lb_dlaqr4( wantt, wantz, n, ilo, ihi, h, ldh, wr, wi, iloz, ihiz, z, ldz, work, lwork, info )
end subroutine dlaqr4

subroutine dlaqr5( wantt, wantz, kacc22, n, ktop, kbot, nshfts, sr, si, h, ldh, iloz, ihiz, z, ldz, v, ldv, u, ldu, nv, wv, ldwv, &
                   nh, wh, ldwh )
  use link_blas
  implicit none
  integer :: ihiz, iloz, kacc22, kbot, ktop, ldh, ldu, ldv, ldwh, ldwv, ldz, n, nh, nshfts, nv
  logical :: wantt, wantz
  real*8 :: h( ldh, * ), si( * ), sr( * ), u( ldu, * ), v( ldv, * ), wh( ldwh, * ), wv( ldwv, * ), z( ldz, * )
  call lb_dlaqr5( wantt, wantz, kacc22, n, ktop, kbot, nshfts, sr, si, h, ldh, iloz, ihiz, z, ldz, v, ldv, u, ldu, nv, wv, ldwv, &
                  nh, wh, ldwh )
end subroutine dlaqr5

subroutine dlar1v( n, b1, bn, lambda, d, l, ld, lld, pivmin, gaptol, z, wantnc, negcnt, ztz, mingma, r, isuppz, nrminv, resid, &
                   rqcorr, work )
  use link_blas
  implicit none
  logical :: wantnc
  integer :: b1, bn, n, negcnt, r
  real*8 :: gaptol, lambda, mingma, nrminv, pivmin, resid, rqcorr, ztz
  integer :: isuppz( * )
  real*8 :: d( * ), l( * ), ld( * ), lld( * ), work( * )
  real*8 :: z( * )
  call lb_dlar1v( n, b1, bn, lambda, d, l, ld, lld, pivmin, gaptol, z, wantnc, negcnt, ztz, mingma, r, isuppz, nrminv, resid, &
                  rqcorr, work )
end subroutine dlar1v

subroutine dlarf( side, m, n, v, incv, tau, c, ldc, work )
  use link_blas
  implicit none
  character :: side
  integer :: incv, ldc, m, n
  real*8 :: tau
  real*8 :: c( ldc, * ), v( * ), work( * )
  call lb_dlarf( side, m, n, v, incv, tau, c, ldc, work )
end subroutine dlarf

subroutine dlarfb( side, trans, direct, storev, m, n, k, v, ldv, t, ldt, c, ldc, work, ldwork )
  use link_blas
  implicit none
  character :: direct, side, storev, trans
  integer :: k, ldc, ldt, ldv, ldwork, m, n
  real*8 :: c( ldc, * ), t( ldt, * ), v( ldv, * ), work( ldwork, * )
  call lb_dlarfb( side, trans, direct, storev, m, n, k, v, ldv, t, ldt, c, ldc, work, ldwork )
end subroutine dlarfb

subroutine dlarfg( n, alpha, x, incx, tau )
  use link_blas
  implicit none
  integer :: incx, n
  real*8 :: alpha, tau
  real*8 :: x( * )
  call lb_dlarfg( n, alpha, x, incx, tau )
end subroutine dlarfg

subroutine dlarft( direct, storev, n, k, v, ldv, tau, t, ldt )
  use link_blas
  implicit none
  character :: direct, storev
  integer :: k, ldt, ldv, n
  real*8 :: t( ldt, * ), tau( * ), v( ldv, * )
  call lb_dlarft( direct, storev, n, k, v, ldv, tau, t, ldt )
end subroutine dlarft

subroutine dlarfx( side, m, n, v, tau, c, ldc, work )
  use link_blas
  implicit none
  character :: side
  integer :: ldc, m, n
  real*8 :: tau
  real*8 :: c( ldc, * ), v( * ), work( * )
  call lb_dlarfx( side, m, n, v, tau, c, ldc, work )
end subroutine dlarfx

subroutine dlarnv( idist, iseed, n, x )
  use link_blas
  implicit none
  integer :: idist, n
  integer :: iseed( 4 )
  real*8 :: x( * )
  call lb_dlarnv( idist, iseed, n, x )
end subroutine dlarnv

subroutine dlarra( n, d, e, e2, spltol, tnrm, nsplit, isplit, info )
  use link_blas
  implicit none
  integer :: info, n, nsplit
  real*8 :: spltol, tnrm
  integer :: isplit( * )
  real*8 :: d( * ), e( * ), e2( * )
  call lb_dlarra( n, d, e, e2, spltol, tnrm, nsplit, isplit, info )
end subroutine dlarra

subroutine dlarrb( n, d, lld, ifirst, ilast, rtol1, rtol2, offset, w, wgap, werr, work, iwork, pivmin, spdiam, twist, info )
  use link_blas
  implicit none
  integer :: ifirst, ilast, info, n, offset, twist
  real*8 :: pivmin, rtol1, rtol2, spdiam
  integer :: iwork( * )
  real*8 :: d( * ), lld( * ), w( * ), werr( * ), wgap( * ), work( * )
  call lb_dlarrb( n, d, lld, ifirst, ilast, rtol1, rtol2, offset, w, wgap, werr, work, iwork, pivmin, spdiam, twist, info )
end subroutine dlarrb

subroutine dlarrc( jobt, n, vl, vu, d, e, pivmin, eigcnt, lcnt, rcnt, info )
  use link_blas
  implicit none
  character :: jobt
  integer :: eigcnt, info, lcnt, n, rcnt
  real*8 :: pivmin, vl, vu
  real*8 :: d( * ), e( * )
  call lb_dlarrc( jobt, n, vl, vu, d, e, pivmin, eigcnt, lcnt, rcnt, info )
end subroutine dlarrc

subroutine dlarrd( range, order, n, vl, vu, il, iu, gers, reltol, d, e, e2, pivmin, nsplit, isplit, m, w, werr, wl, wu, iblock, &
                   indexw, work, iwork, info )
  use link_blas
  implicit none
  character :: order, range
  integer :: il, info, iu, m, n, nsplit
  real*8 :: pivmin, reltol, vl, vu, wl, wu
  integer :: iblock( * ), indexw( * ), isplit( * ), iwork( * )
  real*8 :: d( * ), e( * ), e2( * ), gers( * ), w( * ), werr( * ), work( * )
  call lb_dlarrd( range, order, n, vl, vu, il, iu, gers, reltol, d, e, e2, pivmin, nsplit, isplit, m, w, werr, wl, wu, iblock, &
                  indexw, work, iwork, info )
end subroutine dlarrd

subroutine dlarre( range, n, vl, vu, il, iu, d, e, e2, rtol1, rtol2, spltol, nsplit, isplit, m, w, werr, wgap, iblock, indexw, &
                   gers, pivmin, work, iwork, info )
  use link_blas
  implicit none
  character :: range
  integer :: il, info, iu, m, n, nsplit
  real*8 :: pivmin, rtol1, rtol2, spltol, vl, vu
  integer :: iblock( * ), isplit( * ), iwork( * ), indexw( * )
  real*8 :: d( * ), e( * ), e2( * ), gers( * ), w( * ),werr( * ), wgap( * ), work( * )
  call lb_dlarre( range, n, vl, vu, il, iu, d, e, e2, rtol1, rtol2, spltol, nsplit, isplit, m, w, werr, wgap, iblock, indexw, &
                  gers, pivmin, work, iwork, info )
end subroutine dlarre

subroutine dlarrf( n, d, l, ld, clstrt, clend, w, wgap, werr, spdiam, clgapl, clgapr, pivmin, sigma, dplus, lplus, work, info )
  use link_blas
  implicit none
  integer :: clstrt, clend, info, n
  real*8 :: clgapl, clgapr, pivmin, sigma, spdiam
  real*8 :: d( * ), dplus( * ), l( * ), ld( * ), lplus( * ), w( * ), wgap( * ), werr( * ), work( * )
  call lb_dlarrf( n, d, l, ld, clstrt, clend, w, wgap, werr, spdiam, clgapl, clgapr, pivmin, sigma, dplus, lplus, work, info )
end subroutine dlarrf

subroutine dlarrj( n, d, e2, ifirst, ilast, rtol, offset, w, werr, work, iwork, pivmin, spdiam, info )
  use link_blas
  implicit none
  integer :: ifirst, ilast, info, n, offset
  real*8 :: pivmin, rtol, spdiam
  integer :: iwork( * )
  real*8 :: d( * ), e2( * ), w( * ), werr( * ), work( * )
  call lb_dlarrj( n, d, e2, ifirst, ilast, rtol, offset, w, werr, work, iwork, pivmin, spdiam, info )
end subroutine dlarrj

subroutine dlarrk( n, iw, gl, gu, d, e2, pivmin, reltol, w, werr, info)
  use link_blas
  implicit none
  integer :: info, iw, n
  real*8 :: pivmin, reltol, gl, gu, w, werr
  real*8 :: d( * ), e2( * )
  call lb_dlarrk( n, iw, gl, gu, d, e2, pivmin, reltol, w, werr, info)
end subroutine dlarrk

subroutine dlarrr( n, d, e, info )
  use link_blas
  implicit none
  integer :: n, info
  real*8 :: d( * ), e( * )
  call lb_dlarrr( n, d, e, info )
end subroutine dlarrr

subroutine dlarrv( n, vl, vu, d, l, pivmin, isplit, m, dol, dou, minrgp, rtol1, rtol2, w, werr, wgap, iblock, indexw, gers, z, &
                   ldz, isuppz, work, iwork, info )
  use link_blas
  implicit none
  integer :: dol, dou, info, ldz, m, n
  real*8 :: minrgp, pivmin, rtol1, rtol2, vl, vu
  integer :: iblock( * ), indexw( * ), isplit( * ), isuppz( * ), iwork( * )
  real*8 :: d( * ), gers( * ), l( * ), w( * ), werr( * ), wgap( * ), work( * )
  real*8 :: z( ldz, * )
  call lb_dlarrv( n, vl, vu, d, l, pivmin, isplit, m, dol, dou, minrgp, rtol1, rtol2, w, werr, wgap, iblock, indexw, gers, z, ldz, &
                  isuppz, work, iwork, info )
end subroutine dlarrv

subroutine dlartg( f, g, cs, sn, r )
  use link_blas
  implicit none
  real*8 :: cs, f, g, r, sn
  call lb_dlartg( f, g, cs, sn, r )
end subroutine dlartg

subroutine dlaruv( iseed, n, x )
  use link_blas
  implicit none
  integer :: n
  integer :: iseed( 4 )
  real*8 :: x( n )
  call lb_dlaruv( iseed, n, x )
end subroutine dlaruv

subroutine dlas2( f, g, h, ssmin, ssmax )
  use link_blas
  implicit none
  real*8 :: f, g, h, ssmax, ssmin
  call lb_dlas2( f, g, h, ssmin, ssmax )
end subroutine dlas2

subroutine dlascl( type, kl, ku, cfrom, cto, m, n, a, lda, info )
  use link_blas
  implicit none
  character :: type
  integer :: info, kl, ku, lda, m, n
  real*8 :: cfrom, cto
  real*8 :: a( lda, * )
  call lb_dlascl( type, kl, ku, cfrom, cto, m, n, a, lda, info )
end subroutine dlascl

subroutine dlasd0( n, sqre, d, e, u, ldu, vt, ldvt, smlsiz, iwork, work, info )
  use link_blas
  implicit none
  integer :: info, ldu, ldvt, n, smlsiz, sqre
  integer :: iwork( * )
  real*8 :: d( * ), e( * ), u( ldu, * ), vt( ldvt, * ), work( * )
  call lb_dlasd0( n, sqre, d, e, u, ldu, vt, ldvt, smlsiz, iwork, work, info )
end subroutine dlasd0

subroutine dlasd1( nl, nr, sqre, d, alpha, beta, u, ldu, vt, ldvt, idxq, iwork, work, info )
  use link_blas
  implicit none
  integer :: info, ldu, ldvt, nl, nr, sqre
  real*8 :: alpha, beta
  integer :: idxq( * ), iwork( * )
  real*8 :: d( * ), u( ldu, * ), vt( ldvt, * ), work( * )
  call lb_dlasd1( nl, nr, sqre, d, alpha, beta, u, ldu, vt, ldvt, idxq, iwork, work, info )
end subroutine dlasd1

subroutine dlasd2( nl, nr, sqre, k, d, z, alpha, beta, u, ldu, vt, ldvt, dsigma, u2, ldu2, vt2, ldvt2, idxp, idx, idxc, idxq, &
                   coltyp, info )
  use link_blas
  implicit none
  integer :: info, k, ldu, ldu2, ldvt, ldvt2, nl, nr, sqre
  real*8 :: alpha, beta
  integer :: coltyp( * ), idx( * ), idxc( * ), idxp( * ), idxq( * )
  real*8 :: d( * ), dsigma( * ), u( ldu, * ), u2( ldu2, * ), vt( ldvt, * ), vt2( ldvt2, * ), z( * )
  call lb_dlasd2( nl, nr, sqre, k, d, z, alpha, beta, u, ldu, vt, ldvt, dsigma, u2, ldu2, vt2, ldvt2, idxp, idx, idxc, idxq, &
                  coltyp, info )
end subroutine dlasd2

subroutine dlasd3( nl, nr, sqre, k, d, q, ldq, dsigma, u, ldu, u2, ldu2, vt, ldvt, vt2, ldvt2, idxc, ctot, z, info )
  use link_blas
  implicit none
  integer :: info, k, ldq, ldu, ldu2, ldvt, ldvt2, nl, nr, sqre
  integer :: ctot( * ), idxc( * )
  real*8 :: d( * ), dsigma( * ), q( ldq, * ), u( ldu, * ), u2( ldu2, * ), vt( ldvt, * ), vt2( ldvt2, * ), z( * )
  call lb_dlasd3( nl, nr, sqre, k, d, q, ldq, dsigma, u, ldu, u2, ldu2, vt, ldvt, vt2, ldvt2, idxc, ctot, z, info )
end subroutine dlasd3

subroutine dlasd4( n, i, d, z, delta, rho, sigma, work, info )
  use link_blas
  implicit none
  integer :: i, info, n
  real*8 :: rho, sigma
  real*8 :: d( * ), delta( * ), work( * ), z( * )
  call lb_dlasd4( n, i, d, z, delta, rho, sigma, work, info )
end subroutine dlasd4

subroutine dlasd5( i, d, z, delta, rho, dsigma, work )
  use link_blas
  implicit none
  integer :: i
  real*8 :: dsigma, rho
  real*8 :: d( 2 ), delta( 2 ), work( 2 ), z( 2 )
  call lb_dlasd5( i, d, z, delta, rho, dsigma, work )
end subroutine dlasd5

subroutine dlasd6( icompq, nl, nr, sqre, d, vf, vl, alpha, beta, idxq, perm, givptr, givcol, ldgcol, givnum, ldgnum, poles, difl, &
                   difr, z, k, c, s, work, iwork, info )
  use link_blas
  implicit none
  integer :: givptr, icompq, info, k, ldgcol, ldgnum, nl, nr, sqre
  real*8 :: alpha, beta, c, s
  integer :: givcol( ldgcol, * ), idxq( * ), iwork( * ), perm( * )
  real*8 :: d( * ), difl( * ), difr( * ), givnum( ldgnum, * ), poles( ldgnum, * ), vf( * ), vl( * ), work( * ), z( * )
  call lb_dlasd6( icompq, nl, nr, sqre, d, vf, vl, alpha, beta, idxq, perm, givptr, givcol, ldgcol, givnum, ldgnum, poles, difl, &
                  difr, z, k, c, s, work, iwork, info )
end subroutine dlasd6

subroutine dlasd7( icompq, nl, nr, sqre, k, d, z, zw, vf, vfw, vl, vlw, alpha, beta, dsigma, idx, idxp, idxq, perm, givptr, &
                   givcol, ldgcol, givnum, ldgnum, c, s, info )
  use link_blas
  implicit none
  integer :: givptr, icompq, info, k, ldgcol, ldgnum, nl, nr, sqre
  real*8 :: alpha, beta, c, s
  integer :: givcol( ldgcol, * ), idx( * ), idxp( * ), idxq( * ), perm( * )
  real*8 :: d( * ), dsigma( * ), givnum( ldgnum, * ), vf( * ), vfw( * ), vl( * ), vlw( * ), z( * ), zw( * )
  call lb_dlasd7( icompq, nl, nr, sqre, k, d, z, zw, vf, vfw, vl, vlw, alpha, beta, dsigma, idx, idxp, idxq, perm, givptr, &
                  givcol, ldgcol, givnum, ldgnum, c, s, info )
end subroutine dlasd7

subroutine dlasd8( icompq, k, d, z, vf, vl, difl, difr, lddifr, dsigma, work, info )
  use link_blas
  implicit none
  integer :: icompq, info, k, lddifr
  real*8 :: d( * ), difl( * ), difr( lddifr, * ), dsigma( * ), vf( * ), vl( * ), work( * ), z( * )
  call lb_dlasd8( icompq, k, d, z, vf, vl, difl, difr, lddifr, dsigma, work, info )
end subroutine dlasd8

subroutine dlasda( icompq, smlsiz, n, sqre, d, e, u, ldu, vt, k, difl, difr, z, poles, givptr, givcol, ldgcol, perm, givnum, c, s, &
                   work, iwork, info )
  use link_blas
  implicit none
  integer :: icompq, info, ldgcol, ldu, n, smlsiz, sqre
  integer :: givcol( ldgcol, * ), givptr( * ), iwork( * ), k( * ), perm( ldgcol, * )
  real*8 :: c( * ), d( * ), difl( ldu, * ), difr( ldu, * ), e( * ), givnum( ldu, * ), poles( ldu, * ), s( * ), u( ldu, * ), &
            vt( ldu, * ), work( * ), z( ldu, * )
  call lb_dlasda( icompq, smlsiz, n, sqre, d, e, u, ldu, vt, k, difl, difr, z, poles, givptr, givcol, ldgcol, perm, givnum, c, s, &
                  work, iwork, info )
end subroutine dlasda

subroutine dlasdq( uplo, sqre, n, ncvt, nru, ncc, d, e, vt, ldvt, u, ldu, c, ldc, work, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, ldc, ldu, ldvt, n, ncc, ncvt, nru, sqre
  real*8 :: c( ldc, * ), d( * ), e( * ), u( ldu, * ), vt( ldvt, * ), work( * )
  call lb_dlasdq( uplo, sqre, n, ncvt, nru, ncc, d, e, vt, ldvt, u, ldu, c, ldc, work, info )
end subroutine dlasdq

subroutine dlasdt( n, lvl, nd, inode, ndiml, ndimr, msub )
  use link_blas
  implicit none
  integer :: lvl, msub, n, nd
  integer :: inode( * ), ndiml( * ), ndimr( * )
  call lb_dlasdt( n, lvl, nd, inode, ndiml, ndimr, msub )
end subroutine dlasdt

subroutine dlaset( uplo, m, n, alpha, beta, a, lda )
  use link_blas
  implicit none
  character :: uplo
  integer :: lda, m, n
  real*8 :: alpha, beta
  real*8 :: a( lda, * )
  call lb_dlaset( uplo, m, n, alpha, beta, a, lda )
end subroutine dlaset

subroutine dlasq1( n, d, e, work, info )
  use link_blas
  implicit none
  integer :: info, n
  real*8 :: d( * ), e( * ), work( * )
  call lb_dlasq1( n, d, e, work, info )
end subroutine dlasq1

subroutine dlasq2( n, z, info )
  use link_blas
  implicit none
  integer :: info, n
  real*8 :: z( * )
  call lb_dlasq2( n, z, info )
end subroutine dlasq2

subroutine dlasq3( i0, n0, z, pp, dmin, sigma, desig, qmax, nfail, iter, ndiv, ieee, ttype, dmin1, dmin2, dn, dn1, dn2, g, tau )
  use link_blas
  implicit none
  logical :: ieee
  integer :: i0, iter, n0, ndiv, nfail, pp, ttype
  real*8 :: desig, dmin, dmin1, dmin2, dn, dn1, dn2, g, qmax, sigma, tau
  real*8 :: z( * )
  call lb_dlasq3( i0, n0, z, pp, dmin, sigma, desig, qmax, nfail, iter, ndiv, ieee, ttype, dmin1, dmin2, dn, dn1, dn2, g, tau )
end subroutine dlasq3

subroutine dlasq4( i0, n0, z, pp, n0in, dmin, dmin1, dmin2, dn, dn1, dn2, tau, ttype, g )
  use link_blas
  implicit none
  integer :: i0, n0, n0in, pp, ttype
  real*8 :: dmin, dmin1, dmin2, dn, dn1, dn2, g, tau
  real*8 :: z( * )
  call lb_dlasq4( i0, n0, z, pp, n0in, dmin, dmin1, dmin2, dn, dn1, dn2, tau, ttype, g )
end subroutine dlasq4

subroutine dlasq5( i0, n0, z, pp, tau, sigma, dmin, dmin1, dmin2, dn, dnm1, dnm2, ieee, eps )
  use link_blas
  implicit none
  logical :: ieee
  integer :: i0, n0, pp
  real*8 :: dmin, dmin1, dmin2, dn, dnm1, dnm2, tau, sigma, eps
  real*8 :: z( * )
  call lb_dlasq5( i0, n0, z, pp, tau, sigma, dmin, dmin1, dmin2, dn, dnm1, dnm2, ieee, eps )
end subroutine dlasq5

subroutine dlasq6( i0, n0, z, pp, dmin, dmin1, dmin2, dn, dnm1, dnm2 )
  use link_blas
  implicit none
  integer :: i0, n0, pp
  real*8 :: dmin, dmin1, dmin2, dn, dnm1, dnm2
  real*8 :: z( * )
  call lb_dlasq6( i0, n0, z, pp, dmin, dmin1, dmin2, dn, dnm1, dnm2 )
end subroutine dlasq6

subroutine dlasr( side, pivot, direct, m, n, c, s, a, lda )
  use link_blas
  implicit none
  character :: direct, pivot, side
  integer :: lda, m, n
  real*8 :: a( lda, * ), c( * ), s( * )
  call lb_dlasr( side, pivot, direct, m, n, c, s, a, lda )
end subroutine dlasr

subroutine dlasrt( id, n, d, info )
  use link_blas
  implicit none
  character :: id
  integer :: info, n
  real*8 :: d( * )
  call lb_dlasrt( id, n, d, info )
end subroutine dlasrt

subroutine dlassq( n, x, incx, scale, sumsq )
  use link_blas
  implicit none
  integer :: incx, n
  real*8 :: scale, sumsq
  real*8 :: x( * )
  call lb_dlassq( n, x, incx, scale, sumsq )
end subroutine dlassq

subroutine dlasv2( f, g, h, ssmin, ssmax, snr, csr, snl, csl )
  use link_blas
  implicit none
  real*8 :: csl, csr, f, g, h, snl, snr, ssmax, ssmin
  call lb_dlasv2( f, g, h, ssmin, ssmax, snr, csr, snl, csl )
end subroutine dlasv2

subroutine dlaswp( n, a, lda, k1, k2, ipiv, incx )
  use link_blas
  implicit none
  integer :: incx, k1, k2, lda, n
  integer :: ipiv( * )
  real*8 :: a( lda, * )
  call lb_dlaswp( n, a, lda, k1, k2, ipiv, incx )
end subroutine dlaswp

subroutine dlasy2( ltranl, ltranr, isgn, n1, n2, tl, ldtl, tr, ldtr, b, ldb, scale, x, ldx, xnorm, info )
  use link_blas
  implicit none
  logical :: ltranl, ltranr
  integer :: info, isgn, ldb, ldtl, ldtr, ldx, n1, n2
  real*8 :: scale, xnorm
  real*8 :: b( ldb, * ), tl( ldtl, * ), tr( ldtr, * ), x( ldx, * )
  call lb_dlasy2( ltranl, ltranr, isgn, n1, n2, tl, ldtl, tr, ldtr, b, ldb, scale, x, ldx, xnorm, info )
end subroutine dlasy2

subroutine dlatrd( uplo, n, nb, a, lda, e, tau, w, ldw )
  use link_blas
  implicit none
  character :: uplo
  integer :: lda, ldw, n, nb
  real*8 :: a( lda, * ), e( * ), tau( * ), w( ldw, * )
  call lb_dlatrd( uplo, n, nb, a, lda, e, tau, w, ldw )
end subroutine dlatrd

subroutine dlatrs( uplo, trans, diag, normin, n, a, lda, x, scale, cnorm, info )
  use link_blas
  implicit none
  character :: diag, normin, trans, uplo
  integer :: info, lda, n
  real*8 :: scale
  real*8 :: a( lda, * ), cnorm( * ), x( * )
  call lb_dlatrs( uplo, trans, diag, normin, n, a, lda, x, scale, cnorm, info )
end subroutine dlatrs

subroutine dopgtr( uplo, n, ap, tau, q, ldq, work, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, ldq, n
  real*8 :: ap( * ), q( ldq, * ), tau( * ), work( * )
  call lb_dopgtr( uplo, n, ap, tau, q, ldq, work, info )
end subroutine dopgtr

subroutine dopmtr( side, uplo, trans, m, n, ap, tau, c, ldc, work, info )
  use link_blas
  implicit none
  character :: side, trans, uplo
  integer :: info, ldc, m, n
  real*8 :: ap( * ), c( ldc, * ), tau( * ), work( * )
  call lb_dopmtr( side, uplo, trans, m, n, ap, tau, c, ldc, work, info )
end subroutine dopmtr

subroutine dorg2l( m, n, k, a, lda, tau, work, info )
  use link_blas
  implicit none
  integer :: info, k, lda, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dorg2l( m, n, k, a, lda, tau, work, info )
end subroutine dorg2l

subroutine dorg2r( m, n, k, a, lda, tau, work, info )
  use link_blas
  implicit none
  integer :: info, k, lda, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dorg2r( m, n, k, a, lda, tau, work, info )
end subroutine dorg2r

subroutine dorgbr( vect, m, n, k, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  character :: vect
  integer :: info, k, lda, lwork, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dorgbr( vect, m, n, k, a, lda, tau, work, lwork, info )
end subroutine dorgbr

subroutine dorghr( n, ilo, ihi, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  integer :: ihi, ilo, info, lda, lwork, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dorghr( n, ilo, ihi, a, lda, tau, work, lwork, info )
end subroutine dorghr

subroutine dorgl2( m, n, k, a, lda, tau, work, info )
  use link_blas
  implicit none
  integer :: info, k, lda, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dorgl2( m, n, k, a, lda, tau, work, info )
end subroutine dorgl2

subroutine dorglq( m, n, k, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  integer :: info, k, lda, lwork, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dorglq( m, n, k, a, lda, tau, work, lwork, info )
end subroutine dorglq

subroutine dorgql( m, n, k, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  integer :: info, k, lda, lwork, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dorgql( m, n, k, a, lda, tau, work, lwork, info )
end subroutine dorgql

subroutine dorgqr( m, n, k, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  integer :: info, k, lda, lwork, m, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dorgqr( m, n, k, a, lda, tau, work, lwork, info )
end subroutine dorgqr

subroutine dorgtr( uplo, n, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, lwork, n
  real*8 :: a( lda, * ), tau( * ), work( * )
  call lb_dorgtr( uplo, n, a, lda, tau, work, lwork, info )
end subroutine dorgtr

subroutine dorm2l( side, trans, m, n, k, a, lda, tau, c, ldc, work, info )
  use link_blas
  implicit none
  character :: side, trans
  integer :: info, k, lda, ldc, m, n
  real*8 :: a( lda, * ), c( ldc, * ), tau( * ), work( * )
  call lb_dorm2l( side, trans, m, n, k, a, lda, tau, c, ldc, work, info )
end subroutine dorm2l

subroutine dorm2r( side, trans, m, n, k, a, lda, tau, c, ldc, work, info )
  use link_blas
  implicit none
  character :: side, trans
  integer :: info, k, lda, ldc, m, n
  real*8 :: a( lda, * ), c( ldc, * ), tau( * ), work( * )
  call lb_dorm2r( side, trans, m, n, k, a, lda, tau, c, ldc, work, info )
end subroutine dorm2r

subroutine dormbr( vect, side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info )
  use link_blas
  implicit none
  character :: side, trans, vect
  integer :: info, k, lda, ldc, lwork, m, n
  real*8 :: a( lda, * ), c( ldc, * ), tau( * ), work( * )
  call lb_dormbr( vect, side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info )
end subroutine dormbr

subroutine dormhr( side, trans, m, n, ilo, ihi, a, lda, tau, c, ldc, work, lwork, info )
  use link_blas
  implicit none
  character :: side, trans
  integer :: ihi, ilo, info, lda, ldc, lwork, m, n
  real*8 :: a( lda, * ), c( ldc, * ), tau( * ), work( * )
  call lb_dormhr( side, trans, m, n, ilo, ihi, a, lda, tau, c, ldc, work, lwork, info )
end subroutine dormhr

subroutine dorml2( side, trans, m, n, k, a, lda, tau, c, ldc, work, info )
  use link_blas
  implicit none
  character :: side, trans
  integer :: info, k, lda, ldc, m, n
  real*8 :: a( lda, * ), c( ldc, * ), tau( * ), work( * )
  call lb_dorml2( side, trans, m, n, k, a, lda, tau, c, ldc, work, info )
end subroutine dorml2

subroutine dormlq( side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info )
  use link_blas
  implicit none
  character :: side, trans
  integer :: info, k, lda, ldc, lwork, m, n
  real*8 :: a( lda, * ), c( ldc, * ), tau( * ), work( * )
  call lb_dormlq( side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info )
end subroutine dormlq

subroutine dormql( side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info )
  use link_blas
  implicit none
  character :: side, trans
  integer :: info, k, lda, ldc, lwork, m, n
  real*8 :: a( lda, * ), c( ldc, * ), tau( * ), work( * )
  call lb_dormql( side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info )
end subroutine dormql

subroutine dormqr( side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info )
  use link_blas
  implicit none
  character :: side, trans
  integer :: info, k, lda, ldc, lwork, m, n
  real*8 :: a( lda, * ), c( ldc, * ), tau( * ), work( * )
  call lb_dormqr( side, trans, m, n, k, a, lda, tau, c, ldc, work, lwork, info )
end subroutine dormqr

subroutine dormtr( side, uplo, trans, m, n, a, lda, tau, c, ldc, work, lwork, info )
  use link_blas
  implicit none
  character :: side, trans, uplo
  integer :: info, lda, ldc, lwork, m, n
  real*8 :: a( lda, * ), c( ldc, * ), tau( * ), work( * )
  call lb_dormtr( side, uplo, trans, m, n, a, lda, tau, c, ldc, work, lwork, info )
end subroutine dormtr

subroutine dposv( uplo, n, nrhs, a, lda, b, ldb, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, ldb, n, nrhs
  real*8 :: a( lda, * ), b( ldb, * )
  call lb_dposv( uplo, n, nrhs, a, lda, b, ldb, info )
end subroutine dposv

subroutine dpotrf( uplo, n, a, lda, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, n
  real*8 :: a( lda, * )
  call lb_dpotrf( uplo, n, a, lda, info )
end subroutine dpotrf

recursive subroutine dpotrf2( uplo, n, a, lda, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, n
  real*8 :: a( lda, * )
  call lb_dpotrf2( uplo, n, a, lda, info )
end subroutine dpotrf2

subroutine dpotrs( uplo, n, nrhs, a, lda, b, ldb, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, ldb, n, nrhs
  real*8 :: a( lda, * ), b( ldb, * )
  call lb_dpotrs( uplo, n, nrhs, a, lda, b, ldb, info )
end subroutine dpotrs

subroutine dpptrf( uplo, n, ap, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, n
  real*8 :: ap( * )
  call lb_dpptrf( uplo, n, ap, info )
end subroutine dpptrf

subroutine drscl( n, sa, sx, incx )
  use link_blas
  implicit none
  integer :: incx, n
  real*8 :: sa
  real*8 :: sx( * )
  call lb_drscl( n, sa, sx, incx )
end subroutine drscl

subroutine dspev( jobz, uplo, n, ap, w, z, ldz, work, info )
  use link_blas
  implicit none
  character :: jobz, uplo
  integer ::  info, ldz, n
  real*8 :: ap( * ), w( * ), work( * ), z( ldz, * )
  call lb_dspev( jobz, uplo, n, ap, w, z, ldz, work, info )
end subroutine dspev

subroutine dspgst( itype, uplo, n, ap, bp, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, itype, n
  real*8 :: ap( * ), bp( * )
  call lb_dspgst( itype, uplo, n, ap, bp, info )
end subroutine dspgst

subroutine dspgv( itype, jobz, uplo, n, ap, bp, w, z, ldz, work, info )
  use link_blas
  implicit none
  character :: jobz, uplo
  integer :: info, itype, ldz, n
  real*8 :: ap( * ), bp( * ), w( * ), work( * ), z( ldz, * )
  call lb_dspgv( itype, jobz, uplo, n, ap, bp, w, z, ldz, work, info )
end subroutine dspgv

subroutine dsptrd( uplo, n, ap, d, e, tau, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, n
  real*8 :: ap( * ), d( * ), e( * ), tau( * )
  call lb_dsptrd( uplo, n, ap, d, e, tau, info )
end subroutine dsptrd

subroutine dstebz( range, order, n, vl, vu, il, iu, abstol, d, e, m, nsplit, w, iblock, isplit, work, iwork, info )
  use link_blas
  implicit none
  character :: order, range
  integer :: il, info, iu, m, n, nsplit
  real*8 :: abstol, vl, vu
  integer :: iblock( * ), isplit( * ), iwork( * )
  real*8 :: d( * ), e( * ), w( * ), work( * )
  call lb_dstebz( range, order, n, vl, vu, il, iu, abstol, d, e, m, nsplit, w, iblock, isplit, work, iwork, info )
end subroutine dstebz

subroutine dstedc( compz, n, d, e, z, ldz, work, lwork, iwork, liwork, info )
  use link_blas
  implicit none
  character :: compz
  integer :: info, ldz, liwork, lwork, n
  integer :: iwork( * )
  real*8 :: d( * ), e( * ), work( * ), z( ldz, * )
  call lb_dstedc( compz, n, d, e, z, ldz, work, lwork, iwork, liwork, info )
end subroutine dstedc

subroutine dstein( n, d, e, m, w, iblock, isplit, z, ldz, work, iwork, ifail, info )
  use link_blas
  implicit none
  integer :: info, ldz, m, n
  integer :: iblock( * ), ifail( * ), isplit( * ), iwork( * )
  real*8 :: d( * ), e( * ), w( * ), work( * ), z( ldz, * )
  call lb_dstein( n, d, e, m, w, iblock, isplit, z, ldz, work, iwork, ifail, info )
end subroutine dstein

subroutine dstemr( jobz, range, n, d, e, vl, vu, il, iu, m, w, z, ldz, nzc, isuppz, tryrac, work, lwork, iwork, liwork, info )
  use link_blas
  implicit none
  character :: jobz, range
  logical :: tryrac
  integer :: il, info, iu, ldz, nzc, liwork, lwork, m, n
  real*8 :: vl, vu
  integer :: isuppz( * ), iwork( * )
  real*8 :: d( * ), e( * ), w( * ), work( * )
  real*8 :: z( ldz, * )
  call lb_dstemr( jobz, range, n, d, e, vl, vu, il, iu, m, w, z, ldz, nzc, isuppz, tryrac, work, lwork, iwork, liwork, info )
end subroutine dstemr

subroutine dsteqr( compz, n, d, e, z, ldz, work, info )
  use link_blas
  implicit none
  character :: compz
  integer :: info, ldz, n
  real*8 :: d( * ), e( * ), work( * ), z( ldz, * )
  call lb_dsteqr( compz, n, d, e, z, ldz, work, info )
end subroutine dsteqr

subroutine dsterf( n, d, e, info )
  use link_blas
  implicit none
  integer :: info, n
  real*8 :: d( * ), e( * )
  call lb_dsterf( n, d, e, info )
end subroutine dsterf

subroutine dstevr( jobz, range, n, d, e, vl, vu, il, iu, abstol, m, w, z, ldz, isuppz, work, lwork, iwork, liwork, info )
  use link_blas
  implicit none
  character :: jobz, range
  integer :: il, info, iu, ldz, liwork, lwork, m, n
  real*8 :: abstol, vl, vu
  integer :: isuppz( * ), iwork( * )
  real*8 :: d( * ), e( * ), w( * ), work( * ), z( ldz, * )
  call lb_dstevr( jobz, range, n, d, e, vl, vu, il, iu, abstol, m, w, z, ldz, isuppz, work, lwork, iwork, liwork, info )
end subroutine dstevr

subroutine dsyev( jobz, uplo, n, a, lda, w, work, lwork, info )
  use link_blas
  implicit none
  character :: jobz, uplo
  integer ::   info, lda, lwork, n
  real*8 ::    a( lda, * ), w( * ), work( * )
  call lb_dsyev( jobz, uplo, n, a, lda, w, work, lwork, info )
end subroutine dsyev

subroutine dsyevd( jobz, uplo, n, a, lda, w, work, lwork, iwork, liwork, info )
  use link_blas
  implicit none
  character :: jobz, uplo
  integer :: info, lda, liwork, lwork, n
  integer :: iwork( * )
  real*8 :: a( lda, * ), w( * ), work( * )
  call lb_dsyevd( jobz, uplo, n, a, lda, w, work, lwork, iwork, liwork, info )
end subroutine dsyevd

subroutine dsyevr( jobz, range, uplo, n, a, lda, vl, vu, il, iu, abstol, m, w, z, ldz, isuppz, work, lwork, iwork, liwork, info )
  use link_blas
  implicit none
  character :: jobz, range, uplo
  integer :: il, info, iu, lda, ldz, liwork, lwork, m, n
  real*8 :: abstol, vl, vu
  integer :: isuppz( * ), iwork( * )
  real*8 :: a( lda, * ), w( * ), work( * ), z( ldz, * )
  call lb_dsyevr( jobz, range, uplo, n, a, lda, vl, vu, il, iu, abstol, m, w, z, ldz, isuppz, work, lwork, iwork, liwork, info )
end subroutine dsyevr

subroutine dsygs2( itype, uplo, n, a, lda, b, ldb, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, itype, lda, ldb, n
  real*8 :: a( lda, * ), b( ldb, * )
  call lb_dsygs2( itype, uplo, n, a, lda, b, ldb, info )
end subroutine dsygs2

subroutine dsygst( itype, uplo, n, a, lda, b, ldb, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, itype, lda, ldb, n
  real*8 :: a( lda, * ), b( ldb, * )
  call lb_dsygst( itype, uplo, n, a, lda, b, ldb, info )
end subroutine dsygst

subroutine dsygv( itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, info )
  use link_blas
  implicit none
  character :: jobz, uplo
  integer :: info, itype, lda, ldb, lwork, n
  real*8 :: a( lda, * ), b( ldb, * ), w( * ), work( * )
  call lb_dsygv( itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, info )
end subroutine dsygv

subroutine dsytd2( uplo, n, a, lda, d, e, tau, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, n
  real*8 :: a( lda, * ), d( * ), e( * ), tau( * )
  call lb_dsytd2( uplo, n, a, lda, d, e, tau, info )
end subroutine dsytd2

subroutine dsytrd( uplo, n, a, lda, d, e, tau, work, lwork, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, lwork, n
  real*8 :: a( lda, * ), d( * ), e( * ), tau( * ), work( * )
  call lb_dsytrd( uplo, n, a, lda, d, e, tau, work, lwork, info )
end subroutine dsytrd

subroutine dtrevc3( side, howmny, select, n, t, ldt, vl, ldvl, vr, ldvr, mm, m, work, lwork, info )
  use link_blas
  implicit none
  character :: howmny, side
  integer :: info, ldt, ldvl, ldvr, lwork, m, mm, n
  logical :: select( * )
  real*8 :: t( ldt, * ), vl( ldvl, * ), vr( ldvr, * ), work( * )
  call lb_dtrevc3( side, howmny, select, n, t, ldt, vl, ldvl, vr, ldvr, mm, m, work, lwork, info )
end subroutine dtrevc3

subroutine dtrexc( compq, n, t, ldt, q, ldq, ifst, ilst, work, info )
  use link_blas
  implicit none
  character :: compq
  integer :: ifst, ilst, info, ldq, ldt, n
  real*8 :: q( ldq, * ), t( ldt, * ), work( * )
  call lb_dtrexc( compq, n, t, ldt, q, ldq, ifst, ilst, work, info )
end subroutine dtrexc

subroutine dtrti2( uplo, diag, n, a, lda, info )
  use link_blas
  implicit none
  character :: diag, uplo
  integer :: info, lda, n
  real*8 :: a( lda, * )
  call lb_dtrti2( uplo, diag, n, a, lda, info )
end subroutine dtrti2

subroutine dtrtri( uplo, diag, n, a, lda, info )
  use link_blas
  implicit none
  character :: diag, uplo
  integer :: info, lda, n
  real*8 :: a( lda, * )
  call lb_dtrtri( uplo, diag, n, a, lda, info )
end subroutine dtrtri

subroutine dtrtrs( uplo, trans, diag, n, nrhs, a, lda, b, ldb, info )
  use link_blas
  implicit none
  character :: diag, trans, uplo
  integer :: info, lda, ldb, n, nrhs
  real*8 :: a( lda, * ), b( ldb, * )
  call lb_dtrtrs( uplo, trans, diag, n, nrhs, a, lda, b, ldb, info )
end subroutine dtrtrs

function ieeeck( ispec, zero, one )
  use link_blas
  implicit none
  integer :: ispec
  real :: one, zero
  integer :: ieeeck
  ieeeck=lb_ieeeck( ispec, zero, one )
end function ieeeck

function iladlc( m, n, a, lda )
  use link_blas
  implicit none
  integer :: m, n, lda
  real*8 :: a( lda, * )
  integer :: iladlc
  iladlc=lb_iladlc( m, n, a, lda )
end function iladlc

function iladlr( m, n, a, lda )
  use link_blas
  implicit none
  integer :: m, n, lda
  real*8 :: a( lda, * )
  integer :: iladlr
  iladlr=lb_iladlr( m, n, a, lda )
end function iladlr

function ilaenv( ispec, name, opts, n1, n2, n3, n4 )
  use link_blas
  implicit none
  character*( * )    name, opts
  integer :: ispec, n1, n2, n3, n4
  integer :: ilaenv
  ilaenv=lb_ilaenv( ispec, name, opts, n1, n2, n3, n4 )
end function ilaenv

function ilazlc( m, n, a, lda )
  use link_blas
  implicit none
  integer :: m, n, lda
  complex*16 :: a( lda, * )
  integer :: ilazlc
  ilazlc=lb_ilazlc( m, n, a, lda )
end function ilazlc

function ilazlr( m, n, a, lda )
  use link_blas
  implicit none
  integer :: m, n, lda
  complex*16 :: a( lda, * )
  integer :: ilazlr
  ilazlr=lb_ilazlr( m, n, a, lda )
end function ilazlr

function iparam2stage( ispec, name, opts, ni, nbi, ibi, nxi )
  use link_blas
  implicit none
  character*( * ) :: name, opts
  integer :: ispec, ni, nbi, ibi, nxi
  integer :: iparam2stage
  iparam2stage=lb_iparam2stage( ispec, name, opts, ni, nbi, ibi, nxi )
end function iparam2stage

function iparmq( ispec, name, opts, n, ilo, ihi, lwork )
  use link_blas
  implicit none
  integer :: ihi, ilo, ispec, lwork, n
  character :: name*( * ), opts*( * )
  integer :: iparmq
  iparmq=lb_iparmq( ispec, name, opts, n, ilo, ihi, lwork )
end function iparmq

subroutine zheev( jobz, uplo, n, a, lda, w, work, lwork, rwork, info )
  use link_blas
  implicit none
  character :: jobz, uplo
  integer :: info, lda, lwork, n
  real*8 :: rwork( * ), w( * )
  complex*16 :: a( lda, * ), work( * )
  call lb_zheev( jobz, uplo, n, a, lda, w, work, lwork, rwork, info )
end subroutine zheev

subroutine zhetd2( uplo, n, a, lda, d, e, tau, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, n
  real*8 :: d( * ), e( * )
  complex*16 :: a( lda, * ), tau( * )
  call lb_zhetd2( uplo, n, a, lda, d, e, tau, info )
end subroutine zhetd2

subroutine zhetrd( uplo, n, a, lda, d, e, tau, work, lwork, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, lwork, n
  real*8 :: d( * ), e( * )
  complex*16 :: a( lda, * ), tau( * ), work( * )
  call lb_zhetrd( uplo, n, a, lda, d, e, tau, work, lwork, info )
end subroutine zhetrd

subroutine zhpev( jobz, uplo, n, ap, w, z, ldz, work, rwork, info )
  use link_blas
  implicit none
  character :: jobz, uplo
  integer :: info, ldz, n
  real*8 :: rwork( * ), w( * )
  complex*16 :: ap( * ), work( * ), z( ldz, * )
  call lb_zhpev( jobz, uplo, n, ap, w, z, ldz, work, rwork, info )
end subroutine zhpev

subroutine zhptrd( uplo, n, ap, d, e, tau, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, n
  real*8 :: d( * ), e( * )
  complex*16 :: ap( * ), tau( * )
  call lb_zhptrd( uplo, n, ap, d, e, tau, info )
end subroutine zhptrd

subroutine zlacgv( n, x, incx )
  use link_blas
  implicit none
  integer :: incx, n
  complex*16 :: x( * )
  call lb_zlacgv( n, x, incx )
end subroutine zlacgv

function zladiv( x, y )
  use link_blas
  implicit none
  complex*16 :: x, y
  complex*16 :: zladiv
  zladiv=lb_zladiv( x, y )
end function zladiv

function zlanhe( norm, uplo, n, a, lda, work )
  use link_blas
  implicit none
  character :: norm, uplo
  integer :: lda, n
  real*8 :: work( * )
  complex*16 :: a( lda, * )
  real*8 :: zlanhe
  zlanhe=lb_zlanhe( norm, uplo, n, a, lda, work )
end function zlanhe

function zlanhp( norm, uplo, n, ap, work )
  use link_blas
  implicit none
  character :: norm, uplo
  integer :: n
  real*8 :: work( * )
  complex*16 :: ap( * )
  real*8 :: zlanhp
  zlanhp=lb_zlanhp( norm, uplo, n, ap, work )
end function zlanhp

subroutine zlarf( side, m, n, v, incv, tau, c, ldc, work )
  use link_blas
  implicit none
  character :: side
  integer :: incv, ldc, m, n
  complex*16 :: tau
  complex*16 :: c( ldc, * ), v( * ), work( * )
  call lb_zlarf( side, m, n, v, incv, tau, c, ldc, work )
end subroutine zlarf

subroutine zlarfb( side, trans, direct, storev, m, n, k, v, ldv, t, ldt, c, ldc, work, ldwork )
  use link_blas
  implicit none
  character :: direct, side, storev, trans
  integer :: k, ldc, ldt, ldv, ldwork, m, n
  complex*16 :: c( ldc, * ), t( ldt, * ), v( ldv, * ), work( ldwork, * )
  call lb_zlarfb( side, trans, direct, storev, m, n, k, v, ldv, t, ldt, c, ldc, work, ldwork )
end subroutine zlarfb

subroutine zlarfg( n, alpha, x, incx, tau )
  use link_blas
  implicit none
  integer :: incx, n
  complex*16 :: alpha, tau
  complex*16 :: x( * )
  call lb_zlarfg( n, alpha, x, incx, tau )
end subroutine zlarfg

subroutine zlarft( direct, storev, n, k, v, ldv, tau, t, ldt )
  use link_blas
  implicit none
  character :: direct, storev
  integer :: k, ldt, ldv, n
  complex*16 :: t( ldt, * ), tau( * ), v( ldv, * )
  call lb_zlarft( direct, storev, n, k, v, ldv, tau, t, ldt )
end subroutine zlarft

subroutine zlascl( type, kl, ku, cfrom, cto, m, n, a, lda, info )
  use link_blas
  implicit none
  character :: type
  integer :: info, kl, ku, lda, m, n
  real*8 :: cfrom, cto
  complex*16 :: a( lda, * )
  call lb_zlascl( type, kl, ku, cfrom, cto, m, n, a, lda, info )
end subroutine zlascl

subroutine zlaset( uplo, m, n, alpha, beta, a, lda )
  use link_blas
  implicit none
  character :: uplo
  integer :: lda, m, n
  complex*16 :: alpha, beta
  complex*16 :: a( lda, * )
  call lb_zlaset( uplo, m, n, alpha, beta, a, lda )
end subroutine zlaset

subroutine zlasr( side, pivot, direct, m, n, c, s, a, lda )
  use link_blas
  implicit none
  character :: direct, pivot, side
  integer :: lda, m, n
  real*8 :: c( * ), s( * )
  complex*16 :: a( lda, * )
  call lb_zlasr( side, pivot, direct, m, n, c, s, a, lda )
end subroutine zlasr

subroutine zlassq( n, x, incx, scale, sumsq )
  use link_blas
  implicit none
  integer :: incx, n
  real*8 :: scale, sumsq
  complex*16 :: x( * )
  call lb_zlassq( n, x, incx, scale, sumsq )
end subroutine zlassq

subroutine zlatrd( uplo, n, nb, a, lda, e, tau, w, ldw )
  use link_blas
  implicit none
  character :: uplo
  integer :: lda, ldw, n, nb
  real*8 :: e( * )
  complex*16 :: a( lda, * ), tau( * ), w( ldw, * )
  call lb_zlatrd( uplo, n, nb, a, lda, e, tau, w, ldw )
end subroutine zlatrd

subroutine zsteqr( compz, n, d, e, z, ldz, work, info )
  use link_blas
  implicit none
  character :: compz
  integer :: info, ldz, n
  real*8 :: d( * ), e( * ), work( * )
  complex*16 :: z( ldz, * )
  call lb_zsteqr( compz, n, d, e, z, ldz, work, info )
end subroutine zsteqr

subroutine zung2l( m, n, k, a, lda, tau, work, info )
  use link_blas
  implicit none
  integer :: info, k, lda, m, n
  complex*16 :: a( lda, * ), tau( * ), work( * )
  call lb_zung2l( m, n, k, a, lda, tau, work, info )
end subroutine zung2l

subroutine zung2r( m, n, k, a, lda, tau, work, info )
  use link_blas
  implicit none
  integer :: info, k, lda, m, n
  complex*16 :: a( lda, * ), tau( * ), work( * )
  call lb_zung2r( m, n, k, a, lda, tau, work, info )
end subroutine zung2r

subroutine zungql( m, n, k, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  integer :: info, k, lda, lwork, m, n
  complex*16 :: a( lda, * ), tau( * ), work( * )
  call lb_zungql( m, n, k, a, lda, tau, work, lwork, info )
end subroutine zungql

subroutine zungqr( m, n, k, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  integer :: info, k, lda, lwork, m, n
  complex*16 :: a( lda, * ), tau( * ), work( * )
  call lb_zungqr( m, n, k, a, lda, tau, work, lwork, info )
end subroutine zungqr

subroutine zungtr( uplo, n, a, lda, tau, work, lwork, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, lwork, n
  complex*16 :: a( lda, * ), tau( * ), work( * )
  call lb_zungtr( uplo, n, a, lda, tau, work, lwork, info )
end subroutine zungtr

subroutine zupgtr( uplo, n, ap, tau, q, ldq, work, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, ldq, n
  complex*16 :: ap( * ), q( ldq, * ), tau( * ), work( * )
  call lb_zupgtr( uplo, n, ap, tau, q, ldq, work, info )
end subroutine zupgtr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1983, Per Ake Malmqvist                                *
!               1994,1995, Niclas Forsberg                             *
!***********************************************************************

!module LinAlg

!  Contains:
!    Cholesky    : Performs a Cholesky factorization of a positive definite matrix A.
!    Dool_MULA   : Solves the system of linear equations A*X = B.
!    SolveSecEq  : Solves the seqular equation A*C = S*C*D.
!    Polfit      : Fit a polynomial of requested dimension to the input data.
!    factor      : Calculate coefficient for n'th derivative.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

!contains

subroutine Dool_MULA(A,LA1,LA2,B,LB1,LB2,det)
!  Purpose:
!    Solve A*X = B
!
!  Input:
!    A      : Real two dimensional array
!    B      : Real two dimensional array
!
!  Output:
!    B      : Real two dimensional array - contains the solution X.
!
!  Written by:
!    Per-AAke Malmquist
!    Dept. of Theoretical Chemistry, Lund University, 1983.
!
!  Modified by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LA1, LA2, LB1, LB2
real(kind=wp), intent(inout) :: A(LA1,LA2), B(LB1,LB2)
real(kind=wp), intent(out) :: det
integer(kind=iwp) :: i, ip, iTemp, j, jp, jTemp, k, kp, l, lp, m, n
real(kind=wp) :: Am, Amax, c, diag, rsum
integer(kind=iwp), allocatable :: iPiv(:), jPiv(:)
real(kind=wp), allocatable :: Buf(:)

! Initialize.
ip = -9999999
jp = -9999999
n = LA2
m = LB2
call mma_allocate(Buf,n,label='Buf')
call mma_allocate(iPiv,n,label='iPiv')
call mma_allocate(jPiv,n,label='jPiv')

do i=1,n
  iPiv(i) = i
  jPiv(i) = i
end do
det = One
do i=1,n
  ! Now find better pivot element.
  Amax = -One
  do k=i,n
    do l=i,n
      Am = abs(A(iPiv(k),jPiv(l)))
      if (Amax <= Am) then
        Amax = Am
        ip = k
        jp = l
      end if
    end do
  end do
  if (ip /= i) then
    det = -det
    iTemp = iPiv(i)
    iPiv(i) = iPiv(ip)
    iPiv(ip) = iTemp
  end if
  if (jp /= i) then
    det = -det
    jTemp = jPiv(i)
    jPiv(i) = jPiv(jp)
    jPiv(jp) = jTemp
  end if
  ip = iPiv(i)
  jp = jPiv(i)
  diag = A(ip,jp)
  !Buf(i) = diag
  Buf(i) = diag
  det = det*diag
  do k=i+1,n
    kp = iPiv(k)
    c = A(kp,jp)/diag
    A(kp,jp) = c
    do l=i+1,n
      lp = jPiv(l)
      A(kp,lp) = A(kp,lp)-c*A(ip,lp)
    end do
  end do
end do

! First resubstitution step.
do j=1,m
  do i=2,n
    ip = iPiv(i)
    rsum = B(ip,j)
    do k=1,i-1
      rsum = rsum-A(ip,jPiv(k))*B(iPiv(k),j)
    end do
    B(ip,j) = rsum
  end do
end do

! Second resubstitution step.
do j=1,m
  do i=n,1,-1
    ip = iPiv(i)
    rsum = B(ip,j)
    do k=i+1,n
      rsum = rsum-A(ip,jPiv(k))*B(iPiv(k),j)
    end do
    B(ip,j) = rsum/Buf(i)
  end do
end do

! Reorganization part.
do j=1,m
  do i=1,n
    Buf(i) = B(iPiv(i),j)
  end do
  do i=1,n
    B(jPiv(i),j) = Buf(i)
  end do
end do

call mma_deallocate(Buf)
call mma_deallocate(iPiv)
call mma_deallocate(jPiv)

end subroutine Dool_MULA

subroutine SolveSecEq(A,n,C,S,D)
!  Purpose:
!    Solve the secular equation SAC = CD.
!
!  Input:
!    A        : Real two dimensional array
!    S        : Real two dimensional array
!
!  Output:
!    C        : Real two dimensional array
!    D        : Real array
!
!  Calls:
!    Jacob
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1994.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: A(n,n), S(n,n)
real(kind=wp), intent(out) :: C(n,n), D(n)
integer(kind=iwp) :: i, ii, j, jj, k
real(kind=wp), allocatable :: Asymm(:,:), Scr(:), T(:,:), Temp(:,:)

! Initialize.
!D write(u6,*) 'SolveSecEq test prints.'
!D write(u6,*) 'Matrix A:'
!D do i=1,n
!D   write(u6,'(1x,5F16.8)') (A(i,j),j=1,n)
!D end do

! get memory for temporary matrices.
call mma_allocate(Scr,n*(n+1)/2,label='Scr')
call mma_allocate(T,n,n,label='T')
call mma_allocate(Temp,n,n,label='Temp')
call mma_allocate(Asymm,n,n,label='Asymm')

! Transform S to lower packed storage in Scratch.
k = 1
do i=1,n
  do j=1,i
    Scr(k) = S(i,j)
    k = k+1
  end do
end do

! Turn T into a unit matrix.
T(:,:) = Zero
do i=1,n
  T(i,i) = One
end do

! Diagonalize Scratch and scale each column of T with the square
! root of the corresponding eigenvalue.
call Jacob(Scr,T,n,n)
do j=1,n
  jj = j*(j+1)/2
  T(:,j) = T(:,j)*sqrt(Scr(jj))
end do

! Make A symmetric and transform it to lower packed storage in
! Scratch.
call DGEMM_('N','N',n,n,n,One,A,n,T,n,Zero,Temp,n)
call DGEMM_('T','N',n,n,n,One,T,n,Temp,n,Zero,Asymm,n)
k = 1
do i=1,n
  do j=1,i
    Scr(k) = Asymm(i,j)
    k = k+1
  end do
end do

! Diagonalize Scratch.
call Jacob(Scr,T,n,n)
call JacOrd(Scr,T,n,n)

! Store the eigenvalues in array D.
do i=1,n
  ii = i*(i+1)/2
  D(i) = Scr(ii)
end do
C(:,:) = T

! Free memory of temporary matrices.
call mma_deallocate(Scr)
call mma_deallocate(T)
call mma_deallocate(Temp)
call mma_deallocate(Asymm)

end subroutine SolveSecEq

subroutine PolFit(ipow,nvar,var,yin,ndata,coef,nterm,stand_dev,max_err,diff_vec,use_weight)
!  Purpose:
!    Fit a polynomial to yin.
!
!  Written by:
!    P-AA Malmquist
!
!  Modified by:
!    Niclas Forsberg

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nvar, nterm, ipow(nvar,nterm), ndata
real(kind=wp), intent(in) :: var(ndata,nvar), yin(ndata)
real(kind=wp), intent(out) :: coef(nterm,1), stand_dev, max_err, diff_vec(ndata)
logical(kind=iwp), intent(in) :: use_weight
integer(kind=iwp) :: i, idata, ip, iterm, ivar, jterm, myCoef2, nPolyTerm, NrOfVar
real(kind=wp) :: det, diff, e_max, e_min, e_range, pol, pow, rsum, t
real(kind=wp), allocatable :: equmat(:,:), rhs(:), term(:), vpow(:,:), weight(:), yfit(:)
integer(kind=iwp), parameter :: mxdeg = 6

! Initialize.
NrOfVar = nvar
nPolyTerm = nterm
myCoef2 = 1
call mma_allocate(rhs,nterm,label='rhs')
call mma_allocate(equmat,nterm,nterm,label='equmat')
rhs(:) = Zero
equmat(:,:) = Zero

! Set up weight vector.
call mma_allocate(weight,ndata,label='weight')
if (use_weight) then
  e_min = yin(1)
  e_max = yin(1)
  do idata=2,ndata
    if (yin(idata) < e_min) e_min = yin(idata)
    if (yin(idata) > e_max) e_max = yin(idata)
  end do
  e_range = e_max-e_min
  do idata=1,ndata
    weight(idata) = One/(One+1.0e3_wp*((yin(idata)-e_min)/e_range))
  end do
else
  !vv weight(:) = One
  weight(:) = 0.1_wp
end if

! Accumulate equation matrix and right-hand-side.
call mma_allocate(vpow,[0,mxdeg],[1,nvar],label='vpow')
call mma_allocate(term,nterm,label='term')
do idata=1,ndata
  ! Calculate powers of individual variable values.
  do ivar=1,NrOfVar
    pow = One
    vpow(0,ivar) = One
    do i=1,mxdeg
      pow = pow*var(idata,ivar)
      vpow(i,ivar) = pow
    end do
  end do
  ! Calculate value of each polynomial term at this point.
  do iterm=1,nPolyTerm
    ip = ipow(iterm,1)
    t = vpow(ip,1)
    do ivar=2,NrOfVar
      ip = ipow(iterm,ivar)
      t = t*vpow(ip,ivar)
    end do
    term(iterm) = t
  end do
  ! Accumulate equmat and rhs.
  do iterm=1,nPolyTerm
    rhs(iterm) = rhs(iterm)+yin(idata)*term(iterm)*weight(idata)
    do jterm=1,iterm
      equmat(iterm,jterm) = equmat(iterm,jterm)+term(iterm)*term(jterm)*weight(idata)
    end do
  end do
end do
call mma_deallocate(term)

! Set upper triangle of equmat by symmetry.
do iterm=1,nPolyTerm-1
  do jterm=iterm+1,nPolyTerm
    equmat(iterm,jterm) = equmat(jterm,iterm)
  end do
end do

! Solve the resulting equation system.
do i=1,nterm
  coef(i,1) = rhs(i)
end do
call Dool_MULA(equmat,nPolyTerm,nPolyTerm,coef,nPolyTerm,MyCoef2,det)
if (abs(det) == Zero) write(u6,*) 'WARNING!! Determinant=0 in PolFit'
call mma_deallocate(rhs)
call mma_deallocate(equmat)

! Calculate fitted result.
call mma_allocate(yfit,ndata,label='yfit')
do idata=1,ndata
  ! Calculate powers of individual variable values.
  do ivar=1,NrOfVar
    pow = One
    vpow(0,ivar) = One
    do i=1,mxdeg
      pow = pow*var(idata,ivar)
      vpow(i,ivar) = pow
    end do
  end do
  ! Calculate value of each polynomial term. Add to yfit.
  pol = Zero
  do iterm=1,nPolyTerm
    ip = ipow(iterm,1)
    t = vpow(ip,1)
    do ivar=2,NrOfVar
      ip = ipow(iterm,ivar)
      t = t*vpow(ip,ivar)
    end do
    pol = pol+coef(iterm,1)*t
  end do
  yfit(idata) = pol
end do
call mma_deallocate(vpow)

! Calculate standard deviation and maximum error.
rsum = Zero
do idata=1,ndata
  diff = abs(yin(idata)-yfit(idata))
  diff_vec(idata) = diff
  if (idata == 1) then
    max_err = diff
  else
    if (diff > max_err) max_err = diff
  end if
  rsum = rsum+diff**2
end do
stand_dev = sqrt(rsum/ndata)

call mma_deallocate(yfit)
call mma_deallocate(weight)

end subroutine PolFit

subroutine factor(expnt,nder,rfactor)
!  Purpose:
!    Calculate coefficient for n'th derivative.

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: expnt, nder
real(kind=wp), intent(out) :: rfactor
integer(kind=iwp) :: i, isum, ntot

isum = 1
ntot = nder+expnt
if (nder > 0) then
  do i=ntot,ntot-nder+1,-1
    isum = isum*i
  end do
else if (nder < 0) then
  isum = 0
end if
rfactor = real(isum,kind=wp)

end subroutine factor

subroutine Cholesky(A,L,nd)
!  Purpose:
!    Perform a Cholesky factorization of the matrix A:
!
!                       A = L~ * L
!
!    where L is a lower triangular matrix and L~ is L transposed.
!
!  Input:
!    A      : Real two dimensional array - positive definite matrix.
!
!  Output:
!    L      : Real two dimensional array - lower triangular matrix.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nd
real(kind=wp), intent(in) :: A(nd,nd)
real(kind=wp), intent(out) :: L(nd,nd)
integer(kind=iwp) :: iRow, j, jRow, n
real(kind=wp) :: dd
real(kind=wp), allocatable :: D(:)

! Initialize.
n = nd
call mma_allocate(D,n,label='D')
L(:,:) = A

! Take care of the n-1 last rows.
if (n > 1) then
  do iRow=n,2,-1
    D(iRow) = L(iRow,iRow)
    L(iRow,:) = L(iRow,:)/D(iRow)
    do jRow=iRow-1,1,-1
      do j=1,n
        L(jRow,j) = L(jRow,j)-L(jRow,iRow)*L(iRow,j)
      end do
    end do
  end do
end if

! Take care of the first row.
D(1) = L(1,1)
L(1,1) = One

! Multiply Llow with the square root of d.
do iRow=1,n
  if (D(iRow) < Zero) then
    write(u6,*) 'Error in Cholesky!!! Matrix not positive definite.'
    call Abend()
  end if
  dd = sqrt(D(iRow))
  L(iRow,:) = L(iRow,:)*dd
end do
call mma_deallocate(D)

end subroutine Cholesky

!end module LinAlg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Bernd Artur Hess                                 *
************************************************************************
C $Id: relsewb.r,v 1.4 1995/05/08 14:08:53 hess Exp $
C calculate relativistic operators
C   Bernd Artur Hess, hess@uni-bonn.de
C
C
      SUBROUTINE SCFCLI2(idbg,epsilon,S,H,V,PVP,N,ISIZE,VELIT,
     *BU,P,G,EV2,EIG,SINV,REVT,AUX,OVE,EW,E,AA,RR,TT)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION S(ISIZE),H(ISIZE),V(ISIZE),PVP(ISIZE)
      DIMENSION BU(ISIZE),P(ISIZE),G(ISIZE),EV2(ISIZE),
     *EIG(N,N),SINV(N,N),REVT(N,N),AUX(N,N),OVE(N,N),
     *EW(N),E(N),AA(N),RR(N),TT(N)
C
*
*
      TOL=1.D-14
      PREA=1/(VELIT*VELIT)
      CON2=PREA+PREA
      CON=1.D0/PREA
      DO 90 I=1,ISIZE
      BU(I)=S(I)
90    CONTINUE
      ii=0
      DO i=1,n
      DO j=1,i
      ii=ii+1
      aux(I,J)=s(ii)
      aux(J,I)=s(ii)
      ENDDO
      ENDDO
*      write(*,*) 'OVERLAP MATRIX'
*      do i=1,n
*         write(6,'(5f10.5)') (aux(i,j),j=1,n)
*      enddo
C
C     CALCULATE DETERMINANT
C
      icontr=-1
      dtol=tol
      CALL dcopiv(aux,aux,n,1,n,dtol,det,iex,icontr,p)
*     if(idbg.gt.0)WRITE (idbg,2016) icontr,det,iex
*2016  FORMAT(' relsewb| DCOPIV rc=',I2,', |S|=',D20.6,'x 10**(',I4,') ')
      IF (icontr.NE.0) THEN
*     WRITE (6,2016) icontr,det,iex
*      WRITE (6,2012) dtol
*2012   FORMAT('  relsewb|****** '/,
*     * '        |****** WARNING - OVERLAP MATRIX SINGULAR '/,
*     * '        |****** PIVOTAL ELEMENT LESS THAN ',D20.4,' FOUND'/,
*     * '        |******'//)
      CALL errex_rel(' relsewb| singular overlap matrix')
      ENDIF
C
C     SCHMIDT-ORTHOGONALIZE
C
*
      CALL Sogr(iDbg,N,BU,SINV,P,OVE,EW)
*
      CALL Square(BU,OVE,N,1,N)
C      CALL FilMar(N,BU,OVE)

C
C ** SINV CONTAINS TRANSFORMATION TO ORTHOGONAL AO-BASIS
C ** OVE  CONTAINS OVERLAP MATRIX IN FULL
C--------------------------------------------------------------------
C     NON-RELATIVISTIC KINETIC ENERGY
C--------------------------------------------------------------------
*
      CALL Diagr(H,N,EIG,EW,SINV,AUX,BU)
*
*     if(idbg.gt.0)WRITE (idbg,556)
* 556 FORMAT(//,7X,'- NREL. ENERG.  -  DIVIDED BY C ',
*    *             '- REL.  ENERG.  -  MOMENTUM    -',
*    *             ' TERMS OF POWER SERIES (LOW ENERGY ONLY)'//)
      DO 4 I=1,N
      IF (ew(i).LT.0.D0) THEN
*      WRITE (*,*) ' scfcli2| ew(',i,') = ',ew(i)
       CALL errex_rel('kinetic energy eigenvalue less than zero')
      ENDIF
C
C     IF T SUFFICIENTLY SMALL, USE SERIES EXPANSION TO AVOID CANCELLATIO
C
      RATIO=EW(I)/VELIT
C
C     CALCULATE RELATIVISTIC ENERGY AND MOMENTUM
C
      SR=sqrt(2.D0*EW(I))
      TT(I)=EW(I)
      IF (RATIO.GT.0.02D0) GOTO 11
      TV1=EW(I)
      TV2=-TV1*EW(I)*PREA/2.D0
      TV3=-TV2*EW(I)*PREA
      TV4=-TV3*EW(I)*PREA*1.25D0
      EW(I)=TV1+TV2+TV3+TV4
*     if(idbg.gt.0)WRITE (idbg,100) I,TV1,RATIO,EW(I),SR,TV2,TV3,TV4
* 100 FORMAT(1X,I4,7(2X,D14.8))
      GOTO 12
  11  TV1=EW(I)
      EW(I)=CON*(sqrt(1.D0+CON2*EW(I))-1.D0)
*     if(idbg.gt.0)WRITE (idbg,100) I,TV1,RATIO,EW(I),SR
  12  CONTINUE
      E(I)=EW(I)+CON
4     CONTINUE
C---------------------------------------------------------------------
C     CALCULATE REVERSE TRANSFORMATION
C---------------------------------------------------------------------
      DO 3 I=1,N
      DO 30 J=1,N
      AUX(I,J)=0.D0
      DO 31 K=I,N
      AUX(I,J)=AUX(I,J)+SINV(I,K)*EIG(K,J)
   31 CONTINUE
   30 CONTINUE
    3 CONTINUE
      DO 6 I=1,N
      DO 60 J=1,N
      REVT(I,J)=0.D0
      DO 5 K=1,N
      REVT(I,J)=REVT(I,J)+OVE(I,K)*AUX(K,J)
    5 CONTINUE
   60 CONTINUE
    6 CONTINUE
      IJ=0
      DO 8 I=1,N
      DO 80 J=1,I
      IJ=IJ+1
      H(IJ)=0.D0
      DO 7 K=1,N
      H(IJ)=H(IJ)+REVT(I,K)*REVT(J,K)*EW(K)
    7 CONTINUE
   80 CONTINUE
    8 CONTINUE
C
C     CALCULATE KINEMATICAL FACTORS
C
      DO 362 I=1,N
      AA(I)=sqrt((CON+E(I)) / (2.D0*E(I)))
      RR(I)=sqrt(CON)/(CON+E(I))
362   CONTINUE
C
C     POTENTIAL
C
C
C     BEYOND THIS POINT, OVE IS USED AS SCRATCH ARRAY
C
C
C    TRANSFORM V TO T-BASIS
C
      CALL TrSmr(V,SINV,G,N,AUX,OVE)
*
      CALL TrSmr(G,EIG,BU,N,AUX,OVE)

culf
      if(idbg.gt.0)CALL PRMAT(IDBG,V,N,0,'v oper  ')
C
C    MULTIPLY
C
      IJ=0
      DO 2005 I=1,N
      DO 2006 J=1,I
      IJ=IJ+1
      P(IJ)=BU(IJ)
      BU(IJ)=BU(IJ)*AA(I)*AA(J)
2006  CONTINUE
2005  CONTINUE
*
      CALL TrSmtr(BU,REVT,G,0.0D0,N,AUX,OVE)
*
culf
      if(idbg.gt.0)CALL PRMAT(IDBG,g,N,0,'g oper  ')
*
      CALL AddMar(ISIZE,G,H)
C
C     PVP INTEGRALS AND TRANSFORM THEM TO T-BASIS
C
      if(idbg.gt.0)CALL PRMAT(IDBG,pvp,N,0,'raw pvp integrals  ')
      CALL TrSmr(PVP,SINV,G,N,AUX,OVE)
*
      CALL TrSmr(G,EIG,BU,N,AUX,OVE)
C
C    MULTIPLY
C
      IJ=0
      DO 3005 I=1,N
      DO 3006 J=1,I
      IJ=IJ+1
      G(IJ)=BU(IJ)
      BU(IJ)=BU(IJ)*AA(I)*RR(I)*AA(J)*RR(J)
3006  CONTINUE
3005  CONTINUE
*
      CALL TrSmtr(BU,REVT,EV2,0.0D0,N,AUX,OVE)
culf
      if(idbg.gt.0)CALL PRMAT(IDBG,ev2,n,0,'pvp oper')
*
      CALL AddMar(ISIZE,EV2,H)
C
C     CALCULATE Even2r OPERATOR
C
*     if(idbg.gt.0)CALL Even2r(idbg,N,P,G,E,AA,RR,TT,EIG,AUX,OVE)
*
C
C    TRANSFORM BACK
C
culf
      if(idbg.gt.0)CALL PRMAT(IDBG,g,n,0,'ev2 orig')
*     CALL TrSmtr(G,REVT,EV2,0.0D0,N,AUX,OVE)
culf
*     if(idbg.gt.0)CALL PRMAT(IDBG,ev2,n,0,'ev2 oper')
*     CALL AddMar(ISIZE,EV2,H)
culf
      if(idbg.gt.0)CALL PRMAT(IDBG,h,n,0,'h   oper')
*     CALL Sogr(iDbg,N,S,SINV,P,OVE,EW)
*     CALL Diagr(H,N,EIG,EW,SINV,AUX,0)
*     write(*,*) 'END OF SCFCLI2 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
C
*     if(idbg.gt.0)WRITE (idbg,*) '--- EIGENVALUES OF H MATRIX ---'
*     if(idbg.gt.0)WRITE (idbg,'(4D20.12)') EW
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_real(epsilon)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************

module ChoMP2

use Data_Structures, only: V2
use Definitions, only: wp, iwp

! Stuff for Cholesky MP2 program (chomp2):
!
! iAOVir, iBatOrb, iDel, iFro, iMatab, iOcc, iT1am, iT1AOT, iVir, lUnit_F, nAOVir, nBatch, nBatOrbT, nDel, nDelT, nFro, nFroT,
! nMatab, nMP2Vec, nOcc, nOccT, nOrb, nPQ_Prod, nT1am, nT1AOT, nTypF, nVir, nVirT, RootNm

! Cholesky MP2 configuration stuff (chomp2_cfg):
!
! all_Vir, C_os, ChkDecoMP2, ChoAlg, Decom_Def, DecoMP2, DoDens, DoFNO, DoGrdt, DoMP2, DoT1amp, EMP2_dens, EOSMP2, FNOMP2,
! ForceBatch, iOffT1, l_Dii, Laplace, Laplace_BlockSize, Laplace_BlockSize_Def, Laplace_nGridPoints, LovMP2, MxQual_Def, MxQualMP2,
! nActa, NoGamma, OED_Thr, set_cd_thr, SOS_mp2, Span_Def, SpanMP2, ThrLov, ThrMP2, Verbose, vkept, Wref, XEMP2
! Laplace_mGridPoints: mx implemented in minimax opt

! for Cholesky Mp2-gradients (chomp2g):
!
! iAdrOff, iAoMo, iMoAo, iMoMo, kFLagr, kLagr, kPab, kPai, kPaK, kPij, kPiK, kWab, kWai, kWaK, kWij, kWiK, kWJK, lFLagr, lLagr,
! lPab, lPai, lPaK, lPij, lPiK, LuRInv, LuUVec, LuVVec, LuWVec, lWab, lWai, lWaK, lWij, lWiK, lWJK, nAdrOff, nAoMo, nMo, nMoAo,
! nMoMo, nMoType, nOccVirT

! Stuff for decomposing (ai|bj) integrals or amplitudes in MP2 (chomp2_dec):
!
! EOcc, EVir, InCore, iOption_MP2CD, NowSym

implicit none
private

integer(kind=iwp), parameter :: nTypF = 2
integer(kind=iwp) :: ChoAlg, iAdrOff(8,9), iAoMo(8,8,9), iAOVir(8,8), iBatOrb(8), iDel(8), iFro(8), iMatab(8,8), iMoAo(8,8,9), &
                     iMoMo(8,8,9), iOcc(8), iOffT1(8), iOption_MP2CD, iT1am(8,8), iT1AOT(8,8), iVir(8), kFLagr(8), kLagr(8), &
                     kPab(8), kPai(8), kPaK(8), kPij(8), kPiK(8), kWab(8), kWai(8), kWaK(8), kWij(8), kWiK(8), kWJK(8), l_Dii, &
                     Laplace_BlockSize, Laplace_nGridPoints, lFLagr, lLagr, lPab, lPai, lPaK, lPij, lPiK, lUnit_F(8,nTypF), &
                     LuRInv(8), LuUVec, LuVVec, LuWVec, lWab, lWai, lWaK, lWij, lWiK, lWJK, MxQualMP2, nActa, nAdrOff(8), &
                     nAoMo(8,9), nAOVir(8), nBatch, nBatOrbT, nDel(8), nDelT, nFro(8), nFroT, nMatab(8), nMo(8,9), nMoAo(8,9), &
                     nMoMo(8,9), nMoType, nMP2Vec(8), nOcc(8), nOccT, nOccVirT, nOrb(8), NowSym, nPQ_prod(8), nT1am(8), nT1AOT(8), &
                     nVir(8), nVirT
real(kind=wp) :: C_os, DeMP2, EMP2_dens, EOSMP2, OED_Thr, shf, SpanMP2, ThrLov, ThrMP2, vkept, Wref, XEMP2
logical(kind=iwp) :: all_Vir, ChkDecoMP2, ChoMP2_allocated = .false., ChoMP2g_allocated = .false., DecoMP2, DoDens, DoFNO, DoGrdt, &
                     DoMP2, DoT1amp, FNOMP2, ForceBatch, InCore(8), Laplace, LovMP2, MP2_small, NoGamma, set_cd_thr, SOS_mp2, &
                     Verbose
type(V2) :: MP2D(8), MP2D_e(8), MP2W(8), MP2W_e(8)
integer(kind=iwp), allocatable :: AdrR1(:,:,:), AdrR2(:,:,:), iFirst(:), iFirstS(:,:), LiMatij(:,:,:), LiPQprod(:,:,:), &
                                  LiT1am(:,:,:), LnBatOrb(:,:), LnMatij(:,:), LnOcc(:,:), LnPQprod(:,:), LnT1am(:,:), lUnit(:,:), &
                                  NumBatOrb(:), NumOcc(:)
real(kind=wp), allocatable, target :: MP2D_e_full(:), MP2D_full(:), MP2W_e_full(:), MP2W_full(:)
real(kind=wp), allocatable :: EFrozT(:), EOccuT(:), EVirtT(:), OldVec(:), T1amp(:)
real(kind=wp), pointer, contiguous :: EOcc(:) => null(), EVir(:) => null()
integer(kind=iwp), parameter :: Laplace_BlockSize_Def = 500, Laplace_mGridPoints = 20, MxQual_Def = 200
real(kind=wp), parameter :: Span_Def = 1.0e-2_wp
logical(kind=iwp), parameter :: Decom_Def = .false.
character(len=*), parameter :: RootNm = 'ChoMP2_'

public :: AdrR1, AdrR2, all_Vir, C_os, ChkDecoMP2, ChoAlg, ChoMP2_allocated, ChoMP2g_allocated, Decom_Def, DecoMP2, DeMP2, DoDens, &
          DoFNO, DoGrdt, DoMP2, DoT1amp, EFrozT, EMP2_dens, EOcc, EOccuT, EOSMP2, EVir, EVirtT, FNOMP2, ForceBatch, iAdrOff, &
          iAoMo, iAOVir, iBatOrb, iDel, iFirst, iFirstS, iFro, iMatab, iMoAo, iMoMo, InCore, iOcc, iOffT1, iOption_MP2CD, iT1am, &
          iT1AOT, iVir, kFLagr, kLagr, kPab, kPai, kPaK, kPij, kPiK, kWab, kWai, kWaK, kWij, kWiK, kWJK, l_Dii, Laplace, &
          Laplace_BlockSize, Laplace_BlockSize_Def, Laplace_mGridPoints, Laplace_nGridPoints, lFLagr, LiMatij, LiPQprod, LiT1am, &
          lLagr, LnBatOrb, LnMatij, LnOcc, LnPQprod, LnT1am, LovMP2, lPab, lPai, lPaK, lPij, lPiK, lUnit, lUnit_F, LuRInv, LuUVec, &
          LuVVec, LuWVec, lWab, lWai, lWaK, lWij, lWiK, lWJK, MP2_small, MP2D, MP2D_e, MP2D_e_full, MP2D_full, MP2W, MP2W_e, &
          MP2W_e_full, MP2W_full, MxQual_Def, MxQualMP2, nActa, nAdrOff, nAoMo, nAOVir, nBatch, nBatOrbT, nDel, nDelT, nFro, &
          nFroT, nMatab, nMo, nMoAo, nMoMo, nMoType, NMP2Vec, nOcc, nOccT, nOccVirT, NoGamma, nOrb, NowSym, nPQ_Prod, nT1am, &
          nT1AOT, nTypF, NumBatOrb, NumOcc, nVir, nVirT, OED_Thr, OldVec, RootNm, Set_cd_thr, shf, SOS_mp2, Span_Def, SpanMP2, &
          T1amp, ThrLov, ThrMP2, Verbose, vkept, Wref, XEMP2

end module ChoMP2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3_bt_aaa(nug,ka,la,adim,N,noab,nnoab,lu,iasblock,nga,oeh,oep,enx,voa,t1a,t1b,t3a,t3b,ifvo)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nug, adim, N, noab, nnoab, lu(2), iasblock(3), nga
real(kind=wp), intent(out) :: ka(nTri_Elem(adim-1),N,noab), la(N*adim,nnoab), voa(nTri_Elem(adim-1),nnoab), &
                              t3a(nTri_Elem(adim-1),adim), t3b(nTri_Elem(adim-1),adim)
real(kind=wp), intent(in) :: oeh(noab), oep(adim)
real(kind=wp), intent(inout) :: enx, t1a(noab,*), t1b(noab,*)
logical(kind=iwp), intent(in) :: ifvo
integer(kind=iwp) :: a, aa, ab, ac, b, bc, c, i, ias, ij, ik, j, jk, k, ndim, nga_offset, nug_offset
real(kind=wp) :: den, dena, denb, denc, XX, YY

if (adim == 1) return
!mp write(u6,*) 'enter_aaa enx,nga,',nga,enx
ndim = nTri_Elem(adim-1)
t3b(:,:) = Zero
nug_offset = iasblock(1)*nTri_Elem(nug)
ias = iasblock(2)*(nga-1)+1
call multi_readir(la,nnoab*adim*N,lu(2),ias)
ias = iasblock(2)*nug+iasblock(3)*(nTri_Elem(nga)-1)+1
call multi_readir(voa,nnoab*ndim,lu(2),ias)

nga_offset = iasblock(1)*(nTri_Elem(nga)-1)+1
do i=1,noab
  ias = (i-1)*nug_offset+nga_offset
  call multi_readir(ka(:,:,i),N*ndim,lu(1),ias)
end do
do i=3,noab
  jk = 0
  do j=2,i-1
    ij = nTri_Elem(i-2)+j
    ik = nTri_Elem(i-2)
    do k=1,j-1
      jk = jk+1
      ik = ik+1
      ! K_ab^ir x L_rc^jk
      call DGEMM_('N','N',ndim,adim,N,one,ka(:,:,i),ndim,la(:,jk),N,zero,t3a,ndim)
      ! K_ab^kr x L_rc^ij
      call DGEMM_('N','N',ndim,adim,N,one,ka(:,:,k),ndim,la(:,ij),N,one,t3a,ndim)
      ! -K_ab^jr x L_rc^ik
      call DGEMM_('N','N',ndim,adim,N,-one,ka(:,:,j),ndim,la(:,ik),N,one,t3a,ndim)
      den = oeh(i)+oeh(j)+oeh(k)
      do a=3,adim
        aa = nTri_Elem(a-2)
        dena = den-oep(a)
        bc = 0
        do b=2,a-1
          denb = dena-oep(b)
          ab = aa+b
          do c=1,b-1
            bc = bc+1
            denc = denb-oep(c)
            ac = aa+c
            xx = t3a(ab,c)+t3a(bc,a)-t3a(ac,b)
            yy = xx/denc
            enx = enx+yy*xx
            t3b(ab,c) = yy
            t3b(bc,a) = yy
            t3b(ac,b) = -yy
          end do
        end do
      end do
      ! ccsd(T) part vvoo*t3
      call DGEMM_('N','N',1,adim,ndim,one,voa(:,ij),1,t3b,ndim,one,t1a(k,1),noab)
      call DGEMM_('N','N',1,adim,ndim,one,voa(:,jk),1,t3b,ndim,one,t1a(i,1),noab)
      call DGEMM_('N','N',1,adim,ndim,-one,voa(:,ik),1,t3b,ndim,one,t1a(j,1),noab)
      ! ccsd(T) part t2*t3
      if (ifvo) then
        call DGEMM_('N','N',1,adim,ndim,one,ka(:,i,j),1,t3b,ndim,one,t1b(k,1),noab)
        call DGEMM_('N','N',1,adim,ndim,one,ka(:,j,k),1,t3b,ndim,one,t1b(i,1),noab)
        call DGEMM_('N','N',1,adim,ndim,-one,ka(:,i,k),1,t3b,ndim,one,t1b(j,1),noab)
      end if
    end do !k
  end do !j
end do !i

return

end subroutine t3_bt_aaa

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Roland Lindh                                     *
*               2015, Ignacio Fdez. Galvan (split from gencxctl)       *
************************************************************************
      Subroutine get_drdq(drdq,mLambda)
      Implicit None
************************************************************************
*     subroutine to get the dr/dq vectors for the constraints as given *
*     in the 'UDC' file.                                               *
************************************************************************
#include "info_slapaf.fh"
#include "WrkSpc.fh"
#include "real.fh"
      Real*8, Intent(InOut) :: drdq(mInt,nLambda)
      Integer, Intent(Out) :: mLambda
*
      Integer n3,nBV,i,iLambda,iOff,iOff2,ipCoor_l
      Integer ipBMx,ipdBMx,ipBVc,ipdBVc,ipcInt,ipcInt0,ipValue,ipValue0,
     &        ipMult,ip_iFlip
      Real*8 RR
      Real*8, External :: DDot_
*
      Character*8 Lbl(mInt), Labels(iRow_c-1)
*
      n3=3*nsAtom
*
      If (nLambda.ne.0) Then
         nBV=iRow_c-nLambda-1
         Call GetMem('BVec','Allo','Real',ipBVc,n3*nBV)
         Call GetMem('dBVec','Allo','Real',ipdBVc,nBV*n3**2)
         Call GetMem('BMx','Allo','Real',ipBMx,n3*nLambda)
         Call GetMem('Value','Allo','Real',ipValue,nBV)
         Call GetMem('Value0','Allo','Real',ipValue0,nBV)
         Call FZero(Work(ipValue0),nBV) ! dummy initiate
         Call GetMem('cInt','Allo','Real',ipcInt,nLambda)
         Call GetMem('cInt0','Allo','Real',ipcInt0,nLambda)
         Call GetMem('Mult','Allo','Real',ipMult,nBV**2)
         Call GetMem('dBMx','Allo','Real',ipdBMx,nLambda*n3**2)
         Call GetMem('iFlip','Allo','Inte',ip_iFlip,nBV)
*
         ipCoor_l=ipCx+(Iter-1)*n3
         Call DefInt2(Work(ipBVc),Work(ipdBVc),nBV,Labels,
     &                Work(ipBMx),nLambda,nsAtom,iRow_c,
     &                Work(ipValue),Work(ipcInt),Work(ipcInt0),
     &                Lbl,AtomLbl,Work(ipCoor_l),
     &                lWrite,jStab,nStab,mxdc,
     &                Work(ipMult),Smmtrc,nDimBC,Work(ipdBMx),
     &                Work(ipValue0),Iter,iWork(ip_iFlip),
     &                Work(ipCM))
*        Call RecPrt('dr/dx',' ',Work(ipBMx),n3,nLambda)
*
*        Assemble dr/dq: Solve  B dr/dq = dr/dx
*
         Call FZero(drdq,nLambda*mInt)
*
*        Temporary fix of the dC/dx vector which always
*        is propted up with the full degeneracy factor.
*
         If (.not.Curvilinear) Then
            iOff=ipBMx
            Do iLambda=1,nLambda
               Do i=1,n3
                  Work(iOff+i-1)=Work(iOff+i-1)/Degen(i)
               End Do
               iOff=iOff+n3
            End Do
         End If
         Call Eq_Solver('N',n3,mInt,nLambda,Work(ipB),Curvilinear,Degen,
     &                  Work(ipBMx),drdq)
*        Call RecPrt('drdq',' ',drdq,mInt,nLambda)
*
         Call Free_iWork(ip_iFlip)
         Call Free_Work(ipdBMx)
         Call Free_Work(ipMult)
         Call Free_Work(ipcInt0)
         Call Free_Work(ipcInt)
         Call Free_Work(ipValue0)
         Call Free_Work(ipValue)
         Call Free_Work(ipBMx)
         Call Free_Work(ipdBVc)
         Call Free_Work(ipBVc)
      End If
*
*     Double check that we don't have any null vectors
*
      iOff=1
      iOff2=1
      mLambda=nLambda
      Do iLambda=1,nLambda
         RR=Sqrt(DDot_(mInt,drdq(1,iOff),1,drdq(1,iOff),1))
         If (RR.lt.1.0D-12) Then
            Write (6,*) 'Warning: constraint ',iLambda,
     &                  ' has a null vector, I''ll remove it!'
            mLambda=mLambda-1
         Else
            If (iOff.ne.iOff2)
     &         Call dCopy_(mInt,drdq(1,iOff),1,drdq(1,iOff2),1)
            iOff2=iOff2+1
         End If
         iOff=iOff+1
      End Do
      If (mLambda.lt.nLambda)
     &   Call FZero(drdq(1,mLambda+1),mInt*(nLambda-mLambda))
*
      End Subroutine get_drdq

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine NAMem_GIAO( &
#                     define _CALLING_
#                     include "mem_interface.fh"
                     )

use Index_Functions, only: nTri3_Elem1, nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: iAngV(4), kab, lab, labcd_EF, labMax, labMin, lc, lcd_EF, lcd_NA, lcdMax_EF, lcdMax_NA, lcdMin_EF, lcdMin_NA, &
                     ld, Mem0, Mem1, Mem2, Mem2_EF, Mem2_NA, nFlop, nMem

lc = lr
ld = 0
nHer = (la+lb+lc+ld+2)/2

labMin = nTri3_Elem1(max(la,lb)-1)
labMax = nTri3_Elem1(la+lb)-1
lab = (labMax-labMin+1)
kab = nTri_Elem1(la)*nTri_Elem1(lb)

lcdMin_EF = nTri3_Elem1(lr-1)
lcdMax_EF = nTri3_Elem1(lr)-1
lcd_EF = (lcdMax_EF-lcdMin_EF+1)
labcd_EF = lab*lcd_EF
Mem0 = labcd_EF

lcdMin_NA = nTri3_Elem1(lr-2)
lcdMax_NA = nTri3_Elem1(lr-1)-1
lcd_NA = (lcdMax_NA-lcdMin_NA+1)

call mHRR(la,lb,nFlop,nMem)
Mem1 = max(lcd_EF,lcd_NA)*nMem

iAngV(1) = la
iAngV(2) = lb
iAngV(3) = lc
iAngV(4) = ld
call MemRys(iAngV,Mem2_EF)
iAngV(3) = 0
call MemRys(iAngV,Mem2_NA)
Mem2 = max(Mem2_EF,Mem2_NA,kab*max(lcd_EF,lcd_NA))

Mem = Mem0+Mem1+Mem2

return

end subroutine NAMem_GIAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Real*8 Function Error_for_t(t,rMP,xrMP,xxrMP,xnrMP,EC,A,R_ij,
     &                            C_o_C,ij,l,nij,lMax,nElem,nAtoms,
     &                            nPert,Scratch_New,Scratch_Org,
     &                            iPrint_Errors)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Dimension EC(3,nij),A(3,nij),C_o_C(3),R_ij(3)
      Dimension rMP(nij,0:nElem-1,0:nPert-1),xnrMP(nij,nElem)
      Dimension xrMP(nij,nElem),xxrMP(nij,nElem)
      Dimension Scratch_Org(nij*(2+lMax+1)),Scratch_New(nij*(2+lMax+1))

      iDim = nij*nElem
      A(1,ij) = EC(1,ij) + t*R_ij(1)
      A(2,ij) = EC(2,ij) + t*R_ij(2)
      A(3,ij) = EC(3,ij) + t*R_ij(3)
      Call dCopy_(iDim,rMP,1,xrMP,1)
      Do ij_temp = 1, nij
         Call ReExpand(xrMP,nij,nElem,EC(1,ij_temp),C_o_C,ij_temp,lMax)
      End Do
      call daxpy_(iDim,One,xnrMP,1,xrMP,1)
      Call dCopy_(iDim,xrMP,1,xxrMP,1)
      Call CutOff_Error(l,lMax,xrMP,xxrMP,nij,A,
     &                  C_o_C,nElem,Scratch_New,Scratch_Org,
     &                  nAtoms,iPrint_Errors,Error)
*
      Error_for_t = Error
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine S_SCALE(NAS,SCA,S,iLo,iHi,jLo,jHi,LDS)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NAS, iLo, iHi, jLo, jHi, LDS
real(kind=wp), intent(in) :: SCA(NAS)
real(kind=wp), intent(inout) :: S(LDS,*)
integer(kind=iwp) :: J

do J=jLo,jHi
  S(1:iHi-iLo+1,J-jLo+1) = SCA(iLo:iHi)*SCA(J)*S(1:iHi-iLo+1,J-jLo+1)
end do

end subroutine S_SCALE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Rulin Feng                                       *
!***********************************************************************

!****************************************************
!          Desymmetrize a given array(matrix)
!****************************************************
! This routine is made to expand a given symmetry-adapted array
! into a C1 symmetry. SYMLAB is a bit flag,
! e.g., for symmetry 3, symlab=4=2^(3-1). A is input array with
! size SIZA, B is output array with size of NBST**2.
! Not tested for general cases, so for use of SO-NTOs only.
!
!                                               -RF 8/24,2021
subroutine DESYM_SONTO(A,SIZA,B,SYMLAB)

use Symmetry_Info, only: MUL, nIrrep
use rassi_data, only: NBASF, NBST
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: SIZA, SYMLAB
real(kind=wp), intent(in) :: A(SIZA)
real(kind=wp), intent(out) :: B(NBST,NBST)
integer(kind=iwp) :: I, IJ, IOF, ISY1, ISY12_MA, ISY12_MA_BI, ISY2, ITD, J, NB1, NB1_F, NB1_I, NB2, NB2_F, NB2_I
real(kind=wp) :: TDM
real(kind=wp), allocatable :: SCR(:)

! Initialize
B(:,:) = Zero

call mma_allocate(SCR,SIZA,Label='SCR')
SCR(:) = Zero

if (SYMLAB == 1) then
  ! Diagonal symmetry blocks.
  ! Dont need to do anything, just leave it be
  SCR(:) = A(:)
else
  ! Non-diagonal symmetry blocks
  ! note that only half of the total matrix has been stored
  ITD = 0
  IOF = 0
  do ISY1=1,nIrrep
    NB1 = NBASF(ISY1)
    do ISY2=1,nIrrep
      NB2 = NBASF(ISY2)
      ISY12_ma = MUL(ISY1,ISY2)
      ISY12_ma_bi = 2**(ISY12_ma-1)
      if (ISY12_ma_bi == SYMLAB) then
        if (ISY1 > ISY2) then
          do J=1,NB2
            do I=1,NB1
              ITD = ITD+1
              TDM = A(ITD)
              IJ = IOF+J+NB2*(I-1)
              SCR(IJ) = TDM
            end do
          end do
          IOF = IOF+NB1*NB2
        end if
      end if
    end do
  end do
end if
! Expand into C1

ITD = 0
NB1_i = 0
NB1_f = 0
do ISY1=1,nIrrep
  NB1 = NBASF(ISY1)
  NB1_f = NB1_i+NB1
  NB2_i = 0
  NB2_f = 0
  do ISY2=1,nIrrep
    ISY12_ma = MUL(ISY1,ISY2)
    ISY12_ma_bi = 2**(ISY12_ma-1)
    NB2 = NBASF(ISY2)
    NB2_f = NB2_i+NB2
    if (ISY12_ma_bi == SYMLAB) then
      do J=NB2_i+1,NB2_f
        do I=NB1_i+1,min(NB1_f,J)
          ITD = ITD+1
          B(I,J) = SCR(ITD)
          if (I /= J) B(J,I) = SCR(ITD)
        end do
      end do
    end if
    NB2_i = NB2_i+NB2
  end do
  NB1_i = NB1_i+NB1
end do
call mma_deallocate(SCR)

end subroutine DESYM_SONTO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Jonna Stalring                                   *
!***********************************************************************

subroutine calcerr(kappa,iestate)
!-------------------------------------------------
! Jonna 000411
!
! Calculates the derivative d E_j
!                           ------ = 2\sum_pq Fpq kappa_pq
!                            d w
!
! which estimates the error in the SA.
!---------------------------------------------------

use Index_Functions, only: nTri_Elem
use MCLR_Data, only: ipMat, ISTATE, nDens
use input_mclr, only: nBas, ntAsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: kappa(nDens)
integer(kind=iwp), intent(in) :: ieState
integer(kind=iwp) :: iS, nG1
real(kind=wp) :: dejdw
real(kind=wp), allocatable :: G1q(:), G1r(:), G2r(:), Q(:), T(:)
real(kind=wp), external :: DDot_

ng1 = nTri_Elem(ntash)

call mma_allocate(G1Q,ng1,Label='G1Q')
call mma_allocate(G1R,ntash**2,Label='G1R')
call mma_allocate(G2R,ntash**4,Label='G2R')
call mma_allocate(T,nDens,Label='T')
call mma_allocate(Q,nDens,Label='Q')

! Get densities of iestate in triangular and rectangular form.

call rddj(G1R,G1Q,G2R,iestate)

! Get Fock matrix ipT

call FockGen(One,G1R,G2R,T,Q,1)

! Print energy

!call prnte(G1q,T)

!call Recprt('KAPP',' ',kappa,nDens,1)
!call Recprt('FOCK',' ',T,nDens,1)

dejdw = Zero
do iS=1,nsym
  dejdw = dejdw+ddot_(nBas(is)**2,T(ipmat(is,is)),1,kappa(ipmat(is,is)),1)
end do
dejdw = Two*dejdw
!is = 1
!write(u6,*) 'T(ipmat(is,is))',T(ipmat(is,is))
!write(u6,*) 'kappa(ipmat(is,is)+1)',kappa(ipmat(is,is)+1)

! d E_j / d w_i, without constraint
!write(u6,200) iestate,istate,dejdw

! d E_i / d w_i, with the constraint sum(w_i)=1,
! multiplied by 1-w_i... which happens to be equal to
! d E_i / d w_i, without constraint
! change sign, because this is the *error*
if (iestate == istate) write(u6,100) iestate,-dejdw

call mma_deallocate(Q)
call mma_deallocate(T)
call mma_deallocate(G2R)
call mma_deallocate(G1R)
call mma_deallocate(G1Q)

return

100 format(' **********'/'                  Estimated error in the energy of state ',I5,': ',ES12.5/' **********')
!200 format(' Derivative of the energy of state ',I5,' with the weight ',I5,': ',ES12.5)

end subroutine calcerr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007,2008, Roland Lindh                                *
!***********************************************************************

subroutine Remove_High_Exponents(iD,nD,List2,mData,nTheta_All)
!***********************************************************************
!                                                                      *
!     Experimental code to be used with care.                          *
!                                                                      *
!***********************************************************************

use Basis_Info, only: Shells
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: nD, iD(nD)
integer(kind=iwp), intent(in) :: mData, nTheta_All, List2(mData,nTheta_All)
integer(kind=iwp) :: i, iTheta_All, k, kAng, kShll, l, lAng, lShll, mD
logical(kind=iwp) :: Skip

call iVcPrt('Remove_High_Exponents: iD',' ',iD,nD)
mD = nD
i = 1
do
  iTheta_All = iD(i)
  Skip = .false.
  kAng = List2(1,iTheta_All)
  lAng = List2(2,iTheta_All)
  k = List2(5,iTheta_All)
  l = List2(6,iTheta_All)
  kShll = List2(7,iTheta_All)
  lShll = List2(8,iTheta_All)
  if (kAng == lAng) then
    l = List2(6,iTheta_All)
    Skip = ((k == 1) .and. (l == 1)) .and. (Shells(kShll)%nExp /= 1)
  else
    Skip = (l == 1) .and. (Shells(lShll)%nExp /= 1)
  end if
  if (Skip) then
    if (mD == i) then
      mD = mD-1
      exit
    end if
    iD(i:mD-1) = iD(i+1:mD)
    mD = mD-1
    cycle
  end if
  i = i+1
  if (i > mD) exit
end do
nD = mD
call iVcPrt('Remove_High_Exponents: iD',' ',iD,nD)

return

end subroutine Remove_High_Exponents

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Per Ake Malmqvist                                *
*               2010, Grigory A. Shamov                                *
************************************************************************
      Subroutine CTCA(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object: To compute the Tognetti-Cortona-Adamo TCA functional         *
*         ref: J Chem Phys 128, 034101 (2008)                          *
*         template from CPBE functional, derived  with Maxima          *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author:Per Ake Malmqvist, Department of Theoretical Chemistry,  *
*             University of Lund, SWEDEN. December 2005 (CPBE)         *
*             Grigory Shamov, U of Manitoba (TCA) March 2010           *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
* Local arrays:
      Real*8 func1(3),func2(3,3)
* Call arguments:
* Weights(mGrid) (input) integration weights.
* Rho(nRho,mGrid) (input) Density and density derivative values,
*   Rho(1,iGrid) is rho_alpha values, Rho(2,iGrid) is rho_beta values
*   Rho(i,iGrid) is grad_rho_alpha (i=3..5 for d/dx, d/dy, d/dz)
*   Rho(i,iGrid) is grad_rho_beta  (i=6..8 for d/dx, d/dy, d/dz)
* dF_dRho (inout) are (I believe) values of derivatives of the
*   DFT functional (*NOT* derivatives of Fock matrix contributions).
* F_xc is values of the DFT energy density functional (surprised?)

* IDORD=Order of derivatives to request from CPBE:
      idord=1

* cpbe has three input variables apart from idord=1:
*  The density (rho_in), its gradient (abs value!) grdrho_in,
*  and spin polarization zeta (zeta_in).
* The result is returned as follows:
*   func0 = Correlation energy density
*   func1(1) = Its first derivative wrt rho
*   func1(2) = Its first derivative wrt gamma
*   func1(3) = Its first derivative wrt zeta
*   func2(1,1) = Second derivative wrt rho
*   func2(2,2) = Second derivative wrt gamma
*   func2(3,3) = Second derivative wrt zeta
*   func2(1,2) = Mixed derivative wrt rho and gamma
*   func2(1,3) = Mixed derivative wrt rho and zeta
*   func2(2,3) = Mixed derivative wrt gamma and zeta
* Here, gamma=(grad rho)**2; AKA sigma in some formulas.
* The derivatives w.r.t. spin components rhoa, rhob, and to the
* gradients grdrhoa_x, etcetc, ..., grdrhob_z are then:
*  Let F(rhoa,rhob,grdrhoa_x,...,grdrhob_z) = CPBE(rho,gamma,zeta),
* then dF_drhoa = func1(1)+2*rhob*func1(3)/rho**2
*      dF_drhob = func1(1)-2*rhoa*func1(3)/rho**2
*      dF_dgrdrhoa_x = dF_dgrdrhob_x = 2*func1(2)*grdrho_x and so on.
      if (ispin.eq.1) then
* ispin=1 means spin zero.
        do iGrid=1,mgrid
         rhoa=Rho(ipR,iGrid)
         rho_in=2.0D0*rhoa
         if(rho_in.lt.T_X) goto 110
         grdrho_x=2.D0*Rho(ipdRx,iGrid)
         grdrho_y=2.D0*Rho(ipdRy,iGrid)
         grdrho_z=2.D0*Rho(ipdRz,iGrid)

         gamma_in=(grdrho_x**2+grdrho_y**2+grdrho_z**2)
C         grdrho_in=sqrt(gamma)
         zeta_in=0.0D0
         call ctca_(idord,rho_in,gamma_in,zeta_in,func0,func1,func2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*func0
* dF_drhoa:
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*func1(1)
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*func1(2)
         dF_dRho(ipGxy,iGrid)=dF_dRho(ipGxy,iGrid)+Coeff*2.0D0*func1(2)
 110     continue
        end do
      else
* ispin .ne. 1, use both alpha and beta components.
        do iGrid=1,mgrid
         rhoa=max(1.0D-24,Rho(ipRa,iGrid))
         rhob=max(1.0D-24,Rho(ipRb,iGrid))
         rho_in=rhoa+rhob
         if(rho_in.lt.T_X) goto 210
         grdrhoa_x=Rho(ipdRxa,iGrid)
         grdrhoa_y=Rho(ipdRya,iGrid)
         grdrhoa_z=Rho(ipdRza,iGrid)
         grdrhob_x=Rho(ipdRxb,iGrid)
         grdrhob_y=Rho(ipdRyb,iGrid)
         grdrhob_z=Rho(ipdRzb,iGrid)

         grdrho_x=grdrhoa_x+grdrhob_x
         grdrho_y=grdrhoa_y+grdrhob_y
         grdrho_z=grdrhoa_z+grdrhob_z
         gamma_in=(grdrho_x**2+grdrho_y**2+grdrho_z**2)
C         grdrho_in=sqrt(gamma)
         zeta_in=(rhoa-rhob)/rho_in
         call ctca_(idord,rho_in,gamma_in,zeta_in,func0,func1,func2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*func0
* dF_drhoa:
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+
     &            Coeff*(func1(1)+(2.0D0*func1(3))*(rhob/rho_in**2))
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+
     &            Coeff*(func1(1)-(2.0D0*func1(3))*(rhoa/rho_in**2))
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*func1(2)
         dF_dRho(ipGab,iGrid)=dF_dRho(ipGab,iGrid)+Coeff*2.0D0*func1(2)
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*func1(2)
 210     continue
        end do
      end if

      Return
      End

      subroutine ctca_(idord,rho_in,gamma_in,zeta_in,func0,func1,func2)
      implicit none

C
C     Parameter variables
C
      REAL*8       PI, alpha, sigma, one
      PARAMETER   (PI = 3.1415926535897932384626433832795D0, one=1.0d0)
      parameter (alpha = 2.30D0, sigma=1.43d0)
C
C     Argument variables
C
      REAL*8        FUNC0,       FUNC1(3),    FUNC2(3,3)
      REAL*8        GAMMA_IN,   RHO_IN,      ZETA_IN
      INTEGER       IDORD
C
C     Local variables
C
      real*8 rho, zeta, gamma

      real*8 T1
      real*8 T2
      real*8 T3
      real*8 T4
      real*8 T5
      real*8 T6
      real*8 T7
      real*8 T8
      real*8 T9
      real*8 T10
      real*8 T11
      real*8 T12
      real*8 T13
      real*8 T14
      real*8 T15
      real*8 T16
      real*8 T17
      real*8 T18
      real*8 T19
      real*8 T20
      real*8 T21
      real*8 T22
      real*8 T23
      real*8 T24


      rho=Max(1.0D-24,rho_in)
      gamma=gamma_in
      if(zeta_in.gt. 1.0D0) zeta= 1.0d0
      if(zeta_in.lt.-1.0D0) zeta=-1.0d0
      zeta=zeta_in*(1.0d0-2.3d-16)


* Finally, the functional is defined as the integrand in the
* expression for the correlation energy, i.e. there is a factor
* rho:

      T1=rho**(1.d+0/3.d+0)
      T2=1.970876462555557d+0/T1+4.88827d+0
      T3=8.97889d-1-6.55868d-1*atan(T2)
      T4=rho**(4.d+0/3.d+0)
      T5=one/T4
      T6=sqrt(gamma)
      T7=1.616204596739955d-1*T5*sigma*T6+1.d+0
      T8=one/T7**alpha
      T9=1.d+0-1.d+0*zeta
      T10=zeta+1.d+0
      T11=T10**(2.d+0/3.d+0)+T9**(2.d+0/3.d+0)
      T12=T11**3
      T13=T2**2+1.d+0
      T14=one/T13
      T15=one/rho
      T16=-alpha
      T17=T7**(T16-1)
      T18=one/T6
      T19=6.666666666666666d-1/T10**(1.d+0/3.d+0)-6.66666666666
     8   6666d-1/T9**(1.d+0/3.d+0)
      T20=T11**2
      T21=one/rho**(7.d+0/3.d+0)
      T22=-1.d+0*alpha-1.d+0
      T23=sigma**2
      T24=T7**(T16-2)

      func0 = 2.0149899425205864d-1*T3*T4*T8*T12


      if(idord.ge.1) then

      func1(1) = 4.342181343315399d-2*a
     ;  lpha*T3*T15*sigma*T17*T6*T12+2.686653256694115d-1*T3*T1*T8*T12+
     <  8.682153762983333d-2*T14*T8*T12
      func1(2) = -1.6283180037432754d-2*alpha*T3*sigma*T17*T18*T12
      func1(3) = 6.04496982756176d-1*T3*T4*T8*T19*T20

      end if

      if(idord.ge.2) then

      func2(1,1) = -9.357137929259761d-3*T22*alpha*T3*T23*T24
     ?  *gamma*T12/rho**(1.d+1/3.d+0)+1.4473937811051357d-2*alpha*T3*si
     @  gma*T17*T6*T12/rho**2+3.741903152356469d-2*alpha*T14*T21*sigma*
     1  T17*T6*T12+8.955510855647049d-2*T3*T8*T12/rho**(2.d+0/3.d+0)+1.
     2  1576205017311111d-1*T14*T15*T8*T12+1.140763499716801d-1*T2*T5*T
     3  8*T12/T13**2

      func2(2,2) = 8.141590018716377d-3*alpha*T3*sigma*T17*
     4  T12/T6**3-1.3158475213021542d-3*T22*alpha*T3*T5*T23*T24*T12/gam
     5  ma

      func2(3,3) = 6.04496982756176d-1*T3*T4*T8*(-2.2222222222222224d
     6  -1/T10**(4.d+0/3.d+0)-2.2222222222222224d-1/T9**(4.d+0/3.d+0))*
     7  T20+1.208993965512352d+0*T3*T4*T8*T19**2*T11

      func2(1,2) = 3.508926
     8  723472411d-3*T22*alpha*T3*T21*T23*T24*T12-7.01606841066838d-3*a
     9  lpha*T14*T5*sigma*T17*T18*T12

      func2(1,2) = 1.30265440299462d-1*alp
     =  ha*T3*T15*sigma*T17*T6*T19*T20+8.059959770082344d-1*T3*T1*T8*T1
     ;  9*T20+2.6046461288949996d-1*T14*T8*T19*T20

      func2(2,3) = -4.8849540
     <  112298256d-2*alpha*T3*sigma*T17*T18*T19*T20

      end if

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DXTYP2_GAS(NDXTP,ITP,JTP,KTP,LTP,NOBTP,IL,IR,IPHGAS)
! Obtain types of I,J,K,l so
! <L!a+I a+K a L a J!R> is nonvanishing
! only combinations with type(I) >= type(K) and type(J) >= type(L)
! are included
!
! Intermediate occupations less than zero allowed for particle spaces
! (IPHGAS=2)

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: NDXTP
integer(kind=iwp), intent(_OUT_) :: ITP(*), JTP(*), KTP(*), LTP(*)
integer(kind=iwp), intent(in) :: NOBTP, IL(NOBTP), IR(NOBTP), IPHGAS(NOBTP)
integer(kind=iwp) :: IANNI1, IANNI2, ICREA1, ICREA2, IDIA, IJTP, IOBTP, KLTP, NANNI, NCREA, NDIF, NDIFT
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IDX

write(u6,*) ' DXTYP2_GAS in action'
write(u6,*) ' ===================='
write(u6,*) ' Occupation of left string'
call IWRTMA(IL,1,NOBTP,1,NOBTP)
write(u6,*) ' Occupation of right string'
call IWRTMA(IR,1,NOBTP,1,NOBTP)
#endif

! Number of differing occupations
NANNI = 0
NCREA = 0
NDIFT = 0

ICREA1 = 0
ICREA2 = 0
IANNI1 = 0
IANNI2 = 0
do IOBTP=1,NOBTP
  NDIFT = NDIFT+abs(IL(IOBTP)-IR(IOBTP))
  NDIF = IL(IOBTP)-IR(IOBTP)
  if (NDIF == 2) then
    ! two electrons of type IOBTP must be created
    ICREA1 = IOBTP
    ICREA2 = IOBTP
    NCREA = NCREA+2
  else if (NDIF == -2) then
    ! two electrons of type IOBTP must be annihilated
    IANNI1 = IOBTP
    IANNI2 = IOBTP
    NANNI = NANNI+2
  else if (NDIF == 1) then
    ! one electron of type IOBTP must be created
    if (NCREA == 0) then
      ICREA1 = IOBTP
    else
      ICREA2 = IOBTP
    end if
    NCREA = NCREA+1
  else if (NDIF == -1) then
    ! one electron of type IOBTP must be annihilated
    if (NANNI == 0) then
      IANNI1 = IOBTP
    else
      IANNI2 = IOBTP
    end if
    NANNI = NANNI+1
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' NCREA, NANNI ',NCREA,NANNI
write(u6,*) ' ICREA1, IANNI1 ',ICREA1,IANNI1
write(u6,*) ' ICREA2, IANNI2 ',ICREA2,IANNI2
#endif

NDXTP = 0
if (NDIFT <= 4) then
  if ((NCREA == 0) .and. (NANNI == 0)) then
    ! strings identical, include diagonal excitions  itp = jtp, ktp=ltp
    do IJTP=1,NOBTP
      if ((IR(IJTP) >= 1) .or. (IPHGAS(IJTP) == 2)) then
        do KLTP=1,IJTP
          if (((IJTP /= KLTP) .and. ((IR(KLTP) >= 1) .or. (IPHGAS(KLTP) == 2))) .or. &
              ((IJTP == KLTP) .and. ((IR(KLTP) >= 2) .or. (IPHGAS(KLTP) == 2)))) then
            NDXTP = NDXTP+1
            ITP(NDXTP) = IJTP
            JTP(NDXTP) = IJTP
            KTP(NDXTP) = KLTP
            LTP(NDXTP) = KLTP
          end if
        end do
      end if
    end do
  else if ((NCREA == 1) .and. (NANNI == 1)) then
    ! strings differ by single excitation
    ! diagonal excitation plus creation in ICREA1 and annihilation in IANNI1
    do IDIA=1,NOBTP
      if (((IDIA /= IANNI1) .and. ((IR(IDIA) >= 1) .or. (IPHGAS(IDIA) == 2))) .or. &
          ((IDIA == IANNI1) .and. ((IR(IDIA) >= 2) .or. (IPHGAS(IDIA) == 2)))) then
        NDXTP = NDXTP+1
        ITP(NDXTP) = max(ICREA1,IDIA)
        KTP(NDXTP) = min(ICREA1,IDIA)
        JTP(NDXTP) = max(IANNI1,IDIA)
        LTP(NDXTP) = min(IANNI1,IDIA)
      end if
    end do
  else if ((NCREA == 2) .and. (NANNI == 2)) then
    ! strings differ by double excitation
    NDXTP = 1
    ITP(1) = ICREA2
    KTP(1) = ICREA1
    JTP(1) = IANNI2
    LTP(1) = IANNI1
  end if
end if

#ifdef _DEBUGPRINT_
write(u6,'(A,I4)') ' Number of connecting double excitations ',NDXTP
if (NDXTP /= 0) then
  write(u6,*) '  ITYP KTYP LTYP JTYP'
  write(u6,*) '  ==================='
  do IDX=1,NDXTP
    write(u6,'(1X,4I5)') ITP(IDX),KTP(IDX),LTP(IDX),JTP(IDX)
  end do
end if
#endif

end subroutine DXTYP2_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_P2MO(P2MO,nP2MO)
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"

      Character*24 Label
      Logical      Found
      Integer nP2MO
      Real*8 P2MO(nP2MO)

      Label='P2MO'
      Call qpg_dArray(Label,Found,mP2MO)
      If(.not.Found .or. mP2MO.eq.0) Then
         Call SysAbendmsg('Get_P2MO','Did not find:',label)
      End If
      If (nP2MO/=mP2MO) Then
         Write (6,*) 'Get_P2MO: nP2MO/=mP2MO'
         Write (6,*) 'mP2MO=',mP2MO
         Write (6,*) 'nP2MO=',nP2MO
         Call Abend()
      End If
      Call get_dArray(Label,P2MO,nP2MO)

      Return
      End

      Subroutine Get_P2MOt(P2MO,nP2MO)
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"

      Character*24 Label
      Logical      Found
      Real*8 P2MO(nP2MO)

      Label='P2MOT'
      Call qpg_dArray(Label,Found,mP2MO)
      If(.not.Found .or. mP2MO.eq.0) Then
         Call SysAbendmsg('Get_P2MOt','Did not find:',label)
      End If
      If (nP2MO/=mP2MO) Then
         Write (6,*) 'Get_P2MO: nP2MO/=mP2MO'
         Write (6,*) 'mP2MO=',mP2MO
         Write (6,*) 'nP2MO=',nP2MO
         Call Abend()
      End If
      Call get_dArray(Label,P2MO,nP2MO)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!***********************************************************************

subroutine NewH(nInter,nIter,dq_orig,g,H,iOptH,mIter)
!***********************************************************************
!                                                                      *
! Object: Driver for inverse Hessian update.                           *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January '95                                              *
!***********************************************************************

use Slapaf_Info, only: HUpMet
use NewH_Mod, only: UpdMask
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nInter, nIter, iOptH, mIter
real(kind=wp), intent(in) :: dq_orig(nInter,nIter), g(nInter,mIter+1)
real(kind=wp), intent(inout) :: H(nInter,nInter)
integer(kind=iwp) :: i
logical(kind=iwp) :: DoMask
real(kind=wp), allocatable :: dg(:), dq(:,:), gi(:)

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' NewH: lIter=',nIter
call RecPrt(' NewH: dq_orig',' ',dq_orig,nInter,nIter)
call RecPrt(' NewH: g',' ',g,nInter,nIter)
call RecPrt(' NewH: H(Old)',' ',H,nInter,nInter)
write(u6,*) ' NewH: iOptH=',iOptH
#endif

! Branch out if the first iteration

if (nIter <= 1) return
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the MM mask
DoMask = .false.
if (allocated(UpdMask)) then
  if (size(UpdMask) == nInter) DoMask = .true.
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(dg,nInter,label='dg')
call mma_allocate(gi,nInter,label='gi')
call mma_allocate(dq,nInter,nIter,label='dq')
dq(:,:) = dq_orig(:,:)
!                                                                      *
!***********************************************************************
!                                                                      *
! Form the difference between the gradients. Observe the order!
! This since we are storing the forces rather than the gradients,
! big mistake!!!

dg(:) = g(:,nIter-1)-g(:,nIter)
if (DoMask) then
  do i=1,nInter
    if (UpdMask(i) /= 0) then
      dg(i) = Zero
      dq(i,nIter-1) = Zero
    end if
  end do
end if
#ifdef _DEBUGPRINT_
call RecPrt(' NewH: dg',' ',dg,nInter,1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the update

if (btest(iOptH,3)) then

  ! No update

  HUpMet = ' None '

else if (btest(iOptH,0)) then

  !Fletcher (or Meyer) update

  HUpMet = '  F   '
  write(u6,*) 'Deleted option in NewH'
  call Abend()

else if (btest(iOptH,1)) then

  ! Broyden-Powel Symmetric Rank-2 update

  HUpMet = '  BP  '
  write(u6,*) 'Deleted option in NewH'
  call Abend()

else if (btest(iOptH,2)) then

  ! Broyden-Fletcher-Goldfarb-Shanno update

  HUpMet = ' BFGS '
  call DFP(H,nInter,gi,dq(1,nIter-1),dg)

else if (btest(iOptH,4)) then

  ! Murtagh-Sargent-Powell update

  HUpMet = ' MSP  '
  call dGeMV_('N',nInter,nInter,-One,H,nInter,dq(1,nIter-1),1,One,dg,1)
# ifdef _DEBUGPRINT_
  call RecPrt(' NewH: gamma',' ',dg,nInter,1)
# endif
  call MSP(H,dg,dq(1,nIter-1),nInter)

else if (btest(iOptH,5)) then

  ! EU update

  HUpMet = '  EU  '

  ! Some precalculations:
  gi(:) = -g(:,nIter-1)
  if (DoMask) then
    do i=1,nInter
      if (UpdMask(i) /= 0) gi(i) = Zero
    end do
  end if

  call EU(dq(1,nIter-1),dg,gi,H,nInter)

else if (btest(iOptH,6)) then

  ! TS_BFGS update

  HUpMet = 'TSBFGS'
  call TS_BFGS(dq(1,nIter-1),dg,H,nInter)

else

  call WarningMessage(2,'Error in NewH')
  write(u6,*) ' Improper value of iOptH:',iOptH
  call Abend()

end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt(' NewH:  H(New)',' ',H,nInter,nInter)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(dg)
call mma_deallocate(gi)
call mma_deallocate(dq)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine NewH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Roland Lindh                                     *
************************************************************************
      Subroutine HrrMtrx(HMtrx,np,la,lb,A,B,
     &                   Sph_a,CS_a,nSph_a,Sph_b,Cs_b,nSph_b)
************************************************************************
*                                                                      *
*     Object: to compute the matrix which corresponds to the transfer  *
*             equation.                                                *
*                                                                      *
*     Author: Roland Lindh                                             *
*             Dept of Chem. Phys.                                      *
*             Univ. of Lund, Sweden                                    *
*             February 1999                                            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "binom.fh"
#include "ican.fh"
#include "real.fh"
      Real*8 A(3), B(3), HMtrx(np,nSph_a,nSph_b), AB(3,0:iTabMx),
     &       CS_a((la+1)*(la+2)/2,nSph_a), CS_b((lb+1)*(lb+2)/2,nSph_b)
      Logical EQ, Sph_a, Sph_b
*
      iOff(ixyz) = ixyz*(ixyz+1)*(ixyz+2)/6
      jCan(ix,iy,iz) = iOff(ix+iy+iz) + (iy+iz)*(iy+iz+1)/2 + iz + 1
*
      iPrint=5
      If (iPrint.ge.99) Then
         Call RecPrt('A',' ',A,1,3)
         Call RecPrt('B',' ',B,1,3)
         Call RecPrt('CS_a',' ',CS_a,(la+1)*(la+2)/2,nSph_a)
         Call RecPrt('CS_b',' ',CS_b,(lb+1)*(lb+2)/2,nSph_b)
         Write (6,*) 'np=',np
      End If
      Call FZero(HMtrx,np*nSph_a*nSph_b)
*
      AB(1,0)=One
      AB(2,0)=One
      AB(3,0)=One
      If (la.ge.lb) Then
         AB(1,1)=A(1)-B(1)
         AB(2,1)=A(2)-B(2)
         AB(3,1)=A(3)-B(3)
      Else
         AB(1,1)=B(1)-A(1)
         AB(2,1)=B(2)-A(2)
         AB(3,1)=B(3)-A(3)
      End If
      Do i = 2, Min(la,lb)
         AB(1,i)=AB(1,i-1)*AB(1,1)
         AB(2,i)=AB(2,i-1)*AB(2,1)
         AB(3,i)=AB(3,i-1)*AB(3,1)
      End Do
*
      If (la.ge.lb) Then
*
         If (Sph_a.and.Sph_b) Then
*
         Do iSph_a = 1, nSph_a
         Do ipa = 1, (la+1)*(la+2)/2
            C_a=CS_a(ipa,iSph_a)
            If (C_a.eq.Zero) Go To 100
            ix=iCan(1,iOff(la)+ipa)
            iy=iCan(2,iOff(la)+ipa)
            iz=iCan(3,iOff(la)+ipa)
            Do iSph_b = 1, nSph_b
            Do ipb = 1, (lb+1)*(lb+2)/2
               C_b=CS_b(ipb,iSph_b)
               If (C_b.eq.Zero) Go To 200
               jx=iCan(1,iOff(lb)+ipb)
               jy=iCan(2,iOff(lb)+ipb)
               jz=iCan(3,iOff(lb)+ipb)
*
               If (EQ(A,B)) Then
                  ixLow=ix+jx
                  iyLow=iy+jy
                  izLow=iz+jz
                  jOff=iOff(la+lb)
               Else
                  ixLow=ix
                  iyLow=iy
                  izLow=iz
                  jOff=iOff(la)
               End If
               Do kx = ixLow, ix+jx
               Do ky = iyLow, iy+jy
               Do kz = izLow, iz+jz
                  le=kx+ky+kz
                  ipe=jCan(kx,ky,kz)-jOff
*
                     ABx = AB(1,ix+jx-kx) * Binom(jx,kx-ix)
                     ABy = AB(2,iy+jy-ky) * Binom(jy,ky-iy)
                     ABz = AB(3,iz+jz-kz) * Binom(jz,kz-iz)
                     HMtrx(ipe,iSph_a,iSph_b) =
     &                  HMtrx(ipe,iSph_a,iSph_b) + ABx * ABy * ABz
     &                    * C_a * C_b
               End Do
               End Do
               End Do
*
 200           Continue
            End Do
            End Do
 100        Continue
         End Do
         End Do
*
         Else If (Sph_a) Then
*
         Do iSph_a = 1, nSph_a
         Do ipa = 1, (la+1)*(la+2)/2
            C_a=CS_a(ipa,iSph_a)
            If (C_a.eq.Zero) Go To 101
            ix=iCan(1,iOff(la)+ipa)
            iy=iCan(2,iOff(la)+ipa)
            iz=iCan(3,iOff(la)+ipa)
            Do ipb = 1, (lb+1)*(lb+2)/2
               jx=iCan(1,iOff(lb)+ipb)
               jy=iCan(2,iOff(lb)+ipb)
               jz=iCan(3,iOff(lb)+ipb)
*
               If (EQ(A,B)) Then
                  ixLow=ix+jx
                  iyLow=iy+jy
                  izLow=iz+jz
                  jOff=iOff(la+lb)
               Else
                  ixLow=ix
                  iyLow=iy
                  izLow=iz
                  jOff=iOff(la)
               End If
               Do kx = ixLow, ix+jx
               Do ky = iyLow, iy+jy
               Do kz = izLow, iz+jz
                  le=kx+ky+kz
                  ipe=jCan(kx,ky,kz)-jOff
*
                     ABx = AB(1,ix+jx-kx) * Binom(jx,kx-ix)
                     ABy = AB(2,iy+jy-ky) * Binom(jy,ky-iy)
                     ABz = AB(3,iz+jz-kz) * Binom(jz,kz-iz)
                     HMtrx(ipe,iSph_a,ipb) =
     &                  HMtrx(ipe,iSph_a,ipb) + ABx * ABy * ABz
     &                    * C_a
               End Do
               End Do
               End Do
*
            End Do
 101        Continue
         End Do
         End Do
*
         Else If (Sph_b) Then
*
         Do ipa = 1, (la+1)*(la+2)/2
            ix=iCan(1,iOff(la)+ipa)
            iy=iCan(2,iOff(la)+ipa)
            iz=iCan(3,iOff(la)+ipa)
            Do iSph_b = 1, nSph_b
            Do ipb = 1, (lb+1)*(lb+2)/2
               C_b=CS_b(ipb,iSph_b)
               If (C_b.eq.Zero) Go To 201
               jx=iCan(1,iOff(lb)+ipb)
               jy=iCan(2,iOff(lb)+ipb)
               jz=iCan(3,iOff(lb)+ipb)
*
               If (EQ(A,B)) Then
                  ixLow=ix+jx
                  iyLow=iy+jy
                  izLow=iz+jz
                  jOff=iOff(la+lb)
               Else
                  ixLow=ix
                  iyLow=iy
                  izLow=iz
                  jOff=iOff(la)
               End If
               Do kx = ixLow, ix+jx
               Do ky = iyLow, iy+jy
               Do kz = izLow, iz+jz
                  le=kx+ky+kz
                  ipe=jCan(kx,ky,kz)-jOff
*
                     ABx = AB(1,ix+jx-kx) * Binom(jx,kx-ix)
                     ABy = AB(2,iy+jy-ky) * Binom(jy,ky-iy)
                     ABz = AB(3,iz+jz-kz) * Binom(jz,kz-iz)
                     HMtrx(ipe,ipa,iSph_b) =
     &                  HMtrx(ipe,ipa,iSph_b) + ABx * ABy * ABz
     &                    * C_b
               End Do
               End Do
               End Do
*
 201           Continue
            End Do
            End Do
         End Do
*
         Else
*
         Do ipa = 1, (la+1)*(la+2)/2
            ix=iCan(1,iOff(la)+ipa)
            iy=iCan(2,iOff(la)+ipa)
            iz=iCan(3,iOff(la)+ipa)
            Do ipb = 1, (lb+1)*(lb+2)/2
               jx=iCan(1,iOff(lb)+ipb)
               jy=iCan(2,iOff(lb)+ipb)
               jz=iCan(3,iOff(lb)+ipb)
*
               If (EQ(A,B)) Then
                  ixLow=ix+jx
                  iyLow=iy+jy
                  izLow=iz+jz
                  jOff=iOff(la+lb)
               Else
                  ixLow=ix
                  iyLow=iy
                  izLow=iz
                  jOff=iOff(la)
               End If
               Do kx = ixLow, ix+jx
               Do ky = iyLow, iy+jy
               Do kz = izLow, iz+jz
                  le=kx+ky+kz
                  ipe=jCan(kx,ky,kz)-jOff
*
                     ABx = AB(1,ix+jx-kx) * Binom(jx,kx-ix)
                     ABy = AB(2,iy+jy-ky) * Binom(jy,ky-iy)
                     ABz = AB(3,iz+jz-kz) * Binom(jz,kz-iz)
                     HMtrx(ipe,ipa,ipb) =
     &                  HMtrx(ipe,ipa,ipb) + ABx * ABy * ABz
               End Do
               End Do
               End Do
*
            End Do
         End Do
*
         End If
      Else
*
         If (Sph_a.and.Sph_b) Then
*
         Do iSph_a = 1, nSph_a
         Do ipa = 1, (la+1)*(la+2)/2
            C_a=CS_a(ipa,iSph_a)
            If (C_a.eq.Zero) Go To 300
            ix=iCan(1,iOff(la)+ipa)
            iy=iCan(2,iOff(la)+ipa)
            iz=iCan(3,iOff(la)+ipa)
            Do iSph_b = 1, nSph_b
            Do ipb = 1, (lb+1)*(lb+2)/2
               C_b=CS_b(ipb,iSph_b)
               If (C_b.eq.Zero) Go To 400
               jx=iCan(1,iOff(lb)+ipb)
               jy=iCan(2,iOff(lb)+ipb)
               jz=iCan(3,iOff(lb)+ipb)
*
               If (EQ(A,B)) Then
                  jxLow=ix+jx
                  jyLow=iy+jy
                  jzLow=iz+jz
                  jOff=iOff(la+lb)
               Else
                  jxLow=jx
                  jyLow=jy
                  jzLow=jz
                  jOff=iOff(lb)
               End If
               Do kx = jxLow, ix+jx
               Do ky = jyLow, iy+jy
               Do kz = jzLow, iz+jz
                  ipe=jCan(kx,ky,kz)-jOff
*
                  ABx = AB(1,ix+jx-kx) * Binom(ix,kx-jx)
                  ABy = AB(2,iy+jy-ky) * Binom(iy,ky-jy)
                  ABz = AB(3,iz+jz-kz) * Binom(iz,kz-jz)
                  HMtrx(ipe,iSph_a,iSph_b) =
     &               HMtrx(ipe,iSph_a,iSph_b) + ABx * ABy * ABz
     &                 * C_a * C_b
               End Do
               End Do
               End Do
*
 400           Continue
            End Do
            End Do
 300        Continue
         End Do
         End Do
*
         Else If (Sph_a) Then
*
         Do iSph_a = 1, nSph_a
         Do ipa = 1, (la+1)*(la+2)/2
            C_a=CS_a(ipa,iSph_a)
            If (C_a.eq.Zero) Go To 301
            ix=iCan(1,iOff(la)+ipa)
            iy=iCan(2,iOff(la)+ipa)
            iz=iCan(3,iOff(la)+ipa)
            Do ipb = 1, (lb+1)*(lb+2)/2
               jx=iCan(1,iOff(lb)+ipb)
               jy=iCan(2,iOff(lb)+ipb)
               jz=iCan(3,iOff(lb)+ipb)
*
               If (EQ(A,B)) Then
                  jxLow=ix+jx
                  jyLow=iy+jy
                  jzLow=iz+jz
                  jOff=iOff(la+lb)
               Else
                  jxLow=jx
                  jyLow=jy
                  jzLow=jz
                  jOff=iOff(lb)
               End If
               Do kx = jxLow, ix+jx
               Do ky = jyLow, iy+jy
               Do kz = jzLow, iz+jz
                  ipe=jCan(kx,ky,kz)-jOff
*
                  ABx = AB(1,ix+jx-kx) * Binom(ix,kx-jx)
                  ABy = AB(2,iy+jy-ky) * Binom(iy,ky-jy)
                  ABz = AB(3,iz+jz-kz) * Binom(iz,kz-jz)
                  HMtrx(ipe,iSph_a,ipb) =
     &               HMtrx(ipe,iSph_a,ipb) + ABx * ABy * ABz
     &                 * C_a
               End Do
               End Do
               End Do
*
            End Do
 301        Continue
         End Do
         End Do
*
         Else If (Sph_b) Then
*
         Do ipa = 1, (la+1)*(la+2)/2
            ix=iCan(1,iOff(la)+ipa)
            iy=iCan(2,iOff(la)+ipa)
            iz=iCan(3,iOff(la)+ipa)
            Do iSph_b = 1, nSph_b
            Do ipb = 1, (lb+1)*(lb+2)/2
               C_b=CS_b(ipb,iSph_b)
               If (C_b.eq.Zero) Go To 401
               jx=iCan(1,iOff(lb)+ipb)
               jy=iCan(2,iOff(lb)+ipb)
               jz=iCan(3,iOff(lb)+ipb)
*
               If (EQ(A,B)) Then
                  jxLow=ix+jx
                  jyLow=iy+jy
                  jzLow=iz+jz
                  jOff=iOff(la+lb)
               Else
                  jxLow=jx
                  jyLow=jy
                  jzLow=jz
                  jOff=iOff(lb)
               End If
               Do kx = jxLow, ix+jx
               Do ky = jyLow, iy+jy
               Do kz = jzLow, iz+jz
                  ipe=jCan(kx,ky,kz)-jOff
*
                  ABx = AB(1,ix+jx-kx) * Binom(ix,kx-jx)
                  ABy = AB(2,iy+jy-ky) * Binom(iy,ky-jy)
                  ABz = AB(3,iz+jz-kz) * Binom(iz,kz-jz)
                  HMtrx(ipe,ipa,iSph_b) =
     &               HMtrx(ipe,ipa,iSph_b) + ABx * ABy * ABz
     &                 * C_b
               End Do
               End Do
               End Do
*
 401           Continue
            End Do
            End Do
         End Do
*
         Else
*
         Do ipa = 1, (la+1)*(la+2)/2
            ix=iCan(1,iOff(la)+ipa)
            iy=iCan(2,iOff(la)+ipa)
            iz=iCan(3,iOff(la)+ipa)
            Do ipb = 1, (lb+1)*(lb+2)/2
               jx=iCan(1,iOff(lb)+ipb)
               jy=iCan(2,iOff(lb)+ipb)
               jz=iCan(3,iOff(lb)+ipb)
*
               If (EQ(A,B)) Then
                  jxLow=ix+jx
                  jyLow=iy+jy
                  jzLow=iz+jz
                  jOff=iOff(la+lb)
               Else
                  jxLow=jx
                  jyLow=jy
                  jzLow=jz
                  jOff=iOff(lb)
               End If
               Do kx = jxLow, ix+jx
               Do ky = jyLow, iy+jy
               Do kz = jzLow, iz+jz
                  ipe=jCan(kx,ky,kz)-jOff
*
                  ABx = AB(1,ix+jx-kx) * Binom(ix,kx-jx)
                  ABy = AB(2,iy+jy-ky) * Binom(iy,ky-jy)
                  ABz = AB(3,iz+jz-kz) * Binom(iz,kz-jz)
                  HMtrx(ipe,ipa,ipb) =
     &               HMtrx(ipe,ipa,ipb) + ABx * ABy * ABz
               End Do
               End Do
               End Do
*
            End Do
         End Do
*
         End If
      End If
      If (iPrint.ge.99) Then
         Call RecPrt('HMat ( np x (nSph_a*nSph_b) )','(30F4.1)',HMtrx,
     &             np,nSph_a*nSph_b)
         Write (6,*) DDot_(np*nSph_a*nSph_b,HMtrx,1,HMtrx,1)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine summary(wrk,wrksize,NvGrp,LunAux,maxdim,E1,E2,E2os)
! this routine does:
! T1
!   - make T1o = T1n/Den
!   - calc E1 = FTau
! T2:
!   - Join T2 form Tmp2files-(X,Y) and Tmp3files
!   - make T2o in T2files = T2n/Den
!   - make Tau from new amplitudes
!   - calc E2,E2os = WTau
!
! Scheme of recreation of T2n:
!
! 1) contributions from X and Y matrices
! T2n(be',ga',u,v) <<-
! C1                + 1/2 X(be',u,ga',v)
! C2                + 1/2 X(ga',v,be',u)
! C3                - 1/2 Y(be',u,ga',v)
! C4                - 1/2 Y(ga',v,be',u)
! C5                - 1   Y(ga',u,be',v)
! C6                - 1   Y(be',v,ga',u)
!
! 2) contributions from T2n1,T2n2 (T2+,T2-)
! T2n(be',ga',u,v) <<-
! C7                    T2+(be'ga',uv)
! C8                    T2-(be'ga',uv)
!
! Energy contributions:
! E1  = sum(a,i)       [  2 Fvo(a,i) . T1(a,i)               ]
! E2  = sum(a,b,i,j)   [ {2(ai|bj) - (aj|bi)} . Tau(a,b,i,j) ]
! E2os= sum(a,b,i,j)   [   (ai|bj)            . Tau(a,b,i,j) ]
!
! Memory requirements:
! V1-3 - {v'ov'o}
! H1,2 - {v'o}

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimGrpv, DimSGrpbe, GrpbeLow, GrpbeUp, I2Name, no, nv, PosFree, PosFvo, PosOE, PosT1n, PosT1o, T2Name, &
                       T2o2v4yes, Tmp2Name, Tmp3Name, Xyes, XYyes
#ifdef _MOLCAS_MPP_
use Para_Info, only: nProcs
#endif
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, NvGrp, LunAux, maxdim
real(kind=wp), intent(inout) :: wrk(wrksize)
real(kind=wp), intent(out) :: E1, E2, E2os
integer(kind=iwp) :: addbe, addbepp, addga, addgapp, beGrp, beSGrp, dim_1, dim_2, dimbe, dimbepp, dimga, dimgapp, gaGrp, gaSGrp, &
                     PosH1, PosH2, PosT, PosV1, PosV2, PosV3
real(kind=wp) :: Ehlp, Eoshlp
character(len=6) :: LunName

! Distribute Memory
PosT = PosFree
call DistMemSum(maxdim,PosV1,PosV2,PosV3,PosH1,PosH2,PosT)

! Operations on T1 amplitudes

! Divide T1n by denominators
call T1_div(wrk(PosT1n),wrk(PosOE),no,nv)

! Set T1o <- T1n
dim_1 = no*nv
wrk(PosT1o:PosT1o+dim_1-1) = wrk(PosT1n:PosT1n+dim_1-1)

! Calc E1
call Energy_E1(wrk(PosT1n),wrk(PosFvo),no,nv,EHlp)
E1 = Two*EHlp
!mp E1 = Two*E1

! Operations on T2 amplitudes

! cycle over be'=ga'

E2 = Zero
E2os = Zero

addbe = 0
do beGrp=1,NvGrp
  dimbe = DimGrpv(beGrp)

  ! Extract H1(be',I) <- T1(be,I)
  call ExtT1(wrk(PosH1),wrk(PosT1o),dimbe,addbe)

  ! vanish V3
  dim_1 = dimbe*dimbe*no*no
  wrk(PosV3:PosV3+dim_1-1) = Zero

  !1.1 Add contribution C1-6

  ! read V1(be',u,ga',v) <- X(be',u,ga',v)
  !      V2(be',u,ga',v) <- Y(be',u,ga',v)
  LunName = Tmp2Name(beGrp,beGrp)
  dim_1 = dimbe*dimbe*no*no
  if (XYyes(beGrp,beGrp) == 1) then
    call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,0)
    call GetX(wrk(PosV2),dim_1,LunAux,LunName,0,1)
  else if (Xyes(beGrp,beGrp) == 1) then
    call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
    wrk(PosV2:PosV2+dim_1-1) = Zero
  else
    wrk(PosV1:PosV1+dim_1-1) = Zero
    wrk(PosV2:PosV2+dim_1-1) = Zero
  end if

  ! V3(be',ga',u,v) <-
  ! C1                + 1/2 V1(be',u,ga',v)
  ! C2                + 1/2 V1(ga',v,be',u)
  ! C3                - 1/2 V2(be',u,ga',v)
  ! C4                - 1/2 V2(ga',v,be',u)
  ! C5                - 1   V2(ga',u,be',v)
  ! C6                - 1   V2(be',v,ga',u)
  call MkT_CAlld(wrk(PosV3),wrk(PosV1),wrk(PosV2),dimbe,no)
  !1.2 Add contribution C7,C8

  ! cycle over all subgroups of (be">=ga")
  !@
  !if (.false.) then
  !@
  addbepp = 0
  do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)
    dimbepp = DimSGrpbe(beSGrp)
    addgapp = 0
    do gaSGrp=GrpbeLow(beGrp),beSGrp
      dimgapp = DimSGrpbe(gaSGrp)

      if (beSGrp == gaSGrp) then
        ! read V1(bega",uv+) <- T2+(bega",uv+)
        !      V2(bega",uv-) <- T2-(bega",uv-)
        LunName = Tmp3Name(beSGrp,beSGrp)
        dim_1 = nTri_Elem(dimbepp)*nTri_Elem(no)
        dim_2 = nTri_Elem(dimbepp-1)*nTri_Elem(no-1)
        if (T2o2v4yes(beSGrp,beSGrp) == 1) then
          call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,0)
          call GetX(wrk(PosV2),dim_2,LunAux,LunName,0,1)
        else
          wrk(PosV1:PosV1+dim_1-1) = Zero
          wrk(PosV2:PosV2+dim_2-1) = Zero
        end if

        ! V3(be',ga',u,v) <<- T2+(bega",uv)
        !                     T2-(bega",uv)
        call MkT_C78d(wrk(PosV3),wrk(PosV1),wrk(PosV2),dimbe,dimbepp,addbepp,no)
      else
        LunName = Tmp3Name(beSGrp,gaSGrp)
        ! read V1(be",ga",uv+) <- T2+(be",ga",uv+)
        !      V2(be",ga",uv-) <- T2-(be",ga",uv-)
        dim_1 = dimbepp*dimgapp*nTri_Elem(no)
        dim_2 = dimbepp*dimgapp*nTri_Elem(no-1)
        if (T2o2v4yes(beSGrp,gaSGrp) == 1) then
          call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,0)
          call GetX(wrk(PosV2),dim_2,LunAux,LunName,0,1)
        else
          wrk(PosV1:PosV1+dim_1-1) = Zero
          wrk(PosV2:PosV2+dim_2-1) = Zero
        end if
        ! V3(be',ga',u,v) <<- T2+(be",ga",uv)
        !                     T2-(be",ga",uv)
        call MkT_C78od(wrk(PosV3),wrk(PosV1),wrk(PosV2),dimbe,dimbe,dimbepp,dimgapp,addbepp,addgapp,no)
      end if

      addgapp = addgapp+dimgapp
    end do
    addbepp = addbepp+dimbepp
  end do
  !@
  !end if
  !@

  !1.3 T2 - V3(be',ga',u,v) are now reconstructed (for be'>=ga')
  ! Divide by denominators and completed to be'<ga' also
  call T2d_div(wrk(PosV3),wrk(PosOE),dimbe,dimbe,addbe,addbe,no,nv)

  ! Prepair reduced Set V2(be'>=ga',u,v) <- V3(be',ga',u,v)
  call MkT_red(wrk(PosV2),wrk(PosV3),dimbe,no)

# ifdef _MOLCAS_MPP_
  !## Synchronizacny bod:
  ! Allreduce V2
  dim_1 = nTri_Elem(dimbe)*no*no
  call gadgop(wrk(PosV2),dim_1,'+')

  !## For parallel runs only:
  ! Inverse expansion  V3(be',ga',u,v) <- V2(be'>=ga',u,v)
  if (nProcs > 1) call MkT_exp(wrk(PosV2),wrk(PosV3),dimbe,no)
# endif
  !@@
  !call Chck_T2n(wrk(PosV3),dimbe,addbe,dimbe,addbe,1)
  !@@

  ! Save into corresponding T2file
  LunName = T2Name(beGrp,beGrp)
  dim_1 = nTri_Elem(dimbe)*no*no
  call SaveX(wrk(PosV2),dim_1,LunAux,LunName,1,1)

  ! Make Tau in V3(be',ga',u,v)
  ! (note, that T1 are already new ones)
  ! @@ s tym 2x H1 to nieje celkom koser
  call MkTau_chcc(wrk(PosV3),wrk(PosH1),wrk(PosH1),dimbe,dimbe,no,One,One)

  ! read V1(be',I,ga',J) <- I2(be'I|ga'J)
  LunName = I2Name(beGrp,beGrp)
  dim_1 = dimbe*dimbe*no*no
  call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

  ! Calc E2 = sum(a,b,i,j) (2V1(ai|bj)-V1(aj|bi)) . V3(a,b,i,j)
  call Energy_E2d(wrk(PosV1),wrk(PosV3),Ehlp,Eoshlp,dimbe,no)

  E2 = E2+Ehlp
  E2os = E2os+Eoshlp

  addbe = addbe+dimbe
end do

! cycle over be>ga
! reserved files:
!   V3(be',ga',u,v) = T2n(be',ga',u,v)
! free for use: V1,V2

addbe = DimGrpv(1)
do beGrp=2,NvGrp
  dimbe = DimGrpv(beGrp)

  ! Extract H1(be',I) <- T1(be,I)
  call ExtT1(wrk(PosH1),wrk(PosT1o),dimbe,addbe)

  addga = 0
  do gaGrp=1,beGrp-1
    dimga = DimGrpv(gaGrp)

    ! Extract H2(ga',I) <- T1(ga,I)
    call ExtT1(wrk(PosH2),wrk(PosT1o),dimga,addga)

    ! vanish V3
    dim_1 = dimbe*dimga*no*no
    wrk(PosV3:PosV3+dim_1-1) = Zero

    ! read V1(be',u,ga',v) <- X(be',u,ga',v)
    !      V2(be',u,ga',v) <- Y(be',u,ga',v)
    LunName = Tmp2Name(beGrp,gaGrp)
    dim_1 = dimbe*dimga*no*no
    if (XYyes(beGrp,gaGrp) == 1) then
      call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,0)
      call GetX(wrk(PosV2),dim_1,LunAux,LunName,0,1)
    else if (Xyes(beGrp,gaGrp) == 1) then
      call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
      wrk(PosV2:PosV2+dim_1-1) = Zero
    else
      wrk(PosV1:PosV1+dim_1-1) = Zero
      wrk(PosV2:PosV2+dim_1-1) = Zero
    end if

    ! Add contribution C1,C3,C6
    ! V3(be',ga',u,v) < - + 1/2 V1(be',u,ga',v)
    !                     - 1/2 V2(be',u,ga',v)
    !                     - 1   V2(be',v,ga',u)
    call MkT_C136od(wrk(PosV3),wrk(PosV1),wrk(PosV2),dimbe,dimga,no)

    ! read V1(ga',u,be',v) <- X(ga',u,be',v)
    !      V2(ga',u,be',v) <- Y(ga',u,be',v)
    LunName = Tmp2Name(gaGrp,beGrp)
    dim_1 = dimbe*dimga*no*no
    if (XYyes(gaGrp,beGrp) == 1) then
      call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,0)
      call GetX(wrk(PosV2),dim_1,LunAux,LunName,0,1)
    else if (Xyes(gaGrp,beGrp) == 1) then
      call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
      wrk(PosV2:PosV2+dim_1-1) = Zero
    else
      wrk(PosV1:PosV1+dim_1-1) = Zero
      wrk(PosV2:PosV2+dim_1-1) = Zero
    end if

    ! Add contribution C2,C4,C5
    ! V3(be',ga',u,v) <<- + 1/2 V1(ga',v,be',u)
    !                     - 1/2 V2(ga',v,be',u)
    !                     - 1   V2(ga',u,be',v)
    call MkT_C245od(wrk(PosV3),wrk(PosV1),wrk(PosV2),dimbe,dimga,no)

    !2.2 Add contribution C7,C8

    ! cycle over all subgroups of (be">=ga")
    addbepp = 0
    do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)
      dimbepp = DimSGrpbe(beSGrp)
      addgapp = 0
      do gaSGrp=GrpbeLow(gaGrp),GrpbeUp(gaGrp)
        dimgapp = DimSGrpbe(gaSGrp)

        ! read V1(be",ga",uv+) <- T2+(be",ga",uv+)
        !      V2(be",ga",uv-) <- T2-(be",ga",uv-)
        LunName = Tmp3Name(beSGrp,gaSGrp)
        dim_1 = dimbepp*dimgapp*nTri_Elem(no)
        dim_2 = dimbepp*dimgapp*nTri_Elem(no-1)
        if (T2o2v4yes(beSGrp,gaSGrp) == 1) then
          call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,0)
          call GetX(wrk(PosV2),dim_2,LunAux,LunName,0,1)
        else
          wrk(PosV1:PosV1+dim_1-1) = Zero
          wrk(PosV2:PosV2+dim_2-1) = Zero
        end if
        ! V3(be',ga',u,v) <<- T2+(be",ga",uv)
        !                     T2-(be",ga",uv)
        call MkT_C78od(wrk(PosV3),wrk(PosV1),wrk(PosV2),dimbe,dimga,dimbepp,dimgapp,addbepp,addgapp,no)

        addgapp = addgapp+dimgapp
      end do
      addbepp = addbepp+dimbepp
    end do

    ! T2 - V3(be',ga',u,v) are now completely reconstructed
    !  Divide by denominators
    call T2od_div(wrk(PosV3),wrk(PosOE),dimbe,dimga,addbe,addga,no,nv)

#   ifdef _MOLCAS_MPP_
    !## Synchronizacny bod:
    ! Allreduce V3
    dim_1 = dimbe*dimga*no*no
    call gadgop(wrk(PosV3),dim_1,'+')
#   endif
    !@@
    !call Chck_T2n(wrk(PosV3),dimbe,addbe,dimga,addga,0)
    !@@

    ! Save V3 into corresponding T2file
    LunName = T2Name(beGrp,gaGrp)
    dim_1 = dimbe*dimga*no*no
    call SaveX(wrk(PosV3),dim_1,LunAux,LunName,1,1)

    ! Map V1(ga',be',v,u) <- V3(be',ga',u,v)
    call Map4_2143(wrk(PosV3),wrk(PosV1),dimbe,dimga,no,no)

    ! Save V1 into corresponding T2file
    LunName = T2Name(gaGrp,beGrp)
    dim_1 = dimbe*dimga*no*no
    call SaveX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

    ! Make Tau in V3(be',ga',u,v)
    ! (note, that T1 are already new ones)
    call MkTau_chcc(wrk(PosV3),wrk(PosH1),wrk(PosH2),dimbe,dimga,no,One,One)

    ! read V1(be',I,ga',J) <- I2(be'I|ga'J)
    LunName = I2Name(beGrp,gaGrp)
    dim_1 = dimbe*dimga*no*no
    call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)

    ! Calc E2 = sum(a,b,i,j) (2V1(ai|bj)-V1(aj|bi)) . V3(a,b,i,j)
    call Energy_E2od(wrk(PosV1),wrk(PosV3),Ehlp,Eoshlp,dimbe,dimga,no)

    E2 = E2+Two*Ehlp
    E2os = E2os+Two*Eoshlp

    addga = addga+dimga
  end do

  addbe = addbe+dimbe
end do

!@@
return

! Calc Energy from Chck
call Chck_energ()

! upgrade checkeroo T1c and T2c

! Upgrade T1
call UpG_T1(wrk(PosT1o))

! Upgrade T2
addbe = 0
do beGrp=1,NvGrp
  dimbe = DimGrpv(beGrp)

  addga = 0
  do gaGrp=1,beGrp
    dimga = DimGrpv(gaGrp)

    if (beGrp == gaGrp) then
      LunName = T2Name(beGrp,beGrp)
      dim_1 = nTri_Elem(dimbe)*no*no
      call GetX(wrk(PosV3),dim_1,LunAux,LunName,1,1)
      call UpG_T2d(wrk(PosV3),dimbe,addbe)
    else
      LunName = T2Name(beGrp,gaGrp)
      dim_1 = dimbe*dimga*no*no
      call GetX(wrk(PosV3),dim_1,LunAux,LunName,1,1)
      call UpG_T2od(wrk(PosV3),dimbe,addbe,dimga,addga)
    end if

    addga = addga+dimga
  end do

  addbe = addbe+dimbe
end do

return

end subroutine summary

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013,2014, Ignacio Fdez. Galvan                        *
************************************************************************
*> @file
*> @brief
*>   Subroutines for superposition of molecules.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Subroutines for superposition of molecules.
*> \cite The2005-ACSA-61-478
*> \cite Liu2010-JCC-31-1561
************************************************************************
*  Get_RMSD_w
*
*> @brief
*>   Compute the optimal weighted RMSD between two structures.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Compute the optimal RMSD between two structures, with weights.
*> Coordinates are not changed, but the RMSD corresponds to the aligned structures.
*>
*> @param[in]  x    Cartesian coordinates of the first structure
*> @param[in]  y    Cartesian coordinates of the second structure
*> @param[in]  w    Weights for each atom
*> @param[in]  nAt  Number of atoms in the structures
*> @param[out] RMSD Minimum weighted RMSD between the two structures
*>
*> @see ::Get_RMSD
************************************************************************
      SUBROUTINE Get_RMSD_w(x,y,w,nAt,RMSD)
      IMPLICIT NONE
      INTEGER nAt
      REAL*8 x(3,nAt), y(3,nAt), w(nAt), RMSD
      CALL get_rotation(x,y,w,nAt,RMSD,.FALSE.)
      END
*
************************************************************************
*  Get_RMSD
*
*> @brief
*>   Compute the optimal RMSD between two structures.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Compute the optimal RMSD between two structures, with equal weights.
*> Coordinates are not changed, but the RMSD corresponds to the aligned structures.
*>
*> @param[in]  x    Cartesian coordinates of the first structure
*> @param[in]  y    Cartesian coordinates of the second structure
*> @param[in]  nAt  Number of atoms in the structures
*> @param[out] RMSD Minimum RMSD between the two structures
*>
*> @see ::Get_RMSD_w
************************************************************************
      SUBROUTINE Get_RMSD(x,y,nAt,RMSD)
      IMPLICIT NONE
#include "real.fh"
#include "stdalloc.fh"
      INTEGER nAt, iAt
      REAL*8 x(3,nAt), y(3,nAt), RMSD
      REAL*8, DIMENSION(:), ALLOCATABLE :: w
      CALL mma_allocate(w,nAt)
      DO iAt=1,nAt
        w(iAt)=One
      END DO
      CALL Get_RMSD_w(x,y,w,nAt,RMSD)
      CALL mma_deallocate(w)
      END
*
************************************************************************
*  Superpose_w
*
*> @brief
*>   Superpose two structures.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Superpose two structures, with weights.
*> The coordinates of the first structure are modified.
*>
*> @param[in,out]  x    Cartesian coordinates of the first structure
*> @param[in]      y    Cartesian coordinates of the second structure
*> @param[in]      w    Weights for each atom
*> @param[in]      nAt  Number of atoms in the structures
*> @param[out]     RMSD Weighted RMSD between the two final structures
*> @param[out]     RMax Maximum atom-wise (weighted) distance between the two structures
*>
*> @see ::Superpose
************************************************************************
      SUBROUTINE Superpose_w(x,y,w,nAt,RMSD,RMax)
      IMPLICIT NONE
#include "real.fh"
      INTEGER nAt, iAt
      REAL*8 x(3,nAt), y(3,nAt), w(nAt), RMSD, RMax, r2
      CALL get_rotation(x,y,w,nAt,RMSD,.TRUE.)
*---- Calculate the maximum weighted distance between atoms
*     (not sure what meaning it has with w!=1)
      RMax=Zero
      Do iAt=1,nAt
        r2=(x(1,iAt)-y(1,iAt))**2+
     &     (x(2,iAt)-y(2,iAt))**2+
     &     (x(3,iAt)-y(3,iAt))**2
        RMax=MAX(RMax,w(iAt)*r2)
      END DO
      RMax=SQRT(RMax)
      END
*
************************************************************************
*  Superpose_w
*
*> @brief
*>   Superpose two structures.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Superpose two structures, with equal weights.
*> The coordinates of the first structure are modified.
*>
*> @param[in,out]  x    Cartesian coordinates of the first structure
*> @param[in]      y    Cartesian coordinates of the second structure
*> @param[in]      nAt  Number of atoms in the structures
*> @param[out]     RMSD RMSD between the two final structures
*> @param[out]     RMax Maximum atom-wise distance between the two structures
*>
*> @see ::Superpose_w
************************************************************************
      SUBROUTINE Superpose(x,y,nAt,RMSD,RMax)
      IMPLICIT NONE
#include "real.fh"
#include "stdalloc.fh"
      INTEGER nAt, iAt
      REAL*8 x(3,nAt), y(3,nAt), RMSD, RMax
      REAL*8, DIMENSION(:), ALLOCATABLE :: w
      CALL mma_allocate(w,nAt)
      DO iAt=1,nAt
        w(iAt)=One
      END DO
      CALL Superpose_w(x,y,w,nAt,RMSD,RMax)
      CALL mma_deallocate(w)
      END
*
************************************************************************
*> @name Internal
*>
*> These procedures are probably not very useful outside the file.
*> @{
************************************************************************
*  get_rotation
*
*> @brief
*>   Compute the RMSD and superpose two structures.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Calculate the minimum weighted RMSD between two structures and, optionally,
*> rotate and translate the first one to be superposed onto the other.
*>
*> @param[in,out] x      Cartesian coordinates of the first structure
*> @param[in]     y      Cartesian coordinates of the second structure
*> @param[in]     w      Weights for each atom
*> @param[in]     nAt    Number of atoms in the structures
*> @param[out]    RMSD   Minimum weighted RMSD between the two final structures
*> @param[in]     rotate Flag for changing the coordinates or not
************************************************************************
      SUBROUTINE get_rotation(x,y,w,nAt,RMSD,rotate)
      IMPLICIT NONE
#include "real.fh"
#include "stdalloc.fh"
      INTEGER nAt, iAt, i
      REAL*8 x(3,nAt), y(3,nAt), w(nAt), RMSD,
     &       wTot, Gx, Gy, c_x(3), c_y(3), Mxy(3,3), Kxy(4,4), lambda,
     &       inner_prod, q(4), DDot_
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: xCen, yCen
      LOGICAL rotate
*---- if USE_QCD is defined, use the real QCD method, otherwise use conventional
*     method to locate the largest eigenvalue (may be more robust in some cases)
*define USE_QCD
#ifdef USE_QCD
      REAL*8 Poly(5)
#else
      REAL*8 wTmp(100)
#endif
      CALL mma_allocate(xCen,3,nAt)
      CALL mma_allocate(yCen,3,nAt)
*---- Center the two structures and calculate their inner products
      CALL center_mol(x,w,nAt,c_x,xCen)
      CALL center_mol(y,w,nAt,c_y,yCen)
      Gx=inner_prod(xCen,w,nAt)
      Gy=inner_prod(yCen,w,nAt)
      CALL inner_mat(xCen,yCen,w,nAt,Mxy)
*---- Find the largest eigenvalue (always lower or equal to (Gx+Gy)/2)
#ifdef USE_QCD
      CALL build_polynomial(Mxy,Poly)
      lambda=Half*(Gx+Gy)
      CALL find_lambda(Poly,lambda)
#else
      CALL build_K_matrix(Mxy,Kxy)
      i=0
      call dsyev_('N','U',4,Kxy,4,q,wTmp,100,i)
      lambda=q(4)
#endif
*---- Calculate the optimized RMSD value
      wTot=Zero
      DO iAt=1,nAt
        wTot=wTot+w(iAt)
      END DO
      RMSD=SQRT(ABS(Gx+Gy-Two*lambda)/wTot)
*---- The rotation is only performed if an actual superposition is requested
      IF (rotate) THEN
*----   The rotation quaternion is obtained as the eigenvector of K corresponding
*       to the eigenvalue lambda.
        CALL build_K_matrix(Mxy,Kxy)
        CALL get_eigenvector(Kxy,lambda,q)
*----   Apply the rotation to the first structure. Before rotation, the quaternion
*       must be normalized and the rotation inverted (change of sign in the 1st component)
        call dscal_(4,One/SQRT(DDot_(4,q,1,q,1)),q,1)
        q(1)=-q(1)
        CALL apply_rotation(xCen,nAt,q)
*----   Translate the structure to match the second (reference) one
        DO iAt=1,nAt
          DO i=1,3
            xCen(i,iAt)=xCen(i,iAt)+c_y(i)
          END DO
        END DO
*----   Copy the aligned structures back in the original matrices
        call dcopy_(3*nAt,xCen,1,x,1)
      END IF
      CALL mma_deallocate(xCen)
      CALL mma_deallocate(yCen)
      END
*
************************************************************************
*  center_mol
*
*> @brief
*>   Center a structure on its weighted geometric center.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Center a structure on its weighted geometric center.
*>
*> @param[in]  x    Cartesian coordinates of the structure
*> @param[in]  w    Weights for each atom
*> @param[in]  nAt  Number of atoms in the structures
*> @param[out] c    Weighted center
*> @param[out] xCen Centered Cartesian coordinates
************************************************************************
      SUBROUTINE center_mol(x,w,nAt,c,xCen)
      IMPLICIT NONE
#include "real.fh"
      INTEGER nAt, iAt, i
      REAL*8 x(3,nAt), w(nAt), c(3), xCen(3,nAt), wTot
*---- Compute the total weight
      wTot=Zero
      DO iAt=1,nAt
        wTot=wTot+w(iAt)
      END DO
      DO i=1,3
*----   Calculate the center in each dimension (x, y, z)
        c(i)=Zero
        DO iAt=1,nAt
          c(i)=c(i)+w(iAt)*x(i,iAt)
        END DO
        c(i)=c(i)/wTot
*----   Center the structure in each dimension
        DO iAt=1,nAt
          xCen(i,iAt)=x(i,iAt)-c(i)
        END DO
      END DO
      END
*
************************************************************************
*  inner_prod
*
*> @brief
*>   Calculate the inner product of a single structure.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Returns the inner product of the weighted coordinates of a single structure:
*>  \f[P = \sum_{i=1,N} w_i ( x_i^2 + y_i^2 + z_i^2 ) \f]
*>
*> @param[in] x   Cartesian coordinates of the structure
*> @param[in] w   Weights for each atom
*> @param[in] nAt Number of atoms in the structures
*>
*> @return The inner product \f$ P \f$
************************************************************************
      FUNCTION inner_prod(x,w,nAt)
      IMPLICIT NONE
#include "real.fh"
      INTEGER nAt, iAt
      REAL*8 inner_prod, x(3,nAt), w(nAt), r
      r=Zero
      DO iAt=1,nAt
        r=r+w(iAt)*(x(1,iAt)**2+x(2,iAt)**2+x(3,iAt)**2)
      END DO
      inner_prod=r
      END
*
************************************************************************
*  inner_mat
*
*> @brief
*>   Calculate the inner product matrix of two structures.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Calculate the inner product matrix of the weighted coordinates of two structures,
*> \f$ A, B \f$:
*>   \f[ M_{ij} = \sum_{k=1,N} w_i (A_i)_k (B_j)_k \quad i,j \in \{x, y, z\} \f]
*>
*> @param[in]  x   Cartesian coordinates of the first structure
*> @param[in]  y   Cartesian coordinates of the second structure
*> @param[in]  w   Weights for each atom
*> @param[in]  nAt Number of atoms in the structures
*> @param[out] M   Inner product matrix
************************************************************************
      SUBROUTINE inner_mat(x,y,w,nAt,M)
      IMPLICIT NONE
#include "real.fh"
      INTEGER nAt, iAt, i, j
      REAL*8 x(3,nAt), y(3,nAt), w(nAt), M(3,3)
      DO i=1,3
        DO j=1,3
          M(j,i)=Zero
          DO iAt=1,nAt
            M(j,i)=M(j,i)+w(iAt)*x(j,iAt)*y(i,iAt)
          END DO
        END DO
      END DO
      END
*
************************************************************************
*  build_K_matrix
*
*> @brief
*>   Build the key matrix \f$ K \f$ from the \f$ M \f$ matrix.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Build the key matrix \f$ K \f$ from the inner product matrix \f$ M \f$ matrix.
*>
*> @param[in]  M Inner product matrix
*> @param[out] K Key matrix \f$ K \f$
************************************************************************
      SUBROUTINE build_K_matrix(M,K)
      IMPLICIT NONE
      INTEGER i, j
      REAL*8 M(3,3), K(4,4)
*---- Compute the unique elements
      K(1,1)=M(1,1)+M(2,2)+M(3,3)
      K(1,2)=M(2,3)-M(3,2)
      K(1,3)=M(3,1)-M(1,3)
      K(1,4)=M(1,2)-M(2,1)
      K(2,2)=M(1,1)-M(2,2)-M(3,3)
      K(2,3)=M(1,2)+M(2,1)
      K(2,4)=M(1,3)+M(3,1)
      K(3,3)=M(2,2)-M(1,1)-M(3,3)
      K(3,4)=M(2,3)+M(3,2)
      K(4,4)=M(3,3)-M(1,1)-M(2,2)
*---- Make the matrix symmetric
      DO i=2,4
        DO j=1,i-1
          K(i,j)=K(j,i)
        END DO
      END DO
      END
*
************************************************************************
* build_polynomial
*
*> @brief
*>   Calculate the coefficients for the characteristic polynomial.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Calculate the coefficients for the characteristic polynomial of the \f$ K \f$
*> matrix directly from the elements of the \f$ M \f$ matrix.
*>
*> @param[in]  M Inner product matrix
*> @param[out] P The polynomial coefficients
************************************************************************
      SUBROUTINE build_polynomial(M,P)
      IMPLICIT NONE
#include "real.fh"
      REAL*8 M(3,3), P(5), a1, a2, a3, a4, a5, a6, DDot_, determinant3
*---- The x^4 and x^3 coefficients are constant
      P(5)=One
      P(4)=Zero
*---- The x^2 coefficient is the sum of all squared elements, times -2
      P(3)=-Two*DDot_(9,M,1,M,1)
*---- The x^1 coefficient is the determinant of M, times -8
      P(2)=-Eight*determinant3(M)
*---- The x^0 coefficient has a rather cumbersome expansion
      a1=(M(1,2)**2+M(1,3)**2-M(2,1)**2-M(3,1)**2)**2
      a2=(-M(1,1)**2+M(2,2)**2+M(3,3)**2+M(2,3)**2+M(3,2)**2-
     &    Two*(M(2,2)*M(3,3)-M(2,3)*M(3,2)))*
     &   (-M(1,1)**2+M(2,2)**2+M(3,3)**2+M(2,3)**2+M(3,2)**2+
     &    Two*(M(2,2)*M(3,3)-M(2,3)*M(3,2)))
      a3=(-(M(1,3)+M(3,1))*(M(2,3)-M(3,2))+
     &     (M(1,2)-M(2,1))*(M(1,1)-M(2,2)-M(3,3)))*
     &   (-(M(1,3)-M(3,1))*(M(2,3)+M(3,2))+
     &     (M(1,2)-M(2,1))*(M(1,1)-M(2,2)+M(3,3)))
      a4=(-(M(1,3)+M(3,1))*(M(2,3)+M(3,2))-
     &     (M(1,2)+M(2,1))*(M(1,1)+M(2,2)-M(3,3)))*
     &   (-(M(1,3)-M(3,1))*(M(2,3)-M(3,2))-
     &     (M(1,2)+M(2,1))*(M(1,1)+M(2,2)+M(3,3)))
      a5=( (M(1,2)+M(2,1))*(M(2,3)+M(3,2))+
     &     (M(1,3)+M(3,1))*(M(1,1)-M(2,2)+M(3,3)))*
     &   (-(M(1,2)-M(2,1))*(M(2,3)-M(3,2))+
     &     (M(1,3)+M(3,1))*(M(1,1)+M(2,2)+M(3,3)))
      a6=( (M(1,2)+M(2,1))*(M(2,3)-M(3,2))+
     &     (M(1,3)-M(3,1))*(M(1,1)-M(2,2)-M(3,3)))*
     &   (-(M(1,2)-M(2,1))*(M(2,3)+M(3,2))+
     &     (M(1,3)-M(3,1))*(M(1,1)+M(2,2)-M(3,3)))
      P(1)=a1+a2+a3+a4+a5+a6
      END
*
************************************************************************
*  find_lambda
*
*> @brief
*>   Find one root of a 4th degree polynomial.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Find one real root of a 4th degree polynomial using the Newton--Raphson method.
*> On input, the variable \p r contains the initial guess for the root.
*>
*> @param[in]     P The polynomial coefficients
*> @param[in,out] r The found root (initial guess on input)
************************************************************************
      SUBROUTINE find_lambda(P,r)
      IMPLICIT NONE
#include "real.fh"
      REAL*8 P(5), r, thr, thrr, r_old, f, df
      INTEGER loop, mxloop, j
      PARAMETER ( thr=1.0D-11, mxloop=100 )
      r_old=MAX(Two*r,Ten)
*---- Find the root with the Newton-Raphson method, starting from the initial value
      loop=0
      thrr=thr*r
      DO WHILE ((ABS(r-r_old).GT.thrr).AND.(loop.LT.mxloop))
        r_old=r
*----   Compute the values of the polynomial (f) and its derivative (df)
*       at the current value of r
        f=P(5)
        df=Zero
        DO j=4,1,-1
          df=df*r+f
          f=f*r+P(j)
        END DO
*----   Update the value of r from the values of f and df
*       (special case if the derivative is zero)
        IF (ABS(df).LT.thrr) THEN
          IF (ABS(f).LT.thr) THEN
            r_old=r
          ELSE
*---        If the df is zero and r is not a root, we are in trouble,
*           just move the point a tad
            r=r-SIGN(Two*thrr,f)
          END IF
        ELSE
          r=r-f/df
        END IF
        thrr=thr*r
*----   Increase count to avoid neverending loop
        loop=loop+1
      END DO
      END
*
************************************************************************
*  get_eigenvector
*
*> @brief
*>   Find an eigenvector of the \f$ K \f$ matrix, given its eigenvalue.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Compute the eigenvector of the \f$ K \f$ matrix corresponding to one eigenvalue.
*> @side_effects
*> The matrix \p K is destroyed on output.
*>
*> @param[in]  K The \f$ K \f$ matrix
*> @param[in]  r The eigenvalue
*> @param[out] V The eigenvector
************************************************************************
      SUBROUTINE get_eigenvector(K,r,V)
      IMPLICIT NONE
#include "real.fh"
      REAL*8 K(4,4), r, V(4), n, thr, DDot_, cofactor
      INTEGER i, j
      PARAMETER ( thr=1.0D-12 )
*---- Get the matrix K-rI
      K(1,1)=K(1,1)-r
      K(2,2)=K(2,2)-r
      K(3,3)=K(3,3)-r
      K(4,4)=K(4,4)-r
*---- Find the eigenvector as any non-zero column of adj(K-rI)
      n=Zero
      DO j=1,4
        IF (n.LT.thr) THEN
*----     Since adj(X) is the transpose of the cofactors matrix, we take a row from K
          DO i=1,4
            V(i)=cofactor(K,j,i)
          END DO
*----     Get the norm of the vector, if not too small, no further vector will be computed
          n=DDot_(4,V,1,V,1)
        END IF
      END DO
*---- If the norm is still too small, return the identity quaternion (no rotation)
      IF (n.LT.thr) THEN
        V(1)=One
        V(2)=Zero
        V(3)=Zero
        V(4)=Zero
      END IF
      END
*
************************************************************************
*  cofactor
*
*> @brief
*>   Return a cofactor from a 4&times;4 matrix.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Returns a cofactor (determinant of a submatrix) from a 4&times;4 matrix.
*>
*> @param[in] M The matrix
*> @param[in] i The row of the cofactor
*> @param[in] j The column of the cofactor
*>
*> @return The \f$ C_{ij} \f$ cofactor of the matrix \p M
************************************************************************
      FUNCTION cofactor(M,i,j)
      IMPLICIT NONE
#include "real.fh"
      REAL*8 cofactor, M(4,4), A(3,3), f, determinant3
      INTEGER i, j, ii, jj
*---- Get the submatrix as four blocks, depending on whether the indices are
*     greater or smaller than the element position
      DO ii=1,i-1
        DO jj=1,j-1
          A(ii,jj)=M(ii,jj)
        END DO
      END DO
      DO ii=1,i-1
        DO jj=j+1,4
          A(ii,jj-1)=M(ii,jj)
        END DO
      END DO
      DO ii=i+1,4
        DO jj=1,j-1
          A(ii-1,jj)=M(ii,jj)
        END DO
      END DO
      DO ii=i+1,4
        DO jj=j+1,4
          A(ii-1,jj-1)=M(ii,jj)
        END DO
      END DO
*---- The cofactor is +1/-1 times the determinant of the submatrix
      f=(-One)**(i+j)
      cofactor=f*determinant3(A)
      END
*
************************************************************************
*  determinant3
*
*> @brief
*>   Return the determinant of a 3&times;3 matrix.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Returns the determinant of a 3&times;3 matrix.
*>
*> @param[in] M The matrix
*>
*> @return The determinant of \p M
************************************************************************
      FUNCTION determinant3(M)
      IMPLICIT NONE
      REAL*8 determinant3, M(3,3)
      determinant3=(M(1,1)*M(2,2)*M(3,3)+
     &              M(1,2)*M(2,3)*M(3,1)+
     &              M(1,3)*M(2,1)*M(3,2))-
     &             (M(1,1)*M(2,3)*M(3,2)+
     &              M(1,2)*M(2,1)*M(3,3)+
     &              M(1,3)*M(2,2)*M(3,1))
      END
*
************************************************************************
*  apply_rotation
*
*> @brief
*>   Rotate a structure with a quaternion.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Apply a rotation, given by a unit quaternion, to all atoms in a structure.
*>
*> @param[in, out] x   Cartesian coordinates of the structure
*> @param[in]      nAt Number of atoms in the structure
*> @param[in]      q   A unit quaternion representing a rotation
************************************************************************
      SUBROUTINE apply_rotation(x,nAt,q)
      IMPLICIT NONE
#include "real.fh"
      INTEGER nAt, iAt, i
      REAL*8 x(3,nAt), q(4), MRot(3,3), v(3), DDot_
*---- Compute the rotation matrix from the quaternion
*     (transposed or not, that depends on the rotation direction
*      and storage order... this version seems to work)
      MRot(1,1)=q(1)**2+q(2)**2-q(3)**2-q(4)**2
      MRot(2,2)=q(1)**2-q(2)**2+q(3)**2-q(4)**2
      MRot(3,3)=q(1)**2-q(2)**2-q(3)**2+q(4)**2
      MRot(2,1)=Two*(q(2)*q(3)+q(1)*q(4))
      MRot(1,2)=Two*(q(2)*q(3)-q(1)*q(4))
      MRot(3,2)=Two*(q(3)*q(4)+q(1)*q(2))
      MRot(2,3)=Two*(q(3)*q(4)-q(1)*q(2))
      MRot(1,3)=Two*(q(2)*q(4)+q(1)*q(3))
      MRot(3,1)=Two*(q(2)*q(4)-q(1)*q(3))
*---- Apply the matrix to every atom in the structure
      DO iAt=1,nAt
        DO i=1,3
          v(i)=DDot_(3,MRot(1,i),1,x(1,iAt),1)
        END DO
        call dcopy_(3,v,1,x(1,iAt),1)
      END DO
      END
************************************************************************
*> @}
************************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************
Module ChoMP2
Implicit none
Private
Public:: Pointer_2D
Public:: ChoMP2_allocated, ChoMP2g_allocated, OldVec, EFrozT, EOccuT, EVirtT
Public:: AdrR1, AdrR2
Public:: MP2W_full, MP2W
Public:: MP2D_full, MP2D
Public:: MP2W_e_full, MP2W_e
Public:: MP2D_e_full, MP2D_e

Public:: iFirst, iFirstS, NumOcc, LnOcc, LnT1am, LiT1am, LnMatij, LiMatij
Public:: lUnit, NumBatOrb, LnBatOrb
Public:: LnPQprod, LiPQprod

Logical:: ChoMP2_allocated=.FALSE.
Logical:: ChoMP2g_allocated=.FALSE.
Real*8, Allocatable:: OldVec(:)

Type Pointer_2D
     Real*8, Pointer:: A(:,:)=>Null()
End Type Pointer_2D

Real*8, Allocatable, Target:: MP2D_full(:)
Type (Pointer_2D):: MP2D(8)
Real*8, Allocatable, Target:: MP2W_full(:)
Type (Pointer_2D):: MP2W(8)
Real*8, Allocatable, Target:: MP2D_e_full(:)
Type (Pointer_2D):: MP2D_e(8)
Real*8, Allocatable, Target:: MP2W_e_full(:)
Type (Pointer_2D):: MP2W_e(8)

Real*8, Allocatable:: EFrozT(:)
Real*8, Allocatable:: EOccuT(:)
Real*8, Allocatable:: EVirtT(:)

Integer, Allocatable:: AdrR1(:,:,:), AdrR2(:,:,:)

Integer, Allocatable:: iFirst(:), iFirstS(:,:), NumOcc(:), LnOcc(:,:)
Integer, Allocatable:: LnT1am(:,:), LiT1am(:,:,:)
Integer, Allocatable:: LnMatij(:,:), LiMatij(:,:,:)
Integer, Allocatable:: lUnit(:,:)
Integer, Allocatable:: NumBatOrb(:), LnBatOrb(:,:)
Integer, Allocatable:: LnPQprod(:,:), LiPQprod(:,:,:)
End Module ChoMP2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE SPEC1C(IFC,FACT,ISYM,X,Y)
      USE SUPERINDEX
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
      INTEGER IFC,ISYM
      REAL*8 FACT,X(*),Y(*)
      INTEGER NAS,NT,NA,IT,ITQ,IUQ,ITUU
C If IFC=0, compute
C X(tuu,a) <- X(tuu,a)+FACT*Y(t,a), else
C the conjugate expression (summing into Y, values from X).

      NAS=NTUV(ISYM)
      NT=NASH(ISYM)
      NA=NSSH(ISYM)
      DO 10 IT=1,NT
        ITQ=IT+NAES(ISYM)
        DO 11 IUQ=1,NASHT
          ITUU=KTUV(ITQ,IUQ,IUQ)-NTUVES(ISYM)
          IF(IFC.EQ.0) THEN
            CALL DAXPY_(NA,FACT,Y(IT),NT,X(ITUU),NAS)
          ELSE
            CALL DAXPY_(NA,FACT,X(ITUU),NAS,Y(IT),NT)
          END IF
  11    CONTINUE
  10  CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine schmidtn2_cvb(c,sxc,nvec,sao,n,metr)

use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nvec, n, metr
real(kind=wp), intent(inout) :: c(n,nvec), sxc(n,nvec)
real(kind=wp), intent(in) :: sao(*)
integer(kind=iwp) :: i, j
real(kind=wp) :: cnrm, fac
real(kind=wp), parameter :: thresh = 1.0e-20_wp
real(kind=wp), external :: ddot_

do i=1,nvec
  do j=1,i-1
    c(:,i) = c(:,i)-ddot_(n,c(:,i),1,sxc(:,j),1)*c(:,j)
  end do
  if (metr /= 0) call saoon_cvb(c(:,i),sxc(:,i),1,sao,n,metr)
  cnrm = ddot_(n,c(:,i),1,sxc(:,i),1)
  if (cnrm < thresh) then
    write(u6,*) ' Warning : near-singularity in orthonormalization.'
    write(u6,*) ' Vector norm :',cnrm
  end if
  fac = One/sqrt(cnrm)
  c(:,i) = fac*c(:,i)
  if (metr /= 0) sxc(:,i) = fac*sxc(:,i)
end do

return

end subroutine schmidtn2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine report_cvb(orbs,norb)
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
      dimension orbs(norb,norb)

      write(6,'(/,a)')' Orbital coefficients :'
      write(6,'(a)')' ----------------------'
      call mxprint_cvb(orbs,norb,norb,0)
      write(6,'(/,a)')' Overlap between orbitals :'
      write(6,'(a)')' --------------------------'

      i1 = mstackr_cvb(norb*norb)
      call mxattb_cvb(orbs,orbs,norb,norb,norb,work(i1))
      call mxprint_cvb(work(i1),norb,norb,0)
      call mfreer_cvb(i1)
      return
      end
c  ****************************
c  ** Matrix multiplications **
c  ****************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE AB_MRCI(ICSPCK,INTSYM,INDX,C,S,FC,A,B,FK)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION ICSPCK(*),INTSYM(*),INDX(*),
     *          C(*),S(*),FC(*),A(*),B(*),
     *          FK(*)
      DIMENSION IPOA(9),IPOF(9)
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CPAM96      JSYM(L)=UNPACK(INTSYM((L+9)/10),3*MOD(L-1,10)+1,3)+1
      JSYM(L)=JSUNP(INTSYM,L)
      CALL CSCALE(INDX,INTSYM,C,SQ2)
      CALL CSCALE(INDX,INTSYM,S,SQ2INV)
      NCLIM=4
      IF(IFIRST.NE.0)NCLIM=2
C MOVE FOCK MATRIX TO FK IN SYMMETRY BLOCKS
      CALL IPO(IPOF,NVIR,MUL,NSYM,1,-1)
      DO 10 IASYM=1,NSYM
        IAB=IPOF(IASYM)
        NA1=NVIRP(IASYM)+1
        NA2=NVIRP(IASYM)+NVIR(IASYM)
        DO 15 NA=NA1,NA2
          DO 20 NB=NA1,NA2
            IAB=IAB+1
            NAB=IROW(LN+NA)+LN+NB
            IF(NB.GT.NA)NAB=IROW(LN+NB)+LN+NA
            FK(IAB)=FC(NAB)
            IF(NA.EQ.NB)FK(IAB)=0.0D00
20        CONTINUE
15      CONTINUE
10    CONTINUE
      ITAIL=IRC(NCLIM)
      DO 40 INDA=1,ITAIL
      IF(INDA.LE.IRC(1))GO TO 40
      MYSYM=JSYM(INDA)
      MYL=MUL(MYSYM,LSYM)
      INMY=INDX(INDA)+1
      IF(INDA.GT.IRC(2))GO TO 25
C DOUBLET-DOUBLET INTERACTIONS
      IF(NVIR(MYL).NE.0) THEN
        CALL FZERO(A,NVIR(MYL))
        CALL FMMM(FK(IPOF(MYL)+1),C(INMY),A,NVIR(MYL),1,NVIR(MYL))
        CALL DAXPY_(NVIR(MYL),1.0D00,A,1,S(INMY),1)
      END IF
      GO TO 40
C TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
25    IFT=1
      IF(INDA.GT.IRC(3))IFT=0
      CALL IPO(IPOA,NVIR,MUL,NSYM,MYL,IFT)
CPAM97      IN=0
CPAM97      TSUM=0.0D00
      DO 70 IASYM=1,NSYM
      IAB=IPOF(IASYM+1)-IPOF(IASYM)
      IF(IAB.EQ.0)GO TO 70
      ICSYM=MUL(MYL,IASYM)
      IF(NVIR(ICSYM).EQ.0)GO TO 70
      IF(MYL.NE.1)GO TO 30
      IF(IFT.EQ.0)CALL SQUAR(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      IF(IFT.EQ.1)CALL SQUARM(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      NAA=NVIR(IASYM)*NVIR(IASYM)
      CALL FZERO(B,NAA)
      CALL FMMM(FK(IPOF(IASYM)+1),A,B,NVIR(IASYM),NVIR(IASYM),
     *NVIR(IASYM))
      CALL FZERO(A,NAA)
      CALL DAXPY_(NAA,1.0D00,B,1,A,1)
      IF(IFT.EQ.1)GO TO 230
      CALL SIADD(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
      CALL FZERO(A,NAA)
      GO TO 70
230   CALL TRADD(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
      CALL FZERO(A,NAA)
      GO TO 70
30    NAC=NVIR(IASYM)*NVIR(ICSYM)
      CALL FZERO(A,NAC)
      IF(IASYM.GT.ICSYM)GO TO 31
      CALL FMMM(FK(IPOF(IASYM)+1),C(INMY+IPOA(ICSYM)),A,
     *NVIR(IASYM),NVIR(ICSYM),NVIR(IASYM))
      CALL DAXPY_(NAC,1.0D00,A,1,S(INMY+IPOA(ICSYM)),1)
      GO TO 70
31    CALL FMMM(C(INMY+IPOA(IASYM)),FK(IPOF(IASYM)+1),A,
     *NVIR(ICSYM),NVIR(IASYM),NVIR(IASYM))
      CALL DAXPY_(NAC,1.0D00,A,1,S(INMY+IPOA(IASYM)),1)
      GO TO 70
70    CONTINUE
40    CONTINUE
      CALL CSCALE(INDX,INTSYM,C,SQ2INV)
      CALL CSCALE(INDX,INTSYM,S,SQ2)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer_array(ICSPCK)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine TermCho_RI(irc,nVec_RI,l_nVec_RI)
      Implicit None
      Integer irc, l_nVec_RI
      Integer nVec_RI(l_nVec_RI) ! #RI vectors per irrep on this node

      irc = 0

C     Save number of vectors and other info on runfile.
C     -------------------------------------------------

      Call Cho_Final(.False.)
      Call Cho_RI_Final(irc,nVec_RI,l_nVec_RI)
      If (irc .ne. 0) Return

C     Close storage files.
C     --------------------

      Call Cho_P_OpenVR(2)

C     Deallocate index arrays.
C     ------------------------

      Call Cho_X_Dealloc(irc)
      If (irc .ne. 0) Return

C     More deallocations.
C     -------------------

      Call Cho_RI_XFree()

      End
      SubRoutine Cho_RI_XFree()
      Implicit None
#include "choptr2.fh"

      If (l_mySP .gt. 0) Then
         Call GetMem('mySP','Free','Inte',ip_mySP,l_mySP)
      End If

      End
      SubRoutine Cho_RI_Final(irc,nVec_RI,l_nVec_RI)
      Implicit None
      Integer irc, l_nVec_RI
      Integer nVec_RI(l_nVec_RI)
#include "cholesky.fh"

      If (l_nVec_RI .lt. nSym) Then
         irc = 1
         Return
      Else
         irc = 0
         Call Put_iArray('nVec_RI',nVec_RI,nSym)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine creqadd2(q,G2,idSym,MO,Scr,n2)
! Constructs the Q matrix

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use MCLR_Data, only: ipMat, nA, nDens, nNA
use input_mclr, only: nAsh, nIsh, nOrb, nSym
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Q(nDens)
real(kind=wp), intent(in) :: G2(*)
integer(kind=iwp), intent(in) :: idSym, n2
real(kind=wp), intent(out) :: MO(n2), Scr(n2)
integer(kind=iwp) :: iAA, iAsh, iij, ijS, ikl, ipG, ipM, ipQ, ipS, iS, jAsh, jS, kAA, kAsh, kS, lAA, lAsh, lS
real(kind=wp) :: P_ijkl

!                                                                      *
!***********************************************************************
!                                                                      *
! Q = (pj|kl)P
!  pi         ijkl
!                                                                      *
!***********************************************************************
!                                                                      *
do iS=1,nSym
  ipS = Mul(is,idsym)
  if (norb(ips) /= 0) then
    do jS=1,nsym
      ijS = Mul(is,js)
      do kS=1,nSym
        ls = Mul(ijs,Mul(ks,idsym))
        !                                                              *
        !***************************************************************
        !                                                              *
        do kAsh=1,nAsh(kS)
          kAA = kAsh+nIsh(kS)
          do lAsh=1,nAsh(lS)
            lAA = lAsh+nIsh(lS)
            ikl = nna*(lAsh+nA(lS)-1)+kAsh+nA(kS)

            ! Pick up (pj|kl)

            call Coul(ipS,jS,kS,lS,kAA,lAA,MO,Scr)

            do iAsh=1,nAsh(iS)
              iAA = iAsh+nIsh(iS)
              ipQ = ipMat(ipS,iS)+nOrb(ipS)*(iAA-1)
              ipM = 1+nIsh(jS)*nOrb(ipS)
              do jAsh=1,nAsh(jS)
                iij = nna*(iAsh+nA(iS)-1)+jAsh+nA(jS)
                ipG = iTri(iij,ikl)
                P_ijkl = G2(ipG)

                Q(ipQ:ipQ+nOrb(ipS)-1) = Q(ipQ:ipQ+nOrb(ipS)-1)+P_ijkl*MO(ipM:ipM+nOrb(ipS)-1)
                ipM = ipM+nOrb(ipS)

              end do
            end do

          end do
        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      end do  ! kS
    end do    ! jS
  end if
end do        ! iS
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine creqadd2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine scalstruc2_cvb(orbs,cvb,iconfs,ifnss)

use casvb_global, only: i2s_fr, nconf, nconfion_fr, nel, nfrag, noe, norb, nS_fr, nvb, sc
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: orbs(norb,norb)
real(kind=wp), intent(inout) :: cvb(nvb)
integer(kind=iwp), intent(in) :: iconfs(noe,nconf), ifnss(0:nel,0:nel)
integer(kind=iwp) :: i, iconf_off, ifrag, ion, iorb, iS, istr, nelsing, nss
real(kind=wp) :: fac, fac1, fac2
real(kind=wp), external :: ddot_

if (sc) then
  fac = One
  do iorb=1,norb
    fac2 = ddot_(norb,orbs(:,iorb),1,orbs(:,iorb),1)
    fac = fac*sqrt(fac2)
  end do
  cvb(:) = fac*cvb(:)
else
  do iorb=1,norb
    fac2 = ddot_(norb,orbs(:,iorb),1,orbs(:,iorb),1)
    fac1 = sqrt(fac2)
    istr = 0
    iconf_off = 0
    do ifrag=1,nfrag
      do iS=1,nS_fr(ifrag)
        do ion=0,nel/2
          nelsing = nel-2*ion
          nss = ifnss(nelsing,i2s_fr(iS,ifrag))
          do i=iconf_off+1,iconf_off+nconfion_fr(ion,ifrag)
            if (iconfs(iorb,i) == 1) then
              cvb(istr+1:istr+nss) = fac1*cvb(istr+1:istr+nss)
            else if (iconfs(iorb,i) == 2) then
              cvb(istr+1:istr+nss) = fac2*cvb(istr+1:istr+nss)
            end if
            istr = istr+nss
          end do
          iconf_off = iconf_off+nconfion_fr(ion,ifrag)
        end do
      end do
    end do
    if (istr /= nvb) then
      write(u6,*) ' ISTR not equal to NVB in SCALSTRUC! ',istr,nvb
      call abend_cvb()
    end if
  end do
end if

return

end subroutine scalstruc2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_dEnergy(Energy)

use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Energy
logical(kind=iwp) :: Found_EAV

Found_EAV = .false.
call Qpg_dScalar('Average energy',Found_EAV)

if (Found_EAV) then
  call Get_dScalar('Average energy',Energy)
else
  call Get_dScalar('Last energy',Energy)
end if

return

end subroutine Get_dEnergy

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
*               2009, Grigory A. Shamov                                *
************************************************************************
      Subroutine xB86(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object: Becke86 exchange functional, from Appendix of Becke's B07 ref*
*        Becke, Johnson, J.Chem.Phys 127, 124108 (2007)                *
*        derived with Maxima                                           *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author:template by Per Ake Malmqvist,                           *
*             University of Lund, SWEDEN. June 2006                    *
*             Grigory A Shamov, U of Manitoba, winter 2009             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)

* IDORD=Order of derivatives to request from XPBE:
      idord=1
*
      Rho_Min=T_X*1.0D-2
*
      if (ispin.eq.1) then
* ispin=1 means spin zero.

* T_X: Screening threshold of total density.
        Ta=0.5D0*T_X
        do iGrid=1,mgrid
         rhoa=rho(ipR,iGrid)
         if(rhoa.lt.Ta) goto 110
         grdrhoa_x=rho(ipdRx,iGrid)
         grdrhoa_y=rho(ipdRy,iGrid)
         grdrhoa_z=rho(ipdRz,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2

         call xB86_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*(2.0D0*Fa)
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*dFdrhoa
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*dFdgammaaa
* Note: For xpbe, dFdgammaab is zero.
 110     continue
        end do

      else
* ispin .ne. 1, use both alpha and beta components.

        do iGrid=1,mgrid
         rhoa=Max(Rho_Min,rho(ipRa,iGrid))
         rhob=Max(Rho_Min,rho(ipRb,iGrid))
         rho_tot=rhoa+rhob
         if(rho_tot.lt.T_X) goto 210
         grdrhoa_x=rho(ipdRxa,iGrid)
         grdrhoa_y=rho(ipdRya,iGrid)
         grdrhoa_z=rho(ipdRza,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         call xB86_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)

         grdrhob_x=rho(ipdRxb,iGrid)
         grdrhob_y=rho(ipdRyb,iGrid)
         grdrhob_z=rho(ipdRzb,iGrid)
         sigmabb=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
         call xB86_(idord,rhob,sigmabb,Fb,dFdrhob,dFdgammabb,
     &          d2Fdrb2,d2Fdrbdgbb,d2Fdgbb2)

         F_xc(iGrid)=F_xc(iGrid)+Coeff*(Fa+Fb)
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+Coeff*dFdrhoa
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+Coeff*dFdrhob
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
* Note: For xpbe, dFdgammaab is zero.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*dFdgammaaa
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*dFdgammabb
 210     continue
        end do

      end if

      Return
      End

      subroutine xB86_(idord,rho_s,gamma_s,B88,dB88dr,dB88dg,d2B88dr2,
     &                d2B88drdg,d2B88dg2)
      implicit real*8 (a-h,o-z)
      parameter(third=1.0d0/3.0d0)
      parameter(four3=4.0d0/3.0d0)
      parameter(seven3=7.0d0/3.0d0)
      parameter(b=0.0036d0)
      parameter(g=0.0040d0)

C     parameter(xldacff=0.930525736349100025D0)

      rho=rho_s+1.0D-16
      gamma=gamma_s+1.0D-16

      r43 = rho**four3
      rhoinv=1.0d0/rho
* lda part:
C     xlda=-xldacff*r43
* Note: Use x=sqrt(gamma)/rho**four3
      x = sqrt(gamma_s)/r43


      gx2=g*x*x + 1

      B88 = -b*gamma/(g*gamma/r43 + r43)

      if(idord.lt.1) goto 99

      temp1=g*gamma/rho**(8.0E+0/3.0E+0)+1

      dB88dr = 4.0E+0*b*gamma/(3.0E+0*rho**(7.0E+0/3.0E+0)*temp1)+
     1 (-8.0E+0)*b*g*gamma**2/(3.0E+0*rho**5*temp1**2)

      temp1=g*gamma/rho**(8.0E+0/3.0E+0)+1

      dB88dg = b*g*gamma/(rho**4*temp1**2) -
     1 b/(rho**(4.0E+0/3.0E+0)*temp1)

      if(idord.lt.2) goto 99

      T1=g**2
      T2=g*gamma/rho**(8.d+0/3.d+0)+1
      T3=1/T2**3
      T4=gamma**2
      T5=1/T2**2
      T6=1/T2

      d2B88Dr2 = (-2.799999
     2   9999999997d+1)*b*gamma*T6/(9.d+0*rho**(1.d+1/3.d+0))+1.52d+2*b*
     3   g*T4*T5/(9.d+0*rho**6)+(-1.28d+2)*b*T1*gamma**3*T3/(9.d+0*rho**
     4   (2.6d+1/3.d+0))

      d2B88DrDg = 4.d+0*b*T6/(3.d+0*rho**(7.d+0/3.d+0
     5   ))+(-2.d+1)*b*g*gamma*T5/(3.d+0*rho**5)+1.6d+1*b*T1*T4*T3/(3.d+
     6   0*rho**(2.2999999999999998d+1/3.d+0))

      d2B88Dg2 = 2*b*g*T5/rho**4
     7   -2*b*T1*gamma*T3/rho**(2.d+1/3.d+0)


  99  continue

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine CalcbP(bP,CSFOK,LOK,R)

use ipPage, only: W
use MCLR_Data, only: ipCI, IRLXROOT, nConf1
use input_mclr, only: nRoots
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: bP(nConf1,nRoots)
real(kind=wp), intent(in) :: CSFOK(nConf1,nRoots), LOK(nRoots,nRoots), R(nRoots,nRoots)
integer(kind=iwp) :: I, K, L

bP(:,:) = CSFOK(:,:)
I = irlxroot
do K=1,nRoots
  do L=1,nRoots
    bP(:,K) = bP(:,K)-LOK(L,K)*W(ipci)%A((L-1)*nConf1+1:L*nConf1)
  end do

  bP(:,K) = Two*R(K,I)**2*bP(:,K)

end do

end subroutine CalcbP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
*  Cho_X_Bookmark
*
*> @brief
*>   Get number of Cholesky vectors needed to achieve a given integral target accuracy \p Thr
*> @author Thomas Bondo Pedersen, August 2012
*>
*> @details
*> Return number of Cholesky vectors in each symmetry block needed to
*> achieve an integral accuracy of \p Thr (&le; decomposition threshold).
*> The actual integral accuracy in each symmetry block is returned in
*> array \p delta (for 1C-CD, the accuracy is judged by 1-center
*> diagonal elements only!). Note that \p mSym may be smaller than \p nSym
*> (so that one may find a bookmark in irrep 1 only, for example).
*> Available for full CD and 1C-CD, but *not RI*.
*>
*> On exit, return codes signify:
*>
*> - \p irc = ``-1``: bookmarks not available
*> - \p irc =  ``0``: all OK
*> - \p irc =  ``1``: illegal input
*>
*> @param[in]  Thr   Target integral accuracy
*> @param[in]  mSym  Number of irreps
*> @param[out] nVec  Number of Cholesky vectors
*> @param[out] delta Actual integral accuracy
*> @param[out] irc   Return code
************************************************************************
      Subroutine Cho_X_Bookmark(Thr,mSym,nVec,delta,irc)
      Implicit None
      Real*8  Thr
      Integer mSym
      Integer nVec(mSym)
      Real*8  delta(mSym)
      Integer irc
#include "cho_para_info.fh"
#include "chobkm.fh"
#include "cholesky.fh"
#include "WrkSpc.fh"

      Character*14 SecNam
      Parameter (SecNam='Cho_X_Bookmark')

      Logical Found
      Logical DebugPrint
      Parameter (DebugPrint=.False.)

      Integer iSym
      Integer iRS
      Integer ip
      Integer l
      Integer n

      Integer i, j
      Integer nV
      Real*8  del
      nV(i,j)=iWork(ip_BkmVec-1+nRow_BkmVec*(j-1)+i)
      del(i,j)=Work(ip_BkmThr-1+nRow_BkmThr*(j-1)+i)

C     Set return code.
C     ----------------

      irc=0

C     Check that bookmarks are available.
C     -----------------------------------

      If (l_BkmVec.lt.1 .or. l_BkmThr.lt.1) Then
         irc=-1
         Return
      End If

C     Check input.
C     ------------

      If (sign(1.0d0,Thr).lt.0.0d0 .or. Thr.lt.ThrCom .or.
     &    mSym.lt.1 .or. mSym.gt.nSym) Then
         irc=1
         Return
      End If

C     Debug print.
C     ------------

      If (DebugPrint) Then
         Call Cho_Head(SecNam//': Bookmarks (nVec,delta)','-',80,6)
         Do iSym=1,nSym
            Write(6,'(A,I2,A)') 'Symmetry block',iSym,
     &                          ' Bookmarks (nVec,delta)'
            Write(6,'(5(1X,A,I6,A,D15.8,A))')
     &      ('(',nV(iRS,iSym),',',del(iRS,iSym),')',iRS=1,nRow_BkmThr)
         End Do
      End If

C     Find largest accuracy below Thr.
C     --------------------------------

      Do iSym=1,mSym
         iRS=0
         Found=.False.
         Do While (iRS.lt.nRow_BkmThr .and. .not.Found)
            iRS=iRS+1
            Found=del(iRS,iSym).le.Thr
         End Do
         If (.not.Found) Then
            Call Cho_Quit('Bug detected in '//SecNam,104)
         Else
            nVec(iSym)=nV(iRS,iSym)
            delta(iSym)=del(iRS,iSym)
         End If
      End Do

      ! Parallel run: take into account the distribution of vectors
      ! across nodes. Set nVec to the number of vectors needed on this
      ! node (process).
      If (Cho_Real_Par) Then
         l=nVec(1)
         Do iSym=2,mSym
            l=max(l,nVec(iSym))
         End Do
         Call GetMem('BkmScr','Allo','Inte',ip,l)
         Do iSym=1,mSym
            Call Cho_P_Distrib_Vec(1,nVec(iSym),iWork(ip),n)
            nVec(iSym)=n
         End Do
         Call GetMem('BkmScr','Free','Inte',ip,l)
      End If

#if defined (_DEBUGPRINT_)
      ! Self test
      Do iSym=1,mSym
         If (nVec(iSym).gt.NumCho(iSym)) Then
            Call Cho_Quit('Error in '//SecNam,104)
         End If
      End Do
#endif

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETMAXSHL(DIASH,SMAX,ISHLAB)
C
C     Purpose: Get max. shell pair and update DIASH.
C
      IMPLICIT NONE
      REAL*8  DIASH(*)
      REAL*8  SMAX
      INTEGER ISHLAB
#include "cholesky.fh"

      INTEGER JSHLAB

      CHARACTER*13 SECNAM
      PARAMETER (SECNAM = 'CHO_GETMAXSHL')

      SMAX   = -1.0D9
      ISHLAB = -1
      DO JSHLAB = 1,NNSHL
         IF (DIASH(JSHLAB) .GT. SMAX) THEN
            SMAX   = DIASH(JSHLAB)
            ISHLAB = JSHLAB
         END IF
      END DO

      IF (ISHLAB .LT. 1) THEN
         CALL CHO_QUIT('Error in '//SECNAM,104)
      ELSE
         DIASH(ISHLAB) = 0.0D0
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine cp_SpcInt
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Character*14  qLbl,filnam*16
      Logical Exist
*     Write (*,*) ' Copy files'
*
*.... Copy file SPCINX to SPCIN1
*
      filnam='SPCINX'
      Call f_Inquire(filnam,Exist)
      If (Exist) Then
      LuTmp1=11
      LuTmp2=12
      call molcas_binaryopen_vanilla(luTmp1,filnam)
c      Open(luTmp1,File=filnam,Form='unformatted',Status='unknown')
      filnam='SPCIN1'
      call molcas_binaryopen_vanilla(luTmp2,filnam)
c      Open(luTmp2,File=filnam,Form='unformatted',Status='unknown')
      ReWind (LuTmp1)
      ReWind (LuTmp2)
*
      Read (LuTmp1) nq,nQQ
      Write(LuTmp2) nq,nQQ
      Call GetMem('Temp_rK','Allo','Real',ipTmp,nQQ)
      Do iq = 1, nq
         Read (LuTmp1) qLbl,(Work(ipTmp+i),i=0,nQQ-1)
         Write(LuTmp2) qLbl,(Work(ipTmp+i),i=0,nQQ-1)
      End Do
      Call GetMem('Temp_rK','Free','Real',ipTmp,nQQ)
*
      Close  (LuTmp1)
      Close  (LuTmp2)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Sigma_data

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: IFTEST, INCF1, INCF2, INCX1, INCX2, INCX3, INCY1, INCY2, INCY3, LEN1, LEN2, NFDXP, NFMV, NFR1, NFSCA, NLST1, &
                     NLST2
real(kind=wp) :: VAL1(2), VAL2(2)

public :: IFTEST, INCF1, INCF2, INCX1, INCX2, INCX3, INCY1, INCY2, INCY3, LEN1, LEN2, NFDXP, NFMV, NFR1, NFSCA, NLST1, NLST2, &
          VAL1, VAL2

end module Sigma_data

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine CheckDomain(irc,iDomain,nAtom,nOcc)
! Thomas Bondo Pedersen, January 2006.
!
! Purpose: check domain definition.

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nAtom, nOcc, iDomain(0:nAtom,nOcc)
integer(kind=iwp) :: i, iAt, iAtom

irc = 0
do i=1,nOcc
  if ((iDomain(0,i) < 1) .or. (iDomain(0,i) > nAtom)) then
    write(u6,*) 'Dimension of domain ',i,': ',iDomain(0,i)
    irc = irc+1
  else
    do iAt=1,iDomain(0,i)
      iAtom = iDomain(iAt,i)
      if ((iAtom < 1) .or. (iAtom > nAtom)) then
        write(u6,*) 'Atom ',iAt,' of domain ',i,': ',iAtom
        irc = irc+1
      end if
    end do
  end if
end do

end subroutine CheckDomain

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  SYMWEIGHT := CASSCF scalar product divided into irreps.            *
!*                                                                     *
!***********************************************************************
subroutine symweight_cvb(civec1,civec2,osym)

use casvb_global, only: mxirrep, ndet
use Definitions, only: wp

implicit none
real(kind=wp), intent(inout) :: civec1(0:ndet)
real(kind=wp), intent(in) :: civec2(0:ndet)
real(kind=wp), intent(out) :: osym(mxirrep)

call psym1_cvb(civec1(1:),civec2(1:),osym,2)

return

end subroutine symweight_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NatOrb_RASSCF(CMOO,SCR1,SCR2,SMAT,CMON,OCCN)
C
C     RASSCF program: version IBM-3090: Output section
C
C     PURPOSE: Calculation of natural orbitals from the
C              density matrix. These orbitals are written onto JOBIPH
C              in position IADR15(12), followed by the occupation
C              numbers in IADR15(13).
C              The calculation is performed for each of the NROOT
C              density matrices obtained in an average CASSCF calc.
C              Called from MAIN before OUTCTL
C
C          ****** IBM 3090 MOLCAS Release: 90 02 22 ******
C

      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
#include "splitcas.fh"

      Parameter (ROUTINE='NATORB  ')

      DIMENSION CMOO(*),SCR1(*),SCR2(*),SMAT(*),CMON(*),OCCN(*)

      IPRLEV=IPRLOC(7)
      iDisk=IADR15(12)
      jDisk=IADR15(3)

*        Write(LF,*)
*        Write(LF,*) ' CMO in NATORB_RASSCF very beginning'
*        Write(LF,*) ' ---------------------'
*        Write(LF,*)
*        ioff=0
*        Do iSym = 1,nSym
*         iBas = nBas(iSym)
*         if(iBas.ne.0) then
*           write(6,*) 'Sym =', iSym
*           do i= 1,iBas
*             write(6,*) (CMOO(ioff+iBas*(i-1)+j),j=1,iBas)
*           end do
*           iOff = iOff + (iBas*iBas)
*         end if
*        End Do

      if(.not.DoSplitCAS) then
        Do kRoot = 1,lRoots
          If(KSDFT.eq.'SCF'.and.IPRLEV.ge.USUAL) Then
            Write(LF,*)
            Write(LF,'(6X,A,I3)')
     &          'Natural orbitals and occupation numbers for root',kRoot
          End If
          Call DDaFile(JOBIPH,2,SCR1,NACPAR,jDisk)
          Call DDaFile(JOBIPH,0,SCR1,NACPAR,jDisk)
          Call DDaFile(JOBIPH,0,SCR1,NACPR2,jDisk)
          Call DDaFile(JOBIPH,0,SCR1,NACPR2,jDisk)
          Call DBLOCK(SCR1)

          Call dCopy_(NTOT,[0.0d0],0,OCCN,1)
          Call dCopy_(NTOT2,CMOO,1,CMON,1)

          ID=0
          ISTMO1=0
          IB=0
          DO ISYM=1,NSYM
            NB=NBAS(ISYM)
            NFI=NFRO(ISYM)+NISH(ISYM)
            NAO=NASH(ISYM)
            NB2=NB**2
            NA1=ITRI(NAO+1)
            IO=IB+NFI
            ISTMO=ISTMO1+NB*NFI
C
C  set occupation number of frozen and inactive orbitals
C
            Call dCopy_(NFI,[2.0d0],0,OCCN(IB+1),1)
C
C  Diagonalize the density matrix and transform orbitals
C
            IF(NAO.GT.0) THEN
              Call dCopy_(NAO*NAO,[0.0d0],0,SCR2,1)
              Call dCopy_(NAO,[1.0d0],0,SCR2,NAO+1)
              CALL JACOB(SCR1(ID+1),SCR2,NAO,NAO)
              II=0
              DO I=1,NAO
                II=II+I
                OCCN(IO+I)=SCR1(II+ID)
              END DO
              IST=IO+1
              IEND=IO+NAO
              If(KSDFT.eq.'SCF'.and.IPRLEV.ge.USUAL) Then
                Write(LF,'(6X,A3,I2,A1,10F11.6,/,(12X,10F11.6))')
     &                'sym',iSym,':',(OCCN(I),I=IST,IEND)
              End If
              CALL DGEMM_('N','N',
     &                    NB,NAO,NAO,
     &                    1.0d0,CMOO(ISTMO+1),NB,
     &                    SCR2,NAO,
     &                    0.0d0,CMON(ISTMO+1),NB)
            END IF
C
            ID=ID+NA1
            ISTMO1=ISTMO1+NB2
            IB=IB+NB
          END DO
C
C ORTHOGONALIZE NEW MO'S
C
          CALL SUPSCH(SMAT,CMOO,CMON)
          CALL ORTHO_RASSCF(SMAT,SCR1,CMON,SCR2)
C
C Place NOs wrt decreasing order of OCCN
c***  GLM commented it off for this reordering is not consistent
cGLM throughout Molcas
C
cGLM          iOff=0
cGLM          jOff=0
cGLM          Do iSym=1,nSym
cGLM            NB=nBas(iSym)
cGLM            NAO=nAsh(iSym)
cGLM            IA=1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
cGLM            JA=1+jOff+nFro(iSym)+nIsh(iSym)
cGLM            Call Order_Arrays('decr',CMON(IA),NB,NAO,OCCN(JA),SCR1)
cGLM            iOff=iOff+NB**2
cGLM            jOff=jOff+NB
cGLM          End Do

       If(IPRLEV.ge.DEBUG) Then
           Write(LF,*)
           Write(LF,*) ' CMON in NATORB_RASSCF after ORDER_ARRAYS'
           Write(LF,*) ' ---------------------'
           Write(LF,*)
           ioff=0
           Do iSym = 1,nSym
            iBas = nBas(iSym)
            if(iBas.ne.0) then
              write(6,*) 'Sym =', iSym
              do i= 1,iBas
                write(6,*) (CMON(ioff+iBas*(i-1)+j),j=1,iBas)
              end do
              iOff = iOff + (iBas*iBas)
            end if
           End Do
       end if
C
C Write new molecular orbitals and occupation numbers to JOBIPH
C
C
          CALL DDAFILE(JOBIPH,1,CMON,NTOT2,iDisk)
          CALL DDAFILE(JOBIPH,1,OCCN,NTOT,iDisk)
        End Do

      else   ! if DoSplitCAS (GLMJ)...
        If(KSDFT.eq.'SCF'.and.IPRLEV.ge.USUAL) Then
          Write(LF,*)
          Write(LF,'(6X,A,I3)')
     &     'Natural orbitals and occupation numbers for root',lRootSplit
        End If
        Call DDaFile(JOBIPH,2,SCR1,NACPAR,jDisk)
        Call DDaFile(JOBIPH,0,SCR1,NACPAR,jDisk)
        Call DDaFile(JOBIPH,0,SCR1,NACPR2,jDisk)
        Call DDaFile(JOBIPH,0,SCR1,NACPR2,jDisk)
        Call DBLOCK(SCR1)

        Call dCopy_(NTOT,[0.0d0],0,OCCN,1)
        Call dCopy_(NTOT2,CMOO,1,CMON,1)

        ID=0
        ISTMO1=0
        IB=0
        DO ISYM=1,NSYM
          NB=NBAS(ISYM)
          NFI=NFRO(ISYM)+NISH(ISYM)
          NAO=NASH(ISYM)
          NB2=NB**2
          NA1=ITRI(NAO+1)
          IO=IB+NFI
          ISTMO=ISTMO1+NB*NFI
C
C  set occupation number of frozen and inactive orbitals
C
          Call dCopy_(NFI,[2.0d0],0,OCCN(IB+1),1)
C
C  Diagonalize the density matrix and transform orbitals
C
          IF(NAO.GT.0) THEN
            Call dCopy_(NAO*NAO,[0.0d0],0,SCR2,1)
            Call dCopy_(NAO,[1.0d0],0,SCR2,NAO+1)
            CALL JACOB(SCR1(ID+1),SCR2,NAO,NAO)
            II=0
            DO I=1,NAO
              II=II+I
              OCCN(IO+I)=SCR1(II+ID)
            END DO
            IST=IO+1
            IEND=IO+NAO
            If(KSDFT.eq.'SCF'.and.IPRLEV.ge.USUAL) Then
               Write(LF,'(6X,A3,I2,A1,10F11.6,/,(12X,10F11.6))')
     &               'sym',iSym,':',(OCCN(I),I=IST,IEND)
            End If
            CALL DGEMM_('N','N',
     &                  NB,NAO,NAO,
     &                  1.0d0,CMOO(ISTMO+1),NB,
     &                  SCR2,NAO,
     &                  0.0d0,CMON(ISTMO+1),NB)
          END IF
C
         ID=ID+NA1
         ISTMO1=ISTMO1+NB2
         IB=IB+NB
       END DO
C
C ORTHOGONALIZE NEW MO'S
C
       CALL SUPSCH(SMAT,CMOO,CMON)
       CALL ORTHO_RASSCF(SMAT,SCR1,CMON,SCR2)
C
C Place NOs wrt decreasing order of OCCN
C
       iOff=0
       jOff=0
       Do iSym=1,nSym
          NB=nBas(iSym)
          NAO=nAsh(iSym)
          IA=1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
          JA=1+jOff+nFro(iSym)+nIsh(iSym)
          Call Order_Arrays('decr',CMON(IA),NB,NAO,OCCN(JA),SCR1)
          iOff=iOff+NB**2
          jOff=jOff+NB
       End Do
C
C Write new molecular orbitals and occupation numbers to JOBIPH
C
       CALL DDAFILE(JOBIPH,1,CMON,NTOT2,iDisk)
       CALL DDAFILE(JOBIPH,1,OCCN,NTOT,iDisk)

      end if

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003, Valera Veryazov                                  *
!               2017, Roland Lindh                                     *
!***********************************************************************

subroutine RdInp_scf()
!***********************************************************************
!                                                                      *
!     purpose: Read input options                                      *
!                                                                      *
!     called from: ReadIn                                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
!     University of Lund, Sweden, 1992                                 *
!     modified by M.Schuetz @teokem.lu.se, 1995                        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: UHF- V.Veryazov, 2003                                   *
!                                                                      *
!***********************************************************************

use KSDFT_Info, only: CoefR, CoefX
use OFembed, only: dfmd, Do_OFemb, KEonly, OFE_KSDFT, ThrFThaw, XSigma
use Functionals, only: Custom_File, Custom_Func
use IOBuf, only: lDaRec, nSect
use Fock_util_global, only: Deco, DensityCheck, Estimate, Update
use SpinAV, only: Do_SpinAV
use InfSCF, only: Addc_KSDFT, AddFragments, ALGO, Aufb, C1DIIS, Cho_Aufb, Damping, dmpk, DDnOff, DelThr, DIIS, DIISTh, DltnTh, &
                  Do_addc, Do_Tw, DoCholesky, DoHLgap, DSCF, DThr, EThr, ExFac, Expand, Falcon, FckAuf, FckAuf, FlipThr, FThr, &
                  HLgap, iAu_ab, iCoCo, iDKeep, indxc, InVec, iPrForm, iPrint, iPrOrb, isHDF5, iStatPRN, Iter2run, IterPrlv, &
                  jPrint, jVOut, kIVO, klockan, kOptim_Max, KSDFT, LKon, Loosen, LstVec, MaxFlip, MiniDn, MSYMON, MxConstr, &
                  MxIter, MxOptm, nAufb, nBas, nConstr, nCore, nD, nDel, nDisc, Neg2_Action, nFro, nIter, nOcc, NoExchange, &
                  NoFerm, NoProp, nOrb, nScreen, nSym, nTit, OccSet_e, OccSet_m, One_Grid, OnlyProp, PmTime, PreSch, QNRTh, &
                  QudThr, ReOrd, RFPert, RGEK, RotFac, RotLev, RotMax, RSRFO, RTemp, SCF_FileOrb, ScrFac, Scrmbl, Teee, TemFac, &
                  Thize, ThrEne, Title, Tot_Charge, Tot_El_Charge, Tot_Nuc_Charge, TStop, WrOutD
use Cholesky, only: ChFracMem, timings
#ifdef _HDF5_
use mh5, only: mh5_is_hdf5, mh5_open_file_r
use InfSCF, only: FileOrb_ID
#endif
use spool, only: Close_LuSpool, Spoolinp
use hfc_logical, only: UHF_HFC
use stdalloc, only: mma_allocate
use Constants, only: Zero, One, Five, Ten, Half, Deg2Rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, iArray(32), iAuf, iD, iFroz, iOccu, iOrbi, iPri, iStatus, iSym, j, KeywNo, lthSet_a, lthSet_b, LuCF, &
                     LuSpool, nOccSet_e, nOccSet_m, Mode(1), nFunc, nnn
real(kind=wp) :: dArray(3), Tot_Ml_Charge
logical(kind=iwp) :: CharSet, Chol, DoTit, FermSet, IfAufChg, lTtl, OccSet, SpinSet, TDen_UsrDef, UHFSet
character(len=180) :: Key, Line
character(len=8) :: Method
integer(kind=iwp), external :: Allocdisk, IsFreeUnit
real(kind=wp), external :: Get_ExFac
character(len=180), external :: Get_Ln

! copy input from standard input to a local scratch file

call SpoolInp(LuSpool)

OccSet = .false.
FermSet = .false.
CharSet = .false.
SpinSet = .false.
NoFerm = .false.

Neg2_Action = 'STOP'

! Some initialization

Chol = .false.
ALGO = 4
REORD = .false.
DECO = .true.
DensityCheck = .false.
timings = .false.
UHFSet = .false.
Nscreen = 10    ! default screening interval (# of red sets)
dmpk = 0.045_wp ! default damping of the screening threshold
Estimate = .false.
Update = .true.
#ifdef _MOLCAS_MPP_
ChFracMem = 0.3_wp
#else
ChFracMem = Half
#endif
SCF_FileOrb = 'INPORB'
isHDF5 = .false.
! Constrained SCF initialization
nConstr(1:nSym) = 0
MxConstr = 0
klockan = 1
Do_Addc = .false.
iTer2run = 2
! Delta_Tw correlation energy calculation
Do_Tw = .false.
! Read Cholesky info from runfile and save in infscf.fh
call DecideOnCholesky(DoCholesky)
if (DoCholesky) then
  Chol = .true.
  call Cho_scf_rdInp(.true.,LuSpool)
  if (ALGO >= 2) then
    DDnOFF = .true. !do not use diffential density
    MiniDn = .false.
  end if
  !tbp, may 2013: no thr modification with Cholesky
  !tbp call Get_dScalar('Cholesky Threshold',ThrCom)
  !tbp EThr = Max(EThr,ThrCom)
else
  DDnOFF = .false. !default for conventional
  MiniDn = .true.
end if
TDen_UsrDef = .false.
! Default undershoot avoidance settings (for S-GEK)
Loosen%Thrs = cos(Five*Deg2Rad)
Loosen%Thrs2 = cos(20.0_wp*Deg2Rad)
Loosen%Step = Half*(One+sqrt(Five))
Loosen%Factor = One

! Set up number of orbitals
nOrb(1:nSym) = nBas(1:nSym)

! Set up some counters
iOrbi = 0
iFroz = 0
iOccu = 0
nTit = 0
iPrForm = -1
iterprlv = 0
ScrFac = Zero

! Parameters that control how new orbitals are generated by neworb.

RotLev = Zero
RotFac = One
RotMax = Ten
!HLgap = -One
HLgap = 0.2_wp
DoHLgap = .false.
MaxFlip = 10
FlipThr = 0.1_wp

! Skip exchange when building Fock matrix
! (for debugging purposes)

NoExchange = .false.

! Default value for starting orbitals
! Invec=-1 indicate decision in sorb

InVec = -1

! Default to aufbau for neutral species

Aufb = .true.
Teee = .true.
RTemp = Half
TemFac = 0.46_wp
TStop = 0.01_wp
nAufb(1) = -1
nAufb(2) = -1
call Get_dScalar('Total Nuclear Charge',Tot_Nuc_Charge)
Tot_El_Charge = Zero
Tot_Ml_Charge = Zero
Tot_Charge = Zero
iAu_ab = 0
iStatPRN = 0

IfAufChg = .false.

! Optimization method
RSRFO = .false.
RGEK = .false.
Expand = -1

Falcon = .false.
MSYMON = .false.

nD = 1

! Locate "start of input"
rewind(LuSpool)
call RdNLst(LuSpool,'SCF')

KeywNo = 0
lTtl = .false.
DoTit = .false.
do
  if (.not. DoTit) lTtl = .false.
  Key = Get_Ln(LuSpool)
  Line = Key
  call UpCase(Line)
  KeywNo = KeywNo+1

  select case (Line(1:4))
    case ('TITL')
      !>>>>>>>>>>>>> TITL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      lTtl = .true.
      call Add_title_line()

    case ('ITER')
      !>>>>>>>>>>>>> ITER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      Line(179:180) = '-1'
      call Put_Ln(Line)
      call Get_I(1,nIter,2)
      if (nIter(1) == -1) nIter(1) = nIter(0)

    case ('OCCU')
      !>>>>>>>>>>>>> OCCU <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if (FermSet) then
        call WarningMessage(2,'Options OCCUpied and FERMi are mutually exclusive')
        call Abend()
      end if
      if (SpinSet) then
        call WarningMessage(2,'Keyword OCCUpied and ZSPIn/SPIN are mutually exclusive')
        call Abend()
      end if
      if (CharSet) then
        call WarningMessage(2,'Options OCCUpied and CHARGE are mutually exclusive')
        call Abend()
      end if
      do iD=1,nD
        Line = Get_Ln(LuSpool)
        call Get_I(1,nOcc(1,iD),nSym)
        if (iD == 1) then
          call Put_iArray('nIsh',nOcc(1,iD),nSym)
        else
          call Put_iArray('nIsh beta',nOcc(1,iD),nSym)
        end if
      end do

      iOccu = 1
      if (nD == 1) then
        Tot_El_Charge = -real(sum(2*nOcc(1:nSym,1)),kind=wp)
      else
        Tot_El_Charge = -real(sum(nOcc(1:nSym,1:2)),kind=wp)
      end if
      Aufb = .false. ! Disable default action.
      Teee = .false.
      OccSet = .true.
      Cho_Aufb = .false.
      UHFSet = .true.

    case ('ORBI')
      !>>>>>>>>>>>>> ORBI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I(1,nOrb,nSym)
      iOrbi = 1
      nDel(1:nSym) = nBas(1:nSym)-nOrb(1:nSym)

    case ('FROZ')
      !>>>>>>>>>>>>> FROZ <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I(1,nFro,nSym)
      call Put_iArray('nFro',nFro,nSym)
      iFroz = 1

    case ('OVLD')
      !>>>>>>>>>>>>> OVLD <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,DelThr)

    case ('PRLS')
      !>>>>>>>>>>>>> PRLS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I1(1,iPri)
      iPrint = max(iPri,iPrint)

    case ('PROR')
      !>>>>>>>>>>>>> PROR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      Line(179:180) = '-1'
      call Put_Ln(Line)
      call Get_I1(1,iPrOrb)
      if (iPrOrb >= 2) then
        call Get_F1(2,ThrEne)
        call Get_I1(3,iPrForm)
      else
        call Get_I1(2,iPrForm)
      end if

    case ('KEEP')
      !>>>>>>>>>>>>> KEEP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I1(1,iDKeep)

    case ('STAR')
      !>>>>>>>>>>>>> STAR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      Line(157:180) = '-1 -1 -1 -1 -1 -1 -1 -1'
      call Put_Ln(Line)
      call Get_I(1,LstVec,7)
      ! temporary hack to use density
      if (LstVec(1) == 3) then
        InVec = 3
        RTemp = 0.1_wp
        TemFac = 0.1_wp
        TStop = 0.005_wp
        !Aufb = .false.
        !Teee = .false.
      end if

    case ('CHOL')
      !>>>>>>>>>>>>> CHOL <<<<<<< Cholesky Default Input <<<<<<<<<
      Chol = .true.
      call Cho_scf_rdInp(.true.,LuSpool)
      if (ALGO >= 2) then
        DDnOFF = .true. !do not use diffential density
        MiniDn = .false.
      end if

    case ('CHOI')
      !>>>>>>>>>>>>> CHOI <<<<<<< Cholesky Custom  Input <<<<<<<<<
      ! Cholesky with user-defined settings.
      Chol = .true.
      DDnOFF = .false. ! reset to default value
      MiniDn = .true.  ! reset to default value
      call Cho_scf_rdInp(.false.,LuSpool)
      if (ALGO >= 2) then
        DDnOFF = .true. !do not use diffential density
        MiniDn = .false.
      else
        DECO = .false.
      end if

    case ('CONS')
      !>>>>>>>>>>>>> CONS <<<<<<<<<<<< Constrained SCF <<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I(1,nConstr,nSym)
      indxC(:,:,:) = 0
      do i=1,nSym
        MxConstr = max(MxConstr,nConstr(i))
        Line = Get_Ln(LuSpool)
        call Get_I(1,indxC(1,1,i),nConstr(i))
        if (nConstr(i) > 16) then
          write(u6,*) ' Max nConstr=16. Increase 1st dim of indxC and recompile'
          call Abend()
        end if
        do j=1,nConstr(i)
          if ((indxC(j,1,i) /= 1) .and. (indxC(j,1,i) /= -1)) then
            write(u6,*) ' Only 1 and -1 are accepted values'
            call Abend()
          else if (indxC(j,1,i) == 1) then
            indxC(j,2,i) = 2
          else
            indxC(j,1,i) = 2
            indxC(j,2,i) = 1
          end if
        end do
      end do

    case ('CORE')
      !>>>>>>>>>>>>> CORE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      InVec = 0
      LstVec(1) = 4
      LstVec(2) = -1

    case ('NDDO')
      !>>>>>>>>>>>>> NDDO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if (Chol) then
        call WarningMessage(1,'RdInp: NDDO and Cholesky are incompatible!!; NDDO Option ignored')
      else
        InVec = 1
        LstVec(1) = 5
        LstVec(2) = -1
      end if

    case ('LUMO')
      !>>>>>>>>>>>>> LUMO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      InVec = 2
      One_Grid = .true.
      LstVec(1) = 2
      LstVec(2) = -1

    case ('GSSR')
      !>>>>>>>>>>>>> GSSR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      InVec = 9
      One_Grid = .true.
      LstVec(1) = 1
      LstVec(2) = -1

    case ('REST')
      !>>>>>>>>>>>>> REST <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      call WarningMessage(1,'REST option is redundant and is ignored!')

    case ('THRE')
      !>>>>>>>>>>>>> THRE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,EThr)
      call Get_F1(2,DThr)
      call Get_F1(3,FThr)
      call Get_F1(4,DltNTh)
      !tbp, may 2013: no thr modification with Cholesky
      !tbp if (DoCholesky) then
      !tbp   write(ww,'(a,es20.8)') 'Detected Cholesky or RI/DF calculation BUT user specified EThr will be used. Ethr = ',EThr
      !tbp   call WarningMessage(1,ww)
      !tbp end if
      !if (  DThr*1.0e-2_wp > EThr) then
      !  write(u6,*)
      !  write(u6,*) '----> WARNING! <----'
      !  write(u6,*)
      !  write(u6,*) ' The value of DThr is inconsistent with'
      !  write(u6,*) ' with the value of EThr. The code will'
      !  write(u6,*) ' automatically reset the value to something'
      !  write(u6,*) ' more reasonable based on the requested'
      !  write(u6,*) ' threshold of the energy.'
      !  DThr = 100.0_wp*EThr
      !end if
      !if (  FThr*1.0e-2_wp > EThr) then
      !  write(u6,*)
      !  write(u6,*) '----> WARNING! <----'
      !  write(u6,*)
      !  write(u6,*) ' The value of FThr is inconsistent with'
      !  write(u6,*) ' with the value of EThr. The code will'
      !  write(u6,*) ' automatically reset the value to something'
      !  write(u6,*) ' more reasonable based on the requested'
      !  write(u6,*) ' threshold of the energy.'
      !  FThr = 100.0_wp*EThr
      !end if
      !if (DltNTh*1.0e-2_wp > sqrt(EThr)) then
      !  write(u6,*)
      !  write(u6,*) '----> WARNING! <----'
      !  write(u6,*)
      !  write(u6,*) ' The value of DltNTh is inconsistent with'
      !  write(u6,*) ' with the value of EThr. The code will'
      !  write(u6,*) ' automatically reset the value to something'
      !  write(u6,*) ' more reasonable based on the requested'
      !  write(u6,*) ' threshold of the energy.'
      !  DltNTh = 100.0_wp*Sqrt(EThr)
      !end if

    case ('NODI')
      !>>>>>>>>>>>>> NODI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Diis = .false.

    case ('DIIS')
      !>>>>>>>>>>>>> DIIS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,DiisTh)

    case ('OCCN')
      !>>>>>>>>>>>>> OCCN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if (iOccu /= 1) then
        call WarningMessage(2,' Input Error!;The OCCNumber option works only if  the OCCUpied option has been specified!')
        call Abend()
      end if
      lthSet_a = 0
      lthSet_b = 0
      do iSym=1,nSym
        lthSet_a = lthSet_a+nOcc(iSym,1)
        if (nD == 2) lthSet_b = lthSet_b+nOcc(iSym,2)
      end do
      nOccSet_e = max(lthSet_a,lthSet_b)
      !write(u6,'(a,i5)') 'rdinp: lthset_a ',lthset_a
      !write(u6,'(a,i5)') 'rdinp: lthset_b ',lthset_b

      ! Note, it is dangerous to read Line first. There may be many
      ! lines with occupation numbers.

      call mma_allocate(OccSet_e,nOccSet_e,nD,Label='OccSet_e')
      OccSet_e(:,:) = Zero
      read(LuSpool,*,iostat=istatus) (OccSet_e(i,1),i=1,lthSet_a)
      call Error_check()
      if (nD == 2) then
        read(LuSpool,*,iostat=istatus) (OccSet_e(i,2),i=1,lthSet_b)
        call Error_check()
      end if

      Tot_El_Charge = -sum(OccSet_e(1:nOccSet_e,1:nD))
      UHFSet = .true.
      iCoCo = 1

    case ('MCCN')
      !>>>>>>>>>>>>> MCCN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Just as OCCN, but for muons
      if (iOccu /= 1) then
        call WarningMessage(2,' Input Error!;The OCCNumber option works only if the OCCUpied option has been specified!')
        call Abend()
      end if
      lthSet_a = 0
      lthSet_b = 0
      do iSym=1,nSym
        lthSet_a = lthSet_a+nOcc(iSym,1)
        if (nD == 2) lthSet_b = lthSet_b+nOcc(iSym,2)
      end do
      nOccset_m = max(lthSet_a,lthSet_b)
      !write(u6,'(a,i5)') 'rdinp: lthset_a ',lthset_a
      !write(u6,'(a,i5)') 'rdinp: lthset_b ',lthset_b

      ! Note, it is dangerous to read Line first. There may be many
      ! lines with occupation numbers.

      call mma_allocate(OccSet_m,nOccSet_m,nD,Label='OccSet_m')
      OccSet_m(:,:) = Zero
      read(LuSpool,*,iostat=istatus) (OccSet_m(i,1),i=1,lthSet_a)
      call Error_check()
      if (nD == 2) then
        read(LuSpool,*,iostat=istatus) (OccSet_m(i,2),i=1,lthSet_b)
        call Error_check()
      end if

      Tot_Ml_Charge = -sum(OccSet_m(1:nOccSet_m,1:nD))
      UHFSet = .true.
      iCoCo = 1

    case ('IVO ')
      !>>>>>>>>>>>>> IVO  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      kIvo = 1

    case ('UHF ')
      !>>>>>>>>>>>>> UHF  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if (UHFSet) call sysAbendMsg('rdinp','incorrect input','UHF keyword should be placed before others')
      nD = 2
      MiniDn = .false.

    case ('HFC ')
      !>>>>>>>>>>>>> HFC  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      UHF_HFC = .true.

    case ('NODA')
      !>>>>>>>>>>>>> NODA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Damping = .false.

    case ('CONV')
      !>>>>>>>>>>>>> CONV <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DSCF = .false.

    case ('DISK')
      !>>>>>>>>>>>>> DISK <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I1(1,nDisc)
      call Get_I1(2,nCore)

    case ('THIZ')
      !>>>>>>>>>>>>> THIZ <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,Thize)

    case ('SIMP')
      !>>>>>>>>>>>>> SIMP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      PreSch = .true.

    case ('NOMI')
      !>>>>>>>>>>>>> NOMI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      MiniDn = .false.  !do not use minimized density diff

    case ('TDEN')
      !>>>>>>>>>>>>> TDEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DDnOFF = .true. !do not use diffential density
      MiniDn = .false.
      TDen_UsrDef = .true.

    case ('WRDE')
      !>>>>>>>>>>>>> WRDE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      WrOutD = .true.

    case ('C1DI')
      !>>>>>>>>>>>>> C1DI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      c1Diis = .true.

    case ('QUAD')
      !>>>>>>>>>>>>> QUAD <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,QudThr)

    case ('RS-R')
      !>>>>>>>>>>>>> RS-R <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      RSRFO = .true.

    case ('S-GE')
      !>>>>>>>>>>>>> S-GE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      RGEK = .true.

    case ('EXPA')
      !>>>>>>>>>>>>> EXPA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I1(1,Expand)

    case ('LOOS')
      !>>>>>>>>>>>>> LOOS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F(1,dArray,3)
      Loosen%Thrs = dArray(1)
      Loosen%Thrs2 = dArray(2)
      Loosen%Step = dArray(3)

    case ('SCRA')
      !>>>>>>>>>>>>> SCRA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,ScrFac)
      Scrmbl = .true.

    case ('EXTR')
      !>>>>>>>>>>>>> EXTR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      call WarningMessage(1,'EXTRACT option is redundant and is ignored!')

    case ('RFPE')
      !>>>>>>>>>>>>> RFPE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      RFpert = .true.

    case ('QNRT')
      !>>>>>>>>>>>>> QNRT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,QNRTh)

    case ('FERM')
      !>>>>>>>>>>>>> FERM <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if (OccSet) then
        call WarningMessage(2,'Options OCCUpied and FERMi are mutually exclusive')
        call Abend()
      end if
      if (NoFerm) then
        call WarningMessage(2,'Options FERMi and NOFErmi are mutually exclusive')
        call Abend()
      end if
      if (Chol) then
        DDnOFF = .true.
        DECO = .true.
        MiniDn = .false.
      end if
      Line = Get_Ln(LuSpool)
      call Get_I1(1,iAuf)
      FermSet = .true.
      select case (iAuf)
        case (0)
          Teee = .false.
        case (1)
          RTemp = Half
          TemFac = 0.4_wp
          TStop = 0.005_wp
        case (3)
          RTemp = Half
          TemFac = 0.61_wp
          TStop = 0.025_wp
        case (4)
          RTemp = One
          TemFac = 0.73_wp
          TStop = 0.06_wp
        case (5)
          RTemp = One
          TemFac = 0.87_wp
          TStop = 0.15_wp
        case default
          if (iAuf /= 2) call WarningMessage(1,' RdInp: Aufbau case must be in the range 0-5;Using case 2!')
          RTemp = Half
          TemFac = 0.46_wp
          TStop = 0.01_wp
      end select
      UHFSet = .true.

    case ('NOFE')
      !>>>>>>>>>>>>> NOFE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if (FermSet) then
        call WarningMessage(2,'Options FERMi and NOFErmi are mutually exclusive')
        call Abend()
      end if
      NoFerm = .true.

    case ('TEEE')
      !>>>>>>>>>>>>> TEEE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,RTemp)
      call Get_F1(2,TemFac)
      call Get_F1(3,TStop)
      if (TStop < Zero) then
        call WarningMessage(2,'Input Error!; End temperture < 0.0 ')
        call Abend()
      end if
      if (TemFac < Zero) then
        call WarningMessage(2,'Input Error!; Temperture factor < 0.0 ')
        call Abend()
      end if
      if (RTemp < Zero) then
        call WarningMessage(2,'Input Error!; Start temperature < 0.0 ')
        call Abend()
      end if
      if (RTemp < TStop) then
        call WarningMessage(2,'Input Error!; End temperture > start temperature ')
        call Abend()
      end if

    case ('CHAR')
      !>>>>>>>>>>>>> CHAR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I(1,iArray,1)
      Tot_Charge = real(iArray(1),kind=wp)
      nAufb(1) = -1
      nAufb(2) = -1
      if (IfAufChg) then
        call WarningMessage(2,'Input Error!; Option CHARge is mutually exclusive to AUFBau')
        call Abend()
      end if
      if (OccSet) then
        call WarningMessage(2,'Input Error!; Option CHARge is mutually exclusive to OCCUpied')
        call Abend()
      end if
      IfAufChg = .true.
      CharSet = .true.

    case ('NOTE')
      !>>>>>>>>>>>>> NOTE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Teee = .false.

    case ('KSDF')
      !>>>>>>>>>>>>> KSDF <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call UpCase(Line)
      Line = adjustl(Line)
      KSDFT = Line(1:80)
      nFunc = 0
      read(Line,*,iostat=istatus) nFunc
      if ((istatus == 0) .and. (nFunc > 0)) then
        KSDFT = Custom_Func
        LuCF = IsFreeUnit(10)
        call molcas_open(LuCF,Custom_File)
        write(LuCF,*) trim(KSDFT),nFunc
        do i=1,nFunc
          Line = Get_Ln(LuSpool)
          write(LuCF,*) trim(Line)
        end do
        close(LuCF)
      end if

    case ('DFCF')
      !>>>>>>>>>>>>> DFCF <<<< Factors to scale exch. and corr. <<

      Line = Get_Ln(LuSpool)
      call Get_F1(1,CoefX)
      call Get_F1(2,CoefR)
      !call put_dscalar('DFT exch coeff',CoefX)
      !call put_dscalar('DFT corr coeff',CoefR)

    case ('OFEM')
      !>>>>>>>>>>>>> OFEM <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Do_OFemb = .true.
      Line = Get_Ln(LuSpool)
      call UpCase(Line)
      Line = adjustl(Line)
      OFE_KSDFT = Line(1:16)
      write(u6,*) '  --------------------------------------'
      write(u6,*) '   Orbital-Free Embedding Calculation'
      write(u6,*) '  --------------------------------------'
      if (OFE_KSDFT(1:4) == 'LDTF') then
        write(u6,*) '    T_nad potential   : Thomas-Fermi    '
      else
        write(u6,*) '    T_nad potential   : ',OFE_KSDFT(1:4)
      end if
      if (KEonly) then
        write(u6,*) '    Exc_nad potential :  None           '
      else
        write(u6,*) '    Exc_nad potential : ',OFE_KSDFT(6:10)
      end if
      write(u6,*) '  --------------------------------------'
      write(u6,*)

    case ('FTHA')
      !>>>>>>>>>>>>> FTHA <<<< threshold for Freeze-n-Thaw <<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,ThrFThaw)

    case ('DFMD')
      !>>>>>>>>>>>>> DFMD <<<< fraction of correlation potential <
      Line = Get_Ln(LuSpool)
      call Get_F1(1,dFMD)
      call Get_F1(2,Xsigma)
      if (dFMD+Xsigma < Zero) then
        write(u6,*) ' *** Warning: arguments to DFMD must be nonnegative!'
        write(u6,*) ' ***          I will take their ABS !!! '
        dFMD = abs(dFMD)
        Xsigma = abs(Xsigma)
      end if

    case ('KEON')
      !>>>>>>>>>>>>> KEON <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      KEonly = .true.
      if (.not. Do_OFemb) then
        write(u6,*) ' *** Warning:  KEonly works in OFembedding runs!'
      else
        write(u6,*) ' *** Warning:  Exc_nad set to NONE at this point ***'
      end if
      write(u6,*)

    case ('TWCO')
      !>>>>>>>>>>>>> TWCO <<<<< activate Tw correlation <<<<<<<<<<
      Do_Tw = .true.

    case ('ADDC')
      !>>>>>>>>>>>>> ADDC << add correlation energy (CONStraint) <
      Do_Addc = .true.
      Line = Get_Ln(LuSpool)
      call UpCase(Line)
      Line = adjustl(Line)
      ADDC_KSDFT = Line(1:80)

    case ('SAVE')
      !>>>>>>>>>>>>> SAVE << Spin-Averaged wavelets (CONStraint) <
      Do_SpinAV = .true.

    case ('DEBU')
      !>>>>>>>>>>>>> DEBUG <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Diis = .false.
      MiniDn = .false.
      Damping = .false.

    case ('ZSPI')
      !>>>>>>>>>>>>> ZSPI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if (SpinSet) then
        call WarningMessage(2,'Multiple definition of SPIN/ZSPIn')
        call Abend()
      end if
      if (OccSet) then
        call WarningMessage(2,'Input Error!; Keywords OCCUpied and ZSPIn are mutually exclusive')
        call Abend()
      end if
      Line = Get_Ln(LuSpool)
      call Get_I(1,iArray,1)
      iAu_ab = iArray(1)
      if ((nD /= 2) .and. (iAu_ab /= 0)) then
        call WarningMessage(2,'ZSPIn different from 0 requires UHF before it')
        call Abend()
      end if
      SpinSet = .true.

    case ('SPIN')
      !>>>>>>>>>>>>> SPIN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if (SpinSet) then
        call WarningMessage(2,'Multiple definition of SPIN/ZSPIn')
        call Abend()
      end if
      if (OccSet) then
        call WarningMessage(2,'Input Error!; Keywords OCCUpied and SPIN are mutually exclusive')
        call Abend()
      end if
      Line = Get_Ln(LuSpool)
      call Get_I(1,iArray,1)
      iAu_ab = iArray(1)-1
      if (iAu_ab < 0) then
        call WarningMessage(2,'SPIN must be a positive integer')
        call Abend()
      end if
      if (iAu_ab /= 0) then
        nD = 2
        MiniDn = .false.
      end if
      if ((nD /= 2) .and. (iAu_ab /= 0)) then
        call WarningMessage(2,'SPIN greater than 1 requires UHF before it')
        call Abend()
      end if
      SpinSet = .true.

    case ('EXFA')
      !>>>>>>>>>>>>> EXFA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ExFac = Zero

    case ('ONEG')
      !>>>>>>>>>>>>> ONEG <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      One_Grid = .true.

    case ('ROTP')
      !>>>>>>>>>>>>> ROTP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,RotLev)
      call Get_F1(2,RotFac)
      call Get_F1(3,RotMax)
      write(u6,'(a,ES15.3)') 'Fock matrix levelshift   ',RotLev
      write(u6,'(a,ES15.3)') 'Fock matrix scaling      ',RotFac
      write(u6,'(a,ES15.3)') 'Fock matrix max rotation ',RotMax

    case ('HLGA')
      !>>>>>>>>>>>>> HLGA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_F1(1,HLgap)
      write(u6,'(a,ES15.3)') 'Minimum HOMO-LUMO gap    ',HLgap
      DoHLgap = .true.
      QNRTh = Zero

    case ('FLIP')
      !>>>>>>>>>>>>> FLIP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      Line(178:180) = '0.1'
      call Put_Ln(Line)
      call Get_I(1,iArray,1)
      call Get_F1(2,FlipThr)
      MaxFlip = iArray(1)
      !write(u6,*) 'MaxFlip:',MaxFlip
      !write(u6,*) 'FlipThr:',FlipThr

    case ('PMTI')
      !>>>>>>>>>>>>> PMTI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Time (CPU *and* wall) subroutine pmat_scf (2-el Fock matrix)
      PmTime = .true.

    case ('STAT')
      !>>>>>>>>>>>>> STAT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Print Statistic information
      iStatPRN = 1

    case ('ADDF')
      !>>>>>>>>>>>>> ADDF <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Add the fragment atoms to the MOLDEN file
      AddFragments = .true.

    case ('FILE')
      !>>>>>>>>>>>>> FILE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      InVec = 2
      One_Grid = .true.
      LstVec(1) = 2
      LstVec(2) = -1
      Line = Get_Ln(LuSpool)
      call fileorb(Line,SCF_FileOrb)
#     ifdef _HDF5_
      if (mh5_is_hdf5(SCF_FileOrb)) then
        isHDF5 = .true.
        fileorb_id = mh5_open_file_r(SCF_FileOrb)
      end if
#     endif

    case ('ITPR')
      !>>>>>>>>>>>>> ITPR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I1(1,iterprlv)

    case ('PROP')
      !>>>>>>>>>>>>> PROP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      InVec = 2
      One_Grid = .true.
      LstVec(1) = 2
      LstVec(2) = -1
      OnlyProp = .true.

    case ('NOPR')
      !>>>>>>>>>>>>> SKIP PROP <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      NoProp = .true.

    case ('NOX ')
      !>>>>>>>>>>>>> NOX  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Debug option: skip exchange in Fock matrix build
      NoExchange = .true.

    case ('PSDC')
      !>>>>>>>>>>>>> PSDC <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Debug option: check that full integral matrix is PSD
      ! input=1: diagonalization
      ! input=2: Cholesky decomposition
      Line = Get_Ln(LuSpool)
      call Get_I(1,Mode,1)

    case ('USEX')
      !>>>>>>>>>>>>> USEX <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Debug option: use exact diagonal (1) or off-dagonal (2) blocks when
      ! checking PSD
      Line = Get_Ln(LuSpool)
      call Get_I(1,Mode,1)

    case ('NEG2')
      !>>>>>>>>>>>>> NEG2 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ! Specify action when negative two-electron energies are
      ! encountered (stop, warn, continue).
      Line = Get_Ln(LuSpool)
      call UpCase(Line)
      Neg2_Action = Line(1:4)
      if ((Neg2_Action /= 'STOP') .and. (Neg2_Action /= 'WARN') .and. (Neg2_Action /= 'CONT')) then
        write(u6,'(A,A)') 'Illegal input for NEG2 keyword: ',Line(1:4)
        !call FindErrorLine()
        call Quit_OnUserError()
      end if

    case ('MSYM')
      !>>>>>>>>>>>>> MSYM <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      MSYMON = .true.

    case ('ITDI')
      !>>>>>>>>>>>>> ITDIIS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I1(1,iTer2run)

    case ('FCKA')
      !>>>>>>>>>>>>> ITDIIS <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call UpCase(Line)
      if (index(Line,'TRUE') /= 0) then
        FckAuf = .true.
      else
        FckAuf = .false.
      end if

    case ('DEPT')
      !>>>>>>>>>>>>> DEPTH  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Line = Get_Ln(LuSpool)
      call Get_I1(1,kOptim_Max)
      if (kOptim_Max > MxOptm) then
        write(u6,*) 'kOptim_Max>MxOptm'
        write(u6,*) 'kOptim_Max=',kOptim_Max
        write(u6,*) 'MxOptm=',MxOptm
        write(u6,*) 'Modify infscf.F90 and recompile!'
        call Abend()
      end if

    case ('FALC')
      !>>>>>>>>>>>>> FALC <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      Falcon = .true.

    case ('END ')
      !>>>>>>>>>>>>> END  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      exit

    case default
      if (lTtl) then
        call Add_title_line()
      else
        write(u6,*) 'Unidentified key word:',Key
        call FindErrorLine()
        call Quit_OnUserError()
      end if
  end select

end do

if (iPrint >= 3) iStatPRN = 1

Tot_El_charge = Tot_El_Charge+Tot_Ml_Charge

! xml tag method

if (nD == 1) then
  if (KSDFT == 'SCF') then
    call xml_cDump('method','','',0,'rhf',1,1)
  else
    call xml_cDump('method','','',0,'rdft',1,1)
  end if
else
  if (KSDFT == 'SCF') then
    call xml_cDump('method','','',0,'uhf',1,1)
  else
    call xml_cDump('method','','',0,'udft',1,1)
  end if
end if

! Even or odd number of electrons

if (.not. SpinSet) then
  nnn = int(tot_nuc_charge-tot_charge+half)
  if ((nnn/2)*2 /= nnn) iAu_ab = 1
end if

! Check start orbital priority list

if ((.not. OccSet) .and. (.not. FermSet)) then
  !write(u6,*) 'rdinp: Checking OCCU/FERM'
  call VecFind(OccSet,FermSet,CharSet,SpinSet)
  if (OccSet .and. (.not. FermSet)) then
    !write(u6,*) 'Using OCCU'
    Aufb = .false.
    Teee = .false.
    Cho_Aufb = .false.
  else if (FermSet .and. (.not. OccSet)) then
    !write(u6,*) 'Using FERM'
    Aufb = .true.
    Teee = .true.
    Cho_Aufb = .true.
  else
    call WarningMessage(2,'Internal (logical) error in rdinp_scf')
    call Abend()
  end if
end if
if (SpinSet) then
  nnn = int(Tot_Nuc_Charge-Tot_Charge-iAu_ab+half)
  if ((nnn/2)*2 /= nnn) then
    call WarningMessage(2,'Input error!;zSpin inconsistent with number of electrons')
    call Abend()
  end if
end if

! Check if certain input parameters are not in conflict

if ((iCoCo == 1) .and. (iOccu == 0)) then
  call WarningMessage(2,'Input error!; The OCCNumber option require that the OCCUpied option is specified!')
  call Abend()
end if

if (max(nIter(0),nIter(1)) > MxIter) then
  call WarningMessage(1,'Input error!;Number of iterations specified in input exceeds allowed maximum!')
  !write(u6,*) 'nIter(0)=',nIter(0)
  !write(u6,*) 'nIter(1)=',nIter(1)
  !write(u6,*) 'MxIter=',MxIter
  !write(u6,*)
  nIter(0) = MxIter
  nIter(1) = MxIter

  !write(u6,*) 'Number of iteration reset to ',MxIter
  !write(u6,*)
end if

if ((iOrbi == 1) .and. ((InVec /= 2) .and. (InVec /= 4))) then
  call WarningMessage(2,'Input error!; The ORBITAL option can only be used with input orbitals!;'// &
                      'Possible exclusive options are: LUMORB RESTART')
  call Abend()
end if

if ((iFroz == 1) .and. (InVec == 3)) then
  call WarningMessage(2,'Input error!; The FROZEN option does not work with an density matrix input')
  call Abend()
end if

if ((InVec == 1) .and. Aufb .and. (.not. Chol)) then
  call WarningMessage(2,'Input error!; Aufbau not compatible with NDDO option')
  call Abend()
end if

if ((Invec < -1) .or. (InVec > 9)) then
  call WarningMessage(2,'Input error!; inappropriate value for Invec')
  call Abend()
end if

if ((nD == 1) .and. UHF_HFC) call sysAbendMsg('rdinp','incorrect input','HFC keyword should be used with UHF')

! Print out warning informations (if any)

if ((iFroz == 1) .and. ((InVec == 2) .or. (InVec == 4))) &
  call WarningMessage(1,'RdInp: Warning!;Option FROZEN is used together with input orbitals as initial guess.;'// &
                      'Freezing of orbitals is performed at MO level.;First orbitals in each symmetry will not be modified.')

if (Aufb .and. (iFroz == 1)) then
  do iSym=1,nSym
    nAufb(1) = nAufb(1)+nFro(iSym)
    if (nD == 2) nAufb(2) = nAufb(2)+nFro(iSym)
  end do
  nFro(1:nSym) = 0
  call WarningMessage(2,'Input error!;Aufbau not allowed with frozen orbitals')
  call Abend()
end if

! Check parameters for semi direct SCF

! If semi-direct and I/O buffer value not specified set to default value.
if ((nCore == 0) .and. (nDisc /= 0)) nCore = lDaRec*nSect*2*8/1024
nCore = ((nCore+7)/8)*8

! Adjust disk size to multiple of I/O buffer
if (nDisc /= 0) nDisc = (nDisc*1024+nCore-1)/1024

nDisc = min(10*Allocdisk(),nDisc)

! Set up parameters that follow from others

if ((.not. Diis) .and. (.not. Damping)) iDKeep = 0

if ((InVec == 3) .and. (max(nIter(0),nIter(1)) == 0)) then
  iPrOrb = 0
  jVOut = 0
end if

! Check Cholesky vs. Aufbau
if (Aufb .and. DoCholesky) then
  Cho_Aufb = .true.
  !write(u6,*)
  !write(u6,*) ' ********** WARNING! *********'
  !write(u6,*) ' Cholesky SCF runs much slower with AufBau !'
  !write(u6,*) ' *** Do you really need AufBau in this case? ***'
  !write(u6,*)
end if

! Check CONS vs. UHF+OCCU
if ((MxConstr > 0) .and. (nD-1+iOCCU /= 2)) then
  call WarningMessage(2,'For CONStraints, keywords UHF and OCCUpied are compulsory!')
  call Abend()
end if

! Check CONS vs. ADDC
if ((MxConstr == 0) .and. Do_Addc) then
  call WarningMessage(0,' In absence of CONStraints, ADDCorrelation is de-activated!')
  Do_Addc = .false.
end if

! Check CONS vs. SAVE
if ((MxConstr == 0) .and. Do_SpinAV) then
  call WarningMessage(0,' In absence of CONStraints, SAVErage is de-activated!')
  Do_SpinAV = .false.
end if

if (Do_SpinAV) DThr = 1.0e4_wp ! reset because it is not meaningful
if (MxConstr > 0) InVec = 6

! Check parameters of KS-DFT

if (KSDFT /= 'SCF') then
  if (MiniDn) then
    if (jPrint >= 2) call WarningMessage(0,' Minimized-density-differences option turned off!')
    MiniDn = .false.
  end if
  if (Do_OFemb .and. (dFMD /= Zero)) then
    call WarningMessage(0,' KSDFT/OFE requires DFMD=0 for correlation potential!')
    write(u6,*) ' dFMD = ',dFMD
  end if
else
  if (Do_OFemb .and. (dFMD /= One)) then
    call WarningMessage(0,' HF/OFE may require DFMD=1 for correlation potential!')
    write(u6,*) ' dFMD = ',dFMD
  end if
end if

! Check optimization methods
if (RSRFO .and. RGEK) then
  call WarningMessage(2,'Only one of RS-RFO and S-GEK can be specified!')
  call Abend()
end if
if (RGEK) then
  ! Default subspace expansion method
  if (Expand < 1) Expand = 1 ! DIIS
end if

call Put_iScalar('SCF mode',nD-1)

LKon = (ALGO == 4)

Method = 'RHF-SCF '
if (nD == 2) Method = 'UHF-SCF '
if (kIvo /= 0) Method = 'IVO-SCF '
if (KSDFT /= 'SCF') Method = 'KS-DFT  '
call Put_cArray('Relax Method',Method,8)

ExFac = Get_ExFac(KSDFT)
if ((ExFac == Zero) .and. (.not. TDen_UsrDef) .and. (.not. Do_OFemb)) DDnOFF = .false. ! use always differential density
!DDnOFF = .true.
!MiniDn = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
! remove local copy of standard input

call Close_LuSpool(LuSpool)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*
return

contains

subroutine Add_title_line()

  nTit = nTit+1
  if (nTit == 1) then
    Title(1) = Line(1:72)
  else
    if (nTit == 2) call WarningMessage(1,'More than one title line!')
  end if
  !if (nTit <= MxTit) Title(nTit) = Line(1:72)
  DoTit = .true.

end subroutine Add_title_line

subroutine Error_check()

  select case (istatus)
    case (:-1)
      call WarningMessage(2,'Input error!;End of input file for OCCNO or MCCNO option')
      call Abend()
    case (1:)
      call WarningMessage(2,'Input error!;Error reading input file for OCCNO or MCCNO option')
      call Abend()
  end select

end subroutine Error_check

end subroutine RdInp_scf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines:
c     grc43y
c     grc42y
c     grc32y
c     grc0
c     multdot
c
c     -------------------------------------------------------
c
       subroutine cct3_grc43y (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp4
       integer nhelp41,nhelp42,nhelp43
       integer ntest1,ntest2
       integer sa1,sa2,sa3,sa4,sb1,sb2,sb3,sa23,sa234,sb12
       integer nsymb2
       integer ia,ib,iy,ix
       integer possct
c
c     sctructure A(p,qrs)*B(qrs)=YC(p)
c
c1.0  prepare mapdc,mapic
c
       call cct3_grc0 (1,0,mapda(0,1),0,0,0,mmul(ssa,ssb),
     & possc0,possct,mapdc,mapic)
c
c1.1  define limitations - p,q>r,s must be tested - ntest1
c     p,q,r>s must be tested - ntest2
c
       if (mapda(0,6).eq.2) then
       ntest1=1
       else
       ntest1=0
       end if
c
       if (mapda(0,6).eq.3) then
       ntest2=1
       else
       ntest2=0
       end if
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sb1=1,nsym
       sa2=sb1
       if (ntest1.eq.1) then
       nsymb2=sb1
       else
       nsymb2=nsym
       end if
c
       do 101 sb2=1,nsymb2
       sb12=mmul(sb1,sb2)
       sa3=sb2
       sa23=mmul(sa2,sa3)
c
       sb3=mmul(ssb,sb12)
       sa4=sb3
       sa234=mmul(sa23,sa4)
       if ((ntest2.eq.1).and.(sb2.lt.sb3)) then
c     Meggie out
       goto 101
       end if
c
       sa1=mmul(ssa,sa234)
       if ((ntest1.eq.1).and.(sb1.lt.sb2)) then
c     Meggie out
       goto 101
       end if
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,sa3)
       ib=mapib(sb1,sb2,1)
       iy=mapic(1,1,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 101
       end if
c
c     rowA
       nhelp2=dimm(mapda(0,1),sa1)
c
c     sum
       nhelp41=dimm(mapda(0,2),sa2)
       nhelp42=dimm(mapda(0,3),sa3)
       nhelp43=dimm(mapda(0,4),sa4)
       if ((ntest1.eq.1).and.(sa2.eq.sa3)) then
       nhelp4=nhelp41*(nhelp41-1)*nhelp43/2
       else if ((ntest2.eq.1).and.(sa3.eq.sa4)) then
       nhelp4=nhelp41*nhelp42*(nhelp42-1)/2
       else
       nhelp4=nhelp41*nhelp42*nhelp43
       end if
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(iy,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=0
c
       ix=ix+1
c
 101    continue
 100    continue
       ix=ix-1
c
       return
       end
c
c     --------------------------------
c
       subroutine cct3_grc42y (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp4
       integer nhelp41,nhelp42,nhelp21,nhelp22
       integer ntest1,ntest2
       integer sa1,sa2,sa3,sa4,sb1,sb2,sa34,sa134
       integer ia,ib,iy,ix
       integer possct
c
c     sctructure A(pq,rs)*B(rs)=YC(pq)
c
c1.0  prepare mapdc,mapic
c
       if ((mapda(0,6).eq.1).or.(mapda(0,6).eq.4)) then
       ntest1=1
       else
       ntest1=0
       end if
c
       call cct3_grc0 (2,ntest1,mapda(0,1),mapda(0,2),0,0,mmul(ssa,ssb),
     & possc0,possct,mapdc,mapic)
c
c1.1  define limitations - p>q,r,s must be tested - ntest1
c     p,q,r>s must be tested - ntest2
c
       if ((mapda(0,6).eq.1).or.(mapda(0,6).eq.4)) then
       ntest1=1
       else
       ntest1=0
       end if
c
       if ((mapda(0,6).eq.3).or.(mapda(0,6).eq.4)) then
       ntest2=1
       else
       ntest2=0
       end if
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sb1=1,nsym
       sa3=sb1
c
       sb2=mmul(ssb,sb1)
       sa4=sb2
       sa34=mmul(sa3,sa4)
       if ((ntest2.eq.1).and.(sb1.lt.sb2)) then
c     Meggie out
       goto 100
       end if
c
       do 50 sa1=1,nsym
       sa134=mmul(sa1,sa34)
c
       sa2=mmul(ssa,sa134)
       if ((ntest1.eq.1).and.(sa1.lt.sa2)) then
c     Meggie out
       goto 50
       end if
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,sa3)
       ib=mapib(sb1,1,1)
       iy=mapic(sa1,1,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 50
       end if
c
c     rowA
       nhelp21=dimm(mapda(0,1),sa1)
       nhelp22=dimm(mapda(0,2),sa2)
       if ((ntest1.eq.1).and.(sa1.eq.sa2)) then
       nhelp2=nhelp21*(nhelp21-1)/2
       else
       nhelp2=nhelp21*nhelp22
       end if
c
c     sum
       nhelp41=dimm(mapda(0,3),sa3)
       nhelp42=dimm(mapda(0,4),sa4)
       if ((ntest2.eq.1).and.(sa3.eq.sa4)) then
       nhelp4=nhelp41*(nhelp41-1)/2
       else
       nhelp4=nhelp41*nhelp42
       end if
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(iy,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=0
c
       ix=ix+1
c
 50     continue
 100    continue
       ix=ix-1
c
       return
       end
c
c     --------------------------------
c
       subroutine cct3_grc32y (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp4
       integer nhelp41,nhelp42
       integer ntest1,ntest2
       integer sa1,sa2,sa3,sb1,sb2,sa23
       integer ia,ib,iy,ix
       integer possct
c
c     sctructure A(p,qr)*B(qr)=YC(p)
c
c1.0  prepare mapdc,mapic
c
       call cct3_grc0 (1,0,mapda(0,1),0,0,0,mmul(ssa,ssb),
     & possc0,possct,mapdc,mapic)
c
c1.1  define limitations - A p,q>r must be tested - ntest1
c     - B p>q must be tested - ntest2
c
       if (mapda(0,6).eq.2) then
       ntest1=1
       else
       ntest1=0
       end if
c
       if (mapdb(0,6).eq.1) then
       ntest2=1
       else
       ntest2=0
       end if
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sb1=1,nsym
       sa2=sb1
c
       sb2=mmul(ssb,sb1)
       sa3=sb2
       sa23=mmul(sa2,sa3)
       if ((ntest2.eq.1).and.(sb1.lt.sb2)) then
c     Meggie out
       goto 100
       end if
c
       sa1=mmul(ssa,sa23)
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,1)
       ib=mapib(sb1,1,1)
       iy=mapic(1,1,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 100
       end if
c
c     rowA
       nhelp2=dimm(mapda(0,1),sa1)
c
c     sum
       nhelp41=dimm(mapda(0,2),sa2)
       nhelp42=dimm(mapda(0,3),sa3)
       if ((ntest2.eq.1).and.(sa2.eq.sa3)) then
       nhelp4=nhelp41*(nhelp41-1)/2
       else
       nhelp4=nhelp41*nhelp42
       end if
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(iy,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=0
c
       ix=ix+1
c
 100    continue
       ix=ix-1
c
       return
       end
c
c     -----------------------------
c
       subroutine cct3_grc0 (nind,typ,typp,typq,typr,typs,stot,
     & poss0,posst,mapd,mapi)
c
c     this routine defines mapd and mapi for given intermediat
c
c     !N.B. (this routine cannot run with +OP2)
c
       integer nind,typ,typp,typq,typr,typs,stot,poss0,posst
c
#include "t31.fh"
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer sp,sq,sr,ss,spq,spqr
       integer nsymq,nsymr
       integer poss,i,nhelp1,nhelp2,nhelp3,nhelp4
c
c     To fix some compiler warnings
      poss=0
      i=0
c     vanishing mapi files
c
       do nhelp1=1,nsym
       do nhelp2=1,nsym
       do nhelp3=1,nsym
       mapi(nhelp3,nhelp2,nhelp1)=0
       end do
       end do
       end do
c
       if (nind.eq.1) then
c
c     matrix A(p)
c
       i=1
       poss=poss0
       sp=mmul(stot,1)
c
       nhelp1=dimm(typp,sp)
c
c     def mapi
       mapi(1,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       mapd(i,2)=nhelp1
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=0
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
       else if (nind.eq.2) then
c
c     matrix A(p,q)
c
       i=1
       poss=poss0
c
       do 100 sp=1,nsym
c
       sq=mmul(stot,sp)
       if ((typ.eq.1).and.(sp.lt.sq)) then
c     Meggie out
       goto 100
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
c
c     def mapi
       mapi(sp,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2
       end if
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 100    continue
c
       else if (nind.eq.3) then
c
c     matrix A(p,q,r)
c
       i=1
       poss=poss0
c
       do 200 sp=1,nsym
       if (typ.eq.1) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 201 sq=1,nsymq
       spq=mmul(sp,sq)
c
       sr=mmul(stot,spq)
       if ((typ.eq.2).and.(sq.lt.sr)) then
c     Meggie out
       goto 201
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
c
c     def mapi
       mapi(sp,sq,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)*nhelp3/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3
       end if
c
c     def sym p,q,r
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 201    continue
 200    continue
c
       else if (nind.eq.4) then
c
c     matrix A(p,q,r,s)
c
       i=1
       poss=poss0
c
       do 300 sp=1,nsym
       if ((typ.eq.1).or.(typ.eq.4)) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 301 sq=1,nsymq
       spq=mmul(sp,sq)
       if (typ.eq.2) then
       nsymr=sq
       else
       nsymr=nsym
       end if
c
       do 302 sr=1,nsymr
       spqr=mmul(spq,sr)
c
       ss=mmul(stot,spqr)
       if (((typ.eq.3).or.(typ.eq.4)).and.(sr.lt.ss)) then
c     Meggie out
       goto 302
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
       nhelp4=dimm(typs,ss)
c
c     def mapi
       mapi(sp,sq,sr)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp3-1)*nhelp4/2
       else if ((typ.eq.3).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else if (typ.eq.4) then
       if ((sp.eq.sq).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*(nhelp4-1)/4
       else if (sp.eq.sq) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if (sr.eq.ss) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
c
c     def sym p,q,r,s
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=ss
c
       poss=poss+mapd(i,2)
       i=i+1
c
 302    continue
 301    continue
 300    continue
c
       end if

c
       posst=poss
c
c     definition of other coll
c
       mapd(0,1)=typp
       mapd(0,2)=typq
       mapd(0,3)=typr
       mapd(0,4)=typs
       mapd(0,5)=i-1
       mapd(0,6)=typ
c
       return
       end
#ifdef _NOTUSED_
c
c     -----------------------------
c
       subroutine cct3_multdot (wrk,wrksize,
     & nind,mapda,mapia,ssa,mapdb,mapib,ssb,scalar,
     &                     rc)
c
c     this routine do dot product
c     scalar = A(ind)*B(ind)
c
c     nind        - number of indices in both A B (I)
c     mapda        - direct map of A (I)
c     mapia        - inverse map of A (I)
c     ssa        - symmetry state of A (I)
c     mapdb        - direct map of A (I)
c     mapib        - inverse map of A (I)
c     ssb        - symmetry state of B (I)
c     scalar        - final dot product (O)
c     rc        - return (error) code (O)
c
c     N.B. A and B must have same ordering of indexes
c
c     indA     indB     Implemented
c     1        1         Not yet
c     2        2           Yes
c     3        3           Yes
c     4        4           Yes
c     more              No
c
c
#include "wrk.fh"
c
       integer nind,ssa,ssb,rc
       real*8 scalar
c
       integer mapda(0:512,1:6)
       integer mapia(1:8,1:8,1:8)
c
       integer mapdb(0:512,1:6)
       integer mapib(1:8,1:8,1:8)
c
c     help variables
c
       integer symp,symq,symr,iia,iib,possa,possb,nhelp,lenght
       real*8 scal
c
       rc=0
c
cT    some tests
c
       do 10 nhelp=1,nind
       if (mapda(0,nhelp).ne.mapdb(0,nhelp)) then
c     RC =1 : nonidentical types of indices (NCI/Stup)
       rc=1
       return
       end if
 10     continue
c
       if (mapda(0,5).ne.mapdb(0,5)) then
c     RC =2 : nonidentical number of symmtry blocks in A and B (Stup)
       rc=2
       return
       end if
c
       if (mapda(0,6).ne.mapdb(0,6)) then
c     RC =3 : nonidentical type of A and B (Stup)
       rc=3
       return
       end if
c
       if (ssa.ne.ssb) then
c     RC =4 : nonidentical symmetry state of A and B (Stup)
       rc=4
       return
       end if
c

       if (nind.eq.4) then
c
cI    4 index matrices
c
       scalar=0.0d0
       do 100 iia=1,mapda(0,5)
c
cI.1  def parameters of A
       symp=mapda(iia,3)
       symq=mapda(iia,4)
       symr=mapda(iia,5)
c     syms is redundant
       possa=mapda(iia,1)
c
cI.2  def parameters of B
       iib=mapib(symp,symq,symr)
       possb=mapdb(iib,1)
c
cI.3  lenght must be common for both A and B
       lenght=mapda(iia,2)
c
       if (lenght.gt.0) then
       call cct3_mr0u3wt (lenght,lenght,lenght,1,1,wrk(possa),
     & wrk(possb),scal)
       scalar=scalar+scal
       end if
c
 100    continue
c
       else if (nind.eq.3) then
c
cII   3 index matrices
c
       scalar=0.0d0
       do 200 iia=1,mapda(0,5)
c
cII.1 def parameters of A
       symp=mapda(iia,3)
       symq=mapda(iia,4)
c     symr is redundant
       possa=mapda(iia,1)
c
cII.2 def parameters of B
       iib=mapib(symp,symq,1)
       possb=mapdb(iib,1)
c
cII.3 lenght must be common for both A and B
       lenght=mapda(iia,2)
c
       if (lenght.gt.0) then
       call cct3_mr0u3wt (lenght,lenght,lenght,1,1,wrk(possa),
     & wrk(possb),scal)
       scalar=scalar+scal
       end if
c
 200    continue
c
       else if (nind.eq.2) then
c
cIII  2 index matrices
c
       scalar=0.0d0
       do 300 iia=1,mapda(0,5)
c
cIII.1def parameters of A
       symp=mapda(iia,3)
c     symq is redundant
       possa=mapda(iia,1)
c
cIII.2def parameters of B
       iib=mapib(symp,1,1)
       possb=mapdb(iib,1)
c
cIII.3lenght must be common for both A and B
       lenght=mapda(iia,2)
c
       if (lenght.gt.0) then
       call cct3_mr0u3wt (lenght,lenght,lenght,1,1,wrk(possa),
     & wrk(possb),scal)
       scalar=scalar+scal
       end if
c
 300    continue
c
       else if (nind.eq.1) then
c
cIV   1 index matrices
c     RC=5 : 1 index matrices (NCI)
       rc=5
       return
c
       else
cV    more than 4 index matrices
c     RC=6 : more than 4 index matrices (NCI)
       rc=6
       return
       end if
c
c
       return
       end
c
c     -----------------------------
c
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefT3par(noa,nsym)
! this routine does:
! 0) Open t3nam file, with lunt3 lun
! define parameters, required for T3 integral handling, namely
! 1) def T3IndPos(i)
!    address positions for all occupied orbitals in t3nam file
! 2) def T3Off(ii,isym)
!    relative shifts of address for ii-th block of R_i(a,bc)
!    for each symmetry
!
! noa   - array with occupation numbers
! nsym  - actual number of irreps

use ccsort_global, only: daddr, lunt3, mapdri, mapiri, mbas, posri0
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: noa(8), nsym
#include "t3int.fh"
integer(kind=iwp) :: i, idum(1), ii, iorb, length, post, symi
real(kind=wp) :: dum(1)

!0  open t3nam file
!lunt3= 1
call daname(lunt3,t3nam)

!1 set address poiter to 0
daddr(lunt3) = 0

!2 first record in t3nam file is T3IntPos
!  (emulate writing of T3IntPos)
idum(1) = 0
dum(1) = Zero
call idafile(lunt3,0,idum,mbas,daddr(lunt3))

iorb = 0
!3 cycle over irreps
do symi=1,nsym

  !3.1 make mapd and mapi for  R_i(a,bc)
  call ccsort_t3grc0(3,8,4,4,4,0,symi,posri0,post,mapdri,mapiri)

  !3.2 cycle over occupied orbitals in symi
  do i=1,noa(symi)

    !3.2.1 save initial address for this orbital
    iorb = iorb+1
    T3IntPos(iorb) = daddr(lunt3)

    !3.2.2 emulate writing of mapd and mapp
    call idafile(lunt3,0,idum,513*6,daddr(lunt3))
    call idafile(lunt3,0,idum,8*8*8,daddr(lunt3))

    !3.2.3  cycle over all blocks of R_i(a,bc), which will be stored separately
    do ii=1,mapdri(0,5)

      !3.2.3.1 def T3Off(ii,symi)
      !        note, that iorb is always proper one, since only besides
      !        first occ. orbital in given irrep T3Off is defined
      if (i == 1) T3Off(ii,symi) = daddr(lunt3)-T3IntPos(iorb)

      !3.2.3.2 emulate writing of each block
      length = mapdri(ii,2)
      call ddafile(lunt3,0,dum,length,daddr(lunt3))

    end do
  end do
end do

return

end subroutine DefT3par

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_stats

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE

   ! Public procedures
   PUBLIC :: fmm_init_buffer_stats,      &
             fmm_init_matrix_stats,      &
             fmm_print_stats

   ! Public variables
   !-----------------

   REAL(REALK), POINTER, PUBLIC, SAVE :: stat_tpack_unique,      &
                                         stat_tpack_total,       &
                                         stat_tpack_chunks,      &
                                         stat_T_mat_builds,      &
                                         stat_W_mat_builds

   INTEGER(INTK), PUBLIC, SAVE :: stat_iteration=0,             &
                                  stat_n_basis=0,               &
                                  stat_points=0,                &
                                  stat_raw_moms_RHS=0,          &
                                  stat_pkd_moms_RHS=0,          &
                                  stat_screened_moms_RHS=0,     &
                                  stat_raw_moms_LHS=0,          &
                                  stat_pkd_moms_LHS=0,          &
                                  stat_deepest_level=0,         &
                                  stat_max_branch=0,            &
                                  stat_min_branch=10000,        &
                                  stat_level_saturation=0,      &
                                  stat_RHS_boxes(MAX_LEVEL)=0,  &
                                  stat_LHS_boxes(MAX_LEVEL)=0

   LOGICAL, PUBLIC, SAVE :: stat_NF_not_FF=.FALSE.

   ! Private variables
   !------------------

   REAL(REALK), TARGET, SAVE :: stat_T_direction_NF=0,    &
                                stat_T_matrix_NF=0,       &
                                stat_T_chunks_NF=0,       &
                                stat_T_total_NF=0,        &
                                stat_T_direction_FF=0,    &
                                stat_T_matrix_FF=0,       &
                                stat_T_chunks_FF=0,       &
                                stat_T_total_FF=0

   REAL(REALK), TARGET, SAVE :: stat_W_direction_RB=0,    &
                                stat_W_matrix_RB=0,       &
                                stat_W_total_RB=0,        &
                                stat_W_chunks_RB=0,       &
                                stat_W_direction_BB=0,    &
                                stat_W_matrix_BB=0,       &
                                stat_W_total_BB=0,        &
                                stat_W_chunks_BB=0,       &
                                stat_W_direction_BR=0,    &
                                stat_W_matrix_BR=0,       &
                                stat_W_total_BR=0,        &
                                stat_W_chunks_BR=0

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_buffer_stats(mode,W_mode)

      IMPLICIT NONE
      CHARACTER(LEN=1), INTENT(IN)           :: mode
      CHARACTER(LEN=7), OPTIONAL, INTENT(IN) :: W_mode

      SELECT CASE (mode)
         CASE ('T')
            IF (stat_NF_not_FF) THEN
               stat_tpack_chunks => stat_T_chunks_NF
               stat_tpack_unique => stat_T_direction_NF
               stat_tpack_total => stat_T_total_NF
            ELSE
               stat_tpack_chunks => stat_T_chunks_FF
               stat_tpack_unique => stat_T_direction_FF
               stat_tpack_total => stat_T_total_FF
            END IF
         CASE ('W')
            SELECT CASE (W_mode)
               CASE ('RAW_BOX')
                  stat_tpack_chunks => stat_W_chunks_RB
                  stat_tpack_unique => stat_W_direction_RB
                  stat_tpack_total => stat_W_total_RB
               CASE ('BOX_BOX')
                  stat_tpack_chunks => stat_W_chunks_BB
                  stat_tpack_unique => stat_W_direction_BB
                  stat_tpack_total => stat_W_total_BB
               CASE ('BOX_RAW')
                  stat_tpack_chunks => stat_W_chunks_BR
                  stat_tpack_unique => stat_W_direction_BR
                  stat_tpack_total => stat_W_total_BR
               CASE DEFAULT
                  CALL fmm_quit('cannot reconcile W runtype!')
            END SELECT
         CASE DEFAULT
            CALL fmm_quit('cannot reconcile buffer statistics requested')
      END SELECT

   END SUBROUTINE fmm_init_buffer_stats

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_matrix_stats(mode,W_mode)

      IMPLICIT NONE
      CHARACTER(LEN=1), INTENT(IN)           :: mode
      CHARACTER(LEN=7), OPTIONAL, INTENT(IN) :: W_mode

      SELECT CASE (mode)
         CASE ('T')
            IF (stat_NF_not_FF) THEN
               stat_T_mat_builds => stat_T_matrix_NF
            ELSE
               stat_T_mat_builds => stat_T_matrix_FF
            END IF
         CASE ('W')
            SELECT CASE (W_mode)
               CASE ('RAW_BOX')
                  stat_W_mat_builds => stat_W_matrix_RB
               CASE ('BOX_BOX')
                  stat_W_mat_builds => stat_W_matrix_BB
               CASE ('BOX_RAW')
                  stat_W_mat_builds => stat_W_matrix_BR
               CASE DEFAULT
                  CALL fmm_quit('cannot reconcile W runtype!')
            END SELECT
         CASE DEFAULT
            CALL fmm_quit('cannot reconcile buffer statistics requested')
      END SELECT

   END SUBROUTINE fmm_init_matrix_stats

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_print_stats

      IMPLICIT NONE
      INTEGER(INTK) :: i, RHS_tot, LHS_tot

      IF (.NOT. fmm_stats_printed) THEN
         RETURN
      END IF

      WRITE(LUPRI,'(/,A)') " Multipole method statistics"
      WRITE(LUPRI,'(A,/)') " ---------------------------"

      WRITE(LUPRI,'(A,I8)') " Number of AOs   =", stat_n_basis
      WRITE(LUPRI,'(A,I6)') " Deepest level   =", stat_deepest_level
      IF (stat_level_saturation > 0) &
         WRITE(LUPRI,*) 'deepest level saturated!', stat_level_saturation

      WRITE(LUPRI,'(A,I6)') " Max branch      =", stat_max_branch
      WRITE(LUPRI,'(A,I6)') " Min branch      =", stat_min_branch
      WRITE(LUPRI,'(/,A)') " Unboxed moments:"
      WRITE(LUPRI,'(A,7X,A,I9)') " RHS raw","=", stat_raw_moms_RHS
      WRITE(LUPRI,'(A,4X,A,I9)') " RHS packed","=", stat_pkd_moms_RHS
      WRITE(LUPRI,'(A,2X,A,I9)') " RHS screened","=", stat_screened_moms_RHS
      WRITE(LUPRI,'(A,7X,A,I9)') " LHS raw","=", stat_raw_moms_LHS
      WRITE(LUPRI,'(A,4X,A,I9)') " LHS packed","=", stat_pkd_moms_LHS

      LHS_tot = 0
      RHS_tot = 0
      DO i = stat_deepest_level, TOP_LEVEL, -1
         IF (stat_RHS_boxes(i) /= -1) THEN
            WRITE(LUPRI,'(A,I2)') " Boxes at level: ", i
            WRITE(LUPRI,'(A,5X,A,I9)') " RHS boxes","=", stat_RHS_boxes(i)
            RHS_tot = RHS_tot + stat_RHS_boxes(i)
         END IF
         IF (stat_LHS_boxes(i) /= -1) THEN
            WRITE(LUPRI,'(A,5X,A,I9)') " LHS boxes","=", stat_LHS_boxes(i)
            LHS_tot = LHS_tot + stat_LHS_boxes(i)
         END IF
      END DO
      WRITE(LUPRI,'(/,A,2X,A,I9)') " Total RHS boxes","=", RHS_tot
      WRITE(LUPRI,'(A,2X,A,I9)') " Total LHS boxes","=", LHS_tot

      IF (stat_T_total_NF > 0) THEN
         WRITE(LUPRI,'(/,A)') " NF contraction pairs"
         WRITE(LUPRI,'(A,E17.9)') " total interactions     =", &
                                    stat_T_total_NF
         WRITE(LUPRI,'(A,E17.9)') " total directions       =", &
                                    stat_T_direction_NF
         WRITE(LUPRI,'(A,E17.9)') " total buffer chunks    =", &
                                    stat_T_chunks_NF
         WRITE(LUPRI,'(A,E17.9)') " T matrices built       =", &
                                    stat_T_matrix_NF
      END IF
      WRITE(LUPRI,'(/,A)') " FF contraction pairs"
      WRITE(LUPRI,'(A,E17.9)') " total interactions     =", stat_T_total_FF
      WRITE(LUPRI,'(A,E17.9)') " total directions       =", stat_T_direction_FF
      WRITE(LUPRI,'(A,E17.9)') " total buffer chunks    =", stat_T_chunks_FF
      WRITE(LUPRI,'(A,E17.9)') " T matrices built       =", stat_T_matrix_FF

      WRITE(LUPRI,'(/,A)') " raw-box translations"
      WRITE(LUPRI,'(A,E17.9)') " total number         =", stat_W_total_RB
      WRITE(LUPRI,'(A,E17.9)') " total directions     =", stat_W_direction_RB
      WRITE(LUPRI,'(A,E17.9)') " total buffer chunks  =", stat_W_chunks_RB
      WRITE(LUPRI,'(A,E17.9)') " W matrices built     =", stat_W_matrix_RB

      WRITE(LUPRI,'(/,A)') " box-box translations"
      WRITE(LUPRI,'(A,E17.9)') " total number         =", stat_W_total_BB
      WRITE(LUPRI,'(A,E17.9)') " total directions     =", stat_W_direction_BB
      WRITE(LUPRI,'(A,E17.9)') " total buffer chunks  =", stat_W_chunks_BB
      WRITE(LUPRI,'(A,E17.9)') " W matrices built     =", stat_W_matrix_BB

      WRITE(LUPRI,'(/,A)') " box-raw translations"
      WRITE(LUPRI,'(A,E17.9)') " total number         =", stat_W_total_BR
      WRITE(LUPRI,'(A,E17.9)') " total directions     =", stat_W_direction_BR
      WRITE(LUPRI,'(A,E17.9)') " total buffer chunks  =", stat_W_chunks_BR
      WRITE(LUPRI,'(A,E17.9)') " W matrices built     =", stat_W_matrix_BR

      WRITE(LUPRI,'(/,A,/)') " ------------------------------------------"

   END SUBROUTINE fmm_print_stats

!-------------------------------------------------------------------------------

END MODULE fmm_stats

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombError(PrintNorm,ComputeF,Mode,PackedD,PackedF,nD,FactC,ip_D,F)
! Thomas Bondo Pedersen, January 2011.
!
! Purpose: compute Coulomb error
!
!      F(uv)-Ftilde(uv)= FactC * sum_kl { (uv|kl)-[uv|kl] } * D(kl)
!
!      where [uv|kl] are the LDF integrals.
!
! If ComputF: the LDF Fock matrix is computed here
! Else: on input, F should be the Fock matrix computed from
! LDF integrals (replaced with the error on exit)!

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
logical(kind=iwp), intent(in) :: PrintNorm, ComputeF, PackedD, PackedF
integer(kind=iwp), intent(in) :: Mode, nD, ip_D(nD)
real(kind=wp), intent(inout) :: FactC(nD), F(*)
logical(kind=iwp) :: Timing, Add
integer(kind=iwp) :: IntegralOption, ipF, lF, iD
real(kind=wp), allocatable :: myF(:)
real(kind=wp) :: ThrPS(2)
real(kind=r8), external :: ddot_
#include "localdf_bas.fh"

if (ComputeF) then
  IntegralOption = 0
  Timing = .false.
  ThrPS(1) = Zero
  ThrPS(2) = Zero
  Add = .false.
  call LDF_Fock_CoulombOnly(IntegralOption,Timing,Mode,ThrPS,Add,PackedD,PackedF,nD,FactC,ip_D,F)
end if

if (PackedF) then
  lF = nBas_Valence*(nBas_Valence+1)/2
else
  lF = nBas_Valence**2
end if
call mma_allocate(myF,nD*lF,label='myF')
IntegralOption = 222 ! use conventional integrals
Timing = .false.
ThrPS(1) = Zero
ThrPS(2) = Zero
Add = .false.
call LDF_Fock_CoulombOnly(IntegralOption,Timing,Mode,ThrPS,Add,PackedD,PackedF,nD,FactC,ip_D,myF)
do iD=1,nD
  ipF = (iD-1)*lF+1
  call dAXPY_(lF,-One,myF(ipF),1,F(ipF),1)
  call dScal_(lF,-One,F(ipF),1)
end do
call mma_deallocate(myF)

if (PrintNorm) then
  do iD=1,nD
    ipF = (iD-1)*lF+1
    write(u6,'(A,I10,A,1P,D20.10)') 'Norm of Coulomb error for density',iD,':',sqrt(dDot_(lF,F(ipF),1,F(ipF),1))
  end do
  call xFlush(u6)
end if

end subroutine LDF_Fock_CoulombError

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

!>  @brief
!>    Set breakpoints in code.
!>
!>  @author Oskar Weser
!>
!>  @details
!>    Either you call explicitly
!>    \code{.unparsed}
!>      break breakpoint
!>    \endcode
!>    when using gdb or you add the following commands
!>    \code{.unparsed}
!>      set breakpoint pending on
!>      break breakpoint
!>    \endcode
!>    to your ~/.gdbinit.
      subroutine breakpoint()
        return
      end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FOCKOC(FOCC,F,CMO)
! RASSCF program version IBM-3090: SX section
!
! PURPOSE: Construct a fock matrix for the occupied orbitals and
!          write it on the job interphase for later use in
!          the RASSCF gradient programs.
!          The fock matrix is in MO basis with the frozen orbitals
!          excluded. It is symmetry blocked in contrast to earlier
!          versions.
!
! called from FOCK if IFINAL=1.
!
! ********** IBM-3090 MOLCAS Release: 90 02 22 **********

use Index_Functions, only: nTri_Elem
use wadr, only: FockOcc
use rasscf_global, only: IADR15, NO2M
use general_data, only: JOBIPH, NASH, NBAS, NISH, NORB, NSYM, NTOT1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: FOCC(*)
real(kind=wp), intent(in) :: F(*), CMO(*)
real(kind=wp), allocatable :: SCR1(:), SCR2(:)
integer(kind=iwp) :: IAD15, iBas, iCMO, ij, IPQ, ISTFCK, ISYM, jBas, jFock, kl, lk, NAO, NIO, NO, NOO, NP, NQ

ISTFCK = 0
IPQ = 0
! Loop over symmetry:
do ISYM=1,NSYM
  NIO = NISH(ISYM)
  NAO = NASH(ISYM)
  NOO = NIO+NAO
  NO = NORB(ISYM)
  if (NOO /= 0) then
    do NP=1,NOO
      do NQ=1,NOO
        IPQ = IPQ+1
        FOCC(IPQ) = F(ISTFCK+NO*(NQ-1)+NP)
      end do
    end do
  end if
  ISTFCK = ISTFCK+NO**2
end do

IAD15 = IADR15(5)
call DDAFILE(JOBIPH,1,FOCC,IPQ,IAD15)

! Fock matrices added -- R L 921008.

! Start processing the all occupied indices Fock matrix

call mma_allocate(Scr1,no2m,Label='Scr1')
call mma_allocate(Scr2,no2m,Label='Scr2')
FockOcc(:) = Zero
#ifdef _DEBUGPRINT_
write(u6,*) 'nTot1=',nTot1
#endif

! Construct the occupied part of the Fock matrix in SO/AO basis.

ISTFCK = 1
jFock = 1
iCMo = 1
! A long loop over symmetry:
do ISYM=1,NSYM
  ! Hmm maybe you should check so I use correct nbas/norb
  NO = nOrb(isym)
  if (NO /= 0) then

    ! Transform to SO/AO basis.

#   ifdef _DEBUGPRINT_
    write(u6,*) 'iSym=',iSym
    call RecPrt('F(iStFck)',' ',F(iStFck),nOrb(iSym),nOrb(iSym))
    call RecPrt('CMO(iCMO)',' ',CMO(iCMO),nBas(iSym),nBas(iSym))
#   endif
    call DGEMM_('N','N', &
                nBas(iSym),nOrb(isym),nOrb(isym), &
                One,CMO(iCMo),nBas(iSym), &
                F(iStFck),nOrb(isym), &
                Zero,Scr1,nBas(iSym))
    call DGEMM_('N','T', &
                nBas(iSym),nBas(iSym),nOrb(isym), &
                One,Scr1,nBas(iSym), &
                CMO(iCMo),nBas(iSym), &
                Zero,Scr2,nBas(iSym))
    ij = jFock
    do iBas=1,nBas(iSym)
      do jBas=1,iBas-1
        kl = nBas(iSym)*(jBas-1)+iBas
        lk = nBas(iSym)*(iBas-1)+jBas
        FockOcc(ij) = Scr2(kl)+Scr2(lk)
        ij = ij+1
      end do
      kl = nBas(iSym)*(iBas-1)+iBas
      if (ij-jFock+1 > nTot1) then
        write(u6,*) ij,jFock,nTot1
        call Abend()
      end if
      FockOcc(ij) = Scr2(kl)
      ij = ij+1
    end do
  end if
# ifdef _DEBUGPRINT_
  call TriPrt('FAO',' ',FockOcc(jFock),nBas(iSym))
# endif
  jFock = jFock+nTri_Elem(nBas(iSym))
  iCMo = iCMo+nBas(iSym)**2
  ISTFCK = ISTFCK+NO**2
  ! End of long loop over symmetry
end do
call mma_deallocate(Scr2)
call mma_deallocate(Scr1)

! End of addition, R L 921008.

end subroutine FOCKOC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_fokunpck5 (symp,foka,fokb,dpa,dpb,dimfok,rc)
c
c     this routine produce dpa,dpb from foka,fokb
c     for some cases
c     shifto,shiftv will be also added
c
c     symp   - symmtry of this block
c     foka   - Fok aa matrix (I)
c     fokb   - Fok bb matrix (I)
c     dpa    - Diagonal part alfa vector (O)
c     dpa    - Diagonal part beta vector (O)
c     dimfok - dimension for Fok matrix - norb (I)
c     rc     - return (error) code
c
#include "t31.fh"
       integer symp,dimfok,rc
c
       real*8 foka(1:dimfok,1:dimfok)
       real*8 fokb(1:dimfok,1:dimfok)
       real*8 dpa(1:dimfok)
       real*8 dpb(1:dimfok)
c
c     help variables
c
       integer p,nhelp1,nhelp2
c
       rc=0
c
       if (typden.eq.0) then
c1    diagonal elements are required
c
       do 100 p=1,dimfok
       dpa(p)=foka(p,p)
       dpb(p)=fokb(p,p)
 100    continue
c
       else if (typden.eq.1) then
c2    (faa+fbb)/2 are required
c
       do 200 p=1,dimfok
       dpa(p)=(foka(p,p)+fokb(p,p))/2
       dpb(p)=dpa(p)
 200    continue
c
       else if (typden.eq.2) then
c3    orbital energies are required
c
c3.1  def shift
       if (symp.eq.1) then
       nhelp1=0
       else
       nhelp1=0
       do 300 nhelp2=1,symp-1
       nhelp1=nhelp1+norb(nhelp2)
 300    continue
       end if
c
c3.2  map oe to dp
       do 400 p=1,dimfok
       dpa(p)=eps(nhelp1+p)
       dpb(p)=eps(nhelp1+p)
 400    continue
c
       else
c     RC=1 : invalid key (NCI/Stup)
       rc=1
       end if
c
       if ((keysa.eq.3).or.(keysa.eq.4)) then
c     for full adaptation scheme only D and V orbitals are shifted
c
       do 501 p=1,nob(symp)
       dpa(p)=dpa(p)-shifto
       dpb(p)=dpb(p)-shifto
 501    continue
c
       do 502 p=1+noa(symp),norb(symp)
       dpa(p)=dpa(p)+shiftv
       dpb(p)=dpb(p)+shiftv
 502    continue
c
       else
c     for other schemes all orbitals are shifted
c
       do 511 p=1,noa(symp)
       dpa(p)=dpa(p)-shifto
 511    continue
c
       do 512 p=1,nob(symp)
       dpb(p)=dpb(p)-shifto
 512    continue
c
       do 513 p=1+noa(symp),norb(symp)
       dpa(p)=dpa(p)+shiftv
 513    continue
c
       do 514 p=1+nob(symp),norb(symp)
       dpb(p)=dpb(p)+shiftv
 514    continue
c
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!               2017, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  LinEqSolv
!
!> @brief
!>   Solve linear equations \f$ Ax=B \f$ or \f$ A^\text{T}x=B \f$ where
!>   \f$ A \f$ is a general nonsingular matrix
!> @author Thomas Bondo Pedersen
!> @modified_by Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> For \p TransA(1:1) = ``'N'`` or ``'n'``,
!> this routine solves the equations \f$ Ax = B \f$ for any number of
!> righthand sides stored as columns of the matrix \f$ B \f$. For
!> \p TransA(1:1) = ``'T'`` or ``'t'``, the equations \f$ A^\text{T}x = B \f$ are
!> solved.
!>
!> The solution vectors are stored as columns of \p B on exit. Note
!> that array \p A will be destroyed during the solution (the matrix
!> is replaced by its factors obtained by Gaussian elimination).
!>
!> Return codes are:
!>
!> - \p irc = ``-1``: input error(s) detected and nothing has been done.
!> - \p irc =  ``0``: successful completion.
!> - \p irc =  ``1``: \p A is estimated to be singular and no solution vectors have been computed.
!>
!> @note
!> 4 * \p nDim real and 2 * \p nDim integer words of memory must be available
!> on entry.
!>
!> @param[out]    irc    Return code
!> @param[in]     TransA Transposition of \p A
!> @param[in,out] A      Array containing the nonsingular matrix \p A on entry and the factorized matrix (Gaussian elimination)
!>                       on exit
!> @param[in]     ldA    Leading dimension of \p A
!> @param[in,out] B      Array containing righthand sides of equations on entry and solution vectors on exit
!> @param[in]     ldB    Leading dimension of \p B
!> @param[in]     nDim   Column dimension of \p A
!> @param[in]     nEq    Number of equations, i.e. column dimension of \p B
!***********************************************************************

subroutine LinEqSolv(irc,TransA,A,ldA,B,ldB,nDim,nEq)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
character(len=*), intent(in) :: TransA
integer(kind=iwp), intent(in) :: ldA, ldB, nDim, nEq
real(kind=wp), intent(inout) :: A(ldA,nDim), B(ldB,nEq)
integer(kind=iwp) :: iErr, lTransA
real(kind=wp) :: AN, RC
character :: myTransA
integer(kind=iwp), allocatable :: iPivot(:), iScr(:)
real(kind=wp), allocatable :: Scr(:)
real(kind=wp), external :: DLANGE_

! Test input.
! -----------

irc = 0
if ((nEq < 1) .or. (nDim < 1)) return
if ((ldA < nDim) .or. (ldB < nDim)) then
  irc = -1 ! dimension error
  return
end if

! Translate TransA to integer Job to be used by DGESL.
! ----------------------------------------------------

lTransA = len(TransA)
if (lTransA > 0) then
  myTransA = TransA(1:1)
else
  irc = -1 ! TransA error
  return
end if

if ((myTransA /= 'N') .and. (myTransA /= 'n') .and. (myTransA /= 'T') .and. (myTransA /= 't')) then
  irc = -1 ! TransA error
  return
end if

! Allocate pivot array and scratch space
! --------------------------------------

call mma_allocate(iPivot,nDim,label='LES_Pivot')
call mma_allocate(Scr,4*nDim,label='LES_Scr')
call mma_allocate(iScr,nDim,label='LES_iScr')

! Factor A by Gaussian elimination and estimate reciprocal condition
! number (RC). Check for singularity.
! ------------------------------------------------------------------

RC = Zero
AN = DLANGE_('1',nDim,nDim,A,ldA,Scr)
call DGETRF_(nDim,nDim,A,ldA,iPivot,iErr)
call DGECON_('1',nDim,A,ldA,AN,RC,Scr,iScr,iErr)
if ((One+RC == One) .or. (iErr > 0)) then
  irc = 1 ! error: A is (probably) singular
else

  ! Solve equations.
  ! ----------------

  call DGETRS_(myTransA,nDim,nEq,A,ldA,iPivot,B,ldB,iErr)
  if (iErr > 0) irc = 1 ! error: A is (probably) singular

end if

! Deallocations.
! --------------

call mma_deallocate(iPivot)
call mma_deallocate(Scr)
call mma_deallocate(iScr)

end subroutine LinEqSolv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005,2006, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine PAO_Analysis(D,R,X)
C
C     Thomas Bondo Pedersen, December 2005.
C     - revised January 2006 (Thomas Bondo Pedersen).
C
C     Purpose: test and analysis of Cholesky PAOs.
C
      Implicit Real*8 (a-h,o-z)
      Real*8 D(*), R(*), X(*)
#include "Molcas.fh"
#include "inflocal.fh"
#include "WrkSpc.fh"

      l_S = nBas(1)**2
      Do iSym = 2,nSym
         l_S = l_S + nBas(iSym)**2
      End Do
      Call GetMem('S','Allo','Real',ip_S,l_S)
      Call GetOvlp_Localisation(Work(ip_S),'Sqr',nBas,nSym)
      Call PAO_Ana1(D,R,X,Work(ipMOrig),Work(ip_S),
     &              nBas,nFro,nOrb2Loc,nSym,Name,nAtoms,AnaNrm)
      Call GetMem('S','Free','Real',ip_S,l_S)

      End
      SubRoutine PAO_Ana1(D,R,X,C,S,nBas,nFro,nOrb2Loc,nSym,
     &                    Nam,nAtoms,AnaNrm)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
      Integer nBas(nSym), nFro(nSym), nOrb2Loc(nSym)
      Real*8  D(*), R(*), X(*), C(*), S(*)
      Character*(LENIN8) Nam(*)
      Character*3 AnaNrm
#include "WrkSpc.fh"

      Character*8 SecNam
      Parameter (SecNam = 'PAO_Ana1')

      Character*14 FilNam
      Logical Debug

      external ddot_

      Parameter (Tol = 1.0d-10)

C     Initialization.
C     ---------------

      Debug = .False.

C     Tests:
C     0) RR^T = XX^T = D (check of decomposition)
C     1) Co^TSX = 0 (check that X is orthogonal to the orthogonal
C                    complement space).
C     2) C^TSX is non-singular (check that X spans primary space)
C     ===========================================================

      Write(6,*) 'Testing PAOs...'
      nErr = 0

C     Test 0.
C     -------

      l_Tst = nBas(1)**2
      Do iSym = 2,nSym
         l_Tst = max(l_Tst,nBas(iSym)**2)
      End Do
      Call GetMem('TstDen','Allo','Real',ip_Tst,l_Tst)

      kOff = 1
      Do iSym = 1,nSym
         nB = nBas(iSym)
         nB2 = nB**2
         nF = nFro(iSym)
         nO = nOrb2Loc(iSym)
         Call GetDens_Localisation(Work(ip_Tst),R(kOff),nB,nB)
         Call dAXPY_(nB2,-1.0d0,D(kOff),1,Work(ip_Tst),1)
         If (nB2 .gt. 0) Then
            xB2 = 1.0d0/dble(nB2)
            xRMS = sqrt(xB2*dDot_(nB2,Work(ip_Tst),1,Work(ip_Tst),1))
         Else
            xRMS = 0.0d0
         End If
         If (xRMS .gt. Tol) Then
            Write(6,'(A,A,D16.8,A,I2,A)')
     &      SecNam,': ERROR: RMS(D-RR^T) = ',xRMS,' (sym.',
     &      iSym,')'
            nErr = nErr + 1
         End If
         kOffX = kOff + nB*nF
         Call GetDens_Localisation(Work(ip_Tst),X(kOffX),nB,nO)
         Call dAXPY_(nB2,-1.0d0,D(kOff),1,Work(ip_Tst),1)
         If (nB2 .gt. 0) Then
            xB2 = 1.0d0/dble(nB2)
            xRMS = sqrt(xB2*dDot_(nB2,Work(ip_Tst),1,Work(ip_Tst),1))
         Else
            xRMS = 0.0d0
         End If
         If (xRMS .gt. Tol) Then
            Write(6,'(A,A,D16.8,A,I2,A)')
     &      SecNam,': ERROR: RMS(D-XX^T) = ',xRMS,' (sym.',
     &      iSym,')'
            nErr = nErr + 1
         End If
         kOff = kOff + nB2
      End Do

C     Compute SX.
C     -----------

      l_SX = nBas(1)*nOrb2Loc(1)
      Do iSym = 2,nSym
         l_SX = l_SX + nBas(iSym)*nOrb2Loc(iSym)
      End Do
      Call GetMem('SX','Allo','Real',ip_SX,l_SX)

      kOff = 1
      kSX  = ip_SX
      Do iSym = 1,nSym
         nB = max(nBas(iSym),1)
         kX = kOff + nBas(iSym)*nFro(iSym)
         Call DGEMM_('N','N',nBas(iSym),nOrb2Loc(iSym),nBas(iSym),
     &              1.0d0,S(kOff),nB,X(kX),nB,
     &              0.0d0,Work(kSX),nB)
         kSX  = kSX  + nBas(iSym)*nOrb2Loc(iSym)
         kOff = kOff + nBas(iSym)*nBas(iSym)
      End Do

C     Test 1.
C     First frozen part of orthogonal complement, then the rest.
C     ----------------------------------------------------------

      kC   = 1
      kSX  = ip_SX
      kTst = ip_Tst
      Do iSym = 1,nSym
         nB = max(nBas(iSym),1)
         nF = max(nFro(iSym),1)
         nRest = nBas(iSym) - nFro(iSym) - nOrb2Loc(iSym)
         nR = max(nRest,1)
         Call DGEMM_('T','N',nFro(iSym),nOrb2Loc(iSym),nBas(iSym),
     &              1.0d0,C(kC),nB,Work(kSX),nB,
     &              0.0d0,Work(kTst),nF)
         nFO = nFro(iSym)*nOrb2Loc(iSym)
         If (nFO .gt. 0) Then
            xFO = 1.0d0/dble(nFO)
            xRMS = sqrt(xFO*dDot_(nFO,Work(kTst),1,Work(kTst),1))
         Else
            xRMS = 0.0d0
         End If
         If (xRMS .gt. Tol) Then
            Write(6,'(A,A,D16.8,A,I2,A)')
     &      SecNam,': ERROR: RMS(Co^TSX [Frozen]) = ',xRMS,' (sym.',
     &      iSym,')'
            nErr = nErr + 1
         End If
         kCR = kC + nBas(iSym)*(nFro(iSym)+nOrb2Loc(iSym))
         Call DGEMM_('T','N',nRest,nOrb2Loc(iSym),nBas(iSym),
     &              1.0d0,C(kCR),nB,Work(kSX),nB,
     &              0.0d0,Work(kTst),nR)
         nRO = nRest*nOrb2Loc(iSym)
         If (nRO .gt. 0) Then
            xRO = 1.0d0/dble(nRO)
            xRMS = sqrt(xRO*dDot_(nRO,Work(kTst),1,Work(kTst),1))
         Else
            xRMS = 0.0d0
         End If
         If (xRMS .gt. Tol) Then
            Write(6,'(A,A,D16.8,A,I2,A)')
     &      SecNam,': ERROR: RMS(Co^TSX [Rest]) = ',xRMS,' (sym.',
     &      iSym,')'
            nErr = nErr + 1
         End If
         kC  = kC  + nBas(iSym)*nBas(iSym)
         kSX = kSX + nBas(iSym)*nOrb2Loc(iSym)
      End Do

C     Test 2.
C     -------

      kC   = 1
      kSX  = ip_SX
      kTst = ip_Tst
      Do iSym = 1,nSym
         nB = max(nBas(iSym),1)
         nO = max(nOrb2Loc(iSym),1)
         kCO = kC + nBas(iSym)*nFro(iSym)
         Call DGEMM_('T','N',nOrb2Loc(iSym),nOrb2Loc(iSym),nBas(iSym),
     &              1.0d0,C(kCO),nB,Work(kSX),nB,
     &              0.0d0,Work(kTst),nO)
         l_EigR = nOrb2Loc(iSym)
         l_EigI = nOrb2Loc(iSym)
         Call GetMem('EigR','Allo','Real',ip_EigR,l_EigR)
         Call GetMem('EigI','Allo','Real',ip_EigI,l_EigI)
         iGetVecs = 0
         Call Diag_Localisation(Work(kTst),Work(ip_EigR),Work(ip_EigI),
     &                          nOrb2Loc(iSym),iGetVecs)
         kOffR = ip_EigR - 1
         kOffI = ip_EigI - 1
         Do i = 1,nOrb2Loc(iSym)
            xNrm = sqrt(Work(kOffR+i)**2+Work(kOffI+i)**2)
            If (xNrm .lt. Tol) Then
               Write(6,'(A,A,I6,A,A,D16.8,A,I2,A)')
     &         SecNam,': ERROR: ||eigenvalue',i,'|| of ',
     &         'C^TSX = ',xNrm,' (sym.',iSym,')'
               nErr = nErr + 1
            End If
         End Do
         Call GetMem('EigI','Free','Real',ip_EigI,l_EigI)
         Call GetMem('EigR','Free','Real',ip_EigR,l_EigR)
         kC  = kC  + nBas(iSym)*nBas(iSym)
         kSX = kSX + nBas(iSym)*nOrb2Loc(iSym)
      End Do

      Call GetMem('SX','Free','Real',ip_SX,l_SX)
      Call GetMem('TstDen','Free','Real',ip_Tst,l_Tst)

C     Overall check.
C     --------------

      If (nErr .ne. 0) Then
         Call SysAbendMsg(SecNam,'PAO localization failed!',' ')
      Else
         Write(6,*) '...OK!'
      End If

C     Analysis.
C     This part does not work with symmetry.
C     ======================================

      If (nSym .ne. 1) Then
         Write(6,*)
         Write(6,*) SecNam,': symmetry not implemented for analysis',
     &              ' of PAOs. Sorry!'
         Return
      End If

C     Allocate atom based density and CMO matrices.
C     ---------------------------------------------

      lDAt = nAtoms**2
      lRAt = nAtoms*nBas(1)
      lXAt = nAtoms*nOrb2Loc(1)
      Call GetMem('DAt','Allo','Real',ipDAt,lDAt)
      Call GetMem('RAt','Allo','Real',ipRAt,lRAt)
      Call GetMem('XAt','Allo','Real',ipXAt,lXAt)

C     Allocate and get index arrays for basis functions per atom.
C     -----------------------------------------------------------

      l_nBas_per_Atom = nAtoms
      l_nBas_Start    = nAtoms
      Call GetMem('nB_per_Atom','Allo','Inte',
     &            ip_nBas_per_Atom,l_nBas_per_Atom)
      Call GetMem('nB_Start','Allo','Inte',
     &            ip_nBas_Start,l_nBas_Start)
      Call BasFun_Atom(iWork(ip_nBas_per_Atom),iWork(ip_nBas_Start),
     &                 Nam,nBas(1),nAtoms,Debug)

C     Generate bitmaps.
C     -----------------

      Call GetAt_Localisation(D,nBas(1),nBas(1),Work(ipDAt),nAtoms,2,
     &                        iWork(ip_nBas_per_Atom),
     &                        iWork(ip_nBas_Start),AnaNrm)
      Call GetAt_Localisation(R,nBas(1),nBas(1),Work(ipRAt),nAtoms,1,
     &                        iWork(ip_nBas_per_Atom),
     &                        iWork(ip_nBas_Start),AnaNrm)
      kOffX = nBas(1)*nFro(1) + 1
      Call GetAt_Localisation(X(kOffX),nBas(1),nOrb2Loc(1),
     &                        Work(ipXAt),nAtoms,1,
     &                        iWork(ip_nBas_per_Atom),
     &                        iWork(ip_nBas_Start),AnaNrm)
      Write(FilNam,'(A)') 'PAO_Dnsty1.bmp'
      Call GenBMp_Loc(Work(ipDat),nAtoms,nAtoms,FilNam,'r')
      Write(FilNam,'(A)') 'PAO_LnDep1.bmp'
      Call GenBMp_Loc(Work(ipRat),nAtoms,nBas(1),FilNam,'r')
      Write(FilNam,'(A)') 'PAO_Chole1.bmp'
      Call GenBMp_Loc(Work(ipXat),nAtoms,nOrb2Loc(1),FilNam,'r')
      Write(6,*) 'Bitmap files have been generated. Norm: ',AnaNrm

C     Deallocations.
C     --------------

      Call GetMem('nB_Start','Free','Inte',
     &            ip_nBas_Start,l_nBas_Start)
      Call GetMem('nB_per_Atom','Free','Inte',
     &            ip_nBas_per_Atom,l_nBas_per_Atom)
      Call GetMem('XAt','Free','Real',ipXAt,lXAt)
      Call GetMem('RAt','Free','Real',ipRAt,lRAt)
      Call GetMem('DAt','Free','Real',ipDAt,lDAt)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Ignacio Fdez. Galvan                             *
************************************************************************
*  Sp_Unpack
*
*> @ingroup Sparse
*> @brief
*>   Converts a sparse matrix to a dense (conventional) one
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Unpacks the sparse matrix \p Sp into a conventional dense matrix \p A.
*>
*> @param[in]  n     Size of the matrix
*> @param[in]  Sp    Input matrix, in sparse format
*> @param[in]  ij_Sp Index vector of matrix \p Sp
*> @param[out] A     Output matrix, in dense (conventional) format
************************************************************************
      SUBROUTINE Sp_Unpack(n,Sp,ij_Sp,A)
      IMPLICIT NONE
      INTEGER n, ij_Sp(*), i, j, k
      REAL*8 Sp(*), A(n,n)
#include "real.fh"

      CALL FZero(A,n*n)
      IF (Sp(n+1).GT.Zero) THEN
        DO i=1,n
          A(i,i)=Sp(i)
          DO k=ij_Sp(i),ij_Sp(i+1)-1
            j=ij_Sp(k)
            A(i,j)=Sp(k)
            A(j,i)=Sp(k)
          END DO
        END DO
      ELSE
        DO i=1,n
          A(i,i)=Sp(i)
          DO k=ij_Sp(i),ij_Sp(i+1)-1
            j=ij_Sp(k)
            A(i,j)=Sp(k)
          END DO
        END DO
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkV_Q22 (W2,W1,dima)
c
c       this routine do
c       W1(j,u,i,a') = 2W2(i,u,j,a')-W2(j,u,i,a')
c
c       N.B. Kvajt odflaknute
c
        implicit none
#include "chcc1.fh"
        integer dima
        real*8 W1(1:no,1:no,1:no,1:dima)
        real*8 W2(1:no,1:no,1:no,1:dima)
c
c       help variables
        integer i,j,u,a
c
c
        do a=1,dima
        do i=1,no
        do u=1,no
        do j=1,no
          W1(j,u,i,a)=W2(j,u,i,a)-2.0d0*W2(i,u,j,a)
        end do
        end do
        end do
        end do
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ccsort_grc0(nind,typ,typp,typq,typr,typs,stot,post,map)
! this routine defines %d and %i for given intermediate

use ccsort_global, only: Map_Type, noa, nob, NSYM, nva, nvb
use Symmetry_Info, only: Mul
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nind, typ, typp, typq, typr, typs, stot
integer(kind=iwp), intent(out) :: post
type(Map_Type), intent(_OUT_) :: map
integer(kind=iwp) :: dimm(4,8), i, nhelp1, nhelp2, nhelp3, nhelp4, nsymq, nsymr, pos, sp, spq, spqr, sq, sr, ss

! !!!!!!!! def dimm to je tu len terazky !!!!

dimm(1,1:nsym) = noa(1:nsym)
dimm(2,1:nsym) = nob(1:nsym)
dimm(3,1:nsym) = nva(1:nsym)
dimm(4,1:nsym) = nvb(1:nsym)

! vanishing %i files

map%i(1:nsym,1:nsym,1:nsym) = 0

!  To get rid of tiring compiler warning
i = 1
pos = map%pos0
if (nind == 1) then

  ! matrix A(p)
  sp = mul(stot,1)

  nhelp1 = dimm(typp,sp)

  ! def map%i
  map%i(1,1,1) = i

  ! def position
  map%d(i,1) = pos

  ! def length
  map%d(i,2) = nhelp1

  ! def sym p,q
  map%d(i,3) = sp
  map%d(i,4) = 0
  map%d(i,5) = 0
  map%d(i,6) = 0

  pos = pos+map%d(i,2)
  i = i+1

else if (nind == 2) then

  ! matrix A(p,q)

  do sp=1,nsym

    sq = mul(stot,sp)
    ! Meggie out
    if ((typ == 1) .and. (sp < sq)) cycle

    nhelp1 = dimm(typp,sp)
    nhelp2 = dimm(typq,sq)

    ! def map%i
    map%i(sp,1,1) = i

    ! def position
    map%d(i,1) = pos

    ! def length
    if ((typ == 1) .and. (sp == sq)) then
      map%d(i,2) = nhelp1*(nhelp1-1)/2
    else
      map%d(i,2) = nhelp1*nhelp2
    end if

    ! def sym p,q
    map%d(i,3) = sp
    map%d(i,4) = sq
    map%d(i,5) = 0
    map%d(i,6) = 0

    pos = pos+map%d(i,2)
    i = i+1

  end do

else if (nind == 3) then

  ! matrix A(p,q,r)

  do sp=1,nsym
    if (typ == 1) then
      nsymq = sp
    else
      nsymq = nsym
    end if

    do sq=1,nsymq
      spq = mul(sp,sq)

      sr = mul(stot,spq)
      ! Meggie out
      if ((typ == 2) .and. (sq < sr)) cycle

      nhelp1 = dimm(typp,sp)
      nhelp2 = dimm(typq,sq)
      nhelp3 = dimm(typr,sr)

      ! def map%i
      map%i(sp,sq,1) = i

      ! def position
      map%d(i,1) = pos

      ! def length
      if ((typ == 1) .and. (sp == sq)) then
        map%d(i,2) = nhelp1*(nhelp1-1)*nhelp3/2
      else if ((typ == 2) .and. (sq == sr)) then
        map%d(i,2) = nhelp1*nhelp2*(nhelp2-1)/2
      else
        map%d(i,2) = nhelp1*nhelp2*nhelp3
      end if

      ! def sym p,q,r
      map%d(i,3) = sp
      map%d(i,4) = sq
      map%d(i,5) = sr
      map%d(i,6) = 0

      pos = pos+map%d(i,2)
      i = i+1

    end do
  end do

else if (nind == 4) then

  ! matrix A(p,q,r,s)

  do sp=1,nsym
    if ((typ == 1) .or. (typ == 4)) then
      nsymq = sp
    else
      nsymq = nsym
    end if

    do sq=1,nsymq
      spq = mul(sp,sq)
      if (typ == 2) then
        nsymr = sq
      else
        nsymr = nsym
      end if

      do sr=1,nsymr
        spqr = mul(spq,sr)

        ss = mul(stot,spqr)
        ! Meggie out
        if (((typ == 3) .or. (typ == 4)) .and. (sr < ss)) cycle

        nhelp1 = dimm(typp,sp)
        nhelp2 = dimm(typq,sq)
        nhelp3 = dimm(typr,sr)
        nhelp4 = dimm(typs,ss)

        ! def map%i
        map%i(sp,sq,sr) = i

        ! def position
        map%d(i,1) = pos

        ! def length
        if ((typ == 1) .and. (sp == sq)) then
          map%d(i,2) = nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
        else if ((typ == 2) .and. (sq == sr)) then
          map%d(i,2) = nhelp1*nhelp2*(nhelp3-1)*nhelp4/2
        else if ((typ == 3) .and. (sr == ss)) then
          map%d(i,2) = nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
        else if (typ == 4) then
          if ((sp == sq) .and. (sr == ss)) then
            map%d(i,2) = nhelp1*(nhelp2-1)*nhelp3*(nhelp4-1)/4
          else if (sp == sq) then
            map%d(i,2) = nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
          else if (sr == ss) then
            map%d(i,2) = nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
          else
            map%d(i,2) = nhelp1*nhelp2*nhelp3*nhelp4
          end if
        else
          map%d(i,2) = nhelp1*nhelp2*nhelp3*nhelp4
        end if

        ! def sym p,q,r,s
        map%d(i,3) = sp
        map%d(i,4) = sq
        map%d(i,5) = sr
        map%d(i,6) = ss

        pos = pos+map%d(i,2)
        i = i+1

      end do
    end do
  end do

end if

post = pos

! definition of other coll

map%d(0,1) = typp
map%d(0,2) = typq
map%d(0,3) = typr
map%d(0,4) = typs
map%d(0,5) = i-1
map%d(0,6) = typ

return

end subroutine ccsort_grc0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_CheckBackTra(iTyp,COcc,CVir,lU_AO)
C
C     Thomas Bondo Pedersen, Jan. 2008.
C
C     Purpose: check backtransformation of vectors (MO->AO).
C              A summary is printed at the end of this routine.
C
C     The check is simple, comparing the quantities
C
C        X(J) = sum_alpha,beta L(J;alpha,beta)
C        Y(J) = sum_ai L(ai,J)*P(a)*P(i)
C
C     where
C
C        P(i) = sum_alpha COcc(i,alpha)
C        P(a) = sum_alpha CVir(alpha,a)
C
C     The reported abs. min., abs. max, average, and RMS errors
C     are calculated from the vector
C
C        D(J) = X(J) - Y(J)
C
      Implicit None
      Integer iTyp
      Real*8  COcc(*), CVir(*)
      Integer lU_AO(*)
#include "real.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "chomp2.fh"
#include "stdalloc.fh"

      Real*8, External:: ddot_

      Real*8  Err(4,8)
      Real*8  AbsMinErr, AbsMaxErr, AvgErr, RMSErr
      Integer nMP2Vec_Tot

      Integer iSym, iSyma, iSymi, iSymAl, iSymBe
      Integer i, a, Al, AlBe, nAlBe, na, J
      Integer kP, kP_, kC
      Integer iOpt, lTot, iAdr
      Integer nOcc_Max

      Real*8, Allocatable:: POcc(:), PVir(:), Q(:), X(:), Y(:), D(:),
     &                      V(:)

      Integer MulD2h, k, l
      MulD2h(k,l)=iEOr(k-1,l-1)+1

C     Initializations.
C     ----------------

      nMP2Vec_Tot = 0

      AvgErr = Zero
      RMSErr = Zero

      nOcc_Max = nOcc(1)
      Do iSym = 2,nSym
         nOcc_Max = max(nOcc_Max,nOcc(iSym))
      End Do

      Call mma_allocate(POcc,nOccT,Label='POcc')
      Call mma_allocate(PVir,nVirT,Label='PVir')
      Call mma_allocate(Q,nOcc_Max,Label='Q')

C     P(i) = sum_alpha COcc(i,alpha)
C     ------------------------------

      POcc(:)=Zero
      Do iSymi = 1,nSym
         iSymAl = iSymi
         If (nOcc(iSymi).gt.0 .and. nBas(iSymAl).gt.0) Then
            kP = iOcc(iSymi)
            Do Al = 1,nBas(iSymAl)
               kC = iT1AOT(iSymi,iSymAl) + nOcc(iSymi)*(Al-1)
               Do i = 1,nOcc(iSymi)
                  POcc(kP+i) = POcc(kP+i) + COcc(kC+i)
               End Do
            End Do
         End If
      End Do

C     P(a) = sum_alpha CVir(alpha,a)
C     ------------------------------

      PVir(:)=Zero
      Do iSyma = 1,nSym
         iSymAl = iSyma
         If (nVir(iSyma).gt.0 .and. nBas(iSymAl).gt.0) Then
            kP_ = iVir(iSyma)
            Do a = 1,nVir(iSyma)
               kP = kP_ + a
               kC = iAOVir(iSymAl,iSyma) + nBas(iSymAl)*(a-1)
               Do Al = 1,nBas(iSyma)
                  PVir(kP) = PVir(kP) + CVir(kC+Al)
               End Do
            End Do
         End If
      End Do

C     Check each symmetry block.
C     --------------------------

      Do iSym = 1,nSym

         If (nMP2Vec(iSym) .gt. 0) Then

C           Allocation.
C           -----------

            Call mma_allocate(X,nMP2Vec(iSym),Label='X')
            Call mma_allocate(Y,nMP2Vec(iSym),Label='Y')

C           Zero result arrays.
C           -------------------

            X(:)=Zero
            Y(:)=Zero

C           X(J) = sum_alpha,beta L(J;alpha,beta)
C           -------------------------------------

            nAlBe = 0
            Do iSymBe = 1,nSym
               iSymAl = MulD2h(iSymBe,iSym)
               nAlBe = nAlBe + nBas(iSymAl)*nBas(iSymBe)
            End Do

            Call mma_allocate(V,nMP2Vec(iSym),Label='V')
            Do AlBe = 1,nAlBe
               iOpt = 2
               lTot = nMP2Vec(iSym)
               iAdr = nMP2Vec(iSym)*(AlBe-1) + 1
               Call ddaFile(lU_AO(iSym),iOpt,V,lTot,iAdr)
              Call dAXPY_(nMP2Vec(iSym),1.0d0,V,1,X,1)
            End Do
            Call mma_deallocate(V)

C           Y(J) = sum_ai L(ai,J)*P(a)*P(i)
C           -------------------------------

            Call mma_allocate(V,nT1Am(iSym),Label='V')
            iOpt = 1
            Call ChoMP2_OpenF(iOpt,iTyp,iSym)
            Do J = 1,nMP2Vec(iSym)
               iOpt = 2
               lTot = nT1Am(iSym)
               iAdr = nT1Am(iSym)*(J-1) + 1
               Call ddaFile(lUnit_F(iSym,iTyp),iOpt,V,lTot,iAdr)
               Do iSymi = 1,nSym
                  iSyma = MulD2h(iSymi,iSym)
                  na = max(nVir(iSyma),1)
                  Call dGeMV_('T',nVir(iSyma),nOcc(iSymi),
     &                       1.0d0,V(1+iT1Am(iSyma,iSymi)),na,
     &                             PVir(1+iVir(iSyma)),1,
     &                       0.0d0,Q,1)
                  Y(J) = Y(J) + dDot_(nOcc(iSymi),Q,1,
     &                                POcc(1+iOcc(iSymi)),1)
               End Do
            End Do
            iOpt = 2
            Call ChoMP2_OpenF(iOpt,iTyp,iSym)
            Call mma_deallocate(V)

C           Calculate errors.
C           -----------------

            Call mma_allocate(D,nMP2Vec(iSym),Label='D')
            Call dCopy_(nMP2Vec(iSym),X,1,D,1)
            Call dAXPY_(nMP2Vec(iSym),-1.0d0,Y,1,D,1)
            Err(1,iSym) = abs(D(1))
            Err(2,iSym) = abs(D(1))
            Err(3,iSym) =     D(1)
            Do J = 1,nMP2Vec(iSym)-1
               Err(1,iSym) = min(Err(1,iSym),abs(D(1+J)))
               Err(2,iSym) = max(Err(2,iSym),abs(D(1+J)))
               Err(3,iSym) =     Err(3,iSym)   + D(1+J)
            End Do
            AvgErr = AvgErr + Err(3,iSym)
            Err(3,iSym) = Err(3,iSym)/dble(nMP2Vec(iSym))
            Err(4,iSym) = dDot_(nMP2Vec(iSym),D,1,D,1)
            RMSErr = RMSErr + Err(4,iSym)
            Err(4,iSym) = Err(4,iSym)/dble(nMP2Vec(iSym))
            Err(4,iSym) = sqrt(Err(4,iSym))
            Call mma_deallocate(D)

C           Deallocation.
C           -------------

            Call mma_deallocate(Y)
            Call mma_deallocate(X)

         Else

            Call FZero(Err(1,iSym),4)

         End If

         If (iSym .eq. 1) Then
            AbsMinErr = Err(1,iSym)
            AbsMaxErr = Err(2,iSym)
            nMP2Vec_Tot = max(nMP2Vec(iSym),0)
         Else
            AbsMinErr = min(AbsMinErr,Err(1,iSym))
            AbsMaxErr = max(AbsMaxErr,Err(2,iSym))
            nMP2Vec_Tot = nMP2Vec_Tot + max(nMP2Vec(iSym),0)
         End If

      End Do

      AvgErr = AvgErr/dble(nMP2Vec_Tot)
      RMSErr = RMSErr/dble(nMP2Vec_Tot)
      RMSErr = sqrt(RMSErr)

C     Report.
C     -------

      Call Cho_Head('MO Vector Backtransformation Check','=',80,6)
      Write(6,'(/,2X,A,A,/,2X,A,A)')
     & 'Symmetry  Min. Abs. Error  Max. Abs. Error    Average Error',
     & '        RMS Error',
     & '-----------------------------------------------------------',
     & '-----------------'
      Do iSym = 1,nSym
         Write(6,'(4X,I2,4X,1P,4(3X,D14.6))')
     &   iSym,(Err(i,iSym),i=1,4)
      End Do
      Write(6,'(2X,A,A)')
     & '-----------------------------------------------------------',
     & '-----------------'
      Write(6,'(2X,A,2X,1P,4(3X,D14.6))')
     & 'Total:',AbsMinErr,AbsMaxErr,AvgErr,RMSErr
      Write(6,'(2X,A,A,/)')
     & '-----------------------------------------------------------',
     & '-----------------'

C     Free memory.
C     ------------

      Call mma_deallocate(Q)
      Call mma_deallocate(PVir)
      Call mma_deallocate(POcc)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT_C78d(T2,Tp,Tm,dimbe,dimbepp,addbepp,no)
! this routine does:
! T2n(be',ga',u,v) <<-
! C7                    T2+(bega",uv)
! C8                    T2-(bega",uv)
! for beGrp=gaGrp, beSGrp=gaSGrp
! N.B. calc only contributions to be',ga' (not ga',be')

use Index_Functions, only: nTri_Elem
use Constants, only: One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimbe, dimbepp, addbepp, no
real(kind=wp), intent(inout) :: T2(dimbe,dimbe,no,no)
real(kind=wp), intent(in) :: Tp(nTri_Elem(dimbepp),nTri_Elem(no)), Tm(nTri_Elem(dimbepp-1),nTri_Elem(no-1))
integer(kind=iwp) :: be, bega, bep, u, uv, v
real(kind=wp) :: fact

!1 Distribute symmetric T2+ on proper positions

uv = 0
do u=1,no
  do v=1,u
    uv = uv+1
    if (u == v) then
      fact = Half
    else
      fact = One
    end if

    ! case be"/=ga"
    bep = addbepp+1
    do be=2,dimbepp
      bega = nTri_Elem(be-1)
      bep = bep+1

      T2(bep,addbepp+1:addbepp+be-1,u,v) = T2(bep,addbepp+1:addbepp+be-1,u,v)+Tp(bega+1:bega+be-1,uv)*fact
      T2(bep,addbepp+1:addbepp+be-1,v,u) = T2(bep,addbepp+1:addbepp+be-1,v,u)+Tp(bega+1:bega+be-1,uv)*fact
      !T2(addbepp+1:addbepp+be-1,bep,u,v) = T2(addbepp+1:addbepp+be-1,bep,u,v)+Tp(bega+1:bega+be-1,uv)*fact
      !T2(addbepp+1:addbepp+be-1,bep,v,u) = T2(addbepp+1:addbepp+be-1,bep,v,u)+Tp(bega+1:bega+be-1,uv)*fact

    end do

    ! case be=ga
    bep = addbepp
    do be=1,dimbepp
      bega = nTri_Elem(be)
      bep = bep+1

      T2(bep,bep,u,v) = T2(bep,bep,u,v)+Tp(bega,uv)*fact
      T2(bep,bep,v,u) = T2(bep,bep,v,u)+Tp(bega,uv)*fact

    end do

  end do
end do

!2 Distribute anti-symmetric T2- on proper positions

uv = 0
do u=2,no
  do v=1,u-1
    uv = uv+1

    bep = addbepp+1
    bega = 0
    do be=2,dimbepp
      bep = bep+1

      T2(bep,addbepp+1:addbepp+be-1,u,v) = T2(bep,addbepp+1:addbepp+be-1,u,v)+Tm(bega+1:bega+be-1,uv)
      T2(bep,addbepp+1:addbepp+be-1,v,u) = T2(bep,addbepp+1:addbepp+be-1,v,u)-Tm(bega+1:bega+be-1,uv)
      !T2(addbepp+1:addbepp+be-1,bep,u,v) = T2(addbepp+1:addbepp+be-1,bep,u,v)-Tm(bega+1:bega+be-1,uv)
      !T2(addbepp+1:addbepp+be-1,bep,v,u) = T2(addbepp+1:addbepp+be-1,bep,v,u)+Tm(bega+1:bega+be-1,uv)

      bega = bega+be-1
    end do

  end do
end do

return

end subroutine MkT_C78d

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine frenkelexc(Frenkeltri, dim, nst1, nst2)

      use Constants, only: Zero, One, Two, Three, auToEV
      use Definitions, only: wp, iwp, u6
      use frenkel_global_vars, only: iTyp, jTyp, nestla, nestlb,
     &                               valst, excl
      use stdalloc, only: mma_allocate, mma_deallocate

      IMPLICIT None
      integer(kind=iwp) :: dim, nst1, nst2
      real(kind=wp), intent(inout) :: Frenkeltri(dim*(dim+1)/2)

      integer(kind=iwp) :: d1lines, d2lines, a, b, ntrans, tri, iPL,
     &                     run, LUT3, LUT1, I, J, IO, K, L, iPrintLevel
      real(kind=wp) :: GS, DIPNORM
      real(kind=wp), allocatable :: Frenkelsq(:), Frenkelquad(:,:),
     &                              Freninterm(:,:), Freninterm2(:,:)
      real(kind=wp), allocatable :: D1X(:), D1Y(:), D1Z(:), D2X(:),
     &               D2Z(:), Dip1(:,:,:), Dip2(:,:,:),
     &               EigEn(:),EDIFF(:), OSCSTR(:),Rassi1(:),
     &               Rassi2(:),Frenkeldia(:,:),D2Y(:),
     &               DipFrx(:,:), DipFry(:,:), DipFrz(:,:),
     &               DipFrintermx(:,:), DipFrintermy(:,:),
     &               DipFrintermz(:,:),DipFrintermx2(:,:),
     &               DipFrintermy2(:,:),DipFrintermz2(:,:),
     &               EigEnHa(:), E_FRENKEL(:)
      integer(kind=iwp), allocatable :: I1(:), F1(:), I2(:), F2(:)
      integer(kind=iwp), external :: isFreeUnit
      character(len=13) :: filnam, filnam1, filnam2, filnam3
      character(len=8), allocatable :: Hamelembra(:), Hamelemket(:)
#ifdef _DEBUGPRINT_RASSI_
      logical :: debug_rassi_code = .true.
#else
      logical :: debug_rassi_code = .false.
#endif


222   FORMAT (5X,2(1X,I4),5X,3(1X,ES18.8))
2     FORMAT(5X,(1x,I4,3x,I4,3x,F18.8,3x,F18.8,3x,
     &       F18.8,3x,F18.8,3x,F18.8))
3     FORMAT(6X,A,5x,A,6x,A,6x,A,19x,A,19x,A,19x,A)
443   FORMAT(3x,I4,3x,I4,3x,F18.8,3x,F18.8,3x,F18.8)
551   FORMAT(5X,A,4x,A,10x,A,20x,A,20x,A)

      call GETPRINTLEVEL
      iPL = iPrintLevel(-1)

      call mma_allocate(Frenkelsq,dim*dim)
      call mma_allocate(Frenkeldia,dim,dim)
      call mma_allocate(Freninterm,dim,dim)
      call mma_allocate(Freninterm2,dim,dim)
      call mma_allocate(Frenkelquad,dim,dim)
      call mma_allocate(Rassi1,nst1)
      call mma_allocate(Rassi2,nst2)
      call mma_allocate(E_FRENKEL,dim)

      ! read in rassi energies of both monomers to add them
      ! to the diagonal elements
      if (debug_rassi_code) then
        write(u6,*) 'iTyp=', iTyp, 'jTyp=', jTyp
      end if

      if (iTyp < jTyp) then
        write(u6,*) 'Monomer B was calculated first.'
        write(u6,*) 'Index 1 refers to A.'
      else
        write(u6,*) 'Monomer A was calculated first.'
        write(u6,*) 'Index 1 refers to B.'
        iTyp=2
        jTyp=1
      end if

      write(filnam2,'(A,I1)') 'stE', iTyp
      LuT3 = 11
      LuT1 = isFreeUnit(LuT3)

      call molcas_open(LuT1,filnam2)
      write(u6,'(A,1X,I1,A,I3.3)') 'Number of states of system'
     &      ,iTyp,'=',nst1
      write(u6,'(A,1X,I1,A,I3.3)') 'Number of states of system'
     &      ,jTyp,'=',nst2
      do i=1,nst1
        read(LuT1,*)Rassi1(i)
      end do
      close(LuT1)

      write(filnam3,'(A,I1)') 'stE', jTyp
      LuT3 = 11
      LuT1 = isFreeUnit(LuT3)

      call molcas_open(LuT1,filnam3)
      do i=1,nst2
        read(LuT1,*)Rassi2(i)
      end do
      close(LuT1)

      ! add rassi energies to diag of exciton coupl matrix
      do i=1,nst1
        write(u6,*)'State energy of system 1', Rassi1(i)
      end do
      do i=1,nst2
        write(u6,*)'State energy of system 2', Rassi2(i)
      end do

      tri=0
      do a=1,nst1
        do b=1,nst2
          if ((a/=1) .or. (b/=1)) then
            if (EXCL) then
              if ((ALL(nestla /= a)) .or. (ALL(nestlb /= b))) then
                cycle
              end if
            else
              if((a <= valst) .and. (b <= valst)) cycle
              if((a > valst) .and. (b > valst)) cycle
            end if
          end if
          tri = tri + 1
          Frenkeltri((tri*(tri+1))/2) = Frenkeltri((tri*(tri+1))/2)
     &          + Rassi1(a) + Rassi2(b)
          if (debug_rassi_code) then
            write(u6,*)'tri counter', tri
            write(u6,*) 'add energies 1 and 2', Rassi1(a), Rassi2(b)
          end if
        end do
      end do

      ! subtract gs energy
      gs = Frenkeltri(1)
      do i=1,dim
        Frenkeltri((i*(i+1))/2) = Frenkeltri((i*(i+1))/2) - gs
      end do
      ! convert to eV
      Frenkeltri(:) = Frenkeltri(:)*auToEV

      ! make a full Hamilton matrix from the lower triangular
      call square(Frenkeltri,Frenkelsq,1,dim,dim)
      if (debug_rassi_code) then
       write(u6,*) 'Frenkelsq:'
       do i=1,dim
         write(u6,'(1000ES18.8)') (Frenkelsq(j+(i-1)*dim),j=1,dim)
       enddo
      endif
      ! form a real quadratic matrix from Frenkelsq -> Frenkelquad
      run = 0
      do i=1,dim
        do j=1,dim
          run= run + 1
          Frenkelquad(i,j) = Frenkelsq(run)
        end do
      end do


      call mma_allocate(Hamelembra,dim)
      call mma_allocate(Hamelemket,dim)
      tri=0
      do a=1,nst1
        do b=1,nst2
          if ((a /= 1) .or. (b /= 1)) then
            if (EXCL) then
              if ((ALL(nestla /= a)) .or. (All(nestlb /= b))) then
                cycle
              end if
            else
              if ((a <= valst) .and. (b <= valst)) cycle
              if ((a > valst) .and. (b > valst)) cycle
            end if
          end if
          tri = tri + 1
          write(Hamelemket(tri),'(A,I3.3,I3.3,A)') '|',a,b,'>'
          write(Hamelembra(tri),'(A,I3.3,I3.3,A)') '<',a,b,'|'
        end do
      end do

      write(u6,*)'Frenkel Hamiltonian [eV]:'
      write(u6,'(11X)',advance='NO')
      write(u6,'(100(A,8X))',advance='YES') (Hamelemket(i),i=1,dim)

      do i=1,dim
        write(u6,'(A,1X,100(ES16.8))') Hamelembra(i),
     &        (Frenkelquad(i,j),j=1,dim)
      end do

      write(u6,*) 'Frenkel eigenvectors (column wise):'
      write(u6,'(11X)',advance="NO")
      write(u6,'(100(I3.3,13X))',advance="YES") (i,i=1,dim)

      call NIdiag_New(Frenkeltri, Frenkeldia, dim, dim)

      do i=1,dim
        write(u6,'(A,1X,100(ES16.8))') Hamelembra(i),
     &  (Frenkeldia(i,j),j=1,dim)
      end do

      write(u6,*) 'Hamiltonian eigenvalues [eV]:'
      do i=1,dim
        E_FRENKEL(i) = Frenkeltri((i*(i+1))/2)
        write(u6,*) Frenkeltri((i*(i+1))/2)
      end do

      call Add_Info('E_FRENKEL',E_FRENKEL,dim,6)

      call mma_deallocate(E_FRENKEL)
      call mma_deallocate(Hamelembra)
      call mma_deallocate(Hamelemket)


      if (debug_rassi_code) then
        call dgemm_('N','N',dim,dim,dim,One,Frenkelquad,dim,
     &              Frenkeldia,dim,Zero,Freninterm,dim)

        write(u6,*) 'first trafo H*U'
        do i=1,dim
          write(u6,'(1000ES18.8)') (Freninterm(i,j),j=1,dim)
        end do
        call dgemm_('T','N',dim,dim,dim,One,Frenkeldia,dim,
     &              Freninterm,dim,Zero,Freninterm2,dim)
        write(u6,*) 'second trafo U^(t)HU (should be diagonal)'
        do i=1,dim
          write(u6,'(1000ES18.8)') (Freninterm2(i,j),j=1,dim)
        end do
      end if

      ntrans = 0
      do i=1,dim-1
        ntrans = ntrans + i
      end do

      d1lines = 0
      d2lines = 0
      ! search for number of lines in the dipvec files
      write(filnam, '(A,I1)') 'dip_vec', iTyp
      LuT3 = 11
      LuT1 = isFreeUnit(LuT3)
      call molcas_open(LuT1, filnam)
      do
        read(LuT1, *, iostat=io)
        if (io/=0) exit
        d1lines = d1lines + 1
      end do
      close(LuT1)

      write(filnam1, '(A,I1)') 'dip_vec', jTyp
      LuT3 = 11
      LuT1 = isFreeUnit(LuT3)
      call molcas_open(LuT1, filnam1)
      do
        read(LuT1,*,iostat=io)
        if (io /= 0) exit
        d2lines = d2lines + 1
      end do
      close(LuT1)

      if (debug_rassi_code) then
        write(u6,*) 'd1lines ', d1lines
        write(u6,*) 'd2lines ', d2lines
        write(u6,*) 'ntrans' , ntrans
      end if

      call mma_allocate(I1,d1lines)
      call mma_allocate(F1,d1lines)
      call mma_allocate(D1X,d1lines)
      call mma_allocate(D1Y,d1lines)
      call mma_allocate(D1Z,d1lines)
      call mma_allocate(I2,d2lines)
      call mma_allocate(F2,d2lines)
      call mma_allocate(D2X,d2lines)
      call mma_allocate(D2Y,d2lines)
      call mma_allocate(D2Z,d2lines)
      call mma_allocate(Dip1,nst1,nst1,3)
      call mma_allocate(Dip2,nst2,nst2,3)
      call mma_allocate(EigEn,dim)
      call mma_allocate(EigEnHa,dim)
      call mma_allocate(EDIFF,ntrans)
      call mma_allocate(OSCSTR,ntrans)
      call mma_allocate(DipFrx,dim,dim)
      call mma_allocate(DipFry,dim,dim)
      call mma_allocate(DipFrz,dim,dim)
      call mma_allocate(DipFrintermx,dim,dim)
      call mma_allocate(DipFrintermx2,dim,dim)
      call mma_allocate(DipFrintermy,dim,dim)
      call mma_allocate(DipFrintermy2,dim,dim)
      call mma_allocate(DipFrintermz,dim,dim)
      call mma_allocate(DipFrintermz2,dim,dim)


      write(filnam, '(A,I1)') 'dip_vec', iTyp
      LuT3 = 11
      LuT1 = isFreeUnit(LuT3)
      call molcas_open(LuT1, filnam)
      do i=1,d1lines
        read(LuT1,222) I1(i), F1(i), D1X(i), D1Y(i), D1Z(i)
      end do
      close(LuT1)

      write(filnam1, '(A,I1)') 'dip_vec', jTyp
      LuT3 = 11
      LuT1 = isFreeUnit(LuT3)
      call molcas_open(LuT1, filnam1)
      do i=1,d2lines
        read(LuT1,222) I2(i), F2(i), D2X(i), D2Y(i), D2Z(i)
      end do
      close(LuT1)

      ! fill dipole matrices and use symmetry
      Dip1(:,:,:)=Zero
      do i=1,d1lines
        Dip1(I1(i),F1(i),1) = D1X(i)
        Dip1(I1(i),F1(i),2) = D1Y(i)
        Dip1(I1(i),F1(i),3) = D1Z(i)
        Dip1(F1(i),I1(i),1) = D1X(i)
        Dip1(F1(i),I1(i),2) = D1Y(i)
        Dip1(F1(i),I1(i),3) = D1Z(i)
      end do

      write(u6, *) 'Transition dipole vectors of system 1:'
      write(u6, 551) 'from','to','x','y','z'
      do i=1,d1lines
        write(u6,443)  I1(i), F1(i),
     &        (Dip1(I1(i),F1(i),j),j=1,3)
      end do

      Dip2(:,:,:) = Zero
      do i=1,d2lines
        Dip2(I2(i),F2(i),1) = D2X(i)
        Dip2(I2(i),F2(i),2) = D2Y(i)
        Dip2(I2(i),F2(i),3) = D2Z(i)
        Dip2(F2(i),I2(i),1) = D2X(i)
        Dip2(F2(i),I2(i),2) = D2Y(i)
        Dip2(F2(i),I2(i),3) = D2Z(i)
      end do

      write(u6, *) 'Transition dipole vectors of system 2:'
      write(u6, 551) 'from','to','x','y','z'
      do i=1,d2lines
        write(u6,443)  I2(i), F2(i),
     &        (Dip2(I2(i),F2(i),j),j=1,3)
      end do

      write(u6, *) 'relative excitonic state eigenenergies [eV]:'
      do i=1,dim
        EigEn(i) = Frenkeltri((i*(i+1))/2) - Frenkeltri(1)
        write(u6, *) 'EigEn:',i , EigEn(i)
      end do

      if (iPL >= 3) then
        write(u6,*) 'relative excitonic state '//
     &              'eigenenergies in hartree:'
        do i=1,dim
          EigEnHa(i) = (Frenkeltri((i*(i+1))/2)-Frenkeltri(1))/auToEV
          write(u6,*) 'EigEn:',i , EigEnHa(i)
        end do
      end if

      ! create x
      a = 0
      b = 0
      DipFrx(:,:) = Zero
      do i=1,nst1
        do k=1,nst2
          if ((i /= 1) .or. (k /= 1)) then
            if (excl) then
              if ((All(nestla /= i)) .or. (ALL(nestlb /= k))) then
                cycle
              end if
            else
              if ((i <= valst) .and. (k <= valst)) cycle
              if ((i > valst) .and. (k > valst)) cycle
            end if
          end if
          a = a + 1
          b = 0
          do j=1,nst1
            do l=1,nst2
              if ((j /= 1) .or. (l /= 1)) then
                if (EXCL) then
                  if ((ALL(nestla /= j)) .or. (ALL(nestlb /= l))) then
                    cycle
                  end if
                else
                  if ((j <= valst) .and. (l <= valst)) cycle
                  if ((j > valst) .and. (l > valst)) cycle
                end if
              end if
              b = b + 1
              if (k == l) then
                DipFrx(a,b) = Dip1(i,j,1)
              end if
              if (i == j) then
                DipFrx(a,b) = Dip2(k,l,1)
              end if
            end do
          end do
        end do
      end do

      if (iPL >= 3) then
        write(u6,*) 'DipFrx:'
        do i=1,dim
          write(u6,'(100ES18.8)') (DipFrx(i,j),j=1,dim)
        end do
      end if
      ! transform dipole matrix in dipole basis
      call dgemm_('N','N',dim,dim,dim,One,DipFrx,dim,
     &            Frenkeldia,dim,Zero,DipFrintermx,dim)

      call dgemm_('T','N',dim,dim,dim,One,Frenkeldia,dim,
     &            DipFrintermx,dim,Zero,DipFrintermx2,dim)

      if (iPL >= 3) then
        write(u6,*) 'trafo U^(t)DU, dipole mtx in exc. basis, X'
        do i=1,dim
          write(u6,'(100ES18.8)') (DipFrintermx2(i,j),j=1,dim)
        end do
      end if
      ! create y
      a = 0
      b = 0
      DipFry(:,:) = Zero
      do i=1,nst1
        do k=1,nst2
          if ((i /= 1) .or. (k /= 1)) then
            if (EXCL) then
              if ((ALL(nestla /= i)) .or. (ALL(nestlb /= k))) then
                cycle
              end if
            else
              if ((i <= valst) .and. (k <= valst)) cycle
              if ((i > valst) .and. (k > valst)) cycle
            end if
          end if
          a = a + 1
          b = 0
          do j=1,nst1
            do l=1,nst2
              if ((j /= 1) .or. (l /= 1)) then
                if (EXCL) then
                  if ((ALL(nestla /= j)) .or. (ALL(nestlb /= l))) then
                    cycle
                  end if
                else
                  if ((j <= valst) .and. (l <= valst)) cycle
                  if ((j > valst) .and. (l > valst)) cycle
                end if
              end if
              b = b + 1
              if (k == l) then
                DipFry(a,b)=Dip1(I,J,2)
              end if
              if (i == j) then
                DipFry(a,b)=Dip2(K,L,2)
              end if
            end do
          end do
        end do
      end do

      if (iPL >= 3) then
        write(u6,*) 'DipFry:'
        do i=1,dim
          write(u6,'(100ES18.8)') (DipFry(i,j),j=1,dim)
        end do
      end if

      ! transform dipole matrix in dipole basis
      call dgemm_('N','N',dim,dim,dim,One,DipFry,dim,
     &            Frenkeldia,dim,Zero,DipFrintermy,dim)

      call dgemm_('T','N',dim,dim,dim,One,Frenkeldia,dim,
     &            DipFrintermy,dim,Zero,DipFrintermy2,dim)
      if (iPL >= 3) then
        write(u6,*) 'trafo U^(t)DU, dipole mtx in exc. basis, Y'
        do i=1,dim
          write(u6,'(100ES18.8)') (DipFrintermy2(i,j),j=1,dim)
        end do
      end if

      ! create z
      a = 0
      b = 0
      DipFrz(:,:) = Zero
      do i=1,nst1
        do k=1,nst2
          if ((i /= 1) .or. (k /= 1)) then
            if (excl) then
              if ((ALL(nestla /= i)) .or. (ALL(nestlb /= k))) then
                cycle
              end if
            else
              if ((i <= valst) .and. (k <= valst)) cycle
              if ((i > valst) .and. (k > valst)) cycle
            end if
          end if
          a = a + 1
          b = 0
          do j=1,nst1
            do l=1,nst2
              if ((j /= 1) .or. (l /= 1)) then
                if (excl) then
                  if ((ALL(nestla /= j)) .or. (ALL(nestlb /= l))) then
                    cycle
                  end if
                else
                  if ((j <= valst) .and. (l <= valst)) cycle
                  if ((j > valst) .and. (l > valst)) cycle
                end if
              end if
              b = b + 1
              if (k == l) then
                if ((k > 1) .and. (l > 1)) cycle
                DipFrz(a,b)=Dip1(I,J,3)
              end if
              if (i == j) then
                DipFrz(a,b) = Dip2(K,L,3)
              end if
            end do
          end do
        end do
      end do
      if (iPL >= 3) then
        write(u6,*) 'DipFrz:'
        do i=1,dim
          write(u6,'(100ES18.8)') (DipFrz(i,j),j=1,dim)
        end do
      end if

      ! transform dipole matrix in dipole basis
      call dgemm_('N','N',dim,dim,dim,One,DipFrz,dim,
     &            Frenkeldia,dim,Zero,DipFrintermz,dim)

      call dgemm_('T','N',dim,dim,dim,One,Frenkeldia,dim,
     &            DipFrintermz,dim,Zero,DipFrintermz2,dim)
      if (iPL >= 3) then
        write(u6,*) 'trafo U^(t)DU, dipole mtx in exc. basis, Z'
        do i=1,dim
          write(u6,'(100ES18.8)') (DipFrintermz2(i,j),j=1,dim)
        end do
      end if

      ! calc and print spectrum
      run = 0
      write(u6,*) 'Excitonic absorption spectrum'
      write(u6,3) 'from','to','excitation energy [eV]',
     &       'Dx','Dy','Dz','osc.str.'
      do i=1,dim
        do j=i+1,dim
          run = run + 1
          EDIFF(run) = EigEn(j) - EigEn(i)
          dipnorm = DipFrintermx2(i,j)*DipFrintermx2(i,j) +
     &          DipFrintermy2(i,j)*DipFrintermy2(i,j) +
     &          DipFrintermz2(i,j)*DipFrintermz2(i,j)
          OSCSTR(run) = (Two/Three)*EDIFF(run)*dipnorm
          OSCSTR(run) = OSCSTR(run)/auToEV
          write(u6,2) i,j, EDIFF(run), DipFrintermx2(i,j),
     &      DipFrintermy2(i,j), DipFrintermz2(i,j), OSCSTR(run)
        end do
      end do

      call Add_Info('FRENKEL_OSCSTR',OSCSTR,dim*(dim-1)/2,6)

      if (iPL >= 3) then
        run = 0
        write(u6,*) 'Excitonic absorption spectrum'
        write(u6,3) 'from','to','excitation energy [Ha]',
     &       'Dx','Dy','Dz','osc.str.'
        do i=1,dim
          do j=i+1,dim
            run = run + 1
            EDIFF(run) = (EigEn(j) - EigEn(i))/auToEV
            dipnorm = DipFrintermx2(i,j)*DipFrintermx2(i,j) +
     &          DipFrintermy2(i,j)*DipFrintermy2(i,j) +
     &          DipFrintermz2(i,j)*DipFrintermz2(i,j)
            OSCSTR(run) = (Two/Three)*EDIFF(run)*dipnorm
            write(u6,2) i,j, EDIFF(run), DipFrintermx2(i,j),
     &        DipFrintermy2(i,j), DipFrintermz2(i,j), OSCSTR(run)
          end do
        end do
      end if

      call mma_deallocate(I1)
      call mma_deallocate(F1)
      call mma_deallocate(D1X)
      call mma_deallocate(D1Y)
      call mma_deallocate(D1Z)
      call mma_deallocate(I2)
      call mma_deallocate(F2)
      call mma_deallocate(D2X)
      call mma_deallocate(D2Y)
      call mma_deallocate(D2Z)
      call mma_deallocate(Dip1)
      call mma_deallocate(Dip2)
      call mma_deallocate(EigEn)
      call mma_deallocate(EigEnHa)
      call mma_deallocate(EDIFF)
      call mma_deallocate(OSCSTR)
      call mma_deallocate(Frenkelsq)
      call mma_deallocate(Frenkeldia)
      call mma_deallocate(Freninterm)
      call mma_deallocate(Freninterm2)
      call mma_deallocate(Frenkelquad)
      call mma_deallocate(Rassi1)
      call mma_deallocate(Rassi2)
      call mma_deallocate(DipFrx)
      call mma_deallocate(DipFry)
      call mma_deallocate(DipFrz)
      call mma_deallocate(DipFrintermx)
      call mma_deallocate(DipFrintermx2)
      call mma_deallocate(DipFrintermy)
      call mma_deallocate(DipFrintermy2)
      call mma_deallocate(DipFrintermz)
      call mma_deallocate(DipFrintermz2)

      end subroutine frenkelexc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CLagEigT(CLag,RDMEIG,SLag,EINACT)

use caspt2_module, only: ISCF, NCONF, NSTATE
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: CLag(nConf,nState)
real(kind=wp), intent(in) :: RDMEIG(*), SLag(*), EINACT
real(kind=wp), allocatable :: CI1(:), CI2(:)
real(kind=wp) :: Scal
integer(kind=iwp) :: iStat, jStat

! RDMEIG
call mma_allocate(CI1,nConf,Label='CI1')
call mma_allocate(CI2,nConf,Label='CI2')
do iStat=1,nState
  if (ISCF == 0) then
    call LoadCI(CI1,iStat)
  else
    CI1(1) = One
  end if
  !! Skip iStat = jStat because SLag is zero
  do jStat=1,nState !! iStat-1
    if (ISCF == 0) then
      call LoadCI(CI2,jStat)
    else
      CI2(1) = One
    end if
    !! One of doubling is due to the scaling factor
    !! One of doubling is due to the symmetry of iStat and jStat
    !Scal = SLag(iStat+nState*(jStat-1))*Four
    Scal = SLag(iStat+nState*(jStat-1))*Two
    if (abs(Scal) <= 1.0e-9_wp) cycle

    call Poly1_CLagT(CI1,CI2,CLag(1,iStat),CLag(1,jStat),RDMEIG,Scal)
    !! Inactive terms
#   ifdef _MOLCAS_MPP_
    !! The inactive contributions are computed in all processes,
    !! whereas GADGOP will be done later, so divide
    if (is_real_par()) Scal = Scal/real(nProcs,kind=wp)
#   endif
    CLag(1:nconf,jStat) = CLag(1:nconf,jStat)+Scal*EINACT*CI1(1:nconf)
    CLag(1:nconf,iStat) = CLag(1:nconf,iStat)+Scal*EINACT*CI2(1:nconf)
  end do
end do

call mma_deallocate(CI1)
call mma_deallocate(CI2)

return

end subroutine CLagEigT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine biksmain_cvb(aikcof,bikcof,
     > nel,nalf,ndet,ifns,kbasis,share,iprint)
      implicit real*8 (a-h,o-z)
      logical share
      dimension aikcof(ndet,ifns),bikcof(ndet,ifns)
#include "WrkSpc.fh"
      save one
      data one/1d0/

      if(nel.eq.0.and.kbasis.ne.6) then
        bikcof(1,1)=one
        aikcof(1,1)=one
        return
      endif

      nbet=nel-nalf
      np1=nel+1
      nalf1=nalf+1
      nbet2=nbet+nbet
      nswpdim=2**nbet

      i1 = mstacki_cvb(np1)
      i2 = mstacki_cvb(np1)
      i3 = mstacki_cvb(np1)
      i4 = mstacki_cvb(nbet2+1)
      i5 = mstacki_cvb(nbet2+1)
      i6 = mstacki_cvb(nbet2+1)
      i7 = mstacki_cvb(nbet*nswpdim)
      i8 = mstacki_cvb(nel)
      i9 = mstacki_cvb(nel)
      i10= mstacki_cvb(np1*nalf1)
      i11= mstacki_cvb(np1*nalf1)
      i12= mstacki_cvb(nel)
      i13= mstacki_cvb(nalf)
      i14= mstacki_cvb(nbet)
      call rumer_cvb(bikcof,
     >  nel,nalf,nbet,ndet,ifns,kbasis,iprint,nswpdim,
     >  iwork(i1),iwork(i2),iwork(i3),
     >  iwork(i4),iwork(i5),iwork(i6),iwork(i7),iwork(i8),iwork(i9),
     >  iwork(i10),iwork(i11),iwork(i12),
     >  iwork(i13),iwork(i14))
      call mfreei_cvb(i1)

      if(kbasis.eq.1.or.kbasis.eq.5)
     >  call kotani_cvb(bikcof,ndet,ifns)

      if(kbasis.eq.5)then
        i1 = mstacki_cvb(np1)
        i2 = mstacki_cvb(np1)
        i3 = mstacki_cvb(np1)
        i4 = mstacki_cvb(np1)
        i5 = mstacki_cvb(np1)
        i6 = mstacki_cvb(np1)
        i7 = mstacki_cvb(nbet2)
        i8 = mstacki_cvb(nbet2)
        i9 = mstacki_cvb(nel)
        i10= mstacki_cvb(nel)
        i11= mstacki_cvb(nalf)
        i12= mstacki_cvb(np1*nalf1)
        i13= mstacki_cvb(np1*nalf1)
        i14= mstacki_cvb(nel)
        i15= mstackr_cvb(ndet)
        call projspn_cvb(bikcof,
     >    nel,nalf,nbet,ndet,ifns,
     >    iwork(i1),iwork(i2),iwork(i3),iwork(i4),iwork(i5),iwork(i6),
     >    iwork(i7),iwork(i8),iwork(i9),iwork(i10),
     >    iwork(i11),
     >    iwork(i12),iwork(i13),iwork(i14),work(i15))
        call mfreei_cvb(i1)
      endif

      if(kbasis.eq.2)then
        i1 = mstacki_cvb(np1)
        i2 = mstacki_cvb(np1)
        i3 = mstacki_cvb(np1)
        i4 = mstacki_cvb(nel)
        i5 = mstacki_cvb(nel)
        i6 = mstacki_cvb(np1*nalf1)
        i7 = mstacki_cvb(nalf)
        i8 = mstacki_cvb(nbet)
        i9 = mstacki_cvb(ifns)
        call serber_cvb(bikcof,
     >    nel,nalf,nbet,ndet,ifns,
     >    iwork(i1),iwork(i2),iwork(i3),iwork(i4),iwork(i5),iwork(i6),
     >    iwork(i7),iwork(i8),iwork(i9))
        call mfreei_cvb(i1)
      endif

      if(kbasis.gt.2.and.kbasis.ne.6)then
        i1 = mstackr_cvb(ifns*ifns)
      else
        i1 = mstackr_cvb(0)
      endif
      call aikcof_cvb(aikcof,bikcof,
     >  ndet,ifns,kbasis,share,
     >  work(i1))
      call mfreer_cvb(i1)

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ADVICE_SIGMA(  IAOCC,  IBOCC,  JAOCC,  JBOCC, LADVICE)
*
* Advice Sigma routine about best route to take
*
* LADVICE : ADVICE given ( short, an integer !!)
*
* For ITERM = 1 :
*           LADVICE = 1 : Business as usual, no transpose of matrix
*                         (resolution on alpha strings, direct exc on beta)
*           LADVICE = 2 = Transpose matrices
*                         (resolution on beta strings, direct exc on alpha)
* (SVC: one call to this routine and ITERM is one, so I removed that
* argument and skipped the checking. Also, the arguments are all scalar,
* so that has been hard-coded now too)
*
* Jeppe Olsen, Tirstrup Airport, Jan 12, 98
*
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
#include "mxpdim.fh"
#include "gasstr.fh"
#include "orbinp.fh"
#include "cgas.fh"
#include "crun.fh"
*. Specific input
      INTEGER IAOCC(*),IBOCC(*),JAOCC(*),JBOCC(*)
*. Local Scratch
       DIMENSION ITP(16),JTP(16),KTP(16),LTP(16)
*
      NTEST = 00
*.
*. sigma(i,Ka,Ib) = sum(i,kl)<Ib!Eb_kl!Jb>(ij!kl)C(j,Ka,Jb)
*
* Number of ops : Number of sx(kl) N_i*N_j_dimension of C(j,Ka,Jb)
*.No absolute calc of flops is made, only a relative measure
*
* Single excitations connecting the two types
*
C            SXTYP2_GAS(NSXTYP,ITP,JTP,NGAS,ILTP,IRTP,IPHGAS)
        CALL SXTYP2_GAS(  NIJTYP,     ITP,     JTP,    NGAS,   IAOCC,
     &                     JAOCC,  IPHGAS)
        CALL SXTYP2_GAS(  NKLTYP,     KTP,     LTP,    NGAS,   IBOCC,
     &                     JBOCC,  IPHGAS)
C?      WRITE(6,*) 'NIJTYP, NKLTYP', NIJTYP,NKLTYP
*. P-h modifications ( I cannot predict these at the moment
        IF(NIJTYP.GE.1.AND.NKLTYP.GE.1) THEN
*
        IF((IPHGAS(ITP(1)).EQ.2.AND.IPHGAS(JTP(1)).EQ.2).OR.
     &     (IPHGAS(KTP(1)).EQ.2.AND.IPHGAS(LTP(1)).EQ.2)     ) THEN
           IPHMODI = 1
         ELSE
           IPHMODI = 0
         END IF
        ELSE
           IPHMODI = 0
        END IF

*
        IF(IPHMODI.EQ.1.OR.NIJTYP.NE.1.OR.NKLTYP.NE.1
     &     .OR.IADVICE.EQ.0) THEN
*. Several connections, i.e. the alpha or the beta blocks are identical,
*. or ph modifications
*. just continue
          LADVICE = 1
        ELSE
* =========================================
*.. Index for flops along C(j,Ka,Jb) route
* =========================================
*.Dim of C(j,Ka,Jb) relative to C(Ja,Jb)
*. going from Ja to  Ka reduces occ by one elec, changes dim by n/(N-n+1)
          XNJOB = dble(NOBPT(JTP(1)))
          XNJEL = dble(JAOCC(JTP(1)))
          XCJKAJB = XNJOB*XNJEL/(XNJOB-XNJEL+1.0D0)
*. Number of kl excitations per beta string :
          XNKLSX = dble((NOBPT(KTP(1))-JBOCC(KTP(1)))*JBOCC(LTP(1)))
*. Number of ops (relative to dim of C)
          XNIOB = dble(NOBPT(ITP(1)))
          XFLOPA = XCJKAJB*XNKLSX*XNIOB
* =========================================
*.. Index for flops along C(l,Ja,Kb) route
* =========================================
*.Dim of C(l,Ja,Kb) relative to C(Ja,Jb)
          XNLOB = dble(NOBPT(LTP(1)))
          XNLEL = dble(JBOCC(LTP(1)))
          XCLJAKB = XNLOB*XNLEL/(XNLOB-XNLEL+1.0D0)
*. Number of ij excitations per alpha string :
          XNIJSX = dble((NOBPT(ITP(1))-JAOCC(ITP(1)))*JAOCC(JTP(1)))
*. Number of ops (relative to dim of C)
          XNKOB = dble(NOBPT(KTP(1)))
          XFLOPB = XCLJAKB*XNIJSX*XNKOB
*. Switch to second route if atleast 20 percent less work
          IF(XFLOPB.LE.0.8D0*XFLOPA) THEN
            LADVICE = 2
          ELSE
            LADVICE = 1
          END IF
*. Well, an additional consideration :
* If the C block involes the smallest allowed number of elecs in hole space,
* and the annihilation is in hole space
* then we do the annihilation in the space with the smallest number of
* hole electrons.
          LHOLEA =0
          LHOLEB =0
          DO IGAS = 1, NGAS
            IF(IPHGAS(IGAS).EQ.2) THEN
              LHOLEA = LHOLEA + JAOCC(IGAS)
              LHOLEB = LHOLEB + JBOCC(IGAS)
            END IF
          END DO
*
          IF(LHOLEA+LHOLEB.EQ.MNHL.AND.
     &       (IPHGAS(JTP(1)).EQ.2.OR.IPHGAS(LTP(1)).EQ.2))  THEN
*
             IF(IPHGAS(JTP(1)).EQ.2) THEN
              KHOLEA = LHOLEA-1
              KHOLEB = LHOLEB
             ELSE
              KHOLEA = LHOLEA
              KHOLEB = LHOLEB - 1
             END IF
*
             IF(KHOLEA.EQ.KHOLEB) THEN
               LLADVICE = LADVICE
             ELSE IF(KHOLEA.LT.KHOLEB) THEN
               LLADVICE= 1
             ELSE
               LLADVICE = 2
             END IF
             IF(NTEST.GE.100.AND.LADVICE.NE.LLADVICE) THEN
               WRITE(6,*) ' Advice changed by hole considetions'
               WRITE(6,*) ' LADVICE, LLADVICE', LADVICE,LLADVICE
             END IF
             LADVICE = LLADVICE
          END IF
*
*
          IF(NTEST.GE.100) THEN
            WRITE(6,*) ' ADVICE active '
            WRITE(6,*) ' IAOCC JAOCC IBOCC JBOCC'
            CALL IWRTMA(IAOCC,1,NGAS,1,NGAS)
            CALL IWRTMA(JAOCC,1,NGAS,1,NGAS)
            CALL IWRTMA(IBOCC,1,NGAS,1,NGAS)
            CALL IWRTMA(JBOCC,1,NGAS,1,NGAS)
            WRITE(6,*) ' ITP JTP KTP LTP ',ITP(1),JTP(1),KTP(1),LTP(1)
            WRITE(6,*) ' XFLOPA,XFLOPB', XFLOPA,XFLOPB
            WRITE(6,*) ' ADVICE given : ', LADVICE
          END IF
        END IF
*       ^ End if several types/ph modi
C     WRITE(6,*) ' MEMCHECK at end of ADVICE'
C     CALL MEMCHK
C     WRITE(6,*) ' MEMCHECK passed '
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine RigRot(CoorIn,rM,nAtm)

************************************************************************
*                                                                      *
* Object: to compute the rotational constants and the rotational       *
*         spectrum within the rigid-rotor model.                       *
*                                                                      *
*    Reference: P.W. Atkins, in "Molecular Quantum Mechanics",         *
*               Oxford University Press, Oxford/New York,              *
*               ch. 11.2, pp. 289.                                     *
*               Michael Tinkham, in "Group Theory and Quantum          *
*               Mechanics", McGraw-Hill Book Company, New York,        *
*               ch. 7-14, pp. 250.                                     *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      use Sizes_of_Seward, only: S
      use Real_Info, only: TMass, CoM, rMI, Prin, PAX
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
      Real*8 CoorIn(3,nAtm), rM(nAtm), XI(3)
      Real*8, Dimension(:,:), Allocatable :: Coor, Vec
      Real*8, Dimension(:), Allocatable :: Hess, En
      Character*80 Label
      Logical Linear, RR_Show
#include "constants2.fh"
*
      iRout = 117
      iPrint = nPrint(iRout)
      RR_Show = iPrint.ge.6
      if(iprintlevel(-1).lt.3) RR_Show=.false.
*
      If (RR_Show) Then
         Write (6,*)
         Call CollapseOutput(1,'   Rigid rotor info:')
         Write (6,'(3X,A)')    '   -----------------'
         Write (6,*)
      End If
*
      call dcopy_(9,[Zero],0,PAx,1)
      call dcopy_(3,[One],0,PAx,4)
      If (TMass.eq.Zero) Go To 99
      Linear=.False.
      If (iPrint.ge.99) Then
         Call RecPrt(' In RigRot: CoorIn',' ',CoorIn,3,nAtm)
         Call RecPrt(' In RigRot: Mass',' ',rM,1,nAtm)
      End If
      If (RR_Show) Then
      Write (6,*)
      Write (6,'(19X,A,F10.5)') ' Total mass (a) :', TMass/uToau
      Write (6,*)
      Write (6,'(19X,A)')       ' Center of mass '
      Write (6,'(19X,3A11)')    '       X   ','       Y   ',
     &                          '       Z   '
      Write (6,'(19X,3F11.5)') (CoM(i),i=1,3)
      Write (6,*)
      End If
*
*     Translate coordinate system to center of mass.
*
      Call mma_allocate(Coor,3,nAtm)
      Do 30 iCar = 1, 3
         Do 31 iAtom = 1, nAtm
            Coor(iCar,iAtom)=CoorIn(iCar,iAtom)-CoM(iCar)
 31      Continue
 30   Continue
*
      If (RR_Show) Then
      Write (6,'(19X,A)') ' Reference system based on center of mass'
      Write (6,'(19X,A)')
     &              ' Coordinates and Masses of Atoms, in au and A'
      Write (6,'(19X,A)')
     &      '       X          Y          Z        Mass'
      Write (6,'(19X,4F11.5)') ((Coor(j,i),j=1,3),rM(i)/utoau,i=1,nAtm)
      Write (6,*)
      End If
      If (nAtm.eq.1) Then
         Call mma_deallocate(Coor)
         Go To 99
      End If
*
*     Construct the moment of inertia tensor
*
      ii = 0
      Do 40 iCar = 1, 3
         Do 41 jCar = 1, iCar-1
            ii = ii + 1
            rMI(ii) = Zero
            Do 42 iAtom = 1, nAtm
               rMI(ii) = rMI(ii) -
     &                 Coor(iCar,iAtom) * Coor(jCar,iAtom) * rM(iAtom)
 42         Continue
 41      Continue
         ii = ii + 1
         rMI(ii) = Zero
         Do 43 iAtom = 1, nAtm
            rMI(ii) = rMI(ii) + rM(iAtom) * (
     &                Coor(1,iAtom)**2 +
     &                Coor(2,iAtom)**2 +
     &                Coor(3,iAtom)**2 -
     &                Coor(iCar,iAtom)**2)
 43      Continue
 40   Continue
      Call mma_deallocate(Coor)
      If (RR_Show) Then
      Write (6,'(19X,A)') ' The Moment of Inertia Tensor / au'
      Write (6,'(19X,14X,3A)')'    X     ','     Y    ','    Z     '
      Write (6,'(19X,A,12X,3(E11.4))') ' X',rMI(1)
      Write (6,'(19X,A,12X,3(E11.4))') ' Y',rMI(2), rMI(3)
      Write (6,'(19X,A,12X,3(E11.4))') ' Z',rMI(4), rMI(5), rMI(6)
      Write (6,*)
      End If
*
*     Diagonalize and find principle axis
*
      Call mma_Allocate(Hess,6)
      call dcopy_(6,rMI,1,Hess,1)
      Call Jacob(Hess,Pax,3,3)
      Prin(1) = Hess(1)
      Prin(2) = Hess(3)
      Prin(3) = Hess(6)
*
*     Sort the prinipal axis such that z' is the one with the lowest
*     eigenvalue.
*
      Do 100 i = 1 , 2
         Do 101 j = i+1, 3
            If (Prin(i).lt.Prin(j)) Then
               Save=Prin(i)
               Prin(i)=Prin(j)
               Prin(j)=Save
               Call DSwap_(3,PAx(1+(i-1)*3),1,PAx(1+(j-1)*3),1)
            End If
 101     Continue
 100  Continue
      Call mma_deallocate(Hess)
      If (RR_Show) Then
      Write (6,'(19X,A)')
     &         ' The Principal Axes and Moments of Inertia (au)'
      Write (6,'(19X,A,3(E11.4))') ' Eigenvalues :', (Prin(i),i=1,3)
      Write (6,'(19X,14X,3A)')'    X''    ','     Y''   ','    Z''    '
      Write (6,'(19X,A)')        ' Eigenvectors:'
      Write (6,'(19X,A,3(E11.4))')
     &      ' X            ',Pax(1),Pax(4),Pax(7)
      Write (6,'(19X,A,3(E11.4))')
     &      ' Y            ',Pax(2),Pax(5),Pax(8)
      Write (6,'(19X,A,3(E11.4))')
     &      ' Z            ',Pax(3),Pax(6),Pax(9)
      Write (6,*)
C     Call Put_dArray('PAX',Pax,9)
      Write (6,'(19X,A)') ' The Rotational Constants'
      Write (6,'(19X,A)') '         (cm-1)            (GHz)'
      If (Prin(1).ge.1.D-3)
     &    Write (6,'(19X,F16.3,1X,F16.3)') auTocm*Half/Prin(1),
     &                          1.0D-9*auToHz*Half/Prin(1)
      If (Prin(2).ge.1.D-3)
     &    Write (6,'(19X,F16.3,1X,F16.3)') auTocm*Half/Prin(2),
     &                          1.0D-9*auToHz*Half/Prin(2)
      If (Prin(3).ge.1D-3)
     &    Write (6,'(19X,F16.3,1X,F16.3)') auTocm*Half/Prin(3),
     &                          1.0D-9*auToHz*Half/Prin(3)
      End If
      If (Prin(1).eq.Zero .and.
     &    Prin(2).eq.Zero .and.
     &    Prin(3).eq.Zero ) Go To 99
      If (RR_Show) Then
      Write (6,*)
      Write (6,*)
      Write (6,'(19X,A)') ' *******************************************'
      Write (6,'(19X,A)') ' *                                         *'
      Write (6,'(19X,A)') ' * R I G I D - R O T O R   A N A L Y S I S *'
      Write (6,'(19X,A)') ' *                                         *'
      Write (6,'(19X,A)') ' *******************************************'
      Write (6,*)
      Write (6,'(19X,A,I3)') ' j(Max):', S%jMax
      Write (6,*)
      End If
*
*     Order the three principal moments of inertia, Ia<=Ib<=Ic
*
      call dcopy_(3,Prin,1,XI,1)
      Call Order_Axis(XI,3)
*
*     Asymmetry parameter, Tinkham formula 7-96
*
      B = Half / XI(2)
      C = Half / XI(3)
      If (XI(1).le.1.D-3) Then
         Linear = .True.
         rKappa = -One
      Else
         A = Half / XI(1)
         If (Abs(A-C).le.1.D-10) Then
            rKappa = 0.0D00
         Else
            rKappa = (Two*B-A-C) / (A-C)
         End If
      End If
*
*     Change order if molecule is oblate, Ia=Ib<=Ic
*
      If (Abs(XI(1)-XI(2)).lt.0.000001D0 .and.
     &    Abs(XI(1)-XI(3)).gt.0.000001D0) Then
         Save = XI(1)
         XI(1) = XI(3)
         XI(3) = Save
      End If
*
*     Construct Hessian Matrix
*     Iz=XI(1), Ix=XI(2), and Iy=XI(3)
*
*     Set up constants, see Tinkham fomula 7-89a and 7-89b.
*
      If (Abs(XI(1)).gt.1.0D-3) Then
         A = Half / XI(1)
      Else
         A = Zero
      End If
      B = (One/XI(2) + One/XI(3))/Four
      C =(One/XI(2) - One/XI(3))/Eight
      Do 60 i = 1, 80
         Label(i:i) = ' '
 60   Continue
*     Iz=0 linear rotor
      If (Abs(A).lt.1.0d-3) Then
         Label(1:13)=' Linear Rotor'
*     Ix=/=Iy asymmetric top
      Else If (C .gt. 1.0D-3) Then
         Label(1:15)=' Asymmetric Top'
*     Iz=Ix=Iy
      Else If (Abs(A-B).lt.1.0D-10) Then
         Label(1:14)=' Spherical Top'
      Else If(A.gt.B) Then
         Label(1:25)=' Symmetric Top, Prolate'
      Else
         Label(1:24)=' Symmetric Top, Oblate'
      End If
      If (RR_Show) Then
      Write (6,'(19X,A,A)') ' Rotor Type:',Label(1:mylen(Label))
      Write (6,'(19X,A,F7.3)') ' Asymmetry parameter:',rKappa
      Write (6,'(19X,A)')       ' Prolate = -1'
      Write (6,'(19X,A)')       ' Oblate  =  1'
      Write (6,*)
      End If
*
      nEn = (S%jMax+1)*(S%jMax+2)*(S%jMax+3)/6
      Call mma_Allocate(En,nEn)
      iEn = 1
      nHess = (2*S%jMax+1)*(2*S%jMax+2)/2
      Call mma_allocate(Hess,nHess)
      Call mma_Allocate(Vec,2*S%jMax+1,2*S%jMax+1)
      Do 80 j = 0, S%jMax
         mDim = 2*j+1
         nTri = mDim*(mDim+1)/2
         call dcopy_(nTri,[Zero],0,Hess,1)
         call dcopy_(mDim**2,[Zero],0,Vec,1)
         call dcopy_(mDim,[One],0,Vec,mDim+1)
         If (iPrint.ge.99)
     &       Call RecPrt(' Vec',' ',Vec,mDim,mDim)
         k1 = 1
         Do 81 k = -j, j
            kk = k1*(k1+1)/2
*
*           Formula 7-89a, (j,k|H|j,k), diagonal term
*
            Hess(kk) = B*DBLE(j*(j+1)) + (A-B)*DBLE(k**2)
            If (Linear) Hess(kk)=B*DBLE(j*(j+1))
            If (k+2.gt.j .or. Linear) Go to 82
            k2 = k1 + 2
            kk2 = k2*(k2-1)/2 + k1
*
*           Formula 7-89b, (j,k+2|H|j,k), the only off diagonal term.
*
            Hess(kk2) = C*Sqrt(DBLE( (j*(j+1)-k*(k+1)) *
     &                  (j*(j+1)-(k+1)*(k+2)) ) )
 82         k1 = k1 + 1
 81      Continue
         If (iPrint.ge.99)
     &       Call TriPrt(' Hessian',' ',Hess,mDim)
         Call Jacob(Hess,Vec,mDim,mDim)
         If (iPrint.ge.99)
     &      Call TriPrt(' Hessian',' ',Hess,mDim)
         Do 83 i = 1, mDim
            En(iEn+I-1) = Hess(i*(i+1)/2) * auTocm
 83      Continue
         Call Order_Axis(En(iEn),mDim)
         iEn = iEn + mDim
 80   Continue
      Call mma_deallocate(Vec)
      Call mma_deallocate(Hess)
*
*     Output
*
      If (RR_Show) Then
      Write (6,*)
      Write (6,'(19X,A)') ' Rotational energies / cm-1'
      iEn = 1
      Do 90 j = 0, S%jMax
         Write (6,*)
         If (Linear) Then
             Write (6,'(19X,A,I2,A,F8.3)')
     &           ' E(J=',J,') = ',En(iEn)
             iEn = iEn + (2*j+1)
         Else
            Do 91 kappa = -j, j
               Write (6,'(19X,A,I2,A,I2,A,F12.3)')
     &           ' E(J=',J,',kappa=',kappa,') = ',En(iEn)
               iEn = iEn + 1
 91         Continue
         End If
 90   Continue
      End If
      Call mma_deallocate(En)
*
 99   Continue
      If (RR_Show) Then
         Call CollapseOutput(0,'   Rigid rotor info:')
         Write (6,*)
      End If
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
* Print_Mode_Components
*
*> @brief
*> Print the contributions from the primitive internal coordinates to the
*> vibrational modes.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Compute and print the contributions from the primitive internal coordinates
*> (stretches, angles, dihedrals, out-of-planes) to the vibrational modes
*>
*> @param[in] Modes Vibrational modes, as computed by e.g. ::freqanal
*> @param[in] Freq Vibrational frequencies
*> @param[in] nModes Number of modes
*> @param[in] lModes Size of \p Modes
*> @param[in] lDisp Number of displacements per irrep
************************************************************************
      Subroutine Print_Mode_Components(Modes,Freq,nModes,lModes,lDisp)
      use Symmetry_Info, only: nIrrep, VarR, VarT
      use Slapaf_Info, only: Cx, Gx, Gx0, NAC, Q_nuclear, dMass, Coor,
     &                       Grd, Weights, ANr, Shift, GNrm, Lambda,
     &                       Energy, Energy0, DipM, MF, qInt, dqInt,
     &                       RefGeo, BM, iBM, dBM, idBM, nqBM, BMx,
     &                       Degen, nStab, jStab, iCoSet, AtomLbl,
     &                       Smmtrc, Lbl, mRowH, RootMap
      use Slapaf_Parameters, only: iRow, iRow_c, iInt, nFix,
     &                             ddV_Schlegel, HWRS, iOptH, HUpMet,
     &                             HrmFrq_Show, IRC, Curvilinear,
     &                             Redundant, FindTS, nBVec, nDimBC,
     &                             User_Def, Analytic_Hessian, MaxItr,
     &                             iOptC, UpMeth, HSet, BSet, rHidden,
     &                             CnstWght, PrQ, lOld, Numerical, Beta,
     &                             Beta_Disp, Line_Search,
     &                             TSConstraints, GNrm_Threshold, Mode,
     &                             ThrEne, ThrGrd, nLambda, iRef,
     &                             ThrCons, ThrMEP, Baker, eMEPTest,
     &                             rMEP, MEP, nMEP, MEPNum, MEPCons,
     &                             dMEPStep, MEP_Type, MEP_Algo,
     &                             Header, Max_Center, mTROld, RtRnc,
     &                             Delta, rFuzz, lNmHss, Cubic,
     &                             Request_Alaska, Request_RASSI,
     &                             lOld_Implicit, CallLast, lSoft,
     &                             lCtoF, Track, TwoRunFiles, isFalcon,
     &                             Stop, NmIter, MxItr, mTtAtm, nWndw,
     &                             iter, WeightedConstraints, mB_Tot,
     &                             mdB_Tot, mq, NADC, EDiffZero,
     &                             ApproxNADC, iState
      use thermochem
      Implicit None
#include "backup_info.fh"
#include "print.fh"
#include "stdalloc.fh"
#include "real.fh"
      Real*8 rDum(1)
      Real*8 :: Modes(*), Freq(*), Mx, MinComp
      Integer :: LuInput,
     &           nX, i, j, nB, iq, nAll_Atoms, nUnique_Atoms,
     &           iB, lDisp(nIrrep), nModes, lModes, LuIC, ii, im, nK,
     &           iErr, PLback, nQQ, nsAtom
      Real*8, Dimension(:,:), Allocatable :: KMtrx, KTrsp, KKtB, IntMod,
     &                                       NMod
      Integer, Dimension(:), Allocatable :: Sort
      Integer, Parameter :: nLbl=10*MxAtom
      Integer, External :: IsFreeUnit, iPrintLevel, AixRm
      Logical :: Found
      Character(Len=8) :: Filename
      Character(Len=16) :: StdIn
      Character(Len=24), Allocatable :: Label(:)
      Character(Len=180), External :: Get_Ln_EOF
      Character(LEN=180):: Line
      Real*8, External :: DDot_

      Logical :: Bk_VarR, Bk_VarT

      Real*8, Allocatable:: Bk_Energy(:)
      Real*8, Allocatable:: Bk_Energy0(:)
      Real*8, Allocatable:: Bk_DipM(:,:)
      Real*8, Allocatable:: Bk_GNrm(:)
      Real*8, Allocatable:: Bk_Cx(:,:,:)
      Real*8, Allocatable:: Bk_Gx(:,:,:)
      Real*8, Allocatable:: Bk_Gx0(:,:,:)
      Real*8, Allocatable:: Bk_MF(:,:)
      Real*8, Allocatable:: Bk_Lambda(:,:)

      Real*8, Allocatable:: Bk_NAC(:,:)
      Real*8, Allocatable:: Bk_Q_nuclear(:)
      Real*8, Allocatable:: Bk_dMass(:)
      Real*8, Allocatable:: Bk_Coor(:,:)
      Real*8, Allocatable:: Bk_Grd(:,:)
      Real*8, Allocatable:: Bk_Weights(:)
      Real*8, Allocatable:: Bk_Shift(:,:)
      Real*8, Allocatable:: Bk_qInt(:,:)
      Real*8, Allocatable:: Bk_dqInt(:,:)
      Real*8, Allocatable:: Bk_RefGeo(:,:)
      Real*8, Allocatable:: Bk_BMx(:,:)
      Real*8, Allocatable:: Bk_Degen(:,:)

      Real*8, Allocatable:: Bk_BM(:)
      Real*8, Allocatable:: Bk_dBM(:)
      Integer, Allocatable:: Bk_iBM(:)
      Integer, Allocatable:: Bk_idBM(:)
      Integer, Allocatable:: Bk_nqBM(:)

      Integer, Allocatable:: Bk_ANr(:)
      Integer, Allocatable:: Bk_jStab(:,:)
      Integer, Allocatable:: Bk_nStab(:)
      Integer, Allocatable:: Bk_iCoSet(:,:)
      Character(LEN=LENIN), Allocatable:: Bk_AtomLbl(:)
      Logical, Allocatable:: Bk_Smmtrc(:,:)
      Character(LEN=8), Allocatable:: Bk_Lbl(:)
      Integer, Allocatable:: Bk_mRowH(:)
      Integer, Allocatable:: Bk_RootMap(:)
*
*
*---- Ugly hack: backup all "global" slapaf variables in case this is
*                called from inside slapaf
*
*     Note, this routine might be called from outside the Slapaf
*     environment. In which case there is no backup to be made.
*
      nsAtom=SIZE(Cx,2)
      If (Allocated(Cx)) Then
         Call mma_allocate(Bk_Cx,3,nsAtom,MaxItr+1,Label='Bk_Cx')
         Bk_Cx(:,:,:) = Cx(:,:,:)
         Call mma_deallocate(Cx)
      End If
      If (Allocated(Gx)) Then
         Call mma_allocate(Bk_Gx,3,nsAtom,MaxItr+1,Label='Bk_Gx')
         Bk_Gx(:,:,:) = Gx(:,:,:)
         Call mma_deallocate(Gx)
      End If
      If (Allocated(Gx0)) Then
         Call mma_allocate(Bk_Gx0,3,nsAtom,MaxItr+1,Label='Bk_Gx0')
         Bk_Gx0(:,:,:) = Gx0(:,:,:)
         Call mma_deallocate(Gx0)
      End If
      If (Allocated(NAC)) Then
         Call mma_allocate(Bk_NAC,3,nsAtom,Label='Bk_NAC')
         Bk_NAC(:,:) = NAC(:,:)
         Call mma_deallocate(NAC)
      End If
      If (Allocated(Q_nuclear)) Then
         Call mma_allocate(Bk_Q_nuclear,nsAtom,Label='Bk_Q_nuclear')
         Bk_Q_nuclear(:) = Q_nuclear(:)
         Call mma_deallocate(Q_nuclear)
      End If
      If (Allocated(dMass)) Then
         Call mma_allocate(Bk_dMass,nsAtom,Label='Bk_dMass')
         Bk_dMass(:) = dMass(:)
         Call mma_deallocate(dMass)
      End If
      If (Allocated(Coor)) Then
         Call mma_allocate(Bk_Coor,3,nsAtom,Label='Bk_Coor')
         Bk_Coor(:,:) = Coor(:,:)
         Call mma_deallocate(Coor)
      End If
      If (Allocated(Grd)) Then
         Call mma_allocate(Bk_Grd,3,nsAtom,Label='Bk_Grd')
         Bk_Grd(:,:) = Grd(:,:)
         Call mma_deallocate(Grd)
      End If
      If (Allocated(ANr)) Then
         Call mma_allocate(Bk_ANr,nsAtom,Label='Bk_ANr')
         Bk_ANr(:) = ANr(:)
         Call mma_deallocate(ANr)
      End If
      If (Allocated(Weights)) Then
         Call mma_allocate(Bk_Weights,SIZE(Weights),Label='Bk_Weights')
         Bk_Weights(:) = Weights(:)
         Call mma_deallocate(Weights)
      End If
      If (Allocated(Shift)) Then
         Call mma_allocate(Bk_Shift,SIZE(Shift,1),MaxItr,
     &                     Label='Bk_Shift')
         Bk_Shift(:,:) = Shift(:,:)
         Call mma_deallocate(Shift)
      End If
      If (Allocated(GNrm)) Then
         Call mma_allocate(Bk_GNrm,MaxItr+1,Label='Bk_GNrm')
         Bk_GNrm(:) = GNrm(:)
         Call mma_deallocate(GNrm)
      End If
      If (Allocated(Lambda)) Then
         Call mma_allocate(Bk_Lambda,SIZE(Lambda,1),MaxItr+1,
     &                     Label='Bk_Lambda')
         Bk_Lambda(:,:) = Lambda(:,:)
         Call mma_deallocate(Lambda)
      End If
      If (Allocated(Energy)) Then
         Call mma_allocate(Bk_Energy,MaxItr+1,Label='Bk_Energy')
         Bk_Energy(:) = Energy(:)
         Call mma_deallocate(Energy)
      End If
      If (Allocated(Energy0)) Then
         Call mma_allocate(Bk_Energy0,MaxItr+1,Label='Bk_Energy0')
         Bk_Energy0(:) = Energy0(:)
         Call mma_deallocate(Energy0)
      End If
      If (Allocated(MF)) Then
         Call mma_allocate(Bk_MF,3,nsAtom,Label='Bk_MF')
         Bk_MF(:,:) = MF(:,:)
         Call mma_deallocate(MF)
      End If
      If (Allocated(DipM)) Then
         Call mma_allocate(Bk_DipM,3,MaxItr+1,Label='Bk_DipM')
         Bk_DipM(:,:) = DipM(:,:)
         Call mma_deallocate(DipM)
      End If
      If (Allocated(qInt)) Then
         Call mma_allocate(Bk_qInt,SIZE(qInt,1),MaxItr,
     &                     Label='Bk_qInt')
         Bk_qInt(:,:) = qInt(:,:)
         Call mma_deallocate(qInt)
      End If
      If (Allocated(dqInt)) Then
         Call mma_allocate(Bk_dqInt,SIZE(dqInt,1),MaxItr,
     &                     Label='Bk_dqInt')
         Bk_dqInt(:,:) = dqInt(:,:)
         Call mma_deallocate(dqInt)
      End If
      If (Allocated(RefGeo)) Then
         Call mma_allocate(Bk_RefGeo,3,nsAtom,Label='Bk_RefGeo')
         Bk_RefGeo(:,:) = RefGeo(:,:)
         Call mma_deallocate(RefGeo)
      End If
      If (Allocated(BM)) Then
         Call mma_allocate(Bk_BM,SIZE(BM),Label='Bk_BM')
         Bk_BM(:) = BM(:)
         Call mma_deallocate(BM)
      End If
      If (Allocated(dBM)) Then
         Call mma_allocate(Bk_dBM,SIZE(dBM),Label='Bk_dBM')
         Bk_dBM(:) = dBM(:)
         Call mma_deallocate(dBM)
      End If
      If (Allocated(iBM)) Then
         Call mma_allocate(Bk_iBM,SIZE(iBM),Label='Bk_iBM')
         Bk_iBM(:) = iBM(:)
         Call mma_deallocate(iBM)
      End If
      If (Allocated(idBM)) Then
         Call mma_allocate(Bk_idBM,SIZE(idBM),Label='Bk_idBM')
         Bk_idBM(:) = idBM(:)
         Call mma_deallocate(idBM)
      End If
      If (Allocated(nqBM)) Then
         Call mma_allocate(Bk_nqBM,SIZE(nqBM),Label='Bk_nqBM')
         Bk_nqBM(:) = nqBM(:)
         Call mma_deallocate(nqBM)
      End If
      If (Allocated(BMx)) Then
         Call mma_allocate(Bk_BMx,SIZE(BMx,1),SIZE(BMx,2),
     &                     Label='Bk_BMx')
         Bk_BMx(:,:) = BMx(:,:)
         Call mma_deallocate(BMx)
      End If
      If (Allocated(Degen)) Then
         Call mma_allocate(Bk_Degen,SIZE(Degen,1),SIZE(Degen,2),
     &                     Label='Bk_Degen')
         Bk_Degen(:,:) = Degen(:,:)
         Call mma_deallocate(Degen)
      End If
      If (Allocated(jStab)) Then
         Call mma_allocate(Bk_jStab,[0,7],[1,SIZE(jStab,2)],
     &                     Label='Bk_jStab')
         Bk_jStab(:,:) = jStab(:,:)
         Call mma_deallocate(jStab)
      End If
      If (Allocated(iCoSet)) Then
         Call mma_allocate(Bk_iCoSet,[0,7],[1,SIZE(iCoSet,2)],
     &                     Label='Bk_iCoSet')
         Bk_iCoSet(:,:) = iCoSet(:,:)
         Call mma_deallocate(iCoSet)
      End If
      If (Allocated(nStab)) Then
         Call mma_allocate(Bk_nStab,SIZE(nStab),Label='Bk_nStab')
         Bk_nStab(:) = nStab(:)
         Call mma_deallocate(nStab)
      End If
      If (Allocated(AtomLbl)) Then
         Call mma_allocate(Bk_AtomLbl,SIZE(AtomLbl),Label='Bk_AtomLbl')
         Bk_AtomLbl(:) = AtomLbl(:)
         Call mma_deallocate(AtomLbl)
      End If
      If (Allocated(Smmtrc)) Then
         Call mma_allocate(Bk_Smmtrc,3,SIZE(Smmtrc,2),Label='Bk_Smmtrc')
         Bk_Smmtrc(:,:) = Smmtrc(:,:)
         Call mma_deallocate(Smmtrc)
      End If
      If (Allocated(Lbl)) Then
         Call mma_allocate(Bk_Lbl,SIZE(Lbl),Label='Bk_Lbl')
         Bk_Lbl(:) = Lbl(:)
         Call mma_deallocate(Lbl)
      End If
      If (Allocated(mRowH)) Then
         Call mma_allocate(Bk_mRowH,SIZE(mRowH),Label='Bk_mRowH')
         Bk_mRowH(:) = mRowH(:)
         Call mma_deallocate(mRowH)
      End If
      If (Allocated(RootMap)) Then
         Call mma_allocate(Bk_RootMap,SIZE(RootMap),Label='Bk_RootMap')
         Bk_RootMap(:) = RootMap(:)
         Call mma_deallocate(RootMap)
      End If

      Bk_Header(:)=Header(:)
      Bk_iRef=iRef
      Bk_NmIter=NmIter
      Bk_iter=iter
      Bk_nDimBC=nDimBC
      Bk_MxItr=MxItr
      Bk_Max_Center=Max_Center
      Bk_iOptC=iOptC
      Bk_mode=mode
      Bk_mTROld=mTROld
      Bk_nWndw=nWndw
      Bk_iOptH=iOptH
      Bk_nLambda=nLambda
      Bk_nMEP=nMEP
      Bk_nBVec=nBVec
      Bk_IRC=IRC
      Bk_mTtAtm=mTtAtm
      Bk_MEPnum=MEPnum
      Bk_Stop=Stop
      Bk_lOld=lOld
      Bk_CurviLinear=CurviLinear
      Bk_HSet=HSet
      Bk_BSet=BSet
      Bk_lNmHss=lNmHss
      Bk_Cubic=Cubic
      Bk_Baker=Baker
      Bk_DDV_Schlegel=DDV_Schlegel
      Bk_Line_Search=Line_Search
      Bk_HWRS=HWRS
      Bk_Analytic_Hessian=Analytic_Hessian
      Bk_FindTS=FindTS
      Bk_MEP=MEP
      Bk_User_Def=User_Def
      Bk_rMEP=rMEP
      Bk_lOld_Implicit=lOld_Implicit
      Bk_HrmFrq_Show=HrmFrq_Show
      Bk_eMEPtest=eMEPtest
      Bk_Redundant=Redundant
      Bk_lCtoF=lCtoF
      Bk_lSoft=lSoft
      Bk_CallLast=CallLast
      Bk_TwoRunFiles=TwoRunFiles
      Bk_TSConstraints=TSConstraints
      Bk_MEPCons=MEPCons
      Bk_Track=Track
      Bk_Request_Alaska=Request_Alaska
      Bk_Request_RASSI=Request_RASSI
      Bk_ThrEne=ThrEne
      Bk_ThrGrd=ThrGrd
      Bk_Beta=Beta
      Bk_Beta_Disp=Beta_Disp
      Bk_Delta=Delta
      Bk_Rtrnc=Rtrnc
      Bk_rHidden=rHidden
      Bk_ThrCons=ThrCons
      Bk_GNrm_Threshold=GNrm_Threshold
      Bk_CnstWght=CnstWght
      Bk_dMEPStep=dMEPStep
      Bk_rFuzz=rFuzz
      Bk_ThrMEP=ThrMEP
      Bk_lTherm=lTherm
      Bk_lDoubleIso=lDoubleIso
      Bk_nUserPT=nUserPT
      Bk_nsRot=nsRot
      Bk_UserT(:)=UserT(:)
      Bk_UserP=UserP
      Bk_HUpMet=HUpMet
      Bk_UpMeth=UpMeth
      Bk_MEP_Type=MEP_Type
      Bk_MEP_Algo=MEP_Algo
      Bk_isFalcon=isFalcon
      Bk_mB_Tot=mB_Tot
      Bk_mdB_Tot=mdB_Tot
      Bk_mq=mq
      Bk_WeightedConstraints=WeightedConstraints
      Bk_NADC=NADC
      Bk_EDiffZero=EDiffZero
      Bk_ApproxNADC=ApproxNADC
      Bk_iState(:)=iState(:)
      Bk_iRow = iRow
      Bk_iRow_c=iRow_c
      Bk_nFix = nFix
      Bk_iInt = iInt
      Bk_VarR = VarR
      Bk_VarT = VarT
*
*---- Make a backup of the runfile, since we are going to change the
*     internal coordinates definition.
*
      Call fCopy('RUNFILE','RUNBCK2',iErr)
      If (iErr.ne.0) Call Abend()
*
*---- Remove the Hessian and disable translational and rotational
*     invariance
*
      Call Put_dArray('Hess',rDum,0)
      VarR=.True.
      VarT=.True.
*                                                                      *
************************************************************************
* Call Slapaf to build the B matrix and get the displacement vectors   *
* corresponding to the primitive internal coordinates (bonds and       *
* angles)                                                              *
************************************************************************
*                                                                      *
*---- Process the input
*
      PLback=iPrintLevel(-1)
      i=iPrintLevel(0)
      LuInput=21
      LuInput=IsFreeUnit(LuInput)
      Call StdIn_Name(StdIn)
      Call Molcas_open(LuInput,StdIn)
*
      iRow=0
      iRow_c=0
      nFix=0
      iInt=0
      Call RdCtl_Slapaf(LuInput,.True.)
      Curvilinear = .True.
      Numerical = .False.
*
      Close(LuInput)
      i=iPrintLevel(PLback)
*                                                                      *
************************************************************************
*                                                                      *
      BSet=.True.
      HSet=.False.
      PrQ=.False.
      nWndw=iter
      iRef=0
      Call BMtrx(SIZE(Coor,2),Coor,iter,mTtAtm,nWndw)
      nQQ = SIZE(Shift,1)
*                                                                      *
************************************************************************
*                                                                      *
*---- First get the (transposed) K matrix, (dQ/dq)^T
*
      Call mma_allocate(KMtrx,mq,nQQ,label="KMtrx")
      Call mma_allocate(KTrsp,nQQ,mq,label="KTrsp")
      Call Qpg_dArray('K',Found,nK)
      If (.not.Found .or. (nK.ne.mq*nQQ)) Call Abend()
      Call Get_dArray('K',KMtrx,nK)
      KTrsp(:,:)=Transpose(KMtrx)
      Call mma_deallocate(KMtrx)
*
*---- Form the full B matrix in the redundant internal coordinates
*     (primitives) and multiply by KK(t) on the fly
*
      nX = 3*mTtAtm
      Call mma_allocate(KKtB,mq,nX,label="KKtB")
      Call FZero(KKtB,nX*mq)
      i=1
      Do iq=1,mq
         nB=nqBM(iq)
         Do iB=i,i+nB-1
            j=iBM(iB)
            Do ii=1,mq
               KKtB(ii,j)=KKtB(ii,j)+BM(iB)*
     &            DDot_(nQQ,KTrsp(1,ii),1,KTrsp(1,iq),1)
            End Do
         End Do
         i=i+nB
      End Do
      Call mma_deallocate(KTrsp)
*
*---- Get the Cartesian normal modes
*
      Call Get_iScalar('Unique atoms',nUnique_Atoms)
      Call Get_nAtoms_All(nAll_Atoms)
      If (3*nAll_Atoms.ne.nX) Call Abend()
      Call mma_allocate(NMod,nX,nModes,label="NMod")
      Call FZero(NMod,nX*nModes)
      Call Get_NMode_All(Modes,lModes,nModes,nUnique_Atoms,
     &                   NMod,nAll_Atoms,lDisp)
*
*---- Compute the overlaps with the primitive displacements
*
      Call mma_allocate(IntMod,mq,nModes,label="IntMod")
      Call DGeMM_('N','N',mq,nModes,nX,One,KKtB,mq,
     &            NMod,nX,Zero,IntMod,mq)
      Call mma_deallocate(KKtB)
      Call mma_deallocate(NMod)
*
*---- "Normalize" the maximum value to 1
*
      Do i=1,nModes
         Mx=Zero
         Do j=1,mq
           Mx=Max(Mx,Abs(IntMod(j,i)))
         End Do
         If (Mx.gt.1.0D-10) Call DScal_(mq,One/Mx,IntMod(1,i),1)
      End Do
*
*---- Print the overlaps
*
      Call mma_allocate(Label,nLbl,label='Label')
      Filename='INTCOR'
      LuIC=21
      LuIC=IsFreeUnit(LuIC)
      Call Molcas_open(LuIC,Filename)
      i=1
      Line=Get_Ln_EOF(LuIC)
      Do While (Line .ne. 'EOF')
         j=Index(Line,'=')+1
         Label(i)=AdjustL(Line(j:))
         i=i+1
         Line=Get_Ln_EOF(LuIC)
      End Do
      Close(LuIC)
*
      MinComp=Half
      Call CollapseOutput(1,'Principal components of the normal modes')
      Write(6,'(3X,A)') '----------------------------------------'
      Write(6,*)
      Write(6,'(3X,A,F4.2,A)') '(Only contributions larger than ',
     &                         MinComp,' times the maximum are printed)'
      Write(6,*)
      Call mma_allocate(Sort,mq,label="Sort")
      Do i=1,nModes
         Write(6,*)
         Write(6,'(6X,A,1X,I6)') 'Mode',i
         Write(Line,'(5X,F10.2)') Freq(i)
         j=Index(Line,'-')
         If (j.gt.0) Line(j:j)='i'
         Write(6,'(8X,A)') 'Frequency: '//Trim(Line)//' cm-1'
         Write(6,'(6X,A)') '---------------------------------'
         Do j=1,mq
            Sort(j)=j
         End Do
         Do j=1,mq
            Do ii=j+1,mq
               If (Abs(IntMod(Sort(ii),i)).gt.
     &             Abs(IntMod(Sort(j),i))) Then
                  im=Sort(j)
                  Sort(j)=Sort(ii)
                  Sort(ii)=im
               End If
            End Do
            If (Abs(IntMod(Sort(j),i)).lt.MinComp) Exit
            Write(6,'(8X,A,F7.4)') Label(Sort(j)),IntMod(Sort(j),i)
         End Do
         Write(6,'(6X,A)') '---------------------------------'
      End Do
      Call CollapseOutput(0,'Principal components of the normal modes')
*
*---- Clean up
*
      Call mma_deallocate(Label)
      Call mma_deallocate(IntMod)
      Call mma_deallocate(Sort)
*                                                                      *
************************************************************************
*                                                                      *
*---- Restore the runfile and the "global" variables
*
      Call fCopy('RUNBCK2','RUNFILE',iErr)
      If (iErr.ne.0) Call Abend()
      If (AixRm('RUNBCK2').ne.0) Call Abend
*
      Header(:)=Bk_Header(:)
      iRef=Bk_iRef
      NmIter=Bk_NmIter
      iter=Bk_iter
      nDimBC=Bk_nDimBC
      MxItr=Bk_MxItr
      Max_Center=Bk_Max_Center
      iOptC=Bk_iOptC
      mode=Bk_mode
      mTROld=Bk_mTROld
      nWndw=Bk_nWndw
      iOptH=Bk_iOptH
      nLambda=Bk_nLambda
      nMEP=Bk_nMEP
      nBVec=Bk_nBVec
      IRC=Bk_IRC
      mTtAtm=Bk_mTtAtm
      MEPnum=Bk_MEPnum
      Stop=Bk_Stop
      lOld=Bk_lOld
      CurviLinear=Bk_CurviLinear
      HSet=Bk_HSet
      BSet=Bk_BSet
      lNmHss=Bk_lNmHss
      Cubic=Bk_Cubic
      Baker=Bk_Baker
      DDV_Schlegel=Bk_DDV_Schlegel
      Line_Search=Bk_Line_Search
      HWRS=Bk_HWRS
      Analytic_Hessian=Bk_Analytic_Hessian
      FindTS=Bk_FindTS
      MEP=Bk_MEP
      User_Def=Bk_User_Def
      rMEP=Bk_rMEP
      lOld_Implicit=Bk_lOld_Implicit
      HrmFrq_Show=Bk_HrmFrq_Show
      eMEPtest=Bk_eMEPtest
      Redundant=Bk_Redundant
      lCtoF=Bk_lCtoF
      lSoft=Bk_lSoft
      CallLast=Bk_CallLast
      TwoRunFiles=Bk_TwoRunFiles
      TSConstraints=Bk_TSConstraints
      MEPCons=Bk_MEPCons
      Track=Bk_Track
      Request_Alaska=Bk_Request_Alaska
      Request_RASSI=Bk_Request_RASSI
      ThrEne=Bk_ThrEne
      ThrGrd=Bk_ThrGrd
      Beta=Bk_Beta
      Beta_Disp=Bk_Beta_Disp
      Delta=Bk_Delta
      Rtrnc=Bk_Rtrnc
      rHidden=Bk_rHidden
      ThrCons=Bk_ThrCons
      GNrm_Threshold=Bk_GNrm_Threshold
      CnstWght=Bk_CnstWght
      dMEPStep=Bk_dMEPStep
      rFuzz=Bk_rFuzz
      ThrMEP=Bk_ThrMEP
      lTherm=Bk_lTherm
      lDoubleIso=Bk_lDoubleIso
      nUserPT=Bk_nUserPT
      nsRot=Bk_nsRot
      UserT(:)=Bk_UserT(:)
      UserP=Bk_UserP
      HUpMet=Bk_HUpMet
      UpMeth=Bk_UpMeth
      MEP_Type=Bk_MEP_Type
      MEP_Algo=Bk_MEP_Algo
      isFalcon=Bk_isFalcon
      mB_Tot=Bk_mB_Tot
      mdB_Tot=Bk_mdB_Tot
      mq=Bk_mq
      WeightedConstraints=Bk_WeightedConstraints
      NADC=Bk_NADC
      EDiffZero=Bk_EDiffZero
      ApproxNADC=Bk_ApproxNADC
      iState(:)=Bk_iState(:)
      iRow = Bk_iRow
      iRow_c=Bk_iRow_c
      nFix = Bk_nFix
      iInt = Bk_iInt
      VarR = Bk_VarR
      VarT = Bk_VarT
*
*     Process arrays that is always allocated.
*
      If (Allocated(Bk_Cx)) Then
         Cx(:,:,:) = Bk_Cx(:,:,:)
         Call mma_deallocate(Bk_Cx)
      Else
         Call mma_deallocate(Cx)
      End If
      If (Allocated(Bk_Gx)) Then
         Gx(:,:,:) = Bk_Gx(:,:,:)
         Call mma_deallocate(Bk_Gx)
      Else
         Call mma_deallocate(Gx)
      End If
      If (Allocated(Bk_Gx0)) Then
         Gx0(:,:,:) = Bk_Gx0(:,:,:)
         Call mma_deallocate(Bk_Gx0)
      Else
         Call mma_deallocate(Gx0)
      End If
      If (Allocated(Bk_Q_nuclear)) Then
         Q_nuclear(:) = Bk_Q_nuclear(:)
         Call mma_deallocate(Bk_Q_nuclear)
      Else
         Call mma_deallocate(Q_nuclear)
      End If
      If (Allocated(Bk_dMass)) Then
         dMass(:) = Bk_dMass(:)
         Call mma_deallocate(Bk_dMass)
      Else
         Call mma_deallocate(dMass)
      End If
      If (Allocated(Bk_Coor)) Then
         Coor(:,:) = Bk_Coor(:,:)
         Call mma_deallocate(Bk_Coor)
      Else
        If (Allocated(Coor)) Call mma_deallocate(Coor)
      End If
      If (Allocated(Bk_Grd)) Then
         Grd(:,:) = Bk_Grd(:,:)
         Call mma_deallocate(Bk_Grd)
      Else
        If (Allocated(Grd)) Call mma_deallocate(Grd)
      End If
      If (Allocated(Bk_ANr)) Then
         ANr(:) = Bk_ANr(:)
         Call mma_deallocate(Bk_ANr)
      Else
         Call mma_deallocate(ANr)
      End If
      If (Allocated(Bk_Weights)) Then
         Weights(:) = Bk_Weights(:)
         Call mma_deallocate(Bk_Weights)
      Else
         Call mma_deallocate(Weights)
      End If
      If (Allocated(Bk_Shift)) Then

         If (SIZE(Shift,1)/=SIZE(Bk_Shift,1)) Then
            Call mma_deallocate(Shift)
            Call mma_allocate(Shift,SIZE(Bk_Shift,1),MaxItr,
     &                        Label='Shift')
         End If
         Shift(:,:) = Bk_Shift(:,:)
         Call mma_deallocate(Bk_Shift)
      Else
         Call mma_deallocate(Shift)
      End If
      If (Allocated(Bk_GNrm)) Then
         GNrm(:) = Bk_GNrm(:)
         Call mma_deallocate(Bk_GNrm)
      Else
         Call mma_deallocate(GNrm)
      End If
      If (Allocated(Bk_Energy)) Then
         Energy(:) = Bk_Energy(:)
         Call mma_deallocate(Bk_Energy)
      Else
         Call mma_deallocate(Energy)
      End If
      If (Allocated(Bk_Energy0)) Then
         Energy0(:) = Bk_Energy0(:)
         Call mma_deallocate(Bk_Energy0)
      Else
         Call mma_deallocate(Energy0)
      End If
      If (Allocated(Bk_MF)) Then
         MF(:,:) = Bk_MF(:,:)
         Call mma_deallocate(Bk_MF)
      Else
         Call mma_deallocate(MF)
      End If
      If (Allocated(Bk_DipM)) Then
         DipM(:,:) = Bk_DipM(:,:)
         Call mma_deallocate(Bk_DipM)
      Else
        If (Allocated(DipM)) Call mma_deallocate(DipM)
      End If
      If (Allocated(Bk_RefGeo)) Then
         RefGeo(:,:) = Bk_RefGeo(:,:)
         Call mma_deallocate(Bk_RefGeo)
      Else
        If (Allocated(RefGeo)) Call mma_deallocate(RefGeo)
      End If
*
*     Process arrays that is allocated optionally.
*
      If (Allocated(Bk_NAC)) Then
         NAC(:,:) = Bk_NAC(:,:)
         Call mma_deallocate(Bk_NAC)
      Else
        If (Allocated(NAC)) Call mma_deallocate(NAC)
      End If
      If (Allocated(Bk_Lambda)) Then
         If (.NOT.Allocated(Lambda)) Then
            Call mma_allocate(Lambda,SIZE(Bk_Lambda,1),MaxItr+1,
     &                        Label='Lambda')
         End If
         Lambda(:,:) = Bk_Lambda(:,:)
         Call mma_deallocate(Bk_Lambda)
      Else
        If (Allocated(Lambda)) Call mma_deallocate(Lambda)
      End If

      If (Allocated(Bk_qInt)) Then
         If (Allocated(qInt)) Call mma_deallocate(qInt)
         Call mma_allocate(qInt,SIZE(Bk_qInt,1),MaxItr,Label='qInt')
         qInt(:,:) = Bk_qInt(:,:)
         Call mma_deallocate(Bk_qInt)
      Else
         If (Allocated(qInt)) Call mma_deallocate(qInt)
      End If
      If (Allocated(Bk_dqInt)) Then
         If (Allocated(dqInt)) Call mma_deallocate(dqInt)
         Call mma_allocate(dqInt,SIZE(Bk_dqInt,1),MaxItr,Label='dqInt')
         dqInt(:,:) = Bk_dqInt(:,:)
         Call mma_deallocate(Bk_dqInt)
      Else
         If (Allocated(dqInt)) Call mma_deallocate(dqInt)
      End If

      If (Allocated(Bk_BM)) Then
         If (Allocated(BM)) Call mma_deallocate(BM)
         Call mma_allocate(BM,SIZE(Bk_BM),Label='BM')
         BM(:) = Bk_BM(:)
         Call mma_deallocate(Bk_BM)
      Else
         If (Allocated(BM)) Call mma_deallocate(BM)
      End If
      If (Allocated(Bk_dBM)) Then
         If (Allocated(dBM)) Call mma_deallocate(dBM)
         Call mma_allocate(dBM,SIZE(Bk_dBM),Label='dBM')
         dBM(:) = Bk_dBM(:)
         Call mma_deallocate(Bk_dBM)
      Else
         If (Allocated(dBM)) Call mma_deallocate(dBM)
      End If
      If (Allocated(Bk_iBM)) Then
         If (Allocated(iBM)) Call mma_deallocate(iBM)
         Call mma_allocate(iBM,SIZE(Bk_iBM),Label='iBM')
         iBM(:) = Bk_iBM(:)
         Call mma_deallocate(Bk_iBM)
      Else
         If (Allocated(iBM)) Call mma_deallocate(iBM)
      End If
      If (Allocated(Bk_idBM)) Then
         If (Allocated(idBM)) Call mma_deallocate(idBM)
         Call mma_allocate(idBM,SIZE(Bk_idBM),Label='idBM')
         idBM(:) = Bk_idBM(:)
         Call mma_deallocate(Bk_idBM)
      Else
         If (Allocated(idBM)) Call mma_deallocate(idBM)
      End If
      If (Allocated(Bk_nqBM)) Then
         If (Allocated(nqBM)) Call mma_deallocate(nqBM)
         Call mma_allocate(nqBM,SIZE(Bk_nqBM),Label='nqBM')
         nqBM(:) = Bk_nqBM(:)
         Call mma_deallocate(Bk_nqBM)
      Else
         If (Allocated(nqBM)) Call mma_deallocate(nqBM)
      End If
      If (Allocated(Bk_BMx)) Then
         If (Allocated(BMx)) Call mma_deallocate(BMx)
         Call mma_allocate(BMx,SIZE(Bk_BMx,1),SIZE(Bk_BMx,2),
     &                     Label='BMx')
         BMx(:,:) = Bk_BMx(:,:)
         Call mma_deallocate(Bk_BMx)
      Else
         If (Allocated(BMx)) Call mma_deallocate(BMx)
      End If
      If (Allocated(Bk_Degen)) Then
         If (Allocated(Degen)) Call mma_deallocate(Degen)
         Call mma_allocate(Degen,SIZE(Bk_Degen,1),SIZE(Bk_Degen,2),
     &                     Label='Degen')
         Degen(:,:) = Bk_Degen(:,:)
         Call mma_deallocate(Bk_Degen)
      Else
         If (Allocated(Degen)) Call mma_deallocate(Degen)
      End If
      If (Allocated(Bk_jStab)) Then
         If (Allocated(jStab)) Call mma_deallocate(jStab)
         Call mma_allocate(jStab,[0,7],[1,SIZE(Bk_jStab,2)],
     &                     Label='jStab')
         jStab(:,:) = Bk_jStab(:,:)
         Call mma_deallocate(Bk_jStab)
      Else
         If (Allocated(jStab)) Call mma_deallocate(jStab)
      End If
      If (Allocated(Bk_iCoSet)) Then
         If (Allocated(iCoSet)) Call mma_deallocate(iCoSet)
         Call mma_allocate(iCoSet,[0,7],[1,SIZE(Bk_iCoSet,2)],
     &                     Label='iCoSet')
         iCoSet(:,:) = Bk_iCoSet(:,:)
         Call mma_deallocate(Bk_iCoSet)
      Else
         If (Allocated(iCoSet)) Call mma_deallocate(iCoSet)
      End If
      If (Allocated(Bk_nStab)) Then
         If (Allocated(nStab)) Call mma_deallocate(nStab)
         Call mma_allocate(nStab,SIZE(Bk_nStab,1),Label='nStab')
         nStab(:) = Bk_nStab(:)
         Call mma_deallocate(Bk_nStab)
      Else
         If (Allocated(nStab)) Call mma_deallocate(nStab)
      End If
      If (Allocated(Bk_AtomLbl)) Then
         If (Allocated(AtomLbl)) Call mma_deallocate(AtomLbl)
         Call mma_allocate(AtomLbl,SIZE(Bk_AtomLbl,1),Label='AtomLbl')
         AtomLbl(:) = Bk_AtomLbl(:)
         Call mma_deallocate(Bk_AtomLbl)
      Else
         If (Allocated(AtomLbl)) Call mma_deallocate(AtomLbl)
      End If
      If (Allocated(Bk_Smmtrc)) Then
         If (Allocated(Smmtrc)) Call mma_deallocate(Smmtrc)
         Call mma_allocate(Smmtrc,3,SIZE(Bk_Smmtrc,2),Label='Smmtrc')
         Smmtrc(:,:) = Bk_Smmtrc(:,:)
         Call mma_deallocate(Bk_Smmtrc)
      Else
         If (Allocated(Smmtrc)) Call mma_deallocate(Smmtrc)
      End If
      If (Allocated(Bk_Lbl)) Then
         If (Allocated(Lbl)) Call mma_deallocate(Lbl)
         Call mma_allocate(Lbl,SIZE(Bk_Lbl),Label='Lbl')
         Lbl(:) = Bk_Lbl(:)
         Call mma_deallocate(Bk_Lbl)
      Else
         If (Allocated(Lbl)) Call mma_deallocate(Lbl)
      End If
      If (Allocated(Bk_mRowH)) Then
         If (Allocated(mRowH)) Call mma_deallocate(mRowH)
         Call mma_allocate(mRowH,SIZE(Bk_mRowH),Label='mRowH')
         mRowH(:) = Bk_mRowH(:)
         Call mma_deallocate(Bk_mRowH)
      Else
         If (Allocated(mRowH)) Call mma_deallocate(mRowH)
      End If
      If (Allocated(Bk_RootMap)) Then
         If (Allocated(RootMap)) Call mma_deallocate(RootMap)
         Call mma_allocate(RootMap,SIZE(Bk_RootMap),Label='RootMap')
         RootMap(:) = Bk_RootMap(:)
         Call mma_deallocate(Bk_RootMap)
      Else
         If (Allocated(RootMap)) Call mma_deallocate(RootMap)
      End If
*
      End Subroutine Print_Mode_Components

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1992,2000,2007, Roland Lindh                 *
!               1990, IBM                                              *
!***********************************************************************

!#define _CD_TIMING_
subroutine Drvg1_2Center_RI(Grad,Temp,nGrad,ij2,nij_Eff)
!***********************************************************************
!                                                                      *
!  Object: driver for 2-center two-electron integrals in the RI scheme.*
!                                                                      *
!   The integral derivative is formulated as                           *
!   -Sum(ML) X_ij^K   V_LM^(1) X_kl^L  where                           *
!                                                                      *
!  X_ij^K = Sum(L) R_ij_L  Q_L^K                                       *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for k2 loop. August '91                         *
!             Modified for gradient calculation. January '92           *
!             Modified for SetUp_Ints. January '00                     *
!             Modified for 2-center RI gradients, January '07          *
!***********************************************************************

use setup, only: mSkal, MxPrm
use Index_Functions, only: nTri_Elem
use iSD_data, only: iSD
use pso_stuff, only: A_PT2
use k2_arrays, only: Sew_Scr
use Sizes_of_Seward, only: S
use Gateway_Info, only: CutInt
use RICD_Info, only: Do_RI, RI_2C
use Symmetry_Info, only: nIrrep
use Para_Info, only: King, nProcs
use RI_glob, only: A, AMP2, CijK, DoCholExch, iMP2prpt, MxChVInShl, nIJR, nKvec
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Eight, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nGrad, nij_Eff, ij2(2,nij_Eff)
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Temp(nGrad)
integer(kind=iwp) :: i, iAng, id, ij, iS, iSym1, iSym2, jDen, jlS, jS, jS_, kS, lA, lA_MP2, lS, lS_, mij, nij, nIJRMax, nSkal
real(kind=wp) :: A_int, ThrAO, TMax_all
logical(kind=iwp) :: DoFock, DoGrad, Indexation
integer(kind=iwp), allocatable :: Pair_Index(:,:)
real(kind=wp), allocatable :: TMax1(:), TMax2(:,:)
logical(kind=iwp), external :: Rsv_Tsk

!                                                                      *
!***********************************************************************
!                                                                      *
Temp(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! Handle only the auxiliary basis set.

if (Do_RI) then
  call Set_Basis_Mode('Auxiliary')
  RI_2C = .true.
else
  call Set_Basis_Mode('Valence')
end if
call Setup_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
! Precompute k2 entities.

Indexation = .false.
DoFock = .false.
DoGrad = .true.
ThrAO = Zero
call SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
mSkal = nSkal
!                                                                      *
!***********************************************************************
!                                                                      *
MxPrm = 0
do iAng=0,S%iAngMx
  MxPrm = max(MxPrm,S%MaxPrm(iAng))
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute entities for prescreening at shell level

call mma_allocate(TMax2,nSkal,nSkal,Label='TMax2')
call Shell_MxSchwz(nSkal,TMax2)
TMax_all = Zero

if (Do_RI) then

  call mma_allocate(TMax1,nSkal,Label='TMax1')
  TMax1(:) = TMax2(:,nSkal)

  do iS=1,nSkal-1
    TMax_all = max(TMax_all,TMax1(iS))
  end do

else

  do ij=1,nij_Eff
    iS = ij2(1,ij)
    jS = ij2(2,ij)
    TMax_all = max(TMax_all,TMax2(iS,jS))
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate some scratch arrays to be used by the pget routines.
! In particular we will have temporary arrays for A_IJ and C_ijK.

! Lower case: valence basis set
! Upper case: auxiliary basis sets

if (DoCholExch) then

  ! Find the largest number of contractions in any given shell
  ! of auxiliary functions.

  MxChVInShl = 1
  if (Do_RI) then
    do i=1,nSkal
      MxChVInShl = max(MxChVInShl,iSD(3,i))
    end do
  else
    write(u6,*) 'Not Implemented for Cholesky yet!'
    call Abend()
  end if

  ! Scratch for A_IJ

  lA = MxChVInShl*MxChVInShl
  call mma_allocate(A,lA,Label='A')
  if (iMP2Prpt == 2) then
    lA_MP2 = MxChVInShl
    call mma_allocate(AMP2,lA_MP2,2,Label='AMP2')
  end if

  ! Find the largest set of ij. The basis i and j is due to the
  ! CD of the one-particle density.

  nIJRMax = 0
  do jDen=1,nKvec
    do iSym1=1,nIrrep
      do iSym2=1,nIrrep
        nIJRMax = max(nIJRMax,nIJR(iSym1,iSym2,jDen))
      end do
    end do
  end do

  ! Get scratch for C_kl^I and C_kl^J.
  ! Note that we need nDen arrays for C_kl^I and one for C_kl^J
  ! A_IJ = Sum(kl) C_kl^I x C_kl^J

  call mma_allocate(CijK,nIJRMax*MxChVInShl*(nKvec+1),Label='CijK')

end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Create list of non-vanishing pairs

if (Do_RI) then

  mij = nSkal-1
  call mma_allocate(Pair_Index,2,mij,Label='Shij')
  nij = 0
  do iS=1,nSkal-1
    if (TMax_All*TMax1(iS) >= CutInt) then
      nij = nij+1
      Pair_Index(1,nij) = nSkal
      Pair_Index(2,nij) = iS
    end if
  end do
else
  mij = nij_Eff
  call mma_allocate(Pair_Index,2,mij,Label='Shij')
  nij = 0
  do ij=1,nij_Eff
    iS = ij2(1,ij)
    jS = ij2(2,ij)
    if (TMax_All*TMax2(iS,jS) >= CutInt) then
      nij = nij+1
      Pair_Index(1,nij) = iS
      Pair_Index(2,nij) = jS
    end if
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! For a parallel implementation the iterations over shell-pairs
! are parallelized.

call Init_Tsk(id,nTri_Elem(nij))
!                                                                      *
!***********************************************************************
!                                                                      *
! In MPP case dispatch one processor to do 1-el gradients first

if ((nProcs > 1) .and. King()) then
  if (Do_RI) call Free_iSD()
  call Drvh1(Grad,Temp,nGrad)
# ifdef _DEBUGPRINT_
  call PrGrad(' Gradient excluding two-electron contribution',Grad,nGrad)
# endif
  Temp(:) = Zero
  if (Do_RI) then
    call Set_Basis_Mode('Auxiliary')
    call Setup_iSD()
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! big loop over individual tasks, distributed over individual nodes
do while (Rsv_Tsk(id,jlS))
  ! make reservation of a task on global task list and get task range
  ! in return. Function will be false if no more tasks to execute.

  ! Now do a quadruple loop over shells

  jS_ = int((One+sqrt(Eight*real(jlS,kind=wp)-Three))*Half)
  iS = Pair_Index(1,jS_)
  jS = Pair_Index(2,jS_)
  lS_ = int(real(jlS,kind=wp)-real(jS_,kind=wp)*(real(jS_,kind=wp)-One)*Half)
  kS = Pair_Index(1,lS_)
  lS = Pair_Index(2,lS_)

  if (Do_RI) then
    A_int = TMax1(jS)*TMax1(lS)
  else
    A_int = TMax2(iS,jS)*TMax2(kS,lS)
  end if
  if (A_Int < CutInt) cycle

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call Eval_g1_ijkl(iS,jS,kS,lS,Temp,nGrad,A_Int)

end do
! End of big task loop
!                                                                      *
!***********************************************************************
!                                                                      *
!                         E P I L O G U E                              *
!                                                                      *
!***********************************************************************
!                                                                      *
RI_2C = .false.
call mma_deallocate(Sew_Scr,safe='*')
call Free_Tsk(id)
call mma_deallocate(A_PT2,safe='*')
call mma_deallocate(Pair_Index)
call mma_deallocate(TMax1,safe='*')
call mma_deallocate(TMax2,safe='*')
!                                                                      *
!***********************************************************************
!                                                                      *
call Term_Ints()
!                                                                      *
!***********************************************************************
!                                                                      *
if (DoCholExch) then
  call mma_deallocate(CijK)
  call mma_deallocate(A)
end if
call mma_deallocate(AMP2,safe='*')

call Free_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Drvg1_2Center_RI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Matthew R. Hennefarth                            *
!***********************************************************************
!  get_hcore
!
!> @brief Load bar nuclei Hamiltonian
!>
!> @details
!>   This is h_{mu, nu}, the electron kinetic and nuclear-electron attraction integrals summed in the AO basis.
!>
!> @author Matthew R. Hennefarth
!>
!> @param[out] hcore one electron integrals (kinetic energy + nuclear-electron attraction)
!***********************************************************************

subroutine get_hcore(hcore)

use onedat, only: snoori, snonuc
use general_data, only: ntot1
use Definitions, only: wp, iwp, u0

implicit none
real(kind=wp), intent(out) :: hcore(ntot1)
#include "warnings.h"
integer(kind=iwp) :: comp, opt, rc, sylbl
character(len=8) :: label

rc = -1
opt = ibset(ibset(0,sNoOri),sNoNuc)
comp = 1
sylbl = 1
label = 'OneHam'

call rdone(rc,opt,label,comp,hcore,sylbl)
if (rc /= _RC_ALL_IS_WELL_) then
  call WarningMessage(2,'Error loading hcore integrals')
  write(u0,*) 'Error calling rdone'
  write(u0,*) 'Label = ',label
  write(u0,*) 'RC = ',rc
  call abend()
end if

end subroutine get_hcore

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mlt_PCM(nAt,nTs,nOrdOp,Tessera,AtmC,V,EF_n,EF_e)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAt, nTs, nOrdOp
real(kind=wp), intent(in) :: Tessera(4,nTs), AtmC(3,nAt)
real(kind=wp), intent(out) :: V(nTs), EF_n(3,nTs)
real(kind=wp), intent(inout) :: EF_e(3,nTs)
integer(kind=iwp) :: iTs, nDens
real(kind=wp) :: Temp(3)
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: lOper(:)
real(kind=wp), allocatable :: Chrg(:), D1ao(:), FactOp(:)

call mma_allocate(Chrg,nat)
call Get_dArray('Nuclear charge',Chrg,nAt)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the desired multipole on the tiles

! 1) The nuclear contribution

do iTs=1,nTs
  call EFNuc(Tessera(1,iTs),Chrg,AtmC,nAt,Temp,nOrdOp)
  if (nOrdOp == 0) then
    V(iTs) = Temp(1)
  else if (nOrdOp == 1) then
    EF_n(:,iTs) = Temp(:)
  end if
end do

call mma_deallocate(Chrg)

! 2) The electronic contribution

! Get the total 1st order AO density matrix

call Qpg_dArray('D1ao',Found,nDens)
if (Found .and. (nDens /= 0)) then
  call mma_allocate(D1ao,nDens,Label='D1ao')
else
  write(u6,*) 'Mlt_pcm: D1ao not found.'
  call Abend()
end if
call Get_D1ao(D1ao,nDens)

call mma_allocate(FactOp,nTs,label='FactOp')
call mma_allocate(lOper,nTs,label='lOper')
FactOp(:) = One
lOper(:) = 255

call drv_ef_PCM(FactOp,nTs,D1ao,nDens,Tessera,lOper,EF_e,nOrdOp)
if (nOrdOp == 0) then
  do iTs=1,nTs
    V(iTs) = Ef_e(1,iTs)
  end do
end if

call mma_deallocate(D1ao)
call mma_deallocate(FactOp)
call mma_deallocate(lOper)

return

end subroutine Mlt_PCM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NQGrid_Init()

use Grid_On_Disk, only: Final_Grid, G_S, iDisk_Grid, iDisk_Set, Intermediate, Lu_Grid, Old_Functional_Type, Regenerate
use nq_Info, only: Other_Type
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iDisk, iDum(1)

!                                                                      *
!***********************************************************************
!                                                                      *
! Make the grid file dirty

! Open the file.
Lu_Grid = 77
call DaName_MF_WA(Lu_Grid,'NQGRID')

! Write the status flag and disk addresses fo the sets.

iDisk_Set(Final_Grid) = -1
iDisk_Set(Intermediate) = -1
G_S(Final_Grid) = Regenerate
G_S(Intermediate) = Regenerate
Old_Functional_Type = Other_Type

iDisk_Grid = 0
call iDaFile(Lu_Grid,1,G_S,2,iDisk_Grid)
iDisk = iDisk_Grid
call iDaFile(Lu_Grid,1,iDisk_Set,2,iDisk_Grid)
iDum(1) = Old_Functional_Type
call iDaFile(Lu_Grid,1,iDum,1,iDisk_Grid)

iDisk_Set(Final_Grid) = iDisk_Grid
iDisk_Set(Intermediate) = iDisk_Grid

call iDaFile(Lu_Grid,1,iDisk_Set,2,iDisk)

call DaClos(Lu_Grid)
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine NQGrid_Init

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003-2005, Valera Veryazov                             *
!               2017, Roland Lindh                                     *
!***********************************************************************

subroutine IniLLs()
! initialize the diverse linked lists

use LnkLst, only: IniLst, Init_LLs, LLDelt, LLdGrd, LLGrad, LLlist, LLlGrd, LLx, LLy
use InfSCF, only: MxOptm

implicit none

LLlist = 0
LLGrad = 0
call IniLst(LLGrad,20)
call IniLst(LLlGrd,20)
call IniLst(LLDgrd,20)
call IniLst(LLDelt,20)
call IniLst(LLy,20)
call IniLst(LLx,MxOptm)
Init_LLs = .true.

end subroutine IniLLs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine Fix_Exponents(nP,mP,nC,Exp,CoeffC,CoeffP)
       Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
       Real*8, Allocatable:: Exp(:), CoeffC(:,:,:), CoeffP(:,:,:)
       Real*8, Allocatable:: Scr(:,:,:)
*
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
       Call RecPrt('Fix_Exponents: Exp',' ',Exp,1,nP)
       Call RecPrt('Fix_Exponents: CoeffC(1)',' ',CoeffC(1,1,1),nP,nC)
       Call RecPrt('Fix_Exponents: CoeffC(2)',' ',CoeffC(1,1,2),nP,nC)
       Call RecPrt('Fix_Exponents: CoeffP(1)',' ',CoeffP(1,1,1),nP,nP)
       Call RecPrt('Fix_Exponents: CoeffP(2)',' ',CoeffP(1,1,2),nP,nP)
#endif
*
       mP = nP
       Call Fix_Exp()
*
#ifdef _DEBUGPRINT_
       Write (6,*) 'After Fix_Exp'
       Call RecPrt('Fix_Exponents: Exp',' ',Exp,1,nP)
       Call RecPrt('Fix_Exponents: CoeffC(1)',' ',CoeffC(1,1,1),nP,nC)
       Call RecPrt('Fix_Exponents: CoeffC(2)',' ',CoeffC(1,1,2),nP,nC)
       Call RecPrt('Fix_Exponents: CoeffP(1)',' ',CoeffP(1,1,1),nP,nP)
       Call RecPrt('Fix_Exponents: CoeffP(2)',' ',CoeffP(1,1,2),nP,nP)
#endif
*
*      Reallocate arrays if the number of primitives is reduced.
*
       If (mP.ne.nP) Then
          Call mma_allocate(Scr,mP,1,1,Label='Scr')
          Scr(1:mP,1,1)=Exp(1:mP)
          Call mma_deallocate(Exp)
          Call mma_allocate(Exp,nP,Label='Exp')
          Exp(:)=Scr(:,1,1)
          Call mma_deallocate(Scr)
*
          Call mma_allocate(Scr,mP,nC,2,Label='Scr')
          Scr(1:mP,1:nC,:) = CoeffC(1:mP,1:nC,:)
          Call mma_deallocate(CoeffC)
          Call mma_allocate(CoeffC,mP,nC,2,Label='CoeffC')
          CoeffC(:,:,:)=Scr(:,:,:)
          Call mma_deallocate(Scr)
*
          Call mma_allocate(Scr,mP,mP,2,Label='Scr')
          Scr(1:mP,1:mP,:) = CoeffP(1:mP,1:mP,:)
          Call mma_deallocate(CoeffP)
          Call mma_allocate(CoeffP,mP,mP,2,Label='CoeffP')
          CoeffP(:,:,:)=Scr(:,:,:)
          Call mma_deallocate(Scr)
       End If
*
#ifdef _DEBUGPRINT_
       Write (6,*) 'After Reallocation'
       Call RecPrt('Fix_Exponents: Exp',' ',Exp,1,mP)
       Call RecPrt('Fix_Exponents: CoeffC(1)',' ',CoeffC(1,1,1),mP,nC)
       Call RecPrt('Fix_Exponents: CoeffC(2)',' ',CoeffC(1,1,2),mP,nC)
       Call RecPrt('Fix_Exponents: CoeffP(1)',' ',CoeffP(1,1,1),mP,mP)
       Call RecPrt('Fix_Exponents: CoeffP(2)',' ',CoeffP(1,1,2),mP,mP)
#endif
       Return
*                                                                      *
************************************************************************
*                                                                      *
       Contains
*                                                                      *
************************************************************************
*                                                                      *
       Subroutine Fix_Exp
*
*      First, put the exponents with all coefficients less than the
*      threshold, Thr_Skip, at the end.
*
       Thr_Skip = 1.0D-13
       Do iP = nP, 1, -1
*
          iSkip=1
          Do iC = 1, nC
             If (Abs(CoeffC(iP,iC,1)).ge.Thr_Skip) iSkip=0
          End Do
*
          If (iSkip.eq.1) Then
             If (iP.lt.mP) Then
                Temp   =Exp(iP)
                Exp(iP)=Exp(mP)
                Exp(mP)=Temp
                Do i = 1, 2
                   Temp           =CoeffP(iP,iP,i)
                   CoeffP(iP,iP,i)=CoeffP(mP,mP,i)
                   CoeffP(mP,mP,i)=Temp
                   Do iC = 1, nC
                      Temp            = CoeffC(iP,iC,i)
                      CoeffC(iP,iC,i) = CoeffC(mP,iC,i)
                      CoeffC(mP,iC,i) = Temp
                   End Do
                End Do
             End If
             mP = mP -1
          End If
*
       End Do
*
*      Second, order from largest to smallest exponent
*
       Do iP = 1, mP-1
          Do jP = iP+1, mP
             If (Exp(jP).gt.Exp(ip)) Then
                Temp   =Exp(iP)
                Exp(iP)=Exp(jP)
                Exp(jP)=Temp
                Do i = 1, 2
                   Temp           =CoeffP(iP,iP,i)
                   CoeffP(iP,iP,i)=CoeffP(jP,jP,i)
                   CoeffP(jP,jP,i)=Temp
                   Do iC = 1, nC
                      Temp            = CoeffC(iP,iC,i)
                      CoeffC(iP,iC,i) = CoeffC(jP,iC,i)
                      CoeffC(jP,iC,i) = Temp
                   End Do
                End Do
             End If
          End Do
       End Do
*
       Return
       End Subroutine Fix_Exp
*                                                                      *
************************************************************************
*                                                                      *
       End Subroutine Fix_Exponents

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine FixOrb(Ovrlp,CMO,TrMat,nCMO)
************************************************************************
*                                                                      *
*     purpose: Diagonalize core hamiltonian to get starting orbitals.  *
*                                                                      *
*     input:                                                           *
*       OneHam  : one-electron hamiltonian of length nOH               *
*       TrMat   : matrix transforming to orthonotmal basis of          *
*                 length nCMO                                          *
*                                                                      *
*     output:                                                          *
*       CMO     : starting vectors of length nCMO                      *
*                                                                      *
*     called from: Start1                                              *
*                                                                      *
*     calls to: ModFck, PickUp, Sort                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 Ovrlp(nCMO),CMO(nCMO),TrMat(nCMO)
*
      Real*8, Dimension(:), Allocatable:: S, TT, TTS, CMO0
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*                                                                      *
************************************************************************
*                                                                      *
*---- Allocate memory
*
      Call mma_allocate(S,MaxBas**2,Label='S')
      Call mma_allocate(TT,MaxBas**2,Label='TT')
      Call mma_allocate(TTS,MaxBas**2,Label='TTS')
      Call mma_allocate(CMO0,MaxBas**2,Label='CMO0')
*                                                                      *
************************************************************************
*                                                                      *
*     Observe that TrGen has been called and that the dimensions might
*     have been change. Note also that at this point work in the full
*     basis.
*
*---- Loop over symmetry blocks
*
      iS     = 1
      iCMO   = 1
      iTrM   = 1
      Do iSym = 1, nSym
#ifdef _DEBUGPRINT_
         Call RecPrt('FixOrb: CMO(in)',' ',CMO(iCMO),
     &                       nBas(iSym),nBas(iSym))
         Call RecPrt('FixOrb: TrMat',' ',TrMat(iCMO),
     &                       nBas(iSym),nOrb(iSym))
#endif
*
         nOF  = nOrb(iSym) - nFro(iSym)
         nBF  = nBas(iSym) - nFro(iSym)
*
*------- Skip the frozen orbitals
*
         iCMO   = iCMO + nBas(iSym)*nFro(iSym)
         iTrM   = iTrM + nBas(iSym)*nFro(iSym)
*
         If (nBF.gt.0) Then
*
*---------- Project to the reduced basis
*
*---------- Create the project operator
            Call DGEMM_('N','T',
     &                  nBas(iSym),nBas(iSym),nOF,
     &                  1.0d0,TrMat(iTrM),nBas(iSym),
     &                        TrMat(iTrM),nBas(iSym),
     &                  0.0d0,TT,nBas(iSym))
            Call Square(Ovrlp(iS),S,1,nBas(iSym),nBas(iSym))
            Call DGEMM_('N','N',
     &                  nBas(iSym),nBas(iSym),nBas(iSym),
     &                  1.0d0,TT,nBas(iSym),
     &                        S,nBas(iSym),
     &                  0.0d0,TTS,nBas(iSym))
#ifdef _DEBUGPRINT_
            Call RecPrt('FixOrb: TT',' ',TT,nBas(iSym),nBas(iSym))
            Call RecPrt('FixOrb: TTS',' ',TTS,nBas(iSym),nBas(iSym))
#endif
*
*---------- Project
            Call DGEMM_('N','N',
     &                  nBas(iSym),nOF,nBas(iSym),
     &                  1.0d0,TTS,nBas(iSym),
     &                        CMO(iCMO),nBas(iSym),
     &                  0.0d0,CMO0,nBas(iSym))
            call dcopy_(nBas(iSym)*nOF,CMO0,1,CMO(iCMO),1)
#ifdef _DEBUGPRINT_
            Call RecPrt('FixOrb: CMO(out)',' ',CMO(iCMO),
     &                             nBas(iSym),nBas(iSym))
#endif
*
         End If
*
*------- Update pointers
         iCMO = iCMO + nBF*nBas(iSym)
         iTrM = iTrM + nOF*nBas(iSym)
         iS   = iS   + nBas(iSym)*(nBas(iSym)+1)/2
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Deallocate memory
*
      Call mma_deallocate(CMO0)
      Call mma_deallocate(TTS)
      Call mma_deallocate(TT)
      Call mma_deallocate(S)
*                                                                      *
************************************************************************
*                                                                      *
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADADS1(NK,I1,XI1S,IOBSM,IOBTP,IOBOFF,NIOB,JOBSM,JOBTP,JOBOFF,NJOB,IJORD,NKDIM,ICLS,ISM,I2MAPO,I2MAPS,I2MPF,L2MP,I2MPO, &
                  I2MPL,I1MAPO,I1MAPS,I1MPF,L1MP,I1MPO,I1MPL,IEL1,IEL3,I2EL1,I2EL3,ISSO,I2SSO,N2SSO,NOCTP,N2OCTP,NORB,KMAX,KMIN, &
                  IEND)
! Obtain I1(KSTR) = +/- A+ IORB !KSTR>
!
! KSTR is restricted to strings with relative numbers in the
! range KMAX to KMIN
! =====
! Input
! =====
! ICLS,ISM : Class and symmetry of string with added electron
! I2MAPO,I2MAPS : map N-2 strings to N-1 strings
! I1MAPO,I1MAPS : map N-1 strings to  strings
! IEL1(3) : Number of electrons in RAS1(3) for I strings
! I2EL1(3) : Number of electrons in RAS1(3) for K strings
! ISSO : TS symmetry offset for I strings
! I2SSO : TS symmetry offset for K strings
! N2SSO : Number of TS strings for K strings
! NOCTP : Number of occupation types for I strings
! N2OCTP : Number of occupation types for K strings
! IORBSM : Orbital symmety array
! NORB : Number of active  orbitals
! KMAX : Largest allowed relative number for K strings
! KMIN : Smallest allowed relative number for K strings
!
! ======
! Output
! ======
!
! NK         : Number of K strings
! I1(KSTR)   : /= 0 => a + IORB a+ JORB !KSTR> = +/-!ISTR>
! XI1S(KSTR) : above +/-
!            : == 0    a + IORB !KSTR> = 0
! Offset is KMIN
! IEND : = 0 => end of N-2 strings has not been encountered
! IEND : = 1 => end of N-2 strings has     been encountered

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: NK, IEND
integer(kind=iwp), intent(in) :: IOBSM, IOBTP, IOBOFF, NIOB, JOBSM, JOBTP, JOBOFF, NJOB, IJORD, NKDIM, ICLS, ISM, I2MAPO(*), &
                                 I2MAPS(*), I2MPF, L2MP, I2MPO(*), I2MPL(*), I1MAPO(*), I1MAPS(*), I1MPF, L1MP, I1MPO(*), &
                                 I1MPL(*), IEL1(*), IEL3(*), I2EL1(*), I2EL3(*), NOCTP, ISSO(NOCTP,*), N2OCTP, I2SSO(N2OCTP,*), &
                                 N2SSO(N2OCTP,*), NORB, KMAX, KMIN
integer(kind=iwp), intent(_OUT_) :: I1(NKDIM,*)
real(kind=wp), intent(_OUT_) :: XI1S(NKDIM,*)
integer(kind=iwp) :: i, IFST, IIORB, ij, IJOFF, IKSM, IMIN, IOFF, iorb, ISTR, J, JJORB, JKSM, JKSTR, JORB, KEL1, KEL3, KEND, &
                     KKTYPE, KOFF, KSM, KSTR, KTYPE, NIJ
real(kind=wp) :: SGN
logical(kind=iwp) :: Skip

NIJ = 0 ! dummy initialize
#ifdef _DEBUGPRINT_
write(u6,*) ' ================'
write(u6,*) ' Info from ADADS1'
write(u6,*) ' ================'
write(u6,*) ' Iobsm Iobtp Ioboff, Niob',IOBSM,IOBTP,IOBOFF,NIOB
write(u6,*) ' Jobsm Jobtp Joboff, NJob',JOBSM,JOBTP,JOBOFF,NJOB
write(u6,*) ' icls ism',ICLS,ISM
write(u6,*) ' I1MPF, I2MPF ',I1MPF,I2MPF
#endif

NK = KMAX-KMIN+1
! Type of kstrings
if (IOBTP == 1) then
  KEL1 = IEL1(ICLS)-1
  KEL3 = IEL3(ICLS)
else if (IOBTP == 2) then
  KEL1 = IEL1(ICLS)
  KEL3 = IEL3(ICLS)
else
  KEL1 = IEL1(ICLS)
  KEL3 = IEL3(ICLS)-1
end if
if (JOBTP == 1) then
  KEL1 = KEL1-1
  KEL3 = KEL3
else if (JOBTP == 2) then
  KEL1 = KEL1
  KEL3 = KEL3
else
  KEL1 = KEL1
  KEL3 = KEL3-1
end if
!write(u6,*) ' icls ',icls
!write(u6,*) ' iel1 iel3 ',iel1(icls),iel3(icls)
!write(u6,*) ' kel1 kel3 ',kel1,kel3
KTYPE = 0
do KKTYPE=1,N2OCTP
  if ((I2EL1(KKTYPE) == KEL1) .and. (I2EL3(KKTYPE) == KEL3)) KTYPE = KKTYPE
end do
!write(u6,*) ' ktype ',ktype
Skip = .false.
if (KTYPE == 0) then
  NK = 0
  IEND = 1
  Skip = .true.
else
  ! Symmetry of K strings
  KSM = 0
  JKSM = Mul(IOBSM,ISM)
  if (JKSM == 0) then
    IKSM = Mul(JOBSM,ISM)
    if (IKSM == 0) then
      NK = 0
      IEND = 1
      Skip = .true.
    else
      KSM = Mul(IOBSM,IKSM)
    end if
  else
    KSM = Mul(JOBSM,JKSM)
  end if
  !write(u6,*) ' JOBSM,KSM,JKSM ',JOBSM,KSM,JKSM
  if (KSM == 0) then
    NK = 0
    IEND = 1
    Skip = .true.
  end if
end if
if (.not. Skip) then
  KOFF = I2SSO(KTYPE,KSM)
  KEND = min(KMAX,N2SSO(KTYPE,KSM))
  if (KEND == N2SSO(KTYPE,KSM)) then
    IEND = 1
  else
    IEND = 0
  end if
  NK = KEND-KMIN+1
  IOFF = ISSO(ICLS,ISM)
  ! Loop over iorb,jorb
  if (IJORD == 0) then
    NIJ = NIOB*NJOB
  else
    NIJ = nTri_Elem(NIOB)
  end if
  if (NKDim > 0) then
    I1(:,1:NIJ) = 0
    XI1S(:,1:NIJ) = Zero
  end if

  do J=1,NJOB
    if (IJORD == 1) then
      IMIN = J
    else
      IMIN = 1
    end if
    !do I=IMIN,NIOB
    !  IJ = IJ+1
    !  do IJ=1,NIJ
    !    call NXTIJ(I,J,NIOB,NJOB,IJORD,NONEW)
    !    IORB = IOBOFF-1+I
    JORB = JOBOFF-1+J
    if (IJORD == 1) then
      IJOFF = (J-1)*NIOB-nTri_Elem(J-2)+1-imin+1
    else
      IJOFF = (J-1)*NIOB+1
    end if
    do KSTR=KOFF+KMIN-1,KOFF+KEND-1
      ! N-2 => N-1
      JKSTR = 0
      if (I2MPF == 1) then
        if (I2MAPO((KSTR-1)*L2MP+JORB) == JORB) JKSTR = I2MAPS((KSTR-1)*L2MP+JORB)
      else if (I2MPF == 0) then
        IFST = max(1,JORB+I2MPL(KSTR)-NORB)
        do JJORB=IFST,min(JORB,I2MPL(KSTR))
          if (I2MAPO(I2MPO(KSTR)-1+JJORB) == JORB) JKSTR = I2MAPS(I2MPO(KSTR)-1+JJORB)
        end do
      end if
      if (JKSTR == 0) cycle
      if (JKSTR > 0) then
        SGN = One
      else
        JKSTR = -JKSTR
        SGN = -One
      end if
      ! N-1 => N
      do i=imin,niob
        ij = ijoff+i-1
        iorb = ioboff-1+i
        ISTR = 0
        if (I1MPF == 1) then
          if (I1MAPO((JKSTR-1)*L1MP+IORB) == IORB) ISTR = I1MAPS((JKSTR-1)*L1MP+IORB)
        else if (I1MPF == 0) then
          IFST = max(1,IORB+NORB-I1MPL(JKSTR))
          do IIORB=IFST,min(IORB,I1MPL(JKSTR))
            if (I1MAPO(I1MPO(JKSTR)-1+IIORB) == IORB) ISTR = I1MAPS(I1MPO(JKSTR)-1+IIORB)
          end do
        end if
        if (ISTR == 0) cycle
        ! Synthesis
        if (ISTR > 0) then
          I1(KSTR-KOFF-KMIN+2,IJ) = ISTR-IOFF+1
          XI1S(KSTR-KOFF-KMIN+2,IJ) = SGN
        else
          I1(KSTR-KOFF-KMIN+2,IJ) = -ISTR-IOFF+1
          XI1S(KSTR-KOFF-KMIN+2,IJ) = -SGN
        end if
      end do

    end do

    !end do
  end do
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from ADADS1'
write(u6,*) ' =================='
write(u6,*) ' Number of K strings accessed ',NK
if (NK /= 0) then
  do IJ=1,NIJ
    write(u6,*) ' Excited strings and sign for ij = ',IJ
    call IWRTMA(I1(1,IJ),1,NK,1,NK)
    call WRTMAT(XI1S(1,IJ),1,NK,1,NK)
  end do
end if
#endif

end subroutine ADADS1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Sort_to_Box(Coor,nAtoms,iTab,nMax,nx,ny,nz,iBox,iANr,
     &                       xmin,ymin,zmin,Box_Size)
      Implicit Real*8 (a-h,o-z)
      Real*8 Coor(3,nAtoms)
      Integer iTab(0:nMax,nx,ny,nz), iBox(3,nAtoms), iANr(nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*
      Call ICopy((nMax+1)*nx*ny*nz,[0],0,iTab,1)
*
      Do iAtom = 1, nAtoms
*
         If (iTabRow(iAnr(iAtom)).eq.0) Go To 99
*
         x = Coor(1,iAtom)-xmin
         ix = Int(x/Box_Size)+1
         y = Coor(2,iAtom)-ymin
         iy = Int(y/Box_Size)+1
         z = Coor(3,iAtom)-zmin
         iz = Int(z/Box_Size)+1
         iBox(1,iAtom)=ix
         iBox(2,iAtom)=iy
         iBox(3,iAtom)=iz
*
         Nr = iTab(0,ix,iy,iz) + 1
         If (Nr.gt.nMax) Then
            Call WarningMessage(2,'Sort_to_Box: Nr.gt.nMax')
            Call Abend()
         End If
#ifdef _DEBUGPRINT_
         Write (6,*) 'Sort_to_Box: ix,iy,iz,Nr,iAtom=',
     &                             ix,iy,iz,Nr,iAtom
#endif
*
         iTab(0, ix,iy,iz)=Nr
         iTab(Nr,ix,iy,iz)=iAtom
*
 99      Continue
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gugadrt_dbl_downwalk()
!     juv,just(nost,nost),jud(nost)
!     |  \  1         |
!     | d,dd,s(i=i)   |
!     |    \ s,t,tt(i<j)|
!     |     \       1 2 |     deal with inner of dbl_space
!     |ss(i>j)\       |
!     |  2 1  \       |

use gugadrt_global, only: iseg_sta, iseg_downwei, lsm_inn, max_innorb, ng_sm, norb_dbl, norb_dz, norb_frz, ns_sm
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: im, ismi, ismij, ismj, lr0, lri, lrj, nnd, nns, nnt
integer(kind=iwp), allocatable :: jud(:), just(:,:)

call mma_allocate(jud,max_innorb,label='jud')
call mma_allocate(just,max_innorb,max_innorb,label='just')

if (norb_dbl == 0) then
  !----------- norb_dbl=0 ------------------------------------------------
  do im=1,ng_sm
    nnd = iseg_sta(1+im)
    nnt = iseg_sta(9+im)
    nns = iseg_sta(17+im)
    do lri=norb_dz,norb_frz+1,-1
      ismi = lsm_inn(lri)
      if (ismi /= im) cycle
      jud(lri) = nnd
      nnd = nnd+iseg_downwei(1+im)
    end do
    do lrj=norb_dz,norb_frz+1,-1
      ismj = lsm_inn(lrj)
      do lri=lrj,1,-1
        ismi = lsm_inn(lri)
        ismij = Mul(ismi,ismj)
        if (ismij /= im) cycle
        just(lri,lrj) = nns
        nns = nns+iseg_downwei(17+im)
        if (lri == lrj) cycle
        just(lrj,lri) = nnt
        nnt = nnt+iseg_downwei(9+im)
      end do
    end do
  end do
end if
!----------- norb_dbl<>0 -----------------------------------------------
do im=1,ng_sm
  nnd = 0
  nns = 0
  do lri=norb_frz+1,norb_dz
    ismi = Mul(lsm_inn(lri),ns_sm)
    if (ismi /= im) cycle
    jud(lri) = nnd
    nnd = nnd+1
  end do
  do lri=norb_frz+1,norb_dz-1
    ismi = Mul(lsm_inn(lri),ns_sm)
    do lrj=lri+1,norb_dz !tmp
      ismj = lsm_inn(lrj)
      ismij = Mul(ismi,ismj)
      if (ismij /= im) cycle
      just(lri,lrj) = nns
      nns = nns+1
    end do
  end do
  if (im == ns_sm) then
    do lr0=norb_frz+1,norb_dz
      just(lr0,lr0) = nns
      nns = nns+1
    end do
  end if
  do lri=norb_frz+1,norb_dz-1
    ismi = Mul(lsm_inn(lri),ns_sm)
    do lrj=lri+1,norb_dz !tmp
      ismj = lsm_inn(lrj)
      ismij = Mul(ismi,ismj)
      if (ismij /= im) cycle
      just(lrj,lri) = nns
      nns = nns+1
    end do
  end do
end do

call mma_deallocate(jud)
call mma_deallocate(just)

return

end subroutine gugadrt_dbl_downwalk

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine VanishT1(wrk,wrksize)
! this routine does:
! Vanish T1o

use chcc_global, only: no, nv, PosT1o
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: len_

len_ = no*nv
wrk(PosT1o:PosT1o+len_-1) = Zero

return

end subroutine VanishT1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE UPPCAS(LINE,LENGTH)
*
* Convert letters in character string LINE to upper case
*
* very stupid and not vectorized !
*
      CHARACTER*(*) LINE
      PARAMETER (NCHAR = 41)
      CHARACTER*1 LOWER(NCHAR)
      CHARACTER*1 UPPER(NCHAR)
*
      DATA LOWER/'a','b','c','d','e',
     &           'f','g','h','i','j',
     &           'k','l','m','n','o',
     &           'p','q','r','s','t',
     &           'u','v','w','x','y',
     &           'z','+','-','<','>',
     &           '=','0','1','2','3',
     &           '4','5','6','7','8',
     &           '9'/
      DATA UPPER/'A','B','C','D','E',
     &           'F','G','H','I','J',
     &           'K','L','M','N','O',
     &           'P','Q','R','S','T',
     &           'U','V','W','X','Y',
     &           'Z','+','-','<','>',
     &           '=','0','1','2','3',
     &           '4','5','6','7','8',
     &           '9'/
*
      DO 100 ICHA = 1, LENGTH
        DO 50 I = 1,NCHAR
          IF(LINE(ICHA:ICHA).EQ.LOWER(I))
     &    LINE(ICHA:ICHA) = UPPER(I)
   50   CONTINUE
  100 CONTINUE
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqpsrt(limit,last,maxerr,ermax,elist,iord,nrmax)
!***begin prologue  dqpsrt
!***refer to  dqage,dqagie,dqagpe,dqawse
!***routines called  (none)
!***revision date  810101   (yymmdd)
!***keywords  sequential sorting
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  this routine maintains the descending ordering in the
!            list of the local error estimated resulting from the
!            interval subdivision process. at each call two error
!            estimates are inserted using the sequential search
!            method, top-down for the largest error estimate and
!            bottom-up for the smallest error estimate.
!***description
!
!           ordering routine
!           standard fortran subroutine
!           real*8 version
!
!           parameters (meaning at output)
!              limit  - integer
!                       maximum number of error estimates the list
!                       can contain
!
!              last   - integer
!                       number of error estimates currently in the list
!
!              maxerr - integer
!                       maxerr points to the nrmax-th largest error
!                       estimate currently in the list
!
!              ermax  - real*8
!                       nrmax-th largest error estimate
!                       ermax = elist(maxerr)
!
!              elist  - real*8
!                       vector of dimension last containing
!                       the error estimates
!
!              iord   - integer
!                       vector of dimension last, the first k elements
!                       of which contain pointers to the error
!                       estimates, such that
!                       elist(iord(1)),...,  elist(iord(k))
!                       form a decreasing sequence, with
!                       k = last if last <= (limit/2+2), and
!                       k = limit+1-last otherwise
!
!              nrmax  - integer
!                       maxerr = iord(nrmax)
!
!***end prologue  dqpsrt

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: limit, last
integer(kind=iwp), intent(inout) :: maxerr, iord(last), nrmax
real(kind=wp), intent(in) :: elist(last)
real(kind=wp), intent(out) :: ermax
real(kind=wp) :: errmax, errmin
integer(kind=iwp) :: i, ibeg, ido, isucc, j, jbnd, jupbn, k
logical(kind=iwp) :: jump

!***first executable statement  dqpsrt

! check whether the list contains more than
! two error estimates.

if (last <= 2) then
  iord(1) = 1
  iord(2) = 2
  maxerr = iord(nrmax)
  ermax = elist(maxerr)
  return
end if

! this part of the routine is only executed if, due to a
! difficult integrand, subdivision increased the error
! estimate. in the normal case the insert procedure should
! start after the nrmax-th largest error estimate.

errmax = elist(maxerr)
if (nrmax /= 1) then
  ido = nrmax-1
  do i=1,ido
    isucc = iord(nrmax-1)
    ! ***jump out of do-loop
    if (errmax <= elist(isucc)) exit
    iord(nrmax) = isucc
    nrmax = nrmax-1
  end do
end if

! compute the number of elements in the list to be maintained
! in descending order. this number depends on the number of
! subdivisions still allowed.

jupbn = last
if (last > (limit/2+2)) jupbn = limit+3-last
errmin = elist(last)

! insert errmax by traversing the list top-down,
! starting comparison from the element elist(iord(nrmax+1)).

jbnd = jupbn-1
ibeg = nrmax+1
jump = .false.
if (ibeg <= jbnd) then
  do i=ibeg,jbnd
    isucc = iord(i)
    ! ***jump out of do-loop
    if (errmax >= elist(isucc)) then
      jump = .true.
      exit
    end if
    iord(i-1) = isucc
  end do
end if
if (.not. jump) then
  iord(jbnd) = maxerr
  iord(jupbn) = last
else

  ! insert errmin by traversing the list bottom-up.

  iord(i-1) = maxerr
  k = jbnd
  do j=i,jbnd
    isucc = iord(k)
    ! ***jump out of do-loop
    if (errmin < elist(isucc)) then
      iord(k+1) = last
      exit
    end if
    iord(k+1) = isucc
    k = k-1
  end do
  iord(i) = last
end if

! set maxerr and ermax.

maxerr = iord(nrmax)
ermax = elist(maxerr)

return

end subroutine dqpsrt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,2015, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine PSOAO0(nSO,MemPrm,MemMax,iAnga, iCmpa,
     &                  iBas,  iBsInc, jBas,  jBsInc,
     &                  kBas,  kBsInc, lBas,  lBsInc,
     &                  iPrim, iPrInc, jPrim, jPrInc,
     &                  kPrim, kPrInc, lPrim, lPrInc,
     &                  ipMem1,ipMem2,
     &                  Mem1,  Mem2,  DoFock)
************************************************************************
*                                                                      *
*  Object: to partion the SO and AO block. It will go to some length   *
*          before it will start and break up the SO block. This will   *
*          reduce the total flop count. However, as we are breaking up *
*          the AO block this will affect the vectorization. Hence, at  *
*          some point it will actually be better to recompute the      *
*          primitives.                                                 *
*          Current stratergy:                                          *
*          1. Start reducing the length of the primitives in the order *
*             lPrim,jPrim.                                             *
*          2. Reduce the size of the SO block by reducing the number of*
*             basis functions in the order lBas, jBas.                 *
*          3. Terminate run telling job max and min of additional      *
*             memory needed to perform the calculation.                *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Modified for scratch to FckAcc                           *
*                                                                      *
*             Modified for unified Work2 and Work3 block. Febr. 2015   *
************************************************************************
      use lw_Info
      use Temporary_parameters, only: force_part_c, force_part_p
      use Integral_Parameters, only: iWROpt
      use RICD_Info, only: Do_RI, Cholesky
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "lCache.fh"
#include "pstat.fh"
      Integer iAnga(4), iCmpa(4)
      Logical QiBas, QjBas, QkBas, QlBas, QjPrim, QlPrim, DoFock, Fail
#include "SysDef.fh"
*
*     Statement function to compute canonical index
*
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      iCmp = iCmpa(1)
      jCmp = iCmpa(2)
      nab=iCmp*jCmp
      kCmp = iCmpa(3)
      lCmp = iCmpa(4)
      ncd=kCmp*lCmp
      iTotal = iTotal + 1
      mabMin=nabSz(Max(la,lb)-1)+1
      mabMax=nabSz(la+lb)
      ne=(mabMax-mabMin+1)
      mcdMin=nabSz(Max(lc,ld)-1)+1
      mcdMax=nabSz(lc+ld)
      nf=(mcdMax-mcdMin+1)
*     e0|f0 size
      mabcd=ne*nf
*     ab|cd size
      nabcd=nab*ncd
*
*     For test purposed we can force partitioning for both the
*     contracted and primitive block
*
      If (force_part_c) Then
         iBsInc = (iBas+1)/2
         jBsInc = (jBas+1)/2
         kBsInc = (kBas+1)/2
         lBsInc = (lBas+1)/2
      Else
         iBsInc = iBas
         jBsInc = jBas
         kBsInc = kBas
         lBsInc = lBas
      End If
      If (force_part_p) Then
         jPrInc = (jPrim+1)/2
         lPrInc = (lPrim+1)/2
      Else
         jPrInc = jPrim
         lPrInc = lPrim
      End If
      iPrInc = iPrim
      kPrInc = kPrim
*
      iFact = 1
      If (iWropt.eq.0 .and.
     &   .Not.(Cholesky.or.Do_RI)) iFact = 4 + 3
*
 999  Continue
*
*     We can partion the blocks on all contrcated indicies
*     and on the second and fourth primitive indicies.
*     We put priority in keeping an as large fraction of the contracted
*     block as much preserved to limit the recompution of primitive
*     integrals.
*
      QjPrim = .False.
      QlPrim = .True.
      QiBas  = .False.
      QjBas  = .False.
      QkBas  = .False.
      QlBas  = .False.
      Mem0 = MemMax
*
      ijPrInc=iPrInc*jPrInc
      klPrInc=kPrInc*lPrInc
      mijkl = iPrInc*jPrInc*kPrInc*lPrInc
      nijkl = iBsInc*jBsInc*kBsInc*lBsInc
*
*-----Work1
*     Memory for SO block. If petite list format is used there
*     will be no SO block.
*
      kSOInt = nSO*nijkl
      Mem1 = iFact*kSOInt
      If (Mem1.eq.0) Mem1 = 1
      If (nIrrep.eq.1) Mem1 = 1 + (iFact-1) * nabcd*nijkl
      If (Mem1+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem1+1-Mem0)
         QjPrim = .False.
         QlPrim = .False.
         QiBas  = .False.
         QjBas  = .False.
         QkBas  = .False.
         QlBas  = .True.
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Call WarningMessage(2,' Allocation failed for Work1')
            Write (6,*) Mem0,Mem1
            Write (6,*) iPrInc,iBsInc,kPrInc,kBsInc,
     &                  jPrInc,jBsInc,lPrInc,lBsInc
            Call Abend()
         End If
         Go To 999
      End If
      Mem0 = Mem0 - Mem1 - 1
*
*-----Work2
*     MemPr  : Scratch for Rys
*
*     Memory for the Rys-Gauss procedure. This includes memory for
*     all the intermediate arrays AND the {e0|f0} block.
*
      MemPr = MemPrm*mijkl
*
*     MemAux : Auxiliary memory for partial contraction.
*
*     If the primitive block is not full we need to accumulate primitive
*     contributions to the contracted block. This will require a
*     permanant pice of memory, during the computation of the primitive
*     sublocks, where the incomplete block of contracted integrals are
*     stored (Work4) - mabcd*nijkl.
*
      If (jPrInc.ne.jPrim.or.lPrInc.ne.lPrim) Then
         MemAux = Max(mabcd,nabcd)*nijkl
      Else
         MemAux = 0
      End If
*     Write (*,*) 'MemAux:',MemAux
*
*     MemCon : Scratch for the contraction step
*
*     We need memory to the largest of the {e0|f0} or (e0|f0) block.
*     Note that this correspond to that the A3 block in the second
*     halftransformation is set to zero. We also assume that the
*     integrals might be transformed to real spherical harmonic before
*     the contraction step. This only happens for mijkl>=nijl
*
*     The routine which does the contraction does this in two
*     half contraction steps with an intermediate which contains
*     a subset of the quater or three quarter transformed integrals.
*     Since we do not know the order of contraction at this time we will
*     have to compute for the worst case scenario.
*
*     Contraction of the two first indicies: iPrim->iBas & jPrim->jBas
*     while the third and fourth indicies are uncontrcated.
      nCache_ = (3*lCache)/4 - iPrim*iBas - jPrim*jBas
*     Note that we do not know here the order of the contraction, hence
*     we assume worst case scenario. The worst case is when lSize is
*     the smallest.
      lSize = iPrInc*jPrInc + Min(jPrInc*iBsInc,iPrInc*jBsInc)
*     Length of the compound index.
      nVec1 = kPrInc*lPrInc * Max(nabcd,mabcd)
*     Compute the subsection length of the compound index.
      IncVec = Min(Max(1,nCache_/lSize),nVec1)
*     Size of the initial integrals
      nA1a= Max(nabcd,mabcd)*mijkl
*     Size of the intemediate array
      nA2a= Max(iPrim,jPrim)*IncVec
*     Size of the half transformed integrals
      nA3a= iBsInc*jBsInc*nVec1
*     Write (*,*)
*     Write (*,*) 'IncVec,iPrim,jPrim:',IncVec,iPrim,jPrim
*     Write (*,*) 'nVec1,lSize=',nVec1,lSize
*     Write (*,*) 'nA1,nA2,nA3:',nA1a,nA2a,nA3a
*
*     Contraction of the two last indicies: kPrim->kBas & lPrim->lBas
*     while the first and second indicies are contrcated.
      nCache_ = (3*lCache)/4 - kPrim*kBas - lPrim*lBas
      lSize = kPrInc*lPrInc + Min(lPrInc*kBsInc,kPrInc*lBsInc)
      nVec2 = iBsInc*jBsInc * Max(nabcd,mabcd)
      IncVec = Min(Max(1,nCache_/lSize),nVec2)
      nA1b= nVec2*kPrInc*lPrInc
      nA2b= Max(kPrim,lPrim)*IncVec
      nA3b= kBsInc*lBsInc*nVec2
      If (MemAux.ne.0) nA3b=0
      MemCon=Max(nA1a,nA3b)+Max(nA2a,nA2b)+Max(nA3a,nA1b)
*     Write (*,*) 'IncVec,kPrim,lPrim:',IncVec,kPrim,lPrim
*     Write (*,*) 'nVec2,lSize=',nVec1,lSize
*     Write (*,*) 'nA1,nA2,nA3:',nA1b,nA2b,nA3b
*     Write (*,*) 'MemCon     :',MemCon
*
*     Contraction of the two last indicies: kPrim->kBas & lPrim->lBas
*     while the first and second indicies are uncontrcated.
      nCache_ = (3*lCache)/4 - kPrim*kBas - lPrim*lBas
      lSize = kPrInc*lPrInc + Min(lPrInc*kBsInc,kPrInc*lBsInc)
      nVec1 = iPrInc*jPrInc * Max(nabcd,mabcd)
      IncVec = Min(Max(1,nCache_/lSize),nVec1)
      nA1a= Max(nabcd,mabcd)*mijkl
      nA2a= IncVec*Max(kPrim,lPrim)
      nA3a= kBsInc*lBsInc*nVec1
*     Write (*,*) 'IncVec,kPrim,lPrim:',IncVec,kPrim,lPrim
*     Write (*,*) 'nVec1,lSize=',nVec1,lSize
*     Write (*,*) 'nA1,nA2,nA3:',nA1a,nA2a,nA3a
*
*     Contraction of the two first indicies: iPrim->iBas & jPrim->jBas
*     while the third and fourth indicies are contrcated.
      nCache_ = (3*lCache)/4 - iPrim*iBas - jPrim*jBas
      lSize = iPrInc*jPrInc + Min(jPrInc*iBsInc,iPrInc*jBsInc)
      nVec2 = kBsInc*lBsInc * Max(nabcd,mabcd)
      IncVec = Min(Max(1,nCache_/lSize),nVec2)
      nA1b= nVec2*iPrInc*jPrInc
      nA2b= IncVec*Max(iPrim,jPrim)
      nA3b= iBsInc*jBsInc*nVec2
      If (MemAux.ne.0) nA3b=0
      MemCon = Max(MemCon,Max(nA1a,nA3b)+Max(nA2a,nA2b)+Max(nA3a,nA1b))
*     Write (*,*) 'IncVec,iPrim,jPrim:',IncVec,iPrim,jPrim
*     Write (*,*) 'nVec2,lSize=',nVec1,lSize
*     Write (*,*) 'nA1,nA2,nA3:',nA1b,nA2b,nA3b
*     Write (*,*) 'MemCon     :',MemCon
*
*     MemSp1 : Scratch for the transformation from cartesian to
*              spherical harmonics. This is executed inside the
*              primitive block only if (1) the set of primitive
*              integrals are fewer than the contracted functions
*              and (2) there is no partitioning on the primitive
*              index.
*
      If (jPrInc.ne.jPrim.or.lPrInc.ne.lPrim) Then
         MemSp1= Max(mabcd+nab*nf,nabcd+nab*nf)*nijkl
      Else
         MemSp1= Max(mabcd+nab*nf,nabcd+nab*nf)*nijkl
      End If
*
*     MemFck : Scratch for FckAcc.
*
*     Memory to manupulate the 1-particle densities in FckAcc.
*
      If (DoFock) Then
         MemFck= 6*Max(iBsInc*lBsInc,iBsInc*kBsInc,jBsInc*lBsInc,
     &          jBsInc*kBsInc,iBsInc*jBsInc,kBsInc*lBsInc)
     &         + nijkl*nabcd
      Else
         MemFck=0
      End If
*
*     MemPck : Scratch for integral packing
*
*     Memory for integral packing.
*
      If (iWROpt.eq.0 .and. .Not.(Cholesky.or.Do_RI)) Then
         MemPck= 2 * nabcd*nijkl
      Else
         MemPck = 0
      End If
      Mem2 = Max((MemPr+MemAux),
     &           (MemCon+MemAux),
     &           (MemSp1+MemAux),
     &           MemFck,
     &           MemPck)
      If (Mem2+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem2+1-Mem0)
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Call WarningMessage(2,' Allocation failed for Work2')
            Write (6,*) Mem0
            Write (6,*) iPrInc,iBsInc,kPrInc,kBsInc,
     &                  jPrInc,jBsInc,lPrInc,lBsInc
            Call Abend()
         End If
         Go To 999
      End If
      Mem0 = Mem0 - Mem2 - 1
*
      ipMem2 = ipMem1 + Mem1
*
      MemSum=Mem1+Mem2
*
*     Auxiliary memory for integral packing
*
      If (iWropt.eq.0 .and. .Not.(Cholesky.or.Do_RI)) Then
         If (nIrrep.eq.1) Then
            lPack = nabcd*nijkl
            lwInt = ipMem1
         Else
            lPack = kSOInt
            lwInt = ipMem1 + lPack
         End If
         lwSyB = lwInt + 2*lPack
         lwSqN = lwSyB + 2*lPack
      Else
         lPack = 0
         lwInt  = 0
         lwSyB  = 0
         lwSqN  = 0
      End If
*
      r1 = r1 + DBLE(iBsInc)/DBLE(iBas)
      r2 = r2 + DBLE(jBsInc)/DBLE(jBas)
      r3 = r3 + DBLE(kBsInc)/DBLE(kBas)
      r4 = r4 + DBLE(lBsInc)/DBLE(lBas)
      q1 = q1 + DBLE(iPrInc)/DBLE(iPrim)
      q2 = q2 + DBLE(jPrInc)/DBLE(jPrim)
      q3 = q3 + DBLE(kPrInc)/DBLE(kPrim)
      q4 = q4 + DBLE(lPrInc)/DBLE(lPrim)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _GROMACS_

subroutine RunGromacs(nAtIn,Coord,Mltp,DoFirst,MltOrd,Forces,Grad,Energy)

use, intrinsic :: iso_c_binding, only: c_int, c_loc, c_ptr
use espf_global, only: MMI, MMIterMax, MxExtPotComp, QM, TPRDefName
use UnixInfo, only: SuperName
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Ten, Angstrom, auTokJmol, auTokJmolnm
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtIn, MltOrd
real(kind=wp), intent(in) :: Coord(3,nAtIn), Mltp(*)
logical(kind=iwp), intent(in) :: DoFirst, Forces
real(kind=wp), intent(out) :: Grad(3,nAtIn), Energy
integer(kind=iwp) :: iAtGMX, iAtIn, iAtOut, ic, iLast, iOk, j, LuExtPot, LuWr, nAtGMX, nAtOut
real(kind=wp) :: EnergyGMX, Energy2GMX, q
logical(kind=iwp) :: Found, isNotLast
character(len=256) :: LogFileName, Message, TPRFileName
character(len=12) :: ExtPotFormat
type(c_ptr) :: ipCR, ipGMS
integer(kind=iwp), allocatable :: AT(:)
real(kind=wp), allocatable :: CoordGMX(:,:), CoordMMO(:,:), Field2GMX(:,:), FieldGMX(:,:), Force2GMX(:,:), ForceGMX(:,:), &
                              GradMMO(:,:), Pot2GMX(:), PotGMX(:)
real(kind=wp), parameter :: AuToNm = Angstrom/Ten
integer(kind=iwp), external :: isFreeUnit
interface
  subroutine mmslave_done(gms) bind(C,NAME='mmslave_done_')
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr), value :: gms
  end subroutine mmslave_done
  function mmslave_init(cr,log_) bind(C,NAME='mmslave_init_')
    use, intrinsic :: iso_c_binding, only: c_char, c_ptr
    type(c_ptr) :: mmslave_init
    type(c_ptr), value :: cr
    character(kind=c_char) :: log_(*)
  end function mmslave_init
  function mmslave_read_tpr(tpr,gms) bind(C,NAME='mmslave_read_tpr_')
    use, intrinsic :: iso_c_binding, only: c_char, c_int, c_ptr
    integer(kind=c_int) :: mmslave_read_tpr
    character(kind=c_char) :: tpr(*)
    type(c_ptr), value :: gms
  end function mmslave_read_tpr
  function mmslave_set_q(gms,id,q) bind(C,NAME='mmslave_set_q_')
    use, intrinsic :: iso_c_binding, only: c_double, c_int, c_ptr
    integer(kind=c_int) :: mmslave_set_q
    type(c_ptr), value :: gms
    integer(kind=c_int), value :: id
    real(kind=c_double), value :: q
  end function mmslave_set_q
  function init_commrec() bind(C,NAME='init_commrec_')
    use, intrinsic :: iso_c_binding, only: c_ptr
    type(c_ptr) :: init_commrec
  end function init_commrec
end interface

LuExtPot = 1
LuWr = u6
Energy = Zero

write(ExtPotFormat,'(a4,i2,a6)') '(I4,',MxExtPotComp,'F13.8)'

! Get MMO coordinates and atom types from runfile
call Qpg_dArray('MMO Coords',Found,nAtOut)
nAtOut = nAtOut/3
call mma_allocate(CoordMMO,3,nAtOut)
if (Found) then
  call Get_dArray('MMO Coords',CoordMMO,3*nAtOut)
else
  Message = 'RunGromacs: MMO coordinates not found on runfile'
  call WarningMessage(2,Message)
  call Abend()
end if

call Qpg_iArray('Atom Types',Found,nAtGMX)
call mma_allocate(AT,nAtGMX)
if (Found) then
  call Get_iArray('Atom Types',AT,nAtGMX)
else
  Message = 'RunGromacs: Atom types not found on runfile'
  call WarningMessage(2,Message)
  call Abend()
end if

! Since this is the first time we use information from runfile, do a
! consistency check
if (nAtGMX /= nAtIn+nAtOut) then
  Message = 'RunGromacs: nAtGMX and nAtIn+nAtOut not equal'
  call WarningMessage(2,Message)
  call Abend()
end if

! Initialize Gromacs mmslave
ipCR = init_commrec()
call prgmtranslate('GMX.LOG',LogFileName,iLast)
LogFileName(iLast+1:iLast+1) = char(0)
ipGMS = mmslave_init(ipCR,LogFileName)

! Let Gromacs read tpr file
TPRFileName = TPRDefName
iLast = len_trim(TPRFileName)
TPRFileName(iLast+1:iLast+1) = char(0)
iOk = mmslave_read_tpr(TPRFileName,ipGMS)
if (iOk /= 1) then
  Message = 'RunGromacs: mmslave_read_tpr is not ok'
  call WarningMessage(2,Message)
  call Abend()
end if

! Perform microiterations, though only if (1) it is requested, (2) there
! are MMO atoms to optimize, (3) not last energy, (4) multipoles are
! available, and (5) no gradient calculation
if ((MMIterMax > 0) .and. (nAtOut > 0)) then
  isNotLast = SuperName(1:11) /= 'last_energy'
  if ((.not. Dofirst) .and. (.not. Forces) .and. isNotLast) call Opt_MMO(nAtIn,Coord,nAtOut,CoordMMO,nAtGMX,AT,ipGMS)
end if

! Trick: Set QM charges in Gromacs to zero (or, currently, to a very
! small number). This is needed to exclude their contribution to the
! external potential.
do iAtGMX=1,nAtGMX
  if (AT(iAtGMX) == QM) then
    iOk = mmslave_set_q(ipGMS,int(iAtGMX-1,kind=c_int),1.0e-10_wp)
    if (iOk /= 1) then
      Message = 'RunGromacs: mmslave_set_q is not ok'
      call WarningMessage(2,Message)
      call Abend()
    end if
  end if
end do

! Get energy, forces and external potential from Gromacs
call mma_allocate(CoordGMX,3,nAtGMX)
call mma_allocate(FieldGMX,3,nAtGMX)
call mma_allocate(ForceGMX,3,nAtGMX)
call mma_allocate(PotGMX,nAtGMX)
iAtIn = 1
iAtOut = 1
do iAtGMX=1,nAtGMX
  if ((AT(iAtGMX) == QM) .or. (AT(iAtGMX) == MMI)) then
    CoordGMX(:,iAtGMX) = Coord(:,iAtIn)
    iAtIn = iAtIn+1
  else
    CoordGMX(:,iAtGMX) = CoordMMO(:,iAtOut)
    iAtOut = iAtOut+1
  end if
end do
CoordGMX(:,:) = CoordGMX/AuToNm
FieldGMX(:,:) = Zero
ForceGMX(:,:) = Zero
PotGMX(:) = Zero
iOk = mmslave_calc_energy_wrapper(ipGMS,CoordGMX,ForceGMX,FieldGMX,PotGMX,EnergyGMX)
if (iOk /= 1) then
  Message = 'RunGromacs: mmslave_calc_energy is not ok'
  call WarningMessage(2,Message)
  call Abend()
end if

! Special case: forces on MM atoms
if (Forces) then
  if (DoFirst) then
    Message = 'RunGromacs: something is wrong in the code'
    call WarningMessage(2,Message)
    call Abend()
  end if
  call mma_allocate(Field2GMX,3,nAtGMX)
  call mma_allocate(Force2GMX,3,nAtGMX)
  call mma_allocate(Pot2GMX,nAtGMX)
  Field2GMX(:,:) = Zero
  Force2GMX(:,:) = Zero
  Pot2GMX(:) = Zero
  ic = 1
  do iAtGMX=1,nAtGMX
    if (AT(iAtGMX) == QM) then
      q = Mltp(ic)
      iOk = mmslave_set_q(ipGMS,int(iAtGMX-1,kind=c_int),q)
      if (iOk /= 1) then
        Message = 'RunGromacs: mmslave_set_q is not ok'
        call WarningMessage(2,Message)
        call Abend()
      end if
      ic = ic+MltOrd
    end if
  end do
  iOk = mmslave_calc_energy_wrapper(ipGMS,CoordGMX,Force2GMX,Field2GMX,Pot2GMX,Energy2GMX)
  if (iOk /= 1) then
    Message = 'RunGromacs: mmslave_calc_energy is not ok'
    call WarningMessage(2,Message)
    call Abend()
  end if
end if

! Store classical contributions to energy and gradient
Energy = EnergyGMX/auTokJmol
if (Forces) then
  call mma_allocate(GradMMO,3,nAtOut)
  iAtIn = 1
  iAtOut = 1
  do iAtGMX=1,nAtGMX
    if (AT(iAtGMX) == QM) then
      Grad(:,iAtIn) = ForceGMX(:,iAtGMX)
      iAtIn = iAtIn+1
    else if (AT(iAtGMX) == MMI) then
      Grad(:,iAtIn) = Force2GMX(:,iAtGMX)
      iAtIn = iAtIn+1
    else
      GradMMO(:,iAtOut) = Force2GMX(:,iAtGMX)
      iAtOut = iAtOut+1
    end if
  end do
  Grad(:,:) = Grad(:,:)/auTokJmolnm
  GradMMO(:,:) = GradMMO(:,:)/auTokJmolnm
  call Put_dArray('MMO Grad',GradMMO,3*nAtOut)
end if

! Write external potential to ESPF.EXTPOT file
LuExtPot = isFreeUnit(LuExtPot)
call molcas_open(LuExtPot,'ESPF.EXTPOT')
write(LuExtPot,'(I1)') 0
iAtIn = 1
do iAtGMX=1,nAtGMX
  if ((AT(iAtGMX) == QM) .or. (AT(iAtGMX) == MMI)) then
    write(LuExtPot,ExtPotFormat) iAtIn,PotGMX(iAtGMX)/auTokJmol,-FieldGMX(:,iAtGMX)/auTokJmolnm,(Zero,j=5,MxExtPotComp)
    iAtIn = iAtIn+1
  end if
end do
close(LuExtPot)

! Clean up
call mma_deallocate(CoordMMO)
call mma_deallocate(AT)
call mma_deallocate(CoordGMX)
call mma_deallocate(FieldGMX)
call mma_deallocate(ForceGMX)
call mma_deallocate(PotGMX)
if (Forces) then
  call mma_deallocate(Field2GMX)
  call mma_deallocate(Force2GMX)
  call mma_deallocate(Pot2GMX)
  call mma_deallocate(GradMMO)
end if
call mmslave_done(ipGMS)

return

contains

function mmslave_calc_energy_wrapper(gms,x,f,A,phi,energy)
  integer(kind=iwp) :: mmslave_calc_energy_wrapper
  type(c_ptr) :: gms
  real(kind=wp), target :: x(*), f(*), A(*), phi(*)
  real(kind=wp) :: energy
  interface
    function mmslave_calc_energy(gms,x,f,A,phi,energy) bind(C,NAME='mmslave_calc_energy_')
      use, intrinsic :: iso_c_binding, only: c_double, c_int, c_ptr
      integer(kind=c_int) :: mmslave_calc_energy
      type(c_ptr), value :: gms, x, f, A, phi
      real(kind=c_double) :: energy
    end function mmslave_calc_energy
  end interface
  mmslave_calc_energy_wrapper = mmslave_calc_energy(gms,c_loc(x(1)),c_loc(f(1)),c_loc(A(1)),c_loc(phi(1)),energy)
end function mmslave_calc_energy_wrapper

end subroutine RunGromacs

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(RunGromacs)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETPASS(DIAG,DIASH,ISYSH,IRED,CONV,NPOTSH)
C
C     Purpose: Check convergence and, if not converged, set up
C              integral pass.
C
#include "implicit.fh"
      DIMENSION DIAG(*), DIASH(*)
      INTEGER   ISYSH(*)
      LOGICAL   CONV
#include "cholesky.fh"

C     Initialize the potential number of shell pairs that can
C     contribute.
C     -------------------------------------------------------

      NPOTSH = 0

C     Find max. abs. diagonal in each symmetry and the global max.
C     ------------------------------------------------------------

      DGMAX = -1.0D15
      CALL CHO_MAXABSDIAG(DIAG,IRED,DGMAX)

C     If not converged, set next integral pass.
C     -----------------------------------------

      CONV = DGMAX .LT. THRCOM
      IF (.NOT. CONV) THEN
         CALL CHO_SETMAXSHL(DIAG,DIASH,ISYSH,IRED)
         DO ISYM = 1,NSYM
            DIAMIN(ISYM) = MAX(DIAMAX(ISYM)*SPAN,THRCOM)
         END DO
         DO ISHLAB = 1,NNSHL
            IF (DIASH(ISHLAB) .GT. THRCOM) THEN
               NPOTSH = NPOTSH + 1
            ELSE
               DIASH(ISHLAB) = 0.0D0
            END IF
         END DO
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RPA_Freezer()
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Figure out symmetry distribution of frozen occupied orbitals.
C
      Implicit None
#include "rpa_config.fh"
#include "rpa_data.fh"
#include "WrkSpc.fh"

      Integer  RPA_iUHF
      External RPA_iUHF

      Logical Freeze
      Logical Prnt

      Integer iUHF
      Integer iSym
      Integer iSpin
      Integer ip_Fro, l_Fro

      ! set restricted(1)/unrestricted(2)
      iUHF=RPA_iUHF()

      ! freeze orbitals (if requested)
      iSpin=1
      Freeze=nFreeze(iSpin).gt.0
      Do While (.not.Freeze .and. iSpin.lt.iUHF)
         iSpin=iSpin+1
         Freeze=Freeze.or.nFreeze(iSpin).gt.0
      End Do
      If (Freeze) Then
         Prnt=iPrint.ge.0
         l_Fro=nSym
         Call GetMem('OccFrz','Allo','Inte',ip_Fro,l_Fro)
         Do iSpin=1,iUHF
            If (nFreeze(iSpin).gt.0) Then
               Call RPA_Frz(nFreeze(iSpin),Prnt,nSym,
     *                      Work(ip_OccEn(iSpin)),
     *                      nFro(1,iSpin),nOcc(1,iSpin),
     *                      iWork(ip_Fro))
               Do iSym=1,nSym
                  nFro(iSym,iSpin)=nFro(iSym,iSpin)+iWork(ip_Fro-1+iSym)
               End Do
            End If
         End Do
         Call GetMem('OccFrz','Free','Inte',ip_Fro,l_Fro)
      End If

      ! correct number of active occupied orbitals
      Do iSpin=1,iUHF
         Do iSym=1,nSym
            nOcc(iSym,iSpin)=nOcc(iSym,iSpin)-nFro(iSym,iSpin)
         End Do
      End Do

      End
************************************************************************
      Subroutine RPA_Frz(nFre,Prnt,nSym,EOcc,nFro,nOcc,nFro1)
      Implicit None
      Integer nFre
      Logical Prnt
      Integer nSym
      Real*8  EOcc(*)
      Integer nFro(nSym)
      Integer nOcc(nSym)
      Integer nFro1(nSym)
#include "WrkSpc.fh"

      Character*7 SecNam
      Parameter (SecNam='RPA_Frz')

      Integer  Cho_iRange
      External Cho_iRange

      Integer ip_Point, l_Point
      Integer ip_E, l_E
      Integer ip_Pivot, l_Pivot
      Integer ip_iOcc, l_iOcc
      Integer iCount
      Integer NumFre
      Integer iFre
      Integer i
      Integer iSym
      Integer ip1

      Real*8 xMin

      Integer j
      Integer iOcc
      iOcc(j)=iWork(ip_iOcc-1+j)

      If (nSym.lt.1 .or. nSym.gt.8) Then
         Write(6,'(A,I6)') 'nSym=',nSym
         Call RPA_Warn(3,SecNam//': illegal nSym')
      Else If (nSym .eq. 1) Then
         nFro1(1)=max(nFre,0)
         Return
      Else
         Call iZero(nFro1,nSym)
      End If
      If (nFre.lt.1) Return

      l_Point=nFre
      l_iOcc=nSym
      l_E=nOcc(1)
      Do iSym=2,nSym
         l_E=l_E+nOcc(iSym)
      End Do
      l_Pivot=l_E
      If (nFre.gt.l_E) Then
         Call RPA_Warn(4,SecNam//': too many orbitals to freeze')
      End If
      Call GetMem('ScrPnt','Allo','Inte',ip_Point,l_Point)
      Call GetMem('iOcc','Allo','Inte',ip_iOcc,l_iOcc)
      Call GetMem('ScrOccE','Allo','Real',ip_E,l_E)
      Call GetMem('Pivot','Allo','Inte',ip_Pivot,l_Pivot)

      iCount=0
      ip1=ip_iOcc-1
      Do iSym=1,nSym
         iWork(ip1+iSym)=iCount
         iCount=iCount+nOcc(iSym)
      End Do

      iCount=1
      Do iSym=1,nSym
         Call dCopy_(nOcc(iSym),EOcc(iCount+nFro(iSym)),1,
     *                         Work(ip_E+iOcc(iSym)),1)
         iCount=iCount+nFro(iSym)+nOcc(iSym)
      End Do

      xMin=-1.0d15
      NumFre=nFre
      Call dScal_(l_E,-1.0d0,Work(ip_E),1)
      Call CD_DiaMax(Work(ip_E),l_E,iWork(ip_Pivot),iWork(ip_Point),
     *               NumFre,xMin)
      If (NumFre.ne.nFre) Then
         Write(6,'(2(A,I12))') 'NumFre=',NumFre,'  nFre=',nFre
         Call RPA_Warn(3,SecNam//': NumFre != nFre')
      End If

      Do iFre=1,nFre
         iSym=Cho_iRange(iWork(ip_Point-1+iFre),iWork(ip_iOcc),nSym,
     *                   .false.)
         nFro1(iSym)=nFro1(iSym)+1
      End Do

      If (Prnt) Then
         Write(6,'(/,3X,A,A,A)') 'Output from ',SecNam,':'
         Write(6,'(A,I5,A)')
     &   'The',nFre,' lowest occupied orbitals have been frozen.'
         Write(6,'(A)') 'List of frozen occupied orbitals:'
         Do iFre=1,nFre
            iCount=iWork(ip_Point-1+iFre)
            iSym=Cho_iRange(iCount,iWork(ip_iOcc),nSym,.false.)
            i=iCount-iOcc(iSym)
            Write(6,'(1X,A,I5,A,I1,A,F15.8)')
     &      'Occupied orbital',i,' of symmetry ',iSym,
     &      ' and energy ',-Work(ip_E-1+iCount)
         End Do
         Call xFlush(6)
      End If

      Call GetMem('Pivot','Free','Inte',ip_Pivot,l_Pivot)
      Call GetMem('OccE','Free','Real',ip_E,l_E)
      Call GetMem('iOcc','Free','Inte',ip_iOcc,l_iOcc)
      Call GetMem('Point','Free','Inte',ip_Point,l_Point)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fack(wrk,wrksize,nind,newtyp,a,ssa,b,rc)
! nind   - # of indices in matrices A,B (Input)
! newtyp - typ of final matrix B (Input) (i.e. b%d(0,6))
! a      - map type corresponding to A (Input)
! ssa    - overall symmetry state of matrix A (Input)
! b      - map type corresponding to B (Output)
! rc     - return (error) code (Output)
!
! this routine realizes following packings :
!
! Operation                               Nind    TypA    TypB
!
! B(pq)     = A(p,q)     - A(q,p)          2       0       1
! B(pq,r)   = A(p,q,r)   - A(q,p,r)        3       0       1
! B(p,qr)   = A(p,q,r)   - A(p,r,q)        3       0       2
! B(pq,r,s) = A(p,q,r,s) - A(q,p,r,s)      4       0       1
! B(p,q,rs) = A(p,q,r,s) - A(q,p,s,r)      4       0       3
! B(pq,rs)  = NCI                          4       0       4
! B(pq,rs)  = A(pq,r,s)  - A(pq,s,r)       4       1       4
! B(pq,rs)  = A(p,q,rs)  - A(q,p,rs)       4       3       4

use ccsd_global, only: dimm, Map_Type
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, nind, newtyp, ssa
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: a
type(Map_Type), intent(inout) :: b
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: iam, iap, ib, nhelp1, nhelp2, nhelp3, nhelp4, nhelp5, nhelp6, nhelp7, nhelp8, nhelp9, post, rc1, sb1, sb2, &
                     sb3, sb4

rc = 0

! get b

call grc0(nind,newtyp,a%d(0,1),a%d(0,2),a%d(0,3),a%d(0,4),ssa,post,b)

if (nind < 2) then

  ! *********  less than 2 ind ***

  ! RC=1 less than 2 indices
  rc = 1
  return

else if (nind == 2) then

  ! *********  2 indices *********

  !2.1 A(p,q) -> B(pq)

  if (a%d(0,6) /= 0) then
    ! RC=2 bad type for: nind=2
    rc = 2
    return
  end if

  do ib=1,b%d(0,5)

    sb1 = b%d(ib,3)
    sb2 = b%d(ib,4)
    if (b%d(ib,2) == 0) cycle

    if (sb1 == sb2) then
      ! sym b1 = sym b2

      ! def ia+,-
      iap = a%i(sb1,1,1)

      ! pos B,A+,A-
      nhelp1 = b%d(ib,1)
      nhelp2 = a%d(iap,1)

      ! dimp-s
      nhelp4 = dimm(b%d(0,1),sb1)

      ! def size
      nhelp9 = nhelp4*(nhelp4-1)/2

      call pack210(wrk(nhelp2),wrk(nhelp1),nhelp9,nhelp4,rc1)

    else
      ! sym b1 > sym b2

      ! def ia+,-
      iap = a%i(sb1,1,1)
      iam = a%i(sb2,1,1)

      ! pos B,A+,A-
      nhelp1 = b%d(ib,1)
      nhelp2 = a%d(iap,1)
      nhelp3 = a%d(iam,1)

      ! dimp-s
      nhelp4 = dimm(b%d(0,1),sb1)
      nhelp5 = dimm(b%d(0,2),sb2)

      call pack211(wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,rc1)

    end if

  end do

else if (nind == 3) then

  ! *********  3 indices *********

  if (a%d(0,6) /= 0) then
    ! RC=3 bad type for: nind=3
    rc = 3
    return
  end if

  if (newtyp == 1) then

    !3.1 A(p,q,r) -> B(pq,r)

    do ib=1,b%d(0,5)

      sb1 = b%d(ib,3)
      sb2 = b%d(ib,4)
      sb3 = b%d(ib,5)
      if (b%d(ib,2) == 0) cycle

      if (sb1 == sb2) then
        ! sym b1 = sym b2

        ! def ia+,-
        iap = a%i(sb1,sb2,1)

        ! pos B,A+,A-
        nhelp1 = b%d(ib,1)
        nhelp2 = a%d(iap,1)

        ! dimp-s
        nhelp4 = dimm(b%d(0,1),sb1)
        nhelp6 = dimm(b%d(0,3),sb3)

        ! def size
        nhelp9 = nhelp4*(nhelp4-1)/2

        call pack310(wrk(nhelp2),wrk(nhelp1),nhelp9,nhelp6,nhelp4,rc1)

      else
        ! sym b1 > sym b2

        ! def ia+,-
        iap = a%i(sb1,sb2,1)
        iam = a%i(sb2,sb1,1)

        ! pos B,A+,A-
        nhelp1 = b%d(ib,1)
        nhelp2 = a%d(iap,1)
        nhelp3 = a%d(iam,1)

        ! dimp-s
        nhelp4 = dimm(b%d(0,1),sb1)
        nhelp5 = dimm(b%d(0,2),sb2)
        nhelp6 = dimm(b%d(0,3),sb3)

        call pack311(wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,nhelp6,rc1)

      end if

    end do

  else if (newtyp == 2) then

    !3.2 A(p,q,r) -> B(p,qr)

    do ib=1,b%d(0,5)

      sb1 = b%d(ib,3)
      sb2 = b%d(ib,4)
      sb3 = b%d(ib,5)
      if (b%d(ib,2) == 0) cycle

      if (sb2 == sb3) then
        ! sym b2 = sym b3

        ! def ia+,-
        iap = a%i(sb1,sb2,1)

        ! pos B,A+,A-
        nhelp1 = b%d(ib,1)
        nhelp2 = a%d(iap,1)

        ! dimp-s
        nhelp4 = dimm(b%d(0,1),sb1)
        nhelp5 = dimm(b%d(0,2),sb2)

        ! def size
        nhelp9 = nhelp5*(nhelp5-1)/2

        call pack320(wrk(nhelp2),wrk(nhelp1),nhelp4,nhelp9,nhelp5,rc1)

      else
        ! sym b2 > sym b3

        ! def ia+,-
        iap = a%i(sb1,sb2,1)
        iam = a%i(sb1,sb3,1)

        ! pos B,A+,A-
        nhelp1 = b%d(ib,1)
        nhelp2 = a%d(iap,1)
        nhelp3 = a%d(iam,1)

        ! dimp-s
        nhelp4 = dimm(b%d(0,1),sb1)
        nhelp5 = dimm(b%d(0,2),sb2)
        nhelp6 = dimm(b%d(0,3),sb3)

        call pack321(wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,nhelp6,rc1)

      end if

    end do

  else
    ! RC=4 : bad newtyp for: nind=3
    rc = 4
    return
  end if

else if (nind == 4) then

  ! *********  4 indices *********

  if (a%d(0,6) == 0) then

    !* case A(p,q,r,s) => newtyp can be 1,3,4

    if (newtyp == 1) then

      !4.1 A(p,q,r,s) -> B(pq,r,s)

      do ib=1,b%d(0,5)

        sb1 = b%d(ib,3)
        sb2 = b%d(ib,4)
        sb3 = b%d(ib,5)
        sb4 = b%d(ib,6)
        if (b%d(ib,2) == 0) cycle

        if (sb1 == sb2) then
          ! sym b1 = sym b2

          ! def ia+,-
          iap = a%i(sb1,sb2,sb3)

          ! pos B,A+,A-
          nhelp1 = b%d(ib,1)
          nhelp2 = a%d(iap,1)

          ! dimp-s
          nhelp4 = dimm(b%d(0,1),sb1)
          nhelp6 = dimm(b%d(0,3),sb3)
          nhelp7 = dimm(b%d(0,4),sb4)

          ! def size
          nhelp8 = nhelp4*(nhelp4-1)/2
          nhelp9 = nhelp6*nhelp7

          call pack310(wrk(nhelp2),wrk(nhelp1),nhelp8,nhelp9,nhelp4,rc1)

        else
          ! sym b1 > sym b2

          ! def ia+,-
          iap = a%i(sb1,sb2,sb3)
          iam = a%i(sb2,sb1,sb3)

          ! pos B,A+,A-
          nhelp1 = b%d(ib,1)
          nhelp2 = a%d(iap,1)
          nhelp3 = a%d(iam,1)

          ! dimp-s
          nhelp4 = dimm(b%d(0,1),sb1)
          nhelp5 = dimm(b%d(0,2),sb2)
          nhelp6 = dimm(b%d(0,3),sb3)
          nhelp7 = dimm(b%d(0,4),sb4)

          ! def size
          nhelp9 = nhelp6*nhelp7

          call pack311(wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,nhelp9,rc1)

        end if

      end do

    else if (newtyp == 3) then

      !4.2 A(p,q,r,s) -> B(p,q,rs)

      do ib=1,b%d(0,5)

        sb1 = b%d(ib,3)
        sb2 = b%d(ib,4)
        sb3 = b%d(ib,5)
        sb4 = b%d(ib,6)
        if (b%d(ib,2) == 0) cycle

        if (sb3 == sb4) then
          ! sym b3 = sym b4

          ! def ia+,-
          iap = a%i(sb1,sb2,sb3)

          ! pos B,A+,A-
          nhelp1 = b%d(ib,1)
          nhelp2 = a%d(iap,1)

          ! dimp-s
          nhelp4 = dimm(b%d(0,1),sb1)
          nhelp5 = dimm(b%d(0,2),sb2)
          nhelp6 = dimm(b%d(0,3),sb3)

          ! def size
          nhelp8 = nhelp6*(nhelp6-1)/2
          nhelp9 = nhelp4*nhelp5

          call pack320(wrk(nhelp2),wrk(nhelp1),nhelp9,nhelp8,nhelp6,rc1)

        else
          ! sym b3 > sym b4

          ! def ia+,-
          iap = a%i(sb1,sb2,sb3)
          iam = a%i(sb1,sb2,sb4)

          ! pos B,A+,A-
          nhelp1 = b%d(ib,1)
          nhelp2 = a%d(iap,1)
          nhelp3 = a%d(iam,1)

          ! dimp-s
          nhelp4 = dimm(b%d(0,1),sb1)
          nhelp5 = dimm(b%d(0,2),sb2)
          nhelp6 = dimm(b%d(0,3),sb3)
          nhelp7 = dimm(b%d(0,4),sb4)

          ! def size
          nhelp9 = nhelp4*nhelp5

          call pack321(wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp9,nhelp6,nhelp7,rc1)

        end if

      end do

    else if (newtyp == 4) then

      !4.3 A(p,q,r,s) -> B(pq,rs)

      ! RC=5 : Not Currently Implemented : nind=4, oldtyp=0, newtyp=4
      rc = 5
      return

    else
      ! RC=6 : incompatible newtyp for: nind=4, oldtyp=0
      rc = 6
      return
    end if

  else if (a%d(0,6) == 1) then

    !* case A(pq,r,s) => newtyp can be 4

    if (newtyp == 4) then

      !4.4 A(pq,r,s) -> B(pq,rs)

      do ib=1,b%d(0,5)

        sb1 = b%d(ib,3)
        sb2 = b%d(ib,4)
        sb3 = b%d(ib,5)
        sb4 = b%d(ib,6)
        if (b%d(ib,2) == 0) cycle

        if (sb3 == sb4) then
          ! sym b3 = sym b4

          ! def ia+,-
          iap = a%i(sb1,sb2,sb3)

          ! pos B,A+,A-
          nhelp1 = b%d(ib,1)
          nhelp2 = a%d(iap,1)

          ! dimp-s
          nhelp4 = dimm(b%d(0,1),sb1)
          nhelp5 = dimm(b%d(0,2),sb2)
          nhelp6 = dimm(b%d(0,3),sb3)

          ! def size
          nhelp8 = nhelp6*(nhelp6-1)/2
          if (sb1 == sb2) then
            nhelp9 = nhelp4*(nhelp4-1)/2
          else
            nhelp9 = nhelp4*nhelp5
          end if

          call pack320(wrk(nhelp2),wrk(nhelp1),nhelp9,nhelp8,nhelp6,rc1)

        else
          ! sym b3 > sym b4

          ! def ia+,-
          iap = a%i(sb1,sb2,sb3)
          iam = a%i(sb1,sb2,sb4)

          ! pos B,A+,A-
          nhelp1 = b%d(ib,1)
          nhelp2 = a%d(iap,1)
          nhelp3 = a%d(iam,1)

          ! dimp-s
          nhelp4 = dimm(b%d(0,1),sb1)
          nhelp5 = dimm(b%d(0,2),sb2)
          nhelp6 = dimm(b%d(0,3),sb3)
          nhelp7 = dimm(b%d(0,4),sb4)

          ! def size
          if (sb1 == sb2) then
            nhelp9 = nhelp4*(nhelp4-1)/2
          else
            nhelp9 = nhelp4*nhelp5
          end if

          call pack321(wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp9,nhelp6,nhelp7,rc1)

        end if

      end do

    else
      ! RC=7 : incompatible newtyp for: nind=4, oldtyp=1
      rc = 7
      return
    end if

  else if (a%d(0,6) == 3) then

    !* case A(p,q,rs) => newtyp can be 4

    if (newtyp == 4) then

      !4.5 A(p,q,rs) -> B(pq,rs)

      do ib=1,b%d(0,5)

        sb1 = b%d(ib,3)
        sb2 = b%d(ib,4)
        sb3 = b%d(ib,5)
        sb4 = b%d(ib,6)
        if (b%d(ib,2) == 0) cycle

        if (sb1 == sb2) then
          ! sym b1 = sym b2

          ! def ia+,-
          iap = a%i(sb1,sb2,sb3)

          ! pos B,A+,A-
          nhelp1 = b%d(ib,1)
          nhelp2 = a%d(iap,1)

          ! dimp-s
          nhelp4 = dimm(b%d(0,1),sb1)
          nhelp6 = dimm(b%d(0,3),sb3)
          nhelp7 = dimm(b%d(0,4),sb4)

          ! def size
          nhelp8 = nhelp4*(nhelp4-1)/2
          if (sb3 == sb4) then
            nhelp9 = nhelp6*(nhelp6-1)/2
          else
            nhelp9 = nhelp6*nhelp7
          end if

          call pack310(wrk(nhelp2),wrk(nhelp1),nhelp8,nhelp9,nhelp4,rc1)

        else
          ! sym b1 > sym b2

          ! def ia+,-
          iap = a%i(sb1,sb2,sb3)
          iam = a%i(sb2,sb1,sb3)

          ! pos B,A+,A-
          nhelp1 = b%d(ib,1)
          nhelp2 = a%d(iap,1)
          nhelp3 = a%d(iam,1)

          ! dimp-s
          nhelp4 = dimm(b%d(0,1),sb1)
          nhelp5 = dimm(b%d(0,2),sb2)
          nhelp6 = dimm(b%d(0,3),sb3)
          nhelp7 = dimm(b%d(0,4),sb4)

          ! def size
          if (sb3 == sb4) then
            nhelp9 = nhelp6*(nhelp6-1)/2
          else
            nhelp9 = nhelp6*nhelp7
          end if

          call pack311(wrk(nhelp2),wrk(nhelp3),wrk(nhelp1),nhelp4,nhelp5,nhelp9,rc1)

        end if

      end do

    else
      ! RC=8 : incompatible newtyp for: nind=4, oldtyp=3
      rc = 8
      return
    end if

  else
    ! RC=9 : incompatible typold for: nind=4
    rc = 9
    return
  end if

else

  ! *********  more than 4 ind ***

  ! RC=10: more than 4 indices
  rc = 10
  return
end if

return

end subroutine fack

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
*-- Read all MO-transformed integrals and construct zeroth Fock-matrix.
*
      Subroutine ScfH0(nBas)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "qm1.fh"
#include "numbers.fh"
#include "tratoc.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension nBasM(MxSym),nOrbM(MxSym),nDelM(MxSym),nFroM(MxSym)
      Dimension nBas(MxSym)
      Dimension iToc(64)
      Parameter (lenin8=6+8)
      Parameter (maxbfn=10000)
      Character NameM*(lenin8*maxbfn),firstind*10

*
*-- Wilkommen.
*
      Write(6,*)
      Write(6,*)
      Write(6,*)'Reading MO-transformed integrals. Zero:th hamiltonian '
     &//'constructed.'

*
*-- Numbers and files.
*
      nSize=iOrb(1)*(iOrb(1)+1)/2
      Call GetMem('FockM','Allo','Real',iPointF,nSize)
      Call GetMem('SUPER','Allo','Real',iSupM,nSize**2)
      iLu1=56
      iLu2=58
      Call DaName(iLu1,'TRAONE')
      Call DaName(iLu2,'TRAINT')
      iDisk=0
*--- This is special utility to read header of TRAONE.
      Call Wr_Motra_Info(iLu1,2,iDisk,iToc,64,Ecor,nSymM,nBasM,nOrbM
     &,nFroM,nDelM,MxSym,NameM,lenin8*maxbfn) !Last argument depends on
                                              !mxorb in Molcas.fh.
      nOrbMFirst=nOrbM(1)

*
*-- One checks.
*
      If(nBasM(1).ne.nBas(1)) then
        Write(6,*)
        Write(6,*)'  ERROR! Conflict between one-electron file and MO-t'
     &//'ransformed one-electron file.'
        Write(6,*)'         nBas=',nBas(1),' MO-nBas=',nBasM(1)
        Call Quit(_RC_GENERAL_ERROR_)
      Endif

*
*-- Read one-electron matrix elements.
*
      iDisk=iToc(2)
      Call dDaFile(iLu1,2,Work(iPointF),nSize,iDisk)
      call dcopy_(nSize,Work(iPointF),iONE,HHmat,iONE)
      Call GetMem('FockM','Free','Real',iPointF,nSize)
      Call DaClos(iLu1)

*
*-- Add external perturbation if requested.
*
      If(AddExt) then
        Write(6,*)'    -- Adding external perturbation.'
        nBTri=nBas(1)*(nBas(1)+1)/2
        Lu_One=49
        Lu_One=IsFreeUnit(Lu_One)
        Call OpnOne(irc,0,'ONEINT',Lu_One)
        Call GetMem('AOExt','Allo','Real',ipAOx,nBTri+4)
        Call GetMem('TEMP','Allo','Real',iTEMP,nBas(1)*iOrb(1))
        Call GetMem('Final','Allo','Real',iFine,iOrb(1)**2)
        Call GetMem('Squared','Allo','Real',iSqAO,nBas(1)**2)
        Call GetMem('MOExt','Allo','Real',ipMOx,nSize)
        Do 9901, iExt=1,nExtAddOns
          irc=-1
          iopt=0
          iSmLbl=0
          Call RdOne(irc,iopt,ExtLabel(iExt),iCompExt(iExt),Work(ipAOx)
     &              ,iSmLbl)
          Call DScal_(nBTri,ScalExt(iExt),Work(ipAOx),iONE)
          If(irc.ne.0) then
            Write(6,*)
            Write(6,*)'ERROR when reading ',ExtLabel(iExt),'.'
            Write(6,*)'Have Seward computed this integral?'
            Call Quit(_RC_IO_ERROR_READ_)
          Endif
          Call Square(Work(ipAOx),Work(iSqAO),iONE,nBas(1),nBas(1))
          Call Dgemm_('T','N',iOrb(1),nBas(1),nBas(1),ONE,Work(iV1)
     &              ,nBas(1),Work(iSqAO),nBas(1),ZERO,Work(iTEMP)
     &              ,iOrb(1))
          Call Dgemm_('N','N',iOrb(1),iOrb(1),nBas(1),ONE,Work(iTEMP)
     &              ,iOrb(1),Work(iV1),nBas(1),ZERO,Work(iFine),iOrb(1))
          Call SqToTri_Q(Work(iFine),Work(ipMOx),iOrb(1))
          Call DaxPy_(nSize,ONE,Work(ipMOx),iONE,HHmat,iONE)
9901    Continue
        Call GetMem('AOExt','Free','Real',ipAOx,nBTri+4)
        Call GetMem('TEMP','Free','Real',iTEMP,nBas(1)*iOrb(1))
        Call GetMem('Final','Free','Real',iFine,iOrb(1)**2)
        Call GetMem('Squared','Free','Real',iSqAO,nBas(1)**2)
        Call GetMem('MOExt','Free','Real',ipMOx,nSize)
        Call ClsOne(irc,Lu_One)
      Endif

*
*-- Now to the two-electron matrix elements.
*
      iDisk=0
      Call iDaFile(iLu2,2,iTraToc,nTraToc,iDisk)
      iDisk=iTraToc(1)
      iSup=0
*--- Ooohhhh, lets get crude! Read ALL (yes, you read right) integrals
*    and then order them.
      nBuf1=nOrbM(1)*(nOrbM(1)+1)/2
      nBuf2=nBuf1*(nBuf1+1)/2
*
*--- Lets check if this construct is possible. If not advise user what
*     to do.
*
      Call GetMem('MAX','Max','Real',iDum,nMAX)
      If(nMAX.lt.(nBuf2+nBuf1**2)) then
        Write(6,*)
        Write(6,*)'  Too many MO-transformed two-electron integrals'
     &          //' from Motra. Do you need all?'
        Write(6,*)'  If not, then use the DELEte keyword in Motra'
     &          //' to remove the superfluous ones.'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif
*
*--- Proceed!
*
      Call GetMem('Buffer','Allo','Real',iBuff,nBuf2)
      Call GetMem('Temporary','Allo','Real',iTEMP,nBuf1**2)
      Call dDaFile(iLu2,2,Work(iBuff),nBuf2,iDisk)
      Do 311, i=1,nBuf1
        Do 312, j=i,nBuf1
          iSup=iSup+1
          If(i.le.nSize.and.j.le.nSize) then
            Work(iTEMP+(i-1)*nBuf1+j-1)=Work(iBuff+iSup-1)
            Work(iTEMP+(j-1)*nBuf1+i-1)=Work(iBuff+iSup-1)
          Endif
312     Continue
311   Continue

*
*   and sees to that right numbers get in the right place.
*
      Do 321, i=1,iOrb(1)
        Do 322, j=1,i
          Do 323, k=1,i
            llmax=k
            If(i.eq.k) llmax=j
            Do 324, l=1,llmax
              ij=ipair_qmstat(i,j)
              ik=ipair_qmstat(i,k)
              il=ipair_qmstat(i,l)
              jk=ipair_qmstat(j,k)
              jl=ipair_qmstat(j,l)
              kl=ipair_qmstat(k,l)
            Work(iSupM+nSize*(ij-1)+kl-1)=Work(iTEMP+(ij-1)*nBuf1+kl-1)
     &-(Work(iTEMP+(ik-1)*nBuf1+jl-1)+Work(iTEMP+(il-1)*nBuf1+jk-1))/4
            Work(iSupM+nSize*(kl-1)+ij-1)=Work(iSupM+nSize*(ij-1)+kl-1)
            Work(iSupM+nSize*(ik-1)+jl-1)=Work(iTEMP+(ik-1)*nBuf1+jl-1)
     &-(Work(iTEMP+(ij-1)*nBuf1+kl-1)+Work(iTEMP+(il-1)*nBuf1+jk-1))/4
            Work(iSupM+nSize*(jl-1)+ik-1)=Work(iSupM+nSize*(ik-1)+jl-1)
            Work(iSupM+nSize*(il-1)+jk-1)=Work(iTEMP+(il-1)*nBuf1+jk-1)
     &-(Work(iTEMP+(ik-1)*nBuf1+jl-1)+Work(iTEMP+(ij-1)*nBuf1+kl-1))/4
            Work(iSupM+nSize*(jk-1)+il-1)=Work(iSupM+nSize*(il-1)+jk-1)
324         Continue
323       Continue
322     Continue
321   Continue
      Call GetMem('Buffer','Free','Real',iBuff,nBuf2)
      Call GetMem('Temporary','Free','Real',iTEMP,nBuf1**2)
      Call DaClos(iLu2)

*
*-- Serious amount of printing!
*
      If(iPrint.ge.35) then
        Write(6,*)
        Write(6,*)'The Super Matrix in all its divine g(l)ory:'
        kaunter=0
        Do 331, i=1,iOrb(1)
          Do 332, j=1,i
            Write(firstind,'(I3,A,I3)')i,',',j
            Call TriPrt(firstind,' ',Work(iSupM+nSize*kaunter),iOrb(1))
            kaunter=kaunter+1
332       Continue
331     Continue
        Write(6,*)'Super Matrix End.'
      Endif
      Write(6,*)'...Done!'

*
*-- The end.
*
      Return
      End


*
*-- Little bastard.
*
      Integer Function iPair_qmstat(a,b)
      Implicit Integer (a-z)
      iPair_qmstat=(Max(a,b)*(Max(a,b)-1))/2+Min(a,b)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 22, 2021, created this file.               *
! ****************************************************************
subroutine PDFTMemDeAlloc()

use nq_pdft, only: d2RdRho2, d2RdRhodPi, d2ZdR2, dEdPi, dEdPiMO, dEdPix, dEdPiy, dEdPiz, dEdRho, dEdRhox, dEdRhoy, dEdRhoz, &
                   dF_dRhoamb, dF_dRhoapb, dF_dRhoxamb, dF_dRhoxapb, dF_dRhoyamb, dF_dRhoyapb, dF_dRhozamb, dF_dRhozapb, dRdPi, &
                   dRdRho, dRhodX, dRhodY, dRhodZ, dZdR, dZdRho, GdEdPiMO, GradPidFdRho, GradRdFdRho, GradRhodFdRho, MOas, MOax, &
                   MOay, MOaz, OneMz, OnePz, Pass1, Pass2, Pass3, RatioA, RhoAB, ZetaA
use KSDFT_Info, only: do_pdftpot
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(RatioA)
call mma_deallocate(OnePz)
call mma_deallocate(OneMz)
call mma_deallocate(RhoAB)
call mma_deallocate(ZetaA)
call mma_deallocate(dZdR)
call mma_deallocate(Pass1)
call mma_deallocate(Pass2)

! for ft-functional
call mma_deallocate(Pass3)

if (do_pdftPot) then
  call mma_deallocate(dRdRho)
  call mma_deallocate(dRhodX)
  call mma_deallocate(dRhodY)
  call mma_deallocate(dRhodZ)
  call mma_deallocate(dF_dRhoapb)
  call mma_deallocate(dF_dRhoamb)
  call mma_deallocate(dF_dRhoxapb)
  call mma_deallocate(dF_dRhoyapb)
  call mma_deallocate(dF_dRhozapb)
  call mma_deallocate(dF_dRhoxamb)
  call mma_deallocate(dF_dRhoyamb)
  call mma_deallocate(dF_dRhozamb)
  call mma_deallocate(dEdRho)
  call mma_deallocate(dZdRho)
  call mma_deallocate(dEdRhox)
  call mma_deallocate(dEdRhoy)
  call mma_deallocate(dEdRhoz)
  call mma_deallocate(dEdPi)
  call mma_deallocate(GradRhodFdRho)
  call mma_deallocate(d2ZdR2)
  call mma_deallocate(d2RdRho2)
  call mma_deallocate(d2RdRhodPi)
  call mma_deallocate(MOas)
  ! for ft-functional
  call mma_deallocate(dRdPi)
  call mma_deallocate(GradRdFdRho)
  call mma_deallocate(GradPidFdRho)
  call mma_deallocate(dEdPix)
  call mma_deallocate(dEdPiy)
  call mma_deallocate(dEdPiz)
  call mma_deallocate(dEdPiMO)
  call mma_deallocate(GdEdPiMO)
  call mma_deallocate(MOax)
  call mma_deallocate(MOay)
  call mma_deallocate(MOaz)
end if

end subroutine PDFTMemDeAlloc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      function ranf(idum)
      integer idum,IM1,IM2,IMM1,IA1,IA2,IQ1,IQ2,IR1,IR2,NTAB,NDIV
      real*8 ranf,AM,EPS,RNMX
      parameter(IM1=2147483563,IM2=2147483399,AM=1./dble(IM1),
     *IMM1=IM1-1,IA1=40014,IA2=40692,IQ1=53668,IQ2=52774,IR1=12211,
     *IR2=3791,NTAB=32,NDIV=1+int(dble(IMM1)/NTAB),EPS=1.2e-7,
     *RNMX=1.-EPS)
      integer idum2,j,k,iv(NTAB),iy
      save iv,iy,idum2
      data idum2/123456789/, iv/NTAB*0/, iy/0/
      if (idum.le.0) then
        idum=max(-idum,1)
        idum2=idum
        do 11 j=NTAB+8,1,-1
           k=idum/IQ1
           idum=IA1*(idum-k*IQ1)-k*IR1
           if(idum.lt.0) idum=idum+IM1
           if(j.le.NTAB)iv(j)=idum
11      continue
        iy = iv(1)
      endif
      k=idum/IQ1
      idum=IA1*(idum-k*IQ1)-k*IR1
      if (idum.lt.0) idum = idum+IM1
      k=idum2/IQ2
      idum2=IA2*(idum2-k*IQ2)-k*IR2
      if (idum2.lt.0) idum2=idum2+IM2
      j=1+iy/NDIV
      iy=iv(j)-idum2
      iv(j)=idum
      if(iy.lt.1)iy=iy+IMM1
      ranf=min(AM*iy,RNMX)
      return
      end

*      function ranf(iSeed)
*      Implicit Real*4 (a-h,o-z)
*      Parameter (scale=0.5e0**31)
*      Integer fact
*      Data fact,mask/x'00003ED7',x'7FFFFFFF'/
*      iSeed=iAnd(mask,iSeed*fact)
*      Ranf=scale*iSeed
*      Return
*      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine SING(IWHY)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IWHY

select case (IWHY)
  case default !(1)
    write(u6,11)
  case (2)
    write(u6,12)
  case (3)
    write(u6,13)
end select

return

11 format(' MATRIX WITH ZERO ROW IN DECOMPOSE.')
12 format(' SINGULAR MATRIX IN DECOMPOSE.ZERO DIVIDE IN SOLVE.')
13 format(' NO CONVERGENCE IN IMPROVE.MATRIX IS NEARLY SINGULAR.')

end subroutine SING

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE VERTAB(NACTEL,M2SPIN,LSYM,NPART,NGASORB,NGASLIM,
     &                  ISSTAB,NFSB0,NRDETS0,NFSB,NRDETS,LFSBARR)
      IMPLICIT NONE
      INTEGER ISSTAB(*)
      INTEGER NASPRT,NACTEL,M2SPIN,LSYM
      INTEGER NPART
#include "symmul.fh"
      INTEGER NGASORB(0:NSYM,0:NPART)
      INTEGER NGASLIM(2,NPART)
      INTEGER NFSB,NFSB0,NRDETS,NRDETS0
      INTEGER NVERT,IVER1,IVER2
      INTEGER IPOS,ISPART,NPC1,M2C1,ISC1
      INTEGER ISST,KPOP,KMS2,KSYM
      INTEGER MX1,MN1,MX2,MN2,IPART,NOREM,MINEL,MAXEL
      INTEGER ISPEND,NGO,NSP,ISPSTA,MNL,MXL,MNR,MXR,NO
      INTEGER NPC2,M2C2,ISC2
      INTEGER NSSTP,KSSTP,KPOPMAX,KMS2MAX,NPOP,MS2,NSSTPTR
      INTEGER LSSTPTR,LSSTARR,N,IEND,ISTA,IADDR,ISAVE,NEXT
      INTEGER MS2MIN,MS2MAX,MSFACT,NVIDX,LVIDX,IVIDX,IVERT
      INTEGER LEVUP,LEVDWN,IADDR1,IADDR2,NARC
      INTEGER NARCVRT,NVERTAB,LVERTAB,NDWNTAB,LDWNTAB,NARCLEV,LWEIGHT
      INTEGER NFSBARR,LFSBARR,IVUP,LOWEST,ISW,NSW
      INTEGER KPOPLIM,LLTDA,LSWITCH
      INTEGER IARC,IA,ISUM,KEEP
C     INTEGER NSBS,LDUM,NDUM
      INTEGER NSBS
      INTEGER NSDBLK
#include "Morsel.fh"
#include "WrkSpc.fh"
      INTEGER LIMARR(2,0:50)
      INTEGER ITRY(50)

*----------------------------------------------------------------
* Unbutton the substring table:
      NSYM  =ISSTAB(4)
      NASPRT=ISSTAB(5)
      NSSTP =ISSTAB(7)
      KSSTP =15

CTEST      write(*,*)' Test print in VERTAB.'
CTEST      write(*,*)' NSYM  :',NSYM
CTEST      write(*,*)' NASPRT:',NASPRT
CTEST      write(*,*)' NSSTP :',NSSTP
CTEST      write(*,*)' Substrings:'
CTEST      do isst=1,nsstp
CTEST       NSBS   = ISSTAB(KSSTP+0+5*(ISST-1))
CTEST       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
CTEST       KSYM   = ISSTAB(KSSTP+2+5*(ISST-1))
CTEST       MS2    = ISSTAB(KSSTP+3+5*(ISST-1))
CTEST       ISPART = ISSTAB(KSSTP+4+5*(ISST-1))
CTEST       write(*,'(1x,6i8)')isst,nsbs,npop,ksym,ms2,ispart
CTEST      end do
* Now the properties of the substring types can be picked up
* as
*       NSBS   = ISSTAB(KSSTP+0+5*(ISST-1))
*       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
*       ISYM   = ISSTAB(KSSTP+2+5*(ISST-1))
*       MS2    = ISSTAB(KSSTP+3+5*(ISST-1))
*       ISPART = ISSTAB(KSSTP+4+5*(ISST-1))
*---------------------------------------------------------------
* Determine KPOPMAX = Max population of any subpartition
* Determine KMS2MAX = Max spin proj in any subpartition
      KPOPMAX=0
      KMS2MAX=0
      DO ISST=1,NSSTP
       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
       MS2    = ISSTAB(KSSTP+3+5*(ISST-1))
       KPOPMAX=MAX(NPOP,KPOPMAX)
       KMS2MAX=MAX(MS2,KMS2MAX)
      END DO
CTEST      write(*,'(1x,a,8i8)')'KPOPMAX:',KPOPMAX
CTEST      write(*,'(1x,a,8i8)')'KMS2MAX:',KMS2MAX
*----------------------------------------------------------------
* Using the GAS restrictions, set up an array with min and max nr of
* electrons (cumulative) up to and including subpartition ISPART:
      MX1=0
      MN1=0
      MX2=NACTEL
      MN2=NACTEL
      DO IPART=1,NPART
       NOREM=NGASORB(0,IPART)
       MINEL=MAX(0,NGASLIM(1,IPART))
       MAXEL=MIN(NOREM,NGASLIM(2,IPART))
       MX2=MX2-MINEL
       MN2=MN2-MAXEL
      END DO
      ISPEND=0

      LIMARR(1,0)=0
      LIMARR(2,0)=0
      DO IPART=1,NPART
       NGO  =NGASORB(0,IPART)
       MINEL=MAX(0,NGASLIM(1,IPART))
       MAXEL=MIN(NGO,NGASLIM(2,IPART))
       NSP=(NGO+MORSBITS-1)/MORSBITS
       ISPSTA=ISPEND+1
       ISPEND=ISPEND+NSP
       MNL=MAX(MN1,MN2)
       MXL=MIN(MX1,MX2)
       MN1=MN1+MINEL
       MX1=MX1+MAXEL
       MN2=MN2+MAXEL
       MX2=MX2+MINEL
       MNR=MAX(MN1,MN2)
       MXR=MIN(MX1,MX2)
       NOREM=NGO
       DO ISPART=ISPSTA,ISPEND
        NO=MIN(NOREM,MORSBITS)
        NOREM=NOREM-NO
        LIMARR(1,ISPART)=MAX(MNL,MNR-NOREM)
        LIMARR(2,ISPART)=MIN(MXL+NGO-NOREM,MXR)
       END DO
      END DO
CTEST      write(*,*)' The LIMARR array:'
CTEST      write(*,'(1x,8i5)')(limarr(1,ispart),ispart=0,nasprt)
CTEST      write(*,'(1x,8i5)')(limarr(2,ispart),ispart=0,nasprt)

*----------------------------------------------------------------
* First, set up an array containing substring types.
* It would be nice to be able to quickly loop through just those
* substrings that have a limited population, and belong to a
* specific subpartition. To achieve this, we need a temporary
* array with index limits (0:KPOPMAX+1,1:NASPRT), and one with
* index limits (1:NSSTP).
      NSSTPTR=(KPOPMAX+2)*NASPRT
      CALL GETMEM('SSTPTR','ALLO','INTE',LSSTPTR,NSSTPTR)
      DO ISPART=1,NASPRT
        DO KPOP=0,KPOPMAX+1
          IWORK(LSSTPTR+KPOP+(KPOPMAX+2)*(ISPART-1))=0
        END DO
      END DO
      CALL GETMEM('SSTARR','ALLO','INTE',LSSTARR,NSSTP)
      DO ISST=1,NSSTP
       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
       ISPART = ISSTAB(KSSTP+4+5*(ISST-1))
       N=1+IWORK(LSSTPTR+NPOP+(KPOPMAX+2)*(ISPART-1))
       IWORK(LSSTPTR+NPOP+(KPOPMAX+2)*(ISPART-1))=N
      END DO
      IEND=0
      DO ISPART=1,NASPRT
        DO KPOP=0,KPOPMAX
          N=IWORK(LSSTPTR+KPOP+(KPOPMAX+2)*(ISPART-1))
          ISTA=IEND+1
          IEND=IEND+N
          IWORK(LSSTPTR+KPOP+(KPOPMAX+2)*(ISPART-1))=ISTA
        END DO
        IWORK(LSSTPTR+KPOPMAX+1+(KPOPMAX+2)*(ISPART-1))=IEND+1
      END DO
      DO ISST=1,NSSTP
       NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
       ISPART = ISSTAB(KSSTP+4+5*(ISST-1))
       IADDR=IWORK(LSSTPTR+NPOP+(KPOPMAX+2)*(ISPART-1))
       IWORK(LSSTPTR+NPOP+(KPOPMAX+2)*(ISPART-1))=IADDR+1
       IWORK(LSSTARR-1+IADDR)=ISST
      END DO
      ISAVE=1
      DO ISPART=1,NASPRT
        DO KPOP=0,KPOPMAX
          NEXT=IWORK(LSSTPTR+KPOP+(KPOPMAX+2)*(ISPART-1))
          IWORK(LSSTPTR+KPOP+(KPOPMAX+2)*(ISPART-1))=ISAVE
          ISAVE=NEXT
        END DO
      END DO
CTESTC test print
CTEST      IADDR1=iwork(lsstptr+0+(kpopmax+2)*(1-1))
CTEST      IADDR2=iwork(lsstptr+kpopmax+1+(kpopmax+2)*(nasprt-1))
CTEST      write(*,'(1x,a,8i8)')'iaddr1,iaddr2:',iaddr1,iaddr2
CTEST      do IADDR=IADDR1,IADDR2-1
CTEST        isst=iwork(lsstarr-1+IADDR)
CTEST        kpop=ISSTAB(KSSTP+1+5*(ISST-1))
CTEST        ksym=ISSTAB(KSSTP+2+5*(ISST-1))
CTEST        kms2=ISSTAB(KSSTP+3+5*(ISST-1))
CTEST      write(*,'(1x,a,8i8)')'iaddr,isst,kpop,ksym,kms2:',
CTEST     &                      iaddr,isst,kpop,ksym,kms2
CTEST      end do
CTESTC End of test print

*----------------------------------------------------------------
* Here follows the construction of a graph, to be used for
* producing the FSB table.
* Use a single unique compound index for the vertices
* This way, we can use a temporary counter array to
* identify vertices.
* Subpartition is in 1..NASPRT, so we need levels 0..NASPRT
* Cumulative population is in 0..NACTEL
* Intermediate spin projection is in MS2MIN..MS2MAX:
      MS2MIN=(M2SPIN-KMS2MAX*NASPRT)/2
      MS2MAX=(M2SPIN+KMS2MAX*NASPRT)/2
* and it runs in steps of two units.
      MSFACT=1+(MS2MAX-MS2MIN)/2
* Intermediate symmetry label is in 1..NSYM
* All in all, the index
*  IND=ISCUM+NSYM*(
*    (M2CUM-MS2MIN)/2 + MSFACT*(NPCUM + (NACTEL+1)*ISPART))
* should do the trick.
* Run through the generation procedure twice. First time, we will
* determine the sizes of the vertex and downchain tables, and
* allocate them. Second time, we will fill in the values in these
* tables, and then the temporary counter table can be deallocated.
*----------------------------------
* Allocate temporary counter array:
      NVIDX=NSYM*MSFACT*(NACTEL+1)*(NASPRT+1)
      CALL GETMEM('VERIDX','ALLO','INTE',LVIDX,NVIDX)
      DO IVIDX=1,NVIDX
       IWORK(LVIDX-1+IVIDX)=0
      END DO
*----------------------------------
* Initialize top vertex:
      IPOS=LSYM+NSYM*((M2SPIN-MS2MIN)/2+MSFACT*(
     &              NACTEL+(NACTEL+1)*NASPRT))
      IWORK(LVIDX-1+IPOS)=1
      IVERT=1
*----------------------------------
* Recursively, find all other reachable vertices:
* Upper and lower level:
CTEST      CALL GETMEM('A','Check','Inte',LDUM,NDUM)
      DO LEVUP=NASPRT,1,-1
        LEVDWN=LEVUP-1
* A wasteful loop to pick out vertices on the upper level:
        DO NPC1=LIMARR(1,LEVUP),LIMARR(2,LEVUP)
         DO M2C1=-NPC1,NPC1,2
          IF(M2C1.LT.MS2MIN) GOTO 130
          IF(M2C1.GT.MS2MAX) GOTO 130
          DO ISC1=1,NSYM
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           IVER1=IWORK(LVIDX-1+IPOS)
           IF(IVER1.EQ.0) GOTO 120
* This is a valid upper vertex on the upper level.
* Loop over valid arcs:
           KPOPLIM=MIN(NPC1,KPOPMAX)
           IADDR1=IWORK(LSSTPTR+0+(KPOPMAX+2)*(LEVUP-1))
           IADDR2=IWORK(LSSTPTR+KPOPLIM+1+(KPOPMAX+2)*(LEVUP-1))
           DO IADDR=IADDR1,IADDR2-1
             ISST=IWORK(LSSTARR-1+IADDR)
             KPOP=ISSTAB(KSSTP+1+5*(ISST-1))
             KSYM=ISSTAB(KSSTP+2+5*(ISST-1))
             KMS2=ISSTAB(KSSTP+3+5*(ISST-1))
* Just temporary sanity test:
             ISPART=ISSTAB(KSSTP+4+5*(ISST-1))
             IF(ISPART.NE.LEVUP) THEN
               WRITE(6,*)' THIS IS INSANE!'
               CALL ABEND()
             END IF
             NPC2=NPC1-KPOP
             IF(NPC2.LT.LIMARR(1,LEVDWN)) GOTO 110
             IF(NPC2.GT.LIMARR(2,LEVDWN)) GOTO 110
             M2C2=M2C1-KMS2
             IF(M2C2.LT.MS2MIN) GOTO 110
             IF(M2C2.GT.MS2MAX) GOTO 110
             ISC2=MUL(KSYM,ISC1)
             IF(ABS(M2C2).GT.NPC2) GOTO 110
             IF(NPC2.EQ.0 .AND. ISC2.NE.1) GOTO 110
* Inspect the lower vertex: Is it a new one?
             IPOS=ISC2+NSYM*((M2C2-MS2MIN)/2+MSFACT*(
     &              NPC2+(NACTEL+1)*LEVDWN))
             IVER2=IWORK(LVIDX-1+IPOS)
             IF(IVER2.GT.0) GOTO 110
* This is a new vertex. Register its number
             IVERT=IVERT+1
             IVER2=IVERT
             IWORK(LVIDX-1+IPOS)=IVER2
 110         CONTINUE
           END DO
* Finished looping over possible arcs.
 120      CONTINUE
         END DO
 130     CONTINUE
        END DO
       END DO
* Finished looping over possible upper vertices.
      END DO
* Finished loop over upper level, LEVUP.
*----------------------------------
* Now the index array holds a positive integer IV if the combination
* of properties is such that this vertex could be reached from above.
* We now need to keep just those that can also be reached from below.
* This is accomplished by a similar loop, now in the other direction:
*----------------------------------
CTEST      CALL GETMEM('B','Check','Inte',LDUM,NDUM)
      NARC=0
* Upper and lower level:
      DO LEVUP=1,NASPRT
        LEVDWN=LEVUP-1
* A wasteful loop to pick out vertices on the upper level:
        DO NPC1=LIMARR(1,LEVUP),LIMARR(2,LEVUP)
         DO M2C1=-NPC1,NPC1,2
          IF(M2C1.LT.MS2MIN) GOTO 230
          IF(M2C1.GT.MS2MAX) GOTO 230
          DO ISC1=1,NSYM
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           IVER1=IWORK(LVIDX-1+IPOS)
           IF(IVER1.EQ.0) GOTO 220
* This is a valid upper vertex on the upper level.
* Is it reachable from below?
          NARCVRT=0
* Loop over valid arcs:
           KPOPLIM=MIN(NPC1,KPOPMAX)
           IADDR1=IWORK(LSSTPTR+0+(KPOPMAX+2)*(LEVUP-1))
           IADDR2=IWORK(LSSTPTR+KPOPLIM+1+(KPOPMAX+2)*(LEVUP-1))
           DO IADDR=IADDR1,IADDR2-1
             ISST=IWORK(LSSTARR-1+IADDR)
             KPOP=ISSTAB(KSSTP+1+5*(ISST-1))
             KSYM=ISSTAB(KSSTP+2+5*(ISST-1))
             KMS2=ISSTAB(KSSTP+3+5*(ISST-1))
* Just temporary sanity test:
             ISPART=ISSTAB(KSSTP+4+5*(ISST-1))
             IF(ISPART.NE.LEVUP) THEN
               WRITE(6,*)' THIS IS INSANE!'
               CALL ABEND()
             END IF
             NPC2=NPC1-KPOP
             IF(LEVDWN.EQ.0.AND.NPC2.GT.0) GOTO 210
             M2C2=M2C1-KMS2
             IF(M2C2.LT.MS2MIN) GOTO 210
             IF(M2C2.GT.MS2MAX) GOTO 210
             ISC2=MUL(KSYM,ISC1)
             IF(ABS(M2C2).GT.NPC2) GOTO 210
             IF(NPC2.EQ.0 .AND. ISC2.NE.1) GOTO 210
* Inspect the lower vertex: Is it reachable?
             IPOS=ISC2+NSYM*((M2C2-MS2MIN)/2+MSFACT*(
     &              NPC2+(NACTEL+1)*LEVDWN))
             IVER2=IWORK(LVIDX-1+IPOS)
             IF(IVER2.GT.0) NARCVRT=NARCVRT+1
 210         CONTINUE
           END DO
* Finished looping over possible arcs.
* Remove this vertex if it was unreachable.
          IF(NARCVRT.EQ.0) THEN
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           IWORK(LVIDX-1+IPOS)=0
          END IF
          NARC=NARC+NARCVRT
 220      CONTINUE
         END DO
 230     CONTINUE
        END DO
       END DO
* Finished looping over possible upper vertices.
      END DO
* Finished loop over upper level, LEVUP.
*----------------------------------
CTEST      CALL GETMEM('C','Check','Inte',LDUM,NDUM)
* Renumber the vertices:
      NVERT=0
* Upper and lower level:
      DO LEVUP=NASPRT,0,-1
* A wasteful loop to pick out vertices on the upper level:
        DO NPC1=LIMARR(1,LEVUP),LIMARR(2,LEVUP)
         DO M2C1=-NPC1,NPC1,2
          IF(M2C1.LT.MS2MIN) GOTO 330
          IF(M2C1.GT.MS2MAX) GOTO 330
          DO ISC1=1,NSYM
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           IVER1=IWORK(LVIDX-1+IPOS)
           IF(IVER1.EQ.0) GOTO 320
           NVERT=NVERT+1
           IWORK(LVIDX-1+IPOS)=NVERT
 320       CONTINUE
          END DO
 330      CONTINUE
         END DO
        END DO
       END DO
*----------------------------------
* Now allocate the vertex and downchain tables, and loop again:
      NVERTAB=6*NVERT
      CALL GETMEM('VERTAB','ALLO','INTE',LVERTAB,NVERTAB)
      NDWNTAB=3*NARC
      CALL GETMEM('DWNTAB','ALLO','INTE',LDWNTAB,NDWNTAB)
      IARC =0
CTEST      write(*,'(1x,a,8i8)')'Nr of vertices NVERT=',NVERT
CTEST      write(*,'(1x,a,8i8)')'Nr of arcs     NARC =',NARC
* --------------------------------------------------------------
C Allocate LTDA(1:2,1:NASPRT), Level-to-Downarc array:
      CALL GETMEM('LTDA','Allo','Inte',LLTDA,2*(NASPRT+1))
*----------------------------------
* Upper and lower level:
CTEST      CALL GETMEM('D','Check','Inte',LDUM,NDUM)
      DO LEVUP=NASPRT,1,-1
        LEVDWN=LEVUP-1
* Level-to-Downarc array:
        IWORK(LLTDA+2*LEVUP)=IARC+1
        IWORK(LLTDA+2*LEVUP+1)=0
* Initialize counter of arcs from this upper level:
        NARCLEV=0
* A wasteful loop to pick out vertices on the upper level:
        DO NPC1=LIMARR(1,LEVUP),LIMARR(2,LEVUP)
         DO M2C1=-NPC1,NPC1,2
          IF(M2C1.LT.MS2MIN) GOTO 430
          IF(M2C1.GT.MS2MAX) GOTO 430
          DO ISC1=1,NSYM
           IPOS=ISC1+NSYM*((M2C1-MS2MIN)/2+MSFACT*(
     &              NPC1+(NACTEL+1)*LEVUP))
           IVER1=IWORK(LVIDX-1+IPOS)
           IF(IVER1.EQ.0) GOTO 420
* This is a valid upper vertex on the upper level.
           IWORK(LVERTAB-1+1+6*(IVER1-1))=LEVUP
           IWORK(LVERTAB-1+2+6*(IVER1-1))=NPC1
           IWORK(LVERTAB-1+3+6*(IVER1-1))=M2C1
           IWORK(LVERTAB-1+4+6*(IVER1-1))=ISC1
           IWORK(LVERTAB-1+5+6*(IVER1-1))=IARC+1
           IWORK(LVERTAB-1+6+6*(IVER1-1))=0
* Initialize counter of arcs from this upper vertex:
           NARCVRT=0
* Loop over valid arcs:
           KPOPLIM=MIN(NPC1,KPOPMAX)
           IADDR1=IWORK(LSSTPTR+0+(KPOPMAX+2)*(LEVUP-1))
           IADDR2=IWORK(LSSTPTR+KPOPLIM+1+(KPOPMAX+2)*(LEVUP-1))
           DO IADDR=IADDR1,IADDR2-1
             ISST=IWORK(LSSTARR-1+IADDR)
             KPOP=ISSTAB(KSSTP+1+5*(ISST-1))
             KSYM=ISSTAB(KSSTP+2+5*(ISST-1))
             KMS2=ISSTAB(KSSTP+3+5*(ISST-1))
* Just temporary sanity test:
             ISPART=ISSTAB(KSSTP+4+5*(ISST-1))
             IF(ISPART.NE.LEVUP) THEN
               WRITE(6,*)' THIS IS INSANE!'
               CALL ABEND()
             END IF
             NPC2=NPC1-KPOP
             IF(LEVDWN.EQ.0.AND.NPC2.GT.0) GOTO 410
             M2C2=M2C1-KMS2
             IF(M2C2.LT.MS2MIN) GOTO 410
             IF(M2C2.GT.MS2MAX) GOTO 410
             ISC2=MUL(KSYM,ISC1)
             IF(ABS(M2C2).GT.NPC2) GOTO 410
             IF(NPC2.EQ.0 .AND. ISC2.NE.1) GOTO 410
* Is it a valid arc? See if a lower vertex exists.
             IPOS=ISC2+NSYM*((M2C2-MS2MIN)/2+MSFACT*(
     &              NPC2+(NACTEL+1)*LEVDWN))
             IVER2=IWORK(LVIDX-1+IPOS)
             IF(IVER2.EQ.0) GOTO 410
* A valid arc has been found. The upper vertex IVER1 is
* joined to the lower vertex IVER2 by an arc associated
* with the substring type ISST.
             NARCVRT=NARCVRT+1
             NARCLEV=NARCLEV+1
             IARC=IARC+1
             IWORK(LDWNTAB-1+1+3*(IARC-1))=ISST
             IWORK(LDWNTAB-1+2+3*(IARC-1))=IVER1
             IWORK(LDWNTAB-1+3+3*(IARC-1))=IVER2
 410         CONTINUE
           END DO
* Finished looping over possible arcs.
          IWORK(LVERTAB-1+6+6*(IVER1-1))=NARCVRT
 420      CONTINUE
         END DO
 430     CONTINUE
        END DO
       END DO
* Finished looping over vertices on this level.
       IWORK(LLTDA+2*LEVUP+1)=NARCLEV
      END DO
* Finished loop over upper level, LEVUP.
      IWORK(LVERTAB-1+1+6*(NVERT-1))=0
      IWORK(LVERTAB-1+2+6*(NVERT-1))=0
      IWORK(LVERTAB-1+3+6*(NVERT-1))=0
      IWORK(LVERTAB-1+4+6*(NVERT-1))=1
      IWORK(LVERTAB-1+5+6*(NVERT-1))=IARC
      IWORK(LVERTAB-1+6+6*(NVERT-1))=0
      IWORK(LLTDA)=IARC
      IWORK(LLTDA+1)=0
CTEST      CALL GETMEM('E','Check','Inte',LDUM,NDUM)
*---------------------------------------------------------
* The graph is finished. we do no longer need these arrays:
      CALL GETMEM('SSTPTR','FREE','INTE',LSSTPTR,NSSTPTR)
      CALL GETMEM('SSTARR','FREE','INTE',LSSTARR,NSSTP)
      CALL GETMEM('VERIDX','FREE','INTE',LVIDX,NVIDX)
*---------------------------------------------------------
* A graph has been constructed. We may construct a weight array:
      CALL GETMEM('WEIGHT','ALLO','INTE',LWEIGHT,NVERT)
      DO IVERT=1,NVERT-1
       IWORK(LWEIGHT-1+IVERT)=0
      END DO
      IWORK(LWEIGHT-1+NVERT)=1
CTEST      CALL GETMEM('G','Check','Inte',LDUM,NDUM)
      DO LEVUP=1,NASPRT
        LEVDWN=LEVUP-1
* Loop over arcs leading down from upper level:
        NARCLEV=IWORK(LLTDA+2*LEVUP+1)
        DO IA=1,NARCLEV
          IARC=IWORK(LLTDA+2*LEVUP)-1+IA
          ISST =IWORK(LDWNTAB-1+1+3*(IARC-1))
          IVER1=IWORK(LDWNTAB-1+2+3*(IARC-1))
          IVER2=IWORK(LDWNTAB-1+3+3*(IARC-1))
          ISUM=IWORK(LWEIGHT-1+IVER1)+IWORK(LWEIGHT-1+IVER2)
          IWORK(LWEIGHT-1+IVER1)=ISUM
        END DO
      END DO
C No more use for Level-to-Downarc array:
      CALL GETMEM('LTDA','Free','Inte',LLTDA,2*(NASPRT+1))
CTEST      CALL GETMEM('H','Check','Inte',LDUM,NDUM)
*---------------------------------------------------------
* Now, for any vertex iv, iwork(lweight-1+iv) is the total number of
* downwalks that can reach vertex nr nvert (The bottom vertex).
* Traverse the graph. Use a swich array. The graph is traversed
* from the top. At each vertex, one of the available arcs downwards
* is selected. Which arc to select is given by ISWITCH(LEVUP), where
* LEVUP is the level of the upper vertex.
      CALL GETMEM('Switch','Allo','Inte',LSWITCH,NASPRT)
* Initial values: Lowest walk
      DO LEVUP=1,NASPRT
        IWORK(LSWITCH-1+LEVUP)=1
      END DO
* The total number of walks in the graph:
      NFSB0=IWORK(LWEIGHT)
      NFSBARR=(NASPRT+2)*NFSB0
      CALL GETMEM('FSBARR','ALLO','INTE',LFSBARR,NFSBARR)
      NRDETS0=0
      NFSB=0
      NRDETS=0
CTEST      write(*,*)' A list of all generated FS blocks:'
 500  CONTINUE
* Construct this walk. While constructing it, also find out if
* it has a successor.
      IVUP=1
      LOWEST=NASPRT+1
      DO LEVUP=NASPRT,1,-1
       ISW=IWORK(LSWITCH-1+LEVUP)
* Select arc nr isw from those available to vertex ivup.
       IARC=IWORK(LVERTAB-1+5+6*(IVUP-1))-1+ISW
* Could it be incremented?
       NSW=IWORK(LVERTAB-1+6+6*(IVUP-1))
CTEST      write(*,'(1x,a,8i8)')'IVUP,ISW,NSW:',IVUP,ISW,NSW
       IF(NSW.GT.ISW) LOWEST=LEVUP
* Consult the downarc table:
       ISST =IWORK(LDWNTAB-1+1+3*(IARC-1))
       IVER1=IWORK(LDWNTAB-1+2+3*(IARC-1))
       IVER2=IWORK(LDWNTAB-1+3+3*(IARC-1))
CTEST      write(*,'(1x,a,8i8)')'ISST,IVER1,IVER2:',ISST,IVER1,IVER2
       IF(IVER1.NE.IVUP) THEN
         WRITE(6,*)' OOOOPS! THIS SHOULD NOT HAPPEN.'
         CALL ABEND()
       END IF
       ITRY(LEVUP)=ISST
       IVUP=IVER2
      END DO
* Check GAS restrictions:
      NSDBLK=1
      ISPEND=0
      KEEP=1
      DO IPART=1,NPART
       NGO  =NGASORB(0,IPART)
       NSP=(NGO+MORSBITS-1)/MORSBITS
       ISPSTA=ISPEND+1
       ISPEND=ISPEND+NSP
       NOREM=NGO
       ISUM=0
       DO ISPART=ISPSTA,ISPEND
        ISST=ITRY(ISPART)
        NSBS   = ISSTAB(KSSTP+0+5*(ISST-1))
        NPOP   = ISSTAB(KSSTP+1+5*(ISST-1))
        ISUM=ISUM+NPOP
        NSDBLK=NSDBLK*NSBS
       END DO
       IF(ISUM.LT.NGASLIM(1,IPART)) KEEP=0
       IF(ISUM.GT.NGASLIM(2,IPART)) KEEP=0
      END DO
      NRDETS0=NRDETS0+NSDBLK
      IF(KEEP.EQ.1) THEN
        NFSB=NFSB+1
        DO ISPART=1,NASPRT
         IWORK(LFSBARR-1+ISPART+(NASPRT+2)*(NFSB-1))=ITRY(ISPART)
        END DO
        IWORK(LFSBARR+NASPRT+(NASPRT+2)*(NFSB-1))=NSDBLK
        IWORK(LFSBARR+NASPRT+1+(NASPRT+2)*(NFSB-1))=NRDETS+1
        NRDETS=NRDETS+NSDBLK
CTEST      write(*,'(1x,i8,5x,10i5)') NFSB,(IWORK(LFSBARR-1+
CTEST     &                  LEVUP+NASPRT*(NFSB-1)),LEVUP=1,NASPRT),NSDBLK

* Next walk: Lowest increasable switch value is at level lowest.
      END IF
      IF(LOWEST.GT.NASPRT) GOTO 600
      DO LEVUP=1,LOWEST-1
       IWORK(LSWITCH-1+LEVUP)=1
      END DO
      IWORK(LSWITCH-1+LOWEST)=1+IWORK(LSWITCH-1+LOWEST)
      GOTO 500

 600  CONTINUE
      CALL GETMEM('Switch','Free','Inte',LSWITCH,NASPRT)
      CALL GETMEM('VERTAB','FREE','INTE',LVERTAB,NVERTAB)
      CALL GETMEM('DWNTAB','FREE','INTE',LDWNTAB,NDWNTAB)
      CALL GETMEM('WEIGHT','FREE','INTE',LWEIGHT,NVERT)
* Here we are. No more FS blocks can be constructed.
CTEST      write(*,*)' Total nr of Slater determinants, NRDETS=',NRDETS
CTEST      write(*,*)' Returning from VERTAB.'

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cont(L,breit,ifinite)
cbs###########################################################################
cbs   cont prepares all required contraction coefficients for functions
cbs   with angular momentum L
cbs###########################################################################
      implicit real*8 (a-h,o-z)
#include "para.fh"
#include "param.fh"
      dimension tkintria((MxprimL*MxprimL+MxprimL)/2)
      logical breit,breit_finite
      breit_finite=.true.
cbs   transcon transfers and normalizes contracted functions
cbs   ore more precizely the coefficients
      call transcon(cntscrtch(1,1,L),MxprimL,
     *MxcontL,normovlp(1,1,L),
     *contrarray(iaddori(L)),nprimit(L),ncontrac(L))
cbs   gentkin generates the matrix of kinetic energy  TKIN
      call gentkin(L,TKIN,nprimit(L),exponents(1,L),rootOVLPinv(1,1,L))
cbs   kindiag diagonalizes TKIN
cbs   for finite nucleus
      if (ifinite.eq.2.and.L.eq.0) then
      call kindiag(TKIN,TKINTRIA,nprimit(L),evec,eval,breit_finite)
      else
      call kindiag(TKIN,TKINTRIA,nprimit(L),evec,eval,breit)
      endif
cbs   kinemat generates kinematic factors in
cbs   the basis of eigenvectors
      call kinemat(L,nprimit(L),eval,type1,type2,Energy)
      incr=nprimit(L)*ncontrac(L)
cbs   chngcont= changecont generates the contraction coeffs
cbs   including kinematic factors and even exponents as factors
      call chngcont(
     *contrarray(iaddori(L)),
     *contrarray(iaddtyp1(L)),
     *contrarray(iaddtyp2(L)),
     *contrarray(iaddtyp3(L)),
     *contrarray(iaddtyp4(L)),
     *ncontrac(L),nprimit(L),evec,
     *type1,type2,scratch4,scratch4(nprimit(L)*nprimit(L)+1),
     *scratch4(2*nprimit(L)*nprimit(L)+1),MxprimL,
     *rootOVLP(1,1,L),OVLPinv(1,1,L),
     *exponents(1,L))
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine CISigma_sa(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,Int2a,nInt2a,ipCI1,ipCI2,Have_2_el)

use Symmetry_Info, only: Mul
use ipPage, only: ipin, ipin1, ipnout, opout, W
use MCLR_Data, only: i12, ipCM, ipMat, iRefSM, iST, KAIN1, KINT2, KINT2A, nConf1, pInt1, Square, XISPSM
use CandS, only: ICSM, ISSM
use input_mclr, only: nCSF, nRoots, nSym, Page, State_Sym, Weight
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iiSpin, iCSym, iSSym, nInt1, nInt2s, nInt2a, ipCI1, ipCI2
real(kind=wp), target, intent(in) :: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
logical(kind=iwp), intent(in) :: Have_2_el
integer(kind=iwp) :: nDet, i, iOp, iS, kic(2)
real(kind=wp), allocatable :: CIDET(:)

! Interface Anders to Jeppe
! This interface initiates Jeppe's common block
! and will make it easier to use Anders modifications
! of the CI routines

! OK first tell Jeppe where the integrals are.

! yma: notice the nconf1 if DMRG

if (nconf1 == 0) return

! One electron integrals

KAIN1(1:nInt1) => Int1(:)

! Two electron integrals
! symmetric in particle one and two

KINT2(1:nInt2s) => Int2s(:)

! Two electron integrals
! anti symmetric in particle one and two

KINT2A(1:nInt2a) => Int2a(:)

irefsm = iCSym

! Do we have any two-electron integrals?

if (Have_2_el) then
  i12 = 2
else
  i12 = 1
end if

! Symmetry of Sigma vector

iSSM = iSSym
kic(2) = 2
if (issm == State_sym) kic(2) = 1

! Symmetry of CI vector

iCSM = iCSym
kic(1) = 2
if (icsm == State_sym) kic(1) = 1

! Symmetry properties of operator

ndet = nint(max(xispsm(iSSym,1),xispsm(iCSym,1)))
ndet = max(ndet,ncsf(icsym),ncsf(issym))

if (ndet == 0) return
iOP = Mul(iCSM,iSSm)
if (iOp == 1) then
  pInt1(1:nSym) = ipCM(1:nSym)
else
  do iS=1,nSym
    pInt1(is) = ipMat(is,Mul(iS,iOp))
  end do
end if

! Triplet/Singlet operator

ist = iispin+1
square = .false.

if (.not. page) then
  call mma_allocate(CIDET,nDet,Label='CIDET')
  call ipin(ipCI1)
  call ipin(ipci2)
  do i=1,nroots
    if (weight(i) == Zero) then
      W(ipci2)%A((i-1)*ncsf(issm)+1:i*ncsf(issm)) = Zero
    else
      CIDET(1:nCSF(iCSM)) = W(ipCI1)%A((i-1)*ncsf(icsm)+1:i*ncsf(icsm))
      call SigmaVec(CIDET,W(ipci2)%A(1+(i-1)*ncsf(issm)),kic)
      W(ipci2)%A((i-1)*ncsf(issm)+1:i*ncsf(issm)) = weight(i)*W(ipci2)%A((i-1)*ncsf(issm)+1:i*ncsf(issm))
    end if
  end do
  call mma_deallocate(CIDET)
else
  call ipnout(ipci2)
  call ipin1(ipCI1,ndet)
  call ipin(ipci2)
  call SigmaVec(W(ipCI1)%A,W(ipci2)%A,kic)
  call opout(ipci1)
end if

end subroutine CISigma_sa

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LOOP70(C,S,ABIJ,AIBJ,AJBI,A,B,F,IPOF,IPOA,IPOB,MYL,NYL,INDA,INDB,INMY,INNY,IFTB,IFTA,FACS,IAB,CPL,CPLA,NVIRA,NVIRC,NVIRB)

use mrci_global, only: NSYM, NVIR
use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: C(*), ABIJ(*), AIBJ(*), AJBI(*), FACS, CPL, CPLA
real(kind=wp), intent(inout) :: S(*)
real(kind=wp), intent(_OUT_) :: A(*), B(*), F(*)
integer(kind=iwp), intent(in) :: IPOF(9), IPOA(9), IPOB(9), MYL, NYL, INDA, INDB, INMY, INNY, IFTB, IFTA
integer(kind=iwp), intent(out) :: IAB, NVIRA, NVIRC, NVIRB
integer(kind=iwp) :: IASYM, IBSYM, ICSYM, IPF
real(kind=wp) :: FACSX

do IASYM=1,NSYM
  IAB = IPOF(IASYM+1)-IPOF(IASYM)
  if (IAB == 0) cycle
  ICSYM = MUL(MYL,IASYM)
  IBSYM = MUL(NYL,ICSYM)
  if ((INDA == INDB) .and. (IBSYM > IASYM)) cycle
  NVIRC = NVIR(ICSYM)
  if (NVIRC == 0) cycle
  NVIRA = NVIR(IASYM)
  NVIRB = NVIR(IBSYM)
  if (ICSYM < IASYM) then
    if (ICSYM < IBSYM) then
      ! CASE 1, IASYM > ICSYM AND IBSYM > ICSYM
      IPF = IPOF(IASYM)+1
      F(1:IAB) = CPL*AIBJ(IPF:IPF+IAB-1)+CPLA*ABIJ(IPF:IPF+IAB-1)
      if (INDA == INDB) call DCOPY_(NVIRA,[Zero],0,F,NVIRA+1)
      call DGEMM_('N','N',NVIRC,NVIRB,NVIRA,FACS,C(INMY+IPOA(IASYM)),NVIRC,F,NVIRA,One,S(INNY+IPOB(IBSYM)),NVIRC)
      if (INDA /= INDB) then
        IPF = IPOF(IBSYM)+1
        F(1:IAB) = CPL*AJBI(IPF:IPF+IAB-1)+CPLA*ABIJ(IPF:IPF+IAB-1)
        call DGEMM_('N','N',NVIRC,NVIRA,NVIRB,FACS,C(INNY+IPOB(IBSYM)),NVIRC,F,NVIRB,One,S(INMY+IPOA(IASYM)),NVIRC)
      end if
    else
      ! CASE 2, IASYM > ICSYM AND ICSYM > OR = IBSYM
      IPF = IPOF(IBSYM)+1
      F(1:IAB) = CPL*AJBI(IPF:IPF+IAB-1)+CPLA*ABIJ(IPF:IPF+IAB-1)

      if (NYL == 1) then
        call DGEMM_('N','T',NVIRB,NVIRC,NVIRA,FACS,F,NVIRB,C(INMY+IPOA(IASYM)),NVIRC,Zero,A,NVIRB)
        if (IFTB == 1) then
          call TRADD(A,S(INNY+IPOB(ICSYM)),NVIRB)
          call SQUARN(C(INNY+IPOB(IBSYM)),A,NVIRB)
        else
          call SIADD(A,S(INNY+IPOB(ICSYM)),NVIRB)
          call SQUAR(C(INNY+IPOB(IBSYM)),A,NVIRB)
        end if
        call DGEMM_('N','N',NVIRC,NVIRA,NVIRB,FACS,A,NVIRC,F,NVIRB,One,S(INMY+IPOA(IASYM)),NVIRC)
      else
        FACSX = FACS
        if (IFTB == 1) FACSX = -FACS
        call DGEMM_('N','T',NVIRB,NVIRC,NVIRA,FACSX,F,NVIRB,C(INMY+IPOA(IASYM)),NVIRC,One,S(INNY+IPOB(ICSYM)),NVIRB)
        call DGEMM_('T','N',NVIRC,NVIRA,NVIRB,FACSX,C(INNY+IPOB(ICSYM)),NVIRB,F,NVIRB,One,S(INMY+IPOA(IASYM)),NVIRC)
      end if
    end if
  else
    ! UPDATED UNTIL HERE
    if (ICSYM < IBSYM) then
      ! CASE 3, ICSYM > OR = IASYM AND IBSYM > ICSYM
      IPF = IPOF(IASYM)+1
      F(1:IAB) = CPL*AIBJ(IPF:IPF+IAB-1)+CPLA*ABIJ(IPF:IPF+IAB-1)
      if (MYL == 1) then
        if (IFTA == 0) call SQUAR(C(INMY+IPOA(IASYM)),A,NVIRA)
        if (IFTA == 1) call SQUARN(C(INMY+IPOA(IASYM)),A,NVIRA)
        call DGEMM_('N','N',NVIRC,NVIRB,NVIRA,FACS,A,NVIRC,F,NVIRA,One,S(INNY+IPOB(IBSYM)),NVIRC)
        call DGEMM_('N','T',NVIRA,NVIRC,NVIRB,FACS,F,NVIRA,C(INNY+IPOB(IBSYM)),NVIRC,Zero,A,NVIRA)
        if (IFTA == 0) call SIADD(A,S(INMY+IPOA(IASYM)),NVIRA)
        if (IFTA == 1) call TRADD(A,S(INMY+IPOA(IASYM)),NVIRA)
      else
        FACSX = FACS
        if (IFTA == 1) FACSX = -FACS
        call DGEMM_('T','N',NVIRC,NVIRB,NVIRA,FACSX,C(INMY+IPOA(ICSYM)),NVIRA,F,NVIRA,One,S(INNY+IPOB(IBSYM)),NVIRC)
        call DGEMM_('N','T',NVIRA,NVIRC,NVIRB,FACSX,F,NVIRA,C(INNY+IPOB(IBSYM)),NVIRC,One,S(INMY+IPOA(ICSYM)),NVIRA)
      end if
    else
      ! CASE 4, ICSYM > OR = IASYM AND ICSYM > OR = IBSYM
      IPF = IPOF(IBSYM)+1
      F(1:IAB) = CPL*AJBI(IPF:IPF+IAB-1)+CPLA*ABIJ(IPF:IPF+IAB-1)
      if (INDA == INDB) call DCOPY_(NVIRA,[Zero],0,F,NVIRA+1)
      if ((MYL == 1) .and. (NYL == 1)) then

        if (IFTA == 0) call SQUAR(C(INMY+IPOA(IASYM)),A,NVIRA)
        if (IFTA == 1) call SQUARM(C(INMY+IPOA(IASYM)),A,NVIRA)
        call DGEMM_('N','N',NVIRB,NVIRC,NVIRA,FACS,F,NVIRB,A,NVIRA,Zero,B,NVIRB)
        if (IFTB == 0) call SIADD(B,S(INNY+IPOB(ICSYM)),NVIRB)
        if (IFTB == 1) call TRADD(B,S(INNY+IPOB(ICSYM)),NVIRB)

      else if ((MYL == 1) .and. (NYL /= 1)) then
        if (IFTA == 0) call SQUAR(C(INMY+IPOA(IASYM)),A,NVIRA)
        if (IFTA == 1) call SQUARM(C(INMY+IPOA(IASYM)),A,NVIRA)
        FACSX = FACS
        if (IFTB == 1) FACSX = -FACS
        call DGEMM_('N','N',NVIRB,NVIRC,NVIRA,FACSX,F,NVIRB,A,NVIRA,One,S(INNY+IPOB(ICSYM)),NVIRB)

      else if ((MYL /= 1) .and. (NYL == 1)) then

        FACSX = FACS
        if (IFTA == 1) FACSX = -FACS
        call DGEMM_('N','N',NVIRB,NVIRC,NVIRA,FACSX,F,NVIRB,C(INMY+IPOA(ICSYM)),NVIRA,Zero,B,NVIRB)
        if (IFTB == 0) call SIADD(B,S(INNY+IPOB(ICSYM)),NVIRB)
        if (IFTB == 1) call TRADD(B,S(INNY+IPOB(ICSYM)),NVIRB)
      else if ((MYL /= 1) .and. (NYL /= 1)) then
        FACSX = FACS
        if (IFTA+IFTB == 1) FACSX = -FACS
        call DGEMM_('N','N',NVIRB,NVIRC,NVIRA,FACSX,F,NVIRB,C(INMY+IPOA(ICSYM)),NVIRA,One,S(INNY+IPOB(ICSYM)),NVIRB)
      end if
      if (INDA /= INDB) then
        IPF = IPOF(IASYM)+1
        F(1:IAB) = CPL*AIBJ(IPF:IPF+IAB-1)+CPLA*ABIJ(IPF:IPF+IAB-1)

        if ((NYL == 1) .and. (MYL == 1)) then

          if (IFTB == 0) call SQUAR(C(INNY+IPOB(IBSYM)),A,NVIRB)
          if (IFTB == 1) call SQUARM(C(INNY+IPOB(IBSYM)),A,NVIRB)
          call DGEMM_('N','N',NVIRA,NVIRC,NVIRB,FACS,F,NVIRA,A,NVIRB,Zero,B,NVIRA)
          if (IFTA == 0) call SIADD(B,S(INMY+IPOA(ICSYM)),NVIRA)
          if (IFTA == 1) call TRADD(B,S(INMY+IPOA(ICSYM)),NVIRA)

        else if ((NYL == 1) .and. (MYL /= 1)) then

          if (IFTB == 0) call SQUAR(C(INNY+IPOB(ICSYM)),A,NVIRB)
          if (IFTB == 1) call SQUARM(C(INNY+IPOB(ICSYM)),A,NVIRB)
          FACSX = FACS
          if (IFTA == 1) FACSX = -FACS
          call DGEMM_('N','N',NVIRA,NVIRC,NVIRB,FACSX,F,NVIRA,A,NVIRB,One,S(INMY+IPOA(ICSYM)),NVIRA)

        else if ((NYL /= 1) .and. (MYL == 1)) then

          FACSX = FACS
          if (IFTB == 1) FACSX = -FACS
          call DGEMM_('N','N',NVIRA,NVIRC,NVIRB,FACSX,F,NVIRA,C(INNY+IPOB(ICSYM)),NVIRB,Zero,B,NVIRA)
          if (IFTA == 0) call SIADD(B,S(INMY+IPOA(ICSYM)),NVIRA)
          if (IFTA == 1) call TRADD(B,S(INMY+IPOA(ICSYM)),NVIRA)

        else if ((NYL /= 1) .and. (MYL /= 1)) then

          FACSX = FACS
          if (IFTA+IFTB == 1) FACSX = -FACS
          call DGEMM_('N','N',NVIRA,NVIRC,NVIRB,FACSX,F,NVIRA,C(INNY+IPOB(ICSYM)),NVIRB,One,S(INMY+IPOA(ICSYM)),NVIRA)

        end if
      end if
    end if
  end if

end do

return

end subroutine LOOP70

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DensAB(nBT,nDens,nD,Dens)
!***********************************************************************
!                                                                      *
!     purpose: calculate Density alpha+beta, alpha-beta and dump them  *
!              to runfile                                              *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBT, nDens, nD
real(kind=wp), intent(in) :: Dens(nBT,nD,nDens)
real(kind=wp), allocatable :: Dtemp(:)

if (nD == 1) then
  call Put_dArray('D1ao',Dens(:,1,nDens),nBT)
else
  call mma_allocate(DTemp,nBT,Label='DTemp')

  DTemp(:) = Dens(:,1,nDens)+Dens(:,2,nDens)
  call Put_dArray('D1ao',DTemp,nBT)

  DTemp(:) = Dens(:,1,nDens)-Dens(:,2,nDens)
  call Put_dArray('D1Sao',DTemp,nBT)

  call mma_deallocate(DTemp)
end if

return

end subroutine DensAB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function get_ln(lunit)

use getline_mod, only: Quit_On_Error
use Definitions, only: iwp

implicit none
character(len=180) :: get_ln
integer(kind=iwp), intent(in) :: lunit
character(len=180), external :: get_ln_quit

get_ln = get_ln_quit(lunit,1)
if (Quit_On_Error) then
  call WarningMessage(2,'Error in Get_Ln')
  call Quit_OnUserError()
end if

return

end function get_ln

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005,2006, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine GetRawPAOs(R,C,nBas,nOrb,nFro,nOrb2Loc,nSym,Normalize)
C
C     Thomas Bondo Pedersen, December 2005.
C     - revised january 2006 (Thomas Bondo Pedersen).
C
C     Purpose: compute projected AOs spanning the primary space from the
C              formula
C
C              R = 1 - Do*S = D*S
C
C              where Do is the "AO density" matrix of the orthogonal
C              complement orbitals and D that of the orbital space to be
C              localised (primary space).
C              S is the AO overlap matrix (which is read from disk).
C
C              Which formula is used depends on the dimensions of the
C              two spaces (such that the most economical is computed).
C
C              If (Normalize): normalize each PAO (recommended).
C                              Note that if the norm of the PAO is
C                              smaller than 1.0d-6, it will not be
C                              normalized (it is left unchanged).
C
C-------------------------------------------------------------
C-TODO/FIXME: it is in most cases faster to use Do*S=C*(C^T*S)
C-------------------------------------------------------------
C
      Implicit Real*8 (a-h,o-z)
      Integer nBas(nSym), nOrb(nSym), nFro(nSym), nOrb2Loc(nSym)
      Real*8  R(*), C(*)
      Logical Normalize
#include "WrkSpc.fh"

      Character*10 SecNam
      Parameter (SecNam = 'GetRawPAOs')

      Character*80 Txt

      external ddot_

C     Read the overlap matrix from disk.
C     ----------------------------------

      lOvlp = nBas(1)**2
      Do iSym = 2,nSym
         lOvlp = lOvlp + nBas(iSym)**2
      End Do
      Call GetMem('Ovlp','Allo','Real',ipOvlp,lOvlp)
      Call GetOvlp_Localisation(Work(ipOvlp),'Sqr',nBas,nSym)

C     Compute R.
C     ----------

      lDo = nBas(1)**2
      Do iSym = 2,nSym
         lDo = max(lDo,nBas(iSym)**2)
      End Do
      Call GetMem('Do','Allo','Real',ipDo,lDo)

      kOff  = 1
      kOffS = ipOvlp
      Do iSym = 1,nSym

         nB = nBas(iSym)
         If (nB .gt. 0) Then

            nF    = nFro(iSym)
            nO2L  = nOrb2Loc(iSym)
            nDel  = nB - nOrb(iSym)
            nRest = nOrb(iSym) - nF - nO2L
            nOrth = nF + nRest ! dim. of orthogonal complement

            If (nO2L .lt. 1) Then ! R = 0
               Call fZero(R(kOff),nB**2)
            Else If (nOrth .lt. 0) Then ! error
               Call SysAbendMsg(SecNam,
     &              'Dimension of orthogonal complement space < 0',' ')
            Else If (nOrth .eq. 0) Then ! R = 1
               Call fZero(R(kOff),nB**2)
               Do i = 1,nB
                  R(kOff-1+nB*(i-1)+i) = 1.0d0
               End Do
            Else If (nOrth .lt. nO2L) Then ! R = 1 - Do*S
               If (nRest .gt. 0) Then
                 lOff = kOff + nB*(nF+nO2L)
                 Call GetDens_Localisation(Work(ipDo),C(lOff),nB,nRest)
               Else
                 Call fZero(Work(ipDo),nB**2)
               End If
               If (nF .gt. 0) Then
                  Call GetDens_Localisation(R(kOff),C(kOff),nB,nF)
                  Call dAXPY_(nB**2,1.0d0,R(kOff),1,Work(ipDo),1)
               End If
               Call DGEMM_('N','N',nB,nB,nB,
     &                    -1.0d0,Work(ipDo),nB,Work(kOffS),nB,
     &                     0.0d0,R(kOff),nB)
               Do i = 1,nB
                  R(kOff-1+nB*(i-1)+i) = R(kOff-1+nB*(i-1)+i) + 1.0d0
               End Do
            Else ! R = D*S
               lOff = kOff + nB*nF
               Call GetDens_Localisation(Work(ipDo),C(lOff),nB,nO2L)
               Call DGEMM_('N','N',nB,nB,nB,
     &                    1.0d0,Work(ipDo),nB,Work(kOffS),nB,
     &                    0.0d0,R(kOff),nB)
            End If

            kOff  = kOff  + nB**2
            kOffS = kOffS + nB**2

         End If

      End Do

C     If requested, normalize the PAOs.
C     ---------------------------------

      If (Normalize) Then
         kOff  = 1
         kOffS = ipOvlp
         Do iSym = 1,nSym
            nB = nBas(iSym)
            If (nB .gt. 0) Then
               Call DGEMM_('N','N',nB,nB,nB,
     &                    1.0d0,Work(kOffS),nB,R(kOff),nB,
     &                    0.0d0,Work(ipDo),nB)
               Do mu = 0,nB-1
                  kR  = kOff + nB*mu
                  kSR = ipDo + nB*mu
                  Ovlp = dDot_(nB,R(kR),1,Work(kSR),1)
                  If (Ovlp .gt. 1.0d-6) Then
                     Fac = 1.0d0/sqrt(Ovlp)
                     Call dScal_(nB,Fac,R(kR),1)
                  Else If (Ovlp .lt. 0.0d0) Then
                     Write(Txt,'(A,1P,D15.5)') 'Overlap = ',Ovlp
                     Call SysAbendMsg(SecNam,
     &                                'Negative raw PAO overlap!',Txt)
                  End If
               End Do
               kOff  = kOff + nB**2
               kOffS = kOffS + nB**2
            End If
         End Do
      End If

      Call GetMem('Do','Free','Real',ipDo,lDo)
      Call GetMem('Ovlp','Free','Real',ipOvlp,lOvlp)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine SmAdNa(ArrIn,nb,ArrOut,nop,
     &                  lOper,IndGrd,
     &                  iuv,IfGrd,Index,iDCar,rf,IFG,tr)
      use Symmetry_Info, only: nIrrep, iChTbl, iChBas
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
c#include "print.fh"
      Real*8 ArrIn (nb,*),
     &       ArrOut(nb,*)
      Integer  lOper,
     &          IndGrd(3,4,0:nIrrep-1),iuv(3),Index(3,4),nOp(3)
      Logical   IfGrd(3,4),IFG(4),tr(4)
*
*     Statement function for Cartesian index
*
*
c     iRout = 200
c     iPrint = nPrint(iRout)
*
*--------Accumulate contributions
*
      iComp=0
      Do 102 iIrrep=0,nIrrep-1
        If (iAnd(lOper,2**iIrrep).ne.0) Then
          iComp=iComp+1
          Do 103 iCn=1,3
*           If (Index(idCar,iCn).ne.0) Then
            If ( (Indgrd(idCar,iCn,iIrrep).ne.0) .and.
     &         ( (index(idcar,icn).gt.0).or.tr(icn)))
     &      Then
*              Accumulate contribution to the gradient
               i1=0
               i2=0
               If (iCn.eq.1) Then
                   ps = DBLE( iPrmt( nOp(1), iChBas(1+idCar) ) )
                   Fact = rf*DBLE(iuv(1))/DBLE(nIrrep)
                   If (.not.tr(iCn)) Then
                    i1=Index(idCar,iCn)
                   Else
                    If (index(idcar,2).gt.0) i1=Index(idCar,2)
                    If (index(idCar,3).gt.0) i2=Index(idCar,3)
                    Fact=-Fact
                   End If
               Else If (iCn.eq.2) Then
                   ps=DBLE(iChTbl(iIrrep,nOp(2)))
                   ps = ps*DBLE( iPrmt( nOp(2), iChBas(1+idCar) ) )
                   Fact = rf*ps *
     &                    DBLE(iuv(2))/DBLE(nIrrep)
                   If (.not.tr(iCn)) Then
                    i1=Index(idCar,iCn)
                   Else
                    If (index(idcar,1).gt.0) i1=Index(idCar,1)
                    If (index(idCar,3).gt.0) i2=Index(idCar,3)
                    Fact=-Fact
                   End If
               Else
                   ps=DBLE(iChTbl(iIrrep,nOp(3)))
                   ps = ps*DBLE( iPrmt( nOp(3), iChBas(1+idCar) ) )
                   Fact = rf*ps *
     &                    DBLE(iuv(3))/DBLE(nIrrep)
                   If (.not.tr(iCn)) Then
                    i1=Index(idCar,iCn)
                   Else
                    If (index(idcar,1).gt.0) i1=Index(idCar,1)
                    If (index(idCar,2).gt.0) i2=Index(idCar,2)
                    Fact=-Fact
                   End If
               End if
            If (i1.ne.0)
     &          Call DaXpY_(nb,Fact,
     &                 ArrIn(1,i1),1,ArrOut(1,iComp),1)
            If (i2.ne.0)
     &          Call DaXpY_(nb,Fact,
     &                     ArrIn(1,i2),1,ArrOut(1,iComp),1)
           End If
 103  Continue
      End If
 102  Continue
*
*     Call GetMem(' Exit SymAdO','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical_array(IfGrd)
         Call Unused_logical_array(IFG)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Per-Olof Widmark                                 *
*               1993, Markus P. Fuelscher                              *
*               1995, Anders Bernhardsson                              *
************************************************************************
      Subroutine WrMCK(rc,Option,InLab,iComp,Data,iSymLab)
************************************************************************
*                                                                      *
*     Purpose: write data to one-electron integral file                *
*                                                                      *
*     Calling parameters:                                              *
*     rc      : Return code                                            *
*     Option  : Switch to set options                                  *
*     InLab   : Identifier for the data to write                       *
*     Comp    : Composite identifier to select components              *
*     Data    : contains on input the data to store on disk            *
*     SymLab  : symmetry label of the provided data                    *
*                                                                      *
*     Global data declarations (Include file):                         *
*     Parm    : Table of paramaters                                    *
*     rcParm  : Table of return codes                                  *
*     Switch  : Table of options                                       *
*     Common  : Common block containing TocOne                         *
*     Data    : Data definitions                                       *
*                                                                      *
*     Local data declarations:                                         *
*     Label   : character*8, used to covert incoming names             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark and M.P. Fuelscher                                  *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*     Modified by:                                                     *
*     Anders Bernhardsson                                              *
*     University of Lund, Sweden, 1995                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
#include "MckRc.fh"
#include "MckFlags.fh"
#include "SysDef.fh"
#include "MckDat.fh"
      Character*(*) InLab
      Dimension Data(*)
C     Real*8 DDot_, Check
C     external ddot_
*
      Logical Debug
C     Character*8 TmpLab,Label, Label_Add*11
      Character*8 TmpLab,Label
      Dimension LabTmp(2)
*     Equivalence (TmpLab,LabTmp)
      Character*16 TheName
      Data TheName/'WrMck'/
      Data Debug /.False./
*----------------------------------------------------------------------*
*     Start procedure:                                                 *
*     Define inline function (symmetry multiplication)                 *
*----------------------------------------------------------------------*
      MulTab(i,j)=iEor(i-1,j-1)+1
*----------------------------------------------------------------------*
*     Pick up the file definitions                                     *
*----------------------------------------------------------------------*
      SymLab=iSymLab
      icpi=itob
      Comp=iComp
      Length=rc
      rc    = rc0000
      LuMCK = AuxMCK(pLu  )
      Open  = AuxMCK(pOpen)
*----------------------------------------------------------------------*
*     Check the file status                                            *
*----------------------------------------------------------------------*
      If(Open.ne.1) Then
          Call SysFileMsg(TheName,'MSG: open',LuMck,' ')
      End If
*----------------------------------------------------------------------*
*     Truncate the label to 8 characters and convert it to upper case  *
*----------------------------------------------------------------------*
*     Call StdFmt(InLab,Label)
      Label=InLab
      Call UpCase(Label)
      TmpLab=Label
      Call ByteCopy(TmpLab,LabTmp,8)
*----------------------------------------------------------------------*
*     Print debugging information                                      *
*----------------------------------------------------------------------*
      If(iAnd(option,1024).ne.0) debug=.true.
      If(Debug) Then
         Write(6,*) '<<< Entering WrMck >>>'
         Write(6,'(a,z8)') ' rc on entry:     ',rc
         Write(6,'(a,a)')  ' Label on entry:  ',Label
         Write(6,'(a,z8)') ' Comp on entry:   ',Comp
         Write(6,'(a,z8)') ' SymLab on entry: ',SymLab
         Write(6,'(a,z8)') ' Option on entry: ',Option
         Write(6,*) ' Contents of the Toc'
         Write(6,*) ' ==================='
         Write (6,'(i6,z8)') 'pFID,TocOne(pFID)=',pFID,TocOne(pFID)
         Write (6,'(i6,z8)') pVersN,TocOne(pVersN)
         Write (6,'(i6,z8)') pTitle,TocOne(pTitle)
         Write (6,'(i6,z8)') pOp,TocOne(pOp)
         Write (6,'(i6,z8)') pSym,TocOne(pSym)
         Write (6,'(i6,z8)') pSymOp,TocOne(pSymOp)
         Write (6,'(i6,z8)') pBas,TocOne(pBas)
         Write (6,'(i6,z8)') pNext,TocOne(pNext)
         Write (6,'(i6,z8)') pEnd,TocOne(pEnd)
      End If
*----------------------------------------------------------------------*
*     Store data in TocOne                                             *
*----------------------------------------------------------------------*
*
      If(Label.eq.'TITLE') Then
*
         TocOne(pTitle)=NotNaN
         Call iCopy(nTitle,Data(1),1,TocOne(pTitle+1),1)
*----------------------------------------------------------------------*
*
      Else If(Label.eq.'NSYM') Then
*
         If(Data(1).gt.MxSym .or. Data(1).lt.1) Then
         Call SysWarnMsg(TheName,'Label=',Label)
         Call SysValueMsg('Data(1)=',Data(1))
         End If
         TocOne(pSym)=Data(1)
*----------------------------------------------------------------------*
*
      Else If(Label.eq.'NBAS') Then
*
         If(TocOne(pSym).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pSym)
         Call iCOPY(Len,Data,1,TocOne(pbas),1)
*----------------------------------------------------------------------*
*
      Else If (label.eq.'NISH') THEN
*
         If(TocOne(pSym).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pSym)
         Call iCOPY(Len,Data,1,TocOne(pISH),1)
*----------------------------------------------------------------------*
*
      Else If (label.eq.'NASH') THEN
*
         If(TocOne(pSym).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pSym)
         Call iCOPY(Len,Data,1,TocOne(pASH),1)
*----------------------------------------------------------------------*
*
      Else If (label.eq.'LDISP') THEN
*
         If(TocOne(pSym).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pSym)
         Call iCOPY(Len,Data,1,TocOne(pldisp),1)
*----------------------------------------------------------------------*
*
      Else If (label.eq.'TDISP') THEN
*
         If(TocOne(pndisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pndisp)
         Call iCOPY(Len,Data,1,TocOne(ptdisp),1)
*----------------------------------------------------------------------*
*
      Else If (label.eq.'NDISP') THEN
*
         ToCOne(pnDisp)=Data(1)
*----------------------------------------------------------------------*
*
      Else If (label.eq.'CHDISP') THEN
*
         If(TocOne(pndisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pndisp)*30/icpi+1
         Call iCOPY(Len,Data,1,TocOne(pchdisp),1)
*----------------------------------------------------------------------*
*
      Else If (label.eq.'NRCTDISP') THEN
*
         If(TocOne(pndisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pndisp)
         Call iCOPY(Len,Data,1,TocOne(pnrdisp),1)
*----------------------------------------------------------------------*
*
      Else If (label.eq.'DEGDISP ') THEN
*
         If(TocOne(pndisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=TocOne(pndisp)
         Call iCOPY(Len,Data,1,TocOne(pdegdisp),1)
*----------------------------------------------------------------------*
*
      Else If(Label.eq.'SYMOP') Then
*
         If (TocOne(pSym).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
         Len=(3*TocOne(pSym)+ItoB-1)/ItoB
         Call iCopy(Len,Data,1,TocOne(pSymOp),1)
*----------------------------------------------------------------------*
*
      Else If (label.eq.'PERT') Then
*
         Call icopy(16/icpi,Data,1,TocOne(pPert),1)
*----------------------------------------------------------------------*
      Else
*----------------------------------------------------------------------*
*     Store operators as individual records on disk                    *
*     Note: If the incoming operator has already been stored           *
*     previously (label, component and symmetry labels are identical)  *
*     it will replace the existing one.                                *
*----------------------------------------------------------------------*
         If ((label.eq.'STATHESS').or.
     &       (label.eq.'RESPHESS').or.
     &       (label.eq.'CONNHESS').or.
     &       (label.eq.'HESS').or.
     &       (label.eq.'NUCGRAD').or.
     &       (label.eq.'TWOGRAD')) Then
           Comp=1
           SymLab=1
         End If
*
         If(TocOne(pBas).eq.NaN) Then
            Call SysAbendMsg(TheName,'Undefined Label:',Label)
         End If
*
         k=0
         Do 500 i=MxOp,1,-1
#ifdef _I8_
            If(TocOne(pOp+LenOp*(i-1)+oLabel  ).eq.LabTmp(1) .and.
     &         TocOne(pOp+LenOp*(i-1)+oComp   ).eq.Comp  ) k=i
*     &    .and. TocOne(pOp+LenOp*(i-1)+oSymLb  ).eq.SymLab ) k=i
#else
            If(TocOne(pOp+LenOp*(i-1)+oLabel  ).eq.LabTmp(1) .and.
     &         TocOne(pOp+LenOp*(i-1)+oLabel+1).eq.LabTmp(2) .and.
     &         TocOne(pOp+LenOp*(i-1)+oComp   ).eq.Comp  ) k=i
*     &    .and.TocOne(pOp+LenOp*(i-1)+oSymLb  ).eq.SymLab) k=i
#endif
500      Continue
*
         iDisk=TocOne(pOp+LenOp*(k-1)+oAddr   )
         If (k.eq.0) Then
            Do 505 i=MxOp,1,-1
               If(TocOne(pOp+LenOp*(i-1)+oLabel).eq.NaN) k=i
505         Continue
            iDisk=TocOne(pNext)
            If (Debug) Then
               Write(6,*) ' This is a new field!'
               Write(6,*) ' iDisk=',iDisk
               Write(6,*) ' FldNo=',k
               Write(6,*) ' pNext=',pNext
            End If
         Else
            If(Debug) Then
               Write (6,*) ' This is an old field!'
               Write(6,*) ' iDisk=',iDisk
               Write(6,*) ' FldNo=',k
               Write(6,*) ' pNext=',pNext
            End If
         End If
         If(k.eq.0) Call SysAbendMsg(TheName,'Undefined Label:',Label)
C     Write(*,*) isymlab,label
*                                                                      *
************************************************************************
*                                                                      *
         If (Label.eq.'MOPERT') Then

            nA=0
            Do i=0,TocOne(psym)-1
               nA=TocOne(pAsh+i)+nA
            End Do
            Len=nA*(na+1)/2
            Len=len*(len+1)/2
C           write(*,*) len
*                                                                      *
************************************************************************
*                                                                      *
         Else If (label.eq.'NUCGRAD') Then
             Comp=1
             SymLab=1
             If(TocOne(pldisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
             End If
             Len=TocOne(pldisp)
*                                                                      *
************************************************************************
*                                                                      *
         Else If (label.eq.'TWOGRAD') Then
             Comp=1
             SymLab=1
             If(TocOne(pldisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
             End If
             Len=TocOne(pldisp)
*                                                                      *
************************************************************************
*                                                                      *
         Else If ((label.eq.'STATHESS').or.
     &            (label.eq.'RESPHESS').or.
     &            (label.eq.'CONNHESS').or.
     &            (label.eq.'HESS')) Then
             Comp=1
             SymLab=1
             If(TocOne(pndisp).eq.NaN) Then
         Call SysAbendMsg(TheName,'Undefined Label:',Label)
             End If
             Len=0
             Do iSym=0,TocOne(pSym)-1
               Len=Len+TocOne(pldisp+isym)*
     &                (TocOne(pldisp+isym)+1)/2
             End Do
*                                                                      *
************************************************************************
*                                                                      *
         Else If (label.eq.'INACTIVE') THEN
             Len=0
             Do iS=1,TocOne(pSym)
              Do jS=1,TocOne(pSym)
               ijS=MulTab(iS,jS)
               If(iAnd(2**(ijS-1),iSymLab).ne.0) Then
                 jBas=TocOne(pbas+jS-1)
                 iBas=TocOne(pbas+iS-1)
           If (jBas.eq.NaN)
     * Call SysAbendMsg(TheName,'jBas.eq.NaN at label',Label)
           If (iBas.eq.NaN)
     * Call SysAbendMsg(TheName,'iBas.eq.NaN at label',Label)
                 Len=len+iBas*jBas
               End If
              End Do
             End Do
*                                                                      *
************************************************************************
*                                                                      *
         Else If (label.eq.'TOTAL') THEN
             Len=0
             Do iS=1,TocOne(pSym)
              Do jS=1,TocOne(pSym)
               ijS=MulTab(iS,jS)
               If(iAnd(2**(ijS-1),iSymLab).ne.0) Then
                 jBas=TocOne(pbas+jS-1)
                 iBas=TocOne(pbas+iS-1)
           If (jBas.eq.NaN)
     * Call SysAbendMsg(TheName,'jBas.eq.NaN at label',Label)
           If (iBas.eq.NaN)
     * Call SysAbendMsg(TheName,'iBas.eq.NaN at label',Label)
                 Len=len+iBas*jBas
               End If
              End Do
             End Do
*                                                                      *
************************************************************************
*                                                                      *
         Else
             Len=0
             Do 510 i=1,TocOne(pSym)
              Do 511 j=1,i
               ij=MulTab(i,j)-1
               If(iAnd(2**ij,iSymLab).ne.0) Then
                If(i.eq.j) Then
                  Len=Len+TocOne(pBas-1+i)*(TocOne(pBas-1+i)+1)/2
                Else
                  Len=Len+TocOne(pBas-1+i)*TocOne(pBas-1+j)
                End If
               End If
511           Continue
510          Continue
             If (iAnd(Option,slength).ne.0) Len=Length
         End If
*                                                                      *
************************************************************************
*                                                                      *
         Len=rtoi*Len
         TocOne(pOp+LenOp*(k-1)+oLabel  )=LabTmp(1)
#ifndef _I8_
         TocOne(pOp+LenOp*(k-1)+oLabel+1)=LabTmp(2)
#endif
         TocOne(pOp+LenOp*(k-1)+oComp   )=Comp
         TocOne(pOp+LenOp*(k-1)+oSymLb  )=iSymLab
         TocOne(pOp+LenOp*(k-1)+oAddr   )=iDisk
C           write(*,*) leN,idisk,nauxdt
         Call iDAFile(LuMCK,1,Data,Len+nAuxDt,iDisk)
C         If (Label.eq.'TOTAL'    .or.
C     &       Label.eq.'INACTIVE' .or.
C     &       Label.eq.'MOPERT'       ) Then
CC            Write (*,*) 'iComp=',iComp
CC            Call RecPrt(Label,' ',Data,1,Len/RtoI)
C             Check=DDot_(Len/RtoI,Data,1,Data,1)
C             Label_Add=' '
C             Label_Add=Label
C             Write(Label_Add(9:11),'(I3.3)') iComp
C*            Write (*,*) Label_Add,Label,iComp,Check(1)
C             If (Label.eq.'TOTAL') Then
C                Call Add_Info(Label_Add,Check,1,6)
C             Else If (Label.eq.'INACTIVE') Then
C                Call Add_Info(Label_Add,Check,1,7)
C             Else
C                Call Add_Info(Label_Add,Check,1,1)
C             End If
C         End If
*        TocOne(pNext)=iDisk
         TocOne(pNext)=Max(TocOne(pNext),iDisk)
      End If
*----------------------------------------------------------------------*
*     Finally copy the TocOne back to disk                             *
*----------------------------------------------------------------------*
      iDisk=0
      Call iDaFile(LuMCK,1,TocOne,lToc,iDisk)
*----------------------------------------------------------------------*
*     Print debugging information                                      *
*----------------------------------------------------------------------*
      If(Debug) Then
         Write(6,*) '<<< Exiting WrMck >>>'
         Write(6,'(a,z8)') ' rc on exit:     ',rc
         Write(6,'(a,a)')  ' Label on exit:  ',Label
         Write(6,'(a,z8)') ' Comp on exit:   ',Comp
         Write(6,'(a,z8)') ' SymLab on exit: ',SymLab
         Write(6,'(a,z8)') ' Option on exit: ',Option
      End If
*----------------------------------------------------------------------*
*     Terminate procedure                                              *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************
!  StatusLine
!
!> @brief
!>   Update status file
!> @author V. Veryazov
!>
!> @details
!> Print parameters into status file. There is no
!> difference between params.
!>
!> \code
!> Call StatusLine(ModuleName,': just started')
!> \endcode
!>
!> @param[in] STR  Status
!> @param[in] STR1 Status
!***********************************************************************

subroutine StatusLine(STR,STR1)

#ifdef _MOLCAS_MPP_
use Para_Info, only: King
#endif
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: STR, STR1
integer(kind=iwp) :: Lu

#ifdef _MOLCAS_MPP_
if (.not. King()) return
#endif
Lu = 2
call molcas_open(Lu,'status')
write(Lu,'(A,A)') STR,STR1
close(Lu)

return

end subroutine StatusLine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_expand3(a,b,dimp,dimqr,dimq)
! expand a(p,qr) -> b(p,q,r)
! assumption: q>r, a(p,q,r)=-a(p,r,q)
! RISC version

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimqr, dimq
real(kind=wp), intent(in) :: a(dimp,dimqr)
real(kind=wp), intent(out) :: b(dimp,dimq,dimq)
integer(kind=iwp) :: q, qr

qr = 0
do q=1,dimq
  b(:,q,1:q-1) = a(:,qr+1:qr+q-1)
  b(:,1:q-1,q) = -a(:,qr+1:qr+q-1)
  qr = qr+q-1
  b(:,q,q) = Zero
end do

return

end subroutine cct3_expand3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine Start0x(CMO,mBB,nD,EOr,mmB)
************************************************************************
*                                                                      *
* This routine reads start orbitals generated by guessorb.             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*                                                                      *
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "mxdm.fh"
#include "infscf.fh"
*
      Real*8 CMO(mBB,nD), EOr(mmB,nD)
      Logical Found
*
*----------------------------------------------------------------------*
* Get start orbitals.                                                  *
*----------------------------------------------------------------------*
*
      iRC=0
      Call qpg_darray('Guessorb',Found,ndata)
      If (Found) Then
         If (nData.ne.mBB) Then
            Write (6,*) 'Start0x: nData.ne.mBB'
            Write (6,*) '         nData=',nData
            Write (6,*) '         mBB  =',mBB
            Call Abend()
         End If
         Call get_darray('Guessorb',CMO(1,1),ndata)
      Else
         iRC=-1
      End If
      If (iRC.ne.0) Then
         Write (6,*) 'Start0x: no orbitals found!'
         Call Abend()
      End If
*
      iRC=0
      Call qpg_darray('Guessorb energies',found,ndata)
      If (Found) Then
         If (nData.ne.mmB) Then
            Write (6,*) 'Start0x: nData.ne.mmB'
            Write (6,*) '         nData=',nData
            Write (6,*) '         mmB  =',mmB
            Call Abend()
         End If
         Call get_darray('Guessorb energies',EOr(1,1),ndata)
      Else
         iRC=-1
      End If
      If (iRC.ne.0) Then
         Write (6,*) 'Start0x: no energies found!'
         Call Abend()
      End If
*
      If (nD.eq.2) Then
         Call dCopy_(mBB,CMO(1,1),1,CMO(1,2),1)
         Call dCopy_(mmB,EOr(1,1),1,EOr(1,2),1)
      End If
*
      Call qpg_iarray('nDel_go',Found,ndata)
      nSum=0
      If (Found) Then
         Call Get_iArray('nDel_go',nDel,ndata)
         Call Put_iArray('nDel',nDel,ndata)
         Do iSym=1,nSym
            nSum=nSum+nDel(iSym)
         End Do
      End If
*
      If (nSum.gt.0) Then
         Do iSym=1,nSym
            nOrb(iSym)=nBas(iSym)-nDel(iSym)
         End Do
         Do iD = 1, nD
            Call TrimCMO(CMO(1,iD),CMO(1,iD),nSym,nBas,nOrb)
            Call TrimEor(EOr(1,iD),EOr(1,iD),nSym,nBas,nOrb)
         End Do
      End If
*
*----------------------------------------------------------------------*
* Done                                                                 *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993,1995, Jeppe Olsen                                 *
!***********************************************************************

subroutine NEWTYP(INSPGP,IACOP,ITPOP,OUTSPGP)
! an input  supergroup is given.
! apply an string of elementary operators to this supergroup and
! obtain supergroup mumber of new string
!
! Jeppe Olsen, October 1993
! GAS-version : July 95
!
! Input
! -----
!
! INSPGP  : input super group (given occupation in each AS)
! IACOP = 1 : operator is an annihilation operator
!       = 2 : operator is a creation operator
! ITPOP : orbitals space of operator
!
! Output
! ------
! OUTSPGP  : supergroup of resulting string

use lucia_data, only: NGAS, SPGPAN, SPGPCR
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: INSPGP, IACOP, ITPOP
integer(kind=iwp), intent(out) :: OUTSPGP

if (IACOP == 1) then
  OUTSPGP = SPGPAN(ITPOP+NGAS*(INSPGP-1))
else
  OUTSPGP = SPGPCR(ITPOP+NGAS*(INSPGP-1))
end if

end subroutine NEWTYP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine ChoLoc_xp(irc,Dens,CMO,Thrs,xNrm,nBas,nOcc,iD)
! Same as ChoLoc_p but handles differently the irc=102

use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nBas, nOcc
real(kind=wp), intent(inout) :: Dens(nBas,nBas)
real(kind=wp), intent(out) :: CMO(nBas,nOcc), xNrm
real(kind=wp), intent(in) :: Thrs
integer(kind=iwp), intent(inout) :: iD(nBas)
integer(kind=iwp) :: nVec
character(len=*), parameter :: SecNam = 'ChoLoc_xp'
real(kind=r8), external :: ddot_

irc = 0
xNrm = -huge(xNrm)

nVec = 0
call CD_InCore_p(Dens,nBas,CMO,nOcc,iD,nVec,Thrs,irc)
if (irc == 102) then
  irc = 0  ! reset because it is most likely a numerical noise
else if (irc /= 0) then
  write(u6,*) SecNam,': CD_InCore_p returned ',irc
  return
else if (nVec /= nOcc) then
  write(u6,*) SecNam,': nVec /= nOcc'
  write(u6,*) '   nVec,nOcc = ',nVec,nOcc
  irc = 1
  return
end if

xNrm = sqrt(dDot_(nBas*nOcc,CMO,1,CMO,1))

end subroutine ChoLoc_xp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mk_TInt_P(TInt_p,nTInt_p,TP,nTP,List2_p,nList2_p,mData,iAng,jAng,npk,List_TP)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nTInt_p, nTP, nList2_p, mData, List2_p(mData,nList2_p), iAng, jAng, npk
real(kind=wp), intent(in) :: TInt_p(nTInt_p,nTInt_p)
real(kind=wp), intent(out) :: TP(nTP,nTP)
integer(kind=iwp), intent(out) :: List_TP(2,nTP)
integer(kind=iwp) :: iA, iList2_p, iTP, jA, jList2_p, jTP, k, kAng, kComp, l, lAng, lComp, m, mAng, mComp, n, nAng, nComp

iA = iAng+1
jA = jAng+1
TP(:,:) = Zero
do iList2_p=1,nList2_p
  kAng = List2_p(1,iList2_p)
  lAng = List2_p(2,iList2_p)
  kComp = List2_p(3,iList2_p)
  lComp = List2_p(4,iList2_p)
  !write(u6,*) 'kComp,lComp=',kComp,lComp
  !if ((kAng == iAng) .and. (iAL(kComp,lComp) == 1) .and. (lAng == jAng) .and. (kComp == iA) .and. (lComp == jA)) then
  if ((kAng == iAng) .and. (lAng == jAng) .and. (kComp == iA) .and. (lComp == jA)) then

    k = List2_p(5,iList2_p)
    l = List2_p(6,iList2_p)
    if (iAng == jAng) then
      iTP = nTri_Elem(k-1)+l
    else
      iTP = (l-1)*npk+k
    end if
    List_TP(1,iTP) = k
    List_TP(2,iTP) = l

    do jList2_p=1,nList2_p
      mAng = List2_p(1,jList2_p)
      nAng = List2_p(2,jList2_p)
      mComp = List2_p(3,jList2_p)
      nComp = List2_p(4,jList2_p)
      !write(u6,*) 'mComp,nComp=',mComp,nComp
      !if ((mAng == iAng) .and. (iAL(mComp,nComp) == 1) .and. (nAng == jAng) .and. (mComp == iA) .and. (nComp == jA)) then
      if ((mAng == iAng) .and. (nAng == jAng) .and. (mComp == iA) .and. (nComp == jA)) then

        m = List2_p(5,jList2_p)
        n = List2_p(6,jList2_p)
        if (iAng == jAng) then
          jTP = nTri_Elem(m-1)+n
        else
          jTP = (n-1)*npk+m
        end if

        TP(iTP,jTP) = TP(iTP,jTP)+TInt_P(iList2_p,jList2_p)
        !TP(iTP,jTP) = TP(iTP,jTP)+abs(TInt_P(iList2_p,jList2_p))

      end if

    end do

  end if
end do

return

end subroutine Mk_TInt_P

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
cmp!      SUBROUTINE klvaa_oovo(G,ix,it,ig,iscr,vblock,N,nug,
cmpn      SUBROUTINE klvaa_oovo(ix,it,ig,iscr,vblock,N,nug,
      SUBROUTINE klvaa_oovo(ix,ig,iscr,vblock,N,nug,
     $ LU,last,ias)
C
C  creates L(alpha>alpha,alpha-alpha)
C  DA files LMATICH(ISP)ICH(ISP)
C  max G at this place
C
C  parallelization (seems to be) irrelevant at the moment
C  implemented integer offsets, PV, 14 may 2004.
C
      IMPLICIT NONE
#include "ndisk.fh"
#include "dupfiles.fh"
cmp
#include "cht3_ccsd1.fh"
#include "ccsd_t3compat.fh"
#include "WrkSpc.fh"
cmpn
#include "cht3_reord.fh"
        integer i_blk,j_blk,b2_chk
        integer ngaf,ngal,ngbf,ngbl
        integer nind_ngbf,nind_ngbl,nind_ngaf,nind_ngal
        integer length,length1,length2
        integer it_exp,it2_tmp,itmp2
        integer ngaa,a_tmp,b1_tmp
        integer j_tmp,RAD_tmp
cmp
c       integer jjj
cmp
cmpn
cmp
cmp      real*8 G(*),ddot_,one
      real*8 one
c     real*8 ddot_
      parameter (one=1.d0)
      integer ix,ig,iscr, KADT, IJS, RAD, AADT
      integer isp,ias,vblock,n,i,j,k,lu,iasblock
      INTEGER A,A1,A2,B1,B2,NSTEP,ADIM,NUG,NGA,NGB,R,MAXDIM2
      INTEGER IADT,ISTEP,IS2,KI,BADT, last,indab
      CHARACTER FN*6,ich*1
      INTEGER IOPT,NOAB,NNOAB,NUAB,NNUAB,nno
c     INTEGER m
cmp
        integer il1,itmp,il2
cmp
      COMMON/UHF/NOAB(2),NNOAB(3),NUAB(2),NNUAB(3),ICH(3)
      COMMON/IOIND/IOPT(96)
      indab(i,j)=(max(i,j)-1)*max(i,j)/2+min(i,j)
c
C
cmp      write(6,*) 'Entering klvaa_oovo'
C
      ISP=1
      iasblock=NNOAB(ISP)*vblock*N/nblock
      if((iasblock*nblock).lt.(NNOAB(ISP)*vblock*N))iasblock=iasblock+1
      nno=(noab(isp)+1)*noab(isp)/2
      !!call w_alloc(ix,nnoab(ISP)*vblock*n,'IX klvaao ')
      !!call w_alloc(ig,noab(isp)*nuab(isp)*nnoab(isp),'IG klvaao')
      !!call w_alloc(iscr,nuab(isp)*nuab(isp)*nnoab(isp),'ISCR klvaao')
      !FN(1:5)='OOVOI'
      !FN(6:6)=ICH(ISP)
      !!CALL GET3DM(FN,G(ig),NUAB(ISP)*NOAB(ISP),NNOAB(ISP),0)
C
C      call EXPA1_UHF(G(IT),nnoab(isp),NUAB(ISP),-1,G(ISCR))
C       expa done here. remains in it address
cmpn      IJS=IT
cmpn       do i=2,noab(isp)
cmpn       do j=1,i-1
cmpn       KADT=IT+(i-1)*noab(isp)*nnuab(3)+(j-1)*nnuab(3)
cmpn       !!call dcopy_(NNUAB(3),G(KADT),1,G(IJS),1)
cmpncmp!       call vneg_cht3(G(KADT),1,G(IJS),1,NNUAB(3))
cmpn       call vneg_cht3(Work(KADT),1,Work(IJS),1,NNUAB(3))
cmpncmp!       CALL TRANSM_A(G(KADT),G(IJS),NUAB(ISP),NUAB(ISP))
cmpn       CALL TRANSM_A(Work(KADT),Work(IJS),NUAB(ISP),NUAB(ISP))
cmpn       IJS=IJS+NNUAB(3)
cmpn       enddo ! j
cmpn       enddo ! i
c
      IAS=1
        ngaa=0
cmpn
      do A1=1,NUAB(ISP),vblock
C  not needed    call zeroma(g(ix),1,nnoab(isp)*vblock*n)
         adim=min(vblock,nuab(isp)-A1+1)
         A2=A1+adim-1
cmpn
        ngaa=ngaa+1
c
cmp        write (6,*)
cmp        write (6,*) '================================='
cmp        write (6,*) ' nga ',ngaa
cmp        write (6,*) '================================='
cmp        write (6,*)
c
cmp        write (6,'(A,2(i5,2x))') 'b1,b2 = ',a1,a2
c
        call block_interf(1,1,a1,a2,
     &   ngaf,ngal,nind_ngaf,nind_ngal,
     &   ngbf,ngbl,nind_ngbf,nind_ngbl)
c
cmp        write (6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',
cmp     & ngbf,ngbl,nind_ngbf,nind_ngbl
c
c - read amplitudes T2(nv,vblock,j<i)
c
c - calculate memory requirements
c
        length1=nuab(isp)
c
          length2=0
        do i_blk=ngbf,ngbl
          length2=length2+DimGrpaR(i_blk)
        end do
c
cmp        write (6,*) 'length1, NUAB   = ',length1,NUAB(1)
cmp        write (6,*) 'length2, vblock = ',length2,vblock
c
        length=length1*length2*(((no-1)*no)/2)
cmp        write (6,*) 'length for blocked T2 amplitudes = ',length
c
c - setup memory
c
cmp        write (6,*) 'allocating t2_exp = ',length
        call GetMem('it4_exp','Allo','Real',it_exp,length)
c
c - read pertinent files and store them in the new blocked structure
c
        call GetMem('it2_tmp','Allo','Real',it2_tmp,
     & maxdim*maxdim*no*no)
        call GetMem('itmp2','Allo','Real',itmp2,
     & maxdim*maxdim*no*no)
c
        call gather_t2anti_blocked(length1,length2,
     & ngaf,ngal,ngbf,ngbl,
     & Work(it_exp),Work(it2_tmp),Work(itmp2))
c
        call GetMem('itmp2','Free','Real',itmp2,
     & maxdim*maxdim*no*no)
        call GetMem('it2_tmp','Free','Real',it2_tmp,
     & maxdim*maxdim*no*no)

cmpn
C     copies oovo
C  oovo (k>l,ai)
           K=0
           do I=2,NOAB(ISP)
           do J=1,I-1
           K=K+1
         !!do K=1,NNOAB(ISP)
            IJS=IX+(K-1)*adim*n
            !!KADT=(a1-1)*noab(isp)+IG+(K-1)*noab(isp)*nuab(isp)
            do a=A1,A2
            KADT=(J-1)*nno*nuab(isp)+(A-1)*nno + IG -1
            do r=1,noab(isp)
C    <ra|ij>
cmp            G(IJS+r-1)=G(KADT+indab(r,i))
            Work(IJS+r-1)=Work(KADT+indab(r,i))
            enddo
            KADT=(I-1)*nno*nuab(isp)+(A-1)*nno + IG -1
            do r=1,noab(isp)
C    -<ra|ji>
cmp            G(IJS+r-1)=G(IJS+r-1)-G(KADT+indab(r,j))
            Work(IJS+r-1)=Work(IJS+r-1)-Work(KADT+indab(r,j))
            enddo
!!               call dcopy_(noab(isp),G(KADT),1,G(IJS),1)
               IJS=IJS+N
!!               KADT=KADT+noab(isp)
            enddo
C now the T2
cmpn
            !!KADT=ISCR+(K-1)*NUAB(ISP)*NUAB(ISP) +(A1-1)*NUAB(ISP)
cmp            KADT=IT+(K-1)*NUAB(ISP)*NUAB(ISP) +(A1-1)*NUAB(ISP)
            IJS=NOAB(ISP)+IX+(K-1)*adim*n
c
        a_tmp=a1-nind_ngbf
cmp        write (6,*) 'K, a1, a_tmp',k,a1,a_tmp
c
        KADT=it_exp+(K-1)*NUAB(ISP)*length2
     & +(a_tmp-1)*NUAB(ISP)
c
            do a=A1,A2
cmp               call dcopy_(NUAB(isp),G(KADT),1,G(IJS),1)
               call dcopy_(NUAB(isp),Work(KADT),1,Work(IJS),1)
cmp        write (6,*) (Work(KADT+a_tmp),a_tmp=0,NUAB(isp)-1)
      !!write(6,'(A,2I3,11D10.4)')'OT',K,a,(G(r),r=IJS-noab(isp)
     !!$,IJS+nuab(isp)-1)
c
               KADT=KADT+NUAB(ISP)
               IJS=IJS+N
            enddo               !A
            enddo               !J
            enddo               !I
         !!enddo                  ! K
       !!write(6,'(A,2I5,4x,5D15.10)')
     !!$'block-m:a1,IAS,ddot',a1,ias,
     !!$ddot_(N*adim*nnoab(ISP),G(IX),1,g(ix),1),(G(I),I=IX,IX+3)
cmp         call multi_wridir(G(IX),n*adim*nnoab(isp),LU,IAS, last)
cmp
cmpn        do jjj=0,n*adim*nnoab(isp)-1
cmpn        if (abs(Work(ix+jjj)).gt.10000) then
cmpn          write (*,*) 'fucko 2'
cmpn          write (*,*) jjj,Work(ix+jjj)
cmpn          stop
cmpn        end if
cmpn        end do
cmp
         call multi_wridir(Work(IX),n*adim*nnoab(isp),LU,IAS, last)
         IAS=IAS+iasblock
c
cmp
        call GetMem('it4_exp','Free','Real',it_exp,length)
cmp
      enddo                     ! A1
cmp        write (6,*) 'cast 1 ok'
cmpn

      IS2=3-ISP
C  lmat
cmp! Mozes odjbt ix, iscr, ig
cmp        write (6,*) 'test 2 na iscr ',vblock*noab(1)*noab(1)
cmp        write (6,*) 'test 2 na ig ',noab(1)*nuab(1)*nno
cmp        write (6,*) 'test 2 na ix ',noab(1)*noab(1)*vblock*n
cmp        write (6,*) 'nno (2) = ',nno
        call GetMem('c2_iscr','Free','Real',iscr,
     & vblock*noab(1)*noab(1))
        call GetMem('c2_ig','Free','Real',ig,
     & noab(1)*nuab(1)*nno)
       call GetMem('c2_ix','Free','Real',ix,
     & noab(1)*noab(1)*vblock*n)
cmp        write (*,*) 'n (2) = ',n
cmp      call w_memchk('IX klvaa ')
cmp      call w_free(g(ix),0,'klvaaix')
cmp      call w_alloc(ix,nnoab(isp)*vblock*vblock,'Ix klvaa-v')
cmp
       call GetMem('klv_oo_ix','Allo','Real',ix,
     & nnoab(isp)*vblock*vblock)
cmp
C starts <aa||oo> integrals
      FN(1:5)='VVOOI'
      !!FN(6:6)=ich(isp)
      FN(6:6)=ich(3)
cmp!      CALL GET3DM(FN,G(it),NNUAB(3),NNOAB(3),0)
cmp
cmp!        call w_alloc(il1,nc*no*maxdim,'IL1 klvaa-v')
cmpn       call GetMem('klv_oo_il1','Allo','Real',il1,
cmpn     & nc*no*maxdim)
cmp!        call w_alloc(itmp,
cmp!     & max(nc*no*maxdim,maxdim*maxdim*no*no),'IL2 klvaa-v')
cmpn       call GetMem('klv_oo_itmp','Allo','Real',itmp,
cmpn     & max(nc*no*maxdim,maxdim*maxdim*no*no))
cmp!        call w_alloc(il2,
cmp!     & max(nc*no*maxdim,maxdim*maxdim*no*no),'IL2 klvaa-v')
cmpn       call GetMem('klv_oo_il2','Allo','Real',il2,
cmpn     & max(nc*no*maxdim,maxdim*maxdim*no*no))
c
cmp!        call gen_vvoo(G(it),G(il1),G(itmp),G(il2))
cmpn        call gen_vvoo(Work(it),Work(il1),Work(itmp),Work(il2))

cmp!        open (unit=36,file='vvoo_moje')
cmp!        do i=0,NNUAB(3)*NNOAB(3)-1
cmp!        if (abs(G(it+i)).lt.1.0d-7) G(it+i)=0.0d0
cmp!        write (36,*) i,G(it+i)
cmp!        end do
cmp!        close (36)
c
cmp!        call w_free(G(il1),0,'IL1 klvaa-v')
cmpn       call GetMem('klv_oo_il2','Free','Real',il2,
cmpn     & max(nc*no*maxdim,maxdim*maxdim*no*no))
cmpn       call GetMem('klv_oo_itmp','Free','Real',itmp,
cmpn     & max(nc*no*maxdim,maxdim*maxdim*no*no))
cmpn       call GetMem('klv_oo_il1','Free','Real',il1,
cmpn     & nc*no*maxdim)

cmp        write(6,*)ddot_(nnoab(3)*nnuab(3),G(it),1,G(it),1)

cmp
      !!call dscal_(NNUAB(3)*NNOAB(3),-1.d0,G(it),1)
      !!call dscal_(NNUAB(isp)*NNOAB(ISP),-1.d0,G(it),1)
C
C number of blocks written in a single multiwrite
C
      iasblock=vblock*vblock*nnoab(isp)/nblock
      if((iasblock*nblock).lt.(vblock*vblock*nnoab(isp)))
     $     iasblock=iasblock+1
!!      write(6,*)'create_aa vvoo   iasblock',iasblock
C
!!      FN(1:4)='VMAT'
!!      FN(6:6)=ich(isp)
!!      FN(5:5)=ich(isp)
!!      call multi_opendir(FN,LU)
C currently using 3-dim (big field) - will be replaced after changing
C stepiv and the rest
      do nga=1,nug
         A1=(nga-1)*vblock+1
         adim=min(vblock,nuab(isp)-A1+1)
         A2=A1+adim-1
         do ngb=1,nga
            if(nga.eq.ngb)then
               maxdim2=adim*(adim-1)/2
            else
               maxdim2=adim*vblock
            endif
            B1=(ngb-1)*vblock+1
cmpn
cmp        write (6,*)
cmp        write (6,*) '================================='
cmp        write (6,*) ' nga, ngb',nga,ngb
cmp        write (6,*) '================================='
cmp        write (6,*)
c
cmpn
c - check the largest b2
c
cmp        b2_chk=b1-1+min(vblock,a2-b1)
cmpn        b2_chk=b1-1+vblock
        b2_chk=b1+min(vblock,nuab(isp)-b1+1)-1
c
c - find out which T2 blocked files will be needed
c   for particular nga, ngb
c
cmp        write (6,'(A,4(i5,2x))') 'a1,a2,b1,b2_chk = ',a1,a2,b1,b2_chk
c
        call block_interf(a1,a2,b1,b2_chk,
     &   ngaf,ngal,nind_ngaf,nind_ngal,
     &   ngbf,ngbl,nind_ngbf,nind_ngbl)
c
cmp        write (6,'(A,4(i5,2x))') 'ngaf, ngal, nind_ngaf, nind_ngal',
cmp     & ngaf,ngal,nind_ngaf,nind_ngal
cmp        write (6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',
cmp     & ngbf,ngbl,nind_ngbf,nind_ngbl
c
c - read amplitudes from T2_ngaf_ngbf ...  T2_ngaf_ngbl, nga>=ngb
c                           ....               ....
c                        T2ngal_ngbf  ...  T2_ngal_ngbl, nga>=ngb
c
c - calculate memory requirements (consider squared T2(a',a'))
c
          length1=0
        do i_blk=ngaf,ngal
          length1=length1+DimGrpaR(i_blk)
        end do
c
          length2=0
        do j_blk=ngbf,ngbl
          length2=length2+DimGrpaR(j_blk)
        end do
c
cmp        write (6,*) 'length1, vblock = ',length1,vblock
cmp        write (6,*) 'length2, vblock = ',length2,vblock
c
        length=length1*length2*no*no
cmp        write (6,*) 'length for blocked VVOO integrals = ',length
c
c - setup memory
c
cmp        write (6,*) 'allocating t2_exp = ',length
        call GetMem('it5_exp','Allo','Real',it_exp,length)
c
c - read pertinent files and generate block of vvoo integrals
c
       call GetMem('vvooil1','Allo','Real',il1,
     & nc*no*maxdim)
       call GetMem('vvooitmp','Allo','Real',itmp,
     & max(nc*no*maxdim,maxdim*maxdim*no*no))
       call GetMem('vvooil2','Allo','Real',il2,
     & max(nc*no*maxdim,maxdim*maxdim*no*no))
cmp
        call gen_vvoo_blocked(Work(it_exp),Work(il1),
     & Work(itmp),Work(il2),
     & length1,length2,ngaf,ngal,ngbf,ngbl)
cmp
       call GetMem('vvooil2','Free','Real',il2,
     & max(nc*no*maxdim,maxdim*maxdim*no*no))
       call GetMem('vvooitmp','Free','Real',itmp,
     & max(nc*no*maxdim,maxdim*maxdim*no*no))
       call GetMem('vvooil1','Free','Real',il1,
     & nc*no*maxdim)
cmpn
            do a=a1,a2
               B2=B1-1+min(vblock,A-B1)
               NSTEP=B2-B1+1
               if(nstep.ne.0)then
                  if(nga.eq.ngb)then
                     IJS=(a-a1-1)*(a-a1)/2+IX
                  else
                     IJS=(a-a1)*vblock+IX
                  endif
                  R=0
                  do I=2,NOAB(ISP)
                  do J=1,I-1
                   !!R=R+1
                  !!do R=1,NNOAB(ISP)
                     !!KADT=(R-1)*NNUAB(ISP)
cmpn                  R=(J-1)*noab(isp)+I
cmpn                     KADT=(R-1)*NNUAB(3)
cmpn                     KADT=KADT+(a-1)*NUAB(ISP) +B1 +IT -1
c
        a_tmp=a-nind_ngaf
        b1_tmp=b1-nind_ngbf
c
cmp        write (6,'(A,5(i4,x))') 'a,b1,I,J,nstep ',a,b1,I,J,nstep
cmp        write (6,'(A,5(i4,x))') 'a_tmp,b1_tmp   ',a_tmp,b1_tmp
        do j_tmp=0,nstep-1
c
          KADT=(i-1)*noab(isp)*length1*length2+
     & (j-1)*length1*length2+(b1_tmp+j_tmp-1)*length1+
     & a_tmp+it_exp-1
c
        Work(IJS+j_tmp)=Work(KADT)
c
        end do
c
C address and block for the A1-A2x B1-B2
                     !!KADT=KADT+(a-1)*(a-2)/2 +B1 +IT -1
C    VO >>> G(IX)
cmpn                     call dcopy_(NSTEP,Work(KADT),1,Work(IJS),1)
cmpn                  R=(I-1)*noab(isp)+J
cmpn                     KADT=(R-1)*NNUAB(3)
cmpn                     KADT=KADT+(a-1)*NUAB(ISP) +B1 +IT -1
        do j_tmp=0,nstep-1
c
        KADT=(j-1)*noab(isp)*length1*length2+
     & (i-1)*length1*length2+(b1_tmp+j_tmp-1)*length1+
     & a_tmp+it_exp-1
c
        Work(IJS+j_tmp)=Work(IJS+j_tmp)-1.0d0*Work(KADT)
c
        end do
cmpn
cmpn                     call daxpy_(NSTEP,-1.d0,Work(KADT),1,Work(IJS),1)
       !!write(6,'(A,2I3,8D15.8)')'T',(I-1)*(I-2)/2+j
     !!$,a,(G(r),r=IJS,IJS+NSTEP-1)
                     IJS=IJS+maxdim2
                  enddo         ! RI
                  enddo         ! RJ
               endif
            enddo               ! a1
      !!write(6,'(A,4I5,4x,5D15.10)')
     !!$'block-m: a1,b1,IAS,ddot',a1,b1,ias,maxdim2,
     !!$ ddot_(nnoab(isp)*maxdim2,G(IX),1,G(IX),1),(G(I),I=IX,IX+3)
            IF(maxdim2.eq.0)then
               maxdim2=1
            endif
cmp            call multi_wridir(G(IX),nnoab(isp)*maxdim2,LU,IAS, last)
cmp
cmpn        do jjj=0,nnoab(isp)*maxdim2-1
cmpn        if (abs(Work(ix+jjj)).gt.10000) then
cmpn          write (*,*) 'fucko 3'
cmpn          write (*,*) jjj,Work(ix+jjj)
cmpn          stop
cmpn        end if
cmpn        end do
cmp
            call multi_wridir(Work(IX),nnoab(isp)*maxdim2,LU,IAS, last)
            ias=ias+iasblock
c
cmp        write (6,*) 'deallocating t2_exp = ',length
        call GetMem('it5_exp','Free','Real',it_exp,length)
c
         enddo                  ! ngb
      enddo                     ! nga
cmp        write (6,*) 'cast 2 ok'
cmp      call w_memchk('all klvaa ')
cmp      call w_free(g(ix),0,'klvaa ')
cmp
        call GetMem('klv_oo_ix','Free','Real',ix,
     & nnoab(isp)*vblock*vblock)
cmp
      !!call w_free(g(it),0,'klvaa ')
cmp      call w_alloc(ix,nnoab(3)*vblock*vblock,'ix-vvoo')
cmp
        call GetMem('klv_oo_ix','Allo','Real',ix,
     & nnoab(3)*vblock*vblock)
cmp
      !!call w_alloc(ig,nnoab(3)*nnuab(3),'ig-vvoo')
cmpn       ig=it
C   from now on as for uhf
      iasblock=nnoab(3)*vblock*vblock/nblock
      if((iasblock*nblock).lt.(nnoab(3)*(vblock**2)))iasblock=iasblock+1
!!      FN(1:5)='VVOOI'
!!      FN(6:6)=ICH(3)
!!      CALL GET3DM(FN,G(IG),NNUAB(3),NNOAB(3),0)
C   (c>d|AK)

cmpn
        nga=0
cmpn
      DO A1=1,NUAB(ISP),vblock
         A2=A1+min(vblock,nuab(isp)-A1+1)-1
         adim=A2-A1+1
cmpn
        nga=nga+1
        ngb=0
cmpn
         do B1=1,NUAB(IS2),vblock
cmpn
        ngb=ngb+1
cmpn
            NSTEP=min(vblock,nuab(is2)-B1+1)
cmpn
cmpn
cmp        write (6,*)
cmp        write (6,*) '================================='
cmp        write (6,*) ' nga, ngb',nga,ngb
cmp        write (6,*) '================================='
cmp        write (6,*)
c
c - check the largest b2
c
cmp        b2_chk=b1-1+min(vblock,nuab(is2)-B1+1)
cmpn        b2_chk=b1-1+vblock
        b2_chk=b1+min(vblock,nuab(is2)-B1+1)-1
c
c - find out which T2 blocked files will be needed
c   for particular nga, ngb
c
cmp        write (6,'(A,4(i5,2x))') 'a1,a2,b1,b2_chk = ',a1,a2,b1,b2_chk
c
        if (nga.lt.ngb) then
cmp        write (6,*) 'switching nga, ngb',ngb,nga
c
        call block_interf(b1,b2_chk,a1,a2,
     &   ngaf,ngal,nind_ngaf,nind_ngal,
     &   ngbf,ngbl,nind_ngbf,nind_ngbl)
c
        else
c
        call block_interf(a1,a2,b1,b2_chk,
     &   ngaf,ngal,nind_ngaf,nind_ngal,
     &   ngbf,ngbl,nind_ngbf,nind_ngbl)
c
        end if
c
cmp        write (6,'(A,4(i5,2x))') 'ngaf, ngal, nind_ngaf, nind_ngal',
cmp     & ngaf,ngal,nind_ngaf,nind_ngal
cmp        write (6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',
cmp     & ngbf,ngbl,nind_ngbf,nind_ngbl
c
c - read amplitudes from T2_ngaf_ngbf ...  T2_ngaf_ngbl, nga>=ngb
c                           ....               ....
c                        T2ngal_ngbf  ...  T2_ngal_ngbl, nga>=ngb
c
c - calculate memory requirements (consider squared T2(a',a'))
c
          length1=0
        do i_blk=ngaf,ngal
          length1=length1+DimGrpaR(i_blk)
        end do
c
          length2=0
        do j_blk=ngbf,ngbl
          length2=length2+DimGrpaR(j_blk)
        end do
c
cmp        write (6,*) 'length1, vblock = ',length1,vblock
cmp        write (6,*) 'length2, vblock = ',length2,vblock
c
        length=length1*length2*no*no
cmp        write (6,*) 'length for blocked VVOO integrals = ',length
c
c - setup memory
c
cmp        write (6,*) 'allocating t2_exp = ',length
        call GetMem('it6_exp','Allo','Real',it_exp,length)
c
c - read pertinent files and generate block of vvoo integrals
c
       call GetMem('vvooil1','Allo','Real',il1,
     & nc*no*maxdim)
       call GetMem('vvooitmp','Allo','Real',itmp,
     & max(nc*no*maxdim,maxdim*maxdim*no*no))
       call GetMem('vvooil2','Allo','Real',il2,
     & max(nc*no*maxdim,maxdim*maxdim*no*no))
cmp
        call gen_vvoo_blocked(Work(it_exp),Work(il1),
     & Work(itmp),Work(il2),
     & length1,length2,ngaf,ngal,ngbf,ngbl)
cmp
       call GetMem('vvooil2','Free','Real',il2,
     & max(nc*no*maxdim,maxdim*maxdim*no*no))
       call GetMem('vvooitmp','Free','Real',itmp,
     & max(nc*no*maxdim,maxdim*maxdim*no*no))
       call GetMem('vvooil1','Free','Real',il1,
     & nc*no*maxdim)
cmpn
!!    bdim=NSTEP
C  mv T2(B,A,I,K) >> G(ix)
            KI=0
            do K=1,noab(isp)
               KADT=(K-1)*NNUAB(3)*(NOAB(2)*(2-ISP)+ISP-1)
               DO I=1,NOAB(IS2)
                  KI=KI+1
                  IADT=(I-1)*NNUAB(3)*(NOAB(2)*(2-IS2)+IS2-1)
                  BADT=(2-ISP)*B1+(ISP-1)*(B1-1)*NUAB(2)
                  do A=A1,A2
cmpn
        if (nga.lt.ngb) then
          a_tmp=a-nind_ngbf
          b1_tmp=b1-nind_ngaf
        else
          a_tmp=a-nind_ngaf
          b1_tmp=b1-nind_ngbf
        end if
cmpn
cmpn                     AADT=IADT+KADT+BADT+A*(ISP-1)+(2-ISP)
cmpn     $                    *(A-1)*NUAB(2)+IG-1
C  T2 <A,B,J,K> for isp=1 T2 <B,A,K,J> for isp=2
!!
                     RAD=(KI-1)*adim*nstep+(A-A1)*nstep +IX
                     ISTEP=(ISP-1)*NUAB(2)+2-ISP
cmpn
        if (nga.ge.ngb) then ! nga> ngb

cmp        write (6,'(A,4(i5,2x),3x,i5)') '(I)  a_tmp,b1_tmp,k,i  nstep = ',
cmp     & a_tmp,b1_tmp,k,i,nstep
c T2(B1,A,I,K) =? T2(A,B1,K,I)
          do j_tmp=0,NSTEP-1  ! istep je 1 ak dobre tusim
c
          AADT=(I-1)*length1*length2*NOAB(2)+(K-1)*length1*length2+
     &   (b1_tmp-1+j_tmp)*length1+a_tmp+it_exp-1
c
          RAD_tmp=RAD+j_tmp
c
          Work(RAD_tmp)=Work(AADT)
c
          end do
c
        else ! nga < ngb
c
cmp        write (6,'(A,4(i5,2x),3x,i5)') '(II) b1_tmp,a_tmp,k,i   nstep = ',
cmp     & b1_tmp,a_tmp,i,k,nstep
c T2(B1,A,I,K)
          do j_tmp=0,NSTEP-1  ! istep je 1 ak dobre tusim
c
          AADT=(k-1)*length1*length2*NOAB(2)+(i-1)*length1*length2+
     &   (a_tmp-1)*length1+b1_tmp+j_tmp+it_exp-1
c
          RAD_tmp=RAD+j_tmp
c
          Work(RAD_tmp)=Work(AADT)
c
          end do
        end if
cmpn
cmpn                     call dcopy_(NSTEP,Work(AADT),ISTEP,Work(RAD),1)

                  enddo         ! A
               enddo            ! I
            enddo               ! K
      !!write(6,'(A,3I5,4x,5D15.10)')
     !!$'block-v: a1,b1,IAS,ddot',a1/vblock+1,b1/vblock+1,ias,
     !!$ ddot_(NNOAB(3)*adim*nstep,G(IX),1,G(IX),1),(G(I),I=IX,IX+3)
cmp            call multi_wridir(G(IX),NNOAB(3)*adim*nstep,LU,IAS, last)
cmp
cmpn        do jjj=0,NNOAB(3)*adim*nstep-1
cmpn        if (abs(Work(ix+jjj)).gt.10000) then
cmpn          write (*,*) 'fucko 1'
cmpn          write (*,*) jjj,Work(ix+jjj)
cmpn          stop
cmpn        end if
cmpn        end do
cmp
            call multi_wridir(Work(IX),NNOAB(3)*adim*nstep,LU,IAS, last)
            ias=ias+iasblock
cmpn
        call GetMem('it6_exp','Free','Real',it_exp,length)
cmpn
         enddo                  ! B1
      enddo                     ! A1
cmp        write (6,*) 'cast 3 ok'
      !!close (LU)   in calling routine
!     write(6,*) FN, isp, IAS
      !!dupblk(ndup)=last   in calling routine
cmp      call w_memchk('all klvaa ')
      !!call w_free(g(ix),0,'IT klvaa ')   in calling routine
cmp
        call GetMem('klv_oo_ix','Free','Real',ix,
     & nnoab(3)*vblock*vblock)
cmp
cmpn
        if (printkey.gt.1) then
           write (6,*) 'VVOO integrals regenerated from MOLCAS'
        end if

cmpn
      call xflush(6)
      !!stop
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MLTR1 (IMLTOP,LST1,X,F,Y)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(*),F(*),Y(*)
      DIMENSION LST1(4,NLST1)
#include "sigma.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#endif

C Given a lists with entries LST1(4,ITEM), ITEM=1,NLST1, the
C four entries called L1,L2,L3,L4 for short, for a given
C item, and with V=VAL1(L4),
C compute the Rank-1 updates, if IMLTOP=0,
C X(L1,p,q):= Add V*F(L2,p)*Y(L3,q), p=1..LEN1, q=1..LEN2
C else, the conjugate expression
C Y(L3,q):= Add V*F(L2,p)*X(L1,p,q), p=1..LEN1, q=1..LEN2
C or for IMLTOP=2, compute
C     F(L2,p) := Add V*X(L1,p,q)*Y(L3,q)
C However, strides etc can vary from case to case: The indices
C may appear in 1st, 2nd or 3rd position, Fortran-address-wise,
C thus an independent stride is to be given for each of the
C indices in the above 'formal' index ordering, as follows:
C The formal Y(p,q,r) is accessed as
C Y(1+INCX1*(p-1)+INCX2*(q-1)+INCX3*(r-1)), etc.

CSVC: determine outer loop properties
#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        ILST1_IOFF=MYRANK+1
        ILST1_SKIP=NPROCS
      ELSE
        ILST1_IOFF=1
        ILST1_SKIP=1
      ENDIF
#else
      ILST1_IOFF=1
      ILST1_SKIP=1
#endif

      IF(IMLTOP.EQ.0) THEN
        DO ILST=ILST1_IOFF,NLST1,ILST1_SKIP
          L1=LST1(1,ILST)
          L2=LST1(2,ILST)
          L3=LST1(3,ILST)
          L4=LST1(4,ILST)
          V=VAL1(L4)
          IX=INCX1*(L1-1)+1
          IF=INCF1*(L2-1)+1
          IY=INCY1*(L3-1)+1
          DO I=1,LEN1
            A=V*F(IF)
            CALL DAXPY_(LEN2,A,Y(IY),INCY2,X(IX),INCX3)
            IX=IX+INCX2
            IF=IF+INCF2
          END DO
        END DO
      ELSE IF(IMLTOP.EQ.1) THEN
        DO ILST=ILST1_IOFF,NLST1,ILST1_SKIP
          L1=LST1(1,ILST)
          L2=LST1(2,ILST)
          L3=LST1(3,ILST)
          L4=LST1(4,ILST)
          V=VAL1(L4)
          IX=INCX1*(L1-1)+1
          IF=INCF1*(L2-1)+1
          IY=INCY1*(L3-1)+1
          DO I=1,LEN2
            Y(IY)=Y(IY)+V*DDOT_(LEN1,F(IF),INCF2,X(IX),INCX2)
            IX=IX+INCX3
            IY=IY+INCY2
          END DO
        END DO
      ELSE
        DO ILST=ILST1_IOFF,NLST1,ILST1_SKIP
          L1=LST1(1,ILST)
          L2=LST1(2,ILST)
          L3=LST1(3,ILST)
          L4=LST1(4,ILST)
          V=VAL1(L4)
          IX=INCX1*(L1-1)+1
          IF=INCF1*(L2-1)+1
          IY=INCY1*(L3-1)+1
C     F(L2,p) := Add V*X(L1,p,q)*Y(L3,q)
          DO I=1,LEN2
            A=V*Y(IY)
            CALL DAXPY_(LEN1,A,X(IX),INCX2,F(IF),INCF2)
            IX=IX+INCX3
            IY=IY+INCY2
          END DO
        END DO
      END IF

      NFR1 =NFR1 +2*NLST1*LEN1*LEN2

      RETURN
      END
      SUBROUTINE PMLTR1 (KOD,IMLTOP,LST1,
     &                   lg_X,NAS1,NIS1,JXOFF,
     &                   F,NFI,NFJ,
     &                   lg_Y,NAS2,NIS2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif
      DIMENSION F(NFI,NFJ)
      DIMENSION LST1(4,NLST1)
#include "sigma.fh"
#include "para_info.fh"

#ifdef _MOLCAS_MPP_
C SVC: Determine the index ranges of the local chunks of lg_X and lg_Y.
C The boundaries and leading dimension are stored in a common block for
C access inside the lower-level routines.
C For now, only case H is handled as a distributed array, which is
C always the Y array.
      IF (Is_Real_Par()) THEN
        CALL GA_Sync()
        myRank = GA_NodeID()
*     CALL GA_Distribution (lg_X,myRank,iXLo,iXHi,jXLo,jXHi)
*     IF (iXLo.NE.0.AND.jXLo.NE.0) THEN
*       CALL GA_Access (lg_X,iXLo,iXHi,jXLo,jXHi,mX,LDX)
*     END IF
        CALL GA_Distribution (lg_Y,myRank,iYLo,iYHi,jYLo,jYHi)
        IF (iYLo.NE.0.AND.jYLo.NE.0) THEN
          CALL GA_Access (lg_Y,iYLo,iYHi,jYLo,jYHi,mY,LDY)
          IF (KOD.EQ.17 .OR. KOD.EQ.18) THEN
            CALL MLTR1_EH(IMLTOP,LST1,
     &                  WORK(lg_X),NAS1,NIS1,JXOFF,
     &                  F,NFI,NFJ,
     &                  DBL_MB(mY),NAS2,jYLo,jYHi)
          ELSE IF (KOD.EQ.21 .OR. KOD.EQ.22) THEN
            CALL MLTR1_GH(IMLTOP,LST1,
     &                  WORK(lg_X),NAS1,NIS1,JXOFF,
     &                  F,NFI,NFJ,
     &                  DBL_MB(mY),NAS2,jYLo,jYHi)
          END IF
          CALL GA_Release_Update (lg_Y,iYLo,iYHi,jYLo,jYHi)
        END IF
        CALL GA_Sync()
      ELSE
        IF (KOD.EQ.17 .OR. KOD.EQ.18) THEN
          CALL MLTR1_EH(IMLTOP,LST1,
     &                  WORK(lg_X),NAS1,NIS1,JXOFF,
     &                  F,NFI,NFJ,
     &                  WORK(lg_Y),NAS2,1,NIS2)
        ELSE IF (KOD.EQ.21 .OR. KOD.EQ.22) THEN
          CALL MLTR1_GH(IMLTOP,LST1,
     &                  WORK(lg_X),NAS1,NIS1,JXOFF,
     &                  F,NFI,NFJ,
     &                  WORK(lg_Y),NAS2,1,NIS2)
        END IF
      END IF
#else
      IF (KOD.EQ.17 .OR. KOD.EQ.18) THEN
        CALL MLTR1_EH(IMLTOP,LST1,
     &                WORK(lg_X),NAS1,NIS1,JXOFF,
     &                F,NFI,NFJ,
     &                WORK(lg_Y),NAS2,1,NIS2)
      ELSE IF (KOD.EQ.21 .OR. KOD.EQ.22) THEN
        CALL MLTR1_GH(IMLTOP,LST1,
     &                WORK(lg_X),NAS1,NIS1,JXOFF,
     &                F,NFI,NFJ,
     &                WORK(lg_Y),NAS2,1,NIS2)
      END IF
#endif
      RETURN
      END

      SUBROUTINE MLTR1_EH (IMLTOP,LST1,
     &                     X,NAS1,NIS1,JXOFF,
     &                     F,NFT,NFA,
     &                     Y,NAS2,jYLo,jYHi)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(NAS1,NIS1),F(NFT,NFA),Y(NAS2,jYHi-jYLo+1)
      DIMENSION LST1(4,NLST1)
#include "sigma.fh"

C this routine is adapted to use chunks of a distributed array (lg_Y)
C for the H case.  The chunks span all rows (NAS2) and columns jYlo to
C jYHi. The array Y points to the beginning of a chunk.

      IF(IMLTOP.EQ.0) THEN
        NA=INCX3/NAS1
        DO ILST=1,NLST1
        L1=LST1(1,ILST)
        L2=LST1(2,ILST)
        L3=LST1(3,ILST)
        L4=LST1(4,ILST)
        V=VAL1(L4)
        JX=JXOFF+L1
        DO I=1,NAS1
        A=V*F(I,L2)
C X(L1,p,q):= Add V*F(L2,p)*Y(L3,q), p=1..LEN1, q=1..LEN2
        CALL DAXPY_(jYHi-jYLo+1,A,Y(L3,1),NAS2,
     &                 X(I,JX+NA*(jYLo-1)),INCX3)
        END DO
        END DO
      ELSE IF(IMLTOP.EQ.1) THEN
        NA=INCX3/NAS1
        DO ILST=1,NLST1
        L1=LST1(1,ILST)
        L2=LST1(2,ILST)
        L3=LST1(3,ILST)
        L4=LST1(4,ILST)
        V=VAL1(L4)
        JX=JXOFF+L1
        DO J=jYLo,jYHi
C Y(L3,q):= Add V*F(L2,p)*X(L1,p,q), p=1..LEN1, q=1..LEN2
        Y(L3,J-jYLo+1)=Y(L3,J-jYLo+1)+
     &       V*DDOT_(NAS1,F(1,L2),1,X(1,JX+NA*(J-1)),1)
        END DO
        END DO
      ELSE
        NI=INCX3/NAS1
        DO ILST=1,NLST1
        L1=LST1(1,ILST)
        L2=LST1(2,ILST)
        L3=LST1(3,ILST)
        L4=LST1(4,ILST)
        V=VAL1(L4)
C F(L2,p) := Add V*X(L1,p,q)*Y(L3,q)
        JX=JXOFF+L1
        DO J=jYLo,jYHi
        A=V*Y(L3,J-jYLo+1)
        CALL DAXPY_(NAS1,A,X(1,JX+(J-1)*NI),1,F(1,L2),1)
        END DO
        END DO
      END IF

*     NFR1 =NFR1 +2*NLST1*LEN1*LEN2

      RETURN
      END
      SUBROUTINE MLTR1_GH (IMLTOP,LST1,
     &                     X,NAS1,NIS1,JXOFF,
     &                     F,NFT,NFI,
     &                     Y,NAS2,jYLo,jYHi)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(NAS1,NIS1),F(NFT,NFI),Y(NAS2,jYHi-jYLo+1)
      DIMENSION LST1(4,NLST1)
#include "sigma.fh"

C this routine is adapted to use chunks of a distributed array (lg_Y)
C for the H case.  The chunks span all rows (NAS2) and columns jYlo to
C jYHi. The array Y points to the beginning of a chunk.

      IF(IMLTOP.EQ.0) THEN
        DO ILST=1,NLST1
        L1=LST1(1,ILST)
        L2=LST1(2,ILST)
        L3=LST1(3,ILST)
        L4=LST1(4,ILST)
        V=VAL1(L4)
        IF (L3.GE.jYLo .AND. L3.LE.jYHi) THEN
          JX=JXOFF+L1
          JY=L3-jYLo+1
          DO I=1,NAS1
          A=V*F(I,L2)
C X(L1,p,q):= Add V*F(L2,p)*Y(L3,q), p=1..LEN1, q=1..LEN2
          CALL DAXPY_(NAS2,A,Y(1,JY),1,X(I,JX),INCX3)
          END DO
        END IF
        END DO
      ELSE IF(IMLTOP.EQ.1) THEN
        NI=INCX3/NAS1
        DO ILST=1,NLST1
        L1=LST1(1,ILST)
        L2=LST1(2,ILST)
        L3=LST1(3,ILST)
        L4=LST1(4,ILST)
        V=VAL1(L4)
        IF (L3.GE.jYLo .AND. L3.LE.jYHi) THEN
          JX=JXOFF+L1
          JY=L3-jYLo+1
          DO I=1,NAS2
C Y(L3,q):= Add V*F(L2,p)*X(L1,p,q), p=1..LEN1, q=1..LEN2
          Y(I,JY)=Y(I,JY)+
     &       V*DDOT_(NAS1,F(1,L2),1,X(1,JX+NI*(I-1)),1)
          END DO
        END IF
        END DO
      ELSE
        NI=INCX3/NAS1
        DO ILST=1,NLST1
        L1=LST1(1,ILST)
        L2=LST1(2,ILST)
        L3=LST1(3,ILST)
        L4=LST1(4,ILST)
        V=VAL1(L4)
        IF (L3.GE.jYLo .AND. L3.LE.jYHi) THEN
          JX=JXOFF+L1
          JY=L3-jYLo+1
C F(L2,p) := Add V*X(L1,p,q)*Y(L3,q)
          DO I=1,NAS2
          A=V*Y(I,JY)
          CALL DAXPY_(NAS1,A,X(1,JX+NI*(I-1)),1,F(1,L2),1)
          END DO
        END IF
        END DO
      END IF

*     NFR1 =NFR1 +2*NLST1*LEN1*LEN2

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine P_Int (
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: to compute the multipole moments integrals with the          *
*         Gauss-Hermite quadrature.                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Modified to multipole moments November '90               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "oneswi.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables
      Character*80 Label
*
*     Statement function for Cartesian index
*
      nElem(i) = (i+1)*(i+2)/2
*
      iRout = 122
      iPrint = nPrint(iRout)
*
*---- Observe that this code does not make any sense in case of symmetry!
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
      If (iPrint.ge.99) Then
         Write (6,*) ' Result in P_Int'
         Do ia = 1, nElem(la)
            Do ib = 1, nElem(lb)
               Do iIC = 1, nIC
                  Write (Label,'(A,I2,A,I2,A,I2,A)')
     &               ' Final(a=',ia,',b=',ib,',iIC=',iIC,')'
                  Call RecPrt(Label,' ',Final(1,ia,ib,iIC),nAlpha,nBeta)
               End Do
            End Do
         End Do
      End If
*
*     Call GetMem(' Exit P_Int','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_real_array(Zeta)
         Call Unused_real_array(ZInv)
         Call Unused_real_array(rKappa)
         Call Unused_real_array(P)
         Call Unused_real_array(A)
         Call Unused_real_array(RB)
         Call Unused_integer(nHer)
         Call Unused_real_array(Array)
         Call Unused_real_array(Ccoor)
         Call Unused_integer(nOrdOp)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iChO)
         Call Unused_integer_array(iStabM)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ITO(N,k,q,C0,Cp,Cm)
! This soubroutine implements the core ITO generation
! using the following ITO convention:
!                               S,M2
!                             CG
!                               S,M1,k,q
!  < S,M1 | O_k_q | S,M2 > = -------------
!                               S,S
!                             CG
!                               S,S,k,0
!
! The denominator is computed using a simpler formula:
! Varshalovich, p252, formula (42):
!
! N = 2S+1, dimension   (input)
! k = rank of ITO       (input)
! q = projection of ITO (input)
! Cp = O+ operator (output), complex
! Cm = O- operator (output), complex
! C0 = CG0  (output), real number, positive

use Constants, only: Half, cOne
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, k, q
real(kind=wp), intent(out) :: C0
complex(kind=wp), intent(out) :: Cp(n,n), Cm(n,n)
integer(kind=iwp) :: m1, m2
real(kind=wp) :: CGm, CGp, rK, rm1, rm2, rQ, rS
real(kind=wp), external :: fct

rS = real(n-1,kind=wp)*Half
rK = real(k,kind=wp)
rQ = real(q,kind=wp)
C0 = fct(n-1)*sqrt(real(n,kind=wp)/(fct(n-k-1)*fct(n+k)))
! M1 and M2 go from max value to min value
do m1=1,n
  do m2=1,n
    rm1 = rS-real(m1-1,kind=wp)
    rm2 = rS-real(m2-1,kind=wp)
    call Clebsch_Gordan(rS,rm2,rK,rQ,rS,rm1,CGp)
    call Clebsch_Gordan(rS,rm2,rK,-rQ,rS,rm1,CGm)
    Cp(m1,m2) = CGp/C0*cOne
    Cm(m1,m2) = CGm/C0*cOne
  end do
end do

return

end subroutine ITO

subroutine Liviu_ITO(n,k,q,O,W,redME)
! generate O, W as in previous Stewens_matrixel function:
! redME =  ratio between Naoya's and Liviu operators

use Constants, only: cOne
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, k, q
complex(kind=wp), intent(out) :: O(n,n), W(n,n), redME
real(kind=wp) :: C0, CR

call coeff_redus_sub(n,k,CR)
call ITO(n,k,q,C0,O,W)
redME = C0*CR*cOne
W(:,:) = redME*W(:,:)
O(:,:) = redME*O(:,:)

return

end subroutine Liviu_ITO

subroutine Stev_ITO(n,k,q,O,W,redME)
! generate O, W as in previous Stewens_matrixel function:
! redME =  ratio between Naoya's and Liviu operators
! scaled as for Stevens Operators by knm

use Constants, only: One, cZero, cOne
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, k, q
complex(kind=wp), intent(out) :: O(n,n), W(n,n), redME
real(kind=wp) :: F, knm(12,0:12)

O(:,:) = cZero
W(:,:) = cZero
redME = cZero
if ((k > 12) .or. (q > 12)) return

call set_knm(knm)
call Liviu_ITO(n,k,q,O,W,redME)
F = One/knm(k,q)
redME = F*cOne
W(:,:) = redME*W(:,:)
O(:,:) = redME*O(:,:)

return

end subroutine Stev_ITO

subroutine ESO(n,k,q,O,W,redME)
! generate Hermitian ESO operators, as in MATLAB EasySpin(stev) function
! only for q >= 0

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half, cZero, cOne, Onei
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, k, q
complex(kind=wp), intent(out) :: O(n,n), W(n,n), redME
real(kind=wp) :: C0, CR, F, knm(12,0:12)
complex(kind=wp) :: mQ
complex(kind=wp), allocatable :: Cp(:,:), Cm(:,:)

O(:,:) = cZero
W(:,:) = cZero
redME = cZero
if ((k > 12) .or. (q > 12)) return ! not available in MATLAB

call mma_allocate(Cp,n,n,'Cp')
call mma_allocate(Cm,n,n,'Cm')
Cp(:,:) = cZero
Cm(:,:) = cZero

call set_knm(knm)
call coeff_redus_sub(n,k,CR)
call ITO(n,k,q,C0,Cp,Cm)

F = C0*CR/knm(k,q)
redME = F*cOne
mQ = (-cOne)**q
O(:,:) = Half*cOne*redME*(Cm(:,:)+mQ*Cp(:,:))
W(:,:) = Half*Onei*redME*(Cm(:,:)-mQ*Cp(:,:))
call mma_deallocate(Cp)
call mma_deallocate(Cm)

return

end subroutine ESO

subroutine Liviu_ESO(n,k,q,O,W,redME)
! generate Hermitian ESO operators, as in MATLAB EasySpin(stev) function
! only for q >= 0
! Om = Ok-q
! Op = Ok+q
! the only difference with MATLAB's ESO are scaling factor Knm

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half, cOne, Onei
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, k, q
complex(kind=wp), intent(out) :: O(n,n), W(n,n), redME
real(kind=wp) :: C0, CR
complex(kind=wp) :: mQ
complex(kind=wp), allocatable :: Cp(:,:), Cm(:,:)

call mma_allocate(Cp,n,n,'Cp')
call mma_allocate(Cm,n,n,'Cm')

call coeff_redus_sub(n,k,CR)
call ITO(n,k,q,C0,Cp,Cm)
redME = C0*CR*cOne
mQ = (-cOne)**q
O(:,:) = Half*redME*(Cm(:,:)+mQ*Cp(:,:))
W(:,:) = Half*Onei*redME*(Cm(:,:)-mQ*Cp(:,:))
call mma_deallocate(Cp)
call mma_deallocate(Cm)

return

end subroutine Liviu_ESO

subroutine Stewens_matrixel(N,M,d,ITO_O,ITO_W,IPRINT)
! This Subroutine calculates the matrix elements of the ITO  (On)
! on the basis of the eigenfunctions of the effective spin.
!
! N -- the rank of the ITO (On)
! d -- the multiplicity of the effective spin
! Dip_Stewens(N, L, d, d) -- the matrix elements of the ITO tensor
!               operators in the basis of effective spin eigenfunctions

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half, cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, M, d, IPRINT
complex(kind=wp), intent(out) :: ITO_O(d,d), ITO_W(d,d)
integer(kind=iwp) :: i, j, ms1, ms2, npar
real(kind=wp) :: a, al, b, bt, c, COEFF_REDUS, coeffCG, gm
complex(kind=wp), allocatable :: ITO_PLUS(:,:), ITO_MINUS(:,:)
!***********************************************************************

call mma_allocate(ITO_PLUS,[-d,d],[-d,d],label='ITO_PLUS')
call mma_allocate(ITO_MINUS,[-d,d],[-d,d],label='ITO_MINUS')

NPAR = mod(d,2)
ITO_PLUS(:,:) = cZero
ITO_MINUS(:,:) = cZero
ITO_O(:,:) = cZero
ITO_W(:,:) = cZero

call COEFF_REDUS_SUB(d,N,COEFF_REDUS)
!COEFF_REDUS = One
a = real(N,kind=wp)
al = real(M,kind=wp)
c = real(d-1,kind=wp)*Half
b = real(d-1,kind=wp)*Half
do ms1=-(d-NPAR)/2,(d-NPAR)/2
  if ((ms1 == 0) .and. (NPAR == 0)) cycle
  if (NPAR == 0) then
    if (ms1 < 0) then
      gm = real(ms1,kind=wp)+Half
    else
      gm = real(ms1,kind=wp)-Half
    end if
  else
    gm = real(ms1,kind=wp)
  end if

  do ms2=-(d-NPAR)/2,(d-NPAR)/2
    if ((ms2 == 0) .and. (NPAR == 0)) cycle
    if (NPAR == 0) then
      if (ms2 < 0) then
        bt = real(ms2,kind=wp)+Half
      else
        bt = real(ms2,kind=wp)-Half
      end if
    else
      bt = real(ms2,kind=wp)
    end if
    coeffCG = Zero

    call Clebsch_Gordan(a,al,b,bt,c,gm,coeffCG)

    ITO_PLUS(ms1,ms2) = coeffCG*COEFF_REDUS*cOne

    if (iprint > 5) &
      write(u6,'(5x,2(a,i3,2x),6(a,f4.1,2x),2(a,f14.10,2x))') 'ms1=',ms1,'ms2=',ms2,'a=',a,'al=',al,'b=',b,'bt=',bt,'c=',c, &
                                                              'gm=',gm,'coeffCG=',coeffCG,'coeffCG^2=',coeffCG**2
  end do ! ms2
end do ! ms1

al = -real(M,kind=wp)

do ms1=-(d-NPAR)/2,(d-NPAR)/2
  if ((ms1 == 0) .and. (NPAR == 0)) cycle
  if (NPAR == 0) then
    if (ms1 < 0) then
      gm = real(ms1,kind=wp)+Half
    else
      gm = real(ms1,kind=wp)-Half
    end if
  else
    gm = real(ms1,kind=wp)
  end if

  do ms2=-(d-NPAR)/2,(d-NPAR)/2
    if ((ms2 == 0) .and. (NPAR == 0)) cycle

    if (NPAR == 0) then
      if (ms2 < 0) then
        bt = real(ms2,kind=wp)+Half
      else
        bt = real(ms2,kind=wp)-Half
      end if
    else
      bt = real(ms2,kind=wp)
    end if
    coeffCG = Zero

    call Clebsch_Gordan(a,al,b,bt,c,gm,coeffCG)

    ITO_MINUS(ms1,ms2) = coeffCG*COEFF_REDUS*cOne

    if (iprint > 5) &
      write(u6,'(5x,2(a,i3,2x),6(a,f4.1,2x),2(a,f14.10,2x))') 'ms1=',ms1,'ms2=',ms2,'a=',a,'al=',al,'b=',b,'bt=',bt,'c=',c, &
                                                              'gm=',gm,'coeffCG=',coeffCG,'coeffCG^2=',coeffCG**2
  end do
end do

i = 0
do ms1=-(d-NPAR)/2,(d-NPAR)/2
  if ((ms1 == 0) .and. (NPAR == 0)) cycle
  i = i+1
  j = 0

  do ms2=-(d-NPAR)/2,(d-NPAR)/2
    if ((ms2 == 0) .and. (NPAR == 0)) cycle
    j = j+1
    ITO_O(i,j) = ITO_PLUS(ms1,ms2)
    ITO_W(i,j) = ITO_MINUS(ms1,ms2)
  end do
end do

if (IPRINT > 3) then
  write(u6,'(/)')
  write(u6,'(5X,A,2I3)') 'Operator ITO_PLUS',N,M
  write(u6,*)
  do ms1=-(d-NPAR)/2,(d-NPAR)/2
    if ((ms1 == 0) .and. (NPAR == 0)) cycle
    if (NPAR == 1) write(u6,'(16(2X,2ES12.3))') (ITO_PLUS(ms1,ms2),ms2=-(d-NPAR)/2,(d-NPAR)/2)
    if (NPAR == 0) write(u6,'(16(2X,2ES12.3))') (ITO_PLUS(ms1,ms2),ms2=-d/2,-1),(ITO_PLUS(ms1,ms2),ms2=1,d/2)
  end do ! ms1

  write(u6,'(/)')
  write(u6,'(5X,A,2I3)') 'Operator ITO_MINUS',N,M
  write(u6,*)
  do ms1=-(d-NPAR)/2,(d-NPAR)/2
    if ((ms1 == 0) .and. (NPAR == 0)) cycle
    if (NPAR == 1) write(u6,'(16(2X,2ES12.3))') (ITO_MINUS(ms1,ms2),ms2=-(d-NPAR)/2,(d-NPAR)/2)
    if (NPAR == 0) write(u6,'(16(2X,2ES12.3))') (ITO_MINUS(ms1,ms2),ms2=-d/2,-1),(ITO_MINUS(ms1,ms2),ms2=1,d/2)
  end do ! ms1

  write(u6,'(/////)')
  write(u6,'(5X,A,2I3)') 'ITO_O',N,M
  write(u6,*)
  do i=1,d
    write(u6,'(16(2X,2ES12.3))') (ITO_O(i,j),j=1,d)
  end do   ! i
  write(u6,'(/)')
  write(u6,'(5X,A,2I3)') 'ITO_W',N,M
  write(u6,*)
  do i=1,d
    write(u6,'(16(2X,2ES12.3))') (ITO_W(i,j),j=1,d)
  end do ! i
end if ! iPrint

call mma_deallocate(ITO_PLUS)
call mma_deallocate(ITO_MINUS)

return

end subroutine Stewens_matrixel

function fct(n)
! this function provides correct answer till n=169 only

use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: fct
integer(kind=iwp), intent(in) :: n
integer(kind=iwp) :: i
real(kind=wp) :: xct, xlim

xct = One
fct = One
if (n < 0) then
  write(u6,'(A,i0)') 'FCT:  N<0 !'
  write(u6,'(A,i0)') 'N = ',N
  write(u6,'(A   )') 'It is an impossible case.'
  fct = -9.0e99_wp
  return

else if (n == 0) then
  return

else if ((n > 0) .and. (n <= 169)) then
  xlim = huge(xct)/real(n,kind=wp)
  do i=1,n
    if (xct > xlim) then
      write(u6,'(A,i0)') 'FCT:   N = ',N
      write(u6,'(A)') 'Factorial of overflows current precision.'
      write(u6,'(A)') 'Use higher numerical precision, or rethink your algorithm.'
      call abend()
    end if
    xct = xct*real(i,kind=wp)
  end do

else
  write(u6,'(A,i0)') 'FCT:   N = ',N
  write(u6,'(A)') 'Factorial of N>169 overflows on x86_64'
  write(u6,'(A)') 'Use higher numerical precision, or rethink your algorithm.'
end if

fct = xct

return

end function fct

subroutine COEFF_REDUS_SUB(d,N,COEFF_REDUS)
! THIS Subroutine ReturnS THE VALUE OF THE REDUCED MATRIX ELEMENT  <S|| On ||S>
! WHERE S-EFFECTIVE SPIN, On -- THE HIGHER ORDER SPIN OPERATORS
!
! The convention is to follow the paper:
! C. Rudowicz and C.Y. Chung
! J. Phys.: Condens. Matter, 2004, 16, pp. 5825
! doi:10.1088/0953-8984/16/32/018
!
! with a minor addition of the Norm(N) factor which depends on the operator rank
! This norm makes the matrix elements of ESO identical to those of the
! operators from EasySpin (stev).

use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: d, N
real(kind=wp), intent(out) :: COEFF_REDUS
real(kind=wp) :: s1, s2
real(kind=wp), parameter :: Norm(51) = [Two**0,Two**1,Two**3,Two**4,Two**7,Two**8,Two**10,Two**11,Two**15,Two**16,Two**18,Two**19, &
                                        Two**22,Two**23,Two**25,Two**26,Two**31,Two**32,Two**34,Two**35,Two**38,Two**39,Two**41, &
                                        Two**42,Two**46,Two**47,Two**49,Two**50,Two**53,Two**54,Two**56,Two**57,Two**63,Two**64, &
                                        Two**66,Two**67,Two**70,Two**71,Two**73,Two**74,Two**78,Zero,Zero,Zero,Zero,Zero,Zero, &
                                        Zero,Zero,Zero,Zero]
real(kind=wp), external :: fct

!  new method
s1 = sqrt(fct(d+N)/fct(d-N-1))
s2 = real(2**N,kind=wp)*sqrt(real(d,kind=wp))

COEFF_REDUS = Norm(N/2+1)*s1/s2

return

end subroutine COEFF_REDUS_SUB

subroutine Clebsch_Gordan(a,al,b,bt,c,gm,coeffCG)

use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: a, al, b, bt, c, gm
real(kind=wp), intent(out) :: coeffCG
integer(kind=iwp) :: i, lb1, lb2
real(kind=wp) :: s1, s2, u
real(kind=wp), external :: fct

! exclude the cases for which CG coefficients are exactly zero
coeffCG = Zero
if ((al+bt) /= gm) return
if (a < Zero) return
if (b < Zero) return
if (c < Zero) return
if (abs(al) > a) return
if (abs(bt) > b) return
if (abs(gm) > c) return
if ((abs(a-b) > c) .or. ((a+b) < c)) return
if ((abs(b-c) > a) .or. ((b+c) < a)) return
if ((abs(c-a) > b) .or. ((c+a) < b)) return
if (mod(nint(Two*a),2) /= mod(nint(Two*abs(al)),2)) return
if (mod(nint(Two*b),2) /= mod(nint(Two*abs(bt)),2)) return
if (mod(nint(Two*c),2) /= mod(nint(Two*abs(gm)),2)) return
u = Zero
lb1 = int(min(c-b+al,c-a-bt))
lb2 = int(min(a+b-c,a-al,b+bt))
if (lb1 < 0) then
  if (-lb1 > lb2) then
    coeffCG = Zero
    return
  else

    do i=-lb1,lb2
      u = u+real((-1)**i,kind=wp)/ &
          real(fct(i)*fct(nint(a-al-i))*fct(nint(b+bt-i))*fct(nint(a+b-c-i))*fct(nint(c-b+al+i))*fct(nint(c-a-bt+i)),kind=wp)
    end do
  end if
else
  do i=0,lb2
    u = u+real((-1)**i,kind=wp)/ &
        real(fct(i)*fct(nint(a-al-i))*fct(nint(b+bt-i))*fct(nint(a+b-c-i))*fct(nint(c-b+al+i))*fct(nint(c-a-bt+i)),kind=wp)
  end do
end if

s1 = sqrt(real(fct(nint(a+b-c))*fct(nint(a-b+c))*fct(nint(-a+b+c)),kind=wp)/real(fct(nint(a+b+c+1)),kind=wp))
s2 = sqrt(real(fct(nint(a+al))*fct(nint(a-al))*fct(nint(b+bt))*fct(nint(b-bt))*fct(nint(c+gm))*fct(nint(c-gm))*(2*c+1),kind=wp))

coeffCG = u*s1*s2

return

end subroutine Clebsch_Gordan

function W9J(a,b,c,d,e,f,g,h,j)
! Calculates a Wigner 9-j symbol. Argument a-j are Integer and are
! twice the true value of the 9-j's arguments, in the form
! { a b c }
! { d e f }
! { g h j }
! this is the implementation the formula 10.2.4. (20) from:
!   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
!   "Quantum Theory of Angular Momentum", World Scientific, 1988.

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: W9J
integer(kind=iwp), intent(in) :: a, b, c, d, e, f, g, h, j
integer(kind=iwp) :: n, nhig, nlow
real(kind=wp), external :: W6J
logical(kind=iwp), external :: check_triangle

W9j = Zero
if (mod(a+b,2) /= mod(c,2)) return
if (mod(d+e,2) /= mod(f,2)) return
if (mod(g+h,2) /= mod(j,2)) return
if (mod(a+d,2) /= mod(g,2)) return
if (mod(b+e,2) /= mod(h,2)) return
if (mod(c+f,2) /= mod(j,2)) return
if ((abs(a-b) > c) .or. (a+b < c)) return
if ((abs(d-e) > f) .or. (d+e < f)) return
if ((abs(g-h) > j) .or. (g+h < j)) return
if ((abs(a-d) > g) .or. (a+d < g)) return
if ((abs(b-e) > h) .or. (b+e < h)) return
if ((abs(c-f) > j) .or. (c+f < j)) return
if (.not. check_triangle(a,b,c)) return
if (.not. check_triangle(d,e,f)) return
if (.not. check_triangle(g,h,j)) return
if (.not. check_triangle(a,d,g)) return
if (.not. check_triangle(b,e,h)) return
if (.not. check_triangle(c,f,j)) return

nlow = max(abs(a-j)/2,abs(d-h)/2,abs(b-f)/2)
nhig = min((a+j)/2,(d+h)/2,(b+f)/2)

do n=nlow,nhig
  W9j = W9j+real(2*n+1,kind=wp)*real((-1)**(2*n),kind=wp)*W6J(a,b,c,f,j,2*n)*W6J(d,e,f,b,2*n,h)*W6J(g,h,j,2*n,a,d)
end do

return

end function W9J

function W6J(a,b,c,d,e,f)
! Calculates a Wigner 6-j symbol. Argument a-f are positive Integer
! and are twice the true value of the 6-j's arguments, in the form
! { a b c }
! { d e f }
!
! this is the implementation the formula 9.2.1. (1) from:
!   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
!   "Quantum Theory of Angular Momentum", World Scientific, 1988.

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: W6J
integer(kind=iwp), intent(in) :: a, b, c, d, e, f
integer(kind=iwp) :: n, nhig, nlow
real(kind=wp) :: rsum
real(kind=wp), external :: dlt, fct
logical(kind=iwp), external :: check_triangle

W6J = Zero
if (mod(a+b,2) /= mod(c,2)) return
if (mod(c+d,2) /= mod(e,2)) return
if (mod(a+e,2) /= mod(f,2)) return
if (mod(b+d,2) /= mod(f,2)) return
if ((abs(a-b) > c) .or. (a+b < c)) return
if ((abs(c-d) > e) .or. (c+d < e)) return
if ((abs(a-e) > f) .or. (a+e < f)) return
if ((abs(b-d) > f) .or. (b+d < f)) return

if (.not. check_triangle(a,b,c)) return
if (.not. check_triangle(c,d,e)) return
if (.not. check_triangle(a,e,f)) return
if (.not. check_triangle(b,d,f)) return

nlow = max((a+b+c)/2,(c+d+e)/2,(b+d+f)/2,(a+e+f)/2)
nhig = min((a+b+d+e)/2,(b+c+e+f)/2,(a+c+d+f)/2)

rsum = Zero
do n=nlow,nhig
  rsum = rsum+real((-1)**n,kind=wp)*fct(n+1)/fct((a+c+d+f)/2-n)/fct((b+c+e+f)/2-n)/fct(n-(a+b+c)/2)/fct(n-(c+d+e)/2)/ &
         fct(n-(a+e+f)/2)/fct(n-(b+d+f)/2)/fct((a+b+d+e)/2-n)
end do
W6J = dlt(a,b,c)*dlt(c,d,e)*dlt(a,e,f)*dlt(b,d,f)*rsum

return

end function W6J

function W3J(j1,j2,j3,m1,m2,m3)
! Calculates a Wigner 3-j symbol. Argument j1,j2,j3 are positive Integer
! and are twice the true value of the 3-j's arguments, in the form
! { j1 j2 j3 }
! { m1 m2 m3 }
!
! this is the implementation the formula 8.1.2. (11) from:
!   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
!   "Quantum Theory of Angular Momentum", World Scientific, 1988.

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: W3J
integer(kind=iwp), intent(in) :: j1, j2, j3, m1, m2, m3
real(kind=wp) :: coeffCG

W3J = Zero
call Clebsch_Gordan(real(j1,kind=wp)*Half,real(m1,kind=wp)*Half,real(j2,kind=wp)*Half,real(m2,kind=wp)*Half,real(j3,kind=wp)*Half, &
                    -real(m3,kind=wp)*Half,coeffCG)
if (coeffCG == Zero) return
W3J = real((-1)**((j1-j2-m3)/2),kind=wp)*coeffCG/sqrt(real(j3+1,kind=wp))

return

end function W3J

function WCG(a,al,b,bt,c,gm)
! Calculates a Clebsch-Gordan Coefficient. Argument a, al, b, bt, c, gm are Integer,
! double their actual value.
! (   c/2, gm/2            )
! ( C                      )
! (   a/2, al/2, b/2, bt/2 )
! this is the implementation the formula 8.2.1. (3) from:
!   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
!   "Quantum Theory of Angular Momentum", World Scientific, 1988.

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: WCG
integer(kind=iwp), intent(in) :: a, al, b, bt, c, gm
integer(kind=iwp) :: i, lb1, lb2
real(kind=wp) :: u
real(kind=wp), external :: dlt, fct

WCG = Zero

if ((al+bt) /= gm) return
if (a < 0) return
if (b < 0) return
if (c < 0) return
if (abs(al) > a) return
if (abs(bt) > b) return
if (abs(gm) > c) return
if ((abs(a-b) > c) .or. ((a+b) < c)) return
if ((abs(b-c) > a) .or. ((b+c) < a)) return
if ((abs(c-a) > b) .or. ((c+a) < b)) return
if (mod(a,2) /= mod(abs(al),2)) return
if (mod(b,2) /= mod(abs(bt),2)) return
if (mod(c,2) /= mod(abs(gm),2)) return
u = Zero
lb1 = min((c-b+al)/2,(c-a-bt)/2)
lb2 = min((a+b-c)/2,(a-al)/2,(b+bt)/2)
if (lb1 < 0) then
  if (-lb1 > lb2) then
    WCG = Zero
    return
  else
    do i=-lb1,lb2
      u = u+real((-1)**i,kind=wp)/ &
          (fct(i)*fct((a+b-c-2*i)/2)*fct((c-b+al+2*i)/2)*fct((c-a-bt+2*i)/2)*fct((a-al-2*i)/2)*fct((b+bt-2*i)/2))
    end do
  end if
else
  do i=0,lb2
    u = u+real((-1)**i,kind=wp)/ &
        (fct(i)*fct((a+b-c-2*i)/2)*fct((c-b+al+2*i)/2)*fct((c-a-bt+2*i)/2)*fct((a-al-2*i)/2)*fct((b+bt-2*i)/2))
  end do
end if
WCG = u*dlt(a,b,c)*sqrt(fct((a+al)/2)*fct((a-al)/2)*fct((b+bt)/2)*fct((b-bt)/2)*fct((c+gm)/2)*fct((c-gm)/2)*(c+1))

!write(u6,'(A)') 'a,  al,  b,  bt,  c,  gm'
!write(u6,'(6(F4.1,2x),F20.14)') real(a,kind=wp)*Half,real(al,kind=wp)*Half,real(b,kind=wp)*Half,real(bt,kind=wp)*Half, &
!                                real(c,kind=wp)*Half,real(gm,kind=wp)*Half,WCG

return

end function WCG

function dlt(a,b,c)
! calculates the delta(a,b,c) function using the formula 8.2.1. from:
!   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
!   "Quantum Theory of Angular Momentum", World Scientific, 1988.
!
! a,b,c are positive Integer numbers,
! their values are DoUBLE than their original value

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: dlt
integer(kind=iwp), intent(in) :: a, b, c
real(kind=wp), external :: fct
logical(kind=iwp), external :: check_triangle

dlt = Zero
if ((abs(a-b) > c) .or. (a+b < c)) return
if ((abs(b-c) > a) .or. (b+c < a)) return
if ((abs(c-a) > b) .or. (c+a < b)) return
if (mod((a+b-c),2) == 1) return
if (mod((a-b+c),2) == 1) return
if (mod((-a+b+c),2) == 1) return
if (mod((a+b+c),2) == 1) return
if (.not. check_triangle(a,b,c)) return
! special cases:
if (a == 0) dlt = One/sqrt(real(b+1,kind=wp))
if (b == 0) dlt = One/sqrt(real(a+1,kind=wp))
if (c == 0) dlt = One/sqrt(real(a+1,kind=wp))

dlt = sqrt(fct((a+b-c)/2)*fct((a-b+c)/2)*fct((-a+b+c)/2)/fct((a+b+c)/2+1))

return

end function dlt

function check_triangle(a,b,c)
!  checks If the values a,b,c comply with the triangle rule

use Definitions, only: iwp, u6

implicit none
logical(kind=iwp) :: check_triangle
integer(kind=iwp), intent(in) :: a, b, c

check_triangle = .false.

if ((a <= 0) .or. (b <= 0) .or. (c <= 0)) then
  write(u6,'(A)') 'a=',a
  write(u6,'(A)') 'b=',b
  write(u6,'(A)') 'c=',c
  write(u6,'(A)') 'The rule is: a>0, b>0 and c>0!'
  write(u6,'(A)') 'Please check this issue, or report a bug!'
  return
end if

if ((a+b >= c) .and. (b+c >= a) .and. (c+a >= b)) check_triangle = .true.

return

end function check_triangle

function WignerD(J,M1,M2,al,bt,gm)
! the function Returns the Wigner-D function specifying the rotation
! of the |J,M1,M2> around three  angles(alpha,beta,gamma).
! The rotation is either active (ik=1) or passive (ik=2).
!   J, M1, M2 are specified as Integer numbers, with a value DoUBLE than their actual size;
!   i.e. J = 2*J (Real); M1= 2*M1(Real); M2=2*M2(Real);
!   alpha, beta, gamma are specified as double precision (Real(kind=wp) ::). These values must be defined in
!   radians ( i.e. in units of Pi)
!
!
! This is the implementation of the formula 4.3.(1) from
!   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
!   "Quantum Theory of Angular Momentum", World Scientific, 1988.

use Constants, only: Half, cZero, cOne, Onei
use Definitions, only: wp, iwp

implicit none
complex(kind=wp) :: WignerD
integer(kind=iwp), intent(in) :: J, M1, M2
real(kind=wp), intent(in) :: al, bt, gm
complex(kind=wp) :: m1_fact, m2_fact, wig_fac
real(kind=wp), external :: wigner_d

! check correctness
WignerD = cZero
if (abs(M1) > J) return
if (abs(M2) > J) return
if (abs(J) < 0) return

m1_fact = exp((-Onei)**(real(al*M1,kind=wp)*Half))
m2_fact = exp((-Onei)**(real(gm*M2,kind=wp)*Half))
wig_fac = wigner_d(J,M1,M2,bt)*cOne
WignerD = m1_fact*m2_fact*wig_fac

return

end function WignerD

function wigner_d(J,M1,M2,bt)
! This is the implementation of the formula 4.3.1 (2) from
!   D.A. Varshalovich, A.N. Moskalev, V.K. Khersonskii,
!   "Quantum Theory of Angular Momentum", World Scientific, 1988.

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: wigner_d
integer(kind=iwp), intent(in) :: J, M1, M2
real(kind=wp), intent(in) :: bt
integer(kind=iwp) :: i, kmax, kmin
real(kind=wp) :: ksum
real(kind=wp), external :: fct

wigner_d = Zero
ksum = Zero
kmax = min((J-M1)/2,(J-M2)/2)
kmin = max(0,-(M1+M2)/2)
do i=kmin,kmax
  ksum = real((-1)**i,kind=wp)*(cos(bt*Half)**(M1/2+M2/2+2*i))*(sin(bt*Half)**(J-M1/2-M2/2-2*i))/fct(i)/fct((J-M1)/2-i)/ &
         fct((J-M2)/2-i)/fct((M1+M2)/2+i)
  wigner_d = wigner_d+ksum
end do
wigner_d = wigner_d*real((-1)**((J-M2)/2),kind=wp)*sqrt(fct((J+M1)/2)*fct((J-M1)/2)*fct((J+M2)/2)*fct((J-M2)/2))

return

end function wigner_d

function RedME(La,Sa,LaP,SaP,L,S)
! function evaluates the reduced matrix elements of the ground atomic J multipet
!
!  the function evaluates the formula:
! <L_A, S_A || Operator ( iL_T, iS_T)  || L_A, S_A >>   formula (S.20) derived by Naoya Iwahara
!
! iL, iS, iL_T, iS_T, Jp, Sp and Lp  are defined as Integers with a value DoUBLE of their true value
!
! the formula is valid for Tb, Dy, Ho, Er, Tm and Yb only

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: RedME
integer(kind=iwp), intent(in) :: La, Sa, LaP, SaP, L, S
integer(kind=iwp) :: JaP, jm, js, l_orb, s_orb
real(kind=wp) :: factor, temp
real(kind=wp), external :: WCG

RedME = Zero
l_orb = 6  ! double of true value l_orb = 3
s_orb = 1  ! double of true value s_orb = 1/2
JaP = LaP+SaP
if (WCG(La,La,L,0,La,La) == Zero) return
if (WCG(Sa,Sa,S,0,Sa,Sa) == Zero) return
if (WCG(La,La,l_orb,LaP-La,LaP,LaP) == Zero) return
if (WCG(Sa,Sa,s_orb,SaP-Sa,SaP,SaP) == Zero) return

factor = sqrt(real((La+1)*(Sa+1),kind=wp))/WCG(La,La,L,0,La,La)/WCG(Sa,Sa,S,0,Sa,Sa)

temp = Zero
do jm=-l_orb,l_orb
  do js=-s_orb,s_orb
    temp = temp+real((-1)**((l_orb+jm+s_orb+js)/2),kind=wp)*WCG(l_orb,-jm,l_orb,jm,L,0)*WCG(s_orb,-js,s_orb,js,S,0)* &
           WCG(LaP,La+jm,SaP,Sa+js,JaP,La+jm+Sa+js)*WCG(LaP,La+jm,SaP,Sa+js,JaP,La+jm+Sa+js)*WCG(La,La,l_orb,jm,LaP,La+jm)* &
           WCG(La,La,l_orb,jm,LaP,La+jm)*WCG(Sa,Sa,s_orb,js,SaP,Sa+js)*WCG(Sa,Sa,s_orb,js,SaP,Sa+js)/ &
           WCG(La,La,l_orb,LaP-La,LaP,LaP)/WCG(La,La,l_orb,LaP-La,LaP,LaP)/WCG(Sa,Sa,s_orb,SaP-Sa,SaP,SaP)/ &
           WCG(Sa,Sa,s_orb,SaP-Sa,SaP,SaP)
  end do ! is
end do ! im

RedME = temp*factor

return

end function RedME

function jot1(t,L,ML,S,MS,La,Sa,LaP,SaP)
! function evaluates the J1 exchange matrix element ( formula S.19)
!
! iL_T,iL_TM,iS_T,iS_TM,iL,iS,Sp,Lp are defined as Integers with a value DoUBLE of their true value
! the formula is valid for Tb, Dy, Ho, Er, Tm and Yb only
!    Substitutions:

use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: jot1
real(kind=wp), intent(in) :: t
integer(kind=iwp), intent(in) :: L, ML, S, MS, La, Sa, LaP, SaP
integer(kind=iwp) :: Ja, l_orb
real(kind=wp) :: txt
real(kind=wp), external :: RedME, W9J, WCG

jot1 = Zero
l_orb = 6  ! double of true value l_orb = 3
!s_orb = 1 ! double of true value s_orb = 1/2
txt = Zero
if (mod(L,2) == 0) then
  if (ML == 0) then
    txt = real((-1)**(l_orb/2),kind=wp)*WCG(l_orb,-4,l_orb,4,L,0)
  else if (ML == 8) then
    txt = -Half*real((-1)**(l_orb/2),kind=wp)*WCG(l_orb,4,l_orb,4,L,8)
  else if (ML == -8) then
    txt = -Half*real((-1)**(l_orb/2),kind=wp)*WCG(l_orb,4,l_orb,4,L,8)
  end if
end if
Ja = La+Sa

jot1 = t*txt*sqrt(real((Ja+1)*(L+s+1),kind=wp))*W9J(Ja,La,Sa,Ja,La,Sa,L+s,L,2)*WCG(L,ML,2,MS,L+s,ML+MS)*WCG(Ja,Ja,L+s,0,Ja,Ja)* &
       RedME(La,Sa,LaP,SaP,L,2)/sqrt(Two)

return

end function jot1

function jot0(t,L,ML,La,Sa,LaP,SaP)
! function evaluates the J1 exchange matrix element ( formula S.19)
!
! iL_T,iL_TM,iS_T,iS_TM,iL,iS,Sp,Lp are defined as Integers with a value DoUBLE of their true value
! the formula is valid for Tb, Dy, Ho, Er, Tm and Yb only
!    Substitutions:

use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: jot0
real(kind=wp), intent(in) :: t
integer(kind=iwp), intent(in) :: L, ML, La, Sa, LaP, SaP
integer(kind=iwp) :: Ja, l_orb
real(kind=wp) :: txt, W9Jl
real(kind=wp), external :: RedME, W6J, WCG

jot0 = Zero
l_orb = 6  ! double of true value l_orb = 3
!s_orb = 1 ! double of true value s_orb = 1/2
txt = Zero
if (mod(L,4) == 0) then
  if (ML == 0) then
    txt = real((-1)**(l_orb/2),kind=wp)*WCG(l_orb,-4,l_orb,4,L,0)
  else if (ML == 8) then
    txt = -Half*real((-1)**(l_orb/2),kind=wp)*WCG(l_orb,4,l_orb,4,L,8)
  else if (ML == -8) then
    txt = -Half*real((-1)**(l_orb/2),kind=wp)*WCG(l_orb,4,l_orb,4,L,8)
  end if
end if
Ja = La+Sa
W9Jl = real((-1)**((La+Ja+Sa+L)/2),kind=wp)*sqrt(real((Sa+1)*(L+1),kind=wp))*W6J(Ja,La,Sa,La,Ja,L)

jot0 = -t*txt*sqrt(real((Ja+1)*(L+1),kind=wp))*W9Jl*WCG(Ja,Ja,L,0,Ja,Ja)*RedME(La,Sa,LaP,SaP,L,0)/sqrt(Two)

return

end function jot0

subroutine verify_CG(N)

use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
integer(kind=iwp) :: k, m1, m2, q
real(kind=wp) :: CG_A, CG_B, CG_C, CG_D, CG_E, CG_F, CG_G, CG_H, mf, rfE, rfG, rJ, rK, rM1, rM2, rQ
logical(kind=iwp) :: prn

!2J = n-1
rJ = real(n-1,kind=wp)*Half

do k=1,n-1
  do q=0,k
    rK = real(k,kind=wp)
    rQ = real(q,kind=wp)

    do m1=1,n
      do m2=1,n
        ! real value for the projections:
        rM1 = -rJ+real(m1-1,kind=wp)
        rM2 = -rJ+real(m2-1,kind=wp)

        mf = (-1)**nint(rK)
        ! (a , alpha, b, beta,    c,  gamma)
        call Clebsch_Gordan(rJ,rM2,rK,rQ,rJ,rM1,CG_A)
        call Clebsch_Gordan(rK,rQ,rJ,rM2,rJ,rM1,CG_B)
        call Clebsch_Gordan(rJ,-rM2,rK,-rQ,rJ,-rM1,CG_C)
        call Clebsch_Gordan(rK,-rQ,rJ,-rM2,rJ,-rM1,CG_D)

        rfE = ((-1)**(rJ-rM2))*(sqrt(real(n,kind=wp)/(Two*rK+One)))
        call Clebsch_Gordan(rJ,rM2,rJ,-rM1,rK,-rQ,CG_E)
        call Clebsch_Gordan(rJ,rM1,rJ,-rM2,rK,rQ,CG_F)

        rfG = (-1)**(rK+rQ)
        call Clebsch_Gordan(rJ,-rM1,rK,rQ,rJ,-rM2,CG_G)
        call Clebsch_Gordan(rK,-rQ,rJ,rM1,rJ,rM2,CG_H)

        prn = (CG_A /= Zero) .or. (CG_B /= Zero) .or. (CG_C /= Zero) .or. (CG_D /= Zero) .or. (CG_E /= Zero) .or. &
              (CG_F /= Zero) .or. (CG_G /= Zero) .or. (CG_H /= Zero)

        if (prn) print '(A,1x,8F12.6)','n,k,q,CG:',CG_A,mf*CG_B,mf*CG_C,CG_D,rfE*CG_E,rfE*CG_F,rfG*CG_G,rfG*CG_H

      end do
    end do

  end do
end do

return

end subroutine verify_CG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DIAG_R2(MATRIX,N,INFO,W,Z)
C
C   THIS ROUTINE PERFORMS THE DIAGONALIZATION OF A Real SQUARE
C   MATRIX WITH THE DIMENSION NBTOT. THE EIGENVALUES OF THE DIAGONALIZATION
C   ARE DIRECTED INTO W1 AND THE Real EIGENVECTORS ARE WRITTEN TO Z1.
C

      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)       :: N
      Integer, intent(out)      :: INFO
      Real(kind=8), intent(in) :: MATRIX(N,N)
      Real(kind=8), intent(out):: W(N), Z(N,N)
      ! local variables:
      Integer       :: I,J
      Real(kind=8), allocatable :: AP(:)   !(N*(N+1)/2)
      Real(kind=8), allocatable :: WORK(:) !(3*N)
      Real(kind=8), allocatable :: W1(:)   !(N)
      Real(kind=8), allocatable :: Z1(:,:) !(N,N)

C initializations
      INFO=0
      If(N<1) Return

      Call dcopy_(        N,[0.0_wp],0,  W ,1)
      Call dcopy_(      N*N,[0.0_wp],0,  Z ,1)

      Call mma_allocate(AP,(N*(N+1)/2), 'AP')
      Call mma_allocate(WORK,3*N,'WORK')
      Call mma_allocate(W1,N,'W1')
      Call mma_allocate(Z1,N,N,'Z1')
      Call dcopy_(N*(N+1)/2, [0.0_wp],0,  AP,1)
      Call dcopy_(      3*N, [0.0_wp],0,WORK,1)
      Call dcopy_(        N, [0.0_wp],0,  W1,1)
      Call dcopy_(      N*N, [0.0_wp],0,  Z1,1)

      Do j=1,N
        Do i=1,j
          AP(i+(j-1)*j/2)=MATRIX(i,j)
        End Do
      End Do
      ! diagonalize:
      Call DSPEV_('V','U',N,AP,W1,Z1,N,WORK,INFO)

      Call dcopy_(  N,W1,1,W,1)
      Call dcopy_(N*N,Z1,1,Z,1)

      Call mma_deallocate(AP)
      Call mma_deallocate(WORK)
      Call mma_deallocate(W1)
      Call mma_deallocate(Z1)
      Return
      End Subroutine DIAG_R2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

!#define _DEBUGPRINT_
subroutine OneEl_Integrals(Kernel,KrnlMm,Label,ip,lOper,nComp,CCoor,nOrdOp,rHrmt,iChO,Integrals)

use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
procedure(int_kernel) :: Kernel
procedure(int_mem) :: KrnlMm
character(len=8), intent(in) :: Label
integer(kind=iwp), intent(in) :: nComp, lOper(nComp), nOrdOp, iChO(nComp)
integer(kind=iwp), intent(out) :: ip(nComp)
real(kind=wp), intent(in) :: CCoor(3,nComp), rHrmt
real(kind=wp), allocatable, intent(out) :: Integrals(:)
integer(kind=iwp) :: iComp, iIrrep, iStabO(0:7), LenInt, LenTot, llOper, nIC, nStabO
real(kind=wp) :: dum(1)
integer(kind=iwp), external :: n2Tri

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) ' In OneEl: Label',Label
write(u6,*) ' In OneEl: nComp'
write(u6,'(1X,8I5)') nComp
write(u6,*) ' In OneEl: lOper'
write(u6,'(1X,8I5)') lOper
write(u6,*) ' In OneEl: n2Tri'
do iComp=1,nComp
  ip(iComp) = n2Tri(lOper(iComp))
end do
write(u6,'(1X,8I5)') (ip(iComp),iComp=1,nComp)
call RecPrt(' CCoor',' ',CCoor,3,nComp)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the number of blocks from each component of the operator
! and the irreps it will span.

nIC = 0
llOper = 0
do iComp=1,nComp
  llOper = ior(llOper,lOper(iComp))
  do iIrrep=0,nIrrep-1
    if (btest(lOper(iComp),iIrrep)) nIC = nIC+1
  end do
end do
#ifdef _DEBUGPRINT_
write(u6,*) ' nIC =',nIC
#endif
if (nIC == 0) then
  call WarningMessage(2,'OneEl_Integrals: nIC == 0')
  call Abend()
end if
call SOS(iStabO,nStabO,llOper)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate memory for symmetry adapted one electron integrals.
! Will just store the unique elements, i.e. low triangular blocks
! and lower triangular elements in the diagonal blocks.

ip(:) = -1
LenTot = 0
do iComp=1,nComp
  ip(iComp) = 1+LenTot
  LenInt = n2Tri(lOper(iComp))
  LenTot = LenTot+LenInt+4
end do
call mma_allocate(Integrals,LenTot,Label='Integrals')
Integrals(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute all SO integrals for all components of the operator.

call OneEl_Inner(Kernel,KrnlMm,Label,ip,lOper,nComp,CCoor,nOrdOp,rHrmt,iChO,iStabO,nStabO,nIC,Dum,1,0,Integrals,LenTot)
!                                                                      *
!***********************************************************************
!                                                                      *
return

#undef _DEBUGPRINT_
end subroutine OneEl_Integrals

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Francesco Aquilante                              *
!               2014, Thomas Bondo Pedersen                            *
!***********************************************************************
!  INV_CHO_FACTOR
!
!> @brief
!>   Evaluation of the inverse Cholesky factor (\f$ Q \f$) of a SPD matrix (\f$ A \f$)
!>   by using a modified Gram--Schmidt orthonormalization of a set
!>   of unit vectors
!> @author F. Aquilante (Nov. 2006)
!> @modified_by T.B. Pedersen (2014) Change criterion for too negative norm
!>
!> @details
!> Evaluation of the inverse Cholesky factor (\f$ Q \f$) of a SPD matrix (\f$ A \f$)
!> by using a modified Gram--Schmidt orthonormalization of a set of unit vectors \f$ V: V(i,k)=\delta_{ik} \f$):
!>
!> \code
!>   For k=1,dim(A)
!>     Qu_k = V_k - sum_j=1^k-1 (Q_j^T * A * V_k) * Q_j
!>          = V_k - sum_j=1^k-1 (Q_j^T * A_k) * Q_j
!>     Q_k = Qu_k / sqrt(Qu_k^T * A_k * Qu_k)
!> \endcode
!>
!> The result is such that the inverse of A is Cholesky decomposed as
!>
!> \f[ A^{-1} = Q Q^\text{T} \f]
!> (\f$ Q \f$ is a full-rank upper triangular matrix)
!>
!> or in general (also for rank deficient \f$ A \f$) such that
!>
!> \f[ Q^\text{T} A Q = I \f]
!>
!> The inverse Cholesky factor is in general *NOT UNIQUE!!*
!> Therefore, and for stability reason, a full pivoting of the
!> initial matrix \f$ A \f$ would be advisable.
!>
!> Worth of mention is the fact that the lower triangular
!> matrix L such that
!>
!> \f[ A = L L^\text{T} \f]
!> (Cholesky decomposition of \f$ A \f$)
!>
!> can be computed as: \f$ L = A Q \f$
!>
!> @side_effects
!> In output \p A_k is returned in a PACKED form (i.e. off-diagonal elements are
!> scaled by two); the latter is the form in which it should be stored as column of \p Am.
!> In case of detected linear dependence, the \p Q_k array is returned as zeros!
!>
!> @note
!> Triangular storage must be used for the \f$ Q \f$-matrix!
!>
!> @param[in,out] A_k    \p kCol -th column of \f$ A \f$ (min. size \p kCol)
!> @param[in]     kCol   index of the column/vector
!> @param[in]     Am     in-core part of the matrix \f$ A \f$ (triangular storage)
!> @param[in]     Qm     in-core matrix whose columns are the orthonormal vectors (triangular storage)
!> @param[in]     nMem   max number of columns of \p Qm (and also of \p Am) kept in core
!> @param[in]     lu_A   file unit where the \f$ A \f$-matrix is stored
!> @param[in]     lu_Q   file unit where the \f$ Q \f$-matrix is stored
!> @param[in]     Scr    scratch space used for reading out-of-core columns of \p Qm and \p Am
!> @param[in]     lScr   size of the scratch space (&ge; \p kCol-1 or ``0`` iff in-core)
!> @param[in]     Z      auxiliary array of min. size \p kCol (always needed)
!> @param[in]     X      auxiliary array of min. size \p kCol-1 (needed only for the out-of-core case)
!> @param[in]     thr    threshold for linear dependence
!> @param[out]    Q_k    the \p kCol -th column of \p Qm (min. size \p kCol)
!> @param[out]    lindep integer indicating detected linear dependence (= ``1`` iff found lin dep, else = ``0``)
!***********************************************************************

subroutine INV_CHO_FACTOR(A_k,kCol,Am,Qm,nMem,lu_A,lu_Q,Scr,lScr,Z,X,thr,Q_k,lindep)

use Index_Functions, only: iTri, nTri_Elem
#ifdef _MOLCAS_MPP_
use Para_Info, only: MyRank, nProcs, Is_Real_Par
#endif
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: A_k(*)
integer(kind=iwp), intent(in) :: kCol, nMem, lu_A, lu_Q, lScr
real(kind=wp), intent(in) :: Am(*), Qm(*), thr
real(kind=wp), intent(_OUT_) :: Scr(*), Z(*), X(*), Q_k(*)
integer(kind=iwp), intent(out) :: lindep
#include "warnings.h"
integer(kind=iwp) :: i, IJ, j, jp, kdone, kread, kstart, lQcol, lQdone, lQdone_, lQread
real(kind=wp) :: sprev, xnorm
real(kind=wp), parameter :: thr_neg = -1.0e-8_wp
real(kind=r8), external :: ddot_

!***********************************************************************
if (thr < zero) then
  call WarningMessage(2,'Error in Inv_Cho_Factor')
  write(u6,*) 'thr must be >= zero'
  call Quit(_RC_CHO_LOG_)
end if

lindep = 0

if (kCol <= nMem) then

  ! Compute scalar product of A_k with previous vectors
  ! ---------------------------------------------------
  jp = 1
  do j=1,kCol-1
    Z(j) = ddot_(j,A_k(1),1,Qm(jp),1)
    jp = jp+j
  end do
  !call RecPrt('A_k*Qm',' ',Z,1,kCol)

  ! Compute unnormalized k-th vector
  ! --------------------------------
  ! SVC: this piece of code was computing Q_k = - Qm * Z, where Q_k and Z
  ! are vectors of length kCol-1, and Qm is a matrix in triangular storage
  ! with column-wise layout:
  !   |Q_k(1)     |      |Qm(1,1) Qm(1,2) ... Qm(1,kCol-1)     |   |Z(1)     |
  !   |Q_k(2)     |      |        Qm(2,2) ... Qm(2,kCol-1)     |   |Z(2)     |
  !   | ...       |  = - |                ...     ...          | * |...      |
  !   | ...       |      |                                     |   |...      |
  !   |Q_k(kCol-1)|      |                    Qm(kCol-1,kCol-1)|   |Z(kCol-1)|
  ! In order to improve performance, I've used the DTPMV routine from
  ! BLAS. For parallel processes, we will block up the triangular matrix
  ! and divide the blocks over the processes, using either DTPMV or DGEMV
  ! on the blocks (depending if it is a diagonal or off-diagonal block).

  Q_k(1:kCol-1) = Zero
# ifdef _MOLCAS_MPP_
  if (is_real_par() .and. (kCol >= 500)) then
    ! SVC: the best way would probably be to chop up the triangular matrix
    ! into blocks, and then call DTPMV/DGEMV on those blocks. To keep things
    ! simple, I've just used a series of DAXPY's on each column of the
    ! triangular matrix, this should be sufficient (for now).
    do J=1+MYRANK,KCOL-1,NPROCS
      IJ = iTri(J,1)
      Q_k(1:J) = Q_k(1:J)-Z(J)*Qm(IJ:IJ+J-1)
    end do
    call GAdGOp(Q_k,kCol-1,'+')
  else
# endif
    Q_k(1:kCol-1) = Q_k(1:kCol-1)-Z(1:kCol-1)
    call DTPMV('U','N','N',kCol-1,Qm,Q_k,1)
# ifdef _MOLCAS_MPP_
  end if
# endif
  Q_k(kCol) = one

  ! Normalize k-th vector :   ||Q_k|| = Q_k^T * A * Q_k
  ! ---------------------------------------------------

  A_k(1:kCol-1) = Two*A_k(1:kCol-1) ! packing of A_k

  Z(kCol) = ddot_(kCol,A_k(1),1,Q_k(1),1) !contrib fr k-th col of A

  jp = 1
  do j=1,kCol-1 ! contrib. from previous columns of A
    Z(j) = ddot_(j,Q_k(1),1,Am(jp),1)
    jp = jp+j
  end do

  xnorm = ddot_(kCol,Z(1),1,Q_k(1),1)

  if (xnorm >= thr) then

    xnorm = one/sqrt(xnorm)
    Q_k(1:kCol) = xnorm*Q_k(1:kCol)

    !-tbp: use fixed criterion for too negative diagonal
    !else if ((xnorm > zero) .or. (-xnorm <= Ten*thr)) then
  else if (xnorm > thr_neg) then

    lindep = 1
    Q_k(1:kCol) = Zero

  else

    call WarningMessage(2,'Error in Inv_Cho_Factor')
    write(u6,*) 'INV_CHO_FACTOR: too-negative value for norm(Q_k).'
    write(u6,*) 'INV_CHO_FACTOR: xnorm = ',xnorm
    call Quit(_RC_CHO_RUN_)

  end if

  !                                                                    *
  !*********************************************************************
  !                                                                    *
else   ! the first nMem columns of Q are in memory
  !                                                                    *
  !*********************************************************************
  !                                                                    *

  if (lScr < kCol-1) then
    call WarningMessage(2,'Error in Inv_Cho_Factor')
    write(u6,*) 'lScr must be >= kCol-1'
    call Quit(_RC_CHO_LOG_)
  end if

  X(1:kCol-1) = Zero

  ! Compute scalar product of A_k with in-core previous vectors
  ! -----------------------------------------------------------
  jp = 1
  do j=1,nMem
    Z(j) = ddot_(j,A_k(1),1,Qm(jp),1)
    jp = jp+j
  end do

  ! Batch for the out-of-core previous vectors
  ! ------------------------------------------
  kdone = nMem
  lQcol = nTri_Elem(kCol-1) ! length up to kCol-1
  do while (kdone < kCol-1)

    lQdone = nTri_Elem(kdone)
    lQdone_ = lQdone
    lQread = lQcol-lQdone

    kread = kCol-1
    do while (lQread > lScr)
      lQread = lQread-kread
      kread = kread-1
    end do

    call ddafile(lu_Q,2,Scr,lQread,lQdone_) ! read

    jp = 1
    do j=kdone+1,kread
      Z(j) = ddot_(j,A_k,1,Scr(jp),1)
      jp = jp+j
    end do

    ! Store an out-of-core intermediate for the Q-vectors
    ! ---------------------------------------------------
    do i=1,kread
      sprev = zero
      kstart = max(i,kdone+1) ! ((j >= i) .and. j_out_of_core)
      do j=kstart,kread
        ij = iTri(j,i)-lQdone
        sprev = sprev+Z(j)*Scr(ij)
      end do
      X(i) = X(i)+sprev
    end do

    kdone = kread

  end do
  !call RecPrt('A_k*Qm',' ',Z,1,kCol)

  ! Compute unnormalized k-th vector
  ! --------------------------------
  do i=1,kCol-1
    sprev = X(i) ! out-of-core contrib.
    do j=i,nMem
      ij = iTri(j,i)
      sprev = sprev+Z(j)*Qm(ij)
    end do
    Q_k(i) = -sprev
  end do
  Q_k(kCol) = one

  ! Normalize k-th vector :   ||Q_k|| = Q_k^T * A * Q_k
  ! ---------------------------------------------------

  A_k(1:kCol-1) = Two*A_k(1:kCol-1) ! packing of A_k

  Z(kCol) = ddot_(kCol,A_k(1),1,Q_k(1),1) !contrib fr k-th col of A

  ! Batch for the out-of-core previous vectors
  ! ------------------------------------------
  kdone = nMem
  lQcol = nTri_Elem(kCol-1) ! length up to kCol-1
  do while (kdone < kCol-1)

    lQdone = nTri_Elem(kdone)
    lQread = lQcol-lQdone

    kread = kCol-1
    do while (lQread > lScr)
      lQread = lQread-kread
      kread = kread-1
    end do

    ! Out-of-core intermediate to be used for the normalization factor
    ! ----------------------------------------------------------------
    call ddafile(lu_A,2,Scr,lQread,lQdone) ! read

    jp = 1
    do j=kdone+1,kread
      Z(j) = ddot_(j,Q_k,1,Scr(jp),1)
      jp = jp+j
    end do

    kdone = kread

  end do

  jp = 1
  do j=1,nMem ! contrib. from in-core previous columns of A
    Z(j) = ddot_(j,Q_k(1),1,Am(jp),1)
    jp = jp+j
  end do

  xnorm = ddot_(kCol,Z(1),1,Q_k(1),1)

  if (xnorm >= thr) then

    xnorm = one/sqrt(xnorm)
    Q_k(1:kCol) = xnorm*Q_k(1:kCol)

    !-tbp: use fixed criterion for too negative diagonal
    !else if ((xnorm > zero) .or. (-xnorm <= Ten*thr)) then
  else if (xnorm > thr_neg) then

    lindep = 1
    Q_k(1:kCol) = Zero

  else

    call WarningMessage(2,'Error in Inv_Cho_Factor')
    write(u6,*) 'INV_CHO_FACTOR: too-negative value for norm(Q_k).'
    write(u6,*) 'INV_CHO_FACTOR: xnorm = ',xnorm
    call Quit(_RC_CHO_RUN_)

  end if

end if

return

end subroutine INV_CHO_FACTOR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine CmbnT1(Rnxyz,nZeta,la,lb,Zeta,rKappa,Final,Txyz,
     &                  Alpha,Beta,Grad,nGrad,DAO,IfGrad,IndGrd,iStab,
     &                  jStab,kOp)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChBas
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6),
     &       Zeta(nZeta), rKappa(nZeta), Alpha(nZeta), Beta(nZeta),
     &       Rnxyz(nZeta,3,0:la+2,0:lb+2), Grad(nGrad),
     &       Txyz(nZeta,3,0:la+1,0:lb+1),
     &       DAO(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2)
      Logical IfGrad(3,2)
      Integer IndGrd(3,2), kOp(2)
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
      iRout = 134
      iPrint = nPrint(iRout)
*
*     ii = la*(la+1)*(la+2)/6
*     jj = lb*(lb+1)*(lb+2)/6
      exp32 = -Three/Two
      Do 25 iZeta = 1, nZeta
         rKappa(iZeta) = rKappa(iZeta) * Zeta(iZeta)**exp32
 25   Continue
      Do 10 ixa = 0, la
         iyaMax=la-ixa
      Do 11 ixb = 0, lb
         iybMax=lb-ixb
         Do 20 iya = 0, iyaMax
            iza = la-ixa-iya
            ipa= Ind(la,ixa,iza)
*           iChBs = iChBas(ii+ipa)
*           pa = DBLE(iPrmt(kOp(1),iChBs))
         Do 21 iyb = 0, iybMax
            izb = lb-ixb-iyb
            ipb= Ind(lb,ixb,izb)
*           jChBs = iChBas(jj+ipb)
*           papb = DBLE(iPrmt(kOp(2),jChBs)) * pa
*
*           Combine integrals
*
            tTwo = Two
            If (IfGrad(1,1)) Then
               If (ixa.gt.0) Then
                  xa = Dble(-ixa)
                  Do 30 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,1) =
     &                rKappa(iZeta) * (
     &          (tTwo*Txyz(iZeta,1,ixa+1,ixb)*Alpha(iZeta) +
     &             xa*Txyz(iZeta,1,ixa-1,ixb) )*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb) +
     &         (tTwo*Rnxyz(iZeta,1,ixa+1,ixb)*Alpha(iZeta) +
     &            xa*Rnxyz(iZeta,1,ixa-1,ixb) )*
     &               Txyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb) +
     &         (tTwo*Rnxyz(iZeta,1,ixa+1,ixb)*Alpha(iZeta) +
     &            xa*Rnxyz(iZeta,1,ixa-1,ixb) )*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Txyz(iZeta,3,iza,izb) )
 30               Continue
               Else
                  Do 31 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,1) =
     &                rKappa(iZeta) * Alpha(iZeta) * (
     &           tTwo*Txyz(iZeta,1,ixa+1,ixb) *
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb) +
     &          tTwo*Rnxyz(iZeta,1,ixa+1,ixb) *
     &               Txyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb) +
     &          tTwo*Rnxyz(iZeta,1,ixa+1,ixb) *
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Txyz(iZeta,3,iza,izb) )
 31               Continue
               End If
            End If
            If (IfGrad(1,2)) Then
               If (ixb.gt.0) Then
                  xb = Dble(-ixb)
                  Do 35 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,4) =
     &                rKappa(iZeta) * (
     &          (tTwo*Txyz(iZeta,1,ixa,ixb+1)*Beta(iZeta) +
     &             xb*Txyz(iZeta,1,ixa,ixb-1) )*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb) +
     &         (tTwo*Rnxyz(iZeta,1,ixa,ixb+1)*Beta(iZeta) +
     &            xb*Rnxyz(iZeta,1,ixa,ixb-1) )*
     &               Txyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb) +
     &         (tTwo*Rnxyz(iZeta,1,ixa,ixb+1)*Beta(iZeta) +
     &            xb*Rnxyz(iZeta,1,ixa,ixb-1) )*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Txyz(iZeta,3,iza,izb) )
 35               Continue
               Else
                  Do 36 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,4) =
     &                rKappa(iZeta) * Beta(iZeta) * (
     &           tTwo*Txyz(iZeta,1,ixa,ixb+1) *
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb) +
     &          tTwo*Rnxyz(iZeta,1,ixa,ixb+1) *
     &               Txyz(iZeta,2,iya,iyb)*
     &               Rnxyz(iZeta,3,iza,izb) +
     &          tTwo*Rnxyz(iZeta,1,ixa,ixb+1) *
     &               Rnxyz(iZeta,2,iya,iyb)*
     &               Txyz(iZeta,3,iza,izb) )
 36               Continue
               End If
            End If
            If (IfGrad(2,1)) Then
               If (iya.gt.0) Then
                  ya = Dble(-iya)
                  Do 40 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,2) =
     &                rKappa(iZeta) * (
     &                Txyz(iZeta,1,ixa,ixb)*
     &         (tTwo*Rnxyz(iZeta,2,iya+1,iyb)*Alpha(iZeta) +
     &            ya*Rnxyz(iZeta,2,iya-1,iyb) )*
     &               Rnxyz(iZeta,3,iza,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &          (tTwo*Txyz(iZeta,2,iya+1,iyb)*Alpha(iZeta) +
     &             ya*Txyz(iZeta,2,iya-1,iyb) )*
     &               Rnxyz(iZeta,3,iza,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb) *
     &         (tTwo*Rnxyz(iZeta,2,iya+1,iyb)*Alpha(iZeta) +
     &            ya*Rnxyz(iZeta,2,iya-1,iyb) )*
     &               Txyz(iZeta,3,iza,izb) )
 40               Continue
               Else
                  Do 41 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,2) =
     &                rKappa(iZeta) * Alpha(iZeta) * (
     &                Txyz(iZeta,1,ixa,ixb)*
     &          tTwo*Rnxyz(iZeta,2,iya+1,iyb) *
     &               Rnxyz(iZeta,3,iza,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &           tTwo*Txyz(iZeta,2,iya+1,iyb) *
     &               Rnxyz(iZeta,3,iza,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb) *
     &          tTwo*Rnxyz(iZeta,2,iya+1,iyb) *
     &               Txyz(iZeta,3,iza,izb) )
 41               Continue
               End If
            End If
            If (IfGrad(2,2)) Then
               If (iyb.gt.0) Then
                  yb = Dble(-iyb)
                  Do 45 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,5) =
     &                rKappa(iZeta) * (
     &                Txyz(iZeta,1,ixa,ixb)*
     &         (tTwo*Rnxyz(iZeta,2,iya,iyb+1)*Beta(iZeta) +
     &            yb*Rnxyz(iZeta,2,iya,iyb-1) )*
     &               Rnxyz(iZeta,3,iza,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &          (tTwo*Txyz(iZeta,2,iya,iyb+1)*Beta(iZeta) +
     &             yb*Txyz(iZeta,2,iya,iyb-1) )*
     &               Rnxyz(iZeta,3,iza,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb) *
     &         (tTwo*Rnxyz(iZeta,2,iya,iyb+1)*Beta(iZeta) +
     &            yb*Rnxyz(iZeta,2,iya,iyb-1) )*
     &               Txyz(iZeta,3,iza,izb) )
 45               Continue
               Else
                  Do 46 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,5) =
     &                rKappa(iZeta) * Beta(iZeta) * (
     &                Txyz(iZeta,1,ixa,ixb)*
     &          tTwo*Rnxyz(iZeta,2,iya,iyb+1) *
     &               Rnxyz(iZeta,3,iza,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &           tTwo*Txyz(iZeta,2,iya,iyb+1) *
     &               Rnxyz(iZeta,3,iza,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb) *
     &          tTwo*Rnxyz(iZeta,2,iya,iyb+1) *
     &               Txyz(iZeta,3,iza,izb) )
 46               Continue
               End If
            End If
            If (IfGrad(3,1)) Then
               If (iza.gt.0) Then
                  za = Dble(-iza)
                  Do 50 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,3) =
     &                rKappa(iZeta) * (
     &                Txyz(iZeta,1,ixa,ixb)*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &         (tTwo*Rnxyz(iZeta,3,iza+1,izb)*Alpha(iZeta) +
     &            za*Rnxyz(iZeta,3,iza-1,izb) ) +
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &                Txyz(iZeta,2,iya,iyb)*
     &         (tTwo*Rnxyz(iZeta,3,iza+1,izb)*Alpha(iZeta) +
     &            za*Rnxyz(iZeta,3,iza-1,izb) ) +
     &               Rnxyz(iZeta,1,ixa,ixb) *
     &               Rnxyz(iZeta,2,iya,iyb)*
     &          (tTwo*Txyz(iZeta,3,iza+1,izb)*Alpha(iZeta) +
     &             za*Txyz(iZeta,3,iza-1,izb) ) )
 50               Continue
               Else
                  Do 51 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,3) =
     &                rKappa(iZeta) * Alpha(iZeta) * (
     &                Txyz(iZeta,1,ixa,ixb)*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &          tTwo*Rnxyz(iZeta,3,iza+1,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &                Txyz(iZeta,2,iya,iyb)*
     &          tTwo*Rnxyz(iZeta,3,iza+1,izb) +
     &               Rnxyz(iZeta,1,ixa,ixb) *
     &               Rnxyz(iZeta,2,iya,iyb)*
     &           tTwo*Txyz(iZeta,3,iza+1,izb) )
 51               Continue
               End If
            End If
            If (IfGrad(3,2)) Then
               If (izb.gt.0) Then
                  zb = Dble(-izb)
                  Do 55 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,6) =
     &                rKappa(iZeta) * (
     &                Txyz(iZeta,1,ixa,ixb)*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &         (tTwo*Rnxyz(iZeta,3,iza,izb+1)*Beta(iZeta) +
     &            zb*Rnxyz(iZeta,3,iza,izb-1) ) +
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &                Txyz(iZeta,2,iya,iyb)*
     &         (tTwo*Rnxyz(iZeta,3,iza,izb+1)*Beta(iZeta) +
     &            zb*Rnxyz(iZeta,3,iza,izb-1) ) +
     &               Rnxyz(iZeta,1,ixa,ixb) *
     &               Rnxyz(iZeta,2,iya,iyb)*
     &          (tTwo*Txyz(iZeta,3,iza,izb+1)*Beta(iZeta) +
     &             zb*Txyz(iZeta,3,iza,izb-1) ) )
 55               Continue
               Else
                  Do 56 iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,6) =
     &                rKappa(iZeta) * Beta(iZeta) * (
     &                Txyz(iZeta,1,ixa,ixb)*
     &               Rnxyz(iZeta,2,iya,iyb)*
     &          tTwo*Rnxyz(iZeta,3,iza,izb+1) +
     &               Rnxyz(iZeta,1,ixa,ixb)*
     &                Txyz(iZeta,2,iya,iyb)*
     &          tTwo*Rnxyz(iZeta,3,iza,izb+1) +
     &               Rnxyz(iZeta,1,ixa,ixb) *
     &               Rnxyz(iZeta,2,iya,iyb)*
     &           tTwo*Txyz(iZeta,3,iza,izb+1) )
 56               Continue
               End If
            End If
*
 21      Continue
 20      Continue
 11   Continue
 10   Continue
*
*     Trace the gradient integrals
*
      nDAO = nZeta * (la+1)*(la+2)/2 * (lb+1)*(lb+2)/2
      If (iPrint.ge.99) Then
         Call RecPrt(' T(1)',' ',Final,nDAO,6)
         Call RecPrt('  D  ',' ',DAO,1,nDAO)
      End If
      Do 100 iCn = 1, 2
         Do 110 iCar = 1, 3
            If (IndGrd(iCar,iCn).ne.0) Then
*              Accumulate contribution to the gradient
               iGrad = Abs(IndGrd(iCar,iCn))
               If (iCn.eq.1) Then
                   i1 = iCar
                   i2 = iCar + 3
                   ps = DBLE( iPrmt( kOp(1), iChBas(1+iCar) ) )
                   Fact = DBLE(iStab)/DBLE(nIrrep)
               Else
                   i1 = iCar + 3
                   i2 = iCar
                   ps = DBLE( iPrmt( kOp(2), iChBas(1+iCar) ) )
                   Fact = ps * DBLE(jStab)/DBLE(nIrrep)
               End if
*              Write (*,*) ' Fact=', Fact, ps
               If (IndGrd(iCar,iCn).lt.0) Then
*                 Gradient via translational invariance.
                  Grad(iGrad) = Grad(iGrad) - Fact*
     &                DDot_(nDAO,DAO,1,Final(1,1,1,i2),1)
               Else
                  Grad(iGrad) = Grad(iGrad) + Fact*
     &                DDot_(nDAO,DAO,1,Final(1,1,1,i1),1)
               End If
            End If
 110     Continue
 100  Continue
*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombUpperBoundNorm(PrintNorm,nD,FactC,ip_DBlocks,UBFNorm)
! Thomas Bondo Pedersen, January 2011.
!
! Purpose: compute norm of the upper bound to the Coulomb Fock
!          matrix error in LDF.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: PrintNorm
integer(kind=iwp), intent(in) :: nD, ip_DBlocks(nD)
real(kind=wp), intent(in) :: FactC(nD)
real(kind=wp), intent(out) :: UBFNorm(nD)
integer(kind=iwp) :: ip, l_U, iD, AB, A, B, nAB, ipDel, uv
real(kind=wp), allocatable :: U(:)
integer(kind=iwp), external :: LDF_nBas_Atom
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

if (nD < 1) return
if (NumberOfAtomPairs < 1) return

!-tbp Call LDF_GetQuadraticDiagonal(ip)
ip = ip_AP_Diag
l_U = nD
call mma_allocate(U,l_U,label='CUBNrmU')
call LDF_ComputeU(iWork(ip),nD,ip_DBlocks,U)
do iD=1,nD
  UBFNorm(iD) = Zero
  do AB=1,NumberOfAtomPairs
    A = iWork(ip_AP_Atoms-1+2*(AB-1)+1)
    B = iWork(ip_AP_Atoms-1+2*(AB-1)+2)
    nAB = LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
    ipDel = iWork(ip-1+AB)-1
    do uv=1,nAB
      UBFNorm(iD) = UBFNorm(iD)+Work(ipDel+uv)
    end do
  end do
  UBFNorm(iD) = FactC(iD)*U(iD)*sqrt(UBFNorm(iD))
end do
call mma_deallocate(U)
!-tbp Call LDF_FreeQuadraticDiagonal(ip)

if (PrintNorm) then
  do iD=1,nD
    write(u6,'(A,I10,A,1P,D20.10,1X,A,D20.10,A)') 'Norm of upper bound Coulomb error for density',iD,':',UBFNorm(iD),'(BlockRMS=', &
                                                  sqrt(UBFNorm(iD)**2/real(NumberOfAtomPairs,kind=wp)),')'
  end do
  call xFlush(u6)
end if

end subroutine LDF_Fock_CoulombUpperBoundNorm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1971, Nelson H. F. Beebe                               *
!***********************************************************************

subroutine CHO_OUTPUT(AMATRX,ROWLOW,ROWHI,COLLOW,COLHI,ROWDIM,COLDIM,NCTL,LUPRI)
!.......................................................................
!
! OUTPUT PRINTS A REAL MATRIX IN FORMATTED FORM WITH NUMBERED ROWS
! AND COLUMNS.  THE INPUT IS AS FOLLOWS;
!
!        AMATRX(',').........MATRIX TO BE OUTPUT
!
!        ROWLOW..............ROW NUMBER AT WHICH OUTPUT IS TO BEGIN
!
!        ROWHI...............ROW NUMBER AT WHICH OUTPUT IS TO END
!
!        COLLOW..............COLUMN NUMBER AT WHICH OUTPUT IS TO BEGIN
!
!        COLHI...............COLUMN NUMBER AT WHICH OUTPUT IS TO END
!
!        ROWDIM..............ROW DIMENSION OF AMATRX(',')
!
!        COLDIM..............COLUMN DIMENSION OF AMATRX(',')
!
!        NCTL................CARRIAGE CONTROL FLAG; 1 FOR SINGLE SPACE
!                                                   2 FOR DOUBLE SPACE
!                                                   3 FOR TRIPLE SPACE
!
! THE PARAMETERS THAT FOLLOW MATRIX ARE ALL OF TYPE INTEGER.  THE
! PROGRAM IS SET UP TO HANDLE 5 COLUMNS/PAGE WITH A 5ES24.15 FORMAT
! FOR THE COLUMNS.  IF A DIFFERENT NUMBER OF COLUMNS IS REQUIRED,
! CHANGE FORMATS 1000 AND 2000, AND INITIALIZE KCOL WITH THE NEW NUMBER
! OF COLUMNS.
!
! AUTHOR;  NELSON H.F. BEEBE, QUANTUM THEORY PROJECT, UNIVERSITY OF
!          FLORIDA, GAINESVILLE
! REVISED; FEBRUARY 26, 1971
!
!.......................................................................

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ROWLOW, ROWHI, COLLOW, COLHI, ROWDIM, COLDIM, NCTL, LUPRI
real(kind=wp), intent(in) :: AMATRX(ROWDIM,COLDIM)
integer(kind=iwp) :: BEGIN, I, J, K, KCOL, LAST, MCTL
real(kind=wp) :: AMAX
character(len=20) :: PFMT
character :: CTL
integer(kind=iwp), parameter :: KCOLN = 6, KCOLP = 4
real(kind=wp), parameter :: FFMAX = 1.0e3_wp, FFMIN = 1.0e-3_wp
character(len=*), parameter :: ASA(3) = [' ','0','-'], BLNK = ' ', COLUMN = 'Column  '

if (ROWHI < ROWLOW) return
if (COLHI < COLLOW) return

AMAX = Zero
do J=COLLOW,COLHI
  do I=ROWLOW,ROWHI
    AMAX = max(AMAX,abs(AMATRX(I,J)))
  end do
end do
if (AMAX == Zero) then
  write(LUPRI,'(/T6,A)') 'Zero matrix.'
else
  if ((FFMIN <= AMAX) .and. (AMAX <= FFMAX)) then
    ! use F output format
    PFMT = '(A1,I7,2X,8F15.8)'
  else
    ! use ES output format
    PFMT = '(A1,I7,2X,8ES15.6)'
  end if

  if (NCTL < 0) then
    KCOL = KCOLN
  else
    KCOL = KCOLP
  end if
  MCTL = abs(NCTL)
  if ((MCTL <= 3) .and. (MCTL > 0)) then
    CTL = ASA(MCTL)
  else
    CTL = BLNK
  end if

  LAST = min(COLHI,COLLOW+KCOL-1)
  do BEGIN=COLLOW,COLHI,KCOL
    write(LUPRI,1000) (COLUMN,I,I=BEGIN,LAST)
    do K=ROWLOW,ROWHI
      do I=BEGIN,LAST
        if (AMATRX(K,I) /= Zero) then
          write(LUPRI,PFMT) CTL,K,(AMATRX(K,J),J=BEGIN,LAST)
          exit
        end if
      end do
    end do
    LAST = min(LAST+KCOL,COLHI)
  end do
end if

return

1000 format(/12X,6(3X,A6,I4,2X),(3X,A6,I4))
!2000 format(A1,'Row',I4,2X,8ES15.6)
!2000 format(A1,I7,2X,8ES15.6)

end subroutine CHO_OUTPUT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LDF_SetOptionFlag(Option,Val)

use Definitions, only: iwp, u6

implicit none
character(len=4), intent(in) :: Option
logical(kind=iwp), intent(in) :: Val
#include "localdf.fh"

if (Option == 'LDF2') then
  LDF2 = Val
else if (Option == 'CHEC') then
  CheckPairIntegrals = Val
else if (Option == 'VERI') then
  VerifyFit = Val
else if (Option == 'OVER') then
  CheckOverlapIntegrals = Val
else if (Option == 'WRUC') then
  WriteUnconstrainedC = Val
else if (Option == 'UNIQ') then
  UseUniqueAtomPairs = Val
else
  call WarningMessage(2,'LDF_SetOptionFlag: unknown Option')
  write(u6,'(A,A)') 'Option=',Option
  write(u6,'(A,L1)') 'Val=',Val
  call LDF_Quit(1)
end if

return

end subroutine LDF_SetOptionFlag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkorbfree_cvb()

use casvb_global, only: corth, ifxorb, iorts, irels, irots, nfr, nfrorb, nfrvb, nijrel, norb, north, nprorb, orbfr_is_unit, &
                        orbopt, orbs, relorb, trprm
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, i2, icon, ierr, ioff, ioff2, ioffs, iorb, irel, ishift, ishift2, j, j2, jorb, nc, ncon, nl1, nl2, nrem
real(kind=wp) :: dum(1), sum1, sum2
integer(kind=iwp), allocatable :: idel(:)
real(kind=wp), allocatable :: orbinv(:,:), owrk(:,:), owrk2(:,:)
real(kind=wp), parameter :: thresh = 1.0e-7_wp
real(kind=wp), external :: ddot_

if (orbfr_is_unit) then
  nfrorb = nprorb
else

  call mma_allocate(owrk,norb,norb,label='owrk')
  call mma_allocate(owrk2,norb,norb,label='owrk2')
  call mma_allocate(orbinv,norb,norb,label='orbinv')
  call mma_allocate(idel,nprorb,label='idel')

  trprm(:,:) = Zero
  idel(:) = 0
  orbinv(:,:) = orbs(:,:)
  call mxinv_cvb(orbinv,norb)

  nc = 0
  ioffs = 0
  do iorb=1,norb
    if ((north(iorb) > 0) .and. (ifxorb(iorb) /= 1)) then
      ! Transform simple constraints to basis of VB orbitals:
      call mxattb_cvb(orbs,corth(:,ioffs+1:),norb,norb,north(iorb),owrk)
      call span_cvb(owrk,north(iorb),ncon,dum,norb,0)
      ishift = (iorb-1)*(norb-1)
      do icon=1,ncon
        nc = nc+1
        i2 = 0
        do i=1,norb
          if (i /= iorb) then
            i2 = i2+1
            trprm(i2+ishift,nc) = owrk(i,icon)
          end if
        end do
      end do
    else if (ifxorb(iorb) == 1) then
      ishift = (iorb-1)*(norb-1)
      do icon=1,norb-1
        nc = nc+1
        trprm(icon+ishift,nc) = One
      end do
    end if
    ioffs = ioffs+north(iorb)
  end do

  call mxattb_cvb(orbs,orbs,norb,norb,norb,owrk)
  call ortelim_cvb(trprm,iorts,irots,owrk,nc,nprorb,norb*(norb-1),nrem)
  idel(1:nrem) = 1
  idel(nrem+1:) = 0

  do irel=1,nijrel
    iorb = irels(1,irel)
    jorb = irels(2,irel)
    call mxatb_cvb(relorb(:,:,irel),orbs,norb,norb,norb,owrk)
    call mxatb_cvb(orbinv,owrk,norb,norb,norb,owrk2)
    if (abs(abs(owrk2(iorb,jorb))-One) > thresh) then
      write(u6,*) ' Transformation matrix cannot be correct !'
      call mxprint_cvb(owrk2,norb,norb,0)
      call abend_cvb()
    end if
    ishift = (jorb-1)*(norb-1)
    ishift2 = (iorb-1)*(norb-1)
    i2 = 0
    do i=1,norb
      if (i == iorb) cycle
      i2 = i2+1
      j2 = 0
      do j=1,norb
        if (j == jorb) cycle
        j2 = j2+1
        trprm(i2+ishift2,:) = trprm(i2+ishift2,:)+owrk2(i,j)*trprm(j2+ishift,:)
      end do
    end do
    ioff = 1+(iorb-1)*(norb-1)
    ioff2 = 1+iorb*(norb-1)
    nl1 = (iorb-1)*(norb-1)
    nl2 = (norb-iorb)*(norb-1)
    do i=nrem+1,nprorb
      sum1 = ddot_(norb-1,trprm(ioff:,i),1,trprm(ioff:,i),1)
      sum2 = ddot_(nl1,trprm(:,i),1,trprm(:,i),1)
      if (nl2 > 0) sum2 = sum2+ddot_(nl2,trprm(ioff2:,i),1,trprm(ioff2:,i),1)
      if ((sum1 > thresh) .and. (sum2 < thresh)) idel(i) = 1
    end do
  end do
  nfrorb = 0
  do i=1,norb*(norb-1)
    if (idel(i) /= 1) then
      nfrorb = nfrorb+1
      trprm(:,nfrorb) = trprm(:,i)
    end if
  end do
  trprm(:,nfrorb+1:) = Zero
  ierr = 0
  call nize_cvb(trprm,nfrorb,dum,nprorb,0,ierr)

  call mma_deallocate(owrk)
  call mma_deallocate(owrk2)
  call mma_deallocate(orbinv)
  call mma_deallocate(idel)

end if

nfr = nfrorb+nfrvb
orbopt = (nfrorb /= 0)

return

end subroutine mkorbfree_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Roland Lindh                                     *
!               2010, Mickael G. Delcey                                *
!               2020, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Saddle()
!***********************************************************************
!                                                                      *
! Object: to set up for a TS optimization with the SADDLE approach.    *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             January 2009                                             *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use External_Centers, only: nRP, RP_Centers
use Isotopes, only: PTab
use Sizes_of_Seward, only: S
use Gateway_Info, only: Align_Only, Do_Align, E1, E2, lRP, lRP_Post, SadStep, Shake
use Symmetry_Info, only: nIrrep, VarR, VarT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four, Half, OneHalf, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
#include "warnings.h"
integer(kind=iwp) :: i, iAt, iAtSym, iCnt, iCnttp, iOff, iOff_Iter, iOpt, iOptExp, iProd, ipX2, ipX3, iRA1, iRA2, iReac, iRef, &
                     iRefAlign, iReturn, iRP, iSaddle, iX0, iX1, iX3, iXA0, iXA1, iXA2, iXA3, ixyz, j, jAt, jDim, jTmp, Lu_UDC, &
                     LuInput, mAt, nAt, nData, ndc, nSaddle, nSaddle_Max, nsc
real(kind=wp) :: C, D, Delta, deviation, dHSR, diff, HSR, HSR0, R11, R1_2, R1R2, R22, RandVect(3), RMax, RMSD, RMSMax, tmp, &
                 Update, wTot
logical(kind=iwp) :: FindTS, Found, Invar, Not_First_Iter, quadratic, Skip
character(len=16) :: StdIn
character :: Mode
integer(kind=iwp), allocatable :: iStab(:)
real(kind=wp), allocatable :: MEP(:,:), TanVec(:), TmpA(:), Vec(:,:), W(:), XYZ(:,:)
character(len=2), allocatable :: Elm(:)
integer(kind=iwp), external :: IsFreeUnit
real(kind=wp), external :: dmwdot

!***********************************************************************
!                                                                      *
!                            Prologue                                  *
!                                                                      *
!***********************************************************************

nSaddle_Max = 100
quadratic = .false.

! Avoid warnings

R11 = Zero
R22 = Zero
R1R2 = Zero
iX0 = -1
iX1 = -1

! If lRP true in Info and Saddle block active but set to zero then
! this is after the Saddle procedure is terminated and lRP should
! be ignored.

if (lRP) then
  call qpg_dArray('Saddle',Not_First_Iter,nData)
  if (Not_First_Iter .and. (nData == 0)) lRP = .false.
end if
lRP_Post = lRP

if (.not. lRP) return
!                                                                      *
!***********************************************************************
!                                                                      *
! Get informations about Saddle in RunFile

! Find out whether the energy is assumed invariant to trans. & rot.

Invar = .not. (VarR .or. VarT)

nAt = nRP/3
call qpg_dArray('Saddle',Not_First_Iter,nData)
nSaddle = 2*nRP+5
call mma_allocate(TmpA,nSaddle,label='TmpA')
if (Not_First_Iter) then
  call Get_dArray('Saddle',TmpA,nSaddle)
  Update = TmpA(2*nRP+5)

  if (Update /= One) then
    HSR = TmpA(2*nRP+4)
    call mma_deallocate(TmpA)
    lRP_Post = .false.
    call FinishUp()
    return
  end if
  Update = Zero

  call dcopy_(3*nAt,TmpA(1),1,RP_Centers(:,:,1),1)
  call dcopy_(3*nAt,TmpA(1+3*nAt),1,RP_Centers(:,:,2),1)
  E1 = TmpA(6*nAt+1)
  E2 = TmpA(6*nAt+2)
  HSR0 = TmpA(6*nAt+3)
else
  dHSR = Zero ! Dummy initialize
  Update = Zero
  HSR0 = Zero ! Dummy initialize
  iOff_Iter = 0
  call Put_iScalar('iOff_Iter',iOff_Iter)
  !                                                                  *
  !*******************************************************************
  !                                                                  *
  !       Get the symmetry stabilizers for each center

  call mma_allocate(iStab,nAt,label='iStab')
  iAt = 1
  nsc = 0
  do i=1,nCnttp
    do iCnt=1,dbsc(i)%nCntr
      nsc = nsc+1
      if (.not. (dbsc(i)%pChrg .or. dbsc(i)%Frag .or. dbsc(i)%Aux)) then
        jTmp = 0
        do j=1,dc(nsc)%nStab-1
          jTmp = ior(jTmp,dc(nsc)%iStab(j))
        end do
        iStab(iAt) = jTmp
        iAt = iAt+1
      end if
    end do
  end do

  ! Shake initial structures

  if (Shake > Zero) then
    do iAt=1,nAt
      S%nDim = 0
      do j=0,2
        if (.not. btest(iStab(iAt),j)) S%nDim = S%nDim+1
      end do
      if (S%nDim > 0) then
        do iRP=1,2
          call Random_Vector(S%nDim,RandVect(1:S%nDim),.false.)
          jDim = 0
          do j=0,2
            if (.not. btest(iStab(iAt),j)) then
              jDim = jDim+1
              RP_Centers(jDim,iAt,iRP) = RP_Centers(jDim,iAt,iRP)+Shake*RandVect(jDim)
            end if
          end do
        end do
      end if
    end do
  end if

  ! Retrieve the weights even if the structures are not
  ! going to be aligned explicitly

  call mma_Allocate(XYZ,3*nAt*8,2,label='XYZ')
  iReac = 1
  iProd = 2
  call Expand_Coor(RP_Centers(1,1,1),nAt,XYZ(1,iReac),mAt)
  call Expand_Coor(RP_Centers(1,1,2),nAt,XYZ(1,iProd),mAt)
  call Qpg_dArray('Weights',Found,nData)
  if (Found .and. (nData >= mAt)) then
    call mma_allocate(W,nData,label='W')
    call Get_dArray('Weights',W,nData)
  else
    call SysAbendMsg('Saddle','No or wrong weights were found in the RUNFILE.','')
  end if

  ! Align the reactant and product structures the first time.
  ! Only if energy is invariant

  if (Do_Align .and. Invar) then
    ! Note: this might break symmetry
    call Superpose_w(XYZ(1,iReac),XYZ(1,iProd),W,mAt,RMSD,RMSMax)
    call Fix_Symmetry(XYZ(1,iReac),nAt,iStab)
    call Add_Info('RMSD',[RMSD],1,6)
    call Add_Info('RMSMax',[RMSMax],1,6)
    call dcopy_(3*nAt,XYZ(:,iReac),1,RP_Centers(:,:,1),1)
    call dcopy_(3*nAt,XYZ(:,iProd),1,RP_Centers(:,:,2),1)

    if (Align_Only) then

      ! Get the atomic symbols with symmetry unfolded

      call mma_allocate(Elm,nAt)
      iAt = 0
      iAtSym = nAt
      ndc = 0
      do iCnttp=1,nCnttp
        do iCnt=1,dbsc(iCnttp)%nCntr
          ndc = ndc+1
          if (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
            iAt = iAt+1
            Elm(iAt) = PTab(dbsc(iCnttp)%AtmNr)
            do i=1,nIrrep/dc(ndc)%nStab-1
              iAtSym = iAtSym+1
              Elm(iAtSym) = Elm(iAt)
            end do
          end if
        end do
      end do

      write(u6,*)
      write(u6,*) 'Aligned Reactants and Products'
      write(u6,*) '=============================='
      write(u6,*)
      write(u6,*)
      write(u6,*) ' Reactants / Angstrom'
      write(u6,*) '====================='
      write(u6,*)
      do iAt=1,mAt
        write(u6,'(A,1X,3F15.8)') Elm(iAt),(XYZ((iAt-1)*3+jAt,iReac)*Angstrom,jAt=1,3)
      end do
      write(u6,*)
      write(u6,*)
      write(u6,*) ' Products / Angstrom'
      write(u6,*) '===================='
      write(u6,*)
      do iAt=1,mAt
        write(u6,'(A,1X,3F15.8)') Elm(iAt),(XYZ((iAt-1)*3+jAt,iProd)*Angstrom,jAt=1,3)
      end do
      write(u6,*)
      write(u6,*)
      call WarningMessage(2,'Molecular alignment completed')
      write(u6,*)
      iReturn = _RC_ALL_IS_WELL_
      call mma_deallocate(XYZ)
      call mma_deallocate(iStab)
      call mma_deallocate(W)
      call mma_deallocate(Elm)
      call ClsSew()
      call xQuit(iReturn)
    end if
  end if

  call mma_deallocate(XYZ)
  call mma_deallocate(iStab)
  call mma_deallocate(W)
end if
!                                                                    *
!*********************************************************************
!                                                                    *
! Determine the distance between the two structures

call mma_allocate(iStab,nAt,label='iStab')
iAt = 1
nsc = 0
do i=1,nCnttp
  do iCnt=1,dbsc(i)%nCntr
    nsc = nsc+1
    if (.not. (dbsc(i)%pChrg .or. dbsc(i)%Frag .or. dbsc(i)%Aux)) then
      jTmp = 0
      do j=1,dc(nsc)%nStab-1
        jTmp = ior(jTmp,dc(nsc)%iStab(j))
      end do
      iStab(iAt) = jTmp
      iAt = iAt+1
    end if
  end do
end do

call mma_allocate(XYZ,3*nAt*8,2,label='XYZ')
iRA1 = 1
iRA2 = 2
call Expand_Coor(RP_Centers(1,1,1),nAt,XYZ(1,iRA1),mAt)
call Expand_Coor(RP_Centers(1,1,2),nAt,XYZ(1,iRA2),mAt)
call Qpg_dArray('Weights',Found,nData)
if (Found .and. (nData >= mAt)) then
  call mma_allocate(W,nData,label='W')
  call Get_dArray('Weights',W,nData)
else
  call SysAbendMsg('Saddle','No or wrong weights were found in the RUNFILE.','')
end if
if (.not. Invar) then

  ! If the energy is not trans/rot invariant, compute the weighted
  ! RMSD with the current structures

  HSR = Zero
  wTot = Zero
  iOff = 1
  do i=1,mAt
    do ixyz=1,3
      diff = XYZ(iOff,iRA2)-XYZ(iOff,iRA1)
      HSR = HSR+W(i)*diff**2
      iOff = iOff+1
    end do
    wTot = wTot+W(i)
  end do
  HSR = sqrt(HSR/wTot)
else
  call Get_RMSD_w(XYZ(1,iRA2),XYZ(1,iRA1),W,mAt,HSR)
end if
call mma_deallocate(XYZ)

if (E1 <= E2) then
  Mode = 'R'
else
  Mode = 'P'
end if

!*********************************************************************
!                                                                    *
!                 Determine the desired HSR                          *
!                                                                    *
!*********************************************************************
if (Not_First_Iter) then

  ! FindTS

  FindTS = HSR <= (OneHalf*SadStep)
  if (FindTS) then
    write(u6,*) '**************************'
    write(u6,*) '* Enable TS optimization *'
    write(u6,*) '**************************'
    Update = Two
    Delta = Half-6.25_wp*(E2-E1)
    Delta = min(Delta,0.75_wp)
    Delta = max(Delta,0.25_wp)
    if (Mode == 'R') then
      HSR = (One-Delta)*HSR
    else
      HSR = Delta*HSR
    end if

    ! Calculate tangent vector

    call mma_allocate(TanVec,3*nAt,label='TanVec')
    if (Mode == 'R') then
      call Calc_LSTvec(3*nAt,RP_Centers(1,1,2),RP_Centers(1,1,1),TanVec,Invar)
    else
      call Calc_LSTvec(3*nAt,RP_Centers(1,1,1),RP_Centers(1,1,2),TanVec,Invar)
    end if
    call Put_dArray('TanVec',TanVec,3*nAt)
    call mma_deallocate(TanVec)
  else

    ! Try to be smart:
    ! be slow the first iterations and the last ones
    ! and also if large reorganisation the previous iteration

    call Qpg_iScalar('nMEP',Found)
    if (Found) then
      quadratic = .true.
      call Get_iScalar('nMEP',iSaddle)

      ! Compute some distances, used for quadratic interpolation

      call mma_Allocate(MEP,nRP,nSaddle_Max,label='MEP')
      call Get_dArray('MEP-Coor    ',MEP,nRP*nSaddle_Max)
      call mma_allocate(Vec,nRP,2,label='Vec')
      iX0 = iSaddle-2
      iX1 = iSaddle-1
      if (Mode == 'R') then
        ipX2 = 1
        ipX3 = 2
      else
        ipX2 = 2
        ipX3 = 1
      end if
      if (iSaddle < 3) iX0 = iX1

      ! Align everything with the current structure (X2)

      call mma_Allocate(XYZ,3*nAt*8,4)
      iXA0 = 1
      iXA1 = 2
      iXA2 = 3
      iXA3 = 4
      call Expand_Coor(MEP(1,iX0),nAt,XYZ(1,iXA0),mAt)
      call Expand_Coor(MEP(1,iX1),nAt,XYZ(1,iXA1),mAt)
      call Expand_Coor(RP_Centers(1,1,ipX2),nAt,XYZ(1,iXA2),mAt)
      call Expand_Coor(RP_Centers(1,1,ipX3),nAt,XYZ(1,iXA3),mAt)
      if (Invar) then
        call Superpose_w(XYZ(1,iXA0),XYZ(1,iXA2),W,mAt,RMSD,RMax)
        call Fix_Symmetry(XYZ(1,iXA0),nAt,iStab)
        call Superpose_w(XYZ(1,iXA1),XYZ(1,iXA2),W,mAt,RMSD,RMax)
        call Fix_Symmetry(XYZ(1,iXA1),nAt,iStab)
        call Superpose_w(XYZ(1,iXA3),XYZ(1,iXA2),W,mAt,RMSD,RMax)
        call Fix_Symmetry(XYZ(1,iXA3),nAt,iStab)
      end if
      iX0 = iXA0
      iX1 = iXA1
      iX3 = iXA3

      ! Compute deviation=(X1-X0)*(X2-X1).
      ! If it is lower than 0.8, slow down and do linear interpolation
      ! (the direction is probably broken)

      Skip = .false.
      if (iSaddle > 2) then
        Vec(:,1) = XYZ(1:nRP,iX1)-XYZ(1:nRP,iX0)
        call dcopy_(nRP,RP_Centers(:,:,ipX2),1,Vec(:,2),1)
        Vec(:,2) = Vec(:,2)-XYZ(1:nRP,iX1)
        deviation = dmwdot(nAt,mAt,Vec(1,1),Vec(1,2))
        R11 = dmwdot(nAt,mAt,Vec(1,2),Vec(1,2))
        R22 = dmwdot(nAt,mAt,Vec(1,1),Vec(1,1))
        deviation = deviation/sqrt(R11*R22)
        if (deviation < 0.85_wp) then
          quadratic = .false.
          dHSR = SadStep*0.8_wp
          Skip = .true.
        end if
      end if

      if (.not. Skip) then
        ! Compute R11=(X3-X1)**2 and R22=(X2-X1)**2

        Vec(:,1) = XYZ(1:nRP,iX3)-XYZ(1:nRP,iX1)
        R11 = dmwdot(nAt,mAt,Vec(1,1),Vec(1,1))
        call dcopy_(nRP,RP_Centers(:,:,ipX2),1,Vec(:,2),1)
        Vec(:,2) = Vec(:,2)-XYZ(1:nRP,iX1)
        R22 = dmwdot(nAt,mAt,Vec(1,2),Vec(1,2))
        R1R2 = dmwdot(nAt,mAt,Vec(1,2),Vec(1,1))

        ! The direction of the previous iteration is far from the R-P direction

        tmp = R1R2/(sqrt(R11)*sqrt(R22))
        if (tmp < 0.3_wp) then
          quadratic = .false.
          dHSR = SadStep*0.8_wp
        else if (tmp < Zero) then
          quadratic = .false.
          dHSR = SadStep*0.6_wp
        else
          dHSR = SadStep
          if (isaddle > 1) then
            dHSR = SadStep*1.3_wp
          end if
        end if
      end if
      call mma_deallocate(XYZ)
      call mma_deallocate(MEP)
      if (.not. quadratic) call mma_deallocate(Vec)

      ! Slow down close to the TS or in the first iteration

      if (HSR <= 2.5_wp*SadStep) then
        dHSR = SadStep*0.55_wp
      else if (quadratic .and. (HSR <= Four*SadStep)) then
        dHSR = SadStep*0.75_wp
      end if
    else
      dHSR = SadStep*0.7_wp
    end if
    Delta = dHSR/HSR
    if (Mode == 'P') Delta = One-Delta
    HSR = HSR-dHSR
  end if
  TmpA(6*nAt+5) = Update
  TmpA(6*nAt+4) = HSR
else
  !                                                                  *
  !*******************************************************************
  !                                                                  *
  ! This is written here only the first time around

  FindTS = .false.
  HSR0 = HSR

  ! Already findTS!

  FindTS = HSR <= (OneHalf*SadStep)
  if (FindTS) then
    write(u6,*) '**************************'
    write(u6,*) '* Enable TS optimization *'
    write(u6,*) '**************************'
    Update = Two
    Delta = Half-6.25_wp*(E2-E1)
    Delta = min(Delta,0.75_wp)
    Delta = max(Delta,0.25_wp)
    if (Mode == 'R') then
      HSR = (One-Delta)*HSR
    else
      HSR = Delta*HSR
    end if

    ! Calculate tangent vector

    call mma_allocate(TanVec,3*nAt,label='TanVec')
    if (Mode == 'R') then
      call Calc_LSTvec(3*nAt,RP_Centers(1,1,2),RP_Centers(1,1,1),TanVec,Invar)
    else
      call Calc_LSTvec(3*nAt,RP_Centers(1,1,1),RP_Centers(1,1,2),TanVec,Invar)
    end if
    call Put_dArray('TanVec',TanVec,3*nAt)
    call mma_deallocate(TanVec)
  else

    ! Do not go too fast the first time

    dHSR = SadStep*0.7_wp
    Delta = dHSR/HSR
    HSR = HSR-dHSR
    if (Mode == 'P') Delta = One-Delta
  end if
  call dcopy_(3*nAt,RP_Centers(:,:,1),1,TmpA(1),1)
  call dcopy_(3*nAt,RP_Centers(:,:,2),1,TmpA(1+3*nAt),1)
  TmpA(6*nAt+1) = E1
  TmpA(6*nAt+2) = E2
  TmpA(6*nAt+3) = HSR0
  TmpA(6*nAt+4) = HSR
  TmpA(6*nAt+5) = Update
end if

call Put_dArray('Saddle',TmpA,nSaddle)
call mma_deallocate(TmpA)

!*********************************************************************
!                                                                    *
!                    Some paper work                                 *
!                                                                    *
!*********************************************************************
! Set the point with the highest energy as the reference
! structure. Put the reference structure on the runfile.

write(u6,*)
write(u6,'(A)') ' -- TS optimization a la the Saddle approach'
if (FindTS) then
  write(u6,'(A)') '   Last Macro iteration'
  call Merge_Lists(Mode,nAt)
end if
if (Mode == 'R') then
  iRef = 2
  iOpt = 1
  write(u6,'(A)') '     Reference structure: product side'
  write(u6,'(A,F15.8)') '       Associated Energy: ',E2
  write(u6,'(A)') '     Optimized structure: reactant side'
  write(u6,'(A,F15.8)') '       Associated Energy: ',E1
else
  iRef = 1
  iOpt = 2
  write(u6,'(A)') '     Reference structure: reactant side'
  write(u6,'(A,F15.8)') '       Associated Energy: ',E1
  write(u6,'(A)') '     Optimized structure: product side'
  write(u6,'(A,F15.8)') '       Associated Energy: ',E2
end if
write(u6,*)

! Align the reference structure with the current structure

call mma_allocate(XYZ,3*nAt*8,2,label='XYZ')
iRefAlign = 1
iOptExp = 2
call Expand_Coor(RP_Centers(1,1,iRef),nAt,XYZ(1,iRefAlign),mAt)
call Expand_Coor(RP_Centers(1,1,iOpt),nAt,XYZ(1,iOptExp),mAt)
if (Invar) then
  call Superpose_w(XYZ(1,iRefAlign),XYZ(1,iOptExp),W,mAt,RMSD,RMax)
  call Fix_Symmetry(XYZ(1,iRefAlign),nAt,iStab)
end if
call Put_dArray('Ref_Geom',XYZ(1,iRefAlign),3*nAt)
call mma_deallocate(XYZ)
!                                                                    *
!*********************************************************************
!                                                                    *
! Fix so that two copies of runfile, vector files, jobiph, etc.
! are maintained correctly. This is only done the very first
! iteration.

if (.not. Not_First_Iter) then
  LuInput = 11
  LuInput = IsFreeUnit(LuInput)
  call StdIn_Name(StdIn)
  call Molcas_Open(LuInput,StdIn)

  ! Make two copies of the virgin runfile

  write(LuInput,'(A)') '> CLONE $Project.RunFile $Project.Reac.RunFile'
  write(LuInput,'(A)') '> CLONE $Project.RunFile $Project.Prod.RunFile'
  write(LuInput,'(A)') '> RM $Project.RunFile'

  ! Make the appropriate links for the other files.

  if (Mode == 'R') then
    write(LuInput,'(A)') '> EXPORT SubProject=.Reac'
  else
    write(LuInput,'(A)') '> EXPORT SubProject=.Prod'
  end if
  write(LuInput,'(A)') '> CLONE $Project.GssOrb $Project$SubProject.GssOrb'
  write(LuInput,'(A)') '> RM -FORCE $Project.GssOrb'

  ! Signal that this is a saddle run, and the first iteration in a branch

  write(LuInput,'(A)') '> EXPORT MOLCAS_SADDLE=1'
  write(LuInput,'(A)') '> EXPORT SADDLE_FIRST=1'
  close(LuInput)
else
  lRP_Post = .false.
end if

!*********************************************************************
!                                                                    *
!     Compute the starting structure and put it into the runfile     *
!                                                                    *
!*********************************************************************
if (quadratic) then

  ! Quadratic interpolation:
  ! Find the solutions of the system

  R1_2 = R11-Two*R1R2+R22
  Delta = HSR**2*(R11*R22*R1_2+HSR**2*(R1R2**2-R11*R22))
  if (Delta < Zero) then
    write(u6,*) 'Delta is negative!!!'
    quadratic = .false.
  end if
end if
if (quadratic) then
  C = (HSR**2*(Two*R1R2**2-(R11+R1R2)*R22)+(-Two*R1R2+R22)*sqrt(Delta))/(R11*R22*R1_2)
  D = (HSR**2*(R22-R1R2)+sqrt(Delta))/(R22*R1_2)

  ! Compute the next structure

  Vec(:,1) = C*Vec(:,1)+D*Vec(:,2)
  call mma_allocate(XYZ,3*nAt*8,2,label='XYZ')
  iRA1 = 1
  iRA2 = 2
  call Expand_Coor(RP_Centers(1,1,1),nAt,XYZ(1,iRA1),mAt)
  call Expand_Coor(RP_Centers(1,1,2),nAt,XYZ(1,iRA2),mAt)
  if (Mode == 'R') then
    if (Invar) then
      call Superpose_w(XYZ(1,iRA2),XYZ(1,iRA1),W,mAt,RMSD,RMax)
      call Fix_Symmetry(XYZ(1,iRA2),nAt,iStab)
    end if
    Vec(:,1) = Vec(:,1)+XYZ(1:nRP,iRA2)
  else
    if (Invar) then
      call Superpose_w(XYZ(1,iRA1),XYZ(1,iRA2),W,mAt,RMSD,RMax)
      call Fix_Symmetry(XYZ(1,iRA1),nAt,iStab)
    end if
    Vec(:,1) = Vec(:,1)+XYZ(1:nRP,iRA1)
  end if
  call mma_deallocate(XYZ)
  j = 1
  do iCnttp=1,nCnttp
    if (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
      do iCnt=1,dbsc(iCnttp)%nCntr
        do i=1,3
          dbsc(iCnttp)%Coor(i,iCnt) = Vec(j,1)
          j = j+1
        end do
      end do
    end if
  end do
  if (Not_First_Iter) call Put_Coord_New(Vec(1,1),nAt)
  call mma_deallocate(Vec)
else
  !                                                                  *
  !*******************************************************************
  !                                                                  *
  ! Linear interpolation

  call mma_allocate(TmpA,nRP,label='TmpA')
  TmpA(:) = Zero
  call mma_allocate(XYZ,3*nAt*8,2,label='XYZ')
  iRA1 = 1
  iRA2 = 2
  call Expand_Coor(RP_Centers(1,1,1),nAt,XYZ(1,iRA1),mAt)
  call Expand_Coor(RP_Centers(1,1,2),nAt,XYZ(1,iRA2),mAt)
  if (Invar) then
    if (Mode == 'R') then
      call Superpose_w(XYZ(1,iRA2),XYZ(1,iRA1),W,mAt,RMSD,RMax)
      call Fix_Symmetry(XYZ(1,iRA2),nAt,iStab)
    else
      call Superpose_w(XYZ(1,iRA1),XYZ(1,iRA2),W,mAt,RMSD,RMax)
      call Fix_Symmetry(XYZ(1,iRA1),nAt,iStab)
    end if
  end if
  TmpA(1:nRP) = TmpA(1:nRP)+(One-Delta)*XYZ(1:nRP,iRA1)+Delta*XYZ(1:nRP,iRA2)
  call mma_deallocate(XYZ)
  j = 1
  do iCnttp=1,nCnttp
    if (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
      do iCnt=1,dbsc(iCnttp)%nCntr
        do i=1,3
          dbsc(iCnttp)%Coor(i,iCnt) = TmpA(j)
          j = j+1
        end do
      end do
    end if
  end do
  if (Not_First_Iter) call Put_Coord_New(TmpA,nAt)
  call mma_deallocate(TmpA)
end if

call mma_deallocate(iStab)
call mma_deallocate(W)

call FinishUp()
!                                                                      *
!***********************************************************************
!                                                                      *
return

contains

subroutine FinishUp()

  ! Write constraint on the runfile for slapaf to pick up later.

  Lu_UDC = 97
  Lu_UDC = IsFreeUnit(Lu_UDC)
  call Molcas_Open(Lu_UDC,'UDC.Saddle')
  write(Lu_UDC,*) 'R = Sphere'
  write(Lu_UDC,*) 'Value'
  write(Lu_UDC,*) 'R = ',HSR,' soft'
  write(Lu_UDC,*) 'END'
  close(Lu_UDC)

end subroutine

end subroutine Saddle

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine RdNLst(iUnit,NameIn)
      Character*(*) NameIn
      Logical No_Input_OK
*
      No_Input_OK=.False.
      Call RdNLst_(iUnit,NameIn,No_Input_OK)
*
      Return
      End
      Subroutine RdNLst_(iUnit,NameIn,No_Input_OK)
************************************************************************
*                                                                      *
*     Locate the beginning of an input stream                          *
*     (similar to FORTRAN NAMELIST read known to some systems)         *
*                                                                      *
*     calling arguments:                                               *
*     iUnit  : Type integer, input                                     *
*              FORTRAN unit number                                     *
*     NameIn : Type character string, input                            *
*              Character string marking the beginning of the input     *
*     No_Input_OK: Logical                                             *
*                  On input determines if an input has to be found     *
*                  On exit determines if an input was found.           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and P.O. Widmark                                  *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Character*(*) NameIn
      Character*8 StdNam
      Character*80 Line
      Integer StrnLn
      Logical No_Input_OK
      common /igetline/igetline,myunit
        igetline=0
*----------------------------------------------------------------------*
*     push the entry name on the calling stack                         *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*     convert the Name to internal standard format.                    *
*----------------------------------------------------------------------*
      Call StdFmt(NameIn,StdNam)
      lStdNam=StrnLn(StdNam)
*----------------------------------------------------------------------*
*     read until an input Line is located which starts with            *
*     the string, Name, not before the second column                   *
*----------------------------------------------------------------------*
      lLine=LEN(Line)
100   Read(iUnit,'(A)',End=900) Line
      Call LeftAd(Line)
      Call UpCase(Line)
      If ( Line(1:1).eq.'&' .and.
     &     Line(2:lStdNam+1).eq.StdNam(1:lStdNam) ) then
         Return
      End If
      Goto 100
*----------------------------------------------------------------------*
*     error exit                                                       *
*----------------------------------------------------------------------*
900   If (No_Input_OK) then
         No_Input_OK=.False.
         Return
      EndIf
      Write (6,*) 'RdNLst: Input section not found in input file'
      Write (6,*) '        Looking for:',StdNam(1:lStdNam)
      Call Quit_OnUserError()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_SetRed_L()
!
! Purpose: set next local reduced set. The next global reduced set
!          must be available at (global) index array location 2.

use Cholesky, only: iiBstR, iiBstR_G, iiBstRSh, iiBstRSh_G, iL2G, IndRed, IndRed_G, LuPri, MySP, nnBstR, nnBstRSh, nnBstRSh_G, &
                    nnBstRT, nnShl, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, i0, iC, irc, iShlAB, iSP, iSym, j, k, k0, l, ll
character(len=*), parameter :: SecNam = 'Cho_P_SetRed_L'

! Copy current local reduced set (at location 2) to location 3.
! -------------------------------------------------------------

call Cho_X_RSCopy(irc,2,3)
if (irc /= 0) then
  write(Lupri,*) SecNam,': Cho_X_RSCopy returned ',irc
  call Cho_Quit('Error in '//SecNam,104)
end if

! Re-initialize local reduced set indices at location 2.
! ------------------------------------------------------

IndRed(:,2) = 0
iiBstRSh(:,:,2) = 0
nnBstRSh(:,:,2) = 0
iiBstR(:,2) = 0
nnBstR(:,2) = 0
nnBstRT(2) = 0

! Set local nnBstRSh counter at location 2.
! -----------------------------------------

do iSP=1,nnShl
  iShlAB = mySP(iSP)
  nnBstRSh(1:nSym,iSP,2) = nnBstRSh_G(1:nSym,iShlAB,2)
end do

! Set remaining reduced set indices (excl. IndRed), location 2.
! -------------------------------------------------------------

call Cho_SetRedInd(2)

! Set local IndRed to point to local 1st reduced set.
! ---------------------------------------------------

iC = 0
do iSym=1,nSym
  do iSP=1,nnShl
    iShlAB = mySP(iSP)
    i0 = iiBstR_G(iSym,2)+iiBstRSh_G(iSym,iShlAB,2)
    k0 = iiBstR(iSym,3)+iiBstRSh(iSym,iSP,3)
    do i=1,nnBstRSh_G(iSym,iShlAB,2)
      j = IndRed_G(i0+i,2) ! addr in global rs1
      iC = iC+1
      k = 0
      do while (k < nnBstRSh(iSym,iSP,3))
        k = k+1
        ll = IndRed(k0+k,3)
        l = iL2G(ll)
        if (l == j) then
          IndRed(iC,2) = ll
          k = nnBstRSh(iSym,iSP,3) ! break while loop
        end if
      end do
    end do
  end do
end do

end subroutine Cho_P_SetRed_L

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Find_Bonds(Coor,nAtoms,iTab,nMax,nx,ny,nz,iBox,iANr,
     &                      Schlegel,iOptC,iTabBonds,nBonds,
     &                      nBondMax,iTabAtoms,ThrB)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Real*8 Coor(3,nAtoms)
      Integer iTab(0:nMax,nx,ny,nz), iBox(3,nAtoms), iANr(nAtoms),
     &        iTabBonds(3,nBondMax), iTabAtoms(2,0:nMax,nAtoms)
      Logical Schlegel
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*     Initiate
*
#ifdef _DEBUGPRINT_
      Call RecPrt('Coor',' ',Coor,3,nAtoms)
      Write (6,*) 'Find_Bonds: ThrB=',ThrB
      Write (6,*) 'Initialize iTabAtoms'
#endif
*
      Call ICopy(nBondMax*3,[0],0,iTabBonds,1)
      Call ICopy(2*(nMax+1)*nAtoms,[0],0,iTabAtoms,1)
      nBonds = 0
*                                                                      *
************************************************************************
*                                                                      *
*     Find all covalent bonds (type 0).
*
      Do iAtom = 1, nAtoms
*
         iRow = iTabRow(iANr(iAtom))
         If (iRow.eq.0) Go To 99
*
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*) 'iAtom, iAnr=',iAtom,iANr(iAtom)
         Write (6,*)
#endif
         ix=iBox(1,iAtom)
         iy=iBox(2,iAtom)
         iz=iBox(3,iAtom)
*
*------- Loop over all adjacent boxes.
*
         Do jx = ix-1, ix+1
            Do jy = iy-1, iy+1
               Do jz = iz-1, iz+1
                  Call Bond_Tester(Coor,nAtoms,iTab,nx,ny,nz,jx,jy,jz,
     &                             iAtom,iRow,iANr,Schlegel,iOptC,
     &                             iTabBonds,nBonds,nBondMax,iTabAtoms,
     &                             nMax,ThrB,1.0D+99)

               End Do
            End Do
         End Do
 99      Continue
      End Do
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'After Covalent Bonds'
      Write (6,*)
      Write (6,*) 'iTabAtoms:'
      Do iAtom = 1, nAtoms
         Write (6,*)
         Write (6,*) 'iAtom=',iAtom
         Write (6,*)
         Write (6,*) 'nNeighbor=',iTabAtoms(1,0,iAtom)
         nn=iTabAtoms(1,0,iAtom)
         Write (6,*) ' Neigbors:',(iTabAtoms(1,i,iAtom),i=1,nn)
         Write (6,*) ' Bond    :',(iTabAtoms(2,i,iAtom),i=1,nn)
         Write (6,*) ' Bondtype:',(
     &               iTabBonds(3,iTabAtoms(2,i,iAtom)),i=1,nn)
         Write (6,*) ' nCoBond :', nCoBond(iAtom,nAtoms,nMax,iTabBonds,
     &                                     nBonds,nBondMax,iTabAtoms)

      End Do
      Write (6,*)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Find all vdW bonds (type 1).
*
*     Loop over all adjacent boxes. Do vdW bonds.
*
      ThrB_vdW=1.0D-4*ThrB
      Do iAtom = 1, nAtoms
*
         iRow = iTabRow(iANr(iAtom))
         If (iRow.eq.0) Go To 98
*
         ix=iBox(1,iAtom)
         iy=iBox(2,iAtom)
         iz=iBox(3,iAtom)
*
*------- Loop over all adjacent boxes.
*
         Do jx = ix-1, ix+1
            Do jy = iy-1, iy+1
               Do jz = iz-1, iz+1
                  Call Bond_Tester(Coor,nAtoms,iTab,nx,ny,nz,jx,jy,jz,
     &                             iAtom,iRow,iANr,Schlegel,iOptC,
     &                             iTabBonds,nBonds,nBondMax,iTabAtoms,
     &                             nMax,ThrB,ThrB_vdW)

               End Do
            End Do
         End Do
 98      Continue
      End Do
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'After vdW Bonds'
      Write (6,*)
      Write (6,*) 'iTabAtoms:'
      Do iAtom = 1, nAtoms
         Write (6,*)
         Write (6,*) 'iAtom=',iAtom
         Write (6,*)
         Write (6,*) 'nNeighbor=',iTabAtoms(1,0,iAtom)
         nn=iTabAtoms(1,0,iAtom)
         Write (6,*) ' Neigbors:',(iTabAtoms(1,i,iAtom),i=1,nn)
         Write (6,*) ' Bond    :',(iTabAtoms(2,i,iAtom),i=1,nn)
         Write (6,*) ' Bondtype:',(
     &               iTabBonds(3,iTabAtoms(2,i,iAtom)),i=1,nn)
      End Do
      Write (6,*)
      Write (6,*) 'iTabBonds:'
      Do iBond = 1, nBonds
         Write (6,*)
         Write (6,*) 'iBond=',iBond
         Write (6,*)
         Write (6,*) 'Atoms=',iTabBonds(1,iBond),iTabBonds(2,iBond)
         Write (6,*) 'Bondtype:',iTabBonds(3,iBond)
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
*
*     Test connectivity in case of fragmentation of the system.
*
*     These bonds are of type 2.
*
      Call GetMem('nSet','Allo','Inte',ip_nSet,nAtoms)
      Call Connect_Fragments(iWork(ip_nSet),nAtoms,iTabBonds,nBondMax,
     &                        nBonds,Coor,iTabAtoms,nMax,iANr)
      Call Free_iWork(ip_nSet)
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'After Connecting Fragments'
      Write (6,*)
      Write (6,*) 'iTabAtoms:'
      Do iAtom = 1, nAtoms
         Write (6,*)
         Write (6,*) 'iAtom=',iAtom
         Write (6,*)
         Write (6,*) 'nNeighbor=',iTabAtoms(1,0,iAtom)
         nn=iTabAtoms(1,0,iAtom)
         Write (6,*) ' Neigbors:',(iTabAtoms(1,i,iAtom),i=1,nn)
         Write (6,*) ' Bond    :',(iTabAtoms(2,i,iAtom),i=1,nn)
         Write (6,*) ' Bondtype:',(
     &               iTabBonds(3,iTabAtoms(2,i,iAtom)),i=1,nn)
      End Do
      Write (6,*)
      Write (6,*) 'iTabBonds:'
      Do iBond = 1, nBonds
         Write (6,*)
         Write (6,*) 'iBond=',iBond
         Write (6,*)
         Write (6,*) 'Atoms=',iTabBonds(1,iBond),iTabBonds(2,iBond)
         Write (6,*) 'Bondtype:',iTabBonds(3,iBond)
      End Do
#endif
*
*                                                                      *
************************************************************************
*                                                                      *
*     Finally, for partially linear system we need "extra long bond",
*     this to make sure that we include torsions over linear subsystems.
*     This "magic bonds" are only included when forming torsions.
*
      Call Magic_Bonds(Coor,nAtoms,iTabBonds,nBondMax,nBonds,
     &                 iTabAtoms,nMax)
*
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'After Magic Bonds'
      Write (6,*)
      Write (6,*) 'iTabAtoms:'
      Do iAtom = 1, nAtoms
         Write (6,*)
         Write (6,*) 'iAtom=',iAtom
         Write (6,*)
         Write (6,*) 'nNeighbor=',iTabAtoms(1,0,iAtom)
         nn=iTabAtoms(1,0,iAtom)
         Write (6,*) ' Neigbors:',(iTabAtoms(1,i,iAtom),i=1,nn)
         Write (6,*) ' Bond    :',(iTabAtoms(2,i,iAtom),i=1,nn)
         Write (6,*) ' Bondtype:',(
     &               iTabBonds(3,iTabAtoms(2,i,iAtom)),i=1,nn)
      End Do
      Write (6,*)
      Write (6,*) 'iTabBonds:'
      Do iBond = 1, nBonds
         Write (6,*)
         Write (6,*) 'iBond=',iBond
         Write (6,*)
         Write (6,*) 'Atoms=',iTabBonds(1,iBond),iTabBonds(2,iBond)
         Write (6,*) 'Bondtype:',iTabBonds(3,iBond)
      End Do
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contract(coeffs1,coeffs2,coeffs3,coeffs4,ncont,nprim,arr1,arr2)
!coeffs1 :  (nprim(1),ncont(1)) modified contraction coefficients
!coeffs2 :  (nprim(2),ncont(2)) modified contraction coefficients
!coeffs3 :  (nprim(3),ncont(3)) modified contraction coefficients
!coeffs4 :  (nprim(4),ncont(4)) modified contraction coefficients
!ncont   :  i-th element is number of contracted functions i. index
!nprim   :  i-th element is number of primitive functions  i. index
!arr1    :  array of size (nprim(1)*nprim(2)*nprim(3)*nprim(4))
!arr2    :  array of size (nprim(1)*nprim(2)*nprim(3)*nprim(4))
!bs arr1 contains at the beginning the uncontracted integrals

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: coeffs1(*), coeffs2(*), coeffs3(*), coeffs4(*)
integer(kind=iwp), intent(in) :: ncont(4), nprim(4)
real(kind=wp), intent(inout) :: arr1(*)
real(kind=wp), intent(_OUT_) :: arr2(*)
integer(kind=iwp) :: ifirst, ifourth, isec, ithird, nnew(4), nolds(4)
real(kind=wp) :: ratio1, ratio2, ratio3, ratio4, xmax

!bs makes four index transformations in a row....
!bs try to find out, which indices should be transformed first...

ratio1 = real(nprim(1),kind=wp)/real(ncont(1),kind=wp)
ratio2 = real(nprim(2),kind=wp)/real(ncont(2),kind=wp)
ratio3 = real(nprim(3),kind=wp)/real(ncont(3),kind=wp)
ratio4 = real(nprim(4),kind=wp)/real(ncont(4),kind=wp)
nolds(:) = nprim(:)
nnew(:) = nprim(:)
!bs determine first, second,third and last index
!***********************************************************************
!bs determine the first
xmax = max(ratio1,ratio2,ratio3,ratio4)
if (xmax == ratio1) then
  ifirst = 1
  ratio1 = Zero
  nnew(ifirst) = ncont(ifirst)
  call trans_amfi(coeffs1,nprim(1),ncont(1),1,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
else if (xmax == ratio2) then
  ifirst = 2
  ratio2 = Zero
  nnew(ifirst) = ncont(ifirst)
  call trans_amfi(coeffs2,nprim(2),ncont(2),2,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
else if (xmax == ratio3) then
  ifirst = 3
  ratio3 = Zero
  nnew(ifirst) = ncont(ifirst)
  call trans_amfi(coeffs3,nprim(3),ncont(3),3,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
else if (xmax == ratio4) then
  ifirst = 4
  ratio4 = Zero
  nnew(ifirst) = ncont(ifirst)
  call trans_amfi(coeffs4,nprim(4),ncont(4),4,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
else
  ifirst = 0
  write(u6,*) 'Contract: you should not be here!'
  call abend()
end if
nolds(ifirst) = nnew(ifirst)
!***********************************************************************
!bs determine the second
xmax = max(ratio1,ratio2,ratio3,ratio4)
if (xmax == ratio1) then
  isec = 1
  ratio1 = Zero
  nnew(isec) = ncont(isec)
  call trans_amfi(coeffs1,nprim(1),ncont(1),1,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
else if (xmax == ratio2) then
  isec = 2
  ratio2 = Zero
  nnew(isec) = ncont(isec)
  call trans_amfi(coeffs2,nprim(2),ncont(2),2,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
else if (xmax == ratio3) then
  isec = 3
  ratio3 = Zero
  nnew(isec) = ncont(isec)
  call trans_amfi(coeffs3,nprim(3),ncont(3),3,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
else if (xmax == ratio4) then
  isec = 4
  ratio4 = Zero
  nnew(isec) = ncont(isec)
  call trans_amfi(coeffs4,nprim(4),ncont(4),4,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
else
  isec = 0
  write(u6,*) 'Contract: you should not be here!'
  call abend()
end if
nolds(isec) = nnew(isec)
!***********************************************************************
!bs determine the third
xmax = max(ratio1,ratio2,ratio3,ratio4)
if (xmax == ratio1) then
  ithird = 1
  ratio1 = Zero
  nnew(ithird) = ncont(ithird)
  call trans_amfi(coeffs1,nprim(1),ncont(1),1,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
else if (xmax == ratio2) then
  ithird = 2
  ratio2 = Zero
  nnew(ithird) = ncont(ithird)
  call trans_amfi(coeffs2,nprim(2),ncont(2),2,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
else if (xmax == ratio3) then
  ithird = 3
  ratio3 = Zero
  nnew(ithird) = ncont(ithird)
  call trans_amfi(coeffs3,nprim(3),ncont(3),3,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
else if (xmax == ratio4) then
  ithird = 4
  ratio4 = Zero
  nnew(ithird) = ncont(ithird)
  call trans_amfi(coeffs4,nprim(4),ncont(4),4,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
else
  ithird = 0
  write(u6,*) 'Contract: you should not be here!'
  call abend()
end if
nolds(ithird) = nnew(ithird)
!***********************************************************************
!bs determine the last
xmax = max(ratio1,ratio2,ratio3,ratio4)
if (xmax == ratio1) then
  ifourth = 1
  ratio1 = Zero
  nnew(ifourth) = ncont(ifourth)
  call trans_amfi(coeffs1,nprim(1),ncont(1),1,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
else if (xmax == ratio2) then
  ifourth = 2
  ratio2 = Zero
  nnew(ifourth) = ncont(ifourth)
  call trans_amfi(coeffs2,nprim(2),ncont(2),2,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
else if (xmax == ratio3) then
  ifourth = 3
  ratio3 = Zero
  nnew(ifourth) = ncont(ifourth)
  call trans_amfi(coeffs3,nprim(3),ncont(3),3,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
else if (xmax == ratio4) then
  ifourth = 4
  ratio4 = Zero
  nnew(ifourth) = ncont(ifourth)
  call trans_amfi(coeffs4,nprim(4),ncont(4),4,nolds(1),nolds(2),nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
else
  ifourth = 0
  write(u6,*) 'Contract: you should not be here!'
  call abend()
end if
!bs contracted integrals are now on
!bs arr1(ncont1,ncont2,ncont3,ncont4)

return

end subroutine contract

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine DMSMem(nRys,MemDMS,la,lb,lr)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      MemDMS=0
      nRys =0
      Call EFMmP(nOrder,MmEFP,la,lb+1,lr-1)
      MemDMS=Max(MemDMS,MmEFP)
      nRys =Max(nRys,nOrder)
      Call EFMmP(nOrder,MmEFP,la,lb,lr-1)
      MemDMS=Max(MemDMS,MmEFP)
      nRys =Max(nRys,nOrder)
*
*     Add a scratch area for intermediate integrals
*
      MemDer = 3*(nElem(la)*nElem(lb+1) +  nElem(la)*nElem(lb))
      MemDMS = MemDMS + MemDer
      MemDMS = MemDMS + nElem(la)*nElem(lb)*9
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1996, Markus P. Fuelscher                         *
!               1991, Per Ake Malmqvist                                *
!***********************************************************************

subroutine SORT0()
!***********************************************************************
!                                                                      *
!     Purpose: Prepare all information needed to sort 2el integral     *
!              into canonical order. This is the interface which       *
!              matches the sorting algorithm to SEWARD.                *
!     Method:  The method of choice is a modification of the bin       *
!              sorting algorithm. The sorting proceeds in three        *
!              steps: 1). The integrals are  distributed into          *
!                         the bins where the buffers to save integral  *
!                         values and labels are kept separated.        *
!                         If a bin is filled the 'value buffer' is     *
!                         written to LuOrd but the 'label buffer' is   *
!                         stored on LuTmp. Prior to writing all data   *
!                         are compressed.                              *
!                         (cf. subroutines SORT1A and SORT1B)          *
!                     2). All integrals belonging to the same slice    *
!                         are picked from the disk and sorted in       *
!                         memory. When sorting is completed they       *
!                         overwrite the old records and, if necessary, *
!                         new records are appended to LuOrd. Forward   *
!                         chaining indices are constructed and added to*
!                         the buffers. Hereafter LuTmp is not needed   *
!                         anymore.                                     *
!                         (cf. subroutines SORT2, SORT2A and SORT2B)   *
!                     3). Finally, the records are brought into        *
!                         sequential order and the file header is      *
!                         completed                                    *
!                         (cf. subroutines SORT3 and SORT4)            *
!     References: M. Yoshimine in 'Numerical Algorithms in Chemistry:  *
!                 Algebraic Methods', NRCC wokshop 1978                *
!                                                                      *
!     Called from: Seward_main                                         *
!                                                                      *
!     Calls to : MkSrt0,MkSrt1,MkSrt2,OpnOrd,ErrOrd,IniPkR8            *
!                                                                      *
!     Calling parameters: none                                         *
!                                                                      *
!     Global data declarations (Include files) :                       *
!     TwoDat  : table of contents and auxiliary information            *
!               on the ordered 2el file                                *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher and P.-Aa. Malmqvist                             *
!     University of Lund, Sweden, 1991                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     - build in option to use multiple file units                     *
!       M. P. Fuelscher, University of Lund, Sweden, 1996              *
!     - build in option to use a virtual disk                          *
!       M. P. Fuelscher, University of Lund, Sweden, 1996              *
!                                                                      *
!***********************************************************************

use Basis_Info, only: nBas
use sort_data, only: iDaTmp, iDaTw0, iDaTwo, IndBin, lBin, lDaRec, lIndx, lInts, LuTmp, LuTwo, lwIBin, lwVBin, mDaTmp, mDaTwo, &
                     nBin, ValBin
use Symmetry_Info, only: nIrrep, iSkip
use Gateway_global, only: iPack
use Gateway_Info, only: PkAcc
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6

implicit none
#include "TwoDat.fh"
#include "print.fh"
integer(kind=iwp) :: iDisk, iOpt, iPrint, iRc, iRout, Kase
logical(kind=iwp) :: PkMode
integer(kind=iwp), external :: isfreeunit

!----------------------------------------------------------------------*
!     pick up the print level                                          *
!----------------------------------------------------------------------*
iRout = 80
iPrint = nPrint(iRout)
if (iPrint > 10) write(u6,*) ' >>> Enter SORT0 <<<'
!----------------------------------------------------------------------*
!     assume there is no virtual disk available                        *
!----------------------------------------------------------------------*
RAMD = .false.
!----------------------------------------------------------------------*
!     open the two electron integral file                              *
!----------------------------------------------------------------------*

LuTwo = isfreeunit(40)
iOpt = 1
iRc = 0
call OPNORD(iRc,iOpt,'ORDINT',LuTwo)
if (iRc /= 0) then
  write(u6,*) 'SORT0: Error opening ORDINT'
  call Abend()
end if

iOpt = Toctwo(IsForm)
Kase = iand(iOpt,15)
if (Kase == 0) then
  lBin = 4*lDaRec  ! tce
else
  lBin = 32*lDaRec ! rle
end if

!----------------------------------------------------------------------*
!     Initialize the common /SRT0/                                     *
!     (Get total no. of irred. representations, basis dimensions ect.) *
!----------------------------------------------------------------------*

call MKSRT0(0,nIrrep,nBas,iSkip)

!----------------------------------------------------------------------*
!     Initialize the common /SRT1/, i.e.,                              *
!     determine the partitioning of the 2el integrals into             *
!     submatrices (slices) where the size of the slices is             *
!     determined by the maximum number of bins (mxBin)                 *
!----------------------------------------------------------------------*

call MKSRT1()

!----------------------------------------------------------------------*
!     allocate the space required in phase1 of the bin sort algoritm   *
!----------------------------------------------------------------------*

call mma_allocate(lwVBin,lBin,nBin,Label='lwVBin')
call mma_allocate(lwIBin,lBin,nBin,Label='lwIBin')

call mma_allocate(lIndx,lBin,Label='lIndx')
call mma_allocate(lInts,lBin,Label='lInts')
call mma_allocate(ValBin,lBin,Label='ValBin')
call mma_allocate(IndBin,lBin,Label='IndBin')

!----------------------------------------------------------------------*
!     compute various offsets for each Bin and also                    *
!     initialize various pointers, counters and disk adresses          *
!----------------------------------------------------------------------*

call MKSRT2()

!----------------------------------------------------------------------*
!     set packing mode and initialize packing table                    *
!----------------------------------------------------------------------*

PkMode = .true.
if (iPack /= 0) PkMode = .false.
call INIPKR8(PkAcc,PkMode)

!----------------------------------------------------------------------*
!     generate table of contents on 2el integral file                  *
!----------------------------------------------------------------------*

call MKORD(iDisk)

!----------------------------------------------------------------------*
!     Because the bin sorting algorithm heavily relies on random       *
!     access to the disks from here on the disk access control is      *
!     transfered to the sorting algorithm directly.                    *
!----------------------------------------------------------------------*

iDaTw0 = iDisk
iDaTwo = iDaTw0
mDaTwo = iDaTw0

!----------------------------------------------------------------------*
!     open the scratch file                                            *
!----------------------------------------------------------------------*

LuTmp = isfreeunit(50)
call DANAME_MF(LuTmp,'TEMP01')
iDaTmp = 0
mDaTmp = 0

return

end subroutine SORT0

* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Roland Lindh                                     *
************************************************************************
      Subroutine Mk_Dummy_Shell()
************************************************************************
*                                                                      *
*     Add the final DUMMY SHELL!                                       *
*                                                                      *
* 2008 R. Lindh, Dept. of Theor. Chem., Univ. of Lund, Sweden          *
************************************************************************
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only: S
      Implicit Real*8 (A-H,O-Z)
      External Integral_RICD, Integral_RI_2
#include "Molcas.fh"
#include "SysDef.fh"
#include "real.fh"
#include "stdalloc.fh"
*                                                                      *
************************************************************************
*                                                                      *
      iShll = S%Mx_Shll - 1
      mdc = dbsc(nCnttp)%mdci + dbsc(nCnttp)%nCntr
      nCnttp = nCnttp + 1
      If (nCnttp.gt.Mxdbsc) Then
         Call WarningMessage(2,'Mk_Dummy_Shell: Increase Mxdbsc')
         Call Abend()
      End If
      dbsc(nCnttp)%iVal = iShll + 1
      dbsc(nCnttp)%nVal = 1
      dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal
*
      dbsc(nCnttp)%Bsl='.....RI_Dummy'
      dbsc(nCnttp)%AtmNr=1
      dbsc(nCnttp)%Aux=.True.
*
      nPrim=1
      nCntrc=1
*
      iShll = iShll + 1
      Shells(iShll)%Aux = .True.
      Call mma_allocate(Shells(iShll)%Exp,nPrim,Label='ExpDummy')
      Shells(iShll)%nExp=nPrim
      Shells(iShll)%nBasis=nCntrc
      Shells(iShll)%nBasis_c = nCntrc
*     Exponent
      Shells(iShll)%Exp(1)=Zero
*     Coefficients
      Call mma_allocate(Shells(iShll)%Cff_c,nPrim,nCntrc,2,
     &                  Label='Cff_c')
      Call mma_allocate(Shells(iShll)%pCff,nPrim,nCntrc,
     &                  Label='pCff')
      Call mma_allocate(Shells(iShll)%Cff_p,nPrim,nPrim ,2,
     &                  Label='Cff_p')
      Shells(iShll)%Cff_c(1,1,1)=One
      Shells(iShll)%Cff_c(1,1,2)=One
      Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
*
      Shells(iShll)%Transf=.False.
      Shells(iShll)%Prjct =.False.
*
*-----The coordinates
*
      nCnt = 1
      n_dc=max(mdc+nCnt,n_dc)
      If (mdc+nCnt.gt.MxAtom) Then
         Call WarningMessage(2,'Mk_Dummy_Shell: Increase MxAtom')
         Call Abend()
      End If
      dbsc(nCnttp)%mdci=mdc
      dc(mdc+nCnt)%LblCnt = 'Origin'
      If (mdc+nCnt.gt.1) Call Chk_LblCnt(dc(mdc+nCnt)%LblCnt,mdc+nCnt-1)
      Call mma_allocate(dbsc(nCnttp)%Coor_Hidden,3,1,Label='dbsc:C')
      dbsc(nCnttp)%Coor => dbsc(nCnttp)%Coor_Hidden(:,:)
      dbsc(nCnttp)%Coor(1:3,1:1)=Zero
      dbsc(nCnttp)%nCntr = nCnt
      mdc = mdc + nCnt
*                                                                      *
************************************************************************
*                                                                      *
      S%Mx_Shll=iShll+1
      Max_Shells=S%Mx_Shll
      S%Mx_mdc=mdc
*
      If (iCnttp_Dummy.ne.0) Then
         Write (6,*) 'Mk_dummy_shell: iCnttp_Dummy'
         Call Abend()
      End If
      iCnttp_Dummy=nCnttp
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FUpdt(nInter,FEq,gi_2,gi_1,g_ref,
     &                            qi_2,qi_1,q_ref,u,v,w)
************************************************************************
*                                                                      *
* Object: to do a rank-three update on the anharmonic constants.       *
*                                                                      *
*         Observe that SlapAf stores the forces rather than the        *
*         gradients.                                                   *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 FEq(nInter,nInter,nInter),
     &       gi_2(nInter), gi_1(nInter), g_ref(nInter),
     &       qi_2(nInter), qi_1(nInter), q_ref(nInter),
     &       u(nInter), v(nInter), w(nInter), lambda
*
*     Call RecPrt(' FEq',' ',FEq,nInter**2,nInter)
*     Call RecPrt('  gi-2',' ', gi_2,1,nInter)
*     Call RecPrt('  gi-1',' ', gi_1,1,nInter)
*     Call RecPrt('  g_ref',' ', g_ref,1,nInter)
*     Call RecPrt('  qi-2',' ', qi_2,1,nInter)
*     Call RecPrt('  qi-1',' ', qi_1,1,nInter)
*     Call RecPrt('  q_ref',' ', q_ref,1,nInter)
*
      Do i = 1, nInter
         u(i) = -(gi_1(i)-g_ref(i))
         v(i) = -(gi_2(i)-g_ref(i))
      End Do
      rLHS=DDot_(nInter,qi_2,1,u,1)-DDot_(nInter,q_ref,1,u,1)
     &    -DDot_(nInter,qi_1,1,v,1)+DDot_(nInter,q_ref,1,v,1)
      Write (6,*) 'FUpdt: LHS=',rLHS
      RHS=Zero
      Do i = 1, nInter
         Do k = 1, nInter
            Do l = 1, nInter
               RHS = RHS + FEq(i,k,l)*
     &               (qi_1(i)-q_ref(i))*
     &               (qi_2(k)-q_ref(k))*
     &               (qi_2(l)-qi_1(l))
            End Do
         End Do
      End Do
      RHS = Half*RHS
      Write (6,*) 'FUpdt: RHS=',RHS
      lambda=rLHS - RHS
      Write (6,*) ' FUpdt: lambda=',lambda
      Do i = 1, nInter
         w(i) = v(i) - u(i)
      End Do
      Call RecPrt('u',' ',u,1,nInter)
      Call RecPrt('v',' ',v,1,nInter)
      Call RecPrt('w',' ',w,1,nInter)
*
      ux = DDot_(nInter,u,1,qi_1,1)-DDot_(nInter,u,1,q_ref,1)
      uy = DDot_(nInter,u,1,qi_2,1)-DDot_(nInter,u,1,q_ref,1)
      vx = DDot_(nInter,v,1,qi_1,1)-DDot_(nInter,v,1,q_ref,1)
      vy = DDot_(nInter,v,1,qi_2,1)-DDot_(nInter,v,1,q_ref,1)
      wx = DDot_(nInter,w,1,qi_1,1)-DDot_(nInter,w,1,q_ref,1)
      wy = DDot_(nInter,w,1,qi_2,1)-DDot_(nInter,w,1,q_ref,1)
      lambda=Two*lambda/(ux*vy*(wy-wx)
     &                  +vx*wy*(uy-ux)
     &                  +wx*uy*(vy-vx))
      Write (6,*) ' FUpdt: lambda=',lambda
      Do i = 1, nInter
         Do k = 1, nInter
            Do l = 1, nInter
               FEq(i,k,l) = FEq(i,k,l) + lambda*(
     &                         u(i)*v(k)*w(l)
     &                       + v(i)*w(k)*u(l)
     &                       + w(i)*u(k)*v(l) )
            End Do
         End Do
      End Do
*
*
*---- Check on the third order condition
*
      Do i = 1, nInter
         u(i) = -(gi_1(i)-g_ref(i))
         v(i) = -(gi_2(i)-g_ref(i))
      End Do
      rLHS=DDot_(nInter,qi_2,1,u,1)-DDot_(nInter,q_ref,1,u,1)
     &    -DDot_(nInter,qi_1,1,v,1)+DDot_(nInter,q_ref,1,v,1)
      Write (6,*) 'FUpdt: LHS(qNR)=',rLHS
      RHS=Zero
      Do i = 1, nInter
         Do k = 1, nInter
            Do l = 1, nInter
               RHS = RHS + FEq(i,k,l)*
     &               (qi_1(i)-q_ref(i))*
     &               (qi_2(k)-q_ref(k))*
     &               (qi_2(l)-qi_1(l))
            End Do
         End Do
      End Do
      RHS = Half*RHS
      Write (6,*) 'FUpdt: RHS(qNR)=',RHS
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************

subroutine MulPop(CMO,mBB,nD,Ovrlp,mBT,OccNo,mmB)
!***********************************************************************
!                                                                      *
! This routine is a wrapper for Charge (which prints Mulliken popu-    *
! lation analyzes) since charge needs square CMO matrices.             *
!                                                                      *
!***********************************************************************

use InfSCF, only: BName, nBas, nBB, nnB, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mBB, nD, mBT, mmB
real(kind=wp), intent(in) :: CMO(mBB,nD), Ovrlp(mBT), OccNo(mmB,nD)
real(kind=wp), allocatable :: Aux1(:), Aux2(:)

!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
if (all(nBas(1:nSym) == nOrb(1:nSym))) then
  if (nD == 1) then
    call Charge(nSym,nBas,BName,CMO(:,1),OccNo(:,1),Ovrlp,2,.false.,.false.)
  else
    call Charge(nSym,nBas,BName,CMO(:,1),OccNo(:,1),Ovrlp,0,.false.,.false.)
    call Charge(nSym,nBas,BName,CMO(:,2),OccNo(:,2),Ovrlp,1,.false.,.false.)
  end if
else
  call mma_allocate(Aux1,nBB,Label='Aux1')
  call mma_allocate(Aux2,nnB,Label='Aux2')
  if (nD == 1) then
    Aux1(1:mBB) = CMO(:,1)
    Aux2(1:mmB) = OccNo(:,1)
    call PadCMO(Aux1,nSym,nBas,nOrb)
    call PadEor(Aux2,nSym,nBas,nOrb)
    call Charge(nSym,nBas,BName,Aux1,Aux2,Ovrlp,2,.false.,.false.)
  else
    Aux1(1:mBB) = CMO(:,2)
    Aux2(1:mmB) = OccNo(:,1)
    call PadCMO(Aux1,nSym,nBas,nOrb)
    call PadEor(Aux2,nSym,nBas,nOrb)
    call Charge(nSym,nBas,BName,Aux1,Aux2,Ovrlp,0,.false.,.false.)
    Aux1(1:mBB) = CMO(:,2)
    Aux2(1:mmB) = OccNo(:,2)
    call PadCMO(Aux1,nSym,nBas,nOrb)
    call PadEor(Aux2,nSym,nBas,nOrb)
    call Charge(nSym,nBas,BName,Aux1,Aux2,Ovrlp,1,.false.,.false.)
  end if
  call mma_deallocate(Aux1)
  call mma_deallocate(Aux2)
end if
!----------------------------------------------------------------------*
! Done                                                                 *
!----------------------------------------------------------------------*
return

end subroutine MulPop

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Dong Q. Le                                       *
!***********************************************************************
! Data derived from EasySpin (https://easyspin.org/)                   *
! Copyright (c) 2026                                                   *
! Licensed under the MIT License.                                      *
! Please see the file readme_easyspin_license.md in the                *
! Tools/create_easy_spin_data directory for licence details.           *
!***********************************************************************

module spin_data

use Constants, only: Zero, Half
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, wp, u6

implicit none
private

type :: isotope
  integer(kind=iwp) :: AtNumb, MassNumb
  real(kind=wp) :: Abundance, NucSpin, GNuc
  logical(kind=iwp) :: Stable
end type isotope

type :: element
  integer(kind=iwp) :: first_isotope, last_isotope
end type element

integer(kind=iwp) :: first_isotope, last_isotope
logical(kind=iwp) :: not_found_gnuc, not_found_spin

type(element), allocatable :: elements(:)
type(isotope), allocatable :: isotopes(:)

public :: free_spin_data, get_first_nonzero_GNUC, GNUC_by_nucspin, GNUC_NUCSPIN_by_nucmass, init_spin_data, NUCSPIN_by_gnuc

! Private extensions to mma interfaces

interface mma_allocate
  module procedure :: element_mma_allo_1D, element_mma_allo_1D_lim
  module procedure :: isotope_mma_allo_1D, isotope_mma_allo_1D_lim
end interface
interface mma_deallocate
  module procedure :: element_mma_free_1D
  module procedure :: isotope_mma_free_1D
end interface

contains

subroutine init_spin_data()

  integer(kind=iwp) :: AtNumb, Err, Err1, Err2, Err3, Err4, Err5, FirstIso, iRec, LastIso, NumbElem, NumbIso, SpinData
  logical(kind=iwp) :: Found
  character(len=180) :: Line
  character(len=*), parameter :: SPINDATA_NAME = 'SPINDATA'
  integer(kind=iwp), external :: IsFreeUnit

  call f_Inquire(SPINDATA_NAME,Found)

  if (.not. Found) then
    write(u6,*) 'File data/spin_data.txt does not exist'
    call abend()
  end if

  SpinData = IsFreeUnit(79)
  call molcas_open(SpinData,SPINDATA_NAME)

  do
    read(SpinData,'(A)',iostat=Err) Line
    if (Err < 0) then
      exit
    else if (Err > 0) then
      write(u6,*) 'spin_data.F90: Error reading spin_data.txt'
      call abend()
    end if
    !----------------------------------------------
    if ((Line(1:1) == '!') .or. (Line == '')) cycle
    !----------------------------------------------
    if (Line(1:1) == '@') then
      read(Line(22:24),*,iostat=Err1) NumbElem
      read(Line(57:59),*,iostat=Err2) NumbIso

      if (Err1 > 0) write(u6,*) 'spin_data.F90: Error reading NumbElem'
      if (Err2 > 0) write(u6,*) 'spin_data.F90: Error reading NumbIso'
      if (Err1+Err2 > 0) call AbEnd()

      call mma_allocate(elements,NumbElem,Label='elements')
      call mma_allocate(isotopes,NumbIso,Label='isotopes')
#     include "macros.fh"
      unused_proc(mma_allocate(elements,[0,0]))
      unused_proc(mma_allocate(isotopes,[0,0]))
    end if
    !----------------------------------------------
    if (Line(1:1) == '>') then
      read(Line(22:24),*,iostat=Err1) AtNumb
      read(Line(41:43),*,iostat=Err2) FirstIso
      read(Line(47:49),*,iostat=Err3) LastIso

      if (Err1 > 0) write(u6,*) "spin_data.F90: Error reading AtNumb"
      if (Err2 > 0) write(u6,*) "spin_data.F90: Error reading FirstIso"
      if (Err3 > 0) write(u6,*) "spin_data.F90: Error reading LastIso"
      if ((Err1+Err2+Err3) > 0) call AbEnd()

      elements(AtNumb)%first_isotope = FirstIso
      elements(AtNumb)%last_isotope = LastIso

      ! Skip header file
      read(SpinData,'(A)',iostat=Err) Line

      ! Reading all isotopes of this element
      do iRec=FirstIso,LastIso
        read(SpinData,'(A)',iostat=Err) Line
        read(Line(17:24),*,iostat=Err1) isotopes(iRec)%MassNumb
        read(Line(28:39),*,iostat=Err2) isotopes(iRec)%Abundance
        read(Line(43:49),*,iostat=Err3) isotopes(iRec)%NucSpin
        read(Line(54:64),*,iostat=Err4) isotopes(iRec)%GNuc
        read(Line(71:73),*,iostat=Err5) isotopes(iRec)%Stable

        if (Err > 0) write(u6,*) "spin_data.F90: Error reading Line in spin_data.txt"
        if (Err1 > 0) write(u6,*) "spin_data.F90: Error reading MassNum"
        if (Err2 > 0) write(u6,*) "spin_data.F90: Error reading Abundance"
        if (Err3 > 0) write(u6,*) "spin_data.F90: Error reading NucSpin"
        if (Err4 > 0) write(u6,*) "spin_data.F90: Error reading GNuc"
        if (Err5 > 0) write(u6,*) "spin_data.F90: Error reading Stable"
        if ((Err+Err1+Err2+Err3+Err4+Err5) > 0) call AbEnd()
      end do
    end if
    !----------------------------------------------
  end do

  close(SpinData)

end subroutine

subroutine GNUC_by_nucspin(AtNumb,MassNumb,GNuc,NucSpin,Stability)

  integer(kind=iwp), intent(in) :: AtNumb
  integer(kind=iwp), intent(out) :: MassNumb
  real(kind=wp), intent(out) :: GNuc
  real(kind=wp), intent(in) :: NucSpin
  character, intent(out), optional :: Stability
  integer(kind=iwp) :: iRec

  first_isotope = elements(AtNumb)%first_isotope
  last_isotope = elements(AtNumb)%last_isotope

  GNuc = Zero
  not_found_gnuc = .true.
  do iRec=first_isotope,last_isotope
    if (abs(isotopes(iRec)%NucSpin-NucSpin) < 1.0e-5_wp) then
      not_found_gnuc = .false.
      GNuc = isotopes(iRec)%GNuc
      MassNumb = isotopes(iRec)%MassNumb

      if (present(Stability)) then
        if (isotopes(iRec)%Stable) then
          Stability = ' '
        else
          Stability = '*'
        end if
      end if

      exit
    end if
  end do

  if (not_found_gnuc) call warning_not_found(1)
  call isot_info(AtNumb,GNuc,NucSpin)

end subroutine GNUC_by_nucspin

subroutine NUCSPIN_by_gnuc(AtNumb,MassNumb,GNuc,NucSpin,Stability)

  integer(kind=iwp), intent(in) :: AtNumb
  integer(kind=iwp), intent(out) :: MassNumb
  real(kind=wp), intent(in) :: GNuc
  real(kind=wp), intent(out) :: NucSpin
  character, intent(out), optional :: Stability
  integer(kind=iwp) :: iRec

  first_isotope = elements(AtNumb)%first_isotope
  last_isotope = elements(AtNumb)%last_isotope

  NucSpin = Half
  not_found_spin = .true.
  do iRec=first_isotope,last_isotope
    if (abs(isotopes(iRec)%GNuc-GNuc) < 0.001_wp) then
      not_found_spin = .false.
      NucSpin = isotopes(iRec)%NucSpin
      MassNumb = isotopes(iRec)%MassNumb

      if (present(Stability)) then
        if (isotopes(iRec)%Stable) then
          Stability = ' '
        else
          Stability = '*'
        end if
      end if

      exit
    end if
  end do

  if (not_found_spin) call warning_not_found(0)
  call isot_info(AtNumb,GNuc,NucSpin)

end subroutine NUCSPIN_by_gnuc

subroutine GNUC_NUCSPIN_by_nucmass(AtNumb,MassNumb,GNuc,NucSpin,Stability)

  integer(kind=iwp), intent(in) :: AtNumb, MassNumb
  real(kind=wp), intent(out) :: GNUc, NucSpin
  character, intent(out), optional :: Stability
  integer(kind=iwp) :: iRec

  first_isotope = elements(AtNumb)%first_isotope
  last_isotope = elements(AtNumb)%last_isotope

  NucSpin = Half
  GNuc = Zero
  not_found_gnuc = .true.
  not_found_spin = .true.
  do iRec=first_isotope,last_isotope
    if (isotopes(iRec)%MassNumb == MassNumb) then
      not_found_gnuc = .false.
      not_found_spin = .false.
      NucSpin = isotopes(iRec)%NucSpin
      GNuc = isotopes(iRec)%GNuc

      if (present(Stability)) then
        if (isotopes(iRec)%Stable) then
          Stability = ' '
        else
          Stability = '*'
        end if
      end if

      exit
    end if
  end do

  if (not_found_spin) call warning_not_found(0)
  if (not_found_gnuc) call warning_not_found(1)
  call isot_info(AtNumb,GNuc,NucSpin,MassNumb)

end subroutine GNUC_NUCSPIN_by_nucmass

subroutine get_first_nonzero_GNUC(AtNumb,MassNumb,GNuc,NucSpin,Stability)

  integer(kind=iwp), intent(in) :: AtNumb
  integer(kind=iwp), intent(out) :: MassNumb
  real(kind=wp), intent(out) :: GNuc, NucSpin
  character, intent(out), optional :: Stability
  integer(kind=iwp) :: iRec

  first_isotope = elements(AtNumb)%first_isotope
  last_isotope = elements(AtNumb)%last_isotope

  NucSpin = Half
  GNuc = Zero
  not_found_gnuc = .true.
  not_found_spin = .true.
  do iRec=first_isotope,last_isotope
    if (isotopes(iRec)%GNuc /= Zero) then
      not_found_gnuc = .false.
      not_found_spin = .false.
      GNuc = isotopes(iRec)%GNuc
      NucSpin = isotopes(iRec)%NucSpin
      MassNumb = isotopes(iRec)%MassNumb

      if (present(Stability)) then
        if (isotopes(iRec)%Stable) then
          Stability = ' '
        else
          Stability = '*'
        end if
      end if

      exit
    end if
  end do

  if (not_found_spin) call warning_not_found(0)
  if (not_found_gnuc) call warning_not_found(1)
  call isot_info(AtNumb,GNuc,NucSpin)

end subroutine get_first_nonzero_GNUC

subroutine isot_info(AtNumb,GNuc,NucSpin,MassNumb)

  integer(kind=iwp), intent(in) :: AtNumb
  real(kind=wp), intent(in) :: GNuc, NucSpin
  integer(kind=iwp), intent(in), optional :: MassNumb

  write(u6,'(11X,A18)') repeat('_',18)
  write(u6,'(11X,A18,I0)') 'INFO          Z = ',AtNumb
  if (present(MassNumb)) then
    write(u6,'(11X,A18,I0)') '              A = ',MassNumb
  end if
  write(u6,'(11X,A18,F12.8)') '       g-factor = ',GNuc
  write(u6,'(11X,A18,F5.2)') '        NucSpin = ',NucSpin
  write(u6,*) ''

end subroutine isot_info

subroutine warning_not_found(option)

  integer(kind=iwp), intent(in) :: option

  if (option == 0) then
    write(u6,'(11X,A37)') 'WARNING: Not found a matching record!'
    write(u6,'(20X,A61)') 'Defaulting to NucSpin = 0.5. This value might be fictitious. '
  else if (option == 1) then
    write(u6,'(11X,A37)') 'WARNING: Not found a matching record!'
    write(u6,'(20X,A61)') 'Defaulting to g-factor = 0.0. This value might be fictitious.'
  end if

end subroutine warning_not_found

subroutine free_spin_data()

  call mma_deallocate(isotopes)
  call mma_deallocate(elements)

end subroutine free_spin_data

! Private extensions to mma_interfaces, using preprocessor templates
! (see mma_util/stdalloc.F90)

! Define element_mma_allo_1D, element_mma_allo_1D_lim, element_mma_free_1D
#define _TYPE_ type(element)
#  define _SUBR_NAME_ element_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'elm_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

! Define isotope_mma_allo_1D, isotope_mma_allo_1D_lim, isotope_mma_free_1D
#define _TYPE_ type(isotope)
#  define _SUBR_NAME_ isotope_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'iso_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

end module spin_data

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! stefan: interface wrapper to the QCMaquis interface controller (qcmaquis_interface_ctl)

module qcmaquis_interface_wrapper

#ifdef _DMRG_
 use qcmaquis_interface_main
 use qcmaquis_interface_cfg

implicit none

  !> public
  public dmrg_interface_ctl

contains

  subroutine dmrg_interface_ctl(                                  &
                                task,                             &
                                x1,                               &
                                x2,                               &
                                x3,                               &
                                x4,                               &
                                energy,                           &
                                ndim,                             &
                                mdim,                             &
                                odim,                             &
                                pdim,                             &
                                state,                            &
                                stateL,                           &
                                msproj,                           &
                                msprojL,                          &
                                multiplet,                        &
                                multipletL,                       &
                                rdm1,                             &
                                rdm2,                             &
                                rdm3,                             &
                                rdm4,                             &
                                Key_CION,                         &
                                IterSCF,                          &
                                checkpoint1,                      &
                                checkpoint2                       &
                               )

      character(len=8),                intent(in)    :: task
      real*8 , optional, dimension(*), intent(inout) :: x1
      real*8 , optional, dimension(*), intent(inout) :: x2
      real*8 , optional, dimension(*), intent(inout) :: x3
      real*8 , optional, dimension(*), intent(inout) :: x4
      real*8 , optional,               intent(inout) :: energy
      integer, optional,               intent(in)    :: ndim
      integer, optional,               intent(in)    :: mdim
      integer, optional,               intent(in)    :: odim
      integer, optional,               intent(in)    :: pdim
      integer, optional,               intent(in)    :: state
      integer, optional,               intent(in)    :: stateL
      integer, optional,               intent(in)    :: msproj
      integer, optional,               intent(in)    :: msprojL
      integer, optional,               intent(in)    :: multiplet
      integer, optional,               intent(in)    :: multipletL
      logical, optional,               intent(in)    :: rdm1
      logical, optional,               intent(in)    :: rdm2
      logical, optional,               intent(in)    :: rdm3
      logical, optional,               intent(in)    :: rdm4
      logical, optional,               intent(in)    :: Key_CION
      integer, optional,               intent(in)    :: iterSCF
      ! Leon 02-12-2016: added optional custom checkpoint names
      character(len=*),optional,       intent(in)    :: checkpoint1
      character(len=*),optional,       intent(in)    :: checkpoint2

      !print *, 'DMRG interface called with task == ',trim(task)

      if(dmrg_host_program_settings%myrank == 0)then

        call qcmaquis_interface_ctl(                                  &
                                    task,                             &
                                    x1,                               &
                                    x2,                               &
                                    x3,                               &
                                    x4,                               &
                                    energy,                           &
                                    ndim,                             &
                                    mdim,                             &
                                    odim,                             &
                                    pdim,                             &
                                    state,                            &
                                    stateL,                           &
                                    msproj,                           &
                                    msprojL,                          &
                                    multiplet,                        &
                                    multipletL,                       &
                                    rdm1,                             &
                                    rdm2,                             &
                                    rdm3,                             &
                                    rdm4,                             &
                                    Key_CION,                         &
                                    IterSCF,                          &
                                    checkpoint1,                      &
                                    checkpoint2                       &
                                   )

      end if ! only myrank == 0 enters the interface

      !> update all processes if needed
      if(dmrg_host_program_settings%nprocs > 1 .and. dmrg_host_program_settings%runs_parallel)then
        call dmrg_task_process_update(                 &
                                      task   = task,   &
                                      x1     = x1,     &
                                      x2     = x2,     &
                                      energy = energy, &
                                      ndim   = ndim,   &
                                      mdim   = mdim,   &
                                      rdm1   = rdm1,   &
                                      rdm2   = rdm2    &
                                     )
      end if

  end subroutine dmrg_interface_ctl

  subroutine dmrg_task_process_update(                                  &
                                      task,                             &
                                      x1,                               &
                                      x2,                               &
                                      energy,                           &
                                      ndim,                             &
                                      mdim,                             &
                                      rdm1,                             &
                                      rdm2                              &
                                     )
      !> purpose: either update all co-worker processes or let them wait until the master finishes a DMRG-related task

      character(len=8),                intent(in)    :: task
      real*8 , optional, dimension(*), intent(inout) :: x1
      real*8 , optional, dimension(*), intent(inout) :: x2
      real*8 , optional,               intent(inout) :: energy
      integer, optional,               intent(in)    :: ndim
      integer, optional,               intent(in)    :: mdim
      logical, optional,               intent(in)    :: rdm1
      logical, optional,               intent(in)    :: rdm2
      integer                                        :: error

#ifdef _MOLCAS_MPP_
#include "mafdecls.fh"

      ! select task
      select case(trim(task))
        case('fci dump')
           call GA_sync()
        case('overlap ', 'overlapR')
           Call GA_Brdcst(MT_DBL, energy, 1, 0)
        case('imp spdX', 'imp rdmY')
           Call GA_Brdcst(MT_DBL, x1, nDim, 0)
        case('imp rdmX')
           !if(present(rdm1) .and. rdm1) print *, 'rdm1 before ',x1(1:10)
           if(present(rdm1) .and. rdm1) Call GA_Brdcst(MT_DBL, x1, nDim, 0)
           if(present(rdm2) .and. rdm2) Call GA_Brdcst(MT_DBL, x2, mDim, 0)
           call GA_sync()
           !if(present(rdm1) .and. rdm1) print *, 'rdm1 after ',x1(1:10)
        case('run DMRG')
           call GA_sync()
           Call GA_Brdcst(MT_DBL, dmrg_energy%dmrg, 1, 0)
           Call GA_Brdcst(MT_DBL, dmrg_energy%dmrg_state_specific, size(dmrg_energy%dmrg_state_specific), 0)
           call GA_sync()
        case default
          write(6,*) 'nothing to synchronize...'
          call Abend()
      end select

#endif

      ! take care of unused variable warnings
      if (.false.) then
        call Unused_integer(ndim)
        call Unused_integer(mdim)
        call Unused_integer(error)
        call Unused_logical(rdm1)
        call Unused_logical(rdm2)
        call Unused_character(task)
        call Unused_real(energy)
        call Unused_real_array(x1)
        call Unused_real_array(x2)
      end if

      end subroutine dmrg_task_process_update

#else
implicit none
integer :: qcmaquis_wrapper_dummy
#endif

end module qcmaquis_interface_wrapper

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine write_new_formatted_aniso(nss,nstate,multiplicity,eso_au,esfs_au,U,MM,MS,DM,angmom,edmom,amfi,HSO)

use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Angstrom
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nss, nstate, multiplicity(nstate)
real(kind=wp), intent(in) :: eso_au(nss), esfs_au(nstate), angmom(3,nstate,nstate), edmom(3,nstate,nstate), amfi(3,nstate,nstate)
complex(kind=wp), intent(in) :: U(nss,nss), MM(3,nss,nss), MS(3,nss,nss), DM(3,nss,nss), HSO(nss,nss)
integer(kind=iwp) :: data_file_format, i, iAt, ipar, iss, ist, l, Lu, Lutmp, mult, mxjob, nAtoms, njob
character(len=1024) :: cmolcas, fname, molcasversion
character(len=128) :: Filename
!character(len=30) :: fmt_int, fmt_key, fmt_real
integer(kind=iwp), allocatable :: jbnum(:), mltplt(:), nroot(:), szproj(:)
real(kind=wp), allocatable :: xyz(:,:)
character(len=LenIn), allocatable :: AtomLbl(:)
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: dbg = _DBG_
integer(kind=iwp), external :: IsFreeUnit

!-----------------------------------------------------------------------
! some preparations
njob = 0
mxjob = 0
call get_iScalar('NJOB_SINGLE',njob)
call get_iScalar('MXJOB_SINGLE',mxjob)
! allocate temporary memory:
call mma_allocate(jbnum,nstate,'jbnum')
call mma_allocate(mltplt,mxjob,'mltplt')
! get the information from RUNFILE:
mltplt = 0
jbnum = 0
call get_iArray('MLTP_SINGLE',mltplt,mxjob)
call get_iArray('JBNUM_SINGLE',jbnum,nstate)
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
! prepare the szproj index table
call mma_allocate(szproj,nss,'szproj')
iss = 0
ipar = mod(multiplicity(1),2)
do Ist=1,nstate
  Mult = Multiplicity(Ist)
  do I=-(Mult-Ipar)/2,(Mult-Ipar)/2
    if ((Ipar == 0) .and. (I == 0)) cycle
    Iss = Iss+1
    szproj(iss) = I
  end do ! i
end do ! ist
szproj(iss+1:) = 0

call get_iScalar('MXJOB_SINGLE',mxjob)
call mma_allocate(nroot,mxjob,'nroot')
call get_iArray('NSTAT_SINGLE',nroot,mxjob)

!-----------------------------------------------------------------------
! Get the MOLCAS version: index table
call getenvf('MOLCAS ',cmolcas)
write(fname,'(A)') trim(cmolcas)//'/.molcasversion'
Lutmp = IsFreeUnit(89)
call molcas_open(Lutmp,fname)
read(Lutmp,'(A180)') molcasversion
close(Lutmp)

!-----------------------------------------------------------------------
! add coordinates
nAtoms = 0
call Get_iScalar('Unique atoms',nAtoms)
call mma_allocate(AtomLbl,nAtoms,label='AtomLbl')
call Get_cArray('Unique Atom Names',AtomLbl,LenIn*nAtoms)
call mma_allocate(xyz,3,8*nAtoms)
call Get_dArray('Unique Coordinates',xyz,3*nAtoms)

!-----------------------------------------------------------------------
! write the data to the new aniso file
FileName = 'ANISOFILE'
Lu = IsFreeUnit(81)

call molcas_open(Lu,FileName)
data_file_format = 2021

!fmt_key = '(A)'
!fmt_real = '(5ES22.14,1x)'
!fmt_int = '(40(I0,1x))'

write(Lu,'(        A)') '# OPENMOLCAS interface to ANISO'
!-----------------------------------------------------------------------
! ORIGIN of DATA file
write(Lu,'(        A)') '$source '
write(Lu,'(       2A)') 'MOLCAS  ',trim(cmolcas)
write(Lu,'(       2A)') 'VERSION ',trim(molcasversion)
write(Lu,'(        A)')
!-----------------------------------------------------------------------
! DATA FILE FORMAT VERSION:
write(Lu,'(        A)') '$format '
write(Lu,'(40(I0,1x))') data_file_format
write(Lu,'(        A)')
!-----------------------------------------------------------------------
! Atom labels and coordinates
write(Lu,'(        A)') '$natoms '
write(Lu,'(40(I0,1x))') nAtoms
write(Lu,'(        A)')
write(Lu,'(        A)') '$atomlbl'
write(Lu,'(40(I0,1x))') nAtoms
write(Lu,'(40(A8,1x))') (AtomLbl(iAt),iAt=1,nAtoms)
write(Lu,'(        A)')
write(Lu,'(        A)') '$coords (in angstrom)'
write(Lu,'(40(I0,1x))') nAtoms
do iAt=1,nAtoms
  write(Lu,'(i3,1x,A8,1x,3(ES22.14,1x))') iAt,AtomLbl(iAt),(Angstrom*XYZ(l,iAt),l=1,3)
end do
call mma_deallocate(AtomLbl)
write(Lu,'(        A)')
!-----------------------------------------------------------------------
! Number of spin orbit states
call write_nss(LU,nss,dbg)
!-----------------------------------------------------------------------
! Number of spin free states
call write_nstate(LU,nstate,dbg)
!-----------------------------------------------------------------------
! Number of spin multiplicities
call write_nmult(LU,njob,dbg)
!-----------------------------------------------------------------------
! Values of the spin multiplicity
call write_imult(LU,njob,mltplt,dbg)
!-----------------------------------------------------------------------
! Number of roots in each spin multiplicity
call write_nroot(LU,njob,nroot,dbg)
!-----------------------------------------------------------------------
! SZ projection of the states defining the ording
call write_szproj(LU,nss,szproj,dbg)
!-----------------------------------------------------------------------
! spin multiplicity for all states
call write_multiplicity(LU,nstate,multiplicity,dbg)
!-----------------------------------------------------------------------
! Eigenvalues of the HBO matrix (spin-free energies from RASSCF)
! atomic units
call write_eso(LU,nss,eso_au,dbg)
!-----------------------------------------------------------------------
! Eigenvalues of the HBO matrix (spin-free energies from RASSCF)
! atomic units
call write_esfs(LU,nstate,esfs_au,dbg)
!-----------------------------------------------------------------------
! Angular momentum operator in the basis of spin free states,
! component X,Y,Z
call write_angmom(LU,nstate,angmom,dbg)
!-----------------------------------------------------------------------
! AMFI/SOMF operator in the basis of spin free states
! (see eq. 35 in:
! D. Ganyushin and F. Neese, J. Chem. Phys. 138, 104113, 2013).
! Note that the meaning of AMFI integrals is different in
! MOLCAS and ORCA
call write_amfi(LU,nstate,amfi,dbg)
!-----------------------------------------------------------------------
! Electric transition-dipole moments in the basis of spin free states
! The dipole moments, where bra and ket have the same state, are not computed. ??
call write_edipmom(LU,nstate,edmom,dbg)
!-----------------------------------------------------------------------
! Magnetic dipole moment in the basis of SO states
call write_magnetic_moment(LU,nss,MM,dbg)
!-----------------------------------------------------------------------
! Spin moment in the basis of SO states
call write_spin_moment(Lu,nss,MS,dbg)
!-----------------------------------------------------------------------
! Electric transition-dipole moments in the basis of SO states
call write_electric_moment(LU,nss,DM,dbg)
!-----------------------------------------------------------------------
! Eigenvectors of the HBO+SOC matrix
call write_eigen(LU,nss,U,dbg)
!-----------------------------------------------------------------------
! The HBO+SOC matrix, atomic units
call write_hso(LU,nss,HSO,dbg)
!-----------------------------------------------------------------------
close(Lu)

call mma_deallocate(szproj)
call mma_deallocate(jbnum)
call mma_deallocate(mltplt)
call mma_deallocate(nroot)
call mma_deallocate(xyz)

return

end subroutine write_new_formatted_aniso

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Per Ake Malmqvist                                *
*               1996, Roland Lindh                                     *
************************************************************************
      Subroutine AMPMem(nHer,MemAMP,la,lb,lr)
C     Statement function for Cartesian index
      nElem(ixyz) = ((ixyz+1)*(ixyz+2))/2

C Mem1: Workspace for MltPrm.
C Mem2: Tables Tpp,Tp,T0,Tm, and Tmm.
C Mem3: Result from AMPr.
      Mem1=0
      Call MltMmP(nOrder,Mem,la,lb+2,2)
      Mem1=max(Mem1,Mem)
      Mem2=6*nElem(la)*nElem(lb+2)
      nHer = nOrder
      Call MltMmP(nOrder,Mem,la,lb+1,1)
      Mem1=max(Mem1,Mem)
      Mem2=Mem2+3*nElem(la)*nElem(lb+1)
      Call MltMmP(nOrder,Mem,la,lb  ,2)
      Mem1=max(Mem1,Mem)
      Mem2=Mem2+6*nElem(la)*nElem(lb)
      If (lb.ge.1) Then
        Call MltMmP(nOrder,Mem,la,lb-1,1)
        Mem1=max(Mem1,Mem)
        Mem2=Mem2+3*nElem(la)*nElem(lb-1)
        If (lb.ge.2) Then
          Call MltMmP(nOrder,Mem,la,lb-2,2)
          Mem1=max(Mem1,Mem)
          Mem2=Mem2+6*nElem(la)*nElem(lb-2)
        End If
      End If
      Mem3=6*nElem(la)*nElem(lb)

      MemAMP=Mem1+Mem2+Mem3+1

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lr)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine FckDst(TwoHam,nDens,Fij,iBas,jBas,iCmp,jCmp,ikop1,ikop2,Irrep,Shij,iAO1,iAO2,iAOst1,iAOst2,fact)

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: iChTbl, iOper, nIrrep
use SOAO_Info, only: iAOtSO, nSOInf
use Basis_Info, only: nBas
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDens, iBas, jBas, iCmp, jCmp, ikOp1, ikOp2, Irrep, iAO1, iAO2, iAOst1, iAOst2
real(kind=wp), intent(inout) :: TwoHam(nDens)
real(kind=wp), intent(in) :: Fij(0:iBas-1,0:jBas-1,iCmp,jCmp), Fact
logical(kind=iwp), intent(in) :: Shij
integer(kind=iwp) :: i1, i2, iAO, iAOi, iChO, iIR, iIrrep, ipF, ipFij, iPnt(0:7), iPntij, iSO, iSOi, iSOj, jAO, jAOj, jirr(0:7), &
                     jIrrep, jSO, jSOi, jSOj, l1, l2, NrOpr
real(kind=wp) :: Fac, x1, x2, x3, x4, xr

iChO = iOper(Irrep)
if (iChO == 0) then

  iPntij = 0
  do iIrrep=0,nIrrep-1
    iPnt(iIrrep) = iPntij
    iPntij = iPntij+nTri_Elem(nBas(iIrrep))
  end do

  ! Distribute contributions from the intermediate skeleton
  ! Fock matrix onto the symmetry adapted Fock matrix.

  iiR = NrOpr(ieor(ikOp1,ikOp2))
  do i1=1,iCmp
    do i2=1,jCmp
      do iIrrep=0,nIrrep-1
        if (max(iAO1+i1,iAO2+i2) > nSOInf) then
          write(u6,*) 'Fckdst: Max(iSO.jSO)>nSOInf (1)'
          call Abend()
        end if
        iSO = iAOtSO(iAO1+i1,iIrrep)+iAOst1
        jSO = iAOtSO(iAO2+i2,iIrrep)+iAOst2
        XR = real(iChTbl(iIrrep,iiR),kind=wp)

        if ((iSO < 0) .or. (jSO < 0)) cycle

        iPntij = iPnt(iIrrep)
        do jAOj=0,jBas-1
          do iAOi=0,iBas-1
            Fac = XR
            if (Shij .and. (i1 == i2) .and. (iAOi+iAOst1 == jAOj+iAOst2)) Fac = Two*XR
            jSOj = jSO+jAOj
            iSOi = iSO+iAOi
            ipFij = iPntij+iTri(iSOi,jSOj)
            TwoHam(ipFij) = TwoHam(ipFij)+Fact*Fac*Fij(iAOi,jAOj,i1,i2)
          end do
        end do

      end do ! iIrrep
    end do   ! i2
  end do     ! i1

else

  do iIrrep=0,nIrrep-1
    jIrr(iIrrep) = NrOpr(ieor(iOper(iIrrep),iChO))
  end do

  iPntij = 0
  iPnt(0:nIrrep-1) = -1
  do iIrrep=0,nIrrep-1
    jIrrep = jIrr(iIrrep)
    if (iIrrep > jIrrep) then
      iPnt(iIrrep) = iPntij
      iPntij = iPntij+nBas(jIrrep)*nBas(iIrrep)
    end if
  end do

  ! Distribute contributions from the intermediate skeleton
  ! Fock matrix onto the symmetry adapted Fock matrix.

  l1 = NrOpr(ikop1)
  l2 = NrOpr(ikop2)
  do i1=1,iCmp
    do i2=1,jCmp
      do iIrrep=0,nIrrep-1
        jIrrep = jIrr(iIrrep)
        if (iIrrep < jIrrep) cycle
        X1 = real(iChTbl(iIrrep,l1),kind=wp)
        X2 = real(iChTbl(jIrrep,l2),kind=wp)
        X3 = real(iChTbl(jIrrep,l1),kind=wp)
        X4 = real(iChTbl(iIrrep,l2),kind=wp)
        if (max(iAO1+i1,iAO2+i2) > nSOInf) then
          write(u6,*) 'Fckdst: Max(iSO.jSO)>nSOInf (2)'
          call Abend()
        end if
        iSOi = iAOtSO(iAO1+i1,iIrrep)+iAOst1
        jSOj = iAOtSO(iAO2+i2,jIrrep)+iAOst2
        jSOi = iAOtSO(iAO2+i2,iIrrep)+iAOst2
        iSOj = iAOtSO(iAO1+i1,jIrrep)+iAOst1
        if ((iSOi > -1) .and. (jSOj > -1)) then
          iPntij = iPnt(iIrrep)
          do jAO=0,jBas-1
            do iAO=0,iBas-1
              Fac = X1*X2
              ipF = iPntij+(jSOj+jAO-1)*nBas(iIrrep)+iSOi+iAO
              TwoHam(ipF) = TwoHam(ipF)+Fact*Fac*Fij(iAO,jAO,i1,i2)
            end do
          end do
        end if
        if ((jSOi > -1) .and. (iSOj > -1)) then
          iPntij = iPnt(iIrrep)
          do jAO=0,jBas-1
            do iAO=0,iBas-1
              Fac = X3*X4
              ipF = iPntij+nBas(iIrrep)*(iSOj+iAO-1)+jSOi+jAO
              TwoHam(ipF) = TwoHam(ipF)+Fact*Fac*Fij(iAO,jAO,i1,i2)
            end do
          end do
        end if
      end do
    end do
  end do

end if

return

end subroutine FckDst

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine diisof(diispoint,ndiis)
! this routine opens 1-ndiis Temp files for DIIS procedure
! and store lun's in stack (diispoint)
!
! diispoint - stack of lun numbers (I)
! ndiis     - size of diis procedure (I)

use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: diispoint(4)
integer(kind=iwp), intent(in) :: ndiis
integer(kind=iwp) :: lun, rc

if (ndiis > 0) then
  call filemanager(1,lun,rc)
  diispoint(1) = lun
end if

if (ndiis > 1) then
  call filemanager(1,lun,rc)
  diispoint(2) = lun
end if

if (ndiis > 2) then
  call filemanager(1,lun,rc)
  diispoint(3) = lun
end if

if (ndiis > 3) then
  call filemanager(1,lun,rc)
  diispoint(4) = lun
end if

return

end subroutine diisof

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine expand (wrk,wrksize,
     & nind,exptyp,mapda,mapia,ssa,possb0,mapdb,
     &                    mapib,rc)
c
c     this routine realize expansion
c
c     A(pqrs) -> B(pqrs)
c
c     nind   - # of indexex in matrix A  (Input)
c     exptyp - type of expansion :  (Input)
c     1 - pq,r,s -> p,q,r,s  pq,r -> p,q,r  pq -> p,q
c     2 - p,qr,s -> p,q,r,s  p,qr -> p,q,r
c     3 - p,q,rs -> p,q,r,s
c     4 - pq,rs  -> p,q,r,s
c     5 - pq,rs  -> p,q,rs
c     6 - pq,rs  -> pq,r,s
c     mapda  - direct map matrix corresponding to A  (Input)
c     mapia  - inverse map matrix corresponding to A  (Input)
c     ssa    - overall symetry state  of matrix A  (Input)
c     possb0 - initial possition of matrix B in WRK  (Input)
c     mapdb  - direct map matrix corresponding to B  (Output)
c     mapib  - inverse map matrix corresponding to B  (Output)
c     rc     - return (error) code  (Output)
c
c     Table of expansions
c
c     nind  exptyp          Operation             Implementation
c     4       0     A(p,q,r,s) -> B(p,q,r,s)     Realized in map
c     4       1     A(pq,r,s)  -> B(p,q,r,s)           Yes
c     4       2     A(p,qr,s)  -> B(p,q,r,s)           Yes
c     4       3     A(p,q,rs)  -> B(p,q,r,s)           Yes
c     4       4     A(pq,rs)   -> B(p,q,r,s)           Yes
c     4       5     A(pq,rs)   -> B(p,q,rs)            Yes
c     4       6     A(pq,rs)   -> B(pq,r,s)            Yes
c
c     3       0     A(p,q,r)   -> B(p,q,r)       Realized in map
c     3       1     A(pq,r)    -> B(p,q,r)             Yes
c     3       2     A(p,qr)    -> B(p,q,r)             Yes
c
c     2       0     A(p,q)     -> B(p,q)         Realized in map
c     2       1     A(pq)      -> B(p,q)               Yes
c
c     1       0     A(p)       -> B(p)           Realized in map
c
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer nind,exptyp,ssa,possb0,rc
       integer mapda(0:512,1:6),mapdb(0:512,1:6)
       integer mapia(1:8,1:8,1:8),mapib(1:8,1:8,1:8)
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6
       integer sa1,sa2,sa3,sa4
       integer na,ia,ib1,ib2,ib3,ib4
       integer typa,posst
c
       rc=0
       na=mapda(0,5)
       typa=mapda(0,6)
c
c     general tests
c
       if (exptyp.eq.0) then
c     RC=1  : exptyp=0 (for exptyp=0, there is no sopystical expansion, NCI)
       rc=1
       return
       end if
c
c     get mapdb,mapib
c
       if ((nind.eq.4).and.(exptyp.eq.5)) then
       nhelp1=3
       else if ((nind.eq.4).and.(exptyp.eq.6)) then
       nhelp1=1
       else
       nhelp1=0
       end if
c
       call grc0 (nind,nhelp1,mapda(0,1),mapda(0,2),mapda(0,3),mapda(0,
     &            4),ssa,
     & possb0,posst,mapdb,mapib)
c
c
       if (nind.lt.2) then
c     RC=2 - number of indexes < 2 (NCI)
       rc=2
       end if
c
       if (nind.eq.2) then
c
c     ********** 2 index *********
c
       if (exptyp.eq.1) then
c
c2.1  expand A(pq) -> B(p,q)
c
c     tests
c
       if (typa.ne.1) then
c     RC=3 : nind=2, exptyp=1 (typA is not 1, Stup)
       rc=3
       return
       end if
c
       do 100 ia=1,na
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
c
       ib1=mapib(sa1,1,1)
       ib2=mapib(sa2,1,1)
c
       if (sa1.gt.sa2) then
c
c     map A(p,q) -> B(p,q)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB1
       nhelp2=mapdb(ib1,1)
       call map11 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),1)
c
c     map A(p,q) -> - B(q,p)
c
c     possB2
       nhelp2=mapdb(ib2,1)
c     dimp,dimq
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,2),sa2)
c
       call map21 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,2,1,-1)
c
       else
c     sa1=sa2
c
c     expand A(pq) -> B(p,q)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB
       nhelp2=mapdb(ib1,1)
c     dimp
       nhelp3=dimm(mapda(0,1),sa1)
c
       call expand0 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),nhelp3)
c
       end if

 100    continue
c
       else
c     RC=4 : nind=2, exptyp=@ (Inproper exptyp, Stup)
       rc=4
       return
       end if
c
       else if (nind.eq.3) then
c
c     ********** 3 index *********
c
       if (exptyp.eq.1) then
c
c3.1  expand A(pq,r) -> B(p,q,r)
c
c     tests
c
       if (typa.ne.1) then
c     RC=5 : nind=3, exptyp=1 (typA is not 1, Stup)
       rc=5
       return
       end if
c
       do 300 ia=1,na
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib1=mapib(sa1,sa2,1)
       ib2=mapib(sa2,sa1,1)
c
       if (sa1.gt.sa2) then
c
c     map A(p,q,r) -> B(p,q,r)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB1
       nhelp2=mapdb(ib1,1)
       call map11 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),1)
c
c     map A(p,q,r) -> - B(q,p,r)
c
c     possB2
       nhelp2=mapdb(ib2,1)
c     dimp,dimq,dimr
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,2),sa2)
       nhelp5=dimm(mapda(0,3),sa3)
c
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,2,1,3,
     &             -1)
c
       else
c     sa1=sa2
c
c     expand A(pq,r) -> B(p,q,r)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB
       nhelp2=mapdb(ib1,1)
c     dimpq
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp3=nhelp3*(nhelp3-1)/2
c     dimp,dimr
       nhelp4=dimm(mapda(0,1),sa1)
       nhelp5=dimm(mapda(0,3),sa3)
c
       call expand1 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5)
c
       end if

 300    continue
c
       else if (exptyp.eq.2) then
c
c3.2  expand A(p,qr) -> B(p,q,r)
c
c     tests
c
       if (typa.ne.2) then
c     RC=6 : nind=3, exptyp=2 (typA is not 2, Stup)
       rc=6
       return
       end if
c
       do 400 ia=1,na
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
c
       ib1=mapib(sa1,sa2,1)
       ib2=mapib(sa1,sa3,1)
c
       if (sa2.gt.sa3) then
c
c     map A(p,q,r) -> B(p,q,r)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB1
       nhelp2=mapdb(ib1,1)
       call map11 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),1)
c
c     map A(p,q,r) -> - B(q,p,r)
c
c     possB2
       nhelp2=mapdb(ib2,1)
c     dimp,dimq,dimr
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,2),sa2)
       nhelp5=dimm(mapda(0,3),sa3)
c
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,1,3,2,
     &             -1)
c
       else
c     sa2=sa3
c
c     expand A(p,qr) -> B(p,q,r)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB
       nhelp2=mapdb(ib1,1)
c     dimqr
       nhelp3=dimm(mapda(0,2),sa1)
       nhelp3=nhelp3*(nhelp3-1)/2
c     dimp,dimq
       nhelp4=dimm(mapda(0,1),sa1)
       nhelp5=dimm(mapda(0,2),sa2)
c
       call expand3 (wrk(nhelp1),wrk(nhelp2),nhelp4,nhelp3,nhelp5)
c
       end if

 400    continue
c
       else
c     RC=7 : nind=3, exptyp=@ (Inproper exptyp, Stup)
       rc=7
       return
       end if
c
       else if (nind.eq.4) then
c
c     ********** 4 index *********
c
       if (exptyp.eq.1) then
c
c4.1  expand A(pq,r,s) -> B(p,q,r,s)
c
c     tests
c
       if (typa.ne.1) then
c     RC=8 : nind=4, exptyp=1 (typA is not 1, Stup)
       rc=8
       return
       end if
c
       do 500 ia=1,na
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
       sa4=mapda(ia,6)
c
       ib1=mapib(sa1,sa2,sa3)
       ib2=mapib(sa2,sa1,sa3)
c
       if (sa1.gt.sa2) then
c
c     map A(p,q,r,s) -> B(p,q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB1
       nhelp2=mapdb(ib1,1)
       call map11 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),1)
c
c     map A(p,q,r,s) -> - B(q,p,r,s)
c
c     possB2
       nhelp2=mapdb(ib2,1)
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,2),sa2)
       nhelp5=dimm(mapda(0,3),sa3)
       nhelp6=dimm(mapda(0,4),sa4)
c
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             2,1,3,4,-1)
c
       else
c     sa1=sa2
c
c     expand A(pq,r_s) -> B(p,q,r_s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB
       nhelp2=mapdb(ib1,1)
c     dimpq
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp3=nhelp3*(nhelp3-1)/2
c     dimp,dimr_s
       nhelp4=dimm(mapda(0,1),sa1)
       nhelp5=dimm(mapda(0,3),sa3)*dimm(mapda(0,4),sa4)
c
       call expand1 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5)
c
       end if

 500    continue
c
       else if (exptyp.eq.2) then
c
c4.2  expand A(p,qr,s) -> B(p,q,r,s)
c
c     tests
c
       if (typa.ne.2) then
c     RC=9 : nind=4, exptyp=2 (typA is not 2, Stup)
       rc=9
       return
       end if
c
       do 600 ia=1,na
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
       sa4=mapda(ia,6)
c
       ib1=mapib(sa1,sa2,sa3)
       ib2=mapib(sa1,sa3,sa2)
c
       if (sa2.gt.sa3) then
c
c     map A(p,q,r,s) -> B(p,q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB1
       nhelp2=mapdb(ib1,1)
       call map11 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),1)
c
c     map A(p,q,r,s) -> - B(p,r,q,s)
c
c     possB2
       nhelp2=mapdb(ib2,1)
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,2),sa2)
       nhelp5=dimm(mapda(0,3),sa3)
       nhelp6=dimm(mapda(0,4),sa4)
c
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             1,3,2,4,-1)
c
       else
c     sa2=sa3
c
c     expand A(p,qr,s) -> B(p,q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB
       nhelp2=mapdb(ib1,1)
c     dimqr
       nhelp3=dimm(mapda(0,2),sa1)
       nhelp3=nhelp3*(nhelp3-1)/2
c     dimp,dims,dimq
       nhelp4=dimm(mapda(0,1),sa1)
       nhelp5=dimm(mapda(0,4),sa4)
       nhelp5=dimm(mapda(0,2),sa2)
c
       call expand2 (wrk(nhelp1),wrk(nhelp2),nhelp4,nhelp3,nhelp5,
     &               nhelp6)
c
       end if

 600    continue
c
       else if (exptyp.eq.3) then
c
c4.3  expand A(p,q,rs) -> B(p,q,r,s)
c
c     tests
c
       if (typa.ne.3) then
c     RC=10: nind=4, exptyp=3 (typA is not 3, Stup)
       rc=10
       return
       end if
c
       do 700 ia=1,na
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
       sa4=mapda(ia,6)
c
       ib1=mapib(sa1,sa2,sa3)
       ib2=mapib(sa1,sa2,sa4)
c
       if (sa3.gt.sa4) then
c
c     map A(p,q,r,s) -> B(p,q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB1
       nhelp2=mapdb(ib1,1)
       call map11 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),1)
c
c     map A(p,q,r,s) -> - B(q,p,r,s)
c
c     possB2
       nhelp2=mapdb(ib2,1)
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,2),sa2)
       nhelp5=dimm(mapda(0,3),sa3)
       nhelp6=dimm(mapda(0,4),sa4)
c
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             1,2,4,3,-1)
c
       else
c     sa1=sa2
c
c     expand A(p_q,rs) -> B(p_q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB
       nhelp2=mapdb(ib1,1)
c     dimrs
       nhelp3=dimm(mapda(0,3),sa3)
       nhelp3=nhelp3*(nhelp3-1)/2
c     dimr,dimp_q
       nhelp4=dimm(mapda(0,3),sa3)
       nhelp5=dimm(mapda(0,1),sa1)*dimm(mapda(0,2),sa2)
c
       call expand3 (wrk(nhelp1),wrk(nhelp2),nhelp5,nhelp3,nhelp4)
c
       end if

 700    continue
c
       else if (exptyp.eq.4) then
c
c4.4  expand A(pq,rs) -> B(p,q,r,s)
c
c     tests
c
       if (typa.ne.4) then
c     RC=11: nind=4, exptyp=4 (typA is not 4, Stup)
       rc=11
       return
       end if
c
       do 800 ia=1,na
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
       sa4=mapda(ia,6)
c
       ib1=mapib(sa1,sa2,sa3)
       ib2=mapib(sa2,sa1,sa3)
       ib3=mapib(sa1,sa2,sa4)
       ib4=mapib(sa2,sa1,sa4)
c
       if ((sa1.gt.sa2).and.(sa3.gt.sa4)) then
c
c     map A(p,q,r,s) -> B(p,q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB1
       nhelp2=mapdb(ib1,1)
       call map11 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),1)
c
c     map A(p,q,r,s) -> - B(q,p,r,s)
c     map A(p,q,r,s) -> - B(p,q,s,r)
c     map A(p,q,r,s) -> + B(q,p,s,r)
c
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,2),sa2)
       nhelp5=dimm(mapda(0,3),sa3)
       nhelp6=dimm(mapda(0,4),sa4)
c
c     possB2
       nhelp2=mapdb(ib2,1)
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             2,1,3,4,-1)
c
c     possB3
       nhelp2=mapdb(ib3,1)
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             1,2,4,3,-1)
c
c     possB4
       nhelp2=mapdb(ib4,1)
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             2,1,4,3,1)
c
       else if ((sa1.eq.sa2).and.(sa3.eq.sa4)) then
c
c     expand A(pq,rs) -> B(p,q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB
       nhelp2=mapdb(ib1,1)
c     dimp,dimq
       nhelp5=dimm(mapda(0,1),sa1)
       nhelp6=dimm(mapda(0,3),sa3)
c     dimpq,dimrs
       nhelp3=nhelp5*(nhelp5-1)/2
       nhelp4=nhelp6*(nhelp6-1)/2
c
       call expand40 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,
     &                nhelp6)
c
       else if (sa1.eq.sa2) then
c
c     expand A(pq,r_s) -> B(p,q,r_s)
c
c     possA
       nhelp1=mapda(ia,1)
c     dimr,dims
       nhelp5=dimm(mapda(0,3),sa3)
       nhelp6=dimm(mapda(0,4),sa4)
c     dimpq
       nhelp4=dimm(mapda(0,1),sa1)
       nhelp3=nhelp4*(nhelp4-1)/2
c
c     possB1
       nhelp2=mapdb(ib1,1)
       call expand1 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5*nhelp6,
     &               nhelp4)
c
c     expand A(pq,r,s) -> - B(p,q,s,r)
c
c     possB3
       nhelp2=mapdb(ib3,1)
       call expand41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5,nhelp6,
     &                nhelp4)
c
       else if (sa3.eq.sa4) then
c
c     expand A(p_q,rs) -> B(p_q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     dimp,dimq
       nhelp5=dimm(mapda(0,1),sa1)
       nhelp6=dimm(mapda(0,2),sa2)
c     dimrs
       nhelp4=dimm(mapda(0,3),sa3)
       nhelp3=nhelp4*(nhelp4-1)/2
c
c     possB1
       nhelp2=mapdb(ib1,1)
       call expand3 (wrk(nhelp1),wrk(nhelp2),nhelp5*nhelp6,nhelp3,
     &               nhelp4)
c
c     expand A(p,q,rs) -> - B(q,p,r,s)
c
c     possB4
       nhelp2=mapdb(ib2,1)
       call expand41 (wrk(nhelp1),wrk(nhelp2),nhelp5,nhelp6,nhelp3,
     &                nhelp4)
c
       end if
c
 800    continue
c
       else if (exptyp.eq.5) then
c
c4.5  expand A(pq,rs) -> B(p,q,rs)
c
c     tests
c
       if (typa.ne.4) then
c     RC=12: nind=4, exptyp=5 (typA is not 4, Stup)
       rc=12
       return
       end if
c
       do 900 ia=1,na
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
       sa4=mapda(ia,6)
c
       ib1=mapib(sa1,sa2,sa3)
       ib2=mapib(sa2,sa1,sa3)
c
       if (sa3.gt.sa4) then
c
c     map A(p,q,r,s) -> B(p,q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB1
       nhelp2=mapdb(ib1,1)
       call map11 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),1)
c
c     map A(p,q,r,s) -> - B(q,p,r,s)
c
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,2),sa2)
       nhelp5=dimm(mapda(0,3),sa3)
       nhelp6=dimm(mapda(0,4),sa4)
c
c     possB2
       nhelp2=mapdb(ib2,1)
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             2,1,3,4,-1)
c
       else if ((sa1.eq.sa2).and.(sa3.eq.sa4)) then
c
c     expand A(pq,rs) -> B(p,q,rs)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB
       nhelp2=mapdb(ib1,1)
c     dimp,dimr
       nhelp5=dimm(mapda(0,1),sa1)
       nhelp6=dimm(mapda(0,3),sa3)
c     dimpq,dimrs
       nhelp3=nhelp5*(nhelp5-1)/2
       nhelp4=nhelp6*(nhelp6-1)/2
c
       call expand1 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5)
c
       else if (sa1.eq.sa2) then
c
c     expand A(pq,r_s) -> B(p,q,r_s)
c
c     possA
       nhelp1=mapda(ia,1)
c     dimr,dims
       nhelp5=dimm(mapda(0,3),sa3)
       nhelp6=dimm(mapda(0,4),sa4)
c     dimpq
       nhelp4=dimm(mapda(0,1),sa1)
       nhelp3=nhelp4*(nhelp4-1)/2
c
c     possB1
       nhelp2=mapdb(ib1,1)
       call expand1 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5*nhelp6,
     &               nhelp4)
c
       else if (sa3.eq.sa4) then
c
c     map A(p,q,rs) -> B(p,q,rs)
c
c     possA
       nhelp1=mapda(ia,1)
c     dimp,dimq
       nhelp5=dimm(mapda(0,1),sa1)
       nhelp6=dimm(mapda(0,2),sa2)
c     dimrs
       nhelp4=dimm(mapda(0,3),sa3)
       nhelp3=nhelp4*(nhelp4-1)/2
c
c     possB1
       nhelp2=mapdb(ib1,1)
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp5,nhelp6,nhelp3,1,2,3,1)
c
c     map A(p,q,rs) -> - B(q,p,rs)
c
c     possB4
       nhelp2=mapdb(ib2,1)
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp5,nhelp6,nhelp3,2,1,3,
     &             -1)
c
       end if
c
 900    continue
c
       else if (exptyp.eq.6) then
c
c4.6  expand A(pq,rs) -> B(pq,r,s)
c
c     tests
c
       if (typa.ne.4) then
c     RC=13: nind=4, exptyp=6 (typA is not 4, Stup)
       rc=13
       return
       end if
c
       do 1000 ia=1,na
c
       sa1=mapda(ia,3)
       sa2=mapda(ia,4)
       sa3=mapda(ia,5)
       sa4=mapda(ia,6)
c
       ib1=mapib(sa1,sa2,sa3)
       ib3=mapib(sa1,sa2,sa4)
c
       if ((sa1.gt.sa2).and.(sa3.gt.sa4)) then
c
c     map A(p,q,r,s) -> B(p,q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB1
       nhelp2=mapdb(ib1,1)
       call map11 (wrk(nhelp1),wrk(nhelp2),mapda(ia,2),1)
c
c     map A(p,q,r,s) -> - B(q,p,r,s)
c     map A(p,q,r,s) -> - B(p,q,s,r)
c     map A(p,q,r,s) -> + B(q,p,s,r)
c
c     dimp,dimq,dimr,dims
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,2),sa2)
       nhelp5=dimm(mapda(0,3),sa3)
       nhelp6=dimm(mapda(0,4),sa4)
c
c     possB3
       nhelp2=mapdb(ib3,1)
       call map41 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,
     &             1,2,4,3,-1)
c
       else if ((sa1.eq.sa2).and.(sa3.eq.sa4)) then
c
c     expand A(pq,rs) -> B(pq,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     possB
       nhelp2=mapdb(ib1,1)
c     dimp,dimq
       nhelp5=dimm(mapda(0,1),sa1)
       nhelp6=dimm(mapda(0,3),sa3)
c     dimpq,dimrs
       nhelp3=nhelp5*(nhelp5-1)/2
       nhelp4=nhelp6*(nhelp6-1)/2
c
c@@?  call expand4 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6)
       call expand3 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp6)
c
       else if (sa1.eq.sa2) then
c
c     map A(pq,r,s) -> B(pq,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     dimp,dimr,dims
       nhelp3=dimm(mapda(0,1),sa1)
       nhelp4=dimm(mapda(0,3),sa3)
       nhelp5=dimm(mapda(0,4),sa4)
c     dimpq
       nhelp6=nhelp3*(nhelp3-1)/2
c
c     possB1
       nhelp2=mapdb(ib1,1)
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp6,nhelp4,nhelp5,1,2,3,1)
c
c     map A(pq,r,s) -> - B(pq,s,r)
c
c     possB3
       nhelp2=mapdb(ib3,1)
       call map31 (wrk(nhelp1),wrk(nhelp2),nhelp6,nhelp4,nhelp5,1,3,2,
     &             -1)
c
       else if (sa3.eq.sa4) then
c
c     expand A(p,q,rs) -> B(p,q,r,s)
c
c     possA
       nhelp1=mapda(ia,1)
c     dimp,dimq
       nhelp5=dimm(mapda(0,1),sa1)
       nhelp6=dimm(mapda(0,2),sa2)
c     dimrs
       nhelp4=dimm(mapda(0,3),sa3)
       nhelp3=nhelp4*(nhelp4-1)/2
c
c     possB1
       nhelp2=mapdb(ib1,1)
       call expand3 (wrk(nhelp1),wrk(nhelp2),nhelp5*nhelp6,nhelp3,
     &               nhelp4)
c
       end if
c
 1000   continue
c
       else
c     RC=14: nind=4, exptyp=@ (Inproper exptyp, Stup)
       rc=14
       end if
c
       else
c     RC=15- nind=@ (number of indexes >4, NCI)
       rc=15
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(mapia)
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       SUBROUTINE mkadress (NOIPSB)

CFUE
CFUE   It is strictly forbidden to use any construct to fetch disk
CFUE   addresses which do not make use of subroutines provided in
CFUE   the MOLCAS utilities as otherwise transparency and portability
CFUE   is lost.
CFUE

C
c     this routine prepair information arrays
c     for integral blocks per symmetry in primitive form
c     it defines:
c     noipsb(nijkl) - number of integrals per symmetry block
c     idispsb(nijkl)- initial addreses for exach symmetry block
c     typ(pa,qa,ra) - typ of symmetry block
c     types of (ij|kl):
c     1 - si=sk, si=sj, sk=sl
c     2 - si=sk, si=sj, sk>sl
c     3 - si=sk, si>sj, sk=sl
c     4 - si=sk, si>sj, sk>sl
c     5 - si>sk, si=sj, sk=sl
c     6 - si>sk, si=sj, sk>sl
c     7 - si>sk, si>sj, sk=sl
c     8 - si>sk, si>sj, sk>sl
c
c     idis(pa,qa,ra)- initial addreses for given symmetry block
c     np(pa,qa,ra)  - possition of p index in original block (ij|kl) (on tape)
c     nq(pa,qa,ra)  - possition of q index in original block (ij|kl) (on tape)
c     nr(pa,qa,ra)  - possition of r index in original block (ij|kl) (on tape)
c     ns(pa,qa,ra)  - possition of s index in original block (ij|kl) (on tape)
c
c     N.B. typ,idis,np,nq,nr,ns are trensfered thhrough common block /edpand2/
c
c
       IMPLICIT REAL*8(A-H,O-Z)

#include "tratoc.fh"
       integer INDMAX,MXFUNC
       PARAMETER (INDMAX=nTraBuf,MXFUNC=200)


#include "SysDef.fh"
#include "ccsort.fh"
#include "reorg.fh"

       integer NOIPSB(106)
       integer idispsb(106)
c
c     help variables
c
       integer sense
       integer p,q,r,s,pa,qa,ra,sa
       integer IND,INDT,ISPQRS,NINT,NSLM,idistemp,idishelp
       integer jlow,ilow,iup,jup,kup,lup,iold,jold,kold,lold
       integer norbp,nsi,nsj,nsk,nsl,nsij,nsijk

CFUE   - pick the start addresses of each symmetry allowed integral
CFUE     block from the tranformed two electron integral file
        idistemp=0
        Call iDaFile(LUINTM,0,iTraToc,nTraToc,idistemp)
CFUE   - the option 0 in the call to dafile does not make any I/O
CFUE     but just returns the updated disk address
CFUE   - at this point idistemp points to the first record

C
       IND=0
       INDT=0
CFUE   idistemp=1
CFUE   idisadd=150
C
       do 100 NSI=1,NSYM
       do 101 NSJ=1,NSYM
       do 102 NSK=1,NSYM
       typ(NSI,NSJ,NSK)=0
 102    continue
 101    continue
 100    continue
c

       if (fullprint.gt.0) then
       Write(6,'(6X,A)') 'Transformed integral blocks:'
       Write(6,'(6X,A)') '----------------------------'
       Write(6,*)
       Write(6,'(6X,A)')
     & 'block  symmetry      no. of        no. of '
       Write(6,'(6X,A)')
     & ' no.    spec.        orbitals     integrals'
       Write(6,'(6X,A)')
     & '-------------------------------------------'
       end if
c
       ISPQRS=0
       DO 300 NSI=1,NSYM
       DO 301 NSJ=1,NSI
       NSIJ=MUL(NSI,NSJ)
       DO 302 NSK=1,NSI
       NSIJK=MUL(NSK,NSIJ)
       NSLM=NSK
       IF(NSK.EQ.NSI) NSLM=NSJ
       DO 303 NSL=1,NSLM
       IF(NSIJK.NE.NSL) GO TO 303
       NORBP=NORB(NSI)*NORB(NSJ)*NORB(NSK)*NORB(NSL)
       IF(NORBP.EQ.0)GO TO 303
       ISPQRS=ISPQRS+1
c
c     def
c
c     redefine indices from Parr to Dirac notation <p,q|r,s> <-> (i,j|k,l)
c
       p=nsi
       q=nsk
       r=nsj
       s=nsl
c
c     def. sense
c
c     type (ij|kl)
c     1 - si=sk, si=sj, sk=sl
c     2 - si=sk, si=sj, sk>sl
c     3 - si=sk, si>sj, sk=sl
c     4 - si=sk, si>sj, sk>sl
c     5 - si>sk, si=sj, sk=sl
c     6 - si>sk, si=sj, sk>sl
c     7 - si>sk, si>sj, sk=sl
c     8 - si>sk, si>sj, sk>sl
c
       if (nsi.eq.nsk) then
       if (nsi.eq.nsj) then
       if (nsk.eq.nsl) then
       sense=1
       else
       sense=2
       end if
       else
       if (nsk.eq.nsl) then
       sense=3
       else
       sense=4
       end if
       end if
       else
       if (nsi.eq.nsj) then
       if (nsk.eq.nsl) then
       sense=5
       else
       sense=6
       end if
       else
       if (nsk.eq.nsl) then
       sense=7
       else
       sense=8
       end if
       end if
       end if
c
       if (nsijk.ne.nsl) then
       sense=0
       else if (NORB(NSI)*NORB(NSJ)*NORB(NSK)*NORB(NSL).eq.0) then
       sense=0
       end if
c
c
c1:   perm <pq|rs> -> <pq|rs>
c
       pa=p
       qa=q
       ra=r
       sa=s
       typ(pa,qa,ra)=sense
       idis(pa,qa,ra)=idistemp
       np(pa,qa,ra)=1
       nq(pa,qa,ra)=3
       nr(pa,qa,ra)=2
       ns(pa,qa,ra)=4
c
c2:   perm <pq|rs> -> <rq|ps> 1-3
c
       pa=r
       qa=q
       ra=p
       sa=s
       typ(pa,qa,ra)=sense
       idis(pa,qa,ra)=idistemp
       np(pa,qa,ra)=2
       nq(pa,qa,ra)=3
       nr(pa,qa,ra)=1
       ns(pa,qa,ra)=4
c
c3:   perm <pq|rs> -> <ps|rq> 2-4
c
       pa=p
       qa=s
       ra=r
       sa=q
       typ(pa,qa,ra)=sense
       idis(pa,qa,ra)=idistemp
       np(pa,qa,ra)=1
       nq(pa,qa,ra)=4
       nr(pa,qa,ra)=2
       ns(pa,qa,ra)=3
c
c4:   perm <pq|rs> -> <pq|rs> 1-3,2-4
c
       pa=r
       qa=s
       ra=p
       sa=q
       typ(pa,qa,ra)=sense
       idis(pa,qa,ra)=idistemp
       np(pa,qa,ra)=2
       nq(pa,qa,ra)=4
       nr(pa,qa,ra)=1
       ns(pa,qa,ra)=3
c
c5:   perm <pq|rs> -> <qp|sr> 1-2,3-4
c
       pa=q
       qa=p
       ra=s
       sa=r
       typ(pa,qa,ra)=sense
       idis(pa,qa,ra)=idistemp
       np(pa,qa,ra)=3
       nq(pa,qa,ra)=1
       nr(pa,qa,ra)=4
       ns(pa,qa,ra)=2
c
c6:   perm <pq|rs> -> <qp|sr> 1-2,3-4 -> <sp|qr> 1-3
c
       pa=s
       qa=p
       ra=q
       sa=r
       typ(pa,qa,ra)=sense
       idis(pa,qa,ra)=idistemp
       np(pa,qa,ra)=4
       nq(pa,qa,ra)=1
       nr(pa,qa,ra)=3
       ns(pa,qa,ra)=2
c
c7:   perm <pq|rs> -> <qp|sr> 1-2,3-4 -> <qr|sp> 2-4
c
       pa=q
       qa=r
       ra=s
       sa=p
       typ(pa,qa,ra)=sense
       idis(pa,qa,ra)=idistemp
       np(pa,qa,ra)=3
       nq(pa,qa,ra)=2
       nr(pa,qa,ra)=4
       ns(pa,qa,ra)=1
c
c8:   perm <pq|rs> -> <qp|sr> 1-2,3-4 -> <sr|qp> 1-3,2-4
c
       pa=s
       qa=r
       ra=q
       sa=p
       typ(pa,qa,ra)=sense
       idis(pa,qa,ra)=idistemp
       np(pa,qa,ra)=4
       nq(pa,qa,ra)=2
       nr(pa,qa,ra)=3
       ns(pa,qa,ra)=1
c
c
       idispsb(ispqrs)=idistemp
       idishelp=0
C
C     ******************************************************************
C
C     LOOP OVER THE USED ORBITALS OF EACH SYMMETRY BLOCK
C     THIS LOOPING IS COPIED FROM THE MANUAL OF THE 4-INDEX
C     TRANSFORMATION PROGRAM
C
C     NINT COUNTS INTEGRAL LABELS IN THE GIVEN SYMMETRY BLOCK
C
       NINT=0
       KUP=NORB(NSK)
       DO 401 KOLD=1,KUP
C
       LUP=NORB(NSL)
       IF (NSK.EQ.NSL) LUP=KOLD
       DO 402 LOLD=1,LUP
C
       ILOW=1
       IF (NSI.EQ.NSK) ILOW=KOLD
       IUP=NORB(NSI)
       DO 403 IOLD=ILOW,IUP
C
       JLOW=1
       IF (NSI.EQ.NSK.AND.IOLD.EQ.KOLD) JLOW=LOLD
       JUP=NORB(NSJ)
       IF (NSI.EQ.NSJ) JUP=IOLD
       DO 404 JOLD=JLOW,JUP
C
       IND=IND+1
       INDT=INDT+1
       NINT=NINT+1
       idishelp=idishelp+1
       if (idishelp.gt.INDMAX) then
CFUE     - all integrals in the reord were processed, hence
CFUE       update the disk address by a dummy I/O
         Call dDaFile(LUINTM,0,[0.0d0],INDMAX,idistemp)
CFUE     idistemp=idistemp+idisadd
         idishelp=1
       end if
C
       IF (IND.LT.INDMAX) GO TO 404
       IND=0
C
 404    CONTINUE
 403    CONTINUE
 402    CONTINUE
 401    CONTINUE
       if (idishelp.gt.0) then
CFUE     - all integrals in the reord were processed, hence
CFUE       update the disk address by a dummy I/O
         Call dDaFile(LUINTM,0,[0.0d0],INDMAX,idistemp)
CFUE   idistemp=idistemp+idisadd
       end if
C
C     WRITING THE LAST RECORD OF LABELS IN THE GIVEN SYMMETRY BLOCK
C     RECORDS ON LUPACK ARE FORMATTED TO 28KB LENGTH
C
       IF(IND.NE.0) THEN
       IND=0
       ENDIF
C
       NOIPSB(ISPQRS)=NINT
C
C     ******************************************************************
C
       if (fullprint.gt.0) then
       Write(6,'(6X,I5,2X,4I2,2X,4I4,2X,I8)')
     &       ISPQRS,
     &       NSI,NSJ,NSK,NSL,
     &       IUP,JUP,KUP,LUP,
     &       NINT
       end if
C
C     ******************************************************************
C
C
 303    CONTINUE
 302    CONTINUE
 301    CONTINUE
 300    CONTINUE
       if (fullprint.gt.0) then
       Write(6,'(6X,A)')
     & '-------------------------------------------'
       end if
C
       RETURN
       END
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Misc_Seward(iBas,iBas_Aux,iBas_Frag)
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only: S
      use Real_Info, only: RadMax, cdMax, EtMax
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
*                                                                      *
************************************************************************
*                                                                      *
      LuWr=6
*                                                                      *
************************************************************************
*                                                                      *
*     Loop over distinct shell types
*
      iBas  = 0
      iBas_Aux  = 0
      iBas_Frag = 0
*
      iShell=0
      mc = 1
      kdc = 0
*     Loop over basis sets
      iCnttp = 0
      Do jCnttp = 1, nCnttp
*
*        Make sure that we process the dummy shell last
*
         If (jCnttp.eq.iCnttp_Dummy .and. jCnttp.ne.nCnttp) Then
            iCnttp = iCnttp + 2
         Else If (jCnttp.eq.nCnttp .and. iCnttp.eq.jCnttp) Then
            iCnttp = iCnttp_Dummy
         Else
            iCnttp = iCnttp + 1
         End If
*
*        Loop over distinct centers
*
         Do iCnt = 1, dbsc(iCnttp)%nCntr
            kdc = kdc + 1
            mdc = iCnt + dbsc(iCnttp)%mdci
            if(Max(mdc,kdc).gt.MxAtom) then
               Call WarningMessage(2,'MxAtom too small:')
               write(LuWr,*) 'MxAtom=',MxAtom
               write(LuWr,*) 'Increase mxAtom in Molcas.fh and',
     &                       ' recompile the code!'
               Call Abend()
            end if
*           Loop over shells associated with this center
*           Start with s type shells
            jSh = dbsc(iCnttp)%iVal
            Do iAng = 0, dbsc(iCnttp)%nVal-1
               iShell = iShell + 1
*
               If (Shells(jSh)%nBasis_C.gt.0 )
     &            Call RdMx(RadMax,Shells(jSh)%Exp,
     &                             Shells(jSh)%nExp,
     &                      Shells(jSh)%Cff_c(1,1,1),
     &                      Shells(jSh)%nBasis_C,
     &                      cdMax,EtMax)
               If (iShell.gt.MxShll) Then
                  Call WarningMessage(2,'iShell.gt.MxShll;'
     &                    //' Change MxShll in info.fh and re'
     &                    //'compile the code!')
                  Call Abend()
               End If
               kCmp=(iAng+1)*(iAng+2)/2
               If (Shells(jSh)%Prjct) kCmp=2*iAng+1
*
               If (Shells(jSh)%nBasis.ne.0 ) Then
                  If (Shells(jSh)%Aux) Then
                     iBas_Aux  = iBas_Aux  + Shells(jSh)%nBasis * kCmp
     &                         * nIrrep/dc(mdc)%nStab
                  Else If (Shells(jSh)%Frag) Then
                     iBas_Frag = iBas_Frag  + Shells(jSh)%nBasis * kCmp
     &                         * nIrrep/dc(mdc)%nStab
                  Else
                     iBas  = iBas  + Shells(jSh)%nBasis * kCmp
     &                     * nIrrep/dc(mdc)%nStab
                  End If
               End If
               jSh = jSh + 1
            End Do
            mc = mc + nIrrep/dc(mdc)%nStab
         End Do
*
      End Do
      S%nShlls = iShell
      If (iBas.ge.2*MaxBfn) Then
         Call WarningMessage(2,'MaxBfn too small')
         Write (LuWr,*) 'Increase 2*MaxBfn to ', iBas
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! OBSERVE! If the output to the mpprop file that this subroutine generates
!   is modified, then notify the person responsible for qmstat, since that
!   program uses the mpprop outputfile.
subroutine Wr_Files(nAtoms,nCenters,nMltPl,NORBI,NOCOB,NOCOB_b,OENE,OENE_b,LAllCenters)
!EB subroutine Wr_Files(nAtoms,nCenters,nMltPl,NORBI,NOCOB,OENE,iBond,

use MPProp_globals, only: AtBoMltPl, AtBoMltPlCopy, AtMltPl, AtMltPlTot, AtPol, AtBoPol, BondMat, Cen_Lab, Cor, EneV, iAtomType, &
                          iAtomPar, Method, Title
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nCenters, nMltPl, NORBI, NOCOB, NOCOB_b !, iBond(2,nCenters)
real(kind=wp), intent(in) :: OENE(NOCOB), OENE_b(NOCOB_b)
logical(kind=iwp), intent(in) :: LAllCenters
integer(kind=iwp) :: i, iMltPl, j, Lu
real(kind=wp) :: MolPol(6)
character(len=8) :: FileName
logical(kind=iwp) :: Exists

MolPol(:) = Zero

Lu = 30
FileName = 'MPPROP'
call OpnFl(FileName,Lu,Exists)
rewind(Lu)

write(Lu,6) '**************************************************'
write(Lu,6) '* Molecule'
write(Lu,6) Title
write(Lu,6) '* Method'
write(Lu,6) Method
write(Lu,6) '* Level of Multipoles and Polarizabilities'
write(Lu,3) nMltPl,1

! WE NOW HAVE THE MULTIPOLES IN TWO FORMS
!
! A) SUMMED ONTO ATOMIC TERMS ONLY
! B) SUMMED ONTO ATOMS AND BONDS
!
! EXPANSION TO BE USED FOR ELECTROSTATICS
!
!       CENTER
!       MULTIPOLE
!       POLARIZABILITY

if (.not. LAllCenters) then
  write(Lu,'(A)') '* Atomic centers '
  write(Lu,2) nAtoms
  do i=1,nAtoms
    write(Lu,3) iAtomType(i),iAtomPar(i),Cen_Lab(i*(i+1)/2)
    write(Lu,1) cor(1,i,i),cor(2,i,i),cor(3,i,i)
    do iMltPl=0,nMltPl
      write(Lu,1) AtMltPl(iMltPl)%A(:,i)
    end do
    do iMltPl=0,2
      write(Lu,1) AtBoMltPlCopy(iMltPl)%A(:,i*(i+1)/2)
    end do
    write(Lu,1) AtPol(:,i)
    MolPol(:) = MolPol(:)+AtPol(:,i)
  end do

else

  write(Lu,6) '* All centers'
  write(Lu,2) nCenters
  do i=1,nAtoms
    write(Lu,3) iAtomType(i),iAtomPar(i),Cen_Lab(i*(i+1)/2)
    write(Lu,1) Cor(1,i,i),Cor(2,i,i),Cor(3,i,i)
    do iMltPl=0,nMltPl
      write(Lu,1) AtBoMltPl(iMltPl)%A(:,i*(i+1)/2)
    end do
    do iMltPl=0,2
      write(Lu,1) AtBoMltPlCopy(iMltPl)%A(:,i*(i+1)/2+i-1)
    end do
    ! Begin EB
    ! if AtBoPol is not allocated, print zero
    if (.not. allocated(AtBoPol)) then
      write(Lu,1) Zero,Zero,Zero,Zero,Zero,Zero
    else
    ! End EB
      write(Lu,1) AtBoPol(:,i*(i+1)/2)
    ! Begin EB
    end if
    ! End EB
  end do
  do i=1,nAtoms
    do j=1,i-1
      if (BondMat(i,j)) then
        write(Lu,5) 0,1,iAtomType(i),iAtomPar(i),iAtomType(j),iAtomPar(j),Cen_Lab(i*(i-1)/2+j)
        write(Lu,1) Cor(1,i,j),Cor(2,i,j),Cor(3,i,j)
        do iMltPl=0,nMltPl
          write(Lu,1) AtBoMltPl(iMltPl)%A(:,i*(i-1)/2+j)
        end do
        do iMltPl=0,2
          write(Lu,1) AtBoMltPlCopy(iMltPl)%A(:,i*(i-1)/2+j)
        end do
        ! Begin EB
        ! if AtBoPol is not allocated, print zero
        if (.not. allocated(AtBoPol)) then
          write(Lu,1) Zero,Zero,Zero,Zero,Zero,Zero
        else
        ! End EB
          write(Lu,1) AtBoPol(:,i*(i-1)/2+j)
        ! Begin EB
        end if
        ! End EB
      end if
    end do
  end do

end if

write(Lu,6) '* Molecule properties '
do iMltPl=0,nMltPl
  write(Lu,1) AtMltPlTot(iMltPl)%A(:)
end do
write(Lu,1) MolPol(:)
write(Lu,'(A)') '* Orbital information'
write(Lu,3) NORBI,NOCOB
write(Lu,1) EneV
if (NOCOB /= 0) write(Lu,1) OENE(:)
if (Method == 'UHF-SCF') then
  write(Lu,3) NOCOB_b
  if (NOcOb_b /= 0) write(Lu,1) OENE_b(:)
end if

close(Lu)

return

1 format(3F20.10)
2 format(I5)
3 format(2I5,4X,2A)
!EB 4 format(I5,A1)
5 format(6I5,4X,A)
6 format(A)

end subroutine Wr_Files

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_bastype(BasisTypes,nData)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nData
integer(kind=iwp), intent(out) :: BasisTypes(nData)
integer(kind=iwp) :: is_BasisType = 0, loc_BasisTypes(4) = 0
character(len=*), parameter :: Label = 'BasType'

if (is_BasisType == 0) then
  call get_iArray(Label,loc_BasisTypes,nData)
  is_BasisType = 1
end if
BasisTypes(:) = loc_BasisTypes(1:nData)

return

end subroutine Get_bastype

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DGETMO (A,ldA,M,N,B,ldB)
C
C     TRANSPOSE A REGULAR MATRIX (OUT-OF-PLACE)
C
      REAL*8 A(ldA,*),B(ldB,*)
C
      If ( M.le.0 ) then
         Write (6,*)
         Write (6,*)
     &   '  *** Error in subroutine DGETMO ***'
         Write (6,*)
     &   '  Invalid dimension of matrix A :'
         Write (6,*)
     &   '  The number of columns, M, must be larger than zero'
         Write (6,*)
      End If
      If ( N.le.0 ) then
         Write (6,*)
         Write (6,*)
     &   '  *** Error in subroutine DGETMO ***'
         Write (6,*)
     &   '  Invalid leading dimension of matrix B :'
         Write (6,*)
     &   '  The number of rows, N, must be larger than zero'
         Write (6,*)
      End If
      If ( (ldA.le.0) .or. (ldA.lt.M) ) then
         Write (6,*)
         Write (6,*)
     &   '  *** Error in subroutine DGETMO ***'
         Write (6,*)
     &   '  Invalid leading dimension of matrix A :'
         Write (6,*)
     &   '  ldA must be larger than 0 and larger than M'
         Write (6,*)
      End If
      If ( (ldB.le.0) .or. (ldB.lt.N) ) then
         Write (6,*)
         Write (6,*)
     &   '  *** Error in subroutine DGETMO ***'
         Write (6,*)
     &   '  Invalid leading dimension of matrix B :'
         Write (6,*)
     &   '  ldB must be larger than 0 and larger than N'
         Write (6,*)
      End If
      INC=8
      Do j=1,M,INC
         jj=Min(M-j+1,INC)
         Go To (1,2,3,4,5,6,7,8) jj
         Write (6,*) 'Error in DGETMO!'
 1       Continue
            Do i=1,N
               B(i,j)=A(j,i)
            End Do
         Go To 99
 2       Continue
            Do i=1,N
               B(i,j  )=A(j  ,i)
               B(i,j+1)=A(j+1,i)
            End Do
         Go To 99
 3       Continue
            Do i=1,N
               B(i,j  )=A(j  ,i)
               B(i,j+1)=A(j+1,i)
               B(i,j+2)=A(j+2,i)
            End Do
         Go To 99
 4       Continue
            Do i=1,N
               B(i,j  )=A(j  ,i)
               B(i,j+1)=A(j+1,i)
               B(i,j+2)=A(j+2,i)
               B(i,j+3)=A(j+3,i)
            End Do
         Go To 99
 5       Continue
            Do i=1,N
               B(i,j  )=A(j  ,i)
               B(i,j+1)=A(j+1,i)
               B(i,j+2)=A(j+2,i)
               B(i,j+3)=A(j+3,i)
               B(i,j+4)=A(j+4,i)
            End Do
         Go To 99
 6       Continue
            Do i=1,N
               B(i,j  )=A(j  ,i)
               B(i,j+1)=A(j+1,i)
               B(i,j+2)=A(j+2,i)
               B(i,j+3)=A(j+3,i)
               B(i,j+4)=A(j+4,i)
               B(i,j+5)=A(j+5,i)
            End Do
         Go To 99
 7       Continue
            Do i=1,N
               B(i,j  )=A(j  ,i)
               B(i,j+1)=A(j+1,i)
               B(i,j+2)=A(j+2,i)
               B(i,j+3)=A(j+3,i)
               B(i,j+4)=A(j+4,i)
               B(i,j+5)=A(j+5,i)
               B(i,j+6)=A(j+6,i)
            End Do
         Go To 99
 8       Continue
            Do i=1,N
               B(i,j  )=A(j  ,i)
               B(i,j+1)=A(j+1,i)
               B(i,j+2)=A(j+2,i)
               B(i,j+3)=A(j+3,i)
               B(i,j+4)=A(j+4,i)
               B(i,j+5)=A(j+5,i)
               B(i,j+6)=A(j+6,i)
               B(i,j+7)=A(j+7,i)
            End Do
 99      Continue
      End Do
C
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine SORT1C(nUt,vInt,nSqNum,nSyBlk)
************************************************************************
*                                                                      *
*     Purpose: Provided SEWARD was allowed to use a virtual disk       *
*              scatter the 2el integrals into the approriate place.    *
*                                                                      *
*     Called from: SORT1A                                              *
*                                                                      *
*     Calling Parameters:                                              *
*     nUt    : number of 2el integrals in the buffers vInt,nSqNum      *
*              and nSyBlk                                              *
*     vInt   : Buffer of 2el integral values                           *
*     nSqNum : sequence number of the integral relative to             *
*              the first adress of the symmetry block                  *
*     nSyBlk : symmetry block number of an integral                    *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDat : definitions of sorting flags and address tables         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher                                                  *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (A-H,O-Z)
*
#include "Molcas.fh"
#include "TwoDat.fh"
*
      Real*8 vInt(nUt),nSqNum(nUt),nSyBlk(nUt)
*
*----------------------------------------------------------------------*
*     Turn timing ON                                                   *
*----------------------------------------------------------------------*
*
*
*----------------------------------------------------------------------*
*     scatter the 2el integrals to the appropriate position            *
*     of the virtual disk                                              *
*----------------------------------------------------------------------*
*
*     Write (*,'(2X,5(I4,I8,F12.8))')
*    &      (nSyBlk(iUt),
*    &       RAMD_adr(nBatch(nSyBlk(iUt)))+nSqNum(iUt)-1,
*    &       vInt(iUt),
*    &       iUt=1,nUt)
      Do iUt=1,nUt
        iSyBlk=INT(nSyBlk(iUt))
        iBatch=nBatch(iSyBlk)
        iOff=RAMD_adr(iBatch)+INT(nSqNum(iUt))
        RAMD_ints(iOff) = vInt(iUt)
      End Do
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function dev(N,Fcal,Fexp)
! this function Returns the standard deviation between experimental
! data points and the computed ones
!     N --- number of data points ( Integer, input)
!  Fcal --- calculated array of size (N), Real(kind=wp) ::, input
!  Fexp --- experimental array of size (N), Real(kind=wp) ::, input
!   dev --- standard deviation, Real(kind=wp) ::, output;

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: dev
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: Fcal(N), Fexp(N)
integer(kind=iwp) :: i
real(kind=wp) :: diff, X

X = Zero
do i=1,N
  diff = Fcal(i)-Fexp(i)
  X = X+diff**2
end do
dev = sqrt(X/real(N,kind=wp))

return

end function dev

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine testconv2_cvb(close2conv,converged,wrongstat,act,zz,step,grad,npr,eigmn,eigmx,eigmna,nposeig,nnegeig)

use casvb_global, only: dx, dfx, formAD, grd, ipr, sgn, singul, zzmin, zzmax
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(inout) :: close2conv
logical(kind=iwp), intent(out) :: converged, wrongstat
integer(kind=iwp), intent(in) :: npr, nposeig, nnegeig
real(kind=wp), intent(in) :: act, zz, step(npr), grad(npr), eigmn, eigmx, eigmna
integer(kind=iwp) :: idum, mm
real(kind=wp) :: grad_amx, grad_nrm, grad_rms, step_amx, step_nrm, step_rms
logical(kind=iwp) :: close_old, correct_index, dfx_is_small, grad_is_small, step_is_small, zz_ok
real(kind=wp), external :: dnrm2_

close_old = close2conv

step_nrm = dnrm2_(npr,step,1)
step_rms = step_nrm/sqrt(real(npr,kind=wp))
call findamx_cvb(step,npr,step_amx,idum)

grad_nrm = dnrm2_(npr,grad,1)
grad_rms = grad_nrm/sqrt(real(npr,kind=wp))
call findamx_cvb(grad,npr,grad_amx,idum)

if (ipr(3) >= 2) then
  if ((nnegeig > 0) .and. (nposeig > 0)) then
    write(u6,*) ' Maximum eigenvalue : ',eigmx,' of first ',nnegeig,' values.'
    write(u6,*) ' Minimum eigenvalue : ',eigmn,' of last  ',nposeig,' values.'
  else if (nnegeig > 0) then
    write(u6,*) ' Maximum eigenvalue : ',eigmx
  else
    write(u6,*) ' Minimum eigenvalue : ',eigmn
  end if
end if

! Local region / final convergence reached if:
! a) Change in F(X) small
! b) Step is small
! c) Gradient is small
! d) Hessian has correct index
! e) ACT/EXP ratio is within acceptable interval

if (eigmna > singul(1)) then
  mm = 1
else
  mm = 2
end if
dfx_is_small = act < dfx(mm)
step_is_small = (step_nrm < dx(2,mm)) .and. (step_rms < dx(3,mm)) .and. (step_amx < dx(1,mm))
grad_is_small = (grad_nrm < grd(2,mm)) .and. (grad_rms < grd(3,mm)) .and. (grad_amx < grd(1,mm))
correct_index = (eigmx < sgn(mm)) .and. (eigmn > -sgn(mm))
zz_ok = (zz > zzmin(mm)) .and. (zz < zzmax(mm))

close2conv = dfx_is_small .and. step_is_small .and. grad_is_small .and. correct_index .and. zz_ok

if (eigmna > singul(2)) then
  mm = 3
else
  mm = 4
end if
dfx_is_small = act < dfx(mm)
step_is_small = (step_nrm < dx(2,mm)) .and. (step_rms < dx(3,mm)) .and. (step_amx < dx(1,mm))
grad_is_small = (grad_nrm < grd(2,mm)) .and. (grad_rms < grd(3,mm)) .and. (grad_amx < grd(1,mm))
correct_index = (eigmx < sgn(mm)) .and. (eigmn > -sgn(mm))
zz_ok = (zz > zzmin(mm)) .and. (zz < zzmax(mm))

if (ipr(3) >= 2) then
  write(u6,'(/,a)') ' Test of convergence :'
  write(u6,'(a)') ' ---------------------'
  call cvprt_cvb(' 1) Change in F(x) :',dfx_is_small)
  call cvprt_cvb(' 2) Step length    :',step_is_small)
  call cvprt_cvb(' 3) Grad norm      :',grad_is_small)
  call cvprt_cvb(' 4) Hessian index  :',correct_index)
  call cvprt_cvb(' 5) Act/Exp ratio  :',zz_ok)
  write(u6,*) ' '
  call cvprt2_cvb(' F(x) change   :',act,dfx(mm),1)
  call cvprt2_cvb(' Norm of step  :',step_nrm,dx(2,mm),1)
  call cvprt2_cvb(' RMS of step   :',step_rms,dx(3,mm),1)
  call cvprt2_cvb(' AMAX of step  :',step_amx,dx(1,mm),1)
  call cvprt2_cvb(' Norm of grad  :',grad_nrm,grd(2,mm),1)
  call cvprt2_cvb(' RMS of grad   :',grad_rms,grd(3,mm),1)
  call cvprt2_cvb(' AMAX of grad  :',grad_amx,grd(1,mm),1)
  call cvprt2_cvb(' Max. eigval   :',eigmx,sgn(mm),1)
  call cvprt2_cvb(' Min. eigval   :',eigmn,-sgn(mm),2)
  call cvprt2_cvb(' Act/Exp ratio :',zz,zzmin(mm),2)
  call cvprt2_cvb(' Act/Exp ratio :',zz,zzmax(mm),1)
  write(u6,*) ' '
end if

converged = dfx_is_small .and. step_is_small .and. grad_is_small .and. correct_index .and. zz_ok
converged = converged .and. close2conv

if (eigmna > singul(3)) then
  mm = 5
else
  mm = 6
end if
dfx_is_small = act < dfx(mm)
step_is_small = (step_nrm < dx(2,mm)) .and. (step_rms < dx(3,mm)) .and. (step_amx < dx(1,mm))
grad_is_small = (grad_nrm < grd(2,mm)) .and. (grad_rms < grd(3,mm)) .and. (grad_amx < grd(1,mm))
correct_index = (eigmx < sgn(mm)) .and. (eigmn > -sgn(mm))
zz_ok = (zz > zzmin(mm)) .and. (zz < zzmax(mm))

! Wrong stationary point if otherwise converged, but Hessian
! hasn't got correct index:
wrongstat = dfx_is_small .and. step_is_small .and. grad_is_small .and. (.not. correct_index) .and. zz_ok

if ((ipr(3) >= 1) .and. close2conv .and. (.not. (converged .or. close_old))) write(u6,'(a)') ' Optimization entering local region.'
if (converged .and. (ipr(3) >= 0)) then
  write(u6,formAD) ' Converged ... maximum update to coefficient:',step_amx
  if (eigmna <= singul(2)) then
    write(u6,'(a)') ' Warning - singular hessian!'
    write(u6,formAD) ' Smallest Hessian eigenvalue :',eigmna
  end if
end if

return

end subroutine testconv2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine OrdExp1(nExp,Exp,nCntrc,Cff)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Exp(nExp), Cff(nExp,nCntrc)
*
*     Order exponents
*     Make the subsequent change in the contraction
*     matrix
*
      Do iExp = 1, nExp-1
         Exp1 = Exp(iExp)
         kExp = iExp
         Do jExp = iExp+1, nExp
            Exp2 = Exp(jExp)
            If (Exp2.gt.Exp1) Then
               Exp1 = Exp2
               kExp = jExp
            End If
         End Do
         If (kExp.ne.iExp) Then
            Call DSwap_(1,Exp(iExp),1,Exp(kExp),1)
            Call DSwap_(nCntrc,Cff(iExp,1),nExp,Cff(kExp,1),nExp)
         End If
      End Do
*
*     Move any exponent which are already decontracted to the bottom
*
      iMoved=0
      iBottom=nExp
      Do iCntrc = nCntrc, 1, -1
         mExp=0
         jExp=-1
         Do iExp = 1, nExp
            If (Cff(iExp,iCntrc).ne.Zero) Then
               jExp=iExp
               mExp=mExp+1
            End If
         End Do
         If (mExp.eq.1) Then
            Call DSwap_(1,Exp(jExp),1,Exp(iBottom),1)
            Call DSwap_(nCntrc,Cff(jExp,1),nExp,Cff(iBottom,1),nExp)
            iBottom=iBottom-1
         End If
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine o10a_cvb( &
#                   define _CALLING_
#                   include "opta_interface.fh"
                   )

use casvb_global, only: have_solved_it, n_div, nparm, nvguess, nvrestart, nvrhs, ograd
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
#include "opta_interface.fh"
real(kind=wp) :: cnrm1, cnrm2
real(kind=wp), allocatable :: xp(:)
real(kind=wp), external :: dnrm2_

#include "macros.fh"
unused_var(nparam)

nvrestart = 0
nvguess = 0
nvrhs = 0
have_solved_it = .false.

call mma_allocate(xp,nparm,label='xp')
xp(:) = ograd(:)
call ddproj_cvb(xp,nparm)
cnrm1 = dnrm2_(n_div,xp(1:n_div),1)
cnrm2 = dnrm2_(nparm-n_div,xp(n_div+1:),1)
if (cnrm1 > cnrm2) then
  call ddguess_cvb(xp,n_div,0)
  if (cnrm2 > 1.0e-8_wp) call ddguess_cvb(xp(n_div+1:),nparm-n_div,n_div)
else
  call ddguess_cvb(xp(n_div+1:),nparm-n_div,n_div)
  if (cnrm1 > 1.0e-8_wp) call ddguess_cvb(xp(1:n_div),n_div,0)
end if
call ddrhs_cvb(xp,nparm,0)
call mma_deallocate(xp)

return

end subroutine o10a_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c look for partial loops in active space drt and save them into disk
      subroutine guga_ploop(npl,maxplcon)
#include "drt_h.fh"
#include "files_gugaci.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)


      maxplcon=0
      mhlpmax=0
      idisk_lp=0
      idisk_array=0
      call idafile(luloop,1,idisk_array,13,idisk_lp)
      npl=0
      call vd_lp_search(npl)
      call dv_lp_search(npl)
      call dd_lp_search(npl)
      call dt_lp_search(npl)
      call ds_lp_search(npl)
      call tv_lp_search(npl)
      call td_lp_search(npl)
      call tt_lp_search(npl)
      call ts_lp_search(npl)
      call sv_lp_search(npl)
      call sd_lp_search(npl)
      call st_lp_search(npl)
      call ss_lp_search(npl)

      maxplcon=mhlpmax
      idisk_lp=0
      call idafile(luloop,1,idisk_array,13,idisk_lp)
      write(6,"(4x,a,i20)") "Max number of partial loops: ",mhlpmax
!      print*, "idisk_array"
!      print"(13i8)", idisk_array

      return
      end

      subroutine sv_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)
      common/count/mhsum,lp_count(22),mhlpmax
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(10)=idisk_lp

      imr=1
      do iml=1,ng_sm
        call act_lp_search(4,4,1)     !id=4
      enddo
      lpblock_sv=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'sv:',lpblock,mhsum !,idisk_array(10),idisk_l
      return
      end

      subroutine sd_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(11)=idisk_lp

      do iml=1,ng_sm
        do imr=1,ng_sm
          call act_lp_search(1,4,2)    !id=1
        enddo
      enddo
      lpblock_sd=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'sd:',lpblock,mhsum
      return
      end

      subroutine st_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(12)=idisk_lp

      do iml=1,ng_sm
        do imr=1,ng_sm
          call act_lp_search(3,4,3)   !id=3
        enddo
      enddo
      lpblock_st=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'st:',lpblock,mhsum
      return
      end

      subroutine ss_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(13)=idisk_lp

      do iml=1,ng_sm
        do imr=1,ng_sm
          call act_lp_search(3,4,4)    !id=3
        enddo
      enddo
      lpblock_ss=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'ss:',lpblock,mhsum
      return
      end

      subroutine tv_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(6)=idisk_lp


      imr=1
      do iml=1,ng_sm
        call act_lp_search(4,3,1)       !id=4
      enddo
      lpblock_tv=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'tv:',lpblock,mhsum
      return
      end

      subroutine td_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(7)=idisk_lp

      do iml=1,ng_sm
        do imr=1,ng_sm
          call act_lp_search(1,3,2)    !id=1
        enddo
      enddo
      lpblock_td=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'td:',lpblock,mhsum
      return
      end

      subroutine tt_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(8)=idisk_lp

      do iml=1,ng_sm
        do imr=1,ng_sm
          call act_lp_search(3,3,3)    !id=3
        enddo
      enddo
      lpblock_tt=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'tt:',lpblock,mhsum

      return
      end

      subroutine ts_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(9)=idisk_lp

      do iml=1,ng_sm
        do imr=1,ng_sm
          call act_lp_search(3,3,4)    !id=3
        enddo
      enddo
      lpblock_ts=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'ts:',lpblock,mhsum
      return
      end

      subroutine dv_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(2)=idisk_lp

      imr=1
      do iml=1,ng_sm
        call act_lp_search(1,2,1)      !id=1
      enddo
      lpblock_dv=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'dv:',lpblock,mhsum
      return
      end

      subroutine dd_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(3)=idisk_lp

      do iml=1,ng_sm
        do imr=1,ng_sm
          call act_lp_search(3,2,2)    !id=3
        enddo
      enddo
      lpblock_dd=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'dd:',lpblock,mhsum

      return
      end

      subroutine dt_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(4)=idisk_lp

      do iml=1,ng_sm
        do imr=1,ng_sm
          call act_lp_search(2,2,3)      !id=2
        enddo
      enddo
      lpblock_dt=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'dt:',lpblock,mhsum
      return
      end

      subroutine ds_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(5)=idisk_lp

      do iml=1,ng_sm
        do imr=1,ng_sm
          call act_lp_search(2,2,4)    !id=2
        enddo
      enddo
      lpblock_ds=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'ds:',lpblock,mhsum
      return
      end

      subroutine vd_lp_search(npl)
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      mhsum=0
      lpblock=0
      lp_count(1:22)=0
      idisk_array(1)=idisk_lp

      iml=1
      do imr=1,ng_sm
        call act_lp_search(2,1,2)       !id=2
      enddo
      lpblock_vd=lpblock
      npl=npl+mhsum
      write(6,'(a15,2i10)')'vd:',lpblock,mhsum
      return
      end

      subroutine act_lp_search(id,iptyl,iptyr)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      call get_jp(iptyl,iml,ipael,0)
      call get_jp(iptyr,imr,ipaer,0)

      jpael=nu_ae(ipael)
      jpaer=nu_ae(ipaer)
      if(jpael.eq.0.or.jpaer.eq.0) return
      ide=0
      if(iptyl.eq.4.and.iptyr.eq.4) ide=1
      if(iptyl.eq.4.and.iptyr.eq.3) ide=2
      if(iptyl.eq.3.and.iptyr.eq.4) ide=2
      do jptyl=1,6            !1,6???
        jptyrend=6
        if(jptyl.eq.1) jptyrend=1
        jmlsta=1
        jmlend=ng_sm
        if(jptyl.eq.1) jmlsta=ns_sm
        if(jptyl.eq.1) jmlend=ns_sm
        do jml=jmlsta,jmlend
          call get_jp(jptyl,jml,jpadl,0)
          if(nu_ad(jpadl).eq.0) cycle
          jpad=jpadl
          jpae=jpael
          ipae=ipael
          call seg_drt()
          if(ndim.eq.0) cycle
          call copy_to_drtl()
          do jptyr=1,jptyrend
            jmrsta=1
            jmrend=ng_sm
            if(jptyr.eq.1) jmrsta=ns_sm
            if(jptyr.eq.1) jmrend=ns_sm
            do jmr=jmrsta,jmrend
              call get_jp(jptyr,jmr,jpadr,0)
              if(nu_ad(jpadr).eq.0) cycle
              jpad=jpadr
              jpae=jpaer
              ipae=ipaer
              call seg_drt()
              if(ndim.eq.0) cycle
              jpadlr=map_jplr(jptyl,jptyr)
              if(id.eq.1) call lp_head_in_dbl_1()
              if(id.eq.2) call lp_head_in_dbl_2()
              if(id.eq.3) call lp_head_in_dbl_3(ide)
              if(id.eq.4) call lp_head_in_dbl_4()
              if(jpadl.ne.jpadr) cycle
              if(id.eq.1) call lp_head_in_act_1()
              if(id.eq.2) call lp_head_in_act_2()
              if(id.eq.3) call lp_head_in_act_3(ide)
              if(id.eq.4) call lp_head_in_act_4()
            enddo
          enddo
        enddo
      enddo
      return
      end

      subroutine lp_head_in_act_1()      !for dv,td,sd
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)
      do lra=norb_dz+1,norb_inn
        lma=lsm_inn(lra)
        if(lma.ne.imlr) cycle
!line=1 a&r<-->a^r
        call head_ar_at_given_orb(mh,lra)
        call link_c1_to_given_orb_coe(mh,lra+1,norb_inn)
        if ( mh.eq.0 ) cycle
        call value_sort_ploop(mh,.true.,.true.,.false.)
        if(log_prod.eq.3) then
          linelp=1
          mhlp=mh
          nlg1=lra
          nlg2=0
          call ext_head_in_act()
        else
          call save_lp(1,mh,lra,0)
          lpblock=lpblock+1
        endif
      enddo

      do lrai=norb_dz+1,norb_inn
        lsmi=lsm_inn(lrai)
        do lraj=lrai+1,norb_inn
          lsmj=lsm_inn(lraj)
          lsmij=mul_tab(lsmi,lsmj)
          lmk=mul_tab(lsmij,imlr)
          do lrak=lraj+1,norb_inn
            lsmk=lsm_inn(lrak)
            if(lmk.ne.lsmk) cycle
            ijk=lrai-norb_frz+ngw2(lraj-norb_frz)+ngw3(lrak-norb_frz)
            intpos=intind_ijka(ijk)
!line=4  a&r--b&r--b^r<-->a^r
            call head_ar_at_given_orb(mh,lrai)
            call link_c1_to_given_orb(mh,lrai+1,lraj-1)
            call link_b4_at_given_orb(mh,lraj)
            logic_br(1:mh)=.true.
            call link_c2_to_given_orb(mh,lraj+1,lrak-1)
            call link_b2_at_given_orb(mh,lrak)
            call link_c1_to_given_orb(mh,lrak+1,norb_inn)
            if ( mh.eq.0 ) goto 7
            call value_sort_ploop(mh,.false.,.true.,.true.)
            if(log_prod.eq.3) then
              linelp=4
              mhlp=mh
              nlg1=intpos
              nlg2=0
              call ext_head_in_act()
            else
              call save_lp(4,mh,intpos,0)
              lpblock=lpblock+1
            endif
!line=7 a&r--b&l--b^l<-->a^r
7           call head_ar_at_given_orb(mh,lrai)
            call link_c1_to_given_orb(mh,lrai+1,lraj-1)
            call link_b3_at_given_orb(mh,lraj)
            logic_br(1:mh)=.true.
            call link_c2_to_given_orb(mh,lraj+1,lrak-1)
            call link_b1_at_given_orb(mh,lrak)
            call link_c1_to_given_orb(mh,lrak+1,norb_inn)
            if ( mh.eq.0 ) cycle
            call value_sort_ploop(mh,.false.,.true.,.true.)
            if(log_prod.eq.3) then
              linelp=7
              mhlp=mh
              nlg1=intpos
              nlg2=0
              call ext_head_in_act()
            else
              call save_lp(7,mh,intpos,0)
              lpblock=lpblock+1
            endif
          enddo
        enddo
      enddo
      do lrai=norb_dz+2,norb_inn
        lmai=lsm_inn(lrai)
        if(lmai.ne.imlr) cycle
        do lrak=norb_dz+1,lrai-1
!line=10 d&rr--b^r<-->a^r
          call head_drr_at_given_orb(mh,lrak)
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrak+1,lrai-1)
          call link_b2_at_given_orb(mh,lrai)
          call link_c1_to_given_orb(mh,lrai+1,norb_inn)
          if ( mh.eq.0 ) goto 12
          call value_sort_ploop(mh,.false.,.true.,.true.)
          if(log_prod.eq.3) then
            linelp=10
            mhlp=mh
            nlg1=lrak
            nlg2=lrai
            call ext_head_in_act()
          else
            call save_lp(10,mh,lrak,lrai)
            lpblock=lpblock+1
          endif
!line=12 d&rl--b^l<-->a^r
12        call head_drl_at_given_orb(mh,lrak)
          call link_c2_to_given_orb(mh,lrak+1,lrai-1)
          call link_b1_at_given_orb(mh,lrai)
          call link_c1_to_given_orb(mh,lrai+1,norb_inn)
          if ( mh.eq.0 ) cycle
          call value_sort_ploop(mh,.false.,.true.,.true.)
          if(log_prod.eq.3) then
            linelp=12
            mhlp=mh
            nlg1=lrak
            nlg2=lrai
            call ext_head_in_act()
          else
            call save_lp(12,mh,lrak,lrai)
            lpblock=lpblock+1
          endif
        enddo
      enddo
      return
      end

      subroutine lp_head_in_act_2()      !for vd,dt,ds
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)

      do lra=norb_dz+1,norb_inn
        lma=lsm_inn(lra)
        if(lma.ne.imlr) cycle
        do lrd=lra+1,norb_inn
!line=2 a&r--d&l^r<-->a^l
          call head_ar_at_given_orb(mh,lra)
          call link_c1_to_given_orb(mh,lra+1,lrd-1)
          call link_d10_at_given_orb(mh,lrd)
          call link_c1_to_given_orb(mh,lrd+1,norb_inn)
          if ( mh.eq.0 ) cycle
          call value_sort_ploop(mh,.false.,.true.,.false.)
          if(log_prod.eq.3) then
            linelp=2
            mhlp=mh
            nlg1=lra
            nlg2=lrd
            !call print_lp()
            call ext_head_in_act()
          else
            linelp=2
            mhlp=mh
            nlg1=lra
            nlg2=lrd
            !call print_lp()
            call save_lp(2,mh,lra,lrd)
            lpblock=lpblock+1
          endif
        enddo
      enddo

      do lrai=norb_dz+1,norb_inn
        lsmi=lsm_inn(lrai)
        do lraj=lrai+1,norb_inn
          lsmj=lsm_inn(lraj)
          lsmij=mul_tab(lsmi,lsmj)
          lmk=mul_tab(lsmij,imlr)
          do lrak=lraj+1,norb_inn
            lsmk=lsm_inn(lrak)
            if(lmk.ne.lsmk) cycle
            ijk=lrai-norb_frz+ngw2(lraj-norb_frz)+ngw3(lrak-norb_frz)
            intpos=intind_ijka(ijk)
!line=6  a&r--b&l--b^r<-->a^l
            call head_ar_at_given_orb(mh,lrai)
            call link_c1_to_given_orb(mh,lrai+1,lraj-1)
            call link_b3_at_given_orb(mh,lraj)
            logic_br(1:mh)=.true.
            call link_c2_to_given_orb(mh,lraj+1,lrak-1)
            call link_b2_at_given_orb(mh,lrak)
            call link_c1_to_given_orb(mh,lrak+1,norb_inn)
            if ( mh.eq.0 ) cycle
            call value_sort_ploop(mh,.false.,.true.,.true.)
            if(log_prod.eq.3) then
              linelp=6
              mhlp=mh
              nlg1=intpos
              nlg2=0
              !call print_lp()
              call ext_head_in_act()
            else
              call save_lp(6,mh,intpos,0)
              lpblock=lpblock+1
            endif
          enddo
        enddo
      enddo

      do lrai=norb_dz+2,norb_inn
        lmai=lsm_inn(lrai)
        if(lmai.ne.imlr) cycle
        do lrak=norb_dz+1,lrai-1
!line=11 d&rl--b^r<-->a^l
          call head_drl_at_given_orb(mh,lrak)
          call link_c2_to_given_orb(mh,lrak+1,lrai-1)
          call link_b2_at_given_orb(mh,lrai)
          call link_c1_to_given_orb(mh,lrai+1,norb_inn)
          if ( mh.eq.0 ) cycle
          call value_sort_ploop(mh,.false.,.true.,.true.)
          if(log_prod.eq.3) then
            linelp=11
            mhlp=mh
            nlg1=lrak
            nlg2=lrai
            !call print_lp()
            call ext_head_in_act()
          else
            call save_lp(11,mh,lrak,lrai)
            lpblock=lpblock+1
          endif
        enddo
      enddo
      return
      end

      subroutine lp_head_in_act_3(ide)      !for ide=0:dd,tt,ide=1:ss,id
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)

      do lra=norb_dz+1,norb_inn
        lma=lsm_inn(lra)
!line=9 d&r&l-
          call head_drl_at_given_orb(mh,lra)
          call link_c2_to_given_orb(mh,lra+1,norb_inn)
          if ( mh.eq.0 ) cycle
          call value_sort_ploop(mh,.false.,.true.,.true.)
          call save_lp(9,mh,lra,0)
          lpblock=lpblock+1
      enddo
      do lrai=norb_dz+1,norb_inn
        lsmi=lsm_inn(lrai)
        do lraj=lrai+1,norb_inn
          lsmj=lsm_inn(lraj)
          lsmij=mul_tab(lsmi,lsmj)
          if(lsmij.ne.imlr) cycle
!line=5 a&r-b&l-
          call head_ar_at_given_orb(mh,lrai)
          call link_c1_to_given_orb(mh,lrai+1,lraj-1)
          call link_b3_at_given_orb(mh,lraj)
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lraj+1,norb_inn)
          if ( mh.eq.0 ) cycle
        if(ide.ne.0) then
          goto(22,33),ide
22          call value_sort_ploop(mh,.false.,.true.,.false.)    !ss
            goto 55
33          call value_sort_ploop(mh,.false.,.false.,.true.)    !st,ts
            goto 55
        endif
        call value_sort_ploop(mh,.false.,.true.,.true.)
55      call save_lp(5,mh,lrai,lraj)
        lpblock=lpblock+1
        enddo
      enddo
      return
      end

      subroutine lp_head_in_act_4()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)

      do lra=norb_dz+1,norb_inn
!line=8 d&rr-
        call head_drr_at_given_orb(mh,lra)
        logic_br(1:mh)=.true.
        call link_c2_to_given_orb(mh,lra+1,norb_inn)
        if ( mh.eq.0 ) cycle
        call value_sort_ploop(mh,.false.,.true.,.true.)
        if(log_prod.eq.3) then
          linelp=8
          mhlp=mh
          nlg1=lra
          nlg2=0
          call ext_head_in_act()
        else
          call save_lp(8,mh,lra,0)
          lpblock=lpblock+1
        endif
      enddo
      do lrai=norb_dz+1,norb_inn
        lsmi=lsm_inn(lrai)
        do lraj=lrai+1,norb_inn
          lsmj=lsm_inn(lraj)
          lsmij=mul_tab(lsmi,lsmj)
          if(lsmij.ne.imlr) cycle
          call head_ar_at_given_orb(mh,lrai)
          call link_c1_to_given_orb(mh,lrai+1,lraj-1)
          call link_b4_at_given_orb(mh,lraj)
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lraj+1,norb_inn)
          if ( mh.eq.0 ) cycle
          call value_sort_ploop(mh,.false.,.true.,.true.)
          if(log_prod.eq.3) then
            linelp=3
            mhlp=mh
            nlg1=lrai
            nlg2=lraj
            call ext_head_in_act()
          else
            call save_lp(3,mh,lrai,lraj)
            lpblock=lpblock+1
          endif
        enddo
      enddo
      return
      end

      subroutine lp_head_in_dbl_1()      !for dv,sd,td
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)
      jmlr=mul_tab(jml,jmr)
      lsmact=mul_tab(imlr,jmlr)
      lsta=norb_dz+1
      lend=norb_inn

      if(imlr.eq.jmlr) then       !!! imlr.eq.1

!line=13 -c'-
        call link_c1_to_given_orb_coe(mh,lsta,lend)
        if(mh.eq.0) goto 15
        call value_sort_ploop(mh,.true.,.true.,.true.)
        call save_lp(13,mh,0,0)
        lpblock=lpblock+1
      endif

!line=15 -b^l-
15    do lra=norb_dz+1,norb_inn
        lsma=lsm_inn(lra)

        if(lsma.ne.lsmact) cycle

        if(jml.ne.jmr) goto 1502
        logic_br(1)=.false.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b1_at_given_orb(mh,lra)
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) goto 1502
        call value_sort_ploop(mh,.false.,.true.,.true.)
        call save_lp(15,mh,lra,1)
        lpblock=lpblock+1
1502    logic_br(1)=.true.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b1_at_given_orb(mh,lra)        !b^l
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) goto 1601
        call value_sort_ploop(mh,.false.,.true.,.true.)
        call save_lp(15,mh,lra,2)
        lpblock=lpblock+1

!line=16 -b^r-
1601    if(jml.ne.jmr) goto 1602
        logic_br(1)=.false.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b2_at_given_orb(mh,lra)
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) goto 1602
        call value_sort_ploop(mh,.false.,.true.,.true.)
        call save_lp(16,mh,lra,1)
        lpblock=lpblock+1

1602    logic_br(1)=.true.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b2_at_given_orb(mh,lra)
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) cycle
        call value_sort_ploop(mh,.false.,.true.,.true.)
        call save_lp(16,mh,lra,2)
        lpblock=lpblock+1

      enddo

!line=20 -b&r-b^r-
      do lrai=norb_dz+1,norb_inn-1
        lsmi=lsm_inn(lrai)
        do lraj=lrai+1,norb_inn
          lsmj=lsm_inn(lraj)
          lsmij=mul_tab(lsmi,lsmj)
         if(lsmij.ne.lsmact) cycle
          jk=ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)

          call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b4_at_given_orb(mh,lrai)        !b&r
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
          call link_b2_at_given_orb(mh,lraj)        !b^r
          call link_c1_to_given_orb(mh,lraj+1,norb_inn)
          if(mh.eq.0) goto 22
          call value_sort_ploop(mh,.false.,.true.,.true.)
          call save_lp(20,mh,jk,0)
          lpblock=lpblock+1
!line=22 -b&l-b^l-
22        call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b3_at_given_orb(mh,lrai)        !b&l
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
          call link_b1_at_given_orb(mh,lraj)        !b^l
          call link_c1_to_given_orb(mh,lraj+1,norb_inn)
          if(mh.eq.0) cycle
          call value_sort_ploop(mh,.false.,.true.,.true.)
          call save_lp(22,mh,jk,0)
          lpblock=lpblock+1
        enddo
      enddo
      return
      end

      subroutine lp_head_in_dbl_1_mrpt2()    !for dv,sd,td       !200709

#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)
      jmlr=mul_tab(jml,jmr)
      lsmact=mul_tab(imlr,jmlr)
      lsta=norb_dz+1
      lend=norb_inn

      goto(100,200,300,400),jpadlrel(jpadlr)              !200709

100   if(imlr.eq.jmlr) then               !!! imlr.eq.1
!line=13 -c'-
        call link_c1_to_given_orb_coe(mh,lsta,lend)
        if(mh.eq.0) goto 15
        call value_sort_ploop(mh,.true.,.true.,.true.)
        linelp=13
        mhlp=mh
        nlg1=0
        nlg2=0
        call ext_head_in_dbl()
       endif

!line=20 -b&r-b^r-
      do lrai=norb_dz+1,norb_inn-1
        lsmi=lsm_inn(lrai)
        do lraj=lrai+1,norb_inn
          lsmj=lsm_inn(lraj)
          lsmij=mul_tab(lsmi,lsmj)
              if(lsmij.ne.lsmact) cycle
          jk=ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)

          call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b4_at_given_orb(mh,lrai)        !b&r
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
          call link_b2_at_given_orb(mh,lraj)        !b^r
          call link_c1_to_given_orb(mh,lraj+1,norb_inn)
          if(mh.eq.0) goto 22
          call value_sort_ploop(mh,.false.,.true.,.true.)
          linelp=20
          mhlp=mh
          nlg1=jk
          nlg2=0
          call ext_head_in_dbl()
!line=22 -b&l-b^l-
22        call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b3_at_given_orb(mh,lrai)        !b&l
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
          call link_b1_at_given_orb(mh,lraj)        !b^l
          call link_c1_to_given_orb(mh,lraj+1,norb_inn)
          if(mh.eq.0) cycle
              call value_sort_ploop(mh,.false.,.true.,.true.)
          linelp=22
          mhlp=mh
          nlg1=jk
          nlg2=0
          call ext_head_in_dbl()
         enddo
      enddo
      return

300        continue
!line=15 -b^l-
15    do lra=norb_dz+1,norb_inn
        lsma=lsm_inn(lra)

        if(lsma.ne.lsmact) cycle

        if(jml.ne.jmr) goto 1502
        logic_br(1)=.false.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b1_at_given_orb(mh,lra)
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) goto 1502
        call value_sort_ploop(mh,.false.,.true.,.true.)
        linelp=15
        mhlp=mh
        nlg1=lra
        nlg2=1
        call ext_head_in_dbl()
!        write(*,*) mh,linelp
1502    logic_br(1)=.true.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b1_at_given_orb(mh,lra)        !b^l
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) goto 1601
        call value_sort_ploop(mh,.false.,.true.,.true.)
        linelp=15
        mhlp=mh
        nlg1=lra
        nlg2=2
        call ext_head_in_dbl()
!        write(*,*) mh,linelp
      enddo
      return

400       continue
!line=16 -b^r-
1601  do lra=norb_dz+1,norb_inn
        lsma=lsm_inn(lra)
        if(jml.ne.jmr) goto 1602
        logic_br(1)=.false.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b2_at_given_orb(mh,lra)
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) goto 1602
        call value_sort_ploop(mh,.false.,.true.,.true.)
        linelp=16
        mhlp=mh
        nlg1=lra
        nlg2=1
        call ext_head_in_dbl()
!        write(*,*) mh,linelp

1602    logic_br(1)=.true.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b2_at_given_orb(mh,lra)
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) cycle
        call value_sort_ploop(mh,.false.,.true.,.true.)
        linelp=16
        mhlp=mh
        nlg1=lra
        nlg2=2
        call ext_head_in_dbl()
!        write(*,*) mh,linelp

      enddo

200   return
      end

      subroutine lp_head_in_dbl_2()      !for vd,dt,ds
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)
      jmlr=mul_tab(jml,jmr)
      lsmact=mul_tab(imlr,jmlr)
      lsta=norb_dz+1
      lend=norb_inn

      if(imlr.eq.jmlr) then       !!! imlr.eq.1

!line=13 -c'-
        call link_c1_to_given_orb_coe(mh,lsta,lend)
        if(mh.eq.0) goto 16
        call value_sort_ploop(mh,.true.,.true.,.true.)
        if(log_prod.eq.3) then
          ! mrpt2, do not save loop
          linelp=13
          mhlp=mh
          nlg1=0
          nlg2=0
          call ext_head_in_dbl()
        else
          call save_lp(13,mh,0,0)
          lpblock=lpblock+1
        endif
      endif

!line=16 -b^r-
16    do lra=norb_dz+1,norb_inn
        lsma=lsm_inn(lra)

        if(lsma.ne.lsmact) goto 19

        if(jml.ne.jmr) goto 1602
        logic_br(1)=.false.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b2_at_given_orb(mh,lra)        !b^r
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) goto 1602
        call value_sort_ploop(mh,.false.,.true.,.true.)
        if(log_prod.eq.3) then
          linelp=16
          mhlp=mh
          nlg1=lra
          nlg2=1
          call ext_head_in_dbl()
        else
          call save_lp(16,mh,lra,1)
          lpblock=lpblock+1
        endif

1602    logic_br(1)=.true.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b2_at_given_orb(mh,lra)        !b^r
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) goto 19
        call value_sort_ploop(mh,.false.,.true.,.true.)
        if(log_prod.eq.3) then
          linelp=16
          mhlp=mh
          nlg1=lra
          nlg2=2
          call ext_head_in_dbl()
        else
          call save_lp(16,mh,lra,2)
          lpblock=lpblock+1
        endif

!line=19 -d&r^l-
19      call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
        call link_d10_at_given_orb(mh,lra)
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) cycle
        call value_sort_ploop(mh,.true.,.true.,.true.)
        if(log_prod.eq.3) then
          linelp=19
          mhlp=mh
          nlg1=lra
          nlg2=0
          call ext_head_in_dbl()
        else
          call save_lp(19,mh,lra,0)
          lpblock=lpblock+1
        endif
      enddo

      do lrai=norb_dz+1,norb_inn-1
        lsmi=lsm_inn(lrai)
        do lraj=lrai+1,norb_inn
          lsmj=lsm_inn(lraj)
          lsmij=mul_tab(lsmi,lsmj)
          if(lsmij.ne.lsmact) cycle
          jk=ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)

!line=21 -b&l-b^r-
          call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b3_at_given_orb(mh,lrai)        !b&l
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
          call link_b2_at_given_orb(mh,lraj)        !b^r
          call link_c1_to_given_orb(mh,lraj+1,norb_inn)
          if(mh.eq.0) cycle
          call value_sort_ploop(mh,.false.,.true.,.true.)
          if(log_prod.eq.3) then
            linelp=21
            mhlp=mh
            nlg1=jk
            nlg2=0
            call ext_head_in_dbl()
          else
            call save_lp(21,mh,jk,0)
            lpblock=lpblock+1
          endif
        enddo
      enddo

      return
      end

      subroutine lp_head_in_dbl_2_mrpt2()          !for vd,dt,ds
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)
      jmlr=mul_tab(jml,jmr)
      lsmact=mul_tab(imlr,jmlr)
      lsta=norb_dz+1
      lend=norb_inn

      goto(100,200,300,400),jpadlrel(jpadlr)        !200709

400   return

200   if(imlr.eq.jmlr) then               !!! imlr.eq.1

!line=13 -c'-
        call link_c1_to_given_orb_coe(mh,lsta,lend)
        if(mh.eq.0) goto 16
        call value_sort_ploop(mh,.true.,.true.,.true.)
        linelp=13
        mhlp=mh
        nlg1=0
        nlg2=0
        !call print_lp()
        call ext_head_in_dbl()

       endif
       return

300   continue
!line=16 -b^r-
16    do lra=norb_dz+1,norb_inn
        lsma=lsm_inn(lra)

        if(lsma.ne.lsmact) cycle

        if(jml.ne.jmr) goto 1602
        logic_br(1)=.false.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b2_at_given_orb(mh,lra)        !b^r
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) goto 1602
        call value_sort_ploop(mh,.false.,.true.,.true.)
        linelp=16
        mhlp=mh
        nlg1=lra
        nlg2=1
        !call print_lp()
        call ext_head_in_dbl()

1602    logic_br(1)=.true.
        call link_c2_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b2_at_given_orb(mh,lra)        !b^r
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) cycle
        call value_sort_ploop(mh,.false.,.true.,.true.)
        linelp=16
        mhlp=mh
        nlg1=lra
        nlg2=2
        !call print_lp()
        call ext_head_in_dbl()
      enddo
      return

100   do lra=norb_dz+1,norb_inn
        lsma=lsm_inn(lra)
!line=19 -d&l^r-
        call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
        call link_d10_at_given_orb(mh,lra)
        call link_c1_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) cycle
        call value_sort_ploop(mh,.true.,.true.,.true.)
        linelp=19
        mhlp=mh
        nlg1=lra
        nlg2=0
        !call print_lp()
        call ext_head_in_dbl()
      enddo

      do lrai=norb_dz+1,norb_inn-1
        lsmi=lsm_inn(lrai)
        do lraj=lrai+1,norb_inn
          lsmj=lsm_inn(lraj)
          lsmij=mul_tab(lsmi,lsmj)
          if(lsmij.ne.lsmact) cycle
          jk=ngw2(lrai-norb_frz)+ngw3(lraj-norb_frz)

!line=21 -b&l-b^r-
          call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b3_at_given_orb(mh,lrai)        !b&l
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
          call link_b2_at_given_orb(mh,lraj)        !b^r
          call link_c1_to_given_orb(mh,lraj+1,norb_inn)
          if(mh.eq.0) cycle
          call value_sort_ploop(mh,.false.,.true.,.true.)
          linelp=21
          mhlp=mh
          nlg1=jk
          nlg2=0
          !call print_lp()
          call ext_head_in_dbl()
        enddo
      enddo
      return
      end

      subroutine lp_head_in_dbl_3(ide)      !for ide=0:dd,tt,ide=1:ss,id
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)
      jmlr=mul_tab(jml,jmr)
      lsmact=mul_tab(imlr,jmlr)
      lsta=norb_dz+1
      lend=norb_inn

      if(imlr.eq.jmlr) then       !!! imlr.eq.1

!line=14 -c"-
        if(jml.ne.jmr) goto 1402
        logic_br(1)=.false.
        call link_c2_to_given_orb(mh,lsta,lend)
        if(mh.eq.0) goto 1402
        call value_sort_ploop(mh,.true.,.true.,.true.)
        call save_lp(14,mh,0,1)
        lpblock=lpblock+1

1402    logic_br(1)=.true.
        call link_c2_to_given_orb(mh,lsta,lend)
        if(mh.eq.0) goto 15
        call value_sort_ploop(mh,.true.,.true.,.true.)
        call save_lp(14,mh,0,2)
        lpblock=lpblock+1

      endif

15    do lra=norb_dz+1,norb_inn
        lsma=lsm_inn(lra)
        if(lsma.ne.lsmact) cycle

!line=17 -b&l-
        call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b3_at_given_orb(mh,lra)        !b&l
        logic_br(1:mh)=.true.
        call link_c2_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) cycle
        if(ide.ne.0) then
          goto(1,2),ide
1           call value_sort_ploop(mh,.false.,.true.,.false.)    !ss
            goto 5
2           call value_sort_ploop(mh,.false.,.false.,.true.)    !st,ts
            goto 5
        endif
        call value_sort_ploop(mh,.false.,.true.,.true.)
5       call save_lp(17,mh,lra,0)
        lpblock=lpblock+1

      enddo
      return
      end

      subroutine lp_head_in_dbl_4()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      imlr=mul_tab(iml,imr)
      jmlr=mul_tab(jml,jmr)
      lsmact=mul_tab(imlr,jmlr)
      lsta=norb_dz+1
      lend=norb_inn

      if(imlr.eq.jmlr) then       !!! imlr.eq.1

!line=14 -c"-
        if(jml.ne.jmr) goto 1402
        logic_br(1)=.false.
        call link_c2_to_given_orb(mh,lsta,lend)
        if(mh.eq.0) goto 1402
        call value_sort_ploop(mh,.true.,.true.,.true.)
        call save_lp(14,mh,0,1)
        lpblock=lpblock+1

1402    logic_br(1)=.true.
        call link_c2_to_given_orb(mh,lsta,lend)
        if(mh.eq.0) goto 15
        call value_sort_ploop(mh,.true.,.true.,.true.)
        call save_lp(14,mh,0,2)
        lpblock=lpblock+1

        endif
15      do lra=norb_dz+1,norb_inn
        lsma=lsm_inn(lra)
        if(lsma.ne.lsmact) cycle

!line=18 -b&r-
        call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b4_at_given_orb(mh,lra)        !b&r
        logic_br(1:mh)=.true.
        call link_c2_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) cycle
        call value_sort_ploop(mh,.false.,.true.,.true.)
        call save_lp(18,mh,lra,0)
        lpblock=lpblock+1

      enddo

      return
      end

      subroutine lp_head_in_dbl_4_mrpt2()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      imlr=mul_tab(iml,imr)
      jmlr=mul_tab(jml,jmr)
      lsmact=mul_tab(imlr,jmlr)
      lsta=norb_dz+1
      lend=norb_inn

      goto(100,200,300,400),jpadlrel(jpadlr)         !200709

200   return
300   return
400      if(imlr.eq.jmlr) then               !!! imlr.eq.1

!line=14 -c"-
        if(jml.ne.jmr) goto 1402
        logic_br(1)=.false.
        call link_c2_to_given_orb(mh,lsta,lend)
        if(mh.eq.0) goto 1402
        call value_sort_ploop(mh,.true.,.true.,.true.)
        linelp=14
        mhlp=mh
        nlg1=0
        nlg2=1
        call ext_head_in_dbl()

1402    logic_br(1)=.true.
        call link_c2_to_given_orb(mh,lsta,lend)
        if(mh.eq.0) goto 15
        call value_sort_ploop(mh,.true.,.true.,.true.)
        linelp=14
        mhlp=mh
        nlg1=0
        nlg2=2
        call ext_head_in_dbl()

        endif
       return

100   continue

15      do lra=norb_dz+1,norb_inn
        lsma=lsm_inn(lra)
        if(lsma.ne.lsmact) cycle

!line=18 -b&r-
        call link_c1_to_given_orb(mh,norb_dz+1,lra-1)
        call link_b4_at_given_orb(mh,lra)        !b&r
        logic_br(1:mh)=.true.
        call link_c2_to_given_orb(mh,lra+1,norb_inn)
        if(mh.eq.0) cycle
        call value_sort_ploop(mh,.false.,.true.,.true.)
        linelp=18
        mhlp=mh
        nlg1=lra
        nlg2=0
        call ext_head_in_dbl()

        enddo

      return
      end

      subroutine print_lp()
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "files_gugaci.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      dimension info(10)
      line=linelp
      mh=mhlp
      lg1=nlg1
      lg2=nlg2

      mhsum=mhsum+mh
      lp_count(line)=lp_count(line)+1
      if((line.eq.14.or.line.eq.15.or.line.eq.16).and.lg2.eq.1) then
        mhsum=mhsum-mh
        lp_count(line)=lp_count(line)-1
      endif
      info=0
!===========================================================
      jpml=mul_tab(jml,ns_sm)
      jpmr=mul_tab(jmr,ns_sm)
      write(20,'(2x,10i8)')
     :   line,iml,imr,jpml,jpmr,jpadlr,mtype,mh,lg1,lg2
      write(20,"(7f12.6)")vplpnew_w0(1:mtype)
      write(20,"(7f12.6)")vplpnew_w1(1:mtype)
      write(20,"(8i4)")nstaval(1:mtype)
      write(20,"(8i4)")nvalue(1:mtype)
      write(20,"(8i6)")lpnew_lwei(1:mh)
      write(20,"(8i6)")lpnew_rwei(1:mh)
!===========================================================
      if(line.gt.12) goto 100
!upwei_record
      do m=1,mh
        jph=lpnew_head(m)
        jhyl=jphyl(jph)
        jhyr=jphy(jph)
        in=ihyl(jhyl)
        write(20,"(8(1x,i4))")jph,jhyl,jhyr,in,ihyl(jhyl+1:jhyl+in),
     *    ihy(jhyr+1:jhyr+in)
      enddo
100   if(line.ne.1.and.line.ne.13) return
!coe_record
      do m=1,mh
        write(20,*)lpnew_coe(norb_dz+1:norb_inn,m)
      enddo

      end

      subroutine save_lp(line,mh,lg1,lg2)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "files_gugaci.fh"
      common/count/mhsum,lp_count(22),mhlpmax
      common/lpdisk/idisk_lp,idisk_array(13)
      dimension info(10)

      if(mh.gt.mhlpmax) mhlpmax=mh
      mhsum=mhsum+mh
      lp_count(line)=lp_count(line)+1
      if((line.eq.14.or.line.eq.15.or.line.eq.16).and.lg2.eq.1) then
        mhsum=mhsum-mh
        lp_count(line)=lp_count(line)-1
      endif
      info=0
!===========================================================
!      jpml=mul_tab(jml,ns_sm)
!      jpmr=mul_tab(jmr,ns_sm)
!      write(200,'(2x,10i8)')
!     :   line,iml,imr,jpml,jpmr,jpadlr,mtype,mh,lg1,lg2
!      write(200,*)vplpnew_w0(1:mtype)
!      write(200,*)vplpnew_w1(1:mtype)
!      write(200,*)nstaval(1:mtype)
!      write(200,*)nvalue(1:mtype)
!      write(200,*)lpnew_lwei(1:mh)
!      write(200,*)lpnew_rwei(1:mh)
!===========================================================
      jpml=mul_tab(jml,ns_sm)
      jpmr=mul_tab(jmr,ns_sm)
      info(1)=line
      info(2)=iml
      info(3)=imr
      info(4)=jpml
      info(5)=jpmr
      info(6)=jpadlr
      info(7)=mtype
      info(8)=mh
      info(9)=lg1
      info(10)=lg2
      call idafile(luloop,1,info,10,idisk_lp)
c      print*, "in save_lp, linelp",line,idisk_lp,mh,mtype
      call ddafile(luloop,1,vplpnew_w0,mtype,idisk_lp)
      call ddafile(luloop,1,vplpnew_w1,mtype,idisk_lp)
      call idafile(luloop,1,nstaval,mtype,idisk_lp)
      call idafile(luloop,1,nvalue,mtype,idisk_lp)
      call idafile(luloop,1,lpnew_lwei,mh,idisk_lp)
      call idafile(luloop,1,lpnew_rwei,mh,idisk_lp)
      if(line.gt.12) goto 100
      do m=1,mh
        jph=lpnew_head(m)
        jhyl=jphyl(jph)
        jhyr=jphy(jph)
        in=ihyl(jhyl)
        call idafile(luloop,1,[in],1,idisk_lp)
        call idafile(luloop,1,ihyl(jhyl+1:jhyl+in),in,idisk_lp)
        call idafile(luloop,1,ihy(jhyr+1:jhyr+in),in,idisk_lp)
c        write(20)in,ihyl(jhyl+1:jhyl+in),ihy(jhyr+1:jhyr+in)
      enddo
100   if(line.ne.1.and.line.ne.13) return
c      print*, "in read_lp, write coe",idisk_lp,norb_inn-norb_dz
!coe_record
      lenw=norb_inn-norb_dz
      do m=1,mh
        call idafile(luloop,1,lpnew_coe(norb_dz+1:norb_inn,m),lenw,
     &               idisk_lp)
      enddo
      return
      end

      subroutine read_lp()
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
#include "files_gugaci.fh"
      common/lpdisk/idisk_lp,idisk_array(13)
      dimension info(10)

      call idafile(luloop,2,info,10,idisk_lp)
      linelp=info(1)
      iml=info(2)
      imr=info(3)
      jml=info(4)
      jmr=info(5)
      jpadlr=info(6)
      mtype=info(7)
      mhlp=info(8)
      nlg1=info(9)
      nlg2=info(10)
      call ddafile(luloop,2,vplpnew_w0,mtype,idisk_lp)
      call ddafile(luloop,2,vplpnew_w1,mtype,idisk_lp)
      call idafile(luloop,2,nstaval,mtype,idisk_lp)
      call idafile(luloop,2,nvalue,mtype,idisk_lp)
      call idafile(luloop,2,lpnew_lwei,mhlp,idisk_lp)
      call idafile(luloop,2,lpnew_rwei,mhlp,idisk_lp)
!===========================================================

      if(linelp.gt.12) goto 100
!upwei_read
      ihypos=1
      do m=1,mhlp
        jphy(m)=ihypos
        call idafile(luloop,2,info,1,idisk_lp)
        ndim=info(1)
        call idafile(luloop,2,ihyl(ihypos+1:ihypos+ndim),ndim,idisk_lp)
        call idafile(luloop,2,ihy(ihypos+1:ihypos+ndim),ndim,idisk_lp)
        ihy(ihypos)=ndim
        ihypos=ihypos+ndim+1
      enddo
100   if(linelp.ne.1.and.linelp.ne.13) return
c      print*, "in read_lp, read coe",idisk_lp,norb_inn-norb_dz
!coe_read
      lenr=norb_inn-norb_dz
      do m=1,mhlp
        call idafile(luloop,2,lpnew_coe(norb_dz+1:norb_inn,m),lenr,
     &               idisk_lp)
      enddo
      return
      end

      subroutine value_sort_ploop(mh,logic_ar,logic_w0,logic_w1)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "stdalloc.fh"
      real*8 w0,w1,s_w0,s_w1
      logical logic_ar,logic_w0,logic_w1
      allocatable ntype(:)
      call mma_allocate(ntype,nvaltype,label='nvaltype')
      zero=0.d0
      nvalue(1:nvaltype)=0
      ntype(1:mh)=0
      mtype=0
      if(.not.logic_w0) then
        do n=1,mh
          vplp_w0(n)=zero
        enddo
      endif
      if(.not.logic_w1) then
        do n=1,mh
          vplp_w1(n)=zero
        enddo
      endif
      do n=1,mh
        if(ntype(n).ne.0) cycle
        s_w0=vplp_w0(n)
        s_w1=vplp_w1(n)
        mtype=mtype+1
        if(mtype.gt.nvaltype) then
          write(6,*) " out of array boundary"
          write(6,*) " subroutine value_sort_ploop"
          write(6,*) " program stop"
#ifdef MOLPRO
#else
      call abend()
#endif
#ifdef _XIANEST_
#endif
        endif
        ntype(n)=mtype
        nvalue(mtype)=nvalue(mtype)+1
        vplpnew_w0(mtype)=vplp_w0(n)
        vplpnew_w1(mtype)=vplp_w1(n)
        do m=n+1,mh
          if(ntype(m).ne.0) cycle
          w0=vplp_w0(m)
          w1=vplp_w1(m)
          if(w0.ne.s_w0.or.w1.ne.s_w1) cycle
          ntype(m)=mtype
          nvalue(mtype)=nvalue(mtype)+1
        enddo
      enddo

      nstaval(1)=0
      do mty=1,mtype-1
        nstaval(mty+1)=nstaval(mty)+nvalue(mty)
      enddo

      mnew=0
      do mty=1,mtype
        do n=1,mh
          nty=ntype(n)
          if(nty.eq.mty) then
            mnew=mnew+1
            lpnew_head(mnew)=lp_head(n)
            lpnew_lwei(mnew)=lp_lwei(n)
            lpnew_rwei(mnew)=lp_rwei(n)
            if(logic_ar) then
              do lr=norb_dz+1,norb_inn
                lpnew_coe(lr,mnew)=lp_coe(lr,n)
              enddo
            endif
          endif
        enddo
      enddo
      call mma_deallocate(ntype)
      return
      end

      subroutine ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.false.

      jml=mul_tab(jml,ns_sm)
      jmr=mul_tab(jmr,ns_sm)
      goto( 10, 10, 10, 10, 10, 10, 10, 10, 10,110, 10, 10, 10,
     :      10, 10, 10,117, 10, 10, 10, 10, 10,123, 10, 10,126),ipaety
110   call sv_ext_head_in_act()
       goto 10
117   call tv_ext_head_in_act()
       goto 10
123   call dv_ext_head_in_act()
       goto 10
126   call vd_ext_head_in_act()
10    jml=mul_tab(jml,ns_sm)
      jmr=mul_tab(jmr,ns_sm)
       return
      end

      subroutine ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      logic_dh=.true.
      jml=mul_tab(jml,ns_sm)
      jmr=mul_tab(jmr,ns_sm)
      goto( 10, 10, 10, 10, 10, 10, 10, 10, 10,110, 10, 10, 10,
     :      10, 10, 10,117, 10, 10, 10, 10, 10,123, 10, 10,126),ipaety
110   call sv_ext_head_in_dbl()
      goto 10
117   call tv_ext_head_in_dbl()
      goto 10
123   call dv_ext_head_in_dbl()
      goto 10
126   call vd_ext_head_in_dbl()

10    jml=mul_tab(jml,ns_sm)
      jmr=mul_tab(jmr,ns_sm)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GET_CKAJJB(CB,NJ,NJA,CKAJJB,NKA,NJB,J,ISCA,SSCA)
! Obtain for given orbital index j the gathered matrix
!
! C(Ka,j,Jb) = SSCA(Ka)C(Jb,ISCA(Ka))
!
! For efficient processing of alpha-beta loop

use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NJ, NJA, NKA, NJB, J, ISCA(*)
real(kind=wp), intent(in) :: CB(NJB,NJA), SSCA(*)
real(kind=wp), intent(_OUT_) :: CKAJJB(*)
integer(kind=iwp) :: IADR, IADR0, ICBL, ICEND, ICOFF, ICONST, IROW, JB, KA, LBLK, NBLK
real(kind=wp) :: S

!write(u6,*) ' From GET_CKAJJB'
!LBLK = 100
LBLK = 40
NBLK = NJB/LBLK
if (LBLK*NBLK < NJB) NBLK = NBLK+1
ICOFF = 1
do ICBL=1,NBLK
  if (ICBL > 1) ICOFF = ICOFF+LBLK
  ICEND = min(ICOFF+LBLK-1,NJB)
  ICONST = NKA*NJ
  IADR0 = (J-1)*NKA+(ICOFF-1-1)*NKA*NJ
  if (ICEND > ICOFF) then
    ! Inner loop over JB
    do KA=1,NKA
      if (ISCA(KA) /= 0) then
        S = SSCA(KA)
        IROW = ISCA(KA)
        !IADR = KA+(J-1)*NKA+(ICOFF-1-1)*NKA*NJ
        IADR = IADR0+KA
        do JB=ICOFF,ICEND
          ! Address of C(Ka,j,Jb)
          IADR = IADR+ICONST
          CKAJJB(IADR) = S*CB(JB,IROW)
        end do
      else
        IADR = IADR0+KA
        do JB=ICOFF,ICEND
          !IADR = KA+(J-1)*NKA+(JB-1)*NKA*NJ
          IADR = IADR+ICONST
          CKAJJB(IADR) = Zero
        end do
      end if
    end do
  else
    ! No inner loop over JB
    do KA=1,NKA
      if (ISCA(KA) /= 0) then
        S = SSCA(KA)
        IROW = ISCA(KA)
        !IADR = KA+(J-1)*NKA+(ICOFF-1-1)*NKA*NJ
        IADR = IADR0+KA
        !do JB=ICOFF,ICEND
        ! Address of C(Ka,j,Jb)
        IADR = IADR+ICONST
        CKAJJB(IADR) = S*CB(ICOFF,IROW)
        !end do
      else
        IADR = IADR0+KA
        !do JB=ICOFF,ICEND
        !  IADR = KA + (J-1)*NKA+(JB-1)*NKA*NJ
        IADR = IADR+ICONST
        CKAJJB(IADR) = Zero
        !end do
      end if
    end do
  end if
  ! End of test ICEND,ICOFF
end do

end subroutine GET_CKAJJB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine INT62(I,K,L,IT1,IT2,II,IID,JJ,JJD,JTYP,ITAI,L0,L1,L2,L3)
! I < K < L  J == L

use guga_global, only: COUP, ICOUP, ICOUP1, IJ, IVF0, IWAY, IX, J1, J2, JM, JM1
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: I, K, L, IT1, IT2, II, IID, JJ, JJD, JTYP, L0(*), L1(*), L2(*), L3(*)
integer(kind=iwp), intent(_OUT_) :: ITAI(*)
integer(kind=iwp) :: ISTOP, ITAIL, ITURN, ITYP, KM, LJ, LJM, LJS
logical(kind=iwp) :: first1, first2, skip

LJS = IJ(L+1)+1
LJM = IJ(L)
do LJ=LJS,LJM
  ITAIL = IX(IT2+LJ)
  if (IT1 /= IT2) call TAIL(L,LJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
  IWAY(L) = 1
  skip = .false.
  loop_1: do
    if (skip) then
      skip = .false.
    else
      KM = L
      J2(KM+1) = LJ
      J1(KM+1) = LJ
      JM(KM) = IVF0+1
      JM1(KM) = IVF0+1
      call LOOP8(KM,ISTOP,IT1,IT2)
      if (ISTOP == 1) exit loop_1
      ITYP = 0
      if (IWAY(L) /= 5) ITYP = 2
    end if
    KM = KM-1
    IWAY(KM) = 1
    first1 = KM == K
    loop_2: do
      if (first1) then
        first1 = .false.
        ITURN = 0
        IWAY(K) = 1
        loop_3: do
          KM = K
          if (ITURN == 0) then
            call LOOP20(KM,ISTOP,IT1,IT2)
          else if (ITURN == 1) then
            call LOOP19(KM,ISTOP,IT1,IT2)
          end if
          if (ISTOP /= 0) then
            if (ITURN /= 1) then
              ITURN = 1
              IWAY(K) = 1
              cycle loop_3
            else
              KM = KM+1
              if (KM == L) cycle loop_1
              cycle loop_2
            end if
          end if
          loop_4: do
            KM = KM-1
            first2 = .false.
            if (KM == 0) then
              if ((JTYP <= 3) .or. (ITYP /= 2)) call COMP1(LJ,ITYP,L,IT2,II,IID,JJ,JJD,JTYP,ITAI)
              KM = 1
              if (KM == K) cycle loop_3
            else
              IWAY(KM) = 1
              if (KM == I) first2 = .true.
            end if
            do
              if (first2) then
                IWAY(I) = 1
                do
                  KM = I
                  if (ITURN == 0) then
                    call LOOP4(KM,ISTOP,IT1,IT2)
                  else if (ITURN == 1) then
                    call LOOP3(KM,ISTOP,IT1,IT2)
                  end if
                  if (ISTOP == 1) exit
                  if (abs(COUP(I)) < 1.0e-6_wp) cycle
                  if ((ITYP == 2) .and. (ICOUP1(I) < ICOUP(I))) cycle
                  call COMP(I,LJ,ITYP,I,IT1,IT2)
                end do
                first2 = .false.
              else
                if (ITURN == 0) then
                  call LOOP6(KM,ISTOP,IT1,IT2)
                else if (ITURN == 1) then
                  call LOOP5(KM,ISTOP,IT1,IT2)
                end if
                if (ISTOP == 0) cycle loop_4
              end if
              KM = KM+1
              if (KM == K) cycle loop_3
            end do
            if (.true.) exit loop_4
          end do loop_4
          if (.true.) exit loop_3
        end do loop_3
        exit loop_2
      else
        JM(KM) = IVF0+1
        JM1(KM) = IVF0+1
        call LOOP21(KM,ISTOP,IT1,IT2)
        if (ISTOP == 0) then
          skip = .true.
          cycle loop_1
        end if
        KM = KM+1
        if (KM == L) cycle loop_1
      end if
    end do loop_2
    if (.true.) exit loop_1
  end do loop_1
end do

return

end subroutine INT62

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
module sorting_funcs
implicit none
public

contains

logical pure function leq_i(x, y)
  integer, intent(in) :: x, y
  leq_i = x <= y
end function

logical pure function leq_r(x, y)
  real*8, intent(in) :: x, y
  leq_r = x <= y
end function

logical pure function leq_c(x, y)
  complex*16, intent(in) :: x, y
  leq_c = real(x)**2+aimag(x)**2 <= real(y)**2+aimag(y)**2
end function

logical pure function geq_i(x, y)
  integer, intent(in) :: x, y
  geq_i = x >= y
end function

logical pure function geq_r(x, y)
  real*8, intent(in) :: x, y
  geq_r = x >= y
end function

logical pure function geq_c(x, y)
  complex*16, intent(in) :: x, y
  geq_c = real(x)**2+aimag(x)**2 >= real(y)**2+aimag(y)**2
end function

end module sorting_funcs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine AdT_T17 (T1,Q,dimat,dimaq,no,adda,f)
c
c       this routine do:
c       T1(a,i) <<- f . Q(a',i)
c
        implicit none
        integer dimat,dimaq,no,adda
        real*8 T1(1:dimat,1:no)
        real*8 Q(1:dimaq,no)
        real*8 f
c
c       help variables
        integer i,a
c
        do i=1,no
          do a=1,dimaq
            t1(adda+a,i)=t1(adda+a,i)+f*q(a,i)
          end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3sglh211(w,dima,dimab,dimc,s1,d1,ns)
! this routine adds following contribution to W
! for syma=symb;symc
!
! W(ab,c) <-  + S1 _i(a) . D1 _jk(b,c)
! - S1 _i(b) . D1 _jk(a,c)
!
! w     - W matrix (I/O)
! dima  - dimension of a (b) index (I)
! dimab - dimension of ab  index (I)
! dimc  - dimension of c index (I)
! s1    - S1 matrix (I)
! d1    - D1 matrix (I)
! ns    - signum of the contribution (+-1) (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimab, dimc, ns
real(kind=wp), intent(inout) :: w(dimab,dimc)
real(kind=wp), intent(in) :: s1(dima), d1(dima,dimc)
integer(kind=iwp) :: a, ab, c

if (ns == 1) then
  ! phase + 1

  ab = 0
  do a=2,dima
    w(ab+1:ab+a-1,:) = w(ab+1:ab+a-1,:)+d1(1:a-1,:)*s1(a)
    ab = ab+a-1
  end do

  do c=1,dimc
    ab = 0
    do a=2,dima
      w(ab+1:ab+a-1,c) = w(ab+1:ab+a-1,c)-s1(1:a-1)*d1(a,c)
      ab = ab+a-1
    end do
  end do

else
  ! phase - 1

  ab = 0
  do a=2,dima
    w(ab+1:ab+a-1,:) = w(ab+1:ab+a-1,:)-d1(1:a-1,:)*s1(a)
    ab = ab+a-1
  end do

  do c=1,dimc
    ab = 0
    do a=2,dima
      w(ab+1:ab+a-1,c) = w(ab+1:ab+a-1,c)+s1(1:a-1)*d1(a,c)
      ab = ab+a-1
    end do
  end do

end if

return

end subroutine t3sglh211

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine cnfsort_cvb(iconfs,nconf1,nel1)

use casvb_global, only: noe, norb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nconf1, nel1
integer(kind=iwp), intent(inout) :: iconfs(noe,nconf1)
integer(kind=iwp) :: iconf, ion, iorb, jconf, mnion1, mxion1
integer(kind=iwp), allocatable :: iconfs2(:,:), ioncty(:)

call mma_allocate(ioncty,nconf1,label='ioncty')
call mma_allocate(iconfs2,noe,nconf1,label='iconfs2')

mnion1 = nel1/2
mxion1 = 0
do iconf=1,nconf1
  ion = 0
  do iorb=1,norb
    if (iconfs(iorb,iconf) == 2) ion = ion+1
  end do
  ioncty(iconf) = ion
  if (ion < mnion1) mnion1 = ion
  if (ion > mxion1) mxion1 = ion
end do
jconf = 0
do ion=mnion1,mxion1
  do iconf=1,nconf1
    if (ioncty(iconf) == ion) then
      jconf = jconf+1
      iconfs2(:,jconf) = iconfs(:,iconf)
    end if
  end do
end do
if (jconf /= nconf1) then
  write(u6,*) ' Error in cnfsort - jconf not same as nconf1 :',jconf,nconf1
  call abend_cvb()
end if
iconfs(:,:) = iconfs2(:,:)

call mma_deallocate(ioncty)
call mma_deallocate(iconfs2)

return

end subroutine cnfsort_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Subroutine  MemRys(iAnga,MemPrm)
      Implicit Real*8 (a-h,o-z)
*
*     This routine will compute the memory requirement of RYS
*     Memory requirement is per primitive!
*
#include "itmax.fh"
#include "print.fh"
#include "FMM.fh"
cgh - stuff for short range integrals
#include "srint.fh"
      Integer iAnga(4)
*
*     Statement function for canonical index, etc.
*
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      iRout = 13
      iPrint = nPrint(iRout)
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      nRys = (la+lb+lc+ld+2)/2
      labMin=nabSz(Max(la,lb)-1)+1
      labMax=nabSz(la+lb)
      lcdMin=nabSz(Max(lc,ld)-1)+1
      lcdMax=nabSz(lc+ld)
      labcd = (labMax-labMin+1)*(lcdMax-lcdMin+1)
      If (iPrint.ge.99) Then
         Write (6,*) ' labMin=',labMin
         Write (6,*) ' labMax=',labMax
         Write (6,*) ' lcdMin=',lcdMin
         Write (6,*) ' lcdMax=',lcdMax
      End If
      MemPrm = 0
*     [a0|c0]
      MemPrm = MemPrm + labcd
*                                                                      *
************************************************************************
*                                                                      *
*     For FMM, we only want short-range integrals, using twice the memory
*     to store full and long-range components (which are subtracted)
*    -same for MOLPRO shortrange
*
      If (FMM_shortrange.or.shortrange) MemPrm = MemPrm + labcd
*                                                                      *
************************************************************************
*                                                                      *
      nabMax = la+lb
*     nabMin = Max(la,lb)
      ncdMax = lc+ld
*     ncdMin = Max(lc,ld)
      nabcd = (nabMax+1)*(ncdMax+1)
      lB10=Max(Min(nabMax-1,1),0)
      lB01=Max(Min(ncdMax-1,1),0)
      lB00=Max(Min(Min(nabMax,ncdMax),1),0)
*     Normalization
      MemPrm = MemPrm + 1
*     2D-Integrals
      MemPrm = MemPrm + nabcd*3*nRys
*     Coefficients for recurrence relations
      MemPrm = MemPrm + 3*nRys + 3*nRys + 3*nRys*(lB10+lB01+lB00)
*     Roots
      MemPrm = MemPrm + nRys
*     The inverse of the arguments
      MemPrm = MemPrm + 1
*     Arguments
      MemPrm = MemPrm + 1
*     Expanded versions of Zeta, ZetInv, Eta, EtaInv,
*     rKapab, rKapcd, P and Q
      MemPrm = MemPrm + 12
      If (iPrint.ge.99) Then
         Write (6,*) ' [e0|f0] integrals   :', labcd
         Write (6,*) ' Normalization factor:', 1
         Write (6,*) ' 2D-integrals        :', nabcd*3*nRys
         Write (6,*) ' PAQP vector         :', 3*nRys
         Write (6,*) ' QCPQ vector         :', 3*nRys
         Write (6,*) ' B10 coefficients    :', nRys*3*lB10
         Write (6,*) ' B00 coefficients    :', nRys*3*lB00
         Write (6,*) ' B01 coefficients    :', nRys*3*lB01
         Write (6,*) ' Roots               :', nRys
         Write (6,*) ' Inverse arguments   :', 1
         Write (6,*) ' Arguments           :', 1
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine NAInt(
#define _CALLING_
#include "int_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of nuclear attraction     *
*         integrals.                                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, January 1991                            *
************************************************************************
      Use Basis_Info
      use Center_Info
      use Temporary_Parameters, only: Primitive_Pass
      use DKH_Info, only: DKroll
      Implicit Real*8 (A-H,O-Z)
*     Used for normal nuclear attraction integrals
      External TNAI, Fake, XCff2D, XRys2D
*     Used for finite nuclei
      External TERI, ModU2, vCff2D, vRys2D
#include "real.fh"
#include "oneswi.fh"
#include "print.fh"

#include "int_interface.fh"

*-----Local arrys
      Real*8 C(3), TC(3), Coora(3,4), Coori(3,4), CoorAC(3,2)
      Logical EQ, NoSpecial, No3Cnt, lECP
      Integer iAnga(4), iDCRT(0:7)
      Character ChOper(0:7)*3
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      iRout = 151
      iPrint = nPrint(iRout)
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
      lECP = .False.
      DO i = 1, nCnttp
         lECP = lECP .or. dbsc(i)%ECP
      End Do
      lc=0
      ld=0
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = lc
      iAnga(4) = ld
      call dcopy_(3,A,1,Coora(1,1),1)
      call dcopy_(3,RB,1,Coora(1,2),1)
      call dcopy_(2*3,Coora,1,Coori,1)
      mabMin = nabSz(Max(la,lb)-1)+1
      mabMax = nabSz(la+lb)
      No3Cnt = .FALSE.
      If (EQ(A,RB)) Then
        mabMin=nabSz(la+lb-1)+1
      Else If (NDDO) Then
        No3Cnt = .TRUE.
      End If
*
*     Compute FLOPs and size of work array which Hrr will use.
*
      Call mHrr(la,lb,nFLOP,nMem)
*
*     Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
       call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
       call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
      llOper = lOper(1)
*
*     Modify Zeta if the two-electron code will be used!
*
      If (Nuclear_Model.eq.Gaussian_Type .or.
     &    Nuclear_Model.eq.mGaussian_Type) Then
         Do iZeta = 1, nZeta
            rKappa(iZeta)=rKappa(iZeta)*(TwoP54/Zeta(iZeta))
         End Do
      End If
*
*     Loop over nuclear centers.
*
      kdc = 0
      Do 100 kCnttp = 1, nCnttp
*
*        Change nuclear charge if this is a relativistic ECP-case. This
*        is used for the DKH transformation (see dkh_util/dkrelint.f)!
*
         If (DKroll.and.Primitive_Pass.and.lECP) Then
            Q_Nuc=DBLE(dbsc(kCnttp)%AtmNr)
         Else
            Q_Nuc=dbsc(kCnttp)%Charge
         End If

         If (Q_Nuc.eq.Zero) Go To 111
         Do 101 kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
            If (iPrint.ge.99) Call RecPrt('C',' ',C,1,3)
*
*-----------Find the DCR for M and S
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab ,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
            If (iPrint.ge.99) Then
               Write (6,*) ' m      =',nStabM
               Write (6,'(9A)') '(M)=',(ChOper(iStabM(ii)),
     &               ii = 0, nStabM-1)
               Write (6,*) ' s      =',dc(kdc+kCnt)%nStab
               Write (6,'(9A)') '(S)=',(ChOper(dc(kdc+kCnt)%iStab(ii)),
     &               ii = 0, dc(kdc+kCnt)%nStab-1)
               Write (6,*) ' LambdaT=',LmbdT
               Write (6,*) ' t      =',nDCRT
               Write (6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),
     &               ii = 0, nDCRT-1)
            End If

*
            Do 102 lDCRT = 0, nDCRT-1
               Call OA(iDCRT(lDCRT),C,TC)
*              switch (only two center NA matrix...)
               If (No3Cnt .AND. .NOT.(EQ(A,TC).OR.EQ(RB,TC))) Go To 102
*              switch
               call dcopy_(3,TC,1,CoorAC(1,2),1)
               call dcopy_(3,TC,1,Coori(1,3),1)
               call dcopy_(3,TC,1,Coori(1,4),1)
               call dcopy_(3,TC,1,Coora(1,3),1)
               call dcopy_(3,TC,1,Coora(1,4),1)
*                                                                      *
************************************************************************
*                                                                      *
*              Compute integrals with the Rys quadrature.
*                                                                      *
************************************************************************
*                                                                      *
               nT = nZeta
*                                                                      *
************************************************************************
*                                                                      *
               If (Nuclear_Model.eq.Gaussian_Type) Then
*
*                 Gaussian nuclear charge distribution
*
                  NoSpecial=.False.
                  Eta=dbsc(kCnttp)%ExpNuc
                  EInv=One/Eta
                  rKappcd=TwoP54/Eta
*                 Tag on the normalization
                  rKappcd=rKappcd*(Eta/Pi)**(Three/Two)
*                 s-type function
                  mcdMin=0
                  mcdMax=0
                  Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &                     [Eta],[EInv],1,P,nZeta,
     &                     TC,1,rKappa,[rKappcd],Coori,Coora,CoorAC,
     &                     mabmin,mabmax,mcdMin,mcdMax,
     &                     Array,nArr*nZeta,
     &                     TERI,ModU2,vCff2D,vRys2D,NoSpecial)
*                                                                      *
************************************************************************
*                                                                      *
               Else If (Nuclear_Model.eq.mGaussian_Type) Then
*
*                 Modified Gaussian nuclear charge distribution
*
                  NoSpecial=.False.
                  Eta=dbsc(kCnttp)%ExpNuc
                  EInv=One/Eta
                  rKappcd=TwoP54/Eta
*                 Tag on the normalization
                  rKappcd=rKappcd*(Eta/Pi)**(Three/Two)
     &                   /(One+Three*dbsc(kCnttp)%w_mGauss/(Two*Eta))
*                 s type function
                  mcdMin=0
                  mcdMax=0
                  Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &                     [Eta],[EInv],1,P,nZeta,
     &                     TC,1,rKappa,[rKappcd],Coori,Coora,CoorAC,
     &                     mabmin,mabmax,mcdMin,mcdMax,
     &                     Array,nArr*nZeta,
     &                     TERI,ModU2,vCff2D,vRys2D,NoSpecial)
*
*                 d type function w*(x**2+y**2+z**2)
                  If (dbsc(kCnttp)%w_mGauss.gt.0.0D0) Then
                     rKappcd = rKappcd*dbsc(kCnttp)%w_mGauss
                     iAnga(3)=2
                     mcdMin=nabSz(2+ld-1)+1
                     mcdMax = nabSz(2+ld)
*                    tweak the pointers
                     ipOff = 1 + nZeta * (la+1)*(la+2)/2
     &                                 * (lb+1)*(lb+2)/2
                     mArr = nArr - (la+1)*(la+2)/2*(lb+1)*(lb+2)/2
                     Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &                        [Eta],[EInv],1,P,nZeta,
     &                        TC,1,rKappa,[rKappcd],Coori,Coora,CoorAC,
     &                        mabMin,mabMax,mcdMin,mcdMax,
     &                        Array(ipOff),mArr*nZeta,
     &                        TERI,ModU2,vCff2D,vRys2D,NoSpecial)
                     iAnga(3)=0
*
*                    Add the s and d contributions together!
*
                     Call Assemble_mGauss(Array,Array(ipOff),
     &                                    nZeta*(mabMax-mabMin+1))
                  End If
*                                                                      *
************************************************************************
*                                                                      *
               Else If (Nuclear_Model.eq.Point_Charge) Then
*
*                 Point-like nuclear charge distribution
*
                  NoSpecial=.True.
                  Eta=One
                  EInv=One
                  rKappcd=One
                  mcdMin=0
                  mcdMax=0
                  Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &                     [Eta],[EInv],1,P,nZeta,
     &                     TC,1,rKappa,[rKappcd],Coori,Coora,CoorAC,
     &                     mabMin,mabMax,mcdMin,mcdMax,
     &                     Array,nArr*nZeta,
     &                     TNAI,Fake,XCff2D,XRys2D,NoSpecial)
               End If
*                                                                      *
************************************************************************
*                                                                      *
*
*--------------Use the HRR to compute the required primitive integrals.
*
               Call HRR(la,lb,A,RB,Array,nZeta,nMem,ipIn)
*
*--------------Accumulate contributions to the symmetry adapted operator
*
               nOp = NrOpr(iDCRT(lDCRT))
               Call SymAdO(Array(ipIn),nZeta,la,lb,nComp,Final,nIC,
     &                     nOp         ,lOper,iChO,-Fact*Q_Nuc)
               If (iPrint.ge.99) Then
                  Write (6,*) Fact*Q_Nuc
                  Call RecPrt('NaInt: Array(ipIn)',' ',Array(ipIn),
     &                    nZeta,nElem(la)*nElem(lb)*nComp)
                  Call RecPrt('NaInt: Final',' ',Final,
     &                    nZeta,nElem(la)*nElem(lb)*nIC)
               End If
*
 102        Continue
 101     Continue
 111     kdc = kdc + dbsc(kCnttp)%nCntr
 100  Continue
*
      If (Nuclear_Model.eq.Gaussian_Type .or.
     &    Nuclear_Model.eq.mGaussian_Type) Then
         Do iZeta = 1, nZeta
            rKappa(iZeta)=rKappa(iZeta)/(TwoP54/Zeta(iZeta))
         End Do
      End If
*
*     Call GetMem(' Exit NAInt','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_integer(nHer)
         Call Unused_real_array(CCoor)
         Call Unused_integer(nOrdOp)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DIAG_DKH(A,N,EIG,EW,SINV,AUX,IC)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, IC
real(kind=wp), intent(in) :: A(N*(N+1)/2), SINV(N,N)
real(kind=wp), intent(out) :: EIG(N,N), EW(N), AUX(N,N)
integer(kind=iwp) :: I, IJ, J, K, L
real(kind=wp) :: TOL

IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUX(I,J) = A(IJ)
    AUX(J,I) = A(IJ)
  end do
end do
do K=1,N
  do J=1,N
    EIG(K,J) = Zero
    do L=1,J
      EIG(K,J) = EIG(K,J)+AUX(K,L)*SINV(L,J)
    end do
  end do
end do
do I=1,N
  do J=1,I
    AUX(I,J) = Zero
    do K=1,I
      AUX(I,J) = AUX(I,J)+SINV(K,I)*EIG(K,J)
    end do
    AUX(J,I) = AUX(I,J)
  end do
end do

TOL = 1.0e-80_wp
call JACOB_REL(AUX,EIG,EW,N,TOL,IC)

return

end subroutine DIAG_DKH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1994-1996, Jeppe Olsen                            *
************************************************************************
      SUBROUTINE ADSTN_GAS(  KLOFFI,   IOBSM,   IOBTP,   ISPGP, ISPGPSM,
     &                      ISPGPTP,      I1,    XI1S,   NKSTR,    IEND,
     &                        IFRST,   KFRST,    KACT,  SCLFAC)
*
*
* Obtain mappings
* a+IORB !KSTR> = +/-!ISTR> for orbitals of symmetry IOBSM and type IOBTP
* and I strings belonging to supergroup ISPGP wih symmetry ISPGPSM
* and type ISPGPTP(=1=>alpha,=2=>beta)
*
* The results are given in the form
* I1(KSTR,IORB) =  ISTR if A+IORB !KSTR> = +/-!ISTR>
* (numbering relative to TS start)
* Above +/- is stored in XI1S
*
* if some nonvanishing excitations were found, KACT is set to 1,
* else it is zero
*
*
* Jeppe Olsen , Winter of 1991
*               January 1994 : modified to allow for several orbitals
*               August 95    : GAS version
*               October 96   : Improved version
*
* ======
*. Input
* ======
*
*./BIGGY
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "strbas.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "csm.fh"
#include "lucinp.fh"
*. Local scratch
      INTEGER NELFGS(MXPNGAS), ISMFGS(MXPNGAS),ITPFGS(MXPNGAS)
      INTEGER MAXVAL(MXPNGAS),MINVAL(MXPNGAS)
      INTEGER NNSTSGP(MXPNSMST,MXPNGAS)
      INTEGER IISTSGP(MXPNSMST,MXPNGAS)
*
      INTEGER IACIST(MXPNSMST), NACIST(MXPNSMST)
C??      DIMENSION IOFFI(LOFFI)
      PARAMETER(MXLNGAS=20)
*
* =======
*. Output
* =======
*
      INTEGER I1(*)
      DIMENSION XI1S(*)
      INTEGER ONE_ARR(1)
*. Will be stored as an matrix of dimension
* (NKSTR,*), Where NKSTR is the number of K-strings of
*  correct symmetry . Nk is provided by this routine.
*
* PAM Mars-2006: Allocation moved to outside this subroutine.
*      CALL MEMMAN(IDUM,IDUM,'MARK ',IDUM,'ADSTN ')
*      CALL MEMMAN(KLOFFI,LOFFI,'ADDL  ',2,'KLOFFI')
*
      IF(NGAS.GT.MXLNGAS) THEN
        WRITE(6,*) ' Ad hoc programming in ADSTN (IOFFI)'
        WRITE(6,*) ' Must be changed - or redimensioned '
*        STOP'ADST : IOFFI problem '
        CALL SYSABENDMSG('lucia_util/adstn_gas',
     &                          'Internal error',' ')
      END IF
*
      NTEST = 0000
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' ==================== '
        WRITE(6,*) ' ADSTN_GAS in service '
        WRITE(6,*) ' ==================== '
        WRITE(6,*)
        WRITE(6,*) '  IOBTP IOBSM : ', IOBTP,IOBSM
        WRITE(6,*) '  ISPGP ISPGPSM ISPGPTP :  ',
     &                ISPGP,ISPGPSM,ISPGPTP
      END IF
*
C?    IF(SCLFAC.NE.1.0D0) THEN
C?      WRITE(6,*) ' Problemo : ADSTN_GAS'
C?      WRITE(6,*) ' SCLFAC .ne. 1 '
C?    END IF
*
*. Supergroup and symmetry of K strings
*
      ISPGRPABS = IBSPGPFTP(ISPGPTP)-1+ISPGP
      ONE_ARR(1)=1
      CALL NEWTYP(ISPGRPABS,1,IOBTP,KSPGRPABS)
      CALL SYMCOM(2,0,IOBSM,KSM,ISPGPSM)
      NKSTR = NSTFSMSPGP(KSM,KSPGRPABS)
      IF(NTEST.GE.200) WRITE(6,*)
     & ' KSM, KSPGPRABS, NKSTR : ', KSM,KSPGRPABS, NKSTR
      IF(NKSTR.EQ.0) GOTO 9999
*
      NORBTS= NOBPTS(IOBTP,IOBSM)
      ZERO =0.0D0
      CALL SETVEC(XI1S,ZERO,NORBTS*NKSTR)
      IZERO = 0
      CALL ISETVC(I1,IZERO,NORBTS*NKSTR)
*
*. First orbital of given GASSpace
       IBORBSP = IELSUM(NOBPT,IOBTP-1)+1
*. First orbital of fiven GASSPace and Symmetry
       IBORBSPS = IOBPTS(IOBTP,IOBSM)


*
*. Information about I strings
* =============================
*
*. structure of group of strings defining I strings
      NGASL = 1
      DO IGAS = 1, NGAS
       ITPFGS(IGAS) = ISPGPFTP(IGAS,ISPGRPABS)
       NELFGS(IGAS) = NELFGP(ITPFGS(IGAS))
       IF(NELFGS(IGAS).GT.0) NGASL = IGAS
      END DO
*. Number of electrons before active type
      NELB = 0
      DO IGAS = 1, IOBTP -1
        NELB = NELB + NELFGS(IGAS)
      END DO
*. Number of electrons in active space
      NACGSOB = NOBPT(IOBTP)

*. Number of strings per symmetry for each symmetry
      DO IGAS = 1, NGAS
        CALL ICOPVE2(iWORK(KNSTSGP(1)),(ITPFGS(IGAS)-1)*NSMST+1,NSMST,
     &               NNSTSGP(1,IGAS))
      END DO
*. Offset and dimension for active group in I strings
      CALL ICOPVE2(iWORK(KISTSGP(1)),(ITPFGS(IOBTP)-1)*NSMST+1,NSMST,
     &               IACIST)
      CALL ICOPVE2(iWORK(KNSTSGP(1)),(ITPFGS(IOBTP)-1)*NSMST+1,NSMST,
     &               NACIST)
C?     WRITE(6,*) ' IACIST and NACIST arrays '
C?     CALL IWRTMA(IACIST,1,NSMST,1,NSMST)
C?     CALL IWRTMA(NACIST,1,NSMST,1,NSMST)
*
*. Generate offsets for I strings with given symmetry in
*  each space
*
      DO IGAS = 1, NGAS
        DO ISMST = 1, NSMST
          IF(NNSTSGP(ISMST,IGAS).GT.0) MAXVAL(IGAS) = ISMST
        END DO
        DO ISMST = NSMST,1,-1
          IF(NNSTSGP(ISMST,IGAS).GT.0) MINVAL(IGAS) = ISMST
        END DO
      END DO
      IFIRST = 1
      ISTRBS = 1
      NSTRINT = 0
 2000 CONTINUE
        IF(IFIRST .EQ. 1 ) THEN
          DO IGAS = 1, NGASL - 1
            ISMFGS(IGAS) = MINVAL(IGAS)
          END DO
        ELSE
*. Next distribution of symmetries in NGAS -1
         CALL NXTNUM3(ISMFGS,NGASL-1,MINVAL,MAXVAL,NONEW)
         IF(NONEW.NE.0) GOTO 2001
        END IF
        IFIRST = 0
*. Symmetry of NGASL -1 spaces given, symmetry of full space
        ISTSMM1 = 1
        DO IGAS = 1, NGASL -1
          CALL  SYMCOM(3,1,ISTSMM1,ISMFGS(IGAS),JSTSMM1)
          ISTSMM1 = JSTSMM1
        END DO
*.  sym of SPACE NGASL
        CALL SYMCOM(2,1,ISTSMM1,ISMGSN,ISPGPSM)
        ISMFGS(NGASL) = ISMGSN
        IF(NTEST.GE.200) THEN
          WRITE(6,*) ' next symmetry of NGASL spaces '
          CALL IWRTMA(ISMFGS,1,NGASL,1,NGASL)
        END IF
*. Number of strings with this symmetry combination
        NSTRII = 1
        DO IGAS = 1, NGASL
          NSTRII = NSTRII*NNSTSGP(ISMFGS(IGAS),IGAS)
        END DO
*. Offset for this symmetry distribution in IOFFI
        IOFF = 1
        MULT = 1
        DO IGAS = 1, NGASL
          IOFF = IOFF + (ISMFGS(IGAS)-1)*MULT
          MULT = MULT * NSMST
        END DO
*
      IF(NTEST.GE.1) THEN !SJS
        WRITE(6,*)
        WRITE(6,*) ' ============================ '
        WRITE(6,*) ' If program is crashing here,'
        WRITE(6,*) ' LOFFI needs to be increased. '
        WRITE(6,*) ' ============================ '
        WRITE(6,*)
      END IF
        WORK(KLOFFI+IOFF-1) = DBLE(NSTRINT) + 1.001D0
        NSTRINT = NSTRINT + NSTRII
        IF(NTEST.GE.200) THEN
          WRITE(6,*) ' IOFF, IOFFI(IOFF) NSTRII ',
     &                 IOFF, WORK(KLOFFI+IOFF-1),NSTRII
        END IF
*
      IF(NGASL-1.GT.0) GOTO 2000
 2001 CONTINUE


*
*. Supergroup and symmetry of K strings
*
CM    CALL NEWTYP(ISPGRPABS,1,IOBTP,KSPGRPABS)
CM    CALL SYMCOM(2,0,IOBSM,KSM,ISPGPSM)
CM    NKSTR = NSTFSMSPGP(KSM,KSPGRPABS)
CM    IF(NTEST.GE.200) WRITE(6,*)
CM   & ' KSM, KSPGPRABS, NKSTR : ', KSM,KSPGRPABS, NKSTR
*
*. Gas structure of K strings
*
      NGASL = 1
      DO IGAS = 1, NGAS
       ITPFGS(IGAS) = ISPGPFTP(IGAS,KSPGRPABS)
       NELFGS(IGAS) = NELFGP(ITPFGS(IGAS))
       IF(NELFGS(IGAS).GT.0) NGASL = IGAS
      END DO
*. Active group of K-strings
      KACGRP = ITPFGS(IOBTP)
*. Number of strings per symmetry distribution
      DO IGAS = 1, NGAS
        CALL ICOPVE2(iWORK(KNSTSGP(1)),(ITPFGS(IGAS)-1)*NSMST+1,NSMST,
     &               NNSTSGP(1,IGAS))
        CALL ICOPVE2(iWORK(KISTSGP(1)),(ITPFGS(IGAS)-1)*NSMST+1,NSMST,
     &               IISTSGP(1,IGAS))
      END DO
*
      DO IGAS = 1, NGAS
        DO ISMST = 1, NSMST
          IF(NNSTSGP(ISMST,IGAS).GT.0) MAXVAL(IGAS) = ISMST
        END DO
        DO ISMST = NSMST,1,-1
          IF(NNSTSGP(ISMST,IGAS).GT.0) MINVAL(IGAS) = ISMST
        END DO
      END DO
*
* Loop over symmetry distribtions of K strings
*
      KFIRST = 1
      KSTRBS = 1
 1000 CONTINUE
        IF(KFIRST .EQ. 1 ) THEN
          DO IGAS = 1, NGASL - 1
            ISMFGS(IGAS) = MINVAL(IGAS)
          END DO
        ELSE
*. Next distribution of symmetries in NGAS -1
         CALL NXTNUM3(ISMFGS,NGASL-1,MINVAL,MAXVAL,NONEW)
         IF(NONEW.NE.0) GOTO 1001
        END IF
        KFIRST = 0
        IF(NTEST.GE.200) THEN
          WRITE(6,*) ' next symmetry of NGASL-1 spaces '
          CALL IWRTMA(ISMFGS,NGASL-1,1,NGASL-1,1)
        END IF
*. Symmetry of NGASL -1 spaces given, symmetry of total space
        ISTSMM1 = 1
        DO IGAS = 1, NGASL -1
          CALL  SYMCOM(3,1,ISTSMM1,ISMFGS(IGAS),JSTSMM1)
          ISTSMM1 = JSTSMM1
        END DO
*. required sym of SPACE NGASL
        CALL SYMCOM(2,1,ISTSMM1,ISMGSN,KSM)
C?      write(6,*) ' after  SYMCOM '
C?      write(6,*) ' ngasl istsmm1 ksm',ngasl,istsmm1,ksm
        ISMFGS(NGASL) = ISMGSN
*
        DO IGAS = NGASL+1,NGAS
          ISMFGS(IGAS) = 1
        END DO
        IF(NTEST.GE.200) THEN
          WRITE(6,*) ' Next symmetry distribution '
          CALL IWRTMA(ISMFGS,1,NGAS,1,NGAS)
        END IF
*. Number of strings of this symmetry distribution
        NSTRIK = 1
        DO IGAS = 1, NGASL
          NSTRIK = NSTRIK*NNSTSGP(ISMFGS(IGAS),IGAS)
        END DO
*. Offset for corresponding I strings
        ISAVE = ISMFGS(IOBTP)
        CALL  SYMCOM(3,1,IOBSM,ISMFGS(IOBTP),IACSM)
        ISMFGS(IOBTP) = IACSM
        IOFF = 1
        MULT = 1
        DO IGAS = 1, NGAS
          IOFF = IOFF + (ISMFGS(IGAS)-1)*MULT
          MULT = MULT * NSMST
        END DO
        ISMFGS(IOBTP) = ISAVE
        IBSTRINI = INT(WORK(KLOFFI+IOFF-1))
C?      WRITE(6,*) ' IOFF IBSTRINI ', IOFF,IBSTRINI
*. Number of strings before active GAS space
        NSTB = 1
        DO IGAS = 1, IOBTP-1
          NSTB = NSTB*NNSTSGP(ISMFGS(IGAS),IGAS)
        END DO
*. Number of strings before active GAS space
        NSTA = 1
        DO IGAS =  IOBTP+1, NGAS
          NSTA = NSTA*NNSTSGP(ISMFGS(IGAS),IGAS)
        END DO
*. Number and offset for active group
C?      write(6,*) ' IACSM = ', IACSM
        NIAC  = NACIST(IACSM)
        IIAC =  IACIST(IACSM)
*
        NKAC = NNSTSGP(ISMFGS(IOBTP),IOBTP)
        IKAC = IISTSGP(ISMFGS(IOBTP),IOBTP)
*. I and K strings of given symmetry distribution
        NISD = NSTB*NIAC*NSTA
        NKSD = NSTB*NKAC*NSTA
C?      write(6,*) ' nstb nsta niac nkac ',
C?   &               nstb,nsta,niac,nkac
*. Obtain annihilation n mapping for all strings of this type
*
        NORBTS= NOBPTS(IOBTP,IOBSM)
*
        NKACT = NSTFGP(KACGRP)
C?      write(6,*) ' KACGRP ', KACGRP
        CALL ADSTN_GASSM(    NSTB,    NSTA,    IKAC,    IIAC,IBSTRINI,
     &                     KSTRBS,
     &                   IWORK(KSTSTM(KACGRP,1)),
     &                   IWORK(KSTSTM(KACGRP,2)),
     &                   IBORBSPS, IBORBSP,  NORBTS,    NKAC,   NKACT,
*
     &                       NIAC,   NKSTR, KBSTRIN,    NELB, NACGSOB,
     &                         I1,    XI1S,  SCLFAC)
        KSTRBS = KSTRBS + NKSD
        IF(NGASL-1.GT.0) GOTO 1000
 1001 CONTINUE
*
 9999 CONTINUE
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Output from ADSTN_GAS '
        WRITE(6,*) ' ===================== '
        WRITE(6,*) ' Total number of K strings ', NKSTR
        IF(NKSTR.NE.0) THEN
          DO IORB = IBORBSPS,IBORBSPS + NORBTS  - 1
            IORBR = IORB-IBORBSPS +1
            WRITE(6,*) ' Info for orbital ', IORB
            WRITE(6,*) ' Excited strings and sign '
            CALL IWRTMA(  I1((IORBR-1)*NKSTR+1),1,NKSTR,1,NKSTR)
            CALL WRTMAT(XI1S((IORBR-1)*NKSTR+1),1,NKSTR,1,NKSTR)
          END DO
        END IF
      END IF
*
* PAM Mars-2006: This flush moved outside of this subroutine
*      CALL MEMMAN(IDUM,IDUM,'FLUSM',IDUM,'ADSTN ')

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(IEND)
        CALL Unused_integer(IFRST)
        CALL Unused_integer(KFRST)
        CALL Unused_integer(KACT)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine rs(nm,n,a,w,matz,z,ierr)
! this subroutine calls the recommended sequence of
! subroutines from the eigensystem subroutine package (eispack)
! to find the eigenvalues and eigenvectors (if desired)
! of a real symmetric matrix.
!
! on input
!
!    nm  must be set to the row dimension of the two-dimensional
!    array parameters as declared in the calling program
!    dimension statement.
!
!    n  is the order of the matrix  a.
!
!    a  contains the real symmetric matrix.
!
!    matz  is an integer variable set equal to zero if
!    only eigenvalues are desired.  otherwise it is set to
!    any non-zero integer for both eigenvalues and eigenvectors.
!
! on output
!
!    w  contains the eigenvalues in ascending order.
!
!    z  contains the eigenvectors if matz is not zero.
!
!    ierr  is an integer output variable set equal to an error
!       completion code described in the documentation for tqlrat
!       and tql2.  the normal completion code is zero.
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n, matz
real(kind=wp), intent(inout) :: a(nm,n)
real(kind=wp), intent(out) :: w(n), z(nm,n)
integer(kind=iwp), intent(out) :: ierr
real(kind=wp), allocatable :: fv1(:), fv2(:)

if (n > nm) then
  ierr = 10*n
  return
end if

call mma_allocate(fv1,n,label='fv1')
if (matz /= 0) then
  ! .......... find both eigenvalues and eigenvectors ..........
  call tred2(nm,n,a,w,fv1,z)
  call tql2(nm,n,w,fv1,z,ierr)
else
  ! .......... find eigenvalues only ..........
  call mma_allocate(fv2,n,label='fv2')
  call tred1(nm,n,a,w,fv1,fv2)
  ! tqlrat encounters catastrophic underflow on the Vax
  !call tqlrat(n,w,fv2,ierr)
  call tql1(n,w,fv1,ierr)
  call mma_deallocate(fv2)
end if
call mma_deallocate(fv1)

return

end subroutine rs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c  ********************************************************
c  ** Public-domain library routines used by casvb only. **
c  ********************************************************
c  **********************
c  ** EISPACK ROUTINES **
c  **********************
      subroutine eltran(nm,n,low,igh,a,int,z)
c
      integer i,j,n,kl,mm,mp,nm,igh,low,mp1
      REAL*8 a(nm,igh),z(nm,n)
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmtrans,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine accumulates the stabilized elementary
c     similarity transformations used in the reduction of a
c     real general matrix to upper hessenberg form by  elmhes.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the multipliers which were used in the
c          reduction by  elmhes  in its lower triangle
c          below the subdiagonal.
c
c        int contains information on the rows and columns
c          interchanged in the reduction by  elmhes.
c          only elements low through igh are used.
c
c     on output
c
c        z contains the transformation matrix produced in the
c          reduction by  elmhes.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
c     .......... initialize z to identity matrix ..........
      do 80 j = 1, n
c
         do 60 i = 1, n
         z(i,j) = 0.0d0
   60    continue
c
         z(j,j) = 1.0d0
   80 continue
c
      kl = igh - low - 1
      if (kl .lt. 1) go to 200
c     .......... for mp=igh-1 step -1 until low+1 do -- ..........
      do 140 mm = 1, kl
         mp = igh - mm
         mp1 = mp + 1
c
         do 100 i = mp1, igh
         z(i,mp) = a(i,mp-1)
  100    continue
c
         i = int(mp)
         if (i .eq. mp) go to 140
c
         do 130 j = mp, igh
            z(mp,j) = z(i,j)
            z(i,j) = 0.0d0
  130    continue
c
         z(i,mp) = 1.0d0
  140 continue
c
  200 return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine recover_CF(N,HAM,Akq,B,C,Bstev)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
complex(kind=wp), intent(in) :: HAM(n,n), Akq(n-1,-(n-1):n-1)
real(kind=wp), intent(in) :: B(n,0:n), C(n,0:n), Bstev(n,-n:n)
integer(kind=iwp) :: i, info, j, k, q
real(kind=wp) :: c0, tdiff
complex(kind=wp) :: redME
real(kind=wp), allocatable :: w1(:), w2(:)
complex(kind=wp), allocatable :: Cm(:,:), Cp(:,:), HCF(:,:), O(:,:), W(:,:), Z(:,:)
real(kind=wp), external :: dznrm2_

do k=2,n-1
  do q=-k,k
    write(u6,'(A,i2,A,i3,A,2ES20.10)') 'Akq(',k,',',q,') = ',Akq(k,q)
  end do
end do
!=======================================================================
write(u6,'(A,ES20.10)') 'recover from Akq parameters'
call mma_allocate(HCF,n,n,label='HCF')
HCF(:,:) = cZero
call mma_allocate(Cm,n,n,label='Cm')
call mma_allocate(Cp,n,n,label='Cp')
do k=1,n-1
  do q=0,k
    ! generate the operator matrix K=ik, Q=iq, dimension=na
    call ITO(n,k,q,C0,Cp,Cm)
    if (q == 0) then
      HCF(:,:) = HCF(:,:)+Akq(k,q)*Cp(:,:)
    else
      HCF(:,:) = HCF(:,:)+Akq(k,q)*Cp(:,:)+Akq(k,-q)*Cm(:,:)
    end if
  end do !q
end do !k
call mma_deallocate(Cm)
call mma_deallocate(Cp)
tdiff = dznrm2_(n*n,HAM-HCF,1)
write(u6,'(A,ES20.10)') 'total difference between HAM-HCF=',tdiff
do i=1,n
  do j=1,n
    write(u6,'(2(A,i2,A,i2,A,2ES20.10,A),2(2ES20.10,5x))') 'HAM(',i,',',j,')=',HAM(i,j),'      ','HCF(',i,',',j,')=',HCF(i,j), &
                                                           ' diff=',HAM(i,j)-HCF(i,j)
  end do
end do
call mma_allocate(w1,n,label='w1')
call mma_allocate(w2,n,label='w2')
call mma_allocate(Z,n,n,label='Z')
call diag_c2(HAM,n,info,w1,Z)
call diag_c2(HCF,n,info,w2,Z)
do i=1,n
  write(u6,'(2(A,i2,A,ES20.10,A),2(2ES20.10,5x))') 'W1(',i,')=',w1(i)-w1(1),'      ','W2(',i,')=',w2(i)-w2(1),' diff=',w1(i)-w2(i)
end do

!=======================================================================
write(u6,'(A,ES20.10)') 'recover from B and C parameters'
HCF(:,:) = cZero
call mma_allocate(O,n,n,label='O')
call mma_allocate(W,n,n,label='W')
do k=1,n-1
  do q=0,k
    call Liviu_ESO(n,k,q,O,W,redME)
    if (q == 0) then
      HCF(:,:) = HCF(:,:)+B(k,0)*O(:,:)
    else
      HCF(:,:) = HCF(:,:)+B(k,q)*O(:,:)+C(k,q)*W(:,:)
    end if
  end do
end do
tdiff = dznrm2_(n*n,(HAM-HCF),1)
write(u6,'(A,ES20.10)') 'total difference between HAM-HCF=',tdiff
do i=1,n
  do j=1,n
    write(u6,'(2(A,i2,A,i2,A,2ES20.10,A),2(2ES20.10,5x))') 'HAM(',i,',',j,')=',HAM(i,j),'      ','HCF(',i,',',j,')=',HCF(i,j), &
                                                           ' diff=',HAM(i,j)-HCF(i,j)
  end do
end do
call diag_c2(HAM,n,info,w1,Z)
call diag_c2(HCF,n,info,w2,Z)
do i=1,n
  write(u6,'(2(A,i2,A,ES20.10,A),2(2ES20.10,5x))') 'W1(',i,')=',w1(i)-w1(1),'      ','W2(',i,')=',w2(i)-w2(1),' diff=',w1(i)-w2(i)
end do

!=======================================================================
write(6,'(A,ES20.10)') 'recover from Bstev'
HCF(:,:) = cZero
do k=1,n-1
  do q=0,k
    call ESO(n,k,q,O,W,redME)
    if (q == 0) then
      HCF(:,:) = HCF(:,:)+Bstev(k,0)*O(:,:)
    else
      HCF(:,:) = HCF(:,:)+Bstev(k,q)*O(:,:)+Bstev(k,-q)*W(:,:)
    end if
  end do
end do
tdiff = dznrm2_(n*n,(HAM-HCF),1)
write(u6,'(A,ES20.10)') 'total difference between HAM-HCF=',tdiff
do i=1,n
  do j=1,n
    write(u6,'(2(A,i2,A,i2,A,2ES20.10,A),2(2ES20.10,5x))') 'HAM(',i,',',j,')=',HAM(i,j),'      ','HCF(',i,',',j,')=',HCF(i,j), &
                                                           ' diff=',HAM(i,j)-HCF(i,j)
  end do
end do
call diag_c2(HAM,n,info,w1,Z)
call diag_c2(HCF,n,info,w2,Z)
do i=1,n
  write(u6,'(2(A,i2,A,ES20.10,A),2(2ES20.10,5x))') 'W1(',i,')=',w1(i)-w1(1),'      ','W2(',i,')=',w2(i)-w2(1),' diff=',w1(i)-w2(i)
end do
!=======================================================================

call mma_deallocate(w1)
call mma_deallocate(w2)
call mma_deallocate(Z)
call mma_deallocate(O)
call mma_deallocate(W)
call mma_deallocate(HCF)

return

end subroutine recover_CF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Start_Alaska()
      use Slapaf_Parameters, only: Request_Alaska, Request_RASSI, iState
      Implicit Real*8 (a-h,o-z)
#include "print.fh"
      Character*100 ProgName, Get_ProgName
      Character*128 FileName
      Character*16 StdIn, JOB1, JOB2
      Character*8 Method
      Character(LEN=180):: Line
      Logical Exists
*                                                                      *
************************************************************************
*                                                                      *
*     Get the name of the module
*
      ProgName=Get_ProgName()
      Call Upcase(ProgName)
      ProgName = adjustl(ProgName)
*
      iEnd = 1
 99   If (ProgName(iEnd:iEnd).ne.' ') Then
         iEnd=iEnd+1
         Go To 99
      End If
      iEnd = Min(iEnd-1,5)
      FileName=progname(1:iend)//'INP'
*
      LuInput=11
      LuInput=IsFreeUnit(LuInput)
      Call StdIn_Name(StdIn)
      Call Molcas_Open(LuInput,StdIn)
*
      If (Request_RASSI) Then
*                                                                      *
************************************************************************
*                                                                      *
*     Request computation of overlaps.
*
         If (nPrint(1).ge.6) Then
            Write (6,*)
            Write (6,*)
     &        ' Slapaf requests the computation of overlaps first!'
            Write (6,*)
         End If
*
         Call Get_cArray('Relax Method',Method,8)
         If ((Method .eq. 'CASPT2').or.(Method .eq. 'RASPT2')) Then
           JOB1='JOBMIX'
         Else
           JOB1='JOBIPH'
         End If
         Call f_inquire('JOBAUTO',Exists)
         JOB2=JOB1
         If (Exists) JOB2='JOBAUTO'
*
         Write (LuInput,'(A)') '>ECHO OFF'
         Write (LuInput,'(A)') '> export SL_OLD_TRAP=$MOLCAS_TRAP'
         Write (LuInput,'(A)') '> export MOLCAS_TRAP=ON'
         Write (LuInput,'(A)') ' &RASSI &End'
         Write (LuInput,'(A)') 'StOverlaps'
         Write (LuInput,'(A)') 'NrOfJobIphs'
         Write (LuInput,'(A)') '  2 all'
         Write (LuInput,'(A)') 'IphNames'
         Write (LuInput,'(A)') '  '//Trim(JOB1)
         Write (LuInput,'(A)') '  '//Trim(JOB2)
         Write (LuInput,'(A)') ' End of Input'
         If (JOB1.eq.'JOBMIX') Then
           Write (LuInput,'(A)') '> copy $Project.JobMix JOBAUTO'
         Else
           Write (LuInput,'(A)') '> copy $Project.JobIph JOBAUTO'
         End If
         Write (LuInput,'(A)') '> export MOLCAS_TRAP=$SL_OLD_TRAP'
*
      Else If (Request_Alaska) Then
*                                                                      *
************************************************************************
*                                                                      *
*     Request computation of gradients.
*
         If (nPrint(1).ge.6) Then
            Write (6,*)
            Write (6,*)
     &        ' Slapaf requests the computation of gradients first!'
            If (iState(2).eq.0) Then
               Write (6,*) 'Root: ',iState(1)
            Else
               Write (6,*) 'Roots: ',iState(1),',',iState(2)
            End If
            Write (6,*)
         End If
*
         Write (LuInput,'(A)') '>ECHO OFF'
         Write (LuInput,'(A)') '>export SL_OLD_TRAP=$MOLCAS_TRAP'
         Write (LuInput,'(A)') '> export MOLCAS_TRAP=ON'
         Write (LuInput,'(A)') ' &Alaska &End'
         Write (LuInput,'(A)') 'AUTO'
         If (iState(2).ne.0) Then
            Write (LuInput,'(A)') 'NAC'
            Write (LuInput,'(I5,1X,I5)') iState(1),iState(2)
            Write (LuInput,'(A)') 'NoCSF'
         End If
         Write (LuInput,'(A)') ' End of Input'
         Write (LuInput,'(A)') '> export MOLCAS_TRAP=$SL_OLD_TRAP'
*        Repeat ECHO OFF, because it may have been turned on by alaska
         Write (LuInput,'(A)') '>ECHO OFF'
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Common code.
*
*
      Call f_inquire(Filename,Exists)
      If (Exists) Then
         LuSpool = 77
         LuSpool = IsFreeUnit(LuSpool)
         Call Molcas_Open(LuSpool, Filename)
*
 100     Continue
         Read (LuSpool,'(A)',End=900) Line
         Write(LuInput,'(A)') Line
         Go To 100
 900     Continue
*
         Close(LuSpool)
*
      Else
*
         Write (LuInput,'(A)') ' &Slapaf &End'
         Write (LuInput,'(A)') ' End of Input'
*
      End If
      Write (LuInput,'(A)') '>ECHO ON'
*
      Close(LuInput)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_RSSwap
*
*> @brief
*>   Swap reduced set index arrays
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Swap index arrays at locations \p iRS (``1``,``2``,``3``) and \p jRS (``1``,``2``,``3``).
*> If \p iRS and/or \p jRS are out of bounds, \p irc = ``1`` on exit and nothing
*> has been done!
*>
*> @warning
*> No special action is taken to redefine the \c IndRed array for first reduced set.
*>
*> @note
*> cholesky.fh must have been initialized.
*>
*> @param[out] irc return code
*> @param[in]  iRS location of reduced set
*> @param[in]  jRS location of reduced set
************************************************************************
      Subroutine Cho_X_RSSwap(irc,iRS,jRS)
      use ChoSwp, only: iiBstRSh, nnBstRSh, IndRed
      Implicit None
      Integer irc, iRS, jRS
#include "cholesky.fh"

      Integer N, iTemp

      If (iRS.lt.1 .or. iRS.gt.3 .or. jRS.lt.1 .or. jRS.gt.3) Then
         irc = 1
      Else
         If (iRS .ne. jRS) Then
            N = nSym*nnShl
            Call iSwap(N,iiBstRsh(:,:,iRS),1,iiBstRSh(:,:,jRS),1)
            Call iSwap(N,nnBstRsh(:,:,iRS),1,nnBstRSh(:,:,jRS),1)
            Call iSwap(nSym,iiBstR(1,iRS),1,iiBstR(1,jRS),1)
            Call iSwap(nSym,nnBstR(1,iRS),1,nnBstR(1,jRS),1)
            Call iSwap(nnBstRT(1),IndRed(:,iRs),1,IndRed(:,jRs),1)
            iTemp = nnBstRT(iRS)
            nnBstRT(iRS) = nnBstRT(jRS)
            nnBstRT(jRS) = iTemp
         End If
         irc = 0
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Bend(xyz,nCent,Fir,Bf,lWrite,lWarn,Label,dBf,ldB)

use Constants, only: Zero, One, Pi, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCent
real(kind=wp), intent(in) :: xyz(3,nCent)
real(kind=wp), intent(out) :: Fir, Bf(3,nCent)
logical(kind=iwp), intent(in) :: lWrite, lWarn, ldB
character(len=8), intent(in) :: Label
real(kind=wp), intent(inout) :: dBf(3,nCent,3,nCent)
integer(kind=iwp) :: i, j, mCent
real(kind=wp) :: BRij(3,2), BRjk(3,2), Co, Crap, dBRij(3,2,3,2), dBRjk(3,2,3,2), dFir, Rij1, Rjk1, Si
real(kind=wp), external :: ArCos, ArSin

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _TIME_
!                                                                      *
!***********************************************************************
!                                                                      *
mCent = 2
call Strtch(xyz(1,1),mCent,Rij1,BRij,.false.,Label,dBRij,ldB)
call Strtch(xyz(1,2),mCent,Rjk1,BRjk,.false.,Label,dBRjk,ldB)
Co = Zero
Crap = Zero
! BRij and BRjk should be normalized
do i=1,3
  Co = Co+BRij(i,1)*BRjk(i,2)
end do
do i=1,3
  Crap = Crap+(BRjk(i,2)-sign(One,Co)*BRij(i,1))**2
end do
Crap = sqrt(Crap)

! Special care for cases close to linearity

if (Crap < 1.0e-4_wp) then
  Si = Crap
  if (Co < Zero) then
    Fir = Pi-ArSin(Si)
  else
    Fir = ArSin(Si)
  end if
else
  if (abs(Co) > One) Co = sign(One,Co)
  Fir = ArCos(Co)
  Si = sqrt(One-Co**2)
end if

if (Fir < 1.0e-13_wp) then
  Fir = Zero
  return
else if (abs(Fir-Pi) < 1.0e-13_wp) then
  Fir = Pi
  return
end if
dFir = Fir/deg2rad
if (((abs(dFir) > 177.5_wp) .or. (abs(dFir) < 2.5_wp)) .and. lWarn) write(u6,*) ' Valence angle close to end in range of definition'
if (lWrite) write(u6,'(1X,A,A,F10.4,A,F10.6,A)') Label,' : Angle=    ',dFir,'   / degree  ',Fir,' / rad'

! Compute the WDC B-matrix

if (Si == Zero) then
  ! Dummy assignment for a linear system!
  Bf(:,:) = Zero
else
  do i=1,3
    Bf(i,1) = (Co*BRij(i,1)-BRjk(i,2))/(Si*Rij1)
    Bf(i,3) = (Co*BRjk(i,2)-BRij(i,1))/(Si*Rjk1)
    ! Utilize translational invariance.
    Bf(i,2) = -(Bf(i,1)+Bf(i,3))
  end do
end if
!call RecPrt('Bf',' ',Bf,9,1)

! Compute the cartesian derivative of the B-Matrix.

if (ldB) then

  !dBf = -11.11111_wp
  if (Si == Zero) then
    call WarningMessage(2,'Bend: Si == 0.0')
    call Abend()
  end if
  do i=1,3
    do j=1,i
      dBf(i,1,j,1) = (-Si*Bf(i,1)*BRij(j,1)+Co*dBRij(i,1,j,1)-Bf(j,1)*(Co*Bf(i,1)*Rij1+Si*BRij(i,1)))/(Si*Rij1)
      dBf(i,1,j,3) = (-Si*Bf(i,1)*BRjk(j,2)+dBRij(i,1,j,2)-Bf(j,3)*Co*Bf(i,1)*Rjk1)/(Si*Rjk1)
      !write(u6,*) '13',dBf(i,1,j,3), i, j
      dBf(i,3,j,1) = (-Si*Bf(i,3)*BRij(j,1)+dBRjk(i,2,j,1)-Bf(j,1)*Co*Bf(i,3)*Rij1)/(Si*Rij1)
      dBf(i,3,j,3) = (-Si*Bf(i,3)*BRjk(j,2)+Co*dBRjk(i,2,j,2)-Bf(j,3)*(Co*Bf(i,3)*Rjk1+Si*BRjk(i,2)))/(Si*Rjk1)

      dBf(j,1,i,1) = dBf(i,1,j,1)
      dBf(j,3,i,1) = dBf(i,1,j,3)
      dBf(j,1,i,3) = dBf(i,3,j,1)
      dBf(j,3,i,3) = dBf(i,3,j,3)

      dBf(i,1,j,2) = -(dBf(i,1,j,1)+dBf(i,1,j,3))
      dBf(j,2,i,1) = dBf(i,1,j,2)
      dBf(j,1,i,2) = -(dBf(j,1,i,1)+dBf(j,1,i,3))
      dBf(i,2,j,1) = dBf(j,1,i,2)
      dBf(i,3,j,2) = -(dBf(i,3,j,1)+dBf(i,3,j,3))
      dBf(j,2,i,3) = dBf(i,3,j,2)
      dBf(j,3,i,2) = -(dBf(j,3,i,1)+dBf(j,3,i,3))
      dBf(i,2,j,3) = dBf(j,3,i,2)

      dBf(i,2,j,2) = -(dBf(i,2,j,1)+dBf(i,2,j,3))
      dBf(j,2,i,2) = dBf(i,2,j,2)

    end do
  end do
  !call RecPrt('dBf','(9F9.1)',dBf,9,9)

end if

return

end subroutine Bend

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine write_formatted_aniso_poly(filename,nss,eso,MM,MS)

use Definitions, only: wp, iwp

implicit none
character(len=180), intent(in) :: filename
integer(kind=iwp), intent(in) :: nss
real(kind=wp), intent(in) :: eso(nss)
complex(kind=wp), intent(in) :: MM(3,nss,nss), MS(3,nss,nss)
integer(kind=iwp) :: i, j, l, LuAniso, multiplicity, nstate
integer(kind=iwp), external :: IsFreeUnit

LuAniso = IsFreeUnit(81)
call molcas_open(LuAniso,filename)
nstate = 1
multiplicity = 1
write(LuAniso,'(2i10)') nstate,nss
write(LuAniso,'(5ES24.14)') (eso(i),i=1,nss)
write(LuAniso,'(30i4)') multiplicity
do l=1,3
  do i=1,nss
    write(LuAniso,'(5ES24.14)') (MM(l,i,j),j=1,nss)
  end do
end do
do l=1,3
  do i=1,nss
    write(LuAniso,'(5ES24.14)') (MS(l,i,j),j=1,nss)
  end do
end do
close(LuAniso)

return

end subroutine write_formatted_aniso_poly

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
*               2010, Grigory A. Shamov                                *
************************************************************************
      Subroutine CWIG(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                   Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object: To compute the Powerful Wigner correlation functional        *
* Functional Repository (http://www.cse.clrc.ac.uk/qcg/dft)            *
*    Steward PA, Gill PW. J.Chem.Soc. Fadaday Trans. 91 (1995) 4337    *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author:Per Ake Malmqvist, Department of Theoretical Chemistry,  *
*             University of Lund, SWEDEN. June 2006                    *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),
     &       F_xc(mGrid)

* IDORD=Order of derivatives to request from XPBE:
      idord=1


      if (ispin.eq.1) then
* ispin=1 means spin zero.
* T_X: Screening threshold of total density.
        Ta=0.5D0*T_X
        do iGrid=1,mgrid
         rhoa=max(1.0D-24,Rho(ipR,iGrid))
         if(rhoa.lt.Ta) goto 110

         call cWIG_(idord,rhoa,rhoa,F,dFdrhoa,dFdrhob,
     &          d2Fdra2,d2Fdrb2,d2Fdrab)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*(F)
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*dFdrhoa
C     F is ok, but dFdrho comes in two pieces ? nope
* Note: For xpbe, dFdgammaab is zero.
 110     continue
        end do
      else
* ispin .ne. 1, use both alpha and beta components.
        do iGrid=1,mgrid
         rhoa=max(1.0D-24,Rho(ipRa,iGrid))
         rhob=max(1.0D-24,Rho(ipRb,iGrid))
         rho_tot=rhoa+rhob
         if(rho_tot.lt.T_X) goto 210
         call cWIG_(idord,rhoa,rhob,F,dFdrhoa,dFdrhob,
     &          d2Fdra2,d2Fdrb2,d2Fdrab)

         F_xc(iGrid)=F_xc(iGrid)+Coeff*(F)
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+Coeff*dFdrhoa
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+Coeff*dFdrhob

 210     continue
        end do
      end if

      Return
      End

      Subroutine cWIG_(idord,rho_a,rho_b, F
     &                ,dFdra,dFdrb,
     &                 d2Fdra2,d2Frb2,d2Fdrab)
************************************************************************
*                                                                      *
* Object: The Powerful Wigner Functional                               *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author: Grigory A Shamov, U. of Manitoba. Winter 2009           *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      parameter(one=1.0d0)
      parameter(four=4.0d0)
      parameter(eight=4.0d0)

      parameter(d= 0.349d0)
      parameter(a= 0.04918d0)

      rhoa=max(1.0D-24,rho_a)
      rhob=max(1.0D-24,rho_b)


      temp1=rhob+rhoa
      temp2=one/temp1
      temp3=d/temp1**(1.0d+0/3.0d+0)+1
      temp4=one/temp3
      temp5=(-4.0d+0)*a*d*rhoa*rhob/(3.0d+0*temp1**(7.0d+0/
     &   3.0d+0)*temp3**2)
      temp6=4*a*rhoa*rhob*temp4/temp1**2
      f = -4*a*rhoa*rhob*temp2*temp4


      if (idord .lt. 1) goto 99

      dFdra = -4*a*rhob*temp2*temp4+temp6+temp5
      dFdrb = -4*a*rhoa*temp2*temp4+temp6+temp5

      if ( idord .lt. 2) goto 99

      Call WarningMessage(2,
     & 'Second derivatives werent implemented for Wigner functional')
      call Abend()

99    continue

      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(d2Fdra2)
         Call Unused_real(d2Frb2)
         Call Unused_real(d2Fdrab)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993,1996, Markus P. Fuelscher                         *
!               1993, Per Ake Malmqvist                                *
!               1998, Roland Lindh                                     *
!***********************************************************************

subroutine SORT2()
!***********************************************************************
!                                                                      *
!     Purpose: Control phase 2 of bin sorting algorithm. First,        *
!              reload all integrals belonging to the same slice        *
!              and sort them ( cf. SORT2A ). While reading them        *
!              keep a trace of the records which have been read.       *
!              They are used to generate forward chaining indices.     *
!              Also integrals which are of zero value are placed       *
!              back into the list. In the second step put the sorted   *
!              integrals back onto disk. If new records are needed     *
!              append them to the end of the list.                     *
!                                                                      *
!     Called from: Seward_main                                         *
!                                                                      *
!     Calls to : Sort2A,Sort2B,Sort3                                   *
!                                                                      *
!     Calling parameters: none                                         *
!                                                                      *
!     Global data declarations (Include files) :                       *
!     TwoDat : definitions of sorting flags and address tables         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher and P.-AA. Malmqvist                             *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!     - modified to possibly use a virtual disk                        *
!       M. P. Fuelscher,University of Lund, Sweden, 1996               *
!     - modified to compute MxOrd                                      *
!       R. Lindh,University of Lund, Sweden, 1998                      *
!                                                                      *
!***********************************************************************

use sort_data, only: IndBin, lSll, lStRec, LuTwo, MxOrd, mxSyP, nBs, nSkip, nSln, nSyOp, Square, ValBin
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "TwoDat.fh"
#include "print.fh"
integer(kind=iwp) :: ib, iBatch, iBin, ibj, iDisk, iErr, iOff, iOpt, iOrd, iPrint, iRout, iSkip, iSlice, iStk, iSyblj, iSyBlk, &
                     iSymi, iSymj, jb, jSkip, jSymj, kb, kbl, kSkip, kSybll, kSymk, kSyml, kSymMx, lb, lSkip, lSlice, lSrtA, &
                     lSrtA_, lStk, lStk_Max, lSyml, lSymMx, mxij, nij, nSlice, nStk, nSym
integer(kind=iwp), allocatable :: IOStk(:)
real(kind=wp), allocatable :: SrtA(:), Scr(:)

!----------------------------------------------------------------------*
!     pick up the print level                                          *
!----------------------------------------------------------------------*

iRout = 84
iPrint = nPrint(iRout)
if (iPrint >= 10) write(u6,*) ' >>> Enter SORT2 <<<'

!----------------------------------------------------------------------*
!     Initialize the IO-stack                                          *
!----------------------------------------------------------------------*

call mma_MaxINT(lStk_Max)
lStk = max(64*1024,lStk_Max/5)
call mma_allocate(IOStk,lStk,Label='IOStk')
IOStk(:) = 0
nStk = 0

!----------------------------------------------------------------------*
!     loop over all submatrices of 2el integrals (slices)              *
!----------------------------------------------------------------------*

iOrd = 0
iBin = 0
nSym = nSyOp
do iSymi=1,nSym
  ib = nBs(iSymi)
  iSkip = nSkip(iSymi)
  do jSymj=1,iSymi
    iSymj = 1+ieor(iSymi-1,jSymj-1)
    iSyblj = jSymj+iSymi*(iSymi-1)/2
    jb = nBs(jSymj)
    ibj = ib*jb
    if (iSymi == jSymj) ibj = ib*(ib+1)/2
    jSkip = nSkip(jSymj)
    kSymMx = iSymi
    if (Square) kSymMx = nSym
    do kSymk=1,kSymMx
      kb = nBs(kSymk)
      kSkip = nSkip(kSymk)
      lSymMx = jSymj
      if ((kSymk /= iSymi) .or. Square) lSymMx = kSymk
      do lSyml=1,lSymMx
        kSyml = 1+ieor(kSymk-1,lSyml-1)
        kSybll = lSyml+kSymk*(kSymk-1)/2
        if (ieor(iSymj-1,kSyml-1) == 0) then
          lb = nBs(lSyml)
          kbl = kb*lb
          if (kSymk == lSyml) kbl = kb*(kb+1)/2
          lSkip = nSkip(lSyml)
          iSyBlk = kSybll+mxSyP*(iSyblj-1)

          if ((iSkip+jSkip+kSkip+lSkip == 0) .and. (ibj*kbl /= 0)) then
            !                                                          *
            !***********************************************************
            !                                                          *
            if (RAMD) then

              ! RAMD option

              lSrtA = ibj*kbl
              iBin = iBin+1
              iBatch = nBatch(iSyBlk)
              iOff = RAMD_Adr(iBatch)+1
              call SORT2B(iBin,lSrtA,iOrd,lSrtA,RAMD_Ints(iOff),IOStk,lStk,nStk)
              !                                                        *
              !*********************************************************
              !                                                        *
            else
              !                                                        *
              !*********************************************************
              !                                                        *
              ! Sorting option
              !
              nSlice = nSln(iSyBlk)
              lSlice = lSll(iSyBlk)
              nij = lSlice/kbl
              mxij = ibj

              lSrtA_ = min(mxij,nij)*kbl
              call mma_allocate(SrtA,lSrtA_,Label='SrtA')

              !--------------------------------------------------------*
              !     Allocate space to keep all integrals of a slice in *
              !     memory fetch them from disk and sort them.         *
              !--------------------------------------------------------*

              do iSlice=1,nSlice
                iBin = iBin+1
                lSrtA = min(mxij,nij)*kbl
                SrtA(1:lSrtA) = Zero
                call SORT2A(iBin,lSrtA,SrtA,IOStk,lStk,nStk)

                !------------------------------------------------------*
                ! Sort the IO-stack in ascending order, i.e., prefer-  *
                ! ence is always given to the lowest available disk    *
                ! adresses.                                            *
                !------------------------------------------------------*

                call ILASRT('D',nStk,IOStk,iErr)

                !------------------------------------------------------*
                ! Restore integrals on LuTwo                           *
                !------------------------------------------------------*

                call SORT2B(iBin,lSrtA,iOrd,lSrtA,SrtA,IOStk,lStk,nStk)
                mxij = mxij-nij
              end do

              call mma_deallocate(SrtA)
              !                                                        *
              !*********************************************************
              !                                                        *
            end if
            !                                                          *
            !***********************************************************
            !                                                          *
          end if
        end if
      end do
    end do
  end do
end do

!----------------------------------------------------------------------*
!     Clean the remaining records in the I/O Stack                     *
!----------------------------------------------------------------------*

call mma_allocate(Scr,lStRec,Label='Scr')
Scr(:) = Zero
do iStk=1,nStk
  iOrd = iOrd+1
  iDisk = IOStk(iStk)
  Scr(2) = real(iOrd,kind=wp)
  iOpt = 1
  call dDAFILE(LuTwo,iOpt,Scr,lStRec,iDisk)
end do
MxOrd = iOrd
call mma_deallocate(Scr)
call mma_deallocate(IOStk)

if (.not. RAMD) then
  call mma_deallocate(ValBin)
  call mma_deallocate(IndBin)
end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine SORT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine TraCtl2(CMO,PUVX,TUVX,D1I,FI,D1A,FA,IPR,lSquare,ExFac)

************************************************************************
*                                                                      *
*     main control section for Cholesky-based vs conventional          *
*     - transformation of ERIs from AO to MO basis                     *
*     - Fock matrix generation                                         *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Parameter ( Zero=0.0d0 )

#include "rasdim.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "wadr.fh"
#if defined (_MOLCAS_MPP_)
#include "para_info.fh"
#endif

*
      Dimension CMO(*), PUVX(*), TUVX(*)
      Dimension D1I(*), D1A(*), FI(*), FA(*)
      Logical lSquare,DoCholesky,TraOnly
      Integer ALGO
      Common /CHLCAS / DoCholesky,ALGO
*
*
*
*      Call DecideOnCholesky(DoCholesky)

      If (.not. DoCholesky) Then

        Call TRA_CTL2(CMO,PUVX,TUVX,D1I,FI,D1A,FA,IPR,lSquare,ExFac)

      ElseIf (ALGO.eq.1) Then

        lpwxy = ip_of_work(PUVX(1))

        TraOnly=.false.
       Call CHO_CAS_DRV(irc,CMO,D1I,FI,D1A,FA,WORK(LPMAT),TraOnly)

#if defined (_MOLCAS_MPP_)
c --------------------------------------------------
C  Synchronize Fock matrices if running parallel:
        If (nProcs .gt. 1 .and. Is_Real_Par()) then
           Call GADsum(FI,nTot1)
           Call GADsum(FA,nTot1)
C  Synchronize PUVX if running parallel:
           Call GADsum(PUVX,nPWXY)
        EndIf
#endif
c --------------------------------------------------
*     select integrals TUVX
        Call Get_TUVX(PUVX,TUVX)
*     save integrals on disk
*     nPWXY is computed in cho_eval_waxy
*           and stored in wadr.fh
        iDisk=0
        Call DDaFile(LUINTM,1,PUVX,nPWXY,iDisk)

      ElseIf (ALGO.eq.2) Then

        TraOnly=.false.
       Call CHO_CAS_DRV(irc,CMO,D1I,FI,D1A,FA,WORK(LPMAT),TraOnly)

        If (irc.ne.0) Then
         write(6,*)'TRACTL2: Cho_cas_drv non-Zero return code. rc= ',irc
         Call Abend
        EndIf

C  Synchronization for parallel runs is done in cho_cas_drv

      EndIf


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_INIRSDIM()
!
! Purpose: initialize reduced set dimension.

use Cholesky, only: MaxRed, nDimRS, nnBstR, nSym, RstCho, XnPass
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ILOC, IRS, NSET

if (RSTCHO) then
  ILOC = 3
  do IRS=1,XNPASS
    call CHO_GETRED(IRS,ILOC,.false.)
    call CHO_SETREDIND(ILOC)
    nDimRS(1:NSYM,iRS) = NNBSTR(1:NSYM,ILOC)
  end do
  NSET = XNPASS
else
  nDimRS(1:NSYM,1) = NNBSTR(1:NSYM,1)
  NSET = 1
end if

nDimRS(:,NSET+1:MAXRED) = 0

end subroutine CHO_INIRSDIM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine DIAG_CPF(ICASE,JSY,HDIAG,FC,FIJ,FJI)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICASE(*), JSY(*)
real(kind=wp), intent(_OUT_) :: HDIAG(*)
real(kind=wp), intent(in) :: FC(*), FIJ(*), FJI(*)

call IIJJ_CPF(ICASE,JSY,HDIAG,FC,FIJ,FJI)
call IJIJ_CPF(JSY,HDIAG,FJI)

return

end subroutine DIAG_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PSTTBL_MCLR(C,CTT,IATP,IASM,IBTP,IBSM,IOCOC,
     &                  NOCTPA,NOCTPB,NSASO,NSBSO,PSIGN,
     &                  ICOOSC,IAC,IDC,LUHC,SCR)
*
* add(IAC = 1) or copy (IAC =2) determinant block (iatp iasm, ibtp ibsm
* to vector packed in combination format
* iatp,iasm , ibtp,ibsm is assumed to be allowed combination block
*
* Combination type is defined by IDC
* IAC = 2  does not work for LUHC.NE.0 !
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(*),CTT(*),NSASO(NOCTPA,*),NSBSO(NOCTPB,*)
      DIMENSION IOCOC(NOCTPA,NOCTPB),ICOOSC(NOCTPA,NOCTPB,*)
*
      DIMENSION SCR(*)
      DIMENSION ISGVST(IBSM)
*
* ======================
* Write directly to disc
* ======================
*
*. Assumes complete block in,
*. copies to lower half, scales  and write out.
      IF(LUHC.NE.0) THEN
         NAST = NSASO(IATP,IASM)
         NBST = NSBSO(IBTP,IBSM)
         CALL SDCMRF_MCLR(CTT,SCR,1,IATP,IBTP,IASM,IBSM,NAST,NBST,
     &               IDC,PSIGN,PLSIGN,ISGVST,LDET,LCOMB)
*. Note : PLSIGN and ISGVST missing in order to make it work for IDC=3,4
         CALL ITODS([LCOMB],1,-1,LUHC)
         CALL TODSC_MCLR(SCR,LCOMB,-1,LUHC)
      ELSE
* ==================
* Add to packed list
* ===================
      IF(IASM.GT.IBSM.OR.IDC.EQ.1
     &   .OR.IDC.EQ.3)THEN
**************
** IASM > IBSM
**************

        IF( IDC .LT. 4 ) THEN
*.. simple copying
          IBASE = ICOOSC(IATP,IBTP,IASM)
          NELMNT = NSASO(IATP,IASM)*NSBSO(IBTP,IBSM)
          IF(IAC .EQ. 1 ) THEN
*           CALL VECSUM(C(IBASE),C(IBASE),CTT,1.0D0,1.0D0,NELMNT)
            Call DaXpY_(NELMNT,1.0d0,CTT,1,C(IBASE),1)
          ELSE IF(IAC .EQ.2 ) THEN
            CALL DCOPY_(NELMNT,CTT,1,C(IBASE),1)
          END IF
        ELSE IF ( IDC .EQ. 4 ) THEN
          IF(IATP.GT.IBTP) THEN
            IBASE = ICOOSC(IATP,IBTP,IASM)
            NELMNT = NSASO(IATP,IASM)*NSBSO(IBTP,IBSM)
            IF(IAC .EQ. 1 ) THEN
*             CALL VECSUM(C(IBASE),C(IBASE),CTT,1.0D0,1.0D0,NELMNT)
              Call DaXpY_(NELMNT,1.0d0,CTT,1,C(IBASE),1)
            ELSE IF(IAC .EQ.2 ) THEN
              CALL DCOPY_(NELMNT,CTT,1,C(IBASE),1)
            END IF
          ELSE IF( IATP .EQ. IBTP ) THEN
            IBASE = ICOOSC(IATP,IBTP,IASM)
            NAST = NSASO(IATP,IASM)
            IF( IAC .EQ. 1 ) THEN
              CALL PMPLFM(C(IBASE),CTT,NDIM)
            ELSE
              CALL TRIPK2(CTT,C(IBASE),1,NAST,NAST,PSIGN)
            END IF
          END IF
        END IF
      ELSE IF( IASM.EQ.IBSM) THEN
**************
** IASM = IBSM
**************
        IF(IATP.GT.IBTP) THEN
*.. simple copying
          IBASE = ICOOSC(IATP,IBTP,IASM)
          NELMNT = NSASO(IATP,IASM)*NSBSO(IBTP,IBSM)
          IF(IAC .EQ. 1 ) THEN
*           CALL VECSUM(C(IBASE),C(IBASE),CTT,1.0D0,1.0D0,NELMNT)
            Call DaXpY_(NELMNT,1.0d0,CTT,1,C(IBASE),1)
          ELSE IF(IAC .EQ.2 ) THEN
            CALL DCOPY_(NELMNT,CTT,1,C(IBASE),1)
          END IF
        ELSE IF( IATP.EQ.IBTP) THEN
*.. reform to triangular packed matrix
          IBASE = ICOOSC(IATP,IBTP,IASM)
          NAST = NSASO(IATP,IASM)
          IF( IAC .EQ. 1 ) THEN
            CALL PMPLFM(C(IBASE),CTT,NAST)
          ELSE
            CALL TRIPK2(CTT,C(IBASE),1,NAST,NAST,PSIGN)
          END IF
        END IF
      END IF
      END IF
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer_array(IOCOC)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ResortD(D_Old,D_New,iBas,iCmp,jBas,jCmp)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iBas, iCmp, jBas, jCmp
real(kind=wp), intent(in) :: D_Old(iBas,jBas,iCmp,jCmp)
real(kind=wp), intent(out) :: D_New(iBas,iCmp,jBas,jCmp)
integer(kind=iwp) :: iC, jB, jC

do jC=1,jCmp
  do jB=1,jBas
    do iC=1,iCmp
      D_New(:,iC,jB,jC) = D_Old(:,jB,iC,jC)
    end do
  end do
end do

return

end subroutine ResortD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_GetThrs()
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: Get LDF target accuracy from Runfile
C
      Implicit None
      Real*8 Target_Accuracy
      Call Get_dScalar('LDF Accuracy',Target_Accuracy)
      Call LDF_SetThrs(Target_Accuracy)
#if defined (_DEBUGPRINT_)
      Write(6,'(A,1P,D15.6)')
     & 'LDF_GetThrs: target accuracy from runfile:',Target_Accuracy
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine makecivb_cvb(civec,civb,cvbdet,orbs,cvb,ic)
c  Construct CIVB and CVBDET :
c  IC=0 : CIVB will contain full set of structures (if PROJCAS).
c  IC=1 : CIVB will contain only VB structures.
      implicit real*8 (a-h,o-z)
c ... Content of CI vectors ...
      logical, external :: tstcnt_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension orbs(norb,norb),cvb(nvb)
      dimension civec(ndet),civb(ndet)
      dimension cvbdet(ndetvb)

      if(tstcnt_cvb(civb,3-ic))return

      if(.not.projcas)then
        call str2vbc_cvb(cvb,cvbdet)
        call vb2cic_cvb(cvbdet,civb)
      elseif(projcas)then
        iorbinv = mstackr_cvb(norb*norb)
        igjorb  = mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))

        if(memplenty)then
          call getci_cvb(civec)
          call cicopy_cvb(civec,civb)
        else
          call cird_cvb(civb,61001.2d0)
        endif
        call fmove_cvb(orbs,work(iorbinv),norb*norb)
        call mxinv_cvb(work(iorbinv),norb)
        call gaussj_cvb(work(iorbinv),work(igjorb))
        call applyt_cvb(civb,work(igjorb))
        call ci2vbc_cvb(civb,cvbdet)
        call vb2strc_cvb(cvbdet,cvb)
        if(ic.eq.1)call vb2cic_cvb(cvbdet,civb)

        call mfreer_cvb(iorbinv)
      endif
      call setcnt_cvb(civb,3-ic)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*     PCMSph: coordinates and radii of spheres                         *
*     PCMTess: coordinates and area of tesserae                        *
*     Vert: coordinates of tesserae vertices (3,*)                     *
*     Centr: coordinates of tesserae centers (3,*)                     *
*     SSph: exposed surface of each sphere                             *
*     PCMDM: PCM matrix                                                *
*     PCM_N: atoms where the spheres are centered                      *
*     PCMiSph: sphere to which each tessera belongs                    *
*     NVert: number of vertices of each tessera                        *
*     IntSph: sphere intersecated by each tessera edge (MxVert,*)      *
*     NewSph: parent spheres for each added sphere (2,*)               *
************************************************************************
      Module PCM_arrays
      Integer nTiles
      Real*8, Allocatable:: C_Tessera(:,:), Q_Tessera(:)
      Real*8, Allocatable:: dTes(:,:,:), dPnt(:,:,:,:), dRad(:,:,:),
     &                      dCntr(:,:,:,:)
      Real*8, Allocatable:: PCM_SQ(:,:)   ! PCM solvation charges
      Real*8, Allocatable:: PCMSph(:,:), PCMTess(:,:), Vert(:,:,:),
     &                      Centr(:,:,:), SSph(:), PCMDM(:,:)
      Integer, Allocatable:: PCM_N(:), PCMiSph(:), nVert(:),
     &                       IntSph(:,:), NewSph(:,:)
      Real*8, Allocatable:: MM(:,:)
      End Module PCM_arrays

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GauBon(XE,YE,ZE,RE,IntSph,NV,NS,PTS,CCC,PP,AREA,IPRINT)

use PCM_Arrays, only: MxVert
use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IntSph(MxVert), NV, NS, IPRINT
real(kind=wp), intent(in) :: XE(*), YE(*), ZE(*), RE(*), PTS(3,MxVert), CCC(3,MxVert)
real(kind=wp), intent(out) :: PP(3), AREA
integer(kind=iwp) :: I, JJ, N, N0, N1, N2, NSFE1
real(kind=wp) :: BETAN, COSPHIN, COSTN, DNORM, DNORM1, DNORM2, DNORM3, P1(3), P2(3), P3(3), PHIN, RR2, SCAL, SUM1, SUM2, U1(3), &
                 U2(3)
real(kind=wp), parameter :: Small = 1.0e-35_wp, TPI = Two*Pi

! Sfrutta il teorema di Gauss-Bonnet per calcolare l'area
! della tessera con vertici PTS(3,NV). Consideriamo sempre
! che il lato N della tessera e' quello compreso tra i vertici
! N e N+1 (oppure NV e 1). In CCC(3,NV) sono le posizioni dei
! centri degli archi che sottendono i vari lati della tessera.
! La formula di Gauss-Bonet per le sfere e':
!        Area=R^2[2pi+S(Phi(N)cosT(N))-S(Beta(N))]
! dove Phi(N) e' la lunghezza d'arco (in radianti) del lato N,
! T(N) e' l'angolo polare del lato N, Beta(N) l'angolo esterno
! relativo al vertice N.
!
! Questa SUBROUTINE viene chiamata anche da VOLCHG (in calcoli con
! dielettrico non omogeneo) per calcolare l'area delle tessere
! proiettate sulle relative "sfere del centro di carica": in questo caso
! i vertici della tessera sono in PTS, i centri degli archi (tutti
! coincidenti con il centro di carica) sono in CCC e il punto
! rappresentativo e' in PP. La cosa piu' importante e' che NS < 0.

N0 = 0 ! dummy initialize
N2 = 0 ! dummy initialize

! Calcola la prima sommatoria
SUM1 = Zero
do N=1,NV
  U1(:) = PTS(:,N)-CCC(:,N)
  if (N < NV) then
    U2(:) = PTS(:,N+1)-CCC(:,N)
  else
    U2(:) = PTS(:,1)-CCC(:,N)
  end if
  DNORM1 = U1(1)*U1(1)+U1(2)*U1(2)+U1(3)*U1(3)
  DNORM2 = U2(1)*U2(1)+U2(2)*U2(2)+U2(3)*U2(3)
  SCAL = U1(1)*U2(1)+U1(2)*U2(2)+U1(3)*U2(3)
  COSPHIN = SCAL/(sqrt(DNORM1*DNORM2))
  if (COSPHIN > One) COSPHIN = One
  PHIN = acos(COSPHIN)

  ! Normalmente NS>0, ma se GAUBON e' stata chiamata da VOLCHG NS<0

  if (NS > 0) then
    ! NSFE1 e' la sfera con cui la sfera NS si interseca (eventualmente)
    NSFE1 = INTSPH(N)
    U1(1) = XE(NSFE1)-XE(NS)
    U1(2) = YE(NSFE1)-YE(NS)
    U1(3) = ZE(NSFE1)-ZE(NS)
  else
    U1(:) = ZERO
  end if
  DNORM1 = sqrt(U1(1)*U1(1)+U1(2)*U1(2)+U1(3)*U1(3))
  if (DNORM1 == ZERO) DNORM1 = One
  if (NS > 0) then
    U2(1) = PTS(1,N)-XE(NS)
    U2(2) = PTS(2,N)-YE(NS)
    U2(3) = PTS(3,N)-ZE(NS)
  else
    U2(:) = PTS(:,N)-CCC(:,1)
  end if
  DNORM2 = sqrt(U2(1)*U2(1)+U2(2)*U2(2)+U2(3)*U2(3))
  COSTN = (U1(1)*U2(1)+U1(2)*U2(2)+U1(3)*U2(3))/(DNORM1*DNORM2)
  SUM1 = SUM1+PHIN*COSTN
end do

! Calcola la seconda sommatoria: l'angolo esterno Beta(N) e'
! definito usando i versori (u(N-1),u(N)) tangenti alla sfera
! nel vertice N lungo le direzioni dei lati N-1 e N:
!            cos( Pi-Beta(N) )=u(N-1)*u(N)
!        u(N-1) = [V(N) x (V(N) x V(N-1))]/NORM
!        u(N) = [V(N) x (V(N) x V(N+1))]/NORM
! dove V(I) e' il vettore posizione del vertice I RISPETTO AL
! CENTRO DELL'ARCO CHE SI STA CONSIDERANDO.

SUM2 = Zero
! Loop sui vertici
do N=1,NV
  P1(:) = Zero
  N1 = N
  if (N > 1) N0 = N-1
  if (N == 1) N0 = NV
  if (N < NV) N2 = N+1
  if (N == NV) N2 = 1
  ! Trova i vettori posizione rispetto ai centri corrispondenti
  ! e i versori tangenti

  ! Lato N0-N1:
  P1(:) = PTS(:,N1)-CCC(:,N0)
  P2(:) = PTS(:,N0)-CCC(:,N0)

  call crprod(P1,P2,P3)
  P2(:) = P3(:)
  call crprod(P1,P2,P3)
  DNORM3 = sqrt(P3(1)*P3(1)+P3(2)*P3(2)+P3(3)*P3(3))
  if (DNorm3 < Small) DNorm3 = One
  U1(:) = P3(:)/DNORM3

  ! Lato N1-N2:
  P1(:) = PTS(:,N1)-CCC(:,N1)
  P2(:) = PTS(:,N2)-CCC(:,N1)

  call crprod(P1,P2,P3)
  P2(:) = P3(:)
  call crprod(P1,P2,P3)
  DNORM3 = sqrt(P3(1)*P3(1)+P3(2)*P3(2)+P3(3)*P3(3))
  if (DNorm3 < Small) DNorm3 = One
  U2(:) = P3(:)/DNORM3

  BETAN = acos(U1(1)*U2(1)+U1(2)*U2(2)+U1(3)*U2(3))
  SUM2 = SUM2+(PI-BETAN)
end do
! Calcola l'area della tessera
if (NS > 0) then
  AREA = RE(NS)*RE(NS)*(TPI+SUM1-SUM2)
else
  RR2 = (PTS(1,1)-CCC(1,1))**2+(PTS(2,1)-CCC(2,1))**2+(PTS(3,1)-CCC(3,1))**2
  AREA = RR2*(TPI+SUM1-SUM2)
end if
if (NS > 0) then
  ! Trova il punto rappresentativo (come media dei vertici)
  PP(:) = Zero
  do I=1,NV
    PP(1) = PP(1)+(PTS(1,I)-XE(NS))
    PP(2) = PP(2)+(PTS(2,I)-YE(NS))
    PP(3) = PP(3)+(PTS(3,I)-ZE(NS))
  end do
  DNORM = Zero
  do JJ=1,3
    DNORM = DNORM+PP(JJ)*PP(JJ)
  end do
  PP(1) = XE(NS)+PP(1)*RE(NS)/sqrt(DNORM)
  PP(2) = YE(NS)+PP(2)*RE(NS)/sqrt(DNORM)
  PP(3) = ZE(NS)+PP(3)*RE(NS)/sqrt(DNORM)
end if

! A causa delle approssimazioni numeriche, l'area di alcune piccole
! tessere puo' risultare negativa, e viene in questo caso trascurata
if (AREA < Zero) then
  AREA = Zero
  if (IPRINT >= 1) write(u6,1000) NS
end if

return

1000 format(/,'ATTENTION: THE SURFACE OF A TESSERA IN SPHERE ',I3,' IS NEGLECTED')

end subroutine GauBon

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Dresselhaus                                     *
************************************************************************
      subroutine embPotFreeMem
************************************************************************
*                                                                      *
* Object: cleanup routine for the embedding potential                  *
*                                                                      *
* Called from: Seward                                                  *
*              DrvMO                                                   *
*              EmbPotOutput                                            *
*                                                                      *
* Calling    : GetMem                                                  *
*                                                                      *
*     Author: Thomas Dresselhaus                                       *
*                                                                      *
************************************************************************

      Implicit None

****** Includes
#include "WrkSpc.fh"

      ! Holds the data which is read in in this subroutine
#include "embpotdata.fh"

******
      Call GetMem('embG','FREE','REAL',posEmbGridCoord,nEmbGridPoints*3)
      Call GetMem('embP','FREE','REAL',posEmbPotVal,nEmbGridPoints)
      Call GetMem('embW','FREE','REAL',posEmbWeight,nEmbGridPoints)

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Niclas Forsberg                                        *
!               2008,2009, Giovanni Ghigo                              *
!***********************************************************************

subroutine Mula(ireturn)
!  Purpose:
!  Calculate vibronic intensities.
!
!  Written by:
!  Niclas Forsberg,
!  Dept. of Theoretical Chemistry, Chemical Centre, Lund University.
!
!  Modified by:
!  Giovanni Ghigo,
!  Dip. Chimica Generale e Chimica Organica,
!  Universita' di Torino, ITALY.
!  Inter-System Crossing rate constant.

use mula_global, only: AtCoord1, AtCoord2, energy1, energy2, Hess1, Hess2, Huge_Print, inpUnit, ipow, m_plot, maxMax_n, MaxNumAt, &
                       mdim1, mdim2, n_plot, ndata, ndim1, ndim2, ngdim, NormModes, nPolyTerm, nvar, OscStr, t_dipin1, t_dipin2, &
                       TranDip, TranDipGrad, var, WriteVibLevels, yin1, yin2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, auTocm
use Definitions, only: wp, iwp, u5, u6, ItoB

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: i, iCode, iMaxYes, iMem, iOrd, iOsc, iPrint, iPrint_Save, iRateMem, iUMem, iv, jOrd, jOsc, k1, k2, l_a, &
                     l_harm, l_Hess_1, l_Hess_2, l_IntensityMat_1, l_IntensityMat_2, l_l, l_m_plot, l_n_plot, l_NormModes, &
                     l_TermMat_1, l_TermMat_2, lBatch, leftBatch, lLeft, lMBatch, lNDEC, lNINC, lNMAT, lNMAT0, m_max, max_dip, &
                     max_mInc, max_mOrd, max_nInc, max_nOrd, max_term, minQ, mTabDim, n_max, nBatch, nBond, nDimTot, new_n_max, &
                     nm, nOsc, nOscOld, nTabDim, nterm, NumOfAt, nvTabDim, nYes
real(kind=wp) :: CPE, CPTF0, CPTF1, CPTF2, CPTF3, CPTF4, CPTF5, CPTF6, det, det0, det1, det2, dh, dMinWind, dRho, FC00, GE1, GE2, &
                 max_err, stand_dev, T0, TIOE, TIOTF0, TIOTF1, TIOTF2, TIOTF3, TIOTF4, TIOTF5, TIOTF6
logical(kind=iwp) :: Cartesian, exists, find_minimum, ForceField, lExpan, lInCore, lISC, lOldCode, MatEl, use_weight
character(len=80) :: Title
character(len=4) :: filnam
integer(kind=iwp), allocatable :: Bond(:), Graph1(:,:), Graph2(:,:,:), InterVec(:), level1(:), level2(:), lVec(:), mDec(:,:), &
                                  mInc(:,:), mMat(:,:), nDec(:,:), nInc(:,:), nIndex(:,:), nMat(:,:), nMat0(:), nMaxQ(:), &
                                  nnTabDim(:), VibWind2(:)
real(kind=wp), allocatable :: alpha1(:,:), alpha2(:,:), anharmfreq1(:), anharmfreq2(:), AtCoord(:,:), Base(:,:), Base2(:,:), &
                              BaseInv(:,:), Bmat(:,:), C(:,:), C1(:,:), C2(:,:), D3_1(:,:,:), D3_2(:,:,:), D4_1(:,:,:,:), &
                              D4_2(:,:,:,:), E1(:), E2(:), eigenVec1(:,:), eigenVec2(:,:), G0(:,:), G1(:,:), G2(:,:), &
                              Gbis0(:,:,:,:), Gbis1(:,:,:,:), Gbis2(:,:,:,:), Gprm0(:,:,:), Gprm1(:,:,:), Gprm2(:,:,:), grad1(:), &
                              grad2(:), H1(:,:), H2(:,:), harmfreq1(:), harmfreq2(:), IntensityMat(:,:), Lambda(:), &
                              Mass(:), OccNumMat1(:,:,:), OccNumMat2(:,:,:), PED(:,:,:), PotCoef(:), qMat(:,:), r0(:), r00(:), &
                              r01(:), r02(:), r1(:), r2(:), rtemp(:), S1(:,:), S2(:,:), Smat(:,:), T4(:), temp(:,:), temp1(:,:), &
                              temp2(:,:), TermMat(:,:), TranDipGradInt(:,:), U1(:,:), U2(:,:), W(:,:), W1(:,:), W2(:,:), &
                              x_anharm1(:,:), x_anharm2(:,:)
character(len=80), allocatable :: trfName1(:), trfName2(:)
character(len=4), allocatable :: AtomLbl(:)
integer(kind=iwp), parameter :: MB = 1048576
integer(kind=iwp), external :: iPrintlevel, isfreeunit
#include "warnings.h"

! Initialize.
iReturn = 20
close(u5)
inpUnit = isfreeunit(12)
call molcas_open(inpUnit,'stdin')
iCode = 00         ! Default: NewCode, InCore
lOldCode = .false. ! X0  CGGn.4
lInCore = .true.   ! 0X  CGGn.4
lNMAT0 = 92        !     CGGn.4
lNMAT = 93         !     CGGn.4
lNINC = 94         !     CGGn.4
lNDEC = 95         !     CGGn.4
iPrint = iPrintLevel(-1)
iPrint_Save = iPrint
!open(inpUnit,'stdin')

! Read input file and Write header to log file.
call mma_allocate(AtomLbl,MaxNumAt,label='AtomLbl')
call mma_allocate(Mass,MaxNumAt,label='Mass')
call mma_allocate(InterVec,MaxNumAt*15,label='InterVec')
call mma_allocate(Bond,MaxNumAt*2,label='Bond')
call mma_allocate(trfName1,MaxNumAt,label='trfName1')
call mma_allocate(trfName2,MaxNumAt,label='trfName2')
call ReadInp(Title,AtomLbl,Mass,InterVec,Bond,nBond,nOsc,NumOfAt,trfName1,trfName2,m_max,n_max,max_dip,max_term,MatEl,ForceField, &
             Cartesian,lExpan,lISC,iCode,dMinWind)
if (lISC) then
  if ((iCode == 01) .or. (iCode == 11)) lOldCode = .true.
  if ((iCode == 10) .or. (iCode == 11)) lInCore = .false.
  if (energy1 < energy2) then
    write(u6,*) ' ******************** ERROR *******************'
    write(u6,*) ' Energy of State #2 must be lower than State #1'
    write(u6,*) ' **********i***********************************'
    write(u6,*)
    call Quit_OnUserError()
  end if
  MatEl = .false.
  m_max = 0
  if (iPrint >= 1) then
    write(u6,*)
    write(u6,*) ' ---------------------------------------------'
    write(u6,*) ' InterSystem Crossing rate constant evaluation'
    write(u6,*) '  - simple harmonic approximation is used.'
    write(u6,*) '  - m_max set to 0.'
    write(u6,*) '  - no plot file.'
    if (lOldCode) then
      write(u6,*) '  - Full index matrices evaluation.'
    else
      write(u6,*) '  - Reduced matrices evaluation.'
    end if
    if (lInCore) then
      write(u6,*) '  - In-core (memory) algorithm.'
    else
      write(u6,*) '  - Out-of-core (disk) algorithm.'
    end if
    write(u6,*) ' ---------------------------------------------'
    write(u6,*)
  end if
  iPrint = 0
end if
if ((iPrint >= 1) .and. (Title(1:1) /= ' ')) call WriteHeader(Title)

close(inpUnit)
call mma_allocate(r01,nOsc,label='r01')
call mma_allocate(r02,nOsc,label='r02')
call mma_allocate(r0,nOsc,label='r0')
call mma_allocate(r1,nOsc,label='r1')
call mma_allocate(r2,nOsc,label='r2')

call mma_allocate(grad1,nOsc,label='grad1')
call mma_allocate(grad2,nOsc,label='grad2')

call mma_allocate(G1,nOsc,nOsc,label='G1')
call mma_allocate(G2,nOsc,nOsc,label='G2')

call mma_allocate(eigenVec1,nOsc,nOsc,label='eigenVec1')
call mma_allocate(eigenVec2,nOsc,nOsc,label='eigenVec2')

call mma_allocate(harmfreq1,nOsc,label='harmfreq1')
call mma_allocate(harmfreq2,nOsc,label='harmfreq2')

call mma_allocate(anharmfreq1,nOsc,label='anharmfreq1')
call mma_allocate(anharmfreq2,nOsc,label='anharmfreq2')

call mma_allocate(qMat,3*NumOfAt,nOsc,label='qMat')
call mma_allocate(PED,nOsc,nOsc,nOsc,label='PED')

call mma_allocate(x_anharm1,nOsc,nOsc,label='x_anharm1')
call mma_allocate(x_anharm2,nOsc,nOsc,label='x_anharm2')

if ((max_term >= 0) .and. (max_term <= 2)) then
  ngdim = 1
else if ((max_term >= 3) .and. (max_term <= 4)) then
  ngdim = nosc
else
  write(u6,*) 'MULA error: max_term=',max_term
  write(u6,*) 'Allowed: 1,2,3, or 4.'
  call Quit_OnUserError()
end if
call mma_allocate(D3_1,ngdim,ngdim,ngdim,label='D3_1')
call mma_allocate(D3_2,ngdim,ngdim,ngdim,label='D3_2')
call mma_allocate(D4_1,ngdim,ngdim,ngdim,ngdim,label='D4_1')
call mma_allocate(D4_2,ngdim,ngdim,ngdim,ngdim,label='D4_2')
call mma_allocate(Gprm1,ngdim,ngdim,ngdim,label='Gprm1')
call mma_allocate(Gprm2,ngdim,ngdim,ngdim,label='Gprm2')
call mma_allocate(Gbis1,ngdim,ngdim,ngdim,ngdim,label='Gbis1')
call mma_allocate(Gbis2,ngdim,ngdim,ngdim,ngdim,label='Gbis2')

!----------------------------------------------------------------------!

! Either fit polynomial to energies and find minimum or use
! forcefield and equilibrium geometry given in input.

!----------------------      First State ------------------------------!

call mma_allocate(AtCoord,3,NumOfAt,label='AtCoord')

l_a = NumOfAt
l_Hess_1 = size(Hess1,1)
l_Hess_2 = size(Hess1,2)

call mma_allocate(PotCoef,nPolyTerm,label='PotCoef')
if (ForceField) then
  AtCoord(:,:) = AtCoord1
else
  find_minimum = .true.
  use_weight = .false.
  call PotFit(nPolyTerm,nvar,ndata,ipow,var,yin1,PotCoef,r01,nOsc,energy1,grad1,Hess1,D3_1,D4_1,trfName1,stand_dev,max_err, &
              find_minimum,max_term,use_weight,l_Hess_1,l_Hess_2,ngdim)
  call Int_To_Cart1(InterVec,r01,AtCoord,l_a,nOsc)
end if
call mma_deallocate(AtCoord1)

! Determine vibrational modes and their frequencies.
!D write(u6,*) ' MULA calling VIBFREQ.'
call VibFreq(AtCoord,r01,InterVec,Mass,Hess1,G1,Gprm1,Gbis1,harmfreq1,eigenVec1,qMat,PED,D3_1,D4_1,x_anharm1,anharmfreq1,max_term, &
             nOsc,NumOfAt)

!call WriteLog(PotCoef,AtomLbl,AtCoord,
if (iPrint >= 1) call WriteLog(PotCoef,AtomLbl,AtCoord,Mass,InterVec,stand_dev,max_err,energy1,Hess1,G1,eigenVec1,harmfreq1,qMat, &
                               Bond,nBond,r01,D3_1,D4_1,PED,x_anharm1,anharmfreq1,max_term,1,ForceField,NumOfAt,nOsc)

!----------------------      Second State -----------------------------!

l_Hess_1 = size(Hess2,1)
l_Hess_2 = size(Hess2,2)

if (ForceField) then
  AtCoord(:,:) = AtCoord2
else
  find_minimum = .true.
  use_weight = .false.
  call PotFit(nPolyTerm,nvar,ndata,ipow,var,yin2,PotCoef,r02,nOsc,energy2,grad2,Hess2,D3_2,D4_2,trfName2,stand_dev,max_err, &
              find_minimum,max_term,use_weight,l_Hess_1,l_Hess_2,ngdim)
  call Int_To_Cart1(InterVec,r02,AtCoord,l_a,nOsc)
end if
call mma_deallocate(AtCoord2)

! Determine vibrational modes and their frequencies.
call VibFreq(AtCoord,r02,InterVec,Mass,Hess2,G2,Gprm2,Gbis2,harmfreq2,eigenVec2,qMat,PED,D3_2,D4_2,x_anharm2,anharmfreq2,max_term, &
             nOsc,NumOfAt)
if (iPrint >= 1) call WriteLog(PotCoef,AtomLbl,AtCoord,Mass,InterVec,stand_dev,max_err,energy2,Hess2,G2,eigenVec2,harmfreq2,qMat, &
                               Bond,nBond,r02,D3_2,D4_2,PED,x_anharm2,anharmfreq2,max_term,2,ForceField,NumOfAt,nOsc)

call mma_deallocate(Bond)
call mma_deallocate(PotCoef)
call mma_deallocate(qMat)
call mma_deallocate(PED)

call mma_deallocate(grad1)
call mma_deallocate(grad2)

call mma_deallocate(anharmfreq1)
call mma_deallocate(anharmfreq2)

call mma_deallocate(D3_1)
call mma_deallocate(D3_2)
call mma_deallocate(D4_1)
call mma_deallocate(D4_2)

!----------------------------------------------------------------------!

! Geometry of intermediate oscillator

!----------------------------------------------------------------------!

T0 = energy2-energy1
call mma_allocate(C,nOsc,nOsc,label='C')
call mma_allocate(C1,nOsc,nOsc,label='C1')
call mma_allocate(C2,nOsc,nOsc,label='C2')
call mma_allocate(W,nOsc,nOsc,label='W')
call mma_allocate(W1,nOsc,nOsc,label='W1')
call mma_allocate(W2,nOsc,nOsc,label='W2')

call mma_allocate(temp,nOsc,nOsc,label='temp')

! Calculate W matrices.
do jOsc=1,nOsc
  W1(:,jOsc) = eigenVec1(:,jOsc)/sqrt(harmfreq1(jOsc))
  W2(:,jOsc) = eigenVec2(:,jOsc)/sqrt(harmfreq2(jOsc))
end do

! Calculate C = W^(-1).
C1(:,:) = Zero
do i=1,nOsc
  C1(i,i) = One
end do
temp(:,:) = W1
call Dool_MULA(temp,nOsc,nOsc,C1,nOsc,nOsc,det)
det1 = abs(One/det)
C2(:,:) = Zero
do i=1,nOsc
  C2(i,i) = One
end do
temp(:,:) = W2
call Dool_MULA(temp,nOsc,nOsc,C2,nOsc,nOsc,det)
det2 = abs(One/det)

! Calculate the expansion point geometry and save the full geometries for later use
if (iPrint >= 1) call ExpPointHeader()
call mma_allocate(r00,nOsc,label='r00')
call mma_allocate(alpha1,nOsc,nOsc,label='alpha1')
call mma_allocate(alpha2,nOsc,nOsc,label='alpha2')
call Calc_r00(C1,C2,C,W,alpha1,alpha2,r00,r01,r02,det0,det1,det2,FC00,nOsc)
call mma_deallocate(alpha1)
call mma_deallocate(alpha2)
r0(:) = r00
r1(:) = r01
r2(:) = r02
l_a = NumOfAt
call Int_To_Cart1(InterVec,r00,AtCoord,l_a,nOsc)
if (iPrint >= 1) call WriteCartCoord(AtomLbl,AtCoord,Mass,NumOfAt)
call mma_deallocate(r00)

call mma_deallocate(AtomLbl)

! If we only wanted the expansion point geometry, it's time to quit now.
if (lExpan) then
  write(u6,*) 'Bye bye'
  write(u6,*)
  call Quit(_RC_ALL_IS_WELL_)
end if

if (iPrint >= 1) call IntCalcHeader()

! Calculate term values.
GE1 = Zero
GE2 = GE1+T0
l_NormModes = size(NormModes)
do iOsc=1,nOsc
  jOsc = 1
  exists = .false.
  do while ((.not. exists) .and. (jOsc <= l_NormModes))
    exists = (iOsc == NormModes(jOsc))
    jOsc = jOsc+1
  end do
  if (.not. exists) then
    GE1 = GE1+Half*harmfreq1(iOsc)
    GE2 = GE2+Half*harmfreq2(iOsc)
  end if
end do
T0 = GE2-GE1

! Pick out the chosen modes.
nOscOld = nOsc
nOsc = l_NormModes
call mma_allocate(Lambda,nOsc,label='Lambda')
call mma_allocate(Base,nOscOld,nOsc,label='Base')
call mma_allocate(BaseInv,nOsc,nOscOld,label='BaseInv')
do jOsc=1,nOsc
  nm = NormModes(jOsc)
  do iOsc=1,nOscOld
    Base(iOsc,jOsc) = W2(iOsc,nm)
    BaseInv(jOsc,iOsc) = C2(nm,iOsc)
  end do
end do

call mma_allocate(temp1,nOscOld,nOsc,label='temp1')
call mma_allocate(temp2,nOscOld,nOscOld,label='temp2')

! First state.
! Subroutine SolveRedSec(Hess,Gmat,freq,C,W,det)
call DGEMM_('N','N',nOscOld,nOsc,nOscOld,One,Hess1,nOscOld,Base,nOscOld,Zero,temp1,nOscOld)
call mma_deallocate(Hess1)

call mma_allocate(Hess1,nOsc,nOsc,label='Hess1')
call DGEMM_('T','N',nOsc,nOsc,nOscOld,One,Base,nOscOld,temp1,nOscOld,Zero,Hess1,nOsc)
temp2(:,:) = Zero
do i=1,nOscOld
  temp2(i,i) = One
end do
call Dool_MULA(G1,nOsc,nOsc,temp2,nOscOld,nOscOld,det)
call DGEMM_('N','N',nOscOld,nOsc,nOscOld,One,temp2,nOscOld,Base,nOscOld,Zero,temp1,nOscOld)
call DGEMM_('T','N',nOsc,nOsc,nOscOld,One,Base,nOscOld,temp1,nOscOld,Zero,temp,nOsc)
G1(:,:) = Zero
do i=1,nOsc
  G1(i,i) = One
end do
call Dool_MULA(temp,nOscOld,nOscOld,G1,nOsc,nOsc,det)
call SolveSecEq(Hess1,nOsc,temp,G1,Lambda)
do iv=1,nOsc
  harmfreq1(iv) = sqrt(abs(Lambda(iv)))
end do
if (iPrint >= 1) call WriteFreq(harmfreq1,NormModes,l_NormModes,'Frequencies of reduced problem, state 1')
do jOsc=1,nOsc
  W1(:,jOsc) = temp(:,jOsc)/sqrt(harmfreq1(jOsc))
end do
C1(:,:) = Zero
do i=1,nOsc
  C1(i,i) = One
end do
temp(:,:) = W1
call Dool_MULA(temp,nOscOld,nOsc,C1,nOsc,nOsc,det)
det1 = abs(One/det)

! Second state.
call DGEMM_('N','N',nOscOld,nOsc,nOscOld,One,Hess2,nOscOld,Base,nOscOld,Zero,temp1,nOscOld)
call mma_deallocate(Hess2)

call mma_allocate(Hess2,nOsc,nOsc,label='Hess2')
call DGEMM_('T','N',nOsc,nOsc,nOscOld,One,Base,nOscOld,temp1,nOscOld,Zero,Hess2,nOsc)
temp2(:,:) = Zero
do i=1,nOscOld
  temp2(i,i) = One
end do
call Dool_MULA(G2,nOsc,nOsc,temp2,nOscOld,nOscOld,det)
call DGEMM_('N','N',nOscOld,nOsc,nOscOld,One,temp2,nOscOld,Base,nOscOld,Zero,temp1,nOscOld)
call DGEMM_('T','N',nOsc,nOsc,nOscOld,One,Base,nOscOld,temp1,nOscOld,Zero,temp,nOsc)
G2(:,:) = Zero
do i=1,nOsc
  G2(i,i) = One
end do
call Dool_MULA(temp,nOsc,nOsc,G2,nOsc,nOsc,det)
call SolveSecEq(Hess2,nOsc,temp,G2,Lambda)
do iv=1,nOsc
  harmfreq2(iv) = sqrt(abs(Lambda(iv)))
end do
if (iPrint >= 1) call WriteFreq(harmfreq2,NormModes,l_NormModes,'Frequencies of reduced problem, state 2')
do jOsc=1,nOsc
  W2(:,jOsc) = temp(:,jOsc)/sqrt(harmfreq2(jOsc))
end do
C2(:,:) = Zero
do i=1,nOsc
  C2(i,i) = One
end do
temp(:,:) = W2
call Dool_MULA(temp,nOsc,nOsc,C2,nOsc,nOsc,det)
det2 = abs(One/det)

call mma_deallocate(temp)
call mma_deallocate(temp1)
call mma_deallocate(temp2)

call mma_allocate(rtemp,nOscOld,label='rtemp')

rtemp(:) = r01
call DGEMM_('N','N',nOsc,1,nOscOld,One,BaseInv,nOsc,rtemp,nOscOld,Zero,r01,nOsc)

rtemp(:) = r02
call DGEMM_('N','N',nOsc,1,nOscOld,One,BaseInv,nOsc,rtemp,nOscOld,Zero,r02,nOsc)

call mma_deallocate(rtemp)

call mma_allocate(r00,nOsc,label='r00')
call mma_allocate(alpha1,nOsc,nOsc,label='alpha1')
call mma_allocate(alpha2,nOsc,nOsc,label='alpha2')
call Calc_r00(C1,C2,C,W,alpha1,alpha2,r00,r01,r02,det0,det1,det2,FC00,nOsc)
call mma_deallocate(alpha1)
call mma_deallocate(alpha2)

!Base2(:,:) = W2
!BaseInv2(:,:) = C2

!----------------------------------------------------------------------!

!Transform transition dipole gradients from cartesian to internal coordinates

!----------------------------------------------------------------------!

if (Forcefield .and. (max_dip > 0)) then
  call mma_allocate(Bmat,3*NumOfAt,nOscOld,label='Bmat')
  Bmat(:,:) = Zero
  call CalcS(AtCoord,InterVec,Bmat,nOscOld,NumOfAt)

  call mma_allocate(temp,nOscOld,nOscOld,label='temp')
  call mma_allocate(temp2,nOscOld,nOscOld,label='temp2')

  call DGEMM_('T','N',nOscOld,nOscOld,3*NumOfAt,One,Bmat,3*NumOfAt,Bmat,3*NumOfAt,Zero,temp,nOscOld)
  temp2(:,:) = Zero
  do i=1,nOscOld
    temp2(i,i) = One
  end do
  call Dool_MULA(temp,nOscOld,nOscOld,temp2,nOscOld,nOscOld,det)
  call mma_deallocate(temp)
  call mma_allocate(temp1,3*NumOfAt,nOscOld,label='temp1')

  call DGEMM_('N','N',3*NumOfAt,nOscOld,nOscOld,One,Bmat,3*NumOfAt,temp2,nOscOld,Zero,temp1,3*NumOfAt)
  call mma_deallocate(Bmat)
  call mma_deallocate(temp2)
  call mma_allocate(temp2,3*NumOfAt,nOsc,label='temp2')
  call DGEMM_('N','N',3*NumOfAt,nOsc,nOscOld,One,temp1,3*NumOfAt,Base,nOscOld,Zero,temp2,3*NumOfAt)
  call mma_deallocate(temp1)
  call mma_allocate(temp1,3*NumOfAt,nOsc,label='temp1')
  call DGEMM_('N','N',3*NumOfAt,nOsc,nOsc,One,temp2,3*NumOfAt,W,nOsc,Zero,temp1,3*NumOfAt)
  call mma_deallocate(temp2)
  call mma_allocate(TranDipGradInt,3,nOsc,label='TranDipGradInt')
  call DGEMM_('T','N',nOsc,1,3*NumOfAt,One,temp1,3*NumOfAt,TranDipGrad(1,1),3*NumOfAt,Zero,TranDipGradInt(1,1),nOsc)
  call DGEMM_('T','N',nOsc,1,3*NumOfAt,One,temp1,3*NumOfAt,TranDipGrad(2,1),3*NumOfAt,Zero,TranDipGradInt(2,1),nOsc)
  call DGEMM_('T','N',nOsc,1,3*NumOfAt,One,temp1,3*NumOfAt,TranDipGrad(3,1),3*NumOfAt,Zero,TranDipGradInt(3,1),nOsc)
  call mma_deallocate(temp1)

  call WriteDip(TranDipGradInt,NormModes,'Transition dipole gradient',nOsc)
end if

call mma_deallocate(eigenVec1)
call mma_deallocate(eigenVec2)
call mma_deallocate(Lambda)

!----------------------------------------------------------------------!

!  InterSystem Crossing section.
!  Author: Giovanni Ghigo
!          Dip. Chimica Generale e Chimica Organica, Torino (ITALY)
!          Vers. 1  28 Dec-08 - 13 Jan-09

!----------------------------------------------------------------------!

if (iPrint >= 4) write(u6,*) ' FC(0-0)=',FC00
if (lISC) then

  iPrint = iPrint_Save
  if (WriteVibLevels) iPrint = 2
  if (Huge_Print) iPrint = 3
  if (iPrint >= 1) call ISCHeader()

  dRho = Zero
  call mma_allocate(nMaxQ,nOsc,label='nMaxQ')
  call ISC_Rho(iPrint,nOsc,new_n_max,dRho,energy1,energy2,minQ,dMinWind,nMaxQ,harmfreq1,harmfreq2)
  if (new_n_max < n_max) then
    n_max = new_n_max
    write(u6,*) ' n_max reduced to',n_max
  end if
  if (iPrint >= 3) write(u6,*) ' Actual n_max               =',n_max

  ! Set up excitation matrices

  ! Initial State m
  call TabDim(m_max,nOsc,nvTabDim)
  mTabDim = nvTabDim-1
  max_mOrd = mTabDim
  call TabDim(m_max-1,nOsc,nvTabDim)
  max_mInc = nvTabDim-1
  call mma_allocate(mMat,[0,mTabDim],[1,nOsc],label='mMat')
  call mma_allocate(mInc,[0,mTabDim],[1,nOsc],label='mInc')
  call mma_allocate(mDec,[0,mTabDim],[1,nOsc],label='mDec')
  mdim1 = mTabDim
  mdim2 = nOsc
  call MakeTab2(m_max,max_mOrd,max_mInc,mTabDim,mMat,mInc,mDec,nOsc)

  ! Initialize Final State n
  call TabDim(n_max,nOsc,nvTabDim)
  nTabDim = nvTabDim-1
  max_nOrd = nTabDim
  call TabDim(n_max-1,nOsc,nvTabDim)
  max_nInc = nvTabDim-1

  ! Memory estimation and algorithm selection
  call mma_maxINT(lLeft)
  if (lInCore) then
    if (lOldCode) then
      iMem = 7*(nTabDim+1)*nOsc/2
      if (iMem >= lLeft) then
        write(u6,*) ' Too much memory required (',iMem,' words).'
        write(u6,*) ' Switch to reduced matrices evaluation.'
        lOldCode = .false.
      end if
    else
      iMem = 3*(nTabDim+1)*nOsc/2
      if (iMem >= lLeft) then
        write(u6,*) ' Too much memory required (',iMem,' words).'
        write(u6,*) ' Out-of-Core (disk) algorithm will be used.'
        lInCore = .false.
      end if
    end if
  end if

  call Timing(CPTF0,CPE,TIOTF0,TIOE)
  if (lInCore) then

    if (lOldCode) then
      if (iPrint >= 2) then
        write(u6,*)
        write(u6,*) ' Index matrix evaluation.'
        if (iPrint >= 3) write(u6,*) ' Memory allocated for all index matrix:',iMem,' words,  ',iMem*ItoB/MB,' MB.'
        call XFlush(u6)
      end if
      call mma_allocate(nMat,[0,nTabDim],[1,nOsc],label='nMat')
      call mma_allocate(nInc,[0,nTabDim],[1,nOsc],label='nInc')
      call mma_allocate(nDec,[0,nTabDim],[1,nOsc],label='nDec')
      ndim1 = nTabDim
      ndim2 = nOsc
      call MakeTab2(n_max,max_nOrd,max_nInc,nTabDim,nMat,nInc,nDec,nOsc)
    else ! NewCode: nInc & nDec reduced
      iMem = (nTabDim+1)*nOsc
      if (iPrint >= 2) then
        write(u6,*)
        write(u6,*) ' First index matrix evaluation.'
        if (iPrint >= 3) write(u6,*) ' Memory allocated for first index matrix:',iMem,' words,  ',iMem*ItoB/MB,' MB.'
        call XFlush(u6)
      end if
      call mma_allocate(nMat,[0,nTabDim],[1,nOsc],label='nMat')
      call mma_allocate(Graph1,[0,n_max],[1,nOsc+1],label='Graph1')
      call mma_allocate(Graph2,[0,n_max],[0,n_max],[1,nOsc],label='Graph2')
      ndim1 = nTabDim
      ndim2 = nOsc
      call ISC_MakeTab2(n_max,max_nOrd,nTabDim,nMat,Graph1,Graph2,nOsc)
      call mma_deallocate(Graph1)
    end if
    call Timing(CPTF1,CPE,TIOTF1,TIOE)

    ! Definition of Vector with levels in the window

    if (iPrint >= 2) then
      write(u6,*)
      write(u6,*) ' Energy level screening.'
      call XFlush(u6)
    end if
    call mma_allocate(lVec,[0,nTabDim],label='lVec')
    call LogEVec(iPrint,nOsc,max_nOrd,minQ,nMaxQ,nMat,lVec,nYes)
    if (nYes <= 0) then
      write(u6,*)
      write(u6,*) ' ************ ERROR *************'
      write(u6,*) ' No energy levels in the Window !'
      write(u6,*) ' ********************************'
      write(u6,*)
      call Quit_OnUserError()
    end if
    call Timing(CPTF2,CPE,TIOTF2,TIOE)

    ! Energy levels calculation

    if (iPrint >= 2) then
      write(u6,*)
      write(u6,*) ' Energy level calculation.'
      if (iPrint >= 3) then
        write(u6,*) ' Memory allocated for energy matrix:',(nTabDim+1),' words,  ',(nTabDim+1)*ItoB/MB,' MB.'
      end if
      call XFlush(u6)
    end if
    call ISC_Ene(iPrint,nOsc,max_nOrd,nYes,nMat,nTabDim,GE1,GE2,harmfreq1,harmfreq2,x_anharm1,x_anharm2,dMinWind,dRho,lVec)
    if (nYes <= 0) then
      write(u6,*)
      write(u6,*) ' ************ ERROR *************'
      write(u6,*) ' No energy levels in the Window !'
      write(u6,*) ' ********************************'
      write(u6,*)
      if (iPrint < 4) call Quit_OnUserError()
    end if

    ! The State Window

    call mma_allocate(VibWind2,nYes,label='VibWind2')
    call MkVibWind2(nYes,iMaxYes,max_nOrd,lVec,VibWind2)
    call mma_deallocate(lVec)
    call Timing(CPTF3,CPE,TIOTF3,TIOE)
    call Timing(CPTF4,CPE,TIOTF4,TIOE)

    ! The remaining excitation matrices nInc & nDec

    if (lOldCode) then
      iMaxYes = nTabDim
    else
      iMem = 2*(iMaxYes+1)*nOsc
      if (iPrint >= 2) then
        write(u6,*)
        write(u6,*) ' nInc and nDec matrices generation.'
        if (iPrint >= 3) write(u6,*) ' Memory allocated for remaining index matrix:',iMem,' words,  ',iMem*ItoB/MB,' MB.'
        call XFlush(u6)
      end if
      call mma_allocate(nInc,[0,iMaxYes],[1,nOsc],label='nInc')
      call mma_allocate(nDec,[0,iMaxYes],[1,nOsc],label='nDec')
      call Mk_nIncDec(n_max,nTabDim,iMaxYes,nInc,nDec,nMat,Graph2,nOsc)
      call mma_deallocate(Graph2)
    end if
    call Timing(CPTF5,CPE,TIOTF5,TIOE)

    ! The ISC rate

    if (iPrint >= 2) then
      write(u6,*)
      write(u6,*) ' Franck-Condon factors evaluation.'
      call XFlush(u6)
    end if
    call ISC_Rate(iPrint,nOsc,max_nOrd,iMaxYes,nYes,dMinWind,VibWind2,C1,C2,W2,det0,det1,det2,C,W,r01,r02,nTabDim,nMat,nInc,nDec, &
                  m_max,n_max,FC00,dRho)
    call Timing(CPTF6,CPE,TIOTF6,TIOE)

    call mma_deallocate(VibWind2)

    call mma_deallocate(nMat)
    call mma_deallocate(nInc)
    call mma_deallocate(nDec)

  else ! Out-of-core.

    !GGt --- Out-of-core ---------------------------------------------------

    ! Open files

    filnam = 'MAT0'
    call DaName_mf_wa(lNMAT0,filnam)

    call mma_allocate(Graph1,[0,n_max],[1,nOsc+1],label='Graph1')
    call mma_allocate(Graph2,[0,n_max],[0,n_max],[1,nOsc],label='Graph2')
    call ISCD_MakeGraphs(n_max,max_nOrd,Graph1,Graph2,nOsc)
    call mma_deallocate(Graph1)
    call mma_allocate(nnTabDim,[0,nTabDim],label='nnTabDim')
    call mma_allocate(nMat0,nOsc,label='nMat0')
    if (iPrint >= 2) then
      write(u6,*)
      write(u6,*) ' Index matrix evaluation.'
      if (iPrint >= 3) then
        write(u6,*) ' Memory allocated for address array:',(nTabDim+1),' words,  ',(nTabDim+1)*ItoB/MB,' MB.'
      end if
      call XFlush(u6)
    end if
    call ISCD_MakenMat(n_max,nOsc,lNMAT0,nTabDim,Graph2,nnTabDim,nMat0)
    call Timing(CPTF1,CPE,TIOTF1,TIOE)

    ! Definition of Vector with levels in the window

    if (iPrint >= 2) then
      write(u6,*)
      write(u6,*) ' Energy level screening.'
      call XFlush(u6)
    end if
    call mma_allocate(lVec,[0,nTabDim],label='lVec')
    call ISCD_LogEVec(iPrint,nOsc,max_nOrd,minQ,nYes,lNMAT0,nTabDim,nnTabDim,nMaxQ,nMat0,lVec)
    if (nYes <= 0) then
      write(u6,*)
      write(u6,*) ' ************ ERROR *************'
      write(u6,*) ' No energy levels in the Window !'
      write(u6,*) ' ********************************'
      write(u6,*)
      call Quit_OnUserError()
    end if
    call Timing(CPTF2,CPE,TIOTF2,TIOE)

    ! Energy levels calculation

    if (iPrint >= 2) then
      write(u6,*)
      write(u6,*) ' Energy level calculation.'
      if (iPrint >= 3) then
        write(u6,*) ' Memory allocated for energy matrix:',(nTabDim+1),' words,  ',(nTabDim+1)*ItoB/MB,' MB.'
      end if
      call XFlush(u6)
    end if
    call ISCD_Ene(iPrint,nOsc,max_nOrd,nYes,lNMAT0,nTabDim,GE1,GE2,harmfreq1,harmfreq2,x_anharm1,x_anharm2,dMinWind,dRho,nMat0, &
                  nnTabDim,lVec)
    if (nYes <= 0) then
      write(u6,*)
      write(u6,*) ' ************ ERROR *************'
      write(u6,*) ' No energy levels in the Window !'
      write(u6,*) ' ********************************'
      write(u6,*)
      if (iPrint < 4) call Quit_OnUserError()
    end if

    ! The State Window

    call mma_allocate(VibWind2,nYes,label='VibWind2')
    call MkVibWind2(nYes,iMaxYes,max_nOrd,lVec,VibWind2)
    call mma_deallocate(lVec)
    call Timing(CPTF3,CPE,TIOTF3,TIOE)

    ! Memory estimation & nMat transfer

    if (lOldCode) then
      iMaxYes = nTabDim
    end if
    call mma_maxINT(lLeft)
    if (iPrint >= 3) then
      write(u6,'(A,I10,A,I4,A)') '  Available memory                          :',lLeft,' words,  ',lLeft*iToB/MB,' MB.'
    end if
    iUMem = nTabDim+1  ! Memory for U, 1=> No Hot states
    iRateMem = iUMem+nTabDim+2+13*nOsc*nOsc+5*nOsc
    iRateMem = int(2.1_wp*iRateMem) ! to convert from INTE to REAL
    lLeft = lLeft-iRateMem
    if (iRateMem < 0) then ! .or. (iRateMem > 2048*MB/ItoB)) then
      write(u6,'(A,I10,A,I4,A)') '  Estimated memory for FC factors evaluation:',iRateMem,' words,  ',iRateMem*ItoB/MB,' MB.'
      write(u6,'(A,I10,A,I4,A)') '  Memory left for batches                   :',lLeft,' words,  ',lLeft*ItoB/MB,' MB.'
      write(u6,*)
      write(u6,*) ' ****************** ERROR ********************'
      write(u6,*) ' Not enough memory for FC factors evaluation !'
      write(u6,*) ' *********************************************'
      write(u6,*)
      call Quit_OnUserError()
    end if
    lMBatch = int(lLeft/3)
    lMBatch = min(lMBatch,512*MB/ItoB) ! Max 512 MB
    lMBatch = max(lMBatch,64*MB/ItoB)  ! Min  64 MB
    !GGt lMBatch = MB  ! Test only !!!!
    lBatch = int(lMBatch/nOsc)
    if (lBatch > (iMaxYes+1)) lBatch = (iMaxYes+1)
    lMBatch = lBatch*nOsc
    nBatch = int((iMaxYes+1)/lBatch)
    leftBatch = (iMaxYes+1)-nBatch*lBatch
    if (nBatch+1 > maxMax_n) then
      write(u6,*)
      write(u6,*) ' ******************** ERROR *******************'
      write(u6,*) ' Not enough number of batches for Out-of-core !'
      write(u6,*) ' Increase maxMax_n in src/mula/io_mula.fh'
      write(u6,*) ' **********************************************'
      write(u6,*)
      call Quit_OnUserError()
    end if
    if (iPrint >= 2) then
      write(u6,*)
      if (iPrint >= 3) then
        write(u6,'(A,I10,A,I4,A)') '  Estimated memory for FC factors evaluation:',iRateMem,' words,  ',iRateMem*ItoB/MB,' MB.'
        write(u6,'(A,I10,A,I4,A)') '  Memory left for batches                   :',lLeft,' words,  ',lLeft*ItoB/MB,' MB.'
        write(u6,'(A,I10,A,I4,A)') '  Memory allocated for batch                :',lMBatch,' words,  ',lMBatch*ItoB/MB,' MB.'
        write(u6,'(A,I8)') '  * Elements for batch:',lBatch
        write(u6,'(A,I8,A,I8,A)') '  * Number of batches :',nBatch,' (',lBatch*nBatch,' elements)'
        write(u6,'(A,I8)') '  * Residual elements :',leftBatch
      end if
      write(u6,*) ' Index matrix reloading.'
      call XFlush(u6)
    end if

    call mma_allocate(nIndex,[1,3],[0,maxMax_n],label='nIndex')
    nIndex(:,:) = 0

    filnam = 'NMAT'
    call DaName_mf_wa(lNMAT,filnam)
    call mma_allocate(nMat,nOsc,lBatch,label='nMat')
    call ISCD_ReloadNMAT(nTabDim,iMaxYes,nOsc,lNMAT0,lNMAT,lBatch,nBatch,leftBatch,nIndex,nnTabDim,nMAT0,nMAT)
    call mma_deallocate(nMat0)
    call Timing(CPTF4,CPE,TIOTF4,TIOE)

    ! The remaining excitation matrices nInc & nDec

    if (iPrint >= 2) then
      write(u6,*)
      write(u6,*) ' nInc and nDec matrices generation.'
      call XFlush(u6)
    end if
    filnam = 'NINC'
    call DaName_mf_wa(lNINC,filnam)
    filnam = 'NDEC'
    call DaName_mf_wa(lNDEC,filnam)
    call mma_allocate(nInc,nOsc,lBatch,label='nInc')
    call mma_allocate(nDec,nOsc,lBatch,label='nDec')
    call ISCD_MakenIncDec(n_max,iMaxYes,nOsc,lNMAT,lNINC,lNDEC,lBatch,nBatch,leftBatch,nIndex,Graph2,nMAT,nInc,nDec)
    call mma_deallocate(Graph2)
    call Timing(CPTF5,CPE,TIOTF5,TIOE)

    ! The ISC rate

    if (iPrint >= 2) then
      write(u6,*)
      write(u6,*) ' Franck-Condon factors evaluation.'
      call XFlush(u6)
    end if
    call ISCD_Rate(iPrint,nOsc,max_nOrd,iMaxYes,nYes,dMinWind,lBatch,nIndex,VibWind2,lNMAT0,lNMAT,lNINC,lNDEC,nTabDim,nnTabDim,C1, &
                   C2,W2,det0,det1,det2,C,W,r01,r02,m_max,n_max,FC00,dRho,nMat,nInc,nDec)
    call Timing(CPTF6,CPE,TIOTF6,TIOE)

    call mma_deallocate(nIndex)
    call mma_deallocate(VibWind2)

    call mma_deallocate(nMat)
    call mma_deallocate(nInc)
    call mma_deallocate(nDec)
    call mma_deallocate(nnTabDim)

    call DaClos(lNDEC)
    call DaClos(lNINC)
    call DaClos(lNMAT)
    call DaClos(lNMAT0)

  end if

  if (iPrint >= 3) then
    write(u6,*)
    write(u6,'(A)') ' Timing informations (sec.):'
    write(u6,'(A)') ' ========================================='
    write(u6,'(A)') ' MODULE:                       CPU Elapsed'
    write(u6,'(A,2F8.2)') ' Matrix evaluation        ',CPTF1-CPTF0,TIOTF1-TIOTF0
    write(u6,'(A,2F8.2)') ' Level screening          ',CPTF2-CPTF1,TIOTF2-TIOTF1
    write(u6,'(A,2F8.2)') ' Energy calculation       ',CPTF3-CPTF2,TIOTF3-TIOTF2
    write(u6,'(A,2F8.2)') ' Matrix reloading         ',CPTF4-CPTF3,TIOTF4-TIOTF3
    write(u6,'(A,2F8.2)') ' nInc and nDec generation ',CPTF5-CPTF4,TIOTF5-TIOTF4
    write(u6,'(A,2F8.2)') ' Franck-Condon evaluation ',CPTF6-CPTF5,TIOTF6-TIOTF5
    write(u6,'(A,2F8.2)') ' TOTAL                    ',CPTF6-CPTF0,TIOTF6-TIOTF0
    write(u6,'(A)') ' -----------------------------------------'
    write(u6,*)
  end if

  call mma_deallocate(mMat)
  call mma_deallocate(mInc)
  call mma_deallocate(mDec)

  call mma_deallocate(nMaxQ)

  call mma_deallocate(r00)
  call mma_deallocate(r01)
  call mma_deallocate(r02)

  call mma_deallocate(Hess1)
  call mma_deallocate(Hess2)

  call mma_deallocate(Base)
  call mma_deallocate(BaseInv)

  call mma_deallocate(C)
  call mma_deallocate(C1)
  call mma_deallocate(C2)
  call mma_deallocate(W)
  call mma_deallocate(W1)
  call mma_deallocate(W2)

  call mma_deallocate(AtCoord)

  call mma_deallocate(Gprm1)
  call mma_deallocate(Gprm2)
  call mma_deallocate(Gbis1)
  call mma_deallocate(Gbis2)

  call mma_deallocate(x_anharm1)
  call mma_deallocate(x_anharm2)
  call mma_deallocate(harmfreq1)
  call mma_deallocate(harmfreq2)

  call mma_deallocate(G1)
  call mma_deallocate(G2)

  call mma_deallocate(r0)
  call mma_deallocate(r1)
  call mma_deallocate(r2)

  call mma_deallocate(m_plot)
  call mma_deallocate(n_plot)

  call mma_deallocate(NormModes)
  call mma_deallocate(TranDipGrad)

  lISC = .false.

else
  !GGn -----------------------------------------------------------------

  !--------------------------------------------------------------------!

  ! Set up excitation matrices

  !--------------------------------------------------------------------!

  call mma_allocate(G0,nOsc,nOsc,label='G0')
  call mma_allocate(Gprm0,ngdim,ngdim,ngdim,label='Gprm0')
  call mma_allocate(Gbis0,ngdim,ngdim,ngdim,ngdim,label='Gbis0')

  ! Calculate dimensions given max level of excitation for the different states.
  call TabDim(m_max,nOsc,nvTabDim)
  mTabDim = nvTabDim-1
  call TabDim(n_max,nOsc,nvTabDim)
  nTabDim = nvTabDim-1

  ! Set up mMat for L.
  max_mOrd = mTabDim
  call TabDim(m_max-1,nOsc,nvTabDim)
  max_mInc = nvTabDim-1

  call mma_allocate(mMat,[0,mTabDim],[1,nOsc],label='mMat')
  call mma_allocate(mInc,[0,mTabDim],[1,nOsc],label='mInc')
  call mma_allocate(mDec,[0,mTabDim],[1,nOsc],label='mDec')
  ! Put dimensions into common block:
  mdim1 = mTabDim
  mdim2 = nOsc
  call MakeTab2(m_max,max_mOrd,max_mInc,mTabDim,mMat,mInc,mDec,nOsc)

  ! Set up nMat for U.
  max_nOrd = nTabDim
  call TabDim(n_max-1,nOsc,nvTabDim)
  max_nInc = nvTabDim-1

  call mma_allocate(nMat,[0,nTabDim],[1,nOsc],label='nMat')
  call mma_allocate(nInc,[0,nTabDim],[1,nOsc],label='nInc')
  call mma_allocate(nDec,[0,nTabDim],[1,nOsc],label='nDec')
  ! Put dimensions into common block:
  ndim1 = nTabDim
  ndim2 = nOsc
  call MakeTab2(n_max,max_nOrd,max_nInc,nTabDim,nMat,nInc,nDec,nOsc)

  if (.not. MatEl) then
    l_TermMat_1 = max_mOrd
    l_TermMat_2 = max_nOrd
    call mma_allocate(TermMat,[0,l_TermMat_1],[0,l_TermMat_2],label='TermMat')
    call mma_allocate(level1,nOsc,label='level1')
    call mma_allocate(level2,nOsc,label='level2')
    do jOrd=0,max_nOrd
      level2(:) = nMat(jOrd,:)
      do iOrd=0,max_mOrd
        level1(:) = mMat(iOrd,:)
        l_harm = nOsc
        call TransEnergy(GE1,x_anharm1,harmfreq1,level1,GE2,x_anharm2,harmfreq2,level2,TermMat(iOrd,jOrd),l_harm)
      end do
    end do
    call mma_deallocate(level1)
    call mma_deallocate(level2)

  end if

  !--------------------------------------------------------------------!

  ! Calculate vibrational Hessian if a variational calculation is chosen

  !--------------------------------------------------------------------!

  l_l = 1
  call mma_allocate(U1,l_l,l_l,label='U1')
  call mma_allocate(E1,l_l,label='E1')
  call mma_allocate(U2,l_l,l_l,label='U2')
  call mma_allocate(E2,l_l,label='E2')
  call mma_allocate(OccNumMat1,l_l,l_l,l_l,label='OccNumMat1')
  call mma_allocate(OccNumMat2,l_l,l_l,l_l,label='OccNumMat2')
  if (MatEl) then  ! START: Vibrational Hessian (variational)

    if (Forcefield) then
      nDimTot = max_mOrd+1
    else
      nDimTot = 2*max_mOrd+2
    end if
    l_l = nDimTot

    call mma_allocate(H1,nDimTot,nDimTot,label='H1')
    call mma_allocate(H2,nDimTot,nDimTot,label='H2')
    call mma_allocate(S1,nDimTot,nDimTot,label='S1')
    call mma_allocate(S2,nDimTot,nDimTot,label='S2')

    H1(:,:) = Zero
    S1(:,:) = Zero
    H2(:,:) = Zero
    S2(:,:) = Zero

    ! Calculate inverse mass tensor and its derivatives in r0.
    call mma_allocate(Smat,3*NumOfAt,nOscOld,label='Smat')
    Smat(:,:) = Zero
    !call Int_To_Cart(InterVec,r0,AtCoord,NumOfAt,nOscOld,Mass)
    l_a = NumOfAt
    call Int_To_Cart1(InterVec,r0,AtCoord,l_a,nOsc)
    call CalcS(AtCoord,InterVec,Smat,nOscold,NumOfAt)
    call CalcG(G0,Mass,Smat,nOscold,NumOfAt)
    call mma_deallocate(Smat)
    if (max_term > 2) then
      dh = 1.0e-3_wp
      call CalcGprime(Gprm0,Mass,r0,InterVec,AtCoord,NumOfAt,dh,nOsc)
      dh = 1.0e-2_wp
      call CalcGdblePrime(Gbis0,Mass,r0,InterVec,AtCoord,NumOfAt,dh,nOsc)

      call mma_allocate(T4,nOscOld**4,label='T4')
      call DGEMM_('T','T',nOscOld**2,nOsc,nOscOld,One,Gprm2,nOscOld,BaseInv,nOsc,Zero,T4,nOscOld**2)
      call DGEMM_('T','T',nOsc*nOscOld,nOsc,nOscOld,One,T4,nOscOld,BaseInv,nOsc,Zero,Gprm2,nOsc*nOscOld)
      call DGEMM_('T','N',nOsc**2,nOsc,nOscOld,One,Gprm2,nOscOld,Base,nOscOld,Zero,T4,nOsc**2)
      call dcopy_(nOsc**3,T4,1,Gprm2,1)

      call DGEMM_('T','T',nOscOld**3,nOsc,nOscOld,One,Gbis2,nOscOld,BaseInv,nOsc,Zero,T4,nOscOld**3)
      call DGEMM_('T','T',nOsc*nOscOld**2,nOsc,nOscOld,One,T4,nOscOld,BaseInv,nOsc,Zero,Gbis2,nOsc*nOscOld**2)
      call DGEMM_('T','N',nOsc**2*nOscOld,nOsc,nOscOld,One,Gbis2,nOscOld,Base,nOscOld,Zero,T4,nOsc**2*nOscOld)
      call DGEMM_('T','N',nOsc**3,nOsc,nOscOld,One,T4,nOscOld,Base,nOscOld,Zero,Gbis2,nOsc**3)
      call DGEMM_('T','T',nOscOld**2,nOsc,nOscOld,One,Gprm1,nOscOld,BaseInv,nOsc,Zero,T4,nOscOld**2)
      call DGEMM_('T','T',nOsc*nOscOld,nOsc,nOscOld,One,T4,nOscOld,BaseInv,nOsc,Zero,Gprm1,nOsc*nOscOld)
      call DGEMM_('T','N',nOsc**2,nOsc,nOscOld,One,Gprm1,nOscOld,Base,nOscOld,Zero,T4,nOsc**2)
      call dcopy_(nOsc**3,T4,1,Gprm1,1)

      call DGEMM_('T','T',nOscOld**3,nOsc,nOscOld,One,Gbis1,nOscOld,BaseInv,nOsc,Zero,T4,nOscOld**3)
      call DGEMM_('T','T',nOsc*nOscOld**2,nOsc,nOscOld,One,T4,nOscOld,BaseInv,nOsc,Zero,Gbis1,nOsc*nOscOld**2)
      call DGEMM_('T','N',nOsc**2*nOscOld,nOsc,nOscOld,One,Gbis1,nOscOld,Base,nOscOld,Zero,T4,nOsc**2*nOscOld)
      call DGEMM_('T','N',nOsc**3,nOsc,nOscOld,One,T4,nOscOld,Base,nOscOld,Zero,Gbis1,nOsc**3)
      call DGEMM_('T','T',nOscOld**2,nOsc,nOscOld,One,Gprm0,nOscOld,BaseInv,nOsc,Zero,T4,nOscOld**2)
      call DGEMM_('T','T',nOsc*nOscOld,nOsc,nOscOld,One,T4,nOscOld,BaseInv,nOsc,Zero,Gprm0,nOsc*nOscOld)
      call DGEMM_('T','N',nOsc**2,nOsc,nOscOld,One,Gprm0,nOscOld,Base,nOscOld,Zero,T4,nOsc**2)
      call dcopy_(nOsc**3,T4,1,Gprm0,1)

      call DGEMM_('T','T',nOscOld**3,nOsc,nOscOld,One,Gbis0,nOscOld,BaseInv,nOsc,Zero,T4,nOscOld**3)
      call DGEMM_('T','T',nOsc*nOscOld**2,nOsc,nOscOld,One,T4,nOscOld,BaseInv,nOsc,Zero,Gbis0,nOsc*nOscOld**2)
      call DGEMM_('T','N',nOsc**2*nOscOld,nOsc,nOscOld,One,Gbis0,nOscOld,Base,nOscOld,Zero,T4,nOsc**2*nOscOld)
      call DGEMM_('T','N',nOsc**3,nOsc,nOscOld,One,T4,nOscOld,Base,nOscOld,Zero,Gbis0,nOsc**3)
      call mma_deallocate(T4)
    end if
    call mma_allocate(temp,nOscOld,nOscOld,label='temp')
    call mma_allocate(temp2,nOscOld,nOscOld,label='temp2')

    temp(:,:) = G0
    temp2(:,:) = Zero
    do i=1,nOscOld
      temp2(i,i) = One
    end do
    call Dool_MULA(temp,nOscOld,nOscOld,temp2,nOscOld,nOscOld,det)
    call DGEMM_('N','N',nOscOld,nOsc,nOscOld,One,temp2,nOscOld,Base,nOscOld,Zero,temp,nOscOld)
    call mma_deallocate(temp2)
    call mma_allocate(temp1,nOsc,nOsc,label='temp1')
    call DGEMM_('T','N',nOsc,nOsc,nOscOld,One,Base,nOscOld,temp,nOscOld,Zero,temp1,nOsc)
    G0(:,:) = Zero
    do i=1,nOsc
      G0(i,i) = One
    end do
    call Dool_MULA(temp1,nOsc,nOsc,G0,nOsc,nOsc,det)

    call mma_deallocate(temp)
    call mma_deallocate(temp1)

    ! Set up Hamilton matrix for the first state.
    if (Forcefield) then
      call mma_allocate(Base2,nOsc,nOsc,label='Base2')
      Base2(:,:) = Zero
      do i=1,nOsc
        Base2(i,i) = One
      end do

      call SetUpHmat2(energy1,C1,W1,det1,r01,max_mOrd,max_nOrd,max_mInc,max_nInc,mMat,nMat,mInc,nInc,mDec,nDec,H1,S1,Hess1,G1, &
                      Base2,nDimTot,nOsc)
      call SolveSecEq(H1,nDimTot,U1,S1,E1)
      write(u6,'(20f10.1)') ((E1(i)-E1(1))*auTocm,i=2,nOsc)
      call SetUpHmat2(energy1,C2,W2,det2,r01,max_mOrd,max_nOrd,max_nInc,max_nInc,mMat,nMat,mInc,nInc,mDec,nDec,H2,S2,Hess2,G2, &
                      Base2,nDimTot,nOsc)
      call SolveSecEq(H2,nDimTot,U2,S2,E2)
      write(u6,'(20f10.1)') ((E2(i)-E2(1))*auTocm,i=2,nOsc)
    else
      call SetUpHmat(energy1,r1,ipow,var,yin1,trfName1,max_term,C1,W1,det1,r01,C2,W2,det2,r02,max_mOrd,max_nOrd,max_nOrd,max_mInc, &
                     max_nInc,max_nInc,mMat,nMat,mInc,nInc,mDec,nDec,H1,S1,G1,G2,G0,Gprm1,Gprm2,Gprm0,Gbis1,Gbis2,Gbis0,det0,Base, &
                     r0,r1,r2,nterm,nvar,ndata,nosc,ndimtot)
      call SolveSort(H1,U1,S1,E1,W1,W2,W1,C1,C2,C1,r01,r02,r01,mInc,mDec,mMat,mdim1,mdim2,OccNumMat1,nOsc,nDimTot)
      call SetUpHmat(energy2,r2,ipow,var,yin2,trfName2,max_term,C1,W1,det1,r01,C2,W2,det2,r02,max_mOrd,max_nOrd,max_nOrd,max_mInc, &
                     max_nInc,max_nInc,mMat,nMat,mInc,nInc,mDec,nDec,H2,S2,G1,G2,G0,Gprm1,Gprm2,Gprm0,Gbis1,Gbis2,Gbis0,det0,Base, &
                     r0,r1,r2,nterm,nvar,ndata,nosc,ndimtot)
      call SolveSort(H2,U2,S2,E2,W1,W2,W2,C1,C2,C2,r01,r02,r02,nInc,nDec,nMat,ndim1,ndim2,OccNumMat2,nOsc,nDimTot)
      call mma_deallocate(yin1)
      call mma_deallocate(yin2)

    end if
    write(u6,*) 'T0',T0*auTocm
    k2 = 1
    l_TermMat_1 = nDimTot-1
    l_TermMat_2 = nDimTot-1

    call mma_allocate(TermMat,[0,l_TermMat_1],[0,l_TermMat_2],label='TermMat')

    do jOrd=0,nDimTot-1
      k1 = 1
      do iOrd=0,nDimTot-1
        TermMat(iOrd,jOrd) = T0+(E2(k2)-E1(k1))
        k1 = k1+1
      end do
      k2 = k2+1
    end do
    call mma_deallocate(H1)
    call mma_deallocate(H2)
    call mma_deallocate(S1)
    call mma_deallocate(S2)
    !call mma_deallocate(G0)
  end if  ! END: Vibrational Hessian (variational)

  call mma_deallocate(AtCoord)
  call mma_deallocate(Hess1)
  call mma_deallocate(Hess2)
  call mma_deallocate(G0)
  call mma_deallocate(G1)
  call mma_deallocate(G2)
  call mma_deallocate(Gprm0)
  call mma_deallocate(Gprm1)
  call mma_deallocate(Gprm2)
  call mma_deallocate(Gbis0)
  call mma_deallocate(Gbis1)
  call mma_deallocate(Gbis2)

  !--------------------------------------------------------------------!

  ! Intensity calculations

  !--------------------------------------------------------------------!

  !PAM: If max_dip=0, there are no transition dipole gradients, but the
  !     array TranDipGradInt must be formally all. anyway:
  if (max_dip == 0) then
    call mma_allocate(TranDipGradInt,3,nOsc,label='TranDipGradInt')
  end if

  if (Matel) then
    l_IntensityMat_1 = ndimtot-1
    l_IntensityMat_2 = ndimtot-1
    l_m_plot = size(m_plot)
    l_n_plot = size(n_plot)
    call mma_allocate(IntensityMat,[0,l_IntensityMat_1],[0,l_IntensityMat_2],label='IntensityMat')
    if (Forcefield) then
      Base2(:,:) = Zero
      do i=1,nOsc
        Base2(i,i) = One
      end do
      call Intensity2(IntensityMat,TermMat,U1,U2,C1,W1,det1,r01,C2,W2,det2,r02,det0,m_max,n_max,max_dip,m_plot,n_plot,TranDip, &
                      TranDipGradInt,Base2,l_IntensityMat_1,l_IntensityMat_2,l_TermMat_1,l_TermMat_2,nOsc,nDimTot,l_n_plot,l_m_plot)
      call mma_deallocate(TranDipGradInt)
      call mma_deallocate(Base2)
    else
      call Intensity(IntensityMat,TermMat,ipow,var,t_dipin1,t_dipin2,trfName1,U1,U2,C1,W1,det1,r01,C2,W2,det2,r02,det0,m_max, &
                     n_max,max_dip,m_plot,n_plot,r0,r1,r2,Base,l_IntensityMat_1,l_IntensityMat_2,l_TermMat_1,l_TermMat_2,nOsc, &
                     nDimTot,nPolyTerm,ndata,nvar,MaxNumAt,l_n_plot,l_m_plot)
      call mma_deallocate(t_dipin1)
      call mma_deallocate(t_dipin2)

      call mma_deallocate(var)
      call mma_deallocate(ipow)

    end if
  else
    l_IntensityMat_1 = max_mOrd
    l_IntensityMat_2 = max_nOrd

    call mma_allocate(IntensityMat,[0,l_IntensityMat_1],[0,l_IntensityMat_2],label='IntensityMat')
    call IntForceField(IntensityMat,TermMat,FC00,C1,W1,det1,r01,C2,W2,det2,r02,C,W,det0,m_max,n_max,max_dip,Trandip, &
                       TranDipGradInt,harmfreq1,x_anharm1,harmfreq2,x_anharm2,mMat,mInc,mDec,nMat,nInc,nDec,OscStr,max_mOrd, &
                       max_nOrd,nOsc)
    call mma_deallocate(TranDipGradInt)
  end if

  !write results to log.
  write(u6,*) ' Write intensity data to log file.'
  call XFlush(u6)
  call WriteInt(IntensityMat,TermMat,mMat,nMat,OccNumMat2,MatEl,ForceField,E1,E2,T0,harmfreq1,harmfreq2,x_anharm1,x_anharm2, &
                l_IntensityMat_1,l_IntensityMat_2,l_TermMat_1,l_TermMat_2,nDimTot,nOsc)

  call mma_deallocate(C)
  call mma_deallocate(C1)
  call mma_deallocate(C2)
  call mma_deallocate(W)
  call mma_deallocate(W1)
  call mma_deallocate(W2)

  call mma_deallocate(r00)
  call mma_deallocate(r01)
  call mma_deallocate(r02)

  call mma_deallocate(mMat)
  call mma_deallocate(mInc)
  call mma_deallocate(mDec)
  call mma_deallocate(nMat)
  call mma_deallocate(nInc)
  call mma_deallocate(nDec)

  call mma_deallocate(harmfreq1)
  call mma_deallocate(harmfreq2)

  call mma_deallocate(x_anharm1)
  call mma_deallocate(x_anharm2)
  call mma_deallocate(TermMat)
  call mma_deallocate(IntensityMat)

  call mma_deallocate(U1)
  call mma_deallocate(E1)
  call mma_deallocate(U2)
  call mma_deallocate(E2)

  call mma_deallocate(OccNumMat1)
  call mma_deallocate(OccNumMat2)

  call mma_deallocate(m_plot)
  call mma_deallocate(n_plot)

  call mma_deallocate(NormModes)
  call mma_deallocate(Base)
  call mma_deallocate(BaseInv)

  call mma_deallocate(TranDipGrad)
  call mma_deallocate(r0)
  call mma_deallocate(r1)
  call mma_deallocate(r2)

end if

call mma_deallocate(Mass)
call mma_deallocate(InterVec)
call mma_deallocate(trfName1)
call mma_deallocate(trfName2)

iReturn = 0

end subroutine Mula

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkafter_cvb(chr1,chr2)

use casvb_global, only: charobj, i_dep_on_j, ioffs, mxdep, ndep_ij, nobj
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: chr1, chr2
integer(kind=iwp) :: i, iobj, jobj

call undepend2_cvb(chr1,chr2,1)

iobj = 0
jobj = 0
do i=1,nobj
  if (charobj(i) == chr1) iobj = i
  if (charobj(i) == chr2) jobj = i
end do
if (iobj == 0) then
  write(u6,*) ' Make object not found :',chr1
  call abend_cvb()
end if
if (jobj == 0) then
  write(u6,*) ' Make object not found :',chr2
  call abend_cvb()
end if
ndep_ij = ndep_ij+1
if (ndep_ij > mxdep) then
  write(u6,*) ' Too many make dependencies, max :',mxdep
  call abend_cvb()
end if
i_dep_on_j(ioffs(iobj+1)+2:ioffs(nobj+1)+1) = i_dep_on_j(ioffs(iobj+1)+1:ioffs(nobj+1))
i_dep_on_j(ioffs(iobj+1)+1) = jobj
ioffs(iobj+1:nobj+1) = ioffs(iobj+1:nobj+1)+1

return

end subroutine mkafter_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine removeB2 (length,operator)
c
c*********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 12.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*********************************************************************

      implicit none
#include "dkhparameters.fh"

      integer length,k
      character*(maxlength) operator

      if (operator(1:1).eq.'B') then
        do 10 k=2,length,1
          operator(k-1:k-1)=operator(k:k)
  10    continue
        operator(length:length)=' '
        length=length-1
      endif

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Ignacio Fdez. Galvan                             *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifdef _IN_MODULE_

subroutine Do_Lebedev_Sym(L_Eff,mPt,R)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: L_Eff
integer(kind=iwp), intent(out) :: mPt
real(kind=wp), allocatable, intent(out) :: R(:,:)
integer(kind=iwp) :: i, j, mPt_f
real(kind=wp), allocatable :: R_f(:,:)
real(kind=wp), parameter :: Thr = 1.0e-16_wp

!                                                                      *
!***********************************************************************
!                                                                      *
call Do_Lebedev(L_Eff,mPt_f,R_f)
mPt = 0
outer: do i=1,mPt_f
  do j=1,i-1
    if (all(abs(R_f(1:3,j)+R_f(1:3,i)) < Thr)) then
      R_f(4,i) = Zero
      cycle outer
    end if
  end do
  mPt = mPt+1
end do outer

call mma_allocate(R,4,mPt,label='R')

j = 1
do i=1,mPt_f
  if (R_f(4,i) /= Zero) then
    R(:,j) = R_f(:,i)
    j = j+1
  end if
end do
call mma_deallocate(R_f)

end subroutine Do_Lebedev_Sym

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine SphCr1(Win,ijkla,
     &                  Scrt,nScrt,
     &                  Coeff3,kCar,kSph,Tr3,Pr3,
     &                  Coeff4,lCar,lSph,Tr4,Pr4,Wout,mcd)
************************************************************************
*                                                                      *
* Object : to transform the two-electron integrals from cartesian      *
*          gaussians to real spherical harmonic gaussians.             *
*                                                                      *
*          Observe that most of the time Win and Wout will overlap.    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified to back projection to cartesian gaussians,      *
*             January '92.                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
      Real*8 Win(ijkla*kSph*lSph), Scrt(nScrt),
     &       Coeff3(kCar,kCar), Coeff4(lCar,lCar),
     &       Wout(mcd*ijkla)
      Logical Tr3, Pr3, Tr4, Pr4
*
      iRout = 59
      iPrint = nPrint(iRout)
*     iQ = 0
*     Call RecPrt(' In SphCr1: P(AB|CD) ',' ',Win,ijkla,kSph*lSph)
      If (Tr3.and.Tr4) Then
*        Call RecPrt(' Right contraction',' ',Coeff4,lCar,lSph)
*--------Starting with IJKL,AB,CD transforming to d,IJKL,AB,C
*        Call xxDGeMul(Coeff4,lCar,'N',
*    &               Win,ijkla*kSph,'T',
*    &               Scrt,lCar,
*    &               lCar,lSph,ijkla*kSph)
         Call NTMul(Coeff4,Win,Scrt,lCar,lSph,ijkla*kSph)
*
*        Call RecPrt(' In SphCr: P(AB|Cd) ',' ',Scrt,lCar*ijkla,kSph)
*        Call RecPrt(' Left contraction',' ',Coeff3,kCar,kSph)
*--------Transform d,IJKL,AB,C to cd,IJKL,AB
*        Call xxDGeMul(Coeff3,kCar,'N',
*    &               Scrt,lCar*ijkla,'T',
*    &               Wout,kCar,
*    &               kCar,kSph,lCar*ijkla)
         Call NTMul(Coeff3,Scrt,Wout,kCar,kSph,lCar*ijkla)
      Else If (Tr4) Then
*        Call RecPrt(' Right contraction',' ',Coeff4,lCar,lSph)
*--------Starting with IJKL,AB,cD transforming to d,IJKL,AB,c
*        Call xxDGeMul(Coeff4,lCar,'N',
*    &               Win,ijkla*kCar,'T',
*    &               Scrt,lCar,
*    &               lCar,lSph,ijkla*kCar)
         Call NTMul(Coeff4,Win,Scrt,lCar,lSph,ijkla*kCar)
*--------Transpose d,IJKL,AB,c to cd,IJKL,AB
         Call DGeTMO(Scrt,lCar*ijkla,lCar*ijkla,kCar,Wout,kCar)
      Else If (Tr3) Then
*--------Transpose IJKL,AB,C,d to d,IJKL,AB,C
         Call DGeTMO(Win,ijkla*kSph,ijkla*kSph,lCar,Scrt,lCar)
*
*        Call RecPrt(' Left contraction',' ',Coeff3,kCar,kSph)
*        Transform d,IJKL,AB,c to cd,IJKL,AB
*        Call xxDGeMul(Coeff3,kCar,'N',
*    &               Scrt,lCar*ijkla,'T',
*    &               Wout,kCar,
*    &               kCar,kSph,lCar*ijkla)
         Call NTMul(Coeff3,Scrt,Wout,kCar,kSph,lCar*ijkla)
      Else
*---------Transpose IJKL,AB,cd to cd,IJKL,AB
          If (kCar*lCar.ne.1) Then
             call dcopy_(ijkla*kCar*lCar,Win,1,Scrt,1)
             Call DGeTMO(Scrt,ijkla,ijkla,kCar*lCar,Wout,kCar*lCar)
          Else
             call dcopy_(ijkla*kCar*lCar,Win,1,Scrt,1)
             call dcopy_(ijkla*kCar*lCar,Scrt,1,Wout,1)
          End If
      End If
*
*     Call RecPrt(' In SphCr1: P(AB|cd)  ',' ',Wout,mcd,ijkla)
*     Call GetMem(' Exit SphCr1','CHECK','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Pr3)
         Call Unused_logical(Pr4)
      End If
      End
#ifdef _OLD_CODE_
      Subroutine NTMul(A,B,C,nRowA,nColA,nRowB)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 A(nRowA,nColA), B(nRowB,nColA),
     &       C(nRowA,nRowB)
*
      nCache=(64/8)*1024
      mCache=(nCache*3)/4 - nRowA*nColA
      Incj=mCache/(nRowA+nColA)
*
*-----Sectioning of long index
*
      Do jj = 1, nRowB, Incj
         njVec=Min(Incj,nRowB-jj+1)
*
         Do i = 1, nRowA
*-----------Set target to zero
            Do j = jj, jj+njVec-1
               C(i,j) = Zero
            End Do
            Do k = 1, nColA
               If (A(i,k).ne.Zero) Then
                  Do j = jj, jj+njVec-1
                     C(i,j) = C(i,j) + A(i,k)*B(j,k)
                  End Do
               End If
            End Do
         End Do
*
      End Do    ! End of sectioning
*
      Return
      End
#else
c--------------------------------------------------------------------
      subroutine ntmul(a,b,r,ncol,nlink,nrow)
c--------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      parameter (mxind=2000)
      dimension r(ncol,*),a(ncol,*),b(nrow,*),ind(mxind)
c
      do 100 i=1,ncol
c
      nnot=0
      do k=1,min(nlink,mxind)
        if ( a(i,k) .ne. 0.0d0 ) then
          nnot = nnot + 1
          ind(nnot) = k
        end if
      end do
c
      do 20 j=1,nrow-15,16
      s1=0.0D0
      s2=0.0D0
      s3=0.0D0
      s4=0.0D0
      s5=0.0D0
      s6=0.0D0
      s7=0.0D0
      s8=0.0D0
      t1=0.0D0
      t2=0.0D0
      t3=0.0D0
      t4=0.0D0
      t5=0.0D0
      t6=0.0D0
      t7=0.0D0
      t8=0.0D0
      do 15 k=1,nnot
      s1=s1+a(i,ind(k))*b(j,  ind(k))
      s2=s2+a(i,ind(k))*b(j+1,ind(k))
      s3=s3+a(i,ind(k))*b(j+2,ind(k))
      s4=s4+a(i,ind(k))*b(j+3,ind(k))
      s5=s5+a(i,ind(k))*b(j+4,ind(k))
      s6=s6+a(i,ind(k))*b(j+5,ind(k))
      s7=s7+a(i,ind(k))*b(j+6,ind(k))
      s8=s8+a(i,ind(k))*b(j+7,ind(k))
      t1=t1+a(i,ind(k))*b(j+8,ind(k))
      t2=t2+a(i,ind(k))*b(j+9,ind(k))
      t3=t3+a(i,ind(k))*b(j+10,ind(k))
      t4=t4+a(i,ind(k))*b(j+11,ind(k))
      t5=t5+a(i,ind(k))*b(j+12,ind(k))
      t6=t6+a(i,ind(k))*b(j+13,ind(k))
      t7=t7+a(i,ind(k))*b(j+14,ind(k))
      t8=t8+a(i,ind(k))*b(j+15,ind(k))
15    continue
      r(i,j  )=s1
      r(i,j+1)=s2
      r(i,j+2)=s3
      r(i,j+3)=s4
      r(i,j+4)=s5
      r(i,j+5)=s6
      r(i,j+6)=s7
      r(i,j+7)=s8
      r(i,j+8)=t1
      r(i,j+9)=t2
      r(i,j+10)=t3
      r(i,j+11)=t4
      r(i,j+12)=t5
      r(i,j+13)=t6
      r(i,j+14)=t7
      r(i,j+15)=t8
20    continue
c
      nr1=mod(nrow,16)
      if(nr1.eq.0) goto 100
      j=nrow-nr1+1
c
      if(nr1.ge.8) then
      s1=0.0D0
      s2=0.0D0
      s3=0.0D0
      s4=0.0D0
      s5=0.0D0
      s6=0.0D0
      s7=0.0D0
      s8=0.0D0
      do 25 k=1,nnot
      s1=s1+a(i,ind(k))*b(j,  ind(k))
      s2=s2+a(i,ind(k))*b(j+1,ind(k))
      s3=s3+a(i,ind(k))*b(j+2,ind(k))
      s4=s4+a(i,ind(k))*b(j+3,ind(k))
      s5=s5+a(i,ind(k))*b(j+4,ind(k))
      s6=s6+a(i,ind(k))*b(j+5,ind(k))
      s7=s7+a(i,ind(k))*b(j+6,ind(k))
      s8=s8+a(i,ind(k))*b(j+7,ind(k))
25    continue
      r(i,j  )=s1
      r(i,j+1)=s2
      r(i,j+2)=s3
      r(i,j+3)=s4
      r(i,j+4)=s5
      r(i,j+5)=s6
      r(i,j+6)=s7
      r(i,j+7)=s8
      nr1=nr1-8
      j=j+8
      end if
c
      if(nr1.ge.4) then
      s1=0.0D0
      s2=0.0D0
      s3=0.0D0
      s4=0.0D0
      do 35 k=1,nnot
      s1=s1+a(i,ind(k))*b(j,  ind(k))
      s2=s2+a(i,ind(k))*b(j+1,ind(k))
      s3=s3+a(i,ind(k))*b(j+2,ind(k))
      s4=s4+a(i,ind(k))*b(j+3,ind(k))
35    continue
      r(i,j  )=s1
      r(i,j+1)=s2
      r(i,j+2)=s3
      r(i,j+3)=s4
      nr1=nr1-4
      j=j+4
      end if
c
      If (nr1.eq.1) Then
         s1=0.0D0
         do 45 k=1,nnot
         s1=s1+a(i,ind(k))*b(j,ind(k))
45       continue
         r(i,j)=s1
      Else If (nr1.eq.2) Then
         s1=0.0D0
         s2=0.0D0
         do 50 k=1,nnot
         s1=s1+a(i,ind(k))*b(j,  ind(k))
         s2=s2+a(i,ind(k))*b(j+1,ind(k))
50       continue
         r(i,j  )=s1
         r(i,j+1)=s2
      Else If (nr1.eq.3) Then
         s1=0.0D0
         s2=0.0D0
         s3=0.0D0
         do 55 k=1,nnot
         s1=s1+a(i,ind(k))*b(j,  ind(k))
         s2=s2+a(i,ind(k))*b(j+1,ind(k))
         s3=s3+a(i,ind(k))*b(j+2,ind(k))
55       continue
         r(i,j  )=s1
         r(i,j+1)=s2
         r(i,j+2)=s3
      Else If (nr1.gt.3) Then
         Call WarningMessage(2,'nr1.gt.3')
         Call Abend()
      End If
 100  Continue
*
      if(mxind.ge.nlink) return
      Call WarningMessage(2,'MxInd.lt.nLink')
      Write (6,*) 'mxind,nlink=',mxind,nlink
      Call Abend()
      Return
      End
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SYMINF_LUCIA(IPRNT)
*
* Information about number of symmetries
*
* Input : /LUCINP/,/ORBINP
* Output : /CSM/,/CSMPRO/
*
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
#include "mxpdim.fh"
#include "lucinp.fh"
*

*. Output
* NSMSX : number of symmetries of single excitations
* NSMDX : Number of symmetries of double excitations
* NSMST : Number of symmetries of strings
* NSMCI : NUmber of symmetries of CI spaces
* ITSSX : Total symmetrix single excitation
* ITSDX : Total symmetrix double excitation
C     COMMON/CSM/NSMSX,NSMDX,NSMST,NSMCI,ITSSX,ITSDX
#include "csm.fh"
*
      INTEGER ADASX,ASXAD,ADSXA,SXSXDX,SXDXSX
      COMMON/CSMPRD/ADASX(MXPOBS,MXPOBS),ASXAD(MXPOBS,2*MXPOBS),
     &              ADSXA(MXPOBS,2*MXPOBS),
     &              SXSXDX(2*MXPOBS,2*MXPOBS),SXDXSX(2*MXPOBS,4*MXPOBS)
* ADASX : symmetry of orbs i and i => symmetry of a+iaj
* ASXAD : symmetry of orb j and excit a+iaj => symmetry of i
* ADSXA : symmetry of orb i and excit a+iaj => symmetry of j
*
* SXSXDX : Symmetry of two single excitations
*          => symmetry of double  excitation
* SXDXSX : Symmetry of single excitation and double excitation
*          => symmetry of single  excitation

*.
      IF(PNTGRP.EQ.1) THEN
* =====
* D 2 h
* =====
        CALL ZSYM1(NIRREP,IPRNT)
      ELSE
        WRITE(6,*) ' You are too early , sorry '
        WRITE(6,*) ' Illegal PNTGRP in SYMINF ',PNTGRP
*        STOP 11
        CALL SYSABENDMSG('lucia_util/syminf','Internal error',' ')
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MXMNOC_SPGP(MINEL,MAXEL,NORBTP,NORBFTP,NELFTP)
! Construct accumulated MAX and MIN arrays for a GAS supergroup

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: MINEL(*), MAXEL(*)
integer(kind=iwp), intent(in) :: NORBTP, NORBFTP(NORBTP), NELFTP(NORBTP)
integer(kind=iwp) :: IORB, IORB_END, IORB_START, IORBTP, NEL_END, NEL_START
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: NORB

write(u6,*)
write(u6,*) ' ==========='
write(u6,*) ' MXMNOC_SPGP'
write(u6,*) ' ==========='
write(u6,*)
!write(u6,*) ' NORBFTP :'
!call IWRTMA(NORBFTP,1,NORBTP,1,NORBTP)
#endif

IORB_START = 1
IORB_END = NORBFTP(1)
NEL_START = 0
NEL_END = NELFTP(1)
do IORBTP=1,NORBTP
  ! Max and min at start of this type and at end of this type
  if (IORBTP > 1) then
    IORB_START = IORB_START+NORBFTP(IORBTP-1)
    IORB_END = IORB_START+NORBFTP(IORBTP)-1
    NEL_START = NEL_END
    NEL_END = NEL_START+NELFTP(IORBTP)
  end if
# ifdef _DEBUGPRINT_
  write(u6,*) ' IORBTP,IORB_START-IORB_END,NEL_START,NEL_END'
  write(u6,*) IORBTP,IORB_START-IORB_END,NEL_START,NEL_END
# endif

  do IORB=IORB_START,IORB_END
    MAXEL(IORB) = min(IORB,NEL_END)
    MINEL(IORB) = NEL_START
    if (NEL_END-MINEL(IORB) > IORB_END-IORB) MINEL(IORB) = NEL_END-(IORB_END-IORB)
  end do
end do

#ifdef _DEBUGPRINT_
NORB = sum(NORBFTP(1:NORBTP))
write(u6,*) ' MINEL :'
call IWRTMA(MINEL,1,NORB,1,NORB)
write(u6,*) ' MAXEL :'
call IWRTMA(MAXEL,1,NORB,1,NORB)
#endif

end subroutine MXMNOC_SPGP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_TR_drv(rc,nIsh,nAsh,nSsh,Porb,BName,Do_int,ihdf5,Xint,lXint)
!*********************************************************************
!  a,b,g,d:  AO-index
!  p,q,r,s:  MO-indices belonging to all (fro and del excluded)
!*********************************************************************

#ifdef _HDF5_QCM_
use hdf5_utils, only: file_id, hdf5_close_cholesky, hdf5_init_wr_cholesky, hdf5_write_cholesky, HID_T
#endif
use ChoArr, only: nDimRS
use ChoSwp, only: InfVec
use Symmetry_Info, only: Mul
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, SBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp), intent(in) :: nIsh(*), nAsh(*), nSsh(*), ihdf5, lXint
type(DSBA_Type), intent(in) :: Porb(1)
character(len=6), intent(in) :: BName
logical(kind=iwp), intent(in) :: Do_int
real(kind=wp), intent(out) :: Xint(0:lXint-1)
integer(kind=iwp) :: i, iBatch, idisk, iLoc, iOffB(8), ipq, irc, IREDC, iSwap, iSymb, iSymp, IVEC2, iVrs, JNUM, JRED, JRED1, &
                     JRED2, jSym, JVC, JVEC, k, kMOs, kt, l, LREAD, LunChVF(8), LWORK, kOff(8), Mpq, mTTvec, mTvec, MUSED, mvec, &
                     NAp, nApq, nAq, nBatch, nMOs, nOB(8), nPorb(8), nRS, NUMV, nVec, nVrs
#ifdef _HDF5_QCM_
integer(kind=HID_T) :: choset_id, space_id
#endif
real(kind=wp) :: TCM1, TCM2, TCM3, TCM4, TCR1, TCR2, TCR3, TCR4, TOTCPU, TOTCPU1, TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, TWM1, &
                 TWM2, TWM3, TWM4, TWR1, TWR2, TWR3, TWR4, tmotr1(2), tmotr2(2), tread(2)
character(len=50) :: CFmt
character(len=7) :: Fnam
type(SBA_Type), target :: ChoT(1)
real(kind=wp), allocatable :: Lpq(:,:), Lpq_J(:), Lrs(:)
logical(kind=iwp), parameter :: DoRead = .false.
character(len=10), parameter :: SECNAM = 'CHO_TR_drv'
integer(kind=iwp), external :: IsFreeUnit
real(kind=r8), external :: ddot_
#include "chotime.fh"
#include "chotraw.fh"
#include "cholesky.fh"
#include "choorb.fh"

#ifndef _HDF5_QCM_
#include "macros.fh"
unused_var(ihdf5)
#endif

#ifdef _HDF5_QCM_
! Leon 13.6.2017: Avoid opening a regular file if HDF5 is used
if (ihdf5 /= 1) then
#endif
  do i=1,nSym
    LunChVF(i) = 80
    LunChVF(i) = isfreeunit(LunChVF(i))
    write(Fnam,'(A6,I1)') BName,i
    call DaName_mf_wa(LunChVF(i),Fnam)
  end do
#ifdef _HDF5_QCM_
end if
#endif

IREDC = -1  ! unknown reduced set in core

call CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = Zero   !time read/write vectors
tmotr1(:) = Zero  !time 1st MO half-transf.
tmotr2(:) = Zero  !time 2nd MO half-transf.

if (Do_int) call Fzero(Xint(0),lXint)

! Define MO space used
!---------------------
do i=1,nSym
  nPorb(i) = nIsh(i)+nAsh(i)+nSsh(i)
end do

! ======================================================================

iLoc = 3 ! use scratch location in reduced index arrays

!****************** BIG LOOP OVER VECTORS SYMMETRY *********************

Mpq = 0

do jSym=1,nSym

! Init the HDF5 section
#ifdef _HDF5_QCM_
  if (ihdf5 == 1) then
    ! max size of the cholesky vector for now is the
    ! max(nPorb)*(max(nPorb)+1)/2
    ! probably this can be chosen more efficiently,
    ! but would matter only if we use symmetry
    call hdf5_init_wr_cholesky(file_id(1),JSym,maxval(nPorb(1:nSym))*(maxval(nPorb(1:nSym))+1)/2,NumCho(JSym),choset_id,space_id)
  end if
#endif
  if (NumCho(jSym) < 1) cycle

  ! Set up the skipping flags + some initializations
  !-------------------------------------------------
  do i=1,nSym
    k = Mul(i,JSYM)
    if (i < k) then
      kOff(i) = Mpq
      nOB(i) = nPorb(i)*nPorb(k)*NumCho(jSym)
      Mpq = Mpq+nPorb(i)*nPorb(k)
    else if (k == i) then
      kOff(i) = Mpq
      nOB(i) = nPorb(i)*(nPorb(i)+1)/2*NumCho(jSym)
      Mpq = Mpq+nPorb(i)*(nPorb(i)+1)/2
    else
      nOB(i) = 0
    end if
    iOffB(i) = 0
  end do

  do i=2,nSym
    iOffB(i) = iOffB(i-1)+nOB(i-1)
  end do
  do i=1,nSym
    if (nOB(i) == 0) then
      k = Mul(i,JSYM)
      iOffB(i) = iOffB(k)
      kOff(i) = kOff(k)
    end if
  end do

  !********************* MEMORY MANAGEMENT SECTION *********************
  !---------------------------------------------------------------------
  ! compute memory needed to store at least 1 vector of JSYM
  ! and do all the subsequent calculations
  !---------------------------------------------------------------------
  mTvec = 0  ! mem for storing half-transformed vec Laq,J
  mTTvec = 0  ! mem for storing transformed vec Lpq,J

  do l=1,nSym
    k = Mul(l,JSYM)
    mTvec = mTvec+nPorb(k)*nBas(l)
    mTTvec = max(mTTvec,nPorb(k)*nPorb(l))
  end do

  mvec = mTvec+mTTvec

  !---------------------------------------------------------------------
  !---------------------------------------------------------------------

  JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

  do JRED=JRED1,JRED2

    call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

    if (nVrs == 0) cycle  ! no vectors in that (jred,jsym)

    if (nVrs < 0) then
      write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
      call abend()
    end if

    call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
    if (irc /= 0) then
      write(u6,*) SECNAM//': Cho_X_SetRed non-zero return code. rc= ',irc
      call abend()
    end if

    IREDC = JRED

    nRS = nDimRS(JSYM,JRED)

    call mma_maxDBLE(LWORK)

    nVec = min(LWORK/(nRS+mvec+1),nVrs)

    if (nVec < 1) then
      write(u6,*) SECNAM//': Insufficient memory for batch'
      write(u6,*) 'LWORK= ',LWORK
      write(u6,*) 'Min. mem. need= ',nRS+mvec+1
      write(u6,*) 'Reading ',nRS,' and then MO-transform.'
      write(u6,*) 'In jsym= ',jsym,' and JRED= ',JRED
      rc = 33
      call Abend()
      nBatch = -9999  ! dummy assignment
    end if

    LREAD = nRS*nVec

    call mma_allocate(Lrs,LREAD,Label='Lrs')
    call mma_allocate(Lpq_J,nVec,Label='Lpq_j')

    iSwap = 0  ! Lpb,J are returned by cho_x_getVtra
    call Allocate_DT(ChoT(1),nPorb,nBas,nVec,JSYM,nSym,iSwap)
    ChoT(1)%A0(:) = Zero

    ! BATCH over the vectors

    nBatch = (nVrs-1)/nVec+1

    do iBatch=1,nBatch

      if (iBatch == nBatch) then
        JNUM = nVrs-nVec*(nBatch-1)
      else
        JNUM = nVec
      end if

      JVEC = nVec*(iBatch-1)+iVrs
      IVEC2 = JVEC-1+JNUM

      call CWTIME(TCR1,TWR1)

      call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

      if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
        rc = 77
        return
      end if

      call CWTIME(TCR2,TWR2)
      tread(1) = tread(1)+(TCR2-TCR1)
      tread(2) = tread(2)+(TWR2-TWR1)

      !-----------------------------------------------------------------
      ! First half MO transformation  Lpb,J = sum_a  C(p,a) * Lab,J
      !-----------------------------------------------------------------

      call CWTIME(TCM1,TWM1)

      kMOs = 1
      nMOs = 1

      call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,jSym,iSwap,IREDC,nMOs,kMOs,POrb,ChoT(1),DoRead)

      if (irc /= 0) then
        rc = irc
        return
      end if

      call CWTIME(TCM2,TWM2)
      tmotr1(1) = tmotr1(1)+(TCM2-TCM1)
      tmotr1(2) = tmotr1(2)+(TWM2-TWM1)

      !-----------------------------------------------------------------
      ! 2nd half of MO transformation  Lpq,J = sum_b  Lpb,J * C(q,b)
      !-----------------------------------------------------------------

      if (JSYM == 1) then   !  Lpq,J in LT-storage

        do iSymb=1,nSym

          NAp = nPorb(iSymb)
          NApq = NAp*(NAp+1)/2

          call CWTIME(TCM3,TWM3)

          if (NApq == 0) cycle

          call mma_allocate(Lpq,NApq,JNUM,Label='Lpq')

          do JVC=1,JNUM

            call DGEMM_Tri('N','T',NAp,NAp,nBas(iSymb),One,ChoT(1)%SB(iSymb)%A3(:,:,JVC),NAp,Porb(1)%SB(iSymb)%A2,NAp,Zero, &
                           Lpq(:,jVC),NAp)

          end do

          call CWTIME(TCM4,TWM4)
          tmotr2(1) = tmotr2(1)+(TCM4-TCM3)
          tmotr2(2) = tmotr2(2)+(TWM4-TWM3)

          call CWTIME(TCR3,TWR3)

          if (tv2disk == 'PQK') then
#           ifdef _HDF5_QCM_
            if (ihdf5 /= 1) then
#           endif
              call ddafile(LunChVF(jSym),1,Lpq,NApq*JNUM,iOffB(iSymb))
#           ifdef _HDF5_QCM_
            else
              ! this should never happen, this case should be caught in motra.f
              write(u6,*) ' Writing of Cholesky vectors in HDF5 format as (pq,k) is not supported.'
              call Abend()
            end if
#           endif
            if (Do_int) then
              do ipq=1,NApq
                kt = kOff(iSymb)+ipq-1
                Xint(kt) = Xint(kt)+ddot_(JNUM,Lpq(ipq,:),NApq,Lpq(ipq,:),NApq)
              end do
            end if
          else
            do ipq=1,NApq
              Lpq_J(1:JNUM) = Lpq(ipq,1:JNUM)
              if (Do_int) then
                kt = kOff(iSymb)+ipq-1
                Xint(kt) = Xint(kt)+ddot_(JNUM,Lpq_J,1,Lpq_J,1)
              end if
              idisk = iOffB(iSymb)+NumCho(jSym)*(ipq-1)
#           ifdef _HDF5_QCM_
              ! Leon 13.6.2017: Do not write Cholesky vectors to the regular file
              ! if the hdf5 file is written. It becomes counterproductive to write
              ! the same content twice for large basis sets
              if (ihdf5 /= 1) then
#             endif
                call ddafile(LunChVF(jSym),1,Lpq_J,JNUM,idisk)

#             ifdef _HDF5_QCM_
              else
                ! Write the transformed Cholesky batch to the hdf5 dataset
                ! The ordering in HDF5 is in column-major order, corresponding to
                ! the 'Kpq' storage
                ! This way all the elements needed to compute one integral can be
                ! read with one read operation.

                ! TODO: eventually row-major order storage + chunked dataset might
                ! improve the performance -- but probably it's irrelevant.
                ! Leon 22.4.2016 -- modified the write_cholesky call below to
                ! account for multiple reduced sets
                call hdf5_write_cholesky(choset_id,space_id,ipq-1,nVec*(iBatch-1)+iVrs-1,JNUM,Lpq_J)
              end if
#             endif

            end do
            iOffB(iSymb) = iOffB(iSymb)+JNUM
          end if

          call mma_deallocate(Lpq)

          call CWTIME(TCR4,TWR4)
          tread(1) = tread(1)+(TCR4-TCR3)
          tread(2) = tread(2)+(TWR4-TWR3)

        end do

      else

        do iSymb=1,nSym

          iSymp = Mul(JSYM,iSymb)
          NAp = nPorb(iSymp)
          NAq = nPorb(iSymb) ! iSymb=iSymq
          NApq = NAp*NAq

          call CWTIME(TCM3,TWM3)

          if (NApq == 0) cycle

          call mma_allocate(Lpq,NApq,JNUM,Label='Lpq')

          if (iSymp < iSymb) then
            do JVC=1,JNUM

              call DGEMM_('N','T',NAp,NAq,nBas(iSymb),One,ChoT(1)%SB(iSymp)%A3(:,:,JVC),NAp,Porb(1)%SB(iSymb)%A2,NAq,Zero, &
                          Lpq(:,JVC),NAp)

            end do
          else
            Lpq(:,:) = Zero
          end if

          call CWTIME(TCM4,TWM4)
          tmotr2(1) = tmotr2(1)+(TCM4-TCM3)
          tmotr2(2) = tmotr2(2)+(TWM4-TWM3)

          call CWTIME(TCR3,TWR3)

          if (iSymp < iSymb) then

            if (tv2disk == 'PQK') then
              call ddafile(LunChVF(jSym),1,Lpq,NApq*JNUM,iOffB(iSymp))
              if (Do_int) then
                do ipq=1,NApq
                  kt = kOff(iSymp)+ipq-1
                  Xint(kt) = Xint(kt)+ddot_(JNUM,Lpq(ipq,:),NApq,Lpq(ipq,:),NApq)
                end do
              end if

            else
              do ipq=1,NApq
                Lpq_J(1:JNUM) = Lpq(ipq,1:JNUM)
                if (Do_int) then
                  kt = kOff(iSymp)+ipq-1
                  Xint(kt) = Xint(kt)+ddot_(JNUM,Lpq_J,1,Lpq_J,1)
                end if
                idisk = iOffB(iSymp)+NumCho(jSym)*(ipq-1)
#               ifdef _HDF5_QCM_
                ! Write the transformed Cholesky batch to the hdf5 dataset
                ! The ordering in HDF5 is in column-major order, corresponding to
                ! the 'Kpq' storage
                ! See above for more explanation
                if (ihdf5 == 1) then
                  call hdf5_write_cholesky(choset_id,space_id,ipq-1,nVec*(iBatch-1),JNUM,Lpq_J)
                end if
#               endif

                call ddafile(LunChVF(jSym),1,Lpq_J,JNUM,idisk)
              end do
              iOffB(iSymp) = iOffB(iSymp)+JNUM
            end if

          end if

          call CWTIME(TCR4,TWR4)
          tread(1) = tread(1)+(TCR4-TCR3)
          tread(2) = tread(2)+(TWR4-TWR3)

          call mma_deallocate(Lpq)

        end do

      end if

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------

    end do  ! end batch loop

    ! free memory
    call mma_deallocate(Lpq_J)
    call Deallocate_DT(ChoT(1))
    call mma_deallocate(Lrs)

  end do   ! loop over red sets

# ifdef _HDF5_QCM_
  ! close Cholesky HDF5 stuff
  if (ihdf5 == 1) then
    call hdf5_close_cholesky(choset_id,space_id)
  else
# endif
    call daclos(LunChVF(jSym))
# ifdef _HDF5_QCM_
  end if
# endif

end do   !loop over JSYM

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

!---- Write out timing information
if (timings) then

  CFmt = '(6x,A)'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Cholesky-MOTRA timings            CPU       WALL '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  if (Do_int) then
    write(u6,'(6x,A28,2f10.2)') 'I/O vectors + diag ERIs step',tread(1),tread(2)
  else
    write(u6,'(6x,A28,2f10.2)') 'I/O vectors',tread(1),tread(2)
  end if
  write(u6,'(6x,A28,2f10.2)') '1st half-transf.',tmotr1(1),tmotr1(2)
  write(u6,'(6x,A28,2f10.2)') '2nd half-transf.',tmotr2(1),tmotr2(2)
  write(u6,*)
  write(u6,'(6x,A28,2f10.2)') 'TOTAL',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

rc = 0

write(u6,*)
if (tv2disk == 'PQK') then
  tv2disk(1:2) = 'pq'
  write(u6,*) '     Transformed Cholesky vectors stored as L(',tv2disk(1:2),',',tv2disk(3:3),')'
else
  tv2disk(2:3) = 'pq'
  write(u6,*) '     Transformed Cholesky vectors stored as L(',tv2disk(1:1),',',tv2disk(2:3),')'
end if
write(u6,*)

return

end subroutine CHO_TR_drv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Jeppe Olsen                                      *
!               1989, Markus P. Fuelscher                              *
!***********************************************************************

subroutine PHPCSF(PHP,IPCSF,IPCNF,MXPDIM,DTOC,IPRODT,ICONF,IREFSM,ONEBOD,ECORE,NACTOB,SCR,NCONF,NEL,NAEL,NBEL,NPCSF,NPCNF,DIAG, &
                  TUVX,NTEST,ExFac,IREOTS)
! Obtain primary subspace and obtain
! explicit representation of hamilton matrix in subspace
!
! ARGUMENTS :
! ===========
! PHP    : hamilton matrix in subspace (output)
! IPCSF  : CSF's defining subspace (output)
! IPCNF  : Configurations defining subspace (output)
! MXPDIM : Largest allowed dimension of subspace (input)
! DTOC   : Transformation matrix between CSF's and DET's (input)
! IPRODT : Prototype determinants (input)
! ICONF  : List of configurations  (input)
! IREFSM : symmetry of considered CI space (input)
! Onebod : one body hamilton matrix in rectangular form (input)
! ECORE  : Core energy (input)
! NACTOB : Number of active orbitals (input)
! SCR    : Scratch array of length ????
! NCONF  : Number of configurations of symmetry IREFSM
! NPCNF  : Number of primary configurations obtained (output)
! NPCSF  : Number of primary CSF's obtained  (output)
! TUVX   : Two-electron integrals (MO space)
! DIAG   : Hamilton diagonal over CSF's
!
! IREOTS : Type => symmetry reordering array
!
! Jeppe Olsen, Summer of '89
! adapted to DETRAS by M.P. Fuelscher, October 1989

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Constants, only: One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: MXPDIM, IPRODT(*), ICONF(*), IREFSM, NACTOB, NCONF, NEL, NAEL, NBEL, IREOTS(NACTOB)
real(kind=wp), intent(out) :: PHP(MXPDIM*(MXPDIM+1)/2)
integer(kind=iwp), intent(out) :: IPCSF(MXPDIM), IPCNF(NCONF)
real(kind=wp), intent(in) :: DTOC(*), ONEBOD(NACTOB,NACTOB), ECORE, DIAG(*), TUVX(*), ExFac
real(kind=wp), intent(_OUT_) :: SCR(*)
integer(kind=iwp), intent(out) :: NPCSF, NPCNF
integer(kind=iwp), intent(inout) :: NTEST
integer(kind=iwp) :: ICSFMN, IFINIT, IICNF, IICSF, IILACT, IILB, IIRACT, IIRB, IIRMAX, ILRI, ILRO, ILTYP, IMIN, IRTYP, KLCONF, &
                     KLFREE, KLPHPS, KRCONF, MXCSFC, NCSFL, NCSFMN, NCSFR, NIRREP, NJCNF
real(kind=wp) :: XMAX, XMIN
real(kind=wp), parameter :: Acc = 1.0e-13_wp ! Assumed machine accuray (give and take)
real(kind=wp), external :: FNDMNX
#include "spinfo.fh"

call PHPCSF_INTERNAL(SCR)

! This is to allow type punning without an explicit interface
contains

subroutine PHPCSF_INTERNAL(SCR)

  real(kind=wp), target :: SCR(*)
  integer(kind=iwp), pointer :: iSCRl(:), iSCRr(:)
  integer(kind=iwp) :: ICNF, ICNL, ICNR, IIL, IIR, ITYP

  ! construct the diagonal of the Hamilton matrix in CNF basis
  ICSFMN = 0
  IICNF = 1
  IICSF = 1
  do ITYP=1,NTYP
    NJCNF = NCNFTP(ITYP,IREFSM)
    NIRREP = NCSFTP(ITYP)
    do ICNF=1,NJCNF
      SCR(IICNF) = DIAG(IICSF)
      IICNF = IICNF+1
      IICSF = IICSF+NIRREP
    end do
  end do
  if (NTEST >= 30) call RecPrt('SCR',' ',SCR,1,IICNF-1)

  ! find the elements of the subspace
  ! (MXPDIM elements smallest in energy)

  XMAX = FNDMNX(SCR,NCONF,2)
  NPCSF = 0
  NPCNF = 0
  IFINIT = 0
  do
    XMIN = XMAX+One
    IMIN = 0
    IICNF = 1
    IICSF = 1
    do ITYP=1,NTYP
      NJCNF = NCNFTP(ITYP,IREFSM)
      NIRREP = NCSFTP(ITYP)
      do ICNF=1,NJCNF
        if (SCR(IICNF)+Acc < XMIN) then
          XMIN = SCR(IICNF)
          IMIN = IICNF
          ICSFMN = IICSF
          NCSFMN = NIRREP
        end if
        IICNF = IICNF+1
        IICSF = IICSF+NIRREP
      end do
    end do
    if ((NPCSF+NCSFMN) <= MXPDIM) then
      ! add new configuration
      NPCNF = NPCNF+1
      IPCNF(NPCNF) = IMIN
      call ISTVC2(IPCSF(NPCSF+1),ICSFMN-1,1,NCSFMN)
      NPCSF = NPCSF+NCSFMN
      SCR(IMIN) = XMAX+One
    else
      ! No space for this configuration, remove previous
      ! configurations with the same diagonal value
      ! PAM 2011: Do not remove any previous configurations.
      IFINIT = 1
      !IICNF = NPCNF+1
      !do
      !  IICNF = IICNF-1
      !  DIAVAL = SCR(IPCNF(IICNF))
      !  if (abs(DIAVAL-XMIN) > 1.0e-10_wp) exit
      !  NPCNF = NPCNF-1
      !  call GETCNF_LUCIA(SCR(NCONF+1),ITYP,IPCNF(IICNF),ICONF,IREFSM,NEL)
      !  NPCSF = NPCSF-NCSFTP(ITYP)
      !end do
    end if
    if ((IFINIT /= 0) .or. (NPCNF >= NCONF)) exit
  end do

  if (NPCNF == 0) then
    call WarningMessage(2,'Making explicit Hamiltonian failed.')
    write(u6,*) ' An unforeseen catastrophic failure occurred'
    write(u6,*) ' in the CI solver. The size of the explicit'
    write(u6,*) ' part of the CI Hamiltonian matrix was not'
    write(u6,*) ' sufficient. Suggested fix: Change the size'
    write(u6,*) ' by adding ''SDAV=XXXXX'' to the rasscf input.'
    write(u6,*) ' XXXXX is some integer at least ',MXPDIM+NCSFMN
    write(u6,*) ' Sorry about this. Consider telling the'
    write(u6,*) ' Molcas group about this failure.'
    call Abend()
  end if

  if (NTEST >= 30) then
    write(u6,*) ' Output from PHPCSF'
    write(u6,*) ' =================='
    write(u6,*) ' Number of Configurations in primary subspace ',NPCNF
    write(u6,*) ' Number of CSFs in primary subspace ',NPCSF
    write(u6,*) ' Configurations included :'
    call IWRTMA(IPCNF,1,NPCNF,1,NPCNF)
    write(u6,*) ' CSFs included :'
    call IWRTMA(IPCSF,1,NPCSF,1,NPCSF)
  end if

  ! construct Hamiltonian matrix in subspace

  MXCSFC = 0
  do ITYP=1,NTYP
    MXCSFC = max(MXCSFC,NCSFTP(ITYP))
  end do

  KLFREE = 1
  KLCONF = KLFREE
  KLFREE = KLFREE+NEL
  KRCONF = KLFREE
  KLFREE = KLFREE+NEL
  KLPHPS = KLFREE
  KLFREE = KLFREE+MXCSFC*MXCSFC

  IILB = 1
  do ICNL=1,NPCNF
    call c_f_pointer(c_loc(SCR(KLCONF)),iSCRl,[1])
    call GETCNF_LUCIA(iSCRl,ILTYP,IPCNF(ICNL),ICONF,IREFSM,NEL)
    nullify(iSCRl)
    NCSFL = NCSFTP(ILTYP)
    IIRB = 1
    do ICNR=1,ICNL
      call c_f_pointer(c_loc(SCR(KRCONF)),iSCRr,[1])
      call GETCNF_LUCIA(iSCRr,IRTYP,IPCNF(ICNR),ICONF,IREFSM,NEL)
      nullify(iSCRr)
      NCSFR = NCSFTP(IRTYP)
      call c_f_pointer(c_loc(SCR(KLCONF)),iSCRl,[1])
      call c_f_pointer(c_loc(SCR(KRCONF)),iSCRr,[1])
      call CNHCN(iSCRl,ILTYP,iSCRr,IRTYP,SCR(KLPHPS),SCR(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,NTEST,ExFac,IREOTS)
      nullify(iSCRl,iSCRr)
      do IIL=1,NCSFL
        if (IILB == IIRB) then
          IIRMAX = IIL
        else
          IIRMAX = NCSFR
        end if
        do IIR=1,IIRMAX
          IIRACT = IIRB-1+IIR
          IILACT = IILB-1+IIL
          ILRI = (IIR-1)*NCSFL+IIL
          ILRO = ((IILACT*IILACT-IILACT)/2)+IIRACT
          PHP(ILRO) = SCR(KLPHPS-1+ILRI)
        end do
      end do
      IIRB = IIRB+NCSFR
    end do
    IILB = IILB+NCSFL
  end do

  return

end subroutine PHPCSF_INTERNAL

end subroutine PHPCSF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Drvh1_mck(nGrad,Nona)
************************************************************************
*                                                                      *
* Object: driver for computation of gradients of one-electron matrices.*
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January '91                                              *
*             Modified by Anders Bernhardsson for Gradients            *
*             May 95                                                   *
************************************************************************
      Use Basis_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External OvrGrd_mck,KneGrd_mck,nagrd_mck,prjgrd_mck,m1grd_mck ,
     &         srogrd_mck, nona2
      External OvrMem_mck,KneMem_mck,namem_mck,prjmm1,m1mm1, na2mem,
     &         sromm1
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "print.fh"
      Character*8 Label
      Logical Nona, lECP
      Real*8, Allocatable:: Fock(:), D0(:)
*
c     iRout = 131
c     iPrint = nPrint(iRout)
*
      If (show) Then
         nFock = 0
         nDens = 0
         Do 1 iIrrep = 0, nIrrep - 1
            nFock = nFock + nBas(iIrrep)*(nBas(iIrrep)+1)/2
            nDens = nDens + nBas(iIrrep)*(nBas(iIrrep)+1)/2
 1       Continue
*
*...  Read the variational 1st order density matrix
*...  density matrix in AO/SO basis
         Call mma_allocate(D0,nDens,Label='D0')
         Call Get_D1ao_Var(D0,nDens)
*...  Read the generalized Fock matrix
*...  Fock matrix in AO/SO basis
         Call mma_allocate(Fock,nFock,Label='Fock')
         Call Get_Fock_Occ(Fock,nFock)
      Else
         nFock = 1
         nDens = 1
         Call mma_allocate(Fock,nFock,Label='Fock')
         Call mma_allocate(D0,nDens,Label='D0')
         Fock(1)=Zero
         D0(1)=Zero
      End If
      If (Nona) Then
************************************************************************
*0a)                                                                   *
*                                                                      *
*     Antisymmetric gradient of Overlap matrix                         *
*                                                                      *
************************************************************************
          Label='OVRGRDA '
          idcnt=0
          Do iCnttp=1,nCnttp
             Do iCnt=1,dbsc(iCnttp)%nCntr
                idcnt=idcnt+1
                Do idCar=1,3
            Call Cnt1El(OvrGrd_mck,OvrMem_mck,Label,idcnt,idcar,loper,
     &              -One,.false.,Fock,'OVRGRDA ',0)
                End Do
             End Do
          End Do
************************************************************************
*0b)                                                                   *
*                                                                      *
*     Non-adiabatic second derivative integrals                        *
*                                                                      *
************************************************************************
          Label='NONA2   '
          idcnt=0
          Do iCnttp=1,nCnttp
             Do iCnt=1,dbsc(iCnttp)%nCntr
                idcnt=idcnt+1
                Do idCar=1,3
            Call Cnt1El(NONA2,NA2Mem,Label,idcnt,idcar,loper,
     &                  One,.false.,Fock,'NONA2   ',0)
                End Do
             End Do
          End Do
*
      End If
*
************************************************************************
*1)                                                                    *
*                                                                      *
*     Gradient of Overlap matrix                                       *
*                                                                      *
************************************************************************
      Label='OVRGRD  '
      idcnt=0
      Do iCnttp=1,nCnttp
        Do iCnt=1,dbsc(iCnttp)%nCntr
          idcnt=idcnt+1
          Do idCar=1,3
            Call Cnt1El(OvrGrd_mck,OvrMem_mck,Label,idcnt,idcar,loper,
     &               One,.false.,Fock,'OVRGRD  ',0)
          End Do
        End Do
      End Do
*
************************************************************************
*2)                                                                    *
*                                                                      *
*     Gradient of Kinetic operator                                     *
*                                                                      *
*                                                                      *
************************************************************************
      Label='KNEGRD  '
      idcnt=0
      Do iCnttp=1,nCnttp
        Do iCnt=1,dbsc(iCnttp)%nCntr
          idcnt=idcnt+1
          Do idCar=1,3
            Call Cnt1El(KneGrd_mck,KneMem_mck,Label,idcnt,idcar,loper,
     &                  One,.false.,D0,'ONEGRD  ',0)
          End Do
        End Do
      End Do
*
************************************************************************
*3)                                                                    *
*                                                                      *
*     Gradient of Nuclear attraction Operator                          *
*                                                                      *
*                                                                      *
************************************************************************
      Label='NAGRD   '
      idcnt=0
      Do iCnttp=1,nCnttp
        Do iCnt=1,dbsc(iCnttp)%nCntr
          idcnt=idcnt+1
          Do idCar=1,3
            Call Cnt1El(NaGrd_mck,NaMem_mck,Label,idcnt,idcar,loper,
     &                  One,.true.,D0,'ONEGRD  ',1)
          End Do
        End Do
      End Do
*
*
************************************************************************
*3)                                                                    *
*                                                                      *
*     Gradient of Nuclear attraction Operator  ECP-part                *
*                                                                      *
*                                                                      *
************************************************************************
      lECP = .False.
      DO i = 1, nCnttp
         lECP = lECP .or. dbsc(i)%ECP
      End Do
      If (lecp) Then
      idcnt=0
      Do iCnttp=1,nCnttp
        Do iCnt=1,dbsc(iCnttp)%nCntr
          idcnt=idcnt+1
          Do idCar=1,3
            Label='PRJGRD  '
            Call Cnt1El(Prjgrd_mck,PrjMm1,Label,idcnt,idcar,loper,
     &               One,.true.,D0,'ONEGRD  ',1)
            Label='M1GRD  '
            Call Cnt1El(m1grd_mck,m1Mm1,Label,idcnt,idcar,loper,
     &               One,.true.,D0,'ONEGRD  ',1)
            Label='SROGRD  '
            Call Cnt1El(Srogrd_mck,sroMm1,Label,idcnt,idcar,loper,
     &               One,.true.,D0,'ONEGRD  ',1)
          End Do
        End Do
      End Do
      End if
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(D0)
      Call mma_deallocate(Fock)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nGrad)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Bernd Artur Hess                                 *
************************************************************************
      SubRoutine util8(Beta,nZeta,Final,la,lb,Slalbp,Slalbm)
************************************************************************
*                                                                      *
* Object: to assemble the Vp integrals from                            *
*         derivative integrals of the electric potential.              *
*                                                                      *
*     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
*             Chemie, University of Bonn, Germany, August 1994         *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8  Final (nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,3),
     *        Slalbp(nZeta,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2),
     *        Slalbm(nZeta,(la+1)*(la+2)/2, lb   *(lb+1)/2),
     *        Beta(nZeta)
      Character*80 Label
*
*     Statement function for cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
      nElem(ix) = (ix+1)*(ix+2)/2
*
      iRout = 203
      iPrint = nPrint(iRout)
*
*
      If (iPrint.ge.99) Then
          Write (6,*) ' In util8 la,lb=',la,lb
          Call RecPrt('Beta','(5f15.8)',Beta,nZeta,1)
          Do 200 ib = 1, nElem(lb)
             Write (Label,'(A,I2,A)') ' Slalbp(',la,ib,')'
      Call RecPrt(Label,'(5f15.8)',Slalbp(1,1,ib),nZeta,nElem(la+1))
200       Continue
          If (lb.gt.0) Then
             Do 201 ia = 1, nElem(la)
                Write (Label,'(A,I2,A)') ' Slalbm(',la,ib,')'
      Call RecPrt(Label,'(5f15.8)',Slalbm(1,1,ib),nZeta,nElem(lb-1))
201          Continue
          End If
      End If
*
      Do 10 ixa = la, 0, -1
         Do 11 iya = la-ixa, 0, -1
            iza = la-ixa-iya
            ipa = Ind(la,ixa,iza)
*
      Do 20 ixb = lb, 0, -1
         Do 21 iyb = lb-ixb, 0, -1
            izb = lb-ixb-iyb
            ipb = Ind(lb,ixb,izb)
*
            IF (ixb.EQ.0) THEN
             Do 33 iZeta = 1, nZeta
                Final(iZeta,ipa,ipb,1) =
     *         Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb))
33           Continue
            ELSE
             Do 31 iZeta = 1, nZeta
                Final(iZeta,ipa,ipb,1) =
     *         Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb))
     *           -Dble(ixb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb))
31           Continue
            ENDIF
*
            IF (iyb.EQ.0) THEN
*
            Do 63 iZeta = 1, nZeta
               Final(iZeta,ipa,ipb,2) =
     *           Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb))
63          Continue
            ELSE
            Do 62 iZeta = 1, nZeta
               Final(iZeta,ipa,ipb,2) =
     *           Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb))
     *          -Dble(iyb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb))
62          Continue
            ENDIF
*
            IF (izb.EQ.0) THEN
*
            Do 93 iZeta = 1, nZeta
               Final(iZeta,ipa,ipb,3) =
     *         Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1))
93          Continue
            ELSE
            Do 91 iZeta = 1, nZeta
               Final(iZeta,ipa,ipb,3) =
     *         Two*Beta(iZeta)*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1))
     *          -Dble(iza)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1))
91          Continue
            ENDIF
*
21       Continue
20    Continue
*
11       Continue
10    Continue
*
      If (iPrint.ge.49) Then
          Write (6,*) ' In UTIL8 la,lb=',la,lb
          Do 380 iiComp=1,3
             Do 410 jElem = 1, nElem(lb)
          Do 400 iElem = 1, nElem(la)
          Do 390 iiZeta=1,nZeta
                Write (Label,'(A,I2,A,I2,A)')
     *                ' Final (',iElem,',',jElem,') '
*      Call RecPrt(Label,'(5f15.8)',
         write(6,*) iiZeta,iElem,jElem,iiComp,
     *        Final(iiZeta,iElem,jElem,iiComp)
390        Continue
400       Continue
410          Continue
380          Continue
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Markus P. Fuelscher                              *
************************************************************************
      Subroutine ReadVC_m(CMO,OCC,D,DS,P,PA)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     get start MO-coefficients                                        *
*     (if the CI is restarted from a previous calculation get          *
*      also the density matrices)                                      *
*                                                                      *
*     calling arguments:                                               *
*     CMO     : array of real*8                                        *
*               MO-coefficients                                        *
*     OCC     : array of real*8                                        *
*               occupation numbers                                     *
*     INVEC   : integer                                                *
*               flag indicating orbital type                           *
*     D       : array of real*8                                        *
*               averaged one-body density matrix                       *
*     DS      : array of real*8                                        *
*               averaged one-body spin density matrix                  *
*     P       : array of real*8                                        *
*               averaged two body density matrix                       *
*     PA      : array of real*8                                        *
*               averaged antisymmetric twobody density matrix          *
*     FI      : array of real*8                                        *
*               inactive Fock matrix                                   *
*     D1I     : array of real*8                                        *
*               inactive one body density matrix                       *
*     D1A     : array of real*8                                        *
*               active one body density matrix                         *
*     TUVX    : array of real*8                                        *
*               two-electron integrals (tu!vx)                         *
*     IFINAL  : integer                                                *
*               termination flag                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher                                                  *
*     University of Lund, Sweden, 1998                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     none                                                             *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

*     global data declarations

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='READVC  ')
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "warnings.fh"
#include "wadr.fh"
#include "casvb.fh"
#include "raswfn.fh"
      Common /IDSXCI/ IDXCI(mxAct),IDXSX(mxAct)
*     calling arguments

      Dimension CMO(*),OCC(*),D(*),DS(*),P(*),PA(*)

*     local data declarations

              Character*72 JobTit(mxTit)
      DIMENSION IADR19(30)
      Character*80 VecTit
      Character*4 Label
c      Integer StrnLn
      Logical Found
      Logical Changed
      Integer nTmp(8)
      Dimension Dummy(1),iDummy(1)
      Character*(LENIN8*mxOrb) lJobH1
      Character*(2*72) lJobH2

*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
C Local print level (if any)
      IPRLEV=IPRLOC(1)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
*----------------------------------------------------------------------*
* Do we use default orbitals?                                          *
*----------------------------------------------------------------------*
      If(InVec.eq.0) Then
         Call qpg_darray('RASSCF orbitals',Found,nData)
         If(Found) Then
            InVec=6
            IF(IPRLEV.ge.TERSE) THEN
            Write(6,'(6x,a)') 'Orbitals from runfile: rasscf orbitals'
            END IF
         End If
      End If
      Call Check_InVec_m(InVec)
      If(InVec.eq.0) Then
         Call qpg_darray('SCF orbitals',Found,nData)
         If(Found) Then
            InVec=7
            IF(IPRLEV.ge.TERSE) THEN
            Write(6,'(6x,a)') 'Orbitals from runfile: scf orbitals'
            END IF
         End If
      End If
      Call Check_InVec_m(InVec)
      If(InVec.eq.0) Then
         Call qpg_darray('Guessorb',Found,nData)
         If(Found) Then
            InVec=5
            IF(IPRLEV.ge.TERSE) THEN
            Write(6,'(6x,a)') 'Orbitals from runfile: guessorb orbitals'
            END IF
         End If
      End If
      Call Check_InVec_m(InVec)
      If(Invec.eq.0) Then
         InVec=1
      End If
*----------------------------------------------------------------------*
* read from unit formatted ascii file with starting orbitals

* Note: Inside RDVEC, the file StartOrbFile is opened, but uses blindly
* the unit number provided here. So that should better be a usable
* number, or else!
      LUStartOrb=19
      LUStartOrb=IsFreeUnit(LUStartOrb)
      if(ifvb.eq.2)invec=3
      If ( InVec.eq.2 ) then
       Label='CO  '
       If (iAlphaBeta.eq.1) Label(3:3)='A'
       If (iAlphaBeta.eq.-1) Label(3:3)='B'
       if(iOverwr.eq.1) then
        CALL RDVEC(StartOrbFile,LUStartOrb,Label,NSYM,NBAS,NBAS,
     &             CMO, OCC, Dummy, iDummy, VECTIT, 0, iErr)
       else
        Label(4:4)="I"
        Call GetMem('TIND','Allo','Inte',iTIND,maxbfn)
        CALL RDVEC(StartOrbFile,LUStartOrb,Label,NSYM,NBAS,NBAS,
     &          CMO, OCC, Dummy,iWork(iTIND), VECTIT, 0, iErr)
* If the typeindex array is used to resort orbitals, then if also
* a supersymmetry array is used, it has to be changed.
* The supersymmtry array is IXSYM().
* VECSORT is a utility that does not know about supersymmetry.
* So changing any orbital indices in IXSYM (or potentially any
* other orbital indices -- what about ALTER??) must be done HERE
* immediately togather with the VecSort, but not *inside* VecSort.

* But VecSort does not return any indicing information -- how are
* we to know how to change IXSYM?
* VecSort changed to include a reindexing array!
        NNwOrd=0
        Do ISym=1,NSym
         NNwOrd=NNwOrd+NBas(ISym)
        End Do
        Call GetMem('NewOrd','Allo','Inte',LNEWORD,NNwOrd)
*        Call VecSort(NSYM,NBAS,NBAS,CMO,OCC,iWork(iTIND),iErr)
        Call VecSort(NSYM,NBAS,NBAS,CMO,OCC,iWork(iTIND),
     &                              NNwOrd,iWork(lNewOrd),iErr)
* If there is a supersymmetry array, use the orbital mapping:
      If (iSUPSM.ne.0) Then
       Call GetMem('TmpXSym','Allo','Inte',LTMPXSYM,NNwOrd)
       Do I=1,NNwOrd
        J=iWork(lNewOrd-1+I)
        iWork(lTmpXSym-1+I)=IXSYM(J)
       End Do
       Call ICopy(NNwOrd,iWork(lTmpXSym),1,IXSYM,1)
       Call GetMem('TmpXSym','Free','Inte',LTMPXSYM,NNwOrd)
      End If

        Call GetMem('NewOrd','Free','Inte',LNEWORD,NNwOrd)
        Call GetMem('TIND','Free','Inte',iTIND,maxbfn)
       endif
       Close(LUStartOrb)
       if(iErr.eq.1) then
       Write(LF,*) 'RASSCF tried to read input orbitals from a'
       Write(LF,*) 'file, but encountered an error in the'
       Write(LF,*) 'TypeIndex data.'
       call Abend()
       return
       endif

       IF(IPRLEV.ge.TERSE) THEN
        Write(LF,'(6X,A)')
     &         'The MO-coefficients are taken from the file:'
        Write(LF,'(6X,A)') StartOrbFile
        Write(LF,'(6X,A,A)') 'Title:', VecTit(2:80)
       END IF

*     read from unit JOBOLD (binary file)

      Else If ( InVec.eq.3 ) then
        IAD19=0
        iJOB=0
        Call f_Inquire('JOBOLD',Found)
        If (Found) iJOB=1
        If (iJOB.eq.1) Then
           if(JOBOLD.le.0) Then
             JOBOLD=20
             Call DaName(JOBOLD,'JOBOLD')
           end if
        Else
           If (IPRLEV.ge.TERSE) then
              Write(LF,*) '  File JOBOLD not found -- use JOBIPH.'
           End If
           If (JOBIPH.gt.0) Then
              JOBOLD=JOBIPH
           Else
              Call DaName(JOBOLD,IPHNAME)
           End If
        End If
        Call IDaFile(JOBOLD,2,IADR19,15,IAD19)
        IF(IADR19(15).EQ.-1) THEN
          IAD19=0
          CALL IDAFILE(JOBOLD,2,IADR19,30,IAD19)
        ELSE
          DO I=16,30
            IADR19(I)=0
          END DO
          IF(IPRGLB.GE.VERBOSE)
     &               Call WarningMessage(1,'Old JOBIP file layout.')
        END IF
        lll = 1
        lll = MAX(lll,mxSym)
        lll = MAX(lll,mxOrb)
        lll = MAX(lll,RtoI)
        lll = MAX(lll,RtoI*mxRoot)
        CALL GETMEM('JOBOLD','ALLO','INTEGER',lJobH,lll)
        ldJobH=ip_of_Work_i(iWork(lJobH))
        iAd19=iAdr19(1)
        CALL WR_RASSCF_Info(JobOld,2,iAd19,
     &                      iWork(lJobH),iWork(lJobH),iWork(lJobH),
     &                      iWork(lJobH),iWork(lJobH),iWork(lJobH),
     &                      iWork(lJobH),iWork(lJobH),iWork(lJobH),
     &                      mxSym,
     &                      lJobH1,LENIN8*mxOrb,iWork(lJobH),
     &                      lJobH2,2*72,JobTit,72*mxTit,
     &                      Work(ldJobH),iWork(lJobH),
     &                      iWork(lJobH),iWork(lJobH),mxRoot,
     &                      iWork(lJobH),iWork(lJobH),iWork(lJobH),
     &                      iWork(lJobH),iWork(lJobH),iWork(lJobH),
     &                      Work(ldJobH))
        IF(IPRLEV.ge.TERSE) THEN
         If (iJOB.eq.1) Then
            Write(LF,'(6X,A)')
     &      'The MO-coefficients are taken from the file:'
            Write(LF,'(6X,A)') 'JOBOLD'
         Else
            Write(LF,'(6X,A)')
     &      'The MO-coefficients are taken from the file:'
            Write(LF,'(6X,A)') IPHNAME(:mylen(IPHNAME))
         End If
         Write(VecTit(1:72),'(A72)') JobTit(1)
         Write(LF,'(6X,2A)') 'Title:',VecTit(1:72)
        END IF
        CALL GETMEM('JOBOLD','FREE','INTEGER',lJobH,lll)
        iAd19=iAdr19(2)
        Call DDaFile(JobOld,2,CMO,NTOT2,iAd19)
        Call DDaFile(JobOld,2,OCC,nTot,iAd19)
        If ( ICIRST.eq.1) then
         If ( IPRLEV.ge.VERBOSE) then
           If (iJOB.eq.1) Then
              Write(LF,'(6X,A)')
     &        'The active density matrices (D,DS,P,PA) are read from'//
     &        ' file JOBOLD and weighted together.'
           Else
              Write(LF,'(6X,A)')
     &        'The active density matrices (D,DS,P,PA) are read from'//
     &        ' file '//IPHNAME(:mylen(IPHNAME))//
     &        ' and weighted together.'
           End If
         End If
         Call GetMem('Scr','Allo','Real',lscr,NACPR2)
         iDisk = IADR19(3)
         Do jRoot = 1,lRoots
           Scal = 0.0d0
           Do kRoot = 1,nRoots
             If ( iRoot(kRoot).eq.jRoot ) then
               Scal = Weight(kRoot)
             End If
           End Do
           Call DDaFile(JOBOLD,2,Work(lscr),NACPAR,iDisk)
           call daxpy_(NACPAR,Scal,Work(lscr),1,D,1)
           Call DDaFile(JOBOLD,2,Work(lscr),NACPAR,iDisk)
           call daxpy_(NACPAR,Scal,Work(lscr),1,DS,1)
           Call DDaFile(JOBOLD,2,Work(lscr),NACPR2,iDisk)
           call daxpy_(NACPR2,Scal,Work(lscr),1,P,1)
           Call DDaFile(JOBOLD,2,Work(lscr),NACPR2,iDisk)
           call daxpy_(NACPR2,Scal,Work(lscr),1,PA,1)
         End Do
         Call GetMem('Scr','Free','Real',lscr,NACPR2)
        End If
CSVC: read the L2ACT and LEVEL arrays from the jobiph file
         IAD19=IADR19(18)
         IF (IAD19.NE.0) THEN
           CALL IDAFILE(JOBOLD,2,IDXSX,mxAct,IAD19)
           CALL IDAFILE(JOBOLD,2,IDXCI,mxAct,IAD19)
         END IF
        If(JOBOLD.gt.0.and.JOBOLD.ne.JOBIPH) Then
          Call DaClos(JOBOLD)
          JOBOLD=-1
        Else If(JOBOLD.gt.0) Then
          JOBOLD=-1
        End If


*     read from a HDF5 wavefunction file
      Else If (InVec.eq.4) then
#ifdef _HDF5_
        IF(IPRLEV.ge.TERSE) THEN
          Write(LF,'(6X,A)')
     &            'The MO-coefficients are taken from the file:'
          Write(LF,'(6X,A)') StartOrbFile
        END IF

        mh5id = mh5_open_file_r(StartOrbFile)
        call mh5_fetch_dset(mh5id, 'MOCOEF', CMO)
        call mh5_close_file(mh5id)
#else
        write (6,*) 'Orbitals requested from HDF5, but this'
        write (6,*) 'installation does not support that, abort!'
        call abend
#endif

*     guess MO-coefficients

      Else If (InVec.eq.5) then
         IF(IPRLEV.ge.VERBOSE) Write(LF,'(6x,a)')
     &                               'Detected guessorb orbitals'
         Call Qpg_dArray('Guessorb',Found,nData)
         Call Get_dArray('Guessorb',CMO,nData)
         Call Qpg_iArray('nDel_go',Found,nData)
         If(Found) Then
            Call Get_iArray('nDel_go',nTmp,nData)
            Changed=.false.
            Do iSym=1,nSym
               If(nTmp(iSym).gt.nDel(iSym)) Changed=.true.
            End Do
            If(Changed) Then
               Write(6,'(5x,a,8i5)')'Number of deleted orbitals '//
     &                            'changed from',(nDel(i),i=1,nSym)
               Write(6,'(5x,a,8i5)')'                           '//
     &                            'changed to  ',(nTmp(i),i=1,nSym)
            End If
            Do iSym=1,nSym
               If(nTmp(iSym).gt.nDel(iSym)) Then
                  nSsh(iSym)=nSsh(iSym)-nTmp(iSym)+nDel(iSym)
                  nOrb(iSym)=nOrb(iSym)-nTmp(iSym)+nDel(iSym)
                  nOrbT=nOrbT-nTmp(iSym)+nDel(iSym)
                  nDel(iSym)=nTmp(iSym)
               End If
            End Do
            IF(IPRLEV.ge.TERSE) THEN
             Write(LF,'(6X,A)')
     &       'The MO-coefficients are taken from guessorb on runfile'
            END IF
         End If
      Else If (InVec.eq.6) then
         IF(IPRLEV.ge.VERBOSE) Write(LF,'(6x,a)')
     &                               'Detected old RASSCF orbitals'
         Call qpg_darray('RASSCF orbitals',Found,nData)
         Call get_darray('RASSCF orbitals',CMO,nData)
         Call Qpg_iArray('nDel',Found,nData)
         If(Found) Then
            Call Get_iArray('nDel',nTmp,nData)
            Changed=.false.
            Do iSym=1,nSym
               If(nTmp(iSym).gt.nDel(iSym)) Changed=.true.
            End Do
            If(Changed) Then
               Write(6,'(5x,a,8i5)')'Number of deleted orbitals '//
     &                            'changed from',(nDel(i),i=1,nSym)
               Write(6,'(5x,a,8i5)')'                           '//
     &                            'changed to  ',(nTmp(i),i=1,nSym)
            End If
            Do iSym=1,nSym
               If(nTmp(iSym).gt.nDel(iSym)) Then
                  nSsh(iSym)=nSsh(iSym)-nTmp(iSym)+nDel(iSym)
                  nOrb(iSym)=nOrb(iSym)-nTmp(iSym)+nDel(iSym)
                  nOrbT=nOrbT-nTmp(iSym)+nDel(iSym)
                  nDel(iSym)=nTmp(iSym)
               End If
            End Do
            IF(IPRLEV.ge.TERSE) THEN
             Write(LF,'(6X,A,A)') 'The MO-coefficients are taken from',
     &                                    ' rasscf orbitals on runfile'
            END IF
         End If
      Else If (InVec.eq.7) then
         IF(IPRLEV.ge.VERBOSE) Write(LF,'(6x,a)')
     &                               'Detected SCF orbitals'
         Call qpg_darray('SCF orbitals',Found,nData)
         Call get_darray('SCF orbitals',CMO,nData)
         Call Qpg_iArray('nDel',Found,nData)
         If(Found) Then
            Call Get_iArray('nDel',nTmp,nData)
            Changed=.false.
            Do iSym=1,nSym
               If(nTmp(iSym).gt.nDel(iSym)) Changed=.true.
            End Do
            If(Changed) Then
               Write(6,'(5x,a,8i5)')'Number of deleted orbitals '//
     &                            'changed from',(nDel(i),i=1,nSym)
               Write(6,'(5x,a,8i5)')'                           '//
     &                            'changed to  ',(nTmp(i),i=1,nSym)
            End If
            Do iSym=1,nSym
               If(nTmp(iSym).gt.nDel(iSym)) Then
                  nSsh(iSym)=nSsh(iSym)-nTmp(iSym)+nDel(iSym)
                  nOrb(iSym)=nOrb(iSym)-nTmp(iSym)+nDel(iSym)
                  nOrbT=nOrbT-nTmp(iSym)+nDel(iSym)
                  nDel(iSym)=nTmp(iSym)
               End If
            End Do
         End If
         IF(IPRLEV.ge.TERSE) THEN
           Write(LF,'(6X,A,A)') 'The MO-coefficients are taken from',
     &                                 ' scf orbitals on runfile'
         END IF
      Else If (InVec.eq.1) then
        IF(IPRLEV.ge.VERBOSE) Write(LF,'(6X,2A)')
     &  'The MO-coefficients are obtained by diagonalizing ',
     &  'the core Hamiltonian'
        Call Guess_m(CMO)
      Else
       Write(LF,*) 'Severe internal bug prevents further calculation.'
       Write(LF,*) 'Invalid value for INVEC in READVC. Program stops.'
       Write(LF,*) 'Please issue bug report. INVEC=',INVEC
       CALL QUIT(_RC_GENERAL_ERROR_)
      End If
*     print start orbitals
      IF(IPRLEV.GE.DEBUG) THEN
        CALL GETMEM('DumE','Allo','Real',LENE,nTot)
        CALL DCOPY_(nTot,[0.0D0],0,WORK(LENE),1)
        CALL PRIMO_RASSCF_m('Input orbitals',WORK(LENE),OCC,CMO)
        CALL GETMEM('DumE','Free','Real',LENE,nTot)
      END IF

*     cleaning orbitals for high symmetry cases

      If(iClean.ne.0) Call ClnMO_m(CMO)
      If(PURIFY(1:6).eq.'LINEAR') CALL LINPUR_m(CMO)
      If(PURIFY(1:4).eq.'ATOM') CALL SPHPUR_m(CMO)

*     orthogonalize the molecular orbitals
* New orthonormalization routine, with additional deletion of
* linear dependence.
      CALL GETMEM('CMOO','ALLO','REAL',LCMOO,NTOT2)
      CALL DCOPY_(NTOT2,CMO,1,WORK(LCMOO),1)
!      CALL ONCMO_m(WORK(LCMOO),CMO)
      CALL GETMEM('CMOO','FREE','REAL',LCMOO,NTOT2)

*     save start orbitals

!      IAD15=IADR15(2)
!      CALL DDAFILE(JOBIPH,1,CMO,NTOT2,IAD15)
!      CALL DDAFILE(JOBIPH,1,OCC,NTOT,IAD15)

*     exit

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkE_Y3(Va,V,dima,dimb,no)
! this routine does:
! Va(a',i,b',j) = 2 V(a',j,b',i) - V(a',i,b',j)
!
! N.B. Kvajt odflaknute

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, no
real(kind=wp), intent(out) :: Va(dima,no,dimb,no)
real(kind=wp), intent(in) :: V(dima,no,dimb,no)
integer(kind=iwp) :: b, j

do j=1,no
  do b=1,dimb
    Va(:,:,b,j) = Two*V(:,j,b,:)-V(:,:,b,j)
  end do
end do

return

end subroutine MkE_Y3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1997, Roland Lindh                                *
!***********************************************************************

subroutine DefInt2(BVct,dBVct,nBvct,BMtrx,mInt,nAtom,nLines,Val,rInt,rInt0,Lbl,lWrite,rMult,dBMtrx,Value0,lIter,iFlip)
!***********************************************************************
!                                                                      *
! Object: to generate the B matrix for the constraints                 *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             May '91                                                  *
!                                                                      *
!             Modified to constraints, June '97 by R. Lindh            *
!***********************************************************************

use UnixInfo, only: SuperName
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half, Pi, Angstrom, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBvct, mInt, nAtom, nLines, lIter
real(kind=wp), intent(out) :: BVct(3*nAtom,nBVct), dBVct(3*nAtom,3*nAtom,nBVct), BMtrx(3*nAtom,mInt), Val(nBVct), rInt(mInt), &
                              rInt0(mInt), rMult(nBVct,nBVct), dBMtrx(3*nAtom,3*nAtom,mInt)
character(len=8), intent(out) :: Lbl(mInt)
logical(kind=iwp), intent(inout) :: lWrite
real(kind=wp), intent(inout) :: Value0(nBVct)
integer(kind=iwp), intent(out) :: iFlip(nBVct)
integer(kind=iwp) :: i1, i2, i3, iBMtrx, iBVct, iEnd, iFrst, iInt, iLines, iType, jBVct, jEnd, jLines, Lu_UDC, &
                     mCntr, msAtom, n0, nCntr, neq, nGo, nGo2, nMinus, nPlus, nrInt0, nTemp
real(kind=wp) :: Fact, MaxErr, Sgn, Tmp
logical(kind=iwp) :: Found, InSlapaf, rInt0_in_memory, rInt0_on_file, Skip, Start
character(len=120) :: Line, Temp
character(len=16) :: filnam
character(len=8) :: Frmt
character(len=6) :: Typ
integer(kind=iwp), allocatable :: Ind(:), tpc(:)
real(kind=wp), allocatable :: Grad(:), Hess(:), Mass(:), r0(:), xyz(:)
character(len=8), allocatable :: Labels(:)
integer(kind=iwp), parameter :: Flip = 1, NoFlip = 0

call mma_allocate(Labels,nBVct,Label='Labels')

! Initiate some stuff for automatic setting of
! the constraints to be those that the structure
! actually has initially.

rInt0_on_file = .false.
InSlapaf = SuperName == 'slapaf'
if (InSlapaf) call qpg_dArray('rInt0',rInt0_on_file,nrInt0)
if (.not. rInt0_on_File) nrInt0 = mInt
rInt0_in_memory = .false.

Start = lIter == 1
iFlip(:) = Flip

nTemp = len(Temp)
write(Frmt,'(A,I3.3,A)') '(F',nTemp,'.0)'

Lu_UDC = 91
filnam = 'UDC'
call molcas_open(Lu_UDC,filnam)
!open(Lu_UDC,File=filnam,Form='FORMATTED',Status='OLD')
rewind(Lu_UDC)

rMult(:,:) = Zero
#ifdef _DEBUGPRINT_
lWrite = .true.
if (lWrite) then
  write(u6,*)
  call CollapseOutput(1,'Constraints section')
  write(u6,'(34X,A)') 'CONSTRAINTS'
  write(u6,*)
  write(u6,'(A)') repeat('*',80)
  do iLines=1,nLines
    read(Lu_UDC,'(A)') Line
    write(u6,'(A)') trim(Line)
  end do
  write(u6,'(A)') repeat('*',80)
  write(u6,*)
  write(u6,*)
  write(u6,*) '*************************************************************'
  write(u6,*) '* Values of the primitive constraints                       *'
  write(u6,*) '*************************************************************'
  rewind(Lu_UDC)
end if
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Step 1. Set up the b vectors from which we will define the constraints.
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
iBVct = 0
call mma_allocate(tpc,nBVct,Label='tpc')
Found = .false.
do iLines=1,nLines
  read(Lu_UDC,'(A)') Line
  Temp = Line
  call UpCase(Temp)
  if (Temp(1:4) == 'VALU') then
    Found = .true.
    exit
  end if
  iBVct = iBVct+1

  ! Move the label of the internal coordinate

  neq = index(Line,'=')
  if (neq == 0) then
    call WarningMessage(2,'Error in DefInt2')
    write(u6,'(A)') ' Syntax error in line:'
    write(u6,'(A)') Line
    call Quit_OnUserError()
  else
    iFrst = 1
    call NxtWrd(Line,iFrst,iEnd)
    jEnd = iEnd
    if (Line(iEnd:iEnd) == '=') jEnd = jEnd-1
    if (jEnd-iFrst+1 > 8) then
      call WarningMessage(2,'Error in DefInt2')
      write(u6,'(A,A)') Line(iFrst:jEnd),' has more than 8 character, syntax error!'
      call Quit_OnUserError()
    end if
    call ChkLbl(Line(iFrst:jEnd),Labels,iBVct-1)
    Labels(iBVct) = Line(iFrst:jEnd)
  end if

  ! Construct the corresponding transformation vector

  mCntr = 0
  iType = 0
  if (index(Temp,'CART') /= 0) then
    nCntr = 1
    nGo = index(Temp,'CART')
    call NxtWrd(Temp,nGo,nGo2)
    nGo = nGo2+1
    call NxtWrd(Temp,nGo,nGo2)
    if (Temp(nGo:nGo2) == 'X') then
      nGo = nGo2+1
      call NxtWrd(Temp,nGo,nGo2)
      Typ = 'X     '
      iType = 1
    else if (Temp(nGo:nGo2) == 'Y') then
      nGo = nGo2+1
      call NxtWrd(Temp,nGo,nGo2)
      Typ = 'Y     '
      iType = 2
    else if (Temp(nGo:nGo2) == 'Z') then
      nGo = nGo2+1
      call NxtWrd(Temp,nGo,nGo2)
      Typ = 'Z     '
      iType = 3
    else
      nGo = -1
      call WarningMessage(2,'Error in DefInt2')
      write(u6,*) 'DefInt2: wrong cartesian type'
      write(u6,'(A,A)') 'Temp=',Temp
      call Quit_OnUserError()
    end if
  else if (index(Temp,'BOND') /= 0) then
    nCntr = 2
    nGo = index(Temp,'BOND')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'STRTCH'
    iType = 4
  else if (index(Temp,'LANGLE(2)') /= 0) then
    nCntr = 3
    nGo = index(Temp,'LANGLE(2)')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'LBEND2'
    iType = 5
  else if (index(Temp,'LANGLE(1)') /= 0) then
    nCntr = 3
    nGo = index(Temp,'LANGLE(1)')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'LBEND1'
    iType = 6
  else if (index(Temp,'ANGL') /= 0) then
    nCntr = 3
    nGo = index(Temp,'ANGL')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'BEND  '
    iType = 7
  else if (index(Temp,'DIHE') /= 0) then
    nCntr = 4
    nGo = index(Temp,'DIHE')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'TRSN  '
    ! AOM!! Remove flip for Torsions!!!
    iFlip(iBVct) = NoFlip
    iType = 8
  else if (index(Temp,'OUTO') /= 0) then
    nCntr = 4
    nGo = index(Temp,'OUTO')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'OUTOFP'
    iFlip(iBVct) = NoFlip
    iType = 9
  else if (index(Temp,'EDIF') /= 0) then
    nCntr = nAtom
    nGo = index(Temp,'EDIF')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'EDIFF '
    iFlip(iBVct) = NoFlip
    iType = 10
  else if (index(Temp,'SPHE') /= 0) then
    nCntr = nAtom
    nGo = index(Temp,'SPHE')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'SPHERE'
    iType = 11
  else if (index(Temp,'NAC ') /= 0) then
    nCntr = nAtom
    nGo = index(Temp,'NAC ')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'NAC   '
    iType = 12
  else if (index(Temp,'TRAN') /= 0) then
    nCntr = nAtom
    nGo = index(Temp,'TRAN')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'TRANSV'
    iFlip(iBVct) = NoFlip
    iType = 13
  else if (index(Temp,'DISS') /= 0) then
    i1 = index(Line,'(')
    i2 = index(Line,'+')
    i3 = index(Line,')')
    if ((i1 >= i2) .or. (i2 >= i3)) then
      call WarningMessage(2,'Error in DefInt2')
      write(u6,*)
      write(u6,*) '********** ERROR ************'
      write(u6,*) ' Line contains syntax error !'
      write(u6,'(A)') Line
      write(u6,*) i1,i2,i3
      write(u6,*) '*****************************'
      call Quit_OnUserError()
    end if
    nGo = i3+1
    Temp = Line(i1+1:i2-1)
    read(Temp,Frmt) Tmp
    nCntr = nint(Tmp)
    Temp = Line(i2+1:i3-1)
    read(Temp,Frmt) Tmp
    mCntr = nint(Tmp)
    Typ = 'DISSOC'
    iType = 14
  else
    nGo = -1
    call WarningMessage(2,'Error in DefInt2')
    write(u6,*) ' Line contains syntax error!'
    write(u6,'(A)') Line
    call Quit_OnUserError()
  end if
  tpc(iBVct) = iType

  msAtom = nCntr+mCntr
  call mma_allocate(xyz,3*msAtom,Label='xyz')
  call mma_allocate(Grad,3*msAtom,Label='Grad')
  call mma_allocate(Ind,2*msAtom,Label='Ind')
  call mma_allocate(Mass,msAtom,Label='Mass')
  call mma_allocate(Hess,(3*msAtom)**2,Label='Hess')

  call Cllct2(Line(nGo:nTemp),BVct(:,iBVct),dBVct(:,:,iBVct),Val(iBVct),nAtom,nCntr,mCntr,xyz,Grad,Ind,Typ,Mass,Labels(iBVct), &
              lWrite,rMult(iBVct,iBVct),Hess,lIter)

  if ((Typ == 'TRSN  ') .and. (abs(Val(iBVct)) < Pi*Half)) iFlip(iBVct) = NoFlip

  call mma_deallocate(Hess)
  call mma_deallocate(Mass)
  call mma_deallocate(Ind)
  call mma_deallocate(Grad)
  call mma_deallocate(xyz)

end do

if (.not. Found) then
  call WarningMessage(2,'Error in DefInt2')
  write(u6,*) 'DefInt2: No internal coordinates are defined!'
  call Quit_OnUserError()
end if

! Process primitive value to correct for flips

if (.not. Start) then
  do iBVct=1,nBVct

    ! Test if we have a flip in the sign of the value

    if ((Val(iBVct)*Value0(iBVct) < Zero) .and. (iFlip(iBVct) == Flip)) then
      !write(u6,*) 'Flip Sign for ',Labels(iBVct)
      Val(iBVct) = -Val(iBVct)
    end if
  end do
end if
Value0(:) = Val(:)

#ifdef _DEBUGPRINT_
call RecPrt(' The B-vectors',' ',BVct,3*nAtom,nBVct)
call RecPrt(' Value of primitive internal coordinates / au or rad',' ',Val,nBVct,1)
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Step 2. Define constraints as linear combinations of
!         the previously defined primitive internal coordinates.
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
iBMtrx = 0
jLines = iLines
do
  jLines = jLines+1
  if (jLines > nLines) exit

  read(Lu_UDC,'(A)') Line
  Temp = Line
  call UpCase(Temp)

  iBMtrx = iBMtrx+1
  rInt(iBMtrx) = Zero
  write(Lbl(iBMtrx),'(A,I3.3)') 'Cns',iBMtrx

  ! Find the label of the first primitive

  iFrst = 1
  call NxtWrd(Line,iFrst,iEnd)
  jEnd = iEnd
  if (Line(iEnd:iEnd) == '=') jEnd = iEnd-1

  nPlus = index(Line,' + ')
  nMinus = index(Line,' - ')
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if ((nPlus == 0) .and. (nMinus == 0) .and. (index(Line,'&') == 0)) then
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! a single vector (this will only extend over one line)

    if (index(Line,'&') /= 0) then
      call WarningMessage(2,'Error in DefInt2')
      write(u6,*) 'Single vector lines should not extend'
      write(u6,*) 'over more than one line!'
      write(u6,'(A)') Line
      call Quit_OnUserError()
    end if
    iBVct = 0
    do jBVct=1,nBVct
      if (Line(iFrst:jEnd) == Labels(jBVct)) iBVct = jBVct
    end do
    if (iBVct == 0) then
      call WarningMessage(2,'Error in DefInt2')
      write(u6,*) ' A single vector'
      write(u6,*) ' Undefined internal coordinate'
      write(u6,'(A,A)') Line
      write(u6,'(A,A)') Line(iFrst:jEnd)
      call Quit_OnUserError()
    end if

    BMtrx(:,iBMtrx) = BVct(:,iBVct)
    dBMtrx(:,:,iBMtrx) = dBVct(:,:,iBVct)
    rInt(iBMtrx) = Val(iBVct)

    iFrst = iEnd+1
    call NxtWrd(Line,iFrst,iEnd)
    if (Line(iEnd:iEnd) == '=') then
      iFrst = iEnd+1
      call NxtWrd(Line,iFrst,iEnd)
    end if
    Temp = Line(iFrst:iEnd)

    if (index(Temp,'FIX') /= 0) then

      ! Pick up values from the runfile. Written there on the first iteration.

      if (.not. rInt0_in_memory) then
        rInt0_in_memory = .true.
        call mma_allocate(r0,nrInt0,Label='r0')
        if (rInt0_on_file) then
          call Get_dArray('rInt0',r0,nrInt0)
        else
          r0(:) = Zero
        end if
      end if

      if (rInt0_on_file) then
        rInt0(iBMtrx) = r0(iBMtrx)
      else
        r0(iBmtrx) = rInt(iBMtrx)
        rInt0(iBMtrx) = rInt(iBMtrx)
      end if

    else

      ! Read value from input file.

      read(Temp,Frmt) rInt0(iBMtrx)
      Temp = Line
      call UpCase(Temp)
      if (index(Temp,'ANGSTROM') /= 0) rInt0(iBMtrx) = rInt0(iBMtrx)/Angstrom
      if (index(Temp,'DEGREE') /= 0) rInt0(iBMtrx) = rInt0(iBMtrx)*deg2rad
    end if

    ! AOM: trying to correct torsion...
    if (tpc(iBVct) == 8) then
      n0 = int((rInt(iBMtrx)-rInt0(iBMtrx))/(Two*Pi))
      if (abs(rInt(IBMtrx)-rInt0(iBMtrx)-n0*Two*Pi) > abs(rInt(IBMtrx)-rInt0(iBMtrx)-(n0+1)*Two*Pi)) then
        n0 = n0+1
      else if (abs(rInt(IBMtrx)-rInt0(iBMtrx)-n0*Two*Pi) > abs(rInt(IBMtrx)-rInt0(iBMtrx)-(n0-1)*Two*Pi)) then
        n0 = n0-1
      end if
      rInt(iBMtrx) = rInt(iBMtrx)-n0*Two*Pi
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! A linear combination of vectors

    BMtrx(:,iBMtrx) = Zero
    dBMtrx(:,:,iBMtrx) = Zero
    iFrst = 1
    Sgn = One

    ! Process the rest of the line and possible extension lines

    Skip = .false.
    do

      if (Skip) then
        Skip = .false.
      else
        !                                                              *
        !***************************************************************
        !                                                              *
        !> Get the factor
        call NxtWrd(Line,iFrst,iEnd)
        Temp = Line(iFrst:iEnd)
        read(Temp,Frmt) Fact
        Fact = Fact*Sgn
        iFrst = iEnd+1
        !> Get the label
        call NxtWrd(Line,iFrst,iEnd)
        if (Line(iEnd:iEnd) == '=') iEnd = iEnd-1
        iBVct = 0
        do jBVct=1,nBVct
          if (Line(iFrst:iEnd) == Labels(jBVct)) iBVct = jBVct
        end do
        if (iBVct == 0) then
          call WarningMessage(2,'Error in DefInt2')
          write(u6,*) ' Linear combinations of vectors'
          write(u6,*) ' Undefined internal coordinate'
          write(u6,'(A,A)') Line
          write(u6,'(A,A)') Line(iFrst:iEnd)
          call Quit_OnUserError()
        end if

        BMtrx(:,iBMtrx) = BMtrx(:,iBMtrx)+Fact*BVct(:,iBVct)
        dBMtrx(:,:,iBMtrx) = dBMtrx(:,:,iBMtrx)+Fact*dBVct(:,:,iBVct)
        rInt(iBMtrx) = rInt(iBMtrx)+Fact*Val(iBVct)
        !                                                              *
        !***************************************************************
        !                                                              *

        iFrst = iEnd+1
      end if
      Temp = Line(iFrst:nTemp)
      nEq = index(Temp,'=')
      nPlus = index(Temp,'+')
      nMinus = index(Temp,'-')

      if ((nEq /= 0) .and. ((nEq < nMinus) .eqv. (nMinus > 0)) .and. ((nEq < nPlus) .eqv. (nPlus > 0))) then
        if (index(Line,'&') /= 0) then
          call WarningMessage(2,'Error in DefInt2')
          write(u6,*) 'This line should not be extended'
          write(u6,'(A)') Line
          call Quit_OnUserError()
        end if
        iFrst = iFrst+nEq+1
        call NxtWrd(Line,iFrst,iEnd)
        Temp = Line(iFrst:iEnd)

        if (index(Temp,'FIX') /= 0) then

          ! Pick up values from the runfile. Written there on the first iteration.

          if (.not. rInt0_in_memory) then
            rInt0_in_memory = .true.
            call mma_allocate(r0,nrInt0,Label='r0')
            if (rInt0_on_file) then
              call Get_dArray('rInt0',r0,nrInt0)
            else
              r0(:) = Zero
            end if
          end if

          if (rInt0_on_file) then
            rInt0(iBMtrx) = r0(iBMtrx)
          else
            r0(iBmtrx) = rInt(iBMtrx)
          end if

        else

          ! Read value from input file.

          read(Temp,Frmt) rInt0(iBMtrx)
          Temp = Line
          call UpCase(Temp)
          if (index(Temp,'ANGSTROM') /= 0) rInt0(iBMtrx) = rInt0(iBMtrx)/Angstrom
          if (index(Temp,'DEGREE') /= 0) rInt0(iBMtrx) = rInt0(iBMtrx)*deg2rad
        end if
        exit
      end if

      if ((nPlus /= 0) .and. ((nPlus < nMinus) .eqv. (nMinus > 0))) then
        Sgn = One
        iFrst = iFrst+nPlus
        cycle
      end if

      if ((nMinus /= 0) .and. ((nMinus < nPlus) .eqv. (nPlus > 0))) then
        Sgn = -One
        iFrst = iFrst+nMinus
        cycle
      end if

      ! Here if all statements processed of this line

      if (index(Line,'&') == 0) exit
      jLines = jLines+1
      if (jLines > nLines) then
        call WarningMessage(2,'Error in DefInt2')
        write(u6,*) 'DefInt2: jLines > nLines'
        call Quit_OnUserError()
      end if
      read(Lu_UDC,'(A)') Line
      iFrst = 1
      call NxtWrd(Line,iFrst,iEnd)
      if (Line(iFrst:iEnd) == '+') then
        iFrst = iEnd+1
        Sgn = One
      else if (Line(iFrst:iEnd) == '-') then
        iFrst = iEnd+1
        Sgn = -One
      else if (Line(iFrst:iEnd) == '=') then
        iFrst = 1
        Skip = .true.
      else
        call WarningMessage(2,'Error in DefInt2')
        write(u6,*) ' Syntax Error: first character in  extension line is not + or -'
        write(u6,'(A)') Line
        write(u6,'(3A)') '-->',Line(iFrst:iEnd),'<--'
        call Quit_OnUserError()
      end if
    end do

    ! At the end of this line

    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end do

#ifdef _DEBUGPRINT_
call RecPrt(' The B-matrix',' ',BMtrx,3*nAtom,mInt)
do iInt=1,mInt
  call RecPrt(' The dB-matrix',' ',dBMtrx(:,:,iInt),3*nAtom,3*nAtom)
end do
#endif
close(Lu_UDC)
call mma_deallocate(tpc)
if (rint0_in_memory) then
  if (InSlapaf) call Put_dArray('rInt0',r0,mInt)
  call mma_deallocate(r0)
end if

! Compute the maximum error in the constraints

MaxErr = Zero
do iInt=1,mInt
  MaxErr = max(MaxErr,abs(rInt(iInt)-rInt0(iInt)))
end do
call Put_dScalar('Max error',MaxErr)

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*)
write(u6,*) '*******************************************'
write(u6,*) '* Values of the constraints   / au or rad *'
write(u6,*) '*******************************************'
write(u6,*) '  Label        C         C0'
write(u6,'(1X,A,2X,F10.6,F10.6)') (Lbl(iInt),rInt(iInt),rInt0(iInt),iInt=1,mInt)
write(u6,*)
call CollapseOutput(0,'Constraints section')
write(u6,*)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Labels)

end subroutine DefInt2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SS_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
      w0ss1=0.d0
      w1ss1=0.d0
      w0ss2=0.d0
      w1ss2=0.d0
      w0ss3=0.d0
      w1ss3=0.d0
      w0ss4=0.d0
      w1ss4=0.d0
      w0ss5=0.d0
      w1ss5=0.d0
      w0ss6=0.d0
      w1ss6=0.d0
      w0ss7=0.d0
      w1ss7=0.d0
      w0ss8=0.d0
      w1ss8=0.d0
      w0ss9=0.d0
      w1ss9=0.d0
      w0ss10=0.d0
      w1ss10=0.d0
      w0ss11=0.d0
      w1ss11=0.d0
      w0ss12=0.d0
      w1ss12=0.d0
      w0ss13=0.d0
      w1ss13=0.d0
      w0ss14=0.d0
      w1ss14=0.d0
      w0ss15=0.d0
      w1ss15=0.d0
      w0ss16=0.d0
      w1ss16=0.d0
      w0ss18=0.d0
      w1ss18=0.d0

!SS(1-1)  Ar(01)-Bl(32)-
!SS(1-2)  Ar(02)-Bl(31)-
!SS(1-3)  Ar(13)-Bl(20)-
!SS(1-4)  Ar(23)-Bl(10)-
!SS(1-5)  (22)-Ar(13)-Bl(31)-
!SS(1-6)  (11)-Ar(23)-Bl(32)-
!SS(1-7)  Ar(13)-C'(21)-Bl(32)-
!SS(1-8)  Ar(13)-C'(22)-Bl(31)-
!SS(1-9)  Ar(23)-C'(11)-Bl(32)-
!SS(1-10) Ar(23)-C'(12)-Bl(31)-
!SS(1-11) Ar(13)-Bl(31)-C"(22)-
!SS(1-12) Ar(13)-Bl(32)-C"(21)-
!SS(1-13) Ar(23)-Bl(31)-C"(12)-
!SS(1-14) Ar(23)-Bl(32)-C"(11)-
!SS(1-15) (22)-Drl(11)-
!SS(1-16) (11)-Drl(22)-
!SS(1-17) Drl(22)-C"(11)-
!SS(1-18) Drl(11)-C"(22)-
!SS(1-19) Drl(12)-C"(21)-
!SS(1-20) Drl(33)-C"(00)-
!SS(1-20) Drl(33)-C"(11)-C"(22)-
!SS(1-20) (11)Drl(33)-C"(22)-
!SS(1-20) (11)(22)Drl(33)-
!SS(1-20) Drl(33)-C"(22)-C"(11)-
!SS(1-20) (22)Drl(33)-C"(11)-
!SS(1-20) (22)(11)Drl(33)-
!ss(1-20) (21)(12)Drl(33)-


      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          JMLR=MUL_TAB(JML,JMR)
          IF(LMIJ.NE.JMLR) CYCLE
          W0SS2=W0_SS(2)
          W1SS2=W1_SS(2)
          W0SS4=W0_SS(4)
          W1SS4=W1_SS(4)
          W0SS5=W0_SS(5)
          W1SS5=W1_SS(5)
          W0SS10=-W0_SS(10)
          W1SS10=-W1_SS(10)
          W0SS14=W0_SS(14)
          W1SS14=W1_SS(14)
          IF(JB_SYS.GT.0) THEN
            W0SS1=W0_SS(1)
            W1SS1=W1_SS(1)
            W0SS3=W0_SS(3)
            W1SS3=W1_SS(3)
            W0SS6=W0_SS(6)
            W1SS6=W1_SS(6)
            W0SS7=W0_SS(7)
            W1SS7=W1_SS(7)
            W0SS8=W0_SS(8)
            W1SS8=W1_SS(8)
            W0SS9=W0_SS(9)
            W1SS9=W1_SS(9)
            W0SS11=W0_SS(11)
            W1SS11=W1_SS(11)
            W0SS12=W0_SS(12)
            W1SS12=W1_SS(12)
            W0SS13=W0_SS(13)
            W1SS13=W1_SS(13)
          ENDIF
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W0SS2=-W0SS2
            W1SS2=-W1SS2
            W0SS4=-W0SS4
            W1SS4=-W1SS4
            W0SS5=-W0SS5
            W1SS5=-W1SS5
            W0SS10=-W0SS10
            W1SS10=-W1SS10
            W0SS14=-W0SS14
            W1SS14=-W1SS14
            IF(JB_SYS.GT.0) THEN
              W0SS1=-W0SS1
              W1SS1=-W1SS1
              W0SS3=-W0SS3
              W1SS3=-W1SS3
              W0SS6=-W0SS6
              W1SS6=-W1SS6
              W0SS7=-W0SS7
              W1SS7=-W1SS7
              W0SS8=-W0SS8
              W1SS8=-W1SS8
              W0SS9=-W0SS9
              W1SS9=-W1SS9
              W0SS11=-W0SS11
              W1SS11=-W1SS11
              W0SS12=-W0SS12
              W1SS12=-W1SS12
              W0SS13=-W0SS13
              W1SS13=-W1SS13
            ENDIF
          ENDIF

          IF(JML.EQ.1.AND.LMIJ.EQ.JMR) THEN
            IWDL=JUST(LRI,LRI)
!SS(1-1)   Ar(01)-Bl(32)-
            IF(JB_SYS.GT.0) THEN
              IWDR=JUST(LRJ,LRI)
              VLOP0=W0*W0SS1
              VLOP1=W1*W1SS1
      IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
        CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
      IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
      IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF

            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :      CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

            ENDIF
!SS(1-2)  Ar(02)-Bl(31)-
            IWDR=JUST(LRI,LRJ)
            VLOP0=W0*W0SS2
            VLOP1=W1*W1SS2
      IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
        CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
      IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
      IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :  CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

         ENDIF

          IF(JMR.EQ.1.AND.LMIJ.EQ.JML) THEN
            IWDR=JUST(LRJ,LRJ)
!SS(1-3)  Ar(13)-Bl(20)-
            IF(JB_SYS.GT.0) THEN
              IWDL=JUST(LRJ,LRI)
              VLOP0=W0*W0SS3
              VLOP1=W1*W1SS3
      IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
        CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
      IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
      IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :         CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

            ENDIF
!SS(1-4)  Ar(23)-Bl(10)-        ACT -C"-                         ! IPRAD
            IWDL=JUST(LRI,LRJ)
            VLOP0=W0*W0SS4
            VLOP1=W1*W1SS4
      IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
        CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
      IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
      IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
      ENDIF
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :  CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)
         ENDIF

          VLOP0=W0*W0SS5
          VLOP1=W1*W1SS5
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
            CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
        IF(JB_SYS.GT.0) THEN
          VLOP0=W0*W0SS6
          VLOP1=W1*W1SS6
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
           CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
        ENDIF
          DO LRK=NORB_FRZ+1,LRI-1
            LMK=LSM_INN(LRK)
            LMKI=MUL_TAB(LMK,LMI)
            LMKJ=MUL_TAB(LMK,LMJ)
            IF(LMKI.EQ.JML.AND.LMKJ.EQ.JMR) THEN
!SS(1-5)  (22)-Ar(13)-Bl(31)-
              IWDL=JUST(LRK,LRI)
              IWDR=JUST(LRK,LRJ)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :         CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

              IF(JB_SYS.GT.0) THEN
!SS(1-6)  (11)-Ar(23)-Bl(32)-
                IWDL=JUST(LRI,LRK)
                IWDR=JUST(LRJ,LRK)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_1,JPER,LIST1_1)

              ENDIF
            ENDIF
          ENDDO

       IF(JB_SYS.GT.0) THEN
          VLOP0=W0*W0SS7
          VLOP1=W1*W1SS7
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
           CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          VLOP0=W0*W0SS8
          VLOP1=W1*W1SS8
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
           CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_2,LIST0_2,
     :                     WL1_2,LIST1_2)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_2,LIST0_2,
     :                     WL1_2,LIST1_2)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_2,LIST0_2,
     :                     WL1_2,LIST1_2)
          ENDIF
          VLOP0=W0*W0SS9
          VLOP1=W1*W1SS9
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
           CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_3,LIST0_3,
     :                     WL1_3,LIST1_3)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_3,LIST0_3,
     :                     WL1_3,LIST1_3)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_3,LIST0_3,
     :                     WL1_3,LIST1_3)
          ENDIF
        ENDIF
          VLOP0=W0*W0SS10
          VLOP1=W1*W1SS10
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
           CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_4,LIST0_4,
     :                     WL1_4,LIST1_4)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_4,LIST0_4,
     :                     WL1_4,LIST1_4)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_4,LIST0_4,
     :                     WL1_4,LIST1_4)
          ENDIF

          DO LRK=LRI+1,LRJ-1
            LMK=LSM_INN(LRK)
            LMKI=MUL_TAB(LMK,LMI)
            LMKJ=MUL_TAB(LMK,LMJ)
            IF(LMKI.EQ.JML.AND.LMKJ.EQ.JMR) THEN
              IF(JB_SYS.GT.0) THEN
!SS(1-7)  Ar(13)-C'(21)-Bl(32)-
                IWDL=JUST(LRK,LRI)
                IWDR=JUST(LRJ,LRK)
C                CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,-WL1,JPER)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :      CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL1_1,JPER,LIST1_1)

!SS(1-8)  Ar(13)-C'(22)-Bl(31)-
                IWDL=JUST(LRK,LRI)
                IWDR=JUST(LRK,LRJ)
C                CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,-WL2,JPER)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL0_2,JPER,LIST0_2)
      IF(LIST1_2.NE.0)
     :      CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL1_2,JPER,LIST1_2)

!SS(1-9)  Ar(23)-C'(11)-Bl(32)-
                IWDL=JUST(LRI,LRK)
                IWDR=JUST(LRJ,LRK)
!               WL=(VLOP0-VLOP1)*vint_ci(LIST)-2*VLOP0*vint_ci(LIST+1)
C                CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,-WL3,JPER)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL0_3,JPER,LIST0_3)
      IF(LIST1_3.NE.0)
     :      CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL1_3,JPER,LIST1_3)

              ENDIF
!SS(1-10) Ar(23)-C'(12)-Bl(31)-
              IWDL=JUST(LRI,LRK)
              IWDR=JUST(LRK,LRJ)
C              CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL4,JPER)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_4,JPER,LIST0_4)
      IF(LIST1_4.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_4,JPER,LIST1_4)

            ENDIF
          ENDDO

        IF(JB_SYS.GT.0) THEN
          VLOP0=W0*W0SS11
          VLOP1=W1*W1SS11
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
           CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          VLOP0=W0*W0SS12
          VLOP1=W1*W1SS12
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
           CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_2,LIST0_2,
     :                     WL1_2,LIST1_2)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_2,LIST0_2,
     :                     WL1_2,LIST1_2)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_2,LIST0_2,
     :                     WL1_2,LIST1_2)
          ENDIF
          VLOP0=W0*W0SS13
          VLOP1=W1*W1SS13
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
           CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_3,LIST0_3,
     :                     WL1_3,LIST1_3)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_3,LIST0_3,
     :                     WL1_3,LIST1_3)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_3,LIST0_3,
     :                     WL1_3,LIST1_3)
          ENDIF
        ENDIF
          VLOP0=W0*W0SS14
          VLOP1=W1*W1SS14
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
           CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_4,LIST0_4,
     :                     WL1_4,LIST1_4)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_4,LIST0_4,
     :                     WL1_4,LIST1_4)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
           CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_4,LIST0_4,
     :                     WL1_4,LIST1_4)
          ENDIF

          DO LRK=LRJ+1,NORB_DZ
            LMK=LSM_INN(LRK)
            LMKI=MUL_TAB(LMK,LMI)
            LMKJ=MUL_TAB(LMK,LMJ)
            IF(LMKI.EQ.JML.AND.LMKJ.EQ.JMR) THEN
              IF(JB_SYS.GT.0) THEN
!SS(1-11) Ar(13)-Bl(31)-C"(22)-
                IWDL=JUST(LRK,LRI)
                IWDR=JUST(LRK,LRJ)
C                CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_1,JPER,LIST1_1)

!SS(1-12) Ar(13)-Bl(32)-C"(21)-
                IWDL=JUST(LRK,LRI)
                IWDR=JUST(LRJ,LRK)
C                CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_2,JPER,LIST0_2)
      IF(LIST1_2.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_2,JPER,LIST1_2)

!SS(1-13) Ar(23)-Bl(31)-C"(12)-
                IWDL=JUST(LRI,LRK)
                IWDR=JUST(LRK,LRJ)
C                CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL3,JPER)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_3,JPER,LIST0_3)
      IF(LIST1_3.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_3,JPER,LIST1_3)

              ENDIF
!SS(1-14) Ar(23)-Bl(32)-C"(11)- ACT -C"-
              IWDL=JUST(LRI,LRK)
              IWDR=JUST(LRJ,LRK)
C              CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL4,JPER)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_4,JPER,LIST0_4)
      IF(LIST1_4.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_4,JPER,LIST1_4)

            ENDIF
          ENDDO
        ENDDO
      ENDDO

      IF(JPAD.NE.JPADL) RETURN

!      IF(JB_SYS.GT.0.OR.JWL.GE.JWR) THEN
      IF(JB_SYS.GT.0) THEN
      IF(JPAD.GT.17.AND.JPAD.LT.25) THEN
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.JML.NE.JMR) CYCLE
            IWDL=JUST(LRJ,LRI)
            IWDR=JUST(LRI,LRJ)
!SS(1-19) Drl(12)-C"(21)-
            VLOP0=W0*W0_SS(19)
            VLOP1=W1*W1_SS(19)
            IF(LINE.EQ.26) THEN    !LRI,LRA
              CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRI,LRS,LRA
              CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRI,LRS,LRA
              CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
!         WL=(VLOP0-VLOP1)*VOINT(LRI,LRB)
C           CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

        ENDDO
      ENDDO
      ENDIF
      ENDIF
      IF(JWL.GE.JWR) RETURN

      W0SS15=W0_SS(15)
      W1SS15=W1_SS(15)
      W0SS17=W0_SS(17)
      W1SS17=W1_SS(17)
      W0SS20=W0_SS(20)
      IF(JB_SYS.GT.0) THEN
        W0SS16=W0_SS(16)
        W1SS16=W1_SS(16)
        W0SS18=W0_SS(18)
        W1SS18=W1_SS(18)
      ENDIF

      IF(JML.EQ.1.AND.JMR.EQ.1) THEN
!SS(1-20) Drl(33)-C"(00)-                            ! IPL(R)AD=1 or =NS
        DO LR0=NORB_FRZ+1,NORB_DZ
          IWDL=JUST(LR0,LR0)
          IWDR=IWDL
          VLOP0=W0*W0_SS(20)
          VLOP1=0.D0
C         WL=0.D0
          DO LRK=1,NORB_DZ
            IF(LRK.EQ.LR0) CYCLE
            IF(LINE.EQ.26) THEN    !LRK,LRA
             CALL COMP_LOOP_G(9,LRK,0,0,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRK,LRS,LRA    LRS,LRA,LRK
        CALL COMP_LOOP_G(12,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRK,LRS,LRA
        CALL COMP_LOOP_G(11,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
C            WL=WL+WL1
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_1,JPER,LIST1_1)

          ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
      ENDIF
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.JML.NE.JMR) CYCLE
          IF(JWL.GE.JWR.AND.JB_SYS.EQ.0) CYCLE
          WL=0.D0
          IWDL=JUST(LRI,LRJ)
          IWDR=IWDL
!SS(1-15) (22)-Drl(11)-
          VLOP0=W0*W0SS15
          VLOP1=W1*W1SS15
C          WL=0.D0
          IF(LINE.EQ.26) THEN    !LRJ,LRA
            CALL COMP_LOOP_G(9,LRJ,0,0,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.28) THEN    !LRJ,LRS,LRA
            CALL COMP_LOOP_G(12,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.29) THEN    !LRJ,LRS,LRA
            CALL COMP_LOOP_G(11,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
C          WL=WL+WL1
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_1,JPER,LIST1_1)

!         WL=WL+(VLOP0-VLOP1)*VOINT(LRJ,LRB)
!SS(1-17) Drl(22)-C"(11)-
          VLOP0=W0*W0SS17
         VLOP1=W1*W1SS17
          IF(LINE.EQ.26) THEN    !LRI,LRA
            CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.28) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.29) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
C          WL=WL+WL1
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_1,JPER,LIST1_1)

!         WL=WL+(VLOP0-VLOP1)*VOINT(LRI,LRB)
!SS(1-20) (22)(11)Drl(33)-
!SS(1-20) (22)Drl(33)-C"(11)-
!SS(1-20) Drl(33)-C"(22)-C"(11)-
          VLOP0=W0*W0SS20
          VLOP1=0.D0
         DO LRK=1,NORB_DZ
            IF(LRK.EQ.LRI) CYCLE
            IF(LRK.EQ.LRJ) CYCLE
            IF(LINE.EQ.26) THEN    !LRK,LRA
              CALL COMP_LOOP_G(9,LRK,0,0,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRK,LRS,LRA
            CALL COMP_LOOP_G(12,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRK,LRS,LRA
            CALL COMP_LOOP_G(11,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
C            WL=WL+WL1
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_1,JPER,LIST1_1)

!           WL=WL+VLOP0*VOINT(LRK,LRB)
          ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
          IF(JB_SYS.GT.0) THEN
            IWDL=JUST(LRJ,LRI)
            IWDR=IWDL
!SS(1-16) (11)-Drl(22)-
            VLOP0=W0*W0SS16
           VLOP1=W1*W1SS16
C          WL=0.D0
            IF(LINE.EQ.26) THEN    !LRJ,LRA
            CALL COMP_LOOP_G(9,LRJ,0,0,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRJ,LRS,LRA
          CALL COMP_LOOP_G(12,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRJ,LRS,LRA
          CALL COMP_LOOP_G(11,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
c            WL=WL+WL1
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_1,JPER,LIST1_1)

!            WL=(VLOP0-VLOP1)*VOINT(LRJ,LRB)
!SS(1-18) Drl(11)-C"(22)-
            VLOP0=W0*W0SS18
            VLOP1=W1*W1SS18
            IF(LINE.EQ.26) THEN    !LRI,LRA
            CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
C            WL=WL+WL1
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_1,JPER,LIST1_1)

!            WL=WL+(VLOP0-VLOP1)*VOINT(LRI,LRB)
!SS(1-20) Drl(33)-C"(11)-C"(22)-
!SS(1-20) (11)Drl(33)-C"(22)-
!SS(1-20) (11)(22)Drl(33)-
            VLOP0=W0*W0SS20
            VLOP1=0.D0
            DO LRK=1,NORB_DZ
              IF(LRK.EQ.LRI) CYCLE
              IF(LRK.EQ.LRJ) CYCLE
              IF(LINE.EQ.26) THEN    !LRK,LRA
           CALL COMP_LOOP_G(9,LRK,0,0,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
              ENDIF
              IF(LINE.EQ.28) THEN    !LRK,LRS,LRA
           CALL COMP_LOOP_G(12,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
              ENDIF
              IF(LINE.EQ.29) THEN    !LRK,LRS,LRA
           CALL COMP_LOOP_G(11,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
              ENDIF
C              WL=WL+WL1
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1_1,JPER,LIST1_1)

!              WL=WL+VLOP0*VOINT(LRK,LRB)
            ENDDO
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
           ENDIF
        ENDDO
      ENDDO
      RETURN

      END

      SUBROUTINE ST_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!ST(2-1) Ar(02)-Bl(32)-
!ST(2-2) (22)Ar(13)-Bl(32)-
!ST(2-4) Ar(23)-C'(12)-Bl(32)-
!ST(2-4) Ar(23)-Bl(32)-C'(12)-
!ST(2-5) (22)Drl(12)-
!ST(2-6) Drl(22)-C"(12)-
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          LMIJ=MUL_TAB(LMIJ,1)
          IF(JML.EQ.JMR.AND.LMIJ.EQ.JML) THEN
            IWDS=JUST(LRI,LRJ)
            IWDT=IWDS              !
!ST(2-5) (22)Drl(12)-
            VLOP1=W1*W1_ST(5)             !D2-5
            VLOP0=0.D0
            IF(LINE.EQ.26) THEN    !LRJ,LRA
              CALL COMP_LOOP_G(9,LRJ,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRJ,LRS,LRA
              CALL COMP_LOOP_G(12,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRJ,LRS,LRA
              CALL COMP_LOOP_G(11,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
C           CALL PRODAB_1(3,JPEL,IWDS,IWDT,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL1,JPER,LIST1)

!ST(2-6) Drl(22)-C"(12)-
            VLOP1=W1*W1_ST(6)             !D2-6
            VLOP0=0.D0
            IF(LINE.EQ.26) THEN    !LRI,LRA
          CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRI,LRS,LRA
          CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRI,LRS,LRA
          CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
            ENDIF

C          CALL PRODAB_1(3,JPEL,IWDS,IWDT,JWL,JWR,WL2_1,JPER,LIST2_1,
C    :                                                       LIST3_1)
              CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL1_1,JPER,LIST1_1)

C           WL=WL+WL1
!            LIST=LIST3(LRA,LRB,LRI)
!            WL=WL-VLOP1*vint_ci(LIST)    !4.3 Vlop0=0        !!!!!
C            CALL PRODAB(3,JPEL,IWDS,IWDT,JWL,JWR,WL,JPER)
!ST(2-7) Drl(12)-C"(22)-
            IF(JB_SYS.GT.0) THEN
              IWDS=JUST(LRJ,LRI)
              IWDT=JUST(LRI,LRJ)
            VLOP1=W1*W1_ST(7)
            VLOP0=0.D0             !D2-6
!              LIST=LIST3(LRA,LRB,LRI)
!              WL=WL-VLOP1*vint_ci(LIST)    !4.3 Vlop0=0        !!!!!
              IF(LINE.EQ.26) THEN    !LRI,LRA
                CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
              ENDIF
              IF(LINE.EQ.28) THEN    !LRI,LRS,LRA
                CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
              ENDIF
              IF(LINE.EQ.29) THEN    !LRI,LRS,LRA
                CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
              ENDIF
C           CALL PRODAB_1(3,JPEL,IWDS,IWDT,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL1,JPER,LIST1)

C              CALL PRODAB(3,JPEL,IWDS,IWDT,JWL,JWR,WL,JPER)
            ENDIF
          ENDIF

          JMLR=MUL_TAB(JML,JMR)
         IF(LMIJ.NE.JMLR) CYCLE
          W1ST1=W1_ST(1)
          W1ST2=W1_ST(2)
          W1ST3=W1_ST(3)
          W1ST4=W1_ST(4)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W1ST1=-W1ST1
            W1ST2=-W1ST2
            W1ST3=-W1ST3
            W1ST4=-W1ST4
          ENDIF
          IF(JML.EQ.1)THEN
!ST(2-1) Ar(02)-Bl(32)-
            IWDS=JUST(LRI,LRI)
            IWDT=JUST(LRI,LRJ)      !
            VLOP1=W1*W1ST1
           VLOP0=0.D0
!          LIST=LIST4(LRI,LRJ,LRA,LRB)
            IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
              CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
               CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
              CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
!          WL=-VLOP1*vint_ci(LIST)    !1.1 VLOP0=0        !!!!!
C            CALL PRODAB(3,JPEL,IWDS,IWDT,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDS,IWDT,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL1,JPER,LIST1)

          ENDIF

!ST(2-2) (22)Ar(13)-Bl(32)-
          VLOP1=W1*W1ST2
!       WL=-VLOP1*vint_ci(LIST)    !1.1
          VLOP0=0.D0
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
            CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
         DO LRK=NORB_FRZ+1,LRI-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IF(MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
            IWDS=JUST(LRK,LRI)
            IWDT=JUST(LRK,LRJ)      !
C            CALL PRODAB(3,JPEL,IWDS,IWDT,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDS,IWDT,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL1,JPER,LIST1)
          ENDDO
!ST(2-3) Ar(13)-Bl(32)-C'(22)-
!ST(2-4) Ar(23)-Bl(32)-C'(12)-
          VLOP1=W1*W1ST4
         VLOP0=0.D0
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
            CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
!        WL=-VLOP1*vint_ci(LIST)    !1.1 VLOP0=0
        IF(JB_SYS.GT.0) THEN
          VLOP1=W1*W1ST3
          VLOP0=0.D0
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
        CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
        CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0_1,LIST0_1,
     :                     WL1_1,LIST1_1)
          ENDIF
        ENDIF
!         WL1=-VLOP1*vint_ci(LIST)
         DO LRK=LRJ+1,NORB_DZ
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IF(MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
            IWDS=JUST(LRI,LRK)
            IWDT=JUST(LRJ,LRK)     !
C            CALL PRODAB(3,JPEL,IWDS,IWDT,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDS,IWDT,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL1,JPER,LIST1)

            IF(JB_SYS.GT.0) THEN
              IWDS=JUST(LRK,LRI)
C              CALL PRODAB(3,JPEL,IWDS,IWDT,JWL,JWR,WL1,JPER)
C          CALL PRODAB_1(3,JPEL,IWDS,IWDT,JWL,JWR,WL2_1,JPER,LIST2_1,
C    :                                                       LIST3_1)
              CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,WL1_1,JPER,LIST1_1)

            ENDIF
          ENDDO
!ST(2-4) Ar(23)-C'(12)-Bl(32)-
         DO LRK=LRI+1,LRJ-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IF(MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
            IWDS=JUST(LRI,LRK)
            IWDT=JUST(LRK,LRJ)    !
C            CALL PRODAB(3,JPEL,IWDS,IWDT,JWL,JWR,-WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDS,IWDT,JWL,JWR,-WL2,JPER,LIST2,LIST3
          CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,-WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :       CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,-WL1,JPER,LIST1)

!ST(2-3) Ar(13)-C'(22)-Bl(32)-
            IF(JB_SYS.GT.0) THEN
              IWDS=JUST(LRK,LRI)
C              CALL PRODAB(3,JPEL,IWDS,IWDT,JWL,JWR,-WL1,JPER)
C          CALL PRODAB_1(3,JPEL,IWDS,IWDT,JWL,JWR,-WL2_1,JPER,LIST2_1,
C    :                                                        LIST3_1)
           CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,-WL0_1,JPER,LIST0_1)
      IF(LIST1_1.NE.0)
     :     CALL PRODAB_2(3,JPEL,IWDS,IWDT,JWL,JWR,-WL1_1,JPER,LIST1_1)

           ENDIF
          ENDDO
        ENDDO
      ENDDO
      RETURN

      END

      SUBROUTINE TS_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!TS(3-1) Ar(23)-Bl(20)-
!TS(3-2) (22)Ar(23)-Bl(31)-
!TS(3-2) Ar(23)-C'(22)-Bl(31)-
!TS(3-3) Ar(23)-Bl(31)-C"(22)-
!TS(3-4) Ar(23)-Bl(32)-C"(21)-
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        W1TS1=W1_TS(1)
        W1TS2=W1_TS(2)
        W1TS3=W1_TS(3)
        W1TS4=W1_TS(4)
        NI=MOD(LRJ-LRI,2)
        IF(NI.eq.0) THEN
          W1TS1=-W1TS1
          W1TS2=-W1TS2
          W1TS3=-W1TS3
          W1TS4=-W1TS4
        ENDIF
!        LIST=LIST3(LRI,LRJ,LRB)
!-------------------------------------------------------------------
!TS(3-1) Ar(23)-Bl(20)-
          IF(JMR.EQ.1.and.LMIJ.eq.JML) THEN
            IWDT=JUST(LRI,LRJ)    !
            IWDS=JUST(LRJ,LRJ)
            VLOP1=W1*W1TS1             !D3-1
            VLOP0=0.D0
            IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
              CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
              CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
              CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
!           WL=-VLOP1*(VINT_CI(LIST))    !2.2 vlop0=0
C            CALL PRODAB(3,JPEL,IWDT,IWDS,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDT,IWDS,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,WL1,JPER,LIST1)
          ENDIF
!-------------------------------------------------------------------
          VLOP1=W1*W1TS2             !D3-2
          VLOP0=0.D0
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
            CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
!          WL=-VLOP1*(VINT_CI(LIST))    !2.2 vlop0=0
!TS(3-2) (22)Ar(23)-Bl(31)-
          DO LRK=NORB_FRZ+1,LRI-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML.or.MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
           IWDT=JUST(LRK,LRI)   !
            IWDS=JUST(LRK,LRJ)
C            CALL PRODAB(3,JPEL,IWDT,IWDS,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDT,IWDS,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,WL1,JPER,LIST1)
          ENDDO

!TS(3-2) Ar(23)-C'(22)-Bl(31)-
         DO LRK=LRI+1,LRJ-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML.or.MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
           IWDT=JUST(LRI,LRK)   !
            IWDS=JUST(LRK,LRJ)
C            CALL PRODAB(3,JPEL,IWDT,IWDS,JWL,JWR,-WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDT,IWDS,JWL,JWR,-WL2,JPER,LIST2,LIST3
              CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,-WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,-WL1,JPER,LIST1)
          ENDDO

!-------------------------------------------------------------------
!TS(3-4) Ar(23)-Bl(32)-C"(21)-
          VLOP1=W1*W1TS4             !D3-4
          VLOP0=0.D0
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
            CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          DO LRK=LRJ+1,NORB_DZ
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML.or.MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
            IWDT=JUST(LRI,LRK)   !
            IWDS=JUST(LRJ,LRK)
C            CALL PRODAB(3,JPEL,IWDT,IWDS,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDT,IWDS,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,WL1,JPER,LIST1)

          ENDDO

!-------------------------------------------------------------------
!TS(3-3) Ar(23)-Bl(31)-C"(22)-
          IF(JB_SYS.GT.0) THEN
            VLOP1=W1*W1TS3             !D3-4
            VLOP0=0.D0
            IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
              CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
              CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
              CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
!            WL=-VLOP1*VINT_CI(LIST)    !2.2 vlop0=0
            DO LRK=LRJ+1,NORB_DZ
              LMK=LSM_INN(LRK)
       IF(MUL_TAB(LMK,LMI).NE.JML.or.MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
              IWDT=JUST(LRI,LRK)   !
              IWDS=JUST(LRK,LRJ)
C              CALL PRODAB(3,JPEL,IWDT,IWDS,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDT,IWDS,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDT,IWDS,JWL,JWR,WL1,JPER,LIST1)

            ENDDO
          ENDIF
        ENDDO
      ENDDO
      RETURN

      END

      SUBROUTINE STT_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!ST1(4-1) Ar(01)-Bl(31)-
!ST1(4-2) (11)Ar(23)-Bl(31)-
!ST1(4-3) Ar(13)-C'(21)-Bl(31)-
!ST1(4-3) Ar(13)-Bl(31)-C"(21)-
!ST1(4-4) Ar(23)-C'(11)-Bl(31)-
!ST1(4-4) Ar(23)-Bl(31)-C"(11)-
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          W1ST1=W1_ST1(1)
          W1ST2=W1_ST1(2)
          W1ST3=W1_ST1(3)
          W1ST4=W1_ST1(4)
          NI=MOD(LRJ-LRI,2)
         IF(NI.EQ.0) THEN
            W1ST1=-W1ST1
            W1ST2=-W1ST2
            W1ST3=-W1ST3
            W1ST4=-W1ST4
          ENDIF
!          LIST=LIST3(LRI,LRJ,LRB)
         IF(JML.EQ.1.AND.LMIJ.EQ.JMR) THEN
!ST1(4-1) Ar(01)-Bl(31)-
             IWDL=JUST(LRI,LRI)
             IWDR=JUST(LRI,LRJ)
            VLOP1=W1*W1ST1
             VLOP0=0.D0
             IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
               CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
             ENDIF
             IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
               CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
             ENDIF
             IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
               CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
             ENDIF
!             WL=-VLOP1*(VINT_CI(LIST))    !2.2 vlop0=0
C             CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)
           ENDIF
!ST1(4-2) (11)Ar(23)-Bl(31)-
           VLOP1=W1*W1ST2
           VLOP0=0.D0
           IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
             CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
           ENDIF
           IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
             CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
           ENDIF
           IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
             CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
           ENDIF
           DO LRK=NORB_FRZ+1,LRI-1
             LMK=LSM_INN(LRK)
             IF(MUL_TAB(LMK,LMI).NE.JML.OR.
     :            MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
!            WL=-VLOP1*VINT_CI(LIST)
             IWDL=JUST(LRI,LRK)
             IWDR=JUST(LRK,LRJ)
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)
          ENDDO
           VLOP1=W1*W1ST4
           VLOP0=0.D0
           IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
              CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
           ENDIF
           IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
             CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
           ENDIF
           IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
             CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
           ENDIF
!ST1(4-4) Ar(23)-C'(11)-Bl(31)-
           DO LRK=LRI+1,LRJ-1
             LMK=LSM_INN(LRK)
             IF(MUL_TAB(LMI,LMK).NE.JML.OR.
     :             MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
             IWDL=JUST(LRI,LRK)
             IWDR=JUST(LRK,LRJ)
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,-WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,-WL2,JPER,LIST2,LIST3
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL1,JPER,LIST1)
          ENDDO
!ST1(4-4) Ar(23)-Bl(31)-C"(11)-
           DO LRK=LRJ+1,NORB_DZ
             LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMI,LMK).NE.JML.OR.
     :          MUL_TAB(LMJ,LMK).NE.JMR) CYCLE
             IWDL=JUST(LRI,LRK)
             IWDR=JUST(LRJ,LRK)
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)
          ENDDO

           VLOP1=W1*W1ST3
           VLOP0=0.D0
           IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
             CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
           ENDIF
           IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
             CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
           ENDIF
           IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
             CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
           ENDIF
!ST1(4-3) Ar(13)-C'(21)-Bl(31)-
           DO LRK=LRI+1,LRJ-1
             LMK=LSM_INN(LRK)
             IF(MUL_TAB(LMI,LMK).NE.JML.OR.
     :         MUL_TAB(LMK,LMJ).NE.JMR) CYCLE
             IWDL=JUST(LRK,LRI)
             IWDR=JUST(LRK,LRJ)
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,-WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,-WL2,JPER,LIST2,LIST3
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL1,JPER,LIST1)
          ENDDO
!ST1(4-3) Ar(13)-Bl(31)-C"(21)-
           DO LRK=LRJ+1,NORB_DZ
             LMK=LSM_INN(LRK)
             IF(MUL_TAB(LMI,LMK).NE.JML.OR.
     :            MUL_TAB(LMJ,LMK).NE.JMR) CYCLE
             IWDL=JUST(LRK,LRI)
             IWDR=JUST(LRJ,LRK)
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)
          ENDDO
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TTS_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!T1S(5-1)   Ar(13)-Bl(10)-
!T1S(5-2)   Ar(13)-Bl(32)-
!T1S(5-2)   Ar(13)-C'(11)-Bl(32)-
!T1S(5-3)   Ar(13)-Bl(31)-C"(12)-
!T1S(5-4)   Ar(13)-Bl(32)-C"(11)-
!T1S(5-5)   Drl(12)-
!T1S(5-6)   Drl(12)-C"(12)-
!T1S(5-7)   Drl(12)-C"(11)-
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        W1T1S1=W1_T1S(1)
        W1T1S2=W1_T1S(2)
        W1T1S3=W1_T1S(3)
        W1T1S4=W1_T1S(4)
        W1T1S5=W1_T1S(5)
        W1T1S6=W1_T1S(6)
        W1T1S7=W1_T1S(7)
        NI=MOD(LRJ-LRI,2)
        IF(NI.EQ.0) THEN
          W1T1S1=-W1T1S1
          W1T1S2=-W1T1S2
          W1T1S3=-W1T1S3
          W1T1S4=-W1T1S4
!         W1T1S5=-W1T1S5
!         W1T1S6=-W1T1S6
!         W1T1S7=-W1T1S7
        ENDIF
!       LIST=LIST3(LRI,LRJ,LRB)
        IF(JML.EQ.LMIJ.AND.JMR.EQ.1) THEN
!T1S(5-1)   Ar(13)-Bl(10)-
          VLOP1=W1*W1T1S1
          VLOP0=0.D0
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
            CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
!         WL=-VLOP1*VINT_CI(LIST)
         IWDL=JUST(LRI,LRJ)
          IWDR=JUST(LRJ,LRJ)
C        CALL  PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)
        ENDIF
        VLOP1=W1*W1T1S2
        VLOP0=0.D0
        IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
          CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
          CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
          CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
!         WL=-VLOP1*VINT_CI(LIST)
        DO LRK=NORB_FRZ+1,LRI-1
          LMK=LSM_INN(LRK)
!T1S(5-2)   (11)Ar(13)-Bl(32)-
          IF(JML.NE.MUL_TAB(LMK,LMI).OR.JMR.NE.
     :        MUL_TAB(LMK,LMJ)) CYCLE
!          VLOP1=W1*W1T1S2
!          WL=-VLOP1*VINT_CI(LIST)
           IWDL=JUST(LRK,LRI)
           IWDR=JUST(LRJ,LRK)
C         CALL  PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

        ENDDO
        DO LRK=LRI+1,LRJ-1
          LMK=LSM_INN(LRK)
!T1S(5-2)   Ar(13)-C'(11)-Bl(32)-
          IF(JML.NE.MUL_TAB(LMI,LMK).OR.JMR.NE.
     :        MUL_TAB(LMK,LMJ)) CYCLE
!          VLOP1=W1*W1T1S2
!          WL=-VLOP1*VINT_CI(LIST)
           IWDL=JUST(LRI,LRK)
           IWDR=JUST(LRJ,LRK)
C         CALL  PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,-WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,-WL2,JPER,LIST2,LIST3
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL1,JPER,LIST1)

        ENDDO
        VLOP1=W1*W1T1S3
        VLOP0=0.D0
        IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
          CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
          CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
          CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        DO LRK=LRJ+1,NORB_DZ
          LMK=LSM_INN(LRK)
!T1S(5-3)   Ar(13)-Bl(31)-C"(12)-
          IF(JML.NE.MUL_TAB(LMI,LMK).OR.JMR.NE.
     :        MUL_TAB(LMJ,LMK)) CYCLE
!          VLOP1=W1*W1T1S3
!          WL=-VLOP1*VINT_CI(LIST)
           IWDL=JUST(LRI,LRK)
           IWDR=JUST(LRK,LRJ)
C         CALL  PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

        ENDDO
        VLOP1=W1*W1T1S4
        VLOP0=0.D0
        IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
          CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.28) THEN     !LRI,LRK,LRS,LRA
          CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.29) THEN     !LRI,LRK,LRS,LRA
          CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
!       WL=-VLOP1*VINT_CI(LIST)
        DO LRK=LRJ+1,NORB_DZ
          LMK=LSM_INN(LRK)
!T1S(5-4)   Ar(13)-Bl(32)-C"(11)-
          IF(JML.NE.MUL_TAB(LMI,LMK).OR.JMR.NE.
     :        MUL_TAB(LMJ,LMK)) CYCLE
           IWDL=JUST(LRI,LRK)
           IWDR=JUST(LRJ,LRK)
C         CALL  PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)
        ENDDO
        IF(LMIJ.EQ.JML.AND.LMIJ.EQ.JMR) THEN
!T1S(5-5)   (11)Drl(12)-
          VLOP1=W1*W1T1S5
          VLOP0=0.D0
          IF(LINE.EQ.26) THEN    !LRJ,LRA
            CALL COMP_LOOP_G(9,LRJ,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN    !LRJ,LRS,LRA
            CALL COMP_LOOP_G(12,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN    !LRJ,LRS,LRA
            CALL COMP_LOOP_G(11,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
!         WL=-VLOP1*VOINT(LRB,LRJ)
          IWDL=JUST(LRI,LRJ)
          IWDR=JUST(LRJ,LRI)
C         CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

!T1S(5-6)   Drl(11)-C"(12)-
          VLOP1=W1*W1T1S6
          VLOP0=0.D0
          IF(LINE.EQ.26) THEN    !LRI,LRA
            CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
!         WL=-VLOP1*VOINT(LRB,LRI)
          IWDL=JUST(LRI,LRJ)
          IWDR=JUST(LRJ,LRI)
C         CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

!T1S(5-7)   Drl(12)-C"(11)-
          VLOP1=W1*W1T1S7
          VLOP0=0.D0
          IF(LINE.EQ.26) THEN    !LRI,LRA
            CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
!         WL=-VLOP1*VOINT(LRB,LRI)
          IWDL=JUST(LRI,LRJ)
          IWDR=IWDL
C         CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

        ENDIF
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TT_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!TT(11-1) (22)Ar(23)-Bl(32)-
!TT(11-1) Ar(23)-C'(22)-Bl(32)-
!TT(11-1) Ar(23)-Bl(32)-C"(22)-
!TT(11-2) (22)Drl(22)-
!TT(11-2) Drl(22)-C"(22)-
!TT(11-3) (22)Drl(33)-
!TT(11-3) Drl(33)-C"(22)-
!TT(11-3) Drl(33)-C"(22)-C"(22)-
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          JMLR=MUL_TAB(JML,JMR)
          IF(LMIJ.NE.JMLR) CYCLE
          W0TT1=W0_TT(1)
          W1TT1=W1_TT(1)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W0TT1=-W0TT1
            W1TT1=-W1TT1
          ENDIF
!          LIST=LIST3(LRI,LRJ,LRB)
          VLOP0=W0*W0TT1
          VLOP1=W1*W1TT1
          IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
            CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
!          WL=(VLOP0-VLOP1)*vint_ci(LIST)-2*VLOP0*vint_ci(LIST+1)
!TT(11-1) (22)Ar(23)-Bl(32)-
          DO LRK=NORB_FRZ+1,LRI-1
            LMK=LSM_INN(LRK)
            LMKI=MUL_TAB(LMK,LMI)
            LMKJ=MUL_TAB(LMK,LMJ)
            IF(LMKI.EQ.JML.AND.LMKJ.EQ.JMR) THEN
              IWDL=JUST(LRK,LRI)     !
              IWDR=JUST(LRK,LRJ)     !
C              CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

             ENDIF
          ENDDO
!TT(11-1) Ar(23)-Bl(32)-C"(22)-    ACT -C"-
          DO LRK=LRJ+1,NORB_DZ
            LMK=LSM_INN(LRK)
            LMKI=MUL_TAB(LMK,LMI)
            LMKJ=MUL_TAB(LMK,LMJ)
            IF(LMKI.EQ.JML.AND.LMKJ.EQ.JMR) THEN
              IWDL=JUST(LRI,LRK)     !
              IWDR=JUST(LRJ,LRK)     !
C              CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

            ENDIF
          ENDDO
!TT(11-1) Ar(23)-C'(22)-Bl(32)-    ACT -C"-
          DO LRK=LRI+1,LRJ-1
           LMK=LSM_INN(LRK)
            LMKI=MUL_TAB(LMK,LMI)
            LMKJ=MUL_TAB(LMK,LMJ)
            IF(LMKI.EQ.JML.AND.LMKJ.EQ.JMR) THEN
              IWDL=JUST(LRI,LRK)      !
              IWDR=JUST(LRK,LRJ)      !
C              CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,-WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,-WL2,JPER,LIST2,LIST3
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL1,JPER,LIST1)

            ENDIF
          ENDDO
        ENDDO
      ENDDO

      IF(JPAD.NE.JPADL) RETURN
      IF(JWL .GE. JWR ) RETURN

      W0TT2=W0_TT(2)
      W1TT2=W1_TT(2)
      W0TT3=W0_TT(3)

      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML.OR.LMIJ.NE.JMR) CYCLE
          IF(JWL.GE.JWR) CYCLE
!TT(11-2) (22)Drl(22)-
!TT(11-2) Drl(22)-C"(22)-
          IWDL=JUST(LRI,LRJ)     !
          IWDR=IWDL
          VLOP0=W0*W0TT2
          VLOP1=W1*W1TT2
          IF(LINE.EQ.26) THEN    !LRJ,LRA
            CALL COMP_LOOP_G(9,LRJ,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN    !LRJ,LRS,LRA
            CALL COMP_LOOP_G(12,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN    !LRJ,LRS,LRA
            CALL COMP_LOOP_G(11,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF

C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

          IF(LINE.EQ.26) THEN    !LRI,LRA
            CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN    !LRI,LRS,LRA
            CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)


C         WL=WL+WLTMP
!          WL=(VLOP0-VLOP1)*(VOINT(LRB,LRI)+VOINT(LRB,LRJ))
          VLOP0=W0*W0TT3
          VLOP1=0.D0
          DO LRK=1,NORB_DZ
            IF(LRK.EQ.LRI) CYCLE
            IF(LRK.EQ.LRJ) CYCLE
!TT(11-3) Drl(33)-C"(22)-C"(22)-
!TT(11-3) (22)Drl(33)-C"(22)-
!TT(11-3) (22)(22)Drl(33)-
            IF(LINE.EQ.26) THEN    !LRK,LRA
              CALL COMP_LOOP_G(9,LRK,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRK,LRS,LRA
              CALL COMP_LOOP_G(12,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRK,LRS,LRA
              CALL COMP_LOOP_G(11,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
C            WL=WL+WLTMP
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

          ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TTTT_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!T1T1(12-1)  Ar(13)-Bl(31)-
!T1T1(12-1)  Ar(13)-C'(11)-Bl(31)-
!T1T1(12-1)  Ar(13)-Bl(31)-C"(11)-
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        W0TT1=W0_T1T1(1)
        W1TT1=W1_T1T1(1)
        NI=MOD(LRJ-LRI,2)
        IF(NI.EQ.0) THEN
          W0TT1=-W0TT1
          W1TT1=-W1TT1
        ENDIF
!        LIST=LIST4(LRI,LRJ,LRA,LRB)
        VLOP0=W0*W0TT1
        VLOP1=W1*W1TT1
        IF(LINE.EQ.26) THEN    !LRI,LRJ,LRA
          CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.28) THEN     !LRI,LRJ,LRS,LRA
          CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.29) THEN     !LRI,LRJ,LRS,LRA
          CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
!       WL=(VLOP0-VLOP1)*VINT_CI(LIST)-2*VLOP0*VINT_CI(LIST+1)
!T1T1(12-1)  (11)Ar(13)-Bl(31)-
        DO LRM=NORB_FRZ+1,LRI-1
          LMM=LSM_INN(LRM)
          IF(JML.NE.MUL_TAB(LMI,LMM).OR.JMR.NE.MUL_TAB(LMM,LMJ)) CYCLE
          IWDL=JUST(LRM,LRI)
          IWDR=JUST(LRM,LRJ)
C         CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

        ENDDO
!T1T1(12-1)  Ar(13)-Bl(31)-C"(11)-
        DO LRM=LRJ+1,NORB_DZ
          LMM=LSM_INN(LRM)
          IF(JML.NE.MUL_TAB(LMI,LMM).OR.JMR.NE.MUL_TAB(LMM,LMJ)) CYCLE
          IWDL=JUST(LRI,LRM)
          IWDR=JUST(LRJ,LRM)
C         CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

        ENDDO
!T1T1(12-1)  Ar(13)-C'(11)-Bl(31)-
        DO LRM=LRI+1,LRJ-1
          LMM=LSM_INN(LRM)
          IF(JML.NE.MUL_TAB(LMI,LMM).OR.JMR.NE.MUL_TAB(LMM,LMJ)) CYCLE
          IWDL=JUST(LRI,LRM)
          IWDR=JUST(LRM,LRJ)
C         CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,-WL,JPER)
C          CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,-WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,-WL1,JPER,LIST1)

        ENDDO
      ENDDO
      ENDDO

      IF(JPAD.NE.JPADL) RETURN
      IF(JWL.GE.JWR) RETURN

      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ               !BBS_TMP
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(JML.NE.LMIJ) CYCLE
        VLOP0=W0*W0_T1T1(2)
        VLOP1=W1*W1_T1T1(2)
C----------------------------------------
C lyb
        IWDL=JUST(LRI,LRJ)
        IWDR=IWDL

!T1T1(12-2)  (11)Drl(11)-
        IF(LINE.EQ.26) THEN    !LRI,LRA
           CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.28) THEN    !LRK,LRS,LRA
          CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.29) THEN    !LRK,LRS,LRA
          CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

!T1T1(12-2)  Drl(11)-C"(11)-
        IF(LINE.EQ.26) THEN    !LRJ,LRA
           CALL COMP_LOOP_G(9,LRJ,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.28) THEN    !LRJ,LRS,LRA
          CALL COMP_LOOP_G(12,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.29) THEN    !LRJ,LRS,LRA
          CALL COMP_LOOP_G(11,LRJ,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
C       WL=WL+WLTMP
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

!T1T1(12-3)  (11)(11)Drl(33)-
!T1T1(12-3)  (11)Drl(33)-C"(11)-
!T1T1(12-3)  Drl(33)-C"(11)-C"(11)-
        DO LRK=1,NORB_DZ
          IF(LRK.EQ.LRI) CYCLE
          IF(LRK.EQ.LRJ) CYCLE
          VLOP0=W0*W0_T1T1(3)
          VLOP1=0.D0
          IF(LINE.EQ.26) THEN    !LRK,LRA
            CALL COMP_LOOP_G(9,LRK,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.28) THEN    !LRK,LRS,LRA
            CALL COMP_LOOP_G(12,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.29) THEN    !LRK,LRS,LRA
            CALL COMP_LOOP_G(11,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
C          WL=WL+WLTMP
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

        ENDDO
C        IWDL=JUST(LRI,LRJ)
C        IWDR=IWDL
C       CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE DD_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!DD(19-1) Ar(23)-Bl(32)-
!DD(19-2) Drl(22)-
!DD(19-3) Drl(33)-
!DD(19-3) Drl(33)-C"(22)-
      DO LRIL=NORB_FRZ+1,NORB_DZ
        IMIL=LSM_INN(LRIL)
        IF(IMIL.NE.JML) CYCLE
        IWDL=JUD(LRIL)
        DO LRIR=LRIL,NORB_DZ
          IMIR=LSM_INN(LRIR)
          IF(IMIR.NE.JMR) CYCLE
          IWDR=JUD(LRIR)

         W0DD1=W0_DD(1)
          W1DD1=W1_DD(1)
          NI=MOD(LRIR-LRIL,2)
          IF(NI.EQ.0) THEN
            W0DD1=-W0DD1
            W1DD1=-W1DD1
         ENDIF

         IF(LRIL.EQ.LRIR.and.JWL.LT.JWR) THEN
!DD(19-2) Drl(22)-
            VLOP0=W0*W0_DD(2)
            VLOP1=W1*W1_DD(2)
            IF(LINE.EQ.26) THEN    !LRIL,LRA
              CALL COMP_LOOP_G(9,LRIL,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRIL,LRS,LRA
              CALL COMP_LOOP_G(12,LRIL,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRIL,LRS,LRA
              CALL COMP_LOOP_G(11,LRIL,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

!            WL=(VLOP0-VLOP1)*VOINT(LRA,LRIL)
!            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
!DD(19-3) Drl(33)-
            VLOP0=W0*W0_DD(3)
           VLOP1=0.D0
            DO LRK=1,NORB_DZ
             IF(LRK.EQ.LRIL) CYCLE
!             LIST=LIST3(LRS,LRA,LRK)
             IF(LINE.EQ.26) THEN    !LRK,LRA
               CALL COMP_LOOP_G(9,LRK,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)     !WYB
             ENDIF
             IF(LINE.EQ.28) THEN    !LRK,LRS,LRA
               CALL COMP_LOOP_G(12,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)   !WYB
             ENDIF
             IF(LINE.EQ.29) THEN    !LRK,LRS,LRA
               CALL COMP_LOOP_G(11,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)   !WYB
             ENDIF
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)
!              WL=WL+VLOP0*VOINT(LRK,LRA)
C             WL=WLTMP+WL
            ENDDO
C             CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
          ENDIF
          IF(LRIL.NE.LRIR)THEN
!DD(19-1) Ar(23)-Bl(32)-
            VLOP0=W0*W0DD1
            VLOP1=W1*W1DD1
            IF(LINE.EQ.26) THEN   !LRIL,LRIR,LRA
             CALL COMP_LOOP_G(5,LRIL,LRIR,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN   !LRIL,LRIR,LRS,LRA
             CALL COMP_LOOP_G(7,LRIL,LRIR,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN   !LRIL,LRIR,LRS,LRA
             CALL COMP_LOOP_G(6,LRIL,LRIR,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
!            LIST=LIST4(LRIL,LRIR,LRS,LRA)
!            WL=VLOP0*(vint_ci(LIST)-2*vint_ci(LIST+1)) !1.1       !!!!!
!     :       -VLOP1*vint_ci(LIST)
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

          ENDIF
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE DDDD_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!D1D1(20-1) Ar(13)-BL(31)-
!D1D1(20-1) Drl(11)-
!D1D1(20-1) Drl(33)-
!D1D1(20-1) Drl(33)-C"(11)-
      DO LRIL=NORB_FRZ+1,NORB_DZ
        IMIL=LSM_INN(LRIL)
        IF(IMIL.NE.JML) CYCLE
        IWDL=JUD(LRIL)
        DO LRIR=LRIL,NORB_DZ
          IMIR=LSM_INN(LRIR)
          IF(IMIR.NE.JMR) CYCLE
          W0DD1=W0_D1D1(1)
         W1DD1=W1_D1D1(1)
         NI=MOD(LRIR-LRIL,2)
         IF(NI.EQ.0) THEN
            W0DD1=-W0DD1
            W1DD1=-W1DD1
         ENDIF
         IWDR=JUD(LRIR)
          IF(LRIL.EQ.LRIR.and.JWL.LT.JWR)THEN
!D1D1(20-1) Drl(11)-
           VLOP0=W0*W0_D1D1(2)
            VLOP1=W1*W1_D1D1(2)
            IF(LINE.EQ.26) THEN    !LRIL,LRA
              CALL COMP_LOOP_G(9,LRIL,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN    !LRIL,LRS,LRA
              CALL COMP_LOOP_G(12,LRIL,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN    !LRIL,LRS,LRA
              CALL COMP_LOOP_G(11,LRIL,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

!D1D1(20-1) Drl(33)-
!D1D1(20-1) Drl(33)-C"(11)-
            VLOP0=W0*W0_D1D1(3)
           VLOP1=0.D0
           DO LRK=1,NORB_DZ
              IF(LRK.EQ.LRIL) CYCLE
              IF(LINE.EQ.26) THEN    !LRK,LRA
                CALL COMP_LOOP_G(9,LRK,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
              ENDIF
              IF(LINE.EQ.28) THEN    !LRK,LRS,LRA
                CALL COMP_LOOP_G(12,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
              ENDIF
              IF(LINE.EQ.29) THEN    !LRK,LRS,LRA
                CALL COMP_LOOP_G(11,LRK,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
              ENDIF
C             WL=WL+WLTMP
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

            ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
          ENDIF
          IF(LRIL.NE.LRIR)THEN
!D1D1(20-1) Ar(13)-BL(31)-
            VLOP0=W0*W0DD1
            VLOP1=W1*W1DD1
            IF(LINE.EQ.26) THEN   !LRIL,LRIR,LRA
             CALL COMP_LOOP_G(5,LRIL,LRIR,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.28) THEN   !LRIL,LRIR,LRS,LRA
             CALL COMP_LOOP_G(7,LRIL,LRIR,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.29) THEN   !LRIL,LRIR,LRS,LRA
             CALL COMP_LOOP_G(6,LRIL,LRIR,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
!            LIST=LIST3(LRIL,LRIR,LRA)
!            WL=(VLOP0-VLOP1)*vint_ci(LIST)-2*VLOP0*vint_ci(LIST+1)   !2
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

         ENDIF
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE DD1_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IWDL=JUD(LRI)
      DO LRJ=LRI+1,NORB_DZ
!DD1(21) Ar(23)-Bl(31)-
        LMJ=LSM_INN(LRJ)
        IF(JML.NE.LMI.OR.JMR.NE.LMJ) CYCLE
        VLOP1=W1*W1_DD1
        VLOP0=0.D0
        NI=MOD(LRJ-LRI,2)
        IF(NI.EQ.0) THEN
          VLOP1=-VLOP1
        ENDIF

        IF(LINE.EQ.26) THEN   !LRI,LRJ,LRA
          CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.28) THEN   !LRIL,LRJ,LRS,LRA
          CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.29) THEN   !LRI,LRJ,LRS,LRA
          CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
!       LIST=LIST3(LRI,LRJ,LRA)
!       WL=-VLOP1*VINT_CI(LIST)
        IWDR=JUD(LRJ)
C       CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE D1D_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!D1D(22-1)   Ar(13)-Bl(32)-
!D1D(22-2)   Drl(12)-
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
        IWDL=JUD(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        IF(JML.NE.LMI.OR.JMR.NE.LMJ) CYCLE
        VLOP1=W1*W1_D1D(1)
        VLOP0=0.D0
        IF(MOD(LRJ-LRI,2).EQ.0) THEN
          VLOP1=-VLOP1
        ENDIF
        IF(LINE.EQ.26) THEN   !LRI,LRJ,LRA
          CALL COMP_LOOP_G(5,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.28) THEN   !LRIL,LRJ,LRS,LRA
          CALL COMP_LOOP_G(7,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.29) THEN   !LRI,LRJ,LRS,LRA
          CALL COMP_LOOP_G(6,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
!       LIST=LIST3(LRI,LRJ,LRA)
!       WL=-VLOP1*VINT_CI(LIST)
        IWDR=JUD(LRJ)
C       CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

      ENDDO
      ENDDO
      VLOP1=W1*W1_D1D(2)
      VLOP0=0.D0
      DO LRI=NORB_FRZ+1,NORB_DZ
!D1D(22-2)   Drl(12)-
        LMI=LSM_INN(LRI)
        IF(JML.NE.LMI.OR.JMR.NE.LMI) CYCLE
        IF(LINE.EQ.26) THEN    !LRI,LRA
          CALL COMP_LOOP_G(9,LRI,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.28) THEN    !LRI,LRS,LRA
          CALL COMP_LOOP_G(12,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
        IF(LINE.EQ.29) THEN    !LRI,LRS,LRA
          CALL COMP_LOOP_G(11,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
        ENDIF
!       VLOP1=W1*W1_D1D(2)
!       WL=-VLOP1*VOINT(LRI,LRA)
        IWDL=JUD(LRI)
        IWDR=IWDL
C       CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

      ENDDO

      RETURN
      END

      SUBROUTINE SV_HEAD_DBL_TAIL_ACT_G(LRA)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
!SV(10-1) Ar(13)-Br(23)-
!SV(10-2) Ar(23)-Br(13)-
!SV(10-3) Drr(03)-
      IWDR=0
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(LMIJ.NE.JML) CYCLE
        W0SV1=W0_SV(1)
        W1SV1=W1_SV(1)
        W0SV2=W0_SV(2)
        W1SV2=W1_SV(2)
        NI=MOD(LRJ-LRI,2)
        IF(NI.EQ.0) THEN
          W0SV1=-W0SV1
          W1SV1=-W1SV1
          W0SV2=-W0SV2
          W1SV2=-W1SV2
        ENDIF
        IWDL=JUST(LRI,LRJ)
        IF(LRI.EQ.LRJ) THEN
          VLOP0=W0*W0_SV(3)            !D10-3
          VLOP1=0.D0
!         WL=VLOP0*VOINT(LRA,LRI)/2
          IF(LINE.EQ.25) THEN    !LRI,LRA
Cwyb         CALL COMP_LOOP_G(8,LRI,LRG,LRS,LRA,VLOP0,VLOP1,WL)
             CALL COMP_LOOP_G(8,LRI,0,0,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.27) THEN    !LRI,LRS,LRA
Cwyb         CALL COMP_LOOP_G(10,LRI,LRS,LRA,LRA,VLOP0,VLOP1,WL)
            CALL COMP_LOOP_G(10,LRI,0,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

        ELSE
          VLOP0=W0*W0SV2             !D10-2
          VLOP1=W1*W1SV2
!         LIST=LIST3(LRI,LRJ,LRA)
!          WL=(VLOP0+VLOP1)*vint_ci(LIST)        !2.1          !!!!!
          IF(LINE.EQ.25) THEN    !LRI,LRJ,LRA
            CALL COMP_LOOP_G(3,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
          ENDIF
          IF(LINE.EQ.27) THEN      !LRI,LRJ,LRS,LRA
            CALL COMP_LOOP_G(4,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
         ENDIF
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

          IF(JB_SYS.GT.0) THEN
            IWDL=JUST(LRJ,LRI)
            VLOP0=W0*W0SV1
            VLOP1=W1*W1SV1
!           LIST=LIST3(LRI,LRJ,LRA)
!            WL=(VLOP0+VLOP1)*vint_ci(LIST)        !2.1          !!!!!
            IF(LINE.EQ.25) THEN    !LRI,LRJ,LRA
              CALL COMP_LOOP_G(3,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
            IF(LINE.EQ.27) THEN      !LRI,LRJ,LRS,LRA
              CALL COMP_LOOP_G(4,LRI,LRJ,LRS,LRA,VLOP0,VLOP1,WL0,LIST0,
     :                     WL1,LIST1)
            ENDIF
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
C           CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL2,JPER,LIST2,LIST3)
              CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL0,JPER,LIST0)
      IF(LIST1.NE.0)
     :        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL1,JPER,LIST1)

          ENDIF
        ENDIF
      ENDDO
      ENDDO
      RETURN

      END

      SUBROUTINE SD_HEAD_DBL_TAIL_ACT_G(LRA,LPCOE)
!**********************************************
!     LRA, ....partial loop.......
!**********************************************
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      DIMENSION LPCOE(NORB_DZ+1:NORB_INN)
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
      JMLR=MUL_TAB(JML,JMR)
!SD(6-1) A&r(02)-
!SD(6-2) C(22)A&r(13)-
!SD(6-4) A&r(23)C'(12)-
!SD(6-5) A&r(23)B&r(13)B^r(32)
!SD(6-8) A&r(23)B&l(32)B^l(13)
!SD(6-9) D&r&r(03)B^r(32)
!SD(6-11) D&r&l(22)B^l(13)
!SD(6-12) D&r&l(33)B^l(02)
!SD(6-13) (22)D&r&l(33)B^l(13)
!SD(6-14) D&r&l(33)C"(22)B^l(13)
!SD(6-16) D&r&l(33)B^l(23)C'(12)

!SD(6-3) A&r(13)C'(22)-
!SD(6-6) A&r(13)B&r(23)B^r(32)
!SD(6-7) A&r(13)B&l(32)B^l(23)
!SD(6-10) D&r&l(12)B^l(23)
!SD(6-15) D&r&l(33)B^l(13)C'(22)

      IF(JML.NE.1) GOTO 207

!SD(6-1) A&r(02)-
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IWDL=JUST(LRI,LRI)
        W0SD1 =W0_SD(1)
        W0SD12=W0_SD(12)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1) THEN
          W0SD1 =-W0SD1
          W0SD12=-W0SD12
        ENDIF
        IF(LMI.EQ.JMLR) THEN
          IWDR=JUD(LRI)
          VLOP0=W0*W0SD1
C          WL=VLOP0*VOINT(LRI,LRA)
          WL=VLOP0
          CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRI,LRA)

          DO LR=LRI+1,NORB_DZ
C           LIST =LIST3(LRI,LRA,LR)
C            WL=WL+VLOP0*(2*VINT_CI(LIST+1)-VINT_CI(LIST)) !  310:NEOC=2
          WL=VLOP0*2
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
          WL=-VLOP0
          CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
          ENDDO
          DO LRK=norb_dz+1,LRA
C            LIST=LIST3(LRI,LRA,LRK)
            KCOE=LPCOE(LRK)
            CALL NEOC(KCOE,NOCC,TCOE)
C            WL=WL+VLOP0*NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
          CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C          WL=WL*VLOP0
!SD(6-12) D&rl(33)B^l(02)
          VLOP0=W0*W0SD12
         DO LRK=1,LRI-1
C            LIST=LIST3(LRI,LRA,LRK)
C            WL=WL+VLOP0*(vint_ci(LIST)-2*VINT_CI(LIST+1))
            WL=VLOP0
          CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
           WL=-VLOP0*2
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDIF

!SD(6-9) D&r&r(03)B^r(32)
        DO LRD=LRI+1,NORB_DZ
         LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
          W0SD9=W0_SD(9)
          NI=MOD(NORB_DZ-LRD,2)
          IF(NI.EQ.1)   W0SD9=-W0SD9
          IWDR=JUD(LRD)
          VLOP0=W0*W0SD9
C          LIST=LIST3(LRD,LRA,LRI)
C          WL=VINT_CI(LIST)*VLOP0
           WL=VLOP0
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
        ENDDO
      ENDDO

207   DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML) CYCLE
          W0SD2 =W0_SD(2)
          W1SD2 =W1_SD(2)
          W0SD11=W0_SD(11)
          W1SD11=W1_SD(11)
          W0SD14=W0_SD(14)
          W1SD14=0.D0
          NI=MOD(NORB_DZ-LRJ,2)
          IF(NI.EQ.1) THEN
            W0SD2 =-W0SD2
            W1SD2 =-W1SD2
            W0SD11=-W0SD11
            W1SD11=-W1SD11
            W0SD14=-W0SD14
          ENDIF
          IWDL=JUST(LRI,LRJ)
          IWDL1=JUST(LRJ,LRI)
C**********************************************************
!SD(6-2) C(22)-A&r(13)-
          IF(LMI.EQ.JMR) THEN
            IWDR=JUD(LRI)
            VLOP0=W0*W0SD2
C            LIST=LIST3(LRJ,LRA,LRJ)
C            WL=VLOP0*(VOINT(LRJ,LRA)+VINT_CI(LIST))          !310,act_c
            WL=VLOP0
          CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRJ,LRJ,NXO)
          CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRJ,LRA)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            DO LR=LRJ+1,NORB_DZ
C              LIST =LIST3(LRJ,LRA,LR)
C              WL=WL+VLOP0*(2*VINT_CI(LIST+1)-VINT_CI(LIST)) !  310:NEOC
            WL=VLOP0*2
          CALL TRANS_IJKL_INTPOS(LRA,LRJ,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
          CALL TRANS_IJKL_INTPOS(LRA,LR,LRJ,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
            DO LRK=norb_dz+1,LRA
C              LIST=LIST3(LRJ,LRA,LRK)
              KCOE=LPCOE(LRK)
              CALL NEOC(KCOE,NOCC,TCOE)
C              WL=WL+VLOP0*NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
          CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
          CALL TRANS_IJKL_INTPOS(LRA,LRK,LRJ,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            WL=WL*VLOP0
!SD(6-11) D&r&l(22)B^l(13)
            VLOP0=W0*W0SD11
            VLOP1=W1*W1SD11
C            LIST=LIST3(LRJ,LRA,LRI)
C          WL=WL+(VLOP0-VLOP1)*vint_ci(LIST)-2*VLOP0*VINT_CI(LIST+1)
            WL=VLOP0-VLOP1
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
           WL=-VLOP0*2
          CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRI,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

!SD(6-13) (22)D&r&l(33)B^l(13)
!SD(6-14) D&r&l(33)C"(22)B^l(13)
            VLOP0=W0*W0SD14
            DO LRK=1,LRJ-1
              IF(LRK.EQ.LRI) CYCLE
C              LIST=LIST3(LRJ,LRA,LRK)
C              WL=WL+VLOP0*(vint_ci(LIST)-2*VINT_CI(LIST+1))
            WL=VLOP0
          CALL TRANS_IJKL_INTPOS(LRA,LRK,LRJ,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
           WL=-VLOP0*2
          CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
          ENDIF
        IF(JB_SYS.GT.0) THEN
          IF(LMJ.EQ.JMR) THEN
            IWDR=JUD(LRJ)
            W0SD3=W0_SD(3)
            W0SD15=W0_SD(15)
            W1SD10=W1_SD(10)
           NI=MOD(NORB_DZ-LRI,2)
            IF(NI.EQ.0) THEN
             W0SD3=-W0SD3
             W0SD15=-W0SD15
              W1SD10=-W1SD10
            ENDIF
!SD(6-3) A&r(13)-C'(22)-
           VLOP0=W0*W0SD3
C            LIST=LIST3(LRI,LRA,LRI)
C            WL=VOINT(LRI,LRA)+VINT_CI(LIST)
          WL=VLOP0
          CALL PRODAB_1(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,LRI,LRA)
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
C            LIST=LIST3(LRI,LRA,LRJ)
C            WL=WL+VINT_CI(LIST+1)-VINT_CI(LIST)   !310 C'(22)NEOC=1,COE
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRJ,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRI,LRJ,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)

            DO LR=LRI+1,NORB_DZ
              IF(LR.EQ.LRJ) CYCLE
C           LIST =LIST3(LRI,LRA,LR)
C              WL=WL+2*VINT_CI(LIST+1)-VINT_CI(LIST)       !310:NEOC=2,C
            WL=VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
            DO LRK=norb_dz+1,LRA
C              LIST=LIST3(LRI,LRA,LRK)
              KCOE=LPCOE(LRK)
              CALL NEOC(KCOE,NOCC,TCOE)
C              WL=WL+NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            WL=WL*VLOP0
!SD(6-15) D&r&l(33)B^l(13)C'(22)
            VLOP0=W0*W0SD15
            DO LRK=1,LRI-1
C              LIST=LIST3(LRI,LRA,LRK)
C              WL=WL-VLOP0*(2*VINT_CI(LIST+1)-vint_ci(LIST))
            WL=-VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            CALL PRODAB(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER)
          ENDIF
         IF(LMIJ.EQ.JML.AND.LMI.EQ.JMR) THEN
            IWDR=JUD(LRI)
            IWDL1=JUST(LRJ,LRI)
            W1SD10=W1_SD(10)
            IF(MOD(NORB_DZ-LRJ,2).EQ.1) THEN
              W1SD10=-W1SD10
            ENDIF
!SD(6-10) D&r&l(12)B^l(23)
            VLOP1=W1*W1SD10
C            LIST=LIST3(LRJ,LRA,LRI)
C          WL=-VLOP1*vint_ci(LIST)      !4.3
            WL=-VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRI,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
          ENDIF
        ENDIF
!SD(6-4) A&r(23)-C'(12)-
          IF(LMJ.EQ.JMR) THEN
            IWDR=JUD(LRJ)
            W0SD4=W0_SD(4)
            W0SD16=W0_SD(16)
           NI=MOD(NORB_DZ-LRI,2)
            IF(NI.EQ.0) W0SD4=-W0SD4
            IF(NI.EQ.0) W0SD16=-W0SD16
            VLOP0=W0*W0SD4
C            LIST=LIST3(LRI,LRA,LRI)
C            WL=VOINT(LRI,LRA)+VINT_CI(LIST)             !310,act_coe,61
            WL=VLOP0
          CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRI,LRA)
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C            LIST=LIST3(LRI,LRA,LRJ)
C            WL=WL+VINT_CI(LIST+1)-(JB_SYS+2)*1.d0*VINT_CI(LIST)
            WL=VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRJ,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0*(JB_SYS+2)
              CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRI,LRJ,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            DO LR=LRI+1,NORB_DZ
              IF(LR.EQ.LRJ) CYCLE
C           LIST =LIST3(LRI,LRA,LR)
C              WL=WL+2*VINT_CI(LIST+1)-VINT_CI(LIST)       !310:NEOC=2,C
            WL=VLOP0*2
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
            DO LRK=norb_dz+1,LRA
C              LIST=LIST3(LRI,LRA,LRK)
              KCOE=LPCOE(LRK)
              CALL NEOC(KCOE,NOCC,TCOE)
C              WL=WL+NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
              CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            WL=WL*VLOP0
!SD(6-16) D&r&l(33)B^l(23)C'(12)
            VLOP0=W0*W0SD16
            DO LRK=1,LRI-1
C              LIST=LIST3(LRI,LRA,LRK)
C              WL=WL-VLOP0*(2*VINT_CI(LIST+1)-vint_ci(LIST))
            WL=-VLOP0*2
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
          ENDIF

!SD(6-5) A&r(23)B&r(13)B^r(32)
          DO LRD=LRJ+1,NORB_DZ
           LMD=LSM_INN(LRD)
            IF(LMD.NE.JMR) CYCLE
           IWDR=JUD(LRD)
            W0SD5=W0_SD(5)
            W1SD5=W1_SD(5)
            NI=MOD(LRJ-LRI+NORB_DZ-LRD,2)
            IF(NI.EQ.0)   W0SD5=-W0SD5
            IF(NI.EQ.0)   W1SD5=-W1SD5
            VLOP0=W0*W0SD5
            VLOP1=W1*W1SD5
C            LIST=LIST4(LRI,LRJ,LRD,LRA)
C            WL=(VLOP0-VLOP1)*vint_ci(LIST+2)+
C     :         (VLOP0+VLOP1)*vint_ci(LIST)             !1.3
            WL=VLOP0-VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRD,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0+VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C         CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
         ENDDO
        IF(JB_SYS.GT.0) THEN
!SD(6-6) A&r(13)B&r(23)B^r(32)
          DO LRD=LRJ+1,NORB_DZ
           LMD=LSM_INN(LRD)
            IF(LMD.NE.JMR) CYCLE
           IWDR=JUD(LRD)
            W0SD6=W0_SD(6)
            W1SD6=W1_SD(6)
            NI=MOD(LRJ-LRI+NORB_DZ-LRD,2)
            IF(NI.EQ.0)   W0SD6=-W0SD6
            IF(NI.EQ.0)   W1SD6=-W1SD6
            VLOP0=W0*W0SD6
            VLOP1=W1*W1SD6
C            LIST=LIST4(LRI,LRJ,LRD,LRA)
C            WL=(VLOP0-VLOP1)*vint_ci(LIST+2)+
C     :         (VLOP0+VLOP1)*vint_ci(LIST)             !1.3
            WL=VLOP0-VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRD,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0+VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)

C         CALL PRODAB(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER)
         ENDDO
!SD(6-7) A&r(13)B&l(32)B^l(23)
         DO LRD=LRI+1,LRJ-1
           LMD=LSM_INN(LRD)
           IF(LMD.NE.JMR) CYCLE
           IWDR=JUD(LRD)
           W0SD7=W0_SD(7)
           W1SD7=W1_SD(7)
           NI=MOD(LRD-LRI+NORB_DZ-LRJ,2)
           IF(NI.EQ.0)   W0SD7=-W0SD7
           IF(NI.EQ.0)   W1SD7=-W1SD7
           VLOP0=W0*W0SD7
           VLOP1=W1*W1SD7
C           LIST=LIST4(LRI,LRD,LRJ,LRA)
C          WL=(VLOP0-VLOP1)*vint_ci(LIST+2)-
C     :             2*VLOP0*vint_ci(LIST+1)      !1.2
            WL=VLOP0-VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRJ,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-2*VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
            CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
C          CALL PRODAB(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER)
         ENDDO
        ENDIF
!SD(6-8) A&r(23)B&l(32)B^l(13)
         DO LRD=LRI+1,LRJ-1
           LMD=LSM_INN(LRD)
           IF(LMD.NE.JMR) CYCLE
           IWDR=JUD(LRD)
           W0SD8=W0_SD(8)
           W1SD8=W1_SD(8)
           NI=MOD(LRD-LRI+NORB_DZ-LRJ,2)
           IF(NI.EQ.0)   W0SD8=-W0SD8
           IF(NI.EQ.0)   W1SD8=-W1SD8
           VLOP0=W0*W0SD8
           VLOP1=W1*W1SD8
C           LIST=LIST4(LRI,LRD,LRJ,LRA)
C          WL=(VLOP0-VLOP1)*vint_ci(LIST+2)-
C     :             2*VLOP0*vint_ci(LIST+1)      !1.2
            WL=VLOP0-VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRJ,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-2*VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C        CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE SDD_HEAD_DBL_TAIL_ACT_G(LRA,LPCOE)
!**********************************************
!     LRA, ....partial loop.......
!**********************************************
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      DIMENSION LPCOE(NORB_DZ+1:NORB_INN)
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
      JMLR=MUL_TAB(JML,JMR)
!SD1(8-1) A&r(01)-
!SD1(8-2) C(11)A&r(23)-
!SD1(8-3) A&r(13)C'(21)-
!SD1(8-4) A&r(23)C'(11)-
!SD1(8-5) A&r(13)B&r(23)B^r(31)
!SD1(8-6) A&r(23)B&r(13)B^r(31)
!SD1(8-7) A&r(13)B&l(31)B^l(23)
!SD1(8-8) A&r(23)B&l(31)B^l(13)
!SD1(8-9) D&r&r(03)B^r(31)
!SD1(8-10) D&r&l(11)B^l(23)
!SD1(8-11) D&r&l(33)B^l(01)
!SD1(8-12) D&r&l(33)B^l(23)
!SD1(8-13) D&r&l(33)C"(13)B^l(23)
!SD1(8-14) D&r&l(33)B^l(11)C'(23)
!SD1(8-15) D&r&l(33)B^l(23)C'(11)
      IF(JML.NE.1) GOTO 209
      DO LRI=NORB_FRZ+1,NORB_DZ
!SD1(8-1) A&r(01)-
        LMI=LSM_INN(LRI)
        IWDL=JUST(LRI,LRI)
        W0SD1=W0_SD1(1)
        W0SD11=W0_SD1(9)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1) THEN
          W0SD1 =-W0SD1
          W0SD11=-W0SD11
        ENDIF
        IF(LMI.EQ.JMLR) THEN
          IWDR=JUD(LRI)
          VLOP0=W0*W0SD1
C          WL=VLOP0*VOINT(LRI,LRA)
          WL=VLOP0
          CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRI,LRA)

          DO LR=LRI+1,NORB_DZ
C            LIST =LIST3(LRI,LRA,LR)
C            WL=WL+VLOP0*(2*VINT_CI(LIST+1)-VINT_CI(LIST)) !  310:NEOC=2
          WL=VLOP0*2
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
          WL=-VLOP0
          CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
          DO LRK=norb_dz+1,LRA
C            LIST=LIST3(LRI,LRA,LRK)
            KCOE=LPCOE(LRK)
            CALL NEOC(KCOE,NOCC,TCOE)
C            WL=WL+VLOP0*NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C          WL=WL*VLOP0
!SD1(8-11) D&rl(33)B^l(01)
          VLOP0=W0*W0SD11
         DO LRK=1,LRI-1
C            LIST=LIST3(LRI,LRA,LRK)
C            WL=WL+VLOP0*(vint_ci(LIST)-2*VINT_CI(LIST+1))
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDIF

!SD1(8-9) D&r&r(03)B^r(31)
        DO LRD=LRI+1,NORB_DZ
         LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
          W0SD9=W0_SD1(9)
          NI=MOD(NORB_DZ-LRD,2)
          IF(NI.EQ.1)   W0SD9=-W0SD9
          IWDR=JUD(LRD)
          VLOP0=W0*W0SD9
C          LIST=LIST3(LRD,LRA,LRI)
C          WL=VINT_CI(LIST)*VLOP0
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
      ENDDO

209   DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          IF(LRI.EQ.LRJ) CYCLE
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML) CYCLE
          W0SD2 =W0_SD1(2)
          W1SD2 =W1_SD1(2)
          W0SD3 =W0_SD1(3)
          W1SD3 =W1_SD1(3)
          W0SD4 =W0_SD1(4)
          W1SD4 =W1_SD1(4)
          W0SD10=W0_SD1(10)
          W1SD10=W1_SD1(10)
          W0SD11=W0_SD1(11)
          W1SD11=0.D0
          W0SD12=W0_SD1(12)
          W0SD13=W0_SD1(13)
          NI=MOD(NORB_DZ-LRJ,2)
          IF(NI.EQ.1) THEN
            W0SD2 =-W0SD2
            W1SD2 =-W1SD2
            W0SD10=-W0SD10
            W1SD10=-W1SD10
            W0SD11=-W0SD11
          ENDIF
          IF(MOD(NORB_DZ-LRI,2).EQ.1) THEN
            W0SD3 =-W0SD3
            W1SD3 =-W1SD3
            W0SD4 =-W0SD4
            W1SD4 =-W1SD4
            W0SD12=-W0SD12
            W0SD13=-W0SD13
          ENDIF
          IWDL=JUST(LRJ,LRI)
          IWDL1=JUST(LRI,LRJ)
C**********************************************************
!SD1(8-2) C(11)-A&r(23)-
          IF(LMI.EQ.JMR) THEN
            IWDL=JUST(LRJ,LRI)
            IWDR=JUD(LRI)
            VLOP0=W0*W0SD2
C            LIST=LIST3(LRJ,LRA,LRJ)
C            WL=VLOP0*(VOINT(LRJ,LRA)+VINT_CI(LIST))
              WL=VLOP0
        CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRJ,LRA)
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRJ,LRJ,NXO)
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            DO LR=LRJ+1,NORB_DZ
C              LIST =LIST3(LRJ,LRA,LR)
C              WL=WL+VLOP0*(2*VINT_CI(LIST+1)-VINT_CI(LIST)) !  310:NEOC
            WL=VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LR,LRJ,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
            DO LRK=norb_dz+1,LRA
C              LIST=LIST3(LRJ,LRA,LRK)
              KCOE=LPCOE(LRK)
              CALL NEOC(KCOE,NOCC,TCOE)
C              WL=WL+VLOP0*NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRJ,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            WL=WL*VLOP0
!SD1(8-10) D&r&l(11)B^l(23)
            VLOP0=W0*W0SD10
            VLOP1=W1*W1SD10
C            LIST=LIST3(LRJ,LRA,LRI)
C          WL=WL+(VLOP0-VLOP1)*vint_ci(LIST)-2*VLOP0*VINT_CI(LIST+1)

            WL=VLOP0-VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRI,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)


!SD1(8-11) (11)D&r&l(33)B^l(23)
!SD1(8-11) D&r&l(33)C"(11)B^l(23)
            VLOP0=W0*W0SD11
            DO LRK=1,LRJ-1
              IF(LRK.EQ.LRI) CYCLE
C              LIST=LIST3(LRJ,LRA,LRK)
C              WL=WL+VLOP0*(vint_ci(LIST)-2*VINT_CI(LIST+1))
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRJ,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
          ENDIF
!SD1(8-3) A&r(13)-C'(21)-
          IF(LMJ.EQ.JMR) THEN
            VLOP0=-W0*W0SD3
C--------------------------------------
C lyb
           IWDL=JUST(LRJ,LRI)
           IWDR=JUD(LRJ)

C            LIST=LIST3(LRI,LRA,LRI)
C            WL=VOINT(LRI,LRA)+VINT_CI(LIST)
              WL=VLOP0
C            write(nf2,'(a3,5I8)') 'sdd',JPEL,IWDL,IWDR,JWL,JWR
        CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRI,LRA)
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C            LIST=LIST3(LRI,LRA,LRJ)
C            WL=WL+VINT_CI(LIST+1)+JB_SYS*1.d0*VINT_CI(LIST)
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRJ,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*JB_SYS
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRI,LRJ,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            DO LR=LRI+1,NORB_DZ
              IF(LR.EQ.LRJ) CYCLE
C           LIST =LIST3(LRI,LRA,LR)
C              WL=WL+2*VINT_CI(LIST+1)-VINT_CI(LIST)       !310:NEOC=2,C
            WL=VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
            DO LRK=norb_dz+1,LRA
C              LIST=LIST3(LRI,LRA,LRK)
              KCOE=LPCOE(LRK)
              CALL NEOC(KCOE,NOCC,TCOE)
C              WL=WL+NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            ENDDO
C            WL=WL*VLOP0
!SD1(8-12) Drl(33)-BL(13)-C'(21)-
C            IWDL=JUST(LRJ,LRI)
C           IWDR=JUD(LRJ)
            VLOP0=-W0*W0SD12
            DO LRK=1,LRI-1
C              LIST=LIST3(LRI,LRA,LRK)
C              WL=WL-VLOP0*(2*VINT_CI(LIST+1)-vint_ci(LIST))
            WL=-VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
          ENDIF
!SD1(8-4) A&r(23)-C'(11)-
          IF(LMJ.EQ.JMR) THEN
C-----------------------------
C lyb
           IWDL=JUST(LRI,LRJ)
           IWDR=JUD(LRJ)
             VLOP0=-W0*W0SD4
C            LIST=LIST3(LRI,LRA,LRI)
C            WL=VOINT(LRI,LRA)+VINT_CI(LIST)
              WL=VLOP0
        CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRI,LRA)
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C            LIST=LIST3(LRI,LRA,LRJ)
C            WL=WL+VINT_CI(LIST+1)-VINT_CI(LIST)
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRJ,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRI,LRJ,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            DO LR=LRI+1,NORB_DZ
              IF(LR.EQ.LRJ) CYCLE
C           LIST =LIST3(LRI,LRA,LR)
C              WL=WL+2*VINT_CI(LIST+1)-VINT_CI(LIST)       !310:NEOC=2,C
            WL=VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
            DO LRK=norb_dz+1,LRA
C              LIST=LIST3(LRI,LRA,LRK)
              KCOE=LPCOE(LRK)
              CALL NEOC(KCOE,NOCC,TCOE)
C              WL=WL+NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            WL=WL*VLOP0
!SD1(8-13) Drl(33)-BL(23)-C'(11)-
C            IWDL=JUST(LRI,LRJ)
C           IWDR=JUD(LRJ)
            VLOP0=-W0*W0SD13
            DO LRK=1,LRI-1
C              LIST=LIST3(LRI,LRA,LRK)
C              WL=WL-VLOP0*(2*VINT_CI(LIST+1)-vint_ci(LIST))
            WL=-VLOP0*2
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

            ENDDO
C            CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
          ENDIF
!SD1(8-5) A&r(13)B&r(23)B^r(31)
          DO LRD=LRJ+1,NORB_DZ
           LMD=LSM_INN(LRD)
            IF(LMD.NE.JMR) CYCLE
            IWDL=JUST(LRJ,LRI)
           IWDR=JUD(LRD)
            W0SD5=W0_SD1(5)
            W1SD5=W1_SD1(5)
            NI=MOD(LRJ-LRI+NORB_DZ-LRD,2)
            IF(NI.EQ.0)   W0SD5=-W0SD5
            IF(NI.EQ.0)   W1SD5=-W1SD5
            VLOP0=W0*W0SD5
            VLOP1=W1*W1SD5
C            LIST=LIST4(LRI,LRJ,LRD,LRA)
C            WL=(VLOP0-VLOP1)*vint_ci(LIST+2)+
C     :         (VLOP0+VLOP1)*vint_ci(LIST)             !1.3
            WL=VLOP0-VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRD,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0+VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
!SD1(8-6) A&r(23)B&r(13)B^r(31)
            IWDL=JUST(LRI,LRJ)
            W0SD6=W0_SD1(6)
            W1SD6=W1_SD1(6)
            NI=MOD(LRJ-LRI+NORB_DZ-LRD,2)
            IF(NI.EQ.0)   W0SD6=-W0SD6
            IF(NI.EQ.0)   W1SD6=-W1SD6
            VLOP0=W0*W0SD6
            VLOP1=W1*W1SD6
C            LIST=LIST4(LRI,LRJ,LRD,LRA)
C            WL=(VLOP0-VLOP1)*vint_ci(LIST+2)+
C     :         (VLOP0+VLOP1)*vint_ci(LIST)             !1.3
            WL=VLOP0-VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRD,NXO)
          CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0+VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)

C         CALL PRODAB(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER)
         ENDDO
!SD1(8-7) A&r(13)B&l(31)B^l(23)
         DO LRD=LRI+1,LRJ-1
           LMD=LSM_INN(LRD)
           IF(LMD.NE.JMR) CYCLE
           IWDR=JUD(LRD)
           IWDL=JUST(LRJ,LRI)
           W0SD7=W0_SD1(7)
           W1SD7=W1_SD1(7)
           NI=MOD(LRD-LRI+NORB_DZ-LRJ,2)
           IF(NI.EQ.0)   W0SD7=-W0SD7
           IF(NI.EQ.0)   W1SD7=-W1SD7
           VLOP0=W0*W0SD7
           VLOP1=W1*W1SD7
C           LIST=LIST4(LRI,LRD,LRJ,LRA)
C          WL=(VLOP0-VLOP1)*vint_ci(LIST+2)-
C     :             2*VLOP0*vint_ci(LIST+1)      !1.2
            WL=VLOP0-VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRJ,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-2*VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C         CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
!SD1(8-8) A&r(23)B&l(31)B^l(13)
           IWDL=JUST(LRI,LRJ)
           W0SD8=W0_SD1(8)
           W1SD8=W1_SD1(8)
           NI=MOD(LRD-LRI+NORB_DZ-LRJ,2)
           IF(NI.EQ.0)   W0SD8=-W0SD8
           IF(NI.EQ.0)   W1SD8=-W1SD8
           VLOP0=W0*W0SD8
           VLOP1=W1*W1SD8
C           LIST=LIST4(LRI,LRD,LRJ,LRA)
C          WL=(VLOP0-VLOP1)*vint_ci(LIST+2)-
C     :             2*VLOP0*vint_ci(LIST+1)      !1.2
            WL=VLOP0-VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRJ,NXO)
          CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-2*VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER,NXO)

C         CALL PRODAB(3,JPEL,IWDL1,IWDR,JWL,JWR,WL,JPER)
         ENDDO
       ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE TD_HEAD_DBL_TAIL_ACT_G(LRA,LPCOE)
!**********************************************
!     LRA, ....partial loop.......
!**********************************************
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      DIMENSION LPCOE(NORB_DZ+1:NORB_INN)
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
      JMLR=MUL_TAB(JML,JMR)
!TD(13-1) (22)A&(23)
!TD(13-1) A&(23)C'(22)
!TD(13-5) (22)D&&l(33)B^l(23)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        ISMA=LMI
        IF(LMI.NE.JMLR) CYCLE
        W0TD1=W0_TD(1)
        W0TD4=W0_TD(4)
        W0TD5=W0_TD(5)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1)W0TD1=-W0TD1
        IF(NI.EQ.1)W0TD4=-W0TD4
        IF(NI.EQ.1)W0TD5=-W0TD5

!TD(13-1) A&(23)C'(22)
        DO LRD=LRI+1,NORB_DZ
          LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
         IWDL=JUST(LRI,LRD)      !
          IWDR=JUD(LRD)
          VLOP0=-W0*W0TD1
C          LIST=LIST3(LRI,LRA,LRI)
C          WL=VOINT(LRI,LRA)+VINT_CI(LIST)             !310,act_coe,610,
              WL=VLOP0
        CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRI,LRA)
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C          LIST=LIST3(LRI,LRA,LRD)
C         WL=WL+VINT_CI(LIST+1)                          !310 C'(22) COE
              WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRD,LRI,LRD,NXO)
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

         DO LR=LRI+1,NORB_DZ
            IF(LR.EQ.LRD) CYCLE
C          LIST =LIST3(LRI,LRA,LR)
C            WL=WL+2*VINT_CI(LIST+1)-VINT_CI(LIST)       !310:NEOC=2,COE
            WL=2*VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
          DO LRK=norb_dz+1,LRA
C            LIST=LIST3(LRI,LRA,LRK)
            KCOE=LPCOE(LRK)
            CALL NEOC(KCOE,NOCC,TCOE)
C            WL=WL+NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            WL=VLOP0*NOCC
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C          WL=WL*VLOP0
!TD(13-5) D&rl(33)B^l(23)C'(22)          !CC (22)D&rl(33)B^l(23)???
          VLOP0=-W0*W0TD5
          DO LRK=1,LRI-1
C            LIST=LIST3(LRI,LRA,LRK)
C            WL=WL-VLOP0*(2*VINT_CI(LIST+1)-vint_ci(LIST))
            WL=-2*VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
!-------------------------------------------------------------------
        DO LRD=NORB_FRZ+1,LRI-1
          LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
         IWDL=JUST(LRD,LRI)      !
          IWDR=JUD(LRD)
!TD(13-1) (22)A&(23)
          VLOP0=W0*W0TD1
C          LIST=LIST3(LRI,LRA,LRI)
C          WL=VLOP0*(VOINT(LRI,LRA)+VINT_CI(LIST))             !310,act_
              WL=VLOP0
        CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRI,LRA)
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
       CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          DO LR=LRI+1,NORB_DZ
C            LIST =LIST3(LRI,LRA,LR)
C            WL=WL+VLOP0*(2*VINT_CI(LIST+1)-VINT_CI(LIST)) !  310:NEOC=2
            WL=2*VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
          DO LRK=norb_dz+1,LRA
C            LIST=LIST3(LRI,LRA,LRK)
            KCOE=LPCOE(LRK)
            CALL NEOC(KCOE,NOCC,TCOE)
C            WL=WL+VLOP0*NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
          ENDDO
C            WL=WL*VLOP0
!TD(13-4) D&r&l(22)B^l(23)
          VLOP0=W0*W0TD4
          VLOP1=W1*W0TD4
C          LIST=LIST3(LRI,LRA,LRD)
C          WL=WL+(VLOP0-VLOP1)*vint_ci(LIST)-2*VLOP0*VINT_CI(LIST+1)

            WL=VLOP0-VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRD,LRI,LRD,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-2*VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRD,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
!TD(13-5) D&rl(33)C"(22)B^l(23)
          VLOP0=W0*W0TD5
          DO LRK=1,LRI-1
            IF(LRK.EQ.LRD) CYCLE
C          LIST=LIST3(LRI,LRA,LRK)
C            WL=WL+VLOP0*(vint_ci(LIST)-2*VINT_CI(LIST+1))      !4.3
            WL=VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-2*VLOP0
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
          ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
      ENDDO
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(LMIJ.NE.JML) CYCLE
        IWDL=JUST(LRI,LRJ)     !

!TD(13-2) A&(23)B&r(23)B^r(32)
        DO LRD=LRJ+1,NORB_DZ
          LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
          W0TD2=W0_TD(2)
          W1TD2=W1_TD(2)
          NI=MOD(LRJ-LRI+NORB_DZ-LRD,2)
        IF(NI.EQ.0) W0TD2=-W0TD2
        IF(NI.EQ.0) W1TD2=-W1TD2

          IWDR=JUD(LRD)
          VLOP0=W0*W0TD2
          VLOP1=W1*W1TD2
C          LIST=LIST4(LRI,LRJ,LRD,LRA)
C         WL=VLOP0*(vint_ci(LIST+2)+vint_ci(LIST))  !1.3
C    :       -VLOP1*(vint_ci(LIST+2)-vint_ci(LIST))
            WL=VLOP0-VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRD,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0+VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C       CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
!TD(13-3) A&(23)B&l(32)B^l(23)
        DO LRD=LRI+1,LRJ-1
          LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
          IWDR=JUD(LRD)
          W0TD3=W0_TD(3)
          W1TD3=W1_TD(3)
          NI=MOD(LRD-LRI+NORB_DZ-LRJ,2)
          IF(NI.EQ.0)   W0TD3=-W0TD3
          IF(NI.EQ.0)   W1TD3=-W1TD3
          VLOP0=W0*W0TD3                !D6-8
          VLOP1=W1*W1TD3
C          LIST=LIST4(LRI,LRD,LRJ,LRA)
C       WL=VLOP0*(vint_ci(LIST+2)-2*vint_ci(LIST+1))      !1.2
C     :       -VLOP1*vint_ci(LIST+2)
            WL=VLOP0-VLOP1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRJ,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-2*VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C       CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TTDD_HEAD_DBL_TAIL_ACT_G(LRA,LPCOE)
!**********************************************
!     LRA, ....partial loop.......
!**********************************************
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      DIMENSION LPCOE(NORB_DZ+1:NORB_INN)
      COMMON/ONEPL/LINE,JPH,JPEL,JPER,LRG,LRS,JWL,JWR,W0,W1
      JMLR=MUL_TAB(JML,JMR)
!T1D1(15-1) (11)A&(13)
!T1D1(15-1) A&(13)C'(11)
!T1D1(15-5) (11)D&&l(33)B^l(13)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        ISMA=LMI
        IF(LMI.NE.JMLR) CYCLE
        W0TD1=W0_T1D1(1)
        W0TD4=W0_T1D1(4)
        W0TD5=W0_T1D1(5)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1) THEN
          W0TD1=-W0TD1
          W0TD4=-W0TD4
          W0TD5=-W0TD5
        ENDIF
!T1D1(15-2) A&(13)C'(11)
        DO LRD=LRI+1,NORB_DZ
          LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
         IWDL=JUST(LRI,LRD)      !
          IWDR=JUD(LRD)
          VLOP0=-W0*W0TD1
C          LIST=LIST3(LRI,LRA,LRI)
C          WL=VOINT(LRI,LRA)+VINT_CI(LIST)             !310,act_coe,610,
              WL=VLOP0
        CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRI,LRA)
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C          LIST=LIST3(LRI,LRA,LRD)
C          WL=WL+VINT_CI(LIST+1)                          !310 C'(22) CO
              WL=VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRD,NXO)
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

         DO LR=LRI+1,NORB_DZ
            IF(LR.EQ.LRD) CYCLE
C          LIST =LIST3(LRI,LRA,LR)
C            WL=WL+2*VINT_CI(LIST+1)-VINT_CI(LIST)       !310:NEOC=2,COE
            WL=2*VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
          DO LRK=norb_dz+1,LRA
C            LIST=LIST3(LRI,LRA,LRK)
            KCOE=LPCOE(LRK)
            CALL NEOC(KCOE,NOCC,TCOE)
C            WL=WL+NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
              CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C          WL=WL*VLOP0
!T1D1(15-5) D&rl(33)B^l(13)C'(11)
          VLOP0=-W0*W0TD5
          DO LRK=1,LRI-1
C            LIST=LIST3(LRI,LRA,LRK)
C            WL=WL-VLOP0*(2*VINT_CI(LIST+1)-vint_ci(LIST))
            WL=-2*VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
!-------------------------------------------------------------------
        DO LRD=NORB_FRZ+1,LRI-1
          LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
         IWDL=JUST(LRD,LRI)      !
          IWDR=JUD(LRD)
!T1D1(15-1) (11)A&(13)
          VLOP0=W0*W0TD1
C          LIST=LIST3(LRI,LRA,LRI)
C          WL=VLOP0*(VOINT(LRI,LRA)+VINT_CI(LIST))             !310,act_
              WL=VLOP0
        CALL PRODAB_1(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,LRI,LRA)
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
        CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)


          DO LR=LRI+1,NORB_DZ
C            LIST =LIST3(LRI,LRA,LR)
C            WL=WL+VLOP0*(2*VINT_CI(LIST+1)-VINT_CI(LIST)) !  310:NEOC=2
            WL=2*VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LR,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LR,LRI,LR,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
          DO LRK=norb_dz+1,LRA
C            LIST=LIST3(LRI,LRA,LRK)
            KCOE=LPCOE(LRK)
            CALL NEOC(KCOE,NOCC,TCOE)
C            WL=WL+VLOP0*NOCC*(VINT_CI(LIST+1)+TCOE*VINT_CI(LIST))
            WL=VLOP0*NOCC
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0*NOCC*TCOE
              CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
            CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C            WL=WL*VLOP0
!T1D1(15-4) D&r&l(11)B^l(13)
          VLOP0=W0*W0TD4
          VLOP1=W1*W0TD4
C          LIST=LIST3(LRI,LRA,LRD)
C          WL=WL+(VLOP0-VLOP1)*vint_ci(LIST)-2*VLOP0*VINT_CI(LIST+1)
            WL=VLOP0-VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRD,LRI,LRD,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-2*VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRD,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)


!T1D1(15-5) D&rl(33)C"(11)B^l(13)
          VLOP0=W0*W0TD5
          DO LRK=1,LRI-1
            IF(LRK.EQ.LRD) CYCLE
C          LIST=LIST3(LRI,LRA,LRK)
C           WL=WL+VLOP0*(vint_ci(LIST)-2*VINT_CI(LIST+1))      !4.3
            WL=-2*VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

          ENDDO
C          CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
      ENDDO
      DO LRI=NORB_FRZ+1,NORB_DZ-1
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(LMIJ.NE.JML) CYCLE
        IWDL=JUST(LRI,LRJ)     !

!T1D1(15-2) A&(13)B&r(13)B^r(31)
        DO LRD=LRJ+1,NORB_DZ
          LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
          W0TD2=W0_T1D1(2)
          W1TD2=W1_T1D1(2)
          NI=MOD(LRJ-LRI+NORB_DZ-LRD,2)
        IF(NI.EQ.0) W0TD2=-W0TD2
        IF(NI.EQ.0) W1TD2=-W1TD2

          IWDR=JUD(LRD)
          VLOP0=W0*W0TD2
          VLOP1=W1*W1TD2
C          LIST=LIST4(LRI,LRJ,LRD,LRA)
C         WL=VLOP0*(vint_ci(LIST+2)+vint_ci(LIST))  !1.3
C     :       -VLOP1*(vint_ci(LIST+2)-vint_ci(LIST))
            WL=VLOP0-VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRJ,LRD,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=VLOP0+VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C       CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
!T1D1(15-3) A&(13)B&l(31)B^l(13)
        DO LRD=LRI+1,LRJ-1
          LMD=LSM_INN(LRD)
          IF(LMD.NE.JMR) CYCLE
          IWDR=JUD(LRD)
          W0TD3=W0_T1D1(3)
          W1TD3=W1_T1D1(3)
          NI=MOD(LRD-LRI+NORB_DZ-LRJ,2)
          IF(NI.EQ.0)   W0TD3=-W0TD3
          IF(NI.EQ.0)   W1TD3=-W1TD3
          VLOP0=W0*W0TD3                !D6-8
          VLOP1=W1*W1TD3
C          LIST=LIST4(LRI,LRD,LRJ,LRA)
C       WL=VLOP0*(vint_ci(LIST+2)-2*vint_ci(LIST+1))      !1.2
C     :       -VLOP1*vint_ci(LIST+2)
            WL=VLOP0-VLOP1
              CALL TRANS_IJKL_INTPOS(LRA,LRI,LRD,LRJ,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)
            WL=-2*VLOP0
              CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRD,LRI,NXO)
          CALL PRODAB_2(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER,NXO)

C       CALL PRODAB(3,JPEL,IWDL,IWDR,JWL,JWR,WL,JPER)
        ENDDO
      ENDDO
      ENDDO

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TROrder(TRVec,nTR,nX)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nTR, nX
real(kind=wp), intent(inout) :: TRVec(6*nX)
integer(kind=iwp) :: i, iFrom, iTo, iTR

if (nTR == 6) return
do i=2,nX
  do iTR=1,nTR
    iFrom = (i-1)*6+iTR
    iTo = (i-1)*nTR+iTR
    TRVec(iTo) = TRVec(iFrom)
  end do
end do

return

end subroutine TROrder

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine NStateOpt2(RotMat,GDMat,Gtuvx)

use Index_Functions, only: nTri_Elem
use CMS, only: CMSNotConverged
use rasscf_global, only: CMSThreshold, iCMSIterMax, iCMSIterMin, lRoots, NAC
use PrintLevel, only: USUAL
use output_ras, only: IPRLOC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: RotMat(lRoots,lRoots), GDMat(nTri_Elem(lRoots),NAC,NAC)
real(kind=wp), intent(in) :: Gtuvx(NAC,NAC,NAC,NAC)
integer(kind=iwp) :: ICMSIter, IPair, iPrLev, IState, JState, NPairs
real(kind=wp) :: VeeSumChange, VeeSumNew, VeeSumOld
logical(kind=iwp) :: Converged
integer(kind=iwp), allocatable :: StatePair(:,:)
real(kind=wp), allocatable :: FRot(:,:), theta(:), Vee(:)

IPRLEV = IPRLOC(6)

NPairs = nTri_Elem(lRoots-1)
call mma_allocate(StatePair,NPairs,2)
call mma_allocate(theta,NPairs)
call mma_allocate(Vee,lRoots)
call mma_allocate(FRot,lRoots,lRoots)
IPair = 0
do IState=1,lRoots
  do JState=1,IState-1
    IPair = IPair+1
    StatePair(IPair,1) = IState
    StatePair(IPair,2) = JState
  end do
end do
Converged = .false.
FRot(:,:) = RotMat(:,:)
call RotGDMat(FRot,GDMat)
call CalcVee2(Vee,GDMat,Gtuvx)
VeeSumOld = sum(Vee(:))
ICMSIter = 0
!write(u6,'(6X,I4,8X,F16.8,8X,ES16.4E3)') ICMSIter,VeeSumOld,0.0d0
do while (.not. Converged)
  theta(:) = Zero
  ICMSIter = ICMSIter+1
  call ThetaOpt2(FRot,theta,VeeSumChange,StatePair,NPairs,GDMat,Vee,Gtuvx)
  VeeSumNew = VeeSumOld+VeeSumChange
  if (IPRLEV >= USUAL) then
    if (lRoots > 2) then
      write(u6,'(6X,I4,8X,F16.8,8X,ES16.4E3)') ICMSIter,VeeSumNew,VeeSumChange
      !call RecPrt(' ',' ',Vee,lRoots,1)
      !write(u6,*) sum(Vee(:))
    else
      write(u6,'(6X,I4,8X,F6.1,9X,F16.8,5X,ES16.4E3)') ICMSIter,asin(FRot(2,1))/deg2rad,VeeSumNew,VeeSumChange
      !call RecPrt(' ',' ',Vee,lRoots,1)
      !write(u6,*) sum(Vee(:))
    end if
  end if
  if (abs(VeeSumChange) < CMSThreshold) then
    if (ICMSIter >= ICMSIterMin) then
      Converged = .true.
      if (IPRLEV >= USUAL) write(u6,'(4X,A)') 'CONVERGENCE REACHED'
    end if
  else
    if (ICMSIter >= ICMSIterMax) then
      Converged = .true.
      CMSNotConverged = .true.
      write(u6,'(4X,A)') 'NOT CONVERGED AFTER MAX NUMBER OF CYCLES'
      write(u6,'(4X,A)') 'TEMPORARY ROTATION MATRIX SAVED'
    end if
  end if
  !Converged = .true.
  VeeSumOld = VeeSumNew
end do
if (IPRLEV >= USUAL) write(u6,*) repeat('=',71)

RotMat(:,:) = FRot(:,:)
call mma_deallocate(StatePair)
call mma_deallocate(theta)
call mma_deallocate(Vee)
call mma_deallocate(FRot)

end subroutine NStateOpt2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ssibfn(nmax,x,ssi)
! scaled spherical i Bessel functions

use Constants, only: Zero, One, Two, Three, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nmax
real(kind=wp), intent(in) :: x
real(kind=wp), intent(out) :: ssi(nmax+1)
integer(kind=iwp) :: n
real(kind=wp) :: ak, akpkm2, akqkm2, aprod, ex, f2kp1, f2kp3, f2nm1, f2np1, f2np3, pk, pkm1, qk, qkm1, x2, xmin

x2 = x*x
xmin = (abs(3*nmax-1))

if (x <= xmin) then

  n = nmax
  f2np1 = (n+n+1)
  f2kp3 = f2np1
  pkm1 = Zero
  pk = One
  qkm1 = One
  qk = One
  aprod = One
  do
    f2kp1 = f2kp3
    f2kp3 = f2kp3+Two
    ak = x2/(f2kp1*f2kp3)
    akpkm2 = ak*pkm1
    pkm1 = pk
    pk = pkm1+akpkm2
    akqkm2 = ak*qkm1
    qkm1 = qk
    qk = qkm1+akqkm2
    aprod = ak*aprod
    if (((pk*qkm1)+aprod) == (pk*qkm1)) exit
  end do
  ssi(n+1) = pk/qk
  do
    if (n == 0) exit
    n = n-1
    f2np3 = f2np1
    f2np1 = f2np1-Two
    ssi(n+1) = (f2np1*f2np3)/((f2np1*f2np3)+x2*ssi(n+2))
  end do
  ssi(1) = ssi(1)/(One+x*ssi(1))
  do n=1,nmax
    ssi(n+1) = ssi(n+1)*ssi(n)
  end do

else

  if (x >= 20.0_wp) then
    ex = Zero
  else
    ex = exp(-(x+x))
  end if
  ssi(1) = (One-ex)/(x+x)
  if (nmax == 0) return
  ssi(2) = OneHalf*(One+ex+(ex-One)/x)/x2
  if (nmax == 1) return
  f2np1 = Three
  do n=2,nmax
    f2nm1 = f2np1
    f2np1 = f2np1+Two
    ssi(n+1) = (ssi(n-1)-ssi(n))*(f2nm1*f2np1)/x2
  end do

end if

return

end subroutine ssibfn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WrInp_sl(iRow)
      use kriging_mod
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "info_slapaf.fh"
#include "print.fh"
#include "constants.fh"
*
      iRout=3
      iPrint=nPrint(iRout)
*
      Lu=6
*
*
      If (lNmHss) Then
         lOld = .False.
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.5) Then
*                                                                      *
************************************************************************
*                                                                      *
      Write (Lu,*)
      Write (Lu,*)
      Call CollapseOutput(1,'      Slapaf input parameters:')
      Write (Lu,'(3X,A)')   '      ------------------------'
      Write (Lu,*)
*                                                                      *
************************************************************************
*                                                                      *
      Write (Lu,'(A,I5)')  ' Max iterations:                           '
     &      ,MxItr
      If (Baker) Then
         Write (Lu,'(A)')  ' Convergence test a la Baker.'
      Else
         Write (Lu,'(A)')  ' Convergence test a la Schlegel.'
      End If
      Write (Lu,'(A,ES8.1)')
     &    ' Convergence criterion on gradient/para.<=:',ThrGrd
      Write (Lu,'(A,ES8.1)')
     &    ' Convergence criterion on step/parameter<=:',ThrGrd
      Write (Lu,'(A,ES8.1)')
     &    ' Convergence criterion on energy change <=:',ThrEne
      Write (Lu,'(A)')
     &    ' Parameters for step-restricted optimization'
      If (.NOT.Kriging) Then
      Write (Lu,'(A,ES9.2)')
     &    ' Max step length (initial seed):          ',Beta
      Else
      Write (Lu,'(A,ES9.2)')
     &    ' Max step length (micro iterations):      ',Beta
      End If
      Write (Lu,*)
*                                                                      *
************************************************************************
*                                                                      *
      If (Kriging) Then
       Write (Lu,*) '-RVO activated with parameters:'
!      Write (Lu,'(A,I6)')
!    &    '   GEK starts at iteration:                   ',nspAI
       Write (Lu,'(A,I6)')
     &    '   Maximum number of data points used in GEK: ',nWndw/2
!      Write (Lu,'(A,I6)')
!   &     '   Parameter of diff. for Matern (p):         ',pAI
       Write (Lu,'(A,I6)')
     &    '   Maximum number of micro iterations:        ',
     &                                               Max_Microiterations
       If (set_l) Then
          Call Get_dScalar('Value_l',Value_l)
          Write (Lu,*) '  Global characteristic length scale, l:     ',
     &              Value_l
       Else
          Write (Lu,*) '  Individual characteristic length scales set '
     &          //'to reproduce HMF Hessian.'
       End If
*
       If (blaAI) then
          write (6,'(A,F10.5,A)')
     &          '   Baseline is highest energy plus: ',blavAI,' a.u'
       Else
          if (mblAI) then
             write (6,*) '  Baseline set to maximum value of the energy'
          else if (blAI) then
             write (6,'(A,F9.5,A,/,A,F9.5,A)')
     &              '  Baseline (trend function) changed to value:',
     &              blvAI, 'a.u.',
     &              '                                             ',
     &              blvAI * CONV_AU_TO_KJ_PER_MOLE_,
     &              ' kJ/mol'
          endif
       Endif
       write (6,'(A,F10.5,A)')
     &       '   Maximum dispersion accepted:     ',Beta_disp,
     &       ' * abs(g.max.comp)'
      Else
       Write (Lu,*) '-RFO activated with parameters:'
       Write (Lu,'(A,I6)')
     &    '   Maximum number of data points used in RFO: ',nWndw
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (Line_Search) Then
         Write (Lu,'(A)') ' Line search is performed'
         Write (Lu,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iAnd(iOptC,256).eq.256) Then
*
         Write (Lu,'(1X,A)') '-Constrained optimization.'
*
         If (MEP) Then
            If (IRC.eq.0) Then
               Write (Lu,'(1X,A)') ' Minimum Energy Path (MEP) search'
               Write (Lu,'(1X,A,I5)') ' Max number of points:',nMEP
            Else If (IRC.eq.1) Then
               Write (Lu,'(1X,A)') ' IRC forward search'
               Write (Lu,'(1X,A,I5)') ' Max number of points:',nMEP
            Else
               Write (Lu,'(1X,A)') ' IRC backward search'
               Write (Lu,'(1X,A,I5)') ' Max number of points:',nMEP
            End If
            If (eMEPtest)
     &         Write (Lu,'(1X,A)') ' Stop when energy increases'
            If (MEP_Algo.eq.'GS') Then
               Write (Lu,'(1X,A)') ' MEP optimization algorithm:'
     &                           //' Gonzalez-Schlegel'
            Else If (MEP_Algo.eq.'MB') Then
               Write (Lu,'(1X,A)') ' MEP optimization algorithm:'
     &                           //' Mueller-Brown'
            End If
            If (MEP_Type.eq.'SPHERE    ') Then
               Write (Lu,'(1X,A)') ' Type of constraint: Hypersphere'
            Else If (MEP_Type.eq.'TRANSVERSE') Then
               Write (Lu,'(1X,A)') ' Type of constraint: Hyperplane'
            End If
         End If
*
         If (rMEP) Then
            Write (Lu,'(1X,A)') ' Reverse Minimum Energy Path '
     &                        //'(rMEP) search'
            Write (Lu,'(1X,A,I3)') ' Max number of points:',nMEP
            If (eMEPtest)
     &         Write (Lu,'(1X,A)') ' Stop when energy decreases'
            If (MEP_Type.eq.'SPHERE    ') Then
               Write (Lu,'(1X,A)') ' Type of constraint: Hypersphere'
            Else If (MEP_Type.eq.'TRANSVERSE') Then
               Write (Lu,'(1X,A)') ' Type of constraint: Hyperplane'
            End If
         End If
*
         If (FindTS) Then
            Write (Lu,'(1X,A)')
     &       '-The optimization will home in on a transition state if:'
            Write (Lu,'(A)')
     &       '  a) Negative curvature is encountered, and'
            Write (Lu,'(A,F10.4)')
     &       '  b) the norm of the gradient is below:',GNrm_Threshold
            If (iAnd(iOptC,512).eq.512) Then
               Write (Lu,'(A)') '  TS-search by RS-I-RFO.'
               !If (Kriging) Then
               !   Write (Lu,'(A)') '  TS-search by RV-I-RFO.'
               !Else
               !   Write (Lu,'(A)') '  TS-search by RS-I-RFO.'
               !End If
            Else
               Write (Lu,'(A)') '  TS-search by RS-P-RFO.'
               !If (Kriging) Then
               !   Write (Lu,'(A)') '  TS-search by RV-P-RFO.'
               !Else
               !   Write (Lu,'(A)') '  TS-search by RS-P-RFO.'
               !End If
            End If
         End If
*
      End If
      Write (Lu,*)
*
      If (iAnd(iOptC,128).eq.128) Then
         Write (Lu,'(1X,A)') '-Optimization for minimum.'
         If (iAnd(iOptC,1).eq.1) Then
            Write (Lu,'(A)') '  Optimization method: quasi-NR.'
         Else If (iAnd(iOptC,2).eq.2) Then
            Write (Lu,'(A)') '  Optimization method: C1-DIIS.'
         Else If (iAnd(iOptC,4).eq.4) Then
            Write (Lu,'(A)') '  Optimization method: C2-DIIS.'

         Else If (iAnd(iOptC,8).eq.8) Then
            If (Kriging) Then
               Write (Lu,'(A)') '  Optimization method: RVO.'
            Else
               Write (Lu,'(A)') '  Optimization method: RS-RFO.'
            End If
         Else
            Call WarningMessage(2,' WrInp: Wrong iOptC setting!')
            Write (Lu,*) ' iOptC=',iOptC
            Call Abend()
         End If
      Else
         Write (Lu,'(1X,A)') '-Optimization for transition state.'
         If (iAnd(iOptC,512).eq.512) Then
            Write (Lu,'(A)') '  Optimization method: RS-I-RFO'
            !If (Kriging) Then
            !   Write (Lu,'(A)') '  Optimization method: RV-I-RFO'
            !Else
            !   Write (Lu,'(A)') '  Optimization method: RS-I-RFO'
            !End If
         Else
            Write (Lu,'(A)') '  Optimization method: RS-P-RFO'
            !If (Kriging) Then
            !   Write (Lu,'(A)') '  Optimization method: RV-P-RFO'
            !Else
            !   Write (Lu,'(A)') '  Optimization method: RS-P-RFO'
            !End If
         End If
         If (Mode.gt.0) Then
            Write (Lu,'(A,I2)') '  Original mode to follow:',Mode
         Else
            Write (Lu,'(A)') '  No mode to follow is specified!'
            Write (Lu,'(A)') '  Optimization will follow mode with'
     &                     //' the lowest eigenvalue.'
         End If
      End If
      Write (Lu,*)
*                                                                      *
************************************************************************
*                                                                      *
*.....Special options on DIIS
*
      If (iAnd(iOptC,2).eq.2.or.iAnd(iOptC,4).eq.4) Then
         If (iAnd(iOptC,16).eq.16) Then
            Write (Lu,'(1X,A)') '-DIIS based on <dx|dx>.'
         Else If (iAnd(iOptC,32).eq.32) Then
            Write (Lu,'(1X,A)') '-DIIS based on <g|dx>.'
         Else If (iAnd(iOptC,64).eq.64) Then
            Write (Lu,'(1X,A)') '-DIIS based on <g|g>.'
         Else
            Call WarningMessage(2,' WrInp: Wrong iOptC setting!')
            Write (Lu,*) ' iOptC=',iOptC
            Call Abend()
         End If
         Write (Lu,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*.....Hessian information
*
      If (Analytic_Hessian) Then
         Write (Lu,'(1X,A)') '-The Hessian is analytic.'
         Write (Lu,'(1X,A)') ' Hessian from either input or runfile.'
      Else
         If (.Not.lOld.and..Not.lNmHss) Then
            If (DDV_Schlegel) Then
              Write (Lu,'(1X,A)') '-Initial Hessian guessed a'
     &                //' la Schlegel.'
            Else
              If (Kriging) Then
                 Write (Lu,'(1X,A)') '-Hessian guessed by'
     &                   //' Kriging surrogate surface.'
              Else
                 Write (Lu,'(1X,A)') '-Initial Hessian guessed by'
     &                   //' Hessian Model Function (HMF).'
                 If (iAnd(iOptC,1024).eq.1024) Then
                   Write (Lu,'(A)') '  HMF augmented with'
     &                   //' weak interactions.'
                 End If
              End If
            End If
         Else If (lOld.and..Not.lNmHss) Then
            Write (Lu,'(1X,A)')
     &       '-Initial Hessian guess was read from a RUNFILE file.'
         Else
            Write (Lu,'(1X,A,/,A,E9.2)')
     &         '-Initial Hessian guess is estimated with finite'
     &       //' differences.',
     &         '    Two point symmetric formula, Delta=',Delta
            If (Cubic) Then
               Write (Lu,'(1X,A)')
     &          '-Cubic force constants evaluated numerically.'
            End If
         End If
      End If
      Write (Lu,*)
*                                                                      *
************************************************************************
*                                                                      *
*.....Hessian update method
*
      If (.NOT.Kriging) Then
      If (iAnd(iOptH,1).eq.1) Then
         Write (Lu,'(1X,A)')
     &       '-Hessian update method: Fletcher-Meyer'
      Else If (iAnd(iOptH,2).eq.2) Then
         Write (Lu,'(1X,A)')
     &       '-Hessian update method: Broyden-Powell'
      Else If (iAnd(iOptH,4).eq.4) Then
         Write (Lu,'(1X,A)')
     &       '-Hessian update method: Broyden-Fletcher-Goldfarb-Shanno'
      Else If (iAnd(iOptH,8).eq.8) Then
         Write (Lu,'(1X,A)') '-Hessian update method: none'
      Else If (iAnd(iOptH,16).eq.16) Then
         Write (Lu,'(1X,A)')
     &       '-Hessian update method: Murtagh-Sargent-Powell'
      Else If (iAnd(iOptH,64).eq.64) Then
         Write (Lu,'(1X,A)')
     &       '-Hessian update method: EU update by Bofill'
      Else If (iAnd(iOptH,128).eq.128) Then
         Write (Lu,'(1X,A)')
     &       '-Hessian update method: TS-BFGS update by Bofill'
      Else
         Call WarningMessage(2,' WrInp: Wrong iOptH setting!')
         Write (Lu,*) ' Nonrecognizable iOptH setting:',iOptH
         Call Abend()
      End If
      If (.Not.(iAnd(iOptH,8).eq.8)) Then
         Write (Lu,'(A,I3)')
     &         '  Max number of points in Hessian update:',
     &                        nWndw
      End If
      If (iAnd(iOptH,32).eq.32) Then
         Write (Lu,'(A)')
     &       '  Hessian update order according to Schlegel'
      End If
      Write (Lu,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (rHidden.ge.Two) Then
         Write(Lu,'(1X,A,/,1X,A,F6.2,A)')
     &    '-Improved QM/MM Hessian.',
     &    ' Hidden atoms until ',rHidden,' bohrs are included.'
         Write (Lu,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iRow.gt.0) Then
         If (Redundant) Then
            Write (Lu,'(1X,A)') '-Relaxation will be done in user'
     &             //' supplied redundant internal coordinates.'
         Else
            Write (Lu,'(1X,A)') '-Relaxation will be done in user'
     &             //' supplied non-redundant internal coordinates.'
         End If
      Else
         If (CurviLinear) Then
            If (HWRS) Then
               If (Redundant) Then
                  Write (Lu,'(1X,A)') '-Relaxation will be done on'
     &                   //' redundant internal coordinates,'
     &                   //' based on'
                  Write (Lu,*) ' force constant weighted redundant'
     &                   //' internal coordinates.'
               Else
                  Write (Lu,'(1X,A)') '-Relaxation will be done on'
     &                   //' non-redundant internal coordinates,'
     &                   //' based on'
                  Write (Lu,*) ' force constant weighted redundant'
     &                   //' internal coordinates.'
               End If
            Else
               If (Redundant) Then
                  Write (Lu,'(1X,A)')
     &               '-Relaxation will be done in redundant'
     &                   //' delocalized internal coordinates.'
               Else
                  Write (Lu,'(1X,A)')
     &               '-Relaxation will be done in non-redundant'
     &                   //' delocalized internal coordinates.'
               End If
            End If
         Else
            If (Redundant) Then
               Write (Lu,'(1X,A)')
     &            '-Relaxation will be done in redundant'
     &                //' Cartesian coordinates.'
            Else
               Write (Lu,'(1X,A)')
     &            '-Relaxation will be done in approximate'
     &                //' non-redundant'
     &                //' Cartesian normal mode coordinates.'
            End If
         End If
      End If
      Write (Lu,*)
*                                                                      *
************************************************************************
*                                                                      *
      If (Ref_Geom) Then
         Write (Lu,'(1X,A)')
     &         '-The origin of the hyper sphere is defined implicitly.'
      End If
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.6) Then
         Write (Lu,*)
         Write (Lu,'(A)') ' Header from ONEINT:'
         Call Banner(Header,2,Len(Header(1))+12)
         Write (Lu,*)
         Call PrList('Symmetry Distinct Nuclear Coordinates / bohr',
     &                AtomLbl,nsAtom,Work(ipCoor),3,nsAtom)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.5)
     &   Call CollapseOutput(0,'      Slapaf input parameters:')
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine ABCD_CPF(JSY,INDX,ISAB,C,S,ACBDS,ACBDT,BUFIN)

use cpf_global, only: IPASS, IRC, IROW, JJS, KBUFF1, LN, LSYM, Lu_TiABCD, NDIAG, NSM, NSYM, NSYS, NVIRT, SQ2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JSY(*), INDX(*), ISAB(*)
real(kind=wp), intent(inout) :: C(*), S(*)
real(kind=wp), intent(_OUT_) :: ACBDS(*), ACBDT(*), BUFIN(*)
integer(kind=iwp) :: IAC, IACMAX, IACMIN, IAD16, IFIN1, IFIN2, ILOOP, IN1, INB, INDA, INPS, INPT, INS, INSB, INSIN, INUM, INUMB, &
                     ISAC, IST, IST1, IST2, ISTEP, ISYM, ITAIL, NA, NC, NDMAX, NOV, NSAC, NSACL, NVT
real(kind=wp) :: TERM
real(kind=r8), external :: DDOT_

IAD16 = 0
INSIN = KBUFF1
INUM = IRC(4)-IRC(3)
call PSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)
NVT = IROW(NVIRT+1)
NOV = (NVT-1)/IPASS+1
IACMAX = 0
do ISTEP=1,IPASS
  IACMIN = IACMAX+1
  IACMAX = IACMAX+NOV
  if (IACMAX > NVT) IACMAX = NVT
  if (IACMIN > IACMAX) cycle
  do ISYM=1,NSYM
    IST1 = IRC(3)+JJS(ISYM+9)+1
    IFIN1 = IRC(3)+JJS(ISYM+10)
    INPS = IFIN1-IST1+1
    IST2 = IRC(2)+JJS(ISYM)+1
    IFIN2 = IRC(2)+JJS(ISYM+1)
    INPT = IFIN2-IST2+1
    ITAIL = INPS+INPT
    if (ITAIL == 0) cycle
    IN1 = -NVIRT
    do NA=1,NVIRT
      IN1 = IN1+NVIRT
      do NC=1,NA
        IAC = IROW(NA)+NC
        if (IAC < IACMIN) cycle
        if (IAC > IACMAX) cycle
        if (NA == 1) cycle
        NSAC = MUL(NSM(LN+NA),NSM(LN+NC))
        NSACL = MUL(NSAC,LSYM)
        if (NSACL /= ISYM) cycle
        ISAC = ISAB(IN1+NC)
        NDMAX = NSYS(NSM(LN+NC)+1)
        if (NDMAX > NA) NDMAX = NA
        INS = ISAB(IN1+NDMAX)
        ILOOP = 0
        do
          INSB = INS
          do
            if (INSIN >= KBUFF1) then
              call dDAFILE(Lu_TiABCD,2,BUFIN,KBUFF1,IAD16)
              INSIN = 0
            end if
            INB = KBUFF1-INSIN
            INUMB = INSB
            if (INSB > INB) INUMB = INB
            IST = INS-INSB+1
            if (ILOOP == 0) call DCOPY_(INUMB,BUFIN(INSIN+1),1,ACBDS(IST),1)
            if (ILOOP == 1) call DCOPY_(INUMB,BUFIN(INSIN+1),1,ACBDT(IST),1)
            INSIN = INSIN+INUMB
            INSB = INSB-INUMB
            if (INSB <= 0) exit
          end do
          ILOOP = ILOOP+1
          if (ILOOP /= 1) exit
        end do
        if (INPS /= 0) then
          do INDA=IST1,IFIN1
            TERM = DDOT_(INS,C(INDX(INDA)+1),1,ACBDS,1)
            S(INDX(INDA)+ISAC) = S(INDX(INDA)+ISAC)+TERM
            S(INDX(INDA)+1:INDX(INDA)+INS) = S(INDX(INDA)+1:INDX(INDA)+INS)+C(INDX(INDA)+ISAC)*ACBDS(1:INS)
          end do
        end if
        if ((INPT == 0) .or. (NA == NC)) cycle
        do INDA=IST2,IFIN2
          TERM = DDOT_(INS,C(INDX(INDA)+1),1,ACBDT,1)
          S(INDX(INDA)+ISAC) = S(INDX(INDA)+ISAC)+TERM
          S(INDX(INDA)+1:INDX(INDA)+INS) = S(INDX(INDA)+1:INDX(INDA)+INS)+C(INDX(INDA)+ISAC)*ACBDT(1:INS)
        end do
      end do
    end do
  end do
end do
call DSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)

return

end subroutine ABCD_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRSCTAB(SCTAB,TRANS)
      use definitions, only: iwp, wp, u6
      IMPLICIT NONE
      INTEGER(kind=iwp), intent(in):: SCTAB(*)
      REAL(kind=wp), intent(in):: TRANS(*)

      INTEGER(kind=iwp) NSIZE,ITYPE,MLTPL,MS2,MINOP,MAXOP,LTRANS,NTRANS,
     &                  N,IOPEN,NCP,NBLK,IBLK,NCPL,ND,KSPCPL,KSPDET
      INTEGER(kind=iwp), External:: ngene

      WRITE(u6,*)
      WRITE(u6,*)'------------------------------------------'
      WRITE(u6,*)' Spin Coupling Table printout'
      WRITE(u6,*)'------------------------------------------'
      NSIZE=SCTAB(1)
      ITYPE=SCTAB(2)
      MLTPL=SCTAB(3)
      MS2  =SCTAB(4)
      MINOP=SCTAB(5)
      MAXOP=SCTAB(6)
      LTRANS=SCTAB(7)
      NTRANS=SCTAB(8)
      WRITE(u6,'(1x,A,I16)')' Table size       :',NSIZE
      WRITE(u6,'(1x,A,I16)')' Table type ID    :',ITYPE
      WRITE(u6,'(1x,A,I16)')' Spin multiplicity:',MLTPL
      WRITE(u6,'(1x,A,I16)')' Spin projection  :',MS2
      WRITE(u6,'(1x,A,I16)')' Open shells; min :',MINOP
      WRITE(u6,'(1x,A,I16)')' Open shells; max :',MAXOP
      WRITE(u6,'(1x,A,I16)')' Transf data; addr:',LTRANS
      WRITE(u6,'(1x,A,I16)')' Transf data; wrds:',NTRANS
C Number of (non-trivial) values of IOPEN:
      N=0
      DO IOPEN=MINOP,MAXOP
        NCP=NGENE(IOPEN,MLTPL)
        IF(NCP.GT.0) N=N+1
      END DO
      IF(N.EQ.0) THEN
        WRITE(u6,*)
        WRITE(u6,*)' There is no such spin-coupling scheme.'
        WRITE(u6,*)
      ELSE
       WRITE(u6,'(1x,A,I9)')'   Nr of schemes  :',N
       NBLK=MAXOP-MINOP+1
       DO IBLK=1,NBLK
        IOPEN=SCTAB(9+(IBLK-1)*6)
        NCPL=SCTAB(10+(IBLK-1)*6)
        IF(NCPL.NE.0) THEN
         ND=SCTAB(11+(IBLK-1)*6)
         KSPCPL=SCTAB(12+(IBLK-1)*6)
         KSPDET=SCTAB(13+(IBLK-1)*6)
         LTRANS=SCTAB(14+(IBLK-1)*6)
         WRITE(u6,*)'------------------------------------------'
         WRITE(u6,'(1x,A,I16)')' Nr of open shells  :',IOPEN
         WRITE(u6,'(1x,A,I16)')' Nr of proto-CSF    :',NCPL
         WRITE(u6,'(1x,A,I16)')' Nr of proto-SD     :',ND
         WRITE(u6,'(1x,A,I16)')' Addr of proto-CSF  :',KSPCPL
         WRITE(u6,'(1x,A,I16)')' Addr of proto-SD   :',KSPDET
         WRITE(u6,'(1x,A,I16)')' Addr of transf matr:',LTRANS
         WRITE(u6,*)' proto-CSF''s:'
         CALL PRPCSF(IOPEN,NCPL,SCTAB(KSPCPL))
         WRITE(u6,*)' proto-SD''s:'
         CALL PRPDET(IOPEN,ND,SCTAB(KSPDET))
         WRITE(u6,*)' Transformation matrix:'
         CALL PRPTRA(ND,NCPL,TRANS)
        END IF
       END DO
      END IF
      WRITE(u6,*)'------------------------------------------'
      END SUBROUTINE PRSCTAB

      SUBROUTINE PRPCSF(IOPEN,NCPL,ICOUP)
      use definitions, only: iwp, u6
      IMPLICIT NONE
      Integer(kind=iwp), intent(in):: IOPEN, NCPL
      Integer(kind=iwp), intent(in):: ICOUP(IOPEN,NCPL)

      CHARACTER(LEN=1) :: CPLSMB(0:1)=['d','u']
      CHARACTER(LEN=24) FORM
      Integer(kind=iwp) N,I,J
      IF(IOPEN.LT.0 .OR.NCPL.LT.0) THEN
        Call WarningMessage(2,'Program bug: Erroneous call to PRPCSF.')
        WRITE(u6,*)'PRPCSF error: Wrong arguments.'
        WRITE(u6,*)'PRPCSF: IOPEN=',IOPEN
        WRITE(u6,*)'PRPCSF: NCPL =',NCPL
        CALL ABEND()
      END IF
      IF(IOPEN.EQ.0 .OR.NCPL.EQ.0) THEN
        Call WarningMessage(1,'Program bug? Strange call to PRPCSF.')
        WRITE(u6,*)'PRPCSF warning: Strange arguments.'
        WRITE(u6,*)'PRPCSF: IOPEN=',IOPEN
        WRITE(u6,*)'PRPCSF: NCPL =',NCPL
      ELSE
       N=80/(7+IOPEN)
       WRITE(FORM,'(A1,I2,A,I2,A4)') '(',N,'(1X,I5,1X,',IOPEN,'A1))'
       WRITE(u6,FORM)(I,(CPLSMB(ICOUP(J,I)),J=1,IOPEN),I=1,NCPL)
      END IF
      END SUBROUTINE PRPCSF

      SUBROUTINE PRPTRA(ND,NCPL,TRA)
      use definitions, only: iwp, wp, u6
      IMPLICIT NONE
      integer(kind=iwp), intent(in):: ND, NCPL
      Real(kind=wp), intent(in):: TRA(ND,NCPL)

      integer(kind=iwp) ISTA,IEND,ID,ICPL
      IF(ND.LT.0 .OR.NCPL.LT.0) THEN
        Call WarningMessage(2,'Program bug: Erroneous call to PRPTRA.')
        WRITE(u6,*)'PRPTRA error: Wrong arguments.'
        WRITE(u6,*)'PRPTRA: ND,NCPPL=',ND,NCPL
        CALL ABEND()
      END IF
      IF(ND.EQ.0 .OR.NCPL.EQ.0) THEN
        Call WarningMessage(1,'Program bug? Strange call to PRPCSF.')
        WRITE(u6,*)'PRPTRA warning: Strange arguments.'
        WRITE(u6,*)'PRPTRA: ND,NCPPL=',ND,NCPL
      ELSE
        DO ISTA=1,NCPL,5
         IEND=MIN(NCPL,ISTA+4)
         WRITE(u6,*)
         WRITE(u6,'(8x,5(I8,8X))')(ICPL,ICPL=ISTA,IEND)
         DO ID=1,ND
           WRITE(6,'(1x,5F16.8)')(TRA(ID,ICPL),ICPL=ISTA,IEND)
         END DO
        END DO
      END IF
      END SUBROUTINE PRPTRA

      SUBROUTINE PRPDET(IOPEN,ND,IDET)
      use definitions, only: iwp, u6
      IMPLICIT NONE
      integer(kind=iwp), intent(in):: IOPEN,ND
      Integer(kind=iwp), intent(in):: IDET(IOPEN,ND)

      CHARACTER(LEN=1) :: SPNSMB(0:1)=['b','a']
      CHARACTER(LEN=24) FORM
      Integer(kind=iwp) N,I,J
      IF(IOPEN.LT.0 .OR.ND.LT.0) THEN
        Call WarningMessage(2,'Program bug: Erroneous call to PRPDET.')
        WRITE(u6,*)'PRPDET error: Wrong arguments.'
        WRITE(u6,*)'PRPDET: IOPEN=',IOPEN
        WRITE(u6,*)'PRPDET: ND =',ND
        CALL ABEND()
      END IF
      IF(IOPEN.EQ.0 .OR.ND.EQ.0) THEN
        Call WarningMessage(1,'Program bug? Strange call to PRPDET.')
        WRITE(u6,*)'PRPDET warning: Strange arguments.'
        WRITE(u6,*)'PRPDET: IOPEN=',IOPEN
        WRITE(u6,*)'PRPDET: ND =',ND
      ELSE
       N=80/(7+IOPEN)
       WRITE(FORM,'(A1,I2,A,I2,A4)') '(',N,'(1X,I5,1X,',IOPEN,'A1))'
       WRITE(u6,FORM)(I,(SPNSMB(IDET(J,I)),J=1,IOPEN),I=1,ND)
      END IF
      END SUBROUTINE PRPDET

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Molcas_Order(GOut,na,nb)
      Implicit Real*8 (a-h,o-z)
      Real*8 GOut(na*nb,2)
*                                                                      *
************************************************************************
*                                                                      *
C     Call RecPrt('Gout(Argos)',' ',Gout,nb,na)
      call dcopy_(na*nb,GOut(1,1),1,GOut(1,2),1)
*
      Do ia = 1, na
         Do ib = 1, nb
            iba=(ia-1)*nb+ib
            iab=(ib-1)*na+ia
            GOut(iab,1)=GOut(iba,2)
         End Do
      End Do
C     Call RecPrt('Gout(Molcas)',' ',Gout,na,nb)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        program main
#ifdef _FPE_TRAP_
        Use, Intrinsic :: IEEE_Exceptions
#endif
        implicit real*8 (a-h,o-z)
#ifdef _FPE_TRAP_
        Call IEEE_Set_Halting_Mode(IEEE_Usual,.True._4)
#endif

        Call Start('cht3')
        Call cht3(ireturn)
        Call Finish(ireturn)
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MAXABSDIAG(DIAG,IRED,DGMAX)
!
! Purpose: set max. abs. DIAG (reduced set IRED) in each symmetry, and
!          return the global max. abs. in DGMAX.

use Cholesky, only: Cho_1Center, DiaMax, DiaMaxT, iiBstR, IndRed, LuPri, nnBstR, nSym
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*)
integer(kind=iwp), intent(in) :: IRED
real(kind=wp), intent(out) :: DGMax
integer(kind=iwp) :: AB, AB1, AB2, IAB, ISYM
character(len=*), parameter :: SECNAM = 'CHO_MAXABSDIAG'

if (CHO_1CENTER) then ! specialization for 1-center approximation
  call CHO_MAXABSDIAG_1C(DIAG,IRED,DGMAX)
  return
end if

if (IRED == 1) then
  do ISYM=1,NSYM
    if (NNBSTR(ISYM,IRED) < 1) then
      DIAMAX(ISYM) = Zero
    else
      DIAMAX(ISYM) = abs(DIAG(IIBSTR(ISYM,IRED)+1))
      AB1 = IIBSTR(ISYM,IRED)+2
      AB2 = IIBSTR(ISYM,IRED)+NNBSTR(ISYM,IRED)
      do AB=AB1,AB2
        DIAMAX(ISYM) = max(DIAMAX(ISYM),abs(DIAG(AB)))
      end do
    end if
    DIAMAXT(ISYM) = DIAMAX(ISYM)
  end do
else if ((IRED == 2) .or. (IRED == 3)) then
  do ISYM=1,NSYM
    if (NNBSTR(ISYM,IRED) < 1) then
      DIAMAX(ISYM) = Zero
    else
      AB = INDRED(IIBSTR(ISYM,IRED)+1,IRED)
      DIAMAX(ISYM) = abs(DIAG(AB))
      AB1 = IIBSTR(ISYM,IRED)+2
      AB2 = IIBSTR(ISYM,IRED)+NNBSTR(ISYM,IRED)
      do IAB=AB1,AB2
        AB = INDRED(IAB,IRED)
        DIAMAX(ISYM) = max(DIAMAX(ISYM),abs(DIAG(AB)))
      end do
    end if
    if (NNBSTR(ISYM,1) < 1) then
      DIAMAXT(ISYM) = Zero
    else
      DIAMAXT(ISYM) = abs(DIAG(IIBSTR(ISYM,1)+1))
      AB1 = IIBSTR(ISYM,1)+2
      AB2 = IIBSTR(ISYM,1)+NNBSTR(ISYM,1)
      do AB=AB1,AB2
        DIAMAXT(ISYM) = max(DIAMAXT(ISYM),abs(DIAG(AB)))
      end do
    end if
  end do
else
  write(LUPRI,*) SECNAM,': unknown reduced set, IRED = ',IRED
  call CHO_QUIT('Unknown reduced set in '//SECNAM,104)
end if

DGMAX = DIAMAX(1)
do ISYM=2,NSYM
  DGMAX = max(DGMAX,DIAMAX(ISYM))
end do

#ifdef _DEBUGPRINT_
write(LUPRI,*) SECNAM,': in reduced set ',IRED,':'
write(LUPRI,*) 'DIAMAX  = ',(DIAMAX(ISYM),ISYM=1,NSYM)
write(LUPRI,*) 'DIAMAXT = ',(DIAMAXT(ISYM),ISYM=1,NSYM)
write(LUPRI,*) 'DGMAX   = ',DGMAX
#endif

end subroutine CHO_MAXABSDIAG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DENSCT(AREF)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
#include "WrkSpc.fh"
      DIMENSION AREF(*)
      DIMENSION IDC(MXROOT)
*
      IDREST=0
      IDDMO=0
      CALL GETMEM('CI','ALLO','REAL',LCI,NCONF)
      CALL GETMEM('SGM','ALLO','REAL',LSGM,NCONF)
      CALL GETMEM('ASCR2','ALLO','REAL',LASCR2,NVMAX**2)
      CALL GETMEM('BSCR2','ALLO','REAL',LBSCR2,NVMAX**2)
      CALL GETMEM('FSCR2','ALLO','REAL',LFSCR2,NVSQ)
      DO 10 I=1,NRROOT
        IDC(I)=IDREST
        CALL dDAFILE(LUREST,2,Work(LCI),NCONF,IDREST)
        CALL FZERO(Work(LDMO),NBTRI)
*PAM04        IF(ICPF.NE.0) CALL DCORR(HWork(LJREFX),HWork(LAREF),
*PAM04     *                                 HWork(LCSPCK),
*PAM04     *                           HWork(LINTSY),HWork(LINDX),
*PAM04     *                           HWork(LDMO))
        IF(ICPF.NE.0) CALL DCORR(IWork(LJREFX),AREF,
     *                                 IWork(LCSPCK),
     *                           IWork(LINTSY),IWork(LINDX),
     *                           Work(LDMO))
*PAM04        CALL FIJD (HWork(LINTSY),HWork(LINDX),HWork(LCI),
*PAM04     *             HWork(LDMO),HWork(LJREFX),HWork(LAREF))
        CALL FIJD (IWork(LINTSY),IWork(LINDX),Work(LCI),
     *             Work(LDMO),IWork(LJREFX),AREF)
*PAM04        CALL AID *(HWork(LINTSY),HWork(LINDX),HWork(LCI),HWork(LDMO),
        CALL AID (IWork(LINTSY),IWork(LINDX),Work(LCI),Work(LDMO),
     *            Work(LASCR2),Work(LBSCR2),Work(LFSCR2))
*PAM04        CALL ABD (HWork(LCSPCK),HWork(LINTSY),HWork(LINDX),
        CALL ABD (IWork(LCSPCK),IWork(LINTSY),IWork(LINDX),
*PAM04     *                  HWork(LCI),HWork(LDMO),
     *                  Work(LCI),Work(LDMO),
     *            Work(LASCR2),Work(LBSCR2),Work(LFSCR2),
*PAM04     *            HWork(LJREFX))
     *            IWork(LJREFX))
*PAM04        CALL dDAFILE(LUEIG,1,HWork(LDMO),NBTRI,IDDMO)
        CALL dDAFILE(LUEIG,1,Work(LDMO),NBTRI,IDDMO)
10    CONTINUE
      IF(ITRANS.EQ.0) GOTO 100
      DO 20 I=2,NRROOT
        IDREST=IDC(I)
        CALL dDAFILE(LUREST,2,Work(LCI),NCONF,IDREST)
        DO 21 J=1,I-1
          IDREST=IDC(J)
          CALL dDAFILE(LUREST,2,Work(LSGM),NCONF,IDREST)
*PAM04          CALL FZERO(HWork(LTDMO),NBAST**2)
          CALL FZERO(Work(LTDMO),NBAST**2)
*PAM04          CALL FIJTD (HWork(LINTSY),HWork(LINDX),HWork(LCI),
*PAM04     *                HWork(LSGM),HWork(LTDMO))
          CALL FIJTD (IWork(LINTSY),IWork(LINDX),Work(LCI),
     *                Work(LSGM),Work(LTDMO))
*PAM04          CALL AITD (HWork(LINTSY),HWork(LINDX),HWork(LCI),
          CALL AITD (IWork(LINTSY),IWork(LINDX),Work(LCI),
     *                Work(LSGM),
*PAM04     *               HWork(LTDMO),HWork(LASCR2),HWork(LBSCR2),
     *               Work(LTDMO),Work(LASCR2),Work(LBSCR2),
     *               Work(LFSCR2))
*PAM04          CALL ABTD (HWork(LCSPCK),HWork(LINTSY),HWork(LINDX),
          CALL ABTD (IWork(LCSPCK),IWork(LINTSY),IWork(LINDX),
     *                     Work(LCI),Work(LSGM),
*PAM04     *               HWork(LTDMO),HWork(LASCR2),HWork(LBSCR2),
     *               Work(LTDMO),Work(LASCR2),Work(LBSCR2),
     *               Work(LFSCR2))
*PAM04        CALL dDAFILE(LUEIG,1,HWork(LTDMO),NBAST**2,IDDMO)
          CALL dDAFILE(LUEIG,1,Work(LTDMO),NBAST**2,IDDMO)
21      CONTINUE
20    CONTINUE
100   CONTINUE
      CALL GETMEM('CI','FREE','REAL',LCI,NCONF)
      CALL GETMEM('SGM','FREE','REAL',LSGM,NCONF)
      CALL GETMEM('ASCR2','FREE','REAL',LASCR2,NVMAX**2)
      CALL GETMEM('BSCR2','FREE','REAL',LBSCR2,NVMAX**2)
      CALL GETMEM('FSCR2','FREE','REAL',LFSCR2,NVSQ)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! p-p (sigma), with too small exponent difference.
function CoulT0_4(Rho,dSepInv,Expo)

use Constants, only: One, Two, Ten
use Definitions, only: wp

implicit none
real(kind=wp) :: CoulT0_4
real(kind=wp), intent(in) :: Rho, dSepInv, Expo
real(kind=wp) :: T1, T2, T3, T4, T5, T6, T7, T8

T1 = One
T2 = Two*Rho
T3 = Two*Rho**2
T4 = (263.0_wp/192.0_wp)*Rho**3
T5 = (71.0_wp/96.0_wp)*Rho**4
T6 = (77.0_wp/240.0_wp)*Rho**5
T7 = (One/Ten)*Rho**6
T8 = (One/60.0_wp)*Rho**7
CoulT0_4 = Two*dSepInv**3*(One-(T1+T2+T3+T4+T5+T6+T7+T8)*Expo)

return

end function CoulT0_4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine put array character data to the runfile.                *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: August 2003                                                 *
*                                                                      *
************************************************************************
*  Put_cArray
*
*> @brief
*>   Add/update array data in runfile
*> @author Per-Olof Widmark
*>
*> @details
*> This routine is used to put array data of type
*> ``Character`` into the runfile. The data items are
*> identified by the \p label. Below is a list of the
*> data items that are recognized. The labels are
*> case insensitive and significant to 16 characters.
*>
*> For development purposes you can use an unsupported
*> label. Whenever such a field is accessed a warning
*> message is printed in the output, to remind the
*> developer to update this routine.
*>
*> List of known labels:
*>
*> '``DFT functional``'     Name of the functional used for the KS-DFT calculation.
*> '``Irreps``'             Names of the irreducible representations.
*> '``Relax Method``'       Name of the method used for geometry optimizations.
*> '``Seward Title``'       The title of the calculation as specified in module SEWARD.
*> '``Slapaf Info 3``'      Misc. information for module SLAPAF.
*> '``Unique Atom Names``'  List of the names of the symmetry unique atoms.
*> '``Unique Basis Names``' List of the basis function names.
*> '``MkNemo.lMole``'       The labels of molecules as specified in mknemo module.
*> '``MkNemo.lCluster``'    The labels of clusters as specified in mknemo module.
*> '``MkNemo.lEnergy``'     The labels of energies as specified in mknemo module.
*>
*> @param[in] Label Name of field
*> @param[in] Data  Data to put on runfile
*> @param[in] nData Length of array
************************************************************************
      Subroutine Put_cArray(Label,Data,nData)
      Implicit None
#include "pg_ca_info.fh"
*----------------------------------------------------------------------*
* Arguments                                                            *
*----------------------------------------------------------------------*
      Character*(*) Label
      Character*16  myLabel
      Integer       nData
      Character*(*) Data
cvv      Character*(*) Data(nData)
*----------------------------------------------------------------------*
* Define local variables                                               *
*----------------------------------------------------------------------*
      Character*16 RecLab(nTocCA)
      Integer      RecIdx(nTocCA)
      Integer      RecLen(nTocCA)
      Save         RecLab
      Save         RecIdx
      Save         RecLen
*
      Character*16 CmpLab1
      Character*16 CmpLab2
      Integer      nTmp
      Integer      item
      Integer      iTmp
      Integer      i, ilen
*----------------------------------------------------------------------*
* Do setup if this is the first call.                                  *
*----------------------------------------------------------------------*
      myLabel=' '
      ilen=len(Label)
      ilen=min(ilen,16)
      myLabel=Label(1:ilen)
      Call ffRun('cArray labels',nTmp,iTmp)
      If(nTmp.eq.0) Then
         Do i=1,nTocCA
            RecLab(i)=' '
            RecIdx(i)=sNotUsed
            RecLen(i)=0
         End Do
*
*        Observe that label is at most 16 characters!
*
*                     1234567890123456
         RecLab(  1)='DFT functional  '
         RecLab(  2)='Irreps          '
         RecLab(  3)='Relax Method    '
         RecLab(  4)='Seward Title    '
         RecLab(  5)='Slapaf Info 3   '
         RecLab(  6)='Unique Atom Name' !s
         RecLab(  7)='Unique Basis Nam' !es
         RecLab(  8)='LP_L            '
         RecLab(  9)='MkNemo.lMole    '
         RecLab( 10)='MkNemo.lCluster '
         RecLab( 11)='MkNemo.lEnergy  '
         RecLab( 12)='Symbol ZMAT     '
         RecLab( 13)='Tinker Name     '
         RecLab( 14)='ESPF Filename   '
         RecLab( 15)='ChDisp          '
         RecLab( 16)='cmass           '
         RecLab( 17)='BirthCertificate'
         RecLab( 18)='LastEnergyMethod'
         RecLab( 19)='MMO Labels      '
         RecLab( 20)='MCLR Root       '
         RecLab( 21)='Frag_Type       ' ! EFP fragment labels
         RecLab( 22)='ABC             ' ! EFP atom labels
         RecLab( 23)='Un_cen Names    '
         RecLab( 24)='cDmp            '
         RecLab( 25)='dc: cDmp        '
         RecLab( 26)='SymmetryCInfo   '
         RecLab( 27)='SewardXTitle    '
         RecLab( 28)='Align_Weights   '
*                     1234567890123456
         Call cWrRun('cArray labels',RecLab,16*nTocCA)
         Call iWrRun('cArray indices',RecIdx,nTocCA)
         Call iWrRun('cArray lengths',RecLen,nTocCA)
      Else
         Call cRdRun('cArray labels',RecLab,16*nTocCA)
         Call iRdRun('cArray indices',RecIdx,nTocCA)
         Call iRdRun('cArray lengths',RecLen,nTocCA)
      End If
*----------------------------------------------------------------------*
* Locate item                                                          *
*----------------------------------------------------------------------*
      item=-1
      CmpLab1=myLabel
      Call UpCase(CmpLab1)
      Do i=1,nTocCA
         CmpLab2=RecLab(i)
         Call UpCase(CmpLab2)
         If(CmpLab1.eq.CmpLab2) item=i
      End Do
*
* Do we create a new temporary field?
*
      If(item.eq.-1) Then
         Do i=1,nTocCA
            If(RecLab(i).eq.' ') item=i
         End Do
         If(item.ne.-1) Then
            RecLab(item)=myLabel
            RecIdx(item)=sSpecialField
            Call cWrRun('cArray labels',RecLab,16*nTocCA)
            Call iWrRun('cArray indices',RecIdx,nTocCA)
         End If
      End If
*
* Is this a temporary field?
*
      If(item.ne.-1) Then
         If(Recidx(item).eq.sSpecialField) Then
            Write(6,*) '***'
            Write(6,*) '*** Warning, writing temporary cArray field'
            Write(6,*) '***   Field: ',myLabel
            Write(6,*) '***'
#ifndef _DEVEL_
            Call AbEnd()
#endif
         End If
      End If
*----------------------------------------------------------------------*
* Write data to disk.                                                  *
*----------------------------------------------------------------------*
      If(item.eq.-1) Then
         Call SysAbendMsg('put_cArray','Could not locate',myLabel)
      End If
      Call cWrRun(RecLab(item),Data,nData)
      If(RecIdx(item).eq.0) Then
         RecIdx(item)=sRegularField
         Call iWrRun('cArray indices',RecIdx,nTocCA)
      End If
      If(RecLen(item).ne.nData) Then
         RecLen(item)=nData
         Call iWrRun('cArray lengths',RecLen,nTocCA)
      End If
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Giovanni Ghigo                              *
************************************************************************
*  Cho_TraS
*
*> @brief
*>   Routine for the transformation of the Cholesky vectors in MO-based TCVx for case \c Sym(i) = \c Sym(j)
*> @author Giovanni Ghigo
*>
*> @details
*> In the inner batch the Cholesky Full Vectors are transformed and
*> stored in memory. Adresses (``1``) and length (``2``) are stored in the
*> integer matrix <tt>iMemTCVX(iType, Sym(i), Sym(j), 1/2)</tt>.
*>
*> - \c iType = ``1``: TCVA
*> - \c iType = ``2``: TCVB
*> - \c iType = ``3``: TCVC
*> - \c iType = ``4``: TCVD
*> - \c iType = ``5``: TCVE
*> - \c iType = ``6``: TCVF
*> - \c iType = ``7``: TCVG
*>
*> Types ``1``, ``2`` and ``4``--``7`` are generated only if \c DoTCVA = ``.True.``
*> TCVC is always generated.
*>
*> In the first half-transformation the vectors are contracted
*> only with the occupied (inactive and active) MO coefficients
*> for \c Sym(j). In the second half-transformation the vectors are
*> contracted with all MO coefficients.
*>
*> @note
*> The logical matrix \c TCVXist must be defined.
*>
*> @param[in]     iSymL       Symmetry of the Cholesky vector
*> @param[in]     iSym        Symmetry(``i``) of the Cholesky Full Vector
*> @param[in]     jSym        Symmetry(``j``) of the Cholesky Full Vector
*> @param[in]     NumV        Number of Cholesky vectors to transform in the current batch
*> @param[in]     CMO         MO coefficients
*> @param[in]     NCMO        Total number of MO coefficients
*> @param[in]     lUCHFV      Unit number of the Cholesky Full Vector to transform (``CHFV``)
*> @param[in,out] iStrtVec_AB Current initial disk pointer of the Cholesky Full Vector to transform (``CHFV``)
*> @param[in]     nFVec       Number of Cholesky vectors to transform in the inner batch procedure (\p nFBatch)
*> @param[in]     nFBatch     Number of cycles in the inner batch procedure
************************************************************************
      Subroutine Cho_TraS(iSymL, iSym,jSym, NumV, CMO,NCMO,
     &                               lUCHFV, iStrtVec_AB, nFVec,nFBatch)
************************************************************************
*  This is the routine for the transformation from AO basis to MO      *
*  basis of the Cholesky Full Vectors when  iSym.EQ.jSym.              *
*  The new Transformed Cholesky Full Vectors L are :                   *
*                                                                      *
*   TCVA: L_ij  if DoTCVA=.True.                                       *
*   TCVB: L_tj  if DoTCVA=.True.                                       *
*   TCVC: L_aj                                                         *
*   TCVD: L_tu  if DoTCVA=.True.                                       *
*   TCVE: L_au  if DoTCVA=.True.                                       *
*   TCVF: L_ab  if DoTCVA=.True.                                       *
*   TCVG: L_jt  if DoTCVA=.True.                                       *
*  For generation of <pk|ql>  p,q: All MO, k,l: Occupied (i & t)       *
*  MO Indices  i,j: Inactive;   t,u: Active;   a,b: Secondary          *
*                                                                      *
*----------------------------------------------------------------------*
*  Author  :  Giovanni Ghigo                                           *
*             Lund University, Sweden & University di Torino, Italia   *
*  Written :  October 2004                                             *
*  Modified:  July 2005                                                *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)

#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Dimension CMO(NCMO)
      Logical TCVA,TCVB,TCVC,TCVD,TCVE,TCVF

* --- Memory to allocate & Nr. of Cholesky vectors transformable
*     A=Alpha(AO);  B=Beta(AO)

      TCVA = .False.
      TCVB = .False.
      TCVC = .False.
      TCVD = .False.
      TCVE = .False.
      TCVF = .False.

      Nij = 0
      Ntj = 0
      Njt = 0
      Naj = 0
      Ntu = 0
      Nau = 0
      Nab = 0

      Len_FAB = 0
      Len_ij = 0
      Len_tj = 0
      Len_jt = 0
      Len_aj = 0
      Len_tu = 0
      Len_au = 0
      Len_ab = 0

      Len_XAj = 0
      Len_XAu = 0
      Len_XAb = 0

      NFAB = nBas(iSym) * ( nBas(jSym) + 1 ) /2
      Len_ABSq = nBas(iSym) * nBas(jSym)

* TCV-A :
      If (TCVXist(1,iSym,jSym)) Then
        TCVA = .True.
        Len_XAj = nBas(iSym) * nIsh(jSym)
        Nij = nIsh(iSym) * nIsh(jSym)
      EndIf

* TCV-B :
      If (TCVXist(2,iSym,jSym)) Then
        TCVB = .True.
        Len_XAj = nBas(iSym) * nIsh(jSym)
        Ntj = nAsh(iSym) * nIsh(jSym)
        Njt = nIsh(jSym) * nAsh(iSym)
      EndIf

* TCV-C :
      If (TCVXist(3,iSym,jSym)) Then
        TCVC = .True.
        Len_XAj = nBas(iSym) * nIsh(jSym)
        Naj = nSsh(iSym) * nIsh(jSym)
      EndIf

* TCV-D :
      If (TCVXist(4,iSym,jSym)) Then
        TCVD = .True.
        Len_XAu = nBas(iSym) * nAsh(jSym)
        Ntu = nAsh(iSym) * nAsh(jSym)
      EndIf

* TCV-E :
      If (TCVXist(5,iSym,jSym)) Then
        TCVE = .True.
        Len_XAu = nBas(iSym) * nAsh(jSym)
        Nau = nSsh(iSym) * nAsh(jSym)
      EndIf

* TCV-F :
      If (TCVXist(6,iSym,jSym)) Then
        TCVF = .True.
        Len_XAb = nBas(iSym) * nSsh(jSym)
        Nab = nSsh(iSym) * nssh(jSym)
      EndIf

*     Allocate memory for Transformed Cholesky Vectors - TCVx
      Len_ij = Nij * NumV
      Len_tj = Ntj * NumV
      Len_jt = Njt * NumV
      Len_aj = Naj * NumV
      Len_tu = Ntu * NumV
      Len_au = Nau * NumV
      Len_ab = Nab * NumV
      iStrt_ij = 0
      iStrt_tj = 0
      iStrt_jt = 0
      iStrt_aj = 0
      iStrt_tu = 0
      iStrt_au = 0
      iStrt_ab = 0
      iStrt0_ij = 0
      iStrt0_tj = 0
      iStrt0_jt = 0
      iStrt0_aj = 0
      iStrt0_tu = 0
      iStrt0_au = 0
      iStrt0_ab = 0

      If (TCVA) then
        Call GetMem('ij','ALLO','REAL',iStrt00_ij,Len_ij)
        iMemTCVX(1,iSym,jSym,1)=iStrt00_ij
        iMemTCVX(1,iSym,jSym,2)=Len_ij
      EndIf
      If (TCVB) then
        Call GetMem('tj','ALLO','REAL',iStrt00_tj,Len_tj)
        iMemTCVX(2,iSym,jSym,1)=iStrt00_tj
        iMemTCVX(2,iSym,jSym,2)=Len_tj
        Call GetMem('jt','ALLO','REAL',iStrt00_jt,Len_jt)
        iMemTCVX(7,jSym,iSym,1)=iStrt00_jt
        iMemTCVX(7,jSym,iSym,2)=Len_jt
      EndIf
      If (TCVC) then
        Call GetMem('aj','ALLO','REAL',iStrt00_aj,Len_aj)
        iMemTCVX(3,iSym,jSym,1)=iStrt00_aj
        iMemTCVX(3,iSym,jSym,2)=Len_aj
      EndIf
      If (TCVD) then
        Call GetMem('tu','ALLO','REAL',iStrt00_tu,Len_tu)
        iMemTCVX(4,iSym,jSym,1)=iStrt00_tu
        iMemTCVX(4,iSym,jSym,2)=Len_tu
      EndIf
      If (TCVE) then
        Call GetMem('au','ALLO','REAL',iStrt00_au,Len_au)
        iMemTCVX(5,iSym,jSym,1)=iStrt00_au
        iMemTCVX(5,iSym,jSym,2)=Len_au
      EndIf
      If (TCVF) then
        Call GetMem('ab','ALLO','REAL',iStrt00_ab,Len_ab)
        iMemTCVX(6,iSym,jSym,1)=iStrt00_ab
        iMemTCVX(6,iSym,jSym,2)=Len_ab
      EndIf

* --- START LOOP iFBatch -----------------------------------------------
      DO iFBatch=1,nFBatch
        If (iFBatch.EQ.nFBatch) then
         NumFV = NumV - nFVec * (nFBatch-1)
        Else
         NumFV = nFVec
        EndIf
        If ( TCVA ) iStrt0_ij = iStrt00_ij + (iFBatch-1) * nFVec * Nij
        If ( TCVB ) iStrt0_tj = iStrt00_tj + (iFBatch-1) * nFVec * Ntj
        If ( TCVB ) iStrt0_jt = iStrt00_jt + (iFBatch-1) * nFVec * Njt
        If ( TCVC ) iStrt0_aj = iStrt00_aj + (iFBatch-1) * nFVec * Naj
        If ( TCVD ) iStrt0_tu = iStrt00_tu + (iFBatch-1) * nFVec * Ntu
        If ( TCVE ) iStrt0_au = iStrt00_au + (iFBatch-1) * nFVec * Nau
        If ( TCVF ) iStrt0_ab = iStrt00_ab + (iFBatch-1) * nFVec * Nab

*       Allocate memory & Load Full Cholesky Vectors - CHFV
        Len_FAB = NFAB * NumFV
        iStrtVec_FAB = iStrtVec_AB + nFVec * (iFBatch-1)
        Call GetMem('FAB','Allo','Real',iStrt0_FAB,Len_FAB)
        Call RdChoVec(Work(iStrt0_FAB),NFAB,NumFV,iStrtVec_FAB,lUCHFV)

*  ---  Start Loop  iVec  ---
        Do iVec=1,NumFV   ! Loop  iVec
          iStrt_FAB = iStrt0_FAB + (iVec-1) * NFAB
          If ( TCVA ) iStrt_ij = iStrt0_ij + (iVec-1) * Nij
          If ( TCVB ) iStrt_tj = iStrt0_tj + (iVec-1) * Ntj
          If ( TCVB ) iStrt_jt = iStrt0_jt + (iVec-1) * Njt
          If ( TCVC ) iStrt_aj = iStrt0_aj + (iVec-1) * Naj
          If ( TCVD ) iStrt_tu = iStrt0_tu + (iVec-1) * Ntu
          If ( TCVE ) iStrt_au = iStrt0_au + (iVec-1) * Nau
          If ( TCVF ) iStrt_ab = iStrt0_ab + (iVec-1) * Nab

*     --- 1st Half-Transformation  iBeta(AO) -> q(MO) only occupied
          jStrt0MO = 1
          Do j=1,jSym-1
            jStrt0MO = jStrt0MO + nBas(j) * nBas(j)
          EndDo
          jStrt0MO = jStrt0MO + nFro(jSym) * nBas(jSym)

C         From CHFV A(Alpha,Beta) to XAj(Alpha,jMO)
          If ( TCVA .or. TCVB .or. TCVC ) then
            Call GetMem('XAj','ALLO','REAL',iStrt0_XAj,Len_XAj)
            Call ProdsS_1(Work(iStrt_FAB), nBas(iSym),
     &                CMO(jStrt0MO),nIsh(jSym), Work(iStrt0_XAj))
          EndIf
          jStrt0MO = jStrt0MO + nIsh(jSym) * nBas(jSym)

C         From CHFV A(Alpha,Beta) to XAu(Alpha,uMO)
          If ( TCVD .or. TCVE ) then
            Call GetMem('XAu','ALLO','REAL',iStrt0_XAu,Len_XAu)
            Call ProdsS_1(Work(iStrt_FAB), nBas(iSym),
     &                CMO(jStrt0MO),nAsh(jSym), Work(iStrt0_XAu))
          EndIf
          jStrt0MO = jStrt0MO + nAsh(jSym) * nBas(jSym)

C         From CHFV A(Alpha,Beta) to XAb(Alpha,bMO)
          If ( TCVF ) then
            Call GetMem('XAb','ALLO','REAL',iStrt0_XAb,Len_XAb)
            Call ProdsS_1(Work(iStrt_FAB), nBas(iSym),
     &                CMO(jStrt0MO),nSsh(jSym), Work(iStrt0_XAb))
          EndIf

*     --- 2nd Half-Transformation  iAlpha(AO) -> p(MO)
          iStrt0MO = 1
          Do i=1,iSym-1
            iStrt0MO = iStrt0MO + nBas(i) * nBas(i)
          EndDo
          iStrt0MO = iStrt0MO + nFro(iSym) * nBas(iSym)

C         From XAj(Alpha,jMO) to ij(i,j)
          If ( TCVA ) then
            Call ProdsS_2(Work(iStrt0_XAj), nBas(iSym),nIsh(jSym),
     &                CMO(iStrt0MO),nIsh(iSym), Work(iStrt_ij))
          EndIf
          iStrt0MO = iStrt0MO + nIsh(iSym) * nBas(iSym)

C         From XAj(Alpha,jMO) to tj(t,j) & jt(j,t)
          If ( TCVB ) then
            Call ProdsS_2(Work(iStrt0_XAj), nBas(iSym),nIsh(jSym),
     &                CMO(iStrt0MO),nAsh(iSym), Work(iStrt_tj))
            Call Trnsps(nAsh(iSym),nIsh(jSym),
     &                                    Work(iStrt_tj),Work(iStrt_jt))
          EndIf

C         From XAu(Alpha,uMO) to tu(t,u)
          If ( TCVD ) then
            Call ProdsS_2(Work(iStrt0_XAu), nBas(iSym),nAsh(jSym),
     &                CMO(iStrt0MO),nAsh(iSym), Work(iStrt_tu))
          EndIf
          iStrt0MO = iStrt0MO + nAsh(iSym) * nBas(iSym)

C         From XAj(Alpha,jMO) to aj(a,j)
          If ( TCVC ) then
            Call ProdsS_2(Work(iStrt0_XAj), nBas(iSym),nIsh(jSym),
     &                CMO(iStrt0MO),nSsh(iSym), Work(iStrt_aj))
          EndIf

C         From XAu(Alpha,uMO) to au(a,u)
          If ( TCVE ) then
            Call ProdsS_2(Work(iStrt0_XAu), nBas(iSym),nAsh(jSym),
     &                CMO(iStrt0MO),nSsh(iSym), Work(iStrt_au))
          EndIf

C         From XAb(Alpha,bMO) to ab(a,b)
          If ( TCVF ) then
            Call ProdsS_2(Work(iStrt0_XAb), nBas(iSym),nSsh(jSym),
     &                CMO(iStrt0MO),nSsh(iSym), Work(iStrt_ab))
          EndIf

*     --- End of Transformations

          If ( TCVA .or. TCVB .or. TCVC ) then
            Call GetMem('XAj','FREE','REAL',iStrt0_XAj,Len_XAj)
          EndIf
          If ( TCVD .or. TCVE ) then
            Call GetMem('XAu','FREE','REAL',iStrt0_XAu,Len_XAu)
          EndIf
          If ( TCVF ) then
            Call GetMem('XAb','FREE','REAL',iStrt0_XAb,Len_XAb)
          EndIf

        EndDo
*  ---  End Loop  iVec  ---

        Call GetMem('FAB','Free','Real',iStrt0_FAB,Len_FAB)
      ENDDO
* --- END LOOP iFBatch -------------------------------------------------

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iSymL)
      End

      Subroutine ProdsS_1(AB,iAB, CMO,nMO, Y)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "WrkSpc.fh"
      Dimension AB(iAB*(iAB+1)/2), CMO(iAB,nMO), Y(iAB,nMO)
      Call GetMem('ABSq','ALLO','REAL',iAddABSq,iAB*iAB)
      Call SQUARE(AB,Work(iAddABSq),1,iAB,iAB)
      Call DGEMM_('N','N',iAB,nMO,iAB,1.0d0,Work(iAddABSq),iAB,CMO,iAB,
     &                                                    0.0d0,Y,iAB)
      Call GetMem('ABSq','FREE','REAL',iAddABSq,iAB*2)
      Return
      End

      Subroutine ProdsS_2(AB,iA,jMO, CMO,nMO, Y)
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
      Dimension AB(iA,jMO), CMO(iA,nMO), Y(nMO,jMO)
      Call DGEMM_('T','N',nMO,jMO,iA,1.0d0,CMO,iA,AB,iA,0.0d0,Y,nMO)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Kntc_GIAO(Txyz,Rxyz,Wxyz,na,nb,Alpha,Beta,nZeta)
!***********************************************************************
!                                                                      *
! Object: to assemble the cartesian components of the kinetic energy   *
!         integral from the cartesian components of the overlap        *
!         integral.                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Constants, only: Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: na, nb, nZeta
real(kind=wp), intent(in) :: Rxyz(nZeta,3,0:na+1,0:nb+1,0:1), Alpha(nZeta), Beta(nZeta)
real(kind=wp), intent(out) :: Txyz(nZeta,3,0:na,0:nb,0:1), Wxyz(nZeta,3,0:na,0:nb,2)
#include "print.fh"
integer(kind=iwp) :: ia, ib, iCar, iPrint, iRout
character(len=80) :: Label

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 115
iPrint = nPrint(iRout)
!                                                                      *
!***********************************************************************
!                                                                      *
if (iPrint >= 99) then
  call RecPrt(' In Kntc: Alpha',' ',Alpha,nZeta,1)
  call RecPrt(' In Kntc: Beta ',' ',Beta,nZeta,1)
  do ia=0,na+1
    do ib=0,nb+1
      write(Label,'(A,I2,A,I2,A)') ' In Kntc: Rxyz(',ia,',',ib,',0)'
      call RecPrt(Label,' ',Rxyz(:,:,ia,ib,0),nZeta,3)
      write(Label,'(A,I2,A,I2,A)') ' In Kntc: Rxyz(',ia,',',ib,',1)'
      call RecPrt(Label,' ',Rxyz(:,:,ia,ib,1),nZeta,3)
    end do
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
do ia=0,na
  do ib=0,nb
    if ((ia /= 0) .and. (ib /= 0)) then
      do iCar=1,3
        Txyz(:,iCar,ia,ib,0) = Two*Alpha*Beta*Rxyz(:,iCar,ia+1,ib+1,0)+Half*ia*ib*Rxyz(:,iCar,ia-1,ib-1,0)- &
                               Beta*ia*Rxyz(:,iCar,ia-1,ib+1,0)-Alpha*ib*Rxyz(:,iCar,ia+1,ib-1,0)
        Txyz(:,iCar,ia,ib,1) = Two*Alpha*Beta*Rxyz(:,iCar,ia+1,ib+1,1)+Half*ia*ib*Rxyz(:,iCar,ia-1,ib-1,1)- &
                               Beta*ia*Rxyz(:,iCar,ia-1,ib+1,1)-Alpha*ib*Rxyz(:,iCar,ia+1,ib-1,1)
        Wxyz(:,iCar,ia,ib,1) = -Two*Alpha*Rxyz(:,iCar,ia+1,ib,0)+ia*Rxyz(:,iCar,ia-1,ib,0)
        Wxyz(:,iCar,ia,ib,2) = -Two*Beta*Rxyz(:,iCar,ia,ib+1,0)+ib*Rxyz(:,iCar,ia,ib-1,0)
      end do
    else if (ia /= 0) then
      do iCar=1,3
        Txyz(:,iCar,ia,ib,0) = Two*Alpha*Beta*Rxyz(:,iCar,ia+1,ib+1,0)-Beta*ia*Rxyz(:,iCar,ia-1,ib+1,0)
        Txyz(:,iCar,ia,ib,1) = Two*Alpha*Beta*Rxyz(:,iCar,ia+1,ib+1,1)-Beta*ia*Rxyz(:,iCar,ia-1,ib+1,1)
        Wxyz(:,iCar,ia,ib,1) = -Two*Alpha*Rxyz(:,iCar,ia+1,ib,0)+ia*Rxyz(:,iCar,ia-1,ib,0)
        Wxyz(:,iCar,ia,ib,2) = -Two*Beta*Rxyz(:,iCar,ia,ib+1,0)
      end do
    else if (ib /= 0) then
      do iCar=1,3
        Txyz(:,iCar,ia,ib,0) = Two*Alpha*Beta*Rxyz(:,iCar,ia+1,ib+1,0)-Alpha*ib*Rxyz(:,iCar,ia+1,ib-1,0)
        Txyz(:,iCar,ia,ib,1) = Two*Alpha*Beta*Rxyz(:,iCar,ia+1,ib+1,1)-Alpha*ib*Rxyz(:,iCar,ia+1,ib-1,1)
        Wxyz(:,iCar,ia,ib,1) = -Two*Alpha*Rxyz(:,iCar,ia+1,ib,0)
        Wxyz(:,iCar,ia,ib,2) = -Two*Beta*Rxyz(:,iCar,ia,ib+1,0)+ib*Rxyz(:,iCar,ia,ib-1,0)
      end do
    else
      do iCar=1,3
        Txyz(:,iCar,ia,ib,0) = Two*Alpha*Beta*Rxyz(:,iCar,ia+1,ib+1,0)
        Txyz(:,iCar,ia,ib,1) = Two*Alpha*Beta*Rxyz(:,iCar,ia+1,ib+1,1)
        Wxyz(:,iCar,ia,ib,1) = -Two*Alpha*Rxyz(:,iCar,ia+1,ib,0)
        Wxyz(:,iCar,ia,ib,2) = -Two*Beta*Rxyz(:,iCar,ia,ib+1,0)
      end do
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    if (iPrint >= 99) then
      write(Label,'(A,I2,A,I2,A)') ' In Kntc: Txyz(',ia,',',ib,',0)'
      call RecPrt(Label,' ',Txyz(:,:,ia,ib,0),nZeta,3)
      write(Label,'(A,I2,A,I2,A)') ' In Kntc: Txyz(',ia,',',ib,',1)'
      call RecPrt(Label,' ',Txyz(:,:,ia,ib,1),nZeta,3)
      write(Label,'(A,I2,A,I2,A)') ' In Kntc: Wxyz(',ia,',',ib,',1)'
      call RecPrt(Label,' ',Wxyz(:,:,ia,ib,1),nZeta,3)
      write(Label,'(A,I2,A,I2,A)') ' In Kntc: Wxyz(',ia,',',ib,',2)'
      call RecPrt(Label,' ',Wxyz(:,:,ia,ib,2),nZeta,3)
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Kntc_GIAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
      Subroutine Add_Info(Label,Array,nArray,iToll)
************************************************************************
*                                                                      *
*     written by:                                                      *
*     V.Veryazov                                                       *
*                                                                      *
*    parameters:                                                       *
*       Label - text label                                             *
*       Array(nArray) - values to check                                *
*       iToll - tolerance:                                             *
*                if positive:10**(-iToll)                              *
*                else                                                  *
*                           : -iToll                                   *
*                                                                      *
************************************************************************
*
      Character*(*) Label
      Character*120 Line
      Real*8 Array(nArray)
      Character*32 File_Name
c     Logical Exist
      Character*30 Junk
      Character*8 Toll
c     Integer irecl
c     Logical is_error
      Character*256 STRING
      Character*256 STMP
      Character*256  STRING2
      Character*256 Collect
      Logical Found
*--- Some variables for Geo environment //Jonas 2011
      Integer iGeoInfo(2)
      Character*15 Energy_File
      Character*13 GeoDataF
      Integer iGeoData,iuGeoData
      Integer nIntCoord,iDum(1)
#include "para_info.fh"
*------------------------------------------------
c If this is a fake parallel run (e.g. inside the parallel loop of CASPT2_gradient,
c then do not add info - just return immidiately
#ifdef _MOLCAS_MPP_
      If ((.not.King()).and.(.not.Is_Real_Par())) Return
#endif
c Number - is a number of exported variables from an array.
      Number=20
      File_Name='molcas_info'
      if(iToll.eq.0) iToll=8
*
      Lu_Info=99
*
*---------------------------------------------------------------------*
*     Check the file status                                           *
*---------------------------------------------------------------------*
      call open_molcas_info
c      call f_Inquire (File_name, Exist)
c*----------------------------------------------------------------------*
c*     Open existing file and position the record pointer to the end    *
c*----------------------------------------------------------------------*
c      If ( Exist ) then
c      call molcas_open_Ext2(Lu_info,file_name,'sequential','formatted',
c     &         ios,.false.,irecl,'unknown',is_error)
c         If ( ios.ne.0 ) Then
c            Write (6,*) 'Add_Info: can not create info file'
c            Write (6,*) 'Check file permissions!'
c            Call Abend
c         End If
c         nLines = 0
c         Do while (.True.)
c           Read (Lu_Info,'(A)',End=100,iostat=ios) Line
c           nLines = nLines+1
c         End Do
c100      Continue
c         Rewind(Lu_Info)
c         Do iLine = 1,nLines
c           Read (Lu_Info,'(A)') Line
c         End Do
c#ifdef NAGFOR
cC FIXME: ugly hack to make NAG compiler happy
c         close(Lu_Info)
c         open(Lu_Info,file=file_name,position='append')
c#endif
c*----------------------------------------------------------------------*
c*     Open new file                                                    *
c*----------------------------------------------------------------------*
c      Else
c      call molcas_open_Ext2(Lu_info,file_name,'sequential','formatted',
c     &         ios,.false.,irecl,'unknown',is_error)
c         If ( ios.ne.0 ) Then
c            Write (6,*) 'Add_Info: can not create a new file'
c            Write (6,*) 'Check file permissions!'
c            Call Abend
c         End If
c         Do 20 i=1,Len(Line)
c            Line(i:i)='#'
c20       Continue
c         Write (Lu_Info,'(A)') Line
c         Write (Lu_Info,'(A)') '# MOLCAS-Info_File Vers.No. 1.1'
c         Write (Lu_Info,'(A)') Line
c      End If
*----------------------------------------------------------------------*
*     Append new information                                           *
*----------------------------------------------------------------------*
      write(Toll,'(i8)')iToll
      nlabel=Len(label)
      Line=label
      n0=nlabel
      Do i = 1, nlabel
         If (label(i:i).eq.' ') Line(i:i)='_'
      End Do
      call upcase(Line)
*------------------ Some code for Geo-Environment //Jonas 2011
*----------------------------------------------------------------------*
*     Check if we are in the GEO-Environment and append if energy      *
*----------------------------------------------------------------------*
c666   Continue
      Call qpg_iArray('GeoInfo',Found,length)
      If(Found) Then
         Call get_iArray('GeoInfo',iGeoInfo,2)
         If((nArray.eq.1) .and. (iGeoInfo(1) .eq. 1) .and.
     &      Label(1:2) .eq. 'E_') Then
            Write(Energy_File,'(A,I4.4)') 'disp.energy',iGeoInfo(2)
            LuDispEn = 1
            LuDispEn = isfreeunit(LuDispEn)
            Call Molcas_Open(LuDispEn,Energy_File)
            Write(LuDispEn,'(F16.8)') Array(nArray)
            Close(LuDispEn)
            GeoDataF='GEODATA'
            iGeoData = 0
            iuGeoData = 10
            iuGeoData = isFreeUnit(iuGeoData)
            Call DaName_WA(iuGeoData,GeoDataF)
            Call iDaFile(iuGeoData,2,iDum,1,iGeoData)
            nIntCoord=iDum(1)
            iGeoData=iGeoInfo(2)*(nIntCoord+1)+1
            Call dDaFile(iuGeoData,1,Array(nArray),1,iGeoData)
            Call DaClos(iuGeoData)
         End If
      End If
      If (MyRank.ne.0) GoTo 888
*-----------------------------------------------------------------------


C If this label should not be checked, then just return immediately:
      STRING=' '
      CALL GETENVF('MOLCAS_NOCHECK',STRING)
      call upcase(STRING)
      STMP=STRING
      isfound=0
999   icoma=index(STMP,',')
      if(icoma.ne.0) then
        STRING=' '
        STRING=STMP(1:icoma-1)
        if(icoma.lt.len(STMP)) then
          STMP=STMP(icoma+1:)
        else
          STMP=''
        endif
      else
        STRING=STMP
        STMP=' '
      endif
      k=0
      l=len(STRING)
      do i=1,l
        if(STRING(i:i).eq.' ') then
          if(k.gt.0) then
            if(STRING2(1:k).eq.Line(1:k)) then
               isfound=1
               goto 898
            end if
          end if
          k=0
        else
          k=k+1
          STRING2(k:k)=STRING(i:i)
        end if
      end do
898   continue
      if(STMP.ne.' ') goto 999
      if(isfound.eq.1) goto 888

      Do iArray = 1, nArray
      nlabel=n0
       if(nArray.ne.1) then
         write(Junk,'(a,i3,a)') '[',iArray-1,']'
         do j=1,5
           if(Junk(j:j).ne.' ') then
           nlabel=nlabel+1
           Line(nlabel:nlabel)=Junk(j:j)
           endif
         enddo
       endif
         nlabel=nlabel+1
         Line(nlabel:nlabel)='='
         nlabel=nlabel+1
         Line(nlabel:nlabel)='"'
         ia=int(Array(iArray)+0.3d0)
         if(abs(Array(iArray)-ia).lt.0.0000001.and.ia.ne.0) then
          write(Junk,'(I30)')ia
          else
            if(abs(Array(iArray)).gt.1D-14)then
              write(Junk,'(F30.12)') Array(iArray)
            else
           Junk='0.0'
           endif
         endif
         do j=1,30
           if(Junk(j:j).ne.' ') then
           nlabel=nlabel+1
           Line(nlabel:nlabel)=Junk(j:j)
           endif
         enddo
         nlabel=nlabel+1
         Line(nlabel:nlabel)='"'
        if(iArray.lt.Number) then
*----------------------------------------------------------------------*
*     Export only head of Array                                        *
*----------------------------------------------------------------------*
c        write(Lu_Info,*)
        collect=Line(1:nlabel)
        call add_molcas_info(collect,nlabel)
c        write (Lu_Info,'(a)') Line(1:nlabel)
        if (iArray.eq.nArray) then
          collect='export '//Line(1:n0)
          call add_molcas_info(collect,n0+7)
c          write (Lu_Info,'(a,a)') 'export ',Line(1:n0)
        endif
        endif
      ik=0
      do i=1,8
      if(Toll(i:i).ne.' ') then
        ik=ik+1
        Junk(ik:ik)=Toll(i:i)
      endif
      enddo
      collect='#> '// Line(1:nlabel)// '/'//Junk(1:ik)
      call add_molcas_info(collect,nlabel+ik+4)
c      write (Lu_Info,'(a,a,a,a)') '#> ', Line(1:nlabel),'/',Junk(1:ik)
      enddo
*----------------------------------------------------------------------*
*     Close file                                                       *
*----------------------------------------------------------------------*
888   continue
      call close_molcas_info
*----------------------------------------------------------------------*
*     exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Setup_OffAO()
      use Basis_Info, only: nCnttp, Shells, dbsc
      Implicit Real*8 (A-H,O-Z)
*
*     For some reason we need a counter which for a given shell index,
*     kSh, counts how many angular functions have been in the
*     proceeding shells. This is stored in kOffAO(kSh).
*     Additionally, lOffAO gives the total number of angular functions
*     in a given dbsc.
*
      Do iCnttp = 1, nCnttp
         lComp = 0
         Do lSh = 0, dbsc(iCnttp)%nVal-1
            kSh = lSh + dbsc(iCnttp)%iVal
            If (Shells(kSh)%Prjct ) Then
               kComp = 2*lSh + 1
            Else
               kComp = (lSh+1)*(lSh+2)/2
            End If
            Shells(kSh)%kOffAO = lComp
            If (Shells(kSh)%nBasis_C.ne.0 .and.
     &          Shells(kSh)%nExp    .ne.0 ) lComp = lComp + kComp
         End Do
         dbsc(iCnttp)%lOffAO = lComp
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RSTMOL(NERR)
!
! Purpose: check restart molecular info.

use Cholesky, only: LUPRI, NBAS, NNSHL, NSHELL, NSYM, XNBAS, XNNSHL, XNSHELL, XNSYM
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: NERR
integer(kind=iwp) :: ISYM

NERR = 0

if (XNSYM /= NSYM) then
  write(LUPRI,'(A,I3,A,I3)') 'RESTART ERROR: #irreps from restart file:',XNSYM,' Expected:',NSYM
  NERR = NERR+1
else
  do ISYM=1,NSYM
    if (XNBAS(ISYM) /= NBAS(ISYM)) then
      write(LUPRI,'(A,I2,A,I9,A,I9)') 'RESTART ERROR: #basis functions (sym.',ISYM,') from restart file:',XNBAS(ISYM), &
                                      ' Expected:',NBAS(ISYM)
      NERR = NERR+1
    end if
  end do
end if

if (XNSHELL /= NSHELL) then
  write(LUPRI,'(A,I9,A,I9)') 'RESTART ERROR: #shells from restart file:',XNSHELL,' Expected:',NSHELL
  NERR = NERR+1
end if

if (XNNSHL /= NNSHL) then
  write(LUPRI,'(A,I9,A,I9)') 'RESTART ERROR: #shell pairs from restart file:',XNNSHL,' Expected:',NNSHL
  NERR = NERR+1
end if

end subroutine CHO_RSTMOL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_VecBuf_Copy(Vec,nVec,iSym)
C
C     Purpose: copy as many vectors as fit directly into buffer using
C              current reduced set dimension for symmetry iSym. nVec
C              is the number of vectors in array Vec.
C         NB!  It is important that the vector counter NumCho does NOT
C              include the nVec vectors in array Vec.
C
      use ChoVecBuf, only: CHVBUF, ip_CHVBUF_SYM, l_CHVBUF_SYM,
     &                     nVec_in_Buf
      Implicit None
      Real*8  Vec(*)
      Integer nVec, iSym
#include "cholesky.fh"

      Integer mUsed, Left, nCopy, lCopy, kOff

C     Check if there is anything to do at all.
C     1) any buffer allocated?
C     2) any vectors to copy?
C     3) any elements?
C     ----------------------------------------

      If (l_ChVBuf_Sym(iSym) .lt. 1) Return
      If (nVec .lt. 1) Return
      If (nnBstR(iSym,2) .lt. 1) Return

C     Copy vectors
C     1) if all previous vectors are in the buffer, and
C     2) if there is sufficient free space in the buffer.
C     ---------------------------------------------------

      If (nVec_in_Buf(iSym) .eq. NumCho(iSym)) Then
         mUsed = nnBstR(iSym,2)*nVec_in_Buf(iSym)
         Left  = l_ChVBuf_Sym(iSym) - mUsed
         nCopy = min(Left/nnBstR(iSym,2),nVec)
         If (nCopy .gt. 0) Then
            lCopy = nnBstR(iSym,2)*nCopy
            kOff  = ip_ChVBuf_Sym(iSym) + mUsed
            Call dCopy_(lCopy,Vec,1,CHVBUF(kOff),1)
            nVec_in_Buf(iSym) = nVec_in_Buf(iSym) + nCopy
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AdH_Hvv2(H,Hvv,dima,dimbe,adda,addbe,nv)
! this routine does:
! Hvv(a,be) <<- - H(be',a')

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimbe, adda, addbe, nv
real(kind=wp), intent(in) :: H(dimbe,dima)
real(kind=wp), intent(inout) :: Hvv(nv,nv)
integer(kind=iwp) :: be

do be=1,dimbe
  Hvv(adda+1:adda+dima,addbe+be) = Hvv(adda+1:adda+dima,addbe+be)-H(be,:)
end do

return

end subroutine AdH_Hvv2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************

subroutine CalcEigVec(Matrix,NDIM,EigVec)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDim
real(kind=wp), intent(in) :: Matrix(NDIM,NDIM)
real(kind=wp), intent(out) :: EigVec(NDIM,NDIM)
integer(kind=iwp) :: ICol, INFO, IRIC, IRow, NElem, NScr
real(kind=wp) :: WGRONK(2)
real(kind=wp), allocatable :: Mat(:), Scr(:), Val(:,:)
logical(kind=iwp), parameter :: UseJacob = .true.

EigVec(:,:) = Zero

if (UseJacob) then
  NElem = nTri_Elem(NDim)
  call mma_allocate(Mat,nElem,Label='Mat')
  call mma_allocate(Val,nDim,nDim,Label='Val')
  IRIC = 0
  do IRow=1,NDIM
    do ICol=1,IRow
      IRIC = IRIC+1
      Mat(IRIC) = Matrix(IRow,ICol)
    end do
  end do
  call unitmat(Val,NDim)
  !write(u6,*) 'eigenvector matrix before diag'
  !call RECPRT(' ',' ',Val,NDIM,NDIM)
  !write(u6,*) 'matrix to be diagonalized'
  !call TriPrt(' ',' ',Mat,NDIM)
  call JACOB(Mat,Val,NDim,NDim)
  !write(u6,*)'eigenvector matrix'
  !call RECPRT(' ',' ',Val,NDIM,NDIM)
  !do IRow=1,NDIM
  !  write(u6,*) (EigVec(IRow,ICol),ICol=1,NDim)
  !end do
  do ICol=1,NDIM
    EigVec(:,ICol) = Val(iCol,:)
  end do
  call mma_deallocate(Val)
  call mma_deallocate(Mat)

else
  NElem = NDim**2
  call mma_allocate(Mat,nElem,Label='Mat')
  call mma_allocate(Val,nDim,nDim,Label='Val')
  do ICol=1,NDIM
    Mat((ICol-1)*NDIM+1:ICol*NDIM) = Matrix(:,ICol)
  end do
  Val(:,:) = Zero
  call Dsyev_('V','U',NDIM,Mat,NDIM,Val,WGRONK,-1,INFO)
  NScr = int(WGRONK(1))
  call mma_allocate(Scr,nScr,Label='Scr')
  call Dsyev_('V','U',NDIM,Mat,NDIM,Val,Scr,NScr,INFO)
  do IRow=1,NDIM
    EigVec(IRow,:) = Mat((IRow-1)*NDIM+1:IRow*NDIM)
  end do
  call mma_deallocate(Scr)
  call mma_deallocate(Val)
  call mma_deallocate(Mat)
end if

end subroutine CalcEigVec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Roland Lindh                                     *
************************************************************************
      SUBROUTINE MK_PROP(PROP,IPROP,ISTATE_,JSTATE_,LABEL,ITYPE,
     &                   BUFF,NBUFF,DENS,NDENS,MASK,ISY12,IOFF)
      IMPLICIT REAL*8 (A-H,O-Z)
************************************************************************
*     Objective: to compute the transition property between state      *
*                ISTATE and JSTATE of property IPROP.                  *
*                                                                      *
*     This routine will be generalized to a direct routine later.      *
*                                                                      *
*     Author: Roland Lindh, Uppsala University, 23 Dec. 2015           *
************************************************************************
#include "Molcas.fh"
#include "cntrl.fh"
#include "rassi.fh"
#include "symmul.fh"
      CHARACTER*8 LABEL
      REAL*8 PROP(NSTATE,NSTATE,NPROP), BUFF(NBUFF), DENS(NDENS,4)
      INTEGER IOFF(8)
      DIMENSION IDUM(1)
      ISTATE=Max(ISTATE_,JSTATE_)
      JSTATE=Min(ISTATE_,JSTATE_)
*
      IF (LABEL(1:4).eq.'ASD ') LABEL(1:5)='MAGXP'
      IC=ICOMP(IPROP)
!     Write (*,*) 'Mk_Prop: Label=',Label
!     Write (*,*) 'Mk_Prop:    IC=',IC
      IOPT=1
      NSIZ=0
      CALL iRDONE(IRC,IOPT,LABEL,IC,IDUM,ISCHK)
      IF(IRC.eq.0) NSIZ=IDUM(1)
      IF(MOD(ISCHK/MASK,2).EQ.0) GOTO 300
      IOPT=0
C Rulin: The 'spin-dependent' part of hyperfine contribution
      IF (LABEL(1:5).eq.'MAGXP') THEN
        CALL HFCSD(LABEL,IC,BUFF,NBUFF,NSIZ,ISCHK)
        LABEL(1:5) = 'ASD  '
      ELSE
        CALL RDONE(IRC,IOPT,LABEL,IC,BUFF,ISCHK)
      END IF
!     Write (*,*) 'NBUFF,NSIZ=',NBUFF,NSIZ
      IF ( IRC.NE.0.AND.LABEL(1:4).NE.'TMOM' ) THEN
         WRITE(6,*)
         WRITE(6,'(6X,A)')'*** ERROR IN SUBROUTINE MK_PROP ***'
         WRITE(6,'(6X,A)')'  FAILED IN READING FROM  ONEINT'
         WRITE(6,'(6X,A,A)')'  LABEL     = ',LABEL
         WRITE(6,'(6X,A,I2)')'  COMPONENT = ',IC
         WRITE(6,*)
         GO TO 300
      END IF
      IPUSED(IPROP)=1
C IF THIS IS THE FIRST CALL TO THE SUBROUTINE, PICK UP SOME DATA:
*       IF(ICALL.EQ.0) THEN
C-SVC: for safety reasons, always pick up the data, since it is not
C      necessarily done on the first call!
C PICK UP THE ORIGIN COORDINATES:
      PORIG(1,IPROP)=BUFF(NSIZ+1)
      PORIG(2,IPROP)=BUFF(NSIZ+2)
      PORIG(3,IPROP)=BUFF(NSIZ+3)
C PICK UP THE NUCLEAR CONTRIBUTION FROM INTEGRAL BUFFER
      IF (PNAME(IPROP)(1:3).NE.'ASD'.AND.
     &    PNAME(IPROP)(1:3).NE.'PSO') THEN
         PNUC(IPROP)=BUFF(NSIZ+4)
      ELSE
         Write(6,*) "Removing nuclear contrib from ASD and PSO: "
      END IF
      IINT=1
      PSUM=0.0D00
      DO 220 ISY1=1,NSYM
         NB1=NBASF(ISY1)
         IF(NB1.EQ.0) GOTO  220
         DO 210 ISY2=1,ISY1
            I12=MUL(ISY1,ISY2)
            IF(IAND(2**(I12-1),ISCHK).EQ.0) GOTO 210
            NB2=NBASF(ISY2)
            IF(NB2.EQ.0) GOTO  210
            NB12=NB1*NB2
            IF(ISY1.EQ.ISY2) NB12=(NB12+NB1)/2
            IF (I12.EQ.ISY12) THEN
               IPOS=IOFF(ISY1)+1
               PSUM=PSUM+DDOT_(NB12,BUFF(IINT),1,DENS(IPOS,ITYPE),1)
            END IF
            IINT=IINT+NB12
210      CONTINUE
220   CONTINUE
C     Write (*,*) 'PSUM=',PSUM,LABEL,IC
C IN THE CASE OF MULTIPOLES, CHANGE SIGN TO ACCOUNT FOR THE NEGATIVE
C ELECTRONIC CHARGE AS COMPARED TO THE NUCLEAR CONTRIBUTION.
      IF(LABEL(1:5).EQ.'MLTPL') PSUM=-PSUM
C In the case of AMFI integrals, they should be multiplied by 2.
C The reason for the factor of two is that this program uses spin
C (uses Clebsch-Gordan coefficients to define Wigner-Eckart
C  reduced matrix elements of spin-tensor properties)
C while the AMFI authors used Pauli matrices.
      IF(LABEL(1:4).EQ.'AMFI') PSUM=2.0D0*PSUM
      PROP(ISTATE,JSTATE,IPROP)=PSUM
      IF (ITYPE.EQ.1.OR.ITYPE.EQ.3) THEN
         PROP(JSTATE,ISTATE,IPROP)=PSUM
      ELSE
         PROP(JSTATE,ISTATE,IPROP)=-PSUM
      END IF
*
300   CONTINUE
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module write_orbital_files

use general_data, only: iSpin, nActel, nAsh, nBas, nConf, nDel, nElec3, nFro, nHole1, nIsh, nRs1, nRs2, nRs3, nSym, nTot, nTot2, &
                        stSym
use gas_data, only: iDoGas, nGAS, nGssh
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
private

logical :: write_orb_per_iter = .false.

interface get_typeidx
  module procedure :: RAS_get_typeidx, GAS_get_typeidx
end interface get_typeidx

interface
  function isfreeunit(iseed)
    import :: iwp
    integer(kind=iwp) :: isfreeunit
    integer(kind=iwp), intent(in) :: iseed
  end function
end interface

public :: get_typeidx, OrbFiles, putOrbFile, write_orb_per_iter

contains

subroutine OrbFiles(JOBIPH,IPRLEV)

  use fortran_strings, only: str
  use rasscf_global, only: BName, E2Act, FDiag, header, iOrbTyp, iPt2, iRoot, iToc, lRoots, maxorbout, nRoots, title, Weight
  use PrintLevel, only: USUAL
  use Molcas, only: LenIn, MxOrb, MxRoot, MxSym
  use RASDim, only: MxIter, MxTit
  use Definitions, only: u6

  implicit none
  integer(kind=iwp), intent(in) :: JobIph, iPrlev
  integer(kind=iwp) :: iDisk, iNDType(7,8), iRt, lUVVVec
  real(kind=wp) :: Energy, PotNucDummy
  character(len=128) :: Filename
  character(len=80) :: VecTyp
  real(kind=wp), allocatable :: CMO(:), EDum(:), Ene(:), Occ(:)

  ! This routine is used at normal end of a RASSCF optimization, or
  ! when using the OrbOnly keyword to create orbital files.
  !---------------------------------------------------------------------
  ! NOTE:
  ! PAM 2008: Before this subroutine replaced RASREAD, the orbital energies
  ! were sent as subroutine argument when rasread was called from rasscf.
  ! But the real argument, in rasscf, was FDIAG, which turns out to be a
  ! fixed array FDIAG(mxorb) in rasscf_global.F90.
  ! Rather than checking why that array is there, and how the values are
  ! put there, I simply use the array FDIAG in rasscf_global.F90, when needing
  ! orbital energies to WrVec calls. This may need checking later...
  !--------------------------------------------------------------------*
  !     Read the JobIph file to get the required information           *
  !--------------------------------------------------------------------*
  ! PAM Jan 2014 -- do not take POTNUC from JOBIPH; take it directly
  ! from runfile, where it was stored by seward.
  iDisk = 0
  call iDaFile(JobIph,2,iToc,15,iDisk)
  iDisk = iToc(1)
  call WR_RASSCF_Info(JobIph,2,iDisk,nActEl,iSpin,nSym,stSym,nFro,nIsh,nAsh,nDel,nBas,mxSym,BName,(LenIn+8)*mxOrb,nConf,Header, &
                      144,Title,4*18*mxTit,PotNucDummy,lRoots,nRoots,iRoot,mxRoot,nRs1,nRs2,nRs3,nHole1,nElec3,iPt2,Weight)
  !if (DWSCF%do_DW) then
  !  !! recompute the weight and save on JobIph
  !  !! this is not well tested
  !  call mma_allocate(Ene,mxRoot*mxIter,Label='Ene')
  !  call Get_dArray('Last energies',Ene,lRoots)
  !  call DWSol_wgt(1,Ene,weight)
  !  call mma_deallocate(Ene)
  !  iDisk = iToc(1)
  !  call WR_RASSCF_Info(JobIph,1,iDisk,nActEl,iSpin,nSym,stSym,nFro,nIsh,nAsh,nDel,nBas,mxSym,BName,(LenIn+8)*mxOrb,nConf,Header, &
  !                      144,Title,4*18*mxTit,PotNucDummy,lRoots,nRoots,iRoot,mxRoot,nRs1,nRs2,nRs3,nHole1,nElec3,iPt2,Weight)
  !end if
  ntot = sum(nBas(:nSym))
  ntot2 = sum(nBas(:nSym)**2)
  !--------------------------------------------------------------------*
  !     Allocate CMO array                                             *
  !--------------------------------------------------------------------*
  call mma_allocate(CMO,ntot2,Label='CMO')
  call mma_allocate(Occ,ntot,Label='Occ')
  !--------------------------------------------------------------------*
  !     Make typeindex information                                     *
  !--------------------------------------------------------------------*
  if (.not. iDoGas) then
    IndType(:,:) = get_typeidx(nFro,nIsh,nRs1,nRs2,nRs3,nBas,nDel)
  else
    IndType(:,:) = get_typeidx(nFro,nIsh,nGSSH,nBas,nDel)
  end if
  !--------------------------------------------------------------------*
  !     First, write orbitals to RasOrb:
  ! IORBTYP=1 for 'Average' orbitals... Default!
  ! IORBTYP=2 for 'Canonical' orbitals.
  ! IORBTYP=3 for 'Natural' orbitals... in this case the number of roots need to be specified
  ! IORBTYP=4 for 'Spin' orbitals... in this case the number of roots need to be specified
  !--------------------------------------------------------------------*
  filename = 'RASORB'
  if (iOrbTyp /= 2) then
    iDisk = iToc(2)
    call dDaFile(JobIph,2,CMO,ntot2,iDisk)
    if (IPRLEV >= USUAL) write(u6,'(6X,3A)') 'Average orbitals are written to the ',trim(filename),' file'
    VecTyp = '* RASSCF average (pseudo-natural) orbitals'
    call dDaFile(JobIph,2,Occ,ntot,iDisk)
  else
    iDisk = iToc(9)
    call dDaFile(JobIph,2,CMO,ntot2,iDisk)
    if (IPRLEV >= USUAL) write(u6,'(6X,3A)') 'Canonical orbitals are written to the ',trim(filename),' file'
    VecTyp = '* RASSCF canonical orbitals for CASPT2'
    Occ(:) = One
  end if
  !--------------------------------------------------------------------*
  !     Write  orbitals                                                *
  !--------------------------------------------------------------------*
  LuvvVec = 50
  LuvvVec = isfreeunit(LuvvVec)
  !call WrVec(filename,LuvvVec,'COE',nSym,nBas,nBas,CMO,Occ,FDIAG,iDummy,VecTyp)
  call WrVec_(filename,LuvvVec,'COET',0,nSym,nBas,nBas,CMO,CMO,Occ,Occ,FDIAG,[E2act],indType,VecTyp,0)
  !call WrVec(filename,LuvvVec,'AI',NSYM,NBAS,NBAS,CMO,Occ,FDIAG,IndType,VecTyp)
  call WrVec_(filename,LuvvVec,'AIT',0,nSym,nBas,nBas,CMO,CMO,Occ,Occ,FDIAG,[E2act],indType,VecTyp,0)
  !--------------------------------------------------------------------*
  !     Second, write natural orbitals                                 *
  !--------------------------------------------------------------------*
  call mma_allocate(Ene,mxRoot*mxIter,Label='Ene')
  call Get_dArray('Last energies',Ene,lRoots)

  iDisk = iToc(12)
  do IRT=1,min(MAXORBOUT,LROOTS,999)
    energy = Ene(IRT)
    if (irt < 999) then
      filename = 'RASORB.'//str(IRT)
    else
      filename = 'RASORB.x'
    end if
    call dDaFile(JobIph,2,CMO,ntot2,iDisk)
    call dDaFile(JobIph,2,Occ,ntot,iDisk)
    if (IPRLEV >= USUAL) write(u6,'(6X,A,I3,3A)') 'Natural orbitals for root ',IRT,' are written to the ',trim(filename),' file'
    write(VecTyp,'(A41,I3,A3,f22.12)') '* RASSCF natural orbitals for root number',IRT,' E=',Energy
    !------------------------------------------------------------------*
    !     Write  orbitals                                              *
    !------------------------------------------------------------------*
    LuvvVec = 50
    LuvvVec = isfreeunit(LuvvVec)
    call WrVec(filename,LuvvVec,'COE',nSym,nBas,nBas,CMO,Occ,FDIAG,IndType,VecTyp)
    call WrVec(filename,LuvvVec,'AI',NSYM,NBAS,NBAS,CMO,Occ,FDIAG,IndType,VecTyp)
  end do
  call mma_deallocate(Ene)
  !--------------------------------------------------------------------*
  !     Third, write spin density orbitals                             *
  !--------------------------------------------------------------------*
  iDisk = iToc(14)
  call mma_allocate(EDum,NTot,Label='EDum')
  EDum(:) = Zero
  do IRT=1,min(MAXORBOUT,LROOTS,999)
    if (irt < 999) then
      filename = 'SPDORB.'//str(IRT)
    else
      filename = 'SPDORB.x'
    end if
    call dDaFile(JobIph,2,CMO,ntot2,iDisk)
    call dDaFile(JobIph,2,Occ,ntot,iDisk)
    if (IPRLEV >= USUAL) write(u6,'(6X,A,I3,3A)') 'Spin density orbitals for root ',irt,' are written to the ',trim(filename), &
                                                  ' file'
    write(VecTyp,'(A,I3)') '* RASSCF spin density orbitals for root number',IRT
    !------------------------------------------------------------------*
    !     Write  orbitals                                              *
    !------------------------------------------------------------------*
    LuvvVec = 50
    LuvvVec = isfreeunit(LuvvVec)
    call WrVec(filename,LuvvVec,'CEO',nSym,nBas,nBas,CMO,Occ,EDum,IndType,VecTyp)
    call WrVec(filename,LuvvVec,'AI',NSYM,NBAS,NBAS,CMO,Occ,EDum,IndType,VecTyp)
  end do
  call mma_deallocate(EDum)
  !--------------------------------------------------------------------*
  !     Normal Exit                                                    *
  !--------------------------------------------------------------------*
  call mma_deallocate(CMO)
  call mma_deallocate(Occ)

  return

end subroutine

function RAS_get_typeidx(nFro,nIsh,nRs1,nRs2,nRs3,nBas,nDel) result(typeidx)

  integer(kind=iwp) :: typeidx(7,8)
  integer(kind=iwp), intent(in) :: nFro(:), nIsh(:), nRs1(:), nRs2(:), nRs3(:), nBas(:), nDel(:)

  typeidx(1,:nSym) = nFro(:nSym)
  typeidx(2,:nSym) = nIsh(:nSym)
  typeidx(3,:nSym) = nRS1(:nSym)
  typeidx(4,:nSym) = nRS2(:nSym)
  typeidx(5,:nSym) = nRS3(:nSym)
  typeidx(7,:nSym) = nDel(:nSym)

  typeidx(6,:nSym) = 0
  typeidx(6,:nSym) = nBas(:nSym)-sum(typeidx(:,:nSym),dim=1)

end function RAS_get_typeidx

function GAS_get_typeidx(nFro,nIsh,nGSSH,nBas,nDel) result(typeidx)

  integer(kind=iwp) :: typeidx(7,8)
  integer(kind=iwp), intent(in) :: nFro(:), nIsh(:), nGSSH(:,:), nBas(:), nDel(:)

  typeidx(1,:nSym) = nFro(:nSym)
  typeidx(2,:nSym) = nIsh(:nSym)
  typeidx(3,:nSym) = 0
  typeidx(4,:nSym) = sum(nGssh(1:nGAS,:nSym),dim=1)
  typeidx(5,:nSym) = 0
  typeidx(7,:nSym) = nDel(:nSym)

  typeidx(6,:nSym) = 0
  typeidx(6,:nSym) = nBas(:nSym)-sum(typeidx(:,:nSym),dim=1)

end function GAS_get_typeidx

subroutine putOrbFile(CMO,orbital_E,iDoGAS)

  real(kind=wp), intent(in) :: CMO(:), orbital_E(:)
  logical(kind=iwp), intent(in) :: iDoGAS
  integer(kind=iwp) :: file_id, typeidx(7,8)
  real(kind=wp), allocatable :: occ_number(:)
  character(len=*), parameter :: filename = 'ORTHORB', orbfile_title = 'Orbitals after Orthonormalization.'
  integer(kind=iwp), parameter :: arbitrary_magic_number = 50

  file_id = isfreeunit(arbitrary_magic_number)
  if (.not. iDoGas) then
    typeidx = get_typeidx(nFro,nIsh,nRs1,nRs2,nRs3,nBas,nDel)

  else
    typeidx = get_typeidx(nFro,nIsh,nGSSH,nBas,nDel)
  end if

  ! TODO(Oskar): Implement proper occupation number reading.
  call mma_allocate(occ_number,nTot)
  occ_number(:) = One
  call WrVec(filename,file_id,'COIE',nSym,nBas,nBas,CMO,occ_number,orbital_E,typeidx,orbfile_title)
  call mma_deallocate(occ_number)

end subroutine putOrbFile

end module write_orbital_files

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_CALCINT_1(ISHLAB)
!
! Purpose: calculate qualified integral columns from
!          shell pair distribution (**|ISHLA ISHLB).
!
! Version 1: store full shell quadruple.

use Index_Functions, only: nTri_Elem
use Cholesky, only: iiBstR, iiBstRSh, IndRed, INF_IN2, INF_INT, iOff_Col, iOffQ, IPRINT, iQuAB, iSP2F, nBstSh, LuPri, LuSel, &
                    nnBstR, nnBstRSh, nnShl, nQual, nSym, TINTEG
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ISHLAB
integer(kind=iwp) :: IAB, IADR, ICD, IOPT, ISHLA, ISHLB, ISHLC, ISHLCD, ISHLD, ISYM, JAB, JCD, JCD0, JCDS, KAB, KOFF, KOFF1, &
                     KOFF2, L4SH, L4SHMX, LCOL, LINT, LTOT, MAXCD, NAB(8), NUMAB, NUMCD
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: MEM_END, MEM_START, LEAK
#endif
real(kind=wp) :: C1, C2, PCT, W1, W2, XSKIP, XXSHL
logical(kind=iwp) :: DOINTS
real(kind=wp), allocatable :: Int4Sh(:), IntCol(:)
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_MCA_CALCINT_1'

#ifdef _DEBUGPRINT_
call mma_maxDBLE(MEM_START)
#endif

! Initializations.
! ----------------

call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)

NAB(1) = 0 ! dummy initialization
NAB(1:NSYM) = NQUAL(1:NSYM)-IOFFQ(1:NSYM)

IOFF_COL(1) = 0
LCOL = NNBSTR(1,2)*NAB(1)
do ISYM=2,NSYM
  IOFF_COL(ISYM) = LCOL
  LCOL = LCOL+NNBSTR(ISYM,2)*NAB(ISYM)
end do

if (ISHLA == ISHLB) then
  NUMAB = nTri_Elem(NBSTSH(ISHLA))
else
  NUMAB = NBSTSH(ISHLA)*NBSTSH(ISHLB)
end if
MAXCD = 0
do ISHLCD=1,NNSHL
  ISYM = 1
  DOINTS = (NAB(ISYM) > 0) .and. (NNBSTRSH(ISYM,ISHLCD,2) > 0)
  do while ((ISYM < NSYM) .and. (.not. DOINTS))
    ISYM = ISYM+1
    DOINTS = (NAB(ISYM) > 0) .and. (NNBSTRSH(ISYM,ISHLCD,2) > 0)
  end do
  if (DOINTS) then
    call CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.true.)
    if (ISHLC == ISHLD) then
      NUMCD = nTri_Elem(NBSTSH(ISHLC))
    else
      NUMCD = NBSTSH(ISHLC)*NBSTSH(ISHLD)
    end if
    MAXCD = max(MAXCD,NUMCD)
  end if
end do
L4SHMX = MAXCD*NUMAB

XXSHL = real(NNSHL,kind=wp)
XSKIP = Zero

if (IPRINT >= INF_INT) write(LUPRI,*)

! Allocate memory and initialize:
! qualified columns in reduced set,
! max. shell quadruple.
! ---------------------------------

call mma_allocate(Int4Sh,L4SHMX,Label='Int4Sh')
call mma_allocate(IntCol,LCOL,Label='IntCol')
IntCol(:) = Zero

! Set memory used by seward.
! --------------------------

call mma_maxDBLE(LINT)
call XSETMEM_INTS(LINT)

! Loop over shell quadruples.
! ---------------------------

do ISHLCD=1,NNSHL

  ! Set left shell pair index.
  ! --------------------------

  call CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.true.)
  if (ISHLC == ISHLD) then
    NUMCD = nTri_Elem(NBSTSH(ISHLC))
  else
    NUMCD = NBSTSH(ISHLC)*NBSTSH(ISHLD)
  end if

  ! Find out if this shell pair (CD) contributes to
  ! current reduced set.
  ! -----------------------------------------------

  ISYM = 1
  DOINTS = (NAB(ISYM) > 0) .and. (NNBSTRSH(ISYM,ISHLCD,2) > 0)
  do while ((ISYM < NSYM) .and. (.not. DOINTS))
    ISYM = ISYM+1
    DOINTS = (NAB(ISYM) > 0) .and. (NNBSTRSH(ISYM,ISHLCD,2) > 0)
  end do

  if (DOINTS) then

    ! Print message.
    ! --------------

    if (IPRINT >= INF_INT) write(LUPRI,'(A,I5,1X,I5,A,I5,1X,I5,A)') 'Invoking Seward for shell quadruple (',ISHLC,ISHLD,'|',ISHLA, &
                                                                    ISHLB,')'

    ! Calculate integrals.
    ! --------------------

    call CWTIME(C1,W1)
    L4SH = NUMCD*NUMAB
    Int4Sh(1:L4SH) = Zero
    call CHO_MCA_INT_1(ISHLCD,ISHLAB,Int4SH,L4SH,LOCDBG .or. (IPRINT >= 100))
    call CWTIME(C2,W2)
    TINTEG(1,1) = TINTEG(1,1)+C2-C1
    TINTEG(2,1) = TINTEG(2,1)+W2-W1

    ! Extract columns in reduced set.
    ! IAB: index AB within full shell pair.
    ! JAB: index AB within current reduced set.
    ! KAB: index AB within qualifieds.
    ! -----------------------------------------

    do ISYM=1,NSYM
      do KAB=1,NAB(ISYM)

        JAB = IQUAB(IOFFQ(ISYM)+KAB,ISYM)
        IAB = INDRED(INDRED(JAB,2),1)

        do JCD0=1,NNBSTRSH(ISYM,ISHLCD,2)

          JCDS = IIBSTRSH(ISYM,ISHLCD,2)+JCD0
          JCD = IIBSTR(ISYM,2)+JCDS
          ICD = INDRED(INDRED(JCD,2),1)

          KOFF1 = IOFF_COL(ISYM)+NNBSTR(ISYM,2)*(KAB-1)+JCDS
          KOFF2 = NUMCD*(IAB-1)+ICD

          IntCol(KOFF1) = Int4Sh(KOFF2)

        end do

      end do
    end do

  else

    ! Update skip counter.
    ! --------------------

    XSKIP = XSKIP+One

    ! Print message.
    ! --------------

    if (IPRINT >= INF_INT) write(LUPRI,'(A,I5,1X,I5,A,I5,1X,I5,A)') 'NOTICE: skipping shell quadruple    (',ISHLC,ISHLD,'|',ISHLA, &
                                                                    ISHLB,')'

  end if

end do

! Write the columns to disk.
! --------------------------

call CWTIME(C1,W1)
do ISYM=1,NSYM
  LTOT = NNBSTR(ISYM,2)*NAB(ISYM)
  if (LTOT > 0) then
    IOPT = 1
    KOFF = 1+IOFF_COL(ISYM)
    IADR = NNBSTR(ISYM,2)*IOFFQ(ISYM)
    call DDAFILE(LUSEL(ISYM),IOPT,IntCol(KOFF),LTOT,IADR)
  end if
end do
call CWTIME(C2,W2)
TINTEG(1,2) = TINTEG(1,2)+C2-C1
TINTEG(2,2) = TINTEG(2,2)+W2-W1

! Free memory: both memory used by seward and used here.
! ------------------------------------------------------

call XRLSMEM_INTS()
call mma_deallocate(IntCol)
call mma_deallocate(Int4Sh)

! Print skip statistics.
! ----------------------

if (IPRINT >= INF_IN2) then
  PCT = 1.0e2_wp*XSKIP/XXSHL
  write(LUPRI,'(A,F7.2,A)') 'Skipped',PCT,'% of rows (shell pairs) in this distribution'
end if

#ifdef _DEBUGPRINT_
call mma_maxDBLE(MEM_END)
LEAK = MEM_END-MEM_START
if (LEAK /= 0) then
  write(LUPRI,'(//,A,A,I9)') SECNAM,': Memory leak:',LEAK
  call CHO_QUIT('Memory leak detected in '//SECNAM,104)
end if
#endif

end subroutine CHO_MCA_CALCINT_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Module vRys_RW
      Integer MaxRys
      Parameter(MaxRys=9)
      Real*8, Dimension(:), Allocatable :: TMax, ddx, x0
      Real*8, Dimension(:), Allocatable :: HerR2, HerW2, Cff
      Integer, Dimension(:), Allocatable :: Map
      Integer, Dimension(:), Allocatable :: iHerR2, iHerW2
      Integer   iMap(MaxRys), nMap(MaxRys), ix0(MaxRys), nx0(MaxRys),
     &          iCffR(0:6,MaxRys), iCffW(0:6,MaxRys), nMxRys
      End Module vRys_RW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Jonas Bostrom                                          *
!***********************************************************************

subroutine Compute_A_jk_mp2(jVec,kVec,Ajk,fac_ij,fac_kl,nVec,iOpt)
!***********************************************************************
!   Author: J Bostrom                                                  *
!                                                                      *
!   Purpose: Loading A-matrix for mp2 from disk                        *
!                                                                      *
!***********************************************************************

use RI_glob, only: iMP2prpt, LuAVector
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: jVec, kVec, nVec, iOpt
real(kind=wp), intent(out) :: Ajk
real(kind=wp), intent(in) :: Fac_ij, Fac_kl
integer(kind=iwp) :: iAdrA
real(kind=wp) :: Ajk_mp2(1)
character(len=*), parameter :: SECNAM = 'Compute_A_jk_mp2'

if (iMP2prpt == 2) then
  iAdrA = nVec*(kVec-1)+jVec
  call dDaFile(LuAVector(iOpt),2,Ajk_mp2,1,iAdrA)
  Ajk = Ajk_mp2(1)*Fac_kl*Fac_ij
else
  Ajk = Zero
end if

return

end subroutine Compute_A_jk_mp2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SECNE(A,B,C,NAL,NBL,NSIJ,IFT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NAL,NBL),B(NBL,NAL),C(NBL,NAL)
      IF(IFT.EQ.0) THEN
        DO 20 NA=1,NAL
          DO 10 NB=1,NBL
          C(NB,NA)=B(NB,NA)+A(NA,NB)
10        CONTINUE
20      CONTINUE
      ELSE
        DO 40 NA=1,NAL
          DO 30 NB=1,NBL
          C(NB,NA)=B(NB,NA)-A(NA,NB)
30        CONTINUE
40      CONTINUE
      END IF
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NSIJ)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mk_IOFF(IOFF,mSYM,NBASF,ISY12)

use Symmetry_Info, only: MUL
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: mSYM, NBASF(mSym), ISY12
integer(kind=iwp), intent(out) :: IOFF(mSYM)
integer(kind=iwp) :: IOF, ISY1, ISY2, NB1, NB12, NB2

! FIRST SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS OF TDMSCR
IOF = 0
IOFF(:) = 0
do ISY1=1,mSYM
  ISY2 = MUL(ISY1,ISY12)
  if (ISY1 < ISY2) cycle
  IOFF(ISY1) = IOF
  IOFF(ISY2) = IOF
  NB1 = NBASF(ISY1)
  NB2 = NBASF(ISY2)
  NB12 = NB1*NB2
  if (ISY1 == ISY2) NB12 = (NB12+NB1)/2
  IOF = IOF+NB12
end do

end subroutine mk_IOFF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Roland Lindh                                     *
************************************************************************
       Subroutine HFG(mGrid,Rho,nRho,P2_ontop,
     &                nP2_ontop,iSpin,F_xc,
     &                dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
************************************************************************
*                                                                      *
* Object:   Stand-alone Gill96 exchange                                *
*                                                                      *
*      Author:Roland Lindh, Department of Chemical Physics, University *
*             of Lund, SWEDEN. March 2001                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "ksdft.fh"
      Real*8 Rho(nRho,mGrid), dF_dRho(ndF_dRho,mGrid),
     &       P2_ontop(nP2_ontop,mGrid), F_xc(mGrid),
     &       dF_dP2ontop(ndF_dP2ontop,mGrid)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*---- Dirac (Slater) exchange                                          *
*                                                                      *
      Coeff=One*CoefX
      Call DiracX(mGrid,Rho,nRho,iSpin,F_xc,
     &            dF_dRho,ndF_dRho,Coeff,T_X)
*                                                                      *
*---- Gill 96 Exchange Functional                                      *
*                                                                      *
      Coeff=One*CoefX
      Call xG96(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &          Coeff,iSpin,F_xc,T_X)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(P2_ontop)
         Call Unused_real_array(dF_dP2ontop)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      integer function mcheckxy(m1,m2,m3,m4)
      integer m1,m2,m3,m4,int12a,int12b,
     *int34a,int34b
cbs   makes a check, if there is an interaction inbetween cartesian functions
cbs   with m-values m1-m4
      mcheckxy=1
      int12a=m1+m2
      int12b=-m1+m2
      int34a=m3+m4
      int34b=-m3+m4
cbs   lots of checks
      if (iabs(int12a+int34a).eq.1) return
      if (iabs(int12a-int34a).eq.1) return
      if (iabs(int12b+int34b).eq.1) return
      if (iabs(int12b-int34b).eq.1) return
      if (iabs(int12a+int34b).eq.1) return
      if (iabs(int12a-int34b).eq.1) return
      if (iabs(int12b+int34a).eq.1) return
      if (iabs(int12b-int34a).eq.1) return
      mcheckxy=0
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakeWwdHlp1(Ww,W1,dima,dimbe,dimbega)
! this routine does:
! Make Ww(+)((aa)",(bega)") from W1(a",be",b",ga")
! for the case beSGrp=gaSGrp
! N.B. algoritmus nieje prilis vymakany
!
! parameter description
! Ww   - array for Ww+(-) (O)
! W1   - array for W1(a",be",b",ga") (I)
! dimx - dimension of a",ga",bega" (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimbe, dimbega
real(kind=wp), intent(out) :: Ww(dima,dimbega)
real(kind=wp), intent(in) :: W1(dima,dimbe,dima,dimbe)
integer(kind=iwp) :: a, be, bega, ga

bega = 0
do be=1,dimbe
  do ga=1,be
    bega = bega+1
    do a=1,dima
      Ww(a,bega) = W1(a,be,a,ga)
    end do
  end do
end do

return

end subroutine MakeWwdHlp1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRFSBTAB(IFSBTAB)
      IMPLICIT NONE
      INTEGER IFSBTAB(*)
C     INTEGER NFSB,NASPRT,LPOS,ISPART,IFSB
      INTEGER NFSB,NASPRT,     ISPART,IFSB
      INTEGER NDET,ISTA,NHEAD,KPOS
      IF(IFSBTAB(2).NE.73) THEN
        WRITE(6,*)' PRFSBTAB error: Not a Fock Sector Block Table.'
        WRITE(6,*)' Table type code  =',IFSBTAB(2)
        CALL ABEND()
      END IF
      WRITE(6,*)
      WRITE(6,*)'============================================='
      WRITE(6,*)' Fock Sector Table printout'
      WRITE(6,'(a,i9)')'               Table size:',IFSBTAB(1)
      WRITE(6,'(a,i9)')'          Table type code:',IFSBTAB(2)
      WRITE(6,'(a,i9)')' Nr of Fock Sector Blocks:',IFSBTAB(3)
      WRITE(6,'(a,i9)')'      Nr of Subpartitions:',IFSBTAB(4)
      WRITE(6,'(a,i9)')' Total nr of Determinants:',IFSBTAB(5)
      WRITE(6,'(a,i9)')'        Hash Map Capacity:',IFSBTAB(6)
      WRITE(6,'(a,i9)')'        Hash Map 1st word:',IFSBTAB(7)
      WRITE(6,*)
      WRITE(6,*)'FS Block   BlkSiz    Start indx     Substring Types'
      NFSB=IFSBTAB(3)
      NASPRT=IFSBTAB(4)
      NHEAD=7
      KPOS=NHEAD+1
      DO IFSB=1,NFSB
        NDET=IFSBTAB(KPOS+NASPRT)
        ISTA=IFSBTAB(KPOS+NASPRT+1)
        WRITE(6,'(1X,I6,3X,I7,3x,I10,5X,10I4)')
     &   IFSB,NDET,ISTA,(IFSBTAB(KPOS-1+ISPART),ISPART=1,NASPRT)
        KPOS=KPOS+NASPRT+2
      END DO
      WRITE(6,*)'============================================='
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001-2005, Valera Veryazov                             *
!               2020, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine TransTbl(Filename)

! translate basis file names

use Definitions, only: iwp, u6

implicit none
character(len=256), intent(inout) :: Filename
character(len=256) :: DirName, OrigName, Line
integer(kind=iwp) :: i, ia, ib, ileft, irecl, istatus, iunit, LenOrig
integer(kind=iwp), external :: isFreeUnit, StrnLn
logical(kind=iwp) :: is_error, found

iunit = isFreeUnit(20)
ileft = 0
i = StrnLn(FileName)
found = .false.
do while ((.not. found) .and. (i > 1))
  if (FileName(i:i) == '/') then
    ileft = i
    found = .true.
  end if
  i = i-1
end do

if (.not. found) then
  ileft = 0
  i = StrnLn(FileName)
  found = .false.
  do while ((.not. found) .and. (i > 1))
    if (FileName(i:i) == '_') then
      ileft = i
      found = .true.
    end if
    i = i-1
  end do
end if
DirName = Filename(1:ileft)
i = index(Filename,' ')
if (i <= 0) i = len(Filename)+1
OrigName = Filename(ileft+1:i-1)
LenOrig = i-ileft
call molcas_open_ext2(iunit,DirName(1:ileft)//'trans.tbl','sequential','formatted',istatus,.false.,irecl,'unknown',is_error)
!open(iunit,file=DirName(1:ileft)//'trans.tbl',form='formatted',iostat=istatus)
if (istatus /= 0) then
  close(iunit)
  call molcas_open_ext2(iunit,'BASLIB_trans.tbl','sequential','formatted',istatus,.false.,irecl,'unknown',is_error)
  !open(iunit,file='BASLIB_trans.tbl',form='formatted',iostat=istatus)
  if (istatus /= 0) then
    write(u6,*) 'trans.tbl is not found'
    close(iunit)
    return
  end if
end if
do
  read(iunit,'(a)',iostat=istatus) Line
  if (istatus /= 0) exit
  i = index(Line,OrigName(1:LenOrig-1))
  if ((i == 1) .and. (Line(LenOrig:LenOrig) == ' ')) exit
end do
if (istatus == 0) then
  do i=LenOrig+1,len(Line)
    if (Line(i:i) /= ' ') exit
  end do
  ib = i
  ia = index(Line(ib:),' ')
  if (ia == 0) ia = len(Line)+1
  FileName = DirName(1:ileft)//Line(ib:ib+ia-1)
# ifdef _DEBUGPRINT_
  write(u6,*) '*** Basis set was redirected to ',FileName
# endif
end if
close(iunit)

return

end subroutine TransTbl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Jeppe Olsen                                            *
!***********************************************************************

subroutine ADD_STR_GROUP(NSTADD,IOFADD,ISTADD,NSTB,NSTA,ISTRING,IELOF,NELADD,NELTOT)
! Part of assembling strings in individual types to
! super group of strings
!
! Copying strings belonging to a given type to supergroup of strings
!
! Jeppe Olsen, for once improving performance of LUCIA
!
! Input
! =====
! NSTADD : Number of strings to be added
! IOFADD : First string to be added
! ISTADD : Strings to be added
! NSTB   : Number of strings belonging to lower gasspaces
! NSTA   : Number of strings belonging to higher gasspaces
! ISTRING: Supergroup of strings under construction
! IELOF  : Place of first electron to be added
! NELADD : Number of electrons to be added
! NELTOT : Total number of electrons

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NSTADD, IOFADD, ISTADD(*), NSTB, NSTA, IELOF, NELADD, NELTOT
integer(kind=iwp), intent(inout) :: ISTRING(*)
integer(kind=iwp) :: IADD2, IISTR, IOFF0, IOFF1, IOFF2, IOFFX, IOFFY, ISTA, ISTB

!write(u6,*) '  Inside ADD ...'
if (NSTA > 1) then
  do IISTR=1,NSTADD
    ! Address of A(1,IISTR,1)
    ! A(I(after),Igas,I(before))
    IOFFY = (IOFADD-2+IISTR)*NELADD
    IOFF1 = (IISTR-1)*NSTA+1
    IADD2 = NSTADD*NSTA
    IOFF2 = IOFF1-IADD2
    do ISTB=1,NSTB
      ! Address of A(1,IISTR,ISTB)
      !IOFF2 = IOFF1+(ISTB-1)*NSTADD*NSTA
      IOFF2 = IOFF2+IADD2
      IOFFX = IELOF-1+(IOFF2-2)*NELTOT
      do ISTA=1,NSTA
        IOFFX = IOFFX+NELTOT
        ISTRING(IOFFX+1:IOFFX+NELADD) = ISTADD(IOFFY+1:IOFFY+NELADD)
        !ISTRING(IELOF:IELOF+NELADD-1,IOFF2-1+ISTA) = ISTADD(1:NELADD,IOFADD-1+IISTR)
      end do
    end do
  end do
else if (NSTA == 1) then
  ! Address of A(1,IISTR,1)
  ! A(I(after),Igas,I(before))
  do ISTB=1,NSTB
    IOFF0 = (ISTB-1)*NSTADD
    IOFFY = (IOFADD-2)*NELADD
    IOFFX = IELOF-1+(IOFF0-1)*NELTOT
    do IISTR=1,NSTADD
      ! Address of A(1,IISTR,ISTB)
      !IOFF2 = IISTR+IOFF0
      !IOFFX = IELOF-1+(IOFF2-1)*NELTOT
      IOFFX = IOFFX+NELTOT
      IOFFY = IOFFY+NELADD
      ISTRING(IOFFX+1:IOFFX+NELADD) = ISTADD(IOFFY+1:IOFFY+NELADD)
      !ISTRING((IOFF2-1)*NELTOT+IEOLOF:(IOFF2-1)*NELTOT+IEOLOF+NELADD-1) = &
      !  ISTADD((IOFADD-1+IISTR-1)*NELADD+1:(IOFADD+IISTR-1)*NELADD)
      !ISTRING(IELOF:IELOF+NELADD-1,IOFF2) = ISTADD(1:NELADD,IOFADD-1+IISTR)
      !write(u6,*) ' New string from ADD'
      !call IWRTMA(ISTRING(IOFFX+1),1,NELADD,1,NELADD)
      !write(u6,*) ' IOFFX, IOFFY, NELADD',IOFFX,IOFFY,NELADD
    end do
  end do
end if

end subroutine ADD_STR_GROUP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Localisation_globals

use Definitions, only: wp, iwp

implicit none
private

! CMO     : the MO coefficients
! nCMO    : size of CMO
! Occ     : occupancy vector
! Eor     : orbital energy vector
! ipInd   : orbital type info vector
! nSym    : number of Irrep
! nBas    : number of basis function per Irrep
! nOrb    : number of occ orb per irrep
! LuSpool : Unit number of the input
! nOrb2Loc: Number of orbital to localise
!
! BName   : Basis function names
!
! LC_FileOrb: orbital file for Seward to read

#include "Molcas.fh"

integer(kind=iwp) :: nBas(MxSym), nOrb(MxSym), nSym, nCMO, LuSpool, nOrb2Loc(MxSym), nFro(MxSym), nAtoms, nMxIter, nOccInp(MxSym), &
                     nVirInp(MxSym), LocModel, nActa, iWave, MxConstr, nConstr(MxSym)
real(kind=wp) :: Thrs, ThrRot, ThrGrad, ThrDomain(2), ThrPairDomain(3), ThrSel
logical(kind=iwp) :: LocNatOrb, LocCanOrb, Wave, Maximisation, ChoStart, DoCNOs, Silent, Test_Localisation, Analysis, PrintMOs, &
                     Timing, AnaAtom, EvalER, Order, LocPAO, AnaPAO, AnaPAO_Save, DoDomain, AnaDomain, Skip !, LocVir
character(len=512) :: LC_FileOrb
character(len=3) :: AnaNrm
integer(kind=iwp), allocatable :: Ind(:)
character(len=LenIn8), allocatable :: BName(:)
character(len=LenIn), allocatable :: NamAct(:)
real(kind=wp), allocatable :: CMO(:), EOrb(:), MOrig(:), Occ(:)

public :: AnaAtom, AnaDomain, Analysis, AnaNrm, AnaPAO, AnaPAO_Save, BName, ChoStart, CMO, DoCNOs, DoDomain, EOrb, EvalER, Ind, &
          iWave, LC_FileOrb, LocCanOrb, LocModel, LocNatOrb, LocPAO, LuSpool, Maximisation, MOrig, MxConstr, nActa, NamAct, &
          nAtoms, nBas, nCMO, nConstr, nFro, nMxIter, nOccInp, nOrb, nOrb2Loc, nSym, nVirInp, Occ, Order, PrintMOs, Silent, Skip, &
          Test_Localisation, ThrDomain, ThrGrad, ThrPairDomain, ThrRot, Thrs, ThrSel, Timing, Wave

end module Localisation_globals

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Lu2Lu(Filename,LuInput)

use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: FileName
integer(kind=iwp), intent(in) :: LuInput
#include "warnings.h"
integer(kind=iwp) :: istatus, LuSpool2
character(len=180) :: Line
logical(kind=iwp) :: Exists
integer(kind=iwp), external :: IsFreeUnit

call f_inquire(Filename,Exists)
if (.not. Exists) then
  write(u6,*) 'SuperMac: Missing ',Filename
  call Finish(_RC_INTERNAL_ERROR_)
end if

LuSpool2 = 77
LuSpool2 = IsFreeUnit(LuSpool2)
call Molcas_Open(LuSpool2,Filename)

do
  read(LuSpool2,'(A)',iostat=istatus) Line
  if (istatus < 0) exit
  write(LuInput,'(A)') Line
end do

close(LuSpool2)

return

end subroutine Lu2Lu

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GSBBD2A_LUCIA(   RHO2,  RHO2S,  RHO2A,  NACOB,  ISCSM,
     &                           ISCTP,  ICCSM,  ICCTP,   IGRP,   NROW,
     &                            NGAS,   ISEL,   ICEL,     SB,     CB,
     &                           ADSXA, SXSTST, STSTSX, SXDXSX,MXPNGAS,
     &                          NOBPTS, IOBPTS,   MAXI,   MAXK,   SSCR,
*
     &                            CSCR,     I1,   XI1S,     I2,   XI2S,
     &                               X,  NSMOB,  NSMST,  NSMSX, MXPOBS,
     &                          SCLFAC,  IPACK)
*
* SUBROUTINE GSBBD2A_LUCIA --> 37
*
*
* Contributions to two-electron density matrix from column excitations
*
* GAS version, '96 , Jeppe Olsen
*
* =====
* Input
* =====
* RHO2  : two body density matrix to be updated
* NACOB : Number of active orbitals
* ISCSM,ISCTP : Symmetry and type of sigma columns
* ICCSM,ICCTP : Symmetry and type of C     columns
* IGRP : String group of columns
* NROW : Number of rows in S and C block
* NGAS : Number of active spaces
* ISEL : Number of electrons per AS for S block
* ICEL : Number of electrons per AS for C block
* CB   : Input C block
* ADASX : sym of a+, a => sym of a+a
* ADSXA : sym of a+, a+a => sym of a
* SXSTST : Sym of sx,!st> => sym of sx !st>
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
* MXPNGAS : Max number of AS spaces ( program parameter )
* NOBPTS  : Number of orbitals per type and symmetry
* IOBPTS : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* NSMOB,NSMST,NSMSX,NSMDX : Number of symmetries of orbitals,strings,
*       single excitations, double excitations
* MAXI   : Largest Number of ' spectator strings 'treated simultaneously
* MAXK   : Largest number of inner resolution strings treated at simult.
* IPACK  : Should we pack the density?
*
* ======
* Output
* ======
* RHO2, RHO2S, RHO2A : Updated density block
*
* =======
* Scratch
* =======
*
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S, I2,XI2S : For holding creations/annihilations
*              type and symmetry
*
* Jeppe Olsen, Fall of 96
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "para_info.fh"
*. General input
      INTEGER ADSXA(MXPOBS,2*MXPOBS),SXSTST(NSMSX,NSMST),
     &        STSTSX(NSMST,NSMST), SXDXSX(2*MXPOBS,4*MXPOBS)
      INTEGER NOBPTS(MXPNGAS,*), IOBPTS(MXPNGAS,*)
      LOGICAL IPACK
*.Input
      INTEGER ISEL(NGAS),ICEL(NGAS)
      DIMENSION CB(*),SB(*),X(*)
*.Output
      DIMENSION RHO2(*),RHO2S(*),RHO2A(*)
*.Scatch
      DIMENSION SSCR(*),CSCR(*)
      DIMENSION I1(MAXK,*),XI1S(MAXK,*),I2(MAXK,*),XI2S(MAXK,*)
*.Local arrays
      DIMENSION ITP(256),JTP(256),KTP(256),LTP(256)
C     INTEGER IKBT(3,8),IKSMBT(2,8),JLBT(3,8),JLSMBT(2,8)
      REAL*8, PARAMETER :: ZERO = 0.0D0
*

      NTEST = 000
      IF(NTEST.GE.1000) THEN
        WRITE(6,*)
        WRITE(6,*) ' =================='
        WRITE(6,*) ' GSBBD2A in action '
        WRITE(6,*) ' =================='
        WRITE(6,*)
        WRITE(6,*) ' Occupation of active left strings '
        CALL IWRTMA(ISEL,1,NGAS,1,NGAS)
        WRITE(6,*) ' Occupation of active Right strings '
        CALL IWRTMA(ICEL,1,NGAS,1,NGAS)
      END IF
*
      IFRST = 1
      JFRST = 1
*
CSVC: determine optimum number of partions as the lowest multiple of
C     NPROCS that satisfies a block size smaller than MAXI:
      NPART=0
      DO
        NPART=NPART+NPROCS
        NPARTSZ=MAX(NROW-1,0)/NPART+1
        IF (NPARTSZ.LE.MAXI) EXIT
      END DO
*
* Type of single excitations that connects the two column strings
      CALL DXTYP_GAS(    NDXTP,      ITP,      JTP,      KTP,      LTP,
     &                    NGAS,     ISEL,     ICEL)
*.Symmetry of Double excitation that connects IBSM and JBSM
*. For general use : STSTSX => STSTDX
      IDXSM = STSTSX(ISCSM,ICCSM)
      IF(IDXSM.EQ.0) GOTO 2001
      IF(NTEST.GE.1000)
     &WRITE(6,*) ' ISCSM,ICCSM ', ISCSM,ICCSM
      DO 2000 IDXTP =  1, NDXTP
        ITYP = ITP(IDXTP)
        JTYP = JTP(IDXTP)
        KTYP = KTP(IDXTP)
        LTYP = LTP(IDXTP)
        IF(NTEST.GE.1000)
     &  write(6,*) ' ITYP JTYP KTYP LTYP ', ITYP,JTYP,KTYP,LTYP
        DO 1950 IKOBSM = 1, NSMOB
          JLOBSM = SXDXSX(IKOBSM,IDXSM)
          IF(JLOBSM.EQ.0) GOTO 1950
*. types + symmetries defined => K strings are defined
          KFRST = 1
*. Loop over of symmetry of i orbitals
          DO 1940 ISM = 1, NSMOB
          KSM = ADSXA(ISM,IKOBSM)
          NI = NOBPTS(ITYP,ISM)
          NK = NOBPTS(KTYP,KSM)
          IF(NI.EQ.0.OR.NK.EQ.0) GOTO 1940
*. Loop over batches of j orbitals
          DO 1930 JSM = 1, NSMOB
          LSM = ADSXA(JSM,JLOBSM)
          NJ = NOBPTS(JTYP,JSM)
          NL = NOBPTS(LTYP,LSM)
          IF(NJ.EQ.0.OR.NL.EQ.0) GOTO 1930
*
          IOFF = IOBPTS(ITYP,ISM)
          JOFF = IOBPTS(JTYP,JSM)
          KOFF = IOBPTS(KTYP,KSM)
          LOFF = IOBPTS(LTYP,LSM)
*
          IF(IOFF.LT.KOFF) GOTO 1930
          IF(JOFF.LT.LOFF) GOTO 1930
*
*
* =========================================================================
*                    Use N-2 projection method
* =========================================================================
*
              IFIRST = 1
*. Loop over batches of I strings
              CALL SETVEC(X,ZERO,NI*NJ*NK*NL)
              DO 1801 IIPART = 1+MYRANK, NPART, NPROCS
                IBOT = 1+(IIPART-1)*NPARTSZ
                ITOP = MIN(IBOT+NPARTSZ-1,NROW)
                NIBTC = ITOP-IBOT+1
                IF (NIBTC.LE.0) EXIT
*.Loop over batches of intermediate strings
                KBOT = 1- MAXK
                KTOP = 0
 1800           CONTINUE
                  KBOT = KBOT + MAXK
                  KTOP = KTOP + MAXK
*
* =========================================================
*
*. obtain cb(KB,IA,jl) = sum(JB)<KB!a lb a jb !IB>C(IA,JB)
*
* =========================================================
*
                  IONE = 1
                  JLBOFF = 1
                  IF(JSM.EQ.LSM.AND.JTYP.EQ.LTYP) THEN
                    NJL = NJ*(NJ+1)/2
                    JLSM = 1
                  ELSE
                    NJL = NJ * NL
                    JLSM = 0
                  END IF
*. Obtain all double excitations from this group of K strings
                  II12 = 1
                  K12 = 1
                  IONE = 1
                  CALL ADADST_GAS(  IONE,   JSM,  JTYP,    NJ,  IONE,
     &                               LSM,  LTYP,    NL, ICCTP, ICCSM,
     &                              IGRP,  KBOT,  KTOP,    I1,  XI1S,
     &                              MAXK, NKBTC,  KEND, JFRST, KFRST,
     &                              II12,   K12,SCLFAC)
*
                  JFRST = 0
                  KFRST = 0
*
                  IF(NKBTC.EQ.0) GOTO 1930
*. Loop over jl in TS classes
                  J = 0
                  L = 1
*
                  DO  IJL = 1, NJL
                    CALL NXTIJ(      J,      L,     NJ,     NL,   JLSM,
     &                           NONEW)
                    I1JL = (L-1)*NJ+J
*. JAN28
                    IF(JLSM.NE.0) THEN
                      IJLE = J*(J-1)/2+L
                    ELSE
                      IJLE = IJL
                    END IF
*. JAN28
*.CB(IA,KB,jl) = +/-C(IA,a+la+jIA)
C                   JLOFF = (JLBOFF-1+IJL-1)*NKBTC*NIBTC+1
                    JLOFF = (JLBOFF-1+IJLE-1)*NKBTC*NIBTC+1
                    IF(JLSM.EQ.1.AND.J.EQ.L) THEN
*. a+j a+j gives trivially zero
                      CALL SETVEC(CSCR(JLOFF),ZERO,NKBTC*NIBTC)
                    ELSE
                      CALL MATCG(    CB,CSCR(JLOFF),NROW,NIBTC,IBOT,
     &                            NKBTC,I1(1,I1JL),XI1S(1,I1JL))
                    END IF
                  END DO
*
*
* =========================================================
*
*. obtain sb(KB,IA,ik) = sum(IB)<KB!a kb a ib !IB>S(IA,IB)
*
* =========================================================
*
                  IONE = 1
                  IKBOFF = 1
                  IF(ISM.EQ.KSM.AND.ITYP.EQ.KTYP) THEN
                    NIK = NI*(NI+1)/2
                    IKSM = 1
                  ELSE
                    NIK = NI * NK
                    IKSM = 0
                  END IF
*. Obtain all double excitations from this group of K strings
                  II12 = 2
                  K12 = 1
                  IONE = 1
                  IF(IFRST.EQ.1) KFRST = 1
                  ONE = 1.0D0
                  CALL ADADST_GAS(  IONE,   ISM,  ITYP,    NI,  IONE,
     &                               KSM,  KTYP,    NK, ISCTP, ISCSM,
     &                              IGRP,  KBOT,  KTOP,    I1,  XI1S,
     &                              MAXK, NKBTC,  KEND, IFRST, KFRST,
     &                              II12,   K12,ONE   )
*
                  IFRST = 0
                  KFRST = 0
*
                  IF(NKBTC.EQ.0) GOTO 1930
*. Loop over jl in TS classes
                  I = 0
                  K = 1
*
                  DO  IIK = 1, NIK
                    CALL NXTIJ(      I,      K,     NI,     NK,   IKSM,
     &                           NONEW)
                    I1IK = (K-1)*NI+I
*. JAN28
                    IF(IKSM.NE.0) THEN
                      IIKE = I*(I-1)/2+K
                    ELSE
                      IIKE = IIK
                    END IF
*. JAN28
*.SB(IA,KB,ik) = +/-S(IA,a+ka+iIA)
C                   IKOFF = (IKBOFF-1+IIK-1)*NKBTC*NIBTC+1
                    IKOFF = (IKBOFF-1+IIKE-1)*NKBTC*NIBTC+1
                    IF(IKSM.EQ.1.AND.I.EQ.K) THEN
*. a+j a+j gives trivially zero
                      CALL SETVEC(SSCR(IKOFF),ZERO,NKBTC*NIBTC)
                    ELSE
                      CALL MATCG(    SB,SSCR(IKOFF),NROW,NIBTC,IBOT,
     &                            NKBTC,I1(1,I1IK),XI1S(1,I1IK))
                    END IF
                  END DO
*
*
* =================================================================
*
* RHO2C(ik,jl)  = RHO2C(ik,jl) - sum(Ia,Kb)SB(Ia,Kb,ik)*CB(Ia,Kb,jl)
*
* =================================================================
*
* The minus ??
*
* Well, the density matrices are constructed as

* <I!a+i a+k aj al!> = -sum(K) <I!a+ia+k!K><J!aj al!K>, and
* the latter matrices are the ones we are constructing
*
              IOFF = IOBPTS(ITYP,ISM)
              JOFF = IOBPTS(JTYP,JSM)
              KOFF = IOBPTS(KTYP,KSM)
              LOFF = IOBPTS(LTYP,LSM)
              NTESTO = NTEST
C?            IF(IOFF.EQ.3.AND.JOFF.EQ.3.AND.KOFF.EQ.4.AND.LOFF.EQ.4)
C?   &            NTEST = 5000
                  LDUMMY = NKBTC*NIBTC
                  IF(NTEST.GE.2000) THEN
                    WRITE(6,*) ' CSCR matrix '
                    CALL WRTMAT(CSCR,LDUMMY,NJL,LDUMMY,NJL)
                    WRITE(6,*) ' SSCR matrix '
                    CALL WRTMAT(SSCR,LDUMMY,NIK,LDUMMY,NIK)
                  END IF

                  IF(IFIRST.EQ.1) THEN
                    FACTOR = 0.0D0
                  ELSE
                    FACTOR = 1.0D0
                  END IF
C                 MATML7(C,A,B,NCROW,NCCOL,NAROW,NACOL,
C    &                  NBROW,NBCOL,FACTORC,FACTORAB,ITRNSP )
                  LDUMMY = NKBTC*NIBTC
                  ONEM = -1.0D0
                  CALL MATML7(      X,   SSCR,   CSCR,    NIK,    NJL,
     &                         LDUMMY,    NIK, LDUMMY,    NJL, FACTOR,
     &                           ONEM,      1)
                  IFIRST = 0
                  IF(NTEST.GE.2000) THEN
      WRITE(6,*) ' Updated X matrix IK,JL,IK,JL',NIK,NJL,NIK,NJL
                    CALL WRTMAT(X,NIK,NJL,NIK,NJL)
                  END IF

*
                IF(KEND.EQ.0) GOTO 1800
*. End of loop over partitionings of resolution strings
 1801         CONTINUE
*. Rho2(ik,jl) has been constructed for ik,jl belonging to
*. Scatter out to density matrix
              IOFF = IOBPTS(ITYP,ISM)
              JOFF = IOBPTS(JTYP,JSM)
              KOFF = IOBPTS(KTYP,KSM)
              LOFF = IOBPTS(LTYP,LSM)
!      write(*,*)"I, J, K, L offsets & IPACK :",IOFF,JOFF,KOFF,LOFF,Ipack
              CALL ADTOR2(    RHO2,   RHO2S,   RHO2A,       X,       1,
     &                          NI,    IOFF,      NJ,    JOFF,      NK,
     &                        KOFF,      NL,    LOFF,   NACOB,   IPACK)
C                  ADTOR2(RHO2,RHO2T,ITYPE,
C    &                  NI,IOFF,NJ,JOFF,NK,KOFF,NL,LOFF,NORB)

!              write(6,*) ' updated density matrix A'," norb = 4 ",norb
!         write(6,*) ' offset ',"IOFF,JOFF,KOFF,LOFF",IOFF,JOFF,KOFF,LOFF
!              call prsym(rho2s,NORB*(NORB+1)/2)

 1930       CONTINUE
 1940     CONTINUE
 1950   CONTINUE
 2000 CONTINUE
 2001 CONTINUE
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(SXSTST)
        CALL Unused_integer_array(I2)
        CALL Unused_real_array(XI2S)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Compute_AuxVec(ipVk,ipUk,ipZpk,myProc,nProc)
      use pso_stuff
      use Basis_Info, only: nBas, nBas_Aux
      use Temporary_Parameters, only: force_out_of_core
      use RICD_Info, only: Do_RI, Cholesky
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
      Integer ipVk(nProc), ipUk(nProc), ipZpk(nProc)
#include "WrkSpc.fh"
#include "real.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "etwas.fh"
#include "exterm.fh"
#include "chomp2g_alaska.fh"
      Logical Timings, DoExchange, DoCAS, Estimate, Update
      Integer nIOrb(0:7),nV_l(0:7),nV_t(0:7)
      Integer nU_l(0:7), nU_t(0:7)
      Integer ipTxy(0:7,0:7,2),ipDLT2,jp_V_k
      COMMON    /CHOTIME /timings
      Character*8 Method
*                                                                      *
************************************************************************
*                                                                      *
      DoExchange=Exfac.ne.Zero
*
      nV_ls=0
      Do i=0,nIrrep-1
         nV_l(i) = NumCho(i+1) ! local # of vecs in parallel run
         nV_ls=nV_ls+nV_l(i)
         nV_t(i) = nV_l(i)
      End Do
      Call GAIGOP(nV_t,nIrrep,'+') ! total # of vecs
      If (nV_t(0).eq.0) Then
         Call WarningMessage(2,
     &          'Compute_AuxVec: no total symmetric vectors!!')
         Call Abend()
      EndIf
*
      If(iMp2prpt.eq.2) Then
          nU_ls=0
          Do i=0,nIrrep-1
             nU_l(i) = NumCho(i+1) ! local # of vecs in parallel run
             nU_ls=nU_ls+nU_l(i)
             nU_t(i) = nU_l(i)
          End Do
          Call GAIGOP(nU_t,nIrrep,'+') ! total # of vecs
          If (nU_t(0).eq.0) Then
             Call WarningMessage(2,
     &            'Compute_AuxVec: no total symmetric vectors!!')
             Call Abend()
          EndIf
      End If
*
      NChVMx=0
      nQMax=0
      nBSQ=0
      Do i=0,nIrrep-1
         nBSQ=nBSQ+nBas(i)**2
         NChVMx= Max(NChVMx,nV_t(i))
         nQMax = Max(nQMax,nBas_Aux(i))
         nChOrb(i,1)=0
         nChOrb(i,2)=0
      End Do
      nQvMax=nQMax*NChVMx
      Call Allocate_Work(ipScr,nQMax)
      If(iMp2prpt.eq.2) Then
         NChUMx=0
         Do i=0,nIrrep-1
            NChUMx= Max(NChVMx,nU_t(i))
         End Do
         nQuMax=nQMax*NChUMx
      End If
*
      DoCAS=lPSO
*
      If (nV_ls .gt. 1) Then ! can be = 0 in a parallel run
*
         jp_V_k = ipVk(myProc)
         jp_Z_p_k = ipZpk(myProc)
         jp_U_k = 1
         If(iMp2prpt .eq. 2) Then
            jp_U_k = ipUk(myProc)
         End If
************************************************************************
*                                                                      *
*        Get (and transform) the density matrices                      *
*                                                                      *
************************************************************************
*
         Timings=.False.
*         Timings=.True.
*
         Call Get_iArray('nIsh',nIOrb,nIrrep)

         If(iMp2prpt .ne. 2) Then
            If (DoCAS.and.lSA) Then
               nSA=5
               Call GetMem('Dens','Allo','Real',ipDMLT(1),nDens*nSA)
               Do i=2,nSA
                 ipDMLT(i)=ipDMLT(i-1)+nDens
               End Do
               call dcopy_(nDens*nSA,D0,1,Work(ipDMLT(1)),1)
*Refold some density matrices
               ij = -1
               Do iIrrep = 0, nIrrep-1
                 Do iBas = 1, nBas(iIrrep)
                   Do jBas = 1, iBas-1
                     ij = ij + 1
                     Work(ipDMLT(1)+ij)=Two*Work(ipDMLT(1)+ij)
                     Work(ipDMLT(3)+ij)=Two*Work(ipDMLT(3)+ij)
                     Work(ipDMLT(5)+ij)=Two*Work(ipDMLT(5)+ij)
                   EndDo
                   ij = ij + 1
                 EndDo
               EndDo
            Else
               Call GetMem('DMLT(1)','Allo','Real',ipDMLT(1),nDens)
               Call Get_D1AO_Var(Work(ipDMLT(1)),nDens)
            EndIf
         Else
            Call GetMem('DMLT(1)','Allo','Real',ipDMLT(1),nDens)
            Call Get_D1AO(Work(ipDMLT(1)),nDens)
         End If
*
         If (nKdens.eq.2) Then
            Call GetMem('DMLT(2)','Allo','Real',ipDMLT(2),nDens)
!           spin-density matrix
            Call Get_D1SAO_Var(Work(ipDMLT(2)),nDens)
            Call daxpy_(nDens,-One,Work(ipDMLT(1)),1,
     &                              Work(ipDMLT(2)),1)
            call dscal_(nDens,-Half,Work(ipDMLT(2)),1) ! beta DMAT
            Call daxpy_(nDens,-One,Work(ipDMLT(2)),1,
     &                             Work(ipDMLT(1)),1) ! alpha DMAT
         ElseIf (nKdens.gt.4 .or. nKdens.lt.1) Then
            Call WarningMessage(2,
     &          'Compute_AuxVec: invalid nKdens!!')
            Call Abend()
         EndIf
         ipDLT2 = 1
         If(iMp2prpt.eq.2) Then
            Call GetMem('DLT2','Allo','Real',ipDLT2,nDens)
            Call Get_D1AO_Var(Work(ipDLT2),nDens)
            Call daxpy_(nDens,-One,Work(ipDMLT(1)),1,Work(ipDLT2),1)
         Else
            ipDLT2 = ip_Dummy
         End If
************************************************************************
*                                                                      *
*     Compute Fr+In+Ac localized orbitals                              *
*       using Cholesky  decomposition for PD matrices                  *
*       using Eigenvalue decomposition for non-PD matrices (SA-CASSCF) *
*                                                                      *
************************************************************************
*         DoExchange=Exfac.ne.Zero
*
         Call Get_cArray('Relax Method',Method,8)
         If (Method.eq.'MCPDFT ' ) exfac=1.0d0
         DoExchange=Exfac.ne.Zero

         If (DoExchange .or. DoCAS) Then
            Call GetMem('ChMOs','Allo','Real',ipChM(1),nCMO*nKdens)
            Do i=2,nKdens
              ipChM(i)=ipChM(i-1)+nCMO
            End Do
            If (lSA) Then
              Call GetMem('TmpDens','Allo','Real',ipTmp,nDens)
            EndIf
*                                                                      *
************************************************************************
*                                                                      *
*          PD matrices
*
            Call GetMem('DSQ','Allo','Real',ipDSQ,nBSQ)
            Do j=1,nKvec
               If (lSA) Then
                 If (j.eq.1) Then
                    call dcopy_(nDens,Work(ipDMLT(1)),1,Work(ipTmp),1)
                 Else If (j.eq.2) Then
                    call dcopy_(nDens,Work(ipDMLT(3)),1,Work(ipTmp),1)
                 EndIf
                 Call UnFold(Work(ipTmp),nDens,Work(ipDSQ),nBSQ,
     &                                      nIrrep,nBas)
               Else
                 Call UnFold(Work(ipDMLT(j)),nDens,Work(ipDSQ),nBSQ,
     &                                      nIrrep,nBas)
               EndIf
*
               ipChMM=ipChM(j)
               iOffDSQ=0
               Do i=0,nIrrep-1
                  Call CD_InCore(Work(ipDSQ+iOffDSQ),nBas(i),
     &                           Work(ipChMM),
     &                           nBas(i),nChOrb(i,j),1.0d-12,irc)
                  ipChMM=ipChMM+nBas(i)**2
                  iOffDSQ = iOffDSQ + nBas(i)**2
               End Do
               If (irc.ne.0) Then
                 Write (6,*)
     &             'Compute_AuxVec: failed to get Cholesky MOs !'
                 Call Abend()
               End If
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*          non-PD matrices
*
            If (lSA) Then
*
               Do i=3,4
*
**    Get the appropriate density matrix
*
                 If (i.eq.3) Then
                   call dcopy_(nDens,Work(ipDMLT(2)),1,Work(ipTmp),1)
                 Else If (i.eq.4) Then
                   call dcopy_(nDens,Work(ipDMLT(4)),1,Work(ipTmp),1)
                 EndIf
*
**    And eigenvalue-decompose it
*
                 ipChMM=ipChM(i)
                 iOffDSQ=0
                 Do isym=0,nIrrep-1
*
                   Call dzero(Work(ipChMM),nBas(isym)**2)
                   call dcopy_(nbas(isym),[One],0,Work(ipChMM),
     &                  nBas(isym)+1)
                   Call NIdiag(Work(ipTmp+iOffDSQ),Work(ipChMM),
     &                  nBas(isym),nBas(isym),0)
*
**   First sort eigenvectors and eigenvalues
*
                   Do j=1,nBas(isym)
                     irun=ipTmp+iOffDSQ+j*(j+1)/2-1
                     Do k=j,nBas(isym)
                       jrun=ipTmp+iOffDSQ+k*(k+1)/2-1
                       If (Work(irun).lt.Work(jrun)) Then
                         tmp=Work(irun)
                         Work(irun)=Work(jrun)
                         Work(jrun)=tmp
                         Do l=0,nBas(isym)-1
                           tmp=Work(ipChMM+(j-1)*nBas(isym)+l)
                           Work(ipChMM+(j-1)*nBas(isym)+l)=
     &                         Work(ipChMM+(k-1)*nBas(isym)+l)
                           Work(ipChMM+(k-1)*nBas(isym)+l)=tmp
                         End Do
                       End If
                     End Do
                   End Do
*
                   Cho_thrs=1.0d-12

                   nChOrb(isym,i)=0
                   Do j=1,nBas(isym)
                     If (Work(ipTmp+iOffDSQ+j*(j+1)/2-1).gt.Cho_thrs)
     &                   Then
                       irun=nChOrb(isym,i)*nBas(isym)
                       jrun=(j-1)*nBas(isym)
                       nChOrb(isym,i)=nChOrb(isym,i)+1
                       tmp=Sqrt(Work(ipTmp+iOffDSQ+j*(j+1)/2-1))
                       Do k=1,nBas(isym)
                         Work(ipChMM+irun)=Work(ipChMM+jrun)*tmp
                         irun=irun+1
                         jrun=jrun+1
                       End Do
                     EndIf
                   End Do
                   npos(isym,i-2)=nChOrb(isym,i)
*
                   Do j=1,nBas(isym)
                     If (-Work(ipTmp+iOffDSQ+j*(j+1)/2-1).gt.Cho_thrs)
     &                  Then
                       irun=nChOrb(isym,i)*nBas(isym)
                       jrun=(j-1)*nBas(isym)
                       nChOrb(isym,i)=nChOrb(isym,i)+1
                       tmp=Sqrt(-Work(ipTmp+iOffDSQ+j*(j+1)/2-1))
                       Do k=1,nBas(isym)
                         Work(ipChMM+irun)=Work(ipChMM+jrun)*tmp
                         irun=irun+1
                         jrun=jrun+1
                       End Do
                     EndIf
                   End Do
*
                   ipChMM=ipChMM+nBas(isym)**2
                   iOffDSQ=iOffDSQ+nBas(isym)*(nBas(isym)+1)/2
                 End Do
*
               End Do
*
** Refold the other DM
*
               ij = -1
               Do iIrrep = 0, nIrrep-1
                 Do iBas = 1, nBas(iIrrep)
                   Do jBas = 1, iBas-1
                     ij = ij + 1
                     Work(ipDMLT(2)+ij)=Two*Work(ipDMLT(2)+ij)
                     Work(ipDMLT(4)+ij)=Two*Work(ipDMLT(4)+ij)
                   EndDo
                   ij = ij + 1
                 EndDo
               EndDo
            EndIf
            Call GetMem('DSQ','Free','Real',ipDSQ,nBSQ)
            If (lSA) Call GetMem('TmpDens','Free','Real',ipTmp,nDens)
         EndIf
************************************************************************
*                                                                      *
*        First contract the RI vectors with the density matrix         *
*                                                                      *
************************************************************************
* --- Pointers to the Cholesky vectors of P2
         mAO=0
         iOff=0
         Do kIrrep=0,nIrrep-1 ! compound symmetry
            iOff2=0
            Do jIrrep=0,nIrrep-1
               iIrrep=iEOR(jIrrep,kIrrep)
               If (iIrrep.lt.jIrrep) Then
                  nnAorb=nASh(iIrrep)*nAsh(jIrrep)
               ElseIf (iIrrep.eq.jIrrep) Then
                  nnAorb=nAsh(iIrrep)*(nAsh(iIrrep)+1)/2
               Else
                  Go To 100
               EndIf
               ipTxy(iIrrep,jIrrep,1) = 1 + iOff2+iOff
               ipTxy(jIrrep,iIrrep,1) = ipTxy(iIrrep,jIrrep,1)
               If (lSA) Then
                 ipTxy(iIrrep,jIrrep,2) = ipTxy(iIrrep,jIrrep,1)+n_Txy
                 ipTxy(jIrrep,iIrrep,2) = ipTxy(iIrrep,jIrrep,2)
               EndIf
               iOff2=iOff2+nnAorb
100            Continue
            End Do
            iOff=iOff+iOff2*nnP(kIrrep)
            mAO=mAO+nBas(kIrrep)*nASh(kIrrep)
         End Do
         Call GetMem('AOrb','Allo','Real',ipAOrb(0,1),mAO*nADens)
*
* --- Reordering of the active MOs :  C(a,v) ---> C(v,a)
         iCount=0
         lCount=0
         Do iIrrep=0,nIrrep-1
            jCount = iCount + nBas(iIrrep)*nIOrb(iIrrep)
            ipAOrb(iIrrep,1) = ipAOrb(0,1) + lCount
            ipAOrb(iIrrep,2) = ipAOrb(iIrrep,1)+mAO
            Do i=1,nASh(iIrrep)
               kOff1 = 1 + jCount + nBas(iIrrep)*(i-1)
               kOff2 = ipAOrb(iIrrep,1) + i - 1
               Call dCopy_(nBas(iIrrep),CMO(kOff1,1),1,
     &                               Work(kOff2),nASh(iIrrep))
               If (lSA) Then
                 kOff2 = ipAOrb(iIrrep,2) + i - 1
                 Call dCopy_(nBas(iIrrep),CMO(kOff1,2),1,
     &                               Work(kOff2),nASh(iIrrep))
               EndIf
            End Do
            iCount = iCount + nBas(iIrrep)**2
            lCount = lCount + nBas(iIrrep)*nASh(iIrrep)
         End Do
*
         If (nKdens.eq.2) Then ! for Coulomb term
            Call daxpy_(nDens,One,Work(ipDMLT(2)),1,
     &                            Work(ipDMLT(1)),1)
         EndIf
*
*  Add the density of the environment in a OFE calculation (Coulomb)
*
         Call OFembed_dmat(Work(ipDMlt(1)),nDens)
*
*         nScreen=10 ! Some default values for the screening parameters
*         dmpK=One
         Estimate=.False.
         Update=.True.
         Call Cho_Get_Grad(irc,nKdens,ipDMlt,ipDLT2,ipChM,
     &                     Txy,n_Txy*nAdens,ipTxy,
     &                     DoExchange,lSA,nChOrb,ipAOrb,nAsh,
     &                     DoCAS,Estimate,Update,V_k(jp_V_k,1),
     &                     U_k(jp_U_k),Z_p_k(jp_Z_p_k,1),nnP,npos,
     &                     nZ_p_k)
*
         If (irc.ne.0) Then
            Call WarningMessage(2,
     &                  'Compute_AuxVec: failed in Cho_Get_Grad !!')
            Call Abend()
         End If
*         Call GetMem('AOrb','Free','Real',ipAOrb(0,1),mAO)
         If (DoCAS .or. DoExchange) Then
            Call GetMem('ChMOs','Free','Real',ipChM(1),nCMO*nKdens)
         EndIf
         If(iMp2prpt.eq.2) Then
            Call Free_Work(ipDLT2)
         End If
*
      End If ! no vectors on this node
*
*     For parallel run: reordering of the V_k(tilde) vector from
*     the "node storage" to the Q-vector storage
*MGD will probably not work for SA-CASSCF
      If (nProc.gt.1)  Call Reord_Vk(ipVk,nProc,myProc,nV_l,nV_t,[1],1,
     &                               V_k)
************************************************************************
*                                                                      *
*     Second step: contract with the Q-vectors to produce V_k          *
*            ~  T                                                      *
*     V = V Q                                                          *
*                                                                      *
************************************************************************
*
      If (Cholesky.and..Not.Do_RI) Then ! to cope with the calls below
         nBas_Aux(0)=nBas_Aux(0)+1
      End If
*
      Call GetMem('Qv','Max','Real',iDum,MemMax)
*
      If (Force_out_of_Core) MemMax=4*(nQvMax)/10
      nQv = Min(MemMax,nQvMax)
      Call GetMem('Qv','Allo','Real',ipQv,nQv)
*
**    Coulomb
*
      Do i=0,nJdens-1
         Call Mult_Vk_Qv_s(V_k(ipVk(1),1+i),nV_t(0),
     &               Work(ipQv),nQv,
     &               Work(ipScr),nQMax,nBas_Aux,nV_t(0),nIrrep,'T')
         call dcopy_(nV_k,Work(ipScr),1,V_k(ipVk(1),1+i),1)
      End Do
*
**    MP2
*
      If(iMp2prpt.eq.2) Then
         Call Mult_Vk_Qv_s(U_k(ipUk(1)),nU_t(0),Work(ipQv),nQv,
     &                     Work(ipScr),nQMax,nBas_Aux,nU_t(0),nIrrep,
     &                     'T')
         call dcopy_(nV_k,Work(ipScr),1,U_k(ipUk(1)),1)
      End If
*
**    Active term
*
      If (DoCAS) Then ! reorder Zp_k

         Call GetMem('Zv','Allo','Real',ipZv,nZ_p_k)
*
         Do iAvec=1,nAvec
*MGD wrong
           If (nProc.gt.1)  Call Reord_Vk(ipZpk(1),nProc,myProc,
     &                    nV_l,nV_t,nnP,nIrrep,Z_p_k)
*
           Call Mult_Zp_Qv_s(Z_p_k(ipZpk(1),iAvec),nZ_p_k,
     &                       Work(ipQv),nQv,Work(ipZv),nZ_p_k,nV_t,nnP,
     &                       nBas_Aux,nIrrep,'T')
*
          call dcopy_(nZ_p_k,Work(ipZv),1,Z_p_k(ipZpk(1),iAvec),1)
         End Do
         Call GetMem('Zv','Free','Real',ipZv,nZ_p_k)
      EndIf
*
      Call Free_Work(ipQv)
      Call Free_Work(ipScr)
*
**    Exchange
*
      If (DoExchange) Then
         DoCholExch = .true.
         Do iSO=1,nKvec
            Call Mult_RijK_QKL(iSO,nBas_aux,nIrrep)
         End Do
         If(iMp2prpt.eq.2) Then
            Call Mult_with_Q_MP2(nBas_aux,nBas,nIrrep)
         End If
      End If
      If (Cholesky.and..Not.Do_RI) nBas_Aux(0)=nBas_Aux(0)-1
*
      Return
      End
*                                                                      *
************************************************************************
************************************************************************
************************************************************************
      Subroutine OFembed_dmat(Dens,nDens)

      Implicit Real*8 (a-h,o-z)
      Real*8 Dens(nDens)
#include "WrkSpc.fh"
      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
      Character*16 NamRfil

      If (.not.Do_OFemb) Return
*
      Call Get_NameRun(NamRfil) ! save the old RUNFILE name
      Call NameRun('AUXRFIL')   ! switch RUNFILE name

      Call GetMem('Dens_OFE','Allo','Real',ipD_var,nDens)
      Call get_dArray('D1aoVar',Work(ipD_var),nDens)
      Call daxpy_(nDens,One,Work(ipD_var),1,Dens,1)
      Call GetMem('Dens_OFE','Free','Real',ipD_var,nDens)
*
      Call NameRun(NamRfil)   ! switch back to old RUNFILE name
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Do_PI2(D1mo,nd1mo,TabMO,mAO,mGrid,nMOs,P2_ontop,nP2_ontop,RhoI,RhoA,mRho,P2MOCube,MOs,MOx,MOy,MOz)
!***********************************************************************
!                                                                      *
! Object: Calculation P2 ontop density and its derivatives             *
!                                                                      *
! Called from: Do_batch                                                *
!                                                                      *
!    INPUT:                                                            *
!   D1mo     = one-body density matrix in MO basis                     *
!   nd1mo    = size of D1mo                                            *
!   TabMO    = MO values computed on grid                              *
!   nMOs     = number of MO basis                                      *
!   mAO      = number of derivatives of AO...                          *
!   mGrid    = number of grid points                                   *
!                                                                      *
!***********************************************************************

use nq_Info, only: Functional_type, GGA_type, iOff_Ash, iOff_Bas, iOff_BasAct, mBas, mIrrep, nAsh, NASHT, nFro, nIsh
use Index_Functions, only: iTri
use Constants, only: Zero, Two, Four
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nd1mo, mAO, mGrid, nMOs, nP2_ontop, mRho
real(kind=wp), intent(in) :: D1mo(nd1mo), TabMO(mAO,mGrid,nMOs), P2MOCube(NASHT,mGrid), MOs(NASHT,mGrid), MOx(NASHT,mGrid), &
                             MOy(NASHT,mGrid), MOz(NASHT,mGrid)
real(kind=wp), intent(out) :: P2_ontop(nP2_ontop,mGrid)
real(kind=wp), intent(inout) :: RhoI(mRho,mGrid), RhoA(mRho,mGrid)
integer(kind=iwp) :: i, i_, iGrid, iIrrep, IOff, jOffA_, jOffB_, k, k_, kIrrep, kl, l, l_, lIrrep, NumAsh, NumIsh
real(kind=r8), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
if (nP2_ontop == 4) then
  if ((mAO /= 4) .or. (mRho /= 4)) then
    call WarningMessage(2,' Something is wrong in dim. in p2cs')
    call Abend()
  end if
else if (nP2_ontop == 6) then
  if ((mAO /= 10) .or. (mRho /= 6)) then
    call WarningMessage(2,' Something is wrong in dim. in p2cs')
    call Abend()
  end if
end if

P2_ontop(:,:) = Zero
jOffA_ = 0
jOffB_ = 0
do iIrrep=0,mIrrep-1
  iOff_Ash(iIrrep) = jOffA_
  iOff_Bas(iIrrep) = jOffB_
  iOff_BasAct(iIrrep) = jOffB_+nIsh(iIrrep)+nFro(iIrrep)
  jOffA_ = jOffA_+nAsh(iIrrep)
  jOffB_ = jOffB_+mBas(iIrrep)
end do
!***********************************************************************
!                                                                      *
!   P(1,...) - P_2                                                     *
!   P(2,...), P(3,...), P(4,...) - grad P_2                            *
!   Not implemented:                                                   *
!   P(5,...) - grad^2 P_2                                              *
!   P(6,...) - additional part grad^2 P_2 for CS functional            *
!   P(5) and P(6) removed                                              *
!***********************************************************************

!***********************************************************************
! Inactive part:                                                       *
!***********************************************************************
NumIsh = 0
NumAsh = 0
do iIrrep=0,mIrrep-1
  NumIsh = NumIsh+nISh(iIrrep)
  NumAsh = NumAsh+nAsh(iIrrep)
end do

do iGrid=1,mGrid
  do iIrrep=0,mIrrep-1
    !write(u6,*) ' Symm:',iIrrep
    do i_=1,nISh(iIrrep)+nFro(iIrrep)
      i = iOff_Bas(iIrrep)+i_

      !write(u6,*) ' do_p2: Inact-Inact:',iIrrep,i,TabMO(1,iGrid,i)

      RhoI(1,iGrid) = RhoI(1,iGrid)+TabMO(1,iGrid,i)*TabMO(1,iGrid,i)
      !write(u6,'(A15,2I3,2G15.8)') 'iGrid,i,MO,RhoI',iGrid,i,TabMO(1,iGrid,i),RhoI(1,iGrid)
      !if ((Functional_type == GGA_type) .or. Do_Grad) then
      if (Functional_type == GGA_type) then
        RhoI(2,iGrid) = RhoI(2,iGrid)+TabMO(1,iGrid,i)*TabMO(2,iGrid,i)
        RhoI(3,iGrid) = RhoI(3,iGrid)+TabMO(1,iGrid,i)*TabMO(3,iGrid,i)
        RhoI(4,iGrid) = RhoI(4,iGrid)+TabMO(1,iGrid,i)*TabMO(4,iGrid,i)
      end if

    end do ! i_
  end do   ! iIrrep
end do     ! iGrid

if (NumIsh /= 0) then
  do iGrid=1,mGrid
    P2_ontop(1,iGrid) = RhoI(1,iGrid)*RhoI(1,iGrid)
    !write(u6,'(A15,I3,1G28.20)') 'iGrid,P2(1)=',iGrid,P2_ontop(1,iGrid)

    !if ((Functional_type == GGA_type) .or. Do_Grad) then
    if (Functional_type == GGA_type) then
      P2_ontop(2,iGrid) = Four*RhoI(1,iGrid)*RhoI(2,iGrid)
      !write(u6,'(A,1f28.20)') 'P2(2)   =',P2_ontop(2,iGrid)
      P2_ontop(3,iGrid) = Four*RhoI(1,iGrid)*RhoI(3,iGrid)
      !write(u6,'(A,1f28.20)') 'P2(3)   =',P2_ontop(3,iGrid)
      P2_ontop(4,iGrid) = Four*RhoI(1,iGrid)*RhoI(4,iGrid)
      !write(u6,'(A,1f28.20)') 'P2(4)   =',P2_ontop(4,iGrid)
    end if
    !if ((Functional_type == LDA_type) .and. Do_Grad) then
    !  !Here I must
    !  !1. transform the 2-body density matrix to AO
    !
    !  !2. Loop over effective gradients
    !  !3. Calculate P2_ontop_d(eff_Grad,iGrid)
    !
    !end if
  end do
end if

!***********************************************************************
! Active-Inactive part:                                                *
!***********************************************************************
if ((NumIsh /= 0) .and. (NumAsh /= 0)) then
  do kIrrep=0,mIrrep-1
    do k_=1,nASh(kIrrep)
      k = k_+iOff_BasAct(kIrrep)
      do lIrrep=0,mIrrep-1
        do l_=1,nAsh(lIrrep)
          l = l_+iOff_BasAct(lIrrep)
          kl = iTri(k_+iOff_Ash(kIrrep),l_+iOff_Ash(lIrrep))
          do iGrid=1,mGrid
            RhoA(1,iGrid) = RhoA(1,iGrid)+D1mo(kl)*TabMO(1,iGrid,k)*TabMO(1,iGrid,l)
            !write(u6,'(A35,3I3,3G15.8)') 'iGrid,k,l,D1mo(kl),Tab(k),Tab(l)=',iGrid,k,l,D1mo(kl),TabMO(1,iGrid,k),TabMO(1,iGrid,l)
            !if ((Functional_type == GGA_type) .or. Do_Grad) then
            if (Functional_type == GGA_type) then
              RhoA(2,iGrid) = RhoA(2,iGrid)+D1mo(kl)*TabMO(1,iGrid,k)*TabMO(2,iGrid,l)
              RhoA(3,iGrid) = RhoA(3,iGrid)+D1mo(kl)*TabMO(1,iGrid,k)*TabMO(3,iGrid,l)
              !write(u6,*) 'RhoA(4,iGrid) bf =',RhoA(4,iGrid)
              RhoA(4,iGrid) = RhoA(4,iGrid)+D1mo(kl)*TabMO(1,iGrid,k)*TabMO(4,iGrid,l)
              !write(u6,*) 'D1mo(kl),Tab(1,k),Tab(1,l)=',D1mo(kl)*TabMO(1,iGrid,k)*TabMO(4,iGrid,l)
            end if
          end do ! iGrid
        end do   ! l_
      end do     ! lIrrep
    end do       ! k_
  end do         ! kIrrep

  do iGrid=1,mGrid
    P2_ontop(1,iGrid) = P2_ontop(1,iGrid)+RhoI(1,iGrid)*RhoA(1,iGrid)
    if (Functional_type == GGA_type) then
      P2_ontop(2,iGrid) = P2_ontop(2,iGrid)+Two*RhoI(2,iGrid)*RhoA(1,iGrid)+Two*RhoI(1,iGrid)*RhoA(2,iGrid)
      !write(u6,'(A,1f28.20)') 'P2(2)   =',P2_ontop(2,iGrid)
      P2_ontop(3,iGrid) = P2_ontop(3,iGrid)+Two*RhoI(3,iGrid)*RhoA(1,iGrid)+Two*RhoI(1,iGrid)*RhoA(3,iGrid)
      !write(u6,'(A,1f28.20)') 'P2(3)   =',P2_ontop(3,iGrid)
      P2_ontop(4,iGrid) = P2_ontop(4,iGrid)+Two*RhoI(4,iGrid)*RhoA(1,iGrid)+Two*RhoI(1,iGrid)*RhoA(4,iGrid)
      !write(u6,'(A,1f28.20)') 'P2(4)   =',P2_ontop(4,iGrid)
    end if
  end do ! loop over grid points
end if   ! if Inactive
!***********************************************************************
! Active-Active part:                                                  *
!***********************************************************************

if (NumAsh == 0) return

!call RecPrt('P2MOCube in do_pi2',' ',P2MOCube,NASHT,mGrid)

!call RecPrt('MOs array in do_pi2',' ',MOs,NASHT,mGrid)

do iGrid=1,mGrid
  do kIrrep=0,mIrrep-1
    IOff = iOff_Ash(kIrrep)+1
    P2_ontop(1,iGrid) = P2_ontop(1,iGrid)+ddot_(nAsh(kIrrep),MOs(IOff:,iGrid),1,P2MOCube(IOff:,iGrid),1)
  end do
end do

if (Functional_type == GGA_type) then
  do iGrid=1,mGrid
    do kIrrep=0,mIrrep-1
      IOff = iOff_Ash(kIrrep)+1
      P2_ontop(2,iGrid) = P2_ontop(2,iGrid)+Four*ddot_(nAsh(kIrrep),MOx(IOff:,iGrid),1,P2MOCube(IOff:,iGrid),1)
      P2_ontop(3,iGrid) = P2_ontop(3,iGrid)+Four*ddot_(nAsh(kIrrep),MOy(IOff:,iGrid),1,P2MOCube(IOff:,iGrid),1)
      P2_ontop(4,iGrid) = P2_ontop(4,iGrid)+Four*ddot_(nAsh(kIrrep),MOz(IOff:,iGrid),1,P2MOCube(IOff:,iGrid),1)
    end do
  end do
end if

!write(u6,*) 'On-top density new code'
!write(u6,'(10(F9.6,1X))') (P2_Ontop(1,iGrid),iGrid=1,mGrid)
!write(u6,*) (P2_Ontop(1,iGrid),iGrid=1,mGrid)

return

end subroutine Do_PI2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine ExA_X4 (A,Ap,no)
c
c       this routine do:
c       Ap(i,u,v) <- A(ii,u,v)
c
        implicit none
        integer no
        real*8 Ap(1:no,1:no*no)
        real*8 A(1:no*(no+1)/2,1:no*no)
c
c       help variables
        integer uv,i,ii
c
        do uv=1,no*no
        do i=1,no
          ii=i*(i+1)/2
            Ap(i,uv)=A(ii,uv)
          end do
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SMMAT(PROP,PRMAT,NSS,ISONUM,ISPINCMP)
      use rassi_global_arrays, only: JBNUM
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION PRMAT(NSS,NSS)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='SMMAT')
#include "SysDef.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "rassi.fh"
#include "symmul.fh"
#include "Files.fh"
#include "WrkSpc.fh"
      DIMENSION PROP(NSTATE,NSTATE,NPROP)
      REAL*8, EXTERNAL :: DCLEBS
*
      IPRNUM=-1
      IPRCMP=0
C IFSPIN takes values the values 0,1,2
C 0 = spin free property
C 1 = spin operator (S)
C 2 = spin dependent property, triplet operator
      IFSPIN=0

      IF (ISONUM.EQ.0) THEN
         IPRNUM=0
         IFSPIN=1
         IPRCMP=ISPINCMP
      ELSE
         DO IPROP=1,NPROP
            IF ((PNAME(IPROP).EQ.SOPRNM(ISONUM)).AND.
     &          (PTYPE(IPROP).EQ.SOPRTP(ISONUM)).AND.
     &          (ICOMP(IPROP).EQ.ISOCMP(ISONUM))) THEN
               IPRNUM=IPROP
               IF (PNAME(IPRNUM)(1:5).EQ.'TMOM0') THEN
                  IFSPIN=2
                  IPRCMP=ISPINCMP
               END IF
               IF (PNAME(IPRNUM).EQ.'MLTPL  0'.AND.
     &             PTYPE(IPRNUM).EQ.'ANTITRIP') THEN
                   IFSPIN=2
                   IPRCMP=ISPINCMP
               END IF
               IF (PNAME(IPRNUM).EQ.'MLTPL  1'.AND.
     &             PTYPE(IPRNUM).EQ.'ANTITRIP') THEN
                   IFSPIN=2
                   IPRCMP=ISPINCMP
               END IF
            END IF
         END DO
      END IF
      IF (IPRNUM.EQ.-1) THEN
         Write (6,*) TRIM(ROUTINE),', Abend IPRNUM.EQ.-1'
         Write (6,*) TRIM(ROUTINE),', PRLBL=','>',PNAME(ISONUM),'<'
         Call Abend()
      ENDIF

C Mapping from spin states to spin-free state and to spin:
      ISS=0
      DO ISTATE=1,NSTATE
         JOB1=JBNUM(ISTATE)
         MPLET1=MLTPLT(JOB1)
         S1=0.5D0*DBLE(MPLET1-1)

         DO MSPROJ1=-MPLET1+1,MPLET1-1,2
            SM1=0.5D0*DBLE(MSPROJ1)
            ISS=ISS+1

            JSS=0

            DO JSTATE=1,NSTATE
               JOB2=JBNUM(JSTATE)
               MPLET2=MLTPLT(JOB2)
               S2=0.5D0*DBLE(MPLET2-1)

               DO MSPROJ2=-MPLET2+1,MPLET2-1,2
                  SM2=0.5D0*DBLE(MSPROJ2)
                  JSS=JSS+1

                  IF (IFSPIN.EQ.0 .AND. IPRNUM.NE.0) THEN
                     IF (MPLET1.EQ.MPLET2 .AND. MSPROJ1.EQ.MSPROJ2) THEN
                        PRMAT(ISS,JSS)=PROP(ISTATE,JSTATE,IPRNUM)
                     END IF
                  ELSE IF (IFSPIN.EQ.1 .AND. IPRNUM.EQ.0) THEN
                     SXMER=0.0D0
                     SYMEI=0.0D0
                     SZMER=0.0D0
                     SMINUS=0.0D0
                     SPLUS=0.0D0
                     IF((ISTATE.EQ.JSTATE).AND.(MPLET1.eq.MPLET2)) THEN
                        IF (MSPROJ1.eq.MSPROJ2-2) THEN
                           SMINUS=SQRT((S1+SM2)*(S1-SM1))
                           SXMER= 0.5D0*SMINUS
                           SYMEI= 0.5D0*SMINUS
                        ELSE IF (MSPROJ1.eq.MSPROJ2) THEN
                           SZMER=SM1
                        ELSE IF (MSPROJ1.eq.MSPROJ2+2) THEN
                           SPLUS=SQRT((S1+SM1)*(S1-SM2))
                           SXMER= 0.5D0*SPLUS
                           SYMEI=-0.5D0*SPLUS
                        END IF
                        IF (IPRCMP.EQ.1) THEN
                           PRMAT(ISS,JSS)=SXMER
                        ELSE IF (IPRCMP.EQ.2) THEN
                           PRMAT(ISS,JSS)=SYMEI
                        ELSE IF (IPRCMP.EQ.3) THEN
                           PRMAT(ISS,JSS)=SZMER
                        END IF
                     END IF
                  ELSE IF (IFSPIN.EQ.2) THEN
C 1-electron triplet operator so only Delta S =0,+-1 and Delta MS =0,+-1
C Notice S1,S2 and SM1,SM2 need not to be integers
C Hence MPLET1,MPLET2 and MSPROJ1,MSPROJ2 are used
C Notice SMINUS and SPLUS is interchanged compared to above
C Notice that the Y part is imaginary
C
C see section 3 (Spin_orbit coupling in RASSI) in
C P A Malmqvist, et. al CPL, 357 (2002) 230-240
C for details
C
C Note that we work on the x, y, and z components at this time.
C
C What follows applies only to the exact operator for the
C transition moment.
C
C On page 234 we have the notation V^{AB}(x), that is the
C potential has Cartesian components. Here, however, this is
C partitioned in a slightly different way since we have that
C V^{AB}(x)=(k x e_l)_x V^{AB}. We will only handle the
C V^{AB} part.
C
C Hence, we will compute the contributions to T(i), i=x,y,z
C here and form the inner product
C (k x e_l)_i V^{AB} . T(i)
C outside the code.
C
C Note that this code strictly follows the code of soeig.f where
C the term L.S is added to the Hamiltonian.
C
                     FACT=1.0D0/SQRT(DBLE(MPLET1))
                     IF(MPLET1.EQ.MPLET2-2) FACT=-FACT
                     CGM=FACT*DCLEBS(S2,1.0D0,S1,SM2,-1.0D0,SM1)
                     CG0=FACT*DCLEBS(S2,1.0D0,S1,SM2, 0.0D0,SM1)
                     CGP=FACT*DCLEBS(S2,1.0D0,S1,SM2,+1.0D0,SM1)
                     CGX= SQRT(0.5D0)*(CGM-CGP)
                     CGY=-SQRT(0.5D0)*(CGM+CGP)
*
                     EXPKR=PROP(ISTATE,JSTATE,IPRNUM)
*
                     IF (IPRCMP.EQ.1) THEN
                        EXPKR=EXPKR*CGX
                     ELSE IF (IPRCMP.EQ.2) THEN
                        EXPKR=EXPKR*CGY
                     ELSE IF (IPRCMP.EQ.3) THEN
                        EXPKR=EXPKR*CG0
                     END IF
                     PRMAT(ISS,JSS)= EXPKR
                  END IF

               END DO !MSPROJ2
            END DO !JSTATE
         END DO !MSPROJ1
      END DO !ISTATE

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine LEVXPC(KV,JR,EPR,GAMA,NPP,WF,RFN,V,VLIM,YH,DREF,NBEG,NEND,LXPCT,MORDR,DM,IRFN,BFCT)
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!** Calculates expectation values of the kinetic energy and of X**IP
!  (IP=1,MORDR), denoted XPTKE and XPCTR(IP), respectively, for level
!  v=KV, J=JR, E=EPR(cm-1), using wave function WF(i), (i=NBEG,NEND).
!** Assumes units of length are (angstroms) .
!** Division by BFCT converts potential V(I) to units (cm-1).
!** If (|LXPCT| = 2  or  4), "punch" (WRITE(7,XXX)) results to channel-7
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

use LEVEL_COMMON, only: DRDY2, RVB
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: KV, JR, NPP, NBEG, NEND, LXPCT, IRFN
real(kind=wp), intent(in) :: EPR, GAMA, WF(NPP), V(NPP), VLIM, YH, DM(0:20), BFCT
real(kind=wp), intent(inout) :: RFN(NPP), DREF
integer(kind=iwp), intent(inout) :: MORDR
integer(kind=iwp) :: I, IPNCH, ITRY, K
real(kind=wp) :: DER, DMR, DRT, DS, EINN, RR, RXPCT, SF2, SS2, XPCTR(0:11), XPTKE

EINN = BFCT*EPR
IPNCH = 0
if ((abs(LXPCT) == 2) .or. (abs(LXPCT) >= 4)) IPNCH = 1
! MORDR is the highest-power expectation value considered.
if (MORDR > 11) MORDR = 11
ITRY = 20
if (((IRFN == -1) .or. ((IRFN >= 1) .and. (IRFN <= 9))) .and. (DREF <= Zero)) ITRY = 0
do
  ! Start by calculating contributions at end points
  SS2 = WF(NBEG)**2*DRDY2(NBEG)
  SF2 = WF(NEND)**2*DRDY2(NEND)
  XPTKE = Half*(SS2*(EINN-V(NBEG))+SF2*(EINN-V(NEND)))
  if (MORDR > 0) then
    XPCTR(0) = One/YH
    do K=1,MORDR
      SS2 = SS2*RFN(NBEG)
      SF2 = SF2*RFN(NEND)
      XPCTR(K) = Half*(SS2+SF2)
    end do
  end if
  if (IRFN > -4) then
    ! For regular expectation values of a radial function ...
    do I=NBEG+1,NEND-1
      DS = WF(I)**2*DRDY2(I)
      XPTKE = XPTKE+DS*(EINN-V(I))
      if (MORDR > 0) then
        RR = RFN(I)
        do K=1,MORDR
          DS = DS*RR
          XPCTR(K) = XPCTR(K)+DS
        end do
      end if
    end do
  else
    ! For expectation values involving partial derivative operator ...
    XPCTR(0:MORDR) = Zero
    do I=NBEG+1,NEND-1
      DS = WF(I)**2*DRDY2(I)
      XPTKE = XPTKE+DS*(EINN-V(I))
      DS = WF(I)*(WF(I+1)-WF(I-1))*DRDY2(I)
      if (MORDR > 0) then
        RR = RFN(I)
        do K=1,MORDR
          DS = DS*RR
          XPCTR(K) = XPCTR(K)+DS
        end do
      end if
    end do
    XPCTR(0:MORDR) = XPCTR(0:MORDR)*Half/YH
  end if
  XPTKE = XPTKE*YH/BFCT
  if (MORDR < 0) exit
  XPCTR(0:MORDR) = XPCTR(0:MORDR)*YH
  DMR = sum(DM(0:MORDR)*XPCTR(0:MORDR))
  if ((LXPCT == 1) .or. (abs(LXPCT) == 2)) then
    if (EPR <= VLIM) write(u6,600) KV,JR,EPR,DMR,XPTKE
    if (EPR > VLIM) write(u6,602) KV,JR,EPR,DMR,XPTKE,GAMA
    if (abs(IRFN) <= 9) write(u6,604) (K,XPCTR(K),K=1,MORDR)
    if (IPNCH >= 1) write(7,701) KV,JR,EPR,GAMA,XPTKE,DMR,(XPCTR(K),K=1,MORDR)
  end if
  if (ITRY > 19) exit
  ! If appropriate, iteratively correct DREF value till distance
  ! coordinate expectation value is identically zero.
  if (IRFN == -1) then
    ! For Dunham expansion parameter, define revised function here
    DREF = XPCTR(1)
    DRT = DREF
    write(u6,603) ITRY,DRT,DREF
    RVB(1:NPP) = RVB(1:NPP)/DREF-One
    ITRY = 99
  else
    ! For Surkus-type expansion parameter, define revised function
    ITRY = ITRY+1
    if (ITRY == 1) then
      RXPCT = XPCTR(1)
      DREF = Zero
      DRT = RXPCT
    else
      DER = -IRFN/(Two*DREF)
      DRT = -XPCTR(1)/DER
    end if
    DREF = DREF+DRT
    write(u6,603) ITRY,DRT,DREF
    ! Redefine Surkus-type distance variable RFN using new DREF
    RFN(:) = (RVB(1:NPP)**IRFN-DREF**IRFN)/(RVB(1:NPP)**IRFN+DREF**IRFN)
    if (abs(DRT/DREF) < 1.0e-12_wp) exit
  end if
end do

return

600 format(' E(v=',i3,', J=',i3,')=',f11.3,'   <M(r)>=',G18.10,'   <KE>=',F11.3)
602 format(' E(v=',i3,', J=',i3,')=',f11.3,'   <M(r)>=',G18.10,'   <KE>=',F11.3/'   Tunneling predissociation  Width(FWHM)=', &
           G13.6,'    <X**',I2,'>=',F13.8)
604 format((8x,3('   <X**',I2,'>=',F13.8:)))
603 format(' On iteration #',I2,'  change DREF by',ES10.2,'  to   DREF=',F13.10,' [angstroms]')
701 format(2I4,F11.3,G11.4,F11.3,3(F12.7)/(5X,6F12.7))

end subroutine LEVXPC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This is a very preliminary routine for testing purposes. It relies   *
* on the basis set being of ANO type.                                  *
*                                                                      *
*                                                                      *
* Absolutely NOT to be used for production!!!!                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: Oct 2004                                                    *
*                                                                      *
************************************************************************
      Subroutine Fmod1n(StandAlone)
      Implicit None
#include "Molcas.fh"
#include "stdalloc.fh"
#include "commgo.fh"
*----------------------------------------------------------------------*
* Dummy arguments                                                      *
*----------------------------------------------------------------------*
      Logical StandAlone
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Logical Debug
      Logical Trace
      Integer iSym
      Integer iBas
      Integer jBas
      Integer kBas
      Integer iOff
      Integer ipCMO(MxSym)
      Integer ipFock(MxSym)
      Integer ipX
      Integer ipY
      Integer iSymlb
      Integer iRc
      Integer nBasMax
      Integer nBasTot
      Integer nTriTot
      Integer nSqrTot
*---
      Real*8  orbene(MxBasis)
      Real*8, Dimension(:), Allocatable :: CMO, Fock, EVec, Ovl, Nrm
      Real*8, Dimension(:), Allocatable :: SFk, Hlf, TFk, Aux1
*     Character*4 Name(MxAtom)
*     Character*4 Label(2,MxBasis)
*---
      Integer i,k
      Real*8  Sik
      Real*8  Sjk
      Real*8  eps
      real*8  sum
      Integer Lu
      Integer iDummy(7,8)
      Integer RC
      Character*80 Title
*----------------------------------------------------------------------*
* Some setup                                                           *
*----------------------------------------------------------------------*
      If(StandAlone) Then
         Debug=.false.
         Trace=.false.
      Else
         Debug=.false.
         Trace=.false.
      End If
      If(Trace) Write(6,*) '>>> Entering fmod1n'
*----------------------------------------------------------------------*
* Setup various counters.                                              *
*----------------------------------------------------------------------*
      nBasMax=0
      nBasTot=0
      nTriTot=0
      nSqrTot=0
      Do iSym=1,nSym
         If(nBasMax.lt.nBas(iSym)) nBasMax=nBas(iSym)
         nTriTot=nTriTot+nBas(iSym)*(nBas(iSym)+1)/2
         nSqrTot=nSqrTot+nBas(iSym)*nBas(iSym)
         nBasTot=nBasTot+nBas(iSym)
      End Do
*----------------------------------------------------------------------*
* Make symmetric orthonormal orbital basis.                            *
*----------------------------------------------------------------------*
      Call mma_allocate(CMO,nSqrTot)
      ipCMO(1)=1
      Do iSym=1,nSym-1
         ipCMO(iSym+1)=ipCMO(iSym)+nBas(iSym)*nBas(iSym)
      End Do
      Call goLowdin(CMO)
*----------------------------------------------------------------------*
* Allocate Fock matrix.                                                *
*----------------------------------------------------------------------*
      Call mma_allocate(Fock,nTriTot)
      ipFock(1)=1
      Call mma_allocate(EVec,nBasTot)
      Do iSym=1,nSym-1
         ipFock(iSym+1)=ipFock(iSym)+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
      Call dCopy_(nTriTot,[0.0d0],0,Fock,1)
*----------------------------------------------------------------------*
* Create model Fock operator.                                          *
*----------------------------------------------------------------------*
      Call FockOper(RC,EVec)
      If(RC.ne.0) Then
         Call mma_deallocate(EVec)
         Call mma_deallocate(Fock)
         Call mma_deallocate(CMO)
         Return
      End If
*----------------------------------------------------------------------*
* Get overlap matrix and make normalization.                           *
*----------------------------------------------------------------------*
      Call mma_allocate(Ovl,nTriTot+4)
      Call mma_allocate(Nrm,nBasTot)
      iSymlb=1
      Call RdOne(irc,2,'Mltpl  0',1,Ovl,iSymlb)

      ipX=1
      ipY=1
      Do iSym=1,nSym
         Call goPickup(Ovl(ipX),Nrm(ipY),nBas(iSym))
         Do iBas=1,nBas(iSym)
            Nrm(ipY-1+iBas)=1.0d0/sqrt(Nrm(ipY-1+iBas))
         End Do
         ipX=ipX+nBas(iSym)*(nBas(iSym)+1)/2
         ipY=ipY+nBas(iSym)
      End Do
*----------------------------------------------------------------------*
* Build Fock matrix.                                                   *
*----------------------------------------------------------------------*
      ipX=1
      ipY=1
      iOff=0
      Do iSym=1,nSym
         Do iBas=1,nBas(iSym)
            Do jBas=1,iBas
               sum=0.0d0
               Do kBas=1,nBas(iSym)
                  eps=EVec(iOff+kBas)
                  i=Max(iBas,kBas)
                  k=Min(iBas,kBas)
                  Sik=Ovl(ipX-1+i*(i-1)/2+k)*
     &               Nrm(ipY-1+iBas)*Nrm(ipY-1+kBas)
                  i=Max(jBas,kBas)
                  k=Min(jBas,kBas)
                  Sjk=Ovl(ipX-1+i*(i-1)/2+k)*
     &               Nrm(ipY-1+jBas)*Nrm(ipY-1+kBas)
                  sum=sum+eps*Sik*Sjk
               End Do
               Fock(ipFock(iSym)-1+iBas*(iBas-1)/2+jBas)=sum
            End Do
         End Do
         If(Debug) Then
            Call TriPrt('Modified atomic Fock matrix','(12f12.6)',
     &                  Fock(ipFock(iSym)),nBas(iSym))
         End if
         ipX=ipX+nBas(iSym)*(nBas(iSym)+1)/2
         ipY=ipY+nBas(iSym)
         iOff=iOff+nBas(iSym)
      End Do
*----------------------------------------------------------------------*
* Scale Fock matrix.                                                   *
*----------------------------------------------------------------------*
      ipX=1
      Do iSym=1,nSym
         If(Debug) Then
            Write(6,*) '***'
            Write(6,*) '*** Symmetry',iSym
            Write(6,*) '***'
         End If
         Do iBas=1,nBas(iSym)
            Do jBas=1,iBas
               Fock(ipFock(iSym)-1+iBas*(iBas-1)/2+jBas)=
     &         Fock(ipFock(iSym)-1+iBas*(iBas-1)/2+jBas)*
     &         Sqrt(Ovl(ipX-1+iBas*(iBas+1)/2))*
     &         Sqrt(Ovl(ipX-1+jBas*(jBas+1)/2))
            End Do
         End Do
         If(Debug) Then
            Call TriPrt('Scaled atomic Fock matrix','(12f12.6)',
     &                  Fock(ipFock(iSym)),nBas(iSym))
         End if
         ipX=ipX+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
*----------------------------------------------------------------------*
* Release overlap and norm arrays.                                     *
*----------------------------------------------------------------------*
      Call mma_deallocate(Nrm)
      Call mma_deallocate(Ovl)
*----------------------------------------------------------------------*
* Diagonalize Fock matrix.                                             *
*----------------------------------------------------------------------*
      Call mma_allocate(SFk,nBasMax*nBasMax)
      Call mma_allocate(Hlf,nBasMax*nBasMax)
      Call mma_allocate(TFk,nBasMax*(nBasMax+1)/2)
      iOff=0
      Do iSym=1,nSym
         If(Debug) Then
            Write(6,*) '***'
            Write(6,*) '*** Symmetry',iSym
            Write(6,*) '***'
         End If
         If(nBas(iSym).gt.0) Then
            Call Square(Fock(ipFock(iSym)), SFk,
     &                  1,nBas(iSym), nBas(iSym))
            Call DGEMM_('N','N',
     &                  nBas(iSym),nBas(iSym),nBas(iSym),
     &                  1.0d0,SFk,nBas(iSym),
     &                        CMO(ipCMO(iSym)),nBas(iSym),
     &                  0.0d0,Hlf,nBas(iSym))
            Call MxMt(CMO(ipCMO(iSym)),nBas(iSym),1,
     &                Hlf,1,nBas(iSym),
     &                TFk,
     &                nBas(iSym),nBas(iSym))
            If(Debug) Then
               Call TriPrt('Transformed Fock matrix','(12f12.6)',
     &                     TFk,nBas(iSym))
            End If
         End If

*        Call Jacob(TFk,CMO(ipCMO(iSym)),nbas(iSym),nbas(iSym))
         Call NIdiag(TFk,CMO(ipCMO(iSym)),
     &               nbas(iSym),nbas(iSym),0)
         If(Debug) Then
            Call TriPrt('Diagonalized atomic Fock matrix','(12f12.6)',
     &                  TFk,nBas(iSym))
         End If
         Call goPickup(TFk,orbene(iOff+1),nBas(iSym))
         Call goSort(orbene(iOff+1),CMO(ipCMO(iSym)),
     &             nBas(iSym),nBas(iSym))
         iOff=iOff+nBas(iSym)
      End Do
      Call mma_deallocate(TFk)
      Call mma_deallocate(Hlf)
      Call mma_deallocate(SFk)
*----------------------------------------------------------------------*
* Present data.                                                        *
*----------------------------------------------------------------------*
      If(PrintMOs) then
         Call PriMO('Start orbitals',.false.,.true.,0.0d0,1.0d6,
     &              nSym,nBas,nBas,Label,orbene,orbene,CMO(ipCMO(1)),3)
      End If
      Call put_darray('Guessorb',CMO(ipCMO(1)),nSqrTot)
      Call put_darray('Guessorb energies',orbene,nBasTot)
      Call Put_iArray('nOrb',nBas,nSym)
      Call mma_allocate(Aux1,nBasTot)
      Do iBas=1,nBasTot
         Aux1(iBas)=0.0d0
      End Do
      Lu=20
      Title='Guess orbitals'
      Call WrVec('GSSORB',Lu,'COE',NSYM,NBAS,NBAS,CMO(ipCMO(1)),
     &           Aux1,orbene,iDummy,Title)
      Call mma_deallocate(Aux1)
*----------------------------------------------------------------------*
* Done, deallocate the rest.                                           *
*----------------------------------------------------------------------*
      Call mma_deallocate(Evec)
      Call mma_deallocate(Fock)
      Call mma_deallocate(CMO)
      If(trace) Write(6,*) '<<< Exiting fmod1n'
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_RstD_GetInd3(iSP2F,l_iSP2F)
      Implicit None
      Integer l_iSP2F
      Integer iSP2F(l_iSP2F)
#include "cholesky.fh"

      Integer iOpt, iAdr

      iOpt = 2
      iAdr = nSym*nnShl + 2*nnBstRT(1)
      Call iDAFile(LuRed,iOpt,iSP2F,l_iSP2F,iAdr)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine evaluate_Sxxx (dkhorder,xorder,paramtype,dkhscfflg,
     *             wordercounter,wopsleng,woporder,eowops,dwops,wops,
     *             termleng,termleng2,termorder,dtcoeff,dtcoeff2,
     *             sused,snumber,scounter,stimes,wstimes,sorder,smult,s,
     *             scrchar,scrleng,stimestot,tnumber,tcounter,ttimes,
     *             tmult,t,tscrchar,tscrleng,ttimestot,uused,unumber,
     *             utimes,uorder,umult,u,uscrchar,uscrleng,totmult,
     *             dkhzerothrsh)
c
c*************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 19.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,xorder
      character*(3) paramtype
      logical dkhscfflg
c
C     integer wordercounter(maxorder),wopscounter,wopsleng(maxuops),
      integer wordercounter(maxorder),            wopsleng(maxuops),
     *        woporder(maxuops,3),eowops(maxuops)
      real*8 dwops(maxuops)
      character*(maxlength) wops(maxuops)
c
      integer sused,snumber,scounter(maxsnumber),stimes(maxsnumber),
     *        wstimes(maxuops,maxsnumber),sorder(maxsnumber,3),
     *        smult(maxsnumber),scrleng(maxsnumber),stimestot
      integer tnumber,tcounter(maxsnumber),ttimes(maxsnumber),
     *        tmult(maxsnumber),tscrleng(maxsnumber),ttimestot
      integer uused,unumber,utimes(maxunumber),uorder(maxunumber,3),
     *        umult(maxunumber),uscrleng(maxunumber)
      character*(3) uscrchar(maxunumber)
      character*(4) s(maxsnumber),t(maxsnumber),u(maxunumber)
      character*(9) scrchar(maxsnumber)
      character*(11) tscrchar(maxsnumber)
c
      integer stimes2(maxsnumber),ttimes2(maxsnumber),
     *        utimes2(maxunumber)
c
      integer idum
      integer dummyleng,smulttot
      integer totmult
      real*8 dkhzerothrsh(0:maxorder)
      integer termcounter,termleng(maxoperators),
     *        termleng2(maxoperators),
     *        termorder(maxoperators,3)
      real*8 dtcoeff(maxoperators),dtcoeff2(maxoperators),
     *                 dummycoeff
#if defined(_MOLCAS_) || defined(MOLPRO)
#include "WrkSpc.fh"
      integer term,nwop,lwop,intrea
      character*(maxlength) termstr
#else
      character*(maxlength) term(maxoperators)
#endif
      character*(maxlength) dummychar
c
      integer j,k,l
#ifdef _MOLCAS_
      Integer IsFreeUnit
#endif
CMR      write (stdout,1017)
CMR1017  format (//5X,'|',70('-'),'|',/5X,'|',6X,'STEP 4: Evaluate ',
CMR     *        'even-order auxiliary matrices Sxxx',13X,'|',/5X,'|',
CMR     *        70('-'),'|',/)

      if (dbgflg.ge.1) then
        write (dbgunit,1019)
1019    format (/2X,'Step 4: Enter subroutine "evaluate_Sxxx" ',//2X,
     *          'Evaluate even-order auxiliary matrices Sxxx, which ',
     *          'have been used in step 2.')
      endif
#ifndef MOLPRO
#ifdef _MOLCAS_
      dkhunit3=13
      dkhunit3=IsFreeUnit(dkhunit3)
      Call Molcas_Open(dkhunit3,'dkhops.13')
#else
      open (dkhunit3, file='dkhops.13', status='UNKNOWN',
     *        form='FORMATTED')
#endif
#endif
      rewind(dkhunit3)
      write (dkhunit3,1021) dkhorder,paramtype,xorder,dkhscfflg
1021  format (50('-'),/2X,'dkhorder = ',I2,10X,A3,/2X,'xorder   = ',I2,
     *        /2X,'dkhscfflg = ',L1,/'+++',47('-'))
      write (dkhunit3,'(I3)') snumber
#if defined(_MOLCAS_) || defined(MOLPRO)
      lwop=8/intrea()
      nwop=(maxlength-1)/lwop+1
      call getmem('term_Sxxx','Allo','Inte',term,maxoperators*nwop)
#endif
      idum=0
      do 10 j=1,sused
        smult(j)=0
        if (stimes(j).gt.0) then
          idum=idum+1
          do 20 k=1,maxlength
            dummychar(k:k)=' '
  20      continue
          if (scrleng(j).eq.6) dummyleng=6
          if (scrleng(j).eq.9) dummyleng=9
          dummycoeff=1.0d0
          dummychar(1:dummyleng)=scrchar(j)
c
#if defined(_MOLCAS_) || defined(MOLPRO)
          call replace2 (dummyleng,dummycoeff,dummychar,wordercounter,
     *                   wopsleng,dwops,wops,sused,stimes,wstimes,s,
     *                   scrchar,scrleng,ttimes,termcounter,
     *                   termleng,termleng2,
     *                   dtcoeff,dtcoeff2,iwork(term))
#else
          call replace2 (dummyleng,dummycoeff,dummychar,wordercounter,
     *                   wopsleng,dwops,wops,sused,stimes,wstimes,s,
     *                   scrchar,scrleng,ttimes,termcounter,
     *                   termleng,termleng2,
     *                   dtcoeff,dtcoeff2,term)
#endif
c
          scounter(j)=termcounter
          if (scounter(j).gt.maxoperators) then
            write (stdout,1033) j,scounter(j)
1033        format (/2X,'ERROR in SR "evaluate_Sxxx": scounter(',I3,
     *            ') = ',I9,' > maxoperators.',//2X,'Increase ',
     *            'maxoperators in "dkhparameters.fh".',//2X,'STOP.',/)
            CALL Abend
          endif
1042      continue
          do 30 k=1,termcounter
c
            do 36 l=1,sused
              stimes2(l)=0
              ttimes2(l)=0
  36        continue
            do 37 l=1,uused
              utimes2(l)=0
  37        continue
c
#if defined(_MOLCAS_) || defined(MOLPRO)
            call get_dkoperators_i(k,termstr,iwork(term))
            call removeB1 (termleng(k),dtcoeff(k),termstr)
            call removeB2 (termleng(k),termstr)
            call insert_ri (termleng(k),termstr)
            call movebraces (termleng(k),termstr)
            call finalize (termleng(k),termstr,stimes2,ttimes2,t)
            call finalize2 (termleng(k),termstr,uused,utimes2,u,
     *                      uscrleng,uscrchar)
            termorder(k,3)=sorder(j,3)
            call calc_orders (dkhscfflg,termleng(k),termorder(k,1),
     *                        termorder(k,2),termorder(k,3),termstr,
     *                        sorder,uorder)
            call put_dkoperators_i(k,termstr,iwork(term))
#else
            call removeB1 (termleng(k),dtcoeff(k),term(k))
            call removeB2 (termleng(k),term(k))
            call insert_ri (termleng(k),term(k))
            call movebraces (termleng(k),term(k))
            call finalize (termleng(k),term(k),stimes2,ttimes2,t)
            call finalize2 (termleng(k),term(k),uused,utimes2,u,
     *                      uscrleng,uscrchar)
            termorder(k,3)=sorder(j,3)
            call calc_orders (dkhscfflg,termleng(k),termorder(k,1),
     *                        termorder(k,2),termorder(k,3),term(k),
     *                        sorder,uorder)
#endif
c
CMR ISN'T IT POSSIBLE TO DO THIS PRIOR TO ALL THESE CALCULATIONS ?? -> CHECK AGAIN!
            if ( (dynthrsh.eq.0.and.abs(dtcoeff(k)).lt.dkhzero) .or.
     *           (dynthrsh.eq.1.and.
     *             abs(dtcoeff(k)).lt.dkhzerothrsh(sorder(j,3))) .or.
     *           (dkhscfflg.and.termorder(k,2).gt.xorder) ) then
              do 40 l=k,termcounter-1
                termleng(l)=termleng(l+1)
                dtcoeff(l)=dtcoeff(l+1)
#if defined(_MOLCAS_) || defined(MOLPRO)
CMR das funktioniert hier so vielleicht nicht, weil iwork(term) nicht da ist, sondern term
                call copy_dkoperators_i(l+1,iwork(term),l,iwork(term))
#else
                term(l)=term(l+1)
#endif
  40          continue
              termcounter=termcounter-1
              scounter(j)=scounter(j)-1
CMR WHY SHOULD ONE START WITH 1 AGAIN INSTEAD OF K IN LOOP 30: k=k_actual, termcounter ???
              goto 1042
            else
              do 47 l=1,sused
                stimes(l)=stimes(l)+stimes2(l)
                ttimes(l)=ttimes(l)+ttimes2(l)
  47          continue
              do 48 l=1,uused
                utimes(l)=utimes(l)+utimes2(l)
  48          continue
            endif
c
  30      continue
#if defined(_MOLCAS_) || defined(MOLPRO)
          call calc_smult (j,smult(j),termcounter,termleng,iwork(term))
          call output11 (dkhunit3,scounter(j),sorder(j,1),sorder(j,2),
     *                   sorder(j,3),s(j),scrchar(j),termcounter,
     *                   termleng,termorder,dtcoeff,iwork(term))
#else
          call calc_smult (j,smult(j),termcounter,termleng,term)
          call output11 (dkhunit3,scounter(j),sorder(j,1),sorder(j,2),
     *                   sorder(j,3),s(j),scrchar(j),termcounter,
     *                   termleng,termorder,dtcoeff,term)
#endif

CMR          write (stdout,2045) idum,s(j),scounter(j)
CMR2045      format (2X,I3,4X,A4,'  with ',I7,' low-level lines ',
CMR     *            'completed.')
        endif
  10  continue
c
#ifdef _MOLCAS_
      close (dkhunit3)
#endif
      tnumber=0
      do 50 j=1,sused
        if (ttimes(j).gt.0) then
          tnumber=tnumber+1
          ttimestot=ttimestot+ttimes(j)
        endif
  50  continue
      smulttot=0
      stimestot=0
      do 220 j=1,sused
        if (stimes(j).gt.0) then
          stimestot=stimestot+stimes(j)
          smulttot=smulttot+smult(j)
        endif
 220  continue
c
      totmult=totmult+smulttot
      if (dbgflg.ge.1) then
        write (dbgunit,4026) snumber
4026    format (/2X,'All ',I3,' auxiliary matrices Sxxx have been ',
     *          'reduced to their low-level form.')
        call output6 (dbgunit,dkhscfflg,sused,scounter,stimes,sorder,
     *                smult,s,scrchar,stimestot,smulttot)
        write (dbgunit,4027) snumber
4027    format (2X,'Final low-level expressions for all ',I3,' Sxxx',
     *          ' have been written to the file "dkhops.13".')
        write (dbgunit,4030) tnumber
4030    format (//2X,'Thereby,',I3,' different Txxx-expressions have',
     *          ' been used so far (steps 3 and 4).')
        if (dkhscfflg) then
          write (dbgunit,4072)
4072      format (/5X,'#',7X,'step1',4X,'-->',3X,'step3',3X,'order',3X,
     *          'no. of subs.',3X,/36X,'(tot)',5X,'(ttimes)',/)
        else
          write (dbgunit,4073)
4073      format (/5X,'#',7X,'step1',4X,'-->',3X,'step3',3X,'order',1X,
     *            'order',1X,'order',2X,'no. of subs.',3X,/37X,'(V)',3X,
     *            '(X)',2X,'(tot)',3X,'(ttimes)'/)
        endif
        call output5 (dkhscfflg,dbgunit,sused,ttimes,sorder,t,tscrchar,
     *                ttimestot)
        write (dbgunit,2769)
2769    format (/2X,'Subroutine evaluate_Sxxx (step3) has now been ',
     *          'completed.',//2X,145('*'))
      endif
CMR      write (stdout,1034) snumber
CMR1034  format (/2X,'All ',I3,' high-level expressions Sxxx have been ',
CMR     *        'reduced to their low-level',/2X,'form. The results ',
CMR     *        'are stored in the file "dkhops.13".',/2X)
CMR      write (stdout,1036) tnumber,ttimestot
CMR1036  format (2X,'No. of different Txxx expressions used so far:',19X,
CMR     *        I3,/2X,'No. of high-level subs. (Txxx) used so far:',18X,
CMR     *        I7)
CMR      write (stdout,1038) snumber,smulttot
CMR1038  format (/2X,'No. of low-level matrix multiplications needed',
CMR     *        /4X,'for the evaluation of all ',I3,' Sxxx-operators:',
CMR     *        11X,I10)
c
#if defined(_MOLCAS_) || defined(MOLPRO)
      call getmem('term_Sxxx','Free','Inte',term,maxoperators*nwop)
#endif
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer_array(woporder)
        call Unused_integer_array(eowops)
        call Unused_integer_array(tcounter)
        call Unused_integer_array(tmult)
        call Unused_integer_array(tscrleng)
        call Unused_integer(unumber)
        call Unused_integer_array(umult)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Stefan Knecht                                    *
!***********************************************************************

module active_space_solver_cfg

use Definitions, only: iwp

implicit none
private

character(len=8) :: as_solver = '        '
logical(kind=iwp) :: as_solver_inp_proc = .false.

public :: as_solver, as_solver_inp_proc

end module active_space_solver_cfg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine UrobTau(Tau,NaGrp,LunTau)
! vyraba subor LunTau so simulovanymi Tau amplitudami
! so spravnou strukturou

use chcc_global, only: DimGrpv, no
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: Tau(*)
integer(kind=iwp), intent(in) :: NaGrp, LunTau
integer(kind=iwp) :: aGrp, bGrp, length

!1 cycle over Groups a,b

do aGrp=1,NaGrp
  do bGrp=1,aGrp

    !1.1 def length

    if (aGrp == bGrp) then
      ! groups of a and b are equal, reading for a'>=b'
      length = no*no*DimGrpv(aGrp)*(DimGrpv(bGrp)+1)/2
    else
      ! aGrp>bGrp, reading for a',b' in given groups
      length = no*no*DimGrpv(aGrp)*DimGrpv(bGrp)
    end if

    !1.2 full Tau with random numbers

    call RNFill(length,Tau,1.0e-2_wp)

    !1.3 read block

    write(u6,*) aGrp,bGrp,length
    call wri_chcc(lunTau,length,Tau)

  end do
end do

!2 rewind file
rewind(LunTau)

return

end subroutine UrobTau

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Rulin Feng                                       *
************************************************************************
*       ***************************************************
*                Get TDM in AO basis from SO states
*       ****************************************************
*        This routine is modified from sonatorbm.f to give the
*        full transition density matrix (TDM) in atomic orbital
*        basis, which is not a nbtri sized matrix as in sonatorbm
*        but a full nbst**2 sized matrix.
*

      SUBROUTINE MAKETDMAO(CHARTYPE,
     &                     USOR,USOI,ASS,BSS,NSS,
     &                     iOpt,ROTMAT,DENSOUT)
      use rassi_aux, only : idisk_TDM
      use rassi_global_arrays, only: JBNUM
      use stdalloc, only: mma_allocate, mma_deallocate
      use Cntrl, only: NSTATE, LSYM1, LSYM2, IRREP, MLTPLT
      use cntrl, only: LuTDM
      use Symmetry_Info, only: nSym=>nIrrep, MUL
      use rassi_data, only: NBST,NBASF,NTDMZZ

      IMPLICIT NONE
      CHARACTER(LEN=8) CHARTYPE!,LABEL
      Integer NSS
      Real*8 USOR(NSS,NSS),USOI(NSS,NSS)
      INTEGER ASS,BSS, iOpt
      Real*8 ROTMAT(3,3)
      Real*8 DENSOUT(6,nbst**2)

      Integer IOFF(8)
      Integer, Allocatable:: MAPST(:), MAPSP(:), MAPMS(:)
      Real*8, allocatable, target:: SDMXR(:), SDMXI(:),
     &                              SDMYR(:), SDMYI(:),
     &                              SDMZR(:), SDMZI(:)
      Real*8, allocatable, target:: SDMXR2(:), SDMXI2(:),
     &                              SDMYR2(:), SDMYI2(:),
     &                              SDMZR2(:), SDMZI2(:)
      Type A2_array
         Real*8, Pointer:: A2(:)
      End Type A2_Array
      Type (A2_array)  :: pZMR(3), pZMI(3)
      Type (A2_array)  :: pZMR2(3), pZMI2(3)
      Real*8, allocatable:: TMPR(:), TMPI(:), SCR(:), TDMZZ(:)

      REAL*8 CGY, CGX, CG0, TDM, S1, S2, SM1, SM2, FACT, CGM, CGP,
     &       URR, UIR, URL, UIL, DCLEBS
      Integer NBSTS, ITYPE, ISS, ISF, JOB, MPLET, MSPROJ, KSS, KSF,
     &        MPLETK, MSPROJK, LSS, LSF, MPLETL, MSPROJL, JOB1, JOB2,
     &        ISY12, IEMPTY, IDISK, IGO, ITD, NB1_I, NB1_F, ISY1,
     &        NB2_I, NB2_F, NB1, ISY2, ISY12_MA, NB2, J, I, IJ, IDIR

      nbsts=nbst**2

c VV: dummy initialization
      CGY=-1
      CGX=-1
      CG0=-1
c Initialize
      DENSOUT(:,:) = 0.0D00
C Get the proper type of the property
      ITYPE=0
      IF(CHARTYPE.EQ.'HERMSING') ITYPE=1
      IF(CHARTYPE.EQ.'ANTISING') ITYPE=2
      IF(CHARTYPE.EQ.'HERMTRIP') ITYPE=3
      IF(CHARTYPE.EQ.'ANTITRIP') ITYPE=4
      IF(ITYPE.EQ.0) THEN
        WRITE(6,*)'RASSI/SONATORB internal error.'
        WRITE(6,*)'Erroneous property type:',CHARTYPE
        CALL ABEND()
      END IF

C The following creates an array that is used to
C map a specific spin state to the corresponding
C spin-free state and to its spin
C (see prprop.f and others)

      CALL mma_allocate(MAPST,NSS,Label='MAPST')
      CALL mma_allocate(MAPSP,NSS,Label='MAPSP')
      CALL mma_allocate(MAPMS,NSS,Label='MAPMS')

      ISS=0
      DO ISF=1,NSTATE
        JOB=JBNUM(ISF)
        MPLET=MLTPLT(JOB)

        DO MSPROJ=-MPLET+1,MPLET-1,2
          ISS=ISS+1
          MAPST(ISS)=ISF
          MAPSP(ISS)=MPLET
          MAPMS(ISS)=MSPROJ
        END DO
      END DO


c Allocate some arrays
c SDMXR, etc      DM/TDM for this iteration
c SDMXR2, etc     Accumulated DM/TDM
c TMPR,I          Temporary array for U*AU multiplication
c TDMZZ           DM/TDM as read from file
c SCR             Scratch for expansion of TDMZZ
      CALL mma_allocate(SDMXR,nbsts,Label='SDMXR')
      CALL mma_allocate(SDMXI,nbsts,Label='SDMXI')
      CALL mma_allocate(SDMYR,nbsts,Label='SDMYR')
      CALL mma_allocate(SDMYI,nbsts,Label='SDMYI')
      CALL mma_allocate(SDMZR,nbsts,Label='SDMZR')
      CALL mma_allocate(SDMZI,nbsts,Label='SDMZI')
      SDMXR(:)=0.0D0
      SDMXI(:)=0.0D0
      SDMYR(:)=0.0D0
      SDMYI(:)=0.0D0
      SDMZR(:)=0.0D0
      SDMZI(:)=0.0D0
      pZMR(1)%A2=>SDMXR(:)
      pZMR(2)%A2=>SDMYR(:)
      pZMR(3)%A2=>SDMZR(:)
      pZMI(1)%A2=>SDMXI(:)
      pZMI(2)%A2=>SDMYI(:)
      pZMI(3)%A2=>SDMZI(:)

      CALL mma_allocate(SDMXR2,nbsts,Label='SDMXR2')
      CALL mma_allocate(SDMXI2,nbsts,Label='SDMXI2')
      CALL mma_allocate(SDMYR2,nbsts,Label='SDMYR2')
      CALL mma_allocate(SDMYI2,nbsts,Label='SDMYI2')
      CALL mma_allocate(SDMZR2,nbsts,Label='SDMZR2')
      CALL mma_allocate(SDMZI2,nbsts,Label='SDMZI2')
      SDMXR2(:)=0.0D0
      SDMXI2(:)=0.0D0
      SDMYR2(:)=0.0D0
      SDMYI2(:)=0.0D0
      SDMZR2(:)=0.0D0
      SDMZI2(:)=0.0D0
      pZMR2(1)%A2=>SDMXR2(:)
      pZMR2(2)%A2=>SDMYR2(:)
      pZMR2(3)%A2=>SDMZR2(:)
      pZMI2(1)%A2=>SDMXI2(:)
      pZMI2(2)%A2=>SDMYI2(:)
      pZMI2(3)%A2=>SDMZI2(:)

      CALL mma_allocate(TMPR,nbsts,Label='TMPR')
      CALL mma_allocate(TMPI,nbsts,Label='TMPI')
      TMPR(:)=0.0D0
      TMPI(:)=0.0D0

      CALL mma_allocate(SCR,nbsts,Label='SCR')
c zeroed inside the loop

      CALL mma_allocate(TDMZZ,NTDMZZ,Label='TDMZZ')
      TDMZZ(:)=0.0D0

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C MAIN LOOP OVER KSF/LSF
C WRITTEN AS IN PRPROP
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C CORRESPONDING SPIN-FREE STATES OF THE
C REQUESTED SPIN STATES
c      ASF=MAPST(ASS)
c      BSF=MAPST(BSS)

      DO KSS=1,NSS
       KSF=MAPST(KSS)
       MPLETK=MAPSP(KSS)
       MSPROJK=MAPMS(KSS)

       DO LSS=1,NSS
        LSF=MAPST(LSS)
        MPLETL=MAPSP(LSS)
        MSPROJL=MAPMS(LSS)

        JOB1=JBNUM(KSF)
        JOB2=JBNUM(LSF)
        LSYM1=IRREP(JOB1)
        LSYM2=IRREP(JOB2)
        ISY12=MUL(LSYM1,LSYM2)

C SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS
        Call mk_IOFF(IOFF,nSYM,NBASF,ISY12)

c These are going to be zero, so head them off at the pass
        IF(ITYPE.LE.2
     &     .AND.(MPLETK.NE.MPLETL.OR.MSPROJK.NE.MSPROJL)) GOTO 2200


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
C Transition density matrices, TDMZZ, in AO basis.
C WDMZZ similar, but WE-reduced 'triplet' densities.
C TDMZZ will store either, depending on the type
        TDMZZ(:)=0.0D0


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C IDTDM: TOC array for transition 1-matrices
c TDMZZ is stored on disk from i = 1, NSTATE j=1, i
c so swap if needed
        iEmpty=iDisk_TDM(KSF,LSF,2)
        IDISK=iDisk_TDM(KSF,LSF,1)
        iOpt=2
        IF (ITYPE.GE.3) Then
           iGo=4
           CALL dens2file(TDMZZ,TDMZZ,TDMZZ,
     &                    nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,KSF,LSF)
C NOTE-the TD matrix as read in has an incorrect sign
           CALL DSCAL_(NTDMZZ,-1.0d0,TDMZZ,1)
        Else
           iGo=1
           CALL dens2file(TDMZZ,TDMZZ,TDMZZ,
     &                    nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,KSF,LSF)
        END IF


c Anti-hermitian properties need a little fixing
        IF((ITYPE.EQ.2.OR.ITYPE.EQ.4).AND.(KSF.LE.LSF))
     &          CALL DSCAL_(NTDMZZ,-1.0d0,TDMZZ,1)


C CALCULATE THE SYMMETRIC AND ANTISYMMETRIC FOLDED TRANS D MATRICES
C AND SIMILAR WE-REDUCED SPIN DENSITY MATRICES
        SCR(:)=0.0D0
cccccccccccccc
c nbsq and NTDMZZ are the same, but they are the
c sizes of the symmetry-adapted matrices
c what we need is a NBST**2-sized matrix without symmetry
c Thus we expand the final TDM in C1 symmetry
c Leave the zero matrix elements as they are
ccccccccccccccc

cc Expand into C1
        ITD=0
        NB1_i=0
        NB1_f=0
        Do ISY1=1,NSYM
          NB2_i=0
          NB2_f=0
          NB1=NBASF(ISY1)
          NB1_f=NB1_i+NB1
          Do ISY2=1,NSYM
            ISY12_ma=MUL(ISY1,ISY2)
            NB2=NBASF(ISY2)
            NB2_f=NB2_i+NB2
            If(ISY12_ma.EQ.ISY12) then
              Do J=NB2_i+1,NB2_f
                Do I=NB1_i+1,NB1_f
                  ITD=ITD+1
                  TDM=TDMZZ(ITD)
                  IJ=I+NBST*(J-1)
                  SCR(IJ)=SCR(IJ)+TDM
                Enddo
              Enddo
            Endif
            NB2_i=NB2_i+NB2
          Enddo
          NB1_i=NB1_i+NB1
        Enddo

c ie, see how AMFI is processed in soeig.f
        SDMXR(:)=0.0D0
        SDMXI(:)=0.0D0
        SDMYR(:)=0.0D0
        SDMYI(:)=0.0D0
        SDMZR(:)=0.0D0
        SDMZI(:)=0.0D0

        IF(ITYPE.GE.3) THEN
          S1=0.5D0*DBLE(MPLETK-1)
          SM1=0.5D0*DBLE(MSPROJK)
          S2=0.5D0*DBLE(MPLETL-1)
          SM2=0.5D0*DBLE(MSPROJL)
          FACT=1.0D0/SQRT(DBLE(MPLETK))
          IF(MPLETK.EQ.MPLETL-2) FACT=-FACT

          CGM=FACT*DCLEBS(S2,1.0D0,S1,SM2,-1.0D0,SM1)
          CG0=FACT*DCLEBS(S2,1.0D0,S1,SM2, 0.0D0,SM1)
          CGP=FACT*DCLEBS(S2,1.0D0,S1,SM2,+1.0D0,SM1)
          CGX=SQRT(0.5D0)*(CGM-CGP)
          CGY=SQRT(0.5D0)*(CGM+CGP)
        END IF

        IF((ITYPE.EQ.1.OR.ITYPE.EQ.2)
     &          .AND.MPLETK.EQ.MPLETL
     &          .AND.MSPROJK.EQ.MSPROJL) THEN
          CALL DAXPY_(nbsts,1.0d0,SCR,1,SDMZR,1)
        ELSE IF(ITYPE.EQ.3.OR.ITYPE.EQ.4) THEN
          If (iOpt.eq.1) Then
          CALL DAXPY_(nbsts,CGX*ROTMAT(1,1),SCR,1,SDMXR,1)
          CALL DAXPY_(nbsts,CGY*ROTMAT(2,1),SCR,1,SDMXI,1)
          CALL DAXPY_(nbsts,CG0*ROTMAT(3,1),SCR,1,SDMXR,1)

          CALL DAXPY_(nbsts,CGX*ROTMAT(1,2),SCR,1,SDMYR,1)
          CALL DAXPY_(nbsts,CGY*ROTMAT(2,2),SCR,1,SDMYI,1)
          CALL DAXPY_(nbsts,CG0*ROTMAT(3,2),SCR,1,SDMYR,1)

          CALL DAXPY_(nbsts,CGX*ROTMAT(1,3),SCR,1,SDMZR,1)
          CALL DAXPY_(nbsts,CGY*ROTMAT(2,3),SCR,1,SDMZI,1)
          CALL DAXPY_(nbsts,CG0*ROTMAT(3,3),SCR,1,SDMZR,1)
          Else
          CALL DAXPY_(nbsts,CGX,SCR,1,SDMXR,1)
          CALL DAXPY_(nbsts,CGY,SCR,1,SDMYI,1)
          CALL DAXPY_(nbsts,CG0,SCR,1,SDMZR,1)
          End If
        END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccc
c SPINORBIT
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Sign of the left-hand imaginary part is handled
c when doing DAXPY
        URR=USOR(LSS,BSS)
        UIR=USOI(LSS,BSS)
        URL=USOR(KSS,ASS)
        UIL=USOI(KSS,ASS)

        DO IDIR=1,3
          TMPR(:)=0.0D0
          TMPI(:)=0.0D0

C right side
          CALL DAXPY_(nbsts,       URR,pZMR(IDIR)%A2,1,TMPR,1)
          CALL DAXPY_(nbsts,-1.0d0*UIR,pZMI(IDIR)%A2,1,TMPR,1)
          CALL DAXPY_(nbsts,       UIR,pZMR(IDIR)%A2,1,TMPI,1)
          CALL DAXPY_(nbsts,       URR,pZMI(IDIR)%A2,1,TMPI,1)

C left side
         CALL DAXPY_(nbsts,       URL,TMPR,1,pZMR2(IDIR)%A2,1)
         CALL DAXPY_(nbsts,       UIL,TMPI,1,pZMR2(IDIR)%A2,1)
         CALL DAXPY_(nbsts,       URL,TMPI,1,pZMI2(IDIR)%A2,1)
         CALL DAXPY_(nbsts,-1.0d0*UIL,TMPR,1,pZMI2(IDIR)%A2,1)
        END DO
cccccccccccccccccccccc
c END SPINORBIT STUFF
cccccccccccccccccccccc

C END MAIN LOOP OVER STATES (KSS,LSS)
 2200   CONTINUE

       END DO
      END DO


C Store this density to DENSOUT
      IF(ITYPE.EQ.3.OR.ITYPE.EQ.4) THEN
        DO I=1,nbsts
          DENSOUT(1,I)=SDMXR2(I)
          DENSOUT(2,I)=SDMYR2(I)
          DENSOUT(3,I)=SDMZR2(I)
          DENSOUT(4,I)=SDMXI2(I)
          DENSOUT(5,I)=SDMYI2(I)
          DENSOUT(6,I)=SDMZI2(I)
        END DO
      ELSE
        DO I=1,nbsts
          DENSOUT(1,I)=SDMZR2(I)
          DENSOUT(2,I)=SDMZR2(I)
          DENSOUT(3,I)=SDMZR2(I)
          DENSOUT(4,I)=SDMZI2(I)
          DENSOUT(5,I)=SDMZI2(I)
          DENSOUT(6,I)=SDMZI2(I)
        END DO
      END IF

c Free memory
      CALL mma_deallocate(SCR)
      CALL mma_deallocate(TDMZZ)

      nullify(pZMI(3)%A2,pZMI(2)%A2,pZMI(1)%A2,pZMR(3)%A2,pZMR(2)%A2,
     &        pZMR(1)%A2)
      Call mma_deallocate(SDMZI)
      Call mma_deallocate(SDMZR)
      Call mma_deallocate(SDMYI)
      Call mma_deallocate(SDMYR)
      Call mma_deallocate(SDMXI)
      Call mma_deallocate(SDMXR)

      Call mma_deallocate(TMPI)
      Call mma_deallocate(TMPR)

      nullify(pZMI2(3)%A2,pZMI2(2)%A2,pZMI2(1)%A2,pZMR2(3)%A2,
     &        pZMR2(2)%A2,pZMR2(1)%A2)
      Call mma_deallocate(SDMZI2)
      Call mma_deallocate(SDMZR2)
      Call mma_deallocate(SDMYI2)
      Call mma_deallocate(SDMYR2)
      Call mma_deallocate(SDMXI2)
      Call mma_deallocate(SDMXR2)

      CALL mma_deallocate(MAPST)
      CALL mma_deallocate(MAPSP)
      CALL mma_deallocate(MAPMS)

      END SUBROUTINE MAKETDMAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Giovanni Ghigo                              *
************************************************************************
      Subroutine ChoMP2_TraS(iSymL, iSym,jSym, NumV, CMO,NCMO,
     &                               lUCHFV, iStrtVec_AB, nFVec,nFBatch)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden                                    *
* Written:  October 2004                                               *
* Modified for Cholesky-MP2 May 2005                                   *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)

#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Dimension CMO(NCMO)

* --- Memory to allocate & Nr. of Cholesky vectors transformable
*     A=Alpha(AO);  B=Beta(AO)

      IF ( .NOT. TCVXist(3,iSym,jSym)) RETURN

      Naj = 0
      Len_FAB = 0
      Len_aj = 0
      Len_XAj = 0
      NFAB = nBas(iSym) * ( nBas(jSym) + 1 ) /2
      Len_XAj = nBas(iSym) * nIsh(jSym)
      Naj = nSsh(iSym) * nIsh(jSym)

*     Allocate memory for Transformed Cholesky Vectors - TCVx
      Len_aj = Naj * NumV
      iStrt_aj = 0
      iStrt0_aj = 0
      Call GetMem('aj','ALLO','REAL',iStrt00_aj,Len_aj)
      iMemTCVX(3,iSym,jSym,1)=iStrt00_aj
      iMemTCVX(3,iSym,jSym,2)=Len_aj

* --- START LOOP iFBatch -----------------------------------------------
      DO iFBatch=1,nFBatch
        If (iFBatch.EQ.nFBatch) then
         NumFV = NumV - nFVec * (nFBatch-1)
        Else
         NumFV = nFVec
        EndIf
        iStrt0_aj = iStrt00_aj + (iFBatch-1) * nFVec * Naj

*       Allocate memory & Load Full Cholesky Vectors - CHFV
        Len_FAB = NFAB * NumFV
        iStrtVec_FAB = iStrtVec_AB + nFVec * (iFBatch-1)
        Call GetMem('FAB','Allo','Real',iStrt0_FAB,Len_FAB)
        Call RdChoVec(Work(iStrt0_FAB),NFAB,NumFV,iStrtVec_FAB,lUCHFV)

*  ---  Start Loop  iVec  ---
        Do iVec=1,NumFV   ! Loop  iVec
          iStrt_FAB = iStrt0_FAB + (iVec-1) * NFAB
          iStrt_aj = iStrt0_aj + (iVec-1) * Naj

*     --- 1st Half-Transformation  iBeta(AO) -> q(MO) only occupied
          jStrt0MO = 1
          Do j=1,jSym-1
            jStrt0MO = jStrt0MO + nBas(j) * nBas(j)
          EndDo
          jStrt0MO = jStrt0MO + nFro(jSym) * nBas(jSym)

C         From CHFV A(Alpha,Beta) to XAj(Alpha,jMO)
          Call GetMem('XAj','ALLO','REAL',iStrt0_XAj,Len_XAj)
          Call ProdsS_1(Work(iStrt_FAB), nBas(iSym),
     &                CMO(jStrt0MO),nIsh(jSym), Work(iStrt0_XAj))

*     --- 2nd Half-Transformation  iAlpha(AO) -> p(MO)
          iStrt0MO = 1
          Do i=1,iSym-1
            iStrt0MO = iStrt0MO + nBas(i) * nBas(i)
          EndDo
          iStrt0MO = iStrt0MO + (nFro(iSym)+nIsh(iSym)) * nBas(iSym)

C         From XAj(Alpha,jMO) to aj(a,j)
          Call ProdsS_2(Work(iStrt0_XAj), nBas(iSym),nIsh(jSym),
     &              CMO(iStrt0MO),nSsh(iSym), Work(iStrt_aj))

*     --- End of Transformations

          Call GetMem('XAj','FREE','REAL',iStrt0_XAj,Len_XAj)

        EndDo
*  ---  End Loop  iVec  ---

        Call GetMem('FAB','Free','Real',iStrt0_FAB,Len_FAB)
      ENDDO
* --- END LOOP iFBatch -------------------------------------------------

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iSymL)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!               2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RotateOrb(cMO,PACol,nBasis,nAtoms,PA,Maximisation,nOrb2loc,BName,nBas_per_Atom,nBas_Start,ThrRot,PctSkp,Debug)
! Author: Yannick Carissan.
!
! Modifications:
!    - October 6, 2005 (Thomas Bondo Pedersen):
!      Array PACol introduced in argument list.

use Constants, only: Zero, One, Half, Quart, Pi
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nBasis, nAtoms, nOrb2Loc, nBas_per_Atom(nAtoms), nBas_Start(nAtoms)
real(kind=wp), intent(inout) :: cMO(nBasis,*), PA(nOrb2Loc,nOrb2Loc,nAtoms)
real(kind=wp), intent(out) :: PACol(nOrb2Loc,2), PctSkp
logical(kind=iwp), intent(in) :: Maximisation, Debug
character(len=LenIn8), intent(in) :: BName(*)
real(kind=wp), intent(in) :: ThrRot
integer(kind=iwp) :: iAt, iCouple, iMO1, iMO2, iMO_s, iMO_t
real(kind=wp) :: Alpha, Alpha1, Alpha2, Ast, Bst, cos4alpha, Gamma_rot, PA_ss, PA_st, PA_tt, sin4alpha, SumA, SumB, Tst, Tstc, &
                 Tsts, xDone, xOrb2Loc, xTotal
character(len=LenIn8) :: PALbl
character(len=80) :: Txt

xDone = Zero
if (Debug) then
  write(u6,*) 'RotateOrb[Debug]: nBas_per_Atom: ',nBas_per_Atom(:)
  iCouple = 0
end if
do iMO1=1,nOrb2Loc-1
  do iMO2=iMO1+1,nOrb2Loc

    if (Debug) then
      iCouple = iCouple+1
      write(u6,'(a9,i5)') 'Couple n:',iCouple
      write(u6,'(a9,i5)') '    MO1 :',iMO1
      write(u6,'(a9,i5)') '    MO2 :',iMO2
    end if

    iMO_s = iMO1
    iMO_t = iMO2
    SumA = Zero
    SumB = Zero
    do iAt=1,nAtoms
      PA_st = PA(iMO_t,iMO_s,iAt)
      PA_ss = PA(iMO_s,iMO_s,iAt)
      PA_tt = PA(iMO_t,iMO_t,iAt)
      if (Debug) then
        write(u6,*) 'In RotateOrb'
        write(u6,*) '------------'
        PALbl = 'PA__'//BName(nBas_Start(iAt))(1:LenIn)
        call RecPrt(PALbl,' ',PA(1,1,iAt),nOrb2Loc,nOrb2Loc)
        write(u6,*) '**************************'
        write(u6,*) 'A :',iAt
        write(u6,*) '<',iMO_s,'|PA|',iMO_t,'> = ',PA_st
        write(u6,*) '<',iMO_s,'|PA|',iMO_s,'> = ',PA_ss
        write(u6,*) '<',iMO_t,'|PA|',iMO_t,'> = ',PA_tt
        write(u6,*) '**************************'
      end if
      SumA = SumA+PA_st**2-Quart*(PA_ss-PA_tt)**2
      SumB = SumB+PA_st*(PA_ss-PA_tt)
    end do
    Ast = SumA
    Bst = SumB

    if ((Ast == Zero) .and. (Bst == Zero)) then
      cos4alpha = -One
      sin4alpha = Zero
    else
      cos4alpha = -Ast/sqrt(Ast**2+Bst**2)
      sin4alpha = Bst/sqrt(Ast**2+Bst**2)
    end if
    Tst = abs(cos4alpha)-One
    if (Tst > Zero) then
      if (Tst > 1.0e-10_wp) then
        write(Txt,'(A,D18.10)') 'Actual: cos4alpha = ',cos4alpha
        call SysAbendMsg('RotateOrb','-1.0 < cos4alpha < 1.0',Txt)
      else
        if (cos4alpha < Zero) then
          cos4alpha = -One
        else
          cos4alpha = One
        end if
      end if
    end if

    ! On choisit le cos car Alpha IN [0,Pi/2]

    Alpha1 = acos(cos4alpha)*Quart
    Alpha2 = asin(sin4alpha)*Quart
    if (Alpha2 < Zero) Alpha1 = Alpha2+Pi
    Alpha = Alpha1
    if (.not. Maximisation) then
      Gamma_rot = Alpha-Pi*Quart
    else
      Gamma_rot = Alpha
    end if
    if (Debug) then
      write(u6,'(a9,f10.5)') '   Ast :',Ast
      write(u6,'(a9,f10.5)') '   Bst :',Bst
      write(u6,'(a9,f10.5)') 'Alpha1 :',Alpha1
      write(u6,'(a9,f10.5)') 'Alpha2 :',Alpha2
      write(u6,'(a9,f10.5)') ' Gamma :',Gamma_rot
    end if

    Tsts = sin(Gamma_rot)
    Tstc = One-cos(Gamma_rot)
    if ((abs(Tsts) > ThrRot) .or. (abs(Tstc) > ThrRot)) then
      call Rot_st(cMO(1,iMO_s),cMO(1,iMO_t),nBasis,Gamma_rot,Debug)
      call UpdateP(PACol,BName,nBas_Start,nOrb2Loc,nAtoms,PA,Gamma_rot,iMO_s,iMO_t,Debug)
      xDone = xDone+One
    end if

    if (Debug) then
      call RecPrt('MO after rotation',' ',cMO,nBasis,nBasis)
    end if

  end do !iMO2
end do !iMO1

if (nOrb2Loc > 1) then
  xOrb2Loc = real(nOrb2Loc,kind=wp)
  xTotal = xOrb2Loc*(xOrb2Loc-One)*Half
  PctSkp = 1.0e2_wp*(xTotal-xDone)/xTotal
else
  PctSkp = Zero
end if

return

end subroutine RotateOrb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1998, Roland Lindh                                *
!               1998, Samuel Mikes                                     *
!***********************************************************************

subroutine MVe(rV2Int,rV4Int,Sxyz,na,nb,Alpha,Beta,nZeta)
!***********************************************************************
!                                                                      *
! Object: to compute intermediate integrals for the evaluation of the  *
!          mass velocity integrals.                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!                                                                      *
!             Correct out of bound reference, February '98, Samuel     *
!             Mikes and Roland Lindh.                                  *
!***********************************************************************

use Constants, only: Two, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: na, nb, nZeta
real(kind=wp), intent(out) :: rV2Int(nZeta,3,0:na,0:nb,2), rV4Int(nZeta,3,0:na,0:nb)
real(kind=wp), intent(in) :: Sxyz(nZeta,3,0:na+2,0:nb+2), Alpha(nZeta), Beta(nZeta)
#include "print.fh"
integer(kind=iwp) :: ia, ib, iCar, iPrint, iRout
character(len=80) :: Label

iRout = 192
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  call RecPrt(' In MVe: Alpha',' ',Alpha,nZeta,1)
  call RecPrt(' In MVe: Beta ',' ',Beta,nZeta,1)
  do ib=0,nb+2
    do ia=0,na+2
      write(Label,'(A,I2,A,I2,A)') ' In MVe: Sxyz(',ia,',',ib,')'
      call RecPrt(Label,' ',Sxyz(:,:,ia,ib),nZeta,3)
    end do
  end do

end if
do ib=0,nb
  do ia=0,na
    do iCar=1,3
      rV2Int(:,iCar,ia,ib,1) = Four*Alpha**2*Sxyz(:,iCar,ia+2,ib)-Two*Alpha*real(2*ia+1,kind=wp)*Sxyz(:,iCar,ia,ib)
      if (ia >= 2) rV2Int(:,iCar,ia,ib,1) = rV2Int(:,iCar,ia,ib,1)+real(ia*(ia-1),kind=wp)*Sxyz(:,iCar,ia-2,ib)

      rV2Int(:,iCar,ia,ib,2) = Four*Beta**2*Sxyz(:,iCar,ia,ib+2)-Two*Beta*real(2*ib+1,kind=wp)*Sxyz(:,iCar,ia,ib)
      if (ib >= 2) rV2Int(:,iCar,ia,ib,2) = rV2Int(:,iCar,ia,ib,2)+real(ib*(ib-1),kind=wp)*Sxyz(:,iCar,ia,ib-2)

      rV4Int(:,iCar,ia,ib) = Four*Alpha**2*Four*Beta**2*Sxyz(:,iCar,ia+2,ib+2)- &
                             Four*Alpha**2*Two*Beta*real(2*ib+1,kind=wp)*Sxyz(:,iCar,ia+2,ib)- &
                             Four*Beta**2*Two*Alpha*real(2*ia+1,kind=wp)*Sxyz(:,iCar,ia,ib+2)+ &
                             Two*Alpha*real(2*ia+1,kind=wp)*Two*Beta*real(2*ib+1,kind=wp)*Sxyz(:,iCar,ia,ib)
      if (ia >= 2) rV4Int(:,iCar,ia,ib) = rV4Int(:,iCar,ia,ib)+real(ia*(ia-1),kind=wp)* &
                                          (Four*Beta**2*Sxyz(:,iCar,ia-2,ib+2)-Two*Beta*real(2*ib+1,kind=wp)*Sxyz(:,iCar,ia-2,ib))
      if (ib >= 2) rV4Int(:,iCar,ia,ib) = rV4Int(:,iCar,ia,ib)+real(ib*(ib-1),kind=wp)* &
                                          (Four*Alpha**2*Sxyz(:,iCar,ia+2,ib-2)-Two*Alpha*real(2*ia+1,kind=wp)*Sxyz(:,iCar,ia,ib-2))
      if ((ia >= 2) .and. (ib >= 2)) rV4Int(:,iCar,ia,ib) = rV4Int(:,iCar,ia,ib)+ &
                                                            real(ia*(ia-1)*ib*(ib-1),kind=wp)*Sxyz(:,iCar,ia-2,ib-2)
    end do
  end do
end do

if (iPrint >= 99) then
  do ib=0,nb
    do ia=0,na
      write(Label,'(A,I2,A,I2,A)') 'In MVe: rV2Int(',ia,',',ib,',1)'
      call RecPrt(Label,' ',rV2Int(:,:,ia,ib,1),nZeta,3)
      write(Label,'(A,I2,A,I2,A)') 'In MVe: rV2Int(',ia,',',ib,',2)'
      call RecPrt(Label,' ',rV2Int(:,:,ia,ib,2),nZeta,3)
      write(Label,'(A,I2,A,I2,A)') 'In MVe: rV4Int(',ia,',',ib,')'
      call RecPrt(Label,' ',rV4Int(:,:,ia,ib),nZeta,3)
    end do
  end do
end if

return

end subroutine MVe

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine KnEGrd(
#define _CALLING_
#include "grd_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: to compute the kinetic energy integrals with the Gauss-      *
*         Hermite quadrature.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Modified to multipole moments November '90               *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified to gradients October '91.                       *
************************************************************************
      use Her_RW
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"

#include "grd_interface.fh"

*     Local variables
      Logical ABeq(3)
*
*     Statement function for Cartesian index
*
*     Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*     iOff(ixyz) = ixyz*(ixyz+1)*(ixyz+2)/6
*     Index(ixyz,ix,iz) = Ind(ixyz,ix,iz) + iOff(ixyz)
*
      iRout = 150
      iPrint = nPrint(iRout)
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+3)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+3)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp+1)
      ipRnxyz = nip
      nip = nip + nZeta*3*(la+3)*(lb+3)*(nOrdOp+1)
      ipTxyz = nip
      nip = nip + nZeta*3*(la+2)*(lb+2)
      ipA = nip
      nip = nip + nZeta
      ipB = nip
      nip = nip + nZeta
      If (nip-1.gt.nArr*nZeta) Then
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Call ErrTra
         Write (6,*) ' Abend in KnEGrd'
         Call Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In KnEGrd: A',' ',A,1,3)
         Call RecPrt(' In KnEGrd: RB',' ',RB,1,3)
         Call RecPrt(' In KnEGrd: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In KnEGrd: P',' ',P,nZeta,3)
         Write (6,*) ' In KnEGrd: la,lb=',la,lb
      End If
*
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la+2,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb+2,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the contribution from the multipole moment operator
*
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),
     &            nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the cartesian components for the multipole moment
*     integrals. The integrals are factorized into components.
*
       Call Assmbl(Array(ipRnxyz),
     &             Array(ipAxyz),la+2,
     &             Array(ipRxyz),nOrdOp,
     &             Array(ipBxyz),lb+2,
     &             nZeta,HerW(iHerW(nHer)),nHer)
*
*     Compute the cartesian components for the kinetic energy integrals.
*     The kinetic energy components are linear combinations of overlap
*     components.
*
      ipAOff = ipA
      Do 200 iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
 200  Continue
*
      ipBOff = ipB
      Do 210 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
 210  Continue
*
      Call Kntc(Array(ipTxyz),Array(ipRnxyz),la+1,lb+1,
     &          Array(ipA),Array(ipB),nZeta)
*
*     Combine the cartesian components to the gradient of the kinetic
*     energy integral and trace with the variational density matrix.
*
      Call CmbnT1(Array(ipRnxyz),nZeta,la,lb,Zeta,rKappa,Final,
     &            Array(ipTxyz),Array(ipA),Array(ipB),
     &            Grad,nGrad,DAO,IfGrad,IndGrd,
     &            dc(mdc)%nStab,dc(ndc)%nStab,kOp)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iStabM)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ORBORD_GAS(NSMOB,MXPOBS,MXPNGAS,NGAS,NGSOB,NGSOBT,NTOOBS,NTOOB,IREOST,IREOTS,ISFTO,IBSO,NOBPTS,IOBPTS,ISFSO,NOBPT)
! Obtain Reordering arrays for orbitals
! (See note below for assumed ordering)
!
! GAS version
!
! =====
! Input
! =====
!  NSMOB  : Number of orbital symmetries
!  MXPOBS : Max number of orbital symmetries allowed by program
!  MXPNGAS: Max number of GAS spaces allowed by program
!  NGAS   : Number of GAS spaces
!  NGSOB  : Number of GAS orbitals per symmetry and space
!  NGSOBT : Number of GAS orbitals per space
!  NTOOBS : Number of orbitals per symmetry,all types
!
! ======
! Output
! ======
!  IREOST : Reordering array symmetry => type
!  IREOTS : Reordering array type     => symmetry
!  ISFTO  : Symmetry array for type ordered orbitals
!  IBSO   : First orbital of given symmetry (symmetry ordered)
!  NOBPTS : Number of orbitals per subtype and symmetry
!  IOBPTS : Off sets for orbitals of given subtype and symmetry
!           ordered according to input integrals
!
! ISFSO  : Symmetry of orbitals, symmetry ordereing
!
! Jeppe Olsen, Winter 1994

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSMOB, MXPOBS, MXPNGAS, NGAS, NGSOB(MXPOBS,MXPNGAS), NGSOBT(MXPNGAS), NTOOBS(NSMOB), NTOOB
integer(kind=iwp), intent(out) :: IREOST(NTOOB), IREOTS(NTOOB), ISFTO(NTOOB), IBSO(NSMOB), NOBPTS(MXPNGAS,MXPOBS), &
                                  IOBPTS(MXPNGAS,MXPOBS), ISFSO(NTOOB), NOBPT(MXPNGAS)
integer(kind=iwp) :: IADD, IBSSM, IGAS, IOFF, IORB, ISM, ISTOFF, ISYM, ITSOFF, NPREV

! ==========================
! Note on order of orbitals
! ==========================
!
! The orbitals are supposed to be imported ordered symmetry-type
! ordered as
!
! Loop over symmetries of orbitals
!  Loop over GAS spaces
!   Loop over orbitals of this sym and GAS
!   End of Loop over orbitals
!  End of Loop over Gas spaces
! End of loop over symmetries
!
! Internally the orbitals are reordered to type symmetry order
! where the outer loop is over types and the inner loop is
! over symmetries, i.e.
!
! Loop over GAS spaces
!  Loop over symmetries of orbitals
!   Loop over orbitals of this sym and GAS
!   End of Loop over orbitals
!  End of loop over symmetries
! End of Loop over Gas spaces
!
! 1:  Construct ISFTO, IREOST,IREOTS,NOBPTS,IOBPTS
!
! To get rid of annoying and incorrect compiler warnings
IBSSM = 0

ITSOFF = 1
do IGAS=1,NGAS
  do ISYM=1,NSMOB
    if (ISYM == 1) then
      IBSSM = 1
    else
      IBSSM = IBSSM+NTOOBS(ISYM-1)
    end if
    NPREV = sum(NGSOB(ISYM,1:IGAS-1))
    IADD = 0
    NOBPTS(IGAS,ISYM) = NGSOB(ISYM,IGAS)
    IOBPTS(IGAS,ISYM) = ITSOFF
    !NOBPTS(ISYM,IGAS) = NGSOB(ISYM,IGAS)
    !IOBPTS(ISYM,IGAS) = ITSOFF
    do IORB=ITSOFF,ITSOFF+NGSOB(ISYM,IGAS)-1
      IADD = IADD+1
      IREOTS(IORB) = IBSSM-1+NPREV+IADD
      IREOST(IBSSM-1+NPREV+IADD) = IORB
      !ITFTO(IORB) = IGAS
      ISFTO(IORB) = ISYM
    end do
    ITSOFF = ITSOFF+NGSOB(ISYM,IGAS)
  end do
end do

! 2 : ISFSO,ITFSO

ISTOFF = 1
do ISYM=1,NSMOB
  do IGAS=1,NGAS
    ISFSO(ISTOFF:ISTOFF+NGSOB(ISYM,IGAS)-1) = ISYM
    !ITFSO(ISTOFF:ISTOFF+NGSOB(ISYM,IGAS)-1) = IGAS
    ISTOFF = ISTOFF+NGSOB(ISYM,IGAS)
  end do
end do

! 3 IBSO, NOBPT

IOFF = 1
do ISM=1,NSMOB
  IBSO(ISM) = IOFF
  IOFF = IOFF+NTOOBS(ISM)
end do
NOBPT(1:NGAS) = NGSOBT(1:NGAS)

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' =================='
write(u6,*) ' Output from ORBORD'
write(u6,*) ' =================='
write(u6,*)
write(u6,*) ' Symmetry of orbitals, type ordered'
call IWRTMA(ISFTO,1,NTOOB,1,NTOOB)
write(u6,*) ' Symmetry => type reordering array'
call IWRTMA(IREOST,1,NTOOB,1,NTOOB)
write(u6,*) ' Type => symmetry reordering array'
call IWRTMA(IREOTS,1,NTOOB,1,NTOOB)
write(u6,*) ' IBSO array'
call IWRTMA(IBSO,1,NSMOB,1,NSMOB)

write(u6,*) ' NOBPTS'
call IWRTMA(NOBPTS,NGAS,NSMOB,MXPNGAS,MXPOBS)
write(u6,*) ' NOBPT'
call IWRTMA(NOBPT,NGAS,1,MXPNGAS,1)
write(u6,*) ' IOBPTS'
call IWRTMA(IOBPTS,NGAS,NSMOB,MXPNGAS,MXPOBS)

write(u6,*) ' ISFTO array :'
call IWRTMA(ISFTO,1,NTOOB,1,NTOOB)
!write(u6,*) ' ITFSO array :'
!call IWRTMA(ITFSO,1,NTOOB,1,NTOOB)

write(u6,*) ' ISFSO array :'
call IWRTMA(ISFSO,1,NTOOB,1,NTOOB)
!write(u6,*) ' ITFTO array :'
!call IWRTMA(ITFTO,1,NTOOB,1,NTOOB)
#endif

end subroutine ORBORD_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, IBM                                              *
************************************************************************
      Integer Function iPrmt(jOper,iChct)
************************************************************************
*     Returns the phase factor of a basis function under a symmetry    *
*     operation, jOper. iChct contains the information about the       *
*     character of the basis function.                                 *
************************************************************************
      Use Symmetry_Info, only: iOper
      Implicit Real*8 (a-h,o-z)
#define _CHECK_
#ifdef _CHECK_
      If (Size(iOper)<1) Then
         Write (6,*) 'iPrmt; iOper not defined.'
         Call Abend()
      End If
#endif
      iPrmt = 1
      iCom= iAnd(iOper(jOper),iChct)
      Do i = 1, 3
         If (iAnd(iCom,2**(i-1)).ne.0) iPrmt = iPrmt*(-1)
      End Do
      Return
      End Function iPrmt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000,2016, Valera Veryazov                             *
************************************************************************
************************************************************************
*                                                                      *
* Author:   Valera Veryazov 2000-2016                                  *
*           Theoretical Chemistry                                      *
*           Lund University                                            *
*           Sweden                                                     *
*                                                                      *
************************************************************************
*  CheckRun
*
*> @brief
*>   Check that the program was started via molcas shell script
*> @author V. Veryazov
*>
*> @details
*> The routine checks ``MOLCAS_STAMP`` and quits if this variable
*> has wrong value (to prevent the creation of dummy files)
************************************************************************
      Subroutine CheckRun()
      Character Molcas*256
      Character Env*40
      Env='MOLCAS_STAMP'
*
      Molcas=' '
      Call getenvf(Env,Molcas)
      if (Molcas(1:1) .eq. 'A') then
      Return
      endif
#ifdef _HAVE_EXTRA_
      if (Molcas(1:1) .ne. '5') then
        write (6,*) 'Usage: molcas module_name input'
        Call Abend()
      endif
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2022, Jie J. Bao                                       *
************************************************************************
******************************************************************
* history:                                                       *
* Jie J. Bao, on Apr. 11, 2022, created this file.               *
******************************************************************

* This file contains subroutines relating to generalized 1-e
* density matrix (GD) called in CMSNewton, including
* CalcGD:       calculating GD with lucia.
* CalcDg:       calculating Dg matrix, namely sum_{vx}{GD^KL_vx * g_tuvx}
* RotGD:        GD^KL_tu = sum_{MN}{U^KM * U^LN * GD^MN_tu}
* TransposeMat: transform GD^KL_tu from leading with state indices
*               to leading with orbital indices in mode 1, and vice
*               versa in mode 2.



      Subroutine RotGD(GD,R,nGD,lRoots,NAC2)
      use CMS, only: RGD
      INTEGER nGD,lRoots,NAC2
      Real*8 GD(nGD),R(lRoots**2)

      INTEGER iNAC2,iLoc,lRoots2
*      Real*8 RGD(lRoots**2),RGDR(lRoots**2)

      lRoots2=lRoots**2


C      write(6,*) 'rotation matrix in RotGD'
C      CALL RecPrt(' ',' ',R,lRoots,lRoots)
C
C      write(6,*) 'GD matrix after rotation'
C      CALL RecPrt(' ',' ',GD,lRoots2,NAC2)


      DO iNAC2=1,NAC2
       iLoc=(iNAC2-1)*lRoots2+1
       CALL DGEMM_('T','N',lRoots,lRoots,lRoots,
     &               1.0d0,R       ,lRoots,GD(iLoc),lRoots,
     &               0.0d0,RGD     ,lRoots)
       CALL DGEMM_('N','N',lRoots,lRoots,lRoots,
     &               1.0d0,RGD     ,lRoots,R       ,lRoots,
     &               0.0d0,GD(iLoc),lRoots)
      END DO

C      write(6,*) 'GD matrix after rotation'
C      CALL RecPrt(' ',' ',GD,lRoots2,NAC2)

      RETURN
      End Subroutine


      Subroutine TransposeMat(Matout,Matin,nElem,nRow_in,nCol_in)
      INTEGER nElem,nRow_in,nCol_in,iRow,iCol,iOff1,iOff2
      Real*8 Matin(nElem),Matout(nElem)

      IF(nRow_in*nCol_in.ne.nElem) THEN
       write(6,*) 'Error in TransposeMat()'
       write(6,*) 'nRow_in*nCol_in != nElem'
      END IF

      DO iCol=1,nCol_in
       iOff1=(iCol-1)*nRow_in
       Do iRow=1,nRow_in
        iOff2=(iRow-1)*nCol_in
        Matout(iOff2+iCol)=Matin(iOff1+iRow)
       End Do
      END DO

      RETURN
      End Subroutine
************************************************************************

      Subroutine CalcDg(Dgorbit,GDorbit,Gtuvx,nGD,nTUVX,NAC,lRoots)
      INTEGER nGD,nTUVX,NAC,lRoots
      Real*8 Dgorbit(nGD),GDorbit(nGD),Gtuvx(nTUVX)

      INTEGER NAC2,lRoots2

      NAC2=NAC**2
      lRoots2=lRoots**2

      CALL DGEMM_('T','N',NAC2,lRoots2,NAC2,1.0d0,
     &              Gtuvx,NAC2,GDorbit,NAC2,0.0d0,
     &                         Dgorbit,NAC2)

      RETURN
      End Subroutine
************************************************************************

      Subroutine CalcGD(GD,nGD)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
#include "rasscf_lucia.fh"
      INTEGER nGD
      Real*8 GD(nGD)
      INTEGER CIDisk1,CIDisk2,iVecL,iVecR,iDummy
      INTEGER tlw6,tlw7,ldtmp,lsdtmp
      INTEGER p,q,ipq,iqp,NAC2,IOffNIJ1,IOffNIJ2
      REAL*8 Dummy(1)

      NAC2=NAC**2
      tlw6=lw6
      tlw7=lw7
      Call GetMem('LVEC','ALLO','REAL',iVecL,NConf)
      Call GetMem('RVEC','ALLO','REAL',iVecR,NConf)
      Call GetMem('Dtmp','ALLO','REAL',ldtmp,NAC**2)
      Call GetMem('SDtmp','ALLO','REAL',lsdtmp,NAC**2)
      lw6=ldtmp
      lw7=lsdtmp
      CIDisk1=IADR15(4)
      Do jRoot=1,lRoots
       Call DDafile(JOBIPH,2,Work(iVecL),nConf,CIDisk1)
       C_Pointer=iVecL
       CIDisk2=IADR15(4)
       Do kRoot=1,jRoot-1
        Call DDafile(JOBIPH,2,Work(iVecR),nConf,CIDisk2)
        Call Lucia_Util('Densi',iVecR,iDummy,Dummy)
        IOffNIJ1=(lRoots*(jRoot-1)+kRoot-1)*NAC2
        IOffNIJ2=(lRoots*(kRoot-1)+jRoot-1)*NAC2
C        write(6,*)'GD matrix',jRoot,kRoot
C        CALL RecPrt(' ',' ',WORK(LW6),NAC,NAC)
        Call DCopy_(NAC2,WORK(LW6),1,GD(IOffNIJ1+1),1)
         dO q=1,NAC
          do p=1,NAC
          ipq=(q-1)*NAC+p
          iqp=(p-1)*NAC+q
          GD(IOffNIJ2+iqp)=WORK(LW6+ipq-1)
*          GDMat(NIJ2,q,p)=WORK(LW6+q-1+(p-1)*NAC)
          end do
         eND dO
       End Do
       kRoot=jRoot
       Call DDafile(JOBIPH,2,Work(iVecR),nConf,CIDisk2)
       Call Lucia_Util('Densi',iVecR,iDummy,Dummy)
       IOffNIJ1=(lRoots+1)*(jRoot-1)*NAC2
C       write(6,*)'GD matrix',jRoot,kRoot
C       CALL RecPrt(' ',' ',WORK(LW6),NAC,NAC)
       Call DCopy_(NAC2,WORK(LW6),1,GD(IOffNIJ1+1),1)
      End DO
      lw6=tlw6
      lw7=tlw7
      Call GetMem('LVEC','FREE','REAL',iVecL,NConf)
      Call GetMem('RVEC','FREE','REAL',iVecR,NConf)
      Call GetMem('Dtmp','FREE','REAL',ldtmp,NAC**2)
      Call GetMem('SDtmp','Free','REAL',lsdtmp,NAC**2)
      RETURN
      END Subroutine
************************************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Jonna Stalring                                   *
************************************************************************
*
      Subroutine calcerr(kappa,iestate)
*
*-------------------------------------------------
* Jonna 000411
*
* Calculates the derivative d E_j
*                           ------ = 2\sum_pq Fpq kappa_pq
*                            d w
*
* which estimates the error in the SA.
*---------------------------------------------------
*
      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "SysDef.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
#include "glbbas_mclr.fh"
#include "Files_mclr.fh"
#include "sa.fh"
      Real*8 kappa(*)
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
      ng1=itri(ntash,ntash)
      ng2=itri(ng1,ng1)
*
      Call Getmem('G1Q ','ALLO','REAL',ipG1Q,ng1)
      Call Getmem('G1R ','ALLO','REAL',ipG1R,ntash**2)
      Call Getmem('G2R ','ALLO','REAL',ipG2R,ntash**4)
      Call Getmem('T   ','ALLO','REAL',ipT,ndens2)
      Call Getmem('pq  ','ALLO','REAL',ipq,ndens2)
c
c Get densities of iestate in triangular and rectangular form.
c
      Call rddj(Work(ipG1R),Work(ipG1Q),Work(ipG2R),iestate)
c
c Get Fock matrix ipT
c
      Call FockGen(1.0d0,Work(ipG1R),Work(ipG2R),
     &             Work(ipT),Work(ipq),1)
c
c Print energy
c
c     Call prnte(Work(ipG1q),Work(ipT))
c
c     Call Recprt('KAPP',' ',kappa,nDens2,1)
c     Call Recprt('FOCK',' ',Work(ipT),nDens2,1)
c
      dejdw = 0.0d0
      Do iS=1,nsym
         dejdw = dejdw + ddot_(nBas(is)**2,Work(ipT+ipmat(is,is)-1),
     &           1,kappa(ipmat(is,is)),1)
      End do
      dejdw = 2.0d0*dejdw
c     is=1
c     write(*,*)'Work(ipT+ipmat(is,is)-1)',Work(ipT+ipmat(is,is)-1)
c     write(*,*)'kappa(ipmat(is,is)+1)',kappa(ipmat(is,is)+1)
c
c     d E_j / d w_i, without constraint
c     Write(6,200) iestate,istate,dejdw
c
      If (iestate.eq.istate) Then
c        d E_i / d w_i, with the constraint sum(w_i)=1,
c        multiplied by 1-w_i... which happens to be equal to
c        d E_i / d w_i, without constraint
c        change sign, because this is the *error*
         Write(6,100) iestate,-dejdw
      End If
100   Format(' **********'/'                 ',
     &       ' Estimated error in the energy of state ',I5,': ',ES12.5/
     &       ' **********')
*200   Format(' Derivative of the energy of state ',I5,
*     &       ' with the weight ',I5,': ',ES12.5)
*
      Call Getmem('pq  ','FREE','REAL',ipq,ndens2)
      Call Getmem('T   ','FREE','REAL',ipT,ndens2)
      Call Getmem('G2R ','FREE','REAL',ipG2R,ntash**4)
      Call Getmem('G1R ','FREE','REAL',ipG1R,ntash**2)
      Call Getmem('G1Q ','FREE','REAL',ipG1Q,ng1)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
cpgi$g opt=1
      SUBROUTINE IJKL_CPF(JSY,INDEX,C,S,FIJKL,BUFIN,IBUFIN,
     *ENP,EPP)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION JSY(*),INDEX(*),C(*),S(*),FIJKL(*),BUFIN(*),
     &           IBUFIN(*),ENP(*),EPP(*)
      PARAMETER(IPOW8=2**8,IPOW16=2**16,IPOW24=2**24)
      PARAMETER(IPOW6=2**6,IPOW13=2**13,IPOW19=2**19)
*
      JSYM(L)=JSUNP_CPF(JSY,L)
*
      FINI=0.0D0 ! dummy initialize
      NCONF=JSC(4)
      ICHK=0
      NIJ=IROW(LN+1)
      NIJKL=NIJ*(NIJ+1)/2
      DO 5 I=1,NIJKL
      FIJKL(I)=D0
5     CONTINUE
      KKBUF0=(RTOI*(KBUFF1+2)-2)/(RTOI+1)
      KKBUF1=RTOI*KKBUF0+KKBUF0+1
      KKBUF2=KKBUF1+1
      IADR=LASTAD(1)
201   CALL iDAFILE(Lu_TiABCI,2,IBUFIN,KKBUF2,IADR)
      LENGTH=IBUFIN(KKBUF1)
      IADR=IBUFIN(KKBUF2)
      IF(LENGTH.EQ.0)GO TO 209
      CALL SCATTER(LENGTH,FIJKL,IBUFIN(RTOI*KKBUF0+1),BUFIN)
209   IF(IADR.NE.-1) GO TO 201
      IADD10=IAD10(5)
100   CALL dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
      CALL iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 100
      IF(LEN.LT.0)GO TO 200
      DO 10 IN=1,LEN
      IND=ICOP1(IN)
      IF(ICHK.NE.0)GO TO 460
      IF(IND.NE.0)GO TO 22
      ICHK=1
      GO TO 10
460   ICHK=0
      INDI=IND
*      IP=MOD(INDI,IPOW8)
*      JP=MOD(INDI/IPOW8,IPOW8)
*      KP=MOD(INDI/IPOW16,IPOW8)
*      LP=MOD(INDI/IPOW24,IPOW8)
      IP=IBITS(INDI,0,8)
      JP=IBITS(INDI,8,8)
      KP=IBITS(INDI,16,8)
      LP=IBITS(INDI,24,8)
      NIJ=IROW(IP)+JP
      NKL=IROW(KP)+LP
      IND=NIJ*(NIJ-1)/2+NKL
      FINI=FIJKL(IND)
      GO TO 10
22    IF(ABS(FINI).LT.1.d-06)GO TO 10
CPAM97      IVL=IAND(IND,63)
CPAM97      IC2=IAND(ISHFT(IND,-6),8191)
CPAM97      IC1=IAND(ISHFT(IND,-19),8191)
*      IVL=MOD(IND,IPOW6)
*      IC2=MOD(IND/IPOW6,IPOW13)
*      IC1=MOD(IND/IPOW19,IPOW13)
      IVL=IBITS(IND, 0,6)
      IC2=IBITS(IND,6,13)
      IC1=IBITS(IND,19,13)
      COPI=COP(IN)*FINI
      IF(IVL.NE.0)GO TO 13
      IF(IC1.NE.IREF0)GO TO 16
      COPI=COPI/SQRT(ENP(IC2))
      S(IC2)=S(IC2)+COPI
      IF(ITER.EQ.1)GO TO 10
      EPP(IC2)=EPP(IC2)+COPI*C(IC2)
      GO TO 10
16    IF(IC2.NE.IREF0)GO TO 17
      COPI=COPI/SQRT(ENP(IC1))
      S(IC1)=S(IC1)+COPI
      IF(ITER.EQ.1)GO TO 10
      EPP(IC1)=EPP(IC1)+COPI*C(IC1)
      GO TO 10
17    FACS=D1
      S(IC1)=S(IC1)+FACS*COPI*C(IC2)
      S(IC2)=S(IC2)+FACS*COPI*C(IC1)
      GO TO 10
13    INDA=IRC(IVL)+IC1
      INDB=IRC(IVL)+IC2
      FACS=D1
      NA=INDEX(INDA)
      NB=INDEX(INDB)
      NS1=JSYM(INDA)
      NS1L=MUL(NS1,LSYM)
      INUM=NVIR(NS1L)
      IF(IVL.GE.2)INUM=NNS(NS1L)
      CALL DAXPY_(INUM,COPI*FACS,C(NB+1),1,S(NA+1),1)
      CALL DAXPY_(INUM,COPI*FACS,C(NA+1),1,S(NB+1),1)
10    CONTINUE
      GO TO 100
200   RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
*               1998, Roland Lindh                                     *
************************************************************************
      Subroutine TraDrv(IPR,lSquare,
     &                  iSym,jSym,kSym,lSym,
     &                  iBas,jBas,kBas,lBas,
     &                  iOrb,jOrb,kOrb,lOrb,
     &                  iFro,jFro,kFro,lFro,
     &                  iIsh,jIsh,kIsh,lIsh,
     &                  iAsh,jAsh,kAsh,lAsh,
     &                  ij_Bas_pairs,kl_Bas_pairs,
     &                  ij_Orb_pairs,kl_Orb_pairs,
     &                  off_PUVX,off_sqMat,off_ltMat,mxSym,
     &                  CMO,PUVX,D1I,FI,D1A,FA,ExFac)
************************************************************************
*                                                                      *
*     control subsection for:                                          *
*     - transformation of ERIs from AO to MO basis                     *
*     - Fock matrix generation                                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
*     Modified to only need unique symmetry blocks, R. Lindh, March '98*
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Parameter(Zero=0.0d0)
#include "WrkSpc.fh"
#include "timers.fh"
*
      Integer off_PUVX(mxSym,mxSym,mxSym), off_sqMat(*), off_ltMat(*)
      Dimension CMO(*), PUVX(*)
      Dimension D1I(*), D1A(*), FI(*), FA(*)
      Integer case1, case2
      Logical Process_Twice, lSquare
*
      iTri(i,j)=i*(i-1)/2+j
*
*
*     generate offsets
      iiOff  = off_sqMat(iSym) + iFro*iBas + 1
      jjOff  = off_sqMat(jSym) + jFro*jBas + 1
      kkOff  = off_sqMat(kSym) + kFro*kBas + 1
      llOff  = off_sqMat(lSym) + lFro*lBas + 1
      iiiOff = iiOff + iIsh*iBas
      jjjOff = jjOff + jIsh*jBas
      kkkOff = kkOff + kIsh*kBas
      lllOff = llOff + lIsh*lBas
*
*     Generate logical flag for unique symmetry blocks
*
      Process_Twice = (iTri(iSym,jSym).ne.iTri(kSym,lSym)) .and.
     &                .Not.lSquare
*
*     find cases
      case1 = 4
      If ( iSym.eq.jSym ) case1 = case1-2
      If ( iSym.eq.kSym ) case1 = case1-1
      case2 = iAsh*jAsh*kAsh*lAsh
*
*     quit, if this integral block is not used
      If ( case1.eq.4 .and. case2.eq.0 ) then
        Return
      End If
*
*     allocate memory
      nScrt1=0
      If (iSym.eq.jSym) nScrt1=iBas*jBas
      If (kSym.eq.lSym) nScrt1 = Max(nScrt1,kBas*lBas)
      nBuf2 = Max(jBas*iAsh,kBas*lAsh,iBas*jAsh)
      nBuf3 = Max(jOrb*iAsh,kAsh*lAsh,iOrb*jAsh)
*
*     PQVX and TURS are the halftransformed integrals
*
      nPQVX = ij_Bas_pairs*kl_Orb_pairs
      If (Process_Twice) Then
         nTURS = ij_Orb_pairs*kl_Bas_pairs
         nBuf2 = Max(nBuf2,ij_Orb_pairs,lBas*kAsh)
         nBuf3 = Max(nBuf3,kAsh*lOrb,kOrb*lAsh)
      Else
         nTURS = 0
      End If
*
      If (nScrt1.ne.0)
     &    Call GetMem('TraScr1','Allo','Real',ipScrt1,nScrt1)
      Call GetMem('TraScr2','Allo','Real',lBuf2,nBuf2)
      Call GetMem('TraScr3','Allo','Real',lBuf3,nBuf3)
*
      Call GetMem('TraScr4','Allo','Real',ipPQVX,nPQVX)
      call dcopy_(nPQVX,[Zero],0,Work(ipPQVX),1)
      If (nTURS.gt.0) Then
         Call GetMem('TraScr6','Allo','Real',ipTURS,nTURS)
         call dcopy_(nTURS,[Zero],0,Work(ipTURS),1)
      End If
*
      Call GetMem('TraScr5','Max ','Real',ipInBuf,nInBuf)
      nInBuf=Min(nInBuf,(ij_Bas_pairs*kl_Bas_pairs+1))
      nInBuf=Max(nInBuf,(kl_Bas_pairs+1))
      Call GetMem('TraScr5','Allo','Real',ipInBuf,nInBuf)
*
      If ( IPR.ge.5 .and. case2.ne.0 ) then
         Write(6,'(1X,4I2,2X,4I4,2X,4I4,2X,4I4)')
     &                  iSym,jSym,kSym,lSym,
     &                  iBas,jBas,kBas,lBas,
     &                  iOrb,jOrb,kOrb,lOrb,
     &                  iAsh,jAsh,kAsh,lAsh
      End If
*
      nPairs  = 0
      ij_pair = 0
      nOff = 0
      Do i = 1,iBas
        jMax = jBas
        If ( iSym.eq.jSym ) jMax=i
        Do j = 1,jMax
          ij_pair = ij_pair+1
*
*         read a block of electron repulsion integrals
          If ( nPairs.eq.0 ) then
            iOpt = 1
            If ( ij_pair.ne.1 ) iOpt = 2
            Call RdOrd(iRc,iOpt,iSym,jSym,kSym,lSym,
     &                 Work(ipInBuf),nInBuf,nPairs)
            nOff = 0
          End If
*
*         unwrap triangular matrix of electron repulsion integrals
          ipPQRS_ = ipInBuf+nOff
          If ( kSym.eq.lSym ) then
            Call Square(Work(ipInBuf+nOff),Work(ipScrt1),1,kBas,kBas)
            ipPQRS = ipScrt1
          Else
            ipPQRS = ipInBuf+nOff
          End If
*
*         generate Fock matrices
          If ( case1.ne.4 ) then
            Call Timing(Piaget_1,Swatch,Swatch,Swatch)
            If ( case1.eq.2 ) then
              Call Ftwo(case1,ExFac,
     &                  iSym,kSym,
     &                  i,j,
     &                  off_sqMat,off_ltMat,
     &                  D1I,FI,D1A,FA,Work(ipPQRS))
            Else
              Call Ftwo(case1,ExFac,
     &                  iSym,jSym,
     &                  i,j,
     &                  off_sqMat,off_ltMat,
     &                  D1I,FI,D1A,FA,Work(ipPQRS))
            End If
            Call Timing(Piaget_2,Swatch,Swatch,Swatch)
            Piaget_2 = Piaget_2 - Piaget_1
            Piaget_3 = Piaget_3 + Piaget_2
          End If
*
*         first half transformation of electron repulsion integrals:
*         (ij!kl) --> (vx!ij)
          If ( case2.ne.0 ) then
            Call Timing(Candino_1,Swatch,Swatch,Swatch)
            Call Tra2A(ij_pair,ij_Bas_pairs,kl_Orb_pairs,
     &                 kSym,lSym,
     &                 kBas,lBas,
     &                 kAsh,lAsh,
     &                 CMO(kkkOff),CMO(lllOff),
     &                 Work(ipPQRS),Work(lBuf2),
     &                 Work(lBuf3),Work(ipPQVX))
            If (Process_Twice) Then
                Call Tra2C(i,iSym,iBas,iAsh,
     &                     j,jSym,jBas,jAsh,
     &                     kl_Bas_pairs,ij_Orb_pairs,
     &                     CMO(iiiOff),CMO(jjjOff),
     &                     Work(ipPQRS_),Work(lBuf2),Work(ipTURS))
            End If
            Call Timing(Candino_2,Swatch,Swatch,Swatch)
            Candino_2 = Candino_2 - Candino_1
            Candino_3 = Candino_3 + Candino_2
          End If
*
          nPairs = nPairs-1
          nOff = nOff+kl_Bas_pairs
*
        End Do
      End Do
      Call Timing(Candino_1,Swatch,Swatch,Swatch)
      If (IPR.ge.99) Then
         Call RecPrt('PQVX',' ',Work(ipPQVX),ij_Bas_Pairs,
     &                kl_Orb_Pairs)
         If (Process_Twice) Call RecPrt('TURS',' ',Work(ipTURS),
     &                                  kl_Bas_Pairs,ij_Orb_Pairs)
      End If
*
*     Do second half transformation, skip if block is zero long
*
      If ( case2.ne.0 ) Then
         i1 = off_PUVX(iSym,jSym,kSym)
         i2 = off_PUVX(jSym,iSym,kSym)
*        Call FZero(PUVX(1+i1),iOrb*jAsh*kl_Orb_pairs)
*        Call FZero(PUVX(1+i2),jOrb*iAsh*kl_Orb_pairs)
         Do kl_pair = 1, kl_Orb_pairs
           iOff=ipPQVX+(kl_pair-1)*ij_Bas_pairs
*
*          unwrap triangular matrix of electron repulsion integrals
           If ( iSym.eq.jSym ) then
             Call Square(Work(iOff),Work(ipScrt1),1,iBas,iBas)
             lBuf9 = ipScrt1
           Else
             lBuf9 = iOff
           End If
*
*          second half transformation of electron repulsion integrals:
*          (vx!ij) --> (pu!vx)
           Call Tra2B(iSym,jSym,
     &                iBas,jBas,
     &                iAsh,jAsh,
     &                iOrb,jOrb,
     &                kl_pair,kl_Orb_pairs,
     &                CMO(iiOff),CMO(jjOff),CMO(iiiOff),CMO(jjjOff),
     &                Work(lBuf9),Work(lBuf2),
     &                Work(lBuf3),Work(lBuf3),
     &                PUVX(1+i1),PUVX(1+i2) )
*
         End Do
         If (IPR.ge.99) Then
             Call RecPrt('PUVX(i,j,k)',' ',PUVX(1+i1),iOrb,
     &                    jAsh*kl_Orb_pairs)
             Call RecPrt('PUVX(j,i,k)',' ',PUVX(1+i2),jOrb,
     &                    iAsh*kl_Orb_pairs)
         End If
*
         If (Process_Twice) Then
            i1 = off_PUVX(kSym,lSym,iSym)
            i2 = off_PUVX(lSym,kSym,iSym)
*           Call FZero(PUVX(1+i1),kOrb*iAsh*ij_Orb_pairs)
*           Call FZero(PUVX(1+i2),lOrb*kAsh*ij_Orb_pairs)
            Do ij_pair = 1, ij_Orb_pairs
               iOff=ipTURS+(ij_pair-1)*kl_Bas_pairs
*
*              unwrap triangular matrix of electron repulsion integrals
              If ( kSym.eq.lSym ) then
                 Call Square(Work(iOff),Work(ipScrt1),1,kBas,kBas)
                 lBuf9 = ipScrt1
              Else
                 lBuf9 = iOff
              End If
*
*             second half transformation of electron repulsion integrals
*             (vx!ij) --> (pu!vx)
              Call Tra2B(kSym,lSym,
     &                   kBas,lBas,
     &                   kAsh,lAsh,
     &                   kOrb,lOrb,
     &                   ij_pair,ij_Orb_pairs,
     &                   CMO(kkOff),CMO(llOff),CMO(kkkOff),CMO(lllOff),
     &                   Work(lBuf9),Work(lBuf2),
     &                   Work(lBuf3),Work(lBuf3),
     &                   PUVX(1+i1),PUVX(1+i2) )
            End Do
            If (IPR.ge.99) Then
                Call RecPrt('PUVX(k,l,i)',' ',PUVX(1+i1),kOrb,
     &                       lAsh*ij_Orb_pairs)
                Call RecPrt('PUVX(l,k,i)',' ',PUVX(1+i2),lOrb,
     &                       kAsh*ij_Orb_pairs)
            End If
         End If
*
      End If
*
*     deallocate memory
      Call GetMem('TraScr5','Free','Real',ipInBuf,nInBuf)
      If (nTURS.ne.0) Call GetMem('TraScr6','Free','Real',ipTURS,nTURS)
      Call GetMem('TraScr4','Free','Real',ipPQVX,nPQVX)
      Call GetMem('TraScr3','Free','Real',lBuf3,nBuf3)
      Call GetMem('TraScr2','Free','Real',lBuf2,nBuf2)
      If (nScrt1.ne.0)
     &   Call GetMem('TraScr1','Free','Real',ipScrt1,nScrt1)
      Call Timing(Candino_2,Swatch,Swatch,Swatch)
      Candino_2 = Candino_2 - Candino_1
      Candino_3 = Candino_3 + Candino_2
*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NXTIJ(I,J,NI,NJ,IJSM,NONEW)
! An ordered pair (I,J) is given,I<=NI,J<=NJ
!
! Find next pair, if IJSM /= 0, I >= J

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(inout) :: I, J
integer(kind=iwp), intent(in) :: NI, NJ, IJSM
integer(kind=iwp), intent(out) :: NONEW

NONEW = 0
do
  if (I < NI) then
    I = I+1
  else
    if (J < NJ) then
      I = 1
      J = J+1
    else
      NONEW = 1
      exit
    end if
  end if
  if ((IJSM == 0) .or. (I >= J)) exit
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' next (i,j) pair ',I,J
#endif

end subroutine NXTIJ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SCF_Energy(FstItr,E1_,E2_,EV)
      Use SCF_Arrays
      Use Interfaces_SCF, Only: PMat_SCF
      Implicit Real*8 (a-h,o-z)
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
      Logical FstItr
      Real*8, Dimension (:), Allocatable :: XCf
*
*
      nD = iUHF + 1
*
*     Allocate memory for coefficients for minimized densities.
*
      nXCf = MxIter*nD
      Call mma_allocate(XCf,nXCf)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute
*     (1) density matrix,
*     (2) two-electron part of Fock matrix, and
*     (3) variational energies.
*                                                                      *
************************************************************************
*                                                                      *
*     (1) 1-particle density
*
      Call DMat(Dens,TwoHam,nBT,nDens,CMO,nBO,OccNo,nnB,nD,Ovrlp,
     &          XCf,nXCf,Vxc)
*                                                                      *
************************************************************************
*                                                                      *
*     (2) 2-electron part of the Fock matrix, and the potential of the
*         external field (none linear or bi-linear).
*
*         Affects data in position iPsLst
*
      Call PMat_SCF(Dens,OneHam,TwoHam,nBT,nDens,nXCf,FstItr,XCf,nD,
     &              EDFT,MxIter,Vxc,Fock)
*
      Call mma_deallocate(XCf)
*                                                                      *
************************************************************************
*                                                                      *
*     (3) the energy.
*
      Call EneClc(E1_,E2_,EV,Dens,OneHam,TwoHam,nBT,nDens,nD,EDFT,
     &            MxIter)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

subroutine Get_D1I(CMO,D1It,D1I,nish,nbas,nsym)

use Constants, only: Zero, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(_OUT_) :: D1It(*), D1I(*)
integer(kind=iwp), intent(in) :: nSym, nish(nsym), nbas(nsym)
integer(kind=iwp) :: i, iBas, iOff1, iOff2, iOrb, iSym, j, k
real(kind=wp) :: rSum

iOff1 = 0
do iSym=1,nSym
  iBas = nBas(iSym)
  iOrb = nIsh(iSym)
  if (iBas /= 0) then
    iOff2 = iOff1
    do i=1,iBas
      do j=1,iBas
        rSum = Zero
        do k=0,iOrb-1
          rSum = rSum+Two*CMO(iOff1+k*iBas+i)*CMO(iOff1+k*iBas+j)
        end do
        D1I(iOff2+j) = rSum
      end do
      iOff2 = iOff2+iBas
    end do
    iOff1 = iOff1+iBas*iBas
  end if
end do
call Fold2(nsym,nBas,D1I,D1It)

return

end subroutine Get_D1I

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Prim_Atom_Tab(nAtoms,nPrim,Work,CENTX,CENTY,CENTZ)

use MPProp_globals, only: iAtPrTab, nAtomPBas
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nPrim
real(kind=wp), intent(in) :: Work(3,nAtoms), CENTX(nPrim*(nPrim+1)/2), CENTY(nPrim*(nPrim+1)/2), CENTZ(nPrim*(nPrim+1)/2)
! EB real(kind=wp), intent(in) :: CENTX(nPrim), CENTY(nPrim), CENTZ(nPrim)
integer(kind=iwp) :: i, j, jj
real(kind=wp), parameter :: Thr = 1.0e-10_wp

!---- Get the primitive basis that belongs to a specific atom

do i=1,nAtoms
  nAtomPBas(i) = 0
  do j=1,nPrim
    jj = j*(j+1)/2
    if ((abs(Work(1,i)-CENTX(jj)) <= Thr) .and. (abs(Work(2,i)-CENTY(jj)) <= Thr) .and. (abs(Work(3,i)-CENTZ(jj)) <= Thr)) then
      nAtomPBas(i) = nAtomPBas(i)+1
      iAtPrTab(nAtomPBas(i),i) = j
      !write(u6,*) 'Atom tab',i,j,CENTX(jj),CENTY(jj),CENTZ(jj),nAtomPBas(i)
    end if
  end do
end do

return

end subroutine Get_Prim_Atom_Tab

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Translation(ifg,jfgrd,jfhss,tr,jndgrd,jndhss,coorm,
     &                       nirrep,indgrd,indhss)
      Implicit Integer(a-z)
      Logical jfhss(4,3,4,3),jfgrd(3,4),tr(4),ifg(4),eq,alike

      Integer jndgrd(3,4,0:nirrep-1),jndhss(4,3,4,3,0:nirrep-1)
      Integer indgrd(3,4,0:nirrep-1),indhss(4,3,4,3,0:nirrep-1)
      Real*8 Coorm(3,4)
      Alike=.false.
      If (IfG(1).and.IfG(2).and.IfG(3).and.IfG(4)) Then
        Do 3333 iCent=1,3
          If (.not.Alike) Then
            Do 3334  jCent=iCent+1,4
               If (EQ(CoorM(1,iCent),CoorM(1,jCent))) Then
                  Do kCent=1,4
                     iMax=Max(jCent,kCent)
                     iMin=Min(jCent,kCent)
                     Do kCar=1,3
                        Do lCar=1,3
                           Do mIrrep=0,nIrrep-1
                              JndHss(iMax,kCar,iMin,lCar,mIrrep)=0
                           End Do
                           JfHss(iMax,kCar,iMin,lCar)=.false.
                        End Do
                     End Do
                  End Do
                  Do jCar=1,3
                     Do mIrrep=0,nIrrep-1
                        JndGrd(jCar,jCent,mIrrep)=0
                     End Do
                     jfGrd(jCar,jCent)=.false.
                  End Do
                  IfG(jCent)=.false.
                  If (.not.Alike) Then
                     IfG(iCent)=.false.
                     Tr(iCent)=.true.
                     Alike=.true.
                     Do kCent=1,4
                        If ((.not.(EQ(CoorM(1,iCent),
     &                       CoorM(1,kCent)))) .or.
     &                       (kCent.eq.iCent))
     &                       then
                           iMax=Max(iCent,kCent)
                           iMin=Min(iCent,kCent)
                           Do kCar=1,3
                             If (iMax.eq.iMin) Then
                                iStop=kCar
                             Else
                                iStop=3
                             End If
                             Do lCar=1,iStop
                               Do mIrrep=0,nIrrep-1
                                 JndHss(iMax,kCar,iMin,lCar,mIrrep)=
     &                            -IndHss(iMax,kCar,iMin,lCar,mIrrep)
                               End Do
                               JfHss(iMax,kCar,iMin,lCar)=.false.

*     Set the derivatives that are needed for the translation
*     invarians calculations.
*
                                    Do iiCent=1,4
                                    If (.not.EQ(CoorM(1,iiCent),
     &                                   CoorM(1,iCent)))
     &                                 Then
                                       Do jjCent=1,iiCent
                                         If (.not.EQ(CoorM(1,jjCent),
     &                                        CoorM(1,iCent)))
     &                                   Then
                                           Do kkCar=1,3
                                           if (iiCent.eq.jjCent) Then
                                              iStop=kkCar
                                           Else
                                               iStop=3
                                           End If
                                           Do llCar=1,iStop
                                               JfHss(iiCent,kkCar,
     &                                          jjCent,llCar)=.true.
                                           End Do
                                        End Do
                                    End If
                                   End Do !  icent
                                   Do kkCar=1,3
                                      JfGrd(kkCar,iiCent)=.true.
                                   End Do
                                   End If
                                 End Do
                                End Do
                              End Do
                           End If
                        End Do
                        Do jCar=1,3
                           Do mIrrep=0,nIrrep-1
                              JndGrd(jCar,iCent,mIrrep)=
     &                             -IndGrd(jCar,iCent,mIrrep)
                           End Do
                           JfGrd(jCar,iCent)=.false.
                        End  Do
                     End If
                  End If
 3334          Continue
            End If
 3333    Continue
      End If
*
*     If all centers are different delete the fourth center
*
      If (.not.Alike) Then
         IfG(4)=.false.
         Tr(4)=.true.
         Call lCopy(12,[.true.],0,JFGRD,1)
*     Call lCopy(144,[.true.],0,JFHss,1)
         Do iiC=1,4
            Do jjC=1,iiC
               Do iiCar=1,3
                  iStop=3
                  If (iic.eq.jjc) iStop=iiCar
                  Do jjCar=1,iStop
                     JfHss(iiC,iiCar,jjc,jjCar)=.true.
                  End Do
               End Do
            End Do
         End Do

         Do kCar=1,3
            Do lCent=1,4
               iStop=3
               If (lCent.eq.4) iStop=kCar
               Do lCar=1,iStop
                  Do mIrrep=0,nirrep-1
                     JndHss(4,kCar,lCent,lCar,mIrrep)=
     &                    -IndHss(4,kCar,lCent,lCar,mIrrep)
                  End Do
                  JfHss(4,kCar,lCent,lCar)=.false.
               End Do
            End Do
         End Do
*
         Do lCar=1,3
            Do mIrrep=0,nirrep-1
               Jndgrd(lCar,4,mIrrep)=
     &              -IndGrd(lCar,4,mIrrep)
            End Do
            jfgrd(lCar,4)=.false.
         End Do
*
      End If
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996,1997, Anders Bernhardsson                         *
!***********************************************************************

subroutine Prec(rpre,ipre,idsym)
!***********************************************************************
!
!  idsym, symmetry of orbital hessian of interest
!  CMtx preconditioner
!
! The orbital hessian is dominated of elements that couples
!
! kappa  -> kappa      where i is occupied and p,q is general.
!      ip        iq
!
! we therefore approximate the hessian with those diagonal
! terms in the preconditioner
!
!  Anders Bernhardsson 96
!
!     active; active,general is needed for rasscf calculation
!     and is not coded yet (ugly bastard) (970109, AB)
!***********************************************************************

use Symmetry_Info, only: Mul
use MCLR_Data, only: F0SQMO, FAMO, FIMO, ipCM, nrec
use input_mclr, only: iMethod, nAsh, nBas, NewCho, nIsh, nOrb, nOrb, nRS1, nRS2, nRS3, nSym, ntAsh
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: rpre(*)
integer(kind=iwp), intent(_OUT_) :: ipre(*)
integer(kind=iwp), intent(in) :: idsym
integer(kind=iwp) :: iAdr, iB, iBB, ip, ipi, iR, iRC, iS, jS, n2, nD, ni, nmm, nmmm, nTemp
real(kind=wp) :: Sgn
real(kind=wp), allocatable :: ActInt(:), JA(:), KA(:), Scr(:), Temp1(:,:), Temp2(:), Temp3(:)

nmm = max(0,maxval(nAsh(1:nSym)+nIsh(1:nSym)))
nmmm = max(0,maxval(nBas(1:nSym)))
n2 = nMMM**2
nmmm = ((nmmm-1)/nRec+1)*nRec
nmm = nmm*nMMM
nmm = nmm**2

call mma_allocate(JA,n2,Label='JA')
call mma_allocate(KA,n2,Label='KA')
call mma_allocate(Scr,n2,Label='Scr')
if ((nRs1(iDSym) /= 0) .or. (nRs3(iDSym) /= 0)) then
  call mma_allocate(ActInt,ntAsh**4,Label='ActInt')
  call Precaaa_Pre(ActInt,JA,Scr)
end if

ip = 1
ipi = 1
iAdr = 0
do iS=1,nSym
  jS = Mul(is,iDSym)
  nD = nOrb(js)-nIsh(jS)
  ni = nBas(js)**2
  Sgn = One
  call mma_allocate(Temp2,ni,Label='Temp2')
  call mma_allocate(Temp3,ni,Label='Temp3')
  Temp3(:) = Zero
  call mma_MaxDBLE(nTemp)
  nTemp = min(nmm,nTemp/2)
  call mma_allocate(Temp1,nTemp,2,Label='Temp1')
  if (nd /= 0) then
    do iB=1,nIsh(iS)
      Temp3(1:nD**2) = Zero
      ibb = nOrb(is)*(ib-1)+ib-2
      !                                                                *
      !*****************************************************************
      !                                                                *
      if (NewCho) then  ! Cho-Fock

        call preci_cho(jS,nD,Temp3,nOrb(js),FIMO(1+ipCM(is)+ibb),FAMO(1+ipCM(is)+ibb),FIMO(ipCM(js)),FAMO(ipCM(js)), &
                       F0sqMO(ipCM(js)),Sgn,JA,n2,iAdr) ! OK

      else  ! Cho-MO

        if (iMethod == 2) then
          !                                                            *
          !*************************************************************
          !                                                            *
          ! G
          !  iaib

          if (nash(js) > 0) &
            call Preciaa(ib,is,js,nd,Temp3,nOrb(js),FIMO(1+ipCM(is)+ibb),FAMO(1+ipCM(is)+ibb),FIMO(ipCM(js)),FAMO(ipCM(js)), &
                         F0sqMO(ipCM(js)),Sgn,JA,KA,Scr,n2) ! OK
          !                                                            *
          !*************************************************************
          !                                                            *
          ! G
          !  ipia

          if ((nOrb(js)-nish(js)-nash(js))*nash(js) > 0) &
            call Preciba(ib,is,js,nd,Temp3,nOrb(js),FIMO(ipCM(js)),FAMO(ipCM(js)),F0sqMO(ipCM(js)),Sgn,JA,KA,Scr,n2) ! OK

        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        ! G
        !  ipiq

        if ((nOrb(js)-nish(js)-nash(js)) > 0) &
          call Precibb(ib,is,js,nd,Temp3,norb(js),Temp1(:,1),Temp1(:,2),Temp2,FiMo(1+ipCM(is)+ibb),FAMO(1+ipcm(is)+ibb), &
                       FiMo(ipCM(js)),FAMO(ipcm(js)),Sgn)  ! OK

      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Factorize G:
      !
      !     T
      ! G=LL
      !
      !write(u6,*) 'Preconditioner i =',iB
      !do i=1,min(nd,10)
      !  write(u6,'(10F12.8)') (Temp3((j-1)*nd+i-nTri_Elem(j-1)),j=1,i)
      !end do

      call SQM(Temp3,rpre(ip),nd)

      !write(u6,*) ' ====== rpre ======'
      !do i=1,nd*nd
      !  write(u6,*) i,'rpre',rpre(ip+i-1)
      !end do

      irc = 0
      call dgetrf_(nd,nd,rpre(ip),nd,ipre(ipi),irc)
      if (irc /= 0) then
        write(u6,*) 'Error in DGETRF called from prec'
        call Abend()
      end if
      ip = ip+nD**2
      ipi = ipi+nD

    end do

  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do iB=1,nAsh(iS)
    ibb = nOrb(is)*(nish(is)+ib-1)+nish(is)+ib-2
    if (ib <= nRs1(iS)+nRs2(is)+nRs3(is)) iR = 3
    if (ib <= nRs1(iS)+nRs2(is)) iR = 2
    if (ib <= nRs1(iS)) iR = 1
    if (ir == 1) nD = nOrb(js)-nRs1(js)
    if (ir == 2) nD = nOrb(js)-nRs2(js)
    if (ir == 3) nD = nOrb(js)-nRs3(js)
    if (nd /= 0) then
      Temp3(1:nD**2) = Zero

      !                                                                *
      !*****************************************************************
      !                                                                *
      if (NewCho) then

        !  New Cholesky code

        call Preca_cho(ib,is,js,nd,Temp3,nOrb(js),FIMO(1+ipCM(is)+ibb),FAMO(1+ipCM(is)+ibb),F0SqMO(1+ipCM(is)+ibb),FIMO(ipCM(js)), &
                       FAMO(ipCM(js)),Sgn,JA,n2)

      else

        if (nish(js) > 0) &
          call Precaii(ib,is,js,nd,Temp3,nOrb(js),FIMO(1+ipCM(is)+ibb),FAMO(1+ipCM(is)+ibb),F0SqMO(1+ipCM(is)+ibb),FIMO(ipCM(js)), &
                       FAMO(ipCM(js)),Sgn,JA,KA,Scr,n2) ! OK
        !call Precaai(ib,nd,ir,rpre(ip))
        !call Precaaa(ib,nd,ir,rpre(ip))
        if (nish(js)*nOrb(js) > 0) &
          call Precabi(ib,is,js,nd,Temp3,nOrb(js),FIMO(ipCM(js)),FAMO(ipCM(js)),Sgn,JA,KA,Temp1(:,2),n2)!+/-?
        !call Precaba(ib,nd,ir,rpre(ip))
        if (nOrb(js) > 0) &
          call Precabb_2(ib,is,js,nd,nOrb(js),Temp3,Temp1(:,1),ntemp,Temp1(:,2),Temp2,F0SQMO(1+ipCM(is)+ibb),FiMo(ipCM(js)),Sgn)

        ! symmetry not yet
        ! Eq. (C.12e)
        if ((nRs1(iS) /= 0) .or. (nRs3(iS) /= 0)) &
          call Precaaa(ib,is,js,nd,ir,Temp3,nOrb(js),FIMO(ipCM(js)),F0SqMO(ipCM(js)),Sgn,Scr,n2,ActInt) ! OK

      end if
      !                                                                *
      !*****************************************************************
      !                                                                *

      call SQM(Temp3,rpre(ip),nD)
      irc = 0
      call dgetrf_(nd,nd,rpre(ip),nd,ipre(ipi),irc)
      if (irc /= 0) then
        write(u6,*) 'Error in DGETRF called from prec'
        call Abend()
      end if
      ip = ip+nD**2
      ipi = ipi+nD
    end if
  end do
  call mma_deallocate(Temp1)
  call mma_deallocate(Temp2)
  call mma_deallocate(Temp3)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if ((nRs1(iDSym) /= 0) .or. (nRs3(iDSym) /= 0)) call mma_deallocate(ActInt)
call mma_deallocate(Scr)
call mma_deallocate(KA)
call mma_deallocate(JA)

!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Prec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Francesco Aquilante                              *
*               2011, Thomas Bondo Pedersen                            *
************************************************************************
      SUBROUTINE CHO_GET_GRAD(irc,nDen,
     &                        ipDLT,ipDLT2,ipMSQ,
     &                        Txy,nTxy,ipTxy,DoExchange,lSA,
     &                        nChOrb_,ipAorb,nAorb,DoCAS,
     &                        Estimate,Update,
     &                        V_k,U_k,Z_p_k,nnP,npos,nZpk)

************************************************************************
*  Author : F. Aquilante (visiting F. Illas group in Barcelona, Spain, *
*                                                    March-April 2007) *
*                                                                      *
*  Purpose:                                                            *
*         Computation of the relevant quantities for RI                *
*         (and Cholesky) gradient code                                 *
*                                                                      *
*         Coulomb term :  V_k = sum_gd  D_gd L_gd_k                    *
*                                                                      *
*         MP2 Coulomb term : U_k = sum_gd D(MP2)_gd L_gd_k             *
*                                                                      *
*         Active term :   Z_p_k = sum_xy T(xy,p) L_xy_k                *
*                                                                      *
*         Inact. Exchange term: the quantity returned on disk is       *
*                                                                      *
*                     L_ij_k = sum_gd L_gd_k C_gi C_dj                 *
*                                                                      *
*                                                                      *
*  Input:                                                              *
*                                                                      *
*         nDen : is equal to 2 iff Spin Unrestricted                   *
*                4 for SA-CASSCF, otherwise nDen=1                     *
*                                                                      *
*         ipDLT : pointer to the LT-packed and symm. blocked           *
*                 one-body Dmat.                                       *
*                 For spin unrestricted, Dmat = Dalpha + Dbeta         *
*                                                                      *
*         ipDLT2: pointer to the LT-packed and symm. blocked           *
*                 one body MP2 Dmat.                                   *
*                                                                      *
*         ipMSQ : Cholesky MOs stored as C(a,i) symm. blocked          *
*                 with blocks of dim. (nBas,nBas). These are           *
*                 obtained from CD of the 1-particle DMAT.             *
*                 (Two pointers iff alpha and beta spinorbitals)       *
*                                                                      *
*         ipTxy : array (8,8) of pointers to the symm. blocks          *
*                 of the Cholesky decomposed MO-basis (symmetrized)    *
*                 2-body density matrix                                *
*                 T(xy,p) : is stored by compound symmetry JSYM        *
*                            the indices {xy} are stored as PACKED     *
*                            (sym x.le.sym y)                          *
*                                                                      *
*         DoExchange : logical to activate exchange grad. components   *
*                                                                      *
*         nChOrb_ : array of nr. of Cholesky orbitals in each irrep    *
*                                                                      *
*         ipAorb : array of pointers to the active orbitals of each    *
*                  irrep. The storage MUST BE of type C(v,b)           *
*                                                                      *
*         nAorb : array with # of Active orbitals in each irrep        *
*                 (The same orbital basis                              *
*                 in which the 2-body Dmat is expressed)               *
*                                                                      *
*         DoCAS : logical to activate CASSCF grad. components          *
*                                                                      *
*         nScreen : See e.g. LK-screening docum. in SCF                *
*                   or CASSCF read-input routines. Default = 10        *
*                                                                      *
*         dmpK : damping for the LK-screening threshold. Def: 1.0d0    *
*                                                                      *
*         Estimate : logical for LK-screening. Default: .false.        *
*                                                                      *
*         Update : logical for LK-screening. Default: .true.           *
*                                                                      *
*         nnP : array of # of Cholesky vectors for the dec 2-body      *
*               density matrix in each compound symmetry               *
*                                                                      *
*                                                                      *
*  Output:                                                             *
*         irc : return code                                            *
*                                                                      *
*         V_k : array Real*8 for the Coulomb interm. Size=NumCho(1)    *
*                                                                      *
*         U_k : array Real*8 for the mp2 Coulomb interm. Size=NumCho(1)*
*                                                                      *
*         Z_p_k : array Real*8 for the active grad. components.        *
*                  Must be zeroed by the calling routine. Stored       *
*                  according to jSym and blocked after symm. blocks    *
*                  of the active orbitals (square storage).            *
*                                                                      *
*  Modifications:                                                      *
*    August 24, 2011, Thomas Bondo Pedersen:                           *
*       Allow zero vectors on a node.                                  *
*                                                                      *
************************************************************************

      Implicit Real*8 (a-h,o-z)

      Logical   Debug,timings,DoRead,DoExchange,DoCAS,lSA
      Logical   DoScreen,Estimate,Update,BatchWarn
      Integer   nDen,nChOrb_(8,5),nAorb(8),nnP(8),nIt(5)
      Integer   ipMSQ(nDen),ipAorb(8,*),ipTxy(8,8,2)
      Integer   kOff(8,5), LuRVec(8,3), ipLpq(8), ipLxy(8), iSkip(8)
      Integer   ipDrs(5), ipY, ipYQ, ipML, ipSKsh(5)
      Integer   ipDrs2,ipDLT(5),ipDLT2
      Integer   ipIndx, ipIndik,npos(8,3)
      Integer   iSTSQ(8), iSTLT(8), iSSQ(8,8), nnA(8,8), nInd
      Real*8    tread(2),tcoul(2),tmotr(2),tscrn(2),tcasg(2),tmotr2(2)
      Real*8    Txy(nTxy),V_k(*),Z_p_k(nZpk,*), U_k(*)
      Character*6  Fname
      Character*50 CFmt
      Character*12 SECNAM
      Parameter (SECNAM = 'CHO_GET_GRAD')
      COMMON    /CHOTIME /timings

      parameter (DoRead = .false. )
      parameter (zero = 0.0D0, one = 1.0D0, xone = -1.0D0)
#include "itmax.fh"
#include "Molcas.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
#include "exterm.fh"
#include "chomp2g_alaska.fh"
*#define _CD_TIMING_
#ifdef _CD_TIMING_
#include "temptime.fh"
#endif
#include "para_info.fh"
#include "print.fh"
      Integer iBDsh(MxShll*8)
      Common /BDshell/ iBDsh

      parameter ( N2 = InfVec_N2 )
      Logical add
      Character*6 mode
      Integer  Cho_F2SP
      External Cho_F2SP
*                                                                      *
************************************************************************
*                                                                      *
      MulD2h(i,j) = iEOR(i-1,j-1) + 1

      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j

      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)

      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)

      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)

      NBASSH(I,J)=IWORK(ip_NBASSH-1+NSYM*(J-1)+I)

      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)

      ipLab(i) = iWork(ip_Lab+i-1)

      kOffSh(i,j) = iWork(ip_kOffSh+nShell*(j-1)+i-1)

      iShp_rs(i) = iWork(ip_iShp_rs+i-1)

      SvShp(i) = Work(ip_SvShp+i-1)
*
** next is a trick to save memory. Memory in "location 2" is used
** to store this offset array defined later on
*
      iOffShp(i,j) = iWork(ip_iiBstRSh+nSym*nnShl-1+nSym*(j-1)+i)

*
** Jonas 2010
** Thomas Bondo Pedersen, 2013:
**   Usage of these statement functions has been commented out below,
**   hence I comment them out here, too.
*
ctbp  ijList(iSym,jSym,i,j,jDen,jDen2) = ipijList +
ctbp &                        iChOrbR(iSym,jSym,jDen) +
ctbp &                        i + (j-1)*(nChOrb_(iSym,jDen2)+1)
ctbp  ijListTri(iSym,i,j,jDen) = ipijListTri + iChOrbT(iSym,jDen) +
ctbp &                      i + (j-1)*(nChOrb_(iSym,jDen)+1)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
c      Debug=.true.
      Debug=.false.! to avoid double printing
#else
      Debug=.false.
#endif

************************************************************************
*                                                                      *
*     General Initializiation                                          *
*                                                                      *
************************************************************************

      iRout = 9
      iPrint = nPrint(iRout)


      CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

      do i=1,2            ! 1 --> CPU   2 --> Wall
         tread(i) = zero  !time read vectors
         tcoul(i) = zero  !time for computing V_k
         tcasg(i) = zero  !time for computing Z_p_k
         tmotr(i) = zero  !time for the MO transf of vectors
         tmotr2(i)= zero  !time for the 2nd MO transf of vectors
         tscrn(i) = zero  !time for screening overhead
      end do

      IREDC = -1  ! unknown reduced set in core

      BatchWarn = .True.
      nInd = 0

      Call set_nnA(nSym,nAorb,nnA)

*
**    Various offsets
*
      MaxB=nBas(1)
      ISTLT(1)=0
      ISTSQ(1)=0
      DO ISYM=2,NSYM
        MaxB=Max(MaxB,nBas(iSym))
        NBB=NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
        NBQ=NBAS(ISYM-1)**2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NBB ! Inactive D matrix
        ISTSQ(ISYM)=ISTSQ(ISYM-1)+NBQ ! Diagonal integrals in full
      END DO

      nnBSQ=0
      DO LSYM=1,NSYM
         DO KSYM=LSYM,NSYM
            ISSQ(KSYM,LSYM) = nnBSQ
            ISSQ(LSYM,KSYM) = nnBSQ ! symmetrization
            nnBSQ = nnBSQ + nBas(kSym)*nBas(lSym)
         END DO
      END DO
*
**     Size for occupied CMO-matrix
*
      Do jDen = 1, nKdens
         lCMOi(jDen) = 0
         iOff_CMOi(1,jDen)=0
         Do i = 1, nSym
            lCMOi(jDen) = lCMOi(jDen) + nBas(i)*nChOrb_(i,jDen)
         End Do
         Do i = 2,nSym
            iOff_CMOi(i,jDen)=iOff_CMOi(i-1,jDen) +
     &                        nBas(i-1)*nChOrb_(i-1,jDen)
         End Do
      End Do

*
**
*
      nI2t=0
      nItmx=0
      Do i=1,5
        nIt(i) = 0
      End Do
      Do jDen=nDen,1,-1
         kOff(1,jDen)=0
         nIt(jDen)=nChOrb_(1,jDen)
         Do i=2,nSym
            kOff(i,jDen)=nIt(jDen)
            nIt(jDen)=nIt(jDen)+nChOrb_(i,jDen)
         End Do
         nI2t=nI2t+nIt(jDen)
         nItmx=Max(nItmx,nIt(jDen))
      End Do
*
**   Initialize pointers to avoid compiler warnings
*
      ipDIAG=ip_Dummy
      ipjDIAG=ip_Dummy
      ipDIAH=ip_Dummy
      ipAbs=ip_Dummy
      ipY=ip_Dummy
      ipYQ=ip_Dummy
      ipML=ip_Dummy
      Do i=1,5
        ipSKsh(i)=ip_Dummy
      End Do
      ipIndx=ip_iDummy
      ipIndik=ip_iDummy
      ip_Lab=ip_iDummy
      ip_kOffSh=ip_iDummy
      ip_iShp_rs=ip_iDummy
      ip_SvShp=ip_iDummy
*
      thrv=0.0d0
      xtau=0.0d0
*
**    Construct iBDsh for later use
*
      Do iSyma=1,nSym
         LKsh=0
         Do iaSh=1,nShell
            iSSa=nShell*(iSyma-1)+iaSh
            iBDsh(iSSa) = LKsh
            LKsh = LKsh + nBasSh(iSyma,iaSh)
         End Do
      End Do

!     iShp_rs
      Call GetMem('ip_iShp_rs','Allo','Inte',ip_iShp_rs,nnShl_tot)

************************************************************************
*                                                                      *
*     Initialize a few things for ij-screening //Jonas B               *
*                                                                      *
************************************************************************
      If(DoExchange) Then

         lijList=0
         Do jDen=nKvec,1,-1
            iMOleft=jDen
            iMOright=jDen
            If (DoCAS.and.lSA) iMOright=jDen+2
            iChOrbR(1,1,jDen) = 0
            iChOrbT(1,jDen) = 0
            Do k = 2, nSym
               iChOrbR(k,1,jDen) = iChOrbR(k-1,1,jDen)+
     &                     (nChOrb_(k-1,iMOright)+1)*nChOrb_(1,iMOleft)
            End Do
            Do i=2,nSym
               iChOrbR(1,i,jDen) = iChOrbR(nSym,i-1,jDen)+
     &              (nChOrb_(nSym,iMOright)+1)*nChOrb_(i-1,iMOleft)
               Do k = 2,nSym
                  iChOrbR(k,i,jDen) = iChOrbR(k-1,i,jDen)
     &                 + (nChOrb_(k-1,iMOright)+1)*nChOrb_(i,iMOleft)
               End Do
               iChOrbT(i,jDen) = iChOrbT(i-1,jDen)
     &                 + nChOrb_(i-1,iMOleft)*(nChOrb_(i-1,iMOright)+1)
            End Do
            lijList = max(lijList, iChOrbR(nSym,nSym,jDen)+
     &                nChOrb_(nSym,iMOleft)*(nChOrb_(nSym,iMOright)+1))
         End Do

*
** Define the screening thresholds
*

         Call Get_dScalar('Cholesky Threshold',ThrCom)

         tau = (ThrCom/DBLE(Max(1,nItmx)))*dmpK

         MaxRedT=MaxRed
         Call GAIGOP_SCAL(MaxRedT,'+')

         If (Estimate) tau=tau/DBLE(MaxRedT)
         xtau = sqrt(tau)

         NumVT=NumChT
         Call GAIGOP_SCAL(NumVT,'+')
!        Vector MO transformation screening thresholds
         thrv = ( sqrt(ThrCom/DBLE(Max(1,nItmx)*NumVT)) )*dmpK

#if defined (_MOLCAS_MPP_)
         If (Is_Real_Par() .and. Update) Then
            NNBSTMX=0
            Do i=1,nSym
               NNBSTMX = Max(NNBSTMX,NNBSTR(i,1))
            End Do
            CALL GETMEM('diagJ','Allo','Real',ipjDIAG,NNBSTMX)
            Call FZero(Work(ipjDIAG),NNBSTMX)
         EndIf
#endif

*
** Read the diagonal integrals (stored as 1st red set)
*
         CALL GETMEM('diagI','Allo','Real',ipDIAG,NNBSTRT(1))
         If (Update) CALL CHO_IODIAG(Work(ipDIAG),2) ! 2 means "read"

*
** Allocate memory
*
!        sqrt(D(a,b)) stored in full (squared) dim
         CALL GETMEM('diahI','Allo','Real',ipDIAH,NNBSQ)
         CALL FZERO(Work(ipDIAH),NNBSQ)

         Call GetMem('absc','Allo','Real',ipAbs,MaxB) ! abs(C(l)[k])

         Call GetMem('yc','Allo','Real',ipY,MaxB*nItmx) ! Y(l)[k] vector

         Call GetMem('yq','Allo','Real',ipYQ,nItmx**2) ! Yi[k] vectors

*used to be nShell*something
!        ML[k] lists of largest elements in significant shells
         Call GetMem('MLk1','Allo','Real',ipML,nShell)

!        list of S:= sum_l abs(C(l)[k])
         Call GetMem('SKsh','Allo','Real',ipSKsh(1),nShell*nI2t)
         Do i=2,5
           ipSKsh(i)=ipSKsh(i-1)+nShell*nIt(i-1)    ! for each shell
         End Do

*
** Indx and Indik must be stored for each density, symmetry, etc.
** in case of a batched procedure
*
         Do jDen=1,nKvec
           Do kSym=1,nSym
             nInd = nInd + nChOrb_(kSym,jDen)
           End Do
         End Do

!        Index array
         Call GetMem('Indx','Allo','Inte',ipIndx,(nShell+1)*nInd)

         Call GetMem('Indik','Allo','Inte',ipIndik,
     &               ((nItmx+1)*nItmx+1)*nInd)  !Yi[k] Index array

         Call GetMem('ip_Lab','Allo','Inte',ip_Lab,nShell) ! ipLab

!        kOffSh
         Call GetMem('ip_kOffSh','Allo','Inte',ip_kOffSh,nShell*nSym)

!        shell-pair Frobenius norm of the vectors
         Call GetMem('ip_SvShp','Allo','Real',ip_SvShp,2*nnShl)

*
** Jonas - June 2010:
** allocate memory for rearranged CMO-matrix
*
         Do i=1,nDen
           If (lCMOi(i).gt.0) Then
              Call GetMem('CMO_inv','Allo','Real',ip_CMOi(i), lCMOi(i))
           Else
              ip_CMOi(i)=ip_Dummy
           End If
         End Do
         Call GetMem('ijList','Allo','Inte',ipijList,lijList)
         Call GetMem('ijListTri','Allo','Inte',ipijListTri,lijList)
         Call IZero(iWork(ipijList),lijList)
         Call IZero(iWork(ipijListTri),lijList)

         nQoT = 0
*
** Compute Shell Offsets ( MOs and transformed vectors)
*
         Do iSyma=1,nSym
            LKsh=0
            Do iaSh=1,nShell    ! kOffSh(iSh,iSym)

               iWork(ip_kOffSh+nShell*(iSyma-1)+iaSh-1) = LKsh

               LKsh = LKsh + nBasSh(iSyma,iaSh)
            End Do
         End Do

*
** Determine S:= sum_l C(l)[k]^2  in each shell of C(a,k)
*
         Do jDen=1,nDen
            Do kSym=1,nSym

               Do jK=1,nChOrb_(kSym,jDen)

                  ipMO = ipMSQ(jDen) + ISTSQ(kSym)
     &                 + nBas(kSym)*(jK-1)
*
                  ipSk = ipSKsh(jDen) + nShell*(kOff(kSym,jDen) + jK-1)

                  Do iaSh=1,nShell

                     ipMsh = ipMO + kOffSh(iaSh,kSym)

                     SKsh=zero
                     Do ik=0,nBasSh(kSym,iaSh)-1
                        SKsh = SKsh + Work(ipMsh+ik)**2
                     End Do

                     Work(ipSk+iaSh-1) = SKsh

                  End Do
               End Do
            End Do
         End Do
*
** Reorder CMO-matrix, Needed to construct B-matrix for exchange
** Jonas - June 2010
*
         Do jDen = 1, nKdens
            Do kSym = 1, nSym
*
**If the orbitals come from eigenvalue decomposition, change sign
*
               If (lSA.and.(jDen.ge.3)) Then
                 npos2=npos(ksym,jDen-2)
                 Do jK = 1, nPos2
                    Do jGam = 1, nBas(kSym)
                       ipMO = ipMSQ(jDen) + iSTSQ(kSym)
     &                      + nBas(kSym)*(jK-1) + jGam-1
                       ipMO2 = ip_CMOi(jDen) + iOff_CMOi(kSym,jDen)
     &                      + (jGam-1)*nChOrb_(kSym,jDen) + jK-1
                       Work(ipMO2) = Work(ipMO)
                    End Do
                 End Do
                 Do jK = npos2+1,nChOrb_(kSym,jDen)
                    Do jGam = 1, nBas(kSym)
                       ipMO = ipMSQ(jDen) + iSTSQ(kSym)
     &                      + nBas(kSym)*(jK-1) + jGam-1
                       ipMO2 = ip_CMOi(jDen) + iOff_CMOi(kSym,jDen)
     &                      + (jGam-1)*nChOrb_(kSym,jDen) + jK-1
                       Work(ipMO2) = -Work(ipMO)
                    End Do
                 End Do
               Else
*
                 Do jK = 1, nChOrb_(kSym,jDen)
                    Do jGam = 1, nBas(kSym)
                       ipMO = ipMSQ(jDen) + iSTSQ(kSym)
     &                      + nBas(kSym)*(jK-1) + jGam-1
                       ipMO2 = ip_CMOi(jDen) + iOff_CMOi(kSym,jDen)
     &                      + (jGam-1)*nChOrb_(kSym,jDen) + jK-1
                       Work(ipMO2) = Work(ipMO)
                    End Do
                 End Do
               EndIf
            End Do
         End Do
      End If
*
** Mapping shell pairs from the full to the reduced set
*
      Do iaSh=1,nShell
         Do ibSh=1,iaSh
            iShp = iaSh*(iaSh-1)/2 + ibSh
            iWork(ip_iShp_rs+iShp-1) = Cho_F2SP(iShp)
         End Do
      End Do
************************************************************************
*                                                                      *
*     BIG LOOP OVER VECTORS SYMMETRY                                   *
*                                                                      *
************************************************************************
      DO jSym=1,nSym

         NumCV=NumCho(jSym)
         Call GAIGOP_SCAL(NumCV,'max')
         If (NumCV .lt. 1) GOTO 1000
*
** offsets for active term
*
         iOffZp=0
         Do j=1,jSym-1
            iOffZp = iOffZp + nnP(j)*NumCho(j)
         End Do
*
** Open some files to store exchange auxiliary vectors
*
         If (DoExchange) Then
            iSeed=7
            Do i=1,nSym
               k=muld2h(jSym,i)
               LuRVec(i,1) = IsFreeUnit(iSeed)
               Write(Fname,'(A4,I1,I1)') 'CHTA',i,k
               Call DANAME_MF_WA(LuRVec(i,1),Fname)
               iSeed=iSeed+1
               If (nKvec.ge.2) Then
                  LuRVec(i,2) = IsFreeUnit(iSeed)
                  Write(Fname,'(A4,I1,I1)') 'CHTB',i,k
                  Call DANAME_MF_WA(LuRVec(i,2),Fname)
                  iSeed=iSeed+1
               EndIf
            Enddo
         EndIf
*
** Compute Shell pair Offsets   iOffShp(iSyma,iShp)
*
         LFULL=0

         Do iaSh=1,nShell
          Do ibSh=1,iaSh

           iShp = iaSh*(iaSh-1)/2 + ibSh
           If (iShp_rs(iShp).gt.0) Then
            If (nnBstRSh(Jsym,iShp_rs(iShp),1).gt.0) Then

             Do iSymb=1,nSym
              iSyma=MulD2h(iSymb,Jsym)
              If (iSyma.ge.iSymb) Then

               iWork(ip_iiBstRSh + nSym*nnShl - 1
     &         + nSym*(iShp_rs(iShp)-1) + iSyma) = LFULL

               LFULL = LFULL + nBasSh(iSyma,iaSh)*nBasSh(iSymb,ibSh)
     &        + Min(1,(iaSh-ibSh))*nBasSh(iSyma,ibSh)*nBasSh(iSymb,iaSh)

              EndIf
             End Do
            EndIf
           EndIf
          End Do
         End Do

************************************************************************
*                                                                      *
*     Memory management section                                        *
*                                                                      *
************************************************************************
*
** compute memory needed to store at least 1 vector of JSYM
** and do all the subsequent calculations
*
         mTvec = 0
         MxB=0
         nnOmx=0
         do l=1,nSym
            k=Muld2h(l,JSYM)
            Do jDen=1,nDen
                nnOmx=Max(nnOmx,nChOrb_(l,jDen)*nChOrb_(k,jDen))
                If (nChOrb_(k,jDen).gt.0) Then
                   MxB=Max(MxB,nBas(l)+nChOrb_(l,jDen))
                EndIf
            End Do
            mTvec = mTvec + nAorb(k)*nBas(l)
            If (k.le.l) mTvec = mTvec + nnA(k,l)
         end do

         LFMAX = Max(mTvec,2*LFULL) ! re-use memory for the active vec
         mTvec = nnOmx + Max(MxB,1) ! mem for half transformed + Lik
*
**
*
         iLoc = 3 ! use scratch location in reduced index arrays

         If (NumCho(jSym).lt.1) Then
            JRED1 = 1
            JRED2 = 1
         Else
            JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
            JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last
*                                               !vec
         End If
         myJRED1=JRED1 ! first red set present on this node
         myJRED2=JRED2 ! last  red set present on this node

c --- entire red sets range for parallel run
         Call GAIGOP_SCAL(JRED1,'min')
         Call GAIGOP_SCAL(JRED2,'max')

*
** MGD does it need to be so?
*
         DoScreen=.True.
         ntv0=0
         kscreen=1

         Do JRED=JRED1,JRED2

            If (NumCho(jSym).lt.1) Then
               iVrs=0
               nVrs=0
            Else
               CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)
            End If

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//
     &          ': Cho_X_nVecRS returned nVrs<0. STOP!'
               call Abend
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED)
c            !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*) SECNAM,': cho_X_setred non-zero return code.',
     &                   ' rc= ',irc
              call Abend
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            If(JSYM.eq.1)Then
               Do jden=1,nJdens
                  Call GetMem('rsD','Allo','Real',ipDrs(jden),nRS)
                  Call Fzero(Work(ipDrs(jden)),nRS)
               End Do
               If(iMp2prpt.eq.2) Then
                  Call GetMem('rsD2','Allo','Real',ipDrs2,nRS)
               Else
                  ipDrs2 = ip_Dummy
               End If
            End If

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec = Min(LWORK/(nRS+mTvec+LFMAX),nVrs)

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) ' LWORK= ',LWORK
               WRITE(6,*) ' min. mem. need= ',nRS+mTvec+LFMAX
               WRITE(6,*) ' jsym= ',jsym
               WRITE(6,*) ' nRS = ',nRS
               WRITE(6,*) ' mTvec = ',mTvec
               WRITE(6,*) ' LFMAX = ',LFMAX
               irc = 33
               CALL Abend()
               nBatch = -9999  ! dummy assignment
            End If

*                                                                      *
************************************************************************
*                                                                      *
            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
            Call GetMem('ChoT','Allo','Real',ipChoT,mTvec*nVec)
            CALL GETMEM('FullV','Allo','Real',ipLF,LFMAX*nVec)

            If(JSYM.eq.1)Then
C --- Transform the densities to reduced set storage
               mode = 'toreds'
               add  = .false.
               Call play_casscf_sto(irc,iLoc,nJdens,JSYM,ISTLT,ISSQ,
     &                              ipDLT,ipDrs,mode,add)
               If(iMp2prpt .eq. 2) Then
                  Call play_casscf_sto(irc,iLoc,nJdens,JSYM,ISTLT,ISSQ,
     &                              [ipDLT2],[ipDrs2],mode,add)
               End If
            EndIf
*
**  BATCH over the vectors
*

            nBatch = (nVrs-1)/nVec + 1

            If (BatchWarn .and. nBatch.gt.1) Then
               If (iPrint.ge.6) Then
                  Write(6,'(20A3)')('---',I=1,20)
                  Write(6,*)' Batch procedure used.'//
     &                      ' Increase memory if possible!'
                  Write(6,'(20A3)')('---',I=1,20)
                  Write(6,*)
                  Call XFlush(6)
               End If
               BatchWarn = .False.
            EndIf

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM ) then
                  irc=77
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

************************************************************************
************************************************************************
**                                                                    **
**                                                                    **
**    Coulomb term                                                    **
**           V{#J} = sum_ab  L(ab,{#J}) * D(ab)                       **
**                                                                    **
**                                                                    **
************************************************************************
************************************************************************
               If(JSYM.eq.1)Then

                 CALL CWTIME(TCC1,TWC1)

*
**  Inactive Coulomb term
*
                 Do jden=1,nJdens
                    CALL DGEMV_('T',nRS,JNUM,
     &                         One,Work(ipLrs),nRS,
     &                         Work(ipDrs(jden)),1,
     &                         zero,V_k(jVec+(jDen-1)*NumCho(1)),1)
                 End Do
*
**  MP2 Coulomb term
*
                 If(iMp2prpt .eq. 2) Then
                    CALL DGEMV_('T',nRS,JNUM,
     &                         One,Work(ipLrs),nRS,
     &                         Work(ipDrs2),1,
     &                         zero,U_k(jVec),1)
                 End If
*
                 CALL CWTIME(TCC2,TWC2)
                 tcoul(1) = tcoul(1) + (TCC2 - TCC1)
                 tcoul(2) = tcoul(2) + (TWC2 - TWC1)
               EndIf
************************************************************************
************************************************************************
**                                                                    **
**              E X C H A N G E    T E R M                            **
**                                                                    **
**                                                                    **
************************************************************************
************************************************************************
*
               If (DoExchange) Then

                  CALL CWTIME(TCS1,TWS1)
************************************************************************
*                                                                      *
*   1) Screening                                                       *
*                                                                      *
*      Select only important  ij pairs                                 *
*      For this, one computes the quantity                             *
*         Yik = sum_mu_nu (mu nu | mu nu)^1/2 X_mu_i X_nu_k            *
*      with (mu nu | mu nu) = sum_J (L_mu_nu,J)^2                      *
*                                                                      *
*                                                                      *
*      a) Estimate the diagonals :   D(mu,nu) = sum_J (L_mu_nu,J)^2    *
*                                                                      *
************************************************************************
                  If (Estimate) Then

                     Call Fzero(Work(ipDiag+iiBstR(jSym,1)),
     &                          NNBSTR(jSym,1))

                     Do krs=1,nRS

                        mrs = iiBstR(JSYM,iLoc) + krs
                        jrs = IndRed(mrs,iLoc) ! address in 1st red set

                        Do jvc=1,JNUM

                           ipL = ipLrs + nRS*(jvc-1)

                           Work(ipDiag+jrs-1) = Work(ipDiag+jrs-1)
     &                                     + Work(ipL+krs-1)**2

                        End Do

                     End Do

                  EndIf

                  CALL CWTIME(TCS2,TWS2)
                  tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                  tscrn(2) = tscrn(2) + (TWS2 - TWS1)

                  CALL CWTIME(TCX1,TWX1)

*
** Reorder vectors to Full-dimensions
**
** Vectors are returned in the storage LaJ,b with the restriction:
**    Sym(a).ge.Sym(b)
** and blocked in shell pairs
*

                  CALL FZero(Work(ipLF),LFULL*JNUM)
                  ip_B = ipLF + LFULL*JNUM
                  CALL FZero(Work(ip_SvShp),2*nnShl)

                  CALL CHO_getShFull(Work(ipLrs),lread,JNUM,JSYM,
     &                               IREDC,ipLF,Work(ip_SvShp),
     &                               iWork(ip_iShp_rs))

                  CALL CWTIME(TCX2,TWX2)
                  tmotr(1) = tmotr(1) + (TCX2 - TCX1)
                  tmotr(2) = tmotr(2) + (TWX2 - TWX1)

************************************************************************
*                                                                      *
*   1) Screening                                                       *
*                                                                      *
*      b) DH(mu,nu)=sqrt(D(mu,nu))                                     *
*         Only the symmetry blocks with compound symmetry JSYM         *
*         are computed                                                 *
*                                                                      *
************************************************************************
                  IF (DoScreen) THEN

                     CALL CWTIME(TCS1,TWS1)

                     mode = 'tosqrt'
                     ired1 = 1 ! location of the 1st red set
                     add  = .false.
                     nMat = 1
                     Call play_casscf_sto(irc,ired1,nMat,JSYM,ISTLT,
     &                                  ISSQ,[ipDIAH],[ipDIAG],mode,add)

                     CALL CWTIME(TCS2,TWS2)
                     tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                     tscrn(2) = tscrn(2) + (TWS2 - TWS1)

                  ENDIF

************************************************************************
*                                                                      *
*   1) Screening                                                       *
*                                                                      *
*      c) 1st MO transformation of DH(mu,nu)                           *
*            Y(mu)[k] = sum_nu  DH(mu,nu) * |C(nu)[k]|                 *
*                                                                      *
************************************************************************

                  nInd = 0
                  Do jDen=1,nKvec
*
** Choose which MO sets on each side
*
                    iMOleft=jDen
                    iMOright=jDen
                    If (DoCAS.and.lSA) iMOright=jDen+2
*

                    Do kSym=1,nSym

                       lSym=MulD2h(JSYM,kSym)
                       Nik= nChOrb_(kSym,iMOleft)*nChOrb_(lSym,iMOright)
                       nIJR(kSym,lSym,jDen) = Nik
                       nIJ1(kSym,lSym,jDen) = Nik
                       If ((JSYM.eq.1).and.iMOleft.eq.iMOright)
     &                                Nik = nChOrb_(kSym,iMOleft)
     &                                    *(nChOrb_(kSym,iMOleft)+1)/2
                       nIJ1(kSym,lSym,jDen) = Nik
                       If (Nik.eq.0) Go To 98

                       ip_R = ipChoT
     &                      + (nChOrb_(lSym,iMOright)+nBas(lSym))*JNUM

                       Call Fzero(Work(ip_R),Nik*JNUM)

                       Do jK=1,nChOrb_(kSym,iMOleft)

                        CALL FZero(Work(ipChoT),
     &                         (nChOrb_(lSym,iMOright)+nBas(lSym))*JNUM)

                        ipMO = ipMSQ(iMOleft) + ISTSQ(kSym)
     &                       + nBas(kSym)*(jK-1)

                        ipYk = ipY + MaxB*(kOff(kSym,iMOleft)+jK-1)

                        ipYQk = ipYQ + nIt(iMOright)
     &                         *(kOff(kSym,iMOleft)+jK-1)

                        ipMLk = ipML

                        ipIndSh = ipIndx+nInd*(nShell+1)

                        ipIndikk = ipIndik+nInd*((nItmx+1)*nItmx+1)

                        ipSk=ipSKsh(iMOleft)+
     &                       nShell*(kOff(kSym,iMOleft)+jK-1)


                        IF (DoScreen .and. iBatch.eq.1) THEN
                           CALL CWTIME(TCS1,TWS1)
C------------------------------------------------------------------
C --- Setup the screening
C------------------------------------------------------------------
                           ipDIH = ipDIAH + ISSQ(lSym,kSym)

                           Do ik=0,nBas(kSym)-1
                              Work(ipAbs+ik) = abs(Work(ipMO+ik))
                           End Do
                           If (lSym.ge.kSym.and.nBas(lSym).ge.1) Then

                              nBs = Max(1,nBas(lSym))

                              CALL DGEMV_('N',nBas(lSym),nBas(kSym),
     &                                   ONE,Work(ipDIH),nBs,
     &                                       Work(ipAbs),1,
     &                                  ZERO,Work(ipYk),1)

                           Else If (nBas(kSym).ge.1) Then

                              nBs = Max(1,nBas(kSym))

                              CALL DGEMV_('T',nBas(kSym),nBas(lSym),
     &                                   ONE,Work(ipDIH),nBs,
     &                                       Work(ipAbs),1,
     &                                  ZERO,Work(ipYk),1)

                           EndIf

************************************************************************
*                                                                      *
*   1) Screening                                                       *
*                                                                      *
*      d) 2nd MO transformation of DH(mu,nu)                           *
*            Y(i)[k] = sum_mu  |C(mu)[i]| * Y(mu)[k]                   *
*                                                                      *
************************************************************************

*                           iStart=Min(1,lSym-kSym)
*     &                           +jK*(1-Min(1,lSym-kSym)) ! 1 or jK
                           If ((kSym.ne.lSym).or.
     &                        (iMOleft.ne.iMOright)) Then
                               iStart=1
                           Else
                               iStart=jK
                           EndIf

                           nQo=0
                           Do i=iStart,nChOrb_(lSym,iMOright)

                              ipMO_ = ipMSQ(iMOright) + ISTSQ(lSym)
     &                             + nBas(lSym)*(i-1)

                              Do ik=0,nBas(lSym)-1
                                 Work(ipAbs+ik) = abs(Work(ipMO_+ik))
                              End Do
*
                              Work(ipYQk+i-1)=ddot_(nBas(lSym),
     &                             Work(ipAbs),1,Work(ipYk),1)

                              If (Work(ipYQk+i-1).ge.xtau) Then
                                 nQo=nQo+1
                                 If((iBatch.ne.1) .or.
     &                               (JRED.ne.1)) Go To 1111
*                                 ind1 = iWork(ijList(lSym,kSym,
*     &                                  0,jK,jDen,iMOright))+ 1
*                                 iWork(ijList(lSym,kSym,
*     &                                 ind1,jK,jDen,iMOright))=i
*                                 iWork(ijList(lSym,kSym,
*     &                                 0,jK,jDen,iMOright))=ind1
                                 nQoT = nQoT + 1
                                 If((lSym .eq. kSym) .and.
     &                              (i .ne. jK)      .and.
     &                              (iMOright.eq.iMOleft)) Then
*                                    ind2 =iWork(ijList(kSym,kSym,
*     &                                    0,i,jDen,iMOright))+1
*                                    iWork(ijList(kSym,kSym,
*     &                                    ind2,i,jDen,iMOright))=jK
*                                    iWork(ijList(lSym,kSym,
*     &                                    0,i,jDen,iMOright))= ind2
                                    nQoT = nQoT + 1
                                 End If
                                 If((lSym.eq.kSym).and.
     &                              (iMOleft.eq.iMOright)) Then
*                                    ind3=
*     &                                 iWork(ijListTri(kSym,0,jK,jDen))
*     &                                 +1
*                                    iWork(ijListTri(kSym,ind3,jK,jDen))=
*     &                                    i
*                                    iWork(ijListTri(kSym,0,jK,jDen))=
*     &                                     ind3
                                 End If
 1111                            iWork(ipIndikk+nQo)=i
                              Endif

                           End Do
                           iWork(ipIndikk)=nQo
************************************************************************
*                                                                      *
*   1) Screening                                                       *
*                                                                      *
*      e) List the shells present in Y(l)[k] by the largest element    *
*         and sort the list                                            *
*                                                                      *
************************************************************************

                           Do ish=1,nShell
                              YshMax=zero
                              Do ibs=1,nBasSh(lSym,ish)
                                 YshMax = Max(YshMax,
     &                             Work(ipYk+koffSh(ish,lSym)+ibs-1))
                              End Do
                              Work(ipMLk+ish-1) = YshMax
                           End Do

                           Do ish=1,nShell
                              iWork(ipIndSh+ish) = ish
                           End Do

************************************************************************
*                                                                      *
*   1) Screening                                                       *
*                                                                      *
*      f) Screening                                                    *
*                                                                      *
*   Here we use a non-exact bound for the exchange matrix to achieve   *
*   linear scaling. The positive definiteness of the exchange matrix   *
*   combined with the structure of the density matrix makes this       *
*   bound acceptable and likely to be almost exact for what concerns   *
*   the exchange energy                                                *
*                                                                      *
*   The exact bounds (quadratic scaling of the MO transformation)      *
*   would be                                                           *
*      If (Work(ipMLk+jml-1)*Work(ipMLk).ge. tau) then                 *
*                                                                      *
*                                                                      *
************************************************************************

                           numSh=0  ! # of significant shells
                           jml=1
                           Do while (jml.le.nShell)

                              YMax=Work(ipMLk+jml-1)
                              jmlmax=jml

                              Do iml=jml+1,nShell  ! get the max
                                 If (Work(ipMLk+iml-1).gt.YMax) then
                                    YMax = Work(ipMLk+iml-1)
                                    jmlmax = iml
                                 Endif
                              End Do

                              If(jmlmax.ne.jml) then  ! swap positions
                                xTmp = Work(ipMLk+jml-1)
                                iTmp = iWork(ipIndSh+jml)
                                Work(ipMLk+jml-1) = YMax
                                iWork(ipIndSh+jml)=iWork(ipIndSh+jmlmax)
                                Work(ipMLk+jmlmax-1) = xTmp
                                iWork(ipIndSh+jmlmax) = iTmp
                              Endif

                              If ( Work(ipMLk+jml-1) .ge. xtau ) then
                                numSh = numSh + 1
                              else
                                jml=nShell  ! exit the loop
                              endif

                              jml=jml+1

                           End Do

                           iWork(ipIndSh) = numSh

                           CALL CWTIME(TCS2,TWS2)
                           tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                           tscrn(2) = tscrn(2) + (TWS2 - TWS1)
C------------------------------------------------------------------
                        ENDIF    ! Screening setup


                        CALL CWTIME(TCT1,TWT1)

************************************************************************
*                                                                      *
*               E X C H A N G E    T E R M                             *
*                                                                      *
*   2) MO transformation                                               *
*      a) 1st half transformation                                      *
*                                                                      *
*      Transform vectors for shells in the list ML[k]                  *
*                                                                      *
*      Screening based on the Frobenius norm: sqrt(sum_ij  A(i,j)^2)   *
*         || La,J[k] ||  .le.  || Lab,J || * || Cb[k] ||               *
*                                                                      *
************************************************************************

                        IF (lSym.ge.kSym) Then


                            Do iSh=1,iWork(ipIndSh)

                               iaSh = iWork(ipIndSh+iSh)

                               iOffSha = kOffSh(iaSh,lSym)

                               iWork(ip_Lab+iaSh-1)= ipChoT
     &                                         + nChOrb_(lSym,iMOright)
     &                                         * JNUM
     &                                         + iOffSha*JNUM

                               ibcount=0

                               Do ibSh=1,nShell

                                  iOffShb = kOffSh(ibSh,kSym)

                                  iShp = iTri(iaSh,ibSh)

                                If ( iShp_rs(iShp) .gt. 0 ) Then

                                 If ( nnBstRSh(JSym,iShp_rs(iShp),iLoc)*
     &                              nBasSh(lSym,iaSh)*
     &                              nBasSh(kSym,ibSh) .gt. 0
     &                              .and. sqrt(abs(Work(ipSk+ibSh-1)*
     &                                         SvShp(iShp_rs(iShp)) ))
     &                              .ge. thrv )Then

                                    ibcount = ibcount + 1

                                    jOff = iOffShp(lSym,iShp_rs(iShp)) -
     &                                     nBasSh(lSym,ibSh)*
     &                                     nBasSh(kSym,iaSh)*
     &                             Min(0,(iaSh-ibSh))/Max(1,(ibSh-iaSh))

*
**  LaJ,[k] = sum_b  L(aJ,b) * C(b)[k]
** ------------------------------------
*
                                 CALL DGEMV_('N',nBasSh(lSym,iaSh)*JNUM,
     &                                        nBasSh(kSym,ibSh),
     &                                    ONE,Work(ipLF+jOff*JNUM),
     &                                        nBasSh(lSym,iaSh)*JNUM,
     &                                     Work(ipMO+ioffShb),1,
     &                                    ONE,Work(ipLab(iaSh)),1)


                                 EndIf

                                EndIf

                               End Do
*
** The following re-assignement is used later on to check if the
** iaSh vector LaJ[k] can be neglected because identically zero
*

                               iWork(ip_Lab+iaSh-1) = ipLab(iaSh)*
     &                                                Min(1,ibcount)
     &                                    + ipAbs*(1-Min(1,ibcount))

                            End Do


                        Else   ! lSym < kSym


                            Do iSh=1,iWork(ipIndSh)

                               iaSh = iWork(ipIndSh+iSh)

                               iOffSha = kOffSh(iaSh,lSym)

                               iWork(ip_Lab+iaSh-1)= ipChoT
     &                                        + (nChOrb_(lSym,iMOright)
     &                                        + iOffSha)*JNUM
                               ibcount=0

                               Do ibSh=1,nShell

                                 iOffShb = kOffSh(ibSh,kSym)

                                 iShp = iTri(iaSh,ibSh)

                                 If ( iShp_rs(iShp) .gt. 0 ) Then

                                  If (nnBstRSh(JSym,iShp_rs(iShp),iLoc)*
     &                             nBasSh(lSym,iaSh)*
     &                             nBasSh(kSym,ibSh) .gt. 0
     &                             .and. sqrt(abs(Work(ipSk+ibSh-1)*
     &                                        SvShp(iShp_rs(iShp)) ))
     &                             .ge. thrv ) Then

                                   ibcount = ibcount + 1

                                   jOff = iOffShp(kSym,iShp_rs(iShp)) -
     &                                    nBasSh(kSym,iaSh)*
     &                                    nBasSh(lSym,ibSh)*
     &                             Min(0,(ibSh-iaSh))/Max(1,(iaSh-ibSh))

*
**  LJa,[k] = sum_b  L(b,Ja) * C(b)[k]
** ------------------------------------
*
                                   CALL DGEMV_('T',nBasSh(kSym,ibSh),
     &                                       JNUM*nBasSh(lSym,iaSh),
     &                                    ONE,Work(ipLF+jOff*JNUM),
     &                                        nBasSh(kSym,ibSh),
     &                                     Work(ipMO+ioffShb),1,
     &                                    ONE,Work(ipLab(iaSh)),1)

                                  EndIf

                                 Endif

                               End Do

*
** The following re-assignement is used later on to check if the
** iaSh vector LaJ[k] can be neglected because identically zero
*
                               iWork(ip_Lab+iaSh-1) = ipLab(iaSh)*
     &                                               Min(1,ibcount)
     &                                   + ipAbs*(1-Min(1,ibcount))

                            End Do

                        EndIf

************************************************************************
*                                                                      *
*   2) MO transformation                                               *
*      b) 2nd half transformation                                      *
*                                                                      *
************************************************************************

                        nQo=iWork(ipIndikk)

                        Do ir=1,nQo

                          it = iWork(ipIndikk+ir)

                          ipMO = ipMSQ(iMOright) + ISTSQ(lSym)
     &                         + nBas(lSym)*(it-1)

                          ip_Lik = ipChoT + JNUM*(it-1)

                          If (lSym.ge.kSym) Then

                           Do iSh=1,iWork(ipIndSh)

                              iaSh = iWork(ipIndSh+iSh)

                              iaSkip= Min(1,Max(0,
     &                                abs(ipLab(iaSh)-ipAbs)))!=1 or 0

                              Do i=1,iaSkip

                                 ip_Cai = ipMO + kOffsh(iaSh,lSym)
*
**  LJi[k] = sum_a  LaJ[k] * Cai
** ------------------------------
*
                                 CALL DGEMV_('T',nBasSh(lSym,iaSh),JNUM,
     &                                      One,Work(ipLab(iaSh)),
     &                                      nBasSh(lSym,iaSh),
     &                                      Work(ip_Cai),1,
     &                                      one,Work(ip_Lik),1)


                              End Do

                           End Do


                          Else   ! lSym < kSym


                           Do iSh=1,iWork(ipIndSh)

                              iaSh = iWork(ipIndSh+iSh)

                              iaSkip= Min(1,Max(0,
     &                                abs(ipLab(iaSh)-ipAbs)))!=1 or 0

                              Do i=1,iaSkip

                                 ip_Cai = ipMO + kOffsh(iaSh,lSym)
*
**   LJi[k] = sum_a  LJa[k] * Cai
** --------------------------------
*
                                 CALL DGEMV_('N',JNUM,nBasSh(lSym,iaSh),
     &                                      One,Work(ipLab(iaSh)),
     &                                      JNUM,Work(ip_Cai),1,
     &                                      one,Work(ip_Lik),1)


                              End Do

                           End Do

                          EndIf
*
**  Copy LJi[k] in the standard ordered matrix Lik,J
*
                          If ((jSym.eq.1).and.
     &                       (iMOright.eq.iMOleft)) Then
                             itk = it*(it-1)/2 + jK
                          Else
                             itk = nChOrb_(lSym,iMOright)*(jK-1) + it
                          EndIf
                          ip_Rik = ip_R - 1 + itk
                          call dcopy_(JNUM,Work(ip_Lik),1,
     &                                    Work(ip_Rik),Nik)

                        End Do

                        nInd = nInd+1

                        CALL CWTIME(TCT2,TWT2)
                        tmotr2(1) = tmotr(1) + (TCT2 - TCT1)
                        tmotr2(2) = tmotr(2) + (TWT2 - TWT1)


                       End Do  ! loop over k MOs

                       CALL CWTIME(TCT1,TWT1)

************************************************************************
*                                                                      *
*   3) Put to disk                                                     *
*                                                                      *
************************************************************************
                       iAdr = Nik*(JVEC-1)
                       call DDAFILE(LuRVec(lSym,jDen),1,Work(ip_R),
     &                                                Nik*JNUM,iAdr)

                       CALL CWTIME(TCT2,TWT2)
                       tmotr(1) = tmotr(1) + (TCT2 - TCT1)
                       tmotr(2) = tmotr(2) + (TWT2 - TWT1)
 98                    Continue

                    End Do   ! loop over MOs symmetry

                  End Do   ! loop over densities


C ************  END EXCHANGE CONTRIBUTION  ****************

C --- Diagonals updating. It only makes sense if Nscreen > 0

                  If (Update .and. Nscreen .gt. 0) Then

                     CALL CWTIME(TCS1,TWS1)
C ---------------------------------------------------------------------
C --- update the diagonals :   D(a,b) = D(a,b) - sum_J (Lab,J)^2
C
C --- subtraction is done in the 1st reduced set
#if defined (_MOLCAS_MPP_)
                     If (Is_Real_Par()) then

                      Do krs=1,nRS

                        mrs = iiBstR(JSYM,iLoc) + krs
                        jrs = IndRed(mrs,iLoc) - iiBstR(JSYM,1)

                        Do jvc=1,JNUM

                           ipL = ipLrs + nRS*(jvc-1)
                           Work(ipjDiag+jrs-1) = Work(ipjDiag+jrs-1)
     &                                         + Work(ipL+krs-1)**2
                        End Do

                      End Do

                     Else

                      Do krs=1,nRS

                        mrs = iiBstR(JSYM,iLoc) + krs
                        jrs = IndRed(mrs,iLoc) ! address in 1st red set

                        Do jvc=1,JNUM

                           ipL = ipLrs + nRS*(jvc-1)
                           Work(ipDiag+jrs-1) = Work(ipDiag+jrs-1)
     &                                        - Work(ipL+krs-1)**2
                        End Do

                      End Do

                     EndIf

#else
                     Do krs=1,nRS

                        mrs = iiBstR(JSYM,iLoc) + krs
                        jrs = IndRed(mrs,iLoc) ! address in 1st red set

                        Do jvc=1,JNUM

                           ipL = ipLrs + nRS*(jvc-1)
                           Work(ipDiag+jrs-1) = Work(ipDiag+jrs-1)
     &                                        - Work(ipL+krs-1)**2
                        End Do

                     End Do
#endif

                     CALL CWTIME(TCS2,TWS2)
                     tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                     tscrn(2) = tscrn(2) + (TWS2 - TWS1)

                  EndIf

               EndIf ! DoExchange

************************************************************************
************************************************************************
**                                                                    **
**                                                                    **
**    Active term                                                     **
**                                                                    **
**                                                                    **
************************************************************************
************************************************************************
               If (DoCAS) Then

                  CALL CWTIME(TCC1,TWC1)
*
** Set up the skipping flags and the pointers ipLpq
** The memory used before for the full-dimension AO-vectors
**     is now re-used to store half and full transformed
**     vectors in the active space
*
                  lChoa=0
                  Do i=1,nSym

                     k = Muld2h(i,JSYM)
                     iSkip(k) = Min(1,
     &                    nAorb(k)*nBas(i))

                     ipLpq(k) = ipLF + lChoa       ! Lvb,J
                     ipLxy(k) = ipLF + lChoa       ! Lvw,J
     &                        + nAorb(k)*nBas(i)*JNUM

                     lChoa = lChoa + nAorb(k)*nBas(i)*JNUM
                     If (k.le.i) lChoa = lChoa + nnA(k,i)*JNUM

                  End Do

                  iSwap = 0  ! Lvb,J are returned
                  kMOs = 1  !
                  nMOs = 1  ! Active MOs (1st set)
*
                  Do itran=1,nAdens
                     iMO1=1
                     iMO2=1
                     If (itran.eq.2) iMO1=2

************************************************************************
*                                                                      *
*     MO transformation of Cholesky vectors                            *
*                                                                      *
*         1) Lvb,J = sum_a  C(v,a) * Lab,J                             *
*                                                                      *
************************************************************************

                     CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                             JSYM,iSwap,IREDC,nMOs,kMOs,
     &                             ipAorb(1,iMO1),nAorb,ipLpq,iSkip,
     &                             DoRead)

                     if (irc.ne.0) then
                        RETURN
                     endif

************************************************************************
*                                                                      *
*     MO transformation of Cholesky vectors                            *
*                                                                      *
*         2) Lvw,J = sum_b  Lvb,J * C(w,b)                             *
*                                                                      *
************************************************************************
                     If ((JSYM.eq.1).and.(iMO1.eq.iMO2)) Then

                        Do iSymb=1,nSym

                           NAv = nAorb(iSymb)

                           If(NAv.gt.0)Then

                            Do JVC=1,JNUM

                             ipLvb=ipLpq(iSymb)+NAv*NBAS(iSymb)*(JVC-1)
                             ipLvw=ipLxy(iSymb)+nnA(iSymb,iSymb)*(JVC-1)

                             CALL DGEMM_Tri('N','T',NAv,NAv,NBAS(iSymb),
     &                                  One,Work(ipLvb),NAv,
     &                                      Work(ipAorb(iSymb,iMO2)),
     &                                 NAv,Zero,Work(ipLvw),NAv)

                            End Do

                           EndIf

                        End Do

                     Else

                        Do iSymb=1,nSym

                           iSymv = MulD2h(JSYM,iSymb)
                           NAv = nAorb(iSymv)
                           NAw = nAorb(iSymb) ! iSymb=iSymw

                           If(NAv*NAw.ne.0 .and. iSymv.le.iSymb)Then

                            Do JVC=1,JNUM

                             ipLvb=ipLpq(iSymv)+NAv*NBAS(iSymb)*(JVC-1)
                             ipLvw=ipLxy(iSymv)+NAv*NAw*(JVC-1)

                             CALL DGEMM_('N','T',NAv,NAw,NBAS(iSymb),
     &                                  One,Work(ipLvb),NAv,
     &                                      Work(ipAorb(iSymb,iMO2)),
     &                                 NAw,Zero,Work(ipLvw),NAv)

                            End Do

                           EndIf

                        End Do

                     EndIf
************************************************************************
*                                                                      *
*     Evaluation of the Z_p_k                                          *
*                                                                      *
*         Z(p){#J} = sum_xy  T(xy,p) * L(xy,{#J})                      *
*                                                                      *
*     T(xy,p) : is stored by compound symmetry JSYM                    *
*               the indices {xy} are stored as PACKED (sym x.le.sym y) *
*                                                                      *
************************************************************************
                     Do iTxy=itran,nAdens
                       iAvec=itran+iTxy-1
                       Do iSymy=1,nSym

                         iSymx=MulD2h(iSymy,JSYM)

                         If (iSymx.le.iSymy.and.nnA(iSymx,iSymy).ne.0)
     &                      Then

                            ipZp = iOffZp + nnP(jSym)*(JVEC-1) + 1

                            If (iMO1.eq.iMO2) Then
                              CALL DGEMM_('T','N',nnP(jSym),JNUM,
     &                                         nnA(iSymx,iSymy),
     &                               ONE,Txy(ipTxy(iSymx,iSymy,iTxy)),
     &                                   nnP(jSym),
     &                                   Work(ipLxy(iSymx)),
     &                                   nnA(iSymx,iSymy),
     &                               ONE,Z_p_k(ipZp,iAvec),nnP(jSym))
                            Else
*MGD may rearrange the loops
                              Do i=0,nnP(jSym)-1
                                ioff=ipTxy(iSymx,iSymy,iTxy)+
     &                                nnA(iSymx,iSymy)*i
                                Do j=0,JNUM-1
                                  jOff=ipLxy(iSymx)+
     &                                 nAorb(iSymx)*nAorb(iSymy)*j
                                  temp=0.0d0
*MGD don't work with symmetry
                                  Do k=0,nAOrb(iSymx)-1
                                    Do l=0,k
                                       temp=temp+0.5d0*
     &                                     Txy(ioff+k*(k+1)/2+l)*
     &                                    (Work(jOff+k*nAOrb(iSymx)+l)+
     &                                     Work(jOff+l*nAOrb(iSymx)+k))
                                    End Do
                                  End Do
                                  Z_p_k(ipZp+j*nnP(jSym)+i,iAvec)=
     &                                Z_p_k(ipZp+j*nnP(jSym)+i,iAvec)+
     &                                temp
                                End Do
                              End Do
                            EndIf

                         Endif

                       End Do
                     End Do

                  End Do

                  CALL CWTIME(TCC2,TWC2)
                  tcasg(1) = tcasg(1) + (TCC2 - TCC1)
                  tcasg(2) = tcasg(2) + (TWC2 - TWC1)

               EndIf  ! DoCAS

************************************************************************
************************************************************************
**                                                                    **
**    Epilogue                                                        **
**                                                                    **
************************************************************************
************************************************************************

            END DO  ! end batch loop

C --- free memory
            CALL GETMEM('FullV','Free','Real',ipLF,LFMAX*nVec)
            Call GetMem('ChoT','Free','Real',ipChoT,mTvec*nVec)
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

            If(JSYM.eq.1)Then
              do jden=nJdens,1,-1
               Call GetMem('rsD','Free','Real',ipDrs(jden),nRS)
              end do
              If(iMp2prpt .eq. 2) Then
                 Call GetMem('rsD2','Free','Real',ipDrs2,nRS)
              End If
            EndIf

999         Continue

C --- Screening control section
            DoScreen = kscreen.eq.Nscreen

            if (.not.DoScreen) then
                kscreen = kscreen + 1
            else
                kscreen = 1
            endif

            If (DoExchange) Then
#if defined (_MOLCAS_MPP_)
               If (Is_Real_Par() .and. Update .and. DoScreen) Then
                  Call GaDsum(Work(ipjDiag),nnBSTR(JSYM,1))
                  Call Daxpy_(nnBSTR(JSYM,1),xone,Work(ipjDiag),1,
     &                       Work(ipDiag+iiBstR(JSYM,1)),1)
                  Call Fzero(Work(ipjDiag),nnBSTR(JSYM,1))
               EndIf
C--- Need to activate the screening to setup the contributing shell
C--- indices the first time the loop is entered .OR. whenever other nodes
C--- have performed screening in the meanwhile
               If (Is_Real_Par().and..not.DoScreen.and.nVrs.eq.0) Then
                  ntv0=ntv0+1
                  DoScreen = (JRED.lt.myJRED1 .or. ntv0.ge.Nscreen)
                  if (DoScreen) ntv0=0
               EndIf
#endif
            EndIf

         END DO   ! loop over red sets

         If (DoExchange) Then
           Do jDen=1,nKvec
              Do i=1,nSym
                 Call DACLOS(LuRVec(i,jDen))
              End Do
           End Do
         End If

1000  CONTINUE


      END DO  ! loop over JSYM
*****************************************************************
*              Allocate a field to be used by Compute_A_jk later
*              since allocations cannot be made at that stage
******************************************************************
      If(DoExchange) THen
        nIJMax = 0
        Do jDen = 1, nKvec
           Do iSym1 = 1, nSym
              Do iSym2 = 1, nSym
                 nIJMax = max(nIJMax,nIJR(iSym1,iSym2,jDen))
              End Do
           End Do
        End Do
        ljkVec = 2*nIJMax
        Call GetMem('JKVEC','Allo','Real',ip_VJ,ljkVec)
      End If

      Call GetMem('ip_iShp_rs','Free','Inte',ip_iShp_rs,nnShl_tot)
      If (DoExchange) Then
         Call GetMem('ip_SvShp','Free','Real',ip_SvShp,2*nnShl)
         Call GetMem('ip_kOffSh','Free','Inte',ip_kOffSh,nShell*nSym)
         Call GetMem('ip_Lab','Free','Inte',ip_Lab,nShell)
         Call GetMem('Indik','Free','Inte',ipIndik,(nItmx+1)*nItmx)
         Call GetMem('Indx','Free','Inte',ipIndx,nShell)
         Call GetMem('SKsh','Free','Real',ipSKsh(1),nShell*nI2t)
         Call GetMem('MLk1','Free','Real',ipML,nShell)
         Call GetMem('yq','Free','Real',ipYQ,nItmx**2)
         Call GetMem('yc','Free','Real',ipY,MaxB*nItmx)
         Call GetMem('absc','Free','Real',ipAbs,MaxB)
         CALL GETMEM('diahI','Free','Real',ipDIAH,NNBSQ)
#if defined (_MOLCAS_MPP_)
         If (Is_Real_Par().and.Update)CALL GETMEM('diagJ','Free','Real',
     &                                            ipjDIAG,NNBSTMX)
#endif
         CALL GETMEM('diagI','Free','Real',ipDIAG,NNBSTRT(1))
      EndIf


      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1
#ifdef _CD_TIMING_
      ChoGet_CPU = TOTCPU
      ChoGet_Wall = TOTWALL
#endif
*                                                                      *
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky Gradients timing from '//SECNAM
      Write(6,CFmt)'----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'                                CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ VECTORS                     '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB CONTRIB.                 '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'SCREENING OVERHEAD               '
     &                           //'         ',tscrn(1),tscrn(2)
         Write(6,'(2x,A26,2f10.2)')'INACT MO-TRANSFORM VECTORS       '
     &                           //'         ',tmotr(1),tmotr(2)
         Write(6,'(2x,A26,2f10.2)')'INACT MO-TRANSFORM VECTORS 2     '
     &                           //'         ',tmotr2(1),tmotr2(2)
         Write(6,'(2x,A26,2f10.2)')'ACTIVE CONTRIB.                  '
     &                           //'         ',tcasg(1),tcasg(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif

      irc  = 0


      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine Boys(Functional,CMO,Thrs,ThrRot,ThrGrad,nBas,nOrb2Loc,nFro,nSym,nMxIter,Maximisation,Converged,Debug,Silent)
! Author: T.B. Pedersen
!
! Purpose: Boys localisation of occupied orbitals.

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: Functional
real(kind=wp), intent(inout) :: CMO(*)
real(kind=wp), intent(in) :: Thrs, ThrRot, ThrGrad
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb2Loc(nSym), nFro(nSym), nMxIter
logical(kind=iwp), intent(in) :: Maximisation, Debug, Silent
logical(kind=iwp), intent(out) :: Converged
integer(kind=iwp) :: iComp, iOpt, irc, iSym, kOffC, lAux, nBasT, nFroT, nOrb2LocT
character(len=8) :: Label
real(kind=wp), allocatable :: Aux(:), Lbl(:,:,:), Lbl_AO(:,:,:)
integer(kind=iwp), parameter :: nComp = 3 ! 3 components of dipole operator
character(len=*), parameter :: SecNam = 'Boys'

! Symmetry is NOT allowed!!
! -------------------------

if (nSym /= 1) then
  call SysAbendMsg(SecNam,'Symmetry not implemented!','Sorry!')
end if

! Initializations.
! ----------------

Functional = -huge(Functional)

nBasT = nBas(1)
nOrb2LocT = nOrb2Loc(1)
nFroT = nFro(1)

Converged = .false.

! Read AO dipole moment integrals.
! --------------------------------

call mma_allocate(Lbl_AO,nBasT,nBasT,nComp,label='Dipole')

lAux = nBasT*(nBasT+1)/2+4
call mma_allocate(Aux,lAux,label='DipAux')
Label = 'Mltpl  1'
do iComp=1,nComp
  irc = -1
  iOpt = 2
  iSym = 1
  call RdOne(irc,iOpt,Label,iComp,Aux,iSym)
  if (irc /= 0) then
    write(u6,*) SecNam,': RdOne returned ',irc
    write(u6,*) 'Label = ',Label,'   Component = ',iComp
    call SysAbendMsg(SecNam,'I/O error in RdOne',' ')
  end if
  if (Debug) then
    write(u6,*)
    write(u6,*) ' Triangular dipole matrix at start'
    write(u6,*) ' ---------------------------------'
    write(u6,*) ' Component: ',iComp
    call TriPrt(' ',' ',Aux,nBasT)
  end if
  call Tri2Rec(Aux,Lbl_AO(:,:,iComp),nBasT,Debug)
end do
call mma_deallocate(Aux)

! Allocate MO arrays.
! -------------------

call mma_allocate(Lbl,nOrb2LocT,nOrb2LocT,nComp,label='MO_dip')

! Localise orbitals.
! ------------------

kOffC = 1+nBasT*nFroT
call Boys_Iter(Functional,CMO(kOffC),Thrs,ThrRot,ThrGrad,Lbl_AO,Lbl,nBasT,nOrb2LocT,nComp,nMxIter,Maximisation,Converged,Debug, &
               Silent)

! De-allocations.
! ---------------

call mma_deallocate(Lbl_AO)
call mma_deallocate(Lbl)

end subroutine Boys

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine XDR_fpFWprop(n,Tr,X,pXp,A,B,R,EL,ES,OL,OS,tmp)
C
C  Transform property operator (X,pXp) to fpFW picture
C
      implicit none
C Input
      integer n
      Real*8 Tr(n,n),X(n,n),pXp(n,n),A(n),B(n),R(n)
C Output
      Real*8 EL(n,n),ES(n,n),OL(n,n),OS(n,n)
C Temp
      integer i,j
      Real*8 tmp(n,n),av,aw
C
      call dmxma(n,'C','N',Tr,X,tmp,1.d0)
      call dmxma(n,'N','N',tmp,Tr,X,1.d0)
      call dmxma(n,'C','N',Tr,pXp,tmp,1.d0)
      call dmxma(n,'N','N',tmp,Tr,pXp,1.d0)
C
      do i=1,n
        do j=1,n
          av = X(j,i) * A(i) * A(j)
          aw = pXp(j,i) * B(i) * B(j)
          EL(j,i) = av + aw
          ES(j,i) = aw/R(i)/R(j) + av*R(i)*R(j)
          OL(j,i) = aw/R(i) - av*R(i)
          OS(j,i) = aw/R(j) - av*R(j)
        enddo
      enddo
C
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKSA_DP(DREF,NDREF,PREF,NPREF,iSYM,SA,NSA,iLo,iHi,jLo,jHi,LDA)
! In parallel, this subroutine is called on a local chunk of memory
! and LDA is set. In serial, the whole array is passed but then the
! storage uses a triangular scheme, and the LDA passed is zero.

use Index_Functions, only: iTri
use SUPERINDEX, only: MTUV
use caspt2_module, only: NASHT, nTUVES
use Constants, only: Two, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF, iSYM, NSA, iLo, iHi, jLo, jHi, LDA
real(kind=wp), intent(in) :: DREF(NDREF), PREF(NPREF)
real(kind=wp), intent(inout) :: SA(NSA)
integer(kind=iwp) :: ID, IP, ISADR, ITABS, ITUV, ITUVABS, IUABS, IVABS, IVT, IVU, IVZ, IXABS, IXT, IXYZ, IXYZABS, IXZ, IYABS, IYZ, &
                     IZABS
real(kind=wp) :: Val

ISADR = 0
!-SVC20100831: fill in the G2 and G1 corrections for SA
do IXYZ=jLo,jHi
  IXYZABS = IXYZ+NTUVES(ISYM)
  IXABS = MTUV(1,IXYZABS)
  IYABS = MTUV(2,IXYZABS)
  IZABS = MTUV(3,IXYZABS)
  do ITUV=iLo,iHi
    ITUVABS = ITUV+NTUVES(ISYM)
    ITABS = MTUV(1,ITUVABS)
    IUABS = MTUV(2,ITUVABS)
    IVABS = MTUV(3,ITUVABS)
    ! Add  2 dtx Gvuyz + 2 dtx dyu Gvz
    if (LDA /= 0) then
      Val = SA(1+(iTUV-iLo)+LDA*(iXYZ-jLo))
    else if (IXYZ > ITUV) then
      cycle
    else
      ISADR = iTri(ITUV,IXYZ)
      Val = SA(ISADR)
    end if
    if (ITABS == IXABS) then
      IVU = IVABS+NASHT*(IUABS-1)
      IYZ = IYABS+NASHT*(IZABS-1)
      IP = iTri(IVU,IYZ)
      Val = Val+Four*PREF(IP)
      if (IYABS == IUABS) then
        ID = iTri(IVABS,IZABS)
        Val = Val+Two*DREF(ID)
      end if
    end if
    ! Add  -dxu Gvtyz -dxu dyt Gvz
    if (IXABS == IUABS) then
      IVT = IVABS+NASHT*(ITABS-1)
      IYZ = IYABS+NASHT*(IZABS-1)
      IP = iTri(IVT,IYZ)
      Val = Val-Two*PREF(IP)
      if (IYABS == ITABS) then
        ID = iTri(IVABS,IZABS)
        Val = Val-DREF(ID)
      end if
    end if
    ! Add  -dyt Gvuxz
    if (IYABS == ITABS) then
      IVU = IVABS+NASHT*(IUABS-1)
      IXZ = IXABS+NASHT*(IZABS-1)
      IP = iTri(IVU,IXZ)
      Val = Val-Two*PREF(IP)
    end if
    ! Add -dyu Gvzxt
    if (IYABS == IUABS) then
      IVZ = IVABS+NASHT*(IZABS-1)
      IXT = IXABS+NASHT*(ITABS-1)
      IP = iTri(IVZ,IXT)
      Val = Val-Two*PREF(IP)
    end if
    if (LDA /= 0) then
      SA(1+(iTUV-iLo)+LDA*(iXYZ-jLo)) = Val
    else
      SA(ISADR) = Val
    end if
  end do
end do

end subroutine MKSA_DP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_J_builder

use fmm_global_paras, only: INTK, REALK, scheme_paras, raw_mm_data, id_node, ELECTRONIC_ONLY, NUCLEAR_ONLY, ALL_MOMENTS, Half
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_get_E_from_Vff, &
          fmm_get_E_from_pkd_Vff, &
          fmm_get_J_from_Vff, &
          fmm_get_J_from_pkd_Vff

contains

!-------------------------------------------------------------------------------
! Trivial check that the number of moments matches the number of potentials

subroutine fmm_verify_Vff_input(scheme,LHS_mms,Vff,J_or_E)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  type(raw_mm_data), intent(in)  :: LHS_mms
  real(REALK), intent(in)        :: Vff(:,:)
  character, intent(in)          :: J_or_E
  logical :: A, B, C

  A = (size(LHS_mms%paras) /= size(Vff,2))
  if (A) call fmm_quit('incompatible SIZE of Vff and LHS moments!')

  if (J_or_E == 'J') then
    A = (scheme%LHS_mm_range == NUCLEAR_ONLY)
    B = (scheme%RHS_mm_range == NUCLEAR_ONLY)
    C = (scheme%LHS_mm_range == ALL_MOMENTS)
    if ((A .and. B) .or. C) call fmm_quit('mm_ranges invalid')
  end if

end subroutine fmm_verify_Vff_input

!-------------------------------------------------------------------------------

subroutine fmm_get_E_with_text(scheme,energy,text)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  real(REALK), intent(inout)     :: energy
  character(len=*), intent(out)  :: text
  logical :: A, B, C, D

  A = (scheme%LHS_mm_range == ELECTRONIC_ONLY)
  B = (scheme%RHS_mm_range == ELECTRONIC_ONLY)
  C = (scheme%LHS_mm_range == NUCLEAR_ONLY)
  D = (scheme%RHS_mm_range == NUCLEAR_ONLY)

  if (scheme%LHS_mm_range == scheme%RHS_mm_range) then
    energy = half*energy
    text = 'total classical Coulomb energy'
    if (A) text = 'classical Coulomb electronic energy'
    if (C) text = 'classical Coulomb nuclear repulsion'
  else if (A .or. B) then
    if (C .or. D) then
      text = 'classical Coulomb nuclear attraction'
    else
      text = 'e-n + 2*(e-e) energy'
    end if
  else
    ! range is different and neither is ELECTRONIC_ONLY
    text = 'e-n + 2*(n-n) energy'
  end if

end subroutine fmm_get_E_with_text

!-------------------------------------------------------------------------------
! Get energy from full contraction of LHS moments and the potentials
!-------------------------------------------------------------------
! We assume Vff(lm,i) is the potential at i due to ALL the RHS moments
! (so that a simple contraction with the LHS moments will double count
!  interactions if the LHS and RHS moment ranges overlap).

subroutine fmm_get_E_from_Vff(scheme,LHS_mms,Vff,energy,text)

  implicit none
  type(scheme_paras), intent(IN) :: scheme
  type(raw_mm_data), intent(IN)  :: LHS_mms
  real(REALK), intent(IN)        :: Vff(:,:)
  real(REALK), intent(OUT)       :: energy
  character(len=*), intent(OUT)  :: text

  real(REALK) :: g
  integer(INTK) :: u, v, lm_max

  call fmm_verify_Vff_input(scheme,LHS_mms,Vff,'E')

  ! although Vff should be the same size, we test for generality
  if (size(LHS_mms%qlm_T,1) /= size(Vff,1)) call fmm_quit('mm_get_E_from_Vff:2')
  lm_max = min(size(LHS_mms%qlm_T,1),size(Vff,1))
  do u=1,size(LHS_mms%paras)
    v = LHS_mms%paras(u)%id
    g = dot_product(LHS_mms%qlm_T(:lm_max,v),Vff(:lm_max,v))
    energy = energy+g
  end do

  call fmm_get_E_with_text(scheme,energy,text)

end subroutine fmm_get_E_from_Vff

!-------------------------------------------------------------------------------
! Get energy from full contraction of LHS moments and the potentials
! on the basis that the LHS parameters and Vff may have been packed
! into batches (and must be "expanded").
!-------------------------------------------------------------------
! We assume Vff(lm,i) is the potential at i due to ALL the RHS moments
! (so that a simple contraction with the LHS moments will double count
!  interactions if the LHS and RHS moment ranges overlap).

subroutine fmm_get_E_from_pkd_Vff(scheme,LHS_mms,Vff,energy,text)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  type(raw_mm_data), intent(in)  :: LHS_mms
  real(REALK), intent(in)        :: Vff(:,:)
  real(REALK), intent(out)       :: energy
  character(len=*), intent(out)  :: text

  real(REALK) :: g
  integer(INTK) :: u, v, w, lm_max
  type(id_node), pointer :: batch_map

  call fmm_verify_Vff_input(scheme,LHS_mms,Vff,'E')

  lm_max = min(size(LHS_mms%qlm_T,1),size(Vff,1))
  packed_loop: do u=1,size(LHS_mms%paras)

    v = LHS_mms%paras(u)%id ! LHS packed (batch) parameters
    batch_map => LHS_mms%batch_map(v)%head

    batch_members2: do ! over batch list until pointer disassociated
      w = batch_map%id ! raw LHS moment ID
      g = dot_product(LHS_mms%qlm_T(:lm_max,w),Vff(:lm_max,v))
      energy = energy+g
      ! only do next raw item in batch list if it exists
      if (.not. associated(batch_map%next)) exit batch_members2
      batch_map => batch_map%next
    end do batch_members2

  end do packed_loop

  call fmm_get_E_with_text(scheme,energy,text)

end subroutine fmm_get_E_from_pkd_Vff

!-------------------------------------------------------------------------------
! Build J_matrix components from contracion of the LHS moments and potentials
!----------------------------------------------------------------------------
! We assume Vff(lm,i) is the potential at i due to ALL the RHS moments
! This choice of Vff is fine here since the e-e interactions require a
! factor of 2 in the J-matrix, but NOT the e-n interactions.

subroutine fmm_get_J_from_Vff(scheme,LHS_mms,Vff,J_matrix)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  type(raw_mm_data), intent(in)  :: LHS_mms
  real(REALK), intent(in)        :: Vff(:,:)
  real(REALK), intent(out)       :: J_matrix(:,:)

  real(REALK) :: g
  integer(INTK) :: u, v, i, j, lm_max

  call fmm_verify_Vff_input(scheme,LHS_mms,Vff,'J')

  ! although Vff should be the same size, we test for generality
  if (size(LHS_mms%qlm_T,1) /= size(Vff,1)) call fmm_quit('mm_get_J_from_Vff:2')
  lm_max = min(size(LHS_mms%qlm_T,1),size(Vff,1))
  do u=1,size(LHS_mms%paras)
    v = LHS_mms%paras(u)%id
    g = dot_product(LHS_mms%qlm_T(:lm_max,v),Vff(:lm_max,v))
    i = LHS_mms%J_indices(v)%i_indx
    j = LHS_mms%J_indices(v)%j_indx
    J_matrix(i,j) = J_matrix(i,j)+g
    if (i /= j) J_matrix(j,i) = J_matrix(j,i)+g
  end do

end subroutine fmm_get_J_from_Vff

!-------------------------------------------------------------------------------
! Build J_matrix components from contracion of the LHS moments and potentials
! This routine recognises that the LHS parameters may have been packed
! and thus expands the potential over LHS batches.
!----------------------------------------------------------------------------
! We assume Vff(lm,i) is the potential at i due to ALL the RHS moments

subroutine fmm_get_J_from_pkd_Vff(scheme,LHS_mms,Vff,J_matrix)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  type(raw_mm_data), intent(in)  :: LHS_mms
  real(REALK), intent(in)        :: Vff(:,:)
  real(REALK), intent(out)       :: J_matrix(:,:)

  real(REALK) :: g
  integer(INTK) :: u, v, w, i, j, lm_max
  type(id_node), pointer :: batch_map

  call fmm_verify_Vff_input(scheme,LHS_mms,Vff,'J')

  ! Vff should now be the same size as the raw LHS parameters;
  ! However, the size of LHS %qlm_T will be larger;
  ! We need to "expand" Vff using the batch mapping.

  lm_max = min(size(LHS_mms%qlm_T,1),size(Vff,1))
  packed_loop: do u=1,size(LHS_mms%paras)

    v = LHS_mms%paras(u)%id ! LHS packed (batch) moments
    batch_map => LHS_mms%batch_map(v)%head

    batch_members: do ! over batch list until pointer disassociated
      w = batch_map%id ! raw LHS moment ID
      g = dot_product(LHS_mms%qlm_T(:lm_max,w),Vff(:lm_max,v))
      i = LHS_mms%J_indices(w)%i_indx
      j = LHS_mms%J_indices(w)%j_indx
      J_matrix(i,j) = J_matrix(i,j)+g
      !if (i /= j) J_matrix(j,i) = J_matrix(j,i)+g
      ! only do next raw item in batch list if it exists
      if (.not. associated(batch_map%next)) exit batch_members
      batch_map => batch_map%next
    end do batch_members
  end do packed_loop

end subroutine fmm_get_J_from_pkd_Vff

!-------------------------------------------------------------------------------

end module fmm_J_builder

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Sebastian Wouters                                *
!               2016, Quan Phung                                       *
!***********************************************************************
! Subroutine to load 3-RDM and F4-RDM
! Written by Quan Phung and Sebastian Wouters, Leuven, Aug 2016

subroutine chemps2_load3pdm(NAC,idxG3,NG3,storage,doG3,EPSA,F2,chemroot)

#include "intent.fh"

use mh5, only: mh5_open_file_r, mh5_open_group, mh5_fetch_dset, mh5_close_group, mh5_close_file
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, i1, u6

implicit none
integer(kind=iwp), intent(in) :: NAC, NG3, chemroot
integer(kind=i1), intent(in) :: idxG3(6,NG3)
real(kind=wp), intent(_OUT_) :: storage(*)
real(kind=wp), intent(out) :: F2(NAC,NAC,NAC,NAC)
logical(kind=iwp), intent(in) :: doG3
real(kind=wp), intent(in) :: EPSA(NAC)
character(len=30) :: file_3rdm, file_f4rdm
character(len=10) :: rootindex
integer(kind=iwp) :: file_h5, group_h5, ip1, ip2, ip3, iq1, iq2, iq3, idx, iG3
logical(kind=iwp) :: irdm, jrdm
real(kind=wp), allocatable :: buffer(:)

write(rootindex,'(i2)') chemroot-1
file_3rdm = 'molcas_3rdm.h5.r'//trim(adjustl(rootindex))
file_f4rdm = 'molcas_f4rdm.h5.r'//trim(adjustl(rootindex))
file_3rdm = trim(adjustl(file_3rdm))
file_f4rdm = trim(adjustl(file_f4rdm))
call f_inquire(file_3rdm,irdm)
call f_inquire(file_f4rdm,jrdm)
if ((.not. irdm) .or. (.not. jrdm)) then
  write(u6,'(1x,a15,i3,a26)') 'CHEMPS2> Root: ',CHEMROOT,' :: No 3RDM or F.4RDM file'
  call abend()
end if

call mma_allocate(buffer,NAC**6,label='buffer')

!#ifdef _MOLCAS_MPP_
!if (MPP() .and. KING()) then
!#endif
if (doG3) then
  file_h5 = mh5_open_file_r(file_3rdm)
  group_h5 = mh5_open_group(file_h5,'3-RDM')
else
  file_h5 = mh5_open_file_r(file_f4rdm)
  group_h5 = mh5_open_group(file_h5,'F.4-RDM')
end if
call mh5_fetch_dset(group_h5,'elements',buffer)
call mh5_close_group(group_h5)
call mh5_close_file(file_h5)
!#ifdef _MOLCAS_MPP_
!end if
!call MPI_Bcast(buffer,NAC**6,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,IERROR4)
!#endif

do iG3=1,NG3
  ip1 = idxG3(1,iG3)-1
  iq1 = idxG3(2,iG3)-1
  ip2 = idxG3(3,iG3)-1
  iq2 = idxG3(4,iG3)-1
  ip3 = idxG3(5,iG3)-1
  iq3 = idxG3(6,iG3)-1
  idx = ip1+NAC*(ip2+NAC*(ip3+NAC*(iq1+NAC*(iq2+NAC*iq3))))
  storage(iG3) = buffer(1+idx)
end do

if (doG3) then
  do iq2=1,NAC
    do ip2=1,NAC
      do iq1=1,NAC
        do ip1=1,NAC
          F2(ip1,iq1,ip2,iq2) = Zero
          do ip3=1,NAC
            idx = ip1+NAC*(ip2-1+NAC*(ip3-1+NAC*(iq1-1+NAC*(iq2-1+NAC*(ip3-1)))))
            F2(ip1,iq1,ip2,iq2) = F2(ip1,iq1,ip2,iq2)+EPSA(ip3)*buffer(idx)
          end do
        end do
      end do
    end do
  end do
end if

call mma_deallocate(buffer)

return

end subroutine chemps2_load3pdm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1994, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine RysEF4(xyz2D,nArg,mArg,nRys,neMax,nfMax,EFInt,meMin,meMax,mfMin,mfMax,PreFct,ixe,ixf,ixye,ixyf,nzeMax,nzfMax)
!***********************************************************************
!                                                                      *
! Object: kernel routine to assemble the integrals from the Ixy        *
!         and Iz integrals.                                            *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             August '90                                               *
!                                                                      *
!             Modified for decreased memory access January '94.        *
!***********************************************************************

use Index_Functions, only: C3_Ind
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nArg, mArg, nRys, neMax, nfMax, meMin, meMax, mfMin, mfMax, ixe, ixf, ixye, ixyf, nzeMax, nzfMax
real(kind=wp), intent(in) :: xyz2D(nRys,mArg,3,0:neMax,0:nfMax), PreFct(mArg)
real(kind=wp), intent(inout) :: EFInt(nArg,meMin:meMax,mfMin:mfMax)
integer(kind=iwp) :: Inde, Indf, iRys, iye, iyf, ize, izf

iyf = ixyf-ixf
iye = ixye-ixe
izf = nzfMax
ize = nzeMax
Indf = C3_Ind(ixyf+izf,ixf,izf)-1
Inde = C3_Ind(ixye+ize,ixe,ize)-1
select case (nRys)
  case (1)
    EFInt(1:mArg,Inde,Indf) = PreFct(:)*xyz2D(1,:,1,ixe,ixf)*xyz2D(1,:,2,iye,iyf)*xyz2D(1,:,3,ize,izf)
  case (2)
    EFInt(1:mArg,Inde,Indf) = PreFct(:)*(xyz2D(1,:,1,ixe,ixf)*xyz2D(1,:,2,iye,iyf)*xyz2D(1,:,3,ize,izf)+ &
                                         xyz2D(2,:,1,ixe,ixf)*xyz2D(2,:,2,iye,iyf)*xyz2D(2,:,3,ize,izf))
  case (3)
    EFInt(1:mArg,Inde,Indf) = PreFct(:)*(xyz2D(1,:,1,ixe,ixf)*xyz2D(1,:,2,iye,iyf)*xyz2D(1,:,3,ize,izf)+ &
                                         xyz2D(2,:,1,ixe,ixf)*xyz2D(2,:,2,iye,iyf)*xyz2D(2,:,3,ize,izf)+ &
                                         xyz2D(3,:,1,ixe,ixf)*xyz2D(3,:,2,iye,iyf)*xyz2D(3,:,3,ize,izf))
  case (4)
    EFInt(1:mArg,Inde,Indf) = PreFct(:)*(xyz2D(1,:,1,ixe,ixf)*xyz2D(1,:,2,iye,iyf)*xyz2D(1,:,3,ize,izf)+ &
                                         xyz2D(2,:,1,ixe,ixf)*xyz2D(2,:,2,iye,iyf)*xyz2D(2,:,3,ize,izf)+ &
                                         xyz2D(3,:,1,ixe,ixf)*xyz2D(3,:,2,iye,iyf)*xyz2D(3,:,3,ize,izf)+ &
                                         xyz2D(4,:,1,ixe,ixf)*xyz2D(4,:,2,iye,iyf)*xyz2D(4,:,3,ize,izf))
  case (5)
    EFInt(1:mArg,Inde,Indf) = PreFct(:)*(xyz2D(1,:,1,ixe,ixf)*xyz2D(1,:,2,iye,iyf)*xyz2D(1,:,3,ize,izf)+ &
                                         xyz2D(2,:,1,ixe,ixf)*xyz2D(2,:,2,iye,iyf)*xyz2D(2,:,3,ize,izf)+ &
                                         xyz2D(3,:,1,ixe,ixf)*xyz2D(3,:,2,iye,iyf)*xyz2D(3,:,3,ize,izf)+ &
                                         xyz2D(4,:,1,ixe,ixf)*xyz2D(4,:,2,iye,iyf)*xyz2D(4,:,3,ize,izf)+ &
                                         xyz2D(5,:,1,ixe,ixf)*xyz2D(5,:,2,iye,iyf)*xyz2D(5,:,3,ize,izf))
  case default

    ! General code

    EFInt(1:mArg,Inde,Indf) = xyz2D(1,:,1,ixe,ixf)*xyz2D(1,:,2,iye,iyf)*xyz2D(1,:,3,ize,izf)
    do iRys=2,nRys
      EFInt(1:mArg,Inde,Indf) = EFInt(1:mArg,Inde,Indf)+xyz2D(iRys,:,1,ixe,ixf)*xyz2D(iRys,:,2,iye,iyf)*xyz2D(iRys,:,3,ize,izf)
    end do
    EFInt(1:mArg,Inde,Indf) = EFInt(1:mArg,Inde,Indf)*PreFct(:)
end select

return

end subroutine RysEF4

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Sync_Data(Pren,Prem,nBtch,mBtch,kBtch)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
#endif
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Pren, Prem
integer(kind=iwp), intent(in) :: nBtch, mBtch, kBtch
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: nBtchV(3)
real(kind=wp) :: PrenV(2)

if (.not. Is_Real_Par()) return
if (nProcs == 1) return
PrenV(1) = Pren
PrenV(2) = Prem
call GADGOP(PrenV,2,'+')
Pren = PrenV(1)
Prem = PrenV(2)

nBtchV(1) = nBtch
nBtchV(2) = mBtch
nBtchV(3) = kBtch
call GAIGOP(nBtchV,3,'+')
nBtchV(1) = nBtch
nBtchV(2) = mBtch
nBtchV(3) = kBtch
#else
#include "macros.fh"
unused_var(Pren)
unused_var(Prem)
unused_var(nBtch)
unused_var(mBtch)
unused_var(kBtch)
#endif

end subroutine Sync_Data

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine expand1(a,b,dimpq,dimr,dimp)
! expand a(pq,r) -> b(p,q,r)
! assumption: p>q, a(p,q,r)=-a(q,p,r)
! RISC version

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimpq, dimr, dimp
real(kind=wp), intent(in) :: a(dimpq,dimr)
real(kind=wp), intent(out) :: b(dimp,dimp,dimr)
integer(kind=iwp) :: p, pq, q, r
real(kind=wp) :: scalar

if (dimp > 1) then

  do r=1,dimr
    pq = 0
    do p=2,dimp
      do q=1,p-1
        pq = pq+1
        scalar = a(pq,r)
        b(p,q,r) = scalar
        b(q,p,r) = -scalar
      end do
    end do
  end do

end if

do p=1,dimp
  b(p,p,:) = Zero
end do

return

end subroutine expand1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ibf2unit_cvb(ibf,lu,newfile)

use casvb_global, only: ifilio, iorder, mxunits
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ibf
integer(kind=iwp), intent(out) :: lu
logical(kind=iwp), intent(out) :: newfile
integer(kind=iwp) :: i, ifil
logical(kind=iwp), parameter :: debug = .false.

if (ifilio(ibf) /= 0) then
  newfile = .false.
  ifil = ifilio(ibf)
else
  newfile = .true.
  ifil = 0
  do i=1,mxunits
    if (iorder(i) == 0) then
      iorder(i) = i
      ifil = i
      exit
    end if
  end do
  if (ifil == 0) then
    do i=1,mxunits
      if (iorder(i) == mxunits) then
        ifil = i
        exit
      end if
    end do
    if (ifil == 0) then
      write(u6,*) ' ifil error - iorder :',iorder
      call abend_cvb()
    end if
  end if
  ifilio(ibf) = ifil
end if
call touchord_cvb(ifil,iorder,mxunits)
lu = 90+ifil
if (debug) write(u6,*) ' buffer:',ibf,' now associated with unit:',lu

return

end subroutine ibf2unit_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 25, 2021, created this file.               *
! ****************************************************************
subroutine Calc_Pot2_Inner(Pot2,mGrid,MOP,MOU,MOV,MOX,lSum)

use nq_Info, only: mIrrep, mOrb, nAsh, nIsh, nOrbt, nPot2, nUVX, nUVXt, nVX, nVXt, OffOrb, OffPUVX, OffUVX, OffVX
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Pot2(nPot2)
integer(kind=iwp), intent(in) :: mGrid
real(kind=wp), intent(in) :: MOP(mGrid,nOrbt), MOU(mGrid,nOrbt), MOV(mGrid,nOrbt), MOX(mGrid,nOrbt)
logical(kind=iwp) :: lSum
! Note: when lSum is .true., calculate P(U'VX+UV'X+UVX'), otherwise calculate PUVX
integer(kind=iwp) :: iOff0, iOff1, iOff2, iOff3, ioffu, iStack, iVX, nnUVX, nporb, pIrrep, puIrrep, u, uIrrep, v, vIrrep, vorb, x, &
                     xIrrep, xMax, xorb
real(kind=wp), allocatable :: MOUVX(:,:), MOVX1(:,:), MOVX2(:,:)

call mma_allocate(MOVX1,mGrid,nVXt)
if (lSum) call mma_allocate(MOVX2,mGrid,nVXt)
call mma_allocate(MOUVX,mGrid,nUVXt)

do vIrrep=0,mIrrep-1
  do xIrrep=0,vIrrep
    do v=1,nAsh(vIrrep)
      vorb = v+OffOrb(vIrrep)+nIsh(vIrrep)
      if (xIrrep == vIrrep) then
        xMax = v
        iStack = v*(v-1)/2
      else
        xMax = nAsh(xIrrep)
        iStack = (v-1)*xMax
      end if
      do x=1,xMax
        xorb = x+OffOrb(xIrrep)+nIsh(xIrrep)
        MOVX1(:,OffVX(xIrrep,vIrrep)+iStack+x) = MOV(:,vorb)*MOX(:,xorb)
      end do
    end do
  end do
end do

if (lSum) then
  do vIrrep=0,mIrrep-1
    do xIrrep=0,vIrrep
      do v=1,nAsh(vIrrep)
        vorb = v+OffOrb(vIrrep)+nIsh(vIrrep)
        if (xIrrep == vIrrep) then
          xMax = v
          iStack = v*(v-1)/2
        else
          xMax = nAsh(xIrrep)
          iStack = (v-1)*xMax
        end if
        do x=1,xMax
          xorb = x+OffOrb(xIrrep)+nIsh(xIrrep)
          IOff3 = (OffVX(xIrrep,vIrrep)+iStack+x-1)*mGrid
          MOVX1(:,OffVX(xIrrep,vIrrep)+iStack+x) = MOVX1(:,OffVX(xIrrep,vIrrep)+iStack+x)+MOX(:,vorb)*MOV(:,xorb)
          MOVX2(:,OffVX(xIrrep,vIrrep)+iStack+x) = MOU(:,vorb)*MOV(:,xorb)
        end do
      end do
    end do
  end do
end if

do uIrrep=0,mIrrep-1
  IOffU = OffOrb(uIrrep)+nIsh(uIrrep)
  do vIrrep=0,mIrrep-1
    do xIrrep=0,vIrrep
      do iVX=1,nVX(xIrrep,vIrrep)
        IOff0 = OffUVX(xIrrep,vIrrep,uIrrep)+(iVX-1)*nAsh(uIrrep)
        do u=1,nAsh(uIrrep)
          MOUVX(:,IOff0+u) = MOU(:,iOffU+u)*MOVX1(:,Offvx(xIrrep,vIrrep)+iVX)
        end do
      end do
    end do
  end do
end do

if (lSum) then
  do uIrrep=0,mIrrep-1
    IOffU = OffOrb(uIrrep)+nIsh(uIrrep)
    do vIrrep=0,mIrrep-1
      do xIrrep=0,vIrrep
        do iVX=1,nVX(xIrrep,vIrrep)
          IOff0 = OffUVX(xIrrep,vIrrep,uIrrep)+(iVX-1)*nAsh(uIrrep)
          do u=1,nAsh(uIrrep)
            MOUVX(:,IOff0+u) = MOUVX(:,IOff0+u)+MOX(:,iOffU+u)*MOVX2(:,Offvx(xIrrep,vIrrep)+iVX)
          end do
        end do
      end do
    end do
  end do
end if

! Use dgemm to calculate PUVX at this grid point
do pIrrep=0,mIrrep-1
  nporb = mOrb(pIrrep)
  if (nporb == 0) cycle
  if (nAsh(pIrrep) == 0) cycle
  IOff1 = OffOrb(pIrrep)+1
  IOff2 = OffPUVX(pIrrep)+1
  do uIrrep=0,mIrrep-1
    puIrrep = ieor(pIrrep,uIrrep)
    do vIrrep=0,mIrrep-1
      xIrrep = ieor(puIrrep,vIrrep)
      nnUVX = nUVX(xIrrep,vIrrep,uIrrep)
      if ((xIrrep > vIrrep) .or. (nnUVX == 0)) cycle
      IOff3 = OffUVX(xIrrep,vIrrep,uIrrep)+1
      call DGEMM_('T','N',npOrb,nnUVX,mGrid,One,MOP(:,iOff1:),mGrid,MOUVX(:,IOff3:),mGrid,One,Pot2(iOff2:),npOrb)
      IOff2 = IOff2+nnUVX*npOrb
    end do
  end do
end do

call mma_deallocate(MOVX1)
if (lSum) call mma_deallocate(MOVX2)
call mma_deallocate(MOUVX)

return

end subroutine Calc_Pot2_Inner

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetIndxG(iAtomPair)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: set index arrays for auxiliary functions.
C
      Implicit None
      Integer iAtomPair
#include "ldf_atom_pair_info.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"
#include "WrkSpc.fh"

      Character*12 SecNam
      Parameter (SecNam='LDF_SetIndxG')

      Integer iAtom, jAtom
      Integer iS, jS, ijS, nnShl
      Integer maxAuxSh, nShell, maxAuxSP
      Integer ip, ip0, ipIG0, ipi, ipj
      Integer k, n, nn, ij, i2CF
      Integer iShell, jShell
      Integer nShell_i, nShell_j
      Integer ipLD, iLD
      Integer iLD_Atom, iLD_Shell, iLD_Indx
      Integer l_IndxG, l_IndxG2, l_2CList
      Integer M, niS, njS

      Integer  LDF_nShell_Atom, LDF_nBasSh_Atom
      Integer  LDF_lShell_Atom
      Integer  LDF_nAuxShell_Atom, LDF_nBasAuxSh_Atom
      Integer  LDF_lAuxShell_Atom, LDF_nBasAux_Pair
      External LDF_nShell_Atom, LDF_nBasSh_Atom
      External LDF_lShell_Atom
      External LDF_nAuxShell_Atom, LDF_nBasAuxSh_Atom
      External LDF_lAuxShell_Atom, LDF_nBasAux_Pair

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Check if index arrays are already set
      ! Deallocate them if so....
      l_IndxG=l_IndxG_1*l_IndxG_2
      If (l_IndxG.gt.0) Then
         Call WarningMessage(1,SecNam//': IndxG is already allocated!')
         Call GetMem('IndxG','Free','Inte',ip_IndxG,l_IndxG)
         ip_IndxG=0
         l_IndxG=0
         l_IndxG_1=0
         l_IndxG_2=0
      End If
      l_IndxG2=l_IndxG2_1*l_IndxG2_2
      If (l_IndxG2.gt.0) Then
         Call WarningMessage(1,SecNam//': IndxG2 is already allocated!')
         Call GetMem('IndxG2','Free','Inte',ip_IndxG2,l_IndxG2)
         ip_IndxG2=0
         l_IndxG2=0
         l_IndxG2_1=0
         l_IndxG2_2=0
      End If
      l_2CList=l_2CList_1*l_2CList_2
      If (l_2CList.gt.0) Then
         Call WarningMessage(1,SecNam//': 2CList is already allocated!')
         Call GetMem('G_2CList','Free','Inte',ip_2CList,l_2CList)
         ip_2CList=0
         l_2CList_1=0
         l_2CList_2=0
      End If

      ! Get atoms of pair
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)

      ! Get number of auxiliary functions
      M=LDF_nBasAux_Pair(iAtomPair)

      ! Find largest auxiliary shell of atom pair
      maxAuxSh=0
      Do iS=1,LDF_nAuxShell_Atom(iAtom)
         maxAuxSh=max(maxAuxSh,LDF_nBasAuxSh_Atom(iS,iAtom))
      End Do
      If (iAtom.ne.jAtom) Then
         Do jS=1,LDF_nAuxShell_Atom(jAtom)
            maxAuxSh=max(maxAuxSh,LDF_nBasAuxSh_Atom(jS,jAtom))
         End Do
      End If

      ! Allocate index arrays for G matrix
      nShell=nShell_Valence+nShell_Auxiliary+1
      l_IndxG_1=maxAuxSh
      l_IndxG_2=nShell
      l_IndxG=maxAuxSh*nShell
      Call GetMem('IndxG','Allo','Inte',ip_IndxG,l_IndxG)
      l_IndxG2_1=0
      l_IndxG2_2=0
      l_IndxG2=0
      ip_IndxG2=0
      nnShl=0
      maxAuxSP=0
      nShell_i=0
      nShell_j=0
      If (AP_2CFunctions(1,iAtomPair).gt.0) Then
         nShell_i=LDF_nShell_Atom(iAtom)
         nShell_j=LDF_nShell_Atom(jAtom)
         Do jS=1,nShell_j
            n=LDF_nBasSh_Atom(jS,jAtom)
            Do iS=1,nShell_i
               maxAuxSP=max(maxAuxSP,n*LDF_nBasSh_Atom(iS,iAtom))
            End Do
         End Do
         nnShl=nShell_i*nShell_j
         l_IndxG2_1=maxAuxSP
         l_IndxG2_2=nnShl
         l_IndxG2=maxAuxSP*nnShl
         Call GetMem('IndxG2','Allo','Inte',ip_IndxG2,l_IndxG2)
      End If

      ! Set index arrays for G matrix
      ! IndxG(j,jShl): row/column index in G matrix for auxiliary basis
      !                function j in auxiliary shell jShl of atom iAtom
      !                or jAtom.
      ! IndxG2(ij,ijShl): row/column index in G matrix for 2-center
      !                   auxiliary function ij of shell pair ijShl of
      !                   atom pair iAtomPair.
      ! Note: row/column indices corresponding to linearly dependent
      ! auxiliary functions are zero.
      Call iZero(iWork(ip_IndxG),l_IndxG)
      ip=LDF_lAuxShell_Atom(iAtom)-1
      k=0
      Do iS=1,LDF_nAuxShell_Atom(iAtom)
         iShell=iWork(ip+iS)
         ipIG0=ip_IndxG-1+maxAuxSh*(iShell-1)
         Do i=1,nBasSh(iShell)
            k=k+1
            iWork(ipIG0+i)=k
         End Do
      End Do
      If (jAtom.ne.iAtom) Then
         ip=LDF_lAuxShell_Atom(jAtom)-1
         Do jS=1,LDF_nAuxShell_Atom(jAtom)
            jShell=iWork(ip+jS)
            ipIG0=ip_IndxG-1+maxAuxSh*(jShell-1)
            Do i=1,nBasSh(jShell)
               k=k+1
               iWork(ipIG0+i)=k
            End Do
         End Do
      End If
      If (AP_1CLinDep(1,iAtomPair).gt.0) Then
         ! zero entries corresponding to lin dep functions
         ipLD=AP_1CLinDep(2,iAtomPair)-1
         Do iLD=0,AP_1CLinDep(1,iAtomPair)-1
            iLD_Atom=iWork(ipLD+3*iLD+1)
            iLD_Shell=iWork(ipLD+3*iLD+2)
            iLD_Indx=iWork(ipLD+3*iLD+3)
            ip=LDF_lAuxShell_Atom(iLD_Atom)-1
            iShell=iWork(ip+iLD_Shell)
            ipIG0=ip_IndxG-1+maxAuxSh*(iShell-1)
            iWork(ipIG0+iLD_Indx)=0
         End Do
         ! reset row/column indices
         ip=LDF_lAuxShell_Atom(iAtom)-1
         k=0
         Do iS=1,LDF_nAuxShell_Atom(iAtom)
            iShell=iWork(ip+iS)
            ipIG0=ip_IndxG-1+maxAuxSh*(iShell-1)
            Do i=1,nBasSh(iShell)
               If (iWork(ipIG0+i).gt.0) Then
                  k=k+1
                  iWork(ipIG0+i)=k
               End If
            End Do
         End Do
         If (jAtom.ne.iAtom) Then
            ip=LDF_lAuxShell_Atom(jAtom)-1
            Do jS=1,LDF_nAuxShell_Atom(jAtom)
               jShell=iWork(ip+jS)
               ipIG0=ip_IndxG-1+maxAuxSh*(jShell-1)
               Do i=1,nBasSh(jShell)
                  If (iWork(ipIG0+i).gt.0) Then
                     k=k+1
                     iWork(ipIG0+i)=k
                  End If
               End Do
            End Do
         End If
      End If
      If (AP_2CFunctions(1,iAtomPair).gt.0) Then
         ! Include 2-center functions
         Call iZero(iWork(ip_IndxG2),l_IndxG2)
         ip0=AP_2CFunctions(2,iAtomPair)-1
         Do i2CF=0,AP_2CFunctions(1,iAtomPair)-1
            ip=ip0+4*i2CF
            iS=iWork(ip+1)
            i=iWork(ip+2)
            jS=iWork(ip+3)
            j=iWork(ip+4)
            ijS=nShell_i*(jS-1)+iS
            ij=LDF_nBasSh_Atom(iS,iAtom)*(j-1)+i
            k=k+1
            iWork(ip_IndxG2-1+maxAuxSP*(ijS-1)+ij)=k
         End Do
      End If
#if defined (_DEBUGPRINT_)
      If (k.ne.M) Then
         Write(6,'(A,I8,1X,I8)') SecNam//': k,M=',k,M
         Call WarningMessage(2,SecNam//': G matrix dimension problem!')
         Call LDF_Quit(1)
      End If
#endif

      ! Set up shell pair list for 2-center functions
      If (AP_2CFunctions(1,iAtomPair).gt.0) Then
         ! count shell pairs
         n=0
         Do ijS=0,nnShl-1
            nn=0
            Do ij=0,maxAuxSP-1
               nn=nn+iWork(ip_IndxG2+maxAuxSP*ijS+ij)
            End Do
            n=n+min(nn,1)
         End Do
         ! Allocate list
         l_2CList_1=3
         l_2CList_2=n
         l_2CList=l_2CList_1*l_2CList_2
         Call GetMem('G_2CList','Allo','Inte',ip_2CList,l_2CList)
         ! Set list
         niS=LDF_nShell_Atom(iAtom)
         ipi=LDF_lShell_Atom(iAtom)-1
         njS=LDF_nShell_Atom(jAtom)
         ipj=LDF_lShell_Atom(jAtom)-1
         n=0
         Do ijS=1,nnShl
            nn=0
            Do ij=0,maxAuxSP-1
               nn=nn+iWork(ip_IndxG2+maxAuxSP*(ijS-1)+ij)
            End Do
            If (nn.gt.0) Then
               jS=(ijS-1)/niS+1
               iS=ijS-niS*(jS-1)
               iWork(ip_2CList+3*n)=iWork(ipi+iS)
               iWork(ip_2CList+3*n+1)=iWork(ipj+jS)
               iWork(ip_2CList+3*n+2)=ijS
               n=n+1
            End If
         End Do
      End If

      ! Set nRow_G
      nRow_G=M

      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_UnsetIndxG()
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Unset index arrays for G matrix.
C
      Implicit None
#include "localdf_int.fh"

      Integer l_IndxG, l_IndxG2, l_2CList

      l_IndxG=l_IndxG_1*l_IndxG_2
      If (l_IndxG.gt.0) Then
         Call GetMem('IndxG','Free','Inte',ip_IndxG,l_IndxG)
         ip_IndxG=0
         l_IndxG=0
         l_IndxG_1=0
         l_IndxG_2=0
      End If
      l_IndxG2=l_IndxG2_1*l_IndxG2_2
      If (l_IndxG2.gt.0) Then
         Call GetMem('IndxG2','Free','Inte',ip_IndxG2,l_IndxG2)
         ip_IndxG2=0
         l_IndxG2=0
         l_IndxG2_1=0
         l_IndxG2_2=0
      End If
      l_2CList=l_2CList_1*l_2CList_2
      If (l_2CList.gt.0) Then
         Call GetMem('G_2CList','Free','Inte',ip_2CList,l_2CList)
         ip_2CList=0
         l_2CList_1=0
         l_2CList_2=0
      End If
      If (l_iOff.gt.0) Then
         Call GetMem('iOff','Free','Inte',ip_iOff,l_iOff)
         ip_iOff=0
         l_iOff=0
      End If

      nRow_G=0
      nRow_uvJ=0
      iOffuv=0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!  ********************************************************
!  ** Public-domain library routines used by casvb only. **
!  ********************************************************
!  **********************
!  ** EISPACK ROUTINES **
!  **********************

subroutine balbak(nm,n,low,igh,scl,m,z)
! this subroutine is a translation of the algol procedure balbak,
! num. math. 13, 293-304(1969) by parlett and reinsch.
! handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
!
! this subroutine forms the eigenvectors of a real general
! matrix by back transforming those of the corresponding
! balanced matrix determined by  balanc.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.
!
!    n is the order of the matrix.
!
!    low and igh are integers determined by  balanc.
!
!    scl contains information determining the permutations
!      and scaling factors used by  balanc.
!
!    m is the number of columns of z to be back transformed.
!
!    z contains the real and imaginary parts of the eigen-
!      vectors to be back transformed in its first m columns.
!
! on output
!
!    z contains the real and imaginary parts of the
!      transformed eigenvectors in its first m columns.
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n, low, igh, m
real(kind=wp), intent(in) :: scl(n)
real(kind=wp), intent(inout) :: z(nm,m)
integer(kind=iwp) :: i, ii, j, k
real(kind=wp) :: s

if (m == 0) return
if (igh /= low) then
  do i=low,igh
    s = scl(i)
    ! .......... left hand eigenvectors are back transformed if the
    !            foregoing statement is replaced by s=1.0/scl(i). ..........
    z(i,:) = z(i,:)*s

  end do
end if

! ......... for i=low-1 step -1 until 1, igh+1 step 1 until n do -- ..........
do ii=1,n
  i = ii
  if ((i >= low) .and. (i <= igh)) cycle
  if (i < low) i = low-ii
  k = int(scl(i))
  if (k == i) cycle

  do j=1,m
    s = z(i,j)
    z(i,j) = z(k,j)
    z(k,j) = s
  end do

end do

return

end subroutine balbak

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************
!  Polink
!
!> @brief
!>   Add the field from the QM-region onto the solvent. Include the field from the
!>   polarizabilities in the solvent onto the QM-region.
!>   (The effect of the static field is taken care of in hel)
!> @author A. Ohrn
!>
!> @details
!> To begin with we obtain the charge distribution of the QM-region
!> as it exists due to the pressent density matrix (recall that it
!> is the changes in the density matrix that causes the QM-region to
!> be polarized). The field from these new multipoles are added on to
!> solvent. We also include the reaction field from the QM-region.
!> Then, with the new field from the QM-region included, we compute
!> the field from the polarizabiolities in the solvent onto the QM-region,
!> which is done just like in ::hel.
!>
!> @param[in,out] Energy  The energy of the electrostatic interaction
!> @param[in]     iAtom2  Number of particles in the solvent, times number of polarizabilities per solvent molecule
!> @param[in]     iCi     Number of centers in QM-molecule
!> @param[in]     Fil     The static field from the solvent
!> @param[out]    VpolMat The matrix due to polarization
!> @param[in,out] FFp     The field from the induced dipoles in the solvent
!> @param[in]     polfac  A factor for the computation of the image
!> @param[out]    poli    The solvent polarized field on QM-region
!> @param[in]     iCstart Number to keep track of solvent molecules
!> @param[in]     iTri    ``iOrb(1)*(iOrb(1)+1)/2``
!> @param[in]     iQ_Atoms
!> @param[in]     qTot
!> @param[in]     ChaNuc
!> @param[out]    xyzMyQ
!> @param[in]     xyzMyI
!> @param[in]     xyzMyP
!> @param[in]     RoMat
!> @param[out]    xyzQuQ
!> @param[in]     CT
!***********************************************************************

subroutine Polink(Energy,iAtom2,iCi,Fil,VpolMat,FFp,polfac,poli,iCstart,iTri,iQ_Atoms,qTot,ChaNuc,xyzMyQ,xyzMyI,xyzMyP,RoMat, &
                  xyzQuQ,CT)

use qmstat_global, only: Cha, ChargedQM, Cordst, DipMy, nCent, nPart, nPol, outxyz, Pol, Quad
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iAtom2, iCi, iCstart, iTri, iQ_Atoms
real(kind=wp), intent(inout) :: Energy, FFp(nPart*nPol,3)
real(kind=wp), intent(out) :: VpolMat(iTri), Poli(iCi,10), xyzMyQ(3), xyzQuQ(6)
real(kind=wp), intent(in) :: Fil(nPart*nPol,3,iCi,10), polfac, qTot, ChaNuc(iQ_Atoms), xyzMyI(3), xyzMyP(3), RoMat(iTri), CT(3)
integer(kind=iwp) :: i, iCnum, Iu, j, l
real(kind=wp) :: CofC(3), Gunnar(10), G(3), qD(6), qK(6), qQ(6), qs, Trace1, Trace2, xyzMyC(3)
real(kind=wp), allocatable :: Dm(:,:), Eil(:,:), Qm(:), QQm(:,:)

!----------------------------------------------------------------------*
! Begin with some zeros.                                               *
!----------------------------------------------------------------------*
call mma_allocate(Qm,iCi,label='Qm')
call mma_allocate(Dm,iCi,3,label='Dm')
call mma_allocate(QQm,iCi,6,label='QQm')
call mma_allocate(Eil,iAtom2,3,label='Eil')
iCnum = iCStart/nCent
Qm(1:iQ_Atoms) = -ChaNuc !Here is nuclear contribution added to atoms.
Qm(iQ_Atoms+1:) = Zero
Dm(:,:) = Zero
QQm(:,:) = Zero
Eil(:,:) = Zero
!----------------------------------------------------------------------*
! Below we compute how the MME of the QM-molecule changes with the new *
! density matrix Romat. What we actually do is a HF-SCF procedure with *
! a MME-expanded density. A change in the density has the effect that  *
! the set of multipoles in the MME are slightly perturbed.             *
!----------------------------------------------------------------------*
do i=1,iTri
  Qm(:) = Cha(i,:)*Romat(i)+Qm(:)
  Dm(:,1) = Dm(:,1)+DipMy(i,1,:)*Romat(i)
  Dm(:,2) = Dm(:,2)+DipMy(i,2,:)*Romat(i)
  Dm(:,3) = Dm(:,3)+DipMy(i,3,:)*Romat(i)
  QQm(:,1) = QQm(:,1)+Quad(i,1,:)*Romat(i)
  QQm(:,3) = QQm(:,3)+Quad(i,3,:)*Romat(i)
  QQm(:,6) = QQm(:,6)+Quad(i,6,:)*Romat(i)
  QQm(:,2) = QQm(:,2)+Quad(i,2,:)*Romat(i)
  QQm(:,4) = QQm(:,4)+Quad(i,4,:)*Romat(i)
  QQm(:,5) = QQm(:,5)+Quad(i,5,:)*Romat(i)
end do
xyzMyQ(:) = Zero
xyzMyC(:) = Zero
xyzQuQ(:) = Zero
CofC(:) = Zero
qQ(:) = Zero
qD(:) = Zero
qK(:) = Zero
! Observe one tricky thing about xyzmyq: the electric multipoles
! we use above are actually of opposite sign, so how can xyzmyq be
! the dipole in the qm-region unless we change sign (which we do
! not)? The reason is that the density matrix elements will also
! have opposite sign, which in turn has no physical meaning.
! We also compute the quadupole moment -- a messy formula.
do i=1,iCi
  xyzMyQ(:) = xyzMyQ(:)+Dm(i,:)+Qm(i)*outxyz(:,i)
  qQ(1) = qQ(1)+Qm(i)*(outxyz(1,i)-CT(1))*(outxyz(1,i)-CT(1))
  qQ(2) = qQ(2)+Qm(i)*(outxyz(1,i)-CT(1))*(outxyz(2,i)-CT(2))
  qQ(3) = qQ(3)+Qm(i)*(outxyz(1,i)-CT(1))*(outxyz(3,i)-CT(3))
  qQ(4) = qQ(4)+Qm(i)*(outxyz(2,i)-CT(2))*(outxyz(2,i)-CT(2))
  qQ(5) = qQ(5)+Qm(i)*(outxyz(2,i)-CT(2))*(outxyz(3,i)-CT(3))
  qQ(6) = qQ(6)+Qm(i)*(outxyz(3,i)-CT(3))*(outxyz(3,i)-CT(3))
  qD(1) = qD(1)+Two*Dm(i,1)*(outxyz(1,i)-CT(1))
  qD(2) = qD(2)+Dm(i,1)*(outxyz(2,i)-CT(2))+Dm(i,2)*(outxyz(1,i)-CT(1))
  qD(3) = qD(3)+Dm(i,1)*(outxyz(3,i)-CT(3))+Dm(i,3)*(outxyz(1,i)-CT(1))
  qD(4) = qD(4)+Two*Dm(i,2)*(outxyz(2,i)-CT(2))
  qD(5) = qD(5)+Dm(i,2)*(outxyz(3,i)-CT(3))+Dm(i,3)*(outxyz(2,i)-CT(2))
  qD(6) = qD(6)+Two*Dm(i,3)*(outxyz(3,i)-CT(3))
  qK(1) = qK(1)+QQm(i,1)
  qK(2) = qK(2)+QQm(i,2)
  qK(3) = qK(3)+QQm(i,4)
  qK(4) = qK(4)+QQm(i,3)
  qK(5) = qK(5)+QQm(i,5)
  qK(6) = qK(6)+QQm(i,6)
end do
Trace1 = qQ(1)+qQ(4)+qQ(6)
Trace2 = qD(1)+qD(4)+qD(6)
Trace1 = Trace1
Trace2 = Trace2
xyzQuQ(:) = OneHalf*(qQ+qD)+qK
xyzQuQ(1) = xyzQuQ(1)-Half*(Trace1+Trace2)
xyzQuQ(4) = xyzQuQ(4)-Half*(Trace1+Trace2)
xyzQuQ(6) = xyzQuQ(6)-Half*(Trace1+Trace2)
if (ChargedQM) then !If charged system, then do...
  qs = Zero
  do i=1,iCi
    CofC(:) = CofC+abs(Qm(i))*outxyz(:,i) !Center of charge
    qs = qs+abs(Qm(i))
  end do
  CofC(:) = CofC/qs
  G(:) = CofC-outxyz(:,1)+Cordst(:,1) !Where C-of-C is globally
  xyzMyC(:) = xyzMyC+qtot*G !Dipole
end if
do i=1,3
  ! Change sign on both the dipoles, which in effect gives
  ! no sign change, all in order with Boettcher, p.145.
  Energy = Energy+Polfac*xyzMyQ(i)*(xyzMyQ(i)+xyzMyi(i))
end do
!----------------------------------------------------------------------*
! The multipoles of the QM-region, modified due to the polarization,   *
! now interacts with each polarizability in the solvent.               *
!----------------------------------------------------------------------*
do i=1,iCi
  do j=1+(nPol*iCnum),iAtom2
    Eil(j,:) = Eil(j,:)+Fil(j,:,i,1)*Qm(i)+ &
               Fil(j,:,i,2)*Dm(i,1)+Fil(j,:,i,3)*Dm(i,2)+Fil(j,:,i,4)*Dm(i,3)+ &
               Fil(j,:,i,5)*QQm(i,1)+Fil(j,:,i,7)*QQm(i,3)+Fil(j,:,i,10)*QQm(i,6)+ &
               Fil(j,:,i,6)*QQm(i,2)*Two+Fil(j,:,i,8)*QQm(i,4)*Two+Fil(j,:,i,9)*QQm(i,5)*Two
  end do
end do
! THIS IS LEBENSGEFAHRLICH (original comment says it all!)
!----------------------------------------------------------------------*
! We add up the field from the QM-region to the field on all the       *
! solvent polarizabilities.                                            *
!----------------------------------------------------------------------*
do i=1+(nPol*iCNum),iAtom2
  Iu = i-((i-1)/nPol)*nPol
  ! Here we add the QM-molecule image to the solvent polarizabilities.
  ! Good old classical dielectric cavity model!
  do j=1,3
    FFp(i,j) = FFp(i,j)+PolFac*xyzMyQ(j)+Eil(i,j)
    ! How much the induced dipoles in solvent interacts with the field from the QM-region.
    Energy = Energy+FFp(i,j)*Eil(i,j)*Pol(iu)
  end do
end do
call mma_deallocate(Qm)
call mma_deallocate(Dm)
call mma_deallocate(QQm)
call mma_deallocate(Eil)
!----------------------------------------------------------------------*
! Now we wish to make the induced field from the solvent interact with *
! the QM-region. The static field has already interacted in helstate.  *
! The reaction field of the QM-region in the dielectric cavity is      *
! also included, excluding the quadrupoles and higher; they are        *
! small anyway, so this is not a major restriction.                    *
!----------------------------------------------------------------------*
Gunnar(:) = Zero
Gunnar(2:4) = PolFac*(xyzMyP+xyzMyQ+xyzMyI+xyzMyC)
do l=1,iCi
  ! Potential from the apparent surface charge, see Boettcher (4.22).
  Gunnar(1) = Gunnar(2)*outxyz(1,l)+Gunnar(3)*outxyz(2,l)+Gunnar(4)*outxyz(3,l)
  do i=1,10
    Poli(l,i) = Gunnar(i)
    do j=1+(nPol*iCnum),iAtom2
      Iu = j-((j-1)/nPol)*nPol
      ! Compute the generalized field from induced dipoles in solvent on the QM-region cites.
      Poli(l,i) = Poli(l,i)-FFp(j,1)*Pol(iu)*Fil(j,1,l,i)-FFp(j,2)*Pol(iu)*Fil(j,2,l,i)-FFp(j,3)*Pol(iu)*Fil(j,3,l,i)
    end do
  end do
end do
VpolMat(:) = Zero
do i=1,iTri
  do j=1,iCi
    Vpolmat(i) = Vpolmat(i)+Poli(j,1)*Cha(i,j)+ &
                 Poli(j,2)*DipMy(i,1,j)+Poli(j,3)*DipMy(i,2,j)+Poli(j,4)*DipMy(i,3,j)+ &
                 Poli(j,5)*Quad(i,1,j)+Poli(j,7)*Quad(i,3,j)+Poli(j,10)*Quad(i,6,j)+ &
                 Poli(j,6)*Quad(i,2,j)*Two+Poli(j,8)*Quad(i,4,j)*Two+Poli(j,9)*Quad(i,5,j)*Two
  end do
end do
! This is how the nuclei interact with the induced field (in equil2 exists a corresponding
! term for the interaction with the static field).
! This way interaction between a charged molecule and the induced/permanent potential is included.
do i=1,iQ_Atoms
  Energy = Energy-2*Poli(i,1)*ChaNuc(i)
end do

return

end subroutine Polink

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function ElPot(r,rinv,x,y,z,dMullig,lMax,A,chP,lDOrNot1,lDOrNot2)
! The electric potential with diffuse s- and p-functions. No
! higher than d-functions (with non-zero trace).

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: ElPot
integer(kind=iwp), intent(in) :: lMax
real(kind=wp), intent(in) :: r, rinv, x, y, z, dMullig((lMax+1)*(lMax+2)*(lMax+3)/6), A(2), chP
logical(kind=iwp), intent(in) :: lDOrNot1, lDOrNot2
real(kind=wp) :: ar, dCh, dL2(6), dL3(10), dL4(15), dL5(21), dM
real(kind=wp), external :: ElPointPot
#include "warnings.h"

ElPot = Zero
if (lMax >= 0) then
  if (lDOrNot1) then
    dCh = chP*rinv
    dCh = dCh+dMullig(1)*rinv*(One-(One+A(1)*r)*exp(-Two*A(1)*r))
    ElPot = dCh
  else
    dL2(1) = dMullig(1)+chP
    ElPot = ElPot+ElPointPot(rinv,x,y,z,0,dL2)
  end if
end if
if (lMax >= 1) then
  if (lDOrNot2) then
    ar = A(2)*r
    dM = (x*dMullig(2)+y*dMullig(3)+z*dMullig(4))*rinv**3*(One-(One+Two*ar+Two*ar**2+ar**3)*exp(-Two*ar))
    ElPot = ElPot+dM
  else
    dL2(1) = dMullig(2)
    dL2(2) = dMullig(3)
    dL2(3) = dMullig(4)
    ElPot = ElPot+ElPointPot(rinv,x,y,z,1,dL2)
  end if
end if
if (lMax >= 2) then
  dL2(1) = dMullig(5)
  dL2(2) = dMullig(6)
  dL2(3) = dMullig(7)
  dL2(4) = dMullig(8)
  dL2(5) = dMullig(9)
  dL2(6) = dMullig(10)
  ElPot = ElPot+ElPointPot(rinv,x,y,z,2,dL2)
end if
if (lMax >= 3) then
  dL3(1) = dMullig(11)
  dL3(2) = dMullig(12)
  dL3(3) = dMullig(13)
  dL3(4) = dMullig(14)
  dL3(5) = dMullig(15)
  dL3(6) = dMullig(16)
  dL3(7) = dMullig(17)
  dL3(8) = dMullig(18)
  dL3(9) = dMullig(19)
  dL3(10) = dMullig(20)
  ElPot = ElPot+ElPointPot(rinv,x,y,z,3,dL3)
end if
if (lMax >= 4) then
  dL4(1) = dMullig(21)
  dL4(2) = dMullig(22)
  dL4(3) = dMullig(23)
  dL4(4) = dMullig(24)
  dL4(5) = dMullig(25)
  dL4(6) = dMullig(26)
  dL4(7) = dMullig(27)
  dL4(8) = dMullig(28)
  dL4(9) = dMullig(29)
  dL4(10) = dMullig(30)
  dL4(11) = dMullig(31)
  dL4(12) = dMullig(32)
  dL4(13) = dMullig(33)
  dL4(14) = dMullig(34)
  dL4(15) = dMullig(35)
  ElPot = ElPot+ElpointPot(rinv,x,y,z,4,dL4)
end if
if (lMax >= 5) then
  dL5(1) = dMullig(36)
  dL5(2) = dMullig(37)
  dL5(3) = dMullig(38)
  dL5(4) = dMullig(39)
  dL5(5) = dMullig(40)
  dL5(6) = dMullig(41)
  dL5(7) = dMullig(42)
  dL5(8) = dMullig(43)
  dL5(9) = dMullig(44)
  dL5(10) = dMullig(45)
  dL5(11) = dMullig(46)
  dL5(12) = dMullig(47)
  dL5(13) = dMullig(48)
  dL5(14) = dMullig(49)
  dL5(15) = dMullig(50)
  dL5(16) = dMullig(51)
  dL5(17) = dMullig(52)
  dL5(18) = dMullig(53)
  dL5(19) = dMullig(54)
  dL5(20) = dMullig(55)
  dL5(21) = dMullig(56)
  ElPot = ElPot+ElpointPot(rinv,x,y,z,5,dL5)
end if
if (lMax >= 6) then
  write(u6,*)
  write(u6,*) 'Oops! You hit the roof with respect to angular momentum. Lower that, or do some programming.'
  call Quit(_RC_GENERAL_ERROR_)
end if

return

end function ElPot

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Steven Vancoillie                                *
!***********************************************************************
PROGRAM CASPT2_MINI
  ! A mini-caspt2 program to test the new UDL decompostition in a flexible
  ! environment.  This initial version is based on a Molcas 7.9 calculation of
  ! the 'crazy' system BeHe2Li (without IPEA shift!).

  ! Steven Vancoillie, November-December 2013, Lund

  USE ISO_FORTRAN_ENV, ONLY: REAL64
  USE SECOND_QUANTIZATION
  USE WAVEFUNCTION
  USE DENSITY
  USE FOCKMATRIX
  USE ORBINT
  IMPLICIT NONE

  ! orbital indices
  INTEGER :: P, Q, R, S

  ! the wavefunction
  TYPE(WFN) :: PSI
  INTEGER :: NEL, NORB, MULT

  ! Fock matrix
  TYPE(FMAT) :: F
  INTEGER :: NI, NA, NS, NAO, NMO
  REAL(REAL64), ALLOCATABLE :: FTOT(:,:)

  ! orbint stuff
  REAL(REAL64), ALLOCATABLE :: CMO(:,:)
  REAL(REAL64), ALLOCATABLE :: ONEINT(:,:)
  REAL(REAL64), ALLOCATABLE :: TWOINT(:,:,:,:)

  ! the one- and two- electron density matrices
  REAL(REAL64), ALLOCATABLE :: D1(:,:)
  REAL(REAL64), ALLOCATABLE :: D2(:,:,:,:)

  ! extra info
  ! INTEGER :: NTOTEL

  ! core energy
  ! REAL(REAL64) :: ECORE

  ! initialize linalg library
  CALL INIT_LINALG

  ! initialize binomial tables needed for ranking
  CALL RANK_INIT

  !################################################################
  !#### Set up the wavefunction
  !################################################################

  ! initialize values to match the 'crazy' BeHeLi system
  NEL = 3
  NORB = 3
  MULT = 2

  NI=2
  NA=3
  NS=2
  NMO=NI+NA+NS
  NAO=38

  ! ECORE=-16.704241392292605D0

  ! initialize the wavefunction
  CALL WFN_INIT(PSI,NEL,NORB,MULT)

  ! set coefficients to the rasscf coefficients
  ! of the LiHe2Be calculations
  PSI%COEF    =  0.0D0
  PSI%COEF(1,1) =  1.d0 * ( 0.984615412797048d0) * (-1.d0)
  PSI%COEF(1,2) = -1.d0 * ( 0.116525050204646d-1)
  PSI%COEF(2,1) =  1.d0 * (-0.332209883242451d-12) * (-1.d0)
  PSI%COEF(2,2) =  SQRT(1.d0/2.d0) * (-0.332387701248167d-11) * (-1.d0)
  PSI%COEF(3,1) = -SQRT(1.d0/2.d0) * (-0.332387701248167d-11)
  PSI%COEF(3,2) =  1.d0 * ( 0.250355292052973d-12) * (-1.d0)
  PSI%COEF(1,3) = -SQRT(2.d0/3.d0) * (-0.194099496829364d-11)
  PSI%COEF(2,2) = PSI%COEF(2,2) + SQRT(1.d0/6.d0) * (-0.194099496829364d-11) *(-1.d0)
  PSI%COEF(3,1) = PSI%COEF(3,1) + SQRT(1.d0/6.d0) * (-0.194099496829364d-11)
  PSI%COEF(2,3) = -1.d0 * (-0.723233381792119d-1)
  PSI%COEF(3,3) = -1.d0 * ( 0.158638087368269d0)

  ! normalize the CI coefficients if needed
  !CALL WFN_NORMALIZE(PSI)

  ! print the wavefunction, takes CI coefficient treshold
  CALL WFN_PRINT(PSI,0.0D0)

  !################################################################
  !#### Compute density matrices
  !################################################################

  ALLOCATE(D1(NORB,NORB))
  CALL D1_ANN(PSI,D1)

  ALLOCATE(D2(NORB,NORB,NORB,NORB))
  CALL D2_ANN(PSI,D2)

  !################################################################
  !#### Set up the MO integrals
  !################################################################

  ALLOCATE(CMO(NAO,NMO))
  ALLOCATE(ONEINT(NMO,NMO))
  ALLOCATE(TWOINT(NMO,NMO,NMO,NMO))

  CALL ORBINT_LOAD(CMO,ONEINT,TWOINT)

  !################################################################
  !#### Compute energy
  !################################################################

  CALL WFN_ENERGY(NI,NA,NS,D1,D2,ONEINT,TWOINT)

  !################################################################
  !#### Set up the Fock matrix
  !################################################################

  ! compute Fock matrix
  ALLOCATE(FTOT(NMO,NMO))
  DO P=1,NMO
    DO Q=1,NMO
      FTOT(P,Q)=ONEINT(P,Q)
      DO R=1,NI
        FTOT(P,Q)=FTOT(P,Q)+2.0D0*(TWOINT(P,Q,R,R)-0.5D0*TWOINT(P,R,Q,R))
      END DO
      DO R=NI+1,NI+NA
        DO S=NI+1,NI+NA
          FTOT(P,Q)=FTOT(P,Q)+D1(R-NI,S-NI)*(TWOINT(P,Q,R,S)-0.5D0*TWOINT(P,R,Q,S))
        END DO
      END DO
    END DO
  END DO

  CALL FMAT_INIT(F,NI,NA,NS,FTOT,NMO)
  F%DI=0.0D0
  F%DA=0.0D0
  F%DS=0.0D0

  CALL FMAT_PRINT(F)

  !################################################################
  !#### Regular CASPT2
  !################################################################

  ! Solve CASPT2 by solving a linear system of equations
  !WRITE(*,*) 'CASPT2 Ax=b'
  CALL CASPT2_AXB(PSI,F,NMO,ONEINT,TWOINT)

  !################################################################
  !#### Direct CASPT2
  !################################################################

  WRITE(*,*) 'CASPT2 UDL'
  CALL CASPT2_UDL(PSI,F,NAO,NMO,CMO,ONEINT,TWOINT)

  !################################################################
  !#### Full CI
  !################################################################

  !NTOTEL=2*NI+NEL
  !CALL FULLCI(NTOTEL,NMO,MULT,ONEINT,TWOINT,ECORE)

END PROGRAM CASPT2_MINI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
*  Store_Not_Grad
*
*> @brief Mark a vector as non-computable in the gradients file
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Marks a gradient or coupling vector in the gradients file (GRADS)
*> as non-computable. This is useful, for example, to allow SLAPAF
*> to proceed with an approximate coupling vector if it cannot be
*> computed with the current method.
*> For a gradient use \p iNAC, \p jNAC = 0. For a coupling vector use
*> \p iRoot = 0.
*>
*> @param[in] iRoot Root number to which the gradient belongs
*> @param[in] iNAC  First root of a coupling vector
*> @param[in] jNAC  Second root of a coupling vector
************************************************************************
      Subroutine Store_Not_Grad(iRoot,iNAC,jNAC)
      Implicit None
#include "stdalloc.fh"
      Integer :: nGrad,iRoot,iNAC,jNAC
      Integer, Dimension(5) :: TOC
      Integer, Dimension(1) :: Length
      Integer, Dimension(:), Allocatable :: i_grad,i_nac
      Integer :: nRoots,nCoup,LuGrad,iAd,iSt,jSt,idx
      Logical :: Found
      Character(Len=5) :: Filename
*
* Create GRADS file if it does not exist
*
      Call Get_iScalar('Number of roots',nRoots)
      Call Get_iScalar('Unique atoms',nGrad)
      nGrad=3*nGrad
      Filename='GRADS'
      LuGrad=20
      Call f_Inquire(Filename,Found)
      If (.Not.Found) Call Create_Grads(Filename,nRoots,nGrad)
*
* Read the header
*
      Call DaName(LuGrad,Filename)
      iAd=0
      Call iDaFile(LuGrad,2,TOC,Size(TOC),iAd)
      Call iDaFile(LuGrad,2,Length,1,iAd)
      If (Length(1).ne.nRoots) Then
        Call WarningMessage(2,'Bad number of roots in GRADS file')
        Call Abend()
      End If
      Call iDaFile(LuGrad,2,Length,1,iAd)
      If (Length(1).ne.nGrad) Then
        Call WarningMessage(2,'Bad length in GRADS file')
        Call Abend()
      End If
      nCoup=Max(1,nRoots*(nRoots-1)/2)
      Call mma_Allocate(i_grad,nRoots)
      Call mma_Allocate(i_nac,nCoup)
      Call iDaFile(LuGrad,2,i_grad,nRoots,iAd)
      Call iDaFile(LuGrad,2,i_nac,nCoup,iAd)
*
* Write the negative index that marks it as non-computable
*
      If (iRoot.eq.0) Then
        If ((iNAC.ne.0).and.(jNAC.ne.0)) Then
          iSt=Max(iNAC,jNAC)-1
          jSt=Min(iNAC,jNAC)
          idx=iSt*(iSt-1)/2+jSt
          i_nac(idx)=-1
          iAd=TOC(4)
          Call iDaFile(LuGrad,1,i_nac,nCoup,iAd)
        End If
      Else
        idx=iRoot
        i_grad(idx)=-1
        iAd=TOC(3)
        Call iDaFile(LuGrad,1,i_grad,nRoots,iAd)
      End If
*
      Call DaClos(LuGrad)
      Call mma_Deallocate(i_grad)
      Call mma_Deallocate(i_nac)
*
      End Subroutine Store_Not_Grad

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine filemanager (request,lun,rc)
c
c     request - specification of service (Input)
c     1 - open temporary file and give lun (minfiles-maxfiles)
c     2 - rewind file lun
c     3 - close file lun (and delete it if it is temporrary one)
c     4 - open file with given lun (used for fixed files 10-minfiles)
c     5 - close without deleting (for any file)
c     lun     - Logical unit number (Input, Output)
c     rc      - return (error) code (Output)
c
c     This routine is a manager of temporarry disk files, used durring
c     the calculations.
c     if request=1 it finds free lun number if it is possible
c     and open file as unformatted
c     if request=2 it rewinds lun file if it is opened
c     if request=3 if close given lun file if it is opened
c
#include "filemgr.fh"
#include "ccsd1.fh"
c
       integer lun,request,rc
c
c     help variables
c
       integer nhelp,mhelp,ierr,idum(1)
       logical is_error
c
       rc=0
c
c
       if (request.eq.1) then
c
cI    open new file
c
cI.1  look for lowest free lun
c
       do 100 nhelp=minfiles,maxfiles
        mhelp = nhelp
        if (filestatus(nhelp).eq.0) goto 101
 100    continue
c
cI.2  RC=1 : there is not enough Temporarry files allowed
       rc=1
       return
c
cI.3  open file
c
 101    lun=mhelp
c
       if (iokey.eq.1) then
c      Fortran IO
       call molcas_open_ext2(lun,filename(lun),'sequential',
     &  'unformatted',
     &      ierr,.false.,1,'unknown',is_error)
c       open (unit=lun,
c     &       file=filename(lun),
c     &       status='unknown',
c     &       form='unformatted',
c     &       iostat=ierr)
c
       else
c      MOLCAS IO
       call daname (lun,filename(lun))
       daddr(lun)=0
       end if
c
       filestatus(lun)=1
c
c
       else if (request.eq.2) then
c
cII   rewind given file
c
cII.1 test lun, if it is not too large
c
       if ((lun.lt.10).or.(lun.gt.maxfiles)) then
c     RC=2 : lun is out of range
       rc=2
       return
       end if
c
cII.2 test, if lun is opened
c
       if (filestatus(lun).ne.1) then
c     RC=3 : file with logical unit lun is not opened, it can't be rewined
       rc=3
       return
       end if
c
cII.3 rewind lun file
c
       if (iokey.eq.1) then
c      Fortran IO
       rewind (lun)
c
       else
c      MOLCAS IO
       nhelp=0
       idum(1)=nhelp
       call idafile (lun,5,idum,1,daddr(lun))
       end if
c
c
       else if (request.eq.3) then
c
cIII  close given file + scratch if it is Temp
c
cIII.1test lun, if it is not too large
c
       if ((lun.lt.10).or.(lun.gt.maxfiles)) then
c     RC=4 : lun is out of range
       rc=4
       return
       end if
c
cIII.2test, if lun is opened
c
       if (filestatus(lun).ne.1) then
c     RC=5 : file with logical unit lun is not opened,it can't be closed
       rc=5
       return
       end if
c
cIII.3 close ; scratch file, if it was a temporarry one
c
       if (iokey.eq.1) then
c      Fortran IO
         if (lun.ge.minfiles) then
c        close and scratch
         close (lun)
         call molcas_open(lun,filename(lun))
c         open (unit=lun,file=filename(lun))
         write (lun,*) ' File scratched'
         close (lun)
c        call sqname (lun,filename'lun')
c        call sqeras (lun)
         else
c        close only
         close (lun)
         end if
c
       else
c      MOLCAS IO
         if (lun.ge.minfiles) then
c        close and scratch
         call daeras (lun)
         else
c        close only
         call daclos (lun)
         end if
c
       end if
c
       filestatus(lun)=0
c
c
       else if (request.eq.4) then
c
cIV   open file with given lun
c
c
cIV.1 test lun, if it is not too large
c
       if ((lun.lt.10).or.(lun.gt.maxfiles)) then
c     RC=6 : lun is out of range
       rc=6
       return
       end if
c
cIV.2  test if file is not already opened
       if (filestatus(lun).eq.1) then
c     RC=7 : file is already opened
       rc=7
       return
       end if
c
cIV.3 open file
c
       if (iokey.eq.1) then
c      Fortran IO
       call molcas_open_ext2(lun,filename(lun),
     &     'sequential','unformatted',
     &      ierr,.false.,1,'unknown',is_error)
c       open (unit=lun,
c     &       file=filename(lun),
c     &       status='unknown',
c     &       form='unformatted',
c     &       iostat=ierr)
c
       else
c      MOLCAS IO
       call daname (lun,filename(lun))
       daddr(lun)=0
       end if
c
       filestatus(lun)=1
c
       else if (request.eq.5) then
c
cV     close file with given lun (without deleting)
c
cV.1   test lun, if it is not too large
c
       if ((lun.lt.10).or.(lun.gt.maxfiles)) then
c     RC=8 : lun is out of range
       rc=8
       return
       end if
c
cV.2  test, if lun is opened
c
       if (filestatus(lun).ne.1) then
c     RC=9 : file with logical unit lun is not opened,it can't be closed
       rc=9
       return
       end if
c
cV.3  close
c
       if (iokey.eq.1) then
c      Fortran IO
       close (lun)
c
       else
c      MOLCAS IO
       call daclos (lun)
       end if
c
       filestatus(lun)=0
c
c
       else
c     RC=10 : incorect value of request
       rc=10
       return
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine GetTauHlp1 (Tau,T1,dima,dimb,adda,addb,no,nv)
c
c        Make Tau for aGrp.ne.bGrp
c
        implicit none
        integer dima,dimb,adda,addb,no,nv
        real*8 Tau(1:dima,1:dimb,1:no,1:no)
        real*8 T1(1:nv,1:no)
c
c       help variables
        integer i,j,a,b
        real*8 c
c
c
        do j=1,no
          do i=1,no
            do b=1,dimb
              c=t1(addb+b,j)
              do a=1,dima
                Tau(a,b,i,j)=Tau(a,b,i,j)+c*t1(adda+a,i)
              end do
            end do
          end do
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DETCTL_GAS
*
      IMPLICIT REAL*8 (A-H, O-Z)
#include "mxpdim.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "orbinp.fh"
#include "crun.fh"
#include "cstate.fh"
#include "cands.fh"
#include "cicisp.fh"
#include "cprnt.fh"
#include "stinf.fh"
#include "strbas.fh"
#include "csm.fh"
#include "spinfo_lucia.fh"
#include "glbbas.fh"
#include "strinp.fh"
#include "WrkSpc.fh"
#include "lucinp.fh"
#include "rasscf_lucia.fh"

      INTEGER IOCCLS(1),IBASSPC(1)

*. Set variables in cands.fh
      JSYM = IREFSM
      ICSM  = JSYM
      ISSM  = JSYM
      ICSPC = 1
      ISSPC = 1
*. Set NDET
      NDET = INT(XISPSM(JSYM,1))
*. Number of occupation classes
      IATP = 1
      IBTP = 2
      NEL = NELFTP(IATP)+NELFTP(IBTP)
      IWAY = 1
      IBASSPC(1)=0
      CALL OCCLS(1,NOCCLS,IOCCLS,NEL,NGAS,
     &     IGSOCC(1,1),IGSOCC(1,2),0,IBASSPC,NOBPT)
* store the value in a global variable for later use to free the
* KLOCCLS array. I had to rename it because otherwise it conflicts
* with other local use of NOCCLS in other routines that include the
* same header file
      NOCCLS_G=NOCCLS
*. and then the occupation classes
      CALL GETMEM('KLOCCL','ALLO','INTE',KLOCCLS,NGAS*NOCCLS)
      CALL GETMEM('BASSPC','ALLO','INTE',KLBASSPC,NOCCLS)
      IWAY = 2
      CALL OCCLS(2,NOCCLS,iWORK(KLOCCLS),NEL,NGAS,
     &     IGSOCC(1,1),IGSOCC(1,2),1,iWORK(KLBASSPC),NOBPT)
      CALL GETMEM('BASSPC','FREE','INTE',KLBASSPC,NOCCLS)
C     END IF
      IF(NOCSF.EQ.0) THEN
*. Initial information on CSF expansion
C??         WRITE(6,*) ' CSFDIM_GAS will be called '
         CALL CSFDIM_GAS(IWORK(KLOCCLS),NOCCLS,JSYM,IPRCIX)
C            CSFDIM_GAS(IOCCLS,NOCCLS,ISYM,IPRCIX)
*. Prototype dets and csf's and CSF'SD matrices
C            CSDTMT_GAS(IPDTCNF,IPCSCNF,DTOC,IPRCSF)
         CALL CSDTMT_GAS(iWORK(KDFTP),iWORK(KCFTP),WORK(KDTOC),IPRCIX)
         NVAR = NCSF_PER_SYM(JSYM)
      END  IF
*. Allocate memory for diagonalization
c      IF(ISIMSYM.EQ.0) THEN
         LBLOCK = MXSOOB
c      ELSE
c         LBLOCK = MXSOOB_AS
c      END IF
      LBLOCK = MAX(LBLOCK,LCSBLK)
* JESPER : Should reduce I/O
*PAM06      LBLOCK = MAX(XISPSM(IREFSM,1),DBLE(MXSOOB))
      LBLOCK = MAX(INT(XISPSM(IREFSM,1)),MXSOOB)
      IF(PSSIGN.NE.0.0D0) LBLOCK = INT(2.0D0*XISPSM(IREFSM,1))
*
*. Information about block structure- needed by new PICO2 routine.
*. Memory for partitioning of C vector
      IATP = 1
      IBTP = 2
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
      NTTS = MXNTTS
C??      WRITE(6,*) ' DETCTL : NTTS = ', NTTS
      CALL GETMEM('CLBT  ','ALLO','INTE',KLCLBT ,NTTS  )
      CALL GETMEM('CLEBT ','ALLO','INTE',KLCLEBT ,NTTS  )
      CALL GETMEM('CI1BT ','ALLO','INTE',KLCI1BT,NTTS  )
      CALL GETMEM('CIBT  ','ALLO','INTE',KLCIBT ,8*NTTS)
*. Additional info required to construct partitioning
*
*
      CALL GETMEM('CIOIO ','ALLO','INTE',KLCIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('CBLTP ','ALLO','INTE',KLCBLTP,NSMST)
*
      CALL IAIBCM(ICSPC,iWORK(KLCIOIO))
*. option KSVST not active so
      KSVST = 1
      CALL ZBLTP(ISMOST(1,jsym),NSMST,IDC,iWORK(KLCBLTP),iWORK(KSVST))
*
*. Batches  of C vector
      CALL PART_CIV2(IDC,iWORK(KLCBLTP),iWORK(KNSTSO(IATP)),
     &     iWORK(KNSTSO(IBTP)),
     &     NOCTPA,NOCTPB,NSMST,LBLOCK,iWORK(KLCIOIO),
     &     ISMOST(1,jsym),
     &     NBATCH,iWORK(KLCLBT),iWORK(KLCLEBT),
     &     iWORK(KLCI1BT),iWORK(KLCIBT),0,ISIMSYM)
*. Number of BLOCKS
      NBLOCK = IFRMR(IWORK(KLCI1BT),1,NBATCH)
     &     + IFRMR(IWORK(KLCLBT),1,NBATCH) - 1
*. Length of each block
      CALL EXTRROW(iWORK(KLCIBT),8,8,NBLOCK,iWORK(KLCI1BT))
      IF (NEL .GT. 0)
     &   CALL CNFORD_GAS(IWORK(KLOCCLS), NOCCLS, jsym, PSSIGN, IPRCIX,
     &       IWORK(KICONF_OCC(jsym)), IWORK(KICONF_REO(jsym)),
     &       IWORK(KSDREO_I(jsym)),
     &       IWORK(KLCIBT), NBLOCK)
*
      CALL GETMEM('CLBT  ','FREE','INTE',KLCLBT ,NTTS  )
      CALL GETMEM('CLEBT ','FREE','INTE',KLCLEBT ,NTTS  )
      CALL GETMEM('CI1BT ','FREE','INTE',KLCI1BT,NTTS  )
      CALL GETMEM('CIBT  ','FREE','INTE',KLCIBT ,8*NTTS)
*
      IDUM = 0
*. If PICO2/SBLOCK are used, three blocks are used in PICO2, so
*...
*. Sblock is used in general nowadays so,
*. Largest block of strings in zero order space
      MXSTBL0 = MXNSTR
*. type of alpha and beta strings
      IATP = 1
      IBTP = 2
*. alpha and beta strings with an electron removed
      IATPM1 = 3
      IBTPM1 = 4
*. alpha and beta strings with two electrons removed
      IATPM2 = 5
      IBTPM2 = 6
*
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
*. Largest number of strings of given symmetry and type
      MAXA = 0
      IF(NAEL.GE.1) THEN
         MAXA1 = IMNMX(IWORK(KNSTSO(IATPM1)),NSMST*NOCTYP(IATPM1),2)
         MAXA = MAX(MAXA,MAXA1)
      END IF
      IF(NAEL.GE.2) THEN
         MAXA1 = IMNMX(IWORK(KNSTSO(IATPM2)),NSMST*NOCTYP(IATPM2),2)
         MAXA = MAX(MAXA,MAXA1)
      END IF
      MAXB = 0
      IF(NBEL.GE.1) THEN
         MAXB1 = IMNMX(IWORK(KNSTSO(IBTPM1)),NSMST*NOCTYP(IBTPM1),2)
         MAXB = MAX(MAXB,MAXB1)
      END IF
      IF(NBEL.GE.2) THEN
         MAXB1 = IMNMX(IWORK(KNSTSO(IBTPM2)),NSMST*NOCTYP(IBTPM2),2)
         MAXB = MAX(MAXB,MAXB1)
      END IF
*
      MXSTBL = MAX(MAXA,MAXB,MXSTBL0)
*
      IF(IPRCIX.GE.2 ) WRITE(6,*)
     &' Largest block of strings with given symmetry and type',MXSTBL
*. Largest number of resolution strings and spectator strings
*  that can be treated simultaneously
      MAXI = MIN(MXINKA,MXSTBL)
      MAXK = MIN(MXINKA,MXSTBL)
*.scratch space for projected matrices and a CI block
*
*. Scratch space for CJKAIB resolution matrices
*. Size of C(Ka,Jb,j),C(Ka,KB,ij)  resolution matrices
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
      CALL MXRESCPH(iWORK(KLCIOIO),IOCTPA,IOCTPB,NOCTPA,NOCTPB,
     &        NSMST,NSTFSMSPGP,MXPNSMST,
     &        NSMOB,MXPNGAS,NGAS,NOBPTS,IPRCIX,MAXK,
     &        NELFSPGP,
     &        MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL,MXADKBLK,
     &        IPHGAS,NHLFSPGP,MNHL,IADVICE,MXCJ_ALLSYM,
     &        MXADKBLK_AS,MX_NSPII)
      IF(IPRCIX.GE.2) THEN
         WRITE(6,*) 'DETCTL : MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL',
     &           MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL
         WRITE(6,*) ' MXADKBLK ,MXADKBLK_AS', MXADKBLK, MXADKBLK_AS
      END IF
c      IF(ISIMSYM.EQ.1) THEN
c         MXCJ = MAX(MXCJ_ALLSYM,MX_NSPII)
c         MXADKBLK_AS = MXADKBLK
c      END IF
*. Using hardwired routines, MXCIJAB also used
      LSCR2 = MAX(MXCJ,MXCIJA,MXCIJB,MXCIJAB,MX_NSPII)
      IF(IPRCIX.GE.2)
     &     WRITE(6,*) ' Space for two resolution matrices ',2*LSCR2
      LSCR12 = MAX(LBLOCK,2*LSCR2)
*
      KVEC3_LENGTH = MAX(LSCR12,2*LBLOCK)
*
* Calculate how much memory the sigma routines needs.
*
* Memory needed in Sigma_Master
      MEMORY_NEEDED_LUCIA = KVEC3_LENGTH
* Memory needed in MV7
      MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA
     &                    + 2*1 + NOCTPA*NOCTPB + NSMST + 11*MXNTTS
c      IF (IDC .EQ. 3 .OR. IDC .EQ. 4) THEN
c         MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA + NSMST
c      END IF
* Memory needed in SBLOCK
*Largest active orbital block belonging to given type and symmetry
      MXTSOB = 0
      DO IOBTP = 1, NGAS
      DO IOBSM = 1, NSMOB
       MXTSOB = MAX(MXTSOB,NOBPTS(IOBTP,IOBSM))
      END DO
      END DO
      INTSCR = MAX(MXTSOB**4,NTOOB**2)
*.vectors able to hold strings of given sym and type
      MAXIK = MAX(MAXI,MAXK)
      LSCR3 = MAX(MXADKBLK,MAXIK*MXTSOB*MXTSOB,MXNSTR)
*. Space for four blocks of string occupations and arrays of
*. reordering arrays
*. Also used to hold an NORB*NORB matrix
      LZSCR = (MAX(NAEL,NBEL)+3)*(NOCOB+1) + 2 * NOCOB + NOCOB*NOCOB
      LZ    = (MAX(NAEL,NBEL)+2) * NOCOB
      MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA
     &                    + NOCTPA**2 + NOCTPB**2 + 2*NSMST**2
     &                    + 2*INTSCR + 3*NOCTPA*NOCTPB + NSMST
     &                    + 8*LSCR3 + 12*NTTS + MAX_STR_OC_BLK
     &                    + 2*MAX_STR_SPGP + 2*LZ + LZSCR
c      IF (IDC .EQ. 3 .OR. IDC .EQ. 4) THEN
c         MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA + NSMST
c      END IF
c      IF(ISIMSYM.EQ.0) THEN
         MEMORY_NEEDED_LUCIA = MEMORY_NEEDED_LUCIA + 4*MAX_STR_SPGP
c      END IF
*
      KDTOC_POINTER  = KDTOC
      KSDREO_POINTER = KSDREO_I(jsym)
      CALL LUCIA2MOLCAS(kdftp,kcftp,kdtoc,
     &     iwork(kiconf_occ(jsym)),iwork(KSDREO_I(jsym)),
     &     ndet, ncsf_per_sym, nsd_per_sym, nconf_per_sym, mxpcsm,
     &     mxporb, nconf_per_open, npdtcnf, npcscnf, mults,
     &     iwork(knstso(iatp)), iwork(knstso(ibtp)), KICTS_POINTER,
     &     nCSF_HEXS)

      CALL GETMEM('CIOIO ','FREE','INTE',KLCIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('CBLTP ','FREE','INTE',KLCBLTP,NSMST)

      RETURN
      END
*
      SUBROUTINE DETCTL_FREE
      IMPLICIT REAL*8 (A-H, O-Z)
#include "mxpdim.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "orbinp.fh"
#include "crun.fh"
#include "cstate.fh"
#include "cands.fh"
#include "cicisp.fh"
#include "cprnt.fh"
#include "stinf.fh"
#include "strbas.fh"
#include "csm.fh"
#include "spinfo_lucia.fh"
#include "glbbas.fh"
#include "strinp.fh"
#include "WrkSpc.fh"
#include "lucinp.fh"
#include "rasscf_lucia.fh"

      CALL GETMEM('KLOCCL','FREE','INTE',KLOCCLS,NGAS*NOCCLS_G)

      JSYM = IREFSM
      CALL CSFDIM_FREE(JSYM)

      CALL LUCIA2MOLCAS_FREE

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefParo2v4(NaGrp,NbeGrp,NaSGrp,NbeSgrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
! This routine does:
! define parameters using NaGrp,NbeGrp,NaSGrp,NbeSgrp
!
! I/O parameter description:
! NaGrp    - # of groups in a set (I)
! NbeGrp   - # of groups in be set (I)
! NaSGrp   - # of subgroups in each (a)' group (I)
! NbeSGrp  - # of subgroups in each (be)' group (I)
! mdGrpa   - # maximal dimension od (a)' group (O)
! mdGrpbe  - # maximal dimension od (be)' group (O)
! mdSGrpa  - # maximal dimension od (a)" subgroup (O)
! mdSGrpbe - # maximal dimension od (be)" subgroup (O)

use chcc_global, only: DimGrpa, DimGrpbe, DimSGrpa, DimSGrpbe, GrpaLow, GrpaUp, GrpbeLow, GrpbeUp, L2Name, maxGrp, maxSGrp, nv, &
                       Tmp3Name
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NaGrp, NbeGrp, NaSGrp, NbeSgrp
integer(kind=iwp), intent(out) :: mdGrpa, mdGrpbe, mdSGrpa, mdSGrpbe
integer(kind=iwp) :: i, ij, j, LowGrpa(maxGrp), LowGrpbe(maxGrp), LowSGrpa(maxSGrp), LowSGrpbe(maxSGrp), UpGrpa(maxGrp), &
                     UpGrpbe(maxGrp), UpSGrpa(maxSGrp), UpSGrpbe(maxSGrp)
real(kind=wp) :: rdim

!1 define parameters of Groups of a(b) set

rdim = real(nv,kind=wp)/real(NaGrp,kind=wp)

Grpalow(1) = 1
Grpaup(1) = NaSGrp

do i=1,NaGrp

  if (i == 1) then
    UpGrpa(i) = int(rdim*i)
    LowGrpa(i) = 1
  else if (i == NaGrp) then
    UpGrpa(i) = nv
    LowGrpa(i) = UpGrpa(i-1)+1
  else
    UpGrpa(i) = int(rdim*i)
    LowGrpa(i) = UpGrpa(i-1)+1
  end if

  DimGrpa(i) = (UpGrpa(i)-LowGrpa(i))+1

  if (i > 1) then
    Grpalow(i) = Grpalow(i-1)+NaSGrp
    Grpaup(i) = Grpaup(i-1)+NaSGrp
  end if

end do

!2 define parameters of Groups of be(ga) set

rdim = real(nv,kind=wp)/real(NbeGrp,kind=wp)

Grpbelow(1) = 1
Grpbeup(1) = NbeSGrp

do i=1,NbeGrp

  if (i == 1) then
    UpGrpbe(i) = int(rdim*i)
    LowGrpbe(i) = 1
  else if (i == NbeGrp) then
    UpGrpbe(i) = nv
    LowGrpbe(i) = UpGrpbe(i-1)+1
  else
    UpGrpbe(i) = int(rdim*i)
    LowGrpbe(i) = UpGrpbe(i-1)+1
  end if

  DimGrpbe(i) = (UpGrpbe(i)-LowGrpbe(i))+1

  if (i > 1) then
    Grpbelow(i) = Grpbelow(i-1)+NbeSGrp
    Grpbeup(i) = Grpbeup(i-1)+NbeSGrp
  end if

end do

!3 define parameters of SubGroups of a(b) set

ij = 0
do j=1,NaGrp

  rdim = real(DimGrpa(j),kind=wp)/real(NaSGrp,kind=wp)

  do i=1,NaSGrp
    ij = ij+1

    if (i == 1) then
      UpSGrpa(ij) = (LowGrpa(j)-1)+int(rdim*i)
      LowSGrpa(ij) = LowGrpa(j)
    else if (i == NaSGrp) then
      UpSGrpa(ij) = UpGrpa(j)
      LowSGrpa(ij) = UpSGrpa(ij-1)+1
    else
      UpSGrpa(ij) = (LowGrpa(j)-1)+int(rdim*i)
      LowSGrpa(ij) = UpSGrpa(ij-1)+1
    end if

    DimSGrpa(ij) = (UpSGrpa(ij)-LowSGrpa(ij))+1

  end do
end do

!4 define parameters of SubGroups of be(ga) set

ij = 0
do j=1,NbeGrp

  rdim = real(DimGrpbe(j),kind=wp)/real(NbeSGrp,kind=wp)

  do i=1,NbeSGrp
    ij = ij+1

    if (i == 1) then
      UpSGrpbe(ij) = (LowGrpbe(j)-1)+int(rdim*i)
      LowSGrpbe(ij) = LowGrpbe(j)
    else if (i == NbeSGrp) then
      UpSGrpbe(ij) = UpGrpbe(j)
      LowSGrpbe(ij) = UpSGrpbe(ij-1)+1
    else
      UpSGrpbe(ij) = (LowGrpbe(j)-1)+int(rdim*i)
      LowSGrpbe(ij) = UpSGrpbe(ij-1)+1
    end if

    DimSGrpbe(ij) = (UpSGrpbe(ij)-LowSGrpbe(ij))+1

  end do
end do

!5 find maximal dimensions mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe

mdGrpa = DimGrpa(1)
do i=1,NaGrp
  if (DimGrpa(i) > mdGrpa) mdGrpa = DimGrpa(i)
end do

mdGrpbe = DimGrpbe(1)
do i=1,NbeGrp
  if (DimGrpbe(i) > mdGrpbe) mdGrpbe = DimGrpbe(i)
end do

mdSGrpa = DimSGrpa(1)
do ij=1,NaGrp*NaSGrp
  if (DimSGrpa(ij) > mdSGrpa) mdSGrpa = DimSGrpa(ij)
end do

mdSGrpbe = DimSGrpbe(1)
do ij=1,NbeGrp*NbeSGrp
  if (DimSGrpbe(ij) > mdSGrpbe) mdSGrpbe = DimSGrpbe(ij)
end do

!6 def L2Names

do i=1,NaGrp
  do j=1,NbeGrp
    call DefParo3v3Hlp1(i,j,'L2',L2Name(i,j))
  end do
end do

!7 def Tmp3Names

do i=1,MaxSGrp
  do j=1,MaxSGrp
    call DefParo3v3Hlp1(i,j,'X3',Tmp3Name(i,j))
  end do
end do

return

end subroutine DefParo2v4

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Jeppe Olsen                                      *
!               1989, Markus P. Fuelscher                              *
!               Giovanni Li Manni                                      *
!***********************************************************************

subroutine ipcsfsplit(PHPCSF,IPCSF,IPCNF,MXPDIM,MXSPLI,DTOC,IPRODT,ICONF,IREFSM,ONEBOD,ECORE,NACTOB,SCR,NCONF,NEL,NAEL,NBEL,DIAG, &
                      TUVX,NTEST,ExFac,IREOTS)
!************* Author : GLMJ ****************
!
! Obtain primary subspace and obtain
! explicit representation of hamilton matrix in subspace
!
! ARGUMENTS :
! ===========
! IPCSF  : CSF's defining subspace (output)
! IPCNF  : Configurations defining subspace (output )
! MXPDIM : Largest allowed dimension of subspace (input)
! DTOC   : Transformation matrix between CSF's and DET's (input)
! IPRODT : Prototype determinants (input)
! ICONF  : List of configurations  (input)
! IREFSM : symmetry of considered CI space (input)
! Onebod : one body hamilton matrix in rectangular form (input)
! ECORE  : Core energy (input)
! NACTOB : Number of active orbitals (input)
! SCR    : Scratch array of length ????
! NCONF  : Number of configurations of symmetry IREFSM
! TUVX   : Two-electron integrals (MO space)
! DIAG   : Hamiltonian diagonal over CSF's (input)
!
! IREOTS : Type => symmetry reordering array
!
! Jeppe Olsen, Summer of '89
! adapted to DETRAS by M.P. Fuelscher, October 1989

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Constants, only: One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: MXPDIM, MXSPLI, IPRODT(*), ICONF(*), IREFSM, NACTOB, NCONF, NEL, NAEL, NBEL, IREOTS(NACTOB)
real(kind=wp), intent(out) :: PHPCSF(MXPDIM)
integer(kind=iwp), intent(out) :: IPCSF(MXPDIM), IPCNF(NCONF)
real(kind=wp), intent(in) :: DTOC(*), ONEBOD(NACTOB,NACTOB), ECORE, DIAG(MXPDIM), TUVX(*), ExFac
real(kind=wp), intent(_OUT_) :: SCR(*)
integer(kind=iwp), intent(inout) :: NTEST
integer(kind=iwp) :: ICSFMN, IICNF, IICSF, IILACT, IILB, ILRI, ILTYP, IMIN, KLCONF, KLFREE, KLPHPS, MXCSFC, NCSFL, NCSFMN, NIRREP, &
                     NJCNF, NPCNF, NPCSF
real(kind=wp) :: Acc, XMAX, XMIN
real(kind=wp), external :: FNDMNX
#include "spinfo.fh"
#include "splitcas.fh"

#include "macros.fh"
unused_var(MXPDIM)

call IPCSFSPLIT_INTERNAL(SCR)

! This is to allow type punning without an explicit interface
contains

subroutine IPCSFSPLIT_INTERNAL(SCR)

  real(kind=wp), target :: SCR(*)
  integer(kind=iwp), pointer :: iSCR(:)
  integer(kind=iwp) :: ICNF, ICNL, IIL, ITYP

  ! Assumed machine accuracy (give and take)

  Acc = 1.0e-13_wp
  ! construct the diagonal of the Hamilton matrix in CNF basis
  ICSFMN = 0
  IICNF = 1
  IICSF = 1
  do ITYP=1,NTYP
    NJCNF = NCNFTP(ITYP,IREFSM)
    NIRREP = NCSFTP(ITYP)
    do ICNF=1,NJCNF
      SCR(IICNF) = DIAG(IICSF)
      IICNF = IICNF+1
      IICSF = IICSF+NIRREP
    end do
  end do
  if (NTEST >= 30) call RecPrt('SCR',' ',SCR,1,IICNF-1)
  !call RecPrt('DIAG',' ',DIAG,1,IICSF-1)
  !call RecPrt('SCR',' ',SCR,1,IICNF-1)

  ! find the elements of the subspace
  ! (MXPDIM elements smallest in energy)

  XMAX = FNDMNX(SCR,NCONF,2)
  NPCSF = 0
  NPCNF = 0
  !IFINIT = 0
  do
    XMIN = XMAX+One
    IMIN = 0
    IICNF = 1
    IICSF = 1
    do ITYP=1,NTYP
      NJCNF = NCNFTP(ITYP,IREFSM)
      NIRREP = NCSFTP(ITYP)
      do ICNF=1,NJCNF
        if (SCR(IICNF)+Acc < XMIN) then
          XMIN = SCR(IICNF)
          IMIN = IICNF
          ICSFMN = IICSF
          NCSFMN = NIRREP
        end if
        IICNF = IICNF+1
        IICSF = IICSF+NIRREP
      end do
    end do
    !if ((NPCSF+NCSFMN) <= MXPDIM) then
    ! add new configuration
    NPCNF = NPCNF+1
    IPCNF(NPCNF) = IMIN
    call ISTVC2(IPCSF(NPCSF+1),ICSFMN-1,1,NCSFMN)
    if ((NPCSF+NCSFMN) <= MXSPLI) then
      iDimBlockA = NPCSF+NCSFMN
      iDimBlockACNF = NPCNF
    end if
    NPCSF = NPCSF+NCSFMN
    SCR(IMIN) = XMAX+One
    !else
    !  ! No space for this configuration, remove previous
    !  ! configurations with the same diagonal value
    !  IFINIT = 1
    !  IICNF = NPCNF+1
    !  do
    !    IICNF = IICNF-1
    !    DIAVAL = SCR(IPCNF(IICNF))
    !    if (abs(DIAVAL-XMIN) > 1.0e-10_wp) exit
    !    NPCNF = NPCNF-1
    !    call GETCNF_LUCIA(SCR(NCONF+1),ITYP,IPCNF(IICNF),ICONF,IREFSM,NEL)
    !    NPCSF = NPCSF-NCSFTP(ITYP)
    !  end do
    !end if
    !if ((IFINIT /= 0) .or. (NPCNF > NCONF)) exit
    if (NPCNF >= NCONF) exit
  end do

  if (NTEST >= 30) then
    write(u6,*) ' Output from ipCSFSplit'
    write(u6,*) ' =================='
    write(u6,*) ' Number of Configurations in primary subspace ',NPCNF
    write(u6,*) ' Number of CSFs in primary subspace ',NPCSF
    write(u6,*) ' Configurations included :'
    call IWRTMA(IPCNF,1,NPCNF,1,NPCNF)
    write(u6,*) ' CSFs included :'
    call IWRTMA(IPCSF,1,NPCSF,1,NPCSF)
  end if

 ! construct the diagonal array out of the Hamiltonian matrix

  MXCSFC = 0
  do ITYP=1,NTYP
    MXCSFC = max(MXCSFC,NCSFTP(ITYP))
  end do

  KLFREE = 1
  KLCONF = KLFREE
  KLFREE = KLFREE+NEL
  KLFREE = KLFREE+NEL
  KLPHPS = KLFREE
  KLFREE = KLFREE+MXCSFC*MXCSFC
  !KLSCRS = KLFREE
  !KLFREE = KLFREE+MXCSFC

  IILB = 1
  do ICNL=1,NCONF
    !write(u6,*) 'IILB',IILB
    call c_f_pointer(c_loc(SCR(KLCONF)),iSCR,[1])
    call GETCNF_LUCIA(iSCR,ILTYP,IPCNF(ICNL),ICONF,IREFSM,NEL)
    nullify(iSCR)
    NCSFL = NCSFTP(ILTYP)
    !write(u6,*) 'NCSFL = ',NCSFL
    call c_f_pointer(c_loc(SCR(KLCONF)),iSCR,[1])
    call CNHCN(iSCR,ILTYP,iSCR,ILTYP,SCR(KLPHPS),SCR(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,NTEST,ExFac,IREOTS)
    nullify(iSCR)
    do IIL=1,NCSFL
      IILACT = IILB-1+IIL
      ILRI = IIL*IIL
      PHPCSF(IILACT) = SCR(KLPHPS-1+ILRI)
      !write(u6,*) 'IILACT, ILRI = ',IILACT,ILRI
      !write(u6,*) 'PHPCSF(IILACT)',PHPCSF(IILACT)
      !SCR(KLSCRS-1+IIL) = SCR(KLPHPS-1+ILRI)
    end do
    !XMAX = -FNDMNX(SCR(KLSCRS),NCSFL,2)
    !PHPCNF(ICNL) = XMAX
    !write(u6,*) 'PHPCNF(IILACT)',PHPCNF(ICNL)
    IILB = IILB+NCSFL
  end do

  return

end subroutine IPCSFSPLIT_INTERNAL

end subroutine ipcsfsplit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2014,2006, Markus Reiher                               *
************************************************************************
      character*(2) function dkh_int2char2 (number)
c
c*************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 07.07.2006  (MR, ETH Zurich, name changed)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*************************************************************************
c
      implicit none
c
      integer number,idum(2),j
      character*(2) string
c
c   Translate integer number --> character string of length 2
c
      idum(1)=INT(number/10)
      idum(2)=INT(number-idum(1)*10)
c
      do 100 j=1,2
        if (idum(j).eq.0)  string(j:j)='0'
        if (idum(j).eq.1)  string(j:j)='1'
        if (idum(j).eq.2)  string(j:j)='2'
        if (idum(j).eq.3)  string(j:j)='3'
        if (idum(j).eq.4)  string(j:j)='4'
        if (idum(j).eq.5)  string(j:j)='5'
        if (idum(j).eq.6)  string(j:j)='6'
        if (idum(j).eq.7)  string(j:j)='7'
        if (idum(j).eq.8)  string(j:j)='8'
        if (idum(j).eq.9)  string(j:j)='9'
 100  continue
c
      dkh_int2char2(1:2)=string(1:2)
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_A(AA)
! check AA(ij,u,v)

use Index_Functions, only: nTri_Elem
use chcc_global, only: Ac, no, nv, Q0, Q1, Q21, T1c, T2c
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: AA(nTri_Elem(no),no,no)
integer(kind=iwp) :: a, b, bad, i, ij, j, u, v
real(kind=wp) :: s

call mma_allocate(Ac,no,no,no,no,label='Ac')

bad = 0

ij = 0
do i=1,no
  do j=1,i
    ij = ij+1

    do u=1,no
      do v=1,no

        s = Q0(u,i,v,j)

        do a=1,nv
          s = s+Q1(a,j,u,i)*T1c(a,v)
        end do

        do a=1,nv
          s = s+Q1(a,i,v,j)*T1c(a,u)
        end do

        do a=1,nv
          do b=1,nv
            s = s+Q21(a,i,b,j)*(T2c(a,b,u,v)+T1c(a,u)*T1c(b,v))
          end do
        end do

        Ac(i,j,u,v) = s

        !write(u6,99) i,j,u,v,AA(ij,u,v),s,AA(ij,u,v)-s
        !99 format(4(i2,1x),3(f15.10,1x))
        if (abs(AA(ij,u,v)-s) > 1.0e-10_wp) bad = bad+1

      end do
    end do
  end do
end do

do i=2,no
  Ac(1:i-1,i,:,:) = Ac(i,1:i-1,:,:)
end do

write(u6,*) ' A   Chck :',bad

return

end subroutine Chck_A

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine genprexyz15a(icheckxy,icheckz,interxyz)
      implicit real*8(a-h,o-z)
      dimension icheckxy(*),icheckz(*),interxyz(16,*)
#include "para.fh"
#include "Molcas.fh"
cbs   the following M values are the ones from the cartesian
cbs   linear combinations. interxyz gives the sign sequence
cbs   for interacting spherical functions, starting with
cbs   type 1 (++++) and ending with type 16 (-++-)
      ilauf=1
      do M4=0,Lmax
      do M3=0,Lmax
      do M2=0,Lmax
      do M1=0,Lmax
      irun=0
      if (icheckxy(ilauf)+icheckz(ilauf).gt.0) then
          if (iabs(m1+m2-m3-m4).le.1) then
          irun=irun+1
          interxyz(irun,ilauf)=1          ! + + + +
                  if (m1.gt.0.and.m2.gt.0.and.
     *            m3.gt.0.and.m4.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=2  ! - - - -
                  endif
          endif
          if (iabs(m1+m2-m3+m4).le.1) then
                  if (m4.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=3  ! + + + -
                  endif
                  if (m1.gt.0.and.m2.gt.0.and.
     *            m3.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=4  ! - - - +
                  endif
          endif
          if (iabs(m1+m2+m3-m4).le.1) then
                  if (m3.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=5  ! + + - +
                  endif
                  if (m1.gt.0.and.m2.gt.0.and.
     *            m4.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=6  ! - - + -
                  endif
          endif
          if (iabs(m1-m2-m3-m4).le.1) then
                  if (m2.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=7  ! + - + +
                  endif
                  if (m1.gt.0.and.m3.gt.0.and.
     *            m4.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=8  ! - + - -
                  endif
          endif
          if (iabs(-m1+m2-m3-m4).le.1) then
                  if (m1.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=9  ! - + + +
                  endif
                  if (m2.gt.0.and.m3.gt.0.and.
     *            m4.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=10 ! + - - -
                  endif
          endif
          if (iabs(m1+m2+m3+m4).le.1) then
                  if (m3.gt.0.and.m4.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=11 ! + + - -
                  endif
                  if (m1.gt.0.and.m2.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=12 ! - - + +
                  endif
          endif
          if (iabs(m1-m2-m3+m4).le.1) then
                  if (m2.gt.0.and.m4.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=13 ! + - + -
                  endif
                  if (m1.gt.0.and.m3.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=14 ! - + - +
                  endif
          endif
          if (iabs(m1-m2+m3-m4).le.1) then
                  if (m2.gt.0.and.m3.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=15 ! + - - +
                  endif
                  if (m1.gt.0.and.m4.gt.0) then
                  irun=irun+1
                  interxyz(irun,ilauf)=16 ! - + + -
                  endif
          endif
      endif
      ilauf=ilauf+1
      enddo
      enddo
      enddo
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
! MOLCAS wrapper for Celestino Angeli's NEVPT2 code
! rdinput reads input from the MOLCAS input file
!
!*******************

subroutine rdinput(refwfnfile)

! use global variables directly from the NEVPT2 program
use nevpt2_cfg, only: igelo, MultGroup, no_pc, nr_frozen_orb, nr_states, rdm_distributed, rdm_path, rdm_read, skip_effective_ham, &
                      skip_koopro_molcas
use text_file, only: extend_line, next_non_comment
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(out) :: refwfnfile
integer(kind=iwp) :: LuSpool, iError, i, isplit
character(len=180) :: Line, key
character(len=9001) :: frozen_str
character(len=:), allocatable :: dLine, Line2
integer(kind=iwp), external :: isFreeUnit
character(len=180), external :: Get_Ln

! Initial values

refwfnfile = 'JOBIPH'

LuSpool = isFreeUnit(18)
call SpoolInp(LuSpool)

rewind(LuSpool)
call RdNLst(LuSpool,'NEVPT2')

!> set it to one in order to make sure NEVPT2 runs also with just the basic input
!> &NEVPT2 &END
nr_states = 1

do
  key = Get_Ln(LuSpool)
  Line = adjustl(key)
  if (Line(1:1) == '*') cycle
  if (Line == ' ') cycle
  call UpCase(Line)
  select case (Line(1:4))
    case ('NOPC')
      !========= NOPC =============
      no_pc = .true.

    case ('STAT')
      !========= STAT =============
      ! read the # of states
      key = Get_Ln(LuSpool)
      read(key,*,iostat=iError) nr_states
      if (iError > 0) call error(0)
      ! using standard allocate and deallocate because MultGroup%State
      ! is deallocated somewhere in the external library
      if (allocated(MultGroup%State)) deallocate(MultGroup%State)
      allocate(MultGroup%State(nr_states))
      do i=1,nr_states
        MultGroup%State(i) = i
      end do

    case ('FROZ')
      !========= FROZ =============
      ! Read in the information about frozen orbitals
      ! It can be provided either with a number of frozen orbitals
      ! or with a list -- in the 2nd case one needs to provide a keyword
      ! 'Select' immediately after 'Frozen' and provide a number of frozen
      ! orbitals followed by a list of indexes of the frozen orbitals.
      ! E.g. either
      ! Frozen=20 (orbitals from 1-20 are frozen) or
      ! Frozen
      ! Select
      ! 3 1 2 4 -- 3 orbitals 1 2 4 are frozen
      key = Get_Ln(LuSpool)
      call UpCase(key)
      key = adjustl(key)
      ! If the first line after the keyword contains 'SELECT'
      if (key(1:4) == 'SELE') then
        ! read in the number of frozen orbitals, then the list
        frozen_str = Get_Ln(LuSpool)
        read(frozen_str,*,iostat=iError) nr_frozen_orb
        if (iError > 0) call error(0)
        if (nr_frozen_orb <= 0) then
          call WarningMessage(2,'Nr of frozen orbitals for selection must be > 0!')
          call Quit_OnUserError()
        end if
        frozen_str = frozen_str(scan(frozen_str,' '):)
        ! using standard allocate because igelo
        ! is deallocated somewhere in the external library
        allocate(igelo(nr_frozen_orb))
        igelo(:) = 0
        iError = -1
        do while (iError < 0)
          read(frozen_str,*,iostat=iError) (igelo(i),i=1,nr_frozen_orb)
          if (iError > 0) call error(0)
          if (iError < 0) then
            frozen_str = trim(frozen_str)//trim(Get_Ln(LuSpool))
          end if
        end do
      else ! read only the number of frozen orbitals and fill the frozen
        ! indexes consecutively from 1 to nr_frozen_orb
        read(key,*,iostat=iError) nr_frozen_orb
        if (iError > 0) call error(0)
        if (nr_frozen_orb < 0) then
          call WarningMessage(2,'Nr of frozen orbitals must be >= 0!')
          call Quit_OnUserError()
        else
          if (nr_frozen_orb == 0) then
            write(u6,*) 'Number of frozen orbitals has been set to 0.'
            ! Set it to -1 to signal that frozen orbs have been set forcibly to 0 here
            ! It will be detected in pt2init and reset back to 0
            nr_frozen_orb = -1
          else
            ! using standard allocate because igelo
            ! is deallocated somewhere in the external library
            allocate(igelo(nr_frozen_orb))
            do i=1,nr_frozen_orb
              igelo(i) = i
            end do
          end if
        end if
      end if

    case ('SKIP')
      !========= SKIP =============
      ! Skip the calculation of Koopmans' matrices if requested by the
      ! SKIP(Koop) keyword
      skip_koopro_molcas = .true.

    case ('NOMS')
      !========= NOMS =============
      ! Skip the calculation of an effective Hamiltonian (suitable for multistate state-specific calculations)
      skip_effective_ham = .true.

    case ('MULT')
      !========= MULT =============
      ! multi-state QD-NEVPT2 calculation requested with the states given below
      if (.not. next_non_comment(LuSpool,Line2)) call error(1)
      read(Line2,*) key
      call upcase(key)
      if (trim(key) == 'ALL') then
        nr_states = 0
      else
        read(Line2,*,iostat=iError) nr_states
        if (iError /= 0) call error(0)
        if (nr_states <= 0) then
          write(u6,*) ' number of MULT states must be > 0, quitting!'
          call Quit_OnUserError()
        end if
      end if
      ! using standard allocate and deallocate because MultGroup%State
      ! is deallocated somewhere in the external library
      if (allocated(MultGroup%State)) deallocate(MultGroup%State)
      allocate(MultGroup%State(nr_states))
      iSplit = scan(Line2,' ')
      call mma_allocate (dLine,len(Line),label='dLine')
      dLine = line2(iSplit:)
      iError = -1
      do while (iError < 0)
        read(dLine,*,iostat=iError) (MultGroup%State(i),i=1,nr_states)
        if (iError > 0) call error(0)
        if (iError < 0) then
          if (.not. next_non_comment(LuSpool,Line2)) call error(1)
          call extend_line(dLine,Line)
        end if
      end do
      call mma_deallocate (dLine)

    case ('FILE')
      !========= FILE =============
      ! Specifiy the name of the reference wfn file for NEVPT2.
      if (.not. next_non_comment(LuSpool,Line2)) call error(1)
      line2(:) = adjustl(line2)
      call fileorb(Line2,refwfnfile)

    case ('RDMR')
      !========= RDMR ============= a.k.a. RDMRead
      ! Skip calculation of 4-RDM and/or transition 3-RDMs at the beginning of the calculation
      ! This is useful only for single-file reading, e.g. when your previous calculation has crashed
      ! and you do not wish to recalculate the full 4-RDM again.
      ! For distributed RDM calculations see option below
      rdm_read = .true.

    case ('DIST')
      !========= DIST ============= a.k.a. DistributedRDM
      ! Skip calculation of RDMs *and* read them from distributed RDM calculation
      ! Specify a path, where the program will look for subdirectories
      ! of the format "A-B-C-D", where A,B,C,D are the first four indices of the 4-RDM to be calculated
      ! Each subdirectory should contain the results of a single calculation in a batch
      rdm_distributed = .true.
      if (.not. next_non_comment(LuSpool,Line2)) call error(1)
      read(Line2,'(A)') key
      rdm_path = trim(key)

    case ('END ')
      exit

    case default
      write(u6,*) 'Unidentified key word  : '
      call FindErrorLine()
      call Quit_OnUserError()

  end select

end do
! END of Input

if (allocated(Line2)) call mma_deallocate(Line2)

!> make sure the array is allocated for the minimal input
!> &NEVPT2 &END
if (.not. allocated(MultGroup%State)) then
  ! using standard allocate because MultGroup%State
  ! is deallocated somewhere in the external library
  allocate(MultGroup%State(1))
  MultGroup%State(:) = 1
end if

contains

subroutine error(code)

  integer(kind=iwp), intent(in) :: code

  if (code == 1) call WarningMessage(2,'Premature end of input file.')
  call WarningMessage(2,'Read error during input preprocessing.')
  call Quit_OnUserError()
  call ABEND()

end subroutine

end subroutine rdinput

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 FUNCTION FindDetR(matrix, n)
c     Function to find the determinant of a square matrix
c
c     Description: The Subroutine is based on two key points:
c
c     1]  A determinant is unaltered when row operations are performed:
c         Hence, using this principle, row operations (column operations
c         would work as well) are used to convert the matrix the matrix
c         into upper triangular form
c     2]  The determinant of a triangular matrix is obtained by finding
c         the product of the diagonal elements
      IMPLICIT NONE

      INTEGER, INTENT (IN) :: N
      REAL (kind=8)        :: matrix(N,N)
      ! local variables:
      REAL (kind=8)        :: m, temp, MINIMAL_REAL
      INTEGER              :: i, j, k, l
      LOGICAL              :: DetExists
      DetExists = .TRUE.
      MINIMAL_REAL = TINY(0.d0)
      l = 1
      temp=0
      ! Convert to upper triangular form
      DO k = 1, N-1
         IF (ABS(matrix(k,k))<MINIMAL_REAL) THEN
            DetExists = .FALSE.
            DO i = k+1, N
               IF (ABS(matrix(i,k))>MINIMAL_REAL) THEN
                  DO j = 1, N
                           temp  =  matrix(i,j)
                     matrix(i,j) =  matrix(k,j)
                     matrix(k,j) =  temp
                  END DO
                  DetExists = .TRUE.
               END IF
            END DO
            IF (DetExists .EQV. .FALSE.) THEN
               FindDetR = 0
               RETURN
            END IF
         END IF
         DO j = k+1, N
            m = matrix(j,k)/matrix(k,k)
            DO i = k+1, N
               matrix(j,i) = matrix(j,i) - m*matrix(k,i)
            END DO
         END DO
      END DO ! k
      ! Evaluate determinant by finding product of diagonal elements
      FindDetR = l
      DO i=1, N
         FindDetR = FindDetR * matrix(i,i)
      END DO
      RETURN
      END FUNCTION FindDetR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine setiaprtot2_cvb(civec,iapr,ixapr,ibpr,ixbpr,npvb,nda,ndb)

use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: npvb, nda, ndb
real(kind=wp), intent(in) :: civec(nda,ndb)
integer(kind=iwp), intent(out) :: iapr(npvb), ixapr(nda+1), ibpr(npvb), ixbpr(ndb+1)
integer(kind=iwp) :: ia, ib, idetvb

idetvb = 0
ixapr(1) = 1
do ia=1,nda
  do ib=1,ndb
    if (civec(ia,ib) == One) then
      idetvb = idetvb+1
      if (idetvb > npvb) then
        write(u6,*) ' Error in setiaprtot!',npvb
        call abend_cvb()
      end if
      iapr(idetvb) = ib
    end if
  end do
  ixapr(ia+1) = idetvb+1
end do

idetvb = 0
ixbpr(1) = 1
do ib=1,ndb
  do ia=1,nda
    if (civec(ia,ib) == One) then
      idetvb = idetvb+1
      if (idetvb > npvb) then
        write(u6,*) ' Error in setiaprtot!',npvb
        call abend_cvb()
      end if
      ibpr(idetvb) = ia
    end if
  end do
  ixbpr(ib+1) = idetvb+1
end do

return

end subroutine setiaprtot2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine PT2_GET(NSIZE,LAB,VEC)

use caspt2_global, only: LUDMAT
use caspt2_module, only: CLab10, iAdr10
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSIZE
character(len=*), intent(in) :: LAB
real(kind=wp), intent(out) :: VEC(NSIZE)
integer(kind=iwp) :: I, IAD, NSZ
character(len=8) :: LAB1

I = 9-len(LAB)
if (I >= 1) then
  LAB1 = ''
  LAB1(I:8) = LAB
else
  LAB1 = LAB(1:8)
end if

! FIND DISK ADDRESS:
do I=1,size(CLAB10)
  if (CLAB10(I) == LAB1) then
    NSZ = min(IADR10(I,2),NSIZE)
    IAD = IADR10(I,1)
    call DDAFILE(LUDMAT,2,VEC,NSZ,IAD)
#   ifdef _DEBUGPRINT_
    write(u6,*) LAB1,' SUCCESSFULLY READ FROM LUDMAT.'
    write(u6,*) '         SIZE:',NSZ,' *8 BYTES'
    write(u6,*) ' DISK ADDRESS:',IADR10(I,1)
    write(u6,'(10F12.8)') VEC(1:min(10,NSZ))
#   endif
    return
  end if
end do
write(u6,*) ' LABEL ',LAB1,' NOT FOUND ON LUDMAT.'
call ABEND()

end subroutine PT2_GET

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine sets the name for the runfile.                          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund university, Sweden                                     *
* Written: August 2003                                                 *
*                                                                      *
************************************************************************
      Subroutine NameRun(Name)
#include "runinfo.fh"
      Character*(*) Name
*     Integer       iRc
*     Integer       iOpt

      If(Name.eq.'#Pop') Then
         RunName=RnNmStk(1)
         RnNmStk(1)=RnNmStk(2)
         RnNmStk(2)=RnNmStk(3)
         RnNmStk(3)=RnNmStk(4)
      Else
         RnNmStk(4)=RnNmStk(3)
         RnNmStk(3)=RnNmStk(2)
         RnNmStk(2)=RnNmStk(1)
         RnNmStk(1)=RunName
         RunName=Name
      End If

      Call ClrRunCache()
*
* Do not create the run file when naming it, patch 6.7.263
*
*     iRc=0
*     iOpt=1
*     Call MkRun(iRc,iOpt)

      Return
      End

      Subroutine ClrRunCache

      Call ClrRunCacheDS()
      Call ClrRunCacheIS()
      Return

      End

      Subroutine ClrRunCacheDS()
      Implicit None
#include "pg_ds_info.fh"

      Integer  i

      do i=1,num_DS_init
         i_DS_inmem(i)=0.d0
         DS_init(i)=0
         iLbl_DS_inmem(i)=' '
      end do
      num_DS_init=0

      End

      Subroutine ClrRunCacheIS()
      Implicit None
#include "pg_is_info.fh"

      Integer  i

      do i=1,num_IS_init
         i_IS_inmem(i)=0
         IS_init(i)=0
         iLbl_IS_inmem(i)=' '
      end do
      num_IS_init=0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003-2010, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine CHO_DRV_Inner(IRETURN)
!
! Thomas Bondo Pedersen, 2003-2010.
!
! Purpose: driver for the Cholesky decomposition of two-electron
!          integrals. On entry, the integral program must have been
!          initialized and the relevant index info (#irreps, basis
!          functions, shells, etc.) must have been set up.
!
! NOTE: this is the "old" version prior to the parallel two-step
!       algorithm. It is still used for the "old" algorithms.
!
! Return codes, IRETURN:
!
!    0 -- successful execution
!    1 -- decomposition failed
!    2 -- memory has been out of bounds

use Para_Info, only: Is_Real_Par, nProcs
use Cholesky, only: Cho_DecAlg, Cho_Fake_Par, Cho_IntChk, Cho_Reord, Cho_SScreen, Diag, Diag_G, Diag_G_Hidden, Diag_Hidden, &
                    Idle, INF_TIMING, IPRINT, LuPri, nnBstRT, RstCho, TIMSEC, XnPass
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: IRETURN
integer(kind=iwp) :: IRC, ISEC, LIRS1F, LWRK
real(kind=wp) :: TC, TCPU0, TCPU1, TST, TW, TWALL0, TWALL1
logical(kind=iwp) :: LCONV
real(kind=wp), allocatable :: Check(:), KWRK(:)
integer(kind=iwp), allocatable :: KIRS1F(:)
real(kind=wp), parameter :: DUMTOL = 1.0e-15_wp, DUMTST = 0.123456789_wp
logical(kind=iwp), parameter :: ALLOC_BKM = .true., SKIP_PRESCREEN = .false.
character(len=*), parameter :: SECNAM = 'CHO_DRV_'

#ifdef _DEBUGPRINT_
call CHO_PRTMAXMEM('CHO_DRV_ [ENTER]')
#endif

! Start overall timing.
! ---------------------

if (IPRINT >= INF_TIMING) call CWTIME(TCPU0,TWALL0)

! Set return code.
! ----------------

IRETURN = 0

! Make a dummy allocation.
! ------------------------

call mma_allocate(Check,1,Label='Check')
Check(1) = DUMTST

! INITIALIZATION.
! ===============

ISEC = 1
if (IPRINT >= INF_TIMING) call CWTIME(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
call CHO_INIT(SKIP_PRESCREEN,ALLOC_BKM)
call GASYNC()
if (IPRINT >= INF_TIMING) then
  call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
  call CHO_PRTTIM('Cholesky initialization',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),1)
end if
#ifdef _DEBUGPRINT_
call CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_INIT]')
IRC = 0
call CHO_DUMP(IRC,LUPRI)
if (IRC /= 0) then
  write(LUPRI,*) SECNAM,': CHO_DUMP returned ',IRC
  call CHO_QUIT('[1] Error detected in CHO_DUMP',103)
end if
#endif

! GET DIAGONAL.
! =============

ISEC = 2
if (IPRINT >= INF_TIMING) then
  call CWTIME(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
  write(LUPRI,'(/,A)') '***** Starting Cholesky diagonal setup *****'
  call XFLUSH(LUPRI)
end if
call CHO_GETDIAG(LCONV)
call GASYNC()
if (IPRINT >= INF_TIMING) then
  call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
  call CHO_PRTTIM('Cholesky diagonal setup',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),1)
end if
#ifdef _DEBUGPRINT_
call CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_GETDIAG]')
IRC = 0
call CHO_DUMP(IRC,LUPRI)
if (IRC /= 0) then
  write(LUPRI,*) SECNAM,': CHO_DUMP returned ',IRC
  call CHO_QUIT('[2] Error detected in CHO_DUMP',103)
end if
call CHO_PRINTLB() ! print vector dimension on each node
#endif

! DECOMPOSITION.
! ==============

ISEC = 3
if (LCONV) then
  if (RSTCHO) then
    write(LUPRI,'(//,10X,A,A,A,//)') '***** ',SECNAM,': restarted calculation converged. *****'
    TIMSEC(:,ISEC) = Zero
  else
    write(LUPRI,'(A,A)') SECNAM,': logical error: converged but not restart?!?!'
    call CHO_QUIT('Error in '//SECNAM,103)
  end if
else
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
    write(LUPRI,'(/,A)') '***** Starting Cholesky decomposition *****'
    call XFLUSH(LUPRI)
  end if
  call CHO_P_SETADDR()

  if (CHO_SSCREEN) call CHO_SUBSCR_INIT()

  call CHO_DECDRV(Diag)
  call GASYNC()
  if (CHO_DECALG == 2) then
    ! generate vectors from map
    call CHO_P_OPENVR(2) ! close files
    call CHO_P_OPENVR(1) ! re-open (problem on dec-alpha)
    if (IPRINT >= INF_TIMING) then
      call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
      call CHO_PRTTIM('Cholesky map generation',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),2)
    end if
    IRC = 0
    call CHO_X_GENVEC(IRC,Diag)
    call GASYNC()
    if (IRC /= 0) then
      write(LUPRI,'(A,A)') SECNAM,': decomposition failed!'
      write(LUPRI,'(A,A,I9)') SECNAM,': CHO_X_GENVEC returned ',IRC
      IRETURN = 1
      call CHO_QUIT('Error',104)
    end if
    if (IPRINT >= INF_TIMING) then
      call CWTIME(TC,TW)
      call CHO_PRTTIM('Cholesky vector generation',TC,TIMSEC(2,ISEC),TW,TIMSEC(4,ISEC),2)
    end if
  end if
  if (CHO_SSCREEN) call CHO_SUBSCR_FINAL()
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
    call CHO_PRTTIM('Cholesky decomposition',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),1)
  end if
end if
#ifdef _DEBUGPRINT_
call CHO_PRTMAXMEM('CHO_DRV_ [AFTER DECOMPOSITION]')
#endif

! CHECK DIAGONAL.
! ===============

ISEC = 4
if (LCONV) then
  TIMSEC(:,ISEC) = Zero
else
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
    write(LUPRI,'(/,A)') '***** Starting Cholesky diagonal check *****'
    call XFLUSH(LUPRI)
  end if
  call mma_maxDBLE(LWRK)
  call mma_allocate(KWRK,LWRK,Label='KWRK')
  call CHO_RESTART(Diag,KWRK,LWRK,.true.,LCONV)
  call GASYNC()
  call mma_deallocate(KWRK)
  if (.not. LCONV) then
    write(LUPRI,'(A,A)') SECNAM,': Decomposition failed!'
    IRETURN = 1
    call CHO_QUIT('Decomposition failed!',104)
  end if
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
    call CHO_PRTTIM('Cholesky diagonal check',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),1)
  end if
# ifdef _DEBUGPRINT_
  call CHO_PRTMAXMEM('CHO_DRV_ [AFTER DIAGONAL CHECK]')
# endif
end if

! PARALLEL RUNS: WRITE GLOBAL DIAGONAL TO DISK.
! =============================================

call CHO_P_WRDIAG()

! CHECK INTEGRALS.
! ================

ISEC = 5
if (CHO_INTCHK) then
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
    write(LUPRI,'(/,A)') '***** Starting Cholesky integral check *****'
    call XFLUSH(LUPRI)
  end if
  call CHO_DBGINT()
  call GASYNC()
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
    call CHO_PRTTIM('Cholesky integral check',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),1)
  end if
# ifdef _DEBUGPRINT_
  call CHO_PRTMAXMEM('CHO_DRV_ [AFTER INTEGRAL CHECK]')
# endif
else
  TIMSEC(:,ISEC) = Zero
end if

! REORDER VECTORS.
! ================

ISEC = 6
if (CHO_REORD) then
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
    write(LUPRI,'(/,A)') '***** Starting vector reordering *****'
    call XFLUSH(LUPRI)
  end if
  LIRS1F = NNBSTRT(1)*3
  call mma_allocate(KIRS1F,LIRS1F,Label='KIRS1F')
  call mma_maxDBLE(LWRK)
  call mma_allocate(KWRK,LWRK,Label='KWRK')
  call CHO_REOVEC(KIRS1F,3,NNBSTRT(1),KWRK,LWRK)
  call GASYNC()
  call mma_deallocate(KWRK)
  call mma_deallocate(KIRS1F)
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
    call CHO_PRTTIM('Vector reordering',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),1)
  end if
# ifdef _DEBUGPRINT_
  call CHO_PRTMAXMEM('CHO_DRV_ [AFTER VECTOR REORDERING]')
# endif
else
  TIMSEC(:,ISEC) = Zero
end if

! FAKE PARALLEL: DISTRIBUTE VECTORS.
! Note: after this section, InfVec(*,3,*) is changed
! => vector disk addresses are screwed up!!
! ==================================================

ISEC = 7
if (CHO_FAKE_PAR .and. (NPROCS > 1) .and. Is_Real_Par()) then
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
    write(LUPRI,'(/,A)') '***** Starting vector distribution *****'
    call XFLUSH(LUPRI)
  end if
  call CHO_PFAKE_VDIST()
  call CHO_P_WRRSTC(XNPASS)
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
    call CHO_PRTTIM('Vector distribution',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),1)
  end if
# ifdef _DEBUGPRINT_
  call CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_PFAKE_VDIST]')
# endif
else
  TIMSEC(:,ISEC) = Zero
end if

! FINALIZATIONS.
! ==============

ISEC = 8
if (IPRINT >= INF_TIMING) then
  call CWTIME(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
  write(LUPRI,'(/,A)') '***** Starting Cholesky finalization *****'
  call XFLUSH(LUPRI)
end if
call mma_deallocate(Idle,safe='*')
call CHO_FINAL(.true.)
call GASYNC()
if (IPRINT >= INF_TIMING) then
  call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
  call CHO_PRTTIM('Cholesky finalization',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),1)
end if
#ifdef _DEBUGPRINT_
call CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_FINAL]')
#endif

! STATISTICS.
! ===========

if (IPRINT >= 1) then
  ISEC = 9
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(1,ISEC),TIMSEC(3,ISEC))
    write(LUPRI,'(/,A)') '***** Starting Cholesky statistics *****'
    call XFLUSH(LUPRI)
  end if
  call CHO_P_STAT()
  call GASYNC()
  if (IPRINT >= INF_TIMING) then
    call CWTIME(TIMSEC(2,ISEC),TIMSEC(4,ISEC))
    call CHO_PRTTIM('Cholesky statistics',TIMSEC(2,ISEC),TIMSEC(1,ISEC),TIMSEC(4,ISEC),TIMSEC(3,ISEC),1)
  end if
end if
#ifdef _DEBUGPRINT_
call CHO_PRTMAXMEM('CHO_DRV_ [AFTER CHO_STAT]')
#endif

! Close vector and reduced storage files as well as restart files.
! Deallocate all memory and test bound.
! Print total timing.
! ----------------------------------------------------------------

call CHO_P_OPENVR(2)

TST = DUMTST-Check(1)
if (abs(TST) > DUMTOL) then
  write(LUPRI,*) SECNAM,': memory has been out of bounds!!!'
  call XFLUSH(LUPRI)
  IRETURN = 2
end if

call mma_deallocate(Diag_Hidden,safe='*')
call mma_deallocate(Diag_G_Hidden,safe='*')
nullify(DIag,Diag_G)
call mma_deallocate(Check)

if (IPRINT >= INF_TIMING) then
  call CWTIME(TCPU1,TWALL1)
  call CHO_PRTTIM('Cholesky procedure',TCPU1,TCPU0,TWALL1,TWALL0,1)
end if

#ifdef _DEBUGPRINT_
call CHO_PRTMAXMEM('CHO_DRV_ [EXIT]')
#endif

end subroutine CHO_DRV_Inner

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE SIGMA1_CP2(IP,IQ,CPQ,ISYCI,CI,SGM,NOCSF,IOCSF,NOW,IOW,
     &                 NOCP,IOCP,ICOUP,VTAB,MVL,MVR)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NOCSF(NSYM,NMIDV,NSYM),IOCSF(NSYM,NMIDV,NSYM)
      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)
      DIMENSION NOCP(MXEO,NSYM,NMIDV),IOCP(MXEO,NSYM,NMIDV)
      DIMENSION VTAB(NVTAB)
      INTEGER ICOUP
      DIMENSION ICOUP(3,NICOUP)
      DIMENSION MVL(NMIDV,2),MVR(NMIDV,2)
      DIMENSION CI(*),SGM(*)


#include "rasdim.fh"
#include "caspt2.fh"
#include "pt2_guga.fh"
#include "WrkSpc.fh"
      INTRINSIC MOD
*****************************************************************
*  GIVEN ACTIVE LEVEL INDICES IP AND IQ, AND INPUT CI ARRAYS
*  CI AND SGM, THIS ROUTINE ADDS TO SGM THE RESULT OF ACTING ON
*  CI WITH THE NUMBER CPQ TIMES THE EXCITATION OPERATOR E(IP,IQ).
*  THE ADDITIONAL ENTRIES IN THE PARAMETER LIST ARE TABLES THAT
*  WERE PREPARED BY GINIT AND ITS SUBROUTINES.
*****************************************************************


      IF(ABS(CPQ).LT.1.0D-12) GOTO 999
      iLUW=0
C SYMMETRY OF ORBITALS:
      ISYP=ISM(IP)
      ISYQ=ISM(IQ)
      ISYPQ=MUL(ISYP,ISYQ)
C SYMMETRY OF SIGMA ARRAY:
      ISYSGM=MUL(ISYPQ,ISYCI)

      IF(IP.GT.IQ) THEN
C THEN THIS IS AN EXCITING OPERATOR.
        IF(IP.LE.MIDLEV) GOTO 1600
        IF(IQ.GT.MIDLEV) GOTO 1700
        GOTO 1800
      ELSE IF(IQ.GT.IP) THEN
C THEN THIS IS A DEEXCITING OPERATOR.
        IF(IQ.LE.MIDLEV) GOTO 1300
        IF(IP.GT.MIDLEV) GOTO 1400
        GOTO 1500
      END IF
      IF(IP.GT.MIDLEV) GOTO 1200

C SPECIAL CASE: WEIGHT OPERATOR, IP=IQ.
C IP=IQ < MIDLEV.
      DO 100 MVSGM=1,NMIDV
        DO 101 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 101
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          NDWNSG=NOW(2,ISYDSG,MVSGM)
          IOLW=IOW(2,ISYDSG,MVSGM)
          IPSHFT=2*(IP-1)
          LLW=LICASE+IOLW-NIPWLK+IPSHFT/30
cVV next statement is a cheat to forbid optimization
          if(iLUW.eq.666) iLUW=iLUW+LLW
cVV
          IPSHFT=MOD(IPSHFT,30)
          IPPOW=2**IPSHFT
          DO 102 J=1,NDWNSG
            JC=IWORK(LLW+J*NIPWLK)
CPAM96           ICS=IAND(ISHFT(JC,-IPSHFT),3)
            ICS=MOD(JC/IPPOW,4)
            IF(ICS.EQ.0) GOTO 102
            X=CPQ*DBLE((1+ICS)/2)
            JSTA=ISGSTA+NUPSG*(J-1)
            CALL DAXPY_(NUPSG,X,CI(JSTA),1,SGM(JSTA),1)
 102      CONTINUE
 101    CONTINUE
 100  CONTINUE

      GOTO 999

 1200 CONTINUE
C SPECIAL CASE: WEIGHT OPERATOR, IP=IQ.
C IP=IQ>MIDLEV
      DO 200 MVSGM=1,NMIDV
        DO 201 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 201
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          NDWNSG=NOW(2,ISYDSG,MVSGM)
          IOUW=IOW(1,ISYUSG,MVSGM)
          IPSHFT=2*(IP-1-MIDLEV)
          LUW=LICASE+IOUW-NIPWLK+IPSHFT/30
cVV next statement is a cheat to forbid optimization
          if(iLUW.eq.666) iLUW=iLUW+LUW
cVV
          IPSHFT=MOD(IPSHFT,30)
          IPPOW=2**IPSHFT
          DO 202 I=1,NUPSG
            IC=IWORK(LUW+I*NIPWLK)
CPAM96            ICS=IAND(ISHFT(IC,-IPSHFT),3)
            ICS=MOD(IC/IPPOW,4)
            IF(ICS.EQ.0) GOTO 202
            X=CPQ*DBLE((1+ICS)/2)
            ISTA=ISGSTA-1+I
            CALL DAXPY_(NDWNSG,X,CI(ISTA),NUPSG,SGM(ISTA),NUPSG)
 202      CONTINUE
 201    CONTINUE
 200  CONTINUE

      GOTO 999

 1300 CONTINUE
C DEEXCITING OPERATOR, IP<IQ<=MIDLEV.
      DO 300 MVSGM=1,NMIDV
        DO 301 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 301
          ISYDSG=MUL(ISYUSG,ISYSGM)
          ISYDC=MUL(ISYPQ,ISYDSG)
          NDWNC=NOW(2,ISYDC,MVSGM)
          IF(NDWNC.EQ.0) GOTO 301
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          IOC=IOCSF(ISYUSG,MVSGM,ISYCI)
          INDEO=2*NLEV+(IQ*(IQ-1))/2+IP
          NCP=NOCP(INDEO,ISYDSG,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYDSG,MVSGM)
C CASE IS: LOWER HALF, DEEXCITE:
            CALL DEX1_CP2 (CPQ,NUPSG,CI(IOC+1),SGM(ISGSTA),
     &             NCP,ICOUP(1,LICP),VTAB)
          END IF
 301    CONTINUE
 300  CONTINUE

      GOTO 999

 1400 CONTINUE
C DEEXCITING OPERATOR, MIDLEV<IP<IQ
      DO 400 MVSGM=1,NMIDV
        DO 401 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 401
          ISYUC=MUL(ISYPQ,ISYUSG)
          NUPC=NOW(1,ISYUC,MVSGM)
          IF (NUPC.EQ.0) GOTO 401
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          NDWNSG=NOW(2,ISYDSG,MVSGM)
          IOC=IOCSF(ISYUC,MVSGM,ISYCI)
          INDEO=2*NLEV+(IQ*(IQ-1))/2+IP
          NCP=NOCP(INDEO,ISYUSG,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYUSG,MVSGM)
C CASE IS: UPPER HALF, DEEXCITE:
            CALL DEX2_CP2 (CPQ,NDWNSG,NUPC,CI(IOC+1),NUPSG,SGM(ISGSTA),
     &             NCP,ICOUP(1,LICP),VTAB)
          END IF
 401    CONTINUE
 400  CONTINUE

      GOTO 999

 1500 CONTINUE
C DEEXCITING CASE, IP<=MIDLEV<IQ.
C ALLOCATE TEMPORARY WORK AREA:
      DO 500 MVSGM=1,NMIDV
        MV4=MVR(MVSGM,1)
        MV5=MVR(MVSGM,2)
        DO 501 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 501
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          ISYUC=MUL(ISYQ,ISYUSG)
          ISYDC=MUL(ISYP,ISYDSG)
          IF(MV4.EQ.0) GOTO 499
          NUPC=NOW(1,ISYUC,MV4)
          IF(NUPC.EQ.0) GOTO 499
          NDWNC=NOW(2,ISYDC,MV4)
          IF(NDWNC.EQ.0) GOTO 499
          INDEO=IQ
          NCP=NOCP(INDEO,ISYUSG,MVSGM)
          IF(NCP.EQ.0) GOTO 499
          NTMP=NUPSG*NDWNC
          CALL FZERO(WORK(LSGTMP),NTMP)
          LICP=1+IOCP(INDEO,ISYUSG,MVSGM)
          IOC=IOCSF(ISYUC,MV4,ISYCI)
C CASE IS: UPPER HALF, DEEXCITE:
          CALL DEX2_CP2 (CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,WORK(LSGTMP),
     &             NCP,ICOUP(1,LICP),VTAB)
          INDEO=IP
          NCP=NOCP(INDEO,ISYDSG,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYDSG,MVSGM)
C CASE IS: LOWER HALF, DEEXCITE:
            X=1.0D00
            CALL DEX1_CP2 (X,NUPSG,WORK(LSGTMP),SGM(ISGSTA),
     &               NCP,ICOUP(1,LICP),VTAB)
          END IF
 499      CONTINUE
          IF(MV5.EQ.0) GOTO 501
          NUPC=NOW(1,ISYUC,MV5)
          IF(NUPC.EQ.0) GOTO 501
          NDWNC=NOW(2,ISYDC,MV5)
          IF(NDWNC.EQ.0) GOTO 501
          INDEO=NLEV+IQ
          NCP=NOCP(INDEO,ISYUSG,MVSGM)
          IF(NCP.EQ.0) GOTO 501
          NTMP=NUPSG*NDWNC
          CALL FZERO(WORK(LSGTMP),NTMP)
          LICP=1+IOCP(INDEO,ISYUSG,MVSGM)
          IOC=IOCSF(ISYUC,MV5,ISYCI)
C CASE IS: UPPER HALF, DEEXCITE:
          CALL DEX2_CP2 (CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,WORK(LSGTMP),
     &             NCP,ICOUP(1,LICP),VTAB)
          INDEO=NLEV+IP
          NCP=NOCP(INDEO,ISYDSG,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYDSG,MVSGM)
C CASE IS: LOWER HALF, DEEXCITE:
            X=1.0D00
            CALL DEX1_CP2 (X,NUPSG,WORK(LSGTMP),SGM(ISGSTA),
     &               NCP,ICOUP(1,LICP),VTAB)
          END IF
 501    CONTINUE
 500  CONTINUE

      GOTO 999

 1600 CONTINUE
C EXCITING CASE, IQ<IP<=MIDLEV.
      DO 600 MVSGM=1,NMIDV
        DO 601 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 601
          ISYDSG=MUL(ISYUSG,ISYSGM)
          ISYDC=MUL(ISYPQ,ISYDSG)
          NDWNC=NOW(2,ISYDC,MVSGM)
          IF(NDWNC.EQ.0) GOTO 601
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          IOC=IOCSF(ISYUSG,MVSGM,ISYCI)
          INDEO=2*NLEV+(IP*(IP-1))/2+IQ
          NCP=NOCP(INDEO,ISYDC,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYDC,MVSGM)
C CASE IS: LOWER HALF, EXCITE:
            CALL EXC1_CP2 (CPQ,NUPSG,CI(IOC+1),SGM(ISGSTA),
     &             NCP,ICOUP(1,LICP),VTAB)
          END IF
 601    CONTINUE
 600  CONTINUE

      GOTO 999

 1700 CONTINUE
C EXCITING CASE, MIDLEV<IQ<IP
      DO 700 MVSGM=1,NMIDV
        DO 701 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 701
          ISYUC=MUL(ISYPQ,ISYUSG)
          NUPC=NOW(1,ISYUC,MVSGM)
          IF (NUPC.EQ.0) GOTO 701
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          NDWNSG=NOW(2,ISYDSG,MVSGM)
          IOC=IOCSF(ISYUC,MVSGM,ISYCI)
          INDEO=2*NLEV+(IP*(IP-1))/2+IQ
          NCP=NOCP(INDEO,ISYUC,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYUC,MVSGM)
C CASE IS: UPPER HALF, EXCITE:
            CALL EXC2_CP2 (CPQ,NDWNSG,NUPC,CI(IOC+1),NUPSG,SGM(ISGSTA),
     &             NCP,ICOUP(1,LICP),VTAB)
          END IF
 701    CONTINUE
 700  CONTINUE

      GOTO 999

 1800 CONTINUE
C EXCITING CASE, IQ<=MIDLEV<IP
C ALLOCATE TEMPORARY WORK AREA:
      DO 800 MVSGM=1,NMIDV
        MV1=MVL(MVSGM,2)
        MV2=MVL(MVSGM,1)
        IF((MV1.EQ.0).AND.(MV2.EQ.0)) GOTO 800
        DO 801 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 801
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          ISYUC=MUL(ISYP,ISYUSG)
          ISYDC=MUL(ISYQ,ISYDSG)
          IF(MV2.EQ.0) GOTO 799
          NUPC=NOW(1,ISYUC,MV2)
          IF(NUPC.EQ.0) GOTO 799
          NDWNC=NOW(2,ISYDC,MV2)
          IF(NDWNC.EQ.0) GOTO 799
          INDEO=IP
          NCP=NOCP(INDEO,ISYUC,MV2)
          IF(NCP.EQ.0) GOTO 799
          NTMP=NUPSG*NDWNC
          CALL FZERO(WORK(LSGTMP),NTMP)
          LICP=1+IOCP(INDEO,ISYUC,MV2)
          IOC=IOCSF(ISYUC,MV2,ISYCI)
C CASE IS: UPPER HALF, EXCITE:
          CALL EXC2_CP2 (CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,WORK(LSGTMP),
     &             NCP,ICOUP(1,LICP),VTAB)
          INDEO=IQ
          NCP=NOCP(INDEO,ISYDC,MV2)
          IF(NCP.EQ.0) GOTO 799
          LICP=1+IOCP(INDEO,ISYDC,MV2)
C CASE IS: LOWER HALF, EXCITE:
          X=1.0D00
          CALL EXC1_CP2 (X,NUPSG,WORK(LSGTMP),SGM(ISGSTA),
     &               NCP,ICOUP(1,LICP),VTAB)
  799     CONTINUE
          IF(MV1.EQ.0) GOTO 801
          NUPC=NOW(1,ISYUC,MV1)
          IF(NUPC.EQ.0) GOTO 801
          NDWNC=NOW(2,ISYDC,MV1)
          IF(NDWNC.EQ.0) GOTO 801
          INDEO=NLEV+IP
          NCP=NOCP(INDEO,ISYUC,MV1)
          IF(NCP.EQ.0) GOTO 801
          NTMP=NUPSG*NDWNC
          CALL FZERO(WORK(LSGTMP),NTMP)
          LICP=1+IOCP(INDEO,ISYUC,MV1)
          IOC=IOCSF(ISYUC,MV1,ISYCI)
C CASE IS: UPPER HALF, EXCITE:
          CALL EXC2_CP2 (CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,WORK(LSGTMP),
     &             NCP,ICOUP(1,LICP),VTAB)
          INDEO=NLEV+IQ
          NCP=NOCP(INDEO,ISYDC,MV1)
          IF(NCP.EQ.0) GOTO 801
          LICP=1+IOCP(INDEO,ISYDC,MV1)
C CASE IS: LOWER HALF, EXCITE:
          X=1.0D00
          CALL EXC1_CP2 (X,NUPSG,WORK(LSGTMP),SGM(ISGSTA),
     &               NCP,ICOUP(1,LICP),VTAB)
 801  CONTINUE
 800  CONTINUE

 999  CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000-2016, Valera Veryazov                             *
************************************************************************
******************************************************************************
*                                                                            *
* Author:   Valera Veryazov 2000-2016                                        *
*           Theoretical Chemistry                                            *
*           Lund University                                                  *
*           Sweden                                                           *
*                                                                            *
******************************************************************************

*
*  This is a simple wrapper for getenv
*   Note:
*     Value must be defined as character*256
*     Name must be terminated by space
*
*  Sample:
*    Character Env*40
*    Character Value*256
*      Env='MOLCAS '
*      call getenvf(Env,Value)
*      print *, 'MOLCAS=',Value
*

      Subroutine getenvf(Name,Value)
      Character*(*) Name, Value
      value=' '
      ilen=len(Name)
      maxlen=len(Value)
      Call getenvf2c(Name,ilen,Value,maxlen,irl)
       if(irl.eq.0) then
        Value=' '
       else
        Value=Value(1:irl)
       endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fileorb(filein,fileout)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: filein
character(len=*), intent(out) :: fileout
character(len=256) :: tmp
logical(kind=iwp) :: Exists

if (index(filein,'/') /= 0) then
  fileout = filein
else
  Exists = .false.
  tmp = ' '
  call getenvf('MOLCAS_SUBMIT_DIR',tmp)
  if (tmp /= ' ') then
    fileout = trim(tmp)//'/'//filein
    !write(u6,*) 'vv',fileout
    call f_inquire(fileout,Exists)
  end if
  if (.not. Exists) then
    fileout = filein
    call f_inquire(fileout,Exists)
    if (.not. Exists) then
      tmp = 'file '//trim(fileout)//' not found'
      call WarningMessage(2,tmp)
      call Quit_OnUserError()
    end if
  end if
end if
!write(u6,*) 'INPORB file=',fileout
!call fcopy(trim(fileout),'INPORB')

return

end subroutine fileorb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine FNOMP2_Drv(irc,EMP2,CMOI,EOcc,EVir)

use MBPT2_Global, only: nBas
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(out) :: EMP2
real(kind=wp), intent(inout) :: CMOI(*), EOcc(*), EVir(*)
logical(kind=iwp) :: DoDens_
integer(kind=iwp) :: ChoAlg_
#include "corbinf.fh"
#include "chomp2_cfg.fh"

DoDens_ = DoDens
DoDens = .false.
ChoAlg_ = ChoAlg
ChoAlg = 2

call FNO_MP2(irc,nSym,nBas,nFro,nOcc,nExt,nDel,CMOI,EOcc,EVir,vkept,DoMP2,XEMP2)
if (irc /= 0) then
  write(u6,*) 'FNO_MP2 returned ',irc
  call SysAbendMsg('FNO_MP2','Non-zero return code from FNO_MP2',' ')
end if

ChoAlg = ChoAlg_
DoDens = DoDens_
DoFNO = .false.
call ChoMP2_Drv(irc,EMP2,CMOI,EOcc,EVir)
EMP2 = EMP2+XEMP2

return

end subroutine FNOMP2_Drv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Steven Vancoillie                                      *
************************************************************************
      MODULE CHOVEC_IO
C SVC: subroutines to read/write transformed cholesky vectors from/to
C disk. These are used in tracho (where they are written) and in rhsod
C (where they are read into a global array).
C
C Cholesky vectors are distributed in batches and transformed as
C such. They are written the same way to disk:
C -----------------------------------------------------
C |IB=1               |IB=2 |... |      |IB=NBATCH_TOT|
C -----------------------------------------------------
C |Cholesky vectors   |     |    |      |   ...       |
C |(p,q,nvec_chobatch)|     |    |      |   ...       |
C |for all itk>itq    |     |    |      |   ...       |
C |and isyk,isyq=jsym |     |    |      |   ...       |
C |for jsym=1         |     |    |      | jsym=NSYM   |
C -----------------------------------------------------
C each batch contains blocks of a certain type (case and symmetry).
C Always all vectors are present, with the elements distributed over
C batches as well as processes.
C
C Cases are enumerated as follows:
C   1 =    active,inactive
C   2 =    active,active
C   3 = secondary,active
C   4 = secondary,inactive
C
C Symmetry is determined by total symmetry JSYM and the symmetry of one
C of the orbital cases ISYQ, thus all values of MUL(ISYQ,JSYM).
C
C When reading the vectors, we group all batches of the same type
C together, so that we have all vectors of one type as one block,
C as this is how they are used to compute the integrals for RHS.

      ! indexing of distributed cholesky vectors
      !-----------------------------------------
      ! The cholesky vectors are distributed over batches and processed
      ! like that by tracho2. A batch has a specified number of cholesky
      ! vectors (batches for different JSYM are different, so are the
      ! number of vectors in them). The offset of a batch on disk is
      ! then determined by the type (case,isyq,jsym) and total batch
      ! number (ib).
      INTEGER, ALLOCATABLE, SAVE :: NVLOC_CHOBATCH(:)
      INTEGER, ALLOCATABLE, SAVE :: IDLOC_CHOGROUP(:,:,:,:)

      ! indexing of collected cholesky vectors
      !---------------------------------------
      ! The cholesky vectors can be collected together on disk from
      ! different processes. The combined sizes are stored in separate
      ! arrays.
      INTEGER, ALLOCATABLE, SAVE :: NVGLB_CHOBATCH(:)
      INTEGER, ALLOCATABLE, SAVE :: IDGLB_CHOGROUP(:,:,:,:)

      ! total amount of cholesky vectors in a certain symmetry
      INTEGER, SAVE :: NVTOT_CHOSYM(8)

      CONTAINS

************************************************************************
      INTEGER FUNCTION NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
************************************************************************
* Compute the number of orbital pairs for a given case (valid pair of
* inactive,active,secondary), total symmetry JSYM and component symmetry
* ISYQ. Note that the component Q which determines the symmetry block is
* the _lower_ orbital partition (e.g. inactive for active,inactive),
* which is also the slowest varying index of the pair P,Q.
************************************************************************
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"

      INTEGER :: ICASE,ISYQ,JSYM
      INTEGER :: ISYP,NP,NQ

      ISYP=MUL(ISYQ,JSYM)
      SELECT CASE(ICASE)
      CASE(1)
        NP=NASH(ISYP)
        NQ=NISH(ISYQ)
      CASE(2)
        NP=NASH(ISYP)
        NQ=NASH(ISYQ)
      CASE(3)
        NP=NSSH(ISYP)
        NQ=NASH(ISYQ)
      CASE(4)
        NP=NSSH(ISYP)
        NQ=NISH(ISYQ)
      CASE DEFAULT
        NP=0
        NQ=0
        CALL SYSABENDMSG('NPQ_CHOTYPE',
     &    'invalid case number', '')
      END SELECT
      NPQ_CHOTYPE=NP*NQ
      END FUNCTION

************************************************************************
      SUBROUTINE CHOVEC_SIZE(ICASE,NCHOBUF,IOFF)
************************************************************************
* Allocate a buffer to hold all cholesky vectors of type ITK,ITQ
************************************************************************
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"

      INTEGER :: ICASE,NCHOBUF,IOFF(8,8)
      INTEGER :: ISYK,ISYQ,JSYM
      INTEGER :: NPQ,NVTOT

      NCHOBUF=0
      DO JSYM=1,NSYM
        NVTOT=NVTOT_CHOSYM(JSYM)
        DO ISYQ=1,NSYM
          ISYK=MUL(ISYQ,JSYM)
          IOFF(ISYK,ISYQ)=NCHOBUF
          NPQ=NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
          NCHOBUF=NCHOBUF+NPQ*NVTOT
        END DO
      END DO

      END SUBROUTINE

************************************************************************
      SUBROUTINE CHOVEC_READ(ICASE,LCHOBUF)
************************************************************************
* Read (transposed) cholesky vectors from disk, they
* are indexed as CHOBUF(IVEC,IQ,IK)
************************************************************************
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
      LOGICAL :: IS_REAL_PAR
#endif

      INTEGER :: ICASE,LCHOBUF

      INTEGER :: I,J,IOFF,IDISK
      INTEGER :: IB,IBSTA,IBEND,IBOFF
      INTEGER :: JSYM,ISYQ
      INTEGER :: LBUF,NBUF,NPQ,NV,NVTOT

      IOFF=0
      DO JSYM=1,NSYM
        NVTOT=NVTOT_CHOSYM(JSYM)
        IBSTA=NBTCHES(JSYM)+1
        IBEND=NBTCHES(JSYM)+NBTCH(JSYM)
        DO ISYQ=1,NSYM
          NPQ=NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
          IBOFF=0
          DO IB=IBSTA,IBEND
            NV=NVGLB_CHOBATCH(IB)
            NBUF=NPQ*NV
            CALL GETMEM('BUF','ALLO','REAL',LBUF,NBUF)
            IDISK=IDGLB_CHOGROUP(ICASE,ISYQ,JSYM,IB)
#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              ! cholesky vectors already transposed
              CALL DDAFILE(LUDRATOT,2,WORK(LBUF),NBUF,IDISK)
              DO J=1,NPQ
                DO I=1,NV
                  WORK(LCHOBUF+IOFF+IBOFF+I-1+NVTOT*(J-1))=
     &            WORK(LBUF+I-1+NV*(J-1))
                END DO
              END DO
            ELSE
              ! cholesky vectors not transposed
              CALL DDAFILE(LUDRA,2,WORK(LBUF),NBUF,IDISK)
              DO J=1,NPQ
                DO I=1,NV
                  WORK(LCHOBUF+IOFF+IBOFF+I-1+NVTOT*(J-1))=
     &            WORK(LBUF+J-1+NPQ*(I-1))
                END DO
              END DO
            ENDIF
#else
            ! cholesky vectors not transposed
            CALL DDAFILE(LUDRA,2,WORK(LBUF),NBUF,IDISK)
            DO J=1,NPQ
              DO I=1,NV
                WORK(LCHOBUF+IOFF+IBOFF+I-1+NVTOT*(J-1))=
     &            WORK(LBUF+J-1+NPQ*(I-1))
              END DO
            END DO
#endif
            CALL GETMEM('BUF','FREE','REAL',LBUF,NBUF)
            IBOFF=IBOFF+NV
          END DO
          IOFF=IOFF+NVTOT*NPQ
        END DO
      END DO

      END SUBROUTINE

************************************************************************
      SUBROUTINE CHOVEC_SAVE(CHOBUF,ICASE,ISYQ,JSYM,IB)
************************************************************************
* Write Cholesky vectors to disk.
************************************************************************
      Implicit real*8 (a-h,o-z)
#include "rasdim.fh"
#include "warnings.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "chocaspt2.fh"
      DIMENSION CHOBUF(*)

C always write the chunks to LUDRA, both for serial and parallel
      NPQ=NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
      JNUM=NVLOC_CHOBATCH(IB)
      IDISK=IDLOC_CHOGROUP(ICASE,ISYQ,JSYM,IB)
      CALL DDAFILE(LUDRA,1,CHOBUF,NPQ*JNUM,IDISK)

#ifdef _DEBUGPRINT_
      NBUF=NPQ*JNUM
      SQFP = DNRM2_(NBUF,CHOBUF,1)
      WRITE(6,'(1X,A,I9,A,A,I2,A,A,I2,A,A,I2,A,A,F21.14)')
     &  'BATCH ',IB,   ', ',
     &  'CASE ' ,ICASE,', ',
     &  'ISYQ ' ,ISYQ, ', ',
     &  'JSYM ' ,JSYM, ', ',
     &  'DNRM2 ',SQFP
#endif
      END SUBROUTINE

************************************************************************
      SUBROUTINE CHOVEC_LOAD(CHOBUF,ICASE,ISYQ,JSYM,IB)
************************************************************************
* Read Cholesky vectors from disk.
************************************************************************
      Implicit real*8 (a-h,o-z)
#include "rasdim.fh"
#include "warnings.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "chocaspt2.fh"
      DIMENSION CHOBUF(*)

C always write the chunks to LUDRA, both for serial and parallel
      NPQ=NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
      JNUM=NVLOC_CHOBATCH(IB)
      IDISK=IDLOC_CHOGROUP(ICASE,ISYQ,JSYM,IB)
      CALL DDAFILE(LUDRA,2,CHOBUF,NPQ*JNUM,IDISK)

#ifdef _DEBUGPRINT_
      NBUF=NPQ*JNUM
      SQFP = DNRM2_(NBUF,CHOBUF,1)
      WRITE(6,'(1X,A,I9,A,A,I2,A,A,I2,A,A,I2,A,A,F21.14)')
     &  'BATCH ',IB,   ', ',
     &  'CASE ' ,ICASE,', ',
     &  'ISYQ ' ,ISYQ, ', ',
     &  'JSYM ' ,JSYM, ', ',
     &  'DNRM2 ',SQFP
#endif
      END SUBROUTINE

************************************************************************
      SUBROUTINE CHOVEC_COLL(CHOBUF,ICASE,ISYQ,JSYM,IB)
************************************************************************
* Routine to gather locally available cholesky vectors and collect
* all of them on each process in case of parallel run.
************************************************************************
#ifdef _MOLCAS_MPP_
      use mpi
#endif
      IMPLICIT NONE
#include "rasdim.fh"
#include "warnings.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "chocaspt2.fh"
#include "para_info.fh"
      REAL*8 :: CHOBUF(*)
      INTEGER :: ICASE,ISYQ,JSYM,IB

#ifdef _MOLCAS_MPP_
#  include "global.fh"
#  include "mafdecls.fh"
      INTEGER*4 IERROR4,ITYPE
      INTEGER*4, PARAMETER :: ONE4 = 1
      INTEGER :: LDISP,LSIZE,LRECVBUF,LTRANSP
      INTEGER :: I,JNUM,JNUMT,NPQ,NUMSEND(1),IDISKT,IERROR
#ifdef _DEBUGPRINT_
      INTEGER :: MY_N,NOFF
      REAL*8 :: SQFP
      REAL*8, EXTERNAL :: DDOT_
#endif
#endif

#ifdef _MOLCAS_MPP_
#  ifdef _I8_
      ITYPE=MPI_INTEGER8
#  else
      ITYPE=MPI_INTEGER4
#  endif
      IF (Is_Real_Par()) THEN
C for true parallel, also communicate chunks to each process, write them
C to LUDRATOT, so first allocate memory for the fully transformed
C vectors, and for the per-process size and offset into LUDRATOT
        CALL GETMEM('DISP','ALLO','INTE',LDISP,NPROCS)
        CALL GETMEM('SIZE','ALLO','INTE',LSIZE,NPROCS)

C gather sizes of local cholesky bits
        NPQ=NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
        JNUM=NVLOC_CHOBATCH(IB)
        NUMSEND(1)=NPQ*JNUM
        CALL MPI_Allgather(NUMSEND,ONE4,ITYPE,
     &       IWORK(LSIZE:LSIZE+NPROCS-1),ONE4,ITYPE,
     &       MPI_COMM_WORLD, IERROR4)
C compute offsets into the receiving array
        IWORK(LDISP)=0
        DO I=2,NPROCS
          IWORK(LDISP+I-1)=IWORK(LDISP+I-2)+IWORK(LSIZE+I-2)
        END DO

C collect the vectors
        CALL GETMEM('RECVBUF','ALLO','REAL',LRECVBUF,NFTSPC_TOT)
        CALL MPI_Barrier(MPI_COMM_WORLD, IERROR4)
        CALL MPI_Allgatherv_(CHOBUF,NUMSEND(1),MPI_REAL8,
     &       WORK(LRECVBUF),IWORK(LSIZE),IWORK(LDISP),
     &       MPI_REAL8,MPI_COMM_WORLD, IERROR)

        JNUMT=NVGLB_CHOBATCH(IB)
        ! disk offset is block offset + preceding block size
        IDISKT=IDGLB_CHOGROUP(ICASE,ISYQ,JSYM,IB)

CSVC: for RHS on demand, write transposed chovecs, else just write
        IF (RHSDIRECT) THEN
          CALL GETMEM('TRANSP','ALLO','REAL',LTRANSP,NPQ*JNUMT)
          CALL DTRANS(NPQ,JNUMT,WORK(LRECVBUF),NPQ,
     &                          WORK(LTRANSP),JNUMT)
          CALL DDAFILE(LUDRATOT,1,WORK(LTRANSP),NPQ*JNUMT,IDISKT)
          CALL GETMEM('TRANSP','FREE','REAL',LTRANSP,NPQ*JNUMT)
        ELSE
          CALL DDAFILE(LUDRATOT,1,WORK(LRECVBUF),NPQ*JNUMT,IDISKT)
        END IF

#  ifdef _DEBUGPRINT_
        WRITE(6,*) ' process block, size, offset, fingerprint'
        DO I=1,NPROCS
          MY_N = IWORK(LSIZE+I-1)
          NOFF = IWORK(LDISP+I-1)
          SQFP =DDOT_(MY_N,WORK(LRECVBUF+NOFF),1,WORK(LRECVBUF+NOFF),1)
          WRITE(6,'(A,I6,A,2I12,ES20.12)') ' [',I,'] ',MY_N,NOFF,SQFP
        END DO
#  endif
        CALL GETMEM('RECVBUF','FREE','REAL',LRECVBUF,NFTSPC_TOT)
        CALL GETMEM('DISP','FREE','INTE',LDISP,NPROCS)
        CALL GETMEM('SIZE','FREE','INTE',LSIZE,NPROCS)
      END IF
#else
C Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_real_array(CHOBUF)
        CALL Unused_integer(ICASE)
        CALL Unused_integer(ISYQ)
        CALL Unused_integer(JSYM)
        CALL Unused_integer(IB)
      END IF
#endif
      END SUBROUTINE

#ifdef _MOLCAS_MPP_
************************************************************************
      SUBROUTINE MPI_Allgatherv_(SENDBUF,NSEND,MPITYPES,
     &                     RCVBUF,NRCV,NOFF,MPITYPER,MPICOMM,IERROR)
************************************************************************
* Wrapper to MPI_Allgatherv dealing with ILP64 incompatibility.
************************************************************************
      use mpi
      IMPLICIT NONE
      REAL*8 SENDBUF(*), RCVBUF(*)
      INTEGER NSEND, NRCV(*),NOFF(*)

      INTEGER*4 MPITYPES, MPITYPER, MPICOMM

      INTEGER*4 NPROCS
      INTEGER*4 NSEND4
      INTEGER*4,ALLOCATABLE :: NRCV4(:),NOFF4(:)
      INTEGER*4 IERROR4
      INTEGER, PARAMETER :: I4=KIND(NSEND4)

      INTEGER :: I, IERROR
#ifdef _I8_
      INTEGER :: NRCVTOT
#endif

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD, NPROCS,IERROR4)

#ifdef _I8_
      NRCVTOT=0
      DO I=1,NPROCS
        NRCVTOT=NRCVTOT+NRCV(I)
      END DO
      IF (8*NRCVTOT.GT.2147483647) THEN
        WRITE(6,'(1X,A)') 'MPI_Allgatherv: total rcv buf > 2**31-1'
        WRITE(6,'(1X,A)') 'workaround to avoid buffers >2GB failed'
        WRITE(6,'(1X,A)') '-> please report this as a bug!'
        CALL ABEND()
      END IF
#endif

      ALLOCATE(NRCV4(NPROCS))
      ALLOCATE(NOFF4(NPROCS))
      NSEND4=INT(NSEND,I4)
      DO I=1,NPROCS
        NRCV4(I)=INT(NRCV(I),I4)
        NOFF4(I)=INT(NOFF(I),I4)
      END DO
      CALL MPI_Allgatherv(SENDBUF,NSEND4,MPITYPES,
     &                    RCVBUF,NRCV4,NOFF4,MPITYPER,
     &                    MPICOMM,IERROR4)

      IERROR=IERROR4
      END SUBROUTINE
#endif

      END MODULE CHOVEC_IO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE EXCIND(IAS,INS,ISYM,ICASE,IP,IQ,IR,IS)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
      EXTERNAL ASIND

CPAM99 New call sequence for ASIND
      CALL ASIND(IAS,ISYM,ICASE,IP1,IQ1,IR1)
      CALL NSIND(INS,ISYM,ICASE,IP2,IQ2,IR2)

      IP=IQ1
      IQ=IQ2
      IR=IP1
      IS=IP2
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000,2022, Roland Lindh                                *
!               Ajitha Devarajan                                       *
!***********************************************************************

subroutine DFT_Int(list_s,nlist_s,FckInt,nFckInt,nD,Fact,ndc)
!***********************************************************************
!                                                                      *
! Object: to compute contributions to                                  *
!                                                                      *
!         <m|dF/drho|n> ; integrals over the potential                 *
!                                                                      *
!         where                                                        *
!                                                                      *
!         F(r)=rho(r)*e(rho(r),grad[rho(r)])                           *
!                                                                      *
!      Author:Roland Lindh, Department of Chemical Physics, University *
!             of Lund, SWEDEN. November 2000                           *
!             D.Ajitha:Modifying for the new Kernel outputs            *
!***********************************************************************

use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nlist_s, list_s(2,nlist_s), nFckInt, nD, ndc
real(kind=wp), intent(inout) :: FckInt(nFckInt,nD)
real(kind=wp), intent(in) :: Fact(ndc**2)

!                                                                      *
!***********************************************************************
!                                                                      *
! Evaluate the desired AO integrand here from the AOs, accumulate
! contributions to the SO integrals on the fly.

call Do_NInt_d()
call Do_NIntX()
!                                                                      *
!***********************************************************************
!                                                                      *
! Distribute result on to the full integral matrix.

if (nIrrep == 1) then
  call AOAdd_Full(FckInt,nFckInt,nD)
else
  call SymAdp_Full(FckInt,nFckInt,list_s,nlist_s,Fact,ndc,nD)
end if
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine DFT_Int

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1988,1991,1992,1998, Per Ake Malmqvist                 *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine POLY3(mkF)
!  IBM TEST VERSION 0, 1988-06-23.
!  NEW VERSION 1991-02-23, FOR USE WITH RASSCF IN MOLCAS PACKAGE.
!  NEW VERSION 1992-12-05, FOR MOLCAS-3 VERSION.
!  NEW VERSION 1998-10-02
!  AUTHOR: PER-AAKE MALMQUIST

! THIS PROGRAM CALCULATES 1-EL, 2-EL, AND 3-EL
! DENSITY MATRICES FOR A CASSCF WAVE FUNCTION.
! IF THE INTEGER KEY IFF == 1, THEN
! IT ALSO PRODUCES THE CONTRACTIONS OF 1-EL -- 4-EL
! DENSITY MATRICES WITH THE FOCK OPERATOR USED IN
! THE CASSCF-MP2 PROGRAM. THE RESULTS ARE WRITTEN
! TO FILE IN SEVERAL FORMS, TO SUPPORT BOTH KERSTINS
! PRESENT PROGRAM AND ALSO SUCH NEW PROCEDURES WHICH
! MIGHT TAKE ADVANTAGE OF ALL INDEX PERMUTATION SYMMETRIES.
! THE RDSTAT AND THE GUGA ROUTINES USED IN THIS
! PROGRAM ASSUMES THE JOBIPH IS PRODUCED BY THE RASSCF PROGRAM.

use fciqmc_interface, only: DoFCIQMC
use PrintLevel, only: VERBOSE
use sguga, only: CIS, L2ACT, SGS
use caspt2_global, only: IDTCEX, iPrGlb, LUCIEX, LUSOLV
use caspt2_module, only: CIThr, DoCumulant, EPSA, Eta, iSCF, jState, mState, nActel, NAshT, nConf, nG1, nG2, nG3, nG3Tot, nState, &
                         STSym
#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_ || defined _DMRG_
use caspt2_module, only: DMRG
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, byte

implicit none
logical(kind=iwp), intent(in) :: mkF
integer(kind=iwp) :: IDCI, ILEV, ILUID, IPARDIV, nCI, NG3MAX, nLev
integer(kind=byte), allocatable :: idxG3(:,:)
real(kind=wp), allocatable :: CI(:)
real(kind=wp), allocatable, target :: F1_H(:), F2_H(:), F3_H(:), G1(:), G2(:), G3(:)
real(kind=wp), pointer :: F1(:), F2(:), F3(:)

nLev = SGS%nLev

! Note that in case of FCIQMC nConf is set to 0.
nCI = CIS%NCSF(STSYM)

if (mkF) then
  ! ORBITAL ENERGIES IN CI-COUPLING ORDER:
  do ILEV=1,NLEV
    ETA(ILEV) = EPSA(L2ACT(ILEV))
  end do
end if

call mma_allocate(G1,NG1,LABEL='G1')
call mma_allocate(G2,NG2,LABEL='G2')

!-SVC20100831: recompute approximate max NG3 size needed
NG3MAX = iPARDIV(NG3TOT,NG2)

!-SVC20100831: allocate local G3 matrices
call mma_allocate(G3,NG3MAX,LABEL='G3')

call mma_allocate(idxG3,6,NG3MAX,label='idxG3')
idxG3(:,:) = 0

G1(1) = Zero
G2(1) = Zero
G3(1) = Zero

! ALLOCATE SPACE FOR CORRESPONDING COMBINATIONS WITH H0:
if (mkF) then
  call mma_allocate(F1_H,NG1,LABEL='F1_H')
  call mma_allocate(F2_H,NG2,LABEL='F2_H')
  call mma_allocate(F3_H,NG3MAX,LABEL='F3_H')
  F1 => F1_H
  F2 => F2_H
  F3 => F3_H
else
  ! This is just done such that in the case of mkF=.false. that
  ! F1, F2, and F3 refer to an actual array.
  F1 => G1
  F2 => G2
  F3 => G3
end if

! NG3 will change inside subroutine MKFG3 to the actual
! number of nonzero elements, that is why here we allocate
! with NG3MAX, but we only store (PT2_PUT) the first NG3
! elements of the G3 and F3
NG3 = NG3MAX

if (.not. DoFCIQMC) then
  call mma_allocate(CI,NCONF,Label='CI')

  if ((.not. DoCumulant) .and. (ISCF == 0)) then
    IDCI = IDTCEX(JSTATE)
    call DDAFILE(LUCIEX,2,CI,NCONF,IDCI)
    if (IPRGLB >= VERBOSE) then
      write(u6,*)
      if (NSTATE > 1) then
        write(u6,'(A,I4)') ' With new orbitals, the CI array of state ',MSTATE(JSTATE)
      else
        write(u6,*) ' With new orbitals, the CI array is:'
      end if
      call PRWF_CP2(STSYM,NCONF,CI,CITHR)
    end if
  else
    CI(1) = One
  end if
end if

if ((ISCF /= 0) .and. (NACTEL /= 0)) then
  call SPECIAL(G1,G2,G3,F1,F2,F3,idxG3,nAshT,nG3)
else if (ISCF == 0) then
  !-SVC20100903: during mkfg3, NG3 is set to the actual value
# if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_ || defined _DMRG_
  if ((.not. DoCumulant) .and. (.not. DMRG)) then
# endif
    if (.not. allocated(CI)) call mma_allocate(CI,1,LABEL='CI')
    call MKFG3(mkF,CI,nCI,G1,F1,G2,F2,G3,F3,idxG3,nLev,nG1,nG2,nG3)
# if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_ || defined _DMRG_
  else
    call MKFG3DM(mkF,G1,F1,G2,F2,G3,F3,idxG3,nLev,nG3)
  end if
# endif
end if

if (allocated(CI)) call mma_deallocate(CI)

if (NLEV > 0) then
  call PT2_PUT(NG1,' GAMMA1',G1)
  call PT2_PUT(NG2,' GAMMA2',G2)
  call PT2_PUT(NG3,' GAMMA3',G3)
  iLUID = 0
  call I1DAFILE(LUSOLV,1,idxG3,6*NG3,iLUID)
  if (mkF) then
    call PT2_PUT(NG1,' DELTA1',F1)
    call PT2_PUT(NG2,' DELTA2',F2)
    call PT2_PUT(NG3,' DELTA3',F3)
  end if
end if

if (NLEV > 0) then
  call mma_deallocate(G1)
  call mma_deallocate(G2)
  call mma_deallocate(G3)
  call mma_deallocate(idxG3)
  if (mkF) then
    call mma_deallocate(F1_H)
    call mma_deallocate(F2_H)
    call mma_deallocate(F3_H)
  end if
  nullify(F1,F2,F3)
end if

end subroutine POLY3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Dens_Info(ijS,ipDij,ipDSij,mDCRij,ipDDij,ipTmp,
     &                     nr_of_Densities)
      use k2_arrays
      Implicit Real*8 (a-h,o-z)
*
      ipDij = ipOffD(1,ijS)
      mDCRij= ipOffD(2,ijS)
      nDij  = ipOffD(3,ijS)
      If (nr_of_Densities.eq.2) Then
         ipDSij=ipOffD(4,ijS)
      Else
         ipDSij= 1
      End If
*
      If (mDCRij*nDij.ne.0) Then
         ipDDij = ipTmp
         ipTmp = ipTmp + nDij*mDCRij
      Else
         ipDDij = 1
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!***********************************************************************

subroutine SKICKJ_MCLR(SKII,CKJJ,NKA,NIB,NJB,NKB,XIJKL,NI,NJ,NK,NL,MAXK,KBIB,XKBIB,KBJB,XKBJB,IKORD,IROUTE)
! Calculate S(Ka,Ib,i) = S(Ka,Ib,i)
!          +SUM(j,k,l,Kb) <Ib!a+ kb!Kb><Kb!a lb !Jb>*(ij!kl)*C(Ka,Jb,j)
!
! Jeppe Olsen, Spring of 94

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NKA, NIB, NJB, NKB, NI, NJ, NK, NL, MAXK, KBIB(MAXK,*), KBJB(MAXK,*), IKORD, IROUTE
real(kind=wp), intent(inout) :: SKII(NKA*NI,*)
real(kind=wp), intent(in) :: CKJJ(NKA*NJ,*), XIJKL(*), XKBIB(MAXK,*), XKBJB(MAXK,*)
integer(kind=iwp) :: I, IB, IKEFF, IMIN, INTOF, IOFF, J, JB, JL, JL0, JLIK0, K, KB, KK, L, LEFF, LENGTH, LL, MAXORB
real(kind=wp) :: FACTOR, SGNK, SGNL
integer(kind=iwp), allocatable :: IBOFF(:), JBOFF(:)
real(kind=wp), allocatable :: KSKICK(:)
integer(kind=iwp), parameter :: MXTSOB = 35

! Note if Iroute = 2 the form is S(i,Ka,Ib)
! Note if Iroute = 2 the form is C(j,Ka,Jb)

MAXORB = max(NI,NJ,NK,NL)
LENGTH = MAXORB*MAXORB*MAXORB*MAXORB
call mma_allocate(KSKICK,LENGTH,Label='KSKICK')
call mma_allocate(IBOFF,MXTSOB*MXTSOB,Label='IBOFF')
call mma_allocate(JBOFF,MXTSOB*MXTSOB,Label='JBOFF')

if (MAXORB > MXTSOB) then
  write(u6,*) ' SKICKJ_MCLR : Too many orbs : NI > MXTSOB'
  write(u6,*) ' NI, MXTSOB ',max(NI,NJ,NK,NL),MXTSOB
  write(u6,*) ' Redim MXTSOB in SKICKJ_MCLR'
  call Abend()
end if

if (IROUTE == 3) then
  ! S(Ka,i,Ib) = S(Ka,i,Ib) + sum(j) (ji!kl) C(Ka,j,Jb)
  do KB=1,NKB
    ! Number of nonvanishing connections from KB
    LL = 0
    KK = 0
    do L=1,NL
      if (KBJB(KB,L) /= 0) LL = LL+1
    end do
    do K=1,NK
      if (KBIB(KB,K) /= 0) KK = KK+1
    end do

    if ((KK /= 0) .and. (LL /= 0)) then
      do K=1,NK
        IB = KBIB(KB,K)
        if (IB /= 0) then
          SGNK = XKBIB(KB,K)
          do L=1,NL
            JB = KBJB(KB,L)
            if (JB /= 0) then
              SGNL = XKBJB(KB,L)
              FACTOR = SGNK*SGNL
              ! We have now a IB and Jb string, let's do it
              !ISOFF = (IB-1)*NI*NKA+1
              !ICOFF = (JB-1)*NJ*NKA+1
              INTOF = ((L-1)*NK+K-1)*NI*NJ+1

              call DGEMM_('N','N',NKA,NI,NJ,FACTOR,CKJJ(1,jB),max(1,NKA),XIJKL(INTOF),max(1,NJ),ONE,SKII(1,iB),max(1,NKA))

            end if
          end do
        end if
      end do
    end if
  end do
  ! (end over loop over Kb strings)
else if (IROUTE == 2) then
  ! S(I,Ka,Ib) = S(I,Ka,Ib) + sum(j) (ij!kl) C(j,Ka,Jb)
  do KB=1,NKB
    ! Number of nonvanishing connections from KB
    LL = 0
    KK = 0
    do L=1,NL
      if (KBJB(KB,L) /= 0) LL = LL+1
    end do
    do K=1,NK
      if (KBIB(KB,K) /= 0) KK = KK+1
    end do

    if ((KK /= 0) .and. (LL /= 0)) then
      do K=1,NK
        IB = KBIB(KB,K)
        if (IB /= 0) then
          SGNK = XKBIB(KB,K)
          do L=1,NL
            JB = KBJB(KB,L)
            if (JB /= 0) then
              SGNL = XKBJB(KB,L)
              FACTOR = SGNK*SGNL
              ! We have now a IB and Jb string, let's do it
              !ISOFF = (IB-1)*NI*NKA+1
              !ICOFF = (JB-1)*NJ*NKA+1
              INTOF = ((L-1)*NK+K-1)*NI*NJ+1

              call DGEMM_('N','N',NI,NKA,NJ,FACTOR,XIJKL(INTOF),max(1,NI),CKJJ(1,JB),max(1,NJ),ONE,SKII(1,IB),max(1,NI))
            end if
          end do
        end if
      end do
    end if
  end do
  ! (end over loop over Kb strings)

else if (IROUTE == 1) then

  do KB=1,NKB
    ! Number of nonvanishing a+lb !Kb>
    LL = 0
    do L=1,NL
      if (KBJB(KB,L) /= 0) LL = LL+1
    end do

    IKEFF = 0
    do K=1,NK
      IB = KBIB(KB,K)
      if (IB == 0) cycle
      SGNK = XKBIB(KB,K)

      if (IKORD == 0) then
        IMIN = 1
      else
        IMIN = K
      end if

      do I=IMIN,NI
        IKEFF = IKEFF+1
        IOFF = (IKEFF-1)*NJ*LL
        ! Offset for S(1,IB,i)
        IBOFF(IKEFF) = (I-1)*NIB+IB
        LEFF = 0
        do L=1,NL
          JB = KBJB(KB,L)
          if (JB == 0) cycle
          LEFF = LEFF+1
          SGNL = XKBJB(KB,L)
          if ((IKORD == 1) .and. (I == K)) then
            FACTOR = Half*SGNK*SGNL
          else
            FACTOR = SGNK*SGNL
          end if
          JL0 = (LEFF-1)*NJ
          JLIK0 = (K-1)*NJ*NL*NI+(I-1)*NJ*NL+(L-1)*NJ

          do J=1,NJ
            JL = JL0+J
            ! Offsets for C(1,JB,j)
            JBOFF(JL) = (J-1)*NJB+JB
            ! integral * signs in SCR(jl,ik)
            ! Integrals are stored as (j l i k)
            KSKICK(IOFF+JL) = FACTOR*XIJKL(JLIK0+J)
          end do

        end do

      end do

    end do

    call GSAXPY(SKII,CKJJ,KSKICK,IKEFF,NJ*LL,NKA,IBOFF,JBOFF)

  end do
end if
! End of IROUTE branching

call mma_deallocate(KSKICK)
call mma_deallocate(IBOFF)
call mma_deallocate(JBOFF)

end subroutine SKICKJ_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
*               2002, Roland Lindh                                     *
*               2005, Jesper Wisborg Krogh                             *
************************************************************************
      Subroutine SpoolInp(LuSpool)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Copy all input to a local scratch file                           *
*                                                                      *
*     calling arguments:                                               *
*     LuSpool   : integer                                              *
*               logical unit number of the temporary file              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*     Modified by:  R. Lindh to allow for use of old input file.       *
*                   Tokyo, Japan, June 2002.                           *
*                   J.W. Krogh to make auto.plx create the old input   *
*                   file. Lund, Sweden, October 2005.                  *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
      External Get_ProgName
#include "standard_iounits.fh"
      Character*100 ProgName, Get_ProgName
      Character*128 FileName
      logical exist
*
*
*     Get the name of the module
*
      ProgName=Get_ProgName()
      Call Upcase(ProgName)
      Call LeftAd(ProgName)
*
      iEnd = 1
 99   If (ProgName(iEnd:iEnd).ne.' ') Then
         iEnd=iEnd+1
         Go To 99
      End If
      iEnd = Min(iEnd-1,5)
      FileName=progname(1:iend)//'INP'

*
*     If Spool is true, then the input in StdIn is just used.
*     Else we'll use the latest input. This is created by
*     auto.plx
*
      LuSpool = 17
      If (Spool) Then
         LuSpool = LuRd
      Else
         call f_inquire('LASTEN',exist) ! customized Last_Energy input
         if(exist) then
           LuSpool = IsFreeUnit(LuSpool)
           call Molcas_Open(LuSpool,'LASTEN')
         else
           call f_inquire(Filename,exist)
           if(exist) then
             LuSpool = IsFreeUnit(LuSpool)
             call Molcas_Open(LuSpool,Filename)
           endif
         endif
      End If
*
      Return
*                                                                      *
************************************************************************
*                                                                      *
*

      End
*
      Subroutine Close_LuSpool(LuSpool)
      Implicit Integer (A-Z)
#include "standard_iounits.fh"
*
      If (.Not. Spool) Then
         Close(LuSpool)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CntMem(nHer,MemCnt,la,lb,lr)
      use Sizes_of_Seward, only: s
      Implicit Real*8 (A-H,O-Z)
*
      nHer=S%mCentr
      MemCnt = 3*(la+1)*nHer +
     &         3*(lb+1)*nHer +
     &         ((la+1)*(la+2)/2) *
     &         ((lb+1)*(lb+2)/2)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lr)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!               1996, Luis Serrano-Andres                              *
!               2012, Victor P. Vysotskiy                              *
!               2016, Steven Vancoillie                                *
!***********************************************************************

subroutine MpDaFile(Lu,MaxFileSizel,iOpt,Buf,lBuf,iDisk)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     File systems or disks may be to small to keep a given large      *
!     dataset. Therefore, it may be split into subsets which then      *
!     may be linked to different physical units. This process is       *
!     controlled by the environment variable MOLCASDISK                *
!     (c.f. allocdisk). This routine computes the proper splitting     *
!     and calls the IO routines.                                       *
!                                                                      *
!     calling arguments:                                               *
!     Lu      : integer, input                                         *
!               logical unit number (Lu={1,2,...40,50,60,70,80,90}     *
!     MaxFileSize : integer, input                                     *
!               max length of a file.                                  *
!     iOpt    : integer, input                                         *
!               option code                                            *
!               iOpt= 0 dummy write                                    *
!               iOpt= 1 synchronous write                              *
!               iOpt= 2 synchronous read                               *
!               iOpt= 3 synchronous gather and write                   *
!               iOpt= 4 synchronous read and scatter                   *
!               iOpt= 5 synchronous rewind                             *
!               iOpt= 6 asynchronous write                             *
!               iOpt= 7 asynchronous read                              *
!               iOpt= 8 asynchronous gather and write                  *
!               iOpt= 9 asynchronous read and scatter                  *
!               iOpt=10 asynchronous rewind                            *
!               Note: At present the asynchronous modes are not        *
!                     supported and work identically the synchronous   *
!                     modes                                            *
!     Buf     : array of characters, input/output                      *
!               Buffer carrying/receiving the data to write/read       *
!     lBuf    : integer, input                                         *
!               length of the buffer Buf in bytes!!                    *
!     iDisk   : integer, input                                         *
!               disk address as byte offset!!!                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher, University of Lund, Sweden, 1996                 *
!     L. Serrano-Andres, University of Lund, Sweden, 1996              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! History:                                                             *
!     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
!     Steven Vancoillie: use of byte lengths/offests (2016)            *
!                                                                      *
!***********************************************************************

use Fast_IO, only: Addr, FSCB, isOpen, LuName, Max_File_Length, MaxSplitFile, MBL, MPUnit, Multi_File
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Lu, MaxFileSizel, iOpt, lBuf, iDisk
character, intent(inout) :: Buf(*)
integer(kind=iwp) :: iDisk_mod, iext, iRc, lStdNam, ltmp, Lu_mod, max_Bytes, max_File_Size, n_Bytes, n_Copy, n_Save, offset, &
                     p_Buf, start_char, temp
character(len=256) :: tmp
character(len=80) :: Text
character(len=8) :: Stdnam, ext
character(len=*), parameter :: TheName = 'MpDaFile'
integer(kind=iwp), external :: AixErr, AixOpn, isFreeUnit, StrnLn

max_File_Size = MaxFileSizel*10**6
max_Bytes = min(max_File_Length,max_File_Size)
n_Bytes = lBuf
offset = iDisk/max_Bytes
! set correct char to append: 0-9, A-Z
start_char = 48

if (offset <= 9) then
  start_char = 48
else
  start_char = 55
end if

if ((offset < 0) .or. (offset > MaxSplitFile-1)) then
  StdNam = LuName(Lu)
  call PrgmTranslate(StdNam,tmp,ltmp)
  write(u6,*) '          Current I/O Status as follows'
  write(u6,*)
  call FASTIO('STATUS')
  call SysWarnFileMsg(TheName,StdNam,'Extensions out of range!','increase MOLCAS_DISK value or MaxSplitFile in Fast_IO')
  call Abend()
end if
Lu_mod = MPUnit(offset,LU)
iDisk_mod = iDisk-offset*max_Bytes

! If extension not opened before: open and initiate here!

StdNam = LuName(Lu)
call PrgmTranslate(StdNam,tmp,ltmp)
lStdNam = ltmp
if (Lu_Mod < 0) then
  Lu_Mod = isfreeunit(Lu)
  MPUnit(offset,LU) = Lu_Mod
  temp = 0
  tmp(1+lStdNam:1+lStdNam) = char(start_char+offset)
  iext = strnln(StdNam)
  ext = StdNam
  if (offset <= 9) then
    ext(1+iext:1+iext) = char(start_char+offset)
  else
    ext(1+iext:1+iext) = char(start_char+offset/10)
    ext(2+iext:2+iext) = char(start_char+offset-offset/10*10)
  end if

  iRc = AixOpn(temp,tmp,.false.)
  if (iRc /= 0) then
    iRc = AixErr(Text)
    call SysFileMsg(TheName,'MSG: open',Lu_Mod,Text)
  end if
  isOpen(Lu_Mod) = 1
  FSCB(Lu_Mod) = temp

  !vv LuName(Lu_Mod) = tmp
  LuName(Lu_Mod) = ext
  Addr(Lu_Mod) = 0
  Multi_File(Lu_Mod) = .true.
  MPUnit(0,LU_Mod) = Lu
  MBL(Lu_Mod) = MBL(Lu)

end if

if ((iDisk_mod+n_Bytes) <= max_Bytes) then

  ! The whole record in contained on a single file.

  p_Buf = 1
  n_Copy = lBuf
  call CHDAFILE(LU_mod,iOpt,Buf(p_Buf),n_Copy,iDisk_mod)
else

  ! The record must be split over several files.

  p_Buf = 1
  n_Save = lBuf
  n_Copy = (max_Bytes-iDisk_mod)
  do while (n_Save > 0)
    if (LU_MOD < 0) then
      Lu_Mod = isfreeunit(Lu)
      MPUnit(offset,LU) = Lu_Mod
      temp = 0
      start_char = 48
      if (offset <= 9) then
        start_char = 48
      else
        start_char = 55
      end if

      tmp(1+lStdNam:1+lStdNam) = char(start_char+offset)
      iext = strnln(StdNam)
      ext = StdNam
      if (offset <= 9) then
        ext(1+iext:1+iext) = char(start_char+offset)
      else
        ext(1+iext:1+iext) = char(start_char+offset/10)
        ext(2+iext:2+iext) = char(start_char+offset-offset/10*10)
      end if

      iRc = AixOpn(temp,tmp,.false.)
      if (iRc /= 0) then
        iRc = AixErr(Text)
        call SysFileMsg(TheName,'MSG: open',Lu_Mod,Text)
      end if
      isOpen(Lu_mod) = 1
      FSCB(Lu_mod) = temp

      !vv LuName(Lu_Mod) = tmp
      LuName(Lu_Mod) = ext

      Addr(Lu_Mod) = 0
      Multi_File(Lu_Mod) = .true.
      MPUnit(0,LU_Mod) = Lu
      MBL(Lu_Mod) = MBL(Lu)

    end if
    call CHDAFILE(LU_mod,iOpt,Buf(p_Buf),n_Copy,iDisk_mod)
    p_Buf = p_Buf+n_Copy
    n_Save = n_Save-n_Copy
    n_Copy = min(max_Bytes,n_Save)
    offset = offset+1
    if (offset > MaxSplitFile-1) then
      write(u6,*) '          Current I/O Status as follows'
      write(u6,*)
      call FASTIO('STATUS')
      call SysWarnFileMsg(TheName,StdNam,'Extensions out of range!','increase MOLCAS_DISK value or MaxSplitFile in Fast_IO')
      call Abend()
    end if

    Lu_Mod = MPUnit(offset,LU)
    iDisk_mod = 0
  end do
end if

return

end subroutine MpDaFile

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Print_Input(Title,nSym,nBas,wSet,nSet)
      Implicit Real*8 (a-h,o-z)

#include "mxdm.fh"
#include "mxave.fh"

      Dimension wSet(nSet),nBas(MxSym)
      Character*72 Title
      Parameter (lPaper=132)

      Call Banner(Title,1,lPaper-7)
      Write(6,*)
      Write(6,*)
      Write(6,*)'Number of symmetries:',nSym
      Write(6,*)'Basis functions:',(nBas(iSym),iSym=1,nSym)
      Write(6,*)'Normalized weights:',(wSet(iS),iS=1,nSet)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine construc2_cvb(tconstr)

use casvb_global, only: iconstruc, nconstr, nvb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: tconstr(nvb,nvb)
integer(kind=iwp) :: iconstruc_kp, ivb
real(kind=wp) :: dum(1)
real(kind=wp), allocatable :: repm(:)

iconstruc_kp = iconstruc
iconstruc = 1
call mma_allocate(repm,nvb,label='nvb')

call span0_cvb(nvb,nvb)
do ivb=1,nvb
  repm(:) = Zero
  repm(ivb) = -One
  call symtrizcvb_cvb(repm)
  repm(ivb) = repm(ivb)+One
  call span1_cvb(repm,1,dum,nvb,0)
end do
call span2_cvb(tconstr,nconstr,dum,nvb,0)

call mma_deallocate(repm)
iconstruc = iconstruc_kp

return

end subroutine construc2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Prec_td(pre2,DigPrec,isym)
      use Arrays, only: G1t
*
*     pre2      Preconditioner from Prec
*     DigPrec Output - Diagonal of prec2
*     isym      Symmetry of PT
*
      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
      Real*8 nonzero
      Real*8 DigPrec(*),pre2(*)
      Logical jump
      Real*8, Allocatable:: Dens(:), PreTd(:), TempTd(:)
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*
*---------------------------------------------
* Construct one el density in MO Dens
*---------------------------------------------
*
      nBasTot = 0
      Do iS=1,nSym
         nBasTot = nBasTot + nBas(iS)*nBas(iS)
      End Do
      Call mma_allocate(Dens,nBasTot,Label='Dens')
      Dens(:)=0.0D0
*
      ip3 = 1
      Do iS=1,nSym
          inc = nBas(iS)+1
          call dcopy_(nIsh(iS),[2.0d0],0,Dens(ip3),inc)
          ip3 = ip3 + nBas(iS)*nBas(iS)
      End Do
*
* For a CASSCF wavefunc. From Anders subrut r2elint
* Add the active active dens
*
      Do iS=1,nSym
          Do iB=1,nAsh(iS)
              Do jB=1,nAsh(iS)
                   ip=ipCM(iS)+ib+nIsh(is)+(jB+nIsh(is)-1)*nBas(is)-1
                   iA=nA(is)+ib
                   jA=nA(is)+jb
                   ip2=itri(iA,jA)
                   Dens(ip)=G1t(ip2)
              End Do
           End Do
      End Do
*
C
*      Call RECPRT('Dens',' ',Dens,nBasTot,1)
*      Write(*,*)'Diagnonal elements in D'
*      Do iS=1,nSym
*         Do k=0,nBas(iS)-1
*            Write(*,*) Dens(ipCM(iS) + k*(nBas(iS)+1))
*         End Do
*      End Do
*      Stop
C
*
*-------------------------------------------------------------------
* Construct the diagonal approximation to the orbital prec, PreTd
*-------------------------------------------------------------------
*
      Call mma_allocate(PreTd,nDens2,Label='PreTd')
      PreTd(:)=0.0d0
      ip1 = 1
      ip2 = 1
*      ipsave = 0
      Do iS=1,nSym
         jS=iEOr(iS-1,iSym-1)+1
         nD = nBas(jS) - nIsh(jS)
         Do k=1,nIsh(iS)
            ip1 = ip1 + nIsh(jS)
            Do l=1, nD
               PreTd(ip1) = Pre2(ip2)
               ip1 = ip1 + 1
               ip2 = ip2 + 1
            End Do
         End Do
         nD = nBas(jS) - nAsh(jS)
         Do k=1,nAsh(iS)
            jump = .true.
            Do l=1, nD
               If (l.gt.nIsh(jS).and.jump) Then
                   ip1 = ip1 + nAsh(jS)
                   jump = .false.
               End If
               PreTd(ip1) = Pre2(ip2)
               ip1 = ip1 + 1
               ip2 = ip2 + 1
            End Do
            If ((nBas(jS) - nAsh(jS) - nIsh(jS)).eq.0) Then
               ip1 = ip1 + nAsh(jS)
            End If
         End Do
*         Call RECPRT('PreTd',' ',PreTd(1 + ipsave),
*     &              nBas(jS),nBas(iS))
         ip1 = ip1 + (nBas(iS)-nIsh(iS)-nAsh(iS))*nBas(jS)
*         ipsave = ip1
      End Do
*      Call RECPRT('PreTd',' ',PreTd,nDens2,1)
*
*-----------------------------------------------------------
* Symmetrize PreTd
*-----------------------------------------------------------
      Call mma_allocate(TempTd,nDens2,Label='TempTd')
*
      Do iS=1,nSym
         jS=iEOr(iS-1,iSym-1)+1
         TempTd(:)=0.0d0
         Call Trans(PreTd(ipMat(jS,iS)),nBas(iS),
     &               nBas(jS),TempTd)
         nD = nBas(iS)*nBas(jS)
         Do i=0, nD-1
            nonzero = PreTd(ipMat(iS,jS) +i)
            If (nonzero.ne.0.0d0) Then
                TempTd(1+i) = PreTd(ipMat(iS,jS)+i)
            End If
         End Do
         Call Trans(TempTd,nBas(jS),nBas(iS),
     &              PreTd(ipMat(jS,iS)))
C
      End Do
*
*------------------------------------------------------------------
* Add the density part PreTd_at = PreTd_at - omega(D_aa - D_tt)
*------------------------------------------------------------------
      i = 0
      Do iS=1,nSym
         jS=iEOr(iS-1,iSym-1)+1
         nD = nBas(iS)*nBas(jS)
         j = 0
         l = 0
         Do k=0, nD-1
            If (l.eq.nBas(jS)) l = 0
            If (k.eq.(j+1)*nBas(jS)) j = j +1
C
            i=i+1
            PreTd(i) = PreTd(i) + 2.0D0*Omega*
     &               (  Dens(ipCM(iS) + j*(nBas(iS)+1)) +
     &                  Dens(ipCM(jS) + l*(nBas(jS)+1)) )
C
            l = l + 1
         End Do
C
      End Do
*
*-----------------------------------------------------------------------------
* Symmetry transpose PreTd - To get the same order fo sym as in b_x and
* as required by compress.
*-----------------------------------------------------------------------------
*
      TempTd(:)=0.0d0
*
      Do iS=1,nSym
         jS=iEOr(iS-1,iSym-1)+1
         nD = nBas(iS)*nBas(jS)
         Do k=0, nD-1
            TempTd(ipmat(iS,jS)+k)=PreTd(ipmat(jS,iS)+k)
         End Do
      End Do
*
      Call Compress(TempTd,DigPrec,isym)

      Call mma_deallocate(TempTd)
      Call mma_deallocate(PreTd)
      Call mma_deallocate(Dens)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine OccDef(Occ,mmB,nD,CMO,mBB)
#include "compiler_features.h"
#ifndef POINTER_REMAP
      Use, Intrinsic :: ISO_C_BINDING
#endif
      use OccSets
      use Orb_Type
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
      Real*8 Occ(mmB,nD)
      Real*8, Target::  CMO(mBB,nD)
      Real*8, Pointer, Dimension(:,:):: pCMO
      Real*8, Dimension(:), Allocatable:: OccTmp
      Integer, Allocatable:: iFerm(:)
*
*---- Form occupation numbers
*
*     Note, this puts only in the occupation numbers of the electronic
*     orbitals. The muonic occupation numbers are put in place in
*     NewOrb_Scf on the first iteration.
*
      If (OnlyProp) Return
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Do iD = 1, nD
         Write (6,*) 'iD=',iD
         Write(6,'(a,8i5)') 'sorb: nOcc   ',(nOcc(i,iD),i=1,nSym)
      End Do
      If (Allocated(OccSet_e)) Then
         Do iD = 1, nD
            Write (6,*) 'iD=',iD
            iOff=1
            Do iSym = 1, nSym
               Call RecPrt('OccSet_e',' ',OccSet_e(iOff,iD),1,
     &                       nOcc(iSym,iD))
               iOff = iOff + nOcc(iSym,iD)
            End Do
         End Do
      End If
      If (Allocated(OccSet_m)) Then
         Do iD = 1, nD
            Write (6,*) 'iD=',iD
            iOff=1
            Do iSym = 1, nSym
               Call RecPrt('OccSet_m',' ',OccSet_m(iOff,iD),1,
     &                       nOcc(iSym,iD))
               iOff = iOff + nOcc(iSym,iD)
            End Do
         End Do
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     First we set up the electronic occupation numbers either as
*     by default or as specied by the user. The numbers are stored
*     in the array Occ.
*
      Call FZero(Occ,mmB*nD)
*
      If (Allocated(OccSet_e)) Go To 100
*
*     Deafault is that occupied orbitals are set to 2 and 1
*     for RHF and UHF, respectively.
*
      Do iD = 1, nD
         mOcc=0
         Do iSym = 1,nSym
            Do iOrb = 1, nOcc(iSym,iD)
               Occ(iOrb+mOcc,iD)=DBLE(3-nD) ! Value 2 or 1
            End Do
            mOcc=mOcc+nOrb(iSym)
         End Do
      End Do
      Go To 200
*
 100  Continue
*
*     User define occupation numbers according to the OCCN key word.
*
      Do iD = 1, nD
         mOcc=0
         mSet=0
         Do iSym = 1,nSym
            Do iOrb = 1, nOcc(iSym,iD)
               Occ(iOrb+mOcc,iD)=OccSet_e(iOrb+mSet,iD)
            End Do
            mOcc=mOcc+nOrb(iSym)
            mSet=mSet+nOcc(iSym,iD)
         End Do
      End Do
      call mma_deallocate(OccSet_e)
*
 200  Continue
*                                                                      *
************************************************************************
*                                                                      *
*     Here we put in the occupations from the muons
*
*     Here we will have to run through the orbitals and identify
*     if the orbitals are muonic or electronic. As we proceed we
*     will fill up the vector with the occupation number from
*     the list of either muonic or electronic occupation numbers.
*
      If (Allocated(OccSet_m)) Then
*
         Call mma_Allocate(OccTmp,mmB,Label='OccTmp')
         Call mma_allocate(iFerm,nnB,Label='iFerm')
         Call Get_iArray('Fermion IDs',iFerm,nnB)
*        Write (6,*) 'iFerm=',iFerm
*
         Do iD = 1, nD
*
*           Store the electronic occupation numbers in OccTmp
*
            Call DCopy_(mmB,Occ(1,iD),1,OccTmp,1)
*           Write (6,*) 'OccTmp=',OccTmp
*           Write (6,*) 'Occset_m=',Occset_m
            Call FZero(Occ(1,iD),mmB)
*
            nOcc_e=0     ! number of occupied electronic orbitals
            nOcc_m=0     ! number of occupied muonic orbitals
            iOff = 1     ! Offset to the symmetry sections of CMO
            jEOr = 0     ! Offset to the array with occupation numbers
            Do iSym = 1, nSym
*
*              map the relevant portion of CMO onto pCMO
*
               nB = nBas(iSym)
#ifdef POINTER_REMAP
               pCMO(1:nB,1:nB) => CMO(iOff:iOff+nB**2-1,iD)
#else
               Call C_F_POINTER(C_LOC(CMO(iOff,iD)), pCMO, [nB,nB])
#endif
*
               Do iOrb = 1, nOrb(iSym)  ! Loop over the orbitals
*
*                 Compute identifier which is different from zero
*                 if the orbital is muonic.
*
                  tmp=0.0D0
                  Do k = 1, nB
                     tmp = tmp + DBLE(iFerm(jEOr+k))
     &                         * ABS(pCMO(k,iOrb))
                  End Do
                  Muon_i=0                    ! electronic
                  If (tmp.ne.0.0D0) Muon_i= 1 ! muonic
*
                  If (Muon_i.eq.0) Then
*
*                    The orbital is electronic, put in an
*                    electronic occupation number. If the index
*                    is beyond the number of occupied orbitals
*                    put in a Zero.
*
                     nOcc_e = nOcc_e + 1
                     If (nOcc_e.le.nOcc(iSym,iD)) Then
                        Occ(jEor+iOrb,iD) = OccTmp(jEOr+nOcc_e)
                     Else
                        Occ(jEor+iOrb,iD) = 0.0D0
                     End If
*                    Write (6,*) 'Electronic:',iOrb,Occ(jEOr+iOrb,iD)
*
                  Else If (Muon_i.eq.1) Then
*
*                    The orbital is muonic, put in an
*                    muonic occupation number. If the index
*                    is beyond the number of occupied orbitals
*                    put in a Zero.
*
                     nOcc_m = nOcc_m + 1
                     If (nOcc_m.le.nOcc(iSym,id)) Then
                        Occ(jEor+iOrb,iD) = OccSet_m(jEOr+nOcc_m,iD)
                     Else
                        Occ(jEor+iOrb,iD) = 0.0D0
                     End If
                     OrbType(jEor+iOrb,iD) = 1
*                    Write (6,*) 'Muonic:',iOrb,Occ(jEOr+iOrb,iD)
*
                  End If
*
               End Do
*
               Nullify(pCMO)
               iOff = iOff + nB**2
               jEOr = jEOr + nOrb(iSym)
            End Do ! iSym
*
         End Do    ! iD
*define _SPECIAL_DEBUGPRINT_
#ifdef _SPECIAL_DEBUGPRINT_
         Call DebugCMO(CMO,mBB,nD,Occ,mmB,nBas,nOrb,nSym,iFerm,
     &                 '@ the last position')
#endif
         Call mma_deallocate(iFerm)
         Call mma_deAllocate(OccTmp)
         call mma_deallocate(OccSet_m)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Finally we will have to resort the orbitals with respect to their
*     occupation numbers such that the orbitals which are formally in
*     the occupied space but who are empty are reassigned to being
*     virtuall orbitals.
*
*     This means that the the CMO and Occ arrays will be resorted, and
*     that the nOcc array will be updated with respect to the actual
*     number of orbitals with occupation different from zero, i.e.
*     they are virtual.
*
      Do iD = 1, nD
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
         Write (6,*) 'iD=',iD
         Write (6,*) 'nOccs(original):'
         Write (6,*) (nOcc(iSym,iD),iSym=1,nSym)
         Write (6,*) 'nOV=',nOV
#endif
         iOff=1
         jOff=0
*
         Do iSym = 1, nSym
*
            If (nOrb(iSym).eq.0) Cycle
            iOcc = 0
            Do iOrb = 1, nOrb(iSym)-1
               jOrb = iOrb + 1
               If (Occ(jOrb+jOff,iD).gt.Occ(iOrb+jOff,iD)) Then
*
                  iTmp=OrbType(iOrb+jOff,iD)
                  OrbType(iOrb+jOff,iD)=OrbType(jOrb+jOff,iD)
                  OrbType(jOrb+jOff,iD)=iTmp
*
                  Tmp=Occ(iOrb+jOff,iD)
                  Occ(iOrb+jOff,iD)=Occ(jOrb+jOff,iD)
                  Occ(jOrb+jOff,iD)=Tmp
                  Call DSwap_(nBas(iSym),
     &                        CMO(iOff+(iOrb-1)*nBas(iSym),iD),1,
     &                        CMO(iOff+(jOrb-1)*nBas(iSym),iD),1)
               End If
               If (Occ(iOrb+jOff,iD).ne.0.0D0) iOcc=iOcc+1
            End Do
            If (Occ(nOrb(iSym)+jOff,iD).ne.0.0D0) iOcc=iOcc+1
            nOcc(iSym,iD)=iOcc
*
            jOff=jOff+nOrb(iSym)
            iOff=iOff+nBas(iSym)*nOrb(iSym)
         End Do
#ifdef _DEBUGPRINT_
         Write (6,*) 'iD=',iD
         Write (6,*) 'nOccs(new):'
         Write (6,*) (nOcc(iSym,iD),iSym=1,nSym)
#endif
      End Do
*
*     Sort such that the occupied orbitals are first in each irrep.
*
      Call Sorb2CMOs(CMO,mBB,nD,Occ,mmB,nBas,nOrb,nSym,OrbType)
*                                                                      *
************************************************************************
*                                                                      *
*     Recompute sizes since the nOcc array might have changed.
*
      nOV = 0
      Do iSym = 1, nSym
         If (nD.eq.1) Then
             maxnOcc=nOcc(iSym,1)
             minnOcc=nOcc(iSym,1)
         Else
             maxnOcc=max(nOcc(iSym,1),nOcc(iSym,2))
             minnOcc=min(nOcc(iSym,1),nOcc(iSym,2))
         End If
         nOV    = nOV  + (maxnOcc-nFro(iSym))*
     &                   (nOrb(iSym)-minnOcc)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Do iD = 1, nD
         iOff=1
         jOff=1
         Do iSym = 1, nSym
            Call RecPrt('Occ','(10F6.2)',Occ(iOff,iD),1,nOrb(iSym))
            Call RecPrt('CMO','(10F6.2)',CMO(jOff,iD),
     &                  nBas(iSym),nOrb(iSym))
            Do i = 0, nOrb(iSym)-1
               Write (6,*) 'i,OrbType=',i+1, OrbType(iOff+i,iD)
            End Do
            iOff = iOff + nOrb(iSym)
            jOff = jOff + nOrb(iSym)*nBas(iSym)
         End Do
      End Do
#endif
      Return
      End
#ifdef _SPECIAL_DEBUGPRINT_
      Subroutine DebugCMO(CMO,nCMO,nD,Occ,nnB,nBas,nOrb,nSym,iFerm,
     &                    Label)
      Implicit Real*8 (a-h,o-z)
      Real*8 CMO(nCMO,nD), Occ(nnB,nD)
      Integer nBas(nSym),nOrb(nSym), iFerm(nnB)
      Character*(*) Label
*
      Do iD = 1, nD
         Write (6,*)
         If (iD.eq.1) Then
            If (nD.eq.1) Then
               Write (6,*) ' RHF CMOs'
            Else
               Write (6,*) ' UHF alpha CMOs'
            End If
         Else
            Write (6,*) ' UHF beta CMOs'
         End If
         Write (6,*)
         jOff=0
         iOff=1
         Do iSym = 1, nSym
            Do iOrb = 1, nOrb(iSym)
               tmp=0.0D0
               Do k = 1, nBas(iSym)
                  tmp = tmp + DBLE(iFerm(jOff+k))
     &                      * ABS(CMO(iOff-1+(iOrb-1)*nBas(iSym)+k,iD))
               End Do
               Write (6,*)
               If (tmp.ne.0.0D0) Then
                  Write (6,*) 'Muonic Orbital:',iOrb
               Else
                  Write (6,*) 'Electronic  Orbital:',iOrb
               End If
               Write (6,*) 'Occupation number:',Occ(jOff+iOrb,iD)
               Call RecPrt('CMO',' ',CMO(iOff+(iOrb-1)*nBas(iSym),iD),
     &                      1,nBas(iSym))
            End Do
            jOff = jOff + nOrb(iSym)
            iOff = iOff + nBas(iSym)*nOrb(iSym)
         End Do
      End Do
*
      Return
      End
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine stat_cvb()

use casvb_global, only: cpu0, ipr, n_2el, n_applyh, n_applyt, n_cihess, n_hess, n_orbhess
use Definitions, only: wp, u6

implicit none
real(kind=wp), external :: tim_cvb

if (ipr(3) >= 1) then
  write(u6,'(/,a,i16)') ' Total number of structure transformations :',n_applyt
  write(u6,'(a,i17)') ' Total number of Hamiltonian applications :',n_applyh
  write(u6,'(a,i11)') ' Total number of 2-electron density evaluations :',n_2el
  write(u6,'(a,i21)') ' Total number of Hessian applications :',n_hess
  if (n_orbhess > 0) write(u6,'(a,i8)') ' Total number of pure orbital Hessian applications :',n_orbhess
  if (n_cihess > 0) write(u6,'(a,i13)') ' Total number of pure CI Hessian applications :',n_cihess
  write(u6,'(a,f10.3,a)') ' CASVB at ',tim_cvb(cpu0),' CPU seconds'
  call stat1_cvb()
end if

return

end subroutine stat_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Markus P. Fuelscher                              *
!***********************************************************************

subroutine RdInp_FFPT()
!***********************************************************************
!                                                                      *
!     Objective: Read and interprete input                             *
!                                                                      *
!***********************************************************************
!                                                                      *
!     In order to introduce the ffpt input to the CERIUS2 interface    *
!     the parser had to be changed!                                    *
!     M. Fuelscher, Lund Univeristy, Sweden, February 2000             *
!                                                                      *
!***********************************************************************

use FFPT_Global, only: Atoms, TranCoo, LCumulate, iSelection, Bonds, mLbl, mTit, MxTitL, nSets, MxLbl, Title, ComStk, ComVal, &
                       gLblN, gLblC, gLblW
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u5, u6

implicit none
character(len=20) :: FmtLog
character(len=72) :: Line, Temp1, Temp2
character(len=4) :: Token
integer(kind=iwp) :: i, i1, i2, iCom, iEnd, iSta, j, k, newline, ctrl
real(kind=wp) :: C, W, X, Y, Z
integer(kind=iwp), parameter :: mCom = 11
character(len=*), parameter :: Com(mCom) = ['TITL','DIPO','EFLD','QUAD','OCTU','EFGR','RELA','GLBL','SELE','CUMU','END ']
logical(kind=iwp) :: Op0(9) = .false., Op2(3) = .false., Op3(4) = .false., Op4(8) = .false., Op5(12) = .false., Op6(8) = .false., &
                     skip

LCumulate = .false.

!----------------------------------------------------------------------*
!                                                                      *
!     Start procedure                                                  *
!     Locate "start of input"                                          *
!                                                                      *
!----------------------------------------------------------------------*

call RdNlst(u5,'FFPT')
Temp2 = ' '
Temp1 = ' '
Line = ' &FFPT &END'

!----------------------------------------------------------------------*
!     Initialize counters                                              *
!----------------------------------------------------------------------*

newline = 0
mLbl = 0
mTit = 0

!----------------------------------------------------------------------*
!     Read the input stream line by line and identify key command      *
!----------------------------------------------------------------------*

skip = .false.
mainLoop: do
  if (.not. skip) then
    Temp2 = Temp1
    Temp1 = Line
    read(u5,'(A)',iostat=ctrl) Line
    if (ctrl /= 0) call error(991)
    newline = newline+1
    Line = adjustl(Line)
    if (Line(1:1) == ' ' .or. Line(1:1) == '*') cycle mainLoop
    call StdFmt(Line,Token)
  end if
  skip = .true.

  select case (Token)
    case (Com(1))
      !---  Process the "TITL" command --------------------------------------*

      if (Op0(1)) call error(993)
      Op0(1) = .true.
      ComStk(1,0,0,0) = .true.
      do
        Temp2 = Temp1
        Temp1 = Line
        newline = newline+1
        read(u5,'(A)',iostat=ctrl) Line
        if (ctrl /= 0) call error(991)
        Line = adjustl(Line)
        if (Line(1:1) == ' ' .or. Line(1:1) == '*') cycle
        call StdFmt(Line,Token)
        do iCom=1,mCom
          if (Token == Com(iCom)) cycle mainLoop
        end do
        mTit = mTit+1
        if (mTit <= MxTitL) then
          Title(mTit) = Line
        end if
      end do

    case (Com(2))
      !---  Process the "DIPO" command --------------------------------------*

      if (Op0(2)) call error(993)
      Op0(2) = .true.
      do
        Temp2 = Temp1
        Temp1 = Line
        newline = newline+1
        read(u5,'(A)',iostat=ctrl) Line
        if (ctrl /= 0) call error(991)
        Line = adjustl(Line)
        if (Line(1:1) == ' ' .or. Line(1:1) == '*') cycle
        call UpCase(Line)
        do i=1,len(Line)
          if (Line(i:i) == '=') Line(i:i) = ' '
          if (Line(i:i) == char(9)) Line(i:i) = ' '
        end do
        call StdFmt(Line,Token)
        do iCom=1,mCom
          if (Token == Com(iCom)) cycle mainLoop
        end do
        i1 = 2
        i2 = len(Line)
        select case (Token)
          case ('X')
            if (Op2(1)) call error(993)
            Op2(1) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,1,1,0) = .true.
            ComStk(2,1,1,1) = .true.
            ComVal(2,1,1,1) = W
          case ('Y')
            if (Op2(2)) call error(993)
            Op2(2) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,1,1,0) = .true.
            ComStk(2,1,1,2) = .true.
            ComVal(2,1,1,2) = W
          case ('Z')
            if (Op2(3)) call error(993)
            Op2(3) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,1,1,0) = .true.
            ComStk(2,1,1,3) = .true.
            ComVal(2,1,1,3) = W
          case default
            call error(992)
        end select
      end do

    case (Com(3))
      !---  Process the "EFLD" command --------------------------------------*

      if (Op0(3)) call error(993)
      Op0(3) = .true.
      do
        Temp2 = Temp1
        Temp1 = Line
        newline = newline+1
        read(u5,'(A)',iostat=ctrl) Line
        if (ctrl /= 0) call error(991)
        Line = adjustl(Line)
        if (Line(1:1) == ' ' .or. Line(1:1) == '*') cycle
        call UpCase(Line)
        do i=1,len(Line)
          if (Line(i:i) == '=') Line(i:i) = ' '
          if (Line(i:i) == char(9)) Line(i:i) = ' '
        end do
        call StdFmt(Line,Token)
        do iCom=1,mCom
          if (Token == Com(iCom)) cycle mainLoop
        end do
        i1 = 2
        i2 = len(Line)
        select case (Token)
          case ('X')
            if (Op3(1)) call error(993)
            Op3(1) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,3,1,0) = .true.
            ComStk(2,3,1,1) = .true.
            ComVal(2,3,1,1) = W
          case ('Y')
            if (Op3(2)) call error(993)
            Op3(2) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,3,1,0) = .true.
            ComStk(2,3,1,2) = .true.
            ComVal(2,3,1,2) = W
          case ('Z')
            if (Op3(3)) call error(993)
            Op3(3) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,3,1,0) = .true.
            ComStk(2,3,1,3) = .true.
            ComVal(2,3,1,3) = W
          case ('ORIG')
            if (Op3(4)) call error(993)
            Op3(4) = .true.
            i1 = 5
            read(Line(i1:i2),*,iostat=ctrl) X,Y,Z
            if (ctrl /= 0) call error(991)
            ComStk(2,3,2,0) = .true.
            ComStk(2,3,2,1) = .true.
            ComVal(2,3,2,1) = X
            ComStk(2,3,2,2) = .true.
            ComVal(2,3,2,2) = Y
            ComStk(2,3,2,3) = .true.
            ComVal(2,3,2,3) = Z
          case default
            call error(992)
        end select
      end do

    case (Com(4))
      !---  Process the "QUAD" command --------------------------------------*

      if (Op0(4)) call error(993)
      Op0(4) = .true.
      do
        Temp2 = Temp1
        Temp1 = Line
        newline = newline+1
        read(u5,'(A)',iostat=ctrl) Line
        if (is_iostat_end(ctrl)) call error(991)
        Line = adjustl(Line)
        if (Line(1:1) == ' ' .or. Line(1:1) == '*') cycle
        call UpCase(Line)
        do i=1,len(Line)
          if (Line(i:i) == '=') Line(i:i) = ' '
          if (Line(i:i) == char(9)) Line(i:i) = ' '
        end do
        call StdFmt(Line,Token)
        do iCom=1,mCom
          if (Token == Com(iCom)) cycle mainLoop
        end do
        i1 = 3
        i2 = len(Line)
        select case (Token)
          case ('XX')
            if (Op4(1)) call error(993)
            Op4(1) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,2,1,0) = .true.
            ComStk(2,2,1,1) = .true.
            ComVal(2,2,1,1) = W
          case ('YY')
            if (Op4(2)) call error(993)
            Op4(2) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,2,1,0) = .true.
            ComStk(2,2,1,4) = .true.
            ComVal(2,2,1,4) = W
          case ('ZZ')
            if (Op4(3)) call error(993)
            Op4(3) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,2,1,0) = .true.
            ComStk(2,2,1,6) = .true.
            ComVal(2,2,1,6) = W
          case ('XY')
            if (Op4(4)) call error(993)
            Op4(4) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,2,1,0) = .true.
            ComStk(2,2,1,2) = .true.
            ComVal(2,2,1,2) = W
          case ('XZ')
            if (Op4(5)) call error(993)
            Op4(5) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,2,1,0) = .true.
            ComStk(2,2,1,3) = .true.
            ComVal(2,2,1,3) = W
          case ('YZ')
            if (Op4(6)) call error(993)
            Op4(6) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,2,1,0) = .true.
            ComStk(2,2,1,5) = .true.
            ComVal(2,2,1,5) = W
          case ('RR')
            if (Op4(7)) call error(993)
            Op4(7) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,2,1,0) = .true.
            ComStk(2,2,1,7) = .true.
            ComVal(2,2,1,7) = W
          case ('ORIG')
            if (Op4(8)) call error(993)
            Op4(8) = .true.
            i1 = 5
            read(Line(i1:i2),*,iostat=ctrl) X,Y,Z
            if (ctrl /= 0) call error(991)
            ComStk(2,2,2,0) = .true.
            ComStk(2,2,2,1) = .true.
            ComVal(2,2,2,1) = X
            ComStk(2,2,2,2) = .true.
            ComVal(2,2,2,2) = Y
            ComStk(2,2,2,3) = .true.
            ComVal(2,2,2,3) = Z
          case default
            call error(992)
        end select
      end do

    case (Com(5))
      !---  Process the "OCTU" command --------------------------------------*

      if (Op0(5)) call error(993)
      Op0(5) = .true.
      do
        Temp2 = Temp1
        Temp1 = Line
        newline = newline+1
        read(u5,'(A)',iostat=ctrl) Line
        if (ctrl /= 0) call error(991)
        Line = adjustl(Line)
        if (Line(1:1) == ' ' .or. Line(1:1) == '*') cycle
        call UpCase(Line)
        do i=1,len(Line)
          if (Line(i:i) == '=') Line(i:i) = ' '
          if (Line(i:i) == char(9)) Line(i:i) = ' '
        end do
        call StdFmt(Line,Token)
        do iCom=1,mCom
          if (Token == Com(iCom)) cycle mainLoop
        end do
        i1 = 4
        i2 = len(Line)
        select case (Token)
          case ('XXX')
            if (Op5(1)) call error(993)
            Op5(1) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,1) = .true.
            ComStk(2,6,1,1) = .true.
            ComVal(2,6,1,1) = W
          case ('XYY')
            if (Op5(2)) call error(993)
            Op5(2) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,4) = .true.
            ComStk(2,6,1,4) = .true.
            ComVal(2,6,1,4) = W
          case ('XZZ')
            if (Op5(3)) call error(993)
            Op5(3) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,6) = .true.
            ComStk(2,6,1,6) = .true.
            ComVal(2,6,1,6) = W
          case ('XXY')
            if (Op5(4)) call error(993)
            Op5(4) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,2) = .true.
            ComStk(2,6,1,2) = .true.
            ComVal(2,6,1,2) = W
          case ('YYY')
            if (Op5(5)) call error(993)
            Op5(5) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,7) = .true.
            ComStk(2,6,1,7) = .true.
            ComVal(2,6,1,7) = W
          case ('YZZ')
            if (Op5(6)) call error(993)
            Op5(6) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,9) = .true.
            ComStk(2,6,1,9) = .true.
            ComVal(2,6,1,9) = W
          case ('XXZ')
            if (Op5(7)) call error(993)
            Op5(8) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,3) = .true.
            ComStk(2,6,1,3) = .true.
            ComVal(2,6,1,3) = W
          case ('YYZ')
            if (Op5(9)) call error(993)
            Op5(9) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,8) = .true.
            ComStk(2,6,1,8) = .true.
            ComVal(2,6,1,8) = W
          case ('ZZZ')
            if (Op5(10)) call error(993)
            Op5(10) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,10) = .true.
            ComStk(2,6,1,10) = .true.
            ComVal(2,6,1,10) = W
          case ('XYZ')
            if (Op5(11)) call error(993)
            Op5(11) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,6,1,5) = .true.
            ComStk(2,6,1,5) = .true.
            ComVal(2,6,1,5) = W
          case ('ORIG')
            if (Op5(12)) call error(993)
            Op5(12) = .true.
            i1 = 5
            read(Line(i1:i2),*,iostat=ctrl) X,Y,Z
            if (ctrl /= 0) call error(991)
            ComStk(2,6,2,0) = .true.
            ComStk(2,6,2,1) = .true.
            ComVal(2,6,2,1) = X
            ComStk(2,6,2,2) = .true.
            ComVal(2,6,2,2) = Y
            ComStk(2,6,2,3) = .true.
            ComVal(2,6,2,3) = Z
          case default
            call error(992)
        end select
      end do

    case (Com(6))
      !---  Process the "EFGR" command --------------------------------------*

      if (Op0(6)) call error(993)
      Op0(6) = .true.
      do
        Temp2 = Temp1
        Temp1 = Line
        newline = newline+1
        read(u5,'(A)',iostat=ctrl) Line
        if (ctrl /= 0) call error(991)
        Line = adjustl(Line)
        if (Line(1:1) == ' ' .or. Line(1:1) == '*') cycle
        call UpCase(Line)
        do i=1,len(Line)
          if (Line(i:i) == '=') Line(i:i) = ' '
          if (Line(i:i) == char(9)) Line(i:i) = ' '
        end do
        call StdFmt(Line,Token)
        do iCom=1,mCom
          if (Token == Com(iCom)) cycle mainLoop
        end do
        i1 = 3
        i2 = len(Line)
        select case (Token)
          case ('XX')
            if (Op6(1)) call error(993)
            Op6(1) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,4,1,0) = .true.
            ComStk(2,4,1,1) = .true.
            ComVal(2,4,1,1) = W
          case ('YY')
            if (Op6(2)) call error(993)
            Op6(2) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,4,1,0) = .true.
            ComStk(2,4,1,4) = .true.
            ComVal(2,4,1,4) = W
          case ('ZZ')
            if (Op6(3)) call error(993)
            Op6(3) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,4,1,0) = .true.
            ComStk(2,4,1,6) = .true.
            ComVal(2,4,1,6) = W
          case ('XY')
            if (Op6(4)) call error(993)
            Op6(4) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,4,1,0) = .true.
            ComStk(2,4,1,2) = .true.
            ComVal(2,4,1,2) = W
          case ('XZ')
            if (Op6(5)) call error(993)
            Op6(5) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,4,1,0) = .true.
            ComStk(2,4,1,3) = .true.
            ComVal(2,4,1,3) = W
          case ('YZ')
            if (Op6(6)) call error(993)
            Op6(6) = .true.
            read(Line(i1:i2),*,iostat=ctrl) W
            if (ctrl /= 0) call error(991)
            ComStk(2,4,1,0) = .true.
            ComStk(2,4,1,5) = .true.
            ComVal(2,4,1,5) = W
          case ('ORIG')
            if (Op6(8)) call error(993)
            Op6(8) = .true.
            i1 = 5
            read(Line(i1:i2),*,iostat=ctrl) X,Y,Z
            if (ctrl /= 0) call error(991)
            ComStk(2,4,2,0) = .true.
            ComStk(2,4,2,1) = .true.
            ComVal(2,4,2,1) = X
            ComStk(2,4,2,2) = .true.
            ComVal(2,4,2,2) = Y
            ComStk(2,4,2,3) = .true.
            ComVal(2,4,2,3) = Z
          case default
            call error(992)
        end select
      end do

    case (Com(7))
      !---  Process the "RELA" command --------------------------------------*

      if (Op0(7)) call error(993)
      Op0(7) = .true.
      do
        Temp2 = Temp1
        Temp1 = Line
        newline = newline+1
        read(u5,'(A)',iostat=ctrl) Line
        if (ctrl /= 0) call error(991)
        Line = adjustl(Line)
        if (.not. (Line(1:1) == ' ' .or. Line(1:1) == '*')) exit
      end do
      i1 = 1
      i2 = len(Line)
      read(Line(i1:i2),*,iostat=ctrl) W
      if (ctrl /= 0) call error(991)
      ComStk(2,5,0,0) = .true.
      ComStk(2,5,0,1) = .true.
      ComVal(2,5,0,1) = W
      skip = .false.
      cycle mainLoop

    case (Com(8))
      !---  Process the "GLBL" command --------------------------------------*

      if (Op0(8)) call error(993)
      Op0(8) = .true.
      ComStk(3,0,0,0) = .true.
      do
        Temp2 = Temp1
        Temp1 = Line
        newline = newline+1
        read(u5,'(A)',iostat=ctrl) Line
        if (ctrl /= 0) call error(991)
        Line = adjustl(Line)
        if (Line(1:1) == ' ' .or. Line(1:1) == '*') cycle
        call UpCase(Line)
        call StdFmt(Line,Token)
        do iCom=1,mCom
          if (Token == Com(iCom)) cycle mainLoop
        end do
        i1 = 1
        i2 = len(Line)
        mLbl = mLbl+1
        if (mLbl > MxLbl) call error(994)
        iSta = index(Line,'''')
        Line(i1:iSta) = ' '
        iEnd = index(Line,'''')
        gLblN(mLbl) = Line(iSta+1:iEnd-1)
        Line(i1:iEnd) = ' '
        read(Line(i1:i2),*,iostat=ctrl) C,W
        if (ctrl /= 0) call error(991)
        gLblC(mLbl) = nint(C,kind=iwp)
        gLblW(mLbl) = W
        do i=1,mLbl-1
          if (gLblN(i) == gLblN(mLbl) .and. gLblC(i) == gLblC(mLbl)) call error(993)
        end do
      end do

    case (Com(9))
      !---  Process the "SELE" command --------------------------------------*

      !-- Initialize
      ComStk(4,0,0,0) = .true.
      do
        Temp2 = Temp1
        Temp1 = Line
        newline = newline+1
        read(u5,'(A)',iostat=ctrl) Line
        if (ctrl /= 0) call error(991)
        Line = adjustl(Line)
        if (.not. (Line(1:1) == ' ' .or. Line(1:1) == '*')) exit
      end do
      read(Line,*) nSets
      call mma_allocate(iSelection,2,nSets,label='iSelection')
      call mma_allocate(Atoms,nSets,label='Atoms')
      call mma_allocate(Bonds,nSets,nSets,label='Bonds')
      Atoms(:) = .false.
      Bonds(:,:) = .false.
      do i=1,nSets
        read(u5,*) Atoms(i),iSelection(1,i),iSelection(2,i)
      end do
      do i=2,nSets
        if (i < 10) write(FmtLog,'(A,I1,A)') '(',i-1,'L2)'
        if (i >= 10) write(FmtLog,'(A,I2,A)') '(',i-1,'L2)'
        read(u5,FmtLog) (Bonds(i,j),j=1,i-1)
        do j=1,i-1
          Bonds(j,i) = Bonds(i,j)
        end do
      end do
      read(u5,*) (TranCoo(k),k=1,3)
      !read(u5,*) SiffBond
      skip = .false.
      cycle mainLoop

    case (Com(10))
      !---  Process the "CUMU" command --------------------------------------*

      ! Add the perturbation to the current H0 instead of
      ! to the vacuum H0. This enables multiple FFPT runs after eachother,
      ! useful when using SELE.
      LCumulate = .true.
      skip = .false.
      cycle mainLoop

    case (Com(11))
      !---  Process the "END " command --------------------------------------*

      if (Op0(9)) call error(993)
      Op0(9) = .true.
      !mStk(4,0,0,0) = .true.
      ComStk(5,0,0,0) = .true.
      !---  Check for redunancy in the origin input
      if (ComStk(2,2,2,4) .and. (ComStk(2,2,2,1) .or. ComStk(2,2,2,2) .or. ComStk(2,2,2,3))) call error(996)
      if (ComStk(2,3,2,4) .and. (ComStk(2,3,2,1) .or. ComStk(2,3,2,2) .or. ComStk(2,3,2,3))) call error(996)
      if (ComStk(2,4,2,4) .and. (ComStk(2,4,2,1) .or. ComStk(2,4,2,2) .or. ComStk(2,4,2,3))) call error(996)
      if (ComStk(2,6,2,4) .and. (ComStk(2,6,2,1) .or. ComStk(2,6,2,2) .or. ComStk(2,6,2,3))) call error(996)
      exit mainLoop

    case default
      call error(992)
  end select
end do mainLoop

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

contains

!----------------------------------------------------------------------*
!     Error handling                                                   *
!----------------------------------------------------------------------*
subroutine error(code)

  integer(kind=iwp), intent(in) :: code

  select case (code)
    case (991)
      write(u6,*)
      write(u6,'(2X,A)') 'The program failed to read the input.'
      write(u6,'(2X,A)') 'Please check your input data.'
      write(u6,*)
      write(u6,'(2X,A,I3.3,A)') 'The error occured at line',newline,' after the &FFPT &END line'
      write(u6,'(2X,A,A)') 'The current line is:      ',Line
      write(u6,'(2X,A,A)') 'The previous line is:     ',Temp1
      write(u6,'(2X,A,A)') 'The next previous line is:',Temp2
      call Quit_OnUserError()
    case (992)
      write(u6,*)
      write(u6,'(2X,A)') 'The program has been supplied with an unknown'
      write(u6,'(2X,A)') 'keyword. Please correct your input data.'
      write(u6,*)
      write(u6,'(2X,A,I3.3,A)') 'The error occured at line',newline,' after the &FFPT &END line'
      write(u6,'(2X,A,A)') 'The current line is:      ',Line
      write(u6,'(2X,A,A)') 'The previous line is:     ',Temp1
      write(u6,'(2X,A,A)') 'The next previous line is:',Temp2
      call Quit_OnUserError()
    case (993)
      write(u6,*)
      write(u6,'(2X,A)') 'A command or one of its components has been'
      write(u6,'(2X,A)') 'multiply defined. Please correct your input.'
      write(u6,*)
      write(u6,'(2X,A,I3.3,A)') 'The error occured at line',newline,' after the &FFPT &END line'
      write(u6,'(2X,A,A)') 'The current line is:      ',Line
      write(u6,'(2X,A,A)') 'The previous line is:     ',Temp1
      write(u6,'(2X,A,A)') 'The next previous line is:',Temp2
      call Quit_OnUserError()
    case (994)
      write(u6,*)
      write(u6,'(2X,A)') 'The number of perturbations requested exceeds'
      write(u6,'(2X,A)') 'the internal buffer size. Increase the para-'
      write(u6,'(2X,A)') 'meter MxLbl and recompile the program.'
      call Quit_OnUserError()
    case (996)
      write(u6,*)
      write(u6,'(2X,A)') 'The definition of the origin of an operator '
      write(u6,'(2X,A)') 'is not unique.  Please correct your input.'
    case default
  end select

  call Quit_OnUserError()

end subroutine error

end subroutine RdInp_FFPT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Markus P. Fuelscher                                    *
!               1992,1994, Per Ake Malmqvist                           *
!               2002, Roland Lindh                                     *
!***********************************************************************

!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*
subroutine FOCKTWO(NSYM,NBAS,NFRO,KEEP,W_DLT,W_DSQ,W_FLT,nFlt,W_FSQ,LBUF,X1,X2,ExFac)

use Symmetry_Info, only: Mul
use Data_Structures, only: Allocate_DT, DSBA_Type, Deallocate_DT
use Constants, only: One, Half
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: NSYM, NBAS(8), NFRO(8), KEEP(8), nFlt, LBUF
real(kind=wp), intent(in) :: W_DLT(*), W_DSQ(*), ExFac
real(kind=wp), intent(inout) :: W_FLT(nFlt), W_FSQ(*)
real(kind=wp), intent(out) :: X1(*), X2(*)
integer(kind=iwp) :: IB, IJ, IJB, IJS, IK, IOPT, IP, IPQ, IRC, IS, ISX, ISYM, JB, JK, JQ, JS, KB, KK, KLB, KS, LB, LK, LPQ, LS, &
                     LSMAX, NB, NFI, NFJ, NFK, NFL, NPQ
real(kind=wp) :: TEMP
type(DSBA_Type) :: DLT, DSQ, FLT, FSQ
real(kind=r8), external :: DDOT_

!***********************************************************************
!
! This routine has been nicked from the MOTRA package. It was
! originally written by Marcus Fuelscher, and has been slightly
! modified by P-A Malmqvist 1992-12-04.
! Further modifications by RL 2002-8-30.
! Purpose: Return FLT, which is the effective one-electron
! Hamiltonian when frozen orbitals are removed. It is the
! same as a closed-shell Fock matrix computed using the
! two-electron contribution only from frozen orbitals.
! FLT is returned as symmetry-blocked lower triangles. FSQ
! contains the same matrix, as symmetry-blocked square matrices.
! DSQ and DLT are computed in the calling routine.
! It is assumed that the SEWARD integral file was opened before
! call to this routine.
!
!***********************************************************************

call Allocate_DT(DLT,nBas,nBas,nSym,aCase='TRI',Ref=W_DLT)
call Allocate_DT(FLT,nBas,nBas,nSym,aCase='TRI',Ref=W_FLT)
call Allocate_DT(DSQ,nBas,nBas,nSym,Ref=W_DSQ)
call Allocate_DT(FSQ,nBas,nBas,nSym,Ref=W_FSQ)

do IS=1,NSYM
  IB = NBAS(IS)
  IK = KEEP(IS)
  NFI = NFRO(IS)
  do JS=1,IS
    JB = NBAS(JS)
    JK = KEEP(JS)
    NFJ = NFRO(JS)
    IJS = MUL(IS,JS)
    IJB = IB*JB
    if (IS == JS) IJB = (IB*(IB+1))/2
    do KS=1,IS
      KB = NBAS(KS)
      KK = KEEP(KS)
      NFK = NFRO(KS)
      LSMAX = KS
      if (KS == IS) LSMAX = JS
      LS = MUL(IJS,KS)
      if (LS > LSMAX) cycle
      LB = NBAS(LS)
      LK = KEEP(LS)
      NFL = NFRO(LS)
      KLB = KB*LB
      if (KS == LS) KLB = (KB*(KB+1))/2
      ! INTEGRAL BLOCK EXCLUDED BY SETTING KEEP PARAMETERS?
      if ((IK+JK+KK+LK) /= 0) cycle
      ! NO FROZEN ORBITALS?
      if ((NFI+NFJ+NFK+NFL) == 0) cycle
      ! NO BASIS FUNCTIONS?
      if ((IJB*KLB) == 0) cycle

      if ((IS == JS) .and. (IS == KS)) then
        ! CASE 1: Integrals are of symmetry type (II/II)
        ! Coulomb and exchange terms need to be accumulated
        ! Option code 1: Begin reading at first integral.
        ! NPQ: Nr of submatrices in buffer X1.
        IOPT = 1
        LPQ = 0
        IPQ = 0
        NPQ = 0
        do IP=1,IB
          do JQ=1,IP
            IPQ = IPQ+1
            LPQ = LPQ+1
            if (IPQ > NPQ) then
              call RDORD(IRC,IOPT,IS,JS,KS,LS,X1,LBUF,NPQ)
              if (IRC > 1) call Error(IRC)
              ! Option code 2: Continue reading at next integral.
              IOPT = 2
              IPQ = 1
            end if
            ISX = (IPQ-1)*KLB+1
            TEMP = DDOT_(KLB,X1(ISX),1,DLT%SB(IS)%A1,1)
            FLT%SB(IS)%A1(LPQ) = FLT%SB(IS)%A1(LPQ)+TEMP
            call SQUARE(X1(ISX),X2(1),1,KB,LB)
            call DGEMV_('N',KB,LB,-Half*ExFac,X2(1),KB,DSQ%SB(IS)%A2(1:,IP),1,One,FSQ%SB(IS)%A2(1:,JQ),1)
            if (IP /= JQ) then
              call DGEMV_('N',KB,LB,-Half*ExFac,X2(1),KB,DSQ%SB(IS)%A2(1:,JQ),1,One,FSQ%SB(IS)%A2(1:,IP),1)
            end if
          end do
        end do
      else if ((IS == JS) .and. (IS /= KS)) then
        ! CASE 2: Integrals are of symmetry type (II/JJ)
        ! Coulomb terms need to be accumulated only
        IOPT = 1
        LPQ = 0
        IPQ = 0
        NPQ = 0
        do IP=1,IB
          do JQ=1,IP
            IPQ = IPQ+1
            LPQ = LPQ+1
            if (IPQ > NPQ) then
              call RDORD(IRC,IOPT,IS,JS,KS,LS,X1,LBUF,NPQ)
              if (IRC > 1) call Error(IRC)
              IOPT = 2
              IPQ = 1
            end if
            ISX = (IPQ-1)*KLB+1
            if (NFI /= 0) then
              TEMP = DLT%SB(IS)%A1(LPQ)
              call DAXPY_(KLB,TEMP,X1(ISX),1,FLT%SB(KS)%A1,1)
            end if
            if (NFK /= 0) then
              TEMP = DDOT_(KLB,X1(ISX),1,DLT%SB(KS)%A1,1)
              FLT%SB(IS)%A1(LPQ) = FLT%SB(IS)%A1(LPQ)+TEMP
            end if
          end do
        end do
      else if ((IS == KS) .and. (JS == LS)) then
        ! CASE 3: Integrals are of symmetry type (IJ/IJ)
        ! Exchange terms need to be accumulated only
        IOPT = 1
        LPQ = 0
        IPQ = 0
        NPQ = 0
        do IP=1,IB
          do JQ=1,JB
            IPQ = IPQ+1
            LPQ = LPQ+1
            if (IPQ > NPQ) then
              call RDORD(IRC,IOPT,IS,JS,KS,LS,X1,LBUF,NPQ)
              if (IRC > 1) call Error(IRC)
              IOPT = 2
              IPQ = 1
            end if
            ISX = (IPQ-1)*KLB+1
            if (NFI /= 0) then
              call DGEMV_('N',LB,KB,-Half*ExFac,X1(ISX),LB,DSQ%SB(IS)%A2(1:,IP),1,One,FSQ%SB(JS)%A2(1:,JQ),1)
            end if
            if (NFJ /= 0) then
              call DGEMV_('T',LB,KB,-Half*ExFac,X1(ISX),LB,DSQ%SB(JS)%A2(1:,JQ),1,One,FSQ%SB(IS)%A2(1:,IP),1)
            end if
          end do
        end do
      end if
    end do
  end do
end do

! Accumulate the contributions
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  do IB=1,NB
    do JB=1,IB
      IJ = IB*(IB-1)/2+JB
      FLT%SB(ISYM)%A1(IJ) = FLT%SB(ISYM)%A1(IJ)+FSQ%SB(ISYM)%A2(IB,JB)
    end do
  end do
end do

call GADSum(W_FLT,nFlt)

#ifdef _DEBUGPRINT_
write(u6,'(6X,A)') 'FROZEN FOCK MATRIX IN AO BASIS:'
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  if (NB > 0) then
    write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
    call TRIPRT(' ',' ',FLT%SB(ISYM)%A1,NB)
  end if
end do
#endif
call Deallocate_DT(FSQ)
call Deallocate_DT(DSQ)
call Deallocate_DT(FLT)
call Deallocate_DT(DLT)

return

contains

subroutine Error(IRC)

  integer(kind=iwp), intent(in) :: IRC

  write(u6,*) ' Error return code IRC=',IRC
  write(u6,*) ' from RDORD call, in FTWOI.'
  call Abend()

end subroutine Error

end subroutine FOCKTWO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Compute2IndexIntegrals_11(A,B,tau,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: compute 2-index integrals (J|K) where |J) are auxiliary
C              one-center functions on A and |K) on B.
C
C     tau is the prescreening threshold. Note that the integral
C     prescreening arrays must have been set up before calling this
C     routine.
C
      Implicit None
      Integer A
      Integer B
      Real*8  tau
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "localdf_int3.fh"
#include "ldf_integral_prescreening_info.fh"

      Character*29 SecNam
      Parameter (SecNam='LDF_Compute2IndexIntegrals_11')

      External Int_LDF_2Indx_11

      Integer  LDF_nBasAux_Atom, LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nBasAux_Atom, LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
#if defined (_DEBUGPRINT_)
      Integer  LDF_nAtom
      External LDF_nAtom
#endif

      Real*8 tau2

      Integer nJ, nK
      Integer l_xInt
      Integer nAuxShellA, nAuxShellB
      Integer ipA, ipB
      Integer dShell
      Integer ip_SewWrk, l_SewWrk
      Integer jS, kS
      Integer jShell, kShell
      Integer JK, KJ
      Integer J, K
#if defined (_DEBUGPRINT_)
      Integer M
#endif

      Integer i
      Integer nBasSh
      Real*8  Gmax_A, Gmax_B
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      Gmax_A(i)=Work(iWork(ip_GDiag_1C+2*(A-1)+1)-1+i)
      Gmax_B(i)=Work(iWork(ip_GDiag_1C+2*(B-1)+1)-1+i)

#if defined (_USE_APD_INTEGRALS_)
      If (.True.) Then
         Call WarningMessage(0,SecNam//': Using APD integrals!')
         Call LDF_APD2IndexIntegrals_11(A,B,l_xInt_,xInt)
         Return
      End If
#endif

#if defined (_DEBUGPRINT_)
      If (A.lt.1 .or. A.gt.LDF_nAtom()) Then
         Call WarningMessage(2,SecNam//': A out of bounds!')
         Call LDF_Quit(1)
      End If
      M=LDF_nAuxShell_Atom(A)
      If (iWork(ip_GDiag_1C+2*(A-1)).ne.M) Then
         Call WarningMessage(2,
     &                       SecNam//': GDiag_1C not properly set [A]!')
         Call LDF_Quit(1)
      End If
      If (B.lt.1 .or. B.gt.LDF_nAtom()) Then
         Call WarningMessage(2,SecNam//': B out of bounds!')
         Call LDF_Quit(1)
      End If
      M=LDF_nAuxShell_Atom(B)
      If (iWork(ip_GDiag_1C+2*(B-1)).ne.M) Then
         Call WarningMessage(2,
     &                       SecNam//': GDiag_1C not properly set [B]!')
         Call LDF_Quit(1)
      End If
#endif

      ! Square threshold
      tau2=tau**2

      ! Get number of auxiliary functions on A and B
      nJ=LDF_nBasAux_Atom(A)
      nK=LDF_nBasAux_Atom(B)

      ! Check integral dimension
      l_xInt=nJ*nK
      If (l_xInt.lt.1) Return
      If (l_xInt.gt.l_xInt_) Then
         Call WarningMessage(2,
     &               SecNam//': Insufficient integral array dimension!')
         Call LDF_Quit(1)
      End If

      ! Set row dimension (used for extracting integrals)
      ! Stored in localdf_int3.fh
      nRow=nJ

      ! Get number of aux shells on A,B
      nAuxShellA=LDF_nAuxShell_Atom(A)
      nAuxShellB=LDF_nAuxShell_Atom(B)

      ! Get pointers to aux shell lists on A,B
      ipA=LDF_lAuxShell_Atom(A)-1
      ipB=LDF_lAuxShell_Atom(B)-1

      ! Set dummy shell
      dShell=nShell_Valence+nShell_Auxiliary+1

      ! Allocate Seward memory
      Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
      Call xSetMem_Ints(l_SewWrk)

      ! Compute integrals
      Call Cho_dZero(xInt,l_xInt)
      SHA=dShell
      SHC=dShell
      If (A.eq.B) Then
         iCol0=0
         Do kS=1,nAuxShellB
            kShell=iWork(ipB+kS)
            SHD=kShell
            iRow0=iCol0
            Do jS=kS,nAuxShellA
               jShell=iWork(ipA+jS)
               If (Gmax_A(jS)*Gmax_B(kS).ge.tau2) Then
                  SHB=jShell
                  Call Eval_IJKL(dShell,jShell,dShell,kShell,xInt,
     &                           l_xInt,Int_LDF_2Indx_11)
               End If
               iRow0=iRow0+nBasSh(jShell)
            End Do
            iCol0=iCol0+nBasSh(kShell)
         End Do
         iCol0=nBasSh(iWork(ipB+1))
         Do kS=2,nAuxShellB
            kShell=iWork(ipB+kS)
            iRow0=0
            Do jS=1,kS-1
               jShell=iWork(ipA+jS)
               Do K=iCol0+1,iCol0+nBasSh(kShell)
                  Do J=iRow0+1,iRow0+nBasSh(jShell)
                     JK=nRow*(K-1)+J
                     KJ=nRow*(J-1)+K
                     xInt(JK)=xInt(KJ)
                  End Do
               End Do
               iRow0=iRow0+nBasSh(jShell)
            End Do
            iCol0=iCol0+nBasSh(kShell)
         End Do
      Else
         iCol0=0
         Do kS=1,nAuxShellB
            kShell=iWork(ipB+kS)
            SHD=kShell
            iRow0=0
            Do jS=1,nAuxShellA
               jShell=iWork(ipA+jS)
               If (Gmax_A(jS)*Gmax_B(kS).ge.tau2) Then
                  SHB=jShell
                  Call Eval_IJKL(dShell,jShell,dShell,kShell,xInt,
     &                           l_xInt,Int_LDF_2Indx_11)
               End If
               iRow0=iRow0+nBasSh(jShell)
            End Do
            iCol0=iCol0+nBasSh(kShell)
         End Do
      End If

      ! Release Seward memory
      Call xRlsMem_Ints()

      SHA=0
      SHB=0
      SHC=0
      SHD=0
      nRow=0
      iRow0=0
      iCol0=0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Compute2IndexIntegrals_12(A,CD,tau,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: compute 2-index integrals (J|K) where |J) are auxiliary
C              one-center functions on atom A and |K) are two-center
C              auxiliary functions on atom pair CD.
C
C     tau is the prescreening threshold. Note that the integral
C     prescreening arrays must have been set up before calling this
C     routine.
C
      Implicit None
      Integer A
      Integer CD
      Real*8  tau
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_integral_prescreening_info.fh"

      Character*29 SecNam
      Parameter (SecNam='LDF_Compute2IndexIntegrals_12')

      External Int_LDF_2Indx_12

      Integer  LDF_nBasAux_Pair
      Integer  LDF_nBasAux_Atom, LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nBasAux_Pair
      External LDF_nBasAux_Atom, LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
#if defined (_DEBUGPRINT_)
      Integer  LDF_nAtom
      External LDF_nAtom
#endif

      Real*8 tau2

      Integer nJ, nK
      Integer l_xInt
      Integer nAuxShellA, ipA
      Integer dShell
      Integer ip_SewWrk, l_SewWrk
      Integer klS, kShell, lShell
      Integer jS, jShell
#if defined (_DEBUGPRINT_)
      Integer M
#endif

      Integer i, j
      Integer nBasSh
      Integer AP_2CFunctions
      Integer i2CList
      Real*8  Gmax_A
      Real*8  Gmax_CD
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      i2CList(i,j)=iWork(ip_2CList-1+l_2CList_1*(j-1)+i)
      Gmax_A(i)=Work(iWork(ip_GDiag_1C+2*(A-1)+1)-1+i)
      Gmax_CD(i)=Work(iWork(ip_GDiag_2C+2*(CD-1)+1)-1+i)

#if defined (_USE_APD_INTEGRALS_)
      If (.True.) Then
         Call WarningMessage(0,SecNam//': Using APD integrals!')
         Call LDF_APD2IndexIntegrals_12(A,CD,l_xInt_,xInt)
         Return
      End If
#endif

#if defined (_DEBUGPRINT_)
      If (A.lt.1 .or. A.gt.LDF_nAtom()) Then
         Call WarningMessage(2,SecNam//': A out of bounds!')
         Call LDF_Quit(1)
      End If
      M=LDF_nAuxShell_Atom(A)
      If (iWork(ip_GDiag_1C+2*(A-1)).ne.M) Then
         Call WarningMessage(2,SecNam//': GDiag_1C not properly set!')
         Call LDF_Quit(1)
      End If
      If (CD.lt.1 .or. CD.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,SecNam//': CD out of bounds!')
         Call LDF_Quit(1)
      End If
      If (iWork(ip_GDiag_2C+2*(CD-1)).lt.1) Then
         Call WarningMessage(2,SecNam//': GDiag_2C not properly set!')
         Call LDF_Quit(1)
      End If
#endif

      ! Square threshold
      tau2=tau**2

      ! Get number of auxiliary two-center functions on CD
      nK=AP_2CFunctions(1,CD)
      If (nK.lt.1) Return

      ! Get number of auxiliary one-center functions on A
      nJ=LDF_nBasAux_Atom(A)
      If (nJ.lt.1) Return

      ! Check integral array dimension
      l_xInt=nJ*nK
      If (l_xInt.gt.l_xInt_) Then
         Call WarningMessage(2,
     &               SecNam//': Insufficient integral array dimension!')
         Call LDF_Quit(1)
      End If

      ! Get number of auxiliary shells on A
      nAuxShellA=LDF_nAuxShell_Atom(A)

      ! Get pointer to list of aux shells on A
      ipA=LDF_lAuxShell_Atom(A)-1

      ! Set dummy shell
      dShell=nShell_Valence+nShell_Auxiliary+1

      ! Set column index array including one-center functions.
      ! Set row dimension for integral extraction
      ! Then shift indices to exclude one-center functions.
      Call LDF_SetIndxG(CD)
      nRow_G=nJ
      Call LDF_ColMod(LDF_nBasAux_Pair(CD)-nK)

      ! Allocate Seward memory
      Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
      Call xSetMem_Ints(l_SewWrk)

      ! Compute integrals
      Call Cho_dZero(xInt,l_xInt)
      SHA=dShell
      Do klS=1,l_2CList_2
         kShell=i2CList(1,klS)
         lShell=i2CList(2,klS)
         SPAB=i2CList(3,klS)
         SHC=kShell
         SHD=lShell
         iOffuv=0
         Do jS=1,nAuxShellA
            jShell=iWork(ipA+jS)
            If (Gmax_A(jS)*Gmax_CD(klS).ge.tau2) Then
               SHB=jShell
               Call Eval_IJKL(dShell,jShell,kShell,lShell,xInt,l_xInt,
     &                        Int_LDF_2Indx_12)
            End If
            iOffuv=iOffuv+nBasSh(jShell)
         End Do
      End Do

      ! Release Seward memory
      Call xRlsMem_Ints()

      ! Unset index arrays
      Call LDF_UnsetIndxG()

      SHA=0
      SHB=0
      SHC=0
      SHD=0
      SPAB=0
      SPCD=0
      nRow_G=0
      nRow_uvJ=0
      iOffuv=0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Compute2IndexIntegrals_22(AB,CD,tau,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: compute 2-index integrals (J|K) where |J) are auxiliary
C              two-center functions on atom pair AB and |K) are two-
C              center auxiliary functions on atom pair CD.
C
C     tau is the prescreening threshold. Note that the integral
C     prescreening arrays must have been set up before calling this
C     routine.
C
      Implicit None
      Integer AB
      Integer CD
      Real*8  tau
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "localdf_int2.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_integral_prescreening_info.fh"

      Character*29 SecNam
      Parameter (SecNam='LDF_Compute2IndexIntegrals_22')

      External Int_LDF_JK_2P

      Integer  LDF_nBasAux_Pair
      External LDF_nBasAux_Pair

      Real*8 tau2

      Integer nJ, nK
      Integer l_xInt
      Integer ip_SewWrk, l_SewWrk
      Integer ijS, klS
      Integer iShell, jShell, kShell, lShell
      Integer ii, jj, kk, ll
      Integer ij0, kl0
      Integer ij, kl
      Integer ijkl, klij

      Integer i, j
      Integer nBasSh
      Integer AP_2CFunctions
      Integer iRow
      Integer iCol
      Real*8  Gmax_AB
      Real*8  Gmax_CD
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      iRow(i,j)=iWork(ip_AB_IndxG2-1+l_AB_IndxG2_1*(j-1)+i)
      iCol(i,j)=iWork(ip_CD_IndxG2-1+l_CD_IndxG2_1*(j-1)+i)
      Gmax_AB(i)=Work(iWork(ip_GDiag_2C+2*(AB-1)+1)-1+i)
      Gmax_CD(i)=Work(iWork(ip_GDiag_2C+2*(CD-1)+1)-1+i)

#if defined (_USE_APD_INTEGRALS_)
      If (.True.) Then
         Call WarningMessage(0,SecNam//': Using APD integrals!')
         Call LDF_APD2IndexIntegrals_22(AB,CD,l_xInt_,xInt)
         Return
      End If
#endif

#if defined (_DEBUGPRINT_)
      If (AB.lt.1 .or. AB.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,SecNam//': AB out of bounds!')
         Call LDF_Quit(1)
      End If
      If (iWork(ip_GDiag_2C+2*(AB-1)).lt.1) Then
         Call WarningMessage(2,
     &                      SecNam//': GDiag_2C not properly set [AB]!')
         Call LDF_Quit(1)
      End If
      If (CD.lt.1 .or. CD.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,SecNam//': CD out of bounds!')
         Call LDF_Quit(1)
      End If
      If (iWork(ip_GDiag_2C+2*(CD-1)).lt.1) Then
         Call WarningMessage(2,
     &                      SecNam//': GDiag_2C not properly set [CD]!')
         Call LDF_Quit(1)
      End If
#endif

      ! Square threshold
      tau2=tau**2

      ! Get row and column dimensions
      nJ=AP_2CFunctions(1,AB)
      nK=AP_2CFunctions(1,CD)

      ! Check integral dimension
      l_xInt=nJ*nK
      If (l_xInt.lt.1) Return
      If (l_xInt.gt.l_xInt_) Then
         Call WarningMessage(2,
     &               SecNam//': Insufficient integral array dimension!')
         Call LDF_Quit(1)
      End If

      ! Set indices, redefine row/col dim, and remove one-center
      ! functions
      Call LDF_SetIndx_JK_2P(AB,CD)
      nAB=nJ
      nCD=nK
      Call LDF_ColMod2(LDF_nBasAux_Pair(AB)-nJ,LDF_nBasAux_Pair(CD)-nK)

      ! Allocate memory for Seward
      Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
      Call xSetMem_Ints(l_SewWrk)

      ! Compute integrals
      Call Cho_dZero(xInt,l_xInt)
      If (AB.eq.CD) Then
         Do klS=0,l_CD_2CList_2-1
            kShell=iWork(ip_CD_2CList+3*klS)
            lShell=iWork(ip_CD_2CList+3*klS+1)
            SPCD=iWork(ip_CD_2CList+3*klS+2)
            SHC=kShell
            SHD=lShell
            Do ijS=klS,l_AB_2CList_2-1
               If (Gmax_AB(ijS+1)*Gmax_CD(klS+1).ge.tau2) Then
                  iShell=iWork(ip_AB_2CList+3*ijS)
                  jShell=iWork(ip_AB_2CList+3*ijS+1)
                  SPAB=iWork(ip_AB_2CList+3*ijS+2)
                  SHA=iShell
                  SHB=jShell
                  Call Eval_IJKL(iShell,jShell,kShell,lShell,xInt,
     &                           l_xInt,Int_LDF_JK_2P)
               End If
            End Do
         End Do
         Do klS=1,l_CD_2CList_2-1
            kShell=iWork(ip_CD_2CList+3*klS)
            lShell=iWork(ip_CD_2CList+3*klS+1)
            SPCD=iWork(ip_CD_2CList+3*klS+2)
            Do ijS=0,klS-1
               iShell=iWork(ip_AB_2CList+3*ijS)
               jShell=iWork(ip_AB_2CList+3*ijS+1)
               SPAB=iWork(ip_AB_2CList+3*ijS+2)
               Do ll=1,nBasSh(lShell)
                  kl0=nBasSh(kShell)*(ll-1)
                  Do kk=1,nBasSh(kShell)
                     kl=kl0+kk
                     If (iCol(kl,SPCD).gt.0) Then
                        Do jj=1,nBasSh(jShell)
                           ij0=nBasSh(iShell)*(jj-1)
                           Do ii=1,nBasSh(iShell)
                              ij=ij0+ii
                              If (iRow(ij,SPAB).gt.0) Then
                                 ijkl=nAB*(iCol(kl,SPCD)-1)
     &                               +iRow(ij,SPAB)
                                 klij=nAB*(iRow(ij,SPAB)-1)
     &                               +iCol(kl,SPCD)
                                 xInt(ijkl)=xInt(klij)
                              End If
                           End Do
                        End Do
                     End If
                  End Do
               End Do
            End Do
         End Do
      Else
         Do klS=0,l_CD_2CList_2-1
            kShell=iWork(ip_CD_2CList+3*klS)
            lShell=iWork(ip_CD_2CList+3*klS+1)
            SPCD=iWork(ip_CD_2CList+3*klS+2)
            SHC=kShell
            SHD=lShell
            Do ijS=0,l_AB_2CList_2-1
               If (Gmax_AB(ijS+1)*Gmax_CD(klS+1).ge.tau2) Then
                  iShell=iWork(ip_AB_2CList+3*ijS)
                  jShell=iWork(ip_AB_2CList+3*ijS+1)
                  SPAB=iWork(ip_AB_2CList+3*ijS+2)
                  SHA=iShell
                  SHB=jShell
                  Call Eval_IJKL(iShell,jShell,kShell,lShell,xInt,
     &                           l_xInt,Int_LDF_JK_2P)
               End If
            End Do
         End Do
      End If

      ! Release Seward memory
      Call xRlsMem_Ints()

      ! Unset indices
      Call LDF_UnsetIndx_JK_2P()

      SHA=0
      SHB=0
      SHC=0
      SHD=0
      SPAB=0
      SPCD=0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_ColMod2(MAB,MCD)
      Implicit None
      Integer MAB, MCD
#include "WrkSpc.fh"
#include "localdf_int2.fh"

      Integer i, j, ip0, ij0, ij

      ip0=ip_AB_IndxG2-1
      Do j=1,l_AB_IndxG2_2
         ij0=ip0+l_AB_IndxG2_1*(j-1)
         Do i=1,l_AB_IndxG2_1
            ij=ij0+i
            iWork(ij)=max(iWork(ij)-MAB,0)
         End Do
      End Do

      ip0=ip_CD_IndxG2-1
      Do j=1,l_CD_IndxG2_2
         ij0=ip0+l_CD_IndxG2_1*(j-1)
         Do i=1,l_CD_IndxG2_1
            ij=ij0+i
            iWork(ij)=max(iWork(ij)-MCD,0)
         End Do
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine exchctl( exch, nneq, neqv, neq, nexch, nmax,
     &                    lmax, npair, i_pair, MxRank1, MxRank2,
     &                    imaxrank,
     &                    Jex, JAex, JAex9,
     &                    JDMex, JITOexR, JITOexI, eso, SM,  MM,
     &                    coord, rot, rlg, riso,
     &                    tpar, upar, lant, itype,
     &                    Dipol, AnisoLines1, AnisoLines3, AnisoLines9,
     &                    KE, KEOPT, DM_exchange, JITO_exchange,
     &                    W,  Z,  S,   M, iPrint, mem  )


!     this Subroutine is a control Subroutine for the exchange interaction,
!     diagonalization of total hamiltonian and computation of matrix elements
!     of magnetic and spin moment
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      ! global variables:
      Integer, intent(in)           :: nneq
      Integer, intent(in)           :: neqv ! max of neq(nneq)
      Integer, intent(in)           :: neq(nneq)
      Integer, intent(in)           :: nexch(nneq)
      Integer, intent(in)           :: nmax
      Integer, intent(in)           :: lmax
      Integer, intent(in)           :: npair
      Integer, intent(in)           :: i_pair(npair,2)
      Integer, intent(in)           :: exch
!     ( takes values from 1-7 for Gd-Yb respectively
      Integer, intent(in)           :: lant
      Integer, intent(in)           :: iPrint
      Integer, intent(in)           :: mem ! memory allocated so far
      Integer, intent(in)           :: MxRank1, MxRank2
      Integer, intent(in)           :: imaxrank(npair,2)
      Character(Len=1), intent(in)  :: itype(nneq)

      Real(kind=8), intent(in)     :: eso(nneq,nmax)
      Real(kind=8), intent(in)     :: Jex(npair)
      Real(kind=8), intent(in)     :: JAex(npair,3)
      Real(kind=8), intent(in)     :: JDMex(npair,3)
      Real(kind=8), intent(in)     :: JAex9(npair,3,3)
      Real(kind=8), intent(in)     ::
     &                          JITOexR(nPair,MxRank1,-MxRank1:MxRank1,
     &                                        MxRank2,-MxRank2:MxRank2)
      Real(kind=8), intent(in)     ::
     &                          JITOexI(nPair,MxRank1,-MxRank1:MxRank1,
     &                                        MxRank2,-MxRank2:MxRank2)
      Real(kind=8), intent(in)     :: coord(nneq,3)
      Real(kind=8), intent(in)     :: rot(nneq,neqv,3,3)
      Real(kind=8), intent(in)     :: rlg(nneq,neqv,3,3)
      Real(kind=8), intent(in)     :: riso(nneq,3,3)
      Real(kind=8), intent(in)     :: tpar
      Real(kind=8), intent(in)     :: upar

      Complex(kind=8), intent(inout)  :: SM(nneq,3,nmax,nmax)
      Complex(kind=8), intent(inout)  :: MM(nneq,3,nmax,nmax)

      Logical, intent(in)           :: AnisoLines1
      Logical, intent(in)           :: AnisoLines3
      Logical, intent(in)           :: AnisoLines9
      Logical, intent(in)           :: Dipol
      Logical, intent(in)           :: KE
      Logical, intent(in)           :: DM_exchange
      Logical, intent(in)           :: JITO_exchange




      Real(kind=8), intent(out)    :: W(exch)

      Complex(kind=8), intent(out) :: Z(exch,exch)
      Complex(kind=8), intent(out) :: S(3,exch,exch)
      Complex(kind=8), intent(out) :: M(3,exch,exch)
!------------------------------------------------------------------
      ! local variables
      Integer                       :: i,j,l,lp,lb1,lb2,nb,nb1,nb2,
     &                                 isite,is1,js1,i1,i2,j1,j2,k,
     &                                 ibuf,q1,q2,k1,k2,n1,n2
      Integer                       :: norder
      Integer                       :: NmaxPop
      Integer, allocatable          :: intc(:)   !  intc(lmax)
      Integer, allocatable          :: ibas(:,:) !  ibas(exch,lmax)
      Integer, allocatable          :: icoord(:) !  icoord(lmax)
      Integer, allocatable          :: nind(:,:) !  nind(lmax,2)

      Real(kind=8)                 :: vect(3)
      Real(kind=8)                 :: dist
      Real(kind=8), allocatable    :: wlin(:) ! wlin(exch)
      Real(kind=8), allocatable    :: wlin1(:)! wlin1(exch)
      Real(kind=8), allocatable    :: wlin3(:)! wlin3(exch)
      Real(kind=8), allocatable    :: wlin9(:)! wlin9(exch)
      Real(kind=8), allocatable    :: wdip(:) ! wdip(exch)
      Real(kind=8), allocatable    :: wkex(:) ! wkex(exch)
      Real(kind=8), allocatable    :: wdmo(:) ! wdmo(exch)
      Real(kind=8), allocatable    :: wito(:) ! wito(exch)

      Complex(kind=8), allocatable :: S1(:,:,:) ! S1(3,nmax,nmax)
      Complex(kind=8), allocatable :: M1(:,:,:) ! M1(3,nmax,nmax)
      Complex(kind=8), allocatable :: S2(:,:,:) ! S2(3,nmax,nmax)
      Complex(kind=8), allocatable :: M2(:,:,:) ! M2(3,nmax,nmax)
      Complex(kind=8), allocatable :: ZA1(:,:), ZA2(:,:)
      Complex(kind=8), allocatable :: SM1(:,:,:) ! SM1(3,nmax,nmax)
      Complex(kind=8), allocatable :: MM1(:,:,:) ! MM1(3,nmax,nmax)
      Complex(kind=8), allocatable :: SM2(:,:,:) ! SM2(3,nmax,nmax)
      Complex(kind=8), allocatable :: MM2(:,:,:) ! MM2(3,nmax,nmax)
      Complex(kind=8), allocatable :: HLIN1(:,:,:,:,:)
!                                      HLIN1(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), allocatable :: HLIN3(:,:,:,:,:)
!                                      HLIN3(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), allocatable :: HLIN9(:,:,:,:,:)
!                                      HLIN9(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), allocatable :: HDIP(:,:,:,:,:)
!                                      HDIP(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), allocatable :: HKEX(:,:,:,:,:)
!                                      HKEX(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), allocatable :: HDMO(:,:,:,:,:)
!                                      HDMO(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), allocatable :: HITO(:,:,:,:,:)
!                                      HITO(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), allocatable :: tmp(:,:) ! tmp(exch,exch)
c two options for KE:
      Integer                       :: KEOPT
      Integer, parameter            :: exchR=8
      Integer                       :: nmaxR
      Integer                       :: nsta
      Integer, allocatable          :: nexchR(:)  ! nexchR(nneq)
      Integer, allocatable          :: ibasR(:,:) ! ibasR(exchR,lmax)
      Integer, allocatable          :: intcR(:)   ! intcR(lmax)
      Real(kind=8), allocatable    :: WR(:)  ! WR(exchR)
      Real(kind=8), allocatable    :: rotR(:,:,:,:)
!                                      rotR(nneq,neqv,3,3)
      Complex(kind=8), allocatable :: ZR(:,:) ! ZR(exchR,exchR)
      Complex(kind=8), allocatable :: HKEXR(:,:,:,:,:)
!                                      HKEXR(npair,2,2,2,2)
      Complex(kind=8), allocatable :: MR(:,:,:) ! MR(3,exchR,exchR)
      Complex(kind=8), allocatable :: SR(:,:,:) ! SR(3,exchR,exchR)
      Complex(kind=8), allocatable :: SMR(:,:,:,:) ! SMR(nneq,3,2,2)
      Complex(kind=8), allocatable :: MMR(:,:,:,:) ! MMR(nneq,3,2,2)
c      Complex(kind=8) ::  JAllDip(npair,nmax,-nmax:nmax,nmax,-nmax:nmax)
c      Complex(kind=8) ::  JAllEx( npair,nmax,-nmax:nmax,nmax,-nmax:nmax)
c      Real(kind=8) ::  J1Dip(npair,3,3)
c      Real(kind=8) ::  J1Ex(npair,3,3)
      Real(kind=8)    :: mg1(3,3), mg2(3,3)
      Integer          :: CtoB, RtoB, ItoB, mem_local
      Logical          :: DBG !, testlines
      Real(kind=8)    :: dnrm2_
      External         :: norder, dnrm2_  !,ilaenv

      DBG=.false.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      If(DBG) Then
         Write(6,'(A)') 'Enter EXCHCTL'
         Write(6,'(A,  i8)') 'exch   = ',exch
         Write(6,'(A,  i8)') 'nneq   = ',nneq
         Write(6,'(A,  i8)') 'neqv   = ',neqv
         Write(6,'(A,  i8)') 'nmax   = ',nmax
         Write(6,'(A,  i8)') 'lmax   = ',lmax
         Write(6,'(A,  i8)') 'nPair  = ',nPair
         Write(6,'(A,  i8)') 'nPair  = ',nPair
         Write(6,'(A,  i8)') 'MxRank1= ',MxRank1
         Write(6,'(A,  i8)') 'MxRank2= ',MxRank2
         Write(6,'(A,10i4)') 'neq()  = ',(neq(i),i=1,nneq)
         Write(6,'(A,10i4)') 'nexch()= ',(nexch(i),i=1,nneq)
         Write(6,'(A,  L2)') 'AnisoLines1  = ',AnisoLines1
         Write(6,'(A,  L2)') 'AnisoLines3  = ',AnisoLines3
         Write(6,'(A,  L2)') 'AnisoLines9  = ',AnisoLines9
         Write(6,'(A,  L2)') 'DM_exchange  = ',DM_exchange
         Write(6,'(A,  L2)') 'Dipol        = ',Dipol
         Write(6,'(A,  L2)') 'JITO_exchange= ',JITO_exchange
         If ( AnisoLines1 ) Then
            Do i=1, nPair
              Write(6,'(A,2I4,F10.5)') 'LIN1', i_pair(i,1), i_pair(i,2),
     &                                Jex(i)
            End Do
         End If

         If ( AnisoLines3 ) Then
           Do i=1, nPair
             Write(6,'(A,2I4,3F10.5)') 'LIN3', i_pair(i,1), i_pair(i,2),
     &                              (JAex(i,j),j=1,3)
           End Do
         End If

         If( AnisoLines9 ) Then
           Do i=1, nPair
             Write(6,'(A,2I4,9F10.5)') 'LIN9', i_pair(i,1), i_pair(i,2),
     &                              ((JAex9(i,j,k),j=1,3),k=1,3)
           End Do
         End If

         If(DM_exchange) Then
            Do i=1,nPair
           Write(6,'(A,2I4,3F10.5)') 'DMEX', i_pair(i,1), i_pair(i,2),
     &                              (JDMex(i,j),j=1,3)
            End Do
         End If

         If(Dipol) Then
         Write(6,'(A)') 'COORD(i):'
           Do i=1,nneq
              Write(6,'(i3,3F14.8)') i, (coord(i,j),j=1,3)
           End Do
         End If

         If(JITO_exchange) Then
            Do i=1,nPair
           Write(6,'(A,4I4,3F10.5)') 'ITOJ', i_pair(i,1), i_pair(i,2),
     &                          imaxrank(i,1),imaxrank(i,2)
              Do k1=1,imaxrank(i,1),2
               Do q1=-k1,k1
                Do k2=1,imaxrank(i,2),2
                 Do q2=-k2,k2
                  Write(6,'(4I3,2x,2ES21.14)') k1,q1,k2,q2,
     &                JITOexR(i,k1,q1,k2,q2), JITOexI(i,k1,q1,k2,q2)
                 End Do
                End Do
               End Do
              End Do
            End Do ! ipair
         End If

         Write(6,'(A)') 'ESO(i):'
         Do i=1,nneq
            Write(6,'(i3,90F14.8)') i, (eso(i,j),j=1,nmax)
         End Do
         Write(6,'(90A)') 'itype()=', (itype(i),' ',i=1,nneq)

         Write(6,'(A,  i8)') 'neqv   = ',neqv
         Do i=1, nneq
         Write(6,'(A,  i8)') 'riso( site=',i,'):'
            Do j=1,3
              Write(6,'(3ES22.14)') (riso(i,j,k),k=1,3)
            End Do
         End Do
      End If ! dbg
!-----------------------------------------------------------------------
! allocate memory for this function:
      ItoB=8
      RtoB=8
      CtoB=16
      mem_local=0
      If(lmax>=0) Then
        ! exchange energy spectrum
        Call mma_allocate(intc,lmax,'intc')
        Call mma_allocate(icoord,lmax,'icoord')
        Call mma_allocate(nind,lmax,2,'nind')
        Call icopy(lmax,[0],0,intc,1)
        Call icopy(lmax,[0],0,icoord,1)
        Call icopy(2*lmax,[0],0,nind,1)
        mem_local=mem_local+4*lmax*ItoB
        If(exch>=0) Then
          Call mma_allocate(ibas,exch,lmax,'ibas')
          Call icopy(exch*lmax,[0],0,ibas,1)
          mem_local=mem_local+exch*lmax*ItoB
        End If
      End If
      If(exch>=0) Then
        Call mma_allocate(wlin ,exch,'wlin ')
        Call mma_allocate(wlin1,exch,'wlin1')
        Call mma_allocate(wlin3,exch,'wlin3')
        Call mma_allocate(wlin9,exch,'wlin9')
        Call mma_allocate(wdip ,exch,'wdip ')
        Call mma_allocate(wkex ,exch,'wkex ')
        Call mma_allocate(wdmo ,exch,'wdmo ')
        Call mma_allocate(wito ,exch,'wito ')
        Call dcopy_(exch,[0.0_wp],0,wlin ,1)
        Call dcopy_(exch,[0.0_wp],0,wlin1,1)
        Call dcopy_(exch,[0.0_wp],0,wlin3,1)
        Call dcopy_(exch,[0.0_wp],0,wlin9,1)
        Call dcopy_(exch,[0.0_wp],0,wdip ,1)
        Call dcopy_(exch,[0.0_wp],0,wkex ,1)
        Call dcopy_(exch,[0.0_wp],0,wdmo ,1)
        Call dcopy_(exch,[0.0_wp],0,wito ,1)
        mem_local=mem_local+8*exch*RtoB
      End If
      If(nmax>=0) Then
        Call mma_allocate( S1,3,nmax,nmax,' S1')
        Call mma_allocate( M1,3,nmax,nmax,' M1')
        Call mma_allocate( S2,3,nmax,nmax,' S2')
        Call mma_allocate( M2,3,nmax,nmax,' M2')
        Call mma_allocate( ZA1, nmax,nmax,' Z1')
        Call mma_allocate( ZA2, nmax,nmax,' Z2')
        Call mma_allocate(SM1,3,nmax,nmax,'SM1')
        Call mma_allocate(SM2,3,nmax,nmax,'SM2')
        Call mma_allocate(MM1,3,nmax,nmax,'MM1')
        Call mma_allocate(MM2,3,nmax,nmax,'MM2')
        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0, S1,1)
        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0, M1,1)
        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0, S2,1)
        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0, M2,1)
        Call zcopy_(  nmax*nmax,[(0.0_wp,0.0_wp)],0, ZA1,1)
        Call zcopy_(  nmax*nmax,[(0.0_wp,0.0_wp)],0, ZA2,1)
        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0,SM1,1)
        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0,SM2,1)
        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0,MM1,1)
        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0,MM2,1)
        mem_local=mem_local+8*3*nmax*nmax*CtoB

        If(npair>=0) Then
          ibuf=npair*nmax*nmax*nmax*nmax
          Call mma_allocate(HLIN1,npair,nmax,nmax,nmax,nmax,'HLIN1')
          Call mma_allocate(HLIN3,npair,nmax,nmax,nmax,nmax,'HLIN3')
          Call mma_allocate(HLIN9,npair,nmax,nmax,nmax,nmax,'HLIN9')
          Call mma_allocate(HDIP,npair,nmax,nmax,nmax,nmax,'HDIP')
          Call mma_allocate(HKEX,npair,nmax,nmax,nmax,nmax,'HKEX')
          Call mma_allocate(HDMO,npair,nmax,nmax,nmax,nmax,'HDMO')
          Call mma_allocate(HITO,npair,nmax,nmax,nmax,nmax,'HITO')
          Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HLIN1,1)
          Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HLIN3,1)
          Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HLIN9,1)
          Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HDIP,1)
          Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HKEX,1)
          Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HDMO,1)
          Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HITO,1)
          mem_local=mem_local+7*ibuf*CtoB
        End If
      End If

      If(exch>=0) Then
        Call mma_allocate(tmp,exch,exch,'tmp')
        Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,tmp,1)
        mem_local=mem_local+exch*exch*CtoB
      End If


      If(nneq>=0) Then
        Call mma_allocate(nexchR,nneq,'nexchR')
        Call icopy( nneq,[0],0,nexchR,1)
        mem_local=mem_local+nneq*ItoB

        Call mma_allocate(SMR,nneq,3,2,2,'SMR')
        Call mma_allocate(MMR,nneq,3,2,2,'MMR')
        Call zcopy_(nneq*3*2*2,[(0.0_wp,0.0_wp)],0,SMR,1)
        Call zcopy_(nneq*3*2*2,[(0.0_wp,0.0_wp)],0,MMR,1)
        mem_local=mem_local+2*nneq*3*2*2*CtoB

        If(neqv>=0) Then
          Call mma_allocate(rotR,nneq,neqv,3,3,'rotR')
          Call dcopy_(nneq*neqv*3*3,[0.0_wp],0,rotR,1)
          mem_local=mem_local+nneq*neqv*3*3*RtoB
        End If
      End If

      If(exchR>=0) Then
        If(lmax>=0) Then
          Call mma_allocate(ibasR,nneq,lmax,'ibasR')
          Call icopy( nneq*lmax,[0],0,ibasR,1)
          mem_local=mem_local+nneq*lmax*ItoB
        End If
        Call mma_allocate(WR,exchR,'WR')
        Call dcopy_(exchR,[0.0_wp],0,WR,1)
        mem_local=mem_local+exchR*RtoB

        Call mma_allocate(ZR,exchR,exchR,'ZR')
        Call mma_allocate(MR,3,exchR,exchR,'MR')
        Call mma_allocate(SR,3,exchR,exchR,'SR')
        Call zcopy_(  exchR*exchR,[(0.0_wp,0.0_wp)],0,ZR,1)
        Call zcopy_(3*exchR*exchR,[(0.0_wp,0.0_wp)],0,MR,1)
        Call zcopy_(3*exchR*exchR,[(0.0_wp,0.0_wp)],0,SR,1)
        mem_local=mem_local+7*exchR*exchR*CtoB
      End If

      If(npair>=0) Then
        Call mma_allocate(HKEXR,npair,2,2,2,2,'HKEXR')
        Call zcopy_(npair*2*2*2*2,[(0.0_wp,0.0_wp)],0,HKEXR,1)
        mem_local=mem_local+npair*2*2*2*2*CtoB
      End If

      If(lmax>=0) Then
        Call mma_allocate(intcR,lmax,'intcR')
        Call icopy(lmax,[0],0,intcR,1)
        mem_local=mem_local+lmax*ItoB
      End If
      If(dbg) Write(6,*) 'EXCHCTL:  memory allocated (local):'
      If(dbg) Write(6,*) 'mem_local=', mem_local
      If(dbg) Write(6,*) 'EXCHCTL:  memory allocated (total):'
      If(dbg) Write(6,*) 'mem_total=', mem+mem_local
!-----------------------------------------------------------------------
      l=0
      Do i=1,nneq
        Do j=1,neq(i)
          l=l+1
          nind(l,1)=i
          nind(l,2)=j
        End Do
      End Do
      intc(1)=1
      If (lmax.gt.1) Then
        Do i=2,lmax
          isite=nind(i-1, 1)
          intc(i)=intc(i-1)*nexch(isite)
        End Do
      End If
      Do nb=1,exch
        nb1=nb-1
        Do i=1,lmax
          ibas(nb, lmax-i+1)= nb1 / intc(lmax-i+1)
          nb1=nb1-ibas(nb,lmax-i+1)*intc(lmax-i+1)
        End Do
      End Do
      If(dbg) Then
        Write(6,'(34x,A,1x,20i3)')  'site Nr.', (i,i=1,lmax)
        Do nb=1,exch
          Write(6,'(A,i5,A,20i3)') 'COUPLING: basis set:  ibas(',nb,
     &                             ' ,isite) = ',(ibas(nb,i)+1,i=1,lmax)
        End Do
      End If ! dbg

!-----------------------------------------------------------------------
! Lines model of magnetic couping  -- 1 parameter
      If ( AnisoLines1 ) Then
       If(nPair>0) Then
       Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HLIN1,1)
       Do lp=1, npair
        lb1=i_pair(lp,1)
        lb2=i_pair(lp,2)
        i1=nind(lb1,1) ! indices of non-equivalent sites
        i2=nind(lb2,1) ! indices of non-equivalent sites
        j1=nind(lb1,2) ! indices of equivalent sites
        j2=nind(lb2,2) ! indices of equivalent sites

        n1=nexch(i1)
        n2=nexch(i2)

        ! find local pseudospin and rotate the spin and magnetic moment
        ! to the local pseudospin basis
        If(itype(i1)=='A') Then
         Call prep_mom_exchange( n1, rot(i1,j1,1:3,1:3),
     &                           SM(i1,1:3,1:n1,1:n1),
     &                           MM(i1,1:3,1:n1,1:n1), mg1, .true. )
        End If
        If(itype(i2)=='A') Then
         Call prep_mom_exchange( n2, rot(i2,j2,1:3,1:3),
     &                           SM(i2,1:3,1:n2,1:n2),
     &                           MM(i2,1:3,1:n2,1:n2), mg2, .true. )
        End If

        !If(dbg)
        Call prMom('SM(i1) bf Lines1',SM(i1,1:3,1:n1,1:n1),n1)
        !If(dbg)
        Call prMom('SM(i2) bf Lines1',SM(i2,1:3,1:n2,1:n2),n2)

        ! build the Lines exchange matrix:
        Call Lines_Exchange( Jex(lp), n1, n2,
     &                       SM(i1,1:3,1:n1,1:n1),
     &                       SM(i2,1:3,1:n2,1:n2),
     &              HLIN1(lp,1:n1,1:n1,1:n2,1:n2) )

        If(dbg) Then
         Call prMom('SM(i1) af Lines1',SM(i1,1:3,1:n1,1:n1),n1)
         Call prMom('SM(i2) af Lines1',SM(i2,1:3,1:n2,1:n2),n2)
         Write(6,'(A,i2)') 'Exchange matrix for pair = ',lp
         Write(6,'(A,i2)') 'in local pseudospin basis'
         Do i=1,n1
          Do j=1,n1
           Do k=1,n2
            Do l=1,n2
              Write(6,'(4(a,i2),a,2ES24.14)')
     &         'HLIN1(',i,',',j,',',k,',',l,') = ',HLIN1(lp,i,j,k,l)
            End Do
           End Do
          End Do
         End Do
        End If! dbg

       End Do
       End If ! nPair
      End If
!-----------------------------------------------------------------------





      ! Anisotropic Lines model of magnetic couping -- 3 parameters)
      ! Jxx, Jyy, Jzz
      If (AnisoLines3 ) Then
       If(nPair>0) Then
       Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HLIN3,1)
       Do lp=1, npair
        lb1=i_pair(lp,1)
        lb2=i_pair(lp,2)
        i1=nind(lb1,1) ! indices of non-equivalent sites
        i2=nind(lb2,1) ! indices of non-equivalent sites
        j1=nind(lb1,2) ! indices of equivalent sites
        j2=nind(lb2,2) ! indices of equivalent sites

        n1=nexch(i1)
        n2=nexch(i2)

        ! find local pseudospin and rotate the spin and magnetic moment
        ! to the local pseudospin basis
        If(itype(i1)=='A') Then
         Call prep_mom_exchange( n1, rot(i1,j1,1:3,1:3),
     &                            SM(i1,1:3,1:n1,1:n1),
     &                            MM(i1,1:3,1:n1,1:n1), mg1, dbg )
        End If

        If(itype(i2)=='A') Then
         Call prep_mom_exchange( n2, rot(i2,j2,1:3,1:3),
     &                            SM(i2,1:3,1:n2,1:n2),
     &                            MM(i2,1:3,1:n2,1:n2), mg2, dbg )
        End If

        Call Aniso_Lines_Exchange3( JAex(lp,1:3), n1, n2,
     &                              SM(i1,1:3,1:n1,1:n1),
     &                              SM(i2,1:3,1:n2,1:n2),
     &                     HLIN3(lp,1:n1,1:n1,1:n2,1:n2) )

        If(dbg) Then
         Write(6,'(A,i2)') 'Exchange matrix for pair = ',lp
         Do i=1,n1
          Do j=1,n1
           Do k=1,n2
            Do l=1,n2
              Write(6,'(4(a,i2),a,2ES24.14)')
     &         'HLIN3(',i,',',j,',',k,',',l,') = ',HLIN3(lp,i,j,k,l)
            End Do
           End Do
          End Do
         End Do
        End If ! dbg

       End Do ! lp
       End If ! nPair
      End If
!-----------------------------------------------------------------------




      ! Anisotropic Lines model of magnetic couping -- 9 parameters)
      ! Jxx, Jxy, Jxz, Jyx, Jyy, Jyz, Jzx, Jzy, Jzz
      If ( AnisoLines9 ) Then
       If(nPair>0) Then
       Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HLIN9,1)
       Do lp=1, npair
        lb1=i_pair(lp,1)
        lb2=i_pair(lp,2)
        i1=nind(lb1,1) ! indices of non-equivalent sites
        i2=nind(lb2,1) ! indices of non-equivalent sites
        j1=nind(lb1,2) ! indices of equivalent sites
        j2=nind(lb2,2) ! indices of equivalent sites

        n1=nexch(i1)
        n2=nexch(i2)

        ! find local pseudospin and rotate the spin and magnetic moment
        ! to the local pseudospin basis
        If(itype(i1)=='A') Then
         Call prep_mom_exchange( n1, rot(i1,j1,1:3,1:3),
     &                            SM(i1,1:3,1:n1,1:n1),
     &                            MM(i1,1:3,1:n1,1:n1), mg1, dbg )
        End If
        If(itype(i2)=='A') Then
         Call prep_mom_exchange( n2, rot(i2,j2,1:3,1:3),
     &                            SM(i2,1:3,1:n2,1:n2),
     &                            MM(i2,1:3,1:n2,1:n2), mg2, dbg )
        End If
        ! rotate the input J matrix by the mg1 and mg2
        If(dbg) Call prMom('SM(i1) bf Lines9',SM(i1,1:3,1:n1,1:n1),n1)
        If(dbg) Call prMom('SM(i2) bf Lines9',SM(i2,1:3,1:n2,1:n2),n2)


        Call Aniso_Lines_Exchange9( JAex9(lp,1:3,1:3), n1, n2,
     &                              SM(i1,1:3,1:n1,1:n1),
     &                              SM(i2,1:3,1:n2,1:n2),
     &                     HLIN9(lp,1:n1,1:n1,1:n2,1:n2) )


        If(dbg) Then
         Call prMom('SM(i1) af Lines9',SM(i1,1:3,1:n1,1:n1),n1)
         Call prMom('SM(i2) af Lines9',SM(i2,1:3,1:n2,1:n2),n2)
         Write(6,'(A,i2)') 'Exchange matrix for pair = ',lp
         Do i=1,n1
          Do j=1,n1
           Do k=1,n2
            Do l=1,n2
              Write(6,'(4(a,i2),a,2ES24.14)')
     &         'HLIN9(',i,',',j,',',k,',',l,') = ',HLIN9(lp,i,j,k,l)
            End Do
           End Do
          End Do
         End Do
        End If! dbg

       End Do
       End If ! nPair
      End If



!-----------------------------------------------------------------------
!     dipolar couping
      If(Dipol) Then
       If(nPair>0) Then
       Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HDIP,1)
       Do lp=1,npair
        lb1=i_pair(lp,1)
        lb2=i_pair(lp,2)
        i1=nind(lb1,1) ! indices of non-equivalent sites
        i2=nind(lb2,1) ! indices of non-equivalent sites
        j1=nind(lb1,2) ! indices of equivalent sites
        j2=nind(lb2,2) ! indices of equivalent sites

        n1=nexch(i1)
        n2=nexch(i2)

        vect(1:3)=0.0_wp
        dist=0.0_wp
        Call dirvect( coord(i1,1:3), rlg(i1,j1,1:3,1:3),
     &                coord(i2,1:3), rlg(i2,j2,1:3,1:3),
     &                vect(1:3), dist )
        If(DBG) Write(6,'(A,i3,3ES20.12,2x,ES20.12)')
     &                  'EXCHCTL: DIPOL: lp, vect, R:',
     &                                   lp,(vect(i),i=1,3), dist
        ! find local pseudospin and rotate the spin and magnetic moment
        ! to the local pseudospin basis
        If(itype(i1)=='A') Then
         Call prep_mom_exchange( n1, rot(i1,j1,1:3,1:3),
     &                            SM(i1,1:3,1:n1,1:n1),
     &                            MM(i1,1:3,1:n1,1:n1), mg1, dbg )
        End If
        If(itype(i2)=='A') Then
         Call prep_mom_exchange( n2, rot(i2,j2,1:3,1:3),
     &                            SM(i2,1:3,1:n2,1:n2),
     &                            MM(i2,1:3,1:n2,1:n2), mg2, dbg )
        End If

        Call Dipol_Exchange( n1, n2, vect(1:3), dist,
     &                       MM(i1,1:3,1:n1,1:n1),
     &                       MM(i2,1:3,1:n2,1:n2),
     &               HDIP(lp,1:n1,1:n1,1:n2,1:n2) )

        If(dbg) Then
         Write(6,'(A,i2)') 'Exchange matrix for pair = ',lp
         Do i=1,n1
          Do j=1,n1
           Do k=1,n2
            Do l=1,n2
              Write(6,'(4(a,i2),a,2ES24.14)')
     &         'HDIP (',i,',',j,',',k,',',l,') = ',HDIP(lp,i,j,k,l)
            End Do
           End Do
          End Do
         End Do
        End If ! dbg

       End Do ! lp
       End If
      End If
!-----------------------------------------------------------------------





!     Dzyaloshinsky-Morya antisymmetric couping
      If(DM_exchange) Then
       If(nPair>0) Then
       Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HDMO,1)
       Do lp=1,npair
        lb1=i_pair(lp,1)
        lb2=i_pair(lp,2)
        i1=nind(lb1,1) ! indices of non-equivalent sites
        i2=nind(lb2,1) ! indices of non-equivalent sites
        j1=nind(lb1,2) ! indices of equivalent sites
        j2=nind(lb2,2) ! indices of equivalent sites

        n1=nexch(i1)
        n2=nexch(i2)
        ! find local pseudospin and rotate the spin and magnetic moment
        ! to the local pseudospin basis
        If(itype(i1)=='A') Then
         Call prep_mom_exchange( n1, rot(i1,j1,1:3,1:3),
     &                            SM(i1,1:3,1:n1,1:n1),
     &                            MM(i1,1:3,1:n1,1:n1), mg1, dbg )
        End If
        If(itype(i2)=='A') Then
         Call prep_mom_exchange( n2, rot(i2,j2,1:3,1:3),
     &                            SM(i2,1:3,1:n2,1:n2),
     &                            MM(i2,1:3,1:n2,1:n2), mg2, dbg )
        End If

        Call Dzyaloshinsky_Morya_Exchange( JDMex(lp,1:3), n1, n2,
     &                                     SM(i1,1:3,1:n1,1:n1),
     &                                     SM(i2,1:3,1:n2,1:n2),
     &                             HDMO(lp,1:n1,1:n1,1:n2,1:n2) )
        If(dbg) Then
         Write(6,'(A,i2)') 'Exchange matrix for pair = ',lp
         Do i=1,n1
          Do j=1,n1
           Do k=1,n2
            Do l=1,n2
              Write(6,'(4(a,i2),a,2ES24.14)')
     &         'HDMO (',i,',',j,',',k,',',l,') = ',HDMO(lp,i,j,k,l)
            End Do
           End Do
          End Do
         End Do
        End If! dbg

       End Do
       End If ! nPair
      End If
!-----------------------------------------------------------------------




!     JITO exchange interaction
      If(JITO_exchange) Then
       If(dbg) Write(6,'(A)') 'EXCHCTL:  Enterring  JITO_exchange'
       If(nPair>0) Then
       Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,HITO,1)
       Do lp=1,npair
        lb1=i_pair(lp,1)
        lb2=i_pair(lp,2)
        i1=nind(lb1,1) ! indices of non-equivalent sites
        i2=nind(lb2,1) ! indices of non-equivalent sites
        j1=nind(lb1,2) ! indices of equivalent sites
        j2=nind(lb2,2) ! indices of equivalent sites

        n1=nexch(i1)
        n2=nexch(i2)
        ! find local pseudospin and rotate the spin and magnetic moment
        ! to the local pseudospin basis
        If(itype(i1)=='A') Then
         Call prep_mom_exchange( n1, rot(i1,j1,1:3,1:3),
     &                            SM(i1,1:3,1:n1,1:n1),
     &                            MM(i1,1:3,1:n1,1:n1), mg1, dbg )
        End If
        If(itype(i2)=='A') Then
         Call prep_mom_exchange( n2, rot(i2,j2,1:3,1:3),
     &                            SM(i2,1:3,1:n2,1:n2),
     &                            MM(i2,1:3,1:n2,1:n2), mg2, dbg )
        End If

        ! using Naoya's ITO:, in general coordinate system
        Call JITO_Exchange_Int( MxRank1, MxRank2, imaxrank(lp,1:2),
     &                          n1, n2,
     &                    JITOexR(lp,1:MxRank1,-MxRank1:MxRank1,
     &                               1:MxRank2,-MxRank2:MxRank2 ),
     &                    JITOexI(lp,1:MxRank1,-MxRank1:MxRank1,
     &                               1:MxRank2,-MxRank2:MxRank2 ),
     &                    HITO(lp,1:n1,1:n1,1:n2,1:n2) )
        If(dbg) Then
         Write(6,'(A,i2)') 'Exchange matrix for pair = ',lp
         Do i=1,n1
          Do j=1,n1
           Do k=1,n2
            Do l=1,n2
              Write(6,'(4(a,i2),a,2ES24.14)')
     &         'HITO (',i,',',j,',',k,',',l,') = ',HITO(lp,i,j,k,l)
            End Do
           End Do
          End Do
         End Do
        End If! dbg

       End Do
       End If ! nPair
       If(dbg) Write(6,'(A)') 'EXCHCTL:  Exiting JITO_exchange'
      End If
!-----------------------------------------------------------------------











      If (KE) Then
        If (nPair>0) Then
        HKEX=(0.0_wp,0.0_wp)
        HKEX=(0.0_wp,0.0_wp)
        HKEXR=(0.0_wp,0.0_wp)
        MMR=(0.0_wp,0.0_wp)
        SMR=(0.0_wp,0.0_wp)
        Do lp=1,npair
          lb1=i_pair(lp,1)
          lb2=i_pair(lp,2)
          i1=nind(lb1,1) ! indices of non-equivalent sites
          i2=nind(lb2,1) ! indices of non-equivalent sites
          j1=nind(lb1,2) ! indices of equivalent sites
          j2=nind(lb2,2) ! indices of equivalent sites

          n1=nexch(i1)
          n2=nexch(i2)
          Call zcopy_(3*n1*n1,[(0.0_wp,0.0_wp)],0, S1,1)
          Call zcopy_(3*n2*n2,[(0.0_wp,0.0_wp)],0, S2,1)
          Call zcopy_(3*n1*n1,[(0.0_wp,0.0_wp)],0, M1,1)
          Call zcopy_(3*n2*n2,[(0.0_wp,0.0_wp)],0, M2,1)
          Call rotmom2( MM(i1,1:3,1:n1,1:n1), n1, rot(i1,j1,1:3,1:3),
     &                  M1(1:3,1:n1,1:n1) )
          Call rotmom2( SM(i1,1:3,1:n1,1:n1), n1, rot(i1,j1,1:3,1:3),
     &                  S1(1:3,1:n1,1:n1) )
          Call rotmom2( MM(i2,1:3,1:n2,1:n2), n2, rot(i2,j2,1:3,1:3),
     &                  M2(1:3,1:n2,1:n2) )
          Call rotmom2( SM(i2,1:3,1:n2,1:n2), n2, rot(i2,j2,1:3,1:3),
     &                  S2(1:3,1:n2,1:n2) )
          ! KEOPT=1 ! FULL
          ! KEOPT=2 ! Full, 1/U
          ! KEOPT=3 ! FULL  + reduced form
          ! KEOPT=4 ! Full, 1/U + reduced form
          MM1=(0.0_wp,0.0_wp)
          SM1=(0.0_wp,0.0_wp)
          MM2=(0.0_wp,0.0_wp)
          SM2=(0.0_wp,0.0_wp)
!IFG: this call to KE_Exchange does not match at all its definition, please fix
          Call WarningMessage(2,'There is surely a bug here')
          If (.False.) Call Unused_real(tpar)
          If (.False.) Call Unused_real(upar)
          If (.False.) Call Unused_integer(lant)
!         Call KE_Exchange(n1,n2,
!    &                     M1( 1:3, 1:n1, 1:n1 ),
!    &                     S1( 1:3, 1:n1, 1:n1 ),
!    &                     M2( 1:3, 1:n2, 1:n2 ),
!    &                     S2( 1:3, 1:n2, 1:n2 ),
!    &                     eso(i1,1:n1),eso(i2,1:n2),
!    &                     tpar, upar, lant, KEOPT,
!    &       HKEX(lp,1:n1,1:n1,1:n2,1:n2),
!    &                     MM1(1:3, 1:n1, 1:n1 ),
!    &                     SM1(1:3, 1:n1, 1:n1 ),
!    &                     MM2(1:3, 1:n2, 1:n2 ),
!    &                     SM2(1:3, 1:n2, 1:n2 ) )

          If((KEOPT.eq.1).OR.(KEOPT.eq.2)) Then
            Do is1=1,n2
              Do js1=1,n2
                HKEXR(lp,1,1,is1,js1)=HKEX(lp, 1, 1,is1,js1)
                HKEXR(lp,1,2,is1,js1)=HKEX(lp, 1, 2,is1,js1)
                HKEXR(lp,2,1,is1,js1)=HKEX(lp, 2, 1,is1,js1)
                HKEXR(lp,2,2,is1,js1)=HKEX(lp, 2, 2,is1,js1)
              End Do
            End Do
            Do l=1,3
              Do is1=1,2
                Do js1=1,2
                  MMR(i1,l,is1,js1)=MM1(l,is1,js1)
                  MMR(i2,l,is1,js1)=MM2(l,is1,js1)
                  SMR(i1,l,is1,js1)=SM1(l,is1,js1)
                  SMR(i2,l,is1,js1)=SM2(l,is1,js1)
                End Do
              End Do
            End Do

          Else If((KEOPT.eq.3).OR.(KEOPT.eq.4)) Then
            Do is1=1,n2
              Do js1=1,n2
                HKEXR(lp,1,1,is1,js1)=HKEX(lp, 1, 1,is1,js1)
                HKEXR(lp,1,2,is1,js1)=HKEX(lp, 1,n1,is1,js1)
                HKEXR(lp,2,1,is1,js1)=HKEX(lp,n1, 1,is1,js1)
                HKEXR(lp,2,2,is1,js1)=HKEX(lp,n1,n1,is1,js1)
              End Do
            End Do

            Do l=1,3
              MMR(i1,l,1,1)=MM1(l, 1, 1)
              MMR(i1,l,1,2)=MM1(l, 1,n1)
              MMR(i1,l,2,1)=MM1(l,n1, 1)
              MMR(i1,l,2,2)=MM1(l,n1,n1)

              MMR(i2,l,1,1)=MM2(l, 1, 1)
              MMR(i2,l,1,2)=MM2(l, 1,n2)
              MMR(i2,l,2,1)=MM2(l,n2, 1)
              MMR(i2,l,2,2)=MM2(l,n2,n2)

              SMR(i1,l,1,1)=SM1(l, 1, 1)
              SMR(i1,l,1,2)=SM1(l, 1,n1)
              SMR(i1,l,2,1)=SM1(l,n1, 1)
              SMR(i1,l,2,2)=SM1(l,n1,n1)

              SMR(i2,l,1,1)=SM2(l, 1, 1)
              SMR(i2,l,1,2)=SM2(l, 1,n2)
              SMR(i2,l,2,1)=SM2(l,n2, 1)
              SMR(i2,l,2,2)=SM2(l,n2,n2)
            End Do

            If(DBG) Then
              Write(6,'(A)')'site Ln'
              Do i=1,2
                Do j=1,2
                  Write(6,'(3(A,i1),A,3(2F20.14,2x))')
     &              'MMR(',i1,',L,',i,',',j,')= ',(MMR(i1,l,i,j),l=1,3)
                End Do
              End Do
              Write(6,'(/)')
              Do i=1,2
                Do j=1,2
                  Write(6,'(3(A,i1),A,3(2F20.14,2x))')
     &              'SMR(',i1,',L,',i,',',j,')= ',(SMR(i1,l,i,j),l=1,3)
                End Do
              End Do
              Write(6,'(/)')
              Write(6,'(A)')'site Radical'
              Do i=1,2
                Do j=1,2
                  Write(6,'(3(A,i1),A,3(2F20.14,2x))')
     &              'MMR(',i2,',L,',i,',',j,')= ',(MMR(i2,l,i,j),l=1,3)
                End Do
              End Do
              Write(6,'(/)')
              Do i=1,2
                Do j=1,2
                  Write(6,'(3(A,i1),A,3(2F20.14,2x))')
     &              'SMR(',i2,',L,',i,',',j,')= ',(SMR(i2,l,i,j),l=1,3)
                End Do
              End Do
            End If ! DBG

          End If ! KEOPT
        End Do ! lp

!       in case of KEOPT=3 or KEOPT=4 Then we need to compute the spectrum and the properties
!       in the reduced form, where nexch(i1)=2 ( ground Doublet only).
!       exchnew=8:
        If(KEOPT.le.4) Then
          nmaxR=2
          nexchR(1)=2
          nexchR(2)=2
          Do i=1,nneq
            nexchR(i)=2
          End Do
          intcR(:)=0
          ibasR(:,:)=0
          intcR(1)=1
          If (lmax.gt.1) Then
            Do i=2,lmax
              isite=nind(i-1, 1)
              intcR(i)=intcR(i-1)*nexchR(isite)
            End Do
          End If
          Do nb=1,exchR
            nb1=nb-1
            Do i=1,lmax
              ibasR(nb, lmax-i+1)= nb1 / intcR(lmax-i+1)
              nb1=nb1-ibasR(nb,lmax-i+1)*intcR(lmax-i+1)
            End Do
          End Do
cccc----------------------------------------------------------------------------------
          HLIN1=(0.0_wp,0.0_wp)
          HLIN3=(0.0_wp,0.0_wp)
          HLIN9=(0.0_wp,0.0_wp)
          HDIP=(0.0_wp,0.0_wp)
          WLIN=0.0_wp
          WLIN1=0.0_wp
          WLIN3=0.0_wp
          WLIN9=0.0_wp
          WDIP=0.0_wp
          WKEX=0.0_wp
          WR=0.0_wp
          ZR=(0.0_wp,0.0_wp)
          ! print the Exchange Hamiltonian:
          Call pa_prham( exchR, npair, i_pair,  nneq,   neq, nexchR,
     &                   nmaxR,
     &                lmax, eso(1:nneq,1:nmaxR),
     &                HLIN1(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HLIN3(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HLIN9(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HDIP(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &               HKEXR(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HDMO(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HITO(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                Dipol, AnisoLines1, AnisoLines3, AnisoLines9, KE,
     &                DM_exchange, .False. )
          ! diagonalize the Hamiltonian:
          Call pa_diagham( exchR, npair, i_pair, nneq, neq, nexchR,
     &                     nmaxR,
     &                lmax, eso(1:nneq,1:nmaxR),
     &                HLIN1(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HLIN3(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HLIN9(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HDIP(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &               HKEXR(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HDMO(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                HITO(1:npair,1:nmaxR,1:nmaxR,1:nmaxR,1:nmaxR),
     &                Dipol, .False.,
     &                AnisoLines1, AnisoLines3, AnisoLines9, KE,.False.,
     &                WLIN1(1:exchR), WLIN3(1:exchR), WLIN9(1:exchR),
     &                WLIN(1:exchR), WDIP(1:exchR), WKEX(1:exchR),
     &                WDMO(1:exchR), WITO(1:exchR),
     &                  WR(1:exchR), ZR(1:exchR,1:exchR) )
          ! print the resulting eigenstates:
          Call pa_preigen( exchR,  lmax,   ibasR,  Dipol,
     &                     AnisoLines1, AnisoLines3, AnisoLines9, KE,
     &                     .False., .False.,
     &                     WLIN(1:exchR), WDIP(1:exchR),
     &                     WKEX(1:exchR), WDMO(1:exchR), WITO(1:exchR),
     &                     WR(1:exchR), ZR(1:exchR,1:exchR), 0 )
          ! compute the moments:
          rotR=0.0_wp
          rotR(1,1,1,1)=1.0_wp
          rotR(1,1,2,2)=1.0_wp
          rotR(1,1,3,3)=1.0_wp
          rotR(1,2,1,1)=1.0_wp
          rotR(1,2,2,2)=1.0_wp
          rotR(1,2,3,3)=1.0_wp
          rotR(2,1,1,1)=1.0_wp
          rotR(2,1,2,2)=1.0_wp
          rotR(2,1,3,3)=1.0_wp
          MR=(0.0_wp,0.0_wp)
          SR=(0.0_wp,0.0_wp)
          Do L=1,3
            Do isite=1,lmax
              Do nb1=1,exchR
                Do lp=1,lmax
                  icoord(lp)=ibasR(nb1,lp)
                End Do
                i1=nind(isite,1)
                j1=nind(isite,2)
               is1=ibasR(nb1,isite)+1

                Do js1=1,nexchR(i1)
                  icoord(isite)=js1-1
                  nb2=norder(icoord,intcR,lmax)
                  MR( l, nb1, nb2 ) = MR( l, nb1, nb2 ) +
     &                  rotR( i1, j1, l, 1 ) * MMR( i1, 1, is1, js1 )
     &                 +rotR( i1, j1, l, 2 ) * MMR( i1, 2, is1, js1 )
     &                 +rotR( i1, j1, l, 3 ) * MMR( i1, 3, is1, js1 )
                  SR( l, nb1, nb2 ) = SR( l, nb1, nb2 ) +
     &                  rotR( i1, j1, l, 1 ) * SMR( i1, 1, is1, js1 )
     &                 +rotR( i1, j1, l, 2 ) * SMR( i1, 2, is1, js1 )
     &                 +rotR( i1, j1, l, 3 ) * SMR( i1, 3, is1, js1 )

                End Do  ! js1
              End Do  ! nb1
            End Do  ! isite
            TMP(:,:)=(0.0_wp,0.0_wp)
            Call ZGEMM_('C','N',EXCHR,EXCHR,EXCHR,
     &                  (1.0_wp,0.0_wp), ZR,EXCHR,
     &                                   MR(L,:,:), EXCHR,
     &                  (0.0_wp,0.0_wp), TMP, EXCHR )
            MR(L,:,:)=(0.0_wp,0.0_wp)
            Call ZGEMM_('N','N',EXCHR,EXCHR,EXCHR,
     &                  (1.0_wp,0.0_wp),TMP,EXCHR,
     &                                   ZR, EXCHR,
     &                  (0.0_wp,0.0_wp), MR(L,:,:), EXCHR )
            TMP(:,:)=(0.0_wp,0.0_wp)
            Call ZGEMM_('C','N',EXCHR,EXCHR,EXCHR,
     &                  (1.0_wp,0.0_wp), ZR, EXCHR,
     &                                   SR(L,:,:), EXCHR,
     &                  (0.0_wp,0.0_wp), TMP, EXCHR )
            SR(L,:,:)=(0.0_wp,0.0_wp)
            Call ZGEMM_('N','N',EXCHR,EXCHR,EXCHR,
     &                  (1.0_wp,0.0_wp),TMP, EXCHR,
     &                                   ZR, EXCHR,
     &                  (0.0_wp,0.0_wp), SR(L,:,:), EXCHR )
            Do is1=1,8
              Do js1=1,8
                Write(6,'(3(A,i1),A,2F20.14)') 'MR(',l,',',
     &                     is1,',',js1,') = ',MR(l,is1,js1)
              End Do
            End Do
          End Do  ! L
          ! print the localized moments on sites:
          nsta=exchR
          ! assuming max 10 equivalent magnetic sites
          Call momloc2(nsta, nmaxR, nneq, neq, neqv,
     &                rotR(1:nneq,1:10,:,:), lmax, nexchR,
     &                wR(1:nsta),zR(1:nsta,1:nsta),
     &                MR(1:3,1:nsta,1:nsta),
     &                SR(1:3,1:nsta,1:nsta),
     &                MMR(1:nneq,1:3,1:nmaxR,1:nmaxR),
     &                SMR(1:nneq,1:3,1:nmaxR,1:nmaxR) )

          Call WarningMessage(2,'Wrong code in poly_aniso/exchctl.f')
          ! FIXME: This call is missing 3 arguments
          !Call barrier(exchR,MR(1:3,1:exchR,1:exchR),WR(1:exchR),1,2)
          Call Abend()
        End If !KEOPT

        End If ! npair>0, index lp
      End If !KE


c--------------------------------------------------------------
c ALL exchange couplings for all pairs are now known.
c printout the Hamiltonians:
      If(DBG) Then
        Write(6,'(A,i5)') 'exch  = ',exch
        Write(6,'(A,i5)') 'npair = ',npair
        Write(6,'(A,i5)') 'nneq  = ',nneq
        Write(6,'(A,i5)') 'nmax  = ',nmax
        Write(6,'(A,i5)') 'lmax  = ',lmax
        Write(6,'(A,i5)') 'iPrint= ',iPrint
        Write(6,*) 'AnisoLines1 = ',AnisoLines1
        Write(6,*) 'AnisoLines3 = ',AnisoLines3
        Write(6,*) 'AnisoLines9 = ',AnisoLines9
        Write(6,*) 'Dipol = ',Dipol
        Write(6,*) 'JITO  = ',JITO_exchange
        Write(6,*) 'KE    = ',KE
        Do i=1,npair
          Write(6,'(A,i2,A,i3,3x,A,i2,A,i3)')
     &                       'i_pair(',i,',1) = ',i_pair(i,1),
     &                       'i_pair(',i,',2) = ',i_pair(i,2)
        End Do
        Do i=1,nneq
          Write(6,'(A,i2,A,i3)')    '   neq(',i,') = ',neq(i)
        End Do
        Do i=1,nneq
          Write(6,'(A,i2,A,i3)')    ' nexch(',i,') = ',neq(i)
        End Do
        Do i=1,nneq
          Write(6,'(A,i2,A,100F10.3)') '   eso(',i,') = ',
     &                                (eso(i,j),j=1,nexch(i))
        End Do
        Call xFlush(6)
      End If


      If((iPrint > 2).OR.(DBG)) Then
      ! print the Exchange Hamiltonian:
      Call pa_prham( exch, npair, i_pair, nneq,
     &               neq, nexch, nmax, lmax, eso,
     &               HLIN1, HLIN3, HLIN9, HDIP, HKEX, HDMO, HITO,
     &               Dipol, AnisoLines1, AnisoLines3, AnisoLines9,
     &               KE, DM_exchange, JITO_exchange )
      End If

      ! diagonalize the Hamiltonian:
      Call pa_diagham( exch, npair, i_pair,  nneq,   neq, nexch, nmax,
     &              lmax,   eso,   HLIN1, HLIN3, HLIN9,  HDIP,
     &              HKEX, HDMO, HITO, Dipol, DM_exchange, AnisoLines1,
     &              AnisoLines3, AnisoLines9, KE, JITO_exchange,
     &              WLIN1, WLIN3, WLIN9, WLIN, WDIP, WKEX, WDMO, WITO,
     &              W, Z )

      ! printout the resulting eigenstates:
      Call pa_preigen( exch,  lmax,  ibas, Dipol, AnisoLines1,
     &                 AnisoLines3, AnisoLines9, KE, DM_exchange,
     &                 JITO_exchange,
     &                 WLIN,  WDIP, WKEX, WDMO, WITO, W, Z, iPrint )
      !Z =  exchange eigenstates:
      NmaxPop=500
      If(NmaxPop.gt.exch) Then
        NmaxPop=exch
      End If
      Call PopAnalysis( nneq, neq, exch, nexch, nmax, lmax, NmaxPop,Z)
      Do i=exch,1,-1
        w(i)=w(i)-w(1)
      End Do

      !some verification
      If(dnrm2_(exch,WLIN,1).gt.1.0d-13)
     &   Call Add_Info('EXCHCTL::  WLIN',[dnrm2_(exch,WLIN,1)],1,8)
      If(dnrm2_(exch,WDIP,1).gt.1.0d-13)
     &   Call Add_Info('EXCHCTL::  WDIP',[dnrm2_(exch,WDIP,1)],1,8)
      If(dnrm2_(exch,WKEX,1).gt.1.0d-13)
     &   Call Add_Info('EXCHCTL::  WKEX',[dnrm2_(exch,WKEX,1)],1,8)
      If(dnrm2_(exch,W,1).gt.1.0d-13)
     &   Call Add_Info('EXCHCTL::     W',[dnrm2_(exch,W,1)],1,8)
c compute the moments:
      Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,M,1)
      Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,S,1)
      If(dbg) Then
       Write(6,'(A)') 'Magnetic moments before the build of '//
     &                'coupled M and S matrices'
       If(nPair>0) Then
        Do lp=1,npair
          lb1=i_pair(lp,1)
          lb2=i_pair(lp,2)
          i1=nind(lb1,1) ! indices of non-equivalent sites
          i2=nind(lb2,1) ! indices of non-equivalent sites
          n1=nexch(i1)
          n2=nexch(i2)
          Call prMom('EXCHCTL,Before M ans S, SM(i1):',
     &                SM(i1,1:3,1:n1,1:n1), n1 )
          Call prMom('EXCHCTL,Before M ans S, SM(i2):',
     &                SM(i2,1:3,1:n2,1:n2), n2 )
          Call prMom('EXCHCTL,Before M ans S, MM(i1):',
     &                MM(i1,1:3,1:n1,1:n1), n1 )
          Call prMom('EXCHCTL,Before M ans S, MM(i2):',
     &                MM(i2,1:3,1:n2,1:n2), n2 )
        End Do
       End If
      End If

      Do L=1,3
        Do isite=1,lmax
          Do nb1=1,exch
            Do lp=1,lmax
              icoord(lp)=ibas(nb1,lp)
            End Do
              i1=nind(isite,1)
              j1=nind(isite,2)
            is1=ibas(nb1,isite)+1

            Do js1=1,nexch(i1)
              icoord(isite)=js1-1
              nb2=norder(icoord,intc,lmax)
              M( l, nb1, nb2 ) = M( l, nb1, nb2 ) +
     &              rot( i1, j1, l, 1 ) * MM( i1, 1, is1, js1 )
     &             +rot( i1, j1, l, 2 ) * MM( i1, 2, is1, js1 )
     &             +rot( i1, j1, l, 3 ) * MM( i1, 3, is1, js1 )
              S( l, nb1, nb2 ) = S( l, nb1, nb2 ) +
     &              rot( i1, j1, l, 1 ) * SM( i1, 1, is1, js1 )
     &             +rot( i1, j1, l, 2 ) * SM( i1, 2, is1, js1 )
     &             +rot( i1, j1, l, 3 ) * SM( i1, 3, is1, js1 )

            End Do  ! js1
          End Do  ! nb1
        End Do  ! isite

        ! magnetic moment
        Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,TMP,1)
        Call zgemm_('C','N',EXCH,EXCH,EXCH,
     &             (1.0_wp,0.0_wp),Z, EXCH,
     &                             M(L,:,:), EXCH,
     &             (0.0_wp,0.0_wp),TMP, EXCH )
        Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,M(L,:,:),1)
        Call zgemm_('N','N',EXCH,EXCH,EXCH,
     &             (1.0_wp,0.0_wp),TMP,EXCH,
     &                               Z,EXCH,
     &             (0.0_wp,0.0_wp), M(L,:,:), EXCH )
        Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,TMP,1)
        ! spin moment
        Call zgemm_('C','N',EXCH,EXCH,EXCH,
     &             (1.0_wp,0.0_wp),Z,EXCH,
     &                             S(L,:,:), EXCH,
     &             (0.0_wp,0.0_wp),TMP,EXCH )
        Call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,S(L,:,:),1)
        Call zgemm_('N','N',EXCH,EXCH,EXCH,
     &             (1.0_wp,0.0_wp),TMP,EXCH,
     &                               Z,EXCH,
     &             (0.0_wp,0.0_wp),S(L,:,:),EXCH )
      End Do  ! L


      If(npair >0 ) Then
      ! ITO decomposition of the exchange and dipolar interactions:
      Call pr_ito_int( npair, i_pair, lmax, nexch, nneq, neqv, itype,
     &                 neq, nmax, eso(1:nneq,1:nmax),
     &                  MM(1:nneq,1:3,1:nmax,1:nmax),
     &                  SM(1:nneq,1:3,1:nmax,1:nmax), rot,
     &                 Dipol, AnisoLines1, AnisoLines3, AnisoLines9,
     &                 DM_exchange, JITO_exchange,
     &                 HLIN1, HLIN3, HLIN9, HDIP, HDMO, HITO )
      End If

      ! projection on the Ising Hamiltonian
      ! accessible format
c      Write(6,'(/)')
c      Write(6,'(A)')'Complete decomposition of the exchange interaction'
c      Write(6,'(A)')




!-----------------------------------------------------------------------
! deallocate memory for this function:
      If(lmax>=0) Then
        ! exchange energy spectrum
        Call mma_deallocate(intc)
        Call mma_deallocate(icoord)
        Call mma_deallocate(nind)
        If(exch>=0) Then
          Call mma_deallocate(ibas)
        End If
      End If
      If(exch>=0) Then
        Call mma_deallocate(wlin)
        Call mma_deallocate(wlin1)
        Call mma_deallocate(wlin3)
        Call mma_deallocate(wlin9)
        Call mma_deallocate(wdip)
        Call mma_deallocate(wkex)
        Call mma_deallocate(wdmo)
        Call mma_deallocate(wito)
      End If
      If(nmax>=0) Then
        Call mma_deallocate(S1)
        Call mma_deallocate(M1)
        Call mma_deallocate(S2)
        Call mma_deallocate(M2)
        Call mma_deallocate(ZA1)
        Call mma_deallocate(ZA2)
        Call mma_deallocate(SM1)
        Call mma_deallocate(SM2)
        Call mma_deallocate(MM1)
        Call mma_deallocate(MM2)
        If(npair>=0) Then
          Call mma_deallocate(HLIN1)
          Call mma_deallocate(HLIN3)
          Call mma_deallocate(HLIN9)
          Call mma_deallocate(HDIP)
          Call mma_deallocate(HKEX)
          Call mma_deallocate(HDMO)
          Call mma_deallocate(HITO)
        End If
      End If

      If(exch>=0) Then
        Call mma_deallocate(tmp)
      End If

      If(nneq>=0) Then
        Call mma_deallocate(nexchR)
        Call mma_deallocate(SMR)
        Call mma_deallocate(MMR)
        If(neqv>=0) Then
          Call mma_deallocate(rotR)
        End If
      End If

      If(exchR>=0) Then
        If(lmax>=0) Then
          Call mma_deallocate(ibasR)
        End If
        Call mma_deallocate(WR)
        Call mma_deallocate(ZR)
        Call mma_deallocate(MR)
        Call mma_deallocate(SR)
      End If

      If(npair>=0) Then
        Call mma_deallocate(HKEXR)
      End If

      If(lmax>=0) Then
        Call mma_deallocate(intcR)
      End If




c  results of projection of the exchange interaction on the Ising Hamiltonian:




c      open (76,file='eigenstates.txt')
c      Do i=1,EXCH
c        Do j=1,EXCH
c      Write(76,'(2E24.14)') Z(i,j)
c        End Do
c      End Do
c      close(76)
c
c      open (77,file='eigenstates_full.txt')
c      ZZR=0.0_wp
c      ZZI=0.0_wp
c      Do i=1,EXCH
c        Do j=1,EXCH
c      read(77,'(2E24.14)') ZZR(i,j),ZZI(i,j)
c        End Do
c      End Do
c      close(77)
c      ZF=(0.0_wp,0.0_wp)
c      Do i=1,EXCH
c        Do j=1,EXCH
c        ZF(i,j)=cmplx( ZZR(i,j), ZZI(i,j), 8)
c        End Do
c      End Do
c      OVLP=(0.0_wp,0.0_wp)
c      Call ZGEMM_('C','N',EXCH,  EXCH,  EXCH, (1.0_wp,0.0_wp),
c     &             Z(  1:EXCH,1:EXCH), EXCH,
c     &            ZF(  1:EXCH,1:EXCH), EXCH, (0.0_wp,0.0_wp),
c     &          OVLP(  1:EXCH,1:EXCH), EXCH )
c      Do i=1,1
c        Do j=1,EXCH
c        If(ABS(OVLP(j,i)).gt.0.0000001_wp ) Then
c      Write(6,'(A,i3,A,i3,A,2F18.14,3x,A,F18.14,3x,A,F18.14)')
c     & 'OVLP-1(',j,',',i,') = ',OVLP(j,i),
c     & 'ABS = ', ABS(OVLP(j,i)), 'ABS^2 = ',
c     & ABS(OVLP(j,i))*ABS(OVLP(j,i))
c       End If
c        End Do
c      End Do
c      OVLP=(0.0_wp,0.0_wp)
c      Call ZGEMM_('C','N',EXCH,  EXCH,  EXCH, (1.0_wp,0.0_wp),
c     &            ZF(  1:EXCH,1:EXCH), EXCH,
c     &             Z(  1:EXCH,1:EXCH), EXCH, (0.0_wp,0.0_wp),
c     &          OVLP(  1:EXCH,1:EXCH), EXCH )
c      Do i=1,1
c        Do j=1,EXCH
c        If(ABS(OVLP(j,i)).gt.0.0000001_wp ) Then
c      Write(6,'(A,i3,A,i3,A,2F18.14,3x,A,F18.14,3x,A,F18.14)')
c     & 'OVLP-2(',i,',',j,') = ',OVLP(i,j),
c     & 'ABS = ', ABS(OVLP(i,j)), 'ABS^2 = ',
c     & ABS(OVLP(i,j))*ABS(OVLP(i,j))
c        End If
c        End Do
c      End Do
c 199  Continue
      Return
      End



      Subroutine prep_mom_exchange( n, R, S, M, mg, dbg)

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      Integer, intent(in)             :: n
      Real(kind=8), intent(in)       :: R(3,3)
      Real(kind=8), intent(out)      :: mg(3,3)
      Complex(kind=8), intent(inout) :: S(3,n,n), M(3,n,n)
      Logical                         :: dbg
      ! local data:
      Integer                         :: i
      Complex(kind=8), allocatable   :: Mt(:,:,:), St(:,:,:)
!      Real(kind=8)                   :: g(3)
!      Complex(kind=8), allocatable   :: Z(:,:)

!-----------------------------------------------------------------------
      Call mma_allocate(Mt,3,n,n,'Mt')
      Call mma_allocate(St,3,n,n,'St')
!      Call mma_allocate(Z,n,n,'Z')
!      Call dcopy_(3  ,[0.0_wp],0,  g,1)
      Call zcopy_(3*n*n,[(0.0_wp,0.0_wp)],0,Mt,1)
      Call zcopy_(3*n*n,[(0.0_wp,0.0_wp)],0,St,1)
      Call dcopy_(3*3,[0.0_wp],0, mg,1)

      ! make a local backup of the data:
      Call zcopy_(3*n*n,M,1,Mt,1)
      Call zcopy_(3*n*n,S,1,St,1)
      Do i=1,3
        mg(i,i)=1.0_wp
      End Do

      If(dbg) Call prMom('PA_prep_mom_exch, input S',St,n)
      If(dbg) Call prMom('PA_prep_mom_exch, input M',Mt,n)

      ! rotate the momentum using the R rotation matrix --
      ! to the local axes for a symmetric compound:
      Call zcopy_(3*n*n,[(0.0_wp,0.0_wp)],0,M,1)
      Call zcopy_(3*n*n,[(0.0_wp,0.0_wp)],0,S,1)
      Call rotmom2( St, n, R, S)
      Call rotmom2( Mt, n, R, M)
      ! back-up again:
!      Call zcopy_(3*n*n,M,1,Mt,1)
!      Call zcopy_(3*n*n,S,1,St,1)



!------------------------------------------
! experimental:
!      If (.FALSE.) THEN
!         ! find local magnetic axes:
!         Call atens( M, n, g, mg, 2)
!         ! rotate the momentum using the  mg  rotation matrix --
!         ! to the local magnetic axes:
!         Call zcopy_(3*n*n,[(0.0_wp,0.0_wp)],0,M,1)
!         Call zcopy_(3*n*n,[(0.0_wp,0.0_wp)],0,S,1)
!         Call rotmom2( St, n, mg, S)
!         Call rotmom2( Mt, n, mg, M)
!
!         ! find local pseudospin:
!         Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,Z,1)
!         Call pseudospin( M, n, Z, 3,1, 1)
!         If(dbg) Call pa_prmat('PA_prep_mom_exch, Z:',Z,n)
!
!         ! Transform the moment into their local pseudospins
!         Call UTMU2( n, n, Z, S )
!         Call UTMU2( n, n, Z, M )
!         If(dbg) Call prMom('PA_prep_mom_exch, S:', S, n)
!         If(dbg) Call prMom('PA_prep_mom_exch, M:', M, n)
!         ! back-up again:
!         Call zcopy_(3*n*n,M,1,Mt,1)
!         Call zcopy_(3*n*n,S,1,St,1)
!
!         ! rotate back the moment, so that we preserve the
!         ! original coordinate system of the computed molecule
!         Call zcopy_(3*n*n,[(0.0_wp,0.0_wp)],0,M,1)
!         Call zcopy_(3*n*n,[(0.0_wp,0.0_wp)],0,S,1)
!         Call rotmom( St, n, mg, S)
!         Call rotmom( Mt, n, mg, M)
!      END IF
!-----------------------------------------------------------------------

      Call mma_deallocate(Mt)
      Call mma_deallocate(St)
!      Call mma_deallocate(Z)


!-----------------------------------------------------------------------
! old preparation of the data for Lines exchange
!        ! rotate the moments to the general coordinate system
!        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0, S1,1)
!        Call zcopy_(3*nmax*nmax,[(0.0_wp,0.0_wp)],0, S2,1)
!
!        Call rotmom2( SM(i1,1:3,1:n1,1:n1), n1, rot(i1,j1,1:3,1:3),
!     &                S1(1:3,1:n1,1:n1) )
!        Call rotmom2( SM(i2,1:3,1:n2,1:n2), n2, rot(i2,j2,1:3,1:3),
!     &                S2(1:3,1:n2,1:n2) )
!        Call Lines_Exchange( Jex(lp), n1, n2,
!     &                       S1(1:3,1:n1,1:n1),
!     &                       S2(1:3,1:n2,1:n2),
!     &              HLIN1(lp,1:n1,1:n1,1:n2,1:n2) )
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine full_svd(m,n,amat,umat,vmat,svals)
      implicit real*8 (a-h,o-z)
      dimension amat(m,*)
      dimension umat(m,*)
      dimension vmat(n,*)
      dimension svals(*)
#include "WrkSpc.fh"
      dimension wrk1_lapack(1)

*  Note that dgesvd returns V**T, not V.
c     write(6,*)' In full_svd. Calling dgesvd:'
      call dgesvd_('A','A',m,n,amat,m,svals,umat,m,vmat,n,
     &                                     wrk1_lapack,-1,info)
c     write(6,*)' full_svd back from dgesvd'
      lwork=int(wrk1_lapack(1))
c     write(6,*)' lwork:',lwork
      call getmem('lapckwrk','allo','real',ipwork,lwork)
c     write(6,*)' Calling dgesvd again:'
      call dgesvd_('A','A',m,n,amat,m,svals,umat,m,vmat,n,
     &                                 work(ipwork),lwork,info)
c     write(6,*)' full_svd back from dgesvd'
      call getmem('lapckwrk','free','real',ipwork,lwork)

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ColorizeInit()
      Common /icolorize/icolorize
      Character Str*32
      Str=' '
      icolorize=1
      call getenvf('MOLCAS_COLOR',Str)
      if(Str(1:1).eq.'N'.or.Str(1:1).eq.'n') icolorize=0

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Martin Schuetz                                   *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine RotMOs(Delta,nDelta,CMO,nCMO,nD,Ovrlp,mBT)
************************************************************************
*                                                                      *
*     purpose: rotates MOs according to last displacement vector       *
*              delta after QNR step and DIIS extrapolation.            *
*              only called during second order update (QNR) opt.       *
*              delta is taken as the last entry on LLDelt              *
*                                                                      *
*     input:                                                           *
*       Delta   : displacement vectors used to construct unitary       *
*                 rotation matrix via expKap                           *
*       CMO     : orthonormal vectors from previous iteration of       *
*                 length nCMO                                          *
*                                                                      *
*     output:                                                          *
*       CMO     : orthonormal vectors, rotated by U=exp(delta)         *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*     calls to: ExpKap                                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1994                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: VVUHF                                                   *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
#include "file.fh"
#include "llists.fh"
*
      Integer nDelta,nCMO
      Real*8 CMO(nCMO,nD),Delta(nDelta,nD),Ovrlp(mBT)
      Real*8 Cpu1,Tim1,Tim2,Tim3
*
*---- Define local variables
      Integer iSym,iSyBlpt,nOF,nVrt,nOccmF,iCMOpt
      Real*8, Dimension(:), Allocatable:: RoM, Scratch
*
      Call Timing(Cpu1,Tim1,Tim2,Tim3)
*define _DEBUGPRINT_
*
      Call mma_allocate(RoM,nOFS,Label='RoM')
      nSize=0
      Do iSym=1,nSym
         nOF=nOrb(iSym)-nFro(iSym)
         nOFnBa=nOF*nBas(iSym)
         nSize=Max(nSize,nOFnBa)
      End Do
      Call mma_allocate(Scratch,nSize,Label='Scratch')
*
      Do iD = 1, nD
*        compute rotation matrix via expkap
         Call ExpKap(Delta(1,iD),RoM,nOcc(1,iD))
         iSyBlpt=1
         iCMOpt=1
*
*        loop over all symmetry blocks
*
         Do iSym=1,nSym
*
            nOF=nOrb(iSym)-nFro(iSym)
            nVrt=nOrb(iSym)-nOcc(iSym,iD)
            nOccmF=nOcc(iSym,iD)-nFro(iSym)
            nOFnBa=nOF*nBas(iSym)
            iCMOpt=iCMOpt+nBas(iSym)*nFro(iSym)
*
            If ((nVrt.gt.0).AND.(nOccmF.gt.0)) Then
*              skip, if no orbitals within this irrep
               call dcopy_(nOFnBa,CMO(iCMOpt,iD),1,Scratch,1)
               Call DGEMM_('N','N',
     &                     nBas(iSym),nOF,nOF,
     &                     1.0d0,Scratch,nBas(iSym),
     &                           RoM(iSyBlpt),nOF,
     &                     0.0d0,CMO(iCMOpt,iD),nBas(iSym))
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
               Call NrmClc(Scratch,nBas(iSym)*nOrb(iSym),'RotMOs',
     &                     'Old CMOs')
               Call NrmClc(CMo(iCMOpt,iD),nBas(iSym)*nOrb(iSym),
     &                     'RotMOs','New CMOs')
               Call RecPrt('RoM',' ',RoM(iSyBlpt),nOF,nOF)
*              Call RecPrt('RotMOs: Old CMOs',' ',Scratch,
*    &                     nBas(iSym),nOrb(iSym))
*              Call RecPrt('RotMOs: New CMOs',' ',CMO(iCMOpt,iD),
*    &                     nBas(iSym),nOrb(iSym))
#endif
               iSyBlpt=iSyBlpt+nOF*nOF
            End If
            iCMOpt=iCMOpt+nOF*nBas(iSym)
         End Do
*
*----    Check orthogonality
*
         Call ChkOrt(CMO(1,iD),nBO,Ovrlp,mBT,Whatever)
*
      End Do ! iD
*
      Call mma_deallocate(Scratch)
      Call mma_deallocate(RoM)
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call NrmClc(Delta,nDelta*nD,'RotMos','Delta')
      Call NrmClc(CMO,nCMO*nD,'RotMos','CMO')
      Call RecPrt('RotMOs: Delta',' ',Delta,nDelta,nD)
      Call RecPrt('RotMOs: CMO',' ',CMO,nCMO,nD)
#endif
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld( 9) = TimFld( 9) + (Cpu2 - Cpu1)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine G_Nrm(GrdX,nAtom,nInter,GNrm,Iter,
     &                 Grad,Degen,mIntEff)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "Molcas.fh"
      Real*8 GrdX(3*nAtom),GNrm(Iter),Grad(nInter,Iter),Degen(3*nAtom)
*
*
*     Compute the norm of the cartesian force vector.
*
*     |dE/dx|=Sqrt(dE/dx|u|dE/dx)
*
      Fabs=0.0D0
      Do i = 1, 3*nAtom
         Fabs=Fabs+ Degen(i)*GrdX(i)**2
      End Do
      Fabs=Sqrt(Fabs)
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
         Write (6,42) Fabs
42       Format (/,' Norm of the force vector',F20.15)
#endif
      GNrm(iter)=Fabs
*
*-----Write out the internal force vector.
*
      mIntEff=0
      Do i = 1, nInter
         If (Abs(Grad(i,Iter)).gt.1.0d-6) mIntEff=mIntEff+1
      End Do
      If (mIntEff.eq.0) mIntEff=1
#ifdef _DEBUGPRINT_
      Write (6,*) ' mIntEff=',mIntEff
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Hybnew(OKUAH,OKCHG,MxBond,IAt,IAn,NBond,IBond,IBType,PBO,Chg)

use Constants, only: Zero, One, Two, Three, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: Hybnew
logical(kind=iwp), intent(in) :: OKUAH, OKCHG
integer(kind=iwp), intent(in) :: MxBond, IAt, IAN(*), NBond(*), IBond(MxBond,*), IBtype(MxBond,*)
real(kind=wp), intent(in) :: PBO(MxBond,*)
real(kind=wp), intent(inout) :: Chg
integer(kind=iwp) :: ICARB, ICC, ICN, ii, IQQ, ISP2, JAt, jj, JSP2, K, KAt, kk, NBIA, NBII, NBJ, NBK, NBTot, NumatI, NumII, NumJ, &
                     NumK
real(kind=wp) :: PBtot
logical(kind=iwp) :: PIAT
integer(kind=iwp), external :: IColAt

NumatI = IAn(IAt)
HybNew = Three
!Chg = Zero
IQQ = 0
if (.not. OKUAH) then
  HybNew = Zero
  return
end if

! Hydrogen

if (IAn(IAt) == 1) then
  HybNew = Zero
  if ((NBond(IAT) == 0) .and. (.not. OKCHG)) Chg = One
end if

! Carbon

if (IAN(IAt) == 6) then
  NBTot = 0
  PBtot = Zero
  do jj=1,NBond(IAt)
    NBtot = NBTot+IBType(jj,IAt)
    PBTot = PBTot+PBO(jj,IAt)
  end do
  if ((NBond(IAt) == 3) .and. (NBTot >= 4)) HybNew = Two
  if ((NBond(IAt) == 3) .and. (PBtot > 3.7_wp)) Hybnew = Two
  if (NBond(IAt) == 2) HybNew = One
end if

! Nitrogen, Phosphorus, Arsenic, Antimony

if (IColAt(NumAtI) == 5) then
  NBIA = NBond(IAt)
  select case (NBIA)
    case (1)
      HybNew = One
      ICC = IBond(1,IAt)
      ICN = IAn(IBond(1,IAt))
      if ((ICN == 6) .and. (NBond(ICC) == 1) .and. (.not. OKCHG)) Chg = -One
    case (2)
      if (PIAT(MxBond,IAt,IAn,NBond,IBond)) then
        HybNew = Two
      else
        if (.not. OKCHG) Chg = -One
      end if
    case (3)
      if (PIAT(MxBond,IAt,IAn,NBond,IBond)) HybNew = Two
    case (4)
      NBII = 0
      do ii=1,NBIA
        NumII = IAn(IBond(II,IAt))
        if ((NumII == 6) .or. (NumII == 1)) NBII = NBII+1
      end do
      if ((NBII > 3) .and. (.not. OKCHG)) Chg = One
  end select
end if

! Oxygen, Sulfur, Selenium, Tellurium

if (IColAt(NumAtI) == 6) then

  ! tricoordinated (positively charged only if bonded to C and/or H only)

  if (NBond(IAt) == 3) then
    NBII = 0
    do ii=1,3
      NumII = IAn(IBond(II,IAt))
      if ((NumII == 1) .or. (NumII == 6)) NBII = NBII+1
    end do
    if (NBII == 3) then
      if (.not. OKCHG) Chg = One
      HybNew = Three
    end if
  end if

  ! bicoordinated

  if (NBond(IAt) == 2) then
    if (.not. OKCHG) Chg = Zero
    HybNew = Three

    ! test for protonated aldehydes, ketones and similar for S

    do jj=1,2
      JAt = IBond(JJ,IAt)
      NumJ = IAn(JAt)
      NBJ = NBond(JAt)
      if ((NumJ == 6) .and. (NBJ == 3)) then
        IQQ = 0
        do kk=1,3
          KAt = IBond(kk,JAt)
          NumK = IAn(KAt)
          NBK = NBond(KAt)
          if ((NumK == 6) .and. (NBK == 4)) IQQ = IQQ+1
        end do
      end if
    end do
    if (IQQ >= 2) then
      if (.not. OKCHG) Chg = One
      HybNew = Two
    end if
  end if
  if (NBond(IAt) == 1) then
    HybNew = Two
    Jat = IBond(1,IAt)
    icc = IAn(JAt)
    if (icc == 1) then
      HybNew = Three
      if (.not. OKCHG) Chg = -One
    end if
    if (icc == 6) then
      if (NBond(JAt) == 4) then
        if (.not. OKCHG) CHg = -One
        HybNew = Three
      end if
      ISP2 = 0
      JSP2 = 0
      ICARB = 0
      if (NBond(JAt) == 3) JSP2 = 1
      do K=1,NBond(JAt)
        KAT = IBond(K,JAt)
        if ((IAN(KAT) == 6) .and. (NBond(KAT) == 3)) ISP2 = ISP2+1
        if ((IAN(KAT) == 8) .and. (NBond(KAt) == 1)) ICARB = ICARB+1
      end do
      if (ISP2 > 1) then
        if (.not. OKCHG) Chg = -One
        HybNew = Three
      end if
      if ((JSp2 == 1) .and. (ICARB == 2)) then
        if (.not. OKCHG) Chg = -Half
        HybNew = Three
      end if
    end if
  end if
end if

! Halogens

if ((IColAt(NumAtI) == 7) .and. (NBond(IAt) == 0)) then
  if (.not. OKCHG) Chg = -One
end if

!write(IOut,'(I3,2F3.1)') IAn(IAt),HybNew,Chg

return

end function Hybnew

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine optize_cvb(fx,ioptc,iter,imethod,isadinp,mxiter,maxinp,ipinp,ipdd1,ipdd2,strucopt)
!***********************************************************************
!*                                                                     *
!*  Routine for second-order optimization.                             *
!*                                                                     *
!*  Uses the following functions:                                      *
!*                                                                     *
!*   GETFREE:   Determine # free parameters                            *
!*    UPDATE:   Add dx to vector of free variables, x                  *
!*        FX:   Calculate f(x)                                         *
!*      GRAD:   Calculate gradient of f                                *
!*      HESS:   Calculate the action of the hessian on trial vector    *
!*   GETHESS:   Calculate full hessian                                 *
!*                                                                     *
!*  IOPTC is optimization control :                                    *
!*                                                                     *
!*  IOPTC=-3    Opt. terminated close to convergence (at request)      *
!*  IOPTC=-2    Optimization failed -- too small step size             *
!*  IOPTC=-1    Maximum number of iterations used                      *
!*  IOPTC= 0    Converged                                              *
!*  IOPTC= 1    Not complete                                           *
!*                                                                     *
!***********************************************************************

use casvb_global, only: corenrg, eigval, eigvec, expct, fxbest, hh, hhkeep, hhstart, ip, ipp10, ipp12e, ipp12s, ipp7, isaddleo, &
                        iter10, iter12e, iter12s, iter7, maxize, odx, odxp, ograd, ogradp, owrk
use casvb_interfaces, only: opta_sub, optb_sub
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: fx
integer(kind=iwp), intent(out) :: ioptc, iter
integer(kind=iwp), intent(in) :: imethod, isadinp, mxiter, ipinp, ipdd1, ipdd2
logical(kind=iwp), intent(in) :: maxinp, strucopt
integer(kind=iwp) :: ifollow, maxd, mxit, n_div, nfrdim, nfrdim_dav, nparm, nparm_dav
logical(kind=iwp) :: done, iter_is_1
procedure(opta_sub) :: dum_a_cvb, o10a_cvb, o123a_cvb, o12ea_cvb, o12sa_cvb, o7a_cvb
procedure(optb_sub) :: o10b_cvb, o123b_cvb, o12eb_cvb, o12sb_cvb, o5b_cvb, o7b_cvb, o8b_cvb

if (mxiter == 0) then
  ioptc = -1
  return
end if

! Initialize for new optimization - input parameters:
isaddleo = isadinp
maxize = maxinp
ip = ipinp

! Parameters initialized:
expct = Zero
hh = hhstart
hhkeep = hh
ioptc = 1

if (maxize) then
  ifollow = 1
else
  ifollow = 2
end if

call fx_cvb(fx,.false.)
fxbest = fx
done = .false.
do iter=1,mxiter
  iter_is_1 = (iter == 1)
  call getfree_cvb(nparm,n_div,nfrdim,iter,fx)
  if (nfrdim <= 0) then
    if (ip >= 0) write(u6,'(a)') ' No free parameters!'
    if (ip >= 0) write(u6,'(a)') ' Calculation converged.'
    ioptc = 0
    return
  end if
  if ((fx < Zero) .and. maxize) then
    call chgsgn_cvb(fx)
    call getfree_cvb(nparm,n_div,nfrdim,iter,fx)
  end if

  if ((imethod == 1) .or. (imethod == 2) .or. (imethod == 3)) then
    call mma_allocate(odx,nparm,label='odx')
    call mma_allocate(ograd,nparm,label='ograd')
    call mma_allocate(eigvec,nparm,nparm,label='eigvec')
    call mma_allocate(eigval,nparm,label='eigval')
    call mma_allocate(odxp,nparm,label='odxp')
    call mma_allocate(ogradp,nparm,label='ogradp')
    call mma_allocate(owrk,nparm,label='owrk')
    call optize2_cvb(fx,nparm,ioptc,iter_is_1,o123a_cvb,o123b_cvb)
    call mma_deallocate(odxp)
    call mma_deallocate(ogradp)
    call mma_deallocate(owrk)
  else if (imethod == 5) then
    call mma_allocate(odx,nparm,label='odx')
    call mma_allocate(ograd,nparm,label='ograd')
    call optize2_cvb(fx,nparm,ioptc,iter_is_1,dum_a_cvb,o5b_cvb)
  else if (imethod == 7) then
    call mma_allocate(odx,nparm+1,label='odx')
    call mma_allocate(ograd,nparm+1,label='ograd')
    maxd = min(nparm+1,200)
    mxit = 500
    call ddinit_cvb('AxEx',nparm+1,nfrdim+1,maxd,mxit,ifollow,isaddleo,ipdd1,Zero,n_div)
    iter7 = 0
    ipp7 = ipdd2
    call orthcvb_init_cvb()
    call optize2_cvb(fx,nparm,ioptc,iter_is_1,o7a_cvb,o7b_cvb)
    call ddclean_cvb()
  else if (imethod == 8) then
    call mma_allocate(odx,nparm,label='odx')
    call mma_allocate(ograd,nparm,label='ograd')
    call mma_allocate(eigvec,nparm+1,nparm+1,label='eigvec')
    call mma_allocate(eigval,nparm+1,label='eigval')
    call optize2_cvb(fx,nparm,ioptc,iter_is_1,dum_a_cvb,o8b_cvb)
  else if (imethod == 9) then
    call optize9_cvb(fx,nparm,ioptc)
  else if (imethod == 10) then
    call mma_allocate(odx,nparm,label='odx')
    call mma_allocate(ograd,nparm,label='ograd')
    maxd = min(nparm,200)
    mxit = 500
    call ddinit_cvb('AxExb',nparm,nfrdim,maxd,mxit,ifollow,isaddleo,ipdd1,Zero,n_div)
    iter10 = 0
    ipp10 = ipdd2
    call orthcvb_init_cvb()
    call optize2_cvb(fx,nparm,ioptc,iter_is_1,o10a_cvb,o10b_cvb)
    call ddclean_cvb()
  else if ((imethod == 12) .and. maxize) then
    if (strucopt) then
      nparm_dav = nparm
      nfrdim_dav = nfrdim
    else
      nparm_dav = nparm+1
      nfrdim_dav = nfrdim+1
    end if
    call mma_allocate(odx,nparm_dav,label='odx')
    call mma_allocate(ograd,nparm_dav,label='ograd')
    maxd = min(nparm_dav,200)
    mxit = 500
    call ddinit_cvb('Axb',nparm_dav,nfrdim_dav,maxd,mxit,ifollow,isaddleo,ipdd1,Zero,0)
    iter12s = 0
    ipp12s = ipdd2
    call optize2_cvb(fx,nparm_dav,ioptc,iter_is_1,o12sa_cvb,o12sb_cvb)
    call ddclean_cvb()
  else if ((imethod == 12) .and. (.not. maxize)) then
    if (strucopt) then
      nparm_dav = nparm
      nfrdim_dav = nfrdim
    else
      nparm_dav = nparm+1
      nfrdim_dav = nfrdim+1
    end if
    call mma_allocate(odx,nparm_dav,label='odx')
    call mma_allocate(ograd,nparm_dav,label='ograd')
    maxd = min(nparm_dav,200)
    mxit = 500
    call ddinit_cvb('AxESx',nparm_dav,nfrdim_dav,maxd,mxit,ifollow,isaddleo,ipdd1,corenrg,n_div)
    iter12e = 0
    ipp12e = ipdd2
    call optize2_cvb(fx,nparm_dav,ioptc,iter_is_1,o12ea_cvb,o12eb_cvb)
    call ddclean_cvb()
  else
    write(u6,*) ' Unrecognized optimization algorithm!',imethod
    call abend_cvb()
  end if
  call mma_deallocate(odx,safe='*')
  call mma_deallocate(ograd,safe='*')
  call mma_deallocate(eigval,safe='*')
  call mma_deallocate(eigvec,safe='*')
  if (ioptc <= 0) then
    done = .true.
    exit
  end if
end do
if (.not. done) iter = iter-1
if (ioptc >= 0) call getfree_cvb(nparm,n_div,nfrdim,-1,fx)
if ((iter == mxiter) .and. (ioptc > 0)) ioptc = -1

return

end subroutine optize_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Per-Olof Widmark                                 *
!               1993, Markus P. Fuelscher                              *
!               1996, Luis Serrano-Andres                              *
!               2012, Victor P. Vysotskiy                              *
!***********************************************************************

subroutine FIOInit()
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     set initial values of all arguments in the common blocks         *
!     /FIO1/, /FIO2/ and /FIO3/                                        *
!     /PFIO1/,/PFIO2/,/PFIO3/,/PFIO4/                                  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, IBM Sweden, 1991                                   *
!     M.P. Fuelscher, University of Lund, Sweden, 1993                 *
!     L. Serrano-Andres, University of Lund, Sweden, 1996              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! History:                                                             *
!     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
!                                                                      *
!***********************************************************************

use Fast_IO, only: Addr, FSCB, isOpen, LuName, MaxFileSize, MBL, MPUnit, Multi_File, MxFile, ProfData, Query, Trace
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i

isOpen(:) = 0
FSCB(:) = 0
Addr(:) = 0
Multi_File(:) = .false.
ProfData(:,:) = Zero
MPUnit(:,:) = 0
MBL(:) = 0
LuName(:) = 'FT__F001'
do i=1,MxFile
  write(LuName(i)(3:4),'(I2.2)') i
end do

MaxFileSize = 0
Trace = .false.
Query = .false.

return

end subroutine FIOInit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Kurt Pfingst                                           *
************************************************************************
      SubRoutine CmbnMPr(Rnr,nZeta,la,lb,lr,Zeta,Final,nComp)
************************************************************************
*     Author: K.Pfingst                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
*     External gammat,gammaf
#include "print.fh"
#include "real.fh"
#include "rmat.fh"
#include "gam.fh"
#include "nrmf.fh"
      Real*8 Final(nZeta,nComp,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2),
     *       Zeta(nZeta), Rnr(nZeta,0:(la+lb+lr))
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
      iRout = 134
      iPrint = nPrint(iRout)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     iPrint = 99
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
*     Call GetMem(' Enter CmbnMP','LIST','REAL',iDum,iDum)
*
      Do 10 ixa = 0, la
         iyaMax=la-ixa
      Do 11 ixb = 0, lb
         iybMax=lb-ixb
         Do 20 iya = 0, iyaMax
            iza = la-ixa-iya
            ipa= Ind(la,ixa,iza)
         Do 21 iyb = 0, iybMax
            izb = lb-ixb-iyb
            ipb= Ind(lb,ixb,izb)
            If (iPrint.ge.99) Then
               Write (6,*) ixa,iya,iza,ixb,iyb,izb
               Write (6,*) ipa,ipb
            End If
*
*           Combine multipole moment integrals
*
            iComp = 0
            Do 41 ix = lr, 0, -1
               Do 42 iy = lr-ix, 0, -1
                  iz = lr-ix-iy
                  iComp=iComp+1
*                 Write (*,*) ix, iy, iz, iComp
                  lrs=ixa+ixb+ix+iya+iyb+iy+iza+izb+iz
                  lcost=iza+izb+iz
                  lsint=ixa+ixb+ix+iya+iyb+iy
                  lsinf=iya+iyb+iy
                  lcosf=ixa+ixb+ix
                  Fact=gammath(lsint,lcost)*gammaph(lsinf,lcosf)
*                 Fact1=gammat(x)*gammaf(x)
*                 write(*,*) '  fact',fact
*                 write(*,*) ' fact1',fact1
                  Do 30 iZeta = 1, nZeta
                     Final(iZeta,iComp,ipa,ipb) = Fact *
     *                       Rnr(iZeta,lrs)
30                Continue
42             Continue
41          Continue
*
21       Continue
20       Continue
11    Continue
10    Continue
*
*     Call GetMem(' Exit CmbnMP','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Zeta)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986,1995, Bernd Artur Hess                            *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

subroutine CpLabr(A,B,L,M,N,IA,IB,C,IC,IER)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: L, M, N, IA, IB, IC
real(kind=wp), intent(in) :: A(IA,M), B(IB,N)
real(kind=wp), intent(inout) :: C(IC,N)
integer(kind=iwp), intent(out) :: IER

#ifdef _DEBUGPRINT_
if ((IA >= L) .and. (IB >= M) .and. (IC >= L)) then
#endif
  IER = 0
  call DGEMM_('N','N',L,M,N,One,A,IA,B,IB,One,C,IC)
#ifdef _DEBUGPRINT_
else
  IER = 129
end if
#endif

return

end subroutine CpLabr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Roland Lindh                                     *
************************************************************************
      Subroutine Hessian_Kriging_Layer(qInt,Hessian,nInter)
      Use Limbo
      Implicit None
#include "stdalloc.fh"
      Integer nInter
      Real*8 qInt(nInter), Hessian(nInter,nInter)
      Real*8, Allocatable:: qInt_s(:), Hessian_s(:,:)
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('KHL: qInt',' ',qInt,1,nInter)
#endif
*
      Call mma_allocate(qInt_s,nInter,Label='qInt_s')
      Call mma_allocate(Hessian_s,nInter,nInter,Label='Hessian_s')
*
      Call Trans_K(U,qInt,qInt_s,nInter,1)
      Call Hessian_kriging(qInt_s,Hessian,nInter)
      Call BackTrans_K (U,Hessian,Hessian_s,nInter,nInter)
      Call BackTrans_K2(U,Hessian_s,Hessian,nInter,nInter)
*
      Call mma_deallocate(Hessian_s)
      Call mma_deallocate(qInt_s)
#ifdef _DEBUGPRINT_
      Call RecPrt('KHL: Hessian',' ',Hessian,nInter,nInter)
#endif
*
      End Subroutine Hessian_Kriging_Layer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine rg(nm,n,a,wr,wi,matz,z,iv1,fv1,ierr)
! this subroutine calls the recommended sequence of
! subroutines from the eigensystem subroutine package (eispack)
! to find the eigenvalues and eigenvectors (if desired)
! of a real general matrix.
!
! on input
!
!    nm  must be set to the row dimension of the two-dimensional
!    array parameters as declared in the calling program
!    dimension statement.
!
!    n  is the order of the matrix  a.
!
!    a  contains the real general matrix.
!
!    matz  is an integer variable set equal to zero if
!    only eigenvalues are desired.  otherwise it is set to
!    any non-zero integer for both eigenvalues and eigenvectors.
!
! on output
!
!    wr  and  wi  contain the real and imaginary parts,
!    respectively, of the eigenvalues.  complex conjugate
!    pairs of eigenvalues appear consecutively with the
!    eigenvalue having the positive imaginary part first.
!
!    z  contains the real and imaginary parts of the eigenvectors
!    if matz is not zero.  if the j-th eigenvalue is real, the
!    j-th column of  z  contains its eigenvector.  if the j-th
!    eigenvalue is complex with positive imaginary part, the
!    j-th and (j+1)-th columns of  z  contain the real and
!    imaginary parts of its eigenvector.  the conjugate of this
!    vector is the eigenvector for the conjugate eigenvalue.
!
!    ierr  is an integer output variable set equal to an error
!       completion code described in the documentation for hqr
!       and hqr2.  the normal completion code is zero.
!
!    iv1  and  fv1  are temporary storage arrays.
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n, matz
real(kind=wp), intent(inout) :: a(nm,n), z(nm,n)
real(kind=wp), intent(out) :: wr(n), wi(n), fv1(n)
integer(kind=iwp), intent(out) :: iv1(n), ierr
integer(kind=iwp) :: is1, is2

if (n > nm) then
  ierr = 10*n
  return
end if

call balanc(nm,n,a,is1,is2,fv1)
call elmhes(nm,n,is1,is2,a,iv1)
if (matz /= 0) then
  ! .......... find both eigenvalues and eigenvectors ..........
  call eltran(nm,n,is1,is2,a,iv1,z)
  call hqr2(nm,n,is1,is2,a,wr,wi,z,ierr)
  if (ierr == 0) call balbak(nm,n,is1,is2,fv1,n,z)
else
  ! .......... find eigenvalues only ..........
  call hqr(nm,n,is1,is2,a,wr,wi,ierr)
end if

return

end subroutine rg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MLTMV(IMLTOP,LST1,nLST1,X,nX,F,nF,Y,nY)
! Given a lists with entries LST1(4,ITEM), ITEM=1,NLST1, the
! four entries called L1,L2,L3,L4 for short, for a given
! item, and with V=VAL1(L4),
! compute, for IMLTOP=0 or 1, respectively.
!    X(L1,i) := Add V*F(L2,a)*Y(L3,i,a), i=1..LEN1, a=1..LEN2
! or Y(L3,i,a):= Add V*F(L2,a)*X(L1,i), i=1..LEN1, a=1..LEN2
! or for IMLTOP=2, compute
!     F(L2,a) := Add V*X(L1,i)*Y(L3,i,a)
! However, strides etc can vary from case to case: The indices
! may appear in 1st, 2nd or 3rd position, Fortran-address-wise,
! thus an independent stride is to be given for each of the
! indices in the above 'formal' index ordering, as follows:
! The formal X(p,q,r) is accessed as
! X(1+INCX1*(p-1)+INCX2*(q-1)+INCX3*(r-1)), etc.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, MyRank, nProcs
#endif
use Sigma_data, only: INCF1, INCF2, INCX1, INCX2, INCY1, INCY2, INCY3, LEN1, LEN2, NFMV, VAL1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IMLTOP, nLST1, LST1(4,NLST1), nX, nF, nY
real(kind=wp), intent(inout) :: X(nX), F(nF), Y(nY)
integer(kind=iwp) :: I, I_F, ILST1, ILST1_IOFF, ILST1_SKIP, IX, IY, L1, L2, L3, L4
real(kind=wp) :: A, V
real(kind=wp), external :: DDot_

!SVC: determine outer loop properties
#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  ILST1_IOFF = MYRANK+1
  ILST1_SKIP = NPROCS
else
#endif
  ILST1_IOFF = 1
  ILST1_SKIP = 1
#ifdef _MOLCAS_MPP_
end if
#endif

select case (IMLTOP)
  case (0)
    do ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
      L1 = LST1(1,ILST1)
      L2 = LST1(2,ILST1)
      L3 = LST1(3,ILST1)
      L4 = LST1(4,ILST1)
      V = VAL1(L4)
      IX = INCX1*(L1-1)+1
      I_F = INCF1*(L2-1)+1
      if ((I_F < 1) .or. (I_F > nF)) cycle
      IY = INCY1*(L3-1)+1
      ! X(L1,i) := Add V*F(L2,a)*Y(L3,i,a), i=1..LEN1, a=1..LEN2
      do I=1,LEN1
        X(IX) = X(IX)+V*DDOT_(LEN2,F(I_F),INCF2,Y(IY),INCY3)
        IX = IX+INCX2
        IY = IY+INCY2
      end do
    end do
  case (1)
    do ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
      L1 = LST1(1,ILST1)
      L2 = LST1(2,ILST1)
      L3 = LST1(3,ILST1)
      L4 = LST1(4,ILST1)
      V = VAL1(L4)
      IX = INCX1*(L1-1)+1
      I_F = INCF1*(L2-1)+1
      if ((I_F < 1) .or. (I_F > nF)) cycle
      IY = INCY1*(L3-1)+1
      ! or Y(L3,i,a):= Add V*F(L2,a)*X(L1,i), i=1..LEN1, a=1..LEN2
      do I=1,LEN2
        A = V*F(I_F)
        call DAXPY_(LEN1,A,X(IX),INCX2,Y(IY),INCY2)
        IY = IY+INCY3
        I_F = I_F+INCF2
      end do
    end do
  case default
    do ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
      L1 = LST1(1,ILST1)
      L2 = LST1(2,ILST1)
      L3 = LST1(3,ILST1)
      L4 = LST1(4,ILST1)
      V = VAL1(L4)
      IX = INCX1*(L1-1)+1
      I_F = INCF1*(L2-1)+1
      if ((I_F < 1) .or. (I_F > nF)) cycle
      IY = INCY1*(L3-1)+1
      ! F(L2,a) := Add V*X(L1,i)*Y(L3,i,a)
      do I=1,LEN1
        A = V*X(IX)
        call DAXPY_(LEN2,A,Y(IY),INCY3,F(I_F),INCF2)
        IX = IX+INCX2
        IY = IY+INCY2
      end do
    end do
end select

NFMV = NFMV+2*NLST1*LEN1*LEN2

end subroutine MLTMV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRACID(       T,   LUCIN,  LUCOUT,   LUSC1,   LUSC2,
     &                     LUSC3,    VEC1,    VEC2)
*
* Transform CI vector on LUCIN with T matrix after
* Docent Malmquist's recipe. Place result as next vector on LUOUT
*
* The transformation is done as a sequence of one-electron transformations
*
* with each orbital transformation being
*
* Sum(k=0,2) ( 1/k! sum(n'.ne.n) S(n'n) E_{n'n} ) Tnn^N_n
*
* with Sn'n = T(n'n)/Tnn
*
* each transformation is
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "glbbas.fh"
#include "oper.fh"
#include "intform.fh"
#include "lucinp.fh"
#include "orbinp.fh"
#include "io_util.fh"
      COMMON/CANDS/ICSM,ISSM,ICSPC,ISSPC
      REAL*8 INPRDD
*. Input
      DIMENSION T(*)
*. Scratch blocks ( two of them)
      DIMENSION VEC1(*),VEC2(*)
*
      IDUM=0
*
      NTEST = 000
      LBLK = -1
      IDUM = 1
*. Transfer vector on LUCIN to LUSC1
C           COPVCD(LUIN,LUOUT,SEGMNT,IREW,LBLK)
      CALL  COPVCD(LUCIN,LUSC1,VEC1,1,LBLK)
*. A bit of info for the sigma routine
      I_RES_AB = 0
*. Do the one-electron update
        I12 = 1
*. With 1-electron integrals in complete block form
        IH1FORM = 2
*. Transform each orbital separately
      DO K = 1, NTOOB
*. Place (T(P,K)/S(K,K)   in one-electron integral list
C                       T_ROW_TO_H(T,H,K)
        CALL T_ROW_TO_H(T,WORK(KINT1),K,TKK)
*. T_{kk}^Nk
C            T_TO_NK_VEC(T,KORB,ISM,ISPC,LUCIN,LUCOUT,C)
        CALL T_TO_NK_VEC(     TKK,       K,    ISSM,   ISSPC,   LUSC1,
     &                      LUSC2,    VEC1)
        CALL COPVCD(LUSC2,LUSC1,VEC1,1,LBLK)
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' output from T_TO_NK'
          CALL WRTVCD(VEC1,LUSC1,1,LBLK)
        END IF
*. For each orbital calculate (1+T+1/2 T^2)|0>
* + T
        CALL MV7(VEC1,VEC2,LUSC1,LUSC2)
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' Correction vector'
          CALL WRTVCD(VEC1,LUSC2,1,LBLK)
        END IF
        ONE = 1.0D0
        CALL VECSMDP(     VEC1,     VEC2,      ONE,      ONE,    LUSC1,
     &                   LUSC2,    LUSC3,        1,     LBLK)
        CALL COPVCD(LUSC3,LUSC1,VEC1,1,LBLK)
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' Updated vector'
          CALL WRTVCD(VEC1,LUSC1,1,LBLK)
        END IF
*. + 1/2 T^2
        CALL MV7(VEC1,VEC2,LUSC2,LUSC3)
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' Correction vector'
          CALL WRTVCD(VEC1,LUSC3,1,LBLK)
        END IF
        ONE = 1.0D0
        HALF  = 0.5D0
        CALL VECSMDP(     VEC1,     VEC2,      ONE,     HALF,    LUSC1,
     &                   LUSC3,    LUSC2,        1,     LBLK)
*. and transfer back to LUSC1
        CALL COPVCD(LUSC2,LUSC1,VEC1,1,LBLK)
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' Updated vector'
          CALL WRTVCD(VEC1,LUSC1,1,LBLK)
        END IF
      END DO
*. And transfer to LUCOUT
      CNORM = INPRDD(VEC1,VEC2,LUSC1,LUSC1,1,LBLK)
      IF (NTEST .GT. 0) WRITE(6,*) ' Norm of transformed vector', CNORM
C?    WRITE(6,*) ' Transformed vector'
C?    CALL WRTVCD(VEC1,LUSC1,1,LBLK)
      IDISK(LUSC1)=0
C?    WRITE(6,*) ' LUCOUT LUSC1 = ', LUCOUT,LUSC1
      CALL COPVCD(LUSC1,LUCOUT,VEC1,0,LBLK)
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ddrestv_cvb(vec,avec,svec,ndim,ioffs,ause,suse)

use casvb_global, only: axc, c, maxd, nparm, nvguess, nvrestart, sxc
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndim, ioffs
real(kind=wp), intent(in) :: vec(ndim), avec(ndim), svec(ndim)
logical(kind=iwp), intent(in) :: ause, suse

nvguess = nvguess+1
nvrestart = nvrestart+1
if ((nvguess > maxd) .or. (nvrestart > maxd)) then
  write(u6,*) ' Too many guess vectors in Davidson!',nvguess,nvrestart,maxd
  call abend_cvb()
end if
if (ndim+ioffs > nparm) then
  write(u6,*) ' Illegal call to DDRESTV :',ndim,ioffs,nparm
  call abend_cvb()
end if
c(1:ioffs,nvrestart) = Zero
c(ioffs+1:ioffs+ndim,nvrestart) = vec(:)
c(ioffs+ndim+1:,nvrestart) = Zero
if (ause) then
  axc(1:ioffs,nvrestart) = Zero
  axc(ioffs+1:ioffs+ndim,nvrestart) = avec(:)
  axc(ioffs+ndim+1:,nvrestart) = Zero
end if
if (suse) then
  sxc(1:ioffs,nvrestart) = Zero
  sxc(ioffs+1:ioffs+ndim,nvrestart) = svec(:)
  sxc(ioffs+ndim+1:,nvrestart) = Zero
end if

return

end subroutine ddrestv_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Step4(SMatrix,nDim,TMatrix,iType)
*                                                                      *
************************************************************************
*                                                                      *
*     Step 4. LW S3 ->S4
*
      Implicit ReaL*8 (A-H,O-Z)
      Real*8 SMatrix(nDim*nDim),TMatrix(nDim*nDim)
      Integer iType(nDim)
#include "real.fh"
*
clg   write (*,*) 'Step 4', nDim
clg   Call RecPrt('T before LW 4',' ',TMatrix,nDim,nDim)
clg   Call RecPrt('S in step4 ',' ',SMatrix,nDim,nDim)
clg   write (*,*)
      k=0
      Do i=1,nDim
         Do j=1,nDim
            k=k+1
            If (i.ne.j .and.(iType(i).ne.iType(j))) then
               SMatrix(k)=Zero
            EndIf
         End Do
      End Do
clg   Call RecPrt('S before LW 4',' ',SMatrix,nDim,nDim)

      call dcopy_(nDim**2,[Zero],0,TMatrix,1)
      call dcopy_(nDim,[One],0,TMatrix,nDim+1)
      Call Lowdin(SMatrix,TMatrix,nDim)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine IndSft_Cho_2(TInt,lInt,iCmp,iShell,iBas,jBas,kBas,lBas,Shijij,iAO,iAOst,ijkl,SOint,nSOint)
!***********************************************************************
!  object: to sift and index the SO integrals.                         *
!                                                                      *
!          the indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          april '90                                                   *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: nIrrep
use Index_Functions, only: iTri, nTri_Elem
use SOAO_Info, only: iAOtSO, iOffSO
use Cholesky, only: iOff_col, iShlSO, iShP2Q, iShP2RS, iSOShl, LuPri, nBstSh, nnBstR, ShA, ShAB, ShB, ShC, ShCD, ShD
use sort_data, only: nSkip
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Constants, only: Zero, One
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: lInt, iCmp(4), iShell(4), iBas, jBas, kBas, lBas, iAO(4), iAOst(4), ijkl, nSOint
real(kind=wp), intent(inout) :: TInt(lInt)
logical(kind=iwp), intent(in) :: Shijij
real(kind=wp), intent(in) :: SOint(ijkl,nSOint)
integer(kind=iwp) :: A, AB, ABCD, B, C, CD, CDAB, D, i1, i12, i2, i3, i34, i4, IAB, ICD, ISHLAB, ISHLCD, ISHLI, ISHLJ, ISHLK, &
                     ISHLL, iSO, iSOi, iSym(0:7), ISYM_AB, ISYM_CD, ISYM_RS, ix, j, j1, j12, j2, j2max, j3, j4, jCmpMx, jSO, jSOj, &
                     jSym(0:7), k12, k34, kSO, kSOk, kSym(0:7), lCmpMx, lSO, lSOl, lSym(0:7), memSO2, nijkl, NTELM, NUMA, NUMB, &
                     NUMC, NUMD
logical(kind=iwp) :: qij, qijij, qkl, Shij, Shkl
#ifdef _DEBUGPRINT_
real(kind=wp) :: r1, r2, tr1 = Zero, tr2 = Zero
real(kind=wp), external :: ddot_

r1 = DDot_(ijkl*nSOInt,SOInt,1,[One],0)
r2 = DDot_(ijkl*nSOInt,SOInt,1,SOInt,1)
tr1 = tr1+r1
tr2 = tr2+r2
write(u6,*) ' Sum=',r1,tr1
write(u6,*) ' Dot=',r2,tr2
call RecPrt(' in indsft:SOint ',' ',SOint,ijkl,nSOint)
#endif

k12 = 0
k34 = 0
memSO2 = 0

NUMC = NBSTSH(SHC)
NUMD = NBSTSH(SHD)
NUMA = NBSTSH(SHA)
NUMB = NBSTSH(SHB)

ISHLCD = SHCD
ISHLAB = SHAB

! to avoid stupid compiler warnings:

C = 0
D = 0
A = 0
B = 0

NTELM = 0

! allocate space to store integrals to gether with their
! Symmetry batch and sequence number
! To avoid conflicts in using memory this is done in the
! subroutine PSOAO

! quadruple loop over elements of the basis functions angular
! description. loops are reduced to just produce unique SO integrals
! observe that we will walk through the memory in AOint in a
! sequential way.

Shij = iShell(1) == iShell(2)
Shkl = iShell(3) == iShell(4)
do i1=1,iCmp(1)
  do j=0,nIrrep-1
    ix = 0
    if (iAOtSO(iAO(1)+i1,j) > 0) ix = 2**j
    iSym(j) = ix
  end do
  jCmpMx = iCmp(2)
  if (Shij) jCmpMx = i1
  do i2=1,jCmpMx
    do j=0,nIrrep-1
      ix = 0
      if (iAOtSO(iAO(2)+i2,j) > 0) ix = 2**j
      jSym(j) = ix
    end do
    qij = i1 == i2
    if (iShell(2) > iShell(1)) then
      i12 = iCmp(2)*(i1-1)+i2
    else
      i12 = iCmp(1)*(i2-1)+i1
    end if
    do i3=1,iCmp(3)
      do j=0,nIrrep-1
        ix = 0
        if (iAOtSO(iAO(3)+i3,j) > 0) ix = 2**j
        kSym(j) = ix
      end do
      lCmpMx = iCmp(4)
      if (Shkl) lCmpMx = i3
      do i4=1,lCmpMx
        do j=0,nIrrep-1
          ix = 0
          if (iAOtSO(iAO(4)+i4,j) > 0) ix = 2**j
          lSym(j) = ix
        end do
        qkl = i3 == i4
        if (iShell(4) > iShell(3)) then
          i34 = iCmp(4)*(i3-1)+i4
        else
          i34 = iCmp(3)*(i4-1)+i3
        end if
        if (Shijij .and. (i34 > i12)) cycle
        qijij = Shijij .and. (i12 == i34)

        ! loop over Irreps which are spanned by the basis function.
        ! again, the loop structure is restricted to ensure unique
        ! integrals.

        do j1=0,nIrrep-1
          if (iSym(j1) == 0) cycle
          j2max = nIrrep-1
          if (Shij .and. qij) j2max = j1
          do j2=0,j2max
            if (jSym(j2) == 0) cycle
            j12 = ieor(j1,j2)
            if (qijij) then
              if (Shij .and. qij) then
                k12 = nTri_Elem(j1)+j2+1
              else if (Shij) then
                k12 = nIrrep*j1+j2+1
              else if (iShell(1) > iShell(2)) then
                k12 = nIrrep*j1+j2+1
              else
                k12 = nIrrep*j2+j1+1
              end if
            end if

            do j3=0,nIrrep-1
              if (kSym(j3) == 0) cycle
              j4 = ieor(j12,j3)
              if (lSym(j4) == 0) cycle
              if (Shkl .and. qkl .and. (j4 > j3)) cycle
              if (qijij) then
                if (Shkl .and. qkl) then
                  k34 = nTri_Elem(j3)+j4+1
                else if (Shkl) then
                  k34 = nIrrep*j3+j4+1
                else if (iShell(3) > iShell(4)) then
                  k34 = nIrrep*j3+j4+1
                else
                  k34 = nIrrep*j4+j3+1
                end if
                if (k34 > k12) cycle
              end if

              memSO2 = memSO2+1
              if ((nSkip(j1+1)+nSkip(j2+1)+nSkip(j3+1)+nSkip(j4+1)) /= 0) cycle

              ! Compute absolute starting SO index
              iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)+iOffSO(j1)
              jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)+iOffSO(j2)
              kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+iOffSO(j3)
              lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+iOffSO(j4)

              nijkl = 0
              do lSOl=lSO,lSO+lBas-1
                do kSOk=kSO,kSO+kBas-1
                  do jSOj=jSO,jSO+jBas-1
                    do iSOi=iSO,iSO+iBas-1
                      nijkl = nijkl+1

                      NTELM = NTELM+1

                      ISHLI = ISOSHL(ISOI)
                      ISHLJ = ISOSHL(JSOJ)
                      ISHLK = ISOSHL(KSOK)
                      ISHLL = ISOSHL(LSOL)

                      if ((ISHLI == SHC) .and. (ISHLJ == SHD) .and. (ISHLK == SHA) .and. (ISHLL == SHB)) then
                        C = ISHLSO(ISOI)
                        D = ISHLSO(JSOJ)
                        A = ISHLSO(KSOK)
                        B = ISHLSO(LSOL)
                      else if ((ISHLJ == SHC) .and. (ISHLI == SHD) .and. (ISHLK == SHA) .and. (ISHLL == SHB)) then
                        C = ISHLSO(JSOJ)
                        D = ISHLSO(ISOI)
                        A = ISHLSO(KSOK)
                        B = ISHLSO(LSOL)
                      else if ((ISHLI == SHC) .and. (ISHLJ == SHD) .and. (ISHLL == SHA) .and. (ISHLK == SHB)) then
                        C = ISHLSO(ISOI)
                        D = ISHLSO(JSOJ)
                        A = ISHLSO(LSOL)
                        B = ISHLSO(KSOK)
                      else if ((ISHLJ == SHC) .and. (ISHLI == SHD) .and. (ISHLL == SHA) .and. (ISHLK == SHB)) then
                        C = ISHLSO(JSOJ)
                        D = ISHLSO(ISOI)
                        A = ISHLSO(LSOL)
                        B = ISHLSO(KSOK)
                      else if ((ISHLK == SHC) .and. (ISHLL == SHD) .and. (ISHLI == SHA) .and. (ISHLJ == SHB)) then
                        C = ISHLSO(KSOK)
                        D = ISHLSO(LSOL)
                        A = ISHLSO(ISOI)
                        B = ISHLSO(JSOJ)
                      else if ((ISHLL == SHC) .and. (ISHLK == SHD) .and. (ISHLI == SHA) .and. (ISHLJ == SHB)) then
                        C = ISHLSO(LSOL)
                        D = ISHLSO(KSOK)
                        A = ISHLSO(ISOI)
                        B = ISHLSO(JSOJ)
                      else if ((ISHLK == SHC) .and. (ISHLL == SHD) .and. (ISHLJ == SHA) .and. (ISHLI == SHB)) then
                        C = ISHLSO(KSOK)
                        D = ISHLSO(LSOL)
                        A = ISHLSO(JSOJ)
                        B = ISHLSO(ISOI)
                      else if ((ISHLL == SHC) .and. (ISHLK == SHD) .and. (ISHLJ == SHA) .and. (ISHLI == SHB)) then
                        C = ISHLSO(LSOL)
                        D = ISHLSO(KSOK)
                        A = ISHLSO(JSOJ)
                        B = ISHLSO(ISOI)
                      else
                        write(LUPRI,*) 'Shell quadruple requested: ',SHC,SHD,SHA,SHB
                        write(LUPRI,*) 'Shell quadruple of element ',NTELM,':',ISHLI,ISHLJ,ISHLK,ISHLL
                        call CHO_QUIT('Logical error in IndSft_Cho_2',103)
                      end if

                      if (SHA == SHB) then
                        AB = ITRI(A,B)
                      else
                        AB = NUMA*(B-1)+A
                      end if
                      if (SHC == SHD) then
                        CD = ITRI(C,D)
                      else
                        CD = NUMC*(D-1)+C
                      end if

                      ICD = ISHP2RS(1,CD)
                      IAB = ISHP2Q(1,AB)
                      if ((ICD > 0) .and. (IAB > 0)) then
                        ISYM_CD = ISHP2RS(2,CD)
                        ISYM_AB = ISHP2Q(2,AB)
                        if (ISYM_AB == ISYM_CD) then
                          ISYM_RS = ISYM_AB
                        else
                          call CHO_QUIT('IndSft_Cho_2: sym. error [1]',104)
                          ISYM_RS = -9999999
                        end if
                        CDAB = IOFF_COL(ISYM_RS)+nnBstR(ISYM_RS,2)*(IAB-1)+ICD
                        TINT(CDAB) = SOint(nijkl,memSO2)
                      end if

                      if (ISHLCD == ISHLAB) then
                        if ((SHC == SHD) .or. (SHC == SHA)) then
                          IAB = ISHP2RS(1,AB)
                          ICD = ISHP2Q(1,CD)
                          if ((ICD > 0) .and. (IAB > 0)) then
                            ISYM_AB = ISHP2RS(2,AB)
                            ISYM_CD = ISHP2Q(2,CD)
                            if (ISYM_AB == ISYM_CD) then
                              ISYM_RS = ISYM_AB
                            else
                              call CHO_QUIT('IndSft_Cho_2: sym. error [2]',104)
                              ISYM_RS = -9999999
                            end if
                            ABCD = IOFF_COL(ISYM_RS)+nnBstR(ISYM_RS,2)*(ICD-1)+IAB
                            TINT(ABCD) = SOint(nijkl,memSO2)
                          end if
                        else if (SHC == SHB) then
                          AB = NUMB*(A-1)+B
                          CD = NUMD*(C-1)+D
                          IAB = ISHP2RS(1,AB)
                          ICD = ISHP2Q(1,CD)
                          if ((ICD > 0) .and. (IAB > 0)) then
                            ISYM_AB = ISHP2RS(2,AB)
                            ISYM_CD = ISHP2Q(2,CD)
                            if (ISYM_AB == ISYM_CD) then
                              ISYM_RS = ISYM_AB
                            else
                              call CHO_QUIT('IndSft_Cho_2: sym. error [3]',104)
                              ISYM_RS = -9999999
                            end if
                            ABCD = IOFF_COL(ISYM_RS)+nnBstR(ISYM_RS,2)*(ICD-1)+IAB
                            TINT(ABCD) = SOint(nijkl,memSO2)
                          end if
                        end if
                      end if

                    end do
                  end do
                end do
              end do

            end do
          end do
        end do

      end do
    end do
  end do
end do

return

end subroutine IndSft_Cho_2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995,2001, Roland Lindh                                *
!               2003, Michael Diedenhofen                              *
!***********************************************************************

subroutine COSGrd( &
#                 define _CALLING_
#                 include "grd_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of electronic COSMO cont. *
!         integrals.                                                   *
!                                                                      *
!             M. Diedenhofen Nov. 2003                                 *
!             changes pcmgrd routines which do not take into account   *
!             the contribution of a non fixed grid                     *
!     Author of orig routine: Roland Lindh,                            *
!             Dept. of Theoretical Chemistry, University               *
!             of Lund, Sweden, May '95                                 *
!                                                                      *
!             Modified to PCM gradients September 2001, Lund, by       *
!             R. Lindh.                                                *
!***********************************************************************

use PCM_arrays, only: PCM_SQ, PCMTess
use Center_Info, only: dc
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: i, iAlpha, iAnga(4), iBeta, iCar, iDAO, iDCRT(0:7), ii, iIrrep, ipA, ipAOff, ipB, ipBOff, ipDAO, iPrint, &
                     iRout, iStb(0:7), iTs, iuvwx(4), iZeta, j, JndGrd(3,4), kat, lDCRT, LmbdT, lOp(4), mGrad, mRys, nArray, nDAO, &
                     nDCRT, nDisp, nip, nRys, nStb, nT
real(kind=wp) :: C(3), CoorAC(3,2), Coori(3,4), Fact, Q, TC(3)
logical(kind=iwp) :: JfGrad(3,4)
character(len=3), parameter :: ChOper(0:7) = ['E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz']
integer(kind=iwp), external :: NrOpr
external :: Cff2D, Fake, TNAI1
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"
#include "rctfld.fh"

#include "macros.fh"
unused_var(rFinal)
unused_var(Ccoor(1))
unused_var(nComp)

iRout = 151
iPrint = nPrint(iRout)

nRys = nHer

! Modify the density matrix with the prefactor

nDAO = nTri_Elem1(la)*nTri_Elem1(lb)
do iDAO=1,nDAO
  do iZeta=1,nZeta
    Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
    DAO(iZeta,iDAO) = Fact*DAO(iZeta,iDAO)
  end do
end do
if (iPrint >= 99) call RecPrt('DAO',' ',DAO,nZeta,nDAO)

nip = 1
ipA = nip
nip = nip+nAlpha*nBeta
ipB = nip
nip = nip+nAlpha*nBeta
ipDAO = nip
nip = nip+nAlpha*nBeta*nTri_Elem1(la)*nTri_Elem1(lb)*nTri_Elem1(nOrdOp)
if (nip-1 > nZeta*nArr) then
  call WarningMessage(2,'Error in COSGrd')
  write(u6,*) 'nip-1 > nZeta*nArr'
  call Abend()
end if
nArray = nZeta*nArr-nip+1

iAnga(1) = la
iAnga(2) = lb
iAnga(3) = nOrdOp
iAnga(4) = 0
Coori(:,1) = A(:)
Coori(:,2) = RB(:)

! Find center to accumulate angular momentum on. (HRR)

if (la >= lb) then
  CoorAC(:,1) = A(:)
else
  CoorAC(:,1) = RB(:)
end if
iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
lOp(1) = kOp(1)
lOp(2) = kOp(2)

ipAOff = ipA
do iBeta=1,nBeta
  call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB
do iAlpha=1,nAlpha
  call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
  ipBOff = ipBOff+1
end do

! Loop over the tiles

do iTs=1,nTs
  Q = PCM_SQ(1,iTs)
  if (Q == Zero) cycle
  ! Pick up the tile coordinates
  C(1) = PCMTess(1,iTs)
  C(2) = PCMTess(2,iTs)
  C(3) = PCMTess(3,iTs)
  kat = nint(PCMTess(4,iTs))
  if (iPrint >= 99) call RecPrt('C',' ',C,3,1)

  ! Generate stabilizer of C

  nStb = 1
  iStb(0) = 0

  ! Find the DCR for M and S

  call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
  Fact = -real(nStabM,kind=wp)/real(LmbdT,kind=wp)

  if (iPrint >= 99) then
    write(u6,*) ' Q=',Q
    write(u6,*) ' Fact=',Fact
    call RecPrt('DAO*Fact*Q',' ',Array(ipDAO),nZeta*nDAO,nTri_Elem1(nOrdOp))
    write(u6,*) ' m      =',nStabM
    write(u6,'(9A)') '(M)=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
    write(u6,*) ' s      =',nStb
    write(u6,'(9A)') '(S)=',(ChOper(iStb(ii)),ii=0,nStb-1)
    write(u6,*) ' LambdaT=',LmbdT
    write(u6,*) ' t      =',nDCRT
    write(u6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),ii=0,nDCRT-1)
  end if
  iuvwx(3) = nStb
  iuvwx(4) = nStb

  JndGrd(:,1:2) = IndGrd(:,:)
  do i=1,3
    do j=1,2
      JfGrad(i,j) = IfGrad(i,j)
    end do
  end do
  ! skip contributions if the segment belongs to the atom
  if (mdc == kat) then
    ! skip 1 center
    JfGrad(1,1) = .false.
    JfGrad(2,1) = .false.
    JfGrad(3,1) = .false.
  end if
  if (ndc == kat) then
    ! skip 2 center
    JfGrad(1,2) = .false.
    JfGrad(2,2) = .false.
    JfGrad(3,2) = .false.
  end if

  ! up third center

  iIrrep = 0
  nDisp = IndDsp(kat,iIrrep)
  do iCar=0,2
    nDisp = nDisp+1
    JndGrd(iCar+1,1) = abs(JndGrd(iCar+1,1))
    JndGrd(iCar+1,2) = abs(JndGrd(iCar+1,2))
    JndGrd(iCar+1,3) = -nDisp
    JfGrad(iCar+1,3) = .false.
  end do

  JndGrd(:,4) = 0
  JfGrad(1,4) = .false.
  JfGrad(2,4) = .false.
  JfGrad(3,4) = .false.

  mGrad = 0
  do iCar=1,3
    do i=1,3
      if (JfGrad(iCar,i)) mGrad = mGrad+1
    end do
  end do
  if (iPrint >= 99) write(u6,*) ' mGrad=',mGrad
  if (mGrad == 0) cycle

  do lDCRT=0,nDCRT-1
    lOp(3) = NrOpr(iDCRT(lDCRT))
    lOp(4) = lOp(3)
    call OA(iDCRT(lDCRT),C,TC)
    CoorAC(:,2) = TC(:)
    Coori(:,3) = TC(:)
    Coori(:,4) = TC(:)

    Array(ipDAO:ipDAO+nZeta*nDAO-1) = Fact*Q*pack(DAO,.true.)

    ! Compute integrals with the Rys quadrature.

    nT = nZeta
    mRys = nRys

    call Rysg1(iAnga,mRys,nT,Array(ipA),Array(ipB),[One],[One],Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,Coori,Coori,CoorAC, &
               Array(nip),nArray,TNAI1,Fake,Cff2D,Array(ipDAO),nDAO*nTri_Elem1(nOrdOp),Grad,nGrad,JfGrad,JndGrd,lOp,iuvwx)

    !call RecPrt(' In COSgrd:Grad',' ',Grad,nGrad,1)
  end do  ! End loop over DCRs

end do    ! End loop over centers in the external field

return

end subroutine COSGrd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

function RinT(iOpT,nOpT,iOpR)
!***********************************************************************
!                                                                      *
! Object: to return .true. if R is in {T}.                             *
!                                                                      *
! Called from: TwoEl                                                   *
!                                                                      *
! Calling    : None                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             June '90                                                 *
!***********************************************************************

use Definitions, only: iwp

implicit none
logical(kind=iwp) :: RinT
integer(kind=iwp), intent(in) :: nOpT, iOpT(nOpT), iOpR
integer(kind=iwp) :: i

RinT = .false.
do i=1,nOpT
  if (iOpT(i) == iOpR) then
    RinT = .true.
    return
  end if
end do

end function RinT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine T2d_div (T2,OE,dima,dimb,adda,addb,no,nv)
c
c        this routine do:
c        T2(a',b',i,j) = T2(a',b',i,j/(e(i)+e(j)-e(a)-e(b))
c        for aGrp=beGrp, where only a'>=b',i,j are valid,
c        and completed also cases a'<b',i,j
c
c        divison of T2n amplitides by denominator
c
        implicit none
        integer dima,dimb,adda,addb,no,nv
        real*8 T2(1:dima,1:dimb,1:no,1:no)
        real*8 OE(1:no+nv)
c
c        help variables
        integer i,j,a,av,b,bv
        real*8 eija
c
        av=no+adda
        bv=no+addb
c
c1        divison by denominators
c
        do j=1,no
        do i=1,no
          do a=1,dima
          eija=OE(i)+OE(j)-OE(av+a)
          do b=1,a
            T2(a,b,i,j)=T2(a,b,i,j)/(eija-OE(bv+b))
          end do
        end do
        end do
        end do
c
c2        completing upper triangle
c
        do j=1,no
        do i=1,no
          do b=2,dima
          do a=1,b-1
             T2(a,b,i,j)=T2(b,a,j,i)
          end do
        end do
        end do
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Memory_PolPrep(Que,ixx,iyy,izz,irr3,ixxi,iyyi
     &                         ,izzi,iGri,nPol,nPart)
      Implicit Real*8 (a-h,o-z)

#include "numbers.fh"
#include "WrkSpc.fh"

      Character*(*) Que

      nSize=nPart*nPol
      Call GetMem('xx',Que,'Real',ixx,nSize**2)
      Call GetMem('yy',Que,'Real',iyy,nSize**2)
      Call GetMem('zz',Que,'Real',izz,nSize**2)
      Call GetMem('ixx',Que,'Real',ixxi,nSize**2)
      Call GetMem('iyy',Que,'Real',iyyi,nSize**2)
      Call GetMem('izz',Que,'Real',izzi,nSize**2)
      Call GetMem('irr3',Que,'Real',irr3,nSize**2)
      Call GetMem('iGri',Que,'Real',iGri,nSize**2)

      If(Que(1:4).eq.'Allo') then
        call dcopy_(nSize**2,[ZERO],iZERO,Work(ixx),iONE)
        call dcopy_(nSize**2,[ZERO],iZERO,Work(iyy),iONE)
        call dcopy_(nSize**2,[ZERO],iZERO,Work(izz),iONE)
        call dcopy_(nSize**2,[ZERO],iZERO,Work(ixxi),iONE)
        call dcopy_(nSize**2,[ZERO],iZERO,Work(iyyi),iONE)
        call dcopy_(nSize**2,[ZERO],iZERO,Work(izzi),iONE)
        call dcopy_(nSize**2,[ZERO],iZERO,Work(irr3),iONE)
        call dcopy_(nSize**2,[ZERO],iZERO,Work(iGri),iONE)
      Endif

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Steven Vancoillie                                *
!***********************************************************************
! Molcas task manager
! Steven Vancoillie, June 2015
!   Reimplementation of the task manager routines
!   based solely on atomic read+increment operations on
!   a global task counter.
!
!   For GA, we use the ga_read_inc function, and for DGA
!   we use the gtsk_nxtval function. The latter has a special
!   "gtsk_nxtval_even" sibling for better performance. It is
!   only used when both MPI and DGA are active. The routines
!   that use this special flavour can be found in the second
!   part of the file.
!
!   The task lists are stacked, and have to be freed in
!   the order of last initialized = freed first!

module Task_Manager

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: GA_Create, GA_Destroy, GA_Read_Inc, MT_INT
#endif
use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: mxtsklst = 4
integer(kind=iwp) :: list_counter = 0, ntasks(mxtsklst), task_counter(mxtsklst)

public :: free_tsk, free_tsk_even, init_tsk, init_tsk_even, rsv_tsk, rsv_tsk_even

contains

subroutine init_tsk(id,n)

  integer(kind=iwp), intent(out) :: id
  integer(kind=iwp), intent(in) :: n

  if (list_counter == mxtsklst) call sysabendmsg('init_tsk','no free task lists available',' ')
  list_counter = list_counter+1

  id = list_counter
  ntasks(id) = n
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    if (.not. ga_create(MT_INT,1,1,'gltskl',0,0,task_counter(id))) &
      call sysabendmsg('init_tsk','failed to create global task list',' ')
#   ifdef _GA_
    call ga_fill(task_counter(id),1)
#   else
    call ga_zero(task_counter(id))
    call gtsk_setup(id,task_counter(id))
#   endif
  else
    task_counter(id) = 1
  end if
# else
  task_counter(id) = 1
# endif

end subroutine init_tsk

subroutine free_tsk(id)

  integer(kind=iwp), intent(in) :: id

  if (list_counter == 0) call sysabendmsg('free_tsk','attempting to free a non-existent task list.',' ')
  if (id /= list_counter) call sysabendmsg('free_tsk','only stack-based task lists are supported.',' ')
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    if (.not. ga_destroy(task_counter(id))) call sysabendmsg('free_tsk','failed to destroy global task list.',' ')
#   ifndef _GA_
    call gtsk_reset(id)
#   endif
  end if
# endif
  list_counter = list_counter-1

end subroutine free_tsk

function rsv_tsk(id,task)

  logical(kind=iwp) :: rsv_tsk
  integer(kind=iwp), intent(in) :: id
  integer(kind=iwp), intent(out) :: task

# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    ! (atomically) read+increment next task number
#   ifdef _GA_
    task = ga_read_inc(task_counter(id),1,1,1)
#   else
    task = gtsk_nxtval(id,1)
#   endif
  else
    task = task_counter(id)
    task_counter(id) = task_counter(id)+1
  end if
# else
  task = task_counter(id)
  task_counter(id) = task_counter(id)+1
# endif
  rsv_tsk = task <= ntasks(id)

end function rsv_tsk

!****************************************************************
! The "even" flavour of the task routines just give each process
! a spread of numbers just as they would do with a loop stride.
!****************************************************************
subroutine init_tsk_even(id,n)

# ifdef _MOLCAS_MPP_
  use Para_Info, only: MyRank
# endif

  integer(kind=iwp), intent(out) :: id
  integer(kind=iwp), intent(in) :: n

  if (list_counter == mxtsklst) call sysabendmsg('init_tsk_even','no free task lists available',' ')
  list_counter = list_counter+1

  id = list_counter
  ntasks(id) = n
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    task_counter(id) = myrank+1
  else
    task_counter(id) = 1
  end if
# else
  task_counter(id) = 1
# endif

end subroutine init_tsk_even

subroutine free_tsk_even(id)

  integer(kind=iwp), intent(in) :: id

  if (list_counter == 0) call sysabendmsg('free_tsk_even','attempting to free a non-existent task list.',' ')
  if (id /= list_counter) call sysabendmsg('free_tsk_even','only stack-based task lists are supported.',' ')
  list_counter = list_counter-1

end subroutine free_tsk_even

function rsv_tsk_even(id,task)

# ifdef _MOLCAS_MPP_
  use Para_Info, only: nProcs
# endif

  logical(kind=iwp) :: rsv_tsk_even
  integer(kind=iwp), intent(in) :: id
  integer(kind=iwp), intent(out) :: task

# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    task = task_counter(id)
    ! the next task is a stride of <nprocs> away
    task_counter(id) = task_counter(id)+nprocs
  else
    task = task_counter(id)
    task_counter(id) = task_counter(id)+1
  end if
# else
  task = task_counter(id)
  task_counter(id) = task_counter(id)+1
# endif
  rsv_tsk_even = task <= ntasks(id)

end function rsv_tsk_even

end module Task_Manager

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine LOOP20(KM,ISTOP,IT1,IT2)

use guga_global, only: BL1, BL2, BS3, BS4, COUP, COUP1, IA, IB, ICOUP, ICOUP1, IWAY, IY, J1, J2, JM, JM1, K0, K1, K1F, K2, K2F, &
                       K3, K3F
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: KM, IT1, IT2
integer(kind=iwp), intent(out) :: ISTOP
integer(kind=iwp) :: IDIF, IWAYKM, KM1
real(kind=wp) :: WM0, WP0

ISTOP = 0
KM1 = KM+1
IDIF = IA(J1(KM1))-IA(J2(KM1))
if ((IDIF < -1) .or. (IDIF > 1)) then
  ISTOP = 1
else if (IDIF < 0) then
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    ! J+G
    IWAY(KM) = 2
    if ((K1(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 2
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)
      COUP(KM) = BL1(IB(J2(KM1))+3)*COUP(KM1)
    end if
  end if
  if (IWAYKM == 2) then
    ! L+H
    IWAY(KM) = 3
    if ((K3(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else if (K3F(JM(KM1)) == 0) then
      IWAYKM = 3
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM) = -BS4(IB(J2(KM1))+1)*COUP(KM1)
    end if
  end if
  if (IWAYKM == 3) ISTOP = 1
else if (IDIF == 0) then
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    ! (K+E,R+G)
    IWAY(KM) = 2
    if ((K2(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)
      WM0 = -One
      if (K1F(JM(KM1)) == 0) then
        WP0 = Zero
      else
        WP0 = -One/(IB(J2(KM1))+2)
      end if
      COUP(KM) = WM0*COUP1(KM1)+WP0*COUP(KM1)
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 2
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)
      WP0 = -One/(IB(J2(KM1))+2)
      COUP(KM) = WP0*COUP(KM1)
    end if
  end if
  if (IWAYKM == 2) then
    ! (Q+E,N+G)
    IWAY(KM) = 3
    if ((K1(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)
      WM0 = One/IB(J2(KM1))
      if (K1F(JM(KM1)) == 0) then
        WP0 = Zero
      else
        WP0 = -One
      end if
      COUP(KM) = WM0*COUP1(KM1)+WP0*COUP(KM1)
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 3
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)
      WP0 = -One
      COUP(KM) = WP0*COUP(KM1)
    end if
  end if
  if (IWAYKM == 3) then
    ! L+F
    IWAY(KM) = 4
    if ((K3(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 4
    else if (K3F(JM1(KM1)) == 0) then
      IWAYKM = 4
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM) = -BS3(IB(J2(KM1))+1)*COUP1(KM1)
    end if
  end if
  if (IWAYKM == 4) then
    ! P+H
    IWAY(KM) = 5
    if ((K3(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 5
    else if (K3F(JM(KM1)) == 0) then
      IWAYKM = 5
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM) = -BS4(IB(J2(KM1))+1)*COUP(KM1)
    end if
  end if
  if (IWAYKM == 5) ISTOP = 1
else
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    ! O+E
    IWAY(KM) = 2
    if ((K2(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else if (K2F(JM1(KM1)) == 0) then
      IWAYKM = 2
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)
      COUP(KM) = BL2(IB(J2(KM1))-1)*COUP1(KM1)
    end if
  end if
  if (IWAYKM == 2) then
    ! P+F
    IWAY(KM) = 3
    if ((K3(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else if (K3F(JM1(KM1)) == 0) then
      IWAYKM = 3
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM) = -BS3(IB(J2(KM1))+1)*COUP1(KM1)
    end if
  end if
  if (IWAYKM == 3) ISTOP = 1
end if

return

end subroutine LOOP20

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2006,2007, Markus Reiher                          *
*               2004,2006, Alexander Wolf                              *
************************************************************************
      subroutine dkhparser_symbolic (dkhorder,xorder,paramtype,
     *                               dkhscfflg,no_prop,no_s,no_u)
c
c*****************************************************************************************
c
c                  Implementation of the scalar-relativistic
c
c                       I N F I N I T E - O R D E R
c
c      G E N E R A L I Z E D   D O U G L A S - K R O L L - H E S S  (DKH)
c
c                         T R A N S F O R M A T I O N
c
c                                    F O R
c
c             H A M I L T O N I A N   A N D   P R O P E R T Y
c
c                 2006 Markus Reiher and Alexander Wolf, ETH Zurich
c                      Infinite-order DKH
c                      {markus.reiher,alexander.wolf}@phys.chem.ethz.ch
c
c
c   Reference to the infinite-order DKH method:
c
c     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 2037--2047   part I   [Theory]
c     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 10945--10956 part II  [Algorithm]
c     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064102       part III (Properties-Theory
c     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064103       part IV  (Properties-Implem
c
c   Reference to the generalized higher-order DKH method:
c
c     A. Wolf, M. Reiher, B.A. Hess, J. Chem. Phys. 117 (2002) 9215
c
c-----------------------------------------------------------------------------------------
c
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.1.0
c
c   last modified: 15.01.2007 (M. Reiher, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,xorder
      character*(3) paramtype
      logical dkhscfflg,no_prop,no_s,no_u
c
      integer ordercounter(0:maxorder),opcounter,
     *         xordercounter(0:maxorder),xopcounter
#if defined(_MOLCAS_) || defined(MOLPRO)
#include "WrkSpc.fh"
      integer operators,lwop,nwop,intrea,doperators,
     *        operleng,oporder,evenodd,xoperleng,xoporder,
     *        xevenodd,xdoperators,xoperators,dwops,wops,
     *        wopsleng,woporder,eowops,termleng,termleng2,
     *        termorder,dtcoeff,dtcoeff2
#else
Cfrueher      common/cdkhops1/ operators,xoperators,wops
      integer operleng(maxoperators),oporder(maxoperators,3),
     *        evenodd(maxoperators),
     *        xoperleng(maxoperators),xoporder(maxoperators),
     *        xevenodd(maxoperators),
     *        termleng(maxoperators),termleng2(maxoperators),
     *        termorder(maxoperators2,3)
      REAL*8 dtcoeff(maxoperators),dtcoeff2(maxoperators)
      REAL*8 doperators(maxoperators),
     *                 xdoperators(maxoperators)
      character*(maxlength) operators(maxoperators),
     *                      xoperators(maxoperators)
cweg  W-operators
      REAL*8 dwops(maxuops)
      character*(maxlength) wops(maxuops)
      integer wopsleng(maxuops),woporder(maxuops,3),eowops(maxuops)
#endif
c
      integer wordercounter(maxorder),wopscounter
c
      integer sused,snumber,scounter(maxsnumber),stimes(maxsnumber),
     *        wstimes(maxuops,maxsnumber),sorder(maxsnumber,3),
     *        smult(maxsnumber),scrleng(maxsnumber),stimestot
      integer tnumber,tcounter(maxsnumber),ttimes(maxsnumber),
     *        tmult(maxsnumber),tscrleng(maxsnumber),ttimestot
      integer uused,unumber,utimes(maxunumber),uorder(maxunumber,3),
     *        umult(maxunumber),uscrleng(maxunumber),utimestot,umulttot
      character*(3) uscrchar(maxunumber)
      character*(4) s(maxsnumber),t(maxsnumber),u(maxunumber)
      character*(9) scrchar(maxsnumber)
      character*(11) tscrchar(maxsnumber)
c
      REAL*8 dkhzerothrsh(0:maxorder)
      integer totmult
c
c-------------------------------------------------------------------------------
c
CMR
CMR NOTE: One might hard wire all low-order expressions as an option
CMR       here - however, since the set up is fast it might not be
CMR       worth the effort.
CMR
c
c-------------------------------------------------------------------------------
c
      call output1 (dkhorder,xorder,paramtype,dkhscfflg)
c
#if defined(_MOLCAS_) || defined(MOLPRO)
      lwop=8/intrea()
      nwop=(maxlength-1)/lwop+1
      call getmem('operators','Allo','Char',operators,maxoperators*nwop)
      call getmem('doperators','Allo','Real',doperators,maxoperators)
      call getmem('operleng','Allo','Inte',operleng,maxoperators)
      call getmem('oporder','Allo','Inte',oporder,maxoperators*3)
      call getmem('evenodd','Allo','Inte',evenodd,maxoperators)
      call getmem('dwops','Allo','Real',dwops,maxuops)
      call getmem('wops','Allo','Char',wops,maxuops*maxlength) !fix this
      call getmem('wopsleng','Allo','Inte',wopsleng,maxuops)
      call getmem('woporder','Allo','Inte',woporder,maxuops*3)
      call getmem('eowops','Allo','Inte',eowops,maxuops)
      call getmem('xoperators','Allo','Char',xoperators,
     *            maxoperators*nwop)
      call getmem('xdoperators','Allo','Real',xdoperators,maxoperators)
      call getmem('xoperleng','Allo','Inte',xoperleng,maxoperators)
      call getmem('xoporder','Allo','Inte',xoporder,maxoperators)
      call getmem('xevenodd','Allo','Inte',xevenodd,maxoperators)
      call getmem('termleng','Allo','Inte',termleng,maxoperators)
      call getmem('termleng2','Allo','Inte',termleng2,maxoperators)
      call getmem('termorder','Allo','Inte',termorder,3*maxoperators)
      call getmem('dtcoeff','Allo','Real',dtcoeff,maxoperators)
      call getmem('dtcoeff2','Allo','Real',dtcoeff2,maxoperators)
*                                                                      *
************************************************************************
*                                                                      *
c
      call get_dkhstring (dkhorder,xorder,paramtype,dkhscfflg,
     *          ordercounter,opcounter,iwork(operleng),iwork(oporder),
     *          iwork(evenodd),work(doperators),cwork(operators),
     *          xordercounter,xopcounter,iwork(xoperleng),
     *          iwork(xoporder),iwork(xevenodd),work(xdoperators),
     *          cwork(xoperators),wordercounter,
     *          wopscounter,iWork(wopsleng),iWork(woporder),
     *          iWork(eowops),Work(dwops),cWork(wops),dkhzerothrsh)
c
      call subs_dkhstring (dkhorder,xorder,dkhscfflg,ordercounter,
     *          opcounter,iwork(operleng),iwork(oporder),iwork(evenodd),
     *          work(doperators),cwork(operators),
     *          xordercounter,xopcounter,iwork(xoperleng),
     *          iwork(xoporder),iwork(xevenodd),work(xdoperators),
     *          cwork(xoperators),wordercounter,wopscounter,
     *          iWork(wopsleng),iWork(woporder),iWork(eowops),
     *          Work(dwops),cWork(wops),sused,snumber,scounter,stimes,
     *          wstimes,sorder,smult,s,scrchar,scrleng,stimestot,
     *          tnumber,tcounter,ttimes,tmult,t,tscrchar,tscrleng,
     *          ttimestot,no_s)
c
      call red_dkhstring (dkhorder,xorder,paramtype,dkhscfflg,
     *             ordercounter,opcounter,iwork(operleng),
     *             iwork(oporder),iwork(evenodd),
     *             work(doperators),cwork(operators),xordercounter,
     *             xopcounter,iwork(xoperleng),iwork(xoporder),
     *             iwork(xevenodd),work(xdoperators),cwork(xoperators),
     *             wordercounter,wopscounter,iWork(wopsleng),
     *             iWork(woporder),iWork(eowops),Work(dwops),
     *             cWork(wops),
     *             iwork(termleng),iwork(termleng2),iwork(termorder),
     *             work(dtcoeff),work(dtcoeff2),
     *             sused,snumber,scounter,stimes,wstimes,
     *             sorder,smult,s,scrchar,scrleng,stimestot,tnumber,
     *             tcounter,ttimes,tmult,t,tscrchar,tscrleng,ttimestot,
     *             uused,unumber,utimes,uorder,umult,u,uscrchar,
     *             uscrleng,totmult,dkhzerothrsh,no_u)
c
      call evaluate_Sxxx (dkhorder,xorder,paramtype,dkhscfflg,
     *             wordercounter,iWork(wopsleng),iWork(woporder),
     *             iWork(eowops),Work(dwops),cWork(wops),
     *             iwork(termleng),iwork(termleng2),iwork(termorder),
     *             work(dtcoeff),work(dtcoeff2),
     *             sused,snumber,scounter,stimes,wstimes,sorder,smult,s,
     *             scrchar,scrleng,stimestot,tnumber,tcounter,ttimes,
     *             tmult,t,tscrchar,tscrleng,ttimestot,uused,unumber,
     *             utimes,uorder,umult,u,uscrchar,uscrleng,totmult,
     *             dkhzerothrsh)
c
      call evaluate_Txxx (dkhorder,xorder,paramtype,dkhscfflg,
     *             wordercounter,iWork(wopsleng),iWork(woporder),
     *             iWork(eowops),Work(dwops),cWork(wops),
     *             iwork(termleng),iwork(termleng2),iwork(termorder),
     *             work(dtcoeff),work(dtcoeff2),
     *             sused,snumber,scounter,stimes,wstimes,sorder,s,
     *             scrchar,scrleng,stimestot,tnumber,tcounter,ttimes,
     *             tmult,t,tscrchar,tscrleng,ttimestot,uused,unumber,
     *             utimes,uorder,umult,u,uscrchar,uscrleng,utimestot,
     *             umulttot,totmult,dkhzerothrsh)
c
      call evaluate_Uxxx (dkhorder,xorder,paramtype,dkhscfflg,uused,
     *                    unumber,utimes,uorder,umult,u,uscrchar,
     *                    uscrleng,utimestot,umulttot,totmult)
*                                                                      *
************************************************************************
*                                                                      *
c
      call getmem('dtcoeff2','Free','Real',dtcoeff2,maxoperators)
      call getmem('dtcoeff','Free','Real',dtcoeff,maxoperators)
      call getmem('termorder','Free','Inte',termorder,3*maxoperators)
      call getmem('termleng2','Free','Inte',termleng2,maxoperators)
      call getmem('termleng','Free','Inte',termleng,maxoperators)
      call getmem('xevenodd','Free','Inte',xevenodd,maxoperators)
      call getmem('xoporder','Free','Inte',xoporder,maxoperators)
      call getmem('xoperleng','Free','Inte',xoperleng,maxoperators)
      call getmem('xdoperators','Free','Real',xdoperators,maxoperators)
      call getmem('xoperators','Free','Char',xoperators,maxoperators*
     *            nwop)
      call getmem('eowops','Free','Inte',eowops,maxuops)
      call getmem('woporder','Free','Inte',woporder,maxuops*3)
      call getmem('wopsleng','Free','Inte',wopsleng,maxuops)
      call getmem('wops','Free','Char',wops,maxuops)
      call getmem('dwops','Free','Real',dwops,maxuops)
      call getmem('evenodd','Free','Inte',evenodd,maxoperators)
      call getmem('oporder','Free','Inte',oporder,maxoperators*3)
      call getmem('operleng','Free','Inte',operleng,maxoperators)
      call getmem('doperators','Free','Real',doperators,maxoperators)
      call getmem('operators','Free','Char',operators,maxoperators*nwop)
#else
      call get_dkhstring (dkhorder,xorder,paramtype,dkhscfflg,
     *          ordercounter,opcounter,operleng,oporder,evenodd,
     *          doperators,operators,xordercounter,xopcounter,xoperleng,
     *          xoporder,xevenodd,xdoperators,xoperators,wordercounter,
     *          wopscounter,wopsleng,woporder,eowops,dwops,wops,
     *          dkhzerothrsh)
      call subs_dkhstring (dkhorder,xorder,dkhscfflg,ordercounter,
     *          opcounter,operleng,oporder,evenodd,doperators,operators,
     *          xordercounter,xopcounter,xoperleng,xoporder,xevenodd,
     *          xdoperators,xoperators,wordercounter,wopscounter,
     *          wopsleng,woporder,eowops,dwops,wops,sused,snumber,
     *          scounter,stimes,wstimes,sorder,smult,s,scrchar,scrleng,
     *          stimestot,tnumber,tcounter,ttimes,tmult,t,tscrchar,
     *          tscrleng,ttimestot,no_s)
      call red_dkhstring (dkhorder,xorder,paramtype,dkhscfflg,
     *             ordercounter,opcounter,operleng,oporder,evenodd,
     *             doperators,operators,xordercounter,xopcounter,
     *             xoperleng,xoporder,xevenodd,xdoperators,xoperators,
     *             wordercounter,wopscounter,wopsleng,woporder,eowops,
     *             dwops,wops,
     *             termleng,termleng2,termorder,dtcoeff,dtcoeff2,
     *             sused,snumber,scounter,stimes,wstimes,
     *             sorder,smult,s,scrchar,scrleng,stimestot,tnumber,
     *             tcounter,ttimes,tmult,t,tscrchar,tscrleng,ttimestot,
     *             uused,unumber,utimes,uorder,umult,u,uscrchar,
     *             uscrleng,totmult,dkhzerothrsh,no_u)
      call evaluate_Sxxx (dkhorder,xorder,paramtype,dkhscfflg,
     *             wordercounter,wopsleng,woporder,eowops,dwops,wops,
     *             termleng,termleng2,termorder,dtcoeff,dtcoeff2,
     *             sused,snumber,scounter,stimes,wstimes,sorder,smult,s,
     *             scrchar,scrleng,stimestot,tnumber,tcounter,ttimes,
     *             tmult,t,tscrchar,tscrleng,ttimestot,uused,unumber,
     *             utimes,uorder,umult,u,uscrchar,uscrleng,totmult,
     *             dkhzerothrsh)
      call evaluate_Txxx (dkhorder,xorder,paramtype,dkhscfflg,
     *             wordercounter,wopsleng,woporder,eowops,dwops,wops,
     *             termleng,termleng2,termorder,dtcoeff,dtcoeff2,
     *             sused,snumber,scounter,stimes,wstimes,sorder,s,
     *             scrchar,scrleng,stimestot,tnumber,tcounter,ttimes,
     *             tmult,t,tscrchar,tscrleng,ttimestot,uused,unumber,
     *             utimes,uorder,umult,u,uscrchar,uscrleng,utimestot,
     *             umulttot,totmult,dkhzerothrsh)
      call evaluate_Uxxx (dkhorder,xorder,paramtype,dkhscfflg,uused,
     *                    unumber,utimes,uorder,umult,u,uscrchar,
     *                    uscrleng,utimestot,umulttot,totmult)
#endif
c
c
CMR      write (stdout,2001)
CMR2001  format (/2X,'Symbolic DKH PARSER routines "dkhparser1" ',
CMR     *        'successfully completed.',//2X)
c
#ifdef _MOLCAS_
      if (dbgflg.ge.1) close (dbgunit)
#endif
c
      If (DKH_Verbose) Then
         Write (stdout,1111)
 1111    Format (//2X,
     &        'Start evaluation of the DKH Hamiltonian by matrix ',
     &        'multiplies ...')
      End If
*
      return
c Avoid unused argument warnings
      if (.false.) call Unused_logical(no_prop)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CSDTVC_MCLR_2(CSFVEC,DETVEC,DTOCMT,ICTSDT,IREFSM,ICOPY)
! DETERMINANT TO CSF TRANSFORMATION
!
! ICOPY /= 0 : Copy output into input
!              so input becomes output while
!              output remains output

use MCLR_Data, only: NCNATS, NCPCNT, NCSASM, NDPCNT, NDTASM, NTYP
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: CSFVEC(*)
real(kind=wp), intent(inout) :: DETVEC(*)
real(kind=wp), intent(in) :: DTOCMT(*)
integer(kind=iwp), intent(in) :: ICTSDT(*), IREFSM, ICOPY
integer(kind=iwp) :: ICNF, ICSF, IDET, IOFFCD, IOFFCS, IOFFDT, ITYP, NCSF, NDET

NDET = NDTASM(IREFSM)
NCSF = NCSASM(IREFSM)

! ===================================
!  Determinant to csf transformation
! ===================================

! To CSF ordering

call GATVCS(CSFVEC,DETVEC,ICTSDT,NDET)
DETVEC(1:NDET) = CSFVEC(1:NDET)
! Multiply with CIND expansion matrix
IOFFCS = 1
IOFFDT = 1
IOFFCD = 1
do ITYP=1,NTYP
  IDET = NDPCNT(ITYP)
  ICSF = NCPCNT(ITYP)
  ICNF = NCNATS(ITYP,IREFSM)
  if (ITYP > 1) then
    IOFFCS = IOFFCS+NCNATS(ITYP-1,IREFSM)*NCPCNT(ITYP-1)
    IOFFDT = IOFFDT+NCNATS(ITYP-1,IREFSM)*NDPCNT(ITYP-1)
    IOFFCD = IOFFCD+NDPCNT(ITYP-1)*NCPCNT(ITYP-1)
  end if
  if (IDET*ICNF*ICSF > 0) call DGEMM_('T','N',ICSF,ICNF,IDET,ONE,DTOCMT(IOFFCD),IDET,DETVEC(IOFFDT),IDET,ZERO,CSFVEC(IOFFCS),ICSF)
end do
if (ICOPY /= 0) DETVEC(1:NCSF) = CSFVEC(1:NCSF)

end subroutine CSDTVC_MCLR_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RDJOB(JOB,READ_STATES)
      use rassi_global_arrays, only: JBNUM, LROOT
#ifdef _DMRG_
      use qcmaquis_interface_cfg
      use qcmaquis_info, only: qcmaquis_info_init, qcm_group_names,
     &    qcm_prefixes
      use rasscf_data, only: doDMRG
#endif
      use mspt2_eigenvectors
#ifdef _HDF5_
      use mh5, only: mh5_is_hdf5, mh5_open_file_r, mh5_exists_attr,
     &               mh5_exists_dset, mh5_fetch_attr, mh5_fetch_dset,
     &               mh5_close_file
#endif
      IMPLICIT NONE
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='RDJOB')
#include "rasdim.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "symmul.fh"
#include "rasdef.fh"
#include "rassi.fh"
#include "jobin.fh"
#include "WrkSpc.fh"
#include "Struct.fh"
#include "SysDef.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
      integer :: refwfn_id

      integer :: ref_nSym, ref_stSym, ref_nBas(mxSym), ref_iSpin
      integer :: ref_nfro(mxSym), ref_nish(mxSym), ref_nrs1(mxSym),
     &           ref_nrs2(mxSym), ref_nrs3(mxSym), ref_nssh(mxSym),
     &           ref_ndel(mxSym), ref_nash(mxSym)
      integer :: ref_nactel, ref_nhole1, ref_nelec3, ref_nconf
      integer :: ref_nstates, ref_nroots
      integer, allocatable :: ref_rootid(:)
      integer :: root2state(MxRoot)

      character(len=1), allocatable :: typestring(:)

      real*8, allocatable :: ref_Heff(:,:), ref_energies(:)
#endif

      Real*8 Weight(MxRoot), ENUCDUMMY, AEMAX, E, HIJ
      Integer IAD, IAD15, IDISK, IERR, IDUM(1)
      Integer IPT2
      Integer ISY, IT
      Integer I, J, ISTATE, JSTATE, ISNUM, JSNUM, iAdr
      Integer LEJOB, LHEFF, NEJOB, NHEFF, NIS, NIS1, NTIT1, NMAYBE
      INTEGER JOB, NROOT0
      LOGICAL READ_STATES
#ifdef _HDF5_
      character(len=16) :: molcas_module
      character(len=8)  :: heff_string
      character(len=21) :: pt2_e_string
#endif

#ifdef _DMRG_
      integer :: idx
      character(len=300) :: currdir
#endif


#ifdef _HDF5_
************************************************************************
*
* For HDF5 formatted job files
*
************************************************************************
      If (mh5_is_hdf5(jbname(job))) Then

      IF (IPGLOB.GE.USUAL) THEN
        IF (JOB.EQ.1) THEN
          WRITE(6,*)
          WRITE(6,'(6X,80A1)') ('*',i=1,80)
          WRITE(6,'(6X,A1,78X,A1)') '*','*'
          WRITE(6,'(6X,A1,24X,A,24X,A1)')
     &       '*','     General data section     ','*'
          WRITE(6,'(6X,A1,78X,A1)') '*','*'
          WRITE(6,'(6X,80A1)') ('*',i=1,80)
        END IF
        WRITE(6,*)
        WRITE(6,*)'  Specific data for HDF5 file ',JBNAME(JOB)
        WRITE(6,*)'  -------------------------------------'
      END IF

      refwfn_id = mh5_open_file_r(jbname(job))

      call mh5_fetch_attr (refwfn_id,'MOLCAS_MODULE', molcas_module)
      call mh5_fetch_attr (refwfn_id,'SPINMULT', ref_iSpin)
      call mh5_fetch_attr (refwfn_id,'NSYM', ref_nSym)
      call mh5_fetch_attr (refwfn_id,'LSYM', ref_stSym)
      call mh5_fetch_attr (refwfn_id,'NBAS', ref_nBas)

      call mh5_fetch_attr (refwfn_id,'NACTEL', ref_nactel)
      call mh5_fetch_attr (refwfn_id,'NHOLE1', ref_nhole1)
      call mh5_fetch_attr (refwfn_id,'NELEC3', ref_nelec3)
      call mh5_fetch_attr (refwfn_id,'NCONF',  ref_nconf)
      call mh5_fetch_attr (refwfn_id,'NSTATES', ref_nstates)
      If (mh5_exists_attr(refwfn_id, 'NROOTS')) Then
        call mh5_fetch_attr (refwfn_id,'NROOTS', ref_nroots)
      Else
        ref_nroots = ref_nstates
      End If

      call mma_allocate (typestring, sum(ref_nbas(1:ref_nsym)))
      call mh5_fetch_dset (refwfn_id, 'MO_TYPEINDICES', typestring)
      call tpstr2orb (ref_nsym,ref_nbas,typestring,
     &                ref_nfro,ref_nish,ref_nrs1,ref_nrs2,ref_nrs3,
     &                ref_nssh,ref_ndel)
      ref_nash = ref_nrs1 + ref_nrs2 + ref_nrs3
      call mma_deallocate (typestring)

#ifdef _DMRG_
      If (.not.mh5_exists_dset(refwfn_id, 'CI_VECTORS').and.
     &    .not.doDMRG) Then
* Leon: TODO: This must be also extended for other DMRG interfaces
* than QCMaquis
#else
      If (.not.mh5_exists_dset(refwfn_id, 'CI_VECTORS')) then
#endif
        Write(6,'(1X,A)') 'The HDF5 file does not contain CI vectors,'
        Write(6,'(1X,A)') 'make sure it was created by rasscf/caspt2.'
        Call AbEnd()
      End If
      If (.not.mh5_exists_dset(refwfn_id, 'MO_VECTORS')) Then
        Write(6,'(1X,A)') 'The HDF5 file does not contain MO vectors,'
        Write(6,'(1X,A)') 'make sure it was created by '//
     &                    'rasscf/caspt2/nevpt2.'
        Call AbEnd()
      End If

*     call mh5_fetch_attr (refwfn_id,'L2ACT', L2ACT)
      call mh5_fetch_attr (refwfn_id,'A2LEV', LEVEL)

      call mma_allocate(ref_rootid,ref_nstates)
      call mh5_fetch_attr (refwfn_id,'STATE_ROOTID', ref_rootid)
      call iCopy(MxRoot,[0],0,root2state,1)
      If (mh5_exists_attr(refwfn_id, 'ROOT2STATE')) Then
         call mh5_fetch_attr (refwfn_id,'ROOT2STATE', root2state)
      Else
        Do i=1,ref_nroots
          root2state(i)=i
        End Do
      End if
      if (read_states) then
*  Do not update the state number here, because it's already read in
*  rdjob_nstates()
*        NSTAT(JOB)=ref_nstates
*        NSTATE=NSTATE+ref_nstates
* store the root IDs of each state
        DO I=0,NSTAT(JOB)-1
          LROOT(ISTAT(JOB)+I)=ref_rootid(I+1)
          JBNUM(ISTAT(JOB)+I)=JOB
        END DO
      end if
      LROT1=ref_nroots
      DO I=0,NSTAT(JOB)-1
        NROOT0=root2state(LROOT(ISTAT(JOB)+I))
        IF (NROOT0.LE.0.OR.NROOT0.GT.LROT1) THEN
          GOTO 9002
        END IF
      END DO

      if(qdpt2sc.and.(trim(molcas_module(1:6)).eq.'NEVPT2'))then
        heff_string     = 'H_EFF_SC'
        pt2_e_string    = 'STATE_PT2_ENERGIES_SC'
      else
        heff_string     = 'H_EFF'
        pt2_e_string    = 'STATE_PT2_ENERGIES'
      end if

* read the ms-caspt2/qd-nevpt2 effective hamiltonian if it is available
      If (mh5_exists_dset(refwfn_id, heff_string)) Then
        call mma_allocate(ref_Heff,ref_nstates,ref_nstates)
        call mh5_fetch_dset(refwfn_id,heff_string,ref_Heff)
        HAVE_HEFF=.TRUE.
* with ejob, only read diagonal
        If (ifejob) Then
          HAVE_DIAG=.TRUE.
!         call WarningMessage(0,'Effective Hamiltonian found in '//
!    &    ' reference file, but "EJOB" was requested: off-diagonal '//
!    &    ' elements will be ignored!')
          DO I=1,NSTAT(JOB)
            ISTATE=ISTAT(JOB)-1+I
            ISNUM=root2state(LROOT(ISTATE))
            Work(LREFENE+istate-1)=ref_Heff(ISNUM,ISNUM)
          END DO
        Else
          write(6,'(2x,a)')
     &   ' Effective Hamiltonian from MRPT2 in action'
          write(6,'(2x,a)')
     &   ' ------------------------------------------'
          DO I=1,NSTAT(JOB)
            ISTATE=ISTAT(JOB)-1+I
            ISNUM=root2state(LROOT(ISTATE))
            DO J=1,NSTAT(JOB)
              JSTATE=ISTAT(JOB)-1+J
              JSNUM=root2state(LROOT(JSTATE))
              iadr=(istate-1)*nstate+jstate-1
              Work(l_heff+iadr)=ref_Heff(ISNUM,JSNUM)
!             write(6,*) 'readin: Heff(',istate,',',jstate,') = ',
!    &        Work(l_heff+iadr)
!             call xflush(6)
            END DO
          END DO
        End If
        call mma_deallocate(ref_Heff)
* read the caspt2/qdnevpt2 reference energies if available
      Else If (mh5_exists_dset(refwfn_id, pt2_e_string)) Then
        HAVE_DIAG=.TRUE.
        call mma_allocate(ref_energies,ref_nstates)
        call mh5_fetch_dset(refwfn_id,pt2_e_string,ref_energies)
        DO I=1,NSTAT(JOB)
          ISTATE=ISTAT(JOB)-1+I
          ISNUM=root2state(LROOT(ISTATE))
          Work(LREFENE+istate-1)=ref_energies(ISNUM)
        END DO
        call mma_deallocate(ref_energies)
* read rasscf energies
      Else If (mh5_exists_dset(refwfn_id, 'ROOT_ENERGIES')) Then
        HAVE_DIAG=.TRUE.
        call mma_allocate(ref_energies,ref_nroots)
        call mh5_fetch_dset(refwfn_id,'ROOT_ENERGIES',ref_energies)
        DO I=1,NSTAT(JOB)
          ISTATE=ISTAT(JOB)-1+I
          ISNUM=root2state(LROOT(ISTATE))
          Work(LREFENE+istate-1)=ref_energies(ISNUM)
        END DO
        call mma_deallocate(ref_energies)
      End If

#ifdef _DMRG_
      call getenv("CurrDir", currdir)
      ! Leon 5/12/2016: Fetch QCMaquis checkpoint names if requested
      if (doDMRG) then
        if(mh5_exists_dset(refwfn_id, 'QCMAQUIS_CHECKPOINT')) then
          write(6,*) "  QCMaquis checkpoint files:"
          write(6,*) "  --------------------------"
          write(6,*) "  State   Checkpoint file  "

          !> allocate space for the file name strings of job JOB
          call qcmaquis_info_init(job,nstat(job),1)

          DO I=1,NSTAT(JOB)
            ISTATE=ISTAT(JOB)-1+I
            call mh5_fetch_dset(refwfn_id,'QCMAQUIS_CHECKPOINT',
     &                          qcm_group_names(job)%states(i:i),
     &                          [1],[LROOT(ISTATE)-1])
            Write(6,'(5X,I3,3X,A)') ISTATE,
     &      trim(qcm_group_names(job)%states(i))
          END DO
          write(6,*) "  --------------------------"
          !! save QCMaquis prefix
          !! by cutting off the last '.checkpoint_state.X.h5'
          !! and adding the full path
          if (size(qcm_group_names(job)%states).gt.0) then
            idx = index(qcm_group_names(job)%states(1),
     &        '.checkpoint_state.')
            if (idx.gt.0) then
              qcm_prefixes(job)=
     &        trim(currdir)//'/'//
     &        trim(qcm_group_names(job)%states(1)
     &        (1:idx-1))
            else
              CALL WarningMessage(2,"Faulty QCMaquis checkpoint name")
              write(6,*) 'Must contain "checkpoint_state"'
              Call Abend()
            end if
          end if
        else
          call WarningMessage(2,'QCMaquis checkpoint names not found'//
     &    ' on HDF5 files. Make sure you created them with the'//
     &    ' MOLCAS version which supports them')
          call Quit_OnUserError
        end if
      end if
#endif
      if (ref_nsym.ne.nsym) then
        call WarningMessage(2,'NSYM not consistent with RunFile')
        call Quit_OnUserError
      end if
      do i=1,nsym
        if (ref_nbas(i).ne.nbasf(i)) then
          call WarningMessage(2,'NBAS not consistent with RunFile')
          call Quit_OnUserError
        end if
      end do

      NACTE(JOB)=ref_nactel
      NHOLE1(JOB)=ref_nhole1
      NELE3(JOB)=ref_nelec3
      MLTPLT(JOB)=ref_iSpin
      IRREP(JOB)=ref_stSym
      NCONF(JOB)=ref_nConf
      NROOTS(JOB)=ref_nroots

      if (job.eq.1) then
* first wavefunction file, set global variables
        DO I=1,NSYM
          NFRO(I)=0
          NISH(I)=ref_nfro(I)+ref_nish(I)
          NASH(I)=ref_nash(I)
          NRS1(I)=ref_NRS1(I)
          NRS2(I)=ref_NRS2(I)
          NRS3(I)=ref_NRS3(I)
          NOSH(I)=NISH(I)+NASH(I)
          NDEL(I)=0
          NSSH(I)=NBASF(I)-NFRO(I)-NISH(I)-NASH(I)-NDEL(I)
        END DO
      else
* subsequent wavefunction file, check against global variables
        if ( ref_nhole1.ne.nhole1(1) .or.
     &       ref_nelec3.ne.nele3(1)) then
          call WarningMessage(2,'inconsistent RAS holes/electrons')
          call Quit_OnUserError
        end if
        do i=1,nsym
          if ((ref_nfro(i)+ref_nish(i).ne.nish(i)) .or.
     &        (ref_nash(i).ne.nash(i)) .or.
     &        (ref_nrs1(i).ne.nrs1(i)) .or.
     &        (ref_nrs2(i).ne.nrs2(i)) .or.
     &        (ref_nrs3(i).ne.nrs3(i)) ) then
            call WarningMessage(2,'inconsistent orbital partitioning')
            call Quit_OnUserError
          end if
        end do
      end if

      WFTYPE='GENERAL '
      IF(ref_nactel.EQ.2*SUM(NASH(1:NSYM))) WFTYPE='CLOSED  '
      IF(ref_nactel.EQ.0) WFTYPE='EMPTY   '
      RASTYP(JOB)=WFTYPE

      IF (IPGLOB.GE.USUAL) THEN
        WRITE(6,*)'  STATE IRREP:        ',IRREP(JOB)
        WRITE(6,*)'  SPIN MULTIPLICITY:  ',MLTPLT(JOB)
        WRITE(6,*)'  ACTIVE ELECTRONS:   ',NACTE(JOB)
#ifdef _DMRG_
        if (.not.doDMRG) then
#endif
        WRITE(6,*)'  MAX RAS1 HOLES:     ',NHOLE1(JOB)
        WRITE(6,*)'  MAX RAS3 ELECTRONS: ',NELE3(JOB)
        WRITE(6,*)'  NR OF CONFIG:       ',NCONF(JOB)
#ifdef _DMRG_
        end if
#endif
      END IF
      IF(IPGLOB.GE.VERBOSE)
     &          WRITE(6,*)'  Wave function type WFTYPE=',WFTYPE

      call mma_deallocate(ref_rootid)
      call mh5_close_file(refwfn_id)

      Else
#endif
************************************************************************
*
* For JOBIPH/JOBMIX formatted job files
*
************************************************************************
#ifdef _DMRG_
      if (doDMRG) then
        call WarningMessage(3, "QCMaquis requires checkpoint names "//
     & "from JOBxxx. This works only with HDF5 JobIph files."//
     &   " Please make sure you use a .h5 file as JOBxxx.")
          call abend()
      end if
#endif
      IF (IPGLOB.GE.USUAL) THEN
        IF (JOB.EQ.1) THEN
          WRITE(6,*)
          WRITE(6,'(6X,80A1)') ('*',i=1,80)
          WRITE(6,'(6X,A1,78X,A1)') '*','*'
          WRITE(6,'(6X,A1,24X,A,24X,A1)')
     &       '*','     General data section     ','*'
          WRITE(6,'(6X,A1,78X,A1)') '*','*'
          WRITE(6,'(6X,80A1)') ('*',i=1,80)
        END IF
        WRITE(6,*)
        WRITE(6,*)'  Specific data for JOBIPH file ',JBNAME(JOB)
        WRITE(6,*)'  -------------------------------------'
      END IF
C Open JOBIPH file:
      CALL DANAME(LUIPH,JBNAME(JOB))
C READ TABLE OF CONTENTS ON THIS JOBIPH FILE:
      IAD=0
      CALL IDAFILE(LUIPH,2,ITOC15,30,IAD)
C SCATTER-READ VARIOUS DATA:
* PAM Mar2014: Note that ENUC1 (=POTNUC) replaced by dummy placeholder
      IAD=ITOC15(1)
      Call WR_RASSCF_Info(LUIPH,2,IAD,
     &                    NACTE1,MPLET1,NSYM1,LSYM1,
     &                    NFRO1,NISH1,NASH1,NDEL1,NBAS1,mxSym,
     &                    NAME,LENIN8*mxOrb,NCONF1,HEAD1,2*72,
     &                    TITLE1,4*mxTit*18,
     &                    ENUCDUMMY,LROT1,NROOT1,
     &                    IROOT1,mxRoot,NRS11,NRS21,NRS31,
     &                    NHOL11,NELE31,IPT2,Weight)
C Response field contribution to zero-electron energies
C is added in GETH1.
      IF (READ_STATES) THEN
* Do not update the state number here, because it's already read in
* rdjob_nstates()
!        ISTAT(JOB)=NSTATE+1
!        NSTAT(JOB)=NROOT1
!        NSTATE=NSTATE+NROOT1
* store the root IDs of each state

*If unset yet, set now
        If (LROOT(ISTAT(JOB)).eq.0) Then
          DO I=0,NSTAT(JOB)-1
            LROOT(ISTAT(JOB)+I)=IROOT1(I+1)
            JBNUM(ISTAT(JOB)+I)=JOB
          End DO
        End If
      END IF
      DO I=0,NSTAT(JOB)-1
        NROOT0=LROOT(ISTAT(JOB)+I)
        IF (NROOT0.GT.LROT1) THEN
          GOTO 9002
        END IF
      END DO

C Using energy data from JobIph?
      IF(IFEJOB) THEN
        IF(ITOC15(15).EQ.-1) HAVE_HEFF=.TRUE.
        NEJOB=MXROOT*MXITER
        CALL GETMEM('EJOB','ALLO','REAL',LEJOB,NEJOB)
        IAD=ITOC15(6)
        CALL DDAFILE(LUIPH,2,WORK(LEJOB),NEJOB,IAD)
C Note that there is no info on nr of iterations
C so we cannot know what energies to pick...
C Let us make a guess: The correct set of energy values in the
C table of energies/iteration is the last one with not all zeroes.
        NMAYBE=0
        DO IT=1,MXITER
          AEMAX=0.0D0
          DO I=1,MXROOT
            E=WORK(LEJOB+MXROOT*(IT-1)+(I-1))
            AEMAX=MAX(AEMAX,ABS(E))
          END DO
          IF(ABS(AEMAX).LE.1.0D-12) GOTO 11
          NMAYBE=IT
        END DO
  11    CONTINUE
        IF(NMAYBE.EQ.0) THEN
          WRITE(6,*)' Sorry. Keyword ''EJOB'' has been used'
          WRITE(6,*)' but there are no energies available on'
          WRITE(6,*)' the JOBIPH file nr', JOB
          CALL ABEND()
        END IF
        HAVE_DIAG=.TRUE.

C Put these energies into diagonal of Hamiltonian:
        DO I=1,NSTAT(JOB)
          ISTATE=ISTAT(JOB)-1+I
#ifdef _DMRG_
          if (doDMRG) then
            E=WORK(LEJOB-1+LROOT(ISTATE)-ISTAT(JOB)+1+MXROOT*(NMAYBE-1))
          else
#endif
          E=WORK(LEJOB-1+LROOT(ISTATE)+MXROOT*(NMAYBE-1))
#ifdef _DMRG_
          endif
#endif
          Work(LREFENE+istate-1)=E
        END DO
        CALL GETMEM('EJOB','FREE','REAL',LEJOB,NEJOB)
      END IF
C Using effective Hamiltonian from JobIph file?
      IF(IFHEFF) THEN
        IF(ITOC15(15).NE.-1) THEN
          WRITE(6,*)'RDJOB Error: HEFF not found on JOBIPH.'
          WRITE(6,*)'The HEFF keyword was used, but the JOBIPH file'
          WRITE(6,*)'uses an old layout where this data field is'
          WRITE(6,*)'not present. Recompute JOBIPH file, or put'
          WRITE(6,*)'effective Hamiltonian in input after keyword'
          WRITE(6,*)'HEXT. Program stops here.'
          CALL ABEND()
        END IF
        HAVE_HEFF=.TRUE.
        NHEFF=LROT1**2
        CALL GETMEM('HEFF','ALLO','REAL',LHEFF,NHEFF)
        IAD15=ITOC15(17)
        CALL DDAFILE(LUIPH,2,WORK(LHEFF),NHEFF,IAD15)
C If both EJOB and HEFF are given, read only the diagonal
        IF(IFEJOB) THEN
          HAVE_DIAG=.TRUE.
          DO I=1,NSTAT(JOB)
            ISTATE=ISTAT(JOB)-1+I
            ISNUM=LROOT(ISTATE)
            HIJ=WORK(LHEFF-1+ISNUM+LROT1*(ISNUM-1))
            Work(LREFENE+istate-1)=HIJ
            iadr=(istate-1)*nstate+istate-1
            Work(l_heff+iadr)=HIJ
          END DO
        ELSE
          DO I=1,NSTAT(JOB)
            ISTATE=ISTAT(JOB)-1+I
            ISNUM=LROOT(ISTATE)
            DO J=1,NSTAT(JOB)
              JSTATE=ISTAT(JOB)-1+J
              JSNUM=LROOT(JSTATE)
              HIJ=WORK(LHEFF-1+ISNUM+LROT1*(JSNUM-1))
              iadr=(istate-1)*nstate+jstate-1
              Work(l_heff+iadr)=HIJ
              Work(LREFENE+istate-1)=HIJ
            END DO
          END DO
        END IF
        CALL GETMEM('HEFF','FREE','REAL',LHEFF,NHEFF)
      END IF
C Read the level to orbital translations
      IDISK=ITOC15(18)
      CALL IDAFILE(LUIPH,0,IDUM,MXLEV,IDISK) ! L2ACT
      CALL IDAFILE(LUIPH,2,LEVEL,MXLEV,IDISK)
C Close JobIph file
      CALL DACLOS(LUIPH)

C The RASSCF program is not certain to give consistent data. For
C pure CASSCF cases, it may not bother to set the NRS1..NRS3 arrays.
C Check and repair:
      IF(NHOL11+NELE31.EQ.0) THEN
        IERR=0
        DO I=1,NSYM1
          IF(NRS11(I).NE.0) IERR=1
          IF(NRS21(I).NE.NASH1(I)) IERR=1
          IF(NRS31(I).NE.0) IERR=1
        END DO
        IF(IERR.EQ.1) THEN
          WRITE(6,*)
          WRITE(6,*)' (NOTE: The nr of RAS1, RAS2 and RAS3 orbitals'//
     &              ' as recorded on the JOBIPH file do not match'
          WRITE(6,*)' the number of active orbitals. But this is a'//
     &              ' pure CASSCF case. Maybe the RASSCF programmer did'
          WRITE(6,*)' not bother with the RAS1..RAS3 arrays in that'//
     &              ' case. RASSI will reset these arrays as needed.)'
          WRITE(6,*)
          DO I=1,NSYM1
            NRS11(I)=0
            NRS21(I)=NASH1(I)
            NRS31(I)=0
          END DO
        END IF
      END IF

      IF(JOB.EQ.1) THEN
C FIRST JOB FILE. TRANSFER DATA TO COMMON:
        NSYM=NSYM1
        DO I=1,NSYM
          NFRO(I)=0
          NISH(I)=NFRO1(I)+NISH1(I)
          NASH(I)=NASH1(I)
          NRS1(I)=NRS11(I)
          NRS2(I)=NRS21(I)
          NRS3(I)=NRS31(I)
          NOSH(I)=NISH(I)+NASH(I)
          NDEL(I)=0
          NBASF(I)=NBAS1(I)
          NSSH(I)=NBASF(I)-NFRO(I)-NISH(I)-NASH(I)-NDEL(I)
        END DO
      ELSE
C THIS IS NOT THE FIRST JOBIPH.
C CHECK THAT DATA IS CONSISTENT WITH EARLIER:
        IF(NSYM1.NE.NSYM) GOTO 9001
        IF(NHOL11.ne.NHOLE1(JOB-1)) GOTO 9003
        IF(NELE31.ne.NELE3(JOB-1))  GOTO 9003
        DO ISY=1,NSYM1
          NIS1=NISH1(ISY)+NFRO1(ISY)
          NIS =NISH (ISY)
          IF(NIS1.NE.NIS ) GOTO 9004
          IF(NRS11(ISY).NE.NRS1 (ISY)) GOTO 9005
          IF(NRS21(ISY).NE.NRS2 (ISY)) GOTO 9005
          IF(NRS31(ISY).NE.NRS3 (ISY)) GOTO 9005
          IF(NBAS1(ISY).NE.NBASF(ISY)) GOTO 9006
        END DO
      END IF

C DATA PARTICULAR TO THIS JOBIPH:
      IF (IPGLOB.GE.USUAL) THEN
        WRITE(6,*)
        WRITE(6,*)'  Header from SEWARD:'
        WRITE(6,'(7X,36A2)')(HEAD1(I),I=1,36)
        WRITE(6,'(7X,36A2)')(HEAD1(I),I=37,72)
C NOTE: AT PRESENT, JOBIPH FILE GIVES NO INFORMATION ON THE
C AMOUNT OF TITLE LINES.
        NTIT1=1
        WRITE(6,*)
        WRITE(6,*)'  CASSCF title (first line only):'
        WRITE(6,'(7X,18A4)')((TITLE1(I,J),I=1,18),J=1,NTIT1)
        WRITE(6,*)
        WRITE(6,*)'  STATE IRREP:        ',LSYM1
        WRITE(6,*)'  SPIN MULTIPLICITY:  ',MPLET1
        WRITE(6,*)'  ACTIVE ELECTRONS:   ',NACTE1
        WRITE(6,*)'  MAX RAS1 HOLES:     ',NHOL11
        WRITE(6,*)'  MAX RAS3 ELECTRONS: ',NELE31
        WRITE(6,*)'  NR OF CONFIG:       ',NCONF1
      END IF
      WFTYPE='GENERAL '
*      IF(MPLET1.EQ.(SUM(NASH(1:NSYM))+1)) WFTYPE='HISPIN  '
* Note: the HISPIN case may be buggy and is not used presently.
      IF(MPLET1.EQ.(SUM(NASH(1:NSYM))+1)) THEN
       write(6,*)' This wave function is of HISPIN type.'
       write(6,*)' However, the special handling for that case'
       write(6,*)' is suspected to be buggy. So the variable'
       write(6,*)' WFTYPE is set to GENERAL.'
      END IF
      IF(NACTE1.EQ.2*SUM(NASH(1:NSYM))) WFTYPE='CLOSED  '
      IF(NACTE1.EQ.0) WFTYPE='EMPTY   '
      RASTYP(JOB)=WFTYPE
      IF(IPGLOB.GE.VERBOSE)
     &          WRITE(6,*)'  Wave function type WFTYPE=',WFTYPE
      NACTE(JOB)=NACTE1
      MLTPLT(JOB)=MPLET1
      IRREP(JOB)=LSYM1
      NHOLE1(JOB)=NHOL11
      NELE3(JOB)=NELE31
      NCONF(JOB)=NCONF1
C Where is the CMO data set stored?
      IDCMO(JOB)=ITOC15(2)
      IF(IPT2.NE.0) IDCMO(JOB)=ITOC15(9)

#ifdef _HDF5_
      End If
#endif

      CALL XFLUSH(6)
      RETURN
************************************************************************
*
* Error exits
*
************************************************************************
9001  WRITE(6,*) ' SYMMETRY GROUPS MUST BE EQUAL.'
      WRITE(6,*) ' NSYM1:',NSYM1,'NSYM :',NSYM
      GOTO 9010
9002  WRITE(6,*) ' ROOT NOT AVAILABLE.'
      WRITE(6,*) '             REQUESTED ROOT:',NROOT0
      WRITE(6,*) '  MAXIMUM ROOT IN THIS FILE:',LROT1
      GOTO 9010
9003  WRITE(6,*) ' RAS SPECIFICATIONS DIFFER.'
      WRITE(6,*) '     THIS STATE: MAX NR OF RAS-1 HOLES:',NHOL11
      WRITE(6,*) '             MAX NR OF RAS-3 ELECTRONS:',NELE31
      WRITE(6,*) ' PREVIOUS STATE: MAX NR OF RAS-1 HOLES:',NHOLE1(JOB-1)
      WRITE(6,*) '             MAX NR OF RAS-3 ELECTRONS:',NELE3(JOB-1)
      GOTO 9010
9004  WRITE(6,*) ' NR. OF (FROZEN+INACTIVE) ORBITALS DIFFER.'
      WRITE(6,'(A,8I4)')' THIS STATE:',(NFRO1(I)+NISH1(I),I=1,NSYM1)
      WRITE(6,'(A,8I4)')'   PREVIOUS:',(NISH(I),I=1,NSYM )
      GOTO 9010
9005  WRITE(6,*)' NR. OF ACTIVE ORBITALS DIFFER.'
      WRITE(6,'(A,8I4)')' THIS STATE, ACTIVE:',(NASH1(I),I=1,NSYM1)
      WRITE(6,'(A,8I4)')'               RAS1:',(NRS11(I),I=1,NSYM1)
      WRITE(6,'(A,8I4)')'               RAS2:',(NRS21(I),I=1,NSYM1)
      WRITE(6,'(A,8I4)')'               RAS3:',(NRS31(I),I=1,NSYM1)
      WRITE(6,'(A,8I4)')'   PREVIOUS, ACTIVE:',(NASH (I),I=1,NSYM )
      WRITE(6,'(A,8I4)')'               RAS1:',(NRS1 (I),I=1,NSYM1)
      WRITE(6,'(A,8I4)')'               RAS2:',(NRS2 (I),I=1,NSYM1)
      WRITE(6,'(A,8I4)')'               RAS3:',(NRS3 (I),I=1,NSYM1)
      GOTO 9010
9006  WRITE(6,*)' NR. OF BASIS FUNCTION DIFFER.'
      WRITE(6,'(A,8I4)')' THIS JOBIPH:',(NBAS1(I),I=1,NSYM1)
      WRITE(6,'(A,8I4)')'    PREVIOUS:',(NBASF(I),I=1,NSYM )
9010  CONTINUE
      WRITE(6,*)' DATA IN JOBIPH FILE NAMED ',TRIM(JBNAME(JOB)),' WERE'
      WRITE(6,*)' INCONSISTENT WITH EARLIER DATA. PROGRAM STOPS.'
      WRITE(6,*)
      WRITE(6,*)' Errors occured in RASSI/RDJOB.'
      CALL XFLUSH(6)
      CALL ABEND()

      END

************************************************************************
*                                                                      *
*     Only read the number of states                                   *
*                                                                      *
************************************************************************
      Subroutine rdjob_nstates(JOB)
#ifdef _HDF5_
      use mh5, only: mh5_is_hdf5, mh5_open_file_r, mh5_fetch_attr,
     &               mh5_close_file
#endif
      IMPLICIT NONE
#include "rasdim.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "jobin.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
      integer :: refwfn_id
      integer :: ref_nstates
#endif
      Real*8 Weight(MxRoot), ENUCDUMMY
      Integer job,iad,ipt2
************************************************************************
*
* For HDF5 formatted job files
*
************************************************************************
#ifdef _HDF5_
      If (mh5_is_hdf5(jbname(job))) Then
        refwfn_id = mh5_open_file_r(jbname(job))
        call mh5_fetch_attr (refwfn_id,'NSTATES', ref_nstates)
* update the state offset, number of states, and total number of states
        ISTAT(JOB)=NSTATE+1
        NSTAT(JOB)=ref_nstates
        NSTATE=NSTATE+ref_nstates
        call mh5_close_file(refwfn_id)
      Else
#endif
      CALL DANAME(LUIPH,JBNAME(JOB))
C READ TABLE OF CONTENTS ON THIS JOBIPH FILE:
      IAD=0
      CALL IDAFILE(LUIPH,2,ITOC15,30,IAD)
C SCATTER-READ VARIOUS DATA:
      IAD=ITOC15(1)
      Call WR_RASSCF_Info(LUIPH,2,IAD,
     &                    NACTE1,MPLET1,NSYM1,LSYM1,
     &                    NFRO1,NISH1,NASH1,NDEL1,NBAS1,mxSym,
     &                    NAME,LENIN8*mxOrb,NCONF1,HEAD1,2*72,
     &                    TITLE1,4*mxTit*18,
     &                    ENUCDUMMY,LROT1,NROOT1,
     &                    IROOT1,mxRoot,NRS11,NRS21,NRS31,
     &                    NHOL11,NELE31,IPT2,Weight)
* update the state offset, number of states, and total number of states
      ISTAT(JOB)=NSTATE+1
      NSTAT(JOB)=NROOT1
      NSTATE=NSTATE+NROOT1
      CALL DACLOS(LUIPH)
#ifdef _HDF5_
      EndIf
#endif
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Martin Schuetz                                   *
!               1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2017,2022, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SOiniH()
!***********************************************************************
!                                                                      *
!     purpose: generate initial Hessian (diagonal) from                *
!              orbital energies (for second order update)              *
!                                                                      *
!***********************************************************************

use InfSCF, only: FockMO, HDiag, nFro, nOcc, nOrb, nSym, OrbType
use Constants, only: Zero, One, Four
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: iD, iOcc, iOff_F, iOff_H, ioffs, iSym, iVir, jOcc, jVir, nD, nOccmF, nOrbmF
real(kind=wp) :: Hii
real(kind=wp), pointer :: Fock(:,:)
real(kind=wp), parameter :: Hii_Max = One, Hii_Min = 0.05_wp

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Set the array to silly large values. In the case of UHF these
! will remain but should not make any difference. They are actully
! needed to make the rs-rfo code work.

! Compute the diagonal values of the Fock matrix, stored in EOrb.
! Call Mk_EOrb(CMO_Ref,Size(CMO_Ref,1),Size(CMO_Ref,2))

nD = size(FockMO,2)
HDiag(:) = Zero

#ifdef _DEBUGPRINT_
write(u6,*) 'nD=',nD
do iD=1,nD
  write(u6,*) 'iD=',iD
  write(u6,'(A,8I3)') 'nOcc',(nOcc(iSym,iD),iSym=1,nSym)
end do
write(u6,'(A,8I3)') 'nFro',(nFro(iSym),iSym=1,nSym)
write(u6,'(A,8I3)') 'nOrb',(nOrb(iSym),iSym=1,nSym)
call RecPrt('SOIniH: FockMO',' ',FockMO,1,size(FockMO))
call NrmClc(FockMO,size(FockMO),'SOIniH','FockMO')
#endif
iOff_H = 1
do iD=1,nD

  iOffs = 0
  iOff_F = 0
  do iSym=1,nSym

    ! loop over all occ orbitals in sym block

    iOffs = iOffs+nFro(iSym)
    ! number of Occupied, excluding frozen
    nOccmF = nOcc(iSym,iD)-nFro(iSym)
    ! number of Orbitals, excluding frozen
    nOrbmF = nOrb(iSym)-nFro(iSym)

    if (nOrb(iSym) < 1) cycle
    Fock(1:nOrb(iSym),1:nOrb(iSym)) => FockMO(iOff_F+1:iOff_F+nOrb(iSym)**2,iD)

    do iOcc=ioffs+1,ioffs+nOccmF
      jOcc = iOcc-iOffs

      ! loop over all virt orbitals in sym block

      do iVir=ioffs+nOccmF+1,ioffs+nOrbmF
        jVir = iVir-iOffs

        if (OrbType(iVir,iD) == OrbType(iOcc,iD)) then

          Hii = Four*(Fock(jVir,jVir)-Fock(jOcc,jOcc))/real(nD,kind=wp)

          !write(u6,*) 'Hii, iOff_H=', Hii, iOff_H
          !write(u6,*) 'Fock(jVir,jVir), jVir=',Fock(jVir,jVir),jVir
          !write(u6,*) 'Fock(jOcc,jOcc), jOcc=',Fock(jOcc,jOcc),jOcc
          if (Hii < Zero) then
            !write(u6,*) 'SOIniH: Hii<0.0, Hii=',Hii
            Hii = max(Hii_Max,abs(Hii))
            !write(u6,*) '        Reset to Hii=',Hii
          else if (abs(Hii) < Hii_Min) then
            !write(u6,*) 'SOIniH: Abs(Hii)<Hii_Min, Hii=',Hii
            !write(u6,*) 'jVir,jOcc=',jVir,jOcc
            !write(u6,*) 'Fock(jOcc,jOcc)=',Fock(jOcc,jOcc)
            !write(u6,*) 'Fock(jVir,jVir)=',Fock(jVir,jVir)
            Hii = Hii_Min
            !write(u6,*) 'SOIniH: Reset to          Hii=',Hii
          end if
          HDiag(iOff_H) = Hii
        end if

        iOff_H = iOff_H+1

      end do  ! iVir

    end do    ! iOcc

    nullify(Fock)
    iOff_F = iOff_F+nOrb(iSym)**2
    iOffs = iOffs+nOrbmF

  end do ! iSym
end do ! iD

#ifdef _DEBUGPRINT_
call RecPrt('HDiag',' ',HDiag(:),1,size(HDiag))
call NrmClc(HDiag,size(HDiag),'SOIniH','HDiag')
#endif

return

end subroutine SOiniH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_GetLQ(QVec,l_QVec,LstQSP,nQSP)

      Implicit None
      Integer l_QVec, nQSP
      Real*8  QVec(l_Qvec)
      Integer LstQSP(nQSP)
#include "cho_para_info.fh"

      Character*11 SecNam
      Parameter (SecNam = 'Cho_P_GetLQ')

C --- In parallel:
C --- This code only works if MxShpr is set to 1
C ---      otherwise each node computes a slice
C ---      of QVec and thus a more sophisticated
C ---      "synchronization" would be needed

      If (Cho_Real_Par) Then
         If (nQSP .gt. 1) Then
            Call Cho_Quit('Oops! Bug detected in '//SecNam,103)
         End If
         Call Cho_dZero(QVec,l_Qvec)
         Call Cho_p_QualSwp()
         Call Cho_GetLQ(QVec,l_QVec,LstQSP,nQSP)
         Call Cho_p_QualSwp()
         Call Cho_GAdGOp(QVec,l_QVec,'+') ! sync. array
      Else
         Call Cho_GetLQ(QVec,l_QVec,LstQSP,nQSP)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module rassi_data

! NISHT  - NR OF  INACTIVE ORBITALS, TOTAL
! NASHT  - NR OF    ACTIVE ORBITALS, TOTAL
! NOSHT  - NR OF  OCCUPIED ORBITALS, TOTAL
! NSSHT  - NR OF SECONDARY ORBITALS, TOTAL
! NISH(8),...,NSSH(8), AS ABOVE, BUT BY SYMMETRY TYPE.
! NBST, NBAS(8) - SIMILAR, NR OF BASIS FUNCTIONS.
! NBMX   - MAX NR OF BASIS FUNCTIONS OF ANY SPECIFIC SYMMETRY.
! NBTRI  - TOTAL SIZE OF TRIANGULAR SYMMETRY BLOCKS OF BASIS FNCS.
! NBSQ   - D:O, SQUARE SYMMETRY BLOCKS.
! NBSQPR - ACCUMULATED NR OF SQUARE SYMMETRY BLOCKS OF PREVIOUS
!          SYMMETRY TYPES. NBSQPR(1)=0.
! NCMO   - SIZE OF CMO COEFFICIENT ARRAYS, = SUM(NOSH(I)*NBAS(I)).
! NTDMAB - SIZE OF TRANS.D. MATRIX IN BIORTHONORMAL MO BASIS.
! NTDMZZ - SIZE OF TRANS.D. MATRIX IN AO BASIS.
! NSXY   - SIZE OF MO OVERLAP ARRAY.
! NTRA   - SIZE OF TRANSFORMATION COEFFICIENT ARRAY.
! ChFracMem - fraction of memory for the Cholesky vectors buffer

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: NAES(8), NASH(8), NASHT, NBASF(8), NBMX, NBSQ, NBSQPR(8), NBST, NBTRI, NCMO, NDEL(8), NFRO(8), NISH(8), &
                     NISHT, NOSH(8), NOSHT, NSSH(8), NSSHT, NSXY, NTDMAB, NTDMZZ, NTRA
character(len=8) :: WFTYPE
real(kind=wp) :: ChFracMem, ENUC

public :: ChFracMem, ENUC, NAES, NASH, NASHT, NBASF, NBMX, NBSQ, NBSQPR, NBST, NBTRI, NCMO, NDEL, NFRO, NISH, NISHT, NOSH, NOSHT, &
          NSSH, NSSHT, NSXY, NTDMAB, NTDMZZ, NTRA, WFTYPE

end module rassi_data

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine prmap (mapd,mapi)
c

       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
       integer ii,i,j
       ii=mapd(0,5)
       do i=0,ii
       write (6,99) i,(mapd(i,j),j=1,6)
99      format (i3,6x,i10,1x,5(i6,1x))
       end do
c
        write (6,*) mapi(1,1,1),mapi(2,1,1)
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Chk_OneHam(nBas)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "WrkSpc.fh"

      Dimension nBas(MxSym)
      Character Label_Read*8, Label_Pure*8

      Lu_One=49
      Lu_One=IsFreeUnit(Lu_One)
      Label_Read='OneHam  '
      Label_Pure='OneHam 0'
      nBT=nBas(1)*(nBas(1)+1)/2
      Call OpnOne(irc,0,'ONEINT',Lu_One)
      Call GetMem('Read','Allo','Real',iOneR,nBT+4)
      Call GetMem('Pure','Allo','Real',iOneP,nBT+4)

      irc=-1
      iopt=0
      iSmLbl=0
      Call RdOne(irc,iopt,Label_Read,1,Work(iOneR),iSmLbl)
      irc=-1
      iopt=0
      iSmLbl=0
      Call RdOne(irc,iopt,Label_Pure,1,Work(iOneP),iSmLbl)
      Call ClsOne(irc,Lu_One)

      Call DaxPy_(nBT,-1.0d0,Work(iOneR),1,Work(iOneP),1)

      dNorm=dnrm2_(nBT,Work(iOneP),1)

      If(dNorm.gt.1d-8) then
        Write(6,*)
        Write(6,*)
        Write(6,*)' WARNING!'
        Write(6,*)
        Write(6,*)'   Your one-electron hamiltonian is not purely'
     &//' vacuum. This means that the Hamiltonian'
        Write(6,*)'   in QmStat can be contaminated. Is this'
     &//' intentional? If not, then make sure that the ONEINT'
        Write(6,*)'   file comes directly from a Seward calculation'
     &//' without any calls from'
        Write(6,*)'   FFPT (or similar) in between.'
        Write(6,*)
        Write(6,*)
      Endif

      Call GetMem('Read','Free','Real',iOneR,nBT+4)
      Call GetMem('Pure','Free','Real',iOneP,nBT+4)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Thomas Bondo Pedersen                            *
!***********************************************************************
!  DefineDomain
!
!> @brief
!>   Define orbital domains
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Orbital domains are defined by summing up gross atomic Mulliken
!> charges for each orbital. Once the sum is greater than or equal
!> to the threshold \p ThrDomain(1), the domain is defined. The
!> second threshold \p ThrDomain(2) is then used to check
!> completeness (Pulay-style) of the definition and if needed,
!> more atoms are added to the domain. To avoid the second step
!> (i.e. the completeness check), simply put \p ThrDomain(2) > ``1.0`` in
!> which case array \p f is undefined on exit.
!>
!> On exit, the contents of iDomain array are:
!>
!> - \p iDomain(0,i): number of atoms in domain \c i.
!> - \p iDomain(n,i): id of atom \c n (\c n = ``1``, ``2``, ..., \p iDomain(0,i)) in domain \c i.
!>
!> Return codes:
!>
!> - \p irc = ``-1``: input error(s) detected.
!> - \p irc =  ``0``: all OK.
!> - \p irc =  ``1``: this indicates a bug in the charge setup.
!> - \p irc =  ``2``: can only be set if debug is turned on; in that case, this code means
!>                    that the computed charges do not sum up to the number of occupied orbitals, \p nOcc.
!> - \p irc =  ``3``: can only be set if debug is turned on; in that case, this code means
!>                    that at least one domain is defined as empty or having at least one atom index out of bounds.
!>
!> @param[out] irc           Return code
!> @param[out] iDomain       Domain definition
!> @param[out] QD            Final total charges for each domain
!> @param[out] f             Function values from completeness check
!> @param[in]  C             MO coefficients
!> @param[in]  ThrDomain     Thresholds for domain definition
!> @param[in]  nBas_per_Atom Number of basis functions on each atom
!> @param[in]  nBas_Start    Start index for basis functions on each atom
!> @param[in]  nAtom         Number of atoms
!> @param[in]  nBas          Number of basis functions
!> @param[in]  nOcc          Number of occupied orbitals
!***********************************************************************

subroutine DefineDomain(irc,iDomain,QD,f,C,ThrDomain,nBas_per_Atom,nBas_Start,nAtom,nBas,nOcc)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nAtom, nOcc, nBas_per_Atom(nAtom), nBas_Start(nAtom), nBas
integer(kind=iwp), intent(inout) :: iDomain(0:nAtom,nOcc)
real(kind=wp), intent(out) :: QD(nOcc), f(nOcc)
real(kind=wp), intent(in) :: C(nBas,nOcc), ThrDomain(2)
integer(kind=iwp) :: i, iAt, iAtom, iCount, nB(1), nErr, nSrt
real(kind=wp) :: Charge, Chrg, Diff
integer(kind=iwp), allocatable :: iPivot(:)
real(kind=wp), allocatable :: absQ(:), Q(:,:), S(:,:), T(:,:)
#if defined (_DEBUGPRINT_)
#define DBG .true.
#else
#define DBG .false.
#endif
logical(kind=iwp), parameter :: LocDbg = DBG
real(kind=r8), external :: ddot_

! Check input.
! ------------

irc = 0
if ((nAtom < 1) .or. (nBas < 1) .or. (nOcc < 1)) return

! Allocate and read overlap matrix stored as full square.
! -------------------------------------------------------

call mma_allocate(S,nBas,nBas,label='DfDm_S')

nB(1) = nBas
call GetOvlp_Localisation(S,'Sqr',nB,1)

! Allocations.
! ------------

call mma_allocate(T,nBas,nOcc,label='DfDm_T')
call mma_allocate(Q,nAtom,nOcc,label='DfDm_Q')

! Compute T=SC.
! -------------

call DGEMM_('N','N',nBas,nOcc,nBas,One,S,nBas,C,nBas,Zero,T,nBas)

! Compute atomic contributions to Mulliken charges.
! -------------------------------------------------

Q(:,:) = Zero
do i=1,nOcc
  do iAtom=1,nAtom
    Q(iAtom,i) = Q(iAtom,i)+dDot_(nBas_per_Atom(iAtom),C(nBas_Start(iAtom),i),1,T(nBas_Start(iAtom),i),1)
  end do
end do

! Debug: check charges.
! The sum of them should equal the trace of the occupied MO overlap
! matrix, i.e. nOcc.
! -----------------------------------------------------------------

if (LocDbg) then
  write(u6,*)
  write(u6,*) 'DefineDomain: checking charge calculation:'
  Charge = Zero
  do i=1,nOcc
    Chrg = Zero
    do iAtom=1,nAtom
      Chrg = Chrg+Q(iAtom,i)
    end do
    Charge = Charge+Chrg
    Diff = Chrg-One
    if (abs(Diff) > 1.0e-10_wp) then
      write(u6,*)
      write(u6,*) '  Orbital ',i,':'
      write(u6,*) '  Charge    : ',Chrg
      write(u6,*) '  Expected  : ',One
      write(u6,*) '  Difference: ',Diff
    end if
  end do
  Diff = Charge-real(nOcc,kind=wp)
  write(u6,*)
  write(u6,*) '  Total charge: ',Charge
  write(u6,*) '  Expected    : ',real(nOcc,kind=wp)
  write(u6,*) '  Difference  : ',Diff
  if (abs(Diff) > 1.0e-10_wp) then
    irc = 2
    call FreeMem()
    return
  end if
end if

! For each orbital, create an index array in descending order of
! absolute contributions to charges. Array iDomain will then contain
! the list of atoms ordered according to contributions.
! ------------------------------------------------------------------

call mma_allocate(iPivot,nAtom,label='DfDm_iPivot')
call mma_allocate(absQ,nAtom,label='DfDm_absQ')
do i=1,nOcc
  nSrt = nAtom
  do iAtom=1,nAtom
    absQ(iAtom) = abs(Q(iAtom,i))
  end do
  call CD_DiaMax(absQ,nAtom,iPivot,iDomain(1,i),nSrt,-One)
  if (nSrt /= nAtom) then
    call mma_deallocate(iPivot)
    irc = 1 ! ooops: something is fishy here...
    call FreeMem()
    return
  end if
end do
call mma_deallocate(absQ)
call mma_deallocate(iPivot)

! For each orbital, define domain according to charge threshold.
! --------------------------------------------------------------

do i=1,nOcc
  iCount = 1
  iAtom = iDomain(iCount,i)
  Charge = Q(iAtom,i)
  do while ((iCount < nAtom) .and. (Charge < ThrDomain(1)))
    iCount = iCount+1
    iAtom = iDomain(iCount,i)
    Charge = Charge+Q(iAtom,i)
  end do
  iDomain(0,i) = iCount
end do

! Debug.
! ------

if (LocDbg) then
  nErr = 0
  write(u6,*)
  write(u6,*) 'DefineDomain: domains and charges after step 1:'
  write(u6,*) 'Threshold: ',ThrDomain(1)
  do i=1,nOcc
    write(u6,*)
    write(u6,*) 'Domain ',i,': ',iDomain(0,i),' atoms:'
    if (iDomain(0,i) < 1) then
      write(u6,*) 'No atoms in domain !?!?!'
      nErr = nErr+1
    else if (iDomain(0,i) > nAtom) then
      write(u6,*) 'Number of atoms > nAtom in domain !?!?!'
      nErr = nErr+1
    else
      Charge = Zero
      do iAt=1,iDomain(0,i)
        iAtom = iDomain(iAt,i)
        if ((iAtom < 1) .or. (iAtom > nAtom)) then
          write(u6,*) '  Atom: ',iAtom,' !?!?!'
          nErr = nErr+1
        else
          write(u6,*) '  Atom: ',iAtom,'  Charge: ',Q(iAtom,i)
          Charge = Charge+Q(iAtom,i)
        end if
      end do
      write(u6,*) '  Total charge: ',Charge
    end if
  end do
  if (nErr /= 0) then
    irc = 3
    call FreeMem()
    return
  end if
end if

! For each orbital, check completeness and add atoms as needed to
! meet the requirement f<=threshold.
! ---------------------------------------------------------------

if (ThrDomain(2) < One) then
  do i=1,nOcc
    call MakeDomainComplete(iDomain(0,i),f(i),S,T(:,i),ThrDomain(2),nBas_per_Atom,nBas_Start,nBas,nAtom)
  end do
end if

! Compute total charges for each domain.
! --------------------------------------

do i=1,nOcc
  QD(i) = Zero
  do iAt=1,iDomain(0,i)
    iAtom = iDomain(iAt,i)
    QD(i) = QD(i)+Q(iAtom,i)
  end do
end do

! Debug.
! ------

if (LocDbg) then
  nErr = 0
  write(u6,*)
  write(u6,*) 'DefineDomain: domains and charges after step 2:'
  write(u6,*) 'Threshold: ',ThrDomain(2)
  if (ThrDomain(2) < One) then
    do i=1,nOcc
      write(u6,*)
      write(u6,*) 'Domain ',i,': ',iDomain(0,i),' atoms:'
      if (iDomain(0,i) < 1) then
        write(u6,*) 'No atoms in domain !?!?!'
        nErr = nErr+1
      else if (iDomain(0,i) > nAtom) then
        write(u6,*) 'Number of atoms > nAtom in domain !?!?!'
        nErr = nErr+1
      else
        Charge = Zero
        do iAt=1,iDomain(0,i)
          iAtom = iDomain(iAt,i)
          if ((iAtom < 1) .or. (iAtom > nAtom)) then
            write(u6,*) '  Atom: ',iAtom,' !?!?!'
            nErr = nErr+1
          else
            write(u6,*) '  Atom: ',iAtom,'  Charge: ',Q(iAtom,i)
            Charge = Charge+Q(iAtom,i)
          end if
        end do
        write(u6,*) '  Total charge: ',Charge
        if (abs(Charge-QD(i)) > 1.0e-12_wp) then
          write(u6,*) 'Total charge is inconsistent with QD !'
          nErr = nErr+1
        end if
      end if
    end do
  else
    write(u6,*) 'Threshold >= 1.0: step 2 was skipped.'
    write(u6,*) 'Domains are unchanged from step 1.'
  end if
  if (nErr /= 0) then
    irc = 3
    call FreeMem()
    return
  end if
end if

call FreeMem()

return

contains

subroutine FreeMem()

  ! Deallocations.
  ! --------------

  call mma_deallocate(S)
  call mma_deallocate(T)
  call mma_deallocate(Q)

end subroutine FreeMem

end subroutine DefineDomain

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION ISYMST(STRING,NEL)
*
* Master routine for symmetry of string
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input ( PNTGRP is used )
#include "mxpdim.fh"
#include "lucinp.fh"
*. Specific input
      INTEGER STRING(*)
      IF(PNTGRP.EQ.1) THEN
*.D2h
        ISYMST = ISYMS1(STRING,NEL)
      ELSE
        WRITE(6,*) ' Sorry PNTGRP option not programmed ', PNTGRP
        WRITE(6,*) ' Enforced stop in ISYMST '
*        STOP 5
         CALL SYSABENDMSG('lucia_util/isymst','Internal error',' ')
         ISYMST=-9999
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Anders Bernhardsson                              *
!***********************************************************************

subroutine AddGrad(rKappa,rMat,idsym,fact)
! Purpose:
!   Adds the contribution from the gradient to
!    [2]
!   E   Kappa. This is done to insure us about
!   a beautiful convergence of the PCG,
!   which is just the case if E is symmetric.

use Symmetry_Info, only: Mul
use MCLR_Data, only: F0SQMO, ipCM, ipMat
use input_mclr, only: nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: rKappa(*), fact
real(kind=wp), intent(inout) :: rMat(*)
integer(kind=iwp), intent(in) :: idsym
integer(kind=iwp) :: iS, jS
real(kind=wp), allocatable :: Tempi(:), Tempj(:)

do iS=1,nSym
  js = Mul(is,idsym)
  if (nOrb(is)*nOrb(js) == 0) cycle
  call mma_allocate(Tempi,nOrb(is)**2,Label='Tempi')
  call mma_allocate(Tempj,nOrb(js)**2,Label='Tempj')
  ! T=Brillouin matrix
  call DGeSub(F0SQMO(ipCM(is)),nOrb(is),'N',F0SQMO(ipCM(is)),nOrb(is),'T',Tempi,nOrb(is),nOrb(is),nOrb(is))
  call DGeSub(F0SQMO(ipCM(js)),nOrb(js),'N',F0SQMO(ipCM(js)),nOrb(js),'T',Tempj,nOrb(js),nOrb(js),nOrb(js))
  !             t           t
  ! +1/2 { Kappa T - T kappa  }
  call DGEMM_('T','N',nOrb(is),nOrb(js),nOrb(js),Half*fact,rkappa(ipMat(js,is)),nOrb(js),Tempj,nOrb(js),One,rMat(ipMat(is,js)), &
              nOrb(is))
  call DGEMM_('N','T',nOrb(is),nOrb(js),nOrb(is),-Half*fact,Tempi,nOrb(is),rKappa(ipmat(js,is)),nOrb(js),One,rMat(ipMat(is,js)), &
              nOrb(is))
  call mma_deallocate(Tempi)
  call mma_deallocate(Tempj)
end do

end subroutine AddGrad

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine citrans_init(nel,norb,mult)
      use second_quantization
      use citrans
      implicit none

      integer, intent(in) :: nel, norb, mult
      integer :: nela, nelb, nhoa, nhob

      integer :: ido, iso

      ! compute alpha/beta subsets
      nela = (nel+(mult-1))/2
      nhoa = norb - nela
      nelb = (nel-(mult-1))/2
      nhob = norb - nelb

      ! determine the range of the configuration groups
      if (nel.gt.norb) then
        ndo_min = nel - norb
      else
        ndo_min = 0
      end if
      ndo_max = nelb

      ! compute the various sizes per group
      allocate (ndoc_group(ndo_min:ndo_max))
      allocate (nsoc_group(ndo_min:ndo_max))
      allocate (ndet_group(ndo_min:ndo_max))
      allocate (ncsf_group(ndo_min:ndo_max))

      allocate (spintabs(ndo_min:ndo_max))
      ! loop over configurations
      do ido = ndo_min, ndo_max
        iso = nel - 2 * ido
        ! compute different block sizes
        ndoc_group(ido) = binom_coef(ido,norb)
        nsoc_group(ido) = binom_coef(iso,norb-ido)
        ndet_group(ido) = binom_coef(nela-ido,iso)
        ncsf_group(ido) = ndet_group(ido) - binom_coef(nela-ido+1,iso)
        ! compute+store spin table for this configuration
        spintabs(ido)%ndet = ndet_group(ido)
        spintabs(ido)%ncsf = ncsf_group(ido)
        call spintable_create(iso,nelb-ido,spintabs(ido))
      end do

      end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SetUpA(nZeta,A,Pxyz)
!***********************************************************************
!                                                                      *
! Object: to set up the transformation matrix from the local coordinate*
!         system which has the z-axis going through P to the global    *
!         coordinate system. Formula by P.-A. Malmqvist.               *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!              October '92.                                            *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta
real(kind=wp), intent(out) :: A(nZeta,3,3)
real(kind=wp), intent(in) :: Pxyz(nZeta,3)
integer(kind=iwp) :: iZeta
real(kind=wp) :: r, sgn, x, y, z

#ifdef _DEBUGPRINT_
call RecPrt(' In SetupA: Pxyz',' ',Pxyz,nZeta,3)
#endif

! Set up the transformation matrix

do iZeta=1,nZeta
  x = Pxyz(iZeta,1)
  y = Pxyz(iZeta,2)
  z = Pxyz(iZeta,3)
  r = sqrt(x**2+y**2+z**2)
  sgn = One
  if (z < Zero) then
    x = -x
    y = -y
    z = -z
    sgn = -sgn
  end if
  if (r == Zero) then
    A(iZeta,1,1) = One
    A(iZeta,2,1) = Zero
    A(iZeta,1,2) = A(iZeta,2,1)
    A(iZeta,3,1) = Zero
    A(iZeta,1,3) = A(iZeta,3,1)
    A(iZeta,2,2) = One
    A(iZeta,2,3) = Zero
    A(iZeta,3,2) = A(iZeta,2,3)
    A(iZeta,3,3) = One
  else
    A(iZeta,1,1) = sgn*(One-x**2/(r*(r+z)))
    A(iZeta,2,1) = sgn*(-x*y/(r*(r+z)))
    A(iZeta,1,2) = A(iZeta,2,1)
    A(iZeta,3,1) = sgn*(-x/r)
    A(iZeta,1,3) = A(iZeta,3,1)
    A(iZeta,2,2) = sgn*(One-y**2/(r*(r+z)))
    A(iZeta,2,3) = sgn*(-y/r)
    A(iZeta,3,2) = A(iZeta,2,3)
    A(iZeta,3,3) = sgn*(-z/r)
  end if
end do

#ifdef _DEBUGPRINT_
call RecPrt(' The transformation matrix',' ',A,nZeta,9)
#endif

end subroutine SetUpA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Francesco Aquilante                              *
!               2011, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine CHO_GET_GRAD(irc,nDen,DLT,DLT2,MSQ,Txy,nTxy,ipTxy,DoExchange,lSA,nChOrb_,AOrb,nAorb,DoCAS,Estimate,Update,V_k,nV_k,U_k, &
                        Z_p_k,nZ_p_k,nnP,npos)
!***********************************************************************
!  Author : F. Aquilante (visiting F. Illas group in Barcelona, Spain, *
!                                                    March-April 2007) *
!                                                                      *
!  Purpose:                                                            *
!         Computation of the relevant quantities for RI                *
!         (and Cholesky) gradient code                                 *
!                                                                      *
!         Coulomb term :  V_k = sum_gd  D_gd L_gd_k                    *
!                                                                      *
!         MP2 Coulomb term : U_k = sum_gd D(MP2)_gd L_gd_k             *
!                                                                      *
!         Active term :   Z_p_k = sum_xy T(xy,p) L_xy_k                *
!                                                                      *
!         Inact. Exchange term: the quantity returned on disk is       *
!                                                                      *
!                     L_ij_k = sum_gd L_gd_k C_gi C_dj                 *
!                                                                      *
!                                                                      *
!  Input:                                                              *
!                                                                      *
!         nDen : is equal to 2 iff Spin Unrestricted                   *
!                4 for SA-CASSCF, otherwise nDen=1                     *
!                                                                      *
!         DLT : the LT-packed and symm. blocked one-body Dmat.         *
!                 For spin unrestricted, Dmat = Dalpha + Dbeta         *
!                                                                      *
!         DLT2: pointer to the LT-packed and symm. blocked             *
!                 one body MP2 Dmat.                                   *
!                                                                      *
!         MSQ : Cholesky MOs stored as C(a,i) symm. blocked            *
!                 with blocks of dim. (nBas,nBas). These are           *
!                 obtained from CD of the 1-particle DMAT.             *
!                 (Two pointers iff alpha and beta spinorbitals)       *
!                                                                      *
!         ipTxy : array (8,8) of pointers to the symm. blocks          *
!                 of the Cholesky decomposed MO-basis (symmetrized)    *
!                 2-body density matrix                                *
!                 T(xy,p) : is stored by compound symmetry JSYM        *
!                            the indices {xy} are stored as PACKED     *
!                            (sym x <= sym y)                          *
!                                                                      *
!         DoExchange : logical to activate exchange grad. components   *
!                                                                      *
!         nChOrb_ : array of nr. of Cholesky orbitals in each irrep    *
!                                                                      *
!         nAorb : array with # of Active orbitals in each irrep        *
!                 (The same orbital basis                              *
!                 in which the 2-body Dmat is expressed)               *
!                                                                      *
!         DoCAS : logical to activate CASSCF grad. components          *
!                                                                      *
!         nScreen : See e.g. LK-screening docum. in SCF                *
!                   or CASSCF read-input routines. Default = 10        *
!                                                                      *
!         dmpK : damping for the LK-screening threshold. Def: 1.0      *
!                                                                      *
!         Estimate : logical for LK-screening. Default: .false.        *
!                                                                      *
!         Update : logical for LK-screening. Default: .true.           *
!                                                                      *
!         nnP : array of # of Cholesky vectors for the dec 2-body      *
!               density matrix in each compound symmetry               *
!                                                                      *
!                                                                      *
!  Output:                                                             *
!         irc : return code                                            *
!                                                                      *
!         V_k : array Real*8 for the Coulomb interm. Size=NumCho(1)    *
!                                                                      *
!         U_k : array Real*8 for the mp2 Coulomb interm. Size=NumCho(1)*
!                                                                      *
!         Z_p_k : array Real*8 for the active grad. components.        *
!                  Must be zeroed by the calling routine. Stored       *
!                  according to jSym and blocked after symm. blocks    *
!                  of the active orbitals (square storage).            *
!                                                                      *
!  Modifications:                                                      *
!    August 24, 2011, Thomas Bondo Pedersen:                           *
!       Allow zero vectors on a node.                                  *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use ChoArr, only: nBasSh, nDimRS
use ChoSwp, only: IndRed, InfVec, nnBstRSh
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, L_Full_Type, Lab_Type, NDSBA_Type, SBA_Type, V2
use RI_glob, only: CMOi, dmpK, iBDsh, iMP2prpt, nAdens, nIJ1, nIJR, nJdens, nKdens, nKvec, nScreen, VJ
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nDen, nTxy, ipTxy(8,8,2), nChOrb_(8,5), nAorb(8), nV_k, nZ_p_k, nnP(8), npos(8,3)
type(DSBA_Type), intent(in) :: DLT(5), DLT2, MSQ(nDen), AOrb(*)
real(kind=wp), intent(in) :: Txy(nTxy)
logical(kind=iwp), intent(in) :: DoExchange, lSA, DoCAS, Estimate, Update
real(kind=wp), intent(_OUT_) :: V_k(nV_k,*), U_k(*)
real(kind=wp), intent(inout) :: Z_p_k(nZ_p_k,*)
#include "Molcas.fh"
#include "chotime.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "print.fh"
!#define _CD_TIMING_
#ifdef _CD_TIMING_
#include "temptime.fh"
#endif
integer(kind=iwp) :: i, iAdr, iaSh, iAvec, iBatch, ibcount, ibs, ibs_a, ibSh, iE, ij, ik, iLoc, iml, iMO1, iMO2, iMOleft, &
                     iMOright, ioff, iOffShb, iOffZp, iPrint, ipZp, ir, ired1, IREDC, iRout, iS, iSeed, ish, iShp, iSSa, iStart, &
                     iSwap, iSwap_lxy, ISYM, iSym1, iSym2, iSyma, iSymb, iSymv, iSymx, iSymy, it, itk, iTmp, iTxy, IVEC2, iVrs, j, &
                     jDen, jGam, jK, jK_a, jml, jmlmax, JNUM, JRED, JRED1, JRED2, jrs, jSym, jvc, JVEC, k, kMOs, kOff(8,5), krs, &
                     kscreen, kSym, l, l1, LFMAX, LKsh, LREAD, lSym, LuRVec(8,3), LWORK, MaxB, MaxRedT, mDen, mrs, MUSED, n1, n2, &
                     nAv, NAw, nBatch, nI2t, nIJMax, Nik, nInd, nIt(5), nItmx, nL_Full(2), nLab(2), nLaq, nLik, nLxy, nLxy0, nMat, &
                     nMOs, nnA(8,8), npos2, nQo, nQoT, nRik, nRS, NumCV, numSh, NUMV, NumVT, nVec, nVrs
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: myJRED1, NNBSTMX, ntv0
#endif
real(kind=wp) :: SkSh, tau, tcasg(2), TCC1, TCC2, tcoul(2), TCR1, TCR2, TCS1, TCS2, TCT1, TCT2, TCX1, TCX2, temp, thrv, tmotr(2), &
                 tmotr2(2), TOTCPU, TOTCPU1, TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, tread(2), tscrn(2), TWC1, TWC2, TWR1, TWR2, &
                 TWS1, TWS2, TWT1, TWT2, TWX1, TWX2, xtau, xTmp, YMax, YshMax
logical(kind=iwp) :: add, BatchWarn, DoScreen
character(len=50) :: CFmt
character(len=6) :: Fname
character :: mode
type(L_Full_Type) :: L_Full
type(Lab_Type) :: Lab
type(NDSBA_Type) :: DiaH
type(SBA_Type) :: Laq(1), Lxy
type(V2) :: SumClk(5)
integer(kind=iwp), allocatable :: Indik(:,:), Indx(:,:), iShp_rs(:), kOffSh(:,:)
real(kind=wp), allocatable :: AbsC(:), Diag(:), Drs(:,:), Drs2(:,:), Lrs(:,:), MLk(:), SvShp(:,:), Ylk(:,:)
#ifdef _MOLCAS_MPP_
real(kind=wp), allocatable :: DiagJ(:)
#endif
real(kind=wp), allocatable, target :: Aux(:), Aux0(:), Yik(:)
real(kind=wp), pointer :: Lik(:,:), pYik(:,:), Rik(:)
logical(kind=iwp), parameter :: DoRead = .false.
character(len=*), parameter :: SECNAM = 'CHO_GET_GRAD'
integer(kind=iwp), external :: IsFreeUnit
real(kind=r8), external :: ddot_

!                                                                      *
!***********************************************************************
!                                                                      *
!     General Initialization                                           *
!                                                                      *
!***********************************************************************
!                                                                      *

iRout = 9
iPrint = nPrint(iRout)

call CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = zero  !time read vectors
tcoul(:) = zero  !time for computing V_k
tcasg(:) = zero  !time for computing Z_p_k
tmotr(:) = zero  !time for the MO transf of vectors
tmotr2(:) = zero  !time for the 2nd MO transf of vectors
tscrn(:) = zero  !time for screening overhead

IREDC = -1  ! unknown reduced set in core

BatchWarn = .true.
nInd = 0

call set_nnA(nSym,nAorb,nnA)

! Various offsets

MaxB = nBas(1)
do ISYM=2,NSYM
  MaxB = max(MaxB,nBas(iSym))
end do

nI2t = 0
nItmx = 0
nIt(:) = 0
do jDen=nDen,1,-1
  kOff(1,jDen) = 0
  nIt(jDen) = nChOrb_(1,jDen)
  do i=2,nSym
    kOff(i,jDen) = nIt(jDen)
    nIt(jDen) = nIt(jDen)+nChOrb_(i,jDen)
  end do
  nI2t = nI2t+nIt(jDen)
  nItmx = max(nItmx,nIt(jDen))
end do

! Initialize pointers to avoid compiler warnings

thrv = Zero
xtau = Zero

! Construct iBDsh for later use

call mma_allocate(iBDsh,nShell*nSym,label='iBDsh')
do iSyma=1,nSym
  LKsh = 0
  do iaSh=1,nShell
    iSSa = nShell*(iSyma-1)+iaSh
    iBDsh(iSSa) = LKsh
    LKsh = LKsh+nBasSh(iSyma,iaSh)
  end do
end do

! iShp_rs
call mma_allocate(iShp_rs,nnShl_tot,Label='iShp_rs')

!***********************************************************************
!                                                                      *
!     Initialize a few things for ij-screening //Jonas B               *
!                                                                      *
!***********************************************************************
if (DoExchange) then

  ! Define the screening thresholds

  call Get_dScalar('Cholesky Threshold',ThrCom)

  tau = (ThrCom/real(max(1,nItmx),kind=wp))*dmpK

  MaxRedT = MaxRed
  call GAIGOP_SCAL(MaxRedT,'+')

  if (Estimate) tau = tau/real(MaxRedT,kind=wp)
  xtau = sqrt(tau)

  NumVT = NumChT
  call GAIGOP_SCAL(NumVT,'+')
  ! Vector MO transformation screening thresholds
  thrv = (sqrt(ThrCom/real(max(1,nItmx)*NumVT,kind=wp)))*dmpK

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par() .and. Update) then
    NNBSTMX = 0
    do i=1,nSym
      NNBSTMX = max(NNBSTMX,NNBSTR(i,1))
    end do
    call mma_allocate(DiagJ,NNBSTMX,Label='DiagJ')
    DiagJ(:) = Zero
  end if
# endif

  ! Read the diagonal integrals (stored as 1st red set)

  call mma_allocate(DIAG,NNBSTRT(1),Label='Diag')
  if (Update) call CHO_IODIAG(DIAG,2) ! 2 means "read"


  ! Allocate memory

  ! sqrt(D(a,b)) stored in full (squared) dim
  call Allocate_DT(DiaH,nBas,nBas,nSym)
  DiaH%A0(:) = Zero

  call mma_allocate(AbsC,MaxB,Label='AbsC')

  call mma_allocate(Ylk,MaxB,nItmx,Label='Ylk')

  call mma_allocate(Yik,nItmx**2,Label='Yik') ! Yi[k] vectors

  ! used to be nShell*something
  ! ML[k] lists of largest elements in significant shells
  call mma_allocate(MLk,nShell,Label='MLk')

  ! list of S:= sum_l abs(C(l)[k])
  call mma_allocate(Aux0,nShell*nI2t,Label='Aux0')
  iE = 0
  do i=1,nDen
    iS = iE+1
    iE = iE+nShell*nIt(i)
    SumClk(i)%A(1:nShell,1:nIt(i)) => Aux0(iS:iE)
  end do

  ! Indx and Indik must be stored for each density, symmetry, etc.
  ! in case of a batched procedure
  do jDen=1,nKvec
    do kSym=1,nSym
      nInd = nInd+nChOrb_(kSym,jDen)
    end do
  end do

  ! Index array
  call mma_allocate(Indx,[0,nShell],[1,nInd],Label='Indx')

  ! Yi[k] Index array
  call mma_allocate(Indik,(nItmx+1)*nItmx+1,nInd,Label='Indik')

  ! kOffSh
  call mma_allocate(kOffSh,nShell,nSym,Label='kOffSh')

  ! shell-pair Frobenius norm of the vectors
  call mma_allocate(SvShp,nnShl,2,Label='SvShp')

  ! Jonas - June 2010:
  ! allocate memory for rearranged CMO-matrix

  do i=1,nDen
    call Allocate_DT(CMOi(i),nChOrb_(:,i),nBas,nSym)
  end do

  nQoT = 0

  ! Compute Shell Offsets ( MOs and transformed vectors)

  do iSyma=1,nSym
    LKsh = 0
    do iaSh=1,nShell    ! kOffSh(iSh,iSym)

      kOffSh(iaSh,iSyma) = LKsh

      LKsh = LKsh+nBasSh(iSyma,iaSh)
    end do
  end do

  ! Determine S:= sum_l C(l)[k]^2  in each shell of C(a,k)

  do jDen=1,nDen
    do kSym=1,nSym

      do jK=1,nChOrb_(kSym,jDen)
        jK_a = jK+kOff(kSym,jDen)

        do iaSh=1,nShell

          iS = kOffSh(iaSh,kSym)+1
          iE = kOffSh(iaSh,kSym)+nBasSh(kSym,iaSh)

          SKSh = Zero
          do ik=iS,iE
            SKsh = SKsh+MSQ(jDen)%SB(kSym)%A2(ik,jK)**2
          end do

          SumClk(jDen)%A(iaSh,jK_a) = SkSh

        end do
      end do
    end do
  end do

  ! Reorder CMO-matrix, Needed to construct B-matrix for exchange
  ! Jonas - June 2010

  do jDen=1,nKdens
    do kSym=1,nSym

      ! If the orbitals come from eigenvalue decomposition, change sign

      if (lSA .and. (jDen >= 3)) then
        npos2 = npos(ksym,jDen-2)
        do jK=1,nPos2
          do jGam=1,nBas(kSym)
            CMOi(jDen)%SB(kSym)%A2(jK,jGam) = MSQ(jDen)%SB(kSym)%A2(jGam,jK)
          end do
        end do
        do jK=npos2+1,nChOrb_(kSym,jDen)
          do jGam=1,nBas(kSym)
            CMOi(jDen)%SB(kSym)%A2(jK,jGam) = -MSQ(jDen)%SB(kSym)%A2(jGam,jK)
          end do
        end do
      else

        do jK=1,nChOrb_(kSym,jDen)
          do jGam=1,nBas(kSym)
            CMOi(jDen)%SB(kSym)%A2(jK,jGam) = MSQ(jDen)%SB(kSym)%A2(jGam,jK)
          end do
        end do
      end if
    end do
  end do
end if

! Mapping shell pairs from the full to the reduced set

call Mk_iShp_rs(iShp_rs,nShell)

!                                                                      *
!***********************************************************************
!                                                                      *
!     BIG LOOP OVER VECTORS SYMMETRY                                   *
!                                                                      *
!***********************************************************************
!                                                                      *
do jSym=1,nSym
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  NumCV = NumCho(jSym)
  call GAIGOP_SCAL(NumCV,'max')
  if (NumCV < 1) cycle

  ! offsets for active term

  iOffZp = 0
  do j=1,jSym-1
    iOffZp = iOffZp+nnP(j)*NumCho(j)
  end do

  ! Open some files to store exchange auxiliary vectors

  if (DoExchange) then
    iSeed = 7
    do i=1,nSym
      k = Mul(jSym,i)
      LuRVec(i,1) = IsFreeUnit(iSeed)
      write(Fname,'(A4,I1,I1)') 'CHTA',i,k
      call DANAME_MF_WA(LuRVec(i,1),Fname)
      iSeed = iSeed+1
      if (nKvec >= 2) then
        LuRVec(i,2) = IsFreeUnit(iSeed)
        write(Fname,'(A4,I1,I1)') 'CHTB',i,k
        call DANAME_MF_WA(LuRVec(i,2),Fname)
        iSeed = iSeed+1
      end if
    end do
  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  !        M E M O R Y   M A N A G E M E N T   S E C T I O N           *
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !
  ! For one Cholesky vector, JNUM=1, compute the amount of memory
  ! needed for the various vectors.

  JNUM = 1

  ! L_Full
  call Allocate_DT(L_Full,nShell,iShp_rs,JNUM,JSYM,nSym,Memory=nL_Full)
  ! Lab
  mDen = 1
  call Allocate_DT(Lab,JNUM,nBasSh,nBas,nShell,nSym,mDen,Memory=nLab)
  if (DoCas) then
    iSwap = 0  ! Lvb,J are returned
    call Allocate_DT(Laq(1),nAorb,nBas,JNUM,JSYM,nSym,iSwap,Memory=nLaq)
    nLxy = 0
    do iMO1=1,nAdens
      iSwap_lxy = 5
      if (iMO1 == 2) iSwap_lxy = 6
      call Allocate_DT(Lxy,nAorb,nAorb,JNUM,JSYM,nSym,iSwap_lxy,Memory=nLxy0)
      nLxy = max(nLxy,nLxy0)
    end do
  else
    nLaq = 0
    nLxy = 0
  end if

  ! compute memory needed to store at least 1 vector of JSYM
  ! and do all the subsequent calculations

  nLik = 0
  nRik = 0
  do l=1,nSym
    k = Mul(l,JSYM)
    do jDen=1,nDen
      nRik = max(nRik,nChOrb_(l,jDen)*nChOrb_(k,jDen))
      if (nChOrb_(k,jDen) > 0) then
        nLik = max(nLik,nChOrb_(l,jDen))
      end if
    end do
  end do

  ! re-use memory for the active vec
  LFMAX = max(nLaq+nLxy,nL_Full(1)+nRik+nLik+nLab(1))
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
!                                                                      *

  iLoc = 3 ! use scratch location in reduced index arrays

  if (NumCho(jSym) < 1) then
    JRED1 = 1
    JRED2 = 1
  else
    JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
    JRED2 = InfVec(NumCho(jSym),2,jSym) ! red set of the last vec
  end if
# ifdef _MOLCAS_MPP_
  myJRED1 = JRED1 ! first red set present on this node
  ntv0 = 0
# endif

  ! entire red sets range for parallel run
  call GAIGOP_SCAL(JRED1,'min')
  call GAIGOP_SCAL(JRED2,'max')

  ! MGD does it need to be so?

  DoScreen = .true.
  kscreen = 1
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do JRED=JRED1,JRED2
    !                                                                  *
    !*******************************************************************
    !                                                                  *

    if (NumCho(jSym) < 1) then
      iVrs = 0
      nVrs = 0
    else
      call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)
    end if

    if (nVrs /= 0) then  ! some vector in that (jred,jsym)

      if (nVrs < 0) then
        write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
        call Abend()
      end if

      ! set index arrays at iLoc
      call Cho_X_SetRed(irc,iLoc,JRED)
      if (irc /= 0) then
        write(u6,*) SECNAM,': cho_X_setred non-zero return code. rc= ',irc
        call Abend()
      end if

      IREDC = JRED

      nRS = nDimRS(JSYM,JRED)

      if (JSYM == 1) then
        call mma_allocate(Drs,nRS,nJdens,Label='Drs')
        Drs(:,:) = Zero
        if (iMp2prpt == 2) then
          call mma_allocate(Drs2,nRS,1,Label='Drs2')
        end if
      end if

      call mma_maxDBLE(LWORK)

      nVec = min((LWORK-nL_Full(2)-nLab(2))/(nRS+LFMAX),nVrs)

      if (nVec < 1) then
        write(u6,*) SECNAM//': Insufficient memory for batch'
        write(u6,*) ' LWORK= ',LWORK
        write(u6,*) ' min. mem. need= ',nRS+LFMAX
        write(u6,*) ' jsym= ',jsym
        write(u6,*) ' nRS = ',nRS
        write(u6,*) ' LFMAX = ',LFMAX
        write(u6,*)
        write(u6,*) ' nL_Full = ',nL_Full
        write(u6,*) ' nRik = ',nRik
        write(u6,*) ' nLik = ',nLik
        write(u6,*) ' nLab = ',nLab
        write(u6,*)
        write(u6,*) ' nLaq = ',nLaq
        write(u6,*) ' nLxy = ',nLxy
        irc = 33
        call Abend()
        nBatch = -9999  ! dummy assignment
      end if

      !                                                                *
      !*****************************************************************
      !                                                                *
      LREAD = nRS*nVec

      call mma_allocate(Lrs,nRS,nVec,Label='Lrs')

      if (JSYM == 1) then
        ! Transform the densities to reduced set storage
        add = .false.
        nMat = 1
        do jDen=1,nJdens
          call swap_full2rs(irc,iLoc,nRS,nMat,JSYM,DLT(jDen),Drs(:,jDen),add)
        end do
        if (iMp2prpt == 2) then
          call swap_full2rs(irc,iLoc,nRS,nMat,JSYM,[DLT2],Drs2(:,1),add)
        end if
      end if

      ! BATCH over the vectors

      nBatch = (nVrs-1)/nVec+1

      if (BatchWarn .and. (nBatch > 1)) then
        if (iPrint >= 6) then
          write(u6,'(20A3)') ('---',I=1,20)
          write(u6,*) ' Batch procedure used. Increase memory if possible!'
          write(u6,'(20A3)') ('---',I=1,20)
          write(u6,*)
          call XFlush(u6)
        end if
        BatchWarn = .false.
      end if

      !                                                                *
      !*****************************************************************
      !                                                                *
      do iBatch=1,nBatch
        !                                                              *
        !***************************************************************
        !                                                              *
        if (iBatch == nBatch) then
          JNUM = nVrs-nVec*(nBatch-1)
        else
          JNUM = nVec
        end if

        JVEC = nVec*(iBatch-1)+iVrs
        IVEC2 = JVEC-1+JNUM

        call CWTIME(TCR1,TWR1)

        call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

        if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
          irc = 77
          return
        end if

        call CWTIME(TCR2,TWR2)
        tread(1) = tread(1)+(TCR2-TCR1)
        tread(2) = tread(2)+(TWR2-TWR1)

        !***************************************************************
        !***************************************************************
        !**                                                           **
        !**      Coulomb term                                         **
        !**      V{#J} = sum_ab  L(ab,{#J}) * D(ab)                   **
        !**                                                           **
        !***************************************************************
        !***************************************************************
        if (JSYM == 1) then

          call CWTIME(TCC1,TWC1)

          ! Inactive Coulomb term

          do jden=1,nJdens
            call DGEMV_('T',nRS,JNUM,One,Lrs,nRS,Drs(1,jden),1,zero,V_k(jVec,jDen),1)
          end do

          ! MP2 Coulomb term

          if (iMp2prpt == 2) then
            call DGEMV_('T',nRS,JNUM,One,Lrs,nRS,Drs2(:,1),1,zero,U_k(jVec),1)
          end if

          call CWTIME(TCC2,TWC2)
          tcoul(1) = tcoul(1)+(TCC2-TCC1)
          tcoul(2) = tcoul(2)+(TWC2-TWC1)
        end if
        !***************************************************************
        !***************************************************************
        !**                                                           **
        !**      E X C H A N G E    T E R M                           **
        !**                                                           **
        !***************************************************************
        !***************************************************************

        if (DoExchange) then

          call CWTIME(TCS1,TWS1)
          !*************************************************************
          !                                                            *
          ! 1) Screening                                               *
          !                                                            *
          !    Select only important  ij pairs                         *
          !    For this, one computes the quantity                     *
          !       Yik = sum_mu_nu (mu nu | mu nu)^1/2 X_mu_i X_nu_k    *
          !    with (mu nu | mu nu) = sum_J (L_mu_nu,J)^2              *
          !                                                            *
          !                                                            *
          !    a) Estimate the diagonals:                              *
          !         D(mu,nu) = sum_J (L_mu_nu,J)^2                     *
          !                                                            *
          !*************************************************************
          if (Estimate) then

            Diag(iiBstR(jSym,1)+1:iiBstR(jSym,1)+NNBSTR(jSym,1)) = Zero

            do krs=1,nRS

              mrs = iiBstR(JSYM,iLoc)+krs
              jrs = IndRed(mrs,iLoc) ! address in 1st red set

              do jvc=1,JNUM

                Diag(jrs) = Diag(jrs)+Lrs(krs,jvc)**2

              end do

            end do

          end if

          call CWTIME(TCS2,TWS2)
          tscrn(1) = tscrn(1)+(TCS2-TCS1)
          tscrn(2) = tscrn(2)+(TWS2-TWS1)
          !                                                            *
          !*************************************************************
          !*************************************************************
          !*************************************************************
          !                                                            *
          call Allocate_DT(L_Full,nShell,iShp_rs,JNUM,JSYM,nSym)
          call mma_allocate(Aux,(nRik+nLik)*nVec,Label='Aux')
          call Allocate_DT(Lab,JNUM,nBasSh,nBas,nShell,nSym,mDen)

          call CWTIME(TCX1,TWX1)

          ! Reorder vectors to Full-dimensions
          !
          ! Vectors are returned in the storage LaJ,b with the restriction:
          !    Sym(a) >= Sym(b)
          ! and blocked in shell pairs

          call CHO_getShFull(Lrs,lread,JNUM,JSYM,IREDC,L_Full,SvShp,nnShl,iShp_rs,nnShl_tot)

          call CWTIME(TCX2,TWX2)
          tmotr(1) = tmotr(1)+(TCX2-TCX1)
          tmotr(2) = tmotr(2)+(TWX2-TWX1)

          !*************************************************************
          !                                                            *
          ! 1) Screening                                               *
          !                                                            *
          !    b) DH(mu,nu)=sqrt(D(mu,nu))                             *
          !       Only the symmetry blocks with compound symmetry JSYM *
          !       are computed                                         *
          !                                                            *
          !*************************************************************
          if (DoScreen) then

            call CWTIME(TCS1,TWS1)

            ired1 = 1 ! location of the 1st red set
            call swap_tosqrt(irc,ired1,NNBSTRT(1),JSYM,DIAH,DIAG)

            call CWTIME(TCS2,TWS2)
            tscrn(1) = tscrn(1)+(TCS2-TCS1)
            tscrn(2) = tscrn(2)+(TWS2-TWS1)

          end if

          !*************************************************************
          !                                                            *
          ! 1) Screening                                               *
          !                                                            *
          !    c) 1st MO transformation of DH(mu,nu)                   *
          !          Y(mu)[k] = sum_nu  DH(mu,nu) * |C(nu)[k]|         *
          !                                                            *
          !*************************************************************

          nInd = 1
          do jDen=1,nKvec

            ! Choose which MO sets on each side

            iMOleft = jDen
            iMOright = jDen

            n1 = nIt(iMOright)
            n2 = nItMx

            pYik(1:n1,1:n2) => Yik(1:n1*n2)

            if (DoCAS .and. lSA) iMOright = jDen+2

            do kSym=1,nSym

              lSym = Mul(JSYM,kSym)
              Nik = nChOrb_(kSym,iMOleft)*nChOrb_(lSym,iMOright)
              nIJR(kSym,lSym,jDen) = Nik
              nIJ1(kSym,lSym,jDen) = Nik
              if ((JSYM == 1) .and. (iMOleft == iMOright)) Nik = nTri_Elem(nChOrb_(kSym,iMOleft))
              nIJ1(kSym,lSym,jDen) = Nik

              if (Nik == 0) cycle

              iS = 1
              iE = nChOrb_(lSym,iMOright)*JNUM

              Lik(1:JNUM,1:nChOrb_(lSym,iMOright)) => Aux(iS:iE)

              iS = iE+1
              iE = iE+Nik*JNUM

              Rik(1:Nik*JNUM) => Aux(iS:iE)

              Rik(:) = Zero

              do jK=1,nChOrb_(kSym,iMOleft)
                jK_a = jK+kOff(kSym,iMOleft)

                Lik(:,:) = Zero
                Lab%A0(1:nBas(lSym)*JNUM) = Zero

                if (DoScreen .and. (iBatch == 1)) then
                  call CWTIME(TCS1,TWS1)
                  !-----------------------------------------------------
                  ! Setup the screening
                  !-----------------------------------------------------

                  AbsC(1:nBas(kSym)) = abs(MSQ(iMOleft)%SB(kSym)%A2(:,jK))

                  if (lSym >= kSym) then

                    mode = 'N'
                    n1 = nBas(lSym)
                    n2 = nBas(kSym)

                  else ! lSym<kSym

                    mode = 'T'
                    n1 = nBas(kSym)
                    n2 = nBas(lSym)

                  end if

                  if (n1 > 0) call DGEMV_(Mode,n1,n2,ONE,DiaH%SB(lSym,kSym)%A2,n1,AbsC,1,ZERO,Ylk(1,jK_a),1)

                  !*****************************************************
                  !                                                    *
                  ! 1) Screening                                       *
                  !                                                    *
                  !    d) 2nd MO transformation of DH(mu,nu)           *
                  !          Y(i)[k] = sum_mu  |C(mu)[i]| * Y(mu)[k]   *
                  !                                                    *
                  !*****************************************************

                  if ((kSym /= lSym) .or. (iMOleft /= iMOright)) then
                    iStart = 1
                  else
                    iStart = jK
                  end if

                  nQo = 0
                  do i=iStart,nChOrb_(lSym,iMOright)

                    AbsC(1:nBas(lSym)) = abs(MSQ(iMOright)%SB(lSym)%A2(:,i))

                    pYik(i,jK_a) = ddot_(nBas(lSym),AbsC,1,Ylk,1)

                    if (pYik(i,jK_a) >= xtau) then
                      nQo = nQo+1
                      if ((iBatch == 1) .and. (JRED == 1)) then
                        nQoT = nQoT+1
                        if ((lSym == kSym) .and. (i /= jK) .and. (iMOright == iMOleft)) nQoT = nQoT+1
                      end if
                      Indik(1+nQo,nInd) = i
                    end if

                  end do
                  Indik(1,nInd) = nQo
                  !*****************************************************
                  !                                                    *
                  ! 1) Screening                                       *
                  !                                                    *
                  !    e) List the shells present in Y(l)[k] by the    *
                  !       largest element and sort the list            *
                  !                                                    *
                  !*****************************************************

                  do ish=1,nShell
                    YshMax = zero
                    do ibs=1,nBasSh(lSym,ish)
                      ibs_a = koffSh(ish,lSym)+ibs
                      YshMax = max(YshMax,Ylk(ibs_a,1))
                    end do
                    MLk(ish) = YshMax
                  end do

                  do ish=1,nShell
                    Indx(ish,nInd) = ish
                  end do

                  !*****************************************************
                  !                                                    *
                  ! 1) Screening                                       *
                  !                                                    *
                  !    f) Screening                                    *
                  !                                                    *
                  ! Here we use a non-exact bound for the exchange     *
                  ! matrix to achieve linear scaling. The positive     *
                  ! definiteness of the exchange matrix combined with  *
                  ! the structure of the density matrix makes this     *
                  ! bound acceptable and likely to be almost exact for *
                  ! what concerns the exchange energy                  *
                  !                                                    *
                  ! The exact bounds (quadratic scaling of the MO      *
                  ! transformation) would be                           *
                  !    If (MLk(jml)*MLk(1) >= tau) then                *
                  !                                                    *
                  !*****************************************************

                  numSh = 0  ! # of significant shells
                  jml = 1
                  do while (jml <= nShell)

                    YMax = MLk(jml)
                    jmlmax = jml

                    do iml=jml+1,nShell  ! get the max
                      if (MLk(iml) > YMax) then
                        YMax = MLk(iml)
                        jmlmax = iml
                      end if
                    end do

                    if (jmlmax /= jml) then  ! swap positions
                      xTmp = MLk(jml)
                      iTmp = Indx(jml,nInd)
                      MLk(jml) = YMax
                      Indx(jml,nInd) = Indx(jmlmax,nInd)
                      MLk(jmlmax) = xTmp
                      Indx(jmlmax,nInd) = iTmp
                    end if

                    if (MLk(jml) >= xtau) then
                      numSh = numSh+1
                    else
                      jml = nShell  ! exit the loop
                    end if

                    jml = jml+1

                  end do

                  Indx(0,nInd) = numSh

                  call CWTIME(TCS2,TWS2)
                  tscrn(1) = tscrn(1)+(TCS2-TCS1)
                  tscrn(2) = tscrn(2)+(TWS2-TWS1)
                  !-----------------------------------------------------
                end if  ! Screening setup

                call CWTIME(TCT1,TWT1)

                !*******************************************************
                !                                                      *
                !             E X C H A N G E    T E R M               *
                !                                                      *
                ! 2) MO transformation                                 *
                !    a) 1st half transformation                        *
                !                                                      *
                !    Transform vectors for shells in the list ML[k]    *
                !                                                      *
                !    Screening based on the Frobenius norm:            *
                !       sqrt(sum_ij  A(i,j)^2)                         *
                !       || La,J[k] ||  <=  || Lab,J || * || Cb[k] ||   *
                !                                                      *
                !*******************************************************

                do iSh=1,Indx(0,nInd)

                  iaSh = Indx(iSh,nInd)

                  Lab%Keep(iaSh,1) = .true.

                  ibcount = 0

                  do ibSh=1,nShell

                    iOffShb = kOffSh(ibSh,kSym)

                    iShp = iTri(iaSh,ibSh)

                    if (iShp_rs(iShp) <= 0) cycle

                    if ((nnBstRSh(JSym,iShp_rs(iShp),iLoc)*nBasSh(lSym,iaSh)*nBasSh(kSym,ibSh) > 0) .and. &
                        (sqrt(abs(SumClk(iMOleft)%A(ibSh,jK_a)*SvShp(iShp_rs(iShp),1))) >= thrv)) then

                      ibcount = ibcount+1

                      if (lSym >= kSym) then

                        l1 = 1
                        if (iaSh < ibSh) l1 = 2

                        ! LaJ,[k] = sum_b  L(aJ,b) * C(b)[k]
                        !------------------------------------

                        Mode = 'N'
                        n1 = nBasSh(lSym,iaSh)*JNUM
                        n2 = nBasSh(kSym,ibSh)

                        call DGEMV_(Mode,n1,n2,One,L_Full%SPB(lSym,iShp_rs(iShp),l1)%A21,n1, &
                                    MSQ(iMOleft)%SB(kSym)%A2(iOffShb+1:,jK),1,ONE,Lab%SB(iaSh,lSym,1)%A,1)

                      else   ! lSym < kSym

                        l1 = 1
                        if (ibSh < iaSh) l1 = 2

                        ! LJa,[k] = sum_b  L(b,Ja) * C(b)[k]
                        !------------------------------------

                        Mode = 'T'
                        n1 = nBasSh(kSym,ibSh)
                        n2 = JNUM*nBasSh(lSym,iaSh)

                        call DGEMV_(Mode,n1,n2,One,L_Full%SPB(kSym,iShp_rs(iShp),l1)%A12,n1, &
                                    MSQ(iMOleft)%SB(kSym)%A2(iOffShb+1:,jK),1,ONE,Lab%SB(iaSh,lSym,1)%A,1)

                      end if

                    end if

                  end do

                  ! The following re-assignement is used later on to check if the
                  ! iaSh vector LaJ[k] can be neglected because identically zero

                  if (ibcount == 0) Lab%Keep(iaSh,1) = .false.

                end do

                !*******************************************************
                !                                                      *
                ! 2) MO transformation                                 *
                !    b) 2nd half transformation                        *
                !                                                      *
                !*******************************************************

                nQo = Indik(1,nInd)

                do ir=1,nQo

                  it = Indik(1+ir,nInd)

                  do iSh=1,Indx(0,nInd)

                    iaSh = Indx(iSh,nInd)

                    if (.not. Lab%Keep(iaSh,1)) cycle

                    iS = kOffsh(iaSh,lSym)+1

                    if (lSym >= kSym) then

                      ! LJi[k] = sum_a  LaJ[k] * Cai
                      !------------------------------

                      Mode = 'T'
                      n1 = nBasSh(lSym,iaSh)
                      n2 = JNUM

                    else   ! lSym < kSym

                      ! LJi[k] = sum_a  LJa[k] * Cai
                      !------------------------------

                      Mode = 'N'
                      n1 = JNUM
                      n2 = nBasSh(lSym,iaSh)

                    end if

                    call DGEMV_(Mode,n1,n2,One,Lab%SB(iaSh,lSym,1)%A,n1,MSQ(iMOright)%SB(lSym)%A2(iS:,it),1,one,Lik(:,it),1)

                  end do

                  ! Copy LJi[k] in the standard ordered matrix Lik,J

                  if ((jSym == 1) .and. (iMOright == iMOleft)) then
                    itk = nTri_Elem(it-1)+jK
                  else
                    itk = nChOrb_(lSym,iMOright)*(jK-1)+it
                  end if
                  call dcopy_(JNUM,Lik(:,it),1,Rik(itk:),Nik)

                end do

                nInd = nInd+1

                call CWTIME(TCT2,TWT2)
                tmotr2(1) = tmotr(1)+(TCT2-TCT1)
                tmotr2(2) = tmotr(2)+(TWT2-TWT1)

              end do  ! loop over k MOs

              call CWTIME(TCT1,TWT1)

              !*********************************************************
              !                                                        *
              ! 3) Put to disk                                         *
              !                                                        *
              !*********************************************************
              iAdr = Nik*(JVEC-1)
              call DDAFILE(LuRVec(lSym,jDen),1,Rik,Nik*JNUM,iAdr)

              call CWTIME(TCT2,TWT2)
              tmotr(1) = tmotr(1)+(TCT2-TCT1)
              tmotr(2) = tmotr(2)+(TWT2-TWT1)

            end do   ! loop over MOs symmetry

            nullify(pYik)

          end do   ! loop over densities

          call Deallocate_DT(Lab)
          call mma_deallocate(Aux)
          call Deallocate_DT(L_Full)
          !                                                            *
          !*************************************************************
          !*************************************************************
          !*************************************************************
          !                                                            *

          ! ************  END EXCHANGE CONTRIBUTION  ****************

          ! Diagonals updating. It only makes sense if nScreen > 0

          if (Update .and. (nScreen > 0)) then

            call CWTIME(TCS1,TWS1)
            !-------------------------------------------------------------
            ! update the diagonals :   D(a,b) = D(a,b) - sum_J (Lab,J)^2

            ! subtraction is done in the 1st reduced set
#           ifdef _MOLCAS_MPP_
            if (Is_Real_Par()) then

              do krs=1,nRS
                mrs = iiBstR(JSYM,iLoc)+krs
                jrs = IndRed(mrs,iLoc)-iiBstR(JSYM,1)
                do jvc=1,JNUM
                  DiagJ(jrs) = DiagJ(jrs)+Lrs(krs,jvc)**2
                end do
              end do

            else

              do krs=1,nRS
                mrs = iiBstR(JSYM,iLoc)+krs
                jrs = IndRed(mrs,iLoc) ! address in 1st red set
                do jvc=1,JNUM
                  Diag(jrs) = Diag(jrs)-Lrs(krs,jvc)**2
                end do
              end do

            end if

#           else
            do krs=1,nRS
              mrs = iiBstR(JSYM,iLoc)+krs
              jrs = IndRed(mrs,iLoc) ! address in 1st red set
              do jvc=1,JNUM
                Diag(jrs) = Diag(jrs)-Lrs(krs,jvc)**2
              end do
            end do
#           endif

            call CWTIME(TCS2,TWS2)
            tscrn(1) = tscrn(1)+(TCS2-TCS1)
            tscrn(2) = tscrn(2)+(TWS2-TWS1)

          end if

        end if ! DoExchange

        !***************************************************************
        !***************************************************************
        !**                                                           **
        !**    Active term                                            **
        !**                                                           **
        !***************************************************************
        !***************************************************************
        if (DoCAS) then

          call CWTIME(TCC1,TWC1)

          ! Set up the skipping flags
          ! The memory used before for the full-dimension AO-vectors
          !     is now re-used to store half and full transformed
          !     vectors in the active space

          iSwap = 0  ! Lvb,J are returned
          call Allocate_DT(Laq(1),nAorb,nBas,nVec,JSYM,nSym,iSwap)

          iMO2 = 1
          do iMO1=1,nAdens

            ! iSwap_lxy=5 diagonal blocks are triangular
            ! iSwap_lxy=6 diagonal blocks are square
            iSwap_lxy = 5
            if (iMO1 == 2) iSwap_lxy = 6
            call Allocate_DT(Lxy,nAorb,nAorb,nVec,JSYM,nSym,iSwap_lxy)

            !***********************************************************
            !                                                          *
            !  MO transformation of Cholesky vectors                   *
            !                                                          *
            !      1) Lvb,J = sum_a  C(v,a) * Lab,J                    *
            !                                                          *
            !***********************************************************

            kMOs = 1
            nMOs = 1  ! Active MOs (1st set)

            call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,Aorb(iMO1),Laq(1),DoRead)

            if (irc /= 0) then
              return
            end if

            !***********************************************************
            !                                                          *
            !  MO transformation of Cholesky vectors                   *
            !                                                          *
            !      2) Lvw,J = sum_b  Lvb,J * C(w,b)                    *
            !                                                          *
            !***********************************************************
            if ((JSYM == 1) .and. (iMO1 == iMO2)) then

              do iSymb=1,nSym

                NAv = nAorb(iSymb)

                if (NAv < 1) cycle

                do JVC=1,JNUM
                  ! triangular blocks
                  call DGEMM_Tri('N','T',NAv,NAv,NBAS(iSymb),One,Laq(1)%SB(iSymb)%A3(:,:,JVC),NAv,Aorb(iMO2)%SB(iSymb)%A2,NAv, &
                                 Zero,Lxy%SB(iSymb)%A2(:,JVC),NAv)

                end do

              end do

            else

              do iSymb=1,nSym

                iSymv = Mul(JSYM,iSymb)
                NAv = nAorb(iSymv)
                NAw = nAorb(iSymb) ! iSymb=iSymw

                if ((NAv*NAw /= 0) .and. (iSymv <= iSymb)) then

                  do JVC=1,JNUM

                    ! square or rectangular blocks
                    call DGEMM_('N','T',NAv,NAw,NBAS(iSymb),One,Laq(1)%SB(iSymv)%A3(:,:,JVC),NAv,Aorb(iMO2)%SB(iSymb)%A2,NAw,Zero, &
                                Lxy%SB(iSymv)%A2(:,JVC),NAv)

                  end do

                end if

              end do

            end if
            !***********************************************************
            !                                                          *
            !  Evaluation of the Z_p_k                                 *
            !                                                          *
            !      Z(p){#J} = sum_xy  T(xy,p) * L(xy,{#J})             *
            !                                                          *
            !  T(xy,p) : is stored by compound symmetry JSYM           *
            !            the indices {xy} are stored as PACKED         *
            !            (sym x < = sym y)                             *
            !                                                          *
            !***********************************************************
            do iTxy=iMO1,nAdens
              iAvec = iMO1+iTxy-1
              do iSymy=1,nSym

                iSymx = Mul(iSymy,JSYM)

                if ((iSymx <= iSymy) .and. (nnA(iSymx,iSymy) /= 0)) then

                  ipZp = iOffZp+nnP(JSYM)*(JVEC-1)+1

                  if (iMO1 == iMO2) then

                    ! diagonal symmetry blocks are triangular
                    call DGEMM_('T','N',nnP(JSYM),JNUM,nnA(iSymx,iSymy),ONE,Txy(ipTxy(iSymx,iSymy,iTxy)),nnP(JSYM), &
                                Lxy%SB(iSymx)%A2,nnA(iSymx,iSymy),ONE,Z_p_k(ipZp,iAvec),nnP(JSYM))

                  else
                    !MGD may rearrange the loops

                    do i=1,nnP(JSYM)
                      ioff = ipTxy(iSymx,iSymy,iTxy)+nnA(iSymx,iSymy)*(i-1)

                      do j=1,JNUM

                        !MGD don't work with symmetry
                        temp = Zero
                        do k=0,nAOrb(iSymx)-1
                          do l=0,k
                            temp = temp+Half*Txy(ioff+iTri(k+1,l))*(Lxy%SB(iSymx)%A2(l+1+nAOrb(iSymx)*k,j)+ &
                                   Lxy%SB(iSymx)%A2(k+1+nAOrb(iSymx)*l,j))
                          end do
                        end do

                        ij = ipZp-1+i+nnP(JSYM)*(j-1)

                        Z_p_k(ij,iAvec) = Z_p_k(ij,iAvec)+temp

                      end do ! j
                    end do   ! i

                  end if

                end if

              end do
            end do

            call Deallocate_DT(Lxy)
          end do

          call CWTIME(TCC2,TWC2)
          tcasg(1) = tcasg(1)+(TCC2-TCC1)
          tcasg(2) = tcasg(2)+(TWC2-TWC1)

          call Deallocate_DT(Laq(1))

        end if  ! DoCAS

      end do  ! end batch loop
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !**                                                             **
      !**    Epilogue                                                 **
      !**                                                             **
      !*****************************************************************
      !*****************************************************************
      !                                                                *

      ! free memory
      call mma_deallocate(Lrs)

      if (JSYM == 1) then
        call mma_deallocate(Drs)
        if (iMp2prpt == 2) call mma_deallocate(Drs2)
      end if

    end if

    ! Screening control section
    DoScreen = kscreen == nScreen

    if (.not. DoScreen) then
      kscreen = kscreen+1
    else
      kscreen = 1
    end if

    if (DoExchange) then
#     ifdef _MOLCAS_MPP_
      if (Is_Real_Par() .and. Update .and. DoScreen) then
        call GaDsum(DiagJ,nnBSTR(JSYM,1))
        Diag(iiBstR(JSYM,1)+1:iiBstR(JSYM,1)+nnBstR(JSYM,1)) = Diag(iiBstR(JSYM,1)+1:iiBstR(JSYM,1)+nnBstR(JSYM,1))- &
                                                               DiagJ(1:nnBSTR(JSYM,1))
        DiagJ(1:nnBSTR(JSYM,1)) = Zero
      end if
      ! Need to activate the screening to setup the contributing shell
      ! indices the first time the loop is entered .OR. whenever other nodes
      ! have performed screening in the meanwhile
      if (Is_Real_Par() .and. (.not. DoScreen) .and. (nVrs == 0)) then
        ntv0 = ntv0+1
        DoScreen = ((JRED < myJRED1) .or. (ntv0 >= nScreen))
        if (DoScreen) ntv0 = 0
      end if
#     endif
    end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  end do   ! loop over red sets
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (DoExchange) then
    do jDen=1,nKvec
      do i=1,nSym
        call DACLOS(LuRVec(i,jDen))
      end do
    end do
  end if

  !                                                                    *
  !*********************************************************************
  !                                                                    *
end do  ! loop over JSYM
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate a field to be used by Compute_A_jk later
! since allocations cannot be made at that stage
!                                                                      *
!***********************************************************************
!                                                                      *
if (DoExchange) then
  nIJMax = 0
  do jDen=1,nKvec
    do iSym1=1,nSym
      do iSym2=1,nSym
        nIJMax = max(nIJMax,nIJR(iSym1,iSym2,jDen))
      end do
    end do
  end do
  call mma_allocate(VJ,2*nIJMax,Label='VJ')
end if

call mma_deallocate(iShp_rs)
if (DoExchange) then
  call mma_deallocate(SvShp)
  call mma_deallocate(kOffSh)
  call mma_deallocate(Indik)
  call mma_deallocate(Indx)
  do i=1,nDen
    nullify(SumClk(i)%A)
  end do
  call mma_deallocate(Aux0)
  call mma_deallocate(MLk)
  call mma_deallocate(Yik)
  call mma_deallocate(Ylk)
  call mma_deallocate(AbsC)
  call Deallocate_DT(DiaH)
# ifdef _MOLCAS_MPP_
  if (Is_Real_Par() .and. Update) call mma_deallocate(DiagJ)
# endif
  call mma_deallocate(Diag)
end if

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1
#ifdef _CD_TIMING_
ChoGet_CPU = TOTCPU
ChoGet_Wall = TOTWALL
#endif

! Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky Gradients timing from '//SECNAM
  write(u6,CFmt) '----------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) '                                CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ VECTORS                              ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COULOMB CONTRIB.                          ',tcoul(1),tcoul(2)
  write(u6,'(2x,A26,2f10.2)') 'SCREENING OVERHEAD                        ',tscrn(1),tscrn(2)
  write(u6,'(2x,A26,2f10.2)') 'INACT MO-TRANSFORM VECTORS                ',tmotr(1),tmotr(2)
  write(u6,'(2x,A26,2f10.2)') 'INACT MO-TRANSFORM VECTORS 2              ',tmotr2(1),tmotr2(2)
  write(u6,'(2x,A26,2f10.2)') 'ACTIVE CONTRIB.                           ',tcasg(1),tcasg(2)
  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

irc = 0

return

end subroutine CHO_GET_GRAD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Xprop(short, ifallorb,
     &                 nirrep,nbas,ntotv,vec,ntoto,occ,thrs,
     &                 ntotd,opel,
     &                 out)
************************************************************************
*                                                                      *
*     Purpose: the calculation of the average value of an operator,    *
*              whose matrix elements are supplied in the array opel,   *
*              for a set of eigenvectors supplied in vec with occupa-  *
*              tion numbers supplied in occ                            *
*                                                                      *
*     Parameters                                                       *
*                                                                      *
*       short          logical, if (short) then only the total average *
*                      value is calculated and transferred in out(1)   *
*       ifallorb       logical, if (ifallorb) then print the property  *
*                      of all orbitals (including virtuals) and none is*
*                      weighted by occupation number (S.S.Dong, 2018)  *
*                                                                      *
*       nirrep         number of irreps                                *
*       nbas(0:nirrep) dimension for each irrep                        *
*                                                                      *
*       ntotv          the total number of elemnts for all eigenvectors*
*       vec            if (short) then vec stores all lower triangles  *
*       (1:ntotv)      for all diagonal blocks of the density matrix   *
*                      size: sum(i,i=0,nirrep-1)(nbas(i)*(nbas(i)+1)/2)*
*                      else                                            *
*                      vec stores the eigenvectors                     *
*                      size: sum(i,i=0,nirrep-1)(nbas(i)*nbas(i))      *
*       ntoto          the total number of vectors for all represen-   *
*                      tations=the number of basis functions           *
*       occ            if (short) the occ array is a dummy             *
*       (1:ntoto)      else                                            *
*                      occ stores the occupation numbers               *
*                      size: sum(i,i=0,nirrep-1)(nbas(i))              *
*       thrs           if (short) or (ifallorb) then this parameter is *
*                      a dummy                                         *
*                      else                                            *
*                      if the orbital occupation number is .le.        *
*                      thrs the orbital contribution will not be       *
*                      printed out.                                    *
*                                                                      *
*       ntotd          the total number of elements in lower triangles *
*                      of all diagonal blocks                          *
*       opel           a storage area for transferring all lower       *
*       (1:ntotd)      triangles of diagonal blocks of the operator    *
*                      matrix                                          *
*                      size: sum(i,i=0,nirrep-1)(nbas(i)*(nbas(i)+1)/2)*
*       out            on return if (short) out(1) contains the total  *
*                      average value                                   *
*                      else                                            *
*                      out(i), i=1,sum(k,k=0,nirrep-1)(nbas(i))        *
*                      contains the orbital contributions (multiplied  *
*                      by the corresponding occupation numbers)        *
*                                                                      *
* Modified by S.S.Dong, 2018, Univ. of Minnesota                       *
* - Enable properties to be printed for all orbitals                   *
* (including virtuals) and not weighted by occupation numbers          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      logical short, ifallorb
      dimension nbas(0:nirrep-1),vec(1:ntotv),
     &          occ(1:ntoto),opel(1:ntotd),out(1:ntoto)
*
      if (short) then
        icount=1
        sum=DDOT_(ntotd,vec,1,opel,1)
        Out(1) = Sum
      else if (.Not.ifallorb) then
        ndim2=0
        do 1 i=0,nirrep-1
          ndim2=ndim2+nbas(i)**2
    1   continue
*
        iadv=0
        iado=0
        iadout=0
        jCount = 1
        do 199 i=0,nirrep-1
        do 200 iv=1,nbas(i)
          iado=iado+1
          iadout=iadout+1
          sum=0.0d+00
          icount=jCount
          do 201 iv1=1,nbas(i)
            do 202 iv2=1,iv1-1
              sum=sum+2.0d+00*vec(iadv+iv1)*vec(iadv+iv2)*opel(icount)
              icount=icount+1
  202       continue
            sum=sum+vec(iadv+iv1)*vec(iadv+iv1)*opel(icount)
            icount=icount+1
  201     continue
          out(iadout)=occ(iado)*sum
          iadv=iadv+nbas(i)
  200   continue
        jCount = jCount + nBas(i)*(nBas(i)+1)/2
  199   continue
      else if (ifallorb) then
        ndim2=0
        do 2 i=0,nirrep-1
          ndim2=ndim2+nbas(i)**2
    2   continue
*
        iadv=0
        iado=0
        iadout=0
        jCount = 1
        do 195 i=0,nirrep-1
        do 196 iv=1,nbas(i)
          iado=iado+1
          iadout=iadout+1
          sum=0.0d+00
          icount=jCount
          do 197 iv1=1,nbas(i)
            do 198 iv2=1,iv1-1
              sum=sum+2.0d+00*vec(iadv+iv1)*vec(iadv+iv2)*opel(icount)
              icount=icount+1
  198       continue
            sum=sum+vec(iadv+iv1)*vec(iadv+iv1)*opel(icount)
            icount=icount+1
  197     continue
          out(iadout)=sum
          iadv=iadv+nbas(i)
  196   continue
        jCount = jCount + nBas(i)*(nBas(i)+1)/2
  195   continue
      endif
*
*     if (short) then
*       write (*,'(3x,a,f18.10)') 'Total = ', out(1)
*     else
*       ii=0
*       do 2 i=0,nirrep-1
*         write (*,'(1x,a,i2)') 'Irrep No.',i
*         write (*,'(5(3x,i3,i3,f18.10))')
*    &    (j,out(ii+j),j=1,nbas(i))
*         ii=ii+nbas(i)
*   2   continue
*     endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(thrs)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine wrrs_cvb(vec,n,file_id,ioffset)
      implicit real*8 (a-h,o-z)
      dimension vec(n)

      call wrlow_cvb(vec,n,file_id,ioffset)
      ioffset=ioffset+n
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      SubRoutine Angles(Lbls,xyz,mCentr,rtrnc,Max_Center)
************************************************************************
*                                                                      *
* Object: to compute angles from a list of coordinates.                *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "Molcas.fh"
      Real*8 xyz(3,mCentr)
      Character*(LENIN) Lbls(mCentr)
      Logical Type
*
      Lu=6
      If (mCentr.gt.Max_Center) Go To 99
*
      Type = .False.
*-----The center atom
      Do 52 ic = 1, mCentr
         x1 = xyz(1,ic)
         y1 = xyz(2,ic)
         z1 = xyz(3,ic)
         Do 53 jc = 1, mCentr
            If (jc.eq.ic) Go To 53
            x2 = xyz(1,jc)
            y2 = xyz(2,jc)
            z2 = xyz(3,jc)
            r1 = Sqrt((x2-x1)**2+(y2-y1)**2+(z2-z1)**2)
            If (r1.gt.rtrnc.or.r1.eq.Zero) Go To 53
            Do 54 kc = jc+1, mCentr
               If (kc.eq.ic) Go To 54
               x3 = xyz(1,kc)
               y3 = xyz(2,kc)
               z3 = xyz(3,kc)
               r2 = Sqrt((x3-x1)**2+(y3-y1)**2+(z3-z1)**2)
               If (r2.gt.rtrnc.or.r2.eq.Zero) Go To 54
               arg=  ((x2-x1)*(x3-x1)+(y2-y1)*(y3-y1)+
     &                   (z2-z1)*(z3-z1))/(r1*r2)
               If (abs(arg).gt.One) arg=sign(One,arg)
               Phi= 180.D0 * ACos(arg) / Pi
               If (.Not.Type) Then
                  Type = .True.
                  Write (Lu,*)
                  Write (Lu,'(19X,A)')
     &                  ' ************************************** '
                  Write (Lu,'(19X,A)')
     &                  ' *    Valence Bond Angles / Degree    * '
                  Write (Lu,'(19X,A)')
     &                  ' ************************************** '
                  Write (Lu,'(19X,A)')
     &                   '       Atom centers                 Phi'
               End If
               Write (Lu,'(21X,3(I2,1X,A,2X),1X,F6.2)')
     &               jc,Lbls(jc),ic,Lbls(ic),kc,Lbls(kc),Phi
 54         Continue
 53      Continue
 52   Continue
*
 99   Continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine HrmFrq(nAtom,nInter,iNeg,dDipM,mTR,Smmtrc,DipM,
     &                  IRInt, UserT, UserP, nUserPT, nsRot, lTherm,
     &                  lDoubleIso)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
      Real*8 dDipM(3,nInter+mTR), DipM(3), IRInt(nInter+mTR)
      Logical Smmtrc(3,nAtom), lTherm, lDoubleIso
      Integer mDisp(8), nUserPT, nsRot
      Real*8  UserT(64), UserP
*                                                                      *
************************************************************************
*                                                                      *
      LUt=6
*                                                                      *
************************************************************************
*                                                                      *
      mInter = nInter + mTR
      nX = 3*nAtom
*
      Call GetMem('EVec','Allo','Real',ipEVec,2*mInter**2)
      Call GetMem('EVal','Allo','Real',ipEVal,2*mInter)
      Call GetMem('RedMas','Allo','Real',ipRedMas,mInter)
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute harmonic frequencies and dipole derivatives
*
      Call GetMem('tmp1','Allo','Real',iptmp1,nX**2)
      Call GetMem('tmp2','Allo','Real',iptmp2,nX**2)
*
      iDo_dDipM=1
      Call GF(nX,mInter,nInter,Work(ipTmp1),Work(ipTmp2),Work(ipEVec),
     &        Work(ipEVal),Work(ipRedMas),iNeg,iDo_dDipM,dDipM,mTR,
     &        Smmtrc,nAtom,DipM)
*
      Call GetMem('tmp2','Free','Real',iptmp2,(3*nAtom)**2)
      Call GetMem('tmp1','Free','Real',iptmp1,(3*nAtom)**2)
*                                                                      *
************************************************************************
*                                                                      *
*     Write out frequencies and IR intensities
*
      Write (LUt,10)
      Write (LUt,10) ' Observe that the harmonic oscillator analysis'
     &             //' is only valid at stationary points!'
      Write (LUt,10)
      Write (LUt,10) ' Note that rotational and translational degrees'
     &             //' have been automatically removed,'
      Write (LUt,10) ' if the energy is invariant to these degrees'
     &             //' of freedom.'
      Write (LUt,10)
      Write (LUt,10)
      Write (LUt,10) ' Harmonic frequencies in cm-1'
      Write (LUt,10)
      Write (LUt,10) ' IR Intensities in km/mol'
      Write (LUt,10)
10    Format(a)
*
      iOff=0
      iCtl=1
      iEl =3
      iSym=1
*
      Call Allocate_Work(ipTemp,3*mInter)
      Call DGeTMO(dDipM,3,3,nInter,Work(ipTemp),nInter)
*
      Lu_10=10
      Lu_10=IsFreeUnit(Lu_10)
      Call Molcas_Open(lu_10,'UNSYM')
*
      Write(Lu_10,'(A,I1)') '*NORMAL MODES SYMMETRY: ',isym
      Call GF_Print(Work(ipEVal),Work(ipEVec),Work(ipTemp),iEl,
     &              mInter,nInter,iCtl,IRInt,Work(ipRedMas),Lu_10,iOff)
*
      Close(Lu_10)
      Call Free_Work(ipTemp)
*
      If (lTherm) Call Thermo_Driver(UserT,UserP,nUserPT,nsRot,
     &                                    ipEVal,nInter,lTherm)
*                                                                      *
************************************************************************
*                                                                      *
*     Do single and double isotope substitutions
*
      Call Get_iScalar('NSYM',nIrrep)
      If (nIrrep.eq.1) Call IsoLoop(lDoubleIso)
*                                                                      *
************************************************************************
*                                                                      *
*-----Save normal modes for later generation of Molden input.
*
      nDisp=mInter
      Call GetMem('NMod','Allo','Real',ipNMod,nDisp**2)
      ipNx=ipNMod
*
      lModes=0
      nModes=0
      nX=mInter
      call dcopy_(nX*nInter,Work(ipEVec),2,Work(ipNMod),1)
      lModes=lModes+nInter*nX
      nModes=nModes+nInter
*                                                                      *
************************************************************************
*                                                                      *
*     Write stuff on Molden input file
*
      nSym=1
      Call ICopy(8,[0],0,mDisp,1)
      mDisp(1)=nInter
!      If (nIrrep.eq.1) Then
         Call Print_Mode_Components(Work(ipNMod),Work(ipEVal),
     &                              nModes,lModes,mDisp)
!      End If
      Call Freq_Molden(Work(ipEVal),nModes,Work(ipNMod),lModes,nSym,
     &                 IRInt,mDisp,Work(ipRedMas))
*                                                                      *
************************************************************************
*                                                                      *
*     Deallocate memory
*
      Call GetMem('NMod','Free','Real',ipNMod,nDisp**2)
      Call GetMem('EVal','Free','Real',ipEVal,2*nInter)
      Call GetMem('EVec','Free','Real',ipEVec,2*nInter**2)
      Call GetMem('RedMas','Free','Real',ipRedMas,mInter)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C
      SUBROUTINE GTJK_RASSCF(RJ,RK,NAC,IREOST)
C
C     PURPOSE: GET ALL INTEGRALS COULOMB AND EXCHANGE INTEGRALS
C              WITH THE CHARGE DISTRIBUTION JK
C
*. Modified by addition of IREOST, August 2003.
      IMPLICIT REAL*8 (A-H,O-Z)
*. Input : Reorder array, symmetry => type (sic!)
      INTEGER IREOST(*)
      DIMENSION RJ(*),RK(*)
#include "WrkSpc.fh"
#include "wadr.fh"
C
C     FORM THE COULOMB (RJ) AND EXCHANGE (RK) INTEGRAL MATRICES FROM
C     THE TWO-ELECTRON INTEGRAL LIST
C
      NTUT=0
      DO 100 NT=1,NAC
      DO 101 NU=1,NT
       NT_REO = IREOST(NT)
       NU_REO = IREOST(NU)
*
       NTU_REO = NAC*(NT_REO-1) + NU_REO
       NUT_REO = NAC*(NU_REO-1) + NT_REO
       NTUT=NTUT+1
       NTUK=(NTUT**2+NTUT)/2
       RK(NTU_REO)=WORK(LTUVX+NTUK-1)
       RK(NUT_REO)=WORK(LTUVX+NTUK-1)
C
       NTT=(NT**2+NT)/2
       NTUJ=(NTT**2-NTT)/2+(NU**2+NU)/2
       RJ(NTU_REO)=WORK(LTUVX+NTUJ-1)
       RJ(NUT_REO)=WORK(LTUVX+NTUJ-1)
101   CONTINUE
100   CONTINUE
C
C     EXIT
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PopAnalysis(nneq,neq,exch,nexch,nmax,lmax,NmaxPop,Z)
! computes the density matrix of each interacting site in the coupled eigenstate Zi
! N - (Integer) - total number of the exchange states ( total number of basis functions )
! Z - (Complex array, size N) - contains the coupled eigenvector (a given column of the entire exchange Z array)
! Nsites - total number of interacting magnetic sites
! ibas(N,Nsites) - Integer array denoting the coupled basis
! nneq -- number of non equivalent sites
! neq(Nneq) number of equivalent sites of type i

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nneq, neq(nneq), exch, nexch(nneq), nmax, lmax, NmaxPop
complex(kind=wp), intent(in) :: Z(exch,exch)
integer(kind=iwp) :: i, i1, i2, il, isite, j, l, nb, nb1, nb2, nb3, tmp
integer(kind=iwp), allocatable :: ibas(:,:), intc(:), nind(:,:)
complex(kind=wp), allocatable :: pop(:,:,:,:) ! pop(exch,lmax,nmax,nmax)
character(len=50) :: fmtline

#ifdef _DEBUGPRINT_
write(u6,'(A)') 'enter POPULATION ANALYSIS Subroutine'
write(u6,'(A, i3)') '      nmax = ',nmax
write(u6,'(A, i3)') '      exch = ',exch
write(u6,'(A, i3)') '   NmaxPop = ',NmaxPop
write(u6,'(A, i3)') '      lmax = ',lmax
write(u6,'(A, i3)') '      nneq = ',nneq
write(u6,'(A,8i3)') '    neq(i) = ',(neq(i),i=1,nneq)
write(u6,'(A,8i3)') '  nexch(i) = ',(nexch(i),i=1,nneq)
#endif
call mma_allocate(pop,exch,lmax,nmax,nmax,'pop')
call mma_allocate(ibas,exch,lmax,label='ibas')
call mma_allocate(intc,lmax,label='intc')
call mma_allocate(nind,lmax,2,label='nind')
! fill some general arrays:
! generate the tables:
l = 0
do i=1,nneq
  do j=1,neq(i)
    l = l+1
    nind(l,1) = i
    nind(l,2) = j
  end do
end do
nind(l+1:,:) = 0
intc(1) = 1
if (lmax > 1) then
  do i=2,lmax
    i1 = nind(i-1,1)
    intc(i) = intc(i-1)*nexch(i1)
  end do
end if
do nb=1,exch
  nb1 = nb-1
  do i=1,lmax
    ibas(nb,lmax-i+1) = nb1/intc(lmax-i+1)
    nb1 = nb1-ibas(nb,lmax-i+1)*intc(lmax-i+1)
  end do
end do
isite = 0
call mma_deallocate(intc)

pop(:,:,:,:) = cZero
i = 24+13*lmax
fmtline = '(A)'
write(u6,fmtline) repeat('-',i)
i = (24+13*lmax-19)/2
write(fmtline,'(A,i3,A,i3,A)') '(',i,'X,A,',i,'X)'
write(u6,fmtline) 'POPULATION ANALYSIS'
i = (8+13*lmax-19)/2
write(fmtline,'(A,i3,A,i3,A)') '(',i,'X,A,',i,'X)'
write(u6,fmtline) '(i.e. diagonal value of density matrices of the interacting sites)'
i = 24+13*lmax
fmtline = '(A)'
write(u6,fmtline) repeat('-',i)
write(fmtline,'(A,i3,A)') '(A,',lmax,'A)'
write(u6,fmtline) '--------|-----|',('------------|',i=1,lmax)
write(u6,fmtline) 'Exchange|Basis|',('   center   |',i=1,lmax)
write(fmtline,'(A,i3,A)') '(A,',lmax,'(A,i2,A))'
write(u6,fmtline) ' state  | set |',('     ',i,'     |',i=1,lmax)
write(fmtline,'(A,i3,A)') '(A,',lmax,'A)'
write(u6,fmtline) '--------|-----|',('------------|',i=1,lmax)

! loop over all states for which we want density matrices and
! expectation values to be calculated
do nb1=1,NmaxPop
  do l=1,lmax
    isite = nind(l,1)
    do i1=1,nexch(isite)
      do i2=1,nexch(isite)
        ! sum over all other components of other sites
        do nb2=1,exch
          do nb3=1,exch
            if (ibas(nb2,l)+1 /= i1) cycle
            if (ibas(nb3,l)+1 /= i2) cycle
            tmp = 0
            do il=1,lmax
              if (il /= l) tmp = tmp+(ibas(nb2,il)-ibas(nb3,il))**2
            end do

            if (tmp == 0) pop(nb1,l,i1,i2) = pop(nb1,l,i1,i2)+conjg(Z(nb2,nb1))*Z(nb3,nb1)

          end do
        end do
      end do
    end do
  end do

  do i=1,nmax ! maxim local basis
    write(fmtline,'(A,i2,A)') '(2x,i4,2x,A,1x,i2,2x,A,',lmax,'(1x,F10.8,1x,A))'
    write(u6,fmtline) nb1,'|',i,'|',(real(pop(nb1,l,i,i)),'|',l=1,lmax)
  end do
  write(fmtline,'(A,i2,A)') '(A,',lmax,'A)'
  write(u6,fmtline) '--------|-----|',('------------|',i=1,lmax)
end do ! nb1

! compute and print the calculated expectation values:
!write(u6,*)
!write(u6,'(A)') 'EXPECTATION VALUES'
!write(u6,'(5A)') '--------|----|',('------------------------------|',i=1,4)
!write(u6,'(5A)') 'Exchange|Site|','   MAGNETIC MOMENT (M=-L-2S)  |','        SPIN MOMENT (S)       |', &
!                 '      ORBITAL MOMENT (L)      |','     TOTAL MOMENT (J=L+S)     |'
!write(u6,'(5A)') ' state  | Nr.|',('     X         Y         Z    |',i=1,4)
!write(u6,'(5A)') '--------|----|',('------------------------------|',i=1,4)
!do nb1=1,NmaxPop
!  ! we proceed to compute expectation values for this nb1 exchange state
!  Mx(:) = cZero
!  My(:) = cZero
!  Mz(:) = cZero
!  Sx(:) = cZero
!  Sy(:) = cZero
!  Sz(:) = cZero
!
!  isite = nind(ind_exch(l),1)
!  do i1=1,nexch(isite)
!    do i2=1,nexch(isite)
!      Mx(:) = Mx(:)+pop(nb1,:,i1,i2)*M(isite,1,i1,i2)
!      My(:) = My(:)+pop(nb1,:,i1,i2)*M(isite,2,i1,i2)
!      Mz(:) = Mz(:)+pop(nb1,:,i1,i2)*M(isite,3,i1,i2)
!      Sx(:) = Sx(:)+pop(nb1,:,i1,i2)*S(isite,1,i1,i2)
!      Sy(:) = Sy(:)+pop(nb1,:,i1,i2)*S(isite,2,i1,i2)
!      Sz(:) = Sz(:)+pop(nb1,:,i1,i2)*S(isite,3,i1,i2)
!    end do
!  end do
!  Lx(:) = -Mx(:)-g_e*Sx(:)
!  Ly(:) = -My(:)-g_e*Sy(:)
!  Lz(:) = -Mz(:)-g_e*Sz(:)
!  Jx(:) =  Lx(:)+Sx(:)
!  Jy(:) =  Ly(:)+Sy(:)
!  Jz(:) =  Lz(:)+Sz(:)
!
!  do l=1,lmax
!    if (l == (lmax+1)/2) then
!      write(u6,'(i5,3x,A,1x,i2,1x,A,4(3(F9.5,1x),A))') nb1,'|',l,'|',real(Mx(l)),real(My(l)),real(Mz(l)),'|',real(Sx(l)), &
!                                                       real(Sy(l)),real(Sz(l)),'|',real(Lx(l)),real(Ly(l)),real(Lz(l)),'|', &
!                                                       real(Jx(l)),real(Jy(l)),real(Jz(l)),'|'
!    else
!      write(u6,'(8x,A,1x,i2,1x,A,4(3(F9.5,1x),A))') '|',l,'|',real(Mx(l)),real(My(l)),real(Mz(l)),'|',real(Sx(l)),real(Sy(l)), &
!                                                    real(Sz(l)),'|',real(Lx(l)),real(Ly(l)),real(Lz(l)),'|',real(Jx(l)), &
!                                                    real(Jy(l)),real(Jz(l)),'|'
!    end if
!  end do
!  write(u6,'(5A)') '--------|----|',('------------------------------|',i=1,4)
!end do

call mma_deallocate(pop)
call mma_deallocate(ibas)
call mma_deallocate(nind)

return

end subroutine PopAnalysis

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c  ********************************************************
c  ** Public-domain library routines used by casvb only. **
c  ********************************************************
c  **********************
c  ** EISPACK ROUTINES **
c  **********************
      subroutine casvb_tred1(nm,n,a,d,e,e2)
c
      integer i,j,k,l,n,ii,nm,jp1
      real*8 a(nm,n),d(n),e(n),e2(n)
      real*8 f,g,h,scale
c
c     this subroutine is a translation of the algol procedure tred1,
c     num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
c
c     this subroutine reduces a real symmetric matrix
c     to a symmetric tridiagonal matrix using
c     orthogonal similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the real symmetric input matrix.  only the
c          lower triangle of the matrix need be supplied.
c
c     on output
c
c        a contains information about the orthogonal trans-
c          formations used in the reduction in its strict lower
c          triangle.  the full upper triangle of a is unaltered.
c
c        d contains the diagonal elements of the tridiagonal matrix.
c
c        e contains the subdiagonal elements of the tridiagonal
c          matrix in its last n-1 positions.  e(1) is set to zero.
c
c        e2 contains the squares of the corresponding elements of e.
c          e2 may coincide with e if the squares are not needed.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      do 100 i = 1, n
         d(i) = a(n,i)
         a(n,i) = a(i,i)
  100 continue
c     .......... for i=n step -1 until 1 do -- ..........
      do 300 ii = 1, n
         i = n + 1 - ii
         l = i - 1
         h = 0.0d0
         scale = 0.0d0
         if (l .lt. 1) go to 130
c     .......... scale row (algol tol then not needed) ..........
         do 120 k = 1, l
         scale = scale + abs(d(k))
  120    continue
c
         if (scale .ne. 0.0d0) go to 140
c
         do 125 j = 1, l
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = 0.0d0
  125    continue
c
  130    e(i) = 0.0d0
         e2(i) = 0.0d0
         go to 300
c
  140    do 150 k = 1, l
            d(k) = d(k) / scale
            h = h + d(k) * d(k)
  150    continue
c
         e2(i) = scale * scale * h
         f = d(l)
         g = -sign(sqrt(h),f)
         e(i) = scale * g
         h = h - f * g
         d(l) = f - g
         if (l .eq. 1) go to 285
c     .......... form a*u ..........
         do 170 j = 1, l
         e(j) = 0.0d0
  170    continue
c
         do 240 j = 1, l
            f = d(j)
            g = e(j) + a(j,j) * f
            jp1 = j + 1
            if (l .lt. jp1) go to 220
c
            do 200 k = jp1, l
               g = g + a(k,j) * d(k)
               e(k) = e(k) + a(k,j) * f
  200       continue
c
  220       e(j) = g
  240    continue
c     .......... form p ..........
         f = 0.0d0
c
         do 245 j = 1, l
            e(j) = e(j) / h
            f = f + e(j) * d(j)
  245    continue
c
         h = f / (h + h)
c     .......... form q ..........
         do 250 j = 1, l
         e(j) = e(j) - h * d(j)
  250    continue
c     .......... form reduced a ..........
         do 280 j = 1, l
            f = d(j)
            g = e(j)
c
            do 260 k = j, l
            a(k,j) = a(k,j) - f * e(k) - g * d(k)
  260       continue
c
  280    continue
c
  285    do 290 j = 1, l
            f = d(j)
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = f * scale
  290    continue
c
  300 continue
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CSDIAG_CI_UTIL(CSFDIA,DETDIA,NCNFTP,NTYP,
     *                  ICTSDT,NDTFTP,NCSFTP,IPRINT)
C
C     PURPOSE: OBTAIN AVERAGE CI DIAGONAL ELEMENTS AND STORE IN CSFDIA
C
C     CALLS TO SUBROUTINES AND EXTERNAL FUNCTIONS:
C     DCOPY,WRTMAT
C
C     CALLING PARAMETERS.
C     CSFDIA  : CI DIAGONAL IN SCF BASIS
C     DETDIA  : CI DIAGONAL IN DETERMINENT BASIS
C     NCNFTP  :
C     NTYP    :
C     ICTSDT  :
C     NDTFTP  :
C     NCSFTP  :
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION CSFDIA(*),DETDIA(*)
      DIMENSION NCNFTP(NTYP),NDTFTP(NTYP),NCSFTP(NTYP)
      DIMENSION ICTSDT(*)
C
      ICSOFF = 1
      IDTOFF = 1
      JCNABS = 0
      DO 100 ITYP = 1, NTYP
        IDET = NDTFTP(ITYP)
        ICSF = NCSFTP(ITYP)
        ICNF = NCNFTP(ITYP)
        DO 80 JCNF = 1, ICNF
          JCNABS = JCNABS + 1
          EAVER = 0.0D0
          DO 70 JDET = 1, IDET
            EAVER = EAVER +DETDIA(ABS(ICTSDT(IDTOFF-1+JDET)) )
70        CONTINUE
          IF( IDET .NE. 0 )EAVER = EAVER/DBLE(IDET)
          CALL DCOPY_(ICSF,[EAVER],0,CSFDIA(ICSOFF),1)
          ICSOFF = ICSOFF + ICSF
          IDTOFF = IDTOFF + IDET
80      CONTINUE
100   CONTINUE
C
      IF( IPRINT.GE.40 ) THEN
        NCSTOT = ICSOFF-1
        NDTTOT = IDTOFF-1
        WRITE(6,*) ' '
        WRITE(6,*) ' CIDIAGONAL IN DET BASIS '
        CALL WRTMAT(DETDIA,1,NDTTOT,1,NDTTOT)
        WRITE(6,*) ' '
        WRITE(6,*) ' CIDIAGONAL IN CSF BASIS '
        CALL WRTMAT(CSFDIA,1,NCSTOT,1,NCSTOT)
      END IF
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
c  ************************************
c  ** Print and save final VB energy **
c  ************************************
      subroutine finalresult_cvb()
      implicit real*8 (a-h,o-z)
c ... Make: up to date? ...
      logical, external :: up2date_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      if((.not.variat).and.up2date_cvb('SVB'))then
        call add_info('SVB',[abs(svb)],1,7)
      endif
      if((.not.variat).and.up2date_cvb('EVB'))then
        call add_info('EVB',[evb],1,7)
      endif
      return
      entry finalresult_init_cvb()
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Process_Coor(R,Coor,nAtoms,nSym,iOper)
      Implicit Real*8 (a-h,o-z)
      Real*8 R(3), Coor(3,*)
      Integer iOper(0:nSym-1)
*
*     Local array
*
      Real*8 Q(3)
*                                                                      *
************************************************************************
*                                                                      *
C     Call RecPrt('Coor(Enter)',' ',Coor,3,nAtoms)
C     Call RecPrt('R',' ',R,3,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Identify if this is a new center.
*
      Do iAtom = 1, nAtoms
         If (R(1).eq.Coor(1,iAtom) .and.
     &       R(2).eq.Coor(2,iAtom) .and.
     &       R(3).eq.Coor(3,iAtom) ) Return
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Add this atom to the list
*
      nAtoms=nAtoms+1
      call dcopy_(3,R,1,Coor(1,nAtoms),1)
      iRef = nAtoms
C     Call RecPrt('Coor(updated)',' ',Coor,3,nAtoms)
C     Write (*,*) 'nSym=',nSym
C     Write (*,*) 'iOper=',iOper
*                                                                      *
************************************************************************
*                                                                      *
*     Add symmetry degenerate atoms to the list
*
      Do iSym = 1, nSym-1
C        Write (6,*) 'iOper(iSym)=',iOper(iSym)
         call dcopy_(3,R,1,Q,1)
         If (iAnd(iOper(iSym),1).ne.0) Q(1)=-Q(1)
         If (iAnd(iOper(iSym),2).ne.0) Q(2)=-Q(2)
         If (iAnd(iOper(iSym),4).ne.0) Q(3)=-Q(3)
C        Call RecPrt('Q',' ',Q,3,1)
         Do iAtom = iRef, nAtoms
            If (Q(1).eq.Coor(1,iAtom) .and.
     &          Q(2).eq.Coor(2,iAtom) .and.
     &          Q(3).eq.Coor(3,iAtom) ) Go To 100
         End Do
         nAtoms = nAtoms + 1
         call dcopy_(3,Q,1,Coor(1,nAtoms),1)
 100     Continue
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _EFP_

!#define _DEBUGPRINT_
subroutine DrvEFP(First)

use, intrinsic :: iso_c_binding, only: c_char, c_funloc, c_int, c_loc, c_ptr, c_size_t
use EFP_Module, only: Coor_Type, EFP_Coors, EFP_Instance, FRAG_Type, nEFP_FRAGMENTS
use EFP, only: EFP_Add_Fragment, EFP_Add_Potential, EFP_Create, EFP_Get_Frag_Atom_Count, EFP_Prepare, &
               EFP_Set_Electron_Density_Field_FN, EFP_Set_Frag_Coordinates
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: First
integer(kind=iwp) :: i, iFrag, iLast, j
integer(c_int) :: irc
integer(c_size_t) :: frag_idx
integer(c_size_t), target :: n_atoms
character(len=180) :: CurrDir, MolDir
character(kind=c_char,len=180) :: FragName, PATH
type(c_ptr) :: cptr1
integer(c_int), external :: Molcas_ELECTRON_DENSITY_FIELD_FN
#ifdef _DEBUGPRINT_
integer(c_int) :: do_gradient
type(efp_energy), target :: Energy
#endif

! Initate the EFP object,

if (First) then

  ! Create a new EFP object

  EFP_Instance = EFP_Create()

  ! Now add the potentials

# ifdef _DEBUGPRINT_
  write(u6,*) 'Initiation of EFP'
  write(u6,*) 'nEFP_fragments=',nEFP_fragments
# endif
  iFrag = 0
  outer: do i=1,nEFP_fragments

    ! Find a unique fragment potential.
    ! Procastinate.

    do j=i+1,nEFP_fragments

      ! Branch out if there is an entry later with the same potential
      if (FRAG_TYPE(i) == FRAG_TYPE(j)) cycle outer
    end do

    ! At this point we have a unique potential label in FRAG_TYPE(i)

    if (index(FRAG_TYPE(i),'_l') /= 0) then

      ! .efg file found in the library directory

      iLast = index(FRAG_TYPE(i),'_l')
      FragName = FRAG_TYPE(i)(1:iLast-1)
      call GetEnvf('MOLCAS',MolDir)
      iLast = index(MolDir,' ')
      if (MolDir(iLast-1:iLast-1) /= '/') then
        MolDir(iLast:iLast) = '/'
        iLast = iLast+1
      end if
      Path = MolDir(1:iLast-1)//'External/efp/fraglib/'
    else

      ! .efg file found in the $CurrDir directory

      iLast = index(FRAG_TYPE(i),' ')
      FragName = FRAG_TYPE(i)(1:iLast-1)
      call GetEnvf('CurrDir',CurrDir)
      iLast = index(CurrDir,' ')
      Path = CurrDir(1:iLast-1)//'/'
    end if

    iLast = index(Path,' ')
    Path = Path(1:iLast-1)//FragName
    iLast = index(Path,' ')
    Path = Path(1:iLast-1)//'.efp'//char(0)

    irc = EFP_ADD_POTENTIAL(EFP_Instance,Path)
    if (irc /= 0) then
      write(u6,*) 'EFP potential file error.'
      write(u6,*) Path
      write(u6,*) 'Return code:',irc
      call Abend()
    end if

    ! Loop over all fragment again an add those that are of the
    ! current type

    iLast = index(FRAG_TYPE(i),' ')
    FragName = FRAG_TYPE(i)(1:iLast-1)
    iLast = index(FragNAME,' ')
    FragName = FragName(1:iLast-1)//char(0)
    do j=1,i
      if (FRAG_TYPE(j) /= FRAG_TYPE(i)) cycle
      irc = efp_add_fragment(EFP_Instance,FragName)
      if (irc /= 0) then
        write(u6,*) 'EFP_ADD_FRAGMET error.'
        write(u6,*) 'Return code:',irc
        call Abend()
      end if
      cptr1 = c_loc(EFP_COORS(1,j))
      irc = efp_set_frag_Coordinates(EFP_Instance,iFrag,Coor_type,cptr1)
      if (irc /= 0) then
        write(u6,*) 'EFP_SET_FRAG_COORDINATES error.'
        write(u6,*) 'Return code:',irc
        call Abend()
      end if
      iFrag = iFrag+1
    end do

  end do outer

  irc = EFP_PREPARE(EFP_Instance)
  if (irc /= 0) then
    write(u6,*) 'EFP_PREPARE error.'
    write(u6,*) 'Return code:',irc
    call Abend()
  end if

# ifdef _DEBUGPRINT_
  do_gradient = 0
  irc = EFP_COMPUTE(EFP_Instance,do_gradient)
  if (irc /= 0) then
    write(u6,*) 'EFP_COMPUTE error.'
    write(u6,*) 'Return code:',irc
    call Abend()
  end if

  irc = EFP_GET_ENERGY(EFP_Instance,c_loc(Energy))
  write(u6,*) Energy%Total
# endif

  irc = EFP_SET_ELECTRON_DENSITY_FIELD_FN(EFP_Instance,c_funloc(Molcas_ELECTRON_DENSITY_FIELD_FN))

end if

! Add EFP charges to the nuclear repulsion term

do frag_idx=1,nEFP_fragments

  ! Pick up the number of atoms in the fragment

  irc = EFP_GET_FRAG_ATOM_COUNT(EFP_Instance,frag_idx,c_loc(n_atoms))

  ! Pick up the fragment coordinates and charges

  !irc = EFP_GET_FRAG_ATOMS(EFP_Instance,...

end do

return

end subroutine DrvEFP

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(DrvEFP)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine CD_DiaMax(Diag,nDim,iPivot,iQual,nQual,DiaMin)
C
C     Thomas Bondo Pedersen, October 2004.
C
C     Purpose: find nQual largest elements in Diag and leave pointers to
C              them in iQual. Only elements larger than DiaMin are
C              returned (thus, nQual may be reduced here).
C
      Implicit None
      Integer nDim, nQual
      Real*8  Diag(nDim)
      Real*8  DiaMin
      Integer iPivot(nDim), iQual(nQual)

      Integer i, j, iTmp, iMax

      Do i = 1,nDim
         iPivot(i) = i
      End Do

      Do j = 1,nQual
         Do i = nDim,j+1,-1
            If (Diag(iPivot(i)) .gt. Diag(iPivot(i-1))) Then
               iTmp = iPivot(i-1)
               iPivot(i-1) = iPivot(i)
               iPivot(i)   = iTmp
            End If
         End Do
      End Do

      Call iZero(iQual,nQual)
      iMax  = nQual
      i     = 0
      nQual = 0
      Do While (i .lt. iMax)
         i = i + 1
         If (Diag(iPivot(i)) .ge. DiaMin) Then
            nQual = nQual + 1
            iQual(nQual) = iPivot(i)
         Else
            i = iMax + 1
         End If
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SymAdO_mck(ArrIn,nB,ArrOut,nrOp,nop,IndGrd,iu,iv,ifgrd,idCar,trans)

use Symmetry_Info, only: iChBas, iChTbl, nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nB, nrOp, nop(2), IndGrd(0:7), iu, iv, idCar
real(kind=wp), intent(in) :: ArrIn(nB,2)
real(kind=wp), intent(inout) :: ArrOut(nB,nrOp)
logical(kind=iwp), intent(in) :: IfGrd(3,2), trans(2)
integer(kind=iwp) :: iCn, iIrrep, n
real(kind=wp) :: Fact, ps
integer(kind=iwp), external :: iPrmt

! Accumulate contributions

n = 0
do iIrrep=0,nIrrep-1
  if (Indgrd(iIrrep) /= 0) then
    n = n+1
    do iCn=1,2
      if ((Trans(iCn) .or. IfGrd(idCar,iCn)) .and. (IndGrd(iIrrep) /= 0)) then

        ! Accumulate contribution to the gradient

        if (iCn == 1) then
          ps = real(iPrmt(nOp(1),iChBas(1+idCar)),kind=wp)
          Fact = real(iu,kind=wp)/real(nIrrep,kind=wp)
          if (trans(1)) then
            Fact = -Fact
          end if
        else
          ps = real(iChTbl(iIrrep,nOp(2)),kind=wp)
          ps = ps*real(iPrmt(nOp(2),iChBas(1+idCar)),kind=wp)
          Fact = ps*real(iv,kind=wp)/real(nIrrep,kind=wp)
          if (trans(2)) then
            Fact = -Fact
          end if
        end if
        ArrOut(:,n) = ArrOut(:,n)+Fact*ArrIn(:,1)
      end if
    end do
  end if
end do

return

end subroutine SymAdO_mck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module info_expbas_mod

use Definitions, only: iwp

implicit none
private

!> Different kinds of orbitals
!> f, i, 1, 2, 3, s, d
integer(kind=iwp), parameter :: n_orb_kinds = 7

logical(kind=iwp) :: DoExpbas, DoDesy
character(len=512) :: EB_FileOrb

public :: DoExpbas, DoDesy, EB_FileOrb, n_orb_kinds

! Exporting some useful parameters
#include "Molcas.fh"
public :: LenIn, MxAtom, mxsym

end module info_expbas_mod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!***********************************************************************

subroutine GATRMT(MATIN,NROWIN,NCOLIN,MATUT,NROWUT,NCOLUT,ISCA,SSCA)
! Gather rows of transposed matrix MATIN  to  MATUT
!
! MATUT(I,J) = SSCA(I)*MATIN(J,ISCA(I)),(ISCA(I) /= 0)
!
! Jeppe Olsen, Getting LUCIA in shape, Feb1994

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NROWIN, NCOLIN, NROWUT, NCOLUT, ISCA(*)
real(kind=wp), intent(in) :: MATIN(NCOLIN,NROWIN), SSCA(*)
real(kind=wp), intent(out) :: MATUT(NROWUT,NCOLUT)
integer(kind=iwp) :: I, ICBL, ICEND, ICOFF, IROW, LBLK, NBLK
real(kind=wp) :: S

! (MATIN Transposed)

! To get rid of annoying and incorrect compiler warnings
ICOFF = 0
!LBLK = 100
LBLK = 40
NBLK = NCOLUT/LBLK
if (LBLK*NBLK < NCOLUT) NBLK = NBLK+1
do ICBL=1,NBLK
  if (ICBL == 1) then
    ICOFF = 1
  else
    ICOFF = ICOFF+LBLK
  end if
  ICEND = min(ICOFF+LBLK-1,NCOLUT)
  do I=1,NROWUT
    IROW = ISCA(I)
    if (IROW == 0) then
      MATUT(I,ICOFF:ICEND) = Zero
    else
      S = SSCA(I)
      MATUT(I,ICOFF:ICEND) = S*MATIN(ICOFF:ICEND,IROW)
    end if
  end do
end do

return

end subroutine GATRMT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ZECON(NSTATE,N,UR,UI,AR,AI,ZEKL,IXYZ,ISTATE,ISS,JSS)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NSTATE, N, IXYZ, ISTATE, ISS, JSS
real(kind=wp), intent(in) :: UR(N,N), UI(N,N), AR(N,N), AI(N,N)
complex(kind=wp), intent(inout) :: ZEKL(2,2,3,NSTATE)
real(kind=wp) :: TMPI1, TMPI2, TMPR1, TMPR2

TMPR1 = AR(ISS,JSS)*UR(JSS,1)-AI(ISS,JSS)*UI(JSS,1)
TMPR2 = AR(ISS,JSS)*UR(JSS,2)-AI(ISS,JSS)*UI(JSS,2)
TMPI1 = AI(ISS,JSS)*UR(JSS,1)+AR(ISS,JSS)*UI(JSS,1)
TMPI2 = AI(ISS,JSS)*UR(JSS,2)+AR(ISS,JSS)*UI(JSS,2)

ZEKL(1,1,IXYZ,ISTATE) = ZEKL(1,1,IXYZ,ISTATE)+cmplx(UR(ISS,1)*TMPR1+UI(ISS,1)*TMPI1,UR(ISS,1)*TMPI1-UI(ISS,1)*TMPR1,kind=wp)
ZEKL(1,2,IXYZ,ISTATE) = ZEKL(1,2,IXYZ,ISTATE)+cmplx(UR(ISS,1)*TMPR2+UI(ISS,1)*TMPI2,UR(ISS,1)*TMPI2-UI(ISS,1)*TMPR2,kind=wp)
ZEKL(2,1,IXYZ,ISTATE) = ZEKL(2,1,IXYZ,ISTATE)+cmplx(UR(ISS,2)*TMPR1+UI(ISS,2)*TMPI1,UR(ISS,2)*TMPI1-UI(ISS,2)*TMPR1,kind=wp)
ZEKL(2,2,IXYZ,ISTATE) = ZEKL(2,2,IXYZ,ISTATE)+cmplx(UR(ISS,2)*TMPR2+UI(ISS,2)*TMPI2,UR(ISS,2)*TMPI2-UI(ISS,2)*TMPR2,kind=wp)

end subroutine ZECON

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Multipole_Expansion(q_A,q_B,Dipole_A,Dipole_B,R_A,R_B,R,Absolute)

use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: Multipole_Expansion
real(kind=wp), intent(in) :: q_A, q_B, Dipole_A, Dipole_B, R_A, R_B, R
logical(kind=iwp) :: Absolute
real(kind=wp) :: dR_A, dR_B, E_A, E_B

dR_A = R_A-R
dR_B = R_B-R
call Multipole_E(q_A,Dipole_A,dR_A,E_A)
call Multipole_E(q_B,Dipole_B,dR_B,E_B)

if (Absolute) then
  Multipole_Expansion = abs(E_A+E_B)
else
  Multipole_Expansion = E_A+E_B
end if

return

end function Multipole_Expansion

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018,2019, Roland Lindh                                *
!               2019, Mickael G. Delcey                                *
!               2019, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine PRPROP_TM_Exact(PROP,USOR,USOI,ENSOR,NSS,JBNUM,EigVec)

use Index_Functions, only: nTri_Elem
use RASSI_AUX, only: iDisk_TDM
use kVectors, only: e_Vector, k_Vector, nk_Vector
use do_grid, only: Do_Lebedev
use nq_Grid, only: Pax
use Cntrl, only: DIPR, Do_Pol, Do_SK, ICOMP, IRREP, L_Eff, LOOPDIVIDE, LOOPMAX, lSym1, lSym2, LUTDM, MLTPLT, NPROP, nQuad, NSTATE, &
                 OSThr_Dipr, OSThr_QIPR, PNAME, PrRaw, PrWeight, PTYPE, QIPR, REDUCELOOP, RSPR, RSThr, TMGR_Thrs
use Symmetry_Info, only: MUL, nIrrep
use rassi_data, only: NBASF, NBST, NTDMZZ
#ifdef _HDF5_
use mh5, only: mh5_put_dset
use RASSIWfn, only: wfn_SOS_TM
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four, Half, Pi, auTofs, c_in_au, Debye, gElectron
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: PROP(NSTATE,NSTATE,NPROP)
integer(kind=iwp), intent(in) :: NSS, JBNUM(NSTATE)
real(kind=wp), intent(in) :: USOR(NSS,NSS), USOI(NSS,NSS), ENSOR(NSS), EigVec(NSTATE,NSTATE)
integer(kind=iwp) :: I, iCar, IDISK, IEMPTY, IEND, iEnd_, IGO, iGrp, IJ_, ijSO, IJSS(4), IMSS, IOFF(8), iOpt, iPrint, IPROP, iPrP, &
                     IPRTMOM(14), iQuad, iQuad_, ISF, ISM, ISO, ISS, ISSM, iStart_, iState, iSy12, ITYPE, iVec, iVec_, J, JEnd, &
                     jEnd_, jGrp, JMSS, Job, Job1, Job2, JSF, JSM, JSO, JSS, JSSM, JSTart, jStart_, K, KP, lRaw, lRaw_, MASK, &
                     MaxGrp1, MaxGrp2, NDIFF, NGROUP1, NGROUP2, NIP, NMAX2, nQuad_, NSCR, nTmp, NVEC
real(kind=wp) :: A, ANG, CST, Dummy(1), EDiff, EDiff_, EnSOR1, EnSOR2, F, F_Check, F_temp, kPhase(2), OSThr, R, R_Check, R_temp, &
                 RefEne, RKNorm, RNG, RNorm, Tau, TCPU1, TCPU2, TEMP, Thrs, ThrsParse, TM1, TM2, TM3, TM_2, TM_C(3), TM_I(3), &
                 TM_R(3), TWALL1, TWALL2, UK(3), wavevector(3), Weight
logical(kind=iwp) :: TMOgroup
character(len=52) :: STLNE2
character(len=8) :: LABEL
integer(kind=iwp), allocatable :: iMask(:), ISS_INDEX(:), iSSMask(:), jMask(:), jSSMask(:), TMOgrp1(:), TMOgrp2(:)
real(kind=wp), allocatable :: Aux(:,:), DXI(:,:,:), DXIM(:,:,:), DXR(:,:,:), DXRM(:,:,:), IP(:), OscStr(:,:), pol_Vector(:,:), &
                              RAW(:), Rquad(:,:), SCR(:,:), TDMZZ(:), TMI(:,:,:), TMP(:,:), TMR(:,:,:), VSOI(:,:), VSOR(:,:), &
                              WDMZZ(:)
#ifdef _HDF5_
integer(kind=iwp) :: ijSO_, ip_kVector, ip_TMi, ip_TMr, ip_W, nData, nij
real(kind=wp), allocatable :: Storage(:,:,:,:)
#endif
real(kind=wp), parameter :: AFACTOR = Two/c_in_au**3/(auTofs*1.0e-15_wp), AU2REDR = 200.0_wp*Debye, THRSH = 1.0e-10_wp
real(kind=wp), external :: DDot_

#define _TIME_TMOM_
#ifdef _TIME_TMOM_
call CWTime(TCpu1,TWall1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Before we start we need to backtransform the coefficients of the
! SO states from the basis of the SF states which diagonalize the
! SF Hamiltonian to the basis of the original (input) SF states.
! This since all transition moments, whether retrieved from disk or
! recomputed, are in the basis of the original SF states.

call mma_allocate(VSOR,NSS,NSS,Label='VSOR')
call mma_allocate(VSOI,NSS,NSS,Label='VSOI')

call USOTRANS(USOR,USOI,NSS,EigVec,NSTATE,VSOR,VSOI)

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _TIME_TMOM_
call CWTime(TCpu1,TWall1)
#endif
! Compute transition strengths for spin-orbit states:

! Initial setup for exact operator

! printing threshold
OSTHR = 1.0e-5_wp
if (DIPR) OSTHR = OSTHR_DIPR
if (DIPR) write(u6,30) 'Dipole printing threshold changed to ',OSTHR
! Again to avoid total negative transition strengths
if (QIPR) then
  OSTHR = OSTHR_QIPR
  write(u6,49) 'Printing threshold changed to ',OSTHR,' since quadrupole threshold is given'
end if
! Rotatory strength threshold
if (RSPR) then
  write(u6,30) 'Rotatory strength printing threshold changed to ',RSTHR
else
  RSTHR = 1.0e-07_wp !Default
end if

! Reducing the loop over states - good for X-rays
! At the moment memory is not reduced

JEND = NSS
if (REDUCELOOP) then
  IEND = LOOPDIVIDE
  JSTART = LOOPDIVIDE+1
  if (LOOPMAX > 0) JEND = min(NSS,LOOPDIVIDE+LOOPMAX)
else
  IEND = NSS
  JSTART = 1
end if

!***********************************************************************
!                                                                      *
!     Start of section for transition moments                          *
!                                                                      *
!     This section has two parts. (1) for matrix elements computed by  *
!     Seward, i.e. for a specific wavevector, (2) for the computation  *
!     of the isotropic oscillator strength.                            *
!                                                                      *
!***********************************************************************

! Find the section of transition moments in the property list.

! The operator is split in 4 different component, each with three
! elements corresponding to differentiation in the x, y, and z
! direction. The four parts are labels as:
! TMOM  RS: The symmetric part of the real comp. of the op.
! TMOM  RA: The asymmetric part of the real comp. of the op.
! TMOM  IS: The symmetric part of the imaginary comp. of the op.
! TMOM  IA: The asymmetric part of the imaginary comp. of the op.

!***********************************************************************
!                                                                      *
!     Section (1): Computation of k specific oscillator strength.      *
!     Section (2): Computation of the isotropic oscillator strength.   *
!                                                                      *
!***********************************************************************

! Here we will use a Lebedev grid to integrate over all possible
! directions of the wave vector, k. The property integrals will be
! computed on the fly and traced with the density to generate the
! corresponding values in the PROP matrix.

! Find the slot on the one-electron file where we will store the
! on-the-fly generated property integrals.

IPRTMOM(:) = -1
do IPROP=1,NPROP
  if (PNAME(IPROP) == 'TMOM  RS') then
    if (IPRTMOM(0+ICOMP(IPROP)) == -1) IPRTMOM(0+ICOMP(IPROP)) = IPROP
  end if
  if (PNAME(IPROP) == 'TMOM  IS') then
    if (IPRTMOM(3+ICOMP(IPROP)) == -1) IPRTMOM(3+ICOMP(IPROP)) = IPROP
  end if
  if (PNAME(IPROP) == 'TMOM  RA') then
    if (IPRTMOM(6+ICOMP(IPROP)) == -1) IPRTMOM(6+ICOMP(IPROP)) = IPROP
  end if
  if (PNAME(IPROP) == 'TMOM  IA') then
    if (IPRTMOM(9+ICOMP(IPROP)) == -1) IPRTMOM(9+ICOMP(IPROP)) = IPROP
  end if
  if (PNAME(IPROP) == 'TMOM0  R') then
    if (IPRTMOM(13) == -1) IPRTMOM(13) = IPROP
  end if
  if (PNAME(IPROP) == 'TMOM0  I') then
    if (IPRTMOM(14) == -1) IPRTMOM(14) = IPROP
  end if
end do
if (any(IPRTMOM == -1)) then
  call mma_deallocate(VSOR)
  call mma_deallocate(VSOI)
end if

! Initiate the Seward environment

nDiff = 0
call IniSew(.false.,nDiff)

! Generate the quadrature points.

! In the spin-coupled case, wave functions are complex and there is
! not a simple relation between oscillator and rotatory strengths for
! k and -k vectors, but there is between the integrals computed in
! the spin-free basis, so we compute them only once and obtain separately
! the results for k and -k, given by kPhase

kPhase = [One,-One]
if (Do_SK) then
  nQuad = 1
  nVec = nk_Vector
  call mma_allocate(Rquad,4,nQuad,label='SK')
  if (.not. (PRRAW .or. PRWEIGHT)) kPhase(2) = Zero
else
  call unitmat(Pax,3)
  call Do_Lebedev(L_Eff,nQuad,Rquad,4)
  Rquad(4,:) = Half*Rquad(4,:)
  nVec = 1
end if
if (Do_Pol) call mma_allocate(pol_Vector,3,nVec*nQuad,Label='POL')

! Initialize for density matrices.

call mma_Allocate(TDMZZ,nTDMZZ,Label='TDMZZ')
call mma_Allocate(WDMZZ,nTDMZZ,Label='WDMZZ')
nSCR = nTri_Elem(NBST)
call mma_allocate(SCR,nSCR,4,LABEL='SCR')

! Allocate some temporary arrays for handling the
! properties of the spin-orbit states.

call mma_allocate(DXR,NSS,NSS,3,Label='DXR')
call mma_allocate(DXI,NSS,NSS,3,Label='DXI')
call mma_allocate(DXRM,NSS,NSS,3,Label='DXRM')
call mma_allocate(DXIM,NSS,NSS,3,Label='DXIM')
call mma_Allocate(TMP,NSS,NSS,Label='TMP')
call mma_allocate(TMR,NSS,NSS,3,Label='TMR')
call mma_allocate(TMI,NSS,NSS,3,Label='TMI')

! ALLOCATE A BUFFER FOR READING ONE-ELECTRON INTEGRALS
NIP = 4+nTri_Elem(NBST)
call mma_allocate(IP,NIP,Label='IP')
#ifdef _HDF5_

! Allocate vector to store all individual transition moments.
! We do this for
! all unique pairs ISO-JSO, iSO=/=JSO nTri_Elem(NSS-1)
!     all k-vectors (2*nQuad or 2*nVec)
!         we store:
!             the weight (1)
!             the k-vector (3)
!             we projected transition vector (real and imaginary parts) (2*3)

nIJ = nTri_Elem(nSS-1)
ip_w = 1
ip_kvector = ip_w+1
ip_TMR = ip_kvector+3
ip_TMI = ip_TMR+3
nData = ip_TMI+3-1
call mma_allocate(Storage,nData,2*nQuad,nIJ,nVec,label='Storage')
Storage(:,:,:,:) = Zero
#endif
!MGD group transitions
TMOgroup = .false.
ngroup1 = IEND
ngroup2 = JEND-JSTART+1
nmax2 = 1
if (REDUCELOOP .and. (TMGr_thrs >= Zero)) then
  TMOgroup = .true.
  THRS = TMGr_thrs
  i = IEND
  RefEne = 0
  TAU = -1
  ngroup2 = 1
  do j=JSTART,JEND
    if (ENSOR(J)-Refene > TAU) then
      NGROUP2 = NGROUP2+1
      Refene = ENSOR(J)
      ediff = Refene-ENSOR(I)
      TAU = ediff*THRS
    end if
  end do
  call mma_Allocate(TMOgrp2,NGROUP2,Label='TMOgrp2')
  ngroup2 = 0
  TAU = -1
  RefEne = 0
  do j=JSTART,JEND
    if (ENSOR(J)-Refene > TAU) then
      NGROUP2 = NGROUP2+1
      TMOgrp2(NGROUP2) = J
      Refene = ENSOR(J)
      ediff = Refene-ENSOR(I)
      TAU = ediff*THRS
    end if
  end do
  TMOgrp2(ngroup2+1) = NSS+1

  j = JSTART
  Refene = ENSOR(j)
  TAU = -1
  ngroup1 = 1
  do i=IEND,1,-1
    if (Refene-ENSOR(i) > TAU) then
      ngroup1 = ngroup1+1
      Refene = ENSOR(i)
      ediff = ENSOR(j)-Refene
      Tau = ediff*THRS
    end if
  end do
  call mma_Allocate(TMOgrp1,NGROUP1,Label='TMOgrp1')
  Ntmp = Ngroup1
  Ngroup1 = Ngroup1-1
  Refene = ENSOR(j)
  TAU = -1
  do i=IEND,1,-1
    if (Refene-ENSOR(i) > TAU) then
      TMOgrp1(ntmp) = i+1
      ntmp = ntmp-1
      Refene = ENSOR(i)
      ediff = ENSOR(j)-Refene
      Tau = ediff*THRS
    end if
  end do
  TMOgrp1(1) = 1
  maxgrp1 = maxval(TMOgrp1(2:ngroup1+1)-TMOgrp1(1:ngroup1))
  maxgrp2 = maxval(TMOgrp2(2:ngroup2+1)-TMOgrp2(1:ngroup2))
  nmax2 = maxgrp1*maxgrp2
end if

! Array for printing contributions from different directions

call mma_allocate(RAW,2*NQUAD*6*nmax2,Label='RAW')
LRAW = 1
call mma_allocate(OSCSTR,2,nmax2,Label='OSCSTR')
call mma_allocate(Aux,8,nmax2,Label='Aux')

do iVec=1,nVec

  if (Do_SK) then
    Rquad(1:3,1) = k_Vector(:,iVec)
    Rquad(4,1) = One   ! Dummy weight
  end if

  iPrint = 0
  IJSO = 0

  ThrSparse = 1.0e-12_wp

  call mma_allocate(iMask,NState,LABEL='iMask')
  call mma_allocate(jMask,NState,LABEL='jMask')
  call mma_allocate(iSSMask,NSS,LABEL='iSSMask')
  call mma_allocate(jSSMask,NSS,LABEL='jSSMask')

  call mma_allocate(ISS_INDEX,NState+1,LABEL='ISS_INDEX')
  ISS_INDEX(1) = 0
  do iState=1,NState
    Job = JBNUM(iState)
    ISS_INDEX(iState+1) = ISS_INDEX(IState)+MLTPLT(Job)
  end do

  do igrp=1,ngroup1

    if (TMOgroup) then
      istart_ = TMOgrp1(igrp)
      iend_ = TMOgrp1(igrp+1)-1
      ENSOR1 = Half*(ENSOR(istart_)+ENSOR(iend_))
    else
      istart_ = igrp
      iend_ = igrp
      ENSOR1 = ENSOR(istart_)
    end if
    ! Screening
    iMask(:) = 0
    iSSMask(:) = 0
    ISM = 0
    ISSM = 0
    ISFLoop: do ISF=1,NState
      do ISS=ISS_INDEX(ISF)+1,ISS_INDEX(ISF+1)
        do ISO=istart_,iend_
          Temp = VSOR(ISS,ISO)**2+VSOI(ISS,ISO)**2
          if (Temp > ThrSparse) then
            ISM = ISM+1
            iMask(ISM) = ISF
            iSSMask(ISSM+1:ISSM+ISS_INDEX(ISF+1)-ISS_INDEX(ISF)) = [(IMSS,IMSS=ISS_INDEX(ISF)+1,ISS_INDEX(ISF+1))]
            ISSM = ISSM+ISS_INDEX(ISF+1)-ISS_INDEX(ISF)
            cycle ISFLoop
          end if
        end do
      end do
    end do ISFLoop

    do jgrp=1,ngroup2

      if (TMOgroup) then
        jstart_ = TMOgrp2(jgrp)
        jend_ = TMOgrp2(jgrp+1)-1
        ENSOR2 = Half*(ENSOR(jstart_)+ENSOR(jend_))
      else
        jstart_ = jgrp+jstart-1
        jend_ = jgrp+jstart-1
        ENSOR2 = ENSOR(jstart_)
      end if
      EDIFF_ = ENSOR2-ENSOR1
      ! Screening
      jMask(:) = 0
      jSSMask(:) = 0
      JSM = 0
      JSSM = 0
      JSFLoop: do JSF=1,NState
        do JSS=ISS_INDEX(JSF)+1,ISS_INDEX(JSF+1)
          do JSO=jstart_,jend_
            Temp = VSOR(JSS,JSO)**2+VSOI(JSS,JSO)**2
            if (Temp > ThrSparse) then
              JSM = JSM+1
              jMask(JSM) = JSF
              jSSMask(JSSM+1:JSSM+ISS_INDEX(JSF+1)-ISS_INDEX(JSF)) = [(JMSS,JMSS=ISS_INDEX(JSF)+1,ISS_INDEX(JSF+1))]
              JSSM = JSSM+ISS_INDEX(JSF+1)-ISS_INDEX(JSF)
              cycle JSFLoop
            end if
          end do
        end do
      end do JSFLoop

      IJSS(1) = istart_
      IJSS(2) = iend_
      IJSS(3) = jstart_
      IJSS(4) = jend_

      write(STLNE2,'(A33,I5,A5,I5)') 'Trans. intensities for SO groups ',igrp,' and ',jgrp
      call StatusLine('RASSI: ',STLNE2)

      if (abs(EDIFF_) <= 1.0e-8_wp) cycle
      if (EDIFF_ < Zero) cycle
      IJSO = IJSO+1

      ! The energy difference is used to define the norm of the
      ! wave vector.

      rkNorm = abs(EDIFF_)/c_in_au

      ! For the case the energy difference is negative we
      ! need to change the sign of the B.s term to get
      ! consistency.

      cst = sign(Half,EDIFF_)*gElectron

      ! Iterate over the quadrature points.

      ! Initialize output arrays

      OscStr(:,:) = Zero
      RAW(:) = Zero
      Aux(:,:) = Zero

      do iQuad=1,nQuad
        iVec_ = (iVec-1)*nQuad+iQuad

        ! Generate the wavevector associated with this quadrature
        ! point and pick up the associated quadrature weight.

        UK(:) = Rquad(1:3,iQuad)
        wavevector(:) = rkNorm*UK(:)

        ! Note that the weights are normalized to integrate to
        ! 4*pi over the solid angles.

        Weight = Rquad(4,iQuad)
        if (.not. Do_SK) Weight = Weight/(Four*Pi)

        ! Generate the polarization vector

        if (Do_Pol) then
          pol_Vector(:,iVec_) = e_Vector-DDot_(3,UK,1,e_Vector,1)*UK
          rNorm = DDot_(3,pol_Vector(:,iVec_),1,pol_Vector(:,iVec_),1)
          if (rNorm > 1.0e-12_wp) then
            pol_Vector(:,iVec_) = pol_Vector(:,iVec_)/sqrt(rNorm)
          else
            pol_Vector(:,iVec_) = Zero
          end if
        end if

        ! Generate the property integrals associated with this
        ! direction of the wave vector k.

        iOpt = 2
        call TMOMInt(wavevector,iOpt)

        !***************************************************************
        !                                                              *
        !      Recompute the needed properties for all the spin-free   *
        !      states.                                                 *
        !                                                              *
        !***************************************************************

        do IPRP=1,14
          PROP(:,:,IPRTMOM(IPRP)) = Zero
        end do

        do ISS=1,ISM

          ! Does this spin-free state contribute to any of the
          ! two spin states? Check the corresponding coefficients.

          i = iMask(ISS)
          do JSS=1,JSM
            j = jMask(JSS)

            ! COMBINED SYMMETRY OF STATES:
            JOB1 = JBNUM(I)
            JOB2 = JBNUM(J)
            LSYM1 = IRREP(JOB1)
            LSYM2 = IRREP(JOB2)
            ISY12 = MUL(LSYM1,LSYM2)
            ! THE SYMMETRY CHECK MASK:
            MASK = 2**(ISY12-1)
            ! FIRST SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS OF
            ! TDMSCR
            call mk_IOFF(IOFF,nIrrep,NBASF,ISY12)

            ! Pick up the transition density between the two
            ! states from disc. Generated in GTDMCTL.

            IDISK = iDisk_TDM(I,J,1)
            iEmpty = iDisk_TDM(I,J,2)
            iOpt = 2
            iGO = ibset(ibset(0,0),2)
            call dens2file(TDMZZ,Dummy,WDMZZ,nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,I,J)
            call MK_TWDM(nIrrep,TDMZZ,WDMZZ,nTDMZZ,SCR,nSCR,IOFF,NBASF,ISY12)

            ! Compute the transition property of the property
            ! integrals between the two states.

            do IPRP=1,14
              IPROP = IPRTMOM(IPRP)
              ITYPE = 0
              if (PTYPE(IPROP) == 'HERMSING') ITYPE = 1
              if (PTYPE(IPROP) == 'ANTISING') ITYPE = 2
              if (PTYPE(IPROP) == 'HERMTRIP') ITYPE = 3
              if (PTYPE(IPROP) == 'ANTITRIP') ITYPE = 4
              LABEL = PNAME(IPROP)
              call MK_PROP(PROP,IPROP,I,J,LABEL,ITYPE,IP,NIP,SCR,nSCR,MASK,ISY12,IOFF)
            end do

          end do ! J
        end do ! I

        ! DXR & DXI hold the component that does not change from k to -k
        ! DXRM & DXIM hold the component that changes sign

        DXR(:,:,:) = Zero
        DXI(:,:,:) = Zero
        DXRM(:,:,:) = Zero
        DXIM(:,:,:) = Zero
        do iCar=1,3

          ! (1) the spin-free part.
          !     Note that the integrals are not computed for the
          !     momentum operator but rather for nabla. That is
          !     as we assemble to transition momentum we have to
          !     remember to put in a factor of -i.

          ! The real part (symmetric and anti-symmetric) becomes imaginary

          call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(0+iCar),0,ISS_INDEX,iMask,ISM,jMask,JSM)
          DXI(:,:,iCar) = DXI(:,:,iCar)-TMP(:,:)
          call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(6+iCar),0,ISS_INDEX,iMask,ISM,jMask,JSM)
          DXI(:,:,iCar) = DXI(:,:,iCar)-TMP(:,:)

          ! The imaginary part (symmetric and anti-symmetric) becomes real

          call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(3+iCar),0,ISS_INDEX,iMask,ISM,jMask,JSM)
          DXRM(:,:,iCar) = DXRM(:,:,iCar)+TMP(:,:)
          call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(9+iCar),0,ISS_INDEX,iMask,ISM,jMask,JSM)
          DXRM(:,:,iCar) = DXRM(:,:,iCar)+TMP(:,:)

          ! (2) the spin-dependent part, magnetic

          !     iCar=1: 1/2(S(+)+S(-))
          !     iCar=2: 1/2i(S(+)-S(-))
          !     iCar=3: Sz

          !     Here we need to be very careful. The operator is
          !     similar to the L.S operator, the spin-orbit coupling.
          !     However, here we have that the operator is B.S. Thus
          !     we can do this in a similar fashion as the spin-orbit
          !     coupling, but with some important difference.

          !     For the spin-orbit coupling the L operator is divided
          !     into x-, y-, and z-components, that is the operator
          !     will be represented by three different integrals.
          !     For the integrals over B it is similar but the x-, y-,
          !     and z-components are constants outside of the integral.
          !     For example, the x-component is expressed as
          !     (k x e_l)_x <0|e^(i k.r)|n>. In this section we will
          !     handle the (k x e_l)_x part outside the loop over the
          !     Cartesian components.

          !     We have to note one further difference, the integrals
          !     are complex in this case.

          !     Let us now compute the contributions T(i), i=x,y,z

          !     In the equations we find that the y-component is imaginary,
          !     see the equations on page 234 in Per Ake's paper. Hence,
          !     the y-component is treated slightly differently.

          !     Actually, here we compute (<0|e^(i k.r)|n> x k), which
          !     will be later dotted with e_l.

          !     i*g/2*(s_y*k_z-s_z*k_y) -> T_x
          !     i*g/2*(s_z*k_x-s_x*k_z) -> T_y
          !     i*g/2*(s_x*k_y-s_y*k_x) -> T_z

          !     Note also that the "I" parts should change sign with kPhase,
          !     but so does wavevector, so the net result is the opposite.

          if (iCar == 1) then
            call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(13),iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
            DXIM(:,:,3) = DXIM(:,:,3)+wavevector(2)*cst*TMP(:,:)
            DXIM(:,:,2) = DXIM(:,:,2)-wavevector(3)*cst*TMP(:,:)
            call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(14),iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
            DXR(:,:,3) = DXR(:,:,3)-wavevector(2)*cst*TMP(:,:)
            DXR(:,:,2) = DXR(:,:,2)+wavevector(3)*cst*TMP(:,:)
          else if (iCar == 2) then
            ! For the y-component we have to interchange the real and
            ! the imaginary components. The real component gets a
            ! minus sign due to the product i*i=-1
            call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(14),iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
            DXI(:,:,1) = DXI(:,:,1)-wavevector(3)*cst*TMP(:,:)
            DXI(:,:,3) = DXI(:,:,3)+wavevector(1)*cst*TMP(:,:)
            call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(13),iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
            DXRM(:,:,1) = DXRM(:,:,1)-wavevector(3)*cst*TMP(:,:)
            DXRM(:,:,3) = DXRM(:,:,3)+wavevector(1)*cst*TMP(:,:)
          else if (iCar == 3) then
            call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(13),iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
            DXIM(:,:,2) = DXIM(:,:,2)+wavevector(1)*cst*TMP(:,:)
            DXIM(:,:,1) = DXIM(:,:,1)-wavevector(2)*cst*TMP(:,:)
            call SMMAT_MASKED(PROP,TMP,NSS,IPRTMOM(14),iCar,ISS_INDEX,iMask,ISM,jMask,JSM)
            DXR(:,:,2) = DXR(:,:,2)-wavevector(1)*cst*TMP(:,:)
            DXR(:,:,1) = DXR(:,:,1)+wavevector(2)*cst*TMP(:,:)
          end if
        end do

        ! Now we can compute the transition moments for k and -k

        do kp=1,2

          if (abs(kPhase(kp)) < Half) cycle
          TMR(:,:,:) = DXR(:,:,:)+kPhase(kp)*DXRM(:,:,:)
          TMI(:,:,:) = DXI(:,:,:)+kPhase(kp)*DXIM(:,:,:)
          do iCar=1,3
            call ZTRNSF_MASKED(NSS,VSOR,VSOI,TMR(:,:,iCar),TMI(:,:,iCar),IJSS,iSSMask,ISSM,jSSMask,JSSM)
          end do

          IJ_ = 0
          do ISO=istart_,iend_
            do JSO=jstart_,jend_
              IJ_ = IJ_+1
              EDIFF = ENSOR(JSO)-ENSOR(ISO)

              ! Store the vectors for this direction

              TM_R(:) = TMR(ISO,JSO,:)
              TM_I(:) = TMI(ISO,JSO,:)
#             ifdef _HDF5_
              ! Get proper triangular index
              IJSO_ = nTri_Elem(JSO-2)+ISO
              iQuad_ = 2*(iQuad-1)+kp
              Storage(ip_w,iQuad_,IJSO_,iVec) = Weight
              Storage(ip_kvector:ip_kvector+2,iQuad_,IJSO_,iVec) = kPhase(kp)*Wavevector(:)
              Storage(ip_TMR:ip_TMR+2,iQuad_,IJSO_,iVec) = TM_R(:)
              Storage(ip_TMI:ip_TMI+2,iQuad_,IJSO_,iVec) = TM_I(:)
#             endif

              ! Project out the k direction from the real and imaginary components

              TM_R(:) = TM_R(:)-DDot_(3,TM_R,1,UK,1)*UK(:)
              TM_I(:) = TM_I(:)-DDot_(3,TM_I,1,UK,1)*UK(:)

              ! Implicitly integrate over all directions of the
              ! polarization vector to get the average value.

              TM1 = DDot_(3,TM_R,1,TM_R,1)
              TM2 = DDot_(3,TM_I,1,TM_I,1)
              TM_2 = Half*(TM1+TM2)

              ! Compute maximum and minimum oscillator strengths
              ! and the corresponding polarization vectors

              if (Do_SK) then
                TM3 = DDot_(3,TM_R,1,TM_I,1)
                Rng = sqrt((TM1-TM2)**2+Four*TM3**2)
                Aux(1,ij_) = TM_2+Half*Rng
                Aux(5,ij_) = TM_2-Half*Rng
                ! The direction for the maximum
                Ang = Half*atan2(Two*TM3,TM1-TM2)
                Aux(2:4,ij_) = Aux(2:4,ij_)+cos(Ang)*TM_R(:)+sin(Ang)*TM_I(:)
                ! Normalize and compute the direction for the minimum
                ! as a cross product with k
                rNorm = DDot_(3,Aux(2,ij_),1,Aux(2,ij_),1)
                if (rNorm > 1.0e-12_wp) then
                  Aux(2:4,ij_) = Aux(2:4,ij_)/sqrt(rNorm)
                  Aux(6,ij_) = Aux(3,ij_)*UK(3)-Aux(4,ij_)*UK(2)
                  Aux(7,ij_) = Aux(4,ij_)*UK(1)-Aux(2,ij_)*UK(3)
                  Aux(8,ij_) = Aux(2,ij_)*UK(2)-Aux(3,ij_)*UK(1)
                  rNorm = DDot_(3,Aux(6,ij_),1,Aux(6,ij_),1)
                  Aux(6:8,ij_) = Aux(6:8,ij_)/sqrt(rNorm)
                else
                  Aux(2:4,ij_) = Zero
                  Aux(6:8,ij_) = Zero
                end if
              end if

              ! Oscillator strength for a specific polarization vector

              if (Do_Pol) then
                TM1 = DDot_(3,TM_R,1,pol_Vector(1,iVec_),1)
                TM2 = DDot_(3,TM_I,1,pol_Vector(1,iVec_),1)
                TM_2 = TM1*TM1+TM2*TM2
              end if

              ! Compute the oscillator strength

              F_Temp = Two*TM_2/EDIFF
              if (Do_SK) then
                Aux(1,ij_) = Two*Aux(1,ij_)/EDIFF
                Aux(5,ij_) = Two*Aux(5,ij_)/EDIFF
              end if

              ! Compute the rotatory strength, note that it depends on kPhase

              TM_C(1) = TM_R(2)*TM_I(3)-TM_R(3)*TM_I(2)
              TM_C(2) = TM_R(3)*TM_I(1)-TM_R(1)*TM_I(3)
              TM_C(3) = TM_R(1)*TM_I(2)-TM_R(2)*TM_I(1)
              TM_2 = Two*kPhase(kp)*DDot_(3,TM_C,1,UK,1)
              R_Temp = 0.75_wp*c_in_au/EDIFF**2*TM_2
              R_Temp = R_Temp*AU2REDR

              ! Save the raw oscillator and rotatory strengths in a given direction

              NQUAD_ = 2*NQUAD
              LRAW_ = LRAW+6*NQUAD_*(ij_-1)
              IQUAD_ = 2*(IQUAD-1)+(kp-1)
              RAW(LRAW_+IQUAD_+0*NQUAD_) = F_Temp
              RAW(LRAW_+IQUAD_+1*NQUAD_) = R_Temp

              ! Save the direction and weight too

              RAW(LRAW_+IQUAD_+2*NQUAD_) = UK(1)*kPhase(kp)
              RAW(LRAW_+IQUAD_+3*NQUAD_) = UK(2)*kPhase(kp)
              RAW(LRAW_+IQUAD_+4*NQUAD_) = UK(3)*kPhase(kp)
              RAW(LRAW_+IQUAD_+5*NQUAD_) = Weight

              ! Do not accumulate if not doing an isotropic integration

              if (Do_SK .and. (kp > 1)) cycle

              ! Accumulate to the isotropic oscillator strength

              OscStr(1,IJ_) = OscStr(1,IJ_)+Weight*F_Temp

              ! Accumulate to the isotropic rotatory strength

              OscStr(2,IJ_) = OscStr(2,IJ_)+Weight*R_Temp
            end do
          end do

        end do ! kp

      end do ! iQuad

      IJ_ = 0
      do ISO=istart_,iend_
        do JSO=jstart_,jend_
          IJ_ = IJ_+1
          EDIFF = ENSOR(JSO)-ENSOR(ISO)
          F = OscStr(1,IJ_)
          R = OscStr(2,IJ_)

          call Add_Info('ITMS(SO)',[F],1,6)
          call Add_Info('ROTS(SO)',[R],1,4)

          if (Do_Pol) then
            F_CHECK = abs(Aux(1,ij_))
            R_CHECK = Zero ! dummy assign
          else
            F_CHECK = abs(F)
            R_CHECK = abs(R)
          end if
          if ((F_CHECK < OSTHR) .and. (R_CHECK < RSTHR)) cycle
          A = (AFACTOR*EDIFF**2)*F

          if (iPrint == 0) then
            write(u6,*)
            if (Do_SK) then
              call CollapseOutput(1,'Transition moment strengths (SO states):')
              write(u6,'(3X,A)') '----------------------------------------'
              if (Do_Pol) then
                iVec_ = (iVec-1)*nQuad+1
                write(u6,'(4x,a,3F10.6)') 'Direction of the polarization: ',(pol_vector(k,iVec),k=1,3)
              else
                write(u6,'(4x,a)') 'The oscillator strength is integrated over all directions of the polarization vector'
              end if
              write(u6,'(4x,a,3F10.6)') 'Direction of the k-vector: ',Rquad(1:3,1)
            else
              call CollapseOutput(1,'Isotropic transition moment strengths (SO states):')
              write(u6,'(3X,A)') '--------------------------------------------------'
            end if
            if (OSTHR > Zero) write(u6,45) 'For osc. strength at least',OSTHR,'and red. rot. strength  at least',RSTHR
            write(u6,*)
            if (.not. Do_SK) then
              write(u6,'(4x,a,I4,a)') 'Integrated over ',2*nQuad,' directions of the wave vector'
              write(u6,'(4x,a)') 'The oscillator strength is integrated over all directions of the polarization vector'
              write(u6,*)
            end if
            write(u6,31) 'From','To','Osc. strength','Red. rot. str.','Total A (sec-1)'
            write(u6,32)
            iPrint = 1
          end if

          ! Regular print

          ! Don't print osc. str. if below threshold
          if (F_CHECK < OSTHR) then
            write(u6,46) ISO,JSO,'below threshold',R,A
            ! Don't print rot. str. if below threshold
          else if (R_CHECK < RSTHR) then
            write(u6,47) ISO,JSO,F,'below threshold',A
          else
            write(u6,33) ISO,JSO,F,R,A
          end if

          if (Do_SK) then
            write(u6,50) 'maximum',Aux(1,ij_),'for polarization direction:',Aux(2,ij_),Aux(3,ij_),Aux(4,ij_)
            write(u6,50) 'minimum',Aux(5,ij_),'for polarization direction:',Aux(6,ij_),Aux(7,ij_),Aux(8,ij_)
          end if

          ! Printing raw (unweighted) and direction for every transition

          if (PRRAW) then
            write(u6,*)
            write(u6,*)
            write(u6,34) 'From','To','Raw osc. str.','Red. rot. str.','kx','ky','kz'
            write(u6,35)
            NQUAD_ = 2*NQUAD
            LRAW_ = LRAW+6*NQUAD_*(ij_-1)
            do IQUAD=1,NQUAD
              do kp=1,2
                if (abs(kPhase(kp)) < Half) cycle
                IQUAD_ = 2*(IQUAD-1)+(kp-1)
                write(u6,33) ISO,JSO,RAW(LRAW_+IQUAD_+0*NQUAD_),RAW(LRAW_+IQUAD_+1*NQUAD_),RAW(LRAW_+IQUAD_+2*NQUAD_), &
                             RAW(LRAW_+IQUAD_+3*NQUAD_),RAW(LRAW_+IQUAD_+4*NQUAD_)
              end do
            end do
            write(u6,35)
            write(u6,*)
          end if

          ! Printing weighted and direction for every transition

          if (PRWEIGHT) then
            write(u6,*)
            write(u6,*)
            write(u6,34) 'From','To','Weig. osc. str.','Red. rot. str.','kx','ky','kz'
            write(u6,35)
            NQUAD_ = 2*NQUAD
            LRAW_ = LRAW+6*NQUAD_*(ij_-1)
            do IQUAD=1,NQUAD
              do kp=1,2
                if (abs(kPhase(kp)) < Half) cycle
                IQUAD_ = 2*(IQUAD-1)+(kp-1)
                Weight = RAW(LRAW_+IQUAD_+5*NQUAD_)
                write(u6,33) ISO,JSO,RAW(LRAW_+IQUAD_+0*NQUAD_)*Weight,RAW(LRAW_+IQUAD_+1*NQUAD_)*Weight, &
                             RAW(LRAW_+IQUAD_+2*NQUAD_),RAW(LRAW_+IQUAD_+3*NQUAD_),RAW(LRAW_+IQUAD_+4*NQUAD_)
              end do
            end do
            write(u6,35)
            write(u6,*)
          end if

        end do
      end do

    end do
  end do
  call mma_deallocate(iMask)
  call mma_deallocate(jMask)
  call mma_deallocate(iSSMask)
  call mma_deallocate(jSSMask)
  call mma_deallocate(ISS_INDEX)

  if (iPrint == 1) then
    write(u6,32)
    if (Do_SK) then
      call CollapseOutput(0,'Transition moment strengths (SO states):')
    else
      call CollapseOutput(0,'Isotropic transition moment strengths (SO states):')
    end if
  end if

end do ! iVec
#ifdef _TIME_TMOM_
call CWTime(TCpu2,TWall2)
write(u6,*) 'Time for TMOM : ',TCpu2-TCpu1,TWall2-TWall1
#endif

#ifdef _HDF5_
call mh5_put_dset(wfn_sos_tm,pack(Storage,.true.))
call mma_deallocate(Storage)
#endif

! Do some cleanup

call mma_deallocate(RAW)
call mma_deallocate(IP)
call mma_deallocate(DXR)
call mma_deallocate(DXI)
call mma_deallocate(DXRM)
call mma_deallocate(DXIM)
call mma_deallocate(TMP)
if (TMOgroup) then
  call mma_DeAllocate(TMOgrp1)
  call mma_DeAllocate(TMOgrp2)
end if
if (Do_Pol) call mma_deallocate(pol_Vector)
call mma_deallocate(TMR)
call mma_deallocate(TMI)
call mma_deallocate(OSCSTR)
call mma_deallocate(Aux)

call mma_deallocate(SCR)
call mma_deAllocate(TDMZZ)
call mma_deAllocate(WDMZZ)
call mma_deAllocate(Rquad)
call ClsSew()

call mma_deallocate(VSOR)
call mma_deallocate(VSOI)

30 format(5X,A,1X,ES15.8)
31 format(5X,2(1X,A4),4X,3(1X,A15))
32 format(5X,63('-'))
33 format(5X,2(1X,I4),5X,5(1X,ES15.8))
34 format(5X,2(1X,A4),5X,5(1X,A15))
35 format(5X,95('-'))
45 format(4X,2(A,1X,ES15.8,1X))
46 format(5X,2(1X,I4),5X,(1X,A15),2(1X,ES15.8))
47 format(5X,2(1X,I4),5X,(1X,ES15.8),(1X,A15),(1X,ES15.8))
49 format(5X,A,1X,ES15.8,1X,A)
50 format(10X,A7,3X,1(1X,ES15.8),5X,A27,3(1X,F7.4))

!***********************************************************************
!                                                                      *
!     End of section for transition moments                            *
!                                                                      *
!***********************************************************************

#ifdef _TIME_TMOM_
call CWTime(TCpu2,TWall2)
write(u6,*) 'Time for TMOM(SO) : ',TCpu2-TCpu1,TWall2-TWall1
#endif

end subroutine PRPROP_TM_Exact

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Step3(iCenter,SMatrix,nDim,TMatrix,iType)
! Step 3. GS S2 ->S3

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, iCenter(nDim), iType(nDim)
real(kind=wp), intent(inout) :: SMatrix(nDim,nDim)
real(kind=wp), intent(out) :: TMatrix(nDim,nDim)

!lg write(u6,*) 'Step 3', nDim
!lg call RecPrt('T before GS 3',' ',TMatrix,nDim,nDim)
!lg write(u6,*)
TMatrix(:,:) = Zero
call dcopy_(nDim,[One],0,TMatrix,nDim+1)
call GramSchmidt(SMatrix,TMatrix,nDim,iType,iCenter,1)

return

end subroutine Step3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine OpnFls_MCLR(iPL)
************************************************************************
*                                                                      *
*     Open files.                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "Files_mclr.fh"

#include "Input.fh"
      Character*8 Label
      Logical FoundTwoEls,DoCholesky
*---------------------------------------------------------------------*
*     Start                                                           *
*---------------------------------------------------------------------*
*---  open the JOBIPH file -------------------------------------------*
*     Call DaName(LuJob,FnJob)
      Call DaName(LuTemp,FnTemp)
*---  open the ORDINT file -------------------------------------------*
      Call f_Inquire(FnTwo,FoundTwoEls)
      Call DecideOnDirect(.True.,FoundTwoEls,Direct,DoCholesky)
      If (Direct) Then
         Write (6,*) 'OpnFls: No direct option in MCLR'
         Call Abend()
      Else
         If (.NOT.DoCholesky) Then
            If (iPL.ge.2) Write(6,*) 'Ordinary integral handling'
            iRc=-1
            iOpt=0
            Call OpnOrd(iRc,iOpt,FnTwo,LuTwo)
            If ( iRc.ne.0 ) Then
               Write (6,*) 'OpnFls: Error opening ORDINT'
               Call Abend()
            End If
         End If
      End If
      iRc=-1
      iOpt=0
      Call f_Inquire(FnMCK,McKinley)
      Call f_Inquire(FnPT2,PT2)
      If (McKinley) Then
*        Write(*,*) 'Calculating response on perturbation from mckinley'
         Call OpnMck(iRc,iOpt,FnMck,LuMck)
         If ( iRc.ne.0 ) Then
            Write (6,*) 'OpnFls: Error opening MCKINT'
            Call Abend()
         End If
         iRc=-1
         idum=0
         iOpt=0
         Label='SYMOP'
         call cRdMck(irc,iopt,Label,idum,chirr(1),idum)
         If ( iRc.ne.0 ) Then
            Write (6,*) 'OpnFls: Error reading MCKINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend()
         End If
*
      Else If (PT2) Then
       If (iPL.ge.2)
     &     Write(6,*) 'Calculating lagrange multipliers for CASPT2'
       Call DaName(LuPT2,FnPT2)
      Else
       If (iPL.ge.2) Then
       Write(6,*)'No ',FnPT2,' or ' ,FNMCK, ', I hope that is OK'
       Write(6,*)'Seward mode is assumed, reading perturbation from ',
     &           FnOne
       End If
      End If
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine crprod(a,b,c)

! calculates cross product:   a x b = c

use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: a(3), b(3)
real(kind=wp), intent(out) :: c(3)

c(1) = a(2)*b(3)-a(3)*b(2)
c(2) = a(3)*b(1)-a(1)*b(3)
c(3) = a(1)*b(2)-a(2)*b(1)

return

end subroutine crprod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Roland Lindh                                     *
************************************************************************
      Subroutine set_l_Array(Array_l,nInter,BaseLine,Hessian)
      Implicit Real*8 (a-h,o-z)
      Real*8 Array_l(nInter), Hessian(nInter,nInter)
      Real*8 H_min
*     Real*8 l_max
*
*     Call RecPrt('set_l_Array: Hessian',' ',Hessian,nInter,nInter)
*     Write (6,*) 'BaseLine=',BaseLine
*
*     Gives a Kriging Hessian for a single point of Kriging with
*     a diagonal which is identical to the diagonal values of
*     the HMF ad hoc Hessian.
*
*     l_max=80.0D0
*     l_max=100.0D0
      H_min=0.025D0
      Do i = 1, nInter
*
*        Make sure that the characteristic length is not too long.
*
         Hss=Max(Abs(Hessian(i,i)),H_min)
         Hessian(i,i)=Hss
         Array_l(i)=Sqrt((5.0D0*BaseLine)/(3.0D0*Hss))
*        Hss=Abs(Hessian(i,i))
*        Array_l(i)=Min(l_max,Sqrt((5.0D0*BaseLine)/(3.0D0*Hss)))
*
      End Do
*     Call RecPrt('Array_l',' ',Array_l,1,nInter)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine W2SGORD(SGS,CIS,MWS2W,NLIST,KWALK,ICNUM)
! Purpose: Given a list of bit-packed total walks,
! translate this into a list of elements of a CI array.
! MXCPI= Max nr of case numbers packed in one integer.
!
! For a wave function in Split GUGA storage structure,
! given KWALK(J,I) with J=1..MIPWLK that contains the
! complete Guga walk, as a packed array of case numbers, construct
! ICNUM(I), which is the index of this configuration in the
! Split-Guga scheme.
! Use MAWS to WLK table, MWS2W

use sguga, only: CIStruct, SGStruct
use Symmetry_Info, only: MUL
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(in) :: CIS
integer(kind=iwp), intent(in) :: MWS2W(*), NLIST, KWALK(*)
integer(kind=iwp), intent(out) :: ICNUM(NLIST)
integer(kind=iwp) :: IC, ICONF, IDV, IDW, IOFF, ISYCI, ISYDWN, ISYUP, IUV, IUW, LDIM, LEV, MAWSD, MAWSU, MIPWLK, MV
integer(kind=iwp), allocatable :: ICS(:)
integer(kind=iwp), parameter :: MXCPI = 15

! Nr of integers used to store each total walk:
MIPWLK = 1+(SGS%nLev-1)/MXCPI
! Allocate scratch space for case numbers:
call mma_allocate(ICS,SGS%nLev,Label='ICS')

do ICONF=1,NLIST
  ! Unpack total walk to ICS()
  call UPKWLK(SGS%nLev,MIPWLK,1,KWALK((ICONF-1)*MIPWLK+1),ICS)

  ! Follow upper walk down to SGS%MidLev:
  MAWSU = 0
  IUV = 1
  ISYUP = 1
  IDV = -1000000000
  do LEV=SGS%nLev,SGS%MidLev+1,-1
    IC = ICS(LEV)
    if (((IC+1)/2) == 1) ISYUP = MUL(SGS%ISM(LEV),ISYUP)
    IDV = SGS%DOWN(IUV,IC)
    MAWSU = MAWSU+SGS%MAW(IUV,IC)
    IUV = IDV
  end do
  ! We have found the midvertex number:
  MV = IDV+1-SGS%MVSta
  ! Follow lower walk down to SGS%MidLev:
  ISYDWN = 1
  MAWSD = 0
  do LEV=SGS%MidLev,1,-1
    IC = ICS(LEV)
    if (((IC+1)/2) == 1) ISYDWN = MUL(SGS%ISM(LEV),ISYDWN)
    IDV = SGS%DOWN(IUV,IC)
    MAWSD = MAWSD+SGS%MAW(IUV,IC)
    IUV = IDV
  end do
  IUW = MWS2W(MAWSU)
  IDW = MWS2W(MAWSD)
  ! Subtract the offsets:
  IUW = IUW-CIS%IOW(1,ISYUP,MV)/CIS%nIpWlk
  IDW = IDW-CIS%IOW(2,ISYDWN,MV)/CIS%nIpWlk
  ! Split-Guga storage scheme: an element in a set of matrices.
  ! Offset to the matrix we want is CIS%IOCSF(ISYUP,MV,ISYCI).
  ! Leading dimension=nr of upwalks in this block.
  ISYCI = MUL(ISYUP,ISYDWN)
  IOFF = CIS%IOCSF(ISYUP,MV,ISYCI)
  LDIM = CIS%NOW(1,ISYUP,MV)
  ICNUM(ICONF) = IOFF+IUW+LDIM*(IDW-1)
end do

call mma_deallocate(ICS)

end subroutine W2SGORD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SQUARE(A,B,ICB,IRB,NROW)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: A(*)
real(kind=wp), intent(_OUT_) :: B(*)
integer(kind=iwp), intent(in) :: ICB, IRB, NROW
integer(kind=iwp) :: IC, ICOL, II, IND, IR, IROW

! PAM Sep 06: The two special cases here account for
! almost all calls of this code, and written such as
! not to store with non-zero stride--at least some
! rudimentary consideration for cache.
if (ICB == 1) then

  do IC=0,NROW-1
    II = nTri_Elem(IC)
    B(IC*IRB+1:IC*(IRB+1)+1) = A(II+1:II+IC+1)
  end do
  do IC=0,NROW-2
    do IR=IC+1,NROW-1
      B(1+IR+IC*IRB) = B(1+IC+IR*IRB)
    end do
  end do

else if (IRB == 1) then

  do IC=0,NROW-1
    II = nTri_Elem(IC)
    B(IC*ICB+1:IC*(ICB+1)+1) = A(II+1:II+IC+1)
  end do
  do IC=0,NROW-2
    do IR=IC+1,NROW-1
      B(1+IR+IC*ICB) = B(1+IC+IR*ICB)
    end do
  end do

else

  ! General and inefficient code:
  IND = 0
  do IROW=0,NROW-1
    do ICOL=0,IROW
      IND = IND+1
      B(1+IROW*ICB+ICOL*IRB) = A(IND)
      B(1+ICOL*ICB+IROW*IRB) = A(IND)
    end do
  end do

end if

return

end subroutine SQUARE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine O2N(AA,AB,BB,Temp,nA,nB,Error)

use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nA, nB
real(kind=wp), intent(in) :: AA(nA,nA), AB(nA,nB)
real(kind=wp), intent(out) :: BB(nB,nB), Temp(nA,nB), Error
real(kind=r8), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
! (1) Project the new basis on to the old space and compute the
!     matrix elements.

call DGEMM_('N','N',nA,nB,nA,One,AA,nA,AB,nA,Zero,Temp,nA)
call DGEMM_('T','N',nB,nB,nA,One,AB,nA,Temp,nA,Zero,BB,nB)
!                                                                      *
!***********************************************************************
!                                                                      *
! (2) Do diagnostics on how poorly or good the
!     new basis spans the old space

Error = DDot_(nA,AA,nA+1,AA,nA+1)-DDot_(nB,BB,nB+1,BB,nB+1)

return

end subroutine O2N

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine axexsol_cvb(ap,dum,itdav,maxdav,nfrdim1,
     >  solp,solp_res,eig,eig_res)
c  Diagonalize Hamiltonian in Davidson subspace:
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension ap(maxdav,maxdav),solp(maxdav),solp_res(maxdav)

      i1 = mstackr_cvb(itdav)
      i2 = mstackr_cvb(itdav*itdav)

      call axexsol2_cvb(ap,w(i1),w(i2),dum,itdav,maxdav,
     >  solp,solp_res,eig,eig_res)

      call mfreer_cvb(i1)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(nfrdim1)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Connect_Fragments(nAtoms,iTabBonds,nBondMax,
     &                             nBonds,Coor,iTabAtoms,nMax,iANr)
      use slapaf_parameters, only: rFuzz
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
      Real*8 Coor(3,nAtoms)
      Integer iTabAtoms(2,0:nMax,nAtoms), iANr(nAtoms),
     &        iTabBonds(3,nBondMax)
      Integer, Allocatable, Dimension(:) :: iStack
      Integer, Allocatable:: nSet(:)
      Real*8, Allocatable:: SetDist(:)
#include "bondtypes.fh"
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(nSet,nAtoms,Label='nSet')
      dR_Thr=rFuzz
      HH_Thr=5.0D0
*
      Call mma_allocate(iStack,nAtoms,label="iStack")
*
 1    Continue
      Not_Defined=-1
      nSet(:)=Not_Defined
*
      nStack=1
      iAtom = 1
      iStack(nStack)=iAtom
      iSet = 1
      nSet(iAtom)=iSet
*
#ifdef _DEBUGPRINT_
      Write (6,*) '>>>> Connect Fragments <<<<<'
      Call RecPrt('Coor',' ',Coor,3,nAtoms)
#endif
*                                                                      *
************************************************************************
*                                                                      *
 99   Continue
*
*                                                                      *
************************************************************************
*                                                                      *
*     Pick up an atom from the top of the stack.
*
      iAtom=iStack(nStack)
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'iAtom=',iAtom
      Write (6,*) 'iSet=',iSet
      Write (6,*) 'nStack=',nStack
      Write (6,*) 'nNeighbor=',iTabAtoms(1,0,iAtom)
#endif
*
*     Loop over all atoms to which this atom has a bond
*
*     Decrement the stack size one step
*
      nStack=nStack-1
      Do iNeighbor = 1, iTabAtoms(1,0,iAtom)
         jAtom=iTabAtoms(1,iNeighbor,iAtom)
         iBond=iTabAtoms(2,iNeighbor,iAtom)
#ifdef _DEBUGPRINT_
         Write (6,*) 'jAtom=',jAtom
         Write (6,*) 'iBond=',iBond
         Write (6,*) 'iTabBonds(3,iBond)=',iTabBonds(3,iBond)
         Write (6,*) 'nSet(jAtom)=',nSet(jAtom)
#endif
*        Skip if vdW bond.
         If (iTabBonds(3,iBond).eq.vdW_Bond) Go To 101
         If (nSet(jAtom).eq.Not_Defined) Then
*
*           If not defined add to the stack
            nStack = nStack + 1
            iStack(nStack)=jAtom
*           Assign which set the atom belongs to.
            nSet(jAtom)=iSet
         Else If (nSet(jAtom).ne.iSet) Then
*
*           Error if atom belongs to the wrong set.
            Call WarningMessage(2,' Error in Connect_Fragments')
            Write (6,*) 'Connect_Fragments:'
            Write (6,*) 'Inconsistent set indices!'
            Write (6,*) 'iSet,jSet=',iSet,nSet(jAtom)
            Call Abend()
         End If
 101     Continue
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     If there are more atoms in the stack process the next one.
*
      If (nStack.ne.0) Go To 99
*                                                                      *
************************************************************************
*                                                                      *
*---- If all atoms now belong to a set we are done. Otherwise
*     we have a new set.
*
*     Loop over all atoms. If an atom is found which is not assigned
*     to a set add it to the stack.
*
      Do iAtom = 1, nAtoms
         If (nSet(iAtom).eq.Not_Defined) Then
*           Add atom to the stack
            nStack=1
            iStack(nStack)=iAtom
*           Set the new set index and assign it to the atom.
            iSet = iSet + 1
            nSet(iAtom)=iSet
            Go To 99
         End If
      End Do
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Now all atoms belong to a set
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     If all atoms belong to the same set then we are done.
*
      If (iSet.eq.1) Then
         Call mma_deallocate(iStack)
         Call mma_deallocate(nSet)
         Return
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Now we have to connect the disjoint sets.
*                                                                      *
************************************************************************
*                                                                      *
*     Find the shortest distance between every two sets
*
      Call mma_allocate(SetDist,iSet*iSet,Label='SetDist')
      SetDist(:)= 1.0D6
      Do kAtom = 1, nAtoms
         kSet = nSet(kAtom)
         Do lAtom = kAtom+1, nAtoms
            lSet = nSet(lAtom)
            If (lSet.eq.kSet) Go To 501
*
*           For l < k:
*           In (k,l), the minimum distance between the sets k and l
*           In (l,k), the minimum distance excluding H-H
*
            iOff = (Min(kSet,lSet)-1)*iSet + Max(kSet,lSet)
            iOffHH = (Max(kSet,lSet)-1)*iSet + Min(kSet,lSet)
            RTest = (Coor(1,kAtom)-Coor(1,lAtom))**2
     &             +(Coor(2,kAtom)-Coor(2,lAtom))**2
     &             +(Coor(3,kAtom)-Coor(3,lAtom))**2
            If (iAnr(kAtom).ne.1 .or. iANr(lAtom).ne.1)
     &         SetDist(iOff) = Min(SetDist(iOff),RTest)
            SetDist(iOffHH) = Min(SetDist(iOffHH),RTest)
 501        Continue
         End Do
      End Do
*
*     Find the shortest distance between any two sets.
*
      rShort = 1.0D5
      Do kSet = 1, iSet
         Do lSet = kSet+1, iSet
*
*           H-H distances are only considered if the minimum distance
*           (excluding H-H) is greater than HH_Thr
            iOff = (kSet-1)*iSet + lSet
            If (SetDist(iOff).gt.HH_Thr**2)
     &         iOff = (lSet-1)*iSet + kSet-1
            If (SetDist(iOff).lt.rShort) Then
               rShort = SetDist(iOff)
            End If
         End Do
      End Do
*
*     Add bonds between sets if they are shorter than rShort+dR_Thr
*
      Do kAtom = 1, nAtoms
         kSet = nSet(kAtom)
         Do lAtom = kAtom+1, nAtoms
            lSet = nSet(lAtom)
            If (lSet.eq.kSet) Go To 502
*
*           Again, add H-H bonds only if necessary
            iOff = (Min(kSet,lSet)-1)*iSet + Max(kSet,lSet)
            If ((SetDist(iOff).le.HH_Thr**2) .and.
     &          (iANr(kAtom).eq.1 .and. iANr(lAtom).eq.1)) Go To 502
*
            RTest = (Coor(1,kAtom)-Coor(1,lAtom))**2
     &             +(Coor(2,kAtom)-Coor(2,lAtom))**2
     &             +(Coor(3,kAtom)-Coor(3,lAtom))**2
            RTest = Sqrt(RTest)
            If (RTest.le.Sqrt(rShort)+dR_Thr) Then
               Do iBond = 1, nBonds
*
*                 Look through the bond list and find if it is there.
                  If ( (iTabBonds(1,iBond).eq.kAtom .and.
     &                  iTabBonds(2,iBond).eq.lAtom ) .or.
     &                 (iTabBonds(1,iBond).eq.lAtom .and.
     &                  iTabBonds(2,iBond).eq.kAtom ) ) Then
                     iTabBonds(3,iBond) = Fragments_Bond
*
*                    If the bond is already in the list that is it.
                     Go To 503
                  End If
               End Do
*
*              Add the bond to the bond list
               If (nBonds+1.gt.nBondMax) Then
                  Call WarningMessage(2,' Error in Connect_Fragments')
                  Write (6,*) 'Connect_Fragments: nBonds+1.gt.nBondMax'
                  Call Abend()
               End If
*
               nBonds = nBonds + 1
               iTabBonds(1,nBonds) = lAtom
               iTabBonds(2,nBonds) = kAtom
               iTabBonds(3,nBonds) = Fragments_Bond
*
*              Update atoms list
*
               nNeighbor_k = iTabAtoms(1,0,kAtom)+1
               If (nNeighbor_k.gt.nMax) Then
                  Call WarningMessage(2,' Error in Connect_Fragments')
                  Write (6,*) 'Connect_Fragments: nNeighbor_k.gt.nMax'
                  Write (6,*) 'kAtom=',kAtom
                  Write (6,*) 'nNeighbor_k=',nNeighbor_k
                  Write (6,*) 'nMax=',nMax
                  Call Abend()
               End If
               iTabAtoms(1,0,kAtom) = nNeighbor_k
               iTabAtoms(1,nNeighbor_k,kAtom) = lAtom
               iTabAtoms(2,nNeighbor_k,kAtom) = nBonds
*
               nNeighbor_l = iTabAtoms(1,0,lAtom)+1
               If (nNeighbor_l.gt.nMax) Then
                  Call WarningMessage(2,' Error in Connect_Fragments')
                  Write (6,*) 'Connect_Fragments: nNeighbor_l.gt.nMax'
                  Write (6,*) 'lAtom=',lAtom
                  Write (6,*) 'nNeighbor_l=',nNeighbor_l
                  Write (6,*) 'nMax=',nMax
                  Call Abend()
               End If
               iTabAtoms(1,0,lAtom) = nNeighbor_l
               iTabAtoms(1,nNeighbor_l,lAtom) = kAtom
               iTabAtoms(2,nNeighbor_l,lAtom) = nBonds
*
 503           Continue
            End If
 502        Continue
         End Do
      End Do
      Call mma_deallocate(SetDist)
*
*     Try again!
      Go To 1
*                                                                      *
************************************************************************
*                                                                      *
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Jeppe Olsen                                      *
*               1989, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE PHPCSF(PHP,IPCSF,IPCNF,MXPDIM,
     *                  DTOC,IPRODT,ICONF,
     *                  IREFSM,ONEBOD,ECORE,NACTOB,
     *                  SCR,NCONF,NEL,NAEL,NBEL,NPCSF,NPCNF,
     *                  DIAG,TUVX,NTEST,ExFac,IREOTS)
C
C     Obtain primary subspace and obtain
C     explicit representation of hamilton matrix in subspace
C
C     ARGUMENTS :
C     ===========
C     PHP    : hamilton matrix in subspace ( output)
C     IPCSF  : CSF's defining subspace (output)
C     IPCNF  : Configurations defining subspace (output )
C     MXPDIM : Largest allowed dimension of subspace (Input)
C     DTOC   : Transformation matrix between CSF's and DET's (input)
C     IPRODT : Prototype determinants (input)
C     ICONF  : List of configurations  (input)
C     IREFSM : symmetry of considered CI space (input)
C     Onebod : one body hamilton matrix in rectangular form (input)
C     ECORE  : Core energy (input)
C     NACTOB : Number of active orbitals (input)
C     SCR    : Scratch array of length ????
C     NCONF  : Number of configurations of symmetry IREFSM
C     NPCNF  : Number of primary configurations obtained (output)
C     NPCSF  : Number of primary CSF's obtained  (OUTPUT)
C     TUVX   : Two-electron integrals (MO space)
C     DIAG   : Hamilton diagonal over CSF's
*
*     IREOTS : Type => symmetry reordering array
C
C     Jeppe Olsen , Summer of '89
C     adapted to DETRAS by M.P. Fuelscher, Oktober 1989
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "spinfo.fh"
#include "warnings.fh"
C
      DIMENSION PHP(*),IPCSF(*),IPCNF(*),DIAG(*)
      DIMENSION DTOC(*),IPRODT(*),ICONF(*)
      DIMENSION ONEBOD(*),SCR(*)
      DIMENSION TUVX(*), IREOTS(*)
*
      CALL PHPCSF_INTERNAL(SCR)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE PHPCSF_INTERNAL(SCR)
      USE ISO_C_BINDING
      REAL*8, TARGET :: SCR(*)
      INTEGER, POINTER :: iSCRl(:),iSCRr(:)
*
*     Assumed machine accuray (give and take)
*
      Acc=1.0D-13

* construct the diagonal of the Hamilton matrix in CNF basis
      ICSFMN = 0
      IICNF  = 1
      IICSF  = 1
      DO ITYP = 1, NTYP
        NJCNF = NCNFTP(ITYP,IREFSM)
        NIRREP = NCSFTP(ITYP)
        DO ICNF = 1, NJCNF
          SCR(IICNF) = DIAG(IICSF)
          IICNF = IICNF + 1
          IICSF = IICSF + NIRREP
        END DO
      END DO
      If (NTEST.GE.30) Call RecPrt('SCR',' ',SCR,1,IICNF-1)

* find the elements of the subspace
* (MXPDIM elements smallest in energy)

      XMAX = FNDMNX(SCR,NCONF,2)
      NPCSF = 0
      NPCNF = 0
      IFINIT = 0
400   CONTINUE
      XMIN = XMAX + 1.0D0
      IMIN = 0
      IICNF = 1
      IICSF = 1
      DO ITYP = 1, NTYP
        NJCNF = NCNFTP(ITYP,IREFSM)
        NIRREP = NCSFTP(ITYP)
        DO ICNF = 1,NJCNF
          IF( SCR(IICNF)+Acc.LT.XMIN ) THEN
            XMIN = SCR(IICNF)
            IMIN = IICNF
            ICSFMN = IICSF
            NCSFMN = NIRREP
          END IF
          IICNF = IICNF + 1
          IICSF = IICSF + NIRREP
        END DO
      END DO
      IF( (NPCSF+NCSFMN).LE. MXPDIM ) THEN
*       add new configuration
        NPCNF = NPCNF + 1
        IPCNF(NPCNF) = IMIN
        CALL ISTVC2(IPCSF(NPCSF+1),ICSFMN-1,1,NCSFMN)
        NPCSF = NPCSF + NCSFMN
        SCR(IMIN) = XMAX + 1.0D0
      ELSE
* No space for this configuration , remove previous
* configurations with the same diagonal value
* PAM 2011: Do not remove any previous configurations.
        IFINIT = 1
*        IICNF = NPCNF+1
*600     CONTINUE
*        IICNF = IICNF - 1
*        DIAVAL = SCR(IPCNF(IICNF))
*        IF( ABS(DIAVAL-XMIN).LE.1.0D-10) THEN
*          NPCNF = NPCNF -1
*          CALL GETCNF_LUCIA(SCR(NCONF+1),ITYP,IPCNF(IICNF),
*     &                ICONF,IREFSM,NEL)
*          NPCSF = NPCSF - NCSFTP(ITYP)
*          GOTO 600
*        END IF
      END IF
      IF( (IFINIT.EQ.0) .AND. (NPCNF.LT.NCONF) ) GOTO 400

      IF(NPCNF.eq.0) THEN
        Call WarningMessage(2,'Making explicit Hamiltonian failed.')
        WRITE(6,*)' An unforeseen catastrophic failure occurred'
        WRITE(6,*)' in the CI solver. The size of the explicit'
        WRITE(6,*)' part of the CI Hamiltonian matrix was not'
        WRITE(6,*)' sufficient. Suggested fix: Change the size'
        WRITE(6,*)' by adding ''SDAV=XXXXX'' to the rasscf input.'
        WRITE(6,*)'  XXXXX is some integer at least ',MXPDIM+NCSFMN
        WRITE(6,*)' Sorry about this. Consider telling the'
        WRITE(6,*)' Molcas group about this failure.'
        Call Quit(_RC_INTERNAL_ERROR_)
      END IF
*
      IF( NTEST.GE.30 ) THEN
        WRITE(6,*) ' Output from PHPCSF '
        WRITE(6,*) ' ================== '
        WRITE(6,*)
     &  ' Number of Configurations in primary subspace ',NPCNF
        WRITE(6,*)
     &  ' Number of CSFs in primary subspace ',NPCSF
        WRITE(6,*) ' Configurations included : '
        CALL IWRTMA(IPCNF,1,NPCNF,1,NPCNF)
        WRITE(6,*) ' CSFs included : '
        CALL IWRTMA(IPCSF,1,NPCSF,1,NPCSF)
      END IF

* construct Hamiltonian matrix in subspace

      MXCSFC = 0
      DO ITYP = 1, NTYP
        MXCSFC = MAX(MXCSFC,NCSFTP(ITYP))
      END DO
*
      KLFREE = 1
      KLCONF = KLFREE
      KLFREE = KLFREE+NEL
      KRCONF = KLFREE
      KLFREE = KLFREE+NEL
      KLPHPS = KLFREE
      KLFREE = KLFREE+MXCSFC*MXCSFC
*
      IILB = 1
      DO ICNL = 1, NPCNF
        CALL C_F_POINTER(C_LOC(SCR(KLCONF)),iSCRl,[1])
        CALL GETCNF_LUCIA(iSCRl,ILTYP,IPCNF(ICNL),ICONF,IREFSM,
     &                    NEL)
        NULLIFY(iSCRl)
        NCSFL = NCSFTP(ILTYP)
        IIRB = 1
        DO ICNR = 1, ICNL
          CALL C_F_POINTER(C_LOC(SCR(KRCONF)),iSCRr,[1])
          CALL GETCNF_LUCIA(iSCRr,IRTYP,IPCNF(ICNR),ICONF,IREFSM,
     &                      NEL)
          NULLIFY(iSCRr)
          NCSFR = NCSFTP(IRTYP)
          CALL C_F_POINTER(C_LOC(SCR(KLCONF)),iSCRl,[1])
          CALL C_F_POINTER(C_LOC(SCR(KRCONF)),iSCRr,[1])
          CALL CNHCN(iSCRl,ILTYP,iSCRr,IRTYP,SCR(KLPHPS),
     &               SCR(KLFREE),NAEL,NBEL,ECORE,
     &               ONEBOD,IPRODT,DTOC,NACTOB,TUVX,NTEST,ExFac,IREOTS)
          NULLIFY(iSCRl,iSCRr)
          DO IIL = 1, NCSFL
            IF(IILB.EQ.IIRB) THEN
              IIRMAX = IIL
            ELSE
              IIRMAX = NCSFR
            END IF
            DO IIR = 1, IIRMAX
              IIRACT = IIRB-1+IIR
              IILACT = IILB-1+IIL
              ILRI = (IIR-1)*NCSFL+IIL
              ILRO = ((IILACT*IILACT-IILACT)/2)+IIRACT
              PHP(ILRO) = SCR(KLPHPS-1+ILRI)
            END DO
          END DO
          IIRB = IIRB + NCSFR
        END DO
      IILB = IILB + NCSFL
      END DO
*
      RETURN
      END SUBROUTINE PHPCSF_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine tpidx2orb_sym(TYPEINDEX,NB,NF,NI,N1,N2,N3,NS,ND)
!SVC: read orbital partition info from a typeindex array
!     corresponding to a _specific_symmetry_ (so these variables are
!     scalars!!
!     A typeindex array consists of integers with 7 possible values
!     corresponding to the types 'fi123sd' -> '1234567'.

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: typeindex(*), NB
integer(kind=iwp), intent(out) :: NF, NI, N1, N2, N3, NS, ND
integer(kind=iwp) :: IB, ITYPE

NF = 0
NI = 0
N1 = 0
N2 = 0
N3 = 0
NS = 0
ND = 0
! switch typeindex:
do IB=1,NB
  ITYPE = TYPEINDEX(IB)
  if (ITYPE == 1) then
    NF = NF+1
  else if (ITYPE == 2) then
    NI = NI+1
  else if (ITYPE == 3) then
    N1 = N1+1
  else if (ITYPE == 4) then
    N2 = N2+1
  else if (ITYPE == 5) then
    N3 = N3+1
  else if (ITYPE == 6) then
    NS = NS+1
  else if (ITYPE == 7) then
    ND = ND+1
  else
    write(u6,*) 'TPIDX2ORB_SYM: unknown type index number'
    call AbEnd()
  end if
end do

end subroutine tpidx2orb_sym

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ChkLbl(Lbl,List,nList)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nList
character(len=*), intent(in) :: Lbl, List(nList)
integer(kind=iwp) :: iList
character(len=72) :: Warning

do iList=1,nList
  if (Lbl == List(iList)) then
    write(Warning,'(A,A)') 'ChkLbl: Duplicate label; Lbl=',Lbl
    call WarningMessage(2,Warning)
    call Quit_OnUserError()
  end if
end do

return

end subroutine ChkLbl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine EXPA2_UHF(ARR1,IDM,LI,NSP,ARR2)
! THIS SUBROUTINE EXPANDS THE SECOND INDEX OF A MATRIX ARR1

use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IDM, LI, NSP
real(kind=wp), intent(in) :: ARR1(IDM,nTri_Elem(LI-1))
real(kind=wp), intent(out) :: ARR2(IDM,LI,LI)
integer(kind=iwp) :: I, IJ, J

IJ = 0
do I=1,LI
  do J=1,I-1
    IJ = IJ+1
    ARR2(:,I,J) = ARR1(:,IJ)
    ARR2(:,J,I) = ARR1(:,IJ)
  end do
  ARR2(:,I,I) = Zero
end do
if (NSP < 0) then
  do I=1,LI
    ARR2(:,1:I,I) = -ARR2(:,1:I,I)
  end do
end if

return

end subroutine EXPA2_UHF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine GetT2n (T2n1,T2n2,beSGrp,gaSGrp,LunAux)
c
c       this routine do:
c       Read T2n = T2n(-(+)) (i>(>=)j,(be>(>=)ga)")
c        from Tmp3Name(be",ga")
c
c       parameter description:
c       T2nx    - arrays for T2+- (O)
c       xSGrp   - SubGroups of be,ga (I)
c        LunAux  - Lun (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
c
        real*8 T2n1(1)
        real*8 T2n2(1)
        integer beSGrp,gaSGrp,LunAux
c
c       help variables
        integer length1,length2
        character*6 LunName
c
c1      calc legths
        if (beSGrp.eq.gaSGrp) then
          length1=no*(no+1)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/4
        else
          length1=no*(no+1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)/2
        end if
c
        if (beSGrp.eq.gaSGrp) then
          length2=no*(no-1)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)-1)/4
        else
          length2=no*(no-1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)/2
        end if
c
c2      get T2n1, T2n2
        LunName=Tmp3Name(beSGrp,gaSGrp)
        call GetX (T2n1(1),length1,LunAux,LunName,1,0)
        call GetX (T2n2(1),length2,LunAux,LunName,0,1)
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Stefan Knecht                                    *
!***********************************************************************

module mspt2_eigenvectors

#ifdef _HDF5_
use mh5, only: mh5_put_dset
#endif
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

real(kind=wp), allocatable :: Heff_evc_pc(:,:,:), Heff_evc_sc(:,:,:)

public :: deinit_mspt2_eigenvectors, Heff_evc_pc, Heff_evc_sc, init_mspt2_eigenvectors, prpdata_mspt2_eigenvectors

contains

subroutine init_mspt2_eigenvectors(ijob,nstates,tag)

  use stdalloc, only: mma_allocate
  use Definitions, only: u6

  integer(kind=iwp), intent(in) :: ijob, nstates, tag

  select case (tag)
    case (0)
    case (1)
      call mma_allocate(Heff_evc_pc,nstates,nstates,ijob,Label='Heff_evc_pc')
      HEff_evc_pc(:,:,:) = Zero
    case (2)
      call mma_allocate(Heff_evc_sc,nstates,nstates,ijob,Label='Heff_evc_sc')
      HEff_evc_sc(:,:,:) = Zero
    case default
      write(u6,*) 'unknown tag in init_mspt2_eigenvectors'
      call Abend()
  end select

end subroutine init_mspt2_eigenvectors

subroutine deinit_mspt2_eigenvectors()

  use stdalloc, only: mma_deallocate

  if (allocated(Heff_evc_pc)) call mma_deallocate(Heff_evc_pc)
  if (allocated(Heff_evc_sc)) call mma_deallocate(Heff_evc_sc)

end subroutine deinit_mspt2_eigenvectors

subroutine prpdata_mspt2_eigenvectors(rtdm,stdm,wetdm,prop,nprop,nstate,istate,jstate,ntdmzz,addr,iempty,lu,put_so_data,put_h5_data)

# ifdef _HDF5_
  use RASSIWfn, only: wfn_SFS_TDM, wfn_SFS_TSDM, wfn_SFS_WETDM
# endif

  integer(kind=iwp), intent(in) :: nprop, nstate, istate, jstate, ntdmzz, addr, iempty, lu
  real(kind=wp), intent(inout) :: rtdm(ntdmzz), stdm(ntdmzz), wetdm(ntdmzz), prop(nstate,nstate,nprop)
  logical(kind=iwp), intent(in) :: put_so_data, put_h5_data
  integer(kind=iwp) :: iaddr, iGo, iOpt

  !> calculate property matrix elements
  call proper(prop,istate,jstate,rtdm,wetdm)

  !> put data to file
  if (put_so_data) then
    iOpt = 1
    iGo = ibset(ibset(ibset(0,0),1),2)
    iaddr = addr
    call dens2file(rtdm,stdm,wetdm,ntdmzz,lu,iaddr,iempty,iOpt,iGo,iState,jState)
  end if

# ifdef _HDF5_
  if (put_h5_data .or. put_so_data) then
    call mh5_put_dset(wfn_sfs_tdm,rtdm,[NTDMZZ,1,1],[0,ISTATE-1,JSTATE-1])
    call mh5_put_dset(wfn_sfs_tsdm,stdm,[NTDMZZ,1,1],[0,ISTATE-1,JSTATE-1])
    if (put_so_data) call mh5_put_dset(wfn_sfs_wetdm,wetdm,[NTDMZZ,1,1],[0,ISTATE-1,JSTATE-1])
  end if
# else
# include "macros.fh"
  unused_var(put_h5_data)
# endif

end subroutine prpdata_mspt2_eigenvectors

end module mspt2_eigenvectors

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Sq2Tri
!
!> @brief
!>   Convert from square to lower triangular storage
!> @author Thomas Bondo Pedersen
!>
!> @param[in]  Sq  Square storage array
!> @param[out] Tri Lower triangular storage array
!> @param[in]  n   Dimension
!>
!> @details
!> Perform the extraction
!>
!> \code
!> Tri(i*(i-1)/2+j) = Sq(i,j)
!> \endcode
!>
!> where \c i &ge; \c j.
!***********************************************************************

subroutine Sq2Tri(Sq,Tri,n)

use Index_Functions, only: iTri, nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: Sq(n,n)
real(kind=wp), intent(out) :: Tri(nTri_Elem(n))
integer(kind=iwp) :: i, j

do j=1,n
  do i=j,n
    Tri(iTri(i,j)) = Sq(i,j)
  end do
end do

end subroutine Sq2Tri

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine wrhead()
! this routine writes head of the output file
! parameters transported through cmm common

use ccsd_global, only: ccconv, cycext, eps, filerst, firstext, fullprint, iokey, ispin, keyrst, keysa, lsym, maxiter, mchntyp, &
                       mhkey, mmul, noa, nob, noop, norb, nsym, nva, nvb, shifto, shiftv, slim, title, typden, yesext
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: nhelp, nhelp1, nhelp2

!1 write header and title

!call HelloPN()
if (noop == 1) then
  write(u6,'(6X,A)') ' No Operation is required'
  write(u6,'(6X,A)') ' Happy Landing'
  call Finish(0)
end if

if (title(1:1) /= ' ') then
  write(u6,*)
  write(u6,'(6X,A)') repeat('*',112)
  write(u6,'(6X,A,19X,A72,19X,A)') '*',title,'*'
  write(u6,'(6X,A)') repeat('*',112)
end if

!2 write occupations and matrix multiplication tablaux

write(u6,*)
write(u6,*)
write(u6,'(6X,A)') 'Wave function specifications:'
write(u6,'(6X,A)') '-----------------------------'
write(u6,*)
write(u6,'(6X,A,T45,I6)') 'Spin mutiplicity',ispin
write(u6,'(6X,A,T45,I6)') 'State symmetry',lsym
write(u6,*)
write(u6,'(6X,A)') 'Orbital specifications:'
write(u6,'(6X,A)') '-----------------------'
write(u6,*)
write(u6,'(6X,A,T47,8I4)') 'Symmetry species',(nhelp,nhelp=1,nsym)
write(u6,'(6X,A,T47,8I4)') 'Total no. of orbitals',(norb(nhelp),nhelp=1,nsym)
write(u6,'(6X,A,T47,8I4)') 'No. of occupied orbitals with alpha spin',(noa(nhelp),nhelp=1,nsym)
write(u6,'(6X,A,T47,8I4)') 'No. of occupied orbitals with beta spin',(nob(nhelp),nhelp=1,nsym)
write(u6,'(6X,A,T47,8I4)') 'No. of virtual orbitals with alpha spin',(nva(nhelp),nhelp=1,nsym)
write(u6,'(6X,A,T47,8I4)') 'No. of virtual orbitals with beta spin',(nvb(nhelp),nhelp=1,nsym)
write(u6,*)
if (fullprint > 1) then
  write(u6,*)
  write(u6,16) nsym
  write(u6,17)
  write(u6,*)
  write(u6,18) (nhelp,nhelp=1,nsym)
  write(u6,*)
  do nhelp1=1,nsym
    write(u6,20) nhelp1,(mmul(nhelp1,nhelp),nhelp=1,nsym)
  end do
  write(u6,*)
end if
write(u6,*)
write(u6,'(6X,A)') 'Methods and options:'
write(u6,'(6X,A)') '--------------------'
write(u6,*)
write(u6,'(6X,A,T45,I3)') 'Max no. of iterations',maxiter
if (typden == 0) then
  write(u6,'(6X,A,T45,A)') 'Type of denominators','diagonal Fock matrix elements'
else if (typden == 1) then
  write(u6,'(6X,A,T45,A)') 'Type of denominators','spin averaged diagonal Fock matrix elements'
else
  write(u6,'(6X,A,T45,A)') 'Type of denominators','orbital energies'
end if
write(u6,'(6X,A,T45,F22.14)') 'energy convergence criterium',ccconv
!if (yesext /= 0) then
!end if

!6 write orbital energies per symmetry

write(u6,*)
if (fullprint > 0) then
  write(u6,51)
  write(u6,*)

  nhelp2 = 1
  do nhelp=1,nsym
    write(u6,54) nhelp
    do nhelp1=1,norb(nhelp)
      write(u6,55) nhelp1,eps(nhelp2)
      nhelp2 = nhelp2+1
    end do
  end do
  write(u6,*)
end if

!6 extrapolation parameters

if (yesext == 0) then
  write(u6,61)
else
  write(u6,62)
  write(u6,63) firstext
  write(u6,64) cycext
end if
write(u6,*)

!7  convergence criterion

!FUE write(u6,71) ccconv

!8 spin adaptation

if (keysa == 0) then
  write(u6,81)
else if (keysa == 1) then
  write(u6,82)
else if (keysa == 2) then
  write(u6,83)
else if (keysa == 3) then
  write(u6,84)
else if (keysa == 4) then
  write(u6,85)
end if

!9 restart status
if (keyrst == 0) then
  write(u6,91)
else if (keyrst == 1) then
  write(u6,92) filerst
else if (keyrst == 2) then
  write(u6,93) filerst
end if

!10 write matrix multiplication performance

if (mchntyp == 1) then
  write(u6,101)
else if (mchntyp == 2) then
  write(u6,102) slim
end if

!11 write denominator shifts
write(u6,111) shifto
write(u6,112) shiftv

!12 write workspace

!if (maxspace == 0) then
!  write(u6,121)
!else
!  write(u6,122) maxspace
!end if

!13 level of printing

if (fullprint == 0) then
  write(u6,131)
else if (fullprint == 1) then
  write(u6,132)
else if (fullprint == 2) then
  write(u6,133)
else if (fullprint == 3) then
  write(u6,134)
end if

!14 I/O handling

if (iokey == 1) then
  write(u6,141)
else
  write(u6,142)
end if

!15 Matrix handling

if (mhkey == 1) then
  write(u6,151)
else
  write(u6,152)
end if

!* can be added

write(u6,*)
write(u6,*)

return

16 format(' NUMBER OF IRREPS             :',i3)
17 format(' MATRIX MULTIPLICATION TABLE')
18 format(' IRREP #',9x,8(i3,2x))
20 format(' IRREP #',i3,6x,8(i3,2x))
51 format(' LIST OF ORBITAL ENERGIES')
54 format(' IRREDUCIBLE REPRESENTATION NO:',i2)
55 format(' ORBITAL NO:',i3,5x,f16.10)
61 format(' DIIS EXTRAPOLATION USED     : NO')
62 format(' DIIS EXTRAPOLATION USED     : YES')
63 format(' FIRST ITERATION OF EXT.     :',i3)
64 format(' EXTRAPOLATION CYCLE         :',i3)
!FUE 71 format (' ENERGY CONVERGENCE CRITER.  : ',f10.5)
81 format(' SPIN ADAPTATION             : NONE ')
82 format(' SPIN ADAPTATION             : T2 DDVV ')
83 format(' SPIN ADAPTATION             : T2 DDVV + T1 DV ')
84 format(' SPIN ADAPTATION             : T1 AND T2 FULL ')
85 format(' SPIN ADAPTATION             : T2 FULL WITHOUT SDVS')
91 format(' RESTART STATUS              : NONE ')
92 format(' RST. INF. WILL BE SAVED IN  : ',a6)
93 format(' RST. INF. WILL BE LOAD FROM : ',a6)
101 format(' PREFERENCE MATRIX MULT.     : NORMAL')
102 format(' PREFERENCE MATRIX MULT.     : TRANSP ; LIMIT =',f12.5)
111 format(' DENOMINATOR SHIFT FOR OCC.  : ',f12.5)
112 format(' DENOMINATOR SHIFT FOR VIRT. : ',f12.5)
!121 format (' MAXIMAL ALLOWED WORK SPACE  : UNLIMITED')
!122 format (' MAXIMAL ALLOWED WORK SPACE  : ',i10)
131 format(' LEVEL OF OUTPUT PRINTING    : MINIMAL')
132 format(' LEVEL OF OUTPUT PRINTING    : MEDIUM')
133 format(' LEVEL OF OUTPUT PRINTING    : MAXIMAL')
134 format(' LEVEL OF OUTPUT PRINTING    : DEBUG')
141 format(' INPUT/OUTPUT HANDLING       : Standard SQ ')
142 format(' INPUT/OUTPUT HANDLING       : Molcas4  DA ')
151 format(' MATRIX OPERATIONS           : ESSL        ')
152 format(' MATRIX OPERATIONS           : Fortran code')

end subroutine wrhead

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE CONF_VERTEX_W(IOCC_MIN,IOCC_MAX,NORB,NEL,IVERTEXW)
*
* Obtain vertex weights for configuration graph
*
* Jeppe Olsen, October 2001
*
#include "implicit.fh"
*. Input
      INTEGER IOCC_MIN(NORB),IOCC_MAX(NORB)
*. Output
      INTEGER IVERTEXW(NORB+1,NEL+1)
*
      IZERO = 0
C?    WRITE(6,*) ' CONF_VERTEX : NORB, NEL = ', NORB, NEL
      CALL ISETVC(IVERTEXW,IZERO,(NORB+1)*(NEL+1))
*
      IVERTEXW(0+1,0+1) = 1
      DO IORB = 1, NORB
C$$$ Jesper      DO IEL  = 0, NEL
        DO IEL  = IOCC_MIN(IORB), IOCC_MAX(IORB)
C$$$ Jesper        IF(IOCC_MIN(IORB).LE.IEL.AND.IEL.LE.IOCC_MAX(IORB)) THEN
*
          IF(IEL.EQ. 0 )
     &    IVERTEXW(IORB+1,IEL+1) = IVERTEXW(IORB-1+1,IEL+1)
*
          IF(IEL.EQ. 1 )
     &    IVERTEXW(IORB+1,IEL+1) = IVERTEXW(IORB-1+1,IEL+1)
     &                           + IVERTEXW(IORB-1+1,IEL+1-1)
*
          IF(IEL.GE. 2 )
     &    IVERTEXW(IORB+1,IEL+1) = IVERTEXW(IORB-1+1,IEL+1)
     &                           + IVERTEXW(IORB-1+1,IEL+1-1)
     &                           + IVERTEXW(IORB-1+1,IEL+1-2)
*
C$$$ Jesper        END IF
        END DO
      END DO
* Check whether a configuration has enough singly occupied orbitals
C$$$ Jesper ???  CALL REDUCE_VERTEX_WEIGHTS(IVERTEXW(NORB+1,NEL+1), IVERTEXW,
C$$$ Jesper ??? &                           NEL, NORB, IOCC_MIN, IOCC_MAX)
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*)  ' Vertex weights as an (NORB+1)*(NEL+1) matrix '
        CALL IWRTMA(IVERTEXW,NORB+1,NEL+1,NORB+1,NEL+1)
      END IF
*
      RETURN
      END
*
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WR_MOTRA_Info(Lu,iOpt,iDisk,
     &                         TCONEMO,nTCONEMO,ECOR,NSYM,
     &                         NBAS,NORB,NFRO,NDEL,MxSym,BSLBL,nBSLBL)
      Implicit Real*8 (a-h,o-z)
#include "SysDef.fh"
      Integer TCONEMO(nTCONEMO), nBas(MxSym), nOrb(MxSym), nFro(MxSym),
     &        nDel(MxSym)
      Character BSLBL(nBSLBL)*1
*
      Call iDafile(Lu,iOpt,TCONEMO,nTCONEMO,iDisk)
      Call s_dDafile_motra(Lu,iOpt,ECor,   1,       iDisk)
      Call s_iDafile_motra(Lu,iOpt,nSym,   1,       iDisk)
      Call iDafile(Lu,iOpt,nBas,   MxSym,   iDisk)
      Call iDafile(Lu,iOpt,nOrb,   MxSym,   iDisk)
      Call iDafile(Lu,iOpt,nFro,   MxSym,   iDisk)
      Call iDafile(Lu,iOpt,nDel,   MxSym,   iDisk)
      Call cDafile(Lu,iOpt,BSLBL,  nBSLBL,  iDisk)
*
      Return
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine s_iDaFile_motra(Lu,iOpt,Buf,lBuf_,iDisk_)
      Use Iso_C_Binding
      Integer Lu, iOpt, lBuf_, iDisk_
      Integer, Target :: Buf
      Integer, Pointer :: pBuf(:)
      Call C_F_Pointer(C_Loc(Buf),pBuf,[1])
      Call iDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
      Nullify(pBuf)
      End Subroutine s_iDaFile_motra
      Subroutine s_dDaFile_motra(Lu,iOpt,Buf,lBuf_,iDisk_)
      Use Iso_C_Binding
      Integer Lu, iOpt, lBuf_, iDisk_
      Real*8, Target :: Buf
      Real*8, Pointer :: pBuf(:)
      Call C_F_Pointer(C_Loc(Buf),pBuf,[1])
      Call dDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
      Nullify(pBuf)
      End Subroutine s_dDaFile_motra
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKBD(DREF,NDREF,PREF,NPREF,FD,FP)

use Index_Functions, only: nTri_Elem
use SUPERINDEX, only: MTU
use EQSOLV, only: IDBMAT, IDSMAT
use caspt2_global, only: ipea_shift, LUSBT
use caspt2_module, only: EASUM, EPSA, NASHT, NINDEP, NSYM, NTU, NTUES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two, Four, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF
real(kind=wp), intent(in) :: DREF(NDREF), PREF(NPREF), FD(NDREF), FP(NPREF)
integer(kind=iwp) :: I, IB11, IB12, IB21, IB22, ID, ID1, ID2, IDIAG, IDISK, IDS, IDT, IDU, IP, IP1, IP2, ISYM, ITABS, ITU, ITU2, &
                     ITUABS, IUABS, IUTP, IUYP, IXABS, IXTP, IXY, IXY2, IXYABS, IXYP, IYABS, NAS, NAS2, NBD, NIN
real(kind=wp) :: B11, B22, DUY, ET, ETX, EX, FUY
real(kind=wp), allocatable :: BD(:), S(:), SD(:)

! Set up the matrix BD(tuP,xyQ),P and Q are 1 or 2,
! Formulae used:
!    BD(tu1,xy1)=
!      2*Futxy + 2*(Ex+Et-A)*Gutxy + 2*dxt (Fuy + (Et-A)*Duy)
!    BD(tu2,xy1)= -BD(tu1,xy1)/2
!    BD(tu2,xy2)=
!       -Fxtuy - (Ex+Et-A)*Gxtuy + 2*dxt (Fuy + (Ex-A)*Duy)
! where A=EASUM=Sum(w) of (Ew*Dww)

! Loop over superindex symmetry.
do ISYM=1,NSYM
  NIN = NINDEP(ISYM,5)
  if (NIN == 0) cycle
  NAS = NTU(ISYM)
  NBD = nTri_Elem(2*NAS)
  if (NBD > 0) then
    call mma_allocate(BD,NBD,Label='BD')
    !GG.Nov03  Load in SD the diagonal elements of SD matrix:
    NAS2 = 2*NAS
    call mma_allocate(S,NBD,Label='S')
    call mma_allocate(SD,NAS2,Label='SD')
    IDS = IDSMAT(ISYM,5)
    call DDAFILE(LUSBT,2,S,NBD,IDS)
    IDIAG = 0
    do I=1,NAS2
      IDIAG = IDIAG+I
      SD(I) = S(IDIAG)
    end do
    call mma_deallocate(S)
    !GG End
  end if
  do ITU=1,NAS
    ITU2 = ITU+NAS
    ITUABS = ITU+NTUES(ISYM)
    ITABS = MTU(1,ITUABS)
    IUABS = MTU(2,ITUABS)
    ET = EPSA(ITABS)
    do IXY=1,ITU
      IXY2 = IXY+NAS
      IXYABS = IXY+NTUES(ISYM)
      IXABS = MTU(1,IXYABS)
      IYABS = MTU(2,IXYABS)
      EX = EPSA(IXABS)
      IB11 = (ITU*(ITU-1))/2+IXY
      IB21 = (ITU2*(ITU2-1))/2+IXY
      IB12 = (IXY2*(IXY2-1))/2+ITU
      IB22 = (ITU2*(ITU2-1))/2+IXY2
      IUTP = IUABS+NASHT*(ITABS-1)
      IXYP = IXABS+NASHT*(IYABS-1)
      IP1 = max(IUTP,IXYP)
      IP2 = min(IUTP,IXYP)
      IP = (IP1*(IP1-1))/2+IP2
      ETX = ET+EX
      B11 = Four*(FP(IP)+(ETX-EASUM)*PREF(IP))
      IXTP = IXABS+NASHT*(ITABS-1)
      IUYP = IUABS+NASHT*(IYABS-1)
      IP1 = max(IXTP,IUYP)
      IP2 = min(IXTP,IUYP)
      IP = (IP1*(IP1-1))/2+IP2
      B22 = -Two*(FP(IP)+(ETX-EASUM)*PREF(IP))
      if (IXABS == ITABS) then
        ID1 = max(IUABS,IYABS)
        ID2 = min(IUABS,IYABS)
        ID = (ID1*(ID1-1))/2+ID2
        FUY = FD(ID)
        DUY = DREF(ID)
        B11 = B11+Two*(FUY+(ET-EASUM)*DUY)
        B22 = B22+Two*(FUY+(EX-EASUM)*DUY)
      end if
      BD(IB11) = B11
      BD(IB21) = -Half*B11
      BD(IB12) = -Half*B11
      BD(IB22) = B22
      !GG.Nov03
      if (ITU == IXY) then
        IDT = (ITABS*(ITABS+1))/2
        IDU = (IUABS*(IUABS+1))/2
        BD(IB11) = BD(IB11)+ipea_shift*Half*(Two-DREF(IDU)+DREF(IDT))*SD(ITU)
        BD(IB22) = BD(IB22)+ipea_shift*Half*(Two-DREF(IDU)+DREF(IDT))*SD(ITU+NAS)
      end if
      !GG End
    end do
  end do

  ! Write to disk
  if ((NBD > 0) .and. (NINDEP(ISYM,5) > 0)) then
    IDISK = IDBMAT(ISYM,5)
    call DDAFILE(LUSBT,1,BD,NBD,IDISK)
    call mma_deallocate(BD)
    !GG.Nov03 DisAlloc SD
    call mma_deallocate(SD)
    !GG End
  end if
end do

end subroutine MKBD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dBMult(dCdQ,QC,nQQ,nDim,nLambda)

use Slapaf_Info, only: dBM, idBM, mq, nqBM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nQQ, nDim, nLambda
real(kind=wp), intent(in) :: dCdQ(nQQ,nLambda)
real(kind=wp), intent(out) :: QC(nDim**2,nLambda)
integer(kind=iwp) :: i_Dim, idB, iElem, ijDim, iq, jdim, nElem
real(kind=wp) :: dBqR
real(kind=wp), allocatable :: X(:,:), K(:,:)

QC(:,:) = Zero

if (.not. allocated(dBM)) then
  !write(u6,*) 'FAST out'
  return
end if

call mma_allocate(X,mq,nLambda,Label='X')
X(:,:) = Zero
call mma_allocate(K,mq,nQQ,Label='K')
call Get_dArray('K',K,mq*nQQ)

call DGEMM_('N','N',mq,nLambda,nQQ,One,K,mq,dCdQ,nQQ,Zero,X,mq)
call mma_deallocate(K)

idB = 1
do iq=1,mq
  nElem = nqBM(iq)
  do iElem=idB,idB+(nElem**2)-1
    dBqR = dBM(iElem)
    i_Dim = idBM(1+(iElem-1)*2)
    jDim = idBM(2+(iElem-1)*2)
    ijDim = (jDim-1)*nDim+i_Dim
    QC(ijDim,:) = QC(ijDim,:)+X(iq,:)*dBqR
  end do
  idB = idB+nElem**2
end do
call mma_deallocate(X)

return

end subroutine dBMult

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_INVPCK(IJ,I,J,LOW)
!
! Purpose: invert triangular packing index ij to
!          rectangular indices i and j.
!          Flag LOW specifies packing convention:
!          LOW = T: i>=j
!          LOW = F: i<=j

use Index_Functions, only: iTri_Rev
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IJ
integer(kind=iwp), intent(out) :: I, J
logical(kind=iwp), intent(in) :: LOW
integer(kind=iwp) :: RES(2)

if (IJ > 0) then

  RES = iTri_Rev(IJ)
  if (LOW) then
    I = RES(1)
    J = RES(2)
  else
    I = RES(2)
    J = RES(1)
  end if

else

  I = -1
  J = -2

end if

end subroutine CHO_INVPCK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Jeppe Olsen                                      *
!***********************************************************************

subroutine T_ROW_TO_H(T,H,K,TKK)
! Set H integrals
!
!    Column K : H(P,K) = T(P,K)/T(K,K), P /= K
!    Other Columns     = 0
! - and return T_{kk} in TKK
!
! Jeppe Olsen, Jan 98
! For rotation of CI vectors

use lucia_data, only: IBSO, ISMFSO, NTOOB, NTOOBS, PGINT1A
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: T(NTOOB**2)
real(kind=wp), intent(out) :: H(NTOOB**2), TKK
integer(kind=iwp), intent(in) :: K
integer(kind=iwp) :: IOFF, KOFF, KREL, KSM, NK

KSM = ISMFSO(K)
KOFF = IBSO(KSM)
KREL = K-KOFF+1
NK = NTOOBS(KSM)

H(:) = Zero

IOFF = PGINT1A(1)%A(KSM)
H(IOFF+(KREL-1)*NK:IOFF+KREL*NK-1) = T(IOFF+(KREL-1)*NK:IOFF+KREL*NK-1)
TKK = H(IOFF-1+(KREL-1)*NK+KREL)
if (TKK /= Zero) then
  H(IOFF+(KREL-1)*NK:IOFF+KREL*NK-1) = H(IOFF+(KREL-1)*NK:IOFF+KREL*NK-1)/TKK
  !H(IOFF-1+(K-1)*NK+K) = H(IOFF-1+(K-1)*NK+K)-One
  H(IOFF-1+(KREL-1)*NK+KREL) = Zero
!else
!  TKK = One
end if

end subroutine T_ROW_TO_H

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Francesco Aquilante                              *
************************************************************************
      SUBROUTINE CHO_LR_MOs(iOK,nDen,nSym,nBas,nIsh,ipCM,ISLT,ISK,ipMSQ)

************************************************************************
*
*   Computes Left (L) and Right (R) Cholesky vectors to represent a
*            non-symmetric density matrix
*
*            D = C[a] * C[b]^T = L * R^T
*
*   The code is generalized to treat density matrices with any number
*            (nDen) of distinct blocks. The corresponding Cholesky
*            vectors are returned in the arrays defined by the
*            pointers ipMSQ
*
*   A non-zero value for the return code iOK indicates that something
*            went wrong and therefore the returned arrays may contain
*            junk
*
*   Author: F. Aquilante    (October 2008)
*
************************************************************************

      Implicit Real*8 (a-h,o-z)
      Integer  iOK, nDen, nSym
      Integer  nBas(nSym), nIsh(nSym), ISLT(nSym), ISK(nSym)
      Integer  ipCM(nDen), ipMSQ(nDen)

#include "WrkSpc.fh"
************************************************************************

      irc=0
      ikc=0

      nBm=nBas(1)
      Do iSym=2,nSym
         nBm=Max(nBm,nBas(iSym))
      End Do
      Call GetMem('Dmat','Allo','Real',ipD,nBm**2)
      ipP = ipD
      ipV = ipMSQ(1)
      If (nDen.gt.1) Then
         Call GetMem('Pmat','Allo','Real',ipP,2*(nDen*nBm)**2)
         ipV = ipP + (nDen*nBm)**2
      EndIf

      iSym=1
      Do while (iSym .le. nSym)

        If (nBas(iSym).gt.0 .and. nIsh(iSym).gt.0) then

C --- Inactive P[kl](a,b) = sum_i C[k](a,i)*C[l](b,i)

         n2b=nDen*nBas(iSym)

         Do k=1,nDen

            kCM = ipCM(k) + ISK(iSym)

            Do l=1,nDen

               lCM = ipCM(l) + ISK(iSym)

               Call DGEMM_('N','T',nBas(iSym),nBas(iSym),nIsh(iSym),
     &                      1.0d0,Work(kCM),nBas(iSym),
     &                            Work(lCM),nBas(iSym),
     &                      0.0d0,Work(ipD),nBas(iSym))

               Do ib=1,nBas(iSym)*Min(1,nDen-1)
                  ifr=nBas(iSym)*(ib-1)+ipD
                  ito=n2b*(ib-1)+nBas(iSym)*(k-1)+
     &                n2b*nBas(iSym)*(l-1)+ipP
                  call dcopy_(nBas(iSym),Work(ifr),1,Work(ito),1)
               End Do

            End Do

         End Do

         Ymax=0.0d0
         do ja=1,n2b
            jaa=ipP-1+n2b*(ja-1)+ja
            Ymax=Max(Ymax,Work(jaa))
         end do
         Thr=1.0d-13*Ymax

         If (nDen.eq.1) ipV = ipMSQ(1) + ISK(iSym)

         CALL CD_InCore(Work(ipP),n2b,Work(ipV),n2b,
     &                  NumV,Thr,irc)

         If (NumV.ne.nIsh(iSym)) ikc=1

         If (nDen.gt.1) Then
            Do jden=1,nDen
               iMSQ = ipMSQ(jden) + ISK(iSym)
               Do jv=1,NumV
                  ifr=ipV+n2b*(jv-1)+nBas(iSym)*(jden-1)
                  ito=iMSQ+nBas(iSym)*(jv-1)
                  call dcopy_(nBas(iSym),Work(ifr),1,Work(ito),1)
               End Do
            End Do
         End If


        EndIf

        If (irc.ne.0 .or. ikc.ne.0) iSym=nSym

        iSym=iSym+1

      End Do


      If (nDen.gt.1) Call GetMem('Pmat','Free','Real',
     &                            ipP,2*(nDen*nBm)**2)
      Call GetMem('Dmat','Free','Real',ipD,nBm**2)

      iOK=0
      If (irc.ne.0 .or. ikc.ne.0) iOK=1

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(ISLT)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OpnFls_McKinley()

use McKinley_global, only: lHss, nMethod, RASSCF, SCF
use Basis_Info, only: nBas
use Symmetry_Info, only: lIrrep, nIrrep
use Definitions, only: iwp, u6

implicit none
#include "Molcas.fh"
#include "disp.fh"
integer(kind=iwp) :: i, iDummer, iGo, iOpt, iRC, ngrad
character(len=288) :: Header
character(len=8) :: MckLbl, Method

iOpt = 1
iRC = -1
MckLbl = 'Title'
call cWrMck(iRC,iOpt,MckLbl,1,Header,iDummer)
if (iRC /= 0) then
  write(u6,*) 'OpnFls: Error writing to MCKINT'
  write(u6,'(A,A)') 'MckLbl=',MckLbl
  call Abend()
end if
iOpt = 1
iRC = -1
MckLbl = 'nSym'
call iWrMck(iRC,iOpt,MckLbl,1,[nIrrep],iDummer)
if (iRC /= 0) then
  write(u6,*) 'OpnFls: Error writing to MCKINT'
  write(u6,'(A,A)') 'MckLbl=',MckLbl
  call Abend()
end if
iOpt = 0
iRC = -1
MckLbl = 'nBas'
call iWrMck(iRC,iOpt,MckLbl,1,nBas,iDummer)
if (iRC /= 0) then
  write(u6,*) 'OpnFls: Error writing to MCKINT'
  write(u6,'(A,A)') 'MckLbl=',MckLbl
  call Abend()
end if
iOpt = 0
iRC = -1
MckLbl = 'SymOp'
call cWrMck(iRC,iOpt,MckLbl,1,lirrep(0),iDummer)
if (iRC /= 0) then
  write(u6,*) 'OpnFls: Error writing to MCKINT'
  write(u6,'(A,A)') 'MckLbl=',MckLbl
  call Abend()
end if
iOpt = 0
iRC = -1
MckLbl = 'ldisp'
call iWrMck(iRC,iOpt,MckLbl,1,ldisp,iDummer)
if (iRC /= 0) then
  write(u6,*) 'OpnFls: Error writing to MCKINT'
  write(u6,'(A,A)') 'MckLbl=',MckLbl
  call Abend()
end if
ngrad = 0
do i=0,nIrrep-1
  nGrad = nGrad+ldisp(i)
end do
iOpt = 0
iRC = -1
MckLbl = 'chdisp'
call cWrMck(iRC,iOpt,MckLbl,1,chdisp(1),iDummer)
if (iRC /= 0) then
  write(u6,*) 'OpnFls: Error writing to MCKINT'
  write(u6,'(A,A)') 'MckLbl=',MckLbl
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the method label

call Get_cArray('Relax Method',Method,8)
if (Method == 'RHF-SCF ') then
  nMethod = SCF
else if (Method == 'CASSCF  ') then
  nMethod = RASSCF
else if (Method == 'CASSCFSA') then
  nMethod = RASSCF
  call Get_iScalar('SA ready',iGo)
  if (lHss .and. (iGo /= 2)) then
    write(u6,*)
    write(u6,*) ' Wavefunction type: RASSCF-SA'
    write(u6,*)
    write(u6,*) ' This option is not allowed when computing the Hessian. Use the RHS option!'
    call Quit_OnUserError()
  end if
else
  write(u6,*) ' OpnFls: Wavefunction type:',Method
  write(u6,*) '         Illegal type of wave function!'
  write(u6,*) '         McKinley can not continue'
  write(u6,*)
  call Quit_OnUserError()
end if

return

end subroutine OpnFls_McKinley

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Int_LDF_2Indx_11(
     &                            iCmp,iShell,MapOrg,
     &                            iBas,jBas,kBas,lBas,kOp,
     &                            Shijij,IJeqKL,iAO,iAOst,ijkl,
     &                            AOInt,SOInt,nSOint,
     &                            iSOSym,nSkal,nSOs,
     &                            TInt,nTInt,itOffs,nSym)
*     calls the proper routines IndSft/PLF
*     if IntOrd_jikl==.TRUE. integral order within symblk: jikl
*                      else  integral order within symblk: ijkl
      Implicit Real*8 (a-h,o-z)
*
#include "localdf_int3.fh"
*
      Character*16 SecNam
      Parameter (SecNam='Int_LDF_2Indx_11')
*
      Real*8 AOInt(*), SOInt(*), TInt(nTInt)
      Integer iCmp(4), iShell(4), iAO(4),
     &        iAOst(4), kOp(4), iSOSym(2,nSOs),
     &        itOffs(0:nSym-1,0:nSym-1,0:nSym-1), MapOrg(4)
      Logical Shijij,IJeqKL
*
      External LDF_nShell, LDF_nAuxShell
*
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
*
* some dummy assignments to avoid compiler warnings about unused
* variables.
*
      If (nSym.gt.0.and.nSkal.gt.0) Then
         iDummy_2  = itOffs(0,0,0)
         iDummy_3  = iShell(1)
      End If
*
* call sorting routine
*
      If (nSym==1) Then
         nS_Val=LDF_nShell()
         nS_Aux=LDF_nAuxShell()
         iS_Dum=nS_Val+nS_Aux+1
         If (SHA.eq.iS_Dum .and.
     &       SHB.gt.nS_Val .and. SHB.lt.iS_Dum .and.
     &       SHC.eq.iS_Dum .and.
     &       SHD.gt.nS_Val .and. SHD.lt.iS_Dum) Then
            !check that shells have not been re-ordered
            If (MapOrg(1).ne.1 .or. MapOrg(2).ne.2 .or.
     &          MapOrg(3).ne.3 .or. MapOrg(4).ne.4) Then
               Call WarningMessage(2,
     &      SecNam//': Shell reordering not implemented for this case!')
               Write(6,'(A,4I9)')
     &         'MapOrg.................',(MapOrg(i),i=1,4)
               Write(6,'(A,4I9)')
     &         'SHA,SHB,SHC,SHD........',SHA,SHB,SHC,SHD
               Write(6,'(A,2(9X,I9))')
     &         'SHAB,SHCD..............',iTri(SHA,SHB),iTri(SHC,SHD)
               Write(6,'(A,3I9)')
     &         'nS_Val,nS_Aux,iS_Dum...',nS_Val,nS_Aux,iS_Dum
               Call LDF_Quit(1)
            End If
            ! type (J|K)
            Call PLF_LDF_2Indx_11(TInt,nTInt,
     &                            AOInt,ijkl,
     &                            iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &                            iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
         Else
            Call WarningMessage(2,
     &                  'Shell combination not implemented in '//SecNam)
            Write(6,'(A,4I9)')
     &      'SHA,SHB,SHC,SHD........',SHA,SHB,SHC,SHD
            Write(6,'(A,3I9)')
     &      'nS_Val,nS_Aux,iS_Dum...',nS_Val,nS_Aux,iS_Dum
            Call LDF_Quit(1)
         End If
      Else
         Call WarningMessage(2,'Symmetry not implemented in '//SecNam)
         Call LDF_Quit(1)
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Shijij)
         Call Unused_logical(IJeqKL)
         Call Unused_real_array(SOInt)
         Call Unused_integer(nSOint)
         Call Unused_integer_array(iSOSym)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DrvUpH(nWndw,nIter,H,nInter,
     &                  dq,g,iOptH,HUpMet,nRowH,
     &                  jPrint,IterHess)
      Use NewH_mod
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 H(nInter,nInter), dq(nInter,nIter), g(nInter,nIter+1)
      Logical Found, DoMask,Test
      Character*6 HUpMet
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      Test(i)=iAnd(iOptH,2**(i-1)).eq.2**(i-1)
*                                                                      *
************************************************************************
*                                                                      *
      Lu=6
*                                                                      *
************************************************************************
*                                                                      *
      iSt=Max(2,nIter-(nWndw-1))
      Call Qpg_iScalar('HessIter',Found)
      If (Found) Then
         Call Get_iScalar('HessIter',IterHess)
         iSt=Max(iSt,IterHess+1)
      Else
         IterHess=0
      End If
      If (nRowH.GT.0) iSt=Max(iSt,nRowH+2)
      If (jPrint.ge.99) Then
         Write(Lu,*) 'DrvUpH: iSt,kIter=',iSt,nIter
         Call RecPrt('DrvUpH: Initial Hessian',' ',H,nInter,nInter)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (jPrint.ge.6 .and..Not.Test(4)) Then
         Write (Lu,*)
         If (nIter.lt.iSt) Then
            Write (Lu,*) 'No update of Hessian on the first iteration'
         Else
            Write (Lu,'(A,30I3)') 'Hessian update from points:',
     &            (lIter,lIter=iSt-1,nIter)
         End If
         Write (Lu,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      DoMask=.False.
      If (Allocated(UpdMask)) Then
         If (Size(UpdMask).eq.nInter) DoMask=.True.
      End If
      If (DoMask) Then
         Do i=1,nInter
            If (UpdMask(i).ne.0) Then
               Do j=1,nInter
                  H(i,j)=Zero
                  H(j,i)=Zero
               End Do
               H(i,i)=DiagMM
            End If
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Update the Hessian over the window
*
      If (jPrint.ge.99)
     &   Call RecPrt('DrvUpH: Initial Hessian',' ',H,nInter,nInter)
      Do lIter=iSt,nIter
         If (jPrint.ge.99) Write(Lu,*)'DrvUpH: Call NewH, lIter=',lIter
         Call NewH(nInter,lIter,dq,g,H,iOptH,HUpMet,nIter)
      End Do
      If (jPrint.ge.99)
     &   Call RecPrt('DrvUpH: Updated Hessian',' ',H,nInter,nInter)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_XCV_WrVec_Par(irc,Vec,NVT,myRankSP,SP)
!
! PARALLEL VERSION
!     Write the vectors in blocks.

use Cholesky, only: LuTmp, nnBstRSh, nSym
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: NVT(*), myRankSP(*), SP
real(kind=wp), intent(_IN_) :: Vec(*)
integer(kind=iwp) :: iAdr, iSP, iSym, j, kV, lTot
integer(kind=iwp), parameter :: iOpt = 1

irc = 0

iSP = myRankSP(SP)
kV = 1
do iSym=1,nSym
  lTot = nnBstRSh(iSym,iSP,2)*NVT(iSym)
  if (lTot > 0) then
    iAdr = 0
    do j=1,SP-1
      iAdr = iAdr+nnBstRSh(iSym,myRankSP(j),2)*NVT(iSym)
    end do
    call DDAFile(LuTmp(iSym),iOpt,Vec(kV),lTot,iAdr)
    kV = kV+lTot
  end if
end do

end subroutine Cho_XCV_WrVec_Par

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               2003, Hans-Joachim Werner                              *
!***********************************************************************

subroutine Drv1_Pot(FD,CCoor,pot,ngrid,ncmp,nordop)
!***********************************************************************
!                                                                      *
! Object: to compute the potential on a grid using density FD (triang) *
!         Grid provided in CCoor(3,ngrid)                              *
!         Potential values returned in pot                             *
!                                                                      *
! Generated by modification of drv_rf.f, naint.f, sogthr.f             *
! H.-J. Werner, Jan 2003                                               *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Symmetry_Info, only: nIrrep
use Real_Spherical, only: ipSph, RSph
use iSD_data, only: iSD
use Basis_Info, only: dbsc, MolWgh, Shells
use Center_Info, only: dc
use Sizes_of_Seward, only: S
#ifdef _DEBUGPRINT_
use define_af, only: AngTp
use Symmetry_Info, only: ChOper
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ngrid, ncmp, nordop
real(kind=wp), intent(in) :: FD(*), CCoor(3,ngrid)
real(kind=wp), intent(out) :: pot(ncmp,ngrid)
integer(kind=iwp) :: iAng, iAO, iBas, iCmp, iCnt, iCnttp, iDCRR(0:7), iDCRT(0:7), igeo, iPrim, iS, iShell, iShll, iSmLbl, &
                     iStabM(0:7), iStabO(0:7), iuv, jAng, jAO, jBas, jCmp, jCnt, jCnttp, jPrim, jS, jShell, jShll, kk, lDCRR, &
                     lDCRT, lFinal, LmbdR, LmbdT, loper, mdci, mdcj, MemKer, nComp, nDAO, nDCRR, nDCRT, nOp(3), nOrder, nScr1, &
                     nScr2, nSkal, nSO, nStabM, nStabO
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif
real(kind=wp) :: A(3), B(3), FactNd, RB(3), TA(3), TRB(3), XX, YY, ZZ
real(kind=wp), allocatable :: DAO(:), DSO(:), DSOp(:), Kappa(:), Kern(:), PCoor(:,:), rFinal(:), Scrt1(:), Scrt2(:), Zeta(:), &
                              ZInv(:)
real(kind=wp), parameter :: ThreeI = One/Three
integer(kind=iwp), external :: MemSO1, n2Tri, NrOpr

!                                                                      *
!***********************************************************************
!                                                                      *
loper = 2**nIrrep-1
nComp = nTri_Elem1(nOrdOp)
if (ncomp /= ncmp) then
  call WarningMessage(2,'Drv1_pot: ncmp < ncomp')
  write(u6,*) 'ncmp < ncomp:',ncmp,ncomp
  call Abend()
end if
pot(:,:) = Zero

! Auxiliary memory allocation.

call mma_allocate(Zeta,S%m2Max,label='Zeta')
call mma_allocate(ZInv,S%m2Max,label='ZInv')
call mma_allocate(Kappa,S%m2Max,label='Kappa')
call mma_allocate(PCoor,S%m2Max,3,label='PCoor')
!                                                                      *
!***********************************************************************
!                                                                      *
call Nr_Shells(nSkal)
!                                                                      *
!***********************************************************************
!                                                                      *
! Double loop over shells. These loops decide the integral type

do iS=1,nSkal
  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  mdci = iSD(10,iS)
  iShell = iSD(11,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
  do jS=1,iS
    jShll = iSD(0,jS)
    jAng = iSD(1,jS)
    jCmp = iSD(2,jS)
    jBas = iSD(3,jS)
    jPrim = iSD(5,jS)
    jAO = iSD(7,jS)
    mdcj = iSD(10,jS)
    jShell = iSD(11,jS)
    jCnttp = iSD(13,jS)
    jCnt = iSD(14,jS)
    B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

    iSmLbl = 1
    nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
    if (nSO == 0) cycle
#   ifdef _DEBUGPRINT_
    write(u6,'(A,A,A,A,A)') ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
#   endif

    ! Call kernel routine to get memory requirement.

    !call NAMem(nOrder,MemKer,iAng,jAng,nOrdOp)
    call EFMmP(nOrder,MemKer,iAng,jAng,nOrdOp)
    call mma_allocate(Kern,MemKer*S%m2Max,label='Kernel')

    ! Allocate memory for the final integrals, all in the primitive basis.

    lFinal = 1
    if (nOrdOp /= 0) lFinal = S%MaxPrm(iAng)*S%MaxPrm(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)*nComp
    call mma_allocate(rFinal,lFinal,label='Final')

    ! Scratch area for contraction step

    nScr1 = S%MaxPrm(iAng)*S%MaxPrm(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)
    call mma_allocate(Scrt1,nScr1,label='Scrtch')

    ! Scratch area for the transformation to spherical gaussians

    nScr2 = S%MaxPrm(iAng)*S%MaxPrm(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)
    call mma_allocate(Scrt2,nScr2,label='ScrSph')

    nDAO = iPrim*jPrim*nTri_Elem1(iAng)*nTri_Elem1(jAng)
    call mma_allocate(DAO,nDAO,label='DAO')

    ! At this point we can compute Zeta.

    call ZXia(Zeta,ZInv,iPrim,jPrim,Shells(iShll)%Exp,Shells(jShll)%Exp)

    ! Find the DCR for A and B

    call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
#   ifdef _DEBUGPRINT_
    write(u6,'(10A)') ' {R}=(',(ChOper(iDCRR(i)),i=0,nDCRR-1),')'
#   endif

    ! Find the stabilizer for A and B

    call Inter(dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iStabM,nStabM)

    ! Allocate memory for the elements of the Fock or 1st order
    ! density matrix which are associated with the current shell pair.

    call mma_allocate(DSOp,nSO*iPrim*jPrim,label='DSOpr')
    call mma_allocate(DSO,nSO*iPrim*jPrim,label='DSO')

    ! Gather the elements from 1st order density / Fock matrix.

    call SOGthr(DSO,iBas,jBas,nSO,FD,n2Tri(iSmLbl),iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)

    ! Project the Fock/1st order density matrix in AO
    ! basis on to the primitive basis.

#   ifdef _DEBUGPRINT_
    call RecPrt(' Left side contraction',' ',Shells(iShll)%pCff,iPrim,iBas)
    call RecPrt(' Right side contraction',' ',Shells(jShll)%pCff,jPrim,jBas)
#   endif

    ! Transform IJ,AB to J,ABi
    call DGEMM_('T','T',jBas*nSO,iPrim,iBas,One,DSO,iBas,Shells(iShll)%pCff,iPrim,Zero,DSOp,jBas*nSO)
    ! Transform J,ABi to AB,ij
    call DGEMM_('T','T',nSO*iPrim,jPrim,jBas,One,DSOp,jBas,Shells(jShll)%pCff,jPrim,Zero,DSO,nSO*iPrim)
    ! Transpose to ij,AB
    call DGeTmO(DSO,nSO,nSO,iPrim*jPrim,DSOp,iPrim*jPrim)
    call mma_deallocate(DSO)

#   ifdef _DEBUGPRINT_
    call RecPrt(' Decontracted 1st order density/Fock matrix',' ',DSOp,iPrim*jPrim,nSO)
#   endif

    ! Loops over symmetry operations.

    do lDCRR=0,nDCRR-1
      call OA(iDCRR(lDCRR),B,RB)

      ! Generate stabilizer of the operator.

      call SOS(iStabO,nStabO,lOper)

      ! Find the DCR for M and S

      call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
#     ifdef _DEBUGPRINT_
      write(u6,'(10A)') ' {M}=(',(ChOper(iStabM(i)),i=0,nStabM-1),')'
      write(u6,'(10A)') ' {O}=(',(ChOper(iStabO(i)),i=0,nStabO-1),')'
      write(u6,'(10A)') ' {T}=(',(ChOper(iDCRT(i)),i=0,nDCRT-1),')'
#     endif

      ! Compute normalization factor due the DCR symmetrization
      ! of the two basis functions and the operator.

      iuv = dc(mdci)%nStab*dc(mdcj)%nStab
      FactNd = real(iuv*nStabO,kind=wp)/real(nIrrep**2*LmbdT,kind=wp)
      if (MolWgh == 1) then
        FactNd = FactNd*real(nIrrep**2,kind=wp)/real(iuv,kind=wp)
      else if (MolWgh == 2) then
        FactNd = sqrt(real(iuv*nStabO,kind=wp)/real(nIrrep*LmbdT,kind=wp))
      end if

      do lDCRT=0,nDCRT-1
        nOp(1) = NrOpr(iDCRT(lDCRT))
        nOp(2) = NrOpr(ieor(iDCRT(lDCRT),iDCRR(lDCRR)))
        nOp(3) = NrOpr(0)

        call OA(iDCRT(lDCRT),A,TA)
        call OA(iDCRT(lDCRT),RB,TRB)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,/,3(3F6.2,2X))') ' *** Centers A, B, C ***',(TA(i),i=1,3),(TRB(i),i=1,3)
        write(u6,*) ' nOp=',nOp
#       endif

        ! Desymmetrize the matrix with which we will contract the trace.

        call DesymD(iSmLbl,iAng,jAng,iCmp,jCmp,iShell,jShell,iShll,jShll,iAO,jAO,DAO,iPrim,jPrim,DSOp,nSO,nOp,FactNd)

        ! Project the spherical harmonic space onto the cartesian space.

        kk = nTri_Elem1(iAng)*nTri_Elem1(jAng)
        if (Shells(iShll)%Transf .or. Shells(jShll)%Transf) then

          ! ij,AB --> AB,ij
          call DGeTmO(DAO,iPrim*jPrim,iPrim*jPrim,iCmp*jCmp,Scrt1,iCmp*jCmp)
          ! AB,ij --> ij,ab
          call SphCar(Scrt1,iCmp*jCmp,iPrim*jPrim,Scrt2,nScr2,RSph(ipSph(iAng)),iAng,Shells(iShll)%Transf,Shells(iShll)%Prjct, &
                      RSph(ipSph(jAng)),jAng,Shells(jShll)%Transf,Shells(jShll)%Prjct,DAO,kk)
        end if
#       ifdef _DEBUGPRINT_
        call RecPrt(' Decontracted FD in the cartesian space',' ',DAO,iPrim*jPrim,kk)
#       endif

        ! Compute kappa and P.

        call Setup1(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,TA,TRB,Kappa,PCoor,ZInv)

        ! Compute primitive potential integrals and trace with density

        call potintd(Zeta,ZInv,Kappa,PCoor,iPrim*jPrim,iAng,jAng,TA,TRB,Kern,MemKer,rFinal,lFinal,nDAO,Ccoor,pot,ngrid,ncmp,DAO, &
                     nOrdOp)

      end do
    end do

    call mma_deallocate(Kern)
    call mma_deallocate(rFinal)
    call mma_deallocate(Scrt1)
    call mma_deallocate(Scrt2)
    call mma_deallocate(DAO)
    call mma_deallocate(DSOp)
  end do
end do
if (nOrdOp == 2) then
  ! modifify field gradients to get traceless form
  do igeo=1,ngrid
    XX = Two*pot(1,igeo)-pot(4,igeo)-pot(6,igeo)
    YY = Two*pot(4,igeo)-pot(1,igeo)-pot(6,igeo)
    ZZ = Two*pot(6,igeo)-pot(4,igeo)-pot(1,igeo)
    pot(1,igeo) = XX*ThreeI
    pot(4,igeo) = YY*ThreeI
    pot(6,igeo) = ZZ*ThreeI
  end do
end if

call mma_deallocate(Zeta)
call mma_deallocate(ZInv)
call mma_deallocate(Kappa)
call mma_deallocate(PCoor)

return

end subroutine Drv1_Pot

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine dirdiag_cvb(ddasonc,ddsol,
     >  ddres,ddres2upd,ddrestart,
     >  c,axc,sxc,share,vec,res,rhs,
     >  ap,rhsp,solp,solp_res,
     >  symm,use_a,use_rhs,maxdav,n,nprmdim,
     >  nvguess,nvrestart,isaddle,ifollow,mxiter,
     >  resthr,orththr,nortiter,corenrg,
     >  ioptc,iter,fx,ip)
c  *********************************************************************
c  *                                                                   *
c  *  Routine for "direct" diagonalization.                            *
c  *                                                                   *
c  *  Uses the following functions:                                    *
c  *                                                                   *
c  *  "External" :                                                     *
c  *     DDASonC:    Apply A and S onto vector(s)                      *
c  *     DDSOL:      Solve linear equation in Davidson subspace        *
c  *     DDRES:      From solution, evaluate residual vector           *
c  *     DDRES2UPD:  Convert residual into next Davidson vector        *
c  *     DDRESTART:  Restart when Davidson dimension becomes max       *
c  *                                                                   *
c  *  Other :                                                          *
c  *     ABEND:      Error exit                                        *
c  *     FMOVE:      Vector copy                                       *
c  *     FZERO:      Vector zero                                       *
c  *     MXATB:      Matrix multiply                                   *
c  *     DAXPY:      Level 1 BLAS                                      *
c  *     DDOT:       Level 1 BLAS                                      *
c  *     DNRM2:      Level 1 BLAS                                      *
c  *     DSCAL:      Level 1 BLAS                                      *
c  *                                                                   *
c  *  If no metric is used (S=1), C and SxC may share memory. If they  *
c  *  do, SHARE should be set true.                                    *
c  *                                                                   *
c  *  IFOLLOW controls root selecting :                                *
c  *                                                                   *
c  *     IFOLLOW=1   Maximization                                      *
c  *     IFOLLOW=2   Minimization                                      *
c  *     IFOLLOW=3   Overlap-based root following                      *
c  *     IFOLLOW=4   Eigenvalue-based root following                   *
c  *                                                                   *
c  *  For IFOLLOW=1 the root chosen will be number ISADDLE+1 from the  *
c  *  end, for IFOLLOW=2, number ISADDLE+1 from the beginning.         *
c  *                                                                   *
c  *  IOPTC is optimization control :                                  *
c  *                                                                   *
c  *     IOPTC=-3    Opt. terminated close to convergence (at request) *
c  *     IOPTC=-2    Optimization failed -- too small step size        *
c  *     IOPTC=-1    Maximum number of iterations used                 *
c  *     IOPTC= 0    Converged                                         *
c  *     IOPTC= 1    Not complete                                      *
c  *                                                                   *
c  *  NVRESTART on entry: the number of Davidson vectors in a "restart"*
c  *  run. These are assumed to be obtained from a previous call to    *
c  *  DIRDIAG, and the relevant C, AxC, SxC, AP and RHSP quantities    *
c  *  must be unchanged.                                               *
c  *                                                                   *
c  *  NVRESTART on exit: the final dimension of the Davidson space --  *
c  *  can be used as input in a following restart run.                 *
c  *                                                                   *
c  *  NVGUESS represents the total number of guess vectors (thus       *
c  *  NVGUESS>=NVRESTART).                                             *
c  *                                                                   *
c  *********************************************************************
      implicit real*8 (a-h,o-z)
#include "formats_cvb.fh"
      logical share,is_converged,symm,use_a,use_rhs
      external ddasonc,ddsol,ddres,ddres2upd,ddrestart
      dimension c(n,maxdav),axc(n,maxdav),sxc(n,maxdav),vec(n),res(n)
      dimension rhs(n)
      dimension ap(maxdav,maxdav)
      dimension rhsp(maxdav)
      dimension solp(maxdav),solp_res(maxdav)
      save zero,one
      data zero/0d0/,one/1d0/

      e1=zero

      if(ip.ge.2)then
        write(6,'(/,a)')' Starting Davidson optimization.'
        write(6,'(a)')' -------------------------------'
      endif
      if(ip.ge.1)
     >  write(6,'(a,i5)')' Maximum dimension of Davidson subspace:',
     >  maxdav

      nroot=max(1,isaddle+1)
      ifail=-1
      if(ifollow.le.2.and.maxdav.lt.max(nroot,min(2*nroot,nprmdim)))then
        ifail=max(nroot,min(2*nroot,nprmdim))
      elseif(maxdav.lt.min(2,nprmdim))then
        ifail=min(2,nprmdim)
      endif
      if(ifail.ne.-1)then
        write(6,'(a)')' Davidson dimension too small!'
        write(6,'(a,i3,a)')' Need storage for at least',
     >    ifail,' vectors.'
        call abend_cvb()
      endif

      do 100 ivres=1,nvrestart
      if(use_a)then
        do 200 i=1,ivres
        ap(i,ivres)=ddot_(n,c(1,i),1,axc(1,ivres),1)
        if(.not.symm)then
          ap(ivres,i)=ddot_(n,c(1,ivres),1,axc(1,i),1)
        else
          ap(ivres,i)=ap(i,ivres)
        endif
200     continue
      endif
      if(use_rhs)rhsp(ivres)=ddot_(n,c(1,ivres),1,rhs,1)
100   continue

      iter=0
c  MXITER max possible no of macro iterations, normally opt will skip
      do 1000 imacro=1,mxiter
      do 1100 itdav=max(nvrestart,1),min(maxdav,mxiter-iter)
      if(itdav.gt.nvrestart)then
        iter=iter+1
c  Ensure accurate orthogonalization :
        facn=dnrm2_(n,c(1,itdav),1)
        do 1300 iorth=1,nortiter
        call dscal_(n,one/facn,c(1,itdav),1)
        call schmidtd2_cvb(c,sxc,itdav-1,c(1,itdav),1,n)
        call ddproj_cvb(c(1,itdav),n)
        facn=dnrm2_(n,c(1,itdav),1)
        if(abs(one-facn).lt.orththr)goto 1400
1300    continue
        write(6,*)' Not able to achieve orthonormality in max number',
     >    ' of attempts:',nortiter
        call abend_cvb()
1400    call dscal_(n,one/facn,c(1,itdav),1)

        call ddasonc(c(1,itdav),axc(1,itdav),sxc(1,itdav),1,n)

        facn=sqrt(ddot_(n,c(1,itdav),1,sxc(1,itdav),1))
        call dscal_(n,one/facn,c(1,itdav),1)
        if(.not.share)call dscal_(n,one/facn,sxc(1,itdav),1)
        if(use_a)call dscal_(n,one/facn,axc(1,itdav),1)

        if(use_a)then
          do 1500 i=1,itdav
          ap(i,itdav)=ddot_(n,c(1,i),1,axc(1,itdav),1)
          if(.not.symm)then
            ap(itdav,i)=ddot_(n,c(1,itdav),1,axc(1,i),1)
          else
            ap(itdav,i)=ap(i,itdav)
          endif
1500      continue
        endif
      endif
      if(use_rhs)rhsp(itdav)=ddot_(n,c(1,itdav),1,rhs,1)

      call ddsol(ap,rhsp,itdav,maxdav,nprmdim,solp,solp_res,eig,eig_res)

      if(ip.ge.2)write(6,formAF)' Optimal eigenvalue :',eig+corenrg
      if(e1.eq.zero)e1=eig

      if(ip.ge.3.or.(n.le.100.and.ip.eq.2))then
        write(6,'(a)')' Current vector :'
        call vecprint_cvb(c(1,itdav),n)
      endif
      if(.not.(itdav.lt.nvguess))then
        call ddres(axc,sxc,rhs,res,solp_res,maxdav,n,itdav,eig_res,
     >    is_converged)

        call ddproj_cvb(res,n)
        if(is_converged)then
          resnrm=dnrm2_(n,res,1)
          is_converged=(resnrm.lt.resthr)
        endif
        if(is_converged)then
          if(ip.ge.0)write(6,formAD)
     >      ' Converged ... residual norm:',resnrm
        else
          if(ip.ge.2)then
            write(6,'(a)')' '
            write(6,formAD)' Residual norm:',resnrm
            write(6,'(a)')' '
          endif
        endif
        if(ip.ge.3.or.(n.le.100.and.ip.eq.2))then
          write(6,'(a)')' Residual vector :'
          call vecprint_cvb(res,n)
        endif
        if(is_converged)then
          ioptc=0
          goto 1200
        endif
        if(itdav.le.maxdav-1)call ddres2upd(res,c(1,itdav+1),n)
      endif
1100  continue
      if(iter.ge.mxiter)then
        if(ip.ge.0)write(6,'(2a,i5,a)')' Davidson optimization ',
     >    'not converged in ',mxiter,' iterations'
        ioptc=-1
        goto 1200
      endif
      call ddrestart(c,axc,vec,
     >  ap,solp,
     >  maxdav,n,
     >  nvguess,nvrestart)
1000  continue
1200  continue
      ndavvec=min(itdav,maxdav)
      call mxatb_cvb(c,solp,n,ndavvec,1,vec)

      if(ip.ge.2)write(6,formAD)
     >  ' Total eigenvalue change in Davidson :',eig-e1
      if(ip.ge.3.and.n.le.500)then
        write(6,'(a)')' Final projected solution vector :'
        call vecprint_cvb(solp,n)
        write(6,'(a)')' Final solution vector :'
        call vecprint_cvb(vec,n)
      endif
      fx=eig+corenrg
c  Prepare for restart :
      nvguess=0
      nvrestart=itdav
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2009, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine reads or writes a record from/to the runfile.           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund university, Sweden                                     *
* Written: December 2009                                               *
*                                                                      *
************************************************************************
      Subroutine gzRWRun(Lu,icXX,Data,nData,iDisk,RecTyp)
#include "runinfo.fh"
#include "runtypes.fh"
*----------------------------------------------------------------------*
* Declare arguments                                                    *
*----------------------------------------------------------------------*
      Integer       Lu
      Integer       icXX
      Character     Data(*)
      Integer       nData
      Integer       iDisk
      Integer       RecTyp
*----------------------------------------------------------------------*
* Read/write data from/to runfile.                                     *
*----------------------------------------------------------------------*
      If(RecTyp.eq.TypInt) Then
         Call c_iDaFile(Lu,icXX,Data,nData,iDisk)
      Else If(RecTyp.eq.TypDbl) Then
         Call c_dDaFile(Lu,icXX,Data,nData,iDisk)
      Else If(RecTyp.eq.TypStr) Then
         Call cDaFile(Lu,icXX,Data,nData,iDisk)
      Else If(RecTyp.eq.TypLgl) Then
         Call SysAbendMsg('gzRWRun',
     &                    'Records of logical type not implemented',
     &                    'Aborting')
      Else
         Call SysAbendMsg('gzRWRun',
     &                    'Argument RecTyp is of wrong type',
     &                    'Aborting')
      End If
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Return
*
*     This is to allow type punning without an explicit interface
      Contains
      SubRoutine c_iDaFile(Lu,iOpt,Buf,lBuf_,iDisk_)
      Use Iso_C_Binding
      Integer Lu, iOpt, lBuf_, iDisk_
      Character, Target :: Buf(*)
      Integer, Pointer :: pBuf(:)
      Call C_F_Pointer(C_Loc(Buf(1)),pBuf,[lBuf_])
      Call iDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
      Nullify(pBuf)
      End SubRoutine c_iDaFile
      SubRoutine c_dDaFile(Lu,iOpt,Buf,lBuf_,iDisk_)
      Use Iso_C_Binding
      Integer Lu, iOpt, lBuf_, iDisk_
      Character, Target :: Buf(*)
      Real*8, Pointer :: pBuf(:)
      Call C_F_Pointer(C_Loc(Buf(1)),pBuf,[lBuf_])
      Call dDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
      Nullify(pBuf)
      End SubRoutine c_dDaFile
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TR1CTL(Ovlp,HOne,Kine,CMO)
! Objective: Control section for transformation of one-electron
!            integrals (effective one electron Hamiltonian and
!            kinetic energy )

#include "intent.fh"

#ifdef _HDF5_QCM_
use hdf5_utils, only: datadim, datadim_bound, file_id, hdf5_put_data
use motra_global, only: ihdf5
#endif
use motra_global, only: BsLbl, Debug, FnOneMO, iPrint, LuOneMO, n2max, nBas, nDel, nFro, nOrb, nOrbtt, nSym, nTot1, nTot2, PotNuc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Ovlp(*), HOne(*), Kine(*)
real(kind=wp), intent(_IN_) :: CMO(*)
integer(kind=iwp) :: IDISK, ISTLT, ISYM, TCONEMO(64)
real(kind=wp) :: ECOR
real(kind=wp), allocatable :: DLT(:), DSQ(:), FLT(:), FMO(:), FSQ(:), KAO(:), KMO(:), OVP(:), TMP(:)
#ifdef _HDF5_QCM_
integer(kind=iwp) :: msym
real(kind=wp), allocatable :: writebuf(:,:)
#endif

! Initialize LUONEMO

call DANAME(LUONEMO,FNONEMO)
IDISK = 0
! Provisionally initialize ECOR to prevent false alarms from
! automatic detection of uninitialized variables.
ECOR = Zero
TCONEMO(:) = 0
call WR_MOTRA_Info(LUONEMO,1,iDisk,TCONEMO,64,ECOR,NSYM,NBAS,NORB,NFRO,NDEL,8,BSLBL,size(BSLBL)*len(BSLBL))

! Write Mo coefficients to disc

TCONEMO(1) = IDISK
call dDAFILE(LUONEMO,1,CMO,NTOT2,IDISK)

! Generate Fock-matrix for inactive orbitals
! and compute the total core energy

call mma_allocate(FLT,NTOT1,label='FLT')
call mma_allocate(DLT,NTOT1,label='DLT')
call mma_allocate(FSQ,NTOT2,label='FSQ')
call mma_allocate(DSQ,NTOT2,label='DSQ')
FLT(:) = HONE(1:NTOT1)
FSQ(:) = Zero
DLT(:) = Zero
DSQ(:) = Zero
ECOR = Zero
call FCIN(FLT,NTOT1,DLT,FSQ,DSQ,ECOR,CMO)
call mma_deallocate(DLT)
call mma_deallocate(DSQ)
call mma_deallocate(FSQ)

ECOR = POTNUC+ECOR
if ((IPRINT >= 5) .or. (DEBUG /= 0)) then
  write(u6,'(6X,A,E20.10)') 'TOTAL CORE ENERGY:',ECOR
end if

! Transform one-electron Fock matrix

call mma_allocate(FMO,NORBTT,label='FMO')
call mma_allocate(TMP,2*N2MAX,label='TMP')
FMO(:) = Zero
TMP(:) = Zero
call TRAONE_MOTRA(FLT,FMO,TMP,CMO)
if ((IPRINT >= 5) .or. (DEBUG /= 0)) then
  write(u6,'(6X,A)') 'Fock matrix in MO basis'
  ISTLT = 1
  do ISYM=1,NSYM
    if (NORB(ISYM) > 0) then
      write(u6,'(6X,A,I2)') ' symmetry species:',ISYM
      call TRIPRT(' ',' ',FMO(ISTLT),NORB(ISYM))
      ISTLT = ISTLT+NORB(ISYM)*(NORB(ISYM)+1)/2
    end if
  end do
end if

#ifdef _HDF5_QCM_
if (ihdf5 == 1) then
  msym = nsym
  !> put data to file
  datadim(1) = 1
  datadim_bound = 1
  call hdf5_put_data(file_id(1),'ecore ',datadim,ecor)
  call hdf5_put_data(file_id(1),'norbtt',datadim,norbtt)
  call hdf5_put_data(file_id(1),'nsym  ',datadim,msym)
  datadim(1) = nsym
  call mma_allocate(writebuf,nsym,3,label='writebuf')
  writebuf(:,1) = norb(1:nsym)
  writebuf(:,2) = nfro(1:nsym)
  writebuf(:,3) = ndel(1:nsym)
  call hdf5_put_data(file_id(1),'norb  ',datadim,writebuf(1,1))
  call hdf5_put_data(file_id(1),'nfro  ',datadim,writebuf(1,2))
  call hdf5_put_data(file_id(1),'ndel  ',datadim,writebuf(1,3))
  call mma_deallocate(writebuf)
  datadim(1) = norbtt
  call hdf5_put_data(file_id(1),'FockMO',datadim,fmo)
end if
#endif

TCONEMO(2) = IDISK
call dDAFILE(LUONEMO,1,FMO,NORBTT,IDISK)
call mma_deallocate(FMO)
call mma_deallocate(FLT)

! Transform kinetic energy matrix

call mma_allocate(KAO,NTOT1,label='KAO')
call mma_allocate(KMO,NORBTT,label='KMO')
KAO(:) = KINE(1:NTOT1)
KMO(:) = Zero
TMP(:) = Zero
call TRAONE_MOTRA(KAO,KMO,TMP,CMO)
if ((IPRINT >= 5) .or. (DEBUG /= 0)) then
  write(u6,'(6X,A)') 'Kinetic integrals in MO basis'
  ISTLT = 1
  do ISYM=1,NSYM
    if (NORB(ISYM) > 0) then
      write(u6,'(6X,A,I2)') ' symmetry species:',ISYM
      call TRIPRT(' ',' ',KMO(ISTLT),NORB(ISYM))
      ISTLT = ISTLT+NORB(ISYM)*(NORB(ISYM)+1)/2
    end if
  end do
end if
TCONEMO(3) = IDISK
call dDAFILE(LUONEMO,1,KMO,NORBTT,IDISK)
call mma_deallocate(KAO)
call mma_deallocate(KMO)
call mma_deallocate(TMP)

! Copy overlap matrix to luonem

call mma_allocate(OVP,NTOT1,label='OVP')
OVP(:) = OVLP(1:NTOT1)
TCONEMO(4) = IDISK
call dDAFILE(LUONEMO,1,OVP,NORBTT,IDISK)
call mma_deallocate(OVP)

! Create CIDATA and molecular orbital sections on LUONEM

TCONEMO(5) = IDISK
IDISK = 0
call WR_MOTRA_Info(LUONEMO,1,iDisk,TCONEMO,64,ECOR,NSYM,NBAS,NORB,NFRO,NDEL,8,BSLBL,size(BSLBL)*len(BSLBL))
call DACLOS(LUONEMO)

call mma_deallocate(BSLBL)

return

end subroutine TR1CTL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PtGLbl(H0,Ovlp,RR,nSize,Temp,nTemp)
*
************************************************************************
*                                                                      *
*     Objective: Construct the modified Hamiltonian,                   *
*                i.e., add any perturbation defined by the GLBL input  *
*                                                                      *
************************************************************************
*
      Implicit Real*8 ( A-H,O-Z )
*

#include "input.fh"
*
      Real*8 H0(nSize), Ovlp(nSize), RR(nSize), Temp(nTemp)
      Character*8 Label
      Character*20 PriLbl
      Logical Debug,Exec
      Data    Debug/.false./
      Dimension idum(1)
*
*----------------------------------------------------------------------*
*                                                                      *
*     Start procedure                                                  *
*     Check if the command has been specified on input                 *
*                                                                      *
*----------------------------------------------------------------------*
*
*
      Exec=.false.
      Exec=Exec.or.ComStk(3,0,0,0)
      If ( .not.Exec ) then
         Return
      End If
*
*----------------------------------------------------------------------*
*     Loop over all components and add constributions to the           *
*     one-electron Hamiltonian                                         *
*----------------------------------------------------------------------*
*
      Do iLbl=1,mLbl
         Label=gLblN(iLbl)
         iComp=gLblC(iLbl)
         Alpha=gLblW(iLbl)
         If ( Debug ) Then
           Write(6,'(6X,5A,I2,2A,G9.2)')
     &     'GLBL    ',
     &     'label  ="',gLblN(iLbl),'",',
     &     'comp   =',gLblC(iLbl),',',
     &     'weight =',gLblW(iLbl)
         End If
         iRc=-1
         iOpt1=1
         iOpt2=2
         iSyLbl=0
         Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
         nInts=idum(1)
         If ( iRc.ne.0 ) Goto 991
         Call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
         If ( iRc.ne.0 ) Goto 991
         Call CmpInt(Temp,nInts,nBas,nSym,iSyLbl)
         If ( Debug ) Then
           PriLbl=Label//'; Comp =    '
           Write(PriLbl(19:20),'(I2)') iComp
           Call PrDiOp(PriLbl,nSym,nBas,Temp)
         End If
         call daxpy_(nInts,Alpha,Temp,1,H0,1)
         H0(nInts+4)=H0(nInts+4)-Alpha*Temp(nInts+4)
      End Do
*
*----------------------------------------------------------------------*
*     Normal Exit                                                      *
*----------------------------------------------------------------------*
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(Ovlp)
        Call Unused_real_array(RR)
      End If
*
*----------------------------------------------------------------------*
*     Error Exit                                                       *
*----------------------------------------------------------------------*
*
991   Write (6,*) 'PtGlbl: Error reading ONEINT'
      Write (6,'(A,A)') 'Label=',Label
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Igor Schapiro                                    *
!***********************************************************************
!
! *********************************************************************
! *                                                                   *
! * First part of the velocity Verlet algorithm, which calculates the *
! * new positions for the next time step and the new velocities for   *
! * a half time step. The algorithm is based on the example F4 from   *
! * molecular dynamics bible of Allen and Tildesley.                  *
! *                                                                   *
! * 15/10/2006                                                        *
! * Igor Schapiro                                                     *
! *                                                                   *
! *********************************************************************

subroutine VelVer_First(irc)

#ifdef _HDF5_
use mh5, only: mh5_put_dset
use Dynamix_Globals, only: dyn_geom, dyn_time, dyn_vel
#endif
use Dynamix_Globals, only: DT, iPrint, PIN, POUT, THERMO, USUAL, INSANE
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Angstrom, Zero, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: natom, natom2, i, j, filenum
real(kind=wp) :: DT_2, DTSQ2, Ekin, time, totimpl, RMS
character(len=15) :: caption
character(len=80) :: lastline, filename
logical(kind=iwp) :: hybrid, qmmm
real(kind=wp), allocatable :: Coord(:), vel(:), xyz(:), force(:), Mass(:), tstxyz(:), force2(:), xyz2(:)
character(len=2), allocatable :: atom(:), atom2(:)
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

if (IPRINT == INSANE) write(u6,*) ' Entering VelVer_First'

write(u6,*) '*** First step of the Velocity Verlet algorithm ***'

! Check for QM/MM calculation

filename = 'comqum.dat'
call F_INQUIRE(filename,hybrid)
hybrid = .false.

! Read atom, their coordinates and forces

if (hybrid) then
  write(u6,'(/,5X,A)') 'Perform QM/MM Molecular Dynamics'
  call DxRdNAtomHbrd(natom)
else
  call DxRdNAtomStnd(natom)
end if

call mma_allocate(vel,natom*3)
call mma_allocate(xyz,natom*3)
call mma_allocate(force,natom*3)
call mma_allocate(tstxyz,natom*3)
call mma_allocate(Mass,natom)
call mma_allocate(atom,natom)

if (hybrid) then
  call DxRdHbrd(natom,atom,xyz,force)
else
  call DxRdStnd(natom,atom,xyz,force)
end if
call Get_dScalar('MD_time',time)

! Read the velocities
call Get_Velocity(vel,3*natom)

! Initialize the Mass variable
call GetMassDx(Mass,natom)

! Check if reduced dimensionality
if (POUT /= 0) then
  call project_out_for(force,natom)
else if (PIN /= natom*3) then
  call project_in_for(force,natom)
end if
!--------------------------------------------------------------------C
! CANONICAL ENSEMBLE
!--------------------------------------------------------------------C
if (THERMO == 2) then
  call NhcThermo(vel)
end if
!--------------------------------------------------------------------C
! Write out the old coordinates

call DxRdNAtomStnd(natom2)
call mma_allocate(xyz2,natom*3)
call mma_allocate(force2,natom*3)
call mma_allocate(atom2,natom)
call DxRdStnd(natom2,atom2,xyz2,force2)
!if (iPrint > VERBOSE) then
caption = 'Old Coordinates'
lastline = ''
call DxPtTableCo(caption,time,natom2,atom2,xyz2,lastline,Mass,force)
!end if

!Definition of the time step

DT_2 = DT/Two
DTSQ2 = DT*DT_2

Ekin = Zero
RMS = Zero
totimpl = Zero

do i=1,natom
  do j=1,3
    !** Root mean square deviation ****************************
    tstxyz(3*(i-1)+j) = xyz(3*(i-1)+j)
    !**********************************************************
    xyz(3*(i-1)+j) = xyz(3*(i-1)+j)+DT*vel(3*(i-1)+j)+DTSQ2*force(3*(i-1)+j)/Mass(i)
    !**********************************************************
    RMS = RMS+(tstxyz(3*(i-1)+j)-xyz(3*(i-1)+j))**2
    !**********************************************************
    Ekin = Ekin+Half*Mass(i)*(vel(3*(i-1)+j)**2)
    vel(3*(i-1)+j) = vel(3*(i-1)+j)+DT_2*force(3*(i-1)+j)/Mass(i)
    totimpl = totimpl+vel(3*(i-1)+j)*Mass(i)
  end do
end do

! Check if reduced dimensionality (should not be needed)
if (POUT /= 0) then
  call project_out_vel(vel,natom)
else if (PIN /= natom*3) then
  call project_in_vel(vel,natom)
end if

call Add_Info('EKin',[EKin],1,6)

RMS = sqrt(RMS/natom)

! Update the Link-Atom position
! (Temporary solution uses Coord instead of xyz)

qmmm = .false.
call DecideOnESPF(qmmm)
if (qmmm) then
  call mma_allocate(Coord,3*natom,'Coordinates')
  call dcopy_(3*natom,xyz,1,Coord,1)
  call LA_Morok(natom,Coord,2)
  call dcopy_(3*natom,Coord,1,xyz,1)
  call mma_deallocate(Coord)
end if

! Output

if (iPrint >= USUAL) then
  write(u6,400) 'Molecular Dynamics specifications (time = ',time,' a.u.)'
  write(u6,'(5X,A,/)') '=========================================='
  write(u6,402) 'Kinetic energy',Ekin,'a.u.'
  write(u6,405) 'Total linear momentum ',totimpl,'a.u.'
  write(u6,402) 'RMS deviation ',RMS,'Bohr'
end if

time = time+DT

! Set the initialization flag and save the current time-value

call Put_dScalar('MD_Time',time)
#ifdef _HDF5_
call mh5_put_dset(dyn_time,time)
#endif

! Write out the new coordinates

caption = 'New Coordinates'
lastline = ''
call DxPtTableCo(caption,time,natom,atom,xyz,lastline,Mass,force)

! Write coordinates to output file

!#ifdef _DEBUGPRINT_
!write(u6,*) ' Dynamix calls 2 DxCoord.'
!#endif
call DxCoord(natom,atom,xyz,hybrid)
!#ifdef _DEBUGPRINT_
!write(u6,*) ' Dynamix back from 2 DxCoord.'
!#endif

! Save the new coordinates

if (hybrid) then
  call dscal_(natom*3,Angstrom,xyz,1)
  filenum = IsFreeUnit(81)
  filename = 'prmcrd2'
  call Molcas_Open(filenum,filename)
  write(filenum,403) natom
  write(filenum,404) (xyz(i),i=1,natom*3)
  close(filenum)
else
  call Put_Coord_Full(xyz,natom)
# ifdef _HDF5_
  call mh5_put_dset(dyn_geom,xyz)
# endif
end if

call Put_Velocity(vel,3*natom)
#ifdef _HDF5_
call mh5_put_dset(dyn_vel,vel)
#endif

call mma_deallocate(vel)
call mma_deallocate(xyz)
call mma_deallocate(force)
call mma_deallocate(tstxyz)
call mma_deallocate(Mass)
call mma_deallocate(atom)
call mma_deallocate(xyz2)
call mma_deallocate(force2)
call mma_deallocate(atom2)

! The return code is set in order to continue the loop

irc = _RC_ALL_IS_WELL_

return

400 format(5x,a,f8.1,a)
402 format(5x,a14,8x,d11.4,1x,a)
403 format(/,i5)
404 format(6f12.7)
405 format(5x,a22,d11.4,1x,a)

end subroutine VelVer_First

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine BPut(EVec,nDim,BMx,nX,Smmtrc,nQQ,Degen)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 EVec(nDim,nQQ), BMx(nX,nQQ), Degen(nX)
      Logical Smmtrc(nX)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      iDim=0
      Do iX = 1, nX
         If (Smmtrc(iX)) Then
            iDim=iDim+1
            Do iQQ= 1, nQQ
               BMx(iX,iQQ)=EVec(iDim,iQQ)/Sqrt(Degen(iX))
            End Do
         Else
            Do iQQ = 1, nDim
               BMx(iX,iQQ)=Zero
            End Do
         End If
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('BPut: BMx',' ',BMx,nX,nQQ)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine getdxp_cvb(dxp,gradp,heigval,nnegeig,npr,alfa)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nnegeig, npr
real(kind=wp), intent(out) :: dxp(npr)
real(kind=wp), intent(in) :: gradp(npr), heigval(npr), alfa

dxp(1:nnegeig) = -gradp(1:nnegeig)/(heigval(1:nnegeig)-alfa)
dxp(nnegeig+1:) = -gradp(nnegeig+1:)/(heigval(nnegeig+1:)+alfa)

return

end subroutine getdxp_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992,1999, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drv2_RF(llOper,Ccoor,nOrdOp,Fldxyz,lMax,h0,nh0)
************************************************************************
*                                                                      *
* Object: to compute the one-electron integrals. The method employed at*
*         this point is not necessarily the fastest. However, the total*
*         time for the computation of integrals will depend on the time*
*         spent in computing the two-electron integrals.               *
*         The memory at this point is assumed to be large enough to do *
*         the computation in core.                                     *
*         The data is structured with respect to four indices, two (my *
*         ny or i j) refer to primitives or basis functions and two (a *
*         b) refer to the components of the cartesian or spherical     *
*         harmonic gaussians.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*             Modified for Hermite-Gauss quadrature November '90       *
*             Modified for Rys quadrature November '90                 *
*             Modified for multipole moments November '90              *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for general kernel routines January  91         *
*             Modified for nonsymmetrical operators February  91       *
*             Modified to reaction field calculations July  92         *
*             Modified loop structure April  99                        *
************************************************************************
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Temporary_parameters, only: PrPrt
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "angtp.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "nsd.fh"
#include "setup.fh"
      Real*8 A(3), B(3), Ccoor(3),
     &       Fldxyz((lMax+1)*(lMax+2)*(lMax+3)/6), h0(nh0)
      Character ChOper(0:7)*3
      Integer   nOp(2), iStabO(0:7),
     &          iDCRR(0:7), iDCRT(0:7), iStabM(0:7)
      Logical AeqB
      Real*8, Allocatable:: Zeta(:), ZI(:), Kappa(:), PCoor(:,:)
      Real*8, Allocatable:: Kern(:), Fnl(:,:), Scr1(:), Scr2(:),
     &                      SO_Int(:)
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement functions
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 212
      iPrint = nPrint(iRout)
      If (iPrint.ge.19) Then
         Write (6,*) ' In Drv2_RF: llOper'
         Write (6,'(1X,8I5)') llOper
         Write (6,*) ' In Drv2_RF: n2Tri'
         Write (6,'(1X,8I5)')  n2Tri(llOper)
      End If
*
*
      Call SOS(iStabO,nStabO,llOper)
*
*     Auxiliary memory allocation.
*
      Call mma_allocate(Zeta,S%m2Max,Label='Zeta')
      Call mma_allocate(ZI,S%m2Max,Label='ZI')
      Call mma_allocate(Kappa,S%m2Max,Label='Kappa')
      Call mma_allocate(PCoor,S%m2Max,3,Label='PCoor')
*                                                                      *
************************************************************************
*                                                                      *
      Call Nr_Shells(nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*-----Double loop over shells. These loops decide the integral type
*
      Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         If (Shells(iShll)%Aux) Go To 100
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         Do jS = 1, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
*
            iSmLbl=llOper
            If (Prprt) iSmLbl=iAnd(1,iSmLbl)
            nSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            If (iPrint.ge.29) Write (6,*) ' nSO=',nSO
            If (nSO.eq.0) Go To 131
*
            If (iPrint.ge.19) Write (6,'(A,A,A,A,A)')
     &        ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
*
*           Call kernel routine to get memory requirement. Observe, however
*           that kernels which will use the HRR will allocate that
*           memory internally.
*
            Call RFMem(nOrder,MemKer,iAng,jAng,nOrdOp)
*           Write(*,*)nOrder,MemKer,iAng,jAng,nOrdOp
            MemKrn=MemKer*S%m2Max
            Call mma_allocate(Kern,MemKrn,Label='Kern')
*
*           Allocate memory for the final integrals all in the
*           primitive basis.
            nComp = (lMax+1)*(lMax+2)*(lMax+3)/6
            lFinal = S%MaxPrm(iAng) * S%MaxPrm(jAng) *
     &               nElem(iAng)*nElem(jAng)
            Call mma_allocate(Fnl,lFinal,nComp+1,Label='Fnl')
*
*           Scratch area for contraction step
*
            nScr1 =  Max(S%MaxPrm(iAng),S%MaxPrm(jAng)) *
     &               Max(S%MaxBas(iAng),S%MaxBas(jAng)) *
     &               nComp*nElem(iAng)*nElem(jAng)
            Call mma_allocate(Scr1,nScr1,Label='Scr1')
*
*           Scratch area for the transformation to spherical gaussians
*
            nScr2=nComp*S%MaxBas(iAng)*S%MaxBas(jAng)
     &           *nElem(iAng)*nElem(jAng)
            Call mma_allocate(Scr2,nScr2,Label='Scr2')
*
*           At this point we can compute Zeta.
*           This is now computed in the ij or ji order.
*
            Call ZXia(Zeta,ZI,iPrim,jPrim,Shells(iShll)%Exp,
     &                                    Shells(jShll)%Exp)
*
            AeqB = iS.eq.jS
*
*           Allocate memory for SO integrals that will be generated by
*           this batch of AO integrals.
*
            Call mma_allocate(SO_Int,nSO*iBas*jBas,Label='SO')
            SO_Int(:)=Zero
*
*           Find the DCR for A and B
*
            Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &                     dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
*
*           Find the stabilizer for A and B
*
            Call Inter(dc(mdci)%iStab,dc(mdci)%nStab,
     &                 dc(mdcj)%iStab,dc(mdcj)%nStab,
     &                 iStabM,nStabM)
*
*           Find the DCR for M and S
*
            Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
            If (iPrint.ge.19) Then
               Write (6,*)
               Write (6,*) ' g      =',nIrrep
               Write (6,*) ' u      =',dc(mdci)%nStab
               Write (6,'(9A)') '(U)=',(ChOper(dc(mdci)%iStab(ii)),
     &               ii = 0, dc(mdci)%nStab-1)
               Write (6,*) ' v      =',dc(mdcj)%nStab
               Write (6,'(9A)') '(V)=',(ChOper(dc(mdcj)%iStab(ii)),
     &               ii = 0, dc(mdcj)%nStab-1)
               Write (6,*) ' LambdaR=',LmbdR
               Write (6,*) ' r      =',nDCRR
               Write (6,'(9A)') '(R)=',(ChOper(iDCRR(ii)),
     &               ii = 0, nDCRR-1)
               Write (6,*) ' m      =',nStabM
               Write (6,'(9A)') '(M)=',(ChOper(iStabM(ii)),
     &               ii = 0, nStabM-1)
               Write (6,*) ' s      =',nStabO
               Write (6,'(9A)') '(S)=',(ChOper(iStabO(ii)),
     &               ii = 0, nStabO-1)
               Write (6,*) ' LambdaT=',LmbdT
               Write (6,*) ' t      =',nDCRT
               Write (6,'(9A)') '(R)=',(ChOper(iDCRT(ii)),
     &               ii = 0, nDCRT-1)
            End If
*
*           Compute normalization factor
*
            iuv = dc(mdci)%nStab*dc(mdcj)%nStab
            Fact = DBLE(iuv*nStabO) / DBLE(nIrrep**2 * LmbdT)
            If (MolWgh.eq.1) Then
               Fact = Fact * DBLE(nIrrep)**2 / DBLE(iuv)
            Else If (MolWgh.eq.2) Then
               Fact = Sqrt(DBLE(iuv))*DBLE(nStabO)/DBLE(nIrrep*LmbdT)
            End If
*
*           Loops over symmetry operations.
*
            Do 139 lDCRT = 0, nDCRT-1
            Call OA(iDCRT(lDCRT),dbsc(iCnttp)%Coor(1:3,iCnt),A)
            nOp(1) = NrOpr(iDCRT(lDCRT))
            if(jbas.lt.-99999) write(6,*) 'nDCRR=',nDCRR
            Do 140 lDCRR = 0, nDCRR-1
             iDCRRT=iEor(iDCRR(lDCRR),iDCRT(lDCRT))
             Call OA(iDCRRT,dbsc(jCnttp)%Coor(1:3,jCnt),B)
             nOp(2) = NrOpr(iEor(iDCRT(lDCRT),iDCRR(lDCRR)))
             If (iPrint.ge.49) Write (6,'(A,3(3F6.2,2X))')
     &             '***** Centers A, B, & C. *****',
     &             (A(i),i=1,3),(B(i),i=1,3),(Ccoor(i),i=1,3)
*
*            Compute kappa and P.
*
             Call Setup1(Shells(iShll)%Exp,iPrim,
     &                   Shells(jShll)%Exp,jPrim,
     &                   A,B,Kappa,PCoor,ZI)
*
*            Compute primitive integrals. Result is ordered ij,ab.
*
             Call RFInt(Shells(iShll)%Exp,iPrim,
     &                  Shells(jShll)%Exp,jPrim,
     &                   Zeta,ZI,
     &                   Kappa,Pcoor,
     &                   Fnl,iPrim*jPrim,nComp,
     &                   iAng,jAng,A,B,nOrder,Kern,
     &                   MemKer,Ccoor,lMax)
             If (iPrint.ge.49)
     &          Call RecPrt(' Primitive Integrals',' ',
     &                      Fnl,iPrim*jPrim*
     &                      nElem(iAng)*nElem(jAng),nComp)
*
*-----------Accumulate contributions due to interaction between the
*           electric field and the multipole moments.
*
            nFnc=iPrim*jPrim*nElem(iAng)*nElem(jAng)
            call dcopy_(nFnc,[Zero],0,Fnl(1,nComp+1),1)
            Call DNaXpY(nComp,nFnc,Fldxyz,1,
     &                  Fnl,1,nFnc,
     &                  Fnl(1,nComp+1),1,0)
            If (iPrint.ge.99) Call RecPrt(' Solvation integrals',' ',
     &                        Fnl(1,nComp+1),iPrim*jPrim,
     &                        nElem(iAng)*nElem(jAng))
*
*
*------------Transform from primitive to contracted basis functions.
*            Order of transformation is fixed. It has been shown through
*            testing that the index order ij,ab will give a performance
*            that is up to 20% faster than the ab,ij index order.
*
             If (iPrint.ge.99) Then
                Call RecPrt(' Left side contraction',' ',
     &                      Shells(iShll)%pCff,iPrim,iBas)
                Call RecPrt(' Right side contraction',' ',
     &                      Shells(jShll)%pCff,jPrim,jBas)
             End If
*
*            Transform ij,x,ab to j,xabI
             kk=nElem(iAng)*nElem(jAng)
             Call DGEMM_('T','N',
     &                   jPrim*kk,iBas,iPrim,
     &                   1.0d0,Fnl(1,nComp+1),iPrim,
     &                         Shells(iShll)%pCff,iPrim,
     &                   0.0d0,Scr1,jPrim*kk)
*            Transform j,xabI to xab,IJ
             Call DGEMM_('T','N',
     &                   kk*iBas,jBas,jPrim,
     &                   1.0d0,Scr1,jPrim,
     &                         Shells(jShll)%pCff,jPrim,
     &                   0.0d0,Fnl(1,nComp+1),kk*iBas)
*
             If (iPrint.ge.99) Call
     &          RecPrt(' Contracted integrals in cartesians',' ',
     &                     Fnl(1,nComp+1),kk,iBas*jBas)
*
*            Transform to spherical gaussians if needed.
*
             If (Shells(iShll)%Transf.or.Shells(jShll)%Transf) Then
*
*             Result comes back as IJxAB or IJxAb
              call dcopy_(kk*iBas*jBas,Fnl(1,nComp+1),1,
     &                                Scr2,1)
              Call CarSph(Scr2,kk,iBas*jBas,
     &                    Fnl(1,nComp+1),nScr2,
     &                    RSph(ipSph(iAng)),
     &                    iAng,Shells(iShll)%Transf,
     &                         Shells(iShll)%Prjct,
     &                    RSph(ipSph(jAng)),
     &                    jAng,Shells(jShll)%Transf,
     &                         Shells(jShll)%Prjct,
     &                    Scr1,iCmp*jCmp)
             Else
*             Transpose back to IJ,x,ab
              Call DGeTmO(Fnl(1,nComp+1),kk,kk,iBas*jBas,
     &                   Scr1,iBas*jBas)
             End If
             If (iPrint.ge.99)
     &          Call RecPrt(' Contracted Integrals in Sphericals',
     &                   ' ',Scr1,iBas*jBas,iCmp*jCmp)
*
*            At this point accumulate the batch of integrals onto the
*            final symmetry adapted integrals.
*
             If (iPrint.ge.99) Then
                Call RecPrt (' Accumulated SO integrals, so far...',
     &                               ' ',SO_Int,iBas*jBas,nSO)
             End If
*
            iSmLbl=llOper
            If (Prprt) iSmLbl=iAnd(1,iSmLbl)
            mSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            nIC=1
            iIC=1
            If (mSO.ne.0)
     &         Call SymAd1(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                     iShell,jShell,iShll,jShll,
     &                     iAO,jAO,Scr1,
     &                     iBas,jBas,nIC,iIC,SO_Int,mSO,nOp)
*
 140        Continue
 139        Continue
*
*           Multiply with factors due to projection operators
*
           If (Fact.ne.One) Call DScal_(nSO*iBas*jBas,Fact,SO_Int,1)
            If (iPrint.ge.99) Then
               Write (6,*) ' Scaling SO''s', Fact
               Call RecPrt(' Final SO integrals',' ',
     &                     SO_Int,iBas*jBas,mSO)
            End If
*
*-----------Accumulate contribution to the Hamiltonian.
*
            iSmLbl=llOper
            If (Prprt) iSmLbl=iAnd(1,iSmLbl)
            Call SOAdd(SO_Int,iBas,jBas,mSO,h0,
     &                 n2Tri(iSmLbl),iSmLbl,
     &                 iCmp,jCmp,iShell,jShell,AeqB,iAO,jAO)
*
            Call mma_deallocate(SO_Int)
            Call mma_deallocate(Scr2)
            Call mma_deallocate(Scr1)
            Call mma_deallocate(Fnl)
            Call mma_deallocate(Kern)
 131        Continue
         End Do
      End Do
 100  Continue
*
      Call mma_deallocate(PCoor)
      Call mma_deallocate(Kappa)
      Call mma_deallocate(ZI)
      Call mma_deallocate(Zeta)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NEWORBTAB(IPRTTAB)

use rassi_global_arrays, only: OrbTab
use Cntrl, only: MORSBITS
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IPRTTAB(*)
integer(kind=iwp) :: I, IEXTNUM, INPART, INSBP, INSYM(8), IPAC, IPART, IPFR, IPIN, IPSE, ISMLAB, ISOIND, ISORB, ISPART, ISUM, &
                     ISYM, KOINFO, KSPART, N, NAPART, NASPO, NASPRT, NOES(8), NORBT, NPART, NSORBT, NSPART, NSYM, NTAB

ISOIND = 0 ! dummy initialize
! Executable statements
NPART = IPRTTAB(3)
NSYM = IPRTTAB(4)
! NAPART: Nr of partitions of active orbitals.
NAPART = NPART-4
! Partitions for inactive, secondary,frozen, and deleted orbitals:
IPIN = NAPART+1
IPSE = NAPART+2
IPFR = NAPART+3
! Total nr of orbitals:
NORBT = IPRTTAB(5)
NSORBT = 2*NORBT
! Table words 1--10 contain some header info.
! Table words 11--18 contain start index of each CMO symmetry block
! Table words 19-- contain info for each separate spin orbital
! Presently 8 table entries for each spin orbital.
KOINFO = 19
! Table words 19+8*NSORBT-- contain nr of sp-orbs for each subpartition
KSPART = 19+8*NSORBT
! Nr of sub-partitions:
NSPART = 0
do IPART=1,NPART
  N = 2*IPRTTAB(5+(NSYM+1)*IPART)
  if (N > 0) NSPART = NSPART+(N+MORSBITS-1)/MORSBITS
end do
NTAB = KSPART+NSPART-1
! Allocate the orbital table.
call mma_allocate(ORBTAB,NTAB,Label='OrbTab')
OrbTab(1) = NTAB
OrbTab(2) = 1
OrbTab(3) = NSORBT
! Nr of active spin-orbitals:
ISUM = 0
do IPART=1,NAPART
  ISUM = ISUM+IPRTTAB(5+(NSYM+1)*IPART)
end do
NASPO = 2*ISUM
OrbTab(4) = NASPO
OrbTab(5) = NSYM
OrbTab(6) = NAPART+4
! Accumulated nr of orbital functions/symm:
ISUM = 0
do ISYM=1,NSYM
  NOES(ISYM) = ISUM
  ISUM = ISUM+IPRTTAB(5+ISYM)
end do
! Relative pointers to CMO symmetry blocks:
ISUM = 0
do ISYM=1,NSYM
  OrbTab(9+ISYM) = ISUM+1
  ISUM = ISUM+IPRTTAB(5+ISYM)**2
end do
! Spin orbital number:
ISORB = 0
! First, active orbitals by partition, and by symmetry
! Previous MO indices within each symmetry.
INSYM(1:NSYM) = IPRTTAB(6+(NSYM+1)*IPFR:5+NSYM+(NSYM+1)*IPFR)+IPRTTAB(6+(NSYM+1)*IPIN:5+NSYM+(NSYM+1)*IPIN)
! Increase subpartition index as needed.
ISPART = 0
do IPART=1,NAPART
  N = IPRTTAB(5+(NSYM+1)*IPART)
  if (N == 0) cycle
  ISPART = ISPART+1
  INSBP = 0
  INPART = 0
  do ISYM=1,NSYM
    ISMLAB = ISYM
    N = IPRTTAB(5+ISYM+(NSYM+1)*IPART)
    do I=1,N
      ISOIND = 1+INSYM(ISYM)
      INSYM(ISYM) = ISOIND
      IEXTNUM = NOES(ISYM)+ISOIND
      ! Next spin orbital, with alpha spin:
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      ! Fill in table:
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = 1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
      ! Next spin orbital, same, but beta spin:
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      ! Fill in table:
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = -1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
    end do
  end do
end do
NASPRT = ISPART
! Inactive:
! Must set up start index within each symmetry.
do ISYM=1,NSYM
  INSYM(1:NSYM) = IPRTTAB(6+(NSYM+1)*IPFR:5+NSYM+(NSYM+1)*IPFR)
end do
IPART = NAPART+1
N = IPRTTAB(5+(NSYM+1)*IPART)
if (N /= 0) then
  ISPART = ISPART+1
  INPART = 0
  INSBP = 0
  do ISYM=1,NSYM
    ISMLAB = ISYM
    !N = NISH(ISYM)
    N = IPRTTAB(5+ISYM+(NSYM+1)*IPART)
    do I=1,N
      ISOIND = ISOIND+1
      IEXTNUM = NOES(ISYM)+ISOIND
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = 1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = -1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
    end do
  end do
end if
! Secondary:
IPART = NAPART+2
N = IPRTTAB(5+(NSYM+1)*IPART)
if (N /= 0) then
  ISPART = ISPART+1
  INPART = 0
  INSBP = 0
  ! Must set up start index within each symmetry.
  do ISYM=1,NSYM
    N = IPRTTAB(5+ISYM+(NSYM+1)*IPFR)
    N = N+IPRTTAB(5+ISYM+(NSYM+1)*IPIN)
    do IPAC=1,NAPART
      N = N+IPRTTAB(5+ISYM+(NSYM+1)*IPAC)
    end do
    INSYM(ISYM) = N
  end do

  do ISYM=1,NSYM
    ISMLAB = ISYM
    ISOIND = INSYM(ISYM)
    !N = NSSH(ISYM)
    N = IPRTTAB(5+ISYM+(NSYM+1)*IPART)
    do I=1,N
      ISOIND = ISOIND+1
      IEXTNUM = NOES(ISYM)+ISOIND
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = 1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = -1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
    end do
  end do
end if
! Frozen:
IPART = NAPART+3
N = IPRTTAB(5+(NSYM+1)*IPART)
if (N /= 0) then
  ISPART = ISPART+1
  INPART = 0
  INSBP = 0
  do ISYM=1,NSYM
    ISMLAB = ISYM
    !N = NFRO(ISYM)
    N = IPRTTAB(5+ISYM+(NSYM+1)*IPART)
    ISOIND = 0
    do I=1,N
      ISOIND = ISOIND+1
      IEXTNUM = NOES(ISYM)+ISOIND
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = 1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = -1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
    end do
  end do
end if
! Deleted:
IPART = NAPART+4
N = IPRTTAB(5+(NSYM+1)*IPART)
if (N /= 0) then
  ISPART = ISPART+1
  INPART = 0
  INSBP = 0
  ! Must set up start index within each symmetry.
  do ISYM=1,NSYM
    N = IPRTTAB(5+ISYM+(NSYM+1)*IPFR)
    N = N+IPRTTAB(5+ISYM+(NSYM+1)*IPIN)
    do IPAC=1,NAPART
      N = N+IPRTTAB(5+ISYM+(NSYM+1)*IPAC)
    end do
    N = N+IPRTTAB(5+ISYM+(NSYM+1)*IPSE)
    INSYM(ISYM) = N
  end do
  do ISYM=1,NSYM
    ISMLAB = ISYM
    ISOIND = INSYM(ISYM)
    !N = NDEL(ISYM)
    N = IPRTTAB(5+ISYM+(NSYM+1)*IPART)
    do I=1,N
      ISOIND = ISOIND+1
      IEXTNUM = NOES(ISYM)+ISOIND
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = 1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
      ISORB = ISORB+1
      INPART = INPART+1
      INSBP = INSBP+1
      if (INSBP > MORSBITS) then
        ISPART = ISPART+1
        INSBP = INSBP-MORSBITS
      end if
      OrbTab(KOINFO+0+(ISORB-1)*8) = IEXTNUM
      OrbTab(KOINFO+1+(ISORB-1)*8) = ISMLAB
      OrbTab(KOINFO+2+(ISORB-1)*8) = ISOIND
      OrbTab(KOINFO+3+(ISORB-1)*8) = -1
      OrbTab(KOINFO+4+(ISORB-1)*8) = IPART
      OrbTab(KOINFO+5+(ISORB-1)*8) = INPART
      OrbTab(KOINFO+6+(ISORB-1)*8) = ISPART
      OrbTab(KOINFO+7+(ISORB-1)*8) = INSBP
    end do
  end do
end if
if (ISPART /= NSPART) then
  write(u6,*) 'NEWORBTAB Error: Nr of subpartitions'
  write(u6,*) 'generated does not match number of'
  write(u6,*) 'subpartitions computed!'
  write(u6,*) 'Generated ISPART=',ISPART
  write(u6,*) 'Computed  NSPART=',NSPART
end if
OrbTab(7) = NSPART
OrbTab(8) = NAPART
OrbTab(9) = NASPRT
OrbTab(10) = KSPART
OrbTab(KSPART:KSPART+NSPART-1) = 0
do ISORB=1,NSORBT
  ISPART = OrbTab(KOINFO+6+(ISORB-1)*8)
  N = 1+OrbTab(KSPART-1+ISPART)
  OrbTab(KSPART-1+ISPART) = N
end do

end subroutine NEWORBTAB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Roland Lindh                                     *
!***********************************************************************

subroutine mk_SOs(TabSO,mAO,mGrid,nMOs,List_s,List_Bas,nList_s,jList_s)

use iSD_data, only: iSD
use Center_Info, only: dc
use Symmetry_Info, only: iChTbl, nIrrep
use SOAO_Info, only: iAOtSO
use Basis_Info, only: MolWgh, nBas
use nq_Grid, only: iBfn_Index, TabAO
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mAO, mGrid, nMOs, nlist_s, list_s(2,nlist_s), list_bas(2,nlist_s), jList_s
real(kind=wp), intent(inout) :: TabSO(mAO,mGrid,nMOs)
integer(kind=iwp) :: i1, i2, iAdd, iAO, iBfn, iIrrep, ilist_s, iMO, iOff_MO(0:7), iSh, iSO, iSO0, iSO1, itmp1, kDCRE, mBas, &
                     mBas_Eff, mdci, nBfn, nDeg, nOp
real(kind=wp) :: Fact, xa
integer(kind=iwp), external :: NrOpr

! Compute some offsets

itmp1 = 1
do iIrrep=0,nIrrep-1
  iOff_MO(iIrrep) = itmp1
  itmp1 = itmp1+nBas(iIrrep)
end do

nBfn = size(iBfn_Index,2)
do iBfn=1,nBfn
  ilist_s = iBfn_Index(2,iBfn)
  if ((jlist_s /= 0) .and. (ilist_s /= jlist_s)) cycle
  i1 = iBfn_Index(3,iBfn)
  i2 = iBfn_Index(4,iBfn)
  iSh = list_s(1,ilist_s)
  kDCRE = list_s(2,ilist_s)
  mBas_Eff = List_Bas(1,ilist_s)
  mBas = iSD(3,iSh)
  iAO = iSD(7,iSh)
  mdci = iSD(10,iSh)
  nDeg = nIrrep/dc(mdci)%nStab
  nOp = NrOpr(kDCRE)

  if (MolWgh == 0) then
    Fact = One/real(nDeg,kind=wp)
  else if (MolWgh == 1) then
    Fact = One
  else
    Fact = One/sqrt(real(nDeg,kind=wp))
  end if

  iAdd = mBas-mBas_Eff
  do iIrrep=0,nIrrep-1
    iSO0 = iAOtSO(iAO+i1,iIrrep)
    if (iSO0 < 0) cycle

    iMO = iOff_MO(iIrrep)

    xa = real(iChTbl(iIrrep,nOp),kind=wp)
    iSO = iSO0+i2-1
    iSO1 = iMO+iSO-1+iAdd
    TabSO(:,:,iSO1) = TabSO(:,:,iSO1)+Fact*xa*TabAO(:,:,iBfn)
  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt('mk_SOs: TabSO',' ',TabSO,mAO*mGrid,nMOs)
#endif

return

end subroutine mk_SOs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Gunnar Karlstrom                                 *
!               2000, Roland Lindh                                     *
!***********************************************************************

function Anal_Gitt(cordsi,latato)
!***********************************************************************
!                                                                      *
!     Object:                                                          *
!                                                                      *
!     Authors: G. Karlstroem                                           *
!              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
!                                                                      *
!              and                                                     *
!                                                                      *
!              R. Lindh                                                *
!              Dept. of Chem. Phys., Univ. of Lund, Sweden.            *
!                                                                      *
!              March 2000                                              *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: Anal_Gitt
integer(kind=iwp), intent(in) :: latato
real(kind=wp), intent(in) :: cordsi(3,latato)
integer(kind=iwp) :: i, j
real(kind=wp) :: faktor, gAtom, r2, x1, y1, z1

Anal_Gitt = Zero

! analyze the lattice

gatom = Zero
do i=1,latato
  faktor = One
  x1 = cordsi(1,i)+One
  y1 = cordsi(2,i)
  z1 = cordsi(3,i)
  do j=1,latato
    r2 = (x1-cordsi(1,j))**2+(y1-cordsi(2,j))**2+(z1-cordsi(3,j))**2
    if (r2 < 0.01_wp) faktor = faktor+One
  end do

  x1 = cordsi(1,i)-One
  y1 = cordsi(2,i)
  z1 = cordsi(3,i)
  do j=1,latato
    r2 = (x1-cordsi(1,j))**2+(y1-cordsi(2,j))**2+(z1-cordsi(3,j))**2
    if (r2 < 0.01_wp) faktor = faktor+One
  end do

  x1 = cordsi(1,i)
  y1 = cordsi(2,i)+One
  z1 = cordsi(3,i)
  do j=1,latato
    r2 = (x1-cordsi(1,j))**2+(y1-cordsi(2,j))**2+(z1-cordsi(3,j))**2
    if (r2 < 0.01_wp) faktor = faktor+One
  end do

  x1 = cordsi(1,i)
  y1 = cordsi(2,i)-One
  z1 = cordsi(3,i)
  do j=1,latato
    r2 = (x1-cordsi(1,j))**2+(y1-cordsi(2,j))**2+(z1-cordsi(3,j))**2
    if (r2 < 0.01_wp) faktor = faktor+One
  end do

  x1 = cordsi(1,i)
  y1 = cordsi(2,i)
  z1 = cordsi(3,i)+One
  do j=1,latato
    r2 = (x1-cordsi(1,j))**2+(y1-cordsi(2,j))**2+(z1-cordsi(3,j))**2
    if (r2 < 0.01_wp) faktor = faktor+One
  end do

  x1 = cordsi(1,i)
  y1 = cordsi(2,i)
  z1 = cordsi(3,i)-One
  do j=1,latato
    r2 = (x1-cordsi(1,j))**2+(y1-cordsi(2,j))**2+(z1-cordsi(3,j))**2
    if (r2 < 0.01_wp) faktor = faktor+One
  end do
  gatom = gatom+One/faktor
end do
Anal_Gitt = gatom

return

end function Anal_Gitt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine VpMem(nRys,MemVp,la,lb,lr)
      Integer iAngV(4)
*
      nElem(i)=(i+1)*(i+2)/2
*
      Call mHrr(la,lb+1,nFlop,nMem)
*
      nRys=(la+lb+1+lr+2)/2
      iAngV(1) = la
      iAngV(2) = lb+1
      iAngV(3) = 0
      iAngV(4) = 0
      Call MemRys(iAngV,MemNA1)
*
      MemNA1 = Max(nMem,MemNA1)
*
      If (lb.ne.0) Then
         Call mHrr(la,lb-1,nFlop,nMem)
*
         nRys=(la+lb-1+lr+2)/2
         iAngV(1) = la
         iAngV(2) = lb-1
         iAngV(3) = 0
         iAngV(4) = 0
         Call MemRys(iAngV,MemNA2)
*
         MemNA2 = Max(nMem,MemNA2)
      Else
         MemNA2=0
      End If
*
      MemVp=Max(MemNA1,MemNA2)
*
      MemVp=MemVp+1
*
      MemVp = MemVp+nElem(la)*nElem(lb+1)
      If (lb.ne.0) MemVp=MemVp+nElem(la)*nElem(lb-1)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Per Ake Malmqvist                                *
!***********************************************************************
!****************************************************************
!  PROGRAM RASSI        PER-AAKE MALMQVIST 2000-06-30
!  SUBROUTINE DIMAT
!  CONSTRUCT A DENSITY MATRIX DINAO FOR THE INACTIVE ORBITALS.
!  IT IS RETURNED IN SYMMETRY-BLOCKED SQUARED FORMAT.
!****************************************************************

subroutine DIMAT(CMO1,CMO2,DINAO)

use rassi_data, only: NCMO, NBSQ, NBASF, NISH, NOSH
use Symmetry_Info, only: nIrrep
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CMO1(NCMO), CMO2(NCMO)
real(kind=wp), intent(out) :: DINAO(NBSQ)
integer(kind=iwp) :: ISTC, ISTD, ISYM, NB, NI, NO

ISTC = 1
ISTD = 1
do ISYM=1,nIrrep
  NI = NISH(ISYM)
  NO = NOSH(ISYM)
  NB = NBASF(ISYM)
  if (NI == 0) then
    DINAO(ISTD:ISTD+NB**2-1) = Zero
  else
    call DGEMM_('N','T',NB,NB,NI,Two,CMO1(ISTC),NB,CMO2(ISTC),NB,Zero,DINAO(ISTD),NB)
  end if
  ISTC = ISTC+NO*NB
  ISTD = ISTD+NB**2
end do

end subroutine DIMAT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       FUNCTION GETH1I_MCLR(I,J)
       use Arrays, only: FIMO
*
* Obtain one -electron integral H(IORB,JOB)
*
      IMPLICIT REAL*8 (A-H,O-Z)
#include "detdim.fh"
#include "Input.fh"
#include "Pointers.fh"
#include "orbinp_mclr.fh"
*
      ISM = ISMFTO(I)
      JSM = ISMFTO(J)
      I1 = IREOTS(I)-IBSO(ISM)+nISH(ISM)+1
      J1 = IREOTS(J)-IBSO(JSM)+nISH(JSM)+1

      IJ=ipCM(iSM)-1+(J1-1)*NORB(ISM)+I1
*
      GETH1I_MCLR = FIMO(IJ)
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine multdot(wrk,wrksize,nind,a,ssa,b,ssb,scalar,rc)
! this routine does dot product
! scalar = A(ind)*B(ind)
!
! nind   - number of indices in both A B (I)
! a      - map type of A (I)
! ssa    - symmetry state of A (I)
! b      - map type of A (I)
! ssb    - symmetry state of B (I)
! scalar - final dot product (O)
! rc     - return (error) code (O)
!
! N.B. A and B must have same ordering of indices
!
! indA     indB     Implemented
! 1        1         Not yet
! 2        2           Yes
! 3        3           Yes
! 4        4           Yes
! more                 No

use ccsd_global, only: Map_Type
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, nind, ssa, ssb
real(kind=wp), intent(in) :: wrk(wrksize)
type(Map_Type), intent(in) :: a, b
real(kind=wp), intent(out) :: scalar
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: iia, iib, length, nhelp, posa, posb, symp, symq, symr
real(kind=wp) :: scal

rc = 0

!T some tests

do nhelp=1,nind
  if (a%d(0,nhelp) /= b%d(0,nhelp)) then
    ! RC =1 : nonidentical types of indices (NCI/Stup)
    rc = 1
    return
  end if
end do

if (a%d(0,5) /= b%d(0,5)) then
  ! RC =2 : nonidentical number of symmetry blocks in A and B (Stup)
  rc = 2
  return
end if

if (a%d(0,6) /= b%d(0,6)) then
  ! RC =3 : nonidentical type of A and B (Stup)
  rc = 3
  return
end if

if (ssa /= ssb) then
  ! RC =4 : nonidentical symmetry state of A and B (Stup)
  rc = 4
  return
end if

if (nind == 4) then

  !I 4 index matrices

  scalar = Zero
  do iia=1,a%d(0,5)

    !I.1 def parameters of A
    symp = a%d(iia,3)
    symq = a%d(iia,4)
    symr = a%d(iia,5)
    ! syms is redundant
    posa = a%d(iia,1)

    !I.2 def parameters of B
    iib = b%i(symp,symq,symr)
    posb = b%d(iib,1)

    !I.3 length must be common for both A and B
    length = a%d(iia,2)

    if (length > 0) then
      call mr0u3wt(length,length,length,1,1,wrk(posa),wrk(posb),scal)
      scalar = scalar+scal
    end if

  end do

else if (nind == 3) then

  !II 3 index matrices

  scalar = Zero
  do iia=1,a%d(0,5)

    !II.1 def parameters of A
    symp = a%d(iia,3)
    symq = a%d(iia,4)
    ! symr is redundant
    posa = a%d(iia,1)

    !II.2 def parameters of B
    iib = b%i(symp,symq,1)
    posb = b%d(iib,1)

    !II.3 length must be common for both A and B
    length = a%d(iia,2)

    if (length > 0) then
      call mr0u3wt(length,length,length,1,1,wrk(posa),wrk(posb),scal)
      scalar = scalar+scal
    end if

  end do

else if (nind == 2) then

  !III 2 index matrices

  scalar = Zero
  do iia=1,a%d(0,5)

    !III.1 def parameters of A
    symp = a%d(iia,3)
    ! symq is redundant
    posa = a%d(iia,1)

    !III.2 def parameters of B
    iib = b%i(symp,1,1)
    posb = b%d(iib,1)

    !III.3 length must be common for both A and B
    length = a%d(iia,2)

    if (length > 0) then
      call mr0u3wt(length,length,length,1,1,wrk(posa),wrk(posb),scal)
      scalar = scalar+scal
    end if

  end do

else if (nind == 1) then

  !IV 1 index matrices
  ! RC=5 : 1 index matrices (NCI)
  rc = 5
  return

else
  !V more than 4 index matrices
  ! RC=6 : more than 4 index matrices (NCI)
  rc = 6
  return
end if

return

end subroutine multdot

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Init_SlapAf()

use Symmetry_Info, only: iOper, nIrrep
use Slapaf_Info, only: Analytic_Hessian, ANr, ApproxNADC, Coor, Degen, dMass, Force_dB, Header, iCoSet, jStab, Line_Search, &
                       MaxItr, mB_Tot, mdB_Tot, mq, mTtAtm, MxItr, NADC, nDimBC, nStab, q_nuclear, RootMap, Smmtrc, ThrCons, &
                       ThrEne, ThrGrd, ThrMEP !, lRP, R12
#ifdef _DEBUGPRINT_
use Slapaf_Info, only: AtomLbl, Grd
#endif
use UnixInfo, only: SuperName
use dcr_mod, only: DCR_Init
use PrintLevel, only: nPrint
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: Columbus, i, iAdd(0:7), iChxyz, iComp, iIrrep, iMAX, iMode, ind, iPL, isAtom, ISPIN1, ISPIN2, itest, jCoSet, &
                     jTest, LSYM1, LSYM2, n, nCoSet, nHess, nRM, nRoots, nStb
real(kind=wp) :: tmp
logical(kind=iwp) :: Do_ESPF, Exist_2, Found, Same, Skip
character(len=8) :: CMAX
real(kind=wp), allocatable :: xMass(:)
integer(kind=iwp), external :: iDeg, iPrintLevel, iPrmt
logical(kind=iwp), external :: Reduce_Prt

!
!***********************************************************************
!************************* StartUp section   ***************************
!***********************************************************************
!                                                                      *
call DCR_Init()

! Set the default value of iterations from MOLCAS_MAXITER if it
! has been defined.

call GetEnvf('MOLCAS_MAXITER',CMAX)
!write(u6,'(3A)') 'CMAX="',CMAX,'"'
if (CMAX /= ' ') then
  read(CMAX,'(I8)') iMAX
  MxItr = min(MaxItr,iMax)
else
  MxItr = MaxItr
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call DecideOnESPF(Do_ESPF)
if (Do_ESPF) then
  ThrGrd = 0.003_wp
  ThrEne = 1.0e-5_wp
  Line_Search = .false.
else
  ThrGrd = 0.0003_wp
  ThrEne = 1.0e-6_wp
  Line_Search = .true.
end if
ThrMEP = ThrGrd
ThrCons = 1.0e10_wp
!                                                                      *
!***********************************************************************
!                                                                      *
iPL = iPrintLevel(-1)
if (iPL == 2) then
  iPL = 5
else if (iPL == 3) then
  iPL = 6
else if (iPL == 4) then
  iPL = 99
else if (iPL == 5) then
  iPL = 99
end if
nPrint(:) = iPL

! Reduced print level of Slapaf parameters after the first iteration

if (Reduce_Prt() .and. (iPL <= 5)) nPrint(:) = iPL-1

!                                                                      *
!***********************************************************************
!                                                                      *
! Get Molecular data

! Read the title

call Get_cArray('Seward Title',Header,144)

! Read number of atoms, charges, coordinates, gradients and atom labels

call Get_Molecule()
!                                                                      *
!***********************************************************************
!                                                                      *
NADC = .false.
ApproxNADC = .false.
call Get_iScalar('Columbus',Columbus)
if (Columbus == 1) then

  ! C&M mode

  call Get_iScalar('ColGradMode',iMode)
  if (iMode == 3) NADC = .true.
else

  ! M mode

  ! ISPIN should only be found for RASSCF-based
  ! methods, so no CI mode for SCF, MP2, etc. (or that's the idea)

  !write(u6,*) 'See if CI'
  call Qpg_iScalar('ISPIN',Found)
  if (Found) then
    call Get_iScalar('ISPIN',ISPIN1)
    call Get_iScalar('STSYM',LSYM1)
  else
    ISPIN1 = 0
    LSYM1 = 0
  end if
  !write(u6,*) 'iSpin=',ISPIN1
  !write(u6,*) 'stSym=',LSYM1

  call f_Inquire('RUNFILE2',Exist_2)
  !write(u6,*) 'Exist_2=',Exist_2
  if (Exist_2) then
    call NameRun('RUNFILE2')
    call Qpg_iScalar('ISPIN',Found)
    if (Found) then
      call Get_iScalar('ISPIN',ISPIN2)
      call Get_iScalar('STSYM',LSYM2)
    else
      ISPIN2 = 0
      LSYM2 = 0
    end if
    call NameRun('#Pop')
  else
    ISPIN2 = ISPIN1
    LSYM2 = LSYM1
  end if
  !write(u6,*) 'iSpin=',ISPIN1,ISPIN2
  !write(u6,*) 'stSym=',LSYM1,LSYM2

  ! Do not add the constraint at the NumGrad stage

  if (SuperName /= 'numerical_gradient') then
    if ((ISPIN1 /= 0) .and. (LSYM1 /= 0)) NADC = (ISPIN1 == ISPIN2) .and. (LSYM1 == LSYM2)
    !NADC = .false. ! for debugging
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Read or initialize the root map

call Qpg_iArray('Root Mapping',Found,nRM)
if (nRM > 0) then
  call mma_allocate(RootMap,nRM,Label='RootMap')
  call Get_iArray('Root Mapping',RootMap,nRM)
else
  call Qpg_iScalar('Number of roots',Found)
  nRoots = 1
  if (Found) call Get_iScalar('Number of roots',nRoots)
  call mma_allocate(RootMap,nRoots,Label='RootMap')
  do i=1,nRoots
    RootMap(i) = i
  end do
end if

! Check if there is an analytic Hessian
call qpg_dArray('Analytic Hessian',Analytic_Hessian,nHess)

if (.not. Analytic_Hessian) then
  call NameRun('RUNOLD')
  call qpg_dArray('Analytic Hessian',Analytic_Hessian,nHess)
  call NameRun('#Pop')
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the number of total symmetric displacements

call mma_allocate(jStab,[0,7],[1,size(Coor,2)],Label='jStab ')
call mma_allocate(nStab,[1,size(Coor,2)],Label='nStab ')
call mma_allocate(iCoSet,[0,7],[1,size(Coor,2)],Label='iCoSet')
call mma_allocate(Smmtrc,3,size(Coor,2),Label='Smmtrc')
jStab(:,:) = 0
nStab(:) = 0
iCoSet(:,:) = 0
Smmtrc(:,:) = .false.

nDimbc = 0
! Loop over the unique atoms
do isAtom=1,size(Coor,2)
  ! Find character of center
  iChxyz = 0
  do i=1,3
    if (Coor(i,isAtom) /= Zero) then
      do iIrrep=0,nIrrep-1
        if (btest(iOper(iIrrep),i-1)) iChxyz = ibset(iChxyz,i-1)
      end do
    end if
  end do
  nStb = 0
  do iIrrep=0,nIrrep-1
    if (iand(iChxyz,iOper(iIrrep)) == 0) then
      jStab(nStb,isAtom) = iOper(iIrrep)
      nStb = nStb+1
    end if
  end do
  nStab(isAtom) = nStb
  ! Find the coset representatives
  iCoSet(0,size(Coor,2)) = 0      ! Put in the unit operator
  nCoSet = 1
  do iIrrep=1,nIrrep-1
    itest = iand(iChxyz,iOper(iIrrep))
    Same = .false.
    do jCoSet=0,nCoSet-1
      jTest = iand(iChxyz,iCoSet(jCoSet,isAtom))
      Same = jTest == iTest
      if (Same) exit
    end do
    if (.not. Same) then
      nCoSet = nCoSet+1
      iCoSet(nCoSet-1,isAtom) = iOper(iIrrep)
    end if
  end do
  if (nIrrep/nStb /= nCoSet) then
    call WarningMessage(2,' Error while doing cosets.')
    call Abend()
  end if
  do i=1,3
    iComp = ibset(0,i-1)
    iAdd(0:nCoSet-1) = 0
    do iIrrep=0,nIrrep-1
      ! find the stabilizer index
      iTest = iand(iChxyz,iOper(iIrrep))
      n = -1
      do jCoset=0,nCoset-1
        jTest = iand(iChxyz,iCoset(jCoSet,isAtom))
        if (iTest == jTest) n = jCoset
      end do
      if ((n < 0) .or. (n > nCoset-1)) then
        call WarningMessage(2,' Error finding coset element')
        call Abend()
      end if
      iAdd(n) = iAdd(n)+iPrmt(iIrrep,iComp)
    end do
    Skip = .false.
    do jCoSet=0,nCoSet-1
      if (iAdd(jCoSet) == 0) then
        Skip = .true.
        exit
      end if
    end do
    if (.not. Skip) then
      nDimbc = nDimbc+1
      Smmtrc(i,isAtom) = .true.
    end if
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Transform charges to masses (C=12)

call mma_allocate(dMass,size(Coor,2),Label='dMass')
call mma_allocate(xMass,size(Coor,2),Label='xMass')
call Get_Mass(xMass,size(Coor,2))
!call RecPrt(' Charges',' ',Q_nuclear,SIZE(Coor,2),1)
call mma_allocate(ANr,size(Coor,2),Label='ANr')
do isAtom=1,size(Coor,2)
  ind = int(Q_nuclear(isAtom))
  if (ind <= 0) then
    dMass(isAtom) = 1.0e-10_wp
  else
    dMass(isAtom) = xMass(isAtom)
  end if
  ANr(isAtom) = ind
end do
call mma_deallocate(xMass)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the multiplicities of the cartesian coordinates and the
! total number of atoms.

mTtAtm = 0
call mma_Allocate(Degen,3,size(Coor,2),Label='Degen')
do isAtom=1,size(Coor,2)
  mTtAtm = mTtAtm+iDeg(Coor(:,isAtom))
  tmp = real(iDeg(Coor(:,isAtom)),kind=wp)
  Degen(:,isAtom) = tmp
end do
#ifdef _DEBUGPRINT_
call RecPrt('Degen',' ',Degen,3,size(Coor,2))
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
!call qpg_dArray('Transverse',lRP,nRP)
!if (lRP) then
!  call mma_allocate(R12,3,nRP/3,Label='R12')
!  call Get_dArray('Transverse',R12,nRP)
!end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute center of mass and molecular mass. The molecule is
! translated so origin and center of mass is identical.

#ifdef _DEBUGPRINT_
call Prlist('Symmetry Distinct Nuclear Coordinates / bohr',AtomLbl,size(Coor,2),Coor,3,size(Coor,2))
call PrList('Symmetry Distinct Nuclear Forces / au',AtomLbl,size(Coor,2),Grd,3,size(Coor,2))
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
mB_Tot = 0
mdB_Tot = 0
mq = 0
Force_dB = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Init_SlapAf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE EIGCTL(PROP,OVLP,DYSAMPS,HAM,EIGVEC,ENERGY)
      USE RASSI_aux
      USE kVectors
      USE rassi_global_arrays, only: JBNUM
      USE do_grid, only: Do_Lebedev_Sym
#ifdef _HDF5_
      USE Dens2HDF5
      USE mh5, ONLY: mh5_put_dset
#endif
#include "compiler_features.h"
#ifndef POINTER_REMAP
      USE ISO_C_Binding
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='EIGCTL')
#include "symmul.fh"
#include "rassi.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
* constants.fh defines values of physical constants.
#include "constants.fh"
#include "stdalloc.fh"
#include "rassiwfn.fh"

      character*100 line
      REAL*8 PROP(NSTATE,NSTATE,NPROP),OVLP(NSTATE,NSTATE),
     &       HAM(NSTATE,NSTATE),EIGVEC(NSTATE,NSTATE),ENERGY(NSTATE),
     &       DYSAMPS(NSTATE,NSTATE)
      REAL*8, ALLOCATABLE :: ESFS(:)
      Logical Diagonal
      Integer, Dimension(:), Allocatable :: IndexE,TMOgrp1,TMOgrp2
* Short array, just for putting transition dipole values
* into Add_Info, for generating check numbers:
      Real*8 TDIPARR(3)
      Integer  cho_x_gettol
      External cho_x_gettol
      INTEGER IOFF(8), SECORD(4), IPRTMOM(12)
      CHARACTER*8 LABEL
      Real*8 TM_R(3), TM_I(3), TM_C(3)
      Character*60 FMTLINE
      Real*8 Wavevector(3), UK(3)
      Real*8, Allocatable :: pol_Vector(:,:), Rquad(:,:)
      Real*8, Allocatable :: TDMZZ(:),TSDMZZ(:),WDMZZ(:),SCR(:,:)
#ifdef _HDF5_
      Real*8, Allocatable, Target :: Storage(:,:,:,:)
      Real*8, Pointer :: flatStorage(:)
#endif

#ifdef _DEBUGPRINT_RASSI_
      logical :: debug_dmrg_rassi_code = .true.
#else
      logical :: debug_dmrg_rassi_code = .false.
#endif
      logical TMOgroup
      REAL*8 COMPARE
      REAL*8 Rtensor(6)



C CONSTANTS:
      AU2EV=CONV_AU_TO_EV_
      AU2CM=CONV_AU_TO_CM1_
      DEBYE=CONV_AU_TO_DEBYE_
      AU2REDR=2.0D2*DEBYE
      SPEED_OF_LIGHT=CONST_C_IN_AU_
      HALF=0.5D0
      PI= CONST_PI_
*
      DIAGONAL=.TRUE.

#ifdef _DEBUGPRINT_RASSI_
      write(6,*) 'BLUBB start of eigctl: debug print of property matrix'
        do istate = 1, nstate
        do jstate = 1, nstate
        DO IPROP=1,NPROP
          if(abs(prop(istate,jstate,iprop)) > 1.0d-14)
     &    write(6,*) 'prop(',istate,',',jstate,',',iprop,') = ',
     &                prop(istate,jstate,iprop)
        end do
        end do
        end do
#endif

C DIAGONALIZE SCALAR HAMILTONIAN.

C Initialize eigenvector array.
      DO J=1,NSTATE
        DO I=1,NSTATE
          EIGVEC(I,J)=0.0D0
        END DO
      END DO
C NOTE: It is imperative that we do not mix, or change order, of
C states with different nr of electrons, spin, or symmetry. It is
C assumed in some subsequent parts of the program that these
C remain good properties of the wave functions, with values as
C listed in various tables in common /CNTRL/.
C So it is worth the extra inconvenience to construct an outer
C loop over sets of interacting wave functions.
C Make a list of interacting sets of states:
      CALL GETMEM('LIST','ALLO','INTE',LLIST,NSTATE)
      DO I=1,NSTATE
        IWORK(LLIST-1+I)=0
      END DO
      ISET=0
      DO I=1,NSTATE
        IF(IWORK(LLIST-1+I).GT.0) GOTO 20
        ISET=ISET+1
        IWORK(LLIST-1+I)=ISET
        JOB1=JBNUM(I)
        NACTE1=NACTE(JOB1)
        MPLET1=MLTPLT(JOB1)
        LSYM1=IRREP(JOB1)
        DO J=I+1,NSTATE
          IF(IWORK(LLIST-1+J).GT.0) GOTO 10
          JOB2=JBNUM(J)
          NACTE2=NACTE(JOB2)
          IF(NACTE2.NE.NACTE1) GOTO 10
          MPLET2=MLTPLT(JOB2)
          IF(MPLET2.NE.MPLET1) GOTO 10
          LSYM2=IRREP(JOB2)
          IF(LSYM2.NE.LSYM1) GOTO 10
          IWORK(LLIST-1+J)=ISET
  10      CONTINUE
        END DO
  20    CONTINUE
      END DO
      NSETS=ISET
CTEST      write(*,*)' EIGCTL. There are NSETS sets of interacting states.'
CTEST      write(*,'(1x,a,i3)')' where NSETS=',NSETS
CTEST      write(*,*)' The LIST array:'
CTEST      write(*,'(1x,20i3)')(IWORK(LLIST-1+I),I=1,NSTATE)

      NHH=(NSTATE*(NSTATE+1))/2
      CALL GETMEM('HH','ALLO','REAL',LHH,NHH)
      CALL GETMEM('HSQ','ALLO','REAL',LHSQ,NSTATE**2)
      CALL GETMEM('SS','ALLO','REAL',LSS,NHH)
      CALL GETMEM('UU','ALLO','REAL',LUU,NSTATE**2)
      CALL GETMEM('SCR','ALLO','REAL',LSCR,NSTATE**2)
      CALL DCOPY_(NSTATE**2,[0.0D0],0,WORK(LSCR),1)
      CALL GETMEM('STACK','ALLO','INTE',LSTK,NSTATE)
C Loop over the sets:
      DO ISET=1,NSETS
C Stack up the states belonging to this set:
       MSTATE=0
       DO I=1,NSTATE
        JSET=IWORK(LLIST-1+I)
        IF(JSET.EQ.ISET) THEN
         MSTATE=MSTATE+1
         IWORK(LSTK-1+MSTATE)=I
        END IF
       END DO

       if(debug_dmrg_rassi_code)then
         write(6,*) 'BLUBB DEBUG print of Hamiltonian and overlap'
       end if

C 1. PUT UNIT MATRIX INTO UU
      CALL DCOPY_(MSTATE**2,[0.0D0],0,WORK(LUU),1)
      CALL DCOPY_(MSTATE   ,[1.0D0],0,WORK(LUU),MSTATE+1)
C 2. COPY OVERLAP MATRIX INTO TRIANGULAR STORAGE,
C    and Hamiltonian into square storage:
      CALL DCOPY_(NSTATE**2,[0.0D0],0,WORK(LHSQ),1)
      IJ=0
      DO II=1,MSTATE
        I=IWORK(LSTK-1+II)
        DO JJ=1,II
          J=IWORK(LSTK-1+JJ)
          IJ=IJ+1
          If (I.NE.J .AND.
     &    (ABS(ovlp(i,j)).gt.1.0D-9.or.ABS(ham(i,j)).gt.1.0D-9)) Then
            DIAGONAL=.FALSE.
          EndIf
          if(debug_dmrg_rassi_code)then
            write(6,*) 'overlap     for i,j',i,j,ovlp(i,j)
            write(6,*) 'Hamiltonian for i,j',i,j,HAM(i,j)
          end if
          WORK(LSS-1+IJ)=OVLP(I,J)
          WORK(LHSQ-1+II+MSTATE*(JJ-1))=HAM(I,J)
          WORK(LHSQ-1+JJ+MSTATE*(II-1))=HAM(I,J)
        END DO
      END DO
C 3. SPECTRAL DECOMPOSITION OF OVERLAP MATRIX:
      CALL Jacob(WORK(LSS),WORK(LUU),MSTATE,MSTATE)
      II=0
      DO I=1,MSTATE
        II=II+I
        X=1.0D00/SQRT(MAX(0.5D-14,WORK(LSS-1+II)))
        DO K=1,MSTATE
          LPOS=LUU-1+K+MSTATE*(I-1)
          WORK(LPOS)=X*WORK(LPOS)
        END DO
      END DO

      If (.not.diagonal) Then
C 4. TRANSFORM HAMILTON MATRIX.
        CALL DGEMM_('N','N',MSTATE,MSTATE,MSTATE,1.0D0,
     &             WORK(LHSQ),MSTATE,WORK(LUU),MSTATE,
     &             0.0D0,WORK(LSCR),MSTATE)
        CALL DGEMM_('T','N',MSTATE,MSTATE,MSTATE,1.0D0,
     &             WORK(LUU),MSTATE,WORK(LSCR),MSTATE,
     &             0.0D0,WORK(LHSQ),MSTATE)

C 5. DIAGONALIZE HAMILTONIAN.
      IJ=0
      DO I=1,MSTATE
        DO J=1,I
          IJ=IJ+1
          WORK(LHH-1+IJ)=WORK(LHSQ-1+I+MSTATE*(J-1))
        END DO
      END DO

      CALL Jacob (WORK(LHH),WORK(LUU),MSTATE,MSTATE)
      CALL SortDiag(WORK(LHH),WORK(LUU),MSTATE,MSTATE)

      IDIAG=0
      DO II=1,MSTATE
        IDIAG=IDIAG+II
        I=IWORK(LSTK-1+II)
        ENERGY(I)=WORK(LHH-1+IDIAG)
        DO JJ=1,MSTATE
          J=IWORK(LSTK-1+JJ)
          EIGVEC(I,J)=WORK(LUU-1+II+MSTATE*(JJ-1))
        END DO
      END DO
*if diagonal
      Else
        DO II=1,MSTATE
          I=IWORK(LSTK-1+II)
          ENERGY(I)=HAM(I,I)
          Do JJ=1,MSTATE
            J=IWORK(LSTK-1+JJ)
            EIGVEC(I,J)=0.0d0
          End Do
          EIGVEC(I,I)=1.0d0
        End Do
      EndIf


CUNGUR
c   Correct for diagonal energies in case of orbital degeneracy:
c   Convention: two energies are considered degenerate if their energy difference is
c               lower than 1.0D-4 cm-1
      TMP=0.d0
      DLT=0.d0
      IDIAG=0
      DO II=1,MSTATE
        I=IWORK(LSTK-1+II)
        TMP=ENERGY(I)
        Do JJ=1,MSTATE
          J=IWORK(LSTK-1+JJ)
          IF(I==J) CYCLE
          DLT=ABS(ENERGY(J)-TMP)*AU2CM
          If(DLT<1.0D-4) THEN
            ENERGY(J)=TMP
          End If
        End Do
      End Do

      IDIAG=0
      DO II=1,MSTATE
        IDIAG=IDIAG+II
        I=IWORK(LSTK-1+II)
        WORK(LHH-1+IDIAG)=ENERGY(I)
      END DO
C End of loop over sets.
      END DO
C Morgane Vacher 02/17 - Fix the "arbitrary" sign of
C the eigenvectors such that the largest coefficient
C is positive. This is to avoid spurious changes of
C sign of the SFS with respect to the original ones,
C especially for already diagonal Hamiltonian matrix.
      do i=1,nstate
         j = maxloc(abs(eigvec(:,i)),1)
         if (eigvec(i,j) .lt. 0.0d0) then
           eigvec(:,i) = -eigvec(:,i)
         endif
      enddo
      CALL GETMEM('HH','FREE','REAL',LHH,NHH)
      CALL GETMEM('SS','FREE','REAL',LSS,NHH)
      CALL GETMEM('UU','FREE','REAL',LUU,NSTATE**2)
      CALL GETMEM('HSQ','FREE','REAL',LHSQ,NSTATE**2)
      CALL GETMEM('STACK','FREE','INTE',LSTK,NSTATE)
      CALL GETMEM('LIST','FREE','INTE',LLIST,NSTATE)

#ifdef _HDF5_
      call mh5_put_dset(wfn_sfs_energy, ENERGY)
      call mh5_put_dset(wfn_sfs_coef, EIGVEC)
#endif

      IF(IPGLOB.GE.TERSE) THEN
       DO ISTATE=1,NSTATE
        Call PrintResult(6,'(6x,A,I5,5X,A,F23.14)',
     &    'RASSI State',ISTATE,'Total energy:',ENERGY(ISTATE),1)
       END DO
      END IF

C Put energies onto info file for automatic verification runs:
CPAM06 Added error estimate, based on independent errors for all
C components of H and S in original RASSCF wave function basis:
      EPSS=5.0D-11
      EPSH=MAX(5.0D-10,ABS(ENERGY(1))*EPSS)
      IDX=100
      DO I=1,NSTATE
       EI=ENERGY(I)*EPSS
       V2SUM=0.0D0
       DO J=1,NSTATE
        V2SUM=V2SUM+EIGVEC(J,I)**2
       END DO
       ERMS=SQRT(EPSH**2+EI**2)*V2SUM
       IDX=MIN(IDX,INT(-LOG10(ERMS)))
      END DO
      iTol=cho_x_gettol(IDX) ! reset thr iff Cholesky
      Call Add_Info('E_RASSI',ENERGY,NSTATE,iTol)

C To handle extreme cases of large energies/small energy differences
C all TOTAL energies will undergo a universal constant shift:
      EMIN=ENERGY(1)
      DO ISTATE=2,NSTATE
cvv NAG compiler overoptimize this!
c       EMIN=MIN(EMIN,ENERGY(ISTATE))
       if(ENERGY(ISTATE).lt.EMIN) EMIN=ENERGY(ISTATE)
      END DO
      DO ISTATE=1,NSTATE
        ENERGY(ISTATE)=ENERGY(ISTATE)-EMIN
      END DO

C Experimental addition: Effective L and/or M quantum numbers.

C Identify which properties are angular moment matrix elements:
      IAMX=0
      IAMY=0
      IAMZ=0
      DO IPROP=1,NPROP
       IF(PNAME(IPROP)(1:6).EQ.'ANGMOM') THEN
         IF(ICOMP(IPROP).EQ.1) IAMX=IPROP
         IF(ICOMP(IPROP).EQ.2) IAMY=IPROP
         IF(ICOMP(IPROP).EQ.3) IAMZ=IPROP
       END IF
      END DO
*                                                                      *
************************************************************************
*                                                                      *
C The matrix elements are actually for i*Lx, etc.
C Now form matrix elements of L**2 assuming closure:
C i.e. assume L**2 = -(iLx)*(iLx)-(iLy)*(iLy)-(iLz)*(iLz)
C within the basis formed by the states.
      IAMXYZ=0
      IF (IAMZ.GT.0) THEN
         CALL GETMEM('L2','ALLO','REAL',LL2,NSTATE**2)
         CALL GETMEM('M2DIA','ALLO','REAL',LM2DIA,NSTATE)
         CALL DGEMM_('N','N',NSTATE,NSTATE,NSTATE,-1.0D0,
     &             PROP(1,1,IAMZ),NSTATE,PROP(1,1,IAMZ),NSTATE,
     &             0.0D0,WORK(LL2),NSTATE)
         CALL DCOPY_(NSTATE,WORK(LL2),(NSTATE+1),WORK(LM2DIA),1)
         IF (IAMX.GT.0.and.IAMY.gt.0) THEN
            IAMXYZ=1
            CALL DGEMM_('N','N',NSTATE,NSTATE,NSTATE,-1.0D0,
     &               PROP(1,1,IAMX),NSTATE,PROP(1,1,IAMX),NSTATE,
     &               1.0D0,WORK(LL2),NSTATE)
            CALL DGEMM_('N','N',NSTATE,NSTATE,NSTATE,-1.0D0,
     &               PROP(1,1,IAMY),NSTATE,PROP(1,1,IAMY),NSTATE,
     &               1.0D0,WORK(LL2),NSTATE)
            CALL GETMEM('L2DIA','ALLO','REAL',LL2DIA,NSTATE)
            CALL DCOPY_(NSTATE,WORK(LL2),(NSTATE+1),WORK(LL2DIA),1)
         END IF
         CALL GETMEM('L2','FREE','REAL',LL2,NSTATE**2)
      END IF
*                                                                      *
************************************************************************
*                                                                      *
*     Sort the states energywise
*
      Call mma_Allocate(IndexE,nState,Label='IndexE')
      Do iState = 1, nState
         IndexE(iState)=iState
      End Do
      Do iState = 1, nState-1
         EX=ENERGY(IndexE(iState))
*
         kState=iState
         Do jState = iState+1, nState
            If (ENERGY(IndexE(jState)).lt.EX) Then
               kState=jState
               EX=ENERGY(IndexE(jState))
            End If
         End Do
         If (kState.ne.iState) Then
            lState=IndexE(iState)
            IndexE(iState)=IndexE(kState)
            IndexE(kState)=lState
         End If
      End Do
#ifdef _HDF5_
      If (IFTRD1.or.IFTRD2) Call UpdateIdx(IndexE, 0)
#endif
*                                                                      *
************************************************************************
*                                                                      *
C REPORT ON SECULAR EQUATION RESULT:
      CALL MMA_ALLOCATE(ESFS,NSTATE)
      IF(IPGLOB.ge.TERSE) THEN
       WRITE(6,*)
       WRITE(6,*)
       WRITE(6,*)
       WRITE(6,'(6X,100A1)') ('*',i=1,100)
       WRITE(6,'(6X,A,98X,A)') '*','*'
       WRITE(6,'(6X,A,34X,A,34X,A)')
     &     '*','       Spin-free section      ','*'
       WRITE(6,'(6X,A,98X,A)') '*','*'
       WRITE(6,'(6X,A,17X,A,17X,A)')
     &     '*','Note: index according to input order, order according'
     &     //' to energy.','*'
       WRITE(6,'(6X,A,98X,A)') '*','*'
       WRITE(6,'(6X,100A1)') ('*',i=1,100)
       WRITE(6,*)
       WRITE(6,*)
       WRITE(6,*)
       WRITE(6,*)' SPIN-FREE ENERGIES:'
       WRITE(6,'(1X,A,F22.10,A1)')' (Shifted by EMIN (a.u.) =',EMIN,')'
       WRITE(6,*)
       IF(IFJ2.ne.0 .and. IAMXYZ.gt.0) THEN
        IF(IFJZ.ne.0 .and. IAMZ.gt.0) THEN
        WRITE(6,*)'SF State       Relative EMIN(au)   Rel lowest'//
     &          ' level(eV)    D:o, cm**(-1)      L_eff   Abs_M'
        ELSE
        WRITE(6,*)'SF State       Relative EMIN(au)   Rel lowest'//
     &          ' level(eV)    D:o, cm**(-1)      L_eff'
        END IF
       ELSE
        IF(IFJZ.ne.0 .and. IAMZ.gt.0) THEN
        WRITE(6,*)'SF State       Relative EMIN(au)   Rel lowest'//
     &          ' level(eV)    D:o, cm**(-1)      Abs_M'
        ELSE
        WRITE(6,*)'SF State       Relative EMIN(au)   Rel lowest'//
     &          ' level(eV)    D:o, cm**(-1)'
        END IF
       END IF
       WRITE(6,*)
*
       E0=ENERGY(IndexE(1))
       Do kSTATE=1,NSTATE
          iState=IndexE(kState)
          E1=ENERGY(ISTATE)
          E2=AU2EV*(E1-E0)
          E3=AU2CM*(E1-E0)
*
         IF(IFJ2.ne.0 .and. IAMXYZ.gt.0) THEN
          IF(IFJZ.ne.0 .and. IAMZ.gt.0) THEN
           EFFL=SQRT(MAX(0.5D-12,0.25D0+WORK(LL2DIA-1+ISTATE)))-Half
           EFFM=SQRT(MAX(0.5D-12,WORK(LM2DIA-1+ISTATE)))
           FMTLINE='(1X,I5,7X,F18.10,2X,F18.10,2X,F18.4,6X,F6.1,2X,'//
     &             'F6.1)'
           WRITE(6,FMTLINE) ISTATE,E1,E2,E3,EFFL,EFFM
          ELSE
           EFFL=SQRT(MAX(0.5D-12,0.25D0+WORK(LL2DIA-1+ISTATE)))-Half
           FMTLINE='(1X,I5,7X,F18.10,2X,F18.10,2X,F18.4,6X,F6.1)'
           WRITE(6,FMTLINE) ISTATE,E1,E2,E3,EFFL
          END IF
         ELSE
          IF(IFJZ.ne.0 .and. IAMZ.gt.0) THEN
           EFFM=SQRT(MAX(0.5D-12,WORK(LM2DIA-1+ISTATE)))
           FMTLINE='(1X,I5,7X,F18.10,2X,F18.10,2X,F18.4,6X,F6.1)'
           WRITE(6,FMTLINE) ISTATE,E1,E2,E3,EFFM
          ELSE
           FMTLINE='(1X,I5,7X,F18.10,2X,F18.10,2X,F18.4)'
           WRITE(6,FMTLINE) ISTATE,E1,E2,E3
          END IF
         END IF
       ESFS(ISTATE)=E3
*
       End Do
*
       IF(IAMZ.GT.0) THEN
        CALL GETMEM('M2DIA','FREE','REAL',LM2DIA,NSTATE)
       END IF
       IF(IAMXYZ.GT.0) THEN
        CALL GETMEM('L2DIA','FREE','REAL',LL2DIA,NSTATE)
       END IF
      END IF
c LU: save esfs array
       CALL Put_dArray('ESFS_SINGLE'  , ESFS  , NSTATE)
       CALL Put_dArray('ESFS_SINGLEAU',
     &           (ENERGY+EMIN), NSTATE)
       CALL MMA_DEALLOCATE(ESFS)
c

      IF((IPGLOB.ge.VERBOSE).or.(.not.diagonal)) THEN
       WRITE(6,*)
       WRITE(6,*)'  Spin-free eigenstates in basis of input states:'
       WRITE(6,*)'  -----------------------------------------------'
       WRITE(6,*)
       IF(IPGLOB.ge.VERBOSE) THEN
        DO L=1,NSTATE
           I=IndexE(L)
          Write(6,'(5X,A,I5,A,F18.10)')'Eigenstate No.',I,
     &          ' energy=',ENERGY(I)+EMIN
          WRITE(6,'(5X,5F15.7)')(EIGVEC(K,I),K=1,NSTATE)
        END DO
       END IF
       CALL GETMEM('ILST','ALLO','INTE',LILST,NSTATE)
       CALL GETMEM('VLST','ALLO','REAL',LVLST,NSTATE)
       DO L=1,NSTATE
          I=IndexE(L)
          Write(6,'(5X,A,I5,A,F18.10)')'Eigenstate No.',I,
     &          ' energy=',ENERGY(I)+EMIN
        EVMAX=0.0D0
        DO K=1,NSTATE
         EVMAX=MAX(EVMAX,ABS(EIGVEC(IndexE(K),I)))
        END DO
        EVLIM=0.10D0*EVMAX
        NLST=0
        DO K=1,NSTATE
         EV=EIGVEC(IndexE(K),I)
         IF(ABS(EV).GE.EVLIM) THEN
           NLST=NLST+1
           WORK(LVLST-1+NLST)=EV
           IWORK(LILST-1+NLST)=IndexE(K)
         END IF
        END DO
        DO KSTA=1,NLST,6
         KEND=MIN(NLST,KSTA+4)
         WRITE(Line,'(5X,5(I5,F12.6))')
     &    (IWORK(LILST-1+K),WORK(LVLST-1+K),K=KSTA,KEND)
         CALL NORMAL(Line)
         WRITE(6,*) Line
        END DO
        WRITE(6,*)
       END DO
       CALL GETMEM('ILST','FREE','INTE',LILST,NSTATE)
       CALL GETMEM('VLST','FREE','REAL',LVLST,NSTATE)
       IF(IPGLOB.ge.VERBOSE) THEN
        WRITE(6,*)
        WRITE(6,*)' THE INPUT RASSCF STATES REEXPRESSED IN EIGENSTATES:'
        WRITE(6,*)
        DO L=1,NSTATE
           I=IndexE(L)
         CALL DGEMM_('T','N',NSTATE,NSTATE,NSTATE,1.0D0,
     &             EIGVEC,NSTATE,OVLP,NSTATE,
     &             0.0D0,WORK(LSCR),NSTATE)
         WRITE(6,'(A,I5)')' INPUT STATE NR.:',I
         WRITE(6,*)' OVERLAP WITH THE EIGENSTATES:'
         WRITE(6,'(5(1X,F15.7))')(WORK(LSCR-1+IndexE(K)+NSTATE*(I-1)),
     &          K=1,NSTATE)
         WRITE(6,*)
        END DO
       END IF
      END IF

C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                                                                      C
C     TRANSFORM AND PRINT OUT PROPERTY MATRICES:                       C
C                                                                      C
C     The matrix elements of Prop refers to the original SF basis. We  C
C     now transform these to the basis of the eigenvectors of the SF   C
C     states. Note, for the "exact" operator of the transition moments C
C     we will have a computation of the TDM of the SF states on the    C
C     fly. To account for this transformation we will have to transformC
C     the coefficients of the SO states from a basis of the SF eigen-  C
C     states to the basis of the original SF states.                   C
C
      DO IP=1,NPROP
        CALL DGEMM_('N','N',NSTATE,NSTATE,NSTATE,1.0D0,
     &             PROP(1,1,IP),NSTATE,EIGVEC,NSTATE,
     &             0.0D0,WORK(LSCR),NSTATE)
        CALL DGEMM_('T','N',NSTATE,NSTATE,NSTATE,1.0D0,
     &             EIGVEC,NSTATE,WORK(LSCR),NSTATE,
     &             0.0D0,PROP(1,1,IP),NSTATE)
      END DO

C And the same for the Dyson amplitudes
        CALL DGEMM_('N','N',NSTATE,NSTATE,NSTATE,1.0D0,
     &             DYSAMPS,NSTATE,EIGVEC,NSTATE,
     &             0.0D0,WORK(LSCR),NSTATE)
        CALL DGEMM_('T','N',NSTATE,NSTATE,NSTATE,1.0D0,
     &             EIGVEC,NSTATE,WORK(LSCR),NSTATE,
     &             0.0D0,DYSAMPS,NSTATE)
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C

      CALL GETMEM('SCR','FREE','REAL',LSCR,NSTATE**2)
*
* Initial setup for both dipole, quadrupole etc. and exact operator
*
!
! There are debug statements thoughout - look for ZVAL
! If you want to debug in length gauge then comment out velocity dipole
!
!     ZVAL(1) = 1.0D0 ! Simulation of moving the origin along Z
!     ZVAL(2) = 2.0D0
!     ZVAL(3) = 3.0D0
!     ZVAL(4) = 5.0D0
!     ZVAL(5) = 7.0D0
!     ZVAL(6) = 10.0D0
!     ZVAL(7) = 15.0D0
!     ZVAL(8) = 20.0D0
!     ZVAL(9) = 25.0D0

      OSTHR=1.0D-5
      IF(DIPR) OSTHR = OSTHR_DIPR
      IF(DIPR) THEN
        WRITE(6,30) 'Dipole printing threshold changed to ',OSTHR
      END IF
! this is to ensure that the total transition strength is non-zero
! Negative transitions strengths can occur for quadrupole transitions
! due to the truncation of the Taylor expansion.
      IF(QIPR) OSTHR = OSTHR_QIPR
      IF(QIPR) THEN
      WRITE(6,49) 'Printing threshold changed to ',OSTHR,
     &           ' since quadrupole printing threshold is given '
      END IF
      OSTHR2=1.0D-5
      IF(QIPR) OSTHR2 = OSTHR_QIPR
      IF(QIPR) THEN
       WRITE(6,30) 'Quadrupole printing threshold changed to ',OSTHR2
      END IF
      IF(QIALL) WRITE(6,*) 'Will write all quadrupole contributions '

!Rotatory strength threshold
      IF(RSPR) THEN
        WRITE(6,30) 'Rotatory strength printing threshold changed '//
     &             'to ',RSTHR
      ELSE
        RSTHR = 1.0D-07 !Default
      END IF
!
!     Reducing the loop over states - good for X-rays
!     At the moment memory is not reduced
!
      IF(REDUCELOOP) THEN
        IEND = LOOPDIVIDE
        JSTART = LOOPDIVIDE+1
      ELSE
        IEND = NSTATE
        JSTART = 1
      END IF
*
      ! AFACTOR = 2*pi*e^2*E_h^2 / eps_0*m_e*c^3*h^2
      ! numerically: 2/c^3 (in a.u. of time ^ -1)
      AFACTOR = 2.0D0/CONST_C_IN_AU_**3
     &          /CONST_AU_TIME_IN_SI_
*
      IF(IPGLOB.le.SILENT) GOTO 900
!
* CALCULATION OF THE DIPOLE TRANSITION STRENGTHS
!
!     Initialize arrays for indentifying problematic transitions
!     These stores all dipole oscillator strengths in
!     length and velocity gauge for a later comparison.
!
      CALL GETMEM('DL   ','ALLO','REAL',LDL,NSTATE**2)
      CALL GETMEM('DV   ','ALLO','REAL',LDV,NSTATE**2)
      CALL DCOPY_(NSTATE**2,[0.0D0],0,WORK(LDL),1)
      CALL DCOPY_(NSTATE**2,[0.0D0],0,WORK(LDV),1)
      I_HAVE_DL = 0
      I_HAVE_DV = 0
!
      IF(IPGLOB.ge.TERSE) THEN

       IPRDX=0
       IPRDY=0
       IPRDZ=0
       IFANYD=0
       DO IPROP=1,NPROP
        IF(PTYPE(IPROP)(5:8).NE.'SING') CYCLE
        IF(IPUSED(IPROP).NE.0) THEN
         IF(PNAME(IPROP).EQ.'MLTPL  1') THEN
          IFANYD=1
          IF(ICOMP(IPROP).EQ.1) IPRDX=IPROP
          IF(ICOMP(IPROP).EQ.2) IPRDY=IPROP
          IF(ICOMP(IPROP).EQ.3) IPRDZ=IPROP
         END IF
        END IF
       END DO

       IF(IFANYD.NE.0) THEN
        WRITE(6,*)
        CALL CollapseOutput(1,'Dipole transition strengths '//
     &                        '(spin-free states):')
        WRITE(6,'(3X,A)')     '----------------------------'//
     &                        '-------------------'
        IF(OSTHR.GT.0.0D0) THEN
         WRITE(6,30) 'for osc. strength at least',OSTHR
        END IF
        WRITE(6,*)

! Printout the osc. strength in 3 dimensions into a file
       ! Should be if something happen
        losc_strength=20
        losc_strength=isFreeUnit(losc_strength)
        Call Molcas_Open(losc_strength,'osc_strength.au')
*
        If (Do_SK) Then
           nVec = nk_Vector
        Else
           nVec = 1
        End If
*
        Do iVec = 1, nVec
*
        LNCNT=0
        FMAX=0.0D0
        Two3rds=2.0D0/3.0D0
        DO K_=1,IEND
           I=IndexE(K_)
         DO L_=JSTART,NSTATE
            J=IndexE(L_)
          IJ=I+NSTATE*(J-1)
          EDIFF=ENERGY(J)-ENERGY(I)
*
          IF(EDIFF.GT.0.0D0) THEN
           DX=0.0D0
           DY=0.0D0
           DZ=0.0D0
           IF(IPRDX.GT.0) DX=PROP(J,I,IPRDX)
           IF(IPRDY.GT.0) DY=PROP(J,I,IPRDY)
           IF(IPRDZ.GT.0) DZ=PROP(J,I,IPRDZ)
           If (Do_SK) Then
              tmp=DX*k_vector(1,iVec)+
     &            DY*k_vector(2,iVec)+
     &            DZ*k_vector(3,iVec)
              DX=DX-tmp*k_vector(1,iVec)
              DY=DY-tmp*k_vector(2,iVec)
              DZ=DZ-tmp*k_vector(3,iVec)
           End If
           DX2=DX**2
           DY2=DY**2
           DZ2=DZ**2
           FX=Two3rds*EDIFF*(DX2)
           FY=Two3rds*EDIFF*(DY2)
           FZ=Two3rds*EDIFF*(DZ2)
           F =FX+FY+FZ
           FMAX=MAX(F,FMAX)
           AX=(AFACTOR*EDIFF**2)*FX
           AY=(AFACTOR*EDIFF**2)*FY
           AZ=(AFACTOR*EDIFF**2)*FZ
           A =(AFACTOR*EDIFF**2)*F
           IF (F.ge.OSTHR) THEN
              IF (LNCNT.EQ.0) THEN
                 If (Do_SK) Then
                    WRITE(6,*)
                    WRITE(6,'(4x,a,3F10.6)')
     &                 'Direction of the k-vector: ',
     &                  (k_vector(k,iVec),k=1,3)
                    WRITE(6,'(4x,a)')
     &                 'The light is assumed to be unpolarized.'
                    WRITE(6,*)
                 End If
                 WRITE(6,31) 'From','To','Osc. strength',
     &                   'Einstein coefficients Ax, Ay, Az (sec-1)   ',
     &                   'Total A (sec-1)'
                 WRITE(6,32)
                 WRITE(losc_strength,34) 'From','To','Osc. strength',
     &                   'Fx','Fy','Fz','(a.u.)'
                 WRITE(losc_strength,32)
              END IF
              LNCNT=LNCNT+1
              WRITE(6,33) I,J,F,AX,AY,AZ,A
              write(losc_strength,33) I,J,F,Fx,Fy,Fz
           END IF
! Store dipole oscillator strength
            WORK(LDL-1+IJ) = F
*
           If (F.gt.1.0D0) Then
              k=INT(LOG10(F))+1
              F=F/(10.0D0)**k
           End If
           Call Add_Info('TMS(SF,Len)',[F],1,6)
          END IF
         END DO
        END DO
        IF (LNCNT.EQ.0) THEN
           WRITE(6,*)' ( Max oscillator strength is only ',FMAX,')'
        ELSE
           WRITE(6,32)
           WRITE(losc_strength,32)
        END IF
*
        End Do ! iVec
*
        close(losc_strength)
        CALL CollapseOutput(0,'Dipole transition strengths '//
     &                        '(spin-free states):')
        I_HAVE_DL = 1
       END IF

* Key words for printing transition dipole vectors
* PRDIPVEC TDIPMIN
       IF(PRDIPVEC .AND. (NSTATE.gt.1) .and. (IFANYD.NE.0)) THEN
        WRITE(6,*)
        CALL CollapseOutput(1,'Dipole transition vectors '//
     &                        '(spin-free states):')
        WRITE(6,'(3X,A)')     '--------------------------'//
     &                        '-------------------'
        IF(TDIPMIN.GT.0.0D0) THEN
         WRITE(6,30) 'for vector sizes at least',TDIPMIN
        END IF
        WRITE(6,*)

        If (Do_SK) Then
           nVec = nk_Vector
        Else
           nVec = 1
        End If
*
        Do iVec = 1, nVec
*
        LNCNT=0
        DMAX=0.0D0
        DO K_=1,NSTATE-1
           I=IndexE(K_)
         DO L_=I+1,NSTATE
           J=IndexE(L_)
           DX=0.0D0
           DY=0.0D0
           DZ=0.0D0
           IF(IPRDX.GT.0) DX=PROP(J,I,IPRDX)
           IF(IPRDY.GT.0) DY=PROP(J,I,IPRDY)
           IF(IPRDZ.GT.0) DZ=PROP(J,I,IPRDZ)
           If (Do_SK) Then
              tmp=DX*k_vector(1,iVec)+
     &            DY*k_vector(2,iVec)+
     &            DZ*k_vector(3,iVec)
              DX=DX-tmp*k_vector(1,iVec)
              DY=DY-tmp*k_vector(2,iVec)
              DZ=DZ-tmp*k_vector(3,iVec)
           End If
           DSZ = SQRT(DX**2+DY**2+DZ**2)
           DMAX=MAX(DSZ,DMAX)
           IF(DSZ.ge.TDIPMIN) THEN
            IF(LNCNT.EQ.0) THEN
             If (Do_SK) Then
                WRITE(6,*)
                WRITE(6,'(4x,a,3F10.6)')
     &             'Direction of the k-vector: ',
     &              (k_vector(k,iVec),k=1,3)
                WRITE(6,'(4x,a)')
     &             'The light is assumed to be unpolarized.'
                WRITE(6,*)
             End If
             WRITE(6,34) 'From','To','Dx','Dy','Dz','Total D (a.u.)'
             WRITE(6,42)
            END IF
            LNCNT=LNCNT+1
            WRITE(6,33) I,J,DX,DY,DZ,DSZ
* Put values into array for add_info:
            TDIPARR(1)=DX
            TDIPARR(2)=DY
            TDIPARR(3)=DZ
            Call Add_Info('TRDIP',TDIPARR,3,6)
           END IF
         END DO
        END DO

        IF(LNCNT.EQ.0) THEN
         WRITE(6,*)' ( Max transition dipole is only ',DMAX,')'
        ELSE
         WRITE(6,32)
        END IF
        CALL CollapseOutput(0,'Dipole transition vectors '//
     &                        '(spin-free states):')
*
*
      End Do ! iVec
*
      End If
      END IF
*
*     Transition moments computed with the velocity operator.
*
      IPRDX=0
      IPRDY=0
      IPRDZ=0
      IFANYD=0
      DO IPROP=1,NPROP
         IF (IPUSED(IPROP).NE.0) THEN
            IF (PNAME(IPROP).EQ.'VELOCITY') THEN
               IFANYD=1
               IF(ICOMP(IPROP).EQ.1) IPRDX=IPROP
               IF(ICOMP(IPROP).EQ.2) IPRDY=IPROP
               IF(ICOMP(IPROP).EQ.3) IPRDZ=IPROP
            END IF
         END IF
      END DO

      IF (IFANYD.NE.0) THEN
         WRITE(6,*)
         CALL CollapseOutput(1,'Velocity transition strengths '//
     &                         '(spin-free states):')
         WRITE(6,'(3X,A)')     '------------------------------'//
     &                         '-------------------'
         IF (OSTHR.GT.0.0D0) THEN
            WRITE(6,30) 'for osc. strength at least',OSTHR
         END IF
         WRITE(6,*)
*
         If (Do_SK) Then
            nVec = nk_Vector
         Else
            nVec = 1
         End If
*
         Do iVec = 1, nVec
*
         LNCNT=0
         FMAX=0.0D0
         Two3rds=2.0D0/3.0D0
         DO K_=1,IEND
            I=IndexE(K_)
            DO L_=JSTART,NSTATE
               J=IndexE(L_)
               IJ=I+NSTATE*(J-1)
               EDIFF=ENERGY(J)-ENERGY(I)
               IF(EDIFF.GT.0.0D0) THEN
               DX=0.0D0
               DY=0.0D0
               DZ=0.0D0
               IF(IPRDX.GT.0) DX=PROP(J,I,IPRDX)
               IF(IPRDY.GT.0) DY=PROP(J,I,IPRDY)
               IF(IPRDZ.GT.0) DZ=PROP(J,I,IPRDZ)
               If (Do_SK) Then
                  tmp=DX*k_vector(1,iVec)+
     &                DY*k_vector(2,iVec)+
     &                DZ*k_vector(3,iVec)
                  DX=DX-tmp*k_vector(1,iVec)
                  DY=DY-tmp*k_vector(2,iVec)
                  DZ=DZ-tmp*k_vector(3,iVec)
               End If
               DX2=DX**2
               DY2=DY**2
               DZ2=DZ**2
               FX=Two3rds*(DX2)/EDIFF
               FY=Two3rds*(DY2)/EDIFF
               FZ=Two3rds*(DZ2)/EDIFF
               F =FX+FY+FZ
               FMAX=MAX(F,FMAX)
               AX=(AFACTOR*EDIFF**2)*FX
               AY=(AFACTOR*EDIFF**2)*FY
               AZ=(AFACTOR*EDIFF**2)*FZ
               A =(AFACTOR*EDIFF**2)*F
               IF (F.ge.OSTHR) THEN
                  IF (LNCNT.EQ.0) THEN
                     If (Do_SK) Then
                        WRITE(6,*)
                        WRITE(6,'(4x,a,3F10.6)')
     &                        'Direction of the k-vector: ',
     &                         (k_vector(k,ivec),k=1,3)
                        WRITE(6,'(4x,a)')
     &                        'The light is assumed to be unpolarized.'
                        WRITE(6,*)
                     End If
                     WRITE(6,31) 'From','To','Osc. strength',
     &                   'Einstein coefficients Ax, Ay, Az (sec-1)   ',
     &                   'Total A (sec-1)'
                     WRITE(6,32)
                  END IF
                  LNCNT=1
                  WRITE(6,33) I,J,F,AX,AY,AZ,A
! Store dipole oscillator strength
                  WORK(LDV-1+IJ) = F
               END IF
               Call Add_Info('TMS(SF,Vel)',[F],1,6)
               END IF
            END DO
         END DO
         IF (LNCNT.EQ.0) THEN
            WRITE(6,*)' ( Max oscillator strength is only ',FMAX,')'
         ELSE
            WRITE(6,32)
         END IF
*
         End Do ! iVec
         CALL CollapseOutput(0,'Velocity transition strengths '//
     &                         '(spin-free states):')
         WRITE(6,*)
         I_HAVE_DV = 1
      END IF
!
!      Compare oscillator strengths in length and velocity gauge
!      All differences in oscillator strengths above the tolerance
!      of 0.1 (10 percent) will be printed.
!
       IF(I_HAVE_DL.EQ.1.AND.I_HAVE_DV.EQ.1) THEN
         CALL CollapseOutput(1,'Length and velocity gauge comparison '//
     &                         '(spin-free states):')
         WRITE(6,'(3X,A)')     '-------------------------------------'//
     &                         '-------------------'
!
! I guess that I have to explain it when I print a warning
!
         WRITE(6,*)
         WRITE(6,*) "--------------------------------------------------"
         WRITE(6,*) "A comparison between the dipole oscillator "//
     &              "strengths in "
         WRITE(6,*) "length and velocity gauge "//
     &              "will be performed"
         WRITE(6,*)
         WRITE(6,49) "All dipole oscillator differences above the "//
     &              "tolerance of ",TOLERANCE," will be printed "
         WRITE(6,*)
         WRITE(6,*) "Due to basis set deficiency these oscillator "//
     &              "may be problematic "
         WRITE(6,*)
         WRITE(6,*) "The tolerance is defined as ABS(1-O_l/O_v) "
         WRITE(6,*) "O_l : dipole oscillator strength in length gauge"
         WRITE(6,*) "O_p : dipole oscillator strength in velocity gauge"
         WRITE(6,*) "--------------------------------------------------"
!
          I_PRINT_HEADER = 0
          DO K_=1,IEND
             I=IndexE(K_)
            DO L_=JSTART,NSTATE
               J=IndexE(L_)
               IJ=I+NSTATE*(J-1)
               EDIFF=ENERGY(J)-ENERGY(I)
               IF(JSTART.EQ.1.AND.EDIFF.LT.0.0D0) CYCLE
*
             COMPARE=0.0D0
             dlt=1.0D-18 ! Add small value to avoid zero divide.
             IF(WORK(LDL-1+IJ).GE.OSTHR+dlt .AND.
     &          WORK(LDV-1+IJ).GE.OSTHR+dlt) THEN
               COMPARE = ABS(1-WORK(LDL-1+IJ)/WORK(LDV-1+IJ))
             ELSE IF((WORK(LDL-1+IJ).GE.OSTHR+dlt).AND.
     &               (WORK(LDL-1+IJ).GT.0.0D0)) THEN
               COMPARE = -1.5D0
             ELSE IF((WORK(LDV-1+IJ).GE.OSTHR+dlt).AND.
     &               (WORK(LDV-1+IJ).GT.0.0D0)) THEN
               COMPARE = -2.5D0
             END IF

             IF(ABS(COMPARE).GE.TOLERANCE) THEN
               I_PRINT_HEADER = I_PRINT_HEADER + 1
               IF(I_PRINT_HEADER.EQ.1) THEN
                 WRITE(6,*)
                 WRITE(6,*) " Problematic transitions have been found"
                 WRITE(6,*)
                 WRITE(6,39) "From","To","Difference (%)",
     &                       "Osc. st. (len.)","Osc. st. (vel.)"
                 WRITE(6,40)
               END IF
               IF (COMPARE.GE.0.0D0) THEN
                 WRITE(6,38) I,J,COMPARE*100D0,
     &                      WORK(LDL-1+IJ),WORK(LDV-1+IJ)
               ELSE IF (COMPARE.GE.-2.0D0) THEN
                 WRITE(6,36) I,J,WORK(LDL-1+IJ),"below threshold"
               ELSE
                 WRITE(6,37) I,J,"below threshold",WORK(LDV-1+IJ)
               END IF
             END IF
*
            END DO ! L_
          END DO ! K_
          IF(I_PRINT_HEADER.EQ.0) THEN
            WRITE(6,*)
            WRITE(6,*) "No problematic oscillator strengths above "//
     &                 "the tolerance ", TOLERANCE," have been found"
            WRITE(6,*)
          ELSE
            WRITE(6,40)
            WRITE(6,*)
            WRITE(6,*) "Number of problematic transitions = ",
     &                  I_PRINT_HEADER
            WRITE(6,*)
          END IF
         CALL CollapseOutput(0,'Length and velocity gauge comparison '//
     &                         '(spin-free states):')
         WRITE(6,*)
        END IF
*
* Free the memory
*
      CALL GETMEM('DV   ','FREE','REAL',LDV,NSTATE**2)
      CALL GETMEM('DL   ','FREE','REAL',LDL,NSTATE**2)
*
* CALCULATION OF THE QUADRUPOLE TRANSITION STRENGTHS
*
      SECORD = 0
!
! We will first allocate a matrix for the total of the second order wave vector
!
      CALL GETMEM('TOT2K','ALLO','REAL',LTOT2K,NSTATE**2)
      CALL DCOPY_(NSTATE**2,[0.0D0],0,WORK(LTOT2K),1)

* Magnetic-Dipole - Magnetic-Dipole transitions
!
! Magnetic-Dipole
!
! DEBUG
!
!        IPRDX_TEMP=IPRDX
!        IPRDY_TEMP=IPRDY
!        IPRDZ_TEMP=IPRDZ
! BEBUG END
        IPRDX=0
        IPRDY=0
        IPRDZ=0

        IFANYD=0
        DO IPROP=1,NPROP
          IF(PNAME(IPROP).EQ.'ANGMOM  ') THEN
           IFANYD=1
           IF(ICOMP(IPROP).EQ.1) IPRDX=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDY=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDZ=IPROP
          END IF
        END DO

        IF(IFANYD.NE.0) THEN
!
! Only print the part calculated
!
        IF(QIALL) THEN
          WRITE(6,*)
          Call CollapseOutput(1,
     &                  'Magnetic-Dipole - Magnetic-Dipole '//
     &                  'transition strengths (spin-free states):')
          WRITE(6,'(3X,A)')
     &                  '----------------------------------'//
     &                  '----------------------------------------'
         IF(OSTHR2.GT.0.0D0) THEN
          WRITE(6,30) 'for osc. strength at least',OSTHR2
          WRITE(6,*)
         END IF
         WRITE(6,31) 'From','To','Osc. strength'
         WRITE(6,35)
        END IF

         ONEOVER6C2=1.0D0/(6.0D0*CONST_C_IN_AU_**2)

         DO K_=1,IEND
            I=IndexE(K_)
          DO L_=JSTART,NSTATE
             J=IndexE(L_)
           EDIFF=ENERGY(J)-ENERGY(I)
           IF(EDIFF.GT.0.0D0) THEN
            IJ=J+NSTATE*(I-1)

            DX2=0.0D0
            DY2=0.0D0
            DZ2=0.0D0

            IF(IPRDX.GT.0) DX2=PROP(J,I,IPRDX)**2
            IF(IPRDY.GT.0) DY2=PROP(J,I,IPRDY)**2
            IF(IPRDZ.GT.0) DZ2=PROP(J,I,IPRDZ)**2

            F = (DX2 + DY2 + DZ2)*EDIFF*ONEOVER6C2
! Add it to the total
            WORK(LTOT2K-1+IJ) = WORK(LTOT2K-1+IJ) + F
            IF(ABS(F).GE.OSTHR2) THEN
!            WRITE(6,*) ' value at distance '
             IF(QIALL) WRITE(6,33) I,J,F
            END IF
!
! Debug to move along z. Change DX and DY (1 Aangstrom)
!
!     DO I = 1, 9
!     AA = 1.889726D0*ZVAL(I)*EDIFF!/(2.0D0*CONST_C_IN_AU_)
! z-direction
!     DX2=(PROP(J,I,IPRDX)
!    &    -AA*PROP(J,I,IPRDY_TEMP))**2
!     DY2=(PROP(J,I,IPRDY)
!    &    +AA*PROP(J,I,IPRDX_TEMP))**2
!           F = (DX2 + DY2 + DZ2)*EDIFF*ONEOVER6C2
! x-direction
!     DZ2=(PROP(J,I,IPRDZ)
!    &    +AA*PROP(J,I,IPRDY_TEMP))**2
!     DY2=(PROP(J,I,IPRDY)
!    &    -AA*PROP(J,I,IPRDZ_TEMP))**2
!           F = (DX2 + DY2 + DZ2)*EDIFF*ONEOVER6C2
! y-direction
!     DX2=(PROP(J,I,IPRDX)
!    &    +AA*PROP(J,I,IPRDZ_TEMP))**2
!     DZ2=(PROP(J,I,IPRDZ)
!    &    -AA*PROP(J,I,IPRDX_TEMP))**2
!           F = (DX2 + DY2 + DZ2)*EDIFF*ONEOVER6C2
!           IF(ABS(F).GE.OSTHR2) THEN
!            WRITE(6,*) ' moved value ',ZVAL(I)
!            WRITE(6,'(5X,2I5,5X,G16.8)') I,J,F
!           END IF
!     END DO
           END IF
          END DO
         END DO
        IF(QIALL) THEN
         WRITE(6,35)

         Call CollapseOutput(0,
     &                  'Magnetic-Dipole - Magnetic-Dipole '//
     &                  'transition strengths (spin-free states):')
        END IF
! Magnetic-dipole - Magnetic-dipole calculated
          SECORD(1) = 1
        END IF

*Electric-Quadrupole Electric-Quadrupole transitions

        IPRDXX=0
        IPRDXY=0
        IPRDXZ=0
        IPRDYY=0
        IPRDYZ=0
        IPRDZZ=0

        IFANYD=0
        DO IPROP=1,NPROP
          IF(PNAME(IPROP).EQ.'MLTPL  2') THEN
           IFANYD=1
           IF(ICOMP(IPROP).EQ.1) IPRDXX=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDXY=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDXZ=IPROP
           IF(ICOMP(IPROP).EQ.4) IPRDYY=IPROP
           IF(ICOMP(IPROP).EQ.5) IPRDYZ=IPROP
           IF(ICOMP(IPROP).EQ.6) IPRDZZ=IPROP
          END IF
        END DO

        IF(IFANYD.NE.0) THEN
        IF(QIALL) THEN
         WRITE(6,*)
         Call CollapseOutput(1,
     &            'Quadrupole transition strengths (spin-free states):')
         WRITE(6,'(3X,A)')
     &            '---------------------------------------------------'
         IF(OSTHR2.GT.0.0D0) THEN
          WRITE(6,30) 'for osc. strength at least',OSTHR2
          WRITE(6,*)
         END IF
         WRITE(6,31) 'From','To','Osc. strength'
         WRITE(6,35)
        END IF

         ONEOVER10C=1.0D0/(10.0D0*CONST_C_IN_AU_**2)
         ONEOVER30C=ONEOVER10C/3.0D0

         DO K_=1,IEND
            I=IndexE(K_)
          DO L_=JSTART,NSTATE
             J=IndexE(L_)
           EDIFF=ENERGY(J)-ENERGY(I)
           IF(EDIFF.GT.0.0D0) THEN
!
            EDIFF3=EDIFF**3
            IJ=J+NSTATE*(I-1)

            DXX=0.0D0
            DYY=0.0D0
            DZZ=0.0D0
            DXY=0.0D0
            DXZ=0.0D0
            DYZ=0.0D0
            IF(IPRDXX.GT.0) DXX=PROP(J,I,IPRDXX)
            IF(IPRDYY.GT.0) DYY=PROP(J,I,IPRDYY)
            IF(IPRDZZ.GT.0) DZZ=PROP(J,I,IPRDZZ)
            IF(IPRDXY.GT.0) DXY=PROP(J,I,IPRDXY)
            IF(IPRDXZ.GT.0) DXZ=PROP(J,I,IPRDXZ)
            IF(IPRDYZ.GT.0) DYZ=PROP(J,I,IPRDYZ)

            DXX2=DXX**2
            DYY2=DYY**2
            DZZ2=DZZ**2
            FXX=ONEOVER30C*EDIFF3*(DXX2)
            FYY=ONEOVER30C*EDIFF3*(DYY2)
            FZZ=ONEOVER30C*EDIFF3*(DZZ2)

            DXY2=DXY**2
            DXZ2=DXZ**2
            DYZ2=DYZ**2
            FXY=ONEOVER10C*EDIFF3*(DXY2)
            FXZ=ONEOVER10C*EDIFF3*(DXZ2)
            FYZ=ONEOVER10C*EDIFF3*(DYZ2)

            DXXDYY=DXX*DYY
            DXXDZZ=DXX*DZZ
            DYYDZZ=DYY*DZZ
            FXXFYY=-ONEOVER30C*EDIFF3*(DXXDYY)
            FXXFZZ=-ONEOVER30C*EDIFF3*(DXXDZZ)
            FYYFZZ=-ONEOVER30C*EDIFF3*(DYYDZZ)

            F =FXX+FXY+FXZ+FYY+FYZ+FZZ+FXXFYY+FXXFZZ+FYYFZZ
! Add it to the total
            WORK(LTOT2K-1+IJ) = WORK(LTOT2K-1+IJ) + F

            IF(ABS(F).GE.OSTHR2) THEN
             IF(QIALL) WRITE(6,33) I,J,F
            END IF
!
! Debug to move along z. Change DZZ, DXZ and DYZ
!
!     DO I = 1, 9
!           DZZ2=(PROP(J,I,IPRDZZ)+
!    &           1.889726D0*ZVAL(I)*2.0D0*PROP(J,I,IPRDZ_TEMP))**2
!           DXZ2=(PROP(J,I,IPRDXZ)+
!    &           1.889726D0*ZVAL(I)*  PROP(J,I,IPRDX_TEMP))**2
!           DYZ2=(PROP(J,I,IPRDYZ)+
!    &           1.889726D0*ZVAL(I)*  PROP(J,I,IPRDY_TEMP))**2
!           FZZ=ONEOVER30C*EDIFF3*(DZZ2)
!           FXZ=ONEOVER10C*EDIFF3*(DXZ2)
!           FYZ=ONEOVER10C*EDIFF3*(DYZ2)
!           DXXDZZ=PROP(J,I,IPRDXX)*(PROP(J,I,IPRDZZ)+
!    &             1.889726D0*ZVAL(I)*2.0D0*PROP(J,I,IPRDZ_TEMP))
!           DYYDZZ=PROP(J,I,IPRDYY)*(PROP(J,I,IPRDZZ)+
!    &             1.889726D0*ZVAL(I)*2.0D0*PROP(J,I,IPRDZ_TEMP))
!           FXXFZZ=-ONEOVER30C*EDIFF3*(DXXDZZ)
!           FYYFZZ=-ONEOVER30C*EDIFF3*(DYYDZZ)
!           F =FXX+FXY+FXZ+FYY+FYZ+FZZ+FXXFYY+FXXFZZ+FYYFZZ
!           IF(ABS(F).GE.OSTHR2) THEN
!            WRITE(6,*) ' moved value ',ZVAL(I)
!            WRITE(6,'(5X,2I5,5X,G16.8)') I,J,F
!           END IF
!     END DO
           END IF
          END DO
         END DO
        IF(QIALL) THEN
         WRITE(6,35)

         Call CollapseOutput(0,
     &            'Quadrupole transition strengths (spin-free states):')
        END IF
          SECORD(2) = 1
        END IF

*Electric-Dipole Electric-Octupole transitions

! Octupole
! This is a real symmetric rank 3 tensor so only 10 and not 27 is needed
! The order which comes in
!
! DEBUG
!
!       IPRDXX_TEMP=IPRDXX
!       IPRDXY_TEMP=IPRDXY
!       IPRDXZ_TEMP=IPRDXZ
!       IPRDYY_TEMP=IPRDYY
!       IPRDYZ_TEMP=IPRDYZ
!       IPRDZZ_TEMP=IPRDZZ
! DEBUG END
        IPRDXXX=0 !
        IPRDXXY=0 !
        IPRDXXZ=0 !

!       IPRDXYX=0
!       IPRDXYY=0 ! YYX These are the same due to symmetry
!       IPRDXYZ=0 ! Not present

!       IPRDXZX=0
!       IPRDXZY=0
!       IPRDXZZ=0 ! ZZX

!       IPRDYXX=0
!       IPRDYXY=0
!       IPRDYXZ=0

        IPRDYYX=0 ! Taking the XYY order
        IPRDYYY=0 !
        IPRDYYZ=0 !

!       IPRDYZX=0
!       IPRDYZY=0
!       IPRDYZZ=0 ! ZZY

!       IPRDZXX=0
!       IPRDZXY=0
!       IPRDZXZ=0

!       IPRDZYX=0
!       IPRDZYY=0
!       IPRDZYZ=0

        IPRDZZX=0 ! Taking order from XZZ
        IPRDZZY=0 ! Taking order from YZZ
        IPRDZZZ=0 !
! Dipole
        IPRDX=0
        IPRDY=0
        IPRDZ=0


        IFANYD=0
        DO IPROP=1,NPROP
          IF(PTYPE(IPROP)(5:8).NE.'SING') CYCLE
          IF(PNAME(IPROP).EQ.'MLTPL  1') THEN
           IF(ICOMP(IPROP).EQ.1) IPRDX=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDY=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDZ=IPROP
          ELSE IF(PNAME(IPROP).EQ.'MLTPL  3') THEN
           IFANYD=1
           IF(ICOMP(IPROP).EQ.1) IPRDXXX=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDXXY=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDXXZ=IPROP
           IF(ICOMP(IPROP).EQ.4) IPRDYYX=IPROP ! Changed from XYY
           !IF(ICOMP(IPROP).EQ.5) IPRDXYZ=IPROP
           IF(ICOMP(IPROP).EQ.6) IPRDZZX=IPROP ! Changed from XZZ
           IF(ICOMP(IPROP).EQ.7) IPRDYYY=IPROP
           IF(ICOMP(IPROP).EQ.8) IPRDYYZ=IPROP
           IF(ICOMP(IPROP).EQ.9) IPRDZZY=IPROP ! Changed from YZZ
           IF(ICOMP(IPROP).EQ.10) IPRDZZZ=IPROP
          END IF
        END DO
! Sanity check. Only check that dipole are there
! since it will give problems the other way when
! only calculating dipole transitions
        IF(((IPRDXXX.GT.0.OR.IPRDYYX.GT.0.OR.IPRDZZX.GT.0)
     &   .AND.IPRDX.LE.0)) THEN
         WRITE(6,*) ' Remember to include both Dipole and Octupole'
         CALL ABEND()
        END IF
        IF(((IPRDXXY.GT.0.OR.IPRDYYY.GT.0.OR.IPRDZZY.GT.0)
     &   .AND.IPRDY.LE.0)) THEN
         WRITE(6,*) ' Remember to include both Dipole and Octupole'
         CALL ABEND()
        END IF
        IF(((IPRDXXZ.GT.0.OR.IPRDYYZ.GT.0.OR.IPRDZZZ.GT.0)
     &   .AND.IPRDZ.LE.0)) THEN
         WRITE(6,*) ' Remember to include both Dipole and Octupole'
         CALL ABEND()
        END IF

        IF(IFANYD.NE.0) THEN
        IF(QIALL) THEN
         WRITE(6,*)
         Call CollapseOutput(1,
     &                     'Electric-Dipole - Electric-Octupole '//
     &                     'transition strengths (spin-free states):')
         WRITE(6,'(3X,A)') '------------------------------------'//
     &                     '----------------------------------------'
         IF(OSTHR2.GT.0.0D0) THEN
          WRITE(6,30) 'for osc. strength at least',OSTHR2
          WRITE(6,*)
         END IF
         WRITE(6,31) 'From','To','Osc. strength'
         WRITE(6,35)
        END IF

         TWOOVERM45C=-2.0D0/(45.0D0*CONST_C_IN_AU_**2)
         DO K_=1,IEND
            I=IndexE(K_)
          DO L_=JSTART,NSTATE
             J=IndexE(L_)
           EDIFF=ENERGY(J)-ENERGY(I)
           IF(EDIFF.GT.0.0D0) THEN
!
            EDIFF3=EDIFF**3
            IJ=J+NSTATE*(I-1)

            DXXXDX=0.0D0
            DYYXDX=0.0D0
            DZZXDX=0.0D0
            IF(IPRDXXX.GT.0) DXXXDX=PROP(J,I,IPRDXXX)
     &                             *PROP(J,I,IPRDX)
            IF(IPRDYYX.GT.0) DYYXDX=PROP(J,I,IPRDYYX)
     &                             *PROP(J,I,IPRDX)
            IF(IPRDZZX.GT.0) DZZXDX=PROP(J,I,IPRDZZX)
     &                             *PROP(J,I,IPRDX)
            FXXX=TWOOVERM45C*EDIFF3*(DXXXDX)
            FYYX=TWOOVERM45C*EDIFF3*(DYYXDX)
            FZZX=TWOOVERM45C*EDIFF3*(DZZXDX)

            DXXYDY=0.0D0
            DYYYDY=0.0D0
            DZZYDY=0.0D0
            IF(IPRDXXY.GT.0) DXXYDY=PROP(J,I,IPRDXXY)
     &                             *PROP(J,I,IPRDY)
            IF(IPRDYYY.GT.0) DYYYDY=PROP(J,I,IPRDYYY)
     &                             *PROP(J,I,IPRDY)
            IF(IPRDZZY.GT.0) DZZYDY=PROP(J,I,IPRDZZY)
     &                             *PROP(J,I,IPRDY)
            FXXY=TWOOVERM45C*EDIFF3*(DXXYDY)
            FYYY=TWOOVERM45C*EDIFF3*(DYYYDY)
            FZZY=TWOOVERM45C*EDIFF3*(DZZYDY)

            DXXZDZ=0.0D0
            DYYZDZ=0.0D0
            DZZZDZ=0.0D0
            IF(IPRDXXZ.GT.0) DXXZDZ=PROP(J,I,IPRDXXZ)
     &                             *PROP(J,I,IPRDZ)
            IF(IPRDYYZ.GT.0) DYYZDZ=PROP(J,I,IPRDYYZ)
     &                             *PROP(J,I,IPRDZ)
            IF(IPRDZZZ.GT.0) DZZZDZ=PROP(J,I,IPRDZZZ)
     &                             *PROP(J,I,IPRDZ)
            FXXZ=TWOOVERM45C*EDIFF3*(DXXZDZ)
            FYYZ=TWOOVERM45C*EDIFF3*(DYYZDZ)
            FZZZ=TWOOVERM45C*EDIFF3*(DZZZDZ)

            F =FXXX+FYYX+FZZX+FXXY+FYYY+FZZY+FXXZ+FYYZ+FZZZ
! Add it to the total
            WORK(LTOT2K-1+IJ) = WORK(LTOT2K-1+IJ) + F

            IF(ABS(F).GE.OSTHR2) THEN
             IF(QIALL) WRITE(6,33) I,J,F
            END IF
!
! Debug to move along z. Change DZZX,DZZY,DXXZ,DYYZ and DZZZ
!
!     DO I = 1, 9
!     DZZXDX=(PROP(J,I,IPRDZZX)+
!    &        1.889726D0*ZVAL(I)*2*PROP(J,I,IPRDXZ_TEMP)+
!    &       (1.889726D0*ZVAL(I))**2*PROP(J,I,IPRDX_TEMP))*
!    &        PROP(J,I,IPRDX)
!           FZZX=TWOOVERM45C*EDIFF3*(DZZXDX)

!     DZZYDY=(PROP(J,I,IPRDZZY)+
!    &        1.889726D0*ZVAL(I)*2*PROP(J,I,IPRDYZ_TEMP)+
!    &       (1.889726D0*ZVAL(I))**2*PROP(J,I,IPRDY_TEMP))*
!    &        PROP(J,I,IPRDY)
!           FZZY=TWOOVERM45C*EDIFF3*(DZZYDY)

!     DXXZDZ=(PROP(J,I,IPRDXXZ)+
!    &        1.889726D0*ZVAL(I)*PROP(J,I,IPRDXX_TEMP))*
!    &        PROP(J,I,IPRDZ)
!     DYYZDZ=(PROP(J,I,IPRDYYZ)+
!    &        1.889726D0*ZVAL(I)*PROP(J,I,IPRDYY_TEMP))*
!    &        PROP(J,I,IPRDZ)
!     DZZZDZ=(PROP(J,I,IPRDZZZ)+
!    &        1.889726D0*ZVAL(I)*3*PROP(J,I,IPRDZZ_TEMP)+
!    &       (1.889726D0*ZVAL(I))**2*3*PROP(J,I,IPRDZ_TEMP))*
!    &        PROP(J,I,IPRDZ)
!           FXXZ=TWOOVERM45C*EDIFF3*(DXXZDZ)
!           FYYZ=TWOOVERM45C*EDIFF3*(DYYZDZ)
!           FZZZ=TWOOVERM45C*EDIFF3*(DZZZDZ)

!           F =FXXX+FYYX+FZZX+FXXY+FYYY+FZZY+FXXZ+FYYZ+FZZZ

!           IF(ABS(F).GE.OSTHR2) THEN
!            WRITE(6,*) ' moved value ',ZVAL(I)
!            WRITE(6,'(5X,2I5,5X,G16.8)') I,J,F
!           END IF
!     END DO
           END IF
          END DO
         END DO
        IF(QIALL) THEN
         WRITE(6,35)

         Call CollapseOutput(0,
     &                     'Electric-Dipole - Electric-Octupole '//
     &                     'transition strengths (spin-free states):')
        END IF
          SECORD(3) = 1
        END IF
*
*Electric-Dipole - Magnetic-Quadrupole transitions
!
! Magnetic-Quadrupole
        IPRDXX=0
        IPRDXY=0
        IPRDXZ=0

        IPRDYX=0
        IPRDYY=0
        IPRDYZ=0

        IPRDZX=0
        IPRDZY=0
        IPRDZZ=0
! Electric-Dipole
        IPRDX=0
        IPRDY=0
        IPRDZ=0

        IFANYD=0
        DO IPROP=1,NPROP
          IF(PTYPE(IPROP)(5:8).NE.'SING') CYCLE
          IF(PNAME(IPROP).EQ.'MLTPL  1') THEN
           IF(ICOMP(IPROP).EQ.1) IPRDX=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDY=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDZ=IPROP
          ELSE IF(PNAME(IPROP).EQ.'OMQ') THEN
           IFANYD=1
           IF(ICOMP(IPROP).EQ.1) IPRDXX=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDXY=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDXZ=IPROP

           IF(ICOMP(IPROP).EQ.4) IPRDYX=IPROP
           IF(ICOMP(IPROP).EQ.5) IPRDYY=IPROP
           IF(ICOMP(IPROP).EQ.6) IPRDYZ=IPROP

           IF(ICOMP(IPROP).EQ.7) IPRDZX=IPROP
           IF(ICOMP(IPROP).EQ.8) IPRDZY=IPROP
           IF(ICOMP(IPROP).EQ.9) IPRDZZ=IPROP
          END IF
        END DO
! Sanity check. Only check that dipole are there
! since it will give problems the other way when
! only calculating dipole transitions
        IF(((IPRDYZ.GT.0.OR.IPRDZY.GT.0)
     &   .AND.IPRDX.LE.0)) THEN
         WRITE(6,*) ' Remember to include both Dipole and Quadrupole'
         CALL ABEND()
        END IF
        IF(((IPRDZX.GT.0.OR.IPRDXZ.GT.0)
     &   .AND.IPRDY.LE.0)) THEN
         WRITE(6,*) ' Remember to include both Dipole and Quadrupole'
         CALL ABEND()
        END IF
        IF(((IPRDXY.GT.0.OR.IPRDYX.GT.0)
     &   .AND.IPRDZ.LE.0)) THEN
         WRITE(6,*) ' Remember to include both Dipole and Quadrupole'
         CALL ABEND()
        END IF

        IF(IFANYD.NE.0) THEN
        IF(QIALL) THEN
          WRITE(6,*)
          Call CollapseOutput(1,
     &                  'Electric-Dipole - Magnetic-Quadrupole '//
     &                  'transition strengths (spin-free states):')
          WRITE(6,'(3X,A)')
     &                  '--------------------------------------'//
     &                  '---------------------------------------'

         IF(OSTHR2.GT.0.0D0) THEN
          WRITE(6,30) 'for osc. strength at least',OSTHR2
          WRITE(6,*)
         END IF
         WRITE(6,31) 'From','To','Osc. strength'
         WRITE(6,35)
         END IF

         ONEOVER9C2=1.0D0/(9.0D0*CONST_C_IN_AU_**2)
         DO K_=1,IEND
            I=IndexE(K_)
          DO L_=JSTART,NSTATE
             J=IndexE(L_)
           EDIFF=ENERGY(J)-ENERGY(I)
           IF(EDIFF.GT.0.0D0) THEN
!
            EDIFF2=EDIFF**2
            IJ=J+NSTATE*(I-1)
!
            DXYDZ=0.0D0
            DYXDZ=0.0D0
            IF(IPRDXY.GT.0) DXYDZ=PROP(J,I,IPRDXY)
     &                           *PROP(J,I,IPRDZ)
            IF(IPRDXY.GT.0) DYXDZ=PROP(J,I,IPRDYX)
     &                           *PROP(J,I,IPRDZ)
            FXY=ONEOVER9C2*EDIFF2*(DXYDZ)
            FYX=-ONEOVER9C2*EDIFF2*(DYXDZ)

            DZXDY=0.0D0
            DXZDY=0.0D0
            IF(IPRDZX.GT.0) DZXDY=PROP(J,I,IPRDZX)
     &                           *PROP(J,I,IPRDY)
            IF(IPRDXZ.GT.0) DXZDY=PROP(J,I,IPRDXZ)
     &                           *PROP(J,I,IPRDY)
            FZX=ONEOVER9C2*EDIFF2*(DZXDY)
            FXZ=-ONEOVER9C2*EDIFF2*(DXZDY)

            DYZDX=0.0D0
            DZYDX=0.0D0
            IF(IPRDYZ.GT.0) DYZDX=PROP(J,I,IPRDYZ)
     &                           *PROP(J,I,IPRDX)
            IF(IPRDZY.GT.0) DZYDX=PROP(J,I,IPRDZY)
     &                           *PROP(J,I,IPRDX)
            FYZ=ONEOVER9C2*EDIFF2*(DYZDX)
            FZY=-ONEOVER9C2*EDIFF2*(DZYDX)

            F =FYX+FXY+FZX+FXZ+FYZ+FZY
! Add it to the total
            WORK(LTOT2K-1+IJ) = WORK(LTOT2K-1+IJ) + F

            IF(ABS(F).GE.OSTHR2) THEN
             IF(QIALL) WRITE(6,33) I,J,F
            END IF
!
! Debug to move along z.
!
!           ONEOVER3C = 1.0D0/(3.0D0*CONST_C_IN_AU_)
!           DYXDZ=(PROP(J,I,IPRDYX)*ONEOVER3C
!    &           + PROP(J,I,IPRDXX_TEMP)*ONEOVER3C*EDIFF*1.889726D0)
!    &           * PROP(J,I,IPRDZ)
!           DXYDZ=(PROP(J,I,IPRDXY)*ONEOVER3C
!    &           - PROP(J,I,IPRDYY_TEMP)*ONEOVER3C*EDIFF*1.889726D0)
!    &           * PROP(J,I,IPRDZ)
!     print*,'YX,XY moved',PROP(J,I,IPRDYX)
!    &                   + PROP(J,I,IPRDXX_TEMP)*EDIFF*1.889726D0,
!    &                     PROP(J,I,IPRDXY)
!    &                   - PROP(J,I,IPRDYY_TEMP)*EDIFF*1.889726D0
!           FXY=ONEOVER3C*EDIFF2*(DXYDZ)
!           FYX=-ONEOVER3C*EDIFF2*(DYXDZ)

!           DZXDY=PROP(J,I,IPRDZX)*ONEOVER3C*PROP(J,I,IPRDY) !independent
!           DXZDY=(PROP(J,I,IPRDXZ)*ONEOVER3C
!    &           - PROP(J,I,IPRDYZ_TEMP)*ONEOVER3C*EDIFF*1.889726D0  ! changed from IPRDZY_TEMP to IPRDYZ_TEMP
!    &     + PROP(J,I,IPRDY_TEMP)*2.0D0*ONEOVER3C*EDIFF*1.889726D0**2)
!    &           * PROP(J,I,IPRDY) ! skipped magnetic dipole
!     print*,'ZX,XZ moved',PROP(J,I,IPRDZX),
!    &                     PROP(J,I,IPRDXZ)
!    &                   - PROP(J,I,IPRDYZ_TEMP)*EDIFF*1.889726D0
!    &                + PROP(J,I,IPRDY_TEMP)*2.0D0*EDIFF*1.889726D0**2
!           FZX=ONEOVER3C*EDIFF2*(DZXDY)
!           FXZ=-ONEOVER3C*EDIFF2*(DXZDY)

!           DYZDX=(PROP(J,I,IPRDYZ)*ONEOVER3C
!    &           + PROP(J,I,IPRDXZ_TEMP)*ONEOVER3C*EDIFF*1.889726D0 ! changed from IPRDZX_TEMP to IPRDXZ_TEMP
!    &     - PROP(J,I,IPRDX_TEMP)*2.0D0*ONEOVER3C*EDIFF*1.889726D0**2)
!    &           * PROP(J,I,IPRDX)
!           DZYDX=PROP(J,I,IPRDZY)*ONEOVER3C*PROP(J,I,IPRDX)
!     print*,'YZ,ZY moved',PROP(J,I,IPRDYZ)
!    &                   + PROP(J,I,IPRDXZ_TEMP)*EDIFF*1.889726D0
!    &            - PROP(J,I,IPRDX_TEMP)*2.0D0*EDIFF*1.889726D0**2,
!    &              PROP(J,I,IPRDZY)
!           FYZ=ONEOVER3C*EDIFF2*(DYZDX)
!           FZY=-ONEOVER3C*EDIFF2*(DZYDX)
! The new diagonal ones?
!           F =FYX+FXY+FZX+FXZ+FYZ+FZY

!           IF(ABS(F).GE.OSTHR2) THEN
!            WRITE(6,*) ' The moved value '
!            WRITE(6,'(5X,2I5,5X,G16.8)') I,J,F
!           END IF
! End debug
           END IF
          END DO
         END DO
        IF(QIALL) THEN
         WRITE(6,35)

         Call CollapseOutput(0,
     &                  'Electric-Dipole - Magnetic-Quadrupole '//
     &                  'transition strengths (spin-free states):')
        END IF
          SECORD(4) = 1
        END IF
!
! Now write out the total
!
! Add it to the total
!
      I2TOT = 0
      DO I = 1, 4
        IF(SECORD(I).EQ.1) THEN
          I2TOT = I2TOT + 1
        END IF
      END DO
       IF(I2TOT.GE.1) THEN
         IF(SECORD(1).EQ.0)
     &   WRITE(6,*) 'Magnetic-dipole - magnetic-dipole not included'
         IF(SECORD(2).EQ.0)
     &   WRITE(6,*) 'Electric-quadrupole - electric-quadrupole not '//
     &              'included'
         IF(SECORD(3).EQ.0)
     &   WRITE(6,*) 'Electric-dipole - electric-octupole not included'
         IF(SECORD(4).EQ.0)
     &   WRITE(6,*) 'Electric-dipole - magnetic-quadrupole not included'
         iPrint=0
         DO K_=1,IEND
          I=IndexE(K_)
          DO L_=JSTART,NSTATE
           J=IndexE(L_)
           EDIFF=ENERGY(J)-ENERGY(I)
           IF(EDIFF.GT.0.0D0) THEN
!
            IJ=J+NSTATE*(I-1)
            F = WORK(LTOT2K-1+IJ)
            IF(ABS(F).GE.OSTHR2) THEN
            If (iPrint.eq.0) Then
         WRITE(6,*)
         Call CollapseOutput(1,
     &                'Total transition strengths ' //
     &                'for the second-order expansion of the wave ' //
     &                'vector (spin-free states):')
         WRITE(6,'(3X,A)')
     &                '---------------------------'//
     &                '-------------------------------------------'//
     &                '--------------------------'
!
         IF(OSTHR2.GT.0.0D0) THEN
          WRITE(6,30) 'for osc. strength at least',OSTHR2
          WRITE(6,*)
         END IF
         WRITE(6,31) 'From','To','Osc. strength'
         WRITE(6,35)
         iPrint=1
             End If
             WRITE(6,33) I,J,F
             Call Add_Info('TMS(SF,2nd)',[F],1,6)
            END IF
           END IF
          END DO
         END DO
         If (iPrint.eq.1) Then
         WRITE(6,35)
         Call CollapseOutput(0,
     &                'Total transition strengths ' //
     &                'for the second-order expansion of the wave ' //
     &                'vector (spin-free states):')
         End If
       END IF
! release the memory again
       CALL GETMEM('TOT2K','FREE','REAL',LTOT2K,NSTATE**2)
!
!
      IF(DOCD) THEN
* Lasse 2019
* New CD here with electric dipole and magnetic-dipole - velocity gauge
        IPRDXD=0
        IPRDYD=0
        IPRDZD=0
        IPRDXM=0
        IPRDYM=0
        IPRDZM=0
        IPRQXX=0
        IPRQXY=0
        IPRQXZ=0
        IPRQYY=0
        IPRQYZ=0
        IPRQZZ=0

        IFANYD=0
        IFANYM=0
        IFANYQ=0
        DO IPROP=1,NPROP
          IF (PNAME(IPROP).EQ.'VELOCITY') THEN
           IFANYD=1
           IF(ICOMP(IPROP).EQ.1) IPRDXD=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDYD=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDZD=IPROP
          ELSE IF(PNAME(IPROP).EQ.'ANGMOM  ') THEN
           IFANYM=1
           IF(ICOMP(IPROP).EQ.1) IPRDXM=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDYM=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDZM=IPROP
          ELSE IF(PNAME(IPROP).EQ.'MLTPV  2') THEN
           IFANYQ=1
           IF(ICOMP(IPROP).EQ.1) IPRQXX=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRQXY=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRQXZ=IPROP
           IF(ICOMP(IPROP).EQ.4) IPRQYY=IPROP
           IF(ICOMP(IPROP).EQ.5) IPRQYZ=IPROP
           IF(ICOMP(IPROP).EQ.6) IPRQZZ=IPROP
          END IF
        END DO

        IF((IFANYD.NE.0).AND.(IFANYM.NE.0)) THEN
!
! Only print the part calculated
!
         WRITE(6,*)
         Call CollapseOutput(1,
     &                 'Circular Dichroism - velocity gauge '//
     &                 'Electric-Dipole - Magnetic-Dipole '//
     &                 'rotatory strengths (spin-free states):')
         WRITE(6,'(3X,A)')
     &                 '------------------------------------'//
     &                 '----------------------------------'//
     &                 '--------------------------------------'
         IF (DO_SK) THEN
           WRITE(6,30) 'For red. rot. strength at least',RSTHR
         ELSE
           WRITE(6,30) 'For isotropic red. rot. strength at least',RSTHR
         END IF

         WRITE(6,*)
*
         If (Do_SK.AND.(IFANYQ.NE.0)) Then
            nVec = nk_Vector
         Else
            nVec = 1
         End If
*
         Do iVec = 1, nVec
*
         If (Do_SK.AND.(IFANYQ.NE.0)) Then
            WRITE(6,*)
            WRITE(6,'(4x,a,3F10.6)')
     &         'Direction of the k-vector: ',
     &          (k_vector(k,iVec),k=1,3)
            WRITE(6,*)
            WRITE(6,31) 'From','To','Red. rot. str.'
         Else
            WRITE(6,31) 'From','To','Red. rot. str.'
            IF (IFANYQ.NE.0)
     &         WRITE(6,44) 'Rxx','Rxy','Rxz','Ryy','Ryz','Rzz'
         End If
         WRITE(6,35)
!
         DO K_=1,IEND
            I=IndexE(K_)
          DO L_=JSTART,NSTATE
             J=IndexE(L_)
           EDIFF=ENERGY(J)-ENERGY(I)
           IF(EDIFF.GT.0.0D0) THEN

*           R = e^2*hbar/(2*m^2*E) <J|p|I>.<I|l|J>
*             = e^2*hbar/(2*m^2*E) -i*hbar*<J|nabla|I>.-i*hbar*<I|r x nabla|J>
*             = e^2*hbar^3/(2*m^2*E) <J|nabla|I>.<J|r x nabla|I>

            RXX=0.0D0
            RYY=0.0D0
            RZZ=0.0D0
            IF((IPRDXD.GT.0).AND.(IPRDXM.GT.0)) THEN
              RXX=PROP(J,I,IPRDXD)*PROP(J,I,IPRDXM)
            END IF
            IF((IPRDYD.GT.0).AND.(IPRDYM.GT.0)) THEN
              RYY=PROP(J,I,IPRDYD)*PROP(J,I,IPRDYM)
            END IF
            IF((IPRDZD.GT.0).AND.(IPRDZM.GT.0)) THEN
              RZZ=PROP(J,I,IPRDZD)*PROP(J,I,IPRDZM)
            END IF
            R = RXX+RYY+RZZ
            R = R*Half/EDIFF*AU2REDR
*
* Compute full rotatory strength tensor
* (see Hansen and Bak, 10.1021/jp001899+)
*
            IF (IFANYQ.NE.0) THEN
             RXY=0.0D0
             RXZ=0.0D0
             RYX=0.0D0
             RYZ=0.0D0
             RZX=0.0D0
             RZY=0.0D0
             RXXY=0.0D0
             RXXZ=0.0D0
             RXYX=0.0D0
             RXYZ=0.0D0
             RXZX=0.0D0
             RXZY=0.0D0
             RXYY=0.0D0
             RYYX=0.0D0
             RYYZ=0.0D0
             RYZX=0.0D0
             RYZY=0.0D0
             RXZZ=0.0D0
             RYZZ=0.0D0
             RZZX=0.0D0
             RZZY=0.0D0
             IF((IPRDXD.GT.0).AND.(IPRDYM.GT.0)) THEN
               RXY=PROP(J,I,IPRDXD)*PROP(J,I,IPRDYM)
             END IF
             IF((IPRDXD.GT.0).AND.(IPRDZM.GT.0)) THEN
               RXZ=PROP(J,I,IPRDXD)*PROP(J,I,IPRDZM)
             END IF
             IF((IPRDYD.GT.0).AND.(IPRDXM.GT.0)) THEN
               RYX=PROP(J,I,IPRDYD)*PROP(J,I,IPRDXM)
             END IF
             IF((IPRDYD.GT.0).AND.(IPRDZM.GT.0)) THEN
               RYZ=PROP(J,I,IPRDYD)*PROP(J,I,IPRDZM)
             END IF
             IF((IPRDZD.GT.0).AND.(IPRDXM.GT.0)) THEN
               RZX=PROP(J,I,IPRDZD)*PROP(J,I,IPRDXM)
             END IF
             IF((IPRDZD.GT.0).AND.(IPRDYM.GT.0)) THEN
               RZY=PROP(J,I,IPRDZD)*PROP(J,I,IPRDYM)
             END IF
             IF((IPRQXX.GT.0).AND.(IPRDYD.GT.0)) THEN
               RXXY=PROP(J,I,IPRQXX)*PROP(J,I,IPRDYD)
             END IF
             IF((IPRQXX.GT.0).AND.(IPRDZD.GT.0)) THEN
               RXXZ=PROP(J,I,IPRQXX)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQXY.GT.0).AND.(IPRDXD.GT.0)) THEN
               RXYX=PROP(J,I,IPRQXY)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQXY.GT.0).AND.(IPRDZD.GT.0)) THEN
               RXYZ=PROP(J,I,IPRQXY)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQXZ.GT.0).AND.(IPRDXD.GT.0)) THEN
               RXZX=PROP(J,I,IPRQXZ)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQXZ.GT.0).AND.(IPRDYD.GT.0)) THEN
              RXZY=PROP(J,I,IPRQXZ)*PROP(J,I,IPRDYD)
             END IF
             IF((IPRQXY.GT.0).AND.(IPRDYD.GT.0)) THEN
               RXYY=PROP(J,I,IPRQXY)*PROP(J,I,IPRDYD)
             END IF
             IF((IPRQYY.GT.0).AND.(IPRDXD.GT.0)) THEN
               RYYX=PROP(J,I,IPRQYY)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQYY.GT.0).AND.(IPRDZD.GT.0)) THEN
               RYYZ=PROP(J,I,IPRQYY)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQYZ.GT.0).AND.(IPRDXD.GT.0)) THEN
               RYZX=PROP(J,I,IPRQYZ)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQYZ.GT.0).AND.(IPRDYD.GT.0)) THEN
               RYZY=PROP(J,I,IPRQYZ)*PROP(J,I,IPRDYD)
             END IF
             IF((IPRQXZ.GT.0).AND.(IPRDZD.GT.0)) THEN
               RXZZ=PROP(J,I,IPRQXZ)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQYZ.GT.0).AND.(IPRDZD.GT.0)) THEN
               RYZZ=PROP(J,I,IPRQYZ)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQZZ.GT.0).AND.(IPRDXD.GT.0)) THEN
               RZZX=PROP(J,I,IPRQZZ)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQZZ.GT.0).AND.(IPRDYD.GT.0)) THEN
               RZZY=PROP(J,I,IPRQZZ)*PROP(J,I,IPRDYD)
             END IF
             ! xx, xy, xz, yy, yz, zz
             Rtensor(1) =  0.75D0 *(RYY+RZZ + (RXYZ-RXZY))
             Rtensor(2) = -0.375D0*(RXY+RYX + (RXXZ+RYZY-RXZX-RYYZ))
             Rtensor(3) = -0.375D0*(RXZ+RZX + (RXYX+RZZY-RXXY-RYZZ))
             Rtensor(4) =  0.75D0 *(RXX+RZZ + (RYZX-RXYZ))
             Rtensor(5) = -0.375D0*(RYZ+RZY + (RYYX+RXZZ-RXYY-RZZX))
             Rtensor(6) =  0.75D0 *(RXX+RYY + (RXZY-RYZX))
             CALL DSCAL_(9,AU2REDR/EDIFF,Rtensor,1)
             IF (Do_SK) THEN
              ! k^T R k
              R = k_vector(1,iVec)**2*Rtensor(1)+
     &            k_vector(2,iVec)**2*Rtensor(4)+
     &            k_vector(3,iVec)**2*Rtensor(6)+
     &            2.0D0*k_vector(1,iVec)*k_vector(2,iVec)*Rtensor(2)+
     &            2.0D0*k_vector(1,iVec)*k_vector(3,iVec)*Rtensor(3)+
     &            2.0D0*k_vector(2,iVec)*k_vector(3,iVec)*Rtensor(5)
             ELSE
                WRITE(6,43) 'tensor: ',Rtensor(:)
             END IF
            END IF
*
            IF(ABS(R).GT.RSTHR) THEN
              WRITE(6,33) I,J,R
            END IF
!
            Call Add_Info('CD_V(SF)',[R],1,6)
           END IF
          END DO
         END DO
         WRITE(6,35)
         End Do

         Call CollapseOutput(0,
     &                  'Circular Dichroism - velocity gauge '//
     &                  'Electric-Dipole - Magnetic-Dipole '//
     &                  'rotatory strengths (spin-free states):')
        END IF
!
* Lasse 2019
* New CD here with electric dipole and magnetic-dipole - mixed gauge
* Usually refered to as the length gauge
        IPRDXD=0
        IPRDYD=0
        IPRDZD=0
        IPRDXM=0
        IPRDYM=0
        IPRDZM=0
        IPRQXX=0
        IPRQXY=0
        IPRQXZ=0
        IPRQYY=0
        IPRQYZ=0
        IPRQZZ=0

        IFANYD=0
        IFANYM=0
        IFANYQ=0
        DO IPROP=1,NPROP
          IF(PTYPE(IPROP)(5:8).NE.'SING') CYCLE
          IF (PNAME(IPROP).EQ.'MLTPL  1') THEN
           IFANYD=1
           IF(ICOMP(IPROP).EQ.1) IPRDXD=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDYD=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDZD=IPROP
          ELSE IF(PNAME(IPROP).EQ.'ANGMOM  ') THEN
           IFANYM=1
           IF(ICOMP(IPROP).EQ.1) IPRDXM=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRDYM=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRDZM=IPROP
          ELSE IF(PNAME(IPROP).EQ.'MLTPL  2') THEN
           IFANYQ=1
           IF(ICOMP(IPROP).EQ.1) IPRQXX=IPROP
           IF(ICOMP(IPROP).EQ.2) IPRQXY=IPROP
           IF(ICOMP(IPROP).EQ.3) IPRQXZ=IPROP
           IF(ICOMP(IPROP).EQ.4) IPRQYY=IPROP
           IF(ICOMP(IPROP).EQ.5) IPRQYZ=IPROP
           IF(ICOMP(IPROP).EQ.6) IPRQZZ=IPROP
          END IF
        END DO

        IF((IFANYD.NE.0).AND.(IFANYM.NE.0)) THEN
!
! Only print the part calculated
!
         WRITE(6,*)
         Call CollapseOutput(1,
     &                 'Circular Dichroism - mixed gauge '//
     &                 'Electric-Dipole - Magnetic-Dipole '//
     &                 'rotatory strengths (spin-free states):')
         WRITE(6,'(3X,A)')
     &                 '---------------------------------'//
     &                 '----------------------------------'//
     &                 '--------------------------------------'
         WRITE(6,*)
         WRITE(6,*) ' WARNING WARNING WARNING !!! '
         WRITE(6,*)
         WRITE(6,*) ' Circular Dichroism in the mixed gauge '
         WRITE(6,*) ' is NOT origin independent - check your results '
         IF (DO_SK) THEN
           WRITE(6,30) 'For red. rot. strength at least',RSTHR
         ELSE
           WRITE(6,30) 'For isotropic red. rot. strength at least',RSTHR
         END IF
         WRITE(6,*)
*
         If (Do_SK.AND.(IFANYQ.NE.0)) Then
            nVec = nk_Vector
         Else
            nVec = 1
         End If
*
         Do iVec = 1, nVec
*
         If (Do_SK.AND.(IFANYQ.NE.0)) Then
            WRITE(6,*)
            WRITE(6,'(4x,a,3F10.6)')
     &         'Direction of the k-vector: ',
     &          (k_vector(k,iVec),k=1,3)
            WRITE(6,*)
            WRITE(6,31) 'From','To','Red. rot. str.'
         Else
            WRITE(6,31) 'From','To','Red. rot. str.'
            IF (IFANYQ.NE.0)
     &         WRITE(6,44) 'Rxx','Rxy','Rxz','Ryy','Ryz','Rzz'
         End If
         WRITE(6,35)
!
         DO K_=1,IEND
            I=IndexE(K_)
          DO L_=JSTART,NSTATE
             J=IndexE(L_)
           EDIFF=ENERGY(J)-ENERGY(I)
           IF(EDIFF.GT.0.0D0) THEN

*           R = -i*e^2/(2*m) <J|r|I>.<I|l|J>
*             = -i*e^2/(2*m) <J|r|I>.-i*hbar*<I|r x nabla|J>
*             = e^2*hbar/(2*m) <J|r|I>.<J|r x nabla|I>

            RXX=0.0D0
            RYY=0.0D0
            RZZ=0.0D0
            IF((IPRDXD.GT.0).AND.(IPRDXM.GT.0)) THEN
              RXX=PROP(J,I,IPRDXD)*PROP(J,I,IPRDXM)
            END IF
            IF((IPRDYD.GT.0).AND.(IPRDYM.GT.0)) THEN
              RYY=PROP(J,I,IPRDYD)*PROP(J,I,IPRDYM)
            END IF
            IF((IPRDZD.GT.0).AND.(IPRDZM.GT.0)) THEN
              RZZ=PROP(J,I,IPRDZD)*PROP(J,I,IPRDZM)
            END IF
            R = RXX+RYY+RZZ
            R = R*Half*AU2REDR
*
* Compute full rotatory strength tensor
* (see Hansen and Bak, 10.1021/jp001899+)
*
            IF (IFANYQ.NE.0) THEN
             RXY=0.0D0
             RXZ=0.0D0
             RYX=0.0D0
             RYZ=0.0D0
             RZX=0.0D0
             RZY=0.0D0
             RXXY=0.0D0
             RXXZ=0.0D0
             RXYX=0.0D0
             RXYZ=0.0D0
             RXZX=0.0D0
             RXZY=0.0D0
             RXYY=0.0D0
             RYYX=0.0D0
             RYYZ=0.0D0
             RYZX=0.0D0
             RYZY=0.0D0
             RXZZ=0.0D0
             RYZZ=0.0D0
             RZZX=0.0D0
             RZZY=0.0D0
             IF((IPRDXD.GT.0).AND.(IPRDYM.GT.0)) THEN
               RXY=PROP(J,I,IPRDXD)*PROP(J,I,IPRDYM)
             END IF
             IF((IPRDXD.GT.0).AND.(IPRDZM.GT.0)) THEN
               RXZ=PROP(J,I,IPRDXD)*PROP(J,I,IPRDZM)
             END IF
             IF((IPRDYD.GT.0).AND.(IPRDXM.GT.0)) THEN
               RYX=PROP(J,I,IPRDYD)*PROP(J,I,IPRDXM)
             END IF
             IF((IPRDYD.GT.0).AND.(IPRDZM.GT.0)) THEN
               RYZ=PROP(J,I,IPRDYD)*PROP(J,I,IPRDZM)
             END IF
             IF((IPRDZD.GT.0).AND.(IPRDXM.GT.0)) THEN
               RZX=PROP(J,I,IPRDZD)*PROP(J,I,IPRDXM)
             END IF
             IF((IPRDZD.GT.0).AND.(IPRDYM.GT.0)) THEN
               RZY=PROP(J,I,IPRDZD)*PROP(J,I,IPRDYM)
             END IF
             IF((IPRQXX.GT.0).AND.(IPRDYD.GT.0)) THEN
               RXXY=PROP(J,I,IPRQXX)*PROP(J,I,IPRDYD)
             END IF
             IF((IPRQXX.GT.0).AND.(IPRDZD.GT.0)) THEN
               RXXZ=PROP(J,I,IPRQXX)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQXY.GT.0).AND.(IPRDXD.GT.0)) THEN
               RXYX=PROP(J,I,IPRQXY)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQXY.GT.0).AND.(IPRDZD.GT.0)) THEN
               RXYZ=PROP(J,I,IPRQXY)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQXZ.GT.0).AND.(IPRDXD.GT.0)) THEN
               RXZX=PROP(J,I,IPRQXZ)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQXZ.GT.0).AND.(IPRDYD.GT.0)) THEN
               RXZY=PROP(J,I,IPRQXZ)*PROP(J,I,IPRDYD)
             END IF
             IF((IPRQXY.GT.0).AND.(IPRDYD.GT.0)) THEN
               RXYY=PROP(J,I,IPRQXY)*PROP(J,I,IPRDYD)
             END IF
             IF((IPRQYY.GT.0).AND.(IPRDXD.GT.0)) THEN
               RYYX=PROP(J,I,IPRQYY)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQYY.GT.0).AND.(IPRDZD.GT.0)) THEN
               RYYZ=PROP(J,I,IPRQYY)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQYZ.GT.0).AND.(IPRDXD.GT.0)) THEN
               RYZX=PROP(J,I,IPRQYZ)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQYZ.GT.0).AND.(IPRDYD.GT.0)) THEN
               RYZY=PROP(J,I,IPRQYZ)*PROP(J,I,IPRDYD)
             END IF
             IF((IPRQXZ.GT.0).AND.(IPRDZD.GT.0)) THEN
               RXZZ=PROP(J,I,IPRQXZ)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQYZ.GT.0).AND.(IPRDZD.GT.0)) THEN
               RYZZ=PROP(J,I,IPRQYZ)*PROP(J,I,IPRDZD)
             END IF
             IF((IPRQZZ.GT.0).AND.(IPRDXD.GT.0)) THEN
               RZZX=PROP(J,I,IPRQZZ)*PROP(J,I,IPRDXD)
             END IF
             IF((IPRQZZ.GT.0).AND.(IPRDYD.GT.0)) THEN
               RZZY=PROP(J,I,IPRQZZ)*PROP(J,I,IPRDYD)
             END IF
             ! xx, xy, xz, yy, yz, zz
             Rtensor(1) =  0.75D0 *(RYY+RZZ+EDIFF*(RXYZ-RXZY))
             Rtensor(2) = -0.375D0*(RXY+RYX+EDIFF*(RXXZ+RYZY-RXZX-RYYZ))
             Rtensor(3) = -0.375D0*(RXZ+RZX+EDIFF*(RXYX+RZZY-RXXY-RYZZ))
             Rtensor(4) =  0.75D0 *(RXX+RZZ+EDIFF*(RYZX-RXYZ))
             Rtensor(5) = -0.375D0*(RYZ+RZY+EDIFF*(RYYX+RXZZ-RXYY-RZZX))
             Rtensor(6) =  0.75D0 *(RXX+RYY+EDIFF*(RXZY-RYZX))
             CALL DSCAL_(9,AU2REDR,Rtensor,1)
             IF (Do_SK) THEN
              ! k^T R k
              R = k_vector(1,iVec)**2*Rtensor(1)+
     &            k_vector(2,iVec)**2*Rtensor(4)+
     &            k_vector(3,iVec)**2*Rtensor(6)+
     &            2.0D0*k_vector(1,iVec)*k_vector(2,iVec)*Rtensor(2)+
     &            2.0D0*k_vector(1,iVec)*k_vector(3,iVec)*Rtensor(3)+
     &            2.0D0*k_vector(2,iVec)*k_vector(3,iVec)*Rtensor(5)
             ELSE
                WRITE(6,43) 'tensor: ',Rtensor(:)
             END IF
            END IF
*
            IF(ABS(R).GT.RSTHR) THEN
              WRITE(6,33) I,J,R
            END IF

            Call Add_Info('CD_M(SF)',[R],1,6)
           END IF
          END DO
         END DO
         WRITE(6,35)
         End Do

         Call CollapseOutput(0,
     &                  'Circular Dichroism - mixed gauge '//
     &                  'Electric-Dipole - Magnetic-Dipole '//
     &                  'rotatory strengths (spin-free states):')
        END IF
      END IF
* CD end

*
! +++ J. Norell 12/7 - 2018
! Dyson amplitudes for (1-electron) ionization transitions
       IF (DYSO) THEN
        DYSTHR=1.0D-5
        WRITE(6,*)
        CALL CollapseOutput(1,'Dyson amplitudes '//
     &                        '(spin-free states):')
        WRITE(6,'(3X,A)')     '----------------------------'//
     &                        '-------------------'
        IF (DYSTHR.GT.0.0D0) THEN
           WRITE(6,30) 'for Dyson intensities at least',DYSTHR
           WRITE(6,30)
        END IF
        WRITE(6,*) '       From      To        '//
     &   'BE (eV)       Dyson intensity'
        WRITE(6,32)
        FMAX=0.0D0
        DO I_=1,NSTATE
           I=IndexE(I_)
         DO J_=1,NSTATE
            J=IndexE(J_)
          F=DYSAMPS(I,J)*DYSAMPS(I,J)
          EDIFF=AU2EV*(ENERGY(J)-ENERGY(I))
          IF (F.GT.0.00001) THEN
           IF (EDIFF.GT.0.0D0) THEN
            WRITE(6,'(A,I8,I8,F15.3,E22.5)') '    ',I,J,EDIFF,F
           END IF
          END IF
         END DO ! J
        END DO ! I
       END IF
! +++ J. Norell


************************************************************************
*                                                                      *
*     Start of section for transition moments                          *
*                                                                      *
************************************************************************
*
*     Find the section of transition moments in the property list.
*
*     The operator is split in 4 different component, each with three
*     elements corresponding to differentiation in the x, y, and z
*     direction.
*
************************************************************************
*                                                                      *
*     Computation of the isotropic oscillator strength.                *
*                                                                      *
************************************************************************
*
      If (.Not.Do_TMOM) Go To 900
#define _TIME_TMOM_
#ifdef _TIME_TMOM_
      Call CWTime(TCpu1,TWall1)
#endif
      Call mma_Allocate(TDMZZ,nTDMZZ,Label='TDMZZ')
      Call mma_Allocate(TSDMZZ,nTDMZZ,Label='TSDMZZ')
      Call mma_Allocate(WDMZZ,nTDMZZ,Label='WDMZZ')
      nSCR=(NBST*(NBST+1))/2
      Call mma_allocate(SCR,nSCR,4,LABEL='SCR')

*
*     Here we will use a Lebedev grid to integrate over all possible
*     directions of the wave vector, k. The property integrals will be
*     computed on the fly and traced with the density to generate the
*     corresponding values in the PROP matrix.
*
*     Find the slot on the one-electron file where we will store the
*     on-the-fly generated property integrals.
*
      IPRTMOM(:)=-1
      DO IPROP=1,NPROP
         IF (PNAME(IPROP).EQ.'TMOM  RS') THEN
            IF (IPRTMOM(0+ICOMP(IPROP)).EQ.-1)
     &          IPRTMOM(0+ICOMP(IPROP))=IPROP
         END IF
         IF (PNAME(IPROP).EQ.'TMOM  IS') THEN
            IF (IPRTMOM(3+ICOMP(IPROP)).EQ.-1)
     &          IPRTMOM(3+ICOMP(IPROP))=IPROP
         END IF
         IF (PNAME(IPROP).EQ.'TMOM  RA') THEN
            IF (IPRTMOM(6+ICOMP(IPROP)).EQ.-1)
     &          IPRTMOM(6+ICOMP(IPROP))=IPROP
         END IF
         IF (PNAME(IPROP).EQ.'TMOM  IA') THEN
            IF (IPRTMOM(9+ICOMP(IPROP)).EQ.-1)
     &          IPRTMOM(9+ICOMP(IPROP))=IPROP
         END IF
      ENDDO
      IF (ANY(IPRTMOM.EQ.-1)) RETURN
*
*     Initiate the Seward environment
*
      nDiff=0
      Call IniSew(.FALSE.,nDiff)
*
*     Generate the quadrature points.
*
      If (Do_SK) Then
         nQuad=1
         Call mma_Allocate(Rquad,4,nQuad,label='SK')
         nVec = nk_Vector
      Else
         Call Setup_O()
*        In the spin-free case, oscillator and rotatory strengths for k and -k
*        are equal, so we compute only half the quadrature points and multiply
*        the weights by 2
         Call Do_Lebedev_Sym(L_Eff,nQuad,Rquad)
         Rquad(4,:) = 2.0D0*Rquad(4,:)
         nVec = 1
      End If
      If (Do_Pol) Call mma_allocate(pol_Vector,3,nVec*nQuad,Label='POL')
*
*     Scratch for one-electron integrals
*
      NIP=4+(NBST*(NBST+1))/2
      CALL GETMEM('IP    ','ALLO','REAL',LIP,NIP)
#ifdef _HDF5_
*
*     Allocate vector to store all individual transition moments.
*     We do this for
*     all unique pairs I-J, I=/=J (NSTATE*(NSTATE-1)/2)
*         all k-vectors (nQuad or nVec)
*             we store:
*                 the weight (1)
*                 the k-vector (3)
*                 the projected transition vector (real and imaginary parts) (2*3)
*
      nIJ=nState*(nState-1)/2
      ip_w       = 1
      ip_kvector = ip_w + 1
      ip_TMR     = ip_kvector + 3
      ip_TMI     = ip_TMR + 3
      nData      = ip_TMI + 3 - 1
      Call mma_allocate(Storage,nData,nQuad,nIJ,nVec,label='Storage')
      Call dCopy_(Size(Storage),[0.0D0],0,Storage,1)
#endif
*MGD create the groups of indices
*Only with reduce loop to make things easier
      TMOgroup=.false.
      ngroup1=IEND
      ngroup2=NSTATE-JSTART+1
      nmax2=1
      IF(REDUCELOOP.and.TMGr_thrs.ge.0.0d0) THEN
        TMOgroup=.true.
        THRS=TMGr_thrs
        i=IndexE(IEND)
        RefEne=0
        TAU=-1
        ngroup2=1
        Do j_=JSTART,NSTATE
           j=IndexE(j_)
           if (ENERGY(J)-Refene.gt.TAU) then
              NGROUP2=NGROUP2+1
              Refene=ENERGY(J)
              ediff=Refene-ENERGY(I)
              TAU=ediff*THRS
           EndIf
        End Do
        Call mma_Allocate(TMOgrp2,NGROUP2,Label='TMOgrp2')
        ngroup2=0
        TAU=-1
        RefEne=0
        Do j_=JSTART,NSTATE
           j=IndexE(j_)
           if (ENERGY(J)-Refene.gt.TAU) then
              NGROUP2=NGROUP2+1
              TMOgrp2(NGROUP2)=J_
              Refene=ENERGY(J)
              ediff=Refene-ENERGY(I)
              TAU=ediff*THRS
           EndIf
        End Do
        TMOgrp2(ngroup2+1)=NSTATE+1
*
        j=IndexE(JSTART)
        Refene=ENERGY(j)
        TAU=-1
        ngroup1=1
        Do i_=IEND,1,-1
          i=IndexE(i_)
          if (Refene-ENERGY(i).gt.TAU) then
            ngroup1=ngroup1+1
            Refene=energy(i)
            ediff=energy(j)-Refene
            Tau=ediff*THRS
          EndIf
        End Do
        Call mma_Allocate(TMOgrp1,NGROUP1,Label='TMOgrp1')
        Ntmp=Ngroup1
        Ngroup1=Ngroup1-1
        Refene=ENERGY(j)
        TAU=-1
        Do i_=IEND,1,-1
          i=IndexE(i_)
          if (Refene-ENERGY(i).gt.TAU) then
            TMOgrp1(ntmp)=i_+1
            ntmp=ntmp-1
            Refene=energy(i)
            ediff=energy(j)-Refene
            Tau=ediff*THRS
          EndIf
        End Do
        TMOgrp1(1)=1
*       write(6,*) (TMOgrp1(i),i=1,ngroup1+1)
*       write(6,*) (TMOgrp2(i),i=1,ngroup2+1)
        maxgrp1=0
        Do i=1,ngroup1
          maxgrp1=max(maxgrp1,TMOgrp1(i+1)-TMOgrp1(i))
        End Do
        maxgrp2=0
        Do i=1,ngroup2
          maxgrp2=max(maxgrp2,TMOgrp2(i+1)-TMOgrp2(i))
        End Do
        nmax2=maxgrp1*maxgrp2
      EndIF
*
*     Array for printing contributions from different directions
*
      CALL GETMEM('RAW   ','ALLO','REAL',LRAW,NQUAD*6*nmax2)
      CALL GETMEM('OSCSTR','ALLO','REAL',LF,2*nmax2)
      CALL GETMEM('MAXMIN','ALLO','REAL',LMAX,8*nmax2)
      LMAX_=0
*
      Do iVec = 1, nVec
         If (Do_SK) Then
            Rquad(1:3,1)=k_Vector(:,iVec)
            Rquad(4,1)=1.0D0   ! Dummy weight
         End If
*
      iPrint=0
      IJSO=0
      Do igrp=1,ngroup1
         Do jgrp=1,ngroup2
*
            If (TMOgroup) Then
              istart_=TMOgrp1(igrp)
              iend_=TMOgrp1(igrp+1)-1
              jstart_=TMOgrp2(jgrp)
              jend_=TMOgrp2(jgrp+1)-1
              EDIFF_=(ENERGY(IndexE(jstart_))+ENERGY(IndexE(jend_))
     &              -ENERGY(IndexE(istart_))-ENERGY(IndexE(iend_)))
     &              *Half
            Else
              istart_=igrp
              iend_=igrp
              jstart_=jgrp+jstart-1
              jend_=jgrp+jstart-1
              EDIFF_=ENERGY(IndexE(jstart_))-ENERGY(IndexE(istart_))
            EndIf
            n12=(iend_-istart_+1)*(jend_-jstart_+1)
            If (ABS(EDIFF_).le.1.0D-8) CYCLE
*
            If (JSTART.eq.1 .AND.  EDIFF_.LT.0.0D0) CYCLE
*
            IJSO=IJSO+1
*
*           The energy difference is used to define the norm of the
*           wave vector.
*
            rkNorm=ABS(EDIFF_)/SPEED_OF_LIGHT
*
*           Iterate over the quadrature points.
*
            CALL DCOPY_(2*n12,[0.0D0],0,WORK(LF),1)
*
*           Initialize output arrays
*
            CALL DCOPY_(NQUAD*6*n12,[0.0D0],0,WORK(LRAW),1)
            CALL DCOPY_(8*n12,[0.0D0],0,WORK(LMAX),1)
*
            Do iQuad = 1, nQuad
               iVec_=(iVec-1)*nQuad+iQuad
*
*              Read or generate the wavevector
*
*              Generate the wavevector associated with this quadrature
*              point and pick up the associated quadrature weight.
*
               UK(:)=Rquad(1:3,iQuad)
               Wavevector(:)=rkNorm*UK(:)
*
*              Note that the weights are normalized to integrate to
*              4*pi over the solid angles.
*
               Weight=Rquad(4,iQuad)
               If (.Not.Do_SK) Weight=Weight/(4.0D0*PI)
*
*              Generate the polarization vector
*
               If (Do_Pol) Then
                  pol_Vector(:,iVec_)=
     &               e_Vector-DDot_(3,UK,1,e_Vector,1)*UK
                  rNorm=DDot_(3,pol_Vector(:,iVec_),1,
     &                         pol_Vector(:,iVec_),1)
                  If (rNorm.gt.1.0D-12) Then
                     pol_Vector(:,iVec_)=pol_Vector(:,iVec_)/Sqrt(rNorm)
                  Else
                     pol_Vector(:,iVec_)=0.0D0
                  End If
               End If
*
*              Generate the property integrals associated with this
*              direction of the wave vector k.
*
               iOpt=1
               Call TMOMInt(Wavevector,iOpt)
*
*              Compute the transition property of the property
*              integrals between the two states.
*
               ij_=0
               Do i_=istart_,iend_
                  I=IndexE(I_)
                  Do j_=jstart_,jend_
                     J=IndexE(J_)
                     EDIFF=ENERGY(J)-ENERGY(I)
                     ij_=ij_+1
                     LFIJ=LF+(ij_-1)*2
C COMBINED SYMMETRY OF STATES:
                     JOB1=JBNUM(I)
                     JOB2=JBNUM(J)
                     LSYM1=IRREP(JOB1)
                     LSYM2=IRREP(JOB2)
                     ISY12=MUL(LSYM1,LSYM2)
C THE SYMMETRY CHECK MASK:
                     MASK=2**(ISY12-1)
C ALLOCATE A BUFFER FOR READING ONE-ELECTRON INTEGRALS
C FIRST SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS OF TDMSCR
                     Call mk_IOFF(IOFF,nSYM,NBASF,ISY12)
C CALCULATE THE SYMMETRIC AND ANTISYMMETRIC FOLDED TRANS D MATRICES
C AND SIMILAR WE-REDUCED SPIN DENSITY MATRICES
*
*           Pick up the transition density between the two states from
*           disc. Generated in GTDMCTL.
*
                     ISTATE=MAX(i,j)
                     JSTATE=MIN(i,j)
                     ij=ISTATE*(ISTATE-1)/2+JSTATE
                     If (Diagonal) Then
                        IDISK=iDisk_TDM(I,J,1)
                        iEmpty=iDisk_TDM(I,J,2)
                        iOpt=2
                        iGo=5
                        CALL dens2file(TDMZZ,TSDMZZ,WDMZZ,nTDMZZ,
     &                                 LUTDM,IDISK,iEmpty,iOpt,iGo,I,J)
                        Call MK_TWDM(nSym,TDMZZ,WDMZZ,nTDMZZ,SCR,nSCR,
     &                               IOFF,NBASF,ISY12)
                        DO IPRP = 1,12
                           IPROP=IPRTMOM(IPRP)
                           ITYPE=0
                           IF (PTYPE(IPROP).EQ.'HERMSING') ITYPE=1
                           IF (PTYPE(IPROP).EQ.'ANTISING') ITYPE=2
                           IF (PTYPE(IPROP).EQ.'HERMTRIP') ITYPE=3
                           IF (PTYPE(IPROP).EQ.'ANTITRIP') ITYPE=4
                           LABEL=PNAME(IPROP)
                           Call MK_PROP(PROP,IPROP,I,J,LABEL,ITYPE,
     &                                  WORK(LIP),NIP,SCR,nSCR,
     &                                  MASK,ISY12,IOFF)
                        END DO ! IPRP
                     Else

                        Do IPRP=1,12
                           Prop(:,:,IPRTMOM(IPRP))=0.0D0
                        End Do
                        Do k_ = 1, nState
                           k=IndexE(k_)
                           JOB3=JBNUM(k)
                           LSYM3=IRREP(JOB3)
                           If (Abs(EigVec(k,I)) .lt. 1.0D-10 .and.
     &                         Abs(EigVec(k,J)) .lt. 1.0D-10) Cycle
                           Do l_ = 1, k
                              l=IndexE(l_)
                              JOB4=JBNUM(l)
                              LSYM4=IRREP(JOB4)
                              If (Abs(EigVec(l,I)) .lt. 1.0D-10 .and.
     &                            Abs(EigVec(l,J)) .lt. 1.0D-10) Cycle
*
                              ISY34=MUL(LSYM3,LSYM4)
*
                              MASK34=2**(ISY34-1)
                              Call mk_IOFF(IOFF,nSYM,NBASF,ISY34)
*
                              IDISK=iDisk_TDM(k,l,1)
                              iEmpty=iDisk_TDM(k,l,2)
                              iOpt=2
                              iGo=5
                              CALL dens2file(TDMZZ,TSDMZZ,WDMZZ,nTDMZZ,
     &                                       LUTDM,IDISK,iEmpty,iOpt,
     &                                       iGo,k,l)
                              Call MK_TWDM(nSym,TDMZZ,WDMZZ,nTDMZZ,
     &                                     SCR,nSCR,IOFF,NBASF,ISY34)
*
                              DO IPRP = 1,12
                                 IPROP=IPRTMOM(IPRP)
                                 ITYPE=0
                                 IF (PTYPE(IPROP).EQ.'HERMSING') ITYPE=1
                                 IF (PTYPE(IPROP).EQ.'ANTISING') ITYPE=2
                                 IF (PTYPE(IPROP).EQ.'HERMTRIP') ITYPE=3
                                 IF (PTYPE(IPROP).EQ.'ANTITRIP') ITYPE=4
                                 LABEL=PNAME(IPROP)
                                 Call MK_PROP(PROP,IPROP,K,L,LABEL,ITYPE
     &                                       ,WORK(LIP),NIP,SCR,nSCR,
     &                                        MASK34,ISY34,IOFF)
                              END DO ! IPRP
                           End Do
                        End Do
*
*                       Transform to the new basis. Do it just for the
*                       elements we will use.
*
                        CALL GETMEM('SCR','ALLO','REAL',LSCR,NSTATE)
                        Call FZero(Work(lSCR),nState)
                        DO IP=1,12
                           IPROP=IPRTMOM(IP)
                           CALL DGEMM_('N','N',NSTATE,1,NSTATE,
     &                                 1.0D0,PROP(1,1,IPROP),NSTATE,
     &                                       EIGVEC(1,J),NSTATE,
     &                                 0.0D0,WORK(LSCR),NSTATE)
                           PROP(I,J,IPROP)=DDot_(NSTATE,WORK(LSCR),1,
     &                                                  EIGVEC(1,I),1)
                        END DO
                        CALL GETMEM('SCR','FREE','REAL',LSCR,NSTATE)
*
                     End If
*
*              (1) the oam part
*
*              The contribution to the generalized momentum operator.
*              Note that the integrals contain nabla, but we need p,
*              so we multiply by -i
*
               DO iCar=1,3
                  TM_R(iCar)=+PROP(I,J,IPRTMOM(3+iCar)) ! IS
     &                       +PROP(I,J,IPRTMOM(9+iCar)) ! IA
                  TM_I(iCar)=-PROP(I,J,IPRTMOM(0+iCar)) ! RS
     &                       -PROP(I,J,IPRTMOM(6+iCar)) ! RA
               END DO
*
*              (2) the magnetic-spin part
*
C                 Well the B.S term is overkill, get rid of it.
C                 Why do it when we don't do the L.S-term!
*
*              Finally, evaluate the transition moment from the two
*              different contributions.
*
#ifdef _HDF5_
*              Fix the triangular index because we are not storing the diagonal
               IJSF=IJ-ISTATE+1
               Storage(ip_w,iQuad,IJSF,iVec)=Weight
               Call DCopy_(3,Wavevector,1,
     &                       Storage(ip_kvector,iQuad,IJSF,iVec),1)
               Call DCopy_(3,TM_R,1,Storage(ip_TMR,iQuad,IJSF,iVec),1)
               Call DCopy_(3,TM_I,1,Storage(ip_TMI,iQuad,IJSF,iVec),1)
#endif
*
*              Project out the k direction from the real and imaginary components
*
               Call DaXpY_(3,-DDot_(3,TM_R,1,UK,1),UK,1,TM_R,1)
               Call DaXpY_(3,-DDot_(3,TM_I,1,UK,1),UK,1,TM_I,1)
*
*              Implicitly integrate over all directions of the
*              polarization vector to get the average value.
*
               TM1 = DDot_(3,TM_R,1,TM_R,1)
               TM2 = DDot_(3,TM_I,1,TM_I,1)
               TM_2 = Half*(TM1+TM2)
*
*              Compute maximum and minimum oscillator strengths
*              and the corresponding polarization vectors
*
               If (Do_SK) Then
                  LMAX_ = LMAX+8*(ij_-1)
                  TM3 = DDot_(3,TM_R,1,TM_I,1)
                  Rng = Sqrt((TM1-TM2)**2+4.0D0*TM3**2)
                  Work(LMAX_+0) = TM_2+Half*Rng
                  Work(LMAX_+4) = TM_2-Half*Rng
*                 The direction for the maximum
                  Ang = Half*Atan2(2.0D0*TM3,TM1-TM2)
                  Call daXpY_(3, Cos(Ang),TM_R,1,Work(LMAX_+1),1)
                  Call daXpY_(3, Sin(Ang),TM_I,1,Work(LMAX_+1),1)
*                 Normalize and compute the direction for the minimum
*                 as a cross product with k
                  rNorm = DDot_(3,Work(LMAX_+1),1,Work(LMAX_+1),1)
                  If (rNorm.gt.1.0D-12) Then
                     Call dScal_(3,1.0/Sqrt(rNorm),Work(LMAX_+1),1)
                     Work(LMAX_+5)=Work(LMAX_+2)*UK(3)-
     &                             Work(LMAX_+3)*UK(2)
                     Work(LMAX_+6)=Work(LMAX_+3)*UK(1)-
     &                             Work(LMAX_+1)*UK(3)
                     Work(LMAX_+7)=Work(LMAX_+1)*UK(2)-
     &                             Work(LMAX_+2)*UK(1)
                     rNorm = DDot_(3,Work(LMAX_+5),1,Work(LMAX_+5),1)
                     Call dScal_(3,1.0/Sqrt(rNorm),Work(LMAX_+5),1)
                  Else
                     Call dCopy_(3,[0.0D0],0,Work(LMAX_+1),1)
                     Call dCopy_(3,[0.0D0],0,Work(LMAX_+5),1)
                  End If
               End If
*
*              Oscillator strength for a specific polarization vector
*
               If (Do_Pol) Then
                  TM1 = DDot_(3,TM_R,1,pol_Vector(1,iVec_),1)
                  TM2 = DDot_(3,TM_I,1,pol_Vector(1,iVec_),1)
                  TM_2 = TM1*TM1+TM2*TM2
               End If
*
*              Compute the oscillator strength
*
               F_Temp = 2.0D0*TM_2/EDIFF
               If (Do_SK) Then
                  Work(LMAX_+0) = 2.0D0*Work(LMAX_+0)/EDIFF
                  Work(LMAX_+4) = 2.0D0*Work(LMAX_+4)/EDIFF
               End If
*
*              Compute the rotatory strength
*
               TM_C(1) = TM_R(2)*TM_I(3)-TM_R(3)*TM_I(2)
               TM_C(2) = TM_R(3)*TM_I(1)-TM_R(1)*TM_I(3)
               TM_C(3) = TM_R(1)*TM_I(2)-TM_R(2)*TM_I(1)
               TM_2 = 2.0D0*DDot_(3,TM_C,1,UK,1)
*
*              R = 3/4 * c*hbar^2/DeltaE^2 * (|T^L|^2 - |T^R|^2)
*
               R_Temp=0.75D0*SPEED_OF_LIGHT/EDIFF**2*TM_2
*
*              Now let's convert this to reduced rotational strength
*              (units of 1e-2 debye*Bohr_magneton)
*
               R_Temp=R_Temp*AU2REDR
*
*              Save the raw oscillator and rotatory strengths in a given direction
*
               LRAW_=LRAW+6*NQUAD*(ij_-1)
               WORK(LRAW_+(IQUAD-1)+0*NQUAD) = F_Temp
               WORK(LRAW_+(IQUAD-1)+1*NQUAD) = R_Temp
*
*              Save the direction and weight too
*
               WORK(LRAW_+(IQUAD-1)+2*NQUAD) = UK(1)
               WORK(LRAW_+(IQUAD-1)+3*NQUAD) = UK(2)
               WORK(LRAW_+(IQUAD-1)+4*NQUAD) = UK(3)
               WORK(LRAW_+(IQUAD-1)+5*NQUAD) = Weight
*
*              Compute the oscillator and rotatory strength
*
               Work(LFIJ  ) = Work(LFIJ  ) + Weight * F_Temp
               Work(LFIJ+1) = Work(LFIJ+1) + Weight * R_Temp
                  End Do ! j_
               End Do ! i_
*
            End Do ! iQuad
*
            ij_=0
            Do i_=istart_,iend_
              I=IndexE(I_)
              Do j_=jstart_,jend_
                J=IndexE(J_)
                ij_=ij_+1
                LFIJ=LF+(ij_-1)*2
*
                F=Work(LFIJ)
                R=Work(LFIJ+1)
*
                Call Add_Info('ITMS(SF)',[F],1,6)
                Call Add_Info('ROTS(SF)',[R],1,4)
*
                IF (Do_Pol) THEN
                   LMAX_=LMAX+8*(ij_-1)
                   F_CHECK=ABS(WORK(LMAX_+0))
                   R_CHECK=0.0D0 ! dummy assign
                ELSE
                   F_CHECK=ABS(F)
                   R_CHECK=ABS(R)
                END IF
                IF ( (F_CHECK.LT.OSTHR).AND.(R_CHECK.LT.RSTHR) ) CYCLE
                A =(AFACTOR*EDIFF**2)*F
*
                If (iPrint.eq.0) Then
                   WRITE(6,*)
                   If (Do_SK) Then
                      CALL CollapseOutput(1,
     &                  'Transition moment strengths '//
     &                  '(spin-free states):')
                      WRITE(6,'(3X,A)')
     &                  '----------------------------'//
     &                  '-------------------'
                      If (Do_Pol) Then
                         iVec_=(iVec-1)*nQuad+1
                         WRITE(6,'(4x,a,3F8.4)')
     &                     'Direction of the polarization: ',
     &                     (pol_vector(k,iVec_),k=1,3)
                      Else
                         WRITE(6,'(4x,a)')
     &                     'The oscillator strength is integrated '//
     &                     'over all directions of the polarization '//
     &                     'vector'
                      End If
                      WRITE(6,'(4x,a,3F10.6)')
     &                  'Direction of the k-vector: ',
     &                  (k_vector(k,iVec),k=1,3)
                   Else
                      CALL CollapseOutput(1,
     &                  'Isotropic transition moment strengths '//
     &                  '(spin-free states):')
                       WRITE(6,'(3X,A)')
     &                  '--------------------------------------'//
     &                  '-------------------'
                   End If
                   IF (OSTHR.GT.0.0D0) THEN
                      WRITE(6,45)
     &                  'For osc. strength at least',OSTHR,'and '//
     &                  'red. rot. strength  at least',RSTHR
                   END IF
                   WRITE(6,*)
                   If (.NOT.Do_SK) Then
                      WRITE(6,'(4x,a,I4,a)')
     &                  'Integrated over ',nQuad,' directions of the '//
     &                  'wave vector'
                      WRITE(6,'(4x,a)')
     &                  'The oscillator strength is '//
     &                  'integrated over all directions of the polar'//
     &                  'ization vector'
                      WRITE(6,*)
                   End If
                   WRITE(6,39) 'From','To','Osc. strength',
     &                         'Red. rot. str.','Total A (sec-1)'
                   WRITE(6,40)
                   iPrint=1
                END IF
*
*     Regular print
*
                IF(F_CHECK.LT.OSTHR) THEN
                  WRITE(6,46) I,J,'below threshold',R,A
                !Don't print rot. str. if below threshold
                ELSE IF(R_CHECK.LT.RSTHR) THEN
                  WRITE(6,47) I,J,F,'below threshold',A
                ELSE
                  WRITE(6,33) I,J,F,R,A
                END IF


*
                IF (Do_SK) THEN
                   WRITE(6,50) 'maximum',WORK(LMAX_+0),
     &                'for polarization direction:',
     &                WORK(LMAX_+1),WORK(LMAX_+2),WORK(LMAX_+3)
                   WRITE(6,50) 'minimum',WORK(LMAX_+4),
     &                'for polarization direction:',
     &                WORK(LMAX_+5),WORK(LMAX_+6),WORK(LMAX_+7)
                END IF
*
*     Printing raw (unweighted) and direction for every transition
*
                IF(PRRAW) THEN
                  WRITE(6,*)
                  WRITE(6,*)
                  WRITE(6,41) 'From', 'To', 'Raw osc. str.',
     &                        'Rot. str.','kx','ky','kz'
                  WRITE(6,32)
                  LRAW_=LRAW+6*NQUAD*(ij_-1)
                  DO IQUAD = 1, NQUAD
                    WRITE(6,33) I,J,
     &              WORK(LRAW_+(IQUAD-1)+0*NQUAD),
     &              WORK(LRAW_+(IQUAD-1)+1*NQUAD),
     &              WORK(LRAW_+(IQUAD-1)+2*NQUAD),
     &              WORK(LRAW_+(IQUAD-1)+3*NQUAD),
     &              WORK(LRAW_+(IQUAD-1)+4*NQUAD)
                  END DO
                  WRITE(6,32)
                  WRITE(6,*)
                END IF
*
*     Printing weighted and direction for every transition
*
                IF(PRWEIGHT) THEN
                  WRITE(6,*)
                  WRITE(6,*)
                  WRITE(6,41) 'From', 'To', 'Weig. osc. str.',
     &                        'Rot. str.','kx','ky','kz'
                  WRITE(6,32)
                  LRAW_=LRAW+5*NQUAD*(ij_-1)
                  DO IQUAD = 1, NQUAD
                    Weight=WORK(LRAW+(IQUAD-1)+5*NQUAD)
                    WRITE(6,33) I,J,
     &                WORK(LRAW+(IQUAD-1)+0*NQUAD)*Weight,
     &                WORK(LRAW+(IQUAD-1)+1*NQUAD)*Weight,
     &                WORK(LRAW+(IQUAD-1)+2*NQUAD),
     &                WORK(LRAW+(IQUAD-1)+3*NQUAD),
     &                WORK(LRAW+(IQUAD-1)+4*NQUAD)
                  END DO
                  WRITE(6,32)
                  WRITE(6,*)
                END IF
              End Do
            End Do
*
         END DO
      END DO
*
      If (iPrint.EQ.1) THEN
         WRITE(6,40)
         If (Do_SK) Then
            CALL CollapseOutput(0,
     &                'Transition moment strengths (spin-free states):')
         Else
         CALL CollapseOutput(0,
     &                'Isotropic transition moment strengths '//
     &                '(spin-free states):')
         End If
      END IF
*
      End Do ! iVec
*
#ifdef _HDF5_
#ifdef POINTER_REMAP
      flatStorage(1:SIZE(Storage)) => Storage
#else
      Call C_F_Pointer(C_Loc(Storage), flatStorage, [SIZE(Storage)])
#endif
      Call mh5_put_dset(wfn_sfs_tm,flatStorage)
      Nullify(flatStorage)
      Call mma_deallocate(Storage)
#endif
*
*     Deallocate some arrays.
*
      CALL GETMEM('RAW   ','FREE','REAL',LRAW,NQUAD*5*nmax2)
      CALL GETMEM('IP    ','FREE','REAL',LIP,NIP)
      CALL GETMEM('OSCSTR','FREE','REAL',LF,2*nmax2)
      CALL GETMEM('MAXMIN','FREE','REAL',LMAX,8*nmax2)
      if (TMOgroup) Then
        Call mma_DeAllocate(TMOgrp1)
        Call mma_DeAllocate(TMOgrp2)
      EndIf
      If (Do_Pol) Call mma_deallocate(pol_Vector)
      Call mma_deallocate(SCR)
      Call mma_deAllocate(TDMZZ)
      Call mma_deAllocate(TSDMZZ)
      Call mma_deAllocate(WDMZZ)
*
#ifdef _TIME_TMOM_
      Call CWTime(TCpu2,TWall2)
      write(6,*) 'Time for TMOM (SF) ',TCpu2-TCpu1,TWall2-TWall1
#endif
*
*     Do some cleanup
*
      If (.NOT.Do_SK) Call Free_O()
      Call mma_deAllocate(Rquad)
      Call ClsSew()
************************************************************************
*                                                                      *
*     End of section for transition moments                            *
*                                                                      *
************************************************************************
*
 900  CONTINUE

      if(debug_dmrg_rassi_code)then
        write(6,*) 'end of eigctl: BLUBB debug print of property matrix'
        do istate = 1, nstate
        do jstate = 1, nstate
        DO IPROP=1,NPROP
          if(abs(prop(istate,jstate,iprop)) > 1.0d-14)
     &    write(6,*) 'prop(',istate,',',jstate,',',iprop,') = ',
     &                prop(istate,jstate,iprop)
        end do
        end do
        end do
      end if
      Call mma_DeAllocate(IndexE)

      RETURN
30    FORMAT (5X,A,1X,ES15.8)
31    FORMAT (5X,2(1X,A4),6X,A15,1X,A47,1X,A15)
32    FORMAT (5X,95('-'))
33    FORMAT (5X,2(1X,I4),5X,5(1X,ES15.8))
34    FORMAT (5X,2(1X,A4),5X,4(1X,A15),1X,A)
35    FORMAT (5X,31('-'))
36    FORMAT (5X,2(1X,I4),6X,15('-'),1X,ES15.8,1X,A15)
37    FORMAT (5X,2(1X,I4),6X,15('-'),1X,A15,1X,ES15.8)
38    FORMAT (5X,2(1X,I4),6X,F15.6,4(1X,ES15.8))
39    FORMAT (5X,2(1X,A4),5X,3(1X,A15))
40    FORMAT (5X,63('-'))
41    FORMAT (5X,2(1X,A4),5X,5(1X,A15))
42    FORMAT (5X,79('-'))
43    FORMAT (12X,A8,6(1X,ES15.8))
44    FORMAT (20X,6(1X,A15))
45    FORMAT (4X,2(A,1X,ES15.8,1X))
46    FORMAT (5X,2(1X,I4),5X,(1X,A15),2(1X,ES15.8))
47    FORMAT (5X,2(1X,I4),5X,(1X,ES15.8),(1X,A15),(1X,ES15.8))
49    FORMAT (5X,A,1X,ES15.8,1X,A)
50    FORMAT (10X,A7,3X,1(1X,ES15.8),5X,A27,3(1X,F7.4))
      END Subroutine EigCtl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine setifinish_cvb(icode)
      implicit real*8(a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


      if(icode.eq.1)then
        ifinish=0
      elseif(icode.eq.3)then
        ifinish=1
      endif
      return
      end
      logical function firsttime_cvb()
      implicit real*8(a-h,o-z)
      logical begbracket,second_time_round
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "inpmod_cvb.fh"
#include "seth_cvb.fh"
#include "loopcntr_cvb.fh"
#include "initopt_cvb.fh"
      external istkprobe_cvb
      logical istkprobe_cvb

      if(inputmode.eq.2)then
        if(loopstep.eq.0) then
          begbracket=.false.
        else
          begbracket=
     >      (icode(loopstep).eq.1.and.icode(loopstep+1).eq.2).or.
     >      (icode(loopstep).eq.3.and.icode(loopstep+1).eq.4)
        endif

        firsttime_cvb=(joptstep.eq.ioptstep-1.or.
     >    (ioptstep.eq.0.and.joptstep.eq.0)) .or.
     >    (joptstep.eq.ioptstep.and.begbracket)

        if(ioptim.gt.1.and.iopt2step(ioptim).eq.iopt2step(ioptim-1))
     >    firsttime_cvb=.false.

        if(istkprobe_cvb(istackrep))then
          call istkpop_cvb(istackrep,nc_zeroed_l)
          call istkpop_cvb(istackrep,nconvinone_l)
          call istkpop_cvb(istackrep,italter_l)
          second_time_round=(italter_l.gt.1)
          call istkpush_cvb(istackrep,italter_l)
          call istkpush_cvb(istackrep,nconvinone_l)
          call istkpush_cvb(istackrep,nc_zeroed_l)
        else
          second_time_round=.false.
        endif

        if(second_time_round)firsttime_cvb=.false.

        if(nmcscf.ge.2)firsttime_cvb=.false.
      else
        firsttime_cvb=.false.
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  CCD_InCore
!
!> @brief
!>   Complete Cholesky decomposition of the symmetric positive definite matrix \p X
!> @author Thomas Bondo Pedersen
!>
!> @details
!> The \p n &times; \p n matrix \p X is Cholesky decomposed and the resulting
!> Cholesky vectors are returned in the lower triangle of \p X.
!> A non-zero return code signals
!> that an error has occured (\p X might e.g. be non-positive
!> definite) and the output is ill-defined.
!>
!> @param[in,out] X   Matrix to be Cholesky decomposed;
!>                    on exit, lower triangle contains the vectors
!> @param[in]     n   Linear dimension of \p X
!> @param[out]    irc Return code
!***********************************************************************

subroutine CCD_InCore(X,n,irc)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: X(n,n)
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: i, j, k
real(kind=wp) :: Fac

irc = 0
if (n < 1) return ! return (nothing to do)

do j=1,n
  ! Check for negative diagonal
  if (X(j,j) > Zero) then
    Fac = One/sqrt(X(j,j))
  else
    irc = 1
    return
  end if
  ! Compute vector j
  do i=j,n
    X(i,j) = Fac*X(i,j)
  end do
  ! Subtract from remaining columns
  do k=j+1,n
    Fac = X(k,j)
    do i=k,n
      X(i,k) = X(i,k)-X(i,j)*Fac
    end do
  end do
end do

end subroutine CCD_InCore

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995, Roland Lindh                                *
!               Markus P. Fuelscher                                    *
!***********************************************************************

subroutine Drvh1(Grad,Temp,nGrad)
!***********************************************************************
!                                                                      *
! Object: driver for computation of gradient with respect to the one-  *
!         electron hamiltonian and the overlap matrix. The former will *
!         be contracted with the "variational" first order density     *
!         matrix and the latter will be contracted with the generalized*
!         Fock matrix.                                                 *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!                                                                      *
! modified by M.P. Fuelscher                                           *
! make use of the RELAX file                                           *
!                                                                      *
!             Modified to Sperical Well, External Field, and SRO       *
!             gradients, April '95. R. Lindh                           *
!             Modified to Self Consistent Reaction Fields, May '95     *
!***********************************************************************

use PCM_arrays, only: PCM_SQ
use External_Centers, only: nWel, XF, Wel_Info
use Basis_Info, only: nCnttp, dbsc, nBas
use Symmetry_Info, only: nIrrep
#ifdef _NEXTFFIELD_
use finfld, only: force
#endif
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Temp(nGrad)
integer(kind=iwp) :: i, iComp, iCOSMO, ii, iIrrep, iMltpl, iPrint, iRout, iWel, ix, iy, nComp, nCompf, nDens, nFock, nOrdOp, nOrdOpf
real(kind=wp) :: Fact, TCpu1, TCpu2, TWall1, TWall2
character(len=80) :: Label
character(len=8) :: Method
logical(kind=iwp) :: DiffOp, lECP, lFAIEMP, lPP
integer(kind=iwp), allocatable :: lOper(:), lOperf(:)
real(kind=wp), allocatable :: Coor(:,:), Coorf(:,:), D_Var(:), Fock(:)
#ifdef _NEXTFFIELD_
!AOM<
integer(kind=iwp) :: ncmp, nextfld
character(len=30) :: fldname
!AOM>
#endif
external :: COSGrd, FragPGrd, FragPMmG, KneGrd, KneMmG, M1Grd, M1MmG, M2Grd, M2MmG, MltGrd, MltMmG, NAGrd, NAMmG, OvrGrd, OvrMmG, &
            PCMGrd, PCMMmg, PPGrd, PPMmG, PrjGrd, PrjMmG, RFGrd, RFMmg, SROGrd, SROMmG, WelGrd, WelMmg, XFdGrd, XFdMmg
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"
#include "wldata.fh"
#include "rctfld.fh"

! Prologue
iRout = 131
iPrint = nPrint(iRout)
call CWTime(TCpu1,TWall1)
call StatusLine(' Alaska:',' Computing 1-electron gradients')

! Allocate memory for density and Fock matrices

nFock = 0
nDens = 0
do iIrrep=0,nIrrep-1
  nFock = nFock+nBas(iIrrep)*(nBas(iIrrep)+1)/2
  nDens = nDens+nBas(iIrrep)*(nBas(iIrrep)+1)/2
end do
lECP = .false.
lPP = .false.
lFAIEMP = .false.
do i=1,nCnttp
  lECP = lECP .or. dbsc(i)%ECP
  lPP = lPP .or. (dbsc(i)%nPP /= 0)
  lFAIEMP = LFAIEMP .or. dbsc(i)%Frag
end do

! Get the method label
!write(u6,*) ' Read Method label'
call Get_cArray('Relax Method',Method,8)

! Read the variational 1st order density matrix
! density matrix in AO/SO basis
!write(u6,*) ' Read density matrix'

call mma_allocate(D_Var,nDens,Label='D_Var')
call Get_D1ao_Var(D_Var,nDens)
if (iPrint >= 99) then
  write(u6,*) 'variational 1st order density matrix'
  ii = 1
  do iIrrep=0,nIrrep-1
    write(Label,*) 'symmetry block',iIrrep
    call TriPrt(Label,' ',D_Var(ii),nBas(iIrrep))
    ii = ii+nBas(iIrrep)*(nBas(iIrrep)+1)/2
  end do
end if

! Read the generalized Fock matrix
! Fock matrix in AO/SO basis
!write(u6,*) ' Read Fock matrix'
if (.not. HF_Force) then
  call mma_allocate(Fock,nDens,Label='Fock')
  call Get_Fock_Occ(Fock,nDens)
  if (iPrint >= 99) then
    write(u6,*) 'generalized Fock matrix'
    ii = 1
    do iIrrep=0,nIrrep-1
      write(Label,*) 'symmetry block',iIrrep
      call TriPrt(Label,' ',Fock(ii),nBas(iIrrep))
      ii = ii+nBas(iIrrep)*(nBas(iIrrep)+1)/2
    end do
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! nOrdOp: order/rank of the operator
! lOper: lOper of each component of the operator

nOrdOp = 0
nComp = nTri_Elem1(nOrdOp)
call mma_allocate(Coor,3,nComp,Label='Coor')
call mma_allocate(lOper,nComp,Label='lOper')
Coor(:,:) = Zero
lOper(1) = 1
!***********************************************************************
!1)                                                                    *
!     Trace the generalized Fock matrix with the gradient of the       *
!     overlap matrix.                                                  *
!                                                                      *
!***********************************************************************

if (.not. HF_Force) then
  DiffOp = .false.
  Label = ' The Renormalization Contribution'
  call OneEl_g(OvrGrd,OvrMmG,Temp,nGrad,DiffOp,Coor,Fock,nFock,lOper,nComp,nOrdOp,Label)
  Grad(:) = Grad(:)-Temp(:)
end if

!***********************************************************************
!2)                                                                    *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the kinetic energy integrals.                        *
!                                                                      *
!***********************************************************************

if (.not. HF_Force) then
  DiffOp = .false.
  Label = ' The Kinetic Energy Contribution'
  call OneEl_g(KneGrd,KneMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
  Grad(:) = Grad(:)+Temp(:)
  ! This is either not implemented or disabled, so commenting it out
# ifdef _NEXTFFIELD_
  !AOM<
  ! Check finite field operators...
  nextfld = 0
  do
    call GetNextFfield(nextfld,fldname,nOrdOpf,ncmp,force,size(force))
    if (nextfld == 0) exit
    if (nOrdOpf == 0) then
      if (fldname(1:2) /= 'OV') then
        call WarningMessage(2,'Error in Drvh1')
        write(u6,*) 'Finite field gradients only for MLTP'
        call Quit_OnUserError()
      end if
    end if
    nCompf = nTri_Elem1(nOrdOpf)
    Label = fldname
    if (ncompf /= ncmp) then
      call WarningMessage(2,'Error in Drvh1')
      write(u6,*) 'Wrong number of components in FF grad'
      call Quit_OnUserError()
    end if
    call mma_allocate(lOperf,nCompf,Label='lOperf')
    lOperf(:) = 1
    DiffOp = .false.
    if (nOrdOpf > 0) DiffOp = .true.
    call OneEl_g(MltGrd,MltMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOperf,nCompf,nOrdOpf,Label)
    call MltGrdNuc(Temp,nGrad,nOrdOpf)
    call mma_deallocate(lOperf)
    Grad(:) = Grad(:)-Temp(:)
  end do
  !AOM>
# endif
end if

!***********************************************************************
!3)                                                                    *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the nuclear attraction integrals.                    *
!                                                                      *
!***********************************************************************

DiffOp = .true.
Label = ' The Nuclear Attraction Contribution'
call OneEl_g(NAGrd,NAMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
Grad(:) = Grad(:)+Temp(:)
if (HF_Force) then
  if (lECP .or. (nWel /= 0) .or. allocated(XF) .or. lRF) then
    call WarningMessage(2,'Error in Drvh1')
    write(u6,*) 'HF forces not implemented yet for this case!'
    call Quit_OnUserError()
  end if
end if

!***********************************************************************
!4)                                                                    *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the ECP integrals.                                   *
!                                                                      *
!***********************************************************************

if (.not. HF_Force) then
  if (lECP) then
    DiffOp = .true.
    Label = ' The Projection Operator Contribution'
    call OneEl_g(PrjGrd,PrjMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
    Grad(:) = Grad(:)+Temp(:)

    Label = ' The M1 Operator Contribution'
    call OneEl_g(M1Grd,M1MmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
    Grad(:) = Grad(:)+Temp(:)

    Label = ' The M2 Operator Contribution'
    call OneEl_g(M2Grd,M2MmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
    Grad(:) = Grad(:)+Temp(:)

    Label = ' The SR Operator Contribution'
    call OneEl_g(SROGrd,SROMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
    Grad(:) = Grad(:)+Temp(:)
  end if
  if (lPP) then
    Label = ' The Pseudo Potential Contribution'
    call OneEl_g(PPGrd,PPMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
    Grad(:) = Grad(:)+Temp(:)
  end if
end if

!***********************************************************************
!5)                                                                    *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the Spherical well integrals.                        *
!                                                                      *
!***********************************************************************

if (.not. HF_Force) then
  DiffOp = .true.
  do iWel=1,nWel
    r0 = Wel_Info(1,iWel)
    ExpB = Wel_Info(2,iWel)
    Label = ' The Spherical Well Contribution'
    call OneEl_g(WelGrd,WelMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
    Fact = Wel_Info(3,iWel)
    Grad(:) = Grad(:)+Fact*Temp(:)
  end do
end if

!***********************************************************************
!6)                                                                    *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the external field integrals.                        *
!                                                                      *
!***********************************************************************

if (.not. HF_Force) then
  if (allocated(XF)) then
    DiffOp = .true.
    Label = ' The External Field Contribution'
    call OneEl_g(XFdGrd,XFdMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
    Grad(:) = Grad(:)+Temp(:)
  end if
end if

!***********************************************************************
!7)                                                                    *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the reaction field integrals.                        *
!                                                                      *
!***********************************************************************

if (.not. HF_Force) then
  if (lRF .and. (.not. lLangevin) .and. (.not. PCM)) then

    ! The Kirkwood model

    nOrdOpf = lMax
    nCompf = (lMax+1)*(lMax+2)*(lMax+3)/6
    call mma_allocate(lOperf,nCompf,Label='lOperf')

    ! Store permutation symmetry of components of the EF

    iComp = 1
    do iMltpl=0,lMax
      do ix=iMltpl,0,-1
        !if (Mod(ix,2) == 0) then
        !  iSymX = 1
        !else
        !  ixyz = 1
        !  iSymX = 2**IrrFnc(ixyz)
        !end if
        do iy=iMltpl-ix,0,-1
          !if (Mod(iy,2) == 0) then
          !  iSymY = 1
          !else
          !  ixyz = 2
          !  iSymY = 2**IrrFnc(ixyz)
          !end if
          !iz = iMltpl-ix-iy
          !if (Mod(iz,2) == 0) then
          !  iSymZ = 1
          !else
          !  ixyz = 4
          !  iSymZ = 2**IrrFnc(ixyz)
          !end if
          !lOperf(iComp) = MltLbl(iSymX,MltLbl(iSymY,iSymZ))
          ! Compute only total symmetric contributions
          lOperf(iComp) = 1
          iComp = iComp+1
        end do
      end do
    end do
    call mma_allocate(Coorf,3,nCompf,Label='Coorf')
    Coorf(:,:) = Zero
    DiffOp = .true.
    Label = ' The Electronic Reaction Field Contribution'
    call OneEl_g(RFGrd,RFMmG,Temp,nGrad,DiffOp,Coorf,D_Var,nDens,lOperf,nCompf,nOrdOpf,Label)
    Grad(:) = Grad(:)+Temp(:)

    call mma_deallocate(lOperf)
    call mma_deallocate(Coorf)

  else if (lRF .and. PCM) then
    iCOSMO = 0
    ! The PCM / COSMO model

    if (iCOSMO <= 0) then
      iPrint = 15
      PCM_SQ(:,:) = PCM_SQ(:,:)/real(nIrrep,kind=wp)
    end if
    lOper(1) = 1
    DiffOp = .true.
    if (iCOSMO > 0) then
      call dzero(Temp,ngrad)
      Label = ' The Electronic Reaction Field Contribution (COSMO)'
      call OneEl_g(COSGrd,PCMMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
      if (iPrint >= 15) then
        Label = ' Reaction Field (COSMO) Contribution'
        call PrGrad(Label,Temp,nGrad,ChDisp)
      end if
    else
      Label = ' The Electronic Reaction Field Contribution (PCM)'
      call OneEl_g(PCMGrd,PCMMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
      if (iPrint >= 15) then
        Label = ' Reaction Field (PCM) Contribution'
        call PrGrad(Label,Temp,nGrad,ChDisp)
      end if
    end if

    Grad(:) = Grad(:)+Temp(:)
    if (iCOSMO == 0) PCM_SQ(:,:) = PCM_SQ(:,:)*real(nIrrep,kind=wp)

  end if
end if

!***********************************************************************
!8)                                                                    *
!     Trace the "variational" first order density matrix with the      *
!     gradient of the FAIEMP integrals.                                *
!                                                                      *
!***********************************************************************

if (.not. HF_Force) then
  if (lFAIEMP) then
    DiffOp = .true.
    Label = ' The FAIEMP Projection Operator Contribution'
    call OneEl_g(FragPGrd,FragPMmG,Temp,nGrad,DiffOp,Coor,D_Var,nDens,lOper,nComp,nOrdOp,Label)
    Grad(:) = Grad(:)+Temp(:)
    call DrvG_FAIEMP(Grad,Temp,nGrad)
  end if
end if

!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(lOper)
call mma_deallocate(Coor)
!                                                                      *
!***********************************************************************
!                                                                      *
! Epilogue, end

if (.not. HF_Force) call mma_deallocate(Fock)
call mma_deallocate(D_Var)

call CWTime(TCpu2,TWall2)
call SavTim(3,TCpu2-TCpu1,TWall2-TWall1)
return

end subroutine Drvh1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_VecBuf_Ini2()
!
! Thomas Bondo Pedersen, June 2006.
!
! Purpose: read vectors from disk into buffer.

use Cholesky, only: CHVBUF, ip_CHVBUF_SYM, l_CHVBUF_SYM, LuPri, nSym, NumCho, NumChT, nVec_in_Buf
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iRedC, iSym, iV1, iV2, mUsed(8), nRead
logical(kind=iwp) :: DoRead
#ifdef _CHO_DEBUGPRINT_
#define _DEBUGPRINT_
#endif
character(len=*), parameter :: SecNam = 'Cho_VecBuf_Ini2'
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: irc
#endif

! Check if buffer is allocated.
! Check if there are any vectors.
! -------------------------------

if (.not. allocated(CHVBUF)) then
# ifdef _DEBUGPRINT_
  write(Lupri,*) SecNam,': returning immediately: No buffer allocated!'
# endif
  return
end if
if (NumChT < 1) then
  write(Lupri,*) SecNam,': returning immediately: Buffer allocated, but no vectors!?!?'
  return
end if

! Read vectors.
! -------------

DoRead = .true.
iRedC = -1
do iSym=1,nSym
  iV1 = 1
  iV2 = NumCho(iSym)
  nRead = 0
  mUsed(iSym) = 0
  call Cho_VecRd1(CHVBUF(ip_ChVBuf_Sym(iSym)),l_ChVBuf_Sym(iSym),iV1,iV2,iSym,nRead,iRedC,mUsed(iSym),DoRead)
  nVec_in_Buf(iSym) = nRead
end do

! Debug:
! Enable integrity checks.
! Print info.
! ------------------------

#ifdef _DEBUGPRINT_
call Cho_VecBuf_EnableIntegrityCheck(irc)
if (irc /= 0) then
  write(LuPri,'(A,I9)') SecNam,': Cho_VecBuf_EnableIntegrityCheck returned code',irc
  call Cho_Quit(SecNam//': integrity check init failed',104)
else
  write(LuPri,'(A,A)') SecNam,': buffer integrity check enabled'
end if
write(Lupri,'(A,A,8I10)') SecNam,'(exit): NumCho:',(NumCho(iSym),iSym=1,nSym)
write(Lupri,'(A,A,8I10)') SecNam,'(exit): nVec_in_Buf:',(nVec_in_Buf(iSym),iSym=1,nSym)
write(Lupri,'(A,A,8I10)') SecNam,'(exit): buffer allocated:',(l_ChVBuf_Sym(iSym),iSym=1,nSym)
write(Lupri,'(A,A,8I10)') SecNam,'(exit): memory used:',(mUsed(iSym),iSym=1,nSym)
call XFlush(Lupri)
#endif

end subroutine Cho_VecBuf_Ini2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Fold_tMat(nSym,nBas,A,B)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Fold up symmetry blocked matrix A (UT-storage)                   *
*     into triangular matrices with scaled (by two) off-diagonals      *
*     The input and output matrices may be                             *
*     identical.                                                       *
*                                                                      *
*     calling arguments:                                               *
*     nSym    : input, integer                                         *
*               number of symmetry blocks                              *
*     nBas    : input, array of integers                               *
*               matrix dimension per symmetry block                    *
*     A       : input, array of real*8                                 *
*               Unfolded input matrix (UT-storage)                     *
*     B       : output, array of real*8                                *
*               Folded output matrix  (UT-storage)                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension nBas(*) , A(*) , B(*)

      Parameter (two = 2.0d0)

*************************************
      iit(j) = j*(j+1)/2
*************************************
      ijt(i,j) = i*(i-1)/2 + j
*************************************


      iOff = 0

      Do iSym=1,nSym

        Do j=1,nBas(iSym)

          Do i=j+1,nBas(iSym)

            B( iOff + ijt(i,j) ) = two*A( iOff + ijt(i,j) )

          End Do

          B( iOff + iit(j) ) =  A( iOff + iit(j) )

        End Do

        iOff = iOff + iit(nBas(iSym))

      End Do

c      ij=0
c      do isym=1,nsym
c       do i=1,nbas(isym)
c        do j=1,i-1
c         ij=ij+1
c         B(ij)=2*A(ij)
c        end do
c        ij=ij+1
c        B(ij)=A(ij)
c       end do
c      end do


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HZLP2(CBUF,SBUF,DBUF,CSECT,RSECT,XI1,XI2,CNEW,ICI)

use mrci_global, only: ESMALL, IDFREE, IDISKC, IDISKD, IDISKS, LUEIG, MBUF, MXVEC, MXZ, NCONF, NNEW, NRROOT, NSECT, NVEC, NVTOT, &
                       VSMALL, VZERO
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: CBUF(MBUF,MXVEC), SBUF(MBUF,MXVEC), DBUF(MBUF), CSECT(NSECT,MXVEC), RSECT(NSECT,MXVEC), &
                              XI1(NSECT,NRROOT), XI2(NSECT,NRROOT), CNEW(NSECT,NRROOT)
integer(kind=iwp), intent(out) :: ICI(MBUF)
integer(kind=iwp) :: I, IBUF, IDD, IEND, ISECT, ISTA, IVZ1, IVZ2, IVZ3, IVZ4, IVZSTA, JEND, JSTA, K, KK, NN, NNVEC
integer(kind=iwp), allocatable :: IDCR(:), IDCW(:), IDS(:)

! THIS SUBROUTINE LOOPS OVER SECTIONS OF PSI AND SIGMA ARRAYS
! ON DISK, AND FORMS A NEW SET OF PSI ARRAYS AS A LINEAR COMBINATION
! OF THE BASIS SET PSI, RHO, XI1 AND XI2. TO FORM THE NEW PSI
! ARRAY, THE FIRST (NRROOT-NNEW) COLUMNS ARE SKIPPED, SINCE THEY
! GIVE NO ESSENTIAL IMPROVEMENT.
IVZSTA = 1+NRROOT-NNEW
IVZ1 = 1
IVZ2 = 1+NRROOT
IVZ3 = 1+2*NRROOT
IVZ4 = 1+3*NRROOT
!write(u6,*)
!write(u6,*) ' IN HZLP2. NNEW=',NNEW
!if (NVEC < MXVEC) write(u6,*) ' DUMMY WRITES OF NEW FUNCTIONS.'
! WE MAY NEED DUMMY WRITES TO PROVIDE DISK ADDRESSES:
NNVEC = min(NVEC+NNEW,MXVEC)
do K=NVEC+1,NNVEC
  IDISKC(K) = IDFREE
  !write(u6,'(A,I2,A,I8)') ' IDISKC(',K,')=',IDFREE
  do ISTA=1,NCONF,MBUF
    IEND = min(NCONF,ISTA+MBUF-1)
    IBUF = 1+IEND-ISTA
    call iDAFILE(LUEIG,0,ICI,IBUF,IDFREE)
  end do
end do
! WE NEED COPIES OF THE DISK ADDRESSES. TWO COPIES FOR PSI BUFFERS.
call mma_allocate(IDCR,NNVEC,label='IDCR')
call mma_allocate(IDCW,NNVEC,label='IDCW')
call mma_allocate(IDS,NNVEC,label='IDS')
do K=1,NNVEC
  IDCR(K) = IDISKC(K)
  IDCW(K) = IDISKC(K)
  IDS(K) = IDISKS(K)
end do
IDD = IDISKD
! LOOP OVER BUFFERS FOR READING PSI, SIGMA AND DBUF:
do ISTA=1,NCONF,MBUF
  IEND = min(NCONF,ISTA+MBUF-1)
  IBUF = 1+IEND-ISTA
  call dDAFILE(LUEIG,2,DBUF,IBUF,IDD)
  do K=1,NVEC
    call iDAFILE(LUEIG,2,ICI,IBUF,IDCR(K))
    call UPKVEC(IBUF,ICI,CBUF(1,K))
    call dDAFILE(LUEIG,2,SBUF(1,K),IBUF,IDS(K))
  end do
  ! LOOP OVER VECTOR SECTIONS, LENGTH AT MOST NSECT:
  do JSTA=1,IBUF,NSECT
    JEND = min(IBUF,JSTA+NSECT-1)
    ISECT = 1+JEND-JSTA
    ! TRANSFORM TO EIGENFUNCTIONS OF HSMALL: FIRST, CI SECTION.
    call DGEMM_('N','N',ISECT,NRROOT,NVEC,One,CBUF(JSTA,1),MBUF,VSMALL,MXVEC,Zero,CSECT,NSECT)
    ! THEN, SIGMA SECTION INTO RSECT.
    call DGEMM_('N','N',ISECT,NRROOT,NVEC,One,SBUF(JSTA,1),MBUF,VSMALL,MXVEC,Zero,RSECT,NSECT)
    ! AND THEN FORM RSECT=SECTION OF RESIDUAL ARRAY, AND XI1 AND XI2:
    do I=1,ISECT
      do K=1,NRROOT
        RSECT(I,K) = RSECT(I,K)-ESMALL(K)*CSECT(I,K)
        XI1(I,K) = CSECT(I,K)/(DBUF(I+JSTA-1)-ESMALL(K))
        XI2(I,K) = RSECT(I,K)/(DBUF(I+JSTA-1)-ESMALL(K))
      end do
    end do
    ! FORM NEW PSI ARRAYS IN CNEW SECTION:
    call DGEMM_('N','N',ISECT,NNEW,NRROOT,One,CSECT,NSECT,VZERO(IVZ1,IVZSTA),MXZ,Zero,CNEW,NSECT)
    call DGEMM_('N','N',ISECT,NNEW,NRROOT,One,RSECT,NSECT,VZERO(IVZ2,IVZSTA),MXZ,One,CNEW,NSECT)
    call DGEMM_('N','N',ISECT,NNEW,NRROOT,One,XI1,NSECT,VZERO(IVZ3,IVZSTA),MXZ,One,CNEW,NSECT)
    call DGEMM_('N','N',ISECT,NNEW,NRROOT,One,XI2,NSECT,VZERO(IVZ4,IVZSTA),MXZ,One,CNEW,NSECT)
    !if (ISTA+JSTA == 2) then
    !  write(u6,*) ' CONSTRUCTION OF NEW VECTOR IN HZLP2.'
    !  write(u6,*) ' CSECT:'
    !  write(u6,'(1X,5F15.6)') ((CSECT(I,J),I=1,5),J=1,NNEW)
    !  write(u6,*) ' RSECT:'
    !  write(u6,'(1X,5F15.6)') ((RSECT(I,J),I=1,5),J=1,NNEW)
    !  write(u6,*) '   XI1:'
    !  write(u6,'(1X,5F15.6)') ((XI1(I,J),I=1,5),J=1,NNEW)
    !  write(u6,*) '   XI2:'
    !  write(u6,'(1X,5F15.6)') ((XI2(I,J),I=1,5),J=1,NNEW)
    !  write(u6,*) ' VZERO:'
    !  IIII = IVZSTA-1
    !  write(u6,'(1X,4F15.6)') ((VZERO(I,IIII+J),I=1,4*NNEW),J=1,NNEW)
    !  write(u6,*) '  CNEW:'
    !  write(u6,'(1X,5F15.6)') ((CNEW(I,J),I=1,5),J=1,NNEW)
    !end if
    ! INSERT THE NEW PSI SECTIONS IN BUFFER. THIS MAY IMPLY OVERWRITING
    ! OLD ENTRIES, BUT CAN ALSO LEAD TO AN INCREASED NUMBER OF VECTORS:
    do KK=1,NNEW
      NN = NVTOT+KK
      K = 1+mod(NN-1,MXVEC)
      !if (ISTA+JSTA == 2) then
      !  write(u6,'(A,I2,A,I6)') ' CNEW NR.',KK,' COPIED TO BUFFER ',K
      !  write(u6,*) ' IT CONTAINS:'
      !  write(u6,'(1X,5F15.6)') (CNEW(I,KK),I=1,15)
      !end if
      CBUF(JSTA:JSTA+ISECT-1,K) = CNEW(1:ISECT,KK)
    end do
    ! CONTINUE, NEXT SECTION.
  end do
  do KK=1,NNEW
    NN = NVTOT+KK
    K = 1+mod(NN-1,MXVEC)
    !if (ISTA == 1) then
    !  write(u6,'(A,I2,A,I6)') ' BUFFER NR.',K,' WRITTEN AT ',IDCW(K)
    !  write(u6,*) ' IT CONTAINS:'
    !  write(u6,'(1X,5F15.6)') (CBUF(I,K),I=1,15)
    !end if
    call PKVEC(IBUF,CBUF(1,K),ICI)
    call iDAFILE(LUEIG,1,ICI,IBUF,IDCW(K))
  end do
  ! CONTINUE, NEXT BUFFER.
end do
NVTOT = NVTOT+NNEW
call mma_deallocate(IDCR)
call mma_deallocate(IDCW)
call mma_deallocate(IDS)

return

end subroutine HZLP2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine Freeze(TrMat,nTrMat,OneHam,mBT)
!***********************************************************************
!                                                                      *
!     purpose: Modify transformation matrix such atomic orbitals we    *
!              want to freeze are put in the first position            *
!                                                                      *
!     input:                                                           *
!       TrMat   : transformation matrix of length nTrMat               *
!                                                                      *
!     output:                                                          *
!       TrMat   : modified transformation matrix                       *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: nBas, nBT, nFro, nOrb, nSym
use Molcas, only: MxBas, MxSym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nTrMat, mBT
real(kind=wp), intent(inout) :: TrMat(nTrMat)
real(kind=wp), intent(in) :: OneHam(mBT)
integer(kind=iwp) :: i, iBas, iCMO, iFro, Ind1, Ind2, iSta, iStart, iStrt, iSwap, iSym, j, k, MapBas(MxBas,MxSym), nOr
real(kind=wp) :: OEMin
real(kind=wp), allocatable :: Temp(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Allocate temporary spaces
call mma_allocate(Temp,nBT,Label='Temp')

Temp(:) = OneHam(:)

! Form an array saying which atomic orbitals are frozen
iStart = 0
do iSym=1,nSym
  nOr = nOrb(iSym)
  do iFro=1,nFro(iSym)
    OEMin = 1.0e6_wp
    iStrt = iStart
    iSta = 0
    do iBas=1,nOr
      iStrt = iStrt+iBas
      if (Temp(iStrt) < OEMin) then
        MapBas(iFro,iSym) = iBas
        OEMin = Temp(iStrt)
        iSta = iStrt
      end if
    end do
    if (iSta /= 0) Temp(iSta) = -Temp(iSta)
  end do
  iStart = iStart+nTri_Elem(nOr)
  do i=1,nFro(iSym)-1
    k = i
    do j=i+1,nFro(iSym)
      if (MapBas(j,iSym) < MapBas(k,iSym)) k = j
    end do
    if (k /= i) then
      iSwap = MapBas(k,iSym)
      MapBas(k,iSym) = MapBas(i,iSym)
      MapBas(i,iSym) = iSwap
    end if
  end do
end do

! Move frozen atomic orbitals to the first positions
iCMO = 1
do iSym=1,nSym
  do iFro=1,nFro(iSym)
    ind1 = iCMO+(iFro-1)*nBas(iSym)
    ind2 = iCMO+(MapBas(iFro,iSym)-1)*nBas(iSym)
    call DSwap_(nBas(iSym),TrMat(ind1),1,TrMat(ind2),1)
  end do
  iCMO = iCMO+nBas(iSym)*nOrb(iSym)
end do

! Deallocate memory
call mma_deallocate(Temp)

end subroutine Freeze

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkqhelp2(vector,dimv,length,factor)
! this routine does vector = vector*factor
! vector - multiplied vector (I/O)
! dimv   - dimension of vector
! length - length of vector to be multiplied
! factor - scaling factor
!
! $N.B. this routine should be substituted by mv0s3v

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimv, length
real(kind=wp), intent(inout) :: vector(dimv)
real(kind=wp), intent(in) :: factor

if (length > 0) vector(1:length) = vector(1:length)*factor

return

end subroutine mkqhelp2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKDAW_RASSI(NLEV,NVERT,IDRT,IDOWN,IDAW,LTV)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='MKDAW_RASSI')
      DIMENSION IDOWN(NVERT,0:3),IDAW(NVERT,0:4),IDRT(NVERT,5)
      DIMENSION LTV(-1:NLEV)
      PARAMETER (LTAB=1)

C Purpose: Construct Direct Arc Weights.




C SET UP A LEVEL-TO-VERTEX TABLE, LTV, AND IDENTIFY MIDVERTICES:
      DO LEV=-1,NLEV
        LTV(LEV)=0
      END DO
      DO IV=1,NVERT
        LEV=IDRT(IV,LTAB)
        LTV(LEV)=LTV(LEV)+1
      END DO
      DO LEV=NLEV,0,-1
        LTV(LEV-1)=LTV(LEV-1)+LTV(LEV)
      END DO
      DO LEV=-1,NLEV-1
        LTV(LEV)=1+LTV(LEV+1)
      END DO
      DO IC=0,3
        IDAW(NVERT,IC)=0
      END DO
      IDAW(NVERT,4)=1
      DO IV=NVERT-1,1,-1
        ISUM=0
        DO IC=0,3
          IDAW(IV,IC)=0
          IDWN=IDOWN(IV,IC)
          IF(IDWN.NE.0) THEN
           IDAW(IV,IC)=ISUM
           ISUM=ISUM+IDAW(IDWN,4)
          END IF
        END DO
        IDAW(IV,4)=ISUM
      END DO

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
*               2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine PLF_LDF_JK_2P_3(TInt,nTInt,Map,
     &                           AOint,ijkl,iCmp,jCmp,kCmp,lCmp,
     &                           iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*          Modified for Local DF, Thomas Bondo Pedersen, June 2010     *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit None
      Integer nTInt
      Real*8  TInt(nTInt)
      Integer Map(4)
      Integer ijkl, iCmp, jCmp, kCmp, lCmp
      Real*8  AOInt(ijkl,iCmp,jCmp,kCmp,lCmp)
      Integer iAO(4), iAOst(4)
      Integer iBas, jBas, kBas, lBas
      Integer kOp(4)
#include "localdf_bas.fh"
#include "localdf_int2.fh"
#include "WrkSpc.fh"

      Character*15 SecNam
      Parameter (SecNam='PLF_LDF_JK_2P_3')

      Integer i1, i2, i3, i4
      Integer iShlI, iShlJ, iShlK, iShlL
      Integer iSO, jSO, kSO, lSO
      Integer iSOi, jSOj, lSOl, kSOk
      Integer ii, jj, kk, ll
      Integer iShlKL, kl, kl0
      Integer iShlIJ, ij, ij0
      Integer nijkl
      Integer jkL, ijL

      Integer i, j
      Integer nBasSh, iShlSO, iRow, iCol
#if defined (_DEBUGPRINT_)
      Integer iSOShl
      iSOShl(i)=iWork(ip_iSOShl-1+i)
#endif
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iShlSO(i)=iWork(ip_iShlSO-1+i)
      iRow(i,j)=iWork(ip_AB_IndxG2-1+l_AB_IndxG2_1*(j-1)+i)
      iCol(i,j)=iWork(ip_CD_IndxG-1+l_CD_IndxG_1*(j-1)+i)

      If (Map(1).eq.1 .and. Map(2).eq.2 .and.
     &    Map(3).eq.3 .and. Map(4).eq.4) Then
#if defined (_DEBUGPRINT_)
         If (iSOShl(iAOtSO(iAO(1)+1,kOp(1))+iAOst(1)).ne.SHA) Then
            Call WarningMessage(2,SecNam//': Shell problem [1.1]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(2)+1,kOp(2))+iAOst(2)).ne.SHB) Then
            Call WarningMessage(2,SecNam//': Shell problem [2.1]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)).ne.SHC) Then
            Call WarningMessage(2,SecNam//': Shell problem [3.1]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)).ne.SHD) Then
            Call WarningMessage(2,SecNam//': Shell problem [4.1]')
            Call LDF_Quit(1)
         End If
         If (kCmp*kBas.ne.1) Then
            Call WarningMessage(2,
     &                        SecNam//': Shell dimension problem [1.1]')
            Call LDF_Quit(1)
         End If
#endif
         iShlI=SHA
         iShlJ=SHB
         iShlIJ=SPAB
         iShlL=SHD
         i3=1
         Do i4=1,lCmp
            lSO=iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
            Do i2=1,jCmp
               jSO=iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
               Do i1=1,iCmp
                  iSO=iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
                  nijkl=0
                  Do lSOl=lSO,lSO+lBas-1
                     ll=iShlSO(lSOl)
                     If (iCol(ll,iShlL).gt.0) Then
                        Do jSOj=jSO,jSO+jBas-1
                           jj=iShlSO(jSOj)
                           ij0=nBasSh(iShlI)*(jj-1)
                           Do iSOi=iSO,iSO+iBas-1
                              ii=iShlSO(iSOi)
                              ij=ij0+ii
                              nijkl=nijkl+1
                              If (iRow(ij,iShlIJ).gt.0) Then
                                 ijL=nAB*(iCol(ll,iShlL)-1)
     &                              +iRow(ij,iShlIJ)
                                 TInt(ijL)=AOInt(nijkl,i1,i2,i3,i4)
                              End If
                           End Do
                        End Do
                     Else
                        nijkl=nijkl+iBas*jBas
                     End If
                  End Do
               End Do
            End Do
         End Do
      Else If (Map(1).eq.3 .and. Map(2).eq.4 .and.
     &         Map(3).eq.1 .and. Map(4).eq.2) Then
#if defined (_DEBUGPRINT_)
         If (iSOShl(iAOtSO(iAO(1)+1,kOp(1))+iAOst(1)).ne.SHC) Then
            Call WarningMessage(2,SecNam//': Shell problem [1.2]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(2)+1,kOp(2))+iAOst(2)).ne.SHD) Then
            Call WarningMessage(2,SecNam//': Shell problem [2.2]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)).ne.SHA) Then
            Call WarningMessage(2,SecNam//': Shell problem [3.2]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)).ne.SHB) Then
            Call WarningMessage(2,SecNam//': Shell problem [4.2]')
            Call LDF_Quit(1)
         End If
         If (iCmp*iBas.ne.1) Then
            Call WarningMessage(2,
     &                        SecNam//': Shell dimension problem [1.2]')
            Call LDF_Quit(1)
         End If
#endif
         iShlJ=SHD
         iShlK=SHA
         iShlL=SHB
         iShlKL=SPAB
         i1=1
         Do i4=1,lCmp
            lSO=iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
            Do i3=1,kCmp
               kSO=iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i2=1,jCmp
                  jSO=iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
                  nijkl=0
                  Do lSOl=lSO,lSO+lBas-1
                     ll=iShlSO(lSOl)
                     kl0=nBasSh(iShlK)*(ll-1)
                     Do kSOk=kSO,kSO+kBas-1
                        kk=iShlSO(kSOk)
                        kl=kl0+kk
                        If (iRow(kl,iShlKL).gt.0) Then
                           Do jSOj=jSO,jSO+jBas-1
                              jj=iShlSO(jSOj)
                              nijkl=nijkl+1
                              If (iCol(jj,iShlJ).gt.0) Then
                                 Jkl=nAB*(iCol(jj,iShlJ)-1)
     &                              +iRow(kl,iShlKL)
                                 TInt(Jkl)=AOInt(nijkl,i1,i2,i3,i4)
                              End If
                           End Do
                        Else
                           nijkl=nijkl+jBas
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
      Else
         Call WarningMessage(2,
     &                   SecNam//': shell combination not implemented!')
         Call LDF_Quit(1)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine write_binary_aniso(nss,nstate,multiplicity,eso,esfs,U,MM,MS,DM,ANGMOM,EDMOM,AMFI,HSO)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nss, nstate
integer(kind=iwp), intent(_IN_) :: multiplicity(nstate)
real(kind=wp), intent(_IN_) :: eso(nss), esfs(nstate), angmom(3,nstate,nstate), edmom(3,nstate,nstate), amfi(3,nstate,nstate)
complex(kind=wp), intent(in) :: U(nss,nss), MM(3,nss,nss), MS(3,nss,nss), DM(3,nss,nss), HSO(nss,nss)
integer(kind=iwp) :: idisk, idum(1), l, luaniso
real(kind=wp), allocatable :: tmpI(:,:), tmpR(:,:)

LUANISO = 8
! open the binary $Project.aniso file
call DANAME(LUANISO,'POLYFILE')
! writing data to it:
idisk = 0
idum(1) = nstate
call idafile(luaniso,1,idum,1,idisk)
idum(1) = nss
call idafile(luaniso,1,idum,1,idisk)
! spin multiplicity ofthe spin free states:
call idafile(luaniso,1,multiplicity,nstate,idisk)
! spin-orbit energies:
call ddafile(luaniso,1,eso,nss,idisk)
! spin-free energies:
call ddafile(luaniso,1,esfs,nstate,idisk)

call mma_allocate(tmpR,nss,nss,'tmpR')
call mma_allocate(tmpI,nss,nss,'tmpI')
! spin-orbit mixing coefficients:
tmpR(:,:) = real(U(:,:))
tmpI(:,:) = aimag(U(:,:))
call ddafile(luaniso,1,tmpR,nss*nss,idisk)
call ddafile(luaniso,1,tmpI,nss*nss,idisk)

! spin-orbit Hamiltonian
tmpR(:,:) = real(HSO(:,:))
tmpI(:,:) = aimag(HSO(:,:))
call ddafile(luaniso,1,tmpR,nss*nss,idisk)
call ddafile(luaniso,1,tmpI,nss*nss,idisk)

! angmom
call ddafile(luaniso,1,angmom,3*nstate*nstate,idisk)
! edmom
call ddafile(luaniso,1,edmom,3*nstate*nstate,idisk)
! amfi
call ddafile(luaniso,1,amfi,3*nstate*nstate,idisk)

! magnetic moment:
do l=1,3
  tmpR(:,:) = real(MM(l,:,:))
  tmpI(:,:) = aimag(MM(l,:,:))
  call ddafile(luaniso,1,tmpR,nss*nss,idisk)
  call ddafile(luaniso,1,tmpI,nss*nss,idisk)
end do

! spin moment:
do l=1,3
  tmpR(:,:) = real(MS(l,:,:))
  tmpI(:,:) = aimag(MS(l,:,:))
  call ddafile(luaniso,1,tmpR,nss*nss,idisk)
  call ddafile(luaniso,1,tmpI,nss*nss,idisk)
end do

! electric dipole moment:
do l=1,3
  tmpR(:,:) = real(DM(l,:,:))
  tmpI(:,:) = aimag(DM(l,:,:))
  call ddafile(luaniso,1,tmpR,nss*nss,idisk)
  call ddafile(luaniso,1,tmpI,nss*nss,idisk)
end do

call mma_deallocate(tmpR)
call mma_deallocate(tmpI)
! close the binary $Project.aniso file
call daclos(luaniso)

return

end subroutine write_binary_aniso

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine MltInt_GIAO( &
#                      define _CALLING_
#                      include "int_interface.fh"
                      )
!***********************************************************************
!                                                                      *
! Object: to compute the multipole moments integrals with the          *
!         Gauss-Hermite quadrature.                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!             Modified to multipole moments November '90               *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "oneswi.fh"
#include "print.fh"
integer(kind=iwp) :: ia, ib, iComp, iDCRT(0:7), ii, iIC, ipAxyz, ipBxyz, ipFnl, ipQxyz, iPrint, ipRxyz, iRout, iStabO(0:7), lDCRT, &
                     llOper, LmbdT, nB, nDCRT, nip, nOp, nStabO
real(kind=wp) :: RAB(3), TC(3)
character(len=80) :: Label
logical(kind=iwp) :: ABeq(3)
character(len=*), parameter :: ChOper(0:7) = ['E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz']
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(ZInv)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 122
iPrint = nPrint(iRout)

rFinal(:,:,:,:) = Zero

if (.not. EQ(A,RB)) then

  ABeq(:) = A == RB
  RAB(:) = A-RB
  ! switch (only single center overlap matrix...)
  if (NDDO .and. (.not.(ABeq(1)) .and. ABeq(2) .and. ABeq(3))) return
  ! switch
  nip = 1
  ipAxyz = nip
  nip = nip+nZeta*3*nHer*(la+1)
  ipBxyz = nip
  nip = nip+nZeta*3*nHer*(lb+1)
  ipRxyz = nip
  nip = nip+nZeta*3*nHer*(nOrdOp+2)
  ipQxyz = nip
  nip = nip+nZeta*3*(la+1)*(lb+1)*(nOrdOp+2)
  ipFnl = nip
  nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp
  if (nip-1 > nArr*nZeta) then
    call WarningMessage(2,'MltInt_GIAO: nip-1 > nArr*nZeta')
    write(u6,*) ' nArr is Wrong! ',nip-1,' > ',nArr*nZeta
    write(u6,*) ' Abend in MltInt'
    call Abend()
  end if

  if (iPrint >= 49) then
    call RecPrt(' In MltInt: A',' ',A,1,3)
    call RecPrt(' In MltInt: RB',' ',RB,1,3)
    call RecPrt(' In MltInt: Ccoor',' ',Ccoor,1,3)
    call RecPrt(' In MltInt: Kappa',' ',rKappa,nAlpha,nBeta)
    call RecPrt(' In MltInt: Zeta',' ',Zeta,nAlpha,nBeta)
    call RecPrt(' In MltInt: P',' ',P,nZeta,3)
    write(u6,*) ' In MltInt: la,lb=',la,lb
  end if

  llOper = lOper(1)
  do iComp=2,nComp
    llOper = ior(llOper,lOper(iComp))
  end do

  ! Compute the cartesian values of the basis functions angular part

  call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),la,HerR(iHerR(nHer)),nHer,ABeq)
  call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),lb,HerR(iHerR(nHer)),nHer,ABeq)

  call SOS(iStabO,nStabO,llOper)
  call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
  if (iPrint >= 99) then
    write(u6,*) ' m      =',nStabM
    write(u6,'(9A)') '{M}=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
    write(u6,*) ' s      =',nStabO
    write(u6,'(9A)') '{S}=',(ChOper(iStabO(ii)),ii=0,nStabO-1)
    write(u6,*) ' LambdaT=',LmbdT
    write(u6,*) ' t      =',nDCRT
    write(u6,'(9A)') '{T}=',(ChOper(iDCRT(ii)),ii=0,nDCRT-1)
  end if

  do lDCRT=0,nDCRT-1
    call OA(iDCRT(lDCRT),CCoor,TC)

    ! Compute the contribution from the multipole moment operator

    ABeq(1) = .false.
    ABeq(2) = .false.
    ABeq(3) = .false.
    call CrtCmp(Zeta,P,nZeta,TC,Array(ipRxyz),nOrdOp+1,HerR(iHerR(nHer)),nHer,ABeq)

    ! Compute the cartesian components for the multipole moment
    ! integrals. The integrals are factorized into components.

    call Assmbl(Array(ipQxyz),Array(ipAxyz),la,Array(ipRxyz),nOrdOp+1,Array(ipBxyz),lb,nZeta,HerW(iHerW(nHer)),nHer)

    ! Combine the cartesian components to the full one electron integral.

    nB = 3
    call CmbnMP_GIAO(Array(ipQxyz),nZeta,la,lb,nOrdOp,Zeta,rKappa,Array(ipFnl),nComp/nB,nB,RAB,TC)

    ! Accumulate contributions

    nOp = NrOpr(iDCRT(lDCRT))
    call SymAdO(Array(ipFnl),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,One)

  end do

end if

if (iPrint >= 99) then
  write(u6,*) ' Result in MltInt'
  do ia=1,(la+1)*(la+2)/2
    do ib=1,(lb+1)*(lb+2)/2
      do iIC=1,nIC
        write(Label,'(A,I2,A,I2,A,I2,A)') ' rFinal(a=',ia,',b=',ib,',iIC=',iIC,')'
        call RecPrt(Label,' ',rFinal(:,ia,ib,iIC),nAlpha,nBeta)
      end do
    end do
  end do
end if

return

end subroutine MltInt_GIAO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Remove_TR(nQ,nX,nQQ,KMat,nK,TRVec,nTR,BM,iBM,nqB,nB)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nQ, nX, nQQ, nK, nTR, nB, iBM(nB), nqB(nQ)
real(kind=wp), intent(inout) :: KMat(nQ,nK)
real(kind=wp), intent(in) :: TRVec(nX,nTR), BM(nB)
integer(kind=iwp) :: i, iB, iK, iQ, iTR, iV, iX
real(kind=wp), allocatable :: TR(:), VecInt(:)
real(kind=wp), external :: DDot_

call mma_allocate(TR,nK)
call mma_allocate(VecInt,nX)

TR(:) = Zero

do iK=1,nK

  ! Get the normalized Cartesian vector for this internal coordinate
  VecInt(:) = Zero
  iB = 0
  do iQ=1,nQ
    do i=1,nqB(iQ)
      iB = iB+1
      iX = iBM(iB)
      VecInt(iX) = VecInt(iX)+KMat(iQ,iK)*BM(iB)
    end do
  end do
  VecInt(:) = VecInt(:)/sqrt(dDot_(nX,VecInt,1,VecInt,1))

  ! Compute the overlap with the external translations and rotations
  do iTR=1,nTR
    TR(iK) = TR(iK)+dDot_(nX,VecInt,1,TRvec(:,iTR),1)**2
  end do
end do

! Put the nK-nQQ vectors with largest overlap at the end
do iK=nK,nQQ+1,-1
  iV = maxloc(TR(1:iK),1)
  if (iV /= iK) call dSwap_(nQ,KMat(:,iK),1,KMat(:,iV),1)
end do

call mma_deallocate(TR)
call mma_deallocate(VecInt)

return

end subroutine Remove_TR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Tra2c(i,iSym,iBas,iAsh,j,jSym,jBas,jAsh,kl_Bas_pairs,ij_Orb_pairs,CMO_i,CMO_j,IJKL,C,TUKL)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: i, iSym, iBas, iAsh, j, jSym, jBas, jAsh, kl_Bas_pairs, ij_Orb_pairs
real(kind=wp), intent(in) :: CMO_i(iBas,iAsh), CMO_j(jBas,jAsh), IJKL(kl_Bas_pairs)
real(kind=wp), intent(out) :: C(ij_Orb_pairs)
real(kind=wp), intent(inout) :: TUKL(kl_Bas_pairs,ij_Orb_pairs)
integer(kind=iwp) :: iA, ijA, jA

!call RecPrt('IJKL',' ',IJKL,1,kl_Bas_Pairs)

if ((iSym == jSym) .and. (i /= j)) then
  ijA = 0
  do iA=1,iAsh
    do jA=1,iA
      ijA = ijA+1
      C(ijA) = CMO_i(i,iA)*CMO_i(j,jA)+CMO_i(j,iA)*CMO_i(i,jA)
    end do
  end do
  !call TriPrt('C',' ',C,iAsh)
else if (iSym == jSym) then
  ijA = 0
  do iA=1,iAsh
    do jA=1,iA
      ijA = ijA+1
      C(ijA) = CMO_i(i,iA)*CMO_i(i,jA)
    end do
  end do
  !call TriPrt('C',' ',C,iAsh)
else
  ijA = 0
  do iA=1,iAsh
    do jA=1,jAsh
      ijA = ijA+1
      C(ijA) = CMO_i(i,iA)*CMO_j(j,jA)
    end do
  end do
  !call RecPrt('C',' ',C,jAsh,iAsh)
end if
!write(u6,*) ' ij_Orb_Pairs=',ij_Orb_Pairs

call DNaXpY(ij_Orb_pairs,kl_Bas_pairs,C,1,IJKL,1,0,TUKL,1,kl_Bas_pairs)

return

end subroutine Tra2c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Kurt Pfingst                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Radlq(Zeta,nZeta,lsum,Rnr,icop)
!***********************************************************************
!                                                                      *
! Object: to compute the radial part of the continuum Coulomb          *
!         integrals outside the R-matrix sphere                        *
!                                                                      *
! Called from: KneInt                                                  *
!                                                                      *
! Author: K.Pfingst 21/5/93                                            *
!***********************************************************************

use fx, only: f_interface
use rmat, only: EpsAbs, EpsRel, ExpSum, l, RMatR
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, lSum, icop
real(kind=wp), intent(in) :: Zeta(nZeta)
real(kind=wp), intent(out) :: Rnr(nZeta,0:lsum)
integer(kind=iwp), parameter :: limit = 200, lenw = 4*limit
integer(kind=iwp) :: ier, ir, iScrt(limit), iZeta, Last, nEval
real(kind=wp) :: AbsEr, reslt, Scrt(lenw)
#ifdef _DEBUGPRINT_
character(len=80) :: Label
#endif
procedure(f_interface) :: fradf

call Untested('Radlq')

!                                                                      *
!***********************************************************************
!                                                                      *
do ir=0,lsum
  do iZeta=1,nZeta
    expsum = Zeta(iZeta)
    ier = 0
    l = ir-icop
    call dqagi(fradf,Rmatr,1,Epsabs,Epsrel,reslt,abser,neval,ier,limit,lenw,last,iScrt,Scrt)
    if (ier > 0) then
      call WarningMessage(1,' WARNING in Radlq; Consult output for details!')
      write(u6,*) ' ier=',ier,' Error in Dqagi called from Radlq.'
      write(u6,*) ' result=',reslt
      write(u6,*) ' abser =',abser
      write(u6,*) ' neval =',neval
      write(u6,*) ' WARNING in Radlq'
    end if
    Rnr(iZeta,ir) = reslt
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) ' Result in Radlq'
write(Label,'(A)') ' Rnr'
call RecPrt(Label,' ',Rnr(1,0),nZeta,lsum+1)
#endif

end subroutine Radlq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 FUNCTION GAM(M)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CRELOP/ PI,ZWP,SQPI,VELIT,PREA,CSQ,ZWPH32,FAK(26),
     *ZWPH12,BCO(210),GA(20),IMAX
*rl   COMMON /CRELOP/ PI,ZWP,SQPI
      SAVE /CRELOP/
      IF (MOD(M,2).EQ.0) GOTO 10
      MA=(M+1)/2
      G=1.D0
      IF (MA.EQ.1) GOTO 11
      DO 1 I=2,MA
      G=G*DBLE(I-1)
1     CONTINUE
      GAM=G
      RETURN
10    MA=M
      G=SQPI
      IF (MA.EQ.0) GOTO 11
      DO 2 I=1,MA,2
      G=G*0.5D0*DBLE(I)
2     CONTINUE
11    GAM=G
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------
! 1998  PER-AAKE MALMQUIST
! DEPARTMENT OF THEORETICAL CHEMISTRY
! UNIVERSITY OF LUND
! SWEDEN
!--------------------------------------------

subroutine MKRHSG(IVEC,ERI1,nERI1,ERI2,nERI2,SCR,nSCR)
! Set up RHS vector of PT2 Linear Equation System, in vector
! number IVEC of LUSOLV, for cases 10 and 11 (BJAT).

use Symmetry_Info, only: Mul
use SUPERINDEX, only: KAGEB, KAGTB
use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array, GA_Arrays
use caspt2_module, only: NAGEB, NAGEBES, NAGTB, NAGTBES, NASH, NINDEP, NISH, NISUP, NISUP, NORB, NSES, NSSH, NSYM
use Constants, only: Half, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, nERI1, nERI2, nSCR
real(kind=wp), intent(inout) :: ERI1(nERI1), ERI2(nERI2), SCR(nSCR)
integer(kind=iwp) :: IA, IAABS, IAGEB, IAGTB, IATOT, IB, IBABS, IBTOT, IBUF, ICASE, II, IO1, IO2, IOFF1(8), IOFF2(8), ISYM, ISYMA, &
                     ISYMAB, ISYMB, ISYMI, IT, ITTOT, IWA, IWIM, IWIP, IWM, JWP, LWM, LWP, NAS, NISM, NISP, NVM, NVP
real(kind=wp) :: A, B
real(kind=wp), parameter :: SQI2 = sqrt(Half), SQ32 = sqrt(OneHalf)

do ISYM=1,NSYM
  if (NINDEP(ISYM,10)+NINDEP(ISYM,11) == 0) cycle
  ! Set up offset table:
  IO1 = 0
  IO2 = 0
  do ISYMI=1,NSYM
    IOFF1(ISYMI) = IO1
    IOFF2(ISYMI) = IO2
    ISYMAB = Mul(ISYMI,ISYM)
    IO1 = IO1+NISH(ISYMI)*NAGEB(ISYMAB)
    IO2 = IO2+NISH(ISYMI)*NAGTB(ISYMAB)
  end do
  ! Allocate W with parts WP,WM
  NAS = NASH(ISYM)
  NISP = NISUP(ISYM,10)
  NISM = NISUP(ISYM,11)
  NVP = NAS*NISP
  if (NVP == 0) cycle
  NVM = NAS*NISM
  LWP = Allocate_GA_Array(NVP,'WGP')
  LWM = Allocate_GA_Array(NVM,'WGM')
  ! Let  W(t,i,a,b)=(atbi)
  !   WP(t,i,ab)=  (W(t,i,a,b)+W(t,i,b,a))
  ! With new normalisation, divide by /SQRT(2+2*Kron(ab))
  !   WM(t,i,ab)=3*(W(t,i,a,b)-W(t,i,b,a))
  ! With new normalisation, divide by /SQRT(6)
  do ISYMA=1,NSYM
    do ISYMB=1,ISYMA
      ISYMAB = Mul(ISYMA,ISYMB)
      ISYMI = Mul(ISYMAB,ISYM)
      do IT=1,NASH(ISYM)
        ITTOT = IT+NISH(ISYM)
        do II=1,NISH(ISYMI)
          call EXCH(ISYMA,ISYM,ISYMB,ISYMI,ITTOT,II,ERI1,SCR)
          call EXCH(ISYMA,ISYMI,ISYMB,ISYM,II,ITTOT,ERI2,SCR)
          do IA=1,NSSH(ISYMA)
            IAABS = IA+NSES(ISYMA)
            IATOT = IA+NISH(ISYMA)+NASH(ISYMA)
            do IB=1,NSSH(ISYMB)
              IBABS = IB+NSES(ISYMB)
              IBTOT = IB+NISH(ISYMB)+NASH(ISYMB)
              if (IAABS < IBABS) exit
              IBUF = IATOT+NORB(ISYMA)*(IBTOT-1)
              IWA = IT
              IAGEB = KAGEB(IAABS,IBABS)-NAGEBES(ISYMAB)
              IWIP = II+NISH(ISYMI)*(IAGEB-1)+IOFF1(ISYMI)
              JWP = IWA+NAS*(IWIP-1)
              A = ERI1(IBUF)+ERI2(IBUF)
              if (IAABS /= IBABS) then
                GA_Arrays(LWP)%A(JWP) = SQI2*A
                IAGTB = KAGTB(IAABS,IBABS)-NAGTBES(ISYMAB)
                IWIM = II+NISH(ISYMI)*(IAGTB-1)+IOFF2(ISYMI)
                IWM = IWA+NAS*(IWIM-1)
                B = ERI1(IBUF)-ERI2(IBUF)
                GA_Arrays(LWM)%A(IWM) = SQ32*B
              else
                GA_Arrays(LWP)%A(JWP) = half*A
              end if
            end do
          end do
        end do
      end do
    end do
  end do
  ! Put WP and WM on disk.
  ICASE = 10
  call MKRHS_SAVE(ICASE,ISYM,IVEC,LWP)
  if (NVM > 0) then
    ICASE = 11
    call MKRHS_SAVE(ICASE,ISYM,IVEC,LWM)
  end if
  call Deallocate_GA_Array(LWP)
  call Deallocate_GA_Array(LWM)
end do

end subroutine MKRHSG

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine puts array integer data to the runfile.                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: August 2003                                                 *
!                                                                      *
!***********************************************************************
!  Put_iArray
!
!> @brief
!>   Add/update array data in runfile
!> @author Per-Olof Widmark
!>
!> @details
!> This routine is used to put array data of type
!> ``Integer`` into the runfile. The data items are
!> identified by the label. Below is a list of the
!> data items that are recognized. The labels are
!> case insensitive and significant to 16 characters.
!>
!> For development purposes you can use an unsupported
!> label. Whenever such a field is accessed a warning
!> message is printed in the output, to remind the
!> developer to update this routine.
!>
!> @param[in] Label Name of field
!> @param[in] iData Data to put on runfile
!> @param[in] nData Length of array
!***********************************************************************

subroutine Put_iArray(Label,iData,nData)

use RunFile_data, only: LabelsIA, lw, nTocIA, sNotUsed, sRegularField, sSpecialField
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: nData, iData(nData)
integer(kind=iwp) :: i, item, iTmp, nTmp, RecIdx(nTocIA) = 0, RecLen(nTocIA) = 0
character(len=lw) :: CmpLab1, CmpLab2, RecLab(nTocIA) = ''

!----------------------------------------------------------------------*
! Do setup if this is the first call.                                  *
!----------------------------------------------------------------------*
call ffRun('iArray labels',nTmp,iTmp)
if (nTmp == 0) then
  RecLab(:) = LabelsIA
  RecIdx(:) = sNotUsed
  RecLen(:) = 0
  call cWrRun('iArray labels',RecLab,lw*nTocIA)
  call iWrRun('iArray indices',RecIdx,nTocIA)
  call iWrRun('iArray lengths',RecLen,nTocIA)
else
  call cRdRun('iArray labels',RecLab,lw*nTocIA)
  call iRdRun('iArray indices',RecIdx,nTocIA)
  call iRdRun('iArray lengths',RecLen,nTocIA)
end if
!----------------------------------------------------------------------*
! Locate item                                                          *
!----------------------------------------------------------------------*
item = -1
CmpLab1 = Label
call UpCase(CmpLab1)
do i=1,nTocIA
  CmpLab2 = RecLab(i)
  call UpCase(CmpLab2)
  if (CmpLab1 == CmpLab2) item = i
end do

! Do we create a new temporary field?

if (item == -1) then
  do i=1,nTocIA
    if (RecLab(i) == ' ') item = i
  end do
  if (item /= -1) then
    RecLab(item) = Label
    RecIdx(item) = sSpecialField
    call cWrRun('iArray labels',RecLab,lw*nTocIA)
    call iWrRun('iArray indices',RecIdx,nTocIA)
  end if
end if

! Is this a temporary field?

if (item /= -1) then
  if (Recidx(item) == sSpecialField) then
    write(u6,*) '***'
    write(u6,*) '*** Warning, writing temporary iArray field'
    write(u6,*) '***   Field: ',Label
    write(u6,*) '***'
#   ifndef _DEVEL_
    call AbEnd()
#   endif
  end if
end if
!----------------------------------------------------------------------*
! Write data to disk.                                                  *
!----------------------------------------------------------------------*
if (item == -1) call SysAbendMsg('put_iArray','Could not locate',Label)
call iWrRun(RecLab(item),iData,nData)
if (RecIdx(item) == 0) then
  RecIdx(item) = sRegularField
  call iWrRun('iArray indices',RecIdx,nTocIA)
end if
if (RecLen(item) /= nData) then
  RecLen(item) = nData
  call iWrRun('iArray lengths',RecLen,nTocIA)
end if
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine Put_iArray

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
!****************************************************************
!   ar      =1 (+a^r)     drr     =2 (+d^rr)   drl     =3 (+d^rl)
!   arbr    =4 (+d^rr)    arbl    =5 (+d^rl)   ard_l^r =6 (+a^l)
!   drrb^r  =7 (+a^r)     drlb^r  =8 (+a^l)    drlb^l  =9 (+a^r)
!   arbrb^r =10 (+a^r)    arblb^r =11 (+a^l)   arblb^l =12 (+a^r)
!   drl        =13 (*)
!****************************************************************

      subroutine inner_space_loop_g()
      implicit REAL*8 (a-h,o-z)
      wsc0=c_time()
      call dbl_space_loop_g()
      wsc1=c_time()
      call act_space_cloop_g()
      call act_space_ploop_g()
      wsc2=c_time()
c      write(6,'(2x,2(a5,f12.4))')'dbl',wsc1-wsc0,'act',wsc2-wsc1
      return
      end

      subroutine act_space_cloop_g()        ! one sub_drt
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      if(norb_act.eq.0) return
      ni=mod(norb_act,2)
      do ipae=1,25
        jpae=nu_ae(ipae)
        if(jpae.eq.0) cycle
        do jpad=1,mxnode
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          if(ndim .eq. 0) cycle
          call copy_to_drtl()
          call cloop_in_act_g()
        enddo
      enddo
      return
      end

      subroutine act_space_ploop_g()        ! two sub_drt with same ipae
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"

      if(norb_act.eq.0) return
      ni=mod(norb_act,2)
      do ipae=1,25
        jpae=nu_ae(ipae)
        if(jpae.eq.0) cycle
        do jpadl=1,mxnode                                ! jpadl
          if(nu_ad(jpadl).eq.0) cycle
            jpad=jpadl
            call seg_drt()
            if(ndim .eq. 0) cycle
            call copy_to_drtl()
          do jpad=1,mxnode                                !jpadr
            if(nu_ad(jpad).eq.0) cycle
            call seg_drt()
            if(ndim .eq. 0) cycle
c        if( ipae.eq.18.and. jpadl.eq.2.and.jpad.eq.1) then
c      write(6,*)
c     endif
           call ploop_in_act_g()
          enddo
        enddo
      enddo
      return
      end

      subroutine cloop_in_act_g()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      do lrai=norb_dz+1,norb_inn-1
        lmi=lsm_inn(lrai)
        do lraj=lrai+1,norb_inn
          lmj=lsm_inn(lraj)
          lmij=mul_tab(lmi,lmj)
c-----------------------------------------------------------
!line=8 d&r&r--d^r^r
          call head_drr_at_given_orb(mh,lrai)
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
          call tail_drr_at_given_orb(mh,lraj)
c          write(6,'(6i6)')8,mh,lrai,lraj,0,0
          if(mh.ne.0) call act_cloop_g(8,mh,lrai,lraj,0,0)
c-----------------------------------------------------------
!line=9 d&r&l--d^r^l
          call head_drl_at_given_orb(mh,lrai)
          call link_c2_to_given_orb(mh,lrai+1,lraj-1)
          call tail_drl_at_given_orb(mh,lraj)
c          write(6,'(6i6)')9,mh,lrai,lraj,0,0
          if(mh.ne.0) call act_cloop_g(9,mh,lrai,lraj,0,0)
          lsmij=mul_tab(lmi,lmj)
c-----------------------------------------------------------
          if(lsmij.ne.1) goto 400
c-----------------------------------------------------------
!line=1 a&r--a^r
          call head_ar_at_given_orb(mh,lrai)
          call link_c1_to_given_orb_coe(mh,lrai+1,lraj-1)
          call tail_ar_at_given_orb_coe(mh,lraj)
c          write(6,'(6i6)')1,mh,lrai,lraj,0,0
          if(mh.ne.0) call act_cloop_g(1,mh,lrai,lraj,0,0)
c          call save_clp(1,mh,lra,0)
c-----------------------------------------------------------
!line=2 a&r-d^r&l-a^l
          do lrak=lrai+1,lraj-1
            call head_ar_at_given_orb(mh,lrai)
            call link_c1_to_given_orb(mh,lrai+1,lrak-1)
            call link_d10_at_given_orb(mh,lrak)
            call link_c1_to_given_orb(mh,lrak+1,lraj-1)
            call tail_al_at_given_orb(mh,lraj)
c          write(6,'(6i6)')2,mh,lrai,lraj,lrak,0
            if(mh.ne.0) call act_cloop_g(2,mh,lrai,lraj,lrak,0)
          enddo
c-----------------------------------------------------------
!line=3 a&r-b&r-d^r^r
          do lrak=lraj+1,norb_inn
            list=list3(lrai,lraj,lrak)
           call head_ar_at_given_orb(mh,lrai)
            call link_c1_to_given_orb(mh,lrai+1,lraj-1)
            call link_b4_at_given_orb(mh,lraj)
            logic_br(1:mh)=.true.
            call link_c2_to_given_orb(mh,lraj+1,lrak-1)
            call tail_drr_at_given_orb(mh,lrak)
c          write(6,'(6i6)')3,mh,lrai,lraj,lrak,0
            if(mh.ne.0) call act_cloop_g(3,mh,lrai,lraj,lrak,0)
c-----------------------------------------------------------
!line=5 a&r-b&l-d^r^l
            call head_ar_at_given_orb(mh,lrai)
            call link_c1_to_given_orb(mh,lrai+1,lraj-1)
            call link_b3_at_given_orb(mh,lraj)
            logic_br(1:mh)=.true.
            call link_c2_to_given_orb(mh,lraj+1,lrak-1)
            call tail_drl_at_given_orb(mh,lrak)
c          write(6,'(6i6)')5,mh,lrai,lraj,lrak,0
            if(mh.ne.0) call act_cloop_g(5,mh,lrai,lraj,lrak,0)
          enddo
c-----------------------------------------------------------
          do lrak=norb_dz+1,lrai-1
            list=list3(lrai,lraj,lrak)
!line=10 d&rr--b^r--a^r
            call head_drr_at_given_orb(mh,lrak)
            logic_br(1:mh)=.true.
            call link_c2_to_given_orb(mh,lrak+1,lrai-1)
            call link_b2_at_given_orb(mh,lrai)
            call link_c1_to_given_orb(mh,lrai+1,lraj-1)
            call tail_ar_at_given_orb(mh,lraj)
c          write(6,'(6i6)')10,mh,lrai,lraj,lrak,0
            if(mh.ne.0) call act_cloop_g(10,mh,lrai,lraj,lrak,0)
c-----------------------------------------------------------
!line=11 d&r&l-b^r-a^l
           call head_drl_at_given_orb(mh,lrak)
            call link_c2_to_given_orb(mh,lrak+1,lrai-1)
            call link_b2_at_given_orb(mh,lra)
            call link_c1_to_given_orb(mh,lrai+1,lraj-1)
            call tail_al_at_given_orb(mh,lraj)
c          write(6,'(6i6)')11,mh,lrai,lraj,lrak,0
            if(mh.ne.0) call act_cloop_g(11,mh,lrai,lraj,lrak,0)
c-----------------------------------------------------------
!line=12 d&r&l-b^l-a^r
           call head_drl_at_given_orb(mh,lrak)
            call link_c2_to_given_orb(mh,lrak+1,lrai-1)
            call link_b1_at_given_orb(mh,lrai)
            call link_c1_to_given_orb(mh,lrai+1,lraj-1)
            call tail_ar_at_given_orb(mh,lraj)
c          write(6,'(6i6)')12,mh,lrai,lraj,lrak,0
            if(mh.ne.0) call act_cloop_g(12,mh,lrai,lraj,lrak,0)
          enddo
400       if(lraj.gt.norb_inn-2) cycle
         do lrak=lraj+1,norb_inn
            lmk=lsm_inn(lrak)
            lmk=mul_tab(lmij,lmk)
           do lral=lrak+1,norb_inn
              lml=lsm_inn(lral)
              lml=mul_tab(lmk,lml)
            if(lml.ne.1) cycle
!line=4  a&r--b&r--b^r--a^r
              call head_ar_at_given_orb(mh,lrai)
              call link_c1_to_given_orb(mh,lrai+1,lraj-1)
              call link_b4_at_given_orb(mh,lraj)
              logic_br(1:mh)=.true.
              call link_c2_to_given_orb(mh,lraj+1,lrak-1)
              call link_b2_at_given_orb(mh,lrak)
              call link_c1_to_given_orb(mh,lrak+1,lral-1)
              call tail_ar_at_given_orb(mh,lral)
c          write(6,'(6i6)')4,mh,lrai,lral,lraj,lrak
              if(mh.ne.0) call act_cloop_g(4,mh,lrai,lral,lraj,lrak)
c-----------------------------------------------------------
!line=6  a&r--b&l--b^r--a^l
              call head_ar_at_given_orb(mh,lrai)
              call link_c1_to_given_orb(mh,lrai+1,lraj-1)
              call link_b3_at_given_orb(mh,lraj)
              logic_br(1:mh)=.true.
              call link_c2_to_given_orb(mh,lraj+1,lrak-1)
              call link_b2_at_given_orb(mh,lrak)
              call link_c1_to_given_orb(mh,lrak+1,lral-1)
              call tail_al_at_given_orb(mh,lral)
c          write(6,'(6i6)')6,mh,lrai,lral,lraj,lrak
              if(mh.ne.0) call act_cloop_g(6,mh,lrai,lral,lraj,lrak)
c-----------------------------------------------------------
!line=7 a&r--b&l--b^l--a^r
              call head_ar_at_given_orb(mh,lrai)
              call link_c1_to_given_orb(mh,lrai+1,lraj-1)
              call link_b3_at_given_orb(mh,lraj)
              logic_br(1:mh)=.true.
              call link_c2_to_given_orb(mh,lraj+1,lrak-1)
              call link_b1_at_given_orb(mh,lrak)
              call link_c1_to_given_orb(mh,lrak+1,lral-1)
              call tail_ar_at_given_orb(mh,lral)
c          write(6,'(6i6)')7,mh,lrai,lral,lraj,lrak
              if(mh.ne.0) call act_cloop_g(7,mh,lrai,lral,lraj,lrak)
c-----------------------------------------------------------
            enddo
          enddo
        enddo
      enddo
      return
      end

      subroutine ploop_in_act_g()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
c===========================================================
      do lrai=norb_dz+1,norb_inn
!line=25 -c"-d^r^r
        logic_br(1)=.true.
        call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
        call tail_drr_at_given_orb(mh,lrai)
        if(mh.ne.0)  call lp_act_tail_g(25,mh,0,lrai)
c-----------------------------------------------------------
!line=26 -c"-d^r^l
        logic_br(1)=.true.
        call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
        call tail_drl_at_given_orb(mh,lrai)
        if(mh.ne.0)  call lp_act_tail_g(26,mh,0,lrai)
c===========================================================
!line=23 -c'-a^l
        call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
        call tail_al_at_given_orb(mh,lrai)
        if(mh.ne.0)  call lp_act_tail_g(23,mh,0,0)
c-----------------------------------------------------------
!line=24 -c'-a^r
        call link_c1_to_given_orb_coe(mh,norb_dz+1,lrai-1)
        call tail_ar_at_given_orb_coe(mh,lrai)
        if(mh.ne.0)  call lp_act_tail_g(24,mh,0,0)
c===========================================================
        do lrak=lrai+1,norb_inn
c-----------------------------------------------------------
!line=30 -c'-b&r-d^r^r
          call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b4_at_given_orb(mh,lrai)
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrai+1,lrak-1)
          call tail_drr_at_given_orb(mh,lrak)
          if(mh.ne.0)  call lp_act_tail_g(30,mh,lrai,0)
c-----------------------------------------------------------
!line=31 -c'-b&l-d^r^l
          call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b3_at_given_orb(mh,lrai)
          logic_br(1:mh)=.true.
          call link_c2_to_given_orb(mh,lrai+1,lrak-1)
          call tail_drl_at_given_orb(mh,lrak)
          if(mh.ne.0)  call lp_act_tail_g(31,mh,lrai,0)
        enddo
c===========================================================
        do lrak=norb_dz+1,lrai-1
c-----------------------------------------------------------
!line=35 -c'-d^r&l-a^l
          call link_c1_to_given_orb(mh,norb_dz+1,lrak-1)
          call link_d10_at_given_orb(mh,lrak)
          call link_c1_to_given_orb(mh,lrak+1,lrai-1)
          call tail_al_at_given_orb(mh,lrai)
          if(mh.ne.0)  call lp_act_tail_g(35,mh,lrak,lrak)
         enddo
c===========================================================
        do lraj=lrai+1,norb_inn
c-----------------------------------------------------------
!line=27 -c"-b^r-a^r
          call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b2_at_given_orb(mh,lrai)
          call link_c1_to_given_orb(mh,lrai+1,lraj-1)
          call tail_ar_at_given_orb(mh,lraj)
          if(mh.ne.0)  call lp_act_tail_g(27,mh,0,lrai)
c-----------------------------------------------------------
!line=28 -c"-b^l-a^r
          call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b1_at_given_orb(mh,lrai)
          call link_c1_to_given_orb(mh,lrai+1,lraj-1)
          call tail_ar_at_given_orb(mh,lraj)
          if(mh.ne.0)  call lp_act_tail_g(28,mh,0,lrai)
c-----------------------------------------------------------
!line=29 -c"-b^r-a^l
          call link_c2_to_given_orb(mh,norb_dz+1,lrai-1)
          call link_b2_at_given_orb(mh,lrai)
          call link_c1_to_given_orb(mh,lrai+1,lraj-1)
          call tail_al_at_given_orb(mh,lraj)
          if(mh.ne.0)  call lp_act_tail_g(29,mh,0,lrai)
c-----------------------------------------------------------
          do lral=lraj+1,norb_inn
c-----------------------------------------------------------
!line=32 -c'-b&r-c"-b^r-a^r
            call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
            call link_b4_at_given_orb(mh,lrai)
            logic_br(1:mh)=.true.
            call link_c2_to_given_orb(mh,lrai+1,lraj-1)
            call link_b2_at_given_orb(mh,lraj)
            call link_c1_to_given_orb(mh,lraj+1,lral-1)
            call tail_ar_at_given_orb(mh,lral)
           if(mh.ne.0)  call lp_act_tail_g(32,mh,lrai,lraj)
c-----------------------------------------------------------
!line=33 -c'-b&l-c"-b^r-a^l
            call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
            call link_b3_at_given_orb(mh,lrai)
            logic_br(1:mh)=.true.
            call link_c2_to_given_orb(mh,lrai+1,lraj-1)
            call link_b2_at_given_orb(mh,lraj)
            call link_c1_to_given_orb(mh,lraj+1,lral-1)
            call tail_al_at_given_orb(mh,lral)
           if(mh.ne.0)  call lp_act_tail_g(33,mh,lrai,lraj)
c-----------------------------------------------------------
!line=34 -c'-b&l-c"-b^l-a^r
            call link_c1_to_given_orb(mh,norb_dz+1,lrai-1)
            call link_b3_at_given_orb(mh,lrai)
            logic_br(1:mh)=.true.
            call link_c2_to_given_orb(mh,lrai+1,lraj-1)
            call link_b1_at_given_orb(mh,lraj)
            call link_c1_to_given_orb(mh,lraj+1,lral-1)
            call tail_ar_at_given_orb(mh,lral)
            if(mh.ne.0)  call lp_act_tail_g(34,mh,lrai,lraj)
          enddo
        enddo
c-----------------------------------------------------------
      enddo
      return
      end

      subroutine lp_act_tail_g(lin,mh,lrg0,lrs0)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      line=lin
      lrg=lrg0
      lrs=lrs0
      jph=0
      do mhlp=1,mh
        jpel=lpnew_ltail(mhlp)
        jper=lpnew_rtail(mhlp)
        jwl =lpnew_lwei(mhlp)
        jwr =lpnew_rwei(mhlp)
          w0  =vplpnew_w0(mhlp)
          w1  =vplpnew_w1(mhlp)
        if(line.eq.24) then
          do iorb=norb_dz+1,norb_inn
            lpcoe(iorb)=lpnew_coe(iorb,mhlp)
          enddo
        endif
        call dbl_head_act_tail_g(lpcoe)
      enddo
      return
      end

      subroutine act_cloop_g(lin,mh,lr0,lr,lrg0,lrs0)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      parameter (two=2.0d+00,half=0.5d+00)
      line=lin
      lrg=lrg0
      lrs=lrs0
      do mhlp=1,mh
        jph =lpnew_head(mhlp)
        jpel=lpnew_ltail(mhlp)
        jper=lpnew_rtail(mhlp)
        jwl =lpnew_lwei(mhlp)
        jwr =lpnew_rwei(mhlp)
        vlop0 =vplpnew_w0(mhlp)
        vlop1 =vplpnew_w1(mhlp)

        goto (31,32,21,13,22,11,12,51,52,41,42,43),line
c-----------------------------------------------------------
31          do l=norb_dz+1,lr
              lpcoe(l)=lpnew_coe(l,mhlp)
            enddo
c            wl=voint(lr0,lr)
            wl=vlop0
c            write(nf2,*) 'ar-ar'
          call prodab_1(2,jph,jpel,jwl,jwr,0,wl,jper,lr0,lr)
            do l=lr0,lr
c              list=list3(lr0,lr,l)
              kcoe=lpcoe(l)
c            write(nf2,*) 'arw-c-arw'
              call neoc(kcoe,nocc,tcoe)
c              wl=wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
              wl=vlop0*nocc
          call trans_ijkl_intpos(lr,lr0,l,l,nxo)
c          write(nf2,'(4i4)') lr,lr0,l,l
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
             wl=vlop0*nocc*tcoe
          call trans_ijkl_intpos(lr,l,lr0,l,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)

            enddo
c            wl=wl*vlop0
            goto 500
c-----------------------------------------------------------
32         wl= vlop0
c         write(nf2,*) 'ar-drl-al'
c        list=list3(lr0,lr,lrg)
c            wl=vlop0*vint_ci(list)
          call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500
c-----------------------------------------------------------
11        wl=vlop0-vlop1
c           list=list4(lr0,lrg,lrs,lr)
c             wl=vlop0*(vint_ci(list)-2*vint_ci(list+1))
c     :             -vlop1*vint_ci(list)
c        vint_ci(numb)=vfutei(la,lc,lb,ld)
c        vint_ci(numb+1)=vfutei(la,lb,lc,ld)
c        vint_ci(numb+2)=vfutei(la,ld,lc,lb)
c          write(nf2,*)  'ar-bl-br-al'
          call trans_ijkl_intpos(lr,lrg,lrs,lr0,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
               wl=-vlop0*2.0d0
          call trans_ijkl_intpos(lr,lrs,lrg,lr0,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500

c-----------------------------------------------------------
12        wl=vlop0-vlop1
c      list=list4(lr0,lrg,lrs,lr)
c             wl=vlop0*(vint_ci(list+2)-2.0d0*vint_ci(list+1))
c     :           -vlop1*vint_ci(list+2)
c          write(nf2,*) 'ar-bl-bl-ar'
          call trans_ijkl_intpos(lr,lr0,lrg,lrs,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
               wl=-vlop0*2.0d0
          call trans_ijkl_intpos(lr,lrs,lrg,lr0,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500

c-----------------------------------------------------------
13       wl=vlop0+vlop1
c         write(nf2,*) 'ar-br-br-ar'
c           list=list4(lr0,lrg,lrs,lr)
c             wl=vlop0*(vint_ci(list+2)+vint_ci(list))
c     :             -vlop1*(vint_ci(list+2)-vint_ci(list))

          call trans_ijkl_intpos(lr,lrg,lrs,lr0,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
              wl=vlop0-vlop1
          call trans_ijkl_intpos(lr,lr0,lrg,lrs,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500
c-----------------------------------------------------------
21       wl=vlop0+vlop1
c         write(nf2,*)  'ar-br-drr'
c         list=list3(lr0,lr,lrg)
c             wl=(vlop0+vlop1)*vint_ci(list)

          call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500
c-----------------------------------------------------------
22       wl=vlop0-vlop1
c         write(nf2,*) 'ar-bl-drl'
c          list=list3(lr0,lr,lrg)
c             wl=vlop0*(vint_ci(list)-2.0d0*vint_ci(list+1))
c     :           -vlop1*vint_ci(list)

          call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
               wl=-vlop0*2.0d0
          call trans_ijkl_intpos(lr,lr0,lrg,lrg,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500
c-----------------------------------------------------------
c  drr-drr
c  wl=vlop0 but not 0.5d0*vlop0 is based on that the non-diagonal
c  just uses the non-triangle <ci|h|cj> which designates that i > j.
c
51           wl=vlop0

c          wl=vlop0*voint(lr,lr0)*0.5d0
          call trans_ijkl_intpos(lr,lr0,lr,lr0,nxo)
c          write(nf2,*) 'drr-drr'
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500
c-----------------------------------------------------------
52        wl=(vlop0-vlop1)*2.0d0

c drl-drl
c          wl=(vlop0-vlop1)*voint(lr,lr0)
          call trans_ijkl_intpos(lr,lr0,lr,lr0,nxo)
c          write(nf2,'(a7,2i4,f18.10)') 'drl-drl',lr,lr0,wl
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500
c-----------------------------------------------------------
41        wl=vlop0+vlop1
c          write(nf2,*)  'drr-br-ar'
c           list=list3(lr0,lr,lrg)
c              wl=(vlop0+vlop1)*vint_ci(list)

          call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500
c-----------------------------------------------------------
42        wl=vlop0-vlop1
c          write(nf2,*) 'drl-br-al'
c          list=list3(lr0,lr,lrg)
c              wl=(vlop0-vlop1)*vint_ci(list)

          call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
          goto 500
c-----------------------------------------------------------
43       wl=vlop0-vlop1
c         write(nf2,*) 'drl-bl-ar'
c           list=list3(lr0,lr,lrg)
c              wl=vlop0*(vint_ci(list)-2.0d0*vint_ci(list+1))
c     :           -vlop1*vint_ci(list)

          call trans_ijkl_intpos(lr,lrg,lr0,lrg,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
               wl=-vlop0*2.0d0
          call trans_ijkl_intpos(lr,lr0,lrg,lrg,nxo)
          call prodab_2(2,jph,jpel,jwl,jwr,0,wl,jper,nxo)
500     continue
c-----------------------------------------------------------
      enddo
      return
      end

      subroutine dbl_td_act_comp_g(lin,lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!td(13-1) (22)a&(23)
!td(13-1) a&(23)c'(22)
!td(13-2) a&(23)b&r(23)b^r(32)
!td(13-3) a&(23)b&l(32)b^l(23)
!td(13-4) d&r&l(22)b^l(23)
!td(13-5) (22)d&&l(33)b^l(23)
!td(13-5) d&rl(33)c"(22)b^l(23)
!td(13-5) d&rl(33)b^l(23)c'(22)

      jmlr=mul_tab(jml,jmr)
        do lri=norb_frz+1,norb_dz
          lmi=lsm_inn(lri)
          if(lmi.ne.jmlr) cycle
          w0td1=w0_td(1)
          ni=mod(norb_dz-lri,2)
          if(ni.eq.1) then
            w0td1=-w0td1
          endif

!td(13-1) a&(23)c'(22)
          vlop0=-w0*w0td1
          vlop1=-w1*w0td1
          call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
            if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)   !
            iwdr=jud(lrk)
c            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
          enddo
!td(13-1) (22)a&(23)
          vlop0=w0*w0td1
          vlop1=w1*w0td1
          call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)   !
            iwdr=jud(lrk)
c            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
          enddo
!-------------------------------------------------------------------
        enddo
      return
        end

      subroutine dbl_ttdd_act_comp_g(lin,lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!t1d1(15-1)  ar(13)-
!t1d1(15-1)  ar(13)-c'(11)-

      jmlr=mul_tab(jml,jmr)
        do lri=norb_frz+1,norb_dz
          lmi=lsm_inn(lri)
          if(lmi.ne.jmlr) cycle
          w0td1=w0_t1d1(1)
          ni=mod(norb_dz-lri,2)
          if(ni.eq.1) then
            w0td1=-w0td1
          endif
!t1d1(15-1)  ar(13)-c'(11)-
          vlop0=-w0*w0td1
          vlop1=-w1*w0td1
          call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
            if(lmk.ne.jmr) cycle
            iwdl=just(lri,lrk)   !
            iwdr=jud(lrk)
c            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
          enddo
!t1d1(15-1)  (11)ar(13)-
          vlop0=w0*w0td1
          vlop1=w1*w0td1
          call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)   !
            iwdr=jud(lrk)
c            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
          enddo
!-------------------------------------------------------------------
        enddo
      return
        end

      subroutine comp_loop_g(line,lr0,lrg,lrs,lr,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
        wl0=0.0d0
        list0=0
        wl1=0.0d0
        list1=0
      goto (31,32,21,13,22,11,12,51,52,41,42,43),line
c-----------------------------------------------------------
31    goto 500
c         do l=norb_dz+1,lr-1
c                lpcoe(l)=lp_coe(l,mpl)
c             enddo
c            lpcoe(lr)=kcoe
c             wl=voint(lr0,lr)
c             do l=lr0,lr
c               list=list3(lr0,lr,l)
c               kcoe=lpcoe(l)
c               call neoc(kcoe,nocc,tcoe)
c               wl=wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
c             enddo
c             wl=wl*vlop0
32                wl0=vlop0
c     list=list3(lr0,lr,lrs)   ! lrg
c             wl=vlop0*vint_ci(list)
c         write(nf2,*) 'ar-cw-ar'
         call trans_ijkl_intpos(lr,lrs,lr0,lrs,nxo)
             list0=nxo
             goto 500
c-----------------------------------------------------------
11       wl0=vlop0-vlop1
c          list=list4(lr0,lrg,lrs,lr)
c             wl=vlop0*(vint_ci(list)-2*vint_ci(list+1))
c     :             -vlop1*vint_ci(list)

         call trans_ijkl_intpos(lr,lrg,lrs,lr0,nxo)
             list0=nxo
         wl1=-2*vlop0
         call trans_ijkl_intpos(lr,lrs,lrg,lr0,nxo)
             list1=nxo
             goto 500
c-----------------------------------------------------------
12       wl0=vlop0-vlop1
c           list=list4(lr0,lrg,lrs,lr)
c             wl=vlop0*(vint_ci(list+2)-2.0d0*vint_ci(list+1))
c     :           -vlop1*vint_ci(list+2)

         call trans_ijkl_intpos(lr,lr0,lrg,lrs,nxo)
             list0=nxo
              wl1=-2*vlop0
         call trans_ijkl_intpos(lr,lrs,lrg,lr0,nxo)
             list1=nxo
             goto 500
c-----------------------------------------------------------
13       wl0=vlop0-vlop1
c     list=list4(lr0,lrg,lrs,lr)
c             wl=vlop0*(vint_ci(list+2)+vint_ci(list))
c     :             -vlop1*(vint_ci(list+2)-vint_ci(list))

         call trans_ijkl_intpos(lr,lr0,lrg,lrs,nxo)
             list0=nxo

              wl1=vlop0+vlop1
         call trans_ijkl_intpos(lr,lrg,lrs,lr0,nxo)
             list1=nxo

             goto 500
c-----------------------------------------------------------
21       wl0=vlop0+vlop1
c          list=list3(lr0,lrg,lr)
c             wl=(vlop0+vlop1)*vint_ci(list)

         call trans_ijkl_intpos(lrg,lr,lr0,lr,nxo)
             list0=nxo

             goto 500
c-----------------------------------------------------------
22       wl0=vlop0-vlop1
c    list=list3(lr0,lrg,lr)
c             wl=vlop0*(vint_ci(list)-2.0d0*vint_ci(list+1))
c     :           -vlop1*vint_ci(list)

         call trans_ijkl_intpos(lrg,lr,lr0,lr,nxo)
             list0=nxo

              wl1=-2.0d0*vlop0
         call trans_ijkl_intpos(lrg,lr0,lr,lr,nxo)
             list1=nxo

             goto 500
c-----------------------------------------------------------
c  drr-drr
c  w0lp=2.0d0*w0lp but not 1.0d0*w0lp is based on that the non-diagonal
c  just uses the non-triangle <ci|h|cj> which designates that i > j.
c
51        wl0=vlop0
c          wl=vlop0*voint(lr,lr0)*0.5d0

         call trans_ijkl_intpos(lr,lr0,lr,lr0,nxo)
             list0=nxo
              goto 500
c-----------------------------------------------------------
52       wl0=(vlop0-vlop1)*2.0d0
c         wl=(vlop0-vlop1)*voint(lr,lr0)

         call trans_ijkl_intpos(lr,lr0,lr,lr0,nxo)
             list0=nxo

              goto 500
c-----------------------------------------------------------
41       wl0=vlop0+vlop1
c        list=list3(lrs,lr,lr0)      ! lrg
c              wl=(vlop0+vlop1)*vint_ci(list)

         call trans_ijkl_intpos(lr,lr0,lrs,lr0,nxo)
             list0=nxo

              goto 500
c-----------------------------------------------------------
42       wl0=vlop0-vlop1
c       list=list3(lrs,lr,lr0)      ! lrg
c              wl=(vlop0-vlop1)*vint_ci(list)

         call trans_ijkl_intpos(lr,lr0,lrs,lr0,nxo)
             list0=nxo

              goto 500
c-----------------------------------------------------------
43       wl0=vlop0-vlop1
c      list=list3(lrs,lr,lr0)      ! lrg
c              wl=vlop0*(vint_ci(list)-2.0d0*vint_ci(list+1))
c     :           -vlop1*vint_ci(list)

         call trans_ijkl_intpos(lr,lr0,lrs,lr0,nxo)
             list0=nxo

              wl1=-2*vlop0
         call trans_ijkl_intpos(lr,lrs,lr0,lr0,nxo)
             list1=nxo

c-----------------------------------------------------------
500   return
      end


      subroutine dbl_sd_act_comp_g(lin,lra)
!sd(6-1) a&r(02)-
!sd(6-2) (22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1 =w0_sd(1)
        w0sd2 =w0_sd(2)
          w0sd3 =w0_sd(3)
        w0sd4 =w0_sd(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd2 =-w0sd2
          w0sd3 =-w0sd3
          w0sd4 =-w0sd4
        endif
        if(jml.eq.1.and.lmi.eq.jmr) then
!sd(6-1) a&r(02)-
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          vlop0=w0*w0sd1
          vlop1=w1*w0sd1
          call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
        endif
!sd(6-2) (22)a&(13)-
        vlop0=w0*w0sd2
        vlop1=w1*w0sd2
        call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)
          iwdr=jud(lrk)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
        enddo
!sd(6-4) a&r(23)-c'(12)-
        vlop0=-w0*w0sd4
        vlop1=-w1*w0sd4
        call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
        enddo
!sd(6-3) a&r(13)c'(22)-
        if(jb_sys.gt.0) then
          vlop0=-w0*w0sd3
          vlop1=-w1*w0sd3
          call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
            if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)
            iwdr=jud(lrk)
c            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
          enddo
        endif
      enddo
      return
      end

      subroutine dbl_sdd_act_comp_g(lin,lra)
!sd1(8-1)    ar(01)-
!sd1(8-2)    (11)ar(23)-
!sd1(8-3)    ar(13)-c'(21)-
!sd1(8-4)    ar(23)-c'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1 =w0_sd1(1)
        w0sd2 =w0_sd1(2)
          w0sd3 =w0_sd1(3)
        w0sd4 =w0_sd1(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd2 =-w0sd2
            w0sd3 =-w0sd3
          w0sd4 =-w0sd4
        endif
        if(jml.eq.1.and.lmi.eq.jmr) then
!sd1(8-1)    ar(01)-
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          vlop0=w0*w0sd1
          vlop1=w1*w0sd1
          call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
        endif
!sd1(8-2)    (11)ar(23)-
        vlop0=w0*w0sd2
        vlop1=w1*w0sd2
        call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
        enddo
!sd1(8-4)    ar(23)-c'(11)-
        vlop0=-w0*w0sd4
        vlop1=-w1*w0sd4
        call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
        enddo
!sd1(8-3)    ar(13)-c'(21)-
        if(jb_sys.gt.0) then
          vlop0=-w0*w0sd3
          vlop1=-w1*w0sd3
          call comp_loop_g(lin,lri,lrg,lrs,lra,vlop0,vlop1,wl0,list0,
     :                     wl1,list1)
          do lrk=lri+1,norb_dz
            lmk=lsm_inn(lrk)
            if(lmk.ne.jmr) cycle
            iwdl=just(lrk,lri)
            iwdr=jud(lrk)
c            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
c           call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper,list2,list3)
              call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl0,jper,list0)
      if(list1.ne.0)
     :        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper,list1)
          enddo
        endif
      enddo
      return
      end


      subroutine ext_space_loop_g()
#include "drt_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *      m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ism=0
      do inx=18,25
          ism=ism+1
            if(nu_ae(inx).eq.0) cycle
            isegsta=iseg_sta(inx)
            isegupwei=iseg_upwei(inx)
            isegdownwei=iseg_downwei(inx)
          call g_ss_ext_sequence_g(ism,4)
      enddo
      ism=0
      do inx=10,17
          ism=ism+1
            if(nu_ae(inx).eq.0) cycle
            isegsta=iseg_sta(inx)
            isegupwei=iseg_upwei(inx)
            isegdownwei=iseg_downwei(inx)
             call g_tt_ext_sequence_g(ism)
      enddo
      ism=0
      do inx=2,9
          ism=ism+1
            if(nu_ae(inx).eq.0) cycle
            isegsta=iseg_sta(inx)
            isegupwei=iseg_upwei(inx)
            isegdownwei=iseg_downwei(inx)
             call g_dd_ext_sequence_g(ism)
      enddo
      return
      end

      subroutine dbl_head_act_tail_g(lpcoe)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      lra=kk(jpel)-1
      jml=mod((jpadl-1),8)
      jmr=mod((jpad-1),8)
      itypadl=(jpadl-1)/8+2
      itypadr=(jpad-1)/8+2
      if(jml.eq.0) then
        jml=8
        itypadl=itypadl-1
      endif
      if(jmr.eq.0) then
        jmr=8
        itypadr=itypadr-1
      endif
      if(jpadl.eq.1) itypadl=1
      if(jpad.eq.1)  itypadr=1
      if(jpadl.eq.1) jml=ns_sm
      if(jpad.eq.1)  jmr=ns_sm
      jml=mul_tab(jml,ns_sm)
      jmr=mul_tab(jmr,ns_sm)
      jmlr=mul_tab(jml,jmr)
      lpok=map_jplr(itypadl,itypadr)
      if(lpok.eq.0) return

!          23   24 25 26 27 28 29 30 31 32 33 34 35
      goto(100,200,300,400,500,600,700,800,900,1000,1100,1200,1300),
     :    line-22
!line=23:-a^l<-->ds(7),dds(9),dt(14),ddtt(16)
100   goto(10,10,10,10,10,10,107,10,109,10,10,10,
     :     10,114,10,116,10,10,10,10,10,10,10,10,10,10),lpok
!ds(7-2) ar(23)-bl(31)-br(32)-

!ds(7-1) ar(23)-drl(30)-

107   do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(jmr.ne.1) goto 106
        iwdr=just(lri,lri)
        do lrd=norb_frz+1,lri-1
          lmd=lsm_inn(lrd)
          if(lmd.ne.jml) cycle
          iwdl=jud(lrd)
          w0ds1 =w0_ds(1)
          ni=mod(norb_dz-lri+lri-lrd,2)
          if(ni.eq.0) w0ds1 =-w0ds1
          vlop0=w0*w0ds1
c          list=list3(lrd,lra,lri)
         call trans_ijkl_intpos(lra,lri,lrd,lri,nxo)
c        wl=vlop0*vint_ci(list)
          wl=vlop0
c         call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
        enddo
106     do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmr) cycle
          do lrd=norb_frz+1,lri-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jml) cycle
c            list=list4(lrd,lri,lrj,lra)
            iwdl=jud(lrd)
            w0ds2 =w0_ds(2)
            w1ds2 =w1_ds(2)
            w0ds3 =w0_ds(3)
            w1ds3 =w1_ds(3)
            ni=mod(norb_dz-lrj+lri-lrd,2)
            if(ni.eq.0) then
             w0ds2 =-w0ds2
              w1ds2 =-w1ds2
             w0ds3 =-w0ds3
              w1ds3 =-w1ds3
            endif
!ds(7-3) ar(23)-bl(32)-br(31)-
            iwdr=just(lri,lrj)
           vlop0=w0*w0ds3
            vlop1=w1*w1ds3
c            wl=(vlop0-vlop1)*vint_ci(list)-
c    :             2*vlop0*vint_ci(list+1)            !1.1
            wl=vlop0-vlop1
         call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)

           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-2*vlop0
         call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)

           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            if(jb_sys.gt.0) then
!ds(7-2) ar(23)-bl(31)-br(32)-         the symmetry problem
              iwdr=just(lrj,lri)
             vlop0=w0*w0ds2
              vlop1=w1*w1ds2
c              wl=(vlop0-vlop1)*vint_ci(list)-
c     :               2*vlop0*vint_ci(list+1)            !1.1
            wl=vlop0-vlop1
         call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)

           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-2*vlop0
         call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)

           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            endif
          enddo
        enddo
      enddo
      goto 10
109   do lri=norb_frz+1,norb_dz
!d1s(9-1) ar(13)-drl(30)-
        lmi=lsm_inn(lri)
        do lrd=norb_frz+1,lri-1
          lmd=lsm_inn(lrd)
          if(lmd.eq.jml.and.jmr.eq.1) then
            iwdr=just(lri,lri)
            iwdl=jud(lrd)
            w0ds1=w0_d1s(1)
            ni=mod(norb_dz-lri+lri-lrd,2)
            if(ni.eq.0) w0ds1 =-w0ds1
            vlop0=w0*w0ds1
c            list=list3(lrd,lra,lri)
         call trans_ijkl_intpos(lra,lri,lrd,lri,nxo)

c          wl=vlop0*vint_ci(list)          !   3.2
            wl=vlop0
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          endif
!d1s(9-4) drl(12)-br(31)-
          if(jml.eq.lmd.and.jmr.eq.mul_tab(lmd,lmi)) then
            iwdr=just(lrd,lri)
            iwdl=jud(lrd)
            w1ds=w1_d1s(4)
           if(mod(norb_dz-lri,2).eq.1) w1ds=-w1ds
           vlop1=w1*w1ds
c          list=list3(lri,lra,lrd)
         call trans_ijkl_intpos(lra,lrd,lri,lrd,nxo)

c          wl=-vlop1*vint_ci(list)
            wl=-vlop1
            call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          endif
        enddo
      enddo
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
!d1s(9-3) ar(13)-bl(32)-br(31)-
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmr) cycle
          do lrd=norb_frz+1,lri-1
            iwdr=just(lri,lrj)
            lmd=lsm_inn(lrd)
            if(lmd.ne.jml) cycle
            iwdl=jud(lrd)
            w0ds3 =w0_d1s(3)
            w1ds3 =w1_d1s(3)
            ni=mod(norb_dz-lrj+lri-lrd,2)
            if(ni.eq.0) w0ds3 =-w0ds3
            if(ni.eq.0) w1ds3 =-w1ds3
           vlop0=w0*w0ds3
            vlop1=w1*w1ds3
c          list=list4(lrd,lri,lrj,lra)
c            wl=(vlop0-vlop1)*vint_ci(list)-
c    :               2*vlop0*vint_ci(list+1)            !1.1
            wl=vlop0-vlop1
         call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-2*vlop0
         call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)
           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            if(jb_sys.gt.0) then
!d1s(9-2)   ar(13)-bl(31)-br(32)-   the symmetry problem
              iwdr=just(lrj,lri)
              w0ds3 =w0_d1s(2)
              w1ds3 =w1_d1s(2)
              ni=mod(norb_dz-lrj+lri-lrd,2)
              if(ni.eq.0) w0ds3 =-w0ds3
              if(ni.eq.0) w1ds3 =-w1ds3
             vlop0=w0*w0ds3
              vlop1=w1*w1ds3
c           list=list4(lrd,lri,lrj,lra)
c              wl=(vlop0-vlop1)*vint_ci(list)-
c    :                 2*vlop0*vint_ci(list+1)            !1.1
            wl=vlop0-vlop1
         call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-2*vlop0
         call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)
           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

            endif
          enddo
        enddo
      enddo
      return

!dt(14) ar(23)-bl(32)-br(32)-
114   do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
         lmij=mul_tab(lmi,lmj)
         if(lmij.ne.jmr) cycle
          iwdr=just(lri,lrj)        !
         do lrd=norb_frz+1,lri-1
            lmd=lsm_inn(lrd)
           if(lmd.ne.jml) cycle
            iwdl=jud(lrd)
           vlop0=w0*w0_dt
            vlop1=w1*w1_dt
            ni=mod(lri-lrd+norb_dz-lrj,2)
           if(ni.eq.0) then
             vlop0=-vlop0
              vlop1=-vlop1
            endif
c          list=list4(lrd,lri,lrj,lra)
c            wl=(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1) !1.1
            wl=vlop0-vlop1
         call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-2*vlop0
         call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)
           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
        enddo
      enddo
      return
!d1t1(16)  ar(13)-bl(31)-br(31)-
116   do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
         lmij=mul_tab(lmi,lmj)
         if(lmij.ne.jmr) cycle
          iwdr=just(lri,lrj)        !
         do lrd=norb_frz+1,lri-1
            lmd=lsm_inn(lrd)
            lmd=mul_tab(lmd,1)
           if(lmd.ne.jml) cycle
            iwdl=jud(lrd)
           vlop0=w0*w0_d1t1
            vlop1=w1*w1_d1t1
            ni=mod(lri-lrd+norb_dz-lrj,2)
           if(ni.eq.0) then
             vlop0=-vlop0
              vlop1=-vlop1
            endif
c          list=list4(lrd,lri,lrj,lra)
c            wl=(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1) !1.1
            wl=vlop0-vlop1
         call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-2*vlop0
         call trans_ijkl_intpos(lra,lrj,lri,lrd,nxo)
           call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
        enddo
      enddo
      return
!line=24:-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
200   goto(10,10,10,10,10,206,10,208,10,10,10,10,
     :     213,10,215,10,10,10,10,10,10,10,223,224,10,10),lpok


!sd(6-1) a&r(02)-
!sd(6-2) c(22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
!sd(6-5) a&r(23)b&r(13)b^r(32)
!sd(6-6) a&r(13)b&r(23)b^r(32)
!sd(6-7) a&r(13)b&l(32)b^l(23)
!sd(6-8) a&r(23)b&l(32)b^l(13)
!sd(6-9) d&r&r(03)b^r(32)
!sd(6-10) d&r&l(12)b^l(23)
!sd(6-11) d&r&l(22)b^l(13)
!sd(6-12) d&r&l(33)b^l(02)
!sd(6-13) (22)d&r&l(33)b^l(13)
!sd(6-14) d&r&l(33)c"(22)b^l(13)
!sd(6-15) d&r&l(33)b^l(13)c'(22)
!sd(6-16) d&r&l(33)b^l(23)c'(12)
!sd(6-1) a&r(02)-

206   call sd_head_dbl_tail_act_g(lra,lpcoe)
      return

208   call sdd_head_dbl_tail_act_g(lra,lpcoe)
      return
!td(13-1) (22)a&(23)
!td(13-1) a&(23)c'(22)
!td(13-5) (22)d&&l(33)b^l(23)
213   do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        isma=lmi
        if(lmi.ne.jmlr) cycle
        w0td1=w0_td(1)
        w0td4=w0_td(4)
        w0td5=w0_td(5)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1)w0td1=-w0td1
        if(ni.eq.1)w0td4=-w0td4
        if(ni.eq.1)w0td5=-w0td5

!td(13-1) a&(23)c'(22)
        do lrd=lri+1,norb_dz
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
         iwdl=just(lri,lrd)      !
          iwdr=jud(lrd)
          vlop0=-w0*w0td1
c          list=list3(lri,lra,lri)
c          wl=voint(lri,lra)+vint_ci(list)             !310,act_coe,610,
           wl=vlop0
          call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lri,lra)
         call trans_ijkl_intpos(lra,lri,lri,lri,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

c          list=list3(lri,lra,lrd)
c          wl=wl+vint_ci(list+1)                          !310 c'(22) co
         call trans_ijkl_intpos(lra,lri,lrd,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

         do lr=lri+1,norb_dz
            if(lr.eq.lrd) cycle
c          list =list3(lri,lra,lr)
c            wl=wl+2*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,coe
            wl=2.0d0*vlop0
         call trans_ijkl_intpos(lra,lri,lr,lr,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-vlop0
         call trans_ijkl_intpos(lra,lr,lri,lr,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
          do lrk=norb_dz+1,lra
c            list=list3(lri,lra,lrk)
            kcoe=lpcoe(lrk)
            call neoc(kcoe,nocc,tcoe)
c            wl=wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            wl=vlop0*nocc
         call trans_ijkl_intpos(lra,lri,lrk,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=vlop0*tcoe*nocc
         call trans_ijkl_intpos(lra,lrk,lri,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
c          wl=wl*vlop0
!td(13-5) d&rl(33)b^l(23)c'(22)
          vlop0=-w0*w0td5
          do lrk=1,lri-1
c            list=list3(lri,lra,lrk)
c            wl=wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
            wl=-vlop0*2
         call trans_ijkl_intpos(lra,lri,lrk,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=vlop0
         call trans_ijkl_intpos(lra,lrk,lri,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
!-------------------------------------------------------------------
        do lrd=norb_frz+1,lri-1
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
         iwdl=just(lrd,lri)      !
          iwdr=jud(lrd)
!td(13-1) (22)a&(23)
          vlop0=w0*w0td1
c          list=list3(lri,lra,lri)
c          wl=vlop0*(voint(lri,lra)+vint_ci(list))     !310,act_coe,610,
           wl=vlop0
          call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lri,lra)
         call trans_ijkl_intpos(lra,lri,lri,lri,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          do lr=lri+1,norb_dz
c            list =list3(lri,lra,lr)
c            wl=wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2
            wl=vlop0*2
         call trans_ijkl_intpos(lra,lri,lr,lr,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-vlop0
         call trans_ijkl_intpos(lra,lr,lri,lr,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
          do lrk=norb_dz+1,lra
c            list=list3(lri,lra,lrk)
            kcoe=lpcoe(lrk)
            call neoc(kcoe,nocc,tcoe)
c           wl=wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            wl=vlop0*nocc
         call trans_ijkl_intpos(lra,lri,lrk,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=vlop0*tcoe*nocc
         call trans_ijkl_intpos(lra,lrk,lri,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
c            wl=wl*vlop0
!td(13-4) d&r&l(22)b^l(23)
          vlop0=w0*w0td4
          vlop1=w1*w0td4
c          list=list3(lri,lra,lrd)
c          wl=wl+(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
            wl=-2*vlop0
         call trans_ijkl_intpos(lra,lri,lrd,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=vlop0-vlop1
         call trans_ijkl_intpos(lra,lrd,lri,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)


!td(13-5) d&rl(33)c"(22)b^l(23)
          vlop0=w0*w0td5
          do lrk=1,lri-1
            if(lrk.eq.lrd) cycle
c          list=list3(lri,lra,lrk)
c            wl=wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))      !4.3
            wl=-2*vlop0
         call trans_ijkl_intpos(lra,lri,lrk,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=vlop0
         call trans_ijkl_intpos(lra,lrk,lri,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo

      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(lmij.ne.jml) cycle
        iwdl=just(lri,lrj)     !

!td(13-2) a&(23)b&r(23)b^r(32)
        do lrd=lrj+1,norb_dz
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
          w0td2=w0_td(2)
          w1td2=w1_td(2)
          ni=mod(lrj-lri+norb_dz-lrd,2)
        if(ni.eq.0) w0td2=-w0td2
        if(ni.eq.0) w1td2=-w1td2

          iwdr=jud(lrd)
          vlop0=w0*w0td2
          vlop1=w1*w1td2
c          list=list4(lri,lrj,lrd,lra)
c          wl=vlop0*(vint_ci(list+2)+vint_ci(list))  !1.3
c     :       -vlop1*(vint_ci(list+2)-vint_ci(list))
         wl=vlop0-vlop1
         call trans_ijkl_intpos(lra,lri,lrj,lrd,nxo)
        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
         wl=vlop0+vlop1
         call trans_ijkl_intpos(lra,lrj,lrd,lri,nxo)
        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

        enddo
!td(13-3) a&(23)b&l(32)b^l(23)
        do lrd=lri+1,lrj-1
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
          iwdr=jud(lrd)
          w0td3=w0_td(3)
          w1td3=w1_td(3)
          ni=mod(lrd-lri+norb_dz-lrj,2)
          if(ni.eq.0)   w0td3=-w0td3
          if(ni.eq.0)   w1td3=-w1td3
          vlop0=w0*w0td3                !d6-8
          vlop1=w1*w1td3
c          list=list4(lri,lrd,lrj,lra)
c       wl=vlop0*(vint_ci(list+2)-2*vint_ci(list+1))      !1.2
c     :       -vlop1*vint_ci(list+2)

          wl=vlop0-vlop1
         call trans_ijkl_intpos(lra,lri,lrd,lrj,nxo)
        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl=-vlop0*2
         call trans_ijkl_intpos(lra,lrj,lrd,lri,nxo)
        call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

        enddo
      enddo
      enddo
      goto 10
215   call ttdd_head_dbl_tail_act_g(lra,lpcoe)
      return

!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
223   iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
        w0dv1=w0_dv(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
        vlop1=w1*w0dv1
c**********************************************************
              lr0=lrd
              lr=kk(jpel) -1
c              list=list3(lr0,lr,lr0)
c            wl=vlop0*(voint(lr0,lr)+vint_ci(list))       !310+710
              wl=vlop0

          call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lr0,lr)
         call trans_ijkl_intpos(lr,lr0,lr0,lr0,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          do l=lr0+1,norb_dz
c            list=list3(lr0,lr,l)
           nocc=2
            tcoe=-0.5d0
c           wl=wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))  !dbl_
            wl=vlop0*nocc
         call trans_ijkl_intpos(lr,lr0,l,l,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=vlop0*tcoe*nocc
         call trans_ijkl_intpos(lr,l,lr0,l,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

         enddo
          do l=norb_dz+1,lr
c            list=list3(lr0,lr,l)
           kcoe=lpcoe(l)
          call neoc(kcoe,nocc,tcoe)
c         wl=wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))   !act_c
            wl=vlop0*nocc
         call trans_ijkl_intpos(lr,lr0,l,l,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=vlop0*tcoe*nocc
         call trans_ijkl_intpos(lr,l,lr0,l,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

         enddo
          wl_430=0.d0
          w0dv2=w0_dv(2)
          ni=mod(norb_dz-lrd,2)
          if(ni.eq.1) w0dv2=-w0dv2
         do lrk=1,lrd-1
c            list=list3(lr0,lr,lrk)
            vlop0=w0*w0dv2
c          wl_430=wl_430+vlop0*(vint_ci(list)-2*vint_ci(list+1))       !
            wl=vlop0
         call trans_ijkl_intpos(lr,lrk,lr0,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-vlop0*2
         call trans_ijkl_intpos(lr,lr0,lrk,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
c          wl=wl+wl_430
c**********************************************************
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      enddo
      return
!d1v(24-1) ar(13)-
!d1v(24-2) drl(33)-bl(13)-
224   iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
        w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
          vlop0=w0*w0dv1                !d24-1
        vlop1=w1*w0dv1
c**********************************************************
          lr0=lrd
          lr=kk(jpel) -1
c          list=list3(lr0,lr,lr0)
c           wl=vlop0*(voint(lr0,lr)+vint_ci(list))       !310+710
              wl=vlop0
          call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lr0,lr)
         call trans_ijkl_intpos(lr,lr0,lr0,lr0,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          do l=lr0+1,norb_dz
c            list=list3(lr0,lr,l)
             nocc=2
            tcoe=-0.5d0
c           wl=wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))  !dbl_
            wl=vlop0*nocc
         call trans_ijkl_intpos(lr,lr0,l,l,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=vlop0*tcoe*nocc
         call trans_ijkl_intpos(lr,l,lr0,l,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

         enddo
          do l=norb_dz+1,lr
c            list=list3(lr0,lr,l)
           kcoe=lpcoe(l)
          call neoc(kcoe,nocc,tcoe)
c         wl=wl+nocc*vlop0*(vint_ci(list+1)+tcoe*vint_ci(list))   !act_c
            wl=vlop0*nocc
         call trans_ijkl_intpos(lr,lr0,l,l,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=vlop0*tcoe*nocc
         call trans_ijkl_intpos(lr,l,lr0,l,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

         enddo
          wl_430=0.d0
            w0dv2=w0_d1v(2)
          ni=mod(norb_dz-lrd,2)
          if(ni.eq.1) w0dv2=-w0dv2
         do lrk=1,lrd-1
c            list=list3(lr0,lr,lrk)
            vlop0=w0*w0dv2
c            wl_430=wl_430+vlop0*(vint_ci(list)-2*vint_ci(list+1))
            wl=vlop0
         call trans_ijkl_intpos(lr,lrk,lr0,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
            wl=-vlop0*2
         call trans_ijkl_intpos(lr,lr0,lrk,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

          enddo
c          wl=wl+wl_430
c**********************************************************
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      enddo
      return

!line=25:-d^r^r<-->sv(10),tv(17),ttv(18)
300   goto(10,10,10,10,10,10,10,10,10,310,10,10,
     :     10,10,10,10,317,318,10,10,10,10,10,10,10,10),lpok

310   call sv_head_dbl_tail_act_g(lra)
      return
!tv(17) ar(23)-br(23)-
317   iwdr=0
      do lri=norb_frz+1,norb_dz
        imi=lsm_inn(lri)
      do lrj=lri,norb_dz
        imj=lsm_inn(lrj)
        imij=mul_tab(imi,imj)
        if(imij.ne.jml) cycle
        iwdl=just(lri,lrj)     !
        vlop1=w1*w1_tv             !d17 vlop0=0
c       list=list3(lri,lrj,lra)
c        wl=vlop1*vint_ci(list)        !2.1                  !!!!!
        wl=vlop1
         call trans_ijkl_intpos(lrj,lra,lri,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      enddo
      return

!t1v(18) ar(13)-br(13)-
318   iwdr=0
      do lri=norb_frz+1,norb_dz
        imi=lsm_inn(lri)
      do lrj=lri,norb_dz
        imj=lsm_inn(lrj)
        imij=mul_tab(imi,imj)
        if(imij.ne.jml) cycle
        iwdl=just(lri,lrj)     !
        vlop1=w1*w1_t1v             !d18 vlop0=0
c       list=list3(lri,lrj,lra)
c        wl=vlop1*vint_ci(list)        !2.1                  !!!!!
        wl=vlop1
         call trans_ijkl_intpos(lrj,lra,lri,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

      enddo
      enddo
      return

!line=26:-d^r^l<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(19
400   goto(401,402,403,404,405,10,10,10,10,10,411,412,
     :     10,10,10,10,10,10,419,420,421,422,10,10,425,10),lpok

401   call ss_head_dbl_tail_act_g(lra)
      return

402   call st_head_dbl_tail_act_g(lra)
      return
c=======================================================================
403   call ts_head_dbl_tail_act_g(lra)
      return

404   call stt_head_dbl_tail_act_g(lra)
      return

405   call tts_head_dbl_tail_act_g(lra)
      return

411   call tt_head_dbl_tail_act_g(lra)
      return

412   call tttt_head_dbl_tail_act_g(lra)
      return

419   call dd_head_dbl_tail_act_g(lra)
      return

420   call dddd_head_dbl_tail_act_g(lra)
      return

421   call dd1_head_dbl_tail_act_g(lra)
      return

422   call d1d_head_dbl_tail_act_g(lra)
      return

!vv(25) drl(33)-
425   if(jwl.eq.jwr) return
      vlop0=w0*w0_vv             !d25
      wl=0.d0
      iwdl=0
      iwdr=0
      do lri=1,norb_dz
c       wl=wl+vlop0*voint(lri,lra)
        wl=vlop0
          call prodab_1(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,lri,lra)
      enddo
c      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      return

!line=27:-b^r-a^r<-->sv(10),tv(17),ttv(18)
500   goto(10,10,10,10,10,10,10,10,10,510,10,10,
     :   10,10,10,10,517,518,10,10,10,10,10,10,10,10),lpok

510   call sv_head_dbl_tail_act_g(lra)
      return
!tv(17) ar(23)-br(23)-
517   iwdr=0
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(lmij.ne.jml) cycle
        w1tv=w1_tv
        if(mod(lrj-lri,2).eq.0) w1tv=-w1tv
        iwdl=just(lri,lrj)    !
        vlop1=w1*w1tv             !d17
c        list=list4(lri,lrj,lrs,lra)
c        wl=vlop1*(vint_ci(list)-vint_ci(list+2)) !1.3 vlop0=0      !!!!
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl=vlop1
         call trans_ijkl_intpos(lra,lrj,lrs,lri,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl=-vlop1
         call trans_ijkl_intpos(lra,lri,lrj,lrs,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

      enddo
      enddo
      return
!t1v(18) ar(13)-br(13)-
518   iwdr=0
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(lmij.ne.jml) cycle
        w1tv=w1_t1v
        if(mod(lrj-lri,2).eq.0) w1tv=-w1tv
        iwdl=just(lri,lrj)
        vlop1=w1*w1tv             !d17
c        list=list4(lri,lrj,lrs,lra)
c        wl=vlop1*(vint_ci(list)-vint_ci(list+2)) !1.3 vlop0=0      !!!!
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl=vlop1
         call trans_ijkl_intpos(lra,lrj,lrs,lri,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl=-vlop1
         call trans_ijkl_intpos(lra,lri,lrj,lrs,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      enddo
      return


!line=28:-b^l-a^r<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(
600   goto(601,602,603,604,605,10,10,10,10,10,611,612,
     :     10,10,10,10,10,10,619,620,621,622,10,10,625,10),lpok

601   call ss_head_dbl_tail_act_g(lra)
      return

602   call st_head_dbl_tail_act_g(lra)
      return

603   call ts_head_dbl_tail_act_g(lra)
      return

604   call stt_head_dbl_tail_act_g(lra)
      return

605   call tts_head_dbl_tail_act_g(lra)
      return

611   call tt_head_dbl_tail_act_g(lra)
      return

612   call tttt_head_dbl_tail_act_g(lra)
      return

619   call dd_head_dbl_tail_act_g(lra)
      return

620   call dddd_head_dbl_tail_act_g(lra)
      return

621   call dd1_head_dbl_tail_act_g(lra)
      return

622   call d1d_head_dbl_tail_act_g(lra)
      return


!vv(25) drl(33)-
625   vlop0=w0*w0_vv             !d25
      wl=0.d0
      iwdl=0
      iwdr=0
        do lrk=1,norb_dz
c        list=list3(lrs,lra,lrk)
c        wl=wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))   !4.3 vlop1=0
          wl=vlop0
         call trans_ijkl_intpos(lra,lrk,lrs,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl=-vlop0*2
         call trans_ijkl_intpos(lra,lrs,lrk,lrk,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

        enddo
c      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      return

!line=29:-b^r-a^l<-->ss(1),st(2),ts(3),stt(4),tts(5),tt(11),tttt(12),dd(
700   goto(701,702,703,704,705,10,10,10,10,10,711,712,
     :     10,10,10,10,10,10,719,720,721,722,10,10,725,10),lpok

701   call ss_head_dbl_tail_act_g(lra)
      return

702   call st_head_dbl_tail_act_g(lra)
      return

703   call ts_head_dbl_tail_act_g(lra)
      return

704   call stt_head_dbl_tail_act_g(lra)
      return

705   call tts_head_dbl_tail_act_g(lra)
      return

711   call tt_head_dbl_tail_act_g(lra)
      return

712   call tttt_head_dbl_tail_act_g(lra)
      return

719   call dd_head_dbl_tail_act_g(lra)
      return

720   call dddd_head_dbl_tail_act_g(lra)
      return

721   call dd1_head_dbl_tail_act_g(lra)
      return

722   call d1d_head_dbl_tail_act_g(lra)
      return

!vv(25) drl(33)-
725   if(jwl.ge.jwr) return
      vlop0=w0*w0_vv             !d25
      wl=0.d0
      iwdl=0
      iwdr=0
      do lrk=1,norb_dz
c          list=list3(lrs,lra,lrk)
c          wl=vlop0*vint_ci(list)      !4.2  vlop1=0         !!!!!
          wl=vlop0
         call trans_ijkl_intpos(lra,lrk,lrs,lrk,nxo)
         call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
c      call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      return

!line=30:-b&r-d^r^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
800   goto(10,10,10,10,10,806,10,808,10,10,10,10,
     :     813,10,815,10,10,10,10,10,10,10,823,824,10,10),lpok

!                                    sd(6-3) a&r(13)c'(22)-
806   call dbl_sd_act_comp_g(3,lra)
      return
!sd(6-3) tmp for spin=0
!      return
808   call dbl_sdd_act_comp_g(3,lra)
      return
813   call dbl_td_act_comp_g(3,lra)
      return

815   call dbl_ttdd_act_comp_g(3,lra)
      return
!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
823   iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
          w0dv1=w0_dv(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
         vlop0=w0*w0dv1                   !d23-1
        vlop1=w1*w0dv1
c        list=list3(lrd,lrg,lra)
c        wl=(vlop0+vlop1)*vint_ci(list)        !2.1       !!!!!
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl= vlop0+vlop1
         call trans_ijkl_intpos(lrg,lra,lrd,lra,nxo)
         call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      return
!d1v(24-1)  ar(13)-
824   iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
        w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
         vlop0=w0*w0dv1                   !d23-1
          vlop1=w1*w0dv1
c        list=list3(lrd,lrg,lra)
c        wl=(vlop0+vlop1)*vint_ci(list)        !2.1
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl= vlop0+vlop1
         call trans_ijkl_intpos(lrg,lra,lrd,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      return

!line=31:-b&l-d^r^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
900   goto(10,10,10,10,10,906,10,908,10,10,10,10,
     :     913,10,915,10,10,10,10,10,10,10,923,924,10,10),lpok

906   call dbl_sd_act_comp_g(5,lra)
      return

908   call dbl_sdd_act_comp_g(5,lra)
      return
913   call dbl_td_act_comp_g(5,lra)
      return

915   call dbl_ttdd_act_comp_g(5,lra)
      return
!dv(23-1) ar(23)-
!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
923   iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
        w0dv1=w0_dv(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
        vlop1=w1*w0dv1
c        list=list3(lrd,lrg,lra)
c        wl=vlop0*(vint_ci(list)-2*vint_ci(list+1))   !2.2          !!!!
c     :       -vlop1*(vint_ci(list))
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl= vlop0-vlop1
         call trans_ijkl_intpos(lrg,lra,lrd,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl= -vlop0*2
         call trans_ijkl_intpos(lrg,lrd,lra,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      return
!d1v(24-1)  ar(13)-
924   iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
          w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
        vlop1=w1*w0dv1
c        list=list3(lrd,lrg,lra)
c        wl=vlop0*(vint_ci(list)-2*vint_ci(list+1))   !2.2          !!!!
c     :       -vlop1*(vint_ci(list))
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl= vlop0-vlop1
         call trans_ijkl_intpos(lrg,lra,lrd,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl= -vlop0*2
         call trans_ijkl_intpos(lrg,lrd,lra,lra,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

      enddo
      return


!line=32:-b&r-b^r-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
1000  goto(10,10,10,10,10,1006,10,1008,10,10,10,10,
     :     1013,10,1015,10,10,10,10,10,10,10,1023,1024,10,10),lpok
1006  call dbl_sd_act_comp_g(4,lra)
      return
1008  call dbl_sdd_act_comp_g(4,lra)
      return
1013  call dbl_td_act_comp_g(4,lra)
      return
1015  call dbl_ttdd_act_comp_g(4,lra)
      return
!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
1023  iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
        w0dv1=w0_dv(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
        vlop1=w1*w0dv1
c        list=list4(lrd,lrg,lrs,lra)
c        wl=vlop0*(vint_ci(list+2)+vint_ci(list))  !1.3        !!!!!
c     :       -vlop1*(vint_ci(list+2)-vint_ci(list))
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl= vlop0+vlop1
         call trans_ijkl_intpos(lra,lrg,lrs,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl= vlop0-vlop1
         call trans_ijkl_intpos(lra,lrd,lrg,lrs,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

      enddo
      return
!d1v(24-1)  ar(13)-
1024  iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
          w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
        vlop1=w1*w0dv1
c        list=list4(lrd,lrg,lrs,lra)
c        wl=vlop0*(vint_ci(list+2)+vint_ci(list))  !1.3        !!!!!
c     :       -vlop1*(vint_ci(list+2)-vint_ci(list))
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl= vlop0+vlop1
         call trans_ijkl_intpos(lra,lrg,lrs,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl= vlop0-vlop1
         call trans_ijkl_intpos(lra,lrd,lrg,lrs,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      return

!line=33:-b&l-b^r-a^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
1100  goto(10,10,10,10,10,1106,10,1108,10,10,10,10,
     :     1113,10,1115,10,10,10,10,10,10,10,1123,1124,10,10),lpok

1106  call dbl_sd_act_comp_g(6,lra)
      return
1108  call dbl_sdd_act_comp_g(6,lra)
      return
1113  call dbl_td_act_comp_g(6,lra)
      return
1115  call dbl_ttdd_act_comp_g(6,lra)
      return

!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
1123  iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
          w0dv1=w0_dv(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
        vlop1=w1*w0dv1
c        list=list4(lrd,lrg,lrs,lra)
c        wl=vlop0*(vint_ci(list)-2*vint_ci(list+1))  !1.1          !!!!!
c     :       -vlop1*vint_ci(list)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl= vlop0-vlop1
         call trans_ijkl_intpos(lra,lrg,lrs,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl= -vlop0*2
         call trans_ijkl_intpos(lra,lrs,lrg,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      return
!d1v(24-1)  ar(13)-
1124  iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
          w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
        vlop1=w1*w0dv1
c        list=list4(lrd,lrg,lrs,lra)
c        wl=vlop0*(vint_ci(list)-2*vint_ci(list+1))  !1.1          !!!!!
c     :       -vlop1*vint_ci(list)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl= vlop0-vlop1
         call trans_ijkl_intpos(lra,lrg,lrs,lrd,nxo)
         call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl= -vlop0*2
         call trans_ijkl_intpos(lra,lrs,lrg,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      return

!line=34:-b&l-b^l-a^r<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
1200  goto(10,10,10,10,10,1206,10,1208,10,10,10,10,
     :     1213,10,1215,10,10,10,10,10,10,10,1223,1224,10,10),lpok

1206  call dbl_sd_act_comp_g(7,lra)
      return
1208  call dbl_sdd_act_comp_g(7,lra)
      return
1213  call dbl_td_act_comp_g(7,lra)
      return
1215  call dbl_ttdd_act_comp_g(7,lra)
      return
!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
1223  iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
        w0dv1=w0_dv(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
        vlop1=w1*w0dv1
c        list=list4(lrd,lrg,lrs,lra)
c        wl=vlop0*(vint_ci(list+2)-2.0d0*vint_ci(list+1)) !1.2      !!!!
c     :           -vlop1*vint_ci(list+2)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          wl= vlop0-vlop1
         call trans_ijkl_intpos(lra,lrd,lrg,lrs,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl= -vlop0*2
         call trans_ijkl_intpos(lra,lrs,lrg,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)

      enddo
      return
!d1v(24-1)  ar(13)-
1224  iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
          w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
        vlop1=w1*w0dv1
c        list=list4(lrd,lrg,lrs,lra)
c        wl=vlop0*(vint_ci(list+2)-2.0d0*vint_ci(list+1)) !1.2      !!!!
c     :           -vlop1*vint_ci(list+2)
c          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
         call trans_ijkl_intpos(lra,lrd,lrg,lrs,nxo)
          wl= vlop0-vlop1
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
          wl= -vlop0*2
         call trans_ijkl_intpos(lra,lrs,lrg,lrd,nxo)
          call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      return

!line=35:-d&r^l-a^l<-->sd(6),sdd(8),td(13),ttdd(15),dv(23),ddv(24)
1300  goto(10,10,10,10,10,1306,10,1308,10,10,10,10,
     :     1313,10,1315,10,10,10,10,10,10,10,1323,1324,10,10),lpok

1306  call dbl_sd_act_comp_g(2,lra)
      return
1308  call dbl_sdd_act_comp_g(2,lra)
      return
1313  call dbl_td_act_comp_g(2,lra)
      return
1315  call dbl_ttdd_act_comp_g(2,lra)
      return
!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
1323  iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
        w0dv1=w0_dv(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
c        list=list3(lrd,lra,lrs)
c        wl=vlop0*vint_ci(list)          !3.2         !!!!!
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
         wl=vlop0
         call trans_ijkl_intpos(lra,lrs,lrd,lrs,nxo)
         call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      return
!d1v(24-1)  ar(13)-
1324  iwdr=0
      do lrd=norb_frz+1,norb_dz
        imd=lsm_inn(lrd)
        if(imd.ne.jml) cycle
        iwdl=jud(lrd)
          w0dv1=w0_d1v(1)
        ni=mod(norb_dz-lrd,2)
        if(ni.eq.1) w0dv1=-w0dv1
        vlop0=w0*w0dv1                !d23-1
c        list=list3(lrd,lra,lrg)
c        wl=vlop0*vint_ci(list)          !3.2         !!!!!
c        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
         wl=vlop0
         call trans_ijkl_intpos(lra,lrg,lrd,lrg,nxo)
         call prodab_2(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper,nxo)
      enddo
      return

10    return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkV_A1 (Ve,V1,dimo2,no)
c
c       this routine do:
c       Ve(ij,u,v) <<- V1(iu|jv)
c
        implicit none
        integer dimo2,no
        real*8 Ve(1:dimo2,1:no,1:no)
        real*8 V1(1:dimo2,1:dimo2)
c
c       help variables
        integer i,j,ij,u,v,iu,jv
c
c
        do v=1,no
        do u=1,no
c
          ij=0
          do i=1,no
          do j=1,i
            ij=ij+1
c
            if (i.gt.u) then
            iu=(i-1)*i/2+u
            else
            iu=(u-1)*u/2+i
            end if
c
            if (j.gt.v) then
            jv=(j-1)*j/2+v
            else
            jv=(v-1)*v/2+j
            end if
c
            Ve(ij,u,v)=Ve(ij,u,v)+V1(iu,jv)
c
          end do
          end do
c
        end do
        end do
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_Energy(irc,EMP2,EOcc,EVir,Sorted,DelOrig)
!
! Thomas Bondo Pedersen, Dec. 2004.
!
! Purpose: compute MP2 energy correction from MO Cholesky vectors,
!          constructing (ai|bj) integrals on the fly. Flag Sorted
!          refers to whether or not the MO vectors have been sorted
!          into the sizes of the batches over occupied orbitals.

use ChoMP2, only: nBatch
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(out) :: EMP2
real(kind=wp), intent(in) :: EOcc(*), EVir(*)
logical(kind=iwp), intent(in) :: Sorted, DelOrig
integer(kind=iwp) :: lWrk
real(kind=wp), allocatable :: Wrk(:)
character(len=*), parameter :: SecNam = 'ChoMP2_Energy'

irc = 0

call mma_maxDBLE(lWrk)
call mma_allocate(Wrk,lWrk,Label='Wrk')

if (Sorted) then
  call ChoMP2_Energy_Srt(irc,DelOrig,EMP2,EOcc,EVir,Wrk,lWrk)
  if (irc /= 0) write(u6,*) SecNam,': ChoMP2_Energy_Srt returned ',irc
else if (nBatch == 1) then
  call ChoMP2_Energy_Fll(irc,DelOrig,EMP2,EOcc,EVir,Wrk,lWrk)
  if (irc /= 0) write(u6,*) SecNam,': ChoMP2_Energy_Fll returned ',irc
else
  call ChoMP2_Energy_Org(irc,DelOrig,EMP2,EOcc,EVir,Wrk,lWrk)
  if (irc /= 0) write(u6,*) SecNam,': ChoMP2_Energy_Org returned ',irc
end if

call mma_deallocate(Wrk)

end subroutine ChoMP2_Energy

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Get_Cmo
*
*> @brief
*>   Return the symmetry blocked MO coefficients as read from the runfile
*> @author R. Lindh
*>
*> @details
*> The utility will read the symmetry blocked MO coefficients from the runfile.
*>
*> @param[out] CMO array of symmetry blocked MO coefficients
*> @param[out] nCMO  Number of elements in the array of symmetry blocked MO coefficients
************************************************************************
      Subroutine Get_Cmo(CMO,nCMO)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
      Character Label*24
      Integer is_nSym, nSym
      Integer is_nBas, nBas(0:7)
      save is_nSym, is_nBas
      data is_nSym/0/, is_nBas/0/
      save nSym, nBas
      Logical   IfTest, Found
      Data      IfTest/.False./
      Real*8 CMO(nCMO)
#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif

      Label='Last orbitals'
      Call qpg_dArray(Label,Found,mCmo)
      If(.not.Found) Then
         Call SysAbendMsg('get_CMO','Could not find',Label)
      End If
      If (mCMO/=nCMO) Then
         Write (6,*) 'Get_CMO: mCMO/=nCMO'
         Write (6,*) 'nCMO=',nCMO
         Write (6,*) 'mCMO=',mCMO
         Call Abend()
      End If
      Call Get_dArray(Label,CMO,nCMO)
*                                                                      *
************************************************************************
*                                                                      *
      If (IfTest) Then
         if(is_nSym.eq.0) then
          Call Get_iScalar('nSym',nSym)
          is_nSym=1
         endif
         if(is_nBas.eq.0) then
          Call Get_iArray('nBas',nBas,nSym)
          is_nBas=1
         endif
         Write (6,*) ' Input Orbitals from RUNFILE'
         Write (6,*)
         ii=1
         Do iIrrep = 0, nSym-1
            If (nBas(iIrrep).gt.0) Then
               Write (6,*) ' Symmetry Block',iIrrep
               Call RecPrt(' ',' ',CMO(ii),nBas(iIrrep),nBas(iIrrep))
               Write (6,*)
            End If
            ii = ii + nBas(iIrrep)**2
         End Do
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function iPL_espf()
      Implicit Real*8(A-H,O-Z)
*
*     Returns the print level
*
#include "espf.fh"
*
      Logical Reduce_Prt
      External Reduce_Prt
*
      iPL = iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0
      iPL_espf = iPL
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DNAXPY(N,M,A,INCA,X,INCXI,INCXO,Y,INCYI,INCYO)
C
C     MULTIPLY A VECTOR, X, BY A SCALAR, ADD TO A VECTOR, Y, AND
C     STORE THE RESULT IN THE VECTOR Y. REPEAT THIS N TIMES.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 A((N-1)*INCA+1),
     1       X(((M-1)*INCXI+1)*((N-1)*INCXO+1)),
     2       Y(((M-1)*INCYI+1)*((N-1)*INCYO+1))
      DO 10 I = 1, N
         CALL DAXPY_(M,A(1+(I-1)*INCA),
     1                X(1+(I-1)*INCXO),INCXI,
     2                Y(1+(I-1)*INCYO),INCYI)
   10 CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Jun-ya Hasegawa                                  *
!               2004, Giovanni Ghigo                                   *
!***********************************************************************

subroutine RDINT2(IPRX,DoTCVA)
! SECOND ORDER TWO-ELECTRON TRANFORMATION PROGRAM. TEST SECTION
!
! THIS SUBROUTINE READS AND CHECKS THE RESULT OF THE SECOND ORDER
! TWO-ELECTRON TRANSFORMATION PROGRAM TRA2. IT CAN BE CALLED BY
! TR2CTL IMMEDIATELY AFTER THE CALL TO TRA2
!  IPRX=0 Do not print Coulomb nor Exchange Integrals
!  IPRX=1 Print only Coulomb Integrals
!  IPRX=2 Print all Integrals
!  IPRX=3 Print only Exchange Integrals
!
! Modified for caspt2 by Jun-ya Hasegawa(98/08/18)
! Modified again by G. Ghigo - September-December 2004
!
! A,B are MO indices, counting only non-frozen and non-deleted.
! T,U are occupied MO indices, only non-frozen and non-deleted.
!
! <AB/TU> ARE ALWAYS GENERATED
! EXCHANGE INTEGRALS <AT/BU> ARE GENERATED AS FOLLOWS:
! <AT/BU> IF ISP >= ISR
! <AT/UB> IF ISP > ISS AND ISP /= ISQ
! <TA/BU> IF ISQ > ISR AND ISP /= ISQ
! <TA/UB> IF ISQ >= ISS AND ISP /= ISQ
!
! IAD2M CONTAINS START ADRESS FOR EACH TYPE OF INTEGRALS:
! IAD2M(1,iSymIJAB)   COULOMB INTEGRALS <AB|TU>
! IAD2M(2,iSymIJAB)   EXCHANGE INTEGRALS <AB|TU> FOR SYM T > SYM U
! IAD2M(3,iSymIJAB)   EXCHANGE INTEGRALS <AB|TU> FOR SYM T < SYM U
! THE LAST ADRESS IS ZERO IF SYM T = SYM U

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IPRX
logical(kind=iwp), intent(in) :: DoTCVA
integer(kind=iwp) :: i, IAD131, IAD132, IAD13C, IAD2M(3,36*36), IADC, IADX1, IADX2, iSymA, iSymB, iSymI, iSymIJ, iSymIJA, &
                     iSymIJAB, iSymJ, LEx1, LEx2, LIADUT, LInt, LREC, LRECX, LTotEx1, LTotEx2, LTotInt, nData, NI, NJ, nOccA, &
                     nOccB, nOccI, nOccJ, nOrbA, nOrbB, nOrbI, nOrbJ, NUM
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: Tmp(:)
#include "rasdim.fh"
#include "caspt2.fh"
#include "trafo.fh"

! GG-Dec04  The following informations must be passed to the Cholesky
! transformation section through RunFile. COMMON blocks could not be
! used due to several conflicts.
call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
call Get_iArray('nFroPT',nFro,nSym)
call Get_iArray('nDelPT',nDel,nSym)
call Get_iArray('nIsh',nIsh,nSym)
! PAM 2007 call Get_iArray('nAsh',nAsh,nSym)
! Replaced by:
do i=1,nSym
  nAsh(i) = 0
end do
call qpg_iArray('nAsh',Found,nData)
if (Found .and. (nData == nSym)) then
  call Get_iArray('nAsh',nAsh,nSym)
end if
! End of replacement
do i=1,nSym
  nOrb(i) = nBas(i)-nFro(i)-nDel(i)
  nIsh(i) = nIsh(i)-nFro(i)
  nOsh(i) = nIsh(i)+nAsh(i)
  nSsh(i) = nOrb(i)-nOsh(i)
end do

write(u6,*)
write(u6,*) 'SECOND ORDER TWO-ELECTRON TRANFORMATION PROGRAM. TEST SECTION:'
write(u6,*) ' A,B are MO-symmetry indices, counting only non-frozen and non-deleted.'
write(u6,*) ' I,J are occupied MO-symmetry indices, only non-frozen and non-deleted.'
write(u6,*) ' i,j are occupied MO indices'
!write(u6,*) ' <AB/TU> COULOMB INTEGRALS ARE ALWAYS GENERATED.'
!write(u6,*) ' <AB|TU> EXCHANGE INTEGRALS ARE GENERATED AS FOLLOWS:'
!write(u6,*) '   <AT/BU> IF ISP >= ISR'
!write(u6,*) '   <AT/UB> IF ISP > ISS AND ISP /= ISQ'
!write(u6,*) '   <TA/BU> IF ISQ > ISR AND ISP /= ISQ'
!write(u6,*) '   <TA/UB> IF ISQ >= ISS AND ISP /= ISQ'
!write(u6,*) ' IAD2M(1,iSymIJAB)  COULOMB INTEGRALS <AB|TU>'
!write(u6,*) ' IAD2M(2,iSymIJAB)  EXCHANGE INTEGRALS <AB|TU> FOR SYM T > SYM U'
!write(u6,*) ' IAD2M(3,iSymIJAB)  EXCHANGE INTEGRALS <AB|TU> FOR SYM T < SYM U'
!write(u6,*) ' THE LAST ADRESS IS ZERO IF SYM T = SYM U'
write(u6,*)
write(u6,'(A,8I3)') '        Symmetries :',(i,i=1,nSym)
write(u6,*)
write(u6,'(A,8I3)') '           Frozen  :',(nFro(i),i=1,nSym)
write(u6,'(A,8I3)') '      Inactive (I) :',(nIsh(i),i=1,nSym)
write(u6,'(A,8I3)') '        Active (A) :',(nAsh(i),i=1,nSym)
write(u6,'(A,8I3)') '     Secondary (S) :',(nSsh(i),i=1,nSym)
write(u6,'(A,8I3)') '          Deleted  :',(nDel(i),i=1,nSym)
write(u6,*)
write(u6,'(A,8I3)') '  Total correlated :',(nOrb(i),i=1,nSym)
call XFlush(u6)

! READ ADDRESS RECORD ON UNIT LUINTM

IAD13 = 0
LIADUT = size(IAD2M)
call iDAFILE(LUINTM,2,IAD2M,LIADUT,IAD13)

! LOOP OVER QUADRUPLES OF SYMMETRIES (iSymI,iSymJ,iSymA,iSymB)

iSymIJAB = 0
LTotInt = 0
LTotEx1 = 0
LTotEx2 = 0
do iSymI=1,NSYM
  nOrbI = nOrb(iSymI)
  nOccI = nOsh(iSymI)
  do iSymJ=1,iSymI
    nOrbJ = nOrb(iSymJ)
    nOccJ = nOsh(iSymJ)
    iSymIJ = MUL(iSymI,iSymJ)
    do iSymA=1,NSYM
      nOrbA = nOrb(iSymA)
      nOccA = nOsh(iSymA)
      iSymIJA = MUL(iSymIJ,iSymA)
      ISR = iSymA
      do iSymB=1,iSymA
        nOrbB = nOrb(iSymB)
        nOccB = nOsh(iSymB)
        iSymIJAB = iSymIJAB+1

        if (iSymIJA /= iSymB) cycle
        if ((nOccI*nOccJ) == 0) cycle
        if (nOrbI*nOrbJ*nOrbA*nOrbB == 0) cycle

        ! FIND ADDRESSES FOR THIS SYMMETRY BLOCK

        IADC = IAD2M(1,iSymIJAB)
        IADX1 = IAD2M(2,iSymIJAB)
        IADX2 = IAD2M(3,iSymIJAB)
        write(u6,1000) iSymA,iSymB,iSymI,iSymJ

        if (IADC == 0) then
          !write(u6,*)
          write(u6,*) 'NO COULOMB INTEGRALS FOR THIS SYMMETRY BLOCK'
        else
          write(u6,1200) 'ADDRESS FOR COULOMB INTEGRALS',IADC
          IAD13C = IADC
        end if
        if (IADX1 == 0) then
          !write(u6,*)
          write(u6,*) 'NO EXCHAN1 INTEGRALS FOR THIS SYMMETRY BLOCK'
        else
          write(u6,1200) 'ADDRESS FOR EXCHAN1 INTEGRALS',IADX1
          IAD131 = IADX1
        end if
        if (IADX2 == 0) then
          !write(u6,*)
          write(u6,*) 'NO EXCHAN2 INTEGRALS FOR THIS SYMMETRY BLOCK'
        else
          write(u6,1200) 'ADDRESS FOR EXCHAN2 INTEGRALS',IADX2
          IAD132 = IADX2
        end if
        LREC = nOrbA*nOrbB
        if (iSymA == iSymB) LREC = (nOrbA**2+nOrbA)/2
        LRECX = nOrbA*nOrbB
        if (.not. DoTCVA) LRECX = (nOrbA-nOccA)*(nOrbB-nOccB)
        LInt = 0
        LEx1 = 0
        LEx2 = 0
        do NI=1,nOccI
          NUM = nOccJ
          if (iSymI == iSymJ) NUM = NI
          do NJ=1,NUM

            ! THE LOOP ABOVE OVER T AND U RECOVERS ONE BLOCK OF INTEGRALS <AB|TU>
            ! FOR EACH PAIR T,U. TO PROCESS ONE BLOCK FOR ALL A AND B THE
            ! FOLLOWING LOOP STRUCTURE IS USED:

            if (IADC /= 0) then
              LInt = LInt+LREC
              if ((IPRX > 0) .and. (IPRX < 3)) then
                call mma_allocate(Tmp,LREC,Label='Tmp')
                call dDAFILE(LUINTM,2,Tmp,LREC,IAD13C)
                write(u6,1300) '<AB|IJ> COULOMB INTEGRALS FOR |ij> PAIR',NI,NJ,IAD13C-LREC,(Tmp(I),I=1,LREC)
                call mma_deallocate(Tmp)
              end if
            end if

            ! THE EXCHANGE INTEGRALS OF TYPE 1 ,(AT|BU) ARE PROCESSED AS THE
            ! COULOMB INTEGRALS. IF NST /= NSU THERE ARE ALSO EXCHANGE
            ! INTEGRALS OF TYPE 2, (AU|BT). THE ORDERING IS STILL T,U AND A,B
            ! BUT T IS NOW THE FOURTH INDEX AND U THE SECOND
            ! EXCHANGE INTEGRALS ARE ALWAYS QUADRATIC IN A,B

            if (IADX1 /= 0) then
              LEx1 = LEx1+LRECX
              if (IPRX > 1) then
                call mma_allocate(Tmp,LRECX,Label='Tmp')
                call dDAFILE(LUINTM,2,Tmp,LRECX,IAD131)
                write(u6,1300) 'EXCHAN1 INTEGRALS FOR |ij> PAIR',NI,NJ,IAD131-LRECX,(Tmp(I),I=1,LRECX)
                call mma_deallocate(Tmp)
              end if
            end if

            if (IADX2 /= 0) then
              LEx2 = LEx2+LRECX
              if (IPRX > 1) then
                call mma_allocate(Tmp,LRECX,Label='Tmp')
                call dDAFILE(LUINTM,2,Tmp,LRECX,IAD132)
                write(u6,1300) 'EXCHAN2 INTEGRALS FOR |ij> PAIR',NI,NJ,IAD132-LRECX,(Tmp(I),I=1,LRECX)
                call mma_deallocate(Tmp)
              end if
            end if
          end do
        end do

        write(u6,*)
        write(u6,2000) LInt,LEx1,LEx2
        LTotInt = LTotInt+LInt
        LTotEx1 = LTotEx1+LEx1
        LTotEx2 = LTotEx2+LEx2

        ! ALL INTEGRALS FOR SYMMETRY BLOCK iSymI,iSymJ,iSymA,iSymB ARE READ

      end do
    end do
  end do
end do
write(u6,*)
write(u6,2010) LTotInt,LTotEx1,LTotEx2
write(u6,*) '   LTotTot=',LTotInt+LTotEx1+LTotEx2
write(u6,*)

return

1000 format(/1X,'SYMMETRY BLOCK < A B | I J >',4I4)
1200 format(1X,A,I8)
1300 format(/1X,A,2I3,'  DiskAdd=',I8/(8F10.6))
2000 format(3X,'LCou=',I8,' , LEx1=',I8,' , LEx2=',I8)
2010 format(3X,'LTotCou=',I8,' , LTotEx1=',I8,' , LTotEx2=',I8)

end subroutine RDINT2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3reaccsd(wrk,wrksize,eccsd)
! this routine reads CCSD results, it T1 and T2 amplitudes
! and CCSD energy from saverst file
!
! eccsd - Converged CCSD energy (O)

use CCT3_global, only: daddr, filerst, iokey, t11, t12, t21, t22, t23
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
real(kind=wp), intent(out) :: eccsd
integer(kind=iwp) :: istatus, lunrst, rc1
real(kind=wp) :: dum(1)

!1 open file savename
lunrst = 1

if (iokey == 1) then
  ! Fortran IO
  !open(unit=lunrst,file=filerst,form='unformatted')
  call molcas_binaryopen_vanilla(lunrst,filerst)

else
  ! MOLCAS IO
  call daname(lunrst,filerst)
  daddr(lunrst) = 0
end if

!2 get T1aa
call cct3_getmediate(wrk,wrksize,lunrst,t11,rc1)

!3 get T1bb
call cct3_getmediate(wrk,wrksize,lunrst,t12,rc1)

!4 get T2aaaa
call cct3_getmediate(wrk,wrksize,lunrst,t21,rc1)

!5 get T2bbbb
call cct3_getmediate(wrk,wrksize,lunrst,t22,rc1)

!6 get T2abab
call cct3_getmediate(wrk,wrksize,lunrst,t23,rc1)

!7 get energy,niter
if (iokey == 1) then
  ! Fortran IO
  read(lunrst,iostat=istatus) eccsd,rc1
  if (istatus < 0) then
    write(u6,*) ' ENERGY AND NIT WAS NOT IN SAVE FILE, CHANGED TO 0'
    write(u6,*) ' USE CCSD ENERGY FROM CCSD OUTPUT FILE'
    eccsd = Zero
  end if
else

  ! MOLCAS IO
  call ddafile(lunrst,2,dum,1,daddr(lunrst))
  eccsd = dum(1)
end if

if (iokey == 1) then
  ! Fortran IO
  close(lunrst)

else
  ! MOLCAS IO
  call daclos(lunrst)
end if

return

end subroutine t3reaccsd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************
subroutine Calc_Pot2(Pot2,mGrid,Pi,nPi)

use nq_Grid, only: Weights
use nq_pdft, only: d2RdRhodPi, d2ZdR2, dEdPi, dEdPiMO, dEdPix, dEdPiy, dEdPiz, dF_dRhoamb, dF_dRhoxamb, dF_dRhoyamb, dF_dRhozamb, &
                   dRdPi, dZdR, GdEdPiMO, GradRdFdRho, GradRhodFdRho, lft, lGGA, MOas, MOax, MOay, MOaz, Pass1, Pass2, Pass3, RhoAB
use nq_Info, only: nPot2
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Pot2(nPot2)
integer(kind=iwp), intent(in) :: mGrid, nPi
real(kind=wp), intent(in) :: Pi(nPi,mGrid)
integer(kind=iwp) :: iGrid
real(kind=wp) :: ftggaterm, ggaterm, predEdPip
real(kind=wp), parameter :: ThrsPi = 1.0e-30_wp

if (lGGA .and. lft) then
  dEdPix(:) = Zero
  dEdPiy(:) = Zero
  dEdPiz(:) = Zero
  GdEdPiMO(:,:) = Zero
end if

do iGrid=1,mGrid
  if (Pass1(iGrid) .and. (Pi(1,iGrid) > ThrsPi)) then
    if (Pass2(iGrid) .or. Pass3(iGrid)) then
      if (lGGA) then
        ggaterm = GradRhodFdRho(iGrid)
        if (lft) then
          ftggaterm = (d2ZdR2(iGrid)*dRdPi(iGrid)*GradRdFdRho(iGrid)+ &
                       d2RdRhodPi(iGrid)*dZdR(iGrid)*GradRhodFdRho(iGrid))*RhoAB(iGrid)
          predEdPip = RhoAB(iGrid)*dZdR(iGrid)*dRdPi(iGrid)*Weights(iGrid)
          dEdPix(iGrid) = predEdPip*dF_dRhoxamb(iGrid)
          dEdPiy(iGrid) = predEdPip*dF_dRhoyamb(iGrid)
          dEdPiz(iGrid) = predEdPip*dF_dRhozamb(iGrid)
        else
          ftggaterm = Zero
        end if
      else
        ggaterm = Zero
        ftggaterm = Zero
      end if
      dEdPi(iGrid) = Weights(iGrid)*(dZdR(iGrid)*dRdPi(iGrid)*(RhoAB(iGrid)*dF_dRhoamb(iGrid)+ggaterm)+ftggaterm)
    else
      dEdPi(iGrid) = Zero
    end if
  else
    dEdPi(iGrid) = Zero
  end if
end do

dEdPi(:) = Half*dEdPi
if (lGGA .and. lft) then
  dEdPix(:) = Half*dEdPix
  dEdPiy(:) = Half*dEdPiy
  dEdPiz(:) = Half*dEdPiz
end if

do iGrid=1,mGrid
  dEdPiMO(iGrid,:) = MOas(iGrid,:)*dEdPi(iGrid)
end do

if (lft .and. lGGA) then
  do iGrid=1,mGrid
    GdEdPiMO(iGrid,:) = GdEdPiMO(iGrid,:)+dEdPix(iGrid)*MOax(iGrid,:)+dEdPiy(iGrid)*MOay(iGrid,:)+dEdPiz(iGrid)*MOaz(iGrid,:)
  end do
  dEdPiMO(:,:) = dEdPiMO+GdEdPiMO
end if

! dEdPiMO is practically (Phi_p*dEdPi+Phi_p'*dEdPi')
! The subroutine below calculates
! (Phi_p*dEdPi+Phi_p'*dEdPi')*Phi_u*Phi_v*Phi_x
call Calc_Pot2_Inner(Pot2,mGrid,dEdPiMO,MOas,MOas,MOas,.false.)

if (lft .and. lGGA) then
  call Calc_Pot2_Inner(Pot2,mGrid,MOas,MOas,MOas,GdEdPiMO,.true.)
end if

return

end subroutine Calc_Pot2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine chop4_cvb()

use casvb_global, only: civb1, civb2, civb3, civb4, civb5, civb6, civb7, civb8, civbvecs, icnt_ci, ifinish, iform_ci, lcalccivbs, &
                        lcalcevb, lcalcsvb, lciweights, memplenty, ndres, ndres_ok, nv, release
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iv

if (release(4)) then
  call mma_deallocate(civbvecs)
  nullify(civb1,civb2,civb3,civb4,civb5,civb6,civb7,civb8)
end if
release(4) = .true.
release(5) = .false.

!FIXME: This deallocation should not be needed
call mma_deallocate(civbvecs,safe='*')
! CIVECP and CIVBH share memory
call mma_allocate(civbvecs,[0,ndres-1],[1,nv],label='civbvecs')
if (nv >= 1) then
  civb1 => civbvecs(0:,1)
  if (nv >= 2) then
    civb2 => civbvecs(0:,2)
  else
    civb2 => civbvecs(0:,1)
  end if
  if (nv >= 3) then
    civb3 => civbvecs(0:,3)
  else
    civb3 => civbvecs(0:,1)
  end if
  if (nv >= 4) then
    civb4 => civbvecs(0:,4)
  else
    civb4 => civbvecs(0:,1)
  end if
  if (nv >= 5) then
    civb5 => civbvecs(0:,5)
  else
    civb5 => civbvecs(0:,1)
  end if
  if (nv >= 6) then
    civb6 => civbvecs(0:,6)
  else
    civb6 => civbvecs(0:,1)
  end if
  if (nv >= 7) then
    civb7 => civbvecs(0:,7)
  else
    civb7 => civbvecs(0:,1)
  end if
  if (nv >= 8) then
    civb8 => civbvecs(0:,8)
  else
    civb8 => civbvecs(0:,1)
  end if
end if
! Fix to put in "objects":
do iv=1,nv
  civbvecs(0,iv) = real(iv,kind=wp)
  iform_ci(iv) = 0
  if (.not. ndres_ok) icnt_ci(iv) = 0
end do
!-- ins
if (((ifinish == 1) .or. (ifinish == 2)) .and. (.not. lciweights)) then
  if (((.not. lcalcevb) .or. lcalccivbs) .and. ((.not. lcalcsvb) .or. lcalccivbs)) then
    civb3 => civbvecs(0:,1)
    civb4 => civbvecs(0:,1)
  else if ((.not. lcalcevb) .or. lcalccivbs) then
    civb4 => civbvecs(0:,3)
  else if ((.not. lcalcsvb) .or. lcalccivbs) then
    civb3 => civbvecs(0:,1)
    civb4 => civbvecs(0:,3)
  end if
end if
if (.not. memplenty) then
  select case (nv)
    case (2)
      civb3 => civbvecs(0:,1)
    case (3)
      civb4 => civbvecs(0:,1)
    case (4)
      civb5 => civbvecs(0:,1)
    case (5)
      civb6 => civbvecs(0:,1)
    case (6)
      civb7 => civbvecs(0:,1)
    case (7)
      civb8 => civbvecs(0:,1)
  end select
end if
if ((nv == 3) .or. (nv == 4) .or. (nv == 5)) then
  civb6 => civb2
  civb7 => civb3
  civb8 => civb4
end if

return

end subroutine chop4_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Markus P. Fuelscher                              *
*               1995, Martin Schuetz                                   *
*               2004,2005, Thomas Bondo Pedersen                       *
************************************************************************
      Subroutine RdInp(CMO,Eall,Eocc,Eext,iTst,ESCF)
************************************************************************
*                                                                      *
*     Locate input stream and read commands                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     modified by MGS                                                  *
*                 TBP                                                  *
*     University of Lund, Sweden, 1992/95, 2004/05.                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Dimension CMO(*),Eall(*),Eocc(*),Eext(*)
#include "cddos.fh"
#include "chomp2_cfg.fh"
#include "real.fh"
#include "mxdim.fh"
#include "corbinf.fh"
#include "orbinf2.fh"
#include "mbpt2aux.fh"
#include "WrkSpc.fh"
#include "print_mbpt2.fh"
#include "warnings.fh"
#include "Molcas.fh"
#include "namact.fh"
      Parameter ( nCom=43 )
      Character*4 Command,ComTab(nCom)
      Character*180 Get_Ln
      External Get_Ln
      Character*100 ProgName, Get_SuperName
      External Get_SuperName
      Integer  iPrintLevel
      External iPrintLevel
      Logical  ChoMP2_ChkPar
      External ChoMP2_ChkPar
      Logical  Reduce_Prt
      External Reduce_Prt
      Data ComTab/'TITL','FROZ','DELE','SFRO','SDEL',
     &            'EXTR','PRIN','TEST','TSTP','PRPT',
     &            'LUMO','EREF','VIRA','T1AM','GRDT',
     &            'LAPL','GRID','BLOC','CHOA','$$$$',
     &            '$$$$','$$$$','DECO','NODE','THRC',
     &            'SPAN','MXQU','PRES','CHKI','FORC',
     &            'VERB','NOVE','FREE','PREC','SOSM',
     &            'OEDT','OSFA','LOVM','DOMP','FNOM',
     &            'GHOS','NOGR','END '/
      Character*180 Line
      Character*8 emiloop
      Character*8 inGeo
      Character*72  Blank
      Logical FrePrt,ERef_UsrDef, DecoMP2_UsrDef,DNG,NoGrdt
      Logical lTit,lFro,lFre,lDel,lSFro,lSDel,lExt,lPrt,LumOrb
      Character*80 VecTitle
      Real*8 ESCF
      Dimension iDummy(1)
*----------------------------------------------------------------------*
*     Locate "start of input"                                          *
*----------------------------------------------------------------------*
      lTit=.false.
      lFro=.false.
      lFre=.false.
      lDel=.false.
      lSFro=.false.
      lSDel=.false.
      lExt=.false.
      lPrt=.false.
      LovMP2=.false.
      DoMP2=.false.
      FNOMP2=.false.
      LumOrb=.false.
      all_vir=.false.
      DoT1amp=.false.
      ESCF=0.0d0
      Thr_ghs=5.0d-1
      DelGHost=.false.
      ERef_UsrDef=.false.
      DecoMP2_UsrDef=.false.
      Call Put_iScalar('mp2prpt',0)
*
*     copy input from standard input to a local scratch file
*
      LuSpool = 17
      Call SpoolInp(LuSpool)
      LuRd=5
      Rewind(LuSpool)
      Call RdNLst(LuSpool,'MBPT2')
      Blank=' '
*----------------------------------------------------------------------*
*     Define default values                                            *
*----------------------------------------------------------------------*
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0



*
      If (DoCholesky) Then
         ChoAlg=2
      Else
         ChoAlg=-999999
      End If
      DecoMP2=Decom_Def
      ThrMP2=-9.9D9
      SpanMP2=Span_Def
      MxQualMP2=MxQual_Def
      ChkDecoMP2=.false.
      ForceBatch=.false.
      If (iPL .ge. 3) Then
         Verbose=.true.
      Else
         Verbose=.false.
      End If
* --- Scaled Opposite-Spin MP2
      SOS_mp2=.false.
      set_cd_thr=.true.
      OED_Thr=1.0d-8
      C_os=1.3d0
      EOSMP2=0.0d0
* --- Frozen natural orbitals
      DoFNO=.false.
* --- MP2-gradient/1pdm
      DoDens=.false.
      DoGrdt=.false.
      NoGrdt=.false.
      NoGamma=.false.
* --- Laplace transform
      Laplace=.false.
      Laplace_nGridPoints=0
      Laplace_BlockSize=Laplace_BlockSize_Def
* --- LDF settings
      If (DoLDF) Then
         SOS_MP2=.true.
         Laplace=.true.
      End If

* ---------------------
      nTit=0
      iTst=0
      nTstP=-1
      iPrt=0
      Call Get_iArray('Non valence orbitals',nFro1,nSym)
      Do iSym=1,nSym
C        nFro1(iSym)=0
         nFro2(iSym)=0
         Do iOrb=1,mxFro
            iFro(iSym,iOrb)=0
         End Do
         nDel1(iSym)=0
         nDel2(iSym)=0
         Do iOrb=1,mxFro
            iDel(iSym,iOrb)=0
         End Do
      End Do
      nFre=0
*----------------------------------------------------------------------*
*     Read the input stream line by line and identify key command      *
*----------------------------------------------------------------------*
100   Line = Get_Ln(LuSpool)
      Call StdFmt(Line,Command)
      jCom=0
      Do iCom=1,nCom
        If ( Command.eq.ComTab(iCom) ) jCom=iCom
      End Do
      If ( jCom.eq.0 ) Then
         Write (6,*) 'RdInp: Illegal keyword!'
         Write (6,'(A,A)') 'Command=',Command
         Call Abend()
      End If
*----------------------------------------------------------------------*
*     Branch to the processing of the command sections                 *
*----------------------------------------------------------------------*
 110  Continue
      Select Case(jCom)
         Case(1)
            Goto 501
         Case(2)
            Goto 502
         Case(3)
            Goto 503
         Case(4)
            Goto 504
         Case(5)
            Goto 505
         Case(6)
            Goto 506
         Case(7)
            Goto 507
         Case(8)
            Goto 508
         Case(9)
            Goto 509
         Case(10)
            Goto 510
         Case(11)
            Goto 511
         Case(12)
            Goto 512
         Case(13)
            Goto 513
         Case(14)
            Goto 514
         Case(15)
            Goto 515
         Case(16)
            Goto 516
         Case(17)
            Goto 517
         Case(18)
            Goto 518
         Case(19)
            Goto 519
         Case(20)
            Goto 520
         Case(21)
            Goto 521
         Case(22)
            Goto 522
         Case(23)
            Goto 523
         Case(24)
            Goto 524
         Case(25)
            Goto 525
         Case(26)
            Goto 526
         Case(27)
            Goto 527
         Case(28)
            Goto 528
         Case(29)
            Goto 529
         Case(30)
            Goto 530
         Case(31)
            Goto 531
         Case(32)
            Goto 532
         Case(33)
            Goto 533
         Case(34)
            Goto 534
         Case(35)
            Goto 535
         Case(36)
            Goto 536
         Case(37)
            Goto 537
         Case(38)
            Goto 538
         Case(39)
            Goto 539
         Case(40)
            Goto 540
         Case(41)
            Goto 541
         Case(42)
            Goto 542
         Case Default
            Goto 1000
      End Select
*---  Process the "TITL" input card -----------------------------------*
 501  Continue
      If ( lTit ) Then
         Write (6,*) 'RdInp: Error while reading input!'
         Write (6,*) 'Title option already processed!'
         Write (6,'(A,A)') 'Last read line:',Line
         Call Abend()
      End If
      lTit=.true.
 15   Line = Get_Ln(LuSpool)
      Call StdFmt(Line,Command)
      jCom=0
      Do iCom=1,nCom
        If ( Command.eq.ComTab(iCom) ) jCom=iCom
      End Do
      If ( jCom.ne.0 ) Goto 110
      nTit=nTit+1
      If ( nTit.le.mxTit ) then
         Title(nTit)=Line(1:80)
         Goto 15
      End If
      Goto 100
*---  Process the "FROZ" input card -----------------------------------*
 502  Continue
      If ( lFre .or. lFro) Then
         Write (6,*) 'RdInp: Error while reading input!'
         If (lFro) Write (6,*) 'Frozen option already processed!'
         If (lFre) Write (6,*) 'Freeze option and Frozen option ',
     &                         'are incompatible!'
         Write (6,'(A,A)') 'Last read line:',Line
         Call Abend()
      End If
      lFro=.true.
      Line = Get_Ln(LuSpool)
*
      Write (6,*)
      Write (6,'(A)') 'WARNING!'
      Write (6,'(A)') 'Default frozen orbitals as non valence orbitals'
     &              //' is overwritten by user input.'
      Write (6,'(A,8I4)') 'Default values:',(nFro1(iSym),iSym=1,nSym)
      Write (6,*)
*
      Read(Line,*,err=995) (nFro1(iSym),iSym=1,nSym)
      Goto 100
*---  Process the "DELE" input card -----------------------------------*
 503  Continue
      If ( lDel ) Then
         Write (6,*) 'RdInp: Error while reading input!'
         Write (6,*) 'Delete option already processed!'
         Write (6,'(A,A)') 'Last read line:',Line
         Call Abend()
      End If
      lDel=.true.
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) (nDel1(iSym),iSym=1,nSym)
      Goto 100
*---  Process the "SFRO" input card -----------------------------------*
 504  Continue
      If ( lSFro ) Then
         Write (6,*) 'RdInp: Error while reading input!'
         Write (6,*) 'SFrozen option already processed!'
         Write (6,'(A,A)') 'Last read line:',Line
         Call Abend()
      End If
      lSFro=.true.
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) (nFro2(iSym),iSym=1,nSym)
      Do iSym=1,nSym
         Line = Get_Ln(LuSpool)
         Read(Line,*,err=995)
     &       (iFro(iSym,iOrb),iOrb=1,nFro2(iSym))
      End Do
      Goto 100
*---  Process the "SDEL" input card -----------------------------------*
 505  Continue
      If ( lSDel ) Then
         Write (6,*) 'RdInp: Error while reading input!'
         Write (6,*) 'SDelete option already processed!'
         Write (6,'(A,A)') 'Last read line:',Line
         Call Abend()
      End If
      lSDel=.true.
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) (nDel2(iSym),iSym=1,nSym)
      Do iSym=1,nSym
         Line = Get_Ln(LuSpool)
         Read(Line,*,err=995)
     &       (iDel(iSym,iOrb),iOrb=1,nDel2(iSym))
      End Do
      Goto 100
*---  Process the "Extract" input card --------------------------------*
 506  Continue
      If ( lExt ) Then
         Write (6,*) 'RdInp: Error while reading input!'
         Write (6,*) 'Extract option already processed!'
         Write (6,'(A,A)') 'Last read line:',Line
         Call Abend()
      End If
      Write (6,*) 'RdInp: EXTRACT option is redundant and is ignored!'
      Goto 100
*---  Process the "Print" input card ----------------------------------*
 507  Continue
      If ( lPrt ) Then
         Write (6,*) 'RdInp: Error while reading input!'
         Write (6,*) 'Print option already processed!'
         Write (6,'(A,A)') 'Last read line:',Line
         Call Abend()
      End If
      lPrt=.true.
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) iPrt
      Goto 100
*---  Process the "Test" input card -----------------------------------*
 508  Continue
      iTst=1
      Goto 100
*---  Process the "TSTP" input card -----------------------------------*
 509  Continue
      iTst=1
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) nTstP
      Goto 100
*---  Process the "PRPT" input card -----------------------------------*
 510  Continue
      Call Put_iScalar('mp2prpt',1)
      DoDens = .true.
      NoGamma = .true.
      Goto 100
*---  Process the "LUMO" input card -----------------------------------*
 511  Continue
      LumOrb = .true.
      Goto 100
*---  Process the "EREF" input card -----------------------------------*
 512  Continue
      If (.not.LumOrb) Then
         Write (6,*) 'RdInp: Error while reading input!'
         Write (6,*) 'EREF can be used only with LumOrb.'
         Write (6,*) '(Note: LumOrb keyword must precede EREF)'
         Call Abend()
      EndIf
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) ESCF
      ERef_UsrDef=.true.
      Goto 100
*---  Process the "VIRA" input card -----------------------------------*
 513  Continue
      all_Vir=.true.
      Goto 100
*---  Process the "T1AM" input card -----------------------------------*
 514  Continue
      DoT1amp=.true.
      If (.not.DoCholesky) Then
         Write (6,*) 'RdInp: T1AM is available only with Cholesky/RI .'
         Call Abend()
      EndIf
      Goto 100
*---  Process the "GRDT" input card -----------------------------------*
 515  Continue
      Call Put_iScalar('mp2prpt',2)
      DoDens = .true.
      DoGrdt = .true.
      Goto 100
*---  Process the "LAPLace" input card --------------------------------*
*     Laplace transform with default or previously specified grid.
 516  Continue
      Laplace=.true.
      Goto 100
*---  Process the "GRID" input card -----------------------------------*
*     Read number of Laplace grid points (activates Laplace as well)
 517  Continue
      Laplace=.true.
      Line=Get_Ln(LuSpool)
      Read(Line,*,Err=995) Laplace_nGridPoints
      Laplace_nGridPoints=max(0,Laplace_nGridPoints)
      If (Laplace_nGridPoints.gt.Laplace_mGridPoints) Then
         Call WarningMessage(2,'Input Error')
         Write(6,'(A,I6)') 'Number of Laplace grid points specified:',
     &                     Laplace_nGridPoints
         Write(6,'(A,I6)') 'Max allowed:                            ',
     &                     Laplace_mGridPoints
         Call Quit(_RC_INPUT_ERROR_)
      End If
      Goto 100
*---  Process the "BLOC" input card -----------------------------------*
*     Read vector block size for CD/DF-Laplace-SOS-MP2
*     (Activates Laplace as well)
 518  Continue
      Laplace=.true.
      Line=Get_Ln(LuSpool)
      Read(Line,*,Err=995) Laplace_BlockSize
      Laplace_BlockSize=max(0,Laplace_BlockSize)
      If (Laplace_BlockSize.eq.0) Then
         Laplace_BlockSize=Laplace_BlockSize_Def
      End If
      GoTo 100
*---  Process the "CHOAlgorithm" input card ---------------------------*
 519  Continue
      Line = Get_Ln(LuSpool)
      Read(Line,*,Err=995) ChoAlg
      If (ChoAlg .lt. 0) Then
         ChoAlg = 0
      Else If (ChoAlg .gt. 2) Then
         ChoAlg = 2
      End If
      Goto 100
*---  Process the "$$$$" input card -----------------------------------*
 520  Continue
c     not used
      Goto 100
*---  Process the "$$$$" input card -----------------------------------*
 521  Continue
c     not used
      Goto 100
*---  Process the "$$$$" input card -----------------------------------*
 522  Continue
c     not used
      Goto 100
*---  Process the "DECOmpose MP2 integrals" card ----------------------*
 523  Continue
      DecoMP2=.true.
      DecoMP2_UsrDef=.true.
      Goto 100
*---  Process the "NODEcomposition of MP2 integrals" card -------------*
 524  Continue
      DecoMP2=.false.
      DecoMP2_UsrDef=.true.
      Goto 100
*---  Process the "THRCholesky" card ----------------------------------*
 525  Continue
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) ThrMP2
      set_cd_thr=.false.
      Goto 100
*---  Process the "SPAN" card -----------------------------------------*
 526  Continue
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) SpanMP2
      Goto 100
*---  Process the "MXQUal" input card ---------------------------------*
 527  Continue
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) MxQualMP2
      If (MxQualMP2 .lt. 1) MxQualMP2 = MxQual_Def
      Goto 100
*---  Process the "PRESort input card (OBSOLETE) ----------------------*
 528  Continue
      Goto 100
*---  Process the "CHKI" card -----------------------------------------*
 529  Continue
      ChkDecoMP2=.true.
      Goto 100
*---  Process the "FORCebatching" card --------------------------------*
 530  Continue
      ForceBatch=.true.
      Goto 100
*---  Process the "VERBose" card --------------------------------------*
 531  Continue
      Verbose=.true.
      Goto 100
*---  Process the "NOVErbose" card ------------------------------------*
 532  Continue
      Verbose=.false.
      Goto 100
*---  Process the "FREEze" card  --------------------------------------*
 533  Continue
      If ( lFre .or. lFro ) Then
         Write (6,*) 'RdInp: Error while reading input!'
         If (lFre) Write (6,*) 'Freeze option already processed!'
         If (lFro) Write (6,*) 'Frozen option and Freeze option ',
     &                         'are incompatible!'
         Write (6,'(A,A)') 'Last read line:',Line
         Call Abend()
      End If
*
      Write (6,*)
      Write (6,'(A)') 'WARNING!'
      Write (6,'(A)') 'Default frozen orbitals as non valence orbitals'
     &              //' is overwritten by user input.'
      Write (6,'(A,8I4)') 'Default values:',(nFro1(iSym),iSym=1,nSym)
      Write (6,*)
      Call ICopy(nSym,[0],0,nFro1,1)
*
      lFre=.true.
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) nFre
      Goto 100
*---  Process the "PRECision" card (= "THRCholesky" card) -------------*
 534  Continue
      Goto 525
* Commented out this line because it is not really possible to get here
* //Jonas Bostrom
*      Goto 100
*---  Process the "SOSMp2" card ---------------------------------------*
 535  Continue
      SOS_MP2=.true.
      If (.not.DoLDF) Then
         DecoMP2=.true.
         If (ChoMP2_ChkPar()) Then
            Call WarningMessage(2,'SOS-MP2 is not implemented '
     &                               //'for parallel runs. !! SORRY !!')
            Call Quit(_RC_NOT_AVAILABLE_)
         End If
      End If
      Goto 100
*---  Process the "OEDThreshold" card ---------------------------------*
 536  Continue
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) OED_Thr
      Goto 100
*---  Process the "OSFActor" card -------------------------------------*
 537  Continue
      Line = Get_Ln(LuSpool)
      Read(Line,*,err=995) C_os
      Goto 100
*---  Process the LovMP2 input ----------------------------------------*
 538  Continue
      If (.not. DoCholesky) Then
         WRITE(6,*)
         WRITE(6,*)'********************* ERROR ***********************'
         WRITE(6,*)' LovMP2 not implemented with conventional ERIs.'
         WRITE(6,*)' Please, use Cholesky or RI options.'
         WRITE(6,*)'***************************************************'
         Call Abend()
      Else
         LovMP2=.true.
      EndIf
      Read(LuSpool,*) nActa,ThrLov
*     nActa = number of active atoms
*     ThrLov = threshold for orbital selection
*
      If (ThrLov.lt.0.0d0 .or. ThrLov.ge.1.0d0) Then
         write(6,*)' Threshold out of range! Must be in [0,1[ '
         Call Abend()
      EndIf
*     namAct = names of active atoms (symm. indep. centers)
1538  Read(LuSpool,'(A)',End=995) Line
      If ( Line(1:1).eq.'*' ) Goto 1538
      If ( Line.eq.Blank) Goto 1538
      Call UpCase(Line)
      Do i=1,nActa
       Call LeftAd(Line)
       If( Line.eq.Blank) Goto 995
       j=Index(Line,' ')
       namAct(i)=Line(1:j-1)
       Line(1:j-1)=Blank(1:j-1)
      Enddo
      Goto 100
*
*---  Process DoMP2 card ----------------------------------------------*
 539  Continue
      DoMP2=.true.
      Goto 100
*
*---  process FNOM command
 540  Continue
      If (.not.DoCholesky) Then
         WRITE(6,*)
         WRITE(6,*)'********************* ERROR ***********************'
         WRITE(6,*)' FNO-MP2 not implemented with conventional ERIs.   '
         WRITE(6,*)' Please, use Cholesky or RI options.'
         WRITE(6,*)'***************************************************'
         Call Abend()
      Else
         FnoMP2=.true.
      EndIf
      Read(LuSpool,*) vkept
*
      If (vkept.le.0.0d0 .or. vkept.gt.1.0d0) Then
         write(6,*)' Requested fraction of virtual space out of range! '
         write(6,*)' Must be in ]0,1] '
         Call Abend()
      EndIf
      Goto 100
*
*>>>>>>>>>>>>> GHOST <<<<<< Removal of GHOST virtual space <<<<<<<<<
*
 541  Continue
      Read(LuSpool,'(A)',End=995) Line
      If ( Line(1:1).eq.'*' ) Goto 541
      If ( Line.eq.Blank ) Goto 541
      Read(Line,*,Err=995) Thr_ghs
      If (thr_ghs.lt.0.0d0 .or. thr_ghs.ge.1.0d0) Then
         write(6,*)' GHOST threshold out of range! Must be in [0,1[ '
         Call Abend()
      EndIf
      DelGHost=.true.
      Goto 100
*
*---  Process the "NOGR" input card -----------------------------------*
 542  Continue
      NoGrdt = .true.
      Goto 100
*
*---  Unused ----------------------------------------------------------*
c543  Continue
c     Goto 100
*----------------------------------------------------------------------*
*     "End of input"                                                   *
*----------------------------------------------------------------------*
1000  Continue
*
*---  Postprocessing for SOS-MP2 and Laplace
      If (SOS_MP2) Then
         If (.not.(DoCholesky.or.DoDF.or.DoLDF)) Then
            Call WarningMessage(2,
     &                         'SOS-MP2 only implemented for CD/DF/LDF')
            Call Quit(_RC_INPUT_ERROR_)
         End If
      End If
      If (Laplace) Then
         If (.not.(DoCholesky.or.DoDF.or.DoLDF)) Then
            Call WarningMessage(2,
     &          'Laplace transformation only implemented for CD/DF/LDF')
            Call Quit(_RC_INPUT_ERROR_)
         End If
         If (.not.SOS_MP2) Then
            Call WarningMessage(2,
     &  'Laplace transformation only implemented for CD/DF/LDF-SOS-MP2')
            Call Quit(_RC_INPUT_ERROR_)
         End If
         If (.not.DecoMP2_UsrDef) Then
            ! SOS-MP2 without Laplace automatically turns on DecoMP2.
            ! With Laplace, however, we should use the same default
            ! as for standard MP2. So, change back to default unless
            ! the user explicitly asked for something else.
            DecoMP2=Decom_Def
         End If
         If (DoDens .or. DoGrdt) Then
            Call WarningMessage(2,
     &          'Laplace transformation is incompatible with PRPT/GRDT')
            Call Quit(_RC_INPUT_ERROR_)
         End If
      End If
*
*     Check if the calculation is inside a loop and make analytical
*     gradients default in this case
*
*     Numerical gradients requested in GATEWAY
      Call Qpg_iScalar('DNG',DNG)
      If (DNG) Then
         Call Get_iScalar('DNG',iDNG)
         DNG = iDNG.eq.1
      End If
      DNG=NoGrdt.or.DNG
*
*     Inside LAST_ENERGY we do not need analytical gradients
      ProgName=Get_SuperName()
      If (ProgName(1:11).eq.'last_energy') DNG=.true.
*
*     Inside NUMERICAL_GRADIENT override input!
      If (ProgName(1:18).eq.'numerical_gradient') Then
         Call Put_iScalar('mp2prpt',0)
         DNG=.true.
         DoDens=.false.
         DoGrdt=.false.
      End If
*
      If(nSym .eq. 1) Then
         Call GetEnvF('EMIL_InLoop',emiloop)
         If (emiloop.eq.' ') emiloop='0'
         Call GetEnvF('MOLCAS_IN_GEO',inGeo)
         If ((emiloop(1:1).ne.'0') .and. inGeo(1:1) .ne. 'Y'
     &       .and. .not.DNG) Then
            Call Put_iScalar('mp2prpt',2)
            DoDens=.true.
            DoGrdt=.true.
         End If
      End If

      If (LumOrb) Then
         Lu_orb=7
         Call DaName(Lu_orb,'INPORB')
         l_Occup=nOrb(1)
         Do iSym=2,nSym
            l_Occup=l_Occup+nOrb(iSym)
         End Do
         Call GetMem('Occup','Allo','Real',ip_Occup,l_Occup)
         Call RDVEC('INPORB',Lu_orb,'COE',nSym,nBas,nOrb,CMO,
     &                       Work(ip_Occup),Eall,iDummy,
     &                       VecTitle,0,iErr)
         If (iErr.ne.0) Then
            Write(6,'(A,I4)') 'ERROR: RdVec returned code',iErr
            Call Abend()
         End If
         Call DaClos(Lu_orb)
         write(6,*)
         write(6,*) ' Input Orbitals read from INPORB: ',VecTitle
         If (.not.ERef_UsrDef) Then
            Write(6,*) ' WARNING: reference energy read from RunFile'
            Write(6,*) '          (may not correspond to orbitals)'
            Call Get_dScalar('SCF energy',Escf)
         End If
         write(6,*)
         iErr=0
         ip=ip_Occup-1
         Do iSym=1,nSym
            iCount=0
            Do i=1,nOrb(iSym)
               ip=ip+1
               If (abs(Work(ip)).gt.1.0d-14) iCount=iCount+1
            End Do
            If (iCount.ne.nOcc(iSym)) Then
               iErr=iErr+1
               Write(6,'(A,I2,A,I6,A,I6)')
     &         'WARNING: number of occupied orbitals in symmetry',iSym,
     &         ' is',iCount,' according to INPORB; from RunFile:',
     &         nOcc(iSym)
            End If
         End Do
         If (iErr.ne.0) Then
            Write(6,'(A,A)')
     &      'WARNING: occupation mismatch between RunFile and INPORB. ',
     &      'RunFile occupation will be used:'
            Write(6,'(8I6)') (nOcc(iSym),iSym=1,nSym)
            iErr=0
         End If
         Call GetMem('Occup','Free','Real',ip_Occup,l_Occup)
      Else
         Call Get_dScalar('SCF energy',Escf)
      EndIf
*
      If (lFre .and. nFre.gt.0) Then ! freeze lowest occupied orbitals
         FrePrt = iPrt.gt.0
         Call Freezer(Eall,nFre,nFro,nFro1,nOcc,nBas,nSym,FrePrt)
      End If
      Do iSym=1,nSym
         nFro(iSym)=nFro(iSym)+nFro1(iSym)
         nOcc(iSym)=nOcc(iSym)-nFro1(iSym)
         nDel(iSym)=nDel(iSym)+nDel1(iSym)
         nExt(iSym)=nExt(iSym)-nDel1(iSym)
         nOrb(iSym)=nOrb(iSym)-nDel1(iSym)
      End Do
      Call Put_iArray('nFroPT',NFRO,NSYM)
      Call Put_iArray('nDelPT',NDEL,NSYM)
      jOcc=0
      iExt=0
      iCount=0
      nOccT = 0
      nExtT = 0
      Do i= 1, nSym
         nOccT = nOccT + nOcc(i)
         nExtT = nExtT + nExt(i)
      End Do
*
      Do iSym=1,nSym
         iLow=iCount+nFro(iSym)+1
         iUpp=iLow+nOcc(iSym)-1
         Do i=iLow,iUpp
            jOcc=jOcc+1
            Eocc(jOcc)=Eall(i)
         End Do
         iLow=iUpp+1
         iUpp=iLow+nExt(iSym)-1
         Do i=iLow,iUpp
            iExt=iExt+1
            Eext(iExt)=Eall(i)
         End Do
         iCount=iCount+nBas(iSym)
      End Do
      iCount = 0
*
      If(DoDens) Then
         jFro = 0
         jDel = 0
         Do iSym = 1, nSym
*
            iLow = iCount+1
            iUpp = iLow+nFro(iSym)-1
            Do i = iLow, iUpp
               jFro=jFro+1
               EOcc(jFro+nOccT)= Eall(i)
            End Do
            iLow = iCount+nFro(iSym)+nOcc(iSym)+nExt(iSym)+1
            iUpp = iLow + nDel(iSym)-1
            Do i = iLow, iUpp
               jDel = jDel +1
               Eext(jDel+nExtT) = Eall(i)
            End Do
            iCount = iCount + nBas(iSym)
         End Do
      End If
      If ( lSFro .or. lSDel ) then
         LC=0
         LEO=0
         LEE=0
         LSQ=0
         Do iSym=1,nSym
            LC=LC+nBas(iSym)**2
            LSQ=Max(LSQ,nBas(iSym))
            LEO=LEO+nOcc(iSym)
            LEE=LEE+nExt(iSym)
         End Do
         Call GetMem('C','ALLO','REAL',IADC,LC)
         Call GetMem('EO','ALLO','REAL',IADEO,LEO)
         Call GetMem('EE','ALLO','REAL',IADEE,LEE)
         Call GetMem('SQ','ALLO','INTE',IADSQ,LSQ)
         call dcopy_(LC,CMO,1,WORK(IADC),1)
         call dcopy_(LEO,Eocc,1,WORK(IADEO),1)
         call dcopy_(LEE,Eext,1,WORK(IADEE),1)
         Call FrzDel(nFro2,iFro,Eocc,WORK(IADEO),
     &               nDel2,iDel,Eext,WORK(IADEE),
     &               CMO,WORK(IADC),IWORK(IADSQ))
         Call GetMem('SQ','FREE','INTE',IADSQ,LSQ)
         Call GetMem('EE','FREE','REAL',IADEE,LEE)
         Call GetMem('EO','FREE','REAL',IADEO,LEO)
         Call GetMem('LC','FREE','REAL',IADC,LC)
      End If
*----------------------------------------------------------------------*
*     Normal termination                                               *
*----------------------------------------------------------------------*
*
*     remove local copy of standard input
*
      Call Close_LuSpool(LuSpool)
*
      If (LumOrb .and. DoT1amp) Then
         Write (6,'(/,A)') 'ERROR!  Keywords incompatibility.'
         Write (6,'(/,A)') 'Both LUMOrb and T1AM were selected.'
         Write (6,'(/,A)') '***  I must shut down MBPT2 ! ***'
         Call Abend()
      EndIf
*
      If (all_Vir .and. DoMP2) Then
         Write (6,'(/,A)') 'WARNING!'
         Write (6,'(/,A)') 'Both VirAll and DoMP2 were selected.'
         Write (6,'(/,A)') '***  I turn off DoMP2 ! ***'
         DoMP2=.false.
      EndIf
*
*     turn off decomposition for parallel runs.
*
      If (DecoMP2 .and. ChoMP2_ChkPar()) Then
         Write (6,'(/,A)') 'WARNING!'
         Write (6,'(A)') 'Decomposition of MP2 integrals is not '
     &              //'possible. Turning off decomposition.'
         DecoMP2=.false.
      End If
*
      Call xFlush(6)
*
      Return
*----------------------------------------------------------------------*
*     Error Exit                                                       *
*----------------------------------------------------------------------*
995   Write (6,*) 'RdInp: Error while reading input!'
      Write (6,'(A,A)') 'Last read line:',Line
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! PAM2009 Who wrote this? What purpose?
subroutine Check_InVec(InVec)

#ifdef _MOLCAS_MPP_
use Para_Info, only: nProcs, Is_Real_Par
use Definitions, only: u6
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: InVec
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: InVec_Tot, mProcs

if (.not. Is_Real_Par()) return
InVec_Tot = InVec
call GAIGOP_SCAL(InVec_Tot,'+')
if (InVec_Tot /= 0) then
  if (InVec == 0) then
    mProcs = -1
  else
    mProcs = InVec_Tot/InVec
  end if
  if (mProcs /= nProcs) then
    write(u6,*) 'Check_InVec: different orbital options on different nodes'
    write(u6,*) 'Sets InVec to 0'
    InVec = 0
  end if
end if

#else

#include "macros.fh"
unused_var(InVec)

#endif

end subroutine Check_InVec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Thomas Bondo Pedersen                            *
!               2011, Roland Lindh                                     *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine OneEl_IJ(iS,jS,iPrint,Do_PGamma,xZeta,xZI,xKappa,xPCoor,Kernel,KrnlMm,Label,lOper,nComp,CoorO,nOrdOp,iChO,iStabO, &
                    nStabO,nIC,PtChrg,nGrid,iAddPot,SOInt,l_SOInt,rFinal,nFinal,Scrtch,nScrtch,ScrSph,nScrSph,Kern,nKern)
! Thomas Bondo Pedersen and Roland Lindh, February 2011.
!
! Purpose: compute symmetry adapted one-electron integrals for
!          shell doublet iS, jS.

use Index_Functions, only: nTri_Elem1
use Real_Spherical, only: ipSph, rSph
use iSD_data, only: iSD
use Basis_Info, only: DBSC, MolWgh, Shells
use Center_Info, only: DC
use Sizes_of_Seward, only: S
use Gateway_Info, only: FNMC
use Symmetry_Info, only: ChOper, nIrrep
use rmat, only: RMat_Type_Integrals
use define_af, only: AngTp
use property_label, only: PLabel
use Molcas, only: LenIn, MxAtom
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iS, jS, iPrint, nComp, lOper(nComp), nOrdOp, iChO(nComp), iStabO(0:7), nStabO, nIC, nGrid, &
                                 iAddPot, l_SOInt, nFinal, nScrtch, nScrSph, nKern
logical(kind=iwp), intent(inout) :: Do_PGamma
real(kind=wp), intent(inout) :: xZeta(*), xZI(*)
real(kind=wp), intent(_OUT_) :: xKappa(*), xPCoor(*)
procedure(int_kernel) :: Kernel
procedure(int_mem) :: KrnlMm
character(len=8), intent(in) :: Label
real(kind=wp), intent(in) :: CoorO(3,nComp), PtChrg(nGrid)
real(kind=wp), intent(out) :: SOInt(l_SOInt), Scrtch(nScrtch), ScrSph(nScrSph)
real(kind=wp), target, intent(out) :: rFinal(nFinal), Kern(nKern)
integer(kind=iwp) :: i, iab, iAng, iAO, iAtom, iBas, iCmp, iCnt, iCnttp, iComp, iDCRR(0:7), iDCRT(0:7), ii, iiC, iIrrep, ipFnl, &
                     iPrim, ipX, ipY, ipZ, iShell, iShll, iSmLbl, iSOBlk, iStabM(0:7), iuv, jAng, jAO, jBas, jCmp, jCnt, jCnttp, &
                     jPrim, jShell, jShll, kk, l_Coord, lA0, lA1, LambdT, lB0, lB1, lDCRR, lFinal, Lmbdr, lScrSph, lScrtch, mdci, &
                     mdcj, MemAux, MemBux, MemCux, MemKer, MemKrn, mSO, nAtoms, nDCRR, nDCRT, nij, nijab, nOp(2), nOrder, NrOpr, &
                     nSO, nStabM
real(kind=wp) :: A(3), B(3), Coord(3*MxAtom), Fact, RB(3), xFactor, xMass
character(len=LenIn) :: dbas
#ifdef _GEN1INT_
logical(kind=iwp) :: DO_TRAN, NATEST
#endif
integer(kind=iwp), external :: MemSO1
logical(kind=iwp), external :: EQ

!                                                                      *
!***********************************************************************
!                                                                      *
if (Label(1:3) == 'MAG') then
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iAO = iSD(7,iS)
  iShell = iSD(11,iS)
  jCmp = iSD(2,jS)
  jBas = iSD(3,jS)
  jAO = iSD(7,jS)
  jShell = iSD(11,jS)
  nSO = 0
  B(:) = Zero
  do iComp=1,nComp
    iSmLbl = lOper(iComp)
    nSO = nSO+MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
  end do
  if (iPrint >= 29) write(u6,*) ' nSO=',nSO
  if (nSO < 1) return
  if (l_SOInt < nSO*iBas*jBas) then
    call WarningMessage(2,'OneEl_IJ: insufficient SOInt dimension!')
    call Abend()
  end if
  SOInt(1:nSO*iBas*jBas) = Zero
  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iPrim = iSD(5,iS)
  mdci = iSD(10,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
  dbas = dc(mdci)%LblCnt(1:LenIn)
  call UpCase(dbas)
  jShll = iSD(0,jS)
  jAng = iSD(1,jS)
  jPrim = iSD(5,jS)
  mdcj = iSD(10,jS)
  jCnttp = iSD(13,jS)
  jCnt = iSD(14,jS)
  B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
  if (iPrint >= 19) then
    write(u6,*) 'interacted Ato.Fun '
    write(u6,'(A,A,A,A,A)') ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
  end if
  lFinal = nIC*S%MaxPrm(iAng)*S%MaxPrm(jAng)*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  if (lFinal > nFinal) then
    call WarningMessage(2,'lFinal > nFinal')
    call Abend()
  end if
  rFinal(1:lFinal) = Zero
  call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
  call Inter(dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iStabM,nStabM)
  call DCR(LambdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
  if (iPrint >= 19) then
    write(u6,*)
    write(u6,*) ' g      =',nIrrep
    write(u6,*) ' u      =',dc(mdci)%nStab
    write(u6,'(9A)') '(U)=',(ChOper(dc(mdci)%iStab(ii)),ii=0,dc(mdci)%nStab-1)
    write(u6,*) ' v      =',dc(mdcj)%nStab
    write(u6,'(9A)') '(V)=',(ChOper(dc(mdcj)%iStab(ii)),ii=0,dc(mdcj)%nStab-1)
    write(u6,*) ' LambdaR=**',LmbdR
    write(u6,*) ' r      =',nDCRR
    write(u6,'(9A)') '(R)=',(ChOper(iDCRR(ii)),ii=0,nDCRR-1)
    write(u6,*) ' m      =',nStabM
    write(u6,'(9A)') '(M)=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
  end if
  nOp(1) = NrOpr(0)
  if (nDCRR >= 1) then
    do lDCRR=0,nDCRR-1
      call OA(iDCRR(lDCRR),B,RB)
      nOp(2) = NrOpr(iDCRR(lDCRR))
      if (iPrint >= 49) write(u6,'(A,3F6.2,2X,3F6.2)') '*',(A(i),i=1,3),(RB(i),i=1,3)

      call Get_nAtoms_All(nAtoms)
      l_Coord = 3*nAtoms
      call Get_dArray('Bfn Coordinates',Coord,l_Coord)
      if (nAtoms == 2) nAtoms = nAtoms+1
#     ifdef _GEN1INT_
      NATEST = (nAtoms == 2)
      if (label(4:5) == 'PX') then
        Do_Tran = .true.
      else
        Do_Tran = .false.
      end if
      read(Label(6:),'(I3)') iatom
      call test_f90mod_sgto_mag(iShell,jShell,iCmp,jCmp,iPrim,jPrim,iAng,jAng,iPrim,jPrim,mdci,mdcj,Shells(iShll)%Exp, &
                                Shells(jShll)%Exp,Shells(iShll)%Cff_p(1,1,2),Shells(jShll)%Cff_p(1,1,2),nAtoms,Coord,nComp,rFinal, &
                                .true.,iatom,Do_Tran)
#     else
      call WarningMessage(2,'OneEl_IJ: NO Gen1int interface available!')
      call Abend()
#     endif

      iSOBlk = 1
      iIC = 1
      do iComp=1,nComp
        iSmLbl = lOper(iComp)
        mSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
        if (mSO == 0) then
          do iIrrep=0,nIrrep-1
            if (btest(lOper(iComp),iIrrep)) iIC = iIC+1
          end do
        else
          !write(u6,*) "Symmetry adapt component"
          call SymAd1(iSmLbl,iAng,jAng,iCmp,jCmp,iShell,jShell,iShll,jShll,iAO,jAO,rFinal,iBas,jBas,nIC,iIC,SOInt(iSOBlk),mSO,nOp)
          iSOBlk = iSOBlk+mSO*iBas*jBas
        end if
      end do
    end do
  end if

else  !  MAG Integrals

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Check memory for SO integrals that will be generated by
  ! this batch of AO integrals. Init SOInt.

  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iAO = iSD(7,iS)
  iShell = iSD(11,iS)
  jCmp = iSD(2,jS)
  jBas = iSD(3,jS)
  jAO = iSD(7,jS)
  jShell = iSD(11,jS)
  nSO = 0
  do iComp=1,nComp
    iSmLbl = lOper(iComp)
    nSO = nSO+MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
  end do
  if (iPrint >= 29) write(u6,*) ' nSO=',nSO
  if (nSO < 1) return
  if (l_SOInt < nSO*iBas*jBas) then
    call WarningMessage(2,'OneEl_IJ: insufficient SOInt dimension!')
    call Abend()
  end if
  SOInt(1:nSO*iBas*jBas) = Zero

  ! Shell info

  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iPrim = iSD(5,iS)
  mdci = iSD(10,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
  dbas = dc(mdci)%LblCnt(1:LenIn)
  call UpCase(dbas)

  jShll = iSD(0,jS)
  jAng = iSD(1,jS)
  jPrim = iSD(5,jS)
  mdcj = iSD(10,jS)
  jCnttp = iSD(13,jS)
  jCnt = iSD(14,jS)
  B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

  ! Identify if shell doublet should be computed with special
  ! R-Matrix code.

  if ((iCnttp == jCnttp) .and. (mdcj == mdci) .and. (dbas == 'DBAS')) then
    RMat_type_integrals = .true.
    if (Do_PGamma) then
      call PGamma()
      Do_PGamma = .false.
    end if
  else
    RMat_type_integrals = .false.
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (iPrint >= 19) then
    write(u6,*) 'interacted Ato.Fun '
    write(u6,'(A,A,A,A,A)') ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Call kernel routine to get memory requirement.

  call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)

  ! Special additional allocation for PCC integrals

  if (PLabel /= ' ') then
    la0 = iAng
    lb0 = jAng
    MemAux = 1+3*nTri_Elem1(la0)*nTri_Elem1(lb0+1)*nIC
    la1 = la0
    lb1 = lb0+1
    MemBux = 1+3*nTri_Elem1(la1+1)*nTri_Elem1(lb1)*nIC
    if (la1 /= 0) MemBux = MemBux+3*nTri_Elem1(la1-1)*nTri_Elem1(lb1)*nIC
    if (lb0 /= 0) then
      lb1 = lb0-1
      MemAux = MemAux+3*nTri_Elem1(la0)*nTri_Elem1(lb0-1)*nIC
      MemCux = 1+3*nTri_Elem1(la1+1)*nTri_Elem1(lb1)*nIC
      if (la1 /= 0) MemCux = MemCux+3*nTri_Elem1(la1-1)*nTri_Elem1(lb1)*nIC
    else
      MemCux = 0
    end if
    MemAux = MemAux+max(MemBux,MemCux)
    MemKer = MemKer+MemAux
  end if

  MemKrn = MemKer*iPrim*jPrim
  if (MemKrn > nKern) then
    call WarningMessage(2,'MemKrn > nKern')
    write(u6,*) 'nOrdOp,iAng,jAng=',nOrdOp,iAng,jAng
    write(u6,*) 'MemKrn=',MemKrn
    write(u6,*) 'nKern=',nKern
    call Abend()
  end if
  Kern(1:MemKrn) = Zero
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Allocate memory for the final integrals all in the
  ! primitive basis.

  lFinal = nIC*iPrim*jPrim*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  if (lFinal > nFinal) then
    call WarningMessage(2,'lFinal > nFinal')
    call Abend()
  end if
  rFinal(1:lFinal) = Zero
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Scratch area for contraction step

  lScrtch = max(iPrim,jPrim)*max(iBas,jBas)*nIC*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  if (lScrtch > nScrtch) then
    call WarningMessage(2,'lScrtch > nScrtch')
    call Abend()
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Scratch area for the transformation to spherical gaussians

  lScrSph = nIC*iBas*jBas*nTri_Elem1(iAng)*nTri_Elem1(jAng)
  if (lScrSph > nScrSph) then
    call WarningMessage(2,'lScrSph > nScrSph')
    call Abend()
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! At this point we can compute Zeta.
  ! This is now computed in the ij or ji order.

  call ZXia(xZeta,xZI,iPrim,jPrim,Shells(iShll)%Exp,Shells(jShll)%Exp)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Find the DCR for A and B

  call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)

  ! Find the stabilizer for A and B

  call Inter(dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iStabM,nStabM)

  call DCR(LambdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

# ifdef _DEBUGPRINT_
  if (iPrint >= 19) then
    write(u6,*)
    write(u6,*) ' g      =',nIrrep
    write(u6,*) ' u      =',dc(mdci)%nStab
    write(u6,'(9A)') '(U)=',(ChOper(dc(mdci)%iStab(ii)),ii=0,dc(mdci)%nStab-1)
    write(u6,*) ' v      =',dc(mdcj)%nStab
    write(u6,'(9A)') '(V)=',(ChOper(dc(mdcj)%iStab(ii)),ii=0,dc(mdcj)%nStab-1)
    write(u6,*) ' LambdaR=**',Lmbd
    write(u6,*) ' r      =',nDCRR
    write(u6,'(9A)') '(R)=',(ChOper(iDCRR(ii)),ii=0,nDCRR-1)
    write(u6,*) ' m      =',nStabM
    write(u6,'(9A)') '(M)=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
  end if
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute normalization factor

  iuv = dc(mdci)%nStab*dc(mdcj)%nStab
  if (MolWgh == 1) then
    Fact = real(nStabO,kind=wp)/real(LambdT,kind=wp)
  else if (MolWgh == 0) then
    Fact = real(iuv*nStabO,kind=wp)/real(nIrrep**2*LambdT,kind=wp)
  else
    Fact = sqrt(real(iuv,kind=wp))*real(nStabO,kind=wp)/real(nirrep*LambdT,kind=wp)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Loops over symmetry operations acting on the basis.

  nOp(1) = NrOpr(0)
  if (nDCRR >= 1) then
    do lDCRR=0,nDCRR-1
      call OA(iDCRR(lDCRR),B,RB)
      nOp(2) = NrOpr(iDCRR(lDCRR))
      if (iPrint >= 49) write(u6,'(A,3F6.2,2X,3F6.2)') '*',(A(i),i=1,3),(RB(i),i=1,3)

      ! Compute kappa and P.

      call Setup1(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,A,RB,xKappa,xPCoor,xZI)

      ! Compute primitive integrals. Result is ordered ij,ab.

      call Kernel(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,xZeta,xZI,xKappa,xPCoor,rFinal,iPrim*jPrim,nIC,nComp,iAng,jAng, &
                  A,RB,nOrder,Kern,MemKer,CoorO,nOrdOp,lOper,iChO,iStabM,nStabM,PtChrg,nGrid,iAddPot)
      if (iPrint >= 49) call RecPrt(' Primitive Integrals',' ',rFinal,iPrim*jPrim,nTri_Elem1(iAng)*nTri_Elem1(jAng)*nIC)

      ! Transform from primitive to contracted basis functions.

      if (iPrint >= 99) then
        call RecPrt(' Left side contraction',' ',Shells(iShll)%pCff,iPrim,iBas)
        call RecPrt(' Right side contraction',' ',Shells(jShll)%pCff,jPrim,jBas)
      end if

      ! Transform i,jabx to jabx,I
      kk = nTri_Elem1(iAng)*nTri_Elem1(jAng)
      call DGEMM_('T','N',jPrim*kk*nIC,iBas,iPrim,One,rFinal,iPrim,Shells(iShll)%pCff,iPrim,Zero,Scrtch,jPrim*kk*nIC)
      ! Transform j,abxI to abxI,J
      call DGEMM_('T','N',kk*nIC*iBas,jBas,jPrim,One,Scrtch,jPrim,Shells(jShll)%pCff,jPrim,Zero,ScrSph,kk*nIC*iBas)

      if (iPrint >= 99) call RecPrt(' Contracted integrals in cartesians',' ',ScrSph,kk*nIC,iBas*jBas)

      ! Transform to spherical gaussians if needed.

      if (Shells(iShll)%Transf .or. Shells(jShll)%Transf) then
        ! Result comes back as xIJAB or xIJAb
        call CarSph(ScrSph,kk,iBas*jBas*nIC,rFinal,lScrSph,RSph(ipSph(iAng)),iAng,Shells(iShll)%Transf,Shells(iShll)%Prjct, &
                    RSph(ipSph(jAng)),jAng,Shells(jShll)%Transf,Shells(jShll)%Prjct,Scrtch,iCmp*jCmp)
        call DGeTmO(Scrtch,nIC,nIC,iBas*jBas*iCmp*jCmp,rFinal,iBas*jBas*iCmp*jCmp)
      else
        ! Transpose abx,IJ back to IJ,abx
        call DGeTmO(ScrSph,kk*nIC,kk*nIC,iBas*jBas,rFinal,iBas*jBas)
      end if
      if (iPrint >= 99) call RecPrt(' Contracted integrals in Sphericals',' ',rFinal,iBas*jBas,iCmp*jCmp*nIC)

      ! Tweak here for special cases

      ipFnl = 1
      if (Label == 'P_matrix') then
        nij = iBas*jBas
        nijab = nij*iCmp*jCmp
        do iab=1,iCmp*jCmp
          ipx = ipFnl+(iab-1)*nij
          ipy = ipx+nijab
          ipz = ipy+nijab
          rFinal(ipx:ipx+nij-1) = xPCoor(1:nij)
          rFinal(ipy:ipy+nij-1) = xPCoor(nij+1:2*nij)
          rFinal(ipz:ipz+nij-1) = xPCoor(2*nij+1:3*nij)
        end do
      else if (Label == 'FMMCnX') then
        rFinal(ipFnl:ipFnl+iBas*jBas*iCmp*jCmp*nIC-1) = Half*(A(1)+RB(1))
      else if (Label == 'FMMCnY') then
        rFinal(ipFnl:ipFnl+iBas*jBas*iCmp*jCmp*nIC-1) = Half*(A(2)+RB(2))
      else if (Label == 'FMMCnZ') then
        rFinal(ipFnl:ipFnl+iBas*jBas*iCmp*jCmp*nIC-1) = Half*(A(3)+RB(3))
      else if (Label == 'Kinetic') then

        ! multiply with 1/m, where m is the mass of an electron or muon.

        xfactor = One/dbsc(iCnttp)%fMass

        ! Add the Finite Nuclear Mass Correction if activated

        if (FNMC .and. EQ(A,B) .and. (dbsc(iCnttp)%Charge /= Zero)) then
          iAtom = dbsc(iCnttp)%AtmNr
          ! Get the atom mass in au (me=1)
          xMass = dbsc(iCnttp)%CntMass
          ! Substract the electron mass to get the nuclear mass.
          xMass = xMass-real(iAtom,kind=wp)
          !write(u6,*) 'xMass=',xMass
          xfactor = xfactor+One/xMass
        end if
        !write(u6,*) 'xfactor=',xfactor
        rFinal(1:iBas*jBas*iCmp*jCmp) = xfactor*rFinal(1:iBas*jBas*iCmp*jCmp)
      end if

      ! At this point accumulate the batch of integrals onto the
      ! final symmetry adapted integrals.

      if (iPrint >= 99) call RecPrt(' Accumulated SO integrals, so far...',' ',SOInt,iBas*jBas,nSO)

      ! Symmetry adapt component by component

      iSOBlk = 1
      iIC = 1
      do iComp=1,nComp
        iSmLbl = lOper(iComp)
        mSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
        if (mSO == 0) then
          do iIrrep=0,nIrrep-1
            if (btest(lOper(iComp),iIrrep)) iIC = iIC+1
          end do
        else
          call SymAd1(iSmLbl,iAng,jAng,iCmp,jCmp,iShell,jShell,iShll,jShll,iAO,jAO,rFinal,iBas,jBas,nIC,iIC,SOInt(iSOBlk),mSO,nOp)
          iSOBlk = iSOBlk+mSO*iBas*jBas
        end if
      end do
    end do
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Multiply with factors due to projection operators

  if (Fact /= One) SOInt(1:nSO*iBas*jBas) = Fact*SOInt(1:nSO*iBas*jBas)
  if (iPrint >= 99) then
    write(u6,*) ' Scaling SO''s',Fact
    call RecPrt(' Accumulated SO integrals',' ',SOInt,iBas*jBas,nSO)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *

end if

return

end subroutine OneEl_IJ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PCMDFck(nFck,PCMFck)
      use PCM_arrays
      Implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "Molcas.fh"
#include "rctfld.fh"
#include "periodic_table.fh"
      Dimension PCMFck(nFck,*)
      Character*2 Elements(MxAtom*8)
      Logical DoPot, DoFld
*
************************************************************************
*
*     Driver for the computation of PCM contributions to Fock matrix
*     derivatives
*
C
C     Retrieve atomic info
      Call Get_nAtoms_All(nAtoms)
      Call Allocate_Work(ipCoor,3*nAtoms)
      Call Get_Coord_All(Work(ipCoor),nAtoms)
      Call Get_Name_All(Elements)
      Call GetMem('ANr','Allo','Inte',ipANr,nAtoms)
      Do i = 1, nAtoms
         Do j = 0, Num_Elem
            If (PTab(j).eq.Elements(i)) iWork(ipANr+i-1)=j
         End Do
      End Do
      Call GetMem('Chrg','Allo','Real',ipChrg,nAtoms)
      Call Get_dArray('Nuclear charge',Work(ipChrg),nAtoms)
C
C     Allocate space for total charges
      Call GetMem('Qtot','Allo','Real',ip_Qtot,nTs)
C
C     Allocate space for the PCM matrix derivative
      Call GetMem('DerMat','Allo','Real',ip_DerMat,nTs*nTs)
C
C     Allocate space for the potential on tesserae
      Call GetMem('V','Allo','Real',ip_V,nTs)
C
C     Allocate space for the uncontracted potential on tesserae
      Call GetMem('VMN','Allo','Real',ip_VMN,nTs*nFck)
C
C     Allocate space for the potential derivatives
      nAt3 = nAtoms * 3
      Call GetMem('VDer','Allo','Real',ip_VDer,nAt3*nTs)
C
C     Allocate space for the uncontracted derivatives of the
C     potential on tesserae
      Call GetMem('VDerMN','Allo','Real',ip_VDerMN,nAt3*nTs*nFck)
C
C     Allocate space for electric field
      nComp=3
      Call GetMem('EF_n','Allo','Real',ip_EF_n,nComp*nTs)
      Call GetMem('EF_e','Allo','Real',ip_EF_e,nComp*nTs)
C
C     Allocate two scratch vectors
      Call GetMem('Temp1','Allo','Real',ip_Temp1,nTs)
      Call GetMem('Temp2','Allo','Real',ip_Temp2,nTs)

C
      Call FZero(PCMFck,nAt3*nFck)
C
C     Compute the potential and the electric field on tesserae
      DoPot = .True.
      DoFld = .True.
      Call V_EF_PCM(nAtoms,nTs,DoPot,DoFld,Work(ipCoor),PCMTess,
     &     Work(ip_V),Work(ip_EF_n),Work(ip_EF_e))
C
C     Compute the derivatives of the total potential on tesserae
      Call VDer_PCM(nAtoms,nTs,nS,Work(ipCoor),Work(ipChrg),
     &              Work(ip_EF_n),Work(ip_EF_e),PCMTess,PCMiSph,
     &              dTes,dPnt,dRad,dCntr,Work(ip_VDer))
C
C     Actually compute the PCM correction
      Call PCM_Der_Fock(nFck,nAtoms,nTs,nS,Eps,PCMSph,
     &                  PCMiSph,PCM_N,PCMTess,PCM_SQ,
     &                  Work(ip_Qtot),PCMDM,Work(ip_DerMat),
     &                  dTes,dPnt,dCntr,Work(ip_V),Work(ip_VMN),
     &                  Work(ip_VDer),Work(ip_VDerMN),Work(ip_Temp1),
     &                  Work(ip_Temp2),PCMFck)
C
C     Free the space
      Call GetMem('Qtot','Free','Real',ip_Qtot,nTs)
      Call GetMem('V','Free','Real',ip_V,nTs)
      Call GetMem('VMN','Free','Real',ip_VMN,nTs*nFck)
      Call GetMem('VDer','Free','Real',ip_VDer,nAt3*nTs)
      Call GetMem('VDerMN','Free','Real',ip_VDerMN,nAt3*nTs*nFck)
      Call GetMem('EF_n','Free','Real',ip_EF_n,nComp*nTs)
      Call GetMem('EF_e','Free','Real',ip_EF_e,nComp*nTs)
      Call GetMem('Temp1','Free','Real',ip_Temp1,nTs)
      Call GetMem('Temp2','Free','Real',ip_Temp2,nTs)
      Return
      End
*
************************************************************************
*
      Subroutine PCM_Der_Fock(nFck,nAt,nTs,nS,Eps,Sphere,ISphe,nOrd,
     &           Tessera,Q,Qtot,DM,DerDM,DerTes,DerPunt,DerCentr,
     &           V,VMN,VDer,VDerMN,Temp1,Temp2,PCMFck)
      Implicit real*8 (a-h,o-z)
#include "real.fh"
      Dimension Sphere(4,*),ISphe(*),nOrd(*),Temp1(*),Temp2(*)
      Dimension Tessera(4,*),Q(2,*),Qtot(*),DM(nTs,*),DerDM(nTs,*)
      DImension V(*),VMN(nTs,*)
      Dimension VDer(nTs,*),VDerMN(nTs,nFck,*),PCMFck(nFck,*)
      Dimension DerTes(nTs,nAt,3),DerPunt(nTs,nAt,3,3)
      Dimension DerCentr(nS,nAt,3,3)
C
      FPI = Four*PI
      Diag = - 1.0694d0 * Sqrt(FPI) / Two
      Sc_Cond = (Eps - One) / Eps
C
      Do iTs = 1, nTs
        Qtot(iTs) = Q(1,iTs) + Q(2,iTs)
      EndDo
C
C     Loop over the degrees of freedom
      Do 100 iAt = 1, nAt
        Do 101 iC = 1, 3
          Index = 3 * (iAt-1) + iC
C
C         Derivative of the PCM matrix for the conductor-like case
          Call DMat_CPCM(iAt,iC,Eps,nTs,nS,nAt,Diag,Tessera,
     &                   DerDM,DerTes,DerPunt,DerCentr,iSphe)
C
C         Solvation charges (weights) times the derivative of the PCM matrix
          Call PrMatVec(.True.,.True.,DerDM,-1.d0,nTs,nTs,
     &         QTot,Temp1)
C
C         The previous vector times the inverted PCM matrix
          Call PrMatVec(.True.,.True.,DM,1.d0,nTs,nTs,
     &         Temp1,Temp2)
C
C         Derivative of the potential times the inverted PCM matrix
          Call PrMatVec(.True.,.True.,DM,1.d0,nTs,nTs,
     &         VDer(1,Index),Temp1)
C
C         Loop over the Fock elements
          Do 200 iFck = 1, nFck
C
C------
C           First contribution: charges times the derivative of the
C           (uncontracted) electronic potential: Sum_i q_i V_mn^(i,x)
            Sum = Zero
            Do iTs = 1, nTs
              Sum = Sum + Qtot(iTs) * VDerMN(iTs,iFck,Index)
            EndDo
            PCMFck(iFck,Index) = PCMFck(iFck,Index) + Sum
C------
C           Second contribution: derivative of the potential times the
C           (symmetrized) PCM matrix times the uncontracted potential:
C           Sum_ij V_i^x Q_ij V_mn^j
            Sum = Zero
            Do iTs = 1, nTs
              Sum = Sum + Temp1(iTs) * VMN(iTs,iFck)
            EndDo
            PCMFck(iFck,Index) = PCMFck(iFck,Index) + Sum
C------
C           Third contribution: potential times the derivative of
C           the inverted PCM matrix times the uncontracted potential:
C           Sum_ij V_i Q_ij^x V_mn^j = Sum_ij V_i [-S^-1 S^x S^-1]_ij V_mn^j =
C           Sum_ij q_i [S^x S^-1]_ij V_mn^j
            Sum = Zero
            Do iTs = 1, nTs
              Do jTs = 1, nTs
                Sum = Sum + Temp2(iTs) * VMN(jTs,iFck)
              EndDo
            EndDo
            PCMFck(iFck,Index) = PCMFck(iFck,Index) + Sum
  200     Continue
  101   Continue
  100 Continue
C
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(Sphere)
        Call Unused_integer_array(nOrd)
        Call Unused_real_array(V)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Jie J. Bao                                       *
************************************************************************
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Aug. 06, 2020, created this file.               *
* ****************************************************************
      Subroutine Calcbk(bk,R,nTri,GDMat,zX)
      use stdalloc, only : mma_allocate, mma_deallocate
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "sa.fh"

******Output
      Real*8,DIMENSION(nDens2)::bk
******Input
      Real*8,DIMENSION(nRoots**2)::R
      INTEGER nTri
      Real*8,DIMENSION((nRoots-1)*nRoots/2)::zX
      Real*8,DIMENSION(nRoots*(nRoots+1)/2,nnA,nnA)::GDMat
******Auxiliaries
      Real*8,DIMENSION(:),Allocatable::FOccMO,P2MOt
      INTEGER nP2,nG1
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

      ng1=itri(ntash,ntash)
      nP2=itri(ng1,ng1)
      CALL mma_allocate(FOccMO,nDens2)
      CALL mma_allocate(P2MOt,nP2)
      CALL FZero(bk,nDens2)
      CALL GetWFFock(FOccMO,bk,R,nTri,P2MOt,nP2)
      CALL GetQaaFock(FOccMO,P2MOt,GDMat,zX,nP2)
      CALL GetPDFTFock(bk)
      CALL PutCMSFockOcc(FOccMO,nTri)
*
      CALL mma_deallocate(FOccMO)
      CALL mma_deallocate(P2MOt)

      RETURN
      end subroutine
******************************************************

******************************************************
      Subroutine PutCMSFockOcc(FOccMO,nTri)
      use stdalloc, only : mma_allocate, mma_deallocate
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "sa.fh"
******Output:none
******Input:
      INTEGER nTri
      Real*8,DIMENSION(nDens2)::FOccMO
******Auxiliaries
      Real*8,DIMENSION(:),Allocatable::F,T,F_n
      INTEGER ijb,iS,iB,jB
      CALL mma_allocate(F,nDens2)
      CALL mma_allocate(T,nDens2)
      CALL mma_allocate(F_n,nDens2)

      CALL FZero(F,nDens2)
      CALL FZero(F_n,nDens2)
      CALL Get_Fock_Occ(F,nTri)
***** WF Part
      CALL DCopy_(nDens2,FOccMO,1,T,1)
      CALL TCMO(T,1,-2)
      ijb=0
      DO iS=1,nSym
       do ib=1,nbas(is)
        do jb=1,ib-1
         ijb=ijb+1
         F_n(ijb)=T(ipmat(is,is)+nbas(is)*(JB-1)+IB-1)
     &                +T(ipmat(is,is)+nbas(is)*(IB-1)+JB-1)
        end do
        ijb=ijb+1
        F_n(ijb)=T(ipmat(is,is)+nbas(is)*(iB-1)+IB-1)
       end do
      END DO
      CALL Daxpy_(nDens2,1.0d0,F_n,1,F,1)
      CALL Put_Fock_Occ(F,nDens2)
      CALL mma_deallocate(F)
      CALL mma_deallocate(T)
      CALL mma_deallocate(F_n)
      RETURN
      end subroutine
******************************************************
******************************************************
      Subroutine GetPDFTFock(bk)
      use stdalloc, only : mma_allocate, mma_deallocate
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "sa.fh"
******Output
      Real*8,DIMENSION(nDens2)::bk
******Input
******Auxiliaries
      Real*8,DIMENSION(:),Allocatable::T,FT99,bktmp
      INTEGER IS,JS
      CALL mma_allocate(FT99,nDens2)
      CALL mma_allocate(bktmp,nDens2)
      CALL mma_allocate(T,nDens2)
      CALL Get_DArray('FxyMS           ',FT99 ,nDens2)
      CALL dcopy_(nDens2,FT99,1,T,1)
      DO IS=1,nSym
         jS=iEOR(iS-1,0)+1
         If (nBas(is)*nBas(jS).ne.0) then
           Call DGeSub(T(ipMat(iS,jS)),nBas(iS),'N',
     &                 T(ipMat(jS,iS)),nBas(jS),'T',
     &                 bktmp(ipMat(iS,jS)),nBas(iS),
     &                 nBas(iS),nBas(jS))
         End If
      END DO
      CALL daxpy_(nDens2,-2.0d0,bktmp,1,bk,1)
      CALL mma_deallocate(T)
      CALL mma_deallocate(FT99)
      CALL mma_deallocate(bktmp)
      RETURN
      end subroutine
******************************************************
******************************************************
      Subroutine GetWFFock(FOccMO,bk,R,nTri,P2MOt,NG2)
******Partially readpated from rhs_sa.f
      use stdalloc, only : mma_allocate, mma_deallocate
      use ipPage, only: W
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "sa.fh"
#include "real.fh"
******Input
      Real*8,DIMENSION(nRoots**2)::R
      INTEGER nTri,NG2
******Output
      Real*8,DIMENSION(nDens2)::FOccMO
      Real*8,DIMENSION(nDens2)::bk
      Real*8,DIMENSION(nG2)::P2MOt
******Auxiliaries
      Real*8,DIMENSION(:),Allocatable::FinCI
*     FinCI: CI Vectors in final CMS state basis
      Real*8,DIMENSION(1)::rdum
      Real*8,DIMENSION(:),Allocatable::Fock,T,G1r,G2r,G2rt,
     & CIL,CIR,G1q,G2q,G1qs,G2qs
      Real*8,DIMENSION(:),Allocatable::DMatAO,DIAO,D5,D6
      INTEGER I,K,NCSFs
      Real*8 Fact
      INTEGER iB,jB,kB,lB,iDkl,iRijkl
************************************************************************
*                                                                      *
       itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
       ng1=itri(ntash,ntash)
       ng2=itri(ng1,ng1)

       Call mma_allocate(FinCI,nconf1*nroots,Label='FinCI')
       Call mma_allocate(Fock,ndens2,Label='Fock')
       Call mma_allocate(T,ndens2,Label='T')
       Call mma_allocate(G1q,ng1,Label='G1q')
       Call mma_allocate(G2q,ng2,Label='G2q')
       Call mma_allocate(G1r,ntash**2,Label='G1r')
       Call mma_allocate(G2r,itri(ntash**2,ntash**2),Label='G2r')
       Call mma_allocate(G2rt,itri(ntash**2,ntash**2),Label='G2rt')
*******Rotate CI vectors back to those for reference states
       NCSFs=NCSF(state_sym)
       CALL DGEMM_('n','n',NCSFS,nRoots,nRoots,1.0d0,W(ipCI)%Vec,
     &             NCSFs,R,nRoots,0.0d0,FinCI,nCSFs)
       nConfL=Max(ncsf(state_sym),nint(xispsm(state_sym,1)))

       Call mma_allocate(CIL,nConfL)
       Call mma_allocate(CIR,nConfL)

       I=IRlxRoot
       Call CSF2SD(FinCI(1+(I-1)*NCSFs),CIL,state_sym)
       CALL DCopy_(nConfL,CIL,1,CIR,1)
       Call Densi2(2,G1r,G2rt,CIL,CIR,0,0,0,ntash**2,
     &              itri(ntash**2,ntash**2))
       Do iA=1,nnA
         Do jA=1,nnA
           Do kA=1,nnA
            Do la=1,nnA
             ij1=nnA*(iA-1)+ja
*             ij2=nna*(ja-1)+ia
             kl1=nnA*(ka-1)+la
             kl2=nna*(la-1)+ka
       if(iA.eq.jA.or.kA.eq.la) then
      G2r(itri(ij1,kl1))=G2rt(itri(ij1,kl1))
       else
      G2r(itri(ij1,kl1))=(G2rt(itri(ij1,kl1))+G2rt(itri(ij1,kl2)))/2.0d0
       end if
            End Do
           End Do
         End Do
       End Do
       Call FockGen(1.0d0,G1r,G2r,FOccMO,bk,1)

       Do iB=1,ntash
        Do jB=1,iB
        G1q(itri(ib,jb))= G1r(ib+(jb-1)*ntash)
        End Do
       End Do
*******D1MOt: CMS-PDFT 1RDM for computing 1-electron gradient
       Call Put_DArray('D1MOt           ',G1q,ng1)
       Do iB=1,ntash
        Do jB=1,ntash
         iDij=iTri(ib,jB)
         iRij=jb+(ib-1)*ntash
         Do kB=1,ntash
          Do lB=1,ntash
           iDkl=iTri(kB,lB)
           iRkl=lb+(kb-1)*ntash
           fact=One
           if(iDij.ge.iDkl .and. kB.eq.lB) fact=0.5d0
           if(iDij.lt.iDkl .and. iB.eq.jB) fact=0.5d0
           iijkl=itri(iDij,iDkl)
           iRijkl=itri(iRij,iRkl)
           G2q(iijkl)=Fact*G2r(iRijkl)
          End Do
         End Do
        End Do
       End Do
       Call Get_P2MOt(P2MOt,ng2)
       Call DaXpY_(ng2,1.0d0,G2q,1,P2MOt,1)

*******Done with the info from CMS final state

*******Doing some computation for computing non-active-active 2RDM in
*******integral_util/prepp.f
       Call mma_allocate(D5,nTri)
       Call mma_allocate(D6,nTri)
*******D5: Used in ptrans_sa when isym==jsym (PDFT parts cancel WF
*******    parts for intermediate states)
*******D6: Used in ptrans_sa when isym.ne.jsym (sum of inactive parts of
*******intermediate-state 1RDMs cancels that of the final state)
       Call mma_allocate(DMatAO,nTri)
       Call mma_allocate(DIAO,nTri)
       CALL Get_DArray('MSPDFTD5        ',DIAO,nTri)
       CALL Get_DArray('MSPDFTD6        ',D6,nTri)
       CALL GetDMatAO(G1q,DMatAO,ng1,nTri)
       CALL DaXpY_(nTri,1.0d0,DMatAO,1,D6,1)
       CALL DCopy_(nTri,DMatAO,1,D5,1)
       Call DaXpY_(nTri,0.5d0,DIAO,1,D5,1)
       CALL Put_DArray('MSPDFTD5        ',D5,nTri)
       CALL Put_DArray('MSPDFTD6        ',D6,nTri)
       Call mma_deallocate(D5)
       Call mma_deallocate(D6)
       Call mma_deallocate(DMatAO)
       Call mma_deallocate(DIAO)
*******Beginning of the info for CMS intermediate states


       jdisk=itoc(3)
       Call mma_allocate(G1qs,ng1*nRoots)
       Call mma_allocate(G2qs,ng2*nRoots)
       DO K=1,nRoots
        Call dDaFile(LUJOB ,2,G1q,ng1,jDisk)
        Call dDaFile(LUJOB ,0,rdum,ng1,jDisk)
        Call dDaFile(LUJOB ,2,G2q,Ng2,jDisk)
        Call dDaFile(LUJOB ,0,rdum,Ng2,jDisk)
        Call dcopy_(ng1,G1q,1,G1qs((K-1)*ng1+1),1)
        Call dcopy_(ng2,G2q,1,G2qs((K-1)*ng2+1),1)
        Call mma_allocate(DMatAO,ntri)
        CALL GetDMatAO(G1q,DMatAO,ng1,nTri)
        Call mma_deallocate(DMatAO)
        Do iB=1,ntash
         Do jB=1,ntash
         G1r(ib+(jb-1)*ntash) = G1q(itri(ib,jb))
         End Do
        End Do

        Do iB=1,ntash
         Do jB=1,ntash
          iDij=iTri(ib,jB)
          iRij=jb+(ib-1)*ntash
          Do kB=1,ntash
           Do lB=1,ntash
            iDkl=iTri(kB,lB)
            iRkl=lb+(kb-1)*ntash
            fact=One
            if(iDij.ge.iDkl .and. kB.eq.lB) fact=Two
            if(iDij.lt.iDkl .and. iB.eq.jB) fact=Two
            iijkl=itri(iDij,iDkl)
            iRijkl=itri(iRij,iRkl)
            G2r(iRijkl)=Fact*G2q(iijkl)
           End Do
          End Do
         End Do
        End Do

        Call FockGen(1.0d0,G1r,G2r,T,Fock,1)
        CALL Daxpy_(nDens2,-R((I-1)*nRoots+K)**2,Fock,1,bk,1)
        CALL Daxpy_(nDens2,-R((I-1)*nRoots+K)**2,T,1,FOccMO,1)
        Call DaXpY_(ng2,-R((I-1)*nRoots+K)**2,G2q,1,P2MOt,1)
       END DO
       Call Put_DArray('D1INTER         ',G1qs,ng1*nRoots)
       Call Put_DArray('P2INTER         ',G2qs,ng2*nRoots)
       Call mma_deallocate(G1qs)
       Call mma_deallocate(G2qs)
       Call mma_deallocate(Fock)
       Call mma_deallocate(T)
       Call mma_deallocate(G1r)
       Call mma_deallocate(G2r)
       Call mma_deallocate(G2rt)
       Call mma_deallocate(G1q)
       Call mma_deallocate(G2q)
       Call mma_deallocate(CIL)
       Call mma_deallocate(CIR)
       Call mma_deallocate(FinCI)
       RETURN
       End Subroutine
******************************************************
      Subroutine GetDmatAO(DMO,DAO,nDMO,nDAO)
      use Arrays, only: CMO
#include "detdim.fh"
#include "Input.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "disp_mclr.fh"
#include "cicisp_mclr.fh"
#include "stdalloc.fh"
#include "real.fh"
#include "sa.fh"
#include "dmrginfo_mclr.fh"
#include "SysDef.fh"
******Purpose: calculate the active 1RDM in AO basis given that in MO
******         basis
******Input
      INTEGER nDMO,nDAO
      Real*8,DIMENSION(nDMO)::DMO
******Output
      Real*8,DIMENSION(nDAO)::DAO
******Auxiliaries
      Real*8,DIMENSION(:),Allocatable::D1,OCCU,NatCMO
      INTEGER nLCMO,iS,i,j,iAA,jAA,nbas_tot,ij,iA,jA
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      nLCMO=0
      nbas_tot=0
      DO iS=1,nSym
       nbas_tot=nbas_tot+nbas(is)
       nLCMO=nLCMO+nBas(is)**2
      END DO

      Call mma_allocate(D1,nLCMO)
      Call FZero(D1,nLCMO)
******First, converting DMO into D1
******similar to computing D_K from G1q, as done in out_pt2.f
*********************************************************
      DO iS=1,nSym
       Do iA=1,nash(is)
        do jA=1,nash(is)
         i=iA+nish(is)
         j=jA+nish(is)
         iAA=iA+na(is)
         jAA=jA+na(is)
         D1(ipmat(is,is)+i-1+(j-1)*nbas(is))=DMO(itri(iAA,jAA))
        end do
       End Do
      END DO

*********************************************************
      Call mma_allocate(OCCU,nbas_tot,Label='OCCU')
      Call mma_allocate(NatCMO,ndens2,Label='NatCMO')

      Call NatOrb(D1,CMO,NatCMO,OCCU)
      Call dmat_MCLR(NatCMO,OCCU,DAO)
      ij=0
      DO iS=1,nSym
       Do i=1,nbas(is)
        do j=1,i-1
         ij=ij+1
         DAO(ij)=0.5d0*DAO(ij)
        end do
        ij=ij+1
       End Do
      END DO
      Call mma_deallocate(D1)
      Call mma_deallocate(OCCU)
      Call mma_deallocate(NatCMO)

      RETURN
      End Subroutine

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Desymmetrize(SOInt,nSOInt,Scr,nScr,AOInt,nBas,nBas1,
     &                        SymInv,nSym,iSyLbl)
      Implicit Real*8 (a-h,o-z)
*
#include "real.fh"
      Real*8 SOInt(nSOInt), Scr(nScr), AOInt(nBas1,nBas1),
     &       SymInv(nBas1**2)
      Integer nBas(0:nSym-1)
*
*define _DEBUGPRINT_
*
      Call FZero(AOInt,nBas1**2)
*
      iOffSO=1
      iOffPi=1
      Do iSym = 0, nSym-1
         iOffPj=1
         Do jSym = 0, iSym
            ijSym=iEor(iSym,jSym)
            If (iAnd(iSyLbl,2**ijSym).eq.0) Go To 20
            If (nBas(iSym)*nBas(jSym).eq.0) Go To 30
            If (iSym.eq.jSym) Then
#ifdef _DEBUGPRINT_
               Write (6,*) 'Diagonal Block'
               Call RecPrt('SOInt',' ',SOInt(iOffSO),nBas(iSym),
     &                                               nBas(iSym))
#endif
*
               Call DGEMM_('N','T',
     &                     nBas(iSym),nBas1,nBas(iSym),
     &                     1.0d0,SOInt(iOffSO),nBas(iSym),
     &                     SymInv(iOffPi),nBas1,
     &                     0.0d0,Scr,nBas(iSym))
*
               Call DGEMM_('N','N',nBas1,nBas1,nBas(iSym),
     &                    One,SymInv(iOffPi),nBas1,
     &                        Scr,nBas(iSym),
     &                    One,AOInt,nBas1)
*
            Else
#ifdef _DEBUGPRINT_
               Write (6,*) 'Off-Diagonal Block',iSym,jSym
               Call RecPrt('SOInt',' ',SOInt(iOffSO),nBas(iSym),
     &                                               nBas(jSym))
               Call RecPrt('Pi',' ',SymInv(iOffPi),nbas1,nBas(iSym))
               Call RecPrt('Pj',' ',SymInv(iOffPj),nbas1,nBas(jSym))
#endif
*
               Call DGEMM_('N','T',
     &                     nBas(iSym),nBas1,nBas(jSym),
     &                     1.0d0,SOInt(iOffSO),nBas(iSym),
     &                     SymInv(iOffPj),nBas1,
     &                     0.0d0,Scr,nBas(iSym))
*
               Call DGEMM_('N','N',nBas1,nBas1,nBas(iSym),
     &                    One,SymInv(iOffPi),nBas1,
     &                        Scr,nBas(iSym),
     &                    One,AOInt,nBas1)
*
               Call DGEMM_('T','T',nBas1,nBas1,nBas(iSym),
     &                    One,Scr,nBas(iSym),
     &                        SymInv(iOffPi),nBas1,
     &                    One,AOInt,nBas1)
*
            End If
*
 30         Continue
            iOffSO= iOffSO + nBas(iSym)*nBas(jSym)
 20         Continue
            iOffPj = iOffPj + nBas(jSym)*nBas1
         End Do
         iOffPi = iOffPi + nBas(iSym)*nBas1
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('AOInt',' ',AOInt,nBas1,nBas1)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!> @brief Calculate linear index for 3-body transition density
!> matrix elements
!>
!> Given 6 active orbital indices (t,u,v,x,y,z), this subroutine
!> calculates the linear index for the corresponding transition
!> density matrix element used in MKTG3. The indices are first
!> converted to three orbital pair indices, which are then sorted
!> in descending order to determine the final index.
!>
!> @param t First active orbital index
!> @param u Second active orbital index
!> @param v Third active orbital index
!> @param x Fourth active orbital index
!> @param y Fifth active orbital index
!> @param z Sixth active orbital index
!> @param nasht Number of active orbitals
!> @param linear_index Output - the calculated linear index

subroutine get_tg3_index(t,u,v,x,y,z,nasht,ituvxyz)

use Index_Functions, only: nTri_Elem, nTri3_Elem
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: t, u, v, x, y, z, nasht
integer(kind=iwp), intent(out) :: ituvxyz
integer(kind=iwp) :: itu, ivx, iyz, jtu, jvx, jyz

! Convert individual orbital indices to pair indices
itu = t+nasht*(u-1)
ivx = v+nasht*(x-1)
iyz = y+nasht*(z-1)

! Sort the pair indices in descending order (jtu >= jvx >= jyz)
if (itu < ivx) then
  if (itu >= iyz) then
    jtu = ivx
    jvx = itu
    jyz = iyz
  else if (ivx < iyz) then
    jtu = iyz
    jvx = ivx
    jyz = itu
  else
    jtu = ivx
    jvx = iyz
    jyz = itu
  end if
else
  if (itu < iyz) then
    jtu = iyz
    jvx = itu
    jyz = ivx
  else if (ivx >= iyz) then
    jtu = itu
    jvx = ivx
    jyz = iyz
  else
    jtu = itu
    jvx = iyz
    jyz = ivx
  end if
end if

! Calculate the linear index using the sorted pair indices
ituvxyz = nTri3_Elem(jtu-1)+nTri_Elem(jvx-1)+jyz

end subroutine get_tg3_index

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_CAS_DRV(rc,CMO,DI,FI,DA1,FA,DA2,TraOnly)
      Implicit real*8 (a-h,o-z)

      Integer   rc
      Integer   ISTAQ(8),Nscreen
      Real*8    DA1(*),DI(*),DA2(*),FI(*),FA(*),CMO(*)
      Integer   nForb(8),nIorb(8),nAorb(8),nChM(8),nChI(8)
      Integer   ipDSA2(8,8,8),nnA(8,8),ipAorb(2),ipKLT(2)
      Logical   DoActive,DoQmat,TraOnly,DoLocK,Deco,DoCholesky
      Integer   ALGO
      Real*8    dmpk
      Logical   DeAllocte_CVA

      COMMON /CHOTODO /DoActive,DoQmat,ipQmat
      COMMON /CHOPMAT / ipPL
      Common /CHLCAS / DoCholesky,ALGO
      Common /CHOLK / DoLocK,Deco,dmpk,Nscreen

      Character*11 SECNAM
      Parameter (SECNAM = 'CHO_CAS_DRV')

#include "rasdim.fh"
#include "wadr.fh"
#include "general.fh"
#include "rasscf.fh"
#include "WrkSpc.fh"
C ************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
C  **************************************************


      rc=0

      DeAllocte_CVA=.False.

      IF (TraOnly) THEN
c
c --- It only performs the MO transformation of FI and FA
c -------------------------------------------------------
c
*     transform FI from AO to MO basis  (LT-storage)
      iOff1 = 1
      iOff2 = 1
      iOff3 = 1
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        iOrb = nOrb(iSym)
        iFro = nFro(iSym)
        Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
        Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
        Call Square(FI(iOff1),Work(iTmp1),1,iBas,iBas)
C        Call MXMA(Work(iTmp1),1,iBas,
C     &            CMO(iOff2+(iFro*iBas)),1,iBas,
C     &            Work(iTmp2),1,iBas,
C     &            iBas,iBas,iOrb)
        Call DGEMM_('N','N',iBas,iOrb,iBas,1.0d0,Work(iTmp1),
     &               iBas,CMO(iOff2+(iFro*iBas)),max(iBas,iBas),
     &               0.0d0,Work(iTmp2),iBas)
        Call MXMT(Work(iTmp2),iBas,1,
     &            CMO(iOff2+(iFro*iBas)),1,iBas,
     &            FI(iOff3),
     &            iOrb,iBas)
        Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
        Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
        iOff1 = iOff1 + (iBas*iBas+iBas)/2
        iOff2 = iOff2 + iBas*iBas
        iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
      End Do

*     transform FA from AO to MO basis  (LT-storage)
      iOff1 = 1
      iOff2 = 1
      iOff3 = 1
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        iOrb = nOrb(iSym)
        iFro = nFro(iSym)
        Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
        Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
        Call Square(FA(iOff1),Work(iTmp1),1,iBas,iBas)
        Call DGEMM_('N','N',iBas,iOrb,iBas,1.0d0,Work(iTmp1),
     &               iBas,CMO(iOff2+(iFro*iBas)),max(iBas,iBas),
     &               0.0d0,Work(iTmp2),iBas)

        Call MXMT(Work(iTmp2),iBas,1,
     &            CMO(iOff2+(iFro*iBas)),1,iBas,
     &            FA(iOff3),
     &            iOrb,iBas)
        Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
        Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
        iOff1 = iOff1 + (iBas*iBas+iBas)/2
        iOff2 = iOff2 + iBas*iBas
        iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
      End Do

c**************************************************************************


      ELSE

c --- It only computes FI and FA  in AO-basis and returns
c --- the active integrals (tw|xy)
c --- If specified in input, the routine also computes
c --- the auxiliary Q-matrix stored as Q(av), where a is an AO index
c --- and v refers to the active orbitals only

      Do iSym=1,nSym
         nForb(iSym) = nFro(iSym)
         nIorb(iSym) = nIsh(iSym)
         nAorb(iSym) = nAsh(iSym)
      End Do


C --- Build the packed densities from the Squared ones
      Call Getmem('DILT','Allo','Real',ipDILT,NTot1)
      Call Getmem('DALT','Allo','Real',ipDALT,NTot1)

      Call Fold(nSym,nBas,DI,Work(ipDILT))
      Call Fold(nSym,nBas,DA1,Work(ipDALT))

      FactXI = -1.0D0

!AMS - should this be set differently for ExFac.ne.1?
!      FactXI = 0-ExFac

      If (Deco) Then

         FactXI = -0.5D0

!AMS - should this be set differently for ExFac.ne.1?
!         FactXI = 0-(ExFac*.5d0)

c --- decompose the Inactive density on request
         CALL GETMEM('choIn','allo','real',ipIna,NTot2)
         CALL GETMEM('ddec','allo','real',ipddec,NTot2)
         call dcopy_(NTot2,DI(1),1,Work(ipddec),1)

         ipInc = ipIna

         Thr = 1.0d-12
         ipd = ipddec
         ipV = ipIna
         incs=0
         Do i=1,nSym
            if((nForb(i)+nIorb(i)).gt.0)then
             CALL CD_InCore(Work(ipd),nBas(i),Work(ipV),nBas(i),
     &                     NumV,Thr,rc)
             If (rc.ne.0) Then
              write(6,*)SECNAM//': ill-defined dens decomp for Inact'
              write(6,*) 'rc value produced = ', rc
              Call abend()
             EndIf
             nChI(i) = NumV
             if ( NumV .ne. nIsh(i)+nForb(i) ) then
               write(6,*)'Warning! The number of occupied from the deco'
     &                 //'mposition of the Inactive density matrix is ',
     &                   numV,' in symm. ',i
               write(6,*)'Expected value = ',nIsh(i)+nForb(i)
               incs=incs+1
               Ymax=0.0d0
               do ja=1,nBas(i)
                  jaa=ipd-1+nBas(i)*(ja-1)+ja
                  Ymax=Max(Ymax,Work(jaa))
               end do
               write(6,*)'Max diagonal of the density in symm. ',i,' is'
     &                   //' equal to ',Ymax
             endif
            else
             nChI(i) = 0
            endif
            ipd = ipd + nBas(i)**2
            ipV = ipV + nBas(i)**2
         End Do

         If (incs.gt.0 .and. DoLocK) then
            dmpk_old = dmpk
            dmpk = 1.0d-2*dmpk
            write(6,*)'LK-damping decreased from ',dmpk_old,' to ',dmpk
         EndIf

         CALL GETMEM('ddec','free','real',ipddec,NTot2)

c --- to get the right input arguments for CHO_FCAS_AO and CHO_FMCSCF
         If(.not.DoLocK)Then
           Do i=1,nSym
              nForb(i) = 0
              nIorb(i) = nChI(i)
           End Do
         EndIf


      Else

        ipInc = ip_of_Work(CMO(1))

        Do i=1,nSym
           nChI(i) = nForb(i)+nIorb(i)
        End Do

      EndIf

c --- Various offsets
c --------------------
        ISTAQ(1)=0
      DO ISYM=2,NSYM
        NB=NBAS(ISYM-1)
        NP=NCHI(ISYM-1)+NAORB(ISYM-1)
        NP2=NB*NP
        ISTAQ(ISYM)=ISTAQ(ISYM-1)+NP2 ! Reordered MOs coeff
      END DO

C --- Reordering of the MOs coefficients to fit cholesky needs
      If(.not.DoLocK)Then

        NTaq = ISTAQ(nSym) + nBas(nSym)*(nChI(nSym)+nAorb(nSym))

        Call Getmem('rMOs','Allo','Real',ipPorb,NTaq)

        nOcs=0
        ioff1=0
        Do iSym=1,nSym
           do ikk=1,nChI(iSym)
              ioff2=ioff1+nBas(iSym)*(ikk-1)
              call dcopy_(nBas(iSym),Work(ipInc+ioff2),1,
     &        Work(ipPorb+ISTAQ(iSym)+ikk-1),nChI(iSym))
           end do
           ioff2=ioff1+nBas(iSym)*(nForb(iSym)+nIorb(iSym))
           do ikk=1,nAorb(iSym)
              call dcopy_(nBas(iSym),CMO(1+ioff2+nBas(iSym)*(ikk-1)),1,
     &        Work(ipPorb+ISTAQ(iSym)+nChI(iSym)*nBas(iSym)+ikk-1),
     &             nAorb(iSym))
           end do
           ioff1=ioff1+nBas(iSym)**2
c           call recprt('ReorIMOs','',Work(ipPorb+ISTAQ(iSym)),
c     &                  nChI(iSym),nBas(iSym))
c           call recprt('ReorAMOs','',Work(ipPorb+ISTAQ(iSym)+nChI(iSym)*
c     &                  nBas(iSym)),
c     &                  nAorb(iSym),nBas(iSym))

            nOcs = nOcs + nAorb(iSym)**2

        End Do

      Else

C *** Only the active orbitals MO coeff need reordering
           nVB=0
           Do iSym=1,nSym
            nVB = nVB + nAorb(iSym)*nBas(iSym)
           End Do
           Call GetMem('Cva','Allo','Real',ipAorb(1),nVB)
           DeAllocte_CVA=.True.

           ioff1 = 0
           ioff3 = 0
           Do iSym=1,nSym
            ioff2 = ioff1 + nBas(iSym)*(nForb(iSym)+nIorb(iSym))
            do ikk=1,nAorb(iSym)
               call dcopy_(nBas(iSym),CMO(1+ioff2+nBas(iSym)*(ikk-1)),1,
     &                 Work(ipAorb(1)+ioff3+ikk-1),nAorb(iSym))
            end do
            ioff1 = ioff1 + nBas(iSym)**2
            ioff3 = ioff3 + nAorb(iSym)*nBas(iSym)
           End Do

      EndIf

C --- Optional Section for Q-matrix evaluation
C --- Reorder the 2-el density matrix to fit cholesky needs
      If (DoQmat.and.ALGO.ne.1) Then

         Call set_nnA(nSym,nAorb,nnA)

         nPmat=0   ! P[vw],xy
         Do iSymXY=1,nSym
            Do iSymy=1,nSym
               iSymx=MulD2h(iSymXY,iSymy)
               if (iSymx.le.iSymy) then
               Do iSymw=1,nSym
                  iSymv=MulD2h(iSymXY,iSymw)
                  nPmat = nPmat
     &                  + nAorb(iSymv)*nAorb(iSymw)*nnA(iSymx,iSymy)
               End Do
               endif
            End do
         End Do

         Call Getmem('P-mat','Allo','Real',ipPmat,nPmat)
         Call Getmem('P-scal','Allo','Real',ipPL,NACPR2)
         Call CHO_Pmat(DA2,Work(ipPmat))

         Call Fzero(Work(ipPmat),nPmat)

c         ipDA2 = ip_of_Work(DA2(1))
         ipDA2 = ipPL

         Call Reord_Pmat(ipDA2,ipPmat,ipDSA2)

         Call Getmem('P-scal','Free','Real',ipPL,NACPR2)

      EndIf



      If (DoActive) Then
C ---  Decompose the active density  -----------------------------

#ifdef _DEBUGPRINT_
       koff=0
       do i=1,nSym
          CALL CD_TESTER(rc,ipDALT+koff,nBas(i),.true.)
          write(6,*) 'DALT for sym=', i
          CALL TRIPRT('DALT',' ',Work(ipDALT+koff),nBas(i))
          koff = koff + nBas(i)*(nBas(i)+1)/2
       end do
#endif

        CALL GETMEM('choMOs','allo','real',ipVec,NTot2) !cholesk MOs
        CALL GETMEM('ddec','allo','real',ipddec,NTot2)
        call dcopy_(NTot2,DA1(1),1,Work(ipddec),1)

        Thr = 1.0d-12
        ipd = ipddec
        ipV = ipVec
        nTvec = 0
        Do i=1,nSym
           if(nAorb(i).gt.0)then
! NOTE(Giovanni): CD will proceed with approx. decompos for QMC
!                 This will avoid warnings for negative-definit
             call CD_InCore(Work(ipd),nBas(i),Work(ipV),nBas(i),
     &                      NumV,Thr,rc)
             If (rc.ne.0) Then
                write(6,*)SECNAM//': ill-defined dens decomp for active'
                write(6,*) 'rc value produced = ', rc
                Call abend()
             EndIf
             nChM(i) = NumV
           else
             nChM(i) = 0
           endif
           ipd = ipd + nBas(i)**2
           ipV = ipV + nBas(i)**2
           nTvec = nTvec + nChM(i)*nBas(i)
        End Do

        CALL GETMEM('ddec','free','real',ipddec,NTot2)

      Else

        ipVec = -999999999  ! avoid compiler warnings

        Do i=1,nSym
           nChM(i) = 0
        End Do

      EndIf

      If (.not.DoLocK .and. DoActive) Then
c --- reorder "Cholesky MOs" to Cva storage

        CALL GETMEM('chM','allo','real',ipChM,nTvec) !cholesky reord MOs
        ioff1=0
        ioff2=0
         Do iSym=1,nSym
           If (nBas(iSym)*nChM(iSym).ne.0) Then
               do ikk=1,nChM(iSym)
                  koff = ioff1 + nBas(iSym)*(ikk-1)
                  call dcopy_(nBas(iSym),Work(ipVec+koff),1,
     &                 Work(ipChM+ioff2+ikk-1),nChM(iSym))
               end do
           EndIf
           ioff1=ioff1+nBas(iSym)**2
           ioff2=ioff2+nChM(iSym)*nBas(iSym)
         End Do

      Else

         ipChM = -9999999  ! avoid compiler warnings

      EndIf
C ----------------------------------------------------------------

      Call Fzero(FI(1),nTot1) ! LT-storage
      Call Fzero(FA(1),nTot1) ! LT-storage

      ipFI = ip_of_Work(FI(1))
      ipFA = ip_of_Work(FA(1))


      IF (ALGO.eq.1 .and. .not. DoLocK) THEN

         ipInt = lpwxy   ! (PU|VX) integrals are computed
         ipCM = ip_of_work(CMO(1))  ! MOs coeff. in C(a,p) storage

         CALL CHO_FMCSCF(rc,ipFA,ipFI,nForb,nIorb,nAorb,FactXI,
     &        ipPorb,ipDILT,ipDALT,DoActive,ipChM,nChM,ipInt,ExFac)


      ELSEIF (ALGO.eq.1 .and. DoLocK) THEN

         ipInt = lpwxy   ! (PU|VX) integrals are computed
         ipCM = ip_of_work(CMO(1))  ! MOs coeff. in C(a,p) storage
         ipAorb(2) = ipVec  ! decomposed active density

         Call Getmem('KILT','Allo','Real',ipKLT(1),NTot1)
         Call Fzero(Work(ipKLT(1)),NTot1)

         If (DoActive) Then
           Call Getmem('KALT','Allo','Real',ipKLT(2),NTot1)
           Call Fzero(Work(ipKLT(2)),NTot1)
         EndIf

         CALL CHO_LK_CASSCF(ipDILT,ipDALT,ipFI,ipFA,ipKLT,ipInc,ipInt,
     &                      FactXI,nChI,nAorb,nChM,ipAorb,DoActive,
     &                      nScreen,dmpK,abs(CBLBM),ExFac)

         If(DoActive) Call Getmem('KALT','Free','Real',ipKLT(2),NTot1)
         Call Getmem('KILT','Free','Real',ipKLT(1),NTot1)


      ELSEIF (ALGO.eq.2) THEN

         ipInt = LTUVX   ! (TU|VX) integrals only are computed

         CALL CHO_FCAS_AO(rc,ipFA,ipFI,ipQmat,nForb,nIorb,nAorb,FactXI,
     &    ipPorb,ipDILT,ipDALT,ipDSA2,DoActive,DoQmat,ipChM,nChM,ipInt,
     &    ExFac)

*  Synchronization of the Fock matrices
         Call GaDsum(Work(ipFI),NTot1)
         Call GaDsum(Work(ipFA),NTot1)
*  Synchronization of the Q-matrix
         lQ=0
         Do i=1,nSym
            lQ = lQ + nBas(i)*nAorb(i)
         End Do
         Call GaDsum(Work(ipQmat),lQ)
*  Synchronization of the (TU|VX) integrals
         Call GaDsum(Work(LTUVX),NACPR2)


      ELSE

         write(6,*)SECNAM//': wrong input parameter. ALGO= ',ALGO
         rc=55
         Return

      ENDIF


      If(.not.DoLocK .and. DoActive)Then

        CALL GETMEM('chM','free','real',ipChM,nTvec) !cholesky reord MOs

      EndIf

      If (DeAllocte_CVA) Call GetMem('Cva','free','Real',ipAorb(1),nVB)


      If(DoActive) CALL GETMEM('choMOs','free','real',ipVec,NTot2)

      If (DoQmat.and.ALGO.ne.1) Then
         Call Getmem('P-mat','Free','Real',ipPmat,NPmat)
      EndIf

      If(.not.DoLocK)Then
        Call Getmem('rMOs','Free','Real',ipPorb,NTaq)
      EndIf

      If (Deco) CALL GETMEM('choIn','free','real',ipIna,NTot2)

      Call Getmem('DALT','Free','Real',ipDALT,NTot1)
      Call Getmem('DILT','Free','Real',ipDILT,NTot1)



      ENDIF


      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine distnodes()
! this routine distributes nodes to different parts

use ccsd_global, only: idaaaa, idaabb, idab, idabba, idbaab, idbbaa, idbbbb, ideffab, idfin, nprocab
use Para_Info, only: nProcs
use Constants, only: One, Half, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i
real(kind=wp) :: efftot

!tmp ta zatial takto
if (nProcs == 1) then

  !I def nodes for sumoverab
  nprocab = 1
  idab(1) = 0
  ideffab(1) = One

  !II def nodes for sumoverb and intermezzo
  idaaaa = 0
  idbaab = 0
  idbbaa = 0
  idbbbb = 0
  idaabb = 0
  idabba = 0

  !III def node for finale
  idfin = 0

else if (nProcs == 2) then

  !I def nodes for sumoverab
  nprocab = 1
  idab(1) = 0
  ideffab(1) = One

  !II def nodes for sumoverb and intermezzo
  idaaaa = 1
  idbaab = 1
  idbbaa = 1
  idbbbb = 1
  idaabb = 1
  idabba = 1

  !III def node for finale
  idfin = 1

else if (nProcs == 3) then

  !I def nodes for sumoverab
  nprocab = 1
  idab(1) = 0
  ideffab(1) = One

  !II def nodes for sumoverb and intermezzo
  idaaaa = 1
  idbaab = 1
  idbbaa = 1
  idbbbb = 2
  idaabb = 2
  idabba = 2

  !III def node for finale
  idfin = 1

else if (nProcs == 4) then

  !I def nodes for sumoverab
  nprocab = 4
  idab(1) = 0
  idab(2) = 1
  idab(3) = 2
  idab(4) = 3
  ideffab(1) = Quart
  ideffab(2) = Quart
  ideffab(3) = Quart
  ideffab(4) = Quart

  !II def nodes for sumoverb and intermezzo
  idaaaa = 0
  idbaab = 1
  idbbaa = 1
  idbbbb = 2
  idaabb = 2
  idabba = 3

  !III def node for finale
  idfin = 3

else if (nProcs == 5) then

  !I def nodes for sumoverab
  nprocab = 1
  idab(1) = 0
  ideffab(1) = One

  !II def nodes for sumoverb and intermezzo
  idaaaa = 1
  idbaab = 1
  idbbaa = 2
  idbbbb = 3
  idaabb = 3
  idabba = 4

  !III def node for finale
  idfin = 2

else if (nProcs == 6) then

  !I def nodes for sumoverab
  nprocab = 6
  idab(1) = 0
  idab(2) = 1
  idab(3) = 2
  idab(4) = 3
  idab(5) = 4
  idab(6) = 5
  ideffab(1) = One
  ideffab(2) = One
  ideffab(3) = One
  ideffab(4) = One
  ideffab(5) = One
  ideffab(6) = One

  !II def nodes for sumoverb and intermezzo
  idaaaa = 0
  idbaab = 1
  idbbaa = 2
  idbbbb = 3
  idaabb = 4
  idabba = 5

  !III def node for finale
  idfin = 3

else if (nProcs == 10) then

  !I def nodes for sumoverab
  nprocab = 4
  idab(1) = 0
  idab(2) = 1
  idab(3) = 2
  idab(4) = 3
  ideffab(1) = One
  ideffab(2) = One
  ideffab(3) = One
  ideffab(4) = One

  !II def nodes for sumoverb and intermezzo
  idaaaa = 4
  idbaab = 5
  idbbaa = 6
  idbbbb = 7
  idaabb = 8
  idabba = 9

  !III def node for finale
  idfin = 5

else

  !I def nodes for sumoverab
  nprocab = nProcs
  do i=1,nprocab
    idab(i) = i-1
  end do
  ideffab(1:nprocab) = One

  !II def nodes for sumoverb and intermezzo
  idaaaa = 0
  idbaab = 1
  idbbaa = 2
  idbbbb = 3
  idaabb = 4
  idabba = 5

  !III def node for finale
  idfin = 6

end if

return

!tmp koniec tmp riesenia

if (nProcs == 1) then

  !I def nodes for sumoverab
  nprocab = 1
  idab(1) = 0
  ideffab(1) = One

  !II def nodes for sumoverb and intermezzo
  idaaaa = 0
  idbaab = 0
  idbbaa = 0
  idbbbb = 0
  idaabb = 0
  idabba = 0

  !III def node for finale
  idfin = 0

else if (nProcs == 2) then

  !I def nodes for sumoverab
  nprocab = 2
  idab(1) = 0
  idab(2) = 1
  ideffab(1) = Half
  ideffab(2) = Half

  !II def nodes for sumoverb and intermezzo
  idaaaa = 0
  idbaab = 0
  idbbaa = 0
  idbbbb = 1
  idaabb = 1
  idabba = 1

  !III def node for finale
  idfin = 0

else if (nProcs == 3) then

  !I def nodes for sumoverab
  nprocab = 3
  idab(1) = 0
  idab(2) = 1
  idab(3) = 2
  ideffab(1) = 0.333_wp
  ideffab(2) = 0.333_wp
  ideffab(3) = 0.333_wp

  !II def nodes for sumoverb and intermezzo
  idaaaa = 1
  idbaab = 1
  idbbaa = 1
  idbbbb = 2
  idaabb = 2
  idabba = 2

  !III def node for finale
  idfin = 0

else if (nProcs == 4) then

  !I def nodes for sumoverab
  nprocab = 2
  idab(1) = 2
  idab(2) = 3
  ideffab(1) = One
  ideffab(2) = One

  !II def nodes for sumoverb and intermezzo
  idaaaa = 0
  idbaab = 0
  idbbaa = 0
  idbbbb = 1
  idaabb = 1
  idabba = 1

  !III def node for finale
  idfin = 0

else

  !I def nodes for sumoverab
  nprocab = nProcs-2
  idab(1) = 1
  idab(2) = 2
  idab(3) = 4
  idab(4) = 5
  idab(5) = 6
  idab(6) = 7
  ideffab(1:nprocab) = One/nprocab
  ideffab(1) = Half*ideffab(1)
  ideffab(2) = Half*ideffab(2)

  !II def nodes for sumoverb and intermezzo
  idaaaa = 1
  idbaab = 0
  idbbaa = 0
  idbbbb = 2
  idaabb = 3
  idabba = 3

  !III def node for finale
  idfin = 1

end if

! renormalize ideffab

efftot = sum(ideffab(1:nprocab))

ideffab(1:nprocab) = ideffab(1:nprocab)/efftot

return

end subroutine distnodes

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DoReadBPT2(kS,lS)
! Read back-transformed density elements of the Kth and Lth shells
! All elements of the Jth shell (auxiliary functions) are read
! Only for C1 symmetry

use iSD_data, only: iSD
use Gateway_global, only: force_part_c
use pso_stuff, only: B_PT2, LuGamma2, nBasA, nCalAO, ReadBPT2
use SOAO_Info, only: iAOtSO
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: kS, lS
integer(kind=iwp) :: i3, i4, kAO, kAOk, kBas, kBsInc, kCmp, kSO, kSO0, kSOk, lAO, lAOl, lBas, lBsInc, lCmp, lSO, lSO0, lSOl

kCmp = iSD(2,kS)
kBas = iSD(3,kS)
kAO = iSD(7,kS)

lCmp = iSD(2,lS)
lBas = iSD(3,lS)
lAO = iSD(7,lS)

if (force_part_c) then
  kBsInc = (kBas+1)/2
  lBsInc = (lBas+1)/2
else
  kBsInc = kBas
  lBsInc = lBas
end if

lSO0 = iAOtSO(lAO+1,0)-1
kSO0 = iAOtSO(kAO+1,0)-1
do i4=1,lCmp
  lSO = iAOtSO(lAO+i4,0)
  do i3=1,kCmp
    kSO = iAOtSO(kAO+i3,0)
    do lAOl=0,min(lBsInc,lBas)-1
      lSOl = lSO+lAOl
      do kAOk=0,min(kBsInc,kBas)-1
        kSOk = kSO+kAOk
        nCalAO = nCalAO+1
        !write(6,'("k,l = ",4i5)') ksok,lsol,ksok-kso0,lsol-lso0
        read(LuGAMMA2,rec=nCalAO) B_PT2(1:nBasA,kSOk-kSO0,lSOl-lSO0)
      end do
    end do
  end do
end do

ReadBPT2 = .false.

return

end subroutine DoReadBPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_NMode_All(Vectors,nVectors,nFreq,nUnique_Atoms,
     &                          Vectors_All,nAll_Atoms,mDisp)
      use Symmetry_Info, only: iChTbl, nIrrep, iOper, Symmetry_Info_Get
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8  Vectors(nVectors), Vectors_All(3*nAll_Atoms*nFreq)
      Integer iGen(3), iCoSet(0:7,0:7), mDisp(0:7),
     &        iChCar(3), nDisp(0:7), iStab(0:7)
#ifdef _DEBUGPRINT_
      Logical Temp
#endif
      Logical TF, TstFnc
      Integer, Save:: Active=0
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      TF(iIrrep,iComp) = TstFnc(iCoSet,iIrrep,iComp,nIrrep/nCoSet)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('Vectors',' ',Vectors,1,nVectors)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      If (Active.eq.0) Then
         Call Symmetry_Info_Get()
         Active=1
      End If
*                                                                      *
************************************************************************
*                                                                      *
      nGen=0
      If (nIrrep.eq.2) nGen=1
      If (nIrrep.eq.4) nGen=2
      If (nIrrep.eq.8) nGen=3
      If (nGen.ge.1) iGen(1)=iOper(1)
      If (nGen.ge.2) iGen(2)=iOper(2)
      If (nGen.eq.3) iGen(3)=iOper(4)
#ifdef _DEBUGPRINT_
      Write (6,*) 'nGen=',nGen
      Write (6,*) 'iGen=',(iGen(i),i=1,nGen)
#endif
      Call ChCar(iChCar,iGen,nGen)
*                                                                      *
************************************************************************
*                                                                      *
*     Generate list of symmetry adapted displacements
*
      Call Get_iScalar('Unique atoms',mUnique_Atoms)
      If (mUnique_Atoms.ne.nUnique_Atoms) Then
         Write (6,*) 'Get_NMode_All: mUnique_Atoms.ne.nUnique_Atoms'
         Call Abend()
      End If
      Call Allocate_Work(ipCoor,3*mUnique_Atoms)
      Call Get_dArray('Unique Coordinates',Work(ipCoor),3*mUnique_Atoms)
#ifdef _DEBUGPRINT_
      Write(6,*) 'nVectors,nAll_Atoms,nFreq=',
     &            nVectors,nAll_Atoms,nFreq
      Write (6,*)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Find the number of displacements in each irrep
*
      MaxDCR=0
      Do iIrrep = 0, nIrrep-1
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*) 'iIrrep=',iIrrep
         Write (6,*)
#endif
         nDisp(iIrrep)=0
         ipTmp=ipCoor
         Do iUnique_Atom = 1, nUnique_Atoms
#ifdef _DEBUGPRINT_
            Write (6,*) 'iUnique_Atom=',iUnique_Atom
#endif
            iChAtom=iChxyz(Work(ipTmp),iGen,nGen)
            ipTmp=ipTmp+3
            Call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
            nCoSet=nIrrep/nStab
#ifdef _DEBUGPRINT_
            Write (6,*) 'nCoSet=',nCoSet
            Write (6,*) 'iCoSet=',(iCoSet(i,0),i=0,nCoset-1)
            Write (6,*) 'iChAtom=',iChAtom
#endif
            Do  iCar = 0, 2
                iComp=2**iCar
#ifdef _DEBUGPRINT_
                Write (6,*) 'iComp=',iComp
                Temp=TF(iIrrep,iComp)
                Write (6,*) 'TF(iIrrep,iComp)=',Temp
#endif
                If (TF(iIrrep,iComp)) nDisp(iIrrep)=nDisp(iIrrep)+1
            End Do
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'Grand Total'
      Write (6,*) 'nDisp=',(nDisp(i),i=0,nIrrep-1)
      Write (6,*)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Loop Irreps
*
      iVector=0
      iVector_all=0
      iFreq=0
      Do iIrrep = 0, nIrrep-1
#ifdef _DEBUGPRINT_
         Write (6,*) 'iIrrep,nDisp(iIrrep)=',iIrrep,nDisp(iIrrep)
#endif
*
      Do iMode = 1, mDisp(iIrrep)
         iFreq=iFreq+1
#ifdef _DEBUGPRINT_
         Write (6,*) 'iMode=',iMode
#endif
*
*        Loop over symmetry unique centers
*
         ipTmp=ipCoor
         Do iUnique_Atom = 1, nUnique_Atoms
*
#ifdef _DEBUGPRINT_
            Write (6,*) 'iUnique_Atom=',iUnique_Atom
#endif
*           Get permutational character of the center
*
#ifdef _DEBUGPRINT_
            Write (6,*) Work(ipTmp),Work(ipTmp+1),Work(ipTmp+2)
#endif
            iChAtom=iChxyz(Work(ipTmp),iGen,nGen)
            ipTmp=ipTmp+3
            Call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
            nCoSet=nIrrep/nStab
#ifdef _DEBUGPRINT_
            Write (6,*) 'nCoSet=',nCoSet
            Write (6,*) 'iCoSet=',(iCoSet(i,0),i=0,nCoset-1)
            Write (6,*) 'iChAtom=',iChAtom
#endif
*
            iVec=0 ! dummy initialize
            Do iCo = 0, nCoSet-1
               kOp=iCoSet(iCo,0)
#ifdef _DEBUGPRINT_
               Write (6,*) 'iVector_All=',iVector_All
               Write (6,*) 'iVector=',iVector
               Write (6,*) 'iCo,kOp=',iCo,kOp
#endif
               iVec=0
               Do  iCar = 0, 2
                   iComp=2**iCar
                   iVector_All=iVector_All+1
#ifdef _DEBUGPRINT_
                   Write (6,*) 'iCar=',iCar
                   Write (6,*) 'iVector_All=',iVector_All
                   Write (6,*) 'iComp=',iComp
                   Temp=TF(iIrrep,iComp)
C                  Write (6,*) 'TF(iIrrep,iComp)=',Temp
#endif
                   If (TF(iIrrep,iComp)) Then
C                     Write (*,*) 'Belong!'
                      iVec=iVec+1
*
*     In some cases we only want the normal modes of the first irrep! In
*     that case branch out.
*
                      If (iVector+iVec.gt.nVectors) Then
                         Go To 999
                      End If
                      Vec=Vectors(iVector+iVec)
                      XR=DBLE(iPrmt(NrOpr(kOp),iComp))
                      XY=DBLE(iChTbl(iIrrep,NrOpr(kOp)))
                      Vectors_All(iVector_All)=Vec*XR*XY
                   Else
C                     Write (*,*) 'Doesn''t belong!'
                      Vectors_All(iVector_All)=Zero
                   End If
#ifdef _DEBUGPRINT_
                   Write (6,*) 'iVec=',iVec
#endif
               End Do   ! iCar
            End Do      ! iCo
            iVector=iVector+iVec
*
         End Do ! iUnique_Atom
*
#ifdef _DEBUGPRINT_
         Call RecPrt('Normal mode',' ',
     &               Vectors_All((iFreq-1)*3*nAll_Atoms+1),
     &               3,nAll_Atoms)
#endif
      End Do  ! iMode
      End Do  ! iIrrep
 999  Continue
      Call Free_Work(ipCoor)
#ifdef _DEBUGPRINT_
      Call RecPrt('Normal mode',' ',
     &             Vectors_All,
     &             3*nAll_Atoms,nFreq)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine oneexc2_cvb(cfrom,cto,vij,diag,idens,iPvb)
! Calculates Cto = Pvb Eij Cfrom

use casvb_global, only: absym, i1alf, i1bet, iapr, iato, ibpr, ibto, ixapr, ixbpr, n1a, n1b, nda, ndb, norb, phato, phbto, sc
use Constants, only: Two, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: cfrom(nda,ndb)
real(kind=wp), intent(inout) :: cto(nda,ndb), vij(*)
logical(kind=iwp), intent(in) :: diag
integer(kind=iwp), intent(in) :: idens, iPvb
integer(kind=iwp) :: ia, iax, iaxtmp, ib, ibx, ibxtmp, iorb, iprm, ixa, ixb, jax, jbx, jorb, nvij
real(kind=wp) :: tcof
real(kind=wp), parameter :: thresh = 1.0e-10_wp
real(kind=wp), external :: ddot_

if (diag) then
  nvij = norb*norb
else if (idens == 1) then
  nvij = norb*(norb-1)
else
  nvij = 0
end if
if (absym(3)) then
  if (idens == 0) then
    cto(:,:) = Half*cto(:,:)
  else
    vij(1:nvij) = Half*vij(1:nvij)
  end if
end if
iprm = 0
do jorb=1,norb
  do iorb=1,norb
    if ((iorb == jorb) .and. (.not. diag)) cycle
    iprm = iprm+1
    if ((idens == 0) .and. (abs(vij(iprm)) < thresh)) cycle
    if (.not. sc) then
      ! a) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          if (idens == 0) then
            tcof = vij(iprm)*phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
            if (iPvb == 0) then
              cto(iax,:) = cto(iax,:)+tcof*cfrom(jax,:)
            else if (iPvb == 1) then
              do ixa=ixapr(jax),ixapr(jax+1)-1
                ibx = iapr(ixa)
                cto(iax,ibx) = cto(iax,ibx)+tcof*cfrom(jax,ibx)
              end do
            else if (iPvb == 2) then
              do ixa=ixapr(iax),ixapr(iax+1)-1
                ibx = iapr(ixa)
                cto(iax,ibx) = cto(iax,ibx)+tcof*cfrom(jax,ibx)
              end do
            end if
          else
            tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
            if (iPvb == 0) then
              vij(iprm) = vij(iprm)+tcof*ddot_(ndb,cto(iax,1),nda,cfrom(jax,1),nda)
            else if (iPvb == 1) then
              do ixa=ixapr(jax),ixapr(jax+1)-1
                ibx = iapr(ixa)
                vij(iprm) = vij(iprm)+tcof*cto(iax,ibx)*cfrom(jax,ibx)
              end do
            else if (iPvb == 2) then
              do ixa=ixapr(iax),ixapr(iax+1)-1
                ibx = iapr(ixa)
                vij(iprm) = vij(iprm)+tcof*cto(iax,ibx)*cfrom(jax,ibx)
              end do
            end if
          end if
        end if
      end do

      if (.not. absym(3)) then
        ! c) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            if (idens == 0) then
              tcof = vij(iprm)*phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
              if (iPvb == 0) then
                cto(:,ibx) = cto(:,ibx)+tcof*cfrom(:,jbx)
              else if (iPvb == 1) then
                do ixb=ixbpr(jbx),ixbpr(jbx+1)-1
                  iax = ibpr(ixb)
                  cto(iax,ibx) = cto(iax,ibx)+tcof*cfrom(iax,jbx)
                end do
              else if (iPvb == 2) then
                do ixb=ixbpr(ibx),ixbpr(ibx+1)-1
                  iax = ibpr(ixb)
                  cto(iax,ibx) = cto(iax,ibx)+tcof*cfrom(iax,jbx)
                end do
              end if
            else
              tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
              if (iPvb == 0) then
                vij(iprm) = vij(iprm)+tcof*ddot_(nda,cto(:,ibx),1,cfrom(:,jbx),1)
              else if (iPvb == 1) then
                do ixb=ixbpr(jbx),ixbpr(jbx+1)-1
                  iax = ibpr(ixb)
                  vij(iprm) = vij(iprm)+tcof*cto(iax,ibx)*cfrom(iax,jbx)
                end do
              else if (iPvb == 2) then
                do ixb=ixbpr(ibx),ixbpr(ibx+1)-1
                  iax = ibpr(ixb)
                  vij(iprm) = vij(iprm)+tcof*cto(iax,ibx)*cfrom(iax,jbx)
                end do
              end if
            end if
          end if
        end do
      end if
    else if (sc) then
      ! a) Alpha excitation
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          if (idens == 0) then
            tcof = vij(iprm)*phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
            if (iPvb == 0) then
              cto(iax,:) = cto(iax,:)+tcof*cfrom(jax,:)
            else if (iPvb == 1) then
              ibx = ndb-jax+1
              cto(iax,ibx) = cto(iax,ibx)+tcof*cfrom(jax,ibx)
            else if (iPvb == 2) then
              ibx = ndb-iax+1
              cto(iax,ibx) = cto(iax,ibx)+tcof*cfrom(jax,ibx)
            end if
          else
            tcof = phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
            if (iPvb == 0) then
              vij(iprm) = vij(iprm)+tcof*ddot_(ndb,cto(iax,1),nda,cfrom(jax,1),nda)
            else if (iPvb == 1) then
              ibx = ndb-jax+1
              vij(iprm) = vij(iprm)+tcof*cto(iax,ibx)*cfrom(jax,ibx)
            else if (iPvb == 2) then
              ibx = ndb-iax+1
              vij(iprm) = vij(iprm)+tcof*cto(iax,ibx)*cfrom(jax,ibx)
            end if
          end if
        end if
      end do

      if (.not. absym(3)) then
        ! c) Beta excitation
        do ib=1,n1b
          ibxtmp = i1bet(ib,iorb)
          jbx = ibto(jorb,ibxtmp)
          if (jbx /= 0) then
            ibx = ibto(iorb,ibxtmp)
            if (idens == 0) then
              tcof = vij(iprm)*phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
              if (iPvb == 0) then
                cto(:,ibx) = cto(:,ibx)+tcof*cfrom(:,jbx)
              else if (iPvb == 1) then
                iax = nda-jbx+1
                cto(iax,ibx) = cto(iax,ibx)+tcof*cfrom(iax,jbx)
              else if (iPvb == 2) then
                iax = nda-ibx+1
                cto(iax,ibx) = cto(iax,ibx)+tcof*cfrom(iax,jbx)
              end if
            else
              tcof = phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
              if (iPvb == 0) then
                vij(iprm) = vij(iprm)+tcof*ddot_(nda,cto(:,ibx),1,cfrom(:,jbx),1)
              else if (iPvb == 1) then
                iax = nda-jbx+1
                vij(iprm) = vij(iprm)+tcof*cto(iax,ibx)*cfrom(iax,jbx)
              else if (iPvb == 2) then
                iax = nda-ibx+1
                vij(iprm) = vij(iprm)+tcof*cto(iax,ibx)*cfrom(iax,jbx)
              end if
            end if
          end if
        end do
      end if
    end if
  end do
end do
if (absym(3)) then
  if (idens == 0) then
    do ia=1,nda
      do ib=ia,nda
        cto(ia,ib) = cto(ia,ib)+cto(ib,ia)
        cto(ib,ia) = cto(ia,ib)
      end do
    end do
  else
    vij(1:nvij) = Two*vij(1:nvij)
  end if
end if

return

end subroutine oneexc2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
!---------------------------------------bbs act-ext
      subroutine ar_bl_dd_ext(lri,lrj,nk)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
c      write(nf2,*) 'ar_bl_dd_ext'
      logic_g49b=.true.
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)
      iml0= iml
      imr0= imr
      lptype=5
      do iw0=1,mtype
        w0_plp=vplpnew_w0(iw0)
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)

      if(logic_grad) then
        call lp_arbl_ext_dd_calcuvalue_g
     :                      (lri,lrj,iml0,imr0,nlp_value)
        ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
           call inn_ext_dd_loop_unpack_g(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_dd_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      else
        call lp_arbl_ext_dd_calcuvalue(lri,lrj,iml0,imr0,nlp_value)
        ilpsta=nstaval(iw0)*nk+1
        ilpend=(nstaval(iw0)+nvalue(iw0))*nk
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
           call inn_ext_dd_loop_unpack(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_dd_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      endif
      enddo
      return
      end

      subroutine drl_dd_ext(lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)

      do iw0=1,mtype
        w0_plp=vplpnew_w0(iw0)
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          ilw=lp_lwei(iplp)
          irw=lp_rwei(iplp)
          logic_g49b=.false.
          if(ilw.ne.irw) logic_g49b=.true.

      if(logic_grad) then
!          call lp_drl_ext_dd_calcuvalue_g(lri,iml,nlp_value)
          if(logic_dh) then                       !lp_head is in dbl_spa
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            logic_g49b=.false.
            if(ilw.ne.irw) logic_g49b=.true.
            call lp_drl_ext_dd_calcuvalue_g(lri,iml,nlp_value)
            call inn_ext_dd_loop_unpack_g(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            logic_g49b=.false.
            if(iwal0.ne.iwar0) logic_g49b=.true.
            call lp_drl_ext_dd_calcuvalue_g(lri,iml,nlp_value)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_dd_loop_unpack_g(ilw,irw)
            enddo
            enddo
          endif
      else
!          call lp_drl_ext_dd_calcuvalue_wyb(lri,iml,nlp_value)
          if(logic_dh) then                       !lp_head is in dbl_spa
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            logic_g49b=.false.
            if(ilw.ne.irw) logic_g49b=.true.
            call lp_drl_ext_dd_calcuvalue_wyb(lri,iml,nlp_value)
            call inn_ext_dd_loop_unpack(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            logic_g49b=.false.
            if(iwal0.ne.iwar0) logic_g49b=.true.
            call lp_drl_ext_dd_calcuvalue_wyb(lri,iml,nlp_value)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_dd_loop_unpack(ilw,irw)
            enddo
            enddo
          endif
       endif
        enddo
      enddo
      return
      end

      subroutine drl_ss_ext(lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/

      logic_g1415=.false.
      logic_g2g4b=.false.
      logic_g36b=.false.
      logic_g35b=.false.
      logic_g34b=.false.
      ilnodesm =0
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)

      w0_plp=vplpnew_w0(1)
      if(logic_dh) w0_plp=vplp_w0(1)

      if(logic_grad) then
      call lp_drl_ext_ss_calcuvalue_g(lri,nlp_value)
      w0_old=w0_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 201
        w0_plp=vplpnew_w0(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(abs(w0_plp).lt.crl) cycle
        w0multi=w0_plp/w0_old
        w0_old=w0_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
         value_lpext1(iiext)=value_lpext1(iiext)*w0multi
        enddo

201     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ss_drl_loop_unpack_g(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_ss_drl_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo

      else
      call lp_drl_ext_ss_calcuvalue(lri,nlp_value)
      w0_old=w0_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 202
        w0_plp=vplpnew_w0(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(abs(w0_plp).lt.crl) cycle
        w0multi=w0_plp/w0_old
        w0_old=w0_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
        enddo

202     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ss_drl_loop_unpack(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_ss_drl_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo
      endif
      return
      end


      subroutine drl_ss_sum(lri,lrj)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
                  logic_g1415=.false.
                  logic_g2g4b=.false.
                  logic_g36b=.false.
                  logic_g35b=.false.
                  logic_g34b=.false.
      data crl/1.0e-8/
      if(logic_grad) then
      do lrk=1,norb_dz
         if(lri.eq.lrk)   cycle
         if(lrj.eq.lrk)   cycle
      ilnodesm =0
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)
      w0_plp=vplp_w0(1)
      call lp_drl_ext_ss_calcuvalue_g(lrk,nlp_value)
      w0_old=w0_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 201
        w0_plp=vplp_w0(iw0)
        if(abs(w0_plp).lt.crl) cycle
        w0multi=w0_plp/w0_old
        w0_old=w0_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
         value_lpext1(iiext)=value_lpext1(iiext)*w0multi
        enddo
201     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ss_drl_loop_unpack_g(ilw,irw)
        enddo
      enddo
      enddo

      else
      ilnodesm =0
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)
      w0_plp=vplp_w0(1)
      call lp_drl_sum_ss_calcuvalue(lri,lrj,nlp_value)
      w0_old=w0_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 202
        w0_plp=vplp_w0(iw0)
        if(abs(w0_plp).lt.crl) cycle
        w0multi=w0_plp/w0_old
        w0_old=w0_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
        enddo
202     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ss_drl_loop_unpack(ilw,irw)
        enddo
      enddo
      endif

      return
      end

      subroutine drl_st_ext(lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/

      ilnodesm =0
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)
c      logic_g1415=.false.
c      logic_g34b=.false.
c      logic_g35b=.false.
c      logic_g36b=.false.

      w1_plp=vplpnew_w1(1)
      if(logic_dh) w1_plp=vplp_w1(1)

      if(logic_grad) then
      call lp_drl_ext_st_calcuvalue_g(lri,nlp_value)
      w1_old=w1_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 201
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)
        if(abs(w1_plp).lt.crl) cycle
        w1multi=w1_plp/w1_old
        w1_old=w1_plp

        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w1multi
         value_lpext1(iiext)=value_lpext1(iiext)*w1multi
        enddo
201     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend

         if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_st_drl_loop_unpack_g(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
              ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_st_drl_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo

      else
      call lp_drl_ext_st_calcuvalue(lri,nlp_value)
      w1_old=w1_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 202
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)
        if(abs(w1_plp).lt.crl) cycle
        w1multi=w1_plp/w1_old
        w1_old=w1_plp
c        call calcu_drl2_value_wyb(1,lri,lrj)
c        call lp_drl_ext_st_calcuvalue(lri,nlp_value)
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w1multi
        enddo
202     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
c      write(6,*) '      calcuvalue_w', intentry

         if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_st_drl_loop_unpack(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
              ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_st_drl_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo

      endif
      return
      end

      subroutine drl_tt_ext(lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

c                  logic_g1415=.false.
c                  logic_g2g4b=.false.
c                  logic_g36b=.false.
c                  logic_g35b=.false.
c                  logic_g34b=.false.
      ilnodesm =0
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)

      do iw0=1,mtype
        w0_plp=vplpnew_w0(iw0)
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)

       if(logic_grad) then
        call lp_drl_ext_tt_calcuvalue_g(lri,n1415,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend

          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_tt_drl_loop_unpack_g(ilw,irw,n1415)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
               call inn_ext_tt_drl_loop_unpack_g(ilw,irw,n1415)
              enddo
            enddo
          endif
        enddo
       else
        call lp_drl_ext_tt_calcuvalue(lri,n1415,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend

          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_tt_drl_loop_unpack(ilw,irw,n1415)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
               call inn_ext_tt_drl_loop_unpack(ilw,irw,n1415)
              enddo
            enddo
          endif
        enddo
       endif
      enddo
      return
      end

      subroutine drl_tt_sum(lri,lrj)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      data crl/1.0e-8/
c                  logic_g1415=.false.
c                  logic_g2g4b=.false.
c                  logic_g36b=.false.
c                  logic_g35b=.false.
c                  logic_g34b=.false.
c      write(nf2,*) 'drl_tt_sum'
      if(logic_grad) then
      do lrk=1,norb_dz
         if(lri.eq.lrk)   cycle
         if(lrj.eq.lrk)   cycle
      ilnodesm =0
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)
      w0_plp=vplp_w0(1)
      call lp_drl_sum_tt_calcuvalue_g(lrk,n1415,nlp_value)
      w0_old=w0_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 201
        w0_plp=vplp_w0(iw0)
        if(abs(w0_plp).lt.crl) cycle
        w0multi=w0_plp/w0_old
        w0_old=w0_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
         value_lpext1(iiext)=value_lpext1(iiext)*w0multi
        enddo

201     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_tt_drl_loop_unpack_g(ilw,irw,n1415)
        enddo
      enddo
      enddo

      else
      ilnodesm =0
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)
      w0_plp=vplp_w0(1)
      call lp_drl_sum_tt_calcuvalue(lri,lrj,n1415,nlp_value)
      w0_old=w0_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 202
        w0_plp=vplp_w0(iw0)
        if(abs(w0_plp).lt.crl) cycle
        w0multi=w0_plp/w0_old
        w0_old=w0_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w0multi
        enddo
c      call lp_drl_sum_tt_calcuvalue(lri,lrj,n1415,nlp_value)
202     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_tt_drl_loop_unpack(ilw,irw,n1415)
        enddo
      enddo
      endif
      return
      end

      subroutine drl_ts_ext(lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      data crl/1.0e-8/

c                  logic_g1415=.false.
c                  logic_g2g4b=.false.
c                  logic_g36b=.false.
c                  logic_g35b=.false.
c                  logic_g34b=.false.
      ilnodesm =0
      ildownwei_segdd=iseg_downwei(ipael)
      irdownwei_segdd=iseg_downwei(ipae)
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      w1_plp=vplpnew_w1(1)
      if(logic_dh) w1_plp=vplp_w1(1)

      if(logic_grad) then
      call lp_drl_ext_ts_calcuvalue_g(lri,nlp_value)
      w1_old=w1_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 201
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)
        if(abs(w1_plp).lt.crl) cycle
        w1multi=w1_plp/w1_old
        w1_old=w1_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w1multi
         value_lpext1(iiext)=value_lpext1(iiext)*w1multi
        enddo
201     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend

          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ts_drl_loop_unpack_g(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_ts_drl_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo

      else
      call lp_drl_ext_ts_calcuvalue(lri,nlp_value)
      w1_old=w1_plp
      do iw0=1,mtype
        if(iw0.eq.1) goto 202
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)
        if(abs(w1_plp).lt.crl) cycle
        w1multi=w1_plp/w1_old
        w1_old=w1_plp
        do iiext=1,nlp_value
         value_lpext(iiext)=value_lpext(iiext)*w1multi
        enddo
202     ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend

          if(logic_dh) then                    !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_ts_drl_loop_unpack(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_ts_drl_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      enddo

      endif
      return
      end

      subroutine ar_br_tv_ext_br_ar(lri,lrj)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      ndorb=norb_dz-lri
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      w0g36a=0.d0
      w1g36a=-1.d0
      lptype=9
      do iw0=1,mtype
        w0_plp=vplpnew_w0(iw0)
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)

      if(logic_grad) then
       call lp_arbr_ext_svtv_calcuvalue_g(lri,lrj,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_sv_loop_unpack_g(ilw,irw)
          else
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_sv_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      else
        call lp_arbr_ext_svtv_calcuvalue_wyb(lri,lrj,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_sv_loop_unpack(ilw,irw)
          else
            if(log_prod.eq.3) then
              lphead=lpnew_head(iplp)
              ihyposl=jphyl(lphead)
              ihyposr=jphy(lphead)
              ndim =ihyl(ihyposl)
            else
              ihyposl=jphy(iplp)
              ihyposr=ihyposl
              ndim =ihy(ihyposl)
            endif
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihyposl+in)
              iwar=iwar0+ihy(ihyposr+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_sv_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      endif
      enddo
      return
      end

      subroutine drr_sv_ext_br_ar(lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      ndorb=norb_dz-lri
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      do iw0=1,mtype
        w0_plp=vplpnew_w0(iw0)
        w1_plp=vplpnew_w1(iw0)
        if(ndorb.ge.0) w0_plp=vplp_w0(iw0)
        if(ndorb.ge.0) w1_plp=vplp_w1(iw0)

      if(logic_grad) then
        call lp_drr_ext_svtv_calcuvalue_g(lri,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
           call inn_ext_sv_loop_unpack_g(ilw,irw)
          else
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_sv_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      else
        call lp_drr_ext_svtv_calcuvalue_wyb(lri,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
           call inn_ext_sv_loop_unpack(ilw,irw)
          else
            if(log_prod.eq.3) then
              lphead=lpnew_head(iplp)
              ihyposl=jphyl(lphead)
              ihyposr=jphy(lphead)
              ndim =ihyl(ihyposl)
            else
              ihyposl=jphy(iplp)
              ihyposr=ihyposl
              ndim =ihy(ihyposl)
            endif

            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihyposl+in)
              iwar=iwar0+ihy(ihyposr+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_sv_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      endif
      enddo
      return
      end
      subroutine drr_tv_ext_br_ar(lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      ndorb=norb_dz-lri
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      do iw0=1,mtype
        w0_plp=vplpnew_w0(iw0)
        w1_plp=vplpnew_w1(iw0)
        if(ndorb.ge.0) w0_plp=vplp_w0(iw0)
        if(ndorb.ge.0) w1_plp=vplp_w1(iw0)

      if(logic_grad) then
        call lp_drr_ext_svtv_calcuvalue_g(lri,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
           call inn_ext_sv_loop_unpack_g(ilw,irw)
          else
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_sv_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      else
        call lp_drr_ext_svtv_calcuvalue_wyb(lri,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
           call inn_ext_sv_loop_unpack(ilw,irw)
          else
            if(log_prod.eq.3) then
              lphead=lpnew_head(iplp)
              ihyposl=jphyl(lphead)
              ihyposr=jphy(lphead)
              ndim =ihyl(ihyposl)
            else
              ihyposl=jphy(iplp)
              ihyposr=ihyposl
              ndim =ihy(ihyposl)
            endif

            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihyposl+in)
              iwar=iwar0+ihy(ihyposr+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_sv_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      endif
      enddo
      return
      end

      subroutine ar_dv_ext_ar(idtu,isma,lri,lrj)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      lptype=1
      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
c                        ipcoe=lp_arpos(iplp)
          do norb=norb_dz+1,norb_inn
            lpcoe(norb)=lpnew_coe(norb,iplp)       !01.12.25
          enddo

      if(logic_grad) then
         call lp_ar_coe_calcuvalue_g
     *            (idtu,isma,lri,lrj,nlp_value,lpcoe,nvalue1)
          if(logic_dh) then              !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call gdv_sequence_extspace1_g(ilw,irw,nvalue1)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call gdv_sequence_extspace1_g(ilw,irw,nvalue1)
              enddo
            enddo
         endif
       else
         call lp_ar_coe_calcuvalue_wyb
     *            (idtu,isma,lri,lrj,nlp_value,lpcoe)
         if(logic_dh) then              !lp_head is in dbl_space
           ilw=lp_lwei(iplp)
           irw=lp_rwei(iplp)
           call gdv_sequence_extspace(ilw,irw)
         else           !lp_head is in act_space
           if(log_prod.eq.3) then
             lphead=lpnew_head(iplp)
             ihyposl=jphyl(lphead)
             ihyposr=jphy(lphead)
             ndim =ihyl(ihyposl)
           else
             ihyposl=jphy(iplp)
             ihyposr=ihyposl
             ndim =ihy(ihyposl)
           endif

           iwal0=lpnew_lwei(iplp)
           iwar0=lpnew_rwei(iplp)
           do in=1,ndim
             iwal=iwal0+ihyl(ihyposl+in)
             iwar=iwar0+ihy(ihyposr+in)
             do iwd=0,iwuplwei-1
               ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
               irw=iwalk_ad(jpad,ipae,iwar,iwd)
               call gdv_sequence_extspace(ilw,irw)
             enddo
           enddo
         endif
      endif
        enddo
      enddo
      return
      end

      subroutine ar_sd_ext_ar(idtu,lri,lrj,isma)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)

      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      lptype=1
      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend

          do norb=norb_dz+1,norb_inn
            lpcoe(norb)=lpnew_coe(norb,iplp)
          enddo

      if(logic_grad) then
          call lp_ar_coe_calcuvalue_g
     *            (idtu,isma,lri,lrj,nlp_value,lpcoe,nvalue1)
          if(logic_dh) then              !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call gsd_sequence_extspace1_g(ilw,irw,nvalue1)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call gsd_sequence_extspace1_g(ilw,irw,nvalue1)
              enddo
            enddo
         endif
      else
          call lp_ar_coe_calcuvalue_wyb
     *            (idtu,isma,lri,lrj,nlp_value,lpcoe)
          if(logic_dh) then              !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call gsd_sequence_extspace(ilw,irw)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call gsd_sequence_extspace(ilw,irw)
              enddo
            enddo
         endif
      endif
        enddo
      enddo
      return
      end

      subroutine ar_td_ext_ar(idtu,lri,lrj,isma)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)

      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      lptype=1
      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          do norb=norb_dz+1,norb_inn
            lpcoe(norb)=lpnew_coe(norb,iplp)
          enddo

      if(logic_grad) then
         call lp_ar_coe_calcuvalue_g
     *            (idtu,isma,lri,lrj,nlp_value,lpcoe,nvalue1)
          if(logic_dh) then              !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)

            call gtd_sequence_extspace1_g(ilw,irw,nvalue1)
          else                           !lp_head is in act_space
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call gtd_sequence_extspace1_g(ilw,irw,nvalue1)
              enddo
            enddo
          endif
      else
         call lp_ar_coe_calcuvalue_wyb
     *            (idtu,isma,lri,lrj,nlp_value,lpcoe)
          if(logic_dh) then              !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call gtd_sequence_extspace(ilw,irw)
          else                           !lp_head is in act_space
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call gtd_sequence_extspace(ilw,irw)
              enddo
            enddo
          endif
      endif
        enddo
      enddo
      return
      end

      subroutine ar_br_sv_ext_br_ar(lri,lrj)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      ndorb=norb_dz-lri
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)
      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      do iw0=1,mtype
        w0_plp=vplpnew_w0(iw0)
        w1_plp=vplpnew_w1(iw0)
        if(logic_dh) w0_plp=vplp_w0(iw0)
        if(logic_dh) w1_plp=vplp_w1(iw0)

      if(logic_grad) then
        call lp_arbr_ext_svtv_calcuvalue_g(lri,lrj,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_sv_loop_unpack_g(ilw,irw)
          else
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_sv_loop_unpack_g(ilw,irw)
              enddo
            enddo
          endif
        enddo
      else
        call lp_arbr_ext_svtv_calcuvalue_wyb(lri,lrj,nlp_value)
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call inn_ext_sv_loop_unpack(ilw,irw)
          else
            if(log_prod.eq.3) then
              lphead=lpnew_head(iplp)
              ihyposl=jphyl(lphead)
              ihyposr=jphy(lphead)
              ndim =ihyl(ihyposl)
            else
              ihyposl=jphy(iplp)
              ihyposr=ihyposl
              ndim =ihy(ihyposl)
            endif
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihyposl+in)
              iwar=iwar0+ihy(ihyposr+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call inn_ext_sv_loop_unpack(ilw,irw)
              enddo
            enddo
          endif
        enddo
      endif
      enddo
      return
      end

      subroutine logicg_dd(ilnodesm,irnodesm)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      logic_g50 =.false.
      logic_g49a=.false.
      logic_g49b=.false.
      if (ilnodesm.lt.irnodesm) then
            logic_g49a=.true.
      elseif ( ilnodesm.eq.irnodesm) then
            logic_g49a=.true.
            logic_g49b=.true.
            logic_g50 =.true.
      else
            logic_g49b=.true.
      endif
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MxLbls(nInter,Grad,Shift,Lbl)
      use Slapaf_Parameters, only: GrdLbl,StpLbl,GrdMax,StpMax
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Shift(nInter), Grad(nInter)
      Character Lbl(nInter)*8
*
#ifdef _DEBUGPRINT_
      Call RecPrt('MxLbls:Shift',' ',Shift,nInter,1)
      Call RecPrt('MxLbls:Grad',' ',Grad,nInter,1)
#endif
*
      GrdMax=Zero
      StpMax=Zero
      Do i = 1, nInter
         If(Abs(Grad(i)).gt.Abs(GrdMax)) Then
           GrdMax=Grad(i)
           GrdLbl=Lbl(i)
         End If
         If(Abs(Shift(i)).gt.Abs(StpMax)) Then
           StpMax=Shift(i)
           StpLbl=Lbl(i)
         End If
      End Do
#ifdef _DEBUGPRINT_
      Write (6,*) ' Tmp output in MxLbls'
      Write (6,*) GrdLbl,' ',GrdMax
      Write (6,*) StpLbl,' ',StpMax
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_NumRd
*
*> @brief
*>   Return the number of Cholesky vectors that may be read into \p Mem words of memory.
*> @author Thomas Bondo Pedersen
*>
*> @details
*> The count starts at vector \p iVec1 of symmetry \p iSym
*> (this is needed since the vectors are stored in
*> different reduces sets).
*> On exit, \p Cho_X_NumRd is negative if some error has
*> occurred (``-1``, ``-2``, and ``-3`` signify errors in input
*> variables, ``-4`` indicates an error in \p Cho_X_SetRed).
*>
*> @note
*> The Cholesky procedure must have been successfully initialized (by ::Cho_X_Init).
*>
*> @param[in] iVec1 First vector
*> @param[in] iSym  Symmetry
*> @param[in] iRedC Reduced set in core (location ``3``); ``0`` (or ``-1``) if unknown or undefined
*> @param[in] Mem   Memory available for read
************************************************************************
      Integer Function Cho_X_NumRd(iVec1,iSym,iRedC,Mem)

#include "implicit.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Parameter (N2 = InfVec_N2)
      Integer iRed

      InfVec(i,j,k)=iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
      nDimRS(i,j)=iWork(ip_nDimRS-1+nSym*(j-1)+i)

      If (iSym.lt.1 .or. iSym.gt.nSym) Then
         Cho_X_NumRd = -1
      Else If (NumCho(iSym).lt.1) Then
         Cho_X_NumRd = 0
      Else If (NumCho(iSym).gt.MaxVec) Then
         Cho_X_NumRd = -2
      Else If (iVec1.lt.1 .or. iVec1.gt.NumCho(iSym)) Then
         Cho_X_NumRd = -3
      Else If (Mem .lt. 1) Then
         Cho_X_NumRd = 0
      Else
         NumRd = 0
         Need  = 0
         iVec  = iVec1 - 1
         If (l_nDimRS .lt. 1) Then
            iLoc  = 3
            Do While (iVec.lt.NumCho(iSym) .and. Need.lt.Mem)
               iVec = iVec + 1
               iRed = InfVec(iVec,2,iSym)
               If (iRed .ne. iRedC) Then
                  irc = 0
                  Call Cho_X_SetRed(irc,iLoc,iRed)
                  If (irc .ne. 0) Then
                     Cho_X_NumRd = -4
                     iRedC = -1
                     Return
                  End If
                  iRedC = iRed
               End If
               Need = Need + nnBstR(iSym,iLoc)
               If (Need .le. Mem) Then
                  NumRd = NumRd + 1
               End If
            End Do
         Else
            Do While (iVec.lt.NumCho(iSym) .and. Need.lt.Mem)
               iVec = iVec + 1
               iRed = InfVec(iVec,2,iSym)
               Need = Need + nDimRS(iSym,iRed)
               If (Need .le. Mem) Then
                  NumRd = NumRd + 1
               End If
            End Do
         End If
         Cho_X_NumRd = NumRd
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CCT3(ireturn)
! this program calculates noniterative T3 contributions to CCSD energy

use CCT3_global, only: dp1, dp2, fk1, fk2, fk3, fk4, fk5, fk6, fullprint, h1, h2, h3, ijsegkey, imax, imin, jmax, jmin, l1, l2, &
                       m1, m2, m3, maxspace, mmul, n, noa, nob, nsym, px, rx1, rx2, rx3, symimin, symimax, symjmax, symjmin, t11, &
                       t12, t21, t22, t23, typt3, vx, w11, w12, w13, w14, w21, w22, w23, wx
use Para_Info, only: MyRank, nProcs
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: counter, i, i3, id, ilow, iPrintLevel, istart, istop, j, j3, jstart, jstop, jup, k, k3, keyyes, nsg, post, &
                     rc1, ssl1, ssl2, ssm1, ssm2, symi, symi3, symij, symijk, symj, symj3, symjstart, symjstop, symk, symk3, wrksize
real(kind=wp) :: eaaa(1), eaab(1), eabb(1), ebbb(1), ec, eccsd
real(kind=wp), allocatable :: wrk(:)

!par
!stare call SetTim()
!stare call MPI_COMM_RANK(MPI_COMM_WORLD,myRank,rc)
!stare call MPI_COMM_SIZE(MPI_COMM_WORLD,nProcs,rc)

!I **************  start   section **************

!I.1 read input data form INPDAT (reorg) and input file
fullprint = 0
if (iPrintLevel(-1) <= 0) fullprint = -1
if (fullprint >= 0) then
  write(u6,*)
  write(u6,*) ' **********************************'
  write(u6,*) '  Triples Contribution Calculation '
  write(u6,*) ' **********************************'
  write(u6,*)
end if
call t3reainput()

!I.2 write head to output file
if (fullprint >= 0) call t3wrhead()

!I.3.1 calc. work space requirements to fix and help mediates
call t3initfiles(wrksize)
if (fullprint >= 0) write(u6,*) ' Work space requirements :',wrksize

!I.3.2 allocate work space

call mma_maxDBLE(maxspace)
if (maxspace/10 > 1000) maxspace = maxspace-1000
if (maxspace < wrksize) then
  write(u6,*) ' Allocation of work space failed',maxspace
  write(u6,*) ' Increase the value of the variable MOLCAS_MEM'
  call Abend()
end if
call mma_allocate(wrk,wrksize,label='CCT3')

!I.3.3 set wrk = 0
wrk(:) = Zero
if (fullprint >= 0) write(u6,*) ' Allocation of work space : Done'

!I.4 read static integrals from INTSTA (reorg) file
call t3reaintsta(wrk,wrksize)

!I.5 divide fok to faa,fai,fii and dp
call cct3_divfok(wrk,wrksize,n,px,fk1,fk2,fk3,fk4,fk5,fk6,dp1,dp2,rc1)

!I.6 read CCSD energy and amplitudes
call t3reaccsd(wrk,wrksize,eccsd)

!I.7 get address vector T3IntPos
!    they are located at the beginning of the t3nam file
call GetIntPos()

!I.* set energies=0
eaaa = Zero
eaab = Zero
eabb = Zero
ebbb = Zero

!I.par initialize parallel counter
counter = 0

! ***** work section *****

if (ijsegkey == 0) then
  !No Segmentation
  symimin = 1
  symimax = nsym
end if

!Segmented
!noseg do symi=1,nsym
do symi=symimin,symimax
  if (noa(symi) == 0) cycle

  ! def symjstart,symjstop

  if (ijsegkey == 0) then
    !No Segmentation
    symjstart = 1
    symjstop = symi
  else

    !Segmented
    if (symimin == symjmax) then
      ! case symimin=symi=symimax
      symjstart = symjmin
      symjstop = symjmax
    else
      ! case symimin<symjmax

      if (symi == symimin) then
        symjstart = symjmin
        symjstop = symi
      else if (symi == symimax) then
        symjstart = 1
        symjstop = symjmax
      else
        ! sub case symimin<symi<symimax
        symjstart = 1
        symjstop = symi
      end if

    end if
  end if

  !noseg do symj=1,symi
  do symj=symjstart,symjstop
    if ((symi == symj) .and. (noa(symi) <= 1)) then
      cycle
    else if (noa(symj) == 0) then
      cycle
    end if

    ! define sym(ij)
    symij = mmul(symi,symj)

    ! write symmetry status of I and J
    if (fullprint > 0) write(u6,*) ' SYMI',symi,'SYMJ',symj

    if (symi == symj) then
      ilow = 2
    else
      ilow = 1
    end if

    ! loop over index I

    ! define istart,istop

    if (ijsegkey == 0) then
      !No Segmentation
      istart = ilow
      istop = noa(symi)
    else

      !Segmented
      if ((symi == symimin) .and. (symj == symjmin)) then
        istart = imin
      else
        istart = ilow
      end if

      if ((symi == symimax) .and. (symj == symjmax)) then
        istop = imax
      else
        istop = noa(symi)
      end if

    end if

    !noseg do i=ilow,noa(symi)
    do i=istart,istop

      ! get integrals <ab|ic> for given i into R1(a,bc)
      call cct3_getint(wrk,wrksize,i,symi,rx1,rc1)

      ! def upper limit for index j
      if (symi == symj) then
        jup = i-1
      else
        jup = noa(symj)
      end if

      ! loop over index J

      ! def jstart,jstop

      if (ijsegkey == 0) then
        !No Segmentation
        jstart = 1
        jstop = jup
      else

        !Segmented
        if ((symimin == symimax) .and. (symjmin == symjmax)) then
          ! we are in the only symmetry block taken into consideration
          if (imin == imax) then
            jstart = jmin
            jstop = jmax
          else if (i == imin) then
            jstart = jmin
            jstop = jup
          else if (i == imax) then
            jstart = 1
            jstop = jmax
          else
            jstart = 1
            jstop = jup
          end if
        else if ((symi == symimin) .and. (symj == symjmin)) then
          ! we are in initial symmetry block
          if (i == imin) then
            jstart = jmin
            jstop = jup
          else
            jstart = 1
            jstop = jup
          end if
        else if ((symi == symimax) .and. (symj == symjmax)) then
          ! we are in terminal symmetry block
          if (i == imax) then
            jstart = 1
            jstop = jmax
          else
            jstart = 1
            jstop = jup
          end if
        else
          ! we are in intermediate symmetry block
          jstart = 1
          jstop = jup
        end if

      end if

      !noseg do j=1,jup
      do j=jstart,jstop

        ! get integrals <ab|jc> for given j into R2(a,bc)
        call cct3_getint(wrk,wrksize,j,symj,rx2,rc1)

        do symk=1,nsym
          if (noa(symk) == 0) cycle

          if (fullprint > 1) write(u6,*) ' SYMI',symi,'SYMJ',symj,'SYMK',symk

          ! define sym(ijk)
          symijk = mmul(symij,symk)

          ! loop over index K

          do k=1,noa(symk)
            if (fullprint >= 2) then
              write(u6,999) i,j,k
            end if

            !par update parallel counter, choose proper id for this 'portion'
            !    and skip if this portion is not for myRank
            counter = counter+1
            id = mod(counter,nProcs)
            if (myRank /= id) cycle

            ! get integrals <ab|kc> for given k into R3(a,bc)
            call cct3_getint(wrk,wrksize,k,symk,rx3,rc1)

            !1 ***** aaa spin combination *****

            !1* def keyyes
            if (symj > symk) then
              keyyes = 1
            else if (symj == symk) then
              if (j > k) then
                keyyes = 1
              else
                keyyes = 0
              end if
            else
              keyyes = 0
            end if

            if (keyyes == 1) then

              !1.* define maps of W(abc)
              call cct3_t3grc0(3,5,3,3,3,0,symijk,wx,post)

              !1.* vanish W(abc)
              call stz(wrk,wrksize,wx)

              !1.1 permutations (ijk) P(a,bc) (general sign+)
              nsg = 1

              !1.1.1 V graph

              !1.1.1* def L1(bc,d) <- R3(b,cd) for given k
              call defv(wrk,wrksize,1,l1,ssl1,rx3,symk,rc1)

              !1.1.1* ext M1(da) <- T2aaaa(da,ij) for given i,j
              call ext(wrk,wrksize,4,7,i,j,symi,symj,0,t21,1,m1,ssm1,rc1)

              !1.1.1* exp M2(d,a) <- M1(da)
              call cct3_expand(wrk,wrksize,2,1,m1,ssm1,m2,rc1)
              ssm2 = ssm1

              !1.1.1* mult L2(bc,a) <- L1(bc,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !1.1.1* pack W(abc) <-  P(a,bc) [L2(bc,a)] (minus due to using Tikda instead of T2ikad)
              call t3addpck(wrk,wrksize,3,1,l2,wx,-nsg,0,rc1)

              !1.1.2 O graph

              !1.1.2* ext L1(bc,l) <- T2aaaa(bc,kl) for given k
              call ext(wrk,wrksize,4,3,k,0,symk,0,0,t21,1,l1,ssl1,rc1)

              !1.1.2* ext M1(l,a) <- W11(l,a,ij)=<la||ij>aaaa for given ij
              call ext(wrk,wrksize,4,7,i,j,symi,symj,0,w11,1,m1,ssm1,rc1)

              !1.1.2* mult L2(bc,a) <- L1(bc,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !1.1.2* pack W(abc) <- P(a,bc) [L2(bc,a)]
              call t3addpck(wrk,wrksize,3,1,l2,wx,nsg,0,rc1)

              !1.2 permutations (ikj) P(a,bc)
              nsg = -1

              !1.2.1 V graph

              !1.2.1* def L1(bc,d) <- R2(b,cd) for given j
              call defv(wrk,wrksize,1,l1,ssl1,rx2,symj,rc1)

              !1.2.1* ext M1(da) <- T2aaaa(da,ik) for given i,k
              call ext(wrk,wrksize,4,7,i,k,symi,symk,0,t21,1,m1,ssm1,rc1)

              !1.2.1* exp M2(d,a) <- M1(da)
              call cct3_expand(wrk,wrksize,2,1,m1,ssm1,m2,rc1)
              ssm2 = ssm1

              !1.2.1* mult L2(bc,a) <- L1(bc,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !1.2.1* pack W(abc) <- - P(a,bc) [L2(bc,a)] (minus is due to using Tikda instead of T2ikad)
              call t3addpck(wrk,wrksize,3,1,l2,wx,-nsg,0,rc1)

              !1.2.2 O graph

              !1.2.2* ext L1(bc,l) <- T2aaaa(bc,jl) for given j
              call ext(wrk,wrksize,4,3,j,0,symj,0,0,t21,1,l1,ssl1,rc1)

              !1.2.2* ext M1(l,a) <- W11(l,a,ik)=<la||ik>aaaa for given ik
              call ext(wrk,wrksize,4,7,i,k,symi,symk,0,w11,1,m1,ssm1,rc1)

              !1.2.2* mult L2(bc,a) <- L1(bc,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !1.2.2* pack W(abc) <- P(a,bc) [L2(bc,a)]
              call t3addpck(wrk,wrksize,3,1,l2,wx,nsg,0,rc1)

              !1.3 permutations (jki) P(a,bc)
              nsg = 1

              !1.3.1 V graph

              !1.3.1* def L1(bc,d) <- R1(b,cd) for given i
              call defv(wrk,wrksize,1,l1,ssl1,rx1,symi,rc1)

              !1.3.1* ext M1(da) <- T2aaaa(da,jk) for given j,k
              call ext(wrk,wrksize,4,7,j,k,symj,symk,0,t21,1,m1,ssm1,rc1)

              !1.3.1* exp M2(d,a) <- M1(da)
              call cct3_expand(wrk,wrksize,2,1,m1,ssm1,m2,rc1)
              ssm2 = ssm1

              !1.3.1* mult L2(bc,a) <- L1(bc,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !1.3.1* pack W(abc) <- - P(a,bc) [L2(bc,a)] (minus is due to using Tjkda instead of T2jkad)
              call t3addpck(wrk,wrksize,3,1,l2,wx,-nsg,0,rc1)

              !1.3.2 O graph

              !1.3.2* ext L1(bc,l) <- T2aaaa(bc,kl) for given i
              call ext(wrk,wrksize,4,3,i,0,symi,0,0,t21,1,l1,ssl1,rc1)

              !1.3.2* ext M1(l,a) <- W11(l,a,jk)=<la||jk>aaaa for given jk
              call ext(wrk,wrksize,4,7,j,k,symj,symk,0,w11,1,m1,ssm1,rc1)

              !1.3.2* mult L2(bc,a) <- L1(bc,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !1.3.2* pack W(abc) <-  P(a,bc) [L2(bc,a)]
              call t3addpck(wrk,wrksize,3,1,l2,wx,nsg,0,rc1)

              !1.4 add singles

              !1.4.0 mov V <- -W
              call cct3_t3grc0(3,5,3,3,3,0,symijk,vx,post)
              call minusa(wrk,wrksize,wx,-One)
              call setb(wrk,wrksize,wx,vx,One)

              if (typt3 > 1) then
                !1.4.1 add part W2 . T1
                call t3sgl(wrk,wrksize,vx,t11,t12,w21,w22,1,i,j,k,symi,symj,symk,rc1,m1,h1,m2,h2,m3,h3)
              end if

              if (typt3 == 3) then
                !1.4.2 add part T2 . U
                call t3sgl(wrk,wrksize,vx,fk3,fk4,t21,t22,1,i,j,k,symi,symj,symk,rc1,m1,h1,m2,h2,m3,h3)
              end if

              !1.5  divide by denominators and calc energy contribution

              !1.5.1 divide by den.
              call t3div(wrk,wrksize,wx,vx,dp1,dp2,1,i,j,k,symi,symj,symk,ec,rc1)

              !1.5.2 add energy contribution
              eaaa = eaaa+ec

            end if

            !2 ***** aab spin combination *****

            !2* def keyyes
            if (k <= nob(symk)) then
              keyyes = 1
            else
              keyyes = 0
            end if

            if (keyyes == 1) then

              !2.* define maps of W(abc)
              call cct3_t3grc0(3,1,3,3,4,0,symijk,wx,post)

              !2.* vanish W(abc)
              call stz(wrk,wrksize,wx)

              !2.1 permutations (ijk) P(a,b) (c)
              nsg = 1

              !2.1.1 V graph

              !2.1.1* def L1(b,c,d)aba <- R3(b,cd) for given k
              call defv(wrk,wrksize,4,l1,ssl1,rx3,symk,rc1)

              !2.1.1* ext M1(da) <- T2aaaa(da,ij) for given i,j
              call ext(wrk,wrksize,4,7,i,j,symi,symj,0,t21,1,m1,ssm1,rc1)

              !2.1.1* exp M2(d,a) <- M1(da)
              call cct3_expand(wrk,wrksize,2,1,m1,ssm1,m2,rc1)
              ssm2 = ssm1

              !2.1.1* mult L2(b,c,a) <- L1(b,c,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !2.1.1* pack W(ab,c) <- - P(a,b) [L2(b,c,a)] (minus is due to using Tijda instead of T2ijad)
              call t3addpck(wrk,wrksize,3,2,l2,wx,-nsg,0,rc1)

              !2.1.2 O graph

              !2.1.2* ext L1(b,c,l) <- T2abab(b,c,l,k) for given k
              call ext(wrk,wrksize,4,4,k,0,symk,0,0,t23,1,l1,ssl1,rc1)

              !2.1.2* ext M1(l,a) <- W12(l,a,ij)=<la||ij>aaaa for given ij
              call ext(wrk,wrksize,4,7,i,j,symi,symj,0,w11,1,m1,ssm1,rc1)

              !2.1.2* mult L2(b,c,a) <- L1(b,c,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !2.1.2* pack W(ab,c) <- - P(a,b) [L2(b,c,a)] (-, premutation in V)
              call t3addpck(wrk,wrksize,3,2,l2,wx,-nsg,0,rc1)

              !2.2 permutations (ijk) (cab) do not nontribute

              !2.3 permutations (ikj) P(a,b) (c)
              nsg = -1

              !2.3.1 V graph

              !2.3.1* def L1(b,c,d)abb <- R2(b,cd) for given j
              call defv(wrk,wrksize,3,l1,ssl1,rx2,symj,rc1)

              !2.3.1* ext M1(a,d) <- T2abab(a,d,i,k) for given i,k
              call ext(wrk,wrksize,4,7,i,k,symi,symk,0,t23,1,m1,ssm1,rc1)

              !2.3.1* map M2(d,a) <- M1(a,d)
              call cct3_map(wrk,wrksize,2,2,1,0,0,m1,ssm1,m2,post,rc1)
              ssm2 = ssm1

              !2.3.1* mult L2(b,c,a) <- L1(b,c,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !2.3.1* pack W(ab,c) <-  P(a,b) [L2(b,c,a)]
              call t3addpck(wrk,wrksize,3,2,l2,wx,nsg,0,rc1)

              !2.3.2 O graph

              !2.3.2* ext L1(b,c,l) <- T2abab(b,c,j,l) for given j
              call ext(wrk,wrksize,4,3,j,0,symj,0,0,t23,1,l1,ssl1,rc1)

              !2.3.2* ext M1(l,a) <- W14(l,a,ik)=<la||ik>baab for given ik
              call ext(wrk,wrksize,4,7,i,k,symi,symk,0,w14,1,m1,ssm1,rc1)

              !2.3.2* mult L2(b,c,a) <- L1(b,c,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !2.3.2* pack W(ab,c) <- P(a,b) [L2(b,c,a)]
              call t3addpck(wrk,wrksize,3,2,l2,wx,nsg,0,rc1)

              !2.4 permutations (ikj) (cab)
              nsg = -1

              !2.4.1 V graph

              !2.4.1* def L1(ab,d)aaa <- R2(a,bc) for given j
              call defv(wrk,wrksize,1,l1,ssl1,rx2,symj,rc1)

              !2.4.1* ext M1(d,c) <- T2abab(d,c,i,k) for given i,k
              call ext(wrk,wrksize,4,7,i,k,symi,symk,0,t23,1,m1,ssm1,rc1)

              !2.4.1* mult L2(ab,c) <- L1(ab,d) . M1(d,c)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !2.4.1* add (pack) W(ab,c) <-  [L2(b,c,a)] (- due to permuted T)
              call cct3_add(wrk,wrksize,3,3,0,0,0,0,1,1,real(-nsg,kind=wp),l2,symijk,wx,symijk,rc1)

              !2.4.2 O graph

              !2.4.2* ext L1(ab,l) <- T2aaaa(ab,jl) for given j
              call ext(wrk,wrksize,4,3,j,0,symj,0,0,t21,1,l1,ssl1,rc1)

              !2.4.2* ext M1(l,c) <- W13(l,c,ik)=<lc||ik>abab for given ik
              call ext(wrk,wrksize,4,7,i,k,symi,symk,0,w13,1,m1,ssm1,rc1)

              !2.4.2* mult L2(ab,c) <- L1(ab,l) . M1(l,c)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !2.4.2* add (pack) W(ab,c) <- [L2(ab,c)]
              call cct3_add(wrk,wrksize,3,3,0,0,0,0,1,1,real(nsg,kind=wp),l2,symijk,wx,symijk,rc1)

              !2.5 permutations (jki) P(a,b) (c)
              nsg = 1

              !2.5.1 V graph

              !2.5.1* def L1(b,c,d)abb <- R1(b,cd) for given i
              call defv(wrk,wrksize,3,l1,ssl1,rx1,symi,rc1)

              !2.5.1* ext M1(a,d) <- T2abab(a,d,j,k) for given j,k
              call ext(wrk,wrksize,4,7,j,k,symj,symk,0,t23,1,m1,ssm1,rc1)

              !2.5.1* map M2(d,a) <- M1(a,d)
              call cct3_map(wrk,wrksize,2,2,1,0,0,m1,ssm1,m2,post,rc1)
              ssm2 = ssm1

              !2.5.1* mult L2(b,c,a) <- L1(b,c,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !2.5.1* pack W(ab,c) <-  P(a,b) [L2(b,c,a)]
              call t3addpck(wrk,wrksize,3,2,l2,wx,nsg,0,rc1)

              !2.5.2 O graph

              !2.5.2* ext L1(b,c,l) <- T2abab(b,c,i,l) for given i
              call ext(wrk,wrksize,4,3,i,0,symi,0,0,t23,1,l1,ssl1,rc1)

              !2.5.2* ext M1(l,a) <- W14(l,a,jk)=<la||jk>baab for given jk
              call ext(wrk,wrksize,4,7,j,k,symj,symk,0,w14,1,m1,ssm1,rc1)

              !2.5.2* mult L2(b,c,a) <- L1(b,c,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !2.5.2* pack W(ab,c) <- P(a,b) [L2(b,c,a)]
              call t3addpck(wrk,wrksize,3,2,l2,wx,nsg,0,rc1)

              !2.6 permutations (ikj) (cab)
              nsg = 1

              !2.6.1 V graph

              !2.6.1* def L1(ab,d)aaa <- R1(a,bc) for given i
              call defv(wrk,wrksize,1,l1,ssl1,rx1,symi,rc1)

              !2.6.1* ext M1(d,c) <- T2abab(d,c,j,k) for given j,k
              call ext(wrk,wrksize,4,7,j,k,symj,symk,0,t23,1,m1,ssm1,rc1)

              !2.6.1* mult L2(ab,c) <- L1(ab,d) . M1(d,c)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !2.6.1* add (pack) W(ab,c) <-  [L2(b,c,a)] (- due to permuted T)
              call cct3_add(wrk,wrksize,3,3,0,0,0,0,1,1,real(-nsg,kind=wp),l2,symijk,wx,symijk,rc1)

              !2.6.2 O graph

              !2.6.2* ext L1(ab,l) <- T2aaaa(ab,il) for given i
              call ext(wrk,wrksize,4,3,i,0,symi,0,0,t21,1,l1,ssl1,rc1)

              !2.6.2* ext M1(l,c) <- W13(l,c,jk)=<lc||jk>abab for given jk
              call ext(wrk,wrksize,4,7,j,k,symj,symk,0,w13,1,m1,ssm1,rc1)

              !2.6.2* mult L2(ab,c) <- L1(ab,l) . M1(l,c)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !2.6.2* add (pack) W(ab,c) <- [L2(ab,c)]
              call cct3_add(wrk,wrksize,3,3,0,0,0,0,1,1,real(nsg,kind=wp),l2,symijk,wx,symijk,rc1)

              !2.7 add singles

              !2.7.0 mov V <- W
              call cct3_t3grc0(3,1,3,3,4,0,symijk,vx,post)
              call minusa(wrk,wrksize,wx,-One)
              call setb(wrk,wrksize,wx,vx,One)

              if (typt3 > 1) then
                !2.7.1 add part W2 . T1
                call t3sgl(wrk,wrksize,vx,t11,t12,w21,w23,2,i,j,k,symi,symj,symk,rc1,m1,h1,m2,h2,m3,h3)
              end if

              if (typt3 == 3) then
                !2.7.2 add part T2 . U
                call t3sgl(wrk,wrksize,vx,fk3,fk4,t21,t23,2,i,j,k,symi,symj,symk,rc1,m1,h1,m2,h2,m3,h3)
              end if

              !2.8 divide by denominators and calc energy contribution

              !2.8.1 divide by den.
              call t3div(wrk,wrksize,wx,vx,dp1,dp2,2,i,j,k,symi,symj,symk,ec,rc1)

              !2.8.2 add energy contribution
              eaab = eaab+ec

            end if

            !3 ***** abb spin combination *****

            ! Note: in spin combination 3-abb indices are changed as follows

            i3 = k
            symi3 = symk
            j3 = i
            symj3 = symi
            k3 = j
            symk3 = symj

            ! therefore, also R files are mixed:
            ! R13 = R3, R23=R1 and R33=R2, symijk3=symijk

            !3.* def keyyes
            if (symj3 > symk3) then
              if ((j3 <= nob(symj3)) .and. (k3 <= nob(symk3))) then
                keyyes = 1
              else
                keyyes = 0
              end if
            else if (symj3 == symk3) then
              if ((j3 > k3) .and. (j3 <= nob(symj3))) then
                keyyes = 1
              else
                keyyes = 0
              end if
            else
              keyyes = 0
            end if

            if (keyyes == 1) then

              !3.* define maps of W(a,bc)
              call cct3_t3grc0(3,2,3,4,4,0,symijk,wx,post)

              !3.* vanish W(abc)
              call stz(wrk,wrksize,wx)

              !3.1 permutation (ijk) (abc)
              nsg = 1

              !3.1.1 V graph

              !3.1.1* def L1(bc,d) <- R33(b,cd) for given k3
              call defv(wrk,wrksize,2,l1,ssl1,rx2,symk3,rc1)

              !3.1.1* ext M1(a,d) <- T2abab(a,d,i3,j3) for given i3,j3
              call ext(wrk,wrksize,4,7,i3,j3,symi3,symj3,0,t23,1,m1,ssm1,rc1)

              !3.1.1* map M2(d,a) <- M1(a,d)
              call cct3_map(wrk,wrksize,2,2,1,0,0,m1,ssm1,m2,post,rc1)
              ssm2 = ssm1

              !3.1.1* mult L2(bc,a) <- L1(bc,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !3.1.1 map L1(a,bc) <- L2(bc,a)
              call cct3_map(wrk,wrksize,3,2,3,1,0,l2,ssl2,l1,post,rc1)
              ssl1 = ssl2
              !3.1.1* add (pack) W(a,bc) <- [L1(a,bc)]
              call cct3_add(wrk,wrksize,3,3,0,0,0,0,1,1,real(nsg,kind=wp),l1,symijk,wx,symijk,rc1)

              !3.1.2 O graph

              !3.1.2* ext L1(bc,l) <- T2bbbb(bc,k3l) for given k3
              call ext(wrk,wrksize,4,3,k3,0,symk3,0,0,t22,1,l1,ssl1,rc1)

              !3.1.2* ext M1(l,a) <- W14(l,a,i3j3)=<la||i3j3>baab for given i3,j3
              call ext(wrk,wrksize,4,7,i3,j3,symi3,symj3,0,w14,1,m1,ssm1,rc1)

              !3.1.2* mult L2(bc,a) <- L1(bc,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !3.1.2 map L1(a,bc) <- L2(bc,a)
              call cct3_map(wrk,wrksize,3,2,3,1,0,l2,ssl2,l1,post,rc1)
              ssl1 = ssl2

              !3.1.2* add (pack) W(a,bc) <- [L1(a,bc)]
              call cct3_add(wrk,wrksize,3,3,0,0,0,0,1,1,real(nsg,kind=wp),l1,symijk,wx,symijk,rc1)

              !3.2 permutations (ijk)(bac),(ijk)(cab)
              nsg = 1

              !3.2.1 V graph

              !3.2.1* def L1(a,c,d)aba <- R33(a,cd) for given k3
              call defv(wrk,wrksize,4,l1,ssl1,rx2,symk3,rc1)

              !3.2.1* ext M1(d,b) <- T2abab(d,b,i3,j3) for given i3,j3
              call ext(wrk,wrksize,4,7,i3,j3,symi3,symj3,0,t23,1,m1,ssm1,rc1)

              !3.2.1* mult L2(ac,b) <- L1(a,c,d) . M1(d,b)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !3.2.1* add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm T)
              call t3addpck(wrk,wrksize,3,3,l2,wx,-nsg,0,rc1)

              !3.2.2 O graph

              !3.2.2* ext L1(a,c,l) <- T2abab(a,c,l,k3) for given k3
              call ext(wrk,wrksize,4,4,k3,0,symk3,0,0,t23,1,l1,ssl1,rc1)

              !3.2.2* ext M1(l,b) <- W13(l,b,i3j3)=<la||i3j3>abab for given i3,j3
              call ext(wrk,wrksize,4,7,i3,j3,symi3,symj3,0,w13,1,m1,ssm1,rc1)

              !3.2.2* mult L2(ac,b) <- L1(a,c,l) . M1(l,b)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !3.2.2* add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm V)
              call t3addpck(wrk,wrksize,3,3,l2,wx,-nsg,0,rc1)

              !3.3 permutation (ikj) (abc)
              nsg = -1

              !3.3.1 V graph

              !3.3.1* def L1(bc,d) <- R23(b,cd) for given j3
              call defv(wrk,wrksize,2,l1,ssl1,rx1,symj3,rc1)

              !3.3.1* ext M1(a,d) <- T2abab(a,d,i3,k3) for given i3,k3
              call ext(wrk,wrksize,4,7,i3,k3,symi3,symk3,0,t23,1,m1,ssm1,rc1)

              !3.3.1* map M2(d,a) <- M1(a,d)
              call cct3_map(wrk,wrksize,2,2,1,0,0,m1,ssm1,m2,post,rc1)
              ssm2 = ssm1

              !3.3.1* mult L2(bc,a) <- L1(bc,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !3.3.1 map L1(a,bc) <- L2(bc,a)
              call cct3_map(wrk,wrksize,3,2,3,1,0,l2,ssl2,l1,post,rc1)
              ssl1 = ssl2

              !3.3.1* add (pack) W(a,bc) <- [L1(a,bc)]
              call cct3_add(wrk,wrksize,3,3,0,0,0,0,1,1,real(nsg,kind=wp),l1,symijk,wx,symijk,rc1)

              !3.3.2 O graph

              !3.3.2* ext L1(bc,l) <- T2bbbb(bc,j3l) for given j3
              call ext(wrk,wrksize,4,3,j3,0,symj3,0,0,t22,1,l1,ssl1,rc1)

              !3.3.2* ext M1(l,a) <- W14(l,a,i3k3)=<la||i3k3>baab for given i3,k3
              call ext(wrk,wrksize,4,7,i3,k3,symi3,symk3,0,w14,1,m1,ssm1,rc1)

              !3.3.2* mult L2(bc,a) <- L1(bc,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !3.3.2map L1(a,bc) <- L2(bc,a)
              call cct3_map(wrk,wrksize,3,2,3,1,0,l2,ssl2,l1,post,rc1)
              ssl1 = ssl2

              !3.3.2* add (pack) W(a,bc) <- [L1(a,bc)]
              call cct3_add(wrk,wrksize,3,3,0,0,0,0,1,1,real(nsg,kind=wp),l1,symijk,wx,symijk,rc1)

              !3.4 permutations (ikj)(bac),(ikj)(cab)
              nsg = -1

              !3.4.1 V graph

              !3.4.1* def L1(a,c,d)aba <- R23(a,cd) for given j3
              call defv(wrk,wrksize,4,l1,ssl1,rx1,symj3,rc1)

              !3.4.1* ext M1(d,b) <- T2abab(d,b,i3,k3) for given i3,k3
              call ext(wrk,wrksize,4,7,i3,k3,symi3,symk3,0,t23,1,m1,ssm1,rc1)

              !3.4.1* mult L2(ac,b) <- L1(a,c,d) . M1(d,b)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !3.4.1* add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm T)
              call t3addpck(wrk,wrksize,3,3,l2,wx,-nsg,0,rc1)

              !3.4.2 O graph

              !3.4.2* ext L1(a,c,l) <- T2abab(a,c,l,j3) for given j3
              call ext(wrk,wrksize,4,4,j3,0,symj3,0,0,t23,1,l1,ssl1,rc1)

              !3.4.2* ext M1(l,b) <- W13(l,b,i3k3)=<la||i3k3>abab for given i3,k3
              call ext(wrk,wrksize,4,7,i3,k3,symi3,symk3,0,w13,1,m1,ssm1,rc1)

              !3.4.2* mult L2(ac,b) <- L1(a,c,l) . M1(l,b)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !3.4.2* add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm V)
              call t3addpck(wrk,wrksize,3,3,l2,wx,-nsg,0,rc1)

              !3.5 permutations (jki)(abc) do not contribute

              !3.6 permutations (jki)(bac),(jki)(cab)
              nsg = 1

              !3.6.1 V graph

              !3.6.1* def L1(a,c,d)abb <- R13(a,cd) for given i3
              call defv(wrk,wrksize,3,l1,ssl1,rx3,symi3,rc1)

              !3.6.1* ext M1(db) <- T2bbbb(db,j3k3) for given j3,k3
              call ext(wrk,wrksize,4,7,j3,k3,symj3,symk3,0,t22,1,m1,ssm1,rc1)

              !3.6.1* exp M2(d,a) <- M1(da)
              call cct3_expand(wrk,wrksize,2,1,m1,ssm1,m2,rc1)
              ssm2 = ssm1

              !3.6.1* mult L2(ac,b) <- L1(a,c,d) . M2(d,b)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !3.6.1* add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)] (- do to perm T)
              call t3addpck(wrk,wrksize,3,3,l2,wx,-nsg,0,rc1)

              !3.6.2 O graph

              !3.6.2* ext L1(a,c,l) <- T2abab(a,c,i3,l) for given i3
              call ext(wrk,wrksize,4,3,i3,0,symi3,0,0,t23,1,l1,ssl1,rc1)

              !3.6.2* ext M1(l,b) <- W12(l,b,j3k3)=<la||j3k3>bbbb for given j3,k3
              call ext(wrk,wrksize,4,7,j3,k3,symj3,symk3,0,w12,1,m1,ssm1,rc1)

              !3.6.2* mult L2(ac,b) <- L1(a,c,l) . M1(l,b)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !3.6.2* add (pack) W(a,bc) <- - P(a,c) [L2(ac,b)]
              call t3addpck(wrk,wrksize,3,3,l2,wx,nsg,0,rc1)

              !3.7 add singles

              !3.7.0 mov V <- W
              call cct3_t3grc0(3,2,3,4,4,0,symijk,vx,post)
              call minusa(wrk,wrksize,wx,-One)
              call setb(wrk,wrksize,wx,vx,One)

              if (typt3 > 1) then
                !3.7.1 add part W2 . T1
                call t3sgl(wrk,wrksize,vx,t11,t12,w23,w22,3,i3,j3,k3,symi3,symj3,symk3,rc1,m1,h1,m2,h2,m3,h3)
              end if

              if (typt3 == 3) then
                !3.7.2 add part T2 . U
                call t3sgl(wrk,wrksize,vx,fk3,fk4,t23,t22,3,i3,j3,k3,symi3,symj3,symk3,rc1,m1,h1,m2,h2,m3,h3)
              end if

              !3.8 divide by denominators and calc energy contribution

              !3.8.1 divide by den.
              call t3div(wrk,wrksize,wx,vx,dp1,dp2,3,i3,j3,k3,symi3,symj3,symk3,ec,rc1)

              !3.8.2 add energy contribution
              eabb = eabb+ec

            end if

            !4 ***** bbb spin combination *****

            !4.* def keyyes
            if (symj > symk) then
              keyyes = 1
            else if (symj == symk) then
              if (j > k) then
                keyyes = 1
              else
                keyyes = 0
              end if
            else
              keyyes = 0
            end if

            if ((i > nob(symi)) .or. (j > nob(symj)) .or. (k > nob(symk))) then
              keyyes = 0
            end if

            if (keyyes == 1) then

              !4.* define maps of W(abc)
              call cct3_t3grc0(3,5,4,4,4,0,symijk,wx,post)

              !4.* vanish W(abc)
              call stz(wrk,wrksize,wx)

              !4.1 permutations (ijk) P(a,bc) (general sign+)
              nsg = 1

              !4.1.1 V graph

              !4.1.1* def L1(bc,d) <- R3(b,cd) for given k
              call defv(wrk,wrksize,2,l1,ssl1,rx3,symk,rc1)

              !4.1.1* ext M1(da) <- T2bbbb(da,ij) for given i,j
              call ext(wrk,wrksize,4,7,i,j,symi,symj,0,t22,1,m1,ssm1,rc1)

              !4.1.1* exp M2(d,a) <- M1(da)
              call cct3_expand(wrk,wrksize,2,1,m1,ssm1,m2,rc1)
              ssm2 = ssm1

              !4.1.1* mult L2(bc,a) <- L1(bc,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !4.1.1* pack W(abc) <-  P(a,bc) [L2(bc,a)] (minus due to using Tikda instead of T2ikad)
              call t3addpck(wrk,wrksize,3,1,l2,wx,-nsg,0,rc1)

              !4.1.2 O graph

              !4.1.2* ext L1(bc,l) <- T2bbbb(bc,kl) for given k
              call ext(wrk,wrksize,4,3,k,0,symk,0,0,t22,1,l1,ssl1,rc1)

              !4.1.2* ext M1(l,a) <- W12(l,a,ij)=<la||ij>bbbb for given ij
              call ext(wrk,wrksize,4,7,i,j,symi,symj,0,w12,1,m1,ssm1,rc1)

              !4.1.2* mult L2(bc,a) <- L1(bc,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !4.1.2* pack W(abc) <- P(a,bc) [L2(bc,a)]
              call t3addpck(wrk,wrksize,3,1,l2,wx,nsg,0,rc1)

              !4.2 permutations (ikj) P(a,bc)
              nsg = -1

              !4.2.1 V graph

              !4.2.1* def L1(bc,d) <- R2(b,cd) for given j
              call defv(wrk,wrksize,2,l1,ssl1,rx2,symj,rc1)

              !4.2.1* ext M1(da) <- T2bbbb(da,ik) for given i,k
              call ext(wrk,wrksize,4,7,i,k,symi,symk,0,t22,1,m1,ssm1,rc1)

              !4.2.1* exp M2(d,a) <- M1(da)
              call cct3_expand(wrk,wrksize,2,1,m1,ssm1,m2,rc1)
              ssm2 = ssm1

              !4.2.1* mult L2(bc,a) <- L1(bc,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !4.2.1* pack W(abc) <- - P(a,bc) [L2(bc,a)] (minus is due to using Tikda instead of T2ikad)
              call t3addpck(wrk,wrksize,3,1,l2,wx,-nsg,0,rc1)

              !4.2.2 O graph

              !4.2.2* ext L1(bc,l) <- T2bbbb(bc,jl) for given j
              call ext(wrk,wrksize,4,3,j,0,symj,0,0,t22,1,l1,ssl1,rc1)

              !4.2.2* ext M1(l,a) <- W12(l,a,ik)=<la||ik>bbbb for given ik
              call ext(wrk,wrksize,4,7,i,k,symi,symk,0,w12,1,m1,ssm1,rc1)

              !4.2.2* mult L2(bc,a) <- L1(bc,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !4.2.2* pack W(abc) <- P(a,bc) [L2(bc,a)]
              call t3addpck(wrk,wrksize,3,1,l2,wx,nsg,0,rc1)

              !4.3 permutations (jki) P(a,bc)
              nsg = 1

              !4.3.1 V graph

              !4.3.1* def L1(bc,d) <- R1(b,cd) for given i
              call defv(wrk,wrksize,2,l1,ssl1,rx1,symi,rc1)

              !4.3.1* ext M1(da) <- T2bbbb(da,jk) for given j,k
              call ext(wrk,wrksize,4,7,j,k,symj,symk,0,t22,1,m1,ssm1,rc1)

              !4.3.1* exp M2(d,a) <- M1(da)
              call cct3_expand(wrk,wrksize,2,1,m1,ssm1,m2,rc1)
              ssm2 = ssm1

              !4.3.1* mult L2(bc,a) <- L1(bc,d) . M2(d,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m2,ssm2,l2,ssl2,rc1)

              !4.3.1* pack W(abc) <- - P(a,bc) [L2(bc,a)] (minus is due to using Tjkda instead of T2jkad)
              call t3addpck(wrk,wrksize,3,1,l2,wx,-nsg,0,rc1)

              !4.3.2 O graph

              !4.3.2* ext L1(bc,l) <- T2bbbb(bc,kl) for given i
              call ext(wrk,wrksize,4,3,i,0,symi,0,0,t22,1,l1,ssl1,rc1)

              !4.3.2* ext M1(l,a) <- W12(l,a,jk)=<la||jk>bbbb for given jk
              call ext(wrk,wrksize,4,7,j,k,symj,symk,0,w12,1,m1,ssm1,rc1)

              !4.3.2* mult L2(bc,a) <- L1(bc,l) . M1(l,a)
              call cct3_mult(wrk,wrksize,3,2,3,1,l1,ssl1,m1,ssm1,l2,ssl2,rc1)

              !4.3.2* pack W(abc) <-  P(a,bc) [L2(bc,a)]
              call t3addpck(wrk,wrksize,3,1,l2,wx,nsg,0,rc1)

              !4.4 add singles

              !4.4.0 mov V <- W
              call cct3_t3grc0(3,5,4,4,4,0,symijk,vx,post)
              call minusa(wrk,wrksize,wx,-One)
              call setb(wrk,wrksize,wx,vx,One)

              if (typt3 > 1) then
                !4.4.1 add part W2 . T1
                call t3sgl(wrk,wrksize,vx,t12,t11,w22,w21,1,i,j,k,symi,symj,symk,rc1,m1,h1,m2,h2,m3,h3)
              end if

              if (typt3 == 3) then
                !4.4.2 add part T2 . U
                call t3sgl(wrk,wrksize,vx,fk4,fk3,t22,t21,1,i,j,k,symi,symj,symk,rc1,m1,h1,m2,h2,m3,h3)
              end if

              !4.5 divide by denominators and calc energy contribution

              !4.5.1 divide by den.
              call t3div(wrk,wrksize,wx,vx,dp2,dp1,1,i,j,k,symi,symj,symk,ec,rc1)

              !4.5.2 add energy contribution
              ebbb = ebbb+ec

            end if

          end do
        end do

        !par Separate printing of partial energies e... are
        !    useful only in serial run. For parallel run also
        !    cycle over k is segmented (via parallelization),
        !    so e... are not complete contributions (only sum
        !    over all nodes have some sense). Thus, these values
        !    in parallel run are too dangerous to use separately
        !    so their printout is suppressed.

        if (nProcs == 1) then
          call t3wresult(symi,symj,i,j,eaaa(1),eaab(1),eabb(1),ebbb(1))
          if (fullprint > 1) then
            write(u6,*) ' Eaaa =',eaaa
            write(u6,*) ' Eaab =',eaab
            write(u6,*) ' Eabb =',eabb
            write(u6,*) ' Ebbb =',ebbb
          end if
        end if
        !endpar

      end do
    end do
  end do
end do

!o ***** final section *****

!o.* allreduced energy components
call gadgop(eaaa,1,'+')
call gadgop(eaab,1,'+')
call gadgop(eabb,1,'+')
call gadgop(ebbb,1,'+')
!stare call MPI_ALLREDUCE(ebbb,ec,1,MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,rc)
!      ebbb = ec

!o.* type results

if (fullprint >= 0) then
  write(u6,'(6X,A,F24.13)') ' CCSD     =',eccsd
  write(u6,'(6X,A,F24.13)') ' T3 corr. =',eaaa+eaab+eabb+ebbb
  write(u6,'(6X,A,F24.13)') ' CCSD + T3=',eccsd+eaaa+eaab+eabb+ebbb
  write(u6,*) ' T3 energy decomposition into spin parts'
  write(u6,*) ' Eaaa =',eaaa
  write(u6,*) ' Eaab =',eaab
  write(u6,*) ' Eabb =',eabb
  write(u6,*) ' Ebbb =',ebbb
  write(u6,*)
  write(u6,*)
  write(u6,'(6X,A)') 'Happy Landing!'
  write(u6,*)
end if
call add_Info('E_CCSD_T',eccsd+eaaa+eaab+eabb+ebbb,1,8)
! Export a method and energy to the MOLCAS runfile
call Put_cArray('Relax Method','CCSDT   ',8)
call Store_Energies(1,eccsd+eaaa+eaab+eabb+ebbb,1)
! Releasing the memory
call mma_deallocate(wrk)

ireturn = 0

return

999 format(' I,J,K ',3(i3,1x))

end subroutine CCT3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_2darray_sort

! Sorting module with a very simple O(N^2) insertion sort algorithm
! for integer 2-d arrays like (3,:) according to input key 1-3
!
   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_insertion_sort

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_insertion_sort(arr,xyz)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(INOUT) :: arr(:,:)
      INTEGER(INTK), INTENT(IN)    :: xyz

      INTEGER(INTK) :: tmp(3)
      INTEGER(INTK) :: i, j

      iloop: DO i = 1, SIZE(arr,2)
         tmp(:) = arr(:,i)
         DO j = (i-1), 1, -1
            IF (arr(xyz,j) > tmp(xyz)) THEN
               arr(:,j+1) = arr(:,j)
            ELSE
               arr(:,j+1) = tmp(:)
               CYCLE iloop
            END IF
         END DO
         arr(:,1) = tmp(:)
      END DO iloop

   END SUBROUTINE fmm_insertion_sort

!-------------------------------------------------------------------------------

END MODULE fmm_2darray_sort

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  CIWR   := Write CI vector.                                         *
!*                                                                     *
!***********************************************************************
subroutine ciwr_cvb(cvec,recn)

use casvb_global, only: icnt_ci, iform_ci, ndet
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_IN_) :: cvec(0:ndet)
real(kind=wp), intent(in) :: recn
integer(kind=iwp) :: iformat, ioffs, ivec

ivec = nint(cvec(0))
iformat = iform_ci(ivec)
if (iformat == 0) then
  ioffs = 0
  call wris_cvb(iform_ci(ivec),1,recn,ioffs)
  call wris_cvb(icnt_ci(ivec),1,recn,ioffs)
  call wrrs_cvb(cvec(1:),ndet,recn,ioffs)
else
  write(u6,*) ' Unsupported format in CIWR :',iformat
  call abend_cvb()
end if

return

end subroutine ciwr_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Precabb(ib,is,js,nd,nba,rout,Temp1,ntemp,
     &                   Scr,Temp2,fockti,
     &                   focki,focka,fock,sign)
************************************************************************
*                                        [2]
*   Calculates the diagonal submatrix of E    that couple
*
*   kappa           with   kappa                for a
*        kactive,virtual        kactive,virtual
*
*   single active index.
*   Used for preconditioner.
*
*   See Olsen,Yeager, Joergensen:
*    "Optimization and characterization of an MCSCF state"
*
*   Called by prec
*
*   ib,is       :       active index for the submatrix
*   js          :       symmetry of virtual,virtual
*   rOut        :       Submatrix
*
************************************************************************
      use Arrays, only: G1t, G2t
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
      Real*8 rout(*)
      Real*8 Temp2(nBa,nBa),Focki(nBa,nBa),Focka(nBa,nBa),
     &       Fock(nBa,nBa)
      Real*8 Temp1(nTemp),Scr(nTemp)
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      iTri1(i,j)=nTri-itri(nd-Min(i,j)+1,nd-Min(i,j)+1)
     &          +Max(i,j)-Min(i,j)+1
*                                                                      *
************************************************************************
*                                                                      *
      nTri=itri(nd,nd)
*
      iib=ib+nA(is)
      jVert=nBas(js)-nAsh(js)-nIsh(js)
      If (jvert.eq.0) Return
*
      i2=nD-jVert+1
      ip=iTri1(i2,i2)
      rF=sign*Fockti
      call dcopy_(nBa**2,[0.0d0],0,Temp2,1)
*
      Do kS=1,nSym
         If (nBas(js)*nash(ks).gt.0) Then
            Do kBB=nish(ks)+1,nB(kS)
               Do kCC=nish(ks)+1,kBB
                  Call COUL(jS,jS,kS,kS,kbb,kcc,Temp1,Scr)
                  If (kBB.gt.nish(ks).and.kCC.gt.nish(ks)) Then
                     kkB=kBB+nA(ks)-nish(ks)
                     kkC=kCC+nA(ks)-Nish(ks)
                     rDens1=sign*2.0d0*G2t(
     &                      itri(itri(iib,iib),itri(kkb,kkc)))
*
                     If (kbb.ne.kcc) rdens1=rdens1*2.0d0
                     Call DaxPy_(nBa**2,rdens1,Temp1,1,Temp2,1)
                  End If
               End Do
            End Do
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Do kS=1,nsym
         If (nBas(jS)*nAsh(kS).ne.0) Then
*
            Do lB=nish(kS)+1,nB(kS)
               kkC=nA(kS)+lB-nIsh(kS)
               Do jB=nIsh(kS)+1,nB(kS)
                  kkb=nA(kS)+jB-nIsh(kS)
                  Call EXCH(js,ks,js,ks,jb,lb,Temp1,Scr)
                  If (lB.gt.nIsh(kS).and.jB.gt.nIsh(kS)) Then
                     rDens2=sign*4.0d0*G2t(
     &                      itri(itri(iib,kkc),itri(kkb,iib)))
                    Call DaXpY_(nBa**2,rDens2,Temp1,1,Temp2,1)
                  End If
               End Do
            End Do
         End If
      End Do
*
      rho=sign*2.0d0*G1t(itri(iib,iib))
      Do iI=nAsh(js)+nIsh(js)+1,nBas(js)
         rOut(ip)=rout(ip)-2.0d0*rF+Rho*FockI(iI,ii)+Temp2(ii,ii)
         ip=ip+1
         Do iJ=iI+1,Nbas(js)
            rOut(ip)=Rho*FockI(iI,iJ)+Temp2(ii,ij)
            ip=ip+1
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(focka)
      If (.False.) Call Unused_real_array(fock)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Transpose_TDM
!
!> @brief
!>   Transpose a transition density matrix in place.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Transpose a transition density matrix, stored in symmetry blocks,
!> replacing the original matrix. The matrices contain only the symmetry
!> blocks that match the total symmetry of the transition.
!>
!> @param[in,out] TDM       Transition density matrix
!> @param[in]     Symmetry  Symmetry of the transition
!***********************************************************************

subroutine Transpose_TDM(TDM,Symmetry)

use Symmetry_Info, only: Mul, nIrrep
use rassi_data, only: NBASF
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: TDM(*)
integer(kind=iwp), intent(in) :: Symmetry
integer(kind=iwp) :: i, iBlock(0:8), iSym1, iSym2, j, nTot
real(kind=wp), allocatable :: Tmp(:)

! Compute the location of all the stored symmetry blocks
nTot = 0
iBlock(0) = 0
do iSym1=1,nIrrep
  nTot = nTot+nBasF(iSym1)*nBasF(Mul(Symmetry,iSym1))
  iBlock(iSym1) = nTot
end do
! Make a copy so we can transpose in place
call mma_Allocate(Tmp,nTot,Label='Tmp')
Tmp(:) = TDM(1:nTot)
! Transpose symmetry block (a,b) onto symmetry block (b,a)
do iSym1=1,nIrrep
  iSym2 = Mul(Symmetry,iSym1)
  do i=1,nBasF(iSym2)
    do j=1,nBasF(iSym1)
      TDM(iBlock(iSym2-1)+(j-1)*nBasF(iSym2)+i) = Tmp(iBlock(iSym1-1)+(i-1)*nBasF(iSym1)+j)
    end do
  end do
end do
call mma_deAllocate(Tmp)

end subroutine Transpose_TDM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine map21 (a,b,dimp,dimq,p,q,nfact)
c
c     maping A(p1,q1) -> nfact*B(p2,q2)
c
       real*8 a(*)
       real*8 b(*)
       integer dim(2)
       integer dimp,dimq,p,q,nfact
       dim(p)=dimp
       dim(q)=dimq
       call map22 (a,b,dimp,dimq,dim(1),dim(2),p,q,nfact)
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine hess_cvb(vec)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension vec(*)

      n_hess=n_hess+1
      if(.not.up2date_cvb('OOHESS'))then
        call make_cvb('OOHESS')
        call oohess_cvb(w(lv(1)),w(lc(2)),w(lc(3)),w(lc(4)),
     >    w(lw(1)),w(lw(2)),w(lw(3)),
     >    w(lq(8)),w(lq(9)),w(lq(3)),w(lq(4)))
      endif
      i1 = mstackr_cvb(npr)
      i2 = mstackr_cvb(npr)
      i3 = mstackr_cvb(norb*norb)
      i4 = mstackr_cvb(norb*norb)
      call free2all_cvb(vec,w(i1),1)
      if(icrit.eq.1)then
        call hess_svb1_cvb(w(lv(1)),
     >    w(lc(2)),w(lc(3)),w(lc(4)),w(lc(5)),
     >    w(lw(1)),w(lw(2)),w(lw(3)),
     >    w(lw(4)),w(lw(5)),w(lw(6)),
     >    w(lw(10)),
     >    w(lq(7)),w(lq(8)),w(lq(3)),
     >    w(lq(10)),iw(ls(11)),
     >    w(i1),w(i2),w(i3),w(i4))
      elseif(icrit.eq.2)then
        call hess_evb1_cvb(w(lv(1)),
     >    w(lc(2)),w(lc(3)),w(lc(4)),
     >    w(lw(2)),w(lw(3)),
     >    w(lw(4)),w(lw(5)),w(lw(6)),
     >    w(lw(10)),
     >    w(lq(7)),w(lq(8)),w(lq(3)),
     >    w(lq(10)),iw(ls(11)),
     >    w(i1),w(i2))
      endif
      call all2free_cvb(w(i2),vec,1)
      call mfreer_cvb(i1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Integer Function iPntSO(j1,j2,lOper,nbas)
************************************************************************
*                                                                      *
* Object: to compute the offset to an one-electron integral block.     *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             February '91                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Integer nbas(0:7)
*
      iPntSO=0
      iSmLbl = lOper
      Do iIrrep = 0, j1
         jMax = iIrrep
         If (iIrrep.eq.j1) jMax = j2-1
         Do 20 jIrrep = 0, jMax
            ij = iEor(iIrrep,jIrrep)
            If (iAnd(iSmLbl,2**ij).eq.0) Go To 20
            If (iIrrep.eq.jIrrep) Then
               iPntSO = iPntSO + nBas(iIrrep)*(nBas(iIrrep)+1)/2
            Else
               iPntSO = iPntSO + nBas(iIrrep)*nBas(jIrrep)
            End If
 20      Continue
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine CIDens(response,iLS,iRS,iL,iR,iS,rP,rD)
      use ipPage, only: W
      Implicit Real*8(a-h,o-z)

#include "real.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "stdalloc.fh"
#include "crun_mclr.fh"

#include "Input.fh"
#include "Pointers.fh"
#include "spinfo_mclr.fh"
#include "cands.fh"
#include "dmrginfo_mclr.fh"
      Real*8 rP(*),rD(*)
      integer opout
      Logical Response
      Real*8, Allocatable:: De(:), Pe(:), CIL(:), CIR(:)

      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

* LS = CI
*
*     Ok, we once more want to hide Jeppe's routines from
*     the eyes of the world, so everyone believes that I have done
*     all the work.
*     If we have spin dependent Hamiltonian we will work with
*     SD in all parts of the program, no CSF is necessary,
*     otherwise we will do the optimization in CSF's to increase
*     convergence.
*
*     Input:
*
*     response: true if the density should be used for response calculations
*     iLS: CI Coeff for left state
*     iRS: CI Coeff for right state
*     iL : Symmetry of left state
*     iR : Symmetry of right state
*
*               +       +
*     iS=1 E  =a  a  + a  a
*           pq  ap aq   Bp Bq
*
*                +       +
*     iS=-1 T  =a  a  - a a
*            pq  ap aq   Bp Bq
*
*     Output:
*
*      rP : Two Electron Density
*      rD : One Electron Density
*
*

      If (nconf1.eq.0) return

      if(doDMRG)then  !yma
        call dmrg_dim_change_mclr(LRras2(1:8),ndim,0)
        call dmrg_dim_change_mclr(LRras2(1:8),nna,0)
        n1dens=ndim**2
        n2dens=n1dens*(n1dens+1)/2
      end if

      Call mma_allocate(De,n1dens,Label='De')
      Call mma_allocate(Pe,n2dens,Label='Pe')
      De(:)=Zero
      Pe(:)=Zero

      If (nocsf.eq.0) Then
        nConfL=Max(ncsf(il),nint(xispsm(il,1)))
        nConfR=Max(ncsf(iR),nint(xispsm(iR,1)))
        Call mma_allocate(CIL,nConfL,Label='CIL')
        irc=ipin1(iLS,nconfL)
        Call CSF2SD(W(iLS)%Vec,CIL,iL)
        irc=opout(iLs)
        Call mma_allocate(CIR,nConfR,Label='CIR')
        irc=ipin1(iRS,nconfR)
        Call CSF2SD(W(iRS)%Vec,CIR,iR)
        irc=opout(irs)
        irc=ipnout(-1)
        icsm=iR
        issm=iL
        Call Densi2(2,De,Pe,CIL,CIR,0,0,0,n1dens,n2dens)

        If (.not.timedep) Then
         If (response) Then
          Do iA=1,nnA
           Do jA=1,nnA
            Do kA=1,nnA
             Do la=1,nnA
              ij1=nnA*(iA-1)+ja
              ij2=nna*(ja-1)+ia
              kl1=nnA*(ka-1)+la
              kl2=nna*(la-1)+ka
              rp(itri(ij1,kl1))=
     &         Pe(itri(ij1,kl1))+Pe(itri(ij2,kl2))
             End Do
            End Do
           End Do
          End Do
          Do iA=1,nnA
           Do jA=1,nnA
              ij1=nnA*(iA-1)+ja
              ij2=nna*(ja-1)+ia
              rD(ij1)=De(ij1)+De(ij2)
           End Do
          End Do

         Else
          call dcopy_(n2dens,Pe,1,rp,1)
          call dcopy_(n1dens,De,1,rD,1)
         End If
        Else
          call dcopy_(n2dens,Pe,1,rp,1)
          call dcopy_(n1dens,De,1,rD,1)
          iCSM=iL
          iSSM=iR
          Call Densi2(2,De,Pe,CIR,CIL,0,0,0,n1dens,n2dens)
          call daxpy_(n2Dens,-One,Pe,1,rp,1)
          call daxpy_(n1Dens,-One,De,1,rD,1)
         End If
         Call mma_deallocate(CIL)
         Call mma_deallocate(CIR)
      else
        issm=iL
        icsm=iR
        irc=ipin(iLS)
        irc=ipin(iRS)
        Call Densi2(2,De,Pe,W(iLS)%Vec,W(iRS)%Vec,0,0,0,n1dens,n2dens)
        If (.not.timedep) Then
         If (response) Then
          Do iA=1,nnA
           Do jA=1,nnA
            Do kA=1,nnA
             Do la=1,nnA
              ij1=nnA*(iA-1)+ja
              ij2=nna*(ja-1)+ia
              kl1=nnA*(ka-1)+la
              kl2=nna*(la-1)+ka
              rp(itri(ij1,kl1))=
     &         Pe(itri(ij1,kl1))+Pe(itri(ij2,kl2))
             End Do
            End Do
           End Do
          End Do
          Do iA=1,nnA
           Do jA=1,nnA
              ij1=nnA*(iA-1)+ja
              ij2=nna*(ja-1)+ia
              rD(ij1)=De(ij1)+De(ij2)
           End Do
          End Do
         Else
          call dcopy_(n2dens,Pe,1,rp,1)
          call dcopy_(n1dens,De,1,rD,1)
         End If
        Else
          call dcopy_(n2dens,Pe,1,rp,1)
          call dcopy_(n1dens,De,1,rD,1)
          iCSM=iL
          iSSM=iR
          irc=ipin(iRS)
          irc=ipin(iLS)
          Call Densi2(2,De,Pe,W(iRS)%Vec,W(iLS)%Vec,0,0,0,n1dens,n2dens)
          call daxpy_(n2Dens,-One,Pe,1,rp,1)
          call daxpy_(n1Dens,-One,De,1,rD,1)
         End If
      End If
      Call mma_deallocate(Pe)
      Call mma_deallocate(De)

      if(doDMRG)then  ! yma
        call dmrg_dim_change_mclr(RGras2(1:8),ndim,0)
        call dmrg_dim_change_mclr(RGras2(1:8),nna,0)
        n1dens=ndim**2
        n2dens=n1dens*(n1dens+1)/2
      end if

      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iS)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Picky(nSD,iSD4,i,j)

use k2_arrays, only: DeDe
use Dens_Stuff, only: ipDDij, ipDDik, ipDDil, ipDDjk, ipDDjl, ipDDkl, ipDij, ipDik, ipDil, ipDjk, ipDjl, ipDkl, mDCRij, mDCRik, &
                      mDCRil, mDCRjk, mDCRjl, mDCRkl, mDij, mDik, mDil, mDjk, mDjl, mDkl
use Symmetry_Info, only: nIrrep
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: i, j, nSD, iSD4(0:nSD,4)
integer(kind=iwp) :: i1, i2, i3, iBasAO, iBasi, iBasn, iBsInc, iCmpi, ii1, ii2, ii3, iPrimi, iShell, j1, j2, j3, jBasAO, jBasj, &
                     jBasn, jBsInc, jCmpj, jj1, jj2, jj3, jPrimj, jShell
integer(kind=iwp), pointer :: ipDD_ij, ipD_ij, mDCR_ij, mD_ij

iCmpi = iSD4(2,i)
iBasi = iSD4(3,i)
iPrimi = iSD4(5,i)
iShell = iSD4(11,i)
iBsInc = iSD4(4,i)
iBasAO = iSD4(8,i)+1
iBasn = iSD4(19,i)

jCmpj = iSD4(2,j)
jBasj = iSD4(3,j)
jPrimj = iSD4(5,j)
jShell = iSD4(11,j)
jBsInc = iSD4(4,j)
jBasAO = iSD4(8,j)+1
jBasn = iSD4(19,j)

if ((i == 1) .and. (j == 2)) then
  mDCR_ij => mDCRij
  ipD_ij => ipDij
  ipDD_ij => ipDDij
  mD_ij => mDij
else if ((i == 1) .and. (j == 3)) then
  mDCR_ij => mDCRik
  ipD_ij => ipDik
  ipDD_ij => ipDDik
  mD_ij => mDik
else if ((i == 1) .and. (j == 4)) then
  mDCR_ij => mDCRil
  ipD_ij => ipDil
  ipDD_ij => ipDDil
  mD_ij => mDil
else if ((i == 2) .and. (j == 3)) then
  mDCR_ij => mDCRjk
  ipD_ij => ipDjk
  ipDD_ij => ipDDjk
  mD_ij => mDjk
else if ((i == 2) .and. (j == 4)) then
  mDCR_ij => mDCRjl
  ipD_ij => ipDjl
  ipDD_ij => ipDDjl
  mD_ij => mDjl
else if ((i == 3) .and. (j == 4)) then
  mDCR_ij => mDCRkl
  ipD_ij => ipDkl
  ipDD_ij => ipDDkl
  mD_ij => mDkl
else
  write(u6,*) 'Picky: illegal i and j combination'
  write(u6,*) 'i,j=',i,j
  call Abend()
  nullify(mDCR_ij)
  nullify(ipD_ij)
  nullify(ipDD_ij)
  nullify(mD_ij)
end if

if (nIrrep == 1) then
  ii1 = 0
  ii2 = 1
  ii3 = 0
  jj1 = 0
  jj2 = 1
  jj3 = 0
else
  ii1 = iBasi
  ii2 = iBasAO
  ii3 = iBasn
  jj1 = jBasj
  jj2 = jBasAO
  jj3 = jBasn
end if
if (mDCR_ij /= 0) then
  if (iShell >= jShell) then
    i1 = ii1
    i2 = ii2
    i3 = ii3
    j1 = jj1
    j2 = jj2
    j3 = jj3
  else
    i1 = jj1
    i2 = jj2
    i3 = jj3
    j1 = ii1
    j2 = ii2
    j3 = ii3
  end if
  if ((iBasi == iBsInc) .and. (jBasj == jBsInc)) then
    ipDD_ij = ipD_ij
  else
    call Picky_inner(DeDe(ipD_ij),i1,j1,iPrimi*jPrimj,iCmpi*jCmpj,mDCR_ij,i2,i2+i3-1,j2,j2+j3-1,DeDe(ipDD_ij))
  end if
end if
mD_ij = (ii3*jj3+1)*iCmpi*jCmpj+iPrimi*jPrimj+1

return

end subroutine Picky

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      SubRoutine SroHss(
#define _CALLING_
#include "hss_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of ECP integrals.         *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      p     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      final : array for computed integrals                            *
*      nzeta : nalpha x nbeta                                          *
*      ncomp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      a     : center of bra gaussian                                  *
*      b     : center of ket gaussian                                  *
*      nrys  : order of rys- or Hermite-Gauss polynomial               *
*      array : auxiliary memory as requested by ECPMem                 *
*      narr  : length of array                                         *
*      ccoor : coordinates of the operator, zero for symmetric oper.   *
*      nordop: order of the operator                                   *
************************************************************************
      use Basis_Info
      use Center_Info
      use Real_Spherical
      use Symmetry_Info, only: iOper
      implicit real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "disp.fh"
#include "disp2.fh"

#include "hss_interface.fh"

*     Local variables
      Real*8 C(3), TC(3), Coor(3,4),  g2(78)
      Integer iDCRT(0:7), iuvwx(4), kOp(4),mop(4),
     &        JndGrd(3,4,0:7),jndhss(4,3,4,3,0:7)
      logical jfgrd(3,4),  EQ, jfhss(4,3,4,3), ifg(4),tr(4)
*
       nelem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      nRys=nHer
*
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      call icopy(2,nop,1,mop,1)
      kop(1) = ioper(nop(1))
      kop(2) = ioper(nop(2))
      call dcopy_(3,A,1,coor(1,1),1)
      call dcopy_(3,RB,1,coor(1,2),1)

*
      kdc = 0
      do 1960 kcnttp = 1, ncnttp
         if (.not.dbsc(kcnttp)%ECP) Go To 1961
         if (dbsc(kcnttp)%nSRO.le.0) Go To 1961
         do 1965 kcnt = 1,dbsc(kCnttp)%nCntr
            C(1:3)=dbsc(kCnttp)%Coor(1:3,kCnt)
*
            call dcr(lmbdt,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            fact = dble(nstabm) / DBLE(LmbdT)
*
            iuvwx(3) = dc(kdc+kCnt)%nStab
            iuvwx(4) = dc(kdc+kCnt)%nStab

*
         do 1967 ldcrt = 0, ndcRT-1


            kop(3) = idcrt(ldcrT)
            kop(4) = kop(3)
            mop(3) = nropr(kop(3))
            mop(4) = mop(3)

            Call OA(iDCRT(lDCRT),C,TC)
            call dcopy_(3,TC,1,Coor(1,3),1)

            if (eq(a,rb).and.eq(A,TC)) Go To 1967
            call nucind(coor,kdc+kCnt,ifgrd,ifhss,indgrd,indhss,
     &                  jfgrd,jfhss,jndgrd,jndhss,tr,ifg)
            do 1966 iang = 0, dbsc(kCnttp)%nSRO-1
               ishll = dbsc(kcnttp)%iSRO + iAng
               nExpi=Shells(iShll)%nExp
               if (nExpi.eq.0) Go To 1966
*
               ip = 1
               ipfin = ip
               ip = ip + nzeta*nElem(la)*nElem(lb)*21
               ipfa1 = ip
               ip = ip + nalpha*nExpi*nElem(la)*nElem(iAng)*4
               iptmp = ip
               ip = ip + nalpha*nExpi
               ipfa2 = ip
               ip = ip + nalpha*nExpi*nElem(la)*nElem(iAng)*6
               ipfb1 = ip
               ip = ip + nExpi*nBeta*nElem(iAng)*nElem(lb)*4
               ipfb2 = ip
               ip = ip + nExpi*nBeta*nElem(iAng)*nElem(lb)*6

               call dcopy_(narr,[Zero],0,Array,1)
*              <a|c>, <a'|c>, <a",c>
               Call Acore(iang,la,ishll,nordop,TC,A,Array(ip),
     &                     narr-ip+1,Alpha,nalpha,Array(ipFA1),
     &                     array(ipfa2),jfgrd(1,1),jfhss,
     &                     2,.false.)
*              Transform core orbital to spherical harmonics
               call LToSph(Array(ipFA1),nAlpha,ishll,la,iAng,4)
               call LToSph(Array(ipFA2),nAlpha,ishll,la,iAng,6)

*              <c|b>,<c,b'>,<c|b">
               Call coreB(iang,lb,ishll,nordop,TC,RB,Array(ip),
     &                    narr-ip+1,Beta,nbeta,Array(ipFB1),
     &                    array(ipfb2),jfgrd(1,2),jfhss,
     &                    2,.false.)
*              Transform core orbital to spherical harmonics
               call RToSph(Array(ipFB1),nBeta,ishll,lb,iAng,4)
               call RToSph(Array(ipFB2),nBeta,ishll,lb,iAng,6)

*              Construct complete derivatives (contracting core)
               Call CmbnACB2(Array(ipFa1),Array(ipFa2),Array(ipFb1),
     &                        Array(ipFb2),Array(ipFin),Fact,
     &                        nalpha,nbeta,
     &                        Shells(iShll)%Akl,nExpi,
     &                        la,lb,iang,jfhss,Array(ipTmp),.true.)


*              contract density
               nt=nZeta*(la+1)*(la+2)/2*(lb+1)*(lb+2)/2
               mvec=21
               call dcopy_(78,[Zero],0,g2,1)
               Call dGeMV_('T',nT,21,
     &                    One,Array(ipFin),nT,
     &                    DAO,1,
     &                    Zero,g2,1)

*              distribute in hessian
               Call Distg2(g2,Hess,nHess,JndGrd,
     &                  JfHss,JndHss,iuvwx,kOp,mop,Tr,IfG)

*
 1966       Continue
 1967    Continue
 1965    Continue
 1961    Continue
         kdc = kdc + dbsc(kCnttp)%nCntr
 1960    Continue
         Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Zeta)
         Call Unused_real_array(ZInv)
         Call Unused_real_array(rKappa)
         Call Unused_real_array(P)
         Call Unused_real_array(Final)
         Call Unused_integer(nRys)
         Call Unused_real_array(Ccoor)
         Call Unused_integer_array(lOper)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine NAInt( &
#                define _CALLING_
#                include "int_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of nuclear attraction     *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, January 1991                            *
!***********************************************************************

use Basis_Info, only: dbsc, Gaussian_Type, iCnttp_Dummy, mGaussian_Type, nCnttp, Nuclear_Model, Point_Charge
use Center_Info, only: dc
use Gateway_global, only: Primitive_Pass
use DKH_Info, only: DKroll
use Index_Functions, only: nTri3_Elem1, nTri_Elem1
use Constants, only: Zero, One, Two, Three, OneHalf, Pi, TwoP54
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "oneswi.fh"
#include "print.fh"
integer(kind=iwp) :: i, iAnga(4), iDCRT(0:7), ii, ipIn, ipOff, iPrint, iRout, kCnt, kCnttp, kdc, lc, ld, lDCRT, LmbdT, mabMax, &
                     mabMin, mArr, mcdMax, mcdMin, nDCRT, nFLOP, nMem, nOp, nT
real(kind=wp) :: C(3), Coora(3,4), CoorAC(3,2), Coori(3,4), EInv, Eta, Fact, Q_Nuc, rKappcd, TC(3)
logical(kind=iwp) :: lECP, No3Cnt, NoSpecial
character(len=*), parameter :: ChOper(0:7) = ['E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz']
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ
! Used for normal nuclear attraction integrals: TNAI, Fake, XCff2D, XRys2D
! Used for finite nuclei: TERI, ModU2, vCff2D, vRys2D
external :: Fake, ModU2, TERI, TNAI, vCff2D, vRys2D, XCff2D, XRys2D

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(nHer)
unused_var(Ccoor)
unused_var(nOrdOp)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 151
iPrint = nPrint(iRout)

rFinal(:,:,:,:) = Zero

lECP = .false.
do i=1,nCnttp
  lECP = lECP .or. dbsc(i)%ECP
end do
lc = 0
ld = 0
iAnga(1) = la
iAnga(2) = lb
iAnga(3) = lc
iAnga(4) = ld
Coora(:,1) = A
Coora(:,2) = RB
Coori(:,1:2) = Coora(:,1:2)
mabMin = nTri3_Elem1(max(la,lb)-1)
mabMax = nTri3_Elem1(la+lb)-1
No3Cnt = .false.
if (EQ(A,RB)) then
  mabMin = nTri3_Elem1(la+lb-1)
else if (NDDO) then
  No3Cnt = .true.
end if

! Compute FLOPs and size of work array which Hrr will use.

call mHrr(la,lb,nFLOP,nMem)

! Find center to accumulate angular momentum on. (HRR)

if (la >= lb) then
  CoorAC(:,1) = A
else
  CoorAC(:,1) = RB
end if

! Modify Zeta if the two-electron code will be used!

if ((Nuclear_Model == Gaussian_Type) .or. (Nuclear_Model == mGaussian_Type)) then
  rKappa(:) = rKappa*(TwoP54/Zeta)
end if

! Loop over nuclear centers.

kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr

  ! Change nuclear charge if this is a relativistic ECP-case. This
  ! is used for the DKH transformation (see dkh_util/dkrelint_dp)!

  if (DKroll .and. Primitive_Pass .and. lECP) then
    Q_Nuc = real(dbsc(kCnttp)%AtmNr,kind=wp)
  else
    Q_Nuc = dbsc(kCnttp)%Charge
  end if

  if (kCnttp == iCnttp_Dummy) cycle
  if (Q_Nuc == Zero) cycle
  do kCnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
    if (iPrint >= 99) call RecPrt('C',' ',C,1,3)

    ! Find the DCR for M and S

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    if (iPrint >= 99) then
      write(u6,*) ' m      =',nStabM
      write(u6,'(9A)') '(M)=',(ChOper(iStabM(ii)),ii=0,nStabM-1)
      write(u6,*) ' s      =',dc(kdc+kCnt)%nStab
      write(u6,'(9A)') '(S)=',(ChOper(dc(kdc+kCnt)%iStab(ii)),ii=0,dc(kdc+kCnt)%nStab-1)
      write(u6,*) ' LambdaT=',LmbdT
      write(u6,*) ' t      =',nDCRT
      write(u6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),ii=0,nDCRT-1)
    end if

    do lDCRT=0,nDCRT-1
      call OA(iDCRT(lDCRT),C,TC)
      ! switch (only two center NA matrix...)
      if (No3Cnt .and. (.not. (EQ(A,TC) .or. EQ(RB,TC)))) cycle
      ! switch
      CoorAC(:,2) = TC
      Coori(:,3) = TC
      Coori(:,4) = TC
      Coora(:,3) = TC
      Coora(:,4) = TC
      !                                                                *
      !*****************************************************************
      !                                                                *
      !        Compute integrals with the Rys quadrature.
      !                                                                *
      !*****************************************************************
      !                                                                *
      nT = nZeta
      !                                                                *
      !*****************************************************************
      !                                                                *
      if (Nuclear_Model == Gaussian_Type) then

        ! Gaussian nuclear charge distribution

        NoSpecial = .false.
        Eta = dbsc(kCnttp)%ExpNuc
        EInv = One/Eta
        rKappcd = TwoP54/Eta
        ! Tag on the normalization
        rKappcd = rKappcd*(Eta/Pi)**OneHalf
        ! s-type function
        mcdMin = 0
        mcdMax = 0
        call Rys(iAnga,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,TC,1,rKappa,[rKappcd],Coori,Coora,CoorAC,mabmin,mabmax,mcdMin, &
                 mcdMax,Array,nArr*nZeta,TERI,ModU2,vCff2D,vRys2D,NoSpecial)
        !                                                              *
        !***************************************************************
        !                                                              *
      else if (Nuclear_Model == mGaussian_Type) then

        ! Modified Gaussian nuclear charge distribution

        NoSpecial = .false.
        Eta = dbsc(kCnttp)%ExpNuc
        EInv = One/Eta
        rKappcd = TwoP54/Eta
        ! Tag on the normalization
        rKappcd = rKappcd*(Eta/Pi)**OneHalf/(One+Three*dbsc(kCnttp)%w_mGauss/(Two*Eta))
        ! s type function
        mcdMin = 0
        mcdMax = 0
        call Rys(iAnga,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,TC,1,rKappa,[rKappcd],Coori,Coora,CoorAC,mabmin,mabmax,mcdMin, &
                 mcdMax,Array,nArr*nZeta,TERI,ModU2,vCff2D,vRys2D,NoSpecial)

        ! d type function w*(x**2+y**2+z**2)
        if (dbsc(kCnttp)%w_mGauss > Zero) then
          rKappcd = rKappcd*dbsc(kCnttp)%w_mGauss
          iAnga(3) = 2
          mcdMin = nTri3_Elem1(2+ld-1)
          mcdMax = nTri3_Elem1(2+ld)-1
          ! tweak the pointers
          ipOff = 1+nZeta*(la+1)*(la+2)/2*(lb+1)*(lb+2)/2
          mArr = nArr-(la+1)*(la+2)/2*(lb+1)*(lb+2)/2
          call Rys(iAnga,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,TC,1,rKappa,[rKappcd],Coori,Coora,CoorAC,mabMin,mabMax,mcdMin, &
                   mcdMax,Array(ipOff),mArr*nZeta,TERI,ModU2,vCff2D,vRys2D,NoSpecial)
          iAnga(3) = 0

          ! Add the s and d contributions together!

          call Assemble_mGauss(Array,Array(ipOff),nZeta*(mabMax-mabMin+1))
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
      else if (Nuclear_Model == Point_Charge) then

        ! Point-like nuclear charge distribution

        NoSpecial = .true.
        Eta = One
        EInv = One
        rKappcd = One
        mcdMin = 0
        mcdMax = 0
        call Rys(iAnga,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,TC,1,rKappa,[rKappcd],Coori,Coora,CoorAC,mabMin,mabMax,mcdMin, &
                 mcdMax,Array,nArr*nZeta,TNAI,Fake,XCff2D,XRys2D,NoSpecial)
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
      !
      ! Use the HRR to compute the required primitive integrals.

      call HRR(la,lb,A,RB,Array,nZeta,nMem,ipIn)

      ! Accumulate contributions to the symmetry adapted operator

      nOp = NrOpr(iDCRT(lDCRT))
      call SymAdO(Array(ipIn),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,-Fact*Q_Nuc)
      if (iPrint >= 99) then
        write(u6,*) Fact*Q_Nuc
        call RecPrt('NaInt: Array(ipIn)',' ',Array(ipIn),nZeta,nTri_Elem1(la)*nTri_Elem1(lb)*nComp)
        call RecPrt('NaInt: rFinal',' ',rFinal,nZeta,nTri_Elem1(la)*nTri_Elem1(lb)*nIC)
      end if

    end do
  end do
end do

if ((Nuclear_Model == Gaussian_Type) .or. (Nuclear_Model == mGaussian_Type)) then
  rKappa = rKappa/(TwoP54/Zeta)
end if

return

end subroutine NAInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine scorr2_cvb(cvbdet,dvbdet,evbdet,
     >      ssq,wvbdet,iperm)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "formats_cvb.fh"
      dimension cvbdet(ndetvb),dvbdet(ndetvb),evbdet(ndetvb)
      dimension ssq(norb,norb),wvbdet(ndetvb),iperm(norb)
      save cut,half
      data cut/1.d-10/,half/.5d0/

      write(6,'(/,1x,a)') 'Expectation values of (s(i)+s(j))**2'
      snorm=ddot_(ndetvb,cvbdet,1,dvbdet,1)
      ssnorm=ddot_(ndetvb,cvbdet,1,evbdet,1)
      write(6,formAF)
     >  ' Lower triangle uses SPIN function with Snorm=',ssnorm
      write(6,formAF)
     >  ' Upper triangle uses FULL function with Snorm=',snorm
c! DLC
c     snorm=one/snorm
c     ssnorm=one/ssnorm
      phase=(-one)**iabs(nalf-nbet)
      snorm=phase/snorm
      ssnorm=phase/ssnorm
c! DLC
      call fzero(ssq,norb*norb)
      tot=zero
      stot=zero
      do 100 mu=1,norb
      do 101 nu=mu+1,norb
c  Apply s_mu x s_nu to the wavefunction
      do 200 i=1,norb
      iperm(i)=i
200   continue
      iperm(mu)=nu
      iperm(nu)=mu
      call fmove_cvb(cvbdet,wvbdet,ndetvb)
      call permvb_cvb(wvbdet,iperm)
      sum=one-ddot_(ndetvb,wvbdet,1,dvbdet,1)*snorm
      ssum=one-ddot_(ndetvb,wvbdet,1,evbdet,1)*ssnorm
      tot=tot+sum
      stot=stot+ssum
      ssq(mu,nu)=sum
      ssq(nu,mu)=ssum
101   continue
100   continue
      call mxprint_cvb(ssq,norb,norb,0)
      tot=tot+r3by4*dble(norb-2*norb*(norb-1)/2)
      stot=stot+r3by4*dble(norb-2*norb*(norb-1)/2)
      scheck=half*dble(iabs(nalf-nbet))*(half*dble(iabs(nalf-nbet))+one)
      if(abs(tot-scheck).gt.cut .or. abs(stot-scheck).gt.cut)
     >  write(6,formAD) 'WARNING: spins ',stot,tot,scheck
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Jeppe Olsen                                      *
************************************************************************
      FUNCTION ISTRN_MCLR(STRING,IGROUP)
*
* A string belonging to group IGROUP is given.
* find actual number
*
* Jeppe Olsen, September 1993
*234567
      IMPLICIT REAL*8(A-H,O-Z)
*. Specific input
      INTEGER STRING(*)
*
#include "detdim.fh"
#include "strbas_mclr.fh"
#include "strinp_mclr.fh"
#include "orbinp_mclr.fh"
#include "WrkSpc.fh"

      NEL = NELEC(IGROUP)
      ISTRN_MCLR = ISTRNM(STRING,NACOB,NEL,iWORK(KZ(IGROUP)),
     &               iWORK(KSTREO(IGROUP)),1)
*
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FixHess(H,nH,iOptC,MF,GNrm,nsAtom,AnalHess,AllowFindTS)
      use Slapaf_Parameters, only: iNeg, GNrm_Threshold, Mode
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
#include "stdalloc.fh"
      Real*8 H(nH,nH), MF(3,nsAtom)
      Logical AnalHess, AllowFindTS, Corrected, Found
      Real*8, Allocatable:: EVal(:), LowVal(:), LowVec(:,:), Tmp(:,:),
     &                      FixVal(:), Rx(:,:), Vect(:)
#ifdef _DEBUGPRINT_
      Logical Too_Small
#endif
*
      iRout=211
      iPrint=nPrint(iRout)
*
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*) 'AnalHess=',AnalHess
      Call RecPrt('FixHess: H(Start)',' ',H,nH,nH)
      Lu=6
      Too_Small=.False.
#endif
*
      Corrected=.False.
      HTh=1.0d-3
      ZTh=1.0D-12
      HHigh=1.0D0
*
      Call mma_allocate(EVal,nH*(nH+1)/2,Label='EVal')
*
*---- Copy elements for H
*
      SumHii=Zero
      Do i = 1, nH
         Do j = 1, i
            ij=i*(i-1)/2 + j
            EVal(ij)=H(i,j)
         End Do
         SumHii=SumHii+H(i,i)
      End Do
*
#ifdef _DEBUGPRINT_
      Write (Lu,*) 'FixHess: SumHii=',SumHii
      Call RecPrt('FixHess: Hessian',' ',H,nH,nH)
      Call TriPrt('FixHess: H',' ',EVal,nH)
#endif

*
*---- Compute eigenvalues and eigenvectors
*
*---- Davidson procedure to compute only the lowest eigenvalues
*     For small matrices we can afford to solve it directly
*      (tested with NumVal=2 in all cases)
      If (nH .le. 30) Then
        NumVal=nH
      Else
        NumVal=2
      End If
      nVStep=2
      Found=.False.
      Call mma_allocate(LowVal,NumVal,Label='LowVal')
      Call mma_allocate(LowVec,nH,NumVal,Label='LowVec')
      LowVec(:,:) = Zero
*---- Stop when the highest eigenvalue found is larger than HTh * 10
      Do While (.Not.Found)
        Call Davidson(EVal,nH,NumVal,LowVal,LowVec,iStatus)
#ifdef _DEBUGPRINT_
        Call RecPrt(' Eigenvalues',' ',LowVal,1,NumVal)
        Call RecPrt(' Eigenvectors',' ',LowVec,nH,NumVal)
#endif
        If (iStatus.gt.0) Then
          Call SysWarnMsg('FixHess',
     &      'Davidson procedure did not converge','')
        End If
        If ((LowVal(NumVal).gt.Ten*HTh).or.(NumVal.ge.nH)) Then
          Found=.True.
        Else
*----     Increase the number of eigenpairs to compute
          Call mma_allocate(Tmp,nH,NumVal,Label='Tmp')
          Tmp(:,:)=LowVec(:,:)
          Call mma_deallocate(LowVal)
          Call mma_deallocate(LowVec)
*----     At some point, start doubling the number
          If (NumVal.ge.16) NVStep=NumVal
          nVStep=Min(nVStep,nH-NumVal)
          NumVal=NumVal+nVStep
          Call mma_allocate(LowVal,NumVal,Label='LowVal')
          LowVal(:)=Zero
          Call mma_allocate(LowVec,nH,NumVal,Label='LowVec')
          LowVec(:,:)=Zero
          LowVec(:,1:NumVal-nVStep) = Tmp(:,:)
          Call mma_deallocate(Tmp)
        End If
      End Do
      Call mma_deallocate(EVal)
*
*---- Apply corrections if any ...
*
      Call mma_allocate(FixVal,NumVal,Label='FixVal')
#ifdef _DEBUGPRINT_
      Call RecPrt(' Eigenvalues',' ',LowVal,1,NumVal)
      Call RecPrt(' Eigenvectors',' ',LowVec,nH,NumVal)
#endif
      iNeg(1)=0
      jNeg=0
      rLow=Ten
      iLow=0
*     with sorted eigenvalues, jNeg=iNeg, iLow=1
      Do i = 1, NumVal
         temp=LowVal(i)
         FixVal(i)=temp
         If (temp.lt.rlow) Then
            rlow=temp
            iLow=i
         End If
*        No fixes if the Hessian is analytical
         If (.Not.AnalHess.and.(Abs(temp).lt.HTh)) Then
#ifdef _DEBUGPRINT_
            Too_Small=.True.
#endif
            Corrected=.True.
*
*           For redundant coordinates we will have some
*           eigenvalues which are zero due to the
*           redundancy.
*
            If (Abs(temp).lt.ZTh) Then
               temp=Zero
               FixVal(i)=Zero
            Else
               FixVal(i)=Sign(HTh,temp)
            End If
         End If
         If (temp.lt.Zero) Then
            iNeg(1)=iNeg(1)+1
            jNeg=i
            If ((.Not.AnalHess.or.iAnd(iOptC,256).eq.256) .and.
     &          iAnd(iOptC,128).eq.128 .and.
     &          iAnd(iOptC,4096).ne.4096) Then
*
*             Change the sign and if just too large reduce the value
*             to the default of HHigh.
*
               FixVal(i)=Min(HHigh,Abs(FixVal(i)))
               Corrected=.True.
            End If
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     If FindTS and we have got a negative eigenvalue signal that
*     we are in the TS regime.
*
      If (AllowFindTS) Then
         Call qpg_darray('TanVec',Found,nRP)
         If (iAnd(iOptC,4096).eq.4096 .and.
     &       (iNeg(1).ge.1.or.Mode.ge.0) .and.
     &       ((GNrm.le.GNrm_Threshold).or.Found)) Then
            If (iAnd(iOptC,8192).ne.8192) Then
               Write (6,*) '**************************'
               Write (6,*) '* Enable TS optimization *'
               Write (6,*) '**************************'
            End If
            iOptC=iOr(iOptC,8192)
         End If
         If (iAnd(iOptC,8192).eq.8192) Then
            Mask=2**30-1  - 2**7
            iOptC=iAnd(Mask,iOptC)
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
#ifdef _DEBUGPRINT_
      If (Too_Small) Then
         Write (Lu,*)
         Write (Lu,*) ' Some too small eigenvalues has been corrected'
         Write (Lu,*)
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*----- M I N I M A
*                                                                      *
************************************************************************
*                                                                      *
      If (iAnd(iOptC,128).eq.128) Then
*
         If (iNeg(1).ne.0.and.iAnd(iOptC,256).ne.256) Then
            Corrected=.True.
#ifdef _DEBUGPRINT_
            Write (Lu,*) ' Some negative eigenvalues has been corrected'
            Write (Lu,*) 'iNeg=',iNeg(1)
            Write (Lu,*)
#endif
         End If
*                                                                      *
************************************************************************
*                                                                      *
*---- T R A N S I T I O N  S T A T E  S E A R C H
*                                                                      *
************************************************************************
*                                                                      *
      Else If (iAnd(iOptC,8).eq.8 .or.
     &         iAnd(iOptC,8192).eq.8192 ) Then
*                                                                      *
************************************************************************
*                                                                      *
*        1 negative eigenvalue
*
         If (iNeg(1).eq.1) Then
*
            If (Mode.le.0) Then
*
*------------- Store the eigenvector which we are following
*
               Mode=jNeg
               Call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#ifdef _DEBUGPRINT_
               Write (Lu,'(A,I3)') ' Store Original mode:',Mode
               Call RecPrt(' Reaction mode',' ',MF,3,nsAtom)
#endif
*
            Else
*
*------------- Check that it is the correct eigenvector!
*
#ifdef _DEBUGPRINT_
               Call RecPrt(' Old Reaction mode',' ',MF,3,nsAtom)
#endif
               iTest=0
               Test=Zero
               Call mma_allocate(Rx,3,nsAtom,Label='Rx')
               Do i = 1, NumVal
                  Call ReacX(LowVec(:,i),nH,Rx,3*nsAtom)
                  dRx=Sqrt(DDot_(3*nsAtom,Rx,1,Rx,1))
                  rq=Abs(DDot_(3*nsAtom,MF,1,Rx,1))/dRx
                  If (rq.gt.Test) Then
                     iTest=i
                     Test=rq
                  End If
                  Temp=FixVal(i)
#ifdef _DEBUGPRINT_
                  Write (6,*) '<old|new>,H_new=',rq,Temp
#endif
               End Do
               Call mma_deallocate(Rx)
*
*              Only iTest and jNeg may be touched
               If (iTest.eq.jNeg) Then
                  Mode = jNeg
               Else
#ifdef _DEBUGPRINT_
                  Write (Lu,*) ' Warning: wrong eigenvector has'
     &                       //' negative eigenvalue.'
#endif
*                 Keep the old vector if there is significant overlap
*                 Note: there could be a better vector not in the computed set
                  If (.Not.AnalHess.and.(Test.gt.0.50d0)) Then
                     Mode = iTest
#ifdef _DEBUGPRINT_
                     Write (Lu,*) 'Keep old eigenvector!',Mode
#endif
                     FixVal(jNeg) = Abs(FixVal(jNeg))
                     Corrected=.True.
*                 Prefer the new eigenvector if the Hessian is analytical
*                 or if the best overlap is poor
                  Else
                     Mode = jNeg
#ifdef _DEBUGPRINT_
                     Write (Lu,*) 'Take new eigenvector!',Mode
#endif
                  End if
               End If
*
               FixVal(Mode) = -Abs(FixVal(Mode))
               Call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#ifdef _DEBUGPRINT_
               Write (Lu,'(A,1X,I3)') ' Store mode:',Mode
               Call RecPrt(' New Reaction mode',' ',MF,3,nsAtom)
#endif
*
            End If
*                                                                      *
************************************************************************
*                                                                      *
*        0 negative eigenvalues
*
         Else If (iNeg(1).eq.0) Then
*
            If (Mode.lt.1) Then
*
*------------- Store the eigenvector which we are following
*
               Mode=iLow
               Call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#ifdef _DEBUGPRINT_
               Write (Lu,'(A,I3)') ' Store Original mode:',Mode
               Call RecPrt(' Reaction mode',' ',MF,3,nsAtom)
#endif
*
            Else
*
*------------- Find the eigenvector with the best overlap
*
#ifdef _DEBUGPRINT_
               Call RecPrt(' Old Reaction mode',' ',MF,3,nsAtom)
#endif
               iTest=0
               Test=Zero
               Call mma_allocate(Rx,3,nsAtom,Label='Rx')
               Do i = 1, NumVal
                  Call ReacX(LowVec(:,i),nH,Rx,3*nsAtom)
                  dRx=Sqrt(DDot_(3*nsAtom,Rx,1,Rx,1))
                  rq=Abs(DDot_(3*nsAtom,MF,1,Rx,1))/dRx
                  If (rq.gt.Test) Then
                     iTest=i
                     Test=rq
                  End If
                  Temp=FixVal(i)
#ifdef _DEBUGPRINT_
                  Write (6,*) '<old|new>,H_new=',rq,Temp
#endif
               End Do
               Call mma_deallocate(Rx)
*
*              Keep the old vector if there is significant overlap
*              Note: there could be a better vector not in the computed set
               If (Test.gt.0.50d0) Then
                  Mode = iTest
*              Prefer the lowest eigenvector if the best overlap is poor
               Else
                  Mode = iLow
#ifdef _DEBUGPRINT_
                  Write (Lu,*) ' Warning: no good overlap among'
     &                       //' the computed set of eigenvectors.'
#endif
               End if
*
               Call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#ifdef _DEBUGPRINT_
               Write (Lu,'(A,1X,I3)') ' Store mode:',Mode
               Call RecPrt(' New Reaction mode',' ',MF,3,nsAtom)
#endif
*
            End If
*
            FixVal(Mode) = - Half * Abs(FixVal(Mode))
            Corrected=.True.
#ifdef _DEBUGPRINT_
            Write (Lu,'(A,I2,A)')
     &                ' No negative eigenvalue, correction: mode ',
     &                Mode,' was changed to negative'
            Write (Lu,*)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        2 or more negative eigenvalues
*
         Else If (iNeg(1).ge.2) Then
*
            If (Mode.lt.1) Then
*
*------------- Store the eigenvector which we are following
*
               Mode=iLow
               Call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#ifdef _DEBUGPRINT_
               Write (Lu,'(A,I3)') ' Store Original mode:',Mode
               Call RecPrt(' Reaction mode',' ',MF,3,nsAtom)
#endif
*
            Else
*
*------------- Find the eigenvector with the best overlap
*
#ifdef _DEBUGPRINT_
              Call RecPrt(' Old Reaction mode',' ',MF,3,nsAtom)
#endif
               iTest=0
               Test=Zero
               Call mma_allocate(Rx,3,nsAtom,Label='Rx')
               Do i = 1, NumVal
                  Call ReacX(LowVec(:,i),nH,Rx,3*nsAtom)
                  dRx=Sqrt(DDot_(3*nsAtom,Rx,1,Rx,1))
                  rq=Abs(DDot_(3*nsAtom,MF,1,Rx,1))/dRx
                  If (rq.gt.Test) Then
                     iTest=i
                     Test=rq
                  End If
                  Temp=FixVal(i)
#ifdef _DEBUGPRINT_
                  Write (6,*) '<old|new>,H_new=',rq,Temp
#endif
               End Do
               Call mma_deallocate(Rx)
*
*              Keep the old vector if there is significant overlap
*              Note: there could be a better vector not in the computed set
               If (Test.gt.0.50d0) Then
                  Mode = iTest
*              Prefer the lowest eigenvector if the best overlap is poor
               Else
                  Mode = iLow
#ifdef _DEBUGPRINT_
                  Write (Lu,*) ' Warning: no good overlap among'
     &                       //' the computed set of eigenvectors.'
#endif
               End if
*
               Call ReacX(LowVec(:,Mode),nH,MF,3*nsAtom)
#ifdef _DEBUGPRINT_
               Write (Lu,'(A,1X,I3)') ' Store mode:',Mode
               Call RecPrt(' New Reaction mode',' ',MF,3,nsAtom)
#endif
*
            End If
*
*           Caution! Negative eigenvalues which are not assigned
*           to the reaction mode will be increased by two orders of magnitude
*           magnitude!
*
            Fact=Ten**2
            Do i = 1, NumVal
               Temp = FixVal(i)
               If (i.eq.Mode) Then
                  FixVal(i) = -Abs(Temp)
               Else If (Temp.lt.0) Then
                  FixVal(i) = Abs(Temp) * Fact
               Else
                  FixVal(i) = Abs(Temp)
               End If
            End Do
            Corrected=.True.
#ifdef _DEBUGPRINT_
            Write (Lu,'(A,I2,A)')
     &            ' Too many negative eigenvalue, correction: mode ',
     &            Mode,' was kept'
            Write (Lu,*)
#endif
*
         End If
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Else
         Write (6,*) 'No Hessian massage!'
#endif
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
#ifdef _DEBUGPRINT_
      Write (Lu,*)
      Write (Lu,*)' Analysis of the Hessian'
      Write (Lu,*)
      Call RecPrt(' Eigenvalues',' ',FixVal,1,NumVal)
      Call RecPrt(' Eigenvectors',' ',LowVec,nH,NumVal)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*.... Recompute the Hessian if needed
*
      iNeg(2)=iNeg(1)
      If (Corrected) Then
*
         If (iPrint.ge.99) Then
            Call RecPrt(' Corrected eigenvalues',' ',FixVal,1,NumVal)
            Call RecPrt(' Hessian',' ',H,nH,nH)
         End If
*
         Call mma_allocate(Vect,nH,Label='Vect')
         iNeg(1)=0
         Do i=1,NumVal
           If (FixVal(i).lt.Zero) iNeg(1)=iNeg(1)+1
           Fix_Val=FixVal(i)-LowVal(i)
           If (Abs(Fix_Val).gt.1.0D-12) Then
             Fix_Val=FixVal(i)+LowVal(i)
*
*            H |i>
*
             Call dGeMV_('N',nH,nH,One,H,nH,LowVec(:,i),1,Zero,Vect,1)
*
*            H' = (I-|i><i|) H (I-|i><i|) + val_new |i><i|
*               = H - H|i> <i| - |i> <i|H + (val_old + val_new) |i> <i|
*
*  (since |i> is an eigenvector this could be used instead):
*  H' = H + (val_new - val_old) |i> <i|
*
             Do j=1,nH
               Do k=1,nH
                 H(j,k)=H(j,k)-Vect(j)*LowVec(k,i)
     &                        -Vect(k)*LowVec(j,i)
     &                        +Fix_Val*LowVec(j,i)*LowVec(k,i)
               End Do
             End Do
           End If
         End Do
         Call mma_deallocate(Vect)
*
      End If
*
      If (iPrint.ge.99) Then
         Call RecPrt('FixHess: Hessian',' ',H,nH,nH)
      End If
*
      Call mma_deallocate(FixVal)
      Call mma_deallocate(LowVal)
      Call mma_deallocate(LowVec)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT_exp(T2red,T2full,dimbe,no)
! this routine produces expanded set of amplitudes from reduced set
! (used in parallel case)
! T2red(be'ga',u,v) -> T2full(be',ga',u,v)
! for beGrp=gaGrp

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimbe, no
real(kind=wp), intent(out) :: T2full(dimbe,dimbe,no,no)
real(kind=wp), intent(in) :: T2red(nTri_Elem(dimbe),no,no)
integer(kind=iwp) :: be, bega, j

do j=1,no

  bega = 0
  do be=1,dimbe

    !dir T2red(bega,i,j) = T2Full(be,ga,i,j)
    !inv
    T2Full(be,1:be-1,:,j) = T2red(bega+1:bega+be-1,:,j)
    T2Full(1:be,be,j,:) = T2red(bega+1:bega+be,:,j)

    bega = bega+be
  end do

end do

return

end subroutine MkT_exp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Thomas J. Duignan                                *
!               2021, Rulin Feng                                       *
!***********************************************************************

subroutine merge_mag_ints(nb,jz,lt,ut,dotran)
! Splice together square matrices stored artificially as
! lower triangular matrices.  Result is that upper triangular
! portion of lt is set to ut and ut is then transposed so
! the "upper triangular" portion is in the "lower triangular"
! elements to circumvent Molcas' internal integral handling.

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nb, jz
logical(kind=iwp), intent(in) :: dotran
real(kind=wp), intent(inout) :: lt(jz), ut(jz)
integer(kind=iwp) :: im, jm, km, lm

do im=1,nb
  do jm=im,nb
    km = (im-1)*nb+jm
    lt(km) = ut(km)
  end do
end do

if (dotran) then
  do im=1,nb
    do jm=1,nb
      km = (im-1)*nb+jm
      lm = (jm-1)*nb+im
      ut(km) = lt(lm)
    end do
  end do
else
  ut(:) = lt(:)
end if

end subroutine merge_mag_ints

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine SchInt_mck(CoorM,iAnga,iCmp,
     &                  nAlpha,nBeta,nMemab,
     &                  Zeta,ZInv,rKapab,P,nZeta,
     &                  Work2,nWork2,Work3,nWork3)
************************************************************************
*                                                                      *
* Object: to compute zeta, kappa, P, and the integrals [nm|nm] for     *
*         prescreening. This is done for all unique pairs of centers   *
*         generated from the symmetry unique centers A and B.          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             June '91, modified to compute zeta, P, kappa and inte-   *
*             grals for Schwartz inequality in a k2 loop.              *
*             April '92 modified from k2Loop to a separate subroutine  *
*              for estimates of the gradient.                          *
************************************************************************
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
*     External TERISq, ModU2, Cff2Dq
      External TERIS, ModU2, Cff2DS,rys2d
#include "real.fh"
#include "WrkSpc.fh"
      Real*8  CoorM(3,4), CoorAC(3,2),
     &       Zeta(nZeta), ZInv(nZeta), rKapab(nZeta), P(nZeta,3),
     &       Q(3),  Work2(nWork2), Work3(nWork3)
      Integer iAnga(4), iCmp(4)
      Logical EQ, NoSpecial
*
*     Statement function to compute canonical index
*
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
      nElem(i)    = (i+1)*(i+2)/2
*
      call dcopy_(3,[One],0,Q,1)
      la = iAnga(1)
      lb = iAnga(2)
      iCmpa = iCmp(1)
      jCmpb = iCmp(2)
*
*
*-----Compute primitive integrals to be used in the prescreening
*     by the Schwartz inequality.
*
*
*-----Compute actual size of [a0|c0] block
*
      mabMin=nabSz(Max(la,lb)-1)+1
      If (EQ(CoorM(1,1),CoorM(1,2))) mabMin = nabSz(la+lb-1)+1
      mabMax=nabSz(la+lb)
      mcdMin=mabmin
      mcdMax=mabMax
      mabcd=(mabMax-mabMin+1)*(mcdMax-mcdMin+1)
*
*-----Find the proper centers to start of with the angular
*     momentum on. If la.eq.lb there will excist an
*     ambiguity to which center that angular momentum should
*     be accumulated on. In that case we will use A and C of
*     the order as defined by the basis functions types.
*
      If (iAnga(1).ge.iAnga(2)) Then
         call dcopy_(3,CoorM(1,1),1,CoorAC(1,1),1)
         call dcopy_(3,CoorM(1,3),1,CoorAC(1,2),1)
      Else
         call dcopy_(3,CoorM(1,2),1,CoorAC(1,1),1)
         call dcopy_(3,CoorM(1,4),1,CoorAC(1,2),1)
      End If
*
      mZeta = nAlpha*nBeta
*
*-----Compute [a0|c0], ijkl,a,c
*
      nT = mZeta*1
      NoSpecial=.True.
      Call Rys(iAnga,nT,
     &               Zeta,ZInv,              mZeta,[One],[One],1,
     &               P,         nZeta,Q,1,rKapab,      [One],
     &               CoorM,CoorM,CoorAC,
     &               mabMin,mabMax,mcdMin,mcdMax,
     &               Work2,nWork2,TERIS,ModU2,Cff2DS,
     &               Rys2D,NoSpecial)
*
*-----Apply transfer equation to generate [a0|cd], IJKLa,c,d
*
      nijkla = (mabMax-mabMin+1)*mZeta
      Call HRR(la,lb,CoorM(1,1),CoorM(1,2),Work2,nijkla,nMemab,ipIn)
*
*-----Transform to spherical gaussians [a0|CD], CDIJKL,a. This
*     will also put the integrals in the right position for the
*     transfer equation.
*
      Call CrSph1(Work2(ipIn),nijkla,
     &            Work3,nWork3,
     &            RSph(ipSph(la)),nElem(la),nElem(la),
     &            .False.,.False.,
     &            RSph(ipSph(lb)),nElem(lb),nElem(lb),
     &            .False.,.False.,
     &            Work2,nElem(la)*nElem(lb))
*
*-----Apply transfer equation to generate [ab|CD], CDIJKL,a,b
*
      ijklcd = nElem(la)*nElem(lb)*mZeta
      Call HRR(la,lb,CoorM(1,1),CoorM(1,2),Work2,ijklcd,nMemab,ipIn)
*
*-----Transform to spherical gaussians [AB|CD], IJKL,ABCD
*
      Call CrSph2(Work2(ipIn),mZeta,
     &            nElem(la)*nElem(lb),Work3,nWork3,
     &            RSph(ipSph(la)),nElem(la),nElem(la),
     &            .False.,.False.,
     &            RSph(ipSph(lb)),nElem(lb),nElem(lb),
     &            .False.,.False.,
     &            Work2,nElem(la)*nElem(lb))
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine ABCI_CPF(JSY,INDX,C,S,BMN,IBMN,BIAC,BICA,BUFIN)

use cpf_global, only: IADABCI, IRC, KBUFF1, LN, LSYM, Lu_CIGuga, Lu_TiABCI, NDIAG, NNS, NSM, NSYS, NVIRT, SQ2
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JSY(*), INDX(*)
real(kind=wp), intent(inout) :: C(*), S(*)
real(kind=wp), intent(_OUT_) :: BMN(*), BIAC(*), BICA(*), BUFIN(*)
integer(kind=iwp), intent(_OUT_) :: IBMN(*)
integer(kind=iwp) :: I, IAD15, IADD10, ICCB, ICHK, ICP1, ICP2, IIN, ILEN, ILOOP, IND, INDA, INDB, INS, INSIN, INUM, IOUT, IT, &
                     ITYP, LB, MA, NB, NI, NSAVE, NSIB, NSLB
real(kind=wp) :: COPL, TERM
logical(kind=iwp) :: Skip
integer(kind=iwp), external :: JSUNP
real(kind=r8), external :: DDOT_

INUM = IRC(4)-IRC(3)
call PSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)
ICHK = 0
INSIN = KBUFF1
IAD15 = IADABCI
IADD10 = IAD10(4)
call dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
call iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
ILEN = ICOP1(nCOP+1)
IIN = 2
NSAVE = ICOP1(IIN)
do
  NI = NSAVE
  IOUT = 0
  Skip = .false.
  do
    IIN = IIN+1
    if (IIN > ILEN) then
      call dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
      call iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
      ILEN = ICOP1(nCOP+1)
      if (ILEN <= 0) then
        Skip = .true.
        exit
      end if
      IIN = 1
    end if
    if (ICHK /= 0) exit
    if (ICOP1(IIN) == 0) then
      ICHK = 1
    else
      IOUT = IOUT+1
      BMN(IOUT) = COP(IIN)
      IBMN(IOUT) = ICOP1(IIN)
    end if
  end do
  if (.not. Skip) then
    ICHK = 0
    NSAVE = ICOP1(IIN)
  end if
  do NB=1,NVIRT
    NSIB = MUL(NSM(LN+NB),NSM(NI))
    NSLB = MUL(NSM(LN+NB),LSYM)
    LB = NB-NSYS(NSM(LN+NB))
    INS = NNS(NSIB)
    ILOOP = 0
    do
      do I=1,INS
        if (INSIN >= KBUFF1) then
          call dDAFILE(Lu_TiABCI,2,BUFIN,KBUFF1,IAD15)
          INSIN = 0
        end if
        INSIN = INSIN+1
        if (ILOOP == 0) BIAC(I) = BUFIN(INSIN)
        if (ILOOP == 1) BICA(I) = BUFIN(INSIN)
      end do
      ILOOP = ILOOP+1
      if (ILOOP /= 1) exit
    end do
    do IT=1,IOUT
      IND = IBMN(IT)
      ICP1 = ibits(IND,19,13)
      INDA = IRC(1)+ICP1
      if (JSUNP(JSY,INDA) /= NSLB) cycle
      MA = INDX(INDA)+LB
      ICP2 = ibits(IND,6,13)
      ITYP = ibits(IND,0,6)
      if (INS == 0) cycle
      COPL = BMN(IT)*C(MA)
      INDB = IRC(ITYP)+ICP2
      ICCB = INDX(INDB)+1
      if (ITYP == 3) then
        TERM = DDOT_(INS,C(ICCB),1,BIAC,1)
        S(ICCB:ICCB+INS-1) = S(ICCB:ICCB+INS-1)+COPL*BIAC(1:INS)
      else
        TERM = DDOT_(INS,C(ICCB),1,BICA,1)
        S(ICCB:ICCB+INS-1) = S(ICCB:ICCB+INS-1)+COPL*BICA(1:INS)
      end if
      S(MA) = S(MA)+BMN(IT)*TERM
    end do
  end do
  if (ILEN < 0) exit
end do
call DSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)

return

end subroutine ABCI_CPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

#include "compiler_features.h"
#ifndef _HAVE_EXTRA_

! Broadcast a file from the master to the slaves
subroutine PFGet_ASCII(FName)

#ifdef _MOLCAS_MPP_
use Para_Info, only: mpp_rootid, King
use GA_Wrapper, only: GA_Brdcst, MT_BYTE, MT_INT
use Definitions, only: iwp, u6, ItoB
#endif

implicit none
character(len=*), intent(in) :: FName
#ifdef _MOLCAS_MPP_
integer(kind=iwp), parameter :: LBuf = 4096
integer(kind=iwp) :: Err, FLen, LU, Num, Pos
logical(kind=iwp) :: Failed, Found
character(len=LBuf) :: Buf
integer(kind=iwp), external :: IsFreeUnit

! Note that each process opens only one file, so there is a single
! unit number LU
LU = IsFreeUnit(10)
! Check file existence and read size on the master
if (King()) then
  call f_Inquire(FName,Found)
  if (Found) then
    call Molcas_Open_Ext2(LU,FName,"stream","unformatted",Err,.false.,0,"old",Failed)
    if (Failed .or. (Err /= 0)) then
      write(u6,*) "Failed to open file ",trim(FName)
      call AbEnd()
    end if
    inquire(LU,Size=FLen)
  else
    FLen = 0
  end if
end if
! Broadcast the file size
Err = 0
call GA_Brdcst(MT_INT,FLen,1*ItoB,mpp_rootid)
if (FLen <= 0) return
! Open file for writing in the slaves
if (.not. King()) then
  call Molcas_Open_Ext2(LU,FName,"stream","unformatted",Err,.false.,0,"replace",Failed)
  if (Failed .or. (Err /= 0)) then
    write(u6,*) "Failed to open file ",trim(FName)
    call AbEnd()
  end if
end if
! Pass the file content in chunks
Pos = 0
do while (Pos < FLen)
  ! Length of this chunk
  Num = min(LBuf,FLen-Pos)
  ! The master reads the file
  if (King()) then
    read(LU,IOStat=Err) Buf(1:Num)
    if (Err /= 0) then
      write(u6,*) "Error reading the file ",trim(FName)
      call AbEnd()
    end if
  end if
  call GA_Brdcst(MT_BYTE,Buf,Num,mpp_rootid)
  ! The slaves write the file
  if (.not. King()) then
    write(LU,IOStat=Err) Buf(1:Num)
    if (Err /= 0) then
      write(u6,*) "Error writing the file ",trim(FName)
      call AbEnd()
    end if
  end if
  Pos = Pos+LBuf
end do
close(LU)
#else
#include "macros.fh"
unused_var(_str(FName))
#endif

end subroutine PFGet_ASCII

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(PFGet_ASCII)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_AA (A)
c
c        check T(a,b,i,j)
c
        implicit none
#include "chcc1.fh"
c        real*8 T(1:nv,1:nv,1:no,1:no)
         real*8 A(1:no*(no+1)/2,no,no)
c
        integer j,i,ij,u,v,bad
        real*8 s
c
        bad=0
        do v=1,no
        do u=1,no
        ij=0
        do i=1,no
        do j=1,i
        ij=ij+1
c
           s=Ac(i,j,u,v)
c
          if (abs(A(ij,u,v)-s).gt.1.0d-10) then
            bad=bad+1
c    A(ij,u,v)=s
          end if
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck AA :',bad
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Per Ake Malmqvist                                *
************************************************************************
      SUBROUTINE MKCRVEC(CMO_0,CRVEC)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "warnings.h"
#include "WrkSpc.fh"
      DIMENSION CRVEC(NTOT), CMO_0(NTOT2)
      CHARACTER*8 LABEL
*
* Note: Nbas,etc are in included common. So is ITCORE.
* CMO_0 is the starting CMO vectors. Active orbital nr ITCORE in
* symmetry 1 is a specially prepared core orbital, which will be used
* to define a projector on any CI vector. This projector is that part
* of the state vector where the core orbital would be doubly occupied.
* This orbital is computed as a covariant vector CRVEC, to allow the
* projector to be invariant to the orbital basis in each interation.
* Note: NTOT1, NTOT2 etc, general.fh

      Call GetMem('STRI','Allo','Real',LSTRI,NTOT1+4)
      IRC=0
      IOPT=6
      LABEL='Mltpl  0'
      ICOMP=1
      ISYMLBL=1
      Call RdOne(IRC,IOPT,LABEL,ICOMP,Work(LSTRI),ISYMLBL)
      If ( iRc.ne.0 ) Then
        Write(6,*)' MKCRVEC could not read overlaps from ONEINT.'
        Write(6,*)' Something is wrong with that file, or possibly'
        Write(6,*)' with the program. Please check.'
        Call Quit(_RC_IO_ERROR_READ_)
      End If
      NB=NBAS(1)
      NFI=NFRO(1)+NISH(1)
      NA=NASH(1)
      Call GetMem('SAO','Allo','Real',LSAO,NB**2)
      Call Square(Work(LSTRI),Work(LSAO),1,NB,NB)
      Call GetMem('STRI','Free','Real',LSTRI,NTOT1+4)
      CALL DGEMV_('N',NB,NB,1.0D0, WORK(LSAO),NB,
     &             CMO_0(NB*(NFI+ITCORE-1)+1),1,0.0D0,CRVEC,1)
      Call GetMem('SAO','Free','Real',LSAO,NB**2)

** Test:
*      write(6,*) 'MKCRVEC test: Overlaps all orbs/core :'
*      do it=1,nb
*        write(6,'(1x,i5,f16.8)') it,
*     &              ddot_(NB,CMO_0(NB*(IT-1)+1),1,CRVEC,1)
*      end do

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine tunedefs2_cvb(imethod,endwhenclose1)

use casvb_global, only: delopth1, delopth2, dfxmin, dx, endwhenclose, exp12tol, grd, hhaccfac, hhmax, hhrejfac, hhstart, hhtol, &
                        nopth1, nopth2, resthr, scalesmall, sgn, singul, zzacclim, zzmin, zzrejmax, zzrejmin

use Constants, only: Zero, One, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: imethod
logical(kind=iwp), intent(in) :: endwhenclose1
real(kind=wp), parameter :: small = 1.0e-3_wp, small2 = 1.0e-5_wp, smaller = 1.0e-6_wp

! << TUNE_CVB common block: >>
endwhenclose = endwhenclose1
if ((imethod == 1) .or. (imethod == 10)) then
  !'FLETCHER'
  exp12tol = Zero
  ! Criteria for entering local region:
  grd(1,1) = 5.0e-4_wp
  grd(1,2) = 5.0e-4_wp
  sgn(1) = smaller
  sgn(2) = smaller
  singul(1) = 1.0e-2_wp
  zzmin(1) = -small
  zzmin(2) = -small
  ! Final convergence criteria:
  grd(1,3) = 5.0e-6_wp
  grd(1,4) = 5.0e-6_wp
  dx(1,3) = 5.0e-6_wp
  dx(1,4) = 1.0e-4_wp
  singul(2) = 1.0e-2_wp
  ! << TRST_CVB common block: >>
  scalesmall(1) = .false.
  nopth1(1) = 1
  nopth2(1) = 0
  zzrejmin(1) = Zero
  hhrejfac(1) = 0.4_wp
  hhaccfac(2,1) = One
  hhaccfac(3,1) = OneHalf
  hhaccfac(4,1) = One
  zzacclim(2,2) = 0.8_wp
  zzacclim(3,2) = 1.25_wp
  hhtol(1) = 1.0e-10_wp
  dfxmin(1) = Zero
  scalesmall(2) = .false.
  nopth1(2) = 1
  nopth2(2) = 0
  hhrejfac(2) = 0.4_wp
  hhaccfac(3,2) = 1.2_wp
  hhtol(2) = 1.0e-10_wp
  dfxmin(2) = Zero
end if
if (imethod == 2) then
  ! 'TRIM'
  exp12tol = Zero
  ! Criteria for entering local region:
  grd(1,1) = 5.0e-6_wp
  grd(1,2) = 5.0e-6_wp
  sgn(1) = smaller
  sgn(2) = smaller
  singul(1) = small
  zzmin(1) = -small
  zzmin(2) = -small
  ! Final convergence criteria:
  dx(1,3) = 5.0e-6_wp
  dx(1,4) = 1.0e-4_wp
  singul(2) = small2
  ! << TRST_CVB common block: >>
  scalesmall(1) = .false.
  nopth1(1) = 1
  nopth2(1) = 0
  zzrejmin(1) = 0.75_wp
  zzrejmax(1) = 1.33_wp
  hhrejfac(1) = 0.4_wp
  hhaccfac(2,1) = One
  hhaccfac(3,1) = OneHalf
  hhaccfac(4,1) = One
  zzacclim(2,2) = 0.8_wp
  zzacclim(3,2) = 1.25_wp
  hhtol(1) = 1.0e-10_wp
  scalesmall(2) = .false.
  nopth1(2) = 1
  nopth2(2) = 0
  hhrejfac(2) = 0.4_wp
  hhaccfac(3,2) = 1.2_wp
  hhtol(2) = 1.0e-10_wp
end if
if (imethod == 3) then
  ! 'TRUSTOPT'
  ! << TOLS_CVB common block: >>
  ! Criteria for entering local region:
  grd(1,1) = 5.0e-6_wp
  grd(1,2) = 5.0e-6_wp
  sgn(1) = smaller
  sgn(2) = smaller
  singul(1) = small
  zzmin(1) = -small
  zzmin(2) = -small
  ! Final convergence criteria:
  dx(1,3) = 5.0e-6_wp
  dx(1,4) = 1.0e-4_wp
  singul(2) = small2
  ! << TRST_CVB common block: >>
  scalesmall(1) = .true.
  nopth1(1) = 5
  nopth2(1) = 2
  delopth1(1) = 0.33333_wp
  delopth2(1) = One
  hhrejfac(1) = 0.08333_wp
  hhaccfac(3,1) = One
  hhtol(1) = 5.0e-6_wp
  dfxmin(1) = Zero
  scalesmall(2) = .false.
  nopth1(2) = 1
  nopth2(2) = 0
  hhrejfac(2) = Half
  hhaccfac(3,2) = 1.2_wp
  hhtol(2) = 5.0e-6_wp
  dfxmin(2) = Zero
end if
if (imethod == 4) then
  ! 'DAVIDSON'
  resthr = 1.0e-6_wp
end if
if (imethod == 5) then
  ! 'STEEP'
  exp12tol = Zero
  ! Criteria for entering local region:
  grd(1,1) = 5.0e-6_wp
  grd(1,2) = 5.0e-6_wp
  zzmin(1) = -small
  zzmin(2) = -small
  ! Final convergence criteria:
  ! << TRST_CVB common block: >>
  hhstart = 0.1_wp
  scalesmall(1) = .true.
  nopth1(1) = 1
  nopth2(1) = 0
  zzrejmin(1) = Zero
  zzrejmax(1) = 1.33_wp
  hhrejfac(1) = Half
  hhaccfac(2,1) = 1.2_wp
  hhaccfac(3,1) = 1.5_wp
  hhaccfac(4,1) = 1.2_wp
  zzacclim(2,1) = 0.8_wp
  zzacclim(3,1) = 1.25_wp
  hhtol(1) = 5.0e-6_wp
  hhmax(1) = 0.1_wp
  scalesmall(2) = .true.
  nopth1(2) = 1
  nopth2(2) = 0
  zzrejmin(2) = Zero
  zzrejmax(2) = 1.33_wp
  hhrejfac(2) = Half
  hhaccfac(2,2) = 1.2_wp
  hhaccfac(3,2) = 1.5_wp
  hhaccfac(4,2) = 1.2_wp
  zzacclim(2,2) = 0.8_wp
  zzacclim(3,2) = 1.25_wp
  hhtol(2) = 5.0e-6_wp
  hhmax(2) = Half
end if
if ((imethod == 6) .or. (imethod == 7) .or. (imethod == 8) .or. (imethod == 10) .or. (imethod == 12)) then
  ! 'VB2CAS' or 'AUGHESS' or 'AUG2' or 'DFLETCH' or 'SUPER'
  exp12tol = Zero
  ! Criteria for entering local region:
  grd(1,1) = 5.0e-4_wp
  grd(1,2) = 5.0e-4_wp
  sgn(1) = smaller
  sgn(2) = smaller
  singul(1) = small
  zzmin(1) = -small
  zzmin(2) = -small
  ! Final convergence criteria:
  grd(1,3) = 5.0e-6_wp
  grd(1,4) = 5.0e-6_wp
  !vv
  !dx(1,3) = 5.0e-6_wp
  dx(1,3) = 5.0e-5_wp
  dx(1,4) = 1.0e-4_wp
  singul(2) = small2
  ! << TRST_CVB common block: >>
  scalesmall(1) = .false.
  nopth1(1) = 1
  nopth2(1) = 0
  zzrejmin(1) = Zero
  hhrejfac(1) = 0.4_wp
  hhaccfac(2,1) = One
  hhaccfac(3,1) = OneHalf
  hhaccfac(4,1) = One
  zzacclim(2,2) = 0.8_wp
  zzacclim(3,2) = 1.25_wp
  hhtol(1) = 1.0e-10_wp
  dfxmin(1) = Zero
  scalesmall(2) = .false.
  nopth1(2) = 1
  nopth2(2) = 0
  hhrejfac(2) = 0.4_wp
  hhaccfac(3,2) = 1.2_wp
  hhtol(2) = 1.0e-10_wp
  dfxmin(2) = Zero
end if

return

end subroutine tunedefs2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine rdinp_surfacehop()

use Tully_variables, only: tullyL, DECO, decoherence, NSUBSTEPS, Ethreshold, RandThreshold, fixedrandL, FixedRand, InitSeed, &
                           iseedL, tullySubVerb, rassi_ovlp, Run_rassi
#ifdef _HDF5_
use Surfacehop_globals, only: lH5Restart, File_H5Res
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
character(len=180) :: Key, Line
logical(kind=iwp) :: Found
integer(kind=iwp) :: LuSpool, NSTATE, i, j, ndata, maxHop
real(kind=wp), allocatable :: temp(:), AmatrixVR(:), AmatrixVI(:)
character(len=180), external :: Get_Ln
integer(kind=iwp), external :: IsFreeUnit

LuSpool = IsFreeUnit(21)
call SpoolInp(LuSpool)

call RdNLst(LuSpool,'surfacehop')

read_input: do
  Key = Get_Ln(LuSpool)
  Line = Key
  call UpCase(Line)

  select case (Line(1:4))
    case ('TULL')
      tullyL = .true.
    case ('DECO')
      Line = Get_Ln(LuSpool)
      call Get_F1(1,DECO)
      decoherence = .true.
    case ('SUBS')
      Line = Get_Ln(LuSpool)
      call Get_I1(1,NSUBSTEPS)
    case ('ETHR')
      Line = Get_Ln(LuSpool)
      call Get_F1(1,Ethreshold)
    case ('RTHR')
      Line = Get_Ln(LuSpool)
      call Get_F1(1,RandThreshold)
    case ('PSUB')
      tullySubVerb = .true.
    case ('DMTX')
      Line = Get_Ln(LuSpool)
      call Get_I1(1,NSTATE)
      call mma_allocate(AmatrixVR,NSTATE*NSTATE,label='AmatrixVR')
      call mma_allocate(AmatrixVI,NSTATE*NSTATE,label='AmatrixVI')
      call mma_allocate(temp,NSTATE,label='temp')
      do i=1,NSTATE
        Line = Get_Ln(LuSpool)
        call Get_F(1,temp,NSTATE)
        do j=1,NSTATE
          AmatrixVR((i-1)*NSTATE+j) = temp(j)
        end do
      end do
      do i=1,NSTATE
        Line = Get_Ln(LuSpool)
        call Get_F(1,temp,NSTATE)
        do j=1,NSTATE
          AmatrixVI((i-1)*NSTATE+j) = temp(j)
        end do
      end do
      call mma_deallocate(temp)
      call Qpg_zArray('AmatrixV',Found,ndata)
      if (.not. Found) then
        call Put_dArray('RAmatrixV',AmatrixVR,NSTATE*NSTATE)
        call Put_dArray('IAmatrixV',AmatrixVI,NSTATE*NSTATE)
      else if (ndata /= NSTATE*NSTATE) then
        call warningmessage(2,'The A matrix dimension on the input is different from the one in runfile')
        call Abend()
      end if
      call mma_deallocate(AmatrixVR)
      call mma_deallocate(AmatrixVI)
    case ('FRAN')
      Line = Get_Ln(LuSpool)
      call Get_F1(1,FixedRand)
      fixedrandL = .true.
    case ('ISEE') ! initial seed number
      Line = Get_Ln(LuSpool)
      call Get_I1(1,InitSeed)
      iseedL = .true.
    case ('MAXH')
      Line = Get_Ln(LuSpool)
      call Get_I1(1,maxHop)
      call Put_iScalar('MaxHopsTully',maxHop)
      !write(u6,*) 'MaxHops set to ', maxHop
    case ('NORA')
      rassi_ovlp = .false.
      Run_rassi = .false.
    case ('H5RE')
#     ifdef _HDF5_
      lH5Restart = .true.
      Line = Get_Ln(LuSpool)
      call Get_S(1,File_H5Res,1)
#     else
      write(u6,*) 'The user asks to restart the dynamics calculation from a HDF5 file,'
      write(u6,*) 'but this is not supported in this installation.'
      call Quit_OnUserError()
#     endif
    case ('END ')
      exit
    case default
      write(u6,*) 'Unknown keyword: ',trim(Key)
      call Abend()
  end select
end do read_input

close(LuSpool)

return

end subroutine rdinp_surfacehop

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SIGVST(ISGVST,NSMST)
! Obtain ISGVST(ISM) : Symmetry of sigma v on string of symmetry ism

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSMST
integer(kind=iwp), intent(out) :: ISGVST(NSMST)
integer(kind=iwp) :: ISM

ISGVST(:) = [(-ISM+2,ISM=1,NSMST)]

#ifdef _DEBUGPRINT_
write(u6,*) ' ISGVST array'
write(u6,*) ' ============'
call IWRTMA(ISGVST,1,NSMST,1,NSMST)
#endif

end subroutine SIGVST

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Francesco Aquilante                              *
!***********************************************************************

function Vt_lim(rho,drho,ddrho)

use Constants, only: One, Two, Quart
use Definitions, only: wp

implicit none
real(kind=wp) :: Vt_lim
real(kind=wp), intent(in) :: rho, drho(3), ddrho
real(kind=wp) :: rhoinv, rhoinv2, xnorm

rhoinv = One/rho
rhoinv2 = rhoinv**Two
xnorm = drho(1)**2+drho(2)**2+drho(3)**2

Vt_lim = 0.125_wp*xnorm*rhoinv2-Quart*ddrho*rhoinv

end function Vt_lim

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine Ovrhss( &
#                 define _CALLING_
#                 include "hss_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: to compute the gradients of the overlap matrix               *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!             Anders Bernhardsson 1995                                 *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Her_RW, only: HerR, HerW, iHerR, iHerW
use Center_Info, only: dc
use Definitions, only: wp, iwp, u6

implicit none
#include "hss_interface.fh"
integer(kind=iwp) :: iBeta, ip, ipAlph, ipAxyz, ipBeta, ipBxyz, ipRnxyz, ipRxyz, nip
logical(kind=iwp) :: ABeq(3)

#include "macros.fh"
unused_var(ZInv)
unused_var(ifgrd)
unused_var(lOper)
unused_var(iStabM)
unused_var(nStabM)

ABeq(1) = A(1) == RB(1)
ABeq(2) = A(2) == RB(2)
ABeq(3) = A(3) == RB(3)

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+3)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+3)
ipRxyz = nip
nip = nip+nZeta*3*nHer*(nOrdOp+1)
ipRnxyz = nip
nip = nip+nZeta*3*(la+3)*(lb+3)*(nOrdOp+1)
ipAlph = nip
nip = nip+nZeta
ipBeta = nip
nip = nip+nZeta
if (nip-1 > nArr) then
  write(u6,*) 'OvrHss: nip-1 > nArr'
  write(u6,*) 'nip,nArr=',nip,nArr
  call Abend()
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' IfHss=',IfHss
write(u6,*) ' IndHss=',IndHss
call RecPrt(' In OvrHss: A',' ',A,1,3)
call RecPrt(' In OvrHss: RB',' ',RB,1,3)
call RecPrt(' In OvrHss: Ccoor',' ',Ccoor,1,3)
call RecPrt(' In OvrHss: P',' ',P,nZeta,3)
write(u6,*) ' In OvrHss: la,lb=',la,lb
#endif

! Compute the cartesian values of the basis functions angular part

call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),la+2,HerR(iHerR(nHer)),nHer,ABeq)
call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),lb+2,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the contribution from the multipole moment operator

ABeq(1) = .false.
ABeq(2) = .false.
ABeq(3) = .false.
call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the cartesian components for the multipole moment
! integrals. The integrals are factorized into components.

call Assmbl(Array(ipRnxyz),Array(ipAxyz),la+2,Array(ipRxyz),nOrdOp,Array(ipBxyz),lb+2,nZeta,HerW(iHerW(nHer)),nHer)

! Combine the cartesian components to the gradient of the one
! electron integral and contract with the Fock matrix.

ip = ipAlph
do iBeta=1,nBeta
  Array(ip:ip+nAlpha-1) = Alpha
  ip = ip+nAlpha
end do
ip = ipBeta
do iBeta=1,nBeta
  Array(ip:ip+nAlpha-1) = Beta(iBeta)
  ip = ip+nAlpha
end do

call CmbnS2(Array(ipRnxyz),nZeta,la,lb,Zeta,rKappa,rFinal,Array(ipAlph),Hess,nHess,DAO,IfHss,IndHss,indgrd,dc(mdc)%nStab, &
            dc(ndc)%nStab,nOp)

return

end subroutine Ovrhss

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Interf(i_root,Ene,isuseene,iscasvb)
************************************************************************
*                                                                      *
*     Object: Driver toward MOLDEN interface                           *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "rasdim.fh"
#include "general.fh"
#include "casvb.fh"
#include "WrkSpc.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='INTERF  ')
      Character*10 Filename
      Character*80 Note
      Dimension Ene(*)
      Dimension iDum(7,8)
*
* Local print level:
      IPRLEV=IPRLOC(7)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute memory requirements and allocate memory
*
      nB =0
      nB2=0
      Do iS=1,nSym
         nB =nB +nBas(iS)
         nB2=nB2+nBas(iS)**2
      End Do
*
      Call GetMem('OCCA','Allo','Real',ipOccA,nB)
      Call GetMem('OCCB','Allo','Real',ipOccB,nB)
      Call GetMem('ENERGY','Allo','Real',ipEA,2*nB)
      ipEB=ipEA+nB
      Call GetMem('CMOA','Allo','Real',ipCA,nB**2)
      Call GetMem('CMOB','Allo','Real',ipCB,nB**2)
      Call GetMem('AdCMOA','Allo','Real',mAdCMOA,nB2)
      Call GetMem('AdCMOB','Allo','Real',mAdCMOB,nB2)
*                                                                      *
************************************************************************
*                                                                      *
C -For the moment: Orbital energies just zero
      If (isuseene.ne.0) then
         Do i=1,nB
            Work(ipEA+i-1)=Ene(i)
            Work(ipEB+i-1)=Ene(i)
         End Do
      Else
         Call FZero(Work(ipEA),2*nB)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Get the coeff. of sym adapted basis functions (ipCA, ipCB) and
*     the spin orbital occupations (ipOccA, ipOccB)
*
      Call Dens_IF(i_root,Work(ipCA),Work(ipCB),Work(ipOccA),
     &                                          Work(ipOccB))
      Call Dens_IF_SCF(Work(ipCA),Work(mAdCMOA),'B')
      Call Dens_IF_SCF(Work(ipCB),Work(mAdCMOB),'B')
*                                                                      *
************************************************************************
*                                                                      *
*     Write out info on a temporary vector file.
*
      Note='Temporary orbital file for the MOLDEN interface.'
      LuTmp=50
      LuTmp=IsFreeUnit(LuTmp)
      iUHF=IFVB
      If (i_root.ne.0) iUHF=1
      Call WrVec_('TMPORB',LuTmp,'COE',iUHF,nSym,nBas,nBas,
     &            Work(mAdCMOA),Work(mAdCMOB),
     &            Work(ipOccA),Work(ipOccB),
     &            Work(ipEA),Work(ipEB),
     &            iDum,Note,0)
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('AdCMOB','Free','Real',mAdCMOB,nB2)
      Call GetMem('AdCMOA','Free','Real',mAdCMOA,nB2)
      Call GetMem('CMOA','Free','Real',ipCA,nB**2)
      Call GetMem('CMOB','Free','Real',ipCB,nB**2)
      Call GetMem('ENERGY','Free','Real',ipEA,nB)
      Call GetMem('OCCA','Free','Real',ipOccA,nB)
      Call GetMem('OCCB','Free','Real',ipOccB,nB)
*                                                                      *
************************************************************************
*                                                                      *
      If (i_root.ne.0) Then
         If (i_root.le.9) Then
            Write(filename,'(A7,I1)') 'MD_CAS.',i_root
         Else If (i_root.le.99) Then
            Write(filename,'(A7,I2)') 'MD_CAS.',i_root
         Else If (i_root.le.999) Then
            Write(filename,'(A7,I3)') 'MD_CAS.',i_root
         Else
            filename='MD_CAS.x'
         End If
      Else
         filename='MD_CAS'
      End If
      if(iscasvb.eq.1) filename='MD_VB'
*                                                                      *
************************************************************************
*                                                                      *
*     Call the generic MOLDEN interface
*
      Call Molden_Interface(iUHF,'TMPORB',filename)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2016,2017, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GrdClc(Do_All)
!***********************************************************************
!                                                                      *
!     purpose: Compute gradients and write on disk.                    *
!                                                                      *
!                                                                      *
!     input:                                                           *
!       Do_All  : variable telling what gradients compute: .true. -    *
!                 all gradients, .False. - last gradient               *
!     written by:                                                      *
!     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!***********************************************************************

use InfSCF, only: CMO_Ref, FockMO, Iter, Iter_Start, kOV, mOV, nBO, nBT, nD, nOO, OneHam, Ovrlp
use LnkLst, only: LLGrad, LLlGrd, PutVec
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
logical(kind=iwp), intent(inout) :: Do_All
integer(kind=iwp) :: iOpt, LpStrt
real(kind=wp), allocatable :: GrdOO(:,:), GrdOV(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Allocate memory for gradients
call mma_allocate(GrdOO,nOO,nD,Label='GrdOO')
call mma_allocate(GrdOV,mOV,Label='GrdOV')

! Find the beginning of the loop
if (Do_All) then
  LpStrt = Iter_Start
  Do_All = .false.
else
  LpStrt = Iter
end if

! Compute all gradients / last gradient

do iOpt=LpStrt,Iter

  if (iOpt == Iter) call Mk_FockMO(OneHam,Ovrlp,nBT,CMO_Ref,nBO,FockMO,nOO,nD,iOpt)

  call EGrad(OneHam,Ovrlp,nBT,CMO_Ref,nBO,GrdOO,nOO,nD,iOpt)

  call vOO2OV(GrdOO,nOO,GrdOV,mOV,nD,kOV)

  ! Write Gradient to linked list

  call PutVec(GrdOV,mOV,iOpt,'OVWR',LLGrad)
  if (iOpt == Iter) call PutVec(GrdOV,mOV,iOpt,'OVWR',LLlGrd)

# ifdef _DEBUGPRINT_
  write(u6,*) 'GrdClc: Put Gradient iteration:',iOpt
  write(u6,*) 'iOpt,mOV=',iOpt,mOV
  call NrmClc(GrdOO,nOO*nD,'GrdClc','GrdOO')
  call NrmClc(GrdOV,mOV,'GrdClc','GrdOV')
# endif
end do

! Deallocate memory

call mma_deallocate(GrdOV)
call mma_deallocate(GrdOO)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine GrdClc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Localize_LoProp(Ttot,Ttot_Inv,nBas,SMatrix,iCenter,iType)
!                                                                      *
!***********************************************************************
!                                                                      *
! H2 molecule with 2s basis functions on each H: A and B are the two
! centers
! Original S matrix  (nz=non zero; 10-8 should be zero but it is not for
! numerical imprecision
!       1     10-8  nz   nz
! S0=   10-8  1     nz   nz
!       nz    nz    1    10-8
!       nz    nz    10-8 1
!
! Step 1. LO S0 in order to generate S1 (orthogonalization of all the
! blocks for the same center
!       1     0     nz   nz
! S1=   0     1     nz   nz
!       nz    nz    1    0
!       nz    nz    0    1
!
! Step 2. LO S1 -> S2 (orthogonalization of the OAOB and VAVB blocks
!       1     0     0    nz
! S2=   0     1     nz   0
!       0     nz    1    0
!       nz    0     0    1
!
! Step 3. GS S2 -> S3 (orthogonalization of the VBOA and VAOB blocks
!       1     0     0    0
! S3=   0     1     0    0
!       0     0     1    0
!       0     0     0    1
!                                                                      *
!***********************************************************************
!                                                                      *

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBas, iCenter(nBas), iType(nBas)
real(kind=wp), intent(out) :: Ttot(nBas,nBas), Ttot_Inv(nBas,nBas)
real(kind=wp), intent(inout) :: SMatrix(nBas,nBas)
integer(kind=iwp) :: iBas, IndType(7), iUHF, LuOut, nOcc, nSym
character(len=128) :: OrbName
character(len=80) :: Note
character(len=6) :: Filename
real(kind=wp), allocatable :: E(:), S(:,:), SSave(:,:), T1(:,:), T2(:,:), T3(:,:), T4(:,:), tmp(:,:)
integer(kind=iwp), parameter :: Occ = 1, Vir = 0

!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate temporary memory

call mma_allocate(T1,nBas,nBas,label='T1')
call mma_allocate(T2,nBas,nBas,label='T2')
call mma_allocate(T3,nBas,nBas,label='T3')
call mma_allocate(T4,nBas,nBas,label='T4')
call mma_allocate(tmp,nBas,nBas,label='tmp')
call mma_allocate(S,nBas,nBas,label='S')
call mma_allocate(SSave,nBas,nBas,label='SSave')

! Save S because GS will destroy it!

S(:,:) = SMatrix(:,:)
!                                                                      *
!***********************************************************************
!                                                                      *
! Step 1. GS S0 ->S1

T1(:,:) = Zero
call dcopy_(nBas,[One],0,T1,nBas+1)

call Step1(iCenter,S,nBas,T1,iType,SMatrix,tmp)
!                                                                      *
!***********************************************************************
!                                                                      *
! Step 2. LO S1 ->S2

SSave(:,:) = S(:,:)
T2(:,:) = Zero
call dcopy_(nBas,[One],0,T2,nBas+1)

call Step2(iCenter,S,nBas,T2,iType,SSave,tmp)
!                                                                      *
!***********************************************************************
!                                                                      *
! Now set up things for the GS orthogonalization
!
! Step 3. GS S2 ->S3

call Step3(iCenter,S,nBas,T3,iType)

!                                                                      *
!***********************************************************************
!                                                                      *
! Now do a final Lowdin to remove virtual-virtual
!
! Step 4. LO S3 ->S4

call Step4(S,nBas,T4,iType)

!                                                                      *
!***********************************************************************
!                                                                      *
! Now I have LO orthog twice and GS orthog
! The corresponding transformation matrices are T1 T2 and TGS
! Now I generate the total transformation matrix TTOT=T1*T2*TGS
!
! ...now T is T1*T2*T3*T4

call Ttotal(T1,T2,T3,T4,Ttot,Ttot_Inv,nBas)
!                                                                      *
!***********************************************************************
!                                                                      *
! Check that all this works by applaying TTot to original overlap
! matrix and you should get unit matrix
!
!call RecPrt('Old S',' ',SMatrix,nBas,nBas)
!call xxDGeMul(SMatrix,nBas,'N',Ttot,nBas,'N',tmp,nBas,nBas,nBas,nBas)
!call xxDGeMul(Ttot,nBas,'T',tmp,nBas,'N',SMatrix,nBas,nBas,nBas,nBas)
!call RecPrt('New S',' ',SMatrix,nBas,nBas)
!                                                                      *
!***********************************************************************
!                                                                      *
! Dealloctate memory

call mma_deallocate(T1)
call mma_deallocate(T2)
call mma_deallocate(T3)
call mma_deallocate(T4)
call mma_deallocate(tmp)
call mma_deallocate(S)
call mma_deallocate(SSave)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out the transformation matrix as molecular orbitals.

nOcc = 0
do iBas=1,nBas
  if (iType(iBas) == Occ) nOcc = nOcc+1
end do

IndType(1) = 0
IndType(2) = nOcc
IndType(3) = 0
IndType(4) = 0
IndType(5) = 0
IndType(6) = nBas-nOcc
IndType(7) = 0

call mma_allocate(E,nBas,label='E')
E(:) = Zero
OrbName = 'LPRORB'
LuOut = 20
iUHF = 0
nSym = 1
Note = 'LoProp localized orbitals'
call WrVec_(OrbName,LuOut,'COEI',iUHF,nSym,[nBas],[nBas],TTot,[Zero],E,[Zero],E,[Zero],IndType,Note,0)
call mma_deallocate(E)
!                                                                      *
!***********************************************************************
!                                                                      *
! Not implemented for symmetry!

Filename = 'MD_LPR'
call Get_iScalar('nSym',nSym)
if (nSym == 1) call Molden_Interface(iUHF,OrbName,Filename)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Localize_LoProp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2007, Markus Reiher                               *
************************************************************************
c
c NOTE: THESE ROUTINES ARE IDENTICAL TO THOSE IN multiply.f EXCEPT
c       THAT THESE CAN ALSO PARSE THE DYNAMICALLY ALLOCATED work()
c       SPACE FROM evalstring().
c
c
      subroutine multiplyb(length,term,coeff,nbas,posu,post,poss,vv,nn,
     *                     dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,
     *                     tnumber,unumber,scr1,scr2,scr3,A,C,nbasp,
     *                     nbaso,ieval,count,dkhadr,adrmem,dkh_48,
     *                     adrnext)
c
c************************************************************************
c
c   Execute matrix multiplications for string 'term' of length 'length'
c     with coefficient 'coeff':
c
c     C = coeff * (A * B_1 * B_2 * B_3 ...)
c
c     (the B_i are determined in this routine according to the
c      entries in term(:))
c
c   Note:  * There are no brackets occurring in term, i.e, only Sxxx, Txxx,
c              Uxxx, Axx, V,N,D,Y,F,G,Z,Q,X,I,J,K,L,M  have to be dealt with.
c          * The result is stored in C.
c          * 'term' might contain only 1 factor.
c          * 'term' is destroyed by this procedure.
c
c   This SR belongs to dkhparser_numeric.
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.2.0
c
c   last modified: 13.03.2007 (M. Reiher, ETH Zurich)
c                  * latest version can do IO to disk
c                  * the new version includes calls to a new version of
c                    dertermine_factor() in order to avoid unnecessary matrix
c                    copy calls
c                  * other: significant changes compared to previous versions
c                    in order to make it much more efficient
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer length,nbas,posu(maxunumber),post(maxsnumber),nbasp,
     *        poss(maxsnumber),snumber,tnumber,unumber,count,nbaso,
     *        ieval(count)
      character*(maxlength) term
      REAL*8 coeff
c
      REAL*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp)
      REAL*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),A(nbas,nbas),
     *                 C(nbas,nbas)
c
      integer iact
c
      integer dkh_48,adrmem,adrnext
      integer dkhadr(adrmem)
c
c-------------------------------------------------------------------------
c
      iact=1
CMR      write(*,*) "  multiplyb: term(1:length)=",term(1:length)
      call determine_factorb(length,term,iact,nbas,posu,post,poss,vv,nn,
     *                       dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,
     *                       snumber,tnumber,unumber,scr1,scr2,
     *                       scr3,A,nbasp,nbaso,ieval,count,
     *                       dkhadr,adrmem,dkh_48,adrnext)
*** now: left factor is in A
c
*** check if term() contains only a single matrix and return
      if (iact.gt.length) then
        call mat_copy_c(C,nbas,nbas,A,coeff)
        goto 2000
      end if
c
1000  continue
c
*** determine right factor and multiply -> result is then in C
      call determine_factor2b(length,term,iact,nbas,posu,post,poss,vv,
     *                       nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,
     *                       snumber,tnumber,unumber,scr1,scr2,
     *                       scr3,A,C,nbasp,nbaso,ieval,count,
     *                       dkhadr,adrmem,dkh_48,adrnext)
c
      if (iact.gt.length) then
*** last factor found: multiply and return
        call mat_copy_c(C,nbas,nbas,C,coeff)
        goto 2000
      else
*** multiply without additional copying matrices
*** now: left factor is in C
        call determine_factor2b(length,term,iact,nbas,posu,post,poss,vv,
     *                       nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,
     *                       snumber,tnumber,unumber,scr1,scr2,
     *                       scr3,C,A,nbasp,nbaso,ieval,count,
     *                       dkhadr,adrmem,dkh_48,adrnext)
        if (iact.gt.length) then
          call mat_copy_c(C,nbas,nbas,A,coeff)
          goto 2000
        else
          goto 1000
        end if
      end if
c
2000  return
      end
c
c
c
c
      subroutine multiply2b(length,term,coeff,nbas,iposA,posu,post,poss,
     *                     vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,
     *                     snumber,tnumber,unumber,scr1,scr2,scr3,A,C,
     *                     nbasp,nbaso,ieval,count,dkhadr,adrmem,dkh_48,
     *                     adrnext)
c
c************************************************************************
c
c   Execute matrix multiplications for string 'term' of length 'length'
c     with coefficient 'coeff':
c
c       C = coeff * (A * B_1 * B_2 * B_3 ...)
c
c     (the B_i are determined in this routine according to the
c      entries in term(:))
c
c   Note:  * There are no brackets occurring in term, i.e, only Sxxx, Txxx,
c              Uxxx, Axx, V,N,D,Y,F,G,Z,Q,X,I,J,K,L,M  have to be dealt with.
c          * The result is stored in C.
c          * 'term' might contain only 1 factor.
c          * 'term' is destroyed by this procedure.
c          * most important: this routine obtains the left-hand-side factor
c            on input left factor is in A
c
c   This SR belongs to dkhparser_numeric.
c
c   written by:  Markus Reiher  (ETH Zurich)
c
c   version:  2.2.0
c
c   modified: 13.03.07 MR@ETH
c   first version: 14.01.2007  (ETH Zurich)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer length,nbas,posu(maxunumber),post(maxsnumber),nbasp,
     *        poss(maxsnumber),snumber,tnumber,unumber,iposA,count,
     *        ieval(count),nbaso
      character*(*) term
      REAL*8 coeff
c
      REAL*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp)
      REAL*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),A(nbas,nbas),
     *                 C(nbas,nbas)
c
      integer iact
c
      integer dkh_48,adrmem,adrnext
      integer dkhadr(adrmem)
c
c-------------------------------------------------------------------------
c
CMR      iact=iposA
CMR This sub assumes that "A00" starts at position 1 in term !
      iact=1
*** this routine gets A00 as a first factor so that the next factor starts at iact=4
      iact=iact+3
c
*** check if term() contains only a single matrix
      if (iact.gt.length) then
        call mat_copy_c(C,nbas,nbas,A,coeff)
        goto 2000
      end if
c
1000  continue
c
*** determine right factor and multiply -> result is then in C
      call determine_factor2b(length,term,iact,nbas,posu,post,poss,vv,
     *                       nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,
     *                       snumber,tnumber,unumber,scr1,scr2,
     *                       scr3,A,C,nbasp,nbaso,ieval,count,
     *                       dkhadr,adrmem,dkh_48,adrnext)
c
      if (iact.gt.length) then
*** last factor found: multiply and return
        call mat_copy_c(C,nbas,nbas,C,coeff)
        goto 2000
      else
*** multiply without additional copying matrices
*** now: left factor is in C
        call determine_factor2b(length,term,iact,nbas,posu,post,poss,vv,
     *                       nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,
     *                       snumber,tnumber,unumber,scr1,scr2,
     *                       scr3,C,A,nbasp,nbaso,ieval,count,
     *                       dkhadr,adrmem,dkh_48,adrnext)
        if (iact.gt.length) then
          call mat_copy_c(C,nbas,nbas,A,coeff)
          goto 2000
        else
          goto 1000
        end if
      end if
c
2000  return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(iposA)
      end
c
c
c
c
      subroutine multiply3b(length,term,coeff,nbas,posu,post,poss,vv,nn,
     *                     dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,
     *                     tnumber,unumber,scr1,scr2,scr3,A,C,nbasp,
     *                     nbaso,ieval,count,dkhadr,adrmem,dkh_48,
     *                     adrnext)
c
c************************************************************************
c
c   Execute matrix multiplications for string 'term' of length 'length'
c     with coefficient 'coeff':
c
c       C = coeff * (... B_3 * B_2 * B_1 * A)
c
c     (the B_i are determined in this routine according to the
c      entries in term(:))
c
c   Note:  * There are no brackets occurring in term, i.e, only Sxxx, Txxx,
c              Uxxx, Axx, V,N,D,Y,F,G,Z,Q,X,I,J,K,L,M  have to be dealt with.
c          * The result is stored in C.
c          * 'term' might contain only 1 factor.
c          * 'term' is destroyed by this procedure.
c          * most important: this routine obtains the left-hand-side factor
c            on input left factor is in A
c
c   This SR belongs to dkhparser_numeric.
c
c   written by:  Markus Reiher  (ETH Zurich)
c
c   version:  2.2.0
c
c   modified: 13.03.07 MR@ETH
c   first version: 14.01.2007  (ETH Zurich)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer length,nbas,posu(maxunumber),post(maxsnumber),nbasp,
     *        poss(maxsnumber),snumber,tnumber,unumber,count,
     *        ieval(count),nbaso
      character*(maxlength) term
      REAL*8 coeff
c
      REAL*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp)
      REAL*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),A(nbas,nbas),
     *                 C(nbas,nbas)
c
      integer iact
c
      integer dkh_48,adrmem,adrnext
      integer dkhadr(adrmem)
c
c-------------------------------------------------------------------------
c
*** this routine gets A00 as a first right-hand-side factor so that the next
***   factor starts at length-1
      iact=length
c
*** check if term() contains only a single matrix
      if (iact.lt.1) then
        write(6,*) "CMR: SHOULD NEVER OCCUR HERE !"
        call mat_copy_c(C,nbas,nbas,A,coeff)
        goto 2000
      end if
c
1000  continue
c
*** determine left factor and multiply -> result is then in C
      call determine_factor3b(length,term,iact,nbas,posu,post,poss,vv,
     *                       nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,
     *                       snumber,tnumber,unumber,scr1,scr2,
     *                       scr3,A,C,nbasp,nbaso,ieval,count,
     *                       dkhadr,adrmem,dkh_48,adrnext)
c
      if (iact.lt.1) then
*** last factor found: multiply and return
        call mat_copy_c(C,nbas,nbas,C,coeff)
        goto 2000
      else
*** multiply without additional copying matrices
*** now: left factor is in C
        call determine_factor3b(length,term,iact,nbas,posu,post,poss,vv,
     *                       nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,
     *                       snumber,tnumber,unumber,scr1,scr2,
     *                       scr3,C,A,nbasp,nbaso,ieval,count,
     *                       dkhadr,adrmem,dkh_48,adrnext)
        if (iact.lt.1) then
          call mat_copy_c(C,nbas,nbas,A,coeff)
          goto 2000
        else
          goto 1000
        end if
      end if
c
2000  return
      end
c
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               2016, Lasse Kragh Soerensen                            *
!***********************************************************************

subroutine OAMInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of orbital angular        *
!         momentum integrals.                                          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, February '91                            *
!             Placed restrictions on the differentiation. Lasse '16    *
!***********************************************************************

use Gateway_Info, only: lDOWNONLY, lUPONLY
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
#include "int_interface.fh"
integer(kind=iwp) :: iBeta, iComp, iDCRT(0:7), ipArr, ipB, ipOff, ipRes, ipS1, ipS2, iStabO(0:7), lDCRT, llOper, LmbdT, mArr, &
                     nDCRT, nip, nOp, nStabO
real(kind=wp) :: TC(3)
integer(kind=iwp), external :: NrOpr

#include "macros.fh"
unused_var(PtChrg)
unused_var(iAddPot)

nip = 1
ipB = nip
nip = nip+nZeta
ipS1 = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb+1)*3
ipS2 = 1
if (lb > 0) then
  ipS2 = nip
  nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb-1)*3
end if
ipRes = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp
if (nip-1 > nZeta*nArr) then
  call WarningMessage(2,' OAMInt: nip-1 > nZeta*nArr')
  call Abend()
end if
ipArr = nip
mArr = (nArr*nZeta-(nip-1))/nZeta

rFinal(:,:,:,:) = Zero

iComp = 3
llOper = lOper(1)
do iComp=2,nComp
  llOper = ior(llOper,lOper(iComp))
end do
call SOS(iStabO,nStabO,llOper)
call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

ipOff = ipB-1
do iBeta=1,nBeta
  Array(ipOff+1:ipOff+nAlpha) = Beta(iBeta)
  ipOff = ipOff+nAlpha
end do

do lDCRT=0,nDCRT-1
  call OA(iDCRT(lDCRT),CCoor,TC)

  if (.not. lDOWNONLY) then
    nHer = (la+(lb+1)+(nOrdOp-1)+2)/2
    call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS1),nZeta,iComp,la,lb+1,A,RB,nHer,Array(ipArr),mArr,TC,nOrdOp-1)
  end if

  if (lb > 0) then
    if (.not. lUPONLY) then
      nHer = (la+(lb-1)+(nOrdOp-1)+2)/2
      call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS2),nZeta,iComp,la,lb-1,A,RB,nHer,Array(ipArr),mArr,TC, &
                  nOrdOp-1)
    end if
  end if

  ! Combine derivatives of dipole integrals to generate the
  ! orbital angular momentum integrals.

  call Util2(Array(ipB),nZeta,Array(ipRes),la,lb,Array(ipS1),Array(ipS2))

  ! Accumulate contributions

  nOp = NrOpr(iDCRT(lDCRT))
  call SymAdO(Array(ipRes),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,One)

end do

return

end subroutine OAMInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombOnly_XIDI(Mode,tau,nD,FactC,ip_DBlocks,ip_FBlocks)
! Thomas Bondo Pedersen, June 2014.
!
! Compute correction from errors in the integral diagonal blocks,
! adding them to the blocked Fock matrix.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Mode, nD, ip_DBlocks(nD), ip_FBlocks(nD)
real(kind=wp), intent(in) :: tau, FactC(nD)
logical(kind=iwp) :: IPI_set_here
integer(kind=iwp) :: TaskListID, AB, A, B, nAB, l_Int, n_Int, iD, ipD, ipF
real(kind=wp), allocatable :: FCIInt(:)
logical(kind=iwp), external :: Rsv_Tsk, LDF_IntegralPrescreeningInfoIsSet
integer(kind=iwp), external :: LDF_nBas_Atom
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

if (.not. LDF_IntegralPrescreeningInfoIsSet()) then
  call LDF_SetIntegralPrescreeningInfo()
  IPI_set_here = .true.
else
  IPI_set_here = .false.
end if

call Init_Tsk(TaskListID,NumberOfAtomPairs)
do while (Rsv_Tsk(TaskListID,AB))
  A = iWork(ip_AP_Atoms-1+2*(AB-1)+1)
  B = iWork(ip_AP_Atoms-1+2*(AB-1)+2)
  nAB = LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
  if (nAB > 0) then
    n_Int = nAB**2
    l_Int = 2*n_Int
    call mma_allocate(FCIInt,l_Int,label='FCIInt')
    call LDF_ComputeValenceIntegrals(AB,AB,n_Int,FCIInt)
    call LDF_ComputeValenceIntegralsFromC(Mode,tau,AB,AB,n_Int,FCIInt(n_Int+1))
    call dAXPY_(n_Int,-One,FCIInt(n_Int+1),1,FCIInt,1)
    do iD=1,nD
      ipD = iWork(ip_DBlocks(iD)-1+AB)
      ipF = iWork(ip_FBlocks(iD)-1+AB)
      call dGeMV_('N',nAB,nAB,FactC(iD),FCIInt,max(nAB,1),Work(ipD),1,One,Work(ipF),1)
    end do
    call mma_deallocate(FCIInt)
  end if
end do
call Free_Tsk(TaskListID)

if (IPI_set_here) then
  call LDF_UnsetIntegralPrescreeningInfo()
end if

end subroutine LDF_Fock_CoulombOnly_XIDI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_SetPass(Diag,Sync,DiaSh,iSySh,iLoc,Conv,nPotSh)
C
C     Purpose: check convergence and, if not converged, set up next
C              next integral pass
C              Diag is the local diagonal; the global diagonal is
C              synchronized if Sync=.True. Note that DiaSh and iSySh
C              must be allocated with dimension nnShl_G (global number
C              of shell pairs in 1st reduced set). iLoc is the location
C              to use in the reduced set index arrays. On exit,
C              Conv=.True. if converged and nPotSh is the number of
C              shell pairs whose max. diagonal element is larger than
C              the decomposition threshold.
C
      Implicit None
      Real*8  Diag(*)
      Logical Sync, Conv
      Real*8  DiaSh(*)
      Integer iSySh(*)
      Integer iLoc, nPotSh
#include "cho_para_info.fh"
#include "choglob.fh"
#include "WrkSpc.fh"

      If (Cho_Real_Par) Then

C        Sync diagonal if requested.
C        ---------------------------

         If (Sync) Then
            Call Cho_P_SyncDiag(Diag,iLoc)
         End If

C        Swap local and global index arrays and set next integral pass
C        original serial routine.
C        -------------------------------------------------------------

         Call Cho_P_IndxSwp()
         Call Cho_SetPass(Work(ip_Diag_G),DiaSh,iSySh,iLoc,Conv,nPotSh)
         Call Cho_P_IndxSwp()

      Else

         Call Cho_SetPass(Diag,DiaSh,iSySh,iLoc,Conv,nPotSh)

      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Rd1Int_FFPT()
!***********************************************************************
!                                                                      *
!     Objective: Read the header of the one-electron integral file     *
!                Extract also symmetry and basis set information.      *
!                In addition read the overlap, the nuclear attraction  *
!                and kinetic integrals.                                *
!                                                                      *
!***********************************************************************

use FFPT_Global, only: nAtoms, nBas, nSym, Coor, Header
use stdalloc, only: mma_allocate

implicit none

!----------------------------------------------------------------------*
!                                                                      *
!     Start procedure                                                  *
!     Read one-electron integral file header etc.                      *
!                                                                      *
!----------------------------------------------------------------------*

call Get_cArray('Seward Title',Header,144)
call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
call Get_iScalar('Unique atoms',nAtoms)
call mma_allocate(Coor,3,nAtoms,label='Coor')
call Get_dArray('Unique Coordinates',Coor,3*nAtoms)

return

end subroutine Rd1Int_FFPT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE REOR_MAT(Y,X,I1,I2,J1,J2)
      implicit none
      integer I1,I2,J1,J2, I,J,IJ,L
      REAL*8 Y,X,ONE,SCALAR
      PARAMETER (ONE=1.D0)
      DIMENSION Y(I1,I2,J1,J2),X(*)
C
CSUBROUTINE EX24 EXCHANGE OF THE 2nd and 4th index in a matrix
C
      ENTRY EX24(Y,X,I1,I2,J1,J2)
      IJ=1
      DO J=1,I2
         DO L=1,J1
            DO I=1,J2
               CALL DCOPY_(I1,Y(1,J,L,I),1,X(IJ),1)
               IJ=IJ+I1
            ENDDO
         ENDDO
      ENDDO
      RETURN
C
C
      ENTRY EX24_A(Y,X,I1,I2,J1,J2,SCALAR)
C
CS EX24_A EXCHANGE OF THE 2nd and 4th index in a matrix+ADD
C
      IJ=1
      DO J=1,I2
         DO L=1,J1
            DO I=1,J2
               CALL DAXPY_(I1,SCALAR,Y(1,J,L,I),1,X(IJ),1)
!              CALL DCOPY_(I1,Y(1,J,L,I),1,X(IJ),1)
               IJ=IJ+I1
            ENDDO
         ENDDO
      ENDDO
      RETURN
C
C
      ENTRY EX34_A(Y,X,I1,I2,J1,J2,SCALAR)
C
CS EX34_A EXCHANGE OF THE 3nd and 4th index in a matrix+ADD
C
      IJ=1
!     DO J=1,I2
      DO L=1,J1
         DO I=1,J2
            CALL DAXPY_(I1*I2,SCALAR,Y(1,1,L,I),1,X(IJ),1)
!           CALL DCOPY_(I1,Y(1,J,L,I),1,X(IJ),1)
            IJ=IJ+I1*I2
         ENDDO
      ENDDO
!     ENDDO
      RETURN
C
C
      ENTRY EX23(Y,X,I1,I2,J1,J2)
C
      IJ=1
      DO J=1,J2
         DO L=1,I2
            DO I=1,J1
               CALL DCOPY_(I1,Y(1,L,I,J),1,X(IJ),1)
               IJ=IJ+I1
            ENDDO
         ENDDO
      ENDDO
      RETURN
C
C
      ENTRY EX23_A(Y,X,I1,I2,J1,J2)
C
      IJ=1
      DO J=1,J2
         DO L=1,I2
            DO I=1,J1
               CALL DAXPY_(I1,ONE,Y(1,L,I,J),1,X(IJ),1)
               IJ=IJ+I1
            ENDDO
         ENDDO
      ENDDO
      RETURN
C
C
      ENTRY EX312(Y,X,I1,I2,J1,J2)
C
      IJ=1
      DO J=1,J2
         DO L=1,I2
            DO I=1,I1
               CALL DCOPY_(J1,Y(I,L,1,J),I1*I2,X(IJ),1)
               IJ=IJ+J1
            ENDDO
         ENDDO
      ENDDO
      RETURN
C
C
      ENTRY EX2413(Y,X,I1,I2,J1,J2)
C
      IJ=1
      DO J=1,J1
         DO L=1,I1
            DO I=1,J2
               CALL DCOPY_(I2,Y(L,1,J,I),I1,X(IJ),1)
               IJ=IJ+I2
            ENDDO
         ENDDO
      ENDDO

      RETURN
C
C
      ENTRY EX2413_A(Y,X,I1,I2,J1,J2)
C
      IJ=1
      DO J=1,J1
         DO L=1,I1
            DO I=1,J2
               CALL DAXPY_(I2,ONE,Y(L,1,J,I),I1,X(IJ),1)
               IJ=IJ+I2
            ENDDO
         ENDDO
      ENDDO
      RETURN
C
C
      ENTRY EX423(Y,X,I1,I2,J1,J2)
C
      IJ=1
      DO J=1,J1
         DO L=1,I2
            DO I=1,J2
               CALL DCOPY_(I1,Y(1,L,J,I),1,X(IJ),1)
               IJ=IJ+I1
            ENDDO
         ENDDO
      ENDDO
      RETURN
C
C
      ENTRY EX423_A(Y,X,I1,I2,J1,J2,SCALAR)
C
      IJ=1
      DO J=1,J1
         DO L=1,I2
            DO I=1,J2
               CALL DAXPY_(I1,SCALAR,Y(1,L,J,I),1,X(IJ),1)
C              CALL DCOPY_(I1,Y(1,L,J,I),1,X(IJ),1)
               IJ=IJ+I1
            ENDDO
         ENDDO
      ENDDO
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Strtch(xyz,nCent,Avst,B,lWrite,Label,dB,ldB)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 B(3,nCent), xyz(3,nCent), dB(3,nCent,3,nCent), R(3)
      Logical lWrite, ldB
      Character*8 Label
#include "angstr.fh"
*
      R(1)=xyz(1,2)-xyz(1,1)
      R(2)=xyz(2,2)-xyz(2,1)
      R(3)=xyz(3,2)-xyz(3,1)
      R2=R(1)**2+R(2)**2+R(3)**2
      RR=Sqrt(R2)
      Avst=RR
*
      aRR=RR*angstr
      If (lWrite) Write (6,'(1X,A,A,2(F10.6,A))') Label,
     &      ' : Bond Length=',aRR,' / Angstrom',RR,' / bohr'
      If (aRR.LT.1d-6) then
         Call WarningMessage(2,'Abend in Strtch')
         Write (6,*) '***************** ERROR **********************'
         Write (6,*) ' Short (or negative) distance for coordinate: '
         Write (6,'(1X,A,A,2(F10.6,A))') Label,
     &      ' : Bond Length=',aRR,' / Angstrom',RR,' / bohr'
         Write (6,*) '**********************************************'
         Write (6,*)
         Call Quit_OnUserError()
      EndIf
*
*---- Compute the WDC B-matrix.
*
      B(1,1)=-R(1)/RR
      B(2,1)=-R(2)/RR
      B(3,1)=-R(3)/RR
*
*---- Renormalize
*
      xRR=Sqrt(B(1,1)**2+B(2,1)**2+B(3,1)**2)
      B(1,1)=B(1,1)/xRR
      B(2,1)=B(2,1)/xRR
      B(3,1)=B(3,1)/xRR
*
*.... Utilize translational invariance.
      B(1,2)=-B(1,1)
      B(2,2)=-B(2,1)
      B(3,2)=-B(3,1)
*
*---- Compute the cartesian derivative of the B-matrix.
*
      If (ldB) Then
*
         Do i=1,3
            Do j=1,i
               If (i.eq.j) Then
                  dB(i,1,j,1)= (One-B(j,1)*B(i,1))/RR
               Else
                  dB(i,1,j,1)= (-B(j,1)*B(i,1))/RR
               End If
               dB(j,1,i,1)= dB(i,1,j,1)
*
               dB(i,2,j,1)=-dB(i,1,j,1)
               dB(j,1,i,2)= dB(i,2,j,1)
*
               dB(i,1,j,2)=-dB(i,1,j,1)
               dB(j,2,i,1)= dB(i,1,j,2)
*
               dB(i,2,j,2)=-dB(i,2,j,1)
               dB(j,2,i,2)=dB(i,2,j,2)
            End Do
         End Do
*
      End If
*     Call GetMem('Exit Strtch','Chec','Real',ipMass,2*msAtom)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_aux_qlm_builder

use fmm_global_paras, only: INTK, REALK, LUPRI, scheme_paras, raw_mm_data, USE_RAW_QLM, USE_T_SYM_QLM
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_get_aux_qlm

contains

!-------------------------------------------------------------------------------

subroutine fmm_get_aux_qlm(scheme,LHS_mms,RHS_mms)

  use fmm_qlm_utils, only: fmm_renormalise_qlm

  implicit none
  type(scheme_paras), intent(in)   :: scheme
  type(raw_mm_data), intent(inout) :: LHS_mms, RHS_mms

  ! We use the SCALED solid harmonic formulation throughout
  call fmm_renormalise_qlm(scheme%raw_LMAX,LHS_mms%qlm)
  call fmm_renormalise_qlm(scheme%raw_LMAX,RHS_mms%qlm)

  ! Identify batches of unique centre/extent and sort them in
  ! preparation for packing
  call sort_centres_and_assign_batches(scheme,LHS_mms,RHS_mms)

  ! Get parameter mappings and preconditioned W and T moments
  call get_RHS_data(scheme,RHS_mms)
  call get_LHS_data(scheme,LHS_mms)

  ! All relevant data should now be held in %qlm_T and %qlm_W
  deallocate(LHS_mms%qlm,RHS_mms%qlm)
  nullify(LHS_mms%qlm,RHS_mms%qlm)

end subroutine fmm_get_aux_qlm

!-------------------------------------------------------------------------------

subroutine sort_centres_and_assign_batches(scheme,LHS,RHS)

  use fmm_qlm_utils, only: fmm_sort_paras_wrt_centre, fmm_assign_batches

  implicit none
  type(scheme_paras), intent(in)   :: scheme
  type(raw_mm_data), intent(inout) :: LHS, RHS

  if (scheme%pack_LHS) then
    call fmm_sort_paras_wrt_centre(1_INTK,LHS%paras)
    call fmm_assign_batches(LHS%paras)
  end if
  if (scheme%pack_RHS) then
    call fmm_sort_paras_wrt_centre(1_INTK,RHS%paras)
    call fmm_assign_batches(RHS%paras)
  end if

end subroutine sort_centres_and_assign_batches

!-------------------------------------------------------------------------------

subroutine get_LHS_data(scheme,LHS)

  use fmm_qlm_utils, only: fmm_factor_in_dens, fmm_pack_raw_parameters

  implicit none
  type(scheme_paras), intent(in)   :: scheme
  type(raw_mm_data), intent(inout) :: LHS
  integer(INTK) :: i, ndim, qlm_dim, alloc_error

  ! Get LHS parameters from raw data
  if (scheme%pack_LHS) then
    call fmm_pack_raw_parameters(LHS)
  end if

  ! Sync (packed)parameters:(packed)moments mappings
  do i=1,size(LHS%paras)
    LHS%paras(i)%id = i
  end do

  ! LHS preconditioning for T-matrix
  select case (scheme%T_con%LHS_mm_type)
    case (USE_RAW_QLM)
      ! Note that dimensions of paras and qlm,2 may be different
      qlm_dim = size(LHS%qlm,2)
      ndim = size(LHS%qlm,1)
      write(LUPRI,*) 'LHS%qlm_T: Attempting to allocate',max(1,qlm_dim*ndim*8/1000000),'MB of memory...'
      allocate(LHS%qlm_T(ndim,qlm_dim),stat=alloc_error)
      if (alloc_error /= 0) write(LUPRI,*) '... Failed!'
      LHS%qlm_T(:,:) = LHS%qlm(:,:)
    case default
      call fmm_quit('cannot reconcile LHS_mm_type')
  end select

  ! Factorise in density if required
  if (scheme%LHS_dens) then
    call fmm_factor_in_dens(LHS%dens,LHS%qlm_T)
    deallocate(LHS%dens)
    nullify(LHS%dens)
  end if

end subroutine get_LHS_data

!-------------------------------------------------------------------------------

subroutine get_RHS_data(scheme,RHS)

  use fmm_qlm_utils, only: fmm_get_T_sym_qlm, &
                           fmm_pack_raw_moments, &
                           fmm_factor_in_dens

  implicit none
  type(scheme_paras), intent(in)   :: scheme
  type(raw_mm_data), intent(inout) :: RHS
  integer(INTK) :: LMAX, i, qlm_dim, ndim, alloc_error
  logical :: dens
  real(REALK) :: thr

  LMAX = scheme%raw_LMAX

  if (scheme%pack_RHS) then
    ! We now pack all moments belonging to
    ! the same batch (same centre,extent);
    ! Also factor in density and perform
    ! density-based screening if flagged
    dens = scheme%RHS_dens
    thr = scheme%dens_screen_thr
    call fmm_pack_raw_moments(RHS,dens,thr)
  end if

  ndim = (1+LMAX)**2
  qlm_dim = size(RHS%qlm,2)
  write(LUPRI,*) 'RHS%qlm_W: Attempting to allocate',max(1,qlm_dim*ndim*8/1000000),'MB of memory...'
  allocate(RHS%qlm_W(ndim,qlm_dim),staT=alloc_error)
  if (alloc_error /= 0) write(LUPRI,*) '... Failed!'
  RHS%qlm_W(:,:) = RHS%qlm(:,:)

  if (.not. scheme%pack_RHS) then
    if (scheme%RHS_dens) call fmm_factor_in_dens(RHS%dens,RHS%qlm_W)
  end if

  ! Density nolonger required
  if (scheme%RHS_dens) then
    deallocate(RHS%dens)
    nullify(RHS%dens)
  end if

  if (qlm_dim /= size(RHS%paras)) call fmm_quit('error in RHS data')
  ! Resync parameters:moments mappings
  do i=1,qlm_dim
    RHS%paras(i)%id = i
  end do

  ! RHS preconditioning for T-matrix
  select case (scheme%T_con%RHS_mm_type)
    case (USE_RAW_QLM)
      RHS%qlm_T => RHS%qlm_W(:,:)
    case (USE_T_SYM_QLM)
      allocate(RHS%qlm_T(ndim,qlm_dim))
      ! build %qlm_T by rescaling significant %qlm_W
      call fmm_get_T_sym_qlm(LMAX,RHS%qlm_W,RHS%qlm_T)
    case default
      call fmm_quit('cannot reconcile RHS_mm_type')
  end select

end subroutine get_RHS_data

!-------------------------------------------------------------------------------

end module fmm_aux_qlm_builder

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Per-Olof Widmark                            *
!***********************************************************************
!***********************************************************************
!                                                                      *
!                             A I X - I / O                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! rc=AixOpn(Handle,FileName)                                           *
!                                                                      *
! A file is opened for read/write operations. If the file does not     *
! exist it is automatically created.                                   *
!                                                                      *
! Input:  FileName - A character string specifying a complete path     *
!                    name or relative path name for the file. The      *
!                    name must be shorter than 128 characters.         *
!                                                                      *
! Output: Handle   - When a file is sucessfully opened, a unique file  *
!                    id is supplied by the routine. This is used for   *
!                    specifying the file to other routines.            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          S&TC, ACIS, IBM Sweden                                      *
! Written: November 1990                                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! History:                                                             *
! 911021 - If return code is 13 when opening file, try to open it as a *
!          read only file. Per-Olof Widmark.                           *
! 931217 - Flags obtained from system calls.                           *
! 010710 - Change using iRand to incremental number                    *
! 120304 - Use handle for the passing of 'Lu' value needed by FiM      *
!                                                                      *
!***********************************************************************

function AixOpn(handle,filename,translate)

use Fast_IO, only: CtlBlk, eBlNme, eTlFn, eTmF, FCtlBlk, MxFile, pDesc, pHndle, pStat, pWhere
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: AixOpn
integer(kind=iwp), intent(inout) :: handle
character(len=*), intent(in) :: filename
logical(kind=iwp), intent(in) :: translate
integer(kind=iwp) :: desc, ltmp, n, nFile, NVV = 666, rc
character(len=80) :: ErrTxt
character(len=256) :: tmp, tmp1
integer(kind=iwp), external :: AixErr, StrnLn
interface
  function c_open(Path) bind(C,name='c_open_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: c_open
    character(kind=c_char) :: Path(*)
  end function c_open
end interface

!----------------------------------------------------------------------*
! Entry to AixOpn                                                      *
!----------------------------------------------------------------------*
AixOpn = 0
!----------------------------------------------------------------------*
! Check if slot in table is available                                  *
!----------------------------------------------------------------------*
n = 1
do
  if (CtlBlk(pStat,n) == 0) exit
  n = n+1
  if (n > MxFile) then
    AixOpn = eTmF
    call SysWarnMsg('Aixopn','Too many opened files\n','try to increase MxFile')
    return
  end if
end do
nFile = n
!----------------------------------------------------------------------*
! Strip file name and append string terminator                         *
!----------------------------------------------------------------------*
n = len(filename)
do
  if (filename(n:n) /= ' ') exit
  n = n-1
  if (n <= 0) then
    AixOpn = eBlNme
    return
  end if
end do
n = n+1
if (n >= len(tmp)) then
  AixOpn = eTlFn
  return
end if
tmp = filename
tmp(n:n) = char(0)
!----------------------------------------------------------------------*
! Attempt to open file.                                                *
!----------------------------------------------------------------------*
rc = 0
tmp1 = tmp
ltmp = StrnLn(tmp1)
if (translate) then
  call PrgmTranslate(tmp1,tmp,ltmp)
end if
!write(u6,*) 'DEBUG AIXOPN: what would happen ',tmp(1:ltmp),'<'
tmp = tmp(1:ltmp)

!write(u6,*) 'in=',tmp1
!write(u6,*) 'len=',ltmp
!write(u6,*) 'res=',tmp
tmp(ltmp+1:ltmp+1) = char(0)
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
if (handle == 0) then
  rc = c_open(tmp)
else
  rc = c_FimOpen(tmp,handle)
  if (rc < 0) then
    rc = -rc
    AixOpn = eFiMFo
  end if
end if
if (handle == 0) then
#else
  rc = c_open(tmp)
#endif
  if (rc < 0) then
    rc = AixErr(ErrTxt)
    call SysWarnFileMsg('AixOpn',filename,'MSG: open',ErrTxt)
    call SysPutsEnd()
    call Abend()
  end if
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
end if
#endif
desc = rc
!----------------------------------------------------------------------*
! Attempt sucessful, update control blocks.                            *
!----------------------------------------------------------------------*
!handle = iRand()
NVV = NVV+100
handle = NVV
CtlBlk(pHndle,nFile) = handle
CtlBlk(pDesc,nFile) = desc
CtlBlk(pStat,nFile) = 1
CtlBlk(pWhere,nFile) = 0
FCtlBlk(nFile) = filename
!----------------------------------------------------------------------*
! Finished so return to caller                                         *
!----------------------------------------------------------------------*
return

end function AixOpn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine AOIntegrate(iCStart,nBaseQ,nBaseC,Ax,Ay,Az,nCnC_C
     &          ,iQ_Atoms,nAtomsCC,ipAOint,ipAOintpar,iV2,N,lmax
     &          ,Inside)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "integral.fh"
#include "WrkSpc.fh"
**Taked out by Valera #include "MolcasQmStat.fh"
#include "lenin.fh"

      Dimension V2(MxBasC,MxOrb_C)
      Dimension nCnC_C(MxBasC)
      Dimension Sint(MxBas,MxBasC),SintPar(MxBas,MxBasC),Rot(3,3)
      Dimension Inside(MxAt,3)
      Character Snack*30,BsLbl*(LENIN8*MxBasC)
      Logical PrEne,PrOcc,Inside
      Dimension Dummy(1)

*--------------------------------------------------------------------------*
* Call Transrot. There we compute the rotation matrix for the classical    *
* water under consideration. Used later.                                   *
*--------------------------------------------------------------------------*
      Call TransRot(Cordst,N+1,Rot,Dx,Dy,Dz,Ax,Ay,Az)
      If(iPrint.ge.17) then
        Write(6,*)
        Write(6,*)'ROTATION MATRIX, Molecule ',N/nCent
        Write(6,*)(Rot(1,k),k=1,3)
        Write(6,*)(Rot(2,k),k=1,3)
        Write(6,*)(Rot(3,k),k=1,3)
      Endif
*--------------------------------------------------------------------------*
* Call OrbRot2. Given the rotation matrix (Rot) and the original MO-       *
* coefficients, we transform them to new MO-coefficients. V2 is on input   *
* the original MO-coefficients (stored in V3), and on output the rotated.  *
*--------------------------------------------------------------------------*
      Do 5201, iOrS=1,iOrb(2) !Collect original MO-coeff.
        Do 5202, iBaS=1,nBaseC
          V2(iBaS,iOrS)=V3(iBaS,iOrS)
5202    Continue
5201  Continue
      Call OrbRot2(Rot,V2,iQn,iOrb(2),lMax,nCnC_C)
      kaunt=0
      Do 5211, iMO=1,iOrb(2) !Store the rotated in vector for
        Do 5212, iBa=1,nBaseC !later convinience.
          Work(iV2+kaunt)=V2(iBa,iMO)
          kaunt=kaunt+1
5212    Continue
5211  Continue
      If(iPrint.ge.25) then  !Optional print-out.
        PrOcc=.false.
        PrEne=.false.
        Write(snack,'(A,I3)')'Rotated orbitals for water ',N/ncent
        Call GetMem('PrCMO','Allo','Real',ipPPP,nBaseC*iOrb(2))
        kauntadetta=0
        Do 525, i=1,iOrb(2)
          Do 526, j=1,nBaseC
            Work(ipPPP+kauntadetta)=V2(j,i)
            kauntadetta=kauntadetta+1
526       Continue
525     Continue
        Call NameRun('WRUNFIL')
        Call Get_cArray('Unique Basis Names',BsLbl,LENIN8*nBaseC)
        Call Primo(Snack,PrOcc,PrEne,Dummy(1),Dummy(1),1,[nBaseC]
     &         ,iOrb(2),BsLbl,Dummy,Dummy,Work(ipPPP),3)
        Call GetMem('PrCMO','Free','Real',ipPPP,nBaseC*iOrb(2))
      Endif
      Do 531, m=1,lMax  !New basis function origo definied.
        x=0
        y=0
        z=0
        Do 541, j=1,3
          x=x+Rot(1,j)*SavOri(j,m)
          y=y+Rot(2,j)*SavOri(j,m)
          z=z+Rot(3,j)*SavOri(j,m)
541     Continue
        CasOri(1,m)=x+Dx
        CasOri(2,m)=y+Dy
        CasOri(3,m)=z+Dz
531   Continue
*----------------------------------------------------------------------*
* Compute overlap between the contracted basis functions on the water  *
* molecule presently studied and the QM-molecule.                      *
*----------------------------------------------------------------------*
      Do i=1,nBaseQ
        Do j=1,nBaseC
          Sint(i,j)=0
          SintPar(i,j)=0
        Enddo
      Enddo
      Call ContractOvl(Sint,SintPar,nBaseQ,nBaseC
     &    ,N,nCent,iEl,iQ_Atoms,nAtomsCC,iPrint,Inside)
      !To be able to use the fast matrix multiplication routine DGEMM_,
      !we have to put the Sint (and Sintpar) matrices in vector form.
      !In the future we might 'cut out the middle-man' and already
      !above put the overlap matrix in vector shape.
      kaunt=0
      Do 547, iC=1,nBaseC
        Do 548, iQ=1,nBaseQ
          Work(ipAOint+kaunt)=Sint(iQ,iC)
          kaunt=kaunt+1
548     Continue
547   Continue

      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(iCStart)
        Call Unused_integer(ipAOintpar)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fin_run_use()

use RunFile_data, only: i_run_CA_used, i_run_DA_used, i_run_DS_used, i_run_IA_used, i_run_IS_used, nTocCA, nTocDA, nTocDS, nTocIA, &
                        nTocIS
use Definitions, only: iwp

implicit none
logical(kind=iwp), external :: Reduce_Prt

if (Reduce_Prt()) return
!need_abend = 0
call check_use(nTocCA,i_run_CA_used,'cArray')
call check_use(nTocDA,i_run_DA_used,'dArray')
call check_use(nTocDS,i_run_DS_used,'dScalar')
call check_use(nTocIA,i_run_IA_used,'iArray')
call check_use(nTocIS,i_run_IS_used,'iScalar')
!if (need_abend == 1) call abend()

return

end subroutine fin_run_use

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SPNCOM(NOPEN,MS2,NDET,IABDET,IABUPP,IFLAG,PSSIGN)
! Combinations of nopen unpaired electrons. Required
! spin projection MS2/2.

use lucia_data, only: IPRCIX, MXPORB
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NOPEN, MS2, IFLAG
integer(kind=iwp), intent(_OUT_) :: NDET, IABDET(NOPEN,*), IABUPP(NOPEN,*)
real(kind=wp), intent(in) :: PSSIGN
integer(kind=iwp) :: ADD, I, IEL, IWORK(MXPORB), J, K, LUPPER, MS2L, MX, NALPHA, NUPPER
real(kind=wp) :: XMSD2

NDET = 0
NUPPER = 0

! Determinants are considered as binary numbers,1=alpha,0=beta

MX = 2**NOPEN
IWORK(1:NOPEN) = 0
! Loop over all possible binary numbers
do I=1,MX
  if (I > 1) then
    ! Next number
    ADD = 1
    J = 0
    do while (ADD == 1)
      J = J+1
      if (IWORK(J) == 1) then
        IWORK(J) = 0
      else
        IWORK(J) = 1
        ADD = 0
      end if
    end do
  end if

  ! 2 :  CORRECT SPIN PROJECTION ?
  NALPHA = sum(IWORK(1:NOPEN))

  if ((2*NALPHA-NOPEN == MS2) .and. ((PSSIGN == Zero) .or. (IWORK(1) /= 0))) then
    if (IFLAG < 3) then
      NDET = NDET+1
      IABDET(:,NDET) = IWORK(1:NOPEN)
    end if

    if (IFLAG > 1) then
      ! UPPER DET ?
      MS2L = 0
      LUPPER = 1

      do IEL=1,NOPEN
        if (IWORK(IEL) == 1) then
          MS2L = MS2L+1
        else
          MS2L = MS2L-1
        end if
        if (MS2L < 0) LUPPER = 0
      end do

      if (LUPPER == 1) then
        NUPPER = NUPPER+1
        IABUPP(:,NUPPER) = IWORK(1:NOPEN)
      end if
    end if
  end if

end do

XMSD2 = Half*real(MS2,kind=wp)

if (IPRCIX >= 5) then
  if (IFLAG /= 3) then
    write(u6,1010) NOPEN,NDET,XMSD2
    write(u6,*)
    write(u6,'(A)') '  Combinations :'
    write(u6,'(A)') '  =============='
    write(u6,*)
    do J=1,NDET
      write(u6,1020) J,(IABDET(K,J),K=1,NOPEN)
    end do
  end if

  if (IFLAG > 1) then
    write(u6,*)
    write(u6,'(A)') ' Upper determinants'
    write(u6,'(A)') ' =================='
    write(u6,*)
    do J=1,NUPPER
      write(u6,1020) J,(IABUPP(K,J),K=1,NOPEN)
    end do
  end if
end if

return

1010 format('0',2X,I3,' Unpaired electrons give ',I5,/,'           combinations with spin projection ',F12.7)
1020 format('0',I5,2X,30I2,/,(1X,7X,30I2))

end subroutine SPNCOM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               2008, Giovanni Ghigo                                   *
************************************************************************
      SubRoutine Def_CtoF(lNew,dMass,
     &                    nAtom,Name,Coor,jStab,nStab)
************************************************************************
*                                                                      *
*     Author: Giovanni Ghigo, Dep. of General and Organic Chemistry    *
*             University of Torino, ITALY                              *
*             July 2008                                                *
*     Adapted from  DefInt by                                          *
*             Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "Molcas.fh"
      Real*8    Coor(3,nAtom), dMass(nAtom)
      Character Labels*8, Type*6, Temp*120,
     &          Name(nAtom)*(LENIN), Line*120, Format*8, filnam*16
      Logical lWrite, lNew
      Integer nStab(nAtom), jStab(0:7,nAtom)
*
      lWrite = .True.
      Lu=6
      nTemp=Len(Temp)
      Write (Format,'(A,I3.3,A)') '(F',nTemp,'.0)'
*
      Lu_UDIC=91
      filnam='UDIC'
      call molcas_open(Lu_UDIC,filnam)
c      Open(Lu_UDIC,File=filnam,Form='Formatted',Status='OLD')
      Rewind(Lu_UDIC)
      Write (6,*)
      Write (6,*)
     &'****************************************************************'
      If (lNew) then
         Write (6,*)
     &'* New value of the internal coordinate to follow               *'
      else
         Write (6,*)
     &'* Original value of the internal coordinate to follow          *'
      EndIf
      Write (6,*)
     &'****************************************************************'
*
*     Step 1. BSet up the b vectors from which we will define the
*     internal coordinates.
*
c      iBVct = 0
      Read (Lu_UDIC,'(A)') Line
      Temp=Line
      Call UpCase(Temp)
*
*     Move the label of the internal coordinate
*
      neq = Index(Line,'=')
      If (neq.Eq.0) Then
         Call WarningMessage(2,'Error in Def_CTOF')
         Write (6,'(A)') '***********************************'
         Write (6,'(A)') ' Syntax error in line :            '
         Write (6,'(A)') Line(1:33),'...'
         Write (6,'(A)') '***********************************'
         Call Quit_OnUserError()
      Else
         iFrst = 1
         Call NxtWrd(Line,iFrst,iEnd)
         jEnd = iEnd
         If (Line(iEnd:iEnd).eq.'=') jEnd = jEnd - 1
         If (jEnd-iFrst+1.gt.8) Then
            Call WarningMessage(2,'Error in Def_CTOF')
            Write (6,'(A)') '***********************************'
            Write (6,'(A)') ' Syntax error in line :            '
            Write (6,'(A)') Line(1:33),'...'
            Write (6,'(A,A)') Line(iFrst:jEnd),
     &            ' has more than 8 character'
            Write (6,'(A)') '***********************************'
            Call Quit_OnUserError()
         End If
         Labels = Line(iFrst:jEnd)
      End If
*
*-----Construct the corresponding transformation vector
*
      mCntr = 0
      If (Index(Temp,'CART').Ne.0) Then
         nCntr=1
         nGo = Index(Temp,'CART')
         nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
         If (Index(Temp(nGo:nTemp),'X').Ne.0) Then
            nGo = nGo-1+Index(Temp(nGo:nTemp),'X')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type='X     '
         Else If (Index(Temp(nGo:nTemp),'Y').Ne.0) Then
            nGo = nGo-1+Index(Temp(nGo:nTemp),'Y')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type='Y     '
         Else If (Index(Temp(nGo:nTemp),'Z').Ne.0) Then
            nGo = nGo-1+Index(Temp(nGo:nTemp),'Z')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type='Z     '
         Else
            nGo=-1
            Call WarningMessage(2,'Error in Def_CTOF')
            Write (6,*) 'DefInt: wrong cartesian type'
            Write (6,'(A,A)') 'Temp=',Temp
            Call Quit_OnUserError()
         End If
      Else If (Index(Temp,'BOND').Ne.0) Then
         nCntr=2
         nGo = Index(Temp,'BOND')
         nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
         Type='STRTCH'
      Else If (Index(Temp,'LANGLE(2)').Ne.0) Then
         nCntr=3
         nGo = Index(Temp,'LANGLE(2)')
         nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
         Type ='LBEND2'
      Else If (Index(Temp,'LANGLE(1)').Ne.0) Then
         nCntr=3
         nGo = Index(Temp,'LANGLE(1)')
         nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
         Type ='LBEND1'
      Else If (Index(Temp,'ANGL').Ne.0) Then
         nCntr=3
         nGo = Index(Temp,'ANGL')
         nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
         Type ='BEND  '
      Else If (Index(Temp,'DIHE').Ne.0) Then
         nCntr=4
         nGo = Index(Temp,'DIHE')
         nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
         Type ='TRSN  '
      Else If (Index(Temp,'OUTO').Ne.0) Then
         nCntr=4
         nGo = Index(Temp,'OUTO')
         nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
         Type ='OUTOFP'
      Else If (Index(Temp,'DISS').Ne.0) Then
         i1 = Index(Line,'(')
         i2 = Index(Line,'+')
         i3 = Index(Line,')')
         If (i1.ge.i2 .or. i2.ge.i3) Then
            Call WarningMessage(2,'Error in Def_CTOF')
            Write (6,*)' Line contains syntax error!'
            Write (6,'(A)') Line
            Write (6,*) i1,i2,i3
            Call Quit_OnUserError()
         End If
         nGo = i3+1
         Temp = Line(i1+1:i2-1)
         Read (Temp,Format) Tmp
         nCntr=NInt(Tmp)
         Temp=Line(i2+1:i3-1)
         Read (Temp,Format) Tmp
         mCntr=NInt(Tmp)
         Type ='DISSOC'
      Else
         nGo=-1
         Call WarningMessage(2,'Error in Def_CTOF')
         Write (6,*)' Line contains syntax error!'
         Write (6,'(A)') Line
         Call Quit_OnUserError()
      End If
*
      msAtom = nCntr + mCntr
      Call GetMem('xyz ','Allo','Real',ipxyz ,3*msAtom)
      Call GetMem('Temp','Allo','Real',ipTemp,3*msAtom)
      Call GetMem('Ind ','Allo','Inte',ipInd ,2*msAtom)
      Call GetMem('Mass','Allo','Real',ipMass,2*msAtom)
*
      Call CllCtoF(Line(nGo:nTemp),Name,nAtom,Coor,nCntr,mCntr,
     &           Work(ipxyz),Work(ipTemp),iWork(ipInd),Type,
     &           dMass,Work(ipMass),
     &           Labels,jStab,nStab,nAtom)
*
      Call GetMem('Mass','Free','Real',ipMass,2*msAtom)
      Call GetMem('Ind ','Free','Inte',ipInd ,2*msAtom)
      Call GetMem('Temp','Free','Real',ipTemp,3*msAtom)
      Call GetMem('xyz ','Free','Real',ipxyz ,3*msAtom)
*
      Close(Lu_UDIC)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!               Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine Readinp_localisation()
! Author: Y. Carissan [heavily modified by T.B. Pedersen].

use Localisation_globals, only: AnaAtom, AnaDomain, Analysis, AnaNrm, AnaPAO, AnaPAO_Save, ChoStart, DoCNOs, DoDomain, EvalER, &
                                iWave, LocCanOrb, LocModel, LocNatOrb, LocPAO, LuSpool, Maximisation, MxConstr, nActa, NamAct, &
                                nBas, nConstr, nFro, NMxIter, nOccInp, nOrb, nOrb2Loc, nSym, nVirInp, Order, PrintMOs, Silent, &
                                Skip, Test_Localisation, ThrDomain, ThrGrad, ThrPairDomain, ThrRot, Thrs, ThrSel, Timing, Wave
use stdalloc, only: mma_allocate
use Constants, only: Ten
use Definitions, only: wp, iwp, u6

implicit none
#include "debug.fh"
!TBP Namelist /LOCALISATION/ dummy
integer(kind=iwp) :: i, iPL, istatus, iSym, j, LocOrb
character(len=180) :: Key, Line
logical(kind=iwp) :: Thrs_UsrDef, LocModel_UsrDef, nFro_UsrDef, nOrb2Loc_UsrDef, Freeze
integer(kind=iwp), parameter :: Occupied = 0, Virtual = 1, AllOrb = 2
real(kind=wp), parameter :: ThrsDef = 1.0e-6_wp, ThrRotDef = 1.0e-10_wp, ThrGradDef = 1.0e-2_wp
character(len=*), parameter :: SecNam = 'Readinp_localisation'
integer(kind=iwp), external :: iPrintLevel, isFreeUnit
character(len=180), external :: Get_Ln

LuSpool = 17
LuSpool = isFreeUnit(LuSpool)
call SpoolInp(LuSpool)

Debug = .false.
! Locate "start of input"
rewind(LuSpool)
call RdNLst(LuSpool,'LOCALISATION')

! Get print level

iPL = iPrintLevel(-1)

! Default Parameters

do iSym=1,nSym
  nOrb2Loc(iSym) = 0
  nFro(iSym) = 0
  nConstr(iSym) = 0
end do
Skip = .false.
LocOrb = Occupied
!LocVir = .false.
Thrs_UsrDef = .false.
nOrb2Loc_UsrDef = .false.
nFro_UsrDef = .false.
Freeze = .false.
if (iPL >= 4) then
  Debug = .true.
else
  Debug = .false.
end if
Maximisation = .true.
ChoStart = .false.
if (iPL < 3) then
  Silent = .true.
else
  Silent = .false.
end if
LocModel = 1  ! Pipek-Mezey localisation
if (nSym > 1) LocModel = 3  ! Cholesky localisation
LocModel_UsrDef = .false.
Test_Localisation = .false.
NMxIter = 300
Thrs = ThrsDef
ThrRot = ThrRotDef
ThrGrad = ThrGradDef
Analysis = .false.
AnaAtom = nSym == 1
AnaNrm = 'Fro'
PrintMOs = .true.
Timing = .true.
EvalER = .false.
Order = .false.
LocPAO = .false.
AnaPAO = .false.
AnaPAO_Save = AnaPAO
DoDomain = .false.
AnaDomain = .false.
ThrDomain(1) = 0.9_wp
ThrDomain(2) = 2.0e-2_wp
ThrPairDomain(1) = 1.0e-10_wp
ThrPairDomain(2) = Ten
ThrPairDomain(3) = 15.0_wp
LocNatOrb = .false.
LocCanOrb = .false.
Wave = .false.
iWave = 0
DoCNOs = .false.

! End Default Parameters

do
  Key = Get_Ln(LuSpool)
  Line = Key
  call UpCase(Line)
  select case (Line(1:4))
    case ('DEBU')
      ! DEBUg

      Debug = .true.

    case ('NORB')
      ! NORBitals

      Line = Get_Ln(LuSpool)
      call Get_I(1,nOrb2Loc,nSym)
      nOrb2Loc_UsrDef = .true.

    case ('NFRO')
      ! NFROzen

      Line = Get_Ln(LuSpool)
      call Get_I(1,nFro,nSym)
      nFro_UsrDef = .true.
      Freeze = .false.
      !if (LocVir) then
      if (LocOrb == Virtual) then
        write(u6,*)
        write(u6,*) 'WARNING!!!'
        write(u6,*) 'You have chosen to freeze some orbitals AND asked to localize the virtual space. This implies that'
        write(u6,*) ' some virtual orbitals will be kept frozen, thus they will be left unchanged. Is that OK ?'
        write(u6,*)
      end if

    case ('FREE')
      ! FREEze core orbitals (as defined by seward)

      if (.not. nFro_UsrDef) then
        call Get_iArray('Non valence orbitals',nFro,nSym)
        Freeze = .true.
        !if (LocVir) then
        if (LocOrb == Virtual) then
          write(u6,*)
          write(u6,*) 'WARNING!!!'
          write(u6,*) 'You have chosen to freeze some orbitals AND asked to localize the virtual space. This implies that'
          write(u6,*) ' some virtual orbitals will be kept frozen, thus they will be left unchanged. Is that OK ?'
          write(u6,*)
        end if
      end if

    case ('MAXI')
      ! MAXImisation

      Maximisation = .true.

    case ('MINI')
      ! MINImisation

      Maximisation = .false.

    case ('NITE','ITER')
      ! NITErations or ITERations

      Line = Get_Ln(LuSpool)
      call Get_I1(1,NMxIter)

    case ('THRE')
      ! THREshold

      Line = Get_Ln(LuSpool)
      call Get_F1(1,Thrs)
      Thrs_UsrDef = .true.

    case ('THRG')
      ! THRGrad

      Line = Get_Ln(LuSpool)
      call Get_F1(1,ThrGrad)

    case ('CHOS')
      ! CHOStart (use Cholesky orbitals as start guess for PM/Boys/ER)

      ChoStart = .true.

    case ('THRR')
      ! THRRotation

      Line = Get_Ln(LuSpool)
      call Get_F1(1,ThrRot)

    case ('PIPE','PM  ')
      ! PIPEk-Mezey or PM

      LocModel = 1
      LocModel_UsrDef = .true.

    case ('BOYS')
      ! BOYS

      LocModel = 2
      LocModel_UsrDef = .true.

    case ('CHOL')
      ! CHOLesky

      LocModel = 3
      LocModel_UsrDef = .true.

    case ('EDMI','ER  ')
      ! EDMIston-Ruedenberg or ER

      LocModel = 4
      LocModel_UsrDef = .true.

    case ('SILE')
      ! SILEnt mode

      Silent = .true.

    case ('TEST')
      ! TEST localisation (orthonormality, density, etc.)

      Test_Localisation = .true.

    case ('ANAL')
      ! ANALysis: generate bitmaps + histograms for density, original, and
      !           local MOs. Analysis "per atom" is default, but does not work
      !           with symmetry.

      Analysis = .true.
      AnaAtom = nSym == 1

    case ('ANAA')
      ! ANAAtom: generate bitmaps + histograms for density, original, and
      !          local MOs. Analysis "per atom".

      Analysis = .true.
      AnaAtom = .true.

    case ('ANAS')
      ! ANAShell: generate bitmaps + histograms for density, original, and
      !           local MOs. Analysis "per shell".

      Analysis = .true.
      AnaAtom = .false.

    case ('MAX ')
      ! MAX norm: use max element as norm in analysis.

      AnaNrm = 'Max'

    case ('FROB')
      ! FROBenius norm: use Frobenius norm in analysis.

      AnaNrm = 'Fro'

    case ('NOMO')
      ! NOMO: do not print MOs.

      PrintMOs = .false.

    case ('TIME')
      ! TIME: time the localisation procedure explicitly

      Timing = .true.

    case ('NOTI')
      ! NOTI: do not time the localisation procedure explicitly

      Timing = .false.

    case ('ERFU')
      ! ERFUnctional: evaluate Edmiston-Ruedenberg functional with original
      !               and localised orbitals.

      EvalER = .true.

    case ('ORDE')
      ! ORDEr: order localised orbitals according to Cholesky orbital
      !        ordering, defined according to the overlap between the two sets
      !        orbitals.

      Order = .true.

    case ('VIRT')
      ! VIRTual: localise virtual orbitals

      LocOrb = Virtual
      !LocVir = .true.
      if (nFro_UsrDef .or. Freeze) then
        write(u6,*)
        write(u6,*) 'WARNING!!!'
        write(u6,*) 'You have chosen to freeze some orbitals AND asked to localize the virtual space. This implies that'
        write(u6,*) ' some virtual orbitals will be kept frozen, thus they will be left unchanged. Is that OK ?'
        write(u6,*)
      end if

    case ('OCCU')
      ! OCCUpied: localise occupied orbitals

      LocOrb = Occupied
      !LocVir = .false.

    case ('ALL ')
      ! ALL: localise all orbitals

      LocOrb = AllOrb

    case ('PAO ')
      ! PAO : compute projected AOs that span the virtual space
      !       (= all - occupied - frozen) using Cholesky decomposition to
      !       remove linear dependence.

      LocPAO = .true.
      LocModel = 3
      LocModel_UsrDef = .true.

    case ('ANAP')
      ! ANAP: Special analysis for Cholesky PAOs before orthonormalization.

      AnaPAO = .true.

    case ('DOMA')
      ! DOMAin: set up orbital domains (Pulay-style) and pair domains

      DoDomain = .true.

    case ('THRD')
      ! THRDomain: thresholds for setting up orbital domains.
      !            First value is the minimum sum of gross atomic Mulliken
      !            charge for each orbital.
      !            Second value is the threshold used for the completeness
      !            check of Boughton and Pulay.

      DoDomain = .true.
      Line = Get_Ln(LuSpool)
      call Get_F(1,ThrDomain,2)

    case ('THRP')
      ! THRPairdomain: thresholds for setting up pair domains.
      !                3 values needed: Rs, Rw, Rd (in bohr).
      !                Let R be the minimum distance between any two atoms in
      !                a pair domain. Then,
      !                     R <= Rs: strong pair
      !                Rs < R <= Rw: weak pair
      !                Rw < R <= Rd: distant pair
      !                Rd < R <= Rd: very distant pair

      DoDomain = .true.
      Line = Get_Ln(LuSpool)
      call Get_F(1,ThrPairDomain,3)

    case ('ANAD')
      ! ANADomain: analysis of orbital domains

      AnaDomain = .true.
      DoDomain = .true.

    case ('SKIP')
      ! SKIP: skip localisation completely; i.e. only perform analysis etc.

      Skip = .true.

    case ('LOCN','LOCC')
      ! LOCN: localized natural orbitals
      ! LOCC: localized canonical orbitals

      if (Line(1:4) == 'LOCN') then
        LocNatOrb = .true.
      else if (Line(1:4) == 'LOCC') then
        LocCanOrb = .true.
      end if
      read(LuSpool,*) nActa,ThrSel
      ! Read atom names
      do
        read(LuSpool,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error()
        if ((Line(1:1) /= '*') .and. (Line /= ' ')) exit
      end do
      call UpCase(Line)
      call mma_allocate(NamAct,nActa,label='NamAct')
      do i=1,nActa
        if (Line == ' ') call Error()
        Line = adjustl(Line)
        j = index(Line,' ')
        NamAct(i) = Line(1:j-1)
        Line(1:j-1) = ' '
      end do

    case ('WAVE')
      ! WAVE: wavelet transform of the MO basis

      read(LuSpool,*) iWave
      if ((iWave /= 0) .and. (iWave /= 1)) then
        write(u6,*) ' WARNING!!!'
        write(u6,*) ' Incorrect bit-switch input parameter for WAVE.'
        write(u6,*) ' I will continue with the default value.'
        iWave = 0
      end if
      Skip = .false.
      Wave = .true.
      LocModel = 0

    case ('CONS')
      ! CONS: constrained natural orbital analysis

      Line = Get_Ln(LuSpool)
      call Get_I(1,nConstr,nSym)
      MxConstr = 0
      do i=1,nSym
        MxConstr = max(MxConstr,nConstr(i))
      end do
      if (MxConstr > 16) then
        write(u6,*) ' ERROR  !!!'
        write(u6,*) ' Cannot handle more than 16 constraints/symm !!'
        write(u6,*) ' Increase size of indxC in Get_CNOs and recompile.'
      end if
      DoCNOs = .true.
      Skip = .false.
      PrintMOs = .false.
      LocModel = 0

    case ('FILE')
      ! FILE: filename with input orbitals

      Line = Get_Ln(LuSpool)
      ! Filename is read in localisation.F90

    case ('END ')
      exit

    case default
      write(u6,*) 'Unidentified key word  : ',Key
      write(u6,*) 'Internal representation: ',Line(1:4)
      call FindErrorLine()
      call Quit_OnUserError()
  end select
end do

! END of Input

! ==============
! Postprocessing
! ==============

! Only Cholesky localisation can be run with symmetry.
! Reset if the user explicitly requested a localisation
! model different from Cholesky.
! ------------------------------------------------------------------

if ((nSym > 1) .and. LocModel_UsrDef .and. (LocModel /= 3)) then
  write(u6,*)
  write(u6,*) 'WARNING!!!'
  write(u6,*) 'The localisation model you have suggested in combination with symmetry will not work.'
  write(u6,*) 'In this case the program defaults to the Cholesky localisation scheme!'
  write(u6,*)
  LocModel = 3
end if

! Special settings for PAO: LocModel must be 3 (i.e. Cholesky), else
! we cancel PAO. For PAO, special analysis may be activated by the
! DEBUg keyword.
! ------------------------------------------------------------------

LocPAO = LocPAO .and. (LocModel == 3)
if (LocPAO) then
  AnaPAO = AnaPAO .or. Debug
else
  AnaPAO = .false.
end if

! Set orbitals to localize.
! If the user specified which orbitals to localise, frozen orbitals
! is not our problem (the user must set those as well or use the
! default).
! If the user did not specify which orbitals to localise, we have
! several cases (remembering that virtual localisation is default
! for the PAO method):
! For virtual localisation (specified with keyword VIRTual):
!    user-defined frozen orbitals are regarded as frozen virtual,
!    else we freeze all occupied and localise the rest. Note that
!    keyword FREEze is ignored for virtual localisation!
! For occupied localisation (default for all methods but PAO):
!    user-defined frozen orbitals (possibly by FREEze keyword)
!    are subtracted from the set of occupied orbitals, else we
!    localise all occupied.
! -----------------------------------------------------------------

if (nOrb2Loc_UsrDef) then
  LocOrb = Occupied
  !LocVir = .false.
else
  !if ((LocOrb == Virtual) .or. LocPAO) then
  !  LocOrb = Virtual
  !end if
  !LocVir = LocVir .or. LocPAO ! virtual is default for PAO
  if (LocOrb == Virtual) then ! virtual localisation
    !if (LocVir) then ! virtual localisation
    if (nFro_UsrDef) then
      do iSym=1,nSym
        nFro(iSym) = nOccInp(iSym)+nFro(iSym)
        nOrb2Loc(iSym) = nOrb(iSym)-nFro(iSym)
      end do
    else
      do iSym=1,nSym
        nFro(iSym) = nOccInp(iSym)
        nOrb2Loc(iSym) = nVirInp(iSym)
      end do
    end if
  !else ! occupied localisation
  else if (LocOrb == Occupied) then ! occupied localisation
    if (nFro_UsrDef .or. Freeze) then
      do iSym=1,nSym
        nOrb2Loc(iSym) = nOccInp(iSym)-nFro(iSym)
      end do
    else
      do iSym=1,nSym
        nOrb2Loc(iSym) = nOccInp(iSym)
      end do
    end if
  else ! AllOrb
    if (nFro_UsrDef .or. Freeze) then
      do iSym=1,nSym
        nOrb2Loc(iSym) = nOccInp(iSym)+nVirInp(iSym)-nFro(iSym)
      end do
    else
      do iSym=1,nSym
        nOrb2Loc(iSym) = nOccInp(iSym)+nVirInp(iSym)
      end do
    end if
  end if
end if

if (Debug) then
  write(u6,'(/,A,A)') SecNam,': orbital definitions:'
  write(u6,'(A,8I9)') 'nBas    : ',(nBas(iSym),iSym=1,nSym)
  write(u6,'(A,8I9)') 'nOrb    : ',(nOrb(iSym),iSym=1,nSym)
  write(u6,'(A,8I9)') 'nOccInp : ',(nOccInp(iSym),iSym=1,nSym)
  write(u6,'(A,8I9)') 'nVirInp : ',(nVirInp(iSym),iSym=1,nSym)
  write(u6,'(A,8I9)') 'nFro    : ',(nFro(iSym),iSym=1,nSym)
  write(u6,'(A,8I9,/)') 'nOrb2Loc: ',(nOrb2Loc(iSym),iSym=1,nSym)
end if

! If Cholesky, reset default threshold (unless user defined).
! -----------------------------------------------------------

if ((LocModel == 3) .and. (.not. Thrs_UsrDef)) then
  Thrs = 1.0e-8_wp
end if

! No need to order Cholesky MOs.
! ------------------------------

Order = Order .and. (LocModel /= 3)

! No need to evaluate ER function for Edmiston-Ruedenberg.
! --------------------------------------------------------

EvalER = EvalER .and. (LocModel /= 4)

! Turn on localisation test if debug or analysis was specified.
! -------------------------------------------------------------

Test_Localisation = Test_Localisation .or. Debug .or. Analysis

contains

subroutine Error()
  write(u6,*) ' READIN: Premature end of file when reading selected'
  write(u6,*) ' atoms in keyword LOCN'
  call Abend()
end subroutine Error

end subroutine Readinp_localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE SPSPCLS(ISPSPCLS,ICLS,NCLS)
*
* Obtain mapping a-supergroup X b-supergroup => class
*
* Classes are specified by ICLS
*
* Jeppe Olsen, Jan 97
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "cprnt.fh"
#include "stinf.fh"
#include "strinp.fh"
*. Specific input
      INTEGER ICLS(*)
*. OUtput
      INTEGER ISPSPCLS(*)
*
      IATP = 1
      IBTP = 2
*
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)

      CALL SPSPCLS_GAS(  NOCTPA,
     &                   NOCTPB,
     &                 ISPGPFTP(1,IOCTPA),
     &                 ISPGPFTP(1,IOCTPB),NELFGP,MXPNGAS,NGAS,ISPSPCLS,
     &                     ICLS,    NCLS,  IPRDIA)
*
*
      RETURN
      END
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Bingbing Suo                                     *
!***********************************************************************
!  16 apr 2007 - bsuo - revised to use molcas integrals

#ifdef MOLPRO

subroutine intrd()

use gugaci_global, only: lsmorb, LuTwoMO, map_orb_order, nlsm_all, nlsm_bas, ng_sm, noidx, voint, vpotnuc
use file_qininit, only: maxrecord
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, idx, lrcii, lrcij, lri, lrj, lrt, nc, ni, nidx, nintone, nism, nmob, nsmint
real(kind=wp) :: ecor
integer(kind=iwp), allocatable :: noffset(:)
real(kind=wp), allocatable :: xfock(:)

nintone = 0
nmob = 0
nidx = 0
ni = 0
do i=1,ng_sm
  nism = nlsm_all(i)
  nsmint = nism*(nism+1)/2
  nmob = nmob+nlsm_bas(i)*nlsm_bas(i)
  noidx(i) = nidx
  nidx = nidx+nism
  nintone = nintone+nsmint
  lsmorb(ni+1:nidx) = i
  ni = nidx
end do

call mma_allocate(noffset,maxrecord,label='noffset')
noffset(:) = 0
ni = 0
call idafile(Lutwomo,2,noffset,maxrecord,ni)
! 2nd record in file traint, nuclear repulsive energy
call ddafile(Lutwomo,2,vpotnuc,1,ni)
! 3rd record, ecore
call ddafile(Lutwomo,2,ecor,1,ni)  ! effective core energy
write(u6,'(a,1x,f14.8)') ' Nuclear repulsive energy:',vpotnuc
write(u6,'(a,1x,f14.8)') ' Frozen  core energy:     ',ecor
vpotnuc = vpotnuc+ecor
! 4th record, 1e int
call mma_allocate(xfock,nintone,label='xfock')
call ddafile(Lutwomo,2,xfock,nintone,ni) ! 1e integrals

! write one electron fock matrix into voint
nidx = 0
do i=1,ng_sm
  nism = nlsm_all(i)
  idx = noidx(i)
  nsmint = nism*(nism+1)/2
  nc = 0
  do lri=1,nism
    do lrj=1,lri
      nc = nc+1
      lrcii = map_orb_order(lri+idx)
      lrcij = map_orb_order(lrj+idx)
      if (lrcii > lrcij) then
        lrt = lrcij
        lrcij = lrcii
        lrcii = lrt
      end if
      voint(lrcii,lrcij) = xfock(nc+nidx)
      !write(u6,'(1x,i3,1x,i3,1x,f18.9)') lrcii,lrcij,xfock(nc+nidx)
    end do
  end do
  nidx = nidx+nsmint
end do
call readtwoeint_molpro(lutwomo,maxrecord,noffset,nlsm_all,ng_sm,Mul,map_orb_order,noidx)
call mma_deallocate(noffset)
call mma_deallocate(xfock)

!write(u6,*)
!write(u6,*) 'MRCI integrals'
!do lri=1,406
!  write(55,'(i8,f16.8)') lri,vector1(lri)
!end do

return

end subroutine intrd

subroutine readtwoeint_molpro(nft,maxrecord,noffset,norb,ngsm,multab,maporb,noidx)

use gugaci_global, only: max_orb, ntrabuf
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nft, maxrecord, noffset(maxrecord), norb(8), ngsm, multab(8,8), maporb(max_orb), noidx(8)
integer(kind=iwp) :: idisk, idx, iout, ityp, li, lj, lk, ll, lri, lrj, lrk, lrl, nbpq, nbrs, nintb, nop, noq, nor, nos, nsp, nspq, &
                     nspqr, nsq, nsr, nss, nssm, ntj, ntk, ntl
real(kind=wp) :: val
real(kind=wp), allocatable :: buff(:)

idisk = noffset(5)
write(u6,2000)
call mma_allocate(buff,ntrabuf,label='buff')
do nsp=1,ngsm
  nop = norb(nsp)
  do nsq=1,nsp
    noq = norb(nsq)
    nspq = multab(nsp,nsq)
    do nsr=1,nsp
      nor = norb(nsr)
      nspqr = multab(nspq,nsr)
      nssm = nsr
      if (nsr == nsp) nssm = nsq
      do nss=1,nssm
        if (nspqr /= nss) cycle
        nos = norb(nss)

        ityp = 0
        if (nsr == nss) then
          nbpq = (nop+nop**2)/2
          nbrs = (nos+nos**2)/2
          if (nsp == nsr) then
            ! (ii|ii) type 1 int
            nintb = (nbpq+nbpq**2)/2
            ityp = 1
          else
            ! (ii|jj) type 3 int
            nintb = nbpq*nbrs
            ityp = 3
          end if
        else
          nbpq = nop*noq
          nbrs = nor*nos
          if (nsp == nsr) then
            ! (ij|ij) type 2 int
            nintb = (nbpq+nbpq**2)/2
            ityp = 2
          else
            ! (ij|kl) type 4 int
            nintb = nbpq*nbrs
            ityp = 4
          end if
        end if

        if (nintb == 0) cycle
        write(u6,2100) nsp,nsq,nsr,nss,nop,noq,nor,nos,nintb

        idx = 0
        iout = 0
        !call ddatard(nft,buff,ntrabuf,idisk)
        if (nintb > ntrabuf) then
          call ddafile(nft,2,buff,ntrabuf,idisk)
        else
          call ddafile(nft,2,buff,nintb,idisk)
        end if

        do li=1,nos
          ntj = nor
          if ((ityp == 1) .or. (ityp == 3)) ntj = li
          do lj=1,ntj
            ntk = noq
            if ((ityp == 1) .or. (ityp == 2)) ntk = li
            do lk=1,ntk
              ntl = nop
              if ((ityp == 1) .or. (ityp == 3)) ntl = lk
              if ((ityp == 1) .and. (li == lk)) ntl = lj
              if ((ityp == 2) .and. (li == lk)) ntl = lj
              do ll=1,ntl
                iout = iout+1
                if (iout > ntrabuf) then
                  if (nintb-idx < ntrabuf) then
                    call ddafile(nft,2,buff,nintb-idx,idisk)
                  else
                    call ddafile(nft,2,buff,ntrabuf,idisk)
                  end if
                  iout = 1
                end if
                idx = idx+1
                val = buff(iout)
                lri = maporb(li+noidx(nss))
                lrj = maporb(lj+noidx(nsr))
                lrk = maporb(lk+noidx(nsq))
                lrl = maporb(ll+noidx(nsp))
                !if (ityp /= 2) cycle
                !write(u6,'(9(1x,i2),1x,f18.9)') li,lj,lk,ll,lri,lrj,lrk,lrl,iout,val
                call intrw_mol(lri,lrj,lrk,lrl,val)
              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do
call mma_deallocate(buff)

return

2000 format(/7x,'symmetry',6x,' orbitals',8x,'integrals')
2100 format(7x,4i2,1x,4i4,2x,3x,i9)

end subroutine readtwoeint_molpro

#else

subroutine intrd_molcas()

use gugaci_global, only: FnOneMO, FnTwoMO, lsmorb, LuOneMO, LuTwoMO, map_orb_order, ng_sm, nlsm_all, nlsm_bas, noidx, voint, vpotnuc
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, idisk, idx, lrcii, lrcij, lri, lrj, lrt, nc, ni, nidx, nintone, nism, nmob, nsmint
real(kind=wp) :: ecor
real(kind=wp), allocatable :: x(:), xfock(:)

nintone = 0
nmob = 0
nidx = 0
ni = 0
do i=1,ng_sm
  nism = nlsm_all(i)
  nsmint = nism*(nism+1)/2
  nmob = nmob+nlsm_bas(i)*nlsm_bas(i)
  noidx(i) = nidx
  nidx = nidx+nism
  nintone = nintone+nsmint
  lsmorb(ni+1:nidx) = i
  ni = nidx
end do
call mma_allocate(x,nmob,label='x')
call daname(luonemo,fnonemo)
call readtraonehead(luonemo,ecor,idisk)
vpotnuc = ecor

! read mo coeff, need debug, if frozen and delete orbitals are not zero
!call ddatard(nft,x,nmob,idisk)
call ddafile(luonemo,2,x,nmob,idisk)

! read one electron fock matrix
call mma_allocate(xfock,nintone,label='xfock')
call ddafile(luonemo,2,xfock,nintone,idisk)
!call ddatard(nft,xfock,nintone,idisk)
call daclos(luonemo)
! read one electron kinetic integrals
!call ddatard(nft,x1e,nintone,idisk)
!call cclose_molcas(nft)
! write one electron fock matrix into voint
nidx = 0
do i=1,ng_sm
  nism = nlsm_all(i)
  idx = noidx(i)
  nsmint = nism*(nism+1)/2
  nc = 0
  do lri=1,nism
    do lrj=1,lri
      nc = nc+1
      lrcii = map_orb_order(lri+idx)
      lrcij = map_orb_order(lrj+idx)
      if (lrcii > lrcij) then
        lrt = lrcij
        lrcij = lrcii
        lrcii = lrt
      end if
      voint(lrcii,lrcij) = xfock(nc+nidx)
      !write(u6,'(1x,i3,1x,i3,1x,f18.9)') lrcii,lrcij,xfock(nc+nidx)
    end do
  end do
  nidx = nidx+nsmint
end do
call mma_deallocate(xfock)

call daname(lutwomo,fntwomo)
call readtwoeint(lutwomo,nlsm_all,ng_sm,Mul,map_orb_order,noidx)
call daclos(lutwomo)
write(u6,*)
call mma_deallocate(x)

return

end subroutine intrd_molcas

subroutine readtwoeint(nft,norb,ngsm,multab,maporb,noidx)

use gugaci_global, only: lenintegral, max_orb, ntrabuf, ntratoc
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nft, norb(8), ngsm, multab(8,8), maporb(max_orb), noidx(8)
integer(kind=iwp) :: idisk, idx, iout, lenrd, li, lj, lk, ll, lri, lrj, lrk, lrl, nbpq, nbrs, nintb, nop, noq, nor, nos, nsp, &
                     nspq, nspqr, nsq, nsr, nss, nssm, ntj, ntk, numax, numin
real(kind=wp) :: val
integer(kind=iwp), allocatable :: itratoc(:)
real(kind=wp), allocatable :: buff(:)

idisk = 0
lenrd = ntratoc*lenintegral
write(u6,*) lenrd
call mma_allocate(itratoc,ntratoc,label='itratoc')
!call idatard(nft,itratoc,lenrd,idisk)
call idafile(nft,2,itratoc,ntratoc,idisk)
!write(u6,'(10(1x,i8))') itratoc(1:10)
call mma_deallocate(itratoc)
call mma_allocate(buff,ntrabuf,label='buff')
write(u6,2000)
do nsp=1,ngsm
  nop = norb(nsp)
  do nsq=1,nsp
    noq = norb(nsq)
    nspq = multab(nsp,nsq)
    do nsr=1,nsp
      nor = norb(nsr)
      nspqr = multab(nspq,nsr)
      nssm = nsr
      if (nsr == nsp) nssm = nsq
      do nss=1,nssm
        if (nspqr /= nss) cycle
        nos = norb(nss)

        if (nsr == nss) then
          nbpq = (nop+nop**2)/2
          nbrs = (nos+nos**2)/2
          if (nsp == nsr) then
            ! (ii|ii) type 1 int
            nintb = (nbpq+nbpq**2)/2
          else
            ! (ii|jj) type 3 int
            nintb = nbpq*nbrs
          end if
        else
          nbpq = nop*noq
          nbrs = nor*nos
          if (nsp == nsr) then
            ! (ij|ij) type 2 int
            nintb = (nbpq+nbpq**2)/2
          else
            ! (ij|kl) type 4 int
            nintb = nbpq*nbrs
          end if
        end if

        if (nintb == 0) cycle
        write(u6,2100) nsp,nsq,nsr,nss,nop,noq,nor,nos,nintb

        idx = 0
        iout = 0
        !call ddatard(nft,buff,ntrabuf,idisk)
        call ddafile(nft,2,buff,ntrabuf,idisk)

        do li=1,nor
          ntj = nos
          if (nsr == nss) ntj = li
          do lj=1,ntj
            ntk = 1
            if (nsp == nsr) ntk = li
            do lk=ntk,nop
              numin = 1
              if ((nsp == nsr) .and. (lk == li)) numin = lj
              numax = noq
              if (nsp == nsq) numax = lk
              do ll=numin,numax
                iout = iout+1
                if (iout > ntrabuf) then
                  !call ddatard(nft,buff,ntrabuf,idisk)
                  call ddafile(nft,2,buff,ntrabuf,idisk)
                  iout = 1
                end if
                idx = idx+1
                val = buff(iout)
                lri = maporb(lk+noidx(nsp))
                lrj = maporb(ll+noidx(nsq))
                lrk = maporb(li+noidx(nsr))
                lrl = maporb(lj+noidx(nss))
                !write(u6,'(9(1x,i2),1x,f18.9)') li,lj,lk,ll,lri,lrj,lrk,lrl,iout,val
                call intrw_mol(lri,lrj,lrk,lrl,val)
              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do
call mma_deallocate(buff)

return

2000 format(/7x,'symmetry',6x,' orbitals',8x,'integrals')
2100 format(7x,4i2,1x,4i4,2x,3x,i9)

end subroutine readtwoeint

subroutine readtraonehead(nft,ecor,idisk)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nft
real(kind=wp), intent(out) :: ecor
integer(kind=iwp), intent(out) :: idisk
integer(kind=iwp) :: idum(1), lenrd, nbas(8), ncone(64), ndel(8), nfro(8), norb(8)
real(kind=wp) :: dum(1)
character(len=LenIn8), allocatable :: bsbl(:)

idisk = 0
call idafile(nft,2,ncone,64,idisk)
call ddafile(nft,2,dum,1,idisk)
ecor = dum(1)
call idafile(nft,2,idum,1,idisk)
!nsym = idum(1)
call idafile(nft,2,nbas,8,idisk)
call idafile(nft,2,norb,8,idisk)
call idafile(nft,2,nfro,8,idisk)
call idafile(nft,2,ndel,8,idisk)
call mma_allocate(bsbl,maxbfn,label='bsbl')
lenrd = LenIn8*maxbfn
call cdafile(nft,2,bsbl,lenrd,idisk)
call mma_deallocate(bsbl)

!#ifdef debug
!write(u6,'(a4,1x,8(2x,i8))') 'ncon',ncone(1:8)
!write(u6,*) 'idisk : ', idisk
!write(u6,'(a4,1x,f18.9)') 'ecor',ecor
!write(u6,'(a4,1x,i8)') 'nsym',nsym
!write(u6,'(a4,1x,8(2x,i8))') 'nbas',nbas(1:8)
!write(u6,'(a4,1x,8(2x,i8))') 'norb',norb(1:8)
!write(u6,'(a4,1x,8(2x,i8))') 'nfro',nfro(1:8)
!write(u6,'(a4,1x,8(2x,i8))') 'ndel',ndel(1:8)
!#endif

return

end subroutine readtraonehead

#endif

!subroutine ddatard(nft,xbuff,lend,idisk)
!
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: nft, lend
!integer(kind=iwp), intent(inout) :: idisk
!real(kind=wp), intent(out) :: xbuff(lend)
!
!lenrd = lend*lendbl
!call idatard(nft,xbuff,lenrd,idisk)
!
!return
!
!end subroutine ddatard

!subroutine idatard(nft,ibuf,lbuf,idisk)
!! write by suo bing, read molcas file
!! imul = 0, the file readed is not a multifile
!! imul = 1, the file readed is a multifile
!
!use Definitions, only: iwp, u6
!
!implicit none
!integer(kind=iwp), intent(in) :: nft, lbuf
!integer(kind=iwp), intent(inout) :: idisk
!character, intent(out) :: ibuf(lbuf)
!integer(kind=iwp) :: imo, ioff, noff, nr
!integer(kind=iwp), parameter :: min_block_length = 512
!
!noff = idisk*min_block_length
!call clseek(nft,noff,nr)
!if (nr /= noff) then
!  write(u6,*) 'error seek file : ',idisk
!  call abend()
!end if
!call cread_molcas(nft,ibuf,lbuf,nr)
!if(nr /= lbuf) then
!  write(u6,*) 'error read file ',nr
!  write(u6,*) 'nft : ',nft
!  write(u6,*) 'lbuf  : ',lbuf
!  write(u6,*) 'idisk : ',idisk
!  call abend()
!else
!  imo = mod(lbuf,min_block_length)
!  if(imo == 0) then
!    ioff = lbuf/min_block_length
!  else
!    ioff = 1+lbuf/min_block_length
!  end if
!  idisk = idisk+ioff
!  !write(u6,*) 'ioff ',ioff
!end if
!
!return
!
!end subroutine idatard

subroutine intrw_mol(ik,jk,kk,lk,val)

use gugaci_global, only: vdint, vector1, voint

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ik, jk, kk, lk
real(kind=wp), intent(in) :: val
integer(kind=iwp) :: i, ind(4), j, k, l, list, lri, lrj, lrk, lrl, lrn, nt
integer(kind=iwp), external :: list3_all, list4_all

list = 0
i = ik
j = jk
k = kk
l = lk
lri = min(i,j)
lrj = max(i,j)
lrk = min(k,l)
lrl = max(k,l)
if (lri > lrk) then
  lrn = lrk
  lrk = lri
  lri = lrn
  lrn = lrl
  lrl = lrj
  lrj = lrn
end if

ind(1) = lri
ind(2) = lrj
ind(3) = lrk
ind(4) = lrl
do i=1,4
  do j=i+1,4
    if (ind(i) > ind(j)) then
      nt = ind(i)
      ind(i) = ind(j)
      ind(j) = nt
    end if
  end do
end do

!write(u6,*) ind(1),ind(2),ind(3),ind(4)

if (ind(1) == ind(4)) then   !(iiii)
  vdint(lri,lri) = val

else if ((lri == lrj) .and. (lrk == lrl)) then   !(iikk)
  vdint(lrk,lri) = val

else if ((lri == lrk) .and. (lrj == lrl)) then   !(ijij)
  !if ((lri == 1) .and. (lrj == 2)) call abend()
  voint(lrj,lri) = val

else if ((lri /= lrl) .and. (lrj == lrk)) then !(ijjl)
  list = list3_all(lri,lrl,lrj)
  vector1(list) = val
  if (lrj == lrl) then
    vector1(list+1) = val
  end if
  if (lri == lrj) then
    vector1(list+1) = val
  end if

else if ((lri /= lrj) .and. (lrk == lrl)) then  !(ijkk)
  list = list3_all(lri,lrj,lrk)
  vector1(list+1) = val
  if (lrj == lrk) then
    vector1(list) = val
  end if

else if ((lri == lrj) .and. (lrk /= lrl)) then  !(iikl)
  list = list3_all(lrk,lrl,lri)
  vector1(list+1) = val

else if ((lri == lrk) .and. (lrj /= lrl)) then      !(ijil)
  if (lrj < lrl) then
    list = list3_all(lrj,lrl,lri)
  else
    list = list3_all(lrl,lrj,lri)
  end if
  vector1(list) = val

else if ((lri /= lrk) .and. (lrj == lrl)) then   !(ijkj)
  list = list3_all(lri,lrk,lrj)
  vector1(list) = val
  if (lrj == lrk) then
    vector1(list+1) = val
  end if

else if ((lri /= lrj) .and. (lri /= lrk) .and. (lri /= lrl) .and. (lrj /= lrk) .and. (lrj /= lrl) .and. (lrk /= lrl)) then
  list = list4_all(ind(1),ind(2),ind(3),ind(4))       !(ijkl)
  if ((lrj > lrk) .and. (lrj > lrl)) then
    vector1(list+2) = val
  end if
  if ((lrj > lrk) .and. (lrj < lrl)) then
    vector1(list) = val
  end if
  if ((lrj < lrk) .and. (lrj < lrl)) then
    vector1(list+1) = val
  end if

end if

!write(u6,*) 'list=',list

return

end subroutine intrw_mol

subroutine int_index(numb)

use gugaci_global, only: loij_all, loijk_all, lsm, ncibl_all, ngw2, ngw3, norb_all, norb_number
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: numb
integer(kind=iwp) :: i, j, la, lb, lc, ld, lra, lrb, lrc, lrd, lri, lrj, ms, msa, msb, msc, mscd, msd, msob(8), nij, njkl

msob = 0
do la=norb_all,1,-1
  lra = norb_all-la+1
  ms = lsm(lra)
  msob(ms) = msob(ms)+1
  ncibl_all(la) = msob(ms)
end do

!write(u6,*)
!=======================================================================
!write(u6,'(1x,14i3)') (ncibl(i),i=1,14)

numb = 1
do i=1,norb_all-1
  do j=i+1,norb_all
    lri = norb_number(i)
    lrj = norb_number(j)
    if (lsm(lri) /= lsm(lrj)) cycle
    !write(u6,*) 'lri=',lri,'lrj=',lrj
    !write(u6,*) 'lsm(lri)',lsm(lri),'lsm(lrj)',lsm(lrj)

    nij = i+ngw2(j)
    !write(u6,*) 'i,j,mij,nij   ',i,j,mij,nij
    loij_all(nij) = numb
    !do k=1,norb_all
    !  vint_ci(numb) = vfutei(j,k,i,k)
    !  vint_ci(numb+1) = vfutei(j,i,k,k)
    !  write(10,'(2x,4i6,i8,3f16.8)') i,j,k,k, numb,vint_ci(numb),vint_ci(numb+1)
    numb = numb+2*norb_all
    !end do

  end do
end do
!write(u6,*) 'number 3 index',numb
!call abend()
!=======================================================================
! la<lb<lc<ld
do ld=1,norb_all-3
  do lc=ld+1,norb_all-2
    lrd = norb_all-ld+1
    lrc = norb_all-lc+1
    msd = lsm(lrd)
    msc = lsm(lrc)
    mscd = Mul(msd,msc)
    do lb=lc+1,norb_all-1
      lrb = norb_all-lb+1
      msb = lsm(lrb)
      msa = Mul(mscd,msb)

      njkl = ld+ngw2(lc)+ngw3(lb)
      loijk_all(njkl) = numb

      !nolra = 0
      do la=norb_all,lb+1,-1
        lra = norb_all-la+1
        if (lsm(lra) /= msa) cycle
        !nolra = nolra+1
        !list = loijk_all(njkl)+3*(nolra-1)
        !write(u6,*) 'ld,lc,lb,la',ld,lc,lb,la,list

        !write(u6,'(2x,4i3,2i7)') la,lb,lc,ld,list,numb

        !vint_ci(numb) = vfutei(la,lc,lb,ld)        !tmp stop
        !vint_ci(numb+1) = vfutei(la,lb,lc,ld)
        !vint_ci(numb+2) = vfutei(la,ld,lc,lb)
        !write(10,'(2x,4i6,i8,3f16.8)') la,lb,lc,ld, numb,vint_ci(numb),vint_ci(numb+1),vint_ci(numb+2)
        numb = numb+3
      end do
    end do
  end do
end do
!call abend()

return

end subroutine int_index

function vfutei(ix,jx,kx,lx)

use gugaci_global, only: vector1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: vfutei
integer(kind=iwp), intent(in) :: ix, jx, kx, lx
integer(kind=iwp) :: i, ind(4), j, list, lri, lrj, lrk, lrl, lrn, nt
real(kind=wp) :: val
integer(kind=iwp), external :: list3_all, list4_all

lri = min(ix,jx)
lrj = max(ix,jx)
lrk = min(kx,lx)
lrl = max(kx,lx)
if (lri > lrk) then
  lrn = lrk
  lrk = lri
  lri = lrn
  lrn = lrl
  lrl = lrj
  lrj = lrn
end if
val = Zero
!write(u6,*) ind(1),ind(2),ind(3),ind(4)
if ((lri /= lrl) .and. (lrj == lrk)) then !(ijjl)
  list = list3_all(lri,lrl,lrj)
  val = vector1(list)

else if ((lri /= lrj) .and. (lrk == lrl)) then  !(ijkk)
  list = list3_all(lri,lrj,lrk)
  val = vector1(list+1)

else if ((lri == lrj) .and. (lrk /= lrl)) then  !(iikl)
  list = list3_all(lrk,lrl,lri)
  val = vector1(list+1)

else if ((lri == lrk) .and. (lrj /= lrl)) then  !(ijil)
  if (lrj < lrl) then
    list = list3_all(lrj,lrl,lri)
  else
    list = list3_all(lrl,lrj,lri)
  end if
  val = vector1(list)

else if ((lri /= lrk) .and. (lrj == lrl)) then  !(ijkj)
  list = list3_all(lri,lrk,lrj)
  val = vector1(list)

else if ((lri /= lrj) .and. (lri /= lrk) .and. (lri /= lrl) .and. (lrj /= lrk) .and. (lrj /= lrl) .and. (lrk /= lrl)) then
  ind(1) = lri
  ind(2) = lrj
  ind(3) = lrk
  ind(4) = lrl
  do i=1,4
    do j=i+1,4
      if (ind(i) > ind(j)) then
        nt = ind(i)
        ind(i) = ind(j)
        ind(j) = nt
      end if
    end do
  end do

  list = list4_all(ind(1),ind(2),ind(3),ind(4))  !(ijkl)
  if ((lrj > lrk) .and. (lrj > lrl)) then
    val = vector1(list+2)
  end if
  if ((lrj > lrk) .and. (lrj < lrl)) then
    val = vector1(list)
  end if
  if ((lrj < lrk) .and. (lrj < lrl)) then
    val = vector1(list+1)
  end if
end if

vfutei = val

end function vfutei

function list3_all(i,j,k)

use gugaci_global, only: loij_all, ngw2
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: list3_all
integer(kind=iwp), intent(in) :: i, j, k
integer(kind=iwp) :: nij

nij = i+ngw2(j)
list3_all = loij_all(nij)+2*(k-1)

return

end function list3_all

function list4_all(ld,lc,lb,la)

use gugaci_global, only: loijk_all, ncibl_all, ngw2, ngw3
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: list4_all
integer(kind=iwp), intent(in) :: ld, lc, lb, la
integer(kind=iwp) :: lra, njkl

!write(u6,*) 'ld,lc,lb,la',ld,lc,lb,la
lra = ncibl_all(la)
njkl = ld+ngw2(lc)+ngw3(lb)
list4_all = loijk_all(njkl)+3*(lra-1)

return

end function list4_all

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine TestLoc(irc)
C
C     Author: T.B. Pedersen
C
C     Purpose: test localisation:
C
C              1) CC^T = XX^T ?
C              2) U=C^TSX , UU^T = diag ?
C              3) If C^TSC=1, X^TSX=1 ?
C
C              where C are the original MOs and X the localised ones.
C
C              Return codes: irc=0 (all OK), irc=1 (failure).
C
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "inflocal.fh"
#include "debug.fh"
#include "WrkSpc.fh"

      Character*7 SecNam
      Parameter (SecNam = 'TestLoc')

      Character*8  Label
      Character*80 Txt

      Logical Prnt

      external ddot_
      External iPrintLevel

C     Set return code.
C     ----------------

      irc = 0

C     Set tolerance; allow more deviation for PAOs.
C     ---------------------------------------------

      If (LocPAO) Then
         Tol = 1.0d-4
      Else
         Tol = 1.0d-6
      End If

C     Get the AO overlap matrix.
C     --------------------------

      lOvlp = nBas(1)**2
      lOaux = 4 + nBas(1)*(nBas(1)+1)/2
      Do iSym = 2,nSym
         lOvlp = lOvlp + nBas(iSym)**2
         lOaux = lOaux + nBas(iSym)*(nBas(iSym)+1)/2
      End Do
      Call GetMem('TstOvlp','Allo','Real',ipOvlp,lOvlp)
      Call GetMem('TstOaux','Allo','Real',ipOaux,lOaux)
      jrc = -1
      iOpt = 2
      iComp = 1
      iSyLbl = 1
      Label = 'Mltpl  0'
      Call RdOne(jrc,iOpt,Label,iComp,Work(ipOaux),iSyLbl)
      If (jrc .ne. 0) Then
         Write(Txt,'(A,I4)') 'RdOne returned',jrc
         Call SysAbendMsg(SecNam,'I/O error!',Txt)
      End If
      Prnt=Debug.and.iPrintLevel(-1).ge.5
      kTri = ipOaux
      kSqr = ipOvlp
      Do iSym = 1,nSym
         Call Tri2Rec(Work(kTri),Work(kSqr),nBas(iSym),Prnt)
         kTri = kTri + nBas(iSym)*(nBas(iSym)+1)/2
         kSqr = kSqr + nBas(iSym)**2
      End Do
      Call GetMem('TstOaux','Free','Real',ipOaux,lOaux)

C     Memory allocation.
C     ------------------

      lUmat = nOrb2Loc(1)**2
      lScr  = nBas(1)*nOrb2Loc(1)
      Do iSym = 2,nSym
         lUmat = lUmat + nOrb2Loc(iSym)**2
         lScr  = max(lScr,nBas(iSym)*nOrb2Loc(iSym))
      End Do
      lDen = lOvlp
      Call GetMem('DenC','Allo','Real',ipDenC,lDen)
      Call GetMem('DenX','Allo','Real',ipDenX,lDen)
      Call GetMem('Ddff','Allo','Real',ipDdff,lDen)
      Call GetMem('Scratch','Allo','Real',ipScr,lScr)
      Call GetMem('Umat','Allo','Real',ipUmat,lUmat)

C     Test 1) density.
C     ----------------

      nErr = 0

      kDC = ipDenC
      kDX = ipDenX
      kDd = ipDdff
      kC  = ipMOrig
      kX  = ipCMO
      Do iSym = 1,nSym
         kC1 = kC + nBas(iSym)*nFro(iSym)
         Call GetDens_Localisation(Work(kDC),Work(kC1),
     &                             nBas(iSym),nOrb2Loc(iSym))
         kX1 = kX + nBas(iSym)*nFro(iSym)
         Call GetDens_Localisation(Work(kDX),Work(kX1),
     &                             nBas(iSym),nOrb2Loc(iSym))
         nB2 = nBas(iSym)**2
         Call dCopy_(nB2,Work(kDC),1,Work(kDd),1)
         Call dAXPY_(nB2,-1.0d0,Work(kDX),1,Work(kDd),1)
         xNrm = sqrt(dDot_(nB2,Work(kDd),1,Work(kDd),1))
         If (xNrm .gt. Tol) Then
            Write(6,'(A,A,D16.8,A,I2,A)')
     &      SecNam,': ERROR: ||CC^T - XX^T|| = ',xNrm,' (sym.',
     &      iSym,')'
            nErr = nErr + 1
         End If
         kDC = kDC + nB2
         kDX = kDX + nB2
         kDd = kDd + nB2
         kC  = kC  + nB2
         kX  = kX  + nB2
      End Do
      If (nErr .ne. 0) Then
         irc = 1
         Go To 1 ! exit, after de-allocations
      End If

C     Test 2) U^TU = diag.
C     --------------------

      nErr = 0

      kU = ipUmat
      kO = ipOvlp
      kC = ipMOrig
      kX = ipCMO
      Do iSym = 1,nSym
         kC1 = kC + nBas(iSym)*nFro(iSym)
         kX1 = kX + nBas(iSym)*nFro(iSym)
         Call GetUmat_Localisation(Work(kU),Work(kC1),Work(kO),
     &                             Work(kX1),Work(ipScr),lScr,
     &                             nBas(iSym),nOrb2Loc(iSym))
         nTO = max(nOrb2Loc(iSym),1)
         Call DGEMM_('T','N',
     &              nOrb2Loc(iSym),nOrb2Loc(iSym),nOrb2Loc(iSym),
     &              1.0d0,Work(kU),nTO,Work(kU),nTO,
     &              0.0d0,Work(ipScr),nTO)
         xErr = -9.9d9
         ip0  = ipScr - 1
         Do j = 1,nOrb2Loc(iSym)
            kOff = ip0 + nOrb2Loc(iSym)*(j-1)
            Do i = j+1,nOrb2Loc(iSym)
               Tst  = abs(Work(kOff+i))
               xErr = max(xErr,Tst)
            End Do
         End Do
         If (xErr .gt. Tol) Then
            Write(6,'(A,A,D16.8,A,I2,A)')
     &      SecNam,': ERROR: max. U^TU off-diag. = ',xErr,' (sym.',
     &      iSym,')'
            nErr = nErr + 1
         End If
         nB2 = nBas(iSym)**2
         kU  = kU + nOrb2Loc(iSym)**2
         kO  = kO + nB2
         kC  = kC + nB2
         kX  = kX + nB2
      End Do
      If (nErr .ne. 0) Then
         irc = 1
         Go To 1 ! exit, after de-allocations
      End If

C     Test 3) X^TSX=1.
C     ----------------

      nErr = 0

      kU = ipUmat
      kO = ipOvlp
      kC = ipMOrig
      kX = ipCMO
      Do iSym = 1,nSym
         kC1 = kC + nBas(iSym)*nFro(iSym)
         Call GetUmat_Localisation(Work(kU),Work(kC1),Work(kO),
     &                             Work(kC1),Work(ipScr),lScr,
     &                             nBas(iSym),nOrb2Loc(iSym))
         mErr = 0
         xErr = -9.9d9
         ip0  = kU - 1
         Do j = 1,nOrb2Loc(iSym)
            kOff = ip0 + nOrb2Loc(iSym)*(j-1)
            Tst  = abs(Work(kOff+j)-1.0d0)
            If (Tst .gt. Tol) Then
               mErr = mErr + 1
            End If
            Do i = j+1,nOrb2Loc(iSym)
               Tst  = abs(Work(kOff+i))
               xErr = max(xErr,Tst)
            End Do
         End Do
         If (xErr .gt. Tol) Then
            mErr = mErr + 1
         End If
         If (mErr .eq. 0) Then
            kX1 = kX + nBas(iSym)*nFro(iSym)
            Call GetUmat_Localisation(Work(kU),Work(kX1),Work(kO),
     &                                Work(kX1),Work(ipScr),lScr,
     &                                nBas(iSym),nOrb2Loc(iSym))
            xErr = -9.9d9
            ip0  = kU - 1
            Do j = 1,nOrb2Loc(iSym)
               kOff = ip0 + nOrb2Loc(iSym)*(j-1)
               Tst  = abs(Work(kOff+j)-1.0d0)
               If (Tst .gt. Tol) Then
                  mErr = mErr + 1
               End If
               Do i = j+1,nOrb2Loc(iSym)
                  Tst  = abs(Work(kOff+i))
                  xErr = max(xErr,Tst)
               End Do
            End Do
            If (xErr .gt. Tol) Then
               Write(6,'(A,A,D16.8,A,I2,A)')
     &         SecNam,': ERROR: max. X^TSX off-diag. = ',xErr,' (sym.',
     &         iSym,')'
               mErr = mErr + 1
            End If
            If (mErr .ne. 0) nErr = nErr + 1
         Else
            Write(6,*) SecNam,': original orbitals not orthonormal!'
            Write(6,*) 'Orthonormality test is skipped (sym. ',iSym,')'
         End If
         nB2 = nBas(iSym)**2
         kU  = kU + nOrb2Loc(iSym)**2
         kO  = kO + nB2
         kC  = kC + nB2
         kX  = kX + nB2
      End Do
      If (nErr .ne. 0) Then
         irc = 1
         Go To 1 ! exit, after de-allocations
      End If

C     De-allocations and return.
C     --------------------------

    1 Continue
      Call GetMem('Umat','Free','Real',ipUmat,lUmat)
      Call GetMem('Scratch','Free','Real',ipScr,lScr)
      Call GetMem('Ddff','Free','Real',ipDdff,lDen)
      Call GetMem('DenX','Free','Real',ipDenX,lDen)
      Call GetMem('DenC','Free','Real',ipDenC,lDen)
      Call GetMem('TstOvlp','Free','Real',ipOvlp,lOvlp)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE OEISG(REL,SREL,TREL,UREL,ZETA,
     &                 ZN, MX100, NSYM, NBAS1,
     &                 unrel, tnrel, hcorr, iprint,
     &                  VEXTT,PVPT,EVN1,EVN2,RE1R,AUXI,W1W1,W1E0W1)

      IMPLICIT REAL*8 (A-H,O-Z)
C
      dimension REL(nBAS1*(nBAS1+1)/2),SREL(nBAS1*(nBAS1+1)/2),
     &          TREL(nBAS1*(nBAS1+1)/2),UREL(nBAS1*(nBAS1+1)/2),
     &          ZETA(nBAS1),
     &          unrel(nBAS1*(nBAS1+1)/2), tnrel(nBAS1*(nBAS1+1)/2),
     &          hcorr(nBAS1*(nBAS1+1)/2)
C
      dimension facto(16)
#include "relmp.fh"
      Real*8 VEXTT(*),PVPT(*),
     &       EVN1(NBAS1,NBAS1),EVN2(NBAS1,NBAS1),
     &       RE1R(NBAS1,NBAS1),
     &       AUXI(NBAS1,NBAS1),
     &       W1W1(NBAS1,NBAS1),W1E0W1(NBAS1,NBAS1)
C
C     ONE CONFIGURATION
C     ONE ELECTRON INTEGRAL PROGRAM
C     COMPUTES THE MATRICES S,U,T WITH SLATER (NFLAG1=0) OR GAUSSIAN
C      (NFLAG1=1) ORBITALS AS  BASIS
C
C
C
      CALL OEISG_INTERNAL(REL)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE OEISG_INTERNAL(REL)
      USE ISO_C_BINDING
      REAL*8, TARGET :: REL(*)
      INTEGER, POINTER :: iREL(:)
c     initialize
      CALL RELOP
c     coefficients
      FACTO(1)=1.D0
      FACTO(2)=1.D0
      DO 1301 I=3,16
      IM1=I-1
      FACTO(I)=IM1*FACTO(I-2)
 1301 CONTINUE
      iparm=2
*     WRITE (6,*) ' MX100=',MX100
*     write(6,*) ' nsym',nsym
      if(iprint.ge.10) then
         write(6,*) ' symmetry', nsym
         write(6,*) ' number of basis functions', nbas1
         write(6,*) ' charge', zn
         do i=1,nbas1
            write(6,*) zeta(i)
         enddo
      endif
      L=NSYM
C
      IJ=0
      np=L
      NQ=NP
      DO 10 I=1,NBAS1
      ZP=ZETA(I)
      WP=2.D0*(NP-L)/ZP
      DO 11 J=1,I
      IJ=IJ+1
      ZQ=ZETA(J)
      ZPQ=0.5D0*(ZP+ZQ)
      NPQ=NP+NQ+1
      WQ=2.D0*(NQ-L)/ZQ
      NPQ1=NPQ-1
      NPQ2=NPQ-2
      VPQ=FACTO(NPQ1)/ZPQ**(0.5D0*NPQ)
      VP=FACTO(2*NP)/ZP**(NP+0.5D0)
      VQ=FACTO(2*NQ)/ZQ**(NQ+0.5D0)
      IF (NPQ1.GT.2) GO TO 3
      VPQM2=1.D0
      GO TO 4
    3 VPQM2=FACTO(NPQ2-1)/ZPQ**(0.5D0*NPQ2)
    4 VPQ1=FACTO(NPQ2)*1.595769121605731D0/ZPQ**(0.5D0*NPQ1)
      VPQP2=FACTO(NPQ+1)/ZPQ**(0.5D0*(NPQ+2))
      TERM2=VPQP2-VPQ*(WP+WQ)+WP*WQ*VPQM2
      TERM1=1.D0/SQRT(VP*VQ)
      SREL(IJ)=TERM1*VPQ
      UREL(IJ)=TERM1*VPQ1
      UNREL(IJ)=TERM1*VPQ1
      TNREL(IJ)=0.5D0*ZP*ZQ*TERM1*TERM2
C.    TNRE=0.5D0*ZP*ZQ*TERM1*TERM2
      IF (IPARM.GT.0)   THEN
         I1=np-1
         I2=0
         I3=0
         J1=nq-1
         J2=0
         J3=0
C*
C*     PVP FOR XY-FUNCTIONS
C*
         if (np.eq.3) then
            REL(IJ)=EXTC(L,ZP,ZQ,1,1,0,1,1,0)
            GOTO 900
         endif
C*
C*     PVP FOR XYZ-FUNCTIONS
C*
         if (np.eq.4) then
            REL(IJ)=EXTC(L,ZP,ZQ,1,1,1,1,1,1)
            GOTO 900
         endif
C*
C*     PVP FOR X**(NP-1)-FUNCTIONS
C*
         REL(IJ)=EXTC(L,ZP,ZQ,I1,I2,I3,J1,J2,J3)
C.       TREL(IJ)=SQROPY(ZP,ZQ,I1,I2,I3,J1,J2,J3)
900      TREL(IJ)=0.5D0*ZP*ZQ*TERM1*TERM2
      ELSE
         TREL(IJ)=0.5D0*ZP*ZQ*TERM1*TERM2
C.       TNRE=0.5D0*ZP*ZQ*TERM1*TERM2
      ENDIF
   11 CONTINUE
   10 CONTINUE
C
C     CONVERT TO RELATIVISTIC INTEGRALS
C
      NBSZ=NBAS1*(NBAS1+1)/2
      NBSZ5=5*NBSZ
      NBSQ=NBAS1*NBAS1
      NBSQ5=5*NBSQ
      CALL C_F_POINTER(C_LOC(REL(NBSZ+1)),iREL,[NBSZ])
      CALL AT34R(NBAS1,NBSZ  ,ZN,
     *SREL,UREL,TREL,REL(1),
C     OVERLAP    POTENTIAL  KIN.ENERGY PVP
     *iREL,REL(2*NBSZ+1),REL(3*NBSZ+1),REL(4*NBSZ+1),
C     MULT      BU          P           G
     *REL(NBSZ5+1),REL(NBSZ5+NBSQ+1),REL(NBSZ5+2*NBSQ+1),
C     EIG            SINV                REVT
     *REL(NBSZ5+3*NBSQ+1),REL(NBSZ5+4*NBSQ+1),REL(NBSZ5+5*NBSQ+1),
C     AUX                   OVE                   EW
     *REL(NBSZ5+NBSQ5+MX100+1),REL(NBSZ5+NBSQ5+2*MX100+1),
C     E                         AA
     *REL(NBSZ5+NBSQ5+3*MX100+1),REL(NBSZ5+NBSQ5+4*MX100+1),iprint,
C    RR                         TT
     *VEXTT,PVPT,EVN1,EVN2,RE1R,AUXI,W1W1,W1E0W1)
      NULLIFY(iREL)
      K=NBAS1*(NBAS1+1)/2
C
C     TRANSFER RELATIVISTIC KINETIC ENERGY AND POTENTIAL INTEGRALS
C
      if(iprint.ge.10) then
         write(6,*) ' matrices'
          write(6,*)  l,nbas1
         write(6,*) ' srel'
          write(6,12) (srel(j),j=1,(nbas1*(nbas1+1))/2)
         write(6,*) ' trel'
          write(6,12) (trel(j),j=1,(nbas1*(nbas1+1))/2)
         write(6,*) ' urel'
          write(6,12) (urel(j),j=1,(nbas1*(nbas1+1))/2)
         write(6,*) ' tnrel'
          write(6,12) (tnrel(j),j=1,(nbas1*(nbas1+1))/2)
         write(6,*) ' unrel'
          write(6,12) (unrel(j),j=1,(nbas1*(nbas1+1))/2)
         write(6,*) ' rel'
          write(6,12) (rel(j),j=1,(nbas1*(nbas1+1))/2)
      endif
      ij=0
      do 26 i=1,nbas1
      do 27 j=1,i
      ij=ij+1
      hcorr(ij)=(trel(ij)-zn*urel(ij)) - (tnrel(ij) - zn*unrel(ij))
      trel(ij)=trel(ij) - tnrel(ij)
      urel(ij)=-(zn*urel(ij) - zn*unrel(ij))
 27   continue
 26   continue
      if(iprint.ge.20) then
          write(6,*) ' full correction metrix'
          write(6,*)  l,nbas1
          write(6,12) (hcorr(j),j=1,(nbas1*(nbas1+1))/2)
      endif
 12   format(4f18.14)
      RETURN
      END SUBROUTINE OEISG_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Util2(Beta,nZeta,rFinal,la,lb,Slalbp,Slalbm)
!***********************************************************************
!                                                                      *
! Object: to assemble the orbital angular momentum integrals from the  *
!         derivative integrals and dipole integrals.                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             February '91                                             *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb
real(kind=wp), intent(in) :: Beta(nZeta), Slalbp(nZeta,nTri_Elem1(la),nTri_Elem1(lb+1),3), &
                             Slalbm(nZeta,nTri_Elem1(la),nTri_Elem1(lb-1),3)
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),3)
#include "print.fh"
integer(kind=iwp) :: ia, ib, iElem, ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyb, iza, izb, jElem
character(len=80) :: Label

iRout = 211
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  write(u6,*) ' In Util2 la,lb=',la,lb
  call RecPrt('Beta',' ',Beta,nZeta,1)
  do ia=1,nTri_Elem1(la)
    do ib=1,nTri_Elem1(lb+1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'x)'
      call RecPrt(Label,' ',Slalbp(:,ia,ib,1),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'y)'
      call RecPrt(Label,' ',Slalbp(:,ia,ib,2),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Slalbp(',ia,',',ib,'z)'
      call RecPrt(Label,' ',Slalbp(:,ia,ib,3),nZeta,1)
    end do
  end do
  if (lb > 0) then
    do ia=1,nTri_Elem1(la)
      do ib=1,nTri_Elem1(lb-1)
        write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'x)'
        call RecPrt(Label,' ',Slalbm(:,ia,ib,1),nZeta,1)
        write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'y)'
        call RecPrt(Label,' ',Slalbm(:,ia,ib,2),nZeta,1)
        write(Label,'(A,I2,A,I2,A)') ' Slalbm(',ia,',',ib,'z)'
        call RecPrt(Label,' ',Slalbm(:,ia,ib,3),nZeta,1)
      end do
    end do
  end if
end if

do ixa=la,0,-1
  do iya=la-ixa,0,-1
    iza = la-ixa-iya
    ipa = C_Ind(la,ixa,iza)

    do ixb=lb,0,-1
      do iyb=lb-ixb,0,-1
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        rFinal(:,ipa,ipb,1) = Two*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),2)-Slalbp(:,ipa,C_Ind(lb+1,ixb,izb),3))
        rFinal(:,ipa,ipb,2) = Two*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),3)-Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),1))
        rFinal(:,ipa,ipb,3) = Two*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb,izb),1)-Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),2))

        if (ixb > 0) then
          rFinal(:,ipa,ipb,2) = rFinal(:,ipa,ipb,2)-real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb),3)
          rFinal(:,ipa,ipb,3) = rFinal(:,ipa,ipb,3)+real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb),2)
        end if

        if (iyb > 0) then
          rFinal(:,ipa,ipb,3) = rFinal(:,ipa,ipb,3)-real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb),1)
          rFinal(:,ipa,ipb,1) = rFinal(:,ipa,ipb,1)+real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb),3)
        end if

        if (izb > 0) then
          rFinal(:,ipa,ipb,1) = rFinal(:,ipa,ipb,1)-real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1),2)
          rFinal(:,ipa,ipb,2) = rFinal(:,ipa,ipb,2)+real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1),1)
        end if

      end do
    end do

  end do
end do

if (iPrint >= 49) then
  write(u6,*) ' In Util2 la,lb=',la,lb
  do iElem=1,nTri_Elem1(la)
    do jElem=1,nTri_Elem1(lb)
      write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',x) '
      call RecPrt(Label,' ',rFinal(:,iElem,jElem,1),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',y) '
      call RecPrt(Label,' ',rFinal(:,iElem,jElem,2),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',z) '
      call RecPrt(Label,' ',rFinal(:,iElem,jElem,3),nZeta,1)
    end do
  end do
end if

return

end subroutine Util2

!**********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SymTrafo(LUPROP,lOper,nComp,nBas,nIrrep,Label,MolWgh)
!bs Purpose: combine SO-integrals from amfi to symmetry-adapted
!bs integrals on one file AOPROPER_MF_SYM

use AMFI_global, only: Lmax, MxCart
use index_functions, only: iTri
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LUPROP, nComp, lOper(nComp), nIrrep, nBas(0:nIrrep-1), MolWgh
character(len=8), intent(in) :: Label
#include "Molcas.fh"
integer(kind=iwp) :: I, iBas, icc, iCent, icentprev, icoeff, iComp, idummy(8), iIrrep, ijSO, ilcentprev, imcentprev, indx, indexi, &
                     indexj, iOff, iOff2, iOpt, iorb, ipSCR, iRC, irun, isame, iSmLbl, iSO, iSO_a, iSO_r, istatus, isymunit, &
                     iunit, j1, j12, j2, jcent, jcentprev, jlcentprev, jmcentprev, jrun, jsame, jSO, jSO_r, lauf, laufalt, &
                     length3, length3_tot, LenInt, LenTot, LLhigh, Lrun, Mrun, ncontcent(0:Lmax), not_defined, nSOs, numbofcent, &
                     numboffunct, numboffunct3, numbofsym
real(kind=wp) :: coeff, Sgn
!BS character(len=20) :: filename
character(len=8) :: xa2(4)
character(len=3) :: send
logical(kind=iwp) :: EX
integer(kind=iwp), allocatable :: C(:), ifirstLM(:,:,:), ip(:), iSO_info(:,:), Lcent(:), Lhighcent(:), Lval(:), Mcent(:), mval(:), &
                                  nadpt(:), ncent(:), nphase(:,:), numballcart(:)
real(kind=wp), allocatable :: AMFI_Int(:,:), Scr(:,:), SOInt(:)
integer(kind=iwp), external :: iPntSO, isfreeunit, n2Tri

! These variables are just placeholders for reading
#include "macros.fh"
unused_var(idummy)
unused_var(xa2)

!#######################################################################
call mma_allocate(ifirstLM,[0,Lmax],[-Lmax,Lmax],[1,MxAtom],label='ifirstLM')

! read information from SYMINFO
isymunit = isfreeunit(58)
call f_inquire('SYMINFO',EX)
if (.not. EX) call SysAbendMsg('systrafo','SYMINFO not present','Sorry')
call molcas_open(isymunit,'SYMINFO')
rewind(isymunit)
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
write(u6,*) 'Symmetry adapation of the SO-integrals'
#endif
read(isymunit,*)
read(isymunit,*)
read(isymunit,*)
numboffunct = 0
send = ''
do while (send /= 'END')
  numboffunct = numboffunct+1
  read(isymunit,'(A3)') send
end do
#ifdef _DEBUGPRINT_
write(u6,*) 'there are totally ',numboffunct,' functions'
#endif
if (numboffunct > MxOrb) call SysAbendMsg('symtrafo','increase MxOrb in Molcas.fh',' ')
rewind isymunit
read(isymunit,*)
read(isymunit,*)
numbofcent = 0
call mma_allocate(ncent,numboffunct,label='ncent')
call mma_allocate(Lval,numboffunct,label='Lval')
call mma_allocate(mval,numboffunct,label='mval')
call mma_allocate(nadpt,numboffunct,label='nadpt')
call mma_allocate(nphase,8,numboffunct,label='nphase')
do irun=1,numboffunct
  read(isymunit,*) indx,ncent(irun),lval(irun),mval(irun),nadpt(irun),(nphase(I,irun),I=1,nadpt(irun))
  numbofcent = max(numbofcent,ncent(irun))
  if (indx /= irun) call SysAbendMsg('symtrafo','weird numbering on SYMINFO',' ')
end do
close(iSymUnit)
#ifdef _DEBUGPRINT_
write(u6,*) 'number of unique centres',numbofcent
#endif

! clean up arrays for new integrals
numboffunct3 = (numboffunct*numboffunct+numboffunct)/2

call mma_allocate(AMFI_Int,numboffunct3,3,label='AMFI_Int')
AMFI_Int(:,:) = Zero

nSOs = 0
do iIrrep=0,nIrrep-1
  nSOs = nSOs+nBas(iIrrep)
end do
call mma_allocate(iSO_info,2,nSOs,label='iSO_info')
iSO_a = 0
do iIrrep=0,nIrrep-1
  iSO_r = 0
  do iBas=1,nBas(iIrrep)
    iSO_a = iSO_a+1
    iSO_r = iSO_r+1
    iSO_info(1,iSO_a) = iIrrep
    iSO_info(2,iSO_a) = iSO_r
  end do
end do

! loop over unique centres to read integrals and information

iunit = LUPROP
call mma_allocate(Scr,numboffunct3,3,label='Scr')
Scr(:,:) = Zero
ipSCR = 1
length3_tot = 0

call mma_allocate(C,numbofcent,label='C')
call mma_allocate(numballcart,numbofcent,label='numballcart')
call mma_allocate(Lcent,MxCart,label='Lcent')
call mma_allocate(Mcent,MxCart,label='Mcent')
call mma_allocate(Lhighcent,MxAtom,label='Lhighcent')

! In a MPI run not all atomic block will be available in
! all processes. Make up so we know later if a particular
! atom is present.

C(:) = -99
do jcent=1,numbofcent

# ifdef _DEBUGPRINT_
  write(u6,*) 'read integrals and info for centre ',jcent
# endif

  ! Note that when running in parallel this list is incomplete.
  ! Hence, we process the centers which each process host.

  read(iunit,iostat=istatus) iCent
  if (istatus < 0) exit
  read(iunit) xa2,numbofsym,(idummy(I),i=1,numbofsym),numballcart(icent),(Lcent(i),I=1,numballcart(icent)), &
              (mcent(i),I=1,numballcart(icent)),Lhighcent(icent),(ncontcent(I),I=0,Lhighcent(icent))
# ifdef _DEBUGPRINT_
  write(u6,*) numballcart(icent),'functions on centre ',icent
# endif
  length3 = iTri(numballcart(icent),numballcart(icent))
  C(iCent) = ipSCR
  read(iunit) (Scr(i,1),i=ipSCR,ipSCR+length3-1)
  read(iunit) xa2
  read(iunit) (Scr(i,2),i=ipSCR,ipSCR+length3-1)
  read(iunit) xa2
  read(iunit) (Scr(i,3),i=ipSCR,ipSCR+length3-1)
  ipScr = ipScr+length3
  length3_tot = length3_tot+length3
  !ulf
  ! check if any L-value is missing
  LLhigh = Lhighcent(icent)
  do i=1,Lhighcent(icent)
    if (ncontcent(I) == 0) LLhigh = LLhigh-1
  end do
  Lhighcent(icent) = LLhigh
  !bs determize where the first function of a special type is..
  not_defined = iTri(numboffunct,numboffunct)+1
  do Lrun=0,Lhighcent(icent)
    ifirstLM(Lrun,-Lrun:Lrun,icent) = not_defined
  end do
  do iorb=1,numballcart(icent)
    Lrun = Lcent(iorb)
    Mrun = Mcent(iorb)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iorb,Lrun,mrun',iorb,Lrun,mrun
#   endif
    ifirstLM(Lrun,Mrun,icent) = min(iorb,ifirstLM(Lrun,Mrun,icent))
  end do

  !bs determined..
  !bs check if all of them were found
  do Lrun=0,Lhighcent(icent)
    do Mrun=-Lrun,Lrun
      if (ifirstLM(Lrun,Mrun,icent) == not_defined) then
        write(u6,*) 'problems for centre,L,M ',icent,Lrun,Mrun
        call SysAbendMsg('symtrafo','problems with L- and M-values',' ')
      end if
    end do
  end do
end do    !end of loop over centres
call mma_deallocate(numballcart)
call mma_deallocate(Lcent)
call mma_deallocate(Mcent)
call mma_deallocate(Lhighcent)
#ifdef _DEBUGPRINT_
write(u6,*) 'length3_tot=',length3_tot
call RecPrt('SCR(1,1)',' ',Scr(1,1),1,length3_tot)
call RecPrt('SCR(1,2)',' ',Scr(1,2),1,length3_tot)
call RecPrt('SCR(1,3)',' ',Scr(1,3),1,length3_tot)
do iCent=1,numbofcent
  write(u6,*) C(iCent)
end do
#endif
! If this process does not have any blocks of integrals proceed
! directly to the distribution step.
if (Length3_tot /= 0) then

  !bs Finally the transformation!!!!

  icentprev = 0
  jcentprev = 0
  ilcentprev = -1
  jlcentprev = -1
  imcentprev = 20
  jmcentprev = 20
  isame = 1
  jsame = 1
  lauf = 0
  do irun=1,numboffunct
    ! Skip if center corresponding to this basis function is
    ! not available at this process.
    if ((ncent(irun) == icentprev) .and. (ilcentprev == lval(irun)) .and. (imcentprev == mval(irun))) then
      isame = isame+1
    else
      isame = 1
      icentprev = ncent(irun)
      ilcentprev = lval(irun)
      imcentprev = mval(irun)
    end if
    do jrun=1,irun
      lauf = lauf+1
      if ((ncent(jrun) == jcentprev) .and. (jlcentprev == lval(jrun)) .and. (jmcentprev == mval(jrun))) then
        jsame = jsame+1
      else
        jsame = 1
        jcentprev = ncent(jrun)
        jlcentprev = lval(jrun)
        jmcentprev = mval(jrun)
      end if
      !bs check for same centers
      if (ncent(irun) == ncent(jrun)) then
        if ((lval(irun) == lval(jrun)) .and. (lval(irun) > 0)) then
          if (abs(abs(mval(irun))-abs(mval(jrun))) <= 1) then

            !bs the only cases where non-zero integrals occur
            if (nadpt(irun) == 1) then
              coeff = One
            else
              icoeff = 0
              do icc=1,nadpt(irun)
                icoeff = icoeff+nphase(icc,irun)*nphase(icc,jrun)
              end do
              coeff = real(icoeff,kind=wp)
              if (MolWgh == 2) then
                coeff = coeff/real(nadpt(irun),kind=wp)
              else
                coeff = coeff/real(nadpt(irun)*nadpt(irun),kind=wp)
              end if
            end if
            !bs determine indices of atomic integrals
            indexi = ifirstLM(lval(irun),mval(irun),ncent(irun))+isame-1
            indexj = ifirstLM(lval(irun),mval(jrun),ncent(irun))+jsame-1
            laufalt = iTri(indexi,indexj)

            if (C(nCent(iRun)) /= -99) then
              ipSCR = C(ncent(irun))-1+laufalt
              ! DebugDebug
              !write(u6,*) 'laufalt=',laufalt
              !write(u6,*) 'ip''s:',ipSCR
              !write(u6,*) Scr(ipSCR,1),Scr(ipSCR,2),Scr(ipSCR,3)
              ! DebugDebug
              Sgn = One
              if (indexi > indexj) Sgn = -Sgn
              AMFI_Int(lauf,1) = Sgn*coeff*Scr(ipScr,1)
              AMFI_Int(lauf,2) = Sgn*coeff*Scr(ipScr,2)
              AMFI_Int(lauf,3) = Sgn*coeff*Scr(ipScr,3)
            end if

          end if
        end if
      end if
    end do ! jrun
  end do ! irun
end if
call mma_deallocate(C)
call mma_deallocate(ncent)
call mma_deallocate(Lval)
call mma_deallocate(mval)
call mma_deallocate(nadpt)
call mma_deallocate(nphase)

! Allocate memory for symmetry adapted one electron integrals.
! Will just store the unique elements, i.e. low triangular blocks
! and lower triangular elements in the diagonal blocks.

call mma_allocate(ip,nComp,label='ip')
LenTot = 0
do iComp=1,nComp
  ip(iComp) = 1+LenTot
  LenInt = n2Tri(lOper(iComp))
  LenTot = LenTot+LenInt+4
end do
call mma_allocate(SOInt,LenTot,label='SOInt')
SOInt(:) = Zero

! This test is not valid for parallel execution, since here
! we have only incomplete lists.
!if (lauf /= numboffunct3) call SysAbendMsg('symtrafo','error in numbering ',' ')
do iComp=1,nComp
  do iSO=1,numboffunct
    j1 = iSO_info(1,iSO)
    iSO_r = iSO_info(2,iSO)
    do jSO=1,iSO
      j2 = iSO_info(1,jSO)
      jSO_r = iSO_info(2,jSO)
      j12 = ieor(j1,j2)
      if (.not. btest(lOper(iComp),j12)) cycle

      iOff = iPntSO(max(j1,j2),min(j1,j2),lOper(iComp),nBas)
      iOff = iOff+ip(iComp)-1

      iOff2 = iTri(iSO,jSO)

      if (j1 == j2) then
        ijSO = iTri(iSO_r,jSO_r)
      else
        ijSO = (jSO_r-1)*nBas(j1)+iSO_r
      end if
      SOInt(iOff+ijSO) = -AMFI_Int(iOff2,iComp)

    end do
  end do

  ! Write out integrals to ONEINT for this specific component of the operator.

  iOpt = 0
  iRC = -1
  iSmLbl = lOper(iComp)
  call GADSum(SOInt(ip(iComp)),n2Tri(iSmLbl))
  call WrOne(iRC,iOpt,Label,iComp,SOInt(ip(iComp)),iSmLbl)
  if (iRC /= 0) call SysAbendMsg('symtrafo','     Error in subroutine ONEEL ','     Abend in subroutine WrOne')

end do

#ifdef _DEBUGPRINT_
call PrMtrx(Label,lOper,nComp,ip,SOInt)
#endif

call mma_deallocate(ifirstLM)
call mma_deallocate(iSO_info)
call mma_deallocate(Scr)
call mma_deallocate(AMFI_Int)
call mma_deallocate(ip)
call mma_deallocate(SOInt)
!BS write(u6,*) 'Symmetry transformation successfully done'

return

end subroutine SymTrafo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989,1998, Per Ake Malmqvist                           *
************************************************************************
*  PROGRAM RASSI        PER-AAKE MALMQVIST
*  SUBROUTINE CITRA     IBM-3090 RELEASE 89 01 31
*  USE THE COEFFICIENTS FOR A SEQUENCE OF SINGLE-ORBITAL TRANSFOR-
*  MATION, TRA, TO TRANSFORM THE CI EXPANSION COEFFICIENTS
*  IN-PLACE TO A NEW NON-ON ORBITAL BASIS.
*  NEW VERSION 981122, using user define types SGS,CIS,XS.
************************************************************************
*  CITRA
*
*> @brief
*>   Recompute a CI coefficient array to use another orbital basis
*> @author P. &Aring;. Malmqvist
*>
*> @details
*> For a given linear transformation of the orbitals, and a
*> CI array where the CSF basis is built from the old
*> orbitals, compute the CI array using the new orbitals
*> instead. The orbitals are transformed sequentially, and
*> for each active orbital, a call to ::SSOTRA performs the
*> single-orbital transformation.
*>
*> @param[in]     WFTP Wave function Type Name
*> @param[in]     SGS Split Graph Structure user defined type
*> @param[in]     CIS CI Structure user define type
*> @param[in]     EXS  Excitation operator Structure user defined type
*> @param[in]     LSM  Wave function Symmetry Label
*> @param[in]     TRA  Transformation Matrix
*> @param[in]     NCO  Number of Configuration Functions
*> @param[in,out] CI   CI Array
************************************************************************
      SUBROUTINE CITRA(WFTP,SGS,CIS,EXS,LSM,TRA,NCO,CI)
      use definitions, only: iwp, wp
#ifdef DEBUG_MPSSI
      use definitions, only: u6
#endif
      use constants, only: One
      use gugx, only: SGStruct, CIStruct, EXStruct
      use stdalloc, only: mma_allocate, mma_deallocate
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NTRA,NOSH,NISH,NASH
      IMPLICIT NONE
      CHARACTER(LEN=8), Intent(in):: WFTP
      Type (SGStruct), intent(in):: SGS
      Type (CIStruct), intent(in):: CIS
      Type (EXStruct), intent(in):: EXS
      integer(kind=iwp), intent(in):: LSM, NCO
      Real(kind=wp), intent(in)::TRA(NTRA)
      Real(kind=wp), intent(inout)::CI(NCO)

      real(kind=wp), Allocatable:: TMP(:)
      real(kind=wp) FAC,CKK
      integer(kind=iwp) ISTA,ISYM,NO,I,II,NA,NI


#ifdef DEBUG_MPSSI
      write(6,*)' Entering CITRA. norm=',ddot_(NCO,CI,1,CI,1)
#endif
!     write(6,*)' Entering CITRA. TRA='
!     write(6,'(1x,5f16.8)')(TRA(I),I=1,NTRA)
!     write(6,*)' Entering CITRA. CI='
!     write(6,'(1x,5f16.8)')(CI(I),I=1,NCO)
C TRA contains square matrices, one per symmetry
C  FIRST TRANSFORM THE INACTIVE ORBITALS:
      FAC=One
      ISTA=1
      DO ISYM=1,NSYM
        NO=NOSH(ISYM)
        DO I=1,NISH(ISYM)
          II=ISTA+(NO+1)*(I-1)
          CKK=TRA(II)
          FAC=FAC*CKK
        END DO
        ISTA=ISTA+NO**2
      END DO
!     write(6,*) 'FAC, FAC**2 ... ',FAC,FAC**2
      FAC=FAC**2
      CALL DSCAL_(NCO,FAC,CI,1)
!     write(6,*)' CITRA. inactive done CI='
!     write(6,'(1x,5f16.8)')(CI(I),I=1,NCO)
C  THEN THE ACTIVE ONES:
      if (WFTP /= 'EMPTY   ') then
* The HISPIN case may be buggy and is not presently used.
      IF(WFTP.EQ.'HISPIN  '.or.WFTP.EQ.'CLOSED  ') THEN
        ISTA=1
        DO ISYM=1,NSYM
          NI=NISH(ISYM)
          NA=NASH(ISYM)
          NO=NOSH(ISYM)
          DO I=NI+1,NI+NA
            II=ISTA+(NO+1)*(I-1)
            CKK=TRA(II)
            FAC=FAC*CKK
          END DO
          ISTA=ISTA+NO**2
        END DO
        IF(WFTP.EQ.'CLOSED  ') FAC=FAC**2
        CALL DSCAL_(NCO,FAC,CI,1)
      ELSE
C The general case:
        CALL mma_allocate(TMP,NCO,Label='TMP')
        ISTA=1
        DO ISYM=1,NSYM
          NA=NASH(ISYM)
          NO=NOSH(ISYM)
          IF(NA.NE.0) THEN
            CALL SSOTRA(SGS,CIS,EXS,ISYM,LSM,NA,NO,
     &                TRA(ISTA),NCO,CI,TMP)
          END IF
          ISTA=ISTA+NO**2
        END DO
        CALL mma_deallocate(TMP)
      END IF
#ifdef DEBUG_MPSSI
      write(6,*)' DONE in  CITRA. norm=',ddot_(NCO,CI,1,CI,1)
#endif
!     write(6,*)' CITRA completely done. CI='
!     write(6,'(1x,5f16.8)')(CI(I),I=1,NCO)

      end if

      END SUBROUTINE CITRA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine frankie(nfro,no,nv,printkey)

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use Cholesky, only: timings
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nfro, no, nv, printkey
integer(kind=iwp) :: idum(1), nbas, ndel, nocc, norb, rc
real(kind=wp) :: FracMem
type(DSBA_Type) :: CMO

!.1 - get the info on  nBas, nOrb, nOcc. Use nFro from input

!# nbas = nfro + nocc + nvirt + ndel

call Get_iArray('nBas',idum,1)
nBas = idum(1)
call Get_iArray('nOrb',idum,1)
nOrb = idum(1)
call Get_iArray('nIsh',idum,1) ! in general > no
nOcc = idum(1)

ndel = nbas-no-nv-nfro

if (printkey >= 10) then
  write(u6,*) 'nbas = ',nbas
  write(u6,*) 'norb = ',norb
  write(u6,*) 'nocc = ',nocc
  write(u6,*) 'nfro = ',nfro
  write(u6,*) 'no   = ',no,' (nocc-nfro)'
  write(u6,*)
  write(u6,*) 'ndel = ',ndel
end if

if ((no+nfro+nv+ndel) /= nbas) then
  write(u6,*) 'Problem '
  write(u6,*) 'nbas from Runfile : ',nbas
  write(u6,*) 'nbas control      : ',nfro+no+nv+ndel
  call abend()
end if

timings = .false.
if (printkey > 1) timings = .true.

!.2 - allocate space for CMO with removed SCF deleted and frozen orbitals
!     final ordering of indices : (o+v,nbas)

call Allocate_DT(CMO,[no+nv],[nbas],1)
if (printkey >= 10) write(u6,*) 'Dopice 1 - Allo'

!.3 - read CMO
call read_mo(Cmo,nfro,no,nv,ndel,nbas,nOrb)
!.3 - invert the CMO matrix
FracMem = Zero ! in a parallel run set it to a sensible value
rc = 0
call Cho_X_init(rc,FracMem) ! initialize cholesky info
if (printkey >= 10) write(u6,*) 'Dopice 2 ',rc

call CHO_CC_drv(rc,CMO)
if (printkey >= 10) write(u6,*) 'Dopice 3 '

call Cho_X_final(rc)
if (printkey >= 10) write(u6,*) 'Dopice 4 '

if (rc /= 0) then
  write(u6,*) 'cho_cc_drv failed'
  call abend()
end if

!. - deallocate CMO
call Deallocate_DT(CMO)

return

end subroutine frankie

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine cvbnrm_cvb(cvb)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
#include "frag_cvb.fh"
      dimension cvb(nvb)

      if(nfrag.le.1)then
        call dscal_(nvb,one/dnrm2_(nvb,cvb,1),cvb,1)
      else
        nvbadd=1
        do 100 ifrag=1,nfrag
        call dscal_(nvb_fr(ifrag),
     >    one/dnrm2_(nvb_fr(ifrag),cvb(nvbadd),1),cvb(nvbadd),1)
        nvbadd=nvbadd+nvb_fr(ifrag)
100     continue
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Martin Schuetz                                   *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine vOO2OV(v1,n1,v2,n2,nD)
************************************************************************
*                                                                      *
*     purpose: converts vector of dim nOO (e.g. gradient) to vector    *
*              of lower dimension nOV (occ-virt block only)            *
*              if n1==nOO && n2==nOV  -> compress                      *
*              else if if n1==nOV && n2==nOO -> decompress             *
*                                                                      *
*     output:                                                          *
*       v2      : compressed or decompressed vector, dep. on input     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*     Roland Lindh                                                     *
*     Uppsala University, Sweden, 2017                                 *
*     Fortran pointer structure                                        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
#include "compiler_features.h"
#ifndef POINTER_REMAP
      Use, Intrinsic :: ISO_C_BINDING
#endif
      Implicit Real*8 (a-h,o-z)
*
*     declaration subroutine parameters
      Integer n1,n2
      Real*8, Target:: v1(n1,nD),v2(n2,nD)
      Real*8, Dimension(:,:), Pointer:: pv1, pv2
*
*     declaration local variables
      Integer iSym,ii,ia,ioffs,ivoffs
*
#include "real.fh"

#include "mxdm.fh"
#include "infscf.fh"
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Do iD = 1, nD
         iCase = iD - 1
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
         Write (6,*) 'n1,n2,nOO,nOV=',n1,n2,nOO,nOV
         iOff = 1
         Do iSym = 1, nSym
            If (n1.eq.nOO) Then
               nO = nOrb(iSym)
               Call RecPrt('vOO2OV: v1',' ',v1(ioff,iD),nO,nO)
               iOff = iOff + nO**2
            Else If (n1.eq.nOV) Then
               nO = Max(nOcc(iSym,1),nOcc(iSym,2))-nFro(iSym)
               nV = nOrb(iSym)-Min(nOcc(iSym,1),nOcc(iSym,2))-nFro(iSym)
               Call RecPrt('vOO2OV: v1',' ',v1(ioff,iD),nO,nV)
               iOff = iOff + nO*nV
            End If
         End Do
#endif
         ioffs=0
         ivoffs=1
         Do iSym=1,nSym
            nii1=nFro(iSym)+1
            nii2=nOcc(iSym,iD)
            nia1=nOcc(iSym,iD)+1
            nia2=nOrb(iSym)
            nv1=nia2**2
            nv2=(nia2-nia1+1)*(nii2-nii1+1)
*
            If ((n1.eq.nOO).and.(n2.eq.nOV)) Then
*
*           compress
*
#ifdef POINTER_REMAP
               pv1(1:nia2,1:nia2) => v1(ioffs+1:ioffs+nv1,iD)
               pv2(nia1:nia2,nii1:nii2) => v2(ivoffs:ivoffs+nv2-1,iD)
*
               Do ii=nii1,nii2
                  Do ia=nia1,nia2
                     If (pv1(ia,ii).ne.-pv1(ii,ia)) Then
                        Write (6,*) 'inconsistency in gradient'
                        Call Abend()
                     End If
                     pv2(ia,ii)=pv1(ia,ii)
                  End Do
               End Do
#else
               Call C_F_POINTER(C_LOC(v1(ioffs+1,iD)), pv1, [nia2,nia2])
               Call C_F_POINTER(C_LOC(v2(ivoffs,iD)), pv2,
     &                          [nia2-nia1+1,nii2-nii1+1])
*
               Do ii=nii1,nii2
                  Do ia=nia1,nia2
                     If (pv1(ia,ii).ne.-pv1(ii,ia)) Then
                        Write (6,*) 'inconsistency in gradient'
                        Call Abend()
                     End If
                     pv2(ia-nia1+1,ii-nii1+1)=pv1(ia,ii)
                  End Do
               End Do
#endif
*
            Else If ((n1.eq.nOV).and.(n2.eq.nOO)) Then
*
*           decompress
*
#ifdef POINTER_REMAP
               pv1(nia1:nia2,nii1:nii2) => v1(ivoffs:ivoffs+nv2-1,iD)
               pv2(1:nia2,1:nia2) => v2(ioffs+1:ioffs+nv1,iD)
*
               Do ii=nii1,nii2
                  Do ia=nia1,nia2
                     pv2(ia,ii) = pv1(ia,ii)
                     pv2(ii,ia) =-pv1(ia,ii)
                  End Do
               End Do
#else
               Call C_F_POINTER(C_LOC(v1(ivoffs,iD)), pv1,
     &                          [nia2-nia1+1,nii2-nii1+1])
               Call C_F_POINTER(C_LOC(v2(ioffs+1,iD)), pv2, [nia2,nia2])
*
               Do ii=nii1,nii2
                  Do ia=nia1,nia2
                     pv2(ia,ii) = pv1(ia-nia1+1,ii-nii1+1)
                     pv2(ii,ia) =-pv1(ia-nia1+1,ii-nii1+1)
                  End Do
               End Do
#endif
            End If

            Nullify(pv1,pv2)
            ivoffs=ivoffs+nv2
            ioffs=ioffs+(nOrb(iSym)*nOrb(iSym))
         End Do
*
#ifdef _DEBUGPRINT_
         Write (6,*) 'n1,n2,nOO,nOV=',n1,n2,nOO,nOV
         iOff = 1
         Do iSym = 1, nSym
            If (n2.eq.nOO) Then
               nO = nOrb(iSym)
               Call RecPrt('vOO2OV: v2',' ',v2(ioff,iD),nO,nO)
               iOff = iOff + nO**2
            Else If (n2.eq.nOV) Then
               nO = Max(nOcc(iSym,1),nOcc(iSym,2))-nFro(iSym)
               nV = nOrb(iSym)-Min(nOcc(iSym,1),nOcc(iSym,2))-nFro(iSym)
               Call RecPrt('vOO2OV: v2',' ',v2(ioff,iD),nO,nV)
               iOff = iOff + nO*nV
            End If
         End Do
#endif
*
      End Do ! iD
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine pa_prham( exch, npair, i_pair, nneq, neq, nexch,
     &                     nmax, lmax, eso, HLIN1, HLIN3, HLIN9,
     &                     HDIP, HKEX, HDMO, HITO, Dipol, AnisoLines1,
     &                     AnisoLines3, AnisoLines9, KE, DM_Exchange,
     &                     JITO_exchange )
c this function prints the exchange Hamiltonian
c it does not compute any new infromation
      Implicit None
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
#include "stdalloc.fh"
#include "warnings.fh"
      Integer, intent(in)          :: exch
      Integer, intent(in)          :: npair
      Integer, intent(in)          :: i_pair(npair,2)
      Integer, intent(in)          :: nneq
      Integer, intent(in)          :: neq(nneq)
      Integer, intent(in)          :: nexch(nneq)
      Integer, intent(in)          :: nmax
      Integer, intent(in)          :: lmax
      Real(kind=8), intent(in)    :: eso(nneq,nmax)
      Complex(kind=8), intent(in) :: HLIN1(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HLIN3(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HLIN9(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HDIP(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HKEX(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HDMO(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HITO(npair,nmax,nmax,nmax,nmax)
      Logical, intent(in)          :: Dipol
      Logical, intent(in)          :: DM_exchange
      Logical, intent(in)          :: KE
      Logical, intent(in)          :: AnisoLines1
      Logical, intent(in)          :: AnisoLines3
      Logical, intent(in)          :: AnisoLines9
      Logical, intent(in)          :: JITO_exchange
c local variables
      Complex(kind=8), allocatable :: HTOT(:), H1(:), H2(:), H3(:),
     &                                 H4(:)

      Integer  :: nind(lmax,2), intc(lmax), ibas(exch,lmax),
     &            icoord(lmax),
     &            nb1, nb2, lb1, lb2, i1, i2, is1, is2,
     &            js1, js2, nb, i, j, l, lp, lb, lpr, ibuf
      Integer  :: CtoB, RtoB, ItoB, mem_local
      Integer  :: norder
      Real(kind=8) :: dznrm2_
      External :: norder, dznrm2_

!=======================================================================
      If(npair==0) Then
          Call WarningMessage(2,'PA_PRHAM: npair = 0')
          Return
      End If
      If(nmax==0)  Then
          Call WarningMessage(2,'PA_PRHAM:  nmax = 0')
          Return
      End If
      If(exch==0)  Then
          Call WarningMessage(2,'PA_PRHAM:  exch = 0')
          Return
      End If
      If(lmax==0)  Then
          Call WarningMessage(2,'PA_PRHAM:  lmax = 0')
          Return
      End If
      ibuf=npair*nmax*nmax*nmax*nmax
      If(ibuf>0) Then
        If( (dznrm2_(ibuf,HLIN1,1)==0.0_wp).and.(AnisoLines1) )
     &      Call WarningMessage(2,'PA_PRHAM:  HLIN1 is empty')
        If( (dznrm2_(ibuf,HLIN3,1)==0.0_wp).and.(AnisoLines3) )
     &      Call WarningMessage(2,'PA_PRHAM:  HLIN3 is empty')
        If( (dznrm2_(ibuf,HLIN9,1)==0.0_wp).and.(AnisoLines9) )
     &      Call WarningMessage(2,'PA_PRHAM:  HLIN9 is empty')
        If( (dznrm2_(ibuf,HDIP,1)==0.0_wp).and.(Dipol) )
     &      Call WarningMessage(2,'PA_PRHAM:  HDIP is empty')
        If( (dznrm2_(ibuf,HKEX,1)==0.0_wp).and.(KE) )
     &      Call WarningMessage(2,'PA_PRHAM:  HKEX is empty')
        If( (dznrm2_(ibuf,HDMO,1)==0.0_wp).and.(DM_exchange) )
     &      Call WarningMessage(2,'PA_PRHAM:  HDMO is empty')
        If( (dznrm2_(ibuf,HITO,1)==0.0_wp).and.(JITO_exchange) )
     &      Call WarningMessage(2,'PA_PRHAM:  HITO is empty')
      End If !ibuf
!=======================================================================
! allocate memory
      ItoB=8
      RtoB=8
      CtoB=16
      mem_local=0
      If(exch>=0) Then
        Call mma_allocate(htot,exch,'htot')
        Call mma_allocate(h1,exch,'h1')
        Call mma_allocate(h2,exch,'h2')
        Call mma_allocate(h3,exch,'h3')
        Call mma_allocate(h4,exch,'h4')
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,htot,1)
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,h1,1)
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,h2,1)
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,h3,1)
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,h4,1)
        mem_local=mem_local+5*exch*CtoB
      End If

      !do lp=1,nPair
      !  Write(6,'(A,i2,A,i3)') 'i_Pair(',lp,',1)=',i_pair(lp,1)
      !  Write(6,'(A,i2,A,i3)') 'i_Pair(',lp,',2)=',i_pair(lp,2)
      !end do
c generate the tables:
      nind(:,:)=0
      lpr=0
      l=0
      Do i=1,nneq
        Do j=1,neq(i)
          l=l+1
          nind(l,1)=i
          nind(l,2)=j
        End Do
      End Do
      intc(:)=0
      ibas(:,:)=0
      intc(1)=1
      If (lmax.gt.1) Then
        Do i=2,lmax
          i1=nind(i-1, 1)
          intc(i)=intc(i-1)*nexch(i1)
        End Do
      End If
      Do nb=1,exch
        nb1=nb-1
        Do i=1,lmax
          ibas(nb, lmax-i+1)= nb1 / intc(lmax-i+1)
          nb1=nb1-ibas(nb,lmax-i+1)*intc(lmax-i+1)
        End Do
      End Do
c
      Write(6,*)
      Write(6,'(100a)') (('%'),j=1,100)
      Write(6,'(30x,a)') 'Hamiltonian of the Total Magnetic '//
     &                   'Interaction'
      Write(6,'(100a)') (('%'),j=1,100)


      Write(6,'(A)') 'Only matrix elements '//
     & 'with non-zero absolute value are listed below'

      If ((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.Dipol
     &                             .and.KE.and..not.JITO_exchange ) Then
        Write(6,'(6A)') '                 ',
     &        '|       Lines  Model of Interaction   | ',
     &        '|      Dipolar Magnetic Interaction   | ',
     &        '|      Kinetic Exchange Interaction   | ',
     &        '|       TOTAL  Magnetic Interaction   | '
        lpr=4
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.Dipol
     &                        .and..not.KE.and..not.JITO_exchange ) Then
        Write(6,'(6A)') '                 ',
     &   '|       Lines  Model of Interaction   | ',
     &   '|      Dipolar Magnetic Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=3
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and..not.Dipol
     &                             .and.KE.and..not.JITO_exchange ) Then
        Write(6,'(6A)') '                 ',
     &   '|       Lines  Model of Interaction   | ',
     &   '|      Kinetic Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=3
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.Dipol
     &                             .and.KE.and..not.JITO_exchange ) Then
        Write(6,'(6A)') '                 ',
     &   '|      Dipolar Magnetic Interaction   | ',
     &   '|      Kinetic Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=3
      Else If( (AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &              .not.Dipol.and..not.KE.and..not.JITO_exchange ) Then
        Write(6,'(6A)') '                 ',
     &   '|       Lines  Model of Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=2
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                   Dipol.and..not.KE.and..not.JITO_exchange ) Then
        Write(6,'(6A)') '                 ',
     &   '|      Dipolar Magnetic Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=2
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                   .not.Dipol.and.KE.and..not.JITO_exchange ) Then
        Write(6,'(6A)') '                 ',
     &   '|      Kinetic Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=2
! JITO is active below:
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                    .not.Dipol.and..not.KE.and.JITO_exchange) Then
        Write(6,'(6A)') '                 ',
     &   '|          ITO Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=2
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                         Dipol.and..not.KE.and.JITO_exchange) Then
        Write(6,'(6A)') '                 ',
     &   '|      Dipolar Magnetic Interaction   | ',
     &   '|          ITO Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=3
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                         .not.Dipol.and.KE.and.JITO_exchange) Then
        Write(6,'(6A)') '                 ',
     &   '|      Kinetic Exchange Interaction   | ',
     &   '|          ITO Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=3
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                              Dipol.and.KE.and.JITO_exchange) Then
        Write(6,'(6A)') '                 ',
     &   '|      Dipolar Magnetic Interaction   | ',
     &   '|      Kinetic Exchange Interaction   | ',
     &   '|          ITO Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=4
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                    .not.Dipol.and..not.KE.and.JITO_exchange) Then
        Write(6,'(6A)') '                 ',
     &   '|       Lines  Model of Interaction   | ',
     &   '|          ITO Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=3
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                         Dipol.and..not.KE.and.JITO_exchange) Then
        Write(6,'(6A)') '                 ',
     &   '|       Lines  Model of Interaction   | ',
     &   '|      Dipolar Magnetic Interaction   | ',
     &   '|          ITO Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=4
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                         .not.Dipol.and.KE.and.JITO_exchange) Then
        Write(6,'(6A)') '                 ',
     &   '|       Lines  Model of Interaction   | ',
     &   '|      Kinetic Exchange Interaction   | ',
     &   '|          ITO Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=4
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                              Dipol.and.KE.and.JITO_exchange) Then
        Write(6,'(6A)') '                 ',
     &   '|       Lines  Model of Interaction   | ',
     &   '|      Dipolar Magnetic Interaction   | ',
     &   '|      Kinetic Exchange Interaction   | ',
     &   '|          ITO Exchange Interaction   | ',
     &   '|       TOTAL  Magnetic Interaction   | '
        lpr=5

      End If
      Write(6,'(110A)') '-----------------',
     & ('|-----  Real  ---------  Imaginary  --| ',i=1,lpr)

      Do nb1 = 1,exch
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,  H1,1)
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,  H2,1)
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,  H3,1)
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,  H4,1)
        Call zcopy_(exch,[(0.0_wp,0.0_wp)],0,HTOT,1)
        Do lp = 1,npair
          icoord(:)=0
          Do i = 1,lmax
            icoord(i) = ibas(nb1,i)
          End Do

          lb1 = i_pair(lp ,1)
          lb2 = i_pair(lp ,2)
          i1  =   nind(lb1,1)
          i2  =   nind(lb2,1)
          is1 = icoord(lb1) + 1
          is2 = icoord(lb2) + 1

          Do js1 = 1, nexch(i1)
            icoord(lb1) = js1 - 1
            Do js2 = 1, nexch(i2)
              icoord(lb2) = js2 - 1
              nb2 = norder(icoord,intc,lmax)

              H1(nb2)=H1(nb2)+HLIN1(lp,is1,js1,is2,js2)
     &                       +HLIN3(lp,is1,js1,is2,js2)
     &                       +HLIN9(lp,is1,js1,is2,js2)

              H2(nb2)=H2(nb2)+HDIP(lp,is1,js1,is2,js2)

              H3(nb2)=H3(nb2)+HKEX(lp,is1,js1,is2,js2)

              H4(nb2)=H4(nb2)+HITO(lp,is1,js1,is2,js2)

              HTOT(nb2)=HTOT(nb2)+HLIN1(lp,is1,js1,is2,js2)
     &                           +HLIN3(lp,is1,js1,is2,js2)
     &                           +HLIN9(lp,is1,js1,is2,js2)
     &                            +HDIP(lp,is1,js1,is2,js2)
     &                            +HKEX(lp,is1,js1,is2,js2)
     &                            +HDMO(lp,is1,js1,is2,js2)
     &                            +HITO(lp,is1,js1,is2,js2)

            End Do ! js2
          End Do ! js1
        End Do ! lp

        If(.not.KE) Then
          l=0
          lb=1
          Do i = 1, nneq
            Do j = 1, neq(i)
              l = l + 1
              If( l.eq.lb ) Then
                HTOT(nb1)=HTOT(nb1)+
     &                          cmplx(eso(i,ibas(nb1,lb)+1),0.0_wp,wp)
                If((lb+1).le.(lmax)) lb=lb+1
              End If
            End Do !j
          End Do !i
        End If !.not.KE
c all matrices for HEXCH( Nb1, xxx) are known:
c proceed to print
        If ((AnisoLines1.or.AnisoLines3.or.AnisoLines9)
     &                                        .and.Dipol.and.KE) Then
          Do nb2=nb1,exch
            If( (abs(H1(nb2)).gt.0.0_wp).or.(abs(H2(nb2)).gt.0.0_wp).or.
     &          (abs(H3(nb2)).gt.0.0_wp).or.(abs(HTOT(nb2)).gt.0.0_wp) )
     &                                                            Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H1(nb2), H2(nb2), H3(nb2), HTOT(nb2)
            End If
          End Do

        Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.Dipol
     &                                               .and..not.KE ) Then
          Do nb2=nb1,exch
            If( (abs(H1(nb2)).gt.0.0_wp).or.(abs(H2(nb2)).gt.0.0_wp).or.
     &          (abs(HTOT(nb2)).gt.0.0_wp) ) Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H1(nb2), H2(nb2), HTOT(nb2)
            End If
          End Do

        Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                                         .not.Dipol .and.KE ) Then
          Do nb2=nb1,exch
            If( (abs(H1(nb2)).gt.0.0_wp).or.(abs(H3(nb2)).gt.0.0_wp).or.
     &          (abs(HTOT(nb2)).gt.0.0_wp) ) Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H1(nb2), H3(nb2), HTOT(nb2)
            End If
          End Do

        Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                                               Dipol.and.KE ) Then
          Do nb2=nb1,exch
            If( (abs(H2(nb2)).gt.0.0_wp).or.(abs(H3(nb2)).gt.0.0_wp).or.
     &          (abs(HTOT(nb2)).gt.0.0_wp) ) Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H2(nb2), H3(nb2), HTOT(nb2)
            End If
          End Do

        Else If( (AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                                    .not.Dipol.and..not.KE ) Then
          Do nb2=nb1,exch
            If( (abs(H1(nb2)).gt.0.0_wp).or.(abs(HTOT(nb2)).gt.0.0_wp) )
     &                                                            Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H1(nb2), HTOT(nb2)
            End If
          End Do

        Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                                        Dipol.and..not.KE ) Then
          Do nb2=nb1,exch
            If( (abs(H2(nb2)).gt.0.0_wp).or.(abs(HTOT(nb2)).gt.0.0_wp) )
     &                                                            Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H2(nb2), HTOT(nb2)
            End If
          End Do

        Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9)
     &                                  .and..not.Dipol.and. KE ) Then
          Do nb2=nb1,exch
            If( (abs(H3(nb2)).gt.0.0_wp).or.(abs(HTOT(nb2)).gt.0.0_wp) )
     &                                                            Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H3(nb2), HTOT(nb2)
            End If
          End Do
! JITO is active below:
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                    .not.Dipol.and..not.KE.and.JITO_exchange) Then
          Do nb2=nb1,exch
            If( (abs(H4(nb2)).gt.0.0_wp).or.(abs(HTOT(nb2)).gt.0.0_wp) )
     &                                                            Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H4(nb2), HTOT(nb2)
            End If
          End Do
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                         Dipol.and..not.KE.and.JITO_exchange) Then
          Do nb2=nb1,exch
            If( (abs(H2(nb2)).gt.0.0_wp).or.(abs(H4(nb2)).gt.0.0_wp).or.
     &          (abs(HTOT(nb2)).gt.0.0_wp) ) Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H2(nb2), H4(nb2), HTOT(nb2)
            End If
          End Do
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                         .not.Dipol.and.KE.and.JITO_exchange) Then
          Do nb2=nb1,exch
            If( (abs(H3(nb2)).gt.0.0_wp).or.(abs(H4(nb2)).gt.0.0_wp).or.
     &          (abs(HTOT(nb2)).gt.0.0_wp) ) Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H3(nb2), H4(nb2), HTOT(nb2)
            End If
          End Do
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                              Dipol.and.KE.and.JITO_exchange) Then
          Do nb2=nb1,exch
            If( (abs(H2(nb2)).gt.0.0_wp).or.(abs(H3(nb2)).gt.0.0_wp).or.
     &          (abs(H4(nb2)).gt.0.0_wp).or.(abs(HTOT(nb2)).gt.0.0_wp) )
     &                                                              Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H2(nb2), H3(nb2), H4(nb2), HTOT(nb2)
            End If
          End Do
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                    .not.Dipol.and..not.KE.and.JITO_exchange) Then
          Do nb2=nb1,exch
            If( (abs(H1(nb2)).gt.0.0_wp).or.(abs(H4(nb2)).gt.0.0_wp).or.
     &          (abs(HTOT(nb2)).gt.0.0_wp) ) Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H1(nb2), H4(nb2), HTOT(nb2)
            End If
          End Do
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                         Dipol.and..not.KE.and.JITO_exchange) Then
          Do nb2=nb1,exch
            If( (abs(H1(nb2)).gt.0.0_wp).or.(abs(H2(nb2)).gt.0.0_wp).or.
     &          (abs(H4(nb2)).gt.0.0_wp).or.(abs(HTOT(nb2)).gt.0.0_wp) )
     &                                                              Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H1(nb2), H2(nb2), H4(nb2), HTOT(nb2)
            End If
          End Do
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                         .not.Dipol.and.KE.and.JITO_exchange) Then
          Do nb2=nb1,exch
            If( (abs(H1(nb2)).gt.0.0_wp).or.(abs(H3(nb2)).gt.0.0_wp).or.
     &          (abs(H4(nb2)).gt.0.0_wp).or.(abs(HTOT(nb2)).gt.0.0_wp) )
     &                                                              Then
               Write(6,'(A,i4,A,i4,A,4(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H1(nb2), H3(nb2), H4(nb2), HTOT(nb2)
            End If
          End Do
      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &                              Dipol.and.KE.and.JITO_exchange) Then
          Do nb2=nb1,exch
            If( (abs(H1(nb2)).gt.0.0_wp).or.(abs(H2(nb2)).gt.0.0_wp).or.
     &          (abs(H3(nb2)).gt.0.0_wp).or.(abs(H4(nb2)).gt.0.0_wp).or.
     &          (abs(HTOT(nb2)).gt.0.0_wp) ) Then
               Write(6,'(A,i4,A,i4,A,5(2E19.11,2x))')
     &                  '<',nb1,'| H |',nb2,'> =',
     &                  H1(nb2), H2(nb2), H3(nb2), H4(nb2), HTOT(nb2)
            End If
          End Do
      End If

      End Do !nb1

      Write(6,'(10A)') '-----------------',
     & ('|-------------------------------------| ',i=1,lpr)

!=======================================================================
! deallocate memory
      If(exch>=0) Then
        Call mma_deallocate(htot)
        Call mma_deallocate(h1)
        Call mma_deallocate(h2)
        Call mma_deallocate(h3)
        Call mma_deallocate(h4)
      End If


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Dresselhaus                                     *
!***********************************************************************

subroutine EmbPotKernel( &
#                       define _CALLING_
#                       include "int_interface.fh"
                       )
!***********************************************************************
!                                                                      *
! Object: kernel routine to calculate integrals over an embedding      *
!         potential on a grid.                                         *
!                                                                      *
! Called from: OneEl                                                   *
!                                                                      *
!     Author: Thomas Dresselhaus                                       *
!                                                                      *
!***********************************************************************

use Embedding_Global, only: embDebug, nEmbGridPoints, embGridCoord, embPotVal, embWeight
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
integer(kind=iwp) :: i, j, ia, ib, m, ix, iy, iz, nShellA, nShellB
! dRA, dRB: distance of the current grid point to A/B
real(kind=wp) :: dRA(3), dRB(3), prefactor
real(kind=wp), allocatable :: radA(:), radB(:), sphA(:), sphB(:)
real(kind=wp), external :: gaussRad

#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(P)
unused_var(nIC)
unused_var(nHer)
unused_var(Array)
unused_var(Ccoor)
unused_var(nOrdOp)
unused_var(lOper)
unused_var(iCho)
unused_var(iStabM)
unused_var(PtChrg)
unused_var(nGrid)
unused_var(iAddPot)

!***** Initialization **************************************************

nShellA = (la+1)*(la+2)/2
nShellB = (lb+1)*(lb+2)/2

! Intermediate arrays, radial and angular part of gaussians
call mma_allocate(radA,nAlpha,label='radA')
call mma_allocate(radB,nBeta,label='radB')
call mma_allocate(sphA,nShellA,label='sphA')
call mma_allocate(sphB,nShellB,label='sphB')

!***** Calculation *****************************************************

! Init result var
rFinal(:,:,:,:) = Zero

! Now loop over grid points first
do m=1,nEmbGridPoints
  ! Calculate distances from gaussian centers to current grid point
  do i=1,3
    dRA(i) = embGridCoord(i,m)-A(i)
    dRB(i) = embGridCoord(i,m)-RB(i)
  end do

  prefactor = embPotVal(m)*embWeight(m)

  ! Precalculate radial factors
  do ia=1,nAlpha
    radA(ia) = gaussRad(Alpha(ia),dRA)
  end do

  do ib=1,nBeta
    radB(ib) = gaussRad(Beta(ib),dRB)
  end do

  ! Precalculate spherial factors
  ! shell A
  i = 0
  do ix=la,0,-1
    do iy=la-ix,0,-1
      iz = la-ix-iy
      i = i+1
      sphA(i) = dRA(1)**ix*dRA(2)**iy*dRA(3)**iz
    end do
  end do
  ! shell B
  i = 0
  do ix=lb,0,-1
    do iy=lb-ix,0,-1
      iz = lb-ix-iy
      i = i+1
      sphB(i) = dRB(1)**ix*dRB(2)**iy*dRB(3)**iz
    end do
  end do

  ! Put them together
  do ia=1,nAlpha
    do ib=1,nBeta
      do i=1,nShellA
        do j=1,nShellB
          rFinal(ia,ib,i,j) = rFinal(ia,ib,i,j)+(prefactor*radA(ia)*radB(ib)*sphA(i)*sphB(j))
        end do
      end do
    end do
  end do

  if (embDebug) then
    if (mod(m,587) == 0) then
      write(u6,*) '-------------------------------------------------'
      write(u6,*) 'm=',m
      write(u6,*) 'A=',A(:)
      write(u6,*) 'r=',embGridCoord(:,m)
      write(u6,*) 'dRA=',dRA(1),dRA(2),dRA(3)
      write(u6,*) 'Alpha(1)=',Alpha(1),'; gaussRad(...)=',gaussRad(Alpha(1),dRA)
      write(u6,*) '-------------------------------------------------'
      write(u6,*) 'm=',m,'prefactor=',prefactor
      write(u6,*) 'radA(1)=',radA(1),'; sphA(1)=',sphA(1),', radB(2)=',radB(2),'; sphB(2)=',sphB(2)
      write(u6,*) '-------------------------------------------------'
    end if
  end if

end do ! m, grid point

if (embDebug) then
  write(u6,*) '-------------------------------------------------'
  do ia=1,nAlpha
    do ib=1,nBeta
      do i=1,nShellA
        do j=1,nShellB
          write(u6,*) rFinal(ia,ib,i,j)
        end do
      end do
    end do
  end do
  !write(u6,*) 'rFinal(1,1,1,1)=',rFinal(1,1,1,1),'; rFinal(1,2,1,2)=',rFinal(1,2,1,2)
  write(u6,*) '-------------------------------------------------'
  write(u6,*) '-------------------------------------------------'
end if

!***** Done. Tidy up. **************************************************

call mma_deallocate(radA)
call mma_deallocate(radB)
call mma_deallocate(sphA)
call mma_deallocate(sphB)

return

end subroutine EmbPotKernel

!***********************************************************************
! Returns the radial part of the value of a GTO with given exponent,   *
! centered at the origin.                                              *
!***********************************************************************
function gaussRad(alpha,r)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: gaussRad
real(kind=wp), intent(in) :: alpha, r(3)
integer(kind=iwp) :: i
real(kind=wp) :: rSquare

rSquare = Zero
do i=1,3
  rSquare = rSquare+r(i)**2
end do

! Radial part
gaussRad = exp(-alpha*rSquare)

return

end function gaussRad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine saamphlp2(t2aaaa,t2bbbb,t2abab,t2baba,t2abba,t2baab,noai,noaj,nobi,nobj,nvaa,nvab,nvba,nvbb,key)
! adaptation routine for T2 amplitudes for symi>symj, syma>symb
!
! t2aaaa - amplitudes T2(a,b,i,j)aaaa (I/O)
! t2bbbb - amplitudes T2(a,b,i,j)bbbb (I/O)
! t2abab - amplitudes T2(a,b,i,j)abab (I/O)
! t2baba - amplitudes T2(b,a,j,i)abab (I/O)
! t2abba - amplitudes T2(b,a,i,j)abab (I/O)
! t2baab - amplitudes T2(a,b,j,i)abab (I/O)
! noai   - number of alpha occupied orbitals in symi (I)
! noaj   - number of alpha occupied orbitals in symj (I)
! nobi   - number of beta occupied orbitals in symi (I)
! nobj   - number of beta occupied orbitals in symj (I)
! nvaa   - number of alpha virtual orbitals in syma (I)
! nvab   - number of alpha virtual orbitals in symb (I)
! nvba   - number of beta virtual orbitals in syma (I)
! nvbb   - number of beta virtual orbitals in symb (I)
! key    - type of adaptation (I)
!          0 - no adaptation
!          1 - T2 DDVV adaptation
!          2 - T2 DDVV + T1 DV adaptation
!          3 - full T1 and T2 adaptation (only for doublets)
!          4 - full T2 without SDVS (only for doublets)

use Constants, only: Two, Six, Half, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: noai, noaj, nobi, nobj, nvaa, nvab, nvba, nvbb, key
real(kind=wp), intent(inout) :: t2aaaa(nvaa,nvab,noai,noaj), t2bbbb(nvba,nvbb,nobi,nobj), t2abab(nvaa,nvbb,noai,nobj), &
                                t2baba(nvab,nvba,noaj,nobi), t2abba(nvab,nvba,noai,nobj), t2baab(nvaa,nvbb,noaj,nobi)
integer(kind=iwp) :: a, b, i, j, ndi, ndj, nsa, nsb, nsi, nsj, nva, nvb
real(kind=wp) :: t1, t2, taaaa, tabab, tabba, tbaab, tbaba, tbbbb

if (key == 0) return

ndi = nobi
ndj = nobj
nva = nvaa
nvb = nvab
nsi = noai-nobi
nsj = noaj-nobj
nsa = nvba-nvaa
nsb = nvbb-nvab

! T2 adaptation
!
! case I) DDVV i>=j,a>=b
! turn od in any case of type of adaptation
!
! aaaa=t24a(ijab) DDVV
! bbbb=t24b(ijab) DDVV
! abab=t22b(ijab) DDVV
! abba=-t22b(ijba) DDVV
! baab=-t22b(jiab) DDVV
! baba=t22b(ji,ba) DDVV
!
! direct
! t1 = (abab+baba-abba-baab)/4
! t2 = (2aaaa+2bbbb+abab+baba+abba+baab)/12
!
! reverse
!
! aaaa = 2t2
! bbbb = 2t2
! abab = t2+t1
! abba = t2-t1
! baab = t2-t1
! baba = t2+t1

do j=1,ndj
  do i=1,ndi
    do b=1,nvb
      do a=1,nva

        taaaa = t2aaaa(a,b,i,j)
        tbbbb = t2bbbb(a+nsa,b+nsb,i,j)
        tabab = t2abab(a,b+nsb,i,j)
        tbaba = t2baba(b,a+nsa,j,i)
        tabba = -t2abba(b,a+nsa,i,j)
        tbaab = -t2baab(a,b+nsb,j,i)

        t1 = Quart*(tabab+tbaba-tabba-tbaab)
        t2 = (Two*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/12.0_wp

        taaaa = Two*t2
        tbbbb = Two*t2
        tabab = t1+t2
        tbaba = t1+t2
        tabba = t2-t1
        tbaab = t2-t1

        t2aaaa(a,b,i,j) = taaaa
        t2bbbb(a+nsa,b+nsb,i,j) = tbbbb
        t2abab(a,b+nsb,i,j) = tabab
        t2baba(b,a+nsa,j,i) = tbaba
        t2abba(b,a+nsa,i,j) = -tabba
        t2baab(a,b+nsb,j,i) = -tbaab

      end do
    end do
  end do
end do

if (((key == 3) .or. (key == 4)) .and. (nsb > 0)) then

  ! case II) DDVS
  !
  ! bbbb = t24b(ij,ab)
  ! abab = t22b(i,j,a,b)
  ! baab =-t22b(j,i,a,b)
  !
  ! direct :
  !
  ! t1=(abab-baab)/2
  ! t2=(2bbbb+abab+baab)/6
  !
  ! reverse:
  !
  ! bbbb = 2t2
  ! abab = t2+t1
  ! baab = t2-t1

  b = nsb
  do j=1,ndj
    do i=1,ndi
      do a=1,nva

        tbbbb = t2bbbb(a+nsa,b,i,j)
        tabab = t2abab(a,b,i,j)
        tbaab = -t2baab(a,b,j,i)

        t1 = Half*(tabab-tbaab)
        t2 = (Two*tbbbb+tabab+tbaab)/Six

        tbbbb = Two*t2
        tabab = t2+t1
        tbaab = t2-t1

        t2bbbb(a+nsa,b,i,j) = tbbbb
        t2abab(a,b,i,j) = tabab
        t2baab(a,b,j,i) = -tbaab

      end do
    end do
  end do

end if

if (((key == 3) .or. (key == 4)) .and. (nsa > 0)) then

  ! case III) DDSV
  !
  ! bbbb = - t24b(ij,ab)
  ! abab = - -t22b(i,j,b,a)
  ! baab = - t22b(j,i,b,a)
  !
  ! direct :
  !
  ! t1=(abab-baab)/2
  ! t2=(2bbbb+abab+baab)/6
  !
  ! reverse:
  !
  ! bbbb = 2t2
  ! abab = t2+t1
  ! baab = t2-t1

  a = nsa
  do j=1,ndj
    do i=1,ndi
      do b=1,nvb

        tbbbb = -t2bbbb(a,b+nsb,i,j)
        tabab = t2abba(b,a,i,j)
        tbaab = -t2baba(b,a,j,i)

        t1 = Half*(tabab-tbaab)
        t2 = (Two*tbbbb+tabab+tbaab)/Six

        tbbbb = Two*t2
        tabab = t2+t1
        tbaab = t2-t1

        t2bbbb(a,b+nsb,i,j) = -tbbbb
        t2abba(b,a,i,j) = tabab
        t2baba(b,a,j,i) = -tbaab

      end do
    end do
  end do

end if

if (((key == 3) .or. (key == 4)) .and. (nsi > 0)) then

  ! case IV) SDVV
  !
  ! aaaa=t24a(ij,ab)
  ! abab=t22b(i,j,a,b)
  ! abba=-t22b(i,j,b,a)
  !
  ! direct
  !
  ! t1=(abab-abba)/2
  ! t2=(2aaaa+abab+abba)/6
  !
  ! reverse
  !
  ! aaaa=2t2
  ! abab=t2+t1
  ! abba=t2-t1

  i = ndi+nsi
  do j=1,ndj
    do b=1,nvb
      do a=1,nva

        taaaa = t2aaaa(a,b,i,j)
        tabab = t2abab(a,b+nsb,i,j)
        tabba = -t2abba(b,a+nsa,i,j)

        t1 = Half*(tabab-tabba)
        t2 = (Two*taaaa+tabab+tabba)/Six

        taaaa = TWo*t2
        tabab = t2+t1
        tabba = t2-t1

        t2aaaa(a,b,i,j) = taaaa
        t2abab(a,b+nsb,i,j) = tabab
        t2abba(b,a+nsa,i,j) = -tabba

      end do
    end do
  end do

end if

if (((key == 3) .or. (key == 4)) .and. (nsj > 0)) then

  ! case V) DSVV
  !
  ! aaaa= - t24a(ij,ab)
  ! abab= - -t22b(j,i,a,b)
  ! abba= - t22b(j,i,b,a)
  !
  ! direct
  !
  ! t1=(abab-abba)/2
  ! t2=(2aaaa+abab+abba)/6
  !
  ! reverse
  !
  ! aaaa=2t2
  ! abab=t2+t1
  ! abba=t2-t1

  j = ndj+nsj
  do i=1,ndi
    do b=1,nvb
      do a=1,nva

        taaaa = -t2aaaa(a,b,i,j)
        tabab = t2baab(a,b+nsb,j,i)
        tabba = -t2baba(b,a+nsa,j,i)

        t1 = Half*(tabab-tabba)
        t2 = (Two*taaaa+tabab+tabba)/Six

        taaaa = Two*t2
        tabab = t2+t1
        tabba = t2-t1

        t2aaaa(a,b,i,j) = -taaaa
        t2baab(a,b+nsb,j,i) = tabab
        t2baba(b,a+nsa,j,i) = -tabba

      end do
    end do
  end do

end if

return

end subroutine saamphlp2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  NormalizeVec
*
*> @brief
*>   Normalize the vector \p V
*> @author Y. Carissan
*>
*> @details
*> Normalize the vector \p V.
*>
*> @param[in,out] V Vector to be normalized
************************************************************************
      subroutine normalizeVec(V)
      Implicit none
#include "WrkSpc.fh"
#include "debug.fh"

      Real*8 V(3)
      Real*8 norm,dnrm2_
      External dnrm2_
      Integer i

      norm=dnrm2_(3,V,1)
      Do i=1,3
        V(i)=V(i)/norm
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function ifns_cvb(nel1,nalf1,kbasis1)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ifns_cvb
integer(kind=iwp), intent(in) :: nel1, kbasis1
integer(kind=iwp), intent(inout) :: nalf1
integer(kind=iwp) :: ifn, iretval1, iretval2, nbet1, nsw

nbet1 = nel1-nalf1
if (nbet1 > nalf1) then
  nsw = nalf1
  nalf1 = nbet1
  nbet1 = nsw
end if
if (kbasis1 /= 6) then
  call icomb_cvb(nel1,nbet1,iretval1)
  call icomb_cvb(nel1,nbet1-1,iretval2)
  ifn = iretval1-iretval2
else
  call icomb_cvb(nel1,nalf1,ifn)
  if (nalf1 == nbet1) ifn = (ifn+1)/2
end if
ifns_cvb = ifn

return

end function ifns_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHO_FOCK_RASSI_X(ipDLT,ipMO1,ipMO2,ipFLT,ipK,ipInt)

**********************************************************************
*  Author : F. Aquilante
*
*
*  Note:  this routine differs from CHO_FOCK_RASSI because it can
*         handle ALSO the case where the 2 sets of MOs are different!
*         The Exchange contribution is non-symmetric and so is FI
*
C *************** INACTIVE AO-BASIS FOCK MATRIX **********************
C
C   FI(ab) = 2 * sum_J  Lab,J * U(J)  -  sum_Jk  Yka,J * Xkb,J
C
C      U(J) = sum_gd  Lgd,J * DI(gd)
C
C      a,b,g,d:  AO-index
C      k:        MO-index   belonging to (Inactive)
C      v,w,x,y:  MO-indeces belonging to (Active)
C
**********************************************************************

      Implicit Real*8 (a-h,o-z)

      Integer   rc,ipLxy(8),ipScr(8,8)
      Integer   ipLab(8,2),ipOrb(8,2),nOrb(8,2)
      Integer   iSkip(8)
      Integer   ISTLT(8), ISTSQ(8)
      Real*8    tread(2),tcoul(2),texch(2),tintg(2)
      Integer   ipAorb(8,2)
      Logical   Debug,timings,DoRead,DoReord
      Character*50 CFmt
      Character*16 SECNAM
      Parameter (SECNAM = 'CHO_FOCK_RASSI_X')
      COMMON    /CHOTIME /timings

      parameter (DoRead = .false. )
      parameter (FactCI = 1.0D0, FactXI = -1.0D0)
      parameter (zero = 0.0D0, one = 1.0D0, two = 2.0D0)
      Character*6 mode
      Logical Fake_CMO2
      COMMON / CHO_JOBS / Fake_CMO2

#include "rassi.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )

**************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
**************************************************


#ifdef _DEBUGPRINT_
c      Debug=.true.
      Debug=.false.! to avoid double printing in CASSCF-debug
#else
      Debug=.false.
#endif


      DoReord = .false.
      IREDC = -1  ! unknown reduced set in core

      nDen=2
      If (Fake_CMO2) nDen = 1  ! MO1 = MO2
      kDen=nDen

      CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

      do i=1,2            ! 1 --> CPU   2 --> Wall
         tread(i) = zero  !time read/transform vectors
         tcoul(i) = zero  !time for computing Coulomb
         texch(i) = zero  !time for computing Exchange
         tintg(i) = zero  !time for computing (tw|xy) integrals
      end do

C ==================================================================

c --- Various offsets
c --------------------
      ISTLT(1)=0
      ISTSQ(1)=0
      DO ISYM=2,NSYM
        NB=NBAS(ISYM-1)
        NBB=NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NBB ! Inactive Coul matrix
        ISTSQ(ISYM)=ISTSQ(ISYM-1)+NB**2 ! Inactive Exch matrix
      END DO

      ipOrb(1,1) = ipMO1
      ipOrb(1,2) = ipMO2

      DO jDen=1,nDen

         nOrb(1,jDen)  = nIsh(1)
         ipAorb(1,jDen)= ipOrb(1,jDen)
     &                 + nOrb(1,jDen)*NBAS(1)

         DO ISYM=2,NSYM

            ipOrb(iSym,jDen) = ipAorb(iSym-1,jDen)
     &                       + nAsh(iSym-1)*NBAS(iSym-1)

            nOrb(iSym,jDen)  = nIsh(iSym)

            ipAorb(iSym,jDen)= ipOrb(iSym,jDen)
     &                       + nOrb(iSym,jDen)*NBAS(iSym)

         END DO

      END DO

C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
      DO jSym=1,nSym

        If (NumCho(jSym).lt.1) GOTO 1000

C *** memory for the (tw|xy) integrals --- temporary array
      Mtwxy = 0
      Do iSymy=1,nSym
         iSymx=MulD2h(iSymy,JSYM)
         Do iSymw=iSymy,nSym    ! iSymw.ge.iSymy (particle symmetry)
            iSymt=MulD2h(isymw,JSYM)
            Mtwxy=Mtwxy+nAsh(iSymt)*nAsh(iSymw)*nAsh(iSymx)*nAsh(iSymy)
         End Do
      End Do

      Call GetMem('Mtmp','ALLO','REAL',ipItmp,Mtwxy)
      Call Fzero(Work(ipItmp),Mtwxy)

C *** setup pointers to the symmetry blocks of (tw|xy)
      Do i=1,nSym
         Do j=1,nSym
            ipScr(j,i) = ipItmp
         End Do
      End Do

      kScr=ipItmp
      Do iSymy=1,nSym
         iSymx=MulD2h(iSymy,JSYM)
         Do iSymw=iSymy,nSym   ! iSymw.ge.iSymy (particle symmetry)
            iSymt=MulD2h(isymw,JSYM)
            ipScr(iSymw,iSymy) = kScr
            kScr=kScr+nAsh(iSymt)*nAsh(iSymw)*nAsh(iSymx)*nAsh(iSymy)
         End Do
      End Do


      iLoc = 3 ! use scratch location in reduced index arrays

C ****************     MEMORY MANAGEMENT SECTION    *****************
C ------------------------------------------------------------------
C --- compute memory needed to store at least 1 vector of JSYM
C --- and do all the subsequent calculations
C ------------------------------------------------------------------
         mTvec = 0  ! mem for storing the half-transformed vec
         mTTvec= 0  ! mem for Lvb,J and Lvw,J
         do l=1,nSym
            k=Muld2h(l,JSYM)
            mTvec = mTvec + nDen*nBas(l)*nIsh(k)
            mTTvec = mTTvec + (nBas(l)+nAsh(l))*nAsh(k)
         end do

         mTvec=Max(mTvec,mTTvec,1)

C ------------------------------------------------------------------
C ------------------------------------------------------------------

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

         Do JRED=JRED1,JRED2

            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               call abend()
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.',
     &                        '   rc= ',irc
              call abend()
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            If(JSYM.eq.1)Then

               Call GetMem('rsDtot','Allo','Real',ipDab,nRS)
               Call GetMem('rsFC','Allo','Real',ipFab,nRS)
               Call Fzero(Work(ipDab),nRS)
               Call Fzero(Work(ipFab),nRS)
            EndIf

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec  = Min(LWORK/(nRS+mTvec),nVrs)

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) 'LWORK= ',LWORK
               WRITE(6,*) 'min. mem. need= ',nRS+mTvec
               WRITE(6,*) 'jsym= ',jsym
               rc = 33
               CALL Abend()
               nBatch = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
            Call GetMem('ChoT','Allo','Real',ipChoT,mTvec*nVec)

            If(JSYM.eq.1)Then
C --- Transform the density to reduced storage
               mode = 'toreds'
               Call swap_sto(irc,iLoc,ipDLT,ISTLT,ipDab,mode)
            EndIf

C --- BATCH over the vectors ----------------------------

            nBatch = (nVrs-1)/nVec + 1

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM ) then
                  rc=77
                  write(6,*)'return code = ',rc
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

               If(JSYM.eq.1)Then
C ************ (alpha+beta) COULOMB CONTRIBUTION  ****************
C
C --- Contraction with the density matrix
C ---------------------------------------
C --- V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * DI(rs)
C==========================================================
C
                  CALL CWTIME(TCC1,TWC1)

                  ipVJ = ipChoT

                  CALL DGEMV_('T',nRS,JNUM,
     &                 ONE,Work(ipLrs),nRS,
     &                 Work(ipDab),1,ZERO,Work(ipVJ),1)

C --- FI(rs){#J} <- FI(rs){#J} + FactCI * sum_J L(rs,{#J})*V{#J}
C===============================================================

                  Fact = dble(min(jVec-iVrs,1))

                  CALL DGEMV_('N',nRS,JNUM,
     &                 FactCI,Work(ipLrs),nRS,
     &                 Work(ipVJ),1,Fact,Work(ipFab),1)


                  CALL CWTIME(TCC2,TWC2)
                  tcoul(1) = tcoul(1) + (TCC2 - TCC1)
                  tcoul(2) = tcoul(2) + (TWC2 - TWC1)

               EndIf  ! Coulomb contribution


C *************** EXCHANGE CONTRIBUTIONS  ***********************

C --- Set pointers to the half-transformed Cholesky vectors
               lChoT=0
               Do iSymb=1,nSym

                  iSymp = MulD2h(JSYM,iSymb)

                  Do jDen=1,nDen

                     ipLab(iSymp,jDen) = ipChoT + lChoT  ! LpJ,b

                     lChoT = lChoT + nIsh(iSymp)*nBas(iSymb)*JNUM

                  End Do

               End Do


               iSwap = 2  ! LpJ,b are returned

               CALL CWTIME(TCR3,TWR3)

               kMOs = 1
               nMOs = nDen

C --- Set up the skipping flags
C -------------------------------------------------------------
               Do i=1,nSym

                  k = Muld2h(i,JSYM)
                  iSkip(k) = Min(1,NBAS(i)*nIsh(k))

               End Do
C -------------------------------------------------------------


C *********************** HALF-TRANSFORMATION  ****************

               CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                            JSYM,iSwap,IREDC,nMOs,kMOs,ipOrb,nOrb,
     &                            ipLab,iSkip,DoRead)


               CALL CWTIME(TCR4,TWR4)
               tread(1) = tread(1) + (TCR4 - TCR3)
               tread(2) = tread(2) + (TWR4 - TWR3)

               if (irc.ne.0) then
                  rc = irc
                  write(6,*)'CHO_X_getVtra failed! '
                  RETURN
               endif

               CALL CWTIME(TCX1,TWX1)

               Do iSyma=1,nSym

                  iSymk = MulD2h(JSYM,iSyma)

C ---------------------------------------------------------------------
c *** Compute the InActive exchange matrix
C
C     FI(ab) = FI(ab) + FactXI * sum_Jk  X(2)kJ,a * X(1)kJ,b
C ---------------------------------------------------------------------
                  NK = nIsh(iSymk)

                  If (iSkip(iSymk).ne.0) Then

                     ISFI = ipK + ISTSQ(iSyma)

                     CALL DGEMM_('T','N',NBAS(iSyma),NBAS(iSyma),
     &                         NK*JNUM,FactXI,Work(ipLab(iSymk,kDen)),
     &                         NK*JNUM,Work(ipLab(iSymk,1)),NK*JNUM,
     &                             One,Work(ISFI),NBAS(iSyma))



                  EndIf

C --------------------------------------------------------------------
               End Do  !loop over MOs symmetries

               CALL CWTIME(TCX2,TWX2)
               texch(1) = texch(1) + (TCX2 - TCX1)
               texch(2) = texch(2) + (TWX2 - TWX1)


C ************  END EXCHANGE CONTRIBUTION  ****************


C --------------------------------------------------------------------
C --- First half Active transformation  Lvb,J = sum_a  C1(v,a) * Lab,J
C --------------------------------------------------------------------

               CALL CWTIME(TCR7,TWR7)

C --- Set pointers to the half-transformed Cholesky vectors
               lChoa=0
               Do iSymb=1,nSym

                  iSymp = MulD2h(JSYM,iSymb)

                  ipLab(iSymp,1) = ipChoT + lChoa  ! Lvb,J
                  ipLab(iSymp,2) = ipLab(iSymp,1)
     &                           + nAsh(iSymp)*nBas(iSymb)*JNUM

                  lChoa = lChoa
     &                  + nAsh(iSymp)*(nBas(iSymb)+nAsh(iSymb))*JNUM

               End Do

C --- Set up the skipping flags
C -------------------------------------------------------------
               Do i=1,nSym

                  k = Muld2h(i,JSYM)
                  iSkip(k) = Min(1,
     &                 NBAS(i)*nAsh(k))

               End Do

               iSwap = 0  ! Lvb,J are returned
               kMOs = 1  !
               nMOs = 1  ! Active MOs (1st set)

               CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                           JSYM,iSwap,IREDC,nMOs,kMOs,ipAorb,nAsh,
     &                           ipLab,iSkip,DoRead)

               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif


C --------------------------------------------------------------------
C --- Active-Active transformation  Lvw,J = sum_b  Lvb,J * C2(w,b)
C --------------------------------------------------------------------
                  Do iSymb=1,nSym

                     iSymv = MulD2h(JSYM,iSymb)
                     NAv = nAsh(iSymv)
                     NAw = nAsh(iSymb) ! iSymb=iSymw

                     If(NAv*NAw.ne.0)Then

                      Do JVC=1,JNUM

                       ipLvb = ipLab(iSymv,1) + NAv*NBAS(iSymb)*(JVC-1)
                       ipLvw = ipLab(iSymv,2)
     &                       + nAsh(iSymv)*nAsh(iSymb)*(JVC-1)

                       CALL DGEMM_('N','T',NAv,NAw,NBAS(iSymb),
     &                            One,Work(ipLvb),NAv,
     &                                Work(ipAorb(iSymb,kDen)),NAw,
     &                           Zero,Work(ipLvw),NAv)

                      End Do

                     EndIf

                  End Do


C
C
C *************** EVALUATION OF THE (TW|XY) INTEGRALS ***********

               CALL CWTIME(TCINT1,TWINT1)

               DoReord = JRED.eq.JRED2.and.iBatch.eq.nBatch

               Do iSym=1,nSym
                  ksym = mulD2h(iSym,JSYM)
                  ipLxy(kSym) = ipLab(iSym,2) ! switch to column storage
               End Do

               CALL CHO_rassi_twxy(irc,ipScr,ipLxy,ipInt,nAsh,
     &                                 JSYM,JNUM,DoReord)

               CALL CWTIME(TCINT2,TWINT2)
               tintg(1) = tintg(1) + (TCINT2 - TCINT1)
               tintg(2) = tintg(2) + (TWINT2 - TWINT1)

               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif

C ---------------- END (TW|XY) EVALUATION -----------------------


            END DO  ! end batch loop


            If(JSYM.eq.1)Then
c --- backtransform fock matrix to full storage
               mode = 'tofull'
               Call swap_sto(irc,iLoc,ipFLT,ISTLT,ipFab,mode)
            EndIf

C --- free memory
            Call GetMem('ChoT','Free','Real',ipChoT,mTvec*nVec)
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

            If(JSYM.eq.1)Then
              Call GetMem('rsFC','Free','Real',ipFab,nRS)
              Call GetMem('rsDtot','Free','Real',ipDab,nRS)
            EndIf


999         Continue

         END DO   ! loop over red sets

         Call GetMem('Mtmp','Free','REAL',ipItmp,Mtwxy)

1000  CONTINUE


      END DO  ! loop over JSYM

* --- Accumulate Coulomb and Exchange contributions
      Do iSym=1,nSym

         ipFI = ipFLT - 1 + ISTLT(iSym)
         ipKI = ipK -1 + ISTSQ(iSym)

         Do ia=1,nBas(iSym)
            Do ib=1,ia-1
               iabt = ipFI + ia*(ia-1)/2 + ib
               iabq = ipKI + nBas(iSym)*(ia-1) + ib
               Work(iabq)=Work(iabq)+Work(iabt)
               iabq = ipKI + nBas(iSym)*(ib-1) + ia
               Work(iabq)=Work(iabq)+Work(iabt)
            End Do
            iabt = ipFI + ia*(ia+1)/2
            iabq = ipKI + nBas(iSym)*(ia-1) + ia
            Work(iabq)=Work(iabq)+Work(iabt)
         End Do

      End Do



      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1


*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky RASSI timing from '//SECNAM
      Write(6,CFmt)'----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ/TRANSFORM VECTORS           '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB                          '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'EXCHANGE                         '
     &                           //'         ',texch(1),texch(2)
         Write(6,'(2x,A26,2f10.2)')'(TW|XY) INTEGRALS                '
     &                           //'         ',tintg(1),tintg(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


c Print the Fock-matrix
#ifdef _DEBUGPRINT_

      if(Debug) then !to avoid double printing in RASSI-debug

      WRITE(6,'(6X,A)')'TEST PRINT FROM '//SECNAM
      WRITE(6,'(6X,A)')
      DO ISYM=1,NSYM
        ISFI=ipK+ISTSQ(ISYM)
        IF( NBAS(ISYM).GT.0 ) THEN
          WRITE(6,'(6X,A)')'***** INACTIVE FOCK MATRIX ***** '
          WRITE(6,'(6X,A)')
          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
          call CHO_OUTPUT(Work(ISFI),1,NBAS(ISYM),1,NBAS(ISYM),
     &                    NBAS(ISYM),NBAS(ISYM),1,6)
        ENDIF
      END DO

      endif

#endif

      rc  = 0


      Return
      END

**************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine One_Int(Kernel,Array,nArray,A,iAng,iComp,nOrdOp,Scr1,nScr1,Scr2,nScr2,naa,SAR,nSAR,iShll_a,nPrim_a,Exp_a,nCntrc_a, &
                   Cff_a,iCmp_a,iShll_r,nPrim_r,Exp_r,nCntrc_r,Cff_r,iCmp_r)

use Basis_Info, only: Shells
use Real_Spherical, only: ipSph, RSph
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
external :: Kernel
integer(kind=iwp), intent(in) :: nArray, iAng, iComp, nOrdOp, nScr1, nScr2, naa, nSAR, iShll_a, nPrim_a, nCntrc_a, iCmp_a, &
                                 iShll_r, nPrim_r, nCntrc_r, iCmp_r
real(kind=wp), intent(out) :: Array(nArray), Scr1(nScr1), Scr2(nScr2), SAR(nSAR)
real(kind=wp), intent(in) :: A(3), Exp_a(nPrim_a), Cff_a(nPrim_a,nCntrc_a), Exp_r(nPrim_r), Cff_r(nPrim_r,nCntrc_r)
integer(kind=iwp) :: mArr, mSar, nHer
real(kind=wp), allocatable :: KAR(:), PAR(:,:), pSAR(:), ZAR(:), ZIAR(:)

mArr = nArray/(nPrim_a*nPrim_r)
call mma_allocate(ZAR,nPrim_a*nPrim_r,Label='ZAR')
call mma_allocate(ZIAR,nPrim_a*nPrim_r,Label='ZIAR')
call mma_allocate(KAR,nPrim_a*nPrim_r,Label='KAR')
call mma_allocate(PAR,nPrim_a*nPrim_r,3,Label='PAR')

mSAR = nPrim_a*nPrim_r*naa
call mma_allocate(pSAR,mSAR,Label='pSAR')

call ZXia(ZAR,ZIAR,nPrim_a,nPrim_r,Exp_a,Exp_r)
call SetUp1(Exp_a,nPrim_a,Exp_r,nPrim_r,A,A,KAR,PAR,ZIAR)

nHer = (2*iAng+2+nOrdOp)/2
call Kernel(Exp_a,nPrim_a,Exp_r,nPrim_r,ZAR,ZIAR,KAR,PAR,pSAR,nPrim_a*nPrim_r,iComp,iAng,iAng,A,A,nHer,Array,mArr,A,nOrdOp)

call mma_deallocate(ZAR)
call mma_deallocate(ZIAR)
call mma_deallocate(KAR)
call mma_deallocate(PAR)

call DGEMM_('T','N',nPrim_r*naa,nCntrc_a,nPrim_a,One,pSAR,nPrim_a,Cff_a,nPrim_a,Zero,Scr1,nPrim_r*naa)
call DGEMM_('T','N',naa*nCntrc_a,nCntrc_r,nPrim_r,One,Scr1,nPrim_r,Cff_r,nPrim_r,Zero,Scr2,naa*nCntrc_a)
#ifdef _DEBUGPRINT_
call RecPrt('S_AR in Cartesian',' ',Scr2,naa,nCntrc_a*nCntrc_r)
#endif

! Transform to spherical Gaussian if needed!

if (Shells(iShll_a)%Transf .or. Shells(iShll_r)%Transf) then

  call CarSph(Scr2,naa,nCntrc_a*nCntrc_r,pSAR,nScr2,RSph(ipSph(iAng)),iAng,Shells(iShll_a)%Transf,Shells(iShll_a)%Prjct, &
              RSph(ipSph(iAng)),iAng,Shells(iShll_r)%Transf,Shells(iShll_r)%Prjct,SAR,iCmp_a*iCmp_r)
else
  call DGeTmO(Scr2,naa,naa,nCntrc_a*nCntrc_r,SAR,nCntrc_a*nCntrc_r)
end if
call mma_deallocate(pSAR)
#ifdef _DEBUGPRINT_
call RecPrt('S_AR in Sphericals',' ',SAR,iCmp_a*iCmp_r,nCntrc_a*nCntrc_r)
#endif

return

end subroutine One_Int

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*
!> @brief Apply the resolvent of the diagonal of H0-E0 to a vector
!> @author Per-&Aring;ke Malmqvist, 1994
!>
!> @details
!> ::presdia stands for "parallel resolvent diagonal" and it applies
!> the resolvent of the diagonal of \f$ (H_0 - E_0) \f$ to a coefficient
!> vector stored at position \p IVEC on \p LUSOLV. The result is stored
!> in the vector at position \p JVEC. Furthermore, it computes the
!> "overlap" as \p IVEC squared divided by the resolvent.
!> The parallel part is taken care of in subroutine calls \p RHS_.
!> Potential shifts and modification of \f$ H_0 \f$ are considered
!> in ::rhs_resdia
!>
!> @param[in]    IVEC   Vector position to which the res is applied
!> @param[in]    JVEC   Vector position where the result is saved
!> @param[out]   OVLAPS Array containing the overlaps

subroutine PRESDIA(IVEC,JVEC,OVLAPS)

use EQSOLV, only: IDBMAT
use caspt2_global, only: LUSBT
use caspt2_module, only: MxCase, nASup, nInDep, nISup, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC
real(kind=wp), intent(inout) :: OVLAPS(0:8,0:MXCASE)
integer(kind=iwp) :: ICASE, ISYM, JD, lg_V, NAS, NIN, NIS
real(kind=wp) :: DOVL, OVL, OVLSUM, OVLTOT
real(kind=wp), allocatable :: BD(:), ID(:)

! Apply the resolvent of the diagonal part of H0 to a coefficient
! vector in vector nr. IVEC on LUSOLV. Put the results in vector
! nr. JVEC. Also compute overlaps, see OVLVEC for structure.

OVLTOT = Zero
OVLAPS(:,:) = Zero

do ICASE=1,13
  OVLSUM = Zero
  do ISYM=1,NSYM
    OVL = Zero
    NIN = NINDEP(ISYM,ICASE)
    if (NIN <= 0) cycle
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    ! Remember: NIN values in BDIAG, but must read NAS for correct
    ! positioning.
    call mma_allocate(BD,NAS,LABEL='BD')
    call mma_allocate(ID,NIS,LABEL='ID')

    ! Read the B matrix of each case
    JD = IDBMAT(ISYM,ICASE)
    call DDAFILE(LUSBT,2,BD,NAS,JD)
    call DDAFILE(LUSBT,2,ID,NIS,JD)

    call RHS_ALLO(NIN,NIS,lg_V)
    call RHS_READ(NIN,NIS,lg_V,ICASE,ISYM,IVEC)
    call RHS_RESDIA(NIN,NIS,lg_V,BD,ID,DOVL)

    OVL = OVL+DOVL

    call RHS_SAVE(NIN,NIS,lg_V,ICASE,ISYM,JVEC)
    call RHS_FREE(lg_V)

    call mma_deallocate(BD)
    call mma_deallocate(ID)
    OVLAPS(ISYM,0) = OVLAPS(ISYM,0)+OVL
    OVLSUM = OVLSUM+OVL
  end do
  OVLAPS(0,ICASE) = OVLSUM
  OVLTOT = OVLTOT+OVLSUM
end do
OVLAPS(0,0) = OVLTOT

end subroutine PRESDIA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine prtopt2_cvb(iopt1,ioptim,italter,noptim,
     >  iorts,ifxorb,ifxstr,idelstr)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "spinb_cvb.fh"
#include "WrkSpc.fh"
      parameter(nmeth=12)
      character*3 ayn
      character*8 methkw(nmeth)
      character*9 sbformat
      dimension iorts(2*norb*(norb-1)/2)
      dimension ifxorb(norb),ifxstr(nvb),idelstr(nvb)
      save methkw
      data methkw/'Fletcher','    TRIM','Trustopt','Davidson',
     >            '   Steep','  Vb2cas',' AugHess','AugHess2',
     >            '   Check',' dFletch','    None','Super-CI'/

      if(ifinish.eq.0)then
        if(ip(3).ge.1.or.(ip(3).eq.0.and.
     >    (iopt1.eq.0.or.italter.eq.1)))then
          if(noptim.eq.1)then
            write(6,'(/,a)')
     >        ' -- Starting optimization ------------------'
          else
            write(6,'(/,a,i3,a)')' -- Starting optimization - step',
     >      ioptim,' --------'
          endif
        endif
        if(ip(3).ge.1.and.(iopt1.eq.0.or.italter.eq.1))then
          if(icrit.eq.1)then
            write(6,'(/,a)')' Overlap-based optimization (Svb).'
          elseif(icrit.eq.2)then
            write(6,'(/,a)')' Energy-based optimization (Evb).'
          endif
          write(6,'(/,a,11x,a)')' Optimization algorithm:',
     >      methkw(imethod)
          write(6,'(a,i13)')' Maximum number of iterations:',mxiter
          ayn=' No'
          if(projcas)ayn='Yes'
          if(projcas)write(6,'(a,31x,a)')' Casproj:',ayn
          ayn=' No'
          if(projsym)ayn='Yes'
          if(projsym)write(6,'(a,31x,a)') ' Symproj:',ayn
          ayn=' No'
          sbformat='(a,19x,a)'
          write(sbformat(4:5),'(i2)')31-len_trim_cvb(spinb(kbasis))
          write(6,sbformat)' Spin basis:',
     >      spinb(kbasis)(1:len_trim_cvb(spinb(kbasis)))
          if(isaddle.gt.0)write(6,'(/,a,i9)')
     >      ' Saddle-point optimization, order:',isaddle
          if(nort.gt.0)then
            write(6,'(/,i4,a)')nort,' orthogonalization pairs defined :'
            write(6,6100)(ior,iorts(1+(ior-1)*2),
     >                        iorts(2+(ior-1)*2),ior=1,nort)
6100        format(3(i4,': ',i2,' -',i2))
          endif
          if(nfxorb.eq.norb)then
            write(6,'(/,a)')' All orbitals will be frozen.'
          elseif(nfxorb.gt.0)then
            write(6,'(/,a)')' Following orbitals will be frozen :'
            itmp = mstacki_cvb(nfxorb)
            ifx=0
            do 700 i=1,norb
            if(ifxorb(i).ge.0.and.ifxorb(i).le.norb)then
              ifx=ifx+1
              iwork(ifx+itmp-1)=i
            endif
700         continue
            nfxorb=ifx
            write(6,'(14i3)')(iwork(ii+itmp-1),ii=1,nfxorb)
            call mfreei_cvb(itmp)
          endif
          if(nfxvb.gt.0.and.lfxvb.eq.0)then
            write(6,'(/,a)')' Following structures will be frozen :'
            write(6,'(14i3)')(ifxstr(ii),ii=1,nfxvb)
          elseif(nfxvb.eq.0.and.lfxvb.eq.1)then
            write(6,'(/,a)')' All structures will be frozen.'
          elseif(nfxvb.gt.0.and.lfxvb.eq.1)then
            write(6,'(/,2a)')' Following structures coefficients',
     >        ' will be optimized :'
            write(6,'(14i3)')(ifxstr(ii),ii=1,nfxvb)
          endif
          if(nzrvb.gt.0.and.lzrvb.eq.0)then
            write(6,'(/,a)')' Following structures will be deleted :'
            write(6,'(14i3)')(idelstr(ii),ii=1,nzrvb)
          elseif(nzrvb.eq.0.and.lzrvb.eq.1)then
            write(6,'(/,a)')' All structures will be deleted.'
          elseif(nzrvb.gt.0.and.lzrvb.eq.1)then
            write(6,'(/,a)')' Following structures will not be',
     >        ' deleted :'
            write(6,'(14i3)')(idelstr(ii),ii=1,nzrvb)
          endif
          write(6,'(/,a)')
     >      ' -------------------------------------------'
        endif
        if(iopt1.eq.0.or.italter.eq.1)call tuneprint_cvb()
      elseif(ifinish.lt.3)then
        if(ip(3).ge.1.or.(ip(3).eq.0.and.
     >    (iopt1.eq.0.or.italter.eq.1)))then
          if(noptim.eq.1)then
            write(6,'(/,a)')
     >        ' -- Wavefunction summary -------------------'
          else
            write(6,'(/,a,i3,a)')' -- Wavefunction summary - step',
     >        ioptim,' ---------'
          endif
        endif
      endif
      return
      end
c  ******************************************
c  ** Highest-level input parsing routines **
c  ******************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mxunit_cvb(a,n)
      implicit real*8 (a-h,o-z)
      dimension a(n,n)
      save one
      data one/1d0/

      call fzero(a,n*n)
      do 100 i=1,n
      a(i,i)=one
100   continue
      return
      end
      logical function mxorth_cvb(a,n)
c  Returns .TRUE. if A is orthogonal.
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension a(n,n)
      save thresh,one
      data thresh/1d-8/,one/1d0/

      i1 = mstackr_cvb(n*n)
      i2 = mstackr_cvb(n*n)
c  W(I1) <= A transpose
      do 100 i=1,n
      do 101 j=1,n
      w(i+(j-1)*n+i1-1)=a(j,i)
101   continue
100   continue
      call mxatb_cvb(w(i1),a,n,n,n,w(i2))
c  W(I2) identity ??
      mxorth_cvb=.true.
      do 200 j=1,n
      do 201 i=1,n
      if(i.ne.j)then
        tst=abs(w(i+(j-1)*n+i2-1))
        if(tst.gt.thresh)mxorth_cvb=.false.
      else
        tst=abs(w(i+(j-1)*n+i2-1)-one)
        if(tst.gt.thresh)mxorth_cvb=.false.
      endif
201   continue
200   continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine zasun_pck(i1,length,valn,jn,kn,ln)
! this routine writes one block of 3-indices and appropriate
! values of integrals into an open TEMP-file
!
! i1 - number of pivot index (I)
! length - number of valid integrals in block (I)
! this routine has also jn,kn,ln,valn
! and stattemp and tmpnam as inputs, but they are
! imported from ccsort_global

use ccsort_global, only: iokey, lrectemp, lunpublic, mbas, nrectemp, nsize, stattemp, tmpnam
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, ItoB, RtoB

implicit none
integer(kind=iwp), intent(in) :: i1, length, jn(nsize,mbas), kn(nsize,mbas), ln(nsize,mbas)
real(kind=wp), intent(in) :: valn(nsize,mbas)
integer(kind=iwp) :: ihelp, iRec, m2
real(kind=wp) :: rhelp
character(len=RtoB+ItoB) :: pphelp
character(len=RtoB+ItoB), allocatable :: pp(:)
integer(kind=iwp), parameter :: constj = 1024**2, constk = 1024

! pack indices and integral values

call mma_allocate(pp,length,label='pp')

do m2=1,length
  rhelp = valn(m2,i1)
  ihelp = ln(m2,i1)+constj*jn(m2,i1)+constk*kn(m2,i1)
  pphelp(1:RtoB) = transfer(rhelp,pphelp(1:RtoB))
  pphelp(RtoB+1:) = transfer(ihelp,pphelp(RtoB+1:))
  pp(m2) = pphelp
end do

! open corresponding TEMP file in corresponding form

if (iokey == 1) then

  ! Fortran IO

  if (stattemp(i1) == 0) then
    ! file will be opened first time, it must be opened
    ! with the pointer at then first position
    call molcas_binaryopen_vanilla(lunpublic,tmpnam(i1))
    !open(unit=lunpublic,file=tmpnam(i1),form='unformatted',status='unknown')
    stattemp(i1) = 1

  else
    ! file was already used in expansion of this block, it must
    ! be opened with the pointer at the end of the file
#   ifdef _DECAXP_
    call molcas_open_ext2(lunpublic,tmpnam(i1),'append','unformatted',f_iostat,.false.,1,'unknown',is_error)

    !open(unit=lunpublic,file=tmpnam(i1),form='unformatted',status='unknown',access='append')
#   else
    call molcas_binaryopen_vanilla(lunpublic,tmpnam(i1))
    !open(unit=lunpublic,file=tmpnam(i1),form='unformatted',status='unknown')
    do iRec=1,nrectemp(i1)
      read(lunpublic) m2
    end do
#   endif

  end if

  write(lunpublic) pp
  close(lunpublic)

else

  ! MOLCAS IO

  call daname(lunpublic,tmpnam(i1))
  call cdafile(lunpublic,1,pp,(RtoB+ItoB)*length,stattemp(i1))
  call daclos(lunpublic)

end if

call mma_deallocate(pp)

nrectemp(i1) = nrectemp(i1)+1
lrectemp(i1) = length

return

end subroutine zasun_pck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine output8 (unit,dkhscfflg,uused,unumber,utimes,uorder,
     *                    umult,u,uscrchar,uscrleng,utimestot,umulttot)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 18.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer unit,uused,unumber,utimes(maxunumber),
     *        uorder(maxunumber,3),umult(maxunumber),
     *        uscrleng(maxunumber),utimestot,umulttot
      character*(4) u(maxunumber)
      character*(3) uscrchar(maxunumber)
      integer j,idum
c
      if (dkhscfflg) then
        write (unit,1070)
1070    format (/2X,'Statistic about Uxxx substitution procedure in ',
     *        'steps 3--5:',/2X,58('-'),//5X,'Note:  * All values ',
     *        'refer to low-level situation of steps 3--5.',/12X,
     *        '* All substitutions for operators, Sxxx, and Txxx ',
     *        'have been counted.')
      else
        write (unit,1071)
1071    format (/2X,'Statistic about Uxxx substitution procedure in ',
     *        'steps 3--5:',/2X,58('-'),//5X,'Note:  * All values ',
     *        'refer to low-level situation of steps 3--5.',/12X,
     *        '* All substitutions for (x)operators, Sxxx, and Txxx ',
     *        'have been counted.')
      endif
c
        write (unit,1072)
1072    format (//5X,'#',4X,'steps',3X,'-->',3X,'steps',4X,
     *         'order',1X,'order',1X,'order',3X,'no. of subs.',3X,
     *         'no. of mat.mult.',/10X,'1--2',10X,'3--5',6X,
     *         '(V)',3X,'(X)',2X,'(tot)',
     *         5X,'(utimes)',9X,'(umult)',/)
c
      idum=0
      do 25 j=1,uused
        if (utimes(j).gt.0) then
          idum=idum+1
          write (dbgunit,1081) idum,uscrchar(j),u(j),uorder(j,1),
     *                       uorder(j,2),uorder(j,3),utimes(j),umult(j)
1081      format (3X,I3,4X,A3,11X,A4,6X,I2,4X,I2,4X,I2,5X,I8,9X,I5)
        endif
  25  continue
c
      write (unit,1091) utimestot,umulttot
1091  format (53X,8('-'),9X,5('-'),/53X,I8,9X,I5,/2X)
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(unumber)
        call Unused_integer_array(uscrleng)
      end if
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Jeppe Olsen                                      *
*               2003, Jesper Wisborg Krogh                             *
************************************************************************
      SUBROUTINE MXMNOC_OCCLS(  MINEL,  MAXEL, NORBTP,NORBFTP, NELFTP,
     &                          MINOP, NTESTG)
*
* Construct accumulated MAX and MIN arrays for an occupation class
*
* MINOP ( Smallest allowed number of open orbitals) added
* April2, 2003, JO (modified by JWK, April - June 2003)
*
      IMPLICIT REAL*8           ( A-H,O-Z)
*. Output
      DIMENSION  MINEL(*),MAXEL(*)
*. Input
      INTEGER NORBFTP(*),NELFTP(*)
*. Local scratch added April 2, 2003
*
#include "mxpdim.fh"
C     INTEGER MINOP_ORB(MXPORB), MINOP_GAS(MXPNGAS), MAXOP_GAS(MXPNGAS)
      INTEGER MINOP_GAS(MXPNGAS), MAXOP_GAS(MXPNGAS)
*
      NTESTL = 00
      NTEST = MAX(NTESTG,NTESTL)
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' ============'
        WRITE(6,*) ' MXMNOC_OCCLS'
        WRITE(6,*) ' ============'
        WRITE(6,*)
        WRITE(6,*) ' MINOP  = ', MINOP
        WRITE(6,*) ' NORBTP = ', NORBTP
        WRITE(6,*) ' NORBFTP : '
        CALL IWRTMA(NORBFTP,1,NORBTP,1,NORBTP)
      END IF
*. Well
      NGAS = NORBTP
*
*. Largest number of unpaired electrons in each gas space
*
      DO IGAS = 1, NGAS
        MAXOP_GAS(IGAS) = MIN(NELFTP(IGAS),2*NORBFTP(IGAS)-NELFTP(IGAS))
      END DO
*
*. Smallest number of electrons in each GAS space
*
*. 1 : Just based on number of electrons in each space
      DO IGAS = 1, NGAS
        IF(MOD(NELFTP(IGAS),2).EQ.1) THEN
          MINOP_GAS(IGAS) = 1
        ELSE
          MINOP_GAS(IGAS) = 0
        END IF
      END DO
*. 2 : the total number of open orbitals should be MINOP, this puts
*. also a constraint on the number of open orbitals
*
*. The largest number of open orbitals, all spaces
      MAXOP_T = IELSUM(MAXOP_GAS,NGAS)
      DO IGAS = 1, NGAS
*. Max number of open orbitals in all spaces except IGAS
       MAXOP_EXL = MAXOP_T - MAXOP_GAS(IGAS)
       MINOP_GAS(IGAS) = MAX(MINOP_GAS(IGAS),MINOP-MAXOP_EXL)
       IF (MOD(NELFTP(IGAS)-MINOP_GAS(IGAS),2) .EQ. 1) THEN
          MINOP_GAS(IGAS) = MINOP_GAS(IGAS) + 1
       ENDIF
      END DO
*. We now have the min and max number of open shells per occls,
*. Find the corresponding min and max number accumulated electrons,
*
* The Max occupation is obtained by occupying in max in the
* first orbitals
* The Min occupation is obtained by occopying max in the
* last orbitals.
*
      NEL_INI = 0
      IBORB   = 1
      DO IGAS = 1, NGAS
        NELEC = NELFTP(IGAS)
* PAM2009: This looks like a bug. MAX_DOUBLE can go negative.
*        MAX_DOUBLE = (NELEC-MINOP_GAS(IGAS))/2
* Replace with:
        MAX_DOUBLE = MAX(0,(NELEC-MINOP_GAS(IGAS))/2)
*
* If you are in a situation with no electrons to spare
*
        IF (NELEC .EQ. 0) THEN
           DO IORB = 1,NORBFTP(IGAS)
              IF (IORB+IBORB-1 .EQ. 1) THEN
                 MINEL(IORB+IBORB-1) = 0
                 MAXEL(IORB+IBORB-1) = 0
              ELSE
                 MINEL(IORB+IBORB-1) = MINEL(IORB+IBORB-2)
                 MAXEL(IORB+IBORB-1) = MAXEL(IORB+IBORB-2)
              END IF
           END DO
           GOTO 10
        END IF
*
* The min number of electrons
*
*. Doubly occupy the last MAX_DOUBLE orbitals
C Start Jesper !!!
        IF (NORBFTP(IGAS)-MAX_DOUBLE .LE. 0
     &        .AND. MINOP_GAS(IGAS) .GT. 0) CALL Abend
C End Jesper !!!
        IORB_START = MAX(1,NORBFTP(IGAS)-MAX_DOUBLE)
        DO IORB = IORB_START,NORBFTP(IGAS)
           MINEL(IORB+IBORB-1) =
     &           NEL_INI + NELEC - 2*(NORBFTP(IGAS)-IORB)
C?        write(6,*) ' 1 IORB+IBORB-1, MINEL() ',
C?   &    IORB+IBORB-1,  MINEL(IORB+IBORB-1)
        END DO
*. Singly occupy
        DO IORB = NORBFTP(IGAS)-MAX_DOUBLE-1,1,-1
           MINEL(IORB+IBORB-1) = MAX(NEL_INI,MINEL(IORB+IBORB-1+1)-1)
C?        write(6,*) ' 2 IORB+IBORB-1, MINEL() ',
C?   &    IORB+IBORB-1,  MINEL(IORB+IBORB-1)
        END DO
*
*. The max number of electrons
*
       DO IORB = 1, MAX_DOUBLE
         MAXEL(IORB+IBORB-1) = NEL_INI + 2*IORB
       END DO
       DO IORB = MAX_DOUBLE+1, NORBFTP(IGAS)
         IF (IORB+IBORB-1 .EQ. 1) THEN
           MAXEL(IORB+IBORB-1) = 1
         ELSE
           MAXEL(IORB+IBORB-1)=MIN(NEL_INI+NELEC,MAXEL(IORB+IBORB-2)+1)
         ENDIF
       END DO
  10   CONTINUE
       NEL_INI = NEL_INI + NELFTP(IGAS)
       IBORB = IBORB + NORBFTP(IGAS)
      END DO
*
      IF( NTEST .GE. 100 ) THEN
        NORB = IELSUM(NORBFTP,NORBTP)
        WRITE(6,*) ' MINEL : '
        CALL IWRTMA(MINEL,1,NORB,1,NORB)
        WRITE(6,*) ' MAXEL : '
        CALL IWRTMA(MAXEL,1,NORB,1,NORB)
      END IF
*
      RETURN
      END
* routines for spinadapting CC amplitudes
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Bruno Tenorio                                    *
************************************************************************
      SUBROUTINE SDCHS(IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,
     &                   PSI1,PSI2,IF20,IF02,SDCHSM)

      use stdalloc, only: mma_allocate, mma_deallocate
      use rassi_global_arrays, only: FSBANN1, FSBANN2
      IMPLICIT NONE

      INTEGER IORBTAB(*), ISSTAB(*)
      INTEGER IFSBTAB1(*),IFSBTAB2(*)
      REAL*8 PSI1(*),PSI2(*),SDCHSM(*)
      LOGICAL IF20,IF02

      REAL*8 COEFF,OVLP
      INTEGER NASORB
      INTEGER IMODE
      INTEGER ISORB,JSORB,IJ
      INTEGER ND1,ND2
      Real*8, Allocatable:: ANN1(:), ANN2(:)

      REAL*8, EXTERNAL:: OVERLAP_RASSI

C Calculates the DCH  matrix elements between two states with
C N and N-1 electrons, defined as:
C IF02 D = < N-2 | anni_right anni_right | N >, or
C IF20 D = < N | anni_left anni_left  | N-2 >
C reduced 2-electron tdm in the space of active spin-orbitals
      NASORB=IORBTAB(4)

C IF02 = eliminte one electron to the right: < N-2 | anni_right
C anni_right | N >
      IF(IF02) THEN

       DO ISORB=1,NASORB
C Symmetry properties:
        !ISMLAB=IORBTAB(KOINFO+1+8*(ISORB-1))
        !ISPLAB=IORBTAB(KOINFO+3+8*(ISORB-1))
C Annihilate a single spin orbital from PSI2, the spin orbital ISORB:
        IMODE=-1
        Call FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB2,1)
        ND1=FSBANN1(5)
        COEFF=1.0D0
        CALL mma_allocate(ANN1,ND1,Label='ANN1')
        ANN1(:)=0.0D0
        CALL PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,FSBANN1,
     &                IFSBTAB2,COEFF,ANN1,PSI2)

        DO JSORB=1,ISORB-1
C Symmetry properties:
         !JSMLAB=IORBTAB(KOINFO+1+8*(JSORB-1))
         !JSPLAB=IORBTAB(KOINFO+3+8*(JSORB-1))
C Pair index J,L:

         OVLP=0.0D0
C Annihilate another spin orbital from PSI2, LSORB:
         IMODE=-1
         Call FSBOP(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN1,2)
         ND2=FSBANN2(5)
         COEFF=1.0D0
         CALL mma_allocate(ANN2,ND2,Label='ANN2')
         ANN2(:)=0.0D0
         CALL PRIMSGM(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN2,
     &                FSBANN1,COEFF,ANN2,ANN1)

C Compute the spin transition density matrix element:
         OVLP=OVERLAP_RASSI(IFSBTAB1,FSBANN2,PSI1,ANN2)

         IJ=((ISORB-1)*(ISORB-2))/2+JSORB
         SDCHSM(IJ)=SDCHSM(IJ)+OVLP

         CALL mma_deallocate(ANN2)
         CALL mma_deallocate(FSBANN2)
        END DO
        CALL mma_deallocate(ANN1)
        CALL mma_deallocate(FSBANN1)
       END DO

C ################################################################################
C IF02 = Eliminate to the right (state 2)
      ELSE IF(IF20) THEN
       WRITE(6,*) 'Invalid state combination.
     &      Please, give PSI1=(N-2) and PSI2=(N) '
      ELSE
       WRITE(6,*)'Invalid state combination in DCH states'
      END IF

      END SUBROUTINE SDCHS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Int_Parm_g(iSD4,nSD,iAnga,
     &                    iCmpa,iShlla,iShela,
     &                    iPrimi,jPrimj,kPrimk,lPriml,
     &                    indij,k2ij,nDCRR,k2kl,nDCRS,
     &                    mdci,mdcj,mdck,mdcl,AeqB,CeqD,
     &                    nZeta,nEta,ipZeta,ipZI,ipP,
     &                    ipEta, ipEI,ipQ,ipiZet,ipiEta,
     &                    ipxA,ipxB,ipxG,ipxD,l2DI,nab,nHmab,ncd,nHmcd,
     &                    nIrrep)
      use k2_setup
      use Basis_Info, only: Shells
      Implicit Real*8 (a-h,o-z)
      Integer iAnga(4), iCmpa(4), iShlla(4), iShela(4), iSD4(0:nSD,4)
      Logical AeqB, CeqD, l2DI
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      Call ICopy(4,iSD4( 1,1),nSD+1,iAnga,1)
      Call ICopy(4,iSD4( 2,1),nSD+1,iCmpa,1)
      Call ICopy(4,iSD4( 0,1),nSD+1,iShlla,1)
      Call ICopy(4,iSD4(11,1),nSD+1,iShela,1)
      iPrimi   =Shells(iSD4( 0,1))%nExp
      jPrimj   =Shells(iSD4( 0,2))%nExp
      kPrimk   =Shells(iSD4( 0,3))%nExp
      lPriml   =Shells(iSD4( 0,4))%nExp
      iShell=iSD4(11,1)
      jShell=iSD4(11,2)
      kShell=iSD4(11,3)
      lShell=iSD4(11,4)
      If (iShell.ge.jShell) Then
         ijShll = iShell*(iShell-1)/2 + jShell
      Else
         ijShll = jShell*(jShell-1)/2 + iShell
      End If
      If (kShell.ge.lShell) Then
         klShll = kShell*(kShell-1)/2 + lShell
      Else
         klShll = lShell*(lShell-1)/2 + kShell
      End If
      iAng=iSD4(1,1)
      jAng=iSD4(1,2)
      kAng=iSD4(1,3)
      lAng=iSD4(1,4)
      iCmp=iSD4(2,1)
      jCmp=iSD4(2,2)
      kCmp=iSD4(2,3)
      lCmp=iSD4(2,4)
*
      nab = nElem(iAng)*nElem(jAng)
      ncd = nElem(kAng)*nElem(lAng)
      nHmab=iCmp*jCmp*(nabSz(iAng+jAng)-nabSz(Max(iAng,jAng)-1))
      nHmab=nHmab*nIrrep
      nHmcd=kCmp*lCmp*(nabSz(kAng+lAng)-nabSz(Max(kAng,lAng)-1))
      nHmcd=nHmcd*nIrrep
      If (.Not.l2DI) Then
         nab = 0
         ncd = 0
      End If
      k2ij  = Indk2(1,ijShll)
      nDCRR = Indk2(2,ijShll)
      k2kl  = Indk2(1,klShll)
      nDCRS = Indk2(2,klShll)
      mdci=iSD4(10,1)
      mdcj=iSD4(10,2)
      mdck=iSD4(10,3)
      mdcl=iSD4(10,4)
      AeqB = iSD4(13,1).eq.iSD4(13,2) .and. mdci.eq.mdcj
      CeqD = iSD4(13,3).eq.iSD4(13,4) .and. mdck.eq.mdcl
      nZeta = iPrimi * jPrimj
      nEta = kPrimk * lPriml
      ipZI  = ipZeta + nZeta
      ipP   = ipZI   + nZeta
      ipxA  = ipP    + nZeta*3
      ipxB  = ipxA   + nZeta
      ipEta = ipxB   + nZeta
      ipEI  = ipEta  + nEta
      ipQ   = ipEI   + nEta
      ipxG  = ipQ    + nEta*3
      ipxD  = ipxG   + nEta
*
      ipiEta= ipiZet + nZeta + 1
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(indij)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine InsReqo2v4(NaGrp,NbeGrp,NaSGrp)
! this routine does:
! Inspect W3 and W4 files requirements of o2v4 procedure
! on this node. It checks which of the W3 and W4 files
! are used on this node

use Index_Functions, only: nTri_Elem
use chcc_global, only: ABID, DimGrpa, DimGrpbe, DimSGrpbe, GrpaLow, GrpaUp, GrpbeLow, GrpbeUp, InqW3, InqW4
use Para_Info, only: MyRank
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NaGrp, NbeGrp, NaSGrp
integer(kind=iwp) :: adda, addb, addbe, addbepp, addga, addgapp, aGrp, aSGrp, beGrp, beSGrp, bGrp, bSGrp, bSGrpUp, dima, dimb, &
                     dimbe, dimga, gaGrp, gaSGrp, gaSGrpUp, i, LenW3, LenW4, NSGrp

!* Initial Set InqW3,InqW4 = F
NSGrp = NaGrp*NaSGrp
InqW3(1:nTri_Elem(NSGrp),1:NSGrp) = .false.
InqW4(1:nTri_Elem(NSGrp),1:nTri_Elem(NSGrp)) = .false.
LenW3 = 0
LenW4 = 0

!* cycle over all groups of (a>=b)
adda = 0
do aGrp=1,NaGrp
  dima = DimGrpa(aGrp)

  !## test, if on this node at least one combination with this
  !   aGrp is scheduled. Skip if no
  i = sum(ABID(myRank,aGrp,1:NaGrp))

  if (i /= 0) then
    addb = 0
    do bGrp=1,aGrp
      dimb = DimGrpa(bGrp)

      !## test, if this a'b' combination is planed to be run on this node
      if (ABID(myRank,aGrp,bGrp) /= 0) then

        ! cycle over all groups of (be>=ga)
        addbe = 0
        do beGrp=1,NbeGrp
          dimbe = DimGrpbe(beGrp)
          addga = 0
          do gaGrp=1,beGrp
            dimga = DimGrpbe(gaGrp)

            ! cycle over all subgroups of (be>=ga)'
            addbepp = addbe
            do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)

              if (beGrp == gaGrp) then
                gaSGrpUp = beSGrp
              else
                gaSGrpUp = GrpbeUp(gaGrp)
              end if

              addgapp = addga
              do gaSGrp=GrpbeLow(gaGrp),gaSGrpUp

                ! cycle over all subgroups of (a>=b)'
                do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
                  if (aGrp == bGrp) then
                    bSGrpUp = aSGrp
                  else
                    bSGrpUp = GrpaUp(bGrp)
                  end if
                  do bSGrp=GrpaLow(bGrp),bSGrpUp

                    ! clasical reading or generating of (VV|VV) integrals

                    ! term W1(a",be",b",ga") <- -(b"ga"|a"i) . T1(i,be")
                    ! Get Ww(b",ga",a",i) (Wx used as Aux)
                    call InsReaW3(bSGrp,gaSGrp,aSGrp,LenW3)

                    ! Upgrade W1(a",be",b",ga") <<- (a",be"|b",ga")
                    call InsReaW4(aSGrp,beSGrp,bSGrp,gaSGrp,LenW4)

                    if (aSGrp /= bSGrp) then
                      ! term W2(b",be",a",ga") <- -(a"ga"|b"i) . T1(i,ga")
                      ! Get Ww(a",ga",b",i) (Wx used as Aux)
                      call InsReaW3(aSGrp,gaSGrp,bSGrp,LenW3)

                      ! term W2(b",be",a",ga") <<- -(b"be"|a"i) . T1(i,ga")
                      ! Get Ww(b",be",a",i) (Wx used as Aux)
                      call InsReaW3(bSGrp,beSGrp,aSGrp,LenW3)

                      ! Add W2(b",be",a",ga") <<- (b",be"Ia",ga")
                      ! Upgrade:W2, destroy:Ww
                      call InsReaW4(bSGrp,beSGrp,aSGrp,gaSGrp,LenW4)
                    end if

                  ! end cycle over all subgroups of (a>=b)'
                  end do
                end do

                ! end cycle over all subgroups of (be>=ga)'
                addgapp = addgapp+DimSGrpbe(gaSGrp)
              end do
              addbepp = addbepp+DimSGrpbe(beSGrp)
            end do

            ! end cycle over all groups of (be>=ga)
            addga = addga+dimga
          end do
          addbe = addbe+dimbe
        end do

      end if
      ! end cycle over all groups of (a>=b)
      addb = addb+dimb
    end do
  end if
  adda = adda+dima
end do

return

end subroutine InsReqo2v4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_WriteC(iAtomPair,l_C,C,LuC,iAddr)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: Write LDF fitting coefficients for atom pair iAtomPair to
C     disk at address iAddr. Save disk address in atom pair info.
C
C     Note: iAddr is updated here (to disk address of next atom pair)!
C
      Implicit None
      Integer iAtomPair
      Integer l_C
      Real*8  C(l_C)
      Integer LuC
      Integer iAddr
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*10 SecNam
      Parameter (SecNam='LDF_WriteC')

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Integer LenOfC, iOpt

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Save disk address
      If (iAddr.lt.0) Then
         Call WarningMessage(2,SecNam//': Invalid disk address')
         Call LDF_Quit(1)
      Else
         iWork(ip_AP_DiskC-1+iAtomPair)=iAddr
      End If

      ! Compute dimension of C
      LenOfC=LDF_nBas_Atom(AP_Atoms(1,iAtomPair))
     &      *LDF_nBas_Atom(AP_Atoms(2,iAtomPair))
     &      *LDF_nBasAux_Pair(iAtomPair)

      ! Write C to disk
      If (LenOfC.gt.l_C) Then
         Call WarningMessage(2,SecNam//': LenOfC>l_C')
         Call LDF_Quit(1)
      Else
         iOpt=1 ! write option
         Call dDAFile(LuC,iOpt,C,LenOfC,iAddr)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine MKBNEVE(nAshT,Hact,Gact,G1,G2)

use Index_Functions, only: iTri, nTri_Elem
use caspt2_global, only: LUSBT
use caspt2_module, only: NAES, NASH, NINDEP, NSYM
use EQSOLV, only: IDBMAT
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAshT
real(kind=wp), intent(in) :: Hact(nAshT,nAshT), Gact(nAshT,nAshT,nAshT,nAshT), G1(nAshT,nAshT), G2(nAshT,nAshT,nAshT,nAshT)
integer(kind=iwp) :: IBE, IDISK, ISYM, iSymU, iSymUV, iSymV, iSymY, IT, ITABS, IU, IUABS, IV, IVABS, IX, IXABS, IY, IYABS, NAS, &
                     NBE, NINM
real(kind=wp) :: Val
real(kind=wp), allocatable :: BE(:)

do ISYM=1,NSYM
  if (NINDEP(ISYM,6) == 0) cycle
  NINM = NINDEP(ISYM,7)
  NAS = NASH(ISYM)
  NBE = nTri_Elem(NAS)
  if (NBE > 0) call mma_Allocate(BE,NBE,LABEL='BE')

  ! Eq.(A3): K(t,x) = h(u,x)*tR(u,t) + (ce|da)*(tE(td)E(ce))
  !                 = h(u,x)*(2del(u,t) - R(t,u)) + (uv|yx)*(2*del(ty)*D(uv)-D(yu,tv)-del(tu)D(yv))
  ! Or, considering using Eq.(A4)
  do IT=1,NAS
    ITABS = IT+NAES(ISYM)
    do IX=1,IT
      IXABS = IX+NAES(ISYM)
      Val = Zero
      !do IU=1,NAS
      !  IUABS = IU+NAES(ISYM)
      !  Val = Val-Hact(IUABS,IXABS)*G1(ITABS,IUABS)
      !  if (ITABS == IUABS) Val = Val+Two*Hact(IUABS,IXABS)
      !  do IV=1,NAS
      !    IVABS = IV+NAES(ISYM)
      !    do IY=1,NAS
      !      IYABS = IY+NAES(ISYM)
      !      Val = Val-Gact(IUABS,IVABS,IYABS,IXABS)*G2(IYABS,ITABS,IUABS,IVABS)
      !      if (ITABS == IYABS) Val = Val+Two*Gact(IUABS,IVABS,IYABS,IXABS)*G1(IUABS,IVABS)
      !      if (ITABS == IUABS) Val = Val-Gact(IUABS,IVABS,IYABS,IXABS)*G1(IYABS,IVABS)
      !    end do
      !  end do
      !end do
      do IU=1,NAS
        IUABS = IU+NAES(iSym)
        Val = Val-Hact(IUABS,IXABS)*G1(ITABS,IUABS)
        if (ITABS == IUABS) Val = Val+Two*Hact(IUABS,IXABS)
      end do
      do iSymU=1,nSym
        do iSymV=1,nSym
          iSymUV = MUL(iSymU,iSymV)
          do iSymY=1,nSym
            if (iSym == MUL(iSymY,iSymUV)) then
              do IU=1,NASH(iSymU)
                IUABS = IU+NAES(iSymU)
                do IV=1,NASH(iSymV)
                  IVABS = IV+NAES(iSymV)
                  do IY=1,NASH(iSymY)
                    IYABS = IY+NAES(iSymY)
                    Val = Val-Gact(IUABS,IVABS,IYABS,IXABS)*G2(IYABS,ITABS,IUABS,IVABS)
                    if (ITABS == IYABS) Val = Val+Two*Gact(IUABS,IVABS,IYABS,IXABS)*G1(IUABS,IVABS)
                    if (ITABS == IUABS) Val = Val-Gact(IUABS,IVABS,IYABS,IXABS)*G1(IYABS,IVABS)
                  end do
                end do
              end do
            end if
          end do
        end do
      end do
      IBE = iTri(IT,IX)
      BE(IBE) = Val
    end do
  end do

  if ((NBE > 0) .and. (NINDEP(ISYM,6) > 0)) then
    IDISK = IDBMAT(ISYM,6)
    call DDAFILE(LUSBT,1,BE,NBE,IDISK)
    if ((NINM > 0) .and. (NINDEP(ISYM,7) > 0)) then
      IDISK = IDBMAT(ISYM,7)
      call DDAFILE(LUSBT,1,BE,NBE,IDISK)
    end if
    call mma_deallocate(BE)
  end if
end do

end subroutine MKBNEVE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DMXMT(A,LDA,NTA,B,LDB,NTB,
     &                C,NRC,NSUM,NCC)
      IMPLICIT NONE
      INTEGER IROW,ICOL,LDA,LDB,NRC,NSUM,NCC,IND,ISUM
      CHARACTER NTA,NTB
      REAL*8 A(LDA,*),B(LDB,*),C(*),SUM
      IND=0
      IF (NTA.eq.'N'.and.NTB.eq.'N') Then
      DO ICol=1,NRC
       DO IRow=icol,nrc
         SUM=0.0D0
         DO ISUM=1,NSUM
            SUM=SUM +
     &          A(IROW,ISUM)*
     &          B(ISUM,iCOL)
         End Do
         IND=IND+1
         C(IND)=SUM
       End Do
      End Do
      Else
       Call SysHalt('dmxmt')
      End If
*     IF (NTA.eq.'T'.and.NTB.eq.'N') Then
*     DO IROW=1,NRC
*      DO ICOL=0,IROW
*        SUM=0.0D0
*        DO ISUM=0,NSUM-1
*           SUM=SUM +
*    &          A(ISUM,IROW)*
*    &          B(ISUM,iCOL)
*        End Do
*        IND=IND+1
*        C(IND)=SUM
*      End Do
*     End Do
*     Else IF (NTA.eq.'N'.and.NTB.eq.'T') Then
*     DO IROW=1,NRC
*      DO ICOL=0,IROW
*        SUM=0.0D0
*        DO ISUM=0,NSUM-1
*           SUM=SUM +
*    &          A(IROW,ISUM)*
*    &          B(ICOL,iSUM)
*        End Do
*        IND=IND+1
*        C(IND)=SUM
*      End Do
*     End Do
*     Else IF (NTA.eq.'T'.and.NTB.eq.'T') Then
*     DO IROW=1,NRC
*      DO ICOL=0,IROW
*        SUM=0.0D0
*        DO ISUM=0,NSUM-1
*           SUM=SUM +
*    &          A(ISUM,IROW)*
*    &          B(ICOL,iSUM)
*        End Do
*        IND=IND+1
*        C(IND)=SUM
*      End Do
*     End Do
*     End If
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NCC)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

function IABNUM(IASTR,IBSTR,IAGRP,IBGRP,IGENSG,ISGNA,ISGNB,ISGNAB,IOOS,NORB,IPSFAC,PSSIGN)
! Encapsulation routine for IABNUS

use Str_info, only: nElec, NoCTyp, STR
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: IABNUM
integer(kind=iwp), intent(in) :: IASTR(*), IBSTR(*), IAGRP, IBGRP, IGENSG, ISGNA(*), ISGNB(*), &
                                 IOOS(NOCTYP(IAGRP),NOCTYP(IBGRP),*), NORB
integer(kind=iwp), intent(out) :: ISGNAB, IPSFAC
real(kind=wp), intent(in) :: PSSIGN
integer(kind=iwp), external :: IABNUS

IABNUM = IABNUS(IASTR,NELEC(IAGRP),Str(IAGRP)%STREO,Str(IAGRP)%STCL,Str(IAGRP)%STSM,NOCTYP(IAGRP),Str(IAGRP)%Z,Str(IAGRP)%ISTSO, &
                Str(IAGRP)%NSTSO,IBSTR,NELEC(IBGRP),Str(IBGRP)%STREO,Str(IBGRP)%STCL,Str(IBGRP)%STSM,NOCTYP(IBGRP),Str(IBGRP)%Z, &
                Str(IBGRP)%ISTSO,Str(IBGRP)%NSTSO,IOOS,NORB,IGENSG,ISGNA,ISGNB,ISGNAB,PSSIGN,IPSFAC)

end function IABNUM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION NSTAGTS(IGRP,ITP,ISM)
      Use Str_Info
*
* Number of strings of group IGRP
*                      type  ITP
*                      sym   ISM
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "detdim.fh"
#include "csm.fh"
* element (ITP,ISM) corresponds to adress
       IADRESS = (ISM-1)*NOCTYP(IGRP)+ ITP
*
       NSTAGTS = Str(IGRP)%NSTSO(IADRESS)
*
       NTEST = 0
       IF(NTEST.NE.0) THEN
         WRITE(6,*) ' Number of strings of group,type,sym',
     &   IGRP,ITP,ISM,' is ', NSTAGTS
       END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine PGet4(iCmp,iBas,jBas,kBas,lBas,
     &                 Shijij, iAO, iAOst, ijkl,PSO,nPSO,DSO,nDSO,
     &                 PSOPam,n1,n2,n3,n4,iPam,MapPam,mDim,
     &                 Cred,nCred,Scr1,nScr1,Scr2,nScr2,PMax)
************************************************************************
*                                                                      *
*  Object: to assemble the index list of the batch of the 2nd order    *
*          density matrix.                                             *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*             Modified from PGet2, October '92.                        *
************************************************************************
      use SOAO_Info, only: iAOtSO, iOffSO
      use pso_stuff
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 PSO(ijkl,nPSO), PSOPam(n1,n2,n3,n4), DSO(nDSO),
     &       Cred(nCred), Scr1(nScr1,2), Scr2(nScr2)
      Integer nPam(4,0:7), iiBas(4),
     &          iCmp(4), iAO(4), iAOst(4)
      Real*8 iPam(n1+n2+n3+n4), MapPam(4,mDim)
      Logical Shijij
*     Local Array
      Integer iSym(0:7), jSym(0:7), kSym(0:7), lSym(0:7)
*
*     Prepare some data for Pam
*
      iiBas(1) = iBas
      iiBas(2) = jBas
      iiBas(3) = kBas
      iiBas(4) = lBas
      nPSOPam=n1*n2*n3*n4
*
*-----Set up table with SO indices in iPam and a table
*     with number of basis functions in each irrep in nPam.
*     Observe that the SO index is only within a given irrep.
*
      Call ICopy(4*8,[0],0,nPam,1)
      in1 = 0
      Do 9 jPam = 1, 4
         in2 = 0
         Do 10 j = 0, nIrrep-1
            Do 11 i1 = 1, iCmp(jPam)
               If (iAOtSO(iAO(jPam)+i1,j)>0) Then
                   iSO = iAOtSO(iAO(jPam)+i1,j)
     &                 + iAOst(jPam)
                   nPam(jPam,j) = nPam(jPam,j) + iiBas(jPam)
                   Do 12 iAOi = 0, iiBas(jPam)-1
                      iSOi = iSO + iAOi
                      in2 = in2 + 1
                      iPam(in1+in2) = DBLE(iSOi)
                      MapPam(jPam,iSOi+iOffSO(j)) = DBLE(in2)
 12                Continue
               End If
 11         Continue
 10      Continue
         in1 = in1 + in2
 9    Continue
*
*     Get the scrambled 2nd order density matrix
*
      If (LSA) Then

      Call PTrans_sa(CMO(1,1),nPam,iPam,n1+n2+n3+n4,
     &            DSO,PSOPam,nPSOPam,G1,nG1,G2,nG2,
     &            Cred,nCred/2,Scr1(1,1),nScr1,Scr2,nScr2,Scr1(1,2),
     &            nScr1)
      Else
      Call PTrans(CMO(1,1),nPam,iPam,n1+n2+n3+n4,
     &            DSO,PSOPam,nPSOPam,G1,nG1,G2,nG2,
     &            Cred,nCred,Scr1,nScr1,Scr2,nScr2)
      End If
*
*-----Quadruple loop over elements of the basis functions angular
*     description.
*     Observe that we will walk through the memory in AOInt in a
*     sequential way.
*
      PMax=Zero
      MemSO2 = 0
      Do 100 i1 = 1, iCmp(1)
         niSym = 0
         Do 101 j = 0, nIrrep-1
            If (iAOtSO(iAO(1)+i1,j)>0) Then
               iSym(niSym) = j
               niSym = niSym + 1
            End if
101      Continue
         Do 200 i2 = 1, iCmp(2)
            njSym = 0
            Do 201 j = 0, nIrrep-1
               If (iAOtSO(iAO(2)+i2,j)>0) Then
                  jSym(njSym) = j
                  njSym = njSym + 1
               End If
201         Continue
            Do 300 i3 = 1, iCmp(3)
               nkSym = 0
               Do 301 j = 0, nIrrep-1
                  If (iAOtSO(iAO(3)+i3,j)>0) Then
                     kSym(nkSym) = j
                     nkSym = nkSym + 1
                  End If
301            Continue
               Do 400 i4 = 1, iCmp(4)
                  nlSym = 0
                  Do 401 j = 0, nIrrep-1
                     If (iAOtSO(iAO(4)+i4,j)>0) Then
                        lSym(nlSym) = j
                        nlSym = nlSym + 1
                     End If
401               Continue
*
*------Loop over irreps which are spanned by the basis function.
*      Again, the loop structure is restricted to ensure unique
*      integrals.
*
       Do 110 is = 0, niSym-1
          j1 = iSym(is)
*
          Do 210 js = 0, njSym-1
             j2 = jSym(js)
             j12 = iEor(j1,j2)
*
             Do 310 ks = 0, nkSym-1
                j3 = kSym(ks)
                j123 = iEor(j12,j3)
                Do 410 ls = 0, nlSym-1
                   j4 = lSym(ls)
                   If (j123.ne.j4) Go To 411
*
                MemSO2 = MemSO2 + 1
*
*               Unfold the way the eight indices have been reordered.
                iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)+iOffSO(j1)
                jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)+iOffSO(j2)
                kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+iOffSO(j3)
                lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+iOffSO(j4)
*
                nijkl = 0
                Do 120 lAOl = 0, lBas-1
                   lSOl = lSO + lAOl
                   k4 = INT(MapPam(4,lSOl))
                   Do 220 kAOk = 0, kBas-1
                      kSOk = kSO + kAOk
                      k3 = INT(MapPam(3,kSOk))
                      Do 320 jAOj = 0, jBas-1
                         jSOj = jSO + jAOj
                         k2 = INT(MapPam(2,jSOj))
                         Do 420 iAOi = 0, iBas-1
                            iSOi = iSO + iAOi
                            nijkl = nijkl + 1
                            k1 = INT(MapPam(1,iSOi))
*
*---------------------------Pick up the contribution.
*
                            PMax=Max(PMax,Abs(PSOPam(k1,k2,k3,k4)))
                            PSO(nijkl,MemSO2) = PSOPam(k1,k2,k3,k4)
*
 420                     Continue
 320                  Continue
 220               Continue
 120            Continue
*
 411               Continue
 410            Continue
 310         Continue
 210      Continue
 110   Continue
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
      If (nPSO.ne.MemSO2) Then
         Call WarningMessage(2,'PGet4: nPSO.ne.MemSO2')
         Call Abend()
      End If
*
*     Call GetMem(' Exit PGet4','CHECK','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(Shijij)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_interface

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_initial,                  &
             fmm_final,                    &
             fmm_get_J_matrix,             &
             fmm_get_boundary_potential
!             fmm_get_boundary_potential,   &
!             fefmm_get_J_matrix

   TYPE(fmm_basis), SAVE :: basis

CONTAINS

!-------------------------------------------------------------------------------

! INTEGER :: NAtom    =  number of atoms
! INTEGER :: NShel    =  number of shells
! INTEGER :: NPrim    =  number of primitive exponents
! INTEGER :: NBF_Car  =  dimension of AO Fock matrix

! INTEGER :: MaxAngl  =  maximum angular momentum primitive
! INTEGER :: MaxSgm2  =  maximum number of primitive pairs in any AO-pair

! INTEGER :: KAtom(NShel)     =  map from shells to atoms
! INTEGER :: KType(NShel)     =  angular momentum of shell
! INTEGER :: KStart(NShel)    =  first primitive in this shell
! INTEGER :: KontG(NShel)     =  number of primitives in this shell
! INTEGER :: KLoc_Car(NShel)  =  first (contracted) AO in this shell -1

! REAL    :: Centr(3,NAtom)   =  array of atomic positions
! REAL    :: Expnt(NPrim)     =  primitive exponents
! REAL    :: CCoef(NPrim)     =  contraction coefficients (normalized)

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_initial(NAtom,NShel,NPrim,NBF_Car,MaxAngl,MaxSgm2,    &
                          KAtom,KType,KStart,KontG,KLoc_Car,            &
                          Centr,Expnt,CCoef,mode)

      USE fmm_scheme_builder, ONLY: fmm_init_scheme, fmm_get_scheme
      USE fmm_shell_pairs,    ONLY: fmm_get_shell_pairs

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: NAtom, NShel, NPrim, NBF_Car
      INTEGER(INTK), INTENT(IN) :: MaxSgm2, MaxAngl, mode
      INTEGER(INTK), INTENT(IN) :: KAtom(NShel)
      INTEGER(INTK), INTENT(IN) :: KType(NShel)
      INTEGER(INTK), INTENT(IN) :: KStart(NShel)
      INTEGER(INTK), INTENT(IN) :: KontG(NShel)
      INTEGER(INTK), INTENT(IN) :: KLoc_Car(NShel)
      REAL(REALK),   INTENT(IN) :: Centr(3,NAtom)
      REAL(REALK),   INTENT(IN) :: Expnt(NPrim)
      REAL(REALK),   INTENT(IN) :: CCoef(NPrim)

      TYPE(fmm_sh_pairs), POINTER :: sh_pairs(:)
      TYPE(scheme_paras), POINTER :: scheme
      INTEGER(INTK) :: lmax

      ! Initialise FMM run-type parameters
      CALL fmm_init_scheme(mode)
      CALL fmm_get_scheme(scheme)
      lmax = scheme%raw_lmax

      ! Initialise basis set information
      CALL fmm_init_basis(NAtom,NShel,NPrim,NBF_Car,MaxAngl,lmax,     &
                          maxsgm2,KAtom,KType,KStart,KontG,KLoc_Car,  &
                          Centr,Expnt,CCoef)

      ! Get list of non-vanishing shell pairs
      CALL fmm_get_shell_pairs(basis,sh_pairs)

      ! Build and store on disk density-independent integral components
!      SELECT CASE (mode)
!         CASE ( FE_FMM )
!            CALL fmm_init_fefmm(scheme,basis,lmax,sh_pairs)
!         CASE DEFAULT
            CALL fmm_init_md4fmm(basis,lmax,sh_pairs)
!       END SELECT

      NULLIFY(sh_pairs)

   END SUBROUTINE fmm_initial

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_md4fmm(basis,lmax,sh_pairs)

      USE fmm_multipole_ints, ONLY: fmm_init_multipole_ints,          &
                                    fmm_free_multipole_ints,          &
                                    fmm_build_multipoles

      IMPLICIT NONE
      TYPE(fmm_basis),    INTENT(IN) :: basis
      TYPE(fmm_sh_pairs), INTENT(IN) :: sh_pairs(:)
      INTEGER(INTK),      INTENT(IN) :: lmax

      CALL fmm_init_multipole_ints(basis,lmax)
      CALL fmm_build_multipoles(basis,lmax,sh_pairs)
      CALL fmm_free_multipole_ints

   END SUBROUTINE fmm_init_md4fmm

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_J_matrix(nBas,dens,fockAO)

      USE fmm_driver, ONLY: fmm_build_J_matrix

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)    :: nBas
      REAL(REALK),   INTENT(IN)    :: dens(nBas*(nBas+1)/2)
      REAL(REALK),   INTENT(INOUT) :: fockAO(nBas*(nBas+1)/2)

      CHARACTER(LEN=10), PARAMETER :: Name = 'multipoles'
      CHARACTER(LEN=255) :: FBuf
      REAL(REALK)   :: J_matrix(nBas,nBas)
      REAL(REALK)   :: sq_dens(nBas,nBas)
      INTEGER(INTK) :: i,j,ij

      ! Write null header file for nuclear moments (not computed!)
      FBuf = TRIM(Name)//".fmm2header"
      OPEN(UNIT=LUINTM, FILE=TRIM(FBuf), STATUS='REPLACE',   &
           ACCESS='SEQUENTIAL', FORM='UNFORMATTED')
      WRITE(LUINTM) 0
      CLOSE(UNIT=LUINTM, STATUS='KEEP')

      sq_dens(:,:) = zero
      ij = 0
      DO j = 1, nBas
         DO i = 1, j
            ij = ij+1
            sq_dens(i,j) = two*dens(ij)
            sq_dens(j,i) = sq_dens(i,j)
         END DO
         sq_dens(j,j) = half*sq_dens(j,j)
      END DO

      CALL fmm_build_J_matrix('TWO_EL',sq_dens,J_matrix)

      ij = 0
      DO j = 1, nBas
      DO i = 1, j
         ij = ij+1
         fockAO(ij) = fockAO(ij) + J_matrix(i,j)
      END DO
      END DO

   END SUBROUTINE fmm_get_J_matrix

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_boundary_potential(npoints,nBas,coor,dens,potential)

      USE fmm_stats
      USE fmm_scheme_builder,       ONLY: fmm_get_scheme
      USE fmm_driver,               ONLY: fmm_get_multipole_potential
!      USE fmm_boxed_multipole_ints, ONLY: fmm_pack_boxed_mpoles

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: npoints, nBas
      REAL(REALK),   INTENT(IN)  :: coor(3,npoints)
      REAL(REALK),   INTENT(IN)  :: dens(nBas*(nBas+1)/2)
      REAL(REALK),   INTENT(OUT) :: potential(npoints)

      TYPE(scheme_paras), POINTER :: scheme
      REAL(REALK)   :: sq_dens(nBas,nBas)
      REAL(REALK)   :: Vtmp(1,npoints)
!      REAL(REALK)   :: dummy_dens(1,1) = one
      INTEGER(INTK) :: i,j,ij

      stat_points = npoints

      sq_dens(:,:) = zero
      ij = 0
      DO j = 1, nBas
         DO i = 1, j
            ij = ij+1
            sq_dens(i,j) = two*dens(ij)
            sq_dens(j,i) = sq_dens(i,j)
         END DO
         sq_dens(j,j) = half*sq_dens(j,j)
      END DO

      CALL fmm_get_scheme(scheme)
!      ! Pack moments (with density) to reduce memory in FMM readin
!      CALL fmm_pack_boxed_mpoles(scheme%raw_lmax,nBas,sq_dens)

      ! Rewrite files for LHS potential grid points
      CALL fmm_initialise_gfc_grid(npoints,coor)

!      CALL fmm_get_multipole_potential(GFC_FMM,dummy_dens,Vtmp)
      CALL fmm_get_multipole_potential(GFC_FMM,sq_dens,Vtmp)
      potential(:) = Vtmp(1,:)
      CALL fmm_matrix_norm('fmm_V',potential,npoints)

   END SUBROUTINE fmm_get_boundary_potential

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_initialise_gfc_grid(npoints,coor)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: npoints
      REAL(REALK),   INTENT(IN)  :: coor(3,npoints)

      CHARACTER(LEN=10), PARAMETER :: Name = 'multipoles'
      CHARACTER(LEN=255) :: FBuf
      INTEGER(INTK) :: i

      ! Write grid points to disk
      FBuf = TRIM(Name)//".fmm2"
      OPEN(UNIT=LUINTM, FILE=TRIM(FBuf), STATUS='REPLACE',  &
           ACCESS='SEQUENTIAL', FORM='UNFORMATTED')
      REWIND(LUINTM)
      DO i = 1, npoints
         WRITE(LUINTM) 0, 0, 0, 0, 0, coor(1,i), coor(2,i), coor(3,i), 1.0D0
      END DO
      CLOSE(UNIT=LUINTM, STATUS='KEEP')

      ! Write header file
      FBuf = TRIM(Name)//".fmm2header"
      OPEN(UNIT=LUINTM, FILE=TRIM(FBuf), STATUS='REPLACE',   &
           ACCESS='SEQUENTIAL', FORM='UNFORMATTED')
      WRITE(LUINTM) npoints
      CLOSE(UNIT=LUINTM, STATUS='KEEP')

   END SUBROUTINE fmm_initialise_gfc_grid

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_basis(NAtom,NShel,NPrim,NBF_Car,MaxAngl,lmax,      &
                             maxsgm2,KAtom,KType,KStart,KontG,KLoc_Car,   &
                             Centr,Expnt,CCoef)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: NAtom,NShel,NPrim,NBF_Car
      INTEGER(INTK), INTENT(IN) :: MaxAngl,lmax,maxsgm2
      INTEGER(INTK), INTENT(IN) :: KAtom(NShel)
      INTEGER(INTK), INTENT(IN) :: KType(NShel)
      INTEGER(INTK), INTENT(IN) :: KStart(NShel)
      INTEGER(INTK), INTENT(IN) :: KontG(NShel)
      INTEGER(INTK), INTENT(IN) :: KLoc_Car(NShel)
      REAL(REALK),   INTENT(IN) :: Centr(3,NAtom)
      REAL(REALK),   INTENT(IN) :: Expnt(NPrim)
      REAL(REALK),   INTENT(IN) :: CCoef(NPrim)

      INTEGER(INTK), ALLOCATABLE :: tmp(:)
      INTEGER(INTK) :: IL, It, Iu, Iv, Ituv, ii
      INTEGER(INTK) :: Maxtuv, MaxLtuv

      Maxtuv  = MAX(MaxAngl,lmax)
      MaxLtuv = (Maxtuv+1) * (Maxtuv+2) * (Maxtuv+3) /6

      ALLOCATE(basis%Centr(3,NAtom))
      ALLOCATE(basis%KAtom(NShel))
      ALLOCATE(basis%KType(NShel))
      ALLOCATE(basis%KStart(NShel))
      ALLOCATE(basis%KontG(NShel))
      ALLOCATE(basis%KLoc_Car(NShel))
      ALLOCATE(basis%Expnt(NPrim))
      ALLOCATE(basis%CCoef(NPrim))
      ALLOCATE(basis%LtuvMin_Car(0:Maxtuv))
      ALLOCATE(basis%LtuvMax_Car(0:Maxtuv))
      ALLOCATE(basis%Lt(MaxLtuv))
      ALLOCATE(basis%Lu(MaxLtuv))
      ALLOCATE(basis%Lv(MaxLtuv))

      basis%nshells     = NShel
      basis%nbas        = NBF_Car
      basis%maxangl     = MaxAngl
      basis%maxsgm2     = MaxSgm2
      basis%Centr(:,:)  = Centr(:,:)
      basis%KAtom(:)    = KAtom(:)
      basis%KType(:)    = KType(:)
      basis%KStart(:)   = KStart(:)
      basis%KontG(:)    = KontG(:)
      basis%KLoc_Car(:) = KLoc_Car(:)
      basis%Expnt(:)    = Expnt(:)
      basis%CCoef(:)    = CCoef(:)

      ! Now initialise LtuvMin_Car, LtuvMax_Car, Lt, Lu, Lv

      ALLOCATE(tmp(0:Maxtuv))
      tmp(0) = 1
      basis%LtuvMin_Car(0) = 1
      basis%LtuvMax_Car(0) = 1
      DO IL = 1, Maxtuv
         tmp(IL) = (IL+1) * (IL+2) / 2
         basis%LtuvMin_Car(IL) = basis%LtuvMin_Car(IL-1) + tmp(IL-1)
         basis%LtuvMax_Car(IL) = basis%LtuvMax_Car(IL-1) + tmp(IL)
      END DO

      Ituv = 0
      DO IL = 0, Maxtuv
         DO It = Maxtuv, 0, -1
            DO Iu = Maxtuv, 0, -1
               DO Iv = Maxtuv, 0, -1
                  IF (It+Iu+Iv == IL) THEN
                     Ituv = Ituv + 1
                     basis%Lt(Ituv) = It
                     basis%Lu(Ituv) = Iu
                     basis%Lv(Ituv) = Iv
                  END IF
               END DO
            END DO
         END DO
      END DO
      DEALLOCATE(tmp)

      RETURN

      ! Print section
      write(6,*) '------------'
      write(6,*) 'NAtom',  NAtom
      write(6,*) 'NShel',  NShel
      write(6,*) 'NPrim',  NPrim
      write(6,*) 'NBF_Car',NBF_Car
      write(6,*) '------------'
      write(6,*) 'Maxangl', MaxAngl
      write(6,*) 'Maxsgm2', MaxSgm2
      write(6,*) '------------'
      write(6,*) 'katom:'
      do ii = 1, nshel
         write(6,*) ii, KAtom(ii)
      end do
      write(6,*) '------------'
      write(6,*) 'ktype:'
      do ii = 1, nshel
         write(6,*) ii, KType(ii)
      end do
      write(6,*) '------------'
      write(6,*) 'kstart:'
      do ii = 1, nshel
         write(6,*) ii, KStart(ii)
      end do
      write(6,*) '------------'
      write(6,*) 'kontg:'
      do ii = 1, nshel
         write(6,*) ii, KontG(ii)
      end do
      write(6,*) '------------'
      write(6,*) 'kloc_car:'
      do ii = 1, nshel
         write(6,*) ii, KLoc_Car(ii)
      end do
      write(6,*) '------------'
      write(6,*) 'expnt:'
      do ii = 1, nprim
       write(6,*) ii,Expnt(ii)
      end do
      write(6,*) '------------'
      write(6,*) 'ccoef:'
      do ii = 1, nprim
       write(6,*) ii, CCoef(ii)
      end do
      write(6,*) '------------'

   END SUBROUTINE fmm_init_basis

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_final

      USE fmm_shell_pairs, ONLY: fmm_free_shell_pairs

      DEALLOCATE(basis%Centr)
      DEALLOCATE(basis%KAtom)
      DEALLOCATE(basis%KType)
      DEALLOCATE(basis%KStart)
      DEALLOCATE(basis%KontG)
      DEALLOCATE(basis%KLoc_Car)
      DEALLOCATE(basis%Expnt)
      DEALLOCATE(basis%CCoef)
      DEALLOCATE(basis%LtuvMin_Car)
      DEALLOCATE(basis%LtuvMax_Car)
      DEALLOCATE(basis%Lt)
      DEALLOCATE(basis%Lu)
      DEALLOCATE(basis%Lv)
      CALL fmm_free_shell_pairs

   END SUBROUTINE fmm_final

!-------------------------------------------------------------------------------

END MODULE fmm_interface

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine igaussj_cvb(orbs,igjorb)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension orbs(norb,norb),igjorb(*)
c  *********************************************************************
c  *                                                                   *
c  *  GAUSSJ    := Define sequence of simple updates from orb transf.  *
c  *                                                                   *
c  *********************************************************************

      call igaussj_cvb_internal(igjorb)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine igaussj_cvb_internal(igjorb)
      use iso_c_binding
      integer, target :: igjorb(*)
      real*8, pointer :: gjorb(:)
      k1 = mstackr_cvb(norb*norb)
      k2 = mstacki_cvb(norb)
      k3 = mstacki_cvb(norb)
      k4 = mstacki_cvb(norb)
      call fmove_cvb(orbs,w(k1),norb*norb)
      ioff=idbl_cvb(norb*norb)
      call c_f_pointer(c_loc(igjorb(1)),gjorb,[norb*norb])
      call gaussj2_cvb(w(k1),iw(k2),iw(k3),iw(k4),
     >  igjorb(1+ioff),igjorb(1+norb+ioff),gjorb,norb)
      nullify(gjorb)
      call imove_cvb(igjorb(1+ioff),iw(k2),norb)
      do 100 i=1,norb
      igjorb(iw(i+k2-1)+ioff)=i
100   continue
      call mfreer_cvb(k1)
      return
      end subroutine igaussj_cvb_internal
*
      end
*
      subroutine gaussj_cvb(orbs,gjorb)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
      dimension orbs(norb,norb),gjorb(*)
      call gaussj_cvb_internal(gjorb)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine gaussj_cvb_internal(gjorb)
      use iso_c_binding
      real*8, target :: gjorb(*)
      integer, pointer :: igjorb(:)
      call c_f_pointer(c_loc(gjorb(1)),igjorb,[1])
      call igaussj_cvb(orbs,igjorb)
      nullify(igjorb)
      end subroutine gaussj_cvb_internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine MKBNEVAC_E3(nAshT,NG3,Hact,Htilde,Gact,G1,G2,G3,idxG3)

use Index_Functions, only: nTri_Elem
use caspt2_global, only: LUSBT
use caspt2_module, only: NINDEP, NSYM, NTUV
use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array, GA_Arrays
use SC_NEVPT2, only: IDBMAT_NEVPT2
#ifdef _MOLCAS_MPP_
use Index_Functions, only: iTri
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
use Definitions, only: u6
#endif
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: nAshT, NG3
real(kind=wp), intent(in) :: Hact(nAshT,nAshT), Htilde(nAshT,nAshT), Gact(nAshT,nAshT,nAshT,nAshT), G1(nAshT,nAshT), &
                             G2(nAshT,nAshT,nAshT,nAshT), G3(NG3)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: ICASE1, ICASE4, idisk, ISYM, lg_BA, lg_BC, NASA, NASC, NBA, NBC, NINA, NINC
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: IHIA, IHIC, ii, ILOA, ILOC, JHIA, JHIC, jj, JLOA, JLOC, LDA, LDC, lg_BASQ, lg_BCSQ, MA, MC, MYRANK
#endif

ICASE1 = 1
ICASE4 = 4
do ISYM=1,NSYM
  NINA = NINDEP(ISYM,ICASE1)
  NINC = NINDEP(ISYM,ICASE4)
  if ((NINA == 0) .and. (NINC == 0)) cycle
  NASA = NTUV(ISYM)
  NASC = NTUV(ISYM)
  NBA = nTri_Elem(NASA)
  NBC = nTri_Elem(NASC)
  if ((NBA <= 0) .and. (NBC <= 0)) cycle

    !! Here uses triangular arrays
  lg_BA = Allocate_GA_Array(NBA,'BA')
  lg_BC = Allocate_GA_Array(NBC,'BC')

  ! fill in the 3-el parts
  call MKBNEVAC_E3x(ISYM,nAshT,NG3,NBA,NBC,GA_Arrays(lg_BA)%A(:),GA_Arrays(lg_BC)%A(:),G1,G2,G3,Hact,Htilde,Gact,idxG3)

  ! this is done intentionally before GADGOP
  ! summation will be done in MKBNEVAC_E4
  idisk = IDBMAT_NEVPT2(iSym,iCase1,1)
  call DDAFILE(LUSBT,1,GA_Arrays(lg_BA)%A(1),NBA,IDISK)
  idisk = IDBMAT_NEVPT2(iSym,iCase4,1)
  call DDAFILE(LUSBT,1,GA_Arrays(lg_BC)%A(1),NBC,IDISK)

# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    call GADGOP(GA_Arrays(lg_BA)%A(:),NBA,'+')
    call GADGOP(GA_Arrays(lg_BC)%A(:),NBC,'+')

    MYRANK = GA_NODEID()
    ! Put the partial contribution to the squared matrix
    call PSBMAT_GETMEM('BA',lg_BASQ,NASA)
    call GA_DISTRIBUTION(LG_BASQ,MYRANK,ILOA,IHIA,JLOA,JHIA)
    if ((JLOA /= 0) .and. (JHIA-JLOA+1 /= NASA)) then
      write(u6,*) 'MKBA: MISMATCH IN RANGE OF THE SUPERINDICES'
      call ABEND()
    end if
    if ((ILOA > 0) .and. (JLOA > 0)) then
      call GA_ACCESS(LG_BASQ,ILOA,IHIA,JLOA,JHIA,MA,LDA)
      do ii=iloa,ihia
        do jj=jloa,jhia
          DBL_MB(MA+ii-iloa+LDA*(jj-jloa)) = GA_Arrays(lg_BA)%A(iTri(ii,jj))
        end do
      end do
      call GA_RELEASE_UPDATE(LG_BASQ,ILOA,IHIA,JLOA,JHIA)
    end if
    call PSBMAT_WRITE('B',iCase1,iSYM,lg_BASQ,NASA)
    call PSBMAT_FREEMEM(lg_BASQ)

    call PSBMAT_GETMEM('BC',lg_BCSQ,NASC)
    call GA_DISTRIBUTION(LG_BCSQ,MYRANK,ILOC,IHIC,JLOC,JHIC)
    if ((JLOC /= 0) .and. (JHIC-JLOC+1 /= NASC)) then
      write(u6,*) 'MKBC: MISMATCH IN RANGE OF THE SUPERINDICES'
      call ABEND()
    end if
    if ((ILOC > 0) .and. (JLOC > 0)) then
      call GA_ACCESS(LG_BCSQ,ILOC,IHIC,JLOC,JHIC,MC,LDC)
      do ii=iloc,ihic
        do jj=jloc,jhic
          DBL_MB(MC+ii-iloc+LDC*(jj-jloc)) = GA_Arrays(lg_BC)%A(iTri(ii,jj))
        end do
      end do
      call GA_RELEASE_UPDATE(LG_BCSQ,ILOC,IHIC,JLOC,JHIC)
    end if
    call PSBMAT_WRITE('B',iCase4,iSYM,lg_BCSQ,NASC)
    call PSBMAT_FREEMEM(lg_BCSQ)
  else
# endif
    call PSBMAT_WRITE('B',iCase1,iSYM,lg_BA,NASA)
    call PSBMAT_WRITE('B',iCase4,iSYM,lg_BC,NASC)
# ifdef _MOLCAS_MPP_
  end if
# endif
  call Deallocate_GA_Array(lg_BA)
  call Deallocate_GA_Array(lg_BC)
end do

end subroutine MKBNEVAC_E3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine axesx2_cvb(asonc,ddres2upd,vec,resthr_inp,ioptc,iter,fx_exp,sxc,share,solp_res)

use casvb_global, only: ap, axc, c, corenrg, ifollow, ipdd, isaddledd, maxd, mxit, nfrdim, nortiterdd, nparm, nvguess, nvrestart, &
                        orththrdd, res, resthrdd, solp
use casvb_interfaces, only: ddasonc_sub, ddres_sub, ddres2upd_sub, ddsol_sub
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
procedure(ddasonc_sub) :: asonc
procedure(ddres2upd_sub) :: ddres2upd
real(kind=wp), intent(out) :: vec(nparm), fx_exp, solp_res(maxd)
real(kind=wp), intent(in) :: resthr_inp
integer(kind=iwp), intent(out) :: ioptc, iter
real(kind=wp), intent(inout) :: sxc(nparm,maxd)
logical(kind=iwp), intent(in) :: share
real(kind=wp) :: dum(1), resthr_use
procedure(ddres_sub) :: axesxres_cvb
procedure(ddsol_sub) :: axexsol_cvb

! If RESTHR_INP unset use default:
if (resthr_inp /= Zero) then
  resthr_use = resthr_inp
else
  resthr_use = resthrdd
end if

call dirdiag_cvb(asonc,axexsol_cvb,axesxres_cvb,ddres2upd,c,axc,sxc,share,vec,res,dum,ap,dum,solp,solp_res,.false.,.true.,.false., &
                 maxd,nparm,nfrdim,nvguess,nvrestart,isaddledd,ifollow,mxit,resthr_use,orththrdd,nortiterdd,corenrg,ioptc,iter, &
                 fx_exp,ipdd)

return

end subroutine axesx2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FTwo_Drv(nSym,nBas,nAsh,nSkipX,DI,D1A,FA,nTot1,ExFac,nBMX,CMO)

use Fock_util_interface, only: CHORAS_DRV
use Fock_util_global, only: ALGO
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(8), nAsh(8), nSkipX(8), nTot1, nBMX
real(kind=wp), intent(in) :: DI(*), D1A(*), CMO(*), ExFac
real(kind=wp), intent(inout) :: FA(*)
logical(kind=iwp) :: DoCholesky
type(DSBA_Type) :: WFSQ(1)
real(kind=wp), allocatable :: Temp(:)

!                                                                      *
!***********************************************************************
!                                                                      *
call DecideOncholesky(DoCholesky)

if (DoCholesky .and. (ALGO == 2)) then

  ! Building of the Fock matrix directly from Cholesky vectors

  call Allocate_DT(WFSQ(1),nBas,nBas,nSym)
  WFSQ(1)%A0(:) = Zero

  call mma_allocate(Temp,nTot1,Label='nTot1')
  Temp(:) = Zero

  call CHORAS_DRV(nSym,nBas,nAsh,D1A,DI,Temp,ExFac,WFSQ,CMO)

  FA(1:nTot1) = FA(1:nTot1)+Temp(1:nTot1)

  call mma_deallocate(Temp)
  call Deallocate_DT(WFSQ(1))

else

  ! Standard building of the Fock matrix from Two-el integrals

  call FockTwo_Drv(nSym,nBas,nAsh,nSkipX,DI,D1A,FA,nTot1,ExFac,nBMX)

end if

return

end subroutine FTwo_Drv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  DEV2B  := calculate two-electron Hessian                         *
c  *                                                                   *
c  *********************************************************************
      subroutine dev2b_2_cvb(v1,v2,cfrom,hessorb,hesst,oaa2,aa1,
     >  nprorb,
     > i1alf,i1bet,iafrm,ibfrm,iato,ibto,phato,phbto,
     > iapr,ixapr,ibpr,ixbpr,npvb,
     > gx,grad2,
     > nda,ndb,n1a,n1b,nam1,nbm1,norb,commut,sc,absym)
c  Calculates V1 EijEkl CFROM and V2 EijEkl CFROM
      implicit real*8 (a-h,o-z)
      logical commut,sc,absym
      dimension v1(nda,ndb),v2(nda,ndb),cfrom(nda,ndb)
      dimension hessorb(nprorb,nprorb),hesst(norb*norb,norb*norb)
      dimension i1alf(n1a,norb),i1bet(n1b,norb)
      dimension iafrm(norb,nda),ibfrm(norb,ndb)
      dimension iato(norb,0:nam1),ibto(norb,0:nbm1)
      dimension phato(norb,nam1),phbto(norb,nbm1)
      dimension iapr(npvb),ixapr(nda+1),ibpr(npvb),ixbpr(ndb+1)
      dimension gx(norb,norb),grad2(nprorb)
      save zero,two
      data zero/0.0d0/,two/2d0/

      do 9379 ip1=1,norb*norb
      iorb=(ip1-1)/norb+1
      jorb=ip1-(iorb-1)*norb
      do 9380 ip2=1,ip1
      korb=(ip2-1)/norb+1
      lorb=ip2-(korb-1)*norb
      res1=zero
      res2=zero
      if(commut.and..not.sc)then
c  1) Alpha excitation
      do 1100 ia=1,n1a
      iaxtmp=i1alf(ia,iorb)
      jax=iato(jorb,iaxtmp)
      if(jax.ne.0)then
        iax=iato(iorb,iaxtmp)
        tcof=phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
c  I -> J
        do 1200 ixa=ixapr(iax),ixapr(iax+1)-1
        ibx=iapr(ixa)
c 2. alpha k -> l
        itmp=iafrm(korb,jax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(kax,ibx)*term
          res2=res2+v2(kax,ibx)*term
        endif
c 2. alpha l -> k
        itmp=iafrm(lorb,iax)
        lax=iato(korb,itmp)
        if(lax.ne.0)then
          phase=phato(lorb,itmp)*phato(korb,itmp)
          term=tcof*phase*cfrom(lax,ibx)
          res1=res1-v1(jax,ibx)*term
          res2=res2-v2(jax,ibx)*term
        endif
c 2. beta  k -> l
        itmp=ibfrm(korb,ibx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(jax,kbx)*term
          res2=res2+v2(jax,kbx)*term
        endif
c 2. beta  l -> k
        itmp=ibfrm(lorb,ibx)
        lbx=ibto(korb,itmp)
        if(lbx.ne.0)then
          phase=phbto(lorb,itmp)*phbto(korb,itmp)
          term=tcof*phase*cfrom(iax,lbx)
          res1=res1-v1(jax,ibx)*term
          res2=res2-v2(jax,ibx)*term
        endif
1200    continue
c  J -> I
        do 1300 ixa=ixapr(jax),ixapr(jax+1)-1
        ibx=iapr(ixa)
c 2. alpha k -> l
        itmp=iafrm(korb,jax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1-v1(kax,ibx)*term
          res2=res2-v2(kax,ibx)*term
        endif
c 2. alpha l -> k
        itmp=iafrm(lorb,iax)
        lax=iato(korb,itmp)
        if(lax.ne.0)then
          phase=phato(lorb,itmp)*phato(korb,itmp)
          term=tcof*phase*cfrom(lax,ibx)
          res1=res1+v1(jax,ibx)*term
          res2=res2+v2(jax,ibx)*term
        endif
c 2. beta  k -> l
        itmp=ibfrm(korb,ibx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1-v1(jax,kbx)*term
          res2=res2-v2(jax,kbx)*term
        endif
c 2. beta  l -> k
        itmp=ibfrm(lorb,ibx)
        lbx=ibto(korb,itmp)
        if(lbx.ne.0)then
          phase=phbto(lorb,itmp)*phbto(korb,itmp)
          term=tcof*phase*cfrom(iax,lbx)
          res1=res1+v1(jax,ibx)*term
          res2=res2+v2(jax,ibx)*term
        endif
1300    continue
      endif
1100  continue

      if(absym)then
        res1=two*res1
        res2=two*res2
      else
c  2) Beta excitation
      do 2100 ib=1,n1b
      ibxtmp=i1bet(ib,iorb)
      jbx=ibto(jorb,ibxtmp)
      if(jbx.ne.0)then
        ibx=ibto(iorb,ibxtmp)
        tcof=phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
c  I -> J
        do 2200 ixb=ixbpr(ibx),ixbpr(ibx+1)-1
        iax=ibpr(ixb)
c 2. beta  k -> l
        itmp=ibfrm(korb,jbx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(iax,kbx)*term
          res2=res2+v2(iax,kbx)*term
        endif
c 2. beta  l -> k
        itmp=ibfrm(lorb,ibx)
        lbx=ibto(korb,itmp)
        if(lbx.ne.0)then
          phase=phbto(lorb,itmp)*phbto(korb,itmp)
          term=tcof*phase*cfrom(iax,lbx)
          res1=res1-v1(iax,jbx)*term
          res2=res2-v2(iax,jbx)*term
        endif
c 2. alpha k -> l
        itmp=iafrm(korb,iax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(kax,jbx)*term
          res2=res2+v2(kax,jbx)*term
        endif
c 2. alpha l -> k
        itmp=iafrm(lorb,iax)
        lax=iato(korb,itmp)
        if(lax.ne.0)then
          phase=phato(lorb,itmp)*phato(korb,itmp)
          term=tcof*phase*cfrom(lax,ibx)
          res1=res1-v1(iax,jbx)*term
          res2=res2-v2(iax,jbx)*term
        endif
2200    continue
c  J -> I
        do 2300 ixb=ixbpr(jbx),ixbpr(jbx+1)-1
        iax=ibpr(ixb)
c 2. beta  k -> l
        itmp=ibfrm(korb,jbx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1-v1(iax,kbx)*term
          res2=res2-v2(iax,kbx)*term
        endif
c 2. beta  l -> k
        itmp=ibfrm(lorb,ibx)
        lbx=ibto(korb,itmp)
        if(lbx.ne.0)then
          phase=phbto(lorb,itmp)*phbto(korb,itmp)
          term=tcof*phase*cfrom(iax,lbx)
          res1=res1+v1(iax,jbx)*term
          res2=res2+v2(iax,jbx)*term
        endif
c 2. alpha k -> l
        itmp=iafrm(korb,iax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1-v1(kax,jbx)*term
          res2=res2-v2(kax,jbx)*term
        endif
c 2. alpha l -> k
        itmp=iafrm(lorb,iax)
        lax=iato(korb,itmp)
        if(lax.ne.0)then
          phase=phato(lorb,itmp)*phato(korb,itmp)
          term=tcof*phase*cfrom(lax,ibx)
          res1=res1+v1(iax,jbx)*term
          res2=res2+v2(iax,jbx)*term
        endif
2300    continue
      endif
2100  continue
      endif
      elseif((.not.commut).and..not.sc)then
c  1) Alpha excitation
      do 3100 ia=1,n1a
      iaxtmp=i1alf(ia,iorb)
      jax=iato(jorb,iaxtmp)
      if(jax.ne.0)then
        iax=iato(iorb,iaxtmp)
        tcof=phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
c  I -> J
        do 3200 ixa=ixapr(iax),ixapr(iax+1)-1
        ibx=iapr(ixa)
c 2. alpha k -> l
        itmp=iafrm(korb,jax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(kax,ibx)*term
          res2=res2+v2(kax,ibx)*term
        endif
c 2. beta  k -> l
        itmp=ibfrm(korb,ibx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(jax,kbx)*term
          res2=res2+v2(jax,kbx)*term
        endif
3200    continue
      endif
3100  continue

      if(absym)then
        res1=two*res1
        res2=two*res2
      else
c  2) Beta excitation
      do 4100 ib=1,n1b
      ibxtmp=i1bet(ib,iorb)
      jbx=ibto(jorb,ibxtmp)
      if(jbx.ne.0)then
        ibx=ibto(iorb,ibxtmp)
        tcof=phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
c  I -> J
        do 4200 ixb=ixbpr(ibx),ixbpr(ibx+1)-1
        iax=ibpr(ixb)
c 2. beta  k -> l
        itmp=ibfrm(korb,jbx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(iax,kbx)*term
          res2=res2+v2(iax,kbx)*term
        endif
c 2. alpha k -> l
        itmp=iafrm(korb,iax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(kax,jbx)*term
          res2=res2+v2(kax,jbx)*term
        endif
4200    continue
      endif
4100  continue
      endif
      elseif(commut.and.sc)then
c  1) Alpha excitation
      do 1103 ia=1,n1a
      iaxtmp=i1alf(ia,iorb)
      jax=iato(jorb,iaxtmp)
      if(jax.ne.0)then
        iax=iato(iorb,iaxtmp)
        tcof=phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
c  I -> J
        ibx=ndb-iax+1
c 2. alpha k -> l
        itmp=iafrm(korb,jax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(kax,ibx)*term
          res2=res2+v2(kax,ibx)*term
        endif
c 2. alpha l -> k
        itmp=iafrm(lorb,iax)
        lax=iato(korb,itmp)
        if(lax.ne.0)then
          phase=phato(lorb,itmp)*phato(korb,itmp)
          term=tcof*phase*cfrom(lax,ibx)
          res1=res1-v1(jax,ibx)*term
          res2=res2-v2(jax,ibx)*term
        endif
c 2. beta  k -> l
        itmp=ibfrm(korb,ibx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(jax,kbx)*term
          res2=res2+v2(jax,kbx)*term
        endif
c 2. beta  l -> k
        itmp=ibfrm(lorb,ibx)
        lbx=ibto(korb,itmp)
        if(lbx.ne.0)then
          phase=phbto(lorb,itmp)*phbto(korb,itmp)
          term=tcof*phase*cfrom(iax,lbx)
          res1=res1-v1(jax,ibx)*term
          res2=res2-v2(jax,ibx)*term
        endif
c  J -> I
        ibx=ndb-jax+1
c 2. alpha k -> l
        itmp=iafrm(korb,jax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1-v1(kax,ibx)*term
          res2=res2-v2(kax,ibx)*term
        endif
c 2. alpha l -> k
        itmp=iafrm(lorb,iax)
        lax=iato(korb,itmp)
        if(lax.ne.0)then
          phase=phato(lorb,itmp)*phato(korb,itmp)
          term=tcof*phase*cfrom(lax,ibx)
          res1=res1+v1(jax,ibx)*term
          res2=res2+v2(jax,ibx)*term
        endif
c 2. beta  k -> l
        itmp=ibfrm(korb,ibx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1-v1(jax,kbx)*term
          res2=res2-v2(jax,kbx)*term
        endif
c 2. beta  l -> k
        itmp=ibfrm(lorb,ibx)
        lbx=ibto(korb,itmp)
        if(lbx.ne.0)then
          phase=phbto(lorb,itmp)*phbto(korb,itmp)
          term=tcof*phase*cfrom(iax,lbx)
          res1=res1+v1(jax,ibx)*term
          res2=res2+v2(jax,ibx)*term
        endif
      endif
1103  continue

      if(absym)then
        res1=two*res1
        res2=two*res2
      else
c  2) Beta excitation
      do 2103 ib=1,n1b
      ibxtmp=i1bet(ib,iorb)
      jbx=ibto(jorb,ibxtmp)
      if(jbx.ne.0)then
        ibx=ibto(iorb,ibxtmp)
        tcof=phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
c  I -> J
        iax=nda-ibx+1
c 2. beta  k -> l
        itmp=ibfrm(korb,jbx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(iax,kbx)*term
          res2=res2+v2(iax,kbx)*term
        endif
c 2. beta  l -> k
        itmp=ibfrm(lorb,ibx)
        lbx=ibto(korb,itmp)
        if(lbx.ne.0)then
          phase=phbto(lorb,itmp)*phbto(korb,itmp)
          term=tcof*phase*cfrom(iax,lbx)
          res1=res1-v1(iax,jbx)*term
          res2=res2-v2(iax,jbx)*term
        endif
c 2. alpha k -> l
        itmp=iafrm(korb,iax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(kax,jbx)*term
          res2=res2+v2(kax,jbx)*term
        endif
c 2. alpha l -> k
        itmp=iafrm(lorb,iax)
        lax=iato(korb,itmp)
        if(lax.ne.0)then
          phase=phato(lorb,itmp)*phato(korb,itmp)
          term=tcof*phase*cfrom(lax,ibx)
          res1=res1-v1(iax,jbx)*term
          res2=res2-v2(iax,jbx)*term
        endif
c  J -> I
        iax=nda-jbx+1
c 2. beta  k -> l
        itmp=ibfrm(korb,jbx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1-v1(iax,kbx)*term
          res2=res2-v2(iax,kbx)*term
        endif
c 2. beta  l -> k
        itmp=ibfrm(lorb,ibx)
        lbx=ibto(korb,itmp)
        if(lbx.ne.0)then
          phase=phbto(lorb,itmp)*phbto(korb,itmp)
          term=tcof*phase*cfrom(iax,lbx)
          res1=res1+v1(iax,jbx)*term
          res2=res2+v2(iax,jbx)*term
        endif
c 2. alpha k -> l
        itmp=iafrm(korb,iax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1-v1(kax,jbx)*term
          res2=res2-v2(kax,jbx)*term
        endif
c 2. alpha l -> k
        itmp=iafrm(lorb,iax)
        lax=iato(korb,itmp)
        if(lax.ne.0)then
          phase=phato(lorb,itmp)*phato(korb,itmp)
          term=tcof*phase*cfrom(lax,ibx)
          res1=res1+v1(iax,jbx)*term
          res2=res2+v2(iax,jbx)*term
        endif
      endif
2103  continue
      endif
      elseif((.not.commut).and.sc)then
c  1) Alpha excitation
      do 3103 ia=1,n1a
      iaxtmp=i1alf(ia,iorb)
      jax=iato(jorb,iaxtmp)
      if(jax.ne.0)then
        iax=iato(iorb,iaxtmp)
        tcof=phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
c  I -> J
        ibx=ndb-iax+1
c 2. alpha k -> l
        itmp=iafrm(korb,jax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(kax,ibx)*term
          res2=res2+v2(kax,ibx)*term
        endif
c 2. beta  k -> l
        itmp=ibfrm(korb,ibx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(jax,kbx)*term
          res2=res2+v2(jax,kbx)*term
        endif
      endif
3103  continue

      if(absym)then
        res1=two*res1
        res2=two*res2
      else
c  2) Beta excitation
      do 4103 ib=1,n1b
      ibxtmp=i1bet(ib,iorb)
      jbx=ibto(jorb,ibxtmp)
      if(jbx.ne.0)then
        ibx=ibto(iorb,ibxtmp)
        tcof=phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
c  I -> J
        iax=nda-ibx+1
c 2. beta  k -> l
        itmp=ibfrm(korb,jbx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
          phase=phbto(korb,itmp)*phbto(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(iax,kbx)*term
          res2=res2+v2(iax,kbx)*term
        endif
c 2. alpha k -> l
        itmp=iafrm(korb,iax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
          phase=phato(korb,itmp)*phato(lorb,itmp)
          term=tcof*phase*cfrom(iax,ibx)
          res1=res1+v1(kax,jbx)*term
          res2=res2+v2(kax,jbx)*term
        endif
      endif
4103  continue
      endif
      endif
      hesst(ip2,ip1)=res1
      if(ip1.ne.ip2)then
c  E_ji E_lk = E_lk E_ji - \delta_kj E_li + \delta_il E_jk
        hesst(ip1,ip2)=res1
        if(korb.eq.jorb)hesst(ip1,ip2)=hesst(ip1,ip2)-gx(lorb,iorb)
        if(iorb.eq.lorb)hesst(ip1,ip2)=hesst(ip1,ip2)+gx(jorb,korb)
      endif
      if(iorb.ne.jorb.and.korb.ne.lorb)then
        t1=res1
        t2=res2
        if(jorb.eq.korb.and.iorb.ne.lorb)then
          t1=t1-gx(lorb,iorb)
          li=lorb+(iorb-1)*(norb-1)
          if(lorb.gt.iorb)li=li-1
          t2=t2-grad2(li)
        endif
        ji=jorb+(iorb-1)*(norb-1)
        if(jorb.gt.iorb)ji=ji-1
        lk=lorb+(korb-1)*(norb-1)
        if(lorb.gt.korb)lk=lk-1
        hessorb(ji,lk)=hessorb(ji,lk)+oaa2*t1+aa1*t2
        hessorb(lk,ji)=hessorb(ji,lk)
      endif
9380  continue
9379  continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine fokunpck4 (fok,fii,dimfok,dimfi)
c
c     this routine distribute (Fok - dp) to Fii
c     fok    - Fok matrix (I)
c     fii    - Fii matrix (O)
c     dimfok - dimension for Fok matrix - norb (I)
c     dimfi  - dimension of occupied - no (I)
c
       integer dimfok,dimfi
c
       real*8 fok(1:dimfok,1:dimfok)
       real*8 fii(1:dimfi,1:dimfi)
c
c     help variables
c
       integer i,j
c
c1    distribute Fok to Fii
       do 400 j=1,dimfi
       do 401 i=1,dimfi
       fii(i,j)=fok(i,j)
 401    continue
 400    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine pack311 (ap,am,b,dimp,dimq,dimr,rc)
c
c     this routine do: B(p,q,r) = A+(p,q,r) - A-(q,p,r) for symp>symq
c
       integer dimp,dimq,dimr,rc
       real*8 ap(1:dimp,1:dimq,1:dimr)
       real*8 am(1:dimq,1:dimp,1:dimr)
       real*8 b(1:dimp,1:dimq,1:dimr)
c
c     help variables
c
       integer p,q,r
c
       rc=0
       do 100 r=1,dimr
       do 101 q=1,dimq
       do 102 p=1,dimp
       b(p,q,r)=ap(p,q,r)-am(q,p,r)
 102    continue
 101    continue
 100    continue
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

subroutine CSDTMT(IDFTP,ICFTP,DTOC,PSSIGN)
! Construct list of prototype combinations in IDFTP
! Construct list of prototype CSF'S, in ICFTP
! Construct matrix expanding prototype CSF's in terms of
! prototype combinations in DTOC

use MCLR_Data, only: MINOP, MS2P, MULTSP, NCPCNT, NDPCNT, NTYP
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(inout) :: IDFTP(*), ICFTP(*)
real(kind=wp), intent(_OUT_) :: DTOC(*)
real(kind=wp), intent(in) :: PSSIGN
integer(kind=iwp) :: ICDCBS, ICSBS, IDTBS, IOPEN, ITP, MS2, MULTS, NNDET
integer(kind=iwp), allocatable :: SCR7(:)

MULTS = MULTSP
MS2 = MS2P

! Set up determinants and upper determinants

IDTBS = 0 ! dummy initialize
ICSBS = 0 ! dummy initialize
do ITP=1,NTYP
  IOPEN = MINOP+ITP-1
  if (ITP == 1) then
    IDTBS = 1
    ICSBS = 1
  else
    IDTBS = IDTBS+(IOPEN-1)*NDPCNT(ITP-1)
    ICSBS = ICSBS+(IOPEN-1)*NCPCNT(ITP-1)
  end if

  if (IOPEN /= 0) then
    call mma_allocate(SCR7,IOPEN+1,Label='SCR7')
    ! Proto type determinants and upper determinants
    if (MS2+1 == MULTS) then
      call SPNCOM_MCLR(scr7,IOPEN,MS2,NNDET,IDFTP(IDTBS),ICFTP(ICSBS),2,PSSIGN)
    else
      call SPNCOM_MCLR(scr7,IOPEN,MS2,NNDET,IDFTP(IDTBS),ICFTP(ICSBS),1,PSSIGN)
      call SPNCOM_MCLR(scr7,IOPEN,MULTS-1,NNDET,IDFTP(IDTBS),ICFTP(ICSBS),3,PSSIGN)
    end if
    call mma_deallocate(SCR7)
  end if
end do
! Matrix expressing csf's in terms of combinations
IDTBS = 1
ICSBS = 1
ICDCBS = 1
do ITP=1,NTYP
  IOPEN = MINOP+ITP-1
  if (ITP > 1) then
    IDTBS = IDTBS+(IOPEN-1)*NDPCNT(ITP-1)
    ICSBS = ICSBS+(IOPEN-1)*NCPCNT(ITP-1)
    ICDCBS = ICDCBS+NDPCNT(ITP-1)*NCPCNT(ITP-1)
  end if
  if (NDPCNT(ITP)*NCPCNT(ITP) == 0) cycle
  if (IOPEN == 0) then
    DTOC(ICDCBS) = One
  else
    call CSFDET_MCLR(IOPEN,IDFTP(IDTBS),NDPCNT(ITP),ICFTP(ICSBS),NCPCNT(ITP),DTOC(ICDCBS),PSSIGN)
  end if
end do

end subroutine CSDTMT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contract_Zpk_Tpxy(Zpk,nZpk,Txy,nTxy,Scrt,nScrt,Diag,nDiag,nnP,nBas_Aux,nAdens,nAvec,nAct,nIrrep)

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZpk, nTxy, nScrt, nDiag, nIrrep, nnP(0:nIrrep-1), nBas_Aux(0:nIrrep-1), nAdens, nAvec, &
                                 nAct(0:nIrrep-1)
real(kind=wp), intent(inout) :: Zpk(nZpk,nAVec)
real(kind=wp), intent(in) :: Txy(nTxy,nAdens), Diag(nDiag,nADens)
real(kind=wp), intent(out) :: Scrt(nScrt)
integer(kind=iwp) :: i, iDen, ip, iSym, j, jp, jSym, k, kp, kSym, l, nCumnnP, nCumnnP2, nCumnnP3

!***********************************************************************

do l=1,nAVec
  iDen = 1
  if (l > 1) iDen = 2

  nCumnnP = 0
  nCumnnP2 = 0
  nCumnnP3 = 0
  do iSym=0,nIrrep-1
    do i=1,nBas_Aux(iSym)
      ip = nCumnnP2+(i-1)*nnP(iSym)
      do j=1,nnP(iSym)
        Scrt(j) = Zero
        do k=1,nnP(iSym)
          kp = nCumnnP3+(k-1)*nnP(iSym)
          Scrt(j) = Scrt(j)+sign(One,Diag(nCumnnP+k,iDen))*Zpk(k+ip,l)*Txy(j+kp,iDen)
        end do
      end do
      Zpk(ip+1:ip+nnP(iSym),l) = Scrt(1:nnP(iSym))
    end do
    ! Now correct for the 2 factor
    do i=1,nBas_Aux(iSym)
      ip = nCumnnP2+(i-1)*nnP(iSym)
      do jSym=0,nIrrep-1
        kSym = Mul(jsym+1,isym+1)-1
        if (kSym <= jSym) then
          do j=1,nAct(jSym)
            if (kSym == jSym) then
              jp = ip+nTri_Elem(j-1)
              Zpk(jp+1:jp+j-1,l) = Half*Zpk(jp+1:jp+j-1,l)
            else
              jp = ip+(j-1)*nAct(kSym)
              Zpk(jp+1:jp+nAct(kSym),l) = Half*Zpk(jp+1:jp+nAct(kSym),l)
            end if
          end do
          if (kSym == jSym) then
            ip = ip+nTri_Elem(nAct(jSym))
          else
            ip = ip+nAct(jSym)*nAct(kSym)
          end if
        end if
      end do
    end do

    !call RecPrt('Zpk',' ',Zpk(nCumnnP2+1,l),nnP(iSym),nBas_Aux(iSym))
    nCumnnP = nCumnnP+nnP(iSym)
    nCumnnP2 = nCumnnP2+nnP(iSym)*nBas_Aux(iSym)
    nCumnnP3 = nCumnnP3+nnP(iSym)**2
  end do
end do

end subroutine contract_Zpk_Tpxy

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_K(K,dimbe,addbe,dima,adda)
! check K(be,u,i,a)

use chcc_global, only: Kc, no
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dimbe, addbe, dima, adda
real(kind=wp), intent(in) :: K(dimbe,no,no,dima)
integer(kind=iwp) :: a, bad, be, i, u
real(kind=wp) :: s

bad = 0
do a=adda+1,adda+dima
  do i=1,no
    do u=1,no
      do be=addbe+1,addbe+dimbe

        s = Kc(i,be,u,a)

        if (abs(K(be-addbe,u,i,a-adda)-s) > 1.0e-10_wp) bad = bad+1

      end do
    end do
  end do
end do

write(u6,*) ' Chck K :',bad
!99 format(a9,1x,i8,1x,4(i3,1x))

return

end subroutine Chck_K

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine transadd(n,a,lda)
! Add the transpose to a square matrix, A := A + A^T

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, lda
real(kind=wp), intent(inout) :: a(lda,n)
! number of blocks, remaining elements
integer(kind=iwp) :: nblk, nrem, iblk, jblk, ista, jsta, i, j
! small buffer block
integer(kind=iwp), parameter :: nblksz = 8

nblk = n/nblksz
nrem = n-nblk*nblksz

! loop over diagonal blocks
do iblk=1,nblk
  ista = nblksz*(iblk-1)+1
  ! add transposed upper to lower triangular part
  do i=1,nblksz
    do j=1,i
      a(ista+i-1,ista+j-1) = a(ista+i-1,ista+j-1)+a(ista+j-1,ista+i-1)
    end do
  end do
  ! copy lower to upper part
  do i=1,nblksz
    do j=1,i-1
      a(ista+j-1,ista+i-1) = a(ista+i-1,ista+j-1)
    end do
  end do
end do
! the tail block
ista = nblksz*nblk+1
! add transposed upper to lower triangular part
do i=1,nrem
  do j=1,i
    a(ista+i-1,ista+j-1) = a(ista+i-1,ista+j-1)+a(ista+j-1,ista+i-1)
  end do
end do
! copy lower to upper part
do i=1,nrem
  do j=1,i-1
    a(ista+j-1,ista+i-1) = a(ista+i-1,ista+j-1)
  end do
end do

! loop over lower triangular blocks
do iblk=1,nblk
  ista = nblksz*(iblk-1)+1
  do jblk=1,iblk-1
    jsta = nblksz*(jblk-1)+1
    ! add transposed upper to lower triangular block
    do j=1,nblksz
      do i=1,nblksz
        a(ista+i-1,jsta+j-1) = a(ista+i-1,jsta+j-1)+a(jsta+j-1,ista+i-1)
      end do
    end do
    ! copy transpose of lower to upper triangular block
    do j=1,nblksz
      do i=1,nblksz
        a(jsta+i-1,ista+j-1) = a(ista+j-1,jsta+i-1)
      end do
    end do
  end do
end do
! bottom blocks
ista = nblksz*nblk+1
do jblk=1,iblk-1
  jsta = nblksz*(jblk-1)+1
  ! add transposed upper to lower triangular block
  do j=1,nblksz
    do i=1,nrem
      a(ista+i-1,jsta+j-1) = a(ista+i-1,jsta+j-1)+a(jsta+j-1,ista+i-1)
    end do
  end do
  ! copy transpose of lower to upper triangular block
  do j=1,nrem
    do i=1,nblksz
      a(jsta+i-1,ista+j-1) = a(ista+j-1,jsta+i-1)
    end do
  end do
end do

end subroutine transadd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Ini_David(nRoots,nConf,nDet,nSel,n_keep,ntAsh,LuDavid)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Prepare address tables for further use by the Davidson           *
!     diagonalization scheme which is written in such a way that       *
!     the mechanism by which I/O is done is hidden in the subroutines  *
!     call load_xxx and save_xxx, where xxx stands may be one of       *
!     the following choices: H_diag, CI_vec, Sig_vec or Tmp_vec.       *
!     If possible (there is enough memory) a write through cache       *
!     mechanism is applied, that is to say all accessible memory is    *
!     used as a RAM-disk and dumped to physical disk in a FIFO mode.   *
!                                                                      *
!     calling arguments:                                               *
!     lRoots  : integer                                                *
!               number of roots to be optimized                        *
!     nConf   : integer                                                *
!               length of the CI vector in the CSF basis               *
!     nDet    : integer                                                *
!               length of the CI vector in the determinant basis       *
!     ntAsh   : integer                                                *
!               total number of active orbitals                        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use davctl_mod, only: disk_address, in_core, istart, LblStk, memory_vectors, mixed_mode_1, mixed_mode_2, mxDiskStk, mxMemStk, &
                      n_Roots, nDiskStk, nkeep, nMemStk, nvec, on_disk, save_in_memory, save_mode
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nRoots, nConf, nDet, nSel, n_keep, ntAsh, LuDavid
integer(kind=iwp) :: CI_vec_RecNo, H_diag_RecNo, iDisk, iRoot, lTmp1, lTmp2, lTmp3, Max_free_Mem, Max_used_Mem, Memory_Needed, &
                     nStk, Sig_vec_RecNo, tmp_CI_vec_RecNo, tmp_Sig_vec_RecNo
real(kind=wp) :: Dum(1)
integer(kind=iwp), external :: RecNo
#include "rasdim.fh"
#include "warnings.h"
#include "rasscf_lucia.fh"

! check input arguments
if (nConf < 0) then
  write(u6,*) 'Ini_David: nConf less than 0'
  write(u6,*) 'nConf = ',nConf
  call Abend()
end if
if (nRoots < 0) then
  write(u6,*) 'Ini_David: nRoots less than zero'
  write(u6,*) 'nRoots = ',nRoots
  call Abend()
end if
if (nRoots > mxRoot) then
  write(u6,*) 'Ini_David: nRoots greater than mxRoot'
  write(u6,*) 'nRoots, mxRoot = ',nRoots,mxRoot
  call Abend()
end if
if (nDet < 0) then
  write(u6,*) 'Ini_David: nDet less than zero'
  write(u6,*) 'nDet = ',nDet
  call Abend()
end if
if (ntAsh < 0) then
  write(u6,*) 'Ini_David: ntAsh less than 0'
  write(u6,*) 'ntAsh = ',ntAsh
  call Abend()
end if
if (ntAsh > mxAct) then
  write(u6,*) 'Ini_David: ntAsh greater than mxAct'
  write(u6,*) 'ntAsh, mxAct = ',ntAsh,mxAct
  call Abend()
end if
n_Roots = nRoots
nkeep = n_keep
! If unitialized, determine a reasonable nkeep
if (nkeep == 0) then
  nkeep = (2*mxRoot)*nRoots
  nkeep = min(nkeep,400)
  nkeep = max(nkeep,3*nRoots)
  nkeep = min(nkeep,2*mxRoot)
end if

istart = 0
nvec = nkeep

! check the amount of available memory and decide which algorithm
! is to be used to save intermediate results
MxMemStk = 0
MxDiskStk = 0
call mma_maxDBLE(Max_free_Mem)
Max_free_Mem = Max_free_Mem-3*(nDet+4)
Max_free_Mem = Max_free_Mem-3*(nConf+4)
Max_free_Mem = Max_free_Mem-2*(ntAsh**3+4)
Max_free_Mem = Max_free_Mem-5*(ntAsh**2+4)
Max_used_Mem = (1+2*nKeep+2*nRoots)*(nConf+4)
! Calculate how much memory is needed in the rest of the Davidson
Memory_Needed = 0
if (ntAsh == 0) then
  Memory_Needed = 0
else if (nSel == nConf) then
  Memory_Needed = 2*nSel+nSel*nSel
else
  ! First: davctl
  Memory_Needed = 2*nSel+nSel*nSel
  ! Now: david5
  lTmp1 = nKeep
  lTmp2 = lTmp1*lTmp1
  lTmp3 = (lTmp2+lTmp1)/2
  Memory_Needed = Memory_Needed+5*nDet+lTmp1+3*lTmp2+2*lTmp3+3*nRoots*nSel
  ! Then: lucia_util
  Memory_Needed = Memory_Needed+Memory_Needed_Lucia
end if

if (Max_free_Mem < (nConf+4+Memory_Needed)) then
  MxMemStk = 0
  MxDiskStk = 1+2*nkeep+2*nRoots
  save_mode = on_disk
else if (Max_free_Mem >= Max_used_Mem+Memory_Needed) then
  MxMemStk = 1+2*nkeep+2*nRoots
  MxDiskStk = 0
  save_mode = in_core
else
  MxMemStk = Max_free_Mem/(nConf+4+Memory_Needed)
  MxDiskStk = 1+2*nkeep+2*nRoots-mxMemStk
  save_mode = mixed_mode_2
  if (mxMemStk < (nkeep+1)) save_mode = mixed_mode_1
end if
nMemStk = 0
nDiskStk = 0

call mma_allocate(disk_address,mxDiskStk,label='disk_address')
call mma_allocate(memory_vectors,nConf,mxMemStk,label='memory_vectors')

select case (save_mode)
  case (in_core)
    ! the diagonalization can be run in core,
    ! there's nothing to be done, everything is already allocated and indexed

  case (on_disk)
    ! the diagonalization must be run out of core:
    ! allocate disk space for all vectors that will be needed
    iDisk = 0
    H_diag_RecNo = RecNo(1,1)
    disk_address(H_diag_RecNo) = iDisk
    Dum(1) = Zero
    call DDafile(LuDavid,0,Dum,nConf,iDisk)
    do iRoot=1,nkeep
      CI_vec_RecNo = RecNo(2,iRoot)
      disk_address(CI_vec_RecNo) = iDisk
      call DDafile(LuDavid,0,Dum,nConf,iDisk)
    end do
    do iRoot=1,nKeep
      Sig_vec_RecNo = RecNo(3,iRoot)
      disk_address(Sig_vec_RecNo) = iDisk
      call DDaFile(LuDavid,0,Dum,nConf,iDisk)
    end do
    do iRoot=1,nRoots
      tmp_CI_vec_RecNo = RecNo(4,iRoot)
      disk_address(tmp_CI_vec_RecNo) = iDisk
      call DDaFile(LuDavid,0,Dum,nConf,iDisk)
    end do
    do iRoot=1,nRoots
      tmp_Sig_vec_RecNo = RecNo(5,iRoot)
      disk_address(tmp_Sig_vec_RecNo) = iDisk
      call DDaFile(LuDavid,0,Dum,nConf,iDisk)
    end do
  case (mixed_mode_1,mixed_mode_2)
    ! the diagonalization may be run in mixed mode:
    ! allocate memory and disk space for all vectors that will be needed
    iDisk = 0
    Dum(1) = Zero
    do nStk=1,mxDiskStk
      disk_address(nStk) = iDisk
      call DDaFile(LuDavid,0,Dum,nConf,iDisk)
    end do
    call mma_allocate(LblStk,mxDiskStk+mxMemStk,label='LblStk')
    LblStk(:) = ''
    save_in_memory = .true.
  case default
    call Abend()
end select

return

end subroutine Ini_David

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_Tra(COrb1,COrb2,Diag,DoDiag,iMoType1,iMoType2)
!
! Jonas Bostrom, Dec. 2004.
!
! Purpose: transform Cholesky vectors to (pq) MO basis.

use Cholesky, only: nSym
use ChoMP2, only: nMoMo, nMoType
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: COrb1(*), COrb2(*)
real(kind=wp), intent(_OUT_) :: Diag(*)
logical(kind=iwp), intent(in) :: DoDiag
integer(kind=iwp) :: iMoType1, iMoType2
integer(kind=iwp) :: iSym, iVecType, kOffD, lw
real(kind=wp), allocatable :: TraMax(:)

! Allocate remaining memory.
! --------------------------

! Check what type of Cholesky vector to make (fro-occ, occ-occ.....)
iVecType = iMoType2+(iMoType1-1)*nMoType

call mma_maxDBLE(lw)
call mma_allocate(TraMax,lW,Label='TraMax')

kOffD = 1
do iSym=1,nSym

  ! Open files for MO vectors.
  ! --------------------------

  call ChoMP2_OpenF(1,1,iSym)

  ! Transform vectors.
  ! ------------------

  call ChoMP2g_Tra_1(COrb1,COrb2,Diag(kOffD),DoDiag,TraMax,lW,iSym,iMoType1,iMoType2)
  kOffD = kOffD+nMoMo(iSym,iVecType)

  ! Close files for MO vectors.
  ! ---------------------------

  call ChoMP2_OpenF(2,1,iSym)

end do

! Free memory.
! ------------

call mma_deallocate(TraMax)

end subroutine ChoMP2g_Tra

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WR_GUGA(Lu,iOpt,iDisk,
     &                   NFREF,S,N,LN,NSYM,IR1,IR2,IFIRST,INTNUM,
     &                   LSYM,NREF,LN1,NRLN1,MUL,nMUL,NSH,NISH,MxSym,
     &                   JRC,nJRC,JJS,nJJS,NVAL,IOCR,nIOCR)
      Implicit Real*8 (a-h,o-z)
      Integer MUL(nMUL), NSH(MxSym), NISH(MxSym), JRC(nJRC),
     &        JJS(nJJS), NVAL(MxSym), IOCR(nIOCR)
*
      Call s_iDaFile_guga(Lu,iOpt,NFREF,    1,iDisk)
      Call s_dDaFile_guga(Lu,iOpt,S,        1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,N,        1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,LN,       1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,NSYM,     1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,IR1,      1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,IR2,      1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,IFIRST,   1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,INTNUM,   1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,LSYM,     1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,NREF,     1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,LN1,      1,iDisk)
      Call s_iDaFile_guga(Lu,iOpt,NRLN1,    1,iDisk)
      Call iDaFile(Lu,iOpt,MUL,   nMUL,iDisk)
      Call iDaFile(Lu,iOpt,NSH,  MxSym,iDisk)
      Call iDaFile(Lu,iOpt,NISH, MxSym,iDisk)
      Call iDaFile(Lu,iOpt,JRC,   nJRC,iDisk)
      Call iDaFile(Lu,iOpt,JJS,   nJJS,iDisk)
      Call iDaFile(Lu,iOpt,NVAL, MxSym,iDisk)
      Call iDaFile(Lu,iOpt,IOCR, nIOCR,iDisk)
*
      Return
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine s_iDaFile_guga(Lu,iOpt,Buf,lBuf_,iDisk_)
      Use Iso_C_Binding
      Integer Lu, iOpt, lBuf_, iDisk_
      Integer, Target :: Buf
      Integer, Pointer :: pBuf(:)
      Call C_F_Pointer(C_Loc(Buf),pBuf,[1])
      Call iDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
      Nullify(pBuf)
      End Subroutine s_iDaFile_guga
      Subroutine s_dDaFile_guga(Lu,iOpt,Buf,lBuf_,iDisk_)
      Use Iso_C_Binding
      Integer Lu, iOpt, lBuf_, iDisk_
      Real*8, Target :: Buf
      Real*8, Pointer :: pBuf(:)
      Call C_F_Pointer(C_Loc(Buf),pBuf,[1])
      Call dDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
      Nullify(pBuf)
      End Subroutine s_dDaFile_guga
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION ISYMCN_MCLR(ICL,IOP,NCL,NOPEN)
*
* Master routine for symmetry of configuration
* with NCL doubly occupied orbitals and NOPEN singly occupied shells
*
#include "detdim.fh"
#include "orbinp_mclr.fh"
      INTEGER ICL(*),IOP(*)
*
      ISYMCN_MCLR = 1
      DO 100 IEL = 1, NOPEN
cVV: this ugly code needed for CRAY SV1
        IVV=ISYMCN_MCLR-1
        JVV=ISMFTO(IOP(IEL))-1
        KVV = IEOR(IVV,JVV)
        ISYMCN_MCLR = KVV+1
100   CONTINUE
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_integer_array(ICL)
         CALL Unused_integer(NCL)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

!  RdChoVec
!
!> @brief
!>   Read dense Cholesky vectors in SO basis
!> @author T. B. Pedersen
!>
!> @details
!> Read dense SO Cholesky vectors \f$ L^J_{pq} \f$ where
!> \f$ J \f$ = \p iVec1, \p iVec1+1, ..., \p iVec1+nVec-1 and indices
!> \f$ p \ge q \f$.
!>
!> @note
!> Cholesky vectors must have been sorted into the
!> dense representation (by the Cholesky utility)
!> and the storage file must be open.
!>
!> @param[out] Vec   Array containing the vectors
!> @param[in]  nDim  Vector dimension
!> @param[in]  nVec  Number of vectors
!> @param[in]  iVec1 Index of first vector
!> @param[in]  Lunit Logical unit number
!***********************************************************************
subroutine RdChoVec(Vec,nDim,nVec,iVec1,Lunit)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, nVec, iVec1, Lunit
real(kind=wp), intent(out) :: Vec(nDim,nVec)
integer(kind=iwp) :: iOpt, iAdr, nTot

iOpt = 2
iAdr = nDim*(iVec1-1)+1
nTot = nDim*nVec
call dDaFile(Lunit,iOpt,Vec,nTot,iAdr)

end subroutine RdChoVec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_PrtMaxMem(Location)
C
C     Purpose: print max. available memory block.
C
      Implicit None
      Character*(*) Location
#include "cholesky.fh"

      Character*2 Unt
      Integer l, kMax, lMax
      Real*8 dlMax

      l = len(Location)
      If (l .lt. 1) Then
         Write(Lupri,'(/,A)')
     &   'Largest memory block available @<UNKNOWN>:'
      Else
         Write(Lupri,'(/,A,A,A)')
     &   'Largest memory block available @',Location(1:l),':'
      End If
      Call GetMem('MxRequest','Max ','Real',kMax,lMax)
      Call Cho_Word2Byte(lMax,8,dlMax,Unt)
      Write(Lupri,'(3X,I10,A,F10.3,A,A)')
     & lMax,' 8-byte words; ',dlMax,' ',Unt

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cvbinp_rvb(icode,luinp)
      use definitions, only: iwp
      implicit None
      integer(kind=iwp), intent(in):: icode,luinp

      call cvbstart_cvb_ge9(icode+10)
      call hello_cvb()
      call parse_init_cvb(luinp)
      call input_cvb()

      end subroutine cvbinp_rvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gugadrt(ireturn)

use gugadrt_global, only: ja, jb, jj, jm, kk, max_node, nci_dim
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(out) :: ireturn
real(kind=wp) :: sc, sc0, sc1
real(kind=r8), external :: seconds

sc0 = seconds()

call mma_allocate(ja,max_node,label='ja')
call mma_allocate(jb,max_node,label='jb')
call mma_allocate(jj,[1,4],[0,max_node],label='jj')
call mma_allocate(jm,[0,max_node],label='jm')
call mma_allocate(kk,[0,max_node],label='kk')
ja(:) = 0
jb(:) = 0
jj(:,:) = 0
jm(:) = 0
kk(:) = 0

call gugainit()

call gugadrt_mole_inf()
call gugadrt_paras_calculate()
call arrange_orbital_molcas()

call gugadrt_dbl_upwalk()       ! add by wyb 01.9.5
call gugadrt_ext_downwalk()     ! add by wyb 01.9.5
call gugadrt_active_drt()       ! add by wyb 01.9.5

call add_info('CI_DIM',[real(nci_dim,kind=wp)],1,1)
call gugadrt_gugafinalize()
ireturn = 0

call mma_deallocate(ja)
call mma_deallocate(jb)
call mma_deallocate(jj)
call mma_deallocate(jm)
call mma_deallocate(kk)

sc1 = seconds()
sc = sc1-sc0
write(6,910) sc

return

910 format(/,1x,'end of job, takes ',f10.2,1x,'seconds'/)

end subroutine gugadrt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      Subroutine Mult_Zp_Qv_s(Zp,nZp,Qv,nQv,Rv,n_Rv,nVec,nMuNu,nI,
     &                        nIrrep,QMode)
************************************************************************
*     Author:   F. Aquilante                                           *
*                                                                      *
*     Qv: is a symmetry blocked square matrix                          *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Real*8 Zp(nZp), Qv(nQv), Rv(n_Rv)
      Integer nVec(0:nIrrep-1), nMuNu(0:nIrrep-1), nI(0:nIrrep-1)
      Character QMode*1, Name_Q*6
*                                                                      *
************************************************************************
*                                                                      *
      lstepA=0
      lstepR=1
      If (Qmode.eq.'T') Then
         Call FZero(Rv,n_Rv)
         lstepA=1
         lstepR=0
      End If
*
      iOffA=1
      iOffR=1

      Do iIrrep = 0, nIrrep-1
         nI_     = nI(iIrrep)
         If (iIrrep.eq.0) nI_=nI_-1
         nMuNu_  = nMuNu(iIrrep)
         If (nMuNu_.le.0 .or. nI_.le.0) Go To 999
*
         iSeed=55+iIrrep
         Lu_Q=IsFreeUnit(iSeed)
         Write(Name_Q,'(A4,I2.2)') 'QVEC',iIrrep
         Call DaName_MF_WA(Lu_Q,Name_Q)
         iAddr=0
*
         iOffR2=iOffR
         iOffA2=iOffA
         mQv = nI_*nVec(iIrrep)
         Do While (mQv.ge.nI_)
*
            nK=Min(mQv,nQv)/nI_
            lQv=nI_*nK
            Call dDaFile(Lu_Q,2,Qv,lQv,iAddr)
*
            Call A_3C_Qv_s(Zp(iOffA2),
     &                     Qv,
     &                     Rv(iOffR2),nMuNu_,nI_,nK,QMode)
            mQv = mQv - lQv
            iOffR2 = iOffR2 + lstepR*nMuNu_*nK
            iOffA2 = iOffA2 + lstepA*nMuNu_*nK
         End Do
*
         iOffA = iOffA + nMuNu_*nI_
         iOffR = iOffR + nMuNu_*nVec(iIrrep)
         Call DaClos(Lu_Q)
 999     Continue
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010,2012,2017, Francesco Aquilante                    *
!               2015,2017, Alexander Zech                              *
!***********************************************************************

subroutine Wrap_DrvNQ(KSDFT,F_DFT,nFckDim,Func,D_DS,nh1,nD_DS,Do_Grad,Grad,nGrad,DFTFOCK)

use nq_Info, only: Dens_I, Grad_I, mBas, mIrrep, nAsh, nFro, nIsh, Tau_I
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: KSDFT
integer(kind=iwp), intent(in) :: nFckDim, nh1, nD_DS, nGrad
real(kind=wp), intent(inout) :: F_DFT(nh1,nFckDim), Grad(nGrad)
real(kind=wp), intent(out) :: Func
real(kind=wp), intent(in) :: D_DS(nh1,nD_DS)
logical(kind=iwp), intent(in) :: Do_Grad
character(len=4), intent(in) :: DFTFOCK
integer(kind=iwp) :: nOrbA
logical(kind=iwp) :: Do_MO, Do_TwoEl, F_nAsh

!                                                                      *
!***********************************************************************
!                                                                      *
! DFT functionals, compute integrals over the potential

Func = Zero
Dens_I = Zero
Grad_I = Zero
Tau_I = Zero
Do_MO = .false.
Do_TwoEl = .false.

call Get_iScalar('nSym',mIrrep)
call Get_iArray('nBas',mBas(0),mIrrep)
call Get_iArray('nFro',nFro(0),mIrrep)
call Get_iArray('nIsh',nIsh(0),mIrrep)
call qpg_iArray('nAsh',F_nAsh,nOrbA)
if ((.not. F_nAsh) .or. (nOrbA == 0)) then
  nAsh(0:mIrrep-1) = 0
else
  call Get_iArray('nAsh',nAsh(0),mIrrep)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call Driver(KSDFT,Do_Grad,Func,Grad,nGrad,Do_MO,Do_TwoEl,D_DS,F_DFT,nh1,nFckDim,DFTFOCK)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Wrap_DrvNQ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Andrew M. Sand                                   *
!               2019, Thais R. Scott                                   *
!               2021, Jie J. Bao                                       *
!               2024, Matthew R. Hennefarth                            *
!***********************************************************************

subroutine SaveFock_msPDFT(cmo,h1e,D1Act,NQ,p2d,state)

use PrintLevel, only: DEBUG
use mcpdft_output, only: iPrLoc
use wadr, only: fockocc
use rasscf_global, only: ISTORP, nacpar, nacpr2, nFint, ntot4
use mspdftgrad, only: F1MS, F2MS, FocMS, FxyMS
use general_data, only: nbas, nfro, norb, nsym, ntot1, ntot2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: cmo(ntot2), h1e(ntot1), D1Act(nacpar), P2D(nacpr2)
integer(kind=iwp), intent(in) :: NQ, state
integer(kind=iwp) :: iprlev
real(kind=wp), allocatable :: dm2(:), FA_V(:), FI_V(:), fock(:), h1e_mo(:), ONTOPO(:), ONTOPT(:), Q(:)

call mma_allocate(fock,ntot4,label='fock')

fock(:) = Zero

write(u6,'(2X,A)') 'Calculating potentials for analytic gradients for MS-PDFT'

IPRLEV = IPRLOC(3)

call mma_allocate(h1e_mo,ntot1,label='h1e_mo')
call ao2mo_1e(cmo,h1e,h1e_mo,nsym,nbas,norb,nfro)

! loading one-electron potential and two-electron potential
! Used as F1 and F2 in equations 58 and 59 in Ref1.
call mma_allocate(ONTOPT,nfint,Label='OnTopT')
call mma_allocate(ONTOPO,ntot1,Label='OnTopO')
call Get_dArray('ONTOPT',OnTopT,NFINT)
call Get_dArray('ONTOPO',OnTopO,NTOT1)

! Store for later...
call Get_TUVX(OnTopT,f2ms(:,state))

call mma_allocate(FI_V,Ntot1,Label='FI_V')
call mma_allocate(FA_V,Ntot1,Label='FA_V')
! Note that these are stored in MO basis
call Get_dArray('FI_V',FI_V,NTOT1)
call Get_dArray('FA_V',FA_V,NTOT1)

fi_v(:) = h1e_mo(:)+OnTopO(:)+FI_V(:)
F1MS(:,state) = fi_v(:)

! _______________________________________________________________________
! This next part is to generate the MC-PDFT generalized fock operator.
! The corrections (from the potentials) to FI and FA are built in the NQ
! part of the code, for efficiency's sake.  It still needs to be
! debugged.

! Reordering of the two-body density matrix.
if (ISTORP(NSYM+1) > 0) then
  call mma_allocate(dm2,ISTORP(NSYM+1),label='dm2')
  call PMAT_RASSCF(P2d,dm2)
else
  call mma_allocate(dm2,1,label='dm2')
  dm2(:) = Zero
end if

! Must add to existing fock operator (occ/act).
call mma_allocate(Q,NQ,Label='Q') ! q-matrix(1symmblock)
call fock_update(fock,fi_v,fa_v,D1Act,dm2,Q,NQ,OnTopT,CMO)
call mma_deallocate(Q)
call mma_deallocate(dm2)
call mma_deallocate(OnTopO)
call mma_deallocate(OnTopT)
call mma_deallocate(FI_V)
call mma_deallocate(FA_V)

focms(:,state) = fockocc(:)
FxyMS(:,state) = fock(:)
if (IPRLEV >= DEBUG) then
  write(u6,*) 'FOCC_OCC'
  call wrtmat(fockocc,1,ntot1,1,ntot1)
end if

call Put_iScalar('SA ready',1)

call mma_deallocate(fock)
call mma_deallocate(h1e_mo)

end subroutine SaveFock_msPDFT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ZSPGPIB(NSTSO,ISTSO,NSPGP,NSMST)
! Offset for supergroups of strings with given sym.
! Each supergroup is given start address 1
!
! Jeppe Olsen, Still summer of 95

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSMST, NSPGP, NSTSO(NSMST,NSPGP)
integer(kind=iwp), intent(out) :: ISTSO(NSMST,NSPGP)
integer(kind=iwp) :: ISMST, ISPGP

do ISPGP=1,NSPGP
  ISTSO(1,ISPGP) = 1
  do ISMST=2,NSMST
    ISTSO(ISMST,ISPGP) = ISTSO(ISMST-1,ISPGP)+NSTSO(ISMST,ISPGP)
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from ZSPGPIB'
write(u6,*) ' ==================='
write(u6,*)
call IWRTMA(ISTSO,NSMST,NSPGP,NSMST,NSPGP)
#endif

end subroutine ZSPGPIB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
*  StatusLine
*
*> @brief
*>   Update status file
*> @author V. Veryazov
*>
*> @details
*> Print parameters into status file. There is no
*> difference between params.
*>
*> \code
*> Call StatusLine(ModuleName,': just started')
*> \endcode
*>
*> @param[in] STR  Status
*> @param[in] STR1 Status
************************************************************************
      Subroutine StatusLine(STR,STR1)
      character*(*) STR, STR1
      Integer Lu
#ifdef _MOLCAS_MPP_
      Logical King
      External King
      if(.Not.King()) return
#endif
      Lu=2
      call molcas_open(Lu,'status')
      write(Lu,'(A,A)') STR,STR1
      close(Lu)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
!#define _DEBUGPRINT_
      SUBROUTINE TRINT(CMO1,CMO2,ECORE,NGAM1,FOCKMO,NGAM2,TUVX)
      USE Fock_util_global, only: Fake_CMO2
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: nProcs
#endif
      use Data_structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
      use stdalloc, only: mma_allocate, mma_deallocate
      use Constants, only: Zero
      use Cntrl, only: ERFNUC, RFPert
      use cntrl, only: ALGO, Nscreen, dmpk
      use cntrl, only: LuOrd
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NCMO,NBSQ,NISH,NASH,NASHT,CHFRACMEM,NBASF,
     &                      NBTRI,NOSH

      IMPLICIT None
      Integer NGAM1, NGAM2
      REAL*8 CMO1(NCMO),CMO2(NCMO),FOCKMO(NGAM1),TUVX(NGAM2)

      Integer KEEP(8),NBSX(8), nAux(8)
      LOGICAL   ISQARX
      Type (DSBA_Type) Ash(2), MO1(2), MO2(2), DLT(1), FLT(1), KSQ,
     &                 FAO, Temp_SQ, DInAO
      Logical IfTest,FoundTwoEls,DoCholesky

      Real*8, Allocatable:: Prod(:)
      Integer iOpt, IRC, nSymX, iSym, NB1, NB2, I, nDINAO, NFAO, IOFF,
     &        IKK, IOFF1, IOFF2, IOFF3, JKK, NPROD, ISTFMO, ISTC, NA,
     &        NI, NO, NB, ISTA, IERR
      Real*8 ECORE1, ECORE2, ECORE
      Real*8, External:: DDot_
#ifdef _MOLCAS_MPP_
      Real*8 SCX
#endif

*****************************************************************
*  CALCULATE AND RETURN ECORE, FOCKMO, AND TUVX. ECORE IS THE
*  INACTIVE-INACTIVE ENERGY CONTRIBUTION, WHICH IS TO BE MULTI-
*  PLIED WITH AN OVERLAP TO GIVE A CONTRIBUTION TO THE HAMILTONIAN
*  MATRIX ELEMENT. SIMILARLY, THE INACTIVE-ACTIVE CONTRIBUTION IS
*  GIVEN BY THE FOCKMO ARRAY CONTRACTED WITH AN ACTIVE TRANSITION
*  DENSITY MATRIX, AND THE ACTIVE-ACTIVE IS THE TRANSFORMED
*  INTEGRALS IN ARRAY TUVX CONTRACTED WITH THE TRANSITION DENSITY
*  TWO-ELECTRON MATRIX. THEREFORE, THE STORAGE OF THE FOCKMO AND
*  THE TUVX MATRICES ARE IN THE SAME FORMAT AS THE DENSITY MATRICES.
*****************************************************************

      IfTest=.False.
#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif
C THE FOLLOWING PROGRAMS USE THE ORDERED INTEGRAL FILE FOR BOTH
C THE FOCKMO MATRIX AND THE TUVX ARRAY. THEREFORE, IT IS IMPERATIVE
C THAT SYMMETRY BLOCKS HAVE NOT BEEN EXCLUDED IN THE GENERATION OF
C THIS ORDERED INTEGRAL FILE, UNLESS BOTH ACTIVE AND INACTIVE ORBITALS
C ARE MISSING FOR THAT SYMMETRY LABEL. THIS IS CHECKED FIRST:

C OPEN THE ELECTRON REPULSION INTEGRAL FILE
      Call f_Inquire('ORDINT',FoundTwoEls)
c      Call DecideOnDirect(.False.,FoundTwoEls,DoDirect,DoCholesky)
      Call DecideOnCholesky(DoCholesky)

      If (.not.DoCholesky) then

         IOPT=0
         IRC=0
         CALL OPNORD(IRC,IOPT,'ORDINT',LUORD)
          IF(IRC.NE.0) THEN
             WRITE(6,*)' ERROR: RETURN CODE=',IRC
             WRITE(6,*)' RECEIVED WHEN OPENING ORDINT.'
             CALL ABEND()
          END IF

          IRC=0
          CALL GETORD(IRC,ISQARX,NSYMX,NBSX,KEEP)
          IF(IRC.NE.0) THEN
            WRITE(6,*)' ERROR: RETURN CODE=',IRC
            WRITE(6,*)' RECEIVED WHEN CALLING GETORD.'
            CALL ABEND()
          END IF
          IF ( NSYMX.NE.NSYM ) THEN
            WRITE(6,*)' '
            WRITE(6,*)'     *** ERROR IN SUBROUTINE TRINT ***'
            WRITE(6,*)'     INCOMPATIBLE NUMBERS OF IRRED. REP.'
            WRITE(6,*)' '
            CALL ABEND()
          END IF
          DO ISYM=1,NSYM
            NB1=NBASF(ISYM)
            NB2=NBSX(ISYM)
            IF ( NB1.NE.NB2 ) THEN
              WRITE(6,*)' '
              WRITE(6,*)'     *** ERROR IN SUBROUTINE TRINT ***'
              WRITE(6,*)'   INCOMPATIBLE NUMBERS OF BASIS FUNCTION'
              WRITE(6,*)' '
              CALL ABEND()
            END IF
          END DO
          DO 10 I=1,NSYM
            IF(KEEP(I).EQ.0) GOTO 10
            IF(NOSH(I).GT.0) GOTO 901
10        CONTINUE

      EndIf


C CALCULATE AN INACTIVE TRANSITION DENSITY MATRIX IN AO BASIS:
      NDINAO=NBSQ
      Call Allocate_DT(DInAO,nBasF,nBasF,nSym)
      CALL DIMAT(CMO1,CMO2,DINAO%A0)

      NFAO=NBSQ
      Call Allocate_DT(FAO,nBasF,nBasF,nSym)
*                                                                      *
************************************************************************
*                                                                      *
      IF (.not.DoCholesky) THEN     ! Conventional integrals
*                                                                      *
************************************************************************
*                                                                      *

         If ( IfTest ) Call dVcPrt('Done',' ',DINAO%A0,NDINAO)
C GET THE ONE-ELECTRON HAMILTONIAN MATRIX FROM ONE-EL FILE AND
C PUT IT INTO A FOCK MATRIX IN AO BASIS:
C Note: GETH1 also adds the reaction field contribution to the
C 1-electron hamiltonian, and the variable ERFNuc in common /general/,
C which is the RF contribution to the nuclear repulsion
         CALL GETH1_RASSI(FAO%A0)
         If ( IfTest ) Call dVcPrt('h0',' ',FAO%A0,NFAO)
C ONE CONTRIBUTION TO ECORE MUST BE CALCULATED FROM THE NAKED
C ONE-EL HAMILTONIAN:
         ECORE1=DDOT_(NBSQ,FAO%A0,1,DINAO%A0,1)
         If ( IfTest ) Write (6,*) '      ECore1=',ECORE1


C ADD IN THE TWO-ELECTRON CONTRIBUTIONS TO THE FOCKAO MATRIX:
*
         Call Allocate_DT(Temp_SQ,nBasF,nBasF,nSym)
         Temp_SQ%A0(:)=Zero
         CALL FOCK_RASSI(DINAO%A0,Temp_SQ%A0)

c --- FAO already contains the one-electron part
         FAO%A0(:) = FAO%A0(:) + Temp_SQ%A0(:)
         Call Deallocate_DT(Temp_SQ)

#ifdef _DEBUGPRINT_
         Do i=1,nSym
         call CHO_OUTPUT(FAO%SB(i)%A2,1,nBasF(i),1,nBasF(i),
     &                                  nBasF(i),nBasF(i),1,6)
         End Do
#endif

         ECORE2=DDOT_(NBSQ,FAO%A0,1,DINAO%A0,1)
*                                                                      *
************************************************************************
*                                                                      *
      Else       ! RI/CD integrals
*                                                                      *
************************************************************************
*                                                                      *
* ------ Initialize Cholesky information

         CALL CHO_X_INIT(irc,ChFracMem)
         if (irc.ne.0) then
            write(6,*)'TrInt: Cho_X_Init returns error code ',irc
            Call AbEnd()
         endif

         Call Allocate_DT(DLT(1),nBasF,nBasF,nSym,aCase='TRI')
         CALL Fold_Mat(nSym,nBasF,DINAO%A0,DLT(1)%A0)

#ifdef _DEBUGPRINT_

         do i=1,nSym
            call cho_output(DInAO%SB(i)%A2,1,nBasF(i),1,nBasF(i),
     &                      nBasF(i),nBasF(i),1,6)
            call triprt('DLT','',DLT(1)%SB(i)%A1,nBasF(i))
         end do

#endif

         Call Allocate_DT(FLT(1),nBasF,nBasF,nSym,aCase='TRI')

C GET THE ONE-ELECTRON HAMILTONIAN MATRIX FROM ONE-EL FILE AND
C PUT IT INTO A FOCK MATRIX IN AO BASIS:
C Note: CHO_GETH1 also adds the reaction field contribution to the
C 1-electron hamiltonian, and the variable ERFNuc in common /general/,
C which is the RF contribution to the nuclear repulsion

         CALL CHO_GETH1(nBtri,FLT(1)%A0,RFpert,ERFNuc)

         ECORE1=DDOT_(nBtri,FLT(1)%A0,1,DLT(1)%A0,1)
         If ( IfTest ) Write (6,*) '      ECore1=',ECORE1,ALGO
         If ( IfTest ) Write (6,*) '      FAKE_CMO2=',FAKE_CMO2

#ifdef _MOLCAS_MPP_
         If (nProcs.gt.1) Then
             scx=1.0/dble(nProcs)
C --- to avoid double counting when using gadsum
             FLT(1)%A0(:) = scx * FLT(1)%A0(:)
         EndIf
#endif

         FAO%A0(:)=Zero ! Used as Exchange F matrix
!                                                                      !
!)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
!                                                                      !
         If (ALGO.eq.1) Then
!                                                                      !
!)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
!                                                                      !
c -------- reorder the MOs to fit Cholesky needs

           Call Allocate_DT(MO1(1),nIsh,nBasF,nSym)
           Call Allocate_DT(MO1(2),nIsh,nBasF,nSym)
           Call Allocate_DT(MO2(1),nAsh,nBasF,nSym)
           Call Allocate_DT(MO2(2),nAsh,nBasF,nSym)

           ioff=0
           Do iSym=1,nSym

            do ikk=1,nIsh(iSym)

               ioff1=ioff+nBasF(iSym)*(ikk-1)

               MO1(1)%SB(iSym)%A2(ikk,:) =
     &            CMO1(ioff1+1:ioff1+nBasF(iSym))

               MO1(2)%SB(iSym)%A2(ikk,:) =
     &            CMO2(ioff1+1:ioff1+nBasF(iSym))
            end do

            ioff2=ioff+nBasF(iSym)*nIsh(iSym)

            do ikk=1,nAsh(iSym)

               ioff3=ioff2+nBasF(iSym)*(ikk-1)

               MO2(1)%SB(iSym)%A2(ikk,:) =
     &            CMO1(ioff3+1:ioff3+nBasF(iSym))

               MO2(2)%SB(iSym)%A2(ikk,:) =
     &            CMO2(ioff3+1:ioff3+nBasF(iSym))
            end do

            ioff=ioff+nBasF(iSym)*(nIsh(iSym)+nAsh(iSym))

           End Do


c --- Add the two-electron contribution to the Fock matrix
c ---     and compute the (tu|vx) integrals

           If (Fake_CMO2) Then
              CALL CHO_FOCK_RASSI(DLT,MO1,MO2,FLT,TUVX,NGAM2)
           Else
              CALL CHO_FOCK_RASSI_X(DLT,MO1,MO2,FLT,FAO,TUVX,NGAM2)
           EndIf

           Call Deallocate_DT(MO2(2))
           Call Deallocate_DT(MO2(1))
           Call Deallocate_DT(MO1(2))
           Call Deallocate_DT(MO1(1))
!                                                                      !
!)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
!                                                                      !
         Else  ! algo=2 (local exchange algorithm)
!                                                                      !
!)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
!                                                                      !

           nAux(:) = nIsh(:) + nAsh(:)
           Call Allocate_DT(MO1(1),nBasF,nAux,nSym,Ref=CMO1)
           Call Allocate_DT(MO1(2),nBasF,nAux,nSym,Ref=CMO2)

C *** Only the active orbitals MO coeff need reordering
           Call Allocate_DT(Ash(1),nAsh,nBasF,nSym)
           Call Allocate_DT(Ash(2),nAsh,nBasF,nSym)

           Do iSym=1,nSym

            do ikk=1,nAsh(iSym)
               jkk = nIsh(iSym) + ikk

               Ash(1)%SB(iSym)%A2(ikk,:) =
     &             MO1(1)%SB(iSym)%A2(:,jkk)

               Ash(2)%SB(iSym)%A2(ikk,:) =
     &             MO1(2)%SB(iSym)%A2(:,jkk)

            end do

           End Do

c --- Add the two-electron contribution to the Fock matrix
c ---     and compute the (tu|vx) integrals

           If (Fake_CMO2) Then

             CALL CHO_LK_RASSI(DLT,MO1,FLT,FAO,TUVX,nGAM2,
     &                         Ash,nScreen,dmpk)
           Else

             Call Allocate_DT(KSQ,nBasF,nBasF,nSym)
             KSQ%A0(:)=Zero

             CALL CHO_LK_RASSI_X(DLT,MO1,FLT,KSQ,FAO,TUVX,nGAM2,
     &                           Ash,nScreen,dmpk)

             Call Deallocate_DT(KSQ)
           EndIf

           Call Deallocate_DT(Ash(2))
           Call Deallocate_DT(Ash(1))
           Call Deallocate_DT(MO1(2))
           Call Deallocate_DT(MO1(1))

!                                                                      !
!)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
!                                                                      !
         EndIf
!                                                                      !
!)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
!                                                                      !

         If (Fake_CMO2) Then
            Do i=1,nSym
               CALL SQUARE(FLT(1)%SB(i)%A1,FAO%SB(i)%A2,
     &                     1,nBasF(i),nBasF(i))
            End Do
         EndIf

         Call Deallocate_DT(FLT(1))
         Call Deallocate_DT(DLT(1))

         Call GADSUM(FAO%A0,NBSQ)
         Call GADSUM(TUVX,NGAM2)

         ECORE2=DDOT_(NBSQ,FAO%A0,1,DINAO%A0,1)

* --- Finalize Cholesky information

         CALL CHO_X_FINAL(irc)
         if (irc.ne.0) then
            write(6,*)'TrInt: Cho_X_Final returns error code ',irc
            write(6,*)'Try recovery -- continue.'
         endif
*                                                                      *
************************************************************************
*                                                                      *
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
      If ( IfTest ) Write (6,*) '      Etwo  =',ECORE2
      ECORE=0.5D0*(ECORE1+ECORE2)
      If ( IfTest ) Write (6,*) '      Ecore =',ECORE
C (NOTE COMPENSATION FOR DOUBLE-COUNTING OF TWO-ELECTRON CONTRIBUTION.)
      Call Deallocate_DT(DInAO)


C TRANSFORM THE FOCK MATRIX TO MO BASIS:
      NPROD=0
      DO 20 I=1,NSYM
        NPROD=MAX(NPROD,NASH(I)*NBASF(I))
20    CONTINUE
*
      Call mma_allocate(Prod,nProd,Label='Prod')
      Call FZero(PROD,NPROD)
      ISTFMO=1
      ISTC=1
      CALL FZERO(FOCKMO,NGAM1)
      DO 30 ISYM=1,NSYM
         NA=NASH(ISYM)
         NI=NISH(ISYM)
         NO=NI+NA
         NB=NBASF(ISYM)
         IF (NA.NE.0) THEN
            ISTA=ISTC+NI*NB
C ISTFMO: BEGINNING OF F(MO,MO) BLOCK OF SYMMETRY ISYM.
C ISTC: BEGINNING OF MO-S OF SYMMETRY ISYM.
C ISTA: BEGINNING OF ACTIVE MO-S OF SYMMETRY ISYM.
C MATRIX MULT. PROD(AO,ACTIVE MO)=F(AO,AO)*CMO2(AO,ACTIVE MO)
            CALL DGEMM_('N','N',NB,NA,NB,
     &                  1.0D0,FAO%SB(ISYM)%A2,NB,
     &                        CMO2(ISTA),NB,
     &                  0.0D0,PROD,NB)
C -- MATRIX MULT. F(ACT MO,ACT MO)=CMO1(AO,ACT MO)(TRP)*PROD(AO,ACT MO)
            CALL DGEMM_('T','N',NA,NA,NB,
     &                  1.0D0,CMO1(ISTA),NB,
     &                        PROD,NB,
     &                  0.0D0,FOCKMO(ISTFMO),NASHT)
         END IF
         ISTFMO=ISTFMO+NA*(NASHT+1)
         ISTC=ISTC+NO*NB
30    CONTINUE
      Call mma_deallocate(Prod)
      Call Deallocate_DT(FAO)


      If (.not.DoCholesky) then
C TRANSFORM TWO-ELECTRON INTEGRALS:
         CALL TRAINT(CMO1,CMO2,NGAM2,TUVX)

         IRC=0
         CALL CLSORD(IRC)

      End If
      Call Chk4NaN(nasht*(nasht+1)/2,TUVX,iErr)
      If (iErr.ne.0) Then
         Write (6,*) 'TrInt: TUVX corrupted'
         Call Abend()
      End If
      Call Chk4NaN(nGam1,FOCKMO,iErr)
      If (iErr.ne.0) Then
         Write (6,*) 'TrInt: FOCKMO corrupted'
         Call Abend()
      End If
c     Call triprt('tuvx',' ',TUVX,nasht)

      RETURN
901   CONTINUE
      WRITE(6,*)' ERROR IN KEEP PARAMETERS ON ORDINT FILE.'
      WRITE(6,'(A,8I5)')' KEEP ARRAY:',(KEEP(I),I=1,NSYM)
      WRITE(6,'(A,8I5)')' NASH ARRAY:',(NASH(I),I=1,NSYM)
      WRITE(6,*)' A NON-ZERO KEEP PARAMETER INDICATES THAT BASIS'
      WRITE(6,*)' FUNCTIONS WITH A SPECIFIC SYMMETRY LABEL HAS'
      WRITE(6,*)' BEEN SKIPPED. THIS IS POSSIBLE ONLY IF INACTIVE'
      WRITE(6,*)' AND ACTIVE ORBITALS OF THAT SYMMETRY ARE MISSING.'
      CALL ABEND()
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Load_H_diag(nConf,H_diag,LuDavid)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Load the diagonal approximation of the CI Hamiltonian for        *
!     further use by the Davidson diagonalization scheme               *
!                                                                      *
!     calling arguments:                                               *
!     nConf   : integer                                                *
!               length of the vector H_diag                            *
!     H_diag  : array of real*8                                        *
!               diagonal approximation of the CI Hamiltonian           *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use davctl_mod, only: disk_address, in_core, llab, memory_vectors, mixed_mode_1, mixed_mode_2, on_disk, save_mode
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nConf, LuDavid
real(kind=wp), intent(out) :: H_diag(nConf)
integer(kind=iwp) :: H_diag_RecNo, iDisk
character(len=llab) :: KeyWord
integer(kind=iwp), external :: RecNo
#include "rasdim.fh"
#include "timers.fh"

call Timing(WTC_1,Swatch,Swatch,Swatch)

! check input arguments
if (nConf < 0) then
  write(u6,*) 'Load_H_diag: nConf less than 0'
  write(u6,*) 'nConf = ',nConf
  call Abend()
end if

! the diagonalization can be run in core:
! copy H_diag to new memory location
if (save_mode == in_core) then
  H_diag_RecNo = RecNo(1,1)
  H_diag(:) = memory_vectors(:,H_diag_RecNo)
end if

! the diagonalization must be run out of core:
! load H_diag from disk
if (save_mode == on_disk) then
  H_diag_RecNo = RecNo(1,1)
  iDisk = disk_address(H_diag_RecNo)
  call DDaFile(LuDavid,2,H_diag,nConf,iDisk)
end if

! the diagonalization may be run in mixed mode:
! use the write through cache mechanism to load and save H_diag
if ((save_mode == mixed_mode_1) .or. (save_mode == mixed_mode_2)) then
  KeyWord = 'H_diag'
  call page_in(KeyWord,nConf,H_diag,LuDavid)
end if

call Timing(WTC_2,Swatch,Swatch,Swatch)
WTC_2 = WTC_2-WTC_1
WTC_3 = WTC_3+WTC_2

return

end subroutine Load_H_diag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine BPut(EVec,nDim,BMx,nX,Smmtrc,nQQ,Degen)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, nX, nQQ
real(kind=wp), intent(in) :: EVec(nDim,nQQ), Degen(nX)
real(kind=wp), intent(out) :: BMx(nX,nQQ)
logical(kind=iwp) :: Smmtrc(nX)
integer(kind=iwp) :: i_Dim, iX

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
i_Dim = 0
do iX=1,nX
  if (Smmtrc(iX)) then
    i_Dim = i_Dim+1
    BMx(iX,:) = EVec(i_Dim,:)/sqrt(Degen(iX))
  else
    BMx(iX,:) = Zero
  end if
end do
#ifdef _DEBUGPRINT_
call RecPrt('BPut: BMx',' ',BMx,nX,nQQ)
#endif

return

end subroutine BPut

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine OutCtlSplit(CMO,OCCN,SMAT,lOPTO)
************************************************************************
*                                                                      *
*     Control section for the final output                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
************* GLMJ ************
      Implicit Real*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='OUTCTL  ')
#include "ciinfo.fh"
#include "rctfld.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "splitcas.fh"
#include "SysDef.fh"
      Real*8, Allocatable:: DSave(:)
      Character*8  Fmt2, Label
      Character*3 lIrrep(8)
      Character*80 Note
      Character*120 Line
      Logical FullMlk, get_BasisType
cnf
      Logical Do_ESPF,lSave, lOPTO
cnf
      DIMENSION CMO(*),OCCN(*),SMAT(*)
      Dimension Temp(2,mxRoot)
      Dimension Dum(1),iDum(56)

** (SVC) added for new supsym vector input
*      DIMENSION NXSYM(mxOrb),nUND(mxOrb)

      Integer  Cho_X_GetTol
      External Cho_X_GetTol

*----------------------------------------------------------------------*
*     Start and define the paper width                                 *
*----------------------------------------------------------------------*
C Local print level (if any)
      IPRLEV=IPRLOC(6)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF

* Additional DFT correlation energy, if any
      CASDFT_Funct=0.0d0
      If (KSDFT.ne.'SCF'.and.KSDFT.ne.'PAM') Then
          Call Get_dScalar('CASDFT energy',CASDFT_Funct)
      End If
*----------------------------------------------------------------------*
*     Initialize blank and header lines                                *
*----------------------------------------------------------------------*
      left=6
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'

      IF (IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
* Start of long if-block A over IPRLEV
*----------------------------------------------------------------------*
*     Print orbital and wavefunction specifications                    *
*----------------------------------------------------------------------*
        Write(LF,*)
        Line=''
        Write(Line(left-2:),'(A)') 'Wave function specifications:'
        Call CollapseOutput(1,Line)
        Write(LF,Fmt2//'A)')'-----------------------------'
        Write(LF,*)
        Write(LF,Fmt2//'A,T45,I6)')'Number of closed shell electrons',
     &                           2*NIN
      Write(LF,Fmt2//'A,T45,I6)')'Number of electrons in active shells',
     &                           NACTEL
        Write(LF,Fmt2//'A,T45,I6)')'Max number of holes in RAS1 space',
     &                           NHOLE1
        Write(LF,Fmt2//'A,T45,I6)')'Max nr of electrons in RAS3 space',
     &                           NELEC3
        Write(LF,Fmt2//'A,T45,I6)')'Number of inactive orbitals',
     &                           NIN
        Write(LF,Fmt2//'A,T45,I6)')'Number of active orbitals',
     &                           NAC
        Write(LF,Fmt2//'A,T45,I6)')'Number of secondary orbitals',
     &                           NSEC
        Write(LF,Fmt2//'A,T45,F6.1)')'Spin quantum number',
     &                           (DBLE(ISPIN-1))/2.0d0
        Write(LF,Fmt2//'A,T45,I6)')'State symmetry',
     &                           LSYM
        Call CollapseOutput(0,'Wave function specifications:')
*
        Call Get_cArray('Irreps',lIrrep,24)
        Do iSym = 1, nSym
           Call RightAd(lIrrep(iSym))
        End Do
*
        Write(LF,*)
        Line=''
        Write(Line(left-2:),'(A)') 'Orbital specifications:'
        Call CollapseOutput(1,Line)
        Write(LF,Fmt2//'A)')'-----------------------'
        Write(LF,*)
        Write(LF,Fmt2//'A,T47,8I4)') 'Symmetry species',
     &                            (iSym,iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8(1X,A))') '                ',
     &                            (lIrrep(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'Frozen orbitals',
     &                            (nFro(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'Inactive orbitals',
     &                            (nIsh(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'Active orbitals',
     &                            (nAsh(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'RAS1 orbitals',
     &                            (nRs1(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'RAS2 orbitals',
     &                            (nRs2(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'RAS3 orbitals',
     &                            (nRs3(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'Secondary orbitals',
     &                            (nSsh(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'Deleted orbitals',
     &                            (nDel(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'Number of basis functions',
     &                            (nBas(iSym),iSym=1,nSym)
        Call CollapseOutput(0,'Orbital specifications:')
        Write(LF,*)
        Line=''
        Write(Line(left-2:),'(A)') 'CI expansion specifications:'
        Call CollapseOutput(1,Line)
        Write(LF,Fmt2//'A)')'----------------------------'
        Write(LF,*)
        Write(LF,Fmt2//'A,T40,I11)')'Number of CSFs',
     &                           NCSASM(LSYM)
        Write(LF,Fmt2//'A,T40,I11)')'Number of determinants',
     &                           NDTASM(LSYM)
        write(LF,Fmt2//'A,T45,I6)')  'Root required ', lrootSplit
        if (EnerSplit)
     &    write(LF,Fmt2//'A,T44,F7.2)')'Energy Gap (eV) in SplitCAS',
     &                            GapSpli
        if (PerSplit)
     &    write(LF,Fmt2//'A,T44,F7.1)')'Percentage sought in SplitCAS',
     &                            PercSpli
        percent = Real(iDimBlockA)/Real(NCSASM(LSYM))*100.0d0
        write(LF,Fmt2//'A,T42,I9,A,F5.1,A)')'A-Block Size in '//
     &                          'SplitCAS (CSFs)',iDimBlockA,' (',
     &                          percent,' %)'
        Write(LF,Fmt2//'A,T45,E10.3)')'Threshold for SplitCAS',
     &                            ThrSplit
        write(LF,Fmt2//'A,T47,I4)') 'Maximum number of SplitCAS '//
     &                     'iterations', MxIterSplit
        If ( lRF ) then
           Call GetMem('Ovrlp','Allo','Real',iTmp0,nTot1+4)
           iRc=-1
           iOpt=2
           iComp=1
           iSyLbl=1
           Label='Mltpl  0'
           Call RdOne(iRc,iOpt,Label,iComp,Work(iTmp0),iSyLbl)
           Tot_Nuc_Charge=Work(iTmp0+nTot1+3)
           If ( iRc.ne.0 ) then
              Write(LF,*) 'OutCtl: iRc from Call RdOne not 0'
              Write(LF,*) 'Label = ',Label
              Write(LF,*) 'iRc = ',iRc
              Call Abend
           Endif
           Call GetMem('Ovrlp','Free','Real',iTmp0,nTot1+4)
           Tot_El_Charge=0.0D0
           Do iSym=1,nSym
              Tot_El_Charge=Tot_El_Charge
     &                     -2.0D0*DBLE(nFro(iSym)+nIsh(iSym))
           End Do
           Tot_El_Charge=Tot_El_Charge-DBLE(nActEl)
           Tot_Charge=Tot_Nuc_Charge+Tot_El_Charge
           iCharge=Int(Tot_Charge)
           Call PrRF(.False.,NonEq,iCharge,2)
           Write(LF,Fmt2//'A,T45,I2)')' Reaction field from state:',
     &                                IPCMROOT
        End If
        If ( RFpert ) then
           Write(LF,*)
           Write(LF,*)
           Write(LF,Fmt2//'A)')'Reaction field specifications:'
           Write(LF,Fmt2//'A)')'------------------------------'
           Write(LF,*)
           Write(LF,'(6X,A)')'The Reaction field has been added as a '//
     &                      'perturbation and has been determined '//
     &                      'in a previous calculation'
           Write(LF,*)
        End If
        If (KSDFT.ne.'SCF'.and.KSDFT.ne.'PAM') Call Print_NQ_Info(iSpin)
        Call CollapseOutput(0,'CI expansion specifications:')

* End of long if-block A over IPRLEV
      END IF

      EAV = ENER(lRootSplit,ITER)

      CASDFT_Funct=0.0d0
      If (KSDFT.ne.'SCF'.and.KSDFT.ne.'PAM') Then
         If(nConf.eq.1.and.nActEl.eq.nac) Then
           Call Get_dScalar('CASDFT energy',CASDFT_Funct)
           EAV = EAV + CASDFT_Funct
         Else
           Call Get_dScalar('CASDFT energy',CASDFT_Funct)
           EAV=EAV+CASDFT_Funct - VIA_DFT - HALFQ
         End If
      End If

      IF(IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
* Start of long if-block B over IPRLEV
        Write(LF,*)
        Line=''
        Write(Line(left-2:),'(A)') 'Final optimization specifications:'
        Call CollapseOutput(1,Line)
        Write(LF,Fmt2//'A)')'------------------------------'
        Write(LF,*)

        Write(LF,Fmt2//'A,T45,F20.8)') 'SplitCAS CI-energy',EAV
        Write(LF,Fmt2//'A,T45,F20.8)') 'SplitCAS RAS-energy',ECAS
        Write(LF,Fmt2//'A,T45,F20.8)') 'Super-CI energy',ESX
        Write(LF,Fmt2//'A,T45,F20.8)') 'RASSCF energy change',DE
        Write(LF,Fmt2//'A,T50,E10.3)')'Max change in MO coeff.',CMAX
        Write(LF,Fmt2//'A,T50,E10.3)')
     &          'Max non-diagonal density matrix element',ROTMAX
        Write(LF,Fmt2//'A,T50,E10.3)') 'Max. BLB matrix element',CBLBM
        Write(LF,Fmt2//'A,I4,A,I4,A,I4,A)')
     &     '(orbital pair',IBLBM,',',JBLBM,' in symmetry',ISYMBB,')'
        If (irlxRoot.ne.0)
     &    Write(LF,Fmt2//'A,T45,E10.3)')
     &         'Norm of electronic gradient',RLXGRD

        If ( ISUPSM.ne.0 ) then
          Write(LF,Fmt2//'A)')
     &    'Supersymmetry has been used to disable selected orbital'//
     &    ' rotations'
          iEnd=0
          Do iSym=1,nSym
            iStart=iEnd+1
            iEnd=iEnd+nBas(iSym)
            iTemp=0
            Do i=iStart,iEnd
              iTemp=iTemp+IXSYM(i)
            End Do
            If ( iTemp.gt.0 ) then
               Write(LF,Fmt2//'A,I3)')
     &         'Supersymmetry vector for symmetry species',iSym
               Write(LF,Fmt2//'30I3)') (IXSYM(i),i=iStart,iEnd)
            End If
          End Do
        End If

        If ( ICLEAN.ne.0 ) then
          Write(LF,Fmt2//'A)')
     &    'The cleanup option has been used to set MO-coefficients'//
     &    ' explicitly to zero'
        End If
        Call CollapseOutput(0,'Final optimization conditions:')

* End of long if-block B over IPRLEV
      END IF

      call dcopy_(2*mxRoot,[0.0d0],0,Temp,1)
      iRc1=0
      iRc2=0
      iOpt=1
      iComp=1
      iSyLbl=1
      nMVInt=0
      nDCInt=0
      Call iRdOne(iRc1,iOpt,'MassVel ',iComp,iDum,iSyLbl)
      If (iRc1.eq.0) nMVInt=iDum(1)
      Call iRdOne(iRc2,iOpt,'Darwin  ',iComp,iDum,iSyLbl)
      If (iRc2.eq.0) nDCInt=iDum(1)
      If ( (nMVInt+nDCInt).ne.0 ) Then
        IAD12=IADR15(12)
        CALL GETMEM('OPER','ALLO','REAL',LX1,NTOT1)
        CALL GETMEM('DEN1','ALLO','REAL',LX2,NTOT1)
        CALL GETMEM('OCCN','ALLO','REAL',LX3,NTOT )
        CALL GETMEM('CMON','ALLO','REAL',LX4,NTOT2)

        kRoot = lRootSplit
        CALL DDAFILE(JOBIPH,2,work(LX4),NTOT2,IAD12)
        CALL DDAFILE(JOBIPH,2,work(LX3),NTOT,IAD12)
        Call RelEne(Temp(1,kRoot),Temp(2,kRoot),nSym,nBas,
     &              work(LX4),work(LX3),work(LX2),work(LX1))

        CALL GETMEM('CMON','FREE','REAL',LX4,NTOT2)
        CALL GETMEM('OCCN','FREE','REAL',LX3,NTOT )
        CALL GETMEM('DEN1','FREE','REAL',LX2,NTOT1)
        CALL GETMEM('OPER','FREE','REAL',LX1,NTOT1)
      End If

      If ( (nMVInt+nDCInt).ne.0) then
        Emv=Temp(1,lRootSplit)
        Edc=Temp(2,lRootSplit)
        Erel=ENER(lRootSplit,ITER)+Emv+Edc
        EneTmp = Erel
*          Work(ipEneTmp+i-1) = eRel
      Else
        EneTmp = ENER(lRootSplit,ITER)+CASDFT_Funct-VIA_DFT-HALFQ
      End If

      IF(IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
* Start of long if-block C over IPRLEV
*----------------------------------------------------------------------*
*     Print final state energies (including relativistic correction)   *
*----------------------------------------------------------------------*
        Write(LF,*)
        Write(LF,*)
        Write(LF,Fmt2//'A)')'Final state energy(ies):'
        Write(LF,Fmt2//'A)')'------------------------'
        Write(LF,*)
        If ( (nMVInt+nDCInt).ne.0) then
         Write(LF,Fmt2//'A)')
     &        'root     nonrelativistic        mass-velocity       '//
     &        'Darwin-contact         relativistic'
         Write(LF,Fmt2//'A)')
     &        '             energy                term             '//
     &        '     term                 energy'
          i=lRootSplit
          Emv=Temp(1,i)
          Edc=Temp(2,i)
          Erel=ENER(I,ITER)+Emv+Edc
          Write(LF,Fmt2//'I3,4(1X,F20.8))')
     &          I,ENER(I,ITER),Emv,Edc,Erel
        Else
          Write(LF,Fmt2//'A,I3,A,F20.8,A)')
     &          'root number',lrootSplit,' E =',
     &            EneTmp,' a.u.'
        End If

      ELSE IF(IPRLEV.GE.TERSE .AND..NOT.lOPTO) THEN
        Write(LF,Fmt2//'A,I3,A,F20.8,A)')
     &    'root number',lRootSplit,' E =',
     &    EneTmp,' a.u.'

* End of long if-block C over IPRLEV
      END IF

      call Store_Energies(1,[EneTmp],1)

      Call Put_iScalar('NumGradRoot',irlxroot)
      Call Put_dScalar('Last energy',ECAS)
      Call Put_dScalar('Average energy',EAV)

      iTol = Cho_X_GetTol(8)
      Call Add_Info('E_RASSCF',ENER(1,ITER),1,iTol)

*---------------------------------------------------------------
* New JOBIPH layout: Also write hamiltonian matrix at IADR15(17):
*---------------------------------------------------------------
      IAD15=IADR15(17)
      CALL DDAFILE(JOBIPH,1,ENER(1,ITER),1,IAD15)

*----------------------------------------------------------------------*
*     Print the multipole analysis of the solvation energy             *
*----------------------------------------------------------------------*
      Call RFMltp()

*----------------------------------------------------------------------*
*     Print the final orbitals                                         *
*----------------------------------------------------------------------*
      FullMlk=(OutFmt1.NE.'NOTHING ')
      IF (IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
* Start of if-block D over IPRLEV
        If (OutFmt1.NE.'NOTHING ') then
          If(IPT2.EQ.0) THEN
            CALL PRIMO_RASSCF('Pseudonatural active'//
     &                  ' orbitals and approximate occupation numbers',
     &                  FDIAG,OCCN,CMO)
          Else
            CALL PRIMO_RASSCF('All orbitals are'//
     &                  ' eigenfunctions of the PT2 Fock matrix',
     &                  FDIAG,OCCN,CMO)
          EndIf
        EndIf
* End of if-block D over IPRLEV
      END IF

*----------------------------------------------------------------------*
*     Also put on RUNFILE (in the future...):
*----------------------------------------------------------------------*
      Call Put_dArray('RASSCF orbitals',CMO,NTOT2)

*----------------------------------------------------------------------*
*     compute properties and Mulliken's orbital populations            *
*----------------------------------------------------------------------*
      IAD12=IADR15(12)
      IAD03=IADR15(3)
      IAD14=IADR15(14)
*BOR0511
*     Save original orbitals for the spin density matrices
      Call GetMem('cmon','ALLO','REAL',icmon,nTot2)
      call dcopy_(ntot2,cmo,1,work(icmon),1)
*BOR0511
      FullMlk=(OutFmt1.NE.'NOTHING ')

************************************************************************
*     save the 1st order density for gradients                         *
************************************************************************
      Call mma_allocate(DSave,nTot1,Label='DSave')
      Call Get_D1AO(DSave,NTOT1)

* Read natural orbitals
      If ( NAC.GT.0 ) then
        CALL DDAFILE(JOBIPH,2,CMO,NTOT2,IAD12)
        CALL DDAFILE(JOBIPH,2,OCCN,NTOT,IAD12)
      End If
*
* Put the density matrix of this state on the runfile for
*  LoProp utility
      Call GetMem('DState','ALLO','REAL',ipD,nTot1)
      call dcopy_(nTot1,[0.0D0],0,Work(ipD),1)
      Call DONE_RASSCF(CMO,OCCN,Work(ipD))
      Call Put_D1AO(Work(ipD),NTOT1)
      Call Free_Work(ipD)

      IF (IPRLEV.GE.USUAL) THEN
*       Start of if-block E over IPRLEV
*
*       Compute Mulliken's population analysis
        Write(LF,'(/6X,A,I3)')
     *  'Mulliken population Analysis for root number:',lRootSplit
        Write(LF,'(6X,A)')
     *  '-----------------------------------------------'
        Write(LF,*)
        lSave = lRootSplit.eq.iRlxRoot
        CALL CHARGE(nsym,nbas,name,CMO,OCCN,SMAT,2,FullMlk,lSave)
        Write(LF,*)
*
*       Compute properties
        Write(LF,'(/6X,2A,I3)')
     *  'Expectation values of various properties ',
     *  'for root number:',lRootSplit
        Write(LF,'(6X,2A)')
     *  '-----------------------------------------',
     *  '------------------'
        Write(LF,*)
      END IF
* End of if-block E over IPRLEV

*     Write out info on a temporary vector file. Prpt
*     will need to read this.
      Note='Temporary orbital file used by prpt3.'
      LuTmp=50
      LuTmp=IsFreeUnit(LuTmp)
      Call WrVec('TMPORB',LuTmp,'CO',nSym,nBas,nBas,
     &          CMO,OCCN,Dum,iDum,Note)
      CALL PRPT()
*
*     Compute spin orbitals and spin population
*     (Note: this section overwrites the pseudo natural orbitals
*            with the spin orbitals).
*
      CALL GETMEM('RHO1S','ALLO','REAL',LX6,NACPAR)
      CALL DDAFILE(JOBIPH,0,WORK(LX6),NACPAR,IAD03)
      CALL DDAFILE(JOBIPH,2,WORK(LX6),NACPAR,IAD03)
      CALL DDAFILE(JOBIPH,0,WORK(LX6),NACPR2,IAD03)
      CALL DDAFILE(JOBIPH,0,WORK(LX6),NACPR2,IAD03)
      CALL DBLOCK(WORK(LX6))

      IF (IPRLEV.GE.VERBOSE) THEN
* Start of long if-block F over IPRLEV
        IF(ISPDEN .EQ. 1) THEN
*         Print spin density matrix
          Write(LF,'(/6X,A,I3)')
     &    'Spin density matrix for root number:',lRootSplit
          Write(LF,'(6X,A)')
     &    '--------------------------------------'
          Write(LF,*)
          IND=0
          IDIMV=0
          IDIMO=0
          IDIMN=0
          DO ISYM=1,NSYM
            NAO=NASH(ISYM)
            IF(NAO .EQ. 0) GO TO 50
            NO=NBAS(ISYM)
            IDIMV=IDIMV+NAO*NAO
            IDIMO=IDIMO+NAO
            IDIMN=IDIMN+NO*NAO
            If(iprlev.ge.VERBOSE) then
              Write(LF,'(/6X,A,I2)')
     &        'symmetry species',ISYM
              Write(LF,*)
              CALL TRIPRT(' ',' ',WORK(LX6+IND),NASH(ISYM))
            Endif
            IND=IND+NASH(ISYM)*(NASH(ISYM)+1)/2
  50        CONTINUE
          END DO
        END IF

* End of long if-block F over IPRLEV
      END IF

*     Compute spin orbitals and spin population
      CALL DCOPY_(NTOT,[0.0D0],0,OCCN,1)
*SVC-11-01-2007 store original cmon in cmoso, which gets changed
      CALL GETMEM('CMOSO','ALLO','REAL',ICMOSO,NTOT2)
      CALL DCOPY_(NTOT2,WORK(ICMON),1,WORK(ICMOSO),1)

      CALL SPINORB(WORK(LX6),WORK(ICMOSO),OCCN,lRootSplit)
      CALL GETMEM('RHO1S','FREE','REAL',LX6,NTOTSP)
      CALL DDAFILE(JOBIPH,1,WORK(ICMOSO),NTOT2,IAD14)
      CALL DDAFILE(JOBIPH,1,OCCN,NTOT,IAD14)

      IF (IPRLEV.GE.USUAL) THEN
* Start of long if-block G over IPRLEV
        IF(ISPDEN .EQ. 1) THEN
          Write(LF,'(/6X,A,I3)')
     &   'Mulliken spin population Analysis for root number:',lRootSplit
          Write(LF,'(6X,A)')
     &    '---------------------------------------------------'
          Write(LF,*)
          CALL CHARGE(nsym,nbas,name,Work(icmoso),OCCN,SMAT,3,FullMlk,
     &               .False.)
          Write(LF,*)
        ENDIF

*BOR0511
*       Do LoProp Charge analysis
        If (get_BasisType('ANO')) Then
          Write(LF,'(/6X,A,I3)')
     *    'LoProp population Analysis for root number:',lRootSplit
          Write(LF,'(6X,A)')
     *    '-----------------------------------------------'
          Write(LF,*)
          Write(LF,*)
          Line=''
          Write(Line(left-2:),'(A)') 'LoProp Analysis:'
          Call CollapseOutput(1,Line)
          Write(LF,Fmt2//'A)') '----------------'
          Write(LF,*)
          Write(LF,*)
* Ugly trick: use IRC to pass some info to LoProp ...
          iRC = Min((Abs(lRootSplit-iRlxRoot)),1)
          Call LoProp(iRC)
          Write(LF,*)
          Write(LF,'(6X,A,I2)')
     &    'Natural Bond Order Analysis for root number:',lRootSplit
          Call Nat_Bond_Order(nSym,nBas,Name,2)
          Call CollapseOutput(0,'LoProp Analysis:')
          Write(6,*)
        End If

* End of long if-block G over IPRLEV
      END IF
      CALL GETMEM('CMOSO','FREE','REAL',ICMOSO,NTOT2)

*----- ESPF analysis
      Call DecideOnESPF(Do_ESPF)
      If (Do_ESPF) Call espf_analysis(.False.)


*     Restore the correct 1st order density for gradient calculations.
*
      Call Put_D1AO(DSave,NTOT1)
      Call mma_deallocate(DSave)
*                                                                      *
************************************************************************
*                                                                      *
      CALL GETMEM('CMON','FREE','REAL',icmon,NTOT2)
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Process_Coor(R,Coor,nAtoms,nSym,iOper)

use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: R(3)
real(kind=wp), intent(inout) :: Coor(3,*)
integer(kind=iwp), intent(inout) :: nAtoms
integer(kind=iwp), intent(in) :: nSym, iOper(0:nSym-1)
integer(kind=iwp) :: iAtom, iRef, iSym
real(kind=wp) :: Q(3)

!                                                                      *
!***********************************************************************
!                                                                      *
!call RecPrt('Coor(Enter)',' ',Coor,3,nAtoms)
!call RecPrt('R',' ',R,3,1)
!                                                                      *
!***********************************************************************
!                                                                      *
! Identify if this is a new center.

do iAtom=1,nAtoms
  if ((R(1) == Coor(1,iAtom)) .and. (R(2) == Coor(2,iAtom)) .and. (R(3) == Coor(3,iAtom))) return
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Add this atom to the list

nAtoms = nAtoms+1
Coor(:,nAtoms) = R
iRef = nAtoms
!call RecPrt('Coor(updated)',' ',Coor,3,nAtoms)
!write(u6,*) 'nSym=',nSym
!write(u6,*) 'iOper=',iOper
!                                                                      *
!***********************************************************************
!                                                                      *
! Add symmetry degenerate atoms to the list

outer: do iSym=1,nSym-1
  !write(u6,*) 'iOper(iSym)=',iOper(iSym)
  Q(:) = R
  if (btest(iOper(iSym),0)) Q(1) = -Q(1)
  if (btest(iOper(iSym),1)) Q(2) = -Q(2)
  if (btest(iOper(iSym),2)) Q(3) = -Q(3)
  !call RecPrt('Q',' ',Q,3,1)
  do iAtom=iRef,nAtoms
    if ((Q(1) == Coor(1,iAtom)) .and. (Q(2) == Coor(2,iAtom)) .and. (Q(3) == Coor(3,iAtom))) cycle outer
  end do
  nAtoms = nAtoms+1
  Coor(:,nAtoms) = Q
end do outer
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Process_Coor

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine RdMx(RadMax,Exp,nExp,Cff,nCff,cdMax,EtMax)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             August '91                                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 Exp(nExp), Cff(nExp,nCff)
#include "real.fh"
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
#include "print.fh"
*
      iRout = 201
      iPrint = nPrint(iRout)
*
      Call RecPrt('Exp',' ',Exp,nExp,1)
      Call RecPrt('Cff',' ',Cff,nExp,nCff)
#endif
      Do iExp = 1, nExp
*
         cc = DDot_(nCff,Cff(iExp,1),nExp,Cff(iExp,1),nExp)
         c = Sqrt(cc)
*
         Alpha=Exp(iExp)
         Beta =Exp(iExp)
         Zeta=Alpha+Beta
         If (Zeta.gt.Zero) Then
            Eta=Alpha+Beta
            Rho=(Zeta*Eta)/(Zeta+Eta)
*
            ssss = c**4 * Two*Sqrt(Rho/Pi)*(Pi/Zeta)**(Three/Two)
     &                                    *(Pi/Eta )**(Three/Two)
            If (Sqrt(ssss).gt.RadMax) Then
               RadMax = Sqrt(ssss)
               EtMax  = Eta
               cdMax  = Sqrt(ssss)
            End If
         End If
*
      End Do
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Yoshio Nishimoto                                 *
************************************************************************
      Subroutine CLagX(IFF,CLag,DEPSA,VECROT)

      use PrintLevel, only: VERBOSE
      use caspt2_global, only:iPrGlb
      use Constants, only: Zero
      use definitions, only: wp, iwp, u6
      use stdalloc, only: mma_allocate, mma_deallocate
      use gugx, only: SGS
      use caspt2_module, only: NCONF, NASHT, NASH, ISCF, NSTATE, JSTATE,
     &                         EPSA
      use pt2_guga, only: NG1, NG2, NG3, NG3TOT
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif

      implicit none

#ifdef _MOLCAS_MPP_
#include "global.fh"
#endif

      integer(kind=iwp), intent(in) :: IFF
      real(kind=wp), intent(inout) :: CLag(nConf,nState),
     &                                DEPSA(nAshT,nAshT)
      real(kind=wp), intent(in) :: VECROT(*)

      real(kind=wp), allocatable :: G1(:), G2(:), G3(:)
      real(kind=wp), allocatable :: DG1(:), DG2(:), DG3(:), DF1(:),
     &                              DF2(:), DF3(:)

      integer(kind=iwp) :: nLev, iT, iU
      real(kind=wp) :: DEASUM
      real(kind=wp) :: CPUT, WALLT, CPE, CPTF0, CPTF10, TIOE, TIOTF0,
     &                 TIOTF10

      nLev=SGS%nLev

      !! reduced density matrix and fock-weighted RDM
      CALL mma_allocate(G1 ,NG1, Label='G1')
      CALL mma_allocate(G2 ,NG2, Label='G2')
      CALL mma_allocate(G3 ,NG3, Label='G3')

      !! their derivative contributions
      NG3tot = NG3
      !! Use NG3tot (in pt2_guga.F90) for the moment
#ifdef _MOLCAS_MPP_
      if (is_real_par()) call gaigop_scal(ng3tot,'+')
#endif
      CALL mma_allocate(DG1,NG1,Label='DG1')
      CALL mma_allocate(DG2,NG2,Label='DG2')
      CALL mma_allocate(DG3,NG3,Label='DG3')
      CALL mma_allocate(DF1,NG1,Label='DF1')
      CALL mma_allocate(DF2,NG2,Label='DF2')
      CALL mma_allocate(DF3,NG3,Label='DF3')

      CALL PT2_GET(NG1,' GAMMA1',G1)
      CALL PT2_GET(NG2,' GAMMA2',G2)
      CALL PT2_GET(NG3,' GAMMA3',G3)

      !! Initialize them
      DG1(:) = Zero
      DG2(:) = Zero
      DG3(:) = Zero
      DF1(:) = Zero
      DF2(:) = Zero
      DF3(:) = Zero
      !! DEASUM is the derivative cont. of EASUM
      DEASUM = Zero

      CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
      Call CLagD(G1,G2,G3,
     &           DG1,DG2,DG3,
     &           DF1,DF2,DF3,DEASUM,
     &           DEPSA,VECROT)
      CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
      IF (IPRGLB >= VERBOSE) THEN
        CPUT =CPTF10-CPTF0
        WALLT=TIOTF10-TIOTF0
        write(u6,'(a,2f10.2)')' CLagD   : CPU/WALL TIME=', cput,wallt
#ifdef _MOLCAS_MPP_
!       if (is_real_par()) CALL GADSUM ([deasum],1)
#endif
!       write(u6,*) 'Deasum = ', deasum
#ifdef _MOLCAS_MPP_
!       if (is_real_par()) DEASUM = DEASUM/GA_NNODES()
#endif
      END IF

      !! Some symmetrizations are likely required
      Call CLagSym(nAshT,DG1,DG2,DF1,DF2,0)

      !! Do for the derivative of EASUM
      !! EASUM=EASUM+EPSA(IT)*DREF(IT,IT)
      Do iT = 1, nAsh(1)
         DG1(iT+nAsh(1)*(iT-1)) = DG1(iT+nAsh(1)*(iT-1))
     &                          + DEASUM*EPSA(iT)
        If (ISCF == 0) Then
          Do iU = 1, nAsh(1)
            DEPSA(iT,iU) = DEPSA(iT,iU)
     &        + DEASUM*G1(iT+nAsh(1)*(iU-1))
          End Do
        Else
          !! ?
        End If
      End Do

#ifdef _MOLCAS_MPP_
      !! the master node does the job, so distribute to slave nodes
      !! only for the G1 and G2 replicate arrays
      if (is_real_par()) then
        CALL GADSUM (DG1,NG1)
        CALL GADSUM (DG2,NG2)
        CALL GADSUM (DF1,NG1)
        CALL GADSUM (DF2,NG2)
      end if
#endif

      Call CnstCLag(IFF,CLag(1,jState),
     &              DG1,DG2,DG3,
     &              DF1,DF2,DF3,
     &              DEPSA,
     &              G1,G2,G3,nLev)

      Call mma_deallocate(G1)
      Call mma_deallocate(G2)
      Call mma_deallocate(G3)

      Call mma_deallocate(DG1)
      Call mma_deallocate(DG2)
      Call mma_deallocate(DG3)
      Call mma_deallocate(DF1)
      Call mma_deallocate(DF2)
      Call mma_deallocate(DF3)

      End Subroutine CLagX
!
!-----------------------------------------------------------------------
!
      SUBROUTINE CLagD(G1,G2,G3,DG1,DG2,DG3,DF1,DF2,DF3,DEASUM,DEPSA,
     &                 VECROT)

      use caspt2_global, only: imag_shift, iVecL,
     &                         sigma_p_epsilon, LUSBT,
     &                         LUSOLV, ipea_shift
      use Constants, only: Zero, Half, Two, Four
      use EQSOLV, only: IDSMAT, IDBMAT, IRHS, IVECX, IVECR, IVECW
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp, byte
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: IFMSCOUP, NSYM, NASH, NAES, NASHT,
     &                         NASUP, NISUP, NINDEP, EPSA, EASUM, NTUES,
     &                         NTGEUES, NTGTUES
      use pt2_guga, only: NG3
#ifdef _MOLCAS_MPP_
      use caspt2_global, only: do_lindep, idSDMat, LUSTD, real_shift
      use definitions, only: u6
      USE Para_Info, ONLY: Is_Real_Par, King
#endif

      implicit none

#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      real(kind=wp), intent(inout) :: G1(NASHT,NASHT),
     & G2(NASHT,NASHT,NASHT,NASHT),G3(*),DG1(NASHT,NASHT),
     & DG2(NASHT,NASHT,NASHT,NASHT),DG3(*),DF1(NASHT,NASHT),
     & DF2(NASHT,NASHT,NASHT,NASHT),DF3(*),DEASUM,DEPSA(NASHT,NASHT)
      real(kind=wp), intent(in) :: VECROT(*)

      real(kind=wp), allocatable :: LBD(:),LID(:) !!,VEC1(:),VEC2(:)
      real(kind=wp), allocatable :: SMat(:),BDER(:),SDER(:)
#ifdef _MOLCAS_MPP_
      integer(kind=byte), ALLOCATABLE :: idxG3(:,:)
      real(kind=wp), allocatable :: VEC1(:),VEC2(:),VEC3(:),VEC4(:),
     &                              VEC5(:)
#endif
      integer(kind=iwp) :: iCase, iSym, NIN, NIS, NVEC, NAS, ID,
     &                     iLUID
#ifdef _MOLCAS_MPP_
      integer(kind=iwp) :: MYRANK, lg_S, mS, LDV
      integer(kind=iwp) :: ILO, IHI, JLO, JHI
#endif
      integer(kind=iwp) :: NS, idS, idum, iTabs, iUabs, iVabs, iXabs,
     &  iYabs, iTU2, iTUabs, iTgeUabs, iTgtUabs, iXY2,
     &  iXYabs, iXgeYabs, iXgtYabs, NSEQ
      integer(kind=iwp) :: lg_V1, lg_V2, lg_V3, lg_V4, lg_V5

      real(kind=wp) :: ScalB1, ScalB2, ScalS1, ScalS2, ET, EU, EX, EY,
     & ATUXY, BDERval, bsBDER, SDERval, ATYU, ATYX, ATUX, ATUY

      Do iCase = 1, 11
!       cycle
!       If (icase /= 10.and.icase /= 11) cycle ! G
!       If (icase /= 10)                 cycle ! GP
!       If (icase /=  6.and.icase /=  7) cycle ! E
!       If (icase /=  8.and.icase /=  9) cycle ! F
!       If (icase /=  8)                 cycle ! FP
!       If (icase /=  2.and.icase /=  3) cycle ! B
!       If (icase /=  5)                 cycle ! D
!       If (icase /=  4)                 cycle ! C
!       If (icase /=  1)                 cycle ! A
        Do iSym = 1, nSym
          nIN  = nINDEP(iSym,iCase)
          If (nIN == 0) Cycle
          nIS  = nISUP(iSym,iCase)
          NVEC = nIN*nIS
          nAS  = nASUP(iSym,iCase)
          If (nVec == 0) Cycle

#ifdef _MOLCAS_MPP_
          if (is_real_par()) then
            if (iCase /= 1 .and. iCase /= 4) then
              call mma_allocate(BDER,NAS**2,Label='BDER')
              call mma_allocate(SDER,NAS**2,Label='SDER')
              BDER(:) = Zero
              SDER(:) = Zero
            end if
          else
#endif
            call mma_allocate(BDER,NAS**2,Label='BDER')
            call mma_allocate(SDER,NAS**2,Label='SDER')
            BDER(:) = Zero
            SDER(:) = Zero
#ifdef _MOLCAS_MPP_
          end if
#endif

#if defined(_MOLCAS_MPP_) && defined(_GA_)
          if (is_real_par() .and. (icase == 1 .or. icase == 4)) then
            call CLagDX_MPP()
            cycle
          else
#endif

!         write(u6,*) 'for icase = ', icase
!         write(u6,*) '# of independent vecs:', nin
!         write(u6,*) '# of non-active pairs:', nis
!         write(u6,*) '# of     active pairs:', nas
!         write(u6,*) 'dimension for Vec = ', nin*nis
          !! lg_V1 = T (solution; not quasi-variational)
          Call RHS_ALLO(nIN,nIS,lg_V1)
          Call RHS_READ_SR(lg_V1,iCase,iSym,iVecX)
          !! lg_V2 = lambda (shift correction)
          Call RHS_ALLO(nIN,nIS,lg_V2)
          CALL RHS_READ_SR(lg_V2,iCase,iSym,iVecR)
          if (sigma_p_epsilon /= Zero) then
            call mma_allocate(LBD,nAS,Label='LBD')
            call mma_allocate(LID,nIS,Label='LID')
            iD = iDBMat(iSym,iCase)
            Call dDaFile(LUSBT,2,LBD,nAS,iD)
            Call dDaFile(LUSBT,2,LID,nIS,iD)
            Call CASPT2_ResD(3,nIN,nIS,lg_V2,lg_V1,LBD,LID)
            call mma_deallocate(LBD)
            call mma_deallocate(LID)
          end if

          !! lg_V3 = RHS (in IC basis)
          Call RHS_ALLO(nIN,nIS,lg_V3)
          Call RHS_READ_SR(lg_V3,iCase,iSym,iRHS)
          !! lg_V4 = RHS (in MO basis)
          Call RHS_ALLO(nAS,nIS,lg_V4)
          Call RHS_READ_C (lg_V4,iCase,iSym,iVecW)
          !! lg_V5 = RHS2 (in IC basis)
          If (IFMSCOUP) Then
            Call RHS_ALLO(nIN,nIS,lg_V5)
            Call RHS_READ_SR(lg_V5,iCase,iSym,iVecL) ! 7
          Else
            lg_V5 = lg_V3
          End If

#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            IF (KING()) THEN
              ! copy global array to local buffer
              call mma_allocate(VEC1,NVEC,Label='VEC1')
              CALL GA_GET(lg_V1,1,NIN,1,NIS,VEC1,NIN)
              call mma_allocate(VEC2,NVEC,Label='VEC2')
              CALL GA_GET(lg_V2,1,NIN,1,NIS,VEC2,NIN)
              call mma_allocate(VEC3,NIN*NIS,Label='VEC3')
              CALL GA_GET(lg_V3,1,NIN,1,NIS,VEC3,NIN)
              call mma_allocate(VEC4,NAS*NIS,Label='VEC4')
              CALL GA_GET(lg_V4,1,NAS,1,NIS,VEC4,NAS)
              !! is it possible to avoid allocating twice?
!             IF (IFMSCOUP) THEN
!               call mma_allocate(VEC5,NIN*NIS,Label='VEC5')
!               CALL GA_GET(lg_V5,1,NIN,1,NIS,VEC5,NIN)
!             ELSE
!               LVEC5 = LVEC3
!             END IF
              call mma_allocate(VEC5,NIN*NIS,Label='VEC5')
              CALL GA_GET(lg_V5,1,NIN,1,NIS,VEC5,NIN)

              CALL CLagDX(0,ISYM,ICASE,VEC1,VEC2,
     &                    VEC3,VEC4,
     &                    nIN,nIS,nAS,
     &                    VECROT,VEC5,lg_V2,BDER,SDER)

              ! free local buffer
              call mma_deallocate(VEC1)
              call mma_deallocate(VEC2)
              call mma_deallocate(VEC3)
              call mma_deallocate(VEC4)
!             IF (IFMSCOUP) THEN
              call mma_deallocate(VEC5)
!             END IF
            END IF
            CALL GASYNC()
          ELSE
#endif
            CALL CLagDX(0,iSym,iCase,GA_Arrays(lg_V1)%A,
     &                               GA_Arrays(lg_V2)%A,
     &                               GA_Arrays(lg_V3)%A,
     &                               GA_Arrays(lg_V4)%A,
     &                  nIN,nIS,nAS,
     &                  VECROT,GA_Arrays(lg_V5)%A,lg_V2,BDER,SDER)
#ifdef _MOLCAS_MPP_
          END IF
#endif

          If (imag_shift  /= Zero .or. sigma_p_epsilon /= Zero) Then
            nAS = nASUP(iSym,iCase)
            call mma_allocate(LBD,nAS,Label='LBD')
            call mma_allocate(LID,nIS,Label='LID')
            iD = iDBMat(iSym,iCase)
            Call dDaFile(LUSBT,2,LBD,nAS,iD)
            Call dDaFile(LUSBT,2,LID,nIS,iD)

            CALL RHS_READ_SR(lg_V1,ICASE,ISYM,iVecX)
            CALL RHS_READ_SR(lg_V2,ICASE,ISYM,iVecR)
            Call CASPT2_ResD(2,nIN,nIS,lg_V1,lg_V2,LBD,LID)
            call mma_deallocate(LBD)
            call mma_deallocate(LID)

#ifdef _MOLCAS_MPP_
            IF (Is_Real_Par()) THEN
              IF (KING()) THEN
                ! copy global array to local buffer
                call mma_allocate(VEC1,NVEC,Label='VEC1')
                CALL GA_GET(lg_V1,1,NIN,1,NIS,VEC1,NIN)
                call mma_allocate(VEC2,NVEC,Label='VEC2')
                CALL GA_GET(lg_V2,1,NIN,1,NIS,VEC2,NIN)

                !! lvec3 to lvec5 are not used
                !! only lvec1 and lvec2?
                call mma_allocate(VEC3,1,Label='VEC3')
                call mma_allocate(VEC4,1,Label='VEC4')
                call mma_allocate(VEC5,1,Label='VEC5')
                CALL CLagDX(1,ISYM,ICASE,VEC1,VEC2,
     &                      VEC3,VEC4,
     &                      nIN,nIS,nAS,
     &                      VECROT,VEC5,lg_V2,BDER,SDER)

                ! free local buffer
                call mma_deallocate(VEC1)
                call mma_deallocate(VEC2)
                call mma_deallocate(VEC3)
                call mma_deallocate(VEC4)
                call mma_deallocate(VEC5)
              END IF
              CALL GASYNC()
            ELSE
#endif
              CALL CLagDX(1,iSym,iCase,GA_Arrays(lg_V1)%A,
     &                                 GA_Arrays(lg_V2)%A,
     &                                 GA_Arrays(lg_V3)%A,
     &                                 GA_Arrays(lg_V4)%A,
     &                    nIN,nIS,nAS,
     &                    VECROT,GA_Arrays(lg_V5)%A,lg_V2,BDER,SDER)
#ifdef _MOLCAS_MPP_
            end if
#endif
          End If

          !! for non-separable density/derivative
          CALL RHS_READ_SR(lg_V1,ICASE,ISYM,iVecX)
          CALL RHS_READ_SR(lg_V2,ICASE,ISYM,iVecR)
#if defined(_MOLCAS_MPP_) && defined(_GA_)
          end if
#endif

          if (iCase ==  1) call CLagDXA(BDER,SDER)
          if (iCase ==  2) call CLagDXB(BDER,SDER)
          if (iCase ==  3) call CLagDXB(BDER,SDER)
          if (iCase ==  4) call CLagDXC(BDER,SDER)
          if (iCase ==  5) call CLagDXD(BDER,SDER)
          if (iCase ==  6) call CLagDXE(BDER,SDER)
          if (iCase ==  7) call CLagDXE(BDER,SDER)
          if (iCase ==  8) call CLagDXF(BDER,SDER)
          if (iCase ==  9) call CLagDXF(BDER,SDER)
          if (iCase == 10) call CLagDXG(BDER,SDER)
          if (iCase == 11) call CLagDXG(BDER,SDER)

          CALL RHS_FREE(lg_V1)
          CALL RHS_FREE(lg_V2)
          CALL RHS_FREE(lg_V3)
          CALL RHS_FREE(lg_V4)
          If (IFMSCOUP) CALL RHS_FREE(lg_V5)

#ifdef _MOLCAS_MPP_
          if (is_real_par()) then
            if (iCase /= 1 .and. iCase /= 4) then
              call mma_deallocate(BDER)
              call mma_deallocate(SDER)
            end if
          else
#endif
            call mma_deallocate(BDER)
            call mma_deallocate(SDER)
#ifdef _MOLCAS_MPP_
          end if
#endif
        End Do
      End Do

#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
        iCase = 4
        MYRANK=GA_NODEID()
        Do iSym = 1, nSym
          nAS  = nASUP(iSym,iCase)
          CALL PSBMAT_GETMEM('S',lg_S,NAS)
          CALL PSBMAT_READ('S',4,iSym,lg_S,NAS)
          CALL GA_Distribution(lg_S   ,myRank,ILO,IHI,JLO,JHI)
          Call GA_Access(lg_S   ,ILO,IHI,JLO,JHI,mS   ,LDV)
          CALL mma_allocate(idxG3,6,NG3,label='idxG3')
          iLUID=0
          CALL I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)
          !! DF3 is done after icase=4
          !! construct G3 matrix in lg_S
          CALL MKSC_G3_MPP(ISYM,DBL_MB(mS),ILO,IHI,JLO,JHI,LDV,
     &                     NG3,G3,IDXG3)
          Call GA_Release_Update(lg_S,ILO,IHI,JLO,JHI)
          call DF3_DEPSA_MPP(DF3,DEPSA,lg_S,idxG3)

          Call GA_Release(lg_S   ,ILO,IHI,JLO,JHI)
          CALL mma_deallocate(idxG3)
          CALL PSBMAT_FREEMEM(lg_S)
        End Do
      end if
#endif

      Return

      contains
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXA(BDER,SDER)

      implicit none

      real(kind=wp), intent(in) :: BDER(NAS,NAS)
      real(kind=wp), intent(inout) :: SDER(NAS,NAS)

      integer(kind=byte), allocatable :: idxG3(:,:)

      NS = NAS*(NAS+1)/2
      call mma_allocate(SMat,NS,Label='SMat')
      idS = idSMAT(iSym,1)
      CALL DDAFILE(LUSBT,2,SMat,NS,idS)

      idum=0
      Call CLagDXA_DP (iSym,nAS,BDER,SDER,
     &                 DG1,DG2,DF1,DF2,DEPSA,DEASUM,
     &                 1,nAS,1,nAS,0,G1,G2,SMat,SMat,idum)

      !! G3 and F3 relevant
      CALL mma_allocate(idxG3,6,NG3,label='idxG3')
      iLUID=0
      CALL I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)
!     idS = idSMAT(iSym,4)
!     CALL DDAFILE(LUSBT,2,SMat,NS,idS)
      CALL MKSC_G3(iSym,SMat,nG3,G3,idxG3)
      call CLagDXA_FG3(iSym,nAS,NG3,BDER,SDER,
     &                 DF1,DF2,DF3,DG1,DG2,DG3,DEPSA,G2,
     &                 SMat,idxG3)
      call mma_deallocate(idxG3)

      call mma_deallocate(SMat)

      return

      End Subroutine CLagDXA
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXB(BDER,SDER)

      USE SUPERINDEX, only: MTGEU, MTGTU

      implicit none

      real(kind=wp), intent(in) :: BDER(NAS,NAS)
      real(kind=wp), intent(inout) :: SDER(NAS,NAS)

      real(kind=wp), allocatable :: WrkBbf(:,:,:,:),WrkSbf(:,:,:,:)
      integer(kind=iwp) :: iTU, iXY, iT, iU, iX, iY, iV

      call mma_allocate(WrkBbf,nAshT,nAshT,nAshT,nAshT,Label='WrkBbf')
      call mma_allocate(WrkSbf,nAshT,nAshT,nAshT,nAshT,Label='WrkSbf')
      WrkBbf(:,:,:,:) = Zero
      WrkSbf(:,:,:,:) = Zero

      If (ipea_shift /= Zero) Then
        NS = NAS*(NAS+1)/2
        call mma_allocate(SMat,NS,Label='SMat')
        idS = idSMAT(iSym,iCase)
        CALL DDAFILE(LUSBT,2,SMat,NS,idS)
      End If
      ScalB1 = Zero
      ScalB2 = Zero
      ScalS1 = Zero
      ScalS2 = Zero
      iTabs  = 0
      iUabs  = 0
      iXabs  = 0
      iYabs  = 0
      iTgeUabs = 0
      iTgtUabs = 0
      iXgeYabs = 0
      iXgtYabs = 0
      Do iTU = 1, nAS
        If (iCase == 2) Then
          iTgeUabs = iTU + nTgeUes(iSym)
          iTabs    = mTgeU(1,iTgeUabs)
          iUabs    = mTgeU(2,iTgeUabs)
        Else If (iCase == 3) Then
          iTgtUabs = iTU + nTgtUes(iSym)
          iTabs    = mTgtU(1,iTgtUabs)
          iUabs    = mTgtU(2,iTgtUabs)
        End If
        ET = EPSA(iTabs)
        EU = EPSA(iUabs)
        DO iXY = 1, nAS
          If (iCase == 2) Then
            iXgeYabs = iXY + nTgeUes(iSym)
            iXabs    = mTgeU(1,iXgeYabs)
            iYabs    = mTgeU(2,iXgeYabs)
          Else If (iCase == 3) Then
            iXgtYabs = iXY + nTgtUes(iSym)
            iXabs    = mTgtU(1,iXgtYabs)
            iYabs    = mTgtU(2,iXgtYabs)
          End If
          EX = EPSA(iXabs)
          EY = EPSA(iYabs)
          ATUXY = EASUM-ET-EU-EX-EY
!         iBadr = iTU + nAS*(iXY-1)
          BDERval = BDER(ITU,IXY)

          !! For IPEA shift
          If (iTU ==iXY .and. ipea_shift /= Zero) Then
!           idT=(iTabs*(iTabs+1))/2
            ! idU=(iUabs*(iUabs+1))/2
            NSEQ = iTU*(iTU+1)/2
            bsBDER = ipea_shift*Half*BDERval
!         !! ipea_shift*Half*(DREF(IDT)+DREF(IDU))*SDP(ITGEU)
            DG1(iTabs,iTabs) = DG1(iTabs,iTabs) + bsBDER*SMat(NSEQ)
            DG1(iUabs,iUabs) = DG1(iUabs,iUabs) + bsBDER*SMat(NSEQ)
            SDER(iTU,iXY) = SDER(iTU,iXY)
     &        + (G1(iTabs,iTabs)+G1(iUabs,iUabs))*bsBDER
          End If
          SDERval = SDER(ITU,IXY)
          If (iTabs == iUabs) Then
            BDERval = BDERval*Two
            SDERval = SDERval*Two
          End If

          If (iCase == 2) Then
            ScalB1 = BDERval
            ScalB2 = BDERval
            ScalS1 = SDERval
            ScalS2 = SDERval
          Else If (iCase == 3) Then
            ScalB1 = BDERval
            ScalB2 =-BDERval
            ScalS1 = SDERval
            ScalS2 =-SDERval
          End If

          WRKBBF(iTabs,iUabs,iXabs,iYabs)
     &      = WRKBBF(iTabs,iUabs,iXabs,iYabs) + ScalB1
          WRKBBF(iTabs,iUabs,iYabs,iXabs)
     &      = WRKBBF(iTabs,iUabs,iYabs,iXabs) + ScalB2
          WRKSBF(iTabs,iUabs,iXabs,iYabs)
     &      = WRKSBF(iTabs,iUabs,iXabs,iYabs) + ScalS1
          WRKSBF(iTabs,iUabs,iYabs,iXabs)
     &      = WRKSBF(iTabs,iUabs,iYabs,iXabs) + ScalS2
          If (iTabs /= iUabs) Then
          WRKBBF(iUabs,iTabs,iXabs,iYabs)
     &      = WRKBBF(iUabs,iTabs,iXabs,iYabs) + ScalB2
          WRKBBF(iUabs,iTabs,iYabs,iXabs)
     &      = WRKBBF(iUabs,iTabs,iYabs,iXabs) + ScalB1
          WRKSBF(iUabs,iTabs,iXabs,iYabs)
     &      = WRKSBF(iUabs,iTabs,iXabs,iYabs) + ScalS2
          WRKSBF(iUabs,iTabs,iYabs,iXabs)
     &      = WRKSBF(iUabs,iTabs,iYabs,iXabs) + ScalS1
          End If
        End Do
      End Do

      !! it,iu,... are actually itabs,iuabs,...
      Do iT = 1, nAshT
        ET = EPSA(iT)
        DO iU = 1, nAshT
          EU = EPSA(iU)
          Do iX = 1, nAshT
            EX = EPSA(iX)
            Do iY = 1, nAshT
              EY = EPSA(iY)
              BDERval = WRKBBF(iT,iU,iX,iY)
              SDERval = WRKSBF(iT,iU,iX,iY)

              !! term 1 (w/o delta)
              ATUXY = EASUM-ET-EU-EX-EY
              !! G1 and F1 derivative
              DF2(iX,iT,iY,iU) = DF2(iX,iT,iY,iU) + BDERval
              DG2(iX,iT,iY,iU) = DG2(iX,iT,iY,iU)
     &          - ATUXY*BDERval + SDERval
              !! EASUM derivative
              DEASUM = DEASUM - BDERval*G2(iX,iT,iY,iU)
              !! EPSA derivative
              Do iV = 1, NASHT
                DEPSA(iT,iV) = DEPSA(iT,iV) + BDERval*G2(iX,iV,iY,iU)
                DEPSA(iU,iV) = DEPSA(iU,iV) + BDERval*G2(iX,iT,iY,iV)
                DEPSA(iX,iV) = DEPSA(iX,iV) + BDERval*G2(iV,iT,iY,iU)
                DEPSA(iY,iV) = DEPSA(iY,iV) + BDERval*G2(iX,iT,iV,iU)
              End Do

              BDERval = BDERval*Two
              SDERval = SDERval*Two

              !! term 2 (dxt)
              If (iX == iT) Then
                ATYU = EASUM-ET-EY-EU
                !! G1 and F1 derivative
                DF1(iY,iU) = DF1(iY,iU) - BDERval
                DG1(iY,iU) = DG1(iY,iU) + ATYU*BDERval - SDERval
                !! EASUM derivative
                DEASUM = DEASUM + BDERval*G1(iY,iU)
                !! EPSA derivative
                Do iV = 1, NASHT
                  DEPSA(iY,iV) = DEPSA(iY,iV) - BDERval*G1(iV,iU)
                  DEPSA(iU,iV) = DEPSA(iU,iV) - BDERval*G1(iY,iV)
                End Do
              End If
              !! Additional EPSA derivative
              DEPSA(iX,iT) = DEPSA(iX,iT) - BDERval*G1(iY,iU)
              !! dxt*dyu term
              If (iY == iU) DEPSA(iX,iT) = DEPSA(iX,iT) + Two*BDERval
              If (iX == iT) DEPSA(iY,iU) = DEPSA(iY,iU) + Two*BDERval

              !! term 3 (dyu)
              If (iY == iU) Then
                ATYX = EASUM-ET-EY-EX
                !! G1 and F1 derivative
                DF1(iX,iT) = DF1(iX,iT) - BDERval
                DG1(iX,iT) = DG1(iX,iT) + ATYX*BDERval - SDERval
                !! EASUM derivative
                DEASUM = DEASUM + BDERval*G1(iX,iT)
                !! EPSA derivative
                Do iV = 1, NASHT
                  DEPSA(iX,iV) = DEPSA(iX,iV) - BDERval*G1(iV,iT)
                  DEPSA(iT,iV) = DEPSA(iT,iV) - BDERval*G1(iX,iV)
                End Do
              End If
              !! Additional EPSA derivative
              DEPSA(iY,iU) = DEPSA(iY,iU) - BDERval*G1(iX,iT)

              BDERval = BDERval*Half
              SDERval = SDERval*Half

              !! term 4 (dyt)
              If (iY == iT) Then
                ATUX = EASUM-ET-EU-EX
                !! G1 and F1 derivative
                DF1(iX,iU) = DF1(iX,iU) + BDERval
                DG1(iX,iU) = DG1(iX,iU) - ATUX*BDERval + SDERval
                !! EASUM derivative
                DEASUM = DEASUM - BDERval*G1(iX,iU)
                !! EPSA derivative
                Do iV = 1, NASHT
                  DEPSA(iX,iV) = DEPSA(iX,iV) + BDERval*G1(iV,iU)
                  DEPSA(iU,iV) = DEPSA(iU,iV) + BDERval*G1(iX,iV)
                End Do
              End If
              !! Additional EPSA derivative
              DEPSA(iY,iT) = DEPSA(iY,iT) + BDERval*G1(iX,iU)
              !! dxu*dyt term
              If (iY == iT) DEPSA(iX,iU) = DEPSA(iX,iU) - Two*BDERval
              If (iX == iU) DEPSA(iY,iT) = DEPSA(iY,iT) - Two*BDERval

              !! term 5 (dxu)
              If (iX == iU) Then
                ATUY = EASUM-ET-EU-EY
                !! G1 and F1 derivative
                DF1(iY,iT) = DF1(iY,iT) + BDERval
                DG1(iY,iT) = DG1(iY,iT) - ATUY*BDERval + SDERval
                !! EASUM derivative
                DEASUM = DEASUM - BDERval*G1(iY,iT)
                !! EPSA derivative
                Do iV = 1, NASHT
                  DEPSA(iY,iV) = DEPSA(iY,iV) + BDERval*G1(iV,iT)
                  DEPSA(iT,iV) = DEPSA(iT,iV) + BDERval*G1(iY,iV)
                End Do
              End If
              !! Additional EPSA derivative
              DEPSA(iX,iU) = DEPSA(iX,iU) + BDERval*G1(iY,iT)
            End Do
          End Do
        End Do
      End Do
      If (ipea_shift /= Zero) call mma_deallocate(SMat)

      call mma_deallocate(WrkBbf)
      call mma_deallocate(WrkSbf)

      return

      End Subroutine CLagDXB
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXC(BDER,SDER)

      implicit none

      real(kind=wp), intent(in) :: BDER(NAS,NAS)
      real(kind=wp), intent(inout) :: SDER(NAS,NAS)

      integer(kind=byte), allocatable :: idxG3(:,:)

      NS = NAS*(NAS+1)/2
      call mma_allocate(SMat,NS,Label='SMat')
      idS = idSMAT(iSym,4)
      CALL DDAFILE(LUSBT,2,SMat,NS,idS)

      idum = 0
      Call CLagDXC_DP (iSym,nAS,BDER,SDER,
     &                 DG1,DG2,DF1,DF2,DEPSA,DEASUM,
     &                 1,nAS,1,nAS,0,G1,G2,SMat,SMat,idum)

      !! G3 and F3 relevant
      CALL mma_allocate(idxG3,6,NG3,label='idxG3')
      iLUID=0
      CALL I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)
!     idS = idSMAT(iSym,4)
!     CALL DDAFILE(LUSBT,2,SMat,NS,idS)
      CALL MKSC_G3(iSym,SMat,nG3,G3,idxG3)
      call CLagDXC_FG3(iSym,nAS,NG3,BDER,SDER,
     &                 DF1,DF2,DF3,DG1,DG2,DG3,DEPSA,G2,
     &                 SMat,idxG3)
      call mma_deallocate(idxG3)

      call mma_deallocate(SMat)

      return

      End Subroutine CLagDXC
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXD(BDER,SDER)

      USE SUPERINDEX, only: MTU

      implicit none

      real(kind=wp), intent(in) :: BDER(NAS,NAS)
      real(kind=wp), intent(inout) :: SDER(NAS,NAS)

      real(kind=wp) :: BDER1, BDER2, SDER1, SDER2, ETX
      integer(kind=iwp) :: iTU, iXY, iV

      If (ipea_shift /= Zero) Then
        NS = NAS*(NAS+1)/2
        call mma_allocate(SMat,NS,Label='SMat')
        idS = idSMAT(iSym,iCase)
        CALL DDAFILE(LUSBT,2,SMat,NS,idS)
      End If

      Do iTU = 1, nAS/2
        iTU2   = iTU + nAS/2
        iTUabs = iTU + nTUes(iSym)
        iTabs  = mTU(1,iTUabs)
        iUabs  = mTU(2,iTUabs)
        ET     = EPSA(iTabs)
        DO iXY = 1, nAS/2
          iXY2   = iXY + nAS/2
          iXYabs = iXY + nTUes(iSym)
          iXabs  = mTU(1,iXYabs)
          iYabs  = mTU(2,iXYabs)
          EX     = EPSA(iXabs)
          ETX    = ET+EX

          BDER1 = BDER(iTU ,iXY )
     &          - BDER(iTU ,iXY2)*Half
     &          - BDER(iTU2,iXY )*Half
          BDER2 = BDER(iTU2,iXY2)

          !! Derivative of B11
          DF2(iUabs,iTabs,iXabs,iYabs)
     &      = DF2(iUabs,iTabs,iXabs,iYabs) + Two*BDER1
          DG2(iUabs,iTabs,iXabs,iYabs)
     &      = DG2(iUabs,iTabs,iXabs,iYabs) + Two*(ETX-EASUM)*BDER1
          DEASUM = DEASUM - Two*G2(iUabs,iTabs,iXabs,iYabs)*BDER1
          If (iXabs == iTabs) Then
            DF1(iUabs,iYabs) = DF1(iUabs,iYabs) + Two*BDER1
            DG1(iUabs,iYabs) = DG1(iUabs,iYabs) + Two*(ET-EASUM)*BDER1
            DEASUM = DEASUM - Two*G1(iUabs,iYabs)*BDER1
          End If
          DO iV = 1, nAsh(iSym)
            IVABS=IV+NAES(ISYM)
            DEPSA(iTabs,iVabs) = DEPSA(iTabs,iVabs)
     &        + Two*BDER1*G2(iUabs,iVabs,iXabs,iYabs)
            DEPSA(iXabs,iVabs) = DEPSA(iXabs,iVabs)
     &        + Two*BDER1*G2(iUabs,iTabs,iVabs,iYabs)
          End Do
          DEPSA(iTabs,iXabs) = DEPSA(iTabs,iXabs)
     &      + Two*G1(iUabs,iYabs)*BDER1

          !! Derivative of B22
          DF2(iXabs,iTabs,iUabs,iYabs)
     &      = DF2(iXabs,iTabs,iUabs,iYabs) - BDER2
          DG2(iXabs,iTabs,iUabs,iYabs)
     &      = DG2(iXabs,iTabs,iUabs,iYabs) - (ETX-EASUM)*BDER2
          DEASUM = DEASUM + G2(iXabs,iTabs,iUabs,iYabs)*BDER2
          If (iXabs == iTabs) Then
            DF1(iUabs,iYabs) = DF1(iUabs,iYabs) + Two*BDER2
            DG1(iUabs,iYabs) = DG1(iUabs,iYabs) + Two*(EX-EASUM)*BDER2
            DEASUM = DEASUM - Two*G1(iUabs,iYabs)*BDER2
          End If
          DO iV = 1, nAsh(iSym)
            IVABS=IV+NAES(ISYM)
            DEPSA(iTabs,iVabs) = DEPSA(iTabs,iVabs)
     &        - BDER2*G2(iXabs,iVabs,iUabs,iYabs)
            DEPSA(iXabs,iVabs) = DEPSA(iXabs,iVabs)
     &        - BDER2*G2(iVabs,iTabs,iUabs,iYabs)
          End Do
          DEPSA(iXabs,iTabs) = DEPSA(iXabs,iTabs)
     &      + Two*G1(iUabs,iYabs)*BDER2

          If (iTU == iXY .and. ipea_shift /= Zero) Then
!      !! ipea_shift*Half*(Two-DREF(IDU)+DREF(IDT))*SD(ITU)
            bsBDER = ipea_shift*Half*BDER(iTU,iXY)
            NSEQ = iTU*(iTU+1)/2
            DG1(iTabs,iTabs) = DG1(iTabs,iTabs) + bsBDER*SMat(NSEQ)
            DG1(iUabs,iUabs) = DG1(iUabs,iUabs) - bsBDER*SMat(NSEQ)
            SDER(iTU,iXY) = SDER(iTU,iXY)
     &        + bsBDER*(Two+G1(iTabs,iTabs)-G1(iUabs,iUabs))
!    !! ipea_shift*Half*(Two-DREF(IDU)+DREF(IDT))*SD(ITU+NAS)
            bsBDER = ipea_shift*Half*BDER(iTU2,iXY2)
            NSEQ = iTU2*(iTU2+1)/2
            DG1(iTabs,iTabs) = DG1(iTabs,iTabs) + bsBDER*SMat(NSEQ)
            DG1(iUabs,iUabs) = DG1(iUabs,iUabs) - bsBDER*SMat(NSEQ)
            SDER(iTU2,iXY2) = SDER(iTU2,iXY2)
     &        + bsBDER*(Two+G1(iTabs,iTabs)-G1(iUabs,iUabs))
          End If

          SDER1 = SDER(iTU ,iXY )
     &          - SDER(iTU ,iXY2)*Half
     &          - SDER(iTU2,iXY )*Half
          SDER2 = SDER(iTU2,iXY2)

          !! Derivative of S11
          DG2(iUabs,iTabs,iXabs,iYabs)
     &      = DG2(iUabs,iTabs,iXabs,iYabs) + Two*SDER1
          If (iXabs == iTabs) Then
            DG1(iUabs,iYabs) = DG1(iUabs,iYabs) + Two*SDER1
          End If
          !! Derivative of S22
          DG2(iXabs,iTabs,iUabs,iYabs)
     &      = DG2(iXabs,iTabs,iUabs,iYabs) - SDER2
          If (iXabs == iTabs) Then
            DG1(iUabs,iYabs) = DG1(iUabs,iYabs) + Two*SDER2
          End If
        End Do
      End Do
      If (ipea_shift /= Zero) call mma_deallocate(SMat)

      return

      End Subroutine CLagDXD
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXE(BDER,SDER)

      implicit none

      real(kind=wp), intent(in) :: BDER(NAS,NAS)
      real(kind=wp), intent(inout) :: SDER(NAS,NAS)

      real(kind=wp) :: VAL
      integer(kind=iwp) :: IT, IU, iV

      If (ipea_shift /= Zero) Then
        NS = NAS*(NAS+1)/2
        call mma_allocate(SMat,NS,Label='SMat')
        idS = idSMAT(iSym,6)
        CALL DDAFILE(LUSBT,2,SMat,NS,idS)
        !! ipea_shift*Half*DREF(IDT)*SD(IT)
        DO IT = 1, NAS
          ITABS=IT+NAES(ISYM)
          VAL = ipea_shift*Half*BDER(IT,IT)
          SDER(IT,IT) = SDER(IT,IT) + G1(ITABS,ITABS)*VAL
          NSEQ = IT*(IT-1)/2+IT
          DG1(ITABS,ITABS) = DG1(ITABS,ITABS) + SMat(NSEQ)*VAL
        End Do
        call mma_deallocate(SMat)
      End If

      DO IT = 1, NAS
        ITABS=IT+NAES(ISYM)
        ET = EPSA(ITABS)
        DO IU = 1, NAS
          IUABS=IU+NAES(ISYM)
          EU = EPSA(IUABS)
          !! Derivative of the B matrix
          !! B_{tu} = -F1_{tu} + (Esum-e_t-e_u)*G1(tu)
          DG1(ITABS,IUABS) = DG1(ITABS,IUABS)
     &      + (EASUM-ET-EU)*BDER(IT,IU)
          DEASUM = DEASUM + G1(ITABS,IUABS)*BDER(IT,IU)
          DF1(ITABS,IUABS) = DF1(ITABS,IUABS) - BDER(IT,IU)
          DO IV = 1, NASH(ISYM)
            IVABS=IV+NAES(ISYM)
            DEPSA(ITABS,IUABS) = DEPSA(ITABS,IUABS)
     &        - G1(ITABS,IVABS)*BDER(IV,IU)
     &        - G1(IUABS,IVABS)*BDER(IV,IT)
          End Do
          DEPSA(ITABS,IUABS) = DEPSA(ITABS,IUABS) + Two*BDER(IT,IU)
          !! Derivative of the S matrix
          DG1(ITABS,IUABS) = DG1(ITABS,IUABS) - SDER(IT,IU)
        END DO
      END DO

      return

      End Subroutine CLagDXE
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXF(BDER,SDER)

      USE SUPERINDEX, only: MTGTU, MTGEU

      implicit none

      real(kind=wp), intent(in) :: BDER(NAS,NAS)
      real(kind=wp), intent(inout) :: SDER(NAS,NAS)

      integer(kind=iwp) :: iTU, iXY

      If (ipea_shift /= Zero) Then
        NS = NAS*(NAS+1)/2
        call mma_allocate(SMat,NS,Label='SMat')
        idS = idSMAT(iSym,iCase)
        CALL DDAFILE(LUSBT,2,SMat,NS,idS)
      End If
      ScalB1 = Zero
      ScalB2 = Zero
      ScalS1 = Zero
      ScalS2 = Zero
      iXabs  = 0
      iYabs  = 0
      iTabs  = 0
      iUabs  = 0
      iTgeUabs = 0
      iTgtUabs = 0
      iXgeYabs = 0
      iXgtYabs = 0
      Do iTU = 1, nAS
        If (iCase ==  8) Then
          iTgeUabs = iTU + nTgeUes(iSym)
          iTabs    = mTgeU(1,iTgeUabs)
          iUabs    = mTgeU(2,iTgeUabs)
        Else If (iCase ==  9) Then
          iTgtUabs = iTU + nTgtUes(iSym)
          iTabs    = mTgtU(1,iTgtUabs)
          iUabs    = mTgtU(2,iTgtUabs)
        End If
        DO iXY = 1, nAS !! iTU
          If (iCase ==  8) Then
            iXgeYabs = iXY + nTgeUes(iSym)
            iXabs    = mTgeU(1,iXgeYabs)
            iYabs    = mTgeU(2,iXgeYabs)
          Else If (iCase ==  9) Then
            iXgtYabs = iXY + nTgtUes(iSym)
            iXabs    = mTgtU(1,iXgtYabs)
            iYabs    = mTgtU(2,iXgtYabs)
          End If

          BDERval = BDER(ITU,IXY)
          If (iTU == iXY .and. ipea_shift /= Zero) Then
!           idT=(iTabs*(iTabs+1))/2
            ! idU=(iUabs*(iUabs+1))/2
            NSEQ = iTU*(iTU+1)/2
            bsBDER = ipea_shift*Half*BDERval
!     !! ipea_shift*Half*(Four-DREF(IDT)-DREF(IDU))*SDP(ITGEU)
            DG1(iTabs,iTabs) = DG1(iTabs,iTabs) - SMat(NSEQ)*bsBDER
            DG1(iUabs,iUabs) = DG1(iUabs,iUabs) - SMat(NSEQ)*bsBDER
            SDER(ITU,IXY) = SDER(ITU,IXY)
     &        + (Four-G1(iTabs,iTabs)-G1(iUabs,iUabs))*bsBDER
          End If
          SDERval = SDER(ITU,IXY)
          If (iTabs == iUabs) Then
            BDERval = Two*BDERval
            SDERval = Two*SDERval
          End If

          If (iCase ==  8) Then
            ScalB1 = BDERval
            ScalB2 = BDERval
            ScalS1 = SDERval
            ScalS2 = SDERval
          Else If (iCase ==  9) Then
            ScalB1 = BDERval
            ScalB2 =-BDERval
            ScalS1 = SDERval
            ScalS2 =-SDERval
          End If

          !! Derivative of the B matrix
          !! B(tuxy) -> PREF(tx,uy)
          DEASUM = DEASUM - ScalB1*G2(iTabs,iXabs,iUabs,iYabs)
     &                    - ScalB2*G2(iTabs,iYabs,iUabs,iXabs)
          If (iTabs /= iUabs)
     &    DEASUM = DEASUM - ScalB2*G2(iUabs,iXabs,iTabs,iYabs)
     &                    - ScalB1*G2(iUabs,iYabs,iTabs,iXabs)

          ! iTX = iTabs+nAshT*(iXabs-1)
          ! iUY = iUabs+nAshT*(iYabs-1)
          ! iTY = iTabs+nAshT*(iYabs-1)
          ! iUX = iUabs+nAshT*(iXabs-1)

          DF2(iTabs,iXabs,iUabs,iYabs)
     &      = DF2(iTabs,iXabs,iUabs,iYabs) + ScalB1
          DF2(iTabs,iYabs,iUabs,iXabs)
     &      = DF2(iTabs,iYabs,iUabs,iXabs) + ScalB2
          If (iTabs /= iUabs) Then
            DF2(iUabs,iXabs,iTabs,iYabs)
     &        = DF2(iUabs,iXabs,iTabs,iYabs) + ScalB2
            DF2(iUabs,iYabs,iTabs,iXabs)
     &        = DF2(iUabs,iYabs,iTabs,iXabs) + ScalB1
          End If
          DG2(iTabs,iXabs,iUabs,iYabs)
     &      = DG2(iTabs,iXabs,iUabs,iYabs) + ScalS1-EASUM*ScalB1
          DG2(iTabs,iYabs,iUabs,iXabs)
     &      = DG2(iTabs,iYabs,iUabs,iXabs) + ScalS2-EASUM*ScalB2
          If (iTabs /= iUabs) Then
            DG2(iUabs,iXabs,iTabs,iYabs)
     &        = DG2(iUabs,iXabs,iTabs,iYabs) + ScalS2-EASUM*ScalB2
            DG2(iUabs,iYabs,iTabs,iXabs)
     &        = DG2(iUabs,iYabs,iTabs,iXabs) + ScalS1-EASUM*ScalB1
          End If
        End Do
      End Do
      If (ipea_shift /= Zero) call mma_deallocate(SMat)

      return

      End Subroutine CLagDXF
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXG(BDER,SDER)

      implicit none

      real(kind=wp), intent(in) :: BDER(NAS,NAS)
      real(kind=wp), intent(inout) :: SDER(NAS,NAS)

      real(kind=wp) :: VAL
      integer(kind=iwp) :: IT, IU

      If (ipea_shift /= Zero) Then
        NS = NAS*(NAS+1)/2
        call mma_allocate(SMat,NS,Label='SMat')
        idS = idSMAT(iSym,10)
        CALL DDAFILE(LUSBT,2,SMat,NS,idS)
        !! ipea_shift*Half*(Two-DREF(IDT))*SD(IT)
        DO IT = 1, NAS
          ITABS=IT+NAES(ISYM)
          VAL = ipea_shift*Half*BDER(IT,IT)
          SDER(IT,IT) = SDER(IT,IT) + (Two-G1(ITABS,ITABS))*VAL
          NSEQ = IT*(IT-1)/2+IT
          DG1(ITABS,ITABS) = DG1(ITABS,ITABS) - SMat(NSEQ)*VAL
        End Do
        call mma_deallocate(SMat)
      End If

      DO IT = 1, NAS
        ITABS=IT+NAES(ISYM)
        DO IU = 1, NAS
          IUABS=IU+NAES(ISYM)
          !! Derivative of the B matrix
          DG1(ITABS,IUABS) = DG1(ITABS,IUABS) - EASUM*BDER(IT,IU)
          DEASUM = DEASUM - G1(ITABS,IUABS)*BDER(IT,IU)
          DF1(ITABS,IUABS) = DF1(ITABS,IUABS) + BDER(IT,IU)
          !! Derivative of the S matrix
          DG1(ITABS,IUABS) = DG1(ITABS,IUABS) + SDER(IT,IU)
        END DO
      END DO

      return

      End Subroutine CLagDXG
!
!-----------------------------------------------------------------------
!
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      Subroutine CLagDX_MPP()

      use caspt2_global, only: iVecL
      use caspt2_module, only: MAXIT, JSTATE
      use Constants, only: One

      implicit none

#include "global.fh"
#include "mafdecls.fh"

      integer(kind=byte), ALLOCATABLE :: idxG3(:,:)
      real(kind=wp),allocatable :: EIG(:),WRK(:,:)

      logical(kind=iwp) :: bStat
      integer(kind=iwp) :: myrank, nprocs, lg_T, lg_WRK, lg_WRK2,
     &                     lg_BDER, iLoV1, iHiV1, jLoV1, jHiV1, NROW,
     &                     NCOL, idB, mV1, LDV1, i, j, iICB, jICB,
     &                     lg_SDER, idSD, mBDER, mSDER
      real(kind=wp) :: SCAL, EigI, EigJ
!
!     Construct active density in NAS basis
!     Although non-GA version is also implemented, I noticed that
!     scatter operations require GA, so I should just use GA_DGEMM
!
      SCAL = One
      IF (IFMSCOUP) SCAL = VECROT(jState)
      MYRANK=GA_NODEID()
      NPROCS=GA_NNODES()

      !! First, distribute the transformation matrix
      CALL GA_CREATE_STRIPED ('H',NAS,NIN,'TRANS',lg_T)
      CALL PSBMAT_READ('T',iCase,iSym,lg_T,NAS*NIN)
!     CALL PSBMAT_READ('T',iCase,iSym,lg_T,NAS)
      !! only the master node has written it
!     if (ifmscoup) then
!     else
!     IF (KING()) THEN
!       call mma_allocate(TRANS,NAS*NIN,Label='TRANS')
!       IDT=IDTMAT(ISYM,ICASE)
!       CALL DDAFILE(LUSBT,2,TRANS,NAS*NIN,IDT)
!       CALL GA_PUT(lg_T,1,NAS,1,NIN,TRANS,NAS)
!       call mma_deallocate(TRANS)
!     END IF
!     endif
      CALL GA_SYNC()

      !! Allocate BDER in NIN
      CALL GA_CREATE_STRIPED ('V',NIN,NIN,'WRK',lg_WRK)
      CALL GA_ZERO(lg_WRK)
      CALL GA_SYNC()
!
!     mode = 0 operations for B derivative
!
      !! First, construct the density with NIN basis
      !! lg_V1 = T (solution; not quasi-variational)
      Call RHS_ALLO(nIN,nIS,lg_V1)
      Call RHS_READ_SR(lg_V1,iCase,iSym,iVecX)
      call GA_DGEMM ('N','T',NIN,NIN,NIS,
     &               SCAL,lg_V1,lg_V1,Zero,lg_WRK)

      If ((real_shift /= Zero) .OR. (imag_shift /= Zero)
     &    .OR. (sigma_p_epsilon /= Zero) .OR. IFMSCOUP) Then
        if (sigma_p_epsilon /= Zero) then
          !! lg_V2 = lambda (shift correction)
          Call RHS_ALLO(nIN,nIS,lg_V2)
          Call RHS_READ_SR(lg_V2,iCase,iSym,iVecR)
          call mma_allocate(LBD,nAS,Label='LBD')
          call mma_allocate(LID,nIS,Label='LID')
          iD = iDBMat(iSym,iCase)
          Call dDaFile(LUSBT,2,LBD,nAS,iD)
          Call dDaFile(LUSBT,2,LID,nIS,iD)
          !! this scaling is needed, so GA_DGEMM cannot be used
          Call CASPT2_ResD(3,nIN,nIS,lg_V2,lg_V1,LBD,LID)
          call mma_deallocate(LBD)
          call mma_deallocate(LID)
        else
          !! lg_V2 = lambda (shift correction)
          Call RHS_ALLO(nIN,nIS,lg_V2)
          Call RHS_READ_SR(lg_V2,iCase,iSym,iVecR)
        end if
        call GA_DGEMM ('N', 'T', NIN, NIN, NIS, Half,
     &                 lg_V1, lg_V2, One, lg_WRK)
        call GA_DGEMM ('N', 'T', NIN, NIN, NIS, Half,
     &                 lg_V2, lg_V1, One, lg_WRK)
        Call RHS_FREE(lg_V2)
      End If

      if (sigma_p_epsilon /= Zero) then
!       CALL RHS_READ_SR(lg_V2,ICASE,ISYM,iVecR)
      endif

      CALL GA_SYNC()
!
!     mode = 1 operations for B derivative
!     lg_V1 is still loaded
!
      if (imag_shift /= Zero .or. sigma_p_epsilon /= Zero) then
        CALL GA_Scale (lg_WRK,-One)

        !! T*T is skipped

        !! lg_V2 = lambda (shift correction)
        Call RHS_ALLO(nIN,nIS,lg_V2)
        Call RHS_READ_SR(lg_V2,iCase,iSym,iVecR)
!       CALL GA_Distribution (lg_V1,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
!       CALL GA_Distribution (lg_V2,myRank,iLoV2,iHiV2,jLoV2,jHiV2)
!       NROW1 = iHiV1-iLoV1+1
!       NCOL1 = jHiV1-jLoV1+1
!       NROW2 = iHiV2-iLoV2+1
!       NCOL2 = jHiV2-jLoV2+1
!       if (nrow1*ncol1*nrow2*ncol2 > 0) then
          call mma_allocate(LBD,nAS,Label='LBD')
          call mma_allocate(LID,nIS,Label='LID')
          iD = iDBMat(iSym,iCase)
          Call dDaFile(LUSBT,2,LBD,nAS,iD)
          Call dDaFile(LUSBT,2,LID,nIS,iD)
          !! this scaling is needed, so GA_DGEMM cannot be used
          Call CASPT2_ResD(2,nIN,nIS,lg_V1,lg_V2,LBD,LID)
          call mma_deallocate(LBD)
          call mma_deallocate(LID)
!         Call GA_Access(lg_V1,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)
!         Call GA_Access(lg_V2,iLoV2,iHiV2,jLoV2,jHiV2,mV2,LDV2)
!         Call CLag_MPP_NT(Half,DBL_MB(mV1),NROW1,DBL_MB(mV2),NROW2,
!    *                     lg_WRK,NIN,NCOL1)
!         Call CLag_MPP_NT(Half,DBL_MB(mV2),NROW2,DBL_MB(mV1),NROW1,
!    *                     lg_WRK,NIN,NCOL2)
!         Call GA_Release(lg_V1,iLoV1,iHiV1,jLoV1,jHiV1)
!         Call GA_Release(lg_V2,iLoV2,iHiV2,jLoV2,jHiV2)
          CALL GA_DGEMM ('N','T',NIN,NIN,NIS,
     &                   Half,lg_V1,lg_V2,One,lg_WRK)
          CALL GA_DGEMM ('N','T',NIN,NIN,NIS,
     &                   Half,lg_V2,lg_V1,One,lg_WRK)
!       end if
        Call RHS_FREE(lg_V2)

        !! Restore the original T
        Call RHS_READ_SR(lg_V1,iCase,iSym,iVecX)
        CALL GA_Scale (lg_WRK,-One)
        CALL GA_SYNC()
      end if

      Call RHS_FREE(lg_V1)
!
!     B derivative in NIN completed
!
      CALL GA_CREATE_STRIPED ('H',NAS,NIN,'WRK2',lg_WRK2)
      !! Use the same stripe as PSBMAT_GEMEM?
      CALL GA_CREATE_STRIPED ('H',NAS,NAS,'BDER',lg_BDER)

      !! NIN -> NAS transformation of B derivative
      !! Need 4 GAs; is it possible to reduce?
      !! lg_WRK is used later, so probably not
      CALL GA_DGEMM ('N','N',NAS,NIN,NIN,
     &               One,lg_T,lg_WRK,Zero,lg_WRK2)
      CALL GA_DGEMM ('N','T',NAS,NAS,NIN,
     &               One,lg_WRK2,lg_T,Zero,lg_BDER)
!     if (king()) then
!       call mma_allocate(VEC1,NAS*NAS,Label='WRK1')
!       CALL GA_GET(lg_bder,1,NAS,1,NAS,VEC1,NAS)
!       WRITE (*,*) 'B DERIVATIVE IN NAS'
!       CALL SQPRT(VEC1,NAS)
!       call mma_deallocate(VEC1)
!     end if

      !! cannot destroy lg_WRK; it is used for overlap derivative
      bStat = GA_destroy(lg_WRK2)

      !! At present, lg_T, lg_WRK, and lg_BDER are in GA.
      !! It is possible to destroy lg_T here and can reduce the max
      !! allocated GA by one, but we anyway have to restore the whole
      !! transformation matrix in memory in the master node, so we can
      !! probably assume that there is no problem in the availability
      !! of memory.

      !! It seems that it is not good to decompose the B derivative
      !! matrix to G and F derivative contributions here, because some
      !! contributions are computed as overlap derivatives, so it is
      !! best to decompose later simultaneously. Fortunately, the max
      !! number of allocated GAs remains unchanged (4 at most).

      !! at this point, lg_T, lg_WRK, and lg_BDER are distributed
!     if (king()) then
!       call mma_allocate(VEC1,NAS*NAS,Label='WRK1')
!       CALL GA_GET(lg_wrk,1,NIN,1,NIN,VEC1,NIN)
!       WRITE (*,*) 'B DERIVATIVE IN NIN'
!       CALL SQPRT(VEC1,NIN)
!       call mma_deallocate(VEC1)
!     end if
!
!     mode = 0 operations for S derivative
!
      !! Scale with the eigenvalue
      CALL GA_Distribution (lg_WRK,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
      NROW=iHiV1-iLoV1+1
      NCOL=jHiV1-jLoV1+1
      if (NROW > 0 .and. NCOL > 0) then
        call mma_allocate(EIG,NIN,Label='EIG')
        idB  = idBMAT(iSym,iCase)
        CALL DDAFILE(LUSBT,2,EIG,NIN,IDB)
        CALL GA_Access(lg_WRK,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)

        do j = 1, NCOL
          jICB = j + jLoV1 - 1
          EigJ = EIG(jICB)
          do i = 1, NROW
            iICB = i + iLoV1 - 1
            EigI = EIG(iICB)
            DBL_MB(mV1+i-1+NROW*(j-1))
     &        = -DBL_MB(mV1+i-1+NROW*(j-1))*(EigI+EigJ)*Half
          end do
        end do

        CALL GA_Release_Update(lg_WRK,iLoV1,iHiV1,jLoV1,jHiV1)
        call mma_deallocate(EIG)
      end if
!     if (king()) then
!       call mma_allocate(VEC1,NIN*NIN,Label='VEC1'))
!       CALL GA_GET(lg_wrk,1,NIN,1,NIN,VEC1,NIN)
!       WRITE (*,*) 'SCALED B DERIVATIVE IN NIN'
!       CALL SQPRT(VEC1,NIN)
!       call mma_deallocate(VEC1)
!     end if

      !! Max memory allocation of 5 GAs
      !  1) Implicit overlap derivative of the 2<1|H|0> part
      !! lg_V1 = T (solution; not quasi-variational)
      Call RHS_ALLO(nIN,nIS,lg_V1)
      Call RHS_READ_SR(lg_V1,iCase,iSym,iVecX)
      !! lg_V2 = RHS2 (in IC basis)
      Call RHS_ALLO(nIN,nIS,lg_V2)
      if (ifmscoup) then
        Call RHS_READ_SR(lg_V2,iCase,iSym,iVecL)
      else
        Call RHS_READ_SR(lg_V2,iCase,iSym,iRHS)
      end if
      call GA_DGEMM ('N','T',NIN,NIN,NIS,
     &              -One,lg_V2,lg_V1,One,lg_WRK)
      Call RHS_FREE(lg_V1)
      Call RHS_FREE(lg_V2)

      If ((real_shift /= Zero) .OR. (imag_shift /= Zero)
     &    .OR. (sigma_p_epsilon /= Zero) .OR. IFMSCOUP) Then
        !! WRK1 = -RHS*(T+lambda/2)
        !! lg_V1 = RHS (in IC basis)
        Call RHS_ALLO(nIN,nIS,lg_V1)
        Call RHS_READ_SR(lg_V1,iCase,iSym,iRHS)
        !! lg_V2 = lambda (shift correction)
        Call RHS_ALLO(nIN,nIS,lg_V2)
        Call RHS_READ_SR(lg_V2,iCase,iSym,iVecR)
        call GA_DGEMM ('N','T',NIN,NIN,NIS,
     &                -Half,lg_V1,lg_V2,One,lg_WRK)
        Call RHS_FREE(lg_V1)
        Call RHS_FREE(lg_V2)
      end if
!
!     S derivative in NIN completed (some NAS operations remain)
!
      CALL GA_CREATE_STRIPED ('H',NAS,NIN,'WRK2',lg_WRK2)
      !! Use the same stripe as PSBMAT_GEMEM?
      CALL GA_CREATE_STRIPED ('H',NAS,NAS,'SDER',lg_SDER)

      !! NIN -> NAS transformation of S derivative
      CALL GA_DGEMM ('N','N',NAS,NIN,NIN,
     &               One,lg_T,lg_WRK,Zero,lg_WRK2)
      CALL GA_DGEMM ('N','T',NAS,NAS,NIN,
     &               One,lg_WRK2,lg_T,Zero,lg_SDER)
!     if (king()) then
!       call mma_allocate(VEC1,NAS*NAS,Label='VEC1')
!       CALL GA_GET(lg_sder,1,NAS,1,NAS,VEC1,NAS)
!       WRITE (*,*) 'S DERIVATIVE IN NAS (1)'
!       CALL SQPRT(VEC1,NAS)
!       call mma_deallocate(VEC1)
!     end if

      bStat = GA_destroy(lg_WRK)
      bStat = GA_destroy(lg_WRK2)

      !! Add some trivial contributions due to the dependence
      !! on the linearly independent space
      If (do_lindep .AND. nAS /= nIN) Then
        Call LinDepLag_MPP(lg_BDER,lg_SDER,nAS,nIN,iSym,iCase)
      End If

      !  2) Explicit overlap derivative of the 2<1|H|0> part
      !     Again, not for imaginary shift-specific terms
      !! E = 2<1|H|0> + <1|H0-E0|1>
      !! lg_V1 = VEC1 = T (solution; not quasi-variational)
      Call RHS_ALLO(nIN,nIS,lg_V1)
      Call RHS_READ_SR(lg_V1,iCase,iSym,iVecX)
      Call RHS_SCAL(nIN,nIS,lg_V1,SCAL)
      If ((real_shift /= Zero) .OR. (imag_shift /= Zero)
     &    .OR. (sigma_p_epsilon /= Zero) .OR. IFMSCOUP) Then
        !! lg_V2 = VEC2 = lambda (shift correction)
        Call RHS_ALLO(nIN,nIS,lg_V2)
        CALL RHS_READ_SR(lg_V2,iCase,iSym,iVecR)
        CALL RHS_DAXPY(NIN,NIS,Half,lg_V2,lg_V1)
        CALL RHS_FREE(lg_V2)
      end if

      CALL GA_CREATE_STRIPED ('V',NAS,NIS,'WRK',lg_WRK)
      CALL GA_DGEMM ('N','N',NAS,NIS,NIN,
     &               One,lg_T,lg_V1,Zero,lg_WRK)

      Call RHS_FREE(lg_V1)
      bStat = GA_destroy(lg_T)
      !! lg_V1 = VEC4 = RHS (in MO basis)
      Call RHS_ALLO(nAS,nIS,lg_V1)
      Call RHS_READ_C (lg_V1,iCase,iSym,iVecW)

      CALL GA_DGEMM ('N','T',NAS,NAS,NIS,
     &               Two,lg_WRK,lg_V1,One,lg_SDER)

      Call RHS_FREE(lg_V1)
      bStat = GA_destroy(lg_WRK)
      CALL GA_SYNC()

      !! Add the contributions from the off-diagonal coupling
      !! (i.e., CASPT2-N). Of course, this is not for imaginary shift-
      !! specific terms.
      if (MAXIT /= 0) then
        call mma_allocate(WRK,NAS,NAS,Label='WRK')
        idSD = idSDMat(iSym,iCase)
        CALL DDAFILE(LuSTD,2,WRK,nAS*nAS,idSD)
        CALL GA_Distribution(lg_SDER,myRank,ILO,IHI,JLO,JHI)
        Call GA_Access(lg_SDER,ILO,IHI,JLO,JHI,mSDER,LDV)
        NROW = IHI-ILO+1
        NCOL = JHI-JLO+1
        DO J = 1, NCOL
          DO I = 1, NROW
            DBL_MB(mSDER+I-1+NROW*(J-1))
     &        = DBL_MB(mSDER+I-1+NROW*(J-1))
     &        + WRK(I+ILO-1,J+JLO-1)*Half
!    *        + WORK(LWRK+I+ILO-2+NAS*(J+JLO-2))*Half
          END DO
        END DO
        Call GA_Release_Update(lg_SDER,ILO,IHI,JLO,JHI)
        call mma_deallocate(WRK)
      end if
      CALL GA_SYNC()
!     if (king()) then
!       call mma_allocate(VEC1,NAS*NAS,Label='VEC1')
!       CALL GA_GET(lg_sder,1,NAS,1,NAS,VEC1,NAS)
!       WRITE (*,*) 'S DERIVATIVE IN NAS'
!       CALL SQPRT(VEC1,NAS)
!       call mma_deallocate(VEC1)
!     end if

      !! Compute G and F derivative contributions for B and S der
      CALL PSBMAT_GETMEM('S',lg_S,NAS)
      CALL PSBMAT_READ('S',iCase,iSym,lg_S,NAS)
      CALL GA_Distribution(lg_BDER,myRank,ILO,IHI,JLO,JHI)
      CALL GA_Distribution(lg_SDER,myRank,ILO,IHI,JLO,JHI)
      CALL GA_Distribution(lg_S   ,myRank,ILO,IHI,JLO,JHI)
      Call GA_Access(lg_BDER,ILO,IHI,JLO,JHI,mBDER,LDV)
      Call GA_Access(lg_SDER,ILO,IHI,JLO,JHI,mSDER,LDV)
      Call GA_Access(lg_S   ,ILO,IHI,JLO,JHI,mS   ,LDV)
      NROW = iHi-iLo+1 + 1 !! 1 is added so that the work space is used
      NCOL = jHi-jLo+1 + 1 !! for all procs
      call mma_allocate(WRK,NROW,NCOL,Label='WRK')
      if (iCase == 1) then
        Call CLagDXA_DP(iSym,nAS,DBL_MB(mBDER),DBL_MB(mSDER),
     &                  DG1,DG2,DF1,DF2,DEPSA,DEASUM,
     &                  ILO,IHI,JLO,JHI,LDV,G1,G2,DBL_MB(mS),WRK,
     &                  lg_S)
      else if (iCase == 4) then
        Call CLagDXC_DP(iSym,nAS,DBL_MB(mBDER),DBL_MB(mSDER),
     &                  DG1,DG2,DF1,DF2,DEPSA,DEASUM,
     &                  ILO,IHI,JLO,JHI,LDV,G1,G2,DBL_MB(mS),WRK,
     &                  lg_S)
      else
        write (u6,*) 'Invalid iCase in ...'
        call abend()
      end if
      call mma_deallocate(WRK)
      Call GA_Release_Update(lg_BDER,ILO,IHI,JLO,JHI)
      Call GA_Release_Update(lg_SDER,ILO,IHI,JLO,JHI)

      call ga_sync()

      CALL mma_allocate(idxG3,6,NG3,label='idxG3')
      iLUID=0
      CALL I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)

      if (iCase == 1) then
        Call CLagDXA_FG3_MPP(iSym,lg_BDER,lg_SDER,
     &                  DG1,DG2,DG3,DF1,DF2,DF3,DEPSA,G2,idxG3)
      else if (iCase == 4) then
        Call CLagDXC_FG3_MPP(iSym,lg_BDER,lg_SDER,
     &                  DG1,DG2,DG3,DF1,DF2,DF3,DEPSA,G2,idxG3)

        !! DF3 is done after icase=4
        !! construct G3 matrix in lg_S
!       CALL MKSC_G3_MPP(ISYM,DBL_MB(mS),ILO,IHI,JLO,JHI,LDV,
!    &                   NG3,G3,IDXG3)
!       Call GA_Release_Update(lg_S,ILO,IHI,JLO,JHI)
!       call DF3_DEPSA_MPP(DF3,DEPSA,lg_S,idxG3)
      else
        write (u6,*) 'Invalid iCase in ...'
        call abend()
      end if
      Call GA_Release(lg_S   ,ILO,IHI,JLO,JHI)
      CALL mma_deallocate(idxG3)
      CALL PSBMAT_FREEMEM(lg_S)

      bStat = GA_destroy(lg_BDER)
      bStat = GA_destroy(lg_SDER)

      End Subroutine CLagDX_MPP
#endif

      End Subroutine CLagD
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDX(Mode,iSym,iCase,VEC1,VEC2,VEC3,VEC4,nIN,nIS,nAS,
     &                  VECROT,VEC5,lg_V2,BDERmat,SDERmat)

      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_global, only:real_shift, imag_shift,
     &                        sigma_p_epsilon
      use caspt2_global, only:do_lindep,LUSTD,idSDMat
      use caspt2_global, only: LUSBT
      use EQSOLV, only: IVECR, IDBMAT, IDTMAT
      use definitions, only: wp, iwp
      use caspt2_module, only: IFMSCOUP, MAXIT, JSTATE
      use Constants, only: Zero, One, Half, Two
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
#endif

      implicit none

      integer(kind=iwp), intent(in) :: mode, iSym, iCase, nIN, nIS, nAS,
     &                                 lg_V2
      real(kind=wp), intent(in) :: VEC1(*), VEC3(*), VEC4(*), VEC5(*),
     &                             VECROT(*)
      real(kind=wp), intent(inout) :: VEC2(*), BDERmat(*), SDERmat(*)

      real(kind=wp),allocatable :: WRK1(:),WRK2(:),WRK3(:),TRANS(:),
     &                             EIG(:)

      integer(kind=iwp) :: idT, idB, iICB, jICB, idSD
      real(kind=wp) :: SCAL, EigI, EigJ

      call mma_allocate(WRK1,nAS**2,Label='WRK1')
      call mma_allocate(WRK2,MAX(nAS**2,nAS*nIS),Label='WRK2')
      call mma_allocate(WRK3,nAS**2,Label='WRK3')
      call mma_allocate(TRANS,nAS*nIN,Label='TRANS')
      call mma_allocate(EIG,nIN,Label='EIG')

      idT  = idTMAT(iSym,iCase)
      Call DDAFILE(LUSBT,2,TRANS,nAS*nIN,idT)
      idB  = idBMAT(iSym,iCase)
      Call DDAFILE(LUSBT,2,EIG,nIN,idB)

      SCAL = One
      IF (IFMSCOUP) SCAL = VECROT(jState)

      !! VEC1: solution in IC basis
      !! VEC2: lambda   in IC basis
      !! VEC3: RHS      in IC basis
      !! VEC4: RHS      in MO basis

      !! Form the density in internally contracted basis
      !! The G subspace is employed in the following comments
      !! as an example.
      !! i  : inactive
      !! a,b: secondary
      !! t,u: active
      !! o,p: internally contracted configuration (basis)
      !! WRK1(o,p) = \sum_{iab} T_{o,i}^{ab}*T_{p,i}^{ab}
      !! WRK1 is the effective density in the IC basis,
      !! and will be the B derivative contribution.

      If (Mode == 0) Then
        !! WRK1 = T*T
        Call DGEMM_('N','T',nIN,nIN,nIS,
     &              SCAL,VEC1,nIN,VEC1,nIN,
     &              Zero,WRK1,nIN)
      Else
        WRK1(1:nIN*nIN) = Zero
      End If

      If (real_shift /= Zero .OR. imag_shift /= Zero
     &    .OR. sigma_p_epsilon /= Zero .OR. IFMSCOUP) Then
        !! WRK1 = T*T + (T*lambda+lambda*T)/2
        !! For sigma-p CASPT2, this if branch computes the pseudo-
        !! density that comes from the numerator of the shift.
        Call DGEMM_('N','T',nIN,nIN,nIS,
     &              Half,VEC2,nIN,VEC1,nIN,
     &              One,WRK1,nIN)
        Call DGEMM_('N','T',nIN,nIN,nIS,
     &              Half,VEC1,nIN,VEC2,nIN,
     &              One,WRK1,nIN)
      End If
      if (sigma_p_epsilon /= Zero .and. mode == 0) then
        !! the remaining is the derivative of 2<1|H|0>, so the unscaled
        !! lambda is loaded
#ifdef _MOLCAS_MPP_
        IF (Is_Real_Par()) THEN
          IF (KING()) THEN
            CALL GA_GET(lg_V2,1,NIN,1,NIS,VEC2,NIN)
          End IF
        ELSE
#endif
          CALL RHS_READ_SR(lg_V2,ICASE,ISYM,iVecR)
#ifdef _MOLCAS_MPP_
        end if
#endif
      end if

      !! Transform the internally contracted density to
      !! active MO basis
      !! WRK3(t,u) = ST(t,o)*WRK1(o,p)*ST(u,p)
      !! WRK3 is the derivative contribution of the B matrix
      !! in the MO basis
      Call DGEMM_('N','N',nAS,nIN,nIN,
     &            One,TRANS,nAS,WRK1,nIN,
     &            Zero,WRK2,nAS)
      Call DGEMM_('N','T',nAS,nAS,nIN,
     &            One,WRK2,nAS,TRANS,nAS,
     &            Zero,WRK3,nAS)
!     write(u6,*) 'B derivative in MO'
!     call sqprt(WRK3,nas)

      !! Implicit derivative of the IC vector. This derivative
      !! comes from the derivative of the eigenvalue only. Other
      !! contributions of the derivative of the IC vector is considered
      !! later.
      !! -(e_o + e_p)*dS/da
      Do iICB = 1, nIN
        EigI = EIG(iICB)
        Do jICB = 1, nIN
          EigJ = EIG(jICB)
          WRK1(iICB+nIN*(jICB-1))
     &      = -WRK1(iICB+nIN*(jICB-1))*(EigI+EigJ)*Half
        End Do
      End Do

      !! Derivative of the overlap in the IC basis.
      !! WRK1(o,p) = WRK1(o,p) - T_{o,i}^{ab}*RHS(p,i,a,b)
      !! This contribution should not be done for the imaginary
      !! shift-specific term
      !  1) Implicit overlap derivative of the 2<1|H|0> part
      If (Mode == 0) Then
        !! WRK1 = -RHS*T
        Call DGEMM_('N','T',nIN,nIN,nIS,
     &             -One,VEC5,nIN,VEC1,nIN,
     &              One,WRK1,nIN)
        If (real_shift /= Zero .OR. imag_shift /= Zero
     &      .OR. sigma_p_epsilon /= Zero .OR. IFMSCOUP) Then
          !! WRK1 = -RHS*(T+lambda/2)
          Call DGEMM_('N','T',nIN,nIN,nIS,
     &               -Half,VEC3,nIN,VEC2,nIN,
     &                One,WRK1,nIN)
        End If
      End If

      !! Convert the IC basis to the MO basis
      Call DGEMM_('N','N',nAS,nIN,nIN,
     &            One,TRANS,nAS,WRK1,nIN,
     &            Zero,WRK2,nAS)
      Call DGEMM_('N','T',nAS,nAS,nIN,
     &            One,WRK2,nAS,TRANS,nAS,
     &            Zero,WRK1,nAS)

      !! Add some trivial contributions due to the dependence
      !! on the linearly independent space
      If (do_lindep .AND. nAS /= nIN) Then
        Call LinDepLag(WRK3,WRK1,nAS,nIN,iSym,iCase)
      End If

      !  2) Explicit overlap derivative of the 2<1|H|0> part
      !     Again, not for imaginary shift-specific terms
      If (Mode == 0) Then
        !! E = 2<1|H|0> + <1|H0-E0|1>
        Call DGEMM_('N','N',nAS,nIS,nIN,
     &              SCAL,TRANS,nAS,VEC1,nIN,
     &              Zero,WRK2,nAS)
        If (real_shift /= Zero .OR. imag_shift /= Zero
     &      .OR. sigma_p_epsilon /= Zero .OR. IFMSCOUP) Then
          Call DGEMM_('N','N',nAS,nIS,nIN,
     &                Half,TRANS,nAS,VEC2,nIN,
     &                One,WRK2,nAS)
        END IF
        Call DGEMM_('N','T',nAS,nAS,nIS,
     &              Two,WRK2,nAS,VEC4,nAS,
     &              One,WRK1,nAS)
      End If

      !! Add the contributions from the off-diagonal coupling
      !! (i.e., CASPT2-N). Of course, this is not for imaginary shift-
      !! specific terms.
      If (MAXIT /= 0 .and. Mode == 0) Then
        idSD = idSDMat(iSym,iCase)
        CALL DDAFILE(LuSTD,2,WRK2,nAS*nAS,idSD)
        !! T*(T+lambda) + (T+lambda)*T is saved, so 1/2
        WRK1(1:NAS**2) = WRK1(1:NAS**2) + Half*WRK2(1:NAS**2)
      End If

      if (mode == 0) then
        BDERmat(1:NAS**2) = BDERmat(1:NAS**2) + WRK3(1:NAS**2)
        SDERmat(1:NAS**2) = SDERmat(1:NAS**2) + WRK1(1:NAS**2)
      else
        BDERmat(1:NAS**2) = BDERmat(1:NAS**2) - WRK3(1:NAS**2)
        SDERmat(1:NAS**2) = SDERmat(1:NAS**2) - WRK1(1:NAS**2)
      end if
      !! Now, convert the above contributions to derivatives of RDM,
      !! weighted Fock, etc.
      !! WRK3 is the derivative of B in the MO basis
      !! WRK1 is the derivative of S in the MO basis
      !! See and be consistent with mkbmat.f and mksmat.f
      !! Notice that F2 and G2 in mkbmat.f and mksmat.f are halved
      !! (see getdpref.f).
      !! they are moved to CLagDXA, ... CLagDXG

      call mma_deallocate(WRK1)
      call mma_deallocate(WRK2)
      call mma_deallocate(WRK3)
      call mma_deallocate(TRANS)
      call mma_deallocate(EIG)

      Return

      End Subroutine CLagDX
!
!-----------------------------------------------------------------------
!
      !! From poly3
      SUBROUTINE CnstCLag(IFF,CLag,DG1,DG2,DG3,DF1,DF2,DF3,DEPSA,
     &                    G1,G2,G3,nLev)

      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_global, only: iPrGlb
      use PrintLevel, only: VERBOSE
      use gugx, only: L2ACT
      use caspt2_global, only: LUCIEX, IDTCEX, LUSOLV
      use definitions, only: wp, iwp, byte, u6
      use caspt2_module, only: STSYM, NCONF, NSTATE, MSTATE, JSTATE,
     &                         ISCF, EPSA
      use Constants, only: One
      use pt2_guga, only: ETA, CITHR, NG2, NG3, NG3TOT

      implicit none

      integer(kind=iwp), intent(in) :: IFF, nLev
      real(kind=wp), intent(in) :: G1(*), G2(*), G3(*)
      real(kind=wp), intent(inout) :: CLag(nConf), DG1(*), DG2(*),
     &  DG3(*), DF1(*), DF2(*), DF3(*), DEPSA(*)

      integer(kind=iwp) :: ILEV, NG3MAX, ILUID, IDCI, J
      integer(kind=iwp), external :: iPARDIV
      integer(kind=byte), allocatable :: idxG3(:,:)
      real(kind=wp), allocatable :: CI1(:)

      real(kind=wp) :: CPUT, WALLT, CPE, CPTF0, CPTF10, TIOE, TIOTF0,
     &                 TIOTF10

      IF (IFF == 1) THEN
! ORBITAL ENERGIES IN CI-COUPLING ORDER:
        DO ILEV=1,NLEV
          ETA(ILEV)=EPSA(L2ACT(ILEV))
        END DO
      END IF

!-SVC20100831: recompute approximate max NG3 size needed
      NG3MAX=iPARDIV(NG3TOT,NG2)

!-SVC20100831: allocate local G3 matrices
      CALL mma_allocate(idxG3,6,NG3,label='idxG3')
      iLUID=0
      CALL I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)
* NG3 will change inside subroutine MKFG3 to the actual
* number of nonzero elements, that is why here we allocate
* with NG3MAX, but we only store (PT2_PUT) the first NG3
* elements of the G3 and F3
      IF (ISCF == 0) NG3=NG3MAX

      call mma_allocate(CI1,NCONF,LABEL='CI')
      If (ISCF == 0) Then
        if (iff == 1) then
          IDCI=IDTCEX
          DO J=1,JSTATE-1
            CALL DDAFILE(LUCIEX,0,CI1,NCONF,IDCI)
          END DO
          CALL DDAFILE(LUCIEX,2,CI1,NCONF,IDCI)
        else
!         Call LoadCI_XMS('C',1,CI1,JSTATE,U0)
        end if
        IF (IPRGLB >= VERBOSE) THEN
          WRITE(u6,*)
          IF (NSTATE > 1) THEN
            WRITE(u6,'(A,I4)')
     &      ' With new orbitals, the CI array of state ',MSTATE(JSTATE)
          ELSE
            WRITE(u6,*)' With new orbitals, the CI array is:'
          END IF
          CALL PRWF_CP2(STSYM,NCONF,CI1,CITHR)
        END IF
      Else
        CI1(1) = One
      End If

      CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
      If (ISCF == 0) Then
        CALL DERFG3(CI1,CLAG,DG1,DG2,DG3,DF1,DF2,DF3,
     &              DEPSA,G1,G2,nLev)
      Else
        CALL DERSPE(DF1,DF2,DF3,idxG3,DEPSA,G1,G2,G3)
      End If
      CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
      IF (IPRGLB >= VERBOSE) THEN
        CPUT =CPTF10-CPTF0
        WALLT=TIOTF10-TIOTF0
        write(u6,*)
        write(u6,'(a,2f10.2)')' DERFG3  : CPU/WALL TIME=', cput,wallt
      END IF

      call mma_deallocate(CI1)
      call mma_deallocate(idxG3)

      Return

      End Subroutine CnstCLag
!
!-----------------------------------------------------------------------
!
      !! From poly3
      SUBROUTINE CLagEig(if_SSDMloc,force_equal,CLag,RDMEIG,nLev)

      use caspt2_global, only: DREF, DWGT
      use caspt2_global, only: OMGDER, Weight
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: IFSADREF, IFDW, NCONF, NASHT, ISCF,
     &                         NSTATE, JSTATE, ZETA
      use Constants, only: Zero, One, Half

      implicit none

      logical(kind=iwp), intent(in) :: if_SSDMloc, force_equal
      real(kind=wp), intent(inout) :: CLag(nConf,nState)
      real(kind=wp), intent(in) :: RDMEIG(*)
      integer(kind=iwp), intent(in) :: nLev

      real(kind=wp),allocatable :: CI1(:),WRK(:)

      integer(kind=iwp) :: iState
      real(kind=wp) :: WGT, Scal
      real(kind=wp), external :: DDOT_
!
!     MODE=0: Either state-averaged or DWGT matrix
!     MODE=1: XMS-specific term, always state-averaged DM
!
      !! RDMEIG
      call mma_allocate(CI1,nConf,Label='LCI')
      call mma_allocate(WRK,MAX(NLEV,NASHT)**2,Label='WRK')

      Do iState = 1, nState
        If (.not.if_SSDMloc) Then
          if (force_equal .or. .not.IFSADREF) then
            WGT = One/nState ! force equal-weight for XMS
          else if (IFSADREF) then
            WGT = Weight(iState) ! can be unequal weight
          else
            WGT = One/nState ! this should not happen...
          end if
          if (abs(wgt) <= 1.0e-09_wp) cycle
          If (ISCF == 0) Then
            Call LoadCI(CI1,iState)
          Else
            CI1(1) = One
          End If
          WRK(1:NLEV**2) = RDMEIG(1:NLEV**2)*WGT
          Call Poly1_CLag(CI1,CLag(1,iState),WRK,nLev)
        Else
          Wgt = DWgt(iState,jState)
          If (abs(wgt) > 1.0e-09_wp) Then
            If (ISCF == 0) Then
              Call LoadCI(CI1,iState)
            Else
              CI1(1) = One
            End If
            WRK(1:NLEV**2) = RDMEIG(1:NLEV**2)*WGT
            Call Poly1_CLag(CI1,CLag(1,iState),WRK,nLev)
          End If

          !! Derivative of omega for dynamically weighted density
          If (IFDW .and. zeta >= Zero) Then
            If (ISCF == 0) Then
              Call LoadCI(CI1,iState)
            Else
              CI1(1) = One
            End If
            call POLY1(CI1,nConf)
            call GETDREF(DREF,SIZE(DREF))
            Call SQUARE(DREF,WRK,1,nAshT,nAshT)
            !! probably it is doubled somewhere, so should half
            Scal = DDOT_(nAshT**2,RDMEIG,1,WRK,1)*Half
!           write (*,*) 'scal = ', scal
            OMGDER(iState,jState) = OMGDER(iState,jState) + Scal
          End If

        End If
      End Do

      call mma_deallocate(WRK)
!     write(u6,*) 'clag before projection'
!     do istate = 1, nstate
!       write(u6,*) 'state = ', istate
!       do i = 1, nconf
!         write(u6,'(i3,f20.10)') i,clag(i,istate)
!       end do
!     end do
!     write(u6,*) 'debug'
!     IF(ORBIN == 'TRANSFOR') Call CLagX_TrfCI(CLAG)
!     if (proj) then
!     ovl = ddot_(nconf*nstate,ci1,1,clag,1)
!     write(u6,*) 'projection coeff = ',ovl
!     call daxpy_(nconf*nstate,-ovl,ci1,1,clag,1)
!     write(u6,*) 'clag after projection'
!     do istate = 1, nstate
!       write(u6,*) 'state = ', istate
!       do i = 1, nconf
!         write(u6,'(i3,f20.10)') i,clag(i,istate)
!       end do
!     end do
!     end if
!
      call mma_deallocate(CI1)

      Return

      End Subroutine CLagEig
!
!-----------------------------------------------------------------------
!
      Subroutine CLagFinal(CLag,SLag)

      use caspt2_global, only: iPrGlb
      use PrintLevel, only: VERBOSE
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: REFENE, NCONF, ISCF, NSTATE
      use Constants, only: One

      implicit none

      real(kind=wp), intent(inout) :: CLag(nConf,nState), SLag(*)
      real(kind=wp),allocatable :: CI1(:), CI2(:)

      integer(kind=iwp) :: ijst, ilStat, jlStat
      real(kind=wp) :: Scal, Ovl
      real(kind=wp), external :: DDOT_

      call mma_allocate(CI1,nConf,Label='CI1')
      call mma_allocate(CI2,nConf,Label='CI2')

      !! Construct SLag
      ijst = 0
      do ilStat = 1, nState
        If (ISCF == 0) Then
          Call LoadCI(CI1,ilStat)
        Else
          CI1(1) = One
        End If
        Do jlStat = 1, ilStat !! -1
          ijst = ilStat + nState*(jlStat-1)
          If (ilStat == jlStat) Cycle
          If (ISCF == 0) Then
            Call LoadCI(CI2,jlStat)
          Else
            CI2(1) = One
          End If
          Scal = DDOT_(nConf,CI1,1,CLag(1,jlStat),1)
     &         - DDOT_(nConf,CI2,1,CLag(1,ilStat),1)
          Scal = Scal/(REFENE(jlStat)-REFENE(ilStat))
          SLag(ijst) = SLag(ijst) + Scal
          IF (IPRGLB >= VERBOSE) THEN
            write(u6,*)
            write(u6,'(1x,"SLag for State ",i1,"-",i1," = ",f20.10)')
     &         ilstat,jlstat,slag(ijst)
            write(u6,*)
          END IF
        end do
      end do

      !! This projection is required to get convergence in MCLR.
      !! also the linear equation for non-invariant CASPT2
      Do ilStat = 1, nState
        CI1(1:nConf) = CLag(1:nConf,ilStat)
!       do i = 1, nconf
!         write(u6,'(i3,f20.10)') i,clag(i,ilstat)
!       end do
        Do jlStat = 1, nState
          If (ISCF == 0) Then
            Call LoadCI(CI2,jlStat)
          Else
            CI2(1) = One
          End If
          Ovl = DDot_(nConf,CI1,1,CI2,1)
!         write(u6,*) 'projection coeff = ',ovl
          CLag(1:nConf,ilStat) = CLag(1:nConf,ilStat) - Ovl*CI2(1:nConf)
        End Do
!       write(u6,*) 'clag after projection'
!       write(u6,*) 'state = ', ilstat
!       do i = 1, nconf
!         write(u6,'(i3,f20.10)') i,clag(i,ilstat)
!       end do
      End Do

      call mma_deallocate(CI1)
      call mma_deallocate(CI2)

      Return

      End Subroutine CLagFinal
!
!-----------------------------------------------------------------------
!
      SUBROUTINE POLY1_CLag(CI,CLag,RDMEIG,nLev)
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: nConf
      use pt2_guga, only: MxCI, iAdr10, cLab10
      IMPLICIT NONE
* PER-AAKE MALMQUIST, 92-12-07
* THIS PROGRAM CALCULATES THE 1-EL DENSITY
* MATRIX FOR A CASSCF WAVE FUNCTION.
      real(kind=wp), intent(in) :: CI(NCONF), RDMEIG(*)
      real(kind=wp), intent(inout) :: CLag(NCONF)
      integer(kind=iwp), intent(in) :: nLev

      real(kind=wp), allocatable :: SGM1(:)
      integer(kind=iwp) :: I

      IF(NLEV > 0) THEN
        CALL MMA_ALLOCATE(SGM1,MXCI,LABEL='SGM1')
        CALL DENS1_RPT2_CLag(CI,SGM1,CLag,RDMEIG,nLev)
      END IF
!     return !! for test purpose

* REINITIALIZE USE OF DMAT.
* The fields IADR10 and CLAB10 are kept in pt2_guga.F90
* CLAB10 replaces older field called LABEL.
      DO I=1,64
        IADR10(I,1)=-1
        IADR10(I,2)=0
        CLAB10(I)='   EMPTY'
      END DO
      IADR10(1,1)=0
* HENCEFORTH, THE CALL PUT(NSIZE,LABEL,ARRAY) WILL ENTER AN
* ARRAY ON LUDMAT AND UPDATE THE TOC.
      IF(NLEV > 0) THEN
        CALL MMA_DEALLOCATE(SGM1)
      END IF

      return

      end subroutine POLY1_CLag
!
!-----------------------------------------------------------------------
!
      SUBROUTINE DENS1_RPT2_CLag (CI,SGM1,CLag,RDMEIG,nLev)
      use Symmetry_Info, only: Mul
      use gugx, only: SGS, L2ACT, CIS
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: nConf, STSym
#if defined (_MOLCAS_MPP_) && ! defined (_GA_)
      USE Para_Info, ONLY: Is_Real_Par, King, nProcs
#endif
      use pt2_guga, only: MxCI

      IMPLICIT NONE

      integer(kind=iwp), intent(in) :: nLev
      real(kind=wp), intent(in) :: CI(MXCI), RDMEIG(NLEV,NLEV)
      real(kind=wp), intent(inout) :: SGM1(MXCI), CLag(nConf)

      logical(kind=iwp), external :: RSV_TSK
      integer(kind=iwp), allocatable :: TASK(:,:)

      integer(kind=iwp) :: ID, IST, ISU, ISTU, IT, IU, LT, LU, ITASK,
     &                     NTASKS, ISSG, NSGM

* Purpose: Compute the 1-electron density matrix array G1.


* For the general cases, we use actual CI routine calls, and
* have to take account of orbital order.
* We will use level inices LT,LU... in these calls, but produce
* the density matrices with usual active orbital indices.
* Translation tables L2ACT and LEVEL, in pt2_guga.F90

* SVC20100311: set up a task table with LT,LU
* SB20190319: maybe it doesn't even make sense to parallelize the 1-RDM
      nTasks = nLev**2
      CALL mma_allocate (Task,nTasks,2,Label='TASK')

      iTask=0
      ! First, IL < JL pairs.
      Do LT = 1, nLev-1
        Do LU = LT+1, nLev
          iTask = iTask + 1
          TASK(iTask,1)=LT
          TASK(iTask,2)=LU
        End Do
      End Do
      ! Then, IL = JL pairs.
      Do LT = 1, nLev
        iTask = iTask + 1
        TASK(iTask,1)=LT
        TASK(iTask,2)=LT
      End Do
      ! Last, IL > JL pairs.
      Do LT = 2, nLev
        Do LU = 1, LT-1
          iTask = iTask + 1
          TASK(iTask,1)=LT
          TASK(iTask,2)=LU
        End Do
      End Do
      IF (iTask /= nTasks) WRITE(u6,*) 'ERROR nTasks'

      Call Init_Tsk(ID, nTasks)

* SVC20100311: BEGIN SEPARATE TASK EXECUTION
      do while (Rsv_Tsk(ID,iTask))

* Compute SGM1 = E_UT acting on CI, with T.ge.U,
* i.e., lowering operations. These are allowed in RAS.
        LT=TASK(iTask,1)
        IST=SGS%ISM(LT)
        IT=L2ACT(LT)
        LU=Task(iTask,2)
        ISU=SGS%ISM(LU)
        IU=L2ACT(LU)
        ISTU=Mul(IST,ISU)
        ISSG=Mul(ISTU,STSYM)
        NSGM=CIS%NCSF(ISSG)
        IF(NSGM == 0) cycle
* GETSGM2 computes E_UT acting on CI and saves it on SGM1
        CALL GETSGM2(LU,LT,STSYM,CI,SGM1)
        IF(ISTU == 1) THEN
          ! Symmetry not yet
!          write(u6,*) 'it,iu = ', it,iu
           CLag(1:NSGM) = CLag(1:NSGM) + RDMEIG(IT,IU)*SGM1(1:NSGM)
        END IF

* SVC: The master node now continues to only handle task scheduling,
*     needed to achieve better load balancing. So it exits from the task
*      list. It has to do it here since each process gets at least one
*      task.
#if defined (_MOLCAS_MPP_) && ! defined (_GA_)
        IF (IS_REAL_PAR() .AND. KING() .AND. NPROCS > 1) exit
#endif
      end do

      CALL Free_Tsk(ID)
      CALL mma_deallocate(Task)

      return
      end subroutine DENS1_RPT2_CLag
!
!-----------------------------------------------------------------------
!
      !! Taken from grdctl.f
      SUBROUTINE CLagX_TrfCI(CI)

      use caspt2_global, only: TAT, TORB
      use caspt2_module, only: NSYM, STSYM, NCONF, NISH, NAES, NRAS1,
     &                         NRAS2, NRAS3, NSSH
      use Constants, only: Zero
      use definitions, only: wp, iwp

      implicit none

      real(kind=wp), intent(inout) :: CI(*)

      integer(kind=iwp) :: IOFF1, IOFF2, ISYM, NI, NR1, NR2, NR3, NS,
     &                     I, J, IJ, JI, ITOEND, NSG, ITOSTA, ITO,
     &                     ISTART

      TAT(:) = Zero

      IOFF1 = 0
      IOFF2 = 0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NR1=NRAS1(ISYM)
        NR2=NRAS2(ISYM)
        NR3=NRAS3(ISYM)
        NS=NSSH(ISYM)
* Skip inactive transformation matrix:
        IOFF1=IOFF1+NI**2
* Copy RAS1 transformation matrix transposed to TAT:
        DO I=1,NR1
          DO J=1,NR1
            IJ=I+NR1*(J-1)
            JI=J+NR1*(I-1)
            TAT(IOFF2+JI)=TORB(IOFF1+IJ)
          END DO
        END DO
        IOFF1=IOFF1+NR1**2
        IOFF2=IOFF2+NR1**2
* Copy RAS2 transformation matrix transposed to TAT:
        DO I=1,NR2
          DO J=1,NR2
            IJ=I+NR2*(J-1)
            JI=J+NR2*(I-1)
            TAT(IOFF2+JI)=TORB(IOFF1+IJ)
          END DO
        END DO
        IOFF1=IOFF1+NR2**2
        IOFF2=IOFF2+NR2**2
* Copy RAS2 transformation matrix transposed to TAT:
        DO I=1,NR3
          DO J=1,NR3
            IJ=I+NR3*(J-1)
            JI=J+NR3*(I-1)
            TAT(IOFF2+JI)=TORB(IOFF1+IJ)
          END DO
        END DO
        IOFF1=IOFF1+NR3**2
        IOFF2=IOFF2+NR3**2
* Skip virtual transformation matrix:
        IOFF1=IOFF1+NS**2
      END DO
! Transform SGM to use original MO:
      ITOEND=0
      NSG=NCONF
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NR1=NRAS1(ISYM)
        NR2=NRAS2(ISYM)
        NR3=NRAS3(ISYM)
        NS=NSSH(ISYM)
        ITOSTA=ITOEND+1
        ITOEND=ITOEND+NR1**2+NR2**2+NR3**2
*        ITO=ITOSTA+NI**2
        ITO=ITOSTA
        IF(NR1 > 0) THEN
          ISTART=NAES(ISYM)+1
          CALL TRACI_RPT2(ISTART,NR1,TAT(ITO),STSYM,
     &                                         NSG,CI)
        END IF
        ITO=ITO+NR1**2
        IF(NR2 > 0) THEN
          ISTART=NAES(ISYM)+NR1+1
          CALL TRACI_RPT2(ISTART,NR2,TAT(ITO),STSYM,
     &                                         NSG,CI)
        END IF
        ITO=ITO+NR2**2
        IF(NR3 > 0) THEN
          ISTART=NAES(ISYM)+NR1+NR2+1
         !! NR1 should be NR3?
          CALL TRACI_RPT2(ISTART,NR3,TAT(ITO),STSYM,
     &                                         NSG,CI)
        END IF
      END DO

      RETURN

      END SUBROUTINE CLagX_TrfCI
!
!-----------------------------------------------------------------------
!
      Subroutine CLagSym(nAshT,DG1,DG2,DF1,DF2,mode)

      use Constants, only: Half, Quart
      use definitions, only: wp, iwp

      implicit none

      integer(kind=iwp), intent(in) :: nAshT, mode
      real(kind=wp), intent(inout) :: DG1(nAshT,nAshT),
     &  DG2(nAshT,nAshT,nAshT,nAshT), DF1(nAshT,nAshT),
     &  DF2(nAshT,nAshT,nAshT,nAshT)

      integer(kind=iwp) :: iI, iJ, iK, iL
      real(kind=wp) :: Val1, Val2, Val3, Val4, Val

!     return
!     if (mode == 0) then
      Do iI = 1, nAshT
        Do iJ = 1, iI-1
          Val1 = DG1(iI,iJ)
          Val2 = DG1(iJ,iI)
          DG1(iI,iJ) = (Val1+Val2)*Half
          DG1(iJ,iI) = (Val1+Val2)*Half
          Val1 = DF1(iI,iJ)
          Val2 = DF1(iJ,iI)
          DF1(iI,iJ) = (Val1+Val2)*Half
          DF1(iJ,iI) = (Val1+Val2)*Half
        End Do
      End Do
!     end if

      If (mode == 0) Then
        !! Follow G2 symmetry
        Do iI = 1, nAshT
        Do iJ = 1, nAshT
        Do iK = 1, nAshT
        Do iL = 1, nAshT
          Val1 = DG2(iI,iJ,iK,iL)
          Val2 = DG2(iJ,iI,iL,iK)
          Val3 = DG2(iK,iL,iI,iJ)
          Val4 = DG2(iL,iK,iJ,iI)
          Val  = (Val1+Val2+Val3+Val4)*Quart
          DG2(iI,iJ,iK,iL) = Val
          DG2(iJ,iI,iL,iK) = Val
          DG2(iK,iL,iI,iJ) = Val
          DG2(iL,iK,iJ,iI) = Val
          Val1 = DF2(iI,iJ,iK,iL)
          Val2 = DF2(iJ,iI,iL,iK)
          Val3 = DF2(iK,iL,iI,iJ)
          Val4 = DF2(iL,iK,iJ,iI)
          Val  = (Val1+Val2+Val3+Val4)*Quart
          DF2(iI,iJ,iK,iL) = Val
          DF2(iJ,iI,iL,iK) = Val
          DF2(iK,iL,iI,iJ) = Val
          DF2(iL,iK,iJ,iI) = Val
        End Do
        End Do
        End Do
        End Do
      Else If (mode == 1) Then
        !! Follow EtuEyz symmetry
        Do iI = 1, nAshT
        Do iJ = 1, nAshT
        Do iK = 1, nAshT
        Do iL = 1, nAshT
          Val1 = DG2(iI,iJ,iK,iL)
          Val2 = DG2(iL,iK,iJ,iI)
          Val  = (Val1+Val2)*Quart
        ! DG2(iI,iJ,iK,iL) = Val
        ! DG2(iL,iK,iJ,iI) = Val
!         if (ii /= il.and.ij /= ik) then
!         DG2(iI,iJ,iK,iL) = Two*val
!         DG2(iL,iK,iJ,iI) = Zero
!         end if
          Val1 = DF2(iI,iJ,iK,iL)
          Val2 = DF2(iL,iK,iJ,iI)
          Val  = (Val1+Val2)*Quart
        ! DF2(iI,iJ,iK,iL) = Val
        ! DF2(iL,iK,iJ,iI) = Val
!         if (ii /= il.and.ij /= ik) then
!         DF2(iI,iJ,iK,iL) = Two*val
!         DF2(iL,iK,iJ,iI) = Zero
!         end if
        End Do
        End Do
        End Do
        End Do
      end if

      Return

      End Subroutine CLagSym
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXA_FG3(iSym,nAS,NG3,BDER,SDER,
     &                       DF1,DF2,DF3,DG1,DG2,DG3,DEPSA,
     &                       G2,SC,idxG3)

      use Symmetry_Info, only: Mul
      USE SUPERINDEX, only: KTUV
      use caspt2_module, only: NASHT, IASYM, EPSA, NTUVES
      use Constants, only: Zero
      use definitions, only: wp, iwp, byte

      implicit none

      integer(kind=iwp), intent(in) :: iSym, nAS, NG3
      real(kind=wp), intent(in) :: BDER(nAS,nAS), SDER(nAS,nAS),
     &  G2(nAshT,nAshT,nAshT,nAshT), SC(*)
      real(kind=wp), intent(inout) :: DF1(nAshT,nAshT),
     &  DF2(nAshT,nAshT,nAshT,nAshT), DF3(*), DG1(nAshT,nAshT),
     &  DG2(nAshT,nAshT,nAshT,nAshT), DG3(*), DEPSA(nAshT,nAshT)
      integer(kind=byte), intent(in) :: idxG3(6,NG3)

      integer(kind=iwp) :: iG3, iT, iU, iV, iX, iY, iZ, iST, iSU, iSV,
     &                     iSX, iSY, iSZ, ituvs, ixyzs, iTU, iVX, iYZ,
     &                     jSYM, ISUP, JSUP, iW, NSEQ
      real(kind=wp) :: F3VAL, G3VAL

      DO iG3=1,NG3
        iT=idxG3(1,iG3)
        iU=idxG3(2,iG3)
        iV=idxG3(3,iG3)
        iX=idxG3(4,iG3)
        iY=idxG3(5,iG3)
        iZ=idxG3(6,iG3)
        iST=IASYM(iT)
        iSU=IASYM(iU)
        iSV=IASYM(iV)
        iSX=IASYM(iX)
        iSY=IASYM(iY)
        iSZ=IASYM(iZ)
        ituvs=Mul(IST,Mul(ISU,ISV))
        ixyzs=Mul(ISX,Mul(ISY,ISZ))
        F3VAL=Zero
        G3VAL=Zero
        if(ituvs /= ixyzs) cycle
        iTU=iT+NASHT*(iU-1)
        iVX=iV+NASHT*(iX-1)
        iYZ=iY+NASHT*(iZ-1)
!-SVC20100829: 12 equivalent cases, of which the second
!  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
!  - G(tuvxyz) -> SA(xut,vyz)
        jSYM=Mul(IASYM(iX),Mul(IASYM(iU),IASYM(iT)))
        IF (jSYM == iSYM) THEN
          ISUP=KTUV(iX,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iV,iY,iZ)-nTUVES(jSYM)
          F3VAL = F3VAL + BDER(iSup,jSup)
          G3VAL = G3VAL + SDER(iSup,jSup)
        ENDIF
        if (iTU /= iVX .or. iVX /= iYZ) then
          if (iTU /= iVX .and. iTU /= iYZ .and. iVX /= iYZ) then
!  - G(vxtuyz) -> SA(uxv,tyz)
            jSYM=Mul(IASYM(iU),Mul(IASYM(iX),IASYM(iV)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iU,iX,iV)-nTUVES(jSYM)
              JSUP=KTUV(iT,iY,iZ)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
!  - G(yzvxtu) -> SA(xzy,vtu)
            jSYM=Mul(IASYM(iX),Mul(IASYM(iZ),IASYM(iY)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iX,iZ,iY)-nTUVES(jSYM)
              JSUP=KTUV(iV,iT,iU)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
!  - G(tuyzvx) -> SA(zut,yvx)
            jSYM=Mul(IASYM(iZ),Mul(IASYM(iU),IASYM(iT)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iZ,iU,iT)-nTUVES(jSYM)
              JSUP=KTUV(iY,iV,iX)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
          end if
!  - G(yztuvx) -> SA(uzy,tvx)
          jSYM=Mul(IASYM(iU),Mul(IASYM(iZ),IASYM(iY)))
          IF (jSYM == iSYM) THEN
            ISUP=KTUV(iU,iZ,iY)-nTUVES(jSYM)
            JSUP=KTUV(iT,iV,iX)-nTUVES(jSYM)
            F3VAL = F3VAL + BDER(iSup,jSup)
            G3VAL = G3VAL + SDER(iSup,jSup)
          ENDIF
!  - G(vxyztu) -> SA(zxv,ytu)
          jSYM=Mul(IASYM(iZ),Mul(IASYM(iX),IASYM(iV)))
          IF (jSYM == iSYM) THEN
            ISUP=KTUV(iZ,iX,iV)-nTUVES(jSYM)
            JSUP=KTUV(iY,iT,iU)-nTUVES(jSYM)
            F3VAL = F3VAL + BDER(iSup,jSup)
            G3VAL = G3VAL + SDER(iSup,jSup)
          ENDIF
        end if

        if ((iT /= iU .or. iV /= iX .or. iY /= iZ) .and.
     &      (iT /= iU .or. iV /= iZ .or. iX /= iY) .and.
     &      (iX /= iV .or. iT /= iZ .or. iU /= iY) .and.
     &      (iZ /= iY .or. iV /= iU .or. iX /= iT)) then
!  - G(utxvzy) -> SA(vtu,xzy)
          jSYM=Mul(IASYM(iV),Mul(IASYM(iT),IASYM(iU)))
          IF (jSYM == iSYM) THEN
            ISUP=KTUV(iV,iT,iU)-nTUVES(jSYM)
            JSUP=KTUV(iX,iZ,iY)-nTUVES(jSYM)
            F3VAL = F3VAL + BDER(iSup,jSup)
            G3VAL = G3VAL + SDER(iSup,jSup)
          ENDIF
          if (iTU /= iVX .or. iVX /= iYZ) then
            if (iTU /= iVX .and. iTU /= iYZ .and. iVX /= iYZ) then
!  - G(xvutzy) -> SA(tvx,uzy)
              jSYM=Mul(IASYM(iT),Mul(IASYM(iV),IASYM(iX)))
              IF (jSYM == iSYM) THEN
                ISUP=KTUV(iT,iV,iX)-nTUVES(jSYM)
                JSUP=KTUV(iU,iZ,iY)-nTUVES(jSYM)
                F3VAL = F3VAL + BDER(iSup,jSup)
                G3VAL = G3VAL + SDER(iSup,jSup)
              ENDIF
!  - G(zyxvut) -> SA(vyz,xut)
              jSYM=Mul(IASYM(iV),Mul(IASYM(iY),IASYM(iZ)))
              IF (jSYM == iSYM) THEN
                ISUP=KTUV(iV,iY,iZ)-nTUVES(jSYM)
                JSUP=KTUV(iX,iU,iT)-nTUVES(jSYM)
                F3VAL = F3VAL + BDER(iSup,jSup)
                G3VAL = G3VAL + SDER(iSup,jSup)
              ENDIF
!  - G(utzyxv) -> SA(ytu,zxv)
              jSYM=Mul(IASYM(iY),Mul(IASYM(iT),IASYM(iU)))
              IF (jSYM == iSYM) THEN
                ISUP=KTUV(iY,iT,iU)-nTUVES(jSYM)
                JSUP=KTUV(iZ,iX,iV)-nTUVES(jSYM)
                F3VAL = F3VAL + BDER(iSup,jSup)
                G3VAL = G3VAL + SDER(iSup,jSup)
              ENDIF
            end if
!  - G(zyutxv) -> SA(tyz,uxv)
            jSYM=Mul(IASYM(iT),Mul(IASYM(iY),IASYM(iZ)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iT,iY,iZ)-nTUVES(jSYM)
              JSUP=KTUV(iU,iX,iV)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
!  - G(xvzyut) -> SA(yvx,zut)
            jSYM=Mul(IASYM(iY),Mul(IASYM(iV),IASYM(iX)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iY,iV,iX)-nTUVES(jSYM)
              JSUP=KTUV(iZ,iU,iT)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
          end if
        end if

        F3VAL = -F3VAL
        G3VAL = -G3VAL

        !! last line of F3 transformation in mkfg3.f
        G3VAL = G3VAL - (EPSA(iU)+EPSA(iY))*F3VAL
        Do iW = 1, nAshT
          ISUP=KTUV(iV,iW,iT)-nTUVES(iSYM)
          JSUP=KTUV(iX,iY,iZ)-nTUVES(iSYM)
          NSEQ=MAX(iSup,jSup)*(MAX(iSup,jSup)-1)/2 + MIN(iSup,jSup)
          DEPSA(iW,iU) = DEPSA(iW,iU) - F3VAL*SC(NSEQ)

          ISUP=KTUV(iV,iU,iT)-nTUVES(iSYM)
          JSUP=KTUV(iX,iW,iZ)-nTUVES(iSYM)
          NSEQ=MAX(iSup,jSup)*(MAX(iSup,jSup)-1)/2 + MIN(iSup,jSup)
          DEPSA(iW,iY) = DEPSA(iW,iY) - F3VAL*SC(NSEQ)
        End Do

        !! derivative of <0|EtuEwv,xwEyz|0>*fww
        DF3(iG3) = DF3(iG3) + F3VAL
        !! derivative of <0|EtuEvxEyz|0>
        DG3(iG3) = DG3(iG3) + G3VAL

        !! remaining F3 and G3 transformation in mkfg3.f
        if (iY == iX) then
          DF2(iT,iU,iV,iZ) = DF2(iT,iU,iV,iZ) - F3VAL
          DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ) - EPSA(iU)*F3VAL
          Do iW = 1, nAshT
            DEPSA(iU,iW) = DEPSA(iU,iW) - F3VAL*G2(iT,iW,iV,iZ)
          End Do
          DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ) - G3VAL
        end if
        if (iV == iU) then
          DF2(iT,iX,iY,iZ) = DF2(iT,iX,iY,iZ) - F3VAL
          DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ) - EPSA(iY)*F3VAL
          Do iW = 1, nAshT
            DEPSA(iW,iY) = DEPSA(iW,iY) - F3VAL*G2(iT,iX,iW,iZ)
          End Do
          DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ) - G3VAL
        end if
        if (iY == iU) then
          DF2(iV,iX,iT,iZ) = DF2(iV,iX,iT,iZ) - F3VAL
          DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ) - EPSA(iU)*F3VAL
          DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ) - G3VAL
        end if
        DEPSA(iY,iU) = DEPSA(iY,iU) - F3VAL*G2(iV,iX,iT,iZ)
        if (iY == iX .and. iV == iU) then
          DF1(iT,iZ) = DF1(iT,iZ) - F3VAL
          DG1(iT,iZ) = DG1(iT,iZ) - G3VAL
        end if
      END DO

      Return

      End Subroutine CLagDXA_FG3
!
!-----------------------------------------------------------------------
!
#ifdef _MOLCAS_MPP_
      SUBROUTINE CLagDXA_FG3_MPP(ISYM,lg_BDER,lg_SDER,DG1,DG2,DG3,
     &                           DF1,DF2,DF3,DEPSA,G2,idxG3)

      use Symmetry_Info, only: Mul
      USE SUPERINDEX, only: KTUV
      use definitions, only: iwp,RtoB,wp,byte
      use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
      USE Para_Info, ONLY: Is_Real_Par, nProcs
      use caspt2_module, only: NASHT, IASYM, EPSA, NTUVES
      use pt2_guga, only: NG3
      use Constants, only: Zero

      implicit none

#include "global.fh"
#include "mafdecls.fh"

      integer(kind=iwp), intent(in) :: ISYM, lg_BDER, lg_SDER
      real(kind=wp), intent(inout) :: DG1(NASHT,NASHT),
     &  DG2(NASHT,NASHT,NASHT,NASHT), DG3(*), DF1(NASHT,NASHT),
     &  DF2(NASHT,NASHT,NASHT,NASHT), DF3(*), DEPSA(NASHT,NASHT)
      real(kind=wp), intent(in) :: G2(NASHT,NASHT,NASHT,NASHT)
      integer(kind=byte), intent(in) :: idxG3(6,NG3)

      integer(kind=iwp), ALLOCATABLE :: INDI(:), INDJ(:), NELBsav(:),
     &                                  NELSsav(:)
      real(kind=wp),  ALLOCATABLE :: BUFFB(:), BUFFS(:)

      integer(kind=iwp) :: NG3MAX, MAXMEM, iscal, MAXBUF, NG3B, NBUF,
     &                     NBLOCKS, IBLOCK, IG3STA, IG3END, NtotELB,
     &                     NtotELS, iG3, NELB, NELS, iT, iU, iV, iX,
     &                     iY, iZ, iST, iSU, iSV, iSX, iSY, iSZ, ituvs,
     &                     ixyzs, iTU, iVX, iYZ, jSym, IROW, ICOL, i, IW
      real(kind=wp) :: G3VAL, F3VAL

      ! Since we are stuck with collective calls to MPI_Alltoallv in
      ! order to gather the elements, each process needs to loop over
      ! the same number of blocks.
      NG3MAX=NG3
      CALL GAIGOP_SCAL(NG3MAX,'max')
      IF (NG3MAX == 0) RETURN

      ! The global SC matrix has already been allocated, so we need to
      ! find out how much memory is left for buffering (4 equally sized
      ! buffers for sending and receiving values and indices)
      CALL mma_MaxDBLE(MAXMEM)
      ! we need two real and two integer values per element
      iscal = (iwp*2 + wp*2)/RtoB
      !MAXBUF=MIN(NINT(0.95D0*MAXMEM)/4,2000000000/8)
      MAXBUF=MIN(NINT(0.95_wp*MAXMEM,kind=iwp)/iscal,2000000000/8)
      MAXBUF=MAXBUF-2*NG3 !! for NELBsav and NELSsav

      ! Loop over blocks NG3B of NG3, so that 12*NG3B < MAXBUF/NPROCS.
      ! This guarantees that e.g. if all processes send all their data
      ! to one other, that process receives NPROCS*NG3B*12 elements
      ! in the receive buffer.
      NG3B=MAXBUF/(NPROCS*16) !! originally 12, but not sure why
      NG3B=MIN(NG3B,NG3MAX)
      CALL GAIGOP_SCAL(NG3B,'min')
      NBUF=16*NG3B

      call mma_allocate(BUFFB,NBUF,Label='BUFFB')
      call mma_allocate(BUFFS,NBUF,Label='BUFFS')
      call mma_allocate(INDI,NBUF,Label='INDI')
      call mma_allocate(INDJ,NBUF,Label='INDJ')

      NBLOCKS=(NG3MAX-1)/NG3B+1
      DO IBLOCK=1,NBLOCKS
        IG3STA=1+(IBLOCK-1)*NG3B
        IG3END=MIN(IG3STA+NG3B-1,NG3)
        call mma_allocate(NELBsav,IG3END-IG3STA+1,Label='NELBsav')
        call mma_allocate(NELSsav,IG3END-IG3STA+1,Label='NELSsav')

        ! Second pass fills the buffers with values and indices
        NtotELB = 0 ! Number of total elements of BDER
        NtotELS = 0 ! Number of total elements of SDER
        DO iG3=IG3STA,IG3END
          NELB = 0 ! Number of elements of BDER for iG3
          NELS = 0 ! Number of elements of SDER for iG3
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=Mul(IST,Mul(ISU,ISV))
          ixyzs=Mul(ISX,Mul(ISY,ISZ))
          if(ituvs == ixyzs) then
            iTU=iT+NASHT*(iU-1)
            iVX=iV+NASHT*(iX-1)
            iYZ=iY+NASHT*(iZ-1)
           !F3VAL=F3(iG3)
!-SVC20100829: 12 equivalent cases, of which the second
!  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
!  - G(tuvxyz) -> SA(xut,vyz)
            jSYM=Mul(IASYM(iX),Mul(IASYM(iU),IASYM(iT)))
            IF (jSYM == iSYM) THEN
              IROW=KTUV(iX,iU,iT)-nTUVES(jSYM)
              ICOL=KTUV(iV,iY,iZ)-nTUVES(jSYM)
              NELB = NELB + 1
              NtotELB = NtotELB + 1
              INDI(NtotELB) = IROW
              INDJ(NtotELB) = ICOL
            ENDIF
            if (iTU /= iVX .or. iVX /= iYZ) then
              if (iTU /= iVX .and. iTU /= iYZ .and. iVX /= iYZ) then
!  - G(vxtuyz) -> SA(uxv,tyz)
                jSYM=Mul(IASYM(iU),Mul(IASYM(iX),IASYM(iV)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iU,iX,iV)-nTUVES(jSYM)
                  ICOL=KTUV(iT,iY,iZ)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
!  - G(yzvxtu) -> SA(xzy,vtu)
                jSYM=Mul(IASYM(iX),Mul(IASYM(iZ),IASYM(iY)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iX,iZ,iY)-nTUVES(jSYM)
                  ICOL=KTUV(iV,iT,iU)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
!  - G(tuyzvx) -> SA(zut,yvx)
                jSYM=Mul(IASYM(iZ),Mul(IASYM(iU),IASYM(iT)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iZ,iU,iT)-nTUVES(jSYM)
                  ICOL=KTUV(iY,iV,iX)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
              end if
!  - G(yztuvx) -> SA(uzy,tvx)
              jSYM=Mul(IASYM(iU),Mul(IASYM(iZ),IASYM(iY)))
              IF (jSYM == iSYM) THEN
                IROW=KTUV(iU,iZ,iY)-nTUVES(jSYM)
                ICOL=KTUV(iT,iV,iX)-nTUVES(jSYM)
                NELB = NELB + 1
                NtotELB = NtotELB + 1
                INDI(NtotELB) = IROW
                INDJ(NtotELB) = ICOL
              ENDIF
!  - G(vxyztu) -> SA(zxv,ytu)
              jSYM=Mul(IASYM(iZ),Mul(IASYM(iX),IASYM(iV)))
              IF (jSYM == iSYM) THEN
                IROW=KTUV(iZ,iX,iV)-nTUVES(jSYM)
                ICOL=KTUV(iY,iT,iU)-nTUVES(jSYM)
                NELB = NELB + 1
                NtotELB = NtotELB + 1
                INDI(NtotELB) = IROW
                INDJ(NtotELB) = ICOL
              ENDIF
            end if
            if ((iT /= iU .or. iV /= iX .or. iY /= iZ) .and.
     &          (iT /= iU .or. iV /= iZ .or. iX /= iY) .and.
     &          (iX /= iV .or. iT /= iZ .or. iU /= iY) .and.
     &          (iZ /= iY .or. iV /= iU .or. iX /= iT)) then
!  - G(utxvzy) -> SA(vtu,xzy)
              jSYM=Mul(IASYM(iV),Mul(IASYM(iT),IASYM(iU)))
              IF (jSYM == iSYM) THEN
                IROW=KTUV(iV,iT,iU)-nTUVES(jSYM)
                ICOL=KTUV(iX,iZ,iY)-nTUVES(jSYM)
                NELB  = NELB + 1
                NtotELB = NtotELB + 1
                INDI(NtotELB) = IROW
                INDJ(NtotELB) = ICOL
              ENDIF
              if (iTU /= iVX .or. iVX /= iYZ) then
                if (iTU /= iVX .and. iTU /= iYZ .and. iVX /= iYZ) then
!  - G(xvutzy) -> SA(tvx,uzy)
                  jSYM=Mul(IASYM(iT),Mul(IASYM(iV),IASYM(iX)))
                  IF (jSYM == iSYM) THEN
                    IROW=KTUV(iT,iV,iX)-nTUVES(jSYM)
                    ICOL=KTUV(iU,iZ,iY)-nTUVES(jSYM)
                    NELB = NELB + 1
                    NtotELB = NtotELB + 1
                    INDI(NtotELB) = IROW
                    INDJ(NtotELB) = ICOL
                  ENDIF
!  - G(zyxvut) -> SA(vyz,xut)
                  jSYM=Mul(IASYM(iV),Mul(IASYM(iY),IASYM(iZ)))
                  IF (jSYM == iSYM) THEN
                    IROW=KTUV(iV,iY,iZ)-nTUVES(jSYM)
                    ICOL=KTUV(iX,iU,iT)-nTUVES(jSYM)
                    NELB = NELB + 1
                    NtotELB = NtotELB + 1
                    INDI(NtotELB) = IROW
                    INDJ(NtotELB) = ICOL
                  ENDIF
!  - G(utzyxv) -> SA(ytu,zxv)
                  jSYM=Mul(IASYM(iY),Mul(IASYM(iT),IASYM(iU)))
                  IF (jSYM == iSYM) THEN
                    IROW=KTUV(iY,iT,iU)-nTUVES(jSYM)
                    ICOL=KTUV(iZ,iX,iV)-nTUVES(jSYM)
                    NELB = NELB + 1
                    NtotELB = NtotELB + 1
                    INDI(NtotELB) = IROW
                    INDJ(NtotELB) = ICOL
                  ENDIF
                end if
!  - G(zyutxv) -> SA(tyz,uxv)
                jSYM=Mul(IASYM(iT),Mul(IASYM(iY),IASYM(iZ)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iT,iY,iZ)-nTUVES(jSYM)
                  ICOL=KTUV(iU,iX,iV)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
!  - G(xvzyut) -> SA(yvx,zut)
                jSYM=Mul(IASYM(iY),Mul(IASYM(iV),IASYM(iX)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iY,iV,iX)-nTUVES(jSYM)
                  ICOL=KTUV(iZ,iU,iT)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
              end if
            end if
          end if
          nels = nelb
          NELBsav(iG3-IG3STA+1) = NELB
          NELSsav(iG3-IG3STA+1) = NELS
        END DO
        ntotels = ntotelb

        CALL GA_GATHER(lg_BDER,BUFFB,INDI,INDJ,NtotELB)
        CALL GA_GATHER(lg_SDER,BUFFS,INDI,INDJ,NtotELS)

        ! Finally, fill the local chunk of the SC matrix (block of rows)
        ! with the received values at their appropriate place.
        NtotELB = 0
        NtotELS = 0
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          NELB = NELBsav(iG3-IG3STA+1)
          NELS = NELSsav(iG3-IG3STA+1)

          F3VAL = Zero
          DO i = 1, NELB
            NtotELB = NtotELB + 1
            F3VAL = F3VAL - BUFFB(NtotELB)
          END DO

          G3VAL = Zero
          DO i = 1, NELS
            NtotELS = NtotELS + 1
            G3VAL = G3VAL - BUFFS(NtotELS)
          END DO
          G3VAL = G3VAL - (EPSA(iU)+EPSA(iY))*F3VAL

          DF3(iG3) = DF3(iG3) + F3VAL
          DG3(iG3) = DG3(iG3) + G3VAL

          !! DEPSA is done in DF3_DEPSA_MPP

          !! remaining F3 and G3 transformation in mkfg3.f
          If (iY == iX) Then
            DF2(iT,iU,iV,iZ) = DF2(iT,iU,iV,iZ) - F3VAL
            DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ) - EPSA(iU)*F3VAL
            Do iW = 1, nAshT
              DEPSA(iU,iW) = DEPSA(iU,iW) - F3VAL*G2(iT,iW,iV,iZ)
            End Do
            DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ) - G3VAL
          End If
          If (iV == iU) Then
            DF2(iT,iX,iY,iZ) = DF2(iT,iX,iY,iZ) - F3VAL
            DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ) - EPSA(iY)*F3VAL
            Do iW = 1, nAshT
              DEPSA(iW,iY) = DEPSA(iW,iY) - F3VAL*G2(iT,iX,iW,iZ)
            End Do
            DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ) - G3VAL
          End If
          If (iY == iU) Then
            DF2(iV,iX,iT,iZ) = DF2(iV,iX,iT,iZ) - F3VAL
            DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ) - EPSA(iU)*F3VAL
            DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ) - G3VAL
          End If
          DEPSA(iY,iU) = DEPSA(iY,iU) - F3VAL*G2(iV,iX,iT,iZ)
          If (iY == iX .and. iV == iU) Then
            DF1(iT,iZ) = DF1(iT,iZ) - F3VAL
            DG1(iT,iZ) = DG1(iT,iZ) - G3VAL
          End If
        END DO

        call mma_deallocate(NELBsav)
        call mma_deallocate(NELSsav)
      END DO ! end loop over blocks of G3 values

      call mma_deallocate(BUFFB)
      call mma_deallocate(BUFFS)
      call mma_deallocate(INDI)
      call mma_deallocate(INDJ)

      RETURN

      End Subroutine CLagDXA_FG3_MPP
#endif
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXA_DP(iSym,nAS,BDER,SDER,DG1,DG2,DF1,DF2,
     &                      DEPSA,DEASUM,iLo,iHi,jLo,jHi,LDA,
     &                      G1,G2,SA,SA2,lg_S)

      USE SUPERINDEX, only: MTUV
      use caspt2_global, only:ipea_shift
      use caspt2_module, only: NASHT, EASUM, EPSA, NTUVES
      use Constants, only: Zero, Half, Two
      use definitions, only: wp, iwp
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, nProcs
#endif

      implicit none

#ifdef _MOLCAS_MPP_
#include "global.fh"
#else
#include "macros.fh"
#endif

      integer(kind=iwp), intent(in) :: iSym, nAS, iLo, iHi, jLo, jHi,
     &                                 LDA, lg_S
      real(kind=wp), intent(in) :: BDER(*), SA(*), SA2(*)
      real(kind=wp), intent(inout) :: SDER(*),
     &  DG1(nAshT,nAshT), DG2(nAshT,nAshT,nAshT,nAshT),
     &  DF1(nAshT,nAshT), DF2(nAshT,nAshT,nAshT,nAshT),
     &  DEPSA(nAshT,nAshT), DEASUM, G1(nAshT,nAshT),
     &  G2(nAshT,nAshT,nAshT,nAshT)

      integer(kind=iwp) :: ISADR, NROW, iLoS, jLoS, IXYZ, IXYZABS,
     &  IXABS, IYABS, IZABS, ITUV, ITUVABS, ITABS, IUABS, IVABS,
     &  ISADR2, iWabs, iTWV, iXWZ, iWYZ, iWUV
      real(kind=wp) :: ET, EU, ETU, EX, EY, FACT, ValB, bsBDER,
     &  ValS
#ifdef _MOLCAS_MPP_
      integer(kind=iwp) :: irank, iHiS, jHiS
#endif
!
!     LDA == 0, if not parallel; SA is triangular
!     LDA /= 0, if parallel    ; SA is square
!     In both cases, BDER and SDER are square
!
      ISADR=0
      NROW = 0
      iLoS = 0
      jLoS = 0
#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
        irank = 0
        CALL GA_Distribution (lg_S,iRank,iLoS,iHiS,jLoS,jHiS)
        NROW = jHiS-jLoS+1 !! = NAS
        CALL GA_GET(lg_S,jLoS,jHiS,iLoS,iHiS,SA2,NROW)
      end if
#else
      unused_var(lg_S)
#endif
      DO IXYZ=jLo,jHi
        IXYZABS=IXYZ+NTUVES(ISYM)
        IXABS=MTUV(1,IXYZABS)
        IYABS=MTUV(2,IXYZABS)
        IZABS=MTUV(3,IXYZABS)
        EX=EPSA(IXABS)
        EY=EPSA(IYABS)
        DO ITUV=iLo,iHi
          ITUVABS=ITUV+NTUVES(ISYM)
          ITABS=MTUV(1,ITUVABS)
          IUABS=MTUV(2,ITUVABS)
          IVABS=MTUV(3,ITUVABS)
          ET=EPSA(ITABS)
          EU=EPSA(IUABS)
          ETU=ET+EU
          FACT=EY+EU+EX+ET-EASUM
          IF (LDA == 0) THEN
            ISADR=1+iTUV-iLo+NAS*(iXYZ-jLo)
          ELSE
            ISADR=1+iTUV-iLo+LDA*(iXYZ-jLo)
          END IF
          ValB=BDER(ISADR)

          If (iTUV == iXYZ .and. ipea_shift /= Zero) Then
!           !! BA in the next equation refers to the active overlap
!       ipea_shift*Half*BA(ISADR)*(Two-DREF(IDV)+DREF(IDT)+DREF(IDU))
            bsBDER = ipea_shift*Half*ValB
            SDER(iSAdr) = SDER(iSAdr) + bsBDER*(Two
     &        +G1(iTabs,iTabs)+G1(iUabs,iUabs)-G1(iVabs,iVabs))
            IF (LDA == 0) THEN
              iSAdr2 = iTUV*(iTUV+1)/2
            ELSE
              ISADR2 = 1+iTUV-iLo+LDA*(iTUV-jLo)
            END IF
            DG1(iTabs,iTabs) = DG1(iTabs,iTabs) + bsBDER*SA(iSAdr2)
            DG1(iUabs,iUabs) = DG1(iUabs,iUabs) + bsBDER*SA(iSAdr2)
            DG1(iVabs,iVabs) = DG1(iVabs,iVabs) - bsBDER*SA(iSAdr2)
          End If

          !! First VALUE contribution in MKBC_DP (FACT)
          SDER(ISADR) = SDER(ISADR) + FACT*ValB
          ValS=SDER(ISADR)

          if (lda == 0) then
            Do iWabs = 1, nAshT
              !! EU derivative
              iTWV = iTabs+nAshT*(iWabs-1)+nAshT**2*(iVabs-1)
              iSAdr2 = Max(iTWV,iXYZ)*(Max(iTWV,iXYZ)-1)/2
     &               + Min(iTWV,iXYZ)
              DEPSA(iWabs,iUabs) = DEPSA(iWabs,iUabs)
     &          + ValB*SA(iSAdr2)

              !! EY derivative
              iXWZ = iXabs+nAshT*(iWabs-1)+nAshT**2*(iZabs-1)
              iSAdr2 = Max(iTUV,iXWZ)*(Max(iTUV,iXWZ)-1)/2
     &               + Min(iTUV,iXWZ)
              DEPSA(iWabs,iYabs) = DEPSA(iWabs,iYabs)
     &          + ValB*SA(iSAdr2)

              !! EX derivative
              iWYZ = iWabs+nAshT*(iYabs-1)+nAshT**2*(iZabs-1)
              iSAdr2 = Max(iTUV,iWYZ)*(Max(iTUV,iWYZ)-1)/2
     &               + Min(iTUV,iWYZ)
              DEPSA(iWabs,iXabs) = DEPSA(iWabs,iXabs)
     &          + ValB*SA(iSAdr2)

              !! ET derivative
              iWUV = iWabs+nAshT*(iUabs-1)+nAshT**2*(iVabs-1)
              iSAdr2 = Max(iWUV,iXYZ)*(Max(iWUV,iXYZ)-1)/2
     &               + Min(iWUV,iXYZ)
              DEPSA(iWabs,iTabs) = DEPSA(iWabs,iTabs)
     &          + ValB*SA(iSAdr2)
            End Do
          else
            Do iWabs = 1, nAshT
              !! EU derivative
              iTWV = iTabs+nAshT*(iWabs-1)+nAshT**2*(iVabs-1)
              ISADR2 = 1+iTWV-jLoS+NROW*(iXYZ-iLoS)
              DEPSA(iWabs,iUabs) = DEPSA(iWabs,iUabs)
     &          + ValB*SA2(iSAdr2)

              !! EY derivative
              iXWZ = iXabs+nAshT*(iWabs-1)+nAshT**2*(iZabs-1)
              ISADR2 = 1+iTUV-iLo+LDA*(iXWZ-jLo)
              DEPSA(iWabs,iYabs) = DEPSA(iWabs,iYabs)
     &          + ValB*SA(iSAdr2)

              !! EX derivative
              iWYZ = iWabs+nAshT*(iYabs-1)+nAshT**2*(iZabs-1)
              ISADR2 = 1+iTUV-iLo+LDA*(iWYZ-jLo)
              DEPSA(iWabs,iXabs) = DEPSA(iWabs,iXabs)
     &          + ValB*SA(iSAdr2)

              !! ET derivative
              iWUV = iWabs+nAshT*(iUabs-1)+nAshT**2*(iVabs-1)
              ISADR2 = 1+iWUV-jLoS+NROW*(iXYZ-iLoS)
              DEPSA(iWabs,iTabs) = DEPSA(iWabs,iTabs)
     &          + ValB*SA2(iSAdr2)
            End Do
          end if

          IF (LDA == 0) THEN
            iSAdr = Max(iTUV,iXYZ)*(Max(iTUV,iXYZ)-1)/2
     &            + Min(iTUV,iXYZ)
          END IF
          DEASUM = DEASUM - ValB*SA(iSAdr)

!         2dtx ( Fvuyz-Et*Gvuyz )
!         2 dtx Gvuyz + 2 dtx dyu Gvz
          If (iTabs == iXabs) Then
            !! VALUE=VALUE+Four*(FP(IP)-ET*PREF(IP))
            DF2(iVabs,iUabs,iYabs,iZabs)
     &        = DF2(iVabs,iUabs,iYabs,iZabs) + Two*ValB
            DG2(iVabs,iUabs,iYabs,iZabs)
     &        = DG2(iVabs,iUabs,iYabs,iZabs) - Two*ET*ValB

            !! VALUE=VALUE+Four*PREF(IP)
            DG2(iVabs,iUabs,iYabs,iZabs)
     &        = DG2(iVabs,iUabs,iYabs,iZabs) + Two*ValS
            If (iYabs == iUabs) Then
              !! VALUE=VALUE+Two*DREF(ID)
              DG1(iVabs,iZabs) = DG1(iVabs,iZabs) + Two*ValS
            End If
          End If
          DEPSA(iTabs,iXabs) = DEPSA(iTabs,iXabs)
     &      - Two*ValB*G2(iVabs,iUabs,iYabs,iZabs)

!         dxu ( -Fvtyz + Eu*Gvtyz )
!         -dxu Gvtyz -dxu dyt Gvz
          If (iXabs == iUabs) Then
            !! VALUE=VALUE-Two*(FP(IP)-EU*PREF(IP))
            DF2(iVabs,iTabs,iYabs,iZabs)
     &        = DF2(iVabs,iTabs,iYabs,iZabs) - ValB
            DG2(iVabs,iTabs,iYabs,iZabs)
     &        = DG2(iVabs,iTabs,iYabs,iZabs) + EU*ValB
            !! VALUE=VALUE - Two*PREF(IP)
            DG2(iVabs,iTabs,iYabs,iZabs)
     &        = DG2(iVabs,iTabs,iYabs,iZabs) - ValS
            If (iYabs == iTabs) Then
              !! VALUE=VALUE - DREF(ID)
              DG1(iVabs,iZabs) = DG1(iVabs,iZabs) - ValS
            End If
          End If
          DEPSA(iXabs,iUabs) = DEPSA(iXabs,iUabs)
     &      + ValB*G2(iVabs,iTabs,iYabs,iZabs)

!         dyt ( -Fvuxz + Et*Gvuxz +dxu (-Fvz+(Et+Eu)*Gvz))
!         -dyt Gvuxz
          If (iYabs == iTabs) Then
            !! VALUE=VALUE-Two*(FP(IP)-ET*PREF(IP))
            DF2(iVabs,iUabs,iXabs,iZabs)
     &        = DF2(iVabs,iUabs,iXabs,iZabs) - ValB
            DG2(iVabs,iUabs,iXabs,iZabs)
     &        = DG2(iVabs,iUabs,iXabs,iZabs) + ET*ValB
            If (iXabs == iUabs) Then
              !! VALUE=VALUE - (FD(ID)-ETU*DREF(ID))
              DF1(iVabs,iZabs) = DF1(iVabs,iZabs) - ValB
              DG1(iVabs,iZabs) = DG1(iVabs,iZabs) + ETU*ValB
            End If

            !! VALUE=VALUE - Two*PREF(IP)
            DG2(iVabs,iUabs,iXabs,iZabs)
     &        = DG2(iVabs,iUabs,iXabs,iZabs) - ValS
          End If
          DEPSA(iYabs,iTabs) = DEPSA(iYabs,iTabs)
     &      + ValB*G2(iVabs,iUabs,iXabs,iZabs)
          If (iYabs == iTabs)
     &    DEPSA(iXabs,iUabs) = DEPSA(iXabs,iUabs) + ValB*G1(iVabs,iZabs)
          If (iXabs == iUabs)
     &    DEPSA(iYabs,iTabs) = DEPSA(iYabs,iTabs) + ValB*G1(iVabs,iZabs)

!         -dyu Gvzxt
          If (iYabs == iUabs) Then
            !! VALUE=VALUE-Two*(FP(IP)-EU*PREF(IP))
            DF2(iVabs,iZabs,iXabs,iTabs)
     &        = DF2(iVabs,iZabs,iXabs,iTabs) - ValB
            DG2(iVabs,iZabs,iXabs,iTabs)
     &        = DG2(iVabs,iZabs,iXabs,iTabs) + EU*ValB
            If (iXabs == iTabs) Then
              !! VALUE=VALUE+Two*(FD(ID)-ETU*DREF(ID))
              DF1(iVabs,iZabs) = DF1(iVabs,iZabs) + Two*ValB
              DG1(iVabs,iZabs) = DG1(iVabs,iZabs) - Two*ETU*ValB
            End If

            !! VALUE=VALUE - Two*PREF(IP)
            DG2(iVabs,iZabs,iXabs,iTabs)
     &        = DG2(iVabs,iZabs,iXabs,iTabs) - ValS
          End If
          DEPSA(iYabs,iUabs) = DEPSA(iYabs,iUabs)
     &      + ValB*G2(iVabs,iZabs,iXabs,iTabs)
          If (iYabs == iUabs) DEPSA(iXabs,iTabs) = DEPSA(iXabs,iTabs)
     &      - Two*ValB*G1(iVabs,iZabs)
          If (iXabs == iTabs) DEPSA(iYabs,iUabs) = DEPSA(iYabs,iUabs)
     &      - Two*ValB*G1(iVabs,iZabs)
        end do
#ifdef _MOLCAS_MPP_
        if (is_real_par() .and. IXYZ == iHiS .and.
     &        iRank /= NPROCS-1) then
          irank = irank + 1
          CALL GA_Distribution (lg_S,iRank,iLoS,iHiS,jLoS,jHiS)
          CALL GA_GET(lg_S,jLoS,jHiS,iLoS,iHiS,SA2,NROW)
        end if
#endif
      end do

      Return

      End Subroutine CLagDXA_DP
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXC_FG3(iSym,nAS,NG3,BDER,SDER,
     &                       DF1,DF2,DF3,DG1,DG2,DG3,DEPSA,
     &                       G2,SC,idxG3)

      use Symmetry_Info, only: Mul
      USE SUPERINDEX, only: KTUV
      use caspt2_module, only: NASHT, IASYM, EPSA, NTUVES
      use Constants, only: Zero
      use definitions, only: wp, iwp, byte

      implicit none

      integer(kind=iwp), intent(in) :: iSym, nAS, NG3
      real(kind=wp), intent(in) :: BDER(nAS,nAS), SDER(nAS,nAS),
     &  G2(nAshT,nAshT,nAshT,nAshT), SC(*)
      real(kind=wp), intent(inout) :: DF1(nAshT,nAshT),
     &  DF2(nAshT,nAshT,nAshT,nAshT), DF3(*), DG1(nAshT,nAshT),
     &  DG2(nAshT,nAshT,nAshT,nAshT), DG3(*), DEPSA(nAshT,nAshT)
      integer(kind=byte), intent(in) :: idxG3(6,NG3)

      integer(kind=iwp) :: iG3, iT, iU, iV, iX, iY, iZ, iST, iSU, iSV,
     &                     iSX, iSY, iSZ, ituvs, ixyzs, iTU, iVX, iYZ,
     &                     jSYM, ISUP, JSUP, iW, NSEQ
      real(kind=wp) :: F3VAL, G3VAL

      DO iG3=1,NG3
        iT=idxG3(1,iG3)
        iU=idxG3(2,iG3)
        iV=idxG3(3,iG3)
        iX=idxG3(4,iG3)
        iY=idxG3(5,iG3)
        iZ=idxG3(6,iG3)
        iST=IASYM(iT)
        iSU=IASYM(iU)
        iSV=IASYM(iV)
        iSX=IASYM(iX)
        iSY=IASYM(iY)
        iSZ=IASYM(iZ)
        ituvs=Mul(IST,Mul(ISU,ISV))
        ixyzs=Mul(ISX,Mul(ISY,ISZ))
        F3VAL=Zero
        G3VAL=Zero
        if(ituvs /= ixyzs) cycle
        iTU=iT+NASHT*(iU-1)
        iVX=iV+NASHT*(iX-1)
        iYZ=iY+NASHT*(iZ-1)
!-SVC20100829: 12 equivalent cases, of which the second
!  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
!  - G(tuvxyz) -> SC(vut,xyz)
        jSYM=Mul(IASYM(iV),Mul(IASYM(iU),IASYM(iT)))
        IF (jSYM == iSYM) THEN
          ISUP=KTUV(iV,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iX,iY,iZ)-nTUVES(jSYM)
          F3VAL = F3VAL + BDER(iSup,jSup)
          G3VAL = G3VAL + SDER(iSup,jSup)
        ENDIF
        if (iTU /= iVX .or. iVX /= iYZ) then
          if (iTU /= iVX .and. iTU /= iYZ .and. iVX /= iYZ) then
!  - G(vxtuyz) -> SC(txv,uyz)
            jSYM=Mul(IASYM(iT),Mul(IASYM(iX),IASYM(iV)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iT,iX,iV)-nTUVES(jSYM)
              JSUP=KTUV(iU,iY,iZ)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
!  - G(yzvxtu) -> SC(vzy,xtu)
            jSYM=Mul(IASYM(iV),Mul(IASYM(iZ),IASYM(iY)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iV,iZ,iY)-nTUVES(jSYM)
              JSUP=KTUV(iX,iT,iU)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
!  - G(tuyzvx) -> SC(yut,zvx)
            jSYM=Mul(IASYM(iY),Mul(IASYM(iU),IASYM(iT)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iY,iU,iT)-nTUVES(jSYM)
              JSUP=KTUV(iZ,iV,iX)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
          end if
!  - G(yztuvx) -> SC(tzy,uvx)
          jSYM=Mul(IASYM(iT),Mul(IASYM(iZ),IASYM(iY)))
          IF (jSYM == iSYM) THEN
            ISUP=KTUV(iT,iZ,iY)-nTUVES(jSYM)
            JSUP=KTUV(iU,iV,iX)-nTUVES(jSYM)
            F3VAL = F3VAL + BDER(iSup,jSup)
            G3VAL = G3VAL + SDER(iSup,jSup)
          ENDIF
!  - G(vxyztu) -> SC(yxv,ztu)
          jSYM=Mul(IASYM(iY),Mul(IASYM(iX),IASYM(iV)))
          IF (jSYM == iSYM) THEN
            ISUP=KTUV(iY,iX,iV)-nTUVES(jSYM)
            JSUP=KTUV(iZ,iT,iU)-nTUVES(jSYM)
            F3VAL = F3VAL + BDER(iSup,jSup)
            G3VAL = G3VAL + SDER(iSup,jSup)
          ENDIF
        end if

        if ((iT /= iU .or. iV /= iX .or. iY /= iZ) .and.
     &      (iT /= iU .or. iV /= iZ .or. iX /= iY) .and.
     &      (iX /= iV .or. iT /= iZ .or. iU /= iY) .and.
     &      (iZ /= iY .or. iV /= iU .or. iX /= iT)) then
!  - G(utxvzy) -> SC(xtu,vzy)
          jSYM=Mul(IASYM(iX),Mul(IASYM(iT),IASYM(iU)))
          IF (jSYM == iSYM) THEN
            ISUP=KTUV(iX,iT,iU)-nTUVES(jSYM)
            JSUP=KTUV(iV,iZ,iY)-nTUVES(jSYM)
            F3VAL = F3VAL + BDER(iSup,jSup)
            G3VAL = G3VAL + SDER(iSup,jSup)
          ENDIF
          if (iTU /= iVX .or. iVX /= iYZ) then
            if (iTU /= iVX .and. iTU /= iYZ .and. iVX /= iYZ) then
!  - G(xvutzy) -> SC(uvx,tzy)
              jSYM=Mul(IASYM(iU),Mul(IASYM(iV),IASYM(iX)))
              IF (jSYM == iSYM) THEN
                ISUP=KTUV(iU,iV,iX)-nTUVES(jSYM)
                JSUP=KTUV(iT,iZ,iY)-nTUVES(jSYM)
                F3VAL = F3VAL + BDER(iSup,jSup)
                G3VAL = G3VAL + SDER(iSup,jSup)
              ENDIF
!  - G(zyxvut) -> SC(xyz,vut)
              jSYM=Mul(IASYM(iX),Mul(IASYM(iY),IASYM(iZ)))
              IF (jSYM == iSYM) THEN
                ISUP=KTUV(iX,iY,iZ)-nTUVES(jSYM)
                JSUP=KTUV(iV,iU,iT)-nTUVES(jSYM)
                F3VAL = F3VAL + BDER(iSup,jSup)
                G3VAL = G3VAL + SDER(iSup,jSup)
              ENDIF
!  - G(utzyxv) -> SC(ztu,yxv)
              jSYM=Mul(IASYM(iZ),Mul(IASYM(iT),IASYM(iU)))
              IF (jSYM == iSYM) THEN
                ISUP=KTUV(iZ,iT,iU)-nTUVES(jSYM)
                JSUP=KTUV(iY,iX,iV)-nTUVES(jSYM)
                F3VAL = F3VAL + BDER(iSup,jSup)
                G3VAL = G3VAL + SDER(iSup,jSup)
              ENDIF
            end if
!  - G(zyutxv) -> SC(uyz,txv)
            jSYM=Mul(IASYM(iU),Mul(IASYM(iY),IASYM(iZ)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iU,iY,iZ)-nTUVES(jSYM)
              JSUP=KTUV(iT,iX,iV)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
!  - G(xvzyut) -> SC(zvx,yut)
            jSYM=Mul(IASYM(iZ),Mul(IASYM(iV),IASYM(iX)))
            IF (jSYM == iSYM) THEN
              ISUP=KTUV(iZ,iV,iX)-nTUVES(jSYM)
              JSUP=KTUV(iY,iU,iT)-nTUVES(jSYM)
              F3VAL = F3VAL + BDER(iSup,jSup)
              G3VAL = G3VAL + SDER(iSup,jSup)
            ENDIF
          end if
        end if

        !! last line of F3 transformation in mkfg3.f
        G3VAL = G3VAL - (EPSA(iU)+EPSA(iY))*F3VAL
        Do iW = 1, nAshT
          ISUP=KTUV(iV,iW,iT)-nTUVES(iSYM)
          JSUP=KTUV(iX,iY,iZ)-nTUVES(iSYM)
          NSEQ=MAX(iSup,jSup)*(MAX(iSup,jSup)-1)/2 + MIN(iSup,jSup)
          DEPSA(iW,iU) = DEPSA(iW,iU) - F3VAL*SC(NSEQ)

          ISUP=KTUV(iV,iU,iT)-nTUVES(iSYM)
          JSUP=KTUV(iX,iW,iZ)-nTUVES(iSYM)
          NSEQ=MAX(iSup,jSup)*(MAX(iSup,jSup)-1)/2 + MIN(iSup,jSup)
          DEPSA(iW,iY) = DEPSA(iW,iY) - F3VAL*SC(NSEQ)
        End Do

        !! derivative of <0|EtuEwv,xwEyz|0>*fww
        DF3(iG3) = DF3(iG3) + F3VAL
        !! derivative of <0|EtuEvxEyz|0>
        DG3(iG3) = DG3(iG3) + G3VAL

        !! remaining F3 and G3 transformation in mkfg3.f
        If (iY == iX) Then
          DF2(iT,iU,iV,iZ) = DF2(iT,iU,iV,iZ) - F3VAL
          DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ) - EPSA(iU)*F3VAL
          Do iW = 1, nAshT
            DEPSA(iU,iW) = DEPSA(iU,iW) - F3VAL*G2(iT,iW,iV,iZ)
          End Do
          DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ) - G3VAL
        End If
        If (iV == iU) Then
          DF2(iT,iX,iY,iZ) = DF2(iT,iX,iY,iZ) - F3VAL
          DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ) - EPSA(iY)*F3VAL
          Do iW = 1, nAshT
            DEPSA(iW,iY) = DEPSA(iW,iY) - F3VAL*G2(iT,iX,iW,iZ)
          End Do
          DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ) - G3VAL
        End If
        If (iY == iU) Then
          DF2(iV,iX,iT,iZ) = DF2(iV,iX,iT,iZ) - F3VAL
          DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ) - EPSA(iU)*F3VAL
          DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ) - G3VAL
        End If
        DEPSA(iY,iU) = DEPSA(iY,iU) - F3VAL*G2(iV,iX,iT,iZ)
        If (iY == iX .and. iV == iU) Then
          DF1(iT,iZ) = DF1(iT,iZ) - F3VAL
          DG1(iT,iZ) = DG1(iT,iZ) - G3VAL
        End If
      END DO

      Return

      End Subroutine CLagDXC_FG3
!
!-----------------------------------------------------------------------
!
#ifdef _MOLCAS_MPP_
      SUBROUTINE CLagDXC_FG3_MPP(ISYM,lg_BDER,lg_SDER,DG1,DG2,DG3,
     &                           DF1,DF2,DF3,DEPSA,G2,idxG3)

      use Symmetry_Info, only: Mul
      USE SUPERINDEX, only: KTUV
      use definitions, only: iwp,RtoB,wp,byte
      use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
      USE Para_Info, ONLY: Is_Real_Par, nProcs
      use caspt2_module, only: NASHT, IASYM, EPSA, NTUVES
      use pt2_guga, only: NG3
      use Constants, only: Zero

      implicit none

#include "global.fh"
#include "mafdecls.fh"

      integer(kind=iwp), intent(in) :: ISYM, lg_BDER, lg_SDER
      real(kind=wp), intent(inout) :: DG1(NASHT,NASHT),
     &  DG2(NASHT,NASHT,NASHT,NASHT), DG3(*), DF1(NASHT,NASHT),
     &  DF2(NASHT,NASHT,NASHT,NASHT), DF3(*), DEPSA(NASHT,NASHT)
      real(kind=wp), intent(in) :: G2(NASHT,NASHT,NASHT,NASHT)
      integer(kind=byte), intent(in) :: idxG3(6,NG3)

      integer(kind=iwp), ALLOCATABLE :: INDI(:), INDJ(:), NELBsav(:),
     &                                  NELSsav(:)
      real(kind=wp),  ALLOCATABLE :: BUFFB(:), BUFFS(:)

      integer(kind=iwp) :: NG3MAX, MAXMEM, iscal, MAXBUF, NG3B, NBUF,
     &                     NBLOCKS, IBLOCK, IG3STA, IG3END, NtotELB,
     &                     NtotELS, iG3, NELB, NELS, iT, iU, iV, iX,
     &                     iY, iZ, iST, iSU, iSV, iSX, iSY, iSZ, ituvs,
     &                     ixyzs, iTU, iVX, iYZ, jSym, IROW, ICOL, i, IW
      real(kind=wp) :: G3VAL, F3VAL

      ! Since we are stuck with collective calls to MPI_Alltoallv in
      ! order to gather the elements, each process needs to loop over
      ! the same number of blocks.
      NG3MAX=NG3
      CALL GAIGOP_SCAL(NG3MAX,'max')
      IF (NG3MAX == 0) RETURN

      ! The global SC matrix has already been allocated, so we need to
      ! find out how much memory is left for buffering (4 equally sized
      ! buffers for sending and receiving values and indices)
      CALL mma_MaxDBLE(MAXMEM)
      ! we need two real and two integer values per element
      iscal = (iwp*2 + wp*2)/RtoB
      !MAXBUF=MIN(NINT(0.95D0*MAXMEM)/4,2000000000/8)
      MAXBUF=MIN(NINT(0.95_wp*MAXMEM,kind=iwp)/iscal,2000000000/8)
      MAXBUF=MAXBUF-2*NG3 !! for NELBsav and NELSsav

      ! Loop over blocks NG3B of NG3, so that 12*NG3B < MAXBUF/NPROCS.
      ! This guarantees that e.g. if all processes send all their data
      ! to one other, that process receives NPROCS*NG3B*12 elements
      ! in the receive buffer.
      NG3B=MAXBUF/(NPROCS*16) !! originally 12, but not sure why
      NG3B=MIN(NG3B,NG3MAX)
      CALL GAIGOP_SCAL(NG3B,'min')
      NBUF=16*NG3B

      call mma_allocate(BUFFB,NBUF,Label='BUFFB')
      call mma_allocate(BUFFS,NBUF,Label='BUFFS')
      call mma_allocate(INDI,NBUF,Label='INDI')
      call mma_allocate(INDJ,NBUF,Label='INDJ')

      NBLOCKS=(NG3MAX-1)/NG3B+1
      DO IBLOCK=1,NBLOCKS
        IG3STA=1+(IBLOCK-1)*NG3B
        IG3END=MIN(IG3STA+NG3B-1,NG3)
        call mma_allocate(NELBsav,IG3END-IG3STA+1,Label='NELBsav')
        call mma_allocate(NELSsav,IG3END-IG3STA+1,Label='NELSsav')

        ! Second pass fills the buffers with values and indices
        NtotELB = 0 ! Number of total elements of BDER
        NtotELS = 0 ! Number of total elements of SDER
        DO iG3=IG3STA,IG3END
          NELB = 0 ! Number of elements of BDER for iG3
          NELS = 0 ! Number of elements of SDER for iG3
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=Mul(IST,Mul(ISU,ISV))
          ixyzs=Mul(ISX,Mul(ISY,ISZ))
          if(ituvs == ixyzs) then
            iTU=iT+NASHT*(iU-1)
            iVX=iV+NASHT*(iX-1)
            iYZ=iY+NASHT*(iZ-1)
           !F3VAL=F3(iG3)
!-SVC20100829: 12 equivalent cases, of which the second
!  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
!  - F(tuvxyz) -> BC(vut,xyz)
            jSYM=Mul(IASYM(iV),Mul(IASYM(iU),IASYM(iT)))
            IF (jSYM == iSYM) THEN
              IROW=KTUV(iV,iU,iT)-nTUVES(jSYM)
              ICOL=KTUV(iX,iY,iZ)-nTUVES(jSYM)
              NELB = NELB + 1
              NtotELB = NtotELB + 1
              INDI(NtotELB) = IROW
              INDJ(NtotELB) = ICOL
            ENDIF
            if (iTU /= iVX .or. iVX /= iYZ) then
              if (iTU /= iVX .and. iTU /= iYZ .and. iVX /= iYZ) then
!  - F(vxtuyz) -> BC(txv,uyz)
                jSYM=Mul(IASYM(iT),Mul(IASYM(iX),IASYM(iV)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iT,iX,iV)-nTUVES(jSYM)
                  ICOL=KTUV(iU,iY,iZ)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
!  - F(yzvxtu) -> BC(vzy,xtu)
                jSYM=Mul(IASYM(iV),Mul(IASYM(iZ),IASYM(iY)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iV,iZ,iY)-nTUVES(jSYM)
                  ICOL=KTUV(iX,iT,iU)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
!  - F(tuyzvx) -> BC(yut,zvx)
                jSYM=Mul(IASYM(iY),Mul(IASYM(iU),IASYM(iT)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iY,iU,iT)-nTUVES(jSYM)
                  ICOL=KTUV(iZ,iV,iX)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
              end if
!  - F(yztuvx) -> BC(tzy,uvx)
              jSYM=Mul(IASYM(iT),Mul(IASYM(iZ),IASYM(iY)))
              IF (jSYM == iSYM) THEN
                IROW=KTUV(iT,iZ,iY)-nTUVES(jSYM)
                ICOL=KTUV(iU,iV,iX)-nTUVES(jSYM)
                NELB = NELB + 1
                NtotELB = NtotELB + 1
                INDI(NtotELB) = IROW
                INDJ(NtotELB) = ICOL
              ENDIF
!  - F(vxyztu) -> BC(yxv,ztu)
              jSYM=Mul(IASYM(iY),Mul(IASYM(iX),IASYM(iV)))
              IF (jSYM == iSYM) THEN
                IROW=KTUV(iY,iX,iV)-nTUVES(jSYM)
                ICOL=KTUV(iZ,iT,iU)-nTUVES(jSYM)
                NELB = NELB + 1
                NtotELB = NtotELB + 1
                INDI(NtotELB) = IROW
                INDJ(NtotELB) = ICOL
              ENDIF
            end if
            if ((iT /= iU .or. iV /= iX .or. iY /= iZ) .and.
     &          (iT /= iU .or. iV /= iZ .or. iX /= iY) .and.
     &          (iX /= iV .or. iT /= iZ .or. iU /= iY) .and.
     &          (iZ /= iY .or. iV /= iU .or. iX /= iT)) then
!  - F(utxvzy) -> BC(xtu,vzy)
              jSYM=Mul(IASYM(iX),Mul(IASYM(iT),IASYM(iU)))
              IF (jSYM == iSYM) THEN
                IROW=KTUV(iX,iT,iU)-nTUVES(jSYM)
                ICOL=KTUV(iV,iZ,iY)-nTUVES(jSYM)
                NELB  = NELB + 1
                NtotELB = NtotELB + 1
                INDI(NtotELB) = IROW
                INDJ(NtotELB) = ICOL
              ENDIF
              if (iTU /= iVX .or. iVX /= iYZ) then
                if (iTU /= iVX .and. iTU /= iYZ .and. iVX /= iYZ) then
!  - F(xvutzy) -> BC(uvx,tzy)
                  jSYM=Mul(IASYM(iU),Mul(IASYM(iV),IASYM(iX)))
                  IF (jSYM == iSYM) THEN
                    IROW=KTUV(iU,iV,iX)-nTUVES(jSYM)
                    ICOL=KTUV(iT,iZ,iY)-nTUVES(jSYM)
                    NELB = NELB + 1
                    NtotELB = NtotELB + 1
                    INDI(NtotELB) = IROW
                    INDJ(NtotELB) = ICOL
                  ENDIF
!  - F(zyxvut) -> BC(xyz,vut)
                  jSYM=Mul(IASYM(iX),Mul(IASYM(iY),IASYM(iZ)))
                  IF (jSYM == iSYM) THEN
                    IROW=KTUV(iX,iY,iZ)-nTUVES(jSYM)
                    ICOL=KTUV(iV,iU,iT)-nTUVES(jSYM)
                    NELB = NELB + 1
                    NtotELB = NtotELB + 1
                    INDI(NtotELB) = IROW
                    INDJ(NtotELB) = ICOL
                  ENDIF
!  - F(utzyxv) -> BC(ztu,yxv)
                  jSYM=Mul(IASYM(iZ),Mul(IASYM(iT),IASYM(iU)))
                  IF (jSYM == iSYM) THEN
                    IROW=KTUV(iZ,iT,iU)-nTUVES(jSYM)
                    ICOL=KTUV(iY,iX,iV)-nTUVES(jSYM)
                    NELB = NELB + 1
                    NtotELB = NtotELB + 1
                    INDI(NtotELB) = IROW
                    INDJ(NtotELB) = ICOL
                  ENDIF
                end if
!  - F(zyutxv) -> BC(uyz,txv)
                jSYM=Mul(IASYM(iU),Mul(IASYM(iY),IASYM(iZ)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iU,iY,iZ)-nTUVES(jSYM)
                  ICOL=KTUV(iT,iX,iV)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
!  - F(xvzyut) -> BC(zvx,yut)
                jSYM=Mul(IASYM(iZ),Mul(IASYM(iV),IASYM(iX)))
                IF (jSYM == iSYM) THEN
                  IROW=KTUV(iZ,iV,iX)-nTUVES(jSYM)
                  ICOL=KTUV(iY,iU,iT)-nTUVES(jSYM)
                  NELB = NELB + 1
                  NtotELB = NtotELB + 1
                  INDI(NtotELB) = IROW
                  INDJ(NtotELB) = ICOL
                ENDIF
              end if
            end if
          end if
          nels = nelb
          NELBsav(iG3-IG3STA+1) = NELB
          NELSsav(iG3-IG3STA+1) = NELS
        END DO
        ntotels = ntotelb

        CALL GA_GATHER(lg_BDER,BUFFB,INDI,INDJ,NtotELB)
        CALL GA_GATHER(lg_SDER,BUFFS,INDI,INDJ,NtotELS)

        ! Finally, fill the local chunk of the SC matrix (block of rows)
        ! with the received values at their appropriate place.
        NtotELB = 0
        NtotELS = 0
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          NELB = NELBsav(iG3-IG3STA+1)
          NELS = NELSsav(iG3-IG3STA+1)

          F3VAL = Zero
          DO i = 1, NELB
            NtotELB = NtotELB + 1
            F3VAL = F3VAL + BUFFB(NtotELB)
          END DO
!         BUFFB(iG3-IG3STA+1) = F3VAL

          G3VAL = Zero
          DO i = 1, NELS
            NtotELS = NtotELS + 1
            G3VAL = G3VAL + BUFFS(NtotELS)
          END DO
          G3VAL = G3VAL - (EPSA(iU)+EPSA(iY))*F3VAL

          DF3(iG3) = DF3(iG3) + F3VAL
          DG3(iG3) = DG3(iG3) + G3VAL

          !! do depsa
!         ISUP=KTUV(iV,iU,iT)-nTUVES(iSYM)
!         If (ISUP >= iLo .and. ISUP <= iHi) THen
!           Do iW = 1, nAshT
!             JSUP=KTUV(iX,iW,iZ)-nTUVES(iSYM)
!             NSEQ=1+ISUP-iLo+LDA*(JSUP-jLo)
!             DEPSA(iW,iY) = DEPSA(iW,iY) - F3VAL*SC(ISUP-iLo,JSUP)
!           End Do
!         End If

          !! remaining F3 and G3 transformation in mkfg3.f
          If (iY == iX) Then
            DF2(iT,iU,iV,iZ) = DF2(iT,iU,iV,iZ) - F3VAL
            DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ) - EPSA(iU)*F3VAL
            Do iW = 1, nAshT
              DEPSA(iU,iW) = DEPSA(iU,iW) - F3VAL*G2(iT,iW,iV,iZ)
            End Do
            DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ) - G3VAL
          End If
          If (iV == iU) Then
            DF2(iT,iX,iY,iZ) = DF2(iT,iX,iY,iZ) - F3VAL
            DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ) - EPSA(iY)*F3VAL
            Do iW = 1, nAshT
              DEPSA(iW,iY) = DEPSA(iW,iY) - F3VAL*G2(iT,iX,iW,iZ)
            End Do
            DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ) - G3VAL
          End If
          If (iY == iU) Then
            DF2(iV,iX,iT,iZ) = DF2(iV,iX,iT,iZ) - F3VAL
            DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ) - EPSA(iU)*F3VAL
            DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ) - G3VAL
          End If
          DEPSA(iY,iU) = DEPSA(iY,iU) - F3VAL*G2(iV,iX,iT,iZ)
          If (iY == iX .and. iV == iU) Then
            DF1(iT,iZ) = DF1(iT,iZ) - F3VAL
            DG1(iT,iZ) = DG1(iT,iZ) - G3VAL
          End If
        END DO

        call mma_deallocate(NELBsav)
        call mma_deallocate(NELSsav)
      END DO ! end loop over blocks of G3 values

      call mma_deallocate(BUFFB)
      call mma_deallocate(BUFFS)
      call mma_deallocate(INDI)
      call mma_deallocate(INDJ)

      RETURN

      End Subroutine CLagDXC_FG3_MPP
#endif
!
!-----------------------------------------------------------------------
!
      Subroutine CLagDXC_DP(iSym,nAS,BDER,SDER,DG1,DG2,DF1,DF2,
     &                      DEPSA,DEASUM,iLo,iHi,jLo,jHi,LDC,
     &                      G1,G2,SC,SC2,lg_S)

      USE SUPERINDEX, only: MTUV
      use caspt2_global, only:ipea_shift
      use caspt2_module, only: NASHT, EASUM, EPSA, NTUVES
      use Constants, only: Zero, Half, Four
      use definitions, only: wp, iwp
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, nProcs
#endif

      implicit none

#ifdef _MOLCAS_MPP_
#include "global.fh"
#else
#include "macros.fh"
#endif

      integer(kind=iwp), intent(in) :: iSym, nAS, iLo, iHi, jLo, jHi,
     &                                 LDC, lg_S
      real(kind=wp), intent(in) :: BDER(*), SC(*), SC2(*)
      real(kind=wp), intent(inout) :: SDER(*),
     &  DG1(nAshT,nAshT), DG2(nAshT,nAshT,nAshT,nAshT),
     &  DF1(nAshT,nAshT), DF2(nAshT,nAshT,nAshT,nAshT),
     &  DEPSA(nAshT,nAshT), DEASUM, G1(nAshT,nAshT),
     &  G2(nAshT,nAshT,nAshT,nAshT)

      integer(kind=iwp) :: ISADR, NROW, iLoS, jLoS, IXYZ, IXYZABS,
     &  IXABS, IYABS, IZABS, ITUV, ITUVABS, ITABS, IUABS, IVABS,
     &  ISADR2, iWabs, iTWV, iXWZ
      real(kind=wp) :: EU, EY, EYU, FACT, ValB, bsBDER, ValS
#ifdef _MOLCAS_MPP_
      integer(kind=iwp) :: irank, iHiS, jHiS
#endif
!
!     LDC == 0, if not parallel; SC is triangular
!     LDC /= 0, if parallel    ; SC is square
!     In both cases, BDER and SDER are square
!
      ISADR=0
      NROW = 0
      iLoS = 0
      jLoS = 0
#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
        irank = 0
        CALL GA_Distribution (lg_S,iRank,iLoS,iHiS,jLoS,jHiS)
        NROW = jHiS-jLoS+1 !! = NAS
        CALL GA_GET(lg_S,jLoS,jHiS,iLoS,iHiS,SC2,NROW)
      end if
#else
      unused_var(lg_S)
#endif
      DO IXYZ=jLo,jHi
        IXYZABS=IXYZ+NTUVES(ISYM)
        IXABS=MTUV(1,IXYZABS)
        IYABS=MTUV(2,IXYZABS)
        IZABS=MTUV(3,IXYZABS)
        EY=EPSA(IYABS)
        DO ITUV=iLo,iHi
          ITUVABS=ITUV+NTUVES(ISYM)
          ITABS=MTUV(1,ITUVABS)
          IUABS=MTUV(2,ITUVABS)
          IVABS=MTUV(3,ITUVABS)
          EU=EPSA(IUABS)
          EYU=EY + EU
          FACT=EYU-EASUM
          IF (LDC == 0) THEN
            ISADR=1+iTUV-iLo+NAS*(iXYZ-jLo)
          ELSE
            ISADR=1+iTUV-iLo+LDC*(iXYZ-jLo)
          END IF
          ValB=BDER(ISADR)

          If (iTUV == iXYZ .and. ipea_shift /= Zero) Then
!           !! BC in the next equation refers to the active overlap
!    !! ipea_shift*Half*BC(ISADR)*(Four-DREF(IDT)-DREF(IDV)+DREF(IDU))
            bsBDER = ipea_shift*Half*ValB
            SDER(iSAdr) = SDER(iSAdr) + bsBDER*(Four
     &       -G1(iTabs,iTabs)+G1(iUabs,iUabs)-G1(iVabs,iVabs))
            IF (LDC == 0) THEN
              iSAdr2 = iTUV*(iTUV+1)/2
            ELSE
              ISADR2 = 1+iTUV-iLo+LDC*(iTUV-jLo)
            END IF
            DG1(iTabs,iTabs) = DG1(iTabs,iTabs) - bsBDER*SC(iSAdr2)
            DG1(iUabs,iUabs) = DG1(iUabs,iUabs) + bsBDER*SC(iSAdr2)
            DG1(iVabs,iVabs) = DG1(iVabs,iVabs) - bsBDER*SC(iSAdr2)
          End If

          !! First VALUE contribution in MKBC_DP (FACT)
!         IF (LDC == 0) ISADR=ITUV*(ITUV-1)/2+IXYZ
          SDER(ISADR) = SDER(ISADR) + FACT*ValB
          ValS=SDER(ISADR)

          !! DEPSA can be computed simultaneously with the F3
          !! contributions, but remember that SC here is the overlap,
          !! whereas SC in FG3 subroutines are just G3 matrix
          if (ldc == 0) then
            Do iWabs = 1, nAshT
              iTWV = iTabs+nAshT*(iWabs-1)+nAshT**2*(iVabs-1)
              iSAdr2 = Max(iTWV,iXYZ)*(Max(iTWV,iXYZ)-1)/2
     &               + Min(iTWV,iXYZ)
              DEPSA(iWabs,iUabs) = DEPSA(iWabs,iUabs)
     &          + ValB*SC(iSAdr2)

              iXWZ = iXabs+nAshT*(iWabs-1)+nAshT**2*(iZabs-1)
              iSAdr2 = Max(iTUV,iXWZ)*(Max(iTUV,iXWZ)-1)/2
     &               + Min(iTUV,iXWZ)
              DEPSA(iWabs,iYabs) = DEPSA(iWabs,iYabs)
     &          + ValB*SC(iSAdr2)
            End Do
          else
            !! assume SC has all columns (which is reasonable)
!           iTWV = iTabs+nAshT**2*(iVabs-1)
!           ISADR2 = 1+iTWV-jLoS+NROW*(iXYZ-iLoS)
!           Call DaXpY_(nAshT,ValB,SC2(iSAdr2),nAshT,DEPSA(1,iUabs),1)
!           iXWZ = iXabs+nAshT**2*(iZabs-1)
!           ISADR2 = 1+iTUV-iLo+LDC*(iXWZ-jLo)
!           Call DaXpY_(nAshT,ValB,SC(iSAdr2),LDC*nAshT,
!    *                             DEPSA(1,iYabs),1)
            Do iWabs = 1, nAshT
              !! we do not have all elements, so use distributed memory
              iTWV = iTabs+nAshT*(iWabs-1)+nAshT**2*(iVabs-1)
              ISADR2 = 1+iTWV-jLoS+NROW*(iXYZ-iLoS)
              DEPSA(iWabs,iUabs) = DEPSA(iWabs,iUabs)
     &          + ValB*SC2(iSAdr2)

              !! we have all elements, so local memory
              iXWZ = iXabs+nAshT*(iWabs-1)+nAshT**2*(iZabs-1)
              ISADR2 = 1+iTUV-iLo+LDC*(iXWZ-jLo)
              DEPSA(iWabs,iYabs) = DEPSA(iWabs,iYabs)
     &          + ValB*SC(iSAdr2)
            End Do
          end if

          !! If non-parallel, overlap is triangular
          !! If parallel, the index is the same to that of SDER
          IF (LDC == 0) THEN
            iSAdr = Max(iTUV,iXYZ)*(Max(iTUV,iXYZ)-1)/2
     &            + Min(iTUV,iXYZ)
          END IF
          DEASUM = DEASUM - ValB*SC(iSAdr)

!         dyu ( Fvztx - EPSA(u)*Gvztx )
!         dyu Gvztx
          IF(IYABS == IUABS) THEN
            !! VALUE=VALUE+Two*(FP(IP)-EU*PREF(IP))
            DF2(iVabs,iZabs,iTabs,iXabs)
     &        = DF2(iVabs,iZabs,iTabs,iXabs) + ValB
            DG2(iVabs,iZabs,iTabs,iXabs)
     &        = DG2(iVabs,iZabs,iTabs,iXabs) - EU*ValB

            !! VALUE=VALUE+Two*PREF(IP)
            DG2(iVabs,iZabs,iTabs,iXabs)
     &        = DG2(iVabs,iZabs,iTabs,iXabs) + ValS
          END IF
          DEPSA(iYabs,iUabs) = DEPSA(iYabs,iUabs)
     &      - ValB*G2(iVabs,iZabs,iTabs,iXabs)

!         dyx ( Fvutz - EPSA(y)*Gvutz )
!         dyx Gvutz -> dut Gzyxv
          IF(IYABS == IXABS) THEN
            !! VALUE=VALUE+Two*(FP(IP)-EY*PREF(IP))
            DF2(iVabs,iUabs,iTabs,iZabs)
     &        = DF2(iVabs,iUabs,iTabs,iZabs) + ValB
            DG2(iVabs,iUabs,iTabs,iZabs)
     &        = DG2(iVabs,iUabs,iTabs,iZabs) - EY*ValB

            !! VALUE=VALUE+Two*PREF(IP)
            DG2(iVabs,iUabs,iTabs,iZabs)
     &        = DG2(iVabs,iUabs,iTabs,iZabs) + ValS
          END IF
          DEPSA(iYabs,iXabs) = DEPSA(iYabs,iXabs)
     &      - ValB*G2(iVabs,iUabs,iTabs,iZabs)

!         dtu ( Fvxyz - EPSA(u)*Gvxyz + dyx Fvz -
!                (EPSA(u)+EPSA(y)*dyz Gvz)
!         dtu Gvxyz + dtu dyx Gvz
          IF(ITABS == IUABS) THEN
            !! VALUE=VALUE+Two*(FP(IP)-EU*PREF(IP))
            DF2(iVabs,iXabs,iYabs,iZabs)
     &        = DF2(iVabs,iXabs,iYabs,iZabs) + ValB
            DG2(iVabs,iXabs,iYabs,iZabs)
     &        = DG2(iVabs,iXabs,iYabs,iZabs) - EU*ValB

            !! VALUE=VALUE+Two*PREF(IP)
            DG2(iVabs,iXabs,iYabs,iZabs)
     &        = DG2(iVabs,iXabs,iYabs,iZabs) + ValS
            IF(IYABS == IXABS) THEN
              !! VALUE=VALUE+FD(ID)-EYU*DREF(ID)
              DF1(iVabs,iZabs) = DF1(iVabs,iZabs) + ValB
              DG1(iVabs,iZabs) = DG1(iVabs,iZabs) - EYU*ValB

              !! VALUE=VALUE+DREF((ID1*(ID1-1))/2+ID2)
              DG1(iVabs,iZabs) = DG1(iVabs,iZabs) + ValS
            END IF
          END IF
          DEPSA(iTabs,iUabs) = DEPSA(iTabs,iUabs)
     &      - ValB*G2(iVabs,iXabs,iYabs,iZabs)
          If (iYabs == iXabs)
     &    DEPSA(iTabs,iUabs) = DEPSA(iTabs,iUabs) - ValB*G1(iVabs,iZabs)
          If (iTabs == iUabs)
     &    DEPSA(iYabs,iXabs) = DEPSA(iYabs,iXabs) - ValB*G1(iVabs,iZabs)
        end do
#ifdef _MOLCAS_MPP_
        if (is_real_par() .and. IXYZ == iHiS .and. iRank/=NPROCS-1) then
          irank = irank + 1
          CALL GA_Distribution (lg_S,iRank,iLoS,iHiS,jLoS,jHiS)
          CALL GA_GET(lg_S,jLoS,jHiS,iLoS,iHiS,SC2,NROW)
        end if
#endif
      end do

      Return

      End Subroutine CLagDXC_DP
!
!-----------------------------------------------------------------------
!
#ifdef _MOLCAS_MPP_
      Subroutine DF3_DEPSA_MPP(DF3,DEPSA,lg_S,idxG3)

      use Symmetry_Info, only: Mul
      USE SUPERINDEX, only: KTUV
      USE Para_Info, only: nProcs
      use definitions, only: wp, iwp, byte
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NASHT, IASYM, NTUVES
      use pt2_guga, only: NG3

      implicit none

#include "global.fh"
#include "mafdecls.fh"

      real(kind=wp), intent(in) :: DF3(*)
      real(kind=wp), intent(inout) :: DEPSA(NASHT,NASHT)
      integer(kind=iwp), intent(in) :: lg_S
      integer(kind=byte), intent(in) :: idxG3(6,NG3)

      real(kind=wp), allocatable :: WRK(:)
      integer(kind=iwp) :: isym, iRank, ILO, IHI, JLO, JHI, NROW, NCOL,
     &  iG3, iT, iU, iV, iX, iY, iZ, iST, iSU, iSV, iSX, iSY, iSZ,
     &  ituvs, ixyzs, ISUP1, ISUP2, JSUP1, JSUP2, IW, NSEQ
      real(kind=wp) :: F3VAL

      !! do depsa
      isym=1
      Do iRank = 0, NPROCS-1
        CALL GA_Distribution(lg_S,iRank,ILO,IHI,JLO,JHI)
        NROW=iHi-iLo+1
        NCOL=jHi-jLo+1
        Call mma_allocate(WRK,NROW*NCOL,Label='WRK')
        Call GA_Get(lg_S,iLo,iHi,jLo,jHi,WRK,NROW)
        DO iG3=1,NG3
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=Mul(IST,Mul(ISU,ISV))
          ixyzs=Mul(ISX,Mul(ISY,ISZ))
          if(ituvs /= ixyzs) cycle

          F3VAL = DF3(iG3)

          ISUP1=KTUV(iV,iU,iT)-nTUVES(iSYM)
          If (ISUP1 >= iLo .and. ISUP1 <= iHi) Then
            Do iW = 1, nAshT
              JSUP1=KTUV(iX,iW,iZ)-nTUVES(iSYM)
              NSEQ=1+ISUP1-iLo+NROW*(JSUP1-jLo)
              DEPSA(iW,iY) = DEPSA(iW,iY) - F3VAL*WRK(NSEQ)
            End Do
          End If
          JSUP2=KTUV(iX,iY,iZ)-nTUVES(iSYM)
          If (JSUP2 >= iLo .and. JSUP2 <= iHi) Then
            Do iW = 1, nAshT
              ISUP2=KTUV(iV,iW,iT)-nTUVES(iSYM)
              NSEQ=1+JSUP2-iLo+NROW*(ISUP2-jLo)
              DEPSA(iW,iU) = DEPSA(iW,iU) - F3VAL*WRK(NSEQ)
            End Do
          End If
        END DO
        call mma_deallocate(WRK)
      End Do

      Return

      End Subroutine DF3_DEPSA_MPP
#endif
!
!-----------------------------------------------------------------------
!
      Subroutine DEPSAOffC(CLag,DEPSA,FIFA,FIMO,WRK1,WRK2,U0)

      use Symmetry_Info, only: Mul
      use caspt2_global, only:IPrGlb
      use PrintLevel, only: VERBOSE
      use caspt2_global, only: ConvInvar,SLag
      use gugx, only: SGS, CIS
      use caspt2_global, only: LUCIEX, IDCIEX, IDTCEX
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: iwp, wp, u6
      use Constants, only: Zero, One, Half
      use caspt2_module, only: IFXMS, IFRMS, NSYM, STSYM, NCONF, NFRO,
     &                         NISH, NASH, NASHT, NORB, NBAS,
     &                         NBAST, ISCF, NSTATE, NBTCH, NBTCHES
!     use caspt2_module, only: NSSH
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif

      implicit none

      real(kind=wp), intent(inout) :: CLag(nConf,nState),
     &  DEPSA(nAshT,nAshT),WRK1(nBasT,nBasT),WRK2(*)
      real(kind=wp), intent(in) :: FIFA(*), FIMO(*), U0(nState,nState)
      real(kind=wp),allocatable :: VecST(:,:),VecS1(:,:),VecS2(:,:),
     &                             VecCID(:,:),VecPre(:),VecFancy(:),
     &                             VecCIT(:,:),INT1(:),INT2(:),G2(:)
      real(kind=wp), allocatable ::  Eact(:)

      real(kind=wp) :: Thres, DeltaC, Delta, Delta0, AlphaC, Alpha,
     &                 ResCI, Beta, Res
      real(kind=wp), external :: DDot_
      integer(kind=iwp) :: nLev, nMidV, iSym, ID, iState, isyci,
     &                     MaxIter, Iter

      real(kind=wp) :: CPUT, WALLT, CPE, CPTF0, TIOE, TIOTF0
      real(kind=wp) :: CPTF1, CPTF2, TIOTF1, TIOTF2

      nLev = SGS%nLev
      nMidV= CIS%nMidV

      Thres = ConvInvar !! 1.0d-07

      If (IPRGLB >= VERBOSE) Then
        Write (u6,*)
        Write (u6,'(3X,"Linear Equation for Non-Invariant CASPT2",
     &                 " (threshold =",ES9.2,")")') Thres
        Write (u6,*)
        CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
      End If
!
!     If CASPT2 energy is not invariant with respect to rotations within
!     active space (with IPEA shift and/or with RAS reference), the
!     active density obtained in constructing CI derivative is no longer
!     correct... well, it may be correct, but orbital rotations in the
!     active space cannot be parametrized in Z-vector, so analytic
!     derivatives cannot be computed with the existing module. So,
!     the active density is computed in a differnt way.
!
!     See J. Chem. Phys. 2023, 158, 174112. for details, in particular,
!     Section II C 4 "Non-invariance with respect to active MOs"
!     To be more specific, this subroutine solves the linear equation
!     (Eq. (71)) and computes the second term in Eq. (70) later.
!     CLag corresponds to the RHS in Eq. (71).
!
      !! Some post-processing of CI derivative
      !! Somehow, this has to be done in the XMS basis
      Call CLagFinalOffC(SLag)
!
!     ----- Solve the linear equation -----
!     A_{IS,JR}*X_{JR} = CLag_{IS}, where A_{IS,JR} is the CI-CI Hessian
!     which may be seen in Z-vector
!
      call mma_allocate(VecST,nConf,nState,Label='VecST')
      call mma_allocate(VecS1,nConf,nState,Label='VecS1')
      call mma_allocate(VecS2,nConf,nState,Label='VecS2')
      call mma_allocate(VecCID,nConf,nState,Label='VecCID')
!     call mma_allocate(VecS,nState*(nState-1)/2,Label='VecS')
      call mma_allocate(VecPre,nConf,Label='VecPre')
      call mma_allocate(VecFancy,nState**3,Label='VecFancy')

      call mma_allocate(VecCIT,nConf,nState,Label='VecCIT')
      call mma_allocate(INT1,nAshT**2,Label='INT1')
      call mma_allocate(INT2,nAshT**4,Label='INT2')

      call mma_allocate(Eact,nState,Label='Eact')

      !! We do not have Cholesky vectors for frozen orbitals,
      !! so may be it is not possible to get inactive energies?
      !! It can be computed with TimesE2
      iSym = 1
      Call CnstInt(0,INT1,INT2)
      ID = IDTCEX !! IDCIEX !! this parameter is hacked
      Do iState = 1, nState
        If (ISCF == 0) Then
          !! quasi-canonical, XMS
          Call DDaFile(LUCIEX,2,VecCIT(1,iState),nConf,ID)
        Else
          VecCIT(1,iState) = One
        End If
        !! The second term should be removed
        Eact(iState) = Zero
      End Do
      if (ifxms .or. ifrms) then
        !! Transform the CLag and CI vector from XMS to SCF basis
        !! Maybe, in order to define Eact
        Call DGEMM_('N','T',nConf,nState,nState,
     &              One,CLag,nConf,U0,nState,
     &              Zero,VecST,nConf)
        CLag(1:nConf,1:nState) = VecST(1:nConf,1:nState)
        Call DGEMM_('N','T',nConf,nState,nState,
     &              One,VecCIT,nConf,U0,nState,
     &              Zero,VecST,nConf)
        VecCIT(1:nConf,1:nState) = VecST(1:nConf,1:nState)
      end if
      Call TimesE2(0,VecCIT,VecS1,INT1,INT2)
      Do iState = 1, nState
        !! scaling with nState is due to the division in TimesE2
        Eact(iState) = -Half*nState*
     &    DDot_(nConf,VecS1(1,iState),1,VecCIT(1,iState),1)
      End Do
      isyci = 1

      !! Precondition
      Call CnstInt(2,INT1,INT2)
      Call CnstPrec(ISYCI,VecPre,VecCIT,
     &              INT1,INT2,VecFancy,nLev,
     &              nMidV)
      Call CnstInt(0,INT1,INT2)

      !! Begin!
      VecST(1:nConf,1:nState) = CLag(1:nConf,1:nState)

      !! z0 = M^{-1}*r0
      VecS2(1:nConf,1:nState) = VecST(1:nConf,1:nState)
      Call DoPrec(VecST,VecS2,VecS1,VecPre,VecFancy)
      !! p0 = z0
      VecCId(1:nConf,1:nState) = VecS2(1:nConf,1:nState)
      MaxIter = 100
      Iter    = 1
      iSym    = 1
      ! jspin   = 0
      ! r^T dot z
      ! r (residue) = ipST
      ! z (prec. r) = ipS2
      ! p (...)     = ipCId
      ! x (solution)= ipCIT
      ! Ap          = ipS1
      ! r_{k}z_{k}  = ipST*ipS2 = deltaC
      DeltaC = DDot_(nConf*nState,VecST,1,VecS2,1)
      Delta  = DeltaC
      Delta0 = Delta
!
      If (IPRGLB >= VERBOSE) Write(u6,*)
     &      ' Iteration       Delta           Res(CI)        '//
     &      '  DeltaC'
      VecCIT(1:nConf,1:nState) = Zero
      If (Delta0 > Abs(Thres)) then
        Do Iter = 1, MaxIter
          If (nConf == 1) Then
            Do iState = 1, nState
              VecCIT(1,iState) = One
            End Do
            Exit
          End If
          !! Compute Ap
          !! ipS2 is used as a workind array
          Call TimesE2(1,VecCId,VecS1,INT1,INT2)

          !! AlphaC = p^T*A*p
          AlphaC= DDot_(nConf*nState,VecS1,1,VecCId,1)
          !! Alpha = r^T*z / AlphaC
          Alpha = Delta/(AlphaC)
          ! new x of CI
          VecCIT(1:nConf,1:nState) = VecCIT(1:nConf,1:nState)
     &      + Alpha*VecCId(1:nConf,1:nState)
          ! new r of CI
          VecST(1:nConf,1:nState) = VecST(1:nConf,1:nState)
     &      - Alpha*VecS1(1:nConf,1:nState)
          ResCI = sqrt(DDot_(nConf*nState,VecST,1,VecST,1))
          !! z = M^{-1}*r
          VecS2(1:nConf,1:nState) = VecST(1:nConf,1:nState)
          Call DoPrec(VecST,VecS2,VecS1,VecPre,VecFancy)

          !! Append new vectors
          DeltaC= Ddot_(nConf*nState,VecST,1,VecS2,1)
          Beta  = DeltaC/Delta
          Delta = DeltaC
          VecCId(1:nConf,1:nState)
     &      = Beta*VecCId(1:nConf,1:nState) + VecS2(1:nConf,1:nState)

          If (IPRGLB >= VERBOSE)
     &    Write(u6,'(I7,4X,ES17.9,ES17.9,ES17.9)')
     &           iter,delta/delta0,resci,deltac

          Res = ResCI
          If (Res <= Abs(Thres)) Exit
        End Do

        If (Iter == MaxIter+1) Then
          write(u6,*)
     &    'CI iteration for non-invariant CASPT2 did not converge...'
          call abend()
        End If
      end if

      If (IPRGLB >= VERBOSE) Then
        CALL TIMING(CPTF1,CPE,TIOTF1,TIOE)
        CPUT =CPTF1-CPTF0
        WALLT=TIOTF1-TIOTF0
        Write (u6,*)
        Write (u6,'(3X,"Linear equation converged in ",I3," steps")')
     &         iter-1
        Write (u6,'(3X,"CPU and wall time (in s) = ",2F8.2)') CPUT,WALLT
        Write (u6,*)
      End If

      If (IFXMS .OR. IFRMS) Then
        !! Transform back the CLag from CAS to XMS
        Call DGEMM_('N','N',NConf,nState,nState,
     &              One,CLag,nConf,U0,nState,
     &              Zero,VecST,nConf)
        CLag(1:nConf,1:nState) = VecST(1:nConf,1:nState)
      End If

      call mma_deallocate(VecS1)
      call mma_deallocate(VecS2)
      call mma_deallocate(VecCId)
!     call mma_deallocate(VecS)
      call mma_deallocate(VecPre)
      call mma_deallocate(VecFancy)
!
!     ----- Construct (a part of) the true active density -----
!     Compute the second term in Eq. (70) = Eq. (72)
!     The SCF, not XMS, basis is used
!
      ID = IDCIEX !! idtcex?
      Do iState = 1, nState
        If (ISCF == 0) Then
          If (IFXMS .OR. IFRMS) THen
            !! Use unrotated (SCF) CI vector
            Call LoadCI_XMS('C',1,VecST(1,iState),iState,U0)
          Else
            Call DDaFile(LUCIEX,2,VecST(1,iState),nConf,ID)
          End If
        Else
          VecST(1,iState) = One
        End If
      End Do
      call mma_allocate(G2,nAshT**4,Label='G2')
      Call CnstInt(1,INT1,INT2)
      Call CnstDEPSA(VecST,VecCIT,INT1,G2,INT2)
      call mma_deallocate(G2)

      If (IPRGLB >= VERBOSE) Then
        CALL TIMING(CPTF2,CPE,TIOTF2,TIOE)
        CPUT =CPTF2-CPTF1
        WALLT=TIOTF2-TIOTF1
        Write (u6,'(3X,"Off-diagonal density is constructed")')
        Write (u6,'(3X,"CPU and wall time (in s) = ",2F8.2)') CPUT,WALLT
        Write (u6,*)
      End If

      call mma_deallocate(VecST)
      call mma_deallocate(VecCIT)
      call mma_deallocate(INT1)
      call mma_deallocate(INT2)
      call mma_deallocate(Eact)

      Contains
!
!-----------------------------------------------------------------------
!
      Subroutine CLagFinalOffC(SLag)

      use caspt2_module, only: REFENE

      implicit none

      real(kind=wp), intent(inout) :: SLag(*)
      real(kind=wp), allocatable :: CI1(:), CI2(:)

      integer(kind=iwp) :: ijst, ilStat, jlStat
      real(kind=wp) :: Scal, Ovl
      real(kind=wp), external :: DDot_
!
!     Orthogonalize the partial derivative with respect to CI coeff
!
      call mma_allocate(VecST,nConf,nState,Label='VecST')
      Call DGEMM_('N','T',nConf,nState,nState,
     &            One,CLag,nConf,U0,nState,
     &            Zero,VecST,nConf)
      CLag(1:nConf,1:nState) = VecST(1:nConf,1:nState)

      call mma_allocate(CI1,nConf,Label='CI1')
      call mma_allocate(CI2,nConf,Label='CI2')

      !! Construct SLag
      ijst = 0
      do ilStat = 1, nState
        If (ISCF == 0) Then
          Call LoadCI_XMS('C',1,CI1,ilStat,U0)
        Else
          CI1(1) = One
        End If
        Do jlStat = 1, ilStat !! -1
          ijst = ilStat + nState*(jlStat-1)
          If (ilStat == jlStat) Cycle
          If (ISCF == 0) Then
            Call LoadCI_XMS('C',1,CI2,jlStat,U0)
          Else
            CI2(1) = One
          End If
          Scal = DDOT_(nConf,CI1,1,CLag(1,jlStat),1)
     &         - DDOT_(nConf,CI2,1,CLag(1,ilStat),1)
          Scal = Scal/(REFENE(jlStat)-REFENE(ilStat))
          SLag(ijst) = SLag(ijst) + Scal
          IF (IPRGLB >= VERBOSE) THEN
            write(u6,'(1x,"SLag for State ",i1,"-",i1," = ",f20.10)')
     &         ilstat,jlstat,slag(ijst)
          END IF
        end do
      end do

      !! Projection
      Do ilStat = 1, nState
        CI1(1:nConf) = CLag(1:nConf,ilStat)
        Do jlStat = 1, nState
          If (ISCF == 0) Then
            Call LoadCI_XMS('C',1,CI2,jlStat,U0)
          Else
            CI2(1) = One
          End If
          Ovl = DDot_(nConf,CI1,1,CI2,1)
          CLag(1:nConf,ilStat) = CLag(1:nConf,ilStat) - Ovl*CI2(1:nConf)
        End Do
      End Do

      Call DGEMM_('N','N',nConf,nState,nState,
     &            One,CLag,nConf,U0,nState,
     &            Zero,VecST,nConf)
      CLag(1:nConf,1:nState) = VecST(1:nConf,1:nState)

      call mma_deallocate(CI1)
      call mma_deallocate(CI2)
      call mma_deallocate(VecST)

      Return

      End Subroutine CLagFinalOffC
!
!-----------------------------------------------------------------------
!
      Subroutine CnstInt(Mode,INT1,INT2)

      Use CHOVEC_IO, only: NVLOC_CHOBATCH
      use caspt2_module, only: IfChol, NFRO, NBAS

      implicit none

      integer(kind=iwp), intent(in) :: Mode
      real(kind=wp), intent(inout) :: INT1(nAshT,nAshT),
     &                                INT2(nAshT,nAshT,nAshT,nAshT)

      integer(kind=iwp),allocatable :: BGRP(:,:)
      real(kind=wp),allocatable :: KET(:)

      integer(kind=iwp), parameter :: Inactive=1, Active=2, Virtual=3
      integer(kind=iwp) :: nFroI, nIshI, nCorI, nBasI, iAshI,
     &  jAshI, iSymA, iSymI, iSymB, iSymJ, JSYM, IB, IB1, IB2, MXBGRP,
     &  IBGRP, NBGRP, NCHOBUF, MXPIQK, NADDBUF, IBSTA, IBEND, NV, nKET,
     &  kAshI, lAshI, iT, iU, iTU, iV, iX, iVX, iOrb, jOrb
!     integer(kind=iwp) :: nSh(8,3)
      real(kind=wp) :: Val

      INT1(:,:) = Zero
      Int2(:,:,:,:) = Zero

      nFroI = nFro(iSym)
      nIshI = nIsh(iSym)
      nCorI = nFroI+nIshI
      nBasI = nBas(iSym)
!
!     --- One-Electron Integral
!
      !! Read H_{\mu \nu}
!     IRC=-1
!     IOPT=6
!     ICOMP=1
!     ISYLBL=1
!     CALL RDONE(IRC,IOPT,'OneHam  ',ICOMP,WRK2,ISYLBL)
!     !! triangular -> square transformation
!     Call Square(WRK2,WRK1,1,nBasT,nBasT)
!     !! AO -> MO transformation
!     Call DGemm_('T','N',nBasT,nBasT,nBasT,
!    *            One,CMOPT2,nBasT,WRK1,nBasT,
!    *            Zero,WRK2,nBasT)
!     Call DGemm_('N','N',nBasT,nBasT,nBasT,
!    *            One,WRK2,nBasT,CMOPT2,nBasT,
!    *            Zero,WRK1,nBasT)
      !! Inactive energy
!     Do iCorI = 1, nFro(iSym)+nIsh(iSym)
!       RIn_Ene = RIn_Ene + Two*WRK1(iCorI,iCorI)
!     End Do
      !! Put in INT1
!     Do iAshI = 1, nAsh(iSym)
!       Do jAshI = 1, nAsh(iSym)
!         Val = WRK1(nCorI+iAshI,nCorI+jAshI)
!         INT1(iAshI,jAshI) = INT1(iAshI,jAshI) + Val
!       End Do
!     End Do
      Do iAshI = 1, nAsh(iSym)
        Do jAshI = 1, nAsh(iSym)
          Val = FIMO(nCorI+iAshI+nBasI*(nCorI+jAshI-1))
          INT1(iAshI,jAshI) = INT1(iAshI,jAshI) + Val
        End Do
      End Do
!
!     --- Two-Electron Integral
!
      iSymA = 1
      iSymI = 1
      iSymB = 1
      iSymJ = 1
!     If (.not.IfChol) Then
!       Do iCorI = 1, nFro(iSym)+nIsh(iSym)
!         iOrb = iCorI
!         jOrb = iCorI
!         Call Coul(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,WRK1,WRK2)
!         Do jCorI = 1, nFro(iSym)+nIsh(iSym)
!           RIn_Ene = RIn_Ene + Two*WRK1(jCorI,jCorI)
!         End Do
!         Call Exch(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,WRK1,WRK2)
!         Do jCorI = 1, nFro(iSym)+nIsh(iSym)
!           RIn_Ene = RIn_Ene - WRK1(jCorI,jCorI)
!         End Do
!       End Do
!     End If
!
      If (IfChol) Then
!       nSh(1:nSym,Inactive) = NISH(1:nSym)
!       nSh(1:nSym,Active  ) = NASH(1:nSym)
!       nSh(1:nSym,Virtual ) = NSSH(1:nSym)
        DO JSYM=1,NSYM
          IB1=NBTCHES(JSYM)+1
          IB2=NBTCHES(JSYM)+NBTCH(JSYM)

          MXBGRP=IB2-IB1+1
          IF (MXBGRP <= 0) CYCLE
          call mma_allocate(BGRP,2,MXBGRP,Label='BGRP')
          IBGRP=1
          DO IB=IB1,IB2
           BGRP(1,IBGRP)=IB
           BGRP(2,IBGRP)=IB
           IBGRP=IBGRP+1
          END DO
          NBGRP=MXBGRP

          CALL MEMORY_ESTIMATE(JSYM,BGRP,NBGRP,
     &                         NCHOBUF,MXPIQK,NADDBUF)
          call mma_allocate(KET,NCHOBUF,Label='KETBUF')
!         write(u6,*) 'nchobuf= ', nchobuf
!         write(u6,*) 'nbgrp= ', nbgrp
!         write(u6,*) 'nbtch= ', nbtch(jsym)
          Do IBGRP=1,NBGRP

            IBSTA=BGRP(1,IBGRP)
            IBEND=BGRP(2,IBGRP)
!           write(u6,*) ibsta,ibend

            NV=0
            DO IB=IBSTA,IBEND
              NV=NV+NVLOC_CHOBATCH(IB)
            END DO

            !! int2(tuvx) = (tu|vx)/2
            !! This can be computed without frozen orbitals
            Call Get_Cholesky_Vectors(Active,Active,JSYM,
     &                                KET,nKet,
     &                                IBSTA,IBEND)

            Call DGEMM_('N','T',NASH(JSYM)**2,NASH(JSYM)**2,NV,
     &                  Half,KET,NASH(JSYM)**2,
     &                       KET,NASH(JSYM)**2,
     &                  Zero,INT2,NASH(JSYM)**2)
          End Do
          call mma_deallocate(KET)
          call mma_deallocate(BGRP)
        End Do
      Else
        Do iAshI = 1, nAsh(iSym)
          iOrb = nCorI+iAshI
          Do jAshI = 1, nAsh(iSym)
            jOrb = nCorI+jAshI

            Call Coul(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,WRK1,WRK2)
            !! Put in INT1
!           Do iCorI = 1, nFro(iSym)+nIsh(iSym)
!             INT1(iAshI,jAshI) = INT1(iAshI,jAshI)
!    *          + Two*WRK1(iCorI,iCorI)
!           End Do
            !! Put in INT2
            Do kAshI = 1, nAsh(iSym)
              Do lAshI = 1, nAsh(iSym)
                INT2(iAshI,jAshI,kAshI,lAshI)
     &        = INT2(iAshI,jAshI,kAshI,lAshI)
     &        + WRK1(nCorI+kAshI,nCorI+lAshI)*Half
              End Do
            End Do

!           Call Exch(iSymA,iSymI,iSymB,iSymJ,iOrb,jOrb,WRK1,WRK2)
            !! Put in INT1
!           Do iCorI = 1, nFro(iSym)+nIsh(iSym)
!             INT1(iAshI,jAshI) = INT1(iAshI,jAshI) - WRK1(iCorI,iCorI)
!           End Do
          End Do
        End Do
      End If
#ifdef _MOLCAS_MPP_
      call GADSUM(INT2,nAshT**4)
#endif
!     write(u6,*) 'int2'
!     call sqprt(int2,25)
!     call sqprt(int1,5)
!     call sqprt(fimo,12)
      If (Mode == 0) Then
      Do IT = 1, nAshT
        Do iU = 1, nAshT
          iTU = iT + nAshT*(iU-1)
          Do iV = 1, nAshT
            Do iX = 1, nAshT
              iVX = iV + nAshT*(iX-1)
              If (iVX > iTU) Then
               INT2(iT,iU,iV,IX) = INT2(iT,iU,iV,iX) + INT2(iV,iX,iT,iU)
               INT2(iV,iX,iT,iU) = Zero
              End If
            End Do
          End Do
        End Do
      End Do
      End If

      if (mode == 0 .or. mode == 1) then
      Do IT = 1, nAshT
        Do iU = 1, nAshT
          Do iX = 1, nAshT
            INT1(IT,IU) = INT1(IT,IU) - INT2(IT,IX,IX,IU)
          End Do
        End Do
      End Do
      endif

      Return

      End Subroutine CnstInt
!
!-----------------------------------------------------------------------
!
      !! dens2_rpt2.f
      Subroutine TimesE2(Mode,CIin,CIout,INT1,INT2)

      use gugx, only: SGS, L2ACT, CIS
      use Constants, only: Two

      implicit none

      integer(kind=iwp), intent(in) :: Mode
      real(kind=wp), intent(in) :: CIin(nConf,nState),
     &  INT1(nAshT,nAshT), INT2(nAshT,nAshT,nAshT,nAshT)
      real(kind=wp), intent(out) :: CIout(nConf,nState)

      logical(kind=iwp), external :: RSV_TSK
      real(kind=wp), allocatable :: SGM1(:), SGM2(:)
      integer(kind=iwp), allocatable :: TASK(:,:)

      integer(kind=iwp) :: nLev, nTasks, iTask, LT, LU, kState, IST,
     &  IT, ISU, IU, ISTU, ISSG, NSGM, LVX, LV, ISV, IV, LX, ISX, ISVX,
     &  IX, ilStat, jlStat
      real(kind=wp) :: Ovl

      nLev=SGS%nLev
      ! logical tras,uras,vras,xras
!
!     --- H_{IJ}*P_J
!    <CI1|EtuEvx|CI2>=<CI1|Evx
!
      nTasks = nLev**2
      CALL mma_allocate (Task,nTasks,2,Label='TASK')

      iTask=0
      DO LT=1,nLev
        DO LU=1,nLev
          iTask=iTask+1
          TASK(iTask,1)=LT
          TASK(iTask,2)=LU
        ENDDO
      ENDDO
      IF (iTask /= nTasks) WRITE(u6,*) 'ERROR nTasks'

      call mma_allocate(SGM1,nConf,Label='SGM1')
      call mma_allocate(SGM2,nConf,Label='SGM2')

      CIout(1:nConf,1:nState) = Zero
      Do kState = 1, nState
        !! Start the actual part of dens2_rpt2
        Call Init_Tsk(ID, nTasks)

        do while (Rsv_Tsk(ID,iTask))
          LT=TASK(iTask,1)
          ! tras=.false.
          ! if (lt <= nras1(1)) tras=.true.
          IST=SGS%ISM(LT)
          IT=L2ACT(LT)
          LU=Task(iTask,2)
          ! uras=.false.
          ! if (lu > nras1(1)+nras2(1)) uras=.true.
!         if (tras.and.uras) cycle
          ! LTU=iTask
          ISU=SGS%ISM(LU)
          IU=L2ACT(LU)
          ISTU=Mul(IST,ISU)
          ISSG=Mul(ISTU,STSYM)
          NSGM=CIS%NCSF(ISSG)
          IF(NSGM == 0) cycle
          !! <CIin|Etu
          CALL GETSGM2(LU,LT,STSYM,CIin(1,kState),SGM1)
          IF(ISTU == 1) THEN
            !! <CIin|Etu|CIout>*I1tu
            CIout(1:NSGM,kState) = CIout(1:NSGM,kState)
     &        + INT1(IT,IU)*SGM1(1:NSGM)
          END IF
          LVX=0
          DO LV=1,NLEV
            ISV=SGS%ISM(LV)
            IV=L2ACT(LV)
            ! vras=.false.
            ! if (lv <= nras1(1)) vras=.true.
            DO LX=1,NLEV
              LVX=LVX+1
              ISX=SGS%ISM(LX)
              ISVX=Mul(ISV,ISX)
              ! xras=.false.
              ! if (lx > nras1(1)+nras2(1)) xras=.true.
!             if (vras.and.xras) cycle
              IF (ISVX /= ISTU) cycle
              IX=L2ACT(LX)
              CALL GETSGM2(LX,LV,ISSG,SGM1,SGM2)
              CIout(1:NSGM,kState) = CIout(1:NSGM,kState)
     &          + INT2(IT,IU,IV,IX)*SGM2(1:NSGM)
            END DO
          END DO
        end do
        CALL Free_Tsk(ID)
        !! End the actual part of dens2_rpt2
      End Do

      call mma_deallocate(Task)

#ifdef _MOLCAS_MPP_
      CALL GAdSUM(CIout,nConf*nState)
#endif
!
!     --- -E_{S}*CJ + zL_{KL}
!
      Do kState = 1, nState
        CIout(1:nConf,kState)
     &    = CIout(1:nConf,kState) + Eact(kState)*CIin(1:nConf,kState)
      End Do

      !! Project out the reference vector, just in case
      If (Mode == 1) Then
        Do ilStat = 1, nState
          SGM1(1:nConf) = CIout(1:nConf,ilStat)
          Do jlStat = 1, nState
            Call LoadCI_XMS('C',1,SGM2,jlStat,U0)
            Ovl = DDot_(nConf,SGM1,1,SGM2,1)
            CIout(1:nConf,ilStat)
     &        = CIout(1:nConf,ilStat) - Ovl*SGM2(1:nConf)
          End Do
        End Do
      End If

      call mma_deallocate(SGM1)
      call mma_deallocate(SGM2)

      CIout(1:nConf,1:nState) = Two/nState*CIout(1:nConf,1:nState)

      Return

      End Subroutine TimesE2
!
!-----------------------------------------------------------------------
!
      Subroutine CnstDEPSA(CI,CIT,G1,G2,INT2)

      use gugx, only: SGS
      use pt2_guga, only: NG1, NG2

      implicit none

      real(kind=wp), intent(in) :: CI(nConf,nState), CIT(nConf,nState),
     &  INT2(nAshT,nAshT,nAshT,nAshT)
      real(kind=wp), intent(out) :: G1(nAshT,nAshT),
     &  G2(nAshT,nAshT,nAshT,nAshT)

      real(kind=wp),allocatable :: SGM1(:),SGM2(:),G1T(:),G2T(:),
     &                             Fock(:),FockOut(:)
      integer(kind=iwp) :: nLev, kState, ilState, jlState, iS, jS, iA,
     &  jA, ip1, ip2, ipS, ijS, kS, lS, kAsh, kAA, lAsh, lAA, iAsh, ipQ,
     &  jAsh, ipM, imo, iOrb, jOrb
      real(kind=wp) :: Wgt, vSLag, rd, EigI, EigJ, OLagIJ, Tmp

      nLev=SGS%nLev
!
!     LOGICAL   RSV_TSK
!
!     This subroutine computes the second term in Eq. (70) or the RHS of
!     Eq. (72) in the CASPT2-IPEA gradient paper
!     CIT corresponds to \overline{Q}, if I remember correctly
!
      G1(:,:) = Zero
      G2(:,:,:,:) = Zero

      !! Construct transition(?) density matrix
      !! (<CI|Etu|CIT>+<CIT|Etu|CI>)/2, where CIT is the solution
      call mma_allocate(SGM1,nConf,Label='SGM1')
      call mma_allocate(SGM2,nConf,Label='SGM2')
      call mma_allocate(G1T,NG1,Label='GT1')
      call mma_allocate(G2T,NG2,Label='GT2')
!
!  !! This is for CASSCF orbital Lagrangian, but this may not contribute
!     Call Dens2T_RPT2(CI(1,jState),CI(1,jState),
!    *                 SGM1,SGM2,G1T,G2T,nLev)
!     Call DaXpY_(NG1,-Half,G1T,1,G1,1)
!     Call DaXpY_(NG2,-Half,G2T,1,G2,1)
!
      Do kState = 1, nState
!       Wgt = DWgt(iState,iState)
        Wgt = One/nState

        !! <CI|Etu|CIT>+<CIT|Etu|CI> and the t+ u+ x v variant
        Call Dens2T_RPT2(CI(1,kState),CIT(1,kState),
     &                   SGM1,SGM2,G1T,G2T,nLev)
        Call DaXpY_(NG1,WGT,G1T,1,G1,1)
        Call DaXpY_(NG2,WGT,G2T,1,G2,1)

        !! For the orbital contribution of CASSCF Lagrangian
        !! Just add the SLag rotation contributions
        ilState = kState
        Do jlState = 1, ilState-1
          vSLag = -Half*SLag(ilState,jlState)
          If (abs(vSLag) <= 1.0e-08_wp) Cycle
          Call Dens2T_RPT2(CI(1,ilState),CI(1,jlState),
     &                     SGM1,SGM2,G1T,G2T,nLev)
          Call DaXpY_(NG1,vSLag,G1T,1,G1,1)
          Call DaXpY_(NG2,vSLag,G2T,1,G2,1)
        End Do
      End Do

      call mma_deallocate(SGM1)
      call mma_deallocate(SGM2)
      call mma_deallocate(G1T)
      call mma_deallocate(G2T)

      !! Finally, construct the Fock matrix only for active-active
      !! Should be equivalent to FockGen in MCLR
      call mma_allocate(Fock,nAshT**2,Label='Fock')
      Fock(:) = Zero

      !! 1) FIMO term
      Do iS=1,nSym
        If (nBas(iS) > 0) Then
          jS=iEOr(is-1,iSym-1)+1
          Do iA=1,nAsh(is)
            Do jA=1,nAsh(js)
!             rd=rDens1(iA+nA(iS),jA+nA(js))
!             ip1=nBas(iS)*(nIsh(is)+iA-1)+ipCM(is)-1
!             ip2=nBas(iS)*(nIsh(js)+jA-1) +ipmat(is,js)
              rd=G1(iA,jA)
              ip1= 1+nFro(jS)+nIsh(jS)
     &           + nBas(iS)*(nFro(iS)+nIsh(iS)+iA-1)
              ip2=1+nAsh(iS)*(jA-1)
              Call DaXpY_(nAsh(iS),Rd,FIMO(ip1),1,Fock(ip2),1)
            End Do
          End Do
        End If
      End Do
!     write(6,*) 'after 1'
!     call sqprt(fock,nasht)

      !! 2) two-electron term (only CreQADD part)
      Do iS=1,nSym
        ipS=iEOr(is-1,isym-1)+1
        if (norb(ips) /= 0) Then
          Do jS=1,nsym
            ijS=iEOR(is-1,js-1)+1
            Do kS=1,nSym
              ls=iEOr(ijs-1,iEor(ks-1,isym-1))+1
*                                                                      *
************************************************************************
*                                                                      *
               Do kAsh=1,nAsh(kS)
                kAA=kAsh+nFro(kS)+nIsh(kS)
                Do lAsh=1,nAsh(lS)
                  lAA=lAsh+nFro(lS)+nIsh(lS)
*
*                 Pick up (pj|kl)
*
                  Call Coul(ipS,jS,kS,lS,kAA,lAA,WRK1,WRK2)
*
                  Do iAsh=1,nAsh(iS)
                    ipQ=nAsh(ipS)*(iAsh-1)
                    Do jAsh=1,nAsh(jS)
                      ipM=nFro(ipS)+nIsh(ipS)
     &                   +(nFro(jS)+nIsh(jS)+jAsh-1)*nBas(ipS)
                      Call DaXpY_(nAsh(ipS),G2(iAsh,jAsh,kAsh,lAsh)*2,
     &                            INT2(1,jAsh,kAsh,lAsh),1,
     &                            Fock(1+ipQ),1)
                      ipM=ipM+nOrb(ipS)
*
                    End Do
                  End Do
*
                End Do
              End Do
*                                                                      *
************************************************************************
*                                                                      *
            End Do  ! kS
          End Do     ! jS
        End If
      End Do           ! iS

      !! 3) anti-symmetrize
      !! 4) Divide by the difference of orbital energies
      call mma_allocate(FockOut,nAshT**2,Label='FockOut')
      Do iS=1,nSym
        jS=iEOR(iS-1,iSym-1)+1
        If (nAsh(is)*nAsh(jS) /= 0) Then
          !! Anti-symmetrize
          Call DGeSub(Fock,nAsh(iS),'N',
     &                Fock,nAsh(jS),'T',
     &                FockOut,nAsh(iS),
     &                nAsh(iS),nAsh(jS))


          !! Divide
          imo=1
          Do iAsh = 1, nAsh(iSym)
            iOrb = iAsh + nFro(iSym) + nIsh(iSym)
            EigI = FIFA(iMO+iOrb-1+nBas(iSym)*(iOrb-1))
            Do jAsh = 1, iAsh-1
              jOrb = jAsh + nFro(iSym) + nIsh(iSym)
              EigJ = FIFA(iMO+jOrb-1+nBas(iSym)*(jOrb-1))
              OLagIJ = FockOut(iAsh+nAsh(iSym)*(jAsh-1))
              Tmp = OLagIJ/(EigI-EigJ)
              DEPSA(iAsh,jAsh) = DEPSA(iAsh,jAsh) + Tmp
              DEPSA(jAsh,iAsh) = DEPSA(jAsh,iAsh) + Tmp
            End Do
          End Do
        End If
      End Do

      call mma_deallocate(FockOut)
      call mma_deallocate(Fock)

      Return

      End Subroutine CnstDEPSA
!
!-----------------------------------------------------------------------
!
      !! PRWF1_CP2
      SUBROUTINE CnstPrec(ISYCI,PRE,CI,INT1,INT2,Fancy,nLev,nMidV)
      use gugx, only: SGS, CIS, MXLEV
      use Constants, only: Two, Four
      use caspt2_module, only: NROOTS

      implicit none

#include "intent.fh"

      integer(kind=iwp), INTENT(IN) :: nLev, nMidV
      real(kind=wp), intent(in) ::  CI(*), INT1(NLEV,NLEV),
     &  INT2(NLEV,NLEV,NLEV,NLEV)
      integer(kind=iwp), intent(in) :: ISYCI
      real(kind=wp), intent(_OUT_) :: PRE(*)
      real(kind=wp), intent(out) :: Fancy(nRoots,nRoots,nRoots)

      real(kind=wp) ::  ICS(MXLEV), val, val2, Ene, dnum
      integer(kind=iwp) :: nIpWlk, LENCSF, ISY, LEV, MV, ISYUP, NCI,
     &  NUP, ISYDWN, NDWN, ICONF, IUW0, IDW0, IDWN, IUP, ICDPOS, ICDWN,
     &  NNN, IC1, ICUP, K, IDWNSV, ICUPOS, LEV2, iSt, jSt, kSt

      nIpWlk = CIS%nIpWlk
!
!     Construct (approximate?) preconditioner for the active linear
!     equation that should be solved for non-invariant CASPT2 methods
!     (with IPEA shift)
!
! -- NOTE: THIS PRWF ROUTINE USES THE CONVENTION THAT CI BLOCKS
! -- ARE MATRICES CI(I,J), WHERE THE   F I R S T   INDEX I REFERS TO
! -- THE   U P P E R   PART OF THE WALK.

! SVC: set up a CSF string length as LENCSF
!     LINE=' '
      LENCSF=0
      ISY=0
      DO LEV=1,NLEV
        IF(ISY /= SGS%ISM(LEV)) THEN
          ISY=SGS%ISM(LEV)
          LENCSF=LENCSF+1
        END IF
        LENCSF=LENCSF+1
      END DO
      LENCSF=MIN(LENCSF,256)
      LENCSF=MAX(LENCSF,10)

!     LINE=' '

! -- THE MAIN LOOP IS OVER BLOCKS OF THE ARRAY CI
!    WITH SPECIFIED MIDVERTEX MV, AND UPPERWALK SYMMETRY ISYUP.
      DO MV=1,NMIDV
        DO ISYUP=1,NSYM
          NCI=CIS%NOCSF(ISYUP,MV,ISYCI)
          IF(NCI == 0) cycle
          NUP=CIS%NOW(1,ISYUP,MV)
          ISYDWN=Mul(ISYUP,ISYCI)
          NDWN=CIS%NOW(2,ISYDWN,MV)
          ICONF=CIS%IOCSF(ISYUP,MV,ISYCI)
          IUW0=1-NIPWLK+CIS%IOW(1,ISYUP,MV)
          IDW0=1-NIPWLK+CIS%IOW(2,ISYDWN,MV)
          IDWNSV=0
          DO IDWN=1,NDWN
            DO IUP=1,NUP
              ICONF=ICONF+1
!             COEF=CI(ICONF)
! -- SKIP OR PRINT IT OUT?
!             IF(ABS(COEF) < THR) cycle
              IF(IDWNSV /= IDWN) THEN
                ICDPOS=IDW0+IDWN*NIPWLK
                ICDWN=CIS%ICASE(ICDPOS)
! -- UNPACK LOWER WALK.
                NNN=0
                DO LEV=1,SGS%MIDLEV
                  NNN=NNN+1
                  IF(NNN == 16) THEN
                    NNN=1
                    ICDPOS=ICDPOS+1
                    ICDWN=CIS%ICASE(ICDPOS)
                  END IF
                  IC1=ICDWN/4
                  ICS(LEV)=ICDWN-4*IC1
                  ICDWN=IC1
                END DO
                IDWNSV=IDWN
              END IF
              ICUPOS=IUW0+NIPWLK*IUP
              ICUP=CIS%ICASE(ICUPOS)
! -- UNPACK UPPER WALK:
              NNN=0
              DO LEV=SGS%MIDLEV+1,NLEV
                NNN=NNN+1
                IF(NNN == 16) THEN
                  NNN=1
                  ICUPOS=ICUPOS+1
                  ICUP=CIS%ICASE(ICUPOS)
                END IF
                IC1=ICUP/4
                ICS(LEV)=ICUP-4*IC1
                ICUP=IC1
              END DO
! -- PRINT IT!
              K=0
              ISY=0
              PRE(ICONF) = Zero
              DO LEV=1,NLEV
                IF(ISY /= SGS%ISM(LEV)) THEN
                  ISY=SGS%ISM(LEV)
                  K=K+1
!                 LINE(K:K)=' '
                END IF
                K=K+1
!               LINE(K:K)=CODE(ICS(LEV))
                IF (ICS(LEV) == 0) THEN
                  VAL = Zero
                ELSE IF (ICS(LEV) == 3) THEN
                  VAL = Two*INT1(LEV,LEV)
!                 L=0
!                 JSY=0
                  DO LEV2=1,NLEV
                    IF (ICS(LEV2) == 0) THEN
                    ELSE IF ((LEV == LEV2 .AND. ICS(LEV2) == 3).OR.
     &                       (LEV /= LEV2 .AND. ICS(LEV2) == 1).OR.
     &                       (LEV /= LEV2 .AND. ICS(LEV2) == 2)) THEN
                      val2 =  Four*int2(lev,lev ,lev2,lev2)
     &                      - Two*int2(lev,lev2,lev ,lev2)
                      val = val + val2
                    ELSE IF (LEV /= LEV2 .AND. ICS(LEV2) == 3) THEN
                      val2 =  Four*int2(lev,lev ,lev2,lev2)
     &                      - Two*int2(lev,lev2,lev ,lev2)
                      val = val + val2
                    END IF
                  END DO
                ELSE
                  VAL = INT1(LEV,LEV)
!                 L=0
!                 JSY=0
                  DO LEV2=1,NLEV
                    IF (ICS(LEV2) == 0 .OR. LEV == LEV2) THEN
                    ELSE IF (ICS(LEV2) == 3) THEN
!      val2 =  Two*int2(lev,lev ,lev2,lev2)
!    *       - One*int2(lev,lev2,lev ,lev2)
!      val2 = Zero
!      val = val + val2*Half
                    ELSE
                      val2 = int2(lev,lev ,lev2,lev2)
     &                     + int2(lev,lev2,lev ,lev2)
                      if (ics(lev) == ics(lev2)) then
                      val2 = int2(lev,lev ,lev2,lev2)
     &                     - int2(lev,lev2,lev ,lev2)
                      end if
                      val = val + val2
                    END IF
                  END DO
                END IF
                PRE(ICONF) = PRE(ICONF) + VAL
              END DO
            end do
          end do
        end do
      end do

      !! mclr/sa_prec.f
      !! Prepare so-called fancy preconditioner
      Do iSt = 1, nRoots
        Ene = Eact(iSt)
        Do jSt = 1, nRoots
          Do kSt = 1, nRoots
            Fancy(jSt,kSt,iSt) = Zero
            Do iConf = 1, nConf
              dnum=PRE(iConf)+Ene
              dnum=Sign(Max(Abs(dnum),1.0e-16_wp),dnum)
              Fancy(jSt,kSt,iSt) = Fancy(jSt,kSt,iSt)
     &          + CI(iConf+nConf*(jSt-1))*CI(iConf+nConf*(kSt-1))/dnum
            End Do
          End Do
        End Do
        Call MatInvert(Fancy(1,1,iSt),nRoots)
      End Do

      RETURN

      END SUBROUTINE CnstPrec
!
!-----------------------------------------------------------------------
!
      !! mclr/dminvci_sa.f
      Subroutine DoPrec(VecIN,VecOUT,CI,Pre,Fancy)

      use caspt2_module, only: NROOTS
!
!     Apply precondition to CI vectors, taken from the MCLR module
!
      implicit none

      real(kind=wp), intent(in) :: VecIN(1:nConf,1:nRoots),
     &  Pre(1:nConf), Fancy(nRoots,nRoots,nRoots)
      real(kind=wp), intent(out) :: VecOUT(1:nConf,1:nRoots),
     &  CI(1:nConf,1:nRoots)

      integer(kind=iwp) :: iRoots, iConf, jRoots, kRoots
      real(kind=wp) :: rcoeff(nRoots), alpha(nRoots)

      !! Standard inverse of the diagonal elements
      Do iRoots = 1, nRoots
        Do iConf = 1, nConf
          VecOUT(iConf,iRoots)
     &      = VecIN(iConf,iRoots)/(Pre(iConf)+Eact(iRoots))
        End Do
      End Do

      !! Construct reference CI vectors
      Do iRoots = 1, nRoots
        Call LoadCI_XMS('C',1,CI(1,iRoots),iRoots,U0)
      End Do

      !! The so-called fancy precondioner
      Do iRoots = 1, nRoots
        Do jRoots = 1, nRoots
         rcoeff(jRoots) = DDot_(nconf,VecOUT(1,iRoots),1,CI(1,jRoots),1)
        End Do

        Do jRoots = 1, nRoots
          alpha(jRoots) = Zero
          Do kRoots = 1, nRoots
            alpha(jRoots) = alpha(jRoots)
     &        + Fancy(jRoots,kRoots,iRoots)*rcoeff(kRoots)
          End Do
        End Do

        Do jRoots = 1, nRoots
          Do iConf = 1, nConf
            VecOUT(iConf,iRoots) = VecOUT(iConf,iRoots)
     &        - CI(iConf,jRoots)*alpha(jRoots)/(Pre(iConf)+Eact(iRoots))
          End Do
        End Do
      End Do

      End Subroutine DoPrec

      End Subroutine DEPSAOffC
!
!-----------------------------------------------------------------------
!
      Subroutine DEPSAOffO(OLag,DEPSA,FIFA)

      use caspt2_module, only: NSYM, NFRO, NISH, NASH, NASHT, NDEL, NBAS
      use Constants, only: Half
      use definitions, only: wp, iwp

      implicit none

      real(kind=wp), intent(in) :: OLag(*), FIFA(*)
      real(kind=wp), intent(inout) :: DEPSA(nAshT,nAshT)

      integer(kind=iwp) :: iMO, iSym, nAshI, nOrbI, nFroI, nIshI, nBasI,
     &  iAsh, iOrb, jAsh, jOrb
      real(kind=wp) :: EigI, EigJ, OLagIJ, OLagJI, Tmp
!
!     This is much easier; similar to the frozen core approximation.
!     Corresponds to the first term in Eq. (70)
!
      iMO  = 1
      DO iSym = 1, nSym
        nAshI = nAsh(iSym)
        nOrbI = 0
        If (nAshI /= 0) Then
          nOrbI = nBas(iSym)-nDel(iSym)
          nFroI = nFro(iSym)
          nIshI = nIsh(iSym)
          nBasI = nBas(iSym)

          Do iAsh = 1, nAshI
            iOrb = iAsh + nFroI + nIshI
            EigI = FIFA(iMO+iOrb-1+nBasI*(iOrb-1))
            Do jAsh = 1, iAsh-1
              jOrb = jAsh + nFroI + nIshI
              EigJ = FIFA(iMO+jOrb-1+nBasI*(jOrb-1))
              OLagIJ = OLag(iMO+iOrb-1+nOrbI*(jOrb-1))
              OLagJI = OLag(iMO+jOrb-1+nOrbI*(iOrb-1))
              Tmp = -(OLagIJ-OLagJI)/(EigI-EigJ)*Half

              DEPSA(iAsh,jAsh) = DEPSA(iAsh,jAsh) + Tmp
              DEPSA(jAsh,iAsh) = DEPSA(jAsh,iAsh) + Tmp
            End Do
          End Do
        End If
        iMO  = iMO  + nOrbI*nOrbI
      End Do

      End Subroutine DEPSAOffO
!
!-----------------------------------------------------------------------
!
      Subroutine LinDepLag(BDer,SDer,nAS,nIN,iSym,iCase)

      use caspt2_global, only: LUSTD, idBoriMat
      use caspt2_global, only: LUSBT
      use EQSOLV, only: idSMAT
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: THRSHN, THRSHS, IFDORTHO
      use Constants, only: Zero, One, Two

      implicit none

      real(kind=wp), intent(inout) :: BDer(*), SDer(*)
      integer(kind=iwp), intent(in) :: nAS, nIN, iSym, iCase

      real(kind=wp) :: WGRONK(2)
      real(kind=wp),allocatable :: S(:),SS(:,:),VEC(:,:),EIG(:),SCA(:),
     &                             SCRATCH(:),LAG(:,:),B(:),F(:,:)

      integer(kind=iwp) :: NS, idS, IJ, I, J, IDIAG, INFO, NSCRATCH,
     &  IDB, NB
      real(kind=wp) :: SD, SCAL, EVAL, FACT
!
!     Compute contributions that arise from the non-invariance effect
!     in non-orthogonal -> orthogonal ICB rotations
!     See J. Chem. Phys. 2023, 158, 174112. for details, in particular,
!     Section II C 3 "Non-invariance with respect to orthogonal..."
!
      !! Obtain the X matrix
      !! First, read S
      NS = NAS*(NAS+1)/2
      call mma_allocate(S,NS,Label='S')
      call mma_allocate(SS,NAS,NAS,Label='SS')
      idS = idSMAT(iSym,iCase)
      CALL DDAFILE(LUSBT,2,S,NS,idS)
      IJ=0
      DO J=1,NAS
        DO I=1,J
          IJ=IJ+1
          SS(I,J)=S(IJ)
          SS(J,I)=S(IJ)
        END DO
      END DO

      call mma_allocate(VEC,NAS,NAS,Label='VEC')
      call mma_allocate(EIG,NAS,Label='EIG')
      call mma_allocate(SCA,NAS,Label='SCA')
      IDIAG=0
      DO I=1,NAS
        IDIAG=IDIAG+I
        SD=S(IDIAG)
        If (IFDORTHO) then
          SCA(I)=One
        Else
          IF(SD > THRSHN) THEN
* Small variations of the scale factor were beneficial
              SCA(I)=(One+real(I,kind=wp)*3.0e-6_wp)/SQRT(SD)
          ELSE
            SCA(I)=Zero
          END IF
        End If
      END DO
      IJ=0
      DO J=1,NAS
        DO I=1,J
          IJ=IJ+1
          S(IJ)=S(IJ)*SCA(I)*SCA(J)
        END DO
      END DO

      IJ=0
      DO J=1,NAS
        DO I=1,J
          IJ=IJ+1
          VEC(I,J)=S(IJ)
        END DO
      END DO
      INFO=0
      call dsyev_('V','L',NAS,VEC,NAS,EIG,WGRONK,-1,INFO)
      NSCRATCH=INT(WGRONK(1))
      call mma_allocate(SCRATCH,NSCRATCH,Label='SCRATCH')
      call dsyev_('V','U',NAS,VEC,NAS,EIG,SCRATCH,NSCRATCH,INFO)
      call mma_deallocate(SCRATCH)

      DO I=1,NAS
        SCAL=SCA(I)
        CALL DSCAL_(NAS,SCAL,VEC(I,1),NAS)
      END DO
      call mma_deallocate(SCA)
      call mma_deallocate(S)

      !! Scale only the independent vectors to avoid
      !! any numerically unstable computation
      DO I=1,NAS
        EVAL=EIG(I)
        IF(EVAL < THRSHS) CYCLE
        FACT=One/SQRT(EVAL)
        Call DScal_(nAS,FACT,VEC(1,I),1)
      END DO

      call mma_allocate(LAG,NAS,NAS,Label='LAG')
      IDB=IDBoriMat(ISYM,ICASE)
      NB=NS
      call mma_allocate(B,NB,Label='B')
      CALL DDAFILE(LUSTD,2,B,NB,IDB)
      call mma_allocate(F,NAS,NAS,Label='F')
      IJ=0
      DO J=1,NAS
        DO I=1,J
          IJ=IJ+1
          F(I,J)=B(IJ)
          F(J,I)=B(IJ)
        END DO
      END DO

      !! Compute the partial derivative
      !! F   : B
      !! BDER: D
      !! VEC : X^0 and X
      Call DGEMM_('N','T',NAS,NAS,NAS,
     &            Two,F,NAS,BDER,NAS,
     &            Zero,LAG,NAS)
      Call DGEMM_('N','N',NAS,NAS,NAS,
     &            One,LAG,NAS,VEC,NAS,
     &            Zero,F,NAS)
      LAG(1:NAS,1:NAS) = F(1:NAS,1:NAS)

      CALL DGEMM_('T','N',NAS,NAS,NAS,
     &            One,VEC,NAS,LAG,NAS,
     &            Zero,F,NAS)
      !! At this point,
      !! F = 2 \mathcal{X}^0 * B * D * \mathcal{X}

      !! remove dependent part
      !! (linearly indep-indep and dep-dep)
      F(1:nAS-nIN,1:nAS-nIN) = Zero
      F(nAS-nIN+1:nAS,nAS-nIN+1:nAS) = Zero

      !! orthogonal -> non-orthogonal
      !! Finalize Eq. (62)
      CALL DGEMM_('N','N',NAS,NAS,NAS,
     &            One,VEC,NAS,F,NAS,
     &            Zero,LAG,NAS)
      CALL DGEMM_('N','T',NAS,NAS,NAS,
     &            One,LAG,NAS,VEC,NAS,
     &            Zero,F,NAS)

      Call DaXpY_(nAS*nAS,One,F,1,SDER,1)

      call mma_deallocate(LAG)
      call mma_deallocate(B)
      call mma_deallocate(F)

      call mma_deallocate(SS)
      call mma_deallocate(EIG)
      call mma_deallocate(VEC)

      Return

      End Subroutine LinDepLag
!
!-----------------------------------------------------------------------
!
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      Subroutine LinDepLag_MPP(lg_BDER,lg_SDER,nAS,nIN,iSym,iCase)

      use caspt2_global, only: LUSTD, idBoriMat
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: THRSHS
      use Constants, only: Zero, One, Two
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
#endif

      implicit none

#include "global.fh"
#include "mafdecls.fh"

      integer(kind=iwp), intent(in) :: lg_BDER, lg_SDER, nAS, nIN, iSym,
     &  iCase

#if ! defined (_SCALAPACK_)
      real(kind=wp) :: WGRONK(2)
#endif
      logical(kind=iwp) :: bStat
      integer(kind=iwp) :: lg_S, myRank, lg_Vec, NSCRATCH, iLo, iHi,
     &  jLo, jHi, mV, LDV, I, lg_Lag, lg_B, IDB, mB, LDB, J, info
      real(kind=wp) :: EVAL, FACT
      real(kind=wp), allocatable :: EIG(:),VEC(:),SCRATCH(:)
!
!     Parallel LinDepLag
!     We always use the canonical orthonormalization.
!
      !! Obtain the X matrix
      !! First, read S
      CALL PSBMAT_GETMEM ('S',lg_S,NAS)
      CALL PSBMAT_READ ('S',iCase,iSym,lg_S,NAS)

      call mma_allocate(EIG,NAS,Label='EIG')
      EIG(:) = Zero

      myRank = GA_NodeID()
#ifdef _SCALAPACK_
      CALL PSBMAT_GETMEM('VMAT',lg_Vec,NAS)
      CALL GA_PDSYEVX_ (lg_S, lg_Vec, EIG, 0)
      bSTAT = GA_Destroy (lg_S)
#else
! here for the non-ScaLAPACK version: copy matrix to master process,
! diagonalize using the serial DSYEV routine, and copy the resulting
! eigenvectors back to a global array.  Then distribute the eigenvalues.
      IF (myRank == 0) THEN
        call mma_allocate(VEC,NAS*NAS,Label='VEC')
        CALL GA_Get (lg_S, 1, NAS, 1, NAS, VEC, NAS)
      END IF
      bSTAT = GA_Destroy (lg_S)
      IF (myRank == 0) THEN
        CALL DSYEV_('V','L',NAS,VEC,NAS,EIG,WGRONK,-1,INFO)
        NSCRATCH=INT(WGRONK(1))
        call mma_allocate(SCRATCH,NSCRATCH,Label='SCRATCH')
        CALL DSYEV_('V','L',NAS,VEC,NAS,EIG,SCRATCH,NSCRATCH,INFO)
        call mma_deallocate(SCRATCH)
      END IF
      CALL PSBMAT_GETMEM('VMAT',lg_Vec,NAS)
      IF (myRank == 0) THEN
        CALL GA_Put (lg_Vec, 1, NAS, 1, NAS, VEC, NAS)
        call mma_deallocate(VEC)
      END IF
      CALL GADSUM(EIG,NAS)
#endif

      !! Scale only the independent vectors to avoid
      !! any numerically unstable computation
! Form orthonormal transformation vectors by scaling the eigenvectors.
      call GA_Sync()
      call GA_Distribution (lg_Vec, myRank, iLo, iHi, jLo, jHi)
      IF (iLo /= 0) THEN
        call GA_Access (lg_Vec, iLo, iHi, jLo, jHi, mV, LDV)
        IF ((jHi-jLo+1) /= NAS) THEN
          WRITE(u6,*) 'SBDIAG_MPP: error in striping of lg_Vec, ABORT'
          CALL ABEND()
        END IF
        DO I=1,jHi-jLo+1 ! NAS
          EVAL=EIG(I)
          IF(EVAL < THRSHS) CYCLE
          FACT=One/SQRT(EVAL)
          Call DScal_(iHi-iLo+1,FACT,DBL_MB(mV+LDV*(I-1)),1)
        END DO
        call GA_Release_Update (lg_Vec, iLo, iHi, jLo, jHi)
      END IF
      call GA_Sync()

      call mma_deallocate(EIG)
!
!     X matrix has been prpeared
!
      CALL GA_CREATE_STRIPED ('H',NAS,NAS,'Lag',lg_Lag)
      CALL PSBMAT_GETMEM ('B',lg_B,NAS)

      call GA_Distribution (lg_B, myRank, iLo, iHi, jLo, jHi)
      call GA_Access (lg_B, iLo, iHi, jLo, jHi, mB, LDB)
      IDB=IDBoriMat(ISYM,ICASE)
      CALL DDAFILE(LUSTD,2,DBL_MB(mB),(iHi-iLo+1)*(jHi-jLo+1),IDB)
      call GA_Release_Update (lg_B, iLo, iHi, jLo, jHi)

      !! Compute the partial derivative
      !! Work(LF)  : B --> lg_B
      !! BDER      : D --> lg_BDER
      !! Work(LVEC): X^0 and X --> lg_Vec
      Call GA_DGEMM ('N','T',NAS,NAS,NAS,
     &               Two,lg_B,lg_BDER,
     &               Zero,lg_Lag)
      Call GA_DGEMM ('N','N',NAS,NAS,NAS,
     &               One,lg_Lag,lg_VEC,
     &               Zero,lg_B)
      Call GADupl(lg_B,lg_Lag)

      Call GA_DGEMM ('T','N',NAS,NAS,NAS,
     &               One,lg_Vec,lg_Lag,
     &               Zero,lg_B)
      !! At this point,
      !! Work(LF) = 2 \mathcal{X}^0 * B * D * \mathcal{X}

      !! remove dependent part
      !! (linearly indep-indep and dep-dep)
      call GA_Distribution (lg_B, myRank, iLo, iHi, jLo, jHi)
      if (iLo /= 0) then
        call GA_Access (lg_B, iLo, iHi, jLo, jHi, mV, LDV)
!       if (ilo <= nas-nin) then
          Do J = 1, nAS-nIN
            Do I = 1, min(iHi-iLo+1,nAS-nIN-iLo+1)
              DBL_MB(mV+i-1+LDV*(j-1)) = Zero
            End Do
          End Do
!       end if
!       if (ilo >= nas-nin+1) then
          Do J = nAS-nIN+1, nAS
            Do I = max(1,nAS-nIN+1-iLo+1), LDV
              DBL_MB(mV+i-1+LDV*(j-1)) = Zero
            End Do
          End Do
!       end if
        call GA_Release_Update (lg_B, iLo, iHi, jLo, jHi)
      end if

      !! orthogonal -> non-orthogonal
      !! Finalize Eq. (62)
      Call GA_DGEMM ('N','N',NAS,NAS,NAS,
     &               One,lg_Vec,lg_B,
     &               Zero,lg_Lag)
      Call GA_DGEMM ('N','T',NAS,NAS,NAS,
     &               One,lg_Lag,lg_Vec,
     &               One,lg_SDER)

      CALL PSBMAT_FREEMEM(lg_Vec)
      bSTAT = GA_Destroy (lg_Lag)
      CALL PSBMAT_FREEMEM (lg_B)

      Return

      End Subroutine LinDepLag_MPP
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Bernd Artur Hess                                 *
!***********************************************************************

subroutine VPBMBPV(EIGA,EIGB,REVTA,SINVA,SINVB,NA,NB,ISIZEA,AAA,AAB,RRA,RRB,PVA,VPA,ISYMA,ISYMB,BU2,G2,AUX2,CMM1,BU4,CMM2,PVAA, &
                   VPAA,SCPV,SCVP)
! $Id: vpbmbpv.r,v 1.4 1995/05/08 14:08:53 hess Exp $
! calculate relativistic operators
!   Bernd Artur Hess, hess@uni-bonn.de

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NA, NB, ISIZEA, ISYMA, ISYMB
real(kind=wp), intent(in) :: EIGA(NA,NA), EIGB(NB,NB), REVTA(NA,NA), SINVA(NA,NA), SINVB(NB,NB), AAA(NA), AAB(NB), RRA(NA), &
                             RRB(NB), PVAA(ISIZEA), VPAA(ISIZEA), SCPV(NB,NA), SCVP(NB,NA)
real(kind=wp), intent(inout) :: PVA(NA,NB), VPA(NA,NB), CMM2(NA,NB)
real(kind=wp), intent(out) :: BU2(NA,NB), G2(NA,NB), AUX2(NA,NB), CMM1(NA,NB), BU4(NA,NB)
integer(kind=iwp) :: I, IJ, J, K

if (iSyma == iSymb) then
  IJ = 0
  do I=1,NA
    do J=1,I
      IJ = IJ+1
      PVA(I,J) = PVAA(IJ)
      PVA(J,I) = -VPAA(IJ)
      VPA(I,J) = VPAA(IJ)
      VPA(J,I) = -PVAA(IJ)
    end do
  end do
else if (iSyma < iSymb) then
  do I=1,NA
    do J=1,NB
      PVA(I,J) = SCPV(J,I)
      VPA(I,J) = SCVP(J,I)
    end do
  end do
  CMM2(:,:) = Zero
end if

! TRANSFORM pV TO T-BASIS

call TrSmrN(PVA,SINVA,SINVB,G2,NA,NB,AUX2,CMM1)
call TrSmrN(G2,EIGA,EIGB,BU2,NA,NB,AUX2,CMM1)

G2(:,:) = Zero
Aux2(:,:) = Zero

! TRANSFORM Vp TO T-BASIS

call TrSmrN(VPA,SINVA,SINVB,G2,NA,NB,AUX2,CMM1)
call TrSmrN(G2,EIGA,EIGB,BU4,NA,NB,AUX2,CMM1)

G2(:,:) = Zero
Aux2(:,:) = Zero
Cmm1(:,:) = Zero

! Multiply

do I=1,NA
  do J=1,NB
    G2(I,J) = BU4(I,J)*RRB(J)
    CMM1(I,J) = -BU2(I,J)*RRA(I)
  end do
end do

!write(u6,*)
!write(u6,*) 'pV part of commutator MATRIX'
!write(u6,*)  G2
!write(u6,*)

!write(u6,*)
!write(u6,*) '-Vp part commutator MATRIX'
!write(u6,*)  CMM1
!write(u6,*)

! Calculate the commutator <iSymA|[V,pb]|iSymB> and put into CMM1

CMM1(:,:) = CMM1+G2

! Multiply BY A MATRIX

do I=1,NA
  do J=1,NB
    CMM1(I,J) = CMM1(I,J)*AAA(I)*AAB(J)
  end do
end do

! Multiply BY REVTA  MATRIX

do I=1,NA
  do J=1,NB
    do K=1,NA
      CMM2(I,J) = CMM2(I,J)+REVTA(I,K)*CMM1(K,J)
    end do
  end do
end do

Cmm1(:,:) = Zero

!write(u6,*)
!write(u6,*) 'CMM2  MATRX FINAL'
!write(u6,*)  CMM2
!write(u6,*)

!write(u6,*) 'END OF VPBMBPV !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'

return

end subroutine VPBMBPV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine Cho_P_UpdateBookmarks(iRS)
C
C     Thomas Bondo Pedersen, August 2012.
C
C     Update bookmarks for reduced set (integral pass) iRS:
C        - integral accuracy (max diagonal)
C        - number of Cholesky vectors
C
C     Note: it is assumed that array DiaMax and number of Cholesky
C     vectors are properly updated before calling this routine.
C
      Implicit None
      Integer iRS
#include "cho_para_info.fh"
#include "choglob.fh"
#include "chobkm.fh"
#include "cholesky.fh"
#include "WrkSpc.fh"

      If (l_BkmVec.lt.1 .or. l_BkmThr.lt.1) Return

      If (Cho_Real_Par) Then
         Call Cho_UpdateBookmarks(iRS,nSym,MaxRed,NumCho_G,DiaMaxT,
     &                            iWork(ip_BkmVec),Work(ip_BkmThr))
      Else
         Call Cho_UpdateBookmarks(iRS,nSym,MaxRed,NumCho,DiaMaxT,
     &                            iWork(ip_BkmVec),Work(ip_BkmThr))
      End If
      nCol_BkmVec=nCol_BkmVec+1
      nCol_BkmThr=nCol_BkmThr+1

      End
      Subroutine Cho_UpdateBookmarks(iRS,nSym,nRS,nVec,delta,nBkmVec,
     &                               BkmThr)
      Implicit None
      Integer iRS
      Integer nRS
      Integer nSym
      Integer nVec(nSym)
      Real*8  delta(nSym)
      Integer nBkmVec(nSym,nRS)
      Real*8  BkmThr(nSym,nRS)

      Integer iSym

      Do iSym=1,nSym
         nBkmVec(iSym,iRS)=nVec(iSym)
      End Do

      Do iSym=1,nSym
         BkmThr(iSym,iRS)=delta(iSym)
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
*  RDVEC
*
*> @brief
*>   A routine to read MO coefficients, occupation numbers, one-electron energies and type index information from ``INPORB`` file
*> @author V. Veryazov
*>
*> @details
*> New version of ::rdvec routine.
*> ::RDVEC is a wrapper to ::RDVEC_, which read UHF
*> information from ``INPORB`` file.
*>
*> \p Label defines the type of information to read from ``INPORB`` file
*> Valid targets are: ``C``---CMO, ``O``---OCC, ``E``---EORB, ``I``---INDT
*> ``A``---alpha values, ``B``---beta values
*>
*> ::RdVec checks that \p NBAS / \p NORB information is consistent,
*> and reacts according to \p iWarn. ``0``: No checks for \p NBAS / \p NORB;
*> ``1``: Print error message; ``2``: ::Abend.
*>
*> Example: Get CMO coeff. and OCC for RHF:
*>
*> \code
*> Call RdVec('INPORB',Lu,'CO',NSYM,NBAS,NBAS,CMO,OCC,Dummy,iDummy,Title,0,iErr)
*> \endcode
*>
*> @param[in]  Name  File name
*> @param[in]  LU_   Unit number
*> @param[in]  LABEL Task
*> @param[in]  NSYM  N symmetries
*> @param[in]  NBAS  N basis functions
*> @param[in]  NORB  N orbitals
*> @param[out] CMO   MO coefficients
*> @param[out] OCC   Occupations
*> @param[out] EORB  One electron energies
*> @param[out] INDT  Type Index information
*> @param[out] TITLE Title of orbitals
*> @param[in]  IWARN Warning level
*> @param[out] IERR  Return code
************************************************************************
      SUBROUTINE RDVEC(Name,LU_,LABEL,NSYM,NBAS,NORB,
     &   CMO, OCC, EORB, INDT,TITLE,iWarn,iErr)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NBAS(NSYM),NORB(NSYM),CMO(*),OCC(*), INDT(*), EORB(*)
      CHARACTER*(*) TITLE, Name, Label
      Dimension vDum(2)
      Call RdVec_(Name,LU_,LABEL,0,NSYM,NBAS,NORB,
     &   CMO,vDum, OCC, vDum, EORB, vDum,
     &   INDT,TITLE,iWarn,iErr,iWFtype)
       RETURN
       END

      SUBROUTINE RDVEC_(Name,LU_,LABEL,IUHF,NSYM,NBAS,NORB,
     &   CMO,CMO_ab, OCC, OCC_ab, EORB, EORB_ab,
     &   INDT,TITLE,iWarn,iErr,iWFtype)
* --------------------------------------------------------------------------------
*  Advanced RdVec (to remove all clones!)
* --------------------------------------------------------------------------------
* iWFtype =  0  -- Unknown origin of orbitals
*            1  -- Orbitals for Guessorb
*            2  -- Orbitals for closed shell HF
*            3  -- Orbitals for closed shell DFT
*            4  -- Orbitals for unrestricted HF
*            5  -- Orbitals for unrestricted DFT
*            6  -- Natural orbitals for unrestricted HF
*            7  -- Natural orbitals for unrestricted DFT
*            8  --
* --------------------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
      DIMENSION NBAS(NSYM),NORB(NSYM),CMO(*),OCC(*), INDT(*), EORB(*)
      DIMENSION CMO_ab(*),OCC_ab(*), EORB_ab(*)
      CHARACTER*(*) TITLE, Name, Label
      CHARACTER LINE*256,FMT*40
      LOGICAL Exist
      Character*7 Crypt, CryptUp
      Character*10 Buff
*
* Note! the size of Magic must be exact (thanks to MS formatted inporb!)
*
      Character*8 Location
      data Crypt   /'fi123sd'/
      DATA CryptUP /'FIXXXSD'/
#include "inporbfmt.fh"
      Location='rdVec_'
      Line='not defined yet'
*
* Analyze Label
*
      iCMO=0
      iOCC=0
      iEne=0
      iInd=0
      iBeta=0
      If(index(Label,'C').ne.0) iCMO=1
      If(index(Label,'O').ne.0) iOcc=1
      If(index(Label,'E').ne.0) iEne=1
      If(index(Label,'I').ne.0) iInd=1
      If(index(Label,'A').ne.0) iBeta=-1
      If(index(Label,'B').ne.0) iBeta=1
*----------------------------------------------------------------------*
* Open file Name                                                       *
*----------------------------------------------------------------------*
      iErr=0
      Lu=Lu_
      Call OpnFl(Name,Lu,Exist)
      If (.Not.Exist) Then
        Write(6,*) 'RdVec: File ',Name(1:index(Name,' ')),' not found!'
        Call Abend()
      End If
      REWIND (LU)
*----------------------------------------------------------------------*
* Check version!                                                       *
*----------------------------------------------------------------------*
      READ(LU,'(A256)',END=999,ERR=999) Line
      iVer=0
      Do jVer=1,mxVer
        if(Magic(jVer).eq.Line(1:len(Magic(jVer)))) iVer=jVer
      End Do

      If(iVer.eq.0) Then
        Call SysAbendMsg(Location,'INPORB file in old format',' ')
      End If
*----------------------------------------------------------------------*
* INFO section, read it unconditionally                                *
*----------------------------------------------------------------------*
50    READ(LU,'(A256)',END=999,ERR=999) Line
      If(Line(1:5).ne.'#INFO') goto 50
      Read(Lu,'(a)',end=999,err=999) Title
      Read(Lu,'(a)',End=999,Err=999) Line
      Line(76:80)='0 0 0'
      Read(Line,*) myiUHF,myNSYM,iWFtype
*     Read(Lu,*,end=999,err=999) myiUHF,myNSYM
* In case of UHF mismatch:
      If(myiUHF.ne.iUHF) Then
* Stop if UHF requested, but the INPORB is not UHF
        If(myiUHF.eq.0)
     &    Call SysAbendFileMsg(Location,Name,'IUHF does not match',' ')
* With a UHF INPORB, only go on if alpha or beta orbitals
* explicitly requested
        If(iUHF.eq.0.and.iBeta.eq.0)
     &    Call SysAbendFileMsg(Location,Name,'IUHF does not match',' ')
      End If
      If(myNSYM.ne.NSYM) Call SysAbendFileMsg(Location,Name,
     &   'NSYM does not match',' ')
      Call GetMem('MYNBAS','Allo','Inte',imyNBAS,NSYM)
      Call GetMem('MYNORB','Allo','Inte',imyNORB,NSYM)
      Read(Lu,*,end=999,err=999) (iWork(imyNBAS+i-1),i=1,NSYM)
      Read(Lu,*,end=999,err=999) (iWork(imyNORB+i-1),i=1,NSYM)
*----------------------------------------------------------------------*
* Do checks                                                            *
*----------------------------------------------------------------------*
        Do i=1,NSYM
          If(iWork(imyNBAS+i-1).ne.NBAS(i)) Then
            Line='NBAS does not match'
            If(iWarn.eq.1) Then
              Call SysWarnMsg(Location,Line,' ')
            Else
              Call SysAbendFileMsg(Location,Name,Line,' ')
            End If
          End If
        End Do
      If(iWarn.gt.0) Then
        Do i=1,NSYM
          If(iWork(imyNORB+i-1).lt.NORB(i)) Then
            Line='NORB does not match'
            If(iWarn.eq.1) Then
              Call SysWarnMsg(Location,Line,' ')
            Else
              Call SysAbendFileMsg(Location,Name,Line,' ')
            End If
          End If
        End Do
      End If
      Call GetMem('MYNBAS','Free','Inte',imyNBAS,NSYM)
*----------------------------------------------------------------------*
* ORB section                                                          *
*----------------------------------------------------------------------*
      If(iCMO.eq.1) Then
        nDiv = nDivOrb(iVer)
        FMT = FmtOrb(iVer)
        Rewind(LU)
51      READ(LU,'(A256)',END=999,ERR=999) Line
        If(Line(1:4).ne.'#ORB') goto 51
        KCMO  = 0
        Do ISYM=1,NSYM
          Do IORB=1,iWork(imyNORB+ISYM-1)
            Do IBAS=1,NBAS(ISYM),NDIV
              IBASEND=MIN(IBAS+NDIV-1,NBAS(ISYM))
111           READ(LU,'(A256)',END=999,ERR=999) LINE
              If(LINE(1:1).EQ.'*') GOTO 111
              If(iOrb.le.nOrb(iSym)) Then
                 READ(LINE,FMT,err=888,end=888)
     &               (CMO(I+KCMO),I=IBAS,IBASEND)
              End If
            End Do
            If(iOrb.le.nOrb(iSym)) KCMO=KCMO+NBAS(ISYM)
          End Do
        End Do
        If(iUHF.eq.1.or.iBeta.eq.1) Then
52        READ(LU,'(A256)',END=999,ERR=999) Line
          If(Line(1:5).ne.'#UORB') goto 52
          KCMO  = 0
          Do ISYM=1,NSYM
            Do IORB=1,iWork(imyNORB+ISYM-1)
              Do IBAS=1,NBAS(ISYM),NDIV
                IBASEND=MIN(IBAS+NDIV-1,NBAS(ISYM))
112             READ(LU,'(A256)',END=999,ERR=999) LINE
                If(LINE(1:1).EQ.'*') GOTO 112
                If(iOrb.le.nOrb(iSym)) Then
                  If (iBeta.eq.1) Then
                    READ(LINE,FMT,err=888,end=888)
     &                  (CMO(I+KCMO),I=IBAS,IBASEND)
                  Else
                    READ(LINE,FMT,err=888,end=888)
     &                  (CMO_ab(I+KCMO),I=IBAS,IBASEND)
                  End If
                End If
              End Do
              If(iOrb.le.nOrb(iSym)) KCMO=KCMO+NBAS(ISYM)
            End Do
          End Do
        End If ! iUHF
      End If ! iCMO
*----------------------------------------------------------------------*
* OCC section                                                          *
*----------------------------------------------------------------------*
      If(iOcc.eq.1) Then
        nDiv = nDivOcc(iVer)
        FMT = FmtOcc(iVer)
        Rewind(LU)
53      READ(LU,'(A256)',END=999,ERR=999) Line
        If(Line(1:4).ne.'#OCC') goto 53
        KOCC  = 0
        Do ISYM=1,NSYM
          Do IORB=1,iWork(imyNORB+ISYM-1),NDIV
            IORBEND=MIN(IORB+NDIV-1,iWork(imyNORB+ISYM-1))
113         READ(LU,'(A256)',END=999,ERR=999) LINE
            If(LINE(1:1).EQ.'*') GOTO 113
            READ(LINE,FMT,err=888,end=888)
     &              (OCC(I+KOCC),I=IORB,IORBEND)
          End Do
*         KOCC=KOCC+iWork(imyNORB+ISYM-1)
          KOCC=KOCC+nOrb(iSym)
        End Do
        If(iUHF.eq.1.or.iBeta.eq.1) Then
54        READ(LU,'(A256)',END=999,ERR=999) Line
          If(Line(1:5).ne.'#UOCC') goto 54
          KOCC=0
          Do ISYM=1,NSYM
            Do IORB=1,iWork(imyNORB+ISYM-1),NDIV
              IORBEND=MIN(IORB+NDIV-1,iWork(imyNORB+ISYM-1))
114           READ(LU,'(A256)',END=999,ERR=999) LINE
              If(LINE(1:1).EQ.'*') GOTO 114
              If (iBeta.eq.1) Then
                READ(LINE,FMT,err=888,end=888)
     &              (OCC(I+KOCC),I=IORB,IORBEND)
              Else
                READ(LINE,FMT,err=888,end=888)
     &              (OCC_ab(I+KOCC),I=IORB,IORBEND)
              End If
            End Do
*           KOCC=KOCC+iWork(imyNORB+ISYM-1)
            KOCC=KOCC+nOrb(iSym)
          End Do
        End If ! iUHF
      End If ! iOCC
*----------------------------------------------------------------------*
* ONE section                                                          *
*----------------------------------------------------------------------*
      If(iEne.eq.1) Then
        nDiv = nDivEne(iVer)
        FMT = FmtEne(iVer)
        Rewind(LU)
55      READ(LU,'(A256)',END=666,ERR=666) Line
        If(Line(1:4).ne.'#ONE') goto 55
        KOCC  = 0
        Do ISYM=1,NSYM
          Do IORB=1,iWork(imyNORB+ISYM-1),NDIV
            IORBEND=MIN(IORB+NDIV-1,iWork(imyNORB+ISYM-1))
115         READ(LU,'(A256)',END=999,ERR=999) LINE
            If(LINE(1:1).EQ.'*') GOTO 115
            READ(LINE,FMT,err=888,end=888)
     &          (EORB(I+KOCC),I=IORB,IORBEND)
          End Do
*         KOCC=KOCC+iWork(imyNORB+ISYM-1)
          KOCC=KOCC+nOrb(iSym)
        End Do
        If(iUHF.eq.1.or.iBeta.eq.1) Then
56        READ(LU,'(A256)',END=999,ERR=999) Line
          If(Line(1:5).ne.'#UONE') goto 56
          KOCC=0
          Do ISYM=1,NSYM
            Do IORB=1,iWork(imyNORB+ISYM-1),NDIV
              IORBEND=MIN(IORB+NDIV-1,iWork(imyNORB+ISYM-1))
116           READ(LU,'(A256)',END=999,ERR=999) LINE
              If(LINE(1:1).EQ.'*') GOTO 116
              If (iBeta.eq.1) Then
                READ(LINE,FMT,err=888,end=888)
     &              (EORB(I+KOCC),I=IORB,IORBEND)
              Else
                READ(LINE,FMT,err=888,end=888)
     &              (EORB_ab(I+KOCC),I=IORB,IORBEND)
              End If
            End Do
*           KOCC=KOCC+iWork(imyNORB+ISYM-1)
            KOCC=KOCC+nOrb(iSym)
          End Do
        End If ! iUHF
      End If ! iOne
*----------------------------------------------------------------------*
* INDEX section                                                        *
*----------------------------------------------------------------------*
      If(iInd.eq.1) Then
        Rewind(LU)
57      READ(LU,'(A256)',END=666,ERR=666) Line
        If(Line(1:6).ne.'#INDEX') goto 57
        FMT=FMTIND(iVer)
        nDiv=nDivInd(iVer)
        iShift=1
        Do ISYM=1,NSYM
c         iShift=(ISYM-1)*7
          Do i=1,nSkpInd(iVer)
            read(LU,*)
          EndDo
          Do IORB=1,iWork(imyNORB+ISYM-1),nDiv
            READ(LU,FMT,err=666,end=666) Buff
            Do i=1,nDiv
              IND=index(Crypt,Buff(i:i))+index(CryptUp,Buff(i:i))
              If(Buff(i:i).ne.' ') Then
                If(IND.eq.0) Then
                  WRITE(6,*) '* ERROR IN RDVEC WHILE READING TypeIndex'
                  WRITE(6,'(3A)') '* Type=',Buff(i:i), ' is UNKNOWN'
                  WRITE(6,*) '* TypeIndex information is IGNORED'
                  iErr=1
                  Close(Lu)
                  goto 777
                End If
                IndT(iShift)=IND
                iShift=iShift+1
              End If
            End Do
          End Do
        End Do


        iA=1
        iB=1
        Do iSym=1,nSym
           Call iCopy(nOrb(iSym),IndT(iA),1,IndT(iB),1)
           iA=iA+nBas(iSym)
           iB=iB+nOrb(iSym)
        End Do
      End If  ! Index
      Close(Lu)
      Goto 777
*----------------------------------------------------------------------*
* a special case - INDEX information is not found                      *
*----------------------------------------------------------------------*
666   iErr=1
      WRITE(6,*) '* TypeIndex information is IGNORED *'
      Close(Lu)
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
777   Call GetMem('MYNORB','Free','Inte',imyNORB,NSYM)
      Return
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
999   Call SysAbendFileMsg(Location,Name,
     &   'Error during reading INPORB\n',Line)
888   Call SysAbendFileMsg(Location,Name,
     &   'Error during reading INPORB\n',Line)
      End
************************************************************************
*                                                                      *
************************************************************************
      SUBROUTINE VECSORT(NSYM,NBAS,NORB,CMO,OCC,INDT,NNWORD,NEWORD,iErr)
*
* Sorting routine: sort CMO, OCC according to INDT
*
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"

      DIMENSION NBAS(NSYM),NORB(NSYM),CMO(*),OCC(*), INDT(*)
* PAM 2012: Have VecSort return an array NEWORD with new orbital indices.
* If typedef info in an orbital file is used to change the order
* of orbitals, this is done by a call to VecSort. If user, as a result,
* needs to alter orbital indices ( e.g. in the supersymmetry array
* IXSYM) he needs to know how orbitals have changed order.
* The mapping is (New orbital index)=NEWORD(Old orbital index).
      DIMENSION NEWORD(*)
* PAM 2012: End of update

      MBAS=NBAS(1)
      Do i=2,nSym
         MBAS=Max(MBAS,NBAS(i))
      End Do
      Call GetMem('TCMO','Allo','Real',iTCMO,MBAS)

      kcmo=0
      kocc=0
      iii=0

* PAM 2012: NewOrd update
* If NNWORD is .gt. 0, this indicates the caller wish to get back
* a reindicing array. Then this must be large enough:
      If (NNWORD.gt.0) Then
       nw=0
       Do ISYM=1,NSYM
        Do i=1,NORB(ISYM)
         nw=nw+1
        End Do
       End Do
       If (nw.gt.NNWORD) Then
       End If

       Do nw = 1,NNWORD
        NEWORD(nw)=nw
       End Do
      End If
* PAM 2012: End of update

      Do ISYM=1,NSYM
*---- Check Do we need make sort?
      NeedSort=0
c      print *,'indt'
c      print *,(indt(i+iii),i=1,norb(isym))
        Do I=1,NORB(ISYM)
          If(IndT(i+iii).eq.0) Then
           iErr=1
          End If
          If(i.gt.1) Then
           If(IndT(i+iii).lt.IndT(i-1+iii)) NeedSort=1
          End If
        End Do
c       print *,'NeedSort=',NeedSort
       If(NeedSort.eq.1) Then
*---- Start sort
*---- we Do have only a few types of orbitals, so sorting is a simple...
        Do iType=1,7
          ip=0
          isfirst=0
          Do i=1,NORB(ISYM)
            If(isfirst.eq.0) Then
              If(IndT(i+iii).gt.iType) Then
               isfirst=1
              End If
              If(IndT(i+iii).le.iType) Then
               ip=i
              End If
            End If
            If(isfirst.eq.1.and.IndT(i+iii).eq.iType) Then
*---- We need to shift CMO, Occ
              m=IndT(i+iii)
              q=Occ(i+KOCC)
* PAM 2012: NewOrd update
              nw=NEWORD(i+KOCC)
* PAM 2012: End of update
              Do ii=1,NBAS(ISYM)
               Work(iTCMO+ii-1)=CMO((i-1)*NORB(ISYM)+KCMO+ii)
              End Do
              Do j=i,ip+2,-1
               IndT(j+iii)=IndT(j-1+iii)
               Occ(j+KOCC)=Occ(j-1+KOCC)
* PAM 2012: NewOrd update
               NEWORD(j+KOCC)=NEWORD(j-1+KOCC)
* PAM 2012: End of update
               Do ii=1,NBAS(ISYM)
                 CMO((j-1)*NORB(ISYM)+KCMO+ii)=
     &                 CMO((j-2)*NORB(ISYM)+KCMO+ii)
               End Do
              End Do

              IndT(ip+1+iii)=m
              Occ(ip+1+KOCC)=q
* PAM 2012: NewOrd update
               NEWORD(ip+1+KOCC)=nw
* PAM 2012: End of update
              Do ii=1,NBAS(ISYM)
               CMO((ip)*NORB(ISYM)+KCMO+ii)=Work(iTCMO+ii-1)
              End Do

              ip=ip+1
            End If
          End Do
      End Do
c      print *,'sorted:'
c      print '(10i2)',(IndT(i+iii), i=1,NORB(ISYM))
c      print '(4E18.12)',(Occ(i+KOCC), i=1,NORB(ISYM))

c      Do ii=1,NBAS(ISYM)
c      print *
c      print '(4E18.12)',(CMO(i+KOCC+(ii-1)*NBAS(ISYM)),i=1,NORB(ISYM))
c      End Do

*---- End sort
       End If
*---- Next symmetry
        KCMO=KCMO+NBAS(ISYM)*NORB(ISYM)
        KOCC=KOCC+NORB(ISYM)
        iii=iii+NORB(ISYM)

      End Do
      Call GetMem('TCMO','Free','Real',iTCMO,MBAS)

        Return
      End
*
      Subroutine Chk_vec_UHF(Name,Lu,isUHF)
c routine returns isUHF based on information in INPORB
      Character *(*) Name
      CHARACTER LINE*80,Location *11
      Logical Exist
#include "inporbfmt.fh"
      Location='Chk_vec_UHF'
      Line='not defined yet'

      Call OpnFl(Name,Lu,Exist)
      If (.Not.Exist) Then
       Write (6,*) 'RdVec: File ',Name(1:index(Name,' ')),' not found!'
       Call Abend()
      End If
      REWIND (LU)
* Check version!
      READ(LU,'(A80)',END=999,ERR=999) Line
      iVer=0
      Do jVer=1,mxVer
        if(Magic(jVer).eq.Line(1:len(Magic(jVer)))) iVer=jVer
      End Do

      If(iVer.eq.0) Then
          Call SysWarnMsg(Location,
     & 'INPORB file in old format',' ')
        Call SysPutsEnd()
       isUHF=0
       close(Lu)
       return
      End If
50    READ(LU,'(A80)',END=999,ERR=999) Line
      If(Line(1:5).ne.'#INFO') goto 50
* Now Do the real job
        Read (Lu,'(a)',end=999,err=999) Line
        Read(Lu,*,end=999,err=999) isUHF
        close(Lu)
      return
999      Call SysAbendFileMsg(Location,Name,
     &     'Error during reading INPORB\n',Line)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#if defined (_CHO_DEBUGPRINT_)
#define _DEBUGPRINT_
#endif
      SubRoutine Cho_VecBuf_Init(Frac,lVec)
C
C     Purpose: allocate and initialize vector buffer.
C              RUN_MODE=RUN_INTERNAL: buffer used during decomposition.
C              RUN_MODE=RUN_EXTERNAL: buffer used after decomposition,
C                                     i.e. vectors are available on
C                                     disk.
C              (RUN_MODE stored in cholesky.fh)
C
      Implicit None
      Real*8  Frac
      Integer lVec(*)
#include "cholesky.fh"
#include "chovecbuf.fh"

      Character*15 SecNam
      Parameter (SecNam = 'Cho_VecBuf_Init')

      Logical LocDbg
#if defined (_DEBUGPRINT_)
      Parameter (LocDbg = .true.)
#else
      Parameter (LocDbg = .false.)
#endif

      Character*2 Unt
      Integer ip_Max, l_Max, MF
      Real*8  xMF

      If (LocDbg) Then
         Call Cho_Mem('GetMax','GetM','Real',ip_Max,l_Max)
         Write(Lupri,*) '>>>>> Enter ',SecNam,' <<<<<'
         Write(Lupri,*) 'Memory fraction requested for buffer: ',Frac
         Call Cho_Word2Byte(l_Max,8,xMF,Unt)
         Write(Lupri,*) 'Memory available: ',l_Max,' = ',xMF,Unt
         MF = INT(Frac*DBLE(l_Max))
         Call Cho_Word2Byte(MF,8,xMF,Unt)
         Write(Lupri,*) 'Memory fraction : ',MF,' = ',xMF,Unt
         Call Cho_Flush(Lupri)
      End If

      l_ChVBfI=0
      ip_ChVBfI=0
      Call iZero(l_ChVBfI_Sym,nSym)
      Call iZero(ip_ChVBfI_Sym,nSym)

      If (RUN_MODE .eq. RUN_INTERNAL) Then
         Call Cho_VecBuf_Init_I(Frac,lVec,LocDbg)
      Else If (RUN_MODE .eq. RUN_EXTERNAL) Then
         Call Cho_VecBuf_Init_X(Frac,LocDbg)
      Else
         Call Cho_Quit('RUN_MODE error in '//SecNam,103)
      End If

      If (LocDbg) Then
         Write(Lupri,*) '>>>>> Exit  ',SecNam,' <<<<<'
         Call Cho_Flush(Lupri)
      End If

      End
      SubRoutine Cho_VecBuf_Init_I(Frac,lVec,LocDbg)
C
C     Purpose: allocate and initialize vector buffer.
C              (Internal run mode.)
C
      Implicit None
      Real*8  Frac
      Integer lVec(*)
      Logical LocDbg
#include "cholesky.fh"
#include "chovecbuf.fh"

      Character*17 SecNam
      Parameter (SecNam = 'Cho_VecBuf_Init_I')

      Character*2 Unt
      Real*8 xMemMax(8), x

      Integer lVecTot
      Integer ip_Max, l_Max
      Integer iSym, MemEach, MemLeft

      Logical Enough

      Integer  Cho_iSumElm
      External Cho_iSumElm

      If (LocDbg) Then
         Write(Lupri,*) '>>>>> Enter ',SecNam,' <<<<<'
         Write(Lupri,*) 'Memory fraction requested for buffer: ',Frac
         Write(Lupri,'(A,I8)')  'nSym: ',nSym
         Write(Lupri,'(A,8I8)') 'lVec: ',(lVec(iSym),iSym=1,nSym)
         Call Cho_Flush(Lupri)
      End If

      If (nSym.lt.1 .or. nSym.gt.8) Then
         Call Cho_Quit('nSym out of bounds in '//SecNam,102)
      End If

      x = DBLE(MaxVec)
      lVecTot = lVec(1)
      xMemMax(1) = DBLE(lVec(1))*x
      Do iSym = 2,nSym
         lVecTot = max(lVecTot,lVec(iSym))
         xMemMax(iSym) = DBLE(lVec(iSym))*x
      End Do

      If (Frac.le.0.0d0 .or. Frac.gt.1.0d0 .or. lVecTot.lt.1) Then
         l_ChVBuf  = 0
         ip_ChVBuf = 0
         Call Cho_iZero(ip_ChVBuf_Sym,nSym)
         Call Cho_iZero(l_ChVBuf_Sym,nSym)
      Else
         Call Cho_Mem('GetMax','GetM','Real',ip_Max,l_Max)
         l_ChVBuf = INT(Frac*DBLE(l_Max))
         If (l_ChVBuf.lt.nSym .or. l_ChVBuf.lt.lVecTot) Then
            l_ChVBuf  = 0
            ip_ChVBuf = 0
            Call Cho_iZero(ip_ChVBuf_Sym,nSym)
            Call Cho_iZero(l_ChVBuf_Sym,nSym)
         Else
            MemEach = l_ChVBuf/nSym
            Enough = MemEach .gt. lVec(1)
            Do iSym = 2,nSym
               Enough = Enough .and. MemEach.gt.lVec(iSym)
            End Do
            If (.not. Enough) Then ! whole buffer for sym. 1
               l_ChVBuf_Sym(1) = l_ChVBuf
               Do iSym = 2,nSym
                  l_ChVBuf_Sym(iSym) = 0
               End Do
            Else
               MemLeft = l_ChVBuf - nSym*MemEach
               l_ChVBuf_Sym(1) = MemEach + MemLeft
               If (DBLE(l_ChVBuf_Sym(1)) .gt. xMemMax(1)) Then
                  l_ChVBuf_Sym(1) = INT(xMemMax(1))
               End If
               Do iSym = 2,nSym
                  l_ChVBuf_Sym(iSym) = MemEach
                  If (DBLE(l_ChVBuf_Sym(iSym)) .gt. xMemMax(iSym)) Then
                     l_ChVBuf_Sym(iSym) = INT(xMemMax(iSym))
                  End If
               End Do
            End If
            l_ChVBuf = Cho_iSumElm(l_ChVBuf_Sym,nSym)
            Call Cho_Mem('CHVBUF','Allo','Real',ip_ChVBuf,l_ChVBuf)
            ip_ChVBuf_Sym(1) = ip_ChVBuf
            Do iSym = 2,nSym
               ip_ChVBuf_Sym(iSym) = ip_ChVBuf_Sym(iSym-1)
     &                             + l_ChVBuf_Sym(iSym-1)
            End Do
         End If
      End If

      Call Cho_iZero(nVec_in_Buf,nSym)

      If (LocDbg) Then
         Call Cho_Word2Byte(l_ChVBuf,8,x,Unt)
         Write(Lupri,*) 'Memory allocated for buffer: ',l_ChVBuf,
     &                  '(',x,Unt,') at ',ip_ChVBuf
         Write(Lupri,'(A,8I8)') 'l_ChVBuf_Sym : ',
     &                          (l_ChVBuf_Sym(iSym),iSym=1,nSym)
         Write(Lupri,'(A,8I8)') 'ip_ChVBuf_Sym: ',
     &                          (ip_ChVBuf_Sym(iSym),iSym=1,nSym)
         Write(Lupri,*) '>>>>> Exit  ',SecNam,' <<<<<'
         Call Cho_Flush(Lupri)
      End If

      End
      SubRoutine Cho_VecBuf_Init_X(Frac,LocDbg)
C
C     Purpose: allocate and initialize vector buffer.
C              (External run mode.)
C
      Implicit None
      Real*8  Frac
      Logical LocDbg
#include "cholesky.fh"
#include "chovecbuf.fh"

      Character*17 SecNam
      Parameter (SecNam = 'Cho_VecBuf_Init_X')

      Integer  Cho_iSumElm
      External Cho_iSumElm

      Logical DoRead
      Integer i, iSym, ip_Max, l_Max, Left, jNum, iRedC, mUsed

      Integer lScr
      Parameter (lScr = 1)
      Real*8 Scr(lScr)

      Integer nErr
      Real*8 Scr_Check, Tol, Diff
      Parameter (Scr_Check = 1.23456789d0, Tol = 1.0d-15)

      Character*2 Unt
      Real*8 Byte

      If (LocDbg) Then
         Do i = 1,lScr
            Scr(i) = Scr_Check
         End Do
         Write(Lupri,*) '>>>>> Enter ',SecNam,' <<<<<'
         Write(Lupri,*) 'Memory fraction requested for buffer: ',Frac
         Write(Lupri,'(A,I8)')  'nSym: ',nSym
         Call Cho_Flush(Lupri)
      End If

      If (nSym.lt.1 .or. nSym.gt.8) Then
         Call Cho_Quit('nSym out of bounds in '//SecNam,102)
      End If

      If (Frac.le.0.0d0 .or. Frac.gt.1.0d0) Then
         l_ChVBuf  = 0
         ip_ChVBuf = 0
         Call Cho_iZero(l_ChvBuf_Sym,nSym)
         Call Cho_iZero(ip_ChvBuf_Sym,nSym)
      Else
         Call Cho_Mem('GetMax','GetM','Real',ip_Max,l_Max)
         Left = INT(Frac*DBLE(l_Max))
         iRedC = -1
         DoRead = .false.
         Do iSym = 1,nSym
            jNum = 0
            mUsed = 0
            Call Cho_VecRd1(Scr,Left,1,NumCho(iSym),iSym,
     &                      jNum,iRedC,mUsed,DoRead)
            Left = Left - mUsed
            l_ChVBuf_Sym(iSym) = mUsed
         End Do
         l_ChVBuf = Cho_iSumElm(l_ChVBuf_Sym,nSym)
         If (l_ChVBuf .lt. 1) Then
            l_ChVBuf  = 0
            ip_ChVBuf = 0
            Call Cho_iZero(l_ChvBuf_Sym,nSym)
            Call Cho_iZero(ip_ChvBuf_Sym,nSym)
         Else
            Call Cho_Mem('CHVBUF','Allo','Real',ip_ChVBuf,l_ChVBuf)
            ip_ChVBuf_Sym(1) = ip_ChVBuf
            Do iSym = 2,nSym
               ip_ChVBuf_Sym(iSym) = ip_ChVBuf_Sym(iSym-1)
     &                             + l_ChVBuf_Sym(iSym-1)
            End Do
         End If
      End If

      If (LocDbg) Then
         nErr = 0
         Do i = 1,lScr
            Diff = Scr(i) - Scr_Check
            If (ABS(Diff) .gt. Tol) Then
               nErr = nErr + 1
            End If
         End Do
         If (nErr .ne. 0) Then
            Call Cho_Quit('Memory boundary error in '//SecNam,101)
         End If
         Call Cho_Word2Byte(l_ChVBuf,8,Byte,Unt)
         Write(Lupri,*) 'Memory allocated for buffer: ',l_ChVBuf,
     &                  '(',Byte,Unt,')  at ',ip_ChVBuf
         Write(Lupri,'(A,8I8)') 'l_ChVBuf_Sym : ',
     &                          (l_ChVBuf_Sym(iSym),iSym=1,nSym)
         Write(Lupri,'(A,8I8)') 'ip_ChVBuf_Sym: ',
     &                          (ip_ChVBuf_Sym(iSym),iSym=1,nSym)
         Write(Lupri,*) '>>>>> Exit  ',SecNam,' <<<<<'
         Call Cho_Flush(Lupri)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function getCG(j1,j2,j3,m1,m2,m3)
!bs this routine calculates the Clebsch-Gordan-coefficients
!bs by actually calculating the 3j-symbol
!bs  ---                 ---
!bs  |  j1   j2    |   j3   |         j1+m1+j2-m2
!bs  |             |        |  =  (-)                 sqrt (2  j3+1) *
!bs  |  m1   m2    |   m3   |
!bs  ---                 ---
!bs
!bs                             ---             ---
!bs                             |  j1   j2   j3   |
!bs                             |                 |
!bs                             |  m1   m2  -m3   |

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: getCG
integer(kind=iwp), intent(in) :: j1, j2, j3, m1, m2, m3
integer(kind=iwp) :: idummy
real(kind=wp) :: fac1, fac2, sgn
real(kind=wp), external :: regge3j

!bs initialize CG-coefficient
getCG = Zero
!bs quick check
if (m1+m2 /= m3) return
if ((j1 < 0) .or. (j2 < 0) .or. (j3 < 0)) return
!bs check the correct sign    beginning
idummy = (j1+j2+m1-m2)/2
if (mod(idummy,2) == 0) then
  sgn = One
else
  sgn = -One
end if
!bs check the correct sign    end
fac1 = sqrt(real(j3+1,kind=wp))
fac2 = regge3j(j1,j2,j3,m1,m2,-m3)
getCG = sgn*fac1*fac2

return

end function getCG

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!               2006, Giovanni Ghigo                                   *
!***********************************************************************

subroutine TrGrd_Alaska(CGrad,CNames,GradIn,nGrad,iCen)
!***********************************************************************
!                                                                      *
!      Transforms a symmetry adapted gradient to unsymmetric form.     *
!                                                                      *
!       Written by Anders Bernhardsson                                 *
!       Adapted by Giovanni Ghigo                                      *
!       University of Torino, July 2006                                *
!***********************************************************************

use Basis_Info, only: DBSC, nCnttp
use Center_Info, only: DC
use Symmetry_Info, only: nIrrep
use Disp, only: IndDsp
use Molcas, only: LenIn, MxAtom
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(out) :: CGrad(3,MxAtom)
character(len=LenIn+5), intent(out) :: CNames(MxAtom)
real(kind=wp), intent(in) :: GradIn(nGrad)
integer(kind=iwp), intent(out) :: iCen
integer(kind=iwp) :: iCar, iCnt, iCnttp, iCo, iComp, kOp, mdc, nDisps
integer(kind=iwp), parameter :: iIrrep = 0
real(kind=wp), parameter :: tol = 1.0e-8_wp
integer(kind=iwp), external :: iPrmt, NrOpr
logical(kind=iwp), external :: TF

CGrad(:,:) = Zero
iCen = 0
!nCnttp_Valence = 0
!do iCnttp=1,nCnttp
!  if (dbsc(iCnttp)%Aux) exit
!  nCnttp_Valence = nCnttp_Valence+1
!end do

mdc = 0
do iCnttp=1,nCnttp
  if (.not. (dbsc(iCnttp)%pChrg .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%Aux)) then
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      do iCo=0,nIrrep/dc(mdc)%nStab-1
        kOp = dc(mdc)%iCoSet(iCo,0)
        nDispS = IndDsp(mdc,iIrrep)
        iCen = iCen+1
        do iCar=0,2
          iComp = 2**iCar
          if (TF(mdc,iIrrep,iComp)) then
            nDispS = nDispS+1
            CGrad(iCar+1,iCen) = real(iPrmt(NrOpr(kOp),iComp),kind=wp)*GradIn(nDispS)
          end if
        end do
        CNames(iCen) = dc(mdc)%LblCnt
      end do
    end do
  end if
end do

end subroutine TrGrd_Alaska

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Hess_Tra(Hss_X,nDim,Degen,BMx,nInter,Hss_Q)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, nInter
real(kind=wp), intent(inout) :: Hss_X(nDim*nDim)
real(kind=wp), intent(in) :: Degen(nDim), BMx(nDim,nInter)
real(kind=wp), intent(out) :: Hss_Q(nInter*nInter)
integer(kind=iwp) :: i, ij, j
real(kind=wp), allocatable :: X(:), XT(:)

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the Hessian matrix in Internal Cartesian Coordinates by solving:
!
! d^2E/dx^2 = dQ/dx d^2E/dQ^2 dQ/dx

do j=1,nDim
  do i=1,nDim
    ij = (j-1)*nDim+i
    Hss_X(ij) = Hss_X(ij)/sqrt(Degen(i)*Degen(j))
  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt('BMx',' ',BMx,nDim,nInter)
call RecPrt('Hss_X',' ',Hss_X,nDim,nDim)
#endif
call mma_allocate(X,nDim*nInter,Label='X')
call Eq_Solver('N',nDim,nInter,nDim,BMx,.false.,Degen,Hss_X,X)

call mma_allocate(XT,nDim*nInter,Label='XT')
call TRNSPS(nInter,nDim,X,XT)
#ifdef _DEBUGPRINT_
call RecPrt('X',' ',X,nInter,nDim)
call RecPrt('XT',' ',XT,nDim,nInter)
#endif

call Eq_Solver('N',nDim,nInter,nInter,BMx,.false.,Degen,XT,Hss_Q)

call mma_deallocate(XT)
call mma_deallocate(X)
#ifdef _DEBUGPRINT_
call RecPrt('Hss_Q',' ',Hss_Q,nInter,nInter)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Hess_Tra

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1998, Roland Lindh                      *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drv2El_RI_Diag(ThrAO,TInt,nTInt)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals.                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August '91                         *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. '93          *
*             Modified driver. Jan. '98                                *
************************************************************************
      use SOAO_Info, only: iOffSO
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Integral_WrOut
#include "j12.fh"
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Real*8  TInt(nTInt)
      Logical Verbose, Indexation, FreeK2, DoFock, DoGrad
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 9
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*     Initialize for 2-electron integral evaluation. Do not generate
*     tables for indexation.
*
      DoFock=.False.
      DoGrad=.False.
      Indexation = .False.
      Call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
      nSkal_Valence=nSkal
*                                                                      *
************************************************************************
*                                                                      *
*     Update iOffSO and call the Cholesky code which does this.
*
      nAcc=0
      Do iIrrep = 0, nIrrep-1
         iOffSO(iIrrep) = nAcc
         nAcc = nAcc + nBas(iIrrep)
      End Do
      Call RI_XDiag(TInt,nTInt)
*                                                                      *
************************************************************************
*                                                                      *
*     Terminate integral environment.
*
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      SubRoutine Cho_x_setab(iS,jS)
#include "cholesky.fh"
*
      SHA=iS
      SHB=jS
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2002, Jeppe Olsen                                      *
!***********************************************************************

subroutine GETCNF_LUCIA(KCNF,KTYP,K,ICONF,IREFSM,NEL)
! Obtain configuration number K .
! Occupation in KCNF in form of old RASSCF ( doubly occ orbs first)
! Type in KTYP
!
! Adapted for LUCIA Jeppe Olsen, summer of 02

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: K, ICONF(*), IREFSM, NEL
integer(kind=iwp), intent(out) :: KCNF(NEL), KTYP
integer(kind=iwp) :: ICNFB1, ICNFB2, IIBCL, IIBOP, JCL, JOCC, JOP, JTYP, KADD, KOCC, KORB, KREL, NJCNF, NOCC, NTEST
#include "spinfo.fh"
! Configuration list is assumed to be in the form used
! in LUCIA, i.e. doubly occupied orbitals are flagged by
! a minus

ICNFB1 = 1
ICNFB2 = 1
KTYP = 0
do JTYP=1,NTYP
  JOP = JTYP-1+MINOP
  JCL = (NEL-JOP)/2
  JOCC = JOP+JCL

  NJCNF = NCNFTP(JTYP,IREFSM)
  if ((K >= ICNFB1) .and. (K <= ICNFB1+NJCNF-1)) then
    KREL = K-ICNFB1+1
    KADD = (KREL-1)*JOCC
    KTYP = JTYP
    ! Outdated ...
    !call ICOPY(JOCC,ICONF(ICNFB2+KADD),1,KCNF,1)

    ! Obtain configuration in standard RASSCF form
    IIBOP = 1
    IIBCL = 1
    do KOCC=1,JOCC
      KORB = ICONF(ICNFB2+KADD-1+KOCC)
      if (KORB < 0) then
        ! Doubly occupied orbital
        KCNF(IIBCL) = abs(KORB)
        IIBCL = IIBCL+1
      else
        ! Singly occupied orbital
        KCNF(JCL+IIBOP) = KORB
        IIBOP = IIBOP+1
      end if
    end do
  end if

  ICNFB1 = ICNFB1+NJCNF
  ICNFB2 = ICNFB2+NJCNF*JOCC
end do

NTEST = 0
if (NTEST /= 0) then
  write(u6,*) ' Output from GETCNF'
  write(u6,*) ' =================='
  write(u6,*) ' Input configuration number : ',K
  write(u6,*) ' Corresponding type : ',KTYP
  write(u6,*) ' Occupation :'
  NOCC = (NEL+KTYP-1+MINOP)/2
  call IWRTMA(KCNF,1,NOCC,1,NOCC)
end if

return

end subroutine GETCNF_LUCIA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Chk_Numerical(LuSpool,Numerical)
      Implicit Real*8 (A-H,O-Z)
      Logical Numerical,Is_Root_Set, DNG, KeepOld, Found
      Character KWord*180, Key*180, Get_Ln*180
      External Get_Ln
#include "nac.fh"
#include "alaska_root.fh"
*
      Call Qpg_iScalar('DNG',DNG)
      If (DNG) Then
         Call Get_iScalar('DNG',iDNG)
         Numerical = iDNG.eq.1
      Else
         Numerical = .False.
      End If
      LuWr=6
*
* Setting the defaults
*    iRoot     : Which root to optimize the geometry for
*    rDelta    : Displacements are chosen as r_nearest_neighbor * rDelta
      iRoot     = 1
      rDelta    = 0.0100D0
      NACstates(1)=0
      NACstates(2)=0
      isNAC     = .False.
      KeepOld   = .False.
      DefRoot   = .True.
      ForceNAC  = .False.
      iRlxRoot  = 1
      Auto      = .False.
*
* RASSCF will set the default root to the root that is relaxed.
*
      Is_Root_Set = .False.
      Call Qpg_iScalar('NumGradRoot',Is_Root_Set)
      If (Is_Root_Set) Then
         Call Get_iScalar('NumGradRoot',iRoot)
      End If
*
      Rewind(LuSpool)
      Call RdNLst(LuSpool,'ALASKA')
      KWord=' &ALASKA'
 998  Read (LuSpool,'(A72)',END=997,ERR=988) Key
      KWord = Key
      Call UpCase(KWord)
      If (KWord(1:4) .eq. 'NUME') Then
         Numerical = .True.
         Goto 998
      Else If (KWord(1:4) .eq. 'ROOT') Then
         Key = Get_Ln(LuSpool)
         Call Get_I1(1,iRoot)
         DefRoot = .False.
         Goto 998
      Else If (KWord(1:4) .eq. 'DELT') Then
         Key = Get_Ln(LuSpool)
         Call Get_F1(1,rDelta)
         Goto 998
      Else If (KWord(1:4) .eq. 'NAC ') Then
         Key = Get_Ln(LuSpool)
         Call Get_I(1,NACstates,2)
         isNAC = .True.
         DefRoot = .False.
         Goto 998
      Else If (KWord(1:4) .eq. 'KEEP') Then
         KeepOld = .True.
         Goto 998
      Else If (KWord(1:4) .eq. 'AUTO') Then
         Auto = .True.
         Goto 998
      Else If (KWord(1:4) .eq. 'END ') Then
         Goto 997
      Else
         Goto 998
      End If
*
 988  Call WarningMessage(2,
     &               'Chk_Numerical: Error reading the input')
      Write (LuWr,'(A,A)') 'Last read line=',KWord
      Call Quit_OnUserError()
*
 997  Continue
*
      Call Get_iScalar('Grad ready',iGO)
      iGO = iAnd(iGO,Not(2**0))
      Call Put_iScalar('Grad ready',iGO)
*
* Put on the runfile which root and delta to use
*
      Call qpg_iScalar('Relax CASSCF root',Found)
      If (Found) Then
         Call Get_iScalar('Relax CASSCF root',iRoot0)
         Call Put_iScalar('NumGradRoot',iRoot)
         Call Put_iScalar('Relax CASSCF root',iRoot)
      Else
         iRoot0=0
      End If
      Call Put_dScalar('Numerical Gradient rDelta',rDelta)
*
* These are really input options for numerical_gradient
*
      Call Put_lScalar('Keep old gradient',KeepOld)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************
      SubRoutine ChoMP2g_TraDrv(irc,CMO,Diag,DoDiag)
C
C     Jonas Bostrom, Jan. 2010. (modified from ChoMP2_TraDrv)
C
C     Purpose: AO-to-MO (pq) transformation of Cholesky vectors
C              performed directly in reduced sets. This assumes
C              that the MP2 program has been appropriately initialized.
C
#include "implicit.fh"
      Integer irc
      Real*8  CMO(*), Diag(*)
      Logical DoDiag, DoDiagbak
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2g.fh"
#include "stdalloc.fh"

      Character(LEN=6), Parameter:: ThisNm = 'TraDrv'
      Character(LEN=14), Parameter:: SecNam = 'ChoMP2g_TraDrv'

      Real*8, Allocatable:: COrb1(:), COrb2(:)

      irc = 0

C     Reorder MO coefficients.
C     ------------------------

      DoDiagBak = DoDiag
      DoDiag = .false.
      nProdType = nMOType**2
      l_COrb = 0
      Do iSym = 1, nSym
         nAdrOff(iSym) = 0
      End Do
*
      Do iSym = 1, nSym
         Do i = 1, nProdType
            l_COrb = max(l_COrb,nMoAo(iSym,i))
         End Do
      End Do
      Call mma_allocate(COrb1,l_COrb,Label='COrb1')
      Call mma_allocate(COrb2,l_COrb,Label='COrb2')
*
      DoDiag = .True.
      Call ChoMP2g_MOReOrd(CMO,COrb1,COrb2,2,3)
      Call ChoMP2g_Tra(COrb1,COrb2,Diag,DoDiag,2,3)
      DoDiag = .False.
      Do iMoType = 1,3
         Do jMOType =  1, 3
            If((iMoType .eq. 2) .and. (jMoType .eq. 3)) Go To 50

            Call ChoMP2g_MOReOrd(CMO,COrb1,COrb2,iMOType,jMOType)
C           Transform vectors.
C           ------------------
            Call ChoMP2g_Tra(COrb1,COrb2,Diag,DoDiag,iMoType,jMoType)

 50         Continue
         End Do
      End Do

C     Deallocate reordered MO coefficients.
C     -------------------------------------

      DoDiag = DoDiagBak

      Call mma_deallocate(COrb2)
      Call mma_deallocate(COrb1)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Read22_2(MO1,Fock,Q,FockI,FockA,Temp2,Scr,Temp3)
********************************************************************
*                                                                  *
*   Constructs         everything                                  *
*                                                                  *
*                                                                  *
*                                                                  *
*   Output:MO     :MO integrals                                    *
*          Fock   :Fock matrix (one index transformed integrals)   *
*          MOtilde:MO (one index transformed integrals)            *
*                                                                  *
********************************************************************
      use Arrays, only: W_CMO=>CMO, W_CMO_Inv=>CMO_Inv, Int1, G1t, G2t
      use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
      Implicit Real*8(a-h,o-z)
#include "real.fh"
#include "Pointers.fh"
#include "standard_iounits.fh"
#include "Input.fh"
#include "stdalloc.fh"
#include "Files_mclr.fh"
      Real*8 Fock(nDens2),FockI(nDens2),FockA(nDens2),
     &       Temp2(nDens2),Temp3(ndens2),Q(nDens2),
     &       MO1(*), Scr(*)
      Logical Fake_CMO2,DoAct
      Real*8, Allocatable:: G2x(:)
      Type (DSBA_Type) CVa(2), DLT, DI, DA, Kappa, JI(1), KI, JA, KA,
     &                 FkI, FkA, QVec, CMO, CMO_Inv
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      call dcopy_(ndens2,[0.0d0],0,focki,1)
      call dcopy_(ndens2,[0.0d0],0,focka,1)
      If(TwoStep.and.(StepType.eq.'RUN2')) Then
        iaddressQDAT=0
        Call dcopy_(ndens2,[0.0d0],0,fock,1)
        Call dcopy_(ndens2,[0.0d0],0,Q,1)
        Call ddafile(LuQDAT,2,FockA,nDens2,iaddressQDAT)
        Call ddafile(LuQDAT,2,FockI,nDens2,iaddressQDAT)
        Call ddafile(LuQDAT,2,Fock ,nDens2,iaddressQDAT)
        Call ddafile(LuQDAT,2,Q    ,nDens2,iaddressQDAT)
        goto 101
      End If

*
      nas=0
      Do is=1,nSym
       nAS=nAS+nAsh(is)
      end do
*                                                                      *
************************************************************************
*                                                                      *
      Select Case (NewCho)
*                                                                      *
************************************************************************
*                                                                      *
       Case (.False.)   ! Cho-MO algorithm
*                                                                      *
************************************************************************
*                                                                      *
      Do iS=1,nSym
         Do jS=1,iS
            ijS=iEOr(iS-1,jS-1)+1
            Do kS=1,nSym
               Do lS=1,ks
                  If (nOrb(iS)*nOrb(jS)*nOrb(ks)*nOrb(lS).eq.0)
     &                Go To 100
                  If (iEOr(kS-1,lS-1).ne.ijS-1) Goto 100
*                                                                      *
************************************************************************
*                                                                      *
                  ijB1=0
                  Do iB=1,nB(iS)
                     nnB=nB(jS)
                     If (iS.eq.jS) nnB=iB
                     Do jB=1,nnB
*
*                       Read a symmetry block
*
                        Call COUL(kS,lS,iS,jS,iB,jB,Temp2,Scr)
                        ijB1=ijB1+1
*                                                                      *
************************************************************************
*                                                                      *
*                       Add to unrotated inactive fock matrix
*
*                       Fkl sum(i)     2(ii|kl) -(ki|li)
*
*
*                       Coulomb term: F  =2(ii|kl)
*                                      kl
*
                        If (iS.eq.jS.and.iB.eq.jB .and.
     &                     (iB.le.nIsh(iS)))
     &                     Call DaXpY_(nOrb(kS)*nOrb(lS),Two,
     &                                Temp2,1,Focki(ipCM(kS)),1)

*                                                                      *
************************************************************************
*                                                                      *
*                       Add to unrotated active fock matrix
*
*                       Coulomb term: F  =2(ij|kl)d   i<j
*                                      kl          ij
*
                        If (iMethod.eq.iCASSCF) Then
*
                           If (iS.eq.jS) Then
                              If (((iB.gt.nIsh(is)).and.(nAsh(iS).ne.0))
     &                                .and.
     &                            ((jB.gt.nIsh(js)).and.(nAsh(jS).ne.0))
     &                           ) Then
                                 ipD=iTri(jB-nIsh(jS)+nA(jS),
     &                               iB-nIsh(is)+nA(iS))
                                 Fact=Two
                                 If (iB.eq.jB) Fact=one
                                 Call DaXpY_(nOrb(kS)*nOrb(lS),
     &                                      Fact*G1t(ipD),
     &                                      Temp2,1,FockA(ipCM(kS)),1)
                              End If
                           End If
*
                        End If
*                                                                      *
************************************************************************
*                                                                      *
                     End Do  ! jB
                  End Do     ! iB
*                                                                      *
************************************************************************
*                                                                      *
 100              Continue
               End Do          ! lS
            End Do             ! kS
         End Do                ! jS
      End Do                   ! iS
*                                                                      *
************************************************************************
*                                                                      *
*    Construct Q matrix: Q = sum(jkl)(pj|kl)d
*                         pi                 ijkl

      If (iMethod.eq.iCASSCF) Then

         Call CreQ2(Q,G2t,1,Temp2,Scr,nDens2)
*
*        Sort out MO (ij|kl)
*
         Do iS=1,nSym
            Do jS=1,iS
               Do kS=1,iS
                  lS=iEOR(iEOr(iS-1,jS-1),kS-1)+1
                  If (lS.gt.kS.or.(iS.eq.kS.and.lS.gt.jS)) Goto 123
*
                  Do iB=1,nAsh(iS)
                     iib=ib+nA(iS)
                     nnb=nAsh(jS)
                     If (iS.eq.jS) nnb=ib
                     Do jB=1,nnB
                        jjb=jb+nA(jS)
*
                        Call Coul(kS,lS,iS,jS,iB+nIsh(iS),jB+nIsh(jS),
     &                            Temp2,Scr)
*
                        nnK=nAsh(kS)
                        If (iS.eq.kS)  nnK=iB
                        Do kB=1,nnk
                           kkb=kb+nA(kS)
                           nnL=nAsh(lS)
                           If (kS.eq.lS)  nnL=kB
                           If (iib.eq.kkb) nnL=jB
                           Do lB=1,nnL
                              llb=lb+nA(lS)
*
                              ip2 = (lB+nIsh(lS)-1)*nBas(kS)
     &                            + kB+nIsh(kS)
*
                              ip1=iTri(iTri(iib,jjb),iTri(kkb,llb))
                              MO1(ip1) = Temp2(ip2)
                           End Do
                        End Do
                     End Do
                  End Do
*
 123              Continue
               End Do
            End Do
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Do iS=1,nSym
         kS=iS
         Do js=1,nSym
            lS=jS
            If (iEor(iEor(is-1,js-1),iEor(ks-1,ls-1)).ne.0) Cycle
            If (nOrb(iS)*nOrb(jS)*nOrb(ks)*nOrb(lS).eq.0)   Cycle
            Do LB=1,nB(LS)
               Do JB=1,nB(JS)
*                                                                      *
************************************************************************
*                                                                      *
                  Call EXCH(is,js,ks,ls,jb,lb,Temp2,Scr)
*                                                                      *
************************************************************************
*                                                                      *
*                 Add to unrotated inactive fock matrix
*
*                 Exchange term: F  =-(ij|kj)
*                                 ik
*
                  If (jS.eq.lS.and.jB.eq.lB.and.
     &                (jB.le.nIsh(jS)))
     &               Call DaXpY_(nOrb(iS)*nOrb(kS),-One,
     &                          Temp2,1,Focki(ipCM(iS)),1)

*                                                                      *
************************************************************************
*                                                                      *
*                 Add to unrotated active fock matrix
*
*                 Exchange term: F  =-1/2(ij|kl)d
*                                 ik             jl
*
                  If (iMethod.eq.iCASSCF) Then
                     If (jS.eq.lS) Then
                        If (((jB.gt.nIsh(js)).and.(nAsh(jS).ne.0)).and.
     &                      ((lB.gt.nIsh(ls)).and.(nAsh(lS).ne.0))
     &                     ) Then
                          ipD=iTri(lB-nIsh(lS)+nA(lS),
     &                             jB-nIsh(js)+nA(jS))
                          Call DaXpY_(nOrb(iS)*nOrb(kS),-half*G1t(ipD),
     &                               Temp2,1,FockA(ipCM(iS)),1)
                        End If
                     End If
                  End If
*                                                                      *
************************************************************************
*                                                                      *
               End Do
            End Do
         End Do ! jS
      End Do ! iS
*                                                                      *
************************************************************************
*                                                                      *
      Case (.TRUE.)   ! Cho-Fock Algorithm
*                                                                      *
************************************************************************
*                                                                      *
        Fake_CMO2=.true.
        DoAct=.true.
*
**      Construct inactive density matrix
*
        call dcopy_(nDens2,[0.0d0],0,temp2,1)
        Do is=1,nSym
          Do iB=1,nIsh(is)
            ip=ipCM(iS)+(ib-1)*nOrb(is)+ib-1
            Temp2(ip)=2.0d0
          End Do
        End Do
*
**      Transform to AO basis
*
        Do iS=1,nSym
           If (nIsh(iS).ne.0) Then
              jS=iS
              Call DGEMM_('T','T',nIsh(jS),nOrb(iS),nIsh(iS),
     &                    1.0d0,Temp2(ipCM(iS)),nOrb(iS),
     &                    W_CMO(ipCM(is)),nOrb(iS),
     &                    0.0d0,Temp3(ipMat(jS,iS)),nOrb(jS))
              Call DGEMM_('T','T',nOrb(jS),nOrb(jS),nIsh(iS),
     &                    1.0d0,Temp3(ipMat(jS,iS)),nOrb(iS),
     &                    W_CMO(ipCM(js)),nOrb(jS),
     &                    0.0d0,Temp2(ipCM(iS)),nOrb(jS))
           EndIf
        End Do
*
        Call Allocate_DT(DLT,nBas,nBas,nSym,aCase='TRI')
        call Fold_Mat(nSym,nOrb,Temp2,DLT%A0)
*
**      Form active CMO and density
*
        nAct=0
        If (iMethod.eq.iCASSCF) Then
          na2=0
          nG2=0
          Do iSym=1,nSym
            na2=na2+nAsh(iSym)**2
            nAct=nAct+nAsh(iSym)
            nAG2=0
            Do jSym=1,nSym
              kSym=iEOr(jsym-1,isym-1)+1
              nAG2=nAg2+nAsh(jSym)*nAsh(kSym)
            End Do
            nG2=nG2+nAG2**2
          End Do
          Call Allocate_DT(CVa(1),nAsh,nOrb,nSym)
          CVa(1)%A0(:)=0.0D0
          Call Allocate_DT(CVa(2),nAsh,nOrb,nSym)
          CVa(2)%A0(:)=0.0D0
          Call Allocate_DT(DA,nAsh,nAsh,nSym)
*
          ioff=0
          Do iSym=1,nSym
            ioff2 = ioff + nOrb(iSym)*nIsh(iSym)
            do ikk=1,nAsh(iSym)
               ioff3=ioff2+nOrb(iSym)*(ikk-1)
               CVa(1)%SB(iSym)%A2(ikk,:) =
     &            W_CMO(ioff3+1:ioff3+nOrb(iSym))
               ik=ikk+nA(iSym)
               Do ill=1,ikk-1
                 il=ill+nA(iSym)
                 ikl=ik*(ik-1)/2+il
                 DA%SB(iSym)%A2(ill,ikk)=G1t(ikl)
                 DA%SB(iSym)%A2(ikk,ill)=G1t(ikl)
               End Do
               ikl=ik*(ik-1)/2+ik
               DA%SB(iSym)%A2(ikk,ikk)=G1t(ikl)
            End Do
            ioff=ioff+nOrb(iSym)**2
          End Do
          DA%A0(:) = Half * DA%A0(:)
*
**      Expand 2-body density matrix
*
          Call mma_allocate(G2x,nG2,Label='G2x')
          ipGx=0
          Do ijS=1,nSym
            Do iS=1,nSym
              jS=iEOR(is-1,ijS-1)+1
              Do kS=1,nSym
                lS=iEOR(kS-1,ijS-1)+1
                Do kAsh=1,nAsh(ks)
                  Do lAsh=1,nAsh(ls)
                    ikl=itri(lAsh+nA(lS),kAsh+nA(kS))
                    Do iAsh=1,nAsh(is)
                      Do jAsh=1,nAsh(js)
                        iij =itri(iAsh+nA(is),jAsh+nA(jS))
                        ipGx=ipGx+1
                        G2x(ipGx)=G2t(itri(iij,ikl))
                      End Do
                    End Do
                  End Do
                End Do
              End Do
            End Do
          End Do
        Else
          na2=1
          nG2=1
          Call Allocate_DT(CVa(1),[1],[1],1) ! dummy allocation
          Call Allocate_DT(CVa(2),[1],[1],1)
          Call Allocate_DT(DA,nAsh,nAsh,nSym)
          Call mma_allocate(G2x,nG2,Label='G2x')
        EndIf
*
**      Let's go
*
        Call Allocate_DT(JA,nBas,nBas,nSym)
        JA%A0(:)=Zero
        Call Allocate_DT(KA,nBas,nBas,nSym)
        KA%A0(:)=Zero
*
        call dcopy_(nDens2,[0.0d0],0,Q,1)
*
        Call Allocate_DT(DI,nBas,nBas,nSym,Ref=Temp2)
        Call Allocate_DT(JI(1),nBas,nBas,nSym,aCase='TRI',Ref=Temp3)
        JI(1)%A0(:)=Zero
        Call Allocate_DT(KI,nBas,nBas,nSym,Ref=Scr)
        KI%A0(:)=Zero
        Call Allocate_DT(FkI,nBas,nBas,nSym,Ref=FockI)
        FkI%A0(:)=Zero
        Call Allocate_DT(FkA,nBas,nBas,nSym,Ref=FockA)
        FkA%A0(:)=Zero
        Call Allocate_DT(QVec,nBas,nAsh,nSym,Ref=Q)
        Call Allocate_DT(CMO,nBas,nBas,nSym,Ref=W_CMO)
        Call Allocate_DT(CMO_Inv,nBas,nBas,nSym,Ref=W_CMO_Inv)
        istore=1 ! Ask to store the half-transformed vectors

        CALL CHO_LK_MCLR(DLT,DI,DA,G2x,Kappa,JI,KI,JA,KA,FkI,FkA,
     &                   MO1,QVec,CVa,CMO,CMO_inv,
     &                   nIsh,nAsh,doAct,Fake_CMO2,
     &                   LuAChoVec,LuIChoVec,istore)

        nAtri=nAct*(nAct+1)/2
        nAtri=nAtri*(nAtri+1)/2
        Call DScal_(nAtri,0.25D0,MO1,1)
        FkI%A0(:) = -Half * FkI%A0(:)
*
        Call Deallocate_DT(CMO_Inv)
        Call Deallocate_DT(CMO)
        Call Deallocate_DT(QVec)
        Call Deallocate_DT(FkA)
        Call Deallocate_DT(FkI)
        Call Deallocate_DT(KI)
        Call Deallocate_DT(JI(1))
        Call Deallocate_DT(DI)
        Call Deallocate_DT(JA)
        Call Deallocate_DT(KA)
        Call deallocate_DT(DLT)
        Call mma_deallocate(G2x)
        Call Deallocate_DT(CVa(2))
        Call Deallocate_DT(CVa(1))
        Call deallocate_DT(DA)
*
        Call GADSum(FockI,nDens2)
        Call GADSum(FockA,nDens2)
        Call GADSum(    Q,nDens2)
        Call GADSum(  MO1,nAtri)
*                                                                      *
************************************************************************
*                                                                      *
      End Select
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Do iSym = 1, nSym
        Write (6,*) 'iSym=',iSym
        Call RecPrt('FockI',' ',FockI(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
        Call RecPrt('FockA',' ',FockA(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
        Call RecPrt('Q',' ',Q(ipMatba(iSym,iSym)),nOrb(iSym),nAsh(iSym))
      End Do
      nAtri=nas*(nas+1)/2
      nAtri=nAtri*(nAtri+1)/2
      Call RecPrt('MO1',' ',MO1,1,nAtri)
#endif
      Call DaXpY_(ndens2,One,Int1,1,FockI,1)
      call dcopy_(ndens2,[0.0d0],0,Fock,1)
*
      Do iS=1,nSym
         If (nOrb(iS).eq.0) Go To 300
*
         If (nIsh(iS).gt.0)
     &      Call DYaX(nOrb(iS)*nIsh(is),2.0d0,
     &                FockI(ipCM(iS)),1,
     &                Fock (ipCM(iS)),1)
         If (iMethod.eq.iCASSCF) Then
            If (nIsh(iS).gt.0)
     &         Call DaXpY_(nOrb(iS)*nIsh(is),2.0d0,
     &                    FockA(ipCM(iS)),1,
     &                    Fock (ipCM(iS)),1)
            If (nAsh(iS).gt.0)
     &         Call DYaX(nOrb(iS)*nAsh(is),1.0d0,
     &                   Q(ipMatba(iS,is)),1,
     &                   Fock(ipCM(iS)+nIsh(is)*nOrb(is)),1)
            Do iAsh=1,nAsh(is)
               ipi=ipCM(iS)+nOrb(is)*(nIsh(is)+iAsh-1)
               Do jAsh=1,nAsh(is)
                  ipj=ipCM(iS)+nOrb(is)*(nIsh(is)+jAsh-1)
                  ni=nA(is)+iAsh
                  nj=nA(is)+jAsh
                  ipD=iTri(ni,nj)
                  call daxpy_(nOrb(is),G1t(ipD),
     &                       FockI(ipi),1,
     &                       Fock (ipj),1)
               End Do
            End Do
         End If
*
 300     Continue
      End Do
 101  Continue
      renergy=0.0d0
      rcora=0.0d0
      Do iS=1,nSym
      Do iB=1,nAsh(is)+nIsh(is)
      rEnergy=rEnergy+Fock(ipCM(is)+nOrb(iS)*(ib-1)+ib-1)
      End Do
      End Do
      rcorei=0.0d0
      rcorea=0.0d0
      rcor=0.0d0
      Do iS=1,nSym
       iptmp=ipCM(iS)
       Do iB=1,nIsh(is)
       rcorei=rcorei+2.0d0*Int1(iptmp)
       rcor=rcor+2.0d0*Focki(iptmp)
       iptmp=iptmp+nOrb(iS)+1
       End Do

       Do iB=1,nAsh(iS)
        Do jB=1,nAsh(iS)
         iiB=nA(iS)+ib
         ijB=nA(iS)+jb
         iij=iTri(iib,ijb)
         iiB=nIsh(iS)+ib
         ijB=nIsh(iS)+jb
         rcorea=rcorea+G1t(iij)*Int1(ipCM(is)-1+nOrb(is)*(iib-1)+ijB)

         rcora=rcora+G1t(iij)*Focki(ipCM(is)+nOrb(is)*(iib-1)+ijB-1)
        End Do
       End Do
      End Do
      rin_ene=0.5d0*(rcor+rcorei)
      rcore=rCorei+rcoreA
      If (debug) Then
         Write(6,*) 'Checking energy',0.5d0*renergy+potnuc+half*rcore
         Write(6,*) 'Checking energy',0.5d0*renergy,potnuc,half*rcore
         write(6,*)
      End if

      If(TwoStep.and.(StepType.eq.'RUN1')) Then
        iaddressQDAT=0
        Call ddafile(LuQDAT,1,FockA,nDens2,iaddressQDAT)
        Call ddafile(LuQDAT,1,FockI,nDens2,iaddressQDAT)
        Call ddafile(LuQDAT,1,Fock ,nDens2,iaddressQDAT)
        Call ddafile(LuQDAT,1,Q    ,nDens2,iaddressQDAT)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_qlm_utils

   USE fmm_global_paras
   USE fmm_stats
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_renormalise_qlm,             &
             fmm_sort_paras_wrt_centre,       &
             fmm_assign_batches,              &
             fmm_factor_in_dens,              &
             fmm_get_T_sym_qlm,               &
             fmm_pack_raw_moments,            &
             fmm_pack_raw_parameters

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_renormalise_qlm(LMAX,qlm)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)    :: LMAX
      REAL(REALK),   INTENT(INOUT) :: qlm(:,:)

      INTEGER(INTK) :: i,L,M,p,pp
      REAL(REALK)   :: pref

      ! prefactor to symmetrize T-matrix
      DO i = 1, SIZE(qlm,2)
         DO L = 0, LMAX
            pp = L*(L+1) +1
            DO M = -L, -1
               pref = -one/(SQRT(two*FACTORIAL(l-m)*FACTORIAL(l+m)))
               p = pp+M
               qlm(p,i) = pref*qlm(p,i)
            END DO
            pref = one/FACTORIAL(L)
            p = pp  ! M=0
            qlm(p,i) = pref*qlm(p,i)
            DO M = 1, L
               pref = ((-1)**m)/SQRT(two*FACTORIAL(l-m)*FACTORIAL(l+m))
               p = pp+M
               qlm(p,i) = pref*qlm(p,i)
            END DO
         END DO
      END DO

   CONTAINS

      REAL(REALK) FUNCTION FACTORIAL(n)
         IMPLICIT NONE
         INTEGER(INTK), INTENT(IN) :: n
         INTEGER(INTK) :: i
         FACTORIAL = 1
         DO i = n, 2, -1
            FACTORIAL = FACTORIAL*i
         END DO
      END FUNCTION FACTORIAL

   END SUBROUTINE fmm_renormalise_qlm

!-------------------------------------------------------------------------------

   RECURSIVE SUBROUTINE fmm_sort_paras_wrt_centre(xyz,paras)

      USE fmm_sort_paras, ONLY: fmm_quicksort_wrt_vector

      IMPLICIT NONE
      INTEGER(INTK),      INTENT(IN)    :: xyz
      TYPE(raw_mm_paras), INTENT(INOUT) :: paras(:)

      INTEGER(INTK) :: i, lo, hi
      REAL(REALK)   :: q1,q2

      IF (SIZE(paras) == 1) RETURN

      ! sort only if needed
      q1 = paras(1)%cntr(xyz)
      DO i = 2, SIZE(paras)
         q2 = paras(i)%cntr(xyz)
         IF ( q2 < q1 ) THEN
            CALL fmm_quicksort_wrt_vector(paras,xyz)
            EXIT
         END IF
         q1 = q2
      END DO

      ! sub-sort next cartesian component
      lo = 1
      DO i = 2, SIZE(paras)
         q1 = paras(i-1)%cntr(xyz)
         q2 = paras(i)%cntr(xyz)
         IF ( q2 /= q1 ) THEN
            hi = i-1
            IF (xyz == 3) THEN
               RETURN
            ELSE
               CALL fmm_sort_paras_wrt_centre(xyz+1_INTK,paras(lo:hi))
            END IF
            lo = i
         END IF
      END DO

      ! do last batch
      hi = SIZE(paras)
      IF (xyz == 3) THEN
         RETURN
      ELSE
         CALL fmm_sort_paras_wrt_centre(xyz+1_INTK,paras(lo:hi))
      END IF

   END SUBROUTINE fmm_sort_paras_wrt_centre

!-------------------------------------------------------------------------------
! Identify batches of moments with same centre assuming sorted order and
! assign batch index to parameter list

   SUBROUTINE fmm_assign_batches(paras)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(INOUT) :: paras(:)

      INTEGER(INTK) :: i, batch
!FIXME
      REAL(REALK), PARAMETER :: TOLERANCE = 1.0D-20

      batch = 1
      paras(1)%batch = batch
      DO i = 2, SIZE(paras)
         IF (paras(i)%cntr(3) - paras(i-1)%cntr(3) > TOLERANCE) THEN
            batch = batch + 1
         ELSE IF (paras(i)%cntr(2) - paras(i-1)%cntr(2) > TOLERANCE) THEN
            batch = batch + 1
         ELSE IF (paras(i)%cntr(1) - paras(i-1)%cntr(1) > TOLERANCE) THEN
            batch = batch + 1
         END IF
         paras(i)%batch = batch
      END DO

   END SUBROUTINE fmm_assign_batches

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_factor_in_dens(dens,qlm)

      IMPLICIT NONE
      REAL(REALK), INTENT(IN)    :: dens(:)
      REAL(REALK), INTENT(INOUT) :: qlm(:,:)

      INTEGER(INTK) :: i

      DO i = 1, SIZE(qlm,2)
         qlm(:,i) = qlm(:,i)*dens(i)
      END DO

   END SUBROUTINE fmm_factor_in_dens

!-------------------------------------------------------------------------------
! Prefactorising moments to symmetrize modified T-matrix

   SUBROUTINE fmm_get_T_sym_qlm(LMAX,qlm_in,qlm_out)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: LMAX
      REAL(REALK),   INTENT(IN)  :: qlm_in(:,:)
      REAL(REALK),   INTENT(OUT) :: qlm_out(:,:)

      INTEGER(INTK) :: i,L,u, hi,lo
      REAL(REALK)   :: pref

      DO i = 1, SIZE(qlm_in,2)
         DO L = 0, LMAX
            u = L*(L+1) +1     ! m=0
            hi = u+L
            lo = u-L
            pref = two*((-1)**L)
            qlm_out(lo:hi,i) = pref*qlm_in(lo:hi,i)
            qlm_out(u,i) = half*pref*qlm_in(u,i)
         END DO
      END DO

   END SUBROUTINE fmm_get_T_sym_qlm

!-------------------------------------------------------------------------------
! Get number of unique batches;
! Also check raw_paras are sorted by batch;
! Do this by checking the batch ID is always increasing

   SUBROUTINE get_nbatch(paras,nbatch)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(IN)  :: paras(:)
      INTEGER(INTK),      INTENT(OUT) :: nbatch
      INTEGER(INTK) :: i, ndim

      ndim = SIZE(paras)
      nbatch = 1
      DO i = 2, ndim
         IF ( paras(i)%batch < paras(i-1)%batch ) THEN
            CALL fmm_quit('batches of packed moments not sorted!')
         END IF
         ! some batch numbers are skipped so need to take care of this
         IF ( paras(i)%batch /= paras(i-1)%batch ) THEN
            nbatch = nbatch + 1
         END IF
      END DO

   END SUBROUTINE get_nbatch

!-------------------------------------------------------------------------------

   SUBROUTINE get_pkd_data(add_dens,raw_mms,pkd_paras,pkd_qlm)

      IMPLICIT NONE
      LOGICAL,            INTENT(IN)  :: add_dens
      TYPE(raw_mm_data),  INTENT(IN)  :: raw_mms
      TYPE(raw_mm_paras), INTENT(OUT) :: pkd_paras(:)
      REAL(REALK),        INTENT(OUT) :: pkd_qlm(:,:)
      INTEGER(INTK) :: i,j,k, last_batch

      j = 0
      last_batch = -1
      DO i = 1, SIZE(raw_mms%paras)
         ! Use mapping of raw parameters to raw moments
         k = raw_mms%paras(i)%id
         IF ( raw_mms%paras(i)%batch == last_batch ) THEN
            ! Element same batch as previous
            IF (add_dens) THEN
               pkd_qlm(:,j) = pkd_qlm(:,j) + raw_mms%qlm(:,k)*raw_mms%dens(k)
            ELSE
               pkd_qlm(:,j) = pkd_qlm(:,j) + raw_mms%qlm(:,k)
            END IF
         ELSE
            ! Element in new batch
            j = j + 1
            pkd_paras(j) = raw_mms%paras(i)
            IF (add_dens) THEN
               pkd_qlm(:,j) = raw_mms%qlm(:,k)*raw_mms%dens(k)
            ELSE
               pkd_qlm(:,j) = raw_mms%qlm(:,k)
            END IF
         END IF
         last_batch = raw_mms%paras(i)%batch
      END DO

   END SUBROUTINE get_pkd_data

!-------------------------------------------------------------------------------

   SUBROUTINE get_screened_nmom(screen_thr,qlm,skip,nskip)

      IMPLICIT NONE
      REAL(REALK),   INTENT(IN)  :: screen_thr
      REAL(REALK),   INTENT(IN)  :: qlm(:,:)
      LOGICAL,       INTENT(OUT) :: skip(:)
      INTEGER(INTK), INTENT(OUT) :: nskip
      INTEGER(INTK) :: i,j

      nskip = 0
      batches: DO i = 1, SIZE(qlm,2)
         skip(i) = .TRUE.
         nskip = nskip + 1
         lm_loop: DO j = 1, SIZE(qlm,1)
            IF ( ABS(qlm(j,i)) > screen_thr ) THEN
               skip(i) = .FALSE.
               nskip = nskip - 1
               EXIT lm_loop
            END IF
         END DO lm_loop
      END DO batches

   END SUBROUTINE get_screened_nmom

!-------------------------------------------------------------------------------
! Here we squeeze all the significant batches of moments to be sequential
! at the top of the array, with all the insignificant moments overwritten;
! we use skip(:) as a logical mask to direct the skipping.

   SUBROUTINE squeeze_significant_batches(skip,paras,qlm)

      IMPLICIT NONE
      LOGICAL,            INTENT(IN)    :: skip(:)
      TYPE(raw_mm_paras), INTENT(INOUT) :: paras(:)
      REAL(REALK),        INTENT(INOUT) :: qlm(:,:)
      INTEGER(INTK) :: i, j

      IF (SIZE(paras) /= SIZE(qlm,2)) STOP 'paras and qlm should be same size!'
      IF (SIZE(paras) /= SIZE(skip)) STOP 'paras and skip should be same size!'

      j = 0
      DO i = 1, SIZE(paras)
         IF (skip(i)) CYCLE
         j = j + 1
         paras(j) = paras(i)
         qlm(:,j) = qlm(:,i)
      END DO

   END SUBROUTINE squeeze_significant_batches

!-------------------------------------------------------------------------------
! Routine to pack a set of raw moments by batches,
! where members of a batch share a common centre and extent,
! including density factoring and screening if requested.
! Note that no record is kept of the packing for later "unpacking".

   SUBROUTINE fmm_pack_raw_moments(mm_data,dens,dens_thr)

      IMPLICIT NONE
      TYPE(raw_mm_data),  INTENT(INOUT) :: mm_data
      LOGICAL,            INTENT(IN)    :: dens
      REAL(REALK),        INTENT(IN)    :: dens_thr

      TYPE(raw_mm_paras), ALLOCATABLE :: pkd_paras(:)
      REAL(REALK), ALLOCATABLE :: pkd_qlm(:,:)
      LOGICAL, ALLOCATABLE :: skip(:)
      INTEGER(INTK) :: nbatch, nskip, foo, ndim

      ! Get number of unique batches
      CALL get_nbatch(mm_data%paras,nbatch)

      ! Now build packed data by summing raw data in the same batch
      ALLOCATE (pkd_paras(nbatch))
      foo = SIZE(mm_data%qlm,1)
      ALLOCATE (pkd_qlm(foo,nbatch))
      CALL get_pkd_data(dens,mm_data,pkd_paras,pkd_qlm)
      ndim = nbatch

      IF ( dens ) THEN
         ! Perform density-based screening;
         ! Note we do not reallocate whole array, but push all the
         ! significant terms to the top, and only this array section
         ! of significant moments is then pointed to.
         ALLOCATE (skip(nbatch))
         CALL get_screened_nmom(dens_thr,pkd_qlm,skip,nskip)
         ndim = nbatch - nskip  ! number of significant moments
         CALL squeeze_significant_batches(skip,pkd_paras,pkd_qlm)
         DEALLOCATE (skip)
      END IF

      ! This is just for statistics
      stat_pkd_moms_RHS = nbatch
      stat_screened_moms_RHS = ndim

      ! Reallocate the original moments and copy across the packed ones
      DEALLOCATE (mm_data%paras, mm_data%qlm)
      NULLIFY (mm_data%paras, mm_data%qlm)
      ALLOCATE (mm_data%paras(ndim), mm_data%qlm(foo,ndim))
      mm_data%paras(:) = pkd_paras(:ndim)
      mm_data%qlm(:,:) = pkd_qlm(:,:ndim)

      DEALLOCATE (pkd_paras, pkd_qlm)

   END SUBROUTINE fmm_pack_raw_moments

!-------------------------------------------------------------------------------
! Routine to drive the packing of a set of raw mm parameters by batches,
! where members of a batch share a common centre and extent,
! including the build of a mapping between the packed paras and the
! original raw paras.  This map can be used for later "unpacking".

   SUBROUTINE fmm_pack_raw_parameters(mm_data)

      IMPLICIT NONE
      TYPE(raw_mm_data), INTENT(INOUT) :: mm_data

      TYPE(raw_mm_paras), ALLOCATABLE :: pkd_paras(:)
      INTEGER(INTK) :: i,j, nbatch, last_batch

      ! Get number of unique batches;
      CALL get_nbatch(mm_data%paras,nbatch)
      stat_pkd_moms_LHS = nbatch

      ! Initialise packed paras and batch map
      ALLOCATE(pkd_paras(nbatch))
      ALLOCATE(mm_data%batch_map(nbatch))
      DO i = 1, nbatch
         mm_data%batch_map(i)%occ = 0
         NULLIFY( mm_data%batch_map(i)%head )
      END DO

      ! Now build packed paras by compressing raw paras in same batch
      j = 0
      last_batch = -1
      DO i = 1, SIZE(mm_data%paras)
         IF ( mm_data%paras(i)%batch == last_batch ) THEN
            ! Add raw parameter mapping to existing linked-list for this batch
            CALL add_batch_item(mm_data%batch_map(j),mm_data%paras(i)%id)
         ELSE
            ! Element in new batch
            j = j + 1
            pkd_paras(j) = mm_data%paras(i)
            ! Linked-list for this batch is empty, so start one
            mm_data%batch_map(j)%occ = 1
            ALLOCATE( mm_data%batch_map(j)%head )
            ! Maintain mapping between parameters and moments
            mm_data%batch_map(j)%head%id = mm_data%paras(i)%id
            NULLIFY( mm_data%batch_map(j)%head%next ) ! rest of list is empty
         END IF
         last_batch = mm_data%paras(i)%batch
      END DO

      ! Reallocate the original parameters and copy across the packed ones
      DEALLOCATE (mm_data%paras)
      NULLIFY (mm_data%paras)
      ALLOCATE (mm_data%paras(nbatch))
      mm_data%paras(:) = pkd_paras(:)

      DEALLOCATE (pkd_paras)

   CONTAINS

      SUBROUTINE add_batch_item(batch_list,raw_id)

         IMPLICIT NONE
         TYPE(id_list), INTENT(INOUT) :: batch_list
         INTEGER(INTK), INTENT(IN)    :: raw_id
         TYPE(id_node), POINTER :: new_node

         batch_list%occ = batch_list%occ + 1
         ALLOCATE( new_node )
         new_node%id = raw_id
         IF (ASSOCIATED(batch_list%head%next)) THEN
            ! More than one entry in list (including head)
            ! so point new_node to old second entry
            new_node%next => batch_list%head%next
            ! Point head to new_node
            NULLIFY(batch_list%head%next)
            batch_list%head%next => new_node
         ELSE
            ! Only head so far; make new_node our second entry
            batch_list%head%next => new_node
            NULLIFY(new_node%next)   ! end of list
         END IF

      END SUBROUTINE add_batch_item

   END SUBROUTINE fmm_pack_raw_parameters

!-------------------------------------------------------------------------------

END MODULE fmm_qlm_utils

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Walter Gautschi                                  *
!               1994, Gene H. Golub                                    *
!               2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

module RysScratch
! Compute Rys roots and weights from scratch

use Definitions, only: wp, iwp

implicit none
private

! WhichQuad: which shifted Legendre quadrature to use
!            (number of points would be 24,27,30,34,37,39,42,45,46,50,51,54,56,59,61,63,66,68,70,73,300)
! TAsymp: asymptotic limit for the t parameter, for values larger than
!         this, the scaled Hermite quadrature is accurate enough.
!         These values are quite conservative, with estimated errors
!         below 1e-16.

integer(kind=iwp), parameter :: naux(11) = [30,35,40,45,50,55,60,65,70,75,300], &
                                WhichQuad(21) = [1,1,1,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,9,10,size(naux)]
real(kind=wp), parameter :: TAsymp(20) = [39.0_wp,47.0_wp,54.0_wp,60.0_wp,66.0_wp,72.0_wp,78.0_wp,83.0_wp,89.0_wp,94.0_wp,99.0_wp, &
                                          104.0_wp,109.0_wp,115.0_wp,120.0_wp,125.0_wp,130.0_wp,134.0_wp,139.0_wp,144.0_wp]
real(kind=wp), allocatable :: Leg_r(:,:), Leg_w(:,:)

public :: RysRtsWgh, SetAux, UnSetAux

contains

! Compute and store roots and weights for a shifted Legendre quadrature,
! used for boot-strapping Rys roots and weights.
! Different sets of roots and weights are computed

subroutine SetAux(eps)

  use stdalloc, only: mma_allocate, mma_deallocate
  use Constants, only: One, Four, Half, Quart
  use Definitions, only: u6

  real(kind=wp), intent(in) :: eps
  integer(kind=iwp) :: Err, i, j, maux
  real(kind=wp), allocatable :: a(:), b(:)
  integer(kind=iwp), parameter :: nquad = size(naux)

  if (allocated(Leg_r)) return
  maux = maxval(naux)
  call mma_allocate(Leg_r,maux,nquad,label='Leg_r')
  call mma_allocate(Leg_w,maux,nquad,label='Leg_w')
  call mma_allocate(a,maux)
  call mma_allocate(b,maux)
  do j=1,nquad
    a(1:naux(j)) = Half
    b(1) = One
    do i=2,naux(j)
      b(i) = Quart/(Four-One/(i-1)**2)
    end do
    call GaussQuad(naux(j),a,b,eps,Leg_r(1,j),Leg_w(1,j),Err)
    if (Err /= 0) then
      write(u6,*) Err
      call WarningMessage(2,'Error in GaussQuad')
      call AbEnd()
    end if
    Leg_r(1:naux(j),j) = Leg_r(1:naux(j),j)**2
  end do
  call mma_deallocate(a)
  call mma_deallocate(b)

end subroutine SetAux

subroutine UnSetAux()

  use stdalloc, only: mma_deallocate

  if (allocated(Leg_r)) call mma_deallocate(Leg_r)
  if (allocated(Leg_w)) call mma_deallocate(Leg_w)

end subroutine UnSetAux

! Compute Rys roots and weights from scratch:
! - For high t values use the asymptotic scaled Hermite quadrature
! - For lower t, get first alpha and beta from the auxiliary Legendre
!   quadrature, then compute roots and weights

subroutine RysRtsWgh(TValues,nT,Roots,Weights,Order)

  use vRys_RW, only: HerR2, HerW2, iHerR2, iHerW2
  use Gateway_global, only: asymptotic_Rys
  use stdalloc, only: mma_allocate, mma_deallocate
  use Constants, only: Five
  use Definitions, only: u6

  integer(kind=iwp), intent(in) :: nT, Order
  real(kind=wp), intent(in) :: TValues(nT)
  real(kind=wp), intent(out) :: Roots(Order,nT), Weights(Order,nT)
  integer(kind=iwp) :: i, iquad, Err
  real(kind=wp) :: Alpha(Order), Beta(Order), TA
  real(kind=wp), allocatable :: a(:), b(:)
  real(kind=wp), parameter :: eps = 1.0e-16_wp

  if (Order > size(TAsymp)) then
    ! Rough fit for asymptotic T
    TA = 50.0_wp+Five*Order
  else
    TA = TAsymp(Order)
  end if

  do i=1,nT
    if ((TValues(i) > TA) .or. asymptotic_Rys) then
      Roots(:,i) = HerR2(iHerR2(Order):iHerR2(Order)+Order-1)/TValues(i)
      Weights(:,i) = HerW2(iHerW2(Order):iHerW2(Order)+Order-1)/sqrt(TValues(i))
    else
      iquad = WhichQuad(min(Order,size(WhichQuad)))
      call mma_allocate(a,naux(iquad))
      call mma_allocate(b,naux(iquad))
      a(1:naux(iquad)) = Leg_r(1:naux(iquad),iquad)
      b(1:naux(iquad)) = Leg_w(1:naux(iquad),iquad)*exp(-TValues(i)*a(1:naux(iquad)))
      call Lanczos(Order,naux(iquad),a,b,Alpha,Beta,Err)
      if (Err /= 0) then
        write(u6,*) Err
        call WarningMessage(2,'Error in Lanczos')
        call AbEnd()
      end if
      call GaussQuad(Order,Alpha,Beta,eps,Roots(1,i),Weights(1,i),Err)
      if (Err /= 0) then
        write(u6,*) Err
        call WarningMessage(2,'Error in GaussQuad 2')
        call AbEnd()
      end if
      call mma_deallocate(a)
      call mma_deallocate(b)
    end if
  end do

end subroutine RysRtsWgh

!***********************************************************************
! Routines GaussQuad and Lanczos adapted from:
!
! Algorithm 726: ORTHPOL -- A package of Routines for Generating
! Orthogonal Polynomials and Gauss-Type Quadrature Rules
!   Walter Gautschi. ACM Trans. Math. Softw. 20 (1994) 21-62
!   doi:10.1145/174603.174605
!***********************************************************************

subroutine GaussQuad(n,alpha,beta,eps,roots,weights,ierr)
! Given  n  and a measure  dlambda, this routine generates the n-point
! Gaussian quadrature formula
!
!     integral over supp(dlambda) of f(x)dlambda(x)
!
!        = sum from k=1 to k=n of w(k)f(x(k)) + R(n;f).
!
! The nodes are returned as  roots(k)=x(k) and the weights as
! weights(k)=w(k), k=1,2,...,n. The user has to supply the recursion
! coefficients  alpha(k), beta(k), k=0,1,2,...,n-1, for the measure
! dlambda. The routine computes the nodes as eigenvalues, and the
! weights in term of the first component of the respective normalized
! eigenvectors of the n-th order Jacobi matrix associated with  dlambda.
! It uses a translation and adaptation of the algol procedure  imtql2,
! Numer. Math. 12, 1968, 377-383, by Martin and Wilkinson, as modified
! by Dubrulle, Numer. Math. 15, 1970, 450. See also Handbook for
! Autom. Comput., vol. 2 - Linear Algebra, pp.241-248, and the eispack
! routine  imtql2.
!
!        Input:  n - - the number of points in the Gaussian quadrature
!                      formula; type integer
!                alpha,beta - arrays of dimension  n  to be filled
!                      with the values of  alpha(k-1), beta(k-1), k=1,2,
!                      ...,n
!                eps - the relative accuracy desired in the nodes
!                      and weights
!
!        Output: roots - array of dimension  n  containing the Gaussian
!                      nodes (in increasing order)  roots(k)=x(k), k=1,2,
!                      ...,n
!                weights - array of dimension  n  containing the
!                      Gaussian weights  weights(k)=w(k), k=1,2,...,n
!                ierr - an error flag equal to  0  on normal return,
!                      equal to  i  if the QR algorithm does not
!                      converge within 30 iterations on evaluating the
!                      i-th eigenvalue, equal to  -1  if  n  is not in
!                      range, and equal to  -2  if one of the beta's is
!                      negative.

  use stdalloc, only: mma_allocate, mma_deallocate
  use Constants, only: Zero, One, Two

  integer(kind=iwp), intent(in) :: n
  real(kind=wp), intent(in) :: alpha(n), beta(n), eps
  real(kind=wp), intent(out) :: roots(n), weights(n)
  integer(kind=iwp), intent(out) :: ierr
  integer(kind=iwp) :: i, ii, j, k, l, m, mml
  real(kind=wp) :: b, c, f, g, p, r, s
  real(kind=wp), allocatable :: e(:)
  integer(kind=iwp), parameter :: maxcyc = 30

  ierr = 0
  if (n < 1) then
    ierr = -1
    return
  end if

  ! Initialization

  call mma_allocate(e,n,label='e')
  roots(:) = alpha
  weights(:) = Zero
  if (any(beta < Zero)) then
    ierr = -2
    return
  end if
  e(1:n-1) = sqrt(beta(2:n))
  if (n == 1) then
    weights(1) = beta(1)
    return
  else
    weights(1) = One
    e(n) = Zero
  end if

  ! Loop over roots

  do l=1,n
    do j=1,maxcyc

      ! Look for a small subdiagonal element.

      do m=l,n-1
        if (abs(e(m)) <= eps*(abs(roots(m))+abs(roots(m+1)))) exit
      end do
      p = roots(l)
      if (m == l) exit

      ! Form shift.

      g = (roots(l+1)-p)/(Two*e(l))
      r = sqrt(g*g+One)
      g = roots(m)-p+e(l)/(g+sign(r,g))
      s = One
      c = One
      p = Zero
      mml = m-l

      ! For i=m-1 step -1 until l do ...

      do ii=1,mml
        i = m-ii
        f = s*e(i)
        b = c*e(i)
        if (abs(f) < abs(g)) then
          s = f/g
          r = sqrt(s*s+One)
          e(i+1) = g*r
          c = One/r
          s = s*c
        else
          c = g/f
          r = sqrt(c*c+One)
          e(i+1) = f*r
          s = One/r
          c = c*s
        end if
        g = roots(i+1)-p
        r = (roots(i)-g)*s+Two*c*b
        p = s*r
        roots(i+1) = g+p
        g = c*r-b

        ! Form first component of vector.

        f = weights(i+1)
        weights(i+1) = s*weights(i)+c*f
        weights(i) = c*weights(i)-s*f
      end do
      roots(l) = roots(l)-p
      e(l) = g
      e(m) = Zero
    end do

    ! Set error - no convergence to an eigenvalue after maxcyc iterations.

    if (j > maxcyc) then
      ierr = l
      return
    end if
  end do
  call mma_deallocate(e)

  ! Order eigenvalues and eigenvectors.

  do ii=2,n
    i = ii-1
    k = i
    p = roots(i)
    do j=ii,n
      if (roots(j) < p) then
        k = j
        p = roots(j)
      end if
    end do
    if (k /= i) then
      roots(k) = roots(i)
      roots(i) = p
      p = weights(i)
      weights(i) = weights(k)
      weights(k) = p
    end if
  end do
  weights(:) = beta(1)*weights**2

  return

end subroutine GaussQuad

subroutine Lanczos(n,ncap,x,w,alpha,beta,ierr)
! This routine carries out the same task as the routine  sti, but
! uses the more stable Lanczos method. The meaning of the input
! and output parameters is the same as in the routine  sti. (This
! routine is adapted from the routine RKPW in W.B. Gragg and
! W.J. Harrod, "The numerically stable reconstruction of Jacobi
! matrices from spectral data", Numer. Math. 44, 1984, 317-335.)
!
! Routine sti:
!
! This routine applies "Stieltjes's procedure" (cf. Section 2.1 of
! W. Gautschi, "On generating orthogonal polynomials", SIAM J. Sci.
! Statist. Comput. 3, 1982, 289-317) to generate the recursion
! coefficients  alpha(k), beta(k) , k=0,1,...,n-1, for the discrete
! (monic) orthogonal polynomials associated with the inner product
!
!     (f,g)=sum over k from 1 to ncap of w(k)*f(x(k))*g(x(k)).
!
! The integer  n  must be between  1  and  ncap, inclusive; otherwise,
! there is an error exit with  ierr=1. The results are stored in the
! arrays  alpha, beta.
!
! If there is a threat of underflow or overflow in the calculation
! of the coefficients  alpha(k)  and  beta(k), the routine exits with
! the error flag  ierr  set equal to  -k  (in the case of underflow)
! or  +k  (in the case of overflow), where  k  is the recursion index
! for which the problem occurs. The former [latter] can often be avoided
! by multiplying all weights  w(k)  by a sufficiently large [small]
! scaling factor prior to entering the routine, and, upon exit, divide
! the coefficient  beta(0)  by the same factor.
!
! This routine should be used with caution if  n  is relatively close
! to  ncap, since there is a distinct possibility of numerical
! instability developing. (See W. Gautschi, "Is the recurrence relation
! for orthogonal polynomials always stable?", BIT, 1993, to appear.)
! In that case, the routine  lancz  should be used.

  use stdalloc, only: mma_allocate, mma_deallocate
  use Constants, only: Zero, One

  integer(kind=iwp), intent(in) :: n, ncap
  real(kind=wp), intent(in) :: x(ncap), w(ncap)
  real(kind=wp), intent(out) :: alpha(n), beta(n)
  integer(kind=iwp), intent(out) :: ierr
  integer(kind=iwp) :: i, k
  real(kind=wp) :: gam, pj, rho, sig, t, tk, tmp, tsig, xlam
  real(kind=wp), allocatable :: p0(:), p1(:)

  ierr = 0
  if ((n <= 0) .or. (n > ncap)) then
    ierr = 1
    return
  end if
  call mma_allocate(p0,ncap,label='p0')
  call mma_allocate(p1,ncap,label='p1')
  p0(:) = x
  p1(:) = Zero
  p1(1) = w(1)
  do i=1,ncap-1
    pj = w(i+1)
    gam = One
    sig = Zero
    t = Zero
    xlam = x(i+1)
    do k=1,i+1
      rho = p1(k)+pj
      tmp = gam*rho
      tsig = sig
      if (rho <= Zero) then
        gam = One
        sig = Zero
      else
        gam = p1(k)/rho
        sig = pj/rho
      end if
      tk = sig*(p0(k)-xlam)-gam*t
      p0(k) = p0(k)-(tk-t)
      t = tk
      if (sig <= Zero) then
        pj = tsig*p1(k)
      else
        pj = (t**2)/sig
      end if
      tsig = sig
      p1(k) = tmp
    end do
  end do
  alpha(:) = p0(1:n)
  beta(:) = p1(1:n)
  call mma_deallocate(p0)
  call mma_deallocate(p1)

  return

end subroutine Lanczos

end module RysScratch

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GugaNew(CIL,imode,ksym)
*
      use Str_Info, only: CFTP, CNSM
      Implicit Real*8 (A-H,O-Z)
      Integer A0,B0,C0
*
#include "Input.fh"
#include "stdalloc.fh"
#include "detdim.fh"
#include "spinfo_mclr.fh"
      Real*8 CIL(*)
      Integer OrbSym(2*mxBas)
      Integer, Parameter:: iPrint=0
      Integer, Allocatable:: DRT0(:), DOWN0(:), TMP(:), V11(:), DRT(:),
     &                       DOWN(:), DAW(:), UP(:), RAW(:), LTV(:),
     &                       NOW(:), IOW(:), NOCSF(:), IOCSF(:), SCR(:),
     &                       ICASE(:), USGN(:), LSGN(:)
      Real*8, Allocatable:: CINEW(:)
*
*
      PRWTHR=0.05d0
*
      ntRas1=0
      ntRas2=0
      ntRas3=0
      Do iSym=1,nSym
         ntRas1=ntRas1+nRs1(iSym)
         ntRas2=ntRas2+nRs2(iSym)
         ntRas3=ntRas3+nRs3(iSym)
      End Do
*
      B0=iSpin-1
      A0=(nActEl-B0)/2
      C0=ntASh-A0-B0
      If ( (2*A0+B0).ne.nActEl ) then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine GUGACTL ***'
         Write (6,*) ' 2*A0+B0.ne.nActEl '
         Write (6,*)
      End If
      If ( A0.lt.0 ) then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine GUGACTL ***'
         Write (6,*) ' A0.lt.0'
         Write (6,*)
      End If
      If ( B0.lt.0 ) then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine GUGACTL ***'
         Write (6,*) ' B0.lt.0'
         Write (6,*)
      End If
      If ( C0.lt.0 ) then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine GUGACTL ***'
         Write (6,*) ' C0.lt.0'
         Write (6,*)
      End If
*
      iOrb=0
      Do iSym=1,nSym
         Do iBas=1,nRs1(iSym)
            iOrb=iOrb+1
            OrbSym(iOrb)=iSym
         End Do
      End Do
      Do iSym=1,nSym
         Do iBas=1,nRs2(iSym)
            iOrb=iOrb+1
            OrbSym(iOrb)=iSym
         End Do
      End Do
      Do iSym=1,nSym
         Do iBas=1,nRs3(iSym)
            iOrb=iOrb+1
            OrbSym(iOrb)=iSym
         End Do
      End Do
*
      NLEV=ntASh
      IAC=MIN(A0,C0)
      NVERT0=((A0+1)*(C0+1)*(2*B0+IAC+2))/2-(IAC*(IAC+1)*(IAC+2))/6
      NDRT0=5*NVERT0
      NDOWN0=4*NVERT0
      NTMP=((NLEV+1)*(NLEV+2))/2
      Call mma_allocate(DRT0,NDRT0,Label='DRT0')
      Call mma_allocate(DOWN0,NDOWN0,Label='DOWN0')
      Call mma_allocate(TMP,NTMP,Label='TMP')
      Call DRT0_MCLR (A0,B0,C0,NVERT0,DRT0,DOWN0,NTMP,TMP)
      If ( iPrint.ge.5 ) Call PRDRT_MCLR(NVERT0,DRT0,DOWN0)
      Call mma_deallocate(TMP)
*
      LV1RAS=ntRas1
      LV3RAS=LV1RAS+ntRas2
      LM1RAS=2*LV1RAS-nHole1
      LM3RAS=nActEl-nElec3
      Call mma_allocate(V11,NVERT0,Label='V11')
      Call RESTR_MCLR(NVERT0,DRT0,DOWN0,V11,LV1RAS,LV3RAS,LM1RAS,
     &                LM3RAS,NVERT)
*
      NDRT=5*NVERT
      NDOWN=4*NVERT
      Call mma_allocate(DRT,NDRT,Label='DRT')
      Call mma_allocate(DOWN,NDOWN,Label='DOWN')
      Call DRT_MCLR(NVERT0,NVERT,DRT0,DOWN0,V11,DRT,DOWN)
      If ( iPrint.ge.5 ) Call PRDRT_MCLR(NVERT,DRT,DOWN)
      Call mma_deallocate(V11)
      Call mma_deallocate(DRT0)
      Call mma_deallocate(DOWN0)
*
      NDAW=5*NVERT
      Call mma_allocate(DAW,NDAW,Label='DAW')
      Call MKDAW_MCLR(NVERT,DOWN,DAW,iPrint)
*
      NUP=4*NVERT
      NRAW=5*NVERT
      Call mma_allocate(UP,NUP,Label='UP')
      Call mma_allocate(RAW,NRAW,Label='RAW')
      Call MKRAW_MCLR(NVERT,DOWN,DAW,UP,RAW,iPrint)
*
      NLTV=NLEV+2
      Call mma_allocate(LTV,NLTV,Label='LTV')
      Call MKMID_MCLR(NVERT,NLEV,DRT,DOWN,DAW,UP,RAW,LTV,
     &                MIDLEV,NMIDV,MIDV1,MIDV2,MXUP,MXDWN,iPrint)
      Call mma_deallocate(LTV)
*
      NIPWLK=1+(MIDLEV-1)/15
      NIPWLK=MAX(NIPWLK,1+(NLEV-MIDLEV-1)/15)
      NNOW=2*NMIDV*nSym
      NIOW=NNOW
      NNOCSF=NMIDV*(nSym**2)
      NIOCSF=NNOCSF
      NSCR=3*(NLEV+1)
      Call mma_allocate(NOW,NNOW,Label='NOW')
      Call mma_allocate(IOW,NIOW,Label='IOW')
      Call mma_allocate(NOCSF,NNOCSF,Label='NOCSF')
      Call mma_allocate(IOCSF,NIOCSF,Label='IOCSF')
      Call mma_allocate(SCR,NSCR,Label='SCR')
      Call MKCOT_MCLR(nSym,NLEV,NVERT,MIDLEV,NMIDV,MIDV1,MIDV2,NWALK,
     &                NIPWLK,OrbSym,DOWN,NOW,IOW,NCSF,IOCSF,NOCSF,
     &                SCR,iPrint)
*
*     If ( nConf.ne.NCSF(state_sym) ) then
*        Write (*,*)
*        Write (*,*) ' *** Error in subroutine GUGACTL ***'
*        Write (*,*) ' Inconsistent, number of configurations'
*        Write (*,*)
*     End If
      NCONF=NCSF(kSym)
      iss=1
      if (ksym.ne.state_sym) iss=2
*
      NICASE=NWALK*NIPWLK
      Call mma_allocate(ICASE,NICASE,Label='ICASE')
      Call MKCLIST_MCLR(nSym,NLEV,NVERT,MIDLEV,MIDV1,MIDV2,NMIDV,NICASE,
     &                  NIPWLK,OrbSym,DOWN,NOW,IOW,ICASE,SCR,iPrint)
      Call mma_deallocate(SCR)
*
      NUSGN=MXUP*NMIDV
      NLSGN=MXDWN*NMIDV
      Call mma_allocate(USGN,NUSGN,Label='USGN')
      Call mma_allocate(LSGN,NLSGN,Label='LSGN')
      Call MKSGNUM_MCLR(ksym,nSym,NLEV,NVERT,MIDLEV,NMIDV,MXUP,MXDWN,
     &                  NICASE,NIPWLK,DOWN,UP,DAW,RAW,NOW,IOW,USGN,LSGN,
     &                  ICASE,iPrint)
*
      If (iPrint.ge.5) Then
      If (imode.eq.0.and.iAnd(kprint,8).eq.8) Then
      WRITE(6,101)
101   FORMAT(/,6X,100(1H-),/,
     &      6X,29X,'Wave function printout: Split Graph format',/,
     &      6X, 8X,'in paranthesis: midvertex, upper-walk symmetry',
     &             ' upper- and lower-walk serial numbers',/,
     &         6X,100(1H-),/)
      WRITE(6,102) PRWTHR
102   FORMAT(6X,'printout of CI-coefficients larger than',F6.2)
      Call SGPRWF_MCLR(ksym,PRWTHR,nSym,NLEV,NCONF,MIDLEV,NMIDV,NIPWLK,
     &                 NICASE,OrbSym,NOCSF,IOCSF,NOW,IOW,ICASE,CIL)
      WRITE(6,103)
103   FORMAT(/,6X,100(1H-),/)
      End If
      End If
*
      jPrint=iPrint
      Call mma_allocate(CInew,NCONF,Label='CINew')
      Call REORD(NLEV,NVERT,MIDLEV,MIDV1,MIDV2,NMIDV,MXUP,MXDWN,DRT,
     &           DOWN,DAW,UP,RAW,USGN,LSGN,nActEl,NLEV,NCONF,NTYP,iMode,
     &           jPrint,CNSM(iss)%ICONF,CFTP,NCNATS(1,kSym),NCPCNT,
     &           CIL,CInew,minop)
      If (imode.eq.0.and.iAnd(kprint,8).eq.8)
     &Call SGPRWF_MCLR(ksym,PRWTHR,nSym,NLEV,NCONF,MIDLEV,NMIDV,NIPWLK,
     &                 NICASE,OrbSym,NOCSF,IOCSF,NOW,IOW,ICASE,CInew)
      Call DCopy_(nConf,CINew,1,CIL,1)
      Call mma_deallocate(CINew)
*
      Call mma_deallocate(LSGN)
      Call mma_deallocate(USGN)
      Call mma_deallocate(ICASE)
      Call mma_deallocate(IOCSF)
      Call mma_deallocate(NOCSF)
      Call mma_deallocate(IOW)
      Call mma_deallocate(NOW)
      Call mma_deallocate(RAW)
      Call mma_deallocate(UP)
      Call mma_deallocate(DAW)
      Call mma_deallocate(DOWN)
      Call mma_deallocate(DRT)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE OFFDNS(ISYM1,ICASE1,ISYM2,ICASE2,X1,X2,DPT2,Y,LIST)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: Half, One, Two, Three, Six
      use EQSOLV, only: IFCOUP, NLIST, LLIST
      use Sigma_data, only: VAL1, VAL2, IFTEST, INCF1, INCF2, INCX1,
     &                      INCX2, INCX3, INCY1, INCY2, INCY3, LEN1,
     &                      LEN2, NLST1, NLST2
      use caspt2_module, only: NSYM, NISUP, NASUP, NASH, NORB,
     &                         NSSH, NISH, NIGEJ, NIGTJ, NAGEB, NAGTB,
     &                         NTGEU, NTUV, NTGTU
      IMPLICIT None

      integer(kind=iwp), intent(in)::  ISYM1,ICASE1,ISYM2,ICASE2
      real(kind=wp), intent(inout):: X1(*),X2(*),Y(*)
      real(kind=wp), intent(inout):: DPT2(*)
      integer(kind=iwp), intent(in):: LIST(*)

      integer(kind=iwp) IOFDIT(8),IOFDIA(8),IOFDTA(8)
      integer(kind=iwp) IOFCD(8,8),IOFCEP(8,8),IOFCEM(8,8),IOFCGP(8,8),
     &                  IOFCGM(8,8)
C Various constants:
      real(kind=wp), parameter:: SQR2=SQRT(Two), SQR3=SQRT(Three),
     &                           SQR6=SQRT(Six), SQRI2=One/SQR2,
     &                           SQRI6=One/SQR6, SQR32=SQR3*SQRI2
      Integer(kind=iwp) ICD, ICEM, ICEP, ICGM, ICGP, IDIA, IDIT, IDJB,
     &                  IDOFF, IDTA, IJSYM, IMLTOP, IOXIA, ISYM, ISYM12,
     &                  ISYMA, ISYMAB, ISYMB, ISYMI, ISYMIJ, ISYMJ, IX,
     &                  IXIA, IXTA, IXTI, IY, JSYM, KOD, LLST1, LLST2,
     &                  NA, NAS1, NAS2, NB, NI, NIS1, NJ, NO, NT, NU
C Compute off-diagonal contributions to a trans density matrix.
C Sub-diagonal blocks only. If a density matrix is required,
C i.e. both wave functions equal, use symmetry. Else, call
C again with wave functions interchanged.


      NA = 0 ! dummy initialize
*
      IFTEST=0
      IMLTOP=2
      KOD=IFCOUP(ICASE2,ICASE1)
      IF (KOD==0) RETURN

      ISYM12=Mul(ISYM1,ISYM2)
      NAS1=NASUP(ISYM1,ICASE1)
      NIS1=NISUP(ISYM1,ICASE1)
      NAS2=NASUP(ISYM2,ICASE2)
C Set up various offset arrays:
      IDOFF=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NO=NORB(ISYM)
        IOFDIT(ISYM)=IDOFF+NO*NI
        IOFDIA(ISYM)=IOFDIT(ISYM)+NO*NA
        IOFDTA(ISYM)=IOFDIA(ISYM)+NI
        IDOFF=IDOFF+NO**2
        ICD=0
        ICEP=0
        ICEM=0
        ICGP=0
        ICGM=0
        DO JSYM=1,NSYM
          IJSYM=Mul(ISYM,JSYM)
          IOFCD(ISYM,JSYM)=ICD
          IOFCEP(ISYM,JSYM)=ICEP
          IOFCEM(ISYM,JSYM)=ICEM
          IOFCGP(ISYM,JSYM)=ICGP
          IOFCGM(ISYM,JSYM)=ICGM
          ICD =ICD +NSSH(JSYM)*NISH(IJSYM)
          ICEP=ICEP+NSSH(JSYM)*NIGEJ(IJSYM)
          ICEM=ICEM+NSSH(JSYM)*NIGTJ(IJSYM)
          ICGP=ICGP+NISH(JSYM)*NAGEB(IJSYM)
          ICGM=ICGM+NISH(JSYM)*NAGTB(IJSYM)
        END DO
      END DO

      Select case (KOD)
C  -----------------------------------------------
      Case(1)
C  A&BP One-el
      NLST1=NLIST(ISYM1,ISYM2,12)
      NLST2=NLIST(ISYM1,ISYM2,14)
      IF(NLST1*NLST2/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2,12)
        VAL1(1)=One
        VAL1(2)=Two
        LLST2=LLIST(ISYM1,ISYM2,14)
        VAL2(1)=One
        VAL2(2)=SQR2
        IXTI=1
        INCX1=1
        INCX2=NASH(ISYM1)
        IDIT=1+IOFDIT(ISYM12)
        INCF1=NORB(ISYM12)
        INCF2=1
        IY=1
        INCY1=1
        INCY2=NTGEU(ISYM2)
        CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &              X1(IXTI),DPT2(IDIT),Y(IY))
      END IF

C  A&BP Two-el
      NLST1=NLIST(ISYM1,ISYM2, 3)
      NLST2=NLIST(ISYM1,ISYM2,14)
      IF(NLST1*NLST2/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2, 3)
        VAL1(1)=-One
        VAL1(2)=-Two
        LLST2=LLIST(ISYM1,ISYM2,14)
        VAL2(1)=One
        VAL2(2)=SQR2
        IX=1
        INCX1=1
        INCX2=NTUV(ISYM1)
        IDIT=1+IOFDIT(ISYM12)
        INCF1=NORB(ISYM12)
        INCF2=1
        IY=1
        INCY1=1
        INCY2=NTGEU(ISYM2)
        CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &              X2(IX),DPT2(IDIT),Y(IY))
      END IF
C  -----------------------------------------------
      Case(2)
C A&BM One-el
      NLST1=NLIST(ISYM1,ISYM2,13)
      NLST2=NLIST(ISYM1,ISYM2,15)
      IF(NLST1*NLST2/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2,13)
        VAL1(1)= Three
        VAL1(2)=-Three
        LLST2=LLIST(ISYM1,ISYM2,15)
* Original:
*       VAL2(1)=-One
*       VAL2(2)= One
* Fix for sign error noted by Takeshi, May 2015:
        VAL2(1)= One
        VAL2(2)=-One
        IXTI=1
        INCX1=1
        INCX2=NASH(ISYM1)
        IDIT=1+IOFDIT(ISYM12)
        INCF1=NORB(ISYM12)
        INCF2=1
        IY=1
        INCY1=1
        INCY2=NTGTU(ISYM2)
        CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &              X1(IXTI),DPT2(IDIT),Y(IY))
      END IF

C A&BM Two-el
      NLST1=NLIST(ISYM1,ISYM2, 4)
      NLST2=NLIST(ISYM1,ISYM2,15)
      IF(NLST1*NLST2/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2, 4)
        VAL1(1)=-One
        VAL1(2)= One
        LLST2=LLIST(ISYM1,ISYM2,15)
* Original:
*       VAL2(1)=-One
*       VAL2(2)= One
* Fix for sign error noted by Takeshi, May 2015:
        VAL2(1)= One
        VAL2(2)=-One
        IX=1
        INCX1=1
        INCX2=NTUV(ISYM1)
        IDIT=1+IOFDIT(ISYM12)
        INCF1=NORB(ISYM12)
        INCF2=1
        IY=1
        INCY1=1
        INCY2=NTGTU(ISYM2)
        CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &              X2(IX),DPT2(IDIT),Y(IY))
      END IF
C  -----------------------------------------------
      Case(3)

C  A&D  Two-el
      LLST1=LLIST(ISYM1,ISYM2, 1)
      NLST1=NLIST(ISYM1,ISYM2, 1)
      IF(NLST1/=0) THEN
        VAL1(1)= One
        VAL1(2)= One
        IX=1
        INCX1=1
        INCX2=NAS1
        IDTA=1+IOFDTA(ISYM12)
        INCF1=1
        INCF2=NORB(ISYM12)
        IY=1+NAS2*IOFCD(ISYM2,ISYM12)
        INCY1=1
        INCY2=NAS2
        INCY3=NAS2*NISH(ISYM1)
        LEN1=NISH(ISYM1)
        LEN2=NSSH(ISYM12)
        CALL MLTMV(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDTA),Y(IY))
      END IF
C  -----------------------------------------------
      Case(4)

C  A&EP One-el
      NT=NASH(ISYM1)
      IF(ISYM2==ISYM1 .AND. NT/=0) THEN
       DO ISYMIJ=1,NSYM
        ISYMA=Mul(ISYMIJ,ISYM1)
        NA=NSSH(ISYMA)
        NLST1=NLIST(ISYM1,ISYMIJ,14)
        IF(NA*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYMIJ,14)
          VAL1(1)= One
          VAL1(2)= SQR2
          IXTI=1
          INCX1=NT
          INCX2=1
          IDIA=1+IOFDIA(ISYMA)
          INCF1=1
          INCF2=NORB(ISYMA)
          IY=1+NAS2*IOFCEP(ISYM2,ISYMA)
          INCY1=NT*NA
          INCY2=1
          INCY3=NT
          LEN1=NT
          LEN2=NA
          CALL MLTMV(IMLTOP,LIST(LLST1),X1(IXTI),DPT2(IDIA),Y(IY))
        END IF
       END DO
      END IF
C  -----------------------------------------------
      Case(5)

C  A&EM One-el
      NT=NASH(ISYM1)
      IF(ISYM2==ISYM1 .AND. NT/=0) THEN
       DO ISYMIJ=1,NSYM
        ISYMA=Mul(ISYMIJ,ISYM1)
        NA=NSSH(ISYMA)
        NLST1=NLIST(ISYM1,ISYMIJ,15)
        IF(NA*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYMIJ,15)
          VAL1(1)=-SQR3
          VAL1(2)= SQR3
          IXTI=1
          INCX1=NT
          INCX2=1
          IDIA=1+IOFDIA(ISYMA)
          INCF1=1
          INCF2=NORB(ISYMA)
          IY=1+NAS2*IOFCEM(ISYM2,ISYMA)
          INCY1=NT*NA
          INCY2=1
          INCY3=NT
          LEN1=NT
          LEN2=NA
          CALL MLTMV(IMLTOP,LIST(LLST1),X1(IXTI),DPT2(IDIA),Y(IY))
        END IF
       END DO
      END IF
C  -----------------------------------------------
      Case(6)

C  BP&EP Two-el
      NA=NSSH(ISYM12)
      NLST1=NLIST(ISYM1,ISYM2, 9)
      IF(NA*NLST1/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2, 9)
        VAL1(1)= SQRI2
        VAL1(2)= SQRI2
        IX=1
        INCX1=1
        INCX2=NAS1
        IDTA=1+IOFDTA(ISYM12)
        INCF1=1
        INCF2=NORB(ISYM12)
        IY=1+NAS2*IOFCEP(ISYM2,ISYM12)
        INCY1=1
        INCY2=NAS2*NA
        INCY3=NAS2
        LEN1=NIS1
        LEN2=NA
        CALL MLTMV(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDTA),Y(IY))
      END IF
C  -----------------------------------------------
      Case(7)

C  BM&EM Two-el
      NA=NSSH(ISYM12)
      NLST1=NLIST(ISYM1,ISYM2,10)
      IF(NA*NLST1/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2,10)
* Original:
*       VAL1(1)=-SQRI6
*       VAL1(2)= SQRI6
* Fix for sign error noted by Takeshi, May 2015:
        VAL1(1)= SQRI6
        VAL1(2)=-SQRI6
        IX=1
        INCX1=1
        INCX2=NAS1
        IDTA=1+IOFDTA(ISYM12)
        INCF1=1
        INCF2=NORB(ISYM12)
        IY=1+NAS2*IOFCEM(ISYM2,ISYM12)
        INCY1=1
        INCY2=NAS2*NA
        INCY3=NAS2
        LEN1=NIS1
        LEN2=NA
        CALL MLTMV(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDTA),Y(IY))
      END IF
C  -----------------------------------------------
      Case(8)

C  C&D  One-el
      NI=NISH(ISYM12)
      NLST1=NLIST(ISYM1,ISYM2,11)
      IF(NI*NLST1/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2,11)
        VAL1(1)= Two
        VAL1(2)= One
        IXTA=1
        INCX1=1
        INCX2=NASH(ISYM1)
        IDIT=1+IOFDIT(ISYM12)
        INCF1=NORB(ISYM12)
        INCF2=1
        IY=1+NAS2*IOFCD(ISYM2,ISYM1)
        INCY1=1
        INCY2=NAS2*NI
        INCY3=NAS2
        LEN1=NSSH(ISYM1)
        LEN2=NI
        CALL MLTMV(IMLTOP,LIST(LLST1),X1(IXTA),DPT2(IDIT),Y(IY))
      END IF

C  C&D  Two-el
      NI=NISH(ISYM12)
      NLST1=NLIST(ISYM1,ISYM2, 2)
      IF(NI*NLST1/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2, 2)
        VAL1(1)=-One
        VAL1(2)=-One
        IX=1
        INCX1=1
        INCX2=NAS1
        IDIT=1+IOFDIT(ISYM12)
        INCF1=NORB(ISYM12)
        INCF2=1
        IY=1+NAS2*IOFCD(ISYM2,ISYM1)
        INCY1=1
        INCY2=NAS2*NI
        INCY3=NAS2
        LEN1=NSSH(ISYM1)
        LEN2=NI
        CALL MLTMV(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDIT),Y(IY))
      END IF
C  -----------------------------------------------
      Case(9)

C  C&FP One-el
      NLST1=NLIST(ISYM1,ISYM2,12)
      NLST2=NLIST(ISYM1,ISYM2,16)
      IF(NLST1/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2,12)
        VAL1(1)=-One
        VAL1(2)=-Two
        LLST2=LLIST(ISYM1,ISYM2,16)
        VAL2(1)=One
        VAL2(2)=SQR2
        IXTA=1
        INCX1=1
        INCX2=NASH(ISYM1)
        IDTA=1+IOFDTA(ISYM12)
        INCF1=1
        INCF2=NORB(ISYM12)
        IY=1
        INCY1=1
        INCY2=NTGEU(ISYM2)
        CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &              X1(IXTA),DPT2(IDTA),Y(IY))
      END IF

C  C&FP Two-el
      NLST1=NLIST(ISYM1,ISYM2, 5)
      NLST2=NLIST(ISYM1,ISYM2,16)
      IF(NLST1*NLST2/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2, 5)
        VAL1(1)= One
        VAL1(2)= Two
        LLST2=LLIST(ISYM1,ISYM2,16)
        VAL2(1)=One
        VAL2(2)=SQR2
        IX=1
        INCX1=1
        INCX2=NTUV(ISYM1)
        IDTA=1+IOFDTA(ISYM12)
        INCF1=1
        INCF2=NORB(ISYM12)
        IY=1
        INCY1=1
        INCY2=NTGEU(ISYM2)
        CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &              X2(IX),DPT2(IDTA),Y(IY))
      END IF
C  -----------------------------------------------
      Case(10)

C  C&FM One-el
      NLST1=NLIST(ISYM1,ISYM2,13)
      NLST2=NLIST(ISYM1,ISYM2,17)
      IF(NLST1*NLST2/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2,13)
        VAL1(1)=-One
        VAL1(2)= One
        LLST2=LLIST(ISYM1,ISYM2,17)
        VAL2(1)=One
        VAL2(2)=-One
        IXTA=1
        INCX1=1
        INCX2=NASH(ISYM1)
        IDTA=1+IOFDTA(ISYM12)
        INCF1=1
        INCF2=NORB(ISYM12)
        IY=1
        INCY1=1
        INCY2=NTGTU(ISYM2)
        CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &              X1(IXTA),DPT2(IDTA),Y(IY))
      END IF

C  C&FM Two-el
      NLST1=NLIST(ISYM1,ISYM2, 6)
      NLST2=NLIST(ISYM1,ISYM2,17)
      IF(NLST1*NLST2/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2, 6)
        VAL1(1)=-One
        VAL1(2)= One
        LLST2=LLIST(ISYM1,ISYM2,17)
        VAL2(1)=One
        VAL2(2)=-One
        IX=1
        INCX1=1
        INCX2=NTUV(ISYM1)
        IDTA=1+IOFDTA(ISYM12)
        INCF1=1
        INCF2=NORB(ISYM12)
        IY=1
        INCY1=1
        INCY2=NTGTU(ISYM2)
        CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &              X2(IX),DPT2(IDTA),Y(IY))
      END IF
C  -----------------------------------------------
      Case(11)

C  C&GP One-el
      NT=NASH(ISYM1)
      IF(ISYM2.EQ.ISYM1 .AND. NT/=0) THEN
       DO ISYMAB=1,NSYM
        ISYMI=Mul(ISYMAB,ISYM1)
        NI=NISH(ISYMI)
        NLST1=NLIST(ISYM1,ISYMAB,16)
        IF(NI*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYMAB,16)
          VAL1(1)= SQRI2
          VAL1(2)= One
          IXTA=1
          INCX1=NT
          INCX2=1
          IDIA=1+IOFDIA(ISYMI)
          INCF1=NORB(ISYMI)
          INCF2=1
          IY=1+NAS2*IOFCGP(ISYM2,ISYMI)
          INCY1=NT*NI
          INCY2=1
          INCY3=NT
          LEN1=NT
          LEN2=NI
          CALL MLTMV(IMLTOP,LIST(LLST1),X1(IXTA),DPT2(IDIA),Y(IY))
        END IF
       END DO
      END IF
C  -----------------------------------------------
      Case(12)

C  C&GM One-el
      NT=NASH(ISYM1)
      IF(ISYM2.EQ.ISYM1 .AND. NT/=0) THEN
       DO ISYMAB=1,NSYM
        ISYMI=Mul(ISYMAB,ISYM1)
        NI=NISH(ISYMI)
        NLST1=NLIST(ISYM1,ISYMAB,17)
        IF(NI*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYMAB,17)
          VAL1(1)= SQR32
          VAL1(2)=-SQR32
          IXTA=1
          INCX1=NT
          INCX2=1
          IDIA=1+IOFDIA(ISYMI)
          INCF1=NORB(ISYMI)
          INCF2=1
          IY=1+NAS2*IOFCGM(ISYM2,ISYMI)
          INCY1=NT*NI
          INCY2=1
          INCY3=NT
          LEN1=NT
          LEN2=NI
          CALL MLTMV(IMLTOP,LIST(LLST1),X1(IXTA),DPT2(IDIA),Y(IY))
        END IF
       END DO
      END IF
C  -----------------------------------------------
      Case(13)

C  D&EP One-el
      NT=NASH(ISYM2)
      IF(ISYM1==1 .AND. NT/=0) THEN
       IOXIA=0
       DO ISYMI=1,NSYM
        NI=NISH(ISYMI)
        NA=NSSH(ISYMI)
        ISYMIJ=Mul(ISYMI,ISYM2)
        LLST1=LLIST(ISYMI,ISYMIJ,14)
        NLST1=NLIST(ISYMI,ISYMIJ,14)
        IF(NI*NA*NLST1/=0) THEN
          VAL1(1)= SQRI2
          VAL1(2)= One
          IXIA=IOXIA+1
          INCX1=1
          INCX2=NI
          IDIT=1+IOFDIT(ISYM2)
          INCF1=1
          INCF2=NORB(ISYM2)
          IY=1+NAS2*IOFCEP(ISYM2,ISYMI)
          INCY1=NT*NA
          INCY2=NT
          INCY3=1
          LEN1=NA
          LEN2=NT
          CALL MLTMV(IMLTOP,LIST(LLST1),X1(IXIA),DPT2(IDIT),Y(IY))
        END IF
        IOXIA=IOXIA+NI*NA
       END DO
      END IF

C  D&EP Two-el
      NLST1=NLIST(ISYM1,ISYM2, 7)
      NU=NASH(ISYM2)
      IF(NLST1*NU/=0) THEN
      LLST1=LLIST(ISYM1,ISYM2, 7)
      VAL1(1)=-One
      VAL1(2)=-One
      DO ISYMA=1,NSYM
        NA=NSSH(ISYMA)
        ISYMI=Mul(ISYMA,ISYM1)
        NI=NISH(ISYMI)
        ISYMIJ=Mul(ISYMI,ISYM12)
        LLST2=LLIST(ISYMI,ISYMIJ,14)
        NLST2=NLIST(ISYMI,ISYMIJ,14)
        IF(NA*NI*NLST2/=0) THEN
          VAL2(1)= SQRI2
          VAL2(2)= One
          IX=1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1=1
          INCX2=NAS1
          INCX3=NAS1*NI
          IDIT=1+IOFDIT(ISYM12)
          INCF1=NORB(ISYM12)
          INCF2=1
          IY=1+NU*IOFCEP(ISYM2,ISYMA)
          INCY1=1
          INCY2=NU*NA
          INCY3=NU
          LEN1=NA
          CALL MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X2(IX),DPT2(IDIT),Y(IY))
        END IF
      END DO
      END IF
C  -----------------------------------------------
      Case(14)

C  D&EM One-el
      NT=NASH(ISYM2)
      IF(ISYM1==1 .AND. NT/=0) THEN
       IOXIA=0
       DO ISYMI=1,NSYM
        NI=NISH(ISYMI)
        NA=NSSH(ISYMI)
        ISYMIJ=Mul(ISYMI,ISYM2)
        LLST1=LLIST(ISYMI,ISYMIJ,15)
        NLST1=NLIST(ISYMI,ISYMIJ,15)
        IF(NI*NLST1/=0) THEN
          VAL1(1)= SQR32
          VAL1(2)=-SQR32
          IXIA=IOXIA+1
          INCX1=1
          INCX2=NI
          IDIT=1+IOFDIT(ISYM2)
          INCF1=1
          INCF2=NORB(ISYM2)
          IY=1+NAS2*IOFCEM(ISYM2,ISYMI)
          INCY1=NT*NA
          INCY2=NT
          INCY3=1
          LEN1=NA
          LEN2=NT
          CALL MLTMV(IMLTOP,LIST(LLST1),X1(IXIA),DPT2(IDIT),Y(IY))
        END IF
        IOXIA=IOXIA+NI*NA
       END DO
      END IF

C  D&EM Two-el
      NLST1=NLIST(ISYM1,ISYM2, 7)
      NU=NASH(ISYM2)
      IF(NLST1*NU/=0) THEN
      LLST1=LLIST(ISYM1,ISYM2, 7)
      VAL1(1)=-One
      VAL1(2)= One
      DO ISYMA=1,NSYM
        NA=NSSH(ISYMA)
        ISYMI=Mul(ISYMA,ISYM1)
        NI=NISH(ISYMI)
        ISYMIJ=Mul(ISYMI,ISYM12)
        NLST2=NLIST(ISYMI,ISYMIJ,15)
        IF(NA*NI*NLST2/=0) THEN
          LLST2=LLIST(ISYMI,ISYMIJ,15)
          VAL2(1)= SQRI6
          VAL2(2)=-SQRI6
          IX=1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1=1
          INCX2=NAS1
          INCX3=NAS1*NI
          IDIT=1+IOFDIT(ISYM12)
          INCF1=NORB(ISYM12)
          INCF2=1
          IY=1+NU*IOFCEM(ISYM2,ISYMA)
          INCY1=1
          INCY2=NU*NA
          INCY3=NU
          LEN1=NA
          CALL MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X2(IX),DPT2(IDIT),Y(IY))
        END IF
      END DO
      END IF
C  -----------------------------------------------
      Case(15)

C  D&GP Two-el
      NLST1=NLIST(ISYM1,ISYM2, 8)
      NU=NASH(ISYM2)
      IF(NLST1*NU/=0) THEN
      LLST1=LLIST(ISYM1,ISYM2, 8)
      VAL1(1)= One
      VAL1(2)= One
      DO ISYMA=1,NSYM
        ISYMI=Mul(ISYMA,ISYM1)
        NI=NISH(ISYMI)
        ISYMAB=Mul(ISYMA,ISYM12)
        NLST2=NLIST(ISYMA,ISYMAB,16)
        IF(NI*NLST2/=0) THEN
          LLST2=LLIST(ISYMA,ISYMAB,16)
          VAL2(1)= SQRI2
          VAL2(2)= One
          IX=1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1=1
          INCX2=NAS1*NI
          INCX3=NAS1
          IDTA=1+IOFDTA(ISYM12)
          INCF1=1
          INCF2=NORB(ISYM12)
          IY=1+NU*IOFCGP(ISYM2,ISYMI)
          INCY1=1
          INCY2=NU*NI
          INCY3=NU
          LEN1=NI
          CALL MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X2(IX),DPT2(IDTA),Y(IY))
        END IF
      END DO
      END IF
C  -----------------------------------------------
      Case(16)

C  D&GM Two-el
      NLST1=NLIST(ISYM1,ISYM2, 8)
      NU=NASH(ISYM2)
      IF(NLST1*NU/=0) THEN
      LLST1=LLIST(ISYM1,ISYM2, 8)
      VAL1(1)=-One
      VAL1(2)= One

      DO ISYMA=1,NSYM
        ISYMI=Mul(ISYMA,ISYM1)
        NI=NISH(ISYMI)
        ISYMAB=Mul(ISYMA,ISYM12)
        NLST2=NLIST(ISYMA,ISYMAB,17)
        IF(NI*NLST2/=0) THEN
          LLST2=LLIST(ISYMA,ISYMAB,17)
          VAL2(1)= SQRI6
          VAL2(2)=-SQRI6
          IX=1+NAS1*IOFCD(ISYM1,ISYMA)
          INCX1=1
          INCX2=NAS1*NI
          INCX3=NAS1
          IDTA=1+IOFDTA(ISYM12)
          INCF1=1
          INCF2=NORB(ISYM12)
          IY=1+NU*IOFCGM(ISYM2,ISYMI)
          INCY1=1
          INCY2=NU*NI
          INCY3=NU
          LEN1=NI
          CALL MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X2(IX),DPT2(IDTA),Y(IY))
        END IF
      END DO
      END IF
C  -----------------------------------------------
      Case(17)

C  EP&HP Two-el
      NA=NSSH(ISYM12)
      NLST1=NLIST(ISYM12,ISYM2,16)
      IF(NA*NLST1/=0) THEN
        LLST1=LLIST(ISYM12,ISYM2,16)
        VAL1(1)= SQRI2
        VAL1(2)= One
        IX=1+NAS1*IOFCEP(ISYM1,ISYM12)
        INCX1=NAS1
        INCX2=1
        INCX3=NAS1*NA
        IDTA=1+IOFDTA(ISYM1)
        INCF1=NORB(ISYM1)
        INCF2=1
        IY=1
        INCY1=1
        INCY2=NAS2
        LEN1=NAS1
        LEN2=NIGEJ(ISYM2)
        CALL MLTR1(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDTA),Y(IY))
      END IF
C  -----------------------------------------------
      Case(18)

C  EM&HM Two-el
      NA=NSSH(ISYM12)
      NLST1=NLIST(ISYM12,ISYM2,17)
      IF(NA*NLST1/=0) THEN
        LLST1=LLIST(ISYM12,ISYM2,17)
        VAL1(1)= SQRI2
        VAL1(2)=-SQRI2
        IX=1+NAS1*IOFCEM(ISYM1,ISYM12)
        INCX1=NAS1
        INCX2=1
        INCX3=NAS1*NA
        IDTA=1+IOFDTA(ISYM1)
        INCF1=NORB(ISYM1)
        INCF2=1
        IY=1
        INCY1=1
        INCY2=NAS2
        LEN1=NAS1
        LEN2=NIGTJ(ISYM2)
        CALL MLTR1(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDTA),Y(IY))
      END IF
C  -----------------------------------------------
      Case(19)

C  FP&GP Two-el
      NI=NISH(ISYM12)
      NLST1=NLIST(ISYM1,ISYM2, 9)
      IF(NI*NLST1/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2, 9)
        VAL1(1)=-SQRI2
        VAL1(2)=-SQRI2
        IX=1
        INCX1=1
        INCX2=NAS1
        IDIT=1+IOFDIT(ISYM12)
        INCF1=NORB(ISYM12)
        INCF2=1
        IY=1+NAS2*IOFCGP(ISYM2,ISYM12)
        INCY1=1
        INCY2=NAS2*NI
        INCY3=NAS2
        LEN1=NIS1
        LEN2=NI
        CALL MLTMV(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDIT),Y(IY))
      END IF
C  -----------------------------------------------
      Case(20)

C  FM&GM Two-el
      NI=NISH(ISYM12)
      NLST1=NLIST(ISYM1,ISYM2,10)
      IF(NI*NLST1/=0) THEN
        LLST1=LLIST(ISYM1,ISYM2,10)
        VAL1(1)=-SQRI6
        VAL1(2)= SQRI6
        IX=1
        INCX1=1
        INCX2=NAS1
        IDIT=1+IOFDIT(ISYM12)
        INCF1=NORB(ISYM12)
        INCF2=1
        IY=1+NAS2*IOFCGM(ISYM2,ISYM12)
        INCY1=1
        INCY2=NAS2*NI
        INCY3=NAS2
        LEN1=NIS1
        LEN2=NI
        CALL MLTMV(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDIT),Y(IY))
      END IF
C  -----------------------------------------------
      Case(21)

C  GP&HP Two-el
      LLST1=LLIST(ISYM12,ISYM2,14)
      NLST1=NLIST(ISYM12,ISYM2,14)
      IF(NLST1/=0) THEN
        VAL1(1)= -SQRI2
        VAL1(2)= -One
        IX=1+NAS1*IOFCGP(ISYM1,ISYM12)
        INCX1=NAS1
        INCX2=1
        INCX3=NAS1*NISH(ISYM12)
        IDIT=1+IOFDIT(ISYM1)
        INCF1=1
        INCF2=NORB(ISYM1)
        IY=1
        INCY1=NAS2
        INCY2=1
        LEN1=NAS1
        LEN2=NAS2
        CALL MLTR1(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDIT),Y(IY))
      END IF
C  -----------------------------------------------
      Case(22)

C  GM&HM Two-el
      LLST1=LLIST(ISYM12,ISYM2,15)
      NLST1=NLIST(ISYM12,ISYM2,15)
      IF(NLST1/=0) THEN
        VAL1(1)= SQRI2
        VAL1(2)=-SQRI2
        IX=1+NAS1*IOFCGM(ISYM1,ISYM12)
        INCX1=NAS1
        INCX2=1
        INCX3=NAS1*NISH(ISYM12)
        IDIT=1+IOFDIT(ISYM1)
        INCF1=1
        INCF2=NORB(ISYM1)
        IY=1
        INCY1=NAS2
        INCY2=1
        LEN1=NAS1
        LEN2=NAS2
        CALL MLTR1(IMLTOP,LIST(LLST1),X2(IX),DPT2(IDIT),Y(IY))
      END IF
C  -----------------------------------------------
      Case(23)

C  D&HP One-el
      IF(ISYM1==1) THEN
      IOXIA=0
      DO ISYMI=1,NSYM
       NI=NISH(ISYMI)
       ISYMA=ISYMI
       NA=NSSH(ISYMA)
       ISYMJ=Mul(ISYMI,ISYM2)
       NJ=NISH(ISYMJ)
       ISYMB=ISYMJ
       NB=NSSH(ISYMB)
       NLST1=NLIST(ISYMI,ISYM2,14)
       NLST2=NLIST(ISYMA,ISYM2,16)
       IF(NI*NA*NJ*NB*NLST1*NLST2/=0) Then
         LLST1=LLIST(ISYMI,ISYM2,14)
         VAL1(1)=SQRI2
         VAL1(2)=One
         LLST2=LLIST(ISYMA,ISYM2,16)
         VAL2(1)=SQRI2
         VAL2(2)=One
         IXIA=IOXIA+1
         INCX1=1
         INCX2=NI
         IDJB=1+IOFDIA(ISYMB)
         INCF1=1
         INCF2=NORB(ISYMJ)
         IY=1
         INCY1=NAGEB(ISYM2)
         INCY2=1
         CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X1(IXIA),DPT2(IDJB),Y(IY))
       END IF
       IOXIA=IOXIA+NI*NA
      END DO
      END IF

C  ---------------------------
      Case(24)

C  D&HM One-el
      IF(ISYM1==1) THEN
      IOXIA=0
      DO ISYMI=1,NSYM
       NI=NISH(ISYMI)
       ISYMA=ISYMI
       NA=NSSH(ISYMA)
       ISYMJ=Mul(ISYMI,ISYM2)
       NJ=NISH(ISYMJ)
       ISYMB=ISYMJ
       NB=NSSH(ISYMB)
       NLST1=NLIST(ISYMI,ISYM2,15)
       NLST2=NLIST(ISYMA,ISYM2,17)
       IF(NI*NA*NJ*NB*NLST1*NLST2/=0) THEN
         LLST1=LLIST(ISYMI,ISYM2,15)
         VAL1(1)=SQR3*Half
         VAL1(2)=-VAL1(1)
         LLST2=LLIST(ISYMA,ISYM2,17)
         VAL2(1)= One
         VAL2(2)=-One
         IXIA=IOXIA+1
         INCX1=1
         INCX2=NI
         IDJB=1+IOFDIA(ISYMB)
         INCF1=1
         INCF2=NORB(ISYMJ)
         IY=1
         INCY1=NAGTB(ISYM2)
         INCY2=1
         CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &              X1(IXIA),DPT2(IDJB),Y(IY))
       END IF
       IOXIA=IOXIA+NI*NA
      END DO
      END IF
C  ---------------------------
      Case default
        WRITE(6,*)' INTERNAL ERROR: OffDns reached invalid KOD=',KOD
        Call Abend()
      End Select

      END SUBROUTINE OFFDNS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetPrescreen(Value)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Set LDF prescreening threshold (for determining significant atom
C     pairs).
C
      Implicit None
      Real*8 Value
#include "localdf.fh"
      Thr_Prescreen=Value
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contf5(wrk,wrksize,lunt2o1,lunt2o2,lunt2o3)
! this routine does: FV1,FV2,T23
!
!     FV1
!1    FV(m,j)aa  <= FII(m,j)aa
!2    FV(m,j)bb  <= FII(m,j)bb
!
!     FV2
!3    FV(m,j)aa  <- -0.5 sum (e-a) [ FIII(e,m)aa . T1o(e,j)aa ]
!4    FV(m,j)bb  <- -0.5 sum (e-b) [ FIII(e,m)bb . T1o(e,j)bb ]
!
!     T23
!5    Q(ab,k,l)aaaa   <= sum(m-a)   [ T2o(ab,k,m)aaaa . FV(m,l)aa ]
!5    T2n(ab,ij)aaaa   <- Q(ab,j,i)aaaa - Q(ab,i,j)aaaa
!6    Q(ab,k,l)bbbb   <= sum(m-b)   [ T2o(ab,k,m)bbbb . FV(m,l)bb ]
!6    T2n(ab,ij)bbbb   <- Q(ab,j,i)bbbb - Q(ab,i,j)bbbb
!7    T2n(a,b,i,j)abab <- - sum(m-b) [ T2o(a,b,i,m)abab . FV(m,j)bb ]
!8    T2n(a,b,i,j)abab <- - sum(m-a) [ T2o(a,b,m,j)abab . FV(m,i)aa ]

use ccsd_global, only: f21, f22, f31, f32, idaabb, idbaab, m1, m2, m3, t11, t12, t21, t22, t23, v1, v2, v3
use Para_Info, only: MyRank
use Constants, only: One, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp), intent(_IN_) :: lunt2o1, lunt2o2, lunt2o3
integer(kind=iwp) :: post, rc, ssc

!par
if ((myRank == idbaab) .or. (myRank == idaabb)) then

  !78.0 read V1(a,b,k,l) <= T2o(a,b,k,l)abab
  call filemanager(2,lunt2o3,rc)
  call getmediate(wrk,wrksize,lunt2o3,v1,rc)

end if

!par
if (myRank == idbaab) then

  !1 FV(m,j)aa  <= FII(m,j)aa

  !1.1 map M1(m,j) <= F2(m,j)aa
  call map(wrk,wrksize,2,1,2,0,0,f21,1,m1,post,rc)

  !3 FV(m,j)aa  <- 0.5 sum (e-a) [ FIII(e,m)aa . T1o(e,j)aa ]

  !3.1 map M2(m,e) <= F3(e,m)aa
  call map(wrk,wrksize,2,2,1,0,0,f31,1,m2,post,rc)

  !3.2 mult M3(m,j) <= M2(m,e) . T1o(e,j)aa
  call ccmult(wrk,wrksize,2,2,2,1,m2,1,t11,1,m3,ssc,rc)

  !3.3 add M1(m,j) <- 0.5 M3(m,j)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,Half,m3,1,m1,1,rc)

  !5 Q(ab,k,l)aaaa   <= sum(m-a)   [ T2o(ab,k,m)aaaa . FV(m,l)aa ]
  !5 T2n(ab,ij)aaaa   <- Q(ab,j,i)aaaa - Q(ab,i,j)aaaa

  !5.1 read V3(ab,kl) <= T2o(ab,kl)aaaa
  call filemanager(2,lunt2o1,rc)
  call getmediate(wrk,wrksize,lunt2o1,v3,rc)

  !5.2 expand V2(ab,k,l) <- V3(ab,kl)
  call expand(wrk,wrksize,4,6,v3,1,v2,rc)

  !5.3 mult V3(ab,k,l) <= V2(a,b,k,m) . M1(m,l)
  call ccmult(wrk,wrksize,4,2,4,1,v2,1,m1,1,v3,ssc,rc)

  !5.4 pack V2(ab,ij) <= V3(ab,i,j) - V3(ab,j,i)
  call fack(wrk,wrksize,4,4,v3,1,v2,rc)

  !5.5 add T2n(ab,ij)aaaa <- - V2(ab,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,-One,v2,1,t21,1,rc)

  !8 T2n(a,b,i,j)abab <- - sum(m-a) [ T2o(a,b,m,j)abab . FV(m,i)aa ]

  !8.1 map V2(a,b,j,m) <= V1(a,b,m,j)
  call map(wrk,wrksize,4,1,2,4,3,v1,1,v2,post,rc)

  !8.2 mult V3(a,b,j,i) <= V2(a,b,j,m) . M1(m,i)
  call ccmult(wrk,wrksize,4,2,4,1,v2,1,m1,1,v3,ssc,rc)

  !8.3 map V2(a,b,i,j) <= V3(a,b,j,i)
  call map(wrk,wrksize,4,1,2,4,3,v3,1,v2,post,rc)

  !8.4 add T2n(a,b,i,j)abab <- - V2(a,b,i,j)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,-One,v2,1,t23,1,rc)
  !par
end if

!par
if (myRank == idaabb) then

  !2 FV(m,j)bb  <= FII(m,j)bb

  !2.1 map M1(m,j) <= F2(m,j)bb
  call map(wrk,wrksize,2,1,2,0,0,f22,1,m1,post,rc)

  !4 FV(m,j)bb  <- 0.5 sum (e-b) [ FIII(e,m)bb . T1o(e,j)bb ]

  !4.1 map M2(m,e) <= F3(e,m)bb
  call map(wrk,wrksize,2,2,1,0,0,f32,1,m2,post,rc)

  !4.2 mult M3(m,j) <= M2(m,e) . T1o(e,j)bb
  call ccmult(wrk,wrksize,2,2,2,1,m2,1,t12,1,m3,ssc,rc)

  !4.3 add M1(m,j) <- 0.5 M3(m,j)
  call add(wrk,wrksize,2,2,0,0,0,0,1,1,Half,m3,1,m1,1,rc)

  !6 Q(ab,k,l)bbbb   <= sum(m-b)   [ T2o(ab,k,m)bbbb . FV(m,l)bb ]
  !6 T2n(ab,ij)bbbb   <- Q(ab,j,i)bbbb - Q(ab,i,j)bbbb

  !6.1 read V3(ab,kl) <= T2o(ab,kl)bbbb
  call filemanager(2,lunt2o2,rc)
  call getmediate(wrk,wrksize,lunt2o2,v3,rc)

  !6.2 expand V2(ab,k,l) <- V3(ab,kl)
  call expand(wrk,wrksize,4,6,v3,1,v2,rc)

  !6.3 mult V3(ab,k,l) <= V2(a,b,k,m) . M1(m,l)
  call ccmult(wrk,wrksize,4,2,4,1,v2,1,m1,1,v3,ssc,rc)

  !6.4 pack V2(ab,ij) <= V3(ab,i,j) - V3(ab,j,i)
  call fack(wrk,wrksize,4,4,v3,1,v2,rc)

  !6.5 add T2n(ab,ij)bbbb <- - V2(ab,ij)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,-One,v2,1,t22,1,rc)

  !7 T2n(a,b,i,j)abab <- - sum(m-b) [ T2o(a,b,i,m)abab . FV(m,j)bb ]

  !7.1 mult V3(a,b,i,j) <= V1(a,b,i,m) . M1(m,j)
  call ccmult(wrk,wrksize,4,2,4,1,v1,1,m1,1,v3,ssc,rc)

  !7.2 add T2n(a,b,i,j)abab <- - V3(a,b,i,j)
  call add(wrk,wrksize,4,4,0,0,0,0,1,1,-One,v3,1,t23,1,rc)
  !par
end if

return

end subroutine contf5

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_SyncNumCho(NumCho,nSym)
C
C     Purpose: sync global NumCho_G vector counter. On entry, NumCho is
C              the local counter (unchanged).
C
      Implicit None
      Integer nSym
      Integer NumCho(nSym)
#include "choglob.fh"
#include "cho_para_info.fh"

      Integer iSym
      Real*8  c1, c2, w1, w2

      If (Cho_Real_Par) Then
         Call Cho_Timer(c1,w1)
         Call iCopy(nSym,NumCho,1,NumCho_G,1)
         Call Cho_GAIGop(NumCho_G,nSym,'max')
         NumChT_G = NumCho_G(1)
         Do iSym = 2,nSym
            NumChT_G = NumChT_G + NumCho_G(iSym)
         End Do
         Call Cho_Timer(c2,w2)
         Call Cho_P_SyncNumCho_Time(c2-c1,w2-w1)
      End If

      End
      SubRoutine Cho_P_SyncNumCho_Time(c,w)
      Implicit None
      Real*8 c, w
#include "cholesky.fh"
      tMisc(1,5)=tMisc(1,5)+c
      tMisc(2,5)=tMisc(2,5)+w
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
************************************************************************
      SubRoutine Trns2(Win,Wout,nvec,nc)
************************************************************************
*                                                                      *
* Object: utility routine to transform a AO batch in case of redun-    *
*         dancy of type aA=bB or cC=dD.                                *
*                                                                      *
* Called from: Trns1                                                   *
*                                                                      *
* Calling    : DCopy  (ESSL)                                           *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             June '90                                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
      Real*8 Win(nvec,nc,nc), Wout(nvec,nc,nc)
*
      iRout = 72
      iPrint = nPrint(iRout)
*     Write (*,*) ' In Trns2, nvec,nc=',nVec,nc
      Do 10 ic = 1, nc
         Do 20 id = 1, nc
            call dcopy_(nvec,Win(1,ic,id),1,Wout(1,id,ic),1)
 20      Continue
 10   Continue
*     Call GetMem(' Exit Trns2','CHECK','REAL',iDum,iDum)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_BlockMatrixNorm(Blocks,Norm)
! Thomas Bondo Pedersen, December 2010.
!
! Purpose: compute Frobenius norm of block matrix.

use Definitions, only: wp, iwp, r8

implicit none
#include "ldf_atom_pair_info.fh"
integer(kind=iwp), intent(in) :: Blocks(*)
real(kind=wp), intent(out) :: Norm(NumberOfAtomPairs)
integer(kind=iwp) :: iAtomPair, iAtom, jAtom, ip, l
integer(kind=iwp), external :: LDF_nBas_Atom
real(kind=r8), external :: ddot_
#include "WrkSpc.fh"

do iAtomPair=1,NumberOfAtomPairs
  iAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+1)
  jAtom = iWork(ip_AP_Atoms-1+2*(iAtomPair-1)+2)
  l = LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
  ip = Blocks(iAtomPair)
  Norm(iAtomPair) = sqrt(dDot_(l,Work(ip),1,Work(ip),1))
end do

end subroutine LDF_BlockMatrixNorm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Find_Min(nOrder,XStart,A,XMin,RC,XLow,XHi,ENew)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 A(0:nOrder)
      Logical RC
*
      iRout=117
      iPrint=nPrint(iRout)
      If (iPrint.ge.99) Then
          Call RecPrt('Find_Min: A',' ',A,1,nOrder+1)
      End If
      Thr=1.0D-12
      XValue=XStart
      RC=.True.
      MaxIter=100
      Do i = 1, MaxIter
         X=XValue
         fnc  = Zero
         XX   = One
         Do j=0,nOrder
            fnc=fnc+A(j)*XX
            XX = XX*X
         End Do
         dfnc = Zero
         XX   = One
         Do j=1,nOrder
            tmp = DBLE(j)
            dfnc=dfnc+A(j)*tmp*XX
            XX = XX*X
         End Do
         ddfnc = Zero
         XX    = One
         Do j=2,nOrder
            tmp = DBLE(j*j-j)
            ddfnc=ddfnc+A(j)*tmp*XX
            XX = XX*X
         End Do
         XInc=dfnc/ddfnc
         XValue=XValue-XInc
         If (iPrint.eq.99) Then
            Write (6,*) 'Fnc,dFnc,ddFnc=',Fnc,dFnc,ddFnc
         End If
         If (Abs(XInc).lt.Thr) Then
            ENew=fnc
            XMin=XValue
            Return
         End If
         If (XValue.gt.XHi) XValue=XHi
         If (XValue.lt.XLow) XValue=XLow
      End Do
      If (iPrint.ge.6)
     &   Write (6,*) '-- Too many iterations in Find_Min'
      RC=.False.
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ADAADAS1_GAS(     NK,     I1,   XI1S,    LI1,   IORB,
     &                          NIORB,    IAC,   JORB,  NJORB,    JAC,
     &                           KSTR,   NKEL,  NKSTR,   IREO,     IZ,
     &                          NOCOB,   KMAX,   KMIN,   IEND, SCLFAC,
     &                          NSTRI)
*
*
* Obtain I1(KSTR) = +/- a+/a  IORB a+/a JORB !KSTR>
* Only orbital pairs IOB .gt. JOB are included
*
* KSTR is restricted to strings with relative numbers in the
* range KMAX to KMIN
* =====
* Input
* =====
* IORB : First I orbital to be added
* NIORB : Number of orbitals to be added : IORB to IORB-1+NIORB
*        are used. They must all be in the same TS group
* JORB : First J orbital to be added
* LORB : Number of orbitals to be added : JORB to JORB-1+NJORB
*        are used. They must all be in the same TS group
* KMAX : Largest allowed relative number for K strings
* KMIN : Smallest allowed relative number for K strings
*
* ======
* Output
* ======
*
* NK      : Number of K strings
* I1(KSTR,JORB) : ne. 0 =>  a+IORB a+JORB !KSTR> = +/-!ISTR>
* XI1S(KSTR,JORB) : above +/-
*          : eq. 0    a + JORB !KSTR> = 0
* Offset is KMIN
*
* L.R. Jan 20, 1998
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
      INTEGER KSTR(NKEL,NKSTR)
      INTEGER IREO(*), IZ(NOCOB,*)
*.Output
      INTEGER I1(LI1,*)
      DIMENSION XI1S(LI1,*)
*. Local scratch, at most 1000 orbitals in a given TS block)
      DIMENSION ISCR(1000)
*PAM2009 Array of values, replacing expressions such as ''DBLE((-1)**INT8)'':
      DIMENSION SGNARR(0:63)
      DO I=0,62,2
       SGNARR(I)  = 1.0D0
       SGNARR(I+1)=-1.0D0
      END DO
*
* Some dummy initializations
      SIGN = 0.0D0

      NTEST = 00
      IF(NTEST.NE.0) THEN
       WRITE(6,*) ' ==================== '
       WRITE(6,*) ' ADADS1_GAS speaking '
       WRITE(6,*) ' ==================== '
       WRITE(6,*) ' IORB,NIORB,IAC ', IORB,NIORB,IAC
       WRITE(6,*) ' JORB,NJORB,JAC ', JORB,NJORB,JAC
*
C      WRITE(6,*) ' Kstrings in action (el,string) '
C      WRITE(6,*) ' ==============================='
C      CALL IWRTMA(KSTR,NKEL,NKSTR,NKEL,NKSTR)
       WRITE(6,*) ' 24 elements of reorder array'
       CALL IWRTMA(IREO,1,24,1,24)
*
      END IF
*
      IORBMIN = IORB
      IORBMAX = IORB + NIORB - 1
*
      JORBMIN = JORB
      JORBMAX = JORB + NJORB - 1
*
      KEND = MIN(NKSTR,KMAX)
      IF(KEND.LT.NKSTR) THEN
        IEND = 0
      ELSE
        IEND = 1
      END IF
      NK = KEND-KMIN+1
*
      IF(IAC.EQ.2.AND.JAC.EQ.2) THEN
*
* ==========================
* Creation- creation mapping
* ==========================
*
        DO KKSTR = KMIN,KEND
         IF(NTEST.GE.1000) THEN
           WRITE(6,*) ' Occupation of string ', KKSTR
           CALL IWRTMA(KSTR(1,KKSTR),1,NKEL,1,NKEL)
         END IF
*. Loop over electrons after which JORB can be added
         DO JEL = 0, NKEL
*
           IF(JEL.EQ.0 ) THEN
             JORB1 = JORBMIN - 1
           ELSE
             JORB1 = MAX(JORBMIN-1,KSTR(JEL,KKSTR))
           END IF
           IF(JEL.EQ.NKEL) THEN
             JORB2 = JORBMAX + 1
           ELSE
             JORB2 = MIN(JORBMAX+1,KSTR(JEL+1,KKSTR))
           END IF
           IF(NTEST.GE.1000)
     &      WRITE(6,*) ' JEL JORB1 JORB2 ',JEL,JORB1,JORB2
*
           IF(JEL.GT.0.AND.JORB1.GE.JORBMIN.AND.
     &                     JORB1.LE.JORBMAX) THEN
*. vanishing for any IORB
             IJOFF = (JORB1-JORBMIN)*NIORB
             DO IIORB = 1, NIORB
               IJ = IJOFF + IIORB
               I1(KKSTR-KMIN+1,IJ) = 0
               XI1S(KKSTR-KMIN+1,IJ) = 0.0D0
             END DO
           END IF
*
           IF(JORB1.LT.JORBMAX.AND.JORB2.GT.JORBMIN) THEN
*. Orbitals JORB1+1 - JORB2-1 can be added after electron JEL
*PAM2009             SIGNJ = DBLE((-1)**JEL) * SCLFAC
             SIGNJ = SGNARR(JEL) * SCLFAC
*. reverse lexical number of the first JEL ELECTRONS
             ILEX0 = 1
             DO JJEL = 1, JEL
               ILEX0 = ILEX0 + IZ(KSTR(JJEL,KKSTR),JJEL)
             END DO
             DO JJORB = JORB1+1, JORB2-1
* And electron JEL + 1
               ILEX1 = ILEX0 + IZ(JJORB,JEL+1)
*. Add electron IORB
               DO IEL = JEL, NKEL
                 IF(IEL.EQ.JEL) THEN
                   IORB1 = MAX(JJORB,IORBMIN-1)
                 ELSE
                   IORB1 = MAX(IORBMIN-1,KSTR(IEL,KKSTR))
                 END IF
                   IF(IEL.EQ.NKEL) THEN
                   IORB2 = IORBMAX+1
                 ELSE
                   IORB2 = MIN(IORBMAX+1,KSTR(IEL+1,KKSTR))
                 END IF
                 IF(NTEST.GE.5000)
     &            WRITE(6,*) ' IEL IORB1 IORB2 ',IEL,IORB1,IORB2
                 IF(IEL.GT.JEL.AND.IORB1.GE.IORBMIN.AND.
     &                             IORB1.LE.IORBMAX) THEN
                   IJ = (JJORB-JORBMIN)*NIORB+IORB1-IORBMIN+1
                   I1(KKSTR-KMIN+1,IJ) = 0
                   XI1S(KKSTR-KMIN+1,IJ) = 0.0D0
                 END IF
                 IF(IORB1.LT.IORBMAX.AND.IORB2.GT.IORBMIN) THEN
*. Orbitals IORB1+1 - IORB2 -1 can be added after ELECTRON IEL in KSTR
*. Reverse lexical number of the first IEL+1 electrons
                   ILEX2 = ILEX1
                   DO IIEL = JEL+1,IEL
                     ILEX2 = ILEX2 + IZ(KSTR(IIEL,KKSTR),IIEL+1)
                   END DO
*. add terms for the last electrons
                   DO IIEL = IEL+1,NKEL
                     ILEX2 = ILEX2 + IZ(KSTR(IIEL,KKSTR),IIEL+2)
                   END DO
                   IJOFF = (JJORB-JORBMIN)*NIORB
*PAM2009           SIGNIJ =  SIGNJ*(-1.0D0) ** (IEL+1)
                   SIGNIJ =  SIGNJ*SGNARR(IEL+1)
                   DO IIORB = IORB1+1, IORB2-1
                     IJ = IJOFF + IIORB - IORBMIN + 1
                     ILEX = ILEX2 + IZ(IIORB,IEL+2)
                     IACT = IREO(ILEX)
                     IF(NTEST.GE.1000) THEN
                       WRITE(6,*) 'IIORB JJORB', IIORB,JJORB
                       WRITE(6,*) ' ILEX IACT ', ILEX,IACT
                     END IF
                     I1(KKSTR-KMIN+1,IJ) = IACT
                     XI1S(KKSTR-KMIN+1,IJ) = SIGNIJ
                   END DO
                 END IF
               END DO
             END DO
           END IF
         END DO
        END DO
      ELSE IF(IAC.EQ.1.AND.JAC.EQ.1) THEN
*
* ===========================================
* annihilation - annihilation mapping (a i a j)
* ===========================================
*
        DO KKSTR = KMIN,KEND
*. Active range for electrons
         IIELMIN = 0
         IIELMAX = 0
         JJELMIN = 0
         JJELMAX = 0
*
         DO KEL = 1, NKEL
          KKORB = KSTR(KEL,KKSTR)
          IF(IIELMIN.EQ.0.AND.KKORB.GE.IORBMIN)IIELMIN = KEL
          IF(JJELMIN.EQ.0.AND.KKORB.GE.JORBMIN)JJELMIN = KEL
          IF(KKORB.LE.IORBMAX) IIELMAX = KEL
          IF(KKORB.LE.JORBMAX) JJELMAX = KEL
         END DO
         IF(IIELMIN.EQ.0) IIELMIN = NKEL  + 1
         IF(JJELMIN.EQ.0) JJELMIN = NKEL  + 1

         IF(NTEST.GE.1000) THEN
           WRITE(6,*) ' Occupation of string ', KKSTR
           CALL IWRTMA(KSTR(1,KKSTR),1,NKEL,1,NKEL)
         END IF
*. Loop over first electron to be removed
C        DO JEL = 1, NKEL
         DO JEL = JJELMIN,JJELMAX
           JJORB = KSTR(JEL,KKSTR)
*. Loop over second electron to be removed
C          DO IEL = JEL+1, NKEL
           DO IEL = MAX(JEL+1,IIELMIN),IIELMAX
             IIORB = KSTR(IEL,KKSTR)
             IF(NTEST.GE.1000) THEN
              WRITE(6,*) ' IEL JEL IORB JORB ',
     &        IEL,JEL,IORB,JORB
             END IF
             IF(IIORB.GE.IORBMIN.AND.IIORB.LE.IORBMAX.AND.
     &          JJORB.GE.JORBMIN.AND.JJORB.LE.JORBMAX     )THEN
*PAM09               SIGN = DBLE((-1)**(IEL+JEL-1)) * SCLFAC
               SIGN = SGNARR(IEL+JEL+1) * SCLFAC
*. reverse lexical number of the double annihilated string
               ILEX = 1
               DO JJEL = 1, JEL-1
                 ILEX = ILEX + IZ(KSTR(JJEL,KKSTR),JJEL)
               END DO
               DO JJEL = JEL+1,IEL-1
                 ILEX = ILEX + IZ(KSTR(JJEL,KKSTR),JJEL-1)
               END DO
               DO JJEL = IEL+1, NKEL
                 ILEX = ILEX + IZ(KSTR(JJEL,KKSTR),JJEL-2)
               END DO
               IACT = IREO(ILEX)
               IF(IACT.LE.0.OR.IACT.GT.NSTRI) THEN
                 WRITE(6,*) ' IACT out of bounds, IACT =  ', IACT
*                 STOP       ' IACT out of bounds '
        CALL SYSABENDMSG('lucia_util/adaadas1_gas',
     &                    'Internal error',' ')
               END IF
               IF(NTEST.GE.1000) THEN
                 WRITE(6,*) ' ILEX and IACT ', ILEX, IACT
               END IF
*
               IJ = (JJORB-JORB)*NIORB + IIORB-IORB+1
               I1(KKSTR-KMIN+1,IJ) = IACT
               XI1S(KKSTR-KMIN+1,IJ) = SIGN
             END IF
*            ^ End if orbitals are in correct range
           END DO
*          ^ End of loop over IEL
         END DO
*        ^ End of loop over JEL
        END DO
*       ^ End of loop over Kstrings
*
      ELSE IF(IAC.EQ.2.AND.JAC.EQ.1) THEN
*
* ===================================
* Creation-annihilation map a+ i a j
* ===================================
*
C       DO KKSTR = 1, NKSTR
        DO KKSTR = KMIN,KEND
*. Indicate where a given orbital i should be added in KKSTR
         IZERO = 0
         CALL ISETVC(ISCR(IORBMIN),IZERO,NIORB)
         IIEL = 1
         DO IIORB = IORBMIN,IORBMAX
 2810      CONTINUE
           IF(IIEL.LE.NKEL) THEN
             IF(IIORB.LT.KSTR(IIEL,KKSTR)) THEN
               ISCR(IIORB)=IIEL
             ELSE IF (IIORB.EQ.KSTR(IIEL,KKSTR)) THEN
               ISCR(IIORB) = - IIEL
               IIEL = IIEL+1
             ELSE IF (IIORB.GT.KSTR(IIEL,KKSTR)) THEN
               IIEL = IIEL + 1
               GOTO 2810
             END IF
           ELSE IF(IIEL.EQ.NKEL+1) THEN
              ISCR(IIORB) = IIEL
           END IF
         END DO
         IF(NTEST.GE.10000) THEN
           WRITE(6,*) ' ISCR from IORBMIN array for KKSTR = ', KKSTR
           WRITE(6,*) ' IORBMIN, NIORB', IORBMIN,NIORB
           CALL IWRTMA(ISCR(IORBMIN),1,NIORB,1,NIORB)
         END IF
         DO JEL = 1, NKEL
           JJORB = KSTR(JEL,KKSTR)
           IF(JJORB.GE.JORBMIN.AND.JJORB.LE.JORBMAX)THEN
             DO IIORB = IORBMIN,IORBMAX
               IEL = ISCR(IIORB)
C?             write(6,*) ' JEL IEL JJORB IIORB',JEL,IEL,JJORB,IIORB
               IACT = 0
               IF(IEL.GT.0.AND.IIORB.GT.JJORB) THEN
*. New string is  a+1 ... a+ jel-1 a+jel+1 ..a+iel-1 a+iiorb a+iel+1 ...
*. Lexical number of new string
                 ILEX = 1
                 DO KEL = 1, JEL-1
                  ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL)
                 END DO
                 DO KEL = JEL+1, IEL-1
                  ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL-1)
                 END DO
                 ILEX = ILEX + IZ(IIORB,IEL-1)
                 DO KEL = IEL, NKEL
                  ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL)
                 END DO
                 IACT = IREO(ILEX)
                 IF(IACT.LE.0.OR.IACT.GT.NSTRI) THEN
                   WRITE(6,*) ' 1: IACT out of bounds, IACT =  ', IACT
                   WRITE(6,*) ' NSTRI = ', NSTRI
                   WRITE(6,*) 'IIORB,JJORB ',IIORB,JJORB
                   WRITE(6,*) ' Kstring : '
                   CALL IWRTMA(KSTR(1,KKSTR),1,NKEL,1,NKEL)
                   WRITE(6,*) ' ILEX = ', ILEX
                   WRITE(6,*) 'IZ matrix'
                   CALL IWRTMA(IZ,NOCOB,NKEL,NOCOB,NKEL)
*                   STOP ' IACT out of bounds'
        CALL SYSABENDMSG('lucia_util/adaadas1_gas',
     &                    'Internal error',' ')
                 END IF
*PAM2009                 SIGN = DBLE((-1)**(IEL+JEL-1)) * SCLFAC
                 SIGN = SGNARR(IEL+JEL+1) * SCLFAC
               ELSE IF(IEL.GT.0 .AND. IIORB.LT.JJORB) THEN
*. New string is  a+1 ... a+ iel-1 a+ iiorb a+iel+1 ..a+jel-1 a+jel+1 ...
                 ILEX = 1
                 DO KEL = 1, IEL-1
                   ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL)
                 END DO
                 ILEX = ILEX + IZ(IIORB,IEL)
                 DO KEL = IEL,JEL-1
                   ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL+1)
                 END DO
                 DO KEL = JEL + 1, NKEL
                   ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL)
                 END DO
C?               write(6,*) ' ILEX =' , ILEX
                 IACT = IREO(ILEX)
                 IF(IACT.LE.0.OR.IACT.GT.NSTRI) THEN
                   WRITE(6,*) '2 IACT out of bounds, IACT =  ', IACT
*                   STOP       ' IACT out of bounds '
        CALL SYSABENDMSG('lucia_util/adaadas1_gas',
     &                    'Internal error',' ')
                 END IF
C?               write(6,*) ' IACT = ', IACT
*PAM2009                 SIGN = DBLE((-1)**(IEL+JEL  )) * SCLFAC
                 SIGN = SGNARR(IEL+JEL) * SCLFAC
               ELSE IF (IEL.LT.0. AND. IIORB .EQ. JJORB) THEN
*. Diagonal excitation
                 SIGN = SCLFAC
                 IACT = KKSTR
               END IF
               IF(IACT.NE.0) THEN
                 IJ = (JJORB-JORB)*NIORB + IIORB-IORB+1
                 I1(KKSTR-KMIN+1,IJ) = IACT
                 XI1S(KKSTR-KMIN+1,IJ) = SIGN
               END IF
             END DO
*            ^ End of loop over IIORB
           END IF
*          ^ End of  active cases
         END DO
*        ^ End of loop over electrons to be annihilated
        END DO
*       ^ End of loop over Kstrings
      ELSE IF(IAC.EQ.1.AND.JAC.EQ.2) THEN
*
* ======================================
* Annihilation-creation  map a i a+ j
* ======================================
*
*. Diagonal excitations ?
        IF(IORBMIN.EQ.JORBMIN) THEN
         IDIAG = 1
        ELSE
         IDIAG = 0
        END IF
C       DO KKSTR = 1, NKSTR
        DO KKSTR = KMIN,KEND
*. Indicate where a given orbital j should be added in KKSTR
         IZERO = 0
         CALL ISETVC(ISCR(JORBMIN),IZERO,NJORB)
         JJEL = 1
         DO JJORB = JORBMIN,JORBMAX
 0803      CONTINUE
           IF(JJEL.LE.NKEL) THEN
             IF(JJORB.LT.KSTR(JJEL,KKSTR)) THEN
               ISCR(JJORB)=JJEL
             ELSE IF (JJORB.EQ.KSTR(JJEL,KKSTR)) THEN
               ISCR(JJORB) = - JJEL
               JJEL = JJEL+1
             ELSE IF (JJORB.GT.KSTR(JJEL,KKSTR)) THEN
               JJEL = JJEL + 1
               GOTO 0803
             END IF
           ELSE IF(JJEL.EQ.NKEL+1)THEN
              ISCR(JJORB) = JJEL
           END IF
         END DO
         IF(NTEST.GE.10000) THEN
           WRITE(6,*) ' ISCR from JORBMIN array for KKSTR = ', KKSTR
           CALL IWRTMA(ISCR(JORBMIN),1,NJORB,1,NJORB)
         END IF
         DO IEL = 1, NKEL+IDIAG
*. IEL = NKEL + 1 will be used for excitations a+j aj
           IF(IEL.LE.NKEL) IIORB = KSTR(IEL,KKSTR)
           IF((IIORB.GE.IORBMIN.AND.IIORB.LE.IORBMAX).OR.
     &         IEL.EQ.NKEL+1 )THEN
             DO JJORB = JORBMIN,JORBMAX
               JEL = ISCR(JJORB)
C?             WRITE(6,*) ' IEL IIORB JEL JJORB ',
C?   &                      IEL,IIORB,JEL,JJORB
               IACT = 0
               IF(IEL.LE.NKEL) THEN
                 IF(JEL.GT.0.AND.JJORB.GT.IIORB) THEN
*. New string is  a+1 ... a+ iel-1 a+iel+1 ..a+jel-1 a+jjorb a+jel+1 ...
*. Lexical number of new string
                   ILEX = 1
                   DO KEL = 1, IEL-1
                    ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL)
                   END DO
                   DO KEL = IEL+1, JEL-1
                    ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL-1)
                   END DO
                   ILEX = ILEX + IZ(JJORB,JEL-1)
                   DO KEL = JEL, NKEL
                    ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL)
                   END DO
                   IACT = IREO(ILEX)
                   IF(IACT.LE.0.OR.IACT.GT.NSTRI) THEN
                     WRITE(6,*) '3 IACT out of bounds, IACT =  ', IACT
                     WRITE(6,*) ' ILEX,KKSTR ', ILEX, KKSTR
                     WRITE(6,*) ' occupation of KSTR '
                     CALL IWRTMA(KSTR,1,NKEL,1,NKEL)
                     WRITE(6,*) ' IEL JEL ', IEL,JEL
                     WRITE(6,*) ' IIORB,JJORB',IIORB,JJORB
*                     STOP       ' IACT out of bounds '
        CALL SYSABENDMSG('lucia_util/adaadas1_gas',
     &                    'Internal error',' ')
                   END IF
*PAM2009                   SIGN = DBLE((-1)**(IEL+JEL)) * SCLFAC
                   SIGN = SGNARR(IEL+JEL) * SCLFAC
                 ELSE IF(JEL.GT.0 .AND. JJORB.LT.IIORB) THEN
*. New string is  a+1 ... a+ jel-1 a+ jjorb a+jel+1 ..a+iel-1 a+iel+1 ...
                   ILEX = 1
                   DO KEL = 1, JEL-1
                     ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL)
                   END DO
                   ILEX = ILEX + IZ(JJORB,JEL)
                   DO KEL = JEL,IEL-1
                     ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL+1)
                   END DO
                   DO KEL = IEL + 1, NKEL
                     ILEX = ILEX + IZ(KSTR(KEL,KKSTR),KEL)
                   END DO
                   IACT = IREO(ILEX)
*PAM2009                   SIGN = DBLE((-1)**(IEL+JEL-1)) * SCLFAC
                   SIGN = SGNARR(IEL+JEL+1) * SCLFAC
                   IF(IACT.LE.0.OR.IACT.GT.NSTRI) THEN
                     WRITE(6,*) '4 IACT out of bounds, IACT =  ', IACT
                     WRITE(6,*) ' NSTRI = ', NSTRI
                     WRITE(6,*) 'IIORB,JJORB ',IIORB,JJORB
                     WRITE(6,*) ' Kstring : '
                     CALL IWRTMA(KSTR(1,KKSTR),1,NKEL,1,NKEL)
                     WRITE(6,*) ' ILEX = ', ILEX
                     WRITE(6,*) 'IZ matrix'
                     CALL IWRTMA(IZ,NOCOB,NKEL,NOCOB,NKEL)
*                     STOP       ' IACT out of bounds '
        CALL SYSABENDMSG('lucia_util/adaadas1_gas',
     &                    'Internal error',' ')
                   END IF
                 END IF
                 IF(IACT.NE.0) THEN
                   IJ = (JJORB-JORB)*NIORB + IIORB-IORB+1
                   I1(KKSTR-KMIN+1,IJ) = IACT
                   XI1S(KKSTR-KMIN+1,IJ) = SIGN
                 END IF
               ELSE IF(IEL.EQ.NKEL+1.AND.JEL.GT.0) THEN
*. Diagonal excitations aja+j
                 JJ = (JJORB-JORB)*NJORB + JJORB-JORB+1
                 I1(KKSTR-KMIN+1,JJ) = KKSTR
                 XI1S(KKSTR-KMIN+1,JJ) = SCLFAC
               END IF
             END DO
*            ^ End of loop over JJORB
           END IF
*          ^ End of  active cases
         END DO
*        ^ End of loop over electrons to be annihilated
        END DO
*       ^ End of loop over Kstrings
      END IF
*.    ^ End of types of creation mappings
*
      IF(NTEST.GT.0) THEN
        WRITE(6,*) ' Output from ADADST1_GAS '
        WRITE(6,*) ' ===================== '
        WRITE(6,*) ' Number of K strings accessed ', NK
        IF(NK.NE.0) THEN
          IJ = 0
          DO  JJORB = JORB,JORB+NJORB-1
            DO  IIORB = IORB, IORB + NIORB - 1
              IJ = IJ + 1
C?            WRITE(6,*) ' IJ = ', IJ
C?            IF(IIORB.GT.JJORB) THEN
                WRITE(6,*)
     &          ' Info for orbitals (iorb,jorb) ', IIORB,JJORB
                WRITE(6,*) ' Excited strings and sign '
                CALL IWRTMA(I1(1,IJ),1,NK,1,NK)
                CALL WRTMAT(XI1S(1,IJ),1,NK,1,NK)
C?            END IF
            END DO
          END DO
        END IF
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
!               2010, Jonas Bostrom                                    *
!               2021, Roland Lindh                                     *
!***********************************************************************

subroutine ChoMP2g_deallocate(irc)
!
! Purpose: Deallocate memory needed for
!          MP2-gradients or properties.

use ChoMP2, only: AdrR1, AdrR2, ChoMP2g_allocated, EFrozT, EOccuT, EVirtT, MP2D, MP2D_e, MP2D_e_full, MP2D_full, MP2W, MP2W_e, &
                  MP2W_e_full, MP2W_full
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: iSym

irc = 0

if (ChoMP2g_allocated) then

  call mma_deallocate(MP2D_full)
  call mma_deallocate(MP2W_full)
  call mma_deallocate(MP2D_e_full)
  call mma_deallocate(MP2W_e_full)
  do iSym=1,8
    nullify(MP2D(iSym)%A,MP2W(iSym)%A,MP2D_e(iSym)%A,MP2W_e(iSym)%A)
  end do
  call mma_deallocate(AdrR2)
  call mma_deallocate(AdrR1)
  call mma_deallocate(EVirtT)
  call mma_deallocate(EOccuT)
  call mma_deallocate(EFrozT)

  ChoMP2g_allocated = .false.

end if

end subroutine ChoMP2g_deallocate

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function IPHASE(IDRT,IUP,IWALK)
! PURPOSE: THE SYMMETRIC GROUP APPROACH AND THE UNITARY GROUP
!          APPROACH DIFFER IN THE PHASE CONVENTION. FIND THE
!          PHASE FACTOR RELATING THE CSFS IN EITHER BASIS.

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IPHASE
#include "gugx.fh"
integer(kind=iwp), intent(in) :: IDRT(NVERT,5), IUP(NVERT,0:3), IWALK(NLEV)
integer(kind=iwp) :: ICASE, ISGN, IVERT, LEV

! FIND THE MIDVERTEX AND THE COMBINED WALK SYMMETRY

IPHASE = 1
IVERT = NVERT
do LEV=1,NLEV
  ICASE = IWALK(LEV)
  IVERT = IUP(IVERT,ICASE)
  if ((ICASE == 2) .or. (ICASE == 3)) then
    ISGN = (-1)**IDRT(IVERT,4)
    IPHASE = IPHASE*ISGN
  end if
end do

! EXIT

return

end function IPHASE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,1993, Roland Lindh                                *
************************************************************************
      SubRoutine Screen(nZeta,nEta,mZeta,mEta,lZeta,lEta,
     &                  Zeta,ZInv,P,KappAB,IndZet,Data1,nAlpha,nBeta,
     &                  IndZ,ZtMax,abMax,ZtMaxD,abMaxD,
     &                  Eta,EInv,Q,KappCD,IndEta,Data2,nGamma,nDelta,
     &                  IndE,EtMax,cdMax,EtMaxD,cdMaxD,
     &                  Dij,Dkl,
     &                  iphX1,iphY1,iphZ1,iphX2,iphY2,iphZ2,CutDInt,
     &                  CutInt,vij,vkl,vik,vil,vjk,vjl,
     &                  Prescreen_On_Int_Only)
************************************************************************
*                                                                      *
* Object: to prescreen the integrals for Direct SCF                    *
*                                                                      *
*   nZeta, nEta : unpartioned length of primitives.                    *
*                                                                      *
*   mZeta, mEta : section length due to partioning. These are usually  *
*                 equal to nZeta and nEta.                             *
*                                                                      *
*   lZeta, lEta : section length after prescreening.                   *
*                                                                      *
*   Observe that the integrals are ordered for optimal performance in  *
*   the integral generation step whereas the 1st order density is      *
*   canonically ordered.                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             March '92                                                *
*             April '92 modified for gradient estimate                 *
*             January '93 modified to Direct SCF                       *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
      Real*8 Zeta(mZeta), ZInv(mZeta), KappAB(mZeta), P(nZeta,3),
     &        Eta(mEta),  EInv(mEta),  KappCD(mEta),  Q(nEta, 3),
     &       Data1(nZeta*(nDArray-1)), Data2(nEta*(nDArray-1)),
     &       Dij(nZeta), Dkl(nEta)
      Real*8 ZtMax,EtMax,abMax,cdMax,ZtMaxD,EtMaxD,abMaxD,cdMaxD
      Integer   IndZet(nZeta), IndEta(nEta),
     &          IndZ(nZeta), IndE(nEta)
      Logical Prescreen_On_Int_Only
*
#include "print.fh"
#include "real.fh"
*
*     decalaration of local variables...
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt(' In Screen: Data1',' ',Data1,nZeta,nDArray-1)
      Call RecPrt(' In Screen: Data2',' ',Data2,nEta ,nDArray-1)
      Call FZero(P,nZeta*3)
      Call FZero(Q,nEta *3)
#endif
*
      If (.Not.Prescreen_On_Int_Only) Then
*
*        The former technique will be used for integrals which will
*        be partially stored.
*
*-----   Set up prescreening parameters
*
         DMax = Max(vik,vil,vjk,vjl)/Four            ! AO basis
*
*-----   Combine threshold with maximum of density contribution.
*        Note that we are using the square to avoid doing the
*        square root in the denominator!
         Cut  = Max(CutDInt/Max(DMax,vij,vkl),CutDInt)      ! AO basis
*
*-----   Test on the largest integral which will be produced by this
*        batch.
*
         vMax = abMax*cdMax                     ! integral in AO basis
*-----   Skip prescreening if too low.
         If (vMax.lt.Cut) Then
            lZeta = 0
            lEta  = 0
            Go To 999
         End If
      Else
         DMax=Zero
      End If
*
      lZeta=0
      lEta =0
*
*---- prescreen zeta pairs
      If (.Not.Prescreen_On_Int_Only) Then
         lZeta=0
         Do iZeta = 1, mZeta
            ppaa= Data1(ip_ab   (iZeta,nZeta)) * cdMax
            aaaa= Data1(ip_abCon(iZeta,nZeta)) * cdMax
            jZeta = IndZ(iZeta)
            Test=ppaa*Dij(jZeta)+aaaa*(DMax+vkl)
            If (Test.ge.CutDInt) Then
               lZeta=lZeta+1
               Zeta(lZeta)  = Data1(ip_Z    (iZeta,nZeta))
               KappAB(lZeta)= Data1(ip_Kappa(iZeta,nZeta))
               P(lZeta,1)   = Data1(ip_Pcoor(iZeta,        nZeta))
               P(lZeta,2)   = Data1(ip_Pcoor(iZeta+  nZeta,nZeta))
               P(lZeta,3)   = Data1(ip_Pcoor(iZeta+2*nZeta,nZeta))
               IndZet(lZeta)= IndZ(iZeta)
               ZInv(lZeta)  = Data1(ip_ZInv (iZeta,nZeta))
            End If
         End Do
      Else
         lZeta=0
         Do iZeta = 1, mZeta
            aaaa= Data1(ip_abCon(iZeta,nZeta)) * cdMax
            If (aaaa.ge.CutInt) Then
               lZeta=lZeta+1
               Zeta(lZeta)  = Data1(ip_Z    (iZeta,nZeta))
               KappAB(lZeta)= Data1(ip_Kappa(iZeta,nZeta))
               P(lZeta,1)   = Data1(ip_Pcoor(iZeta,        nZeta))
               P(lZeta,2)   = Data1(ip_Pcoor(iZeta+  nZeta,nZeta))
               P(lZeta,3)   = Data1(ip_Pcoor(iZeta+2*nZeta,nZeta))
               IndZet(lZeta)= IndZ(iZeta)
               ZInv(lZeta)  = Data1(ip_ZInv (iZeta,nZeta))
            End If
         End Do
      End If
      If (lZeta.eq.0) Go To 999
*
      If (iphX1.ne.1) Call DScal_(lZeta,-One,P(1,1),1)
      If (iphY1.ne.1) Call DScal_(lZeta,-One,P(1,2),1)
      If (iphZ1.ne.1) Call DScal_(lZeta,-One,P(1,3),1)
*
*---- prescreen eta pairs
      If (.Not.Prescreen_On_Int_Only) Then
         lEta=0
         Do iEta = 1, mEta
            ppaa= Data2(ip_ab   (iEta,nEta)) * abMax
            aaaa= Data2(ip_abCon(iEta,nEta)) * abMax
            jEta = IndE(iEta)
            Test=ppaa*Dkl(jEta)+aaaa*(DMax+vij)
            If (Test.ge.CutDInt) Then
               lEta=lEta+1
               IndEta(lEta)= IndE(iEta)
               Eta(lEta)   = Data2(ip_Z    (iEta,nEta))
               KappCD(lEta)= Data2(ip_Kappa(iEta,nEta))
               Q(lEta,1)   = Data2(ip_Pcoor(iEta,       nEta))
               Q(lEta,2)   = Data2(ip_Pcoor(iEta+  nEta,nEta))
               Q(lEta,3)   = Data2(ip_PCoor(iEta+2*nEta,nEta))
               EInv(lEta)  = Data2(ip_ZInv (iEta,nEta))
            End If
         End Do
      Else
         lEta=0
         Do iEta = 1, mEta
            aaaa= Data2(ip_abCon(iEta,nEta)) * abMax
            If (aaaa.ge.CutInt) Then
               lEta=lEta+1
               IndEta(lEta)= IndE(iEta)
               Eta(lEta)   = Data2(ip_Z    (iEta,nEta))
               KappCD(lEta)= Data2(ip_Kappa(iEta,nEta))
               Q(lEta,1)   = Data2(ip_Pcoor(iEta,       nEta))
               Q(lEta,2)   = Data2(ip_Pcoor(iEta+  nEta,nEta))
               Q(lEta,3)   = Data2(ip_PCoor(iEta+2*nEta,nEta))
               EInv(lEta)  = Data2(ip_ZInv (iEta,nEta))
            End If
         End Do
      End If
      If (lEta.eq.0) Go To 999
*
      If (iphX2.ne.1) Call DScal_(lEta,-One,Q(1,1),1)
      If (iphY2.ne.1) Call DScal_(lEta,-One,Q(1,2),1)
      If (iphZ2.ne.1) Call DScal_(lEta,-One,Q(1,3),1)
*
 999  Continue
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*) ' In Screen'
      Call RecPrt(' Zeta  ',' ',Zeta,lZeta,1)
      Call RecPrt(' Eta   ',' ', Eta, lEta,1)
      Call RecPrt(' ZInv  ',' ',ZInv,lZeta,1)
      Call RecPrt(' EInv  ',' ',EInv,lEta, 1)
      Call RecPrt(' Px    ',' ',P(1,1),lZeta,1)
      Call RecPrt(' Py    ',' ',P(1,2),lZeta,1)
      Call RecPrt(' Pz    ',' ',P(1,3),lZeta,1)
      Call RecPrt(' Qx    ',' ',Q(1,1),lEta, 1)
      Call RecPrt(' Qy    ',' ',Q(1,2),lEta, 1)
      Call RecPrt(' Qz    ',' ',Q(1,3),lEta, 1)
      Call RecPrt(' KappAB',' ',KappAB,lZeta,1)
      Call RecPrt(' KappCD',' ',KappCD,lEta, 1)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nAlpha)
         Call Unused_integer(nBeta)
         Call Unused_real(ZtMax)
         Call Unused_real(ZtMaxD)
         Call Unused_real(abMaxD)
         Call Unused_integer(nGamma)
         Call Unused_integer(nDelta)
         Call Unused_real(EtMax)
         Call Unused_real(EtMaxD)
         Call Unused_real(cdMaxD)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RInt_Generic(rkappa,rmos,rmoa,Fock,Q,Focki,Focka,idsym,reco,jspin)
!                          ~
! Constructs  F  = <0|[E  ,H]|0> (+ <0|[[E  , Kappa],H]|0>)
!              pq       pq                pq

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use MCLR_Data, only: CMO, CMO_Inv, FAMO, FIMO, G1t, G2t, ipCM, ipMat, ipMatBA, nA, nDens, nMBA
use input_mclr, only: iMethod, IsPop, LuAChoVec, LuIChoVec, nAsh, nBas, NewCho, nIsh, nOrb, nSym
#ifdef _DEBUGPRINT_
use Spool, only: LuWr
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: rkappa(nDens), reco
real(kind=wp), intent(_OUT_) :: rMOs(*), rmoa(*)
real(kind=wp), intent(out) :: Fock(nDens)
real(kind=wp), intent(inout) :: Q(nDens), FockI(nDens), FockA(nDens)
integer(kind=iwp), intent(in) :: iDSym, jSpin
integer(kind=iwp) :: iAsh, iB, iij, ijS, ikl, iOff, iOff2, iOff3, iOff4, iOff5, ip2, ipF, ipFI, ipGx, iRead, iS, iSym, jAsh, jB, &
                     jS, jSym, kAsh, kS, lAsh, lS, nAct, nAG2, nAtri, nG2
real(kind=wp) :: Dij, Fact
logical(kind=iwp) :: DoAct, Fake_CMO2
type(DSBA_Type) :: CVa(2), DA, DI, DLT(1), FkA, FkI, JA, JI(1), KA, Kappa, KI, QVec, WCMO, WCMO_Inv
real(kind=wp), allocatable :: Dens2(:), G2x(:), MT1(:), MT2(:), MT3(:), QTemp(:)
#ifdef _DEBUGPRINT_
real(kind=wp), external :: DDot_
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(LuWr,*) 'Focki=',DDot_(nDens,Focki,1,Focki,1)
write(LuWr,*) 'Focka=',DDot_(nDens,Focka,1,Focka,1)
#endif

Fact = -One
Fock(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. NewCho) then  ! Cho-MO

  call mma_allocate(MT1,nmba,Label='MT1')
  call mma_allocate(MT2,nmba,Label='MT2')
  MT1(:) = Zero
  MT2(:) = Zero

  call R2ElInt(rkappa,MT1,MT2,focki,focka,idSym,ReCo,Fact,jspin)
# ifdef _DEBUGPRINT_
  write(LuWr,*) 'MT1=',DDot_(nmba,MT1,1,MT1,1)
  write(LuWr,*) 'MT2=',DDot_(nmba,MT2,1,MT2,1)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Q  = sum(jkl)=(pj|kl)d(ijkl)
  !  pi

  if (iMethod == 2) then
    call mma_allocate(QTemp,nDens,Label='QTemp')
    call CreQ(Q,MT1,G2t,idsym)
    call CreQ(QTemp,MT2,G2t,idsym)
#   ifdef _DEBUGPRINT_
    write(LuWr,*) 'Q=',DDot_(nDens,Q,1,Q,1)
    write(LuWr,*) 'QTemp=',DDot_(nDens,QTemp,1,QTemp,1)
#   endif
    Q(:) = Q(:)+QTemp(:)
    call mma_deallocate(QTemp)
  end if

else  ! Cho-Fock

  Fake_CMO2 = .false.
  DoAct = .true.

  ! Form inactive density

  call Allocate_DT(DI,nOrb,nOrb,nSym)
  DI%A0(:) = Zero

  do iS=1,nsym
    do iB=1,nIsh(iS)
      DI%SB(iS)%A2(iB,iB) = Two
    end do
  end do

  ! Form AO 1-index transform inactive density

  call mma_allocate(Dens2,nDens,Label='Dens2')
  Dens2(:) = Zero
  call Allocate_DT(DLT(1),nOrb,nOrb,nSym) ! Note SQ format
  DLT(1)%A0(:) = Zero

  if (idSym /= 1) then
    write(u6,*) 'idSym/=1, idSym=',idsym
    call Abend()
  end if

  do iS=1,nSym
    if (nOrb(iS) /= 0) then
      do jS=1,nSym
        if ((Mul(iS,jS) == idsym) .and. (nOrb(jS) /= 0)) then
          call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(jS),One,rkappa(ipMat(is,js)),nOrb(iS),DI%SB(js)%A2,nOrb(jS),Zero, &
                      Dens2(ipMat(iS,jS)),nOrb(iS))
          call DGEMM_('T','T',nOrb(jS),nOrb(iS),nOrb(iS),One,Dens2(ipMat(iS,jS)),nOrb(iS),CMO(ipCM(is)),nOrb(iS),Zero, &
                      DLT(1)%SB(iS)%A2,nOrb(jS))
          call DGEMM_('T','T',nOrb(jS),nOrb(jS),nOrb(iS),One,DLT(1)%SB(iS)%A2,nOrb(iS),CMO(ipCM(js)),nOrb(jS),Zero, &
                      Dens2(ipMat(iS,jS)),nOrb(jS))

          call DGEMM_('T','T',nOrb(jS),nOrb(iS),nOrb(iS),One,DI%SB(js)%A2,nOrb(iS),CMO(ipCM(is)),nOrb(iS),Zero,DLT(1)%SB(iS)%A2, &
                      nOrb(jS))
          call DGEMM_('T','T',nOrb(jS),nOrb(jS),nOrb(iS),One,DLT(1)%SB(iS)%A2,nOrb(iS),CMO(ipCM(js)),nOrb(jS),Zero,DI%SB(js)%A2, &
                      nOrb(jS))
        end if
      end do
    end if
  end do
  ! Release and allocate again in LT format
  call Deallocate_DT(DLT(1))
  call Allocate_DT(DLT(1),nOrb,nOrb,nSym,aCase='TRI')

  call Fold_Mat(nSym,nOrb,Dens2,DLT(1)%A0)
  DLT(1)%A0(:) = ReCo*DLT(1)%A0(:)

  ! Form active density and MO coefficients

  nAct = sum(nAsh(1:nSym))
  nAtri = nTri_Elem(nTri_Elem(nAct))
  if (iMethod == 2) then
    nG2 = 0
    do iSym=1,nSym
      nAG2 = 0
      do jSym=1,nSym
        nAG2 = nAG2+nAsh(jSym)*nAsh(Mul(jSym,iSym))
      end do
      nG2 = nG2+nAG2**2
    end do

    call Allocate_DT(CVa(1),nAsh,nOrb,nSym)
    call Allocate_DT(CVa(2),nAsh,nOrb,nSym)
    call Allocate_DT(DA,nAsh,nAsh,nSym)

    ioff = 0
    ioff4 = 1
    do iS=1,nSym
      ioff2 = ioff+nOrb(iS)*nIsh(iS)
      ioff5 = ioff4+nOrb(iS)*nIsh(iS)
      do iB=1,nAsh(iS)
        ioff3 = ioff2+nOrb(iS)*(iB-1)
        CVa(1)%SB(iS)%A2(iB,:) = CMO(ioff3+1:ioff3+nOrb(iS))
        do jB=1,nAsh(iS)
          ip2 = iTri(nA(is)+ib,nA(is)+jb)
          DA%SB(iS)%A2(iB,jB) = G1t(ip2)
        end do
      end do
      !MGD to check
      call DGEMM_('T','T',nAsh(iS),nOrb(iS),nOrb(iS),One,rkappa(ioff5),nOrb(iS),CMO(1+ioff),nOrb(iS),Zero,CVa(2)%SB(iS)%A2,nAsh(iS))
      ioff = ioff+(nIsh(iS)+nAsh(iS))*nOrb(iS)
      ioff4 = ioff4+nOrb(iS)**2
    end do

    ! Expand 2-body density matrix

    call mma_allocate(G2x,nG2,Label='G2x')
    ipGx = 0
    do ijS=1,nSym
      do iS=1,nSym
        jS = Mul(is,ijS)
        do kS=1,nSym
          lS = Mul(kS,ijS)
          do kAsh=1,nAsh(ks)
            do lAsh=1,nAsh(ls)
              ikl = iTri(lAsh+nA(lS),kAsh+nA(kS))
              do iAsh=1,nAsh(is)
                do jAsh=1,nAsh(js)
                  iij = iTri(iAsh+nA(is),jAsh+nA(jS))
                  ipGx = ipGx+1
                  G2x(ipGx) = G2t(iTri(iij,ikl))
                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end if

  ! Allocate temp arrays and zero Fock matrices

  rMOs(1:nATri) = Zero
# ifdef _DEBUGPRINT_
  call RecPrt('DLT',' ',DLT(1)%A0,1,size(DLT(1)%A0))
  call RecPrt('DI ',' ',DI%A0,1,size(DI%A0))
  call RecPrt('DA ',' ',DA%A0,1,size(DA%A0))
  call RecPrt('G2x',' ',G2x,1,size(G2x))
  call RecPrt('rKappa ',' ',rKappa,1,size(rKappa))
# endif

  ! Compute the whole thing

  call Allocate_DT(Kappa,nBas,nBas,nSym,Ref=rKappa)
  call Allocate_DT(JI(1),nBas,nBas,nSym,aCase='TRI')
  JI(1)%A0(:) = Zero
  call Allocate_DT(KI,nBas,nBas,nSym)
  KI%A0(:) = Zero
  call Allocate_DT(JA,nBas,nBas,nSym)
  JA%A0(:) = Zero
  call Allocate_DT(KA,nBas,nBas,nSym)
  KA%A0(:) = Zero
  call Allocate_DT(FkI,nBas,nBas,nSym,Ref=FockI)
  FkI%A0(:) = Zero
  call Allocate_DT(FkA,nBas,nBas,nSym,Ref=FockA)
  FkA%A0(:) = Zero
  call Allocate_DT(QVec,nBas,nAsh,nSym,Ref=Q)
  call Allocate_DT(WCMO,nBas,nAsh,nSym,Ref=CMO)
  call Allocate_DT(WCMO_Inv,nBas,nAsh,nSym,Ref=CMO_Inv)
  iread = 2 ! Asks to read the half-transformed Cho vectors

  call CHO_LK_MCLR(DLT,DI,DA,G2x,Kappa,JI,KI,JA,KA,FkI,FkA,rMOs,QVec,CVa,WCMO,WCMO_inv,nIsh,nAsh,DoAct,Fake_CMO2,LuAChoVec, &
                   LuIChoVec,iread)

  call Deallocate_DT(WCMO_Inv)
  call Deallocate_DT(WCMO)
  call Deallocate_DT(QVec)
  call Deallocate_DT(FkA)
  call Deallocate_DT(FkI)
  call Deallocate_DT(KA)
  call Deallocate_DT(JA)
  call Deallocate_DT(KI)
  call Deallocate_DT(JI(1))
  call Deallocate_DT(Kappa)
  call GADSum(FockI,nDens)
  call GADSum(FockA,nDens)
# ifdef _DEBUGPRINT_
  do iSym=1,nSym
    write(u6,*) 'iSym=',iSym
    !call RecPrt('FIMO ',' ',FIMO(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
    !call RecPrt('FAMO ',' ',FAMO(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
    call RecPrt('FockI',' ',FockI(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
    call RecPrt('FockA',' ',FockA(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
    !call RecPrt('Q',' ',Q(ipMatba(iSym,iSym)),nOrb(iSym),nAsh(iSym))
  end do
  !call RecPrt('MO1',' ',rMOs,1,nAtri)
# endif

  ! Calculate contribution from uncontracted indexes

  do iS=1,nSym
    jS = Mul(iS,iDSym)
    if (nOrb(iS)*nOrb(jS) /= 0) then
      call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(iS),Reco*Fact,FIMO(ipCM(iS)),nOrb(is),rkappa(ipMat(iS,jS)),nOrb(iS),One, &
                  FockI(ipMat(iS,jS)),nOrb(iS))
      call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(jS),Fact,rkappa(ipMat(iS,jS)),nOrb(is),FIMO(ipCM(jS)),nOrb(jS),One, &
                  FockI(ipMat(iS,jS)),nOrb(is))
      if (iMethod == 2) then
        call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(iS),Reco*Fact,FAMO(ipCM(iS)),nOrb(is),rkappa(ipMat(iS,jS)),nOrb(iS),One, &
                    FockA(ipMat(iS,jS)),nOrb(iS))
        call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(jS),Fact,rkappa(ipMat(iS,jS)),nOrb(is),FAMO(ipCM(jS)),nOrb(jS),One, &
                    FockA(ipMat(iS,jS)),nOrb(is))
      end if
    end if
  end do

  ! Deallocate

  call mma_deallocate(Dens2)

  if (iMethod == 2) then
    call mma_deallocate(G2x)
    call Deallocate_DT(CVa(2))
    call Deallocate_DT(CVa(1))
    call deallocate_DT(DA)
  end if

  call deallocate_DT(DLT(1))
  call deallocate_DT(DI)

  call GADSum(Q,nDens)
  call GADSum(rMOs,nAtri)

# ifdef _DEBUGPRINT_
  do iSym=1,nSym
    write(u6,*) 'iSym=',iSym
    call RecPrt('FockI',' ',FockI(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
    call RecPrt('FockA',' ',FockA(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
    call RecPrt('Q',' ',Q(ipMatba(iSym,iSym)),nOrb(iSym),nAsh(iSym))
  end do
  call RecPrt('MO1',' ',rMOs,1,nAtri)
  call abend()
# endif

end if
!                                                                      *
!***********************************************************************
!                                                                      *

do iS=1,nSym
  jS = Mul(iS,idsym)

  !         I    A
  ! F  = 2 ( F  + F  )
  !  pi       pi   pi

  if (nIsh(iS)*nOrb(jS) > 0) then
    Fock(ipMat(js,is):ipMat(js,is)+nIsh(iS)*nOrb(jS)-1) = Fock(ipMat(js,is):ipMat(js,is)+nIsh(iS)*nOrb(jS)-1)+ &
                                                          Two*Focki(ipMat(js,is):ipMat(js,is)+nIsh(iS)*nOrb(jS)-1)
    if (iMethod == 2) Fock(ipMat(js,is):ipMat(js,is)+nIsh(iS)*nOrb(jS)-1) = Fock(ipMat(js,is):ipMat(js,is)+nIsh(iS)*nOrb(jS)-1)+ &
                                                                            Two*Focka(ipMat(js,is):ipMat(js,is)+nIsh(iS)*nOrb(jS)-1)
  end if

  if (nOrb(iS) > 0) then
    do iAsh=1,nAsh(jS)
      do jAsh=1,nAsh(js)
        ipF = ipMat(js,is)+nIsh(js)+jAsh-1
        ipFI = ipMat(is,js)+(nIsh(js)+iAsh-1)*nOrb(is)
        Dij = G1t(iTri(iash+nA(js),jAsh+nA(js)))

        !         I
        ! F  = F - F  D
        !  ap   ap  ap ba

        ipF = ipMat(is,js)+(Nish(js)+iAsh-1)*nOrb(is)
        ipFI = ipMat(is,js)+(Nish(js)+jAsh-1)*nOrb(is)

        !         I
        ! F  = F + F  D
        !  pa   pa  pb ab

        Fock(ipF:ipF+nOrb(is)-1) = Fock(ipF:ipF+nOrb(is)-1)+Dij*Focki(ipFI:ipFI+nOrb(is)-1)
      end do
    end do
  end if

  ! F  = F  + Q
  !  pa   pa   pa

  Fock(ipMat(js,is)+nOrb(js)*nIsh(is):ipMat(js,is)+nOrb(js)*(nIsh(is)+nAsh(is))-1) = &
    Fock(ipMat(js,is)+nOrb(js)*nIsh(is):ipMat(js,is)+nOrb(js)*(nIsh(is)+nAsh(is))-1)+ &
    Q(ipMatba(js,is):ipMatba(js,is)+nAsh(is)*nOrb(js)-1)

  ! F  = F  - Q
  !  ap   ap   ap

end do
#ifdef _DEBUGPRINT_
write(LuWr,*) 'Fock=',DDot_(nDens,Fock,1,Fock,1)
#endif

Focka(:) = Two*Fock(:)
do iS=1,nSym
  js = Mul(is,idsym)
  if (nOrb(is)*nOrb(js) /= 0) &
    call DGESUB(Focka(ipMat(is,js)),nOrb(is),'N',Focka(ipMat(js,is)),nOrb(js),'T',Fock(ipMat(is,js)),nOrb(is),nOrb(is),nOrb(js))
end do
#ifdef _DEBUGPRINT_
write(LuWr,*) 'Fock=',DDot_(nDens,Fock,1,Fock,1)
#endif

call AddGrad(rKappa,Fock,idsym,Two*fact)
if (.not. newCho) then
  call mma_allocate(MT3,nmba,Label='MT3')
  MT3(:) = MT1(:)+MT2(:)
  call PickMO_MCLR(MT3,rmos,idsym)

  if (ispop /= 0) then
    MT3(:) = MT2(:)-MT1(:)
    call PickMO_MCLR(MT3,rmoa,idsym)
  end if
  call mma_deallocate(MT3)
  call mma_deallocate(MT2)
  call mma_deallocate(MT1)
end if
#ifdef _DEBUGPRINT_
write(LuWr,*) 'Exit RInt_Generic'
#endif

end subroutine RInt_Generic

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Modify_TInt_p(TInt,nTheta_All,List2,mData)
      use Basis_Info
      Implicit Real*8 (a-h,o-z)
      Real*8 TInt(nTheta_All,nTheta_All)
      Integer List2(mData,nTheta_All)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('Modify_TInt_p: TInt',' ',TInt,nTheta_All,nTheta_All)
#endif
      Do iTheta_All= 1, nTheta_All
         iPrim=List2(5,iTheta_All)
         iShll=List2(7,iTheta_All)
         nConti=Shells(iShll)%nBasis_C
         nPrimi=Shells(iShll)%nExp
         Coeff_i = DDot_(nConti,Shells(iShll)%Cff_c(1,1,1),nPrimi,
     &                          Shells(iShll)%Cff_c(1,1,1),nPrimi)
         Coeff_i = Sqrt(Coeff_i)
*
         jPrim=List2(6,iTheta_All)
         jShll=List2(8,iTheta_All)
         nContj=Shells(jShll)%nBasis_C
         nPrimj=Shells(jShll)%nExp
         Coeff_j = DDot_(nContj,Shells(jShll)%Cff_c(1,1,1),nPrimj,
     &                          Shells(jShll)%Cff_c(1,1,1),nPrimj)
         Coeff_j = Sqrt(Coeff_j)
*
         Do jTheta_All = 1, nTheta_All
            kPrim=List2(5,jTheta_All)
            kShll=List2(7,jTheta_All)
            nContk=Shells(kShll)%nBasis_C
            nPrimk=Shells(kShll)%nExp
            Coeff_k = DDot_(nContk,Shells(kShll)%Cff_c(1,1,1),nPrimk,
     &                             Shells(kShll)%Cff_c(1,1,1),nPrimk)
            Coeff_k = Sqrt(Coeff_k)
*
            lPrim=List2(6,jTheta_All)
            lShll=List2(8,jTheta_All)
            nContl=Shells(lShll)%nBasis_C
            nPriml=Shells(lShll)%nExp
            Coeff_l = DDot_(nContl,Shells(lShll)%Cff_c(1,1,1),nPriml,
     &                             Shells(lShll)%Cff_c(1,1,1),nPriml)
            Coeff_l = Sqrt(Coeff_l)
*
            TInt(iTheta_All,jTheta_All) = TInt(iTheta_All,jTheta_All)
     &                                  * Coeff_i * Coeff_j
     &                                  * Coeff_k * Coeff_l
#ifdef _DEBUGPRINT_
            Write (6,*)
            Write (6,*) Coeff_i,Coeff_j,Coeff_k,Coeff_l
            Write (6,*) iPrim,  jPrim,  kPrim,  lPrim
            Write (6,*) nPrimi, nPrimj, nPrimk, nPriml
#endif
*
         End Do
*
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Modify_TInt_p: TInt',' ',TInt,nTheta_All,nTheta_All)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRMake(TRVec,Coor,nAtoms,nTR,uMtrx,nDim,CofM)

use Symmetry_Info, only: VarR, VarT
use Slapaf_Info, only: dMass, Smmtrc
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nDim
real(kind=wp), intent(out) :: TRVec(6,3,nAtoms)
real(kind=wp), intent(in) :: Coor(3,nAtoms), uMtrx(3,nAtoms)
integer(kind=iwp), intent(out) :: nTR
logical(kind=iwp), intent(in) :: CofM
integer(kind=iwp) :: i, iAtom, iCmp, j, k
real(kind=wp) :: CM(3), rii, rNorm
logical(kind=iwp) :: SymDsp

#ifdef _DEBUGPRINT_
call RecPrt(' In TRMake: Coor',' ',Coor,3,nAtoms)
write(u6,*) ' nDim=',nDim
#else
#include "macros.fh"
unused_var(nDim)
#endif

TRVec(:,:,:) = Zero
nTR = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Translation

if (.not. VarT) then
  do i=1,3
    iCmp = 2**(i-1)
    if (SymDsp(iCmp)) then
      nTR = nTR+1
      TRVec(nTR,i,:) = One
    end if
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Rotation around some center

! Loop over axis

if (.not. VarR) then
  do i=1,3
    CM(i) = Zero
    rNorm = Zero
    do iAtom=1,nAtoms
      if (CofM) then
        rNorm = rNorm+uMtrx(i,iAtom)*dMass(iAtom)
        if (Smmtrc(i,iAtom)) CM(i) = CM(i)+uMtrx(i,iAtom)*Coor(i,iAtom)*dMass(iAtom)
      else
        rNorm = rNorm+uMtrx(i,iAtom)
        if (Smmtrc(i,iAtom)) CM(i) = CM(i)+uMtrx(i,iAtom)*Coor(i,iAtom)
      end if
    end do
    CM(i) = CM(i)/rNorm
  end do
  !write(u6,*) 'TrMake CM=',CM

  do i=1,3
    j = mod(i,3)+1
    k = mod(i+1,3)+1
    ! j and k are the index of the plane perpendicular to the axis

    ! Check the rotation has any mirror plane parallel to the axis
    ! of the rotation. If not then the rotation will not break the
    ! symmetry.

    iCmp = ibset(ibset(0,j-1),k-1)
    if (SymDsp(iCmp)) then
      nTR = nTR+1
      TRVec(nTR,k,:) = Coor(j,:)-CM(j)
      TRVec(nTR,j,:) = CM(k)-Coor(k,:)
    end if
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Normalize vectors

do i=1,nTR
  rii = Zero
  do iAtom=1,nAtoms
    do j=1,3
      rii = rii+uMtrx(j,iAtom)*TRVec(i,j,iatom)**2
    end do
  end do
  if (rii > 1.0e-15_wp) then
    TRVec(i,:,:) = TRVec(i,:,:)/sqrt(rii)
  else
    TRVec(i,:,:) = Zero
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt(' In TRMake: TRVec',' ',TRVec,6,3*nAtoms)
#endif

call TROrder(TRVec,nTR,3*nAtoms)

#ifdef _DEBUGPRINT_
call RecPrt(' In TRMake: TRVec',' ',TRVec,nTR,3*nAtoms)
#endif

call TRComp(TRVec,nTR,3*nAtoms,SmmTrc)

#ifdef _DEBUGPRINT_
call RecPrt(' In TRMake: TRVec',' ',TRVec,nTR,nDim)
#endif

end subroutine TRMake

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************
!  MultiNew
!
!> @brief
!>   Perform the MME in contracted AO-basis
!> @author A. Ohrn
!>
!> @details
!> (i) Read in the multipole integrals from Seward. (ii) Construct
!> some data to simplify accessing the computed data. (iii) Make
!> the actual MME.
!>
!> @note
!> Requires numbers taken from ::qfread. We also need some integrals
!> that supposedly have been computed by Seward.
!>
!> @param[in]  nAt      Number of atoms in QM-molecule
!> @param[in]  nBas     Number of contracted basis functions
!> @param[in]  nOcc     Number of basis functions of the \f$ i \f$ -th atom-type
!> @param[in]  natyp    Number of atoms of the \f$ i \f$ -th atom-type
!> @param[in]  nntyp    Number of atom-types
!> @param[out] MME      The multicenter multipole expanded densities of unique pairs of contracted basis functions
!> @param[out] iCenTri  Set of indices that tells to which center the \f$ i \f$ -th unique pair of basis functions in a lower
!>                      triangularly stored matrix belongs
!> @param[out] iCenTriT Just like \p iCenTri, but in square shape
!> @param[out] nMlt     Highest multipole in MME
!> @param[out] outxyz   Expansion centers in molecule
!> @param[in]  lSlater
!***********************************************************************

subroutine MultiNew(nAt,nBas,nOcc,natyp,nntyp,MME,iCenTri,iCenTriT,nMlt,outxyz,lSlater)

use qmstat_global, only: MxMltp
use Index_Functions, only: nTri3_Elem, nTri_Elem
use Data_Structures, only: Alloc1DArray_Type, Allocate_DT, Deallocate_DT
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAt, nBas, nntyp, nOcc(nntyp), natyp(nntyp)
type(Alloc1DArray_Type), intent(out) :: MME(nTri3_Elem(MxMltp))
integer(kind=iwp), intent(out) :: iCenTri(nTri_Elem(nBas)), iCenTriT(nBas,nBas), nMlt
real(kind=wp), intent(out) :: outxyz(3,nTri_Elem(nAt))
logical(kind=iwp), intent(in) :: lSlater
integer(kind=iwp) :: i, iAt, iB1, iB2, iComp, iDum(1), iMlt, Ind, Indie, IndiePrev, iOpt, irc, iSmLbl, j, kaunt, kaunter, LMltSlq, &
                     Lu_One, nB1Prev, nB2Prev, nBasA, nComp, nMul, nSize
real(kind=wp) :: CordMul(MxMltp,3), Corr, CorrDip1, CorrDip2, CorrOvl
logical(kind=iwp) :: Changed1, Changed2, Lika
character(len=20) :: MemLab
character(len=2) :: ChCo, ChCo2
integer(kind=iwp), allocatable :: nBasAt(:)
real(kind=wp), allocatable :: xyz(:,:,:)
type(Alloc1DArray_Type), allocatable :: Mult(:,:)
integer(kind=iwp), parameter :: iX(6) = [1,1,1,2,2,3], iY(6) = [1,2,3,2,3,3]
character(len=9), parameter :: Integrals(3) = ['MLTPL  0','MLTPL  1','MLTPL  2']
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"
!Jose.No Nuclear charges in Slater

!----------------------------------------------------------------------*
! Read the multipole integrals in contracted AO-basis.                 *
!----------------------------------------------------------------------*
irc = -1
Lu_One = IsFreeUnit(49)
call OpnOne(irc,0,'ONEINT',Lu_One)
if (irc /= 0) then
  write(u6,*)
  write(u6,*) 'ERROR! Could not open one-electron integral file.'
  call Quit(_RC_IO_ERROR_READ_)
end if

call Allocate_DT(Mult,[1,MxMltp],[1,nTri_Elem(MxMltp)],label='Mult')

! This loop will terminate when no more multipole integrals are
! available, hence there is not a problem that we apparently loop
! over MxMltpl, which is a fixed number.

outer: do iMlt=1,MxMltp
  nComp = nTri_Elem(iMlt)
  do iComp=1,nComp
    irc = -1
    iOpt = 1
    iSmLbl = 1
    call iRdOne(irc,iOpt,integrals(iMlt),iComp,iDum,iSmLbl)
    if (irc == 0) nSize = iDum(1)
    if (irc /= 0) then
      if (iComp /= 1) then
        write(u6,*)
        write(u6,*) 'ERROR! Failed to read number of one-electron integrals.'
        call Quit(_RC_IO_ERROR_READ_)
      else  !Normal exit here.
        nMlt = iMlt-1
        exit outer
      end if
    end if
    if (nSize /= 0) then
      write(ChCo,'(I2.2)') iMlt
      write(ChCo2,'(I2.2)') iComp
      write(MemLab,*) 'MEM'//ChCo//ChCo2
      call mma_allocate(Mult(iMlt,iComp)%A,nSize+4,label=MemLab)
      irc = -1
      iOpt = 0
      iSmLbl = 0
      call RdOne(irc,iOpt,integrals(iMlt),iComp,Mult(iMlt,iComp)%A,iSmLbl) !Collect integrals
    else
      write(u6,*)
      write(u6,*) 'ERROR! Problem reading ',integrals(iMlt)
      call Quit(_RC_IO_ERROR_READ_)
    end if
  end do
  CordMul(iMlt,:) = Mult(iMlt,1)%A(nSize+1:3)
  nMlt = MxMltp
end do outer

!----------------------------------------------------------------------*
! Collect centers from preceeding MpProp calculation. Compute two      *
! index vectors. First one gives index of atom on which the ith basis  *
! function is centered. The other (iCenTri) gives to which center the  *
! ith unique basis function product belong.                            *
!----------------------------------------------------------------------*
call mma_allocate(xyz,3,nAt,nAt,label='xyz')
call Get_Centers(nAt,xyz)
do i=1,nAt
  outxyz(:,i) = xyz(:,i,i)
end do
kaunt = nAt
do i=1,nAt
  do j=1,i-1
    kaunt = kaunt+1
    outxyz(:,kaunt) = xyz(:,i,j)
  end do
end do
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
!Jose. Collect data of the Slater representation of the Quantum System *
! Prefactors, Exponents, PointNuclearCharges.                          *
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
if (lSlater) then
  call Get_Slater(LMltSlQ,outxyz,nAt)

  if (LMltSlQ+1 /= nMlt) then
    write(u6,*) 'ERROR! Multipole order',LMltSlQ,' in DiffPr file is different from order',nMlt-1, &
                ' in One-electron file. Check your files.'
    call Quit(_RC_GENERAL_ERROR_)
  end if
end if

call mma_allocate(nBasAt,nBas,label='nBasAt')

kaunter = 0
iAt = 0
do i=1,nntyp
  nBasA = nOcc(i)/natyp(i)
  do j=1,natyp(i)
    iAt = iAt+1
    nBasAt(kaunter+1:kaunter+nBasA) = iAt
    kaunter = kaunter+nBasA
  end do
end do

kaunter = 0
Indie = nAt
IndiePrev = 1
nB1Prev = 1
nB2Prev = 1
do iB1=1,nBas !Count over unique pairs of bas.func.
  do iB2=1,iB1
    kaunter = kaunter+1
    Lika = nBasAt(iB1) == nBasAt(iB2)
    if (Lika) then !If equal indices, then take that number.
      iCenTri(kaunter) = nBasAt(iB1)
      nB1Prev = nBasAt(iB1)
      nB2Prev = nBasAt(iB2)
    else
      Changed1 = nB1Prev /= nBasAt(iB1) !Check if changed atom.
      Changed2 = nB2Prev /= nBasAt(iB2)
      if (Changed1 .and. (.not. Changed2)) then !Case when from center 1 to nAt+1.
        Indie = Indie+1
        nB1Prev = nBasAt(iB1)
        IndiePrev = Indie
      else if (Changed2 .and. (.not. Changed1)) then
        ! Moving to new atom horizontally in lower triangular
        ! matrix. If it is a jump back to left corner,
        ! do not increase index, but get old one.
        if (iB2 == 1) then
          Indie = IndiePrev
        else
          Indie = Indie+1
        end if
        nB2Prev = nBasAt(iB2)
      else if (Changed1 .and. Changed2) then !Changing both atoms.
        Indie = Indie+1
        nB1Prev = nBasAt(iB1)
        nB2Prev = nBasAt(iB2)
        IndiePrev = Indie
      end if
      iCenTri(kaunter) = Indie
    end if
  end do
end do
Ind = 0
do i=1,nBas !Let's be square.
  do j=1,i
    Ind = Ind+1
    iCenTriT(i,j) = iCenTri(ind)
    iCenTriT(j,i) = iCenTri(ind)
  end do
end do

!----------------------------------------------------------------------*
! Start the MME. To get a MME-dipole, we want <psi_i|x-x_o|psi_j> but  *
! we have <psi_i|x-x_M|psi_j> where x_o is the chosen MME-center, while*
! x_M is the center that Molcas uses. We transform in this manner:     *
! <psi_i|x-x_o|psi_j> = <psi_i|x-x_M|psi_j>+(x_M-x_o)*<psi_i|psi_j>.   *
! The quadrupole contains a further complication: not only must we     *
! include more terms, but the dipole correction may not be the MME-    *
! dipole due to that Molcas may not have used the same center for      *
! dipoles and quadrupoles. Let have a look:                            *
! <psi_i|(x-x_o)(y-y_o)|psi_j>=                                        *
! <psi_i|(x-x_M)(y-y_M)|psi_j>+(x_M-x_o)*<psi_i|y-y_M|psi_j>+...       *
! But the last dipole term may need to be transformed further if y_M   *
! for the quadrupoles are not the same as y_M for the dipoles. This is *
! the explanation for the somewhat "sliskiga" expression below for the *
! quadrupoles.                                                         *
!----------------------------------------------------------------------*
if (nMlt > 3) then !This number is connected to for how high order of multipole we have implemented below.
  write(u6,*)
  write(u6,*) 'Too high order of multipole in MME.'
  call Quit(_RC_INTERNAL_ERROR_)
end if
nMul = 0
do i=1,nMlt
  nMul = nMul+nTri_Elem(i)
end do
do iMlt=1,nMul
  write(ChCo,'(I2.2)') iMlt
  call mma_allocate(MME(iMlt)%A,nSize,label='MME'//ChCo)
end do

! The MME.

kaunt = 0
do iB1=1,nBas
  do iB2=1,iB1
    kaunt = kaunt+1

    ! The charge. No translation.

    MME(1)%A(kaunt) = Mult(1,1)%A(kaunt)

    ! The dipole. Translation gives rise to charge.

    do i=1,3
      Corr = (CordMul(2,i)-xyz(i,nBasAt(iB1),nBasAt(iB2)))*Mult(1,1)%A(kaunt)
      MME(i+1)%A(kaunt) = Mult(2,i)%A(kaunt)+Corr
    end do

    ! The quadrupole. Translation gives rise to dipoles and charges.
    ! Also we have to keep track of the centers for the integrals computed
    ! by Seward.

    do i=1,6
      CorrDip1 = (CordMul(3,iX(i))-xyz(iX(i),nBasAt(iB1),nBasAt(iB2)))* &
                 (Mult(2,iY(i))%A(kaunt)+(CordMul(2,iY(i))-CordMul(3,iY(i)))*Mult(1,1)%A(kaunt))
      CorrDip2 = (CordMul(3,iY(i))-xyz(iY(i),nBasAt(iB1),nBasAt(iB2)))* &
                 (Mult(2,iX(i))%A(kaunt)+(CordMul(2,iX(i))-CordMul(3,iX(i)))*Mult(1,1)%A(kaunt))
      CorrOvl = (CordMul(3,iX(i))-xyz(iX(i),nBasAt(iB1),nBasAt(iB2)))* &
                (CordMul(3,iY(i))-xyz(iY(i),nBasAt(iB1),nBasAt(iB2)))*Mult(1,1)%A(kaunt)
      MME(i+4)%A(kaunt) = Mult(3,i)%A(kaunt)+CorrDip1+CorrDip2+CorrOvl
    end do
  end do
end do

! Deallocations.

call mma_deallocate(nBasAt)
call mma_deallocate(xyz)
call Deallocate_DT(Mult)

call ClsOne(irc,Lu_One)

return

end subroutine MultiNew

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_X_GetTotV(nV,n)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: return total number of vectors (over all nodes).
C
      Implicit None
      Integer n
      Integer nV(n)
#include "cholesky.fh"
#include "chopar.fh"
#include "cho_para_info.fh"

      Integer iSym

#if defined (_DEBUGPRINT_)
      If (n .lt. nSym) Then
         Call Cho_Quit('Illegal input variable in Cho_X_GetTotV',104)
      End If
#endif

      If (Cho_Real_Par) Then
         Do iSym = 1,nSym
            nV(iSym)=NumCho_Bak(iSym)
         End Do
      Else
         Do iSym = 1,nSym
            nV(iSym)=NumCho(iSym)
         End Do
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FRMDSC_MCLR(ARRAY,NDIM,MBLOCK,IFILE,IMZERO)
! TRANSFER ARRAY FROM DISC FILE IFILE

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDIM, MBLOCK, IFILE
real(kind=wp), intent(out) :: ARRAY(NDIM)
integer(kind=iwp), intent(out) :: IMZERO
integer(kind=iwp) :: I, IBASE, IDUM(1), IREST, NBLOCK
integer(kind=iwp), parameter :: IPACK = 1, ICRAY = 1

if (IPACK /= 0) then
  ! Read if ARRAY is zero
  call IFRMDS(IDUM,1,MBLOCK,IFILE)
  IMZERO = IDUM(1)
  if (IMZERO == 1) then
    ARRAY(:) = Zero
    return
  end if
end if

if ((MBLOCK >= 0) .or. (ICRAY == 1)) then
  NBLOCK = MBLOCK
  if (MBLOCK <= 0) NBLOCK = NDIM
  IREST = NDIM
  IBASE = 0
  do while (IREST > 0)
    if (IREST > NBLOCK) then
      read(IFILE) (ARRAY(IBASE+I),I=1,NBLOCK)
      IBASE = IBASE+NBLOCK
      IREST = IREST-NBLOCK
    else
      read(IFILE) (ARRAY(IBASE+I),I=1,IREST)
      IREST = 0
    end if
  end do
end if

if ((MBLOCK < 0) .and. (NDIM > 0) .and. (ICRAY == 0)) then
  !call SQFILE(IFILE,2,ARRAY,2*NDIM)
  call SysHalt('frmdsc')
end if

return

end subroutine FRMDSC_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA_PrInp()

! Thomas Bondo Pedersen (CTCC,UiO), July 2013.
!
! Print RPA configuration after input processing.

use RPA_globals, only: CMO, DFTFunctional, EMO, iPrint, nBas, nDel, nFro, nOcc, nOrb, nSym, nTitle, nVir, OccEn, Reference, Title, &
                       VirEn
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp) :: iUHF, lLine, nLine, l_orbitals, i, j, k, left, iSym, nB, l_Name, iCount
real(kind=wp) :: Dummy(1)
character(len=3) :: lIrrep(8)
character(len=7) :: spin(2)
character(len=8) :: Fmt1, Fmt2
character(len=13) :: orbitals
character(len=120) :: Line, BlLine, StLine
character(len=LenIn8), allocatable :: UBName(:)
integer(kind=iwp), parameter :: lPaper = 132
character(len=*), parameter :: SecNam = 'RPA_PrInp'
integer(kind=iwp), external :: RPA_iUHF

! set restricted(1)/unrestricted(2)
iUHF = RPA_iUHF()

! set labels
if (iUHF == 1) then
  orbitals = 'orbitals'
  l_orbitals = 8
  spin(1) = ' '
  spin(2) = ' '
else if (iUHF == 2) then
  orbitals = 'spin-orbitals'
  l_orbitals = 13
  spin(1) = '(alpha)'
  spin(2) = '(beta)'
else
  write(u6,'(A,I6)') 'iUHF=',iUHF
  call RPA_Warn(3,SecNam//': iUHF error')
  orbitals = ' '
  l_orbitals = 1
  spin(1) = ' '
  spin(2) = ' '
end if

! set irrep names
call Get_cArray('Irreps',lIrrep,24)
do iSym=1,nSym
  lIrrep(iSym) = adjustr(lIrrep(iSym))
end do

! init blank line and "star" line
lLine = len(Line)
do i=1,lLine
  BlLine(i:i) = ' '
  StLine(i:i) = '*'
end do
left = (lPaper-lLine)/2
write(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'

! print title from input
if (nTitle > 0) then
  write(u6,*)
  nLine = nTitle+5
  do i=1,nLine
    Line = BlLine
    if ((i == 1) .or. (i == nLine)) Line = StLine
    if (i == 3) Line = 'Title:'
    if ((i >= 4) .and. (i <= nLine-2)) Line = Title(i-3)
    call Center_Text(Line)
    write(u6,Fmt1) '*'//Line//'*'
  end do
  write(u6,*)
end if

! print coordinates of the molecule
if (iPrint >= 2) then
  call PrCoor()
end if

! print orbital info
if (iPrint >= 2) then
  write(u6,*)
  write(u6,Fmt2//'A,2(1X,A))') Reference,'reference',orbitals
  j = len(Reference)+11+l_orbitals
  write(u6,Fmt2//'80A1)')('-',i=1,j)
  if (Reference(2:3) == 'KS') then
    write(u6,Fmt2//'A,A)') 'DFT functional: ',DFTFunctional
  end if
  write(u6,*)
  write(u6,Fmt2//'A,T47,8I4)') 'Symmetry species',(iSym,iSym=1,nSym)
  write(u6,Fmt2//'A,T47,8(1X,A))') '                ',(lIrrep(iSym),iSym=1,nSym)
  write(u6,Fmt2//'A,T47,8I4)') 'Number of basis functions',(nBas(iSym),iSym=1,nSym)
  write(u6,Fmt2//'A,T47,8I4)') 'Number of orbitals',(nOrb(iSym),iSym=1,nSym)
  do k=1,iUHF
    write(u6,Fmt2//'A,2(1X,A),T47,8I4)') 'Frozen occupied',orbitals,spin(k),(nFro(iSym,k),iSym=1,nSym)
  end do
  do k=1,iUHF
    write(u6,Fmt2//'A,2(1X,A),T47,8I4)') 'Active occupied',orbitals,spin(k),(nOcc(iSym,k),iSym=1,nSym)
  end do
  do k=1,iUHF
    write(u6,Fmt2//'A,2(1X,A),T47,8I4)') 'Active virtual',orbitals,spin(k),(nVir(iSym,k),iSym=1,nSym)
  end do
  do k=1,iUHF
    write(u6,Fmt2//'A,2(1X,A),T47,8I4)') 'Deleted virtual',orbitals,spin(k),(nDel(iSym,k),iSym=1,nSym)
  end do
end if

! print orbital energies
if (iPrint >= 2) then
  iCount = 0
  do k=1,iUHF
    do iSym=1,nSym
      iCount = iCount+nFro(iSym,k)
    end do
  end do
  if (iCount > 0) then
    write(u6,*)
    write(u6,*)
    write(u6,Fmt2//'A,1X,A,T47)') 'Energies of the frozen occupied',orbitals
    do k=1,iUHF
      i = 0
      do iSym=1,nSym
        if (nFro(iSym,k) > 0) then
          write(u6,*)
          write(u6,Fmt2//'A,I2,2(1X,A),(T40,5F14.6))') 'symmetry species',iSym,lIrrep(iSym),spin(k),(OccEn(i+j,k),j=1,nFro(iSym,k))
          i = i+nFro(iSym,k)+nOcc(iSym,k)
        end if
      end do
    end do
  end if
  write(u6,*)
  write(u6,*)
  write(u6,Fmt2//'A,1X,A,T47)') 'Energies of the active occupied',orbitals
  do k=1,iUHF
    i = 0
    do iSym=1,nSym
      if (nOcc(iSym,k) > 0) then
        write(u6,*)
        write(u6,Fmt2//'A,I2,2(1X,A),(T40,5F14.6))') &
          'symmetry species',iSym,lIrrep(iSym),spin(k),(OccEn(i+nFro(iSym,k)+j,k),j=1,nOcc(iSym,k))
        i = i+nFro(iSym,k)+nOcc(iSym,k)
      end if
    end do
  end do
  write(u6,*)
  write(u6,*)
  write(u6,Fmt2//'A,1X,A,T47)') 'Energies of the active virtual',orbitals
  do k=1,iUHF
    i = 0
    do iSym=1,nSym
      if (nVir(iSym,k) > 0) then
        write(u6,*)
        write(u6,Fmt2//'A,I2,2(1X,A),(T40,5F14.6))') 'symmetry species',iSym,lIrrep(iSym),spin(k),(VirEn(i+j,k),j=1,nVir(iSym,k))
        i = i+nVir(iSym,k)+nDel(iSym,k)
      end if
    end do
  end do
  iCount = 0
  do k=1,iUHF
    do iSym=1,nSym
      iCount = iCount+nDel(iSym,k)
    end do
  end do
  if (iCount > 0) then
    write(u6,*)
    write(u6,*)
    write(u6,Fmt2//'A,1X,A,T47)') 'Energies of the deleted virtual',orbitals
    do k=1,iUHF
      i = 0
      do iSym=1,nSym
        if (nDel(iSym,k) > 0) then
          write(u6,*)
          write(u6,Fmt2//'A,I2,2(1X,A),(T40,5F14.6))') &
            'symmetry species',iSym,lIrrep(iSym),spin(k),(VirEn(i+nVir(iSym,k)+j,k),j=1,nDel(iSym,k))
          i = i+nVir(iSym,k)+nDel(iSym,k)
        end if
      end do
    end do
  end if
end if

! print orbitals
if (iPrint >= 2) then
  nB = nBas(1)
  do iSym=2,nSym
    nB = nB+nBas(iSym)
  end do
  l_Name = nB
  call mma_allocate(UBName,l_Name,label='Name')
  call Get_cArray('Unique Basis Names',UBName,LenIn8*nB)
  do k=1,iUHF
    call PriMO(Reference//' '//orbitals//' '//spin(k),.false.,.true.,-9.9e9_wp,9.9e9_wp,nSym,nBas,nOrb,UBName,EMO(:,k),Dummy, &
               CMO(:,k),-1)
  end do
  call mma_deallocate(UBName)
end if

! flush output buffer
call xFlush(u6)

end subroutine RPA_PrInp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Roland Lindh                                     *
!***********************************************************************

#include "compiler_features.h"
#ifdef _EFP_

function Molcas_ELECTRON_DENSITY_FIELD_FN(n_pt,xyz,field,user_field)
!***********************************************************************
!                                                                      *
!     This is a callback routine for the computation of the electric   *
!     field (variable field), at a set of points in space (n_pt of     *
!     them, coordinates stored in the variable xyz).                   *
!                                                                      *
!***********************************************************************

use, intrinsic :: iso_c_binding, only: c_int, c_size_t, c_double, c_ptr
use EFP, only: EFP_RESULT_SUCCESS
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(c_int) :: Molcas_ELECTRON_DENSITY_FIELD_FN
integer(c_size_t), intent(in) :: n_pt
real(c_double), intent(in) :: xyz(3,n_pt)
real(c_double), intent(out) :: field(3,n_pt)
type(c_ptr), intent(in) :: user_field
integer(kind=iwp) :: nDens
integer(c_size_t) :: nCmp, nOrdOp
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: D1ao(:)

#include "macros.fh"
unused_var(user_field)

! Pick up the one-particle density matrix.

call Qpg_dArray('D1ao',Found,nDens)
if (Found .and. (nDens /= 0)) then
  call mma_allocate(D1ao,nDens)
  call Get_dArray_chk('D1ao',D1ao,nDens)
else
  write(u6,*) 'D1ao not found!'
  call abend()
end if

! Compute the electric field at the points xyz

nCmp = 3
nOrdOp = 1
call Drv1_Pot(D1ao,xyz,field,n_pt,ncmp,nordop)

call mma_deallocate(D1ao)

Molcas_ELECTRON_DENSITY_FIELD_FN = EFP_RESULT_SUCCESS

end function Molcas_ELECTRON_DENSITY_FIELD_FN

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(Molcas_ELECTRON_DENSITY_FIELD_FN)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Drvh1_EMB(Grad,Temp,nGrad)
      Use Basis_Info, only: dbsc, nCnttp, nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External OvrGrd, KneGrd, NAGrd, PrjGrd, M1Grd, M2Grd, SROGrd,
     &         WelGrd, XFdGrd, RFGrd, PCMGrd, PPGrd, COSGrd, FragPGrd
      External OvrMmG, KneMmG, NAMmG, PrjMmG, M1MmG, M2MmG, SROMmG,
     &         WelMmg, XFdMmg, RFMmg, PCMMmg, PPMmG, FragPMmG
#include "Molcas.fh"
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "disp.fh"
#include "wldata.fh"
#include "rctfld.fh"
      Integer, Allocatable:: lOper(:)
      Real*8, Allocatable:: Coor(:,:), D_Var(:)

      Character Label*80
      Real*8 Grad(nGrad), Temp(nGrad)
CAOM<
      parameter (lforce=20)
      real*8 force(lforce)
      common /finfld/force
      External MltGrd,MltMmG
CAOM>
      Logical DiffOp, lECP, lPP, lFAIEMP
      Character*16 NamRfil
*
*-----Statement function
*
      nElem(i) = (i+1)*(i+2)/2
*
*...  Prologue
      iRout = 131
      iPrint = nPrint(iRout)
      Call CWTime(TCpu1,TWall1)
      Call StatusLine(' Alaska:',' Computing 1-el OFE gradients')
*
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
*
      lECP=.False.
      lPP =.False.
      lFAIEMP=.False.
      Do i = 1, nCnttp
         lECP = lECP .or. dbsc(i)%ECP
         lPP  = lPP  .or. dbsc(i)%nPP.ne.0
         lFAIEMP = LFAIEMP .or. dbsc(i)%Frag
      End Do
*
*---- Allocate memory for density matrices
*
      nDens = 0
      Do iIrrep = 0, nIrrep - 1
         nDens = nDens + nBas(iIrrep)*(nBas(iIrrep)+1)/2
      End Do
*
*...  Read the variational 1st order density matrix
*...  density matrix in AO/SO basis

      Call Get_NameRun(NamRfil) ! save the old RUNFILE name
      Call NameRun('AUXRFIL')   ! switch RUNFILE name

      Call mma_allocate(D_Var,nDens,Label='D_Var')
      Call Get_D1ao_Var(D_var,nDens)
      If (iPrint.ge.99) then
         Write(6,*) 'variational 1st order density matrix'
         ii=1
         Do iIrrep = 0, nIrrep - 1
            Write(6,*) 'symmetry block',iIrrep
            Call TriPrt(' ',' ',D_Var(ii),nBas(iIrrep))
            ii = ii + nBas(iIrrep)*(nBas(iIrrep)+1)/2
         End Do
      End If
*
* Annihilate all the components of rho_B in the bsfs of the A subsystem
*
*SVC: fixed according to instructions from Francesco,
* as embedding should not deal with symmetry
      Call Annihil_rho(D_var,nBas(0))
*
      Call NameRun(NamRfil)   ! switch RUNFILE name
*                                                                      *
************************************************************************
*                                                                      *
*     nOrdOp: order/rank of the operator
*     lOper(:): lOper of each component of the operator
*
      nOrdOp=0
      nComp = nElem(nOrdOp)
      Call mma_allocate(Coor,3,nComp)
      Call mma_allocate(lOper,nComp,Label='lOper')
      Coor(:,:)=Zero
      lOper(:) = 1
*
************************************************************************
*3)                                                                    *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the nuclear attraction integrals.                    *
*                                                                      *
************************************************************************
*
      DiffOp = .True.
      Label = ' The Nuclear Attraction Contribution'
      Call OneEl_g(NAGrd,NAMmG,Temp,nGrad,DiffOp,Coor,
     &             D_Var,nDens,lOper,nComp,nOrdOp,Label)

      Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
************************************************************************
*4)                                                                    *
*     Trace the "variational" first order density matrix with the      *
*     gradient of the ECP integrals.                                   *
*                                                                      *
************************************************************************
*
      If (lECP) Then
         DiffOp = .True.
         Label = ' The Projection Operator contribution'
         Call OneEl_g(PrjGrd,PrjMmG,Temp,nGrad,DiffOp,Coor,
     &                D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
         Label = ' The M1 Operator contribution'
         Call OneEl_g( M1Grd, M1MmG,Temp,nGrad,DiffOp,Coor,
     &                D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
         Label = ' The M2 Operator contribution'
         Call OneEl_g( M2Grd, M2MmG,Temp,nGrad,DiffOp,Coor,
     &                D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
*
         Label = ' The SR Operator contribution'
         Call OneEl_g(SROGrd,SROMmG,Temp,nGrad,DiffOp,Coor,
     &                D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
      End If
      If (lPP) Then
         Label = ' The Pseudo Potential contribution'
         Call OneEl_g(PPGrd,PPMmG,Temp,nGrad,DiffOp,Coor,
     &                 D_Var,nDens,lOper,nComp,nOrdOp,Label)
         Call DaXpY_(nGrad,One,Temp,1,Grad,1)
      End If
*                                                                      *
************************************************************************
*
      If(lFAIEMP) Then
        DiffOp = .True.
        Label = ' The FAIEMP Projection Operator Contribution'
        Call OneEl_g(FragPGrd,FragPMmG,Temp,nGrad,DiffOp,Coor,
     &               D_Var,nDens,lOper,nComp,nOrdOp,Label)
        Call DaXpY_(nGrad,One,Temp,1,Grad,1)
        Call DrvG_FAIEMP(Grad,Temp,nGrad)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(lOper)
      Call mma_deallocate(Coor)
*                                                                      *
************************************************************************
*                                                                      *
*...  Epilogue, end
*
      Call mma_deallocate(D_Var)
*
      Call Free_iSD()
      Call CWTime(TCpu2,TWall2)
      Call SavTim(3,TCpu2-TCpu1,TWall2-TWall1)
      Return
      End
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Subroutine Annihil_rho(Dmat,nBas)

      Implicit Real*8 (a-h,o-z)
#include "itmax.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
      Real*8 Dmat(*)
      Integer nBas
      Character*(LENIN4) Name(mxBas)
      Integer, Allocatable:: nBas_per_Atom(:), nBas_Start(:)
      Real*8, Allocatable:: Charge_B(:)
*
************************************************************************
*
      Call Get_iScalar('Unique atoms',nAtoms)

      If (nAtoms.lt.1) Then
         Write(6,'(A,I9)') 'nUniqAt =',nAtoms
         Call Abend()
      End If
*
      Call mma_allocate(nBas_per_Atom,nAtoms,Label='nBpA')
      Call mma_allocate(nBas_Start,nAtoms,Label='nB_Start')

      Call Get_cArray('Unique Basis Names',Name,(LENIN8)*nBas)

      Call BasFun_Atom(nBas_per_Atom,nBas_Start,
     &                 Name,nBas,nAtoms,.false.)
*
      Call mma_allocate(Charge_B,nAtoms,Label='Charge_B')
      Call Get_dArray('Nuclear charge',Charge_B,nAtoms)
*
      ZA=0.0d0
      iAt=1
      Do while (iAt.le.nAtoms .and. ZA.eq.0.0d0)
         ZA = Charge_B(iAt)
         iAt = iAt + 1
      End Do
      iAt_B=iAt-1  ! start of atoms of subsystem B
      Call mma_deallocate(Charge_B)
*
      If (iAt_B.eq.1) Then ! subsystem B comes first
         ZB=1.0d0
         nAt_B=1
         Do while (nAt_B.le.nAtoms .and. ZB.gt.0.0d0)
            ZB = Charge_B(nAt_B)
            nAt_B = nAt_B + 1
         End Do
         nAt_B=nAt_B-1  ! end of atoms of subsystem B
         nBas_B = nBas_Start(nAt_B) - 1
         Do j=nBas_B,nBas-1
            jj=j*(j+1)/2
            Do i=1,j
               ijj=i+jj
               Dmat(ijj)=0.0d0
            End Do
         End Do
      Else
         nBas_A = nBas_Start(iAt_B) - 1
         nAA=nBas_A*(nBas_A+1)/2
         Call FZero(Dmat,nAA)
         Do j=nBas_A,nBas-1
            jj=j*(j+1)/2
            Do i=1,nBas_A
               ijj=i+jj
               Dmat(ijj)=0.0d0
            End Do
         End Do
      EndIf
*
      Call mma_deallocate(nBas_Start)
      Call mma_deallocate(nBas_per_Atom)
*
*  Annihilated density written to runfile for use in Coulomb gradients
*
      Length=nBas*(nBas+1)/2
      Call Put_D1ao_Var(Dmat,Length)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SIMPLIFY(FRAC)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: FRAC(2)
integer(kind=iwp) :: A, B, ITEMP

if (FRAC(1) == 0) return
! Find GCD of numerator and denominator
A = FRAC(1)
B = FRAC(2)
do while (B /= 0)
  ITEMP = B
  B = mod(A,B)
  A = ITEMP
end do
FRAC(1) = FRAC(1)/A
FRAC(2) = FRAC(2)/A

end subroutine SIMPLIFY

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_VerifyFit_Drv(irc)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: check fit by verifying that fitting equations are
C              are fulfilled for each atom pair.
C
      Implicit None
      Integer irc
#include "WrkSpc.fh"
#include "localdf.fh"
#include "ldf_atom_pair_info.fh"

      Character*17 SecNam
      Parameter (SecNam='LDF_VerifyFit_Drv')

      Real*8 RMSTol
      Parameter (RMSTol=1.0d-10)

      Logical  LDF_ConstraintInfoIsSet
      External LDF_ConstraintInfoIsSet

      Integer  iPrintLevel, LDF_nBas_Atom, LDF_nBasAux_Pair_wLD
      Integer  LDF_nBasAux_Pair
      External iPrintLevel, LDF_nBas_Atom, LDF_nBasAux_Pair_wLD
      External LDF_nBasAux_Pair

      Logical LinDepRemoved
      Logical Silent
      Logical ConstraintInfoSetHere

      Integer AB
      Integer ip_C, l_C, l

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      If (NumberOfAtomPairs.lt.1) Then
         irc=0
         Return
      End If

      If (LDF_Constraint.lt.-1 .or. LDF_Constraint.gt.0) Then
         Call WarningMessage(2,SecNam//': unknown constraint')
         Write(6,'(A,I10)') 'Constraint=',LDF_Constraint
         Call LDF_Quit(1)
      End If

      If (LDF_ConstraintInfoIsSet(LDF_Constraint)) Then
         ConstraintInfoSetHere=.False.
      Else
         Call LDF_SetConstraint(LDF_Constraint)
         ConstraintInfoSetHere=.True.
      End If

      l_C=LDF_nBas_Atom(AP_Atoms(1,1))
     &   *LDF_nBas_Atom(AP_Atoms(2,1))
     &   *LDF_nBasAux_Pair_wLD(1)
      Do AB=2,NumberOfAtomPairs
         l_C=max(l_C,LDF_nBas_Atom(AP_Atoms(1,AB))
     &              *LDF_nBas_Atom(AP_Atoms(2,AB))
     &              *LDF_nBasAux_Pair_wLD(AB))
      End Do
      Call GetMem('VFC','Allo','Real',ip_C,l_C)

      LinDepRemoved=.False.
      Silent=iPrintLevel(-1).lt.3
      irc=0
      AB=0
      Do While (AB.lt.NumberOfAtomPairs .and. irc.eq.0)
         AB=AB+1
         If (LDF_Constraint.eq.0) Then ! get lambda and overlap
            l=LDF_nBas_Atom(AP_Atoms(1,AB))
     &       *LDF_nBas_Atom(AP_Atoms(2,AB))
     &       *LDF_nBasAux_Pair(AB)
            Call LDF_ReadUnconstrainedCoefficients(AB,l,Work(ip_C),irc)
            If (irc.eq.-1) Then
               Call WarningMessage(2,
     &         SecNam//': unconstrained coefficients not found on disk')
               Call LDF_Quit(1)
            Else If (irc.ne.0) Then
               Call WarningMessage(2,SecNam//
     &  ': non-zero return code from LDF_ReadUnconstrainedCoefficients')
               Write(6,'(A,I10)') 'irc=',irc
               Call LDF_Quit(1)
            End If
            Call LDF_AddChargeConstraintCorrection(AB,l,Work(ip_C))
         End If
         l=LDF_nBas_Atom(AP_Atoms(1,AB))
     &    *LDF_nBas_Atom(AP_Atoms(2,AB))
     &    *LDF_nBasAux_Pair_wLD(AB)
         Call LDF_CIO_ReadC_wLD(AB,Work(ip_C),l)
         Call LDF_VerifyFit(LinDepRemoved,Silent,LDF_Constraint,
     &                      RMSTol,AB,l,Work(ip_C),irc)
         If (irc.ne.0) Then
            Write(6,'(A,A,I10)')
     &      SecNam,': LDF_VerifyFit returned code',irc
            Write(6,'(A)')
     &      'Parameters passed to LDF_VerifyFit:'
            Write(6,'(3X,A,L1)')
     &      'LinDepRemoved=',LinDepRemoved
            Write(6,'(3X,A,L1)')
     &      'Silent=',Silent
            Write(6,'(3X,A,1P,D20.10)')
     &      'RMSTol=',RMSTol
            Write(6,'(3X,A,I10)')
     &      'AB=',AB
            Write(6,'(3X,A,I10)')
     &      'l=',l
         End If
      End Do

      Call GetMem('VFC','Free','Real',ip_C,l_C)

      If (ConstraintInfoSetHere) Then
         Call LDF_UnsetConstraint(LDF_Constraint)
      End If

      End
      Subroutine LDF_VerifyFit(LinDepRemoved,Silent,Constraint,
     &                         RMSTol,AB,l_C,C,irc)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: Check fit by verifying that fitting equations are
C              fulfilled for atom pair AB.
C
      Implicit None
      Logical LinDepRemoved
      Logical Silent
      Integer Constraint
      Real*8  RMSTol
      Integer AB
      Integer l_C
      Real*8  C(l_C)
      Integer irc

      If (LinDepRemoved) Then
         Call LDF_VerifyFit_1(Silent,Constraint,RMSTol,AB,l_C,C,irc)
      Else
         Call LDF_VerifyFit_2(Silent,Constraint,RMSTol,AB,l_C,C,irc)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_VerifyFit_1(Silent,Constraint,RMSTol,AB,l_C,C,irc)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: Check fit by verifying that fitting equations are
C              fulfilled for atom pair AB.
C              Linearly dependent functions removed from C.
C
      Implicit None
      Logical Silent
      Integer Constraint
      Real*8  RMSTol
      Integer AB
      Integer l_C
      Real*8  C(l_C)
      Integer irc
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_charge_constraint_info.fh"

      Character*15 SecNam
      Parameter (SecNam='LDF_VerifyFit_1')

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Real*8   dDot_, LDF_AtomicDistance, Cho_dSumElm
      external ddot_, LDF_AtomicDistance, Cho_dSumElm

      Character*4 Label1, Label2

      Integer n, M
      Integer ip_Int, l_Int
      Integer ip_G, l_G
      Integer ip_Stat, l_Stat
      Integer ip_JInt, l_JInt

      Real*8  NrmI, Nrm, RMS
      Real*8  SmI, Sm

      Integer i, j
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Set dimensions
      n=LDF_nBas_Atom(AP_Atoms(1,AB))*LDF_nBas_Atom(AP_Atoms(2,AB))
      M=LDF_nBasAux_Pair(AB)
      If (n.lt.1 .or. M.lt.1) Then
         irc=0
         Return
      End If
      If (l_C.lt.n*M) Then
         irc=-1
         Return
      End If

      ! Set index arrays for G matrix
      Call LDF_SetIndxG(AB)

      ! Allocate and compute 3-index integrals
      ! Add constraint term if needed
      l_Int=n*M
      Call GetMem('VFInt','Allo','Real',ip_Int,l_Int)
      Call LDF_ComputeIntegrals_uvJ(AB,l_Int,Work(ip_Int))
      If (Constraint.eq.0) Then ! charge constraint
         l_JInt=M
         Call GetMem('VFJInt','Allo','Real',ip_JInt,l_JInt)
         ! Get n(J)=\int J(r)dr for this pair with 1C LinDep removed
         ! and including 2C functions (copied from overlap)
         Call LDF_CC_GetRHS(AB,n,Work(ip_CC_Overlap),M,Work(ip_JInt))
         ! Add correction to integrals: (uv|J) + lambda(uv)*n(J)
         Call dGeR(n,M,1.0d0,Work(ip_CC_lambda),1,Work(ip_JInt),1,
     &             Work(ip_Int),n)
         Call GetMem('VFJInt','Free','Real',ip_JInt,l_JInt)
      Else If (Constraint.ne.-1) Then ! unknown constraint
         Call WarningMessage(2,SecNam//': unknown constraint')
         Write(6,'(A,I10)') 'Constraint=',Constraint
         Call LDF_Quit(1)
      End If
      NrmI=sqrt(dDot_(l_Int,Work(ip_Int),1,Work(ip_Int),1))
      SmI=Cho_dSumElm(Work(ip_Int),l_Int)

      ! Allocate and compute G matrix
      l_G=M**2
      Call GetMem('VFG','Allo','Real',ip_G,l_G)
      Call LDF_ComputeGMat(AB,M,Work(ip_G))

      ! Compute difference
      Call dGeMM_('N','N',n,M,M,
     &            -1.0d0,C,n,Work(ip_G),M,
     &            1.0d0,Work(ip_Int),n)

      ! Compute difference norm and evaluate irc
      Nrm=dDot_(l_Int,Work(ip_Int),1,Work(ip_Int),1)
      RMS=sqrt(Nrm/dble(l_Int))
      Nrm=sqrt(Nrm)
      If (RMS.gt.RMSTol) Then
         irc=1
      Else
         irc=0
      End If
      Sm=Cho_dSumElm(Work(ip_Int),l_Int)

      ! Compute and print statistics
      If (.not.Silent) Then
         Call LDF_SetAtomicLabels()
         Call LDF_GetAtomicLabel(AP_Atoms(1,AB),Label1)
         Call LDF_GetAtomicLabel(AP_Atoms(2,AB),Label2)
         l_Stat=7
         Call GetMem('VFStat','Allo','Real',ip_Stat,l_Stat)
         Call Statistics(Work(ip_Int),l_Int,Work(ip_Stat),1,2,3,4,5,6,7)
         Call Cho_Head(SecNam//': fit verification info','-',80,6)
         Write(6,'(2X,A,10X,I10,2X,A,2I10,2X,A,1X,A)')
     &   'Atom pair...........',AB,
     &   'Atoms...............',AP_Atoms(1,AB),AP_Atoms(2,AB),
     &   Label1,Label2
         Write(6,'(2X,A,10X,I10,2X,A,1P,D20.10)')
     &   'Auxiliary basis dim.',LDF_nBasAux_Pair(AB),
     &   'Atomic distance.....',LDF_AtomicDistance(AP_Atoms(1,AB),
     &                                             AP_Atoms(2,AB))
         Write(6,'(2X,A,I10,A,2X,A,10X,I10)')
     &   '1C LinDep...........',AP_1CLinDep(1,AB),'   (Excl.)',
     &   '2C Functions........',AP_2CFunctions(1,AB)
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Integral norm.......',NrmI,
     &   'Difference norm.....',Nrm
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Integral sum........',SmI,
     &   'Difference sum......',Sm
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Average.............',Work(ip_Stat),
     &   'Abs Average.........',Work(ip_Stat+1)
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Max Difference......',Work(ip_Stat+3),
     &   'Max Abs Difference..',Work(ip_Stat+4)
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Variance............',Work(ip_Stat+5),
     &   'Unbiased Variance...',Work(ip_Stat+6)
         Write(6,'(2X,A,1P,D20.10)')
     &   'RMS.................',RMS
         Call xFlush(6)
         Call GetMem('VFStat','Free','Real',ip_Stat,l_Stat)
         Call LDF_UnsetAtomicLabels()
      End If

      ! Deallocation
      Call GetMem('VFG','Free','Real',ip_G,l_G)
      Call GetMem('VFInt','Free','Real',ip_Int,l_Int)

      ! Unset index arrays for G matrix
      Call LDF_UnsetIndxG()

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_VerifyFit_2(Silent,Constraint,RMSTol,AB,l_C,C,irc)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: Check fit by verifying that fitting equations are
C              fulfilled for atom pair AB.
C              Linearly dependent functions included in C.
C
      Implicit None
      Logical Silent
      Integer Constraint
      Real*8  RMSTol
      Integer AB
      Integer l_C
      Real*8  C(l_C)
      Integer irc
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_charge_constraint_info.fh"

      Character*15 SecNam
      Parameter (SecNam='LDF_VerifyFit_2')

      Logical  LDF_IntegralPrescreeningInfoIsSet
      External LDF_IntegralPrescreeningInfoIsSet

      Integer  LDF_nBasAux_Pair
      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair_wLD, LDF_nBasAux_Atom
      External LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair_wLD, LDF_nBasAux_Atom

      Real*8   dDot_, LDF_AtomicDistance, Cho_dSumElm
      external ddot_, LDF_AtomicDistance, Cho_dSumElm

      Character*4 Label1, Label2

      Logical IPI_set_here

      Integer A, B
      Integer n, M, MA, MB, MAB
      Integer ip_Int, l_Int
      Integer ip_G, l_G
      Integer ip_Stat, l_Stat
      Integer ipI, ipJ, l
      Integer ip_2CInt, l_2CInt
      Integer nRow_Map, nCol_Map
      Integer ip_Map, l_Map
      Integer ip2, ipS
      Integer i2C

      Real*8  NrmI, Nrm, RMS
      Real*8  SmI, Sm

      Real*8 tau
      Parameter (tau=0.0d0)

      Integer i, j
      Integer Map
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      Map(i)=iWork(ip_Map-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)

      ! Set prescreening info (if not already done)
      If (.not.LDF_IntegralPrescreeningInfoIsSet()) Then
         Call LDF_SetIntegralPrescreeningInfo()
         IPI_set_here=.True.
      Else
         IPI_set_here=.False.
      End If

      ! Get atoms
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)

      ! Set and check dimensions
      n=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      M=LDF_nBasAux_Pair_wLD(AB)
      MA=LDF_nBasAux_Atom(A)
      MB=LDF_nBasAux_Atom(B)
      MAB=AP_2CFunctions(1,AB)
      If (n.lt.1 .or. M.lt.1) Then
         irc=0
         Return
      End If
      If (l_C.lt.n*M) Then
         irc=-1
         Return
      End If

      ! Allocate G matrix blocks
      l_G=max(MA,MB,MAB)*max(MA,MB,MAB)
      Call GetMem('VFG','Allo','Real',ip_G,l_G)

      ! Allocate 3-index integrals
      l_Int=n*M
      Call GetMem('VFInt','Allo','Real',ip_Int,l_Int)

      ! Compute 3-index integrals (u_A v_B | J_A;J_B;J_AB)
      l=n*MA
      ipI=ip_Int
      Call LDF_Compute3IndexIntegrals_1(AB,A,tau,l,Work(ipI))
      ipI=ipI+l
      If (B.ne.A) Then
         l=n*MB
         Call LDF_Compute3IndexIntegrals_1(AB,B,tau,l,Work(ipI))
         ipI=ipI+l
      End If
      If (MAB.gt.0) Then
         l=n*MAB
         Call LDF_Compute3IndexIntegrals_2(AB,AB,tau,l,Work(ipI))
      End If
      ! Add constraint term if needed
      If (Constraint.eq.0) Then ! charge constraint
         ! (uv|J) + lambda(uv)*n(J), n(J)=\int J(r)dr
         ipI=ip_Int
         ipJ=iWork(ip_CC_AuxIntVec-1+A)
         Call dGeR(n,MA,1.0d0,Work(ip_CC_lambda),1,Work(ipJ),1,
     &             Work(ipI),n)
         ipI=ipI+n*MA
         If (B.ne.A) Then
            ipJ=iWork(ip_CC_AuxIntVec-1+B)
            Call dGeR(n,MB,1.0d0,Work(ip_CC_lambda),1,Work(ipJ),1,
     &                Work(ipI),n)
            ipI=ipI+n*MB
         End If
         If (MAB.gt.0) Then
            l_2CInt=MAB
            Call GetMem('VF2CInt','Allo','Real',ip_2CInt,l_2CInt)
            nRow_Map=MAB
            nCol_Map=1
            l_Map=nRow_Map*nCol_Map
            Call GetMem('VFMap','Allo','Inte',ip_Map,l_Map)
            Call LDF_Map2CF(AB,nRow_Map,nCol_Map,iWork(ip_Map))
            ip2=ip_2CInt-1
            ipS=ip_CC_Overlap-1
            Do i2C=1,MAB
               Work(ip2+i2C)=Work(ipS+Map(i2C))
            End Do
            Call dGeR(n,MAB,1.0d0,Work(ip_CC_lambda),1,Work(ip_2CInt),1,
     &                Work(ipI),n)
            Call GetMem('VFMap','Free','Inte',ip_Map,l_Map)
            Call GetMem('VF2CInt','Free','Real',ip_2CInt,l_2CInt)
         End If
      Else If (Constraint.ne.-1) Then ! unknown constraint
         Call WarningMessage(2,SecNam//': unknown constraint')
         Write(6,'(A,I10)') 'Constraint=',Constraint
         Call LDF_Quit(1)
      End If
      NrmI=sqrt(dDot_(l_Int,Work(ip_Int),1,Work(ip_Int),1))
      SmI=Cho_dSumElm(Work(ip_Int),l_Int)

      ! Compute contributions from 2-index integrals (J_A|K_A)
      l=MA**2
      Call LDF_Compute2IndexIntegrals_11(A,A,tau,l,Work(ip_G))
      Call dGeMM_('N','N',n,MA,MA,
     &            -1.0d0,C,n,Work(ip_G),max(MA,1),
     &            1.0d0,Work(ip_Int),n)

      ! Compute contributions from 2-index integrals (J_A|K_B)
      ! and (J_B|K_B)
      If (B.ne.A) Then
         l=MA*MB
         Call LDF_Compute2IndexIntegrals_11(A,B,tau,l,Work(ip_G))
         Call dGeMM_('N','N',n,MB,MA,
     &               -1.0d0,C,n,Work(ip_G),max(MA,1),
     &               1.0d0,Work(ip_Int+n*MA),n)
         Call dGeMM_('N','T',n,MA,MB,
     &               -1.0d0,C(n*MA+1),n,Work(ip_G),max(MA,1),
     &               1.0d0,Work(ip_Int),n)
         l=MB**2
         Call LDF_Compute2IndexIntegrals_11(B,B,tau,l,Work(ip_G))
         Call dGeMM_('N','N',n,MB,MB,
     &               -1.0d0,C(n*MA+1),n,Work(ip_G),max(MB,1),
     &               1.0d0,Work(ip_Int+n*MA),n)
      End If

      ! Compute contributions from 2-index integrals (J_A|K_AB)
      ! and (J_B|K_AB) and (J_AB|K_AB)
      If (MAB.gt.0) Then
         l=MA*MAB
         Call LDF_Compute2IndexIntegrals_12(A,AB,tau,l,Work(ip_G))
         If (B.eq.A) Then
            Call dGeMM_('N','N',n,MAB,MA,
     &                  -1.0d0,C,n,Work(ip_G),max(MA,1),
     &                  1.0d0,Work(ip_Int+n*MA),n)
            Call dGeMM_('N','T',n,MA,MAB,
     &                  -1.0d0,C(n*MA+1),n,Work(ip_G),max(MA,1),
     &                  1.0d0,Work(ip_Int),n)
         Else
            Call dGeMM_('N','N',n,MAB,MA,
     &                  -1.0d0,C,n,Work(ip_G),max(MA,1),
     &                  1.0d0,Work(ip_Int+n*(MA+MB)),n)
            Call dGeMM_('N','T',n,MA,MAB,
     &                  -1.0d0,C(n*(MA+MB)+1),n,Work(ip_G),max(MA,1),
     &                  1.0d0,Work(ip_Int),n)
         End If
         If (B.ne.A) Then
            l=MB*MAB
            Call LDF_Compute2IndexIntegrals_12(B,AB,tau,l,Work(ip_G))
            Call dGeMM_('N','N',n,MAB,MB,
     &                  -1.0d0,C(n*MA+1),n,Work(ip_G),max(MB,1),
     &                  1.0d0,Work(ip_Int+n*(MA+MB)),n)
            Call dGeMM_('N','T',n,MB,MAB,
     &                  -1.0d0,C(n*(MA+MB)+1),n,Work(ip_G),max(MB,1),
     &                  1.0d0,Work(ip_Int+n*MA),n)
         End If
         l=MAB**2
         Call LDF_Compute2IndexIntegrals_22(AB,AB,tau,l,Work(ip_G))
         If (B.eq.A) Then
            Call dGeMM_('N','N',n,MAB,MAB,
     &                  -1.0d0,C(n*MA+1),n,Work(ip_G),MAB,
     &                  1.0d0,Work(ip_Int+n*MA),n)
         Else
            Call dGeMM_('N','N',n,MAB,MAB,
     &                  -1.0d0,C(n*(MA+MB)+1),n,Work(ip_G),MAB,
     &                  1.0d0,Work(ip_Int+n*(MA+MB)),n)
         End If
      End If

      ! Compute difference norm and evaluate irc
      Nrm=dDot_(l_Int,Work(ip_Int),1,Work(ip_Int),1)
      RMS=sqrt(Nrm/dble(l_Int))
      Nrm=sqrt(Nrm)
      If (RMS.gt.RMSTol) Then
         irc=1
      Else
         irc=0
      End If
      Sm=Cho_dSumElm(Work(ip_Int),l_Int)

      ! Compute and print statistics
      If (.not.Silent) Then
         Call LDF_SetAtomicLabels()
         Call LDF_GetAtomicLabel(AP_Atoms(1,AB),Label1)
         Call LDF_GetAtomicLabel(AP_Atoms(2,AB),Label2)
         l_Stat=7
         Call GetMem('VFStat','Allo','Real',ip_Stat,l_Stat)
         Call Statistics(Work(ip_Int),l_Int,Work(ip_Stat),1,2,3,4,5,6,7)
         Call Cho_Head(SecNam//': fit verification info','-',80,6)
         Write(6,'(2X,A,10X,I10,2X,A,2I10,2X,A,1X,A)')
     &   'Atom pair...........',AB,
     &   'Atoms...............',AP_Atoms(1,AB),AP_Atoms(2,AB),
     &   Label1,Label2
         Write(6,'(2X,A,10X,I10,2X,A,1P,D20.10)')
     &   'Auxiliary basis dim.',LDF_nBasAux_Pair(AB),
     &   'Atomic distance.....',LDF_AtomicDistance(AP_Atoms(1,AB),
     &                                             AP_Atoms(2,AB))
         Write(6,'(2X,A,I10,A,2X,A,10X,I10)')
     &   '1C LinDep...........',AP_1CLinDep(1,AB),'   (Incl.)',
     &   '2C Functions........',AP_2CFunctions(1,AB)
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Integral norm.......',NrmI,
     &   'Difference norm.....',Nrm
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Integral sum........',SmI,
     &   'Difference sum......',Sm
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Average.............',Work(ip_Stat),
     &   'Abs Average.........',Work(ip_Stat+1)
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Max Difference......',Work(ip_Stat+3),
     &   'Max Abs Difference..',Work(ip_Stat+4)
         Write(6,'(2X,A,1P,D20.10,2X,A,D20.10)')
     &   'Variance............',Work(ip_Stat+5),
     &   'Unbiased Variance...',Work(ip_Stat+6)
         Write(6,'(2X,A,1P,D20.10)')
     &   'RMS.................',RMS
         Call xFlush(6)
         Call GetMem('VFStat','Free','Real',ip_Stat,l_Stat)
         Call LDF_UnsetAtomicLabels()
      End If

      ! Deallocation
      Call GetMem('VFInt','Free','Real',ip_Int,l_Int)
      Call GetMem('VFG','Free','Real',ip_G,l_G)

      ! Unset integral prescreening info (if done here)
      If (IPI_set_here) Then
         Call LDF_UnsetIntegralPrescreeningInfo()
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_XCV_WrVec_Ser(irc,Vec,iSP)
!
! SERIAL VERSION
!     Simply write the partial vectors to disk at the appropriate
!     addresses on the vector files.

use Cholesky, only: iiBstRSh, LuCho, nnBstR, nnBstRSh, nSym, NumCho
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iSP
real(kind=wp), intent(_IN_) :: Vec(*)
integer(kind=iwp) :: iAdr, iAdr0, iSym, j, kV, lTot
integer(kind=iwp), parameter :: iOpt = 1

irc = 0

kV = 1
do iSym=1,nSym
  lTot = nnBstRSh(iSym,iSP,2)
  if (lTot > 0) then
    iAdr0 = iiBstRSh(iSym,iSP,2)
    do J=1,NumCho(iSym)
      iAdr = iAdr0+nnBstR(iSym,2)*(J-1)
      call DDAFile(LuCho(iSym),iOpt,Vec(kV),lTot,iAdr)
      kV = kV+lTot
    end do
  end if
end do

end subroutine Cho_XCV_WrVec_Ser

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

module NEVPT2_MOD

use Constants, only: Two, Four, Eight
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: nAshT

public :: derex2, derex3, dertG2, dertG3, ex2, ex3, nAshT, tG2, tG3

contains

function tG2(it,iu,iy,iz,G1,G2)

  real(kind=wp) :: tG2
  integer(kind=iwp), intent(in) :: it, iu, iy, iz
  real(kind=wp), intent(in) :: G1(NASHT,NASHT), G2(NASHT,NASHT,NASHT,NASHT)

  ! zero delta
  tG2 = G2(iy,it,iz,iu)
  ! one delta
  if (it == iy) tG2 = tG2-Two*G1(iz,iu)
  if (iu == iz) tG2 = tG2-Two*G1(iy,it)
  if (it == iz) tG2 = tG2+G1(iy,iu)
  if (iu == iy) tG2 = tG2+G1(iz,it)

  ! if (.not. diag) return

  !! two delta
  if ((it == iy) .and. (iu == iz)) tG2 = tG2+Four
  if ((it == iz) .and. (iu == iy)) tG2 = tG2-Two

end function tG2

! subroutine Add_MKBNEVB(ITABS_,IXABS_,IUABS_,IYABS_,IVABS_,IZABS_)
!function tG3(it,iu,iv,ix,iy,iz,G1,G2,G3)
function tG3(it,ix,iu,iy,iv,iz,G1,G2,G3)

  real(kind=wp) :: tG3
  integer(kind=iwp), intent(in) :: it, ix, iu, iy, iv, iz
  real(kind=wp), intent(in) :: G1(NASHT,NASHT), G2(NASHT,NASHT,NASHT,NASHT), G3

  ! \tilde{R}_{abc,def}^{(3)}
  !! zero delta
  tG3 = -G3 !! (iz,iy,ix,iv,iu,it)
  !! one delta
  ! if (it == ix) tG3 = tG3+Two*G2(iz,iy,iv,iu)
  ! if (iu == iy) tG3 = tG3+Two*G2(iz,ix,iv,it)
  ! if (iv == iz) tG3 = tG3+Two*G2(iy,ix,iu,it)
  if (it == ix) tG3 = tG3+Two*G2(iz,iv,iy,iu)
  if (iu == iy) tG3 = tG3+Two*G2(iz,iv,ix,it)
  if (iv == iz) tG3 = tG3+Two*G2(iy,iu,ix,it)

  ! if (it == iy) tG3 = tG3-G2(iz,ix,iv,iu)
  ! if (it == iz) tG3 = tG3-G2(ix,iy,iv,iu)
  ! if (iu == ix) tG3 = tG3-G2(iz,iy,iv,it)
  ! if (iu == iz) tG3 = tG3-G2(iy,ix,iv,it)
  ! if (iv == ix) tG3 = tG3-G2(iy,iz,iu,it)
  ! if (iv == iy) tG3 = tG3-G2(iz,ix,iu,it)
  if (it == iy) tG3 = tG3-G2(iz,iv,ix,iu)
  if (it == iz) tG3 = tG3-G2(ix,iv,iy,iu)
  if (iu == ix) tG3 = tG3-G2(iz,iv,iy,it)
  if (iu == iz) tG3 = tG3-G2(iy,iv,ix,it)
  if (iv == ix) tG3 = tG3-G2(iy,iu,iz,it)
  if (iv == iy) tG3 = tG3-G2(iz,iu,ix,it)

  !! two delta
  !  two same spin
  if ((it == ix) .and. (iu == iy)) tG3 = tG3-Four*G1(iz,iv)
  if ((it == ix) .and. (iv == iz)) tG3 = tG3-Four*G1(iy,iu)
  if ((iu == iy) .and. (iv == iz)) tG3 = tG3-Four*G1(ix,it)
  !  one same spin
  if ((it == ix) .and. (iu == iz)) tG3 = tG3+Two*G1(iy,iv)
  if ((it == ix) .and. (iv == iy)) tG3 = tG3+Two*G1(iz,iu)
  if ((iu == iy) .and. (it == iz)) tG3 = tG3+Two*G1(ix,iv)
  if ((iu == iy) .and. (iv == ix)) tG3 = tG3+Two*G1(iz,it)
  if ((iv == iz) .and. (it == iy)) tG3 = tG3+Two*G1(ix,iu)
  if ((iv == iz) .and. (iu == ix)) tG3 = tG3+Two*G1(iy,it)
  !  one crossing
  if ((it == iy) .and. (iu == ix)) tG3 = tG3+Two*G1(iz,iv)
  if ((it == iz) .and. (iv == ix)) tG3 = tG3+Two*G1(iy,iu)
  if ((iu == iz) .and. (iv == iy)) tG3 = tG3+Two*G1(ix,it)

  if ((it == iy) .and. (iu == iz)) tG3 = tG3-G1(ix,iv)
  if ((it == iy) .and. (iv == ix)) tG3 = tG3-G1(iz,iu)
  if ((it == iz) .and. (iu == ix)) tG3 = tG3-G1(iy,iv)
  if ((it == iz) .and. (iv == iy)) tG3 = tG3-G1(ix,iu)
  if ((iu == ix) .and. (iv == iy)) tG3 = tG3-G1(iz,it)
  if ((iu == iz) .and. (iv == ix)) tG3 = tG3-G1(iy,it)

  !! three delta
  if ((it == ix) .and. (iu == iy) .and. (iv == iz)) tG3 = tG3+Eight

  if ((it == ix) .and. (iu == iz) .and. (iv == iy)) tG3 = tG3-Four
  if ((iu == iy) .and. (it == iz) .and. (iv == ix)) tG3 = tG3-Four
  if ((iv == iz) .and. (it == iy) .and. (iu == ix)) tG3 = tG3-Four

  if ((it == iy) .and. (iu == iz) .and. (iv == ix)) tG3 = tG3+Two
  if ((it == iz) .and. (iu == ix) .and. (iv == iy)) tG3 = tG3+Two

end function tG3

function ex2(it,iu,iy,iz,G1,G2)

  real(kind=wp) :: ex2
  integer(kind=iwp), intent(in) :: it, iu, iy, iz
  real(kind=wp), intent(in) :: G1(NASHT,NASHT), G2(NASHT,NASHT,NASHT,NASHT)

  ex2 = G2(it,iu,iy,iz)
  if (iu == iy) ex2 = ex2+G1(it,iz)

end function ex2

function ex3(it,iu,iv,ix,iy,iz,G1,G2,G3)

  use Definitions, only: iwp, wp

  real(kind=wp) :: ex3
  integer(kind=iwp), intent(in) :: it, iu, iv, ix, iy, iz
  real(kind=wp), intent(in) :: G1(NASHT,NASHT), G2(NASHT,NASHT,NASHT,NASHT), G3

  ex3 = G3
  if (iu == iv) ex3 = ex3+G2(it,ix,iy,iz)
  if (ix == iy) ex3 = ex3+G2(it,iu,iv,iz)
  if (iu == iy) ex3 = ex3+G2(it,iz,iv,ix)
  if ((iu == iv) .and. (ix == iy)) ex3 = ex3+G1(it,iz)

end function ex3

subroutine dertG2(it,iu,iy,iz,DG1,DG2,val)

  integer(kind=iwp), intent(in) :: it, iu, iy, iz
  real(kind=wp), intent(inout) :: DG1(NASHT,NASHT), DG2(NASHT,NASHT,NASHT,NASHT)
  real(kind=wp), intent(in) :: val

  ! zero delta
  DG2(iy,it,iz,iu) = DG2(iy,it,iz,iu)+val
  ! one delta
  if (it == iy) DG1(iz,iu) = DG1(iz,iu)-Two*val
  if (iu == iz) DG1(iy,it) = DG1(iy,it)-Two*val
  if (it == iz) DG1(iy,iu) = DG1(iy,iu)+val
  if (iu == iy) DG1(iz,it) = DG1(iz,it)+val

end subroutine dertG2

subroutine dertG3(it,ix,iu,iy,iv,iz,DG1,DG2,DG3,val)

  integer(kind=iwp), intent(in) :: it, ix, iu, iy, iv, iz
  real(kind=wp), intent(inout) :: DG1(NASHT,NASHT), DG2(NASHT,NASHT,NASHT,NASHT), DG3
  real(kind=wp), intent(in) :: val

  ! \tilde{R}_{abc,def}^{(3)}
  !! zero delta
  DG3 = DG3-val !! (iz,iy,ix,iv,iu,it)
  !! one delta
  if (it == ix) DG2(iz,iv,iy,iu) = DG2(iz,iv,iy,iu)+Two*val
  if (iu == iy) DG2(iz,iv,ix,it) = DG2(iz,iv,ix,it)+Two*val
  if (iv == iz) DG2(iy,iu,ix,it) = DG2(iy,iu,ix,it)+Two*val

  if (it == iy) DG2(iz,iv,ix,iu) = DG2(iz,iv,ix,iu)-val
  if (it == iz) DG2(ix,iv,iy,iu) = DG2(ix,iv,iy,iu)-val
  if (iu == ix) DG2(iz,iv,iy,it) = DG2(iz,iv,iy,it)-val
  if (iu == iz) DG2(iy,iv,ix,it) = DG2(iy,iv,ix,it)-val
  if (iv == ix) DG2(iy,iu,iz,it) = DG2(iy,iu,iz,it)-val
  if (iv == iy) DG2(iz,iu,ix,it) = DG2(iz,iu,ix,it)-val

  !! two delta
  !  two same spin
  if ((it == ix) .and. (iu == iy)) DG1(iz,iv) = DG1(iz,iv)-Four*val
  if ((it == ix) .and. (iv == iz)) DG1(iy,iu) = DG1(iy,iu)-Four*val
  if ((iu == iy) .and. (iv == iz)) DG1(ix,it) = DG1(ix,it)-Four*val
  !  one same spin
  if ((it == ix) .and. (iu == iz)) DG1(iy,iv) = DG1(iy,iv)+Two*val
  if ((it == ix) .and. (iv == iy)) DG1(iz,iu) = DG1(iz,iu)+Two*val
  if ((iu == iy) .and. (it == iz)) DG1(ix,iv) = DG1(ix,iv)+Two*val
  if ((iu == iy) .and. (iv == ix)) DG1(iz,it) = DG1(iz,it)+Two*val
  if ((iv == iz) .and. (it == iy)) DG1(ix,iu) = DG1(ix,iu)+Two*val
  if ((iv == iz) .and. (iu == ix)) DG1(iy,it) = DG1(iy,it)+Two*val
  !  one crossing
  if ((it == iy) .and. (iu == ix)) DG1(iz,iv) = DG1(iz,iv)+Two*val
  if ((it == iz) .and. (iv == ix)) DG1(iy,iu) = DG1(iy,iu)+Two*val
  if ((iu == iz) .and. (iv == iy)) DG1(ix,it) = DG1(ix,it)+Two*val

  if ((it == iy) .and. (iu == iz)) DG1(ix,iv) = DG1(ix,iv)-val
  if ((it == iy) .and. (iv == ix)) DG1(iz,iu) = DG1(iz,iu)-val
  if ((it == iz) .and. (iu == ix)) DG1(iy,iv) = DG1(iy,iv)-val
  if ((it == iz) .and. (iv == iy)) DG1(ix,iu) = DG1(ix,iu)-val
  if ((iu == ix) .and. (iv == iy)) DG1(iz,it) = DG1(iz,it)-val
  if ((iu == iz) .and. (iv == ix)) DG1(iy,it) = DG1(iy,it)-val

end subroutine dertG3

subroutine derex2(it,iu,iy,iz,DG1,DG2,val)

  integer(kind=iwp), intent(in) :: it, iu, iy, iz
  real(kind=wp), intent(inout) :: DG1(NASHT,NASHT), DG2(NASHT,NASHT,NASHT,NASHT)
  real(kind=wp), intent(in) :: val

  DG2(it,iu,iy,iz) = DG2(it,iu,iy,iz)+val
  if (iu == iy) DG1(it,iz) = DG1(it,iz)+val

end subroutine derex2

subroutine derex3(it,iu,iv,ix,iy,iz,DG1,DG2,DG3,val)

  integer(kind=iwp), intent(in) :: it, iu, iv, ix, iy, iz
  real(kind=wp), intent(inout) :: DG1(NASHT,NASHT), DG2(NASHT,NASHT,NASHT,NASHT), DG3
  real(kind=wp), intent(in) :: val

  DG3 = DG3+val
  if (iu == iv) DG2(it,ix,iy,iz) = DG2(it,ix,iy,iz)+val
  if (ix == iy) DG2(it,iu,iv,iz) = DG2(it,iu,iv,iz)+val
  if (iu == iy) DG2(it,iz,iv,ix) = DG2(it,iz,iv,ix)+val
  if ((iu == iv) .and. (ix == iy)) DG1(it,iz) = DG1(it,iz)+val

end subroutine derex3

end module NEVPT2_MOD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
************************************************************************
* This file contains boiler-plate code to allow developers to experiment
* with modifications to the zero-order hamiltonian. To enable them,
* remove the #if 0/#endif blocks, and use 'HZero = Custom' in the input.
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE NEWB()
#if 0
      use caspt2_global, only: LUSBT
      use EQSOLV, only: iDSMat, iDBMat
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: nSym, nASup, nISup
      IMPLICIT NONE

      INTEGER ICASE,ISYM,NAS,NIS,NCOEF
      INTEGER IDS,NS,IDB,NB
      REAL*8, ALLOCATABLE:: S(:), B(:)

C Modify B matrices, if requested.


      DO ICASE=1,11
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          NCOEF=NAS*NIS
          IF(NCOEF.EQ.0) CYCLE
          NS=(NAS*(NAS+1))/2
          CALL mma_allocate(S,NS,LABEL='S')
          IDS=IDSMAT(ISYM,ICASE)
          CALL DDAFILE(LUSBT,2,S,NS,IDS)
          NB=NS
          CALL mma_allocate(B,NB,LABEL='B')
          IDB=IDBMAT(ISYM,ICASE)
          CALL DDAFILE(LUSBT,2,B,NB,IDB)
C Modify B matrix, using S matrix and some other data.
          CALL mma_deallocate(B)
          CALL mma_deallocate(S)
        END DO
      END DO

#endif
      END SUBROUTINE NEWB

      SUBROUTINE NEWDIA()
#if 0
      use caspt2_global, only: LUSBT
      use EQSOLV, only: IDBMAT
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: nSym, nInDep, nASup, nISup
      IMPLICIT NONE

      INTEGER ICASE,ISYM,NIN,NAS,NIS,I
      INTEGER JD
      REAL*8, ALLOCATABLE:: BD(:), ID(:), C1(:), C2(:)

C Post-diagonalization modification of diagonal energy
C denominator terms for active and for non-active superindex.


      DO ICASE=1,13
        DO ISYM=1,NSYM
          NIN=NINDEP(ISYM,ICASE)
          IF(NIN.EQ.0) CYCLE
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF(NIS.EQ.0) CYCLE
C Remember: NIN values in BDIAG, but must read NAS for correct
C positioning.
          CALL mma_allocate(BD,NAS,LABEL='BD')
          CALL mma_allocate(ID,NIS,LABEL='ID')
          CALL mma_allocate(C1,NAS,LABEL='C1')
          CALL mma_allocate(C2,NIS,LABEL='C2')
          JD=IDBMAT(ISYM,ICASE)
C Active, and non-active, energy denominators:
          CALL DDAFILE(LUSBT,2,BD,NAS,JD)
          CALL DDAFILE(LUSBT,2,ID,NIS,JD)
C Active, and non-active, corrections:
C (Replace this strange example with something sensible)
          C1(:)=0.0D0
          C2(:)=0.0D0
C Modifications are added to the usual diagonal energies:
          DO I=1,NAS
            BD(I)=BD(I)+C1(I)
          END DO
          DO I=1,NIS
            ID(I)=ID(I)+C2(I)
          END DO
          ID=IDBMAT(ISYM,ICASE)
          CALL DDAFILE(LUSBT,1,BD,NAS,JD)
          CALL DDAFILE(LUSBT,1,ID,NIS,JD)
C Added modifications are saved on LUSBT.
          CALL DDAFILE(LUSBT,1,C1,NAS,JD)
          CALL DDAFILE(LUSBT,1,C2,NIS,JD)

          CALL mma_deallocate(BD)
          CALL mma_deallocate(ID)
          CALL mma_deallocate(C1)
          CALL mma_deallocate(C2)
          ID=IDBMAT(ISYM,ICASE)
        END DO
      END DO
#endif
      END SUBROUTINE NEWDIA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_Check(irc)
C
C     Purpose: check settings for parallel Cholesky.
C
C-TODO/FIXME: The features not allowed in parallel execution of the
C             Cholesky decomposition should be implemented later. Thus,
C             this subroutine is, in effect, a TODO-list.
C
      Implicit None
      Integer irc
#include "cholesky.fh"
#include "chosubscr.fh"
#include "chosimri.fh"
#include "cho_para_info.fh"

      Logical WriteBlank

      irc = 0
      WriteBlank=.True.

      If (Cho_Real_Par) Then ! TRUE PARALLEL
         If (Cho_DecAlg.ne.4 .and. Cho_DecAlg.ne.5 .and.
     &       Cho_DecAlg.ne.6) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            Write(Lupri,'(A,A)')
     &      'Only possible parallel Cholesky decomposition algorithm ',
     &      'is "PARAllel".'
            Write(Lupri,'(A,I3,A)')
     &                     'Resetting Cho_DecAlg from ',Cho_DecAlg,
     &                     ' to 5 (parallel two-step algorithm),'
            Cho_DecAlg = 5
         End If
         If (MxShPr .ne. 1) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            Write(Lupri,'(A,A,A)')
     &                     'Max. number of shell pair distributions ',
     &                     'calculated in each pass is 1 for ',
     &                     'parallel Cholesky.'
            Write(Lupri,'(A,I6,A)')
     &                     'Resetting MxShPr from ',MxShPr,' to 1'
            MxShPr = 1
         End If
         If (Cho_IntChk) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            Write(Lupri,'(A)') 'You have requested integral checking.'
            Write(Lupri,'(A,A)')
     &                     'Integral checking is not possible for ',
     &                     'parallel Cholesky.'
            irc = irc + 1
         End If
         If (RstDia .or. RstCho) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            If (RstDia) Then
               Write(Lupri,'(A)') 'You have requested diagonal restart.'
               irc = irc + 1
            End If
            If (RstCho) Then
               Write(Lupri,'(A)')
     &         'You have requested decomposition restart.'
               irc = irc + 1
            End If
            Write(Lupri,'(A,A)')
     &                     'Restart is not possible for parallel ',
     &                     'Cholesky.'
         End If
         If (Cho_ReOrd) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            Write(Lupri,'(A,A)')
     &                     'Vector reordering is not possible for ',
     &                     'parallel Cholesky.'
            irc = irc + 1
         End If
         If (Cho_AdrVec .ne. 1) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            Write(Lupri,'(A,A)')
     &                     'Address mode for vector I/O must be word-',
     &                     'addressable for parallel Cholesky.'
            Write(Lupri,'(A,I4,A)')
     &      'Resetting Cho_AdrVec from ',Cho_AdrVec,' to 1'
            Cho_AdrVec = 1
         End If
         If (IfcSew .ne. 2) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            Write(Lupri,'(A,A)')
     &      'Seward interface must be directly in reduced ',
     &      'sets for parallel Cholesky.'
            Write(Lupri,'(A,I4,A)')
     &      'Resetting IfcSew from ',IfcSew,' to 2'
            IfcSew = 2
         End If
         If (Cho_TstScreen) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            Write(Lupri,'(A,A)')
     &                     'Test of subtraction screening is not ',
     &                     'possible for parallel Cholesky.'
            Write(Lupri,'(A)') 'Turning Cho_TstScreen off.'
            Cho_TstScreen = .False.
         End If
         If (Cho_SScreen) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            Write(Lupri,'(A,A)') 'Subtraction screening is not ',
     &                     'possible for parallel Cholesky.'
            irc = irc + 1
         End If
         If (Cho_SimRI) Then
            If (WriteBlank) Then
               Write(Lupri,*)
               WriteBlank=.False.
            End If
            Write(Lupri,'(A,A)') 'Simulation of RI is not ',
     &                     'possible for parallel Cholesky.'
            irc = irc + 1
         End If
      Else
         If (CHO_FAKE_PAR .and.
     &       nProcs.gt.1 .and. Is_Real_Par()) Then ! FAKE PARALLEL
            If (Cho_ReOrd) Then
               If (WriteBlank) Then
                  Write(Lupri,*)
                  WriteBlank=.False.
               End If
               Write(Lupri,'(A,A)')
     &                        'Vector reordering is not possible for ',
     &                        'parallel Cholesky.'
               irc = irc + 1
            End If
         End If
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PolRas(iDist,iDistIm,iDT,iFI,iFP,iFil,iCStart
     &                 ,iTriState,VMat,Smat,DiFac,Ract,icnum,Energy
     &                 ,NVarv,iSTC,Haveri,iQ_Atoms,ip_ExpVal,Poli)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "qm2.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension Poli(MxQCen,10),VMat(MxStOT),FFp(nPol*nPart,3)
      Dimension VpolMat(MxStOT),Smat(MxStOT),RoMatSt(MxStOT)
      Dimension EEigen(MxState)
      Dimension iDT(3),iFI(3),iFP(3),iFil(MxQCen,10)
      Logical JaNej,Haveri

*
*-- Allocate and initialize the eigenvector matrix with the unit matrix.
*
      Call GetMem('Coeff','Allo','Real',iSTC,nState**2)
      call dcopy_(nState**2,[ZERO],iZERO,Work(iSTC),iONE)
      call dcopy_(nState,[ONE],iZERO,Work(iSTC),nState+1)
*
*-- Define some numbers.
*
      nQMCent=(iQ_Atoms*(iQ_Atoms+1))/2
      nPolCent=nPart*nPol
      Rinv=1.0d0/Ract
      R2inv=Rinv**2
      PolFac=DiFac/Ract**3
      Egun=0.0d0

*
*-- Compute distances and vectors needed for solving the polarization
*   equations. Observe the use of a memory allocator before the call
*   to polprep. This is to conserve memory but without having to
*   rewrite the entire polprep routine (written originally with
*   static allocations). A future project is to rewrite polprep.
*
      Call Memory_PolPrep('Allo',ixx,iyy,izz,irr3,ixxi,iyyi,izzi
     &                   ,iGri,nPol,nPart)
      Call PolPrep(iDist,iDistIM,Work(ixx),Work(iyy),Work(izz)
     &            ,Work(irr3),Work(ixxi),Work(iyyi),Work(izzi)
     &            ,Work(iGri),iCNum,nPolCent)

*
*-- Polarization loop commencing.
*
      NVarv=0
7912  Continue
      NVarv=NVarv+1
      Energy=0.0d0
      Call PolSolv(iDT,iFI,iFP,Work(ixx),Work(iyy),Work(izz),Work(irr3)
     &            ,Work(ixxi),Work(iyyi),Work(izzi),Work(iGri),FFp
     &            ,iCNum,r2Inv,DiFac,nPolCent)
      Call DensiSt(RomatSt,Work(iSTC),nEqState,nState,nState)
      Call Polins(Energy,iCall,nPolCent,nQMCent,iFil,VpolMat,FFp
     &           ,PolFac,poli,xyzMyQ,xyzMyI,xyzMyP,iCstart,iQ_Atoms
     &           ,qTot,ChaNuc,RoMatSt,xyzQuQ,CT)

*
*-- Assemble the Hamiltonian matrix.
*
      Do 815, i=1,iTriState
        HmatState(i)=HmatSOld(i)+Vmat(i)+VpolMat(i)+SMat(i)
815   Continue
      Energy=0.5*Energy

*
*-- Diagonalize the bastard. Eigenvalues are sorted and the
*   relevant eigenvalue is added to total energy.
*
      Call GetMem('Scratch','Allo','Real',iScratch,nState**2)
      Call Diag_Driver('V','A','L',nState,HMatState,Work(iScratch)
     &                ,nState,Dummy,Dummy,iDum,iDum,EEigen,Work(iSTC)
     &                ,nState,1,-1,'J',nFound,iErr)
      If(lCiSelect) Call CiSelector(nEqState,nState,iSTC,nCIRef,iCIInd
     &                                                         ,dCIRef)
      Energy=Energy+EEigen(nEqState)
      Call GetMem('Scratch','Free','Real',iScratch,nState**2)

*
*-- Check if polarization loop has converged.
*
      Call HaveWeConv(iCNum,iCStart,iQ_Atoms,nPolCent,iDT,FFp,xyzMyI
     &               ,Egun,Energy,NVarv,JaNej,Haveri)
      If(Haveri) GoTo 8108
      If(.not.JaNej) GoTo 7912

8108  Continue

*
*-- Deallocate.
*
      Call Memory_PolPrep('Free',ixx,iyy,izz,irr3,ixxi,iyyi,izzi,iGri
     &                   ,nPol,nPart)

*
*-- If expectation values are extracted, make a detour.
*
      If(lExtr(6))Call Expectus('RASSI',HmatSOld,Vmat,VpolMat,Smat
     &                         ,MxStOT,iSTC,nState,lExtr(4),iExtr_Eig
     &                         ,ip_ExpVal)

*
*-- Is it dead? It's terminated!
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!               1993, Per Boussard                                     *
!***********************************************************************

subroutine PAM2Int( &
#                  define _CALLING_
#                  include "int_interface.fh"
                  )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of PAM integrals used in  *
!         PAM calculations. The operator is a gaussian type function   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
!             Physics, University of Stockholm, Sweden, October '93.   *
!***********************************************************************

use Basis_Info, only: dbsc, PAMexp
use Center_Info, only: dc
use Her_RW, only: HerR, HerW, iHerR, iHerW
use PAM2, only: iPAMPrim, kCnttpPAM
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: ia, iab, ib, iDCRT(0:7), ikdc, iM2xp, ipab, ipAxyz, ipBxyz, ipK, ipPx, ipPy, ipPz, ipQxyz, ipRes, iPrint, &
                     ipRxyz, ipZ, iRout, iZeta, kCnt, kCnttp, kdc, lDCRT, LmbdT, nDCRT, nip, nOp
real(kind=wp) :: C(3), Fact, Factor, Gmma, PTC2, TC(3), Tmp0, Tmp1
character(len=80) :: Label
logical(kind=iwp) :: ABeq(3)
real(kind=wp), allocatable :: Scr(:)
integer(kind=iwp), external :: NrOpr

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(ZInv)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 122
iPrint = nPrint(iRout)

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+1)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+1)
ipRxyz = nip
nip = nip+nZeta*3*nHer*(nOrdOp+1)
ipQxyz = nip
nip = nip+nZeta*3*(la+1)*(lb+1)*(nOrdOp+1)
ipK = nip
nip = nip+nZeta
ipZ = nip
nip = nip+nZeta
ipPx = nip
nip = nip+nZeta
ipPy = nip
nip = nip+nZeta
ipPz = nip
nip = nip+nZeta
ipRes = nip
nip = nip+nZeta*nComp*nTri_Elem1(la)*nTri_Elem1(lb)
if (nip-1 > nArr*nZeta) then
  call WarningMessage(2,'PAM2Int: nip-1 > nArr*nZeta')
  write(u6,*) ' nArr is Wrong! ',nip-1,' > ',nArr*nZeta
  write(u6,*) ' Abend in PAM2Int'
  call Abend()
end if

if (iPrint >= 49) then
  call RecPrt(' In PAM2Int: A',' ',A,1,3)
  call RecPrt(' In PAM2Int: RB',' ',RB,1,3)
  call RecPrt(' In PAM2Int: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In PAM2Int: Kappa',' ',rKappa,nAlpha,nBeta)
  call RecPrt(' In PAM2Int: Zeta',' ',Zeta,nAlpha,nBeta)
  call RecPrt(' In PAM2Int: P',' ',P,nZeta,3)
  write(u6,*) ' In PAM2Int: la,lb,nHer=',la,lb,nHer
end if

rFinal(:,:,:,:) = Zero

! Loop over nuclear centers

kdc = 0
if (kCnttpPAM > 1) then
  do ikdc=1,kCnttpPAM-1
    kdc = kdc+dbsc(ikdc)%nCntr
  end do
end if

kCnttp = kCnttpPAM

call mma_allocate(Scr,nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp,label='Scr')
do kCnt=1,dbsc(kCnttp)%nCntr
  C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)

  call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
  Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

  do lDCRT=0,nDCRT-1
    call OA(iDCRT(lDCRT),C,TC)

    Scr(:) = Zero
    do iM2xp=1,iPAMPrim
      Gmma = PAMexp(iM2xp,1)

      if (iPrint >= 99) write(u6,*) ' Gamma=',Gmma

      ! Modify the original basis.

      do iZeta=1,nZeta
        PTC2 = (P(iZeta,1)-TC(1))**2+(P(iZeta,2)-TC(2))**2+(P(iZeta,3)-TC(3))**2
        Tmp0 = Zeta(iZeta)+Gmma
        Tmp1 = exp(-Zeta(iZeta)*Gmma*PTC2/Tmp0)
        Array(ipK+iZeta-1) = rKappa(iZeta)*Tmp1
        Array(ipZ+iZeta-1) = Tmp0
        Array(ipPx+iZeta-1) = (Zeta(iZeta)*P(iZeta,1)+Gmma*TC(1))/Tmp0
        Array(ipPy+iZeta-1) = (Zeta(iZeta)*P(iZeta,2)+Gmma*TC(2))/Tmp0
        Array(ipPz+iZeta-1) = (Zeta(iZeta)*P(iZeta,3)+Gmma*TC(3))/Tmp0
      end do
      if (iPrint >= 99) then
        write(u6,*) ' The modified basis set'
        call RecPrt(' In PAM2Int: Kappa',' ',Array(ipK),nAlpha,nBeta)
        call RecPrt(' In PAM2Int: Zeta',' ',Array(ipZ),nAlpha,nBeta)
        call RecPrt(' In PAM2Int: P',' ',Array(ipPx),nZeta,3)
      end if

      ! Compute the cartesian values of the basis functions angular part

      ABeq(:) = (A == RB) .and. (A == TC)
      call CrtCmp(Array(ipZ),Array(ipPx),nZeta,A,Array(ipAxyz),la,HerR(iHerR(nHer)),nHer,ABeq)
      call CrtCmp(Array(ipZ),Array(ipPx),nZeta,RB,Array(ipBxyz),lb,HerR(iHerR(nHer)),nHer,ABeq)

      ! Compute the contribution from the multipole moment operator

      ABeq(:) = .false.
      call CrtCmp(Array(ipZ),Array(ipPx),nZeta,TC,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)

      ! Compute the cartesian components for the multipole moment
      ! integrals. The integrals are factorized into components.

      call Assmbl(Array(ipQxyz),Array(ipAxyz),la,Array(ipRxyz),nOrdOp,Array(ipBxyz),lb,nZeta,HerW(iHerW(nHer)),nHer)

      ! Combine the cartesian components to the full one electron integral.

      call CmbnMP(Array(ipQxyz),nZeta,la,lb,nOrdOp,Array(ipZ),Array(ipK),Array(ipRes),nComp)
      if (iPrint >= 99) then
        write(u6,*) ' Intermediate result in PAM2Int'
        do ia=1,nTri_Elem1(la)
          do ib=1,nTri_Elem1(lb)
            iab = (ib-1)*nTri_Elem1(la)+ia
            ipab = (iab-1)*nZeta+ipRes
            write(Label,'(A,I2,A,I2,A)') ' Array(',ia,',',ib,')'
            if (nComp /= 1) then
              call RecPrt(Label,' ',Array(ipab),nZeta,nComp)
            else
              call RecPrt(Label,' ',Array(ipab),nAlpha,nBeta)
            end if
          end do
        end do
      end if

      ! Multiply result by Zeff*Const

      Factor = -dbsc(kCnttp)%Charge*PAMexp(iM2xp,2)*Fact

      ! FOR DMFT calculation!!!

      !write(u6,*) ' Cff',PAMexp(iM2xp,2)
      Factor = Fact*PAMexp(iM2xp,2)
      if (iPrint >= 99) write(u6,*) ' Factor=',Factor
      Scr(:) = Scr+Factor*Array(ipRes:ipRes+size(Scr)-1)

    end do

    ! Accumulate contributions

    nOp = NrOpr(iDCRT(lDCRT))
    call SymAdO(Scr,nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,One)

  end do
end do
call mma_deallocate(Scr)

!if (nOrdOp == 1) then
if (iPrint >= 99) then
  write(u6,*) ' Result in PAM2Int'
  do ia=1,nTri_Elem1(la)
    do ib=1,nTri_Elem1(lb)
      write(Label,'(A,I2,A,I2,A)') ' rFinal(ia=',ia,',ib=',ib,')'
      call RecPrt(Label,' ',rFinal(:,ia,ib,1),nAlpha,nBeta)
    end do
  end do
end if

return

end subroutine PAM2Int

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Giovanni Li Manni                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NEXT_SYM_DISTR_NEW(NSMST,NGRP,KGRP,NGAS,ISYM,ISYM_TOT,IFIRST,NONEW,ISMDFGP,NACTSYM,ISMSCR)
! Giovanni Li Manni. Geneva, February 2012
!
! Obtain next distribution of symmetries with given total
! Symmetry.
!
! Loop over first NGAS-1 spaces are performed, and the symmetry
! of the last space is then fixed by the required total sym

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSMST, NGRP, NGAS, KGRP(NGAS), ISYM_TOT, ISMDFGP(NSMST,NGRP), NACTSYM(NGRP)
integer(kind=iwp), intent(out) :: ISYM(NGAS), NONEW
integer(kind=iwp), intent(inout) :: IFIRST, ISMSCR(NGRP)
integer(kind=iwp) :: IGAS, JSYM
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I, ISM
#endif
integer(kind=iwp), external :: ISYMSTR

#ifdef _DEBUGPRINT_
write(u6,*) '***************************'
write(u6,*) 'INPUT IN NEXT_SYM_DISTR_NEW'
write(u6,*) '***************************'
write(u6,*) 'NGRP :',NGRP
write(u6,*) 'KGRP :'
write(u6,'(40I3)') (KGRP(i),i=1,NGAS)
write(u6,*) 'NACTSYM(NGRP) :'
write(u6,'(40I2)') (NACTSYM(i),i=1,NGRP)
write(u6,*) 'ISMDFGP(ISYM,NGRP) :'
do Ism=1,NSMST
  write(u6,'(40I2)') (ISMDFGP(ism,i),i=1,NGRP)
end do
write(u6,*) 'IFIRST',IFIRST
#endif

if (IFIRST == 1) then
  ISMSCR(1:NGAS) = 1
  do IGAS=1,NGAS
    ISYM(IGAS) = ISMDFGP(1,KGRP(IGAS))
  end do
  NONEW = 0
end if

#ifdef _DEBUGPRINT_
write(u6,*) 'Symmetry distribution :'
write(u6,'(40I2)') (ISYM(IGAS),IGAS=1,NGAS)
#endif

do
  if (IFIRST == 0) then
    call NXTDIST(NGRP,NGAS,KGRP,ISMSCR,NACTSYM,NONEW)
    do IGAS=1,NGAS
      ISYM(IGAS) = ISMDFGP(ISMSCR(IGAS),KGRP(IGAS))
    end do
  end if
  IFIRST = 0
  if (NONEW == 0) then
    JSYM = ISYMSTR(ISYM,NGAS)
    if (JSYM == ISYM_TOT) exit
  else
    exit
  end if
end do

#ifdef _DEBUGPRINT_
if (NONEW == 1) then
  write(u6,*) ' No new symmetry distributions'
else
  write(u6,*) ' Next symmetry distribution'
  call IWRTMA(ISYM,1,NGAS,1,NGAS)
end if
#endif

end subroutine NEXT_SYM_DISTR_NEW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine poti(k,ipot3)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: k
integer(kind=iwp), intent(out) :: ipot3(0:k+1)
integer(kind=iwp) :: i, iSum

isum = 1
ipot3(0) = 1
do i=1,k
  ipot3(i) = 3**i
  isum = isum+ipot3(i)
end do
ipot3(k+1) = isum

return

end subroutine poti

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine iRBuf(Array,nArray,Copy)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Definitions, only: wp, iwp, RtoI

implicit none
integer(kind=iwp), intent(in) :: nArray
integer(kind=iwp), intent(inout) :: Array(nArray)
logical(kind=iwp), intent(in) :: Copy

call idRBuf(Array,nArray/RtoI,Copy)

return

! This is to allow type punning without an explicit interface
contains

subroutine idRBuf(Array,nArray,Copy)

  integer(kind=iwp), intent(in) :: nArray
  logical(kind=iwp), intent(in) :: Copy
  integer(kind=iwp), target, intent(inout) :: Array(nArray)
  real(kind=wp), pointer :: dArray(:)

  call c_f_pointer(c_loc(Array(1)),dArray,[nArray])
  call dRBuf(dArray,nArray,Copy)
  nullify(dArray)

end subroutine idRBuf

end subroutine iRBuf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine block_interf(ind1f,ind1l,ind2f,ind2l,b1f,b1l,nind_b1f,nind_b1l,b2f,b2l,nind_b2f,nind_b2l)
! this routine does:
!
! Interface between Palo and Juzek virtual orbitals blocking structure
!
! ind1f,ind1l,ind2f,ind2l - first and last absolute of the VO indices of interest
!
! b1f,b1l   - first and last Palo's block which contain ind1
! b2f,b2l   - first and last Palo's block which contain ind2
!
! nind_b1f  - sum of VOs in blocks 1,2, ..., b1f-1
! nind_b2f  - sum of VOs in blocks 1,2, ..., b2f-1
!
! nind_b1l  - # of VOs in b1f before ind1
! nind_b2l  - # of VOs in b2f before ind2

use ChT3_global, only: DimGrpaR, NvGrp
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ind1f, ind1l, ind2f, ind2l
integer(kind=iwp), intent(out) :: b1f, b1l, nind_b1f, nind_b1l, b2f, b2l, nind_b2f, nind_b2l
integer(kind=iwp) :: i, isum
logical(kind=iwp) :: found1, found2, found3, found4

! set b1f, b2f, b1l, b2l

isum = 0
found1 = .false.
found2 = .false.
found3 = .false.
found4 = .false.

do i=1,NvGrp
  isum = isum+DimGrpaR(i)

  if ((ind1f <= isum) .and. (.not. found1)) then
    b1f = i
    found1 = .true.
  end if

  if ((ind1l <= isum) .and. (.not. found2)) then
    b1l = i
    found2 = .true.
  end if

  if ((ind2f <= isum) .and. (.not. found3)) then
    b2f = i
    found3 = .true.
  end if

  if ((ind2l <= isum) .and. (.not. found4)) then
    b2l = i
    found4 = .true.
  end if

end do

!mp write(u6,*) 'b1f, b1l, b2f, b2l ',b1f,b1l,b2f,b2l

! set nind_b1f, nind_b1l

if (b1f > 1) then
  isum = 0
  do i=1,b1f-1
    isum = isum+DimGrpaR(i)
  end do
  nind_b1f = isum
else
  nind_b1f = 0
end if
nind_b1l = ind1f-nind_b1f-1

! set nind_b1f, nind_b1l

if (b2f > 1) then
  isum = 0
  do i=1,b2f-1
    isum = isum+DimGrpaR(i)
  end do
  nind_b2f = isum
else
  nind_b2f = 0
end if
nind_b2l = ind2f-nind_b2f-1

return

end subroutine block_interf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine initialize guessorb.                                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: Oct 2004                                                    *
*                                                                      *
************************************************************************
      Subroutine InitGO(StandAlone)
      Implicit None
      Logical StandAlone
#include "Molcas.fh"
#include "commgo.fh"
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Logical Debug
      Logical Trace
      Logical Found
      Integer nBasTot
      Integer iSym
      Integer iBas
      Integer iPrt
      Integer i
*----------------------------------------------------------------------*
* External entry points                                                *
*----------------------------------------------------------------------*
      Integer  iPrintLevel
      External iPrintLevel
*----------------------------------------------------------------------*
* Setup                                                                *
*----------------------------------------------------------------------*
      Debug=.false.
      Trace=.false.
      If(Trace) Write(6,*) '>>> Entering initgo'
*----------------------------------------------------------------------*
* Set default for MO printing.                                         *
*----------------------------------------------------------------------*
      iPrt=iPrintLevel(-1)
      If(iPrt.ge.4) Then
         PrintMOs=.true.
         PrintEor=.true.
         PrintPop=.true.
         iPrFmt=3
         PrThr=1.0d6
      Else If(iPrt.ge.3) Then
         PrintMOs=.false.
         PrintEor=.false.
         PrintPop=.false.
         iPrFmt=1
         PrThr=5.0d0
      Else
         PrintMOs=.false.
         PrintEor=.false.
         PrintPop=.false.
         PrThr=5.0d0
      End If
*----------------------------------------------------------------------*
* Set other defaults.                                                  *
*----------------------------------------------------------------------*
      Call Qpg_dScalar('S delete thr',Found)
      If(Found) Then
         Call Get_dScalar('S delete thr',SThr)
      Else
         SThr=1.0d-9
         Call Put_dScalar('S delete thr',SThr)
      End If
      Call Qpg_dScalar('T delete thr',Found)
      If(Found) Then
         Call Get_dScalar('T delete thr',TThr)
      Else
         TThr=1.0d+6
         Call Put_dScalar('T delete thr',TThr)
      End If
      GapThr=0.01d0
*----------------------------------------------------------------------*
* Get basic data from runfile.                                         *
*----------------------------------------------------------------------*
      Call get_iscalar('nSym',nSym)
      Call get_iarray('nBas',nBas,nSym)
      Do iSym=1,MxSym
         nOcc(iSym)=0
         nVir(iSym)=0
         nDel(iSym)=0
      End Do
      nBasTot=0
      Do iSym=1,nSym
         nBasTot=nBasTot+nBas(iSym)
      End Do
      If(Debug) Then
         Write(6,'(a,8i5)') 'initgo: nSym',nSym
         Write(6,'(a,8i5)') 'initgo: nBas',nBas
         Write(6,'(a,8i5)') 'initgo: nOcc',nOcc
         Write(6,'(a,8i5)') 'initgo: nVir',nVir
         Write(6,'(a,8i5)') 'initgo: nBasTot',nBasTot
      End If
      Call get_iscalar('Unique Atoms',nNuc)
      If(nNuc.gt.MxAtom) Then
         Call SysAbendMsg('initgo','Fatal:',
     &                    'Too many atoms, increase MxAtom')
      End If
      Call get_carray('Unique Atom Names',Name,LENIN*nNuc)
      Call get_carray('Unique Basis Names',Label,(LENIN8)*nBasTot)
      Call get_darray('Nuclear Charge',xCharge,nNuc)
      If(Debug) Then
         Write(6,'(a,8i5)')    'initgo: nNuc',nNuc
         Write(6,'(a,8i5)')    'initgo: nBasTot',nBasTot
         Write(6,'(a,8f12.6)') 'initgo: Charge',(xCharge(i),i=1,nNuc)
         Write(6,'(a,8a4)')    'initgo: Name ',(Name(i),i=1,nNuc)
         Write(6,'(a)') 'initgo: Basis functions'
         Do iBas=1,nBasTot
            Write(6,'(2a)') Label(iBas)(1:LENIN),
     &                      Label(iBas)(LENIN1:LENIN8)
         End Do
      End If
*----------------------------------------------------------------------*
* Done                                                                 *
*----------------------------------------------------------------------*
      If(Trace) Write(6,*) '<<< Exiting initgo'
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(StandAlone)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine chi_sum(N,Xex,Zex,XL,ZL,XR,ZR,iopt,X,Z)
! computes the total CHI, provided all input values are provided
! according to the desired partition scheme  (iopt = 1 or 2 )
! all X tensors must be given in the general coordinate system
!
! definition of the variables:
!     N  -- total number of magnetic sites, Integer, input
!    Xex -- susceptibility tensor arising form the exchange states only, Real(kind=wp) :: , (3,3) array, input
!    Zex -- statistical sum according to Boltzmann distribution law of the exchange states, Real(kind=wp) :: , input
!    XL  -- susceptibility tensor arising from LOCAL states (all), Real(kind=wp) :: , (N,3,3) array, input
!    ZL  -- statistical sum according to Boltzmann distribution law arising from LOCAL states (all),
!           Real(kind=wp) :: , (N) array, input
!    XR  -- susceptibility tensor arising from LOCAL states (exchange only), Real(kind=wp) :: , (N,3,3) array, input
!    ZR  -- statistical sum according to Boltzmann distribution law arising from LOCAL states (exchange only),
!           Real(kind=wp) :: , (N) array, input
!   iopt -- option allowing to choose the desired formula, (Integer, input):
!           iopt=1  =>  formula for weak exchange limit ( new derivation)
!           iopt=2  =>  formula for strong exchange limit
!           iopt=3  =>  formula for strong exchange limit
!    X   -- total susceptibility, Real(kind=wp) :: , (3,3) array, output
!    Z   -- total statistical sum according to Boltzmann distribution, Real(kind=wp) :: , output
!---------

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, iopt
real(kind=wp), intent(in) :: Xex(3,3), Zex, XL(N,3,3), ZL(N), XR(N,3,3), ZR(N)
real(kind=wp), intent(out) :: X(3,3), Z
integer(kind=iwp) :: i
real(kind=wp) :: XLT(3,3), XRT(3,3), ZLT, ZRT

XRT(:,:) = Zero
XLT(:,:) = Zero
! compute the total ZT
if (iopt == 1) then
  ! my formula (simple):
  ZLT = product(ZL)
  ZRT = product(ZR)
  Z = Zex+ZLT-ZRT
  do i=1,N
    XLT(:,:) = XLT(:,:)+XL(i,:,:)
    XRT(:,:) = XRT(:,:)+XR(i,:,:)
  end do
  X(:,:) = Xex(:,:)+XLT(:,:)-XRT(:,:)

else if (iopt == 2) then
  ! thesis formula:
  ZLT = product(ZL)
  ZRT = product(ZR)
  Z = Zex+ZLT-ZRT
  do i=1,N
    XLT(:,:) = XLT(:,:)+XL(i,:,:)*ZLT
    XRT(:,:) = XRT(:,:)+XR(i,:,:)*ZRT
  end do
  X(:,:) = (Xex(:,:)*Zex+XLT(:,:)-XRT(:,:))/Z

else if (iopt == 3) then
  ! weird formula as implemented in some version of the code, e.g. in the 2013 version:
  ZLT = product(ZL)
  ZRT = product(ZR)
  ZLT = Zex*ZLT/ZRT
  ZRT = Zex
  Z = ZLT-ZRT+Zex
  do i=1,N
    XLT(:,:) = XLT(:,:)+XL(i,:,:)
    XRT(:,:) = XRT(:,:)+XR(i,:,:)
  end do
  X(:,:) = (XLT(:,:)*ZLT-XRT(:,:)*ZRT+Xex(:,:)*Zex)/Z

else

  Z = Zero
  X(:,:) = Zero
  write(u6,'(A)') 'chi_sum: IOPT parameter out of range'
  write(u6,'(A,i8)') 'IOPT = ',IOPT
  return

end if

return

end subroutine chi_sum

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine BoostRep(AddRep,SmatPure,iVecs,nSize,InCutOff)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "qminp.fh"
#include "WrkSpc.fh"

      Dimension SmatPure(*)
      Logical InCutOff

*
*-- Enter.
*
*
*-- Common section.
*
      Scalar=0
*
*-- Take different route for different QM-method.
*
      If(QmType(1:3).eq.'SCF') then
*
*-- Repulsion term added to the Energy
*-- Calculated as S_i*S_i*CPsi_m* CPis_n
*-- S_i is the overlap integral (with the solvent molecule)
*-- for the occupied orbitals of the quantum system
*-- CPsi_m and CPsi_n are the transformation coeficients
*-- obtained from the diagonalization procedure of the Fock matrix
*-- to go from the original wavefunction to the final wavefunction
*-- after the SCF procedure. These coeficientes run over all basis set
*
        Do 801, iO1=1,nSize
          Do 802, iO2=1,nSize
            Do 803, i=1,iOcc1
                kaunter=i*(i+1)/2
                ind1=nSize*(iO1-1)+i-1
                ind2=nSize*(iO2-1)+i-1
                Scalar=Scalar+(Work(iVecs+ind1)*Work(iVecs+ind2)
     &                       *SmatPure(kaunter))
803         Continue
802       Continue
801     Continue
        AddRep=exrep4*abs(Scalar)**2+exrep6*abs(Scalar)**3
     &                       +exrep10*abs(Scalar)**5
      Elseif(QmType(1:4).eq.'RASS') then
        Do 813, i=1,nSize
          Do 814, j=1,nSize
            If(i.ge.j) then
              kaunter=i*(i+1)/2-i+j
            Else
              kaunter=j*(j+1)/2-j+i
            Endif
            ind1=nSize*(nEqState-1)+i-1
            ind2=nSize*(nEqState-1)+j-1
            Scalar=Scalar+Work(iVecs+ind1)*Work(iVecs+ind2)
     &                   *SmatPure(kaunter)
814       Continue
813     Continue
        AddRep=exrep4*abs(Scalar)**2+exrep6*abs(Scalar)**3
     &                       +exrep10*abs(Scalar)**5
      Endif

*
*-- Crazy energy added if inner cut-off has been passed. Ensure reject.
*
      If(InCutOff) AddRep=1D+20


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine drl_bl_ext_ar_new(lin,lrk,lri)

use gugaci_global, only: ihy, ihyl, ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, jphy, jphyl, &
                         log_prod, logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_head, lpnew_lwei, lpnew_rwei, lsm_inn, mtype, &
                         ndim, nstaval, nvalue, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sdplp, w1_sdplp
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lrk, lri
integer(kind=iwp) :: ihypos, ihyposl, ihyposr, ilpend, ilpsta, ilw, in_, iplp, irw, isma, iw0, iwal, iwal0, iwar, iwar0, iwd, &
                     iwuplwei, lphead
integer(kind=iwp), external :: iwalk_ad

isma = lsm_inn(lri)
iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)
do iw0=1,mtype
  w0_sdplp = vplpnew_w0(iw0)
  w1_sdplp = vplpnew_w1(iw0)
  if (logic_dh) w0_sdplp = vplp_w0(iw0)
  if (logic_dh) w1_sdplp = vplp_w1(iw0)
  if (logic_grad) then
    call lp9_drlbl_ext_calcuvalue_g(lri,lrk,isma)
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 6) call gsd_sequence_extspace_g(ilw,irw)
        if (lin == 13) call gtd_sequence_extspace_g(ilw,irw)
        if (lin == 23) call gdv_sequence_extspace_g(ilw,irw)
      else
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 6) call gsd_sequence_extspace_g(ilw,irw)
            if (lin == 13) call gtd_sequence_extspace_g(ilw,irw)
            if (lin == 23) call gdv_sequence_extspace_g(ilw,irw)
          end do
        end do
      end if
    end do
  else
    call lp9_drlbl_ext_calcuvalue_wyb(lri,lrk,isma)
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 6) call gsd_sequence_extspace(ilw,irw)
        if (lin == 13) call gtd_sequence_extspace(ilw,irw)
        if (lin == 23) call gdv_sequence_extspace(ilw,irw)
      else
        if (log_prod == 3) then
          lphead = lpnew_head(iplp)
          ihyposl = jphyl(lphead)
          ihyposr = jphy(lphead)
          ndim = ihyl(ihyposl)
        else
          ihyposl = jphy(iplp)
          ihyposr = ihyposl
          ndim = ihy(ihyposl)
        end if
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihyposl+in_)
          iwar = iwar0+ihy(ihyposr+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 6) call gsd_sequence_extspace(ilw,irw)
            if (lin == 13) call gtd_sequence_extspace(ilw,irw)
            if (lin == 23) call gdv_sequence_extspace(ilw,irw)
          end do
        end do
      end if
    end do

  end if
end do

return

end subroutine drl_bl_ext_ar_new

subroutine drl_br_ext_al_new(lin,lrk,lri)   !to be revised

use gugaci_global, only: ihy, ihyl, ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, jphy, jphyl, &
                         log_prod, logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_head, lpnew_lwei, lpnew_rwei, lsm_inn, mtype, &
                         ndim, nstaval, nvalue, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sdplp
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lrk, lri
integer(kind=iwp) :: ihypos, ihyposl, ihyposr, ilpend, ilpsta, ilw, in_, iplp, irw, isma, iw0, iwal, iwal0, iwar, iwar0, iwd, &
                     iwuplwei, lphead, nlp_value
real(kind=wp), parameter :: crl = 1.0e-8_wp
integer(kind=iwp), external :: iwalk_ad

iwuplwei = jpad_upwei(jpad)
ilsegdownwei = iseg_downwei(ipae)
irsegdownwei = iseg_downwei(ipael)
isma = lsm_inn(lri)

do iw0=1,mtype
  w0_sdplp = vplpnew_w0(iw0)-vplpnew_w1(iw0)
  if (logic_dh) w0_sdplp = vplp_w0(iw0)-vplp_w1(iw0)
  if (abs(w0_sdplp) < crl) cycle
  if (logic_grad) then
    call lp678_ext_calcuvalue_g(lri,lrk,isma,nlp_value)
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 7) call gsd_sequence_extspace_g(irw,ilw)
        if (lin == 14) call gtd_sequence_extspace_g(irw,ilw)
        if (lin == 26) call gdv_sequence_extspace_g(irw,ilw)
      else
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 7) call gsd_sequence_extspace_g(irw,ilw)
            if (lin == 14) call gtd_sequence_extspace_g(irw,ilw)
            if (lin == 26) call gdv_sequence_extspace_g(irw,ilw)
          end do
        end do
      end if
    end do

  else
    call lp678_ext_wyb_calcuvalue(lri,lrk,isma,nlp_value)
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 7) call gsd_sequence_extspace(irw,ilw)
        if (lin == 14) call gtd_sequence_extspace(irw,ilw)
        if (lin == 26) call gdv_sequence_extspace(irw,ilw)
      else
        if (log_prod == 3) then
          lphead = lpnew_head(iplp)
          ihyposl = jphyl(lphead)
          ihyposr = jphy(lphead)
          ndim = ihyl(ihyposl)
        else
          ihyposl = jphy(iplp)
          ihyposr = ihyposl
          ndim = ihy(ihyposl)
        end if
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihyposl+in_)
          iwar = iwar0+ihy(ihyposr+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 7) call gsd_sequence_extspace(irw,ilw)
            if (lin == 14) call gtd_sequence_extspace(irw,ilw)
            if (lin == 26) call gdv_sequence_extspace(irw,ilw)
          end do
        end do
      end if
    end do
  end if
end do

return

end subroutine drl_br_ext_al_new

subroutine ar_bl_br_ext_al_new(lin,intentry,isma,nk)

use gugaci_global, only: ihy, ihyl, ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, jphy, jphyl, &
                         log_prod, logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_head, lpnew_lwei, lpnew_rwei, mtype, ndim, &
                         nstaval, nvalue, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sdplp, w1_sdplp
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, intentry, isma, nk
integer(kind=iwp) :: ihypos, ihyposl, ihyposr, ilpend, ilpsta, ilw, in_, iplp, irw, iw0, iwal, iwal0, iwar, iwar0, iwd, iwuplwei, &
                     lphead, nlp_value
integer(kind=iwp), external :: iwalk_ad

!if ((lin == 14) .and. (intentry == 15195) .and. (isma == 1) .and. (jpad == 20) .and. (jpad == jpadl)) write(u6,*) 'bbs_tmp'

iwuplwei = jpad_upwei(jpad)
ilsegdownwei = iseg_downwei(ipae)
irsegdownwei = iseg_downwei(ipael)
do iw0=1,mtype
  w0_sdplp = vplpnew_w0(iw0)
  w1_sdplp = vplpnew_w1(iw0)
  if (logic_dh) w0_sdplp = vplp_w0(iw0)
  if (logic_dh) w1_sdplp = vplp_w1(iw0)

  if (logic_grad) then
    call lp11_arblbr_ext_calcuvalue_g(intentry,isma,nlp_value)
    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                     !lp_head is in dbl_spa
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 7) call gsd_sequence_extspace_g(irw,ilw)
        if (lin == 14) call gtd_sequence_extspace_g(irw,ilw)
        if (lin == 26) call gdv_sequence_extspace_g(irw,ilw)
      else                                   !lp_head is in act_s
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 7) call gsd_sequence_extspace_g(irw,ilw)
            if (lin == 14) call gtd_sequence_extspace_g(irw,ilw)
            if (lin == 26) call gdv_sequence_extspace_g(irw,ilw)
          end do
        end do
      end if
    end do
  else
    call lp11_arblbr_ext_calcuvalue(intentry,isma,nlp_value)
    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                     !lp_head is in dbl_spa
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 7) call gsd_sequence_extspace(irw,ilw)
        if (lin == 14) call gtd_sequence_extspace(irw,ilw)
        if (lin == 26) call gdv_sequence_extspace(irw,ilw)
      else                                   !lp_head is in act_s
        if (log_prod == 3) then
          lphead = lpnew_head(iplp)
          ihyposl = jphyl(lphead)
          ihyposr = jphy(lphead)
          ndim = ihyl(ihyposl)
        else
          ihyposl = jphy(iplp)
          ihyposr = ihyposl
          ndim = ihy(ihyposl)
        end if

        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihyposl+in_)
          iwar = iwar0+ihy(ihyposr+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 7) call gsd_sequence_extspace(irw,ilw)
            if (lin == 14) call gtd_sequence_extspace(irw,ilw)
            if (lin == 26) call gdv_sequence_extspace(irw,ilw)
          end do
        end do
      end if
    end do
  end if
end do

return

end subroutine ar_bl_br_ext_al_new

subroutine ar_drl_ext_al_new(lin,lri,lrk)

use gugaci_global, only: ihy, ihyl, ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, jphy, jphyl, &
                         log_prod, logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_head, lpnew_lwei, lpnew_rwei, lsm_inn, mtype, &
                         ndim, nstaval, nvalue, value_lpext, value_lpext1, vplp_w0, vplpnew_w0, w0_sdplp
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lri, lrk
integer(kind=iwp) :: ihypos, ihyposl, ihyposr, iiext, ilpend, ilpsta, ilw, in_, iplp, irw, isma, iw0, iwal, iwal0, iwar, iwar0, &
                     iwd, iwuplwei, lphead, nlp_value
real(kind=wp) :: w0_sdold, w0multi
real(kind=wp), parameter :: crl = 1.0e-8_wp
integer(kind=iwp), external :: iwalk_ad

isma = lsm_inn(lri)
iwuplwei = jpad_upwei(jpad)
ilsegdownwei = iseg_downwei(ipae)
irsegdownwei = iseg_downwei(ipael)
w0_sdplp = vplpnew_w0(1)
if (logic_dh) w0_sdplp = vplp_w0(1)

if (logic_grad) then
  call lp678_ext_calcuvalue_g(lri,lrk,isma,nlp_value)
  w0_sdold = w0_sdplp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w0_sdplp = vplpnew_w0(iw0)
      if (logic_dh) w0_sdplp = vplp_w0(iw0)
      if (abs(w0_sdplp) < crl) cycle
      w0multi = w0_sdplp/w0_sdold
      w0_sdold = w0_sdplp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
        value_lpext1(iiext) = value_lpext1(iiext)*w0multi
      end do
    end if
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 7) call gsd_sequence_extspace_g(irw,ilw)
        if (lin == 14) call gtd_sequence_extspace_g(irw,ilw)
        if (lin == 26) call gdv_sequence_extspace_g(irw,ilw)
      else
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 7) call gsd_sequence_extspace_g(irw,ilw)
            if (lin == 14) call gtd_sequence_extspace_g(irw,ilw)
            if (lin == 26) call gdv_sequence_extspace_g(irw,ilw)
          end do
        end do
      end if
    end do
  end do

else
  call lp678_ext_wyb_calcuvalue(lri,lrk,isma,nlp_value)
  w0_sdold = w0_sdplp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w0_sdplp = vplpnew_w0(iw0)
      if (logic_dh) w0_sdplp = vplp_w0(iw0)
      if (abs(w0_sdplp) < crl) cycle
      w0multi = w0_sdplp/w0_sdold
      w0_sdold = w0_sdplp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
      end do
    end if
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 7) call gsd_sequence_extspace(irw,ilw)
        if (lin == 14) call gtd_sequence_extspace(irw,ilw)
        if (lin == 26) call gdv_sequence_extspace(irw,ilw)
      else
        if (log_prod == 3) then
          lphead = lpnew_head(iplp)
          ihyposl = jphyl(lphead)
          ihyposr = jphy(lphead)
          ndim = ihyl(ihyposl)
        else
          ihyposl = jphy(iplp)
          ihyposr = ihyposl
          ndim = ihy(ihyposl)
        end if

        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihyposl+in_)
          iwar = iwar0+ihy(ihyposr+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 7) call gsd_sequence_extspace(irw,ilw)
            if (lin == 14) call gtd_sequence_extspace(irw,ilw)
            if (lin == 26) call gdv_sequence_extspace(irw,ilw)
          end do
        end do
      end if
    end do
  end do
end if

return

end subroutine ar_drl_ext_al_new

subroutine drr_br_ext_ar(lin,lrk,lri)

use gugaci_global, only: ihy, ihyl, ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, jphy, jphyl, &
                         log_prod, logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_head, lpnew_lwei, lpnew_rwei, lsm_inn, mtype, &
                         ndim, nstaval, nvalue, vplp_w0, vplpnew_w0, w0_sdplp
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lrk, lri
integer(kind=iwp) :: ihypos, ihyposl, ihyposr, ilpend, ilpsta, ilw, in_, iplp, irw, isma, iw0, iwal, iwal0, iwar, iwar0, iwd, &
                     iwuplwei, lphead, nlp_value
real(kind=wp), parameter :: crl = 1.0e-8_wp
integer(kind=iwp), external :: iwalk_ad

isma = lsm_inn(lri)
iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)

do iw0=1,mtype
  w0_sdplp = vplpnew_w0(iw0)
  if (logic_dh) w0_sdplp = vplp_w0(iw0)
  if (abs(w0_sdplp) < crl) cycle
  if (logic_grad) then
    call lp678_ext_calcuvalue_g(lri,lrk,isma,nlp_value)
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 6) call gsd_sequence_extspace_g(ilw,irw)
        if (lin == 13) call gtd_sequence_extspace_g(ilw,irw)
        if (lin == 23) call gdv_sequence_extspace_g(ilw,irw)
      else
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 6) call gsd_sequence_extspace_g(ilw,irw)
            if (lin == 13) call gtd_sequence_extspace_g(ilw,irw)
            if (lin == 23) call gdv_sequence_extspace_g(ilw,irw)
          end do
        end do
      end if
    end do

  else
    call lp678_ext_wyb_calcuvalue(lri,lrk,isma,nlp_value)
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 6) call gsd_sequence_extspace(ilw,irw)
        if (lin == 13) call gtd_sequence_extspace(ilw,irw)
        if (lin == 23) call gdv_sequence_extspace(ilw,irw)
      else
        if (log_prod == 3) then
          lphead = lpnew_head(iplp)
          ihyposl = jphyl(lphead)
          ihyposr = jphy(lphead)
          ndim = ihyl(ihyposl)
        else
          ihyposl = jphy(iplp)
          ihyposr = ihyposl
          ndim = ihy(ihyposl)
        end if

        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihyposl+in_)
          iwar = iwar0+ihy(ihyposr+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 6) call gsd_sequence_extspace(ilw,irw)
            if (lin == 13) call gtd_sequence_extspace(ilw,irw)
            if (lin == 23) call gdv_sequence_extspace(ilw,irw)
          end do
        end do
      end if
    end do
  end if
end do

return

end subroutine drr_br_ext_ar

subroutine ar_br_br_ext_ar_new(lin,intentry,isma)

use gugaci_global, only: ihy, ihyl, ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, jphy, jphyl, &
                         log_prod, logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_head, lpnew_lwei, lpnew_rwei, mtype, ndim, &
                         nstaval, nvalue, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sdplp, w1_sdplp
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, intentry, isma
integer(kind=iwp) :: ihypos, ihyposl, ihyposr, ilpend, ilpsta, ilw, in_, iplp, irw, iw0, iwal, iwal0, iwar, iwar0, iwd, iwuplwei, &
                     lphead, nlp_value
integer(kind=iwp), external :: iwalk_ad

iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)
do iw0=1,mtype
  w0_sdplp = vplpnew_w0(iw0)
  w1_sdplp = vplpnew_w1(iw0)
  if (logic_dh) w0_sdplp = vplp_w0(iw0)
  if (logic_dh) w1_sdplp = vplp_w1(iw0)
  if (logic_grad) then
    call lp10_arbrbr_ext_calcuvalue_g(intentry,isma,nlp_value)
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 6) call gsd_sequence_extspace_g(ilw,irw)
        if (lin == 13) call gtd_sequence_extspace_g(ilw,irw)
        if (lin == 23) call gdv_sequence_extspace_g(ilw,irw)
      else
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 6) call gsd_sequence_extspace_g(ilw,irw)
            if (lin == 13) call gtd_sequence_extspace_g(ilw,irw)
            if (lin == 23) call gdv_sequence_extspace_g(ilw,irw)
          end do
        end do
      end if
    end do

  else
    call lp10_arbrbr_ext_calcuvalue(intentry,isma,nlp_value)
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      if (logic_dh) then
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 6) call gsd_sequence_extspace(ilw,irw)
        if (lin == 13) call gtd_sequence_extspace(ilw,irw)
        if (lin == 23) call gdv_sequence_extspace(ilw,irw)
      else
        if (log_prod == 3) then
          lphead = lpnew_head(iplp)
          ihyposl = jphyl(lphead)
          ihyposr = jphy(lphead)
          ndim = ihyl(ihyposl)
        else
          ihyposl = jphy(iplp)
          ihyposr = ihyposl
          ndim = ihy(ihyposl)
        end if

        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihyposl+in_)
          iwar = iwar0+ihy(ihyposr+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 6) call gsd_sequence_extspace(ilw,irw)
            if (lin == 13) call gtd_sequence_extspace(ilw,irw)
            if (lin == 23) call gdv_sequence_extspace(ilw,irw)
          end do
        end do
      end if
    end do
  end if
end do

return

end subroutine ar_br_br_ext_ar_new

subroutine ar_bl_bl_ext_ar_new(lin,intentry,isma,nk)

use gugaci_global, only: ihy, ihyl, ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, jphy, jphyl, &
                         log_prod, logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_head, lpnew_lwei, lpnew_rwei, mtype, ndim, &
                         nstaval, nvalue, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sdplp, w1_sdplp
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, intentry, isma, nk
integer(kind=iwp) :: ihypos, ihyposl, ihyposr, ilpend, ilpsta, ilw, in_, iplp, irw, iw0, iwal, iwal0, iwar, iwar0, iwd, iwuplwei, &
                     lphead, nlp_value
integer(kind=iwp), external :: iwalk_ad

iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)
do iw0=1,mtype
  w0_sdplp = vplpnew_w0(iw0)
  w1_sdplp = vplpnew_w1(iw0)
  if (logic_dh) w0_sdplp = vplp_w0(iw0)
  if (logic_dh) w1_sdplp = vplp_w1(iw0)
  if (logic_grad) then
    call lp12_arblbl_ext_calcuvalue_g(intentry,isma,nlp_value)
    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                     !lp_head is in dbl_spa
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 6) call gsd_sequence_extspace_g(ilw,irw)
        if (lin == 13) call gtd_sequence_extspace_g(ilw,irw)
        if (lin == 23) call gdv_sequence_extspace_g(ilw,irw)
      else                                   !lp_head is in act_s
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 6) call gsd_sequence_extspace_g(ilw,irw)
            if (lin == 13) call gtd_sequence_extspace_g(ilw,irw)
            if (lin == 23) call gdv_sequence_extspace_g(ilw,irw)
          end do
        end do
      end if
    end do

  else
    call lp12_arblbl_ext_calcuvalue(intentry,isma,nlp_value)
    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                     !lp_head is in dbl_spa
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 6) call gsd_sequence_extspace(ilw,irw)
        if (lin == 13) call gtd_sequence_extspace(ilw,irw)
        if (lin == 23) call gdv_sequence_extspace(ilw,irw)
      else                                   !lp_head is in act_s
        if (log_prod == 3) then
          lphead = lpnew_head(iplp)
          ihyposl = jphyl(lphead)
          ihyposr = jphy(lphead)
          ndim = ihyl(ihyposl)
        else
          ihyposl = jphy(iplp)
          ihyposr = ihyposl
          ndim = ihy(ihyposl)
        end if

        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihyposl+in_)
          iwar = iwar0+ihy(ihyposr+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            if (lin == 6) call gsd_sequence_extspace(ilw,irw)
            if (lin == 13) call gtd_sequence_extspace(ilw,irw)
            if (lin == 23) call gdv_sequence_extspace(ilw,irw)
          end do
        end do
      end if
    end do
  end if
end do

return

end subroutine ar_bl_bl_ext_ar_new

subroutine drl_br_sum_al_new(lin,lrp,lrq,lri)   !to be revised

use gugaci_global, only: ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, logic_grad, lp_lwei, lp_rwei, lsm_inn, mtype, &
                         norb_dz, nstaval, nvalue, value_lpext, value_lpext1, vplp_w0, w0_sdplp
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lrp, lrq, lri
integer(kind=iwp) :: iiext, ilpend, ilpsta, ilw, iplp, irw, isma, iw0, lrk, nlp_value
real(kind=wp) :: w0_sdold, w0multi
real(kind=wp), parameter :: crl = 1.0e-8_wp

if (logic_grad) then
  do lrk=1,norb_dz
    if (lrp == lrk) cycle
    if (lrq == lrk) cycle
    ilsegdownwei = iseg_downwei(ipae)
    irsegdownwei = iseg_downwei(ipael)
    isma = lsm_inn(lri)
    w0_sdplp = vplp_w0(1)
    call lp8_drlbr_sum_calcuvalue_g(lri,lrk,isma,nlp_value)
    w0_sdold = w0_sdplp
    do iw0=1,mtype
      if (iw0 /= 1) then
        w0_sdplp = vplp_w0(iw0)
        if (abs(w0_sdplp) < crl) cycle
        w0multi = w0_sdplp/w0_sdold
        w0_sdold = w0_sdplp
        do iiext=1,nlp_value
          value_lpext(iiext) = value_lpext(iiext)*w0multi
          value_lpext1(iiext) = value_lpext1(iiext)*w0multi
        end do
      end if
      ilpsta = nstaval(iw0)+1
      ilpend = nstaval(iw0)+nvalue(iw0)
      do iplp=ilpsta,ilpend
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 7) call gsd_sequence_extspace_g(irw,ilw)
        if (lin == 14) call gtd_sequence_extspace_g(irw,ilw)
        if (lin == 26) call gdv_sequence_extspace_g(irw,ilw)
      end do
    end do
  end do

else
  ilsegdownwei = iseg_downwei(ipae)
  irsegdownwei = iseg_downwei(ipael)
  isma = lsm_inn(lri)
  w0_sdplp = vplp_w0(1)
  call lp8_drlbr_sum_calcuvalue_wyb(lri,lrp,lrq,isma,nlp_value)
  w0_sdold = w0_sdplp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w0_sdplp = vplp_w0(iw0)
      if (abs(w0_sdplp) < crl) cycle
      w0multi = w0_sdplp/w0_sdold
      w0_sdold = w0_sdplp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
      end do
    end if
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      ilw = lp_lwei(iplp)
      irw = lp_rwei(iplp)
      if (lin == 7) call gsd_sequence_extspace(irw,ilw)
      if (lin == 14) call gtd_sequence_extspace(irw,ilw)
      if (lin == 26) call gdv_sequence_extspace(irw,ilw)
    end do
  end do
end if

return

end subroutine drl_br_sum_al_new

subroutine drl_bl_sum_ar_new(lin,lrp,lrq,lri)

use gugaci_global, only: ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, logic_grad, lp_lwei, lp_rwei, lsm_inn, mtype, &
                         norb_dz, nstaval, nvalue, value_lpext, value_lpext1, vplp_w0, w0_sdplp
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lrp, lrq, lri
integer(kind=iwp) :: iiext, ilpend, ilpsta, ilw, iplp, irw, isma, iw0, lrk, nlp_value
real(kind=wp) :: w0_sdold, w0multi
real(kind=wp), parameter :: crl = 1.0e-8_wp

if (logic_grad) then
  do lrk=1,norb_dz
    if (lrp == lrk) cycle
    if (lrq == lrk) cycle
    isma = lsm_inn(lri)
    ilsegdownwei = iseg_downwei(ipael)
    irsegdownwei = iseg_downwei(ipae)
    w0_sdplp = vplp_w0(1)
    call lp9_drlbl_sum_calcuvalue_g(lri,lrk,isma,nlp_value)
    w0_sdold = w0_sdplp
    do iw0=1,mtype
      if (iw0 /= 1) then
        w0_sdplp = vplp_w0(iw0)
        if (abs(w0_sdplp) < crl) cycle
        w0multi = w0_sdplp/w0_sdold
        w0_sdold = w0_sdplp
        do iiext=1,nlp_value
          value_lpext(iiext) = value_lpext(iiext)*w0multi
          value_lpext1(iiext) = value_lpext1(iiext)*w0multi
        end do
      end if
      ilpsta = nstaval(iw0)+1
      ilpend = nstaval(iw0)+nvalue(iw0)
      do iplp=ilpsta,ilpend
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        if (lin == 6) call gsd_sequence_extspace_g(ilw,irw)
        if (lin == 13) call gtd_sequence_extspace_g(ilw,irw)
        if (lin == 23) call gdv_sequence_extspace_g(ilw,irw)
      end do
    end do
  end do

else
  isma = lsm_inn(lri)
  ilsegdownwei = iseg_downwei(ipael)
  irsegdownwei = iseg_downwei(ipae)
  w0_sdplp = vplp_w0(1)

  call lp9_drlbl_sum_calcuvalue_wyb(lri,lrp,lrq,isma,nlp_value)
  w0_sdold = w0_sdplp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w0_sdplp = vplp_w0(iw0)
      if (abs(w0_sdplp) < crl) cycle
      w0multi = w0_sdplp/w0_sdold
      w0_sdold = w0_sdplp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
      end do
    end if
    ilpsta = nstaval(iw0)+1
    ilpend = nstaval(iw0)+nvalue(iw0)
    do iplp=ilpsta,ilpend
      ilw = lp_lwei(iplp)
      irw = lp_rwei(iplp)
      if (lin == 6) call gsd_sequence_extspace(ilw,irw)
      if (lin == 13) call gtd_sequence_extspace(ilw,irw)
      if (lin == 23) call gdv_sequence_extspace(ilw,irw)
    end do
  end do
end if

return

end subroutine drl_bl_sum_ar_new

subroutine ar_bl_ext_ss(lri,lrj,nk)

use gugaci_global, only: ihy, ihyl, ilsegdownwei, iml, imr, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, &
                         jphy, logic_dh, logic_g13, logic_g1415, logic_g2g4b, logic_g34b, logic_g35b, logic_g36b, logic_grad, &
                         lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, mtype, ndim, nstaval, nvalue, value_lpext, value_lpext1, &
                         vplp_w0, vplpnew_w0, w0_plp, w1_plp
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, nk
integer(kind=iwp) :: ihypos, iiext, ilpend, ilpsta, ilw, imlr, in_, iplp, irw, iw0, iwal, iwal0, iwar, iwar0, iwd, iwuplwei, &
                     nlp_value
real(kind=wp) :: w0_old, w0multi
real(kind=wp), parameter :: crl = 1.0e-8_wp
integer(kind=iwp), external :: iwalk_ad

iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)
imlr = Mul(iml,imr)
if (imlr == 1) then
  logic_g1415 = .true.
  if (iml == 1) logic_g13 = .true.
  if (iml == 1) logic_g2g4b = .true.
  logic_g36b = .true.
  logic_g35b = .true.
  logic_g34b = .true.
end if

w0_plp = vplpnew_w0(1)
w1_plp = Zero
if (logic_dh) w0_plp = vplp_w0(1)

if (logic_grad) then
  call lp_arbl_ext_st_calcuvalue_g(lri,lrj,nlp_value)
  w0_old = w0_plp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w0_plp = vplpnew_w0(iw0)
      if (logic_dh) w0_plp = vplp_w0(iw0)
      if (abs(w0_plp) < crl) cycle
      w0multi = w0_plp/w0_old
      w0_old = w0_plp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
        value_lpext1(iiext) = value_lpext1(iiext)*w0multi
      end do
    end if

    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                    !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call inn_ext_ss_loop_unpack_g(ilw,irw)
      else                                  !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call inn_ext_ss_loop_unpack_g(ilw,irw)
          end do
        end do
      end if
    end do
  end do
else
  call lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
  w0_old = w0_plp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w0_plp = vplpnew_w0(iw0)
      if (logic_dh) w0_plp = vplp_w0(iw0)
      if (abs(w0_plp) < crl) cycle
      w0multi = w0_plp/w0_old
      w0_old = w0_plp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
      end do
    end if

    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                    !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call inn_ext_ss_loop_unpack(ilw,irw)
      else                                  !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call inn_ext_ss_loop_unpack(ilw,irw)
          end do
        end do
      end if
    end do
  end do
end if

return

end subroutine ar_bl_ext_ss

subroutine ar_bl_ext_st(lri,lrj,nk)     !w0=0

use gugaci_global, only: ihy, ihyl, ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, jphy, &
                         logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, mtype, ndim, nstaval, nvalue, &
                         value_lpext, value_lpext1, vplp_w1, vplpnew_w1, w0_plp, w1_plp
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, nk
integer(kind=iwp) :: ihypos, iiext, ilpend, ilpsta, ilw, in_, iplp, irw, iw0, iwal, iwal0, iwar, iwar0, iwd, iwuplwei, nlp_value
real(kind=wp) :: w0multi, w1_old
real(kind=wp), parameter :: crl = 1.0e-8_wp
integer(kind=iwp), external :: iwalk_ad

iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)
w0_plp = Zero
w1_plp = vplpnew_w1(1)
if (logic_dh) w1_plp = vplp_w1(1)

if (logic_grad) then
  call lp_arbl_ext_st_calcuvalue_g(lri,lrj,nlp_value)
  w1_old = w1_plp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w1_plp = vplpnew_w1(iw0)
      if (logic_dh) w1_plp = vplp_w1(iw0)
      if (abs(w1_plp) < crl) cycle
      w0multi = w1_plp/w1_old
      w1_old = w1_plp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
        value_lpext1(iiext) = value_lpext1(iiext)*w0multi
      end do
    end if

    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                    !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call inn_ext_st_loop_unpack_g(ilw,irw)
      else                                  !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call inn_ext_st_loop_unpack_g(ilw,irw)
          end do
        end do
      end if
    end do
  end do
else
  call lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
  w1_old = w1_plp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w1_plp = vplpnew_w1(iw0)
      if (logic_dh) w1_plp = vplp_w1(iw0)
      if (abs(w1_plp) < crl) cycle
      w0multi = w1_plp/w1_old
      w1_old = w1_plp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
      end do
    end if

    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                    !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call inn_ext_st_loop_unpack(ilw,irw)
      else                                  !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call inn_ext_st_loop_unpack(ilw,irw)
          end do
        end do
      end if
    end do
  end do
end if

return

end subroutine ar_bl_ext_st

subroutine ar_bl_ext_ts(lri,lrj,nk)

use gugaci_global, only: ihy, ihyl, ilsegdownwei, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, jphy, &
                         logic_dh, logic_grad, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, mtype, ndim, nstaval, nvalue, &
                         value_lpext, value_lpext1, vplp_w1, vplpnew_w1, w0_plp, w1_plp
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, nk
integer(kind=iwp) :: ihypos, iiext, ilpend, ilpsta, ilw, in_, iplp, irw, iw0, iwal, iwal0, iwar, iwar0, iwd, iwuplwei, nlp_value
real(kind=wp) :: w0multi, w1_old
real(kind=wp), parameter :: crl = 1.0e-8_wp
integer(kind=iwp), external :: iwalk_ad

iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)
w0_plp = Zero
w1_plp = vplpnew_w1(1)
if (logic_dh) w1_plp = vplp_w1(1)

if (logic_grad) then
  call lp_arbl_ext_st_calcuvalue_g(lri,lrj,nlp_value)
  w1_old = w1_plp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w1_plp = vplpnew_w1(iw0)
      if (logic_dh) w1_plp = vplp_w1(iw0)
      if (abs(w1_plp) < crl) cycle
      w0multi = w1_plp/w1_old
      w1_old = w1_plp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
        value_lpext1(iiext) = value_lpext1(iiext)*w0multi
      end do
    end if

    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                    !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call inn_ext_ts_loop_unpack_g(ilw,irw)
      else                                  !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call inn_ext_ts_loop_unpack_g(ilw,irw)
          end do
        end do
      end if
    end do
  end do
else
  call lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
  w1_old = w1_plp
  do iw0=1,mtype
    if (iw0 /= 1) then
      w1_plp = vplpnew_w1(iw0)
      if (logic_dh) w1_plp = vplp_w1(iw0)
      if (abs(w1_plp) < crl) cycle
      w0multi = w1_plp/w1_old
      w1_old = w1_plp
      do iiext=1,nlp_value
        value_lpext(iiext) = value_lpext(iiext)*w0multi
      end do
    end if

    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                    !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call inn_ext_ts_loop_unpack(ilw,irw)
      else                                  !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call inn_ext_ts_loop_unpack(ilw,irw)
          end do
        end do
      end if
    end do
  end do
end if

return

end subroutine ar_bl_ext_ts

subroutine ar_bl_ext_tt(lri,lrj,nk)

use gugaci_global, only: ihy, ihyl, ilsegdownwei, iml, imr, ipae, ipael, irsegdownwei, iseg_downwei, jpad, jpad_upwei, jpadl, &
                         jphy, logic_dh, logic_g1415, logic_g34b, logic_g35b, logic_g36b, logic_grad, lp_lwei, lp_rwei, &
                         lpnew_lwei, lpnew_rwei, mtype, ndim, nstaval, nvalue, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_plp, &
                         w1_plp
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, nk
integer(kind=iwp) :: ihypos, ilpend, ilpsta, ilw, imlr, in_, iplp, irw, iw0, iwal, iwal0, iwar, iwar0, iwd, iwuplwei, nlp_value
integer(kind=iwp), external :: iwalk_ad

iwuplwei = jpad_upwei(jpadl)
ilsegdownwei = iseg_downwei(ipael)
irsegdownwei = iseg_downwei(ipae)
imlr = Mul(iml,imr)
if (imlr == 1) then
  logic_g1415 = .true.
  logic_g36b = .true.
  logic_g35b = .true.
  logic_g34b = .true.
end if
do iw0=1,mtype
  w0_plp = vplpnew_w0(iw0)
  w1_plp = vplpnew_w1(iw0)
  if (logic_dh) w0_plp = vplp_w0(iw0)
  if (logic_dh) w1_plp = vplp_w1(iw0)

  if (logic_grad) then
    call lp_arbl_ext_st_calcuvalue_g(lri,lrj,nlp_value)
    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                    !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call inn_ext_tt_loop_unpack_g(ilw,irw)
      else                                  !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call inn_ext_tt_loop_unpack_g(ilw,irw)
          end do
        end do
      end if
    end do
  else
    call lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
    ilpsta = nstaval(iw0)*nk+1
    ilpend = (nstaval(iw0)+nvalue(iw0))*nk
    do iplp=ilpsta,ilpend
      if (logic_dh) then                    !lp_head is in dbl_space
        ilw = lp_lwei(iplp)
        irw = lp_rwei(iplp)
        call inn_ext_tt_loop_unpack(ilw,irw)
      else                                  !lp_head is in act_spa
        ihypos = jphy(iplp)
        ndim = ihy(ihypos)
        iwal0 = lpnew_lwei(iplp)
        iwar0 = lpnew_rwei(iplp)
        do in_=1,ndim
          iwal = iwal0+ihyl(ihypos+in_)
          iwar = iwar0+ihy(ihypos+in_)
          do iwd=0,iwuplwei-1
            ilw = iwalk_ad(jpadl,ipael,iwal,iwd)
            irw = iwalk_ad(jpad,ipae,iwar,iwd)
            call inn_ext_tt_loop_unpack(ilw,irw)
          end do
        end do
      end if
    end do

  end if
end do

return

end subroutine ar_bl_ext_tt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
*               2009, Grigory A. Shamov                                *
************************************************************************
      Subroutine xOPT(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object: To compute the GGA term of the OPTX exchange functional.     *
*     Note that it is GGA part only, without the LDA part.             *
*     Expressions derived with Maxima  from the formula taken from     *
*     ref: Handy, Cohen J. Mol.Phys 2001, 99, 403-412                  *
*                                                                      *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author:Per Ake Malmqvist, Department of Theoretical Chemistry,  *
*             University of Lund, SWEDEN. June 2006 (B88 code)         *
*             Grigory Shamov, U of Manitoba, Jan 2009                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),
     &       dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
cGLM     &       F_xca(mGrid),F_xcb(mGrid),tmpB(mGrid)

* IDORD=Order of derivatives to request from XPBE:
      idord=1
*
      Rho_Min=T_X*1.0D-2
*
      if (ispin.eq.1) then
* ispin=1 means spin zero.

* T_X: Screening threshold of total density.
        Ta=0.5D0*T_X
        do iGrid=1,mgrid
         rhoa=rho(ipR,iGrid)
         if(rhoa.lt.Ta) goto 110
         grdrhoa_x=rho(ipdRx,iGrid)
         grdrhoa_y=rho(ipdRy,iGrid)
         grdrhoa_z=rho(ipdRz,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2

         call OPTX_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*(2.0D0*Fa)
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*dFdrhoa
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*dFdgammaaa
* Note: For xpbe, dFdgammaab is zero.
 110     continue
        end do

      else
* ispin .ne. 1, use both alpha and beta components.

        do iGrid=1,mgrid
         rhoa=Max(Rho_Min,rho(ipRa,iGrid))
         rhob=Max(Rho_Min,rho(ipRb,iGrid))
         rho_tot=rhoa+rhob
         if(rho_tot.lt.T_X) goto 210
         grdrhoa_x=rho(ipdRxa,iGrid)
         grdrhoa_y=rho(ipdRya,iGrid)
         grdrhoa_z=rho(ipdRza,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         call OPTX_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)

         grdrhob_x=rho(ipdRxb,iGrid)
         grdrhob_y=rho(ipdRyb,iGrid)
         grdrhob_z=rho(ipdRzb,iGrid)
         sigmabb=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
         call OPTX_(idord,rhob,sigmabb,Fb,dFdrhob,dFdgammabb,
     &          d2Fdrb2,d2Fdrbdgbb,d2Fdgbb2)

         F_xc(iGrid)=F_xc(iGrid)+Coeff*(Fa+Fb)
cGLM         F_xca(iGrid)=F_xca(iGrid)+Coeff*(Fa)
cGLM         F_xcb(iGrid)=F_xcb(iGrid)+Coeff*(Fb)
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+Coeff*dFdrhoa
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+Coeff*dFdrhob
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
* Note: For xpbe, dFdgammaab is zero.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*dFdgammaaa
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*dFdgammabb
 210     continue
        end do
cGLM        call DCopy_(mGrid,F_xc,1,tmpB,1)

      end if

      Return
      End



      subroutine OPTX_(idord,rho_s,gamma_s, B88, dB88dr, dB88dg,
     & d2B88dr2, d2B88drdg, d2B88dg2)
C      needs 1.05151 coefficient for the Dirac part!
      implicit None
      integer idord
      real*8 rho_s, gamma_s, B88, dB88dr, dB88dg
      real*8 d2B88dr2, d2B88drdg, d2B88dg2
C
      real*8 rho, gamma, y, one, four
      parameter(one=1.0d0)
      parameter(four=4.0d0)
      parameter(y=0.006d0)
C      parameter(bcoef=1.43169d0) for
C      OPTX coeff moved outside, to allow for O3LYP and O2PLYP and KT3
      real*8 T1,T2,T3,T4,T5,T6,T7,T8,T9,T10

      rho=rho_s+1.0D-16
      gamma=gamma_s+1.0D-16

      T1=one/rho**4
      T2=gamma**2
      T3=   6.0d-3*gamma/rho**(8.0d+0/3.0d+0)+1
      T4=one/T3**2
      T5=one/rho**(2.3d+1/3.0d+0)
      T6=gamma**3
      T7=one/T3**3
      T8=one/rho**5
      T9=one/rho**(2.0d+1/3.0d+0)
      T10=one/T3**4

      B88 = -3.60d-5*T1*T2*T4

      if(idord.lt.1) goto 99

      dB88Dr = 1.44d-4*T8*T2*T4-1.1520d-6*T5*T6*T7
      dB88Dg = 4.32d-7*T9*T2*T7-7.20d-5*T1*gamma*T4


      if(idord.lt.2) goto 99

      d2B88dr2 = -7.20d-4*T2*T4/rho**6+1.34400
     7  00d-5*T6*T7/rho**(2.6d+1/3.0d+0)-5.52960d-8*gamma*
     8  *4*T10/rho**(3.4d+1/3.0d+0)

      d2B88drdg = 2.8800d-4*T
     9  8*gamma*T4-5.18400d-6*T5*T2*T7+2.073600d-8
     =  *T6*T10/rho**(3.1d+1/3.0d+0)

      d2B88dg2 = -7.200d-5*
     ;  T1*T4+1.728d-6*T9*gamma*T7-7.77600d-9*T2*T10/rho**(2
     <  .8d+1/3.0d+0)


 99   continue

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine Remove_TR(nQ,nX,nQQ,KMat,nK,TRVec,nTR,BM,iBM,nqB,nB)
      Implicit None
      Integer :: nQ,nX,nQQ,nK,nTR,nB
      Real*8 :: KMat(nQ,nK),TRVec(nX,nTR),BM(nB)
      Integer :: iBM(nB),nqB(nQ)
#include "real.fh"
#include "stdalloc.fh"
      Integer :: i,iK,iX,iQ,iB,iTR,iV
      Real*8, Dimension(:), Allocatable :: VecInt,TR
      Real*8, External :: DDot_

      Call mma_allocate(TR,nK)
      Call mma_allocate(VecInt,nX)

      Call FZero(TR,nK)

      Do iK=1,nK
*
*       Get the normalized Cartesian vector for this internal coordinate
        Call FZero(VecInt,nX)
        iB=0
        Do iQ=1,nQ
          Do i=1,nqB(iQ)
            iB=iB+1
            iX=iBM(iB)
            VecInt(iX)=VecInt(iX)+KMat(iQ,iK)*BM(iB)
          End Do
        End Do
        Call dScal_(nX,One/Sqrt(dDot_(nX,VecInt,1,VecInt,1)),VecInt,1)
*
*       Compute the overlap with the external translations and rotations
        Do iTR=1,nTR
          TR(iK)=TR(iK)+dDot_(nX,VecInt,1,TRvec(1,iTR),1)**2
        End Do
      End Do
*
*     Put the nK-nQQ vectors with largest overlap at the end
      Do iK=nK,nQQ+1,-1
        iV=MaxLoc(TR(1:iK),1)
        If (iV.ne.iK) Call dSwap_(nQ,KMat(1,iK),1,KMat(1,iV),1)
      End Do

      Call mma_deallocate(TR)
      Call mma_deallocate(VecInt)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine oohess_cvb(orbs,civecp,civbs,civb,orbinv,sorbs,owrk,grad2,gradx,hessorb,hesst)
! Evaluate "cheap" orbital <-> orbital part of hessian:

use casvb_global, only: aa1, f1, f2, icrit, ndet, norb, npr, nprorb, oaa2, ovraa, proj, projcas, ww
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: orbs(norb,norb), civb(0:ndet), grad2(npr), gradx(norb,norb)
real(kind=wp), intent(inout) :: civecp(0:ndet), civbs(0:ndet)
real(kind=wp), intent(out) :: orbinv(norb,norb), sorbs(norb,norb), owrk(norb,norb), hessorb(nprorb,nprorb), &
                              hesst(norb*norb,norb*norb)
integer(kind=iwp) :: ifr1, ifr2, iorb, iprm, iprm1, iprm2, jorb, korb, lorb
real(kind=wp) :: aa1_use, oaa2_use

if (icrit == 1) then
  oaa2_use = oaa2
  aa1_use = aa1
else if (icrit == 2) then
  oaa2_use = f2
  aa1_use = f1
end if

hessorb(:,:) = Zero
if ((icrit == 1) .and. (.not. (proj .or. projcas))) then
  call dev2b_cvb(civbs,civecp,civb,hessorb,hesst,oaa2_use,aa1_use,gradx,grad2)

  call mxattb_cvb(orbs,orbs,norb,norb,norb,sorbs)
  orbinv(:,:) = sorbs(:,:)
  call mxinv_cvb(orbinv,norb)

  do jorb=1,norb
    do iorb=1,norb
      iprm = iorb+(jorb-1)*norb
      call mxatb_cvb(orbinv,hesst(:,iprm),norb,norb,norb,owrk)
      call mxatb_cvb(owrk,sorbs,norb,norb,norb,hesst(:,iprm))
    end do
  end do
  iprm1 = 0
  do iorb=1,norb
    do jorb=1,norb
      if (jorb == iorb) cycle
      iprm1 = iprm1+1
      ifr1 = jorb+(iorb-1)*norb
      iprm2 = 0
      do korb=1,norb
        do lorb=1,norb
          if (lorb == korb) cycle
          iprm2 = iprm2+1
          ifr2 = korb+(lorb-1)*norb
          if (iprm2 <= iprm1) then
            hessorb(iprm2,iprm1) = hessorb(iprm2,iprm1)+oaa2_use*hesst(ifr2,ifr1)
            hessorb(iprm1,iprm2) = hessorb(iprm2,iprm1)
          end if
        end do
      end do
    end do
  end do
else if (icrit == 1) then
  call dev2a_cvb(civbs,civecp,civb,hessorb,oaa2_use,aa1_use)
else
  call cidaxpy_cvb(-ww/ovraa,civbs,civecp)
  call cizero_cvb(civbs)
  call dev2c_cvb(civecp,civb,hessorb,aa1_use)
end if

return

end subroutine oohess_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RDMCCI(JOB,IDISP,LABEL,ISYMP,NARRAY,ARRAY)
! Purpose: Read in the derivatives of CI array derivatives
! from MCKINT file, with respect to some displacement IDISP.
! ISYMP is the symmetry irrep label of the derivatives.

use rassi_aux, only: ipglob
use Cntrl, only: LuMck, MINAME, NCONF1, NJOB
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: JOB, IDISP, ISYMP, nArray
character(len=8), intent(inout) :: LABEL
real(kind=wp), intent(out) :: ARRAY(NARRAY)
integer(kind=iwp) :: IOPT, IRC, ISCODE, NTEMP
real(kind=wp), allocatable :: TEMP(:)

if ((JOB < 1) .or. (JOB > NJOB)) then
  write(u6,*) ' RDMCI: Invalid JOB parameter.'
  write(u6,*) ' JOB:',JOB
  call ABEND()
end if

if (IPGLOB >= 3) then
  write(u6,*) ' RDMCCI called for JOB=',JOB
  write(u6,*) ' perturbed by displacement nr.',IDISP
  write(u6,*) ' MckInt file name:',MINAME(JOB)
  write(u6,*) ' Irrep label   ISYMP=',ISYMP
  write(u6,*) ' Length NARRAY=',NARRAY
end if

! Open MCKINT file:
IRC = -1
IOPT = 0
call OPNMCK(IRC,IOPT,MINAME(JOB),LUMCK)
if (IRC /= 0) then
  write(u6,*) 'RDMCCI: Failed to open '//MINAME(JOB)
  write(u6,*) 'Unit nr LUMCK=',LUMCK
  write(u6,*) 'Option code IOPT=',IOPT
  write(u6,*) 'Return code IRC =',IRC
  call ABEND()
end if

! Read MCKINT file:
NTEMP = NCONF1
IOPT = 0
ISCODE = 2**(ISYMP-1)
! Get temporary buffer to read data by RDMCK calls
call mma_allocate(TEMP,NTEMP,Label='TEMP')
! Read 1-electron integral derivatives:
IRC = NTEMP
call dRDMCK(IRC,IOPT,LABEL,IDISP,TEMP,ISCODE)
if (IRC /= 0) then
  write(u6,*) 'RDMCCI: RDMCCI failed to read '//MINAME(JOB)
  write(u6,*) '  Displacement IDISP=',IDISP
  write(u6,*) '    Option code IOPT=',IOPT
  write(u6,*) 'Symmetry code ISCODE=',ISCODE
  write(u6,*) '    Return code IRC =',IRC
  call ABEND()
end if

if (NTEMP > NARRAY) then
  write(u6,*) 'RDMCCI: Output ARRAY has insufficient length.'
  write(u6,*) ' Input parameter NARRAY=',NARRAY
  write(u6,*) ' Needed size       NTEMP=',NTEMP
  call ABEND()
end if
! Move buffer integrals into ARRAY in proper format:
ARRAY(1:NTEMP) = TEMP(:)
! Get rid of temporary buffer
call mma_deallocate(TEMP)

! Close MCKINT file:
IRC = -1
IOPT = 0
call CLSMCK(IRC,IOPT)
if (IRC /= 0) then
  write(u6,*) 'RDMCCI: Failed to close '//MINAME(JOB)
  write(u6,*) 'Unit nr LUMCK=',LUMCK
  write(u6,*) 'Option code IOPT=',IOPT
  write(u6,*) 'Return code IRC =',IRC
  call ABEND()
end if

end subroutine RDMCCI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MltGrdNuc(Grad,nGrad,nOrdOp)
      use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "print.fh"
#include "real.fh"
#include "disp.fh"
      Real*8 Grad(nGrad),C(3)
      parameter (lforce=20)
      real*8 Force(lforce)
      common /finfld/Force
*
      logical TstFnc,TF
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*
      iIrrep=0
      do 800 ixop=0,nOrdOp
      do 801 iyop=0,nOrdOp-ixop
      izop=nOrdOp-ixop-iyop
      icomp=Ind(nOrdOp,ixop,izop)
      ff=Force(icomp)
      if(ff.eq.0.d0) goto 801
        kdc = 0
        Do kCnttp = 1, nCnttp
           If (dbsc(kCnttp)%Charge.eq.0.d0) Go To 411
           Do kCnt = 1, dbsc(kCnttp)%nCntr
              C(1:3)=dbsc(kCnttp)%Coor(1:3,kCnt)
              ndc=kdc+kCnt
              Fact=-dbsc(kCnttp)%Charge*ff
              nDisp = IndDsp(ndc,iIrrep)
              Do iCar = 0, 2
                iComp = 2**iCar
                If ( TF(ndc,iIrrep,iComp) .and.
     &              .Not.dbsc(kCnttp)%pChrg ) Then
                  nDisp = nDisp + 1
                  If (Direct(nDisp)) Then
                   XGrad=0.d0
                   if(iCar.eq.0) then
                     if(ixop.gt.0) XGrad=Fact*Dble(ixop)*C(1)**(ixop-1)*
     &                              C(2)**iyop*C(3)**izop
                   else if(iCar.eq.1) then
                     if(iyop.gt.0) XGrad=Fact*Dble(iyop)*C(1)**ixop*
     &                              C(2)**(iyop-1)*C(3)**izop
                   else
                    if(izop.gt.0) XGrad=Fact*Dble(izop)*C(1)**ixop*
     &                              C(2)**iyop*C(3)**(izop-1)
                   endif
                   Grad(nDisp)=Grad(nDisp)+XGrad
                  End If
                End If
             Enddo
           Enddo
411     kdc = kdc + dbsc(kCnttp)%nCntr
        Enddo
801   continue
800   continue

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GETINT_MCLR(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,IXCHNG,IKSM,JLSM,ICOUL,ieaw)
! Outer routine for accessing integral block

use MCLR_Data, only: KINT2, KINT2A, Square
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Index_Functions, only: nTri_Elem
use MCLR_Data, only: NOBPTS
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: XINT(*)
integer(kind=iwp), intent(in) :: ITP, ISM, JTP, JSM, KTP, KSM, LTP, LSM, IXCHNG, IKSM, JLSM, ICOUL, ieaw
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: nI, nIJ, nIK, nJ, nJL, nK, nKL, nL
#endif

if (.not. square) then
  if (ieaw /= 0) then
    call GETINC_ABT(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,IXCHNG,IKSM,JLSM,KINT2a,ICOUL,ieaw)
  else
    call GETINC_ABT(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,IXCHNG,IKSM,JLSM,KINT2,ICOUL,ieaw)
  end if
else
  call GETINC_ABS(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,IXCHNG,KINT2,ICOUL)
end if

#ifdef _DEBUGPRINT_
NI = NOBPTS(ITP,ISM)
NK = NOBPTS(KTP,KSM)
if (IKSM == 0) then
  NIK = NI*NK
else
  NIK = nTri_Elem(NI)
end if
NJ = NOBPTS(JTP,JSM)
NL = NOBPTS(LTP,LSM)
if (JLSM == 0) then
  NJL = NJ*NL
else
  NJL = nTri_Elem(NJ)
end if
if (ICOUL == 0) then
  write(u6,*) ' 2 electron integral block for TS blocks'
  write(u6,*) ' Ixchng :',IXCHNG
  write(u6,'(1X,4(A,I2,A,I2,A))') '(',ITP,',',ISM,')','(',JTP,',',JSM,')','(',KTP,',',KSM,')','(',LTP,',',LSM,')'
  call WRTMAT(XINT,NIK,NJL,NIK,NJL)
else
  write(u6,*) ' Integrals in Coulomb form'
  write(u6,'(1X,4(A,I2,A,I2,A))') '(',ITP,',',ISM,')','(',JTP,',',JSM,')','(',KTP,',',KSM,')','(',LTP,',',LSM,')'
  NIJ = NI*NJ
  NKL = NK*NL
  call WRTMAT(XINT,NIJ,NKL,NIJ,NKL)
end if
#endif

end subroutine GETINT_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dmrg_dim_change_mclr(orbspc,ndim,iflag)

use Index_Functions, only: nTri_Elem
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: orbspc(8), iflag
integer(kind=iwp), intent(out) :: ndim

!write(u6,*) '==================================================='
!write(u6,*) ' Currently, only valid for no symmetry calculation'
!write(u6,*) '==================================================='

! I remember it was already valid for all symmetry.
!                  -- yma, need check it again 2015.5.14

!write(u6,*) 'orbspc',orbspc(1:8)

select case (iflag)
  case (0)
    ndim = sum(orbspc(:))
  case (1)
    ndim = orbspc(1)**2
  case (2)
    ndim = orbspc(1)**4
  case (3)
    ndim = nTri_Elem(orbspc(1))
  case (4)
    ndim = nTri_Elem(orbspc(1)**2)
  case default
    ndim = 0
    write(u6,*) 'unknow iflag'
    call Quit_OnUserError()
end select

end subroutine dmrg_dim_change_mclr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Do_Lobatto(L_Eff,nPoints,ipR)
************************************************************************
*                                                                      *
*     Computes datas useful for the angular quadrature.                *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "nq_info.fh"
#include "real.fh"
#include "WrkSpc.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Statement Function
*
      Pax(i) = Work(ip_O-1+i)
*                                                                      *
************************************************************************
*                                                                      *
*---- Generate angular grid a la Lobatto
*
      nPoints=0
      nTheta = (L_Eff+3)/2
      Do iTheta = 1, nTheta
         nPhi = L_Eff
         If(iTheta.eq.1.or.iTheta.eq.nTheta) nPhi = 1
         If(iTheta.eq.nTheta/2+1.and.nTheta/2*2-nTheta.eq.-1.and.
     &                         nTheta.gt.3)  nPhi = L_Eff+4
*
         nPoints = nPoints + nPhi
*
      End Do
*
      Call GetMem('AngRW','Allo','Real',ipR,4*nPoints)
*
      nTheta = (L_Eff+3)/2
      nLabatto=3*(nTheta+2)*(nTheta+3)/2
      Call GetMem('Labatto','Allo','Real',ipLabatto,nLabatto)
      Call Lobatto(ntheta,Work(ipLabatto))
*
      mTheta=nTheta-1
      iOffT=ipLabatto + 3*mTheta*(mTheta+1)/2
      iOff   = ipR
      Do iTheta = 1, nTheta
*
         Cos_Theta=Work(iOffT)
         Sin_Theta=Sqrt(One-Cos_Theta**2)
         w_Theta  =Work(iOffT+1)
         iOffT = iOffT + 3
*
         nPhi = L_Eff
         if(iTheta.eq.1.or.iTheta.eq.nTheta) nPhi = 1
         if(iTheta.eq.nTheta/2+1.and.nTheta/2*2-nTheta.eq.-1.and.
     &                         nTheta.gt.3)  nPhi = L_Eff+4
*
         Do iPhi = 1, nPhi
            Call Phi_point(iPhi,nPhi,Cos_Phi,Sin_Phi,w_Phi)
*
            x = Sin_Theta*Cos_Phi
            y = Sin_Theta*Sin_Phi
            z = Cos_Theta
            Work(iOff  )=Pax(1)*x+Pax(4)*y+Pax(7)*z
            Work(iOff+1)=Pax(2)*x+Pax(5)*y+Pax(8)*z
            Work(iOff+2)=Pax(3)*x+Pax(6)*y+Pax(9)*z
            Work(iOff+3)=w_Theta*w_Phi
            iOff = iOff + 4
*
         End Do  ! iPhi
*
      End Do     ! iTheta
      Call GetMem('Labatto','Free','Real',ipLabatto,nLabatto)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine IniCho_RI_Xtras(iTOffs,nIrrep,iShij,nShij)

use ChoArr, only: iRS2F, nDimRS
use ChoSwp, only: iiBstRSh, IndRed, IndRed_Hidden, IndRSh, IndRSh_Hidden, nnBstRSh
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nIrrep, iTOffs(3,nIrrep), nShij, iShij(2,nShij)
#include "cholesky.fh"
integer(kind=iwp) :: i, iCount, iiBst(8), iSym, nnBst(8), nnBstT
logical(kind=iwp) :: DoDummy

! Define max. dimensions and offsets of the symmetry blocks of the
! integrals matrix.
! ----------------------------------------------------------------

iCount = 0
do iSym=1,nSym
  iiBst(iSym) = iCount
  nnBst(iSym) = iTOffs(3,iSym)
  iCount = iCount+nnBst(iSym)
end do

! Set dimensions of reduced sets equal to full dimension.
! -------------------------------------------------------

do i=1,3
  nnBstT = 0
  do iSym=1,nSym
    iiBstR(iSym,i) = iiBst(iSym)
    nnBstR(iSym,i) = nnBst(iSym)
    nnBstT = nnBstT+nnBstR(iSym,i)
  end do
  nnBstRT(i) = nnBstT
end do
mmBstRT = nnBstRT(1)

! Allocate index arrays for reduced sets: IndRed and IndRsh.
! ----------------------------------------------------------

call mma_allocate(IndRed_Hidden,nnBstRT(1),3,Label='IndRed_Hidden')
IndRed => IndRed_Hidden
call mma_allocate(IndRSh_Hidden,nnBstRT(1),Label='IndRSh_Hidden')
IndRSh => IndRSh_Hidden

! Allocate iScr array used by reading routines.
! ---------------------------------------------

DoDummy = .false.
call Cho_Allo_iScr(DoDummy)

! Initialize reduced set dimensions used for reading vectors.
! (Note: here they are all the same - there is one reduced sets!)
! ---------------------------------------------------------------

do i=1,MaxRed
  nDimRS(1:nSym,i) = nnBstR(1:nSym,1)
end do

! Allocate and set mapping array from 1st reduced set to full storage.
! --------------------------------------------------------------------

call mma_allocate(iRS2F,2,nnBstRT(1),Label='iRS2F')

! Set index arrays corresponding to full storage:
! iiBstRSh, nnBstRSh, IndRed, IndRSh, and iRS2F.
! -----------------------------------------------

call SetChoIndx_RI(iiBstRSh,nnBstRSh,IndRed,IndRsh,iRS2F,nSym,nnShl,nnBstRT(1),iShij,nShij)

return

end subroutine IniCho_RI_Xtras

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SPHPUR_m(CMO)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CMO(*)
      CHARACTER*1 LCHAR
      DIMENSION WGTLQN(0:9)
      LOGICAL IFTEST
* Define mxsym etc.
#include "rasdim.fh"
* general.fh defines NSYM,NBAS,NORB:
#include "general.fh"
* rasscf.fh defines NAME:
#include "rasscf.fh"
* angtp.fh defines ITABMX,ANGTP
#include "angtp.fh"

#include "WrkSpc.fh"

* Set IFTEST=.true. to get supsym input generated in the output
* for further use, or for testing.
      IFTEST=.false.
      IF(IFTEST) WRITE(6,*)'SUPSYM'

* Set up array with angular quant num for each basis function:
      NBTOT=0
      DO ISYM=1,NSYM
       NBTOT=NBTOT+NBAS(ISYM)
      END DO
      CALL GETMEM('LQN','ALLO','INTE',LLQN,NBTOT)
      DO IBAS=1,NBTOT
       LCHAR=NAME(IBAS)(LENIN3:LENIN3)
       L=-999999
       DO ITP=0,ITABMX
         IF(LCHAR.EQ.ANGTP(ITP)) L=ITP
       END DO
       IWORK(LLQN-1+IBAS)=L
      END DO
      ICMOES=0
      IBASES=0
      IORBES=0
      DO ISYM=1,NSYM
       NB=NBAS(ISYM)
       NO=NORB(ISYM)
       IF(NO.EQ.0) GOTO 100
       DO IO=1,NO
        IORB=IORBES+IO
        DO L=0,9
         WGTLQN(L)=0.0D0
        END DO
        DO IB=1,NB
         IBAS=IBASES+IB
         L=IWORK(LLQN-1+IBAS)
         WGT=CMO(ICMOES+IB+NB*(IO-1))**2
         WGTLQN(L)=WGTLQN(L)+WGT
        END DO
        LMX=0
        WMX=WGTLQN(0)
        DO L=0,9
         IF(WGTLQN(L).GT.WMX) THEN
           LMX=L
           WMX=WGTLQN(L)
         END IF
        END DO
        IXSYM(IORB)=LMX
       END DO
* We have now a provisional IXSYM array. How many different
* L values appear in it?
       MNL=9
       MXL=0
       NONZ=0
       DO L=0,9
        LEXIST=0
        DO IO=1,NO
         IORB=IORBES+IO
         IF(L.EQ.IXSYM(IORB))THEN
          LEXIST=1
          MNL=MIN(L,MNL)
          MXL=MAX(L,MXL)
          GOTO 19
         END IF
        END DO
  19    CONTINUE
        NONZ=NONZ+LEXIST
       END DO
* There are NONZ different values, so we want NONZ-1 special supsym
* labels for this symmetry. Reuse IWORK(LLQN) for orbital numbers:
* This will be the supsym label:
       IF (IFTEST) WRITE(6,*) NONZ-1
       ISSLAB=0
       DO L=MNL,MXL
        LCOUNT=0
        DO IO=1,NO
         IORB=IORBES+IO
         IF(L.EQ.IXSYM(IORB))THEN
          LCOUNT=LCOUNT+1
          IWORK(LLQN-1+LCOUNT)=IO
         END IF
        END DO
        IF(LCOUNT.GT.0) THEN
* Replace provisional IXSYM value with correct label:
          DO IO=1,NO
           IORB=IORBES+IO
           IF(IXSYM(IORB).eq.L) IXSYM(IORB)=ISSLAB
          END DO
* Lowest L = label zero = do not specify in input:
          IF (IFTEST.and.(ISSLAB.GT.0)) THEN
           WRITE(6,'(1x,I3,16I5,(/,5X,16I5))') LCOUNT,
     &         (IWORK(LLQN+i),i=0,LCOUNT-1)
          END IF
          ISSLAB=ISSLAB+1
        END IF
       END DO

       ICMOES=ICMOES+NO*NB
       IORBES=IORBES+NO
 100   CONTINUE
       IBASES=IBASES+NB
      END DO
      CALL GETMEM('LQN','FREE','INTE',LLQN,NBTOT)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine mk_DeDe(FD,nFD,mFD,ipOffD,nOffD,ipDeDe,ipD00,MaxDe,mDeDe,mIndij,Special_NoSym,DFT_Storage,DeDe,nDeDe)
!***********************************************************************
!                                                                      *
! Object: to decontract, desymmetrize the 1st order density matrix.    *
!         The memory at this point is assumed to be large enough to do *
!         the computation in core.                                     *
!         The data is structured with respect to four indices, two (my *
!         ny or i j) refer to primitives or basis functions and two (a *
!         b) refer to the components of the cartesian or spherical     *
!         harmonic gaussians.                                          *
!                                                                      *
!         The indices are here ordered canonically!!!                  *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!             Modified for Hermite-Gauss quadrature November '90       *
!             Modified for Rys quadrature November '90                 *
!             Modified for multipole moments November '90              *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for general kernel routines January '91         *
!             Modified for nonsymmetrical operators February '91       *
!             Modified for gradients October '91                       *
!             Modified to process 1st order density matrices, Dec. '92 *
!***********************************************************************

use Index_Functions, only: iTri
use iSD_data, only: iSD
use Basis_Info, only: MolWgh, Shells
use Center_Info, only: DC
use Symmetry_Info, only: iOper, nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6
#ifdef _DEBUGPRINT_
use Index_Functions, only: nTri_Elem
use define_af, only: AngTp
use Basis_Info, only: nBas
use Symmetry_Info, only: ChOper
#endif

implicit none
integer(kind=iwp), intent(in) :: nFD, mFD, nOffD, ipDeDe, MaxDe, nDeDe
real(kind=wp), intent(in) :: FD(nFD,mFD)
integer(kind=iwp), intent(out) :: ipOffD(2+mFD,nOffD), mDeDe, mIndij
logical(kind=iwp), intent(in) :: Special_NoSym, DFT_Storage
real(kind=wp), intent(inout) :: DeDe(nDeDe)
integer(kind=iwp) :: i, iAO, iAOi, iBas, iBasi, iCmp, iCmpi, iDCRR(0:7), iFD, iHigh, ij, ijCmp, ijShll, ipD00, iPrim, iPrimi, &
                     ipStart, iS, iSh, iShell, iShll, iSmLbl, iuv, j, jAO, jAOj, jBas, jBasj, jCMp, jCmpj, jOffD, jpDAO, jPrim, &
                     jPrimj, jS, jSh, jShell, jShll, lDCRR, LmbdR, mdci, mdcj, nDCRR, nOp(2), nSkal, nSO
real(kind=wp) :: FactND, Temp
real(kind=wp), allocatable :: DAO(:), DSO(:), DSOc(:), DSOp(:), Scrt(:)
integer(kind=iwp), external :: iDAMax_, MemSO1, n2Tri, NrOpr
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iIrrep, jFD
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' Differential 1st order density matrix'
iFD = 1
do iIrrep=0,nIrrep-1
  write(u6,*)
  write(u6,*) 'iIrrep=',iIrrep
  do jFD=1,mFD
    write(u6,*) 'jFD=',jFD
    write(u6,*)
    call TriPrt(' Diagonal block',' ',FD(iFD,jFD),nBas(iIrrep))
  end do
  iFD = iFD+nTri_Elem(nBas(iIrrep))
end do
#endif

mIndij = 0
jOffD = 0
ipOffD(1,:) = ipD00
ipOffD(2,:) = nIrrep
ipOffD(3,:) = MaxDe
if (mFD == 2) ipOffD(4,:) = ipD00
!                                                                      *
!***********************************************************************
!                                                                      *
call Nr_Shells(nSkal)
!                                                                      *
!***********************************************************************
!                                                                      *
! Double loop over shells. These loops decide the integral type
! i.e. (dd), (dp), (pp), etc. This is the ab index.

do iS=1,nSkal
  iShll = iSD(0,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  mdci = iSD(10,iS)
  iShell = iSD(11,iS)

  do jS=1,iS
    jShll = iSD(0,jS)
    jCmp = iSD(2,jS)
    jBas = iSD(3,jS)
    jPrim = iSD(5,jS)
    jAO = iSD(7,jS)
    mdcj = iSD(10,jS)
    jShell = iSD(11,jS)
    ijShll = iTri(iShell,jShell)

    iSmLbl = 1
    nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
    if (nSO == 0) cycle
    !                                                                  *
    !*******************************************************************
    !                                                                  *
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iS,jS=',iS,jS
    write(u6,'(A,A,A,A,A)') ' ***** (',AngTp(iSD(1,iS)),',',AngTp(iSD(1,jS)),') *****'
#   endif

    call mma_allocate(DAO,max(iBas*jBas,iPrim*jPrim)*iCmp*jCmp,label='DAO')

    !-------Find the DCR for A and B

    iDCRR(0:nIrrep-1) = iOper(0:nIrrep-1)
    nDCRR = nIrrep
    LmbdR = 1
#   ifdef _DEBUGPRINT_
    write(u6,'(10A)') ' {R}=(',(ChOper(iDCRR(i)),i=0,nDCRR-1),')'
#   endif

    ! Compute normalization factor due the DCR symmetrization
    ! of the two basis functions and the operator.

    iuv = dc(mdci)%nStab*dc(mdcj)%nStab
    FactNd = real(iuv,kind=wp)/real(nIrrep*LmbdR,kind=wp)
    if (MolWgh == 1) then
      FactNd = FactNd*real(nIrrep,kind=wp)/real(iuv,kind=wp)
    else if (MolWgh == 2) then
      FactNd = sqrt(real(iuv,kind=wp))*real(nIrrep,kind=wp)/real(LmbdR,kind=wp)
    end if

    ! Allocate memory for the elements of the Fock or 1st order
    ! density matrix which are associated with the current shell
    ! pair.

    call mma_allocate(DSOp,nSO*iPrim*jPrim,label='DSOp')
    call mma_allocate(DSOc,nSO*iBas*jBas,label='DSOc')
    call mma_allocate(DSO,nSO*iPrim*jPrim,label='DSO')
    call mma_allocate(Scrt,max(iBas*jBas,iPrim*jPrim),label='Scrt')

    ! Introduce canonical order for the contracted basis

    if (iShell >= jShell) then
      iSh = iShell
      jSh = jShell
      iAOi = iAO
      jAOj = jAO
      iBasi = iBas
      jBasj = jBas
      iPrimi = iPrim
      jPrimj = jPrim
      iCmpi = iCmp
      jCmpj = jCmp
    else
      iSh = jShell
      jSh = iShell
      iAOi = jAO
      jAOj = iAO
      iBasi = jBas
      jBasj = iBas
      iPrimi = jPrim
      jPrimj = iPrim
      iCmpi = jCmp
      jCmpj = iCmp
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Loop over the density and the spin-density (optional)

    do iFD=1,mFD
#     ifdef _DEBUGPRINT_
      if (iFD == 1) then
        write(u6,*) 'Processing the density'
      else
        write(u6,*) 'Processing the spin-density'
      end if
#     endif
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Gather the elements from 1st order density / Fock matrix.

      call SOGthr(DSOc,iBasi,jBasj,nSO,FD(1,iFD),n2Tri(iSmLbl),iSmLbl,iCmpi,jCmpj,iSh,jSh,iAOi,jAOj)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Project the Fock/1st order density matrix in AO
      ! basis on to the primitive basis.

#     ifdef _DEBUGPRINT_
      call RecPrt(' Left side contraction',' ',Shells(iShll)%pCff,iPrimi,iBasi)
      call RecPrt(' Right side contraction',' ',Shells(jShll)%pCff,jPrimj,jBasj)
#     endif

      ! Transform IJ,AB to J,ABi
      call DGEMM_('T','T',jBasj*nSO,iPrimi,iBasi,One,DSOc,iBasi,Shells(iShll)%pCff,iPrimi,Zero,DSOp,jBasj*nSO)
      ! Transform J,ABi to AB,ij
      call DGEMM_('T','T',nSO*iPrimi,jPrimj,jBasj,One,DSOp,jBasj,Shells(jShll)%pCff,jPrimj,Zero,DSO,nSO*iPrimi)
      ! Transpose to ij,AB
      call DGeTmO(DSO,nSO,nSO,iPrimi*jPrimj,DSOp,iPrimi*jPrimj)

#     ifdef _DEBUGPRINT_
      call RecPrt(' Decontracted 1st order density/Fock matrix',' ',DSOp,iPrimi*jPrimj,nSO)
#     endif
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Loops over symmetry operations.

      nOp(1) = NrOpr(0)
      if (iFD == 1) then

        ! Store away pointer to the block of density info

        ipOffD(1,ijShll) = jOffD+ipDeDe
        ipOffD(2,ijShll) = nDCRR
        if ((nIrrep == 1) .and. Special_NoSym) then
          ipOffD(3,ijShll) = iCmp*jCmp+iPrim*jPrim+1
        else
          ipOffD(3,ijShll) = iCmp*jCmp*(iBas*jBas+1)+iPrim*jPrim+1
        end if
      else

        ! Store away pointer to the block of spin-density info

        ipOffD(4,ijShll) = jOffD+ipDeDe
      end if
      mIndij = mIndij+(nIrrep/dc(mdci)%nStab)*(nIrrep/dc(mdcj)%nStab)
#     ifdef _DEBUGPRINT_
      write(u6,*) ' ipDeDe+jOffD,nDCRR,iCmp*jCmp*iBas*jBas=',ipDeDe+jOffD,nDCRR,iCmp*jCmp*iBas*jBas
#     endif
      do lDCRR=0,nDCRR-1
        nOp(2) = NrOpr(iDCRR(lDCRR))
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Desymmetrize the 1st order density matrix(contracted).

        call Desym1(iSmLbl,iCmpi,jCmpj,iSh,jSh,iAOi,jAOj,DAO,iBasi,jBasj,DSOc,nSO,nOp,Scrt)

        ! Store away result

        Temp = Zero
        ipStart = ipDeDe+jOffD
        if (DFT_Storage) then

          ! Storage format for numerical integration

          ! D(iBas*iCmp,jBas*jCmp)

          call ResortD(DAO,DeDe(ipStart),iBas,iCmp,jBas,jCmp)
          jOffD = jOffD+iBas*iCmp*jBas*jCmp

        else

          ! Storage format for direct SCF

          ! D(iBas*jBas+1,iCmp*jCmp)

          jpDAO = 1
          do ijCmp=1,iCmp*jCmp
            if ((nIrrep /= 1) .or. (.not. Special_NoSym)) then
              DeDe(ipDeDe+jOffD:ipDeDe+jOffD+iBas*jBas-1) = DAO(jpDAO:jpDAO+iBas*jBas-1)
              jOffD = jOffD+iBas*jBas
            end if
            ! Find the largest density for this angular combination
            iHigh = iDAMax_(iBas*jBas,DAO(jpDAO),1)
            DeDe(ipDeDe+jOffD) = abs(DAO(jpDAO+iHigh-1))
            if (Temp < abs(DAO(jpDAO+iHigh-1))) Temp = abs(DAO(jpDAO+iHigh-1))
            jOffD = jOffD+1
            jpDAO = jpDAO+iBas*jBas
          end do
#         ifdef _DEBUGPRINT_
          if ((nIrrep /= 1) .or. (.not. Special_NoSym)) call RecPrt(' DAO(+AMax)',' ',DeDe(ipStart),iBas*jBas+1,iCmp*jCmp)
#         endif
        end if

        if (DFT_Storage) cycle
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Desymmetrize the 1st order density matrix(primitive).

        call Desym1(iSmLbl,iCmpi,jCmpj,iSh,jSh,iAOi,jAOj,DAO,iPrimi,jPrimj,DSOp,nSO,nOp,Scrt)

        ! Change order so it follows what is used in TwoEl

        ipStart = ipDeDe+jOffD
        do j=1,jPrimj
          do i=1,iPrimi
            ij = (j-1)*iPrimi+i
            iHigh = IDAMax_(iCmpi*jCmpj,DAO(ij),iPrimi*jPrimj)-1
            DeDe(ipDeDe+jOffD) = abs(DAO(ij+iHigh*iPrimi*jPrimj))
            jOffD = jOffD+1
          end do
        end do
        ! Find the overall largest density
        DeDe(ipDeDe+jOffD) = Temp
        jOffD = jOffD+1
#       ifdef _DEBUGPRINT_
        call RecPrt(' D,prim',' ',DeDe(ipStart),iPrimi,jPrimj)
        write(u6,*) ' Max(DAO)=',Temp
#       endif
        !                                                              *
        !***************************************************************
        !                                                              *
      end do  ! lDCRR
      !                                                                *
      !*****************************************************************
      !                                                                *
    end do  ! iFD
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    call mma_deallocate(Scrt)
    call mma_deallocate(DSO)
    call mma_deallocate(DSOc)
    call mma_deallocate(DSOp)
    call mma_deallocate(DAO)
  end do
end do
mDeDe = jOffD

if (mDeDe /= nDeDe) then
  write(u6,*) 'DeDe:  mDeDe =',mDeDe,' nDeDe =',nDeDe
  call Abend()
end if

return

end subroutine mk_DeDe

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Setup_Aux(nIrrep,nBas,nShell,nShell_Aux,nSO,TMax,CutOff,nij_Shell,nBas_Aux,nChV,iTOffs)

use iSD_data, only: iSD
use SOAO_Info, only: iSOInf
use RI_glob, only: iShij, iSSOff, nBasSh, ShlSO, SOShl
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nIrrep, nBas(0:nIrrep-1), nShell, nShell_Aux, nBas_Aux(0:nIrrep-1), nChV(0:nIrrep-1)
integer(kind=iwp), intent(out) :: nSO, nij_Shell, iTOffs(3,0:nIrrep-1)
real(kind=wp), intent(in) :: TMax(nShell,nShell), CutOff
integer(kind=iwp) :: iAng, iCnt, iCnttp, iIrrep, ij_Shell, iSkal, iSO, jAng, jCnt, jCnttp, jSkal, nSO_Aux
real(kind=wp) :: TMax_ij

!                                                                      *
!***********************************************************************
!                                                                      *
!define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'Setup_Aux:nIrrep:   ',nIrrep
write(u6,*) 'Setup_Aux:nBas:     ',nBas
write(u6,*) 'Setup_Aux:nBas_Aux: ',nBas_Aux
write(u6,*) 'Setup_Aux:nChV:     ',nChV
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
nSO = 0
nSO_Aux = 0
do iIrrep=0,nIrrep-1
  nSO = nSO+nBas(iIrrep)
  nSO_Aux = nSO_Aux+nBas_Aux(iIrrep)
end do

call mma_allocate(SOShl,nSO+nSO_Aux,Label='SOShl')
call mma_allocate(ShlSO,nSO+nSO_Aux,Label='ShlSO')
call mma_allocate(nBasSh,[0,nIrrep-1],[1,nShell+nShell_Aux],Label='nBasSh')
!                                                                      *
!***********************************************************************
!                                                                      *
do iSO=1,nSO+nSO_Aux
  iCnttp = iSOInf(1,iSO)
  iCnt = iSOInf(2,iSO)
  iAng = iSOInf(3,iSO)
  !write(u6,*) 'iCnttp,iCnt,iAng=',iCnttp,iCnt,iAng

  ! Find the Shell from which this basis function is derived.

  do iSkal=1,nShell+nShell_Aux
    jCnttp = iSD(13,iSkal)
    jCnt = iSD(14,iSkal)
    jAng = iSD(1,iSkal)
    if ((jCnttp == iCnttp) .and. (jCnt == iCnt) .and. (jAng == iAng)) then
      SOShl(iSO) = iSkal
      !write(u6,*) 'Found in shell=',iSkal
      exit
    end if
  end do
end do
!call iVcPrt('SOShl',' ',SOShl,nSO+nSO_Aux)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the number of effective shell pairs.

TMax_ij = Zero
do iSkal=1,nShell
  do jSkal=1,iSkal
    TMax_ij = max(TMax_ij,TMax(iSkal,jSkal))
  end do
end do

nij_Shell = 0
do iSkal=1,nShell
  do jSkal=1,iSkal
    if (TMax(iSkal,jSkal)*TMax_ij >= CutOff) nij_Shell = nij_Shell+1
  end do
end do
call mma_allocate(iShij,2,nij_Shell,Label='iShij')

ij_Shell = 0
do iSkal=1,nShell
  do jSkal=1,iSkal
    if (TMax(iSkal,jSkal)*TMax_ij >= CutOff) then
      ij_Shell = ij_Shell+1
      iShij(1,ij_Shell) = iSkal
      iShij(2,ij_Shell) = jSkal
#     ifdef _DEBUGPRINT_
      write(u6,*) 'ij_Shell,iSkal,jSkal=',ij_Shell,iSkal,jSkal
#     endif
    end if
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(iSSOff,[0,nIrrep-1],[0,nIrrep-1],[1,nij_Shell],Label='iSSOff')
!                                                                      *
!***********************************************************************
!                                                                      *
call Setup_Aux_Inner(SOShl,nSO+nSO_Aux,ShlSO,nBasSh,nShell+nShell_Aux,nIrrep,nBas,iSSOff,nij_Shell,iShij,nBas_Aux,nChV,iTOffs)
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'nij_Shell=',nij_Shell
write(u6,*)
do ij_Shell=1,nij_Shell
  write(u6,*) iShij(1,ij_Shell),iShij(2,ij_Shell)
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Setup_Aux

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GETINC_ABT(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,IXCHNG,IKSM,JLSM,INTLST,ICOUL,ieaw)
! Obtain integrals
! ICOUL = 0 :      XINT(IK,JL) = (IJ!KL) for IXCHNG = 0
!                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
! ICOUL = 1 :      XINT(IJ,KL) = (IJ!KL)
!
! Version for integrals stored in INTLST

use Index_Functions, only: iTri
use MCLR_Data, only: IBTSOB, NTSOB
use Constants, only: One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: XINT(*)
integer(kind=iwp), intent(in) :: ITP, ISM, JTP, JSM, KTP, KSM, LTP, LSM, IXCHNG, IKSM, JLSM, ICOUL, ieaw
real(kind=wp), intent(in) :: Intlst(*)
integer(kind=iwp) :: iBas, iInt, IJ, IJKL, IL, IMIN, iOff, iOrb, jBas, JK, JMIN, jOff, jOrb, kBas, KL, kOff, kOrb, lBas, lOff, lOrb
real(kind=wp) :: SGN

iOrb = NTSOB(ITP,ISM)
jOrb = NTSOB(JTP,JSM)
kOrb = NTSOB(KTP,KSM)
lOrb = NTSOB(LTP,LSM)
iOff = IBTSOB(ITP,ISM)
jOff = IBTSOB(JTP,JSM)
kOff = IBTSOB(KTP,KSM)
lOff = IBTSOB(LTP,LSM)

if (ICOUL == 0) then

  ! Collect Coulomb terms

  iint = 1
  do lBas=lOff,lOff+lOrb-1
    jMin = jOff
    if (JLSM /= 0) jMin = lBas
    do jBas=jMin,jOff+jOrb-1
      do kBas=kOff,kOff+kOrb-1
        iMin = iOff
        if (IKSM /= 0) iMin = kBas
        do iBas=iMin,iOff+iOrb-1
          ij = iTri(iBas,jBas)
          kl = iTri(kBas,lBas)
          SGN = One
          if ((ij < kl) .and. (ieaw /= 0)) SGN = -One
          ijkl = iTri(ij,kl)
          Xint(iInt) = SGN*Intlst(ijkl)
          iInt = iInt+1
        end do
      end do
    end do
  end do

  ! Collect Exchange terms

  if (IXCHNG /= 0) then
    iint = 1
    do lBas=lOff,lOff+lOrb-1
      jMin = jOff
      if (JLSM /= 0) jMin = lBas
      do jBas=jMin,jOff+jOrb-1
        do kBas=kOff,kOff+kOrb-1
          iMin = iOff
          if (IKSM /= 0) iMin = kBas
          do iBas=iMin,iOff+iOrb-1
            il = iTri(iBas,lBas)
            jk = iTri(jBas,kBas)
            ijkl = iTri(il,jk)
            XInt(iInt) = XInt(iInt)-Intlst(ijkl)
            iInt = iInt+1
          end do
        end do
      end do
    end do
  end if
else
  iint = 1
  do lBas=lOff,lOff+lOrb-1
    do kBas=kOff,kOff+kOrb-1
      do jBas=joff,jOff+jOrb-1
        do iBas=ioff,iOff+iOrb-1
          ij = iTri(iBas,jBas)
          kl = iTri(kBas,lBas)
          ijkl = iTri(ij,kl)
          Xint(iInt) = Intlst(ijkl)
          iInt = iint+1
        end do
      end do
    end do
  end do
end if

end subroutine GETINC_ABT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE STEPVEC(ICL,IOP,NCL,NOP,ISPIN,NORB,IWALK)
C
C     PURPOSE: A SPIN-COUPLED CSF IS SPECIFIED BY NCL CLOSED SHELL
C              AND NOP OPEN SHELL AND OCCUPATION VECTORS ICL AND IOP,
C              RESPECTIVELY. THE SPIN COUPLING IS STORED IN THE
C              VECTOR ISPIN. TRANSLATE THESE DATA INTO THE
C              CORRESPONDING STEP VECTOR.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION ICL(*),IOP(*),ISPIN(*)
      DIMENSION IWALK(*)
C
      NXTCL = 1
      NXTOP = 1
      DO 100 IORB = 1,NORB
        IF(NXTCL.LE.NCL.AND.IORB.EQ.ICL(NXTCL) ) THEN
          IWALK(IORB) = 3
          NXTCL =NXTCL + 1
        ELSE IF(NXTOP.LE.NOP.AND.IORB.EQ.IOP(NXTOP) ) THEN
          IF(ISPIN(NXTOP).EQ.1) THEN
            IDELSP = 1
          ELSE
            IDELSP = -1
          END IF
          IF(IDELSP.EQ.1) THEN
             IWALK(IORB) = 1
          ELSE IF(IDELSP.EQ.-1) THEN
             IWALK(IORB) = 2
          END IF
          NXTOP = NXTOP + 1
        ELSE
          IWALK(IORB) = 0
        END IF
100   CONTINUE
C
C     EXIT
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------
! 1998  PER-AAKE MALMQUIST
! DEPARTMENT OF THEORETICAL CHEMISTRY
! UNIVERSITY OF LUND
! SWEDEN
!--------------------------------------------

subroutine MKRHS_SAVE(ICASE,ISYM,IVEC,LW)
!SVC: special routine to save the RHS array. MKRHS works in serial, so
! in case of a true parallel run we need to put the local array in a
! global array and then save that to disk in a distributed fashion.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use fake_GA, only: GA_Arrays
#endif
use caspt2_module, only: NASUP, NISUP
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ICASE, ISYM, IVEC, LW
integer(kind=iwp) :: lg_w, NAS, NIS

NAS = NASUP(ISYM,ICASE)
NIS = NISUP(ISYM,ICASE)

#ifdef _MOLCAS_MPP_
if (IS_REAL_PAR()) then
  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_PUT(NAS,NIS,lg_W,GA_Arrays(LW)%A)
else
#endif
  lg_W = LW
#ifdef _MOLCAS_MPP_
end if
#endif

call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)

#ifdef _MOLCAS_MPP_
if (IS_REAL_PAR()) call RHS_FREE(lg_W)
#endif

end subroutine MKRHS_SAVE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine contt29 (wrk,wrksize)
c
c     this routine do:
c
c     T29
c1    Q(c,d,ij)aaaa   <= - sum(m-a)  [ T1o(c,m)aa . <ij||md>aaaa ]
c     T2n(ab,ij)aaaa   <- Q(a,b,ij)aaaa - Q(b,a,ij)aaaa
c2    Q(c,d,ij)bbbb   <= - sum(m-b)  [ T1o(c,m)bb . <ij||md>bbbb ]
c     T2n(ab,ij)bbbb   <- Q(a,b,ij)bbbb - Q(b,a,ij)bbbb
c3    T2n(a,b,i,j)abab <- - sum(m-a)  [ T1o(a,m)aa . <ij||mb)abab ]
c4    T2n(a,b,i,j)abab <- + sum(m-b)  [ T1o(b,m)bb . <ij||ma>abba ]
c
c     N.B. use and destroy : V1,V2
c
       use Para_Info, only: MyRank
#include "ccsd2.fh"
#include "parallel.fh"
#include "wrk.fh"
c
c     help variables
c
       integer posst,rc,ssc
c
cpar
        if (myRank.eq.idfin) then
c
c1    T2n(ab,ij)aaaa <- -P(a,b) sum(m-a) [T1o(a,m)aa . <md||ij>aaaa]
c
c1.1  mult V1(c,d,ij) <= T1o(c,m)aa . <md||ij>aaaa
       call mult (wrk,wrksize,
     & 2,4,4,1,mapdt11,mapit11,1,mapdw11,mapiw11,1,mapdv1,
     &            mapiv1,ssc,possv10,rc)
c
c1.2  pack V2(cd,ij) <= V1(c,d,ij) - V1(d,c,ij)
       call fack (wrk,wrksize,
     & 4,4,mapdv1,1,mapiv1,mapdv2,mapiv2,possv20,rc)
c
c1.3  add t2n(ab,ij)aaaa <- - V2(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv2,1,mapdt21,mapit21,1,rc)
c
c
c
c2    T2n(ab,ij)bbbb <- -P(a,b) sum(m-b) [T1o(a,m)bb . <md||ij>bbbb]
c
c2.1  mult V1(c,d,ij) <= T1o(c,m)bb . <md||ij>bbbb
       call mult (wrk,wrksize,
     & 2,4,4,1,mapdt12,mapit12,1,mapdw12,mapiw12,1,mapdv1,
     &            mapiv1,ssc,possv10,rc)
c
c2.2  pack V2(cd,ij) <= V1(c,d,ij) - V1(d,c,ij)
       call fack (wrk,wrksize,
     & 4,4,mapdv1,1,mapiv1,mapdv2,mapiv2,possv20,rc)
c
c2.3  add t2n(ab,ij)bbbb <- - V2(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv2,1,mapdt22,mapit22,1,rc)
c
c
c
c3    T2n(a,b,i,j)abab <- - sum(m-a)  [ T1o(a,m)aa . <ij||mb)abab ]
c
c3.1  mult V1(a,b,i,j) <= T1o(a,m)aa . <mb||ij>abab
       call mult (wrk,wrksize,
     & 2,4,4,1,mapdt11,mapit11,1,mapdw13,mapiw13,1,mapdv1,
     &            mapiv1,ssc,possv10,rc)
c
c3.2  add t2n(a,b,i,j)abab <- - V1(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv1,1,mapdt23,mapit23,1,rc)
c
c
c
c4    T2n(a,b,i,j)abab <- + sum(m-b)  [ T1o(b,m)bb . <ij||ma>abba ]
c
c4.1  mult V1(b,a,i,j) <= T1o(b,m)bb . <ma||ij>baab
       call mult (wrk,wrksize,
     & 2,4,4,1,mapdt12,mapit12,1,mapdw14,mapiw14,1,mapdv1,
     &            mapiv1,ssc,possv10,rc)
c
c4.2  map V2(a,b,i,j) <= V1(b,a,i,j)
       call map (wrk,wrksize,
     & 4,2,1,3,4,mapdv1,mapiv1,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
c
c4.3  add t2n(a,b,i,j)abab <-  V2(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdt23,mapit23,1,rc)
c
cpar
        end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine deflength(mapd,length)
! this routine defines length of mediate, described by mapd

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: mapd(0:512,6)
integer(kind=iwp), intent(out) :: length
integer(kind=iwp) :: ii

ii = mapd(0,5)
length = mapd(ii,1)+mapd(ii,2)-mapd(1,1)

return

end subroutine deflength

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKCOT_m(ISM,IDOWN,NOW,IOW,IOCSF,NOCSF,ISCR,IPRINT)
C     PURPOSE: SET UP COUNTER AND OFFSET TABLES FOR WALKS AND CSFS
C     NOTE:    TO GET GET VARIOUS COUNTER AND OFFSET TABLES
C              THE DOWN-CHAIN TABLE IS SCANNED TO PRODUCE ALL POSSIBLE
C              WALKS. POSSIBLY, THERE ARE MORE EFFICIENT WAYS, BUT
C              SINCE ONLY UPPER AND LOWER WALKS ARE REQUIRED
C              THEIR NUMBER IS VERY LIMITTED, EVEN FOR LARGE CASES.
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='MKCOT   ')
#include "gugx.fh"
C
      DIMENSION ISM(NLEV),IDOWN(NVERT,0:3)
      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)
      DIMENSION NOCSF(NSYM,NMIDV,NSYM),IOCSF(NSYM,NMIDV,NSYM)
      DIMENSION ISCR(3,0:NLEV)
      PARAMETER(IVERT=1,ISYM=2,ISTEP=3)
C
C     CLEAR ARRAYS IOW AND NOW
C
      DO IHALF=1,2
        DO MV=1,NMIDV
          DO IS=1,NSYM
            NOW(IHALF,IS,MV)=0
            IOW(IHALF,IS,MV)=0
          END DO
        END DO
      END DO
C
C     CLEAR ARRAYS IOCSF AND NOCSF
C
      DO IS=1,NSYM
        DO MV=1,NMIDV
          DO JS=1,NSYM
            IOCSF(JS,MV,IS)=0
            NOCSF(JS,MV,IS)=0
          END DO
        END DO
      END DO
C
C     START MAIN LOOP OVER UPPER AND LOWER WALKS, RESPECTIVELY.
C
      DO IHALF=1,2
        IF(IHALF.EQ.1) THEN
          IVTSTA=1
          IVTEND=1
          LEV1=NLEV
          LEV2=MIDLEV
        ELSE
          IVTSTA=MIDV1
          IVTEND=MIDV2
          LEV1=MIDLEV
          LEV2=0
        END IF
C
C     LOOP OVER VERTICES STARTING AT TOP OF SUBGRAPH
C
        DO IVTOP=IVTSTA,IVTEND
C     SET CURRENT LEVEL=TOP LEVEL OF SUBGRAPH
          LEV=LEV1
          ISCR(IVERT,LEV)=IVTOP
          ISCR(ISYM,LEV)=1
          ISCR(ISTEP,LEV)=-1
100       IF(LEV.GT.LEV1) GOTO 400
C     FIND FIRST POSSIBLE UNTRIED ARC DOWN FROM CURRENT VERTEX
          IVT=ISCR(IVERT,LEV)
          DO ISTP=ISCR(ISTEP,LEV)+1,3
            IVB=IDOWN(IVT,ISTP)
            IF(IVB.NE.0) GOTO 200
          END DO
C     NO SUCH ARC WAS POSSIBLE. GO UP ONE STEP AND TRY AGAIN.
          ISCR(ISTEP,LEV)=-1
          LEV=LEV+1
          GOTO 100
C     SUCH AN ARC WAS FOUND. WALK DOWN:
200       ISCR(ISTEP,LEV)=ISTP
          ISML=1
          IF((ISTP.EQ.1).OR.(ISTP.EQ.2)) ISML=ISM(LEV)
          LEV=LEV-1
          ISCR(ISYM,LEV)=MUL(ISML,ISCR(ISYM,LEV+1))
          ISCR(IVERT,LEV)=IVB
          ISCR(ISTEP,LEV)=-1
          IF (LEV.GT.LEV2) GOTO 100
C     WE HAVE REACHED THE BOTTOM LEVEL. THE WALK IS COMPLETE.
C     FIND MIDVERTEX NUMBER ORDERING NUMBER AND SYMMETRY OF THIS WALK
          MV=ISCR(IVERT,MIDLEV)+1-MIDV1
          IWSYM=ISCR(ISYM,LEV2)
          ILND=1+NOW(IHALF,IWSYM,MV)
C     SAVE THE MAX WALK NUMBER FOR GIVEN SYMMETRY AND MIDVERTEX
          NOW(IHALF,IWSYM,MV)=ILND
C     BACK UP ONE LEVEL AND TRY AGAIN:
          LEV=LEV+1
          GOTO 100
400       CONTINUE
        END DO
      END DO
C
C     NOW,CONSTRUCT OFFSET TABLES FOR UPPER AND LOWER WALKS
C     SEPARATED FOR EACH MIDVERTEX AND SYMMETRY
C
      NUW=0
      DO MV=1,NMIDV
        DO IS=1,NSYM
          IOW(1,IS,MV)=NUW*NIPWLK
          NUW=NUW+NOW(1,IS,MV)
        END DO
      END DO
      NWALK=NUW
      DO MV=1,NMIDV
        DO IS=1,NSYM
          IOW(2,IS,MV)=NWALK*NIPWLK
          NWALK=NWALK+NOW(2,IS,MV)
        END DO
      END DO
      NLW=NWALK-NUW
C
C     FINALLY, CONSTRUCT COUNTER AND OFFSET TABLES FOR THE CSFS
C     SEPARATED BY MIDVERTICES AND SYMMETRY.
C     FORM ALSO CONTRACTED SUMS OVER MIDVERTICES.
C
      DO ISYTOT=1,NSYM
        NCSF(ISYTOT)=0
        DO MV=1,NMIDV
          DO ISYUP=1,NSYM
            ISYDWN=MUL(ISYTOT,ISYUP)
            N=NOW(1,ISYUP,MV)*NOW(2,ISYDWN,MV)
            NOCSF(ISYUP,MV,ISYTOT)=N
            IOCSF(ISYUP,MV,ISYTOT)=NCSF(ISYTOT)
            NCSF(ISYTOT)=NCSF(ISYTOT)+N
          END DO
        END DO
      END DO
      IF (IPRINT.GE.5) THEN
        Write(LF,*)
        Write(LF,*)' TOTAL NR OF WALKS: UPPER ',NUW
        Write(LF,*)'                    LOWER ',NLW
        Write(LF,*)'                     SUM  ',NWALK
        Write(LF,*)
        Write(LF,*)' NR OF CONFIGURATIONS/SYMM:'
        Write(LF,'(8(1X,I8))')(NCSF(IS),IS=1,NSYM)
        Write(LF,*)
        Write(LF,*)
        Write(LF,*)' NR OF WALKS AND CONFIGURATIONS IN NRCOUP'
        Write(LF,*)' BY MIDVERTEX AND SYMMETRY.'
        DO MV=1,NMIDV
          Write(LF,*)
          Write(LF,'(A,I2,A,8I6)') '  MV=',MV,'    UPPER WALKS:',
     &                             (NOW(1,IS,MV),IS=1,NSYM)
          Write(LF,'(A,8I6)') '           LOWER WALKS:',
     &                             (NOW(2,IS,MV),IS=1,NSYM)
          DO IST=1,NSYM
          Write(LF,'(A,I2,A,8I6)') ' IST=',IST,'  CONFIGURATIONS:',
     &                           (NOCSF(IS,MV,IST),IS=1,NSYM)
          END DO
        END DO
      ENDIF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!               2012,2014, Victor P. Vysotskiy                         *
!***********************************************************************

subroutine Cho_XCV_DV_P(irc,SP_BatchDim,nSP_Batch,id_mySP,n_mySP,NVT,l_NVT)

#ifdef _MOLCAS_MPP_
#ifndef _GA_
use Para_Info, only: nProcs
#endif
use Cholesky, only: iiBstRSh, INF_PROGRESS, IPRINT, LuCho, LuPri, LuTmp, nnBstR, nnBstRSh, nSym, NumCho
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nSP_Batch, SP_BatchDim(nSP_Batch), n_mySP, id_mySP(n_mySP), l_NVT, NVT(l_NVT)
#ifdef _MOLCAS_MPP_
#include "mafdecls.fh"
integer(kind=iwp) :: g_a, iAdr, iAdr0, iBatch, iSP, iSP1, iSP2, iSP_, iSP_Batch, iSym, J0, J1, J2, kV, l_IDV, l_Mem, l_numV, l_V, &
                     lTot, max_vector_dim, my_nV, myEnd, myStart, nBatch, nDim, nSP_this_batch, nVec_per_batch, nVec_this_batch
real(kind=wp) :: X0, X1, Y0, Y1
logical(kind=iwp) :: ok
#ifndef _GA_
integer(kind=iwp) :: Jen, Jst
#else
integer(kind=iwp) :: i, j
#endif
integer(kind=iwp), allocatable :: GADIST(:), GAMNCH(:), GANUMV(:)
real(kind=wp), allocatable :: GAVEC(:)
integer(kind=iwp), parameter :: iOpt = 1
character(len=*), parameter :: SecNam = 'Cho_XCV_DV_P'
logical(kind=iwp), external :: ga_create, ga_destroy

! Init return code
irc = 0

! Find max vector dimension
max_vector_dim = nnBstR(1,2)
do iSym=1,nSym
  max_vector_dim = max(max_vector_dim,nnBstR(iSym,2))
end do
if (max_vector_dim < 1) then
  irc = -2
  return
end if

! Allocate my vector counter array
call mma_allocate(GAMNCH,nSym,Label='GAMNCH')
GAMNCH(:) = 0

! Allocate index arrays for GA use
l_numV = 1
call mma_allocate(GANUMV,l_numV,Label='GANUMV')

! Figure out how much 1/3 of total memory is
call mma_maxDBLE(l_Mem)
l_Mem = l_Mem/3
if (l_Mem < max_vector_dim) then
  ! OK, let us try 2/3 then...
  l_Mem = l_Mem*2
  if (l_Mem < max_vector_dim) then
    irc = -1
    return
  end if
end if

! distribute vectors, one symmetry at a time
do iSym=1,nSym
  if (iPrint >= Inf_Progress) then
    write(LuPri,'(/,A,I2,/,A)') 'Distributing vectors, symmetry',iSym,'--------------------------------'
    write(LuPri,'(3X,A,I8)') 'Total number of vectors:',NVT(iSym)
    write(LuPri,'(3X,A,I8)') 'Local number of vectors:',NumCho(iSym)
    write(LuPri,'(3X,A,I8)') 'Vector dimension       :',nnBstR(iSym,2)
    write(LuPri,'(3X,A,I8)') 'Shell pair batches     :',nSP_Batch
    call XFlush(LuPri)
  end if
  if ((NVT(iSym) > 0) .and. (nnBstR(iSym,2) > 0)) then
    ! Set up batching, ensuring that the number of vectors is
    ! the same on all nodes
    GANUMV(1) = min(l_Mem/nnBstR(iSym,2),NVT(iSym))
    call Cho_GAIGOp(GANUMV,1,'min')
    nVec_per_batch = GANUMV(1)
    if (nVec_per_batch < 1) call Cho_Quit('Insufficient memory for batching in '//SecNam,101)
    nBatch = (NVT(iSym)-1)/nVec_per_batch+1
    ! Allocate memory for vectors (will hold local as well as
    ! full vectors)
    l_V = nnBstR(iSym,2)*nVec_per_batch
    call mma_allocate(GAVEC,l_V,Label='GAVEC')
    ! Allocate vector ID array for distribution
    l_IDV = nVec_per_batch
    call mma_allocate(GADIST,l_IDV,Label='GADIST')
    ! Create global array with evenly distributed chunks
    ok = ga_create(mt_dbl,nnBstR(iSym,2),nVec_per_batch,'GA_XCV',0,0,g_a)
    if (.not. ok) call Cho_Quit(SecNam//': ga_create() failed!',101)
    if (iPrint >= Inf_Progress) then
      write(LuPri,'(3X,A,I8)') 'Vector batches         :',nBatch
      call XFlush(LuPri)
    end if
    ! Distribute in batches
    do iBatch=1,nBatch
      ! Sync: all must be at the same batch
      ! (so that we do not put while another is getting)
      call GASync()
      ! Determine number of vectors in this batch
      if (iBatch == nBatch) then
        nVec_this_batch = NVT(iSym)-nVec_per_batch*(nBatch-1)
      else
        nVec_this_batch = nVec_per_batch
      end if
      ! First and last vector in this batch
      J1 = nVec_per_batch*(iBatch-1)+1
      J2 = J1+nVec_this_batch-1
      if (iPrint >= Inf_Progress) then
        write(LuPri,'(3X,A,I8,/,3X,A)') 'Vector batch number:',iBatch,'++++++++++++++++++++++++++++'
        write(LuPri,'(6X,A,I8)') 'Number of vectors in this batch:',nVec_this_batch
        write(LuPri,'(6X,A,I8,1X,I8)') 'First and last vector          :',J1,J2
        call XFlush(LuPri)
        call CWTime(X0,Y0)
      end if
      ! Loop through SP blocks of vectors in this vector batch
      iAdr0 = 0
      iSP1 = 1
      do iSP_Batch=1,nSP_Batch
        nSP_this_batch = SP_BatchDim(iSP_Batch)
        iSP2 = iSP1+nSP_this_batch-1
        nDim = 0
        do iSP=iSP1,iSP2
          nDim = nDim+nnBstRSh(iSym,id_mySP(iSP),2)
        end do
        if (nDim > 0) then
          ! Read vector block
          lTot = nDim*nVec_this_batch
          iAdr = iAdr0+nDim*(J1-1)
          call DDAFile(LuTmp(iSym),2,GAVEC,lTot,iAdr)
          iAdr0 = iAdr0+nDim*NVT(iSym)
          ! Put vector block into global array
          kV = 1
          do iSP_=iSP1,iSP2
            iSP = id_mySP(iSP_)
            if (nnBstRSh(iSym,iSP,2) > 0) then
              myStart = iiBstRSh(iSym,iSP,2)+1
              myEnd = myStart+nnBstRSh(iSym,iSP,2)-1
              call ga_put(g_a,myStart,myEnd,1,nVec_this_batch,GAVEC(kV),nDim)
              kV = kV+nnBstRSh(iSym,iSP,2)
            end if
          end do
        end if
        iSP1 = iSP1+nSP_this_batch
      end do
      if (iPrint >= Inf_Progress) then
        call CWTime(X1,Y1)
        write(LuPri,'(6X,A,F12.2,1X,F12.2)') 'Time for read/ga_put (sec)     :',(X1-X0),(Y1-Y0)
        call XFlush(LuPri)
      end if
      ! Sync: all must be done putting data into g_a
      call GASync()
      ! Compute vector distribution for this batch
      my_nV = 0
      call Cho_P_Distrib_Vec(J1,J2,GADIST,my_nV)
      if (iPrint >= Inf_Progress) call CWTime(X0,Y0)
      ! Get vectors from global array
      J0 = J1-1
      kV = 1
      do i=1,my_nV
        J = GADIST(i)-J0
        call ga_get(g_a,1,nnBstR(iSym,2),J,J,GAVEC(kV),nnBstR(iSym,2))
        kV = kV+nnBstR(iSym,2)
      end do
      ! Write vectors to disk
      lTot = nnBstR(iSym,2)*my_nV
      if (lTot > 0) then
        iAdr = nnBstR(iSym,2)*GAMNCH(iSym)
        call DDAFile(LuCho(iSym),iOpt,GAVEC,lTot,iAdr)
      end if
      if (iPrint >= Inf_Progress) then
        call CWTime(X1,Y1)
        write(LuPri,'(6X,A,F12.2,1X,F12.2)') 'Time for ga_get/write (sec)    :',(X1-X0),(Y1-Y0)
        call XFlush(LuPri)
      end if
      ! Update my vector counter
      GAMNCH(iSym) = GAMNCH(iSym)+my_nV
    end do
    ! Destroy global array
    ok = ga_destroy(g_a)
    ! Deallocations
    call mma_deallocate(GADIST)
    call mma_deallocate(GAVEC)
  end if
end do

! Deallocations
call mma_deallocate(GANUMV)
call mma_deallocate(GAMNCH)
#else

#include "macros.fh"
unused_var(SP_BatchDim)
unused_var(id_mySP)
unused_var(NVT)

irc = 999 ! should never be called in serial installation

return

#endif

end subroutine Cho_XCV_DV_P

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine transHam(n1,n2,rot1,rot2,MM1,MM2,typ1,typ2,H,HT,iopt)
! purpose:  transform the exchange Hamiltonian
!           matrices to the basis of their local pseudospins

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n1, n2, iopt
real(kind=wp), intent(in) :: rot1(3,3), rot2(3,3)
complex(kind=wp), intent(in) :: MM1(3,n1,n1), MM2(3,n2,n2), H(n1,n1,n2,n2)
character, intent(in) :: typ1, typ2
complex(kind=wp), intent(out) :: HT(n1,n1,n2,n2)
integer(kind=iwp) :: i1, i2, iprint, j1, j2
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif
real(kind=wp), allocatable :: ax1(:,:), ax2(:,:), gt1(:), gt2(:)
complex(kind=wp), allocatable :: HI(:,:,:,:), HTMP(:,:), M1(:,:,:), M2(:,:,:), MR1(:,:,:), MR2(:,:,:), TMP1(:,:), TMP2(:,:), &
                                 Z1(:,:), Z2(:,:)

!-----------------------------------------------------------------------
call mma_allocate(gt1,3,'gt1')
call mma_allocate(gt2,3,'gt2')
call mma_allocate(ax1,3,3,'ax1')
call mma_allocate(ax2,3,3,'ax2')
call mma_allocate(M1,3,n1,n1,'M1')
call mma_allocate(MR1,3,n1,n1,'MR1')
call mma_allocate(Z1,n1,n1,'Z1')
call mma_allocate(TMP1,n1,n1,'TMP1')
call mma_allocate(M2,3,n2,n2,'M2')
call mma_allocate(MR2,3,n2,n2,'MR2')
call mma_allocate(Z2,n2,n2,'Z2')
call mma_allocate(TMP2,n2,n2,'TMP2')
call mma_allocate(HI,n1,n1,n2,n2,'HI')
HT(:,:,:,:) = cZero
!-----------------------------------------------------------------------

! rotate the magnetic moments to their general coordinate system

call rotmom(MM1,n1,rot1,M1)
call rotmom(MM2,n2,rot2,M2)

if (iopt == 1) then ! local coordinate system
  iprint = 1
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'TRANSHAM:: local g tensors and axes:'
  iprint = 2
# endif
  call atens(M1,n1,gt1,ax1,iprint)
  call atens(M2,n2,gt2,ax2,iprint)

else if (iopt == 2) then ! general coordinate system
  call unitmat(ax1,3)
  call unitmat(ax2,3)
end if

!-----------------------------------------------------------------------
! rotate magnetic moments to their local magnetic axes:
MR1(:,:,:) = cZero
MR2(:,:,:) = cZero
if (((typ1 == 'A') .and. (typ2 == 'A')) .or. ((typ1 == 'B') .and. (typ2 == 'B')) .or. ((typ1 == 'B') .and. (typ2 == 'C')) .or. &
    ((typ1 == 'C') .and. (typ2 == 'B')) .or. ((typ1 == 'C') .and. (typ2 == 'C'))) then
  ! both sites have been computed ab initio
  call rotmom2(M1,n1,ax1,MR1)
  call rotmom2(M2,n2,ax2,MR2)
else if (((typ1 == 'A') .and. (typ2 == 'B')) .or. ((typ1 == 'A') .and. (typ2 == 'C'))) then
  ! site 2 is generated isotropic
  ! use axes of site 1
  call rotmom2(M1,n1,ax1,MR1)
  call rotmom2(M2,n2,ax1,MR2)
else if (((typ1 == 'B') .and. (typ2 == 'A')) .or. ((typ1 == 'C') .and. (typ2 == 'A'))) then
  ! site 1 is generated isotropic
  ! use axes of site 2
  call rotmom2(M1,n1,ax2,MR1)
  call rotmom2(M2,n2,ax2,MR2)
end if

#ifdef _DEBUGPRINT_
if (iopt == 1) then
  write(u6,'(A,i3)') 'site 1'
  call prMom('transHam:: magnetic moment, coordinate system of LOCAL main magnetic axes, site 1',MR1,n1)
  write(u6,'(A,i3)') 'site 2'
  call prMom('transHam:: magnetic moment, coordinate system of LOCAL main magnetic axes, site 2',MR2,n2)
else
  write(u6,'(A,i3)') 'site 1'
  call prMom('transHam:: magnetic moment, coordinate system of GENERAL main magnetic axes, site 1',MR1,n1)
  write(u6,'(A,i3)') 'site 2'
  call prMom('transHam:: magnetic moment, coordinate system of GENERAL main magnetic axes, site 2',MR2,n2)
end if
#endif

!-----------------------------------------------------------------------
! find local pseudospin on each site:
call pseudospin(MR1,n1,Z1,3,1,1)
call pseudospin(MR2,n2,Z2,3,1,1)

#ifdef _DEBUGPRINT_
call pa_prmat('Matrix Z1',Z1,n1)
call zgemm_('C','N',n1,n1,n1,cOne,Z1,n1,Z1,n1,cZero,TMP1,n1)
write(u6,'(A)') 'transHam:  Verify unitarity of Z1'
do i=1,n1
  write(u6,'(A,i2,A,i2,A,2ES20.10)') 'conjg(Z1)*Z1:  (',i,',',i,')=',TMP1(i,i)
end do
call pa_prmat('Matrix Z2',Z2,n2)
call zgemm_('C','N',n2,n2,n2,cOne,Z2,n2,Z2,n2,cZero,TMP2,n2)
write(u6,'(A)') 'transHam:  Verify unitarity of Z2'
do i=1,n2
  write(u6,'(A,i2,A,i2,A,2ES20.10)') 'conjg(Z2)*Z2:  (',i,',',i,')=',TMP2(i,i)
end do
call UTMU2(n1,n1,Z1,MR1)
call UTMU2(n2,n2,Z2,MR2)
call prMom('transHam:: magnetic moment, coordinate MR1, site 1',MR1,n1)
call prMom('transHam:: magnetic moment, coordinate MR2, site 2',MR2,n2)
#endif

! save a local copy:
HI(:,:,:,:) = H(:,:,:,:)

do i1=1,n1
  do j1=1,n1
    do i2=1,n2
      do j2=1,n2
#       ifdef _DEBUGPRINT_
        if (abs(H(i1,j1,i2,j2)) > 0.5e-13_wp) write(u6,'(A,4(i2,A),2ES22.14)') 'H (',i1,',',j1,',',i2,',',j2,')=',H(i1,j1,i2,j2)
#       else
        write(u6,'(A,4(i2,A),2ES22.14)') 'H (',i1,',',j1,',',i2,',',j2,')=',H(i1,j1,i2,j2)
#       endif
      end do
    end do
  end do
end do

! transform the Hamiltonian to local pseudospins:
do i2=1,n2
  do j2=1,n2
    call zgemm_('C','N',n1,n1,n1,cOne,Z1,n1,HI(:,:,i2,j2),n1,cZero,TMP1,n1)
    call zgemm_('N','N',n1,n1,n1,cOne,TMP1,n1,Z1,n1,cZero,HI(:,:,i2,j2),n1)
  end do
end do

call mma_allocate(HTMP,n2,n2,label='HTMP')
do i1=1,n1
  do j1=1,n1
    HTMP(:,:) = HI(i1,j1,:,:)
    call zgemm_('C','N',n2,n2,n2,cOne,Z2,n2,HTMP,n2,cZero,TMP2,n2)
    call zgemm_('N','N',n2,n2,n2,cOne,TMP2,n2,Z2,n2,cZero,HTMP,n2)
    HI(i1,j1,:,:) = HTMP(:,:)
  end do
end do
call mma_deallocate(HTMP)

HT(:,:,:,:) = HI(:,:,:,:)

do i1=1,n1
  do j1=1,n1
    do i2=1,n2
      do j2=1,n2
#       ifdef _DEBUGPRINT_
        if (abs(HT(i1,j1,i2,j2)) > 0.5e-13_wp) write(u6,'(A,4(i2,A),2ES22.14)') 'HT(',i1,',',j1,',',i2,',',j2,')=',HT(i1,j1,i2,j2)
#       else
        write(u6,'(A,4(i2,A),2ES22.14)') 'HT(',i1,',',j1,',',i2,',',j2,')=',HT(i1,j1,i2,j2)
#       endif
      end do
    end do
  end do
end do

!-----------------------------------------------------------------------
call mma_deallocate(gt1)
call mma_deallocate(gt2)
call mma_deallocate(ax1)
call mma_deallocate(ax2)
call mma_deallocate(M1)
call mma_deallocate(MR1)
call mma_deallocate(Z1)
call mma_deallocate(TMP1)
call mma_deallocate(M2)
call mma_deallocate(MR2)
call mma_deallocate(Z2)
call mma_deallocate(TMP2)
call mma_deallocate(HI)

return

end subroutine transHam

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine GetChVHlp4 (H,T1,dima,adda)
c
c       this routine do:
c       Extract H(i,a') <- T1(a,i) for given aGrp
c
c       parameter description:
c       H       - Output file (O)
c       T1      - T1 amplitudes (I)
c       dima    - dimension of given Group (I)
c       adda    - shift of a' in full a set (I)
c
c       N.B. Kvajt odflaknute, je to ExtT1 len transponovane
c
        implicit none
#include "chcc1.fh"
        integer dima,adda
        real*8 T1(1:nv,1:no)
        real*8 H(1:no,1:dima)
c
c       help variables
        integer a,aa,i
c
        do a=1,dima
        aa=adda+a
          do i=1,no
            H(i,a)=T1(aa,i)
          end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1998  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MKSMAT()
      IMPLICIT REAL*8 (A-H,O-Z)
C     Set up S matrices for cases 1..13.
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
#include "pt2_guga.fh"
#include "SysDef.fh"


      IF(IPRGLB.GE.VERBOSE) THEN
        WRITE(6,*)
        WRITE(6,*)' Construct S matrices'
      END IF

      IF(NASHT.GT.0) THEN
CSVC: print header for debug info
        IF(IPRGLB.GE.DEBUG) THEN
          WRITE(6,'("DEBUG> ",A)') 'CASE SYM S-MATRIX NORM'
          WRITE(6,'("DEBUG> ",A)') '==== === ============='
        END IF
C For the cases A and C, begin by reading in the local storage
C  part of the three-electron density matrix G3:
        CALL GETMEM('GAMMA3','ALLO','REAL',LG3,NG3)
        CALL PT2_GET(NG3,'GAMMA3',WORK(LG3))
        iPad=ItoB-MOD(6*NG3,ItoB)
        CALL GETMEM('idxG3','ALLO','CHAR',LidxG3,6*NG3+iPad)
        iLUID=0
        CALL CDAFILE(LUSOLV,2,cWORK(LidxG3),6*NG3+iPad,iLUID)

        CALL MKSA(WORK(LDREF),WORK(LPREF),
     &            NG3,WORK(LG3),i1WORK(LidxG3))
        CALL MKSC(WORK(LDREF),WORK(LPREF),
     &            NG3,WORK(LG3),i1WORK(LidxG3))

        CALL GETMEM('GAMMA3','FREE','REAL',LG3,NG3)
        CALL GETMEM('idxG3','FREE','CHAR',LidxG3,6*NG3+iPad)

C-SVC20100902: For the remaining cases that do not need G3, use replicate arrays
        CALL MKSB(WORK(LDREF),WORK(LPREF))
        CALL MKSD(WORK(LDREF),WORK(LPREF))
        CALL MKSE(WORK(LDREF))
        CALL MKSF(WORK(LPREF))
        CALL MKSG(WORK(LDREF))
      END IF

C For completeness, even case H has formally S and B
C matrices. This costs nothing, and saves conditional
C looping, etc in the rest  of the routines.
      DO ISYM=1,NSYM
        DO ICASE=12,13
          NIN=NINDEP(ISYM,ICASE)
          IF(NIN.GT.0) THEN
            IDISK=IDSMAT(ISYM,ICASE)
            CALL DDAFILE(LUSBT,1,[1.0D00],1,IDISK)
          END IF
        END DO
      END DO


      RETURN
      END

********************************************************************************
* Case A (ICASE=1)
********************************************************************************
      SUBROUTINE MKSA(DREF,PREF,NG3,G3,idxG3)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      DIMENSION DREF(NDREF),PREF(NPREF),G3(NG3)
      INTEGER*1 idxG3(6,NG3)

      ICASE=1
C LONG loop over superindex symmetry.
      DO ISYM=1,NSYM
        NIN=NINDEP(ISYM,ICASE)
        IF(NIN.EQ.0) CYCLE
        NAS=NTUV(ISYM)
        NSA=(NAS*(NAS+1))/2
        IF(NSA.LE.0) CYCLE
C Set up the matrix SA(tuv,xyz) defined by the expression
C <ituv|kxyz> = dik SA(tuv,xyz)
C Formula used:
C    SA(tuv,xyz) =  -Gvuxtyz -dyu Gvzxt - dyt Gvuxz -
C         - dxu Gvtyz - dxu dyt Gvz +2 dtx Gvuyz + 2 dtx dyu Gvz

        CALL PSBMAT_GETMEM('SA',lg_SA,NAS)

        ! fill in the 3-el parts
#ifdef _MOLCAS_MPP_
        IF (IS_REAL_PAR()) THEN
          MYRANK = GA_NODEID()
          CALL GA_DISTRIBUTION (LG_SA,MYRANK,ILO,IHI,JLO,JHI)
          IF (JLO.NE.0 .AND. (JHI-JLO+1).NE.NAS) THEN
            WRITE(6,*) 'MKSA: MISMATCH IN RANGE OF THE SUPERINDICES'
            CALL ABEND()
          END IF
          IF (ILO.GT.0 .AND. JLO.GT.0) THEN
            CALL GA_ACCESS (LG_SA,ILO,IHI,JLO,JHI,MA,LDA)
            CALL MKSA_G3_MPP(ISYM,DBL_MB(MA),ILO,IHI,JLO,JHI,LDA,
     &                       NG3,G3,IDXG3)
            CALL MKSA_DP(DREF,PREF,ISYM,DBL_MB(MA),ILO,IHI,JLO,JHI,LDA)
            CALL GA_RELEASE_UPDATE (LG_SA,ILO,IHI,JLO,JHI)
          ELSE
            CALL MKSA_G3_MPP(ISYM,WORK(IP_DUMMY),ILO,IHI,JLO,JHI,LDA,
     &                       NG3,G3,IDXG3)
          END IF
        ELSE
          CALL MKSA_G3(ISYM,WORK(LG_SA),NG3,G3,IDXG3)
          CALL MKSA_DP(DREF,PREF,ISYM,WORK(lg_SA),1,NAS,1,NAS,0)
        END IF
#else
        call MKSA_G3(ISYM,WORK(lg_SA),NG3,G3,idxG3)
        CALL MKSA_DP(DREF,PREF,ISYM,WORK(lg_SA),1,NAS,1,NAS,0)
#endif

        CALL PSBMAT_WRITE('S',iCase,iSYM,lg_SA,NAS)

        IF(IPRGLB.GE.DEBUG) THEN
          DSA=PSBMAT_FPRINT(lg_SA,NAS)
          WRITE(6,'("DEBUG> ",A4,1X,I3,1X,ES21.14)') 'A', ISYM, DSA
        END IF

        CALL PSBMAT_FREEMEM('SA',lg_SA,NAS)
      END DO

      END

      SUBROUTINE MKSA_G3(ISYM,SA,NG3,G3,idxG3)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

      DIMENSION SA(*)
      DIMENSION G3(NG3)
      INTEGER*1 idxG3(6,NG3)

C-SVC20100831: determine indices in SA where a certain G3 value will end up
      DO iG3=1,NG3
        iT=idxG3(1,iG3)
        iU=idxG3(2,iG3)
        iV=idxG3(3,iG3)
        iX=idxG3(4,iG3)
        iY=idxG3(5,iG3)
        iZ=idxG3(6,iG3)
        iST=IASYM(iT)
        iSU=IASYM(iU)
        iSV=IASYM(iV)
        iSX=IASYM(iX)
        iSY=IASYM(iY)
        iSZ=IASYM(iZ)
        ituvs=MUL(IST,MUL(ISU,ISV))
        ixyzs=MUL(ISX,MUL(ISY,ISZ))
        if(ituvs.ne.ixyzs) goto 500
        iTU=iT+NASHT*(iU-1)
        iVX=iV+NASHT*(iX-1)
        iYZ=iY+NASHT*(iZ-1)
        G3VAL=-G3(iG3)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
C  - G(tuvxyz) -> SA(xut,vyz)
        jSYM=MUL(IASYM(iX),MUL(IASYM(iU),IASYM(iT)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iX,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iV,iY,iZ)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
        if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 300
        if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 200
C  - G(vxtuyz) -> SA(uxv,tyz)
        jSYM=MUL(IASYM(iU),MUL(IASYM(iX),IASYM(iV)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iU,iX,iV)-nTUVES(jSYM)
          JSUP=KTUV(iT,iY,iZ)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(yzvxtu) -> SA(xzy,vtu)
        jSYM=MUL(IASYM(iX),MUL(IASYM(iZ),IASYM(iY)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iX,iZ,iY)-nTUVES(jSYM)
          JSUP=KTUV(iV,iT,iU)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(tuyzvx) -> SA(zut,yvx)
        jSYM=MUL(IASYM(iZ),MUL(IASYM(iU),IASYM(iT)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iZ,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iY,iV,iX)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
 200   CONTINUE
C  - G(yztuvx) -> SA(uzy,tvx)
        jSYM=MUL(IASYM(iU),MUL(IASYM(iZ),IASYM(iY)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iU,iZ,iY)-nTUVES(jSYM)
          JSUP=KTUV(iT,iV,iX)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(vxyztu) -> SA(zxv,ytu)
        jSYM=MUL(IASYM(iZ),MUL(IASYM(iX),IASYM(iV)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iZ,iX,iV)-nTUVES(jSYM)
          JSUP=KTUV(iY,iT,iU)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
 300   CONTINUE
        if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) go to 500
        if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) go to 500
        if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) go to 500
        if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) go to 500
C  - G(utxvzy) -> SA(vtu,xzy)
        jSYM=MUL(IASYM(iV),MUL(IASYM(iT),IASYM(iU)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iV,iT,iU)-nTUVES(jSYM)
          JSUP=KTUV(iX,iZ,iY)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
        if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 500
        if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 400
C  - G(xvutzy) -> SA(tvx,uzy)
        jSYM=MUL(IASYM(iT),MUL(IASYM(iV),IASYM(iX)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iT,iV,iX)-nTUVES(jSYM)
          JSUP=KTUV(iU,iZ,iY)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(zyxvut) -> SA(vyz,xut)
        jSYM=MUL(IASYM(iV),MUL(IASYM(iY),IASYM(iZ)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iV,iY,iZ)-nTUVES(jSYM)
          JSUP=KTUV(iX,iU,iT)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(utzyxv) -> SA(ytu,zxv)
        jSYM=MUL(IASYM(iY),MUL(IASYM(iT),IASYM(iU)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iY,iT,iU)-nTUVES(jSYM)
          JSUP=KTUV(iZ,iX,iV)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
 400   CONTINUE
C  - G(zyutxv) -> SA(tyz,uxv)
        jSYM=MUL(IASYM(iT),MUL(IASYM(iY),IASYM(iZ)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iT,iY,iZ)-nTUVES(jSYM)
          JSUP=KTUV(iU,iX,iV)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(xvzyut) -> SA(yvx,zut)
        jSYM=MUL(IASYM(iY),MUL(IASYM(iV),IASYM(iX)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iY,iV,iX)-nTUVES(jSYM)
          JSUP=KTUV(iZ,iU,iT)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SA(ISADR)=G3VAL
          END IF
        ENDIF
 500   CONTINUE
      END DO

      RETURN
      END

#ifdef _MOLCAS_MPP_
      SUBROUTINE MKSA_G3_MPP(ISYM,SA,iLo,iHi,jLo,jHi,LDA,
     &                       NG3,G3,idxG3)
      USE MPI
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

#include "global.fh"
#include "mafdecls.fh"

      DIMENSION SA(LDA,*)
      DIMENSION G3(NG3)
      INTEGER*1 idxG3(6,NG3)

      INTEGER*4, ALLOCATABLE :: SCOUNTS(:), RCOUNTS(:)
      INTEGER*4, ALLOCATABLE :: SCOUNTS2(:), RCOUNTS2(:)
      INTEGER*4, ALLOCATABLE :: SDISPLS(:), RDISPLS(:)
      INTEGER*4, ALLOCATABLE :: SDISPLS2(:), RDISPLS2(:)

      INTEGER*4, ALLOCATABLE :: SENDIDX(:), RECVIDX(:)
      REAL*8,    ALLOCATABLE :: SENDVAL(:), RECVVAL(:)

      INTEGER*4, PARAMETER :: ONE4=1, TWO4=2
      INTEGER*4 :: IERROR4
      INTEGER, PARAMETER :: I4=KIND(ONE4)

      INTEGER, ALLOCATABLE :: IBUF(:)

      ! Since we are stuck with collective calls to MPI_Alltoallv in
      ! order to gather the elements, each process needs to loop over
      ! the same number of blocks.
      NG3MAX=NG3
      CALL GAIGOP_SCAL(NG3MAX,'max')
      IF (NG3MAX.EQ.0) RETURN

      ! basic information
      NPROCS=GA_NNODES()
      MYRANK=GA_NODEID()

      ALLOCATE(SCOUNTS(NPROCS))
      ALLOCATE(RCOUNTS(NPROCS))
      ALLOCATE(SCOUNTS2(NPROCS))
      ALLOCATE(RCOUNTS2(NPROCS))
      ALLOCATE(SDISPLS(NPROCS))
      ALLOCATE(RDISPLS(NPROCS))
      ALLOCATE(SDISPLS2(NPROCS))
      ALLOCATE(RDISPLS2(NPROCS))

      ALLOCATE(IBUF(NPROCS))

      ! The global SA matrix has already been allocated, so we need to
      ! find out how much memory is left for buffering (4 equally sized
      ! buffers for sending and receiving values and indices)
      CALL GETMEM('MAXMEM','MAX','REAL',IDUMMY,MAXMEM)
      MAXBUF=MIN(NINT(0.95D0*MAXMEM)/4,2000000000/8)

      ! Loop over blocks NG3B of NG3, so that 12*NG3B < MAXBUF/NPROCS.
      ! This guarantees that e.g. if all processes send all their data
      ! to one other, that process receives NPROCS*NG3B*12 elements
      ! in the receive buffer.
      NG3B=MAXBUF/(NPROCS*12)
      NG3B=MIN(NG3B,NG3MAX)
      CALL GAIGOP_SCAL(NG3B,'min')
      NBUF=12*NG3B

      ALLOCATE(SENDVAL(NBUF))
      ALLOCATE(SENDIDX(2*NBUF))

      ! Finally, we need some info on the layout of the global array in
      ! order to compute the process row of the row index.
      NAS=jHi-jLo+1
      NQOT=NAS/NPROCS
      NREM=NAS-NPROCS*NQOT

      NBLOCKS=(NG3MAX-1)/NG3B+1
      DO IBLOCK=1,NBLOCKS
        IG3STA=1+(IBLOCK-1)*NG3B
        IG3END=MIN(IG3STA+NG3B-1,NG3)

        SCOUNTS=0
        ! First pass to determine how many values will need to be sent
        ! to other processes. This is necessary to be able to allocate
        ! the buffer size and offsets.
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=MUL(IST,MUL(ISU,ISV))
          ixyzs=MUL(ISX,MUL(ISY,ISZ))
          if(ituvs.ne.ixyzs) CYCLE
          iTU=iT+NASHT*(iU-1)
          iVX=iV+NASHT*(iX-1)
          iYZ=iY+NASHT*(iZ-1)
          ! There are 12 equivalent cases, of which the second half
          ! reflects the S(tuv,xyz)=S(xyz,tuv) symmetry.

          ! - G(tuvxyz) -> SA(xut,vyz)
          jSYM=MUL(iSX,MUL(iSU,iST))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 300
          if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 200
          ! - G(vxtuyz) -> SA(uxv,tyz)
          jSYM=MUL(iSU,MUL(iSX,iSV))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - G(yzvxtu) -> SA(xzy,vtu)
          jSYM=MUL(iSX,MUL(iSZ,iSY))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - G(tuyzvx) -> SA(zut,yvx)
          jSYM=MUL(iSZ,MUL(iSU,iST))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
 200      CONTINUE
          ! - G(yztuvx) -> SA(uzy,tvx)
          jSYM=MUL(iSU,MUL(iSZ,iSY))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - G(vxyztu) -> SA(zxv,ytu)
          jSYM=MUL(iSZ,MUL(iSX,iSV))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
 300      CONTINUE
          if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) CYCLE
          if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) CYCLE
          if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) CYCLE
          if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) CYCLE
          ! - G(utxvzy) -> SA(vtu,xzy)
          jSYM=MUL(iSV,MUL(iST,iSU))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) CYCLE
          if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 400
          ! - G(xvutzy) -> SA(tvx,uzy)
          jSYM=MUL(iST,MUL(iSV,iSX))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - G(zyxvut) -> SA(vyz,xut)
          jSYM=MUL(iSV,MUL(iSY,iSZ))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - G(utzyxv) -> SA(ytu,zxv)
          jSYM=MUL(iSY,MUL(iST,iSU))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
 400      CONTINUE
          ! - G(zyutxv) -> SA(tyz,uxv)
          jSYM=MUL(iST,MUL(iSY,iSZ))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - G(xvzyut) -> SA(yvx,zut)
          jSYM=MUL(iSY,MUL(iSV,iSX))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
        END DO

        ! At this point, SCOUNTS contains the number of values generated
        ! for each process. Use them to determine the send offsets.
        IOFFSET=0
        DO I=1,NPROCS
          SDISPLS(I)=INT(IOFFSET,I4)
          IBUF(I)=IOFFSET
          IOFFSET=IOFFSET+SCOUNTS(I)
        END DO

        ! Second pass fills the buffers with values and indices
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=MUL(IST,MUL(ISU,ISV))
          ixyzs=MUL(ISX,MUL(ISY,ISZ))
          if(ituvs.ne.ixyzs) CYCLE
          iTU=iT+NASHT*(iU-1)
          iVX=iV+NASHT*(iX-1)
          iYZ=iY+NASHT*(iZ-1)
          G3VAL=-G3(iG3)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
C  - G(tuvxyz) -> SA(xut,vyz)
          jSYM=MUL(IASYM(iX),MUL(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iU,iT)-nTUVES(jSYM)
            ICOL=KTUV(iV,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 301
          if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 201
C  - G(vxtuyz) -> SA(uxv,tyz)
          jSYM=MUL(IASYM(iU),MUL(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iX,iV)-nTUVES(jSYM)
            ICOL=KTUV(iT,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(yzvxtu) -> SA(xzy,vtu)
          jSYM=MUL(IASYM(iX),MUL(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iZ,iY)-nTUVES(jSYM)
            ICOL=KTUV(iV,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(tuyzvx) -> SA(zut,yvx)
          jSYM=MUL(IASYM(iZ),MUL(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iU,iT)-nTUVES(jSYM)
            ICOL=KTUV(iY,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
 201      CONTINUE
C  - G(yztuvx) -> SA(uzy,tvx)
          jSYM=MUL(IASYM(iU),MUL(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iZ,iY)-nTUVES(jSYM)
            ICOL=KTUV(iT,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(vxyztu) -> SA(zxv,ytu)
          jSYM=MUL(IASYM(iZ),MUL(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iX,iV)-nTUVES(jSYM)
            ICOL=KTUV(iY,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
 301      CONTINUE
          if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) CYCLE
          if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) CYCLE
          if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) CYCLE
          if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) CYCLE
C  - G(utxvzy) -> SA(vtu,xzy)
          jSYM=MUL(IASYM(iV),MUL(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iT,iU)-nTUVES(jSYM)
            ICOL=KTUV(iX,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) CYCLE
          if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 401
C  - G(xvutzy) -> SA(tvx,uzy)
          jSYM=MUL(IASYM(iT),MUL(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iV,iX)-nTUVES(jSYM)
            ICOL=KTUV(iU,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(zyxvut) -> SA(vyz,xut)
          jSYM=MUL(IASYM(iV),MUL(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iY,iZ)-nTUVES(jSYM)
            ICOL=KTUV(iX,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(utzyxv) -> SA(ytu,zxv)
          jSYM=MUL(IASYM(iY),MUL(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iT,iU)-nTUVES(jSYM)
            ICOL=KTUV(iZ,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
 401      CONTINUE
C  - G(zyutxv) -> SA(tyz,uxv)
          jSYM=MUL(IASYM(iT),MUL(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iY,iZ)-nTUVES(jSYM)
            ICOL=KTUV(iU,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(xvzyut) -> SA(yvx,zut)
          jSYM=MUL(IASYM(iY),MUL(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iV,iX)-nTUVES(jSYM)
            ICOL=KTUV(iZ,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
        END DO

        ! Now we need to determine the receive counts.
        CALL MPI_ALLTOALL(SCOUNTS, ONE4, MPI_INTEGER4,
     &                    RCOUNTS, ONE4, MPI_INTEGER4,
     &                    MPI_COMM_WORLD, IERROR4)

        IOFFSET=0
        DO I=1,NPROCS
          RDISPLS(I)=INT(IOFFSET,I4)
          IOFFSET=IOFFSET+RCOUNTS(I)
          SCOUNTS2(I)=TWO4*SCOUNTS(I)
          RCOUNTS2(I)=TWO4*RCOUNTS(I)
          SDISPLS2(I)=TWO4*SDISPLS(I)
          RDISPLS2(I)=TWO4*RDISPLS(I)
        END DO
        NRECV=IOFFSET

        ALLOCATE(RECVVAL(NRECV))
        ALLOCATE(RECVIDX(2*NRECV))

        ! Now, it is time to collect the appropriate values and indices
        ! in their respective receive buffers.
        CALL MPI_ALLTOALLV(SENDVAL, SCOUNTS, SDISPLS, MPI_REAL8,
     &                     RECVVAL, RCOUNTS, RDISPLS, MPI_REAL8,
     &                     MPI_COMM_WORLD, IERROR4)
        CALL MPI_ALLTOALLV(SENDIDX, SCOUNTS2, SDISPLS2, MPI_INTEGER4,
     &                     RECVIDX, RCOUNTS2, RDISPLS2, MPI_INTEGER4,
     &                     MPI_COMM_WORLD, IERROR4)

        ! Finally, fill the local chunk of the SA matrix (block of rows)
        ! with the received values at their appropriate place.
        DO I=1,NRECV
          ISUP=RECVIDX(2*I-1)
          JSUP=RECVIDX(2*I)
          SA(ISUP-ILO+1,JSUP-JLO+1)=RECVVAL(I)
        END DO

        DEALLOCATE(RECVVAL)
        DEALLOCATE(RECVIDX)

      END DO ! end loop over blocks of G3 values

      DEALLOCATE(SENDVAL)
      DEALLOCATE(SENDIDX)

      DEALLOCATE(SCOUNTS)
      DEALLOCATE(RCOUNTS)
      DEALLOCATE(SCOUNTS2)
      DEALLOCATE(RCOUNTS2)
      DEALLOCATE(SDISPLS)
      DEALLOCATE(RDISPLS)
      DEALLOCATE(SDISPLS2)
      DEALLOCATE(RDISPLS2)

      DEALLOCATE(IBUF)

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL UNUSED_INTEGER(iHi)

      CONTAINS

      PURE INTEGER FUNCTION IPROW(IROW,NQOT,NREM)
      INTEGER, INTENT(IN) :: IROW, NQOT, NREM
      INTEGER :: TMP
      TMP=IROW-NREM*(NQOT+1)
      IF (TMP.GT.0) THEN
        IPROW=(TMP-1)/NQOT+NREM+1
      ELSE
        IPROW=(IROW-1)/(NQOT+1)+1
      END IF
      END FUNCTION

      END
#endif

      SUBROUTINE MKSA_DP (DREF,PREF,iSYM,SA,iLo,iHi,jLo,jHi,LDA)
C In parallel, this subroutine is called on a local chunk of memory
C and LDA is set. In serial, the whole array is passed but then the
C storage uses a triangular scheme, and the LDA passed is zero.
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

      DIMENSION DREF(NDREF),PREF(NPREF)
      DIMENSION SA(*)

      ISADR=0
C-SVC20100831: fill in the G2 and G1 corrections for SA
      DO 100 IXYZ=jLo,jHi
        IXYZABS=IXYZ+NTUVES(ISYM)
        IXABS=MTUV(1,IXYZABS)
        IYABS=MTUV(2,IXYZABS)
        IZABS=MTUV(3,IXYZABS)
        DO 101 ITUV=iLo,iHi
          ITUVABS=ITUV+NTUVES(ISYM)
          ITABS=MTUV(1,ITUVABS)
          IUABS=MTUV(2,ITUVABS)
          IVABS=MTUV(3,ITUVABS)
C Add  2 dtx Gvuyz + 2 dtx dyu Gvz
          IF (LDA.NE.0) THEN
            VALUE=SA(1+(iTUV-iLo)+LDA*(iXYZ-jLo))
          ELSE
            IF (IXYZ.LE.ITUV) THEN
              ISADR=(ITUV*(ITUV-1))/2+IXYZ
              VALUE=SA(ISADR)
            ELSE
              GOTO 101
            ENDIF
          END IF
          IF(ITABS.EQ.IXABS) THEN
            IVU=IVABS+NASHT*(IUABS-1)
            IYZ=IYABS+NASHT*(IZABS-1)
            IP1=MAX(IVU,IYZ)
            IP2=MIN(IVU,IYZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE+4.0D0*PREF(IP)
            IF(IYABS.EQ.IUABS)THEN
              ID1=MAX(IVABS,IZABS)
              ID2=MIN(IVABS,IZABS)
              ID=(ID1*(ID1-1))/2+ID2
              VALUE=VALUE+2.0D0*DREF(ID)
            END IF
          END IF
C Add  -dxu Gvtyz -dxu dyt Gvz
          IF(IXABS.EQ.IUABS) THEN
            IVT=IVABS+NASHT*(ITABS-1)
            IYZ=IYABS+NASHT*(IZABS-1)
            IP1=MAX(IVT,IYZ)
            IP2=MIN(IVT,IYZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE - 2.0D0*PREF(IP)
            IF(IYABS.EQ.ITABS)THEN
              ID1=MAX(IVABS,IZABS)
              ID2=MIN(IVABS,IZABS)
              ID=(ID1*(ID1-1))/2+ID2
              VALUE=VALUE - DREF(ID)
            END IF
          END IF
C Add  -dyt Gvuxz
          IF(IYABS.EQ.ITABS) THEN
            IVU=IVABS+NASHT*(IUABS-1)
            IXZ=IXABS+NASHT*(IZABS-1)
            IP1=MAX(IVU,IXZ)
            IP2=MIN(IVU,IXZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE - 2.0D0*PREF(IP)
          END IF
C Add -dyu Gvzxt
          IF(IYABS.EQ.IUABS) THEN
            IVZ=IVABS+NASHT*(IZABS-1)
            IXT=IXABS+NASHT*(ITABS-1)
            IP1=MAX(IVZ,IXT)
            IP2=MIN(IVZ,IXT)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE - 2.0D0*PREF(IP)
          END IF
          IF (LDA.NE.0) THEN
            SA(1+(iTUV-iLo)+LDA*(iXYZ-jLo))=VALUE
          ELSE
            SA(ISADR)=VALUE
          END IF
 101    CONTINUE
 100  CONTINUE
      END

********************************************************************************
* Case C (ICASE=4)
********************************************************************************
      SUBROUTINE MKSC(DREF,PREF,NG3,G3,idxG3)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      DIMENSION DREF(NDREF),PREF(NPREF),G3(NG3)
      INTEGER*1 idxG3(6,NG3)

      ICASE=4
C LONG loop over superindex symmetry.
      DO ISYM=1,NSYM
        NIN=NINDEP(ISYM,ICASE)
        IF(NIN.EQ.0) CYCLE
        NAS=NTUV(ISYM)
        NSC=(NAS*(NAS+1))/2
        IF(NSC.LE.0) CYCLE

C Set up the matrix SC(tuv,xyz) defined by the expression
C <atuv|cxyz> = dac SC(tuv,xyz)
C Formula used:
C    SC(tuv,xyz)
C    = Gvutxyz +dyu Gvztx + dyx Gvutz + dtu Gvxyz + dtu dyx Gvz

        CALL PSBMAT_GETMEM('SC',lg_SC,NAS)

        ! fill in the 3-el parts
#ifdef _MOLCAS_MPP_
        IF (IS_REAL_PAR()) THEN
          MYRANK = GA_NODEID()
          CALL GA_DISTRIBUTION (LG_SC,MYRANK,ILO,IHI,JLO,JHI)
          IF (JLO.NE.0 .AND. (JHI-JLO+1).NE.NAS) THEN
            WRITE(6,*) 'MKSC: MISMATCH IN RANGE OF THE SUPERINDICES'
            CALL ABEND()
          END IF
          IF (ILO.GT.0 .AND. JLO.GT.0) THEN
            CALL GA_ACCESS (LG_SC,ILO,IHI,JLO,JHI,MC,LDC)
            CALL MKSC_G3_MPP(ISYM,DBL_MB(MC),ILO,IHI,JLO,JHI,LDC,
     &                       NG3,G3,IDXG3)
            CALL MKSC_DP(DREF,PREF,ISYM,DBL_MB(MC),ILO,IHI,JLO,JHI,LDC)
            CALL GA_RELEASE_UPDATE (LG_SC,ILO,IHI,JLO,JHI)
          ELSE
            CALL MKSC_G3_MPP(ISYM,WORK(IP_DUMMY),ILO,IHI,JLO,JHI,LDC,
     &                       NG3,G3,IDXG3)
          END IF
        ELSE
          CALL MKSC_G3(ISYM,WORK(LG_SC),NG3,G3,IDXG3)
          CALL MKSC_DP(DREF,PREF,ISYM,WORK(lg_SC),1,NAS,1,NAS,0)
        END IF
#else
        call MKSC_G3(ISYM,WORK(lg_SC),NG3,G3,idxG3)
        CALL MKSC_DP(DREF,PREF,ISYM,WORK(lg_SC),1,NAS,1,NAS,0)
#endif

        CALL PSBMAT_WRITE('S',iCase,iSYM,lg_SC,NAS)

        IF(IPRGLB.GE.DEBUG) THEN
          DSC=PSBMAT_FPRINT(lg_SC,NAS)
          WRITE(6,'("DEBUG> ",A4,1X,I3,1X,ES21.14)') 'C', ISYM, DSC
        END IF

        CALL PSBMAT_FREEMEM('SC',lg_SC,NAS)
      END DO

      END

      SUBROUTINE MKSC_G3(ISYM,SC,NG3,G3,idxG3)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

      DIMENSION SC(*)
      DIMENSION G3(NG3)
      INTEGER*1 idxG3(6,NG3)

C-SVC20100831: determine indices in SC where a certain G3 value will end up
      DO iG3=1,NG3
        iT=idxG3(1,iG3)
        iU=idxG3(2,iG3)
        iV=idxG3(3,iG3)
        iX=idxG3(4,iG3)
        iY=idxG3(5,iG3)
        iZ=idxG3(6,iG3)
        iST=IASYM(iT)
        iSU=IASYM(iU)
        iSV=IASYM(iV)
        iSX=IASYM(iX)
        iSY=IASYM(iY)
        iSZ=IASYM(iZ)
        ituvs=MUL(IST,MUL(ISU,ISV))
        ixyzs=MUL(ISX,MUL(ISY,ISZ))
        if(ituvs.ne.ixyzs) goto 500
        iTU=iT+NASHT*(iU-1)
        iVX=iV+NASHT*(iX-1)
        iYZ=iY+NASHT*(iZ-1)
        G3VAL=G3(iG3)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
C  - G(tuvxyz) -> SC(vut,xyz)
        jSYM=MUL(IASYM(iV),MUL(IASYM(iU),IASYM(iT)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iV,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iX,iY,iZ)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
        if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 300
        if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 200
C  - G(vxtuyz) -> SC(txv,uyz)
        jSYM=MUL(IASYM(iT),MUL(IASYM(iX),IASYM(iV)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iT,iX,iV)-nTUVES(jSYM)
          JSUP=KTUV(iU,iY,iZ)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(yzvxtu) -> SC(vzy,xtu)
        jSYM=MUL(IASYM(iV),MUL(IASYM(iZ),IASYM(iY)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iV,iZ,iY)-nTUVES(jSYM)
          JSUP=KTUV(iX,iT,iU)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(tuyzvx) -> SC(yut,zvx)
        jSYM=MUL(IASYM(iY),MUL(IASYM(iU),IASYM(iT)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iY,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iZ,iV,iX)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
 200   CONTINUE
C  - G(yztuvx) -> SC(tzy,uvx)
        jSYM=MUL(IASYM(iT),MUL(IASYM(iZ),IASYM(iY)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iT,iZ,iY)-nTUVES(jSYM)
          JSUP=KTUV(iU,iV,iX)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(vxyztu) -> SC(yxv,ztu)
        jSYM=MUL(IASYM(iY),MUL(IASYM(iX),IASYM(iV)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iY,iX,iV)-nTUVES(jSYM)
          JSUP=KTUV(iZ,iT,iU)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
 300   CONTINUE
        if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) go to 500
        if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) go to 500
        if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) go to 500
        if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) go to 500
C  - G(utxvzy) -> SC(xtu,vzy)
        jSYM=MUL(IASYM(iX),MUL(IASYM(iT),IASYM(iU)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iX,iT,iU)-nTUVES(jSYM)
          JSUP=KTUV(iV,iZ,iY)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
        if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 500
        if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 400
C  - G(xvutzy) -> SC(uvx,tzy)
        jSYM=MUL(IASYM(iU),MUL(IASYM(iV),IASYM(iX)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iU,iV,iX)-nTUVES(jSYM)
          JSUP=KTUV(iT,iZ,iY)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(zyxvut) -> SC(xyz,vut)
        jSYM=MUL(IASYM(iX),MUL(IASYM(iY),IASYM(iZ)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iX,iY,iZ)-nTUVES(jSYM)
          JSUP=KTUV(iV,iU,iT)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(utzyxv) -> SC(ztu,yxv)
        jSYM=MUL(IASYM(iZ),MUL(IASYM(iT),IASYM(iU)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iZ,iT,iU)-nTUVES(jSYM)
          JSUP=KTUV(iY,iX,iV)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
 400   CONTINUE
C  - G(zyutxv) -> SC(uyz,txv)
        jSYM=MUL(IASYM(iU),MUL(IASYM(iY),IASYM(iZ)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iU,iY,iZ)-nTUVES(jSYM)
          JSUP=KTUV(iT,iX,iV)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
C  - G(xvzyut) -> SC(zvx,yut)
        jSYM=MUL(IASYM(iZ),MUL(IASYM(iV),IASYM(iX)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iZ,iV,iX)-nTUVES(jSYM)
          JSUP=KTUV(iY,iU,iT)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            SC(ISADR)=G3VAL
          END IF
        ENDIF
 500   CONTINUE
      END DO

      RETURN
      END

#ifdef _MOLCAS_MPP_
      SUBROUTINE MKSC_G3_MPP(ISYM,SC,iLo,iHi,jLo,jHi,LDC,
     &                       NG3,G3,idxG3)
      USE MPI
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

#include "global.fh"
#include "mafdecls.fh"

      DIMENSION SC(LDC,*)
      DIMENSION G3(NG3)
      INTEGER*1 idxG3(6,NG3)

      INTEGER*4, ALLOCATABLE :: SCOUNTS(:), RCOUNTS(:)
      INTEGER*4, ALLOCATABLE :: SCOUNTS2(:), RCOUNTS2(:)
      INTEGER*4, ALLOCATABLE :: SDISPLS(:), RDISPLS(:)
      INTEGER*4, ALLOCATABLE :: SDISPLS2(:), RDISPLS2(:)

      INTEGER*4, ALLOCATABLE :: SENDIDX(:), RECVIDX(:)
      REAL*8,    ALLOCATABLE :: SENDVAL(:), RECVVAL(:)

      INTEGER*4, PARAMETER :: ONE4=1, TWO4=2
      INTEGER*4 :: IERROR4
      INTEGER, PARAMETER :: I4=KIND(ONE4)

      INTEGER, ALLOCATABLE :: IBUF(:)

      ! Since we are stuck with collective calls to MPI_Alltoallv in
      ! order to gather the elements, each process needs to loop over
      ! the same number of blocks.
      NG3MAX=NG3
      CALL GAIGOP_SCAL(NG3MAX,'max')
      IF (NG3MAX.EQ.0) RETURN

      ! basic information
      NPROCS=GA_NNODES()
      MYRANK=GA_NODEID()

      ALLOCATE(SCOUNTS(NPROCS))
      ALLOCATE(RCOUNTS(NPROCS))
      ALLOCATE(SCOUNTS2(NPROCS))
      ALLOCATE(RCOUNTS2(NPROCS))
      ALLOCATE(SDISPLS(NPROCS))
      ALLOCATE(RDISPLS(NPROCS))
      ALLOCATE(SDISPLS2(NPROCS))
      ALLOCATE(RDISPLS2(NPROCS))

      ALLOCATE(IBUF(NPROCS))

      ! The global SC matrix has already been allocated, so we need to
      ! find out how much memory is left for buffering (4 equally sized
      ! buffers for sending and receiving values and indices)
      CALL GETMEM('MAXMEM','MAX','REAL',IDUMMY,MAXMEM)
      MAXBUF=MIN(NINT(0.95D0*MAXMEM)/4,2000000000/8)

      ! Loop over blocks NG3B of NG3, so that 12*NG3B < MAXBUF/NPROCS.
      ! This guarantees that e.g. if all processes send all their data
      ! to one other, that process receives NPROCS*NG3B*12 elements
      ! in the receive buffer.
      NG3B=MAXBUF/(NPROCS*12)
      NG3B=MIN(NG3B,NG3MAX)
      CALL GAIGOP_SCAL(NG3B,'min')
      NBUF=12*NG3B

      ALLOCATE(SENDVAL(NBUF))
      ALLOCATE(SENDIDX(2*NBUF))

      ! Finally, we need some info on the layout of the global array in
      ! order to compute the process row of the row index.
      NAS=jHi-jLo+1
      NQOT=NAS/NPROCS
      NREM=NAS-NPROCS*NQOT

      NBLOCKS=(NG3MAX-1)/NG3B+1
      DO IBLOCK=1,NBLOCKS
        IG3STA=1+(IBLOCK-1)*NG3B
        IG3END=MIN(IG3STA+NG3B-1,NG3)

        SCOUNTS=0
        ! First pass to determine how many values will need to be sent
        ! to other processes. This is necessary to be able to allocate
        ! the buffer size and offsets.
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=MUL(IST,MUL(ISU,ISV))
          ixyzs=MUL(ISX,MUL(ISY,ISZ))
          if(ituvs.ne.ixyzs) goto 500
          iTU=iT+NASHT*(iU-1)
          iVX=iV+NASHT*(iX-1)
          iYZ=iY+NASHT*(iZ-1)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
C  - G(tuvxyz) -> SC(vut,xyz)
          jSYM=MUL(IASYM(iV),MUL(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 300
          if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 200
C  - G(vxtuyz) -> SC(txv,uyz)
          jSYM=MUL(IASYM(iT),MUL(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - G(yzvxtu) -> SC(vzy,xtu)
          jSYM=MUL(IASYM(iV),MUL(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - G(tuyzvx) -> SC(yut,zvx)
          jSYM=MUL(IASYM(iY),MUL(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
 200   CONTINUE
C  - G(yztuvx) -> SC(tzy,uvx)
          jSYM=MUL(IASYM(iT),MUL(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - G(vxyztu) -> SC(yxv,ztu)
          jSYM=MUL(IASYM(iY),MUL(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
 300   CONTINUE
          if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) go to 500
          if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) go to 500
          if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) go to 500
          if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) go to 500
C  - G(utxvzy) -> SC(xtu,vzy)
          jSYM=MUL(IASYM(iX),MUL(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 500
          if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 400
C  - G(xvutzy) -> SC(uvx,tzy)
          jSYM=MUL(IASYM(iU),MUL(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - G(zyxvut) -> SC(xyz,vut)
          jSYM=MUL(IASYM(iX),MUL(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - G(utzyxv) -> SC(ztu,yxv)
          jSYM=MUL(IASYM(iZ),MUL(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
 400   CONTINUE
C  - G(zyutxv) -> SC(uyz,txv)
          jSYM=MUL(IASYM(iU),MUL(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - G(xvzyut) -> SC(zvx,yut)
          jSYM=MUL(IASYM(iZ),MUL(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
 500   CONTINUE
        END DO

        ! At this point, SCOUNTS contains the number of values generated
        ! for each process. Use them to determine the send offsets.
        IOFFSET=0
        DO I=1,NPROCS
          SDISPLS(I)=INT(IOFFSET,I4)
          IBUF(I)=IOFFSET
          IOFFSET=IOFFSET+SCOUNTS(I)
        END DO

        ! Second pass fills the buffers with values and indices
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=MUL(IST,MUL(ISU,ISV))
          ixyzs=MUL(ISX,MUL(ISY,ISZ))
          if(ituvs.ne.ixyzs) goto 501
          iTU=iT+NASHT*(iU-1)
          iVX=iV+NASHT*(iX-1)
          iYZ=iY+NASHT*(iZ-1)
          G3VAL=G3(iG3)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
C  - G(tuvxyz) -> SC(vut,xyz)
          jSYM=MUL(IASYM(iV),MUL(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iU,iT)-nTUVES(jSYM)
            ICOL=KTUV(iX,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 301
          if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 201
C  - G(vxtuyz) -> SC(txv,uyz)
          jSYM=MUL(IASYM(iT),MUL(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iX,iV)-nTUVES(jSYM)
            ICOL=KTUV(iU,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(yzvxtu) -> SC(vzy,xtu)
          jSYM=MUL(IASYM(iV),MUL(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iZ,iY)-nTUVES(jSYM)
            ICOL=KTUV(iX,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(tuyzvx) -> SC(yut,zvx)
          jSYM=MUL(IASYM(iY),MUL(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iU,iT)-nTUVES(jSYM)
            ICOL=KTUV(iZ,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
 201   CONTINUE
C  - G(yztuvx) -> SC(tzy,uvx)
          jSYM=MUL(IASYM(iT),MUL(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iZ,iY)-nTUVES(jSYM)
            ICOL=KTUV(iU,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(vxyztu) -> SC(yxv,ztu)
          jSYM=MUL(IASYM(iY),MUL(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iX,iV)-nTUVES(jSYM)
            ICOL=KTUV(iZ,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
 301   CONTINUE
          if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) go to 501
          if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) go to 501
          if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) go to 501
          if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) go to 501
C  - G(utxvzy) -> SC(xtu,vzy)
          jSYM=MUL(IASYM(iX),MUL(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iT,iU)-nTUVES(jSYM)
            ICOL=KTUV(iV,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) go to 501
          if (iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ) go to 401
C  - G(xvutzy) -> SC(uvx,tzy)
          jSYM=MUL(IASYM(iU),MUL(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iV,iX)-nTUVES(jSYM)
            ICOL=KTUV(iT,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(zyxvut) -> SC(xyz,vut)
          jSYM=MUL(IASYM(iX),MUL(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iY,iZ)-nTUVES(jSYM)
            ICOL=KTUV(iV,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(utzyxv) -> SC(ztu,yxv)
          jSYM=MUL(IASYM(iZ),MUL(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iT,iU)-nTUVES(jSYM)
            ICOL=KTUV(iY,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
 401   CONTINUE
C  - G(zyutxv) -> SC(uyz,txv)
          jSYM=MUL(IASYM(iU),MUL(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iY,iZ)-nTUVES(jSYM)
            ICOL=KTUV(iT,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - G(xvzyut) -> SC(zvx,yut)
          jSYM=MUL(IASYM(iZ),MUL(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iV,iX)-nTUVES(jSYM)
            ICOL=KTUV(iY,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=G3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
 501   CONTINUE
        END DO

        ! Now we need to determine the receive counts.
        CALL MPI_ALLTOALL(SCOUNTS, ONE4, MPI_INTEGER4,
     &                    RCOUNTS, ONE4, MPI_INTEGER4,
     &                    MPI_COMM_WORLD, IERROR4)

        IOFFSET=0
        DO I=1,NPROCS
          RDISPLS(I)=INT(IOFFSET,I4)
          IOFFSET=IOFFSET+RCOUNTS(I)
          SCOUNTS2(I)=TWO4*SCOUNTS(I)
          RCOUNTS2(I)=TWO4*RCOUNTS(I)
          SDISPLS2(I)=TWO4*SDISPLS(I)
          RDISPLS2(I)=TWO4*RDISPLS(I)
        END DO
        NRECV=IOFFSET

        ALLOCATE(RECVVAL(NRECV))
        ALLOCATE(RECVIDX(2*NRECV))

        ! Now, it is time to collect the appropriate values and indices
        ! in their respective receive buffers.
        CALL MPI_ALLTOALLV(SENDVAL, SCOUNTS, SDISPLS, MPI_REAL8,
     &                     RECVVAL, RCOUNTS, RDISPLS, MPI_REAL8,
     &                     MPI_COMM_WORLD, IERROR4)
        CALL MPI_ALLTOALLV(SENDIDX, SCOUNTS2, SDISPLS2, MPI_INTEGER4,
     &                     RECVIDX, RCOUNTS2, RDISPLS2, MPI_INTEGER4,
     &                     MPI_COMM_WORLD, IERROR4)

        ! Finally, fill the local chunk of the SC matrix (block of rows)
        ! with the received values at their appropriate place.
        DO I=1,NRECV
          ISUP=RECVIDX(2*I-1)
          JSUP=RECVIDX(2*I)
          SC(ISUP-ILO+1,JSUP-JLO+1)=RECVVAL(I)
        END DO

        DEALLOCATE(RECVVAL)
        DEALLOCATE(RECVIDX)

      END DO ! end loop over blocks of G3 values

      DEALLOCATE(SENDVAL)
      DEALLOCATE(SENDIDX)

      DEALLOCATE(SCOUNTS)
      DEALLOCATE(RCOUNTS)
      DEALLOCATE(SCOUNTS2)
      DEALLOCATE(RCOUNTS2)
      DEALLOCATE(SDISPLS)
      DEALLOCATE(RDISPLS)
      DEALLOCATE(SDISPLS2)
      DEALLOCATE(RDISPLS2)

      DEALLOCATE(IBUF)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL UNUSED_INTEGER(iHi)

      CONTAINS

      PURE INTEGER FUNCTION IPROW(IROW,NQOT,NREM)
      INTEGER, INTENT(IN) :: IROW, NQOT, NREM
      INTEGER :: TMP
      TMP=IROW-NREM*(NQOT+1)
      IF (TMP.GT.0) THEN
        IPROW=(TMP-1)/NQOT+NREM+1
      ELSE
        IPROW=(IROW-1)/(NQOT+1)+1
      END IF
      END FUNCTION

      END
#endif

      SUBROUTINE MKSC_DP (DREF,PREF,iSYM,SC,iLo,iHi,jLo,jHi,LDC)
C In parallel, this subroutine is called on a local chunk of memory
C and LDC is set. In serial, the whole array is passed but then the
C storage uses a triangular scheme, and the LDC passed is zero.
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

      DIMENSION DREF(NDREF),PREF(NPREF)
      DIMENSION SC(*)

      ISADR=0
C-SVC20100831: fill in the G2 and G1 corrections for this SC block
      DO 100 IXYZ=jLo,jHi
        IXYZABS=IXYZ+NTUVES(ISYM)
        IXABS=MTUV(1,IXYZABS)
        IYABS=MTUV(2,IXYZABS)
        IZABS=MTUV(3,IXYZABS)
        DO 101 ITUV=iLo,iHi
          ITUVABS=ITUV+NTUVES(ISYM)
          ITABS=MTUV(1,ITUVABS)
          IUABS=MTUV(2,ITUVABS)
          IVABS=MTUV(3,ITUVABS)
          IF (LDC.NE.0) THEN
            VALUE=SC(1+iTUV-iLo+LDC*(iXYZ-jLo))
          ELSE
            IF (IXYZ.LE.ITUV) THEN
              ISADR=(ITUV*(ITUV-1))/2+IXYZ
              VALUE=SC(ISADR)
            ELSE
              GOTO 101
            ENDIF
          END IF
C Add  dyu Gvztx
          IF(IYABS.EQ.IUABS) THEN
            IVZ=IVABS+NASHT*(IZABS-1)
            ITX=ITABS+NASHT*(IXABS-1)
            IP1=MAX(IVZ,ITX)
            IP2=MIN(IVZ,ITX)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE+2.0D0*PREF(IP)
          END IF
C Add  dyx Gvutz
          IF(IYABS.EQ.IXABS) THEN
            IVU=IVABS+NASHT*(IUABS-1)
            ITZ=ITABS+NASHT*(IZABS-1)
            IP1=MAX(IVU,ITZ)
            IP2=MIN(IVU,ITZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE+2.0D0*PREF(IP)
          END IF
C Add  dtu Gvxyz + dtu dyx Gvz
          IF(ITABS.EQ.IUABS) THEN
            IVX=IVABS+NASHT*(IXABS-1)
            IYZ=IYABS+NASHT*(IZABS-1)
            IP1=MAX(IVX,IYZ)
            IP2=MIN(IVX,IYZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE+2.0D0*PREF(IP)
            IF(IYABS.EQ.IXABS) THEN
              ID1=MAX(IVABS,IZABS)
              ID2=MIN(IVABS,IZABS)
              VALUE=VALUE+DREF((ID1*(ID1-1))/2+ID2)
            END IF
          END IF
          IF (LDC.NE.0) THEN
            SC(1+iTUV-iLo+LDC*(iXYZ-jLo))=VALUE
          ELSE
            SC(ISADR)=VALUE
          END IF
 101    CONTINUE
 100  CONTINUE
      END

********************************************************************************
* Case B (ICASE=2,3)
********************************************************************************
      SUBROUTINE MKSB(DREF,PREF)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

      DIMENSION DREF(NDREF),PREF(NPREF)

C Set up the matrices SBP(tu,xy) and SBM(tu,xy)
C Formulae used:
C    SB(tu,xy)=
C    = 4 Pxtyu -4dxt Dyu -4dyu Dxt +2dyt Dxu + 8 dxt dyu
C      -4dxu dyt + 2dxu Dyt
C    SBP(tu,xy)=SB(tu,xy)+SB(tu,yx)
C    SBM(tu,xy)=SB(tu,xy)-SB(tu,yx)


C Loop over superindex symmetry.
      DO 1000 ISYM=1,NSYM
        NINP=NINDEP(ISYM,2)
        IF(NINP.EQ.0) GOTO 1000
        NAS=NTU(ISYM)
        NSB=(NAS*(NAS+1))/2
        IF(NSB.GT.0) THEN
          CALL GETMEM('SB','ALLO','REAL',LSB,NSB)
        END IF
        DO 100 ITU=1,NAS
          ITUABS=ITU+NTUES(ISYM)
          ITABS=MTU(1,ITUABS)
          IUABS=MTU(2,ITUABS)
          DO 101 IXY=1,ITU
            IXYABS=IXY+NTUES(ISYM)
            IXABS=MTU(1,IXYABS)
            IYABS=MTU(2,IXYABS)
            ISADR=(ITU*(ITU-1))/2+IXY
            IXT=IXABS+NASHT*(ITABS-1)
            IYU=IYABS+NASHT*(IUABS-1)
            IP1=MAX(IXT,IYU)
            IP2=MIN(IXT,IYU)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=4.0D0*PREF(IP)
C Add  -4 dxt Dyu + 8dxt dyu
            IF(IXABS.EQ.ITABS) THEN
              ID1=MAX(IYABS,IUABS)
              ID2=MIN(IYABS,IUABS)
              ID=(ID1*(ID1-1))/2+ID2
              VALUE=VALUE-4.0D0*DREF(ID)
              IF(IYABS.EQ.IUABS) VALUE=VALUE+8.0D00
            END IF
C Add  -4 dyu Dxt
            IF(IYABS.EQ.IUABS) THEN
              ID1=MAX(IXABS,ITABS)
              ID2=MIN(IXABS,ITABS)
              ID=(ID1*(ID1-1))/2+ID2
              VALUE=VALUE-4.0D0*DREF(ID)
            END IF
C Add  +2 dyt Dxu
            IF(IYABS.EQ.ITABS) THEN
              ID1=MAX(IXABS,IUABS)
              ID2=MIN(IXABS,IUABS)
              ID=(ID1*(ID1-1))/2+ID2
              VALUE=VALUE+2.0D0*DREF(ID)
            END IF
C Add  -4dxu dyt + 2dxu Dyt
            IF(IXABS.EQ.IUABS) THEN
              ID1=MAX(IYABS,ITABS)
              ID2=MIN(IYABS,ITABS)
              ID=(ID1*(ID1-1))/2+ID2
              VALUE=VALUE+2.0D0*DREF(ID)
              IF(IYABS.EQ.ITABS) VALUE=VALUE-4.0D00
            END IF
            ISADR=(ITU*(ITU-1))/2+IXY
            WORK(LSB-1+ISADR)=VALUE
 101      CONTINUE
 100    CONTINUE
        NASP=NTGEU(ISYM)
        NSBP=(NASP*(NASP+1))/2
        IF(NSBP.GT.0) THEN
          CALL GETMEM('SBP','ALLO','REAL',LSBP,NSBP)
        END IF
        NASM=NTGTU(ISYM)
        NSBM=(NASM*(NASM+1))/2
        IF(NSBM.GT.0) THEN
          CALL GETMEM('SBM','ALLO','REAL',LSBM,NSBM)
        END IF
        DO 200 ITGEU=1,NASP
          ITGEUABS=ITGEU+NTGEUES(ISYM)
          ITABS=MTGEU(1,ITGEUABS)
          IUABS=MTGEU(2,ITGEUABS)
          ITU=KTU(ITABS,IUABS)-NTUES(ISYM)
          DO 201 IXGEY=1,ITGEU
            IXGEYABS=IXGEY+NTGEUES(ISYM)
            IXABS=MTGEU(1,IXGEYABS)
            IYABS=MTGEU(2,IXGEYABS)
            IXY=KTU(IXABS,IYABS)-NTUES(ISYM)
            IYX=KTU(IYABS,IXABS)-NTUES(ISYM)
            IF(ITU.GE.IXY) THEN
              ISADR=(ITU*(ITU-1))/2+IXY
            ELSE
              ISADR=(IXY*(IXY-1))/2+ITU
            END IF
            STUXY=WORK(LSB-1+ISADR)
            IF(ITU.GE.IYX) THEN
              ISADR=(ITU*(ITU-1))/2+IYX
            ELSE
              ISADR=(IYX*(IYX-1))/2+ITU
            END IF
            STUYX=WORK(LSB-1+ISADR)
            ISPADR=(ITGEU*(ITGEU-1))/2+IXGEY
            WORK(LSBP-1+ISPADR)=STUXY+STUYX
            IF(ITABS.EQ.IUABS) GOTO 201
            IF(IXABS.EQ.IYABS) GOTO 201
            ITGTU=KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
            IXGTY=KTGTU(IXABS,IYABS)-NTGTUES(ISYM)
            ISMADR=(ITGTU*(ITGTU-1))/2+IXGTY
            WORK(LSBM-1+ISMADR)=STUXY-STUYX
 201      CONTINUE
 200    CONTINUE
        IF(NSB.GT.0) THEN
          CALL GETMEM('SB','FREE','REAL',LSB,NSB)
        END IF

C Write to disk, and save size and address.
        IF(NSBP.GT.0) THEN
          IDISK=IDSMAT(ISYM,2)
          CALL DDAFILE(LUSBT,1,WORK(LSBP),NSBP,IDISK)
          CALL GETMEM('SBP','FREE','REAL',LSBP,NSBP)
        END IF
        IF(NSBM.GT.0) THEN
          IF(NINDEP(ISYM,3).GT.0) THEN
            IDISK=IDSMAT(ISYM,3)
            CALL DDAFILE(LUSBT,1,WORK(LSBM),NSBM,IDISK)
          END IF
          CALL GETMEM('SBM','FREE','REAL',LSBM,NSBM)
        END IF
 1000 CONTINUE


      RETURN
      END

      SUBROUTINE MKSD(DREF,PREF)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

      DIMENSION DREF(NDREF),PREF(NPREF)

C Set up the matrix SD(tuP,xyQ),P and Q are 1 or 2,
C Formulae used:
C    SD(tu1,xy1)=2*(Gutxy + dxt Duy)
C    SD(tu2,xy1)= -(Gutxy + dxt Duy)
C    SD(tu2,xy2)= -Gxtuy +2*dxt Duy


C Loop over superindex symmetry.
      DO 1000 ISYM=1,NSYM
        NIN=NINDEP(ISYM,5)
        IF(NIN.EQ.0) GOTO 1000
        NAS=NTU(ISYM)
        NSD=(2*NAS*(2*NAS+1))/2
        IF(NSD.GT.0) THEN
          CALL GETMEM('SD','ALLO','REAL',LSD,NSD)
        END IF
        DO 100 ITU=1,NAS
        ITU2=ITU+NAS
          ITUABS=ITU+NTUES(ISYM)
          ITABS=MTU(1,ITUABS)
          IUABS=MTU(2,ITUABS)
          DO 101 IXY=1,ITU
            IXY2=IXY+NAS
            IXYABS=IXY+NTUES(ISYM)
            IXABS=MTU(1,IXYABS)
            IYABS=MTU(2,IXYABS)
            IS11=(ITU*(ITU-1))/2+IXY
            IS21=(ITU2*(ITU2-1))/2+IXY
            IS12=(IXY2*(IXY2-1))/2+ITU
            IS22=(ITU2*(ITU2-1))/2+IXY2
            IUTP=IUABS+NASHT*(ITABS-1)
            IXYP=IXABS+NASHT*(IYABS-1)
            IP1=MAX(IUTP,IXYP)
            IP2=MIN(IUTP,IXYP)
            IP=(IP1*(IP1-1))/2+IP2
            GUTXY=2.0D0*PREF(IP)
            IXTP=IXABS+NASHT*(ITABS-1)
            IUYP=IUABS+NASHT*(IYABS-1)
            IP1=MAX(IXTP,IUYP)
            IP2=MIN(IXTP,IUYP)
            IP=(IP1*(IP1-1))/2+IP2
            GXTUY=2.0D0*PREF(IP)
            S11=2.0D0*GUTXY
            S22=-GXTUY
            IF(IXABS.EQ.ITABS) THEN
              ID1=MAX(IUABS,IYABS)
              ID2=MIN(IUABS,IYABS)
              ID=(ID1*(ID1-1))/2+ID2
              DUY=DREF(ID)
              S11=S11+2.0D0*DUY
              S22=S22+2.0D0*DUY
            END IF
C    SD(tu1,xy1)=2*(Gutxy + dtx Duy)
            WORK(LSD-1+IS11)= S11
C    SD(tu2,xy1)= -(Gutxy + dtx Duy)
            WORK(LSD-1+IS21)=-0.5D0*S11
            WORK(LSD-1+IS12)=-0.5D0*S11
C    SD(tu2,xy2)= -Gxtuy +2*dtx Duy
            WORK(LSD-1+IS22)= S22
 101      CONTINUE
 100    CONTINUE

C Write to disk
        IF(NSD.GT.0) THEN
         IF(NINDEP(ISYM,5).GT.0) THEN
          IDISK=IDSMAT(ISYM,5)
          CALL DDAFILE(LUSBT,1,WORK(LSD),NSD,IDISK)
         END IF
         CALL GETMEM('SD','FREE','REAL',LSD,NSD)
        END IF
 1000 CONTINUE


      RETURN
      END

      SUBROUTINE MKSE(DREF)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

      DIMENSION DREF(NDREF)

C Set up the matrix SE(t,x)
C Formula used:
C    SE(t,x)=2*dtx - Dtx



      DO 1000 ISYM=1,NSYM
        NINP=NINDEP(ISYM,6)
        IF(NINP.EQ.0) GOTO 1000
        NINM=NINDEP(ISYM,7)
        NAS=NASH(ISYM)
        NSE=(NAS*(NAS+1))/2
        IF(NSE.GT.0) CALL GETMEM('SE','ALLO','REAL',LSE,NSE)
        DO 100 IT=1,NAS
          ITABS=IT+NAES(ISYM)
          DO 101 IX=1,IT
            IXABS=IX+NAES(ISYM)
            ISE=(IT*(IT-1))/2+IX
            ID=(ITABS*(ITABS-1))/2+IXABS
            IF(ITABS.EQ.IXABS) THEN
              WORK(LSE-1+ISE)=2.0D00-DREF(ID)
            ELSE
              WORK(LSE-1+ISE)=-DREF(ID)
            END IF
 101      CONTINUE
 100    CONTINUE

C Write to disk
        IF(NSE.GT.0.and.NINDEP(ISYM,6).GT.0) THEN
          IDISK=IDSMAT(ISYM,6)
          CALL DDAFILE(LUSBT,1,WORK(LSE),NSE,IDISK)
          IF(NINM.GT.0.and.NINDEP(ISYM,7).GT.0) THEN
            IDISK=IDSMAT(ISYM,7)
            CALL DDAFILE(LUSBT,1,WORK(LSE),NSE,IDISK)
          END IF
          CALL GETMEM('SE','FREE','REAL',LSE,NSE)
        END IF
 1000 CONTINUE


      RETURN
      END

      SUBROUTINE MKSF(PREF)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

      DIMENSION PREF(NPREF)

C Set up the matrices SFP(tu,xy) and SFM(tu,xy)
C Formulae used:
C    SF(tu,xy)= 4 Ptxuy
C    SFP(tu,xy)=SF(tu,xy)+SF(tu,yx)
C    SFM(tu,xy)=SF(tu,xy)-SF(tu,yx)



C Loop over superindex symmetry.
      DO 1000 ISYM=1,NSYM
        NINP=NINDEP(ISYM,8)
        IF(NINP.EQ.0) GOTO 1000
        NAS=NTU(ISYM)
        NSF=(NAS*(NAS+1))/2
        IF(NSF.GT.0) THEN
          CALL GETMEM('SF','ALLO','REAL',LSF,NSF)
        END IF
        DO 100 ITU=1,NAS
          ITUABS=ITU+NTUES(ISYM)
          ITABS=MTU(1,ITUABS)
          IUABS=MTU(2,ITUABS)
          DO 101 IXY=1,ITU
            IXYABS=IXY+NTUES(ISYM)
            IXABS=MTU(1,IXYABS)
            IYABS=MTU(2,IXYABS)
            ISADR=(ITU*(ITU-1))/2+IXY
            ITX=ITABS+NASHT*(IXABS-1)
            IUY=IUABS+NASHT*(IYABS-1)
            IP1=MAX(ITX,IUY)
            IP2=MIN(ITX,IUY)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=4.0D0*PREF(IP)
            WORK(LSF-1+ISADR)=VALUE
 101      CONTINUE
 100    CONTINUE
        NASP=NTGEU(ISYM)
        NSFP=(NASP*(NASP+1))/2
        IF(NSFP.GT.0) THEN
          CALL GETMEM('SFP','ALLO','REAL',LSFP,NSFP)
        END IF
        NASM=NTGTU(ISYM)
        NSFM=(NASM*(NASM+1))/2
        IF(NSFM.GT.0) THEN
          CALL GETMEM('SFM','ALLO','REAL',LSFM,NSFM)
        END IF
        DO 200 ITGEU=1,NASP
          ITGEUABS=ITGEU+NTGEUES(ISYM)
          ITABS=MTGEU(1,ITGEUABS)
          IUABS=MTGEU(2,ITGEUABS)
          ITU=KTU(ITABS,IUABS)-NTUES(ISYM)
          DO 201 IXGEY=1,ITGEU
            IXGEYABS=IXGEY+NTGEUES(ISYM)
            IXABS=MTGEU(1,IXGEYABS)
            IYABS=MTGEU(2,IXGEYABS)
            IXY=KTU(IXABS,IYABS)-NTUES(ISYM)
            IYX=KTU(IYABS,IXABS)-NTUES(ISYM)
            IF(ITU.GE.IXY) THEN
              ISADR=(ITU*(ITU-1))/2+IXY
            ELSE
              ISADR=(IXY*(IXY-1))/2+ITU
            END IF
            STUXY=WORK(LSF-1+ISADR)
            IF(ITU.GE.IYX) THEN
              ISADR=(ITU*(ITU-1))/2+IYX
            ELSE
              ISADR=(IYX*(IYX-1))/2+ITU
            END IF
            STUYX=WORK(LSF-1+ISADR)
            ISPADR=(ITGEU*(ITGEU-1))/2+IXGEY
            WORK(LSFP-1+ISPADR)=STUXY+STUYX
            IF(ITABS.EQ.IUABS) GOTO 201
            IF(IXABS.EQ.IYABS) GOTO 201
            ITGTU=KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
            IXGTY=KTGTU(IXABS,IYABS)-NTGTUES(ISYM)
            ISMADR=(ITGTU*(ITGTU-1))/2+IXGTY
            WORK(LSFM-1+ISMADR)=STUXY-STUYX
 201      CONTINUE
 200    CONTINUE
        IF(NSF.GT.0) THEN
          CALL GETMEM('SF','FREE','REAL',LSF,NSF)
        END IF

C Write to disk
        IF(NSFP.GT.0.and.NINDEP(ISYM,8).GT.0) THEN
          IDISK=IDSMAT(ISYM,8)
          CALL DDAFILE(LUSBT,1,WORK(LSFP),NSFP,IDISK)
          CALL GETMEM('SFP','FREE','REAL',LSFP,NSFP)
        END IF
        IF(NSFM.GT.0) THEN
          IF(NINDEP(ISYM,9).GT.0) THEN
           IDISK=IDSMAT(ISYM,9)
           CALL DDAFILE(LUSBT,1,WORK(LSFM),NSFM,IDISK)
          END IF
          CALL GETMEM('SFM','FREE','REAL',LSFM,NSFM)
        END IF
 1000 CONTINUE


      RETURN
      END

      SUBROUTINE MKSG(DREF)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

      DIMENSION DREF(NDREF)

C Set up the matrix SG(t,x)
C Formula used:
C    SG(t,x)= Dtx


      DO 1000 ISYM=1,NSYM
        NINP=NINDEP(ISYM,10)
        IF(NINP.EQ.0) GOTO 1000
        NINM=NINDEP(ISYM,11)
        NAS=NASH(ISYM)
        NSG=(NAS*(NAS+1))/2
        IF(NSG.GT.0) CALL GETMEM('SG','ALLO','REAL',LSG,NSG)
        DO 100 IT=1,NAS
          ITABS=IT+NAES(ISYM)
          DO 101 IX=1,IT
            IXABS=IX+NAES(ISYM)
            ISG=(IT*(IT-1))/2+IX
            ID=(ITABS*(ITABS-1))/2+IXABS
            WORK(LSG-1+ISG)= DREF(ID)
 101      CONTINUE
 100    CONTINUE

C Write to disk
        IF(NSG.GT.0.and.NINDEP(ISYM,10).GT.0) THEN
          IDISK=IDSMAT(ISYM,10)
          CALL DDAFILE(LUSBT,1,WORK(LSG),NSG,IDISK)
          IF(NINM.GT.0.and.NINDEP(ISYM,11).GT.0) THEN
            IDISK=IDSMAT(ISYM,11)
            CALL DDAFILE(LUSBT,1,WORK(LSG),NSG,IDISK)
          END IF
          CALL GETMEM('SG','FREE','REAL',LSG,NSG)
        END IF
 1000 CONTINUE


      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine qpasy(alpha,dfac,npi,l,lambu,lmahi,lmbhi,ltot1,xka,
     &  xkb,prd,dum,qsum)
c
c  compute type 2 radial integrals, scaled by exp(-arc2)/sqrt(pi),
c  using the partially asymptotic method,
c  for lama=l to lmahi, lamb=l to lmbhi, n=lama+lamb-l-l
c
      implicit real*8 (a-h,o-z)
      parameter (a0=0.0d0, accrcy=1.0d-13, a1s4=0.25d0, a1s2=0.5d0,
     1  a1=1.0d0)
      dimension dfac(*),qsum(ltot1,lambu,*)
c
      sqalpi=a1/sqrt(alpha)
      alf1=a1
      if(xka.gt.xkb) go to 42
c
c  xka is smaller: set up parameters for qcomp using xkb
c
      xk=xkb*sqalpi
      t=a1s4*xk*xk
      prde=prd*exp(t-dum)*sqalpi**(npi+l)
      if(l.ge.2) prde=prde*xka**(l-1)
      tk=xka*xka/(alpha+alpha)
      do 30 lama=l,lmahi
      la=lama-1
      prefac=prde
      do 28 lamb=l,lmbhi
      lb=lamb-1
      n=((1-l-l)+lama)+lamb
c     # run power series using xka, obtaining initial
c     # q(n,l) values from qcomp, then recurring upwards
c     # j=0 term in sum
      nprime=npi+n+la-1
      qold1=qcomp(alf1,dfac,nprime,lb,t,xk)/dfac(la+la+3)
      sum=qold1
      if(tk.eq.a0) go to 24
c     # j=1 term in sum
      nprime=nprime+2
      qnew=qcomp(alf1,dfac,nprime,lb,t,xk)/dfac(la+la+3)
      f1=(la+la+3)
      qold2=(tk/f1)*qold1
      qold1=(tk/f1)*qnew
      sum=sum+qold1
      j=1
c     # increment j for next term
   22 j=j+1
      nprime=nprime+2
      f1=(nprime+nprime-5)
      f2=((lb-nprime+4)*(lb+nprime-3))
      qnew=(t+a1s2*f1)*qold1+a1s4*f2*qold2
      f1=(j*(la+la+j+j+1))
      qold2=(tk/f1)*qold1
      qold1=(tk/f1)*qnew
      sum=sum+qold1
      if(qold1.gt.accrcy*sum) go to 22
   24 qsum(n,lamb,lama)=qsum(n,lamb,lama)+prefac*sum
      prefac=prefac*sqalpi
   28 continue
      prde=prde*(xka/alpha)
   30 continue
      return
c
c  xkb is smaller: set up parameters for qcomp using xka
c
   42 xk=xka*sqalpi
      t=a1s4*xk*xk
      prde=prd*exp(t-dum)*sqalpi**(npi+l)
      if(l.ge.2) prde=prde*xkb**(l-1)
      tk=xkb*xkb/(alpha+alpha)
      do 60 lama=l,lmahi
      la=lama-1
      prefac=prde
      do 58 lamb=l,lmbhi
      lb=lamb-1
      n=((1-l-l)+lama)+lamb
c     # run power series using xkb, obtaining initial
c     # q(n,l) values from qcomp, then recurring upwards
c     # j=0 term in sum
      nprime=npi+n+lb-1
      qold1=qcomp(alf1,dfac,nprime,la,t,xk)/dfac(lb+lb+3)
      sum=qold1
      if(tk.eq.a0) go to 54
c     # j=1 term in sum
      nprime=nprime+2
      qnew=qcomp(alf1,dfac,nprime,la,t,xk)/dfac(lb+lb+3)
      f1=(lb+lb+3)
      qold2=(tk/f1)*qold1
      qold1=(tk/f1)*qnew
      sum=sum+qold1
      j=1
c     # increment j for next term
   52 j=j+1
      nprime=nprime+2
      f1=(nprime+nprime-5)
      f2=((la-nprime+4)*(la+nprime-3))
      qnew=(t+a1s2*f1)*qold1+a1s4*f2*qold2
      f1=(j*(lb+lb+j+j+1))
      qold2=(tk/f1)*qold1
      qold1=(tk/f1)*qnew
      sum=sum+qold1
      if(qold1.gt.accrcy*sum) go to 52
   54 qsum(n,lamb,lama)=qsum(n,lamb,lama)+prefac*sum
      prefac=prefac*(xkb/alpha)
   58 continue
      prde=prde*sqalpi
   60 continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_multi_T_buffer

   USE fmm_stats
   USE fmm_global_paras

   IMPLICIT NONE
   PRIVATE
   ! public procedures
   PUBLIC :: fmm_init_multi_T_buffer,    &
             fmm_free_multi_T_buffer,    &
             fmm_multi_T_buffer_add

   INTEGER(INTK), PARAMETER :: BUFFER_SIZE = 1000
   ! module wide variables
   INTEGER(INTK),      SAVE :: ndim_max
   TYPE(T_pair_batch), SAVE :: T_pair_buffer

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_multi_T_buffer(ndim_max_in)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: ndim_max_in

!      ndim_max = ndim_max_in*2  ! we multiply by two for 'paired" algorithm
      ndim_max = ndim_max_in
      IF (ndim_max < 1) CALL fmm_quit('invalid multiple T-matrix dimension!')
      NULLIFY (T_pair_buffer%items)
      ALLOCATE (T_pair_buffer%items(BUFFER_SIZE))
      T_pair_buffer%ndim = 0

   END SUBROUTINE fmm_init_multi_T_buffer

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_free_multi_T_buffer(T_contractor)

      IMPLICIT NONE
      EXTERNAL T_contractor

      IF (.NOT.ASSOCIATED(T_pair_buffer%items))  &
         CALL fmm_quit('T_pair_buffer not alloc.')
      IF ( T_pair_buffer%ndim /= 0 ) THEN
         CALL expunge_multi_buffer(T_contractor)
         T_pair_buffer%ndim = 0
      END IF
      DEALLOCATE (T_pair_buffer%items)
      NULLIFY (T_pair_buffer%items)

   END SUBROUTINE fmm_free_multi_T_buffer

!-------------------------------------------------------------------------------
!
!   SUBROUTINE fmm_multi_T_buffer_add(T_contractor,T_pair)
!
!      IMPLICIT NONE
!      TYPE(T_pair_single), INTENT(IN) :: T_pair
!      EXTERNAL T_contractor
!
!      INTEGER(INTK), SAVE :: iRHS_last = 0
!      INTEGER(INTK) :: iRHS
!
!      iRHS = T_pair%paras%RHS_id
!
!!!!!      IF ( BTEST(T_pair_buffer%ndim+1,0) ) THEN
!         ! number of buffer entries is even; try to expunge
!         IF ( (T_pair_buffer%ndim == ndim_max)   &
!              .OR. ((iRHS /= iRHS_last) .AND. (iRHS_last /= 0)) ) THEN
!            ! expunge buffer and build all the T-matrices at once
!            CALL T_contractor(T_pair_buffer)
!            T_pair_buffer%ndim = 0
!         END IF
!         iRHS_last = T_pair%paras%RHS_id
!!!!!      END IF
!
!      T_pair_buffer%ndim = T_pair_buffer%ndim +1
!      T_pair_buffer%items(T_pair_buffer%ndim) = T_pair
!
!   END SUBROUTINE fmm_multi_T_buffer_add
!
!-------------------------------------------------------------------------------

   SUBROUTINE fmm_multi_T_buffer_add(T_contractor,T_pair)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: T_pair
      EXTERNAL T_contractor

      IF ( T_pair_buffer%ndim == BUFFER_SIZE ) THEN
         ! expunge buffer and build all the T-matrices at once
         CALL expunge_multi_buffer(T_contractor)
      END IF

      stat_tpack_total = stat_tpack_total + one
      T_pair_buffer%ndim = T_pair_buffer%ndim +1
      T_pair_buffer%items(T_pair_buffer%ndim) = T_pair

   END SUBROUTINE fmm_multi_T_buffer_add

!-------------------------------------------------------------------------------

   SUBROUTINE expunge_multi_buffer(T_contractor)

      USE fmm_sort_T_pairs, ONLY: fmm_quicksort_wrt_RHS

      IMPLICIT NONE
      EXTERNAL T_contractor

      INTEGER(INTK) :: i, lo
      INTEGER(INTK) :: iRHS, iRHS_next, item_max
      TYPE(T_pair_batch) :: ptr

      lo = 1
      item_max = MIN((BUFFER_SIZE-1),(T_pair_buffer%ndim-1))

      ! sort only if needed
      iRHS = T_pair_buffer%items(1)%paras%RHS_id
      DO i = 2, item_max
         iRHS_next = T_pair_buffer%items(i)%paras%RHS_id
         IF ( iRHS_next < iRHS ) THEN
            CALL fmm_quicksort_wrt_RHS(T_pair_buffer%items(1:item_max))
            EXIT
         END IF
         iRHS = iRHS_next
      END DO

      DO i = 1, item_max
         iRHS = T_pair_buffer%items(i)%paras%RHS_id
         iRHS_next = T_pair_buffer%items(i+1)%paras%RHS_id
         ptr%ndim = i-lo+1
         IF ((iRHS /= iRHS_next) .OR. (ptr%ndim == ndim_max)) THEN
            ptr%items => T_pair_buffer%items(lo:i)
            CALL T_contractor(ptr)
            lo = i+1
         END IF
      END DO

      ptr%ndim = (item_max+1)-lo+1
      ptr%items => T_pair_buffer%items(lo:(item_max+1))
      CALL T_contractor(ptr)

      T_pair_buffer%ndim = 0
      stat_tpack_chunks = stat_tpack_chunks + one

   END SUBROUTINE expunge_multi_buffer

!-------------------------------------------------------------------------------

END MODULE fmm_multi_T_buffer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Bruno Tenorio                                    *
************************************************************************
      SUBROUTINE MKDCHS(IFSBTAB1,IFSBTAB2,ISSTAB,
     &                  MAPORB,DET1,DET2,
     &                  IF20,IF02,NDCHSM,DCHSM,OrbTab)

      use Constants, only: Zero
      use stdalloc, only: mma_allocate, mma_deallocate

      IMPLICIT NONE
      INTEGER IFSBTAB1(*),IFSBTAB2(*)
      INTEGER ISSTAB(*),MAPORB(*),NDCHSM
      REAL*8 DET1(*),DET2(*)
      REAL*8 DCHSM(NDCHSM)
      Integer OrbTab(*)
      INTEGER NASHT,NASORB
      REAL*8 GVAL,GAB,GBA
      INTEGER IAJB,IBJA
      INTEGER JORB,IORB
      INTEGER JORBA,JORBB,IORBA,IORBB
      INTEGER ITABS,JTABS,IJTABS
      INTEGER NSDCHSM
      LOGICAL IF20,IF02
      Real*8, Allocatable:: SDCHSM(:)

C Given two CI expansions, using a biorthonormal set of SD''s,
C calculate the matrix elements relevant to DCH state intensities
C in the biorthonormal active orbital basis.
C
C  'I,J,|< N-2 | anni_right anni_right | N >|**2'

C Pick out nr of active orbitals from orbital table:
      NASORB=ORBTAB(4)
      NASHT=NASORB/2
      NSDCHSM= NASORB*(NASORB-1)/2
      Call mma_allocate(SDCHSM,nSDCHSM,Label='SDCHSM')
      SDCHSM(:)=Zero

        CALL SDCHS(ORBTAB,ISSTAB,
     &              IFSBTAB1,IFSBTAB2,DET1,DET2,
     &              IF20,IF02,SDCHSM)

C Mapping from active spin-orbital to active orbital in external order.
C Note that these differ, not just because of the existence of two
C spin-orbitals for each orbital, but also because the active orbitals
C (external order) are grouped by symmetry and then RAS space, but the
C spin orbitals are grouped by subpartition.

      IAJB=0      ! dummy initialize
      IBJA=0      ! dummy initialize

      DO IORB=1,NASHT
       IORBA=2*IORB-1
       IORBB=2*IORB
       ITABS=MAPORB(IORBA)
       DO JORB=1,NASHT
        JORBA=2*JORB-1
        JORBB=2*JORB
        JTABS=MAPORB(JORBA)
        GVAL=Zero
        IF(IORB.GT.JORB) THEN
         IAJB=((IORBA-1)*(IORBA-2)/2)+JORBB
         IBJA=((IORBB-1)*(IORBB-2)/2)+JORBA
        ELSE IF(JORB.EQ.IORB) THEN
         IAJB=((IORBA-1)*(IORBA-2)/2)+JORBB
         IBJA=((IORBB-1)*(IORBB-2)/2)+JORBA
         GAB=SDCHSM(IAJB)
         GBA=SDCHSM(IBJA)
         GVAL=GAB+GBA
        ELSE IF(IORB.LT.JORB) THEN
         IBJA=((JORBA-1)*(JORBA-2)/2)+IORBB
         IAJB=((JORBB-1)*(JORBB-2)/2)+IORBA
        END IF
        IJTABS=JTABS+NASHT*(ITABS-1)
        DCHSM(IJTABS)=GVAL**2
       END DO
      END DO

      CALL mma_deallocate(SDCHSM)

      END SUBROUTINE MKDCHS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
*               1998, Roland Lindh                                     *
************************************************************************
      Subroutine Ftwo(case,ExFac,
     &                iSym,kSym,
     &                iBas,kBas,
     &                off_sqMat,off_ltMat,
     &                D1I,FI,D1A,FA,PQRS)
************************************************************************
*                                                                      *
*     Assemble Fock matrices FI and FA (in AO-basis)                   *
*                                                                      *
*     calling arguments:                                               *
*     case    : input, integer                                         *
*               symmetry case number; (II!II)=1, (II!KK)=2, (IK!IK)=3  *
*     ExFac   : input, real*8                                          *
*               coefficient of "exact exchange"                        *
*     iSym    : input, integer                                         *
*               symmetry species iSym                                  *
*     kSym    : input, integer                                         *
*               symmetry species kSym                                  *
*     iBas    : input, integer                                         *
*               1-st, fixed index of ERIs                              *
*     kBas    : input, integer                                         *
*               2-nd, fixed index of ERIs                              *
*     off_sqMat : input, array of integer                              *
*               offset of one-electron integrals (squared format)      *
*     off_ltMat : input, array of integer                              *
*               offset of one-electron integrals (lower triangular)    *
*     D1I     : input, array of real*8                                 *
*               one-body density matrix (frozen+inactive, AO-basis)    *
*     FI      : output, array of real*8                                *
*               Fock matrix (frozen+inactive, AO-basis)                *
*     D1A     : input, array of real*8                                 *
*               one-body density matrix (active, AO-basis)             *
*     FA      : output, array of real*8                                *
*               Fock matrix (active, AO-basis)                         *
*     PQRS    : input, array of real*8                                 *
*               two-electron integrals (AO-basis)                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
*     Modified to only need the unique symmetry blocks, R. Lindh,      *
*     March '98.                                                       *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Parameter ( Zero=0.0D0, Half=-0.5d0 , One=1.0D0, Two=2.0d0)
#include "rasdim.fh"
#include "general.fh"
*
      Integer   case, off_sqMat, off_ltMat
      Dimension off_sqMat(*), off_ltMat(*)
      Dimension D1I(*), FI(*), D1A(*), FA(*), PQRS(*)
*
      iTri(i)=(i*i-i)/2
      iSqr(i)=(i-1)*nBas(iSym)
      kSqr(i)=(i-1)*nBas(kSym)
*
*
*                                                                      *
************************************************************************
*                                                                      *
*     symmetry case (II|II)
*     Both Coulomb and Exchange contributions
*                                                                      *
************************************************************************
*                                                                      *
      If ( case.eq.1 ) Then
*
*------- Coulombic contribution
*
         iOff=off_ltMat(iSym)+iTri(iBas)+kBas
         kOff=off_sqMat(kSym)+1
         FI(iOff) = FI(iOff)
     &            + dDot_(nBas(kSym)*nBas(kSym),D1I(kOff),1,PQRS,1)
         FA(iOff) = FA(iOff)
     &            + dDot_(nBas(kSym)*nBas(kSym),D1A(kOff),1,PQRS,1)
*
*------- Exchange contribution
*
         If (ExFac.ne.Zero) Then
            iOff=off_sqMat(iSym)+iSqr(iBas)+1
            kOff=off_ltMat(kSym)+iTri(kBas)+1
*            Call DGeMX (kBas,nBas(iSym),Half*ExFac,
*     &                  PQRS,nBas(iSym),
*     &                  D1I(iOff),1,
*     &                  FI(kOff),1)
*            Call DGeMX (kBas,nBas(iSym),Half*ExFac,
*     &                  PQRS,nBas(iSym),
*     &                  D1A(iOff),1,
*     &                  FA(kOff),1)
            CALL DGEMV_('N',kBas,nBas(iSym),(Half*ExFac),
     &                  PQRS,nBas(iSym),
     &                  D1I(iOff),1,1.0D0,FI(kOff),1)
            CALL DGEMV_('N',kBas,nBas(iSym),(Half*ExFac),
     &                  PQRS,nBas(iSym),
     &                  D1A(iOff),1,1.0D0,FA(kOff),1)
            If ( iBas.ne.kBas ) then
               iOff=off_ltMat(iSym)+iTri(iBas)+1
               kOff=off_sqMat(kSym)+kSqr(kBas)+1
*               Call DGeMX (iBas,nBas(iSym),Half*ExFac,
*     &                     PQRS,nBas(iSym),
*     &                     D1I(kOff),1,
*     &                     FI(iOff),1)
*               Call DGeMX (iBas,nBas(iSym),Half*ExFac,
*     &                     PQRS,nBas(iSym),
*     &                     D1A(kOff),1,
*     &                     FA(iOff),1)
               CALL DGEMV_('N',iBas,nBas(iSym),(Half*ExFac),
     &                     PQRS,nBas(iSym),
     &                     D1I(kOff),1,1.0D0,FI(iOff),1)
               CALL DGEMV_('N',iBas,nBas(iSym),(Half*ExFac),
     &                     PQRS,nBas(iSym),
     &                     D1A(kOff),1,1.0D0,FA(iOff),1)
            End If
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     symmetry case (II|KK) and (KK|II)
*     Only Coulomb contributions
*     This is limited to iBas >= jBas
*     Code modified to only require uniqe symmetry blocks of
*     two-electron integrals. R. Lindh, March '98.
*                                                                      *
************************************************************************
*                                                                      *
      If ( case.eq.2 .and. iSym.gt.kSym) then
         jBas=kBas    ! To avoid confusion.
         iOff_ij=off_ltMat(iSym)+iTri(iBas)+jBas
         kOff=off_sqMat(kSym)+1
*
         FI(iOff_ij) = FI(iOff_ij)
     &               + DDot_(nBas(kSym)**2,D1I(kOff),1,PQRS,1)
         FA(iOff_ij) = FA(iOff_ij)
     &               + DDot_(nBas(kSym)**2,D1A(kOff),1,PQRS,1)
*
         D1I_ij=D1I(off_sqMat(iSym)+(jBas-1)*nBas(iSym)+iBas)
         D1A_ij=D1A(off_sqMat(iSym)+(jBas-1)*nBas(iSym)+iBas)
         If (iBas.ne.jBas) Then
            D1I_ij=D1I_ij*Two
            D1A_ij=D1A_ij*Two
         End If
         Do k = 1, nBas(kSym)
            Do l = 1, k
               kl = (l-1)*nBas(kSym)+k
               iOff_kl = off_ltMat(kSym)+iTri(k)+l
               FI(iOff_kl)=FI(iOff_kl)+D1I_ij*PQRS(kl)
               FA(iOff_kl)=FA(iOff_kl)+D1A_ij*PQRS(kl)
            End Do
         End Do
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     symmetry case (IK!IK)
*     Only Exchange contributions
*                                                                      *
************************************************************************
*                                                                      *
      If ( case.eq.3 .and. ExFac.ne.Zero) then
         iOff=off_sqMat(iSym)+iSqr(iBas)+1
         kOff=off_ltMat(kSym)+iTri(kBas)+1
*         Call DGeMX  (kBas,nBas(iSym),Half*ExFac,
*     &                PQRS,nBas(kSym),
*     &                D1I(iOff),1,
*     &                FI(kOff),1)
*         Call DGeMX  (kBas,nBas(iSym),Half*ExFac,
*     &                PQRS,nBas(kSym),
*     &                D1A(iOff),1,
*     &                FA(kOff),1)
         CALL DGEMV_('N',kBas,nBas(iSym),(Half*ExFac),
     &                PQRS,nBas(kSym),
     &                D1I(iOff),1,1.0D0,FI(kOff),1)
         CALL DGEMV_('N',kBas,nBas(iSym),(Half*ExFac),
     &                PQRS,nBas(kSym),
     &                D1A(iOff),1,1.0D0,FA(kOff),1)
         iOff=off_ltMat(iSym)+iTri(iBas)+1
         kOff=off_sqMat(kSym)+kSqr(kBas)+1
*         Call DGeMTX (nBas(kSym),iBas,Half*ExFac,
*     &                PQRS,nBas(kSym),
*     &                D1I(kOff),1,
*     &                FI(iOff),1)
*         Call DGeMTX (nBas(kSym),iBas,Half*ExFac,
*     &                PQRS,nBas(kSym),
*     &                D1A(kOff),1,
*     &                FA(iOff),1)
         CALL DGEMV_('T',nBas(kSym),iBas,(Half*ExFac),
     &                PQRS,nBas(kSym),
     &                D1I(kOff),1,1.0D0,FI(iOff),1)
         CALL DGEMV_('T',nBas(kSym),iBas,(Half*ExFac),
     &                PQRS,nBas(kSym),
     &                D1A(kOff),1,1.0D0,FA(iOff),1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Init_Dynamix()

use Dynamix_globals, only: DT, iPrint, lH5Restart, PIN, POUT, RESTART, TEMP, THERMO, VELO
use Constants, only: Zero, Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: natom
!integer(kind=iwp) :: lLine
!character(len=180) :: Lines(10)

!#ifdef _SKIP_
!Lines(1) = _MOLCAS_VERSION_
!#ifdef _DEMO_
!Lines(2) = 'DEMO VERSION '
!#else
!Lines(2) = ' '
!#endif
!Lines(3) = ' '
!Lines(4) = 'D Y N A M I X'
!Lines(5) = ' '
!Lines(6) = 'Written by Igor Schapiro'
!Lines(7) = ' '
!Lines(8) = 'A program for molecular dynamics simulations'
!Lines(9) = ' '
!Lines(10) = 'Code compiled :'//_BUILD_DATE_
!lLine = Len(Lines(1))
!call Banner(Lines,10,lLine)
!
!write(u6,*)
!write(u6,'(a,i8,a)')   ' The Dynamix program has ',mxMem,' double precision words memory available.'
!write(u6,'(a,i8,a)')   '                         ',mxMem*8/(1024**2),' MB'
!write(u6,*)
!#endif

! Set the default values

call Get_nAtoms_Full(natom)
THERMO = 0
TEMP = 298.15_wp
VELO = 0
POUT = 0
PIN = natom*3
iPrint = 2
DT = Ten
RESTART = Zero
lH5Restart = .false.

!Etot0 = Zero

return

end subroutine Init_Dynamix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine CalcOMat(CSFOK,LOK,FMO1t,FMO2t,nTri)

use ipPage, only: ipget, W
use MCLR_Data, only: ipCI, ipMat, nAcPr2, nConf1, nDens, XISPSM
use MCLR_procedures, only: CISigma_sa
use input_mclr, only: nBas, nRoots, nSym, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: CSFOK(nConf1,nRoots), LOK(nRoots,nRoots)
integer(kind=iwp), intent(in) :: nTri
real(kind=wp), intent(in) :: FMO1t(nTri,nRoots), FMO2t(nAcPr2,nRoots)
integer(kind=iwp) :: I, iB, ij, iOff, iptmp, iS, jB, ji, jS, L, nConf3
real(kind=wp) :: rdum(1)
real(kind=wp), allocatable :: FMO1(:)
real(kind=wp), external :: DDot_

nConf3 = nint(max(xispsm(State_SYM,1),xispsm(State_SYM,1)))
iptmp = ipGet(nconf3*nRoots)
CSFOK(:,:) = Zero
W(iptmp)%A(1:nRoots*nConf3) = Zero
call mma_allocate(FMO1,nDens)

do I=1,nRoots
  iOff = 0
  do iS=1,nSym
    jS = iS
    if (NBAS(IS)*NBAS(JS) /= 0) then
      do iB=1,nBas(iS)
        do jB=1,iB
          ioff = ioff+1
          ji = ipMat(is,js)-1+(iB-1)*nbas(iS)+jB
          FMO1(ji) = FMO1t(ioff,I)
          if (iB /= jB) then
            ij = ipMat(is,js)-1+(jB-1)*nbas(iS)+iB
            FMO1(ij) = FMO1t(ioff,I)
          end if
        end do
      end do
    end if
  end do
  !call ipin(ipCI)
  call CISigma_SA(0,State_Sym,State_Sym,FMO1,nDens,FMO2t(:,I),NACPR2,rdum,1,ipci,iptmp,.true.)
  CSFOK(:,I) = CSFOK(:,I)+real(nRoots,kind=wp)*W(iptmp)%A((I-1)*nConf1+1:I*nConf1)

  do L=1,nRoots
    LOK(L,I) = ddot_(nConf1,CSFOK(:,I),1,W(ipCI)%A((L-1)*nConf1+1),1)
  end do
end do
call mma_deallocate(FMO1)

end subroutine CalcOMat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Giovanni Ghigo                                   *
!***********************************************************************

subroutine ChoMP2_GenE(iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddEx,LenE)
!***********************************************************************
! Author :  Giovanni Ghigo                                             *
!           Lund University, Sweden & Torino University, Italy         *
!           January-February 2005                                      *
! Modified for Cholesky-MP2 May 2005                                   *
!***********************************************************************

use Cho_Tra, only: nSsh
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSymI, iSymJ, iSymA, iSymB, iI, iJ, numV, LenE
real(kind=wp), intent(inout) :: AddEx(LenE)
integer(kind=iwp) :: iIx, LxType
logical(kind=iwp) :: SameLx
real(kind=wp), allocatable :: Lx0(:), Ly0(:)

! SubBlock 3 3

! Build Lx
call mma_allocate(Lx0,nSsh(iSymA)*numV,Label='Lx0')
LxType = 0
iIx = 0
SameLx = .false.
call MkL3(iSymA,iSymI,iI,numV,LxType,iIx,Lx0,SameLx)

! Build Ly
call mma_allocate(Ly0,nSsh(iSymB)*numV,Label='Ly0')
if (iSymA == iSymB) SameLx = .true.
call MkL3(iSymB,iSymJ,iJ,numV,LxType,iIx,Ly0,SameLx)

! Generate the SubBlock
if (.not. SameLx) then
  call DGEMM_('N','T',nSsh(iSymB),nSsh(iSymA),numV,One,Ly0,nSsh(iSymB),Lx0,nSsh(iSymA),One,AddEx,nSsh(iSymB))
else
  call DGEMM_('N','T',nSsh(iSymA),nSsh(iSymA),numV,One,Lx0,nSsh(iSymA),Lx0,nSsh(iSymA),One,AddEx,nSsh(iSymA))
end if

call mma_deallocate(Ly0)
call mma_deallocate(Lx0)

return

end subroutine ChoMP2_GenE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Roland Lindh                                     *
************************************************************************
      Subroutine ReNorm2(iCnttp)
      use Wrj12
*
      Call ICopy(4*8,[0],0,iOffA,1)
      Do ire_do = 1, 2
*
         Call ReNorm2_Internal(iCnttp)
*
      End Do
*
      Return
      End
      Subroutine ReNorm2_Internal(iCnttp)
************************************************************************
*                                                                      *
*    Objective: Orthonormalize parts of the auxiliary basis set.       *
*                                                                      *
* Called from: Mk_RICD_Shells                                          *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theor. Chemi., Lund Univ., Sweden.*
*                                                                      *
*             Modified to transform the auxiliary basis to a true      *
*             Cholesky basis set while on TACC 2008 conference in      *
*             Songjiang District, Shanghai, China, 23-27 Sept. 2008.   *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO, nSOInf
      use Real_Spherical
      use Basis_Info
      use Sizes_of_Seward, only: S
      use RICD_Info, only: Thrshld_CD
      Implicit Real*8 (A-H,O-Z)
      External Integral_RI_2
#include "itmax.fh"
#include "SysDef.fh"
#include "real.fh"
#include "print.fh"
#include "status.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      Real*8, Allocatable :: TInt_c(:), ADiag(:)
      Logical In_Core
      Interface
            Subroutine Drv2El_Atomic_NoSym(Integral_RI_2,
     &                                     ThrAO,iCnttp,jCnttp,
     &                                     TInt_c,nTInt_c,
     &                                     In_Core,ADiag,Lu_A,
     &                                     ijS_req,Keep_Shell)
            External Integral_RI_2
            Real*8 ThrAO
            Integer iCnttp, jCnttp, nTInt_c, Lu_A,ijS_req, Keep_Shell
            Real*8, Allocatable :: TInt_c(:), ADiag(:)
            Logical In_Core
            End Subroutine
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
!#define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*     Let us now Gram-Schmidt orthonormalize the auxiliary basis for
*     better numerics and balance.
*
*     Update kOffAO and lOffAO to include the auxiliary basis too.
*
      Call Setup_OffAO()
*
*     Set up transformation matrix from Cartesian to real spherical
*     harmonics.
*
      Call Sphere(S%iAngMx)
*
      Call Flip_Flop(.False.) ! Contracted mode.
*
      Thr_CB=Max(1.0D-14,Thrshld_CD*1.0D-10)
      ThrAO=Zero
*
*     Do iCnttp = 1, nCnttp
*        Skip the dummy shell
         If (iCnttp.eq.iCnttp_dummy) Go To 2222
*        skip non-auxiliary basis sets
         If (.Not.dbsc(iCnttp)%Aux) Go To 2222
*                                                                      *
************************************************************************
*                                                                      *
*        Define some parameters to facilitate the atomic calculation
*
         S%nShlls= dbsc(iCnttp)%nVal
         nTest = dbsc(iCnttp)%nVal-1
*
*        Define AOtSO
*
         iAO = 0
         iSO = 0
         nSO=0
         Do iAng = 0, nTest
            iShll_ = dbsc(iCnttp)%iVal + iAng
            nCmp = (iAng+1)*(iAng+2)/2
            If (Shells(iShll_)%Prjct) nCmp = 2*iAng+1
            iSO = 0
            If (Shells(iShll_)%nBasis_C*Shells(iShll_)%nExp==0) Cycle
            Do iCmp = 1, nCmp
               iAO = iAO + 1
               If (iAO>nSOInf) Then
                  Write (6,*) 'renorm2_internal: iAO>nSOInf'
                  Write (6,*) 'iAO=',iAO
                  Write (6,*) 'nSOInf=',nSOInf
                  Call Abend()
               End If
               iAOtSO(iAO,0) = iSO + 1
               iSO = iSO + Shells(iShll_)%nBasis
            End Do
            nSO=nSO+iSO
         End Do
*
         ijS_req=0
         Keep_Shell=iTabMx
         Do iAng = 0, nTest
            iShll = dbsc(iCnttp)%iVal + iAng
            nExpi = Shells(iShll)%nExp
            nBasisi=Shells(iShll)%nBasis
            If (nExpi*nBasisi.eq.0) Go To 2221
*
            nCmp = (iAng+1)*(iAng+2)/2
            If (Shells(iShll)%Prjct) nCmp = 2*iAng+1
*
            ijS_req=ijS_req+1
*
            Call Drv2El_Atomic_NoSym(Integral_RI_2,
     &                               ThrAO,iCnttp,iCnttp,
     &                               TInt_c,nTInt_c,
     &                               In_Core,ADiag,Lu_A,ijS_req,
     &                               Keep_Shell)
#ifdef _DEBUGPRINT_
            Call TriPrt('TInt_c',' ',TInt_c,nTInt_c)
#endif
*
            If (.NOT.In_Core) Then
               Call WarningMessage(2,'Error in ReNorm')
               Write (6,*) 'Out-of-core acCD not implemented!'
               Call Abend()
            End If
*
*           Produce the reduced set, in-place reduction.
*
            Call Allocate_Work(ipA,nTInt_c**2)
            ijT=0
            Do iBas = 1, nTInt_c
               Do jBas = 1, iBas
                  ijT=ijT+1
                  ijS=(jBas-1)*nTInt_c+iBas
                  jiS=(iBas-1)*nTInt_c+jBas
                  Work(ipA+ijS-1)=TInt_c(ijT)
                  Work(ipA+jiS-1)=TInt_c(ijT)
               End Do
            End Do
            Call mma_deallocate(TInt_c)
            ip_TInt_c=ipA
#ifdef _DEBUGPRINT_
            Call RecPrt('TInt_c',' ',Work(ip_TInt_c),nTInt_c,nTInt_c)
#endif
*
            ij=0
            iCmp=1
            jCmp=1
            Do jBas = 1, nBasisi
               j=(jCmp-1)*nBasisi+jBas
               Do iBas = 1, nBasisi
                  i=(iCmp-1)*nBasisi+iBas
                  ijF=(j-1)*nBasisi*nCmp+i
                  ij=ij+1
*
                  Work(ij+ip_TInt_c-1)=Work(ijF+ip_TInt_c-1)
*
               End Do
            End Do
#ifdef _DEBUGPRINT_
            Call RecPrt('TInt_c(r)','(5G20.10)',
     &                  Work(ip_TInt_c),nBasisi,nBasisi)
#endif
*
            Call GetMem('ADiag','Allo','Real',ipADiag,nBasisi)
            Call GetMem('iADiag','Allo','Inte',ipiADiag,nBasisi)
*
            iSeed=77
            Lu_A=IsFreeUnit(iSeed)
            Call DaName_MF_WA(Lu_A,'AMat09')
*
            iDisk=0
            Call dDaFile(Lu_A,1,Work(ip_TInt_c),nBasisi**2,iDisk)
*
            iSeed=iSeed+1
            Lu_Q=IsFreeUnit(iSeed)
            Call DaName_MF_WA(Lu_Q,'QMat09')
*
            call dcopy_(nBasisi,Work(ip_TInt_c),nBasisi+1,
     &                 Work(ipADiag),1)
*
            Call CD_AInv_(nBasisi,m,Work(ipADiag),iWork(ipiADiag),
     &                    Lu_A,Lu_Q,Thr_CB)
*
            Call GetMem('iADiag','Free','Inte',ipiADiag,n)
            Call GetMem('ADiag','Free','Real',ipADiag,n)
            Call Free_Work(ip_TInt_c)
*
*           Transform the contraction coefficients according to the
*           Cholesky vectors.
*
            Call Allocate_Work(ipTmp,nBasisi*nExpi)
            Call Allocate_Work(ipQVec,nBasisi**2)
            Call FZero(Work(ipQVec),nBasisi**2)
*
            iDisk=0
            Call dDaFile(Lu_Q,2,Work(ipQVec),nBasisi*m,iDisk)
            Call DaEras(Lu_Q)
#ifdef _DEBUGPRINT_
            Call RecPrt('QVec',' ',Work(ipQVec),nBasisi,m)
#endif
*
            iOff=0
            Do iCase = 1, 2
               call dcopy_(nExpi*nBasisi,
     &                     Shells(iShll)%Cff_c(1,1,iCase),1,
     &                     Work(ipTmp),1)
#ifdef _DEBUGPRINT_
               Call RecPrt('Coeff(old)',' ',
     &                     Shells(iShll)%Cff_c(1,1,iCase),
     &                     nExpi,nBasisi)
#endif
               Call DGEMM_('N','N',
     &                    nExpi,nBasisi,nBasisi,
     &                    1.0D0,Work(ipTmp),nExpi,
     &                          Work(ipQVec),nBasisi,
     &                    0.0D0,Shells(iShll)%Cff_c(1,1,iCase),
     &                          nExpi)
#ifdef _DEBUGPRINT_
               Call RecPrt('Coeff(new)',' ',
     &                     Shells(iShll)%Cff_c(1,1,iCase),
     &                     nExpi,nBasisi)
#endif
            End Do
*
            Call Free_Work(ipQVec)
            Call Free_Work(ipTmp)
*
 2221       Continue
         End Do
*
 2222    Continue
*     End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Comp_F(h0,Ei,nBas,Delta_i,Energy,S,Refx,Originx)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBas
real(kind=wp), intent(in) :: h0(nBas*(nBas+1)/2+4), Ei(nBas*(nBas+1)/2+4), Delta_i, S(nBas*(nBas+1)/2+4), Refx, Originx
real(kind=wp), intent(out) :: Energy
integer(kind=iwp) :: i, iComp, ireturn, iRc, iSyLbl, mBas(8), nInts, nsize
real(kind=wp) :: PotNuc_Save
character(len=8) :: Method, Label
real(kind=wp), allocatable :: h0_temp(:)

nInts = nBas*(nBas+1)/2
call mma_allocate(h0_temp,nInts+4,label='h0_temp')

call Get_cArray('Relax Method',Method,8)
call Get_iScalar('nSym',i)
call Get_iArray('nBas',mBas,i)
nsize = nInts+4

! Add perturbations to h0

call dcopy_(nSize,h0,1,h0_temp,1)
call DaXpY_(nSize,Delta_i,Ei,1,h0_temp,1)
call DaXpY_(nSize,Delta_i*(Originx-Refx),S,1,h0_temp,1)
call Get_dScalar('PotNuc',PotNuc_Save)
call Put_dScalar('PotNuc',h0_temp(nInts+4))

!---- Write the one-electron hamiltonian.

!call TriPrt('H0 before wrone',' ',h0,nBas)
iComp = 1
iSyLbl = 1
Label = 'OneHam  '
iRc = -1
call WrOne(iRc,0,Label,iComp,h0_temp,iSyLbl)
!call TriPrt('H0_temp after wrone',' ',h0_temp,nBas)

if ((Method == 'RHF-SCF') .or. (Method == 'UHF-SCF') .or. (Method == 'KS-DFT')) then

  call StartLight('scf')
  call Disable_Spool()
  call xml_open('module',' ',' ',0,'scf')
  call SCF(ireturn)
  call xml_close('module')
  if (iReturn /= 0) call Error()

else if (Method(1:5) == 'MBPT2') then

  call StartLight('scf')
  call Disable_Spool()
  call xml_open('module',' ',' ',0,'scf')
  call SCF(ireturn)
  call xml_close('module')
  if (iReturn /= 0) call Error()
  call StartLight('mbpt2')
  call Disable_Spool()
  call mp2_driver(ireturn)
  if (iReturn /= 0) call Error()

else if ((Method == 'RASSCF') .or. (Method == 'CASSCF')) then

  call StartLight('rasscf')
  call Disable_Spool()
  call RASSCF(ireturn)
  if (iReturn /= 0) call Error()

else if (Method == 'CASPT2') then

  call StartLight('rasscf')
  call Disable_Spool()
  call RASSCF(ireturn)
  if (iReturn /= 0) call Error()
  call StartLight('caspt2')
  call Disable_Spool()
  call CASPT2(ireturn)
  if (iReturn /= 0) call Error()

else
  write(u6,*) 'Method=',Method
  write(u6,*) ' Oups!'
  call Abend()
end if

!call Get_Energy(Energy)
call Get_dScalar('Last energy',Energy)

call WrOne(iRc,0,Label,iComp,h0,iSyLbl)
call Put_dScalar('PotNuc',PotNuc_Save)

call mma_deallocate(h0_temp)

return

contains

subroutine Error()

  write(u6,*)
  write(u6,*) 'Comp_f: Wave function calculation failed!'
  write(u6,*)
  call Abend()

end subroutine

end subroutine Comp_F

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_local_search

use fmm_global_paras, only: INTK, id_list, id_node, scheme_paras, box_mm_data, box_mm_paras, gen_mm_paras, LHS_raw_RHS_raw, &
                            LHS_box_RHS_box, TOP_LEVEL, DO_FMM
use fmm_box_utils, only: fmm_parent_box, fmm_same_box, fmm_RFF_boxes
use fmm_utils, only: fmm_quit

implicit none
private
! Public procedures
public :: fmm_init_local_search, &
          fmm_free_local_search, &
          fmm_get_local_paras

type fmm_local_map
  type(id_list), pointer :: box_list(:)
end type fmm_local_map

type(fmm_local_map), allocatable, save :: map_at_level(:)
integer(INTK), save :: deepest_level

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_local_search(scheme)

  use fmm_box_builder, only: fmm_get_box_paras_at_level
  use fmm_box_utils, only: fmm_deepest_level

  implicit none
  type(scheme_paras), intent(in) :: scheme

  type(fmm_local_map), allocatable :: RHS_map(:)
  type(box_mm_data), allocatable :: mm_paras(:)
  type(box_mm_paras), pointer :: ptr(:)
  integer(INTK) :: level, j

  if (.not. scheme%branch_free) call fmm_quit('local search module may not work with CFMM!')
  if (.not. scheme%algorithm == DO_FMM) call fmm_quit('local search module is only for FMM algorithm')

  deepest_level = fmm_deepest_level(scheme)
  nullify(ptr)
  allocate(mm_paras(deepest_level))
  allocate(RHS_map(deepest_level))

  ! Get multipole moment box information over whole hierarchy
  do level=TOP_LEVEL,deepest_level
    nullify(RHS_map(level)%box_list)
    nullify(mm_paras(level)%LHS_paras)
    nullify(mm_paras(level)%RHS_paras)
    nullify(mm_paras(level)%qlm_T)
    nullify(mm_paras(level)%qlm_W)
    call fmm_get_box_paras_at_level(level,scheme,ptr,'LHS')
    mm_paras(level)%LHS_paras => ptr
    call fmm_get_box_paras_at_level(level,scheme,ptr,'RHS')
    mm_paras(level)%RHS_paras => ptr
  end do

  ! Build parent:child map of RHS parameters and use it to make
  ! local interaction map of LHS-RHS pairs
  call fmm_init_local_map(mm_paras)
  call fmm_build_RHS_map(mm_paras,RHS_map)
  call fmm_build_local_map(mm_paras,RHS_map)

  ! Deallocations
  do level=TOP_LEVEL,deepest_level
    if (associated(RHS_map(level)%box_list)) then
      do j=1,size(RHS_map(level)%box_list)
        call free_linked_list(RHS_map(level)%box_list(j)%head)
      end do
      deallocate(RHS_map(level)%box_list)
    end if
    nullify(RHS_map(level)%box_list)
    nullify(mm_paras(level)%LHS_paras)
    nullify(mm_paras(level)%RHS_paras)
  end do
  deallocate(mm_paras,RHS_map)

end subroutine fmm_init_local_search

!-------------------------------------------------------------------------------

subroutine fmm_init_local_map(mm_paras)

  implicit none
  type(box_mm_data), intent(in) :: mm_paras(:)

  integer(INTK) :: i, j, ndim

  allocate(map_at_level(deepest_level))

  do i=TOP_LEVEL,deepest_level
    ndim = size(mm_paras(i)%LHS_paras)
    nullify(map_at_level(i)%box_list)
    allocate(map_at_level(i)%box_list(ndim))
    do j=1,ndim
      nullify(map_at_level(i)%box_list(j)%head)
      map_at_level(i)%box_list(j)%occ = 0
    end do
  end do

end subroutine fmm_init_local_map

!-------------------------------------------------------------------------------

subroutine fmm_free_local_search()

  implicit none
  integer(INTK) :: i, j, ndim

  if (deepest_level == TOP_LEVEL) return

  do i=TOP_LEVEL,deepest_level
    if (associated(map_at_level(i)%box_list)) then
      ndim = size(map_at_level(i)%box_list)
      do j=1,ndim
        call free_linked_list(map_at_level(i)%box_list(j)%head)
      end do
      deallocate(map_at_level(i)%box_list)
    end if
    nullify(map_at_level(i)%box_list)
  end do

  if (allocated(map_at_level)) deallocate(map_at_level)

end subroutine fmm_free_local_search

!-------------------------------------------------------------------------------

recursive subroutine free_linked_list(occ_node)

  implicit none
  type(id_node), pointer :: occ_node

  if (.not. associated(occ_node)) return

  ! traverse linked-list freeing from bottom up recursively
  if (associated(occ_node%next)) then
    call free_linked_list(occ_node%next)
    if (associated(occ_node)) deallocate(occ_node)
    nullify(occ_node)
  end if
  if (associated(occ_node)) deallocate(occ_node)
  nullify(occ_node)

end subroutine free_linked_list

!-------------------------------------------------------------------------------
! For each box, a list of the children boxes is generated.
! Box occupancy is only computed for levels _above_ the deepest
! level since deepest level occupancy corresponds to raw moments,
! not boxed moments, which is done separately.

subroutine fmm_build_RHS_map(mm_paras,RHS_map)

  implicit none
  type(box_mm_data), intent(in)    :: mm_paras(:)
  type(fmm_local_map), intent(out) :: RHS_map(:)

  type(box_mm_paras) :: box
  integer(INTK) :: i, id, level, ndim

  do level=deepest_level-1,TOP_LEVEL,-1

    ndim = size(mm_paras(level)%RHS_paras)
    allocate(RHS_map(level)%box_list(ndim))

    ! Initialise
    do i=1,ndim
      nullify(RHS_map(level)%box_list(i)%head)
      RHS_map(level)%box_list(i)%occ = 0
    end do

    ! We drive the loop over the child box level
    do i=1,size(mm_paras(level+1)%RHS_paras)
      ! 'map_up' indexes moments but, if in sync, then also the para set
      id = mm_paras(level+1)%RHS_paras(i)%map_up
      box%box = fmm_parent_box(mm_paras(level+1)%RHS_paras(i)%box)
      box%level = level
      ! 'id' should point to RHS parent box parameters
      if (.not. fmm_same_box(mm_paras(level)%RHS_paras(id),box)) call fmm_quit('RHS paras map-up to parent broken')
      ! Append item to linked list
      call fmm_add_item(RHS_map(level)%box_list(id),i)
    end do

  end do

end subroutine fmm_build_RHS_map

!-------------------------------------------------------------------------------

subroutine fmm_add_item(box_map,raw_id)

  implicit none
  type(id_list), intent(inout) :: box_map
  integer(INTK), intent(in)    :: raw_id
  type(id_node), pointer       :: new_node

  if (box_map%occ == 0) then
    ! Start new linked list for these boxes
    box_map%occ = 1
    allocate(box_map%head)
    box_map%head%id = raw_id
    nullify(box_map%head%next)
    return
  end if

  box_map%occ = box_map%occ+1

  allocate(new_node)
  new_node%id = raw_id
  if (associated(box_map%head%next)) then
    ! More than one entry in list (including head)
    ! so point new_node to old second entry
    new_node%next => box_map%head%next
    ! Point head to new_node
    nullify(box_map%head%next)
    box_map%head%next => new_node
  else
    ! Only head so far; make new_node our second entry
    box_map%head%next => new_node
    nullify(new_node%next)   ! end of list
  end if

end subroutine fmm_add_item

!-------------------------------------------------------------------------------
! Here we generate a list for each LHS box of all
! the RHS boxes spatially local to the LHS box.
! For now 'local' includes all the parent's near-field boxes.

subroutine fmm_build_local_map(mm_paras,RHS_map)

  implicit none
  type(box_mm_data), intent(in)   :: mm_paras(:)
  type(fmm_local_map), intent(in) :: RHS_map(:)

  type(box_mm_paras) :: LHS_box, RHS_box
  integer(INTK) :: i, j, id, lev
  type(id_node), pointer :: LHS_ptr, RHS_ptr

  lev = TOP_LEVEL
  do i=1,size(mm_paras(lev)%LHS_paras)
    do j=1,size(mm_paras(lev)%RHS_paras)
      LHS_box = mm_paras(lev)%LHS_paras(i)
      RHS_box = mm_paras(lev)%RHS_paras(j)
      if (.not. fmm_RFF_boxes(LHS_box,RHS_box)) then
        call fmm_add_item(map_at_level(lev)%box_list(i),j)
      end if
    end do
  end do

  do lev=TOP_LEVEL+1,deepest_level
    do i=1,size(mm_paras(lev)%LHS_paras)

      ! 'map_up' indexes moments but, if in sync, then also the para set
      id = mm_paras(lev)%LHS_paras(i)%map_up
      LHS_box%box = fmm_parent_box(mm_paras(lev)%LHS_paras(i)%box)
      LHS_box%level = lev-1
      ! 'id' should point to LHS parent box parameters
      if (.not. fmm_same_box(mm_paras(lev-1)%LHS_paras(id),LHS_box)) call fmm_quit('LHS paras map-up to parent broken')

      if (map_at_level(lev-1)%box_list(id)%occ == 0) cycle
      LHS_ptr => map_at_level(lev-1)%box_list(id)%head
      ! Loop over parent's near-field boxes
      parent: do
        if (RHS_map(lev-1)%box_list(LHS_ptr%id)%occ == 0) then
          if (.not. associated(LHS_ptr%next)) exit parent
          LHS_ptr => LHS_ptr%next
          cycle parent
        end if
        RHS_ptr => RHS_map(lev-1)%box_list(LHS_ptr%id)%head
        ! Get children and add to list of local boxes
        LHS_box = mm_paras(lev)%LHS_paras(i)
        child: do
          RHS_box = mm_paras(lev)%RHS_paras(RHS_ptr%id)
          if (.not. fmm_RFF_boxes(LHS_box,RHS_box)) then
            call fmm_add_item(map_at_level(lev)%box_list(i),RHS_ptr%id)
          end if
          if (.not. associated(RHS_ptr%next)) exit child
          RHS_ptr => RHS_ptr%next
        end do child

        if (.not. associated(LHS_ptr%next)) exit parent
        LHS_ptr => LHS_ptr%next
      end do parent

    end do
  end do

end subroutine fmm_build_local_map

!-------------------------------------------------------------------------------

subroutine fmm_get_local_paras(id,RHS_all,pair_type,RHS_local,ndim)

  implicit none
  type(gen_mm_paras), intent(out) :: RHS_local
  type(gen_mm_paras), intent(in)  :: RHS_all
  integer(INTK), intent(out)      :: ndim
  integer(INTK), intent(in)       :: pair_type
  integer(INTK), intent(in)       :: id

  type(id_node), pointer :: ptr
  integer(INTK) :: level, i

  select case (pair_type)
    case (LHS_raw_RHS_raw)
      call fmm_quit('local_paras: raw_raw NYI')

    case (LHS_box_RHS_box)

      if (associated(RHS_local%box_paras)) call fmm_quit('RHS_local')
      level = RHS_all%box_paras(1)%level
      ndim = map_at_level(level)%box_list(id)%occ
      if (ndim == 0) return
      allocate(RHS_local%box_paras(ndim))

      ptr => map_at_level(level)%box_list(id)%head
      i = 0
      do ! over linked-list of local boxes
        i = i+1
        RHS_local%box_paras(i) = RHS_all%box_paras(ptr%id)
        if (.not. associated(ptr%next)) exit
        ptr => ptr%next
      end do

    case default
      call fmm_quit('local_paras: requested T_pair type!')
  end select

end subroutine fmm_get_local_paras

!-------------------------------------------------------------------------------

end module fmm_local_search

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

module CHOVEC_IO

! SVC: subroutines to read/write transformed cholesky vectors from/to
! disk. These are used in tracho (where they are written) and in rhsod
! (where they are read into a global array).
!
! Cholesky vectors are distributed in batches and transformed as
! such. They are written the same way to disk:
! -----------------------------------------------------
! |IB=1               |IB=2 |... |      |IB=NBATCH_TOT|
! -----------------------------------------------------
! |Cholesky vectors   |     |    |      |   ...       |
! |(p,q,nvec_chobatch)|     |    |      |   ...       |
! |for all itk>itq    |     |    |      |   ...       |
! |and isyk,isyq=jsym |     |    |      |   ...       |
! |for jsym=1         |     |    |      | jsym=NSYM   |
! -----------------------------------------------------
! each batch contains blocks of a certain type (case and symmetry).
! Always all vectors are present, with the elements distributed over
! batches as well as processes.
!
! Cases are enumerated as follows:
!   1 =    active,inactive
!   2 =    active,active
!   3 = secondary,active
!   4 = secondary,inactive
!
! Symmetry is determined by total symmetry JSYM and the symmetry of one
! of the orbital cases ISYQ, thus all values of Mul(ISYQ,JSYM).
!
! When reading the vectors, we group all batches of the same type
! together, so that we have all vectors of one type as one block,
! as this is how they are used to compute the integrals for RHS.

! indexing of distributed cholesky vectors
!-----------------------------------------
! The cholesky vectors are distributed over batches and processed
! like that by tracho2. A batch has a specified number of cholesky
! vectors (batches for different JSYM are different, so are the
! number of vectors in them). The offset of a batch on disk is
! then determined by the type (case,isyq,jsym) and total batch
! number (ib).
! NVLOC_CHOBATCH, IDLOC_CHOGROUP

! indexing of collected cholesky vectors
!---------------------------------------
! The cholesky vectors can be collected together on disk from
! different processes. The combined sizes are stored in separate
! arrays.
! NVGLB_CHOBATCH, IDGLB_CHOGROUP

! total amount of cholesky vectors in a certain symmetry
! NVTOT_CHOSYM

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: NVTOT_CHOSYM(8)
integer(kind=iwp), allocatable :: IDGLB_CHOGROUP(:,:,:,:), IDLOC_CHOGROUP(:,:,:,:), NVGLB_CHOBATCH(:), NVLOC_CHOBATCH(:)

public :: CHOVEC_COLL, CHOVEC_LOAD, CHOVEC_READ, CHOVEC_SAVE, CHOVEC_SIZE, IDGLB_CHOGROUP, IDLOC_CHOGROUP, NPQ_CHOTYPE, &
          NVGLB_CHOBATCH, NVLOC_CHOBATCH, NVTOT_CHOSYM

contains

function NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
  !*********************************************************************
  ! Compute the number of orbital pairs for a given case (valid pair of
  ! inactive,active,secondary), total symmetry JSYM and component symmetry
  ! ISYQ. Note that the component Q which determines the symmetry block is
  ! the _lower_ orbital partition (e.g. inactive for active,inactive),
  ! which is also the slowest varying index of the pair P,Q.
  !*********************************************************************

  use Symmetry_Info, only: Mul
  use caspt2_module, only: nAsh, nIsh, nSSh

  integer(kind=iwp) :: NPQ_CHOTYPE
  integer(kind=iwp), intent(in) :: ICASE, ISYQ, JSYM
  integer(kind=iwp) :: ISYP, NP, NQ

  ISYP = Mul(ISYQ,JSYM)
  select case (ICASE)
    case (1)
      NP = NASH(ISYP)
      NQ = NISH(ISYQ)
    case (2)
      NP = NASH(ISYP)
      NQ = NASH(ISYQ)
    case (3)
      NP = NSSH(ISYP)
      NQ = NASH(ISYQ)
    case (4)
      NP = NSSH(ISYP)
      NQ = NISH(ISYQ)
    case default
      NP = 0
      NQ = 0
      call SYSABENDMSG('NPQ_CHOTYPE','invalid case number','')
  end select
  NPQ_CHOTYPE = NP*NQ

end function NPQ_CHOTYPE

subroutine CHOVEC_SIZE(ICASE,NCHOBUF,IOFF)
  !*********************************************************************
  ! Allocate a buffer to hold all cholesky vectors of type ITK,ITQ
  !*********************************************************************

  use Symmetry_Info, only: Mul
  use caspt2_module, only: nSym

  integer(kind=iwp), intent(in) :: ICASE
  integer(kind=iwp), intent(out) :: NCHOBUF, IOFF(8,8)
  integer(kind=iwp) :: ISYK, ISYQ, JSYM, NPQ, NVTOT

  NCHOBUF = 0
  do JSYM=1,NSYM
    NVTOT = NVTOT_CHOSYM(JSYM)
    do ISYQ=1,NSYM
      ISYK = Mul(ISYQ,JSYM)
      IOFF(ISYK,ISYQ) = NCHOBUF
      NPQ = NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
      NCHOBUF = NCHOBUF+NPQ*NVTOT
    end do
  end do

end subroutine CHOVEC_SIZE

subroutine CHOVEC_READ(ICASE,CHOBUF,nCHOBUF)
  !*********************************************************************
  ! Read (transposed) cholesky vectors from disk, they
  ! are indexed as CHOBUF(IVEC,IQ,IK)
  !*********************************************************************

  use caspt2_module, only: nSym, nBtches, nBtch
  use caspt2_global, only: LUDRA
# ifdef _MOLCAS_MPP_
  use Para_Info, only: Is_Real_Par
  use caspt2_global, only: LUDRATOT
# endif
  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp), intent(in) :: ICASE, nCHOBUF
  real(kind=wp), intent(inout) :: CHOBUF(nCHOBUF)
  integer(kind=iwp) :: IB, IBEND, IBOFF, IBSTA, IDISK, IOFF, ISYQ, J, JSYM, NBUF, NPQ, NV, NVTOT
  real(kind=wp), allocatable :: BUF(:)

  IOFF = 0
  do JSYM=1,NSYM
    NVTOT = NVTOT_CHOSYM(JSYM)
    IBSTA = NBTCHES(JSYM)+1
    IBEND = NBTCHES(JSYM)+NBTCH(JSYM)
    do ISYQ=1,NSYM
      NPQ = NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
      IBOFF = 0
      do IB=IBSTA,IBEND
        NV = NVGLB_CHOBATCH(IB)
        NBUF = NPQ*NV
        call mma_allocate(BUF,NBUF,LABEL='BUF')
        IDISK = IDGLB_CHOGROUP(ICASE,ISYQ,JSYM,IB)
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          ! cholesky vectors already transposed
          call DDAFILE(LUDRATOT,2,BUF,NBUF,IDISK)
          do J=1,NPQ
            CHOBUF(IOFF+IBOFF+NVTOT*(J-1)+1:IOFF+IBOFF+NVTOT*(J-1)+NV) = BUF(NV*(J-1)+1:NV*J)
          end do
        else
#       endif
          ! cholesky vectors not transposed
          call DDAFILE(LUDRA,2,BUF,NBUF,IDISK)
          do J=1,NPQ
            CHOBUF(IOFF+IBOFF+NVTOT*(J-1)+1:IOFF+IBOFF+NVTOT*(J-1)+NV) = BUF(J:J+NPQ*(NV-1):NPQ)
          end do
#       ifdef _MOLCAS_MPP_
        end if
#       endif
        call mma_deallocate(BUF)
        IBOFF = IBOFF+NV
      end do
      IOFF = IOFF+NVTOT*NPQ
    end do
  end do

end subroutine CHOVEC_READ

subroutine CHOVEC_SAVE(CHOBUF,NCHOBUF,ICASE,ISYQ,JSYM,IB)
  !*********************************************************************
  ! Write Cholesky vectors to disk.
  !*********************************************************************

  use caspt2_global, only: LUDRA
# ifdef _DEBUGPRINT_
  use Definitions, only: u6
# endif

  integer(kind=iwp), intent(in) :: NCHOBUF, ICASE, ISYQ, JSYM, IB
  real(kind=wp), intent(inout) :: CHOBUF(NCHOBUF)
  integer(kind=iwp) :: IDISK, JNUM, NPQ
# ifdef _DEBUGPRINT_
  integer(kind=iwp) :: NBUF
  real(kind=wp) :: SQFP
  real(kind=wp), external :: DNRM2_
# endif

  ! always write the chunks to LUDRA, both for serial and parallel
  NPQ = NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
  JNUM = NVLOC_CHOBATCH(IB)
  IDISK = IDLOC_CHOGROUP(ICASE,ISYQ,JSYM,IB)
  call DDAFILE(LUDRA,1,CHOBUF,NPQ*JNUM,IDISK)

# ifdef _DEBUGPRINT_
  NBUF = NPQ*JNUM
  SQFP = DNRM2_(NBUF,CHOBUF,1)
  write(u6,'(1X,A,I9,A,A,I2,A,A,I2,A,A,I2,A,A,F21.14)') &
    'BATCH ',IB,', ','CASE ',ICASE,', ','ISYQ ',ISYQ,', ','JSYM ',JSYM,', ','DNRM2 ',SQFP
# endif

end subroutine CHOVEC_SAVE

subroutine CHOVEC_LOAD(CHOBUF,NCHOBUF,ICASE,ISYQ,JSYM,IB)
  !*********************************************************************
  ! Read Cholesky vectors from disk.
  !*********************************************************************

  use caspt2_global, only: LUDRA
# ifdef _DEBUGPRINT_
  use Definitions, only: u6
# endif

  integer(kind=iwp), intent(in) :: NCHOBUF, ICASE, ISYQ, JSYM, IB
  real(kind=wp), intent(out) :: CHOBUF(NCHOBUF)
  integer(kind=iwp) :: IDISK, JNUM, NPQ
# ifdef _DEBUGPRINT_
  integer(kind=iwp) :: NBUF
  real(kind=wp) :: SQFP
  real(kind=wp), external :: DNRM2_
# endif

  ! always write the chunks to LUDRA, both for serial and parallel
  NPQ = NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
  JNUM = NVLOC_CHOBATCH(IB)
  IDISK = IDLOC_CHOGROUP(ICASE,ISYQ,JSYM,IB)
  call DDAFILE(LUDRA,2,CHOBUF,NPQ*JNUM,IDISK)

# ifdef _DEBUGPRINT_
  NBUF = NPQ*JNUM
  SQFP = DNRM2_(NBUF,CHOBUF,1)
  write(u6,'(1X,A,I9,A,A,I2,A,A,I2,A,A,I2,A,A,F21.14)') &
    'BATCH ',IB,', ','CASE ',ICASE,', ','ISYQ ',ISYQ,', ','JSYM ',JSYM,', ','DNRM2 ',SQFP
# endif

end subroutine CHOVEC_LOAD

subroutine CHOVEC_COLL(CHOBUF,NCHOBUF,ICASE,ISYQ,JSYM,IB)
  !*********************************************************************
  ! Routine to gather locally available cholesky vectors and collect
  ! all of them on each process in case of parallel run.
  !*********************************************************************

# ifdef _MOLCAS_MPP_
  use MPI_Wrapper, only: MPI_COMM_WORLD, MPI_INTEGER, MPI_REAL8
  use Para_Info, only: Is_Real_Par, nProcs
  use caspt2_global, only: LUDRATOT
  use caspt2_module, only: RHSDirect
  use chocaspt2, only: NFTSPC_TOT
  use stdalloc, only: mma_allocate, mma_deallocate
  use Definitions, only: MPIInt
# endif

  integer(kind=iwp), intent(in) :: NCHOBUF, ICASE, ISYQ, JSYM, IB
  real(kind=wp), intent(inout) :: CHOBUF(NCHOBUF)
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: I, IDISKT, IERROR, JNUM, JNUMT, NPQ, NUMSEND(1)
  integer(kind=MPIInt) :: IERROR4, ITYPE
  integer(kind=MPIInt), allocatable :: DISP(:), SIZ(:)
  real(kind=wp), allocatable :: RECVBUF(:), TRANSP(:)
# ifdef _DEBUGPRINT_
  integer(kind=iwp) :: MY_N, NOFF
  real(kind=wp) :: SQFP
  real(kind=wp), external :: DDOT_
# endif
# endif

# ifdef _MOLCAS_MPP_
  ITYPE = MPI_INTEGER
  if (Is_Real_Par()) then
    ! for true parallel, also communicate chunks to each process, write them
    ! to LUDRATOT, so first allocate memory for the fully transformed
    ! vectors, and for the per-process size and offset into LUDRATOT
    call mma_allocate(DISP,NPROCS,Label='DISP')
    call mma_allocate(SIZ,NPROCS,LABEL='SIZ')

    ! gather sizes of local cholesky bits
    NPQ = NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
    JNUM = NVLOC_CHOBATCH(IB)
    NUMSEND(1) = NPQ*JNUM
    call MPI_Allgather(NUMSEND,1_MPIInt,ITYPE,SIZ(1:NPROCS),1_MPIInt,ITYPE,MPI_COMM_WORLD,IERROR4)
    ! compute offsets into the receiving array
    DISP(1) = 0
    do I=2,NPROCS
      DISP(I) = DISP(I-1)+SIZ(I-1)
    end do

    ! collect the vectors
    call mma_allocate(RECVBUF,NFTSPC_TOT,Label='RECVBUF')
    call MPI_Barrier(MPI_COMM_WORLD,IERROR4)
    call MPI_Allgatherv_(CHOBUF,NCHOBUF,NUMSEND(1),MPI_REAL8,RECVBUF,NFTSPC_TOT,SIZ,DISP,NPROCS,MPI_REAL8,MPI_COMM_WORLD,IERROR)

    JNUMT = NVGLB_CHOBATCH(IB)
    ! disk offset is block offset + preceding block size
    IDISKT = IDGLB_CHOGROUP(ICASE,ISYQ,JSYM,IB)

    !SVC: for RHS on demand, write transposed chovecs, else just write
    if (RHSDIRECT) then
      call mma_allocate(TRANSP,NPQ*JNUMT,Label='TRANSP')
      call DTRANS(NPQ,JNUMT,RECVBUF,NPQ,TRANSP,JNUMT)
      call DDAFILE(LUDRATOT,1,TRANSP,NPQ*JNUMT,IDISKT)
      call mma_deallocate(TRANSP)
    else
      call DDAFILE(LUDRATOT,1,RECVBUF,NPQ*JNUMT,IDISKT)
    end if

#   ifdef _DEBUGPRINT_
    write(u6,*) ' process block, size, offset, fingerprint'
    do I=1,NPROCS
      MY_N = SIZ(I)
      NOFF = 1+DISP(I)
      SQFP = DDOT_(MY_N,RECVBUF(NOFF:),1,RECVBUF(NOFF:),1)
      write(u6,'(A,I6,A,2I12,ES20.12)') ' [',I,'] ',MY_N,NOFF,SQFP
    end do
#   endif
    call mma_deallocate(RECVBUF)
    call mma_deallocate(DISP)
    call mma_deallocate(SIZ)
  end if
# else
# include "macros.fh"
  unused_var(CHOBUF)
  unused_var(ICASE)
  unused_var(ISYQ)
  unused_var(JSYM)
  unused_var(IB)
# endif

end subroutine CHOVEC_COLL

#ifdef _MOLCAS_MPP_
subroutine MPI_Allgatherv_(SENDBUF,NSENDBUF,NSEND,MPITYPES,RCVBUF,NRCVBUF,NRCV,NOFF,MPROCS,MPITYPER,MPICOMM,IERROR)
  !*********************************************************************
  ! Wrapper to MPI_Allgatherv dealing with ILP64 incompatibility.
  !*********************************************************************

  use MPI_Wrapper, only: MPI_COMM_WORLD
  use stdalloc, only: mma_allocate, mma_deallocate
  use Definitions, only: MPIInt
# ifdef _I8_
  use Definitions, only: u6
# endif

  integer(kind=iwp), intent(in) :: NSENDBUF, NSEND, NRCVBUF, MPROCS
  real(kind=wp), intent(inout) :: SENDBUF(NSENDBUF), RCVBUF(NRCVBUF)
  integer(kind=MPIInt), intent(in) :: MPITYPES, NRCV(MPROCS), NOFF(MPROCS), MPITYPER, MPICOMM
  integer(kind=iwp), intent(out) :: IERROR
  integer(kind=MPIInt) :: IERROR4, NPROCS, NSEND4
  integer(kind=MPIInt), allocatable :: NRCV4(:), NOFF4(:)
# ifdef _I8_
  integer(kind=iwp) :: NRCVTOT
# endif

  call MPI_COMM_SIZE(MPI_COMM_WORLD,NPROCS,IERROR4)

# ifdef _I8_
  NRCVTOT = sum(NRCV(1:NPROCS))
  if (8*NRCVTOT > 2147483647) then
    write(u6,'(1X,A)') 'MPI_Allgatherv: total rcv buf > 2**31-1'
    write(u6,'(1X,A)') 'workaround to avoid buffers >2GB failed'
    write(u6,'(1X,A)') '-> please report this as a bug!'
    call ABEND()
  end if
# endif

  call MMA_ALLOCATE(NRCV4,int(NPROCS,kind=iwp),Label='NRCV4')
  call MMA_ALLOCATE(NOFF4,int(NPROCS,kind=iwp),Label='NOFF4')
  NSEND4 = int(NSEND,kind=MPIInt)
  NRCV4(:) = int(NRCV(1:NPROCS),kind=MPIInt)
  NOFF4(:) = int(NOFF(1:NPROCS),kind=MPIInt)
  call MPI_Allgatherv(SENDBUF,NSEND4,MPITYPES,RCVBUF,NRCV4,NOFF4,MPITYPER,MPICOMM,IERROR4)

  IERROR = IERROR4
  call MMA_DEALLOCATE(NRCV4)
  call MMA_DEALLOCATE(NOFF4)

end subroutine MPI_Allgatherv_
#endif

end module CHOVEC_IO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Dmat_MCLR(CMO,OCC,D)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Compute the active one-body density                              *
!                                                                      *
!     calling arguments:                                               *
!     CMO     : input, array of real(kind=wp)                          *
!               MO-coefficients                                        *
!     OCC     : input, array of real(kind=wp)                          *
!               occupation numbers                                     *
!     D       : output, array of real(kind=wp)                         *
!               total one-body density                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use input_mclr, only: nBas, nSym
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*), OCC(*)
real(kind=wp), intent(_OUT_) :: D(*)
integer(kind=iwp) :: i, iBas, ii, iOff1, iOff2, iOff3, iSym, j, k
real(kind=wp) :: rSum

iOff1 = 0
iOff2 = 0
iOff3 = 0
do iSym=1,nSym
  iBas = nBas(iSym)
  if (iBas /= 0) then
    do i=1,iBas
      ii = nTri_Elem(i-1)
      do j=1,i
        rSum = Zero
        do k=1,ibas
          rSum = rSum+OCC(iOff3+k)*CMO(iOff1+(k-1)*iBas+i)*CMO(iOff1+(k-1)*iBas+j)
        end do
        if (j == i) then
          D(iOff2+ii+j) = rSum
        else
          D(iOff2+ii+j) = Two*rSum
        end if
      end do
    end do
  end if
  iOff1 = iOff1+iBas*iBas
  iOff2 = iOff2+nTri_Elem(iBas)
  iOff3 = iOff3+iBas
end do

end subroutine Dmat_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_Gvv (Gvv)
c
c        check Gvv(be,a)
c
        implicit none
#include "chcc1.fh"
        real*8 Gvv(1:nv,1:nv)
c
c        help var
        integer i,a,b,be,bad
c       integer j
        real*8 s
c
        bad=0
c
        do be=1,nv
        do a=1,nv
c
c          s=0.0d0
c          do i=1,no
c          do j=1,no
c          do b=1,nv
c          s=s+(2.0d0*Q21(a,i,b,j)-Q21(a,j,b,i))*T2c(be,b,i,j)
c          end do
c          end do
c          end do
c          s=-s
c
          s=Hvvc(be,a)
c
          do i=1,no
          do b=1,nv
          s=s+(2.0d0*Q3(a,be,b,i)-Q3(b,be,a,i))*T1c(b,i)
          end do
          end do
c
          Gvvc(be,a)=s
c
          if (abs(Gvv(be,a)-s).gt.1.0d-10) then
          bad=bad+1
          end if
c
        end do
        end do
c
        write (6,*) ' Gvv Chck :',bad
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PMATEL(ISTATE,JSTATE,PROP,PINT,SMAT,CNO,OCC,SFOLD,AFOLD,TDAO)

use mrci_global, only: BNAME, IPCOMP, NBAS, NBAST, NBTRI, NCMO, NPROP, NRROOT, NSYM, PNAME, PNUC, PORIG, PTYPE
use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ISTATE, JSTATE
real(kind=wp), intent(_OUT_) :: PROP(NRROOT,NRROOT,NPROP), SMAT(*)
real(kind=wp), intent(out) :: PINT(NBTRI+4), SFOLD(NBTRI), AFOLD(NBTRI)
real(kind=wp), intent(in) :: CNO(NCMO), OCC(NBAST), TDAO(NBAST,NBAST)
integer(kind=iwp) :: I, ICALL = 0, IDUM(1), IDUMMY, IEND, IFROM, IJ, IPROP, IRTC, ISTA, ISY, ISY1, ISY12, ISY2, ISYMLB, ITO, J, &
                     NB1, NB12, NB2, NSIZ
real(kind=wp) :: SGN, X
real(kind=r8), external :: DDOT_

if (ISTATE == JSTATE) then
  ! READ OVERLAP INTEGRALS FROM TRAONE.
  call RDONE(IRTC,6,'MLTPL  0',1,SMAT,IDUMMY)
  ! CALCULATE AND WRITE MULLIKEN CHARGES.
  write(u6,*)
  write(u6,'(A,I2)') ' MULLIKEN CHARGES FOR STATE NR ',ISTATE
  call CHARGE(NSYM,NBAS,BNAME,CNO,OCC,SMAT,2,.true.,.true.)
  write(u6,*) ' ',('*',I=1,70)
end if
! FOLD TDAO SYMMETRICALLY (ANTI-SYMM) INTO SFOLD (AFOLD):
! MOLCAS2 UPDATE: SYMMETRY-BLOCKED STORAGE.
IJ = 0
IEND = 0
do ISY=1,NSYM
  ISTA = IEND+1
  IEND = IEND+NBAS(ISY)
  do I=ISTA,IEND
    do J=ISTA,I-1
      IJ = IJ+1
      SFOLD(IJ) = TDAO(I,J)+TDAO(J,I)
      AFOLD(IJ) = TDAO(I,J)-TDAO(J,I)
    end do
    IJ = IJ+1
    SFOLD(IJ) = TDAO(I,I)
    AFOLD(IJ) = Zero
  end do
end do
NSIZ = 0
do IPROP=1,NPROP
  ! PICK UP MATRIX ELEMENTS FROM ONE-ELECTRON FILE:
  call iRDONE(IRTC,1,PNAME(IPROP),IPCOMP(IPROP),IDUM,ISYMLB)
  if (IRTC == 0) NSIZ = IDUM(1)
  call RDONE(IRTC,0,PNAME(IPROP),IPCOMP(IPROP),PINT,ISYMLB)
  ! SEPARATE OUT THE OPERATOR GAUGE ORIGIN, AND NUCLEAR CONTRIBUTION:
  if (ICALL == 0) then
    PORIG(1,IPROP) = PINT(NSIZ+1)
    PORIG(2,IPROP) = PINT(NSIZ+2)
    PORIG(3,IPROP) = PINT(NSIZ+3)
    PNUC(IPROP) = PINT(NSIZ+4)
  end if
  if (ISYMLB /= 1) then
    ! NON-DIAGONAL SYMMETRY BLOCKS MUST BE COMPRESSED AWAY:
    IFROM = 1
    ITO = 1
    do ISY1=1,NSYM
      NB1 = NBAS(ISY1)
      if (NB1 == 0) cycle
      do ISY2=1,ISY1
        NB2 = NBAS(ISY2)
        if (NB2 == 0) cycle
        ISY12 = MUL(ISY1,ISY2)
        if (mod(ISYMLB,2**(ISY12)) == 0) cycle
        NB12 = NB1*NB2
        if (ISY12 == 1) then
          NB12 = (NB12+NB1)/2
          if (IFROM > ITO) call DCOPY_(NB12,PINT(IFROM),1,PINT(ITO),1)
          ITO = ITO+NB12
        end if
        IFROM = IFROM+NB12
      end do
    end do
    NSIZ = ITO
  end if
  ! PUT DDOT OF TR DENS MATRIX AND INTEGRALS INTO PROPER MATRIX ELEMENT
  ! FOR MULTIPOLES, USE NEGATIVE SIGN OF ELECTRONIC PART.
  SGN = One
  if (PNAME(IPROP)(1:5) == 'MLTPL') SGN = -SGN
  if (PTYPE(IPROP) == 'HERM') then
    X = SGN*DDOT_(NSIZ,SFOLD,1,PINT,1)
    PROP(ISTATE,JSTATE,IPROP) = X
    PROP(JSTATE,ISTATE,IPROP) = X
  else
    X = SGN*DDOT_(NSIZ,AFOLD,1,PINT,1)
    PROP(ISTATE,JSTATE,IPROP) = X
    PROP(JSTATE,ISTATE,IPROP) = -X
  end if
end do
ICALL = 1

return

end subroutine PMATEL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine IntFcm(lOld_Implicit)
!***********************************************************************
!                                                                      *
! Object: to initialize the Hessian matrix for the first iteration.    *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             May 1991                                                 *
!***********************************************************************

use Slapaf_Info, only: lOld
use Slapaf_procedures, only: OldFCM
use stdalloc, only: mma_deallocate
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(inout) :: lOld_Implicit
integer(kind=iwp) :: nHess, nQQ
real(kind=wp) :: rDum(1)
logical(kind=iwp) :: Found_IRC, Hess_Found
real(kind=wp), allocatable :: Hess(:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Read force constant matrix from old interphase

if (lOld) then

  ! Explicit request to use an old force constant matrix stored
  ! on an old runfile.

  call OldFcm(Hess,nQQ,'RUNOLD')

else

  ! If this is not an IRC calculation explore if the runfile
  ! contains a Hessian. If so, pull it off the runfile.

  call qpg_iScalar('IRC',Found_IRC)

  if (.not. Found_IRC) then
    call qpg_dArray('Hess',Hess_Found,nHess)

    if (Hess_Found .and. (nHess > 0)) then
      lOld_Implicit = .true.
      call OldFcm(Hess,nQQ,'RUNFILE')
    end if

  end if

end if

if ((.not. lOld) .and. lOld_Implicit) lOld = .true.

if (lOld) then
# ifdef _DEBUGPRINT_
  call RecPrt('IntFcm: Final Hessian',' ',Hess,nQQ,nQQ)
# endif
  call Put_dArray('Hss_Q',Hess,nQQ**2)
  call Put_dArray('Hss_upd',rDum,0)
  call mma_deallocate(Hess)
end if

return

end subroutine IntFcm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2006  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE DENS2_RPT2 (CI,SGM1,SGM2,G1,G2)
      use output_caspt2, only:iPrGlb,debug
#if defined (_MOLCAS_MPP_) && !defined (_GA_)
      USE Para_Info, ONLY: nProcs, Is_Real_Par, King
#endif
      IMPLICIT NONE

#include "rasdim.fh"
#include "caspt2.fh"
#include "pt2_guga.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

      LOGICAL RSV_TSK

      REAL*8 CI(MXCI),SGM1(MXCI),SGM2(MXCI)
      REAL*8 G1(NLEV,NLEV),G2(NLEV,NLEV,NLEV,NLEV)

      REAL*8 GTU,GTUVX,GTUXV

      INTEGER ID
      INTEGER IST,ISU,ISV,ISX,ISTU,ISVX
      INTEGER IT,IU,IV,IX,LT,LU,LV,LX,LTU,LVX

      INTEGER ITASK,LTASK,LTASK2T,LTASK2U,NTASKS

      INTEGER ISSG,NSGM

      REAL*8, EXTERNAL :: DDOT_,DNRM2_

c Purpose: Compute the 1- and 2-electron density matrix
c arrays G1 and G2.


      CALL DCOPY_(NG1,[0.0D0],0,G1,1)
      CALL DCOPY_(NG2,[0.0D0],0,G2,1)

C For the special cases, there is no actual CI-routines involved:
c Special code for hi-spin case:
      IF(ISCF.EQ.2) THEN
        DO IT=1,NASHT
          G1(IT,IT)=1.0D00
          DO IU=1,IT-1
            G2(IT,IT,IU,IU)= 1.0D00
            G2(IU,IU,IT,IT)= 1.0D00
            G2(IT,IU,IU,IT)=-1.0D00
            G2(IU,IT,IT,IU)=-1.0D00
          END DO
        END DO
        GOTO 99
      END IF
c Special code for closed-shell:
      IF(ISCF.EQ.1 .AND. NACTEL.GT.0) THEN
        DO IT=1,NASHT
          G1(IT,IT)=2.0D00
          G2(IT,IT,IT,IT)= 2.0D00
          DO IU=1,IT-1
            G2(IT,IT,IU,IU)= 4.0D00
            G2(IU,IU,IT,IT)= 4.0D00
            G2(IT,IU,IU,IT)=-2.0D00
            G2(IU,IT,IT,IU)=-2.0D00
          END DO
        END DO
        GOTO 99
      END IF

* For the general cases, we use actual CI routine calls, and
* have to take account of orbital order.
* We will use level indices LT,LU... in these calls, but produce
* the density matrices with usual active orbital indices.
* Translation tables L2ACT and LEVEL, in pt2_guga.fh

C-SVC20100311: set up a task table with LT,LU
      nTasks=(nLev**2+nLev)/2

      CALL GETMEM ('Tasks','ALLO','INTE',lTask,2*nTasks)
      lTask2T=lTask
      lTask2U=lTask+nTasks

      iTask=0
      DO LT=1,nLev
        DO LU=1,LT
          iTask=iTask+1
          iWork(lTask2T+iTask-1)=LT
          iWork(lTask2U+iTask-1)=LU
        ENDDO
      ENDDO
      IF (iTask.NE.nTasks) WRITE(6,*) "ERROR nTasks"

      Call Init_Tsk(ID, nTasks)

C-SVC20100311: BEGIN SEPARATE TASK EXECUTION
 500  If (.NOT.Rsv_Tsk (ID,iTask)) GOTO 501

* Compute SGM1 = E_UT acting on CI, with T.ge.U,
* i.e., lowering operations. These are allowed in RAS.
C     LTU=0
C     DO 140 LT=1,NLEV
      LT=iWork(lTask2T+iTask-1)
        IST=ISM(LT)
        IT=L2ACT(LT)
C       DO 130 LU=1,LT
        LU=iWork(lTask2U+iTask-1)
C         LTU=LTU+1
          LTU=iTask
          ISU=ISM(LU)
          IU=L2ACT(LU)
          ISTU=MUL(IST,ISU)
          ISSG=MUL(ISTU,STSYM)
          NSGM=NCSF(ISSG)
C         IF(NSGM.EQ.0) GOTO 130
          IF(NSGM.EQ.0) GOTO 500
          CALL GETSGM2(LU,LT,STSYM,CI,SGM1)
          IF(ISTU.EQ.1) THEN
            GTU=DDOT_(NSGM,CI,1,SGM1,1)
            G1(IT,IU)=GTU
            G1(IU,IT)=GTU
          END IF
          LVX=0
          DO LV=1,LT
            ISV=ISM(LV)
            IV=L2ACT(LV)
            DO LX=1,LV
              LVX=LVX+1
C             IF(LVX.GT.LTU) GOTO 125
              IF(LVX.GT.LTU) GOTO 500
              ISX=ISM(LX)
              ISVX=MUL(ISV,ISX)
              IF(ISVX.NE.ISTU) GOTO 110
              IX=L2ACT(LX)
              IF(LX.EQ.LT) THEN
C then actually T=U=V=X.
                GTUVX=DDOT_(NSGM,SGM1,1,SGM1,1)
              ELSE
                CALL GETSGM2(LX,LV,ISSG,SGM1,SGM2)
                GTUVX=DDOT_(NCONF,CI,1,SGM2,1)
              END IF

              IF(LV.EQ.LX) THEN
                GTUXV=GTUVX
              ELSE
                IF(LVX.EQ.LTU) THEN
                  GTUXV=DDOT_(NSGM,SGM1,1,SGM1,1)
                ELSE
                  CALL GETSGM2(LX,LV,STSYM,CI,SGM2)
                  GTUXV=DDOT_(NSGM,SGM1,1,SGM2,1)
                END IF
              END IF
              G2(IT,IU,IV,IX)=GTUVX
              G2(IT,IU,IX,IV)=GTUXV
 110        CONTINUE
            END DO
          END DO

CSVC: The master node now continues to only handle task scheduling,
C     needed to achieve better load balancing. So it exits from the task
C     list.  It has to do it here since each process gets at least one
C     task.
#if defined (_MOLCAS_MPP_) && !defined (_GA_)
      IF (IS_REAL_PAR().AND.KING().AND.(NPROCS.GT.1)) GOTO 501
#endif

      GOTO 500
 501  CONTINUE
      CALL Free_Tsk(ID)

      CALL GETMEM ('Tasks','FREE','INTE',lTask,2*nTasks)

      CALL GAdSUM (G1,NG1)
      CALL GAdSUM (G2,NG2)

C-SVC20100311: serial part: add corrections to G2
      DO LT=1,NLEV
       IT=L2ACT(LT)
       DO LX=1,LT
        IX=L2ACT(LX)
        DO LU=LX,LT
         IU=L2ACT(LU)
         G2(IT,IU,IU,IX)=G2(IT,IU,IU,IX)-G1(IT,IX)
        END DO
       END DO
      END DO
      DO LT=2,NLEV
       IT=L2ACT(LT)
       DO LX=2,LT
        IX=L2ACT(LX)
        DO LU=1,LX-1
         IU=L2ACT(LU)
         G2(IT,IU,IU,IX)=G2(IT,IU,IU,IX)-G1(IT,IX)
        END DO
       END DO
      END DO
      LTU=0
      DO LT=1,NLEV
       IT=L2ACT(LT)
       DO LU=1,LT
        LTU=LTU+1
        IU=L2ACT(LU)
        LVX=0
        DO LV=1,LT
         IV=L2ACT(LV)
         DO LX=1,LV
          LVX=LVX+1
          IX=L2ACT(LX)
          IF(LVX.GT.LTU) GOTO 225
          GTUVX=G2(IT,IU,IV,IX)
          G2(IU,IT,IX,IV)=GTUVX
          G2(IV,IX,IT,IU)=GTUVX
          G2(IX,IV,IU,IT)=GTUVX
          GTUXV=G2(IT,IU,IX,IV)
          G2(IU,IT,IV,IX)=GTUXV
          G2(IX,IV,IT,IU)=GTUXV
          G2(IV,IX,IU,IT)=GTUXV
         END DO
        END DO
 225    CONTINUE
       END DO
      END DO
  99  CONTINUE

      IF(iPrGlb.GE.DEBUG) THEN
        WRITE(6,'("DEBUG> ",A)')
     &   "DENS2_RPT2: norms of the density matrices:"
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G1:", DNRM2_(NG1,G1,1)
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G2:", DNRM2_(NG2,G2,1)
      ENDIF


      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SQUARE(A, B,ICB,IRB, NROW)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*),B(*)

* PAM Sep 06: The two special cases here account for
* almost all calls of this code, and written such as
* not to store with non-zero stride--at least some
* rudimentary consideration for cache.
      if(ICB.EQ.1) GOTO 100
      if(IRB.EQ.1) GOTO 200
* General and inefficient code:
      IND=0
      DO 10 IROW=0,NROW-1
      DO 11 ICOL=0,IROW
         IND=IND+1
         B(1+IROW*ICB+ICOL*IRB)=A(IND)
         B(1+ICOL*ICB+IROW*IRB)=A(IND)
11    CONTINUE
10    CONTINUE
      GOTO 900

 100  CONTINUE
      DO IC=0,NROW-1
       DO IR=0,IC
        B(1+IR+IC*IRB)=A(1+IR+(IC*(IC+1))/2)
       END DO
      END DO
      DO IC=0,NROW-2
       DO IR=IC+1,NROW-1
        B(1+IR+IC*IRB)=B(1+IC+IR*IRB)
       END DO
      END DO
      GOTO 900

 200  CONTINUE
      DO IC=0,NROW-1
       DO IR=0,IC
        B(1+IR+IC*ICB)=A(1+IR+(IC*(IC+1))/2)
       END DO
      END DO
      DO IC=0,NROW-2
       DO IR=IC+1,NROW-1
        B(1+IR+IC*ICB)=B(1+IC+IR*ICB)
       END DO
      END DO

 900  CONTINUE
      RETURN

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagVVVO(iSym,NBSQT,lT2AO,MaxVec_PT2,DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,T2AO,DIA,DI,FIFA,FIMO,A_PT2)

use iSD_data, only: iSD
use caspt2_global, only: LuAPT2, LuCMOPT2, LuGAMMA, OLag
use caspt2_global, only: CMOPT2
use caspt2_module, only: IFDW, IFMSCOUP, IFRMS, IFSADREF, IFXMS, iRlxRoot, JSTATE, NASH, NBAS, NBAST, NBMX, NFRO, NISH, NSSH, &
                         NSTATE, NSYM
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use caspt2_global, only: nOLag
use caspt2_module, only: NFROT
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iSym, NBSQT, lT2AO, MaxVec_PT2
real(kind=wp), intent(in) :: DPT2AO(NBSQT), DPT2CAO(NBSQT), T2AO(lT2AO), DIA(NBSQT), DI(NBSQT)
real(kind=wp), intent(inout) :: FPT2AO(NBSQT), FPT2CAO(NBSQT), FIFA(NBSQT), FIMO(NBSQT), A_PT2(MaxVec_PT2**2)
integer(kind=iwp) :: i, iBas, iBas0, id, iOcc, iost, IRC, iRec, iSh, iSymA, iSymB, iSymI, iSymJ, j, jBas, jBas0, jOcc, jSh, &
                     KEEP(8), loc1, loc2, lRealName, MaxShlAO, nBasI, nBasJ, nBasX(8), nDiff, nocc, nOrbA, nSkal, nSSDM, nSymX
logical(kind=iwp) :: DoCholesky, DoRys, is_error, Square
character(len=4096) :: RealName
integer(kind=iwp), allocatable :: iOffAO(:)
real(kind=wp), allocatable :: T_hbf(:,:,:,:), vLag(:), WRK1(:), WRK2(:)
integer(kind=iwp), external :: isFreeUnit

! ----- (VV|VO)

! Compute L_{pq} = (pa|jb) * T_{qj}^{ab}, in particular for
! (p,q) \in  (virt, inact+act). This operation involves
! (VV|VO) integrals which are stored in neither disk nor memory.
! The back-transformation is applied to occupied orbital derivatives
! of two-electron integrals that have two virtual indices (F, G, H).
! In principle, the algorithm is to avoid (VV|VO) integrals,
! i.e. U_{pq} for (p,q) = (vir, inact+act), but can also be applied
! to U_{pq} for (p,q) = (all, inact+act).

call mma_allocate(vLag,nBasT*nBasT,Label='vLag')
call mma_allocate(WRK1,nBasT*nBasT,Label='WRK1')
call GetOrd(IRC,Square,nSymX,nBasX,KEEP)

vLag(:) = Zero

call DecideOncholesky(DoCholesky)
if (DoCholesky) then
  !! No need to save CMOPT2. Just save A_PT2 and B_PT2.
  !! First, save A_PT2 in LuCMOPT2
  if (IFMSCOUP .and. (jState /= 1)) then
    call mma_allocate(WRK2,MaxVec_PT2**2,Label='WRK2')

    ! read A_PT2 from LUAPT2
    id = 0
    call ddafile(LUAPT2,2,WRK2,MaxVec_PT2**2,id)

    A_PT2(1:MaxVec_PT2**2) = A_PT2(1:MaxVec_PT2**2)+WRK2(1:MaxVec_PT2**2)
    call mma_deallocate(WRK2)
  end if

  ! For SS-CASPT2 I should write A_PT2 on disk only
  ! for the correct iRlxRoot
  if ((jState == iRlxRoot) .or. IFMSCOUP) then
    ! write A_PT2 in LUAPT2
    id = 0
    call ddafile(LUAPT2,1,A_PT2,MaxVec_PT2**2,id)
  end if

  !rewind(LuGamma)
  call PrgmTranslate('GAMMA',RealName,lRealName)
  LuGAMMA = isFreeUnit(LuGAMMA)
  call MOLCAS_Open_Ext2(LuGamma,RealName(1:lRealName),'DIRECT','UNFORMATTED',iost,.true.,nBas(iSym)**2*8,'OLD',is_error)
end if
!! 2) Compute ERI (mu rho | nu sigma)
!! 3) Quarter-transformation of ERI
!!    (mu rho | j sigma) = sum_{j} C_{nu j} (mu rho | nu sigma)
!! 4) Contract with AO amplitude
!!    L_{mu i} = sum_{j,rho sigma} T_{ij}^{mu nu}*(mu rho|j sigma)
!! the third argument is used wrongly, but should be no problem

!! D_{mu nu} := DPT2AO
!! FPT2AO = ((mu nu|rho sigma)-(mu rho|nu sigma)/4
!!          -(mu sigma|nu rho)/4)*D_{rho sigma}
isymi = 1
isymj = 1
isyma = 1
isymb = 1
!nocc = nfro(1)+nish(1)+nash(1)
nocc = nish(1)+nash(1)
call VVVO_Drv(nSym,nBas,nFro,KEEP,iSym,iSymI,iSymA,iSymJ,iSymB,lT2AO,T2AO,vLag,nOcc,nBasT,nBMX,CMOPT2(1+nBasT*nFro(iSymA)),DPT2AO, &
              DPT2CAO,FPT2AO,FPT2CAO,DIA,DI,FIFA,FIMO)

!! Save the half transformed integrals on disk.
!! It will be used in drvg1 etc for gradient.
if (DoCholesky) then
  !! Do nothing
  close(LuGAMMA)
else
  !! This is only for conventional calculations!!
  call PrgmTranslate('CMOPT2',RealName,lRealName)
  LuCMOPT2 = isFreeUnit(LuCMOPT2)
  call MOLCAS_Open_Ext2(LuCMOPT2,RealName(1:lRealName),'DIRECT','UNFORMATTED',iost,.false.,1,'OLD',is_error)
  !! First, CMOPT2 has to be saved. The MO coefficient matrix in
  !! grvg1 may be different from CMOPT2.
  do i=1,nBasT*nBasT
    write(LuCMOPT2) CMOPT2(i)
  end do
  do i=1,8
    write(LuCMOPT2) nIsh(i)+nAsh(i)
  end do
  do i=1,8
    write(LuCMOPT2) nFro(i)
  end do
  !! Number of state-specific density matrix
  !! It is needed, because the separable contribution to the
  !! electron repulsion integral is different
  nSSDM = 0
  if (.not. IFSADREF) then
    if (nState == 1) then
      nSSDM = 0
    else if (IFDW .or. IFRMS) then
      !! For (X)DW, use nState density matrix
      nSSDM = nState
    else if (IFXMS) then
      !! For XMS, use SA density matrix
      nSSDM = 0
    else if (IFMSCOUP) then
      !! For MS, use nState density matrix
      nSSDM = nState
    else
      !! Otherwise, use one SS density matrix
      nSSDM = 1
    end if
  end if
  write(LuCMOPT2) nSSDM

  close(LuCMOPT2)

  !write(u6,*) 'mo saved'
  !call sqprt(CMOPT2,nbast)

  call PrgmTranslate('GAMMA',RealName,lRealName)
  LuGAMMA = isFreeUnit(LuGAMMA)
  call MOLCAS_Open_Ext2(LuGamma,RealName(1:lRealName),'DIRECT','UNFORMATTED',iost,.true.,nOcc*nOcc*8,'OLD',is_error)
  if (is_error) then
    write(u6,*) 'Something is wrong in opening LuGamma in olagvvvo'
    call abend()
  end if
  ! Setup for shell. Why do I have to call IniSew damn here?
  ! The number of shells should be able to be referred globally.
  nDiff = 1
  DoRys = .true.
  call IniSew(DoRys,nDiff)
  call Nr_Shells(nSkal)
  call Setup_iSD()
  !! see Include/info.fh
  call mma_allocate(iOffAO,nSkal+1,Label='iOffAO')
  MaxShlAO = 0
  iOffAO(1) = 0
  do iSh=1,nSkal
    nBasI = iSD(2,iSh)*iSD(3,iSh)
    if (nBasI > MaxShlAO) MaxShlAO = nBasI
    iOffAO(iSh+1) = iOffAO(iSh)+nBasI
  end do
  !nMax = MaxShlAO*MaxShlAO*nOcc*nOcc

  call mma_allocate(T_hbf,nOcc,nOcc,MaxShlAO,MaxShlAO,Label='T_hbf')
  do iSh=1,nSkal
    !! iSD(2,iSh): number of AOs of the shell
    !! iSD(3,iSh): number of cont. func. of the shell
    nBasI = iSD(2,iSh)*iSD(3,iSh)
    do jSh=1,nSkal
      nBasJ = iSD(2,jSh)*iSD(3,jSh)
      do iBas0=1,nBasI
        iBas = iOffAO(iSh)+iBas0
        do jBas0=1,nBasJ
          jBas = iOffAO(jSh)+jBas0
          do iOcc=1,nOcc
            do jOcc=1,nOcc
              loc1 = jOcc-1+(jBas-1)*nOcc+(iOcc-1)*nOcc*nBasT+(iBas-1)*nOcc*nBasT*nOcc
              loc2 = iOcc-1+(iBas-1)*nOcc+(jOcc-1)*nOcc*nBasT+(jBas-1)*nOcc*nBasT*nOcc
              T_hbf(iOcc,jOcc,iBas0,jBas0) = T2AO(loc1+1)+T2AO(loc2+1)
            end do
          end do
          iRec = iBas+nBasT*(jBas-1)
          if (ifmscoup .and. (jstate /= 1)) then
            read(lugamma,rec=irec) (wrk1(i),i=1,nocc*nocc)
            t_hbf(:,:,ibas0,jbas0) = t_hbf(:,:,ibas0,jbas0)+reshape(wrk1(1:nocc**2),[nocc,nocc])
          end if
          write(LuGamma,rec=iRec) ((T_hbf(i,j,iBas0,jBas0),i=1,nOcc),j=1,nOcc)
        end do
      end do
    end do
  end do
  call mma_deallocate(iOffAO)
  call mma_deallocate(T_hbf)
  close(LuGAMMA)
  call Free_iSD()
  call clssew()
end if

!! 5) L_{ai} = sum_{mu} C_{mu a} L_{mu i}
!call DGEMM_('T','N',nSsh(iSym),nOcc,nBasT,One,CMOPT2(1+nBasT*nOcc),nBasT,vLag,nBasT,One,OLAG(nOCC+1),nOrb(iSymA))
!write(u6,*) 'olag before vvvo'
!call sqprt(olag,nbast)
nOrbA = nFro(iSymA)+nIsh(iSymA)+nAsh(iSymA)+nSsh(iSymA)
if (DoCholesky) nOcc = nOrbA-nFro(iSymA)
!write(u6,*) 'vLag'
!call sqprt(vLag,nbast)
call DGEMM_('T','N',nOrbA,nOcc,nBasT,One,CMOPT2,nBasT,vLag,nBasT,One,OLAG(nOrbA*nFro(iSymA)+1),nOrbA)
!write(u6,*) 'olag after vvvo'
!call sqprt(olag,nbast)

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  if (DoCholesky) call GADGOP(OLag,nOLag,'+')
  if (nFroT == 0) then
    call GADGOP(FPT2AO,nBasT**2,'+')
    call GADGOP(FPT2CAO,nBasT**2,'+')
  end if
end if
#endif
call mma_deallocate(vLag)
call mma_deallocate(WRK1)

end subroutine OLagVVVO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000-2016, Valera Veryazov                             *
************************************************************************
******************************************************************************
*                                                                            *
* Author:   Valera Veryazov 2000-2016                                        *
*           Theoretical Chemistry                                            *
*           Lund University                                                  *
*           Sweden                                                           *
*                                                                            *
******************************************************************************
      Subroutine systemf(c,rc)
      Implicit None
      Character*(*) C
      Character*1024 C2
      Integer LenC,StrnLn,i,rc

      LenC=StrnLn(C)
      if(LenC.gt.1024-1)then
        Write(6,*)' Error in systemf.f ! LenC :',LenC
        call abend()
      endif

      do 100 i=1,lenc
      c2(i:i)=c(i:i)
100   continue
      call systemc(c2,lenc,rc)
      Return
      End
      Subroutine systemf2(c,rc)
      Implicit None
      Character*(*) C
      Character*1024 C2
      Integer LenC,StrnLn,i,rc

      LenC=StrnLn(C)
      if(LenC.gt.1024-1)then
        Write(6,*)' Error in systemf.f ! LenC :',LenC
        call abend()
      endif

      do 100 i=1,lenc
      c2(i:i)=c(i:i)
100   continue
      call systemc2(c2,lenc,rc)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Ignacio Fdez. Galvan                             *
************************************************************************
*  Sp_Transpose
*
*> @ingroup Sparse
*> @brief
*>   Transpose a matrix in sparse format
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Saves in \p B the transpose of the input matrix \p A, both in sparse format.
*>
*> @param[in] n   Size of the matrices
*> @param[in] A   Input matrix, in sparse format
*> @param[in] ija Index vector of matrix \p A
*> @param[in] B   Output matrix, in sparse format
*> @param[in] ijb Index vector of matrix \p B
*> @param[in] nij Length of the vectors
************************************************************************
      SUBROUTINE Sp_Transpose(n,A,ija,B,ijb,nij)
      IMPLICIT NONE
      INTEGER n, ija(*), ijb(*), nij, i, j, k, kk
      INTEGER, DIMENSION(:), ALLOCATABLE :: ia
      REAL*8 A(*), B(*)
#include "real.fh"
#include "stdalloc.fh"

      IF (A(n+1).GT.Zero) THEN
        call dcopy_(nij,A,1,B,1)
        CALL ICopy(nij,ija,1,ijb,1)
      ELSE
        CALL mma_allocate(ia,nij)
c
c       Create an index of the rows in A
        DO i=1,n
          B(i)=A(i)
          DO k=ija(i),ija(i+1)-1
            ia(k)=i
          END DO
        END DO
c
c       Lookup each column in A, save in B as a row
        ijb(1)=n+2
        kk=ijb(1)
        DO j=1,n
          DO k=ija(1),nij
            IF (ija(k).EQ.j) THEN
              ijb(kk)=ia(k)
              B(kk)=A(k)
              kk=kk+1
            END IF
          END DO
          ijb(j+1)=kk
        END DO
        B(n+1)=Zero
        CALL mma_deallocate(ia)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3initfiles(length)
! this routine distributes work space WRK for required files
! for fix mediates it defines also mapd and mapi, for help mediates
! it estimates their length and distribute WRK (i.e. def pos0 parameters)
!
! length - overal requirements of work space (O)
!
! !N.B. This routine cannot run with +OP2 level

use CCT3_global, only: dp1, dp2, fk1, fk2, fk3, fk4, fk5, fk6, h1, h2, h3, l1, l2, m1, m2, m3, mchntyp, n, noa, norb, nsym, nvb, &
                       posd0, px, rx1, rx2, rx3, t11, t12, t21, t22, t23, vx, w11, w12, w13, w14, w21, w22, w23, wx
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: length
integer(kind=iwp) :: maxnoa, maxnorb, maxnvb, nhelp1, nhelp2, post, sizeh, sizel, sizem, sizen, sizer, sizew, symp

!1 maps and positions for fix mediated

!1.0 maps for DP - diagonal part
!    N.B. DP has one degree of freedom, while other 1 index has none
!    DP1 - dp(p)a
!    DP2 - dp(p)b

dp1%i(1:nsym,1:nsym,1:nsym) = 0
dp2%i(1:nsym,1:nsym,1:nsym) = 0

post = 1

dp1%pos0 = post
dp1%d(0,1) = 5
dp1%d(0,2) = 0
dp1%d(0,3) = 0
dp1%d(0,4) = 0
dp1%d(0,5) = nsym
dp1%d(0,6) = 0

dp1%d(1:nsym,4:6) = 1
do symp=1,nsym
  dp1%d(symp,1) = post
  dp1%d(symp,2) = norb(symp)
  dp1%d(symp,3) = symp
  dp1%i(symp,1,1) = symp
  post = post+norb(symp)
end do

dp2%pos0 = post
dp2%d(0,1) = 5
dp2%d(0,2) = 0
dp2%d(0,3) = 0
dp2%d(0,4) = 0
dp2%d(0,5) = nsym
dp2%d(0,6) = 0

dp2%d(1:nsym,4:6) = 1
do symp=1,nsym
  dp2%d(symp,1) = post
  dp2%d(symp,2) = norb(symp)
  dp2%d(symp,3) = symp
  dp2%i(symp,1,1) = symp
  post = post+norb(symp)
end do

!1.1 maps for T1
!    T11 - t1oaa(a,i)
!    T12 - t1obb(a,i)

t11%pos0 = post
call cct3_grc0(2,0,3,1,0,0,1,t11,post)
t12%pos0 = post
call cct3_grc0(2,0,4,2,0,0,1,t12,post)

!1.5 maps for FK
!    FK1 - f(a,b)aa
!    FK2 - f(a,b)bb
!    FK3 - f(a,i)aa
!    FK4 - f(a,i)bb
!    FK5 - f(i,j)aa
!    FK6 - f(i,j)bb

fk1%pos0 = post
call cct3_grc0(2,0,3,3,0,0,1,fk1,post)
fk2%pos0 = post
call cct3_grc0(2,0,4,4,0,0,1,fk2,post)
fk3%pos0 = post
call cct3_grc0(2,0,3,1,0,0,1,fk3,post)
fk4%pos0 = post
call cct3_grc0(2,0,4,2,0,0,1,fk4,post)
fk5%pos0 = post
call cct3_grc0(2,0,1,1,0,0,1,fk5,post)
fk6%pos0 = post
call cct3_grc0(2,0,2,2,0,0,1,fk6,post)

!1.6 maps for T2
!    T21 - t2o(ab,ij)aaaa
!    T22 - t2o(ab,ij)bbbb
!    T23 - t2o(a,b,i,j)abab

t21%pos0 = post
call cct3_grc0(4,4,3,3,1,1,1,t21,post)
t22%pos0 = post
call cct3_grc0(4,4,4,4,2,2,1,t22,post)
t23%pos0 = post
call cct3_grc0(4,0,3,4,1,2,1,t23,post)

!1.8 maps for W1
!    W11 - <ie||mn>aaaa
!    W12 - <ie||mn>bbbb
!    W13 - <ie||mn>abab
!    W14 - <ie||mn>baab

w11%pos0 = post
call cct3_grc0(4,3,1,3,1,1,1,w11,post)
w12%pos0 = post
call cct3_grc0(4,3,2,4,2,2,1,w12,post)
w13%pos0 = post
call cct3_grc0(4,0,1,4,1,2,1,w13,post)
w14%pos0 = post
call cct3_grc0(4,0,2,3,1,2,1,w14,post)

!1.9 maps for W2
!    W21 - <ab||ij>aaaa
!    W22 - <ab||ij>bbbb
!    W23 - <a,b|i,j>abab

w21%pos0 = post
call cct3_grc0(4,4,3,3,1,1,1,w21,post)
w22%pos0 = post
call cct3_grc0(4,4,4,4,2,2,1,w22,post)
w23%pos0 = post
call cct3_grc0(4,0,3,4,1,2,1,w23,post)

!2 for help files maps are irrelevant,
!  here only estimation of maximal length is done to
!  define pos0 of help files
!  we have:
!  2  W,V files - of vv2 type
!  2    L files - of vvv (vvo) type
!  3    R files - of vv2+ type
!  3    M files - of vv (vo)  type
!  3    H files - of v (o)  type
!  2  N,P files - of nn   type

wx%pos0 = post

!2.* find maxsize of W,L,M,H
sizew = 0
sizel = 0
sizer = 0
sizem = 0
sizeh = 0

do nhelp1=1,nsym

  ! W,V files
  call cct3_t3grc0(3,2,4,4,4,0,nhelp1,wx,post)
  nhelp2 = post-wx%pos0
  if (nhelp2 > sizew) then
    sizew = nhelp2
  end if

  ! L files
  call cct3_t3grc0(3,0,4,4,4,0,nhelp1,wx,post)
  nhelp2 = post-wx%pos0
  if (nhelp2 > sizel) then
    sizel = nhelp2
  end if
  call cct3_t3grc0(3,0,1,4,4,0,nhelp1,wx,post)
  nhelp2 = post-wx%pos0
  if (nhelp2 > sizel) then
    sizel = nhelp2
  end if

  ! R files
  call cct3_t3grc0(3,8,4,4,4,0,nhelp1,wx,post)
  nhelp2 = post-wx%pos0
  if (nhelp2 > sizer) then
    sizer = nhelp2
  end if

  ! M files
  call cct3_t3grc0(2,0,4,4,0,0,nhelp1,wx,post)
  nhelp2 = post-wx%pos0
  if (nhelp2 > sizem) then
    sizem = nhelp2
  end if
  call cct3_t3grc0(2,0,1,4,0,0,nhelp1,wx,post)
  nhelp2 = post-wx%pos0
  if (nhelp2 > sizem) then
    sizem = nhelp2
  end if

  ! H files
  call cct3_t3grc0(1,0,4,0,0,0,nhelp1,wx,post)
  nhelp2 = post-wx%pos0
  if (nhelp2 > sizeh) then
    sizeh = nhelp2
  end if
  call cct3_t3grc0(1,0,1,0,0,0,nhelp1,wx,post)
  nhelp2 = post-wx%pos0
  if (nhelp2 > sizeh) then
    sizeh = nhelp2
  end if

end do

!2.* def max{noa}, max{norb} ,max{nvb}

maxnoa = noa(1)
maxnvb = nvb(1)
maxnorb = norb(1)
do symp=1,nsym
  if (noa(symp) > maxnoa) maxnoa = noa(symp)
  if (norb(symp) > maxnorb) maxnorb = norb(symp)
  if (nvb(symp) > maxnvb) maxnvb = nvb(symp)
end do

!2.* def lengths of N fils

sizen = 0

do symp=1,nsym
  ! symq is not known for N file
  ! instead of norb(symr) maxnorb will be used so that reallength<=length
  sizen = sizen+norb(symp)*maxnorb
end do

!2.1 WX,VX - files

! wx%pos0 is defined
post = wx%pos0+sizew
vx%pos0 = post
post = post+sizew

!2.2 L - files

l1%pos0 = post
post = post+sizel
l2%pos0 = post
post = post+sizel

!2.3 RX - files

rx1%pos0 = post
post = post+sizer
rx2%pos0 = post
post = post+sizer
rx3%pos0 = post
post = post+sizer

!2.4 M - files

m1%pos0 = post
post = post+sizem
m2%pos0 = post
post = post+sizem
m3%pos0 = post
post = post+sizem

!2.5 H - files

h1%pos0 = post
post = post+sizeh
h2%pos0 = post
post = post+sizeh
h3%pos0 = post
post = post+sizeh

!2.6 N,PX - files

n%pos0 = post
post = post+sizen
px%pos0 = post
post = post+sizen

!2.7 declare space for help matrix D in for matrix multiplication C=AT*B if mchntyp=2

if (mchntyp == 2) then
  posd0 = post
  if (maxnoa <= maxnvb) then
    post = post+maxnoa*maxnoa*maxnvb*maxnvb
  else
    post = post+maxnoa*maxnoa*maxnoa*maxnoa
  end if
end if

length = post-1

return

end subroutine t3initfiles

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKBG(DREF,NDREF,FD)

use Index_Functions, only: iTri, nTri_Elem
use EQSOLV, only: IDBMAT, IDSMAT
use caspt2_global, only: ipea_shift, LUSBT
use caspt2_module, only: EASUM, NAES, NASH, NINDEP, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDREF
real(kind=wp), intent(in) :: DREF(NDREF), FD(NDREF)
integer(kind=iwp) :: I, IBG, ID, IDIAG, IDISK, IDS, IDT, ISYM, IT, ITABS, IX, IXABS, NAS, NBG, NINM, NINP
real(kind=wp) :: Val
real(kind=wp), allocatable :: BG(:), S(:), SD(:)

! Set up the matrix BG(t,x)
! Formula used:
! BG(t,x)= Ftx -EASUM*Dtx

do ISYM=1,NSYM
  NINP = NINDEP(ISYM,10)
  if (NINP == 0) cycle
  NINM = NINDEP(ISYM,11)
  NAS = NASH(ISYM)
  NBG = nTri_Elem(NAS)
  if (NBG > 0) then
    call mma_Allocate(BG,NBG,LABEL='BG')
    !GG.Nov03  Load in SD the diagonal elements of SG matrix:
    call mma_allocate(S,NBG,Label='S')
    call mma_allocate(SD,NAS,Label='SD')
    IDS = IDSMAT(ISYM,10)
    call DDAFILE(LUSBT,2,S,NBG,IDS)
    IDIAG = 0
    do I=1,NAS
      IDIAG = IDIAG+I
      SD(I) = S(IDIAG)
    end do
    call mma_deallocate(S)
    !GG End
  end if
  do IT=1,NAS
    ITABS = IT+NAES(ISYM)
    do IX=1,IT
      IXABS = IX+NAES(ISYM)
      IBG = iTri(IT,IX)
      ID = iTri(ITABS,IXABS)
      !GG.Nov03
      Val = FD(ID)-EASUM*DREF(ID)
      if (IT == IX) then
        IDT = nTri_Elem(ITABS)
        Val = Val+ipea_shift*half*(two-DREF(IDT))*SD(IT)
      end if
      BG(IBG) = Val
      !BG(BG) = FD(ID)-EASUM*DREF(ID)
      !GG End
    end do
  end do

  ! Write to disk, and save size and address.
  if (NBG > 0) then
    if (NINDEP(ISYM,10) > 0) then
      IDISK = IDBMAT(ISYM,10)
      call DDAFILE(LUSBT,1,BG,NBG,IDISK)
    end if
    if ((NINM > 0) .and. (NINDEP(ISYM,11) > 0)) then
      IDISK = IDBMAT(ISYM,11)
      call DDAFILE(LUSBT,1,BG,NBG,IDISK)
    end if
    !GG.Nov03 DisAlloc SD
    call mma_deallocate(SD)
    !GG End
    call mma_deallocate(BG)
  end if
end do

end subroutine MKBG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Density_Matrix(ip_D,nBas1,nBas2,nBasMax,nBas,nSym,
     &                      ipP,UserDen,PrintDen,SubtractDen,SubScale,
     &                      Q_Nuc,nAtoms,iPert,Restart,Utility,TDensity,
     &                      nStateI,nStateF)

      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
* OBSERVE! MxState has to be the same as MxStat in cntrl.fh
*          in src/rassi.
      Parameter (MxState=200,MxStOT=MxState*(MxState+1)/2)
      Integer nBas(nSym)
      Character*16 Label, filename
      Dimension Q_Nuc(nAtoms)
      Dimension iToc(MxStOT)
      Logical UserDen, PrintDen, SubtractDen, Exist, Restart, Utility
      Logical TDensity, ok1, ok2, Found
      Character*8 Method
      Real*8, Allocatable:: DTmp(:), DSym(:)
*
*define _DEBUGPRINT_
*
      Write(Label,'(A,I1)') 'LoProp Dens ',iPert
      If (Restart) Then
*
* Retrieve density matrix from the runfile
*
         Call qpg_dArray(Label,Exist,nDens)
         If (.NOT. Exist .or. nDens .eq. 0) Then
            Call SysAbendMsg('get_density_matrix',
     &                       'Could not locate:',Label)
         End If
         Call Allocate_Work(ip_D,nDens)
         Call Get_dArray(Label,Work(ip_D),nDens)
*
         nSize=nDens
*
      Else If (nSym.eq.1) Then
*
         nSize=nBas(1)*(nBas(1)+1)/2
*
         If(UserDen) then
* Additions made by A.Ohrn to enable LoProp to read in a density matrix
* provided by the user. Generalized by P. Soderhjelm so that also
* perturbed density matrices may be read for polarizability calculation
           Lu_Ud=56
           Lu_Ud=IsFreeUnit(Lu_Ud)
           If(ipert.eq.0) Then
              filename='USERDEN'
           Else
              Write(filename,'(A7,I1)')'USERDEN',ipert
           EndIf
           Call OpnFl(filename,Lu_Ud,Exist)
           If(.not.Exist) then
             Write(6,*)
             Write(6,*)' Unable to locate user density matrix.'
             Call Abend()
           Endif
           Call GetMem('UserDen','Allo','Real',ipUser,nSize)
           Read(Lu_Ud,*)(Work(ipUser+k),k=0,nSize-1)
           Call Put_D1ao(Work(ipUser),nSize)
           Call GetMem('UserDen','Free','Real',ipUser,nSize)
           Close(Lu_Ud)
         Endif
* Addition of A.Ohrn, to collect transition density matrix from ToFile.
         If(TDensity) then
           LuIn=57
           LuIn=IsFreeUnit(LuIn)
           Call DaName(LuIn,'TOFILE')
           iDisk=0
*---  Table-of-contents
           Call iDaFile(LuIn,2,iToc,MxStOT,iDisk)
*---  Allocation of density
           Call GetMem('TDMden','Allo','Real',iTDMden,nSize)
*---  Loop to 'suck-out' the relevant matrix from the ToFile.
           nStateM=max(nStateI,nStateF)
           kaunter=0
           Do iS1=1,nStateM
             Do iS2=1,iS1
               kaunter=kaunter+1
               iDisk=iToc(kaunter)
               Call dDaFile(LuIn,2,Work(iTDMden),nSize,iDisk)
               ok1=iS1.eq.nStateI.and.iS2.eq.nStateF
               ok2=iS1.eq.nStateF.and.iS2.eq.nStateI
               If(ok1.or.ok2) then
                 Call Put_D1ao(Work(iTDMden),nSize)
               Endif
             Enddo
           Enddo
           Call GetMem('TDMden','Free','Real',iTDMden,nSize)
           Call DaClos(LuIn)
         Endif
* End addition A.Ohrn.

         If(SubtractDen) then
* Additions made by P.Soderhjelm to enable LoProp to read in a density matrix
* provided by the user and subtract that from the current one (which could
* in fact be provided by the Userdens keyword. After subtraction the matrix
* is scaled by a constant SubScale. Nuclear charges are set to zero.
           Lu_Ud=56
           Lu_Ud=IsFreeUnit(Lu_Ud)
           Call OpnFl('SUBDEN',Lu_Ud,Exist)
           If(.not.Exist) then
             Write(6,*)
             Write(6,*)' Unable to locate density matrix to subtract.'
             Call Abend()
           Endif
           Call GetMem('UserDen','Allo','Real',ipUser,nSize)
           Read(Lu_Ud,*)(Work(ipUser+k),k=0,nSize-1)
           Call mma_allocate(DTmp,nSize)
           Call Get_D1ao(Dtmp,nSize)
           Do k=0,nSize-1
              Dtmp(1+k)=SubScale*(Dtmp(1+k)-Work(ipUser+k))
           EndDo
           Call Put_D1ao(Dtmp,nSize)
           Call mma_deallocate(DTmp)
           Call GetMem('UserDen','Free','Real',ipUser,nSize)
           Close(Lu_Ud)
           Do k=1,nAtoms
              Q_Nuc(k)=0.0D0
           EndDo
         Endif
* End addition P.Soderhjelm.

* Addition by J.Bostrom to check if loprop should pick
* the variational density instead.
         Call Get_cArray('Relax Method',Method,8)
         iMp2Prpt = 0
         If(Method.eq.'MBPT2   ') Then
            Call Get_iScalar('mp2prpt',iMp2Prpt)
         End If
         Call getmem('D','Allo','Real',ip_D,nSize)
         If(iMp2Prpt.ne.0) Then
            Call Get_D1ao_var(Work(ip_D),nSize)
         else
* End Addition J.Bostrom (well, the End If too ofc.)
            Call Get_D1ao(Work(ip_D),nSize)
         End If
         nDens=nSize
#ifdef _DEBUGPRINT_
         Call RecPrt('D',' ',Work(ip_D),1,nDens)
#endif
         If(PrintDen) Then
* Addition made by P.Soderhjelm to enable LoProp to print the density matrix
* to a text file for later use.
           Lu_Ud=56
           Lu_Ud=IsFreeUnit(Lu_Ud)
           Call OpnFl('PRDEN',Lu_Ud,Exist)
           Write(Lu_Ud,'(10d25.16)')(Work(ip_D+k),k=0,nDens-1)
           Close(Lu_Ud)
         EndIf

*
      Else
*
         Call Allocate_Work(ip_D,nBas1*(nBas1+1)/2)
         Call Allocate_Work(ip_D_sq,nBas1**2)
         Call Allocate_Work(ip_Tmp,nBas2)
*
         Call Qpg_darray('D1ao',Found,nDens)
         If (Found .and. nDens/=0) Then
            Call mma_allocate(DSym,nDens,Label='DSym')
            Call Get_D1ao(DSym,nDens)
         Else
            Write (6,*) 'Get_density_matrix: not found.'
            Call Abend()
         End If
         iSyLbl=1
#ifdef _DEBUGPRINT_
         Call RecPrt('DSym',' ',DSym,1,nDens)
#endif
         iOfft = 1
         iOffs = ip_Tmp
         Do iSym = 1, nSym
            If (nBas(iSym).eq.0) Go To 99
#ifdef _DEBUGPRINT_
            Call TriPrt('DSym',' ',DSym(iOfft),nBas(iSym))
#endif
            Call Square(DSym(iOfft),Work(iOffs),1,nBas(iSym),nBas(iSym))
            Call DScal_(nBas(iSym)**2,Half,Work(iOffs),1)
            Call DScal_(nBas(iSym)   ,Two, Work(iOffs),nBas(iSym)+1)
#ifdef _DEBUGPRINT_
            Call RecPrt('DSym',' ',Work(iOffs),nBas(iSym),nBas(iSym))
#endif
            iOfft = iOfft + nBas(iSym)*(nBas(iSym)+1)/2
            iOffs = iOffs + nBas(iSym)**2
 99         Continue
         End Do
         Call mma_deallocate(DSym)
*
         nScr=nBasMax*nBas1
         Call Allocate_Work(ipScr,nScr)
         Call Desymmetrize(Work(ip_Tmp),nBas2,Work(ipScr),nScr,
     &                     Work(ip_D_sq),nBas,nBas1,Work(ipP),nSym,
     &                     iSyLbl)
         Call Free_Work(ipScr)
         Call Free_Work(ip_Tmp)
*
         Call Triangularize(Work(ip_D_sq),Work(ip_D),nBas1,.True.)
         Call Free_Work(ip_D_sq)
      End If
#ifdef _DEBUGPRINT_
      Call TriPrt('Density Matrix',' ',Work(ip_D),nBas1)
#endif
*
* Copy Density Matrix to the runfile
*
      If ((.Not. Restart) .AND. (.Not. Utility)) Then
*        Call put_dArray(Label,Work(ip_D),nDens)
         Call put_dArray(Label,Work(ip_D),nBas1*(nBas1+1)/2)
      End If
*
      Return
      End
      Subroutine Triangularize(A_sq, A_tr, n, Fold)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 A_sq(n,n), A_tr(n*(n+1)/2)
      Logical Fold
*
      Fact = One
      If (Fold) Fact = Two
      ij = 1
      Do i = 1, n
         Do j = 1, i-1
            A_tr(ij)=Fact*A_sq(i,j)
            ij = ij + 1
         End Do
         A_tr(ij)=A_sq(i,j)
         ij = ij + 1
      End Do
*
      Return
      End
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine contw1 (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,
     &                    lunt2o3)
c
c     this routine calc contributions to W1 i.e. W11,W12,W13
c     and controibution frim W1 to T2 i.e. T24
c
c
c     Mediate : WI(m,n,i,j)
c     Spin states : WI(mn,ij)aaaa, WI(mn,ij)bbbb, WI(m,n,i,j)abab
c     Contributions:
c
c     WI1
cI.1  WI(mn,ij)aaaa   <= <mn||ij>aaaa
cJ.1  WI(mn,ij)bbbb   <= <mn||ij>bbbb
cK.1  WI(m,n,i,j)abab <= <mn||ij>abab
c
c     WI2
cI.2  Q(mn,i,j)aaaa  <= sum(e-a) [ <ie||mn>aaaa . T1o(e,j)aa ]
c     WI(mn,ij)aaaa   <- Q(mn,i,j)aaaa - Q(mn,j,i)aaaa  i>j
cJ.2  Q(mn,i,j)bbbb  <= sum(e-b) [ <ie||mn>bbbb . T1o(e,j)bb ]
c     WI(mn,ij)bbbb   <- Q(mn,i,j)bbbb - Q(mn,j,i)bbbb  i>j
cK.2  WI(m,n,i,j)abab <- - sum(e-a) [ <je||mn>baab . T1o(e,i)aa ]
c     <- sum(e-b) [ <ie||mn>abab . T1o(e,j)bb ]
c
c     WI3
cI.3  WI(mn,ij)aaaa   <- sum(e>f-aa) [ <ef||mn>aaaa . Tau(ef,ij)aaaa ]
cJ.3  WI(mn,ij)bbbb   <- sum(e>f-bb) [ <ef||mn>bbbb . Tau(ef,ij)bbbb ]
cK.3  WI(m,n,i,j)abab <- sum(e,f-ab) [ <ef||mn>abab . Tau(e,f,i,j)abab ]
c
c     T24
cI.4  T2n(ab,ij)aaaa   <- sum(m>n-aa) [ Tau(ab,mn)aaaa . W1(mn,ij)aaaa ]
cJ.4  T2n(ab,ij)bbbb   <- sum(m>n-bb) [ Tau(ab,mn)bbbb . W1(mn,ij)bbbb ]
cK.4  T2n(a,b,i,j)abab <- sum(m,n-ab) [ Tau(a,b,m,n)abab . W1(m,n,i,j)abab ]
c
c     N.B. use and destroy : V1,V2,V3,V4
c     N.B. number of read  : 6
c
       use Para_Info, only: MyRank
#include "ccsd2.fh"
#include "parallel.fh"
#include "wrk.fh"
       integer lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,lunt2o3
c
c     help variables
c
       integer posst,rc,ssc
c
c
cpar
      if (myRank.eq.idfin) then
c
cI    case W1(mn,ij)aaaa
c
cI.1.1map V1(mn,ij) <= <mn||ij>aaaa
       call map (wrk,wrksize,
     & 4,1,2,3,4,mapdw01,mapiw01,1,mapdv1,mapiv1,possv10,
     &           posst,rc)
c
c
c
cI.2.1map V2(mn,i,e) <= <ie||mn>aaaa
       call map (wrk,wrksize,
     & 4,3,4,1,2,mapdw11,mapiw11,1,mapdv2,mapiv2,possv20,
     &           posst,rc)
c
cI.2.2mult V3(mn,i,j) <= V2(mn,i,e) . T1o(e,j)aa
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv2,mapiv2,1,mapdt11,mapit11,1,mapdv3,
     &            mapiv3,ssc,possv30,rc)
c
cI.2.3pack V2(mn,ij) <= V3(mn,i,j)
       call fack (wrk,wrksize,
     & 4,4,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
c
cI.2.4add V1(mn,ij) <- V2(mn,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
c
c
cI.3.1read V2(ef,ij) <= T2o(ef,ij)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv20,mapdv2,mapiv2,rc)
c
cI.3.2make Tau V2(ef,ij) from V2(ef,ij)
       call mktau (wrk,wrksize,
     & mapdv2,mapiv2,mapdt11,mapit11,mapdt12,mapit12,1.0d0,
     &             rc)
c
cI.3.3read V3(ef,mn) <= <ef||mn>aaaa
       call filemanager (2,lunabij1,rc)
       call getmediate (wrk,wrksize,
     & lunabij1,possv30,mapdv3,mapiv3,rc)
c
cI.3.4map V4(mn,ef) <= V3(ef,mn)
       call map (wrk,wrksize,
     & 4,3,4,1,2,mapdv3,mapiv3,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
c
cI.3.5mult V3(mn,ij) = V4(mn,ef) . V2(ef,ij)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
cI.3.6add V1(mn,ij) <- V3(mn,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
c
c
cI.4.0Tau(ab,mn) are in V2(ab,mn) from I.3.2
c     W1(mn,ij)  are in V1(mn,ij)
c
cI.4.1V3(ab,ij) = V2(ab,mn) . V1(mn,ij)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
cI.4.2add t2n(ab,ij)aaaa <- V3(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt21,mapit21,1,rc)
c
c
c
cJ    case W1(mn,ij)bbbb
c
cJ.1.1map V1(mn,ij) <= <mn||ij>bbbb
       call map (wrk,wrksize,
     & 4,1,2,3,4,mapdw02,mapiw02,1,mapdv1,mapiv1,possv10,
     &           posst,rc)
c
c
c
cJ.2.1map V2(mn,i,e) <= <ie||mn>bbbb
       call map (wrk,wrksize,
     & 4,3,4,1,2,mapdw12,mapiw12,1,mapdv2,mapiv2,possv20,
     &           posst,rc)
c
cJ.2.2mult V3(mn,i,j) <= V2(mn,i,e) . T1o(e,j)bb
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv2,mapiv2,1,mapdt12,mapit12,1,mapdv3,
     &            mapiv3,ssc,possv30,rc)
c
cJ.2.3pack V2(mn,ij) <= V3(mn,i,j)
       call fack (wrk,wrksize,
     & 4,4,mapdv3,1,mapiv3,mapdv2,mapiv2,possv20,rc)
c
cJ.2.4add V1(mn,ij) <- V2(mn,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
c
c
cJ.3.1read V2(ef,ij) <= T2o(ef,ij)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv20,mapdv2,mapiv2,rc)
c
cJ.3.2make Tau V2(ef,ij) from V2(ef,ij)
       call mktau (wrk,wrksize,
     & mapdv2,mapiv2,mapdt11,mapit11,mapdt12,mapit12,1.0d0,
     &             rc)
c
cJ.3.3read V3(ef,mn) <= <ef||mn>bbbb
       call filemanager (2,lunabij2,rc)
       call getmediate (wrk,wrksize,
     & lunabij2,possv30,mapdv3,mapiv3,rc)
c
cJ.3.4map V4(mn,ef) <= V3(ef,mn)
       call map (wrk,wrksize,
     & 4,3,4,1,2,mapdv3,mapiv3,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
c
cJ.3.5mult V3(mn,ij) = V4(mn,ef) . V2(ef,ij)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
cJ.3.6add V1(mn,ij) <- V3(mn,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
c
c
cJ.4.0Tau(ab,mn) are in V2(ab,mn) from J.3.2
c     W1(mn,ij)  are in V1(mn,ij)
c
cJ.4.1mult V3(ab,ij) = V2(ab,mn) . V1(mn,ij)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
cJ.4.2add t2n(ab,ij)bbbb <- V3(ab,ij)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt22,mapit22,1,rc)
c
c
c
cK    case W1(mn,ij)abab
c
cK.1.1map V1(m,n,i,j) <= <mn||ij>abab
       call map (wrk,wrksize,
     & 4,1,2,3,4,mapdw03,mapiw03,1,mapdv1,mapiv1,possv10,
     &           posst,rc)
c
c
c
cK.2.1map V2(m,n,j,e) <= <je||mn>baab
       call map (wrk,wrksize,
     & 4,3,4,1,2,mapdw14,mapiw14,1,mapdv2,mapiv2,possv20,
     &           posst,rc)
c
cK.2.2mult V3(m,n,j,i) <= V2(m,n,j,e) . T1o(e,i)aa
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv2,mapiv2,1,mapdt11,mapit11,1,mapdv3,
     &            mapiv3,ssc,possv30,rc)
c
cK.2.3map V2(m,n,i,j) <= V3(m,n,j,i)
       call map (wrk,wrksize,
     & 4,1,2,4,3,mapdv3,mapiv3,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
c
cK.2.4add V1(m,n,i,j) <- - V2(m,n,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,-1.0d0,mapdv2,1,mapdv1,mapiv1,1,rc)
c
c
cK.2.5map V2(m,n,i,e) <= <ie||mn>abab
       call map (wrk,wrksize,
     & 4,3,4,1,2,mapdw13,mapiw13,1,mapdv2,mapiv2,possv20,
     &           posst,rc)
c
cK.2.6mult V3(m,n,i,j) <= V2(m,n,i,e) . T1o(e,j)bb
       call mult (wrk,wrksize,
     & 4,2,4,1,mapdv2,mapiv2,1,mapdt12,mapit12,1,mapdv3,
     &            mapiv3,ssc,possv30,rc)
c
cK.2.7add V1(m,n,i,j) <- V3(m,n,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
c
c
cK.3.1read V2(e,f,i,j) <= T2o(e,f,i,j)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv20,mapdv2,mapiv2,rc)
c
cK.3.2make Tau V2(e,f,i,j) from V2(e,f,i,j)
       call mktau (wrk,wrksize,
     & mapdv2,mapiv2,mapdt11,mapit11,mapdt12,mapit12,1.0d0,
     &             rc)
c
cK.3.3read V3(e,f,m,n) <= <ef||mn>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv30,mapdv3,mapiv3,rc)
c
cK.3.4map V4(m,n,e,f) <= V3(e,f,m,n)
       call map (wrk,wrksize,
     & 4,3,4,1,2,mapdv3,mapiv3,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
c
cK.3.5mult V3(m,n,i,j) = V4(m,n,e,f) . V2(e,f,i,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv4,mapiv4,1,mapdv2,mapiv2,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
cK.3.6add V1(m,n,i,j) <- V3(m,n,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdv1,mapiv1,1,rc)
c
c
c
cK.4.0Tau(a,b,m,n) are in V2(ab,mn) from K.3.2
c     W1(m,n,i,j)  are in V1(m,n,i,j)
c
cK.4.1mult V3(a,b,i,j) = V2(a,b,m,n) . V1(m,n,i,j)
       call mult (wrk,wrksize,
     & 4,4,4,2,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdv3,mapiv3,
     &            ssc,possv30,rc)
c
cK.4.2add t2n(a,b,i,j)abab <- V3(a,b,i,j)
       call add (wrk,wrksize,
     & 4,4,0,0,0,0,1,1,1.0d0,mapdv3,1,mapdt23,mapit23,1,rc)
c
cpar
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

#include "compiler_features.h"
#ifdef _MOLCAS_MPP_

subroutine DF3_DEPSA_MPP(NG3,NASHT,DF3,DEPSA,lg_S,idxG3)

use Symmetry_Info, only: Mul
use SUPERINDEX, only: KTUV
use Para_Info, only: nProcs
use caspt2_module, only: IASYM, NTUVES
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: NG3, NASHT, lg_S
real(kind=wp), intent(in) :: DF3(NG3)
real(kind=wp), intent(inout) :: DEPSA(NASHT,NASHT)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: iG3, IHI, ILO, iRank, iST, iSU, ISUP1, ISUP2, iSV, iSX, iSY, isym, iSZ, iT, ituvs, iU, iV, IW, iX, ixyzs, iY, &
                     iZ, JHI, JLO, JSUP1, JSUP2, NCOL, NROW, NSEQ
real(kind=wp) :: F3VAL
real(kind=wp), allocatable :: WRK(:)

!! do depsa
isym = 1
do iRank=0,NPROCS-1
  call GA_Distribution(lg_S,iRank,ILO,IHI,JLO,JHI)
  NROW = iHi-iLo+1
  NCOL = jHi-jLo+1
  call mma_allocate(WRK,NROW*NCOL,Label='WRK')
  call GA_Get(lg_S,iLo,iHi,jLo,jHi,WRK,NROW)
  do iG3=1,NG3
    iT = idxG3(1,iG3)
    iU = idxG3(2,iG3)
    iV = idxG3(3,iG3)
    iX = idxG3(4,iG3)
    iY = idxG3(5,iG3)
    iZ = idxG3(6,iG3)
    iST = IASYM(iT)
    iSU = IASYM(iU)
    iSV = IASYM(iV)
    iSX = IASYM(iX)
    iSY = IASYM(iY)
    iSZ = IASYM(iZ)
    ituvs = Mul(IST,Mul(ISU,ISV))
    ixyzs = Mul(ISX,Mul(ISY,ISZ))
    if (ituvs /= ixyzs) cycle

    F3VAL = DF3(iG3)

    ISUP1 = KTUV(iV,iU,iT)-nTUVES(iSYM)
    if ((ISUP1 >= iLo) .and. (ISUP1 <= iHi)) then
      do iW=1,nAshT
        JSUP1 = KTUV(iX,iW,iZ)-nTUVES(iSYM)
        NSEQ = 1+ISUP1-iLo+NROW*(JSUP1-jLo)
        DEPSA(iW,iY) = DEPSA(iW,iY)-F3VAL*WRK(NSEQ)
      end do
    end if
    JSUP2 = KTUV(iX,iY,iZ)-nTUVES(iSYM)
    if ((JSUP2 >= iLo) .and. (JSUP2 <= iHi)) then
      do iW=1,nAshT
        ISUP2 = KTUV(iV,iW,iT)-nTUVES(iSYM)
        NSEQ = 1+JSUP2-iLo+NROW*(ISUP2-jLo)
        DEPSA(iW,iU) = DEPSA(iW,iU)-F3VAL*WRK(NSEQ)
      end do
    end if
  end do
  call mma_deallocate(WRK)
end do

return

end subroutine DF3_DEPSA_MPP

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(DF3_DEPSA_MPP)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Jeppe Olsen                                      *
*               1990, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE UG2SG(NROOTS,NCONF,NORB,NEL,IREFSM,IPRINT,
     *                 ICONF,ISPIN,IORD,ICI,JCJ,CCI,MXROOTS)
C
C     AUTHOR:  J. OLSEN AND M.P. FUELSCHER
C              UNIV. OF LUND, SWEDEN 1990
C
C     PURPOSE: CONSTRUCT THE REINDEXING ARRAY WHICH REORDERS
C              THE CSFS GENERATED BY THE DETERMINANT CODE INTO
C              THE SPLIT GRAPH GUGA ORDER. THEREFORE, CONSTRUCT
C              FOR EACH CSF THE CORRESPONDING
C              STEP VECTOR AND PASS IT TO THE FUNCTIONS IPHASE
C              AND ISGNUM WHICH COMPUTES THE THE PHASE FACTOR
C              INVOLVED WHEN GOING FROM THE SYMMETRIC TO THE
C              UNITARY GROUP AND THE SPLIT ORDERING NUMBER.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "rasdim.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='UG2SD   ')
#include "strnum.fh"
#include "ciinfo.fh"
#include "spinfo.fh"
#include "gugx.fh"
#include "WrkSpc.fh"
C
      DIMENSION ICONF(*),ISPIN(*)
      DIMENSION IORD(*)
      DIMENSION ICI(MXROOTS,*),JCJ(MXROOTS,*),CCI(MXROOTS,*)
C
      DIMENSION IWALK(mxAct)
      DIMENSION KCNF(mxAct)
C
C     JCJ IS A TEMPORARY COPY OF ICI AND WILL OBTAIN THE SELECTED REFERENCE
C     NUMBERS IN THE SYMMETRIC GROUP NUMBERING
C

      IF( IPRINT.GE.5 ) THEN
        Write(LF,*)
        Write(LF,*)' SPLIT GRAPH GUGA CONFIGURATION NUMBERS:'
        DO 88 K=1,NROOTS
        Write(LF,'(A,I2,A,5I8)') ' ROOT',K,' CSFs:',(ICI(K,L),L=1,5)
88      CONTINUE
      ENDIF
C
      Do kRef = 1,mxRef
        Do kRoot = 1,mxRoots
          JCJ(kRoot,kRef) = 0
        End Do
      End Do
C
C     LOOP OVER CONFIGURATIONS TYPES
C
      ICSFJP = 0
      ICNBS0 = 0 ! dummy initialize
      IPBAS  = 0 ! dummy initialize
      DO 1000 ITYP = 1, NTYP
        IOPEN = ITYP + MINOP - 1
        ICL = (NEL - IOPEN) / 2
C      BASE ADRESS FOR CONFIGURATION OF THIS TYPE
        IF( ITYP .EQ. 1 ) THEN
          ICNBS0 = 1
        ELSE
          ICNBS0 = ICNBS0 + NCNFTP(ITYP-1,IREFSM)*(NEL+IOPEN-1)/2
        END IF
C      BASE ADRESS FOR PROTOTYPE SPIN COUPLINGS
        IF( ITYP .EQ. 1 ) THEN
          IPBAS = 1
        ELSE
          IPBAS = IPBAS + NCSFTP(ITYP-1)*(IOPEN-1)
        END IF
C
C     LOOP OVER NUMBER OF CONFIGURATIONS OF TYPE ITYP AND PROTOTYPE
C     SPIN COUPLINGS
C
        DO 900  IC = 1, NCNFTP(ITYP,IREFSM)
          ICNBS = ICNBS0 + (IC-1)*(IOPEN+ICL)
          DO 800 IICSF = 1,NCSFTP(ITYP)
            ICSFJP = ICSFJP + 1
            ICSBAS = IPBAS + (IICSF-1)*IOPEN
CPAM04 The following lines have been replaced....
*C     COMPUTE STEP VECTOR
*            CALL STEPVEC(ICONF(ICNBS),ICONF(ICNBS+ICL),ICL,IOPEN,
*     &                   ISPIN(ICSBAS),NORB,IWALK)
CPAM04 ... because of new convention for representing SG config, we
* need to arrange orbital indices in form used by RASSCF codes:
*. Obtain configuration in standard RASSCF form
            IIBOP = 1
            IIBCL = 1
            JOCC  = ICL + IOPEN
            DO KOCC = 0, JOCC-1
              KORB = ICONF(ICNBS+KOCC)
              IF(KORB.LT.0) THEN
*. Doubly occupied orbitals
                KCNF(IIBCL) = ABS(KORB)
                IIBCL = IIBCL + 1
              ELSE
*. Singly occupied orbital
                KCNF(ICL+IIBOP) = KORB
                IIBOP = IIBOP + 1
              END IF
            END DO
C     COMPUTE STEP VECTOR
            CALL STEPVEC(KCNF(1),KCNF(1+ICL),ICL,IOPEN,
     &                   ISPIN(ICSBAS),NORB,IWALK)
CPAM04 End of replacement code.
C     GET SPLIT GRAPH ORDERING NUMBER
            ISG=ISGNUM(IWORK(LDOWN),IWORK(LUP),
     &                 IWORK(LDAW),IWORK(LRAW),
     &                 IWORK(LUSGN),IWORK(LLSGN),
     &                 IWALK)
C     GET PHASE PHASE FACTOR
            IP=IPHASE(IWORK(LDRT),IWORK(LUP),IWALK)
C     UPDATE REINDEXING TABLE
           IORD(ICSFJP) = ISG * IP
800       CONTINUE
900     CONTINUE
1000  CONTINUE
C
      IF( IPRINT.GE.5 ) THEN
        LPRINT=MIN(200,NCONF)
        Write(LF,*)
        Write(LF,*)' INDEX TABLE IN SUBROUTINE REORD'
        Write(LF,'(10I8)') (IORD(I),I=1,LPRINT)
        Write(LF,*)
      ENDIF
C
C     REPLACE CONFIGURATION NUMBERS
C
      DO 200 IC=1,NCONF
        ISG=IORD(IC)
        PHASE=1.0D0
        IF ( ISG.LT.0 ) PHASE=-1.0D0
        ISG=ABS(ISG)
        DO 210 K=1,NROOTS
          DO 220 L=1,MXREF
            IF (ICI(K,L).EQ.ISG) THEN
               JCJ(K,L)=IC
               CCI(K,L)=CCI(K,L)*PHASE
            END IF
220       CONTINUE
210     CONTINUE
200   CONTINUE
C
      IF( IPRINT.GE.5 ) THEN
        Write(LF,*)' SYMMETRIC GROUP CONFIGURATION NUMBERS:'
        DO 260 K=1,NROOTS
        Write(LF,'(A,I2,A,5I6)') ' ROOT',K,' CSFs:',(JCJ(K,L),L=1,5)
260     CONTINUE
        Write(LF,*)
      ENDIF
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Martin Schuetz                                   *
!               1998, Roland Lindh                                     *
!               2000-2015, Steven Vancoillie                           *
!***********************************************************************

! finalize GA
subroutine GATerminate()
! SVC: This terminates the parallel runtime after which the processes
! are no longer allowed to make ga/mpi calls. When called more than
! once, the routine does nothing. This is to support early
! termination of the parallel runtime without actually exiting.
! In such a situation, when the process eventually finishes, it
! will call this routine again, but then doing nothing. Such a use
! case is e.g. when we want to terminate slave processes and only
! continue to run the master process in serial mode.

#ifdef _MOLCAS_MPP_
use Para_Info, only: mpp_nprocs
#ifdef _GA_
use Definitions, only: MPIInt
#endif
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: FirstCall = .true.
#ifdef _GA_
integer(kind=MPIInt) :: iErr
#endif

if (FirstCall) then
  FirstCall = .false.
  if (mpp_nprocs > 1) then
    call ga_terminate()
#   ifdef _GA_
    call mpi_finalize(iErr)
#   endif
  end if
end if
#endif

end subroutine GATerminate

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine Distg2(g2,Hess,nHess,IndGrd,IfHss,IndHss,iuvwx,kOp,nop,Tr,IfGr)
!***********************************************************************
!                                                                      *
! @parameter kOp   operators for center generator                      *
!                                                                      *
! Object: trace the gradient of the ERI's with the second order        *
!         density matrix                                               *
!                                                                      *
!     Author: Anders Bernhardsson Dept. of Theoretical Chemistry,      *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Symmetry_Info, only: nIrrep, iChTbl, iChBas
use Index_Functions, only: iTri
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nHess, IndGrd(3,4,0:(nIrrep-1)), IndHss(4,3,4,3,0:(nIrrep-1)), iuvwx(4), kOp(4), nOp(4)
real(kind=wp), intent(inout) :: g2(78), Hess(nHess)
logical(kind=iwp), intent(in) :: IfHss(4,3,4,3), Tr(4), IfGr(4)
integer(kind=iwp) :: iCa1, iCa2, iCar, iCn, iCn1, iCn2, iHess, iIrrep, ij, iStop, jCar, jCn, k1, k2, kCn, kl, lCn
real(kind=wp) :: Fact, ps
real(kind=wp), parameter :: Prmt(0:7) = [One,-One,-One,One,-One,One,One,-One]

!                                                                      *
!***********************************************************************
!                                                                      *
!iRout = 239
!iPrint = nPrint(iRout)
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call recprt('Distg2: g2(raw) ',' ',g2,1,78)
call recprt('Distg2: Hess(raw) ',' ',Hess,1,nHess)
#endif

! Compute some of the contributions via the translational invariance

do iCn=1,4
  do iCar=1,3
    do jCn=1,iCn
      if (iCn == jCn) then
        iStop = iCar
      else
        iStop = 3
      end if
      do jCar=1,iStop
        if (Tr(iCn) .or. Tr(jCn)) then
          ij = iTri((iCn-1)*3+iCar,(jCn-1)*3+jCar)
          g2(ij) = Zero
          !------------------------------------------------------------*
          !
          ! Both derivatives by translation!
          !
          !------------------------------------------------------------*
          if (Tr(iCn) .and. Tr(jCn)) then
            do kCn=1,4
              do lCn=1,kCn
                if (lCn == kCn) then
                  !iMax = Max(iCar,jCar)
                  iCa2 = min(iCar,jCar)
                  iCa1 = max(iCar,jCar)
                  if (IfHss(kCn,iCa1,lCn,iCa2)) then
                    k1 = iTri((kCn-1)*3+iCa1,(lCn-1)*3+iCa2)
                    g2(ij) = g2(ij)+g2(k1)
                  end if
                else
                  if (IfHss(kCn,iCar,lCn,jCar)) then
                    k1 = iTri((kCn-1)*3+iCar,(lCn-1)*3+jCar)
                    k2 = iTri((kCn-1)*3+jCar,(lCn-1)*3+iCar)
                    g2(ij) = g2(ij)+g2(k1)+g2(k2)
                  end if
                end if
              end do
            end do
          else if (IfGr(iCn) .and. Tr(jCn)) then
            !----------------------------------------------------------*
            !
            ! Centre jCn by translation
            !
            !----------------------------------------------------------*
            do kCn=1,4
              if (kCn > iCn) then
                iCn1 = kCn
                iCn2 = iCn
                iCa1 = jCar
                iCa2 = iCar
              else if (kCn < iCn) then
                iCn1 = iCn
                iCn2 = kCn
                iCa1 = iCar
                iCa2 = jCar
              else
                iCn1 = iCn
                iCn2 = kCn
                iCa1 = max(iCar,jCar)
                iCa2 = min(iCar,jCar)
              end if
              if (IfHss(iCn1,iCa1,iCn2,iCa2)) then
                kl = iTri((iCn1-1)*3+iCa1,(iCn2-1)*3+iCa2)
                g2(ij) = g2(ij)-g2(kl)
              end if
            end do
          else if (IfGr(jCn) .and. Tr(iCn)) then
            !----------------------------------------------------------*
            !
            ! Centre iCn by translation
            !
            !----------------------------------------------------------*
            do kCn=1,4
              if (kCn > jCn) then
                iCn1 = kCn
                iCn2 = jCn
                iCa1 = iCar
                iCa2 = jCar
              else if (kCn < jCn) then
                iCn1 = jCn
                iCn2 = kCn
                iCa1 = jCar
                iCa2 = iCar
              else
                iCn1 = jCn
                iCn2 = kCn
                iCa1 = max(iCar,jCar)
                iCa2 = min(iCar,jCar)
              end if
              if (IfHss(iCn1,iCa1,iCn2,iCa2)) then
                kl = iTri((iCn1-1)*3+iCa1,(iCn2-1)*3+iCa2)
                g2(ij) = g2(ij)-g2(kl)
              end if
            end do
          end if
        end if
      end do
    end do
  end do
end do
!----------------------------------------------------------------------*

#ifdef _DEBUGPRINT_
call recprt('Distg2: g2 ',' ',g2,1,78)
#endif
! Distribute contribution to the hessian.

!----------------------------------------------------------------------*
do iIrrep=0,nIrrep-1
  do iCn=1,4
    do iCar=1,3
      do jCn=1,iCn
        if (iCn == jCn) then
          iStop = iCar
        else
          iStop = 3
        end if
        do jCar=1,istop
          if (IndHss(iCn,iCar,jCn,jCar,iIrrep) /= 0) then
            !----------------------------------------------------------*
            !
            ! Get indices
            !
            !----------------------------------------------------------*
            ij = iTri((iCn-1)*3+iCar,(jCn-1)*3+jCar)
            iHess = abs(IndHss(iCn,iCar,jCn,jCar,iIrrep))
            !----------------------------------------------------------*
            !
            ! Sign due to integral direction
            !
            !----------------------------------------------------------*
            ps = real(iChTbl(iIrrep,nOp(iCn))*iChTbl(iIrrep,nOp(jCn)),kind=wp)
            !----------------------------------------------------------*
            !
            ! If over & under triangular integrals are needed
            ! multiply by two instead!
            !
            !----------------------------------------------------------*
            if ((iCn /= jCn) .and. (iCar == jCar) .and. (abs(IndGrd(iCar,iCn,iIrrep)) == abs(IndGrd(jCar,jCn,iIrrep)))) then
              ps = ps*Two
            end if
            !----------------------------------------------------------*
            !
            ! Sign due to which symmetry group the translation is in
            !
            !----------------------------------------------------------*
            ps = ps*Prmt(iand(kOp(iCn),iChBas(1+iCar)))*Prmt(iand(kOp(jCn),iChBas(1+jCar)))
            !----------------------------------------------------------*
            !
            ! Multiply by number of stabilisers.
            !
            !----------------------------------------------------------*
            Fact = ps*real(iuvwx(iCn),kind=wp)/real(nIrrep*nirrep,kind=wp)*real(iuvwx(jCn),kind=wp)
            !----------------------------------------------------------*
            !
            ! Add to hessian
            !
            !----------------------------------------------------------*
            Hess(iHess) = Hess(iHess)+Fact*g2(ij)
          end if
        end do
      end do
    end do
  end do
end do
#ifdef _DEBUGPRINT_
call recprt('Distg2: Hess ',' ',Hess,1,nHess)
#endif

return

end subroutine Distg2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Tully(CIBigArray, NSTATE, NCI)
      use Tully_variables
      implicit none
#include "surfacehop.fh"
      INTEGER      values(8)
      character*8  date
      character*10 time
      character*5  zone
      real*8       Random_Molcas
      EXTERNAL     Random_Molcas
      logical    HOPPED, normalTully, found, lmaxHop, lnhop
      integer    NSTATE, NCI, maxhop, nhop
      real*8     DT, LO, EKIN, TAU(NSTATE)
      real*8     CIBigArray(NCI*NSTATE), CIBigArrayP(NCI*NSTATE)
      real*8     CIBigArrayPP(NCI*NSTATE), Etot, ediffcheck
      real*8     Dmatrix(NSTATE,NSTATE), sp(NSTATE,NSTATE)
      real*8     D32matrix(NSTATE,NSTATE), D12matrix(NSTATE,NSTATE)
      real*8     ExtrSlope(NSTATE,NSTATE), ExtrInter(NSTATE,NSTATE)
      real*8     VenergySlope(NSTATE), tempVector(NSTATE)
      real*8     tempVector2(NSTATE), VenergyInter(NSTATE)
      real*8     V(NSTATE,NSTATE), Bmatrix(NSTATE,NSTATE)
      real*8     Gprobab(NSTATE), Popul(NSTATE)
      real*8     VenergyP(NSTATE), Venergy(NSTATE), temp
      real*8     SumProb, scalarprod, prod,populOS
      integer    k,l,j,i,ii,jjj
      integer    rightOrder(NSTATE), decVec(NSTATE)
      integer    nstatesq, nciquery, stateRi, temproot, nsatom
      integer    ISTATE2, iseed, irlxroot
      complex*16 Amatrix(NSTATE,NSTATE), AmatrixDT(NSTATE,NSTATE)
      complex*16 ArelaxPrev


      CIBigArrayP(:)=0.0D0
      CIBigArrayPP(:)=0.0D0
      V(:,:) = 0.0D0
      TAU(:)=0.0D0
      write(6,*) ''
      write(6,*) '------------------------------------------'
      write(6,*) '            TULLY ALGORITHM'
      write(6,*) '------------------------------------------'
      write(6,*) ''

      call get_darray('Last energies',Venergy,NSTATE)
      call Get_iScalar('Relax CASSCF root',iRlxRoot)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C             Watch if dt exists.  then if Amatrix exist               C
C        if exist, it gets it, if not, it creates a new one            C
C                                                                      C

      call qpg_dscalar('Timestep',Found)

#ifdef _HDF5_
      if (.not.found .and. lH5Restart) then
         call restart_surfacehop
         found = .true.
      endif
#endif

      if (Found) then
         call Get_dScalar('Timestep',DT)
      end if

      call Qpg_zArray('AmatrixV', Found, nStateSq)
      write(6,*) 'Did the density matrix exists? ', Found
      IF (.NOT.Found) THEN
        do i=1, NSTATE
           do j=1, NSTATE
              Amatrix(i,j)=(0.0, 0.0)
           end do
        end do
        Amatrix(iRlxRoot,iRlxRoot)=(1.0, 0.0)

        call Put_zArray('AmatrixV',Amatrix,NSTATE*NSTATE)
      ELSE
        call get_zarray('AmatrixV',Amatrix,NSTATE*NSTATE)
      END IF

      call Qpg_dArray('AllCIP',Found,nCiQuery)
      write(6,*) 'Did the Pre-coefficients array exists? ', Found
      if (.NOT.Found) then
         call put_darray('AllCIP', CIBigArray, NCI*NSTATE)
         call put_dArray('VenergyP', Venergy, NSTATE)
         do i=1,NSTATE
            Popul(i)=Real(Amatrix(i,i))
         end do
         write(6,*) 'Gnuplot:', (Popul(j), j=1,NSTATE,1),
     &      (Venergy(j), j=1,NSTATE,1 ), Venergy(iRlxRoot)
         write(6,*) 'Cannot do deltas at first step, see you later! '
         RETURN
      else
         call Get_dArray('AllCIP', CIBigArrayP,NCI*NSTATE)
         call Get_dArray('VenergyP', VenergyP, NSTATE)
      end if

C now check for the CI coefficients at Pre-Pre-Step (PP)

      call Qpg_dArray('AllCIPP',Found,nCiQuery)
      write(6,*) 'Did the Pre-Pre-coefficients array exists? ', Found
      if (.NOT.Found) then
         normalTully=.true.
         call put_darray('AllCIPP', CIBigArrayP, NCI*NSTATE)
         call put_darray('AllCIP', CIBigArray, NCI*NSTATE)
         write(6,*) 'At second step we will use normal Tully Algorithm:'
      else
         normalTully=.false.
         call Get_dArray('AllCIPP', CIBigArrayPP,NCI*NSTATE)
      end if


      call Get_dScalar('MD_Etot',Etot)
      call Get_iScalar('Unique atoms',nsAtom)

      write(6,*) 'Density Matrix elements (i=1..#states):'
      do i=1, NSTATE
         write(6,*)( Amatrix(i,j), j=1,NSTATE,1 )
      end do


C Timestep:                  DT
C Total Energy               Etot
C Coefficients:              CIBigArray(i)      length = NCI*NSTATE
C Prev step coefficients:    CIBigArrayP(i)     length = NCI*NSTATE
C Prev-Prev coefficients:    CIBigArrayPP(i)    length = NCI*NSTATE
C V energy:                  Venergy(i)         length = NSTATE
C V Prev step energy:        VenergyP(i)        length = NSTATE
C MatriX A:                  Amatrix(i,j)       length = NSTATE*NSTATE

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                        C
C                         Sign Corrector                                 C
C                                                                        C

C so first of all I create 2 temp vectors that store the absolute value
C of the energy difference

      do i=1, NSTATE
            tempVector(i) = ABS(Venergy(i)-Venergy(irlxRoot))
            tempVector2(i) = ABS(Venergy(i)-Venergy(irlxRoot))
      end do

C then I sort one of them, (relaxroot becomes first, it's zero)

      do j = 1,(NSTATE-1)
        do k = (j+1), NSTATE
           if (tempVector(j) .gt. tempVector(k)) then
              temp=tempVector(j)
              tempVector(j)=tempVector(k)
              tempVector(k)=temp
           end if
        end do
      end do

C I get the right order I need to process roots

      do i=1,NSTATE
         do j=1,NSTATE
            if (tempVector(i) .eq. tempVector2(j)) then
             rightOrder(i)= j
            end if
         end do
      end do
C ii counter on CURRENT STEP
      do ii=1,NSTATE
       do i=1,NSTATE
        scalarprod = 0.0
         do j=1,NCI
        scalarprod=scalarprod+
     &      CIBigArray(NCI*(ii-1)+j)*CIBigArrayP(NCI*(i-1)+j)
         end do
        sp(ii,i)=scalarprod
       end do
        decVec(ii)=1
      end do

      do ii=1,NSTATE
         stateRi=rightOrder(ii)
         prod=0.0
         jjj=0
         do i=1,NSTATE
            if (decVec(i) .eq. 1) then
               if (ABS(sp(stateRi,i)) .gt. ABS(prod)) then
                  prod = sp(stateRi,i)
                  jjj = i
               end if
            end if
         end do
         decVec(jjj)=0
         if (prod .lt. 0) then
             do k=1,NCI
          CIBigArray(NCI*(stateRi-1)+k)=-CIBigArray(NCI*(stateRi-1)+k)
             end do
         end if
      end do
C                                                                       C
C                         end of sign corrector                         C
C                                                                       C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C create D matrix normal tully

      IF (normalTully) THEN

      write (6,*) ''
      write (6,*) 'Executing Normal Tully !!'
      write (6,*) ''

      do i=1, NSTATE
         do j=1, NSTATE
            if (i.ne.j) then
              Dmatrix(i,j) = 0.0
              do ii=1, NCI
                 Dmatrix(i,j) = Dmatrix(i,j) +
     &    CIBigArray(NCI*(i-1)+ii)*CIBigArrayP(NCI*(j-1)+ii)
              end do
              Dmatrix(i,j) = -Dmatrix(i,j)/DT
            else
              Dmatrix(i,i)=0.0
            end if
         end do
      end do
      normalTully=.false.

      do i=1, NSTATE
         do j=1, NSTATE
           ExtrInter(i,j)= Dmatrix(i,j)
           ExtrSlope(i,j)= 0.0
         end do
           VenergyInter(i)=VenergyP(i)
           VenergySlope(i)=(Venergy(i)-VenergyP(i))/DT
      end do

      ELSE

C Create D matrix according to Hammes-Schiffer-Tully (interpolating extrapolating)

C      D32matrix

      do i=1, NSTATE
         do j=1, NSTATE
            if (i.ne.j) then
            D32matrix(i,j) = 0.0
            do ii=1, NCI
                D32matrix(i,j) = D32matrix(i,j) +
     &            CIBigArrayPP(NCI*(i-1)+ii)*CIBigArrayP(NCI*(j-1)+ii)
                D32matrix(i,j) = D32matrix(i,j) -
     &            CIBigArrayP(NCI*(i-1)+ii)*CIBigArrayPP(NCI*(j-1)+ii)
            end do
            D32matrix(i,j) = D32matrix(i,j)/(2*DT)
            else
            D32matrix(i,i)=0.0
            end if
         end do
      end do

C      D12matrix

      do i=1, NSTATE
         do j=1, NSTATE
            if (i.ne.j) then
            D12matrix(i,j) = 0.0
            do ii=1, NCI
                D12matrix(i,j) = D12matrix(i,j) +
     &              CIBigArrayP(NCI*(i-1)+ii)*CIBigArray(NCI*(j-1)+ii)
                D12matrix(i,j) = D12matrix(i,j) -
     &              CIBigArray(NCI*(i-1)+ii)*CIBigArrayP(NCI*(j-1)+ii)
            end do
            D12matrix(i,j) = D12matrix(i,j)/(2*DT)
            else
            D12matrix(i,i)=0.0
            end if
         end do
      end do

C definition of Y intercept (ExtrInter) and slope (ExtrSlope) for EXTRapolation line

      do i=1, NSTATE
         do j=1, NSTATE
           ExtrSlope(i,j) = (1/DT) * (D12matrix(i,j) - D32matrix(i,j))
           ExtrInter(i,j) = D12matrix(i,j)
         end do
           VenergyInter(i)=VenergyP(i)
           VenergySlope(i)=(Venergy(i)-VenergyP(i))/DT
      end do

      END IF

C   UNCOMMENT to print coefficients !!!
C     just few coefficients
      write(6,*) 'WaveFunctionsCoefficients are: ',NCI,'*',NSTATE
      write(6,*) '       This step        Previous step:        PP:'

      write(6,*) CIBigArray(1), CIBigArrayP(1), CIBigArrayPP(1)
      write(6,*) CIBigArray(2), CIBigArrayP(2), CIBigArrayPP(2)
      write(6,*) CIBigArray(3), CIBigArrayP(3), CIBigArrayPP(3)
      write(6,*) CIBigArray(4), CIBigArrayP(4), CIBigArrayPP(4)

C    All coefficients
C      do i=1,NCI*NSTATE
C      write(6,*) CIBigArray(i), CIBigArrayP(i), CIBigArrayPP(i)
C      END DO
C   UNCOMMENT to print coefficients !!!

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                        GET RANDOM number LO                          C
C                                                                      C


C     Check if Random number is fixed by user
      if (fixedrandL) then
        write(6,*) 'From input Random is Fixed at:', FixedRand
        LO=FixedRand/dble(NSUBSTEPS)
        write(6,*) 'Normalized by Substep number:', LO
      else
C       check if seed number is read from input / RunFile
        if (iseedL) then
          call qpg_iscalar('Seed',Found)
          if (Found) then
            call get_iscalar('Seed',iseed)
            write(6,*) 'Seed number read from the RunFile: ', iseed
          else
            iseed = InitSeed ! initial seed read from input
            write(6,*) 'Seed number read from input file: ', iseed
          end if
C       or generate a new random seed number
        else
          call date_and_time( date, time, zone, values )
C         Just milliseconds multiplied by seconds
          iseed = ((values(7)+1)*values(8)+1)
        endif
        LO = Random_Molcas(iseed)
        call put_iscalar('Seed',iseed)
        if (LO.lt.RandThreshold) then
            LO=RandThreshold
        end if
      end if

C                                                                      C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                             INTEGRATOR                               C
C                   NSUBSTEPS is the substep number                    C
C                                                                      C

      write(6,*) 'executing the integration:'
      write(6,*) 'Time Step is:    ', DT
      write(6,*) 'Substeps are: ',NSUBSTEPS

      temproot=iRlxRoot

      DO ii=1,NSUBSTEPS
      if (fixedrandL) then
         continue
      else
        LO = Random_Molcas(iseed)
        call put_iscalar('Seed',iseed)
        if (LO.lt.RandThreshold) then
           LO=RandThreshold
        end if
      end if

      do i=1,NSTATE
        do j=1,NSTATE
          Dmatrix(i,j) = ExtrInter(i,j) + ExtrSlope(i,j) *
     &                   (((ii-1)*DT/NSUBSTEPS) - DT/2)
          if(i.ne.j) then
             V(i,j) = 0.0
          else
             V(i,j) = VenergyInter(i) +
     &                VenergySlope(i)*(ii-1)*DT/NSUBSTEPS
          end if
        end do
      end do

      do i=1,NSTATE
       do j=1, NSTATE
         AmatrixDT(i,j) = (0.0, 0.0)
         do l=1,NSTATE
               AmatrixDT(i,j)=AmatrixDT(i,j) + Amatrix(i,l)*Dmatrix(l,j)
     &                                       - Amatrix(l,j)*Dmatrix(i,l)
               AmatrixDT(i,j) = AmatrixDT(i,j) +
     &               (0.0,1.0)*Amatrix(i,l)*V(l,j)-
     &               (0.0,1.0)*Amatrix(l,j)*V(i,l)
         end do

       end do
      end do

      do i=1,NSTATE
         do j=1, NSTATE
            Amatrix(i,j) = Amatrix(i,j) + AmatrixDT(i,j)*DT/NSUBSTEPS
         end do
      end do

      do i=1,NSTATE
        do j=1,NSTATE
         if(i.eq.j) then
!         B(i,i) not used
          Bmatrix(i,j)=2*aimag(CONJG(Amatrix(i,j))*V(i,j))
         else
          Bmatrix(i,j)=-2*real(CONJG(Amatrix(i,j))*Dmatrix(i,j))
         endif
        end do
      end do

      do i=1,NSTATE
        if (i.ne.temproot) then
          Gprobab(i) = Bmatrix(i,temproot)*DT/
     &    (real(Amatrix(temproot,temproot))*NSUBSTEPS)
          if (Gprobab(i).lt.0.0) then
             Gprobab(i)=0.0
          end if
         else
          Gprobab(i) = 0.0
        end if
      end do

      SumProb=0.0
      do i=1,NSTATE
       if (i.ne.temproot) then
            SumProb=SumProb + Gprobab(i)
        if (LO.le.SumProb) then
           write(6,*)'Following Tully, should hop from',temproot,'to',i
           if (V(i,i).lt.Etot) then
               write(6,*)'this root has an energy lower than the total',
     &               Etot,' (thus, permitted)'
               Ediffcheck=(V(i,i)-V(temproot,temproot))
               write(6,*)'Ediffcheck is:',Ediffcheck
               Ediffcheck=ABS(Ediffcheck)
               if (Ediffcheck.lt.Ethreshold) then
                  write(6,*)'lower than the threshold:',Ethreshold
                  write(6,*)'temproot set to:', i
                  temproot=i
                  GOTO 9000
               end if
               GOTO 9000
           end if
        GOTO 9000
        end if
       end if
      end do
 9000 continue

C Persico-Granucci all in a THEN branch

      IF (decoherence) THEN
      EKIN=Etot-V(temproot,temproot)
      If (EKIN.le.0.0D0) then
         write(6,*) 'WARNING! Negative Kinetic Energy. Ekin= ',
     &               EKIN,' a.u.'
         write(6,*) 'Kinetic energy rescaled to 10 e-5.'
         EKIN=0.00001D0
      End If
      do i=1,NSTATE
       if(i.ne.temproot) then
        TAU(i)=abs(1.0D0/(V(temproot,temproot)-V(i,i)))*
     &   (1.0D0+DECO/EKIN)
       end if
      end do

      do i=1,NSTATE
       do j=1,NSTATE
        if(i.ne.temproot.and.j.ne.temproot) then
         Amatrix(i,j)=Amatrix(i,j)*exp(-(DT/NSUBSTEPS)/TAU(i))*
     &                 exp(-(DT/NSUBSTEPS)/TAU(j))
        end if
       end do
      end do

      populOS=0.0D0
      do i=1,NSTATE
       if(i.ne.temproot) then
        populOS=populOS+real(Amatrix(i,i))
       end if
      end do

      ArelaxPrev=Amatrix(temproot,temproot)
      Amatrix(temproot,temproot)=1.-populOS

      do i=1,NSTATE
       do j=1,NSTATE
        if(i.ne.temproot.and.j.eq.temproot) then
         Amatrix(i,j)=Amatrix(i,j)*exp(-(DT/NSUBSTEPS)/TAU(i))*
     &     sqrt(Amatrix(temproot,temproot)/ArelaxPrev)
        elseif(i.eq.temproot.and.j.ne.temproot) then
         Amatrix(i,j)=Amatrix(i,j)*exp(-(DT/NSUBSTEPS)/TAU(j))*
     &     sqrt(Amatrix(temproot,temproot)/ArelaxPrev)
        endif
       end do
      end do
      END IF

      do i=1,NSTATE
          Popul(i)=real(Amatrix(i,i))
      end do

      if (tullySubVerb) then
        write(6,*) 'Substep:', ii
        write(6,*) 'Temproot:', temproot
        write(6,*) 'MATRIX D:'
        do i=1, NSTATE
          write (6,*) (Dmatrix(i,j), j=1,NSTATE,1 )
        end do
        write(6,*) 'Density Matrix elements (i=1..#states):'
        do i=1, NSTATE
         write(6,*)( Amatrix(i,j), j=1,NSTATE,1 )
        end do
        write(6,*) 'B Matrix:'
        do i=1, NSTATE
         write(6,*)( Bmatrix(i,j), j=1,NSTATE,1 )
        end do
        write(6,*) 'Probabilities:'
        write(6,*)( Gprobab(j), j=1,NSTATE,1 )
        write(6,*) 'Random Number is: ', LO
        write(6,*) 'Populations Energies:', ( Popul(j), j=1,NSTATE,1 ),
     &           (V(j,j), j=1,NSTATE,1 ), V(temproot,temproot)
        write(6,*) ''
      end if


      END DO

C                                                                      C
C                        END OF INTEGRATOR                             C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      write(6,*) 'Gnuplot:', (Popul(j), j=1,NSTATE,1),
     &      (Venergy(j), j=1,NSTATE,1 ), Venergy(temproot)
C      write(6,*) 'Gnuplot:', ( Popul(j), j=1,NSTATE,1 ),
C     &           (V(j,j), j=1,NSTATE,1 ), V(temproot,temproot)

      if (temproot.eq.iRlxRoot) then
        HOPPED=.false.
      else
C       Is the keyword MAXHOP set?
        CALL Qpg_iScalar('MaxHopsTully',lmaxHop)
        IF (lmaxHop) THEN
           CALL get_iScalar('MaxHopsTully',maxHop)
           CALL qpg_iScalar('Number of Hops',lnHop)
           if (.not.lnHop) then
              nHop=0
           else
              call get_iScalar('Number of Hops',nHop)
           end if
           write (6,*) 'User set a max of', maxHop
           write (6,*) 'nhop is:', nHop
           if (maxHop.le.nHop) then
              write (6,*) 'This surface HOP is not allowed'
              HOPPED=.false.
           else
              nHop = nHop + 1
              call put_iScalar('Number of Hops',nHop)
              HOPPED=.true.
           end if
        ELSE
C In case temproot is different then iRlxRoot, and no lmaxHop has been
C set
           HOPPED=.true.
        END IF
      end if

C give the "HOP TO:" state name ISTATE2 !!!!
C start the HOPPING procedure
      if (HOPPED) then
      ISTATE2=temproot
      write(6,*)'HOP ALLOWED'
      write(6,'(6X,120A1)')'+',('-',i=1,118),'+'
      write(6,'(6X,A,118X,A)')'|','|'
      write(6,'(6X,A,2(47X,A))')'|','A HOP event is detected!',
     &           '|'
      write(6,'(6X,A,118X,A)')'|','|'
      write(6,'(6X,A,44X,2(A,I3,4X),40X,A)')'|','From state:',
     &           iRlxRoot,'To state:',ISTATE2,'|'
      write(6,'(6X,A,118X,A)')'|','|'
      write(6,'(6X,120A1,//)')'+',('-',i=1,118),'+'

      call Put_iScalar('NumGradRoot',ISTATE2)
      call Put_iScalar('Relax CASSCF root',ISTATE2)
      call Put_iScalar('Relax Original root',ISTATE2)
      call Put_dScalar('Last energy',Venergy(ISTATE2))
      end if
C scale velocities
C
C        CALL get_dArray('Velocities',vel,nsAtom*3)
C
C        write(6,*) 'Velocities before Hop:'
C        do i=1, nsAtom
C          write(6,*) vel(i*3-2), vel(i*3-1), vel(i*3)
C        end do
C        EKIN=Etot-Venergy(iRlxRoot)
C        EKIN_target=Etot-Venergy(temproot)
C        scalfac = sqrt(Ekin_target / Ekin)
C        write(6,*) Etot, Venergy(iRlxRoot), Venergy(temproot), EKIN,
C     &             EKIN_target, scalfac
C        do i=1, nsAtom
C           do j=1,3
C              vel(3*(i-1)+j)=scalfac*vel(3*(i-1)+j)
C           end do
C        end do
C        write(6,*) 'Velocities after Hop:'
C        do i=1, nsAtom
C          write(6,*) vel(i*3-2), vel(i*3-1), vel(i*3)
C        end do
C
C        CALL put_dArray('Velocities',vel,nsAtom*3)
C

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                             SAVING                                   C
C                                                                      C

      call put_lscalar('hopped',HOPPED)
      call Put_dArray('VenergyP', Venergy, NSTATE)
      call Put_dArray('AllCIPP', CIBigArrayP, NCI*NSTATE)
      call Put_dArray('AllCIP', CIBigArray, NCI*NSTATE)
      call put_zarray('AmatrixV',Amatrix,NSTATE*NSTATE)

C                                                                      C
C                           END SAVING                                 C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      RETURN

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#ifdef _HDF5_
      SUBROUTINE read_hdf5_init(file_h5,nstate,nss)
      Use mh5, Only: mh5_open_file_r, mh5_fetch_attr, mh5_close_file
      Implicit None
#include "stdalloc.fh"
      Character(Len=180),intent(in) ::    file_h5
      Integer, intent(out)      ::    nstate,nss
      ! local variables:
      Integer                   ::    i,fileid
      Character                 ::    tmp*256, sFile*128
      Character(Len=180)        ::    tmp2
      Integer, allocatable      ::    spin_mult(:)
      Character(Len=5)          ::    molcas_module_kind
      Logical                   ::    Exist
      Logical                   ::    DBG

      DBG=.false.

      WRITE (6,'(A,A)') 'Read data from rassi.h5 file ',trim(file_h5)
      NSS=0
      NSTATE=0
      Exist=.false.
      ! Check if it is a rassi-h5 file:

      ! Check the file exists in $WorkDir
      Call f_inquire(trim(file_h5),Exist)
      IF (Exist) WRITE (6,*) 'file ',trim(file_h5),' exists!!!'
      ! if not present, look for it in the submit directory:
      IF (.not.Exist) THEN
        Call getenvf('MOLCAS_SUBMIT_DIR',tmp)
        IF (tmp.ne.' ') THEN
          i=index(tmp,' ')
          IF (i.gt.0) THEN
            sFile=trim(tmp(1:i-1)//'/'//file_h5)
            Call f_inquire(sFile,Exist)
          END IF
        END IF
        ! if still not present, warn the user and abort:
        IF (.not.Exist) THEN
          Call WarningMessage(2,'File '//
     &                        trim(file_h5)//' is not found')
          Call Quit_OnUserError()
        END IF
      END IF
!----------------------------------------------------------------------|
      ! open the file
      fileid = mh5_open_file_r(trim(file_h5))
      ! check if it is an HDF5 file produced by RASSI
      Call mh5_fetch_attr(fileid,'MOLCAS_MODULE',tmp2)
      molcas_module_kind=trim(tmp2)
      IF (DBG) WRITE (6,'(A,A)') 'read_hdf5::  molcas_module=',
     &                           molcas_module_kind
      IF ( molcas_module_kind(1:5).ne.'RASSI') THEN
          Call WarningMessage(2,'Input HDF5 file '//trim(file_h5)//
     &                        ' is not produced by RASSI')
          Call Quit_OnUserError()
      END IF

!----------------------------------------------------------------------|
      ! read number of spin free states
      Call mh5_fetch_attr(fileid,'NSTATE',nstate)
      IF (DBG) WRITE (6,'(A,I6)') 'read_hdf5::  NSTATE=', NSTATE
      Call Put_iScalar('NSTATE_SINGLE   ',NSTATE)


      ! read spin multiplicity of each state:
      Call mma_allocate(spin_mult,nstate,'nstate')
      Call mh5_fetch_attr(fileid,'STATE_SPINMULT',spin_mult(1:nstate))
      IF (DBG) WRITE (6,'(A)') 'spin_mult'
      IF (DBG) WRITE (6,'(20I4)') (spin_mult(i),i=1,nstate)
      ! compute the number of spin-orbit states:
      nss=0
      DO i=1,nstate
        nss=nss+spin_mult(i)
      END DO
      IF (DBG) WRITE (6,'(A,I6)') 'read_hdf5::     NSS=',NSS
      Call Put_iScalar('NSS_SINGLE      ',NSS)
      Call mma_deallocate(spin_mult)

!----------------------------------------------------------------------|
      ! close the file
      Call mh5_close_file(fileid)

      RETURN
      END SUBROUTINE read_hdf5_init






      SUBROUTINE read_hdf5_all(file_h5, nss, nstate,
     &                         multiplicity, eso, esfs,
     &                         U, MM, MS, ML, DM, ANGMOM, EDMOM,
     &                         amfi, HSO )
      Use mh5, Only: mh5_open_file_r, mh5_fetch_attr, mh5_exists_dset,
     &               mh5_fetch_dset, mh5_close_file
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      Integer, intent(in)           :: nstate,nss
      Integer, intent(out)          :: multiplicity(nstate)

      Real(kind=8), intent(out)    :: esfs(nstate)
      Real(kind=8), intent(out)    :: eso(nss)
      Real(kind=8), intent(out)    ::  edmom(3,nstate,nstate)
      Real(kind=8), intent(out)    ::   amfi(3,nstate,nstate)
      Real(kind=8), intent(out)    :: angmom(3,nstate,nstate)
      Complex(kind=8), intent(out) :: MM(3,nss,nss)
      Complex(kind=8), intent(out) :: MS(3,nss,nss)
      Complex(kind=8), intent(out) :: ML(3,nss,nss)
!     electric dipole moment
      Complex(kind=8), intent(out) :: DM(3,nss,nss)
      Complex(kind=8), intent(out) :: U(nss,nss)
      Complex(kind=8), intent(out) :: HSO(nss,nss)

      Real(kind=8)                 :: AU2CM
      Real(kind=8), allocatable    :: etmp(:)
      Real(kind=8), allocatable    :: RR(:,:), RI(:,:)
      Real(kind=8), allocatable    :: AL(:,:,:)
      Integer                       :: fileid,jend,INRM
      Character(Len=180)            :: file_h5
      Real(kind=8)                 :: RNRM
      Real(kind=8), external       :: dnrm2_, dznrm2_
      Complex(kind=8), external    :: spin
      ! local variables:
      Integer       :: iss, ibas(nstate,-50:50)
      Integer       :: i, j, i1, j1, ist, jst, mult, multI, multJ
      Integer       :: l, ipar
      Real(kind=8) :: g_e
      Complex(kind=8), allocatable    :: tmp(:,:)

!      Logical :: Exist
      Logical :: found_edmom !, found_angmom, found_hso, found_amfi,
!     &           found_sos_coeff, found_eso, found_esfs, found_mult
      Logical :: DBG

      DBG  =.false.
      AU2CM=219474.6313702_wp
      g_e=2.00231930437180_wp
      found_edmom=.false.
!      found_angmom=.false.
!      found_hso=.false.
!      found_amfi=.false.
!      found_sos_coeff=.false.
!      found_eso=.false.
!      found_esfs=.false.
!      found_mult=.false.

      WRITE (6,'(A,A)') 'Read data from rassi.h5 file ',trim(file_h5)

      ! the presence of the RASSI-HDF5 has already been made in
      ! read_hdf5_init subroutine, executed earlier
      ! nss, nstate are already known
!----------------------------------------------------------------------|
      ! open the file
      fileid = mh5_open_file_r(trim(file_h5))
      IF (DBG) WRITE (6,'(A,I24)') 'read_hdf5_all:: fileid=',fileid
!----------------------------------------------------------------------|
      ! read spin multiplicity of each state:
c      IF (mh5_exists_dset(fileid,'STATE_SPINMULT')) THEN
!         found_mult=.true.
         Call mh5_fetch_attr(fileid,'STATE_SPINMULT',
     &                       multiplicity(1:nstate))
         IF (DBG) WRITE (6,'(A)') 'read_hdf5_all:: multiplicity'
         IF (DBG) WRITE (6,'(20I4)') (multiplicity(i),i=1,nstate)
         INRM=0
         INRM=SUM(multiplicity(:))
         IF ( INRM == 0 ) THEN
            Call WarningMessage(2,'STATE_SPINMULT array read from '//
     &                          'HDF5 file has norm = zero')
            WRITE (6,*) 'Norm=',INRM
         END IF
c      ELSE
c         Call WarningMessage(2,'State multiplicity array was not '//
c     &                         'found on HDF5 file')
c      END IF

!----------------------------------------------------------------------|
      ! read the spin free energies (cm-1)
      Call mma_allocate(etmp,nstate,'etmp)')
      Call dcopy_(nstate,[0.0_wp],0,etmp,1)
      IF (mh5_exists_dset(fileid,'SFS_ENERGIES')) THEN
!         found_esfs=.true.
         Call mh5_fetch_dset(fileid,'SFS_ENERGIES',etmp)
         RNRM=0.0_wp
         RNRM=dnrm2_(nstate,etmp,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'ESFS read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         ! compute the energeis in cm-1:
         DO i=1,nstate
            esfs(i)=(etmp(i)-etmp(1))*AU2CM
         END DO
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: esfs'
            DO i=1,nstate,4
               jEND=MIN(nstate,i+3)
               WRITE (6,'(4ES24.14)') (esfs(j),j=i,jEnd)
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'Spin-free energies were not '//
     &                         'found on HDF5 file')
      END IF
      Call mma_deallocate(etmp)


!----------------------------------------------------------------------|
      ! read the spin-orbit energies (cm-1)
      Call mma_allocate(etmp,nss,'tmp)')
      Call dcopy_(nss,[0.0_wp],0,etmp,1)
      IF (mh5_exists_dset(fileid,'SOS_ENERGIES')) THEN
!         found_eso=.true.
         Call mh5_fetch_dset(fileid,'SOS_ENERGIES',etmp)
         RNRM=0.0_wp
         RNRM=dnrm2_(nss,etmp,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'ESO read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         ! compute the energeis in cm-1:
         DO i=1,nss
            eso(i)=(etmp(i)-etmp(1))*AU2CM
         END DO
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: eso'
            DO i=1,nss,4
               jEnd=MIN(nss,i+3)
               WRITE (6,'(4ES24.14)') (eso(j),j=i,jEnd)
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'Spin-orbit energies were not '//
     &                         'found on HDF5 file')
      END IF
      Call mma_deallocate(etmp)


!----------------------------------------------------------------------|
      ! read the spin-orbit mixing coefficient matrix:
      Call mma_allocate(RR,nss,nss,'RR')
      Call mma_allocate(RI,nss,nss,'RI')
      Call dcopy_(nss*nss,[0.0_wp],0,RR,1)
      Call dcopy_(nss*nss,[0.0_wp],0,RI,1)

      IF ( mh5_exists_dset(fileid,'SOS_COEFFICIENTS_REAL').and.
     &     mh5_exists_dset(fileid,'SOS_COEFFICIENTS_IMAG') ) THEN
!         found_sos_coeff=.true.
         Call mh5_fetch_dset(fileid,'SOS_COEFFICIENTS_REAL', RR )
         Call mh5_fetch_dset(fileid,'SOS_COEFFICIENTS_IMAG', RI )
         ! assemble the complex matrix U:
         DO i=1,nss
            DO j=1,nss
               U(i,j)=cmplx( RR(i,j), RI(i,j), wp )
            END DO
         END DO
         RNRM=0.0_wp
         RNRM=dznrm2_(nss*nss,U,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'SOS-U matrix read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: U'
            DO i=1,nss
               DO j=1,nss
                  WRITE (6,'(2i4,A,2ES24.14)') i,j,' |',U(i,j)
               END DO
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'SO mixing coefficeints were not '//
     &                         'found on HDF5 file')
      END IF
      Call mma_deallocate(RR)
      Call mma_deallocate(RI)


!----------------------------------------------------------------------|
      ! read the angular momentum integrals (L):
      Call mma_allocate(AL,nstate,nstate,3,'AL')
      Call dcopy_(nstate*nstate*3,[0.0_wp],0,AL,1)
      IF (mh5_exists_dset(fileid,'SFS_ANGMOM')) THEN
!         found_angmom=.true.
         Call mh5_fetch_dset(fileid,'SFS_ANGMOM',AL)
         DO i=1,nstate
            DO j=1,nstate
               DO l=1,3
                  ANGMOM(l,i,j)=AL(i,j,l)
               END DO
            END DO
         END DO
         RNRM=0.0_wp
         RNRM=dnrm2_(nstate*nstate*3,AL,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'SFS_ANGMOM read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: ANGMOM (x,y,z)'
            DO i=1,nstate
               DO j=1,nstate
                  WRITE (6,'(2i4,A,3ES24.14)') i,j,' |',
     &                                       (ANGMOM(l,i,j),l=1,3)
               END DO
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'ANGMOM integrals were not found on '//
     &                         'HDF5 file')
      END IF
      Call mma_deallocate(AL)


!----------------------------------------------------------------------|
      ! read the electric dipole momentum integrals (EDMOM):
      Call mma_allocate(AL,nstate,nstate,3,'AL')
      Call dcopy_(nstate*nstate*3,[0.0_wp],0,AL,1)
      IF (mh5_exists_dset(fileid,'SFS_EDIPMOM')) THEN
         found_edmom=.true.
         Call mh5_fetch_dset(fileid,'SFS_EDIPMOM',AL)
         DO i=1,nstate
            DO j=1,nstate
               DO l=1,3
                  EDMOM(l,i,j)=AL(i,j,l)
               END DO
            END DO
         END DO
         RNRM=0.0_wp
         RNRM=dnrm2_(nstate*nstate*3,AL,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'SFS_EDIPMOM read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: SFS_EDIPMOM(x,y,z)'
            DO i=1,nstate
               DO j=1,nstate
                  WRITE (6,'(2i4,A,3ES24.14)') i,j,' |',
     &                                       (EDMOM(l,i,j),l=1,3)
               END DO
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'EDMOM integrals were not found on '//
     &                         'HDF5 file')
      END IF
      Call mma_deallocate(AL)


!----------------------------------------------------------------------|
      ! read the spin-orbit integrals (AMFI):
      Call mma_allocate(AL,nstate,nstate,3,'AL')
      Call dcopy_(nstate*nstate*3,[0.0_wp],0,AL,1)
      IF (mh5_exists_dset(fileid,'SFS_AMFIINT')) THEN
!         found_amfi=.true.
         Call mh5_fetch_dset(fileid,'SFS_AMFIINT',AL)
         DO i=1,nstate
            DO j=1,nstate
               DO l=1,3
                  AMFI(l,i,j)=AL(i,j,l)
               END DO
            END DO
         END DO
         RNRM=0.0_wp
         RNRM=dnrm2_(nstate*nstate*3,AL,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'SFS_AMFIINT read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: SFS_AMFIINT(x,y,z)'
            DO i=1,nstate
               DO j=1,nstate
                  WRITE (6,'(2i4,A,3ES24.14)') i,j,' |',
     &                                       (AMFI(l,i,j),l=1,3)
               END DO
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'AMFI integrals were not found on '//
     &                         'HDF5 file')
      END IF
      Call mma_deallocate(AL)

!----------------------------------------------------------------------|
      ! read the RASSI SFS Hamiltonian (SFS_HAM):


!----------------------------------------------------------------------|
      ! read the RASSI SOS Hamiltonian (SOS_HAM):
      Call mma_allocate(RR,nss,nss,'RR')
      Call mma_allocate(RI,nss,nss,'RI')
      Call dcopy_(nss*nss,[0.0_wp],0,RR,1)
      Call dcopy_(nss*nss,[0.0_wp],0,RI,1)

      IF ( mh5_exists_dset(fileid,'HSO_MATRIX_REAL').and.
     &     mh5_exists_dset(fileid,'HSO_MATRIX_IMAG') ) THEN
!         found_hso=.true.
         Call mh5_fetch_dset(fileid,'HSO_MATRIX_REAL',RR )
         Call mh5_fetch_dset(fileid,'HSO_MATRIX_IMAG',RI )
         ! assemble the complex matrix U:
         DO i=1,nss
            DO j=1,nss
               HSO(i,j)=cmplx( RR(i,j), RI(i,j), wp )
            END DO
         END DO
         RNRM=0.0_wp
         RNRM=dznrm2_(nss*nss,HSO,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'HSO matrix read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: HSO'
            DO i=1,nss
               DO j=1,nss
                  WRITE (6,'(2i4,A,2ES24.14)') i,j,' |',HSO(i,j)
               END DO
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'HSO matrix was not found on HDF5 file')
      END IF
      Call mma_deallocate(RR)
      Call mma_deallocate(RI)


!----------------------------------------------------------------------|
!  All info has been read
!  transform the SFS data to the SO basis
!----------------------------------------------------------------------|
      ! generate a local indexing table:
      iss=0
      ibas=0
      ipar=mod(multiplicity(1),2)
      DO Ist=1,nstate
         Mult=Multiplicity(Ist)
         DO I=-(Mult-Ipar)/2,(Mult-Ipar)/2
            IF ( (Ipar == 0) .AND. (I == 0)) GO TO 310
               Iss=Iss+1
               Ibas(Ist,I)=Iss
  310       CONTINUE
         END DO ! i
      END DO ! ist



c----- expand the spin free basis to the spin-orbit basis:
      MM=(0.0_wp,0.0_wp)
      ML=(0.0_wp,0.0_wp)
      MS=(0.0_wp,0.0_wp)
      DO Ist=1,nstate
         Mult=Multiplicity(Ist)
         DO I=-(Mult-Ipar)/2,(Mult-Ipar)/2
            IF ( (Ipar == 0) .AND. (I == 0) ) GO TO 301
            DO J=-(Mult-Ipar)/2,(Mult-Ipar)/2
               IF ( (Ipar == 0) .AND. (J == 0) ) GO TO 302
               DO l=1,3
                  i1=Ibas(Ist,I)
                  j1=Ibas(Ist,J)
                  MM(l,i1,j1)=-Spin(l,Mult,I,J)*g_e
                  MS(l,i1,j1)= Spin(l,Mult,I,J)
               END DO ! l
  302          CONTINUE
            END DO ! J
  301       CONTINUE
         END DO ! I
      END DO ! Ist


      DO Ist=1,nstate
         MultI=Multiplicity(Ist)
         DO Jst=1,nstate
            MultJ=Multiplicity(Jst)
            IF (MultI == MultJ) THEN
               DO I=-(MultI-Ipar)/2,(MultI-Ipar)/2
               IF ( (Ipar == 0) .AND. (I == 0) ) GO TO 303
                  DO l=1,3
                     i1=Ibas(Ist,I)
                     j1=Ibas(Jst,I)
                     MM(l,i1,j1)=MM(l,i1,j1)
     &                              -CMPLX(0.0_wp,Angmom(l,Ist,Jst),wp)
                     ML(l,i1,j1)=ML(l,i1,j1)
     &                              +CMPLX(0.0_wp,Angmom(l,Ist,Jst),wp)
                     DM(l,i1,j1)=DM(l,i1,j1)
     &                              +CMPLX(eDmom(l,Ist,Jst),0.0_wp,wp)
                  END DO   ! l
  303             CONTINUE
               END DO   ! I
            END IF
         END DO   ! Jst
      END DO   ! Ist

      ! calculate the matrix elements of the spin and magnetic moment
      ! in the spin-orbit basis:
      Call mma_allocate(tmp,nss,nss,'tmp')
      DO L=1,3
         TMP=(0.0_wp,0.0_wp)
         ! spin moment
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             MS(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             MS(L,:,:), nss )
         ! orbital moment
         TMP=(0.0_wp,0.0_wp)
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             ML(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             ML(L,:,:), nss )
         ! magnetic moment
         TMP=(0.0_wp,0.0_wp)
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             MM(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             MM(L,:,:), nss )

         IF (found_EDMOM) THEN
         ! electric dipole moment
         TMP=(0.0_wp,0.0_wp)
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             DM(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             DM(L,:,:), nss )
         END IF
      END DO !L
      Call mma_deallocate(tmp)




      ! close the file
      Call mh5_close_file(fileid)

      RETURN
      END SUBROUTINE read_hdf5_all







      SUBROUTINE read_hdf5_poly( file_h5, nss, nstate,
     &                           eso, MM, MS,iReturn )
      Use mh5, Only: mh5_open_file_r, mh5_fetch_attr, mh5_exists_dset,
     &               mh5_fetch_dset, mh5_close_file
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      Integer, intent(in)           :: nstate,nss
      Integer                       :: multiplicity(nstate)
      Integer                       :: iReturn

!      Real(kind=8), intent(out)    :: esfs(nstate)
      Real(kind=8), intent(out)    :: eso(nss)
!      Real(kind=8), intent(out)    ::  edmom(3,nstate,nstate)
!      Real(kind=8), intent(out)    ::   amfi(3,nstate,nstate)
      Real(kind=8)                 :: angmom(3,nstate,nstate)
      Complex(kind=8)  :: MM(3,nss,nss)
      Complex(kind=8)  :: MS(3,nss,nss)
!      Complex(kind=8), intent(out) :: ML(3,nss,nss)
!      Complex(kind=8), intent(out) :: DM(3,nss,nss) ! electric dipole moment
!      Complex(kind=8)              :: U(nLoc,nLoc)
!      Complex(kind=8), intent(out) :: HSO(nss,nss)

      Real(kind=8)                 :: AU2CM
      Real(kind=8), allocatable    :: etmp(:)
      Real(kind=8), allocatable    :: RR(:,:), RI(:,:)
      Real(kind=8), allocatable    :: AL(:,:,:)
      Complex(kind=8), allocatable :: U(:,:)
      Integer                       :: fileid,jend,INRM
      Character(Len=180)            :: file_h5
      Real(kind=8)                 :: RNRM
      Real(kind=8), external       :: dnrm2_, dznrm2_
      Complex(kind=8), external    :: spin
      ! local variables:
      Integer       :: iss, ibas(nstate,-50:50)
      Integer       :: i, j, i1, j1, ist, jst, mult, multI, multJ
      Integer       :: l, ipar
      Real(kind=8) :: g_e
      Complex(kind=8), allocatable    :: tmp(:,:)

!      Logical :: Exist
!      Logical :: found_edmom, found_angmom, found_hso, found_amfi,
!     &           found_sos_coeff, found_eso, found_esfs, found_mult
      Logical :: DBG

      DBG  =.false.
      AU2CM=219474.6313702_wp
      g_e=2.00231930437180_wp
!      found_edmom=.false.
!      found_angmom=.false.
!      found_hso=.false.
!      found_amfi=.false.
!      found_sos_coeff=.false.
!      found_eso=.false.
!      found_esfs=.false.
!      found_mult=.false.
      iReturn=0

      WRITE (6,'(A,A)') 'Read data from rassi.h5 file ',trim(file_h5)

      ! the presence of the RASSI-HDF5 has already been made in
      ! read_hdf5_init subroutine, executed earlier
      ! nss, nstate are already known
!----------------------------------------------------------------------|
      ! open the file
      fileid = mh5_open_file_r(trim(file_h5))
      IF (DBG) WRITE (6,'(A,I24)') 'read_hdf5_all:: fileid=',fileid
!----------------------------------------------------------------------|
      ! read spin multiplicity of each state:
c      IF (mh5_exists_dset(fileid,'STATE_SPINMULT')) THEN
!         found_mult=.true.
         Call mh5_fetch_attr(fileid,'STATE_SPINMULT',
     &                       multiplicity(1:nstate))
         IF (DBG) WRITE (6,'(A)') 'read_hdf5_all:: multiplicity'
         IF (DBG) WRITE (6,'(20I4)') (multiplicity(i),i=1,nstate)
         INRM=0
         INRM=SUM(multiplicity(:))
         IF ( INRM == 0 ) THEN
            Call WarningMessage(2,'STATE_SPINMULT array read from '//
     &                          'HDF5 file has norm = zero')
            WRITE (6,*) 'Norm=',INRM
         END IF
c      ELSE
c         Call WarningMessage(2,'State multiplicity array was not '//
c     &                         'found on HDF5 file')
c      END IF

!----------------------------------------------------------------------|
!      ! read the spin free energies (cm-1)
!      Call mma_allocate(etmp,nstate,'etmp)')
!      Call dcopy_(nstate,[0.0_wp],0,etmp,1)
!      IF (mh5_exists_dset(fileid,'SFS_ENERGIES')) THEN
!         found_esfs=.true.
!         Call mh5_fetch_dset(fileid,'SFS_ENERGIES',etmp)
!         RNRM=0.0_wp
!         RNRM=dnrm2_(nstate,etmp,1)
!         IF ( RNRM.lt.1.0D-50 ) THEN
!            Call WarningMessage(2,'ESFS read from HDF5 file '//
!     &                          ' has norm = zero')
!            WRITE (6,*) 'Norm=',RNRM
!         END IF
!         ! compute the energeis in cm-1:
!         DO i=1,nstate
!            esfs(i)=(etmp(i)-etmp(1))*AU2CM
!         END DO
!         IF (DBG) THEN
!            WRITE (6,'(A)') 'read_hdf5_all:: esfs'
!            DO i=1,nstate,4
!               jEND=MIN(nstate,i+3)
!               WRITE (6,'(4ES24.14)') (esfs(j),j=i,jEnd)
!            END DO
!         END IF
!      ELSE
!         Call WarningMessage(2,'Spin-free energies were not '//
!     &                         'found on HDF5 file')
!      END IF
!      Call mma_deallocate(etmp)
!
!
!----------------------------------------------------------------------|
      ! read the spin-orbit energies (cm-1)
      Call mma_allocate(etmp,nss,'tmp)')
      Call dcopy_(nss,[0.0_wp],0,etmp,1)
      IF (mh5_exists_dset(fileid,'SOS_ENERGIES')) THEN
!         found_eso=.true.
         Call mh5_fetch_dset(fileid,'SOS_ENERGIES',etmp)
         RNRM=0.0_wp
         RNRM=dnrm2_(nss,etmp,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'ESO read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         ! compute the energeis in cm-1:
         DO i=1,nss
            eso(i)=(etmp(i)-etmp(1))*AU2CM
         END DO
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: eso'
            DO i=1,nss,4
               jEnd=MIN(nss,i+3)
               WRITE (6,'(4ES24.14)') (eso(j),j=i,jEnd)
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'Spin-orbit energies were not '//
     &                         'found on HDF5 file')
      END IF
      Call mma_deallocate(etmp)


!----------------------------------------------------------------------|
      ! read the spin-orbit mixing coefficient matrix:
      Call mma_allocate(RR,nss,nss,'RR')
      Call mma_allocate(RI,nss,nss,'RI')
      Call mma_allocate(U,nss,nss,'U')
      Call dcopy_(nss*nss,[0.0_wp],0,RR,1)
      Call dcopy_(nss*nss,[0.0_wp],0,RI,1)
      Call zcopy_(nss*nss,[(0.0_wp,0.0_wp)],0,U,1)

      IF ( mh5_exists_dset(fileid,'SOS_COEFFICIENTS_REAL').and.
     &     mh5_exists_dset(fileid,'SOS_COEFFICIENTS_IMAG') ) THEN
!         found_sos_coeff=.true.
         Call mh5_fetch_dset(fileid,'SOS_COEFFICIENTS_REAL', RR )
         Call mh5_fetch_dset(fileid,'SOS_COEFFICIENTS_IMAG', RI )
         ! assemble the complex matrix U:
         DO i=1,nss
            DO j=1,nss
               U(i,j)=cmplx( RR(i,j), RI(i,j), wp )
            END DO
         END DO
         RNRM=0.0_wp
         RNRM=dznrm2_(nss*nss,U,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'SOS-U matrix read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: U'
            DO i=1,nss
               DO j=1,nss
                  WRITE (6,'(2i4,A,2ES24.14)') i,j,' |',U(i,j)
               END DO
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'SO mixing coefficeints were not '//
     &                         'found on HDF5 file')
      END IF
      Call mma_deallocate(RR)
      Call mma_deallocate(RI)


!----------------------------------------------------------------------|
      ! read the angular momentum integrals (L):
      Call mma_allocate(AL,nstate,nstate,3,'AL')
      Call dcopy_(nstate*nstate*3,[0.0_wp],0,AL,1)
      IF (mh5_exists_dset(fileid,'SFS_ANGMOM')) THEN
!         found_angmom=.true.
         Call mh5_fetch_dset(fileid,'SFS_ANGMOM',AL)
         DO i=1,nstate
            DO j=1,nstate
               DO l=1,3
                  ANGMOM(l,i,j)=AL(i,j,l)
               END DO
            END DO
         END DO
         RNRM=0.0_wp
         RNRM=dnrm2_(nstate*nstate*3,AL,1)
         IF ( RNRM.lt.1.0D-50 ) THEN
            Call WarningMessage(2,'SFS_ANGMOM read from HDF5 file '//
     &                          ' has norm = zero')
            WRITE (6,*) 'Norm=',RNRM
         END IF
         IF (DBG) THEN
            WRITE (6,'(A)') 'read_hdf5_all:: ANGMOM (x,y,z)'
            DO i=1,nstate
               DO j=1,nstate
                  WRITE (6,'(2i4,A,3ES24.14)') i,j,' |',
     &                                       (ANGMOM(l,i,j),l=1,3)
               END DO
            END DO
         END IF
      ELSE
         Call WarningMessage(2,'ANGMOM integrals were not found on '//
     &                         'HDF5 file')
      END IF
      Call mma_deallocate(AL)




!----------------------------------------------------------------------|
!      ! read the electric dipole momentum integrals (EDMOM):
!      Call mma_allocate(AL,nstate,nstate,3,'AL')
!      Call dcopy_(nstate*nstate*3,[0.0_wp],0,AL,1)
!      IF (mh5_exists_dset(fileid,'SFS_EDIPMOM')) THEN
!         found_edmom=.true.
!         Call mh5_fetch_dset(fileid,'SFS_EDIPMOM',AL)
!         DO i=1,nstate
!            DO j=1,nstate
!               DO l=1,3
!                  EDMOM(l,i,j)=AL(i,j,l)
!               END DO
!            END DO
!         END DO
!         RNRM=0.0_wp
!         RNRM=dnrm2_(nstate*nstate*3,AL,1)
!         IF ( RNRM.lt.1.0D-50 ) THEN
!            Call WarningMessage(2,'SFS_EDIPMOM read from HDF5 file '//
!     &                          ' has norm = zero')
!            WRITE (6,*) 'Norm=',RNRM
!         END IF
!         IF (DBG) THEN
!            WRITE (6,'(A)') 'read_hdf5_all:: SFS_EDIPMOM(x,y,z)'
!            DO i=1,nstate
!               DO j=1,nstate
!                  WRITE (6,'(2i4,A,3ES24.14)') i,j,' |',
!     &                                       (EDMOM(l,i,j),l=1,3)
!               END DO
!            END DO
!         END IF
!      ELSE
!         Call WarningMessage(2,'EDMOM integrals were not found on '//
!     &                         'HDF5 file')
!      END IF
!      Call mma_deallocate(AL)
!
!
!----------------------------------------------------------------------|
!      ! read the spin-orbit integrals (AMFI):
!      Call mma_allocate(AL,nstate,nstate,3,'AL')
!      Call dcopy_(nstate*nstate*3,[0.0_wp],0,AL,1)
!      IF (mh5_exists_dset(fileid,'SFS_AMFIINT')) THEN
!         found_amfi=.true.
!         Call mh5_fetch_dset(fileid,'SFS_AMFIINT',AL)
!         DO i=1,nstate
!            DO j=1,nstate
!               DO l=1,3
!                  AMFI(l,i,j)=AL(i,j,l)
!               END DO
!            END DO
!         END DO
!         RNRM=0.0_wp
!         RNRM=dnrm2_(nstate*nstate*3,AL,1)
!         IF ( RNRM.lt.1.0D-50 ) THEN
!            Call WarningMessage(2,'SFS_AMFIINT read from HDF5 file '//
!     &                          ' has norm = zero')
!            WRITE (6,*) 'Norm=',RNRM
!         END IF
!         IF (DBG) THEN
!            WRITE (6,'(A)') 'read_hdf5_all:: SFS_AMFIINT(x,y,z)'
!            DO i=1,nstate
!               DO j=1,nstate
!                  WRITE (6,'(2i4,A,3ES24.14)') i,j,' |',
!     &                                       (AMFI(l,i,j),l=1,3)
!               END DO
!            END DO
!         END IF
!      ELSE
!         Call WarningMessage(2,'AMFI integrals were not found on '//
!     &                         'HDF5 file')
!      END IF
!      Call mma_deallocate(AL)
!
!----------------------------------------------------------------------|
      ! read the RASSI SFS Hamiltonian (SFS_HAM):


!----------------------------------------------------------------------|
!      ! read the RASSI SOS Hamiltonian (SOS_HAM):
!      Call mma_allocate(RR,nss,nss,'RR')
!      Call mma_allocate(RI,nss,nss,'RI')
!      Call dcopy_(nss*nss,[0.0_wp],0,RR,1)
!      Call dcopy_(nss*nss,[0.0_wp],0,RI,1)
!
!      IF ( mh5_exists_dset(fileid,'HSO_MATRIX_REAL').and.
!     &     mh5_exists_dset(fileid,'HSO_MATRIX_IMAG') ) THEN
!         found_hso=.true.
!         Call mh5_fetch_dset(fileid,'HSO_MATRIX_REAL',RR )
!         Call mh5_fetch_dset(fileid,'HSO_MATRIX_IMAG',RI )
!         ! assemble the complex matrix U:
!         DO i=1,nss
!            DO j=1,nss
!               HSO(i,j)=cmplx( RR(i,j), RI(i,j), wp )
!            END DO
!         END DO
!         RNRM=0.0_wp
!         RNRM=dznrm2_(nss*nss,HSO,1)
!         IF ( RNRM.lt.1.0D-50 ) THEN
!            Call WarningMessage(2,'HSO matrix read from HDF5 file '//
!     &                          ' has norm = zero')
!            WRITE (6,*) 'Norm=',RNRM
!         END IF
!         IF (DBG) THEN
!            WRITE (6,'(A)') 'read_hdf5_all:: HSO'
!            DO i=1,nss
!               DO j=1,nss
!                  WRITE (6,'(2i4,A,2ES24.14)') i,j,' |',HSO(i,j)
!               END DO
!            END DO
!         END IF
!      ELSE
!         Call WarningMessage(2,'HSO matrix was not found on HDF5 file')
!      END IF
!      Call mma_deallocate(RR)
!      Call mma_deallocate(RI)
!
!
!----------------------------------------------------------------------|
!  All info has been read
!  transform the SFS data to the SO basis
!----------------------------------------------------------------------|
      ! generate a local indexing table:
      iss=0
      ibas=0
      ipar=mod(multiplicity(1),2)
      DO Ist=1,nstate
         Mult=Multiplicity(Ist)
         DO I=-(Mult-Ipar)/2,(Mult-Ipar)/2
            IF ( (Ipar == 0) .AND. (I == 0)) GO TO 310
               Iss=Iss+1
               Ibas(Ist,I)=Iss
  310       CONTINUE
         END DO ! i
      END DO ! ist



c----- expand the spin free basis to the spin-orbit basis:
      MM=(0.0_wp,0.0_wp)
!      ML=(0.0_wp,0.0_wp)
      MS=(0.0_wp,0.0_wp)
      DO Ist=1,nstate
         Mult=Multiplicity(Ist)
         DO I=-(Mult-Ipar)/2,(Mult-Ipar)/2
            IF ( (Ipar == 0) .AND. (I == 0) ) GO TO 301
            DO J=-(Mult-Ipar)/2,(Mult-Ipar)/2
               IF ( (Ipar == 0) .AND. (J == 0) ) GO TO 302
               DO l=1,3
                  i1=Ibas(Ist,I)
                  j1=Ibas(Ist,J)
                  MM(l,i1,j1)=-Spin(l,Mult,I,J)*g_e
                  MS(l,i1,j1)= Spin(l,Mult,I,J)
               END DO ! l
  302          CONTINUE
            END DO ! J
  301       CONTINUE
         END DO ! I
      END DO ! Ist


      DO Ist=1,nstate
         MultI=Multiplicity(Ist)
         DO Jst=1,nstate
            MultJ=Multiplicity(Jst)
            IF (MultI == MultJ) THEN
               DO I=-(MultI-Ipar)/2,(MultI-Ipar)/2
               IF ( (Ipar == 0) .AND. (I == 0) ) GO TO 303
                  DO l=1,3
                     i1=Ibas(Ist,I)
                     j1=Ibas(Jst,I)
                     MM(l,i1,j1)=MM(l,i1,j1)
     &                              -CMPLX(0.0_wp,Angmom(l,Ist,Jst),wp)
!                     ML(l,i1,j1)=ML(l,i1,j1)
!     &                              +CMPLX(0.0_wp,Angmom(l,Ist,Jst),wp)
!                     DM(l,i1,j1)=DM(l,i1,j1)
!     &                              +CMPLX(eDmom(l,Ist,Jst),0.0_wp,wp)
                  END DO   ! l
  303             CONTINUE
               END DO   ! I
            END IF
         END DO   ! Jst
      END DO   ! Ist



      ! calculate the matrix elements of the spin and magnetic moment
      ! in the spin-orbit basis:
      Call mma_allocate(tmp,nss,nss,'tmp')
      DO L=1,3
         TMP=(0.0_wp,0.0_wp)
         ! spin moment
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             MS(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             MS(L,:,:), nss )
!         ! orbital moment
!         TMP=(0.0_wp,0.0_wp)
!         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
!     &                     U, nss,
!     &             ML(L,:,:), nss,           (0.0_wp,0.0_wp),
!     &                   TMP, nss )
!         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
!     &                   TMP, nss,
!     &                     U, nss,           (0.0_wp,0.0_wp),
!     &             ML(L,:,:), nss )
         ! magnetic moment
         TMP=(0.0_wp,0.0_wp)
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             MM(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             MM(L,:,:), nss )

!         IF (found_EDMOM) THEN
!         ! electric dipole moment
!         TMP=(0.0_wp,0.0_wp)
!         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
!     &                     U, nss,
!     &             DM(L,:,:), nss,           (0.0_wp,0.0_wp),
!     &                   TMP, nss )
!         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
!     &                   TMP, nss,
!     &                     U, nss,           (0.0_wp,0.0_wp),
!     &             DM(L,:,:), nss )
!         END IF
      END DO !L
      Call mma_deallocate(tmp)
      Call mma_deallocate(U)


      ! close the file
      Call mh5_close_file(fileid)

      RETURN
      END  SUBROUTINE read_hdf5_poly





#else
      !
      SUBROUTINE read_hdf5_init()
      RETURN
      END

      SUBROUTINE read_hdf5_all()
      RETURN
      END

      SUBROUTINE read_hdf5_poly()
      RETURN
      END

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DO_SONATORB(NSS,USOR,USOI)

use rassi_aux, only: ipglob
use rassi_global_arrays, only: EIGVEC, JBNUM
use rassi_data, only: NBTRI
use Cntrl, only: IfCurd, MLTPLT, NOSO, NSTATE, SODIAG, SODIAGNSTATE, SONAT, SONATNSTATE
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSS
real(kind=wp), intent(in) :: USOR(NSS,NSS), USOI(NSS,NSS)
integer(kind=iwp) :: I, IC, INATSTATE, IOPT, ISS, ISTATE, JOB1, JOB2, JSS, JSTATE, MPLET1, MPLET2, MSPROJ1, MSPROJ2
real(kind=wp) :: DUM1, DUM2, DUM3, DUM4, DUM5, DUM6, IDENTMAT(3,3)
character(len=8) :: LAB
real(kind=wp), allocatable :: DMATTMP(:), UMATI(:), UMATR(:), VMAT(:,:)

! Calculates natural orbitals, including spinorbit effects
write(u6,*)
write(u6,*)
write(u6,*) '*****************************************'
write(u6,*) '* RUNNING SONATORB CODE *****************'
write(u6,*) '*****************************************'
write(u6,*)

call unitmat(IDENTMAT,3)

call mma_allocate(UMATR,NSS**2,Label='UMATR')
call mma_allocate(UMATI,NSS**2,Label='UMATI')
call mma_allocate(VMAT,NSS,NSS,Label='VMAT')

VMAT(:,:) = Zero

! transform V matrix in SF basis to spin basis
! This was taken from smmat and modified slightly
ISS = 0
do ISTATE=1,NSTATE
  JOB1 = JBNUM(ISTATE)
  MPLET1 = MLTPLT(JOB1)

  do MSPROJ1=-MPLET1+1,MPLET1-1,2
    ISS = ISS+1
    JSS = 0

    do JSTATE=1,NSTATE
      JOB2 = JBNUM(JSTATE)
      MPLET2 = MLTPLT(JOB2)

      do MSPROJ2=-MPLET2+1,MPLET2-1,2
        JSS = JSS+1

        if ((MPLET1 == MPLET2) .and. (MSPROJ1 == MSPROJ2)) VMAT(ISS,JSS) = EIGVEC(JSTATE,ISTATE)
      end do
    end do
  end do
end do

if (.not. NOSO) then
  ! combine this matrix with the SO eigenvector matrices
  call DGEMM_('N','N',NSS,NSS,NSS,One,VMAT,NSS,USOR,NSS,Zero,UMATR,NSS)
  call DGEMM_('N','N',NSS,NSS,NSS,One,VMAT,NSS,USOI,NSS,Zero,UMATI,NSS)
else
  ! Spinorbit contributions to this are disabled
  UMATR(:) = pack(VMAT(:,:),.true.)
  UMATI(:) = Zero
end if

! Holds the density matrices for all three directions
call mma_allocate(DMATTMP,6*NBTRI,Label='DMATTMP')

! SONATNSTATE = number of states to calculate.
! These states are stored beginning in SONAT
do I=1,SONATNSTATE
  INATSTATE = SONAT(I)

  write(u6,*)
  write(u6,*) 'CALCULATING NAT ORBITALS FOR SSTATE: ',INATSTATE
  if ((INATSTATE > NSS) .or. (INATSTATE <= 0)) then
    write(u6,*) '...WHICH DOES NOT EXIST!'
    call ABEND()
  end if
  write(u6,*)

  ! Calculate overall density, store in DMATTMP
  iOpt = 0
  call SONATORBM('HERMSING',UMATR,UMATI,INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,DMATTMP)

  ! Integrate for the expectation value
  if (IPGLOB >= 3) then
    IC = 1
    iOpt = 0
    LAB = 'MLTPL  0'
    call SONATORBM_INT(DMATTMP,LAB,IC,'HERMSING',INATSTATE,INATSTATE,iOpt,IDENTMAT,DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)

    !call ADD_INFO('MLTPL0SING_INT3',DUM3,1,6)
    !call ADD_INFO('MLTPL0SING_INT6',DUM6,1,6)
  end if

  ! Create SONATTDENS total density orbital file for this (I,I) state
  call SONATORB_PLOT(DMATTMP,'SONATTDENS','HERMSING',INATSTATE,INATSTATE)

  if (IPGLOB >= 4) call SONATORB_CPLOT(DMATTMP,'TDENSTESTX','HERMSING',INATSTATE,INATSTATE)

  ! Calculate spin density, store in LDMATTMP
  iOpt = 0
  call SONATORBM('HERMTRIP',UMATR,UMATI,INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,DMATTMP)

  ! Integrate for the expectation value
  if (IPGLOB >= 3) then
    IC = 1
    iOpt = 0
    LAB = 'MLTPL  0'
    call SONATORBM_INT(DMATTMP,LAB,IC,'HERMTRIP',INATSTATE,INATSTATE,iOpt,IDENTMAT,DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)
    !call ADD_INFO('MLTPL0TRIP_INT3',DUM3,1,6)
    !call ADD_INFO('MLTPL0TRIP_INT6',DUM6,1,6)
  end if

  ! Create SONATSDENS spin density orbital file for this (I,I) state
  call SONATORB_PLOT(DMATTMP,'SONATSDENS','HERMTRIP',INATSTATE,INATSTATE)

  if (IPGLOB >= 4) call SONATORB_CPLOT(DMATTMP,'SDENSTESTX','HERMTRIP',INATSTATE,INATSTATE)

  ! Type 2 - current density
  if (IFCURD) then
    iOpt = 0
    call SONATORBM('ANTISING',UMATR,UMATI,INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,DMATTMP)

    if (IPGLOB >= 3) then
      IC = 1
      iOpt = 0
      LAB = 'ANGMOM'
      call SONATORBM_INT(DMATTMP,LAB,IC,'ANTISING',INATSTATE,INATSTATE,iOpt,IDENTMAT,DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)
      !call ADD_INFO('CURD1_INT3',DUM3,1,6)
      !call ADD_INFO('CURD1_INT6',DUM6,1,6)

      IC = 2
      iOpt = 0
      LAB = 'ANGMOM'
      call SONATORBM_INT(DMATTMP,LAB,IC,'ANTISING',INATSTATE,INATSTATE,iOpt,IDENTMAT,DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)

      !call ADD_INFO('CURD2_INT3',DUM3,1,6)
      !call ADD_INFO('CURD2_INT6',DUM6,1,6)

      IC = 3
      iOpt = 0
      LAB = 'ANGMOM'
      call SONATORBM_INT(DMATTMP,LAB,IC,'ANTISING',INATSTATE,INATSTATE,iOpt,IDENTMAT,DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)
      !call ADD_INFO('CURD3_INT3',DUM3,1,6)
      !call ADD_INFO('CURD3_INT6',DUM6,1,6)

    end if

    call SONATORB_CPLOT(DMATTMP,'SONATLDENS','ANTISING',INATSTATE,INATSTATE)
  end if

end do

call mma_deallocate(DMATTMP)
call mma_deallocate(SONAT)

! perform the state diagonalization similar to
! what is done in single_aniso
if (SODIAGNSTATE > 0) then

  ! This actually does all the work
  call mkSODIAG(UMATR,UMATI,NSS)

  ! This is only allocated if SODIAGNSTATE > 0
  call mma_deallocate(SODIAG)
end if

call mma_deallocate(UMATR)
call mma_deallocate(UMATI)
call mma_deallocate(VMAT)

end subroutine DO_SONATORB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine SCECORas(KV,KVLEV,JROT,INNER,ICOR,IWR,EO,RH,BFCT,NDP,NCN,V,SDRDY,BMAX,VLIM,DGDV2)
!** Subroutine calculates (approximate!) semiclassical estimate of
!  dG/dv for level  v= KV  with energy  EO [cm-1]  on potential
!  {V(i),i=1,NDP} (in 'internal BCFT units' {V[cm-1]*BFCT}), and uses
!  those results to estimate energy of level  KVLEV
!** If the 'clever' semiclassical procedure fails - try a brute force
!  step-by-step search, using alternately INNER & OUTER well starting
!** BMAX is internal barrier maximum energy for double-well case,
!   and very large negative number for single-well potential
!** On return, negative DGDV2 signals error!  No phase integrals found

use Constants, only: Zero, One, Two, Three, Half, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: KV, KVLEV, INNER
integer(kind=iwp), intent(in) :: JROT, ICOR, IWR, NDP, NCN
real(kind=wp), intent(inout) :: EO
real(kind=wp), intent(in) :: RH, BFCT, V(NDP), SDRDY(NDP), BMAX, VLIM
real(kind=wp), intent(out) :: DGDV2
integer(kind=iwp) :: BRUTE, I, I1, I2, I3, I4, IB, IDIF, II, IV1, IV2, KVB = -1, KVDIF
real(kind=wp) :: ANS1, ANS2, ARG2, ARG3, DE0, DE1, DE2, DGDV1, DGDV2P, DGDVB = -One, DGDVBP, EINT, PNCN, PP1, RT, VPH1, VPH2, &
                 XDIF, Y1, Y2, Y3
logical(kind=iwp) :: Found, Skip
real(kind=wp), save :: DEBRUTE, EBRUTE

ARG3 = 0
I1 = 0
II = 0
DGDVBP = -One
DGDV2 = -One
EINT = EO*BFCT
if (KVLEV == 0) DGDVB = -One
KVDIF = KVLEV-KV
if (ICOR == 1) BRUTE = 0
I3 = NDP
PNCN = real(NCN-2,kind=wp)/real(NCN+2,kind=wp)
PP1 = One/pNCN+One
! For Quasibound levels, first search inward to classically forbidden
if (EO > VLIM) then
  PNCN = One
  PP1 = Two
  do I=NDP,1,-1
    I3 = I
    if (V(I) > EINT) exit
  end do
end if
! First, search inward for outermost turning point
Found = .false.
do I=I3,1,-1
  I4 = I
  if (V(I) < EINT) then
    Found = .true.
    exit
  end if
end do
! If never found an 'outer' turning point (e.g., above qbdd. barier)
! then simply return with negative  DGDV2  as error flag
if (.not. Found) return
!... Now collect vibrational phase and its energy deriv. over outer well
Y1 = EINT-V(I4+1)
Y2 = EINT-V(I4)
Y3 = EINT-V(I4-1)
call LEVQAD(Y1,Y2,Y3,RH,RT,ANS1,ANS2)
ARG2 = sqrt(Y3)
VPH2 = Half*ARG2+ANS2*SDRDY(I4)**2/RH
DGDV2 = Half/ARG2+ANS1*SDRDY(I4)**2/RH
do I=I4-2,1,-1
  !... now, collect (v+1/2) and dv/dG integrals to next turning point ...
  II = I
  if (V(I) > EINT) exit
  ARG3 = ARG2
  ARG2 = sqrt(EINT-V(I))
  VPH2 = VPH2+ARG2*SDRDY(I)**2
  DGDV2 = DGDV2+SDRDY(I)**2/ARG2
end do
I3 = II+1
Y1 = EINT-V(I3-1)
Y2 = EINT-V(I3)
Y3 = EINT-V(I3+1)
call LEVQAD(Y1,Y2,Y3,RH,RT,ANS1,ANS2)
VPH2 = (VPH2-ARG2-Half*ARG3+ANS2*SDRDY(I3)**2/RH)/Pi
DGDV2 = DGDV2-One/ARG2-Half/ARG3+ANS1*SDRDY(I3)**2/RH
DGDV2 = Two*Pi/(BFCT*DGDV2)
! Next, search for innermost turning point
do I=1,NDP
  I1 = I
  if (V(I) < EINT) exit
end do
!... then collect vibrational phase and its energy deriv. over outer well
if (I1 == 1) then
  write(u6,602) JROT,EO
  !stop
  call ABEND()
end if
Skip = .false.
if (I1 >= I3) then
  ! For single-well potential or above barrier of double-well potential
  if (IWR >= 2) write(u6,600) ICOR,KV,JROT,EO,VPH2-Half,DGDV2
  if ((KV /= KVLEV-1) .and. (DGDVB > Zero)) then
    !... If got wrong level (KV not one below KVLEV) and NOT first call ...
    if ((EO-BMAX) > (Two*DGDV2)) then
      !... 'Normal' case: use B-S plot area to estimate correct energy
      DE0 = KVDIF*(DGDV2-Half*(DGDV2-DGDVB)/real(KV-KVB,kind=wp))
      EO = EO+DE0
      KV = KVB
      KVLEV = KV+1
      return
    else
      !... but close to barrier in double-well potential, switch to 'BRUTE'
      BRUTE = BRUTE+1
      DGDV1 = DGDV2
      XDIF = sign(1,KVDIF)
      Skip = .true.
    end if
  end if
  if (.not. Skip) then
    if (KVLEV == 0) then
      ! If looking for v=0, just use local DVDG2 to estimate energy correction
      EO = EO+KVDIF*DGDV2
      return
    end if
    if (KV == 0) then
      ! Normally:  use B-S plot considerations to estimate next level energy
      !... use harmonic estimate for v=1 energy
      EO = EO+DGDV2
    else
      !... estimate Delta(G) based on linear Birge-Sponer
      DE0 = Half*(Three*DGDV2-DGDVB)
      if ((Two*DGDV2) > DGDVB) then
        !... if linear Birge-Sponer predicts another level, then use it
        EO = EO+DE0
      else
        !... otherwise, use N-D theory extrapolation for next level...
        DGDV2P = DGDV2**PNCN
        DE0 = (DGDV2P+DGDV2P-DGDVBP)
        if (DE0 > Zero) then
          DE0 = (DE0**PP1-DGDV2P**PP1)/(PP1*(DGDV2P-DGDVBP))
          EO = EO+DE0
        else
          !... but if NDT predicts no more levels, quit, and (optionally) print
          if (IWR > 0) write(u6,604) KV,EO
          return
        end if
      end if
    end if
    DGDVB = DGDV2
    DGDVBP = DGDVB**PNCN
    KVB = KV
    INNER = 0
    return
  end if
end if

! For a double-well potential, collect vibrational phase and its
! energy derivative over the inner well
Y1 = EINT-V(I1-1)
Y2 = EINT-V(I1)
Y3 = EINT-V(I1+1)
call LEVQAD(Y1,Y2,Y3,RH,RT,ANS1,ANS2)
ARG2 = sqrt(Y3)
VPH1 = Half*ARG2+ANS2*SDRDY(I1)**2/RH
DGDV1 = Half/ARG2+ANS1*SDRDY(I1)**2/RH
do I=I1+2,NDP
  !... now, collect integral and count nodes outward to next turning point ...
  if (V(I) > EINT) exit
  ARG3 = ARG2
  ARG2 = sqrt(EINT-V(I))
  VPH1 = VPH1+ARG2*SDRDY(I)**2
  DGDV1 = DGDV1+SDRDY(I)**2/ARG2
end do
I2 = I-1
Y1 = EINT-V(I2+1)
Y2 = EINT-V(I2)
Y3 = EINT-V(I2-1)
call LEVQAD(Y1,Y2,Y3,RH,RT,ANS1,ANS2)
VPH1 = (VPH1-ARG2-Half*ARG3+ANS2*SDRDY(I2)**2/RH)/Pi
DGDV1 = DGDV1-One/ARG2-Half/ARG3+ANS1*SDRDY(I2)**2/RH
DGDV1 = Two*Pi/(BFCT*DGDV1)
if (KVDIF == 0) then
  ! If already at level sought, return
  if (IWR >= 2) write(u6,610) KV,JROT,EO,VPH1-Half,DGDV1,KVLEV,ICOR,VPH2-Half,DGDV2
  return
end if

! Check whether looking for higher or lower level ...
IDIF = sign(1,KVDIF)
XDIF = IDIF
if ((ICOR < 6) .or. ((abs(KVDIF) /= 1) .and. (BRUTE <= 0))) then
  ! 'Conventional' semiclassical search for neared INNER or OUTER well level
  if (INNER <= 0) then
    !... and current energy EO is for an outer-well level ...
    DE2 = DGDV2*XDIF
    IV1 = int(VPH1+Half)
    DE1 = (real(IV1,kind=wp)+Half-VPH1)*DGDV1*XDIF
    if (IWR >= 2) write(u6,610) KV,JROT,EO,VPH1-Half,DGDV1,KVLEV,ICOR,VPH2-Half,DGDV2
    do
      if (abs(DE1) < abs(DE2)) then
        INNER = 1
        EO = EO+DE1
        DE1 = DGDV1*XDIF
      else
        INNER = 0
        EO = EO+DE2
      end if
      KVDIF = KVDIF-IDIF
      if (KVDIF == 0) return
    end do
  end if
  if (INNER > 0) then
    !... and current energy EO is for an inner-well level ...
    DE1 = DGDV1*XDIF
    IV2 = int(VPH2+Half)
    DE2 = (real(IV2,kind=wp)+Half-VPH2)*DGDV2*XDIF
    if (IWR >= 2) write(u6,610) KV,JROT,EO,VPH1-Half,DGDV1,KVLEV,ICOR,VPH2-Half,DGDV2
    do
      if (abs(DE2) < abs(DE1)) then
        INNER = 0
        EO = EO+DE2
        DE2 = DGDV2*XDIF
      else
        INNER = 1
        EO = EO+DE1
      end if
      KVDIF = KVDIF-IDIF
      if (KVDIF == 0) return
    end do
  end if
end if
if (.not. Skip) then
  BRUTE = BRUTE+1
  ! Now .. Brute force search for desired level !
  if (IWR >= 2) write(u6,610) KV,JROT,EO,VPH1-Half,DGDV1,KVLEV,ICOR,VPH2-Half,DGDV2
end if
if (BRUTE == 1) then
  !... in first brute-force step, use previous energy with opposite INNER
  EBRUTE = EO
  if (INNER == 0) then
    INNER = 1
  else
    INNER = 0
  end if
  DEBRUTE = min(DGDV1,DGDV2)*XDIF*0.3_wp
  return
end if
IB = BRUTE/2
!... in subsequent even steps, lower EO by DEBRUTE/10 for same INNER
if ((IB+IB) == BRUTE) then
  EBRUTE = EBRUTE+DEBRUTE
  EO = EBRUTE
  return
else
  !... in subsequent odd steps, lower repeat previous EO with INNER changed
  if (INNER == 0) then
    INNER = 1
  else
    INNER = 0
  end if
  EO = EBRUTE
  return
end if

!return

600 format(' Single well  ICOR=',I2,':  E(v=',i3,',J=',I3,')=',f10.2,'  v(SC)=',F8.3,'  dGdv=',f8.3)
602 format(/' *** ERROR ***  V(1) < E(J=',i3,')=',f10.2)
604 format(10x,'Find highest bound level is   E(v=',i3,')=',ES18.10)
610 format(' Double well   E(v=',i3,', J=',I3,')=',f9.3,':   v1(SC)=',F7.3,'   dGdv1=',f8.2/8x,'seeking  v=',I3,' (ICOR=',I2,')', &
           8x,':   v2(SC)=',F7.3,'   dGdv2=',f8.2)

end subroutine SCECORas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SetShP2Q_2(irc,iLoc,iShlAB,nAB)
C
C     Purpose: set mapping from shell pair iShlAB to qualified
C              columns within current reduced set (stored at location
C              iLoc = 2 or 3).
C              If a non-zero code (irc) is returned, nothing has been
C              set!!
C
#include "implicit.fh"
      Integer nAB(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "chosew.fh"
#include "WrkSpc.fh"

      IndRed(i,j)=iWork(ip_IndRed-1+mmBstRT*(j-1)+i)
      iQuAB(i,j)=iWork(ip_iQuAB-1+MaxQual*(j-1)+i)
      nBstSh(i)=iWork(ip_nBstSh-1+i)
      iSP2F(i)=iWork(ip_iSP2F-1+i)
      IndRsh(i)=iWork(ip_IndRSh-1+i)

C     Check allocations.
C     ------------------

      Call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.True.)
      If (iShlA .eq. iShlB) Then
         NumAB = nBstSh(iShlA)*(nBstSh(iShlA)+1)/2
      Else
         NumAB = nBstSh(iShlA)*nBstSh(iShlB)
      End If
      lTst = 2*NumAB
      If (l_iShP2Q.lt.1 .or. l_iShP2Q.lt.lTst) Then
         irc = 102
         Return
      End If

C     Check iLoc.
C     -----------

      If (iLoc.lt.2 .or. iLoc.gt.3) Then
         irc = 104
         Return
      End If

C     Set mapping array.
C     iShP2Q(1,AB) = index among qualified, symmetry reduced.
C     iShP2Q(2,AB) = symmetry block.
C     Zeros are returned if the element AB is not qualified.
C     -------------------------------------------------------

      Call Cho_iZero(iWork(ip_iShP2Q),lTst)
      Call Cho_iZero(nAB,nSym)

      Do iSym = 1,nSym
         Do iQ = 1,nQual(iSym)
            iAB = iQuAB(iQ,iSym) ! addr in curr. red. set
            jAB = IndRed(iAB,iLoc)  ! addr in 1st red. set
            kShlAB = IndRSh(jAB)  ! shell pair (full)
            If (kShlAB .eq. iSP2F(iShlAB)) Then
               kAB = IndRed(jAB,1) ! addr in full shell pair
               iWork(ip_iShP2Q+2*(kAB-1))   = iQ
               iWork(ip_iShP2Q+2*(kAB-1)+1) = iSym
               nAB(iSym) = nAB(iSym) + 1
            End If
         End Do
      End Do

C     Set return code 0: all ok!
C     --------------------------

      irc = 0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996,1999, Niclas Forsberg                             *
!               1996,1999, Anders Bernhardsson                         *
!***********************************************************************

!module PotKin

!  Contains:
!    PotEnergy      (A,nMat,energy,grad,Hess,D3,D4,max_term)
!    KinEnergy      (A,nMat,G,Gprime,Gdbleprime,max_term)
!
!  Written by:
!    Niclas Forsberg & Anders Bernhardsson,
!    Dept. of Theoretical Chemistry, Lund University, 1996.
!    Dept. of Theoretical Chemistry, Lund University, 1999.

!contains

subroutine PotEnergy(A,nMat,iCre,iAnn,energy,grad,Hess,D3,D4,max_term,W,max_Ord,nOsc,nOscOld)
!  Purpose:
!    Calculate matrix elements of potential energy terms.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use mula_global, only: ndim1, ndim2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nMat(0:ndim1,ndim2), iAnn(0:ndim1,ndim2), iCre(0:ndim1,ndim2), max_term, max_Ord, nOsc, nOscOld
real(kind=wp), intent(out) :: A(0:max_Ord,0:max_Ord)
real(kind=wp), intent(in) :: energy, grad(nOscOld), Hess(nOscOld,nOscOld), D3(nOscOld,nOscOld,nOscOld), &
                             D4(nOscOld,nOscOld,nOscOld,nOscOld), W(nOscOld,nOsc)
integer(kind=iwp) :: i
real(kind=wp) :: rdx(4)
real(kind=wp), allocatable :: D3_2(:,:,:), D4_2(:,:,:,:), grad_2(:), Hess_2(:,:), Temp(:)

! Zeroth order term.
do i=0,max_Ord
  A(i,i) = Energy
end do
rdx(1) = One
rdx(2) = One
rdx(3) = One
rdx(4) = One
call mma_allocate(Temp,nOscOld**4,label='Temp')

! First order terms.
if (max_term > 0) then
  call mma_allocate(grad_2,nOsc,label='grad_2')
  call DGEMM_('T','N',1,nOsc,nOscOld,One,grad,nOscOld,W,nOscOld,Zero,grad_2,1)
  call Mul1(nMat,A,icre,iann,grad_2,max_Ord,nOsc,rdx)
  call mma_deallocate(grad_2)
end if

! Second order terms.
if (max_term > 1) then
  call mma_allocate(Hess_2,nOsc,nOsc,label='Hess_2')
  call DGEMM_('T','N',nOscOld,nOsc,nOscOld,One,Hess,nOscOld,W,nOscOld,Zero,Temp,nOscOld)
  call DGEMM_('T','N',nOsc,nOsc,nOscOld,One,Temp,nOscOld,W,nOscOld,Zero,Hess_2,nOsc)
  call Mul2(nMat,A,icre,iann,Hess_2,max_Ord,nOsc,rdx)
  call mma_deallocate(Hess_2)
end if

! Third order terms.
if (max_term > 2) then
  call mma_allocate(D3_2,nOsc,nOsc,nOsc,label='D3_2')
  call DGEMM_('T','N',nOscOld**2,nOsc,nOscOld,One,D3,nOscOld,W,nOscOld,Zero,Temp,nOscOld**2)
  call DGEMM_('T','N',nOsc*nOscOld,nOsc,nOscOld,One,Temp,nOscOld,W,nOscOld,Zero,D3_2,nOsc*nOscOld)
  call DGEMM_('T','N',nOsc**2,nOsc,nOscOld,One,D3_2,nOscOld,W,nOscOld,Zero,Temp,nOsc**2)
  call dcopy_(nOsc**3,Temp,1,D3_2,1)
  call Mul3(nMat,A,icre,iann,D3_2,max_Ord,nOsc,rdx)
  call mma_deallocate(D3_2)
end if

! Fourth order terms.
if (max_term > 3) then
  call mma_allocate(D4_2,nOsc,nOsc,nOsc,nOsc,label='D4_2')
  call DGEMM_('T','N',nOscOld**3,nOsc,nOscOld,One,D4,nOscOld,W,nOscOld,Zero,Temp,nOscOld**3)
  call DGEMM_('T','N',nOsc*nOscOld**2,nOsc,nOscOld,One,Temp,nOscOld,W,nOscOld,Zero,D4_2,nOsc*nOscOld**2)
  call DGEMM_('T','N',nOsc**2*nOscOld,nOsc,nOscOld,One,D4_2,nOscOld,W,nOscOld,Zero,Temp,nOsc**2*nOscOld)
  call DGEMM_('T','N',nOsc**3,nOsc,nOscOld,One,Temp,nOscOld,W,nOscOld,Zero,D4_2,nOsc**3)
  call Mul4(nMat,A,icre,iann,D4_2,max_Ord,nOsc,rdx)
  call mma_deallocate(D4_2)
end if

call mma_deallocate(Temp)

end subroutine PotEnergy

subroutine KinEnergy(A,nMat,iCre,iAnn,G,Gprime,Gdbleprime,max_term,C,W,alpha1,alpha2,beta,r_diff,max_Ord,nOsc,nOscOld)
! Out : A
! In  :
!      Real G,Gprime,Gdbleprime,W,C,alpha1,alpha2,beta,r_diff
!      integer nMat,iCre,iAnn,max_term
!
!  Purpose:
!    Calculate matrix elements of kinetic energy terms.
!
!  Written by:
!    Niclas Forsberg,Anders Bernhardsson
!    Dept. of Theoretical Chemistry, Lund University, 1996.
!    Dept. of Theoretical Chemistry, Lund University, 1999.

use mula_global, only: ndim1, ndim2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Six, Half, OneHalf
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nMat(0:ndim1,ndim2), iCre(0:ndim1,ndim2), iAnn(0:ndim1,ndim2), max_term, max_Ord, nOsc, nOscOld
real(kind=wp), intent(out) :: A(0:max_Ord,0:max_Ord)
real(kind=wp), intent(in) :: G(nOsc,nOsc), Gprime(nOsc,nOsc,nOsc), Gdbleprime(nOsc,nOsc,nOsc,nOsc), C(nOsc,nOsc), W(nOsc,nOsc), &
                             alpha1(nOsc,nOsc), alpha2(nOsc,nOsc), beta(nOsc,nOsc), r_diff(nOscOld)
integer(kind=iwp) :: i, j, k, l, nOscSqr
real(kind=wp) :: alpha_norm, r, r_norm, ran, rdx(4)
real(kind=wp), allocatable :: G_2(:,:), r_temp(:), T1(:), T2(:), Temp(:,:), Temp1(:,:,:), Temp2(:,:,:), Temp3(:,:,:,:), &
                              Temp4(:,:,:,:), Tempa(:,:), Tempb(:,:)
real(kind=wp), parameter :: Thrs = 1.0e-15_wp
real(kind=r8), external :: Ddot_, Dnrm2_

! Initialize.
call mma_allocate(Temp,nOsc,nOsc,label='Temp')
call mma_allocate(Tempa,nOsc,nOsc,label='Tempa')
call mma_allocate(Tempb,nOsc,nOsc,label='Tempb')
call mma_allocate(Temp1,nOsc,nOsc,nOsc,label='Temp1')
call mma_allocate(Temp2,nOsc,nOsc,nOsc,label='Temp2')
call mma_allocate(Temp3,nOsc,nOsc,nOsc,nOsc,label='Temp3')
call mma_allocate(Temp4,nOsc,nOsc,nOsc,nOsc,label='Temp4')
call mma_allocate(r_temp,nOsc,label='r_temp')
call mma_allocate(G_2,nOsc,nOsc,label='G_2')
call mma_allocate(T1,nOsc,label='T1')
call mma_allocate(T2,nOsc,label='T2')
nOscSqr = nOsc**2
r_norm = Dnrm2_(nOsc,r_diff,1)
ran = One
call Dgesub(alpha1,nOsc,'N',alpha2,nOsc,'N',Tempa,nOsc,nOsc,nOsc)
alpha_norm = Dnrm2_(nOscSqr,Tempa,1)
if ((r_norm > Thrs) .or. (alpha_norm > Thrs)) then
  call Dgesub(alpha1,nOsc,'N',alpha2,nOsc,'N',Tempa,nOsc,nOsc,nOsc)
  call DGEMM_('N','N',nOsc,nOsc,nOsc,One,Tempa,nOsc,W,nOsc,Zero,Tempb,nOsc)
  call DGEMM_('N','N',nOsc,1,nOsc,-Two,beta,nOsc,r_diff,nOsc,Zero,r_temp,nOsc)
  rdx(1) = One
  rdx(2) = -One
  call DGEMM_('T','N',nosc,nosc,nosc,One,G,nosc,Tempb,nosc,Zero,Temp,nosc)
  call DGEMM_('T','T',nosc,nosc,nosc,-ran,Temp,nosc,C,nosc,Zero,G_2,nosc)
  call Mul2(nmat,A,iCre,iAnn,G_2,max_ord,nosc,rdx)
  rdx(1) = -One
  rdx(2) = One
  call DGEMM_('T','T',nosc,nosc,nosc,One,G,nosc,C,nosc,Zero,Temp,nosc)
  call DGEMM_('T','N',nosc,nosc,nosc,-ran,Temp,nosc,Tempb,nosc,Zero,G_2,nosc)
  call Mul2(nmat,A,iCre,iAnn,G_2,max_ord,nosc,rdx)
  rdx(1) = One
  rdx(2) = One
  call DGEMM_('T','N',nosc,nosc,nosc,One,G,nosc,Tempb,nosc,Zero,Temp,nosc)
  call DGEMM_('T','N',nosc,nosc,nosc,-One,Temp,nosc,Tempb,nosc,Zero,G_2,nosc)
  call Mul2(nmat,A,iCre,iAnn,G_2,max_ord,nosc,rdx)
  call dGeMV_('N',nosc,nosc,One,G,nosc,r_temp,1,Zero,T1,1)
  call dGeMV_('T',nosc,nosc,One,G,nosc,r_temp,1,One,T1,1)
  call dGeMV_('N',nosc,nosc,-Half*ran,C,nosc,T1,1,Zero,T2,1)
  rdx(1) = -One
  call Mul1(nmat,A,iCre,iAnn,T2,max_ord,nosc,rdx)
  call dGeMV_('N',nosc,nosc,One,G,nosc,r_temp,1,Zero,T1,1)
  call dGeMV_('T',nosc,nosc,One,G,nosc,r_temp,1,One,T1,1)
  call dGeMV_('T',nosc,nosc,-Half,tempb,nosc,T1,1,Zero,T2,1)
  rdx(1) = One
  call Mul1(nmat,A,iCre,iAnn,T2,max_ord,nosc,rdx)
  call dGeMV_('N',nosc,nosc,One,G,nosc,r_temp,1,Zero,T1,1)
  r = Ddot_(nosc,T1,1,r_temp,1)
  do i=0,max_Ord
    A(i,i) = A(i,i)-Half*r
  end do
  if (max_term > 2) then
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Gprime,nosc,tempb,nosc,Zero,Temp1,nosc**2)
    call DGEMM_('T','T',nosc**2,nosc,nosc,One,Temp1,nosc,C,nosc,Zero,Temp2,nosc**2)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp2,nosc,W,nosc,Zero,Temp1,nosc**2)
    rdx(1) = One
    rdx(2) = One
    rdx(3) = -One
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          Temp2(i,k,j) = -Three*ran*Temp1(i,j,k)
        end do
      end do
    end do
    call Mul3(nmat,A,iCre,iAnn,Temp2,max_ord,nosc,rdx)
    call DGEMM_('T','T',nosc**2,nosc,nosc,One,Gprime,nosc,C,nosc,Zero,Temp1,nosc**2)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp1,nosc,Tempb,nosc,Zero,Temp2,nosc**2)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp2,nosc,W,nosc,Zero,Temp1,nosc**2)
    rdx(1) = -One
    rdx(2) = One
    rdx(3) = One
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          Temp2(i,k,j) = -Three*ran*Temp1(i,j,k)
        end do
      end do
    end do
    call Mul3(nmat,A,iCre,iAnn,Temp2,max_ord,nosc,rdx)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Gprime,nosc,Tempb,nosc,Zero,Temp1,nosc**2)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp1,nosc,Tempb,nosc,Zero,Temp2,nosc**2)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp2,nosc,W,nosc,Zero,Temp1,nosc**2)
    rdx(1) = One
    rdx(2) = One
    rdx(3) = One
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          Temp2(i,k,j) = -Three*Temp1(i,j,k)
        end do
      end do
    end do
    call Mul3(nmat,A,iCre,iAnn,Temp2,max_ord,nosc,rdx)

    Temp(:,:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          Temp(k,j) = Temp(k,j)-ran*Gprime(i,j,k)*r_temp(i)
        end do
      end do
    end do
    rdx(1) = One
    rdx(2) = -One
    call DGEMM_('T','N',nosc,nosc,nosc,One,Temp,nosc,W,nosc,Zero,G_2,nosc)
    call DGEMM_('T','T',nosc,nosc,nosc,One,G_2,nosc,C,nosc,Zero,Temp,nosc)
    call Mul2(nmat,A,iCre,iAnn,Temp,max_ord,nosc,rdx)

    Temp(:,:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          Temp(k,j) = Temp(k,j)-Gprime(i,j,k)*r_temp(i)
        end do
      end do
    end do
    rdx(1) = One
    rdx(2) = One
    call DGEMM_('T','N',nosc,nosc,nosc,One,Temp,nosc,W,nosc,Zero,G_2,nosc)
    call DGEMM_('T','N',nosc,nosc,nosc,One,G_2,nosc,Tempb,nosc,Zero,Temp,nosc)
    call Mul2(nmat,A,iCre,iAnn,Temp,max_ord,nosc,rdx)

    Temp(:,:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          Temp(i,k) = Temp(i,k)-ran*Gprime(i,j,k)*r_temp(j)
        end do
      end do
    end do
    rdx(1) = -One
    rdx(2) = One
    call DGEMM_('T','T',nosc,nosc,nosc,One,Temp,nosc,C,nosc,Zero,G_2,nosc)
    call DGEMM_('T','N',nosc,nosc,nosc,One,G_2,nosc,W,nosc,Zero,Temp,nosc)
    call Mul2(nmat,A,iCre,iAnn,Temp,max_ord,nosc,rdx)

    Temp(:,:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          Temp(i,k) = Temp(i,k)-Gprime(i,j,k)*r_temp(j) !!
        end do
      end do
    end do
    rdx(1) = One
    rdx(2) = One
    call DGEMM_('T','n',nosc,nosc,nosc,One,Temp,nosc,Tempb,nosc,Zero,G_2,nosc)
    call DGEMM_('T','n',nosc,nosc,nosc,One,G_2,nosc,W,nosc,Zero,Temp,nosc)
    call Mul2(nmat,A,iCre,iAnn,Temp,max_ord,nosc,rdx)

    t1(:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          T1(k) = -Half*Gprime(i,j,k)*r_temp(i)*r_temp(j)+t1(k)
        end do
      end do
    end do
    call DGEMM_('T','n',1,nosc,nosc,One,T1,nosc,W,nosc,Zero,T2,1)
    rdx(1) = One
    call Mul1(nmat,A,iCre,iAnn,T2,max_ord,nosc,rdx)
  end if
  if (max_term > 3) then
    call DGEMM_('T','N',nosc**3,nosc,nosc,One,Gdbleprime,nosc,tempb,nosc,Zero,Temp3,nosc**3)
    call DGEMM_('T','T',nosc**3,nosc,nosc,One,Temp3,nosc,C,nosc,Zero,Temp4,nosc**3)
    call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp4,nosc,W,nosc,Zero,Temp3,nosc**3)
    call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp3,nosc,W,nosc,Zero,Temp4,nosc**3)
    rdx(1) = One
    rdx(2) = One
    rdx(3) = One
    rdx(4) = -One
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          do l=1,nosc
            Temp3(i,k,l,j) = -ran*Six*Temp4(i,j,k,l)
          end do
        end do
      end do
    end do
    call Mul4(nmat,A,iCre,iAnn,Temp3,max_ord,nosc,rdx)
    call DGEMM_('T','T',nosc**3,nosc,nosc,One,Gdbleprime,nosc,C,nosc,Zero,Temp3,nosc**3)
    call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp3,nosc,Tempb,nosc,Zero,Temp4,nosc**3)
    call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp4,nosc,W,nosc,Zero,Temp3,nosc**3)
    call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp3,nosc,W,nosc,Zero,Temp4,nosc**3)
    rdx(1) = -One
    rdx(2) = One
    rdx(3) = One
    rdx(4) = One
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          do l=1,nosc
            Temp3(i,k,l,j) = -ran*Six*Temp4(i,j,k,l)
          end do
        end do
      end do
    end do
    call Mul4(nmat,A,iCre,iAnn,Temp3,max_ord,nosc,rdx)
    call DGEMM_('T','n',nosc**3,nosc,nosc,One,Gdbleprime,nosc,Tempb,nosc,Zero,Temp3,nosc**3)
    call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp3,nosc,Tempb,nosc,Zero,Temp4,nosc**3)
    call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp4,nosc,W,nosc,Zero,Temp3,nosc**3)
    call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp3,nosc,W,nosc,Zero,Temp4,nosc**3)
    rdx(1) = One
    rdx(2) = One
    rdx(3) = One
    rdx(4) = One
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          do l=1,nosc
            Temp3(i,k,l,j) = -Six*Temp4(i,j,k,l)
          end do
        end do
      end do
    end do
    call Mul4(nmat,A,iCre,iAnn,Temp3,max_ord,nosc,rdx)

    Temp1(:,:,:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          do l=1,nosc
            Temp1(k,l,j) = Temp1(k,l,j)-ran*OneHalf*Gdbleprime(i,j,k,l)*r_temp(i)
          end do
        end do
      end do
    end do
    rdx(1) = One
    rdx(2) = One
    rdx(3) = -One
    call DGEMM_('T','n',nosc**2,nosc,nosc,One,Temp1,nosc,W,nosc,Zero,Temp2,nosc**2)
    call DGEMM_('T','n',nosc**2,nosc,nosc,One,Temp2,nosc,W,nosc,Zero,Temp1,nosc**2)
    call DGEMM_('T','T',nosc**2,nosc,nosc,One,Temp1,nosc,C,nosc,Zero,Temp2,nosc**2)
    call Mul3(nmat,A,iCre,iAnn,Temp2,max_ord,nosc,rdx)
    Temp1(:,:,:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          do l=1,nosc
            Temp1(k,l,j) = Temp1(k,l,j)-OneHalf*Gdbleprime(i,j,k,l)*r_temp(i)
          end do
        end do
      end do
    end do
    rdx(1) = One
    rdx(2) = One
    rdx(3) = One
    call DGEMM_('T','n',nosc**2,nosc,nosc,One,Temp1,nosc,W,nosc,Zero,Temp2,nosc**2)
    call DGEMM_('T','n',nosc**2,nosc,nosc,One,Temp2,nosc,W,nosc,Zero,Temp1,nosc**2)
    call DGEMM_('T','n',nosc**2,nosc,nosc,One,Temp1,nosc,Tempb,nosc,Zero,Temp2,nosc**2)
    call Mul3(nmat,A,iCre,iAnn,Temp2,max_ord,nosc,rdx)

    Temp1(:,:,:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          do l=1,nosc
            Temp1(i,k,l) = Temp1(i,k,l)-ran*OneHalf*Gdbleprime(i,j,k,l)*r_temp(j)
          end do
        end do
      end do
    end do
    rdx(1) = -One
    rdx(2) = One
    rdx(3) = One
    call DGEMM_('T','T',nosc**2,nosc,nosc,One,Temp1,nosc,C,nosc,Zero,Temp2,nosc**2)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp2,nosc,W,nosc,Zero,Temp1,nosc**2)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp1,nosc,W,nosc,Zero,Temp2,nosc**2)
    call Mul3(nmat,A,iCre,iAnn,Temp2,max_ord,nosc,rdx)

    Temp1(:,:,:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          do l=1,nosc
            Temp1(i,k,l) = Temp1(i,k,l)-OneHalf*Gdbleprime(i,j,k,l)*r_temp(j)
          end do
        end do
      end do
    end do
    rdx(1) = One
    rdx(2) = One
    rdx(3) = One
    call DGEMM_('T','n',nosc**2,nosc,nosc,One,Temp1,nosc,Tempb,nosc,Zero,Temp2,nosc**2)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp2,nosc,W,nosc,Zero,Temp1,nosc**2)
    call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp1,nosc,W,nosc,Zero,Temp2,nosc**2)
    call Mul3(nmat,A,iCre,iAnn,Temp2,max_ord,nosc,rdx)

    rdx(1) = One
    rdx(2) = One
    Temp(:,:) = Zero
    do i=1,nosc
      do j=1,nosc
        do k=1,nosc
          do l=1,nosc
            Temp(k,l) = Temp(k,l)-Half*Gdbleprime(i,j,k,l)*r_temp(i)*r_temp(j)
          end do
        end do
      end do
    end do
    call DGEMM_('T','N',nosc,nosc,nosc,One,Temp,nosc,W,nosc,Zero,G_2,nosc)
    call DGEMM_('T','N',nosc,nosc,nosc,One,G_2,nosc,W,nosc,Zero,Temp,nosc)
    call Mul2(nmat,A,iCre,iAnn,Temp,max_ord,nosc,rdx)
  end if
end if

call mma_deallocate(Tempa)
call mma_deallocate(Tempb)
call mma_deallocate(r_temp)
call mma_deallocate(T1)
call mma_deallocate(T2)

! If higher terms than quadratic are used in the polynomial
! fit of the potential surface, then we have to use a
! Taylor expansion of the inverse mass tensor.
rdx(1) = -One
rdx(2) = -One
call DGEMM_('T','T',nosc,nosc,nosc,One,G,nosc,C,nosc,Zero,Temp,nosc)
call DGEMM_('T','T',nosc,nosc,nosc,-One,Temp,nosc,C,nosc,Zero,G_2,nosc)
call Mul2(nmat,A,iCre,iAnn,G_2,max_ord,nosc,rdx)
if (max_term > 2) then
  call DGEMM_('T','T',nosc**2,nosc,nosc,One,Gprime,nosc,C,nosc,Zero,Temp1,nosc**2)
  call DGEMM_('T','T',nosc**2,nosc,nosc,One,Temp1,nosc,C,nosc,Zero,Temp2,nosc**2)
  call DGEMM_('T','N',nosc**2,nosc,nosc,One,Temp2,nosc,W,nosc,Zero,Temp1,nosc**2)
  rdx(1) = -One
  rdx(2) = One
  rdx(3) = -One
  do i=1,nosc
    do j=1,nosc
      do k=1,nosc
        Temp2(i,k,j) = -Three*Temp1(i,j,k)
      end do
    end do
  end do
  call Mul3(nmat,A,iCre,iAnn,Temp2,max_ord,nosc,rdx)
end if
if (max_term > 3) then
  call DGEMM_('T','T',nosc**3,nosc,nosc,One,Gdbleprime,nosc,C,nosc,Zero,Temp3,nosc**3)
  call DGEMM_('T','T',nosc**3,nosc,nosc,One,Temp3,nosc,C,nosc,Zero,Temp4,nosc**3)
  call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp4,nosc,W,nosc,Zero,Temp3,nosc**3)
  call DGEMM_('T','N',nosc**3,nosc,nosc,One,Temp3,nosc,W,nosc,Zero,Temp4,nosc**3)

  rdx(1) = -One
  rdx(2) = One
  rdx(3) = One
  rdx(4) = -One
  do i=1,nosc
    do j=1,nosc
      do k=1,nosc
        do l=1,nosc
          Temp3(i,k,l,j) = -Six*Temp4(i,j,k,l)
        end do
      end do
    end do
  end do
  call Mul4(nmat,A,iCre,iAnn,Temp3,max_ord,nosc,rdx)
end if

call mma_deallocate(Temp)
call mma_deallocate(Temp1)
call mma_deallocate(Temp2)
call mma_deallocate(Temp3)
call mma_deallocate(Temp4)
call mma_deallocate(G_2)

end subroutine KinEnergy

!end module PotKin

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine checkMem(NvGrp,NvSGrp,NchBlk,Jal1,Jal2,wrksize,maxdim)
! Check memory consumption according to the specified
! orbital segmentation

use chcc_global, only: PosFree
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NvGrp, NvSGrp, NchBlk
integer(kind=iwp), intent(out) :: Jal1, Jal2, wrksize, maxdim
integer(kind=iwp) :: Jal3, mdGrpa, mdGrpbe, mdSGrpa, mdSGrpbe, PosH1, PosH2, PosH3, PosH4, PosH5, PosK, PosL11, PosL12, PosM1, &
                     PosM2, PosM3, PosM4, PosM5, PosMax, PosQ, PosT, PosV1, PosV2, PosV3, PosV4

!2 Distribute memory (and redefine wrksize)

!*.1 Distribute Permanent arrays

PosT = 1
call DistMemPerm(PosT)
PosMax = PosT

!*.2 Distribute Work arrays for Reord

call DefParReord(NvGrp,maxdim)
! also
call DefParo2v4(NvGrp,NvGrp,NvSGrp,NvSGrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
PosT = PosFree
call DistMemReord(maxdim,mdSGrpa,NchBlk,PosV1,PosV2,PosV3,PosV4,PosM1,PosM2,PosT)
if (PosT > PosMax) PosMax = PosT

!*.3 Distribute Work arrays for o3v3

call DefParo3v3(NvGrp,maxdim)

PosT = PosFree
call DistMemo3v3jk(maxdim,PosV1,PosV2,PosV3,PosV4,PosH1,PosH2,PosH3,PosH4,PosH5,PosK,PosQ,PosT)
if (PosT > PosMax) PosMax = PosT

PosT = PosFree
call DistMemo3v3t2(maxdim,PosV1,PosV2,PosV3,PosV4,PosH1,PosH2,PosH3,PosH4,PosK,PosQ,PosT)
if (PosT > PosMax) PosMax = PosT

PosT = PosFree
call DistMemo3v3chol(maxdim,PosV1,PosV2,PosV3,PosV4,PosH1,PosH2,PosH3,PosH4,PosM1,PosM2,PosM3,PosM4,PosM5,PosK,PosQ,PosT)
if (PosT > PosMax) PosMax = PosT

!*.4 Distribute Work arrays for o2v4

call DefParo2v4(NvGrp,NvGrp,NvSGrp,NvSGrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
PosT = PosFree
! Nazvy premennych tu davam ine, lebo ide len o vypocet narokov na Mem
call DistMemo2v4(NvGrp,NvGrp,NvSGrp,NvSGrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,PosV1,PosV2,PosV3,PosV4,PosL11,PosL12,PosH1,PosH2, &
                 PosH3,PosH4,PosQ,Jal1,Jal2,PosM1,PosM2,PosM3,PosM4,PosM5,Jal3,PosT,PosK)
if (PosT > PosMax) PosMax = PosT

!*.5 Memory requirements for Summary step are upperbounded by o3v3
!    and also o2v4, this it is skipped

wrksize = PosMax

return

end subroutine checkMem

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine SetMltplCenters()
! Thomas Bondo Pedersen, July 2012.
!
! Set multipole centers.

use MpmC, only: Coor_MPM
use Sizes_of_Seward, only: S
use Gateway_Info, only: CoM
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i

! Check
if (S%nMltpl < 0) then
  call WarningMessage(2,'SetMltplCenters: illegal input')
  write(u6,'(A,I10)') 'S%nMltpl=',S%nMltpl
  call Abend()
end if

! Allocate center array
call mma_allocate(Coor_MPM,[1,3],[0,S%nMltpl],label='Coor_MPM')
! Set origin as center for overlap (0th order)
Coor_MPM(:,:) = Zero

! center of mass as center for higher-order multipoles
if (S%nMltpl > 0) then
  do i=1,S%nMltpl
    Coor_MPM(:,i) = CoM(:)
  end do
end if

end subroutine SetMltplCenters

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine io_init_cvb()

use casvb_global, only: idan, iorder, mxfiles, nrec, thresh_io, recn_jobiph, recn_jobold, recn_oneint, recn_tmp01, recn_tmp02, &
                        recn_tmp03, recn_tmp04, recn_vbwfn
use Definitions, only: wp

implicit none

nrec = 0
thresh_io = 1.0e-5_wp
iorder(:) = 0
call istkinit_cvb(idan,mxfiles)

! Preassign some file names to identifiers:
call setfn_cvb(recn_jobold,'JOBOLD')
call setfn_cvb(recn_jobiph,'JOBIPH')
call setfn_cvb(recn_oneint,'ONEINT')
call setfn_cvb(recn_vbwfn,'VBWFN')
call setfn_cvb(recn_tmp01,'TMP01')
call setfn_cvb(recn_tmp02,'TMP02')
call setfn_cvb(recn_tmp03,'TMP03')
call setfn_cvb(recn_tmp04,'TMP04')

return

end subroutine io_init_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine axesx_cvb(asonc,ddres2upd,vec,
     >  resthr_inp,ioptc,iter,fx_exp)
c  *********************************************************************
c  *                                                                   *
c  *  DIRDIAG front-end for solving  A x = E S x .                     *
c  *                                                                   *
c  *********************************************************************
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "direct_cvb.fh"
      external asonc,ddres2upd

      dimension vec(*)

      call axesx2_cvb(asonc,ddres2upd,vec,
     >  resthr_inp,ioptc,iter,fx_exp,
     >  work(idd(1)),work(idd(2)),work(idd(3)),.false.,work(idd(4)),
     >  work(idd(5)),work(idd(6)),work(idd(7)))
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE WRTTTS(  BLOCKS,  IBLOCK,  NBLOCK,   NSMST,
     &                    NSASO,   NSBSO,     ISC)
*
* Print a batch of TTS blocks as given by IBLOCK
*
*
* ISC = 1 : In slater determinant form
* ISC = 2 : In Combination        form
*
*. Jeppe Olsen, August 1995
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
      DIMENSION NSASO(NSMST,*),NSBSO(NSMST,*)
*.
      DIMENSION BLOCKS(*)
      INTEGER IBLOCK(8,NBLOCK)
*
*
      WRITE(6,*) '  Batch of blocks '
      WRITE(6,*) ' ================= '
      WRITE(6,*)
      WRITE(6,'(A,I4)') ' Number of blocks in batch ', NBLOCK
*
      DO JBLOCK = 1, NBLOCK
*
        IATP = IBLOCK(1, JBLOCK)
        IBTP = IBLOCK(2, JBLOCK)
        IASM = IBLOCK(3, JBLOCK)
        IBSM = IBLOCK(4, JBLOCK)
        IF(IBLOCK(1,JBLOCK).GT.0) THEN
*
        IF (ISC.EQ.1 ) THEN
          IOFF = IBLOCK(5,JBLOCK)
        ELSE
          IOFF = IBLOCK(6,JBLOCK)
        END IF
*
*. Is this block diagonal
        IF(ISC.EQ.2.AND.IASM.EQ.IBSM.AND.IATP.EQ.IBTP) THEN
          IPACK = 1
        ELSE
          IPACK = 0
        END IF
        NIA = NSASO(IASM,IATP)
        NIB = NSBSO(IBSM,IBTP)
C?      write(6,*) ' iatp ibtp iasm ibsm nia nib ',
C?   &  iatp,ibtp,iasm,ibsm,nia,nib
*
        IF(IPACK.EQ.1) THEN
          NELMNT = NIA*(NIA+1)/2
          IF(NELMNT.NE.0) THEN
            WRITE(6,'(A,3I3)')
     &      '  Iasm iatp ibtp : ', IASM,IATP,IBTP
            WRITE(6,'(A)')
     &      '  ============================'
            CALL PRSM2(BLOCKS(IOFF) ,NIA)
          END IF
        ELSE
          NELMNT = NIA*NIB
          IF(NELMNT.NE.0) THEN
            WRITE(6,'(A,3I3)')
     &      '  Iasm iatp ibtp : ', IASM,IATP,IBTP
            WRITE(6,'(A)')
     &      '  ============================'
            CALL WRTMAT(BLOCKS(IOFF) ,NIA,NIB,NIA,NIB)
          END IF
        END IF
*
        END IF
      END DO
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine tql2(nm,n,d,e,z,ierr)
! this subroutine is a translation of the algol procedure tql2,
! num. math. 11, 293-306(1968) by bowdler, martin, reinsch, and
! wilkinson.
! handbook for auto. comp., vol.ii-linear algebra, 227-240(1971).
!
! this subroutine finds the eigenvalues and eigenvectors
! of a symmetric tridiagonal matrix by the ql method.
! the eigenvectors of a full symmetric matrix can also
! be found if  tred2  has been used to reduce this
! full matrix to tridiagonal form.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.
!
!    n is the order of the matrix.
!
!    d contains the diagonal elements of the input matrix.
!
!    e contains the subdiagonal elements of the input matrix
!      in its last n-1 positions.  e(1) is arbitrary.
!
!    z contains the transformation matrix produced in the
!      reduction by  tred2, if performed.  if the eigenvectors
!      of the tridiagonal matrix are desired, z must contain
!      the identity matrix.
!
!  on output
!
!    d contains the eigenvalues in ascending order.  if an
!      error exit is made, the eigenvalues are correct but
!      unordered for indices 1,2,...,ierr-1.
!
!    e has been destroyed.
!
!    z contains orthonormal eigenvectors of the symmetric
!      tridiagonal (or full) matrix.  if an error exit is made,
!      z contains the eigenvectors associated with the stored
!      eigenvalues.
!
!    ierr is set to
!      zero       for normal return,
!      j          if the j-th eigenvalue has not been
!                 determined after 30 iterations.
!
! calls pythag for  sqrt(a*a + b*b) .
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n
real(kind=wp), intent(inout) :: d(n), e(n), z(nm,n)
integer(kind=iwp), intent(out) :: ierr
integer(kind=iwp) :: i, ii, j, k, l, l1, l2, m, mml
real(kind=wp) :: c, c2, c3, dl1, el1, f, g, h, p, r, s, s2, tst1, tst2
real(kind=wp), external :: pythag

ierr = 0
c3 = Zero ! dummy initialize
s2 = Zero ! dummy initialize
if (n == 1) return

e(1:n-1) = e(2:)

f = Zero
tst1 = Zero
e(n) = Zero

do l=1,n
  j = 0
  h = abs(d(l))+abs(e(l))
  if (tst1 < h) tst1 = h
  ! .......... look for small sub-diagonal element ..........
  do m=l,n
    tst2 = tst1+abs(e(m))
    if (tst2 == tst1) exit
    ! .......... e(n) is always zero, so there is no exit through the bottom of the loop ..........
  end do

  if (m /= l) then
    do
      if (j == 30) then
        ! .......... set error -- no convergence to an eigenvalue after 30 iterations ..........
        ierr = l
        return
      end if
      j = j+1
      ! .......... form shift ..........
      l1 = l+1
      l2 = l1+1
      g = d(l)
      p = (d(l1)-g)/(Two*e(l))
      r = pythag(p,One)
      d(l) = e(l)/(p+sign(r,p))
      d(l1) = e(l)*(p+sign(r,p))
      dl1 = d(l1)
      h = g-d(l)

      d(l2:) = d(l2:)-h

      f = f+h
      ! .......... ql transformation ..........
      p = d(m)
      c = One
      c2 = c
      el1 = e(l1)
      s = Zero
      mml = m-l
      ! .......... for i=m-1 step -1 until l do -- ..........
      do ii=1,mml
        c3 = c2
        c2 = c
        s2 = s
        i = m-ii
        g = c*e(i)
        h = c*p
        r = pythag(p,e(i))
        e(i+1) = s*r
        s = e(i)/r
        c = p/r
        p = c*d(i)-s*g
        d(i+1) = h+s*(c*g+s*d(i))
        ! .......... form vector ..........
        do k=1,n
          h = z(k,i+1)
          z(k,i+1) = s*z(k,i)+c*h
          z(k,i) = c*z(k,i)-s*h
        end do

      end do

      p = -s*s2*c3*el1*e(l)/dl1
      e(l) = s*p
      d(l) = c*p
      tst2 = tst1+abs(e(l))
      if (tst2 <= tst1) exit
    end do
  end if
  d(l) = d(l)+f
end do
! .......... order eigenvalues and eigenvectors ..........
do ii=2,n
  i = ii-1
  k = i
  p = d(i)

  do j=ii,n
    if (d(j) >= p) cycle
    k = j
    p = d(j)
  end do

  if (k == i) cycle
  d(k) = d(i)
  d(i) = p

  do j=1,n
    p = z(j,i)
    z(j,i) = z(j,k)
    z(j,k) = p
  end do

end do

return

end subroutine tql2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine fraginp_cvb()

use casvb_global, only: confsinp, i2s_fr, nalf_fr, nbet_fr, nconf, nconf_fr, nel_fr, nfrag, nMs_fr, noe, nS_fr
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxINT
use Constants, only: One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: istr, istr2, mavaili, mxconf, nread
real(kind=wp) :: dum(1), Scurr
integer(kind=iwp), allocatable :: tmp(:,:)
integer(kind=iwp), parameter :: ncmp = 4, nstrin = 2
character(len=*), parameter :: string(nstrin) = ['WAVE    ','CON     ']

do
  call fstring_cvb(string,nstrin,istr,ncmp,2)
  if (istr == 1) then
    ! 'WAVE'
    nfrag = nfrag+1
    nel_fr(nfrag) = 0
    call int_cvb(nel_fr(nfrag),1,nread,1)
    nMs_fr(nfrag) = 0
    nS_fr(nfrag) = 0
    nalf_fr(1,nfrag) = 0
    nbet_fr(1,nfrag) = 0
    i2s_fr(1,nfrag) = -1
    do
      Scurr = -One
      call real_cvb(dum,1,nread,1)
      Scurr = dum(1)
      if (Scurr == -One) exit
      nS_fr(nfrag) = nS_fr(nfrag)+1
      i2s_fr(nS_fr(nfrag),nfrag) = nint(Two*Scurr)
    end do
  else if (istr == 2) then
    ! 'CON'
    if (nfrag == 0) then
      nfrag = 1
      nel_fr(nfrag) = 0
      nMs_fr(nfrag) = 0
      nS_fr(nfrag) = 0
      nalf_fr(1,nfrag) = 0
      nbet_fr(1,nfrag) = 0
      i2s_fr(1,nfrag) = -1
    end if

    call mma_maxINT(mavaili)
    mxconf = max(mavaili/2,0)/noe
    call mma_allocate(tmp,noe,mxconf,label='confsinp')
    if (allocated(confsinp)) then
      tmp(:,1:size(confsinp,2)) = confsinp(:,:)
      call mma_deallocate(confsinp)
    end if
    call move_alloc(tmp,confsinp)
    nconf_fr(nfrag) = 1
    nconf = nconf+1
    do
      if (mxconf < nconf) then
        write(u6,*) ' Insufficient memory for configuration read',mavaili,mxconf,nconf
        call abend_cvb()
      end if
      confsinp(:,nconf) = 0
      call int_cvb(confsinp(:,nconf),noe,nread,1)
      call fstring_cvb('CON',1,istr2,3,2)
      if (istr2 == 0) exit
      nconf_fr(nfrag) = nconf_fr(nfrag)+1
      nconf = nconf+1
    end do
    call mma_allocate(tmp,noe,nconf,label='confsinp')
    tmp(:,:) = confsinp(:,1:nconf)
    call mma_deallocate(confsinp)
    call move_alloc(tmp,confsinp)
  end if
  if (istr == 0) exit
end do

return

end subroutine fraginp_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Martin Schuetz                                   *
!               1998, Roland Lindh                                     *
!***********************************************************************
!***********************************************************************
! This Module contains subroutines and functions which interface calls *
! to the Global Array Tools (GA)                                       *
!  DISTRIBUTED DATA PARALLEL VERSION for SCF                           *
!                                                                      *
! SubRoutine BCTwoHam(TwoHam,nDens,TCPU,TWall)                         *
! -> partial sum of Fock matrices                                      *
!    TwoHam: TwoHam(nDens): actual Fock matrix                         *
!----------------------------------------------------------------------*
!     written by:                                                      *
!     M. Schuetz                                                       *
!     University of Lund, Sweden, 1995                                 *
!                                                                      *
!     modified by:                                                     *
!     R. Lindh                                                         *
!     University of Lund, Sweden, 1998                                 *
!***********************************************************************

subroutine BCTwoHam(TwoHam,nDens,TCPU,TWall)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDens
real(kind=wp), intent(inout) :: TwoHam(nDens)
real(kind=wp), intent(inout) :: TCPU, TWall
#ifdef _MOLCAS_MPP_
real(kind=wp) :: TCPU1, TCPU2, TWall1, TWall2

if (.not. Is_Real_Par()) return
call CWTime(TCpu1,TWall1)
call GADGOP(TwoHam,nDens,'+')
call CWTime(TCpu2,TWall2)
TCPU = TCpu2-TCpu1
TWall = TWall2-TWall1

#else
#include "macros.fh"
unused_var(TwoHam)
unused_var(TCPU)
unused_var(TWall)
#endif

end subroutine BCTwoHam

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      Subroutine M2Mem(nHer,MemM2,la,lb,lr)
************************************************************************
*  Object: to compute the number of real*8 the kernal routine will     *
*          need for the computation of a matrix element between two    *
*          cartesian Gaussin functions with the total angular momentum *
*          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
*          lr is the order of the operator (this is only used when the *
*          integrals are computed with the Hermite-Gauss quadrature).  *
*                                                                      *
*  Called from: OneEl                                                  *
*                                                                      *
************************************************************************
*
      nElem(i) = (i+1)*(i+2)/2
*
      nHer=(la+lb+2)/2
      MemM2 = 3*nHer*(la+1) +
     &        3*nHer*(lb+1) +
     &        3*nHer +
     &        3*(la+1)*(lb+1) +
     &        5 + nElem(la)*nElem(lb)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lr)
      End
*
      Subroutine PAM2Mem(nHer,MemM2,la,lb,lr)
************************************************************************
*  Object: to compute the number of real*8 the kernal routine will     *
*          need for the computation of a matrix element between two    *
*          cartesian Gaussin functions with the total angular momentum *
*          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
*          lr is the order of the operator (this is only used when the *
*          integrals are computed with the Hermite-Gauss quadrature).  *
*                                                                      *
*  Called from: OneEl                                                  *
*                                                                      *
************************************************************************
*
      nElem(i) = (i+1)*(i+2)/2
*
      nComp = nElem(lr)
*
       nHer=(la+lb+lr+2)/2
      MemM2 = 3*nHer*(la+1) +
     &        3*nHer*(lb+1) +
     &        3*nHer*(lr+1) +
     &        3*(la+1)*(lb+1)*(lr+1) +
     &        5 + nElem(la)*nElem(lb)*nComp
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               2003, Hans-Joachim Werner                              *
************************************************************************
      SubRoutine Drv1_Pot(FD,CCoor,pot,ngrid,ncmp,nordop)
************************************************************************
*                                                                      *
* Object: to compute the potential on a grid using density FD (triang) *
*         Grid provided in CCoor(3,ngrid)                              *
*         Potential values returned in pot                             *
*                                                                      *
* Generated by modification of drv_rf.f, naint.f, sogthr.f             *
* H.-J. Werner, Jan 2003                                               *
************************************************************************
      use Symmetry_Info, only: nIrrep
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only: S
      Implicit Real*8 (A-H,O-Z)
#include "angtp.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "nsd.fh"
#include "setup.fh"
      Real*8 A(3), B(3), FD(*), CCoor(3,ngrid),
     &       RB(3), TRB(3), TA(3), pot(ncmp,ngrid)
      Logical AeqB
      Character ChOper(0:7)*3
      Integer   iStabO(0:7),
     &          iDCRR(0:7), iDCRT(0:7), iStabM(0:7), nOp(3)
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*                                                                      *
************************************************************************
*                                                                      *
*
*     Statement functions
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 112
      iPrint = nPrint(iRout)
*
      iIrrep = 0
      loper = 2**nIrrep-1
      nComp = (nOrdOp+1)*(nOrdOp+2)/2
      if(ncomp.ne.ncmp) then
        Call WarningMessage(2,'Drv1_pot: ncmp.lt.ncomp')
        Write (6,*) 'ncmp.lt.ncomp:',ncmp,ncomp
        Call Abend()
      end if
      call fzero(pot,ncmp*ngrid)
*
*     Auxiliary memory allocation.
*
      Call GetMem('Zeta','ALLO','REAL',iZeta,S%m2Max)
      Call GetMem('Zeta','ALLO','REAL',ipZI ,S%m2Max)
      Call GetMem('Kappa','ALLO','REAL',iKappa,S%m2Max)
      Call GetMem('PCoor','ALLO','REAL',iPCoor,S%m2Max*3)
*                                                                      *
************************************************************************
*                                                                      *
      Call Nr_Shells(nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*-----Double loop over shells. These loops decide the integral type
*
      Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
         Do jS = 1, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
            B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
            iSmLbl = 1
            nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            If (nSO.eq.0) Go To 131
            If (iPrint.ge.19) Write (6,'(A,A,A,A,A)')
     &        ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
*
*---------- Call kernel routine to get memory requirement.
*
c           Call NAMem(nOrder,MemKer,iAng,jAng,nOrdOp)
            Call EFMmP(nOrder,MemKer,iAng,jAng,nOrdOp)
            MemKrn=MemKer*S%m2Max
            Call GetMem('Kernel','ALLO','REAL',iKern,MemKrn)

*           Allocate memory for the final integrals, all in the
*           primitive basis.
*
            lFinal=1
            if(nOrdOp.ne.0) then
              lFinal = S%MaxPrm(iAng) * S%MaxPrm(jAng)
     &               * nElem(iAng)*nElem(jAng)
     &               * nComp
            end if
            Call GetMem('Final','ALLO','REAL',ipFnl,lFinal)
*
*           Scratch area for contraction step
*
            nScr1 =  S%MaxPrm(iAng)*S%MaxPrm(jAng) *
     &               nElem(iAng)*nElem(jAng)
            Call GetMem('Scrtch','ALLO','REAL',iScrt1,nScr1)
*
*           Scratch area for the transformation to spherical gaussians
*
            nScr2=S%MaxPrm(iAng)*S%MaxPrm(jAng)*nElem(iAng)*nElem(jAng)
            Call GetMem('ScrSph','Allo','Real',iScrt2,nScr2)
*
            nDAO =iPrim*jPrim*nElem(iAng)*nElem(jAng)
            Call GetMem(' DAO ','Allo','Real',ipDAO,nDAO)
*
*           At this point we can compute Zeta.
*
            Call ZXia(Work(iZeta),Work(ipZI),
     &                iPrim,jPrim,Shells(iShll)%Exp,
     &                            Shells(jShll)%Exp)
*
            AeqB = iS.eq.jS
*
*           Find the DCR for A and B
*
            Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &                     dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
            If (iPrint.ge.49) Write (6,'(10A)')
     &         ' {R}=(',(ChOper(iDCRR(i)),i=0,nDCRR-1),')'
*
*-----------Find the stabilizer for A and B
*
            Call Inter(dc(mdci)%iStab,dc(mdci)%nStab,
     &                 dc(mdcj)%iStab,dc(mdcj)%nStab,
     &                 iStabM,nStabM)
*
*           Allocate memory for the elements of the Fock or 1st order
*           denisty matrix which are associated with the current shell
*           pair.
*
            Call GetMem('DSOpr ','ALLO','REAL',ipDSOp,nSO*iPrim*jPrim)
            Call GetMem('DSO ','ALLO','REAL',ipDSO,nSO*iPrim*jPrim)
*
*           Gather the elements from 1st order density / Fock matrix.
*
            Call SOGthr(Work(ipDSO),iBas,jBas,nSO,FD,
     &                  n2Tri(iSmLbl),iSmLbl,
     &                  iCmp,jCmp,iShell,jShell,
     &                  AeqB,iAO,jAO)
*
*           Project the Fock/1st order density matrix in AO
*           basis on to the primitive basis.
*
            If (iPrint.ge.99) Then
               Call RecPrt(' Left side contraction',' ',
     &                     Shells(iShll)%pCff,iPrim,iBas)
               Call RecPrt(' Right side contraction',' ',
     &                     Shells(jShll)%pCff,jPrim,jBas)
            End If
*
*           Transform IJ,AB to J,ABi
            Call DGEMM_('T','T',
     &                  jBas*nSO,iPrim,iBas,
     &                  1.0d0,Work(ipDSO),iBas,
     &                        Shells(iShll)%pCff,iPrim,
     &                  0.0d0,Work(ipDSOp),jBas*nSO)
*           Transform J,ABi to AB,ij
            Call DGEMM_('T','T',
     &                  nSO*iPrim,jPrim,jBas,
     &                  1.0d0,Work(ipDSOp),jBas,
     &                        Shells(jShll)%pCff,jPrim,
     &                  0.0d0,Work(ipDSO),nSO*iPrim)
*           Transpose to ij,AB
            Call DGeTmO(Work(ipDSO),nSO,nSO,iPrim*jPrim,Work(ipDSOp),
     &                  iPrim*jPrim)
            Call GetMem('DSO ','Free','Real',ipDSO,nSO*iPrim*jPrim)
*
            If (iPrint.ge.99) Call
     &         RecPrt(' Decontracted 1st order density/Fock matrix',
     &                ' ',Work(ipDSOp),iPrim*jPrim,nSO)
*
*           Loops over symmetry operations.
*
            Do lDCRR = 0, nDCRR-1
               Call OA(iDCRR(lDCRR),B,RB)
*
*-----------------Generate stabilizer of the operator.
*
                  Call SOS(iStabO,nStabO,lOper)
*
*-----------------Find the DCR for M and S
*
                  Call DCR(LmbdT,iStabM,nStabM,
     &                           iStabO,nStabO,iDCRT,nDCRT)
                  If (iPrint.ge.49) Then
                     Write (6,'(10A)') ' {M}=(',(ChOper(iStabM(i)),
     &                     i=0,nStabM-1),')'
                     Write (6,'(10A)') ' {O}=(',(ChOper(iStabO(i)),
     &                     i=0,nStabO-1),')'
                     Write (6,'(10A)') ' {T}=(',(ChOper(iDCRT(i)),
     &                     i=0,nDCRT-1),')'
                  End If
*
*-----------------Compute normalization factor due the DCR symmetrization
*                 of the two basis functions and the operator.
*
                  iuv = dc(mdci)%nStab*dc(mdcj)%nStab
                  FactNd = DBLE(iuv*nStabO) / DBLE(nIrrep**2*LmbdT)
                  If (MolWgh.eq.1) Then
                     FactNd = FactNd * DBLE(nIrrep)**2 / DBLE(iuv)
                  Else If (MolWgh.eq.2) Then
                     FactNd = Sqrt(DBLE(iuv))*DBLE(nStabO) /
     &                        DBLE(nIrrep*LmbdT)
                  End If
*
                  Do lDCRT = 0, nDCRT-1
                     nOp(1) = NrOpr(iDCRT(lDCRT))
                     nOp(2) = NrOpr(iEor(iDCRT(lDCRT),iDCRR(lDCRR)))
                     nOp(3) = NrOpr(0)

                     Call OA(iDCRT(lDCRT),A,TA)
                     Call OA(iDCRT(lDCRT),RB,TRB)
                     If (iPrint.ge.49) Then
                        Write (6,'(A,/,3(3F6.2,2X))')
     &                  ' *** Centers A, B, C ***',
     &                  ( TA(i),i=1,3),
     &                  (TRB(i),i=1,3)
                        Write (6,*) ' nOp=',nOp
                     End If
*
*--------------------Desymmetrize the matrix with which we will
*                    contracte the trace.
*
                     Call DesymD(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                           iShell,jShell,iShll,jShll,
     &                           iAO,jAO,Work(ipDAO),iPrim,jPrim,
     &                           Work(ipDSOp),nSO,nOp,FactNd)
*
*--------------------Project the spherical harmonic space onto the
*                    cartesian space.
*
                     kk = nElem(iAng)*nElem(jAng)
                     If (Shells(iShll)%Transf.or.
     &                   Shells(jShll)%Transf) Then
*
*-----------------------ij,AB --> AB,ij
                        Call DGeTmO(Work(ipDAO),iPrim*jPrim,iPrim*jPrim,
     &                              iCmp*jCmp,Work(iScrt1),iCmp*jCmp)
*-----------------------AB,ij --> ij,ab
                        Call SphCar(Work(iScrt1),iCmp*jCmp,iPrim*jPrim,
     &                              Work(iScrt2),nScr2,
     &                              RSph(ipSph(iAng)),
     &                              iAng,Shells(iShll)%Transf,
     &                                   Shells(iShll)%Prjct,
     &                              RSph(ipSph(jAng)),
     &                              jAng,Shells(jShll)%Transf,
     &                                   Shells(jShll)%Prjct,
     &                              Work(ipDAO),kk)
                     End If
                     If (iPrint.ge.99) Call RecPrt(
     &                        ' Decontracted FD in the cartesian space',
     &                        ' ',Work(ipDAO),iPrim*jPrim,kk)
*
*--------------------Compute kappa and P.
*
                     Call Setup1(Shells(iShll)%Exp,iPrim,
     &                           Shells(jShll)%Exp,jPrim,
     &                   TA,TRB,Work(iKappa),Work(iPCoor),Work(ipZI))
*
*--------------------Compute primitive potential integrals and trace with density
*
                     Call potintd(Shells(iShll)%Exp,iPrim,
     &                            Shells(jShll)%Exp,jPrim,
     &                   Work(iZeta),Work(ipZI),
     &                   Work(iKappa),Work(iPCoor),
     &                   iPrim*jPrim,iAng,jAng,TA,TRB,nOrder,
     &                   Work(iKern),MemKer,work(ipFnl),lFinal,nDAO,
     &                   Ccoor,pot,ngrid,ncmp,Work(ipDAO),nOrdOp)
*
                  End Do
            End Do
*
            Call GetMem('DSOpr ','Free','REAL',ipDSOp,nSO*iPrim*jPrim)
            Call GetMem(' DAO ','Free','Real',ipDAO,nDAO)
            Call GetMem('ScrSph','Free','Real',iScrt2,nScr2)
            Call GetMem('Scrtch','Free','Real',iScrt1,nScr1)
            Call GetMem('Final','Free','Real',ipFnl,lFinal)
            Call GetMem('Kernel','Free','Real',iKern,MemKrn)
 131        Continue
         End Do
      End Do
      If (nOrdOp.eq.2) Then
c... modifify field gradients to get traceless form
         ThreeI = One / Three
         Do igeo=1,ngrid
            XX = Two * pot(1,igeo)-pot(4,igeo)-pot(6,igeo)
            YY = Two * pot(4,igeo)-pot(1,igeo)-pot(6,igeo)
            ZZ = Two * pot(6,igeo)-pot(4,igeo)-pot(1,igeo)
            pot(1,igeo)=XX * ThreeI
            pot(4,igeo)=YY * ThreeI
            pot(6,igeo)=ZZ * ThreeI
         End Do
      End If
*
      Call GetMem('PCoor','FREE','REAL',iPCoor,S%m2Max*3)
      Call GetMem('Kappa','FREE','REAL',iKappa,S%m2Max)
      Call GetMem('Zeta','FREE','REAL',ipZI ,S%m2Max)
      Call GetMem('Zeta','FREE','REAL',iZeta,S%m2Max)
*
      Return
      End
c----------------------------------------------------------------------
      SubRoutine PotIntd(Alpha,nAlpha,Beta, nBeta,
     &                  Zeta,ZInv,rKappa,P,
     &                  nZeta,la,lb,A,RB,nRys,
     &                  Array,nArr,Final,lFinal,nDAO,
     &                  CCoor,pot,ngrid,ncmp,DAO,nOrdOp)
c----------------------------------------------------------------------
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of potential (nordop=0)   *
*         or electric field (nordop.gt.0) on a grid                    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, January '91                             *
************************************************************************
      use k2_arrays
      Implicit Real*8 (A-H,O-Z)
*     Used for normal nuclear attraction integrals
      External TNAI, Fake, XCff2D, XRys2D
#include "real.fh"
#include "WrkSpc.fh"
#include "oneswi.fh"

c#include "print.fh"
      Real*8 Zeta(nZeta), ZInv(nZeta), Alpha(nAlpha), Beta(nBeta),
     &       rKappa(nZeta), P(nZeta,3), A(3), RB(3), CCoor(3,*),
     &       Array(nZeta*nArr),pot(ncmp,ngrid),DAO(*),Final(lfinal)
*-----Local arrys
C     Real*8 C(3), TC(3), Coori(3,4), CoorAC(3,2)
      Real*8 TC(3), Coori(3,4), CoorAC(3,2)
      Logical EQ, NoSpecial
      Integer iAnga(4)
C     Character ChOper(0:7)*3
C     Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      nComp = (nOrdOp+1)*(nOrdOp+2)/2
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = nOrdOp
      iAnga(4) = 0
      call dcopy_(3,A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
      mabMin = nabSz(Max(la,lb)-1)+1
      mabMax = nabSz(la+lb)
      If (EQ(A,RB)) mabMin=nabSz(la+lb-1)+1
      mcdMin=nabSz(nOrdOp-1)+1
      mcdMax=nabSz(nOrdOp)
      lab=(mabMax-mabMin+1)
      kab=nElem(la)*nElem(lb)
      lcd=(mcdMax-mcdMin+1)
      labcd=lab*lcd
*
*     Compute FLOP's and size of work array which Hrr will use.
*
      Call mHrr(la,lb,nFLOP,nMem)
*
*---- Distribute the work array
*
      ip1 = 1 + nZeta*Max(labcd,lcd*nMem)
      mArr = nArr - Max(labcd,lcd*nMem)
*
*     Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
       call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
       call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
      nT = nZeta
      NoSpecial=.True.

      do 100 igeo=1,ngrid
        Do i=1,3
          TC(i)=CCoor(i,igeo)
          CoorAC(i,2)=TC(i)
          Coori(i,3)=TC(i)
          Coori(i,4)=TC(i)
        End Do
*
* Compute integrals with the Rys quadrature.
*
      Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &         [One],[One],1,P,nZeta,
     &         TC,1,rKappa,[One],Coori,Coori,CoorAC,
     &         mabMin,mabMax,mcdMin,mcdMax,Array(ip1),mArr*nZeta,
     &         TNAI,Fake,XCff2D,XRys2D,NoSpecial)
*
      if(nOrdOp.eq.0) then
*
*-------Use the HRR to compute the required primitive integrals.
*
        Call HRR(la,lb,A,RB,Array(ip1),nZeta,nMem,ipIn)
        ipc=ip1-1+ipin
*
*-------Trace primitive integrals with density
*
         pot(1,igeo)=pot(1,igeo)-ddot_(nDAO,Array(ipc),1,DAO,1)
      else
         Call DGetMO(Array(ip1),nZeta*lab,nZeta*lab,lcd,Array,lcd)
         Call HRR(la,lb,A,RB,Array,lcd*nZeta,nMem,ipIn)
         Call DGetMO(Array(ipIn),lcd,lcd,nZeta*kab,Final,nZeta*kab)
         ipc=1
         do icmp=1,ncomp
           pot(icmp,igeo)=pot(icmp,igeo)+ddot_(nDAO,Final(ipc),1,DAO,1)
           ipc=ipc+nDAO
         end do
      end if
100   Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_integer(nRys)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      Subroutine ChoMP2g_ConstrAP(irc,Scr,lScr,Type,
     &                            iSym,nVec,Ap,lAp,Dens,lDens,factor)


#include "implicit.fh"
#include "chomp2g.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"
#include "cholesky.fh"
#include "choorb.fh"
*
      Real*8 Scr(lScr), Ap(lAp), Dens(lDens)

      Character  Type(1:4)
      Logical DoX, DoY, DoZ
      Integer iOffp(8), iOffAp(8)
      Integer nOrb1(8,4), iOrbType(4)
*
      Character*8  ThisNm
      Character*16 SecNam
      Parameter (SecNam = 'ChoMP2g_ConstrAP', ThisNm = 'ConstrAP')
*************************************
      MulD2h(i,j)=iEor(i-1,j-1) + 1
*************************************

*     Setup some lengths
*     ------------------
      nTypes = 4

      iTypL = 1

*     Setup lengths of needed cholesky/intermediate vectors
*     ----------------------------------------------------

*     Read the char-array Type = 'pqri'
*     ---------------------------------
      Do i = 1, nTypes
         If(Type(i) .eq. 'f') Then
            iOrbType(i) = 1
            Do iSym1 = 1, nSym
               nOrb1(iSym1,i) = nFro(iSym1)
            End Do
         Else If (Type(i) .eq. 'o') Then
            iOrbType(i) = 2
            Do iSym1 = 1, nSym
               nOrb1(iSym1,i) = nOcc(iSym1)
            End Do
         Else If (Type(i) .eq. 'v') Then
            iOrbType(i) = 3
            Do iSym1 = 1, nSym
               nOrb1(iSym1,i) = nVir(iSym1)
            End Do
         Else
            Write(6,*) 'Forbidden Type pqrs in', SecNam
            irc = -1
            Return
         End If
      End Do

*     Set vector type index
*     ---------------------
      iPQ = 3*(iOrbType(1)-1) + iOrbType(2)
      iIR = 3*(iOrbType(4)-1) + iOrbType(3)
      iIQ = 3*(iOrbType(4)-1) + iOrbType(2)
      iRP = 3*(iOrbType(3)-1) + iOrbType(1)
      iIP = 3*(iOrbType(4)-1) + iOrbType(1)
      iRQ = 3*(iOrbType(3)-1) + iOrbType(2)

*     Set vector lengths
*     ------------------
      nPQ = nMoMo(iSym,iPQ)
      nIR = nMoMo(iSym,iIR)
      nIQ = nMoMo(iSym,iIQ)
      nRP = nMoMo(iSym,iRP)
      nIP = nMoMo(iSym,iIP)
      nRQ = nMoMo(iSym,iRQ)

*     Set adress-offset for cholesky vector adress
*     --------------------------------------------
      iAdrLpq = iAdrOff(iSym,iPQ)
      iAdrLir = iAdrOff(iSym,iIR)
      iAdrLiq = iAdrOff(iSym,iIQ)
      iAdrLrp = iAdrOff(iSym,iRP)
      iAdrLip = iAdrOff(iSym,iIP)
      iAdrLrq = iAdrOff(iSym,iRQ)

*     Set
*

#ifdef _DEBUGPRINT_
      Write(6,*) 'iPQ', iPQ
      Write(6,*) 'iIQ', iIQ
      Write(6,*) 'iIR', iIR
      Write(6,*) 'iIP', iIP
      Write(6,*) 'iRQ', iRQ
      Write(6,*) 'iRP', iRP
*
      Write(6,*) 'nPQ', nPQ
      Write(6,*) 'nIQ', nIQ
      Write(6,*) 'nIR', nIR
      Write(6,*) 'nIP', nIP
      Write(6,*) 'nRQ', nRQ
      Write(6,*) 'nRP', nRP
#endif
*     Decide what type of intermediate vectors is needed
*     --------------------------------------------------
      DoX = .True.
      DoY = .True.
      DoZ = .True.
*
      If(iSym.ne.1) DoX = .False.
      If((nPQ .eq. 0) .or. (nIR .eq. 0)) DoX = .False.
      If((nRP .eq. 0) .or. (nIQ .eq. 0)) DoY = .False.
      If((nIP .eq. 0) .or. (nRQ .eq. 0)) DoZ = .False.
      If(Type(1) .eq. Type(2)) DoZ = .False.

      If(DoY.or.DoZ) Then
         iOffp(1) = 0
         iOffap(1) = 0
         Do iSym1 = 2, nSym
            iOffp(iSym1) = iOffp(iSym1-1) +
     &                      nOrb1(iSym1-1,1)*nOrb1(iSym1-1,2)
            iOffap(iSym1) = iOffap(iSym1-1) +
     &                      nOrb1(iSym1-1,3)*nOrb1(iSym1-1,4)
         End Do
      End If

*     Allocate memory for L-vectors
*     ------------------------------

*        Lri:
         lLir = nIR*nVec
         kLir = 1
         kEndLir = kLir +lLir

*        Lpq:
         lLpq = nPQ*nVec
         kLpq = kEndLir
         kEndLpq = kLpq + lLpq

*        Lrp:
         lLrp = nRP*nVec
         kLrp = kEndLpq
         kEndLrp = kLrp + lLrp

*        Lrq:
         lLrq = nRQ*nVec
         kLrq = kEndLrp
         kEndLrq = kLrq + lLrq

*        Lip:
         lLip = nIP*nVec
         kLip = kEndLrq
         kEndLip = kLip + lLip

*        Liq:
         lLiq = nIQ*nVec
         kLiq = kEndLip
         kEndLiq = kLiq + lLiq

*     Allocate memory for Intermediate Vectors
*     ----------------------------------------
*        X-vector
         lX = NumCho(iSym)
         kX = kEndLiq
         kEndX = kX + lX
*        Y-vector
         lY = nVec*nIP
         kY = kEndX
         kEndY = kY + lY
*        Z-vector
         kZ = kEndY
*
      nBatL = (NumCho(iSym)-1)/nVec + 1

*     Construction of Intermediate vectors
*     ------------------------------------
      Do iBat = 1, nBatL
         If (iBat .eq. nBatL) Then
            NumVec = NumCho(iSym) - nVec*(nBatL-1)
         Else
            NumVec = nVec
         End If
         iVec = nVec*(iBat-1) + 1

*        Read Lpq-vectors
*        ----------------
         If(DoX) Then
            iOpt = 2
            lTot = nPQ*NumVec
            iAdr = nPQ*(iVec-1) + 1 +
     &             iAdrLpq
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLpq),
     &                   lTot,iAdr)
         End If

*        Read Liq-vectors
*        ----------------
         If(DoY) Then
            iOpt = 2
            lTot = nIQ*NumVec
            iAdr = nIQ*(iVec-1) + 1 +
     &           iAdrLiq
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLiq),
     &                   lTot,iAdr)
         End If

*
         If(DoZ) Then
            iOpt = 2
            lTot = nIP*NumVec
            iAdr = nIP*(iVec-1) + 1 + iAdrLip
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLip),
     &                   lTot,iAdr)
         End If

*        Construct X-vector
*        ------------------
         If(DoX) Then
            nRow = 1
            Call dGemm_('T','N',nRow,NumVec,nPQ,
     &                 1.0d0,Dens(1),nPQ,
     &                       Scr(kLpq),nPQ,0.0d0,
     &                       Scr(kX+iVec-1),nRow)
         End If

*        Construct Y-vector
*        ------------------
         If(DoY) Then
            Do iVec1 = 1, NumVec
               iOffL1 = 0
               iOffY1 = 0
               Do iSymI = 1, nSym
                  iSymP = MulD2h(iSym,iSymI)
                  iSymQ = iSymP
                  nI = nOrb1(iSymI,4)
                  nP = nOrb1(iSymP,1)
                  nQ = nOrb1(iSymQ,2)
                  nR = nOrb1(iSymI,3)
                  If(nQ*nP*nI*nR .eq. 0) Go To 101
                  iOffL = (iVec1-1)*nIQ + iOffL1
                  iOffY = (iVec1-1)*nIP + iOffY1
                  Call dGemm_('T','N', nP, nI, nQ,1.0d0,
     &                       Dens(1+iOffP(iSymP)), nQ,
     &                       Scr(kLiq+iOffL), nQ, 0.0d0,
     &                       Scr(kY+iOffY), nP)
 101              Continue
                  iOffL1 = iOffL1 + nQ*nI
                  iOffY1 = iOffY1 + nP*nI
               End Do
            End Do
            If(nBatL .ne. 1) Then
               iOpt = 1
               lTot = nIP*NumVec
               iAdr = nIP*(iVec-1)+1
               Call dDaFile(LuVVec, iOpt, Scr(kY),lTot,iAdr)
            End If
         End If
*        Construct Z-vectors
*        -------------------
         If(DoZ) Then
            Do iVec1 = 1, NumVec
               iOffL1 = 0
               iOffZ1 = 0
               Do iSymI = 1, nSym
                  iSymP = MulD2h(iSym,iSymI)
                  iSymQ = iSymP
                  nI = nOrb1(iSymI,4)
                  nP = nOrb1(iSymP,1)
                  nQ = nOrb1(iSymQ,2)
                  nR = nOrb1(iSymI,3)
                  If(nQ*nP*nI*nR .eq. 0) Go To 102
                  iOffL = (iVec1-1)*nIP + iOffL1
                  iOffZ = (iVec1-1)*nIQ + iOffZ1
                  Call dGemm_('N','N', nQ, nI, nP,1.0d0,
     &                       Dens(1+iOffP(iSymQ)), nQ,
     &                       Scr(kLip+iOffL), nP, 0.0d0,
     &                       Scr(kZ+iOffZ), nQ)
 102              Continue
                  iOffL1 = iOffL1 + nP*nI
                  iOffZ1 = iOffZ1 + nQ*nI
               End Do
            End Do
            If(nBatL .ne. 1) Then
               iOpt = 1
               lTot = nIQ*NumVec
               iAdr = nIQ*(iVec-1)+1
               Call dDaFile(LuWVec, iOpt, Scr(kZ),lTot,iAdr)
            End If
*
         End If
      End Do

*     Contracting to produce the final contribution to A*p
*     ----------------------------------------------------
      Do iBat = 1, nBatL
         If (iBat .eq. nBatL) Then
            NumVec = NumCho(iSym) - nVec*(nBatL-1)
         Else
            NumVec = nVec
         End If
         iVec = nVec*(iBat-1) + 1

*        Read Lir-vectors
*        ----------------
         If(DoX) Then
            iOpt = 2
            lTot = nIR*NumVec
            iAdr = nIR*(iVec-1) + 1 +
     &             iAdrLir
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLir),
     &                   lTot,iAdr)
         End If

*        Read Lrp-vectors
*        ----------------
         If(DoY) Then
            iOpt = 2
            lTot = nRP*NumVec
            iAdr = nRP*(iVec-1) + 1 + iAdrLrp
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLrp),
     &                   lTot,iAdr)
         End If

*        Read Lrq-vectors
*        ----------------
         If(DoZ) Then
            iOpt = 2
            lTot = nRQ*NumVec
            iAdr = nRQ*(iVec-1) + 1 + iAdrLrq
            Call dDaFile(lUnit_F(iSym,iTypL),iOpt,Scr(kLrq),
     &                   lTot,iAdr)
         End If
*
         If(DoX) Then
            iCol = 1
            Call dGemm_('N','N',nIR,iCol,NumVec,
     &                 4.0d0*factor, Scr(kLir),nIR,
     &                 Scr(kX+iVec-1),NumVec, 1.0d0,
     &                 Ap(1),nIR)
         End If
*
         If(DoY) Then
*           Read Y-vector (if they are stored on disk and not in memory)
*           ------------------------------------------------------------
            If(nBatL .ne. 1) Then
               iOpt = 2
               lTot = nIP*NumVec
               iAdr = nIP*(iVec-1)+1
               Call dDaFile(LuVVec, iOpt, Scr(kY),lTot,iAdr)
            End If
*
            yfactor = 1.0d0*factor
            If(.not. DoZ) yfactor = yfactor*2.0d0
            Do iVec1 = 1, NumVec
                  iOffL1 = 0
                  iOffY1 = 0
                  Do iSymI = 1, nSym
                     iSymP = MulD2h(iSym,iSymI)
                     iSymR = iSymI
                     nI = nOrb1(iSymI,4)
                     nR = nOrb1(iSymR,3)
                     nP = nOrb1(iSymP,1)
                     nQ = nOrb1(iSymP,2)
*
                     If(nI*nR*nP*nQ .eq. 0) Go To 201
                     iOffL = (iVec1-1)*nRP + iOffL1
                     iOffY = (iVec1-1)*nIP + iOffY1
                     Call dGemm_('T','N',nR, nI, nP,-1.0d0*yfactor,
     &                          Scr(kLrp+iOffL), nP,
     &                          Scr(kY+iOffY),nP ,1.0d0,
     &                          Ap(1+ iOffAP(iSymI)),nR)
 201                 Continue
                     iOffL1 = iOffL1 + nR*nP
                     iOffY1 = iOffY1 + nI*nP
                  End Do
               End Do


         End If

         If(DoZ) Then
*           Read Z-vector (if they are stored on disk and not in memory)
*           ------------------------------------------------------------
            If(nBatL .ne. 1) Then
               iOpt = 2
               lTot = nIQ*NumVec
               iAdr = nIQ*(iVec-1)+1
               Call dDaFile(LuWVec, iOpt, Scr(kZ),lTot,iAdr)
            End If
*
            Do iVec1 = 1, NumVec
                  iOffL1 = 0
                  iOffZ1 = 0
                  Do iSymI = 1, nSym
                     iSymQ = MulD2h(iSym,iSymI)
                     iSymR = iSymI
                     nI = nOrb1(iSymI,4)
                     nR = nOrb1(iSymR,3)
                     nQ = nOrb1(iSymQ,2)
                     nP = nOrb1(iSymQ,1)
                     If(nI*nR*nQ*nP .eq. 0) Go To 202
                     iOffL = (iVec1-1)*nRQ + iOffL1
                     iOffZ = (iVec1-1)*nIQ + iOffZ1
                     Call dGemm_('T','N',nR, nI, nQ,-1.0d0*factor,
     &                          Scr(kLrq+iOffL), nQ,
     &                          Scr(kZ+iOffZ),nQ ,1.0d0,
     &                          Ap(1+ iOffAP(iSymI)),nR)
 202                 Continue
                     iOffL1 = iOffL1 + nR*nQ
                     iOffZ1 = iOffZ1 + nI*nQ
                  End Do
               End Do
         End If
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine No_ESPF(Forces,DoTinker)

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use external_centers, only: nOrd_XF, nXF, XF
use Gateway_global, only: Primitive_pass
use Gateway_Info, only: PotNuc
use Symmetry_Info, only: nIrrep
use Constants, only: Zero, One, Two, Three, Half, auTokcalmol
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: Forces, DoTinker
integer(kind=iwp) :: iChxyz, iDCRR(0:7), iDum, iFd, iM1xp, iM2xp, iPL, iR, ITkQMMM, jCnt, jCnttp, jCoSet(8,8), iStb(0:7), LmbdR, &
                     ndc, nDCRR, nDiff, nStb
real(kind=wp) :: A(3), ABx, ABy, ABz, B(3), CffM1, CffM2, DAx, DAy, DAz, fab, Gmma, PNX, Qxx, Qxy, Qxz, Qyy, Qyz, Qzz, r12, &
                 RepNuc, RepNuc_old, RB(3), temp0, temp1, temp2, Tke, ZA, ZAZB, ZB
logical(kind=iwp) :: DoRys, NoLoop
character(len=180) :: Line
integer(kind=iwp), external :: iChAtm, iPL_espf, IsFreeUnit
logical(kind=iwp), external :: EQ
character(len=180), external :: Get_Ln

iPL = iPL_espf()
NoLoop = .true.

! Nothing to do in a gradient calc

if (Forces) return

! Update the nuclear repulsion energy

call Get_dScalar('PotNuc',RepNuc)
RepNuc_old = RepNuc

! Read the MM contribution to the total energy and add it
! to the Nuclear Repulsion term

if (DoTinker) then
  Tke = Zero
  ITkQMMM = IsFreeUnit(30)
  call Molcas_Open(ITkQMMM,'QMMM')
  Line = ' '
  do while (index(Line,'TheEnd ') == 0)
    Line = Get_Ln(ITkQMMM)
    if (index(Line,'MMEnergy ') /= 0) call Get_F1(2,TkE)
  end do
  close(ITkQMMM)
  TkE = TkE/auTokcalmol
  RepNuc = RepNuc+TkE
  if (iPL >= 3) write(u6,1000) RepNuc_old,TkE,RepNuc
end if

if (allocated(XF) .and. (nOrd_XF >= 0)) then
  write(u6,*) 'Here we are!!'

  DoRys = .true.
  nDiff = 0
  call GetInf(DoRys,nDiff)
  Primitive_Pass = .true.

  ! Add contribution for interaction external field and nuclear
  ! charges. Here we will have charge-charge, and charge-dipole
  ! interaction.

  ZA = Zero
  DAx = Zero
  DAy = Zero
  DAz = Zero
  Qxx = Zero
  Qxy = Zero
  Qxz = Zero
  Qyy = Zero
  Qyz = Zero
  Qzz = Zero

  PNX = Zero
  iDum = 0
  do iFd=1,nXF
    if (nOrd_XF == 0) then
      ZA = XF(4,iFd)
      NoLoop = ZA == Zero
    else if (nOrd_XF == 1) then
      ZA = XF(4,iFd)
      DAx = XF(5,iFd)
      DAy = XF(6,iFd)
      DAz = XF(7,iFd)
      NoLoop = (ZA == Zero) .and. (DAx == Zero) .and. (DAy == Zero) .and. (DAz == Zero)
    else if (nOrd_XF == 2) then
      ZA = XF(4,iFd)
      DAx = XF(5,iFd)
      DAy = XF(6,iFd)
      DAz = XF(7,iFd)
      Qxx = XF(8,iFd)
      Qxy = XF(9,iFd)
      Qxz = XF(10,iFd)
      Qyy = XF(11,iFd)
      Qyz = XF(12,iFd)
      Qzz = XF(13,iFd)
      NoLoop = (ZA == Zero) .and. (DAx == Zero) .and. (DAy == Zero) .and. (DAz == Zero) .and. (Qxx == Zero) .and. (Qxy == Zero) &
               .and. (Qxz == Zero) .and. (Qyy == Zero) .and. (Qyz == Zero) .and. (Qzz == Zero)
    else
      call WarningMessage(2,'Option not implemented yet!')
      call Quit_OnUserError()
    end if
    if (NoLoop) cycle
    A(1:3) = XF(1:3,iFd)
    iChxyz = iChAtm(A)
    call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)

    ndc = 0
    do jCnttp=1,nCnttp
      if (jCnttp > 1) ndc = ndc+dbsc(jCnttp-1)%nCntr
      ZB = dbsc(jCnttp)%Charge
      if (dbsc(jCnttp)%pChrg) cycle
      if (ZB == Zero) cycle
      if (dbsc(jCnttp)%Frag) cycle
      ZAZB = ZA*ZB
      do jCnt=1,dbsc(jCnttp)%nCntr
        B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

        ! Find the DCR for the two centers

        call DCR(LmbdR,iStb,nStb,dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,iDCRR,nDCRR)

        temp0 = Zero
        temp1 = Zero
        temp2 = Zero
        do iR=0,nDCRR-1
          call OA(iDCRR(iR),B,RB)
          ! The index A=RB is illegal.
          if (.not. EQ(A,RB)) then
            ABx = A(1)-RB(1)
            ABy = A(2)-RB(2)
            ABz = A(3)-RB(3)
            r12 = sqrt(ABx**2+ABy**2+ABz**2)

            fab = One
            if (dbsc(jCnttp)%ECP) then
              ! Add contribution from M1 operator
              do iM1xp=1,dbsc(jCnttp)%nM1
                Gmma = dbsc(jCnttp)%M1xp(iM1xp)
                CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
                fab = fab+CffM1*exp(-Gmma*r12**2)
              end do
              ! Add contribution from M2 operator
              do iM2xp=1,dbsc(jCnttp)%nM2
                Gmma = dbsc(jCnttp)%M2xp(iM2xp)
                CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
                fab = fab+CffM2*r12*exp(-Gmma*r12**2)
              end do
            end if
            temp0 = temp0+fab/r12
            if (nOrd_XF >= 1) temp1 = temp1-fab*(DAx*ABx+DAy*ABy+DAz*ABz)/r12**3
            if (nOrd_XF >= 2) then

              temp2 = temp2+fab*Half* &
                      (Three*(Qxx*ABx**2+Two*Qxy*ABx*ABy+Two*Qxz*ABx*ABz+Qyy*ABy**2+Two*Qyz*ABy*ABz+Qzz*ABz**2)/r12**5- &
                       One/r12**3*(Qxx+Qyy+Qzz))
            end if

          end if
        end do
        PNX = PNX+(ZAZB*temp0+ZB*(temp1+temp2))*real(nIrrep,kind=wp)/real(LmbdR,kind=wp)

      end do
    end do
  end do

  if (iPL >= 3) write(u6,1100) RepNuc,PNX,RepNuc+PNX

  PotNuc = PotNuc+PNX
  call Put_dScalar('PotNuc',RepNuc)
end if

! Update the 1-e integrals

return

1000 format(/,' RepNuc + MM = ',F13.8,' + ',F13.8,' = ',F13.8)
1100 format(/,' RepNuc + Point charges = ',F13.8,' + ',F13.8,' = ',F13.8)

end subroutine No_ESPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine CIDIA_TD(iSym)
      use Exp, only: nexp, nexp_max
      use Str_Info, only: CNSM
      use ipPage, only: W
      use negpre
      Implicit Real*8 (a-h,o-z)
#include "detdim.fh"
#include "crun_mclr.fh"
#include "cicisp_mclr.fh"
#include "spinfo_mclr.fh"
#include "incdia.fh"
#include "Input.fh"
#include "Pointers.fh"
      Integer iSM(1),LSPC(1),iSPC(1),IDUM(1)
*
*     This is just a interface to hide Jeppe from the rest of the world
*     we dont want to let world see the work of the danish
*     (I hope he never reads that)
*     Anyway concerning the CSF/SD stuff.
*     If we work with spin dependent perturbations
*     we never use CSF's (to complicated), instead we use
*     SD in all parts of the program,
*     otherwise we will switch to SD representation in this routine
*
      NSPC=1
      ISPC(1)=1
      iSM(1)=iSym
      IAMCMP=0
      ICISTR=1
      i=2
      If (isym.eq.state_sym) i=1
      If (NOCSF.eq.0) Then
        nsd=max(ncsf(isym),nint(XISPSM(ISYM,1)))
        ipdcsfi=ipget(nsd)
        irc=ipin(ipdcsfi)
        ipDSDi=ipGet(nSD)
      Else
        nsd=max(ncsf(isym),nint(XISPSM(ISYM,1)))
        ipDSDi=ipGet(nsd)
        irc=ipin(ipdsdi)
      End If
      If (NOCSF.eq.0) Then
         nD=NCSASM(ISYM)
         ipdiai=ipdcsfi
      Else
         nD=idint(XISPSM(ISYM,ISPC(1)))
         ipdiai=ipdsdi
      End If

      LSPC(1)=nSD

      irc=ipin(ipDSDi)
      Call IntDia(W(ipDSDi)%Vec,NSPC,ISPC,ISM,LSPC,
     &           IAMCMP,rin_ene+potnuc)
      If (NOCSF.ne.1) Call CSDIAG(W(ipDCSFi)%Vec,W(ipDSDi)%Vec,
     &                            NCNATS(1,ISYM),NTYP,
     &                            CNSM(i)%ICTS,NDPCNT,NCPCNT,0,
     &                            0,IDUM,IPRNT)

      If (nocsf.eq.0) irc=ipClose(ipDSDi)
*     Calculate explicit part of hamiltonian
*
      np2=Min(nd,nexp_max)
      np1=0
      nq=0
      If (np2.ne.0) Then
         irc=ipnout(ipdiai)
         irc=ipin(ipdiai)
         call h0(W(ipdiai)%Vec,np1,nexp_max,nq,isym,nexp,TimeDep)
      Else
         nexp=0
      End if


      ECAS=ERASSCF(1)
      irc=ipin(ipdiai)
      Do iC=1,nD
        W(ipdiai)%Vec(iC)=(W(ipdiai)%Vec(iC)-ECAS)
      End do

      ipdia=ipdiai
      RETURN
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c       docasne utilitky
c       rea_chcc
c       wri_chcc
c       IniReord
c       RNFill
c       UrobTau
c       UrobChV
c       UrobInt
c       ReaW
c         rea1
c       GetX
c       SaveX
c       Exp1
c       Exp2
c       Exp2i
c       Exp4
c       UrobL1
c       UrobL2
c       UrobI1
c       UrobI2
c       UrobI3
c       UrobT2
c        TimeDelay
c
c       ----------------
c
        subroutine rea_chcc (lun,length,A)
c
c       nacitane bloku dat
c
        implicit none
        integer lun,length
        real*8 A(1:length)
c
        read (lun) A
c
        return
        end
c
c       ----------------
c
        subroutine wri_chcc (lun,length,A)
c
c       zapisanie bloku dat
c
        implicit none
        integer lun,length
        real*8 A(1:length)
c
        write (lun) A
c
        return
        end
c
c       ----------------
c
        subroutine IniReord(NaGrp,NaSGrp,NchBlk,LunAux,wrksize)
c
c       nacitanie vsupu a inicializacia premnennych
c       a tlac primitivnej hlavicky pre Reord procesz
c
        implicit none
#include "chcc1.fh"
#include "chcc_reord.fh"
cmp!
#include "chcc_parcc.fh"
#include "para_info.fh"
cmp!

c
        integer NaGrp,NaSGrp,NchBlk
        integer LunAux,wrksize
cmp!
        integer nOrb(8),nOcc(8),nFro(8),nDel(8)
        integer intkey1,intkey2
        integer ndelvirt

        integer LuSpool
        character*80 LINE
        character*80 TITLE

#ifdef _MOLCAS_MPP_
        integer jal1
#endif
        integer NChLoc_min,NChLoc_max,NchBlk_tmp

        character*3 msg
cmp!

c setup defaults

        Call Get_iArray('nBas',nOrb,1) ! must read always nBas!!
        Call Get_iArray('nIsh',nOcc,1)
        Call Get_iArray('nFroPT',nFro,1) ! = 'nFro' in previous step
        Call Get_iArray('nDelPT',nDel,1) ! = 'nDel' in previous step
c
#ifdef _MOLCAS_MPP_
cmp     get min/max
        NChLoc_min=nc
        NChLoc_max=0
        do jal1=0,Nprocs-1
          if (NChLoc(jal1).le.NChLoc_min) NChLoc_min = NChLoc(jal1)
          if (NChLoc(jal1).ge.NChLoc_max) NChLoc_max = NChLoc(jal1)
        end do

cmp     calc reasonable starting value (200-300)
        if (NChLoc_min.ne.NChLoc_max) then
          NChBlk = int(NChLoc_min/2)
        else
          NChBlk = NChLoc_min
        end if

        if (NChBlk.ge.300) then
          NChBlk=min(200,int(NChBlk/2))
        end if

cmp     fix num of ChV blocks to be less then 100
        if (int(NChLoc_max/NChBlk).ge.100)
     & NChBlk = int(NChLoc_max/100) - 1
#else
        NChLoc_max=nc
cmp     calc reasonable starting value (200-300)
        if (nc.ge.300) then
          NChBlk=min(200,nc/2)
        else
          NChBlk=nc
        endif

        NChLoc_min=NChBlk
cmp     fix num of ChV blocks to be less then 100
        if (int(nc/NChBlk).ge.100)
     & NChBlk = int(nc/100) - 1
#endif

        nfr= nFro(1)
        no = nOcc(1)-nFro(1)
        ndelvirt = nDel(1)

        nv = nOrb(1)-nDel(1)-nOcc(1) ! nOrb defined as = to nBas, right!

        LunAux = 13
        mhkey = 1
        generkey = 1
        intkey1 = 0
        intkey2 = 0

        NaGrp = 0
        NaSGrp = 0
        W34DistKey = 1
        JoinLkey = 2 ! toto este nemam domyslene
        restkey = 0
        conv = 1.0d-6
        printkey = 1
        maxiter = 40

c
cmp!    read input file
c
      LuSpool = 17
      Call SpoolInp(LuSpool)
      Rewind(LuSpool)
 5      Read(LuSpool,'(A80)') LINE
       CALL UPCASE(LINE)
       IF( INDEX(LINE,'&CHCC') .EQ. 0 ) GOTO 5
       TITLE=' '
 6     Read(LuSpool,'(A80)') LINE
       IF(LINE(1:1).EQ.'*') GOTO 6
       CALL UPCASE(LINE)
c
       IF (LINE(1:4).EQ.'TITL') THEN
       Read(LuSpool,'(A72)') TITLE

       ELSE IF (LINE(1:4).EQ.'FROZ') THEN
       Read(LuSpool,*) nfr
             if ((nfr.lt.0).or.(nfr.ge.no)) then
               write (6,*)
               write (6,*) 'Ilegal value for FROZen keyword : ',
     &                      nfr
               call abend()
             end if
             no = no + nFro(1) - nfr

       ELSE IF (LINE(1:4).EQ.'DELE') THEN
       Read(LuSpool,*) ndelvirt
             if ((ndelvirt.lt.0).or.(ndelvirt.gt.nv)) then
               write (6,*)
               write (6,*) 'Ilegal value for DELETED keyword : ',
     &                      ndelvirt
               call abend()
             end if
             nv = nv + nDel(1) - ndelvirt

       ELSE IF (LINE(1:4).EQ.'LARG') THEN
       Read(LuSpool,*) NaGrp
           if ((NaGrp.lt.0).or.(NaGrp.gt.maxGrp)) then
               write (6,*)
               write (6,*) 'Ilegal value for LARGE keyword : ',
     &                      NaGrp
               write (6,*) 'Large segmentation must be -le 32'
               call abend()
           end if

       ELSE IF (LINE(1:4).EQ.'SMAL') THEN
       Read(LuSpool,*) NaSGrp
           if ((NaSGrp.lt.0).or.(NaSGrp.gt.8)) then
               write (6,*)
               write (6,*) 'Ilegal value for SMALL keyword : ',
     &                      NaSGrp
               write (6,*) 'Small segmentation must be -le 8'
               call abend()
           end if

c          large == 0, small != 0 => quit
           if ((NaGrp.eq.0).and.(NaSGrp.ne.0)) then
               write (6,*)
               write (6,*) 'Small segmentation must be specified'
               write (6,*) 'with large segmentation, or both can'
               write (6,*) 'be left unspecified'
               call abend()
           end if

           if (NaGrp.ne.0) then
c             large != 0, small == 0 => small = 1
              if (NaSGrp.eq.0) then
                 NaSGrp = 1
              endif

c             large * small <= 64
              if ((NaGrp*NaSGrp).gt.maxSGrp) then
                write (6,*)
                write (6,*) 'Product of Large and Small segmen-'
                write (6,*) 'tation must be less or equal to 64'
                call abend()
              endif
           end if

       ELSE IF (LINE(1:4).EQ.'CHSE') THEN
       Read(LuSpool,*) NchBlk_tmp
           if ((NchBlk_tmp.lt.1).or.(NchBlk_tmp.gt.NChLoc_min)) then
               write (6,*)
               write (6,*) 'Ilegal value for CHSegment keyword  : ',
     &                      NchBlk_tmp
               write (6,*) 'Reseting to a reasonable value for    '
               write (6,*) 'this system :                         ',
     & NchBlk
           else if (int(NChLoc_max/NchBlk_tmp).ge.100) then
               write (6,*) 'Number of block of the MO Cholesky vector'
               write (6,*) 'exceeded the limit. Increasing value of  '
               write (6,*) 'the CHSEgmentation keyword to : ',
     & NchBlk
           else
              NchBlk = NchBlk_tmp
           end if

cmp!       ELSE IF (LINE(1:4).EQ.'LUNA') THEN  ... toto sa nikdy nevyuzivalo
cmp!       Read(LuSpool,*) LunAux

       ELSE IF (LINE(1:4).EQ.'MHKE') THEN
       Read(LuSpool,*) mhkey
           if ((mhkey.lt.0).or.(mhkey.gt.2)) then
              mhkey=1
              write(6,*)
              write(6,*) ' Warning!!!',
     &                   '  Matrix handling key out of range'
              write(6,*) ' parameter mhkey changed to 1'
           end if

       ELSE IF (LINE(1:4).EQ.'NOGE') THEN
            generkey = 0

       ELSE IF (LINE(1:4).EQ.'ONTH') THEN
            intkey1 = 1

       ELSE IF (LINE(1:4).EQ.'PREC') THEN
            intkey2 = 1

       ELSE IF (LINE(1:4).EQ.'NODI') THEN
            W34DistKey = 0

       ELSE IF (LINE(1:4).EQ.'JOIN') THEN
       Read(LuSpool,*) JoinLkey
            if ((JoinLkey.lt.0).or.(JoinLkey.gt.3)) then
               write (6,*)
               write (6,*) 'Ilegal value for Join keyword : ',
     &                      JoinLkey
               write (6,*) 'Use one of 0, 1, 2, 3'
               write (6,*) 'For details, see the manual ...'
               call abend()
            end if


       ELSE IF (LINE(1:4).EQ.'MAXI') THEN
       Read(LuSpool,*) maxiter
            if (maxiter.le.0) then
               write (6,*)
               write (6,*) 'Ilegal value of the MAXITER keyword: ',
     &                      maxiter
               write (6,*) 'Use integer > 0'
               call abend()
            end if

       ELSE IF (LINE(1:4).EQ.'REST') THEN
            restkey = 1
            write (6,*)
            write (6,*) 'This option is temporary disabled'
            write (6,*) 'No Restart possible (... yet).'
            call abend()

       ELSE IF (LINE(1:4).EQ.'THRE') THEN
       Read(LuSpool,*) conv

       ELSE IF (LINE(1:4).EQ.'PRIN') THEN
       Read(LuSpool,*) printkey
            if (((printkey.lt.0).or.(printkey.gt.10)).or.
     & ((printkey.gt.2).and.(printkey.lt.10))) then

               write (6,*)
               write (6,*) 'Ilegal value of the PRINT keyword: ',
     &                      printkey
               write (6,*) ' Use: 1  (Minimal) '
               write (6,*) '      2  (Minimal + Timings)'
               write (6,*) '      10 (Debug) '
               call abend()
            end if

       ELSE IF (LINE(1:4).EQ.'END ') THEN
       GOTO 7
       END IF
       GOTO 6
7      CONTINUE

       Call Close_LuSpool(LuSpool)

c! take care of the algorithm keyword
        if (intkey1.eq.intkey2) then
           if (intkey1.eq.0) then
              write (6,*)
              write (6,*) 'None of OnTheFly/PreCalculate'
              write (6,*) 'algorithm was selected. Using'
              write (6,*) 'default: PreCalculate (1)'
              intkey = 1
           else
              write (6,*)
              write (6,*) 'OnTheFly and PreCalculate keywords'
              write (6,*) 'are mutually exclusive'
              call abend()
           end if
        else
           if (intkey1.eq.1) then
               intkey = 0
           else
               intkey = 1
           end if
        end if

c2      tlac hlavicky
        write (6,*)
        write (6,*) '    Cholesky Based Closed-Shell CCSD code'
cmp!        write (6,*) ' Dedicated to the memory of Boris Jeltzin'
        write (6,*)
      write (6,*) '---------------------------------------------------'

        write (6,'(A,i9)') ' Frozen Orbitals                   : ',
     & nfr
        write (6,'(A,i9)') ' Occupied Orbitals                 : ',
     & no
        write (6,'(A,i9)') ' Virtual Orbitals                  : ',
     & nv
        write (6,'(A,i9)') ' Total number of Cholesky Vectors  : ',
     & nc

      write (6,*) '---------------------------------------------------'

        if (NaGrp.ne.0) then
          write (6,'(A,i9)') ' Large Virtual Segmentation        : ',
     & NaGrp
        else
          write (6,'(A,A9)') ' Large Virtual Segmentation        : ',
     & ' auto'
        end if

        if (NaSGrp.ne.0) then
          write (6,'(A,i9)') ' Small Virtual Segmentation        : ',
     & NaSGrp
        else
          write (6,'(A,A9)') ' Small Vectors Segmentation        : ',
     & ' auto'
        end if

        write (6,'(A,i9)') ' Cholesky Vectors Segmentation     : ',
     & NchBlk

      write (6,*) '---------------------------------------------------'

        msg = 'No'
        if (generkey.eq.1) msg = 'Yes'

        write (6,'(A,A4)') ' Generate Scratch Files?                : ',
     & msg
        write (6,'(A,i4)') ' Precalculate (1) / On-the-Fly (0) Alg. : ',
     & intkey
        write (6,'(A,i4)') ' 3 and 4-ext. MO integrals distribute?  : ',
     & W34DistKey
        write (6,'(A,i4)') ' Parallel Join of varios MO integrals   : ',
     & JoinLkey

      write (6,*) '---------------------------------------------------'

        write (6,'(A,E9.2)') ' Convergence Threshold             : ',
     & conv
        write (6,'(A,i9)') ' Maximum number of Iterations      : ',
     & maxiter

      write (6,*) '---------------------------------------------------'

        write (6,'(A,i9)') ' Lun Number for Aux. Matrixes      : ',
     & LunAux
        write (6,'(A,i9)') ' BLAS/FTN Matrix Handling          : ',
     & mhkey

        msg = 'No'
        if (restkey.eq.1) msg = 'Yes'

        write (6,'(A,A10)') ' Start from RstFil ?               : ',
     & msg
        write (6,'(A,i9)') ' Print level                       : ',
     & printkey

      write (6,*) '---------------------------------------------------'
        write (6,*)

c
        return
c Avoid unused argument warnings
        if (.false.) Call Unused_integer(wrksize)
        end
c
c --------------------------------
c
        subroutine RNFill (length,A,c)
c
c       fill an array with random numbers in interval (-c,c)
c
        implicit none
        integer length
        real*8 c
        real*8 A(1:length)
c
c       help variables
        integer i
c
c
        do i=1,length
c          A(i)=c*(srand()-0.5d0)
           A(i)=(1.0d-7)*i
        end do
c
c
        return
c Avoid unused argument warnings
        if (.false.) Call Unused_real(c)
        end
c
c       ----------------
c
        subroutine UrobTau (Tau,NaGrp,LunTau)
c
c       vyraba subor LunTau so simulovanymi Tau amplitudami
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
c@@     include 'o2v4.fh' stare
#include "o3v3.fh"
c
        integer NaGrp,LunTau
        real*8 Tau(1)
c
c       help variables
        integer length
        integer aGrp,bGrp
c
c
c1      cycle over Groups a,b
c
        do aGrp=1,NaGrp
        do bGrp=1,aGrp
c
c1.1    def legth
c
        if (aGrp.eq.bGrp) then
c       groups of a and b are equal, reading for a'>=b'
          length=no*no*DimGrpv(aGrp)*(DimGrpv(bGrp)+1)/2
        else
c       aGrp>bGrp, reading for a',b' in given groups
          length=no*no*DimGrpv(aGrp)*DimGrpv(bGrp)
        end if
c
c
c1.2    full Tau with random numbers
c
        call RNFill (length,Tau(1),1.0d-2)
c
c1.3    read block
c
        write (6,*) aGrp,bGrp,length
        call wri_chcc (lunTau,length,Tau(1))
c
        end do
        end do
c
c
c2      rewind file
        rewind (LunTau)
c
        return
        end
c
c       ----------------
c
        subroutine UrobChV (L2,NaGrp,NbeGrp,LunAux)
c
c       vyraba fily so simulovanymi Cholesky vektormi
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
c@@     include 'o2v4.fh' stare
#include "o3v3.fh"
#include "chcc_files.fh"
c
        integer NaGrp,NbeGrp,LunAux
        real*8 L2(1)
c
c       help variables
        integer aGrp,beGrp,len
        real*8 schem
c
c1      cycle over a,be Groups
c
        do aGrp=1,NaGrp
        do beGrp=1,NbeGrp
c
c1.1      def length
          len=nc*DimGrpv(aGrp)*DimGrpv(beGrp)
c
c1.2      full L2 with random numbers
          schem=1.0d-2
          call RNFill (len,L2(1),schem)
c
c1.3      open proper file
*         open (unit=LunAux,file=L2Name(aGrp,beGrp),form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(LunAux,L2Name(aGrp,beGrp))
c
c1.4      write L2 into proper file
          write (6,*) aGrp,beGrp,len
          call wri_chcc (LunAux,len,L2(1))
c
        end do
        end do
c
c
        return
        end
c
c       ----------------
c
        subroutine UrobInt (W,maxa,maxbe,n,lun)
c
c       vyraba subor LunInt so simulovanymi (a"be"|b"ga") integralmi
c       kde je za sebou N blokov
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer maxa,maxbe,n,lun
        real*8 W(1)
c
c       help variables
        integer length,i
c
c       open (unit=Lun,file='IntFil',form='unformatted')
c
c1      def legth
c
        length=maxa*maxa*maxbe*maxbe
c
c2      cycle over N
c
        do i=1,n
c
c2.1    full W with random numbers
c
        call RNFill (length,W(1),1.0d-2)
c
c2.2    write block
c
        write (6,*) 'Vint',i,length
        call wri_chcc (lun,length,W(1))
c
        end do
c
c
        rewind(lun)
c
        return
        end
c
c       -----------
c
        subroutine ReaW (W,aSGrp,beSGrp,bSGrp,gaSGrp,LunInt)
c
c       simuluje citanie VVVV integralov
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 W(1)
        integer aSGrp,beSGrp,bSGrp,gaSGrp,LunInt
c
c       help variables
        integer dim
c
        dim=DimSGrpa(aSGrp)*DimSGrpbe(beSGrp)*
     c      DimSGrpa(bSGrp)*DimSGrpbe(gaSGrp)
c
        call rea1 (LunInt,dim,W(1))
c
        return
        end
c
c       -----------
c
        subroutine rea1 (lun,length,A)
c
c       nacitane bloku dat z Sekvencneho suboru, ak koniec tak
c       rewind a citanie znova od zaciatku
c       Toto je ozaj ditry
c
        implicit none
        integer lun,length
        real*8 A(1:length)
c
        read (lun,end=99) A
        return
c
99      rewind(lun)
        read (lun) A
c
        end
c
c       -----------
c
        subroutine GetX (X,length,Lun,LunName,keyopen,keyclose)
c
c       this routine do
c       1) keyopen = 0 - nothing (i.e) file is opened
c                    1 - open LunName file with Lun
c                    2 - rewind Lun file
c                    3 - open LunName file with Lun with ACCESS='append'
c       2) read X  of dimension length
c       3) keyclose= 0 - nothing
c                    1 - close Lun file
c
c
        implicit none
        integer length,Lun,keyopen,keyclose
        real*8 X(1)
        character*6 LunName
c
c1
        if (keyopen.eq.1) then
*         open (unit=Lun,file=LunName,form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
        else if (keyopen.eq.2) then
          rewind(Lun)
        else if (keyopen.eq.3) then

cmp!          open (unit=Lun,file=LunName,form='unformatted',
cmp!     c          ACCESS='append')

          Call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
          call append_file_u(Lun)

        end if
c
c2
        call rea_chcc (Lun,length,X(1))
c
c3
        if (keyclose.eq.1) then
          close (Lun)
        end if
c
        return
        end
c
c       -----------
c
        subroutine SaveX (X,length,Lun,LunName,keyopen,keyclose)
c
c       this routine do
c       1) keyopen = 1 - open LunName file with Lun
c                    2 - rewind Lun file
c                    3 - open LunName file with Lun with ACCESS='append'
c                 else - nothing (i.e) file is opened
c       2) write X  of dimension length
c       3) keyclose= 1 - close Lun file
c                 else - nothing
c
c
        implicit none
        integer length,Lun,keyopen,keyclose
        real*8 X(1)
        character*6 LunName
c
c1
        if (keyopen.eq.1) then
*         open (unit=Lun,file=LunName,form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
        else if (keyopen.eq.2) then
          rewind(Lun)
        else if (keyopen.eq.3) then
cmp!          open (unit=Lun,file=LunName,form='unformatted',
cmp!     c          ACCESS='append')

          Call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
          call append_file_u(Lun)

        end if
c
c2
        call wri_chcc (Lun,length,X(1))
c
c3
        if (keyclose.eq.1) then
          close (Lun)
        end if
c
        return
        end
c
c       -----------
c
        subroutine Exp1 (A,B,dimi,dim2,dime)
c
c       this routine do:
c       expand A(i,pq) -> B(i,p,q)
c       for matrices, where A(i,pq)=A(i,qp)
c
c       parameter description:
c       A       - input matrix (I)
c       B       - outpun matrix (O)
c       dimi    - first dimension in A,B (I)
c       dim2    - # of pq (I)
c       dimf    - # of p (also q) (I)
c
        implicit none
        integer dimi,dim2,dime
        real*8 A(1:dimi,1:dim2)
        real*8 B(1:dimi,1:dime,1:dime)
c
c       help variables
        integer i,p,q,pq
c
        pq=0
        do p=1,dime
        do q=1,p
        pq=pq+1
c
          do i=1,dimi
            B(i,p,q)=A(i,pq)
          end do
c
          do i=1,dimi
            B(i,q,p)=A(i,pq)
          end do
c
        end do
        end do
c
        return
        end
c
c       -----------
c
        subroutine Exp2 (A,B,dima,dimb,dim2,dime)
c
c       this routine do:
c       expand A(a,b,pq) -> B(a,b,p,q)
c       for matrices, where A(a,b,pq)=A(a,b,qp)
c
c       parameter description:
c       A       - input matrix (I)
c       B       - outpun matrix (O)
c       dima,b  - first dimension in A,B (I)
c       dim2    - # of pq (I)
c       dimf    - # of p (also q) (I)
c
        implicit none
        integer dima,dimb,dim2,dime
        real*8 A(1:dima,1:dimb,1:dim2)
        real*8 B(1:dima,1:dimb,1:dime,1:dime)
c
c       help variables
        integer a1,b1,p,q,pq
c
        pq=0
        do p=1,dime
        do q=1,p
        pq=pq+1
c
          do b1=1,dimb
          do a1=1,dima
            B(a1,b1,p,q)=A(a1,b1,pq)
          end do
          end do
c
          do b1=1,dimb
          do a1=1,dima
            B(a1,b1,q,p)=A(a1,b1,pq)
          end do
          end do
c
        end do
        end do
c
        return
        end
c
c       -----------
c
        subroutine Exp2i (A,B,dima,dimb,dim2,dime)
c
c       this routine do:
c       expand A(a,b,pq) -> B(b,a,p,q)
c       for matrices, where A(a,b,pq)=A(a,b,qp)
c
c       parameter description:
c       A       - input matrix (I)
c       B       - outpun matrix (O)
c       dima,b  - first dimension in A,B (I)
c       dim2    - # of pq (I)
c       dimf    - # of p (also q) (I)
c
        implicit none
        integer dima,dimb,dim2,dime
        real*8 A(1:dima,1:dimb,1:dim2)
        real*8 B(1:dimb,1:dima,1:dime,1:dime)
c
c       help variables
        integer a1,b1,p,q,pq
c
        pq=0
        do p=1,dime
        do q=1,p
        pq=pq+1
c
          do a1=1,dima
          do b1=1,dimb
            B(b1,a1,p,q)=A(a1,b1,pq)
          end do
          end do
c
          do a1=1,dima
          do b1=1,dimb
            B(b1,a1,q,p)=A(a1,b1,pq)
          end do
          end do
c
        end do
        end do
c
        return
        end
c
c       -----------
c
        subroutine Exp4 (A,B,dima2,dima,dimp2,dimp)
c
c       this routine do:
c       expand A(ab,pq) -> B(b,a,p,q)
c       for matrices, where A(ab,pq)=A(ab,qp)=A(ba,pq)=A(ba,qp)
c        N.B. kvajto odflaknute
c
c       parameter description:
c       A       - input matrix (I)
c       B       - outpun matrix (O)
c
        implicit none
        integer dima2,dima,dimp2,dimp
        real*8 A(1:dima2,1:dimp2)
        real*8 B(1:dima,1:dima,1:dimp,1:dimp)
c
c       help variables
        integer a1,b1,ab,p,q,pq
c
        pq=0
        do p=1,dimp
        do q=1,p
        pq=pq+1
c
          ab=0
          do a1=1,dima
          do b1=1,a1
          ab=ab+1
            B(a1,b1,p,q)=A(ab,pq)
            B(a1,b1,q,p)=A(ab,pq)
            B(b1,a1,p,q)=A(ab,pq)
            B(b1,a1,q,p)=A(ab,pq)
          end do
          end do
c
        end do
        end do
c
        return
        end
c
c       ----------------
c
        subroutine UrobL1 (L1,NaGrp,LunAux)
c
c       vyraba fily so simulovanymi L1       vektormi
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
#include "o3v3.fh"
#include "chcc_files.fh"
c
        integer NaGrp,LunAux
        real*8 L1(1)
c
c       help variables
        integer aGrp,len
        real*8 schem
c
c1      cycle over a,be Groups
c
        do aGrp=1,NaGrp
c
c1.1      def length
          len=nc*DimGrpv(aGrp)*no
c
c1.2      full L1 with random numbers
          schem=1.0d-2
          call RNFill (len,L1(1),schem)
c
c1.3      open proper file
*         open (unit=LunAux,file=L1Name(aGrp),form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(LunAux,L1Name(aGrp))
c
c1.4      write L1 into proper file
          write (6,*) aGrp,len
          call wri_chcc (LunAux,len,L1(1))
c
        close (LunAux)
c
        end do
c
c
        return
        end
c
c       ----------------
c
        subroutine UrobL2 (L2,NaGrp,NbeGrp,LunAux)
c
c       vyraba fily so simulovanymi Cholesky vektormi
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
#include "o3v3.fh"
#include "chcc_files.fh"
c
        integer NaGrp,NbeGrp,LunAux
        real*8 L2(1)
c
c       help variables
        integer aGrp,beGrp,len
        real*8 schem
c
c1      cycle over a,be Groups
c
        do aGrp=1,NaGrp
        do beGrp=1,NbeGrp
c
c1.1      def length
          len=nc*DimGrpv(aGrp)*DimGrpv(beGrp)
c
c1.2      full L2 with random numbers
          schem=1.0d-2
          call RNFill (len,L2(1),schem)
c
c1.3      open proper file
*         open (unit=LunAux,file=L2Name(aGrp,beGrp),form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(LunAux,L2Name(aGrp,beGrp))
c
c1.4      write L2 into proper file
          write (6,*) aGrp,beGrp,len
          call wri_chcc (LunAux,len,L2(1))
c
          close (LunAux)
c
        end do
        end do
c
c
        return
        end
c
c       ----------------
c
        subroutine UrobI1 (I1,NaGrp,LunAux)
c
c       vyraba fily so simulovanymi I1       vektormi
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
#include "o3v3.fh"
#include "chcc_files.fh"
c
        integer NaGrp,LunAux
        real*8 I1(1)
c
c       help variables
        integer aGrp,len
        real*8 schem
c
c1      cycle over a,be Groups
c
        do aGrp=1,NaGrp
c
c1.1      def length
          len=no*DimGrpv(aGrp)*no*(no+1)/2
c
c1.2      full I1 with random numbers
          schem=1.0d-2
          call RNFill (len,I1(1),schem)
c
c1.3      open proper file
*         open (unit=LunAux,file=I1Name(aGrp),form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(LunAux,I1Name(aGrp))
c
c1.4      write I1 into proper file
          write (6,*) aGrp,len
          call wri_chcc (LunAux,len,I1(1))
c
        close (LunAux)
c
        end do
c
c
        return
        end
c
c       ----------------
c
        subroutine UrobI2 (I2,NaGrp,NbeGrp,LunAux)
c
c       vyraba fily so simulovanymi I2       vektormi
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
#include "o3v3.fh"
#include "chcc_files.fh"
c
        integer NaGrp,NbeGrp,LunAux
        real*8 I2(1)
c
c       help variables
        integer aGrp,beGrp,len
        real*8 schem
c
c1      cycle over a,be Groups
c
        do aGrp=1,NaGrp
        do beGrp=1,NbeGrp
c
c1.1      def length
          len=no*no*DimGrpv(aGrp)*DimGrpv(beGrp)
c
c1.2      full I2 with random numbers
          schem=1.0d-2
          call RNFill (len,I2(1),schem)
c
c1.3      open proper file
*         open (unit=LunAux,file=I2Name(aGrp,beGrp),form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(LunAux,I2Name(aGrp,beGrp))
c
c1.4      write I2 into proper file
          write (6,*) aGrp,beGrp,len
          call wri_chcc (LunAux,len,I2(1))
c
          close (LunAux)
c
        end do
        end do
c
c
        return
        end
c
c       ----------------
c
        subroutine UrobI3 (I3,NaGrp,NbeGrp,LunAux)
c
c       vyraba fily so simulovanymi I3       vektormi
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
#include "o3v3.fh"
#include "chcc_files.fh"
c
        integer NaGrp,NbeGrp,LunAux
        real*8 I3(1)
c
c       help variables
        integer aGrp,beGrp,len
        real*8 schem
c
c1      cycle over a,be Groups
c
        do aGrp=1,NaGrp
        do beGrp=1,NbeGrp
c
c1.1      def length
          if (aGrp.eq.beGrp) then
          len=no*(no+1)*DimGrpv(aGrp)*(DimGrpv(beGrp)+1)/4
          else
          len=no*(no+1)*DimGrpv(aGrp)*DimGrpv(beGrp)/2
          end if
c
c1.2      full I3 with random numbers
          schem=1.0d-2
          call RNFill (len,I3(1),schem)
c
c1.3      open proper file
*         open (unit=LunAux,file=I3Name(aGrp,beGrp),form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(LunAux,I3Name(aGrp,beGrp))
c
c1.4      write I3 into proper file
          write (6,*) aGrp,beGrp,len
          call wri_chcc (LunAux,len,I3(1))
c
          close (LunAux)
c
        end do
        end do
c
c
        return
        end
c
c       ----------------
c
        subroutine UrobT2 (T2,NaGrp,NbeGrp,LunAux)
c
c       vyraba fily so simulovanymi T2       vektormi
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
#include "o3v3.fh"
#include "chcc_files.fh"
c
        integer NaGrp,NbeGrp,LunAux
        real*8 T2(1)
c
c       help variables
        integer aGrp,beGrp,len
        real*8 schem
c
c1      cycle over a,be Groups
c
        do aGrp=1,NaGrp
        do beGrp=1,NbeGrp
c
c1.1      def length
          len=no*(no+1)*DimGrpv(aGrp)*DimGrpv(beGrp)/2
c
c1.2      full T2 with random numbers
          schem=1.0d-2
          call RNFill (len,T2(1),schem)
c
c1.3      open proper file
*         open (unit=LunAux,file=T2Name(aGrp,beGrp),form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(LunAux,T2Name(aGrp,beGrp))
c
c1.4      write T2 into proper file
          write (6,*) aGrp,beGrp,len
          call wri_chcc (LunAux,len,T2(1))
c
          close (LunAux)
c
        end do
        end do
c
c
        return
        end
c
c       ----------------
c
cmp!        subroutine TimeDelay (LunAux)
cmp!c
cmp!c        this routine do:
cmp!c        only on myRank=0
cmp!c        1) Read nTime, keyRep from ClcFil
cmp!c        2) wait nTime (sec)
cmp!c        3) for keyRep - 1 - goto 1
cmp!c                       0 - continue
cmp!c        on all nodes
cmp!c        4) allreduce Blnk (useless) in order to catch
cmp!c           time delay on all nodes
cmp!c
cmp!c
cmp!        implicit none
cmp!        integer LunAux
cmp!        include 'para_info.fh'
cmp!        real*8 Blnk(1)
cmp!        integer nTime,keyRep
cmp!        logical ClcFilExist
cmp!c
cmp!c1        Delaying on master node
cmp!c
cmp!        if (myRank.eq.0) then
cmp!          inquire (file='ClcFil',exist=ClcFilExist)
cmp!          if (ClcFilExist) then
cmp!1            open (unit=LunAux,file='ClcFil')
cmp!            read (LunAux,*) nTime,keyRep
cmp!            close (LunAux)
cmp!c
cmp!            write (6,*) ' Sleep for :',nTime, keyRep
cmp!            call sleep (nTime)
cmp!            if (keyRep.eq.1) then
cmp!                  goto 1
cmp!            end if
cmp!          end if
cmp!        end if
cmp!c
cmp!c2        Defining Blnk (useless)
cmp!c
cmp!        Blnk(1)=1.0d0*myRank
cmp!c
cmp!c3        Allreduce Blnk (i.e. waiting on all nodes)
cmp!c
cmp!#ifdef _MOLCAS_MPP_
cmp!c##     Synchronizacny bod:
cmp!c       Allreduce Blank
cmp!        call gadgop (Blnk(1),1,'+')
cmp!#endif
cmp!c
cmp!        return
cmp!        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine casinfodef_cvb()

use casvb_global, only: inputmode, iorclos_d, iorcore_d, iorocc_d, mxorb_cvb, noe, nstsym_d, recn_jobiph, recn_jobold, &
                        recn_oneint, recn_vbwfn, strtci, strtint, strtmo, strtvb, savvb, savvbci, variat

implicit none

! Counters
nstsym_d = 0

noe = 2*mxorb_cvb
if (.not. variat) then
  strtci = recn_jobold
else
  strtci = recn_jobiph
end if
strtmo = recn_jobiph
strtint = recn_oneint
strtvb = recn_vbwfn
savvb = recn_vbwfn
savvbci = recn_jobiph

if (inputmode == 2) then
  iorcore_d(:) = -1
  iorclos_d(:) = -1
  iorocc_d(:) = -1
end if

return

end subroutine casinfodef_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine defvhlp9 (r2,v,dimr2b,dimr2a,dimr2ac,
     & dimva,dimvb,dimvc,adda,addc)
c
c     this routine do
c     V(a,b,c)aba = - R2(b,ac)
c     for syma.eq.symc
c
c     r2        - r2 matrix (I)
c     v        - v matrix (O)
c     dimr2b         - dimension of b in R2 (I)
c     dimr2a         - dimension of a (c) in R2 (I)
c     dimr2ac - dimension of ac in R2 (I)
c     dimva        - dimension of a in V (I)
c     dimvb        - dimension of b in V (I)
c     dimvc        - dimension of c in V (I)
c     adda    - additional constat to a (I)
c     addc    - additional constat to c (I)
c
#include "t31.fh"
       integer dimr2b,dimr2a,dimr2ac
       integer dimva,dimvb,dimvc,adda,addc
       real*8 r2(1:dimr2b,1:dimr2ac)
       real*8 v(1:dimva,1:dimvb,1:dimvc)
c
c     help variables
c
       integer a,b,c,cr2,acr2
c
c
       do 100 c=1,dimvc
       cr2=c+addc
       do 101 a=1,dimva
c      acr2=indab(a+adda,cr2)
         if ((a+adda).ge.cr2) then
           acr2=(a+adda)*(a+adda-1)/2+cr2
         else
           acr2=cr2*(cr2-1)/2+a+adda
         end if
       do 102 b=1,dimvb
       v(a,b,c)=-r2(b,acr2)
 102    continue
 101    continue
 100    continue
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dimr2a)
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018, Jesper Norell                                    *
************************************************************************
      SUBROUTINE DYSON(IFSBTAB1,
     &    IFSBTAB2,ISSTAB,
     &    DET1,DET2,
     &    IF10,IF01,DYSAMP,DYSCOF)

      IMPLICIT NONE
      INTEGER IFSBTAB1(*),IFSBTAB2(*),ISSTAB(*)
      INTEGER LORBTB
      INTEGER NASORB
      REAL*8 DET1(*),DET2(*),DYSAMP,DYSCOF(*)
      LOGICAL IF10,IF01

#include "symmul.fh"
#include "WrkSpc.fh"

! +++ J.Norell 12/7 - 2018
C Given two CI expansions, using a biorthonormal set of SD's,
C (assuming one state with N and one with N-1 electrons)
C calculate the following quantities:
C (1) The Dyson orbital norm between the two states (DYSAMP)
C (2) The Dyson orbital expansion coefficients in the
C     basis of active biorthonormal orbitals (DYSCOF)
C More functionality should be added here later.

      LORBTB=ISSTAB(3)
C Pick out nr of active orbitals from orbital table:
      NASORB=IWORK(LORBTB+3)

      CALL MKDYSORB(IWORK(LORBTB),ISSTAB,
     &               IFSBTAB1,IFSBTAB2,DET1,DET2,
     &               IF10,IF01,DYSAMP,DYSCOF)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ANNSTR(STRING,NSTINI,NSTINO,NEL,NORB,Z,NEWORD,LROW,LSGSTR,ISGSTI,ISGSTO,TI,TTO,I1TYP)
! A set of strings containing NEL electrons are given
! set up all possible ways of annihilating an electron from
! this set of string
!
!========
! Input :
!========
! STRING : Input strings containing NEL electrons
! NSTINI : Number of NEL  strings
! NSTINO : Number of NEL-1 strings
! NEL    : Number of electrons in input strings
! NORB   : Number of orbitals
! Z      : Lexical ordering matrix for output strings containing
!          NEL - 1 electrons
! NEWORD : Reordering array for N-1 strings
! LROW   : Number of rows in output vector
!          = NEL : Information is written in truncated form
!                  row  corresponds to place of electron
!          = NORB: Information is written in expanded form,
!                  row corresponds to full orbital number
! LSGSTI : /= 0 => use ISGSTI,ISGSTO to allow for sign of string
! ISGSTI : Sign array for NEL   strings
! ISGSTO : Sign array for NEL-1 strings
!
!=========
! Output :
!=========
!TI      : Array giving minus orbital annihilated
!          TI(I,ISTRIN) < 0 : Orbital TI(I,ISTRIN) can be
!          annihilated from string ISTRIN
!TTO     : Resulting NEL - 1 strings
!          if the resulting string has carries a negative sign
!          then the string number is shifted with a NSTINO
!          TTO(I,ISTRIN) = <= 0 indicates that orbital I cannot be
!                             added to istrin
!          TTO(I,ISTRIN) = LSTRIN /= 0 indicates that I added to
!                          ISTRIN  gives LSTRIN. If LSTRIN is
!                          nehative
!                          A+(I)!ISTRIN>=-!-LSTRIN>.

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSTINI, NEL, STRING(NEL,NSTINI), NSTINO, NORB, Z(NORB,NEL-1), NEWORD(NSTINO), LROW, LSGSTR, &
                                 ISGSTI(NSTINI), ISGSTO(NSTINO), I1TYP
integer(kind=iwp), intent(out) :: TI(LROW,NSTINI), TTO(LROW,NSTINI)
integer(kind=iwp) :: IEL, IEXPN, IIISGN, IPLACE, ISTRIN, ITYPE, JSTRIN, STRIN2(NEL-1)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I, NPR
integer(kind=iwp), parameter :: MAXPR = 60
#endif
integer(kind=iwp), external :: IOCTP2_MCLR, ISTRNM

#ifdef _DEBUGPRINT_
write(u6,*) ' ==============='
write(u6,*) ' ANNSTR speaking'
write(u6,*) ' ==============='
#endif
! Expanded or truncated form
if ((LROW == NEL) .and. (NEL /= NORB)) then
  IEXPN = 0
else
  IEXPN = 1
end if
! Loop over input strings
do ISTRIN=1,NSTINI
  ! loop over electrons to be removed
  do IEL=1,NEL
    if (IEXPN == 0) then
      IPLACE = IEL
    else
      IPLACE = STRING(IEL,ISTRIN)
    end if
    STRIN2(1:IEL-1) = STRING(1:IEL-1,ISTRIN)
    STRIN2(IEL:NEL-1) = STRING(IEL+1:NEL,ISTRIN)
    ! Is new string allowed ?
    ITYPE = IOCTP2_MCLR(STRIN2,NEL-1,I1TYP)
    if (ITYPE /= 0) then
      !        ISTRNM(IOCC,NORB,NEL,Z,NEWORD,IREORD)
      JSTRIN = ISTRNM(STRIN2,NORB,NEL-1,Z,NEWORD,1)
      TTO(IPLACE,ISTRIN) = JSTRIN
      TI(IPLACE,ISTRIN) = -STRING(IEL,ISTRIN)
      IIISGN = (-1)**(IEL-1)
      if (LSGSTR > 0) IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
      if (IIISGN == -1) TTO(IPLACE,ISTRIN) = -TTO(IPLACE,ISTRIN)
    end if
  end do
end do

#ifdef _DEBUGPRINT_
NPR = min(NSTINI,MAXPR)
write(u6,*) ' Output from ANNSTR :'
write(u6,*) '==================='
if (IEXPN == 0) then
  write(u6,*) ' Strings with an electron removed'
else
  write(u6,*) ' Combined N+1/N-1 string array'
end if
do ISTRIN=1,NPR
  write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' New strings.. ',(TTO(I,ISTRIN),I=1,LROW)
end do

write(u6,*) ' orbitals removed'
do ISTRIN=1,NPR
  write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' orbitals annihilated.. ',(TI(I,ISTRIN),I=1,LROW)
end do
#endif

return

end subroutine ANNSTR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine compute_txy(DM1,nDM,Txy,nTxy,nAuxVec,nIrrep,Diag,DMTmp,nAct)
!***********************************************************************
!                                                                      *
!     Compute the matrices needed for CD-CASSCF gradients              *
!                                                                      *
!     input : G2    = 2-body density matrix                           *
!             nDM    = size of the one-body DM                         *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use pso_stuff, only: G2, lsa, nnP
use Constants, only: Zero, One, Two, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDM, nTxy, nAuxVec, nIrrep, nAct(0:7)
real(kind=wp), intent(in) :: DM1(nDM,nAuxVec)
real(kind=wp), intent(out) :: Txy(nTxy,nAuxVec), Diag(nDM,nAuxVec), DMtmp(nTri_Elem(nDM))
integer(kind=iwp) :: i, icol, iend, iline, ista, isym, it, itu, ituvx, ituvx2, itv, itx, iu, iuv, iux, iv, iVec, ivx, ix, jend, &
                     jsta, jsym, kend, klsym, ksta, ksym, lend, lsta, lsym, nCumAct(0:7), nCumAct2(0:7), nkl, nvx, Txy_sta, Txy_sta2
real(kind=wp) :: Fac, Fac2, tmp

nCumAct(0) = 0
do i=1,nIrrep-1
  nCumAct(i) = nCumAct(i-1)+nAct(i-1)
end do

do iVec=1,nAuxVec
  !*********************************************************************
  !                                                                    *
  !   Remove Coulomb and exchange contribution from the 2DM            *
  !                                                                    *
  !*********************************************************************
  Txy_sta = 1
  Txy_sta2 = 1
  do klsym=0,nIrrep-1 ! compound symmetry
    nkl = 0

    do lSym=0,nIrrep-1
      lsta = nCumAct(lsym)+1
      lend = nCumAct(lsym)+nAct(lSym)

      ksym = Mul(lsym+1,klsym+1)-1
      if (ksym > lsym) cycle
      ksta = nCumAct(ksym)+1
      kend = nCumAct(ksym)+nAct(ksym)
      if (kSym == lSym) then
        nvx = nTri_Elem(nAct(lSym))
      else
        nvx = nAct(lSym)*nAct(ksym)
      end if
      nCumAct2(lSym) = nkl

      do jsym=0,lSym

        jsta = nCumAct(jsym)+1
        jend = nCumAct(jsym)+nAct(jSym)

        isym = Mul(jsym+1,klsym+1)-1
        if (isym > jsym) cycle
        ista = nCumAct(iSym)+1
        iend = nCumAct(iSym)+nAct(iSym)

        iline = nkl

        do ix=lsta,lend
          if (kSym == lSym) kend = ix
          do iv=ksta,kend
            ivx = iTri(ix,iv)
            if (jSym == lSym) jend = ix
            iline = iline+1
            icol = nCumAct2(jSym)
            do iu=jsta,jend
              iux = iTri(ix,iu)
              iuv = iTri(iu,iv)
              if (iSym == jSym) iend = iu
              do it=ista,iend
                itu = iTri(iu,it)
                if (itu > ivx) cycle
                itx = iTri(ix,it)
                itv = iTri(iv,it)
                ituvx = iTri(ivx,itu)
                icol = icol+1
                ituvx2 = nTri_Elem(iline-1)+icol

                Fac = One
                if (ix /= iv) Fac = Two*Fac
                if (it /= iu) Fac = Two*Fac
                Fac2 = One
                if (it == iu) Fac2 = Two

                DMTmp(ituvx2) = Fac*(Fac2*G2(ituvx,iVec))
                if (.not. lSA) then
                  ! For SA-CASSCF, don't remove Coulomb and exchange
                  if (iSym == jSym) DMTmp(ituvx2) = DMTmp(ituvx2)-Fac*(DM1(itu,iVec)*DM1(ivx,iVec))
                  if (iSym == kSym) DMTmp(ituvx2) = DMTmp(ituvx2)+Fac*(Quart*DM1(itv,iVec)*DM1(iux,iVec))
                  if (iSym == lSym) DMTmp(ituvx2) = DMTmp(ituvx2)+Fac*(Quart*DM1(itx,iVec)*DM1(iuv,iVec))
                end if

              end do
            end do
          end do
        end do

      end do
      nkl = nkl+nvx
    end do

    !*******************************************************************
    !                                                                  *
    ! Eigen-decompose the density                                      *
    !                                                                  *
    !*******************************************************************

    ! Diagonalize G2

    Txy(Txy_sta2:Txy_sta2+nkl**2-1,iVec) = Zero
    call dcopy_(nkl,[One],0,Txy(Txy_sta2,iVec),nkl+1)

    call NIdiag(DMTmp,Txy(Txy_sta2,iVec),nkl,nkl)

    ! Multiply by Sqrt[eigenvalue]

    do i=1,nkl
      Diag(i+Txy_sta-1,iVec) = DMTmp(nTri_Elem(i))
      tmp = sqrt(abs(DMTmp(nTri_Elem(i))))
      Txy(Txy_sta2+(i-1)*nkl:Txy_sta2+i*nkl-1,iVec) = tmp*Txy(Txy_sta2+(i-1)*nkl:Txy_sta2+i*nkl-1,iVec)
    end do

    ! Since there is no screening yet

    nnP(klsym) = nkl

    Txy_sta = Txy_sta+nkl
    Txy_sta2 = Txy_sta2+nkl**2
  end do
end do

end subroutine compute_txy

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Statistics
!
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Computes the following statistics for a data set \p X(i), \p i = ``1``, ``2``, ..., ``n``:
!>
!> - \p Stat(ip_Mean):      mean value
!> - \p Stat(ip_MeanAbs):   mean absolute value
!> - \p Stat(ip_Min):       minimum value
!> - \p Stat(ip_Max):       maximum value
!> - \p Stat(ip_MaxAbs):    maximum absolute value
!> - \p Stat(ip_Variance):  biased variance (i.e. RMS w.r.t. mean value)
!> - \p Stat(ip_VarianceU): unbiased variance
!>
!> @param[in]  X            Data array
!> @param[in]  n            Dimension of \p X
!> @param[out] Stat         Statistics
!> @param[in]  ip_Mean      Pointer to mean value in \p Stat
!> @param[in]  ip_MeanAbs   Pointer to mean abs. value in \p Stat
!> @param[in]  ip_Min       Pointer to min. value in \p Stat
!> @param[in]  ip_Max       Pointer to max. value in \p Stat
!> @param[in]  ip_MaxAbs    Pointer to max. abs. value in \p Stat
!> @param[in]  ip_Variance  Pointer to biased variance in \p Stat
!> @param[in]  ip_VarianceU Pointer to unbiased variance in \p Stat
!***********************************************************************

subroutine Statistics(X,n,Stat,ip_Mean,ip_MeanAbs,ip_Min,ip_Max,ip_MaxAbs,ip_Variance,ip_VarianceU)

use Constants, only: One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: n, ip_Mean, ip_MeanAbs, ip_Min, ip_Max, ip_MaxAbs, ip_Variance, ip_VarianceU
real(kind=wp), intent(in) :: X(n)
real(kind=wp), intent(_OUT_) :: Stat(*)
integer(kind=iwp) :: i
real(kind=wp) :: xMax, xMean, xMeanAbs, xMin, xn, xn1, xVariance

if (n < 1) return

xn = One/real(n,kind=wp)
if (n == 1) then
  xn1 = 9.99e15_wp
else
  xn1 = One/real(n-1,kind=wp)
end if

xMean = sum(X(1:n))
xMeanAbs = sum(abs(X(1:n)))
xMax = X(1)
xMin = X(1)
do i=2,n
  xMax = max(xMax,X(i))
  xMin = min(xMin,X(i))
end do
xMean = xMean*xn

if (ip_Mean > 0) Stat(ip_Mean) = xMean
if (ip_MeanAbs > 0) Stat(ip_MeanAbs) = xMeanAbs*xn
if (ip_Min > 0) Stat(ip_Min) = xMin
if (ip_Max > 0) Stat(ip_Max) = xMax
if (ip_MaxAbs > 0) Stat(ip_MaxAbs) = max(abs(xMax),abs(xMin))

if ((ip_Variance > 0) .or. (ip_VarianceU > 0)) then
  xVariance = sum((X(1:n)-xMean)**2)
  if (ip_VarianceU > 0) Stat(ip_VarianceU) = sqrt(xVariance*xn1)
  if (ip_Variance > 0) Stat(ip_Variance) = sqrt(xVariance*xn)
end if

end subroutine Statistics

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LDF_UpdateDiagonalFromC(Constraint,AB,l_C,C,irc)
      Implicit None
      Integer Constraint
      Integer AB
      Integer l_C
      Real*8  C(l_C)
      Integer irc
#include "localdf.fh"
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*23 SecNam
      Parameter (SecNam='LDF_UpdateDiagonalFromC')

      Integer  LDF_AtomPair_DiagDim, LDF_nBasAux_Pair
      External LDF_AtomPair_DiagDim, LDF_nBasAux_Pair

      Integer nAB
      Integer M
      Integer ip_G, l_G
      Integer ip_X, l_X
      Integer i, J, iJ
      Integer ipD
      Integer ipX0, ipX

      nAB=LDF_AtomPair_DiagDim(AB)
      M=LDF_nBasAux_Pair(AB)
      If (nAB.lt.1 .or. M.lt.1) Return
      If (l_C.lt.(nAB*M)) Then
         Call WarningMessage(2,SecNam//': insufficient array dimension')
         Call LDF_Quit(1)
      End If

      Call LDF_SetIndxG(AB)
      l_G=M**2
      Call GetMem('UDFCG','Allo','Real',ip_G,l_G)
      Call LDF_ComputeGMat(AB,M,Work(ip_G))
      l_X=nAB*M
      Call GetMem('UDFCX','Allo','Real',ip_X,l_X)
      Call LDF_ComputeIntegrals_uvJ(AB,l_X,Work(ip_X))
      Call dGeMM_('N','N',nAB,M,M,
     &            -1.0d0,C,nAB,Work(ip_G),M,
     &             2.0d0,Work(ip_X),nAB)
      ipD=iWork(ip_AP_Diag-1+AB)-1
      ipX0=ip_X-1
      Do J=0,M-1
         iJ=nAB*J
         ipX=ipX0+iJ
         Do i=1,nAB
            Work(ipD+i)=Work(ipD+i)-C(iJ+i)*Work(ipX+i)
         End Do
      End Do
      Call GetMem('UDFCX','Free','Real',ip_X,l_X)
      Call GetMem('UDFCG','Free','Real',ip_G,l_G)
      Call LDF_UnsetIndxG()

      irc=0
      Do i=1,nAB
         If (Work(ipD+i).lt.TooNegative) Then
            irc=irc+1
         End If
      End Do

c Avoid unused argument warnings
      If (.False.) Call Unused_integer(Constraint)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine MltInt_GIAO(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,
     &                       P,Final,nZeta,nIC,nComp,la,lb,A,RB,nHer,
     &                       Array,nArr,Ccoor,nOrdOp,lOper,iChO,
     &                       iStabM,nStabM,
     &                       PtChrg,nGrid,iAddPot)
************************************************************************
*                                                                      *
* Object: to compute the multipole moments integrals with the          *
*         Gauss-Hermite quadrature.                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Modified to multipole moments November '90               *
************************************************************************
      use Her_RW
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "oneswi.fh"
#include "print.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nIC),
     &       Zeta(nZeta), ZInv(nZeta), Alpha(nAlpha), Beta(nBeta),
     &       rKappa(nZeta), P(nZeta,3), A(3), RB(3), RAB(3),
     &       Array(nZeta*nArr), Ccoor(3), TC(3)
      Character*80 Label, ChOper(0:7)*3
      Integer lOper(nComp), iStabM(0:nStabM-1), iStabO(0:7),
     &          iDCRT(0:7), iChO(nComp)
      Logical ABeq(3), EQ
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement function
*
      nElem(i) = (i+1)*(i+2)/2
*
      iRout = 122
      iPrint = nPrint(iRout)
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
      If (EQ(A,RB)) Go To 999
*
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
      RAB(1)=A(1)-RB(1)
      RAB(2)=A(2)-RB(2)
      RAB(3)=A(3)-RB(3)
*     switch (only single center overlap matrix...)
      If (NDDO.AND.
     &    .NOT.(ABeq(1).AND.ABeq(2).AND.ABeq(3))) Then
        call dcopy_(nZeta*nIC*nElem(la)*nElem(lb),[Zero],0,Final,1)
        Return
      End If
*     switch
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+1)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+1)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp+2)
      ipQxyz = nip
      nip = nip + nZeta*3*(la+1)*(lb+1)*(nOrdOp+2)
      ipFnl = nip
      nip = nip + nZeta*nElem(la)*nElem(lb)*nComp
      If (nip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'MltInt_GIAO: nip-1.gt.nArr*nZeta')
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Write (6,*) ' Abend in MltInt'
         Call Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In MltInt: A',' ',A,1,3)
         Call RecPrt(' In MltInt: RB',' ',RB,1,3)
         Call RecPrt(' In MltInt: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In MltInt: Kappa',' ',rKappa,nAlpha,nBeta)
         Call RecPrt(' In MltInt: Zeta',' ',Zeta,nAlpha,nBeta)
         Call RecPrt(' In MltInt: P',' ',P,nZeta,3)
         Write (6,*) ' In MltInt: la,lb=',la,lb
      End If
*
      llOper = lOper(1)
      Do 90 iComp = 2, nComp
         llOper = iOr(llOper,lOper(iComp))
 90   Continue
*
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb,HerR(iHerR(nHer)),nHer,ABeq)
*
*
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
      If (iPrint.ge.99) Then
         Write (6,*) ' m      =',nStabM
         Write (6,'(9A)') '{M}=',(ChOper(iStabM(ii)),ii = 0, nStabM-1)
         Write (6,*) ' s      =',nStabO
         Write (6,'(9A)') '{S}=',(ChOper(iStabO(ii)),ii = 0, nStabO-1)
         Write (6,*) ' LambdaT=',LmbdT
         Write (6,*) ' t      =',nDCRT
         Write (6,'(9A)') '{T}=',(ChOper(iDCRT(ii)),ii = 0, nDCRT-1)
      End If
*
      Do 102 lDCRT = 0, nDCRT-1
         Call OA(iDCRT(lDCRT),CCoor,TC)
*
*        Compute the contribution from the multipole moment operator
*
         ABeq(1) = .False.
         ABeq(2) = .False.
         ABeq(3) = .False.
         Call CrtCmp(Zeta,P,nZeta,TC,Array(ipRxyz),
     &               nOrdOp+1,HerR(iHerR(nHer)),nHer,ABeq)
*
*        Compute the cartesian components for the multipole moment
*        integrals. The integrals are factorized into components.
*
          Call Assmbl(Array(ipQxyz),
     &                Array(ipAxyz),la,
     &                Array(ipRxyz),nOrdOp+1,
     &                Array(ipBxyz),lb,
     &                nZeta,HerW(iHerW(nHer)),nHer)
*
*        Combine the cartesian components to the full one electron
*        integral.
*
         nB=3
         Call CmbnMP_GIAO(Array(ipQxyz),nZeta,la,lb,nOrdOp,Zeta,rKappa,
     &                    Array(ipFnl),nComp/nB,nB,RAB,TC)
*
*        Accumulate contributions
*
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array(ipFnl),nZeta,la,lb,nComp,Final,nIC,
     &               nOp         ,lOper,iChO,One)
*
 102  Continue
*
 999  Continue
      If (iPrint.ge.99) Then
         Write (6,*) ' Result in MltInt'
         Do 100 ia = 1, (la+1)*(la+2)/2
            Do 200 ib = 1, (lb+1)*(lb+2)/2
               Do 300 iIC = 1, nIC
                  Write (Label,'(A,I2,A,I2,A,I2,A)')
     &               ' Final(a=',ia,',b=',ib,',iIC=',iIC,')'
                  Call RecPrt(Label,' ',Final(1,ia,ib,iIC),nAlpha,nBeta)
 300           Continue
 200        Continue
 100     Continue
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_real_array(ZInv)
         Call Unused_real(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!               2000, Valera Veryazov                                  *
!               2014, Thomas Dresselhaus                               *
!***********************************************************************

subroutine MOEval(MOValue,nMOs,nCoor,CCoor,CMOs,nCMO,DoIt,nDrv,mAO)
!***********************************************************************
!      Author:Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN. November 1995                           *
!                                                                      *
!      Modified: Thomas Dresselhaus, March 2014                        *
!                Added ability to calculate 2nd derivative as well     *
!***********************************************************************

use Real_Spherical, only: ipSph, RSph
use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Phase_Info, only: iPhase
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
! nDrv: Between 0 and 2. The highest derivative to be calc.
! mAO:  Memory slots per point and basis functions. Should be >=1 for nDrv=0, >=4 for nDrv=1, >=10 for nDrv=2.
integer(kind=iwp), intent(in) :: nMOs, nCoor, nCMO, DoIt(nMOs), nDrv, mAO
real(kind=wp), intent(out) :: MOValue(mAO,nCoor,nMOs)
real(kind=wp), intent(in) :: CCoor(3,nCoor), CMOs(nCMO)
#include "print.fh"
integer(kind=iwp) :: iAng, iAO, iAOttp, iBas, iCmp, iCnt, iCnttp, iDrv, iG, iPrim, iPrint, ipx, ipy, ipz, iRout, iShll, iSkal, &
                     kSh, mdc, mRad, nAngular, nAO, nCnt, nDeg, nElem, nForm, nOp, nRadial, nSO, nTerm, nTest, nxyz
real(kind=wp) :: A(3), px, py, pz, RA(3), Thr
integer(kind=iwp), allocatable :: Ang(:)
real(kind=wp), allocatable :: AOs(:), Radial(:), SOs(:), xyz(:)
integer(kind=iwp), external :: NrOpr

iRout = 112
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  write(u6,*) ' In MOEval'
end if
MOValue(:,:,:) = Zero

! Loop over shells.

iSkal = 0
Thr = Zero

do iAng=S%iAngMx,0,-1

  if (S%MaxPrm(iAng) == 0) cycle
  if (S%MaxBas(iAng) == 0) cycle

  ! Loop over basis sets. Skip if basis set do not include
  ! angular momentum functions as specified above.

  iAOttp = 0
  mdc = 0
  do iCnttp=1,nCnttp

    if (iCnttp > 1) then
      mdc = mdc+dbsc(iCnttp-1)%nCntr
      iAOttp = iAOttp+dbsc(iCnttp-1)%lOffAO*dbsc(iCnttp-1)%nCntr
    end if

    nTest = dbsc(iCnttp)%nVal
    if (iAng+1 > nTest) cycle
    if (dbsc(iCnttp)%Aux) cycle
    if (dbsc(iCnttp)%Frag) cycle
    nCnt = dbsc(iCnttp)%nCntr
    iShll = dbsc(iCnttp)%iVal+iAng
    iPrim = Shells(iShll)%nExp
    if (iPrim == 0) cycle
    iBas = Shells(iShll)%nBasis
    if (iBas == 0) cycle
    if (Shells(iShll)%Prjct) then
      iCmp = 2*iAng+1
    else
      iCmp = (iAng+1)*(iAng+2)/2
    end if

    call OrdExpD2C(iPrim,Shells(iShll)%Exp,iBas,Shells(iShll)%pCff)
    kSh = dbsc(iCnttp)%iVal+iAng

    ! Loop over unique centers of basis set "iCnttp"

    do iCnt=1,nCnt

      iAO = iAOttp+(iCnt-1)*dbsc(iCnttp)%lOffAO+Shells(kSh)%kOffAO
      A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

      !------- Allocate memory for SO and AO values

      mRad = nDrv+1

      nForm = 0
      do iDrv=0,nDrv
        nForm = nForm+(iDrv+1)*(iDrv+2)/2
      end do
      nTerm = 2**nDrv

      nAO = (iCmp*iBas*nCoor)*(mAO)
      nSO = nAO*nIrrep/dc(mdc+iCnt)%nStab
      nDeg = nIrrep/dc(mdc+iCnt)%nStab
      call mma_allocate(AOs,nAO,label='AOs')
      call mma_allocate(SOs,nSO,label='SOs')
      SOs(:) = Zero
      nxyz = nCoor*3*(iAng+mRad)
      call mma_allocate(xyz,nxyz,label='xyz')
      nRadial = iBas*nCoor*mRad
      call mma_allocate(Radial,nRadial,label='Radial')

      nAngular = 5*nForm*nTerm
      call mma_allocate(Ang,nAngular,label='Angular')

      !------- Loops over symmetry operations operating on the basis set center.

      do iG=0,nIrrep/dc(mdc+iCnt)%nStab-1
        iSkal = iSkal+1
        call OA(dc(mdc+iCnt)%iCoSet(iG,0),A,RA)
        ipx = iPhase(1,dc(mdc+iCnt)%iCoSet(iG,0))
        ipy = iPhase(2,dc(mdc+iCnt)%iCoSet(iG,0))
        ipz = iPhase(3,dc(mdc+iCnt)%iCoSet(iG,0))
        px = real(iPhase(1,dc(mdc+iCnt)%iCoSet(iG,0)),kind=wp)
        py = real(iPhase(2,dc(mdc+iCnt)%iCoSet(iG,0)),kind=wp)
        pz = real(iPhase(3,dc(mdc+iCnt)%iCoSet(iG,0)),kind=wp)
        nOp = NrOpr(dc(mdc+iCnt)%iCoSet(iG,0))

        !----- Evaluate AOs at RA

        AOs(:) = Zero
        nElem = (iAng+1)*(iAng+2)/2
        call AOEval(iAng,nCoor,CCoor,xyz,RA,Shells(iShll)%Transf,RSph(ipSph(iAng)),nElem,iCmp,Ang,nTerm,nForm,Thr,mRad,iPrim, &
                    iPrim,Shells(iShll)%Exp,Radial,iBas,Shells(iShll)%pCff,AOs,mAO,px,py,pz,ipx,ipy,ipz)

        !----- Distribute contributions to the SOs

        call SOAdpt(AOs,mAO,nCoor,iBas,iCmp,nOp,SOs,nDeg,iAO)

      end do ! iG

      !------- Distribute contributions to the MOs

      call SODist(SOs,mAO,nCoor,iBas,iCmp,nDeg,MOValue,nMOs,iAO,CMOs,nCMO,DoIt)

      call mma_deallocate(AOs)
      call mma_deallocate(SOs)
      call mma_deallocate(xyz)
      call mma_deallocate(Radial)
      call mma_deallocate(Ang)

    end do ! iCnt
  end do
end do

return

end subroutine MOEval

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DIAGCT()
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
#include "WrkSpc.fh"
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
* ----------------------------------------------------------------------
      NINDS=(NBITM1+2)*NCHN1
      NBUFS=NBITM1*NCHN1
      CALL GETMEM('Bufs','Allo','Real',LBUFS,NBUFS)
      CALL GETMEM('Inds','Allo','Inte',LINDS,NINDS)
      NBUFBI=KBUFF1
      CALL GETMEM('BUFBI','Allo','Real',LBUFBI,NBUFBI)
      CALL GETMEM('BIAC1','Allo','Real',LBIAC1,ISMAX)
      CALL GETMEM('BICA1','Allo','Real',LBICA1,ISMAX)
      CALL DCOPY_(NBUFS,[0.0D0],0,Work(LBUFS),1)
      CALL ICOPY(NINDS,[0],0,IWork(LINDS),1)
      CALL SORTA (Work(LBUFS),IWork(LINDS),IWork(LISAB),
     *            Work(LBUFBI),Work(LBIAC1),Work(LBICA1),NINTGR)
      CALL GETMEM('BIAC1','Free','Real',LBIAC1,ISMAX)
      CALL GETMEM('BICA1','Free','Real',LBICA1,ISMAX)
      CALL GETMEM('BUFBI','Free','Real',LBUFBI,NBUFBI)
      CALL GETMEM('Bufs','Free','Real',LBUFS,NBUFS)
      CALL GETMEM('Inds','Free','Inte',LINDS,NINDS)
* ----------------------------------------------------------------------

      IF(IFIRST.EQ.0) THEN
      NINDS=(NBITM2+2)*NCHN2
      NBUFS=NBITM2*NCHN2
      CALL GETMEM('Bufs','Allo','Real',LBUFS,NBUFS)
      CALL GETMEM('Inds','Allo','Inte',LINDS,NINDS)
      CALL GETMEM('BACBD','Allo','Real',LBACBD,KBUFF1)
      CALL GETMEM('ACBDT','Allo','Real',LACBDT,ISMAX)
      CALL GETMEM('ACBDS','Allo','Real',LACBDS,ISMAX)
      CALL DCOPY_(NBUFS,[0.0D0],0,Work(LBUFS),1)
      CALL ICOPY(NINDS,[0],0,IWork(LINDS),1)
      CALL SORTB (Work(LBUFS),IWork(LINDS),
     *            Work(LACBDS),Work(LACBDT),IWork(LISAB),
     *            Work(LBACBD),NINTGR)
      CALL GETMEM('BACBD','Free','Real',LBACBD,KBUFF1)
      CALL GETMEM('ACBDT','Free','Real',LACBDT,ISMAX)
      CALL GETMEM('ACBDS','Free','Real',LACBDS,ISMAX)
      CALL GETMEM('Bufs','Free','Real',LBUFS,NBUFS)
      CALL GETMEM('Inds','Free','Inte',LINDS,NINDS)
      END IF
* ------------------- SORT --------------------------------------------
      NINDS=(NBITM3+2)*NCHN3
      NBUFS=NBITM3*NCHN3
      CALL GETMEM('Bufs','Allo','Real',LBUFS,NBUFS)
      CALL GETMEM('Inds','Allo','Inte',LINDS,NINDS)
      CALL GETMEM('FIIJJ','Allo','Real',LIIJJ,NBTRI)
      CALL GETMEM('FIJIJ','Allo','Real',LIJIJ,NBTRI)
      CALL DCOPY_(NBUFS,[0.0D0],0,Work(LBUFS),1)
      CALL ICOPY(NINDS,[0],0,IWork(LINDS),1)
      CALL SORT_MRCI (Work(LBUFS),IWork(LINDS),Work(LFOCK),Work(LIIJJ),
     *           Work(LIJIJ),NINTGR)
      CALL GETMEM('Bufs','Free','Real',LBUFS,NBUFS)
      CALL GETMEM('Inds','Free','Inte',LINDS,NINDS)
* ----------------------------------------------------------------------
      NVT=(NVIRT*(NVIRT+1))/2
      NHDIAG=MAX(NVT,IRC(1))
      CALL GETMEM('HDIAG','Allo','Real',LHDIAG,NHDIAG)
      CALL IIJJ (IWork(LCSPCK),IWork(LINTSY),Work(LHDIAG),
     *           Work(LFOCK),Work(LIIJJ),Work(LIJIJ))
      CALL GETMEM('FIIJJ','Free','Real',LIIJJ,NBTRI)
      CALL IJIJ (IWork(LINTSY),Work(LHDIAG),Work(LFOCK),Work(LIJIJ))
      CALL GETMEM('HDIAG','Free','Real',LHDIAG,NHDIAG)
      CALL GETMEM('FIJIJ','Free','Real',LIJIJ,NBTRI)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine SCATTLEN(JROT,SL,VLIM,V,WF,BFCT,YMIN,YH,NPP,CNN,NCN,IWR,LPRWF)
!***** Subroutine SCATTLEN, last updated 30 April 2011 ****
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!** SCATTLEN solves the radial Schrodinger equation in dimensionless
!  form  d^2WF/dy^2 = - [(VLIM-V(R))*(r')^2 - F(y)]*WF(y) ,  where WF(I)
!  is the wave function,  y  the reduced radial vble. y_p(r), and  VLIM
!  the energy at the potential asymptote, to determine the scattering
!  length  SL.
!** Integrate by Numerov method over NPP mesh points with increment
!  H=YH across range from YMIN  to  YMAX= 1. Then uses interpoaltion
!  over last 5 \phi(y) values to the \phi'(y=1) in order to generate
!  SL from log-derivative equation.  After completing the calculation
!  using mesh YH, repeat it with mesh 2*YH and thn use Richardson
!  extrapolation (RE) to improve the final result.  Scheme used requires
!  PRV= 1.0.
!** Input potential asymptote VLIM has have units (cm-1).
!** On entry, the input potential V(I) must include the centrifugal
!  term and the factor:  'BFCT'=2*mu*(2*pi*YH/hbar)**2  (1/cm-1)
!   = ZMU[u]*YH[Angst]**2/16.85762920 (1/cm-1)  which is also
!  (internally) incorporated into VLIM.  Note that inclusion of the
!  squared integration increment YH**2 saves arithmetic in the
!  innermost loop of the algorithm.
!-----------------------------------------------------------------------
!** Output scattering length SL [Angst] normalized wave function WF(I)
!  and range, NBEG <=  I <=  NEND  over which WF(I) is defined. Define
!  WF(I)=0  outside the range (NBEG,NEND), which is defined by requiring
!  abs(WF(I)) < RATST=1.0e-9  outside.
!** If(LPRWF > 0) print [WRITE(u6,xxx)] wavefx WF(I) every LPRWF-th point.
!* If(LPRWF < 0) every |LPRWF|-th point of the wave function to Channel
!      10 starting at R(NBEG)
!** If(IWR /= 0) print error & warning descriptions
!  If (IWR >= 2) also show end-of-range wave function amplitudes
!  If (IWR >= 3) print also intermediate trial eigenvalues, etc.
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

use LEVEL_COMMON, only: ARV, DRDY2, PRV, RVB, SDRDY, YVB
use Constants, only: Zero, One, Two, Three, Four, Six, Eight, Ten, Twelve
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: JROT
integer(kind=iwp), intent(in) :: NPP, NCN, IWR, LPRWF
real(kind=wp), intent(out) :: SL, WF(NPP)
real(kind=wp), intent(in) :: VLIM, V(NPP), BFCT, YMIN, YH, CNN
integer(kind=iwp) :: I, ITP1, ITP1P, JPSIQ, NBEG, NNH, NODE, NPR
real(kind=wp) :: C4BAR, DSOC, GI, GN, HT, PHIp1, PHIp2, PHIp3, PHIp4, RATIN, RINC, RSTT, SB, SI, SL2, SLcor, sumSL, sumVV, WF0, &
                 WF1, WF2, WF3, WF4, Y1, Y2, Y3, YMINN, Z4
logical(kind=iwp) :: Found
real(kind=wp), parameter :: RATST = 1.0e-9_wp

WF4 = 0
if (abs(PRV-One) > Zero) then
  ! Scattering length calculation assumes  PRV=1  s.th.  FAS= 0.0
  write(u6,620) PRV
  SL = Zero
  return
end if
Z4 = Four
YMINN = YMIN-YH
HT = One/Twelve
DSOC = VLIM*BFCT
RATIN = Zero
NBEG = 1
C4BAR = Zero
if (NCN == 4) C4BAR = BFCT*CNN/(Two*ARV)**2
! Begin by checking that Numerov is stable at innermost end of range ...
do
  GN = V(NBEG)-DSOC*DRDY2(NBEG)
  if (GN <= Ten) exit
  ! If potential has [V(i)-E] so high that H is (locally) too ;arge,
  ! then shift inner starting point outward.
  NBEG = NBEG+1
  if (NBEG >= NPP) then
    if (IWR /= 0) write(u6,600)
    ! ERROR condition if  E > V(R)  at outer end of integration range.
    ! Return in error mode
    JROT = -1
    return
  end if
end do
if (IWR /= 0) then
  if (NBEG > 1) write(u6,602) JROT,NBEG,YVB(NBEG)
  if (GN <= Zero) write(u6,604) JROT,NBEG,V(NBEG)/BFCT
end if
NNH = (NPP-NBEG)/2
if ((NPP-NBEG) > (2*NNH)) then
  ! If necessary, adjust NBEG by 1 to ensure interval has an even
  ! no. mesh points in order to simplify RE correction step
  NBEG = NBEG+1
  GN = V(NBEG)-DSOC*DRDY2(NBEG)
end if
! Initialize outward wave function with a node:  WF(NBEG) = 0.
SB = Zero
SI = One
GI = V(NBEG+1)-DSOC*DRDY2(NBEG+1)
Y1 = SB*(One-HT*GN)
Y2 = SI*(One-HT*GI)
WF(NBEG) = SB
WF(NBEG+1) = SI
NODE = 0
!sumSL = SI*(GI/SDRDY(NBEG+1))*(One+YVB(NBEG+1))/(One-YVB(NBEG+1))
sumSL = SI*GI*(One+YVB(NBEG+1))
! Actual outward integration loops start here
Found = .false.
do I=NBEG+2,NPP
  Y3 = Y2+Y2-Y1+GI*SI
  GI = V(I)-DSOC*DRDY2(I)
  SI = Y3/(One-HT*GI)
  WF(I) = SI
  !sumSL = sumSL+(GI*SI/SDRDY(I))*(One+YVB(I))/(One-YVB(I))
  sumSL = sumSL+GI*SI*(One+YVB(I))
  if (abs(SI) >= 1.0e36_wp) then
    ! Renormalize to prevent overflow of  WF(I)  in classically forbidden
    ! region where  V(I) > E
    SI = One/SI
    sumSL = sumSL*SI
    WF(NBEG:I) = WF(NBEG:I)*SI
    Y2 = Y2*SI
    Y3 = Y3*SI
    SI = One
  end if
  ITP1 = I
  ! Exit from this loop at onset of classically allowed region
  if (GI <= Zero) then
    Found = .true.
    exit
  end if
  Y1 = Y2
  Y2 = Y3
end do
if (.not. Found) then
  if (IWR /= 0) write(u6,606) JROT,NPP
  ! ERROR condition if  E > V(R)  at outer end of integration range.
  ! Return in error mode
  JROT = -1
  return
end if
ITP1P = ITP1+1
do I=ITP1P,NPP-1 ! Now - integrate automatically to second-last mesh point ...
  Y1 = Y2
  Y2 = Y3
  Y3 = Y2+Y2-Y1+GI*SI
  GI = V(I)-DSOC*DRDY2(I)
  SB = SI
  SI = Y3/(One-HT*GI)
  sumSL = sumSL+GI*SI*(One+YVB(I))
  ! perform node count ...
  if ((SI*SB <= Zero) .and. (abs(SI) > Zero)) NODE = NODE+1
  WF(I) = SI
end do
! Finally ... complete integration to very last mesh point at  y= 1,
Y1 = Y2
Y2 = Y3
Y3 = Y2+Y2-Y1+GI*SI
if (NCN > 4) GI = Zero
if (NCN == 4) GI = -C4BAR
SB = SI
SI = Y3/(One-HT*GI)
WF(NPP) = SI
! Now generate a value for \phi'(y=1) from the WF values using
! "Newton's formula for forward interpolation" as described in
! Sect. 1.4 of K. Smith "Calculation of Atomic Collision Processes"`
PHIp1 = (WF(NPP)-WF(NPP-1))/YH
PHIp2 = PHIp1+(WF(NPP)-Two*WF(NPP-1)+WF(NPP-2))/(Two*YH)
PHIp3 = PHIp2+(WF(NPP)-Three*WF(NPP-1)+Three*WF(NPP-2)-WF(NPP-3))/(Three*YH)
PHIp4 = PHIp3+(WF(NPP)-Four*WF(NPP-1)+Six*WF(NPP-2)-Four*WF(NPP-3)+WF(NPP-4))/(Four*YH)
SL = ARV*(Two*PHIp4/WF(NPP)-One)
write(u6,608) SL,PHIp4/SI,PHIp1,PHIp2,PHIp3,PHIp4
!=======================================================================

! If desired, calculate partial derivatives of scattering length
! w.r.t. parameters.
! DF*H  is the integral of  (WF(I))**2 dR
!if (NPARM > 0) then
!DADPARM(1:NPARM) = Zero
!do I= NBEG,NPP
!  DF = DRDY2(I)*WF(I)**2
!  DADPARM(1:NPARM) = DADPARM(1:NPARM)+DF*DVDP(I,1:NPARM)
!end do
!DADPARM(1:NPARM) = DADPARM(1:NPARM)*YH

if ((abs(RATIN) > RATST) .and. (YMIN > Zero)) write(u6,614) JROT,RATIN
if (LPRWF < 0) then
  ! If desired, write every |LPRWF|-th point of the wave function
  ! to a file on channel-10, starting at the NBEG-th mesh point.
  JPSIQ = -LPRWF
  NPR = 1+(NPP-NBEG)/JPSIQ
  RINC = YH*JPSIQ
  RSTT = YMINN+NBEG*YH
  ! Write every JPSIQ-th point of the wave function, beginning at mesh
  ! point NBEG & distance RSTT where
  ! the NPR values written separated by mesh step RINC=JPSIQ*YH
  write(10,701) JROT,NPR,RSTT,RINC,NBEG,JPSIQ
  write(10,702) (YVB(I),WF(I),I=NBEG,NPP,JPSIQ)
end if

! Now ... re-do SL calculation with twice the step size to allow
! Richardson Extraoplation correction extimation ...
! Initialize outward wave function with a node:  WF(NBEG) = 0.
SB = Zero
SI = One
GN = Z4*(V(NBEG)-DSOC*DRDY2(NBEG))
GI = Z4*(V(NBEG+2)-DSOC*DRDY2(NBEG+2))
Y1 = SB*(One-HT*GN)
Y2 = SI*(One-HT*GI)
WF1 = SB
WF0 = SI
!sumSL = SI*(GI/SDRDY(NBEG+1))*(One+YVB(NBEG+1))/(One-YVB(NBEG+1))
sumSL = SI*GI*(One+YVB(NBEG+2))
! Actual outward integration loops start here
Found = .false.
do I=NBEG+4,NPP,2
  WF1 = WF0
  Y3 = Y2+Y2-Y1+GI*SI
  GI = (V(I)-DSOC*DRDY2(I))*Z4
  SI = Y3/(One-HT*GI)
  WF0 = SI
  !sumSL = sumSL+(GI*SI/SDRDY(I))*(One+YVB(I))/(One-YVB(I))
  sumSL = sumSL+GI*SI*(One+YVB(I))
  if (abs(SI) >= 1.0e36_wp) then
    ! Renormalize to prevent overflow of  WF(I)  in classically forbidden
    ! region where  V(I) > E
    SI = One/SI
    WF1 = WF1*SI
    sumSL = sumSL*SI
    Y2 = Y2*SI
    Y3 = Y3*SI
    SI = One
    WF0 = SI
  end if
  ITP1 = I
  ! Exit from this loop at onset of classically allowed region
  if (GI <= Zero) then
    Found = .true.
    exit
  end if
  Y1 = Y2
  Y2 = Y3
end do
if (.not. Found) then
  if (IWR /= 0) write(u6,606) JROT,NPP
  ! ERROR condition if  E > V(R)  at outer end of integration range.
  ! Return in error mode
  JROT = -1
  return
end if
ITP1P = ITP1+2
WF2 = WF1
WF3 = WF2
do I=ITP1P,NPP,2
  ! Now - integrate automatically to second-last mesh point ...
  Y1 = Y2
  Y2 = Y3
  Y3 = Y2+Y2-Y1+GI*SI
  GI = (V(I)-DSOC*DRDY2(I))*Z4
  if (I == NPP) then
    if (NCN > 4) GI = Zero
    if (NCN == 4) GI = -C4BAR*Z4
  end if
  !if (NCN > 4) GI = Zero
  !... HEY ... RJ should go & figure out how to treat the C4 case!
  !C4bar = BFCT*C4/(4*ARV**2)   ???
  WF4 = WF3
  WF3 = WF2
  WF2 = WF1
  WF1 = WF0
  SI = Y3/(One-HT*GI)
  WF0 = SI
  sumSL = sumSL+GI*SI*(One+YVB(I))
end do
! Now generate a value for  \phi'(y=1) from the WF values using
! "Newton's formula for forward interpolation" as described in
! Sect. 1.4 of K. Smith "Calculation of Atomic Collision Processes"`
PHIp1 = (WF0-WF1)/(Two*YH)
PHIp2 = PHIp1+(WF0-Two*WF1+WF2)/(Four*YH)
PHIp3 = PHIp2+(WF0-Three*WF1+Three*WF2-WF3)/(Six*YH)
PHIp4 = PHIp3+(WF0-Four*WF1+Six*WF2-Four*WF3+WF4)/(Eight*YH)
!... SL2  is scattering length associated with mesh of  2*YH
SL2 = ARV*(Two*PHIp4/WF0-One)
write(u6,608) SL2,PHIp4/SI,PHIp1,PHIp2,PHIp3,PHIp4
! Finally - user Ricardson expraolation of results for mesh  YH  and
! 2*YH  to obtain final optimum  SL estimate!
SLcor = SL+(SL-SL2)/15.0_wp
write(u6,610) YH,SLCOR,SL2,SL
write(8,610) YH,SLCOR,SL2,SL
!write(u6,612) NODE-1
SL = SLcor
! Now ... use second-last mesh point to normalize wavefunction to
! correspond to asymptotic normalization  \psi(r) \sim r .
SI = (RVB(NPP-1)-SL)/(WF(NPP-1)*SDRDY(NPP-1))
SUMVV = Zero
do I=NBEG,NPP-1
  WF(I) = WF(I)*SI
  ! ... and calculate expectation values of  V(r)  in cm-1
  SUMVV = SUMVV+DRDY2(I)*V(I)*WF(I)**2
end do
SUMVV = SUMVV/YH
write(u6,616) SUMVV,BFCT

write(u6,612) NODE-1

return

600 format(/' *** ERROR in potential array ... V(I) everywhere too big to integrate with given  increment')
602 format(' *** For  J=',I3,"  integration can't start till past"/23x,'mesh point',I5,' (yp=',f6.2, &
           '),  so YMIN smaller than needed')
604 format('   NOTE:  for  J=',I3,'   V(',i3,')=',F12.4,' <= 0.0')
606 format(/' *** ERROR *** for   J =',I3,'  Innermost turning point not found by   M = MSAVE =',I5)
608 format(/' Calculate  SL=',ES21.13,'   log-derivative(y=1)=',ES20.12/'     with slope convergence:',ES21.13/(28x,ES21.13))
610 format(/' YH=',f10.7,'  gives  SL(RE)=',ES21.13,':  SL2=',ES21.13/55x,'SL=',ES21.13)
612 format(/' Last bound level of this potential is   v=',i3////)
614 format(' *** CAUTION *** For  J=',I3,'   WF(first)/WF(Max)=',ES9.2,'  suggests  YMIN  may be too large')
616 format(' Expectation value of  V(r) is:',ES17.8,'   BFCT=',ES17.8)
620 format(/' *** ERROR in scattlen ***  Input  PRV=',F7.3,'  /= 1')
701 format(/2x,'For   J=',I3,',  wave function at',I6,' points.'/7x,'R(1-st)=',F12.8,'   mesh=',F12.8,'   NBEG=',I4,'   |LPRWF|=', &
           I3)
702 format((1X,4(f9.5,ES13.5)))

end subroutine SCATTLEN

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996,1999, Per Ake Malmqvist                           *
!***********************************************************************
!--------------------------------------------*
! 1996  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
! 1999: GEMINAL-R12 ENABLED                  *
!--------------------------------------------*

subroutine PCG(ICONV)

use INPUTDATA, only: INPUT
use caspt2_global, only: do_grad, EMP2, imag_shift, iPrGlb, LISTS, nStpGrd, real_shift, sigma_p_epsilon
use PrintLevel, only: TERSE, USUAL
use EQSOLV, only: iRHS, iVecc, iVecc2, iVecR, iVecX, NLSTOT
use caspt2_module, only: Cases, DeNorm, E2Corr, E2Tot, ERef, HZERO, IfChol, MaxIt, MxCase, nSym, rNorm, ThrConv
use SC_NEVPT2, only: Do_SC, ECORR_SC, OVLAPS_SC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ICONV
integer(kind=iwp) :: IC, IS, ITER, IVECP, IVECT, IVECU, LAXITY
real(kind=wp) :: ALPHA, BETA, DSCALE, E2NONV, EAIVX, EATVX, EBJAI, EBJAT, EBVAT, ECORR(0:8,0:MXCASE), ESHIFT, EVJAI, EVJTI, EVJTU, &
                 OVLAPS(0:8,0:MXCASE), PR, PT, REFWGT, SAV, SAVI, savreg, UR
integer(kind=iwp), external :: Cho_X_GetTol

! Flag to tell whether convergence was obtained
ICONV = 0

! Lists of coupling coefficients, used for sigma vector
! generation from non-diagonal blocks of H0.
call mma_allocate(LISTS,NLSTOT,LABEL='LISTS')
call MKLIST(LISTS,NLSTOT)

! Mnemonic names for vectors stored on LUSOLV, see EQCTL.
! Here, we use the local names IVECP, IVECT, IVECU which are thus
! to be seen as overlayed areas. The true vectors IVECC and IVECC2
! are computed on return from this routine, so for a while we use them
! for temporaries.
IVECP = IVECC
IVECT = IVECC2
IVECU = IVECC2

! Solve equations for the diagonal case, in eigenbasis:
! Current solution vector X, Current residual vector R
call PSCAVEC(-One,IRHS,IVECR)
call PRESDIA(IVECR,IVECX,OVLAPS)

if (MAXIT == 0) then
  if (IPRGLB >= TERSE) then
    if (HZERO /= 'DYALL') then
      write(u6,*)
      write(u6,'(A)') repeat('-',115)
      write(u6,*) ' DIAGONAL CASPT2 APPROXIMATION:'
    end if
  end if
else

  RNORM = Zero
  ! Pre-conditioned conjugate gradient:
  ! R <- R - (H0-E0)*X
  call SIGMA_CASPT2(-One,One,IVECX,IVECR)
  call POVLVEC(IVECR,IVECR,OVLAPS)
  RNORM = sqrt(OVLAPS(0,0))

  if (RNORM >= THRCONV) then

    if (IPRGLB >= USUAL) then
      write(u6,*)
      write(u6,*) 'The contributions to the second order correlation energy in atomic units.'
      write(u6,'(A)') repeat('-',125)
      write(u6,'(2X,A)') 'IT.      VJTU        VJTI        ATVX        AIVX        VJAI        BVAT        BJAT        BJAI'// &
                         '        TOTAL       RNORM  '
      write(u6,'(A)') repeat('-',125)
    end if

    call PRESDIA(IVECR,IVECP,OVLAPS)
    ! PCG iteration loops:
    !---------------------
    ITER = 0
    do
      call POVLVEC(IVECP,IVECP,OVLAPS)
      DSCALE = One/sqrt(OVLAPS(0,0))
      call PSCAVEC(DSCALE,IVECP,IVECP)
      call POVLVEC(IVECP,IVECR,OVLAPS)
      PR = OVLAPS(0,0)
      call SIGMA_CASPT2(One,Zero,IVECP,IVECT)
      call POVLVEC(IVECP,IVECT,OVLAPS)
      PT = OVLAPS(0,0)
      ALPHA = PR/PT
      call PLCVEC(ALPHA,One,IVECP,IVECX)
      call PLCVEC(-ALPHA,One,IVECT,IVECR)
      call POVLVEC(IVECR,IVECR,OVLAPS)
      RNORM = sqrt(OVLAPS(0,0))

      if (RNORM < THRCONV) exit

      ITER = ITER+1
      call POVLVEC(IRHS,IVECX,ECORR)
      EVJTU = ECORR(0,1)
      EVJTI = ECORR(0,2)+ECORR(0,3)
      EATVX = ECORR(0,4)
      EAIVX = ECORR(0,5)
      EVJAI = ECORR(0,6)+ECORR(0,7)
      EBVAT = ECORR(0,8)+ECORR(0,9)
      EBJAT = ECORR(0,10)+ECORR(0,11)
      EBJAI = ECORR(0,12)+ECORR(0,13)
      E2NONV = ECORR(0,0)
      if (IPRGLB >= USUAL) write(u6,'(1X,I3,1X,10F12.6)') ITER,EVJTU,EVJTI,EATVX,EAIVX,EVJAI,EBVAT,EBJAT,EBJAI,E2NONV,RNORM

      if (ITER >= MAXIT) then
        if (IPRGLB >= TERSE) then
          write(u6,*)
          write(u6,*) ' NOT CONVERGED AFTER MAX ITERATIONS.'
        end if
        ICONV = 16
        exit
      end if

      call PRESDIA(IVECR,IVECU,OVLAPS)
      UR = OVLAPS(0,0)
      BETA = PR/UR
      call PLCVEC(BETA,One,IVECU,IVECP)
    end do
    !---------------------
  end if

end if

call POVLVEC(IRHS,IVECX,ECORR)
EVJTU = ECORR(0,1)
EVJTI = ECORR(0,2)+ECORR(0,3)
EATVX = ECORR(0,4)
EAIVX = ECORR(0,5)
EVJAI = ECORR(0,6)+ECORR(0,7)
EBVAT = ECORR(0,8)+ECORR(0,9)
EBJAT = ECORR(0,10)+ECORR(0,11)
EBJAI = ECORR(0,12)+ECORR(0,13)
E2NONV = ECORR(0,0)
call POVLVEC(IVECX,IVECX,OVLAPS)
if ((HZERO == 'DYALL') .and. Do_SC) OVLAPS_SC(1:8,12:13) = OVLAPS(1:8,12:13)
DENORM = One+OVLAPS(0,0)
REFWGT = One/DENORM
!PAM Insert: Compute the variational second-order energy.
!PAM Use unshifted H0. Save any shifts, then restore them.
SAV = real_shift
SAVI = imag_shift
savreg = sigma_p_epsilon
real_shift = Zero
imag_shift = Zero
sigma_p_epsilon = Zero
call SIGMA_CASPT2(One,Zero,IVECX,IVECT)
real_shift = SAV
imag_shift = SAVI
sigma_p_epsilon = savreg
call POVLVEC(IVECX,IVECT,OVLAPS)
E2CORR = Two*E2NONV+OVLAPS(0,0)
!PAM End of insert.
ESHIFT = E2CORR-E2NONV
E2TOT = EREF+E2CORR

if (IPRGLB > USUAL) then
  write(u6,*)
  write(u6,*) ' Correlation energy /Case, /Symm, and sums:'
  do IC=1,13
    write(u6,'(1X,A8,9F12.8)') CASES(IC),(ECORR(IS,IC),IS=1,NSYM),ECORR(0,IC)
  end do
  write(u6,'(1X,A8,9F12.8)') 'Summed: ',(ECORR(IS,0),IS=1,NSYM),ECORR(0,0)
end if

if ((nStpGrd == 1) .or. ((nStpGrd == 2) .and. (.not. do_grad))) then
  if (IPRGLB >= TERSE) then
    write(u6,'(A)') repeat('-',125)
    write(u6,*)
    if (HZERO /= 'DYALL') then
      write(u6,*) ' FINAL CASPT2 RESULT:'
    else
      write(u6,*) ' FINAL PC-NEVPT2 RESULT:'
    end if
    write(u6,*)

    if (.not. Input%LovCASPT2) then
      write(u6,'(6x,a,f18.10)') 'Reference energy:     ',EREF
      write(u6,'(6x,a,f18.10)') 'E2 (Non-variational): ',E2NONV
      if ((real_shift /= Zero) .or. (imag_shift /= Zero) .or. (sigma_p_epsilon /= Zero)) &
        write(u6,'(6x,a,f18.10)') 'Shift correction:     ',ESHIFT
      write(u6,'(6x,a,f18.10)') 'E2 (Variational):     ',E2CORR
      if (.not. Input%FnoCASPT2) then
        write(u6,'(6x,a,f18.10)') 'Total energy:         ',E2TOT
      else
        write(u6,'(6x,a,f18.10,a)') 'FNO correction:       ',EMP2,'   (estimate)   '
        write(u6,'(6x,a,f13.5)')
        E2TOT = E2TOT+EMP2
        write(u6,'(6x,a,f18.10,a)') 'Total energy:         ',E2TOT,'   (FNO-CASPT2) '
      end if
      write(u6,'(6x,a,f18.10)') 'Residual norm:        ',RNORM
      write(u6,'(6x,a,f13.5)') 'Reference weight:     ',REFWGT
    else
      write(u6,'(6x,a,f18.10)') 'Reference energy:                 ',EREF
      write(u6,'(6x,a,f18.10)') 'Active-Site E2 (Non-variational): ',E2NONV
      if ((real_shift /= Zero) .or. (imag_shift /= Zero)) write(u6,'(6x,a,f18.10)') 'Shift correction:                 ',ESHIFT
      write(u6,'(6x,a,f18.10)') 'Active-Site E2 (Variational):     ',E2CORR
      write(u6,'(6x,a,f18.10)') 'Frozen region E2 :                ',EMP2
      write(u6,'(6x,a,f18.10)') 'Residual norm:                    ',RNORM
      write(u6,'(6x,a,f13.5)') 'Reference weight:                 ',REFWGT
      write(u6,'(6x,a,f13.5)')
      E2TOT = E2TOT+EMP2
      write(u6,'(6x,a,f18.10)') 'Total energy (LovCASPT2):         ',E2TOT
    end if
  end if
end if

! In automatic verification calculations, the precision is lower
! in case of Cholesky calculation.
LAXITY = 8
if (IfChol) LAXITY = Cho_X_GetTol(LAXITY)
call Add_Info('E_CASPT2',[E2TOT],1,LAXITY)

if ((nStpGrd == 1) .or. ((nStpGrd == 2) .and. (.not. do_grad))) then
  if (IPRGLB >= USUAL) then
    write(u6,*)
    if (HZERO /= 'DYALL') then
      write(u6,'(6x,a)') 'Contributions to the CASPT2 correlation energy'
    else
      write(u6,'(6x,a)') 'Contributions to the PC-NEVPT2 correlation energy'
    end if
    write(u6,'(6x,a,F18.10)') 'Active & Virtual Only:    ',EATVX+EBVAT
    write(u6,'(6x,a,F18.10)') 'One Inactive Excited:     ',EVJTU+EAIVX+EBJAT
    write(u6,'(6x,a,F18.10)') 'Two Inactive Excited:     ',EVJTI+EVJAI+EBJAI
    write(u6,*)
  end if
end if
!! we use the same energy for the H subspace
if ((HZERO == 'DYALL') .and. Do_SC) ECORR_SC(1:8,12:13) = ECORR(1:8,12:13)
call mma_deallocate(LISTS)

end subroutine PCG

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine IndSft_RI_3(iCmp,iShell,jBas,kBas,lBas,iAO,iAOst,ijkl,SOint,nSOint,TInt,nTInt,iOff,iShlSO,nBasSh,iSOShl,nSO, &
                       nShell,nSym,iSSOff)
!***********************************************************************
!  object: to sift and index the SO integrals.                         *
!                                                                      *
!          the indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          april '90                                                   *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri
use Basis_Info, only: nBas
use SOAO_Info, only: iAOtSO
use Symmetry_Info, only: Mul, nIrrep
use sort_data, only: nSkip
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCmp(4), iShell(4), jBas, kBas, lBas, iAO(4), iAOst(4), ijkl, nSOint, nTInt, iOff(3,0:7), nSO, &
                                 iShlSO(nSO), nShell, nSym, nBasSh(0:nSym-1,nShell), iSOShl(nSO), iSSOff(0:nIrrep-1,0:nIrrep-1)
real(kind=wp), intent(in) :: SOint(ijkl,nSOint)
real(kind=wp), intent(inout) :: TInt(nTInt)
integer(kind=iwp) :: i2, i3, i4, iAux, iC, iD, iIrrep, iOff_L, iShC, iShD, ix, j, j1, j12, j2, j3, j4, jOffSO(0:7), jSO, jSOj, &
                     jSym(0:7), kl, kl_B, kSO, kSOk, kSym(0:7), lCmpMx, lSO, lSOl, lSym(0:7), memSO2, mm, n3C, nC, nD, nijkl
logical(kind=iwp) :: qkl, Shkl

!                                                                      *
!***********************************************************************
!                                                                      *
!define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
jOffSO(0) = 0
do iIrrep=1,nIrrep-1
  jOffSO(iIrrep) = jOffSO(iIrrep-1)+nBas(iIrrep-1)
end do
memSO2 = 0

! quadruple loop over elements of the basis functions angular
! description. loops are reduced to just produce unique SO integrals
! observe that we will walk through the memory in AOint in a
! sequential way.

Shkl = iShell(3) == iShell(4)
if (iShell(4) > iShell(3)) then
  call WarningMessage(2,'Error in IndSft_RI_3')
  write(u6,*) 'iShell(4) > iShell(3)'
  call Abend()
end if

j1 = 0
do i2=1,iCmp(2)
  do j=0,nIrrep-1
    ix = 0
    if (iAOtSO(iAO(2)+i2,j) > 0) ix = 2**j
    jSym(j) = ix
  end do
  do i3=1,iCmp(3)
    do j=0,nIrrep-1
      ix = 0
      if (iAOtSO(iAO(3)+i3,j) > 0) ix = 2**j
      kSym(j) = ix
    end do
    lCmpMx = iCmp(4)
    if (Shkl) lCmpMx = i3
    do i4=1,lCmpMx
      do j=0,nIrrep-1
        ix = 0
        if (iAOtSO(iAO(4)+i4,j) > 0) ix = 2**j
        lSym(j) = ix
      end do
      qkl = i3 == i4

      ! loop over Irreps which are spanned by the basis function.
      ! again, the loop structure is restricted to ensure unique
      ! integrals.

      do j2=0,nIrrep-1
        if (jSym(j2) == 0) cycle
        j12 = Mul(j1+1,j2+1)-1

        do j3=0,nIrrep-1
          if (kSym(j3) == 0) cycle
          j4 = Mul(j12+1,j3+1)-1
          if (lSym(j4) == 0) cycle
          if (Shkl .and. qkl .and. (j4 > j3)) cycle

          memSO2 = memSO2+1
          if ((nSkip(j2+1)+nSkip(j3+1)+nSkip(j4+1)) /= 0) cycle
          !                                                            *
          !*************************************************************
          !                                                            *
          ! Number of auxiliary basis functions in this symmetry block.
          mm = iOff(1,j12)
          if (mm == 0) cycle
          ! Effective number of valence basis products in this symmetry block.
          n3C = iOff(3,j12)
          if (n3C == 0) cycle
          ! Offset to the symmetry block of this shell pair.
          iOff_L = iSSOff(j3,j4)
          !                                                            *
          !*************************************************************
          !                                                            *
          ! Compute index within the irrep. Keep the indexation
          ! of the two basis set sets apart.

          jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)-nBas(j2)
          kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+jOffSO(j3)
          lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+jOffSO(j4)

          nijkl = 0
          do lSOl=lSO,lSO+lBas-1
            iD = iShlSO(lSOl)
            iShD = iSOShl(lSOl)
            nD = nBasSh(j4,iShD)
            do kSOk=kSO,kSO+kBas-1
              iC = iShlSO(kSOk)
              iShC = iSOShl(kSOk)
              nC = nBasSh(j3,iShC)

              if (iShC == iShD) then
                if (j12 == 0) then
                  kl = iTri(iC,iD)
                else if (j3 > j4) then
                  kl = (iC-1)*nD+iD
                else
                  kl = (iD-1)*nC+iC
                end if
              else
                if (iShC >= iShD) then
                  kl = (iD-1)*nC+iC
                else
                  kl = (iC-1)*nD+iD
                end if
              end if

              do jSOj=jSO,jSO+jBas-1
                iAux = jSOj
                nijkl = nijkl+1
                !                                                      *
                !*******************************************************
                !                                                      *
                if ((j12 /= 0) .or. (kSOk >= lSOl)) then
                  kl_B = (iAux-1)*n3C+kl+iOff_L
                  TInt(kl_B) = SOint(nijkl,memSO2)
                end if
                !                                                      *
                !*******************************************************
                !                                                      *
              end do
            end do
          end do

        end do
      end do

    end do
  end do
end do

return

end subroutine IndSft_RI_3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Take higher multipole into spherical representation.
subroutine Spherical(dMul)

use Index_Functions, only: nTri_Elem1
use Constants, only: Three, Half
use Definitions, only: wp

implicit none
real(kind=wp), intent(inout) :: dMul(nTri_Elem1(2))
real(kind=wp) :: x2, xy, xz, y2, yz, z2
real(kind=wp), parameter :: d3 = sqrt(Three)

x2 = dMul(1)
y2 = dMul(4)
z2 = dMul(6)
xy = dMul(2)
xz = dMul(3)
yz = dMul(5)
dMul(1) = d3*xy
dMul(2) = d3*xz
dMul(3) = z2-Half*(x2+y2)
dMul(4) = d3*yz
dMul(5) = Half*d3*(x2-y2)

return

end subroutine Spherical

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine hqr2(nm,n,low,igh,h,wr,wi,z,ierr)
! this subroutine is a translation of the algol procedure hqr2,
! num. math. 16, 181-204(1970) by peters and wilkinson.
! handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
!
! this subroutine finds the eigenvalues and eigenvectors
! of a real upper hessenberg matrix by the qr method.  the
! eigenvectors of a real general matrix can also be found
! if  elmhes  and  eltran  or  orthes  and  ortran  have
! been used to reduce this general matrix to hessenberg form
! and to accumulate the similarity transformations.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.
!
!    n is the order of the matrix.
!
!    low and igh are integers determined by the balancing
!      subroutine  balanc.  if  balanc  has not been used,
!      set low=1, igh=n.
!
!    h contains the upper hessenberg matrix.
!
!    z contains the transformation matrix produced by  eltran
!      after the reduction by  elmhes, or by  ortran  after the
!      reduction by  orthes, if performed.  if the eigenvectors
!      of the hessenberg matrix are desired, z must contain the
!      identity matrix.
!
! on output
!
!    h has been destroyed.
!
!    wr and wi contain the real and imaginary parts,
!      respectively, of the eigenvalues.  the eigenvalues
!      are unordered except that complex conjugate pairs
!      of values appear consecutively with the eigenvalue
!      having the positive imaginary part first.  if an
!      error exit is made, the eigenvalues should be correct
!      for indices ierr+1,...,n.
!
!    z contains the real and imaginary parts of the eigenvectors.
!      if the i-th eigenvalue is real, the i-th column of z
!      contains its eigenvector.  if the i-th eigenvalue is complex
!      with positive imaginary part, the i-th and (i+1)-th
!      columns of z contain the real and imaginary parts of its
!      eigenvector.  the eigenvectors are unnormalized.  if an
!      error exit is made, none of the eigenvectors has been found.
!
!    ierr is set to
!      zero       for normal return,
!      j          if the limit of 30*n iterations is exhausted
!                 while the j-th eigenvalue is being sought.
!
! calls cdiv for complex division.
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n, low, igh
real(kind=wp), intent(inout) :: h(nm,n), z(nm,n)
real(kind=wp), intent(out) :: wr(n), wi(n)
integer(kind=iwp), intent(out) :: ierr
integer(kind=iwp) :: en, enm2, i, ii, itn, its, j, jj, k, l, ll, m, mm, mp2, na, nn, nroot
real(kind=wp) :: norm, p, q, r, ra, s, sa, t, tst1, tst2, vi, vr, w, x, y, zz
logical(kind=iwp) :: notlas

w = Zero
zz = Zero
ierr = 0
norm = Zero
k = 1
l = 0     ! dummy initialize
m = 0     ! dummy initialize
p = Zero  ! dummy initialize
q = Zero  ! dummy initialize
r = Zero  ! dummy initialize
s = Zero  ! dummy initialize
nroot = 0 ! dummy initialize
! .......... store roots isolated by balanc and compute matrix norm ..........
do i=1,n

  do j=k,n
    norm = norm+abs(h(i,j))
  end do

  k = i
  if ((i >= low) .and. (i <= igh)) cycle
  wr(i) = h(i,i)
  wi(i) = Zero
end do

en = igh
t = Zero
itn = 30*n
do
  ! .......... search for next eigenvalues ..........
  if (en < low) exit
  its = 0
  na = en-1
  enm2 = na-1
  do
    ! .......... look for single small sub-diagonal element for l=en step -1 until low do -- ..........
    do ll=low,en
      l = en+low-ll
      if (l == low) exit
      s = abs(h(l-1,l-1))+abs(h(l,l))
      if (s == Zero) s = norm
      tst1 = s
      tst2 = tst1+abs(h(l,l-1))
      if (tst2 == tst1) exit
    end do
    ! .......... form shift ..........
    x = h(en,en)
    if (l == en) then
      nroot = 1
      exit
    end if
    y = h(na,na)
    w = h(en,na)*h(na,en)
    if (l == na) then
      nroot = 2
      exit
    end if
    if (itn == 0) then
      ! .......... set error -- all eigenvalues have not converged after 30*n iterations ..........
      ierr = en
      return
    end if
    if ((its == 10) .or. (its == 20)) then
      ! .......... form exceptional shift ..........
      t = t+x

      do i=low,en
        h(i,i) = h(i,i)-x
      end do

      s = abs(h(en,na))+abs(h(na,enm2))
      x = 0.75_wp*s
      y = x
      w = -0.4375_wp*s*s
    end if
    its = its+1
    itn = itn-1
    ! .......... look for two consecutive small sub-diagonal elements.
    !            for m=en-2 step -1 until l do -- ..........
    do mm=l,enm2
      m = enm2+l-mm
      zz = h(m,m)
      r = x-zz
      s = y-zz
      p = (r*s-w)/h(m+1,m)+h(m,m+1)
      q = h(m+1,m+1)-zz-r-s
      r = h(m+2,m+1)
      s = abs(p)+abs(q)+abs(r)
      p = p/s
      q = q/s
      r = r/s
      if (m == l) exit
      tst1 = abs(p)*(abs(h(m-1,m-1))+abs(zz)+abs(h(m+1,m+1)))
      tst2 = tst1+abs(h(m,m-1))*(abs(q)+abs(r))
      if (tst2 == tst1) exit
    end do

    mp2 = m+2

    do i=mp2,en
      h(i,i-2) = Zero
      if (i == mp2) cycle
      h(i,i-3) = Zero
    end do
    ! .......... double qr step involving rows l to en and columns m to en ..........
    do k=m,na
      notlas = k /= na
      if (k /= m) then
        p = h(k,k-1)
        q = h(k+1,k-1)
        r = Zero
        if (notlas) r = h(k+2,k-1)
        x = abs(p)+abs(q)+abs(r)
        if (x == Zero) cycle
        p = p/x
        q = q/x
        r = r/x
      end if
      s = sign(sqrt(p*p+q*q+r*r),p)
      if (k == m) then
        if (l /= m) h(k,k-1) = -h(k,k-1)
      else
        h(k,k-1) = -s*x
      end if
      p = p+s
      x = p/s
      y = q/s
      zz = r/s
      q = q/p
      r = r/p
      if (notlas) then
        ! .......... row modification ..........
        do j=k,n
          p = h(k,j)+q*h(k+1,j)+r*h(k+2,j)
          h(k,j) = h(k,j)-p*x
          h(k+1,j) = h(k+1,j)-p*y
          h(k+2,j) = h(k+2,j)-p*zz
        end do

        j = min(en,k+3)
        ! .......... column modification ..........
        do i=1,j
          p = x*h(i,k)+y*h(i,k+1)+zz*h(i,k+2)
          h(i,k) = h(i,k)-p
          h(i,k+1) = h(i,k+1)-p*q
          h(i,k+2) = h(i,k+2)-p*r
        end do
        ! .......... accumulate transformations ..........
        do i=low,igh
          p = x*z(i,k)+y*z(i,k+1)+zz*z(i,k+2)
          z(i,k) = z(i,k)-p
          z(i,k+1) = z(i,k+1)-p*q
          z(i,k+2) = z(i,k+2)-p*r
        end do
      else
        ! .......... row modification ..........
        do j=k,n
          p = h(k,j)+q*h(k+1,j)
          h(k,j) = h(k,j)-p*x
          h(k+1,j) = h(k+1,j)-p*y
        end do

        j = min(en,k+3)
        ! .......... column modification ..........
        do i=1,j
          p = x*h(i,k)+y*h(i,k+1)
          h(i,k) = h(i,k)-p
          h(i,k+1) = h(i,k+1)-p*q
        end do
        ! .......... accumulate transformations ..........
        do i=low,igh
          p = x*z(i,k)+y*z(i,k+1)
          z(i,k) = z(i,k)-p
          z(i,k+1) = z(i,k+1)-p*q
        end do
      end if

    end do
  end do

  if (nroot == 1) then
    ! .......... one root found ..........
    h(en,en) = x+t
    wr(en) = h(en,en)
    wi(en) = Zero
    en = na
  else if (nroot == 2) then
    ! .......... two roots found ..........
    p = (y-x)*Half
    q = p*p+w
    zz = sqrt(abs(q))
    h(en,en) = x+t
    x = h(en,en)
    h(na,na) = y+t
    if (q < Zero) then
      ! .......... complex pair ..........
      wr(na) = x+p
      wr(en) = x+p
      wi(na) = zz
      wi(en) = -zz
    else
      ! .......... real pair ..........
      zz = p+sign(zz,p)
      wr(na) = x+zz
      wr(en) = wr(na)
      if (zz /= Zero) wr(en) = x-w/zz
      wi(na) = Zero
      wi(en) = Zero
      x = h(en,na)
      s = abs(x)+abs(zz)
      p = x/s
      q = zz/s
      r = sqrt(p*p+q*q)
      p = p/r
      q = q/r
      ! .......... row modification ..........
      do j=na,n
        zz = h(na,j)
        h(na,j) = q*zz+p*h(en,j)
        h(en,j) = q*h(en,j)-p*zz
      end do
      ! .......... column modification ..........
      do i=1,en
        zz = h(i,na)
        h(i,na) = q*zz+p*h(i,en)
        h(i,en) = q*h(i,en)-p*zz
      end do
      ! .......... accumulate transformations ..........
      do i=low,igh
        zz = z(i,na)
        z(i,na) = q*zz+p*z(i,en)
        z(i,en) = q*z(i,en)-p*zz
      end do
    end if

    en = enm2
  end if
end do
! .......... all roots found.  backsubstitute to find vectors of upper triangular form ..........
if (norm == Zero) return
! .......... for en=n step -1 until 1 do -- ..........
do nn=1,n
  en = n+1-nn
  p = wr(en)
  q = wi(en)
  na = en-1
  if (q == Zero) then
    ! .......... real vector ..........
    m = en
    h(en,en) = One
    if (na == 0) cycle
    ! .......... for i=en-1 step -1 until 1 do -- ..........
    do ii=1,na
      i = en-ii
      w = h(i,i)-p
      r = Zero

      do j=m,en
        r = r+h(i,j)*h(j,en)
      end do

      if (wi(i) < Zero) then
        zz = w
        s = r
        cycle
      end if
      m = i
      if (wi(i) /= Zero) then
        ! .......... solve real equations ..........
        x = h(i,i+1)
        y = h(i+1,i)
        q = (wr(i)-p)*(wr(i)-p)+wi(i)*wi(i)
        t = (x*s-zz*r)/q
        h(i,en) = t
        if (abs(x) <= abs(zz)) then
          h(i+1,en) = (-s-y*t)/zz
        else
          h(i+1,en) = (-r-w*t)/x
        end if
      else
        t = w
        if (t == Zero) then
          tst1 = norm
          t = tst1
          do
            t = 0.01_wp*t
            tst2 = norm+t
            if (tst2 <= tst1) exit
          end do
        end if
        h(i,en) = -r/t
      end if

      ! .......... overflow control ..........
      t = abs(h(i,en))
      if (t == Zero) cycle
      tst1 = t
      tst2 = tst1+One/tst1
      if (tst2 > tst1) cycle
      h(i:en,en) = h(i:en,en)/t

    end do
    ! .......... end real vector ..........
  else if (q < Zero) then
    ! .......... complex vector ..........
    m = na
    ! .......... last vector component chosen imaginary so that eigenvector matrix is triangular ..........
    if (abs(h(en,na)) <= abs(h(na,en))) then
      call cdiv(Zero,-h(na,en),h(na,na)-p,q,h(na,na),h(na,en))
    else
      h(na,na) = q/h(en,na)
      h(na,en) = -(h(en,en)-p)/h(en,na)
    end if
    h(en,na) = Zero
    h(en,en) = One
    enm2 = na-1
    if (enm2 == 0) cycle
    ! .......... for i=en-2 step -1 until 1 do -- ..........
    do ii=1,enm2
      i = na-ii
      w = h(i,i)-p
      ra = Zero
      sa = Zero

      do j=m,en
        ra = ra+h(i,j)*h(j,na)
        sa = sa+h(i,j)*h(j,en)
      end do

      if (wi(i) < Zero) then
        zz = w
        r = ra
        s = sa
      else
        m = i
        if (wi(i) /= Zero) then
          ! .......... solve complex equations ..........
          x = h(i,i+1)
          y = h(i+1,i)
          vr = (wr(i)-p)*(wr(i)-p)+wi(i)*wi(i)-q*q
          vi = (wr(i)-p)*Two*q
          if ((vr == Zero) .and. (vi == Zero)) then
            tst1 = norm*(abs(w)+abs(q)+abs(x)+abs(y)+abs(zz))
            vr = tst1
            do
              vr = 0.01_wp*vr
              tst2 = tst1+vr
              if (tst2 <= tst1) exit
            end do
          end if
          call cdiv(x*r-zz*ra+q*sa,x*s-zz*sa-q*ra,vr,vi,h(i,na),h(i,en))
          if (abs(x) <= abs(zz)+abs(q)) then
            call cdiv(-r-y*h(i,na),-s-y*h(i,en),zz,q,h(i+1,na),h(i+1,en))
          else
            h(i+1,na) = (-ra-w*h(i,na)+q*h(i,en))/x
            h(i+1,en) = (-sa-w*h(i,en)-q*h(i,na))/x
          end if
        else
          call cdiv(-ra,-sa,w,q,h(i,na),h(i,en))
        end if

        ! .......... overflow control ..........
        t = max(abs(h(i,na)),abs(h(i,en)))
        if (t == Zero) cycle
        tst1 = t
        tst2 = tst1+One/tst1
        if (tst2 > tst1) cycle
        h(i:en,na) = h(i:en,na)/t
        h(i:en,en) = h(i:en,en)/t
      end if

    end do
    ! .......... end complex vector ..........
  end if
end do
! .......... end back substitution. vectors of isolated roots ..........
do i=1,n
  if ((i >= low) .and. (i <= igh)) cycle

  z(i,:) = h(i,:)

end do
! .......... multiply by transformation matrix to give vectors of original full matrix.
!            for j=n step -1 until low do -- ..........
do jj=low,n
  j = n+low-jj
  m = min(j,igh)

  do i=low,igh
    zz = Zero

    do k=low,m
      zz = zz+z(i,k)*h(k,j)
    end do

    z(i,j) = zz
  end do
end do

return

end subroutine hqr2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine WrVec_Localisation(FName,Lu,Label,nSym,nBas,nOrb,CMO,
     &                              Occ,EOrb,IndT,Title)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Write orbital info.
C     This is a work-around to fix bugs when orbitals are deleted.
C
      Implicit None
      Character*6  FName
      Integer Lu
      Character*(*) Label
      Integer nSym
      Integer nBas(nSym)
      Integer nOrb(nSym)
      Real*8  CMO(*)
      Real*8  Occ(*)
      Real*8  EOrb(*)
      Integer IndT(*)
      Character*(*) Title
#include "WrkSpc.fh"

      Integer ip_CMO, l_CMO
      Integer ip_Occ, l_Occ
      Integer ip_EOr, l_EOr
      Integer ip_Ind, l_Ind
      Integer iSym, k1, k2

      Logical Write_CMO, Write_Occ, Write_EOr, Write_Ind

      Integer  isFreeUnit
      External isFreeUnit

      Write_CMO=index(Label,'C').ne.0
      Write_Occ=index(Label,'O').ne.0
      Write_EOr=index(Label,'E').ne.0
      Write_Ind=index(Label,'I').ne.0

      If (Write_CMO) Then
         l_CMO=nBas(1)*nOrb(1)
         Do iSym=2,nSym
            l_CMO=l_CMO+nBas(iSym)*nOrb(iSym)
         End Do
         Call GetMem('CMO_','Allo','Real',ip_CMO,l_CMO)
         k1=1
         k2=ip_CMO
         Do iSym=1,nSym
            Call dCopy_(nBas(iSym)*nOrb(iSym),CMO(k1),1,Work(k2),1)
            k1=k1+nBas(iSym)*nBas(iSym)
            k2=k2+nBas(iSym)*nOrb(iSym)
         End Do
      Else
         l_CMO=1
         Call GetMem('CMO_','Allo','Real',ip_CMO,l_CMO)
         Work(ip_CMO)=0.0d0
      End If

      If (Write_Occ) Then
         l_Occ=nOrb(1)
         Do iSym=2,nSym
            l_Occ=l_Occ+nOrb(iSym)
         End Do
         Call GetMem('Occ_','Allo','Real',ip_Occ,l_Occ)
         k1=1
         k2=ip_Occ
         Do iSym=1,nSym
            Call dCopy_(nOrb(iSym),Occ(k1),1,Work(k2),1)
            k1=k1+nBas(iSym)
            k2=k2+nOrb(iSym)
         End Do
      Else
         l_Occ=1
         Call GetMem('Occ_','Allo','Real',ip_Occ,l_Occ)
         Work(ip_Occ)=0.0d0
      End If

      If (Write_EOr) Then
         l_EOr=nOrb(1)
         Do iSym=2,nSym
            l_EOr=l_EOr+nOrb(iSym)
         End Do
         Call GetMem('EOr_','Allo','Real',ip_EOr,l_EOr)
         k1=1
         k2=ip_EOr
         Do iSym=1,nSym
            Call dCopy_(nOrb(iSym),EOrb(k1),1,Work(k2),1)
            k1=k1+nBas(iSym)
            k2=k2+nOrb(iSym)
         End Do
      Else
         l_EOr=1
         Call GetMem('EOr_','Allo','Real',ip_EOr,l_EOr)
         Work(ip_EOr)=0.0d0
      End If

      If (Write_Ind) Then
         l_Ind=56
         Call GetMem('Ind_','Allo','Inte',ip_Ind,l_Ind)
         Call iCopy(l_Ind,IndT,1,iWork(ip_Ind),1)
      Else
         l_Ind=1
         Call GetMem('Ind_','Allo','Inte',ip_Ind,l_Ind)
         iWork(ip_Ind)=0
      End If

      Call WrVec(FName,Lu,Label,nSym,nBas,nOrb,Work(ip_CMO),
     &           Work(ip_Occ),Work(ip_EOr),iWork(ip_Ind),Title)

      Call GetMem('Ind_','Free','Inte',ip_Ind,l_Ind)
      Call GetMem('EOr_','Free','Real',ip_EOr,l_EOr)
      Call GetMem('Occ_','Free','Real',ip_Occ,l_Occ)
      Call GetMem('CMO_','Free','Real',ip_CMO,l_CMO)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
C SVC-20120305: This is a new parallel version of the SGM subroutine.
C Instead of the full array Y, distributed array indices lg_Y is passed,
C which refer to distributed arrays.

C Currently, only case H will be passed as a distributed array, since
C this is the largest array (about a factor of NI larger than case G)
C and it avoids communications of this array: if it is updated, we use
C only the local chunk. If is is used to update another case, that case
C is partially updated and then communicated.  The special routines are
C called MLTR1_GH, MLTR1_EH and MLTSCA_DH.

C The distributed arrays are (currently) layed out as 2-dimensional
C distributed arrays, with NAS rows and NIS columns (see subroutine
C RHS_ALLO in file par_rhs.f). The chunks are along the column indices,
C so each chunk has all the row indices (full columns).


      SUBROUTINE SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,
     &               X1,X2,lg_Y,LIST)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use Constants, only: One,  Half, Two, Three, Six
      use Fockof, only: IOFFIA, FIT, FTI, FIA, FAI, FTA, FAT
      use EQSOLV, only: nList, LList, IfCoup
      use Sigma_data, only: Val1, Val2, INCF1, INCF2, INCX1, INCX2,
     &                      INCX3, INCY1, INCY2, INCY3, LEN1, LEN2,
     &                      nLst1, nLst2
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: nIsh, nAsh, nSSh, nSym, nISUP,
     &                         nASUP, nIGEJ, nIGTJ, nAGEB, nAGTB, nTGEU,
     &                         nTUV, nTGTU, nTGEU
#ifdef _DEBUGPRINT_
      use caspt2_module, only: Cases
#endif

      IMPLICIT None

      integer(kind=iwp), intent(in):: IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2
      real(kind=wp), intent(inout) ::  X1(*), X2(*)
      integer(kind=iwp), intent(in) ::  LIST(*)

      integer(kind=iwp) IOFCD(8,8),IOFCEP(8,8),IOFCEM(8,8),IOFCGP(8,8),
     &                  IOFCGM(8,8)
C Various constants:
      real(kind=wp), parameter:: SQR2=SQRT(Two), SQR3=SQRT(Three),
     &                           SQR6=SQRT(Six), SQRI2=One/SQR2,
     &                           SQRI6=One/SQR6, SQR32=SQR3*SQRI2
      integer(kind=iwp) lg_Y, ICD, ICEM, ICEP, ICGM, ICGP, IJSYM, ISYM,
     &                  ISYM12, ISYMA, ISYMAB, ISYMB, ISYMI, ISYMIJ,
     &                  ISYMJ, IX, IXIA, IXTA, IXTI, IY, JSYM, JXOFF,
     &                  KOD, LLST1, LLST2, NA, NAS1, NAS2, NB, NFA, NFI,
     &                  NFT, NI, NIS1, NIS2, NJ, NT, NU

C Compute a contribution from a single block (ISYM2,ICASE2)
C of expansion vector to a single block (ISYM1,ICASE1)
C of a sigma vector, if IMLTOP=0. If IMLTOP=1, the role of the
C two blocks are reversed. It is assumed that ICASE2 is
C greater than ICASE1, hence the reverse option.

CFUE  IF( (ICASE1.EQ.1 .AND. ICASE2.EQ.2) .AND.
CFUE &    (ISYM1.EQ.1  .AND. ISYM2.EQ.1 )       ) IFTEST=1
CPAM      IF(ICASE1.EQ.5.AND.ICASE2.GT.11) IFTEST=1
#ifdef _DEBUGPRINT_
      WRITE(6,'(A,10I5)')' ENTERING SGM.'
      WRITE(6,'(A,10I5)')'       IMLTOP:',IMLTOP
      WRITE(6,'(A,10I5)')' ISYM1,ICASE1:',ISYM1,ICASE1
      WRITE(6,'(A,10I5)')' ISYM2,ICASE2:',ISYM2,ICASE2
      WRITE(6,'(A,A,A)') ' CASES: ',CASES(ICASE1),CASES(ICASE2)
#endif

      IF(IMLTOP.LT.0 .OR. IMLTOP.GT.2) THEN
        WRITE(6,*) 'Error in SGM: IMLTOP = ', IMLTOP
        CALL AbEnd()
      END IF

C SVC: IFCOUP is set in SIGMA_CASPT2
      KOD=IFCOUP(ICASE2,ICASE1)
      IF(KOD==0) RETURN

      ISYM12=Mul(ISYM1,ISYM2)
      NAS1=NASUP(ISYM1,ICASE1)
      NIS1=NISUP(ISYM1,ICASE1)
      NAS2=NASUP(ISYM2,ICASE2)
      NIS2=NISUP(ISYM2,ICASE2)
      DO ISYM=1,NSYM
        ICD=0
        ICEP=0
        ICEM=0
        ICGP=0
        ICGM=0
        DO JSYM=1,NSYM
          IJSYM=Mul(ISYM,JSYM)
          IOFCD(ISYM,JSYM)=ICD
          IOFCEP(ISYM,JSYM)=ICEP
          IOFCEM(ISYM,JSYM)=ICEM
          IOFCGP(ISYM,JSYM)=ICGP
          IOFCGM(ISYM,JSYM)=ICGM
          ICD =ICD +NSSH(JSYM)*NISH(IJSYM)
          ICEP=ICEP+NSSH(JSYM)*NIGEJ(IJSYM)
          ICEM=ICEM+NSSH(JSYM)*NIGTJ(IJSYM)
          ICGP=ICGP+NISH(JSYM)*NAGEB(IJSYM)
          ICGM=ICGM+NISH(JSYM)*NAGTB(IJSYM)
        END DO
      END DO

C SVC: this is an extra check, since coupling cases that are 0 should
C not have entered the sgm subroutine

      SELECT CASE (KOD)
C  -----------------------------------------------
      CASE(1)
C ICASE1= 1
C ICASE2= 2

C  A&BP One-el
        NLST1=NLIST(ISYM1,ISYM2,12)
        NLST2=NLIST(ISYM1,ISYM2,14)
        IF(NLST1*NLST2/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2,12)
          VAL1(1)=One
          VAL1(2)=Two
          LLST2=LLIST(ISYM1,ISYM2,14)
          VAL2(1)=One
          VAL2(2)=SQR2
          IXTI=1
          INCX1=1
          INCX2=NASH(ISYM1)
          INCF1=NISH(ISYM12)
          INCF2=1
          IY=1
          INCY1=1
          INCY2=NTGEU(ISYM2)
          CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X1(IXTI),
     &                FIT(ISYM12)%A,
     &                GA_Arrays(lg_Y)%A(IY))
        END IF

C  A&BP Two-el
        NLST1=NLIST(ISYM1,ISYM2, 3)
        NLST2=NLIST(ISYM1,ISYM2,14)
        IF(NLST1*NLST2/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 3)
          VAL1(1)=-One
          VAL1(2)=-Two
          LLST2=LLIST(ISYM1,ISYM2,14)
          VAL2(1)=One
          VAL2(2)=SQR2
          IX=1
          INCX1=1
          INCX2=NTUV(ISYM1)
          INCF1=NISH(ISYM12)
          INCF2=1
          IY=1
          INCY1=1
          INCY2=NTGEU(ISYM2)
          CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X2(IX),
     &                FIT(ISYM12)%A,
     &                GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (2)
C ICASE1= 1
C ICASE2= 3

C A&BM One-el
        NLST1=NLIST(ISYM1,ISYM2,13)
        NLST2=NLIST(ISYM1,ISYM2,15)
        IF(NLST1*NLST2/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2,13)
          VAL1(1)= Three
          VAL1(2)=-Three
          LLST2=LLIST(ISYM1,ISYM2,15)
* Original:
*         VAL2(1)=-One
*         VAL2(2)= One
* Fix for sign error noted by Takeshi, May 2015:
          VAL2(1)= One
          VAL2(2)=-One
          IXTI=1
          INCX1=1
          INCX2=NASH(ISYM1)
          INCF1=NISH(ISYM12)
          INCF2=1
          IY=1
          INCY1=1
          INCY2=NTGTU(ISYM2)
          CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X1(IXTI),
     &                FIT(ISYM12)%A,
     &                GA_Arrays(lg_Y)%A(IY))
        END IF

C A&BM Two-el
        NLST1=NLIST(ISYM1,ISYM2, 4)
        NLST2=NLIST(ISYM1,ISYM2,15)
        IF(NLST1*NLST2/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 4)
          VAL1(1)=-One
          VAL1(2)= One
          LLST2=LLIST(ISYM1,ISYM2,15)
* Original:
*         VAL2(1)=-One
*         VAL2(2)= One
* Fix for sign error noted by Takeshi, May 2015:
          VAL2(1)= One
          VAL2(2)=-One
          IX=1
          INCX1=1
          INCX2=NTUV(ISYM1)
          INCF1=NISH(ISYM12)
          INCF2=1
          IY=1
          INCY1=1
          INCY2=NTGTU(ISYM2)
          CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X2(IX),
     &                FIT(ISYM12)%A,
     &                GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (3)
C ICASE1= 1
C ICASE2= 5

C  A&D  Two-el
        NLST1=NLIST(ISYM1,ISYM2, 1)
        IF(NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 1)
          VAL1(1)= One
          VAL1(2)= One
          IX=1
          INCX1=1
          INCX2=NAS1
          INCF1=NSSH(ISYM12)
          INCF2=1
          IY=1+NAS2*IOFCD(ISYM2,ISYM12)
          INCY1=1
          INCY2=NAS2
          INCY3=NAS2*NISH(ISYM1)
          LEN1=NISH(ISYM1)
          LEN2=NSSH(ISYM12)
          CALL MLTMV(IMLTOP,LIST(LLST1),
     &               X2(IX),
     &               FAT(ISYM12)%A,
     &               GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (4)
C ICASE1= 1
C ICASE2= 6

C  A&EP One-el
        IF(ISYM2.EQ.ISYM1) THEN
          NT=NASH(ISYM1)
          IF(NT/=0) THEN
            DO ISYMIJ=1,NSYM
            ISYMA=Mul(ISYMIJ,ISYM1)
            NA=NSSH(ISYMA)
            NLST1=NLIST(ISYM1,ISYMIJ,14)
            IF(NA*NLST1/=0) THEN
              LLST1=LLIST(ISYM1,ISYMIJ,14)
              VAL1(1)= One
              VAL1(2)= SQR2
              IXTI=1
              INCX1=NT
              INCX2=1
              INCF1=NSSH(ISYMA)
              INCF2=1
              IY=1+NAS2*IOFCEP(ISYM2,ISYMA)
              INCY1=NT*NA
              INCY2=1
              INCY3=NT
              LEN1=NT
              LEN2=NA
              CALL MLTMV(IMLTOP,LIST(LLST1),
     &                   X1(IXTI),
     &                   FAI(ISYMA)%A,
     &                   GA_Arrays(lg_Y)%A(IY))
            END IF
            END DO
          END IF
        END IF
C  -----------------------------------------------
      CASE (5)
C ICASE1= 1
C ICASE2= 7

C  A&EM One-el
        IF(ISYM2.EQ.ISYM1) THEN
          NT=NASH(ISYM1)
          IF(NT/=0) THEN
            DO ISYMIJ=1,NSYM
            ISYMA=Mul(ISYMIJ,ISYM1)
            NA=NSSH(ISYMA)
            NLST1=NLIST(ISYM1,ISYMIJ,15)
            IF(NA*NLST1/=0) THEN
              LLST1=LLIST(ISYM1,ISYMIJ,15)
              VAL1(1)=-SQR3
              VAL1(2)= SQR3
              IXTI=1
              INCX1=NT
              INCX2=1
              INCF1=NSSH(ISYMA)
              INCF2=1
              IY=1+NAS2*IOFCEM(ISYM2,ISYMA)
              INCY1=NT*NA
              INCY2=1
              INCY3=NT
              LEN1=NT
              LEN2=NA
              CALL MLTMV(IMLTOP,LIST(LLST1),
     &                   X1(IXTI),
     &                   FAI(ISYMA)%A,
     &                   GA_Arrays(lg_Y)%A(IY))
            END IF
            END DO
          END IF
        END IF
C  -----------------------------------------------
      CASE (6)
C ICASE1= 2
C ICASE2= 6

C  BP&EP Two-el
        NA=NSSH(ISYM12)
        NLST1=NLIST(ISYM1,ISYM2, 9)
        IF(NA*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 9)
          VAL1(1)= SQRI2
          VAL1(2)= SQRI2
          IX=1
          INCX1=1
          INCX2=NAS1
          INCF1=NSSH(ISYM12)
          INCF2=1
          IY=1+NAS2*IOFCEP(ISYM2,ISYM12)
          INCY1=1
          INCY2=NAS2*NA
          INCY3=NAS2
          LEN1=NIS1
          LEN2=NA
          CALL MLTMV(IMLTOP,LIST(LLST1),
     &               X2(IX),
     &               FAT(ISYM12)%A,
     &               GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (7)
C ICASE1= 3
C ICASE2= 7

C  BM&EM Two-el
        NA=NSSH(ISYM12)
        NLST1=NLIST(ISYM1,ISYM2,10)
        IF(NA*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2,10)
* Original:
*         VAL1(1)=-SQRI6
*         VAL1(2)= SQRI6
* Fix for sign error noted by Takeshi, May 2015:
          VAL1(1)= SQRI6
          VAL1(2)=-SQRI6
          IX=1
          INCX1=1
          INCX2=NAS1
          INCF1=NSSH(ISYM12)
          INCF2=1
          IY=1+NAS2*IOFCEM(ISYM2,ISYM12)
          INCY1=1
          INCY2=NAS2*NA
          INCY3=NAS2
          LEN1=NIS1
          LEN2=NA
          CALL MLTMV(IMLTOP,LIST(LLST1),
     &               X2(IX),
     &               FAT(ISYM12)%A,
     &               GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (8)
C ICASE1= 4
C ICASE2= 5

C  C&D  One-el
        NI=NISH(ISYM12)
        NLST1=NLIST(ISYM1,ISYM2,11)
        IF(NI*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2,11)
          VAL1(1)= Two
          VAL1(2)= One
          IXTA=1
          INCX1=1
          INCX2=NASH(ISYM1)
          INCF1=NI
          INCF2=1
          IY=1+NAS2*IOFCD(ISYM2,ISYM1)
          INCY1=1
          INCY2=NAS2*NI
          INCY3=NAS2
          LEN1=NSSH(ISYM1)
          LEN2=NI
          CALL MLTMV(IMLTOP,LIST(LLST1),
     &               X1(IXTA),
     &               FIT(ISYM12)%A,
     &               GA_Arrays(lg_Y)%A(IY))
        END IF

C  C&D  Two-el
        NI=NISH(ISYM12)
        NLST1=NLIST(ISYM1,ISYM2, 2)
        IF(NI*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 2)
          VAL1(1)=-One
          VAL1(2)=-One
          IX=1
          INCX1=1
          INCX2=NAS1
          INCF1=NI
          INCF2=1
          IY=1+NAS2*IOFCD(ISYM2,ISYM1)
          INCY1=1
          INCY2=NAS2*NI
          INCY3=NAS2
          LEN1=NSSH(ISYM1)
          LEN2=NI
          CALL MLTMV(IMLTOP,LIST(LLST1),
     &               X2(IX),
     &               FIT(ISYM12)%A,
     &               GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (9)
C ICASE1= 4
C ICASE2= 8

C  C&FP One-el
        NLST1=NLIST(ISYM1,ISYM2,12)
        NLST2=NLIST(ISYM1,ISYM2,16)
        IF(NLST1*NLST2/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2,12)
          VAL1(1)=-One
          VAL1(2)=-Two
          LLST2=LLIST(ISYM1,ISYM2,16)
          VAL2(1)=One
          VAL2(2)=SQR2
          IXTA=1
          INCX1=1
          INCX2=NASH(ISYM1)
          INCF1=1
          INCF2=NASH(ISYM12)
          IY=1
          INCY1=1
          INCY2=NTGEU(ISYM2)
          CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X1(IXTA),
     &                FTA(ISYM12)%A,
     &                GA_Arrays(lg_Y)%A(IY))
        END IF

C  C&FP Two-el
        NLST1=NLIST(ISYM1,ISYM2, 5)
        NLST2=NLIST(ISYM1,ISYM2,16)
        IF(NLST1*NLST2/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 5)
          VAL1(1)= One
          VAL1(2)= Two
          LLST2=LLIST(ISYM1,ISYM2,16)
          VAL2(1)=One
          VAL2(2)=SQR2
          IX=1
          INCX1=1
          INCX2=NTUV(ISYM1)
          INCF1=1
          INCF2=NASH(ISYM12)
          IY=1
          INCY1=1
          INCY2=NTGEU(ISYM2)
          CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X2(IX),
     &                FTA(ISYM12)%A,
     &                GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (10)
C ICASE1= 4
C ICASE2= 9

C  C&FM One-el
        NLST1=NLIST(ISYM1,ISYM2,13)
        NLST2=NLIST(ISYM1,ISYM2,17)
        IF(NLST1*NLST2/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2,13)
          VAL1(1)=-One
          VAL1(2)= One
          LLST2=LLIST(ISYM1,ISYM2,17)
          VAL2(1)=One
          VAL2(2)=-One
          IXTA=1
          INCX1=1
          INCX2=NASH(ISYM1)
          INCF1=1
          INCF2=NASH(ISYM12)
          IY=1
          INCY1=1
          INCY2=NTGTU(ISYM2)
          CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X1(IXTA),
     &                FTA(ISYM12)%A,
     &                GA_Arrays(lg_Y)%A(IY))
        END IF

C  C&FM Two-el
        NLST1=NLIST(ISYM1,ISYM2, 6)
        NLST2=NLIST(ISYM1,ISYM2,17)
        IF(NLST1*NLST2/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 6)
          VAL1(1)=-One
          VAL1(2)= One
          LLST2=LLIST(ISYM1,ISYM2,17)
          VAL2(1)=One
          VAL2(2)=-One
          IX=1
          INCX1=1
          INCX2=NTUV(ISYM1)
          INCF1=1
          INCF2=NASH(ISYM12)
          IY=1
          INCY1=1
          INCY2=NTGTU(ISYM2)
          CALL MLTSCA(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                X2(IX),
     &                FTA(ISYM12)%A,
     &                GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (11)
C ICASE1= 4
C ICASE2= 10

C  C&GP One-el
        NT=NASH(ISYM1)
        IF(ISYM2==ISYM1 .AND.  NT/=0) THEN
          DO ISYMAB=1,NSYM
          ISYMI=Mul(ISYMAB,ISYM1)
          NI=NISH(ISYMI)
          NLST1=NLIST(ISYM1,ISYMAB,16)
          IF(NI*NLST1/=0) THEN
            LLST1=LLIST(ISYM1,ISYMAB,16)
            VAL1(1)= SQRI2
            VAL1(2)= One
            IXTA=1
            INCX1=NT
            INCX2=1
            INCF1=NI
            INCF2=1
            IY=1+NAS2*IOFCGP(ISYM2,ISYMI)
            INCY1=NT*NI
            INCY2=1
            INCY3=NT
            LEN1=NT
            LEN2=NI
            CALL MLTMV(IMLTOP,LIST(LLST1),
     &                 X1(IXTA),
     &                 FIA(ISYMI)%A,
     &                 GA_Arrays(lg_Y)%A(IY))
          END IF
          END DO
        END IF
C  -----------------------------------------------
      CASE (12)
C ICASE1= 4
C ICASE2= 11

C  C&GM One-el
        NT=NASH(ISYM1)
        IF(ISYM2==ISYM1 .AND. NT/=0) THEN
          DO ISYMAB=1,NSYM
          ISYMI=Mul(ISYMAB,ISYM1)
          NI=NISH(ISYMI)
          NLST1=NLIST(ISYM1,ISYMAB,17)
          IF(NI*NLST1/=0) THEN
            LLST1=LLIST(ISYM1,ISYMAB,17)
            VAL1(1)= SQR32
            VAL1(2)=-SQR32
            IXTA=1
            INCX1=NT
            INCX2=1
            INCF1=NI
            INCF2=1
            IY=1+NAS2*IOFCGM(ISYM2,ISYMI)
            INCY1=NT*NI
            INCY2=1
            INCY3=NT
            LEN1=NT
            LEN2=NI
            CALL MLTMV(IMLTOP,LIST(LLST1),
     &                 X1(IXTA),
     &                 FIA(ISYMI)%A,
     &                 GA_Arrays(lg_Y)%A(IY))
          END IF
          END DO
        END IF
C  -----------------------------------------------
      CASE (13)
C ICASE1= 5
C ICASE2= 6

C  D&EP One-el
        NT=NASH(ISYM2)
        IF(ISYM1==1 .AND. NT/=0) THEN
          DO ISYMI=1,NSYM
          NI=NISH(ISYMI)
          NA=NSSH(ISYMI)
          ISYMIJ=Mul(ISYMI,ISYM2)
          NLST1=NLIST(ISYMI,ISYMIJ,14)
          IF(NI*NA*NLST1/=0) THEN
            LLST1=LLIST(ISYMI,ISYMIJ,14)
            VAL1(1)= SQRI2
            VAL1(2)= One
            IXIA=1+IOFFIA(ISYMI)
            INCX1=1
            INCX2=NI
            INCF1=NASH(ISYM2)
            INCF2=1
            IY=1+NAS2*IOFCEP(ISYM2,ISYMI)
            INCY1=NT*NA
            INCY2=NT
            INCY3=1
            LEN1=NA
            LEN2=NT
            CALL MLTMV(IMLTOP,LIST(LLST1),
     &                 X1(IXIA),
     &                 FTI(ISYM2)%A,
     &                 GA_Arrays(lg_Y)%A(IY))
          END IF
          END DO
        END IF

C  D&EP Two-el
        LLST1=LLIST(ISYM1,ISYM2, 7)
        NLST1=NLIST(ISYM1,ISYM2, 7)
        NU=NASH(ISYM2)
        IF(NLST1*NU/=0) THEN
          VAL1(1)=-One
          VAL1(2)=-One
          DO ISYMA=1,NSYM
          NA=NSSH(ISYMA)
          ISYMI=Mul(ISYMA,ISYM1)
          NI=NISH(ISYMI)
          ISYMIJ=Mul(ISYMI,ISYM12)
          NLST2=NLIST(ISYMI,ISYMIJ,14)
          IF(NA*NI*NLST2/=0) THEN
            LLST2=LLIST(ISYMI,ISYMIJ,14)
            VAL2(1)= SQRI2
            VAL2(2)= One
            IX=1+NAS1*IOFCD(ISYM1,ISYMA)
            INCX1=1
            INCX2=NAS1
            INCX3=NAS1*NI
            INCF1=NISH(ISYM12)
            INCF2=1
            IY=1+NU*IOFCEP(ISYM2,ISYMA)
            INCY1=1
            INCY2=NU*NA
            INCY3=NU
            LEN1=NA
            CALL MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                  X2(IX),
     &                  FIT(ISYM12)%A,
     &                  GA_Arrays(lg_Y)%A(IY))
          END IF
          END DO
        END IF
C  -----------------------------------------------
      CASE (14)
C ICASE1= 5
C ICASE2= 7

C  D&EM One-el
        NT=NASH(ISYM2)
        IF(ISYM1==1 .AND. NT/=0) THEN
          DO ISYMI=1,NSYM
          NI=NISH(ISYMI)
          NA=NSSH(ISYMI)
          ISYMIJ=Mul(ISYMI,ISYM2)
          NLST1=NLIST(ISYMI,ISYMIJ,15)
          IF(NI*NA*NLST1/=0) THEN
            LLST1=LLIST(ISYMI,ISYMIJ,15)
            VAL1(1)= SQR32
            VAL1(2)=-SQR32
            IXIA=1+IOFFIA(ISYMI)
            INCX1=1
            INCX2=NI
            INCF1=NASH(ISYM2)
            INCF2=1
            IY=1+NAS2*IOFCEM(ISYM2,ISYMI)
            INCY1=NT*NA
            INCY2=NT
            INCY3=1
            LEN1=NA
            LEN2=NT
            CALL MLTMV(IMLTOP,LIST(LLST1),
     &                 X1(IXIA),
     &                 FTI(ISYM2)%A,
     &                 GA_Arrays(lg_Y)%A(IY))
          END IF
          END DO
        END IF

C  D&EM Two-el
        NLST1=NLIST(ISYM1,ISYM2, 7)
        NU=NASH(ISYM2)
        IF(NLST1*NU/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 7)
          VAL1(1)=-One
          VAL1(2)= One
          DO ISYMA=1,NSYM
            NA=NSSH(ISYMA)
            ISYMI=Mul(ISYMA,ISYM1)
            NI=NISH(ISYMI)
            ISYMIJ=Mul(ISYMI,ISYM12)
            NLST2=NLIST(ISYMI,ISYMIJ,15)
            IF(NA*NI*NLST2/=0) THEN
              LLST2=LLIST(ISYMI,ISYMIJ,15)
              VAL2(1)= SQRI6
              VAL2(2)=-SQRI6
              IX=1+NAS1*IOFCD(ISYM1,ISYMA)
              INCX1=1
              INCX2=NAS1
              INCX3=NAS1*NI
              INCF1=NISH(ISYM12)
              INCF2=1
              IY=1+NU*IOFCEM(ISYM2,ISYMA)
              INCY1=1
              INCY2=NU*NA
              INCY3=NU
              LEN1=NA
              CALL MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                          X2(IX),
     &                          FIT(ISYM12)%A,
     &                          GA_Arrays(lg_Y)%A(IY))
            END IF
            END DO
        END IF
C  -----------------------------------------------
      CASE (15)
C ICASE1= 5
C ICASE2= 10

C  D&GP Two-el
        NLST1=NLIST(ISYM1,ISYM2, 8)
        NU=NASH(ISYM2)
        IF(NLST1*NU/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 8)
          VAL1(1)= One
          VAL1(2)= One
            DO ISYMA=1,NSYM
            ISYMI=Mul(ISYMA,ISYM1)
            NI=NISH(ISYMI)
            ISYMAB=Mul(ISYMA,ISYM12)
            NLST2=NLIST(ISYMA,ISYMAB,16)
            IF(NI*NLST2/=0) THEN
              LLST2=LLIST(ISYMA,ISYMAB,16)
              VAL2(1)= SQRI2
              VAL2(2)= One
              IX=1+NAS1*IOFCD(ISYM1,ISYMA)
              INCX1=1
              INCX2=NAS1*NI
              INCX3=NAS1
              INCF1=1
              INCF2=NASH(ISYM12)
              IY=1+NU*IOFCGP(ISYM2,ISYMI)
              INCY1=1
              INCY2=NU*NI
              INCY3=NU
              LEN1=NI
              CALL MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                    X2(IX),
     &                    FTA(ISYM12)%A,
     &                    GA_Arrays(lg_Y)%A(IY))
            END IF
            END DO
        END IF
C  -----------------------------------------------
      CASE (16)
C ICASE1= 5
C ICASE2= 11

C  D&GM Two-el
        NLST1=NLIST(ISYM1,ISYM2, 8)
        NU=NASH(ISYM2)
        IF(NLST1*NU/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 8)
          VAL1(1)=-One
          VAL1(2)= One
            DO ISYMA=1,NSYM
            ISYMI=Mul(ISYMA,ISYM1)
            NI=NISH(ISYMI)
            ISYMAB=Mul(ISYMA,ISYM12)
            NLST2=NLIST(ISYMA,ISYMAB,17)
            IF(NI*NLST2/=0) THEN
              LLST2=LLIST(ISYMA,ISYMAB,17)
              VAL2(1)= SQRI6
              VAL2(2)=-SQRI6
              IX=1+NAS1*IOFCD(ISYM1,ISYMA)
              INCX1=1
              INCX2=NAS1*NI
              INCX3=NAS1
              INCF1=1
              INCF2=NASH(ISYM12)
              IY=1+NU*IOFCGM(ISYM2,ISYMI)
              INCY1=1
              INCY2=NU*NI
              INCY3=NU
              LEN1=NI
              CALL MLTDXP(IMLTOP,LIST(LLST1),LIST(LLST2),
     &                    X2(IX),
     &                    FTA(ISYM12)%A,
     &                    GA_Arrays(lg_Y)%A(IY))
            END IF
            END DO
        END IF
C  -----------------------------------------------
      CASE (17)
C ICASE1= 6
C ICASE2= 12

C  EP&HP Two-el
        NA=NSSH(ISYM12)
        NLST1=NLIST(ISYM12,ISYM2,16)
        IF(NA*NLST1/=0) THEN
          LLST1=LLIST(ISYM12,ISYM2,16)
          VAL1(1)= SQRI2
          VAL1(2)= One
          JXOFF=IOFCEP(ISYM1,ISYM12)
          INCX3=NAS1*NA
          NFT=NASH(ISYM1)
          NFA=NSSH(ISYM1)
          CALL PMLTR1(KOD,IMLTOP,LIST(LLST1),
     &                X2,NAS1,NIS1,JXOFF,
     &                FTA(ISYM1)%A,NFT,NFA,
     &                lg_Y,NAS2,NIS2)
        END IF
C  -----------------------------------------------
      CASE (18)
C ICASE1= 7
C ICASE2= 13

C  EM&HM Two-el
        NA=NSSH(ISYM12)
        NLST1=NLIST(ISYM12,ISYM2,17)
        IF(NA*NLST1/=0) THEN
          LLST1=LLIST(ISYM12,ISYM2,17)
          VAL1(1)= SQRI2
          VAL1(2)=-SQRI2
          JXOFF=IOFCEM(ISYM1,ISYM12)
          INCX3=NAS1*NA
          NFT=NASH(ISYM1)
          NFA=NSSH(ISYM1)
          CALL PMLTR1(KOD,IMLTOP,LIST(LLST1),
     &                X2,NAS1,NIS1,JXOFF,
     &                FTA(ISYM1)%A,NFT,NFA,
     &                lg_Y,NAS2,NIS2)
        END IF
C  -----------------------------------------------
      CASE (19)
C ICASE1= 8
C ICASE2= 10

C  FP&GP Two-el
        NI=NISH(ISYM12)
        NLST1=NLIST(ISYM1,ISYM2, 9)
        IF(NI*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2, 9)
          VAL1(1)=-SQRI2
          VAL1(2)=-SQRI2
          IX=1
          INCX1=1
          INCX2=NAS1
          INCF1=NI
          INCF2=1
          IY=1+NAS2*IOFCGP(ISYM2,ISYM12)
          INCY1=1
          INCY2=NAS2*NI
          INCY3=NAS2
          LEN1=NIS1
          LEN2=NI
          CALL MLTMV(IMLTOP,LIST(LLST1),
     &               X2(IX),
     &               FIT(ISYM12)%A,
     &               GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (20)
C ICASE1= 9
C ICASE2= 11

C  FM&GM Two-el
        NI=NISH(ISYM12)
        NLST1=NLIST(ISYM1,ISYM2,10)
        IF(NI*NLST1/=0) THEN
          LLST1=LLIST(ISYM1,ISYM2,10)
          VAL1(1)=-SQRI6
          VAL1(2)= SQRI6
          IX=1
          INCX1=1
          INCX2=NAS1
          INCF1=NI
          INCF2=1
          IY=1+NAS2*IOFCGM(ISYM2,ISYM12)
          INCY1=1
          INCY2=NAS2*NI
          INCY3=NAS2
          LEN1=NIS1
          LEN2=NI
          CALL MLTMV(IMLTOP,LIST(LLST1),
     &               X2(IX),
     &               FIT(ISYM12)%A,
     &               GA_Arrays(lg_Y)%A(IY))
        END IF
C  -----------------------------------------------
      CASE (21)
C ICASE1= 10
C ICASE2= 12

C  GP&HP Two-el
        NLST1=NLIST(ISYM12,ISYM2,14)
        IF(NLST1/=0) THEN
          LLST1=LLIST(ISYM12,ISYM2,14)
          VAL1(1)= -SQRI2
          VAL1(2)= -One
          JXOFF=IOFCGP(ISYM1,ISYM12)
          INCX3=NAS1*NISH(ISYM12)
          NFT=NASH(ISYM1)
          NFI=NISH(ISYM1)
          CALL PMLTR1(KOD,IMLTOP,LIST(LLST1),
     &                X2,NAS1,NIS1,JXOFF,
     &                FTI(ISYM1)%A,NFT,NFI,
     &                lg_Y,NAS2,NIS2)
        END IF
C  -----------------------------------------------
      CASE (22)
C ICASE1= 11
C ICASE2= 13

C  GM&HM Two-el
        NLST1=NLIST(ISYM12,ISYM2,15)
        IF(NLST1/=0) THEN
          LLST1=LLIST(ISYM12,ISYM2,15)
          VAL1(1)= SQRI2
          VAL1(2)=-SQRI2
          JXOFF=IOFCGM(ISYM1,ISYM12)
          INCX3=NAS1*NISH(ISYM12)
          NFT=NASH(ISYM1)
          NFI=NISH(ISYM1)
          CALL PMLTR1(KOD,IMLTOP,LIST(LLST1),
     &                X2,NAS1,NIS1,JXOFF,
     &                FTI(ISYM1)%A,NFT,NFI,
     &                lg_Y,NAS2,NIS2)
        END IF
C  -----------------------------------------------
      CASE (23)
C ICASE1= 5
C ICASE2= 12

C  D&HP One-el
        IF(ISYM1==1) THEN
          DO ISYMI=1,NSYM
          NI=NISH(ISYMI)
          ISYMA=ISYMI
          NA=NSSH(ISYMA)
          ISYMJ=Mul(ISYMI,ISYM2)
          NJ=NISH(ISYMJ)
          ISYMB=ISYMJ
          NB=NSSH(ISYMB)
          NLST1=NLIST(ISYMI,ISYM2,14)
          NLST2=NLIST(ISYMA,ISYM2,16)
          IF(NI*NA*NJ*NB*NLST1*NLST2/=0) THEN
            LLST1=LLIST(ISYMI,ISYM2,14)
            VAL1(1)=SQRI2
            VAL1(2)=One
            LLST2=LLIST(ISYMA,ISYM2,16)
            VAL2(1)=SQRI2
            VAL2(2)=One
            IXIA=1+IOFFIA(ISYMI)
            INCX1=1
            INCX2=NI
            CALL PMLTSCA(KOD,IMLTOP,
     &                   LIST(LLST1),LIST(LLST2),
     &                   X1(IXIA),NI,NA,
     &                   FIA(ISYMB)%A,NJ,NB,
     &                   lg_Y,NAS2,NIS2)
          END IF
          END DO
        END IF
C ---------------------------
      CASE (24)
C ICASE1= 5
C ICASE2= 13

C  D&HM One-el
        IF(ISYM1==1) THEN
          DO ISYMI=1,NSYM
          NI=NISH(ISYMI)
          ISYMA=ISYMI
          NA=NSSH(ISYMA)
          ISYMJ=Mul(ISYMI,ISYM2)
          NJ=NISH(ISYMJ)
          ISYMB=ISYMJ
          NB=NSSH(ISYMB)
          NLST1=NLIST(ISYMI,ISYM2,15)
          NLST2=NLIST(ISYMA,ISYM2,17)
          IF(NI*NA*NJ*NB*NLST1*NLST2/=0) THEN
            LLST1=LLIST(ISYMI,ISYM2,15)
            VAL1(1)=SQR3*Half
            VAL1(2)=-VAL1(1)
            LLST2=LLIST(ISYMA,ISYM2,17)
            VAL2(1)= One
            VAL2(2)=-One
            IXIA=1+IOFFIA(ISYMI)
            INCX1=1
            INCX2=NI
            CALL PMLTSCA(KOD,IMLTOP,
     &                   LIST(LLST1),LIST(LLST2),
     &                   X1(IXIA),NI,NA,
     &                   FIA(ISYMB)%A,NJ,NB,
     &                   lg_Y,NAS2,NIS2)
          END IF
          END DO
        END IF
C ---------------------------
      CASE DEFAULT
        WRITE(6,*)' INTERNAL ERROR: SGM reached invalid KOD=',KOD
        Call Abend()
      END SELECT

      END SUBROUTINE SGM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CASPT2_ResD(Mode,NIN,NIS,lg_W1,lg_W2,DIN,DIS)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
#endif
use fake_GA, only: GA_Arrays
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Mode, NIN, NIS, lg_W1, lg_W2
real(kind=wp), intent(in) :: DIN(NIN), DIS(NIS)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iHi1, iHi2, iLo1, iLo2, jHi1, jHi2, jLo1, jLo2, LDW1, LDW2, mW1, mW2, myRank, NCOL, NROW
#endif

! Apply the resolvent of the diagonal part of H0 to an RHS array

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  call GA_Sync()
  myRank = GA_NodeID()
  !-SVC: get the local vertical stripes of the lg_W vector
  call GA_Distribution(lg_W1,myRank,iLo1,iHi1,jLo1,jHi1)
  call GA_Distribution(lg_W2,myRank,iLo2,iHi2,jLo2,jHi2)
  !! Well, assume the same dimension
  if ((iLo1 > 0) .and. (jLo1 > 0) .and. (iLo2 > 0) .and. (jLo2 > 0)) then
    NROW = iHi1-iLo1+1
    NCOL = jHi1-jLo1+1
    call GA_Access(lg_W1,iLo1,iHi1,jLo1,jHi1,mW1,LDW1)
    call GA_Access(lg_W2,iLo2,iHi2,jLo2,jHi2,mW2,LDW2)
    call CASPT2_ResD2(MODE,NROW,NCOL,DBL_MB(mW1),DBL_MB(mW2),LDW1,DIN(iLo1),DIS(jLo1))
    call GA_Release_Update(lg_W1,iLo1,iHi1,jLo1,jHi1)
    call GA_Release_Update(lg_W2,iLo2,iHi2,jLo2,jHi2)
  end if
  call GA_Sync()
else
#endif
  call CASPT2_ResD2(MODE,NIN,NIS,GA_Arrays(lg_W1)%A,GA_Arrays(lg_W2)%A,NIN,DIN,DIS)
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine CASPT2_ResD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Yoshio Nishimoto                                 *
************************************************************************
      Subroutine DerHEff(CLag,VECROT)

      use caspt2_global, only: LUCIEX, IDTCEX
      use EQSOLV, only: IVECW, IVECC
      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: STSYM, NCONF, NASHT, ISCF, NSTATE, JSTATE
      use pt2_guga, only: MXCI
      use Constants, only: Zero

      implicit none

      integer(kind=iwp) ::  IST, JST, I, NTG1, NTG2, NTG3, IDCI
      real(kind=wp) :: OVL, DUMMY(1)

      real(kind=wp), intent(inout) :: CLag(nConf,nState)
      real(kind=wp), intent(in) :: VECROT(*)

      real(kind=wp),allocatable :: DTG1(:),DTG2(:),DTG3(:),CI1(:),
     &  CI2(:),CI3(:)
!     return

! We evaluate the effective Hamiltonian matrix element in two steps.

      NTG1=NASHT**2
      NTG2=NASHT**4
      NTG3=(NTG1*(NTG1+1)*(NTG1+2))/6
! Note: Need proper allocation even if unused, sinced allocated
! arrays are in subroutine parameter lists of MKTG3, HCOUP.
      NTG1=MAX(1,NTG1)
      NTG2=MAX(1,NTG2)
      NTG3=MAX(1,NTG3)
      call mma_allocate(DTG1,NTG1,Label='DTG1')
      call mma_allocate(DTG2,NTG2,Label='DTG2')
      call mma_allocate(DTG3,NTG3,Label='DTG3')
      DTG1(:) = Zero
      DTG2(:) = Zero
      DTG3(:) = Zero

      !! OVL will contain the derivative contribution?
      !! It should be ignored
      OVL = Zero
      CALL DerHeffX(IVECW,IVECC,OVL,DTG1,DTG2,DTG3)

      call mma_allocate(CI1,MXCI,Label='MCCI1')
      call mma_allocate(CI2,MXCI,Label='MCCI2')
      call mma_allocate(CI3,MXCI,Label='MCCI3')

      IF(ISCF == 0) THEN
        IDCI=IDTCEX
        JST = jState
        CI1(1:NCONF) = Zero
        DO I=1,NSTATE
          IST = I
          IF (IST == JST) THEN
            CALL DDAFILE(LUCIEX,2,CI2,NCONF,IDCI)
          Else If (ABS(VECROT(IST)) <= 1.0e-12_wp) Then
            CALL DDAFILE(LUCIEX,0,DUMMY,NCONF,IDCI)
          ELSE
            CALL DDAFILE(LUCIEX,2,CI3,NCONF,IDCI)
            CI1(1:NCONF) = CI1(1:NCONF) + VECROT(IST)*CI3(1:NCONF)
          END IF
        END DO

        CI3(1:NCONF) = Zero
        CALL DERTG3(.TRUE.,STSYM,STSYM,CI1,CI2,OVL,
     &              DTG1,DTG2,NTG3,DTG3,CI3,CLag(1,JST))

        DO I=1,NSTATE
          IST = I
          IF (IST == JST) THEN
            CYCLE
          Else If (ABS(VECROT(IST)) <= 1.0e-12_wp) Then
            CYCLE
          ELSE
            CLag(1:NCONF,IST) = CLag(1:NCONF,IST)
     &        + VECROT(IST)*CI3(1:NCONF)
          END IF
        END DO
      END IF

      call mma_deallocate(CI1)
      call mma_deallocate(CI2)
      call mma_deallocate(CI3)

      call mma_deallocate(DTG1)
      call mma_deallocate(DTG2)
      call mma_deallocate(DTG3)

      End Subroutine DerHEff
!
!-----------------------------------------------------------------------
!
      SUBROUTINE DerHeffX(IVEC,JVEC,OVL,DTG1,DTG2,DTG3)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: NSYM, NASHT, NASUP, NISUP, NINDEP
      use definitions, only: wp, iwp, u6

      implicit none
! Compute the coupling Hamiltonian element defined as
!     HEL = < ROOT1 | H * OMEGA | ROOT2 >
! assuming that IVEC contains a contravariant representation of
! H|ROOT1>, JVEC contains a contravariant representation of
! OMEGA|ROOT2>, and OVL, TG1, TG2, TG3 contain the overlap (normally
! expected to be 0 or 1) and active transition density matrices of ROOT1
! and ROOT2. See also subroutine TSVEC for explanations.

! SVC (March 2014): modification of original code to handle distributed
! RHS arrays. There is now a main HCOUP subroutine that loops over cases
! and irreps and gets access to the process-specific block of the RHS.
! The coupling for that block is computed by the subroutine HCOUP_BLK.

      integer(kind=iwp), intent(in) :: IVEC, JVEC
      real(kind=wp), intent(out) :: OVL
      real(kind=wp), intent(inout) :: DTG1(NASHT,NASHT),
     &  DTG2(NASHT,NASHT,NASHT,NASHT), DTG3(*)

      integer(kind=iwp) :: ICASE, ISYM, NAS, NIN, NIS, lg_V1, lg_V2,
     &  iLo1, iHi1, jLo1, jHi1, MV1, iLo2, iHi2, jLo2, jHi2, MV2
! The dimension of TG3 is NTG3=(NASHT**2+2 over 3)

#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif


! Sketch of procedure:
!  Loop over every (case/symmetry)-block.
!           If (No such vector block) Skip to end of loop
!           Allocate two places for this block, VEC1 and VEC2
!           Read VEC1 as IVEC component from file.
!           Read VEC2 as JVEC component from file.
!           Loop nest, computing
!              HEL := HEL + VEC1*GOM*VEC2
!           End of loop nest
!           Deallocate VEC1 and VEC2
!  End of loop.

      DO ICASE=1,13
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIN=NINDEP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)

          IF(NAS*NIS == 0) cycle
          IF(NIN == 0) cycle

          CALL RHS_ALLO (NAS,NIS,lg_V1)
          CALL RHS_ALLO (NAS,NIS,lg_V2)
          CALL RHS_READ (NAS,NIS,lg_V1,ICASE,ISYM,IVEC)
          CALL RHS_READ (NAS,NIS,lg_V2,ICASE,ISYM,JVEC)
          CALL RHS_ACCESS(NAS,NIS,lg_V1,iLo1,iHi1,jLo1,jHi1,MV1)
          CALL RHS_ACCESS(NAS,NIS,lg_V2,iLo2,iHi2,jLo2,jHi2,MV2)

          IF ((iLo1 /= iLo2) .OR. (iHi1 /= iHi2) .OR.
     &        (jLo1 /= jLo2) .OR. (jHi1 /= jHi2)) THEN
            WRITE(u6,'(1X,A)') 'HCOUP: Error: block mismatch, abort...'
            CALL ABEND()
          END IF

#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            CALL DerHEffX_BLK(ICASE,ISYM,NAS,jLo1,jHi1,
     &                      DBL_MB(MV1),DBL_MB(MV2),OVL,
     &                      DTG1,DTG2,DTG3)
          ELSE
#endif
            CALL DerHEffX_BLK(ICASE,ISYM,NAS,jLo1,jHi1,
     &                        GA_Arrays(MV1)%A,
     &                        GA_Arrays(MV2)%A,OVL,
     &                        DTG1,DTG2,DTG3)
#ifdef _MOLCAS_MPP_
          END IF
#endif

          CALL RHS_RELEASE (lg_V1,iLo1,iHi1,jLo1,jHi1)
          CALL RHS_RELEASE (lg_V2,iLo2,iHi2,jLo2,jHi2)
          CALL RHS_FREE (lg_V1)
          CALL RHS_FREE (lg_V2)
        END DO
      END DO

      end subroutine DerHeffX
!
!-----------------------------------------------------------------------
!
      SUBROUTINE DerHEffX_BLK(ICASE,ISYM,NAS,IISTA,IIEND,V1,V2,OVL,
     &                        DTG1,DTG2,DTG3)

      USE SUPERINDEX, only: MTU, MTUV, MTGEU, MTGTU
      use caspt2_module, only: NAES, NASHT, NTUVES, NTUES, NTGEUES,
     &                         NTGTUES
      use definitions, only: wp, iwp
      use Constants, only: Zero, Two, Four, Eight
! Compute a contribution to the coupling Hamiltonian element (HEL)
! defined as HEL = < ROOT1 | H * OMEGA | ROOT2 >. The contribution
! arises from the block V_(A,I), with A=1,NAS and I=IISTA,IIEND,
! with A the active superindex and I the inactive superindex. Since
! the inactive superindex is partitioned over processes, each process
! only computes part of the HEL value, which is then sum reduced in the
! calling subroutine.
      implicit none

      integer(kind=iwp), intent(in) :: ICASE, ISYM, NAS, IISTA, IIEND
      real(kind=wp), intent(in) :: V1(*), V2(*)
      real(kind=wp), intent(out) :: OVL
      real(kind=wp), intent(inout) :: DTG1(NASHT,NASHT),
     &  DTG2(NASHT,NASHT,NASHT,NASHT), DTG3(*)
! The dimension of TG3 is NTG3=(NASHT**2+2 over 3)

      integer(kind=iwp) :: NISBLK, IAS, IASABS, ITABS, IUABS, IVABS,
     &  JAS, JASABS, IXABS, IYABS, IZABS, IND1, IND2, IND3, JND1,
     &  JND2, JND3, ITG3, NAS1, IAS1, IAS2, JAS1, JAS2
      real(kind=wp) :: VAL, VAL11, VAL12, VAL21, VAL22
      real(kind=wp), external :: ddot_

      IF (IISTA <= 0) RETURN

      OVL = Zero
      NISBLK=IIEND-IISTA+1
      SELECT CASE (ICASE)
************************************************************************
      CASE (1)
        DO IAS=1,NAS
          IASABS=NTUVES(ISYM)+IAS
          ITABS=MTUV(1,IASABS)
          IUABS=MTUV(2,IASABS)
          IVABS=MTUV(3,IASABS)
          DO JAS=1,NAS
            JASABS=NTUVES(ISYM)+JAS
            IXABS=MTUV(1,JASABS)
            IYABS=MTUV(2,JASABS)
            IZABS=MTUV(3,JASABS)
! Compute and use SA(ITABS IUABS IVABS, IXABS IYABS IZABS)
! Formulae used:
!  SA(tuv,xyz) =  -Gvuxtyz -dyu Gvzxt - dyt Gvuxz -
!         - dxu Gvtyz - dxu dyt Gvz +2 dtx Gvuyz + 2 dtx dyu Gvz
! Gvuxtyz is stored using full permutation symmetry of three pairs
! (vu),(xt), and (yz):
            IND1=IVABS+NASHT*(IUABS-1)
            IND2=IXABS+NASHT*(ITABS-1)
            IND3=IYABS+NASHT*(IZABS-1)
            IF(IND2 > IND3) THEN
              IF(IND1 > IND2) THEN
                JND1=IND1
                JND2=IND2
                JND3=IND3
              ELSE IF(IND1 > IND3) THEN
                JND1=IND2
                JND2=IND1
                JND3=IND3
              ELSE
                JND1=IND2
                JND2=IND3
                JND3=IND1
              END IF
            ELSE
              IF(IND1 > IND3) THEN
                JND1=IND1
                JND2=IND3
                JND3=IND2
              ELSE IF(IND1 > IND2) THEN
                JND1=IND3
                JND2=IND1
                JND3=IND2
              ELSE
                JND1=IND3
                JND2=IND2
                JND3=IND1
              END IF
            END IF
            ITG3=((JND1+1)*JND1*(JND1-1))/6+(JND2*(JND2-1))/2+JND3
!  SA(tuv,xyz) =  -Gvuxtyz -dyu Gvzxt - dyt Gvuxz -
!         - dxu Gvtyz - dxu dyt Gvz +2 dtx Gvuyz + 2 dtx dyu Gvz
! Compute TMP=Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
            VAL = DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
            IF(IXABS == ITABS) THEN
              DTG2(IVABS,IUABS,IYABS,IZABS)
     &          = DTG2(IVABS,IUABS,IYABS,IZABS) + Two*VAL
              IF(IYABS == IUABS) THEN
                DTG1(IVABS,IZABS) = DTG1(IVABS,IZABS) + Two*VAL
              END IF
            END IF
            VAL = -VAL
            DTG3(ITG3) = DTG3(ITG3) + VAL
            IF(IYABS == IUABS) THEN
              DTG2(IVABS,IZABS,IXABS,ITABS)
     &          = DTG2(IVABS,IZABS,IXABS,ITABS) + VAL
            END IF
            IF(IYABS == ITABS) THEN
              DTG2(IVABS,IUABS,IXABS,IZABS)
     &          = DTG2(IVABS,IUABS,IXABS,IZABS) + VAL
              IF(IXABS == IUABS) THEN
                DTG1(IVABS,IZABS) = DTG1(IVABS,IZABS) + VAL
              END IF
            END IF
            IF(IXABS == IUABS) THEN
              DTG2(IVABS,ITABS,IYABS,IZABS)
     &          = DTG2(IVABS,ITABS,IYABS,IZABS) + VAL
            END IF
          END DO
        END DO
************************************************************************
      CASE(4)
        DO IAS=1,NAS
          IASABS=NTUVES(ISYM)+IAS
          IXABS=MTUV(1,IASABS)
          IUABS=MTUV(2,IASABS)
          IVABS=MTUV(3,IASABS)
          DO JAS=1,NAS
            JASABS=NTUVES(ISYM)+JAS
            ITABS=MTUV(1,JASABS)
            IYABS=MTUV(2,JASABS)
            IZABS=MTUV(3,JASABS)
! Compute and use SC(IXABS IUABS IVABS, ITABS IYABS IZABS)
! In SBMAT, the formula is written as SC(tuv,xyz)
!    = Gvutxyz +dyu Gvztx + dyx Gvutz + dtu Gvxyz + dtu dyx Gvz
! Rewritten, in order to reuse same quantities as in SA:
!  SC(xuv,tyz)
!    = Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
! Gvuxtyz is stored using full permutation symmetry of three pairs
! (vu),(xt), and (yz):
            IND1=IVABS+NASHT*(IUABS-1)
            IND2=IXABS+NASHT*(ITABS-1)
            IND3=IYABS+NASHT*(IZABS-1)
            IF(IND2 > IND3) THEN
              IF(IND1 > IND2) THEN
                JND1=IND1
                JND2=IND2
                JND3=IND3
              ELSE IF(IND1 > IND3) THEN
                JND1=IND2
                JND2=IND1
                JND3=IND3
              ELSE
                JND1=IND2
                JND2=IND3
                JND3=IND1
              END IF
            ELSE
              IF(IND1 > IND3) THEN
                JND1=IND1
                JND2=IND3
                JND3=IND2
              ELSE IF(IND1 > IND2) THEN
                JND1=IND3
                JND2=IND1
                JND3=IND2
              ELSE
                JND1=IND3
                JND2=IND2
                JND3=IND1
              END IF
            END IF
            ITG3=((JND1+1)*JND1*(JND1-1))/6+(JND2*(JND2-1))/2+JND3
!  SC(xuv,tyz) (rewritten, swapping x and t)
!    = Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
            VAL = DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
            DTG3(ITG3) = DTG3(ITG3) + VAL
            IF(IYABS == IUABS) THEN
              DTG2(IVABS,IZABS,IXABS,ITABS)
     &          = DTG2(IVABS,IZABS,IXABS,ITABS) + VAL
            END IF
            IF(IYABS == ITABS) THEN
              DTG2(IVABS,IUABS,IXABS,IZABS)
     &          = DTG2(IVABS,IUABS,IXABS,IZABS) + VAL
              IF(IXABS == IUABS) THEN
                DTG1(IVABS,IZABS) = DTG1(IVABS,IZABS) + VAL
              END IF
            END IF
            IF(IXABS == IUABS) THEN
              DTG2(IVABS,ITABS,IYABS,IZABS)
     &          = DTG2(IVABS,ITABS,IYABS,IZABS) + VAL
            END IF
          END DO
        END DO
************************************************************************
      CASE(2)
        DO IAS=1,NAS
          IASABS=NTGEUES(ISYM)+IAS
          ITABS=MTGEU(1,IASABS)
          IUABS=MTGEU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGEUES(ISYM)+JAS
            IXABS=MTGEU(1,JASABS)
            IYABS=MTGEU(2,JASABS)
! Formulae used:
!    SB(tu,xy)=
!    = 2 Gxtyu -4dxt Gyu -4dyu Gxt +2dyt Gxu + 8 dxt dyu
!      -4dxu dyt + 2dxu Gyt
!    SB(tu,yx)=
!    = 2 Gytxu -4dyt Gxu -4dxu Gyt +2dxt Gyu + 8 dyt dxu
!      -4dyu dxt + 2dyu Gxt
            VAL = DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
            DTG2(IXABS,ITABS,IYABS,IUABS)
     &        = DTG2(IXABS,ITABS,IYABS,IUABS) + Two*VAL
            DTG2(IYABS,ITABS,IXABS,IUABS)
     &        = DTG2(IYABS,ITABS,IXABS,IUABS) + Two*VAL
            IF(IXABS == ITABS) THEN
              DTG1(IYABS,IUABS) = DTG1(IYABS,IUABS) - Four*VAL + Two*VAL
              IF(IYABS == IUABS) THEN
                OVL = OVL + Eight*VAL - Four*VAL
              END IF
            END IF
            IF(IYABS == IUABS) THEN
              DTG1(IXABS,ITABS) = DTG1(IXABS,ITABS) - Four*VAL + Two*VAL
            END IF
            IF(IYABS == ITABS) THEN
              DTG1(IXABS,IUABS) = DTG1(IXABS,IUABS) + Two*VAL - Four*VAL
              IF(IXABS == IUABS) THEN
                OVL = OVL - Four*VAL + Eight*VAL
              END IF
            END IF
            IF(IXABS == IUABS) THEN
              DTG1(IYABS,ITABS) = DTG1(IYABS,ITABS) + Two*VAL - Four*VAL
            END IF
          END DO
        END DO
************************************************************************
      CASE(3)
        DO IAS=1,NAS
          IASABS=NTGTUES(ISYM)+IAS
          ITABS=MTGTU(1,IASABS)
          IUABS=MTGTU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGTUES(ISYM)+JAS
            IXABS=MTGTU(1,JASABS)
            IYABS=MTGTU(2,JASABS)
! Formulae used:
!    SB(tu,xy)=
!    = 2 Gxtyu -4dxt Gyu -4dyu Gxt +2dyt Gxu + 8 dxt dyu
!      -4dxu dyt + 2dxu Gyt
!    SB(tu,yx)=
!    = 2 Gytxu -4dyt Gxu -4dxu Gyt +2dxt Gyu + 8 dyt dxu
!      -4dyu dxt + 2dyu Gxt
            VAL = DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
            DTG2(IXABS,ITABS,IYABS,IUABS)
     &        = DTG2(IXABS,ITABS,IYABS,IUABS) + Two*VAL
            DTG2(IYABS,ITABS,IXABS,IUABS)
     &        = DTG2(IYABS,ITABS,IXABS,IUABS) - Two*VAL
            IF(IXABS == ITABS) THEN
              DTG1(IYABS,IUABS) = DTG1(IYABS,IUABS) - Four*VAL - Two*VAL
              IF(IYABS == IUABS) THEN
                OVL = OVL + Eight*VAL + Four*VAL
              END IF
            END IF
            IF(IYABS == IUABS) THEN
              DTG1(IXABS,ITABS) = DTG1(IXABS,ITABS) - Four*VAL - Two*VAL
            END IF
            IF(IYABS == ITABS) THEN
              DTG1(IXABS,IUABS) = DTG1(IXABS,IUABS) + Two*VAL + Four*VAL
              IF(IXABS == IUABS) THEN
                OVL = OVL - Four*VAL - Eight*VAL
              END IF
            END IF
            IF(IXABS == IUABS) THEN
              DTG1(IYABS,ITABS) = DTG1(IYABS,ITABS) + Two*VAL + Four*VAL
            END IF
          END DO
        END DO
************************************************************************
      CASE(5)
        NAS1=NAS/2
        DO IAS1=1,NAS1
          IAS2=IAS1+NAS1
          IASABS=NTUES(ISYM)+IAS1
          ITABS=MTU(1,IASABS)
          IUABS=MTU(2,IASABS)
          DO JAS1=1,NAS1
            JAS2=JAS1+NAS1
            JASABS=NTUES(ISYM)+JAS1
            IXABS=MTU(1,JASABS)
            IYABS=MTU(2,JASABS)
! Formulae used:
!    SD11(tu1,xy1)=2*(Gutxy + dtx Guy)
!    SD12(tu2,xy1)= -(Gutxy + dtx Guy)
!    SD21(tu2,xy1)= -(Gutxy + dtx Guy)
!    SD22(tu2,xy2)= -Gxtuy +2*dtx Guy
            VAL11 = DDOT_(NISBLK,V1(IAS1),NAS,V2(JAS1),NAS)
            VAL12 = DDOT_(NISBLK,V1(IAS1),NAS,V2(JAS2),NAS)
            VAL21 = DDOT_(NISBLK,V1(IAS2),NAS,V2(JAS1),NAS)
            VAL22 = DDOT_(NISBLK,V1(IAS2),NAS,V2(JAS2),NAS)
            DTG2(IUABS,ITABS,IXABS,IYABS)
     &        = DTG2(IUABS,ITABS,IXABS,IYABS)
     &        + Two*VAL11 - VAL12 - VAL21
            DTG2(IXABS,ITABS,IUABS,IYABS)
     &        = DTG2(IXABS,ITABS,IUABS,IYABS) - VAL22
            IF(ITABS == IXABS) THEN
              DTG1(IUABS,IYABS) = DTG1(IUABS,IYABS)
     &          + Two*VAL11 - VAL12 - VAL21 + Two*VAL22
            END IF
          END DO
        END DO
************************************************************************
      CASE(6)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
! Formula used: SE(t,x)=2*dxt - Dxt
            VAL = DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
            DTG1(IXABS,ITABS) = DTG1(IXABS,ITABS) - VAL
            IF(IXABS == ITABS) OVL=OVL+Two*VAL
          END DO
        END DO
************************************************************************
      CASE(7)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
! Formula used: SE(t,x)=2*dxt - Dxt
            VAL = DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
            DTG1(IXABS,ITABS) = DTG1(IXABS,ITABS) - VAL
            IF(IXABS == ITABS) OVL=OVL+Two*VAL
          END DO
        END DO
************************************************************************
      CASE(8)
! ========================================================
! Compute and use SFP(ITABS IUABS , IXABS IYABS)
! and (later, similar) SFM(ITABS IUABS , IXABS IYABS)
        DO IAS=1,NAS
          IASABS=NTGEUES(ISYM)+IAS
          ITABS=MTGEU(1,IASABS)
          IUABS=MTGEU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGEUES(ISYM)+JAS
            IXABS=MTGEU(1,JASABS)
            IYABS=MTGEU(2,JASABS)
! Formulae used:
!    SF(tu,xy)= 2 Gtxuy
!    SFP(tu,xy)=SF(tu,xy)+SF(tu,yx)
!    SFM(tu,xy)=SF(tu,xy)-SF(tu,yx)
            VAL = DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
            DTG2(ITABS,IXABS,IUABS,IYABS)
     &        = DTG2(ITABS,IXABS,IUABS,IYABS) + Two*VAL
            DTG2(ITABS,IYABS,IUABS,IXABS)
     &        = DTG2(ITABS,IYABS,IUABS,IXABS) + Two*VAL
          END DO
        END DO
************************************************************************
      CASE(9)
! ========================================================
! Compute and use SFM(ITABS IUABS, IXABS ,IYABS)
        DO IAS=1,NAS
          IASABS=NTGTUES(ISYM)+IAS
          ITABS=MTGTU(1,IASABS)
          IUABS=MTGTU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGTUES(ISYM)+JAS
            IXABS=MTGTU(1,JASABS)
            IYABS=MTGTU(2,JASABS)
! Formulae used:
!    SF(tu,xy)= 4 Ptxuy
!    SFP(tu,xy)=SF(tu,xy)+SF(tu,yx)
!    SFM(tu,xy)=SF(tu,xy)-SF(tu,yx)
            VAL = DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
            DTG2(ITABS,IXABS,IUABS,IYABS)
     &        = DTG2(ITABS,IXABS,IUABS,IYABS) + Two*VAL
            DTG2(ITABS,IYABS,IUABS,IXABS)
     &        = DTG2(ITABS,IYABS,IUABS,IXABS) - Two*VAL
          END DO
        END DO
************************************************************************
! CASES GP, GM
! Compute and use SG(ITABS , IXABS) (Same for cases GP and GM)
************************************************************************
      CASE(10)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
! Formula used: SG(t,x)= Gtx
!           SG= TG1(ITABS,IXABS)
            DTG1(ITABS,IXABS) = DTG1(ITABS,IXABS)
     &        + DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(11)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
! Formula used: SG(t,x)= Gtx
!           SG= TG1(ITABS,IXABS)
            DTG1(ITABS,IXABS) = DTG1(ITABS,IXABS)
     &        + DDOT_(NISBLK,V1(IAS),NAS,V2(JAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(12)
        OVL = OVL + DDOT_(NAS*NISBLK,V2,1,V1,1)
!       IF(ABS(OVL) >= 1.0e-12_wp) THEN
!         HEBLK=HEBLK+OVL*DDOT_(NAS*NISBLK,V2,1,V1,1)
!       END IF
************************************************************************
      CASE(13)
        OVL = OVL + DDOT_(NAS*NISBLK,V2,1,V1,1)
!       IF(ABS(OVL) >= 1.0e-12_wp) THEN
!         HEBLK=HEBLK+OVL*DDOT_(NAS*NISBLK,V2,1,V1,1)
!       END IF
************************************************************************
      END SELECT
      Return
      end subroutine DerHEffX_BLK
!
!-----------------------------------------------------------------------
!
      SUBROUTINE DERTG3(DOG3,LSYM1,LSYM2,CI1,CI2,OVL,DTG1,DTG2,NTG3,
     &                  DTG3,CLAG1,CLAG2)
      use Symmetry_Info, only: Mul
      use gugx, only: SGS, L2ACT, CIS, EXS
      use stdalloc, only: mma_MaxDBLE, mma_allocate, mma_deallocate
      use definitions, only: iwp,wp,u6
      use caspt2_module, only: NACTEL, NASHT, ISCF, IASYM
      use pt2_guga, only: MXCI
      use Constants, only: Zero, One

      implicit none

      logical(kind=iwp), intent(in) :: DOG3
      integer(kind=iwp), intent(in) :: LSYM1, LSYM2, NTG3
      real(kind=wp), intent(in) :: CI1(MXCI), CI2(MXCI), OVL
      real(kind=wp), intent(inout) :: DTG1(NASHT,NASHT),
     &  DTG2(NASHT,NASHT,NASHT,NASHT), DTG3(NTG3), CLAG1(MXCI),
     &  CLAG2(MXCI)

      real(kind=wp), allocatable :: TG3WRK(:),BUF1(:),DTU(:,:),DYZ(:,:)
      integer(kind=iwp), allocatable :: P2LEV(:)
      integer(kind=iwp) :: nLev, LP2LEV1, LP2LEV2, IP, IL, JL, IP1,
     &  IT, IU, ITU, ITS, IUS, IS1, IP2, IV, IX, IVX, IVS, IXS, IS2,
     &  IP3, IY, IZ, IYS, IZS, IS3, IYZ, JTU, JVX, JYZ, JTUVXYZ, NCI1,
     &  NVECS, NTG3WRK, NYZBUF, NTUBUF, LSGM1, LTAU, LSGM2, IP3STA,
     &  IP3END, LTO, ISSG2, IP1STA, IP1END, ISSG1, LFROM, LFROMD, IM,
     &  JM, ISTAU, NTAU, ibuf
      real(kind=wp) :: VAL

      nLev = SGS%nLev
! Procedure for computing 1-body, 2-body, and 3-body transition
! density elements with active indices only.

! In: Wave functions CI1, with symmetry LSYM1, and CI2, with
!  symmetry LSYM2.
!
! Out: Transition density matrices, denoted here TG1, TG2 and TG3.
! Storage: TG1 and TG2 are simple two- and four-index arrays, and
! includes also such zeroes that are implied by symmetry.
! But TG3 is quite large, and while it is stored with zeroes, it
! is made more compact by the following addressing:

! <Psi1|E_tuvxyz|Psi2> is stored in TG3(ITG3) where
!    ITG3= ((i+1)*i*(i-1))/6 + (j*(j-1))/2 + k
!     i  = max(tu,vx,yz)
!     j  = mid(tu,vx,yz)
!     k  = min(tu,vx,yz)
! tu stands for the pair index tu= t + NASHT*(u-1), etc., and t is
! the usual active orbital number, when they are enumerated across
! all the symmetries (The ''absolute'' active index).


! Put in zeroes. Recognize special cases:
!     OVL=1.0D0
      IF(NASHT == 0) return
      IF(NACTEL == 0) return
!     IF(LSYM1 /= LSYM2) OVL=Zero
!     TG1(:,:) = Zero
!     TG2(:,:,:,:) = Zero
!     TG3(1:NTG3) = Zero

      IF(ISCF /= 0) then
! -Special code for the closed-shell or hi-spin cases:
! ISCF=1 for closed-shell, =2 for hispin
        write (u6,*) 'Here is the special case'
        write (u6,*) 'not yet'
        call abend()
      end if
! Here, for regular CAS or RAS cases.

! Special pair index allows true RAS cases to be handled:
      CALL mma_allocate(P2LEV,2*NASHT**2,Label='P2LEV')
      LP2LEV1=1
      LP2LEV2=1+NASHT**2
      IP=0
! First, IL < JL pairs.
      DO IL=1,NLEV-1
       DO JL=IL+1,NLEV
        IP=IP+1
        P2LEV(LP2LEV1-1+IP)=IL
        P2LEV(LP2LEV2-1+IP)=JL
       END DO
      END DO
! Then, IL = JL pairs.
      DO IL=1,NLEV
        IP=IP+1
        P2LEV(LP2LEV1-1+IP)=IL
        P2LEV(LP2LEV2-1+IP)=IL
      END DO
! Last, IL > JL pairs.
      DO IL=2,NLEV
       DO JL=1,IL-1
        IP=IP+1
        P2LEV(LP2LEV1-1+IP)=IL
        P2LEV(LP2LEV2-1+IP)=JL
       END DO
      END DO

! First, the 3-particle density matrix:
! <PSI1|E(T,U,V,X,Y,Z)|PSI2>  = <PSI1|E(TU)E(VX)E(YZ)|PSI2>
! -D(Y,X)*(TG2(T,U,V,Z)+D(V,U)*TG1(T,Z))
! -D(V,U)*TG2(T,X,Y,Z) C -D(Y,U)*TG2(V,X,T,Z)
      IF (DOG3) THEN
       DO IP1=1,NASHT**2
        IT=L2ACT(P2LEV(LP2LEV1-1+IP1))
        IU=L2ACT(P2LEV(LP2LEV2-1+IP1))
        ITU=IT+NASHT*(IU-1)
        ITS=IASYM(IT)
        IUS=IASYM(IU)
        IS1=Mul(Mul(ITS,IUS),LSYM1)
        DO IP2=1,IP1
         IV=L2ACT(P2LEV(LP2LEV1-1+IP2))
         IX=L2ACT(P2LEV(LP2LEV2-1+IP2))
         IVX=IV+NASHT*(IX-1)
         IVS=IASYM(IV)
         IXS=IASYM(IX)
         IS2=Mul(Mul(IVS,IXS),IS1)
         DO IP3=1,IP2
          IY=L2ACT(P2LEV(LP2LEV1-1+IP3))
          IZ=L2ACT(P2LEV(LP2LEV2-1+IP3))
          IYS=IASYM(IY)
          IZS=IASYM(IZ)
          IS3=Mul(Mul(IYS,IZS),IS2)
          IF(IS3 == LSYM2) THEN
           IYZ=IY+NASHT*(IZ-1)
           IF(ITU < IVX) THEN
             IF(ITU >= IYZ) THEN
               JTU=IVX
               JVX=ITU
               JYZ=IYZ
             ELSE IF(IVX < IYZ) THEN
                 JTU=IYZ
                 JVX=IVX
                 JYZ=ITU
             ELSE
                 JTU=IVX
                 JVX=IYZ
                 JYZ=ITU
             END IF
           ELSE
             IF(ITU < IYZ) THEN
               JTU=IYZ
               JVX=ITU
               JYZ=IVX
             ELSE IF (IVX >= IYZ) THEN
               JTU=ITU
               JVX=IVX
               JYZ=IYZ
             ELSE
               JTU=ITU
               JVX=IYZ
               JYZ=IVX
             END IF
           END IF
           JTUVXYZ=((JTU+1)*JTU*(JTU-1))/6+(JVX*(JVX-1))/2+JYZ
           VAL=DTG3(JTUVXYZ)
           IF(IY == IX) THEN
            DTG2(IT,IU,IV,IZ)=DTG2(IT,IU,IV,IZ)-VAL
            IF(IV == IU) THEN
             DTG1(IT,IZ)=DTG1(IT,IZ)-VAL
            END IF
           END IF
           IF(IV == IU) THEN
            DTG2(IT,IX,IY,IZ)=DTG2(IT,IX,IY,IZ)-VAL
           END IF
           IF(IY == IU) THEN
            DTG2(IV,IX,IT,IZ)=DTG2(IV,IX,IT,IZ)-VAL
           END IF
          END IF
         END DO
        END DO
       END DO
      END IF
!
! Then, the 2-particle density matrix:
! <PSI1|E(T,U,V,X)|PSI2>  = <PSI1|E(TU)E(VX)|PSI2> - D(V,U)*TG2(T,U,V,X)
      DO IP1=1,NASHT**2
       IT=L2ACT(P2LEV(LP2LEV1-1+IP1))
       IU=L2ACT(P2LEV(LP2LEV2-1+IP1))
       DO IP2=1,IP1
        IV=L2ACT(P2LEV(LP2LEV1-1+IP2))
        IX=L2ACT(P2LEV(LP2LEV2-1+IP2))
        IF (IP1 /= IP2) Then
          DTG2(IT,IU,IV,IX)=DTG2(IT,IU,IV,IX)+DTG2(IV,IX,IT,IU)
          DTG2(IV,IX,IT,IU) = Zero
        End If
        IF(IV == IU) DTG1(IT,IX)=DTG1(IT,IX)-DTG2(IT,IU,IV,IX)
       END DO
      END DO
!
! If now any matrix element E(t1u1)E(t2u2)..E(tnun) is arranged
! such that the pair indices are non-decreasing, then the matrix
! element can be correctly computed by performing explicit
! excitations within the RAS space.
! But we also need the 'usual' pair index in order to use the
! packed addressing.

      NCI1=CIS%NCSF(LSYM1)
! Overlap:
!     IF(LSYM1 == LSYM2) OVL=DDOT_(NCI1,CI1,1,CI2,1)
      IF(LSYM1 == LSYM2) THEN
        CLAG2(1:NCI1) = CLAG2(1:NCI1) + OVL*CI1(1:NCI1)
        CLAG1(1:NCI1) = CLAG1(1:NCI1) + OVL*CI2(1:NCI1)
      END IF
!     write (*,*) 'overlap = ',DDOT_(NCI1,CI1,1,CI2,1)
! Allocate as many vectors as possible:
! Wishful thinking:
      NVECS=2*NASHT**2+1
! But what is really available?
      CALL mma_MaxDBLE(NTG3WRK)
      NTG3WRK=NTG3WRK-3*MXCI ! for BUF1, DTU, and DYZ, allocated later
      NTG3WRK=NTG3WRK/2
      NTG3WRK=MIN(MXCI*NVECS,NTG3WRK)
      NVECS=NTG3WRK/MXCI
      NTG3WRK=NVECS*MXCI
! Find optimal subdivision of available vectors:
      NYZBUF=NINT(real(NVECS-1,kind=wp)/real(NASHT,kind=wp),kind=iwp)
      NYZBUF=MAX(1,NYZBUF)
      NTUBUF=MIN(NASHT**2,NVECS-1-NYZBUF)
      NYZBUF=NVECS-1-NTUBUF
! Insufficient memory?
      IF(NTUBUF <= 0) THEN
        WRITE(u6,*)' Too little memory left for MKTG3.'
        WRITE(u6,*)' Need at least 6 vectors of length MXCI=',MXCI
        CALL ABEND()
      END IF
      IF(NTUBUF <= (NASHT**2)/5) THEN
        WRITE(u6,*)' WARNING: MKTG3 will be inefficient owing to'
        WRITE(u6,*)' small memory.'
      END IF
      CALL mma_allocate(TG3WRK,NTG3WRK,Label='TG3WRK')
      CALL mma_allocate(BUF1,MXCI,Label='BUF1')

      call mma_allocate(DTU,MXCI,NTUBUF,Label='DTU')
      call mma_allocate(DYZ,MXCI,NYZBUF,Label='DYZ')

! And divide it up:
      !! LSGM1: NTUBUF vectors
      !! LTAU : 1 vector
      !! LSGM2: NYZBUF vectors
      LSGM1=1
      LTAU=LSGM1+NTUBUF*MXCI
      LSGM2=LTAU+MXCI

! Sectioning loops over pair indices IP3 (ket side):
      DO IP3STA=1,NASHT**2,NYZBUF
       IP3END=MIN(NASHT**2,IP3STA-1+NYZBUF)
! Compute a section of sigma vectors E(YZ)*PSI2 to memory:
       LTO=LSGM2
       DO IP3=IP3STA,IP3END
! Translate to levels in the SGUGA coupling order:
        IL=P2LEV(LP2LEV1-1+IP3)
        JL=P2LEV(LP2LEV2-1+IP3)
        IY=L2ACT(IL)
        IZ=L2ACT(JL)
        IYS=IASYM(IY)
        IZS=IASYM(IZ)
        ISSG2=Mul(Mul(IYS,IZS),LSYM2)
        TG3WRK(LTO:LTO+MXCI-1) = Zero
! LTO is first element of Sigma2 = E(YZ) Psi2
        CALL SIGMA1(SGS,CIS,EXS,
     &              IL,JL,One,LSYM2,CI2,TG3WRK(LTO))
        IF(ISSG2 == LSYM1 .AND. DTG1(IY,IZ) /= Zero) THEN
          !! It is possible to calculate the contribution using
          !! DGEMV, but DAXPY seems to be faster than DGEMV
          CLAG1(1:NCI1) = CLAG1(1:NCI1)
     &      + DTG1(IY,IZ)*TG3WRK(LTO:LTO+NCI1-1)
        END IF
        LTO=LTO+MXCI
       END DO

       DYZ(1:MXCI,1:NYZBUF) = Zero
! Sectioning loops over pair indices IP1 (bra side):
       DO IP1STA=IP3STA,NASHT**2,NTUBUF
        IP1END=MIN(NASHT**2,IP1STA-1+NTUBUF)
! Compute a section of sigma vectors E(UT)*PSI1 to memory:
        LTO=LSGM1
        !! <Psi1|E(TU)
        DO IP1=IP1STA,IP1END
! Translate to levels:
         JL=P2LEV(LP2LEV1-1+IP1)
         IL=P2LEV(LP2LEV2-1+IP1)
         IT=L2ACT(IL)
         IU=L2ACT(JL)
         ITS=IASYM(IT)
         IUS=IASYM(IU)
         ISSG1=Mul(Mul(ITS,IUS),LSYM1)
         TG3WRK(LTO:LTO+MXCI-1) = Zero
         CALL SIGMA1(SGS,CIS,EXS,
     &               IL,JL,One,LSYM1,CI1,TG3WRK(LTO))
         IF (ISSG1 == LSYM1 .AND. DTG1(IU,IT) /= Zero
     &       .AND. IP3STA == 1) THEN
          CLAG2(1:NCI1) = CLAG2(1:NCI1)
     &      + DTG1(IU,IT)*TG3WRK(LTO:LTO+NCI1-1)
         END IF
         LTO=LTO+MXCI
        END DO

        DTU(1:MXCI,1:NTUBUF) = Zero
! Now compute as many elements as possible:
        LFROM=LSGM2
        LFROMD=1
        DO IP3=IP3STA,IP3END
         IY=L2ACT(P2LEV(LP2LEV1-1+IP3))
         IZ=L2ACT(P2LEV(LP2LEV2-1+IP3))
! LFROM will be start element of Sigma2=E(YZ) Psi2
         IYZ=IY+NASHT*(IZ-1)
         IYS=IASYM(IY)
         IZS=IASYM(IZ)
         ISSG2=Mul(Mul(IYS,IZS),LSYM2)
         IM=P2LEV(LP2LEV1-1+IP3)
         JM=P2LEV(LP2LEV2-1+IP3)
         DO IP2=IP3,IP1END
          IL=P2LEV(LP2LEV1-1+IP2)
          JL=P2LEV(LP2LEV2-1+IP2)
          IV=L2ACT(IL)
          IX=L2ACT(JL)
          IVX=IV+NASHT*(IX-1)
          IVS=IASYM(IV)
          IXS=IASYM(IX)
          ISTAU=Mul(Mul(IVS,IXS),ISSG2)
          NTAU=CIS%NCSF(ISTAU)
          TG3WRK(LTAU:LTAU+MXCI-1) = Zero
! LTAU  will be start element of Tau=E(VX) Sigma2=E(VX) E(YZ) Psi2
          !! LTAU = EvxEyz|Psi2>
          CALL SIGMA1(SGS,CIS,EXS,
     &                IL,JL,One,ISSG2,TG3WRK(LFROM),TG3WRK(LTAU))
          IF(ISTAU == LSYM1 .AND. DTG2(IV,IX,IY,IZ) /= Zero) THEN
!          DTG2(IV,IX,IY,IZ)=DDOT_(NTAU,TG3WRK(LTAU),1,CI1,1)
           !! For left derivative: <I|Evx Eyz|Psi2>
           CLAG1(1:NTAU) = CLAG1(1:NTAU)
     &       + DTG2(IV,IX,IY,IZ)*TG3WRK(LTAU:LTAU+NTAU-1)
           !! For right derivative: <Psi1|Evx Eyz|I>
           IF (IP2 >= IP1STA.AND.IP2 <= IP1END) THEN
              ibuf = lsgm1+mxci*(ip2-ip1sta)
              DYZ(1:MXCI,LFROMD) = DYZ(1:MXCI,LFROMD)
     &          + DTG2(IV,IX,IY,IZ)*TG3WRK(IBUF:IBUF+MXCI-1)
           ELSE
         CALL SIGMA1(SGS,CIS,EXS,
     &               JL,IL,DTG2(IV,IX,IY,IZ),ISSG2,CI1,DYZ(1,LFROMD))
           END IF
           DTG2(IV,IX,IY,IZ) = Zero
          END IF
          IF (DOG3) THEN
            BUF1(1:MXCI) = Zero
            DO IP1=MAX(IP2,IP1STA),IP1END
             IT=L2ACT(P2LEV(LP2LEV1-1+IP1))
             IU=L2ACT(P2LEV(LP2LEV2-1+IP1))
             ITS=IASYM(IT)
             IUS=IASYM(IU)
             ISSG1=Mul(Mul(ITS,IUS),LSYM1)
             IF(ISSG1 == ISTAU) THEN
!             L=LSGM1+MXCI*(IP1-IP1STA)
!             VAL=DDOT_(NTAU,TG3WRK(LTAU),1,TG3WRK(L),1)
              ITU=IT+NASHT*(IU-1)
! Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
! Code to put it in correct place:
              IF(ITU < IVX) THEN
                IF(ITU >= IYZ) THEN
                  JTU=IVX
                  JVX=ITU
                  JYZ=IYZ
                ELSE IF(IVX < IYZ) THEN
                  JTU=IYZ
                  JVX=IVX
                  JYZ=ITU
                ELSE
                  JTU=IVX
                  JVX=IYZ
                  JYZ=ITU
                END IF
              ELSE
                IF(ITU < IYZ) THEN
                  JTU=IYZ
                  JVX=ITU
                  JYZ=IVX
                ELSE IF (IVX >= IYZ) THEN
                  JTU=ITU
                  JVX=IVX
                  JYZ=IYZ
                ELSE
                  JTU=ITU
                  JVX=IYZ
                  JYZ=IVX
                END IF
              END IF
              JTUVXYZ=((JTU+1)*JTU*(JTU-1))/6+(JVX*(JVX-1))/2+JYZ
              IF (DTG3(JTUVXYZ) /= Zero) then
                !! For left derivative: <I|Evx Eyz|Psi2> * Dtuvxyz
                !! I don't understand, but this is much faster than
                !! processing all possible vectors at once with DGEMM
                !! (and DGER) after finishing the IP1 loop below
                DTU(1:MXCI,1+IP1-IP1STA) = DTU(1:MXCI,1+IP1-IP1STA)
     &            + DTG3(JTUVXYZ)*TG3WRK(LTAU:LTAU+MXCI-1)
                !! For right derivative: <Psi1|Etu|I> * Dtuvxyz
                !! This is also (slightly) faster than DGEMV, apparently
                Call DaXpY_(MXCI,DTG3(JTUVXYZ),
     &                      TG3WRK(LSGM1+MXCI*(IP1-IP1STA)),1,BUF1,1)
               END IF
! End of symmetry requirement IF-clause:
             END IF
! End of IP1 loop.
            END DO
            !! Second operator for the right derivative:
            !! <Psi1|Etu Evx|I> * Dtuvxyz
            CALL SIGMA1(SGS,CIS,EXS,
     &                  JL,IL,One,ISTAU,BUF1,DYZ(1,LFROMD))
          END IF !! End of DOG3 clause
! End of IP2 loop.
         END DO
         LFROM=LFROM+MXCI
         LFROMD=LFROMD+1
! End of IP3 loop.
        END DO

        LTO=1
        !! <I|Etu Evx Eyz|Psi2> * Dtuvxyz
        DO IP1=IP1STA,IP1END
! Translate to levels:
         IL=P2LEV(LP2LEV1-1+IP1)
         JL=P2LEV(LP2LEV2-1+IP1)
         IT=L2ACT(IL)
         IU=L2ACT(JL)
         ITS=IASYM(IT)
         IUS=IASYM(IU)
         ISSG1=Mul(Mul(ITS,IUS),LSYM1)
         CALL SIGMA1(SGS,CIS,EXS,IL,JL,One,LSYM1,DTU(1,LTO),CLAG1)
         LTO=LTO+1
        END DO
! End of IP1STA sectioning loop
       END DO

       LTO=1
       DO IP3=IP3STA,IP3END
        IY=L2ACT(P2LEV(LP2LEV1-1+IP3))
        IZ=L2ACT(P2LEV(LP2LEV2-1+IP3))
! LFROM will be start element of Sigma2=E(YZ) Psi2
        IYZ=IY+NASHT*(IZ-1)
        IYS=IASYM(IY)
        IZS=IASYM(IZ)
        ISSG2=Mul(Mul(IYS,IZS),LSYM2)
        IM=P2LEV(LP2LEV1-1+IP3)
        JM=P2LEV(LP2LEV2-1+IP3)
! LTO is first element of Sigma2 = E(YZ) Psi2
        CALL SIGMA1(SGS,CIS,EXS,JM,IM,One,LSYM2,DYZ(1,LTO),CLAG2)
        LTO=LTO+1
       END DO
! End of IP3STA sectioning loop
      END DO

      call mma_deallocate(TG3WRK)
      call mma_deallocate(BUF1)
      call mma_deallocate(DTU)
      call mma_deallocate(DYZ)
      call mma_deallocate(P2LEV)

      end subroutine DERTG3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine OrdExpD2C(nExp,Exp,nCntrc,Cff)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Exp(nExp), Cff(nExp,nCntrc)
*
*     Order exponents diffuse to compact
*     Make the subsequent change in the contraction
*     matrix
*
      Do iExp = 1, nExp-1
         Exp1 = Exp(iExp)
         kExp = iExp
         Do jExp = iExp+1, nExp
            Exp2 = Exp(jExp)
            If (Exp2.lt.Exp1) Then
               Exp1 = Exp2
               kExp = jExp
            End If
         End Do
         If (kExp.ne.iExp) Then
            Call DSwap_(1,Exp(iExp),1,Exp(kExp),1)
            Call DSwap_(nCntrc,Cff(iExp,1),nExp,Cff(kExp,1),nExp)
         End If
      End Do
#ifdef _ORDER_BAS_
*
*     Now order the contracted basis functions diffuse to compact
*
      Do iCntrc = 1, nCntrc-1
         Bas1=Abs(Cff(1,iCntrc))
         kCntrc = iCntrc
         Do jCntrc = iCntrc+1, nCntrc
            Bas2=Abs(Cff(1,jCntrc))
            If (Bas2.lt.Bas1) Then
               Bas1 = Bas2
               kCntrc = jCntrc
            End If
         End Do
         If (kCntrc.ne.iCntrc) Then
            Call DSwap_(nExp,Cff(1,iCntrc),1,Cff(1,kCntrc),1)
         End If
      End Do
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
* This routine projects out specified vectors from the density matrix. *
* The procedure is to read the projection orbitals, generate a         *
* complimentary space, and orthonormalize it. Then the density matrix  *
* is transformed into this representation, the corresponding matrix    *
* are zeroed out, and transformed back to AO representaion.            *
*                                                                      *
*======================================================================*
*                                                                      *
* NOTE: The transformations and orthonormalizations are done as        *
*       (On^4) processes and not as O(n^3) processed due to a lazy     *
*       programmer. I will rewrite this when I get the time.           *
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine Proj1
      Implicit Real*8 (a-h,o-z)
#include "parm.fh"
#include "common.fh"
      Dimension pOrb(MxS,MxS)
      Dimension DAO(MxS,MxS)
      Dimension DMO(MxS,MxS)
      Dimension Sc(MxS,MxS)
      Dimension Ovlp(MxS,MxS)
      call molcas_open(17,'PROJ')
c      Open(unit=17,file='PROJ',form='FORMATTED')
      iBlk=0
*--- Loop over l quantum number ---*
      Do 100 iLqn=0,MxLqn
         Read(17,*,end=999,err=999) nB,nO
         If(nB*nO.le.0) Go To 100
         If(nB.ne.nPrim(iLqn)) Then
            Write(6,*) 'Project: inconsistency in number of functions'
            Call Abend
         End If
         Do 105 iB=1,nB
            Read(17,*) (pOrb(iB,iO),iO=1,nO)
105      Continue
*--- Generate complimentary space ---*
         Do 110 iB=1,nB
         Do 111 iO=nO+1,nB
            pOrb(iB,iO)=Cos(3.14d0*iO*iB/nB)
111      Continue
110      Continue
*         Write(*,'(a,i5)') ' Projection orbitals',iLqn
*         Do 120 iB=1,nB
*            Write(*,'(1x,6f12.6)') (pOrb(iB,iO)),iO=1,nO)
*120      Continue
*--- Loop over m quantum number ---*
         Do 200 iShell=-iLqn,iLqn
            iBlk=iBlk+1
*           Write(*,'(a,2i5)') ' Density matrix block',iLqn,iShell
*           Call Triprt(' ','(6F12.6)',tDsym(iSymbk(iBlk)),nPrim(iLqn))
*           Write(*,'(a,2i5)') ' Overlap matrix block',iLqn,iShell
*           Call Triprt(' ','(6F12.6)',Ssym(iSymbk(iBlk)),nPrim(iLqn))
*--- Copy and square D and S ---*
            Do 210 i=1,nB
            Do 211 j=1,nB
               indT=min(i,j)+max(i,j)*(max(i,j)-1)/2
               indS=i+nB*(j-1)
               DAO(i,j)=tDsym(iSymbk(iBlk)-1+indT)
               Ovlp(i,j)=Ssym(iSymbk(iBlk)-1+indT)
211         Continue
210         Continue
*--- Orthonormalize orbitals ---*
            Do 220 iO=1,nB
               s=0.0d0
               Do 221 iB=1,nB
               Do 2210 jB=1,nB
                  s=s+pOrb(iB,iO)*ovlp(iB,jB)*pOrb(jB,iO)
2210           Continue
221            Continue
               s=1.0d0/sqrt(s)
               Do 222 iB=1,nB
                  pOrb(iB,iO)=s*pOrb(iB,iO)
222            Continue
               Do 223 jO=iO+1,nB
                  s=0.0d0
                  Do 224 iB=1,nB
                  Do 2240 jB=1,nB
                     s=s+pOrb(iB,iO)*ovlp(iB,jB)*pOrb(jB,jO)
2240              Continue
224               Continue
                  Do 225 iB=1,nB
                     pOrb(iB,jO)=pOrb(iB,jO)-s*pOrb(iB,iO)
225               Continue
223            Continue
220         Continue
*--- Transform to MO basis ---*
            Do 230 iB=1,nB
            Do 231 iO=1,nB
               s=0.0d0
               Do 232 jB=1,nB
                  s=s+ovlp(iB,jB)*pOrb(jB,iO)
232            Continue
               Sc(iB,iO)=s
231         Continue
230         Continue
            Do 240 iO=1,nB
            Do 241 jO=1,nB
               s=0.0d0
               Do 242 iB=1,nB
               Do 243 jB=1,nB
                  s=s+Sc(iB,iO)*DAO(iB,jB)*Sc(jB,jO)
243            Continue
242            Continue
               DMO(iO,jO)=s
241         Continue
240         Continue
*--- Project ---*
            Do 250 iO=1,nO
            Do 251 jO=1,nB
               DMO(iO,jO)=0.0d0
               DMO(jO,iO)=0.0d0
251         Continue
250         Continue
*--- Transform back to AO ---*
            ind=0
            Do 260 iB=1,nB
            Do 261 jB=1,iB
               ind=ind+1
               s=0.0d0
               Do 262 iO=1,nB
               Do 263 jO=1,nB
                  s=s+pOrb(iB,iO)*DMO(iO,jO)*pOrb(jB,jO)
263            Continue
262            Continue
               tDsym(iSymbk(iBlk)-1+ind)=s
261         Continue
260         Continue
*--- ---*
*           Write(*,'(a,2i5)') ' Density matrix block',iLqn,iShell
*           Call Triprt(' ','(6F12.6)',tDsym(iSymbk(iBlk)),nPrim(iLqn))
200      Continue
100   Continue
*--- Finished ---*
999   Continue
      Close(unit=17)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine bspset_cvb(kbasis1,ic,need)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "WrkSpc.fh"

      if(ic.eq.1)then
        i1 = mstackiz_cvb((nel+1)*(nel+1)*(nel+1))
        call bspset2_cvb(iwork(i1),nel,kbasis1,need)
        call mfreei_cvb(i1)
      elseif(ic.eq.2)then
        do 100 i=0,(nel+1)*(nel+1)*(nel+1)-1
        iwork(i+lb(3))=-1
100     continue
        call bspset2_cvb(iwork(lb(3)),nel,kbasis1,need)
        call setifnss_cvb(iwork(lb(4)),iwork(lb(5)),iwork(lb(6)))
      endif
      if(kbasis1.eq.6)need=0
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine switch_density(iLoc,XLT,Xab,kSym)

use Index_Functions, only: iTri
use Cholesky, only: iBas, iiBstR, IndRed, iRS2F, nnBstR
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iLoc, kSym
real(kind=wp), intent(in) :: XLT(*)
real(kind=wp), intent(_OUT_) :: Xab(*)
integer(kind=iwp) :: iab, iag, ias, ibg, ibs, iRab, iSyma, jRab, jSym, kRab
real(kind=wp) :: xf
integer(kind=iwp), external :: cho_isao

jSym = 1 ! only total symmetric density

do jRab=1,nnBstR(jSym,iLoc)

  kRab = iiBstr(jSym,iLoc)+jRab
  iRab = IndRed(kRab,iLoc)

  iag = iRS2F(1,iRab)  !global address
  ibg = iRS2F(2,iRab)

  iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

  xf = real(1-min(1,abs(iSyma-kSym)),kind=wp)

  ias = iag-ibas(iSyma)  !address within that symm block
  ibs = ibg-ibas(iSyma)
  iab = iTri(ias,ibs)

  Xab(jRab) = xf*XLT(iab)

end do  ! jRab loop

return

end subroutine switch_density

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine o8b_cvb( &
#                  define _CALLING_
#                  include "optb_interface.fh"
                  )

use casvb_global, only: eigval, eigvec, hh, ip, odx, ograd, scalesmall
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "optb_interface.fh"
integer(kind=iwp) :: iprm, ipu, iroot
real(kind=wp) :: fac1
real(kind=wp), external :: dnrm2_

#include "macros.fh"
unused_var(grdnrm)

eigvec(1:nparm+1,1:nparm+1) = Zero
eigvec(2:nparm+1,1) = ograd(1:nparm)
eigvec(1,2:nparm+1) = ograd(1:nparm)
do iprm=2,nparm+1
  eigvec(iprm,iprm) = One
  call hess_cvb(eigvec(2,iprm))
end do
write(u6,*) ' Augmented Hessian matrix :'
call mxprint_cvb(eigvec,nparm+1,nparm+1,0)
call mxdiag_cvb(eigvec,eigval,nparm+1)
iroot = nparm+1
if (ip >= 2) then
  write(u6,'(a)') ' Eigenvalues of augmented Hessian :'
  call vecprint_cvb(eigval,nparm+1)
  write(u6,'(a)') ' Eigenvector to be followed :'
  call vecprint_cvb(eigvec(1,iroot),nparm+1)
end if
write(u6,*) ' Following root no :',iroot
odx(:) = eigvec(2:,iroot)
if (abs(eigvec(1,iroot)) > 1.0e-8_wp) then
  fac1 = One/eigvec(1,iroot)
else
  fac1 = sign(One,eigvec(1,iroot))
end if
odx(1:nparm) = fac1*odx(1:nparm)
dxnrm = dnrm2_(nparm,odx,1)
if (.not. close2conv) then
  ipu = 1
else
  ipu = 2
end if
if ((dxnrm > hh) .or. scalesmall(ipu)) then
  odx(1:nparm) = hh/dxnrm*odx(1:nparm)
  dxnrm = hh
end if

return

end subroutine o8b_cvb

*s***********************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine daname_cvb(lu,fname)
      implicit real*8 (a-h,o-z)
      character*(*) fname
#include "dancom_cvb.fh"
      integer find_lu, isfreeunit, i_open
      logical find_unused, is_opened
      external find_lu, isfreeunit, is_opened

      ilu=find_lu(fname)
      if(ilu.gt.0)then
        lu=ilu
        goto 1000
      endif
      find_unused=(lu.lt.1)
      if(.not.find_unused)find_unused=is_opened(lu)
      if(find_unused)then
        ilu=isfreeunit(10)
      endif

1000  if(is_opened(lu)) then
        i_open=1
      else
        i_open=0
        lu=10  ! initialize
      end if
      call istkpush_cvb(idan,i_open)
      if(i_open.eq.0)call daname(lu,fname)
      return
      end
      subroutine daclos_cvb(lu)
      implicit real*8 (a-h,o-z)
#include "dancom_cvb.fh"
c      logical find_unused

      call istkpop_cvb(idan,iwasopen)
      if(iwasopen.eq.0)call daclos(lu)
      return
      end
      subroutine daninit_cvb()
      implicit real*8 (a-h,o-z)
#include "dancom_cvb.fh"
c      logical find_unused
      call istkinit_cvb(idan,mxfiles)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Luis Serrano-Andres                              *
************************************************************************
      SUBROUTINE SUPSCH(SMAT,CMOO,CMON)
C
C     Program RASSCF
C
C     Objective: To check the order of the input of natural orbitals
C                to obtain the right labels for the Supersymmetry matrix.
C
C     Called from ortho, neworb, fckpt2, and natorb.
C
C     Luis Serrano-Andres
C     University of Lund, Sweden, 1997
C     **** Molcas-4 *** Release 97 04 01 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "general.fh"
#include "rasscf.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='SUPSCH  ')
#include "WrkSpc.fh"
      Real*8 CMOO(*),CMON(*),SMAT(*)
*
*
      nOrbMX=0
      nOrb_tot=0
      Do iSym=1,nSym
         nOrbMX=Max(nOrbMX,nBas(iSym))
         nOrb_tot=nOrb_tot+nBas(iSym)
      End Do
*
      Call GetMem('Temp1','Allo','Real',ipTemp1,nOrbMX*nOrbMX)
      Call GetMem('Temp2','Allo','Real',ipTemp2,nOrbMX*nOrbMX)
      Call GetMem('IxSym2','Allo','Inte',ipIxSym2,nOrb_tot)
*
      Call SUPSCH_(SMAT,CMOO,CMON,Work(ipTemp1),Work(ipTemp2),nOrbMX,
     &             iWork(ipIxSym2),nOrb_tot)
*
      Call GetMem('IxSym2','Free','Inte',ipIxSym2,nOrb_tot)
      Call GetMem('Temp2','Free','Real',ipTemp2,nOrbMX*nOrbMX)
      Call GetMem('Temp1','Free','Real',ipTemp1,nOrbMX*nOrbMX)
*
*
      Return
      End
      SUBROUTINE SUPSCH_(SMAT,CMOO,CMON,Temp1,Temp2,nOrbMX,IxSym2,
     &                   nOrb_tot)
C
C     Program RASSCF
C
C     Objective: To check the order of the input of natural orbitals
C                to obtain the right labels for the Supersymmetry matrix.
C
C     Called from ortho, neworb, fckpt2, and natorb.
C
C     Luis Serrano-Andres
C     University of Lund, Sweden, 1997
C     **** Molcas-4 *** Release 97 04 01 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "warnings.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='SUPSCH_ ')
#include "rasscf.fh"

      DIMENSION CMOO(*),CMON(*),SMAT(*)

      DIMENSION Temp1(nOrbMX*nOrbMX),Temp2(nOrbMX*nOrbMX)
      INTEGER IxSym2(nOrb_tot)
      Integer pSij
      DIMENSION DUM(1)
C
C Local print level (if any)
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
*
*     Read overlap matrix SMAT:
*
      i_Rc=0
      i_Opt=6
      i_Component=1
      i_SymLbl=1
      Call RdOne(i_Rc,i_Opt,'Mltpl  0',i_Component,Smat,i_SymLbl)
      If ( i_Rc.ne.0 ) Then
        Write(LF,*)
        Write(LF,*)' ********************* ERROR **********************'
        Write(LF,*)' SUPSCH: Failed to read overlap from ONEINT.       '
        Write(LF,*)' RASSCF is using overlaps to compare old and new   '
        Write(LF,*)' orbitals, but could not read overlaps from ONEINT.'
        Write(LF,*)' Something is wrong with the file, or possibly with'
        Write(LF,*)' the program. Please check.                        '
        Write(LF,*)' **************************************************'
        Call Quit(_RC_IO_ERROR_READ_)
      End If
C
C
C     Check order of the orbitals for supersymmetry option
C
      If( ( ISupsm.eq.1 ).and.( Iter.ge.1 ) ) then
C
       If(IPRLEV.GE.DEBUG) then
         CALL PRIMO_RASSCF('Testing old orb for supersymmetry',
     &               FDIAG,DUM,CMOO)
         CALL PRIMO_RASSCF('Testing new orb for supersymmetry',
     &               FDIAG,DUM,CMON)
       End if
C
       kOrb=0
       kCof=0
       pSij=0
       Do iOrb=1,nOrb_tot
         IxSym2(iOrb)=0
       End do
       Do iSym=1,nSym
         iSafe=0
         nBs=nBas(iSym)
         If(nBs.le.0) Goto 1966
C
C        Computing orbital overlaping Sum(p,q) C1kp* C2lq Spq
C
         Call Square(SMat(pSij+1),Temp1,1,nBs,nBs)
         Call DGEMM_('N','N',
     &               nBs,nBs,nBs,
     &               1.0d0,Temp1,nBs,
     &               CMON(kCof+1),nBs,
     &               0.0d0,Temp2,nBs)
         Call DGEMM_('T','N',
     &               nBs,nBs,nBs,
     &               1.0d0,CMOO(kCof+1),nBs,
     &               Temp2,nBs,
     &               0.0d0,Temp1,nBs)
C
C        Checking the maximum overlap between the orbitals
C        and building the new supersymmetry matrix
C
         nnOrb=1
         Do iOrb=1,nBs
           iLabel=IxSym(kOrb+iOrb)
           iOrder=1
           xOvlp=0.0d0
           Do jOrb=0,nBs-2
             Ovlp1=Abs(Temp1(nnOrb+(jOrb*nBs)))
             Ovlp2=Abs(Temp1(nnOrb+((jOrb+1)*nBs)))
             OldOvlp=xOvlp
             xOvlp=Max(Ovlp1,Ovlp2,xOvlp)
             If (jOrb.eq.0) then
               If(Ovlp1.lt.Ovlp2) iOrder=2
             Else
               If(xOvlp.ne.OldOvlp) iOrder=jOrb+2
             End if
           End do
           IxSym2(kOrb+iOrder)=iLabel
           nnOrb=nnOrb+1
         End do
C
C        Number of orbital groups on the symmetry
C
         kGroup=0
         Do iOrb=1,nBs-1
           kGroup=Max(IxSym(kOrb+iOrb),IxSym(kOrb+iOrb+1),kGroup)
         End do
         Do iGroup=0,kGroup
           nOGr1=0
           nOGr2=0
           Do iOrb=1,nBs
             if(IxSym(kOrb+iOrb).eq.iGroup) nOGr1=nOGr1+1
             if(IxSym2(kOrb+iOrb).eq.iGroup) nOGr2=nOGr2+1
           End do
C
C        Checking if we have the same number of orbitals
C        per group
C
           If((nOGr2.ne.nOGr1).and.(iGroup.ne.0)) then
             iSafe=1
             Call WarningMessage(1,'Supersymmetry may have failed.')
             Write(LF,*)' Check orbital order or try cleaning orbitals.'
           End if
         End do
C
C        New matrix replaces the old one
C
         If(iSafe.eq.0) then
           Do iOrb=1,nBs
             IxSym(kOrb+iOrb)=IxSym2(kOrb+iOrb)
           End do
         End if
         kCof=kCof+(nBs*nBs)
         pSij=pSij+(nBs*nBs+nBs)/2
         kOrb=kOrb+nBs
1966     Continue
       End do
      End if
C
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Energy_E2d(V,Tau,e,eos,dima,no)
! this routine calcs:
! E2 = sum(a,b,i,j) (2V(ai|bj)-V(aj|bi)) . Tau(a,b,i,j
! E2os=sum(a,b,i,j) (  (ai|bj)         ) . Tau(a,b,i,j
! where
!    E2    - complete E2 component of energy
!    E2os  - other spin E2 component of energy
! for aGrp=bGrp (Tau array is full, but only a>=b values are completed)

use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, no
real(kind=wp), intent(in) :: V(dima,no,dima,no), Tau(dima,dima,no,no)
real(kind=wp), intent(out) :: e, eos
integer(kind=iwp) :: a, b, i, j
real(kind=wp) :: ehlp

e = Zero
eos = Zero
ehlp = Zero

! off diagonal

do j=1,no
  do i=1,no
    do b=1,dima-1
      ehlp = ehlp+V(b,i,b,j)*Tau(b,b,i,j)
      do a=b+1,dima
        e = e+(Two*V(a,i,b,j)-V(a,j,b,i))*Tau(a,b,i,j)
        eos = eos+V(a,i,b,j)*Tau(a,b,i,j)
      end do
    end do
    ehlp = ehlp+V(dima,i,dima,j)*Tau(dima,dima,i,j)
  end do
end do

e = Two*e+ehlp
eos = Two*eos+ehlp

return

end subroutine Energy_E2d

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!               2007, Per Ake Malmqvist                                *
!***********************************************************************

subroutine HALFTRNSF(irc,scr,lscr,jVref,JVEC1,JNUM,NUMV,JSYM,JREDC,CMO,NCMO,ISTART,NUSE,ipChoT,Work,nWork)
!********************************************************
!   Author: F. Aquilante as subroutine cho_vtra
!   Modified PAM 2007: Use ordinary CMO array without restructuring
!   This amounts to (1) having symmetry blocks of MO:s accessed
!   untransposed, (2) not through pointers to workspace array Work()
!   but giving the index of start orbital in each symmetry instead,
!   and (3) having CMO array in call parameter list.
!
!   Purpose:  SCR(lscr) contains JNUM cholesky vectors
!             starting from JVEC1 and stored in reduced
!             sets. The routine performs an MOs half transformation
!             of these elements in a set of target
!             arrays identified by the pointers ipChoT.
!             In the target arrays, the vectors are
!             stored in full dimension and as a
!             subset of a a given NUMV number of vectors.
!             Each pointer should thereby point to a
!             location where the corresponding Cholesky
!             vector of a given unique symmetry pair
!             of indices has to be stored
!
!   Input:
!       jVref =  index of the first vector to be transformed
!                computed wrt to the first vector in the
!                target arrays (see calling routine)
!
!       Jvec1 =  first vector to be transformed
!       JNum  =  # of vectors to be transformed
!
!       NumV  =  total # of vectors in the target arrays
!
!       JREDC :  reduced set in core at the moment of
!                the first call to the routine.
!                Can be set to -1 by the calling routine
!
!********************************************************

use Symmetry_Info, only: Mul
use Cholesky, only: iBas, iiBstR, IndRed, InfVec, iRS2F, nBas, nDimRS, nnBstR, nSym
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: irc, JREDC
integer(kind=iwp), intent(in) :: lscr, jVref, JVEC1, JNUM, NUMV, JSYM, NCMO, ISTART(8), NUSE(8), ipChoT(8), nWork
real(kind=wp), intent(inout) :: Scr(lscr)
real(kind=wp), intent(in) :: CMO(NCMO)
real(kind=wp), intent(out) :: Work(nWork)
integer(kind=iwp) :: iag, ias, ibg, ibs, IOC, IOFFC(8), iRab, ISCA, ISCB, ISYM, iSyma, iSymb, iSymp, jRab, JRED, JVEC, JVTRNS, &
                     kchot, kRab, kscr, NBA, NBB, nElem, NREAD, NUSEA, NUSEB
integer(kind=iwp), external :: cho_isao
integer(kind=iwp), parameter :: iLoc = 3 ! this means 'use scratch location in reduced index arrays'

! Offset counter into CMO array:
IOC = 0
do ISYM=1,NSYM
  IOFFC(ISYM) = IOC
  IOC = IOC+NBAS(ISYM)**2
end do

do iSymp=1,nSym
  if (nUse(iSymp) /= 0) then
    iSymb = Mul(JSYM,iSymp)
    nElem = nUse(iSymp)*nBas(iSymb)*NUMV
    Work(ipChoT(iSymp):ipChoT(iSymp)+nElem-1) = Zero
  end if
end do

NREAD = 0
do JVEC=1,JNUM
  ! JVTRNS=Cholesky vector to be transformed.
  JVTRNS = JVEC1-1+JVEC
  ! JRED: Which reduced set does it belong to:
  JRED = InfVec(JVTRNS,2,JSYM)

  ! Is it the same still?
  if (JRED /= JREDC) then
    ! It is not. Tables must be regenerated with information that is
    ! common to this reduced set.
    write(u6,*) ' Rats! It was assumed that the Cholesky vectors'
    write(u6,*) ' in HALFTRNSF all belonged to a given reduced'
    write(u6,*) ' set, but they don''t!'
    write(u6,*) ' JRED, JREDC:',JRED,JREDC
    write(u6,*) ' Back to the drawing board?'
    write(u6,*) ' Let the program continue and see what happens.'
    call Cho_X_SetRed(irc,iLoc,JRED)
    JREDC = JRED
  end if

  kscr = NREAD
  NREAD = NREAD+nDimRS(JSYM,JRED)

  if (JSYM == 1) then
    ! L(a,b,J)=L(b,a,J); only a >= b stored

    do jRab=1,nnBstR(jSym,iLoc)

      kRab = iiBstr(jSym,iLoc)+jRab
      iRab = IndRed(kRab,3)

      ! Global address:
      iag = iRS2F(1,iRab)
      ibg = iRS2F(2,iRab)

      iSyma = cho_isao(iag)

      kscr = kscr+1

      ISYMB = ISYMA

      NUSEA = nUse(iSyma)
      NUSEB = nUse(iSymb)

      if (NUSEA /= 0) then

        ias = iag-ibas(iSyma)
        ibs = ibg-ibas(iSyma)
        !  L(p,J,b) = sum( C(a,p)* L(a,b,J), a=1..NBA), where p=1..NUSEA
        !  L(p,J,a) = sum( C(b,p)* L(b,a,J), b=1..NBB), where p=1..NUSEB
        !  ----------------------------------------

        NBA = NBAS(ISYMA)
        ISCA = IOFFC(ISYMA)+IAS+NBA*(ISTART(ISYMA)-1)
        NBB = NBAS(ISYMB)
        ISCB = IOFFC(ISYMB)+IBS+NBB*(ISTART(ISYMB)-1)

        kchot = ipChoT(iSymb)+NUSEB*(jVref+JVEC-2+NUMV*(ias-1))

        call DAXPY_(NUSEA,Scr(kscr),CMO(ISCB),NBB,Work(kchot),1)

        if (IAS /= IBS) then
          kchot = ipChoT(iSyma)+NUSEA*(jVref+JVEC-2+NUMV*(ibs-1))

          call DAXPY_(NUSEA,Scr(kscr),CMO(ISCA),NBA,Work(kchot),1)
        end if

        ! End of NUSE  test
      end if

      ! End of loop over basis function pair index JRAB
    end do

  else
    ! jSym /= 1

    do jRab=1,nnBstR(jSym,iLoc)

      kRab = iiBstr(jSym,iLoc)+jRab
      iRab = IndRed(kRab,3)

      ! Global address:
      iag = iRS2F(1,iRab)
      ibg = iRS2F(2,iRab)

      ! iSyma = cho_isao(iag) = symmetry block of basis function iag
      iSyma = cho_isao(iag)
      ! iSyma > isymb since jsym /= 1 and a >= b
      iSymb = Mul(jSym,iSyma)
      NUSEA = nUse(iSyma)
      NUSEB = nUse(iSymb)

      kscr = kscr+1

      ias = iag-ibas(iSyma)
      ibs = ibg-ibas(iSymb)

      if (NUSEA /= 0) then
        !  L(p,J,b) = sum( C(a,p)*L(a,b,J), a=1..NBA), where p=1..NUSEA

        NBA = NBAS(ISYMA)
        ISCA = IOFFC(ISYMA)+IAS+NBA*(ISTART(ISYMA)-1)

        kchot = ipChoT(iSyma)+nUse(iSyma)*(jVref+JVEC-2+NUMV*(ibs-1))

        call DAXPY_(NUSEA,Scr(kscr),CMO(ISCA),NBA,Work(kchot),1)

        ! End of NUSE  test
      end if

      if (NUSEB /= 0) then
        ! L(p,J,a) = sum( C(b,p)*L(b,a,J), b=1..NBA), where p=1..NUSEB

        NBB = NBAS(ISYMB)
        ISCB = IOFFC(ISYMB)+IBS+NBB*(ISTART(ISYMB)-1)

        kchot = ipChoT(iSymb)+NUSEB*(jVref+JVEC-2+NUMV*(ias-1))

        call DAXPY_(NUSEB,Scr(kscr),CMO(ISCB),NBB,Work(kchot),1)

        ! End of NUSE  test
      end if

      ! End of loop over basis function pair index JRAB
    end do

    ! End of JSYM /= 1 test
  end if

  ! End of JSYM loop
end do

irc = 0

end subroutine HALFTRNSF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
cpgi$g opt=1
      SUBROUTINE FIJ(ICASE,JSY,INDEX,C,S,FC,A,B,FK,DBK,ENP,
     *EPP)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION JSY(*),INDEX(*),C(*),S(*),FC(*),A(*),B(*),
     &             FK(*),DBK(*),ENP(*),EPP(*)
      DIMENSION ICASE(*)
      PARAMETER (IPOW6=2**6, IPOW10=2**10, IPOW19=2**19)
*
      JSYM(L)=JSUNP_CPF(JSY,L)
*
      IK = 0 ! dummy initialize
      NOB2=IROW(NORBT+1)
C      IF(IDENS.EQ.1)WRITE(6,876)(FC(I),I=1,NOB2)
C  876 FORMAT(1X,'FIJ',5F12.6)
      ICHK=0
      IF(IDENS.EQ.1)GO TO 105
      NOB2=IROW(NORBT+1)
      CALL SETZ(FC,NOB2)
      IADD25=0
      CALL dDAFILE(Lu_25,2,FC,NOB2,IADD25)
      IF(ITER.EQ.1)GO TO 200
105   IADD10=IAD10(8)
100   CALL dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
      CALL iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 100
      IF(LEN.LT.0)GO TO 200
      DO 10 IN=1,LEN
      IND=ICOP1(IN)
      IF(ICHK.NE.0)GO TO 460
      IF(IND.NE.0)GO TO 11
      ICHK=1
      GO TO 10
460   ICHK=0
      INDI=IND
*      NI=MOD(INDI,1024)
*      NK=MOD(INDI/IPOW10,1024)
      NI=IBITS(INDI,0,10)
      NK=IBITS(INDI,10,10)
      IK=IROW(NK)+NI
      GO TO 10
11    CONTINUE
*      IVL=MOD(IND,64)
*      IC2=MOD(IND/IPOW6,8192)
*      IC1=MOD(IND/IPOW19,8192)
      IVL=IBITS(IND, 0, 6)
      IC2=IBITS(IND,6,13  )
      IC1=IBITS(IND,19,13  )
      COPI=COP(IN)*FC(IK)
      IF(IVL.NE.IV0)GO TO 13
      IF(IC1.NE.IREF0)GO TO 16
      IF(IDENS.EQ.1)GO TO 18
      COPI=COPI/SQRT(ENP(IC2))
      S(IC2)=S(IC2)+COPI
      IF(ITER.EQ.1)GO TO 10
      EPP(IC2)=EPP(IC2)+COPI*C(IC2)
      GO TO 10
18    FC(IK)=FC(IK)+COP(IN)*C(IC1)*C(IC2)/ENP(IC2)
      GO TO 10
16    IF(IC2.NE.IREF0)GO TO 17
      IF(IDENS.EQ.1)GO TO 19
      COPI=COPI/SQRT(ENP(IC1))
      S(IC1)=S(IC1)+COPI
      IF(ITER.EQ.1)GO TO 10
      EPP(IC1)=EPP(IC1)+COPI*C(IC1)
      GO TO 10
19    FC(IK)=FC(IK)+COP(IN)*C(IC1)*C(IC2)/ENP(IC1)
      GO TO 10
17    IF(IDENS.EQ.1)GO TO 21
      FACS=D1
      S(IC1)=S(IC1)+FACS*COPI*C(IC2)
      S(IC2)=S(IC2)+FACS*COPI*C(IC1)
      GO TO 10
21    FC(IK)=FC(IK)+COP(IN)*C(IC1)*C(IC2)/
     *(SQRT(ENP(IC1))*SQRT(ENP(IC2)))
      GO TO 10
13    INDA=IRC(IVL)+IC1
      INDB=IRC(IVL)+IC2
      NA=INDEX(INDA)
      NB=INDEX(INDB)
      NS1=JSYM(INDA)
      NS1L=MUL(NS1,LSYM)
      INUM=NVIR(NS1L)
      IF(IVL.GE.2)INUM=NNS(NS1L)
      IF(IDENS.EQ.1)GO TO 15
      FACS=D1
      CALL DAXPY_(INUM,COPI*FACS,C(NB+1),1,S(NA+1),1)
      CALL DAXPY_(INUM,COPI*FACS,C(NA+1),1,S(NB+1),1)
      GO TO 10
15    TERM=DDOT_(INUM,C(NA+1),1,C(NB+1),1)
      FC(IK)=FC(IK)+COP(IN)*TERM/(SQRT(ENP(INDA))*SQRT(ENP(INDB)))
10    CONTINUE
      GO TO 100
C  200 IF(IDENS.EQ.1)WRITE(6,876)(FC(I),I=1,NOB2)
200   CALL dAI_CPF(C)
      IF(ITER.EQ.1)RETURN
      CALL AB(ICASE,JSY,INDEX,C,S,FC,A,B,FK,ENP)
      RETURN
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE dAI_CPF(C)
      USE ISO_C_BINDING
      REAL*8, TARGET :: C(*)
      INTEGER, POINTER :: iC(:)
      CALL C_F_POINTER(C_LOC(C(1)),iC,[1])
      CALL AI_CPF(JSY,INDEX,C,S,FC,C,iC,A,B,FK,DBK,ENP,EPP,0)
      NULLIFY(iC)
      END SUBROUTINE dAI_CPF
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function nPre(kS)

use Symmetry_Info, only: Mul
use input_mclr, only: nIsh, nOrb, nRS1, nRS2, nRS3, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nPre
integer(kind=iwp), intent(in) :: kS
integer(kind=iwp) :: iS, jS, nRest

nPre = 0
do iS=1,nSym
  jS = Mul(iS,kS)
  nRest = nOrb(jS)-nIsh(jS)
  nPre = nPre+nIsh(iS)*nRest**2
  nRest = nOrb(jS)-nRs1(jS)
  nPre = nPre+nRs1(iS)*nRest**2
  nRest = nOrb(jS)-nRs2(jS)
  nPre = nPre+nRs2(iS)*nRest**2
  nRest = nOrb(jS)-nRs3(jS)
  nPre = nPre+nRs3(iS)*nRest**2
end do

end function nPre

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE MABCD(JSY,INDEX,ISAB,C,S,ACBDS,ACBDT,BUFIN,
     *W,THET,ENP,NII)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION JSY(*),INDEX(*),ISAB(*),C(*),S(*),ACBDS(*),ACBDT(*),
     &          BUFIN(*),W(*),THET(NII,NII),ENP(*)
*
      INUM=IRC(4)-IRC(3)
      CALL MPSQ2(C,S,W,MUL,INDEX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)
      IAD16=0
      KBUFF1=2*9600
      INSIN=KBUFF1
      NVT=IROW(NVIRT+1)
      NOV=(NVT-1)/IPASS+1
      IACMAX=0
      DO 70 ISTEP=1,IPASS
      IACMIN=IACMAX+1
      IACMAX=IACMAX+NOV
      IF(IACMAX.GT.NVT)IACMAX=NVT
      IF(IACMIN.GT.IACMAX)GO TO 70
      DO 40 ISYM=1,NSYM
      IST1=IRC(3)+JJS(ISYM+9)+1
      IFIN1=IRC(3)+JJS(ISYM+10)
      INPS=IFIN1-IST1+1
      IST2=IRC(2)+JJS(ISYM)+1
      IFIN2=IRC(2)+JJS(ISYM+1)
      INPT=IFIN2-IST2+1
      ITAIL=INPS+INPT
      IF(ITAIL.EQ.0)GO TO 40
      IN1=-NVIRT
      DO 50 NA=1,NVIRT
      IN1=IN1+NVIRT
      DO 60 NC=1,NA
      IAC=IROW(NA)+NC
      IF(IAC.LT.IACMIN)GO TO 60
      IF(IAC.GT.IACMAX)GO TO 60
      IF(NA.EQ.1)GO TO 60
      NSAC=MUL(NSM(LN+NA),NSM(LN+NC))
      NSACL=MUL(NSAC,LSYM)
      IF(NSACL.NE.ISYM)GO TO 60
      ISAC=ISAB(IN1+NC)
      NDMAX=NSYS(NSM(LN+NC)+1)
      IF(NDMAX.GT.NA)NDMAX=NA
      INS=ISAB(IN1+NDMAX)
      ILOOP=0
72    DO 75 I=1,INS
      IF(INSIN.LT.KBUFF1)GO TO 73
      CALL dDAFILE(Lu_TiABCD,2,BUFIN,KBUFF1,IAD16)
      INSIN=0
73    INSIN=INSIN+1
      IF(ILOOP.EQ.0)ACBDS(I)=BUFIN(INSIN)
      IF(ILOOP.EQ.1)ACBDT(I)=BUFIN(INSIN)
75    CONTINUE
      ILOOP=ILOOP+1
      IF(ILOOP.EQ.1)GO TO 72
      IF(INPS.EQ.0)GO TO 11
      DO 10 INDA=IST1,IFIN1
      ENPQ=(D1-THET(INDA,INDA)/D2)*(ENP(INDA)+ENP(INDA)-D1)+
     *THET(INDA,INDA)/D2
      FACS=SQRT(ENP(INDA))*SQRT(ENP(INDA))/ENPQ
      FACW=(FACS*(D2-THET(INDA,INDA))/ENPQ)*ENP(INDA)-FACS
      TERM=DDOT_(INS,C(INDEX(INDA)+1),1,ACBDS,1)
      S(INDEX(INDA)+ISAC)=S(INDEX(INDA)+ISAC)+FACS*TERM
      W(INDEX(INDA)+ISAC)=W(INDEX(INDA)+ISAC)+FACW*TERM
      CALL DAXPY_(INS,FACS*C(INDEX(INDA)+ISAC),ACBDS,1,
     *S(INDEX(INDA)+1),1)
      CALL DAXPY_(INS,FACW*C(INDEX(INDA)+ISAC),ACBDS,1,
     *W(INDEX(INDA)+1),1)
10    CONTINUE
11    IF(INPT.EQ.0.OR.NA.EQ.NC)GO TO 60
      DO 30 INDA=IST2,IFIN2
      ENPQ=(D1-THET(INDA,INDA)/D2)*(ENP(INDA)+ENP(INDA)-D1)+
     *THET(INDA,INDA)/D2
      FACS=SQRT(ENP(INDA))*SQRT(ENP(INDA))/ENPQ
      FACW=(FACS*(D2-THET(INDA,INDA))/ENPQ)*ENP(INDA)-FACS
      TERM=DDOT_(INS,C(INDEX(INDA)+1),1,ACBDT,1)
      S(INDEX(INDA)+ISAC)=S(INDEX(INDA)+ISAC)+FACS*TERM
      W(INDEX(INDA)+ISAC)=W(INDEX(INDA)+ISAC)+FACW*TERM
      CALL DAXPY_(INS,FACS*C(INDEX(INDA)+ISAC),ACBDT,1,
     *S(INDEX(INDA)+1),1)
      CALL DAXPY_(INS,FACW*C(INDEX(INDA)+ISAC),ACBDT,1,
     *W(INDEX(INDA)+1),1)
30    CONTINUE
60    CONTINUE
50    CONTINUE
40    CONTINUE
70    CONTINUE
      CALL MDSQ2(C,S,W,MUL,INDEX,JSY,NDIAG,INUM,IRC(3),
     *LSYM,NVIRT,SQ2)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagNS2(iSym,NBSQT,lT2AO,DPT2C,T2AO)

use Symmetry_Info, only: Mul
use caspt2_module, only: NACTEL, NASH, NBAS, NDEL, NFRO, NISH, NSSH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSym, NBSQT, lT2AO
real(kind=wp), intent(inout) :: DPT2C(NBSQT), T2AO(lT2AO)
integer(kind=iwp) :: iCase, iSymA, iSymAB, iSymB, iSymI, iSymIJ, iSymIJAB, iSymJ, jSym, lInt, nMaxOrb
real(kind=wp), allocatable :: Amp1(:), Int1(:), Scr1(:)

!! orbital Lagrangian from the T-amplitude
!! See the loop structure in rhs_mp2
!! and the helper subroutine in rhs_mp2_help1/2

nMaxOrb = 0
do jSym=1,nSym
  nMaxOrb = max(nMaxOrb,nBas(jSym))
end do
lInt = nMaxOrb*nMaxOrb

call mma_allocate(Int1,lInt,Label='Int1') !! for (ia|jb)
call mma_allocate(Scr1,lInt,Label='Scr1') !! work space
call mma_allocate(Amp1,lInt,Label='Amp1') !! for amplitude

!! (ia|jb)
do iSymI=1,nSym !! Symmetry of occupied (docc+act) orbitals
  !! Check, in particular nFro
  if (nFro(iSymI)+nIsh(iSymI)+nAsh(iSymI) == 0) cycle
  do iSymJ=1,iSymI
    if (nFro(iSymJ)+nIsh(iSymJ)+nAsh(iSymJ) == 0) cycle
    iSymIJ = Mul(iSymI,iSymJ)
    do iSymA=1,nSym !! Symmetry of non-filled (act+virt) orbs
      if (nAsh(iSymA)+nSsh(iSymA)+nDel(iSymA) == 0) cycle
      do iSymB=1,iSymA
        if (nAsh(iSymB)+nSsh(iSymB)+nDel(iSymB) == 0) cycle
        iSymAB = Mul(iSymA,iSymB)
        iSymIJAB = Mul(iSymIJ,iSymAB)
        if (iSym /= iSymIJAB) cycle
        do iCase=1,13
          call OLagNs_Hel2(iCase,NBSQT,lT2AO,iSym,iSymA,iSymB,iSymI,iSymJ,nMaxOrb,Int1,Amp1,Scr1,DPT2C,T2AO)
        end do
      end do
    end do
  end do
end do

DPT2C(1:NBSQT) = DPT2C(1:NBSQT)/real(max(1,NACTEL),kind=wp)

call mma_deallocate(Int1)
call mma_deallocate(Scr1)
call mma_deallocate(Amp1)

end subroutine OLagNS2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module ccsd_global

! A   Most common arrays of whole program
!
!1    max. number of orbitals (basis functions)
!     - maxorb
!
!2    characteristics from MOLCAS
!
!2.1  Number of active electrons
!     - nactel
!
!2.2  spin state of the system
!     - ispin
!
!2.3  number of irreps in the system
!     - nsym
!
!2.4  symmetry state of the system
!     - lsym
!
!2.5  matrix multiplication table
!     - mmul
!
!2.6  vectors containing size of the system
!     - noa, nob, nva, nvb, norb
!
!2.7  orbital energies
!     - eps
!
!3    internal CCSD characteristics
!
!3.1  size characteristic Table
!     - dimm(1:5,1:8)
!
!3.2  shift vector
!     - nshf(1:maxorb)
!
!4    input parameters (read from input file)
!
!4.1  title of the job + number ot title lines
!     - title, ntit
!
!4.2  Maximal number of iterations
!     - maxiter
!
!4.3  type of t3 contribution
!     - typt3
!
!4.4  type of denominator
!     - typden
!
!4.5  using of extrapolation
!     - yesext
!
!4.6  first iteration of extrapolation
!     - firstext
!
!4.7  extrapolation cycle
!     - cycext
!
!4.9  tolerance for energy
!     - ccconv
!
!4.10 spin adaptation key
!     - keysa
!
!4.11 restart key
!     - keyrst
!
!4.12 restart information file name
!     - filerst
!
!4.13 type of machine (from point of mtx multiplication efficiency)
!     parameter posd0 will be defined in initfile if mchntyp=2)
!     - mchntyp, posd0
!
!4.14 limiting ratio for using AT*B mtx multiplication, if mchntyp=2
!     - slim
!
!4.15 denominator shifts
!     - shifto, shiftv
!
!4.16 maximal allowed work space
!     - maxspace
!
!4.17 level of printing option
!     - fullprint
!
!4.18 No Operation key
!     - noop
!
!4.19 Input/Output style key
!     - iokey
!
!4.20 Matrix handling control key
!     - mhkey
!
!4.21 Key to switch off CCSD part
!     - noccsd
!
!FUE  added to transport the total energies
!     - Escf
!
! B   Maps for all mediates, used in CC
!
!1    maps for fixed mediates
!
!1.0  maps for DP - diagonal part
!     DP1 - dp(p)a
!     DP2 - dp(p)b
!
!1.1  maps for T1
!     T11 - t1oaa(a,i)
!     T12 - t1obb(a,i)
!     T13 - t1naa(a,i)
!     T14 - t1nbb(a,i)
!
!1.2  maps for F1
!     F11 - FI(a,e)aa
!     F12 - FI(a,e)bb
!
!1.3  maps for F2
!     F21 - FII(m,i)aa
!     F22 - FII(m,i)bb
!
!1.4  maps for F3
!     F31 - FIII(e,m)aa
!     F32 - FIII(e,m)bb
!
!1.5  maps for FK
!     FK1 - f(a,b)aa
!     FK2 - f(a,b)bb
!     FK3 - f(a,i)aa
!     FK4 - f(a,i)bb
!     FK5 - f(i,j)aa
!     FK6 - f(i,j)bb
!
!1.6  maps for T2
!     T21 - t2n(ab,ij)aaaa
!     T22 - t2n(ab,ij)bbbb
!     T33 - t2n(a,b,i,j)abab
!
!1.7  maps for W0
!     W01 - <mn||ij>aaaa
!     W02 - <mn||ij>bbbb
!     W03 - <mn||ij>abab
!
!1.8  maps for W1
!     W11 - <ie||mn>aaaa
!     W12 - <ie||mn>bbbb
!     W13 - <ie||mn>abab
!     W14 - <ie||nm>baab
!
!2    maps for help files
!
!     There are :
!     four V  files - of vvoo type
!     four M  files - of vvo  type
!     four H  files - of voo  type
!     two N,P files - of nn   type
!     For V1-V4, M1-M4 H1-H4 and N,P there is corresponding space on WRK at
!     positions %pos0,
!     that are ALWAYS used when using corresponding help files
!     There are also corresponding %d and %i matrix, that are USUALLY used
!     when using corresponding help files
!
!     Moreover, there are 6 additional R1-R6, that can be used
!     arbitrarily, of course with no corresponding space on WRK
!
! C   Parallel run
!
!1    general parameters
!     - maxproc
!
!2    parameters for sumoverab part
!     - nprocab, idab, ideffab, idtmab, ididle
!
!3    parameters for sumoverb and intermezzo part
!     - idaaaa, idbbbb, idaabb, idabba, idbaab, idbbaa
!
!4    parameters for finale part
!     - idfin

use Definitions, only: wp, iwp

implicit none
private

! pos0 - initial position
! d    - direct map
! i    - inverse map
type Map_Type
  integer(kind=iwp) :: d(0:512,6), i(8,8,8), pos0
end type Map_Type

integer(kind=iwp), parameter :: minfiles = 17, maxfiles = 50, &
                                maxorb = 1024, maxproc = 16

integer(kind=iwp) :: cycext, daddr(10:maxfiles) = 0, dimm(5,8), filestatus(10:maxfiles) = 0, firstext, fullprint, idaaaa, idaabb, &
                     idab(maxproc), idabba, idbaab, idbbaa, idbbbb, idfin, iokey, ispin, keyrst, keysa, lsym, maxiter, maxspace, &
                     mchntyp, mhkey, mmul(8,8), nactel, noa(8), nob(8), noccsd, noop, norb(8), nprocab, nshf(maxorb), nsym, ntit, &
                     nva(8), nvb(8), posd0, typden, typt3, yesext
real(kind=wp) :: ccconv, eps(maxorb), Escf, ideffab(maxproc), ididle(maxproc), idtmab(maxproc), shifto, shiftv, slim
character(len=72) :: title
character(len=6) :: filename(10:maxfiles) = 'Temp', filerst
type(Map_Type) :: dp1, dp2, f11, f12, f21, f22, f31, f32, fk1, fk2, fk3, fk4, fk5, fk6, h1, h2, h3, h4, m1, m2, m3, m4, n, p, r1, &
                  r2, r3, r4, r5, r6, t11, t12, t13, t14, t21, t22, t23, v1, v2, v3, v4, w01, w02, w03, w11, w12, w13, w14

public :: ccconv, cycext, daddr, dimm, dp1, dp2, eps, Escf, f11, f12, f21, f22, f31, f32, filename, filerst, filestatus, firstext, &
          fk1, fk2, fk3, fk4, fk5, fk6, fullprint, h1, h2, h3, h4, idaaaa, idaabb, idab, idabba, idbaab, idbbaa, idbbbb, ideffab, &
          idfin, ididle, idtmab, iokey, ispin, keyrst, keysa, lsym, m1, m2, m3, m4, Map_Type, maxfiles, maxiter, maxorb, maxproc, &
          maxspace, mchntyp, mhkey, minfiles, mmul, n, nactel, noa, nob, noccsd, noop, norb, nprocab, nshf, nsym, ntit, nva, nvb, &
          p, posd0, r1, r2, r3, r4, r5, r6, shifto, shiftv, slim, t11, t12, t13, t14, t21, t22, t23, title, typden, typt3, v1, v2, &
          v3, v4, w01, w02, w03, w11, w12, w13, w14, yesext

end module ccsd_global

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Energy_E1 (T1n,Fvo,no,nv,E1)
c
c        this routine do:
c        E1 = sum(a,i) T1n(a,i) . Fvo(a,i)
c
c        calculate E1 component of energy
c
        implicit none
        integer no,nv
        real*8 T1n(1)
        real*8 Fvo(1)
        real*8 e1
c
c        help variables
        integer dim1
c
        e1=0.0d0
        dim1=nv*no
        call mr0u3wt (dim1,dim1,dim1,1,1,T1n(1),Fvo(1),e1)
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine cvbinp_cvb(icode,luinp)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: icode, luinp

call cvbstart_cvb_ge9(icode+10)
call hello_cvb()
call parse_init_cvb(luinp)
call input_cvb()

return

end subroutine cvbinp_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Ignacio Fdez. Galvan                             *
************************************************************************
*  Align
*
*> @brief
*>   Align two structures.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Align a molecular structure with the reference, using the stored weights
*> (masses by default). This is sometimes needed to ensure that an optimal
*> structure is found when there are constraints expressed in weighted space
*> (e.g. `sphere` or `transverse`).
*>
*> @param[in,out] Coord Cartesian coordinates to align
*> @param[in]     Ref   Cartesian coordinates of the reference structure
*> @param[in]     nAtom Number of symmetry-unique atoms
************************************************************************
      Subroutine Align(Coord,Ref,nAtom)
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "sbs.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "info_slapaf.fh"
#include "weighting.fh"
      Real*8 Coord(3*nAtom), Ref(3*nAtom)
      Logical Invar
      Real*8, Allocatable:: Coor_All(:,:), Ref_All(:,:)
      Integer, Allocatable:: iStab(:)

*---- Do nothing if the energy is not rot. and trans. invariant
      Invar=(iAnd(iSBS,2**7).eq.0).and.(iAnd(iSBS,2**8).eq.0)
      If (.Not.Invar) Return

      Call mma_allocate(Coor_All,3,nAtom*8,Label='Coor_All')
      Call Expand_Coor(Coord,nAtom,Coor_All,mAtom)
      Call mma_allocate(Ref_All ,3,nAtom*8,Label='Ref_All')
      Call Expand_Coor(Ref,  nAtom,Ref_All,mAtom)

c     Call RecPrt('Coord before align',' ',Coor_All,3,mAtom)

      Call Superpose_w(Coor_All,Ref_All,Work(ipWeights),mAtom,
     &                 RMS,RMSMax)

*---- Get the stabilizers for each atom (to keep the symmetry)
*     (code copied from init_slapaf)
      Call mma_allocate(iStab,nAtom,Label='iStab')
      Do iAt=1,nAtom
        iAdr=(iAt-1)*3+1
        iChxyz=0
        Do i=0,2
          If (Ref(iAdr+i).ne.Zero) Then
            Do iIrrep=0,nIrrep-1
              If (iAnd(2**i,iOper(iIrrep)).ne.0)
     &           iChxyz=iOr(iChxyz,2**i)
            End Do
          End If
        End Do
        nStb=0
        Do iIrrep=0,nIrrep-1
          If ((nStb.le.1).And.
     &       (iAnd(iChxyz,iOper(iIrrep)).eq.0)) Then
            iStab(iAt)=iOper(iIrrep)
            nStb=nStb+1
          End If
        End Do
      End Do
*
      Call Fix_Symmetry(Coor_All,nAtom,iStab)
      Call mma_deallocate(iStab)

      call dcopy_(3*nAtom,Coor_All,1,Coord,1)

c     Call RecPrt('Coord after align',' ',Coor_All,3,mAtom)

      Call mma_deallocate(Coor_All)
      Call mma_deallocate(Ref_All)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_stats

use fmm_global_paras, only: INTK, REALK, LUPRI, fmm_stats_printed, MAX_LEVEL, TOP_LEVEL
use fmm_utils, only: fmm_quit
implicit none
private

! Public procedures
public :: fmm_init_buffer_stats, &
          fmm_init_matrix_stats, &
          fmm_print_stats

! Public variables
!-----------------

real(REALK), pointer, public, save :: stat_tpack_unique, &
                                      stat_tpack_total, &
                                      stat_tpack_chunks, &
                                      stat_T_mat_builds, &
                                      stat_W_mat_builds

integer(INTK), public, save :: stat_iteration = 0, &
                               stat_n_basis = 0, &
                               stat_points = 0, &
                               stat_raw_moms_RHS = 0, &
                               stat_pkd_moms_RHS = 0, &
                               stat_screened_moms_RHS = 0, &
                               stat_raw_moms_LHS = 0, &
                               stat_pkd_moms_LHS = 0, &
                               stat_deepest_level = 0, &
                               stat_max_branch = 0, &
                               stat_min_branch = 10000, &
                               stat_level_saturation = 0, &
                               stat_RHS_boxes(MAX_LEVEL) = 0, &
                               stat_LHS_boxes(MAX_LEVEL) = 0

logical, public, save :: stat_NF_not_FF = .false.

! Private variables
!------------------

real(REALK), target, save :: stat_T_direction_NF = 0, &
                             stat_T_matrix_NF = 0, &
                             stat_T_chunks_NF = 0, &
                             stat_T_total_NF = 0, &
                             stat_T_direction_FF = 0, &
                             stat_T_matrix_FF = 0, &
                             stat_T_chunks_FF = 0, &
                             stat_T_total_FF = 0

real(REALK), target, save :: stat_W_direction_RB = 0, &
                             stat_W_matrix_RB = 0, &
                             stat_W_total_RB = 0, &
                             stat_W_chunks_RB = 0, &
                             stat_W_direction_BB = 0, &
                             stat_W_matrix_BB = 0, &
                             stat_W_total_BB = 0, &
                             stat_W_chunks_BB = 0, &
                             stat_W_direction_BR = 0, &
                             stat_W_matrix_BR = 0, &
                             stat_W_total_BR = 0, &
                             stat_W_chunks_BR = 0

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_buffer_stats(mode,W_mode)

  implicit none
  character, intent(in)                  :: mode
  character(len=7), optional, intent(in) :: W_mode

  select case (mode)
    case ('T')
      if (stat_NF_not_FF) then
        stat_tpack_chunks => stat_T_chunks_NF
        stat_tpack_unique => stat_T_direction_NF
        stat_tpack_total => stat_T_total_NF
      else
        stat_tpack_chunks => stat_T_chunks_FF
        stat_tpack_unique => stat_T_direction_FF
        stat_tpack_total => stat_T_total_FF
      end if
    case ('W')
      select case (W_mode)
        case ('RAW_BOX')
          stat_tpack_chunks => stat_W_chunks_RB
          stat_tpack_unique => stat_W_direction_RB
          stat_tpack_total => stat_W_total_RB
        case ('BOX_BOX')
          stat_tpack_chunks => stat_W_chunks_BB
          stat_tpack_unique => stat_W_direction_BB
          stat_tpack_total => stat_W_total_BB
        case ('BOX_RAW')
          stat_tpack_chunks => stat_W_chunks_BR
          stat_tpack_unique => stat_W_direction_BR
          stat_tpack_total => stat_W_total_BR
        case default
          call fmm_quit('cannot reconcile W runtype!')
      end select
    case default
      call fmm_quit('cannot reconcile buffer statistics requested')
  end select

end subroutine fmm_init_buffer_stats

!-------------------------------------------------------------------------------

subroutine fmm_init_matrix_stats(mode,W_mode)

  implicit none
  character, intent(in)                  :: mode
  character(len=7), optional, intent(in) :: W_mode

  select case (mode)
    case ('T')
      if (stat_NF_not_FF) then
        stat_T_mat_builds => stat_T_matrix_NF
      else
        stat_T_mat_builds => stat_T_matrix_FF
      end if
    case ('W')
      select case (W_mode)
        case ('RAW_BOX')
          stat_W_mat_builds => stat_W_matrix_RB
        case ('BOX_BOX')
          stat_W_mat_builds => stat_W_matrix_BB
        case ('BOX_RAW')
          stat_W_mat_builds => stat_W_matrix_BR
        case default
          call fmm_quit('cannot reconcile W runtype!')
      end select
    case default
      call fmm_quit('cannot reconcile buffer statistics requested')
  end select

end subroutine fmm_init_matrix_stats

!-------------------------------------------------------------------------------

subroutine fmm_print_stats()

  implicit none
  integer(INTK) :: i, RHS_tot, LHS_tot

  if (.not. fmm_stats_printed) then
    return
  end if

  write(LUPRI,'(/,A)') ' Multipole method statistics'
  write(LUPRI,'(A,/)') ' ---------------------------'

  write(LUPRI,'(A,I8)') ' Number of AOs   =',stat_n_basis
  write(LUPRI,'(A,I6)') ' Deepest level   =',stat_deepest_level
  if (stat_level_saturation > 0) write(LUPRI,*) 'deepest level saturated!',stat_level_saturation

  write(LUPRI,'(A,I6)') ' Max branch      =',stat_max_branch
  write(LUPRI,'(A,I6)') ' Min branch      =',stat_min_branch
  write(LUPRI,'(/,A)') ' Unboxed moments:'
  write(LUPRI,'(A,7X,A,I9)') ' RHS raw','=',stat_raw_moms_RHS
  write(LUPRI,'(A,4X,A,I9)') ' RHS packed','=',stat_pkd_moms_RHS
  write(LUPRI,'(A,2X,A,I9)') ' RHS screened','=',stat_screened_moms_RHS
  write(LUPRI,'(A,7X,A,I9)') ' LHS raw','=',stat_raw_moms_LHS
  write(LUPRI,'(A,4X,A,I9)') ' LHS packed','=',stat_pkd_moms_LHS

  LHS_tot = 0
  RHS_tot = 0
  do i=stat_deepest_level,TOP_LEVEL,-1
    if (stat_RHS_boxes(i) /= -1) then
      write(LUPRI,'(A,I2)') ' Boxes at level: ',i
      write(LUPRI,'(A,5X,A,I9)') ' RHS boxes','=',stat_RHS_boxes(i)
      RHS_tot = RHS_tot+stat_RHS_boxes(i)
    end if
    if (stat_LHS_boxes(i) /= -1) then
      write(LUPRI,'(A,5X,A,I9)') ' LHS boxes','=',stat_LHS_boxes(i)
      LHS_tot = LHS_tot+stat_LHS_boxes(i)
    end if
  end do
  write(LUPRI,'(/,A,2X,A,I9)') ' Total RHS boxes','=',RHS_tot
  write(LUPRI,'(A,2X,A,I9)') ' Total LHS boxes','=',LHS_tot

  if (stat_T_total_NF > 0) then
    write(LUPRI,'(/,A)') ' NF contraction pairs'
    write(LUPRI,'(A,E17.9)') ' total interactions     =',stat_T_total_NF
    write(LUPRI,'(A,E17.9)') ' total directions       =',stat_T_direction_NF
    write(LUPRI,'(A,E17.9)') ' total buffer chunks    =',stat_T_chunks_NF
    write(LUPRI,'(A,E17.9)') ' T matrices built       =',stat_T_matrix_NF
  end if
  write(LUPRI,'(/,A)') ' FF contraction pairs'
  write(LUPRI,'(A,E17.9)') ' total interactions     =',stat_T_total_FF
  write(LUPRI,'(A,E17.9)') ' total directions       =',stat_T_direction_FF
  write(LUPRI,'(A,E17.9)') ' total buffer chunks    =',stat_T_chunks_FF
  write(LUPRI,'(A,E17.9)') ' T matrices built       =',stat_T_matrix_FF

  write(LUPRI,'(/,A)') ' raw-box translations'
  write(LUPRI,'(A,E17.9)') ' total number         =',stat_W_total_RB
  write(LUPRI,'(A,E17.9)') ' total directions     =',stat_W_direction_RB
  write(LUPRI,'(A,E17.9)') ' total buffer chunks  =',stat_W_chunks_RB
  write(LUPRI,'(A,E17.9)') ' W matrices built     =',stat_W_matrix_RB

  write(LUPRI,'(/,A)') ' box-box translations'
  write(LUPRI,'(A,E17.9)') ' total number         =',stat_W_total_BB
  write(LUPRI,'(A,E17.9)') ' total directions     =',stat_W_direction_BB
  write(LUPRI,'(A,E17.9)') ' total buffer chunks  =',stat_W_chunks_BB
  write(LUPRI,'(A,E17.9)') ' W matrices built     =',stat_W_matrix_BB

  write(LUPRI,'(/,A)') ' box-raw translations'
  write(LUPRI,'(A,E17.9)') ' total number         =',stat_W_total_BR
  write(LUPRI,'(A,E17.9)') ' total directions     =',stat_W_direction_BR
  write(LUPRI,'(A,E17.9)') ' total buffer chunks  =',stat_W_chunks_BR
  write(LUPRI,'(A,E17.9)') ' W matrices built     =',stat_W_matrix_BR

  write(LUPRI,'(/,A,/)') ' ------------------------------------------'

end subroutine fmm_print_stats

!-------------------------------------------------------------------------------

end module fmm_stats

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Jeppe Olsen                                      *
!***********************************************************************

subroutine GENSTR_MCLR(NEL,NELMN1,NELMX1,NELMN3,NELMX3,ISTASO,NOCTYP,NSM,Z,LSTASO,IREORD,STRING,IOC,IOTYP)
! Generate strings consisting of  NEL electrons fulfilling
!   1 : Between NELMN1 AND NELMX1 electrons in the first NORB1 orbitals
!   2 : Between NELMN3 AND NELMX3 electrons in the last  NORB3 orbitals
!
! In the present version the strings are directly ordered into
! symmetry and occupation type.
!
! Jeppe Olsen Winter of 1990
! ========
! Output :
! ========
! STRING(IEL,ISTRIN) : Occupation of strings.
! IREORD             : Reordering array going from lexical
!                      order to symmetry and occupation type order.

use MCLR_Data, only: NACOB, NORB1, NORB2, NORB3
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NEL, NELMN1, NELMX1, NELMN3, NELMX3, NOCTYP, NSM, ISTASO(NOCTYP,NSM), Z(NACOB,NEL), IOTYP
integer(kind=iwp), intent(out) :: LSTASO(NOCTYP,NSM)
integer(kind=iwp), intent(inout) :: IREORD(*)
integer(kind=iwp), intent(_OUT_) :: STRING(NEL,*), IOC(*)
integer(kind=iwp) :: i, IEL1, IEL2, IEL3, IFRST1, IFRST2, IFRST3, IOCTP2_MCLR, IORB1F, IORB1L, IORB2F, IORB2L, IORB3F, IORB3L, &
                     ISTRNM, ISYM, ISYMST_MCLR, ITYP, LACTU, LEXCI, NONEW1, NONEW2, NONEW3, NSTRIN
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IEL, ISTRIN, KSTRIN, LSTRIN
#endif

LSTASO(:,:) = 0
NSTRIN = 0
IORB1F = 1
IORB1L = IORB1F+NORB1-1
IORB2F = IORB1L+1
IORB2L = IORB2F+NORB2-1
IORB3F = IORB2L+1
IORB3L = IORB3F+NORB3-1
! Loop over possible partitionings between RAS1,RAS2,RAS3
outer: do IEL1=NELMX1,NELMN1,-1
  inner: do IEL3=NELMN3,NELMX3,1
    if (IEL1 > NORB1) cycle outer
    if (IEL3 > NORB3) cycle inner
    IEL2 = NEL-IEL1-IEL3
    if ((IEL2 < 0) .or. (IEL2 > NORB2)) cycle inner
    IFRST1 = 1
    ! Loop over RAS 1 occupancies
    RAS1occ: do
      if (IEL1 /= 0) then
        if (IFRST1 == 1) then
          IOC(1:IEL1) = [(i,i=1,IEL1)]
          IFRST1 = 0
        else
          call NXTORD(IOC,IEL1,IORB1F,IORB1L,NONEW1)
          if (NONEW1 == 1) cycle inner
        end if
      end if
#     ifdef _DEBUGPRINT_
      write(u6,*) ' RAS 1 string'
      call IWRTMA(IOC,1,IEL1,1,IEL1)
#     endif
      IFRST2 = 1
      IFRST3 = 1
      ! Loop over RAS 2 occupancies
      RAS2occ: do
        if (IEL2 /= 0) then
          if (IFRST2 == 1) then
            IOC(IEL1+1:IEL1+IEL2) = [(i,i=IORB2F,IORB2F+IEL2-1)]
            IFRST2 = 0
          else
            call NXTORD(IOC(IEL1+1),IEL2,IORB2F,IORB2L,NONEW2)
            if (NONEW2 == 1) then
              if (IEL1 /= 0) cycle RAS1occ
              if (IEL1 == 0) cycle inner
            end if
          end if
        end if
#       ifdef _DEBUGPRINT_
        write(u6,*) ' RAS 1 2 string'
        call IWRTMA(IOC,1,IEL1+IEL2,1,IEL1+IEL2)
#       endif
        IFRST3 = 1
        ! Loop over RAS 3 occupancies
        RAS3occ: do
          if (IEL3 /= 0) then
            if (IFRST3 == 1) then
              IOC(IEL1+IEL2+1:IEL1+IEL2+IEL3) = [(i,i=IORB3F,IORB3F+IEL3-1)]
              IFRST3 = 0
            else
              call NXTORD(IOC(IEL1+IEL2+1),IEL3,IORB3F,IORB3L,NONEW3)
              if (NONEW3 == 1) then
                if (IEL2 /= 0) cycle RAS2occ
                if (IEL1 /= 0) cycle RAS1occ
                cycle inner
              end if
            end if
          end if
#         ifdef _DEBUGPRINT_
          write(u6,*) ' RAS 1 2 3 string'
          call IWRTMA(IOC,1,NEL,1,NEL)
#         endif
          ! Next string has been constructed, Enlist it!
          NSTRIN = NSTRIN+1
          ! Symmetry
          ISYM = ISYMST_MCLR(IOC,NEL)
          ! Occupation type
          ITYP = IOCTP2_MCLR(IOC,NEL,IOTYP)

          if (ITYP /= 0) then
            LSTASO(ITYP,ISYM) = LSTASO(ITYP,ISYM)+1
            LEXCI = ISTRNM(IOC,NACOB,NEL,Z,IREORD,0)
            LACTU = ISTASO(ITYP,ISYM)-1+LSTASO(ITYP,ISYM)
            IREORD(LEXCI) = LACTU
            STRING(:,LACTU) = IOC(1:NEL)
          end if

          if (IEL3 == 0) exit RAS3occ
        end do RAS3occ
        if ((IEL3 /= 0) .or. (IEL2 == 0)) exit RAS2occ
      end do RAS2occ
      if ((IEL3 /= 0) .or. (IEL2 /= 0) .or. (IEL1 == 0)) exit RAS1occ
    end do RAS1occ
  end do inner
end do outer

#ifdef _DEBUGPRINT_
write(u6,*) ' Number of strings generated ',NSTRIN
write(u6,*) ' Strings generated'
write(u6,*) ' =================='
ISTRIN = 0
do ISYM=1,NSM
  do ITYP=1,NOCTYP
    LSTRIN = min(LSTASO(ITYP,ISYM),NSTRIN-ISTRIN)
    if (LSTRIN > 0) then
      write(u6,*) ' Strings of type and symmetry ',ITYP,ISYM
      do KSTRIN=1,LSTRIN
        ISTRIN = ISTRIN+1
        write(u6,'(2X,I4,8X,(10I5))') ISTRIN,(STRING(IEL,ISTRIN),IEL=1,NEL)
      end do
    end if
  end do
end do

write(u6,*) ' Array giving actual place from lexical place'
write(u6,*) ' ============================================'
call IWRTMA(IREORD,1,NSTRIN,1,NSTRIN)
#endif

end subroutine GENSTR_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine findmn_cvb(vec,n,vmn,imn)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: vec(n)
real(kind=wp), intent(out) :: vmn
integer(kind=iwp), intent(out) :: imn
integer(kind=iwp) :: i

if (n > 0) then
  imn = 1
  vmn = vec(1)
  do i=2,n
    if (vec(i) < vmn) then
      imn = i
      vmn = vec(i)
    end if
  end do
else
  imn = 0
  vmn = 1.0e20_wp
end if

return

end subroutine findmn_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016, Sebastian Wouters                                *
*               2016, Quan Phung                                       *
************************************************************************
! CheMPS2-Molcas main interface
! Based on Block interface, writen by N. Nakatani
! Written by Quan Phung and Sebastian Wouters, Leuven, Aug 2016
      Subroutine CHEMPS2_DENSI_RASSCF(jRoot,D,DS,PS,PA,PT)
      Implicit Real*8 (A-H,O-Z)
*
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
*
      Dimension D(NACPAR),DS(NACPAR),PS(NACPR2),PA(NACPR2)
      Dimension PT(NAC,NAC,NAC,NAC)
*
      Call DCOPY_(NACPAR,0.0D0,0,D, 1)
      Call DCOPY_(NACPAR,0.0D0,0,DS,1)
      Call DCOPY_(NACPR2,0.0D0,0,PS,1)
      Call DCOPY_(NACPR2,0.0D0,0,PA,1)
*
      If(NACTEL.GT.1) Then
        Call chemps2_load2pdm(NAC,PT,jRoot)
        IJ_pack=1
        Do J=1,NAC
          Do I=1,J
            D1sum=0.0D0
            Do K=1,NAC
              D1sum=D1sum+PT(K,K,I,J)
            End Do
            D(IJ_pack)=D1sum/(NACTEL-1)
            IJ_pack=IJ_pack+1
          End Do
        End Do

        IJKL_pack=0
        Do I=1,NAC
          Do J=1,I
            Do K=1,I
              LLIM=K
              If(K.EQ.I)LLIM=J
              DO L=1,LLIM
                IJKL_pack=IJKL_pack+1
                If(K.EQ.L) Then
                  PS(IJKL_pack)=0.5D0*PT(L,K,J,I)
                Else
                  PS(IJKL_pack)=0.5D0*(PT(L,K,J,I)+PT(K,L,J,I))
                  PA(IJKL_pack)=0.5D0*(PT(L,K,J,I)-PT(K,L,J,I))
                End If
              End Do
            End Do
          End Do
        End Do
      Else
* special case for NACTEL = 1
         write(6,*) 'CheMPS2 does not allow 1 electron.'
      End If

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine hotred(nx,n,a,d,e,z)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nx, n
real(kind=wp), intent(in) :: a(nx*(nx+1)/2)
real(kind=wp), intent(out) :: d(nx), e(nx), z(nx,nx)
integer(kind=iwp) :: i, ij, ip, j, jn, k, l
real(kind=wp) :: f, g, h, hh

if (n <= 2) then
  select case (n)
    case default ! (1)
      d(1) = a(1)
      e(1) = Zero
      z(1,1) = One
    case (2)
      d(1) = a(1)
      d(2) = a(3)
      e(1) = Zero
      e(2) = a(2)
      z(1,1) = One
      z(2,2) = One
      z(1,2) = Zero
      z(2,1) = Zero
  end select
  return
end if

ij = 0
do i=1,n
  do j=1,i
    ij = ij+1
    z(i,j) = a(ij)
  end do
end do
do ip=2,n
  i = n-ip+2
  l = i-2
  f = z(i,i-1)
  g = Zero
  if (l /= 0) then
    do k=1,l
      g = g+z(i,k)*z(i,k)
    end do
  end if
  h = g+f*f
  if (g <= 1.0e-12_wp) then
    e(i) = f
    h = Zero
  else
    l = l+1
    g = sqrt(h)
    if (f >= Zero) g = -g
    e(i) = g
    h = h-f*g
    z(i,i-1) = f-g
    f = Zero
    do j=1,l
      z(j,i) = z(i,j)/h
      g = Zero
      do k=1,j
        g = g+z(j,k)*z(i,k)
      end do
      jn = j+1
      if (l >= jn) then
        do k=jn,l
          g = g+z(k,j)*z(i,k)
        end do
      end if
      e(j) = g/h
      f = f+g*z(j,i)
    end do
    hh = f/(h+h)
    do j=1,l
      f = z(i,j)
      g = e(j)-hh*f
      e(j) = g
      do k=1,j
        z(j,k) = z(j,k)-f*e(k)-g*z(i,k)
      end do
    end do
  end if
  d(i) = h
end do
d(1) = z(1,1)
z(1,1) = One
e(1) = Zero
do i=2,n
  l = i-1
  if (d(i) /= Zero) then
    do j=1,l
      g = Zero
      do k=1,l
        g = g+z(i,k)*z(k,j)
      end do
      do k=1,l
        z(k,j) = z(k,j)-g*z(k,i)
      end do
    end do
  end if
  d(i) = z(i,i)
  z(i,i) = One
  do j=1,l
    z(i,j) = Zero
    z(j,i) = Zero
  end do
end do

return

end subroutine hotred

subroutine qlcm(nx,n,d,e,z)

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nx, n
real(kind=wp), intent(inout) :: d(nx), e(nx), z(nx,nx)
integer(kind=iwp) :: i, j, k, kk, l, ll, m, mm
real(kind=wp) :: b, c, f, g, h, p, pp, r, s

do i=2,n
  e(i-1) = e(i)
end do
e(n) = Zero
b = Zero
f = Zero
do l=1,n
  j = 0
  h = 1.0e-12_wp*(abs(d(l))+abs(e(l)))
  if (b < h) b = h
  do m=l,n
    if (abs(e(m)) <= b) exit
  end do
  if (m /= l) then
    do
      if (j == nx+1) then
        write(u6,250)
#       ifndef MOLPRO
        call abend()
#       endif
        !call abend()
      end if
      j = j+1
      g = d(l)
      p = (d(l+1)-g)/(2*e(l))
      r = sqrt(p*p+One)
      if (p < Zero) then
        pp = p-r
      else
        pp = p+r
      end if
      d(l) = e(l)/pp
      h = g-d(l)
      if (l /= n) then
        ll = l+1
        do i=ll,n
          d(i) = d(i)-h
        end do
      end if
      f = f+h
      p = d(m)
      c = One
      s = Zero
      mm = m-1
      do kk=l,mm
        i = mm+l-kk
        g = c*e(i)
        h = c*p
        if (abs(p) < abs(e(i))) then
          c = p/e(i)
          r = sqrt(c*c+One)
          e(i+1) = s*e(i)*r
          s = One/r
          c = c/r
        else
          c = e(i)/p
          r = sqrt(c*c+One)
          e(i+1) = s*p*r
          s = c/r
          c = One/r
        end if
        p = c*d(i)-s*g
        d(i+1) = h+s*(c*g+s*d(i))
        do k=1,n
          h = z(k,i+1)
          z(k,i+1) = s*z(k,i)+c*h
          z(k,i) = c*z(k,i)-s*h
        end do
      end do
      e(l) = s*p
      d(l) = c*p
      if (abs(e(l)) <= b) exit
    end do
  end if
  d(l) = d(l)+f
end do
do i=1,n
  k = i
  p = d(i)
  l = i+1
  if (l <= n) then
    do j=l,n
      if (d(j) >= p) cycle
      k = j
      p = d(j)
    end do
  end if
  if (k == i) cycle
  d(k) = d(i)
  d(i) = p
  do j=1,n
    p = z(j,i)
    z(j,i) = z(j,k)
    z(j,k) = p
  end do
end do

return

250 format(1x///5x,'***the subroutine qlcm is fail, so this computation must stop***')

end subroutine qlcm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ORTHOX_MOTRA(S,C,NORB,NBAS)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NORB, NBAS
real(kind=wp), intent(inout) :: S(NORB,NORB), C(NBAS,NORB)
integer(kind=iwp) :: IBAS, IORB, JORB, KORB
real(kind=wp) :: A, F

do IORB=1,NORB
  F = One/sqrt(S(IORB,IORB))
  do IBAS=1,NBAS
    C(IBAS,IORB) = F*C(IBAS,IORB)
  end do
  do JORB=1,NORB
    S(IORB,JORB) = F*S(IORB,JORB)
    S(JORB,IORB) = F*S(JORB,IORB)
  end do
  do JORB=IORB+1,NORB
    A = S(IORB,JORB)
    do IBAS=1,NBAS
      C(IBAS,JORB) = C(IBAS,JORB)-A*C(IBAS,IORB)
    end do
    do KORB=1,NORB
      S(JORB,KORB) = S(JORB,KORB)-A*S(IORB,KORB)
    end do
    do KORB=1,NORB
      S(KORB,JORB) = S(KORB,JORB)-A*S(KORB,IORB)
    end do
  end do
end do

return

end subroutine ORTHOX_MOTRA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!----------------------------------------------------------------------*
! Global Variables describing chemical system                          *
!----------------------------------------------------------------------*
! nSym    - number of symmetries                                       *
! nOrb(i) - (i = 1, nSym), number of orbitals                          *
! nOcc(i) - (i = 1, nSym), number of occupied orbitals                 *
! nFro(i) - (i = 1, nSym), number of frozen orbitals                   *
! nDel(i) - (i = 1, nSym), number of orbitals deleted by linear deps.  *
! nExt(i) - (i = 1, nSym), number of virtual (external) orbitals       *
!----------------------------------------------------------------------*

module COrbInf

use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: nDel(8), nExt(8), nFro(8), nOcc(8), nOrb(8), nSym

public :: nDel, nExt, nFro, nOcc, nOrb, nSym

end module COrbInf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Cho_TestBookmark(irc,verbose,is1CCD)
      Implicit None
      Integer irc
      Logical verbose
      Logical is1CCD
#include "cholesky.fh"
#include "stdalloc.fh"

      Character*16 SecNam
      Parameter (SecNam='Cho_TestBookmark')

      Logical dealloc

      Integer nVec(8)
      Integer jrc
      Integer iSym
      Integer NumChoBak(8)
      Integer NumChTBak

      Real*8  delta(8)
      Real*8  Thr
      Real*8  ThrComBak
      Real*8  ErrMx

      Real*8, Allocatable:: BkmDia(:), BkmDiaX(:)

      Logical Cho_1Center_Bak


      irc=0

      If (verbose) Then
         Call Cho_Head('Output from '//SecNam,'=',80,6)
      End If

      ! test 1: asking for accuracy below decomposition threshold
      !         should result in failure (return code 1)
      Thr=ThrCom*1.0d-1
      Call Cho_X_Bookmark(Thr,nSym,nVec,delta,jrc)
      If (jrc.eq.-1) Then ! bookmarks not available
         irc=-1
         If (verbose) Then
            Write(6,'(A,A)')
     &      'Cho_X_Bookmark returned -1 [not available].',
     &      'No further testing performed!'
         End If
         Return
      End If
      If (jrc.eq.1) Then
         If (verbose) Call Cho_TestBookmark_Prt(1,'passed')
      Else
         irc=irc+1
         If (verbose) Call Cho_TestBookmark_Prt(1,'failed')
      End If

      ! test 2: asking for negative accuracy
      !         should result in failure (return code 1)
      Thr=-1.0d-12
      Call Cho_X_Bookmark(Thr,nSym,nVec,delta,jrc)
      If (jrc.eq.1) Then
         If (verbose) Call Cho_TestBookmark_Prt(2,'passed')
      Else
         irc=irc+1
         If (verbose) Call Cho_TestBookmark_Prt(2,'failed')
      End If

      ! test 3: asking for decomposition threshold should
      !         give the total number of vectors.
      Thr=ThrCom
      Call Cho_X_Bookmark(Thr,nSym,nVec,delta,jrc)
      If (jrc.eq.0) Then
         Do iSym=1,nSym
            If (nVec(iSym).ne.NumCho(iSym)) Then
               jrc=jrc+1
            End If
            If (delta(iSym).gt.ThrCom) Then
               jrc=jrc+1
            End If
         End Do
         If (jrc.eq.0) Then
            If (verbose) Call Cho_TestBookmark_Prt(3,'passed')
         Else
            irc=irc+1
            If (verbose) Call Cho_TestBookmark_Prt(3,'failed')
         End If
      Else
         irc=irc+1
         If (verbose) Call Cho_TestBookmark_Prt(3,'failed')
      End If

      ! test 4: a threshold above the decomposition threshold
      !         should result in fewer vectors and less accuracy.
      If (ThrCom.lt.1.0d-4) Then
         Thr=max(ThrCom*1.0d3,1.0d-14)
      Else
         Thr=max(ThrCom*1.0d2,1.0d-14)
      End If
      Call Cho_X_Bookmark(Thr,nSym,nVec,delta,jrc)
      If (jrc.eq.0) Then
         Do iSym=1,nSym
            If (delta(iSym).gt.Thr) Then
               jrc=jrc+1
            End If
            If (nVec(iSym).gt.NumCho(iSym)) Then
               jrc=jrc+1
            Else If (nVec(iSym).eq.NumCho(iSym)) Then
               If (delta(iSym).gt.ThrCom) Then
                  jrc=jrc+1
               End If
            End If
         End Do
         If (jrc.eq.0) Then
            If (verbose) Call Cho_TestBookmark_Prt(4,'passed')
         Else
            irc=irc+1
            If (verbose) Call Cho_TestBookmark_Prt(4,'failed')
         End If
      Else
         irc=irc+1
         If (verbose) Call Cho_TestBookmark_Prt(4,'failed')
      End If

      ! Test 5: check diagonal (only if previous tests passed).
      If (irc.ne.0) Then
         If (verbose) Call Cho_TestBookmark_Prt(5,'not executed')
      Else
         Cho_1Center_Bak=Cho_1Center
         Cho_1Center=is1CCD
         Do iSym=1,nSym
            NumChoBak(iSym)=NumCho(iSym)
         End Do
         NumChTBak=NumChT
         ThrComBak=ThrCom
         NumChT=0
         ThrCom=0.0d0
         Do iSym=1,nSym
            NumCho(iSym)=nVec(iSym)
            NumChT=NumChT+NumCho(iSym)
            ThrCom=max(ThrCom,delta(iSym))
         End Do
         Call mma_allocate(BkmDia,nnBstRT(1),Label='BkmDia')
         Call Cho_X_CalcChoDiag(jrc,BkmDia)
         If (jrc.eq.0) Then
            Call mma_allocate(BkmDiaX,nnBstRT(1),Label='BkmDiaX')
            Call Cho_IODiag(BkmDiaX,2)
            Call dAXPY_(nnBstRT(1),-1.0d0,BkmDia,1,BkmDiaX,1)
            If (Cho_1Center) Then
               Call Cho_TestBookmark_1CInit(dealloc)
               Call Cho_MaxAbsDiag(BkmDiaX,1,ErrMx)
               If (dealloc) Call Cho_TestBookmark_1CFinal()
            Else
               Call Cho_MaxAbsDiag(BkmDiaX,1,ErrMx)
            End If
            Call FZero(DiaMax,nSym)
            Call FZero(DiaMaxT,nSym)
            Call mma_deallocate(BkmDiaX)
            If (abs(ErrMx-ThrCom).gt.1.0d-12) Then
               irc=irc+1
               If (verbose) Call Cho_TestBookmark_Prt(5,'failed')
            Else
               If (verbose) Call Cho_TestBookmark_Prt(5,'passed')
            End If
         Else
            irc=irc+1
            If (verbose) Call Cho_TestBookmark_Prt(5,'failed')
         End If
         Call mma_deallocate(BkmDia)
         Do iSym=1,nSym
            NumCho(iSym)=NumChoBak(iSym)
         End Do
         NumChT=NumChTBak
         ThrCom=ThrComBak
         Cho_1Center=Cho_1Center_Bak
      End If

      End
      Subroutine Cho_TestBookmark_Prt(TestNumber,PassFail)
      Implicit None
      Integer TestNumber
      Character*(*) PassFail
      Write(6,'(A,I3,1X,A)') 'Test',TestNumber,PassFail
      End
      Subroutine Cho_TestBookmark_1CInit(AllocatedHere)
      use ChoArr, only: iAtomShl
      Implicit None
      Logical AllocatedHere
#include "cholesky.fh"
#include "stdalloc.fh"

      Integer irc

      If (.NOT.Allocated(iAtomShl)) Then
         Call mma_allocate(iAtomShl,nShell,Label='iAtomShl')
         irc=-1
         Call Cho_SetAtomShl(irc,iAtomShl,SIZE(iAtomShl))
         If (irc.ne.0) Then
            Write(6,'(A,I4)')
     &      'Cho_TestBookmark_1Cinit: Cho_SetAtomShl returned',irc
            Call Cho_Quit('shell-to-atom init failed!',104)
         End If
         AllocatedHere=.True.
      Else
         AllocatedHere=.False.
      End If

      End
      Subroutine Cho_TestBookmark_1CFinal()
      use ChoArr, only: iAtomShl
      Implicit None
#include "stdalloc.fh"

      If (Allocated(iAtomShl)) Call mma_deallocate(iAtomShl)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DistMemo3v3chol (NvGrp,maxdim,
     c        PossV1,PossV2,PossV3,PossV4,
     c        PossH1,PossH2,PossH3,PossH4,
     c        PossM1,PossM2,PossM3,PossM4,PossM5,
     c        PossK,PossQ,
     c        PossT)

c
c       This routine do:
c       define initial possitions of T,L,M and W arrays,
c       used in routine o3v3chol
c
c
c       I/O parameter description:
c       NvGrp    - # of groups in a,b,be,ga set (I)
c       maxdim   - maximal dimension of V'
c       Possx    - initial possitinos of arrays (O-all)
c       PossT    - initial and last possition (I/O)
c
c        requirements of o3v3chol step
c        K  - max{v'v'oo}
c        Q  - max{v'v'oo}
c        V1 - max{v'oo2, mv'v', v'v'oo, mv'o, moo, vv}
c        V2 - max{v'ooo, mv'v', v'v'oo, vo}
c        V3 - max{mv'o, v'v'oo, v'ooo}
c        V4 - max{v'ooo}
c        H1 - max{v'o}
c        H2 - max{v'o}
c        H3 - max{v'o}
c        H4 - max{v'o}
c        M1 - max{moo}
c        M2 - max{mv'o}
c        M3 - max{mv'o}
c        M4 - max{moo}
c        M5 - max{mv'o}
c
        implicit none
#include "chcc1.fh"
c
        integer NvGrp,maxdim
        integer PossV1,PossV2,PossV3,PossV4
        integer PossH1,PossH2,PossH3,PossH4
        integer PossM1,PossM2,PossM3,PossM4,PossM5
        integer PossK,PossQ
        integer PossT
c
c       help variables
        integer length
c
c
c1      Q,K (used also as X,Y)
c
        length=no*no*maxdim*maxdim
c
        PossQ=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM Q  ',PossQ,length
        end if
        PossK=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM K  ',PossK,length
        end if
c
c2.1    V1 file max{v'oo2, mv'v', v'v'oo, mv'o, moo, vv}
        length=maxdim*no*no*(no+1)/2
        if (maxdim*maxdim*nc.gt.length) then
          length=maxdim*maxdim*nc
        end if
        if (no*no*maxdim*maxdim.gt.length) then
          length=no*no*maxdim*maxdim
        end if
        if (no*nc*maxdim.gt.length) then
          length=no*nc*maxdim
        end if
        if (no*nc*no.gt.length) then
          length=no*no*nc
        end if
        if (nv*nv.gt.length) then
          length=nv*nv
        end if
c
        PossV1=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V1 ',PossV1,length
        end if
c
c2.2    V2 file - max{v'ooo, mv'v', v'v'oo, vo}
c
        length=no*no*maxdim*maxdim
        if (no*no*no*maxdim.gt.length) then
          length=no*no*no*maxdim
        end if
        if (nc*maxdim*maxdim.gt.length) then
          length=nc*maxdim*maxdim
        end if
        if (no*nv.gt.length) then
          length=no*nv
        end if
c
        PossV2=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V2 ',PossV2,length
        end if
c
c2.2    V3 files - max{mv'o, v'v'oo, v'ooo}
c
        length=no*no*maxdim*maxdim
        if (no*no*no*maxdim.gt.length) then
          length=no*no*no*maxdim
        end if
        if (no*nc*maxdim.gt.length) then
          length=nc*no*maxdim
        end if
c
        PossV3=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V3 ',PossV3,length
        end if
c
c2.4    V4 files - max{v'ooo}
c
        length=no*no*no*maxdim
c
        PossV4=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM V4 ',PossV4,length
        end if
c
c3      H1-4 files - max{v'o}
c
        length=no*maxdim
c
        PossH1=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM H1 ',PossH1,length
        end if
        PossH2=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM H2 ',PossH2,length
        end if
        PossH3=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM H3 ',PossH3,length
        end if
        PossH4=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM H4 ',PossH4,length
        end if
c
c4      M1-5 files
c        M1 - max{moo}
c        M2 - max{mv'o}
c        M3 - max{mv'o}
c        M4 - max{moo}
c        M5 - max{mv'o}
c
        length=no*no*nc
        PossM1=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM M1 ',PossM1,length
        end if
        length=no*nc*maxdim
        PossM2=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM M2 ',PossM2,length
        end if
        length=no*nc*maxdim
        PossM3=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM M3 ',PossM3,length
        end if
        length=no*nc*no
        PossM4=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM M4 ',PossM4,length
        end if
        length=no*nc*maxdim
        PossM5=possT
        PossT=PossT+length
        if (printkey.ge.10) then
        write (6,*) 'DM M5 ',PossM5,length
        end if
c
c
        if (printkey.ge.10) then
        write (6,*) 'PossT ',PossT
        end if
c
        return
c Avoid unused argument warnings
        if (.false.) Call Unused_integer(NvGrp)
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Valera Veryazov                                  *
************************************************************************
************************************************************************
*                                                                      *
*     purpose:                                                         *
*       replace SYSDB                                                  *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     V.Veryazov University of Lund, 2001                              *
*                                                                      *
************************************************************************
*  SysHalt
*
*> @brief
*>   Quit calculation
*> @author V. Veryazov
*>
*> @details
*> A routine to stop calculation because of internal error or
*> inconsistency in the code.
*>
*> @param[in] Location routine name
************************************************************************
      Subroutine SysHalt(Location)
      Character *(*) Location
       Call SysAbendMsg(Location,'Internal error',' ')
      return
      end
************************************************************************
*  SysWarnMsg
*
*> @brief
*>   Print nice formatted warning message
*> @author V. Veryazov
*>
*> @details
*> Print formatted message.
*> For a set of standard messages (started from ``MSG:``) the aliases
*> (defined in ::SysExpand) will be used.
*>
*> @param[in] Location routine name
*> @param[in] Text1    message text
*> @param[in] Text2    message text
************************************************************************
      Subroutine SysWarnMsg(Location,Text1,Text2)
      Character*(*) Location,Text1, Text2
      Character Str*256
      common /WarnMess/ MaxWarnMess
      Level=1
c for these messages assume that Level is 1
      if(Level.gt.MaxWarnMess) MaxWarnMess=Level
      call SysPutsStart()
      call SysPuts('Location: ',Location,'\n\n\n')
      call SysExpand(Text1,Str,i)
      if(i.eq.0) then
        call SysPuts(Text1,' ',Text2)
      else
        call SysPuts(str(:i),' ',Text2)
      endif
      call SysPutsEnd()

      Return
      End
************************************************************************
      Subroutine SysWarnFileMsg(Location,TheFile,Text1,Text2)
      Character*(*) Location,Text1, Text2, TheFile
      Character Str*256
      call SysPutsStart()
      call SysPuts('Location: ',Location,'\n')
      call SysExpand(TheFile,Str,i)
      call SysPuts('File: ',TheFile,'\n\n\n')
      call SysExpand(Text1,Str,i)
      if(i.eq.0) then
        call SysPuts(Text1,' ',Text2)
      else
        call SysPuts(str(:i),' ',Text2)
      endif
      call SysPutsEnd()

      Return
      End
************************************************************************
*  SysAbendMsg
*
*> @brief
*>   Stop calculation
*> @author V. Veryazov
*>
*> @details
*> Print formatted message and stop the calculation.
*>
*> @param[in] Location routine name
*> @param[in] Text1    message text
*> @param[in] Text2    message text
************************************************************************
      Subroutine SysAbendMsg(Location,Text1,Text2)
      Character*(*) Location,Text1, Text2
      call SysWarnMsg(Location,Text1,Text2)
      Call Abend()
      Return
      End
************************************************************************
      Subroutine SysAbendFileMsg(Location,TheFile,Text1,Text2)
      Character*(*) Location,Text1, Text2, TheFile
      call SysWarnFileMsg(Location,TheFile,Text1,Text2)
      Call Abend()
      Return
      End
************************************************************************
      Subroutine SysQuitFileMsg(rc,Location,TheFile,Text1,Text2)
      Integer rc
      Character*(*) Location,Text1, Text2, TheFile
      call SysWarnFileMsg(Location,TheFile,Text1,Text2)
      Call Quit(rc)
      Return
      End
************************************************************************
      Subroutine SysQuitMsg(rc,Location,Text1,Text2)
      Integer rc
      Character*(*) Location,Text1, Text2
      call SysWarnMsg(Location,Text1,Text2)
      Call Quit(rc)
      Return
      End
************************************************************************
      Subroutine SysCondMsg(Text1,N1,Text2,N2)
      Character s*64
      Character*(*) Text1, Text2
      call SysPuts('Condition: ',Text1,' ')
      write(s,'(i16,a,i16)') N1,Text2,N2
      call SysPuts('Actual   : ',s,' ')
      call SysPutsEnd()
      call Abend()
      return
      end
************************************************************************
      Subroutine SysValueMsg(Text1,N1)
      Character*(*) Text1
      call SysValueWarnMsg(Text1,N1)
      call SysPutsEnd()
      call Abend()
      return
      end
************************************************************************
      Subroutine SysValueWarnMsg(Text1,N1)
      Character s*20
      Character*(*) Text1
      write(s,'(a,i16)') ' = ',N1
      call SysPuts('Value: ',Text1, s)
      return
      end
************************************************************************
      Subroutine SysPutsStart()
      character c
      c='#'
      write (6,'(a,79a1)') ' ',(c,i=1,79)
      write (6,'(a,79a1)') ' ',(c,i=1,79)
      write (6,'(a,73x,a)') ' ###','###'
      write (6,'(a,73x,a)') ' ###','###'
      return
      end
************************************************************************
      Subroutine SysPutsEnd()
      character c
      c='#'
      write (6,'(a,73x,a)') ' ###','###'
      write (6,'(a,73x,a)') ' ###','###'
      write (6,'(a,79a1)') ' ',(c,i=1,79)
      write (6,'(a,79a1)') ' ',(c,i=1,79)
      return
      end
************************************************************************
      Subroutine SysFileMsg(Location,Text1,Lu,Text2)
      Character*(*) Location,Text1, Text2
      character *256 str
      call SysPutsStart()
      call SysPuts('Location: ',Location,'\n')
      write(str,*) Lu
      call SysPuts('Unit    : ',str,' ')
      str=' '
      inquire (unit=lu, name=str)
       if(str.ne.' ') then
      call SysPuts('File    : ',str,'\n')
       endif

      call SysExpand(Text1,Str,i)
      if(i.eq.0) then
        call SysPuts(Text1,'\n',Text2)
      else
        call SysPuts(str(:i),'\n',Text2)
      endif
      call SysPutsEnd()
      call Abend()
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018, Jesper Norell                                    *
************************************************************************
      SUBROUTINE MKDYSORB(IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,
     &                 PSI1,PSI2,IF10,IF01,DYSAMP,DYSCOF)

      use Constants, only: One, Zero
      use stdalloc, only: mma_allocate, mma_deallocate
      use rassi_global_arrays, only: FSBANN1, FSBANN2

      IMPLICIT NONE
      INTEGER IORBTAB(*)
      INTEGER ISSTAB(*)
      INTEGER IFSBTAB1(*),IFSBTAB2(*)
      REAL*8 PSI1(*),PSI2(*)
      LOGICAL IF10,IF01
      REAL*8 DYSAMP, DYSCOF(*)

      REAL*8 COEFF,OVLP
      Real*8, EXTERNAL :: OVERLAP_RASSI
      INTEGER NASORB
      INTEGER IMODE,ISORB
      INTEGER NDETS1,NDETS2
      INTEGER JSORB
      Real*8, Allocatable:: ANN1(:), ANN2(:)

! +++ J. Norell 12/7 - 2018
C Calculates the Dyson orbital between two states with
C N and N-1 electrons, defined as:
C D = < N-1 | anni_right | N >, or
C D = < N | anni_left | N-1 >

C Nr of active spin-orbitals
      NASORB= IORBTAB(4)
      DYSAMP=Zero
      DO ISORB=1,NASORB
       DYSCOF(ISORB)=Zero
      END DO

C IF10 = Eliminate to the left (state 1)
      IF(IF10) THEN

C Loop over all spin orbitals ISORB:
       DO ISORB=1,NASORB
        OVLP=Zero

C Annihilate a single orbital:
        COEFF=One
        IMODE=-1
        Call FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB1,1)
        NDETS1=FSBANN1(5)
        CALL mma_allocate(ANN1,NDETS1,Label='ANN1')
        ANN1(:)=0.0D0
        CALL PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,FSBANN1,
     &                   IFSBTAB1,COEFF,ANN1,PSI1)

C Compute the coefficient as the overlap between the N-1 electron w.f.s
        OVLP=OVERLAP_RASSI(FSBANN1,
     &                  IFSBTAB2,ANN1,PSI2)
        Call mma_deallocate(ANN1)
        Call mma_deallocate(FSBANN1)
        DYSCOF(ISORB)=OVLP

C Collect the squared norm of the Dyson orbital
        DYSAMP=DYSAMP+OVLP*OVLP

       END DO ! ISORB LOOP

C IF01 = Eliminate to the right (state 2)
      ELSE IF(IF01) THEN

C Loop over all spin orbitals JSORB:
       DO JSORB=1,NASORB
         OVLP=Zero

C Annihilate a single orbital:
         COEFF=One
         IMODE=-1
         Call FSBOP(IMODE,JSORB,IORBTAB,ISSTAB,IFSBTAB2,2)
         NDETS2=FSBANN2(5)
C BRN
         CALL mma_allocate(ANN2,NDETS2,Label='ANN2')
         ANN2(:)=0.0D0
         CALL PRIMSGM(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN2,
     &                   IFSBTAB2,COEFF,ANN2,PSI2)

C Compute the coefficient as the overlap between the N-1 electron w.f.s
         OVLP=OVERLAP_RASSI(IFSBTAB1,
     &                  FSBANN2,PSI1,ANN2)
         Call mma_deallocate(ANN2)
         Call mma_deallocate(FSBANN2)
         DYSCOF(JSORB)=OVLP

C Collect the squared norm of the Dyson orbital
         DYSAMP=DYSAMP+OVLP*OVLP

       END DO ! JSORB LOOP

      ELSE
       WRITE(6,*)'Invalid state combination in MKDYSORB'
       WRITE(6,*)'(No such Dyson orbital can exist!)'

      END IF ! IF10 or IF01

C The eventual PES amplitude is given by the squared norm,
C but for transformation of the D_ij elements we need to remove the
C square for now
      DYSAMP = SQRT(DYSAMP)

      END SUBROUTINE MKDYSORB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine SIZES()

use Index_Functions, only: nTri_Elem, nTri3_Elem
use Symmetry_Info, only: Mul
use PrintLevel, only: USUAL
use SUPERINDEX, only: SUPINI
use Cholesky, only: NumCho
use EQSOLV, only: IFCOUP, NLIST, NLSTOT
use caspt2_global, only: do_csf, do_grad, do_nac, if_invar, if_invaria, if_SSDM, ipea_shift, iPrGlb, NCMO
use caspt2_module, only: IfChol, IfDW, IfMSCoup, IfProp, IfRMS, IfXMS, MxCI, nActEl, nAsh, nAshT, nASup, nBasT, nBSqT, nBTri, &
                         nCases, nConf, nFroT, nG1, nG2, nG3Tot, nIMx, nInDep, nISh, nIshT, nISup, nOrb, nOSqT, nOTri, nSMx, nSsh, &
                         nState, nSym, nTGTU, nTU, Zeta
#ifdef _DEBUGPRINT_
use caspt2_module, only: NAMX
#endif
use stdalloc, only: mma_MaxDBLE
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
#include "warnings.h"
integer(kind=iwp) :: ICASE, ICASE1, ICASE2, ISL1, ISL2, ISL3, ISYM, ISYM1, ISYM2, M, M11, M12, M21, M22, M31, MAXAIS, MC1S1DER, &
                     MC2DER, MEMBASE, MINBUF, MMX, MXLeft, MXLFT, N, NAS, NAS1, NAS2, NBOTTOM, NCH, nCLag, NCX, NDD, NEED, NEED0, &
                     NFIA, NFIT, NFTA, NG02, NG10, NG12, NG20, NG30, NGARR, ngrad, ngrad1, ngrad10, ngrad11, ngrad11_1, ngrad11_2, &
                     ngrad2, ngrad3, ngrad4, ngrad5, ngrad6, ngrad6_1, ngrad6_2, ngrad7, ngrad7_1, ngrad7_2, ngrad8, ngrad9, NIN, &
                     NIN1, NIS, NIS1, NIS2, NMKRHS, NMX, nOLag, nOMax, NPLBUF, NPoly, nPrp, nPrp1, nPrp2, nRHSP, nSgm1, nSgm2, &
                     nSigma, nSigma_inner, nSigma_outer, NSLag, nTG1, nTG2, nTG3, NumChT, nV, nVCUtil, nWLag, NX
real(kind=wp) :: XX, YY
integer(kind=iwp), external :: iParDiv
integer(kind=iwp), parameter :: Magic = 119000

! Available workspace right now:
call mma_MaxDBLE(MXLEFT)
! 250000 words margin, for various purposes.
NBOTTOM = 250000
! POLY package:
! MINBUF=Min acceptable nr of buffers in POLY3 for efficiency.
MINBUF = 1
NPOLY = NBOTTOM
! Sizes of G10,G20,G02,G12,G30: Faked, since no more used.
NG10 = 1
NG20 = 1
NG02 = 1
NG30 = 1
NG12 = 1

if (NACTEL > 0) then
  NGARR = 2*(NG10+NG20+NG02+NG30+NG12)
  NPOLY = NPOLY+NGARR+5*MXCI
  MXLFT = MXLEFT-NPOLY
  XX = Half*real(3*MXCI+3,kind=wp)
  YY = real(MXLFT,kind=wp)
  ! Allowed by memory:
  NPLBUF = int(sqrt(YY+XX**2)-XX)
  ! Preferred size for efficiency:
  NPLBUF = max(MINBUF,NPLBUF)
  ! Actual max needed in-core:
  NPLBUF = min(NPLBUF,nTri_Elem(NASHT))
  NPOLY = NPOLY+NPLBUF*(NPLBUF+3+3*MXCI)
  !write(u6,*) ' Memory requirements for POLY3 (Above SGUGA):'
  !write(u6,*) '   CI vector                      :',MXCI
  !write(u6,*) '   Extra margin for small scratch :',NBOTTOM
  !write(u6,*) '   Ten arrays G10,G20..F12        :',NGARR
  !write(u6,*) '   H0,SGM0,C1,C2                  :',4*MXCI
  !write(u6,*) '   VXYZB,TUBUF,DTUB               :',3*NPLBUF
  !write(u6,*) '   A,B1,B2                        :',3*NPLBUF*MXCI
  !write(u6,*) '   SCR                            :',NPLBUF**2
  !write(u6,*)
  !write(u6,*) ' Total, for POLY3                 :',NPOLY
  !write(u6,*)
end if

! Precompute sizes, offsets etc.
call SUPINI()

! SBMAT need:
!NG3C = 0
!do ISYM=1,NSYM
!  N = NTUV(ISYM)
!  NG3C = NG3C+nTri_Elem(N)
!end do
!NG3C = iPARDIV(NG3TOT,NG2)

! Sizes and addresses to lists:
do ISL1=1,NSYM
  do ISL3=1,NSYM
    ISL2 = Mul(ISL1,ISL3)
    NLIST(ISL1,ISL3,1) = NASH(ISL2)*NTU(ISL3)*2
    NLIST(ISL1,ISL3,2) = NLIST(ISL1,ISL3,1)
    NLIST(ISL1,ISL3,3) = NASH(ISL2)*NTU(ISL3)
    NLIST(ISL1,ISL3,4) = NASH(ISL2)*NTGTU(ISL3)*2
    NLIST(ISL1,ISL3,5) = NLIST(ISL1,ISL3,3)
    NLIST(ISL1,ISL3,6) = NLIST(ISL1,ISL3,4)
    NLIST(ISL1,ISL3,7) = NASH(ISL2)*NASH(ISL3)*2
    NLIST(ISL1,ISL3,8) = NLIST(ISL1,ISL3,7)
    NLIST(ISL1,ISL3,9) = NASH(ISL2)*NASH(ISL3)
    NLIST(ISL1,ISL3,10) = NLIST(ISL1,ISL3,9)
    if (ISL1 == 1) NLIST(ISL1,ISL3,10) = NLIST(ISL1,ISL3,10)-NASH(ISL2)
    NLIST(ISL1,ISL3,12) = NASH(ISL1)*NASH(ISL2)
    NLIST(ISL1,ISL3,13) = NLIST(ISL1,ISL3,12)
    if (ISL3 == 1) NLIST(ISL1,ISL3,13) = NLIST(ISL1,ISL3,13)-NASH(ISL1)
    NLIST(ISL1,ISL3,11) = NLIST(ISL1,ISL3,12)
    if (ISL3 == 1) NLIST(ISL1,ISL3,11) = NLIST(ISL1,ISL3,11)+NASH(ISL1)*NASHT
    NLIST(ISL1,ISL3,14) = NISH(ISL1)*NISH(ISL2)
    NLIST(ISL1,ISL3,15) = NLIST(ISL1,ISL3,14)
    if (ISL3 == 1) NLIST(ISL1,ISL3,15) = NLIST(ISL1,ISL3,15)-NISH(ISL1)
    NLIST(ISL1,ISL3,16) = NSSH(ISL1)*NSSH(ISL2)
    NLIST(ISL1,ISL3,17) = NLIST(ISL1,ISL3,16)
    if (ISL3 == 1) NLIST(ISL1,ISL3,17) = NLIST(ISL1,ISL3,17)-NSSH(ISL1)
  end do
end do
NLSTOT = 4*sum(NLIST(1:NSYM,1:NSYM,:))

! maximum orbitals in an irrep
NOMAX = maxval(NORB(1:NSYM))
if (.not. IFCHOL) then
  ! MKRHS needs:
  NMKRHS = 2*NOMAX**2
  NMX = 0
  do ICASE=1,13
    do ISYM=1,NSYM
      NIN = NINDEP(ISYM,ICASE)
      if (NIN == 0) cycle
      NAS = NASUP(ISYM,ICASE)
      NIS = NISUP(ISYM,ICASE)
      NV = NAS*NIS
      if (NV == 0) cycle
      if (ICASE > 11) then
        N = NV
      else
        N = 2*NV+nTri_Elem(NAS)
      end if
      NMX = max(N,NMX)
    end do
  end do
  NMKRHS = NMKRHS+NMX
  !if (MAXIT == 0) then
  !  NSIGMA = 0
  !else
  !  NSIGMA = NBOTTOM+NLSTOT+MMX
  !end if
else
  ! RHSALL2 and ADDRHS needs:
  NMKRHS = maxval(NASUP(1:NSYM,:)*NISUP(1:NSYM,:))
  NMKRHS = 2*iPARDIV(NMKRHS,2*NOMAX**2)
end if
NMKRHS = NMKRHS+NBOTTOM

! PCG/(new)SIGMA routine needs: twice a global array RHS size for
! transformations (overrides NSIGMA computed above)
NSIGMA_OUTER = 0
NSIGMA_INNER = 0
NVCUTIL = 0
do ICASE=1,13
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    NRHSP = iPARDIV(NAS*NIS,0)
    if (ICASE > 11) then
      NSIGMA_INNER = max(NSIGMA_INNER,NRHSP)
    else
      NSIGMA_INNER = max(NSIGMA_INNER,NAS*NIS+NRHSP)
      NSIGMA_OUTER = max(NSIGMA_OUTER,NAS*NIS+NRHSP)
    end if
    NVCUTIL = max(NVCUTIL,2*NRHSP)
  end do
end do
NSIGMA = max(NSIGMA_INNER+NSIGMA_OUTER,NVCUTIL)+NBOTTOM

! PRPCTL needs:
! In DIADNS alone, NDD words are needed:
#ifdef _DEBUGPRINT_
write(u6,*) ' Memory requirements for PRPCTL (Above SGUGA).'
write(u6,*)
write(u6,*) ' PRP1) First phase of PRPCTL.'
write(u6,*)
write(u6,*) '    A) DIADNS alone, broken up in case/symm:'
#endif
MMX = 0
do ICASE=1,13
  do ISYM=1,NSYM
    NIN = NINDEP(ISYM,ICASE)
    if (NIN == 0) cycle
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    NV = NAS*NIS
    if (NV == 0) cycle
    if (ICASE > 11) then
      M = 2*NV
    else
      M = 3*NV+nTri_Elem(NAS)
    end if
    MMX = max(M,MMX)
  end do
end do

NDD = 0
do ICASE=1,13
  do ISYM=1,NSYM
    NX = 0
    NIN = NINDEP(ISYM,ICASE)
    if (NIN > 0) then
      NIS = NISUP(ISYM,ICASE)
      if (NIS > 0) then
        NAS = NASUP(ISYM,ICASE)
#       ifdef _DEBUGPRINT_
        write(u6,*) ' Case, Symm:',ICASE,ISYM
        write(u6,*) ' NIN,NAS,NIS:',NIN,NAS,NIS
        write(u6,*) ' NIMX,NSMX:',NIMX,NAMX
#       endif
        if ((ICASE == 2) .or. (ICASE == 3)) NX = NIN*NIMX**2
        if ((ICASE == 6) .or. (ICASE == 7)) NX = NIN*NSMX*NIMX**2
        if ((ICASE == 8) .or. (ICASE == 9)) NX = NIN*NSMX**2
        if ((ICASE == 10) .or. (ICASE == 11)) NX = NIN*NIMX*NSMX**2
        if ((ICASE == 12) .or. (ICASE == 13)) NX = max(NAS*NIMX**2,NIS*NSMX**2)
      end if
    end if
#   ifdef _DEBUGPRINT_
    write(u6,'(1x,a,2i4,5x,i8)') '      Case, symm:',ICASE,ISYM,2*NX
#   endif
    NDD = max(2*NX,NDD)
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) '       DIADNS needs the maximum, or NDD=',NDD
#endif
NCMO = NBSQT
NPRP1 = NBOTTOM+NCMO+notri+NLSTOT+2*NOSQT+MMX+NDD

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) '    B) Also needed, for 1st phase of PRPCTL:'
write(u6,'(1x,a,i8)') '       NBOTTOM:',NBOTTOM
write(u6,'(1x,a,i8)') '       NCMO   :',NCMO
write(u6,'(1x,a,i8)') '       notri :',notri
write(u6,'(1x,a,i8)') '       NLSTOT :',NLSTOT
write(u6,'(1x,a,i8)') '     2*NOSQT  :',2*NOSQT
write(u6,'(1x,a,i8)') '       MMX    :',MMX
#endif
NPRP2 = NBOTTOM+2*NCMO+notri+NBAST*(NBAST+1)

#ifdef _DEBUGPRINT_
write(u6,*) ' PRP2) Second phase of PRPCTL.'
write(u6,*)
write(u6,'(1x,a,i8)') '       NBOTTOM:',NBOTTOM
write(u6,'(1x,a,i8)') '     2*NCMO   :',2*NCMO
write(u6,'(1x,a,i8)') '       notri :',notri
write(u6,'(1x,a,i8)') 'NBAST*(NBAST+1)',NBAST*(NBAST+1)
#endif

! (rough) memory estimation for gradients
! Cholesky vectors try to use all the available memory, so the
! memory used for them are not counted (as in other steps)
ngrad = 0
if (do_grad) then
  ! memory in caspt2_grad
  nCLag = nConf*nState
  nOLag = NBSQT
  NSLag = nState*nState
  nWLag = NBTRI
  ngrad1 = NBSQT*4+nCLag*2+nOLag*2+nSLag*2+nWLag+NBSQT*2+nAshT**2
  if (IFXMS .or. IFRMS) ngrad1 = ngrad1+NBSQT
  if (IFDW .and. (zeta >= Zero)) ngrad1 = ngrad1+nState
  if (do_nac) ngrad1 = ngrad1+NBSQT
  if (nFroT /= 0) ngrad1 = ngrad1+nFroT**2

  ! "base" memory in dens
  nch = 0
  !if (IfChol) nch = nvloc_chobatch(1)
  ngrad2 = NOSQT*2+NBSQT*9+2*max(nbast**2,nch)+2*nAshT**2
  if ((nFroT /= 0) .or. (.not. if_invaria)) ngrad2 = ngrad2+2*NBSQT
  if (do_csf) ngrad2 = ngrad2+NBSQT
  ngrad2 = ngrad2+nAshT**2
  if (.not. if_invaria) ngrad2 = ngrad2+nAshT**2

  membase = MXLEFT-ngrad1-ngrad2-NBOTTOM

  ! gradient: residual
  ngrad3 = NSIGMA-NBOTTOM

  ! gradient: density (trdns2o)
  ngrad4 = NDD*3/2

  ! gradient: off-diagonal derivatives (sigder)
  NFIT = sum(NASH(1:NSYM)*NISH(1:NSYM))+1
  NFIA = sum(NSSH(1:NSYM)*NISH(1:NSYM))+1
  NFTA = sum(NSSH(1:NSYM)*NASH(1:NSYM))+1

  MMX = 0
  do ICASE1=1,11
    do ISYM1=1,NSYM
      NIS1 = NISUP(ISYM1,ICASE1)
      NAS1 = NASUP(ISYM1,ICASE1)
      NIN1 = NINDEP(ISYM1,ICASE1)
      NSGM2 = NIS1*NAS1
      NSGM1 = 1
      if (ICASE1 == 1) then
        NSGM1 = NASH(ISYM1)*NISH(ISYM1)
      else if (ICASE1 == 4) then
        NSGM1 = NASH(ISYM1)*NSSH(ISYM1)
      else if ((ICASE1 == 5) .and. (ISYM1 == 1)) then
        NSGM1 = NIS1
      end if
      M11 = NSGM2+NSGM1
      M12 = 2*iPARDIV(NSGM2,0)+NSGM2
      if (ICASE1 <= 11) then
        M12 = M12+iPARDIV(max(NSGM2,nTri_Elem(NAS1)),0)
      else
        M12 = M12+iPARDIV(NSGM2,0)
      end if
      do ICASE2=ICASE1+1,NCASES
        if (IFCOUP(ICASE2,ICASE1) == 0) cycle
        do ISYM2=1,NSYM
          NIS2 = NISUP(ISYM2,ICASE2)
          NAS2 = NASUP(ISYM2,ICASE2)
          NCX = NIS2*NAS2
          ! first loop
          M21 = M11+2*iPARDIV(NCX,0)
          M31 = M11-NSGM1+iPARDIV(NCX,0)
          if (iCASE1 <= 11) then
            ! C1S1DER
            MC1S1DER = iPARDIV(NAS1*NAS1+NIN1*NIS1+NAS1*NIN1,0)
            M31 = M31+iPARDIV(NSGM2,0)+max(MC1S1DER+NAS1*NAS1,iPARDIV(NSGM2,0))
          end if

          ! second loop
          M22 = NSGM1+iPARDIV(NCX,0)
          if (ICASE2 <= 11) then
            ! C2DER
            MC2DER = iPARDIV(NAS2*(2*NIS2+max(NAS2,NIS2)),0)
            M22 = M22+NAS2*NAS2+MC2DER
          end if
          M = max(M21,M31,M12,M22)
          MMX = max(M,MMX)
        end do
      end do
    end do
  end do
  ngrad5 = NFIT*2+NFIA*2+NFTA*2+MMX

  ! gradient: CI derivatives (clagx)
  ngrad6 = NG1*4+NG2*4+NG3TOT*3
  ! CLagD (hmm, not for the A and C subspaces in parallel)
  MMX = 0
  do ICASE=1,11
    do ISYM=1,NSYM
      NIS = NISUP(ISYM,ICASE)
      NAS = NASUP(ISYM,ICASE)
      NIN = NINDEP(ISYM,ICASE)
      M = 2*NAS**2+3*NIN*NIS+NAS*NIS
      if (IFMSCOUP) M = M+NIN*NIS
      ! inside CLagDX
      M = M+2*NAS**2+NAS*min(NAS,NIS)+NAS*NIN+NIN
      select case (ICASE)
        case (1)
          M = M+nTri_Elem(NAS)+NG3TOT
        case (2,3)
          M = M+2*NASHT**4
          if (IPEA_SHIFT /= Zero) M = M+nTri_Elem(NAS)
        case (4)
          M = M+nTri_Elem(NAS)+NG3TOT
        case (5)
          if (IPEA_SHIFT /= Zero) M = M+nTri_Elem(NAS)
        case (6,7)
          if (IPEA_SHIFT /= Zero) M = M+nTri_Elem(NAS)
        case (8,9)
          if (IPEA_SHIFT /= Zero) M = M+nTri_Elem(NAS)
        case (10,11)
          if (IPEA_SHIFT /= Zero) M = M+nTri_Elem(NAS)
      end select
      MMX = max(M,MMX)
    end do
  end do
  ngrad6_1 = MMX
  ! CnstCLag (derfg3)
  ngrad6_2 = NG3TOT+NCONF
  MXLFT = membase-ngrad6-ngrad6_2
  MXLFT = min(MXCI*(3*NASHT**2+NASHT),MXLFT)
  ngrad6_2 = ngrad6_2+MXLFT
  ngrad6 = ngrad6+max(ngrad6_1,ngrad6_2)

  ! gradient: effective Hamiltonian (DerHEff)
  NTG1 = NASHT**2
  NTG2 = NASHT**4
  NTG3 = nTri3_Elem(NTG1)
  ngrad7 = NTG1+NTG2+NTG3
  ! DerHeffX
  MAXAIS = 0
  do ICASE=1,13
    do ISYM=1,NSYM
      NIS = NISUP(ISYM,ICASE)
      NAS = NASUP(ISYM,ICASE)
      NIN = NINDEP(ISYM,ICASE)
      M = 2*iPARDIV(NAS*NIS,0)
      MAXAIS = max(M,MAXAIS)
    end do
  end do
  ngrad7_1 = MAXAIS
  ! DERTG3
  ngrad7_2 = MXCI*3+2*NASHT**2
  MXLFT = membase-ngrad7-ngrad7_2
  MXLFT = min(MXCI*(2*NASHT**2+4),MXLFT)
  ngrad7_2 = ngrad7_2+MXLFT
  ngrad7 = ngrad7+max(ngrad7_1,ngrad7_2)

  ! gradient: iterative CI derivatives (DEPSAOffC)
  ngrad8 = 0
  if (.not. if_invar) ngrad8 = nConf*nState*5+nConf+nState**3+nAshT**2+nAshT**4

  ! gradient: kappa (orbital) derivatives
  !           (OLagNS_RI, OLagNS2, OLagVVVO)
  NumChT = 0
  if (IFCHOL) then
    call Get_iArray('NumCho',NumCho,nSym)
    NumChT = sum(NumCho(1:nSym))
    ngrad9 = NumChT**2+1
  else
    ngrad9 = (NISHT+NASHT)**2*NBAST**2+1
  end if

  ! gradient: state-specific density matrix
  ngrad10 = 0
  ! IFCHOL is always true
  if (if_SSDM) ngrad10 = NCONF+NumChT**2+2*nBasT**2+2*NumChT+NBSQT

  ! memory in XMS (XMS_Grad)
  ngrad11 = 0
  if (IFMSCOUP) then
    ngrad11_1 = NCONF*4+2*NASHT**2+2*NASHT**4+NASHT**6
    ngrad11_2 = 3*NASHT**2+NBSQT*4+NCONF
    ngrad11 = max(ngrad11_1,ngrad11_2)
  end if

  !! NPRP1 corresponds to trdns2d
  ngrad = NBOTTOM+ngrad1+ngrad2+max(ngrad3,ngrad4,ngrad5,ngrad6,ngrad7,ngrad8,ngrad9,ngrad10,ngrad11,NPRP1-NBOTTOM)

# ifdef _DEBUGPRINT_
  write(u6,*) ' PRP3) Gradient.'
  write(u6,*)
  write(u6,'(1x,a,i12,a)') 'NBOTTOM        :',NBOTTOM,' (essential)'
  write(u6,'(1x,a,i12,a)') 'caspt2_grad    :',ngrad1,' (essential)'
  write(u6,'(1x,a,i12,a)') 'dens           :',ngrad2,' (essential)'
  write(u6,'(1x,a,i12)') '(Part of) PRP1 :',NPRP1-NBOTTOM
  write(u6,'(1x,a,i12)') 'caspt2_res     :',ngrad3
  write(u6,'(1x,a,i12)') 'trnds2o        :',ngrad4
  write(u6,'(1x,a,i12)') 'sigder         :',ngrad5
  write(u6,'(1x,a,i12)') 'clagx          :',ngrad6
  write(u6,'(1x,a,i12)') 'derheff        :',ngrad7
  write(u6,'(1x,a,i12)') 'DEPSAOffC      :',ngrad8
  write(u6,'(1x,a,i12)') 'OLagNS/OLagVVVO:',ngrad9
  write(u6,'(1x,a,i12)') 'CnstAB_SSDM    :',ngrad10
  write(u6,'(1x,a,i12)') 'XMS_Grad       :',ngrad11
  write(u6,'(1x,a,a )') '----------------','------------'
  write(u6,'(1x,a,i12)') 'Total Estimate :',ngrad
# endif
end if

NPRP = 0
if (IFPROP .or. do_grad) NPRP = max(NPRP1,NPRP2,ngrad)
if (IPRGLB >= USUAL) then
  write(u6,'(A)') repeat('-',80)
  write(u6,*) 'Estimated memory requirements:'
  write(u6,'(a,i12)') '  POLY3 :             ',NPOLY
  write(u6,'(a,i12)') '  RHS:                ',NMKRHS
  write(u6,'(a,i12)') '  SIGMA :             ',NSIGMA
  write(u6,'(a,i12)') '  PRPCTL:             ',NPRP
  !SVC: NPRP includes NDD if it is needed, so this is confusing
  !write(u6,'(a,i12)') '  DIADNS:             ',NDD
  write(u6,'(a,i12)') ' Available workspace: ',MXLEFT
  write(u6,*)
end if

NEED0 = max(NPOLY,NMKRHS,NSIGMA)
NEED = max(NEED0,NPRP)
if (NEED > MXLEFT) then
  if (NEED0 <= MXLEFT) then
    write(u6,'(5X,A)') repeat('*',26)
    write(u6,'(5X,A)') ' Memory problem!! The memory is insufficient '
    write(u6,'(5X,A)') ' for the property section.'
    write(u6,'(5X,A,I5,A)') '* Need at least ',2+NEED/Magic,' MB *'
    if (do_grad) then
      write(u6,'(5X,A)') ' The property (including gradient) section will be skipped.'
      write(u6,'(5X,A)') ' If you cannot increase the memory, consider using numerical gradients'
      if (IFPROP) write(u6,'(5X,A)') ' (without PROPerty keyword)'
    else
      write(u6,'(5X,A)') ' The property section will be skipped.'
    end if
    write(u6,'(5X,A)') repeat('*',26)
    if (do_grad) call Quit(_RC_MEMORY_ERROR_)
    NEED = NEED0
    IFPROP = .false.
  else if (.not. IFCHOL) then
    ! not a Cholesky calculation, keep old memory requirements
    write(u6,'(5X,A)') repeat('*',26)
    write(u6,'(5X,A)') '* Insufficient memory !! *'
    write(u6,'(5X,A,I5,A)') '* Need at least ',2+NEED0/Magic,' MB *'
    write(u6,'(5X,A)') repeat('*',26)
    write(u6,*)
    write(u6,*) ' Program execution stops -- sorry!'
    write(u6,*)
    call Quit(_RC_MEMORY_ERROR_)
  else if (max(NPOLY,NSIGMA) <= MXLEFT) then
    ! This is a Cholesky calculation, only give recommended amount
    write(u6,'(5X,A)') repeat('*',40)
    write(u6,'(5X,A,I5,A)') '* Below comfortable memory of ',2+NEED0/Magic,' MB *'
    write(u6,'(5X,A)') repeat('*',40)
    write(u6,*)
    write(u6,*) ' Program will try to adapt'
    write(u6,*) ' If it fails, please raise the memory to at least',2+max(NPOLY,int(0.55_wp*NMKRHS),NSIGMA)/Magic,' MB'
    write(u6,*) ' (Maybe more, this aint rocket science)'
    write(u6,*)
    write(u6,*) ' With print level DEBUG you will get some more'
    write(u6,*) ' informative memory estimates during computation'
    write(u6,*)
  else
    write(u6,'(5X,A)') repeat('*',26)
    write(u6,'(5X,A)') '* Insufficient memory... *'
    write(u6,'(5X,A)') repeat('*',26)
    write(u6,*)
    write(u6,'(A,I6,A)') ' If possible, I would like to have   ',NEED0/Magic,' MB'
    write(u6,'(A,I6,A)') ' Please raise the memory to at least ',max(NPOLY,int(0.55_wp*NMKRHS),NSIGMA)/Magic,' MB'
    write(u6,*) ' (Maybe more, this aint rocket science)'
    write(u6,*)
    call Quit(_RC_MEMORY_ERROR_)
  end if
end if

end subroutine SIZES

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Dstncs(Lbls,xyz,mCentr,Angstr,Max_Center,iCols)
!***********************************************************************
!                                                                      *
! Object: to compute distances from a coordinate list                  *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Three
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mCentr, Max_Center, iCols
character(len=LenIn), intent(in) :: Lbls(mCentr)
real(kind=wp), intent(in) :: xyz(3,mCentr), Angstr
integer(kind=iwp) :: i, iC, iCC, ii, iiBst, IsFirst, jC, jCC, MoreToGo
real(kind=wp) :: Fact, r, rr, Thr_D, Thr_R, x1, x2, y1, y2, z1, z2
integer(kind=iwp), allocatable :: iBST(:,:)
real(kind=wp), allocatable :: BST(:)

if (mCentr <= Max_Center) then

  do i=1,2
    write(u6,*)
    if (i == 1) then
      Fact = One
      write(u6,'(19X,A)') ' *************************************** '
      write(u6,'(19X,A)') ' *    InterNuclear Distances / bohr    * '
      write(u6,'(19X,A)') ' *************************************** '
    else
      Fact = Angstr
      write(u6,'(19X,A)') ' ******************************************* '
      write(u6,'(19X,A)') ' *    InterNuclear Distances / angstrom    * '
      write(u6,'(19X,A)') ' ******************************************* '
    end if
    do icc=1,mCentr,iCols
      write(u6,*)
      if (iCols == 6) write(u6,'( 9X,6(5X,I2,1X,A,2X))') (ic,Lbls(ic),ic=icc,min(icc+5,mCentr))
      if (iCols == 5) write(u6,'( 9X,5(5X,I2,1X,A,2X))') (ic,Lbls(ic),ic=icc,min(icc+4,mCentr))

      do jc=icc,mCentr
        x1 = xyz(1,jc)
        y1 = xyz(2,jc)
        z1 = xyz(3,jc)
        if (iCols == 6) &
          write(u6,101) jc,Lbls(jc),(Fact*sqrt((xyz(1,ic)-x1)**2+(xyz(2,ic)-y1)**2+(xyz(3,ic)-z1)**2),ic=icc,min(jc,icc+5,mCentr))
        if (iCols == 5) &
          write(u6,102) jc,Lbls(jc),(Fact*sqrt((xyz(1,ic)-x1)**2+(xyz(2,ic)-y1)**2+(xyz(3,ic)-z1)**2),ic=icc,min(jc,icc+4,mCentr))
      end do
    end do
  end do
  return
else

  write(u6,*)
  write(u6,'(19X,A)') ' ************************************************* '
  write(u6,'(19X,A)') ' **** InterNuclear Distances / bohr, angstrom **** '
  write(u6,'(19X,A)') ' ************************************************* '
  write(u6,*)
  write(u6,'(A)') '     Atom centers         bohr        angstrom'

  !VV Set .false. to get faster printing without sorting.

  if (.true.) then
    Thr_R = (Three/Angstr)**2
    Thr_D = 1.0e-4_wp
    call mma_allocate(BST,mCentr**2,Label='BST')
    call mma_allocate(iBST,2,mCentr**2,Label='iBST')
    iiBST = 0
    do icc=1,mCentr
      x1 = xyz(1,icc)
      y1 = xyz(2,icc)
      z1 = xyz(3,icc)
      do jcc=1,icc-1
        x2 = xyz(1,jcc)
        y2 = xyz(2,jcc)
        z2 = xyz(3,jcc)
        R = (x2-x1)**2+(y2-y1)**2+(z2-z1)**2
        if (R <= Thr_R) then
          iiBST = iiBST+1
          BST(iiBST) = R
          iBST(1,iiBST) = icc
          iBST(2,iiBST) = jcc
        end if
      end do
    end do
#   ifdef _DEBUGPRINT_
    do ii=1,iiBST
      R = sqrt(BST(ii))
      write(u6,'(2(I5,1X,A4),2(F10.6,6X))') iBST(1,ii),Lbls(iBST(1,ii)),iBST(2,ii),Lbls(iBST(2,ii)),R,R*Angstr
    end do
#   endif
    MoreToGo = 1
    do while (MoreToGo == 1)

      ! Find the shortest distance between any atoms

      R = 100.0_wp
      do ii=1,iiBST
        R = min(R,BST(ii))
      end do

      if (R > 90.0_wp) exit

      moretogo = 0
      isfirst = 1
      do ii=1,iiBST

        if (abs(R-BST(ii)) < Thr_D) then
          if (isfirst == 1) then
            RR = sqrt(R)
            write(u6,'(2(I5,1X,A),2(F10.6,6X))') iBST(1,ii),Lbls(iBST(1,ii)),iBST(2,ii),Lbls(iBST(2,ii)),RR,RR*Angstr
            isfirst = 0
          else
            write(u6,'(2(I5,1X,A),2(F10.6,6X))') iBST(1,ii),Lbls(iBST(1,ii)),iBST(2,ii),Lbls(iBST(2,ii))
          end if
          BST(ii) = 100.0_wp ! Effectively remove from the list
          moretogo = 1
        end if
      end do
    end do
    call mma_deallocate(iBST)
    call mma_deallocate(BST)

  else

    Thr_R = Three
    do icc=1,mCentr
      x1 = xyz(1,icc)
      y1 = xyz(2,icc)
      z1 = xyz(3,icc)
      do jcc=1,icc-1
        x2 = xyz(1,jcc)
        y2 = xyz(2,jcc)
        z2 = xyz(3,jcc)
        R = sqrt((x2-x1)**2+(y2-y1)**2+(z2-z1)**2)
        if (R*Angstr <= Thr_R) write(u6,'(2(I5,1X,A),2(F10.6,6X))') icc,Lbls(icc),jcc,Lbls(jcc),R,R*Angstr
      end do
    end do
  end if
end if

return

101 format (I5,1X,A,1X,6(F10.6,6X))
102 format (I5,1X,A,1X,5(F10.6,6X))

end subroutine Dstncs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Sq2Tri
*
*> @brief
*>   Convert from square to lower triangular storage
*> @author Thomas Bondo Pedersen
*>
*> @param[in]  Sq  Square storage array
*> @param[out] Tri Lower triangular storage array
*> @param[in]  n   Dimension
*>
*> @details
*> Perform the extraction
*>
*> \code
*> Tri(i*(i-1)/2+j) = Sq(i,j)
*> \endcode
*>
*> where \c i &ge; \c j.
************************************************************************
      SubRoutine Sq2Tri(Sq,Tri,n)
      Implicit None
      Integer n
      Real*8  Sq(n,n), Tri(n*(n+1)/2)

      Integer i,j, iTri

      iTri(i,j)=i*(i-1)/2 + j

      Do j = 1,n
         Do i = j,n
            Tri(iTri(i,j)) = Sq(i,j)
         End Do
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Leon Freitag                                     *
!               2017, Stefan Knecht                                    *
!***********************************************************************
!***************
! This is the wrapper for Celestino Angeli's NEVPT2 code, modified for
! DMRG and Cholesky support
! Author: Leon Freitag, ETH Zurich
! last modifications: S. Knecht, ETH Zurich, August 2017
!***************

subroutine nevpt2(iReturn)

use koopro4QD, only: koopro4qd_driver
use qdnevpt_core, only: qdnevpt
use nevpt2wfn, only: nevpt2wfn_estore                                  ! wfn file
use nevpt_header, only: print_nevpt_header                             ! header
use nevpt2_cfg, only: do_dmrg_pt, no_pc, nr_states, skip_koopro_molcas ! input variables
use info_state_energy, only: e2en, e2mp                                ! energies
use Para_Info, only: King
use Definitions, only: iwp, u6, r4

implicit none
integer(kind=iwp), intent(out) :: iReturn
logical(kind=iwp) :: nevpth5_exists = .true.
character(len=256) :: refwfnfile
! dummy variables for the koopro4QD call
real(kind=r4) :: t13
logical(kind=iwp), parameter :: rel_ham = .false., from_molcas = .true.

! Make sure we run single-threaded in an MPI environment

if (KING()) then
  !> initialize
  refwfnfile = ''

  !> print NEVPT2 header
  do_dmrg_pt = .true.
  call print_nevpt_header(rel_ham)
  call xflush(u6)

  !> read and process input
  call rdinput(refwfnfile)
  call xflush(u6)

  !> read and process input
  call pt2init(refwfnfile)
  call xflush(u6)

  if (.not. skip_koopro_molcas) then
    write(u6,'(/a )') ' Calculating the Koopmans'' matrices'
    write(u6,'( a )') ' ----------------------------------'
    call koopro4QD_driver(rel_ham,t13,from_molcas)
    call xflush(u6)
  else
    write(u6,*) 'Skipping the calculation of Koopmans'' matrices.'
    call f_inquire('nevpt.h5', nevpth5_exists)
    if (.not. nevpth5_exists) then
      call WarningMessage(1,'Requested to skip the Koopmans'' matrix calculation step but nevpt.h5 file not found!')
      call Abend()
    end if
  end if
  write(u6,'(/a )') ' Starting NEVPT2 perturbation summation'
  write(u6,'( a )') ' --------------------------------------'
  call qdnevpt(rel_ham,t13,from_molcas)
  call xflush(u6)

  !> store the PT2 energy and effective hamiltonian on the wavefunction file
  call nevpt2wfn_estore()

  ! Test verification, a tolerance of 10^-6 is assumed for the test
  call Add_Info('E_SC_NEVPT2',e2mp,nr_states,6)
  if (.not. no_pc) then
    call Add_Info('E_PC_NEVPT2',e2en,nr_states,6)
  end if

  !> clean up and free memory
  call pt2close()
end if
iReturn = 0

end subroutine nevpt2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

!#define _DEBUGPRINT_
!#define _SPECIAL_DEBUGPRINT_
subroutine OccDef(Occ,mmB,nD,CMO,mBB)

#include "compiler_features.h"

use InfSCF, only: kOV, mOV, nBas, nFro, nnb, nOcc, nOrb, nOV, nSym, OccSet_e, OccSet_m, OnlyProp, OrbType
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: mmB, nD, mBB
real(kind=wp), intent(out) :: Occ(mmB,nD)
real(kind=wp), target, intent(inout) :: CMO(mBB,nD)
integer(kind=iwp) :: iD, iOcc, iOff, iOrb, iSym, iTmp, jEOr, jOff, jOrb, MaxnOcc, MinnOcc, mOcc, mSet, Muon_i, nB, nOcc_e, nOcc_m
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif
real(kind=wp) :: Tmp
integer(kind=iwp), allocatable :: iFerm(:)
real(kind=wp), allocatable :: OccTmp(:)
real(kind=wp), pointer :: pCMO(:,:)

! Form occupation numbers
!
! Note, this puts only in the occupation numbers of the electronic
! orbitals. The muonic occupation numbers are put in place in
! NewOrb_Scf on the first iteration.

if (OnlyProp) return

#ifdef _DEBUGPRINT_
do iD=1,nD
  write(u6,*) 'iD=',iD
  write(u6,'(a,8i5)') 'sorb: nOcc   ',(nOcc(i,iD),i=1,nSym)
end do
if (allocated(OccSet_e)) then
  do iD=1,nD
    write(u6,*) 'iD=',iD
    iOff = 1
    do iSym=1,nSym
      call RecPrt('OccSet_e',' ',OccSet_e(iOff,iD),1,nOcc(iSym,iD))
      iOff = iOff+nOcc(iSym,iD)
    end do
  end do
end if
if (allocated(OccSet_m)) then
  do iD=1,nD
    write(u6,*) 'iD=',iD
    iOff = 1
    do iSym=1,nSym
      call RecPrt('OccSet_m',' ',OccSet_m(iOff,iD),1,nOcc(iSym,iD))
      iOff = iOff+nOcc(iSym,iD)
    end do
  end do
end if
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! First we set up the electronic occupation numbers either as
! by default or as specied by the user. The numbers are stored
! in the array Occ.

Occ(:,:) = Zero

if (.not. allocated(OccSet_e)) then

  ! Default is that occupied orbitals are set to 2 and 1
  ! for RHF and UHF, respectively.

  do iD=1,nD
    mOcc = 0
    do iSym=1,nSym
      Occ(mOcc+1:mOcc+nOcc(iSym,iD),iD) = real(3-nD,kind=wp) ! Value 2 or 1
      mOcc = mOcc+nOrb(iSym)
    end do
  end do

else

  ! User define occupation numbers according to the OCCN key word.

  do iD=1,nD
    mOcc = 0
    mSet = 0
    do iSym=1,nSym
      Occ(mOcc+1:mOcc+nOcc(iSym,iD),iD) = OccSet_e(mSet+1:mSet+nOcc(iSym,iD),iD)
      mOcc = mOcc+nOrb(iSym)
      mSet = mSet+nOcc(iSym,iD)
    end do
  end do
  call mma_deallocate(OccSet_e)

end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Here we put in the occupations from the muons

! Here we will have to run through the orbitals and identify
! if the orbitals are muonic or electronic. As we proceed we
! will fill up the vector with the occupation number from
! the list of either muonic or electronic occupation numbers.

if (allocated(OccSet_m)) then

  call mma_Allocate(OccTmp,mmB,Label='OccTmp')
  call mma_allocate(iFerm,nnB,Label='iFerm')
  call Get_iArray('Fermion IDs',iFerm,nnB)
  !write(u6,*) 'iFerm=',iFerm

  do iD=1,nD

    ! Store the electronic occupation numbers in OccTmp

    OccTmp(:) = Occ(:,iD)
    !write(u6,*) 'OccTmp=',OccTmp
    !write(u6,*) 'Occset_m=',Occset_m
    Occ(:,iD) = Zero

    nOcc_e = 0   ! number of occupied electronic orbitals
    nOcc_m = 0   ! number of occupied muonic orbitals
    iOff = 1     ! Offset to the symmetry sections of CMO
    jEOr = 0     ! Offset to the array with occupation numbers
    do iSym=1,nSym

      ! map the relevant portion of CMO onto pCMO

      nB = nBas(iSym)
      pCMO(1:nB,1:nB) => CMO(iOff:iOff+nB**2-1,iD)

      do iOrb=1,nOrb(iSym)  ! Loop over the orbitals

        ! Compute identifier which is different from zero
        ! if the orbital is muonic.

        tmp = Zero
        tmp = sum(real(iFerm(jEOr+1:jEOr+nB),kind=wp)*abs(pCMO(1:nB,iOrb)))
        Muon_i = 0                  ! electronic
        if (tmp /= Zero) Muon_i = 1 ! muonic

        if (Muon_i == 0) then

          ! The orbital is electronic, put in an
          ! electronic occupation number. If the index
          ! is beyond the number of occupied orbitals
          ! put in a Zero.

          nOcc_e = nOcc_e+1
          if (nOcc_e <= nOcc(iSym,iD)) then
            Occ(jEor+iOrb,iD) = OccTmp(jEOr+nOcc_e)
          else
            Occ(jEor+iOrb,iD) = Zero
          end if
          !write(u6,*) 'Electronic:',iOrb,Occ(jEOr+iOrb,iD)

        else if (Muon_i == 1) then

          ! The orbital is muonic, put in an
          ! muonic occupation number. If the index
          ! is beyond the number of occupied orbitals
          ! put in a Zero.

          nOcc_m = nOcc_m+1
          if (nOcc_m <= nOcc(iSym,id)) then
            Occ(jEor+iOrb,iD) = OccSet_m(jEOr+nOcc_m,iD)
          else
            Occ(jEor+iOrb,iD) = Zero
          end if
          OrbType(jEor+iOrb,iD) = 1
          !write(u6,*) 'Muonic:',iOrb,Occ(jEOr+iOrb,iD)

        end if

      end do

      nullify(pCMO)
      iOff = iOff+nB**2
      jEOr = jEOr+nOrb(iSym)
    end do ! iSym

  end do   ! iD
# ifdef _SPECIAL_DEBUGPRINT_
  call DebugCMO(CMO,mBB,nD,Occ,mmB,nBas,nOrb,nSym,iFerm,'@ the last position')
# endif
  call mma_deallocate(iFerm)
  call mma_deAllocate(OccTmp)
  call mma_deallocate(OccSet_m)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Finally we will have to resort the orbitals with respect to their
! occupation numbers such that the orbitals which are formally in
! the occupied space but which are empty are reassigned to being
! virtual orbitals.
!
! This means that the the CMO and Occ arrays will be resorted, and
! that the nOcc array will be updated with respect to the actual
! number of orbitals with occupation different from zero, i.e.
! they are virtual.

do iD=1,nD
# ifdef _DEBUGPRINT_
  write(u6,*) 'iD=',iD
  write(u6,*) 'nOccs(original):'
  write(u6,*) (nOcc(iSym,iD),iSym=1,nSym)
  write(u6,*) 'nOV=',nOV
# endif
  iOff = 1
  jOff = 0

  do iSym=1,nSym

    if (nOrb(iSym) == 0) cycle
    iOcc = 0
    do iOrb=1,nOrb(iSym)-1
      jOrb = iOrb+1
      if ((Occ(iOrb+jOff,iD) == Zero) .and. (Occ(jOrb+jOff,iD) > Occ(iOrb+jOff,iD))) then

        iTmp = OrbType(iOrb+jOff,iD)
        OrbType(iOrb+jOff,iD) = OrbType(jOrb+jOff,iD)
        OrbType(jOrb+jOff,iD) = iTmp

        Tmp = Occ(iOrb+jOff,iD)
        Occ(iOrb+jOff,iD) = Occ(jOrb+jOff,iD)
        Occ(jOrb+jOff,iD) = Tmp
        call DSwap_(nBas(iSym),CMO(iOff+(iOrb-1)*nBas(iSym),iD),1,CMO(iOff+(jOrb-1)*nBas(iSym),iD),1)
      end if
      if (Occ(iOrb+jOff,iD) /= Zero) iOcc = iOcc+1
    end do
    if (Occ(nOrb(iSym)+jOff,iD) /= Zero) iOcc = iOcc+1
    nOcc(iSym,iD) = iOcc

    jOff = jOff+nOrb(iSym)
    iOff = iOff+nBas(iSym)*nOrb(iSym)
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) 'iD=',iD
  write(u6,*) 'nOccs(new):'
  write(u6,*) (nOcc(iSym,iD),iSym=1,nSym)
# endif
end do

! Sort such that the occupied orbitals are first in each irrep.

call Sorb2CMOs(CMO,mBB,nD,Occ,mmB,nBas,nOrb,nSym,OrbType)
!                                                                      *
!***********************************************************************
!                                                                      *
! Recompute sizes since the nOcc array might have changed.

nOV = 0
mOV = 0
kOV(:) = 0
do iSym=1,nSym
  if (nD == 1) then
    maxnOcc = nOcc(iSym,1)
    minnOcc = nOcc(iSym,1)
  else
    maxnOcc = max(nOcc(iSym,1),nOcc(iSym,2))
    minnOcc = min(nOcc(iSym,1),nOcc(iSym,2))
  end if
  kOV(:) = kOV(:)+(nOcc(iSym,:)-nFro(iSym))*(nOrb(iSym)-nOcc(iSym,:))
  nOV = nOV+(maxnOcc-nFro(iSym))*(nOrb(iSym)-minnOcc)
end do
mOV = kOV(1)+kOV(2)
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
do iD=1,nD
  iOff = 1
  jOff = 1
  do iSym=1,nSym
    call RecPrt('Occ','(10F6.2)',Occ(iOff,iD),1,nOrb(iSym))
    call RecPrt('CMO','(10F6.2)',CMO(jOff,iD),nBas(iSym),nOrb(iSym))
    do i=0,nOrb(iSym)-1
      write(u6,*) 'i,OrbType=',i+1,OrbType(iOff+i,iD)
    end do
    iOff = iOff+nOrb(iSym)
    jOff = jOff+nOrb(iSym)*nBas(iSym)
  end do
end do
#endif

return

#ifdef _SPECIAL_DEBUGPRINT_
contains

subroutine DebugCMO(CMO,nCMO,nD,Occ,nnB,nBas,nOrb,nSym,iFerm,Label)

  use Definitions, only: u6

  integer(kind=iwp), intent(in) :: nCMO, nD, nnB, nSym, nBas(nSym), nOrb(nSym), iFerm(nnB)
  real(kind=wp), intent(in) :: CMO(nCMO,nD), Occ(nnB,nD)
  character(len=*) :: Label
  integer(kind=iwp) :: iD, iOff, iOrb, iSym, jOff
  real(kind=wp) :: tmp

  write(u6,*) Label
  do iD=1,nD
    write(u6,*)
    if (iD == 1) then
      if (nD == 1) then
        write(u6,*) ' RHF CMOs'
      else
        write(u6,*) ' UHF alpha CMOs'
      end if
    else
      write(u6,*) ' UHF beta CMOs'
    end if
    write(u6,*)
    jOff = 0
    iOff = 1
    do iSym=1,nSym
      do iOrb=1,nOrb(iSym)
        tmp = sum(real(iFerm(jOff+1:jOff+nBas(iSym)-1),kind=wp)*abs(CMO(iOff+(iOrb-1)*nBas(iSym):iOff+iOrb*nBas(iSym),iD))
        write(u6,*)
        if (tmp /= Zero) then
          write(u6,*) 'Muonic Orbital:',iOrb
        else
          write(u6,*) 'Electronic  Orbital:',iOrb
        end if
        write(u6,*) 'Occupation number:',Occ(jOff+iOrb,iD)
        call RecPrt('CMO',' ',CMO(iOff+(iOrb-1)*nBas(iSym),iD),1,nBas(iSym))
      end do
      jOff = jOff+nOrb(iSym)
      iOff = iOff+nBas(iSym)*nOrb(iSym)
    end do
  end do

  return

end subroutine DebugCMO
#endif

#undef _DEBUGPRINT_
end subroutine OccDef

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SOAdpt(AOValue,mAO,nCoor,mBas,
     &                  nCmp,nOp,SOValue,nDeg,iAO)
      use Symmetry_Info, only: nIrrep, iChTbl
      use SOAO_Info, only: iAOtSO
      use Basis_Info, only: MolWgh
      Implicit Real*8 (a-h,o-z)
#include "print.fh"
#include "real.fh"
      Real*8 AOValue(mAO,nCoor,mBas,nCmp),
     &       SOValue(mAO,nCoor,mBas,nCmp*nDeg), Aux(8)
      Integer   iTwoj(0:7)
      Character*80 Label
      Data iTwoj/1,2,4,8,16,32,64,128/
*
      iRout=133
      iPrint=nPrint(iRout)
*     Call GetMem('SOAdpt_E','CHEC','REAL',iDum,iDum)
*
      If (MolWgh.eq.0) Then
         Fact=One/DBLE(nDeg)
      Else If (MolWgh.eq.1) Then
         Fact=One
      Else
         Fact=One/Sqrt(DBLE(nDeg))
      End If
      iSO=1
      Do i1 = 1, nCmp
         iaux=0
         Do j1 = 0, nIrrep-1
            If (iAOtSO(iAO+i1,j1)<0) Cycle
            iaux=iaux+1
            xa= DBLE(iChTbl(j1,nOp))
            Aux(iAux)=Fact*xa
         End Do
         If (iPrint.ge.49) Call RecPrt('Aux',' ',Aux,1,iAux)
         Call DnaXpY(iAux,mAO*nCoor*mBas,Aux,1,
     &               AOValue(1,1,1,i1),1,0,
     &               SOValue(1,1,1,iSO),1,mAO*nCoor*mBas)
         iSO=iSO+iAux
      End Do
*
      If (iPrint.ge.49) Then
         Do iCmp = 1, nCmp*nDeg
            Write (Label,'(A,I2,A)') 'SOValue(mAO,nCoor,mBas,',iCmp,')'
            Call RecPrt(Label,' ',SOValue(1,1,1,iCmp),mAO*nCoor,mBas)
         End Do
      End If
*
*     Call GetMem('SOAdpt_X','CHEC','REAL',iDum,iDum)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_PUTVEC(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM)
!
! Purpose: write Cholesky vectors IVEC=IVEC1,...,IVEC1+NUMVEC-1
!          of symmetry ISYM to file.

use Cholesky, only: Cho_AdrVec, Cho_Real_Par, InfVec, LuCho, LuPri, MaxVec, nnBstR, nSym
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: LENVEC, NUMVEC, IVEC1, ISYM
real(kind=wp), intent(_IN_) :: CHOVEC(LENVEC,NUMVEC)
integer(kind=iwp) :: IADR, IADR2, IOPT, IVEC, IVEC2, JADR, JVEC, LTOT
real(kind=wp) :: XNRM
logical(kind=iwp) :: CHK_OVERFLOW
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_PUTVEC'
real(kind=wp), external :: ddot_

CHK_OVERFLOW = .not. Cho_Real_Par

! Return if no vectors.
! ---------------------

if (NUMVEC < 1) then
  if (LOCDBG) then
    write(LUPRI,*) SECNAM,': WARNING: no vectors in this call!'
    write(LUPRI,*) SECNAM,': NUMVEC = ',NUMVEC
  end if
  return
end if

! Check vector dimension: should be the same as current reduced set.
! ------------------------------------------------------------------

if (LENVEC /= NNBSTR(ISYM,2)) then
  call CHO_QUIT('Illegal vector dimension in '//SECNAM,104)
end if
if (LENVEC < 1) then
  if (LOCDBG) then
    write(LUPRI,*) SECNAM,': WARNING: negative vector dimension'
    write(LUPRI,*) SECNAM,': LENVEC = ',LENVEC
  end if
  return
end if

! Check symmetry.
! ---------------

if ((ISYM < 1) .or. (ISYM > NSYM)) then
  write(LUPRI,*) SECNAM,': symmetry out of bounds'
  write(LUPRI,*) 'ISYM = ',ISYM
  call CHO_QUIT('Symmetry out of bounds in '//SECNAM,104)
end if

! Check vector index.
! -------------------

IVEC2 = IVEC1+NUMVEC-1
if ((IVEC1 < 1) .or. (IVEC1 > MAXVEC) .or. (IVEC2 < 1) .or. (IVEC2 > MAXVEC)) then
  write(LUPRI,*) SECNAM,': vector index out of bounds'
  write(LUPRI,*) 'IVEC1 = ',IVEC1,' IVEC2 = ',IVEC2
  write(LUPRI,*) '...must be between 1 and ',MAXVEC
  call CHO_QUIT('Vector index out of bounds in '//SECNAM,104)
end if

! Check for overflow for WA file addressing.
! ------------------------------------------

if (CHK_OVERFLOW .and. (CHO_ADRVEC == 1)) then
  IADR2 = INFVEC(IVEC2,4,ISYM)
  if (INFVEC(IVEC1,4,ISYM) < 0) then
    write(LUPRI,*) 'Error in ',SECNAM,':'
    write(LUPRI,*) 'Illegal disk address for first vector: ',INFVEC(IVEC1,4,ISYM)
    if (INFVEC(IVEC1,4,ISYM) < -1) write(LUPRI,*) '....is it an overflow?'
    write(LUPRI,*) 'IVEC1 = ',IVEC1,' ISYM = ',ISYM
    call CHO_QUIT('Illegal disk address in '//SECNAM,104)
  else if (IADR2 < INFVEC(IVEC1,4,ISYM)) then
    write(LUPRI,*) 'Error in ',SECNAM,':'
    write(LUPRI,*) 'Illegal disk address for last vector: ',IADR2
    if (IADR2 < -1) write(LUPRI,*) '....is it an overflow?'
    write(LUPRI,*) 'IVEC2 = ',IVEC2,' ISYM = ',ISYM
    call CHO_QUIT('Illegal disk address in '//SECNAM,104)
  end if
end if

! Call the low-level I/O routines.
! CHO_ADRVEC=1: WA files.
! CHO_ADRVEC=2: DA files.
! Set (next) disk addresses.
! --------------------------------

if (CHO_ADRVEC == 1) then
  IOPT = 1  ! synchronous write option
  LTOT = LENVEC*NUMVEC
  IADR = INFVEC(IVEC1,3,ISYM)
  call DDAFILE(LUCHO(ISYM),IOPT,CHOVEC,LTOT,IADR)
  do IVEC=1,NUMVEC-1
    JVEC = IVEC1+IVEC-1
    INFVEC(JVEC+1,3,ISYM) = INFVEC(JVEC,3,ISYM)+LENVEC
  end do
  IVEC = NUMVEC
  JVEC = IVEC1+IVEC-1
  IADR = INFVEC(JVEC,3,ISYM)
  if (JVEC < MAXVEC) INFVEC(JVEC+1,3,ISYM) = INFVEC(JVEC,3,ISYM)+LENVEC
else if (CHO_ADRVEC == 2) then
  IOPT = 1  ! synchronous write option
  LTOT = LENVEC
  do IVEC=1,NUMVEC-1
    JVEC = IVEC1+IVEC-1
    IADR = INFVEC(JVEC,3,ISYM)
    call DDAFILE(LUCHO(ISYM),IOPT,CHOVEC(1,IVEC),LTOT,IADR)
    INFVEC(JVEC+1,3,ISYM) = IADR
  end do
  IVEC = NUMVEC
  JVEC = IVEC1+IVEC-1
  IADR = INFVEC(JVEC,3,ISYM)
  call DDAFILE(LUCHO(ISYM),IOPT,CHOVEC(1,IVEC),LTOT,IADR)
  if (JVEC < MAXVEC) INFVEC(JVEC+1,3,ISYM) = IADR
else
  call CHO_QUIT('CHO_ADRVEC out of bounds in '//SECNAM,102)
end if

! Debug stuff.
! ------------

if (LOCDBG) then
  write(LUPRI,*)
  write(LUPRI,*) SECNAM,':'
  write(LUPRI,*) 'Vectors ',IVEC1,' to ',IVEC1+NUMVEC-1,' of symmetry ',ISYM,' written to unit ',LUCHO(ISYM)
  write(LUPRI,*) 'Vector dimension: ',LENVEC
  do IVEC=1,NUMVEC
    JVEC = IVEC1+IVEC-1
    JADR = INFVEC(JVEC,3,ISYM)
    XNRM = sqrt(DDOT_(LENVEC,CHOVEC(1,IVEC),1,CHOVEC(1,IVEC),1))
    write(LUPRI,*) 'Vector:',JVEC,' address: ',JADR,' norm: ',XNRM
  end do
end if

end subroutine CHO_PUTVEC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Jeppe Olsen                                      *
*               2011, Giovanni Li Manni                                *
************************************************************************
      SUBROUTINE CHECK_BLOCKS_FOR_BK_APPROX(
     &           IATP,IBTP,JATP,JBTP,
     &           IASM,IBSM,JASM,JBSM,
     &           IOCTPA,IOCTPB,I_DO_EXACT_BLOCK)
*. Check whether block <IATP, IBTP! H! JATP, JBTP> should
* be calculated exactly or by BK approx
*. Input
* ======
* IATP IBTP JATP JBTP : Supergroups (relative numbers)
* IOCTPA, IOBTPB : Offset for type
*. Output
* ======
* I_DO_EXACT_BLOCK = 1 => Do exact block
*                  = 0 => Set block to zero
*                  =-1 => Use diagonal aproximation
* Giovanni +Jeppe Olsen, Sept 2011, on a bench at Torre Normanna, Sicily
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "bk_approx.fh"
*. Local
      INTEGER IOCC(MXPNGAS), JOCC(MXPNGAS)
      NTEST = 000

      IONE = 1
      IOCTPA=IBSPGPFTP(1)
      IOCTPB=IBSPGPFTP(2)
      if(ntest.ge.100) then
        write(6,*) 'IOCTPA, IOCTPB', IOCTPA, IOCTPB
        write(6,*) 'IATP,IBTP,JATP,JBTP'
        write(6,'(5x,I4,5x,I4,5x,I4,5X,I4)') IATP,IBTP,JATP,JBTP
        write(6,*)  'NELFSPGP (IA), (IB), (JA), (JB)'
        write(6,*) (NELFSPGP(igas,IOCTPA-1+IATP),igas=1,NGAS)
        write(6,*) (NELFSPGP(igas,IOCTPB-1+IBTP),igas=1,NGAS)
        write(6,*) (NELFSPGP(igas,IOCTPA-1+JATP),igas=1,NGAS)
        write(6,*) (NELFSPGP(igas,IOCTPB-1+JBTP),igas=1,NGAS)
      end if
      CALL IVCSUM(IOCC,
     &     NELFSPGP(1,IOCTPA-1+IATP),NELFSPGP(1,IOCTPB-1+IBTP),
     &     IONE,IONE,NGAS)
      CALL IVCSUM(JOCC,
     &     NELFSPGP(1,IOCTPA-1+JATP),NELFSPGP(1,IOCTPB-1+JBTP),
     &     IONE,IONE,NGAS)
        if(ntest.ge.100) then
          write(6,*) ' Routine CHECK_BLOCKS_FOR_BK_APPROX is speaking! '
          write(6,*) ' I am doing BK-type of approximation '
          write(6,*) ' Min and Max for subspace with exact Hamiltonian '
          write(6,*) ' =============================================== '
          write(6,*) 'NGASBK : ',NGASBK
          write(6,*) '              Min. Occ.      Max. Occ.           '
          Do IGAS = 1, NGASBK
            write(6,'(A,I2,10X,I3,9X,I3)')
     &      '   GAS',IGAS,IOCCPSPC(IGAS,1),IOCCPSPC(IGAS,2)
          End do
         end if
*
      IOCC_IN = ICHECK_OCC_IN_ACCSPC(IOCC,IOCCPSPC,NGASBK,20)
      JOCC_IN = ICHECK_OCC_IN_ACCSPC(JOCC,IOCCPSPC,NGASBK,20)
* = 1 if the Occupation is IN
* = 0 of the Occupation is OUT
*. If both occupation are outside of IOCCPSPC, we make approximations
      IF(IOCC_IN.EQ.0.AND.JOCC_IN.EQ.0) THEN
*. If the blocks are identical use diagonal approximation
        IF(IATP.EQ.JATP.AND.IASM.EQ.JASM.AND.
     &     IBTP.EQ.JBTP.AND.IBSM.EQ.JBSM) THEN
*. Compute as diagonal
           I_DO_EXACT_BLOCK = -1
        ELSE
*. Neglect
           I_DO_EXACT_BLOCK =  0
        END IF
      ELSE
*. Atleast one block is in PSPC, so calculate exactly
        I_DO_EXACT_BLOCK = 1
      END IF
*
      IF(NTEST.GE.10) THEN
       WRITE(6,*)  ' CHECK_BLOCKS_FOR_BK_APPROX is speaking '
       WRITE(6,'(A, 4I4)') ' Input blocks IA, IB, JA, JB = ',
     &                     IATP,IBTP, JATP, JBTP
       WRITE(6,'(A, 4I4)') ' Input blocks IASM, IBSM, JASM, JBSM = ',
     &                     IASM,IBSM, JASM, JBSM
      END IF
*
      IF(NTEST.GE.10) THEN
       WRITE(6,'(A,I4)') ' I_DO_EXACT_BLOCK = ', I_DO_EXACT_BLOCK
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE NATORB_CASPT2(DMAT,CMO,OCC,CNAT)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
      DIMENSION DMAT(*),CMO(*),OCC(*),CNAT(*)
C Given DMAT, symmetry-blocked array of triangular
C density matrices in MO basis, and symmetry-blocked
C array CMO of MO coefficients, return array of
C natural occupation numbers and MO coefficients of
C natural orbitals.


      IDMAT=0
      IOCC=0
      ICMO=0
      DO ISYM=1,NSYM
        NF=NFRO(ISYM)
        NO=NORB(ISYM)
        ND=NDEL(ISYM)
        NB=NBAS(ISYM)
C  Frozen orbitals:
        IF(NF.GT.0) THEN
          CALL DCOPY_(NF,[2.0D00],0,OCC(IOCC+1),1)
          IOCC=IOCC+NF
          CALL DCOPY_(NB*NF,CMO(ICMO+1),1,CNAT(ICMO+1),1)
          ICMO=ICMO+NB*NF
        END IF
C Inactive, active, and secondary orbitals:
        IF(NO.GT.0) THEN
          NTMP=(NO*(NO+1))/2
          CALL GETMEM('TMP','ALLO','REAL',LTMP,NTMP)
          CALL DCOPY_(NB*NO,CMO(ICMO+1),1,CNAT(ICMO+1),1)
C For correct order, change sign.
          CALL DYAX(NTMP,-1.0D0,DMAT(IDMAT+1),1,WORK(LTMP),1)
          CALL NIDiag(WORK(LTMP),CNAT(ICMO+1),NO,NB,0)
          CALL JACORD(WORK(LTMP),CNAT(ICMO+1),NO,NB)
          CALL VEIG(NO,WORK(LTMP),OCC(IOCC+1))
C Change back to positive sign.
          CALL DSCAL_(NO,-1.0D0,OCC(IOCC+1),1)
          IDMAT=IDMAT+NTMP
          IOCC=IOCC+NO
          ICMO=ICMO+NB*NO
          CALL GETMEM('TMP','FREE','REAL',LTMP,NTMP)
        END IF
C Deleted orbitals:
        IF(ND.GT.0) THEN
          CALL DCOPY_(ND,[0.0D0],0,OCC(IOCC+1),1)
          IOCC=IOCC+ND
          CALL DCOPY_(NB*ND,CMO(ICMO+1),1,CNAT(ICMO+1),1)
          ICMO=ICMO+NB*ND
        END IF
      END DO


      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Kurt Pfingst                                           *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CmbnMPr(Rnr,nZeta,la,lb,lr,rFinal,nComp)
!***********************************************************************
!     Author: K.Pfingst                                                *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use rmat, only: GammaPh, GammaTh
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, lr, nComp
real(kind=wp), intent(in) :: Rnr(nZeta,0:la+lb+lr)
real(kind=wp), intent(out) :: rFinal(nZeta,nComp,nTri_Elem1(la),nTri_Elem1(lb))
integer(kind=iwp) :: iComp, ipa, ipb, ix, ixa, ixb, iy, iya, iyaMax, iyb, iybMax, iz, iza, izb, lcosf, lcost, lrs, lsinf, lsint
real(kind=wp) :: Fact

do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)
#       ifdef _DEBUGPRINT_
        write(u6,*) ixa,iya,iza,ixb,iyb,izb
        write(u6,*) ipa,ipb
#       endif

        ! Combine multipole moment integrals

        iComp = 0
        do ix=lr,0,-1
          do iy=lr-ix,0,-1
            iz = lr-ix-iy
            iComp = iComp+1
            lrs = ixa+ixb+ix+iya+iyb+iy+iza+izb+iz
            lcost = iza+izb+iz
            lsint = ixa+ixb+ix+iya+iyb+iy
            lsinf = iya+iyb+iy
            lcosf = ixa+ixb+ix
            Fact = gammath(lsint,lcost)*gammaph(lsinf,lcosf)
            rFinal(:,iComp,ipa,ipb) = Fact*Rnr(:,lrs)
          end do
        end do

      end do
    end do
  end do
end do

return

end subroutine CmbnMPr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Roland Lindh                                     *
************************************************************************
      Subroutine Trsn(xyz,nCent,Tau,Bt,lWrite,lWarn,Label,dBt,ldB)
************************************************************************
*                                                                      *
* Reference: Molecular Vibrations, E. Bright Wilson, Jr, J. C. Decicius*
*            and Paul C. Cross, Sec. 4-1, Eq. 20-24                    *
*                                                                      *
* R.Lindh May-June '96                                                 *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Bt(3,nCent), xyz(3,nCent), dBt(3,nCent,3,nCent),
     &       BRij(3,2), dBRij(3,2,3,2), BRjk(3,2), dBRjk(3,2,3,2),
     &       BRkl(3,2), dBRkl(3,2,3,2), Bf2(3,3),
     &       Bf3(3,3)
      Logical lWrite, lWarn, ldB
      Character*8 Label
      Dimension Dum(1)
*
      mCent=2
      Call Strtch(xyz(1,1),mCent,Rij1,BRij,.False.,Label,dBRij,ldB)
      Call Strtch(xyz(1,2),mCent,Rjk1,BRjk,.False.,Label,dBRjk,ldB)
      Call Strtch(xyz(1,3),mCent,Rkl1,BRkl,.False.,Label,dBRkl,ldB)
      mCent=3
      Call Bend(xyz(1,1),mCent,Fi2,Bf2,.False.,.False.,Label,Dum,
     &          .False.)
      SinFi2=Sin(Fi2)
      CosFi2=Cos(Fi2)
      Call Bend(xyz(1,2),mCent,Fi3,Bf3,.False.,.False.,Label,Dum,
     &          .False.)
      SinFi3=Sin(Fi3)
      CosFi3=Cos(Fi3)
*
      If (SinFi2*SinFi3.lt.1.0d-13) Then
         Tau=Zero
         dTau=Zero
         If (lWrite) Write (6,1) Label,-dTau,-Tau
         Return
      End If
*
*     Get the angle between the two planes, i.e. the
*     angle between the normal vectors.
*
*     r123 * r234 = CosTau
*
      CosTau = ( ( BRij(2,1)*BRjk(3,2) - BRij(3,1)*BRjk(2,2) ) *
     &           ( BRjk(2,1)*BRkl(3,2) - BRjk(3,1)*BRkl(2,2) ) +
     &           ( BRij(3,1)*BRjk(1,2) - BRij(1,1)*BRjk(3,2) ) *
     &           ( BRjk(3,1)*BRkl(1,2) - BRjk(1,1)*BRkl(3,2) ) +
     &           ( BRij(1,1)*BRjk(2,2) - BRij(2,1)*BRjk(1,2) ) *
     &           ( BRjk(1,1)*BRkl(2,2) - BRjk(2,1)*BRkl(1,2) ) )
     &         / (SinFi2*SinFi3)
*
*     For the vector product of the two vectors. This
*     will give a vector parallel to e23. The direction
*     relative to e23 defines the sign.
*
*     e123 X e234 = SinTau * e23
*
      SinTau = ( BRij(1,2) * (BRjk(2,1)*BRkl(3,2)-BRjk(3,1)*BRkl(2,2))
     &         + BRij(2,2) * (BRjk(3,1)*BRkl(1,2)-BRjk(1,1)*BRkl(3,2))
     &         + BRij(3,2) * (BRjk(1,1)*BRkl(2,2)-BRjk(2,1)*BRkl(1,2)) )
     &         / (SinFi2*SinFi3)
*
*     (-Pi < Tau <= Pi)
*
      Tau = ATan2(SinTau,CosTau)
      If (Abs(Tau).eq.Pi) Tau=Pi
*
      dTau = 180.0D+00*Tau/Pi
      dFi2 = 180.0D+00*Fi2/Pi
      dFi3 = 180.0D+00*Fi3/Pi
      If (lWarn) Then
         If (dTau.gt.177.5 .or. dTau.lt.-177.5) Then
            Call WarningMessage(1,
     &                  ' Warning: dihedral angle close to'
     &         //' end of range')
         End If
         If (dFi2.gt.177.5 .or. dFi2.lt.2.5) Then
            Call WarningMessage(1,
     &                  ' Warning: bond angle 2 close to'
     &         //' end of range')
         End If
         If (dFi3.gt.177.5 .or. dFi3.lt.2.5) Then
            Call WarningMessage(1,
     &                  ' Warning: bond angle 3 close to'
     &         //' end of range')
         End If
      End If
      If (LWRITE) Write (6,1) Label,-dTau,-Tau
1     FORMAT(1X,A,' : Dihedral= ',F10.4,
     & '   / Degree  ',F10.6,' / rad')
*
*---- Compute the WDC matrix.
*
      Do ix = 1, 3
         iy=ix+1
         If (iy.gt.3) iy=iy-3
         iz=iy+1
         If (iz.gt.3) iz=iz-3
         Bt(ix,1) = (BRij(iy,2)*BRjk(iz,2)-BRij(iz,2)*BRjk(iy,2))
     &           / (Rij1*SinFi2**2)
         Bt(ix,4) = (BRkl(iy,1)*BRjk(iz,1)-BRkl(iz,1)*BRjk(iy,1))
     &           / (Rkl1*SinFi3**2)
         Bt(ix,2) = -( (Rjk1-Rij1*CosFi2) * Bt(ix,1)
     &             +         Rkl1*CosFi3  * Bt(ix,4))/Rjk1
         Bt(ix,3) = - ( Bt(ix,1)+Bt(ix,2)+Bt(ix,4))
      End Do
*
      If (ldB) Then
*
*------- Compute the derivative of the WDC matrix.
*
         Do ix = 1, 3
            iy=ix+1
            If (iy.gt.3) iy=iy-3
            iz=iy+1
            If (iz.gt.3) iz=iz-3
            Do jx = 1, ix
               jy=jx+1
               If (jy.gt.3) jy=jy-3
               jz=jy+1
               If (jz.gt.3) jz=jz-3
*
            dBt(ix,1,jx,1) =(  dBRij(ix,1,jy,2)*BRjk(jz,2)
     &                       - dBRij(ix,1,jz,2)*BRjk(jy,2)
     &                       - Bt(jx,1)*(BRij(ix,1)*SinFi2**2
     &                       + Rij1*Two*SinFi2*CosFi2*Bf2(ix,1)) )
     &                       / (Rij1*SinFi2**2)
            dBt(ix,1,jx,2) =-( (-BRij(ix,1)*CosFi2
     &                         + Rij1*SinFi2*Bf2(ix,1) ) * Bt(jx,1)
     &                         + (Rjk1-Rij1*CosFi2) * dBt(ix,1,jx,1) )
     &                       / Rjk1
            dBt(jx,2,ix,1) = dBt(ix,1,jx,2)
            dBt(ix,1,jx,4) = Zero
            dBt(jx,4,ix,1) = dBt(ix,1,jx,4)
            dBt(ix,1,jx,3) = - (dBt(ix,1,jx,1) + dBt(ix,1,jx,2) )
            dBt(jx,3,ix,1) = dBt(ix,1,jx,3)
            dBt(ix,4,jx,4) =(  dBRkl(ix,2,jy,1)*BRjk(jz,1)
     &                       - dBRkl(ix,2,jz,1)*BRjk(jy,1)
     &                       - Bt(jx,4)*(BRkl(ix,2)*SinFi3**2
     &                       + Rkl1*Two*SinFi3*CosFi3*Bf3(ix,3)) )
     &                       / (Rkl1*SinFi3**2)
            dBt(ix,4,jx,3) =-( (-BRkl(ix,2)*CosFi3
     &                         + Rkl1*SinFi3*Bf3(ix,3) ) * Bt(jx,4)
     &                         + (Rjk1-Rkl1*CosFi3) * dBt(ix,4,jx,4) )
     &                       / Rjk1
            dBt(jx,3,ix,4) = dBt(ix,4,jx,3)
            dBt(ix,4,jx,2) = - ( dBt(ix,4,jx,4) + dBt(ix,4,jx,3) )
            dBt(jx,2,ix,4) = dBt(ix,4,jx,2)
            If (ix.ne.jx) Then
               dBt(jx,1,ix,1) = dBt(ix,1,jx,1)
               dBt(ix,4,jx,1) = Zero
               dBt(jx,4,ix,4) = dBt(ix,4,jx,4)
               dBt(jx,1,ix,4) = dBt(ix,4,jx,1)
               dBt(jx,1,ix,2) =-( (-BRij(jx,1)*CosFi2
     &                            + Rij1*SinFi2*Bf2(jx,1) ) * Bt(ix,1)
     &                            + (Rjk1-Rij1*CosFi2) * dBt(jx,1,ix,1))
     &                          / Rjk1
               dBt(ix,2,jx,1) = dBt(jx,1,ix,2)
               dBt(ix,3,jx,1) = - ( dBt(ix,1,jx,1) + dBt(ix,2,jx,1)
     &                          + dBt(ix,4,jx,1) )
               dBt(jx,1,ix,3) = dBt(ix,3,jx,1)
               dBt(jx,4,ix,3) =-( (-BRkl(jx,2)*CosFi3
     &                            + Rkl1*SinFi3*Bf3(jx,3) ) * Bt(ix,4)
     &                            + (Rjk1-Rkl1*CosFi3) * dBt(jx,4,ix,4))
     &                          / Rjk1
               dBt(ix,3,jx,4) = dBt(jx,4,ix,3)
               dBt(ix,2,jx,4) = - ( dBt(ix,4,jx,4) + dBt(ix,3,jx,4) )
               dBt(jx,4,ix,2) = dBt(ix,2,jx,4)
            End If
            dBt(ix,2,jx,3) = - ( ( BRjk(ix,1)
     &                           + Rkl1*SinFi3*Bf3(ix,1) ) * Bt(jx,4)
     &                         + ( Rjk1 - Rkl1*CosFi3 ) * dBt(ix,2,jx,4)
     &                         + ( BRij(ix,2)*CosFi2
     &                           - Rij1*SinFi2*Bf2(ix,2) ) * Bt(jx,1)
     &                         +  Rij1*CosFi2 * dBt(ix,2,jx,1)
     &                         + Bt(jx,3) * BRjk(ix,1) ) / Rjk1
            dBt(jx,3,ix,2) = dBt(ix,2,jx,3)
            dBt(ix,2,jx,2) = - ( dBt(ix,2,jx,1) + dBt(ix,2,jx,4)
     &                         + dBt(ix,2,jx,3) )
            dBt(ix,3,jx,3) = - ( dBt(ix,2,jx,3) + dBt(ix,1,jx,3)
     &                         + dBt(ix,4,jx,3) )
            If (ix.ne.jx) Then
               dBt(ix,3,jx,2) = - ( dBt(ix,2,jx,2) + dBt(ix,1,jx,2)
     &                            + dBt(ix,4,jx,2) )
               dBt(jx,2,ix,3) = dBt(ix,3,jx,2)
               dBt(jx,2,ix,2) = dBt(ix,2,jx,2)
               dBt(jx,3,ix,3) = dBt(ix,3,jx,3)
            End If
*
            End Do
         End Do
*
      End If
*
      Fac = -One
      Tau = Fac * Tau
      Call DScal_(3*nCent,Fac,Bt,1)
      If (ldB) Call DScal_((3*nCent)**2,Fac,dBt,1)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine not_DGeEV(iOpt,a,lda,w,z,ldz,n)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iOpt, lda, ldz, n
real(kind=wp), intent(inout) :: a(lda,n)
real(kind=wp), intent(out) :: w(2,n), z(2*ldz*n)
integer(kind=iwp) :: i, iErr, iOff
real(kind=wp), allocatable :: aux(:,:), w1(:)

if (iOpt == 2) then
  write(u6,*) 'not_DGeEV: iOpt=2 is not implemented yet!'
  call Abend()
end if
if (ldz /= n) then
  write(u6,*) 'not_DGeEV: ldz=/=n is not implemented yet!'
  call Abend()
end if
if (iOpt == 0) then
  write(u6,*) 'not_DGeEV: iOpt=0 is not implemented yet!'
  call Abend()
end if
iOff = n+1
call mma_allocate(w1,n,label='w1')
iErr = 0
call XEIGEN(iOpt,lda,n,a,w,w1,z,iErr)
if (iErr /= 0) then
  write(u6,*) ' not_DGeEV: iErr=/= 0!'
  call Abend()
end if
!call RecPrt('w',' ',w,n,1)
!call RecPrt('w1',' ',w1,n,1)
!call RecPrt('z',' ',z,n,n)

!-----Order eigenvalues to ESSL standard

call mma_allocate(aux,n,2,label='aux')
call dcopy_(n,w,1,aux(:,1),1)
do i=1,n
  w(1,i) = aux(i,1)  ! Real
  w(2,i) = w1(i)     ! Imaginary
end do
call mma_deallocate(w1)

!-----Order eigenvector to ESSL standard

i = N
do while (i >= 1)
  if (w(2,i) /= Zero) then
    i = i-1
    iOff = (i-1)*n
    call dcopy_(2*N,Z(iOff+1),1,Aux,1)
    iOff = (i-1)*2*n
    call dcopy_(N,Aux(:,1),1,Z(iOff+1),2)
    call dcopy_(N,Aux(:,2),1,Z(iOff+2),2)
    iOff = i*2*n
    call dcopy_(N,Aux(:,1),1,Z(iOff+1),2)
    call dcopy_(N,Aux(:,2),1,Z(iOff+2),2)
    call DScal_(N,-One,Z(iOff+2),2)
  else
    iOff = (i-1)*n
    call dcopy_(N,Z(iOff+1),1,Aux,1)
    iOff = (i-1)*2*n
    call dcopy_(N,Aux(:,1),1,Z(iOff+1),2)
    call dcopy_(N,[Zero],0,Z(iOff+2),2)
  end if
  i = i-1
end do
call mma_deallocate(aux)

return

end subroutine not_DGeEV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!               2024, Giovanni Li Manni                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CSFDIM_GAS(IOCCLS,NOCCLS,ISYM)
! Initializing routine for CSF-DET expansions
!
! information about the number of dets,csf's for
! each symmetry. CI space is defined by the NOCCLS
! occupation classes IOCCLS
!
! DETERMINE BASE ADDRESSES
!             DFTP : OPEN SHELL DETERMINANTS OF PROTO TYPE
!             CFTP : BRANCHING DIAGRAMS FOR PROTO TYPES
!             DTOC  : CSF-DET TRANSFORMATION FOR PROTO TYPES
!             ONF_OCC%I(I) : SPACE FOR STORING  NCNSM
!                        CONFIGURATION EXPANSIONS
! (Spin signaled by PSSIGN in CIINFO)
!
! Adapted for GAS calculations and LUCIA, Dec. 2001
! G. Li Manni, June 2024: Scale-up capability for single SD ROHF type calculations

use Data_Structures, only: Allocate_DT
use lucia_data, only: CFTP, CONF_OCC, CONF_REO, DFTP, DTOC, I2ELIMINATED_IN_GAS, I_ELIMINATE_GAS, IB_CONF_OCC, IB_CONF_REO, &
                      IB_SD_FOR_OPEN, IBCONF_ALL_SYM_FOR_OCCLS, IELIMINATED_IN_GAS, IPRCIX, MAXOP, MINOP, MS2, MULTS, MXPORB, &
                      N_2ELIMINATED_GAS, N_ELIMINATED_GAS, NCONF_ALL_SYM, NCONF_PER_OPEN, NCONF_PER_SYM, NCONF_TOT, NCSF_HEXS, &
                      NCSF_PER_SYM, NGAS, NOBPT, NOCOB, NPCMCNF, NPCSCNF, NPDTCNF, NSD_PER_SYM, PSSIGN, REO_PTDT, SDREO, SDREO_I, &
                      Z_PTDT
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NOCCLS, IOCCLS(NGAS,NOCCLS), ISYM
#include "warnings.h"
integer(kind=iwp) :: HEXS_CNF(MXPORB+1), I, IAEL, IALPHA, IB, IBEL, ICL, IDOREO, IDUM, IDUM_ARR(1), IELIM, IGAS, ILCNF, ILLCNF, &
                     INITIALIZE_CONF_COUNTERS, IOPEN, ITP, ITYP, J, JGAS, JOCCLS, LCONF, LDTOC, LENGTH_LIST, LICS, LIDT, LLCONF, &
                     LPTDT, LZ, maxingas(N_ELIMINATED_GAS), maxingas2(N_2ELIMINATED_GAS), MXDT, MXPTBL, NCMB, NCONF_OCCLS, NCSF, &
                     NELEC, NSD, TMP_CNF(MXPORB+1)
integer(kind=iwp), external :: IBINOM, IWEYLF

IDUM = 0
IDUM_ARR(1) = 0

#ifdef _DEBUGPRINT_
write(u6,*) '  PSSIGN : ',PSSIGN
write(u6,*) ' MULTS, MS2 = ',MULTS,MS2
#endif
NELEC = sum(IOCCLS(:,1))

! Define parameters in SPINFO

! Allowed number of open orbitals
MINOP = abs(MS2)
call MAX_OPEN_ORB(MAXOP,IOCCLS,NGAS,NOCCLS,NOBPT)
if (IPRCIX >= 6) write(u6,*) ' MINOP MAXOP ',MINOP,MAXOP

! Number of prototype sd's and csf's per configuration prototype

do IOPEN=MINOP,MAXOP
  ITP = IOPEN+1
  ! Unpaired electrons :
  IAEL = (IOPEN+MS2)/2
  IBEL = (IOPEN-MS2)/2
  if ((IAEL+IBEL == IOPEN) .and. (IAEL-IBEL == MS2) .and. (IAEL >= 0) .and. (IBEL >= 0)) then
    if ((PSSIGN == Zero) .or. (IOPEN == 0)) then
      ! Number of determinants is in general set to number of combinations
      NPDTCNF(ITP) = IBINOM(IOPEN,IAEL)
    else
      NPDTCNF(ITP) = IBINOM(IOPEN,IAEL)/2
    end if
    if (IOPEN >= MULTS-1) then
      NPCSCNF(ITP) = IWEYLF(IOPEN,MULTS)
    else
      NPCSCNF(ITP) = 0
    end if
  else
    NPDTCNF(ITP) = 0
    NPCSCNF(ITP) = 0
  end if
end do
NPCMCNF(MINOP+1:MAXOP+1) = NPDTCNF(MINOP+1:MAXOP+1)

if (IPRCIX >= 5) then
  if (PSSIGN == Zero) then
    write(u6,*) '  (Combinations = Determinants)'
  else
    write(u6,*) '  (Spin combinations in use)'
  end if
  write(u6,'(/A)') ' Information about prototype configurations'
  write(u6,'( A)') ' =========================================='
  write(u6,'(/A)') '  Open orbitals   Combinations    CSFs'
  do IOPEN=MINOP,MAXOP,2
    write(u6,'(5X,I3,10X,I6,7X,I6)') IOPEN,NPCMCNF(IOPEN+1),NPCSCNF(IOPEN+1)
  end do
end if

! Number of Configurations per occupation type

!if (NOCCLS > MXPCSM) then
!  write(u6,*) ' A known bug has reoccurred -- It seems that'
!  write(u6,*) ' the named constant MXPCSM must be increased'
!  write(u6,*) ' from its current value MXPCSM=',MXPCSM
!  write(u6,*) ' to AT LEAST NOCCLS=',NOCCLS
!  write(u6,*) ' This parameter is found in the module'
!  write(u6,*) '  <molcas>/src/lucia_util/lucia_data.F90'
!  write(u6,*) ' Change it. Then ''cd'' to molcas root'
!  write(u6,*) ' directory and give command ''make''.'
!  write(u6,*) ' But this may also be a bug. Please tell the'
!  write(u6,*) ' molcas developers!'
!  call Quit(_RC_INTERNAL_ERROR_)
!end if
!MGD : max occupation in removed GAS spaces
do i=1,N_ELIMINATED_GAS
  iGAS = IELIMINATED_IN_GAS(i)
  maxingas(i) = max(0,maxval(IOCCLS(iGAS,:)))
end do
do i=1,N_2ELIMINATED_GAS
  iGAS = I2ELIMINATED_IN_GAS(i)
  maxingas2(i) = max(0,maxval(IOCCLS(iGAS,:)))
end do
HEXS_CNF(:) = 0
NCONF_PER_OPEN(:,ISYM) = 0

call mma_allocate(IBCONF_ALL_SYM_FOR_OCCLS,NOCCLS,Label='IBCONF_ALL_SYM_FOR_OCCLS')
NCONF_ALL_SYM = 0
do JOCCLS=1,NOCCLS
  if (JOCCLS == 1) then
    INITIALIZE_CONF_COUNTERS = 1
  else
    INITIALIZE_CONF_COUNTERS = 0
  end if

  IBCONF_ALL_SYM_FOR_OCCLS(JOCCLS) = NCONF_ALL_SYM+1

  IDOREO = 0
  TMP_CNF(:) = 0
  call GEN_CONF_FOR_OCCLS(IOCCLS(:,JOCCLS),IDUM,INITIALIZE_CONF_COUNTERS,NGAS,ISYM,MINOP,MAXOP,1,NOCOB,NOBPT,TMP_CNF,NCONF_OCCLS, &
                          IB_CONF_REO,IB_CONF_OCC,IDUM_ARR,IDOREO,IDUM_ARR,NCONF_ALL_SYM,idum_arr,nconf_tot)
  NCONF_PER_OPEN(:,ISYM) = NCONF_PER_OPEN(:,ISYM)+TMP_CNF(:)
  !MGD add to hexs_cnf only if the configuration does not have max occupation
  ! in the selected GAS space
  if (I_ELIMINATE_GAS > 0) then
    ielim = 0
    if ((I_ELIMINATE_GAS == 1) .or. (I_ELIMINATE_GAS == 3)) then
      do j=1,N_ELIMINATED_GAS
        jGAS = IELIMINATED_IN_GAS(j)
        if (IOCCLS(jGAS,JOCCLS) == maxingas(j)) ielim = 1
      end do
    end if
    if (I_ELIMINATE_GAS > 1) then
      do j=1,N_2ELIMINATED_GAS
        jGAS = I2ELIMINATED_IN_GAS(j)
        if (IOCCLS(jGAS,JOCCLS) >= maxingas2(j)-1) ielim = 1
      end do
    end if
    if (ielim == 0) HEXS_CNF(:) = HEXS_CNF(:)+TMP_CNF(:)
  end if
  ! testing
  !write(u6,*) 'nconf_per_open after first call of gen_conf_for_occls'
  !call iwrtma(nconf_per_open,1,4,1,4)

  ! NCONF_ALL_SYM is accumulated, so
  !if (JOCCLS == 1) then
  !  NCONF_ALL_SYM_FOR_OCCLS(JOCCLS) = NCONF_ALL_SYM
  !  IBCONF_ALL_SYM_FOR_OCCLS(JOCCLS) = 1
  !else
  !  ! PAM2009: It was discovered that these two arrays could be overrun.
  !  ! The arrays are declared in lucia_data, and their dimension
  !  ! is MXPCSM, which is set in lucia_data -- both included above.
  !  ! So MXPCSM is now increased from 20 to 40 -- if this is not a final
  !  ! solution remains to be discovered:
  !  ! IFG 2025: It doesn't make sense for MXPCSM to be larger than 8,
  !  !           so if this is still a problem, there must be some bug.
  !  NCONF_ALL_SYM_FOR_OCCLS(JOCCLS) = NCONF_ALL_SYM-NCONF_ALL_SYM_PREV
  !  IBCONF_ALL_SYM_FOR_OCCLS(JOCCLS) = IBCONF_ALL_SYM_FOR_OCCLS(JOCCLS-1)+NCONF_ALL_SYM_FOR_OCCLS(JOCCLS-1)
  !end if
end do
! Number of CSF's in expansion
NCSF = sum(NCONF_PER_OPEN(1:MAXOP+1,ISYM)*NPCSCNF(1:MAXOP+1))
! Number of combinations in expansion
NCMB = sum(NCONF_PER_OPEN(1:MAXOP+1,ISYM)*NPCMCNF(1:MAXOP+1))
! Number of SD's in expansion
NSD = NCMB
if (PSSIGN /= Zero) NSD = NSD+NCMB-NCONF_PER_OPEN(1,ISYM)*NPDTCNF(1)
!MGD
if (I_ELIMINATE_GAS > 0) then
  NCSF_HEXS = sum(HEXS_CNF(1:MAXOP+1)*NPCSCNF(1:MAXOP+1))
else
  NCSF_HEXS = 0
end if

NCSF_PER_SYM(ISYM) = NCSF
NSD_PER_SYM(ISYM) = NCMB
NCONF_PER_SYM(ISYM) = sum(NCONF_PER_OPEN(:,ISYM))
if (IPRCIX >= 5) then
  write(u6,*) ' Number of CSFs  ',NCSF
  write(u6,*) ' Number of SDs   ',NSD
  write(u6,*) ' Number of Confs ',NCONF_PER_SYM(ISYM)
  write(u6,*) ' Number of CMBs  ',NCMB
end if

! Total number of configurations and length of configuration list
!    INFO_CONF_LIST(NCONF_PER_OPEN,MAXOP,NEL,LENGTH_LIST,NCONF_TOT,IB_REO,IB_OCC)
call INFO_CONF_LIST(NCONF_PER_OPEN(:,ISYM),MAXOP,NELEC,LENGTH_LIST,NCONF_TOT,IB_CONF_REO,IB_CONF_OCC)
! Permanent and local memory for csf routines

! memory for CSDTMT arrays.
! Largest block of proto type combinations .
! Largest number of prototype csf's

LIDT = 0
LICS = 0
LDTOC = 0
MXPTBL = 0
MXDT = 0
LCONF = 0
do IOPEN=MINOP,MAXOP
  ITP = IOPEN+1
  LIDT = LIDT+NPCMCNF(ITP)*IOPEN
  LICS = LICS+NPCSCNF(ITP)*IOPEN
  LDTOC = LDTOC+NPCSCNF(ITP)*NPCMCNF(ITP)
  MXDT = max(MXDT,NPCMCNF(ITP))
  MXPTBL = max(NPCMCNF(ITP)*IOPEN,MXPTBL)
end do
! Memory needed to store ICONF array
LCONF = 0
ILCNF = 0

!LDET = NCMB
LLCONF = 0
ILLCNF = 0
do IOPEN=MINOP,MAXOP
  ITYP = IOPEN+1
  ICL = (NELEC-IOPEN)/2
  LLCONF = LLCONF+NCONF_PER_OPEN(ITYP,ISYM)*(IOPEN+ICL)
  ILLCNF = ILLCNF+NCONF_PER_OPEN(ITYP,ISYM)
end do
!write(u6,*) ' MEMORY FOR HOLDING CONFS OF SYM... ',ISYM,LLCONF
LCONF = max(LCONF,LLCONF)
ILCNF = max(ILCNF,ILLCNF)

if (IPRCIX >= 5) then
  write(u6,'(/A,I8)') '  Memory for holding list of configurations ',LCONF
  write(u6,'(/A,I8)') '  Size of CI expansion (combinations)',NCMB
  write(u6,'(/A,I8)') '  Size of CI expansion (confs)',ILCNF
end if

! permanent memory for csf proto type arrays

call mma_allocate(DFTP,max(1,LIDT),Label='DFTP')
call mma_allocate(CFTP,max(1,LICS),Label='CFTP')
call mma_allocate(DTOC,max(1,LDTOC),Label='DTOC')

! PERMANENT ARRAYS FOR
! HOLDING CONFIGURATION EXPANSIONS AND REORDER ARRAYS

! Occupation of configurations
call mma_allocate(CONF_OCC(ISYM)%A,LCONF,Label='CONF_OCC()')
! Reorder array for configurations
call mma_allocate(CONF_REO(ISYM)%A,NCONF_TOT,Label='CONF_REO()')
! Reorder array for determinants, index and sign
call mma_allocate(SDREO_I(ISYM)%A,NCMB,Label='SDREO_I()')
SDREO(1:NCMB) => SDREO_I(ISYM)%A(:)

! Arrays for addressing prototype determinants for each number of orbitals

call Allocate_DT(Z_PTDT,[MINOP+1,MAXOP+1],Label='Z_PTDT')
call Allocate_DT(REO_PTDT,[MINOP+1,MAXOP+1],Label='REO_PTDT')
do IOPEN=MINOP,MAXOP
  ITYP = IOPEN+1

  IALPHA = (IOPEN+MS2)/2
  LZ = IOPEN*IALPHA
  LPTDT = IBINOM(IOPEN,IALPHA)
  call mma_allocate(Z_PTDT(ITYP)%A,LZ,Label='Z_PTDT()')
  call mma_allocate(REO_PTDT(ITYP)%A,LPTDT,Label='REO_PTDT()')
end do

! Array giving first determinant with given number of electrons
! in list of determinants ordered  according to the number of open orbitals

IB_SD_FOR_OPEN(:) = 0
IB = 1
do IOPEN=MINOP,MAXOP
  IB_SD_FOR_OPEN(IOPEN+1) = IB
  if (mod(IOPEN-MS2,2) == 0) IB = IB+NCONF_PER_OPEN(IOPEN+1,ISYM)*NPCMCNF(IOPEN+1)
end do

end subroutine CSFDIM_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_expand40 (a,b,dimpq,dimrs,dimp,dimr)
c
c     expand a(pq,rs) -> b(p,q,r,s)
c     assumption: p>q,r>s, + antisymetry
c     RISC version
c
       integer dimpq,dimrs,dimp,dimr
       real*8 a(1:dimpq,1:dimrs)
       real*8 b(1:dimp,1:dimp,1:dimr,1:dimr)
c
c     help variables
c
       integer p,q,r,s,pq,rs
       real*8 scalar
c
       if ((dimp.gt.1).and.(dimr.gt.1)) then
c
       rs=0
       do 100 r=2,dimr
       do 101 s=1,r-1
       rs=rs+1
c
       pq=0
       do 102 p=2,dimp
       do 103 q=1,p-1
       pq=pq+1
c
       scalar=a(pq,rs)
       b(p,q,r,s)=scalar
       b(p,q,s,r)=-scalar
       b(q,p,r,s)=-scalar
       b(q,p,s,r)=scalar
c
 103    continue
 102    continue
 101    continue
 100    continue
c
       end if
c
       do r=1,dimr
       do p=1,dimp
       do q=1,dimp
       b(p,q,r,r)=0.0d0
       end do
       end do
       end do
c
       do s=1,dimr
       do r=1,dimr
       do p=1,dimp
       b(p,p,r,s)=0.0d0
       end do
       end do
       end do
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETRSTC()
C
C     Purpose: read and check decomposition restart info.
C
#include "implicit.fh"
#include "cholesky.fh"

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_GETRSTC')

C     Read restart file, populating restart common block.
C     ---------------------------------------------------

      IFAIL = 0
      CALL CHO_RDRSTC(IFAIL)
      IF (IFAIL .NE. 0) THEN
         WRITE(LUPRI,'(A,A)')
     &   SECNAM,': error reading decomposition restart file.'
         WRITE(LUPRI,'(A,A,I10)')
     &   SECNAM,': return code from reading routine:',IFAIL
         CALL CHO_QUIT('Error reading decomposition restart file',104)
      END IF

C     Check system info .
C     -------------------

      IFAIL = 0
      CALL CHO_RSTMOL(IFAIL)
      IF (IFAIL .NE. 0) THEN
         WRITE(LUPRI,'(A,A)')
     &   SECNAM,': decomposition restart failure.'
         CALL CHO_QUIT('Decomposition restart failure in '//SECNAM,105)
      END IF

C     Check decomposition configuration.
C     ----------------------------------

      IFAIL = 0
      CALL CHO_RSTCNF(IFAIL)
      IF (IFAIL .NE. 0) THEN
         WRITE(LUPRI,'(A,A,I6,A)')
     &   SECNAM,':',IFAIL,' configuration discrepancies detected.'
         IF (MODRST .EQ. -1) THEN
            WRITE(LUPRI,'(A)')
     &      'Recovery: using configuration from restart file.'
            CALL CHO_RESETCNF
         ELSE IF (MODRST .EQ. 0) THEN
            WRITE(LUPRI,'(A)')
     &      'Recovery: none, program stops.'
            CALL CHO_QUIT('Restart configuration error in '//SECNAM,105)
         ELSE IF (MODRST .EQ. 1) THEN
            WRITE(LUPRI,'(A)')
     &      'Recovery: using input configuration.'
         ELSE
            WRITE(LUPRI,'(A,A,I6,A)')
     &      SECNAM,': restart model,',MODRST,', not recognized.'
            CALL CHO_QUIT('Error in '//SECNAM,103)
         END IF
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine OrdIn2(iOpt,Buf,lBuf,iBatch)
!***********************************************************************
!                                                                      *
!    Purpose: Read a buffer of ordered two electron integrals          *
!                                                                      *
!    Calling arguments:                                                *
!    Buf    : contains on output the integrals                         *
!    lBuf   : number of integrals to be transfered                     *
!    iOpt   : option code (iOpt=1:start reading at first integral)     *
!                         (iOpt=2:continue reading)                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher                                                  *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use TwoDat, only: RAMD
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iOpt, lBuf, iBatch
real(kind=wp), intent(out) :: Buf(lBuf)
integer(kind=iwp) :: iOff

!----------------------------------------------------------------------*
! If this is the first block of a symmetry batch                       *
! get the disk disk start address and load the buffer                  *
!----------------------------------------------------------------------*
if (iOpt == 1) RAMD%next = RAMD%adr(iBatch)
!----------------------------------------------------------------------*
! If the number of requested integrals is larger than                  *
! the current buffer first drain the current buffer and                *
! read as many subsequent buffers as needed                            *
!----------------------------------------------------------------------*
iOff = RAMD%next
Buf(:) = RAMD%ints(iOff:iOff+lBuf-1)
RAMD%next = RAMD%next+lBuf

!----------------------------------------------------------------------*
! exit                                                                 *
!----------------------------------------------------------------------*
return

end subroutine OrdIn2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Stefano Battaglia                                *
!***********************************************************************

#include "compiler_features.h"
#ifdef _DMRG_

subroutine mkfg3qcm(mkF,nLev,G1,F1,G2,F2,G3,F3,idxG3,nG3)

use, intrinsic :: iso_c_binding, only: c_bool
use Symmetry_Info, only: Mul
use qcmaquis_interface, only: qcmaquis_interface_get_1rdm_full, qcmaquis_interface_get_2rdm_full, &
                              qcmaquis_interface_get_3rdm_full, qcmaquis_interface_get_fock_contracted_4rdm_full, &
                              qcmaquis_interface_read_fock_contracted_4rdm
use printLevel, only: verbose
use sguga, only: SGS
use caspt2_global, only: iPrGlb
use caspt2_module, only: EPSA, jState
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, byte

implicit none
logical(kind=iwp), intent(in) :: mkF
integer(kind=iwp), intent(in) :: nLev, nG3
real(kind=wp), intent(out) :: G1(nLev,nLev), F1(nLev,nLev), G2(nLev,nLev,nLev,nLev), F2(nLev,nLev,nLev,nLev), G3(nG3), F3(nG3)
integer(kind=byte), intent(in) :: idxG3(6,nG3)
integer(kind=iwp) :: i, t, u, v, w, x, y, z
real(kind=wp), allocatable :: G3tmp(:,:,:,:,:,:), TG3tmp(:,:,:,:,:,:)

! This might be memory hungry
call mma_allocate(G3tmp,nLev,nLev,nLev,nLev,nLev,nLev,Label='G3Tmp')
call mma_allocate(TG3tmp,nLev,nLev,nLev,nLev,nLev,nLev,Label='TG3Tmp')
!call mma_allocate(G4,n4,nLev,nLev,nLev,nLev,Label='G4')

if (iPrGlb >= verbose) write(u6,*) '>QCMaquis: Computing RDMs for STATE: ',JSTATE-1

! Remeasure RDM from rotated MPS
call qcmaquis_interface_get_1rdm_full(G1)
call qcmaquis_interface_get_2rdm_full(G2)
call qcmaquis_interface_get_3rdm_full(G3tmp)

! Fetch rotated RDM from unrotated MPS
!call qcmaquis_interface_read_rdm_full(int(JSTATE-1,kind=c_int),int(JSTATE-1,kind=c_int),G1,int(1,kind=c_int))
!call qcmaquis_interface_read_rdm_full(int(JSTATE-1,kind=c_int),int(JSTATE-1,kind=c_int),G2,int(2,kind=c_int))
! call qcmaquis_interface_read_rdm_full(int(JSTATE-1,kind=c_int),int(JSTATE-1,kind=c_int),G3tmp,int(3,kind=c_int))

! TODO: This should be removed in the future
TG3tmp = Zero  ! Initialize TG3tmp to zero
call qcmaquis_interface_get_fock_contracted_4rdm_full(EPSA,0)
call qcmaquis_interface_read_fock_contracted_4rdm(TG3tmp,logical(.false.,c_bool))

! call qcmaquis_interface_get_fock_contracted_4rdm_full(TG3tmp, epsa, CompressMPS)

! number of elements in the contracted 4-index of the 4-RDM
! n4 = nTri4_Elem(nLev)
! call mma_allocate(G4,n4,nLev,nLev,nLev,nLev,Label='G4')
! call qcmaquis_interface_get_4rdm_full(G4)

if (mkF) then
  do t=1,nLev
    do u=1,t
      if (Mul(SGS%ism(t),SGS%ism(u)) == 1) then
        do w=1,nLev
          F1(t,u) = F1(t,u)+G2(t,u,w,w)*epsa(w)
        end do
        F1(u,t) = F1(t,u)
      end if
    end do
  end do
end if

if (mkF) then
  do t=1,nLev
    do u=1,nLev
      do v=1,nLev
        do x=1,nLev
          if (Mul(SGS%ism(x),Mul(SGS%ism(v),Mul(SGS%ism(u),SGS%ism(t)))) == 1) then
            do w=1,nLev
              F2(t,u,v,x) = F2(t,u,v,x)+G3tmp(t,v,w,u,x,w)*epsa(w)
            end do
          end if
        end do
      end do
    end do
  end do
end if

do i=1,ng3
  t = idxG3(1,i)
  u = idxG3(2,i)
  v = idxG3(3,i)
  x = idxG3(4,i)
  y = idxG3(5,i)
  z = idxG3(6,i)

  G3(i) = G3tmp(t,v,y,u,x,z)
  ! F_tvyuxz = <| e_{tv,yu,xz} E_ww f_ww |> - <| e_{tv,yu,xz} |> (f_uu + f_xx + f_zz)
  ! Compute first term using transition RDM between <| and |'> = E_ww f_ww |>: <| e_{tv,yu,xz} |'>
  if (mkF) F3(i) = TG3tmp(t,v,y,u,x,z)-G3(i)*(epsa(u)+epsa(x)+epsa(z))

  !do w=1,nLev
  !  val = get_p4_element(G4,w,t,v,y,w,u,x,z,nLev)
  !  F3(i) = F3(i)+val*epsa(w)
  !end do
end do

call mma_deallocate(G3tmp)
call mma_deallocate(TG3tmp)
! call mma_deallocate(G4)
end subroutine mkfg3qcm

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(mkfg3qcm)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Stefano Battaglia                                *
************************************************************************
* This subroutine diagonalizes a real symmetric matrix A using
* the Jacobi algorithm
**
      subroutine eigen(A,U,N)
      use stdalloc, only: mma_allocate, mma_deallocate
      implicit None

      integer N
      real(8) A(N,N)
      real(8) U(N,N)

      integer:: NSCR, IJ, I, J
      real(8), allocatable:: SCR(:)



      NSCR=(N*(N+1))/2
      call mma_allocate(SCR,NSCR,LABEL='SCR')

      IJ=0
      do I=1,N
        do J=1,I
          IJ=IJ+1
          SCR(IJ)=A(I,J)
        end do
      end do

* Initialize U as the identity matrix
      U=0.0d0
      call dcopy_(N,[1.0D0],0,U,N+1)

* Call Jacobi algorithm
      call JACOB(SCR,U,N,N)

      call mma_deallocate(SCR)

      end subroutine eigen

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Giovanni Li Manni                                      *
************************************************************************
      SUBROUTINE print_MCPDFT(CASDFT_E)
******************************************************************
* Purpose:
* This routine is called from RASSCF when performing MC-PDFT jobs,
* for printing out some densities information and some functionals
* as computed in DRVNQ and children routines.
*
* Author:
* G. Li Manni (GLM)
******************************************************************
      use KSDFT_Info, only: Funcaa, Funcbb, Funccc
      use nq_Info, only: Dens_a1, Dens_a2, Dens_b1, Dens_b2, Dens_I
      use PrintLevel, only: USUAL
      use output_ras, only: IPRLOC
      Implicit None
      REAL*8 CASDFT_E

      integer left
      character(LEN=6) Fmt2
      character(LEN=120) Line
      integer IPRLEV

      IPRLEV=IPRLOC(6)
      IF(IPRLEV.ge.USUAL) THEN

      left=6
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
      Line=''
      Write(Line(left-2:),'(A)') 'MC-PDFT run print out'
      write(6,'(6X,80A)')
      Call CollapseOutput(1,Line)
      Write(6,Fmt2//'A)') repeat('-',len_trim(Line)-3)
      write(6,'(6X,80A)')

      write(6,'(6X,A25,45X,F10.3)') 'Integrated total density:',Dens_I
      write(6,'(6X,A58,12X,F10.3)') 'Integrated alpha density '//
     &           'before functional transformation:', Dens_a1
      write(6,'(6X,A58,12X,F10.3)') 'Integrated  beta density '//
     &           'before functional transformation:', Dens_b1
      write(6,'(6X,A58,12X,F10.3)') 'Integrated alpha density '//
     &           ' after functional transformation:', Dens_a2
      write(6,'(6X,A58,12X,F10.3)') 'Integrated  beta density '//
     &           ' after functional transformation:', Dens_b2
      write(6,'(6X,80A)')
      write(6,'(6X,A32,30X,F18.6)') 'Integrated alpha exchange energy',
     &          Funcaa
      write(6,'(6X,A32,30X,F18.6)') 'Integrated beta  exchange energy',
     &          Funcbb
      write(6,'(6X,A32,30X,F18.6)') 'Integrated  correlation   energy',
     &          Funccc
      write(6,'(6X,80A)')
      write(6,'(6X,A20,42X,F18.8)') 'Total CAS-DFT energy',
     &         CASDFT_E

      Call CollapseOutput(0,Line)
      write(6,'(6X,80A)')
      END IF

      Call Add_Info('dens_tt',[Dens_I],1,6)
      Call Add_Info('dens_a1',[Dens_a1],1,6)
      Call Add_Info('dens_b1',[Dens_b1],1,6)
      Call Add_Info('dens_a2',[Dens_a2],1,6)
      Call Add_Info('dens_b2',[Dens_b2],1,6)
      Call Add_Info('excha_a',[Funcaa],1,6)
      Call Add_Info('excha_b',[Funcbb],1,6)
      Call Add_Info('corr_e', [Funccc],1,6)
      Call Add_Info('CASDFTE',[CASDFT_E],1,8)

      END SUBROUTINE print_MCPDFT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine DefInt(nBVct,BMtrx,nQQ,nAtom,rInt,Lbl,Coor,nDim)
************************************************************************
*                                                                      *
* Object: to generate the B matrix which is the transformation matrix  *
*         between an infinitesimal displacement in the symmetry adapted*
*         internal coordinates and the symmetry unique cartesian       *
*         coordinates.                                                 *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             May 1991                                                 *
************************************************************************
      use Slapaf_Info, only: AtomLbl
      use Slapaf_Parameters, only: iRow, Redundant
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "Molcas.fh"
      Real*8 BMtrx(3*nAtom,nQQ), rInt(nQQ), Coor(3,nAtom)
      Character Type*6, Temp*120, Lbl(nQQ)*8, cNum*4,
     &          Line*120, Format*8, filnam*16
      Logical Flip, lPIC(6*nAtom), lAtom(nAtom)
      Logical, Save:: First=.True.
      Logical :: lWrite = .False., lErr = .False.
      Integer, Allocatable:: Ind(:)
      Real*8, Allocatable:: xyz(:), Tmp2(:), Mass(:), TM(:)
      Real*8, Allocatable:: BVct(:,:), Value(:), rMult(:)
      Character(LEN=8), Allocatable:: Labels(:)

      Call mma_allocate(BVct,3*nAtom,nBVct,Label='BVct')
      Call mma_allocate(Value,nBVct,Label='Value')
      Call mma_allocate(rMult,nBVct,Label='rMult')
      Call mma_allocate(Labels,nBVct,Label='Labels')
      BVct(:,:)=Zero
      Value(:)=Zero


      iRout = 30
      iPrint = nPrint(iRout)

      If (iPrint.ge.6) lWrite = .True.
      Do i = 1, 6*nAtom
         lPIC(i)  = .True.
      EndDo
      Do i = 1, nAtom
         lAtom(i) = .True.
      EndDo
      Do jBVct = 1, nBVct
         Labels(jBVct)=' '
      End Do
*
*     Lu=6
      nTemp=Len(Temp)
      Write (Format,'(A,I3.3,A)') '(F',nTemp,'.0)'
*
      Lu_UDIC=91
      filnam='UDIC'
      Call molcas_open(Lu_UDIC,filnam)
c      Open(Lu_UDIC,File=filnam,Form='Formatted',Status='OLD')
      Rewind(Lu_UDIC)
*
      call dcopy_(nBVct,[Zero],0,rMult,1)
      If (iPrint.eq.99) First = .True.
      If (lWrite) Then
         Write (6,*)
         Write (6,'(80A)') ('*',i=1,60)
         Write (6,*) ' User-Defined Internal coordinates'
         Write (6,'(80A)') ('-',i=1,60)
         Do iLines = 1, iRow
            Read (Lu_UDIC,'(A)') Temp
            Write (6,'(A)') Temp
         End Do
         Write (6,'(80A)') ('*',i=1,60)
         Write (6,*)
         Write (6,*)
         Write (6,*) '***********************************************'//
     &               '**************'
         Write (6,*) '* Values of primitive internal coordinates     '//
     &               '             *'
         Write (6,*) '-----------------------------------------------'//
     &               '--------------'
         Rewind(Lu_UDIC)
      End If
*
*     Step 1. Set up the b vectors from which we will define the
*     internal coordinates.
*
      iBVct = 0
      Do 10 iLines = 1, iRow
         Flip=.False.
         Read (Lu_UDIC,'(A)') Line
         Temp=Line
         Call UpCase(Temp)

         If (Temp(1:4).Eq.'VARY') Go To 100
         iBVct = iBVct + 1
*
*        Move the label of the internal coordinate
*
         neq = Index(Line,'=')
         If (neq.Eq.0) Then
            Call WarningMessage(2,'Error in DefInt')
            Write (6,*)
            Write (6,'(A)') '***********************************'
            Write (6,'(A)') ' Syntax error in line :            '
            Write (6,'(A)') Line(1:33),'...'
            Write (6,'(A)') '***********************************'
            Call Quit_OnUserError()
         Else
            iFrst = 1
            Call NxtWrd(Line,iFrst,iEnd)
            jEnd = iEnd
            If (Line(iEnd:iEnd).eq.'=') jEnd = jEnd - 1
            If (jEnd-iFrst+1.gt.8) Then
               Call WarningMessage(2,'Error in DefInt')
               Write (6,*)
               Write (6,'(A)') '***********************************'
               Write (6,'(A)') ' Syntax error in line :            '
               Write (6,'(A)') Line(1:33),'...'
               Write (6,'(A,A)') Line(iFrst:jEnd),
     &               ' has more than 8 character'
               Write (6,'(A)') '***********************************'
               Call Quit_OnUserError()
            End If
            Call ChkLbl(Line(iFrst:jEnd),Labels,iBVct-1)
            Labels(iBVct) = Line(iFrst:jEnd)
         End If
*
*--------Construct the corresponding transformation vector
*
         mCntr = 0
         If (Index(Temp,'CART').Ne.0) Then
            nCntr=1
            nGo = Index(Temp,'CART')
            Call NxtWrd(Temp,nGo,nGo2)
            nGo = nGo2+1
            Call NxtWrd(Temp,nGo,nGo2)
            If (Temp(nGo:nGo2).Eq.'X') Then
               nGo = nGo2+1
               Call NxtWrd(Temp,nGo,nGo2)
               Type='X     '
            Else If (Temp(nGo:nGo2).Eq.'Y') Then
               nGo = nGo2+1
               Call NxtWrd(Temp,nGo,nGo2)
               Type='Y     '
            Else If (Temp(nGo:nGo2).Eq.'Z') Then
               nGo = nGo2+1
               Call NxtWrd(Temp,nGo,nGo2)
               Type='Z     '
            Else
               nGo=-1
               Call WarningMessage(2,'Error in DefInt')
               Write (6,*)
               Write (6,*) '*********** ERROR ************'
               Write (6,*) ' DefInt: wrong cartesian type '
               Write (6,'(A,A)') ' Temp=',Temp
               Write (6,*) '******************************'
               Call Quit_OnUserError()
            End If
         Else If (Index(Temp,'BOND').Ne.0) Then
            nCntr=2
            nGo = Index(Temp,'BOND')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type='STRTCH'
         Else If (Index(Temp,'LANGLE(2)').Ne.0) Then
            nCntr=3
            nGo = Index(Temp,'LANGLE(2)')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='LBEND2'
         Else If (Index(Temp,'LANGLE(1)').Ne.0) Then
            nCntr=3
            nGo = Index(Temp,'LANGLE(1)')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='LBEND1'
         Else If (Index(Temp,'ANGL').Ne.0) Then
            nCntr=3
            nGo = Index(Temp,'ANGL')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='BEND  '
         Else If (Index(Temp,'DIHE').Ne.0) Then
            nCntr=4
            nGo = Index(Temp,'DIHE')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='TRSN  '
            Flip=.True. .and. .Not. First
         Else If (Index(Temp,'OUTO').Ne.0) Then
            nCntr=4
            nGo = Index(Temp,'OUTO')
            nGo = nGo-1+Index(Temp(nGo:nTemp),' ')
            Type ='OUTOFP'
         Else If (Index(Temp,'DISS').Ne.0) Then
            i1 = Index(Line,'(')
            i2 = Index(Line,'+')
            i3 = Index(Line,')')
            If (i1.ge.i2 .or. i2.ge.i3) Then
               Call WarningMessage(2,'Error in DefInt')
               Write (6,*)
               Write (6,*) '********** ERROR ************'
               Write (6,*)' Line contains syntax error !'
               Write (6,'(A)') Line
               Write (6,*) i1,i2,i3
               Write (6,*) '*****************************'
               Call Quit_OnUserError()
            End If
            nGo = i3+1
            Temp = Line(i1+1:i2-1)
            Read (Temp,Format) Tmp
            nCntr=NInt(Tmp)
            Temp=Line(i2+1:i3-1)
            Read (Temp,Format) Tmp
            mCntr=NInt(Tmp)
            Type ='DISSOC'
         Else
            nGo=-1
            Call WarningMessage(2,'Error in DefInt')
            Write (6,*)
            Write (6,*) '*********** ERROR ***********'
            Write (6,*)' Line contains syntax error !'
            Write (6,'(A)') Line
            Write (6,*) '*****************************'
            Call Quit_OnUserError()
         End If
*
         msAtom = nCntr + mCntr
         Call mma_allocate(xyz ,3*msAtom,Label='xyz')
         Call mma_allocate(Tmp2,3*msAtom,Label='Tmp2')
         Call mma_allocate(Ind ,2*msAtom,Label='Ind')
         Call mma_allocate(Mass,2*msAtom,Label='Mass')
         Call mma_allocate(TM,9*nAtom*(nCntr+mCntr),Label='TM')
*
         Call Cllct(Line(nGo:nTemp),BVct(1,iBVct),Value_Temp,
     &              nAtom,Coor,nCntr,mCntr,
     &              xyz,Tmp2,Ind,Type,
     &              Mass,TM,lWrite,
     &              Labels(iBVct),lWrite,
     &              rMult(iBVct),lAtom)
*
         If (.Not.First .and.
     &       Type.eq.'TRSN' .and.
     &       Abs(Value_Temp).lt.Pi*Half) Flip=.False.
         If (Flip .and.
     &       Value(iBVct)*Value_Temp.lt.Zero ) Then
*           Write (Lu,*) 'Flip Sign for ',Labels(iBVct)
            If (Value(iBVct).lt.Zero) Then
               Value(iBVct)= -Pi - (Pi-Value_Temp)
            Else
               Value(iBVct)=  Pi + (Pi+Value_Temp)
            End If

         Else
            Value(iBVct)= Value_Temp
         End If

*
         Call mma_deallocate(TM)
         Call mma_deallocate(Mass)
         Call mma_deallocate(Ind)
         Call mma_deallocate(Tmp2)
         Call mma_deallocate(xyz)
*
 10   Continue
      Call WarningMessage(2,'Error in DefInt')
      Write (6,*) '**********************************************'
      Write (6,*) ' ERROR: No internal coordinates are defined ! '
      Write (6,*) '**********************************************'
      Call Quit_OnUserError()
*
 100  Continue
      nDefPICs = iBVct
      If (iPrint.ge.59) Call RecPrt(' The B-vectors',' ',
     &                              BVct,3*nAtom,nBVct)
      If (iPrint.ge.19) Call RecPrt(
     &        ' Values of primitive internal coordinates / au or rad',
     &                             ' ',Value,nBVct,1)
*
*     Step 2. Define internal coordinates as linear combinations of
*     the previously defined primitive internal coordinates.
*
      iBMtrx = 0
      jLines=iLines
 201  Continue
         jLines=jLines+1
         If (jLines.gt.iRow) Go To 200
*
*------- Jump over the FIX keyword if present
*
         Read (Lu_UDIC,'(A)') Line
         Temp = Line
         Call UpCase(Temp)
         If (Temp(1:3).Eq.'FIX') Go To 20
         If (Temp(1:4).Eq.'ROWH') Go To 30
*
         iBMtrx = iBMtrx + 1
         rInt(iBMtrx) = Zero
         RR=Zero
*
         iFrst = 1
         Call NxtWrd(Line,iFrst,iEnd)
         jEnd = iEnd
         If (Line(iEnd:iEnd).eq.'=') jEnd=iEnd-1
         Lbl(iBMtrx) = Line(iFrst:jEnd)
         neq = Index(Line,'=')
         If (neq.Eq.0) Then
*
*           a single vector (this will only extend over one line)
*
            iBVct = 0
            Do 21 jBVct = 1, nBVct
               If (Line(iFrst:jEnd).eq.Labels(jBVct))
     &            iBVct=jBVct
 21         Continue
            If (iBVct.eq.0) Then
               Call WarningMessage(2,'Error in DefInt')
               Write (6,*)
               Write (6,*) '*******************************'
               Write (6,*) ' ERROR: A single vector        '
               Write (6,*) ' Undefined internal coordinate '
               Write (6,'(A,A)') Line
               Write (6,'(A,A)') Line(iFrst:jEnd)
               Write (6,*) '*******************************'
               Call ErrTra
               Call Quit_OnUserError()
            End If
*
            lPIC(iBVct) = .False.
            call dcopy_(3*nAtom,BVct(1,iBVct),1,BMtrx(1,iBMtrx),1)
            Call DScal_(3*nAtom,rMult(iBVct)**2,
     &                 BMtrx(1,iBMtrx),1)
            rInt(iBMtrx) = rMult(iBVct)**2*Value(iBVct)
            RR=RR+rMult(iBVct)**2
*
         Else
*
*-----------A linear combination of vectors
*
            call dcopy_(3*nAtom,[Zero],0,BMtrx(1,iBMtrx),1)
            iFrst = neq + 1
            Sgn=One
*
*-----------Process the rest of the line and possible extension lines
*
 22         Continue
*              Get the factor
               Call NxtWrd(Line,iFrst,iEnd)
               Temp=Line(iFrst:iEnd)
               Read (Temp,Format) Fact
               Fact = Fact * Sgn
               iFrst = iEnd + 1
*              Get the label
               Call NxtWrd(Line,iFrst,iEnd)
               iBVct = 0
               Do jBVct = 1, nBVct
                  If (Line(iFrst:iEnd).eq.Labels(jBVct)) iBVct=jBVct
               End Do
               If (iBVct.eq.0) Then
                  Call WarningMessage(2,'Error in DefInt')
                  Write (6,*)
                  Write (6,*) '************ ERROR *************'
                  Write (6,*) ' Linear combinations of vectors '
                  Write (6,*) ' Undefined internal coordinate  '
                  Write (6,'(A,A)') Line
                  Write (6,'(A,A)') Line(iFrst:iEnd)
                  Write (6,*) '********************************'
                  Call ErrTra
                  Call Quit_OnUserError()
               End If
*
               lPIC(iBVct) = .False.
               Call DaXpY_(3*nAtom,Fact*rMult(iBVct)**2,
     &                    BVct(1,iBvct),1,
     &                    BMtrx(1,iBMtrx),1)
               rInt(iBMtrx) = rInt(iBMtrx)
     &                      + Fact * rMult(iBVct)**2
     &                      * Value(iBVct)
               RR=RR+rMult(iBVct)**2*Fact**2
*
               iFrst = iEnd + 1
               Temp=Line(iFrst:nTemp)
               nPlus = Index(Temp,'+')
               nMinus= Index(Temp,'-')
            If (nPlus.ne.0.and.(nPlus.lt.nMinus.eqv.nMinus.gt.0)) Then
               Sgn=One
               iFrst = iFrst + nPlus
               Go To 22
            End If
            If (nMinus.ne.0.and.(nMinus.lt.nPlus.eqv.nPlus.gt.0)) Then
               Sgn=-One
               iFrst = iFrst + nMinus
               Go To 22
            End If
*
*---------- Here if all statements processed of this line
*
            If (Index(Line,'&').ne.0) Then
               jLines=jLines+1
               If (jLines.gt.iRow) Then
                  Call WarningMessage(2,'Error in DefInt')
                  Write(6,*)
                  Write(6,*) '********** ERROR *********'
                  Write(6,*) ' DefInt: jLines.gt.iRow '
                  Write(6,*) '**************************'
                  Call Quit_OnUserError()
               End If
               Read (Lu_UDIC,'(A)') Line
               iFrst = 1
               Call NxtWrd(Line,iFrst,iEnd)
               If (Line(iFrst:iEnd).eq.'+') Then
                  iFrst = iEnd + 1
                  Sgn=One
                  Go To 22
               Else If (Line(iFrst:iEnd).eq.'-') Then
                  iFrst = iEnd + 1
                  Sgn=-One
                  Go To 22
               Else
                  Call WarningMessage(2,'Error in DefInt')
                  Write (6,*)
                  Write (6,*) '************** ERROR *************'
                  Write (6,*) ' Syntax Error: first character in '
     &                      //' extension line is not + or -'
                  Write (6,'(A)') Line
                  Write (6,'(3A)') '-->',Line(iFrst:iEnd),'<--'
                  Write (6,*) '**********************************'
                  Call Quit_OnUserError()
               End If
            End If
*
         End If
*
       rInt(iBMtrx)=rInt(iBMtrx)/Sqrt(RR)
       Call DScal_(3*nAtom,One/Sqrt(RR),BMtrx(1,iBMtrx),1)
*
 20   Continue
      Go To 201
*
* --- Skip the  RowH  section of input ---
*
 30   jLines=jLines+1
      If (jLines.gt.iRow) Go To 200
      Read (Lu_UDIC,'(A)') Line
      Temp = Line
      Call UpCase(Temp)
      Go To 30
*-----------------------------------------
 200  Continue
      If (iPrint.ge.99) Call RecPrt(' The B-matrix',' ',
     &                              BMtrx,3*nAtom,nQQ)
*
      If (lWrite) Then
         Write (6,*)
         Write (6,*)
         Write (6,*) '*********************************************'
         Write (6,*) '* Value of internal coordinates / au or rad *'
         Write (6,*) '---------------------------------------------'
         Write (6,'(1X,A,2X,F10.4)')
     &         (Lbl(iInt),rInt(iInt),iInt=1,nQQ)
         Write (6,*)
         Call XFlush(6)
      End If
*
* --- Some checks: Warnings & Errors ---
*
      iDiff = 3*nAtom-nDim
      If (iDiff.eq.0) Then
        cNum = '3N'
      Else
        Write(cNum,'(A,I1)') '3N-',iDiff
      End If

      If (iBMtrx.LT.nDim) then
         Write (6,*) '**************** ERROR **********************'
         Write (6,*) ' N.r of Internal Coordinates lower than ',cNum
         Write (6,*) '*********************************************'
         Write (6,*)
         lErr = .True.
      EndIf

      If (iBMtrx.GT.nDim.and..NOT.Redundant) then
         Write (6,*) '***************** ERROR ***********************'
         Write (6,*) ' N.r of Internal Coordinates greater than ',cNum
         Write (6,*) '***********************************************'
         Write (6,*)
         lErr = .True.
      EndIf

      If (nDefPICs.LT.iBMtrx) then
         Write (6,*)
         Write (6,*) '****************** ERROR ******************'
         Write (6,*) ' Too many Internal Coordinates !           '
         Write (6,'(A,I4)') ' N.r of Primitive Internal Coordinates:',
     &                                                    nDefPICs
         Write (6,'(A,I4)') ' N.r of Internal Coordinates:          ',
     &                                                      iBMtrx
         Write (6,*) '*******************************************'
         Write (6,*)
         lErr = .True.
      EndIf

      Do i = 1, nDefPICs
         If (lPIC(i)) then
            Write (6,*)
            Write (6,*) '*************** ERROR *******************'
            Write (6,*) ' Primitive Internal Coordinate not used: '
            Write (6,*) ' ',Labels(i)
            Write (6,*) '*****************************************'
            Write (6,*)
            lErr = .True.
         EndIf
      EndDo

      Do i = 1, nAtom
         If (lAtom(i)) then
            Call WarningMessage(2,'Error in DefInt')
            Write (6,*)
            Write (6,*) '*********** ERROR ****************'
            Write (6,*) ' No Coordinate defined for atom:  '
            Write (6,*) ' ',AtomLbl(i)
            Write (6,*) '**********************************'
            Write (6,*)
            lErr = .True.
         EndIf
      End Do

      If (lErr) Call Quit_OnUserError()

      If (iBMtrx.ne.nQQ) Then
         Call WarningMessage(2,'Error in DefInt')
         Write (6,*)
         Write (6,*) '******************* ERROR *****************'
         If (iBMtrx.gt.nQQ)
     &      Write (6,*) ' Too many internal coordinates are defined'
         If (iBMtrx.lt.nQQ)
     &      Write (6,*) ' Too few internal coordinates are defined'
         Write (6,*) ' You have defined', iBMtrx
         Write (6,*) ' There should be ', nQQ
         Write (6,*) '*******************************************'
         Call Quit_OnUserError()
      End If

      Close(Lu_UDIC)
      First = .False.

      Call mma_deallocate(Labels)
      Call mma_deallocate(rMult)
      Call mma_deallocate(Value)
      Call mma_deallocate(BVct)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016, Thomas Bondo Pedersen                            *
************************************************************************
#if defined (_CHO_DEBUGPRINT_)
#define _DEBUGPRINT_
#endif
      SubRoutine Cho_VecBuf_Ini2()
C
C     Thomas Bondo Pedersen, June 2006.
C
C     Purpose: read vectors from disk into buffer.
C
      use ChoVecBuf, only: CHVBUF, ip_CHVBUF_SYM, l_CHVBUF_SYM,
     &                     nVec_in_Buf
      Implicit None
#include "cholesky.fh"

      Character*15 SecNam
      Parameter (SecNam = 'Cho_VecBuf_Ini2')

      Logical LocDbg
#if defined (_DEBUGPRINT_)
      Parameter (LocDbg = .true.)
#else
      Parameter (LocDbg = .false.)
#endif
      Logical DoRead

      Integer iV1, iV2, iSym, nRead, iRedC
      Integer mUsed(8)
      Integer irc

C     Check if buffer is allocated.
C     Check if there are any vectors.
C     -------------------------------

      If (.NOT.Allocated(CHVBUF)) Then
         If (LocDbg) Then
            Write(Lupri,*) SecNam,': returning immediately: ',
     &                     'No buffer allocated!'
         End If
         Return
      End If
      If (NumChT .lt. 1) Then
         Write(Lupri,*) SecNam,': returning immediately: ',
     &                  'Buffer allocated, but no vectors!?!?'
         Return
      End If

C     Read vectors.
C     -------------

      DoRead = .true.
      iRedC = -1
      Do iSym = 1,nSym
         iV1 = 1
         iV2 = NumCho(iSym)
         nRead = 0
         mUsed(iSym) = 0
         Call Cho_VecRd1(CHVBUF(ip_ChVBuf_Sym(iSym)),
     &                   l_ChVBuf_Sym(iSym),
     &                   iV1,iV2,iSym,nRead,iRedC,mUsed(iSym),DoRead)
         nVec_in_Buf(iSym) = nRead
      End Do

C     Debug:
C     Enable integrity checks.
C     Print info.
C     ------------------------

      If (LocDbg) Then
         Call Cho_VecBuf_EnableIntegrityCheck(irc)
         If (irc.ne.0) Then
            Write(LuPri,'(A,I9)')
     &      SecNam,': Cho_VecBuf_EnableIntegrityCheck returned code',irc
            Call Cho_Quit(SecNam//': integrity check init failed',104)
         Else
            Write(LuPri,'(A,A)')
     &      SecNam,': buffer integrity check enabled'
         End If
         Write(Lupri,'(A,A,8I10)') SecNam,'(exit): NumCho:',
     &                             (NumCho(iSym),iSym=1,nSym)
         Write(Lupri,'(A,A,8I10)') SecNam,'(exit): nVec_in_Buf:',
     &                             (nVec_in_Buf(iSym),iSym=1,nSym)
         Write(Lupri,'(A,A,8I10)') SecNam,'(exit): buffer allocated:',
     &                             (l_ChVBuf_Sym(iSym),iSym=1,nSym)
         Write(Lupri,'(A,A,8I10)') SecNam,'(exit): memory used:',
     &                             (mUsed(iSym),iSym=1,nSym)
         Call Cho_Flush(Lupri)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Per Ake Malmqvist                                *
************************************************************************
      SUBROUTINE CMBN2DC(RNXYZ,NZETA,LA,LB,ZETA,RKAPPA,
     &                  FINAL,ALPHA,BETA,IFGRAD)
************************************************************************
*
* OBJECT: COMPUTE THE SECOND DERIVATIVE NON-ADIABATIC COUPLING
* MATRIX ELEMENTS, OF TYPE < D/DX CHI_1 | D/DX CHI_2 >
* WITH DIFFERENTIATION WRT NUCLEAR COORDINATES
*
*     AUTHOR: PER AKE MALMQVIST NOV 2000
*             DEPT. OF THEORETICAL CHEMISTRY,
*             UNIVERSITY OF LUND, SWEDEN
*             FOLLOWING THE PATTERN OF R. LINDH,
*             SAME PLACE.
*
************************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 FINAL(NZETA,(LA+1)*(LA+2)/2,(LB+1)*(LB+2)/2,1),
     &       ZETA(NZETA), RKAPPA(NZETA), BETA(NZETA),
     &       RNXYZ(NZETA,3,0:LA+1,0:LB+1), ALPHA(NZETA)
      LOGICAL IFGRAD(3)
* STATEMENT FUNCTION FOR CARTESIAN INDEX
      IND(IXYZ,IX,IZ) = (IXYZ-IX)*(IXYZ-IX+1)/2 + IZ + 1
*
C PREFACTOR FOR THE PRIMITIVE OVERLAP MATRIX
      DO IZETA=1,NZETA
        RKAPPA(IZETA)=RKAPPA(IZETA)*(ZETA(IZETA)**(-1.5D0))
      END DO

C LOOP STRUCTURE FOR THE CARTESIAN ANGULAR PARTS
      DO 10 IXA = 0, LA
         IYAMAX=LA-IXA
      DO 11 IXB = 0, LB
         IYBMAX=LB-IXB
         DO 20 IYA = 0, IYAMAX
            IZA = LA-IXA-IYA
            IPA= IND(LA,IXA,IZA)
         DO 21 IYB = 0, IYBMAX
            IZB = LB-IXB-IYB
            IPB= IND(LB,IXB,IZB)

* COMBINE 1-DIM PRIMITIVE OVERLAP INTEGRALS
      IF (IFGRAD(1)) THEN
C COMPUTE INTEGRALS TYPE <D/DX,D/DX>
         DO IZETA=1,NZETA
           DIFFX=4D0*ALPHA(IZETA)*BETA(IZETA)*RNXYZ(IZETA,1,IXA+1,IXB+1)
           IF(IXB.GT.0) THEN
             DIFFX=DIFFX-2D0*ALPHA(IZETA)*DBLE(IXB)*
     >             RNXYZ(IZETA,1,IXA+1,IXB-1)
             IF(IXA.GT.0) THEN
               DIFFX=DIFFX+DBLE(IXA*IXB)*RNXYZ(IZETA,1,IXA-1,IXB-1)
             END IF
           END IF
           IF(IXA.GT.0) THEN
             DIFFX=DIFFX-DBLE(2*IXA)*BETA(IZETA)*
     >             RNXYZ(IZETA,1,IXA-1,IXB+1)
           END IF
           OVLY=RNXYZ(IZETA,2,IYA,IYB)
           OVLZ=RNXYZ(IZETA,3,IZA,IZB)
           FINAL(IZETA,IPA,IPB,1)=RKAPPA(IZETA)*DIFFX*OVLY*OVLZ
         END DO
      END IF
      IF (IFGRAD(2)) THEN
C COMPUTE INTEGRALS TYPE <D/DY,D/DY>
         DO IZETA=1,NZETA
           DIFFY=4D0*ALPHA(IZETA)*BETA(IZETA)*RNXYZ(IZETA,2,IYA+1,IYB+1)
           IF(IYB.GT.0) THEN
             DIFFY=DIFFY-2D0*ALPHA(IZETA)*DBLE(IYB)*
     >             RNXYZ(IZETA,2,IYA+1,IYB-1)
             IF(IYA.GT.0) THEN
               DIFFY=DIFFY+DBLE(IYA*IYB)*RNXYZ(IZETA,2,IYA-1,IYB-1)
             END IF
           END IF
           IF(IYA.GT.0) THEN
             DIFFY=DIFFY-DBLE(2*IYA)*BETA(IZETA)*
     >             RNXYZ(IZETA,1,IYA-1,IYB+1)
           END IF
           OVLX=RNXYZ(IZETA,1,IXA,IXB)
           OVLZ=RNXYZ(IZETA,3,IZA,IZB)
           FINAL(IZETA,IPA,IPB,1)=RKAPPA(IZETA)*OVLX*DIFFY*OVLZ
         END DO
      END IF
      IF (IFGRAD(1)) THEN
C COMPUTE INTEGRALS TYPE <D/DZ,D/DZ>
         DO IZETA=1,NZETA
           DIFFZ=4D0*ALPHA(IZETA)*BETA(IZETA)*RNXYZ(IZETA,1,IZA+1,IZB+1)
           IF(IZB.GT.0) THEN
             DIFFZ=DIFFZ-2D0*ALPHA(IZETA)*DBLE(IZB)*
     >             RNXYZ(IZETA,1,IZA+1,IZB-1)
             IF(IZA.GT.0) THEN
               DIFFZ=DIFFZ+DBLE(IZA*IZB)*RNXYZ(IZETA,1,IZA-1,IZB-1)
             END IF
           END IF
           IF(IZA.GT.0) THEN
             DIFFZ=DIFFZ-DBLE(2*IZA)*BETA(IZETA)*
     >             RNXYZ(IZETA,1,IZA-1,IZB+1)
           END IF
           OVLX=RNXYZ(IZETA,1,IXA,IXB)
           OVLY=RNXYZ(IZETA,2,IYA,IYB)
           FINAL(IZETA,IPA,IPB,1)=RKAPPA(IZETA)*OVLX*OVLY*DIFFZ
         END DO
      END IF

C END OF LOOP NEST OVER CARTESIAN ANGULAR COMPONENT
 21      CONTINUE
 20      CONTINUE
 11   CONTINUE
 10   CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_RS2RS(IMAP,LMAP,IRS2,IRS3,IRED3,ISYM)
C
C     Purpose: set up mapping between reduced sets stored at IRS2 and
C              IRS3 (IRED3 is the reduced set id of IRS3).
C
C     WARNING: for IRED3 = 1, INDRED is reset here!!!!
C
#include "implicit.fh"
      INTEGER IMAP(LMAP)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*9 SECNAM
      PARAMETER (SECNAM = 'CHO_RS2RS')

      IIBSTRSH(I,J,K)=IWORK(ip_IIBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)

C     Check input.
C     ------------

      IF (IRS2.LT.1 .OR. IRS2.GT.3 .OR.
     &    IRS3.LT.1 .OR. IRS3.GT.3) THEN
         CALL CHO_QUIT('Index error in '//SECNAM,104)
      ELSE IF (LMAP .LT. NNBSTR(ISYM,IRS2)) THEN
         CALL CHO_QUIT('Dimension error in '//SECNAM,104)
      END IF

C     For IRED3 = 1, INDRED array addresses into shell pair. We hence
C     need to reset it (as warned about above).
C     ---------------------------------------------------------------

      IF (IRED3 .EQ. 1) THEN
         K0 = ip_INDRED - 1 + MMBSTRT*(IRS3 - 1)
         I1 = IIBSTR(ISYM,IRS3) + 1
         I2 = I1 + NNBSTR(ISYM,IRS3) - 1
         DO I = I1,I2
            IWORK(K0+I) = I
         END DO
      END IF

C     Set up mapping array.
C     ---------------------

      CALL CHO_IZERO(IMAP,NNBSTR(ISYM,IRS2))
      DO ISHLAB = 1,NNSHL
         N2 = NNBSTRSH(ISYM,ISHLAB,IRS2)
         N3 = NNBSTRSH(ISYM,ISHLAB,IRS3)
         IF (N2.GT.0 .AND. N3.GT.0) THEN
            IF (N2 .LT. N3) THEN
               IAB1 = IIBSTRSH(ISYM,ISHLAB,IRS2) + 1
               IAB2 = IAB1 + N2 - 1
               LAST = 0
               DO IAB = IAB1,IAB2
                  JAB = INDRED(IIBSTR(ISYM,IRS2)+IAB,IRS2)
                  KAB = LAST
                  DO WHILE (KAB .LT. NNBSTRSH(ISYM,ISHLAB,IRS3))
                     KAB = KAB + 1
                     LAB = IIBSTRSH(ISYM,ISHLAB,IRS3) + KAB
                     MAB = INDRED(IIBSTR(ISYM,IRS3)+LAB,IRS3)
                     IF (MAB .EQ. JAB) THEN
                        IMAP(IAB) = LAB
                        LAST = KAB
                        KAB  = NNBSTRSH(ISYM,ISHLAB,IRS3)
                     END IF
                  END DO
               END DO
            ELSE
               LAB1 = IIBSTRSH(ISYM,ISHLAB,IRS3) + 1
               LAB2 = LAB1 + N3 - 1
               LAST = 0
               DO LAB = LAB1,LAB2
                  MAB = INDRED(IIBSTR(ISYM,IRS3)+LAB,IRS3)
                  KAB = LAST
                  DO WHILE (KAB .LT. NNBSTRSH(ISYM,ISHLAB,IRS2))
                     KAB = KAB + 1
                     IAB = IIBSTRSH(ISYM,ISHLAB,IRS2) + KAB
                     JAB = INDRED(IIBSTR(ISYM,IRS2)+IAB,IRS2)
                     IF (JAB .EQ. MAB) THEN
                        IMAP(IAB) = LAB
                        LAST = KAB
                        KAB  = NNBSTRSH(ISYM,ISHLAB,IRS2)
                     END IF
                  END DO
               END DO
            END IF
         END IF
      END DO

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

subroutine WelInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: to compute the Pauli repulsion integrals with the            *
!         Gauss-Hermite quadrature.                                    *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden. October '92.                            *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "wldata.fh"
#include "print.fh"
integer(kind=iwp) :: i, ik, iOff, ip, ip1, ip2, ip3, ip4, ip5, ipA, ipGri, ipGrin, iPrint, ipScr, iPxyz, iRout, jsum, k

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(ZInv)
unused_var(nHer)
unused_var(Ccoor)
unused_var(nOrdOp)
unused_var(lOper)
unused_var(iChO)
unused_var(iStabM)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 122
iPrint = nPrint(iRout)
!iQ = 1
if (iPrint >= 59) then
  write(u6,*) ' In WelInt'
  write(u6,*) ' r0, ExpB=',r0,ExpB
  write(u6,*) ' la,lb=',la,lb
end if

k = la+lb
jsum = 1
do i=1,k
  jsum = jsum+3**i
end do

ip = 1
ipGri = ip
ip = ip+nZeta*jsum
ipGrin = ip
ip = ip+nZeta*(k+1)*(k/2+1)*(k/4+1)
iPxyz = ip
ip = ip+nZeta
if (ip-1 > nZeta*nArr) then
  call WarningMessage(2,'WelInt:  ip-1 > nZeta*nArr(pos.1)')
  write(u6,*) ip-1,'>',nZeta*nArr
  call Abend()
end if

call Rowel(nZeta,r0,expB,k,Zeta,P,Array(iPxyz),Array(ipGri),Array(ipGrin),jsum)
ip = ip-nZeta
ip = ip-nZeta*(k+1)*(k/2+1)*(k/4+1)

ipA = ip
ip = ip+nZeta*9
ipScr = ip
ip = ip+nZeta*3**k
if (ip-1 > nZeta*nArr) then
  call WarningMessage(2,'WelInt:  ip-1 > nZeta*nArr(pos.2)')
  write(u6,*) ip-1,'>',nZeta*nArr
  call Abend()
end if

! Transform each block to the global coordinate system

iOff = ipgri+nZeta
do ik=1,k
  if (ik == 1) call SetUpA(nZeta,Array(ipA),P)
  call Traxyz(nZeta,ik,Array(iOff),Array(ipScr),Array(ipA))
  iOff = iOff+nZeta*3**ik
end do
if (iPrint >= 99) call RecPrt(' In WelInt: Array(ipGri)',' ',Array(ipGri),nZeta,jSum)
ip = ip-nZeta*3**k
ip = ip-nZeta*9

ip1 = ip
ip = ip+nZeta
ip2 = ip
ip = ip+nZeta
ip3 = ip
ip = ip+nZeta
ip4 = ip
ip = ip+nZeta
ip5 = ip
ip = ip+nZeta
if (ip-1 > nZeta*nArr) then
  call WarningMessage(2,'WelInt:  ip-1 > nZeta*nArr(pos.3)')
  write(u6,*) ip-1,'>',nZeta*nArr
  call Abend()
end if
call TraPAB(nZeta,la,lb,rFinal,Array(ipgri),jSum,rKappa,Array(ip1),Array(ip2),Array(ip3),Array(ip4),Array(ip5),A,RB,P)
ip = ip-nZeta*5
ip = ip-nZeta*jsum

return

end subroutine WelInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PT2INI()

use INPUTDATA, only: INPUT, READIN_CASPT2
use PT2WFN, only: PT2WFN_DATA, PT2WFN_INIT
use REFWFN, only: REFWFN_CLOSE, REFWFN_DATA, REFWFN_INFO, REFWFN_INIT
use Cholesky, only: MaxVec, NumCho
use ChoCASPT2, only: MaxVec_PT2, NASPlit, NISplit, NumCho_PT2
use spool, only: Close_LuSpool, SpoolInp
use Molcas, only: LenIn
use caspt2_global, only: CMOPT2, DMIX, do_grad, DREF, DWGT, FIFA, FIMO, iStpGrd, NCMO, NDREF, NPREF, NTAT, NTORB, PREF, TAT, TORB
use caspt2_module, only: bName, Header, ifChol, jState, nAsh, nBas, nBasT, nBSqT, nIsh, nOTri, nSsh, nState, nSym
#ifdef _DMRG_
use qcmaquis_interface_cfg, only: qcmaquis_param
use PrintLevel, only: DEBUG
use caspt2_global, only: iPrGlb
use caspt2_module, only: DMRG, nAshT
#endif
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iRC, iSym, LuSpool

call SETTIM()

! Probe the environment to globally set the IPRGLB value
call Set_Print_Level()

! Probe the RunFile for some basic information

call Get_cArray('Seward Title',Header,144)
call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
nbast = sum(nbas(1:nsym))
nbsqt = sum(nbas(1:nsym)**2)
call Get_cArray('Unique Basis Names',bName,(LenIn+8)*nbast)
jstate = 1
call DecideOnCholesky(IfChol)
! PAM Feb 2008: The following statement was moved here from
! prpctl, in case prpctl call is bypassed by keyword ''NOPROP''.
call Put_cArray('Relax Method','CASPT2  ',8)

! Allocate Input struct, read and process the Input

allocate(Input)
LuSpool = 21
call SpoolInp(LuSpool)
call READIN_CASPT2(LuSpool,nSym)
call Close_LuSpool(LuSpool)
! Initialize scratch files.
call OPNFLS_CASPT2()
! Initialize the reference wavefunction file and read basic info
call refwfn_init(Input%FILE)
call refwfn_info()
! the input processing needs some data from the reference wavefunction
! to be set, hence this phase occurs after reading that data.
call ProcInp_Caspt2()

! Allocate some arrays that will stay globally allocated:

! Finally read the MO and CI data from the refwfn file, and close it as
! we have no more need for it and the same filename might be reused for
! the pt2wfn file. We do this after input processing because we need to
! know which roots to pick up. The MOs are stored on LUONEM, at address
! IAD1M(1), and the CI arrays on LUCIEX at IDCIEX.
call refwfn_data()
call refwfn_close()

! If necessary, make modifications to the inactive/virtual orbitals. The
! new MOs, if any, will overwrite the originals on LUONEM at IAD1M(1).
if (Input%modify_correlating_MOs) call correlating_orbitals()

! After possible reconfiguration of inactives/virtuals, the computation
! of total sizes of orbital spaces is done here, before any other code
! (that might rely on these to be correctly set!)
call wfnsizes()

#ifdef _DMRG_
if (DMRG) then
  ! set the lattice length (i.e. the active space size)
  qcmaquis_param%L = nasht
  if (iPrGlb >= DEBUG) write(u6,*) 'PT2INI> qcmaquis_param%L = ',qcmaquis_param%L
end if
#endif
! Create the PT2 wavefunction file (formerly JOBMIX). The reference file
! should not be active, as it might be the same file (in which case it
! is overwritten).
call pt2wfn_init()
call pt2wfn_data()

! Global allocations active throughout the program (NOTRI was computed
! during the call to wfnsizes, so this is done here.)

! The total fock matrix (sum of inactive and active contrib.)
call mma_allocate(FIFA,NOTRI,Label='FIFA')
! The fock matrix with contributions from inactive orbitals, only.
call mma_allocate(FIMO,NOTRI,Label='FIMO')
! Density matrices, active indices.
call mma_allocate(DREF,NDREF,Label='DREF')
call mma_allocate(PREF,NPREF,Label='PREF')
! All the density matrices kept in memory
call mma_allocate(DMIX,NDREF,NSTATE,Label='DMIX')
call mma_allocate(DWGT,NSTATE,NSTATE,Label='DWGT')

! Print input data
call PRINP_CASPT2()

! INITIALIZE SPLIT-GRAPH UGA TABLES.
call SG_SETUP_CASPT2()

! Initialize superindex tables. Check memory needs.
call SIZES()

! Initialize sizes, offsets etc used in equation solver.
call EQCTL1()

if (IfChol) then
  ! initialize Cholesky information
  call Cho_X_init(irc,Zero)
  if (irc /= 0) then
    write(u6,*) 'CASPT2: Non-zero rc in Cho_X_init'
    call QUIT(irc)
  end if
  ! transfer some values from Cholesky module to chocaspt2
  NumCho_PT2(:) = NumCho(:)
  MaxVec_PT2 = MaxVec
  call setup_cho(nSym,nIsh,nAsh,nSsh,NumCho_PT2,'ALLO')
  ! get unit numbers for Cholesky MO vectors
  do iSym=1,nSym
    call Cho_Caspt2_OpenF(0,1,iSym,nIsplit(iSym))
    call Cho_Caspt2_OpenF(0,2,iSym,nAsplit(iSym))
  end do
  ! set up size info for cholesky vector transformation in tracho2
  call trachosz()
end if

! Allocate global orbital arrays:
call mma_allocate(CMOPT2,NCMO,Label='CMOPT2')
CMOPT2(:) = Zero
! Allocate global orbital transformation arrays:
call mma_allocate(TORB,NTORB,Label='TORB')
call mma_allocate(TAT,NTAT,Label='TAT')

! initialize quantities for gradient calculation
iStpGrd = 1 !! Just in case
if (do_grad) call GrdIni()

end subroutine PT2INI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2009, Roland Lindh                                     *
************************************************************************
      Subroutine ReacX(V_Q,nQ,V_X,nX)
************************************************************************
*                                                                      *
*     Objective: Transform the "reaction vector" from internal         *
*                coordinates to Cartesians.                            *
*                                                                      *
*     Roland Lindh, Dept. of Theor. Chem., Lund University, Sweden     *
*     2009                                                             *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "info_slapaf.fh"
      Real*8 V_Q(nQ), V_X(nX)
*                                                                      *
************************************************************************
*                                                                      *
      Call DGEMM_('N','N',
     &           nX,1,nQ,
     &           1.0D0,Work(ipB),nX,
     &                 V_Q,nQ,
     &           0.0D0,V_X,nX)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine newCF(H,n,A,B,C,Bstev)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero, cOne, Onei
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: n
complex(kind=wp), intent(in) :: H(n,n)
complex(kind=wp), intent(out) :: A(n-1,-(n-1):n-1)
real(kind=wp), intent(out) :: B(n,0:n), C(n,0:n), Bstev(n,-n:n)
integer(kind=iwp) :: ik, iq
real(kind=wp) :: C0, cr, knm(12,0:12), mfact, rfact
complex(kind=wp) :: cfact, mf
complex(kind=wp), allocatable :: Cm(:,:), Cp(:,:)
complex(kind=wp), external :: trace

!-------------------------------------------
if (n < 1) return
!-------------------------------------------
call mma_allocate(Cp,n,n,'operator O')
call mma_allocate(Cm,n,n,'operator W')
!-------------------------------------------
! n=2*J+1;  or   n=2*S+1
call set_knm(knm)

Bstev(:,:) = Zero
B(:,:) = Zero
C(:,:) = Zero
A(:,:) = cZero
do ik=1,n-1
  do iq=0,ik
    ! generate the operator matrix K=ik, Q=iq, dimension = n
    call ITO(n,ik,iq,C0,Cp,Cm)
    call coeff_redus_sub(n,ik,cr)

    mfact = real((-1)**iq,kind=wp)
    rfact = C0*C0*real(2*ik+1,kind=wp)/real(n,kind=wp)
    cfact = mfact*rfact*cOne

    !-------------------------------------------
    ! Naoya's C/C0 operators:
    a(ik,-iq) = cfact*trace(n,H,Cp)
    a(ik,iq) = cfact*trace(n,H,Cm)

    !-------------------------------------------
    ! make real combinations of CF parameters:
    ! Liviu's ITO operators:
    if (iq == 0) then
      !b(ik,iq) = real(Half*(A(ik,iq)+A(ik,-iq)))
      b(ik,iq) = real(A(ik,iq))
    else
      mf = real((-1)**iq,kind=wp)*cOne
      b(ik,iq) = real(A(ik,-iq)+mf*A(ik,iq))
      c(ik,iq) = real(-Onei*(A(ik,-iq)-mf*A(ik,iq)))

    end if
    ! scale with the correct ratio:
    b(ik,iq) = b(ik,iq)/(cr*C0)
    c(ik,iq) = c(ik,iq)/(cr*C0)

    !-------------------------------------------
    ! parameters to be used in connection with ESO as in MATLAB
    ! EasySpin program
    ! The ESO operaors are not implemented for k>12 in EasySpin
    ! therefore we do not provide these parameters as well.
    if ((ik <= 12) .and. (iq <= 12)) then
      ! scale with the correct ratio:
      if (iq == 0) then
        bstev(ik,iq) = b(ik,iq)*knm(ik,iq)
      else
        bstev(ik,iq) = b(ik,iq)*knm(ik,iq)
        bstev(ik,-iq) = c(ik,iq)*knm(ik,iq)
      end if
    end if

#   ifdef _DEBUGPRINT_
    write(u6,'(A,2I3,5(ES20.13,1x))') 'k,q, b(k,q), c(k,q)',ik,iq,b(ik,iq),c(ik,iq)
#   endif
  end do
end do

call mma_deallocate(Cp)
call mma_deallocate(Cm)

return

end subroutine newCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014-2016, Steven Vancoillie                           *
*               2015,2020, Ignacio Fdez. Galvan                        *
*               2015, Liviu Ungur                                      *
************************************************************************
* stdalloc: wraps the standard allocate/deallocate fortran intrinsics.
*
* When memory is allocated, it is registered to getmem, and when it is
* deallocated it is excluded. On allocation, a check is made that the
* available memory as reported by getmem is sufficient. Thus, all memory
* allocated here counts towards the maximum allowed by getmem.
*
* To add additional data types or dimensions, just include the file
* "mma_allo_template.fh" with appropriate values for the macros:
*   _SUBR_NAME_: The base name for the subroutines
*   _DATA_NAME_: The data type string for getmem: 'REAL' for real*8,
*                'INTE' for integer, undefined for anything else
*                ['CHAR' would only be appropriate for character(len=1)]
*   _DEF_LABEL_: The default label
*   _TYPE_: The data type
*   _DIMENSIONS_: The number of dimensions
* Then add the subroutines to the list in the generic interface definitions
* in src/Include/stdalloc.fh
*
* Steven Vancoillie, December 2014
* Ignacio Fdez. Galvan, April 2015 (added label optional arg. and _lim variants)
* Liviu Ungur, May 2015 (added support for COMPLEX*16)
* Ignacio Fdez. Galvan, November 2020 (rewrote with preprocessor templates)

#include "molcastypes.fh"

* out-of-memory handling
      subroutine mma_oom(label,bufsize,mma_avail)
        implicit none
#include "warnings.h"
        character(len=*) :: label
        integer :: bufsize, mma_avail
        write(6,'(1x,a)') '?mma_allo_?D: error: out-of-memory'
        write(6,'(1x,a,a)') 'label: ',label
        write(6,'(1x,a,i12)') ' available (kB): ',
     &    nint(mma_avail * 1.0d-3)
        write(6,'(1x,a,i12)') ' required  (kB):  ',
     &    nint(bufsize  * 1.0d-3)
        call quit(_RC_MEMORY_ERROR_)
      end subroutine

* double allocation/deallocation handling
      subroutine mma_double_allo
        implicit none
#include "warnings.h"
        write(6,'(1x,a)') '?mma_allo_?D: error: double allocate'
        call quit(_RC_MEMORY_ERROR_)
      end subroutine
      subroutine mma_double_free
        implicit none
#include "warnings.h"
        write(6,'(1x,a)') '?mma_free_?D: error: double deallocate'
        call quit(_RC_MEMORY_ERROR_)
      end subroutine

      subroutine mma_maxDBLE(mma_avail)
        implicit none
#include "SysDef.fh"
        integer, intent(out) :: mma_avail
        integer, external :: mma_avmem
        mma_avail = mma_avmem()/RtoB
      end subroutine

      subroutine mma_maxINT(mma_avail)
        implicit none
#include "SysDef.fh"
        integer, intent(out) :: mma_avail
        integer, external :: mma_avmem
        mma_avail = mma_avmem()/ItoB
      end subroutine

      subroutine mma_maxbytes(mma_avail)
        implicit none
        integer, intent(out) :: mma_avail
        integer, external :: mma_avmem
        mma_avail = mma_avmem()
      end subroutine

* type-specific pointer-to-offset routines

#define _FUNC_NAME_ d_cptr2loff
#define _TYPE_ real*8
#define _DATA_NAME_ 'REAL'
#include "cptr2loff_template.fh"
#undef _FUNC_NAME_
#undef _TYPE_
#undef _DATA_NAME_

#define _FUNC_NAME_ z_cptr2loff
#define _TYPE_ complex*16
#include "cptr2loff_template.fh"
#undef _FUNC_NAME_
#undef _TYPE_

#define _FUNC_NAME_ i_cptr2loff
#define _TYPE_ integer
#define _DATA_NAME_ 'INTE'
#include "cptr2loff_template.fh"
#undef _FUNC_NAME_
#undef _TYPE_
#undef _DATA_NAME_

#define _FUNC_NAME_ b_cptr2loff
#define _TYPE_ integer*1
#include "cptr2loff_template.fh"
#undef _FUNC_NAME_
#undef _TYPE_

! _WITH_LEN_ enables a workaround for older gfortran
#define _FUNC_NAME_ c_cptr2loff
#define _TYPE_ character(len=*)
#define _DATA_NAME_ 'CHAR'
#define _WITH_LEN_
#include "cptr2loff_template.fh"
#undef _FUNC_NAME_
#undef _TYPE_
#undef _DATA_NAME_
#undef _WITH_LEN_

#define _FUNC_NAME_ l_cptr2loff
#define _TYPE_ logical
#include "cptr2loff_template.fh"
#undef _FUNC_NAME_
#undef _TYPE_

* type-specific allocation subroutines
* each #include defines NAME_allo_xD, NAME_allo_xD_lim, and NAME_free_xD

* real*8 variants

#define _SUBR_NAME_ dmma
#define _TYPE_ real*8
#define _DATA_NAME_ 'REAL'

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'dmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'dmma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'dmma_3D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 4
#  define _DEF_LABEL_ 'dmma_4D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 5
#  define _DEF_LABEL_ 'dmma_5D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 7
#  define _DEF_LABEL_ 'dmma_7D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_
#undef _DATA_NAME_

* complex*16 variants
* (note that there is no specific _DATA_NAME_ for these)

#define _SUBR_NAME_ zmma
#define _TYPE_ complex*16

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'zmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'zmma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'zmma_3D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 4
#  define _DEF_LABEL_ 'zmma_4D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 5
#  define _DEF_LABEL_ 'zmma_5D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_

* integer variants

#define _SUBR_NAME_ imma
#define _TYPE_ integer
#define _DATA_NAME_ 'INTE'

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'imma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'imma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'imma_3D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 4
#  define _DEF_LABEL_ 'imma_4D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 5
#  define _DEF_LABEL_ 'imma_5D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_
#undef _DATA_NAME_

* byte variants

#define _SUBR_NAME_ bmma
#define _TYPE_ integer*1

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'bmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'bmma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_

* character variants
* (no _DATA_NAME_ defined to make sure size is counted in bytes)

#define _SUBR_NAME_ cmma

#define _TYPE_ character(len=:)
#  define _DIMENSIONS_ 0
#  define _DEF_LABEL_ 'cmma_0D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

#define _TYPE_ character(len=*)

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'cmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'cmma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _TYPE_

#undef _SUBR_NAME_

* logical variants
* (note that there is no specific _DATA_NAME_ for these)

#define _SUBR_NAME_ lmma
#define _TYPE_ logical

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'lmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'lmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_

#ifdef _NOT_USED_
* pointer variants

#define _IS_POINTER_

#  define _SUBR_NAME_ ipmma
#  define _TYPE_ integer
#  define _DATA_NAME_ 'INTE'

#    define _DIMENSIONS_ 1
#    define _DEF_LABEL_ 'ipmma_1D'
#    include "mma_allo_template.fh"
#    undef _DIMENSIONS_
#    undef _DEF_LABEL_

#  undef _SUBR_NAME_
#  undef _TYPE_
#  undef _DATA_NAME_

#  define _SUBR_NAME_ dpmma
#  define _TYPE_ real*8
#  define _DATA_NAME_ 'REAL'

#    define _DIMENSIONS_ 1
#    define _DEF_LABEL_ 'dpmma_1D'
#    include "mma_allo_template.fh"
#    undef _DIMENSIONS_
#    undef _DEF_LABEL_

#  undef _SUBR_NAME_
#  undef _TYPE_
#  undef _DATA_NAME_

#undef _IS_POINTER_
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE EXPA2_UHF(ARR1,IDM,LI,NSP,ARR2)
      implicit none
      REAL*8 ARR1,ARR2
      integer IDM,LI,NSP, IJ, I,J
C
C THIS SUBROUTINE EXPANDS THE SECOND INDEX OF A MATRIX ARR1
C
      DIMENSION ARR1(IDM,*),ARR2(IDM,LI,*)
      IJ=0
      CALL ZEROMA(ARR2(1,1,1),1,IDM)
      DO  I=2,LI
         DO  J=1,I-1
            IJ=IJ+1
            CALL DCOPY_(IDM,ARR1(1,IJ),1,ARR2(1,I,J),1)
            CALL DCOPY_(IDM,ARR1(1,IJ),1,ARR2(1,J,I),1)
         ENDDO
         CALL ZEROMA(ARR2(1,I,I),1,IDM)
      ENDDO
      IF(NSP.LT.0)THEN
         DO I=1,LI
            CALL VNEG_CHT3(ARR2(1,1,I),1,ARR2(1,1,I),1,IDM*I)
         enddo
      ENDIF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine Rs2Dgh(xyz2D0,nT,nRys,la,lb,lc,ld,xyz2D1,xyz2D2,IfHss,IndHss,IfGrad,IndGrd,IfG,Coora,Alpha,Beta,Gmma,Delta,nZeta,nEta, &
                  Scrtch,Scrtch2,Temp,Index1,Index2,Index3,Index4,ng,nh,ExpX,ExpY,mZeta,mEta,nIrrep,Tr)
!***********************************************************************
!                                                                      *
! Object:To compute the gradients and the Hessians of the 2D-integrals.*
!                                                                      *
!     Author: Anders Bernhardsson & Roland Lindh,                      *
!             Dept. of Theoretical Chemistry,                          *
!             University of Lund, SWEDEN                               *
!             Februar '95                                              *
!***********************************************************************

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nT, nRys, la, lb, lc, ld, nZeta, nEta, mZeta, mEta, nIrrep
real(kind=wp), intent(in) :: xyz2D0(nRys*nT,0:la+2,0:lb+2,0:lc+2,0:ld+2,3), Coora(3,4), Alpha(nZeta), Beta(nZeta), Gmma(nEta), &
                             Delta(nEta)
real(kind=wp), intent(out) :: xyz2D1(nRys*nT,0:la,0:lb,0:lc,0:ld,3,3), xyz2D2(nRys*nT,0:la,0:lb,0:lc,0:ld,3,6), Scrtch(nRys*nT), &
                              Scrtch2(nRys*nT), Temp(nT)
logical(kind=iwp), intent(inout) :: IfHss(4,3,4,3), IfGrad(3,4), IfG(4), Tr(4)
integer(kind=iwp), intent(inout) :: IndHss(4,3,4,3,0:nIrrep-1), IndGrd(3,4,0:nIrrep-1)
integer(kind=iwp), intent(out) :: Index1(3,4), Index2(3,4,4), Index3(3,3), Index4(2,6,3), ng(3), nh(3)
external :: ExpX, ExpY
integer(kind=iwp) :: i1, i2, i3, i4, i5, ia, ib, ic, iCar, iCent, id, Ind1(3), Ind2(3), Ind3(3), Ind4(3), j4, j5, jCent, kCent, &
                     mVec, mx, my, mz, n, nVec, nvecx, nx, ny, nz
real(kind=wp) :: Fact, ra, rb, rc, rd
logical(kind=iwp), external :: EQ

nx = 0
ny = 0
nz = 0
mx = 0
my = 0
mz = 0
Index1(:,:) = 0
Index2(:,:,:) = 0

! Differentiate with respect to the first center

if (IfG(1)) then
  call ExpX(Temp,mZeta,mEta,Alpha,sqrt(Two))
  call Exp_2(Scrtch,nRys,nT,Temp,sqrt(Two))
  nVec = 0
  if (IfGrad(1,1)) then
    nx = nx+1
    nVec = nVec+1
    Ind1(nVec) = nx
    Ind2(nVec) = 1
    Index1(1,1) = nx
    Index3(nx,1) = 1
  end if
  if (IfGrad(2,1)) then
    ny = ny+1
    nVec = nVec+1
    Ind1(nVec) = ny
    Ind2(nVec) = 2
    Index1(2,1) = ny
    Index3(ny,2) = 1
  end if
  if (IfGrad(3,1)) then
    nz = nz+1
    nVec = nVec+1
    Ind1(nVec) = nz
    Ind2(nVec) = 3
    Index1(3,1) = nz
    Index3(nz,3) = 1
  end if
  Ind1(nVec+1:) = 0

  mVec = 0
  if (IfHss(1,1,1,1)) then
    mx = mx+1
    mVec = mVec+1
    Ind3(mVec) = mx
    Ind4(mVec) = 1
    Index2(1,1,1) = mx
    Index4(1,mx,1) = 1
    Index4(2,mx,1) = 1
  end if
  if (IfHss(1,2,1,2)) then
    my = my+1
    mVec = mVec+1
    Ind3(mVec) = my
    Ind4(mVec) = 2
    Index2(2,1,1) = my
    Index4(1,my,2) = 1
    Index4(2,my,2) = 1
  end if
  if (IfHss(1,3,1,3)) then
    mz = mz+1
    mVec = mVec+1
    Ind3(mVec) = mz
    Ind4(mVec) = 3
    Index2(3,1,1) = mz
    Index4(1,mz,3) = 1
    Index4(2,mz,3) = 1
  end if
  Ind3(mVec+1:) = 0
  nvecx = max(nVec,mVec)
  if (nVecx /= 0) then

    ! Here we go with center 1

    do n=1,nVec
      do id=0,ld
        do ic=0,lc
          do ib=0,lb
            ra = -One
            do ia=0,la
              ra = ra+Two
              xyz2D1(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch(:)*xyz2D0(:,ia+1,ib,ic,id,Ind2(n))
            end do
          end do
        end do
      end do
    end do
    do n=1,mVec
      do id=0,ld
        do ic=0,lc
          do ib=0,lb
            ra = -One
            do ia=0,la
              ra = ra+Two
              xyz2D2(:,ia,ib,ic,id,Ind4(n),Ind3(n)) = Scrtch(:)**2*xyz2D0(:,ia+2,ib,ic,id,Ind4(n))- &
                                                      ra*Scrtch(:)*xyz2D0(:,ia,ib,ic,id,Ind4(n))
            end do
          end do
        end do
      end do
    end do
    if (la >= 1) then
      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            do ib=0,lb
              ra = Zero
              do ia=1,la
                ra = ra+One
                xyz2D1(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D1(:,ia,ib,ic,id,Ind2(n),Ind1(n))-ra*xyz2D0(:,ia-1,ib,ic,id,Ind2(n))
              end do
            end do
          end do
        end do
      end do
    end if
    if (la >= 2) then
      do n=1,mVec
        do id=0,ld
          do ic=0,lc
            do ib=0,lb
              ra = One
              do ia=2,la
                ra = ra+One
                Fact = ra*ra-ra
                xyz2D2(:,ia,ib,ic,id,Ind4(n),Ind3(n)) = xyz2D2(:,ia,ib,ic,id,Ind4(n),Ind3(n))+Fact*xyz2D0(:,ia-2,ib,ic,id,Ind4(n))
              end do
            end do
          end do
        end do
      end do
    end if
  end if
end if

! Cross term center 1 and center 2
if (IfG(2)) then
  call ExpX(Temp,mZeta,mEta,Beta,sqrt(Two))
  call Exp_2(Scrtch2,nRys,nT,Temp,sqrt(Two))
end if
if (IfG(2) .and. IfG(1)) then
  nVec = 0
  if (IfHss(2,1,1,1)) then
    mx = mx+1
    nVec = nVec+1
    Ind1(nVec) = mx
    Ind2(nVec) = 1
    Index2(1,2,1) = mx
    Index4(1,mx,1) = 2
    Index4(2,mx,1) = 1
  end if
  if (IfHss(2,2,1,2)) then
    my = my+1
    nVec = nVec+1
    Ind1(nVec) = my
    Ind2(nVec) = 2
    Index2(2,2,1) = my
    Index4(1,my,2) = 2
    Index4(2,my,2) = 1
  end if
  if (IfHss(2,3,1,3)) then
    mz = mz+1
    nVec = nVec+1
    Ind1(nVec) = mz
    Ind2(nVec) = 3
    Index2(3,2,1) = mz
    Index4(1,mz,3) = 2
    Index4(2,mz,3) = 1
  end if
  Ind1(nVec+1:) = 0
  if (nVec /= 0) then
    do n=1,nVec
      do id=0,ld
        do ic=0,lc
          do ib=0,lb
            do ia=0,la
              xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch(:)*Scrtch2(:)*xyz2D0(:,ia+1,ib+1,ic,id,Ind2(n))
            end do
          end do
        end do
      end do
    end do
    if (la >= 1) then
      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            do ib=0,lb
              ra = Zero
              do ia=1,la
                ra = ra+One
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                        ra*Scrtch2(:)*xyz2D0(:,ia-1,ib+1,ic,id,Ind2(n))
              end do
            end do
          end do
        end do
      end do
    end if
    if (lb >= 1) then
      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            rb = Zero
            do ib=1,lb
              rb = rb+One
              do ia=0,la
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                        rb*Scrtch(:)*xyz2D0(:,ia+1,ib-1,ic,id,Ind2(n))
              end do
            end do
          end do
        end do
      end do
    end if
    if ((la >= 1) .and. (lb >= 1)) then
      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            rb = Zero
            do ib=1,lb
              rb = rb+One
              ra = Zero
              do ia=1,la
                ra = ra+One
                Fact = ra*rb
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))+Fact*xyz2D0(:,ia-1,ib-1,ic,id,Ind2(n))
              end do
            end do
          end do
        end do
      end do
    end if
  end if
end if

! Differentiate with respect to the second center

if (IfG(2)) then
  call ExpX(Temp,mZeta,mEta,Beta,sqrt(Two))
  call Exp_2(Scrtch2,nRys,nT,Temp,sqrt(Two))
  nVec = 0
  if (IfGrad(1,2)) then
    nx = nx+1
    nVec = nVec+1
    Ind1(nVec) = nx
    Ind2(nVec) = 1
    Index1(1,2) = nx
    Index3(nx,1) = 2
  end if
  if (IfGrad(2,2)) then
    ny = ny+1
    nVec = nVec+1
    Ind1(nVec) = ny
    Ind2(nVec) = 2
    Index3(ny,2) = 2
    Index1(2,2) = ny
  end if
  if (IfGrad(3,2)) then
    nz = nz+1
    nVec = nVec+1
    Ind1(nVec) = nz
    Ind2(nVec) = 3
    Index1(3,2) = nz
    Index3(nz,3) = 2
  end if
  Ind1(nVec+1:) = 0

  mVec = 0
  if (IfHss(2,1,2,1)) then
    mx = mx+1
    mVec = mVec+1
    Ind3(mVec) = mx
    Ind4(mVec) = 1
    Index2(1,2,2) = mx
    Index4(1,mx,1) = 2
    Index4(2,mx,1) = 2
  end if
  if (IfHss(2,2,2,2)) then
    my = my+1
    mVec = mVec+1
    Ind3(mVec) = my
    Ind4(mVec) = 2
    Index2(2,2,2) = my
    Index4(1,my,2) = 2
    Index4(2,my,2) = 2
  end if
  if (IfHss(2,3,2,3)) then
    mz = mz+1
    mVec = mVec+1
    Ind3(mVec) = mz
    Ind4(mVec) = 3
    Index2(3,2,2) = mz
    Index4(1,mz,3) = 2
    Index4(2,mz,3) = 2
  end if
  Ind3(mVec+1:) = 0
  nvecx = max(nVec,mVec)
  if (nVecx /= 0) then

    do n=1,nVec
      do id=0,ld
        do ic=0,lc
          rb = -One
          do ib=0,lb
            rb = rb+Two
            do ia=0,la
              xyz2D1(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch2(:)*xyz2D0(:,ia,ib+1,ic,id,Ind2(n))
            end do
          end do
        end do
      end do
    end do
    do n=1,mVec
      do id=0,ld
        do ic=0,lc
          rb = -One
          do ib=0,lb
            rb = rb+Two
            do ia=0,la
              xyz2D2(:,ia,ib,ic,id,Ind4(n),Ind3(n)) = Scrtch2(:)**2*xyz2D0(:,ia,ib+2,ic,id,Ind4(n))- &
                                                      rb*Scrtch2(:)*xyz2D0(:,ia,ib,ic,id,Ind4(n))
            end do
          end do
        end do
      end do
    end do

    if (lb >= 1) then
      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            rb = Zero
            do ib=1,lb
              rb = rb+One
              xyz2D1(:,:,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D1(:,:,ib,ic,id,Ind2(n),Ind1(n))-rb*xyz2D0(:,0:la,ib-1,ic,id,Ind2(n))
            end do
          end do
        end do
      end do
    end if
    if (lb >= 2) then
      do n=1,mVec
        do id=0,ld
          do ic=0,lc
            rb = One
            do ib=2,lb
              rb = rb+One
              Fact = rb*rb-rb
              xyz2D2(:,:,ib,ic,id,Ind4(n),Ind3(n)) = xyz2D2(:,:,ib,ic,id,Ind4(n),Ind3(n))+Fact*xyz2D0(:,0:la,ib-2,ic,id,Ind4(n))
            end do
          end do
        end do
      end do
    end if
  end if
end if

! Cross Term center 2 and 3

if (IfG(2) .and. IfG(3)) then
  call ExpX(Temp,mZeta,mEta,Beta,sqrt(Two))
  call Exp_2(Scrtch2,nRys,nT,Temp,sqrt(Two))
  call ExpY(Temp,mZeta,mEta,Gmma,sqrt(Two))
  call Exp_2(Scrtch,nRys,nT,Temp,sqrt(Two))
  nVec = 0
  if (IfHss(3,1,2,1)) then
    mx = mx+1
    nVec = nVec+1
    Ind1(nVec) = mx
    Ind2(nVec) = 1
    Index2(1,3,2) = mx
    Index4(1,mx,1) = 3
    Index4(2,mx,1) = 2
  end if
  if (IfHss(3,2,2,2)) then
    my = my+1
    nVec = nVec+1
    Ind1(nVec) = my
    Ind2(nVec) = 2
    Index2(2,3,2) = my
    Index4(1,my,2) = 3
    Index4(2,my,2) = 2
  end if
  if (IfHss(3,3,2,3)) then
    mz = mz+1
    nVec = nVec+1
    Ind1(nVec) = mz
    Ind2(nVec) = 3
    Index2(3,3,2) = mz
    Index4(1,mz,3) = 3
    Index4(2,mz,3) = 2
  end if
  Ind1(nVec+1:) = 0
  if (nVec /= 0) then

    do n=1,nVec
      do id=0,ld
        do ic=0,lc
          do ib=0,lb
            do ia=0,la
              xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch(:)*Scrtch2(:)*xyz2D0(:,ia,ib+1,ic+1,id,Ind2(n))
            end do
          end do
        end do
      end do
    end do
    if (lb >= 1) then
      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            rb = Zero
            do ib=1,lb
              rb = rb+One
              do ia=0,la
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                        rb*Scrtch(:)*xyz2D0(:,ia,ib-1,ic+1,id,Ind2(n))
              end do
            end do
          end do
        end do
      end do
    end if
    if (lc >= 1) then
      do n=1,nvec
        do id=0,ld
          rc = Zero
          do ic=1,lc
            rc = rc+One
            do ib=0,lb
              do ia=0,la
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                        rc*Scrtch2(:)*xyz2D0(:,ia,ib+1,ic-1,id,Ind2(n))
              end do
            end do
          end do
        end do
      end do
    end if
    if ((lb >= 1) .and. (lc >= 1)) then
      do n=1,nVec
        do id=0,ld
          rc = Zero
          do ic=1,lc
            rc = rc+One
            rb = Zero
            do ib=1,lb
              rb = rb+One
              Fact = rb*rc
              xyz2D2(:,:,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,:,ib,ic,id,Ind2(n),Ind1(n))+Fact*xyz2D0(:,0:la,ib-1,ic-1,id,Ind2(n))
            end do
          end do
        end do
      end do
    end if
  end if
end if

! Differentiate with respect to the third center

if (IfG(3)) then
  call ExpY(Temp,mZeta,mEta,Gmma,sqrt(Two))
  call Exp_2(Scrtch,nRys,nT,Temp,sqrt(Two))
  nVec = 0
  if (IfGrad(1,3)) then
    nx = nx+1
    nVec = nVec+1
    Ind1(nVec) = nx
    Ind2(nVec) = 1
    Index1(1,3) = nx
    Index3(nx,1) = 3
  end if
  if (IfGrad(2,3)) then
    ny = ny+1
    nVec = nVec+1
    Ind1(nVec) = ny
    Ind2(nVec) = 2
    Index1(2,3) = ny
    Index3(ny,2) = 3
  end if
  if (IfGrad(3,3)) then
    nz = nz+1
    nVec = nVec+1
    Ind1(nVec) = nz
    Ind2(nVec) = 3
    Index1(3,3) = nz
    Index3(nz,3) = 3
  end if
  Ind1(nVec+1:) = 0

  mVec = 0
  if (IfHss(3,1,3,1)) then
    mx = mx+1
    mVec = mVec+1
    Ind3(mVec) = mx
    Ind4(mVec) = 1
    Index2(1,3,3) = mx
    Index4(1,mx,1) = 3
    Index4(2,mx,1) = 3
  end if
  if (IfHss(3,2,3,2)) then
    my = my+1
    mVec = mVec+1
    Ind3(mVec) = my
    Ind4(mVec) = 2
    Index2(2,3,3) = my
    Index4(1,my,2) = 3
    Index4(2,my,2) = 3
  end if
  if (IfHss(3,3,3,3)) then
    mz = mz+1
    mVec = mVec+1
    Ind3(mVec) = mz
    Ind4(mVec) = 3
    Index2(3,3,3) = mz
    Index4(1,mz,3) = 3
    Index4(2,mz,3) = 3
  end if
  Ind3(mVec+1:) = 0
  nvecx = max(nVec,mVec)
  if (nVecx /= 0) then
    do n=1,nVec
      do id=0,ld
        rc = -One
        do ic=0,lc
          rc = rc+Two
          do ib=0,lb
            do ia=0,la
              xyz2D1(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch(:)*xyz2D0(:,ia,ib,ic+1,id,Ind2(n))
            end do
          end do
        end do
      end do
    end do
    do n=1,mVec
      do id=0,ld
        rc = -One
        do ic=0,lc
          rc = rc+Two
          do ib=0,lb
            do ia=0,la
              xyz2D2(:,ia,ib,ic,id,Ind4(n),Ind3(n)) = Scrtch(:)**2*xyz2D0(:,ia,ib,ic+2,id,Ind4(n))- &
                                                      rc*Scrtch(:)*xyz2D0(:,ia,ib,ic,id,Ind4(n))
            end do
          end do
        end do
      end do
    end do

    if (lc >= 1) then
      do n=1,nVec
        do id=0,ld
          rc = Zero
          do ic=1,lc
            rc = rc+One
            xyz2D1(:,:,:,ic,id,Ind2(n),Ind1(n)) = xyz2D1(:,:,:,ic,id,Ind2(n),Ind1(n))-rc*xyz2D0(:,0:la,0:lb,ic-1,id,Ind2(n))
          end do
        end do
      end do
    end if
    if (lc >= 2) then
      do n=1,mVec
        do id=0,ld
          rc = One
          do ic=2,lc
            rc = rc+One
            Fact = rc*rc-rc
            xyz2D2(:,:,:,ic,id,Ind4(n),Ind3(n)) = xyz2D2(:,:,:,ic,id,Ind4(n),Ind3(n))+Fact*xyz2D0(:,0:la,0:lb,ic-2,id,Ind4(n))
          end do
        end do
      end do
    end if
  end if
end if

! Cross term 1 3

if (IfG(1) .and. IfG(3)) then
  call ExpX(Temp,mZeta,mEta,Alpha,sqrt(Two))
  call Exp_2(Scrtch2,nRys,nT,Temp,sqrt(Two))
  call ExpY(Temp,mZeta,mEta,Gmma,sqrt(Two))
  call Exp_2(Scrtch,nRys,nT,Temp,sqrt(Two))
  nVec = 0
  if (IfHss(3,1,1,1)) then
    mx = mx+1
    nVec = nVec+1
    Ind1(nVec) = mx
    Ind2(nVec) = 1
    Index4(1,mx,1) = 3
    Index4(2,mx,1) = 1
    Index2(1,3,1) = mx
  end if
  if (IfHss(3,2,1,2)) then
    my = my+1
    nVec = nVec+1
    Ind1(nVec) = my
    Ind2(nVec) = 2
    Index4(1,my,2) = 3
    Index4(2,my,2) = 1
    Index2(2,3,1) = my
  end if
  if (IfHss(3,3,1,3)) then
    mz = mz+1
    nVec = nVec+1
    Ind1(nVec) = mz
    Ind2(nVec) = 3
    Index4(1,mz,3) = 3
    Index4(2,mz,3) = 1
    Index2(3,3,1) = mz
  end if
  Ind1(nVec+1:) = 0
  if (nVec /= 0) then
    do n=1,nVec
      do id=0,ld
        do ic=0,lc
          do ib=0,lb
            do ia=0,la
              xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch(:)*Scrtch2(:)*xyz2D0(:,ia+1,ib,ic+1,id,Ind2(n))
            end do
          end do
        end do
      end do
    end do
    if (la >= 1) then
      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            do ib=0,lb
              ra = Zero
              do ia=1,la
                ra = ra+One
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                        ra*Scrtch(:)*xyz2D0(:,ia-1,ib,ic+1,id,Ind2(n))
              end do
            end do
          end do
        end do
      end do
    end if
    if (lc >= 1) then
      do n=1,nVec
        do id=0,ld
          rc = Zero
          do ic=1,lc
            rc = rc+One
            do ib=0,lb
              do ia=0,la
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                        rc*Scrtch2(:)*xyz2D0(:,ia+1,ib,ic-1,id,Ind2(n))
              end do
            end do
          end do
        end do
      end do
    end if
    if ((la >= 1) .and. (lc >= 1)) then
      do n=1,nVec
        do id=0,ld
          rc = Zero
          do ic=1,lc
            rc = rc+One
            do ib=0,lb
              ra = Zero
              do ia=1,la
                ra = ra+One
                Fact = rc*ra
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))+Fact*xyz2D0(:,ia-1,ib,ic-1,id,Ind2(n))
              end do
            end do
          end do
        end do
      end do
    end if
  end if
end if

! 1 4

if (IfG(4)) then
  call ExpY(Temp,mZeta,mEta,Delta,sqrt(Two))
  call Exp_2(Scrtch,nRys,nT,Temp,sqrt(Two))
  if (IfG(1)) then
    call ExpX(Temp,mZeta,mEta,Alpha,sqrt(Two))
    call Exp_2(Scrtch2,nRys,nT,Temp,sqrt(Two))
    nVec = 0
    if (IfHss(4,1,1,1)) then
      mx = mx+1
      nVec = nVec+1
      Ind1(nVec) = mx
      Ind2(nVec) = 1
      Index2(1,4,1) = mx
      Index4(1,mx,1) = 4
      Index4(2,mx,1) = 1
    end if
    if (IfHss(4,2,1,2)) then
      my = my+1
      nVec = nVec+1
      Ind1(nVec) = my
      Ind2(nVec) = 2
      Index2(2,4,1) = my
      Index4(1,my,2) = 4
      Index4(2,my,2) = 1
    end if
    if (IfHss(4,3,1,3)) then
      mz = mz+1
      nVec = nVec+1
      Ind1(nVec) = mz
      Ind2(nVec) = 3
      Index2(3,4,1) = mz
      Index4(1,mz,3) = 4
      Index4(2,mz,3) = 1
    end if
    Ind1(nVec+1:) = 0

    if (nVec /= 0) then

      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            do ib=0,lb
              do ia=0,la
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch(:)*Scrtch2(:)*xyz2D0(:,ia+1,ib,ic,id+1,Ind2(n))
              end do
            end do
          end do
        end do
      end do

      if (la >= 1) then
        do n=1,nVec
          do id=0,ld
            do ic=0,lc
              do ib=0,lb
                ra = Zero
                do ia=1,la
                  ra = ra+One
                  xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                          ra*Scrtch(:)*xyz2D0(:,ia-1,ib,ic,id+1,Ind2(n))
                end do
              end do
            end do
          end do
        end do
      end if

      if (ld >= 1) then
        do n=1,nVec
          rd = Zero
          do id=1,ld
            rd = rd+One
            do ic=0,lc
              do ib=0,lb
                do ia=0,la
                  xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                          rd*Scrtch2(:)*xyz2D0(:,ia+1,ib,ic,id-1,Ind2(n))
                end do
              end do
            end do
          end do
        end do
      end if
      if ((la >= 1) .and. (ld >= 1)) then
        do n=1,nVec
          rd = Zero
          do id=1,ld
            rd = rd+One
            do ic=0,lc
              do ib=0,lb
                ra = Zero
                do ia=1,la
                  ra = ra+One
                  Fact = rd*ra
                  xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))+ &
                                                          Fact*xyz2D0(:,ia-1,ib,ic,id-1,Ind2(n))
                end do
              end do
            end do
          end do
        end do
      end if
    end if
  end if

  ! Cross terms between 2 4

  if (IfG(2) .and. IfG(4)) then
    call ExpX(Temp,mZeta,mEta,Beta,sqrt(Two))
    call Exp_2(Scrtch2,nRys,nT,Temp,sqrt(Two))
    nVec = 0
    if (IfHss(4,1,2,1)) then
      mx = mx+1
      nVec = nVec+1
      Ind1(nVec) = mx
      Ind2(nVec) = 1
      Index2(1,4,2) = mx
      Index4(1,mx,1) = 4
      Index4(2,mx,1) = 2
    end if
    if (IfHss(4,2,2,2)) then
      my = my+1
      nVec = nVec+1
      Ind1(nVec) = my
      Ind2(nVec) = 2
      Index2(2,4,2) = my
      Index4(1,my,2) = 4
      Index4(2,my,2) = 2
    end if
    if (IfHss(4,3,2,3)) then
      mz = mz+1
      nVec = nVec+1
      Ind1(nVec) = mz
      Ind2(nVec) = 3
      Index2(3,4,2) = mz
      Index4(1,mz,3) = 4
      Index4(2,mz,3) = 2
    end if
    Ind1(nVec+1:) = 0

    if (nVec /= 0) then

      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            do ib=0,lb
              do ia=0,la
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch(:)*Scrtch2(:)*xyz2D0(:,ia,ib+1,ic,id+1,Ind2(n))
              end do
            end do
          end do
        end do
      end do

      if (lb >= 1) then
        do n=1,nVec
          do id=0,ld
            do ic=0,lc
              rb = Zero
              do ib=1,lb
                rb = rb+One
                do ia=0,la
                  xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                          rb*Scrtch(:)*xyz2D0(:,ia,ib-1,ic,id+1,Ind2(n))
                end do
              end do
            end do
          end do
        end do
      end if

      if (ld >= 1) then
        do n=1,nVec
          rd = Zero
          do id=1,ld
            rd = rd+One
            do ic=0,lc
              do ib=0,lb
                do ia=0,la
                  xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                          rd*Scrtch2(:)*xyz2D0(:,ia,ib+1,ic,id-1,Ind2(n))
                end do
              end do
            end do
          end do
        end do
      end if
      if ((lb >= 1) .and. (ld >= 1)) then
        do n=1,nVec
          rd = Zero
          do id=1,ld
            rd = rd+One
            do ic=0,lc
              rb = Zero
              do ib=1,lb
                rb = rb+One
                Fact = rb*rd
                xyz2D2(:,:,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,:,ib,ic,id,Ind2(n),Ind1(n))+Fact*xyz2D0(:,0:la,ib-1,ic,id-1,Ind2(n))
              end do
            end do
          end do
        end do
      end if
    end if
  end if

  ! Cross Term 3 4

  if (IfG(3) .and. IfG(4)) then
    call ExpY(Temp,mZeta,mEta,Gmma,sqrt(Two))
    call Exp_2(Scrtch2,nRys,nT,Temp,sqrt(Two))
    nVec = 0
    if (IfHss(4,1,3,1)) then
      mx = mx+1
      nVec = nVec+1
      Ind1(nVec) = mx
      Ind2(nVec) = 1
      Index2(1,4,3) = mx
      Index4(1,mx,1) = 4
      Index4(2,mx,1) = 3
    end if
    if (IfHss(4,2,3,2)) then
      my = my+1
      nVec = nVec+1
      Ind1(nVec) = my
      Ind2(nVec) = 2
      Index2(2,4,3) = my
      Index4(1,my,2) = 4
      Index4(2,my,2) = 3

    end if
    if (IfHss(4,3,3,3)) then
      mz = mz+1
      nVec = nVec+1
      Ind1(nVec) = mz
      Ind2(nVec) = 3
      Index2(3,4,3) = mz
      Index4(1,mz,3) = 4
      Index4(2,mz,3) = 3
    end if
    Ind1(nVec+1:) = 0

    if (nVec /= 0) then

      do n=1,nVec
        do id=0,ld
          do ic=0,lc
            do ib=0,lb
              do ia=0,la
                xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch(:)*Scrtch2(:)*xyz2D0(:,ia,ib,ic+1,id+1,Ind2(n))
              end do
            end do
          end do
        end do
      end do

      if (lc >= 1) then
        do n=1,nVec
          do id=0,ld
            rc = Zero
            do ic=1,lc
              rc = rc+One
              do ib=0,lb
                do ia=0,la
                  xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                          rc*Scrtch(:)*xyz2D0(:,ia,ib,ic-1,id+1,Ind2(n))
                end do
              end do
            end do
          end do
        end do
      end if
      if (ld >= 1) then
        do n=1,nVec
          rd = Zero
          do id=1,ld
            rd = rd+One
            do ic=0,lc
              do ib=0,lb
                do ia=0,la
                  xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,ia,ib,ic,id,Ind2(n),Ind1(n))- &
                                                          rd*Scrtch2(:)*xyz2D0(:,ia,ib,ic+1,id-1,Ind2(n))
                end do
              end do
            end do
          end do
        end do
      end if
      if ((lc >= 1) .and. (ld >= 1)) then
        do n=1,nVec
          rd = Zero
          do id=1,ld
            rd = rd+One
            rc = Zero
            do ic=1,lc
              rc = rc+One
              Fact = rc*rd
              xyz2D2(:,:,:,ic,id,Ind2(n),Ind1(n)) = xyz2D2(:,:,:,ic,id,Ind2(n),Ind1(n))+Fact*xyz2D0(:,0:la,0:lb,ic-1,id-1,Ind2(n))
            end do
          end do
        end do
      end if
    end if
  end if

  ! Differentiate with respect to the fourth center

  nVec = 0
  if (IfGrad(1,4)) then
    nx = nx+1
    nVec = nVec+1
    Ind1(nVec) = nx
    Ind2(nVec) = 1
    Index1(1,4) = nx
    Index3(nx,1) = 4
  end if
  if (IfGrad(2,4)) then
    ny = ny+1
    nVec = nVec+1
    Ind1(nVec) = ny
    Ind2(nVec) = 2
    Index1(2,4) = ny
    Index3(ny,2) = 4
  end if
  if (IfGrad(3,4)) then
    nz = nz+1
    nVec = nVec+1
    Ind1(nVec) = nz
    Ind2(nVec) = 3
    Index1(3,4) = nz
    Index3(nz,3) = 4
  end if
  Ind1(nVec+1:) = 0

  mVec = 0
  if (IfHss(4,1,4,1)) then
    mx = mx+1
    mVec = mVec+1
    Ind3(mVec) = mx
    Ind4(mVec) = 1
    Index2(1,4,4) = mx
    Index4(1,mx,1) = 4
    Index4(2,mx,1) = 4
  end if
  if (IfHss(4,2,4,2)) then
    my = my+1
    mVec = mVec+1
    Ind3(mVec) = my
    Ind4(mVec) = 2
    Index2(2,4,4) = my
    Index4(1,my,2) = 4
    Index4(2,my,2) = 4
  end if
  if (IfHss(4,3,4,3)) then
    mz = mz+1
    mVec = mVec+1
    Ind3(mVec) = mz
    Ind4(mVec) = 3
    Index2(3,4,4) = mz
    Index4(1,mz,3) = 4
    Index4(2,mz,3) = 4
  end if
  Ind3(mVec+1:) = 0
  nvecx = max(nVec,mVec)

  if (nVecx /= 0) then

    do n=1,nVec
      rd = -One
      do id=0,ld
        rd = rd+Two
        do ic=0,lc
          do ib=0,lb
            do ia=0,la
              xyz2D1(:,ia,ib,ic,id,Ind2(n),Ind1(n)) = Scrtch(:)*xyz2D0(:,ia,ib,ic,id+1,Ind2(n))
            end do
          end do
        end do
      end do
    end do
    do n=1,mVec
      rd = -One
      do id=0,ld
        rd = rd+Two
        do ic=0,lc
          do ib=0,lb
            do ia=0,la
              xyz2D2(:,ia,ib,ic,id,Ind4(n),Ind3(n)) = Scrtch(:)**2*xyz2D0(:,ia,ib,ic,id+2,Ind4(n))- &
                                                      rd*Scrtch(:)*xyz2D0(:,ia,ib,ic,id,Ind4(n))
            end do
          end do
        end do
      end do
    end do
    if (ld >= 1) then
      do n=1,nVec
        rd = Zero
        do id=1,ld
          rd = rd+One
          xyz2D1(:,:,:,:,id,Ind2(n),Ind1(n)) = xyz2D1(:,:,:,:,id,Ind2(n),Ind1(n))-rd*xyz2D0(:,0:la,0:lb,0:lc,id-1,Ind2(n))
        end do
      end do
    end if
    if (ld >= 2) then
      do n=1,mVec
        rd = One
        do id=2,ld
          rd = rd+One
          Fact = rd*rd-rd
          xyz2D2(:,:,:,:,id,Ind4(n),Ind3(n)) = xyz2D2(:,:,:,:,id,Ind4(n),Ind3(n))+Fact*xyz2D0(:,0:la,0:lb,0:lc,id-2,Ind4(n))
        end do
      end do
    end if

  end if
end if

! Sum over common centers

do iCent=1,3
  if (IfG(iCent)) then
    do jCent=iCent+1,4
      if (EQ(Coora(1,iCent),Coora(1,jCent))) then
        if (IfG(jCent)) then
          do iCar=1,3
            i1 = Index2(iCar,iCent,iCent)
            i2 = Index2(iCar,jCent,jCent)
            i3 = Index2(iCar,jCent,iCent)
            j4 = Index1(iCar,jCent)
            j5 = Index1(iCar,iCent)
            if (IfHss(jCent,iCar,jCent,iCar) .and. IfHss(iCent,iCar,iCent,iCar)) &
              xyz2D2(:,:,:,:,:,iCar,i1) = xyz2D2(:,:,:,:,:,iCar,i1)+xyz2D2(:,:,:,:,:,iCar,i2)
            if (IfHss(jCent,iCar,iCent,iCar) .and. IfHss(iCent,iCar,iCent,iCar)) &
              xyz2D2(:,:,:,:,:,iCar,i1) = xyz2D2(:,:,:,:,:,iCar,i1)+Two*xyz2D2(:,:,:,:,:,iCar,i3)
            if ((j4 /= 0) .and. (j5 /= 0) .and. IfGrad(iCar,iCent) .and. IfGrad(iCar,jCent)) &
              xyz2D1(:,:,:,:,:,iCar,j5) = xyz2D1(:,:,:,:,:,iCar,j5)+xyz2D1(:,:,:,:,:,iCar,j4)
            do kCent=1,4
              if (IfG(kCent)) then
                if ((kCent /= iCent) .and. (kCent /= jCent)) then
                  if (IfHss(kCent,iCar,jCent,iCar) .or. IfHss(jCent,iCar,kCent,iCar)) then
                    i4 = Index2(iCar,max(kCent,jCent),min(jCent,kCent))
                    i5 = Index2(iCar,max(kCent,iCent),min(iCent,kCent))
                    xyz2D2(:,:,:,:,:,iCar,i5) = xyz2D2(:,:,:,:,:,iCar,i5)+xyz2D2(:,:,:,:,:,iCar,i4)
                  end if
                end if
              end if
            end do ! kCent
          end do ! iCar

          IfG(jCent) = .false.
          Tr(jCent) = .false.
          IfGrad(:,jCent) = .false.
          IndGrd(:,jCent,:) = 0
          IfHss(jCent,:,:,:) = .false.
          IfHss(:,:,jCent,:) = .false.
          IndHss(jCent,:,:,:,:) = 0
          IndHss(:,:,jCent,:,:) = 0

        end if
      end if ! end eq
    end do ! jCent
  end if
end do ! iCent

nh(1) = mx
nh(2) = my
nh(3) = mz
ng(1) = nx
ng(2) = ny
ng(3) = nz

return

end subroutine Rs2Dgh

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_multipole_ints

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_init_multipole_ints,   &
             fmm_free_multipole_ints,   &
             fmm_build_multipoles

   REAL(REALK), ALLOCATABLE :: ECoefX(:,:,:,:)
   REAL(REALK), ALLOCATABLE :: ECoefY(:,:,:,:)
   REAL(REALK), ALLOCATABLE :: ECoefZ(:,:,:,:)

   REAL(REALK), ALLOCATABLE :: MIntX(:,:,:)
   REAL(REALK), ALLOCATABLE :: MIntY(:,:,:)
   REAL(REALK), ALLOCATABLE :: MIntZ(:,:,:)

   REAL(REALK), ALLOCATABLE :: MpoleX(:,:,:,:)
   REAL(REALK), ALLOCATABLE :: MpoleY(:,:,:,:)
   REAL(REALK), ALLOCATABLE :: MpoleZ(:,:,:,:)

   REAL(REALK), ALLOCATABLE :: CarMpole(:,:,:)
   REAL(REALK), ALLOCATABLE :: SphMpole(:,:,:)

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_multipole_ints(basis,MaxMul)

      IMPLICIT NONE
      TYPE(fmm_basis), INTENT(IN) :: basis
      INTEGER(INTK),   INTENT(IN) :: MaxMul

      INTEGER(INTK) :: MaxAngl, MaxSgm2
      MaxAngl = basis%maxangl
      MaxSgm2 = basis%maxsgm2

      ALLOCATE(ECoefX(0:MaxAngl, 0:MaxAngl, 0:MaxAngl*2, MaxSgm2))
      ALLOCATE(ECoefY(0:MaxAngl, 0:MaxAngl, 0:MaxAngl*2, MaxSgm2))
      ALLOCATE(ECoefZ(0:MaxAngl, 0:MaxAngl, 0:MaxAngl*2, MaxSgm2))

      ALLOCATE(MIntX(-1:MaxMul+1, -1:MaxMul+1, MaxSgm2))
      ALLOCATE(MIntY(-1:MaxMul+1, -1:MaxMul+1, MaxSgm2))
      ALLOCATE(MIntZ(-1:MaxMul+1, -1:MaxMul+1, MaxSgm2))

      ALLOCATE(MpoleX(0:MaxAngl, 0:MaxAngl, 0:MaxMul, MaxSgm2))
      ALLOCATE(MpoleY(0:MaxAngl, 0:MaxAngl, 0:MaxMul, MaxSgm2))
      ALLOCATE(MpoleZ(0:MaxAngl, 0:MaxAngl, 0:MaxMul, MaxSgm2))


   END SUBROUTINE fmm_init_multipole_ints

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_free_multipole_ints

      IMPLICIT NONE
      DEALLOCATE(ECoefX)
      DEALLOCATE(ECoefY)
      DEALLOCATE(ECoefZ)

      DEALLOCATE(MIntX)
      DEALLOCATE(MIntY)
      DEALLOCATE(MIntZ)

      DEALLOCATE(MpoleX)
      DEALLOCATE(MpoleY)
      DEALLOCATE(MpoleZ)

      IF (ALLOCATED(CarMpole)) DEALLOCATE(CarMpole)
      IF (ALLOCATED(SphMpole)) DEALLOCATE(SphMpole)

   END SUBROUTINE fmm_free_multipole_ints

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_build_multipoles(basis,MaxMul,sh_pairs)

      USE fmm_car_to_sph,     ONLY: fmm_init_car_to_sph,      &
                                    fmm_free_car_to_sph
      USE fmm_integral_utils, ONLY: fmm_get_prim_batch,       &
                                    fmm_build_Ecoef1,         &
                                    fmm_build_Ecoef2


      IMPLICIT NONE
      TYPE(fmm_basis),    INTENT(IN) :: basis
      INTEGER(INTK),      INTENT(IN) :: MaxMul
      TYPE(fmm_sh_pairs), INTENT(IN) :: sh_pairs(:)

!fixme
      CHARACTER(LEN=10), PARAMETER :: Name = 'multipoles'

      TYPE(fmm_prim_batch) :: batch(basis%MaxSgm2)
      CHARACTER(LEN=255) :: FBuf
      INTEGER(INTK) :: Ish, Jsh, NPrim, IAnglA, IAnglB
      INTEGER(INTK) :: i, ij, nmoms

      CALL fmm_init_car_to_sph(MaxMul)

      FBuf = TRIM(Name)//".fmm1"
      OPEN(UNIT=LUINTM, FILE=TRIM(FBuf), STATUS='REPLACE',  &
           ACCESS='SEQUENTIAL', FORM='UNFORMATTED')
      REWIND(LUINTM)

      nmoms = 0
      DO ij = 1, SIZE(sh_pairs)
!          print *, SIZE(sh_pairs), ij

          Ish = sh_pairs(ij)%I
          Jsh = sh_pairs(ij)%J

          ! Prepare batch of primitives
          CALL fmm_get_prim_batch(basis,Ish,Jsh,batch,NPrim)
          ! Build Hermite expansion E-coefficients
          IAnglA = basis%KType(Ish)
          IAnglB = basis%KType(Jsh)
          IF (IAnglA >= IAnglB) THEN
             CALL fmm_build_Ecoef1(batch,NPrim,IAnglA,IAnglB,    &
                                   ECoefX,ECoefY,ECoefZ)

          ELSE
             CALL fmm_build_Ecoef2(batch,NPrim,IAnglA,IAnglB,    &
                                   ECoefX,ECoefY,ECoefZ)
          END IF

          ! Set multipole origin
          DO i = 1, NPrim
             batch(i)%PC(:) = batch(i)%P(:) - sh_pairs(ij)%centre(:)
          END DO
          ! Build Hermite multipole moment integrals
          CALL fmm_build_Mints(batch,NPrim,IAnglA+IAnglB,MaxMul)

          ! Build spherical multipole integrals for Cartesian GTOs
          ! assuming final Fock matrix in spherical GTOs
          ! (only difference is we use spherical AO contraction coefs)
          ! When using these multipoles need Cartesian form of
          ! density and J_matrices
          CALL fmm_build_Mpole_ints(IAnglA,IAnglB,NPrim,MaxMul)
          CALL fmm_build_SphMpole(basis,batch,Ish,Jsh,NPrim,MaxMul)
          CALL fmm_store_SphMpole(basis,batch,Ish,Jsh,NPrim,MaxMul,  &
                                  sh_pairs(ij)%centre,nmoms)
      END DO

      ! Mark end of file with negative L-index
      WRITE(LUINTM) 0,-1,0,0,0, 0d0,0d0,0d0, 0d0
      CLOSE(UNIT=LUINTM, STATUS='KEEP')

      FBuf = TRIM(Name)//".fmm1header"
      OPEN(UNIT=LUINTM, FILE=TRIM(FBuf), STATUS='REPLACE',   &
           ACCESS='SEQUENTIAL', FORM='UNFORMATTED')
      WRITE(LUINTM) MaxMul, basis%nbas, nmoms
      CLOSE(UNIT=LUINTM, STATUS='KEEP')

      CALL fmm_free_car_to_sph

   END SUBROUTINE fmm_build_multipoles

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_build_Mints(batch,NPrim,MaxAng,MaxMul)

!     o Evaluate 1D multipole-moment integrals

      IMPLICIT NONE

      TYPE(fmm_prim_batch), INTENT(IN) :: batch(:)
      INTEGER(INTK),        INTENT(IN) :: NPrim, MaxAng, MaxMul

      INTEGER :: Ie, It, IJ

      REAL(REALK) :: PXCX(NPrim), PYCY(NPrim), PZCZ(NPrim)
      REAL(REALK) :: ExpPHalf(NPrim), ExpntP(NPrim)

      PXCX(:) = batch(1:Nprim)%PC(1)
      PYCY(:) = batch(1:Nprim)%PC(2)
      PZCZ(:) = batch(1:Nprim)%PC(3)
      ExpPHalf(:) = batch(1:Nprim)%ExpPHalf
      ExpntP(:) = batch(1:Nprim)%ExpntP

!     o Recurence relation
!       M(t,e,NPrim)

      MIntX(:,:,:) = Zero
      MIntY(:,:,:) = Zero
      MIntZ(:,:,:) = Zero

      MIntX(0,0,1:NPrim) = SQRT(Pi/ExpntP(:))
      MIntY(0,0,1:NPrim) = SQRT(Pi/ExpntP(:))
      MIntZ(0,0,1:NPrim) = SQRT(Pi/ExpntP(:))

      DO Ie = 1, MaxMul
         DO It = 0, Ie
            DO IJ = 1, NPrim
               MIntX(It,Ie,IJ) = DBLE(It) * MIntX(It-1,Ie-1,IJ)
               MIntY(It,Ie,IJ) = DBLE(It) * MIntY(It-1,Ie-1,IJ)
               MIntZ(It,Ie,IJ) = DBLE(It) * MIntZ(It-1,Ie-1,IJ)
            END DO
            DO IJ = 1, NPrim
               MIntX(It,Ie,IJ) = MIntX(It,Ie,IJ) + PXCX(IJ) * MIntX(It,Ie-1,IJ)
               MIntY(It,Ie,IJ) = MIntY(It,Ie,IJ) + PYCY(IJ) * MIntY(It,Ie-1,IJ)
               MIntZ(It,Ie,IJ) = MIntZ(It,Ie,IJ) + PZCZ(IJ) * MIntZ(It,Ie-1,IJ)
            END DO
            DO IJ = 1, NPrim
               MIntX(It,Ie,IJ) = MIntX(It,Ie,IJ) + ExpPHalf(IJ) * MIntX(It+1,Ie-1,IJ)
               MIntY(It,Ie,IJ) = MIntY(It,Ie,IJ) + ExpPHalf(IJ) * MIntY(It+1,Ie-1,IJ)
               MIntZ(It,Ie,IJ) = MIntZ(It,Ie,IJ) + ExpPHalf(IJ) * MIntZ(It+1,Ie-1,IJ)
            END DO
         END DO
      END DO

! Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(MaxAng)
   END SUBROUTINE fmm_build_Mints

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_build_Mpole_ints(IAnglA,IAnglB,NPrim,MaxMul)

      IMPLICIT NONE

      INTEGER(INTK), INTENT(IN) :: IAnglA, IAnglB, NPrim, MaxMul

      INTEGER(INTK) :: It1, It2, Ie, It, IJ
      INTEGER(INTK) :: ItMax

      MpoleX(:,:,:,:) = zero
      MpoleY(:,:,:,:) = zero
      MpoleZ(:,:,:,:) = zero

      DO It1 = 0, IAnglA
         DO It2 = 0, IAnglB
            DO Ie = 0, MaxMul
               ItMax = MIN((It1+It2),Ie)
               DO It = 0, ItMax
                  DO IJ = 1, NPrim
                     MpoleX(It1,It2,Ie,IJ) = MpoleX(It1,It2,Ie,IJ) +    &
                                             ECoefX(It1,It2,It,IJ) *    &
                                             MIntX(It,Ie,IJ)
                     MpoleY(It1,It2,Ie,IJ) = MpoleY(It1,It2,Ie,IJ) +    &
                                             ECoefY(It1,It2,It,IJ) *    &
                                             MIntY(It,Ie,IJ)
                     MpoleZ(It1,It2,Ie,IJ) = MpoleZ(It1,It2,Ie,IJ) +    &
                                             ECoefZ(It1,It2,It,IJ) *    &
                                             MIntZ(It,Ie,IJ)
                  END DO
               END DO
            END DO
         END DO
      END DO

   END SUBROUTINE fmm_build_Mpole_ints

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_build_SphMpole(basis,batch,Ish,Jsh,NPrim,MaxMul)

      USE fmm_car_to_sph, ONLY: fmm_transform_car_to_sph

      IMPLICIT NONE
      TYPE(fmm_basis),      INTENT(IN) :: basis
      TYPE(fmm_prim_batch), INTENT(IN) :: batch(:)
      INTEGER(INTK),        INTENT(IN) :: Ish, Jsh, NPrim, MaxMul

!fixme
      REAL(REALK), PARAMETER :: ThrInt = 1.0d-12

      LOGICAL :: IEqJ
      INTEGER :: IAnglA, IAnglB
      INTEGER :: IL1, IL2, IL3
      INTEGER :: IeX, IeY, IeZ, MType, MCar
      INTEGER :: It1, Iu1, Iv1
      INTEGER :: It2, Iu2, Iv2
      INTEGER :: IJ, IBatch
      INTEGER :: IIBatch
      INTEGER :: IL2Temp
      INTEGER :: Labelp, Labelq, ndim
      REAL(REALK) :: Temp1, Temp2

      IAnglA = basis%KType(Ish)
      IAnglB = basis%KType(Jsh)

      ndim =  (basis%LtuvMax_Car(IAnglA) - basis%LtuvMin_Car(IAnglA) + 1)   &
            * (basis%LtuvMax_Car(IAnglB) - basis%LtuvMin_Car(IAnglB) + 1)
      ndim = ndim * NPrim

      ALLOCATE(CarMpole(ndim, (MaxMul+1)*(MaxMul+2)/2, 0:MaxMul))
      IF (.NOT.ALLOCATED(SphMpole)) THEN
         ALLOCATE(SphMpole(ndim, (2*MaxMul+1), 0:MaxMul))
      END IF

      CarMpole(:,:,:) = zero

      IEqJ = (ISh == JSh)
      IBatch = 0
      IIBatch = 0
      Labelp = basis%KLoc_Car(ISh)
      DO IL1 = basis%LtuvMin_Car(IAnglA), basis%LtuvMax_Car(IAnglA)
         Labelp = Labelp + 1
         It1 = basis%Lt(IL1)
         Iu1 = basis%Lu(IL1)
         Iv1 = basis%Lv(IL1)

         Labelq = basis%KLoc_Car(JSh)
         IL2Temp = basis%LtuvMax_Car(IAnglB)
         IF (IEqJ) IL2Temp = IL1
         DO IL2 = basis%LtuvMin_Car(IAnglB), IL2Temp
            IBatch = IBatch + 1
            Labelq = Labelq + 1
            It2 = basis%Lt(IL2)
            Iu2 = basis%Lu(IL2)
            Iv2 = basis%Lv(IL2)

!contracted functions
            DO MType = 0, MaxMul
               DO MCar = 1, (MType+1)*(MType+2)/2
                  IL3 = MCar + basis%LtuvMin_Car(MType) - 1
                  IeX = basis%Lt(IL3)
                  IeY = basis%Lu(IL3)
                  IeZ = basis%Lv(IL3)

                  Temp1 = Zero
                  DO IJ = 1, NPrim
                     Temp2 = MpoleX(It1,It2,IeX,IJ) *    &
                             MpoleY(Iu1,Iu2,IeY,IJ) *    &
                             MpoleZ(Iv1,Iv2,IeZ,IJ) *    &
                             batch(IJ)%CCoefAB
                     Temp1 = Temp1 + Temp2
                  END DO

                  IF (ABS(Temp1) >= ThrInt) &
                     CarMpole(IBatch,MCar,MType) = Temp1

               END DO
            END DO

!primitive functions
!            DO IJ = 1, NPrim
!               IIbatch = IIbatch +1
!               DO MType = 0, MaxMul
!                  DO MCar = 1, (MType+1)*(MType+2)/2
!
!                     IL3 = MCar + basis%LtuvMin_Car(MType) - 1
!                     IeX = basis%Lt(IL3)
!                     IeY = basis%Lu(IL3)
!                     IeZ = basis%Lv(IL3)
!                     Temp1 = MpoleX(It1,It2,IeX,IJ) *    &
!                             MpoleY(Iu1,Iu2,IeY,IJ) *    &
!                             MpoleZ(Iv1,Iv2,IeZ,IJ) *    &
!                             batch(IJ)%CCoefAB
!                     IF (ABS(Temp1) >= ThrInt) &
!                        CarMpole(IIBatch,MCar,MType) = Temp1
!
!                  END DO
!               END DO
!            END DO

!------------
         END DO
      END DO

!      print *, 'carmpole:'
!      do iex = 1, size(carmpole,1)
!         DO MType = 0, MaxMul
!            DO MCar = 1, (MType+1)*(MType+2)/2
!               print *, mtype,mcar, carmpole(iex,mcar,mtype)
!            end do
!         end do
!      end do

      ! Transform batch of cartesian integrals to spherical moments
!      ndim = MAX(Ibatch,IIbatch)
      ndim = SIZE(CarMpole,1)
      CALL fmm_transform_car_to_sph(CarMpole,SphMpole,ndim,MaxMul)

      DEALLOCATE(CarMpole)

   END SUBROUTINE fmm_build_SphMpole

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_store_SphMpole(basis,batch,Ish,Jsh,NPrim,MaxMul,mcntr,nmoms)

      IMPLICIT NONE
      TYPE(fmm_basis),      INTENT(IN)    :: basis
      TYPE(fmm_prim_batch), INTENT(IN)    :: batch(:)
      INTEGER(INTK),        INTENT(IN)    :: ISh, JSh, MaxMul, NPrim
      REAL(REALK),          INTENT(IN)    :: mcntr(3)
      INTEGER(INTK),        INTENT(INOUT) :: nmoms

      REAL(REALK), PARAMETER :: MomScrn = 1d-15
      LOGICAL :: IEqJ, flag
      INTEGER :: IAnglA, IAnglB
      INTEGER :: IL1, IL2 !, IJ
      INTEGER :: MType, MSph
      INTEGER :: IBatch
      INTEGER :: IIBatch
      INTEGER :: IL2Temp
      INTEGER :: Labelp, Labelq

      IEqJ = (ISh == JSh)
      IAnglA = basis%KType(Ish)
      IAnglB = basis%KType(Jsh)

      IBatch = 0
      IIBatch = 0
      Labelp = basis%KLoc_Car(ISh)
      DO IL1 = basis%LtuvMin_Car(IAnglA), basis%LtuvMax_Car(IAnglA)
         Labelp = Labelp + 1
         Labelq = basis%KLoc_Car(JSh)
         IL2Temp = basis%LtuvMax_Car(IAnglB)
         IF (IEqJ) IL2Temp = IL1
         DO IL2 = basis%LtuvMin_Car(IAnglB), IL2Temp
            IBatch = IBatch + 1
            Labelq = Labelq + 1

!contracted functions
            flag = .FALSE.
            DO MType = 0, MaxMul
               DO MSph = 1, (MType+MType+1)
                  ! Weak screening
                  IF (ABS(SphMpole(IBatch,MSph,MType)) < MomScrn) CYCLE
                  flag = .TRUE.
                  WRITE(LUINTM) nmoms+1, MType, (MSph-MType-1),      &
                                Labelp, Labelq,                      &
                                mcntr(1:3),                          &
                                SphMpole(IBatch,MSph,MType)
               END DO
            END DO
            IF (flag) nmoms = nmoms + 1

!primitive functions

!            DO IJ = 1, NPrim
!               IIBatch = IIBatch + 1
!               flag = .FALSE.
!               DO MType = 0, MaxMul
!                  DO MSph = 1, (MType+MType+1)
!                     ! Weak screening
!                     IF (ABS(SphMpole(IIBatch,MSph,MType)) < MomScrn) CYCLE
!                     WRITE(LUINTM) nmoms, MType, (MSph-MType-1),        &
!                     flag = .TRUE.
!                                   Labelp, Labelq,                      &
!                                   batch(IJ)%P(1:3),                    &
!                                   SphMpole(IIBatch,MSph,MType)
!                  END DO
!               END DO
!               IF (flag) nmoms = nmoms + 1
!            END DO

!------------
         END DO
      END DO

      IF (ALLOCATED(SphMpole)) DEALLOCATE(SphMpole)

! Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_real_array(batch(1)%P)
         CALL Unused_integer(NPrim)
      END IF
   END SUBROUTINE fmm_store_SphMpole

!-------------------------------------------------------------------------------

END MODULE fmm_multipole_ints

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SA_PREC(S,rdia)
      use ipPage, only: W
      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
      Real*8 S(nroots**2,nroots),rdia(*)

      irc=ipin(ipci)
      Do i=1,nroots
         Call SA_PREC2(rdia,S(1,i),W(ipci)%Vec,ERASSCF(i))
      End Do
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

      Subroutine SA_PREC2(rdia,S,CI,ENE)
      use negpre
      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
#include "incdia.fh"
      Real*8 rdia(*),CI(*),S(nroots,nroots)

      Do i=0,nroots-1
       Do j=0,nroots-1
         S(i+1,j+1)=0.0d0
         Do k=1,ncsf(State_Sym)
          dnum=rdia(k)-Ene
          dnum=Sign(Max(Abs(dnum),1.0d-16),dnum)
          S(i+1,j+1)=S(i+1,j+1)+
     &    CI(i*ncsf(State_Sym)+k)*CI(j*ncsf(State_Sym)+k)/dnum
         End Do
       End Do
      End Do
      Call MatInvert(S,nroots)
      Return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Martin Schuetz                                   *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine SwiOpt(AllCnt,OneHam,Ovrlp,mBT,CMO,mBB,nD)
************************************************************************
*                                                                      *
*     purpose: Switch from HF AO to MO optimization                    *
*                                                                      *
*     called from: SCF                                                 *
*                                                                      *
*     calls to:                                                        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
#include "twoswi.fh"
#include "file.fh"
*
*     declaration of subroutine parameter...
      Logical AllCnt
*     declaration of some local variables...
      Real*8 OneHam(mBT), Ovrlp(mBT), CMO(mBB,nD)
      Real*8 EThr_o,FThr_o,DThr_o,DNTh_o, ThrInt_o
      Save EThr_o,FThr_o,DThr_o,DNTh_o, ThrInt_o
      Character*8 Label
*
      If (AllCnt .AND. NDDO) Then
        nIterP=1
*       read full overlap matrix from ONEINT file
        Label='Mltpl  0'
        iOpt = 6
        iRC = -1
        Call RdOne(iRC,iOpt,Label,1,Ovrlp,lOper)
        If (iRC.ne.0) GoTo 9999
*       read full one-electron Hamiltonian from ONEINT file
        Label='OneHam  '
        iOpt=6
        iRC = -1
        Call RdOne(iRC,iOpt,Label,1,OneHam,lOper)
        If (iRc.ne.0) GoTo 9999
*       Call Get_PotNuc(PotNuc)
*       Call Get_dScalar('PotNuc',PotNuc)
        Call Peek_dScalar('PotNuc',PotNuc)
*       orthonormalize CMO
        Do iD = 1, nD
           Call Ortho(CMO(1,iD),nBO,Ovrlp,nBT)
        End Do
*       restore threshold values in WfCtl
        EThr=EThr_o
        Call Put_dScalar('EThr',EThr)
        FThr=FThr_o
        DThr=DThr_o
        DltNTh=DNTh_o
        Call xSet_ThrInt(ThrInt_o)
*       set twoel to AllCnt...
        NDDO=.FALSE.
*       close and reopen some DA files...
        Call DaClos(LuDSt)
        Call DaClos(LuOSt)
        Call DaClos(LuTSt)
        Call DaClos(LuGrd)
        Call DaClos(LuDGd)
        Call DaClos(Lux)
        Call DaClos(LuDel)
        Call DaClos(Luy)
        Call DAName(LuDSt,FnDSt)
        Call DAName(LuOSt,FnOSt)
        Call DAName(LuTSt,FnTSt)
        Call DAName(LuGrd,FnGrd)
        Call DAName(LuDGd,FnDGd)
        Call DAName(Lux,Fnx)
        Call DAName(LuDel,FnDel)
        Call DAName(Luy,Fny)
      Else
        nIterP=0
*       read kinetic energy matrix, use space for overlap matrix,
*       since that one is reread afterwards anyway...
        Label='Kinetic '
        iOpt = 6
        iRC = -1
        Call RdOne(iRC,iOpt,Label,1,Ovrlp,lOper)
        If (iRC.ne.0) GoTo 9999
*       read NDDO NA matrix from ONEINT file...
        Label='AttractS'
        iOpt = 6
        iRC = -1
        Call RdOne(iRC,iOpt,Label,1,OneHam,lOper)
        If (iRC.ne.0) GoTo 9999
*       and form NDDO one-electron Hamiltonian...
        Call DaXpY_(nBT,One,Ovrlp,1,OneHam,1)
*       read NDDO overlap matrix from ONEINT file...
        Label='MltplS 0'
        iOpt = 6
        iRC = -1
        Call RdOne(iRC,iOpt,Label,1,Ovrlp,lOper)
        If (iRC.ne.0) GoTo 9999
*       save threshold values in WfCtl
        EThr_o=EThr
        FThr_o=FThr
        DThr_o=DThr
        DNTh_o=DltNTh
        ThrInt_o=Get_ThrInt()
*       and set new thresholds
c       EThr=EThr*1.0D+04
c       Call Put_dScalar('EThr',EThr)
c       FThr=FThr*1.0D+04
c       DThr=DThr*1.0D+04
c       DltNTh=DltNTh*1.0D+04
c       Call xSet_ThrInt(ThrInt_o*1.0D+04)
*       set twoel to OneCnt...
        NDDO=.TRUE.
      End If
*
      Return
*
*---- Error exit
 9999 Continue
      Write (6,*) 'SwiOpt: Error reading ONEINT'
      Write (6,'(A,A)') 'Label=',Label
      Call Abend()
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Screen_mck(iOffZ,iOffE,PAO,Scrtch,mPAO,nZeta,nEta,mZeta,mEta,lZeta,lEta, &
                      k2Data1,k2Data2, &
                      Zeta,ZInv,P,xA,xB,rKA,Eta,EInv,Q,xG,xD,rKC, &
                      xpre,iphX1,iphY1,iphZ1,iphX2,iphY2,iphZ2,CutInt,PreScr,IndZet,IndEta,ldot)

!***********************************************************************
!                                                                      *
! Object: to prescreen the integral derivatives.                       *
!                                                                      *
!   nZeta, nEta : unpartitioned length of primitives.                  *
!                                                                      *
!   mZeta, mEta : section length due to partitioning. These are usually*
!                 equal to nZeta and nEta.                             *
!                                                                      *
!   lZeta, lEta : section length after prescreening.                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             March '92                                                *
!                                                                      *
!             April '92 modified for gradient estimate                 *
!                                                                      *
!             Anders Bernhardsson 1995                                 *
!***********************************************************************

use k2_structure, only: k2_type
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iOffZ, iOffE, mPAO, nZeta, nEta, mZeta, mEta, iphX1, iphY1, iphZ1, iphX2, iphY2, iphZ2
real(kind=wp), intent(inout) :: PAO(mZeta*mEta*mPAO)
real(kind=wp), intent(out) :: Scrtch(mZeta*mEta*(1+mPAO*2)), Zeta(nZeta), ZInv(nZeta), P(nZeta,3), xA(nZeta), xB(nZeta), &
                              rKA(nZeta), Eta(nEta), EInv(nEta), Q(nEta,3), xG(nEta), xD(nEta), rKC(nEta), xpre(mZeta*mEta)
integer(kind=iwp), intent(out) :: lZeta, lEta, IndZet(nZeta), IndEta(nEta)
type(k2_type), intent(in) :: k2Data1, k2Data2
real(kind=wp), intent(in) :: CutInt
logical(kind=iwp), intent(in) :: PreScr, ldot
integer(kind=iwp) :: iEta, ij, ip, ip1, ip2, iPAO, ipOAP, ipPAO, iZeta, jEta, jPAO, jZeta
real(kind=wp) :: abcd, abMax, cdMax

#ifdef _DEBUGPRINT_
call RecPrt('2nd order density matrix',' ',PAO,mZeta*mEta,mPAO)
#endif

abMax = k2Data1%abMax
cdMax = k2Data2%abMax

ip = 1
ipPAO = ip
ip = ip+mZeta*mEta*mPAO

! Compress all indices except zeta

ipOAP = ip
ip = ip+mZeta*mEta*mPAO
if (ldot) call DGetMO(PAO,mZeta,mZeta,mEta*mPAO,Scrtch(ipOAP),mEta*mPAO)

! Prescreen Zeta

lZeta = 0
IndZet(:) = 0
if (PreScr) then
  do iZeta=1,mZeta
    jZeta = k2Data1%IndZ(iOffZ+iZeta)
    IndZet(jZeta) = -lZeta
    !write(u6,*) k2Data1%ab(iOffZ+iZeta),cdMax
    abcd = k2Data1%ab(iOffZ+iZeta)*cdMax
    if (abs(abcd) >= CutInt) then
      lZeta = lZeta+1
      IndZet(jZeta) = lZeta
      Zeta(lZeta) = k2Data1%Zeta(iOffZ+iZeta)
      rKA(lZeta) = k2Data1%Kappa(iOffZ+iZeta)
      P(lZeta,1) = k2Data1%PCoor(iOffZ+iZeta,1)
      P(lZeta,2) = k2Data1%PCoor(iOffZ+iZeta,2)
      P(lZeta,3) = k2Data1%PCoor(iOffZ+iZeta,3)
      xA(lZeta) = k2Data1%Alpha(iOffZ+iZeta)
      xB(lZeta) = k2Data1%Beta(iOffZ+iZeta)
      ZInv(lZeta) = k2Data1%ZInv(iOffZ+iZeta)
      ip1 = ipOAP+mEta*mPAO*(iZeta-1)
      ip2 = ipPAO+mEta*mPAO*(lZeta-1)
      if (ldot) Scrtch(ip2:ip2+mEta*mPAO-1) = Scrtch(ip1:ip1+mEta*mPAO-1)
    end if
  end do
else
  do iZeta=1,mZeta
    lZeta = lZeta+1
    jZeta = k2Data1%IndZ(iOffZ+iZeta)
    IndZet(jZeta) = lZeta
    Zeta(lZeta) = k2Data1%Zeta(iOffZ+iZeta)
    rKA(lZeta) = k2Data1%Kappa(iOffZ+iZeta)
    P(lZeta,1) = k2Data1%PCoor(iOffZ+iZeta,1)
    P(lZeta,2) = k2Data1%PCoor(iOffZ+iZeta,2)
    P(lZeta,3) = k2Data1%PCoor(iOffZ+iZeta,3)
    xA(lZeta) = k2Data1%Alpha(iOffZ+iZeta)
    xB(lZeta) = k2Data1%Beta(iOffZ+iZeta)
    ZInv(lZeta) = k2Data1%ZInv(iOffZ+iZeta)
    ip1 = ipOAP+mEta*mPAO*(iZeta-1)
    ip2 = ipPAO+mEta*mPAO*(lZeta-1)
    if (ldot) Scrtch(ip2:ip2+mEta*mPAO-1) = Scrtch(ip1:ip1+mEta*mPAO-1)
  end do
end if
if (lZeta /= 0) then

  if (iphX1 /= 1) P(1:lZeta,1) = -P(1:lZeta,1)
  if (iphY1 /= 1) P(1:lZeta,2) = -P(1:lZeta,2)
  if (iphZ1 /= 1) P(1:lZeta,3) = -P(1:lZeta,3)

  ! Transpose eta,mPAO,zeta to mPAO,zeta,eta

  if (ldot) call DGetMO(Scrtch(ipPAO),mEta,mEta,mPAO*lZeta,Scrtch(ipOAP),mPAO*lZeta)

  ! Prescreen Eta

  lEta = 0
  IndEta(:) = 0
  if (PreScr) then
    do iEta=1,mEta
      jEta = k2Data2%IndZ(iOffE+iEta)
      IndEta(jEta) = -lEta ! To be removed
      abcd = k2Data2%ab(iOffE+iEta)*abMax
      if (abs(abcd) >= CutInt) then
        lEta = lEta+1
        IndEta(jEta) = lEta
        Eta(lEta) = k2Data2%Zeta(iOffE+iEta)
        rKC(lEta) = k2Data2%Kappa(iOffE+iEta)
        Q(lEta,1) = k2Data2%PCoor(iOffE+iEta,1)
        Q(lEta,2) = k2Data2%PCoor(iOffE+iEta,2)
        Q(lEta,3) = k2Data2%PCoor(iOffE+iEta,3)
        xG(lEta) = k2Data2%Alpha(iOffE+iEta)
        xD(lEta) = k2Data2%Beta(iOffE+iEta)
        EInv(lEta) = k2Data2%ZInv(iOffE+iEta)
        ip1 = ipOAP+mPAO*lZeta*(iEta-1)
        ip2 = ipPAO+mPAO*lZeta*(lEta-1)
        if (ldot) Scrtch(ip2:ip2+lZeta*mPAO-1) = Scrtch(ip1:ip1+lZeta*mPAO-1)
      end if
    end do
  else
    do iEta=1,mEta
      lEta = lEta+1
      jEta = k2Data2%IndZ(iOffE+iEta)
      IndEta(jEta) = lEta
      Eta(lEta) = k2Data2%Zeta(iOffE+iEta)
      rKC(lEta) = k2Data2%Kappa(iOffE+iEta)
      Q(lEta,1) = k2Data2%PCoor(iOffE+iEta,1)
      Q(lEta,2) = k2Data2%PCoor(iOffE+iEta,2)
      Q(lEta,3) = k2Data2%PCoor(iOffE+iEta,3)
      xG(lEta) = k2Data2%Alpha(iOffE+iEta)
      xD(lEta) = k2Data2%Beta(iOffE+iEta)
      EInv(lEta) = k2Data2%ZInv(iOffE+iEta)
      ip1 = ipOAP+mPAO*lZeta*(iEta-1)
      ip2 = ipPAO+mPAO*lZeta*(lEta-1)
      if (ldot) Scrtch(ip2:ip2+lZeta*mPAO-1) = Scrtch(ip1:ip1+lZeta*mPAO-1)
    end do
  end if
  if (lEta /= 0) then

    if (iphX2 /= 1) Q(1:lEta,1) = -Q(1:lEta,1)
    if (iphY2 /= 1) Q(1:lEta,2) = -Q(1:lEta,2)
    if (iphZ2 /= 1) Q(1:lEta,3) = -Q(1:lEta,3)

    ! Transpose mPAO,zeta,eta to zeta,eta,mPAO

    if (ldot) call DGeTMO(Scrtch(ipPAO),mPAO,mPAO,lZeta*lEta,PAO,lZeta*lEta)

  end if
end if

ij = 0
do iEta=1,lEta
  xpre(ij+1:ij+lZeta) = rKA(1:lZeta)*rKC(iEta)*sqrt(One/(Zeta(1:lZeta)+Eta(iEta)))
  ij = ij+lZeta
end do
if (ldot) then
  jPAO = 0
  do iPAO=1,mPAO
    PAO(jPAO+1:jPAO+lZeta*lEta) = xpre(1:lZeta*lEta)*PAO(jPAO+1:jPAO+lZeta*lEta)
    jPAO = jPAO+lZeta*lEta
  end do
end if
#ifdef _DEBUGPRINT_
call RecPrt(' PAO',' ',PAO,lZeta*lEta,mPAO)
#endif

return

end subroutine Screen_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine map32 (a,b,dimp,dimq,dimr,dim1,dim2,dim3,p,q,r,nfact)
c
       integer dimp,dimq,dimr,dim1,dim2,dim3,p,q,r,nfact
       real*8 a(1:dimp,1:dimq,1:dimr)
       real*8 b(1:dim1,1:dim2,1:dim3)
c     integer index(1:3)
c
       integer pp,qq,rr
c
       if (nfact.eq.1) then
c
c     fact = + 1
c
c     do 100 rr=1,dimr
c     index(r)=rr
c     do 100 qq=1,dimq
c     index(q)=qq
c     do 100 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2),index(3))=a(pp,qq,rr)
c100  continue
c
       if (p.eq.1) then
c     1**
       if (q.eq.2) then
c     12* (3)
       do 110 rr=1,dimr
       do 111 qq=1,dimq
       do 112 pp=1,dimp
       b(pp,qq,rr)=a(pp,qq,rr)
 112    continue
 111    continue
 110    continue
       else
c     13* (2)
       do 120 rr=1,dimr
       do 121 qq=1,dimq
       do 122 pp=1,dimp
       b(pp,rr,qq)=a(pp,qq,rr)
 122    continue
 121    continue
 120    continue
       end if
       else if (p.eq.2) then
c     2**
       if (q.eq.1) then
c     21* (3)
       do 130 rr=1,dimr
       do 131 qq=1,dimq
       do 132 pp=1,dimp
       b(qq,pp,rr)=a(pp,qq,rr)
 132    continue
 131    continue
 130    continue
       else
c     23* (1)
       do 140 rr=1,dimr
       do 141 qq=1,dimq
       do 142 pp=1,dimp
       b(rr,pp,qq)=a(pp,qq,rr)
 142    continue
 141    continue
 140    continue
       end if
       else if (p.eq.3) then
c     3**
       if (q.eq.1) then
c     31* (2)
       do 150 rr=1,dimr
       do 151 qq=1,dimq
       do 152 pp=1,dimp
       b(qq,rr,pp)=a(pp,qq,rr)
 152    continue
 151    continue
 150    continue
       else
c     32* (1)
       do 160 rr=1,dimr
       do 161 qq=1,dimq
       do 162 pp=1,dimp
       b(rr,qq,pp)=a(pp,qq,rr)
 162    continue
 161    continue
 160    continue
       end if
       end if
c
c
       else
c
c     factor = -1
c
c     do 200 rr=1,dimr
c     index(r)=rr
c     do 200 qq=1,dimq
c     index(q)=qq
c     do 200 pp=1,dimp
c     index(p)=pp
c     b(index(1),index(2),index(3))=-a(pp,qq,rr)
c     200        continue
c
       if (p.eq.1) then
c     1**
       if (q.eq.2) then
c     12* (3)
       do 210 rr=1,dimr
       do 211 qq=1,dimq
       do 212 pp=1,dimp
       b(pp,qq,rr)=-a(pp,qq,rr)
 212    continue
 211    continue
 210    continue
       else
c     13* (2)
       do 220 rr=1,dimr
       do 221 qq=1,dimq
       do 222 pp=1,dimp
       b(pp,rr,qq)=-a(pp,qq,rr)
 222    continue
 221    continue
 220    continue
       end if
       else if (p.eq.2) then
c     2**
       if (q.eq.1) then
c     21* (3)
       do 230 rr=1,dimr
       do 231 qq=1,dimq
       do 232 pp=1,dimp
       b(qq,pp,rr)=-a(pp,qq,rr)
 232    continue
 231    continue
 230    continue
       else
c     23* (1)
       do 240 rr=1,dimr
       do 241 qq=1,dimq
       do 242 pp=1,dimp
       b(rr,pp,qq)=-a(pp,qq,rr)
 242    continue
 241    continue
 240    continue
       end if
       else if (p.eq.3) then
c     3**
       if (q.eq.1) then
c     31* (2)
       do 250 rr=1,dimr
       do 251 qq=1,dimq
       do 252 pp=1,dimp
       b(qq,rr,pp)=-a(pp,qq,rr)
 252    continue
 251    continue
 250    continue
       else
c     32* (1)
       do 260 rr=1,dimr
       do 261 qq=1,dimq
       do 262 pp=1,dimp
       b(rr,qq,pp)=-a(pp,qq,rr)
 262    continue
 261    continue
 260    continue
       end if
       end if
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(r)
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018, Ignacio Fdez. Galvan                             *
************************************************************************
      SubRoutine Print_Isotopes()
      use Period
      use Basis_Info, only: nCnttp, dbsc
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "constants2.fh"
      Logical Changed
*                                                                      *
************************************************************************
*                                                                      *
      iRout=2
      iPrint = nPrint(iRout)
      If (iPrint.eq.0) Return
      LuWr=6
*                                                                      *
************************************************************************
*                                                                      *
*     Determine whether any mass is different from default
*
      Changed = .False.
      Do i=1,nCnttp
        If (dbsc(i)%Aux.or.dbsc(i)%Frag) Cycle
        iAtom=dbsc(i)%AtmNr
        If (dbsc(i)%CntMass.ne.rMass(iAtom)) Then
          Changed = .True.
          Exit
        End If
      End Do
      If (.not.Changed.and.iPrint.le.5) Return
*                                                                      *
************************************************************************
*                                                                      *
      Write (LuWr,*)
      Call CollapseOutput(1,'   Isotope specification:')
      Write (LuWr,'(3X,A)') '   ----------------------'
      Write (LuWr,*)
      If (Changed) Then
        Write(LuWr,10) 'Center                     [     Default     ]'
        Write(LuWr,10) 'Type   Z    A    mass (Da) [   A    mass (Da)]'
        Write(LuWr,10) '---------------------------------------------'
      Else
        Write(LuWr,10) 'Center'
        Write(LuWr,10) 'Type   Z    A    mass (Da)'
        Write(LuWr,10) '--------------------------'
      End If
      Do i=1,nCnttp
        If (dbsc(i)%Aux.or.dbsc(i)%Frag) Cycle
        iAtom=dbsc(i)%AtmNr
        act_Mass=dbsc(i)%CntMass/UToAU
        def_Mass=rmass(iAtom)/UToAU
        If (act_Mass.ne.def_Mass) Then
          Write(LuWr,101) i,iAtom,nInt(act_Mass),act_Mass,
     &                            nInt(def_Mass),def_Mass
        Else
          Write(LuWr,100) i,iAtom,nInt(act_Mass),act_Mass
        End If
      End Do
      Call CollapseOutput(0,'   Isotope specification:')
      Write (LuWr,*)
*                                                                      *
************************************************************************
*                                                                      *
 10   Format(1X,A)
100   Format(I5,1X,I3,1X,I4,1X,F12.6)
101   Format(I5,1X,I3,1X,I4,1X,F12.6,1X,'[',I4,1X,F12.6,']')
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkV_Goo3(V,V2,dima,no)
! this routine does:
! Make AntiSymmetric integrals
! V2(a',j,i,u) <- 2 V(a,j|iu) - (a,i|ju)

use Index_Functions, only: iTri, nTri_Elem
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, no
real(kind=wp), intent(in) :: V(dima,no,nTri_Elem(no))
real(kind=wp), intent(out) :: V2(dima,no,no,no)
integer(kind=iwp) :: i, iu, j, ju, u

do u=1,no

  do i=1,no
    iu = iTri(i,u)

    do j=1,no

      ju = iTri(j,u)

      V2(:,j,i,u) = Two*V(:,j,iu)-V(:,i,ju)

    end do
  end do
end do

return

end subroutine MkV_Goo3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      subroutine triang(nrow,a)

      IMPLICIT NONE

      integer nrow
      real*8 a(nrow**2)

      integer i,j,ij,ji
      real*8 symm

c Convert a square matrix to triangular in-place.

      do 10 i=2,nrow
        do 11 j=1,i-1
          ij=i+(j-1)*nrow
          ji=j+(i-1)*nrow
          symm=0.5D0*(a(ij)+a(ji))
          a(ji)=symm
          a(ij)=symm
  11    continue
  10  continue
      ij=0
      do i=1,nrow
       do j=1,i
        ij=ij+1
        a(ij)=a(j+nrow*(i-1))
       end do
      end do
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Martin Schuetz                                   *
!               2022, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Mk_FockAO(nIter_)
!***********************************************************************
!                                                                      *
!     purpose: Update Fock matrix from actual OneHam & TwoHam matrices *
!                                                                      *
!***********************************************************************

use InfSCF, only: FockAO, OneHam, TwoHam, Vxc
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nIter_
integer(kind=iwp) :: i2Hm, iD, nD, NumDT
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: nDT
#endif

NumDT = size(TwoHam,3)
nD = size(FockAO,2)

if (nIter_ == 1) then
  i2Hm = 1
else
  i2Hm = NumDT
end if
#ifdef _DEBUGPRINT_
nDT = size(FockAO,1)
write(u6,*) 'i2Hm=',i2Hm
call NrmClc(OneHam,nDT,'UpdFck','OneHam')
call NrmClc(TwoHam(1,1,i2Hm),nDT*nD,'UpdFck','T in i2Hm')
call NrmClc(FockAO,(nDT)*nD,'UpdFck','FockAO')
call NrmClc(Vxc(1,1,i2Hm),nDT*nD,'UpdFck','V in i2Hm  ')
#endif
do iD=1,nD

  ! F = h + G(D), where D is the inter-/extrapolated
  ! densitity matrix. This part is exact.
  !
  ! G(D) = Sum_i c_i G(D_i)
  !
  ! Here we add the contribution to the Fock matrix from
  ! the external field (the none linear or bi-linear parts).
  ! Note that Vxc(D_a+D_b)=/= Vxc(D_a) + Vxc(D_b). However,
  ! using a first order Taylor expansion we can demonstate that
  ! this is correct to first order. Hence, we pick up the
  ! inter-/extra-polated external potential here as generated
  ! by OptClc.f.
  !
  ! Proof:
  !
  ! D = Sum_i c_i * D_i; Sum_i c_i = 1
  !
  ! First order Taylor expansion of Vxc around D_0 (arbitrary)
  !
  ! Vxc(D) = Vxc(D_0) + dVxc(D_0)/dD (D-D_0)
  !
  ! Vxc(D) = Vxc(D_0) + Sum_i C_i dVxc(D_0)/dD (D_i_D_0)
  !
  ! Vxc(D) = Vxc(D_0) + Sum_i C_i (Vxc(D_i) - Vxc(D_0)
  !
  ! Vxc(D) = Sum_i c_i Vxc(D_i), which is produced by OptClc.f

  FockAO(:,iD) = OneHam(:)+TwoHam(:,iD,i2Hm)+Vxc(:,iD,i2Hm)

# ifdef _DEBUGPRINT_
  write(u6,*) 'Fock'
  !write(u6,'(5f12.6)') (FockAO(ivv,iD),ivv=1,nDT)
  call NrmClc(FockAO(1,iD),nDT,'Fock  ','UpdFck ')
  call NrmClc(TwoHam(1,iD,i2Hm),nDT,'TwoHam','UpdFck ')
  call NrmClc(Vxc(1,iD,i2Hm),nDT,'Vxc','UpdFck ')
# endif

end do

end subroutine Mk_FockAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_RSCOPY(IIBSTRSH,NNBSTRSH,INDRED,IRS1,IRS2,
     &                      MSYM,MMSHL,LMMBSTRT,NRS)
C
C     Purpose: copy red. set info from location IRS1 to IRS2.
C              Special action is taken with INDRED if IRS1=1 so that it
C              will point as expected for the "current" reduced set.
C
      IMPLICIT NONE
      INTEGER IRS1, IRS2, MSYM, MMSHL, LMMBSTRT, NRS
      INTEGER IIBSTRSH(MSYM,MMSHL,NRS), NNBSTRSH(MSYM,MMSHL,NRS)
      INTEGER INDRED(LMMBSTRT,NRS)
      INTEGER IAB
#include "cholesky.fh"

      CALL ICOPY(MSYM*MMSHL,IIBSTRSH(1,1,IRS1),1,IIBSTRSH(1,1,IRS2),1)
      CALL ICOPY(MSYM*MMSHL,NNBSTRSH(1,1,IRS1),1,NNBSTRSH(1,1,IRS2),1)
      CALL ICOPY(MSYM,IIBSTR(1,IRS1),1,IIBSTR(1,IRS2),1)
      CALL ICOPY(MSYM,NNBSTR(1,IRS1),1,NNBSTR(1,IRS2),1)
      IF (IRS1 .EQ. 1) THEN
         DO IAB = 1,MMBSTRT
            INDRED(IAB,IRS2) = IAB
         END DO
      ELSE
         CALL ICOPY(MMBSTRT,INDRED(1,IRS1),1,INDRED(1,IRS2),1)
      END IF
      NNBSTRT(IRS2) = NNBSTRT(IRS1)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
Module Real_Info
Private
Public :: AccMch, ThrInt, PotNuc, Rtrnc, CutInt, TMass, qNuc, PkAcc, &
          Thrs, RadMax, cdMax, EtMax, E1, E2, RPQMin, SadStep, Shake,&
          ChiI2, CoM, rMI, Prin, PAX, CoC, kVector, &
          Real_Info_Dmp, Real_Info_Get

#include "stdalloc.fh"
Integer i
Real*8 ::AccMch  =1.d-15
Real*8 ::ThrInt  =1.d-14
Real*8 ::PotNuc  =0.0D0
Real*8 ::Rtrnc   =3.D0
Real*8 ::CutInt  =1.d-16
Real*8 ::TMass   =0.0D0
Real*8 ::qNuc    =0.0D0
Real*8 ::PkAcc   =1.d-14
Real*8 ::Thrs    =1.d-6
Real*8 ::RadMax  = 0.0D0
Real*8 ::cdMax   = 0.0D0
Real*8 ::EtMax   = 0.0D0
Real*8 ::E1      =0.0D0
Real*8 ::E2      =0.0D0
Real*8 ::RPQMin  = 0.4d0
Real*8 ::SadStep =0.1d0
Real*8 ::CLight_Info=0.0D0
Real*8 ::Shake   =-1.0D0
Real*8 ::ChiI2   =0.0D0
Real*8 :: CoM(3)=[(0.0D0,i=1,3)]
Real*8 :: rMI(6)=[(0.0D0,i=1,6)]
Real*8 :: Prin(3)=[(0.0D0,i=1,3)]
Real*8 :: PAX(9)=[(0.0D0,i=1,9)]
Real*8 :: CoC(3)=[(0.0D0,i=1,3)]
Real*8 :: kVector(3)=[(0.0D0,i=1,3)]

Contains

Subroutine Real_Info_Dmp()
#include "RelLight.fh"
  Real*8, Allocatable:: rDmp(:)
  Integer:: Len=46

  CLight_Info=CLightAU
  Call mma_allocate(rDmp,Len,Label='rDmp:Real')

  rDmp(01)=AccMch
  rDmp(02)=ThrInt
  rDmp(03)=PotNuc
  rDmp(04)=Rtrnc
  rDmp(05)=CutInt
  rDmp(06)=TMass
  rDmp(07)=qNuc
  rDmp(08)=PkAcc
  rDmp(09)=Thrs
  rDmp(10)=RadMax
  rDmp(11)=cdMax
  rDmp(12)=EtMax
  rDmp(13)=E1
  rDmp(14)=E2
  rDmp(15)=RPQMin
  rDmp(16)=SadStep
  rDmp(17)=CLight_Info
  rDmp(18)=Shake
  rDmp(19)=ChiI2
  rDmp(20:22)= CoM(1:3)
  rDmp(23:28)= rMI(1:6)
  rDmp(29:31)= Prin(1:3)
  rDmp(32:40)= PAX(1:9)
  rDmp(41:43)= CoC(1:3)
  rDmp(44:46)= kVector(1:3)

  Call Put_dArray('Real_Info',rDmp,Len)
  Call mma_deallocate(rDmp)
End Subroutine Real_Info_Dmp

Subroutine Real_Info_Get()
#include "RelLight.fh"
  Real*8, Allocatable:: rDmp(:)
  Integer:: Len=46

  Call mma_allocate(rDmp,Len,Label='rDmp:Real')
  Call Get_dArray('Real_Info',rDmp,Len)

  AccMch     = rDmp(01)
  ThrInt     = rDmp(02)
  PotNuc     = rDmp(03)
  Rtrnc      = rDmp(04)
  CutInt     = rDmp(05)
  TMass      = rDmp(06)
  qNuc       = rDmp(07)
  PkAcc      = rDmp(08)
  Thrs       = rDmp(09)
  RadMax     = rDmp(10)
  cdMax      = rDmp(11)
  EtMax      = rDmp(12)
  E1         = rDmp(13)
  E2         = rDmp(14)
  RPQMin     = rDmp(15)
  SadStep    = rDmp(16)
  CLight_Info= rDmp(17)
  Shake      = rDmp(18)
  ChiI2      = rDmp(19)
  CoM(1:3)   = rDmp(20:22)
  rMI(1:6)   = rDmp(23:28)
  Prin(1:3)  = rDmp(29:31)
  PAX(1:9)   = rDmp(32:40)
  CoC(1:3)   = rDmp(41:43)
  kVector(1:3)=rDmp(44:46)

  Call mma_deallocate(rDmp)

  CLightAU = CLight_Info

End Subroutine Real_Info_Get

End Module Real_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine gtany_cvb(string,intx,realx,ic,ifield,ierr)

use casvb_global, only: iline, ilv, lenline, line
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(inout) :: string
integer(kind=iwp), intent(inout) :: intx, ierr
real(kind=wp), intent(inout) :: realx
integer(kind=iwp), intent(in) :: ic, ifield
integer(kind=iwp) :: ich, iempty, ifirst, istatus, jch, jfield, jline
logical(kind=iwp) :: done
integer(kind=iwp), parameter :: nempty = 1
logical(kind=iwp), parameter :: debug = .false.
character(len=*), parameter :: empty(nempty) = ['--']
logical(kind=iwp), external :: isitanint_cvb, isitareal_cvb

if (ic > 1) ierr = 0
jfield = 1
jline = 1
do ich=1,lenline
  if (ilv(ich) == 1) jline = jline+1
  if ((jline == iline) .and. (ilv(ich) == 2)) jfield = jfield+1
  if ((jline == iline) .and. (jfield == ifield)) then
    jch = ich
    if (ich == 1) jch = 0
    do
      jch = jch+1
      if ((ilv(jch) /= 0) .or. (jch == lenline+1)) exit
    end do
    ifirst = ich+1
    if (ich == 1) ifirst = 1
    ! Special character strings to signify empty field?
    done = .false.
    do iempty=1,nempty
      if (line(ifirst:jch-1) == trim(empty(iempty))) then
        done = .true.
        exit
      end if
    end do
    if (done) then
      ! "Empty" field:
      if (ic == 1) then
        string = ' '
      else
        ierr = 2
      end if
    else
      if (debug) write(u6,*) ' Field=',line(ifirst:jch-1)
      if (ic == 1) then
        string = line(ifirst:jch-1)
        if (debug) write(u6,*) ' Field read as string :',string
      else if (ic == 2) then
        if (ifirst > jch-1) then
          ierr = 2
          return
        end if
        if (.not. isitanint_cvb(line(ifirst:jch-1))) then
          ierr = 1
          if (debug) write(u6,*) ' Could not read field as integer.'
          return
        end if
        read(line(ifirst:jch-1),*,iostat=istatus) intx
        if (istatus > 0) then
          ierr = 1
          if (debug) write(u6,*) ' Could not read field as integer.'
          return
        end if
        if (debug) write(u6,*) ' Field read as int :',intx
      else if (ic == 3) then
        if (ifirst > jch-1) then
          ierr = 2
          return
        end if
        if (.not. isitareal_cvb(line(ifirst:jch-1))) then
          ierr = 1
          if (debug) write(u6,*) ' Could not read field as real.'
          return
        end if
        read(line(ifirst:jch-1),*,iostat=istatus) realx
        if (istatus > 0) then
          ierr = 1
          if (debug) write(u6,*) ' Could not read field as real.'
          return
        end if
        if (debug) write(u6,*) ' Field read as real :',realx
      end if
    end if
    exit
  end if
end do
if (ich > lenline) then
  write(u6,*) ' Error in input parsing !'
  call abend_cvb()
end if

return

end subroutine gtany_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Set_Fake_ERIs()

use Basis_Info, only: nBas
use RICD_Info, only: Cholesky, Do_RI
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
#include "cholesky.fh"
integer(kind=iwp) :: i, nBasT, nVec_RI(8)
character(len=16) :: NamRfil
integer(kind=iwp), allocatable :: iSOShl(:)

write(u6,*)
write(u6,*) '   *** Skipping anything related to ERIs ***'
write(u6,*)

if (.not. (Cholesky .or. Do_RI)) return

call Get_NameRun(NamRfil)
call NameRun('AUXRFIL')

call Get_iScalar('ChoVec Address',CHO_ADRVEC)
nBasT = nBas(0)
do i=1,nIrrep-1
  nBasT = nBasT+nBas(i)
end do
call mma_allocate(iSOShl,nBasT)
call Get_dScalar('Cholesky Threshold',THRCOM)
call Get_iArray('NumCho',NumCho,nIrrep)
call Get_iArray('nVec_RI',nVec_RI,nIrrep)
call Get_iArray('iSOShl',ISOSHL,NBAST)

call NameRun(NamRfil)
call Put_iArray('iSOShl',ISOSHL,NBAST)
call mma_deallocate(iSOShl)
call Put_iArray('NumCho',NumCho,nIrrep)
call Put_iArray('nVec_RI',nVec_RI,nIrrep)
call Put_iScalar('ChoVec Address',CHO_ADRVEC)
call Put_dScalar('Cholesky Threshold',THRCOM)

return

end subroutine Set_Fake_ERIs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine BMtrx(nsAtom,Coor,nIter,mTtAtm,nWndw)
      Use Slapaf_Info, Only: Cx, Shift, qInt, KtB, BMx, Smmtrc,
     &                       Lbl
      Use Slapaf_Parameters, only: Curvilinear, Redundant, nDimBC,
     &                             User_Def, MaxItr, BSet, HSet,
     &                             lOld, Numerical, nLambda, iRef
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
      Real*8 Coor(3,nsAtom)
      Character(LEN=100), External:: Get_SuperName
      Integer, Allocatable:: TabB(:,:), TabA(:,:,:), TabAI(:,:), AN(:)
      Real*8, Allocatable:: TR(:), TRNew(:), TROld(:), Scr2(:),
     &                      Vec(:,:), Coor2(:,:), EVal(:), Hss_X(:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
        Subroutine Box(Coor,nsAtom,iANr,TabB,TabA,nBonds,nMax)
        Integer nsAtom
        Real*8 Coor(3,nsAtom)
        Integer iANr(nsAtom)
        Integer, Allocatable:: TabB(:,:), TabA(:,:,:)
        Integer nBonds, nMax
        End Subroutine Box
        Subroutine Hidden(Coor,AN,nHidden)
        Real*8, Allocatable:: Coor(:,:)
        Integer, Allocatable:: AN(:)
        Integer nHidden
        End Subroutine Hidden
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      nQQ = 0
*
      Lu=6
*                                                                      *
************************************************************************
*                                                                      *
*     iRef: point at the reference geometry, used for non-redundant
*           internal coordinate to define the K-matrix and to generate
*           the raw model Hessian and TR vectors.
*
      If (Numerical) Then
         iRef = 1               ! Numerical Hessian Computation
      Else If (iRef.eq.0) Then
         If (.Not.BSet) Then
            iRef = nIter-1      ! Compute cartesian Structure
         Else
            iRef = nIter        ! Normal Computation
         End If
      End If
*
#ifdef _DEBUGPRINT_
      Write (6,*) ' Actual structure from iteration',iRef
      Write (6,*) ' Last structure from iteration',nIter
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Find the translational and rotational eigenvectors for the
*     current structure.
*
      Call mma_allocate(TR,18*nsAtom,Label='TR')
      TR(:)=Zero
*
      Call TRPGen(nDimBC,nsAtom,Cx(1,1,iRef),mTR,.False.,TR)
*
      Call mma_allocate(TRnew,3*nsAtom*mTR,Label='TRNew')
      TRNew(:)=Zero
      i = 0
      Do ix = 1, 3*nsAtom
         iAtom = (ix+2)/3
         ixyz = ix - (iAtom-1)*3
         If (Smmtrc(ixyz,iAtom)) Then
            i = i + 1
            call dcopy_(mTR,TR(i),-nDimBC,TRNew(ix),3*nsAtom)
         End If
      End Do
      Call Put_dArray('TR',TRnew,3*nsAtom*mTR)
      Call mma_deallocate(TRnew)
*
*     Call RecPrt('TR',' ',TR,nDimBC,mTR)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(TabAI,2,mTtAtm,Label='TabAI')
      Call mma_allocate(Vec,3*mTtAtm,nDimBC,Label='Vec')
      Call mma_allocate(AN,mTtAtm,Label='AN')
      Call mma_allocate(Coor2,3,mTtAtm,Label='Coor2')
*
*-----Generate Grand atoms list
*
      Call GenCoo(Cx(1,1,iRef),nsAtom,Coor2,mTtAtm,Vec,nDimBC,AN,TabAI)
*
*---- Are there some hidden frozen atoms ?
*
      Call Hidden(Coor2,AN,nHidden)
*
*-----Generate bond list
*
      mTtAtm = mTtAtm+nHidden
      Call Box(Coor2,mTtAtm,AN,TabB,TabA,nBonds,nMax)
      mTtAtm = mTtAtm-nHidden
*                                                                      *
************************************************************************
*                                                                      *
*---- First compute the approximate Hessian in cartesians
*
*     OBSERVE if the analytic Hessian is available it will be used
*     rather than the model Hessian.
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the raw Cartesian Hessian
*
      Call mma_allocate(EVal,(3*mTtAtm)*(3*mTtAtm+1)/2,Label='EVal')
      Call mma_Allocate(Hss_X,(3*mTtAtm)**2,Label='Hss_X')
      Call mma_allocate(Scr2,(3*mTtAtm)**2,Label='Scr2')
*
      If (HSet.or..Not.(Curvilinear.or.User_Def))
     &   Call LNM(Coor2,mTtAtm,EVal,Hss_X,Scr2,Vec,nsAtom,nDimBC,AN,
     &            nIter,TabB,TabA,nBonds,nMax,nHidden)
*
      Call mma_deallocate(Scr2)
      Call mma_deallocate(Coor2)
*                                                                      *
************************************************************************
*                                                                      *
*     The internal coordinates are of either two sets.
*
*              i)  user supplied internal coordinates
*
*             or
*
*             ii)  automatic internal coordinates
*                    a) cartesian coordinates (lnm)
*                    b) non-redundant internal coordinates (nrc)
*                       1) Conventional
*                       2) Curvature weighted   (HWRS)
*
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      If (User_Def) Then
*                                                                      *
************************************************************************
*                                                                      *
         Call BMtrx_User_Defined(nsAtom,Coor,nDimBC,nIter,mTR,nQQ)
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Curvilinear) Then
*                                                                      *
************************************************************************
*                                                                      *
         If (Redundant) Then
            Call WarningMessage(2,
     &           ' Bmtrx: Redundant option not implemented yet.')
            Call Abend()
         End If
*
*------- Re-generate the bonds if there were hidden atoms
*
         If (nHidden.ne.0) Then
            Call Box(Coor2,mTtAtm,AN,TabB,TabA,
     &               nBonds,nMax)
         End If
         Call BMtrx_Internal(
     &                 nsAtom,nDimBC,
     &                 nIter,
     &                 mTtAtm,
     &                 iRef,mTR,TR,TabAI,
     &                 TabA,TabB,nBonds,nMax,
     &                 iRef,nQQ,nWndw)
*
*------- Set the Labels for internal coordinates.
*
         Do i = 1, nQQ
            Write (Lbl(i),'(A,I3.3,A)') 'nrc',i,'  '
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      Else   ! Cartesian coordinates
*                                                                      *
************************************************************************
*                                                                      *
         Call BMtrx_Cartesian(nsAtom,nDimBC,nIter,mTtAtm,mTR,TR,EVal,
     &                        Hss_X,nQQ,nWndw)
*
*------- Set the Labels for cartesian normal modes.
*
         Do i = 1, nQQ
            Write (Lbl(i),'(A,I3.3,A)') 'lnm',i,'  '
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      If ((BSet.and.HSet.and..NOT.lOld)) Then
         Call Put_dArray('Hss_X',Hss_X,nDimBC**2)
         Call Put_dArray('KtB',KtB,nDimBC*nQQ)
         Call mma_deallocate(KtB)
      End If
      Call mma_deallocate(Hss_X)
      Call mma_deallocate(EVal)
      Call mma_deallocate(TabA)
      Call mma_deallocate(TabB)
      Call mma_deallocate(AN)
      Call mma_deallocate(Vec)
      Call mma_deallocate(TabAI)
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the shift vector in the basis.
*
      If (Bset) Then
         Call mma_allocate(Shift,nQQ,MaxItr,Label='Shift')
         Shift(:,:)=Zero
         Call ShfANM(nQQ,nIter,qInt,Shift)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Store B matrices to be used to transform the numerical
*     Hessian to the new basis as the optimization proceeds.
*
      If ((nIter.eq.1.and.BSet).and.
     &    (Get_SuperName().ne.'numerical_gradient')) Then

         Call Put_dArray('BMxOld',BMx,3*nsAtom*nQQ)

         If (mTR.ne.0) Then
            Call mma_allocate(TROld,3*nsAtom*mTR,Label='TROld')
            TROld(:)=Zero
#ifdef _DEBUGPRINT_
            Call RecPrt('TRVec',' ',TR,3*nsAtom,mTR)
#endif
            i = 0
            Do ix = 1, 3*nsAtom
               iAtom = (ix+2)/3
               ixyz = ix - (iAtom-1)*3
               If (Smmtrc(ixyz,iAtom)) Then
                  i = i + 1
                  call dcopy_(mTR,TR(i),-nDimBC,TROld(ix),3*nsAtom)
               End If
            End Do
            Call Put_dArray('TROld',TROld,3*nsAtom*mTR)
            Call mma_deallocate(TROld)
         End If
      End IF
*
*---- Print the B-matrix
*
#ifdef _DEBUGPRINT_
      Call RecPrt(' The BMtrx',' ',BMx,3*nsAtonsAtom,nQQ)
#endif
      Call mma_deallocate(TR)
*                                                                      *
************************************************************************
*                                                                      *
*.... Print out the values of the internal coordinates
*
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) ' Internal coordinates'
      Write (6,*)
      Write (6,'(1X,A,2X,F10.4)')
     &         (Lbl(iInter),qInt(iInter,nIter),iInter=1,nQQ)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Too many constraints?
*
      If (nLambda.gt.nQQ) Then
         Call WarningMessage(2,'Error in RlxCtl')
         Write (Lu,*)
         Write (Lu,*) '********************************************'
         Write (Lu,*) ' ERROR: nLambda.gt.nQQ'
         Write (Lu,*) ' nLambda=',nLambda
         Write (Lu,*) ' nQQ=',nQQ
         Write (Lu,*) ' There are more constraints than coordinates'
         Write (Lu,*) '********************************************'
         Call Quit_OnUserError()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Roland Lindh                                     *
!***********************************************************************

subroutine free_UpdMask()

use NewH_mod, only: UpdMask
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(UpdMask,safe='*')

return

end subroutine free_UpdMask

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OpenGrid(INPORB)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use grid_it_globals, only: iBinary, isDebug, isLine, isLuscus, isTheOne, isUHF, LID, LID_ab, LuVal, LuVal_ab, TheName, Title1
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: INPORB
integer(kind=iwp) :: i, iiUHF, istatus, iPRGM, irecl, l, LuExtra, LuOrb, mm, RC
real(kind=wp) :: g
logical(kind=iwp) :: is_error
character(len=512) :: TMPLUS
character(len=256) :: FullName
character(len=306) :: RealName
character(len=64) :: Project
character(len=40) :: Env
character(len=12) :: Alpha
character(len=2) :: ss
character, parameter :: Slash = '/'
integer(kind=iwp), external :: isFreeUnit
interface
  function lusopen(lid,fname,fname_len) bind(C,name='lusopen_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: lusopen
    integer(kind=MOLCAS_C_INT) :: lid, fname_len
    character(kind=c_char) :: fname(*)
  end function lusopen
end interface

LuOrb = isFreeUnit(46)
iPRGM = 0
call Chk_Vec_UHF(INPORB,LuOrb,iiUHF)
isUHF = (iiUHF == 1)
close(LuOrb)
LuVal_ab = -99999
if (isLuscus) then
  Alpha = '.lus'
else
  Alpha = '.grid'
end if
if (isUHF) then
  if (isLuscus) then
    Alpha = '_a.lus'
  else
    Alpha = '_a.grid'
  end if
end if
do iiUHF=0,merge(1,0,isUHF)
  if (iiUHF == 1) then
    if (isLuscus) then
      Alpha = '_b.lus'
    else
      Alpha = '_b.grid'
    end if
  end if
  Env = 'WorkDir '
  call getenvf(Env,FullName)
  iPRGM = 0
  if (TheName /= ' ') then
    LuExtra = isFreeUnit(88)
    call molcas_open(LuExtra,'extra.prgm')
    iPRGM = 1
  end if
  if ((FullName == ' ') .or. (TheName(1:1) == ' ')) then
    RealName = 'M2MSI'
    if (isUHF) then
      if (isLuscus) then
        if (iiUHF == 0) RealName = 'AM2L'
        if (iiUHF == 1) RealName = 'BM2L'
      else
        if (iiUHF == 0) RealName = 'AM2MSI'
        if (iiUHF == 1) RealName = 'BM2MSI'
      end if
    end if

  else
    l = 1
    !ii = 1
    !fullname = outf
    do
      i = index(FullName(l:),Slash)
      if (i == 0) exit
      !ii = i+l
      l = l+i+1
    end do
    call getenvf('Project',Project)
    !Project = FullName(ii:)
    if ((TheName == 'NEW') .or. (TheName == 'new') .or. (TheName == 'New')) then
      do i=1,99
        write(ss,'(i2)') i
        if (i < 10) ss(1:1) = '0'
        RealName = FullName(1:index(FullName,' ')-1)//Slash//Project(1:index(Project,' ')-1)//'.'//ss//Alpha
      end do

    else

      RealName = FullName(1:index(FullName,' ')-1)//Slash//Project(1:index(Project,' ')-1)//'.'//TheName(1:index(TheName,' ')-1)// &
                 Alpha
    end if
    write(u6,*) 'Grid file: ',trim(RealName)
  end if

  if (TheName /= ' ') then
    !LuExtra = isFreeUnit(88)
    !open(LuExtra,file='extra.prgm')
    write(LuExtra,'(a,a,a)') ' (file) M2MSI ',RealName(1:index(RealName,' ')),'  rwsg'
    !close(LuExtra)
  end if
  if (iiUHF == 0) then
    LuVal = isFreeUnit(49)
    if (isLuscus) then
      ! FIXME: User can't define luscus input file name
      RC = -1
      if (Thename == ' ') then
        if (.not. isUHF) TMPLUS(1:) = 'LUSCUS'
        if (isUHF .and. (iiUHF == 0)) TMPLUS(1:8) = 'alph.lus'
        if (isUHF .and. (iiUHF == 1)) TMPLUS(1:8) = 'beta.lus'
        mm = len_trim(TMPLUS)
        !write(u6,*) ' before 2 lusop', mm
        RC = lusopen(LID,TMPLUS,mm)
      else
        mm = len_trim(RealName)
        !write(u6,*) ' before 2 lusop', mm
        RC = lusopen(LID,RealName,mm)
      end if
      !rc = AixOpn(LID,'LUSCUS',.TRUE.)
      if (RC /= 0) then
        write(u6,*) 'ERROR: Can''t open luscus file!'
        call Abend()
      end if
    else ! not luscus
      if (iBinary == 1) then
        call molcas_open_ext2(LuVal,RealName,'sequential','unformatted',istatus,.false.,irecl,'unknown',is_error)
        !open(unit=LuVal,access='sequential',form='unformatted',file=RealName)
        !write(u6,*) '** Create Grid file:',RealName(1:index(RealName,' '))
        write(LuVal) 'a'
        !if (isMOPack) then
        !  g = 2003.9_wp
        !  i = 0
        !  write(LuVal) g,nMOs,nShowMOs_,nCoor,nInc,nBlocks,merge(1,0,isCutOff),Cutoff,iiCoord
        !  write(LuVal) i
        !else
        g = 1999.0_wp
        write(LuVal) g
        !end if
        write(LuVal) Title1
      end if

      if (iBinary == 0) then
        call molcas_open(LuVal,RealName)
        !open(unit=LuVal,file=RealName,Form='FORMATTED')
        if (isLine) then
          write(LuVal,'(a)') '# data in GNUplot format'
          exit
        end if
        !write(u6,*) '** Create Grid file (in ASCII format):',RealName(1:index(RealName,' '))
        if (isTheOne) then
          write(LuVal,'(a1)') '9'
        else
          write(LuVal,'(a1)') '0'
        end if
        if (isDebug) then
          write(Luval,'(a,a)') Title1,' DEBUG'
        else
          write(Luval,'(a)') Title1
        end if
      end if
    end if
  else ! iiUHF
    if (isLuscus) then
      ! FIXME: User can't define luscus input file name
      if (Thename == ' ') then
        if (isUHF .and. (iiUHF == 0)) TMPLUS = 'AM2L'
        if (isUHF .and. (iiUHF == 1)) TMPLUS = 'BM2L'
        mm = 6
        write(u6,*) ' before 1 lusop',mm
        RC = lusopen(LID_ab,TMPLUS,mm)
      else
        mm = len_trim(RealName)
        write(u6,*) ' before lusop',mm
        RC = lusopen(LID_ab,RealName,mm)
      end if
      !rc = AixOpn(LID,'LUSCUS',.TRUE.)
      if (RC /= 0) then
        write(u6,*) 'ERROR: Can''t open luscus file!'
        call Abend()
      end if
    end if
    LuVal_ab = isFreeUnit(51)

    if (iBinary == 1) then
      call molcas_open_ext2(LuVal_ab,RealName,'sequential','unformatted',istatus,.false.,irecl,'unknown',is_error)
      !open(unit=LuVal_ab,access='sequential',form='unformatted',file=RealName)
      !write(u6,*) '** Create Grid file',RealName(1:index(RealName,' '))
      write(LuVal_ab) 'a'
      !if (isMOPack) then
      !  g = 2003.9_wp
      !  i = 0
      !  write(LuVal_ab) g
      !  write(LuVal_ab) i
      !else
      g = 1999.0_wp
      write(LuVal_ab) g
      !end if
      write(LuVal_ab) Title1
    end if

    if (iBinary == 0) then
      call molcas_open(LuVal_ab,RealName)
      !open(unit=LuVal_ab,file=RealName,Form='FORMATTED')
      !write(u6,*) '** Create Grid file (in ASCII format):',RealName(1:index(RealName,' '))
      if (isTheOne) then
        write(LuVal_ab,'(a1)') '9'
      else
        !if (isMOPack) then
        !  write(LuVal_ab,'(a1)') '1'
        !  write(LuVal_ab,'(i5)') 0
        !else
        write(LuVal_ab,'(a1)') '0'
        !end if
      end if
      if (isDebug) then
        write(Luval_ab,'(a,a)') Title1,' DEBUG'
      else
        write(Luval_ab,'(a)') Title1
      end if
    end if
  end if
end do
if (iPRGM == 1) close(LuExtra)

return

end subroutine OpenGrid

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine G_HIGH_1(iMLTPL,d,ESOM,GRAD,S_SOM,dipsom,Do_structure_abc,cryst,coord,gtens,maxes,iprint)
! This routine calculates the g-tensor and D-tensor in the basis of the any effective spin,
! (COMING FROM 1 MOLECULAR TERM)
!
! d ---  the multiplicity of the effective spin

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, cZero, cOne, Onei
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iMLTPL, d, iprint
real(kind=wp), intent(in) :: ESOM(d), cryst(6), coord(3)
logical(kind=iwp), intent(in) :: GRAD, Do_structure_abc
complex(kind=wp), intent(in) :: s_som(3,d,d), dipsom(3,d,d)
real(kind=wp), intent(out) :: gtens(3), maxes(3,3)
integer(kind=iwp) :: I, I1, I2, J, L, LuDgrad, M, N, nmax, rc
real(kind=wp) :: axes_in_abc(3,3), CHECK_SGN2, E0, ESUM, knm(12,0:12), m_fact
complex(kind=wp) :: CHECK_SGN, ES(0:2), FS(0:2), SP_HZFSO, SP_HZFSW, SP_MOW
real(kind=wp), allocatable :: ELOC(:)
complex(kind=wp), allocatable :: AMS(:,:,:), AMS_TMP(:,:), AMSSPIN(:,:,:), B(:,:,:), BNMC(:,:,:), BNMS(:,:,:), C(:,:), CNMC(:,:), &
                                 CNMS(:,:), DIP_MOW(:,:), DIP_O(:,:), DIP_W(:,:), DIPSO2(:,:,:), HCF2(:,:,:,:), HZFS(:,:), &
                                 HZFS_MONM(:,:), HZFS_MWNM(:,:), MUX(:,:), MUXZ(:,:), MUY(:,:), MUZ(:,:), MUZX(:,:), S_SO2(:,:,:), &
                                 SP_DIPO(:), SP_DIPW(:), ZOUT(:,:)
integer(kind=iwp), external :: IsFreeUnit
complex(kind=wp), external :: trace
!-----------------------------------------------------------------------

call mma_allocate(ELOC,d,'ELOC')

call mma_allocate(DIP_O,d,d,'DIP_O')
call mma_allocate(DIP_W,d,d,'DIP_W')
call mma_allocate(MUX,d,d,'MUX')
call mma_allocate(MUY,d,d,'MUY')
call mma_allocate(MUZ,d,d,'MUZ')
call mma_allocate(MUXZ,d,d,'MUXZ')
call mma_allocate(MUZX,d,d,'MUZX')
call mma_allocate(HZFS,d,d,'HZFS')
call mma_allocate(DIP_MOW,d,d,'DIP_MOW')
call mma_allocate(HZFS_MONM,d,d,'HZFS_MONM')
call mma_allocate(HZFS_MWNM,d,d,'HZFS_MWNM')
call mma_allocate(ZOUT,d,d,'ZOUT')
call mma_allocate(AMS,3,d,d,'AMS')
call mma_allocate(AMS_TMP,d,d,'AMS_TMP')
call mma_allocate(AMSSPIN,3,d,d,'AMSSPIN')
call mma_allocate(DIPSO2,3,d,d,'DIPSO2')
call mma_allocate(S_SO2,3,d,d,'S_SO2')
call mma_allocate(HCF2,d,3,d,d,'HCF2')
call mma_allocate(SP_DIPO,3,'SP_DIPO')
call mma_allocate(SP_DIPW,3,'SP_DIPW')

!-----------------------------------------------------------------------
call atens(dipsom,d,gtens,maxes,2)
! save data for construction of the blocking barriers
!axes(iMLTPL,:,:) = maxes(:,:)
! compute the magnetic axes in the crystalographic coordinate system, If requested:
if (do_structure_abc) then
  axes_in_abc(:,:) = Zero
  if (iprint > 4) then
    write(u6,'(A, 6F12.6)') 'cryst = ',(cryst(i),i=1,6)
    write(u6,'(A, 3F12.6)') 'coord = ',(coord(i),i=1,3)
  end if

  rc = 0
  call abc_axes(cryst,coord,maxes,axes_in_abc,1,rc)

  write(u6,'(19x,11a,3x,a)') '|',repeat('-',4),'|',repeat('-',5),' a ',repeat('-',7),' b ',repeat('-',7),' c ',repeat('-',3),'|', &
                             'a , b , c  -- crystallographic axes'
  write(u6,'(A,F12.9,A,3F10.6,1x,A,16x,a)') ' gX = ',gtens(1),' | Xm |',(axes_in_abc(j,1),j=1,3),'|','(defined in the input)'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gY = ',gtens(2),' | Ym |',(axes_in_abc(j,2),j=1,3),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gZ = ',gtens(3),' | Zm |',(axes_in_abc(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',56),'|'
end if ! do_structure_abc
! Compute the matrix elements of the magnetic moment in the coordinate system
! of magnetic axes.  ==> I.e. ROTATE the matrix DipSO to the coordinate system of magnetic axes
!call unitmat(maxes,3)
call rotmom2(dipsom,d,maxes,dipso2)
call rotmom2(s_som,d,maxes,s_so2)

if (iprint > 2) then
  call prMom('G_HIGH_1:  DIPSO2(l,i,j):',dipso2,d)
  call prMom('G_HIGH_1:   S_SO2(l,i,j):',s_so2,d)
end if

ZOUT(:,:) = cZero
AMS(:,:,:) = cZero
AMSSPIN(:,:,:) = cZero
HCF2(:,:,:,:) = cZero

call mu_order(d,s_so2,dipso2,gtens,1,HCF2,AMS,AMSSPIN,ZOUT,iprint)

check_sgn = cZero
check_sgn2 = Zero
mux(:,:) = HCF2(1,1,:,:)
muy(:,:) = HCF2(1,2,:,:)
muz(:,:) = HCF2(1,3,:,:)
call ZGEMM_('N','N',d,d,d,cOne,mux,d,muz,d,cZero,muxz,d)
call ZGEMM_('N','N',d,d,d,cOne,muz,d,mux,d,cZero,muzx,d)

if (abs(muy(1,2)) > 1.0e-25_wp) then
  check_sgn = -Onei*(muxz(1,2)-muzx(1,2))/muy(1,2)
  check_sgn2 = real(check_sgn)
else
  write(u6,'(A)') 'Is it an Ising doublet?'
  write(u6,'(A)') 'For an Ising doublet gX=gY=0, therefore, the product gX * gY * gZ is also zero'
end if

if (iprint > 2) then
  write(u6,'(5x,A,2F20.14)') 'check_sgn  = ',check_sgn
  write(u6,'(5x,A,F20.14)') 'check_sgn2 = ',check_sgn2
end if

write(u6,'(A,F11.6)') 'CHECK-SIGN parameter = ',check_sgn2
if (check_sgn2 < Zero) then
  write(u6,'(A,i2,a)') 'The sign of the product gX * gY * gZ for multiplet',iMLTPL,': < 0.'
else if (check_sgn2 > Zero) then
  write(u6,'(A,i2,a,F9.6)') 'The sign of the product gX * gY * gZ for multiplet',iMLTPL,': > 0.'
end if
! Obtain the b3m and c3m coefficients:
call mma_allocate(B,[1,3],[1,d],[-d,d],label='B')
call mma_allocate(BNMC,[1,3],[1,d],[0,d],label='BNMC')
call mma_allocate(BNMS,[1,3],[1,d],[0,d],label='BNMS')
B(:,:,:) = cZero
do N=1,d-1,2
  do M=0,N
    DIP_O(:,:) = cZero
    DIP_W(:,:) = cZero

    call Stewens_matrixel(N,M,d,DIP_O,DIP_W,IPRINT)

    if (iprint > 3) then
      write(u6,*)
      write(u6,'( 5x,a,i2,a,i3)') 'DIP_O, N = ',N,', M =',m
      write(u6,*)
      do i=1,d
        write(u6,'(20(2F10.6,2x))') (DIP_O(i,j),j=1,d)
      end do

      write(u6,*)
      write(u6,'( 5x,a,i2,a,i3)') 'DIP_W, N = ',N,', M =',m
      write(u6,*)
      do i=1,d
        write(u6,'(20(2F10.6,2x))') (DIP_W(i,j),j=1,d)
      end do
    end if

    SP_DIPO(:) = cZero
    SP_DIPW(:) = cZero
    SP_MOW = cZero
    SP_MOW = trace(d,DIP_O,DIP_W)
    do l=1,3
      AMS_TMP(:,:) = AMS(l,:,:)
      SP_DIPO(l) = trace(d,AMS_TMP,DIP_O)
      SP_DIPW(l) = trace(d,AMS_TMP,DIP_W)

      B(l,n,-m) = SP_DIPO(l)/SP_MOW
      B(l,n,m) = SP_DIPW(l)/SP_MOW
    end do ! l
  end do !m
end do !n

BNMC(:,:,:) = cZero
BNMS(:,:,:) = cZero
do n=1,d-1,2
  BNMC(:,n,0) = B(:,n,0)
  do m=1,N
    m_fact = (-One)**M
    BNMC(:,n,m) = B(:,n,m)+m_fact*B(:,n,-m)
    BNMS(:,n,m) = -Onei*(B(:,n,m)-m_fact*B(:,n,-m))
  end do
end do !n

write(u6,*)
write(u6,'(A)') repeat('-',80)
write(u6,'(A)') 'DECOMPOSITION OF THE MAGNETIC MOMENT Mu_i IN IRREDUCIBLE TENSOR OPERATORS (ITO):'
write(u6,'(A)') repeat('-',80)
write(u6,*)
write(u6,'(A)') 'The quantization axis is the main magnetic axis of this multiplet (Zm).'
write(u6,'(A)') repeat('*',80)
write(u6,'(A)') '   Mu_i = SUM_{n,m}: [ B(i,n,m) * O(n,m) +  C(i,n,m) * W(n,m) ]'
write(u6,'(A)') 'where:'
write(u6,'(A)') '   O(n,m) =  0.5 * ( (-1)**m * Y(n,+m) + Y(n,-m) );'
write(u6,'(A)') '   W(n,m) = -0.5 * ( (-1)**m * Y(n,+m) - Y(n,-m) ) * I;   (I = imaginary unit)'
write(u6,'(A)') '   n - the rank of the ITO, = 1, 3, 5, ... 2*spin;'
write(u6,'(A)') '   m - the component of the ITO, = 0, 1, ... n;'
write(u6,'(A)') '   i - the Cartesian projection of the magnetic moment, i = x,y,z;'
write(u6,'(A)') 'These operators have been defined in: '
write(u6,'(A)') '  L. F. Chibotaru, L.Ungur, J. Chem. Phys., 137, 064112 (2012).'
write(u6,'(2A)') repeat('-',63),'|'
write(u6,'(A)') '  n  |  m  | i |        B(i,n,m)       |        C(i,n,m)       |'
do N=1,d-1,2
  write(u6,'(A)') '-----|-----|---|-----------------------|-----------------------|'
  do M=0,N
    if (M /= 0) write(u6,'(A)') '     |-----|---|-----------------------|-----------------------|'
    write(u6,'(2(1x,I2,2x,A),1x,A,1x,A,2(ES22.14,1x,A))') N,'|',M,'|','X','|',real(BNMC(1,N,M)),'|',real(BNMS(1,N,M)),'|'
    write(u6,'(2(1x,I2,2x,A),1x,A,1x,A,2(ES22.14,1x,A))') N,'|',M,'|','Y','|',real(BNMC(2,N,M)),'|',real(BNMS(2,N,M)),'|'
    write(u6,'(2(1x,I2,2x,A),1x,A,1x,A,2(ES22.14,1x,A))') N,'|',M,'|','Z','|',real(BNMC(3,N,M)),'|',real(BNMS(3,N,M)),'|'
  end do
end do
write(u6,'(2A)') repeat('-',63),'|'
! decomposition of the magnetic moment in Extended Stevens Operators

call Set_knm(knm)

write(u6,'(/)')
write(u6,'(A)') repeat('*',80)
write(u6,'(A)') '   Mu_i = SUM_{k,q} * [ B(i,k,q) * O(k,q) ];'
write(u6,'(A)') 'where:'
write(u6,'(A)') '   O(k,q) =  Extended Stevens Operators (ESO) as defined in:'
write(u6,'(10x,A)') '1. Rudowicz, C.; J.Phys.C: Solid State Phys.,18(1985) 1415-1430.'
write(u6,'(10x,A)') '2. Implemented in the "EasySpin" function in MATLAB, www.easyspin.org.'
write(u6,'(A    )') '   k - the rank of the ITO, = 1, 3, 5, 7, 9, 11;'
write(u6,'(A    )') '   q - the component of the ITO, = -k, -k+1, ... 0, 1, ... k;'
if (d-1 > 11) then
  write(u6,'(A)') 'k = 11 may not be the highest rank of the ITO for this case, but it '
  write(u6,'(A)') 'is the maximal k implemented in the "EasySpin" function in MATLAB.'
end if
write(u6,'(A)') 'Knm are proportionality coefficients between the ESO and operators defined in '
write(u6,'(A)') 'J. Chem. Phys., 137, 064112 (2012).'
write(u6,'(2A)') repeat('-',51),'|'
write(u6,'(A)') '  k |  q  | i |   (Knm)^2  |         B(k,q)        |'

if (d-1 > 11) then
  Nmax = 11
else
  nmax = d-1
end if

do N=1,nmax,2
  write(u6,'(A)') '----|-----|---|------------|-----------------------|'
  do M=-N,N
    if (M < 0) then
      write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),1x,A,1x,A,12x,A,2(ES22.14,1x,A))') N,'|',M,'|','X','|','|', &
                                                                              real(BNMS(1,N,abs(M)))*knm(n,abs(m)),'|'
      write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),1x,A,1x,A,1x,F10.3,1x,A,2(ES22.14,1x,A))') N,'|',M,'|','Y','|', &
                                                                                      knm(n,abs(m))*knm(n,abs(m)),'|', &
                                                                                      real(BNMS(2,N,abs(M)))*knm(n,abs(m)),'|'
      write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),1x,A,1x,A,12x,A,2(ES22.14,1x,A))') N,'|',M,'|','Z','|','|', &
                                                                              real(BNMS(3,N,abs(M)))*knm(n,abs(m)),'|'
      write(u6,'(A)') '    |-----|---|------------|-----------------------|'
    else
      write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),1x,A,1x,A,12x,A,2(ES22.14,1x,A))') N,'|',M,'|','X','|','|', &
                                                                              real(BNMC(1,N,abs(M)))*knm(n,abs(m)),'|'
      write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),1x,A,1x,A,1x,F10.3,1x,A,2(ES22.14,1x,A))') N,'|',M,'|','Y','|', &
                                                                                      knm(n,abs(m))*knm(n,abs(m)),'|', &
                                                                                      real(BNMC(2,N,abs(M)))*knm(n,abs(m)),'|'
      write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),1x,A,1x,A,12x,A,2(ES22.14,1x,A))') N,'|',M,'|','Z','|','|', &
                                                                              real(BNMC(3,N,abs(M)))*knm(n,abs(m)),'|'
      if (M /= N) write(u6,'(A)') '    |-----|---|------------|-----------------------|'
    end if !M<0
  end do !M
end do !N
write(u6,'(2A)') repeat('-',51),'|'

call mma_deallocate(B)
call mma_deallocate(BNMC)
call mma_deallocate(BNMS)

! Calculation of the ZFS tensors and the coefficients of the higher order spin-operators Enm and Fnm
if (d > 2) then
  ESUM = sum(ESOM(:))
  E0 = ESUM/real(d,kind=wp)
  ELOC(:) = ESOM(:)-E0

  HZFS(:,:) = cZero
  do i1=1,d
    do i2=1,d
      do i=1,d
        HZFS(i1,i2) = HZFS(i1,i2)+ELOC(i)*conjg(ZOUT(i,I1))*ZOUT(i,I2)
      end do
    end do
  end do

  if (iprint > 2) then
    write(u6,*)
    write(u6,'(5X,A)') 'SPIN-ORBIT ENERGIES OF THE FIRST MOLECULAR TERM SHIfTED TO THE MASS CENTER'
    write(u6,*)
    write(u6,'(5X,A,F10.4)') 'E0 = ',E0
    write(u6,'(15X,A,11X,A)') 'ESOM','ESO_LOC'

    do I=1,d
      write(u6,'(5X,F15.6,2X,F15.6)') ESOM(I),ELOC(I)
    end do
  end if

  write(u6,*)
  write(u6,'(A)') repeat('-',87)
  write(u6,'(A)') 'DECOMPOSITION OF THE ZERO-FIELD SPLITTING (ZFS) IN IRREDUCIBLE TENSOR OPERATORS (ITO):'
  write(u6,'(A)') repeat('-',87)
  write(u6,*)
  write(u6,'(A)') 'Ab Initio Calculated Zero-Field Splitting Matrix written in the basis of Pseudospin Eigenfunctions'
  if (mod(d,2) == 0) then
    write(u6,'(52A)') repeat('-',10),(repeat('-',24),j=1,d),'|'
    write(u6,'(10x,A,50(8x,A,I3,A,7x,A))') '|',('|',2*i-d-1,'/2 >','|',i=1,d)
    write(u6,'(102A)') repeat('-',10),'|',(repeat('-',23),'|',j=1,d)
    do i=1,d
      write(u6,'(1x,A,I3,A,1x,A,50(2F11.5,1x,A))') '<',2*i-d-1,'/2','| |',(HZFS(j,i),'|',j=1,d)
    end do
    write(u6,'(52A)') repeat('-',10),(repeat('-',24),j=1,d),'|'
  else
    write(u6,'(52A)') repeat('-',8),(repeat('-',24),j=1,d),'|'
    write(u6,'(8x,A,50(8x,A,I3,A,9x,A))') '|',('|',-(d-1)/2-1+i,' >','|',i=1,d)
    write(u6,'(102A)') repeat('-',8),'|',(repeat('-',23),'|',j=1,d)
    do I=1,d
      write(u6,'(1x,A,I3,1x,A,50(2F11.5,1x,A))') '<',-(d-1)/2-1+i,'| |',(HZFS(j,i),'|',j=1,d)
    end do
    write(u6,'(52A)') repeat('-',8),(repeat('-',24),j=1,d),'|'
  end if

  call mma_allocate(C,[1,d],[-d,d],label='C')
  call mma_allocate(CNMC,[1,d],[0,d],label='CNMC')
  call mma_allocate(CNMS,[1,d],[0,d],label='CNMS')
  C(:,:) = cZero
  do N=2,d-1,2
    do M=0,N
      DIP_O(:,:) = cZero
      DIP_W(:,:) = cZero
      HZFS_MONM(:,:) = cZero
      HZFS_MWNM(:,:) = cZero
      DIP_MOW(:,:) = cZero

      call Stewens_matrixel(N,M,d,DIP_O,DIP_W,IPRINT)

      if (IPRINT > 5) then
        write(u6,'(/)')
        write(u6,'(5x,a,i3,3x,A,I3)') 'DIP_STEWENS_O  N = ',N,'M =',M
        write(u6,*)
        do i=1,d
          write(u6,'(20(2X,2ES20.10))') (DIP_O(i,j),j=1,d)
        end do
        write(u6,'(/)')
        write(u6,'(5x,a,i3,3x,A,I3)') 'DIP_STEWENS_W  N = ',N,'M =',M
        write(u6,*)
        do i=1,d
          write(u6,'(20(2X,2ES20.10))') (DIP_W(i,j),j=1,d)
        end do
      end if

      SP_HZFSO = cZero
      SP_HZFSW = cZero
      SP_MOW = cZero
      SP_MOW = trace(d,DIP_O,DIP_W)
      SP_HZFSO = trace(d,HZFS,DIP_O)
      SP_HZFSW = trace(d,HZFS,DIP_W)

      C(N,-M) = SP_HZFSO/SP_MOW
      C(N,M) = SP_HZFSW/SP_MOW

      if (IPRINT > 5) then
        write(u6,'(/)')
        write(u6,'( 5x,a)') 'HZFS_MONM(i,j)'
        write(u6,*)
        do i=1,d
          write(u6,'(20(2F18.10,2x))') (HZFS_MONM(i,j),j=1,d)
        end do
        write(u6,*)
        write(u6,'(5X,a,2F18.10)') 'SP_HZFSO = ',SP_HZFSO
        write(u6,'(/)')
        write(u6,'( 5x,a)') 'HZFS_MWNM(i,j)'
        write(u6,*)
        do i=1,d
          write(u6,'(20(2F18.10,2x))') (HZFS_MWNM(i,j),j=1,d)
        end do
        write(u6,*)
        write(u6,'(5X,a,2F18.10)') 'SP_HZFSW = ',SP_HZFSW
        write(u6,'(/)')
        write(u6,'( 5x,a)') 'HZFS_MOW(i,j) (i,j)'
        write(u6,*)
        do i=1,d
          write(u6,'(20(2F18.10,2x))') (DIP_MOW(i,j),j=1,d)
        end do
        write(u6,*)
        write(u6,'(5X,a,2F18.10)') 'SP_MOW = ',SP_MOW
      end if
    end do !M
  end do !N

  CNMC(:,:) = cZero
  CNMS(:,:) = cZero
  do N=2,d-1,2
    do M=0,N
      if (M == 0) then
        CNMC(N,M) = Half*(C(N,M)+C(N,-M))
      else
        m_fact = (-One)**M
        CNMC(N,M) = C(N,M)+m_fact*C(N,-M)
        CNMS(N,M) = -Onei*(C(N,M)-m_fact*C(N,-M))
      end if
    end do
  end do

  write(u6,'(A)') 'The ZFS Hamiltonian:'
  write(u6,'(A)') '   ZFS = SUM_{n,m}: [ E(n,m) * O(n,m) +  F(n,m) * W(n,m) ]'
  write(u6,'(A)') 'where:'
  write(u6,'(A)') '   O(n,m) =  0.5 * ( (-1)**m * Y(n,+m) + Y(n,-m) );'
  write(u6,'(A)') '   W(n,m) = -0.5 * ( (-1)**m * Y(n,+m) - Y(n,-m) ) * I;    (I = imaginary unit)'
  write(u6,'(A)') '   n - the rank of the ITO, = 2, 4, 6, ... 2*spin;'
  write(u6,'(A)') '   m - the component of the ITO, = 0, 1, ... n;'
  write(u6,'(A)') 'The quantization axis is the main magnetic axis of this multiplet (Zm).'
  write(u6,'(2A)') repeat('-',59),'|'
  write(u6,'(A)') '  n  |  m  |         E(n,m)        |         F(n,m)        |'
  do N=2,d-1,2
    write(u6,'(A)') '-----|-----|-----------------------|-----------------------|'
    do M=0,N
      write(u6,'(2(1x,I2,2x,A),2(ES22.14,1x,A))') N,'|',M,'|',real(CNMC(N,M)),'|',real(CNMS(N,M)),'|'
    end do
  end do
  write(u6,'(2A)') repeat('-',59),'|'

  ! decomposition of the ZFS matrix in Extended Stevens Operators
  write(u6,'(A)') repeat('*',80)
  write(u6,'(A)') 'The ZFS Hamiltonian:'
  write(u6,'(A)') '   ZFS = SUM_{k,q} * [ B(k,q) * O(k,q) ];'
  write(u6,'(A)') 'where:'
  write(u6,'(A)') '   O(k,q) =  Extended Stevens Operators (ESO) as defined in:'
  write(u6,'(10x,A)') '1. Rudowicz, C.; J.Phys.C: Solid State Phys.,18(1985) 1415-1430.'
  write(u6,'(10x,A)') '2. Implemented in the "EasySpin" function in MATLAB, www.easyspin.org.'
  write(u6,'(A    )') '   k - the rank of the ITO, = 2, 4, 6, 8, 10, 12.'
  write(u6,'(A)') '   q - the component of the ITO, = -k, -k+1, ... 0, 1, ... k;'

  if ((d-1) > 12) then
    write(u6,'(A)') 'k = 12 may not be the highest rank of the ITO for this case, but it '
    write(u6,'(A)') 'is the maximal k implemented in the "EasySpin" function in MATLAB.'
  end if

  write(u6,'(A)') 'Knm are proportionality coefficients between the ESO and operators defined in '
  write(u6,'(A)') 'J. Chem. Phys., 137, 064112 (2012).'
  write(u6,'(2A)') repeat('-',48),'|'
  write(u6,'(A)') '  k |  q  |    (Knm)^2  |         B(k,q)        |'
  if (d-1 > 12) then
    Nmax = 12
  else
    Nmax = d-1
  end if
  do N=2,Nmax,2
    write(u6,'(A)') '----|-----|-------------|-----------------------|'
    do M=-N,N
      if (M < 0) then
        write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),F11.2,2x,A,2(ES22.14,1x,A))') N,'|',M,'|',knm(n,abs(m))*knm(n,abs(m)),'|', &
                                                                           real(CNMS(N,abs(M)))*knm(n,abs(m)),'|'
      else
        write(u6,'((1x,I2,1x,A),(1x,I3,1x,A),F11.2,2x,A,2(ES22.14,1x,A))') N,'|',M,'|',knm(n,abs(m))*knm(n,abs(m)),'|', &
                                                                           real(CNMC(N,abs(M)))*Knm(n,abs(m)),'|'
      end if
    end do
  end do
  write(u6,'(2A)') repeat('-',48),'|'
  !-----------------------------
  ! for the interface related to CF gradient calculation:
  if (GRAD) then
    LuDgrad = IsFreeUnit(81)
    call molcas_open(LuDgrad,'DMAT')
    do N=2,Nmax,2
      write(u6,'(A)') '----|-----|-------------|-----------------------|'
      do M=-N,N
        if (M < 0) then
          write(LuDgrad,'(I4,I4,1x,2(ES25.15))') N,M,real(CNMS(n,abs(n)))*knm(n,abs(m))
        else
          write(LuDgrad,'(I4,I4,1x,2(ES25.15))') N,M,real(CNMC(n,abs(m)))*Knm(n,abs(m))
        end if
      end do
    end do
    close(LuDgrad)
  end if
  !-----------------------------

  ES(:) = CNMC(2,0:2)
  FS(:) = CNMS(2,0:2)

  call mma_deallocate(C)
  call mma_deallocate(CNMC)
  call mma_deallocate(CNMS)

  call DMATRIX(Es,Fs,maxes,2)
end if ! decomposition of ZFS in higher-order ITO operators

write(u6,*)
write(u6,'(A,I2,A,I3,A)') 'ANGULAR MOMENTS ALONG THE MAIN MAGNETIC AXES'
call moments(d,s_so2,dipso2,iprint)

!----------------------------------------------------------------------
call mma_deallocate(ELOC)
call mma_deallocate(DIP_O)
call mma_deallocate(DIP_W)
call mma_deallocate(MUX)
call mma_deallocate(MUY)
call mma_deallocate(MUZ)
call mma_deallocate(MUXZ)
call mma_deallocate(MUZX)
call mma_deallocate(HZFS)
call mma_deallocate(DIP_MOW)
call mma_deallocate(HZFS_MONM)
call mma_deallocate(HZFS_MWNM)
call mma_deallocate(ZOUT)
call mma_deallocate(AMS)
call mma_deallocate(AMS_TMP)
call mma_deallocate(AMSSPIN)
call mma_deallocate(DIPSO2)
call mma_deallocate(S_SO2)
call mma_deallocate(HCF2)
call mma_deallocate(SP_DIPO)
call mma_deallocate(SP_DIPW)

return

end subroutine G_HIGH_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RHS_NAC(Fock)
      use ipPage, only: W
      Implicit None
#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
#include "real.fh"
#include "sa.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "cands.fh"
      Real*8 Fock(*)
      Integer ng1,ng2,i,j,k,l,ij,kl,ijkl,ij2,kl2,ijkl2
      Integer iTri
      Integer ipIn,opOut,ipnOut,nConfL,nConfR,iRC,LuDens
      Real*8 factor
      External ipIn,opOut,ipnOut
      Real*8, Allocatable:: G1q(:), G1m(:), G1r(:), G2q(:), G2r(:),
     &                      CIL(:), CIR(:), T(:), F(:)
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      ng1=ntAsh*(ntAsh+1)/2
      ng2=ng1*(ng1+1)/2
      Call mma_allocate(G1q,nG1,Label='G1q')
      Call mma_allocate(G1m,nG1,Label='G1m')
      Call mma_allocate(G2q,nG2,Label='G2q')
      Call mma_allocate(G1r,n1dens,Label='G1r')
      G1r(:)=Zero
      Call mma_allocate(G2r,n2dens,Label='G2r')
      G2r(:)=Zero
*
**    Calculate one- and two-particle transition matrices
**    from the CI vectors of the two NAC states
**    (code copied from CIdens_SA, same symmetry)
*
      nConfL=Max(nconf1,nint(xispsm(State_sym,1)))
      nConfR=Max(nconf1,nint(xispsm(State_sym,1)))
      Call mma_allocate(CIL,nConfL,Label='CIL')
      Call mma_allocate(CIR,nConfR,Label='CIR')
      irc=ipIn(ipCI)
      Call CSF2SD(W(ipCI)%Vec(1+(NSSA(2)-1)*nconf1),CIL,State_sym)
      iRC=opout(ipCI)
      Call CSF2SD(W(ipCI)%Vec(1+(NSSA(1)-1)*nconf1),CIR,State_sym)
      iRC=opout(ipCI)
      iRC=ipnout(-1)
      icsm=1
      issm=1
      Call Densi2(2,G1r,G2r,
     &              CIL,CIR,0,0,0,n1dens,n2dens)
      Call mma_deallocate(CIL)
      Call mma_deallocate(CIR)
*
**    Symmetrize densities
**    For the one-particle density, save the antisymmetric part too
*
      ij=0
      Do i=0,ntAsh-1
        Do j=0,i-1
          ij=ij+1
          G1q(ij)=(G1r(1+i*ntAsh+j)+
     &                    G1r(1+j*ntAsh+i))*Half
*         Note that the order of subtraction depends on how the matrix
*         will be used when contracting with derivative integrals
*         This is found to give the correct results:
          G1m(ij)=(G1r(1+j*ntAsh+i)-
     &                    G1r(1+i*ntAsh+j))*Half
        End Do
        ij=ij+1
        G1q(ij)=G1r(1+i*ntAsh+i)
        G1m(ij)=Zero
      End Do
*
      Do i=1,ntAsh**2
        j=itri(i,i)
        G2r(j)=Half*G2r(j)
      End Do
      Do i=0,ntAsh-1
        Do j=0,i-1
          ij=i*(i+1)/2+j
          Do k=0,ntAsh-1
            Do l=0,k
              kl=k*(k+1)/2+l
              If (ij.ge.kl) Then
                factor=Quart
                If (ij.eq.kl) factor=Half
                ijkl=ij*(ij+1)/2+kl
                ij2=i*ntAsh+j
                kl2=k*ntAsh+l
                G2q(1+ijkl)=factor*G2r(1+ij2*(ij2+1)/2+kl2)
                ij2=Max(j*ntAsh+i,l*ntAsh+k)
                kl2=Min(j*ntAsh+i,l*ntAsh+k)
                G2q(1+ijkl)=G2q(1+ijkl)+
     &                           factor*G2r(1+ij2*(ij2+1)/2+kl2)
                If (k.ne.l) Then
                  ij2=i*ntAsh+j
                  kl2=l*ntAsh+k
                  G2q(1+ijkl)=G2q(1+ijkl)+
     &                             factor*G2r(1+ij2*(ij2+1)/2+kl2)
                  If (ij.ne.kl) Then
                    ij2=Max(j*ntAsh+i,k*ntAsh+l)
                    kl2=Min(j*ntAsh+i,k*ntAsh+l)
                    G2q(1+ijkl)=G2q(1+ijkl)+
     &                              factor*G2r(1+ij2*(ij2+1)/2+kl2)
                  End If
                End If
              End If
            End Do
          End Do
        End Do
        ij=i*(i+1)/2+i
        Do k=0,ntAsh-1
          Do l=0,k
            kl=k*(k+1)/2+l
            If (ij.ge.kl) Then
              factor=Half
              If (ij.eq.kl) factor=One
              ijkl=ij*(ij+1)/2+kl
              ij2=i*ntAsh+i
              kl2=k*ntAsh+l
              G2q(1+ijkl)=factor*G2r(1+ij2*(ij2+1)/2+kl2)
              If (k.ne.l) Then
                kl2=l*ntAsh+k
                G2q(1+ijkl)=G2q(1+ijkl)+
     &                           factor*G2r(1+ij2*(ij2+1)/2+kl2)
              End If
            End If
          End Do
        End Do
      End Do
*
**    Write the symmetric densities in the runfile and
**    the antisymmetric one-particle in MCLRDENS
*
      iRC=0
      LuDens=20
      Call DaName(LuDens,'MCLRDENS')
      Call dDaFile(LuDens,1,G1m,ng1,iRC)
      Call DaClos(LuDens)
      Call Put_D1MO(G1q,ng1)
      Call Put_P2MO(G2q,ng2)
*
**    Store transition Fock matrix
*
      Do i=1,ntAsh
        Do j=1,ntAsh
          G1r(ntAsh*(j-1)+i)=G1q(iTri(i,j))
        End Do
      End Do
      Do i=1,ntAsh
        Do j=1,ntAsh
          ij=iTri(i,j)
          ij2=ntAsh*(i-1)+j
          Do k=1,ntAsh
            Do l=1,ntAsh
              kl=iTri(k,l)
              kl2=ntAsh*(k-1)+l
              factor=One
              If (ij.ge.kl .and. k.eq.l) factor=Two
              If (ij.lt.kl .and. i.eq.j) factor=Two
              ijkl=iTri(ij,kl)
              ijkl2=iTri(ij2,kl2)
              G2r(ijkl2)=factor*G2q(ijkl)
            End Do
          End Do
        End Do
      End Do

* Note: 1st arg = zero for no inactive density (TDM)
      Call mma_allocate(T,nDens2,Label='T')
      Call mma_allocate(F,nDens2,Label='F')
      Call FockGen(Zero,G1r,G2r,T,Fock,1)
      Call TCMO(T,1,-2)
      ij=0
      Do k=1,nSym
        Do i=0,nBas(k)-1
          Do j=0,i-1
            ij=ij+1
            F(ij)=T(ipMat(k,k)+nBas(k)*j+i)+
     &                   T(ipMat(k,k)+nBas(k)*i+j)
          End Do
          ij=ij+1
          F(ij)=T(ipMat(k,k)+nBas(k)*i+i)
        End Do
      End Do
      Call Put_Fock_Occ(F,nDens2)
*
      Call mma_deallocate(T)
      Call mma_deallocate(F)
      Call mma_deallocate(G1r)
      Call mma_deallocate(G2r)
      Call mma_deallocate(G2q)
      Call mma_deallocate(G1m)
      Call mma_deallocate(G1q)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2016,2017, Roland Lindh                                *
************************************************************************
      SubRoutine OptClc(Dens,TwoHam,Vxc,nDT,NumDT,CInter,nCI,nD,Ind)
************************************************************************
*                                                                      *
* purpose: calculate optimal density matrix and two-electron hamil-    *
*          tonial as well as optimal difference from interpolation     *
*          or extrapolation coefficients.                              *
*                                                                      *
* input:                                                               *
*   Dens    : density matrices (nDT,NumDT)                             *
*   TwoHam  : two-electron hamiltonian matrices (nDT,NumDT)            *
*   Vxc     : external potential       matrices (nDT,NumDT)            *
*   CInter  : interpolation coefficients (nCI)                         *
*                                                                      *
* output:                                                              *
*   Dens and TwoHam                                                    *
*                                                                      *
* called from: Wfctl_scf                                               *
*                                                                      *
* calls to: RWDTG                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* written by:                                                          *
* P.O. Widmark, M.P. Fuelscher and P. Borowski                         *
* University of Lund, Sweden, 1992                                     *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
      Real*8 Dens(nDT,nD,NumDT),TwoHam(nDT,nD,NumDT),
     &       CInter(nCI,nD), Vxc(nDT,nD,NumDT)
      Integer Ind(MxOptm)
*
      Real*8, Dimension(:,:), Allocatable:: DnsTmp, TwoTmp, VxcTmp
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*define _DEBUGPRINT_
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Allocate memory for matrices that contribute to the optimal one
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      Call mma_allocate(DnsTmp,nBT,nD,Label='DnsTmp')
      Call mma_allocate(TwoTmp,nBT,nD,Label='TwoTmp')
      Call mma_allocate(VxcTmp,nBT,nD,Label='VxcTmp')
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Accumulate liner combinations in position iPsLst
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Start with the last iteration
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      iter_d=Ind(kOptim)-iter0
*
      iMap=MapDns(iter_d)
      If (iMap.lt.0) Then
         Call RWDTG(-iMap,DnsTmp,nBT*nD,'R','DENS  ',iDisk,MxDDsk)
         Call RWDTG(-iMap,TwoTmp,nBT*nD,'R','TWOHAM',iDisk,MxDDsk)
         Call RWDTG(-iMap,VxcTmp,nBT*nD,'R','dVxcdR',iDisk,MxDDsk)
      Else
         Call DCopy_(nBT*nD,Dens  (1,1,iMap),1,DnsTmp,1)
         Call DCopy_(nBT*nD,TwoHam(1,1,iMap),1,TwoTmp,1)
         Call DCopy_(nBT*nD,Vxc   (1,1,iMap),1,VxcTmp,1)
      End If
*
      Do iD = 1, nD
*
         C = CInter(kOptim,iD)
         Call DScal_(nBT,C,DnsTmp(1,iD),1)
         Call DScal_(nBT,C,TwoTmp(1,iD),1)
         Call DScal_(nBT,C,VxcTmp(1,iD),1)
*
      End Do
*
      Call dcopy_(nBT*nD,DnsTmp,1,Dens  (1,1,nDens),1)
      Call dcopy_(nBT*nD,TwoTmp,1,TwoHam(1,1,nDens),1)
      Call dcopy_(nBT*nD,VxcTmp,1,Vxc   (1,1,nDens),1)
*
      Do i = 1, kOptim - 1
         C = CInter(i,1)
         MatNo = Ind(i)-iter0
*
         iMap=MapDns(MatNo)
         If (iMap.lt.0) Then
            Call RWDTG(-iMap,DnsTmp,nBT*nD,'R','DENS  ',iDisk,MxDDsk)
            Call RWDTG(-iMap,TwoTmp,nBT*nD,'R','TWOHAM',iDisk,MxDDsk)
            Call RWDTG(-iMap,VxcTmp,nBT*nD,'R','dVxcdR',iDisk,MxDDsk)
         Else
            Call DCopy_(nBT*nD,Dens  (1,1,iMap),1,DnsTmp,1)
            Call DCopy_(nBT*nD,TwoHam(1,1,iMap),1,TwoTmp,1)
            Call DCopy_(nBT*nD,Vxc   (1,1,iMap),1,VxcTmp,1)
         End If
*
         Do iD = 1, nD
            C = CInter(i,iD)
            call daxpy_(nBT,C,DnsTmp(1,iD),1,Dens  (1,iD,nDens),1)
            call daxpy_(nBT,C,TwoTmp(1,iD),1,TwoHam(1,iD,nDens),1)
            call daxpy_(nBT,C,VxcTmp(1,iD),1,Vxc   (1,iD,nDens),1)
         End Do
*
      End Do ! i
*
* Deallocate memory
*
      Call mma_deallocate(DnsTmp)
      Call mma_deallocate(TwoTmp)
      Call mma_deallocate(VxcTmp)
*
#ifdef _DEBUGPRINT_
      Call NrmClc(Dens  (1,1,iPsLst),nBT*nD,'OptClc','D in iPsLst. ')
      Call NrmClc(TwoHam(1,1,iPsLst),nBT*nD,'OptClc','T in iPsLst. ')
      Call NrmClc(Vxc   (1,1,iPsLst),nBT*nD,'OptClc','V in iPsLst. ')
#endif
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HMAT(C,HC,HH,HD,NDIM,NDIMH,NTRIAL)
! RASSCF program: version IBM-3090: SX section
!
! Purpose: Calculation of the Davidson Hamiltonian.
! The sigma vector HC is computed in SIGVEC
!
! ********** IBM-3090 Release 88 09 08 **********

use Index_Functions, only: nTri_Elem
use wadr, only: BM, DIA, F1, F2, NLX, SXG, SXH, SXN
use rasscf_global, only: NSXS
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDIM, NTRIAL
real(kind=wp), intent(in) :: C(*), HD(NDIM)
real(kind=wp), intent(inout) :: HC(*), HH(*)
integer(kind=iwp), intent(inout) :: NDIMH
integer(kind=iwp) :: I, IJ, IST, J, JST, L1
real(kind=wp), allocatable :: XC(:), XX(:)
real(kind=wp), external :: DDot_

! COMPUTE SIGMA VECTORS

IST = 1+NDIMH*NDIM

call mma_allocate(XX,NLX,Label='XX')
call mma_allocate(XC,NSXS,Label='XC')

call SIGVEC(C(IST),HC(IST),HD,BM,SXN,SXG,SXH,DIA,F1,F2,XX,XC,NTRIAL)

call mma_deallocate(XX)
call mma_deallocate(XC)

! Compute a new block of the HH matrix

IJ = nTri_Elem(NDIMH)
L1 = NDIMH+1
NDIMH = NDIMH+NTRIAL
do I=L1,NDIMH
  JST = 1
  do J=1,I
    IJ = IJ+1
    HH(IJ) = DDOT_(NDIM,HC(IST),1,C(JST),1)
    JST = JST+NDIM
  end do
  IST = IST+NDIM
end do

end subroutine HMAT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Stefano Battaglia                                *
!***********************************************************************

subroutine Backtransform(Heff,Ueff,U0,nState)
! Back-transform Heff and Ueff to the basis of the original CASSCF states.

use caspt2_module, only: IFRMS, IFXMS
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Nstate
real(kind=wp), intent(inout) :: Heff(Nstate,Nstate), Ueff(Nstate,Nstate)
real(kind=wp), intent(in) :: U0(Nstate,Nstate)
real(kind=wp), allocatable :: U0transpose(:,:), Utmp(:,:)

if (IFXMS .or. IFRMS) then

  ! First we need to back-transform the effective Hamiltonian in the
  ! basis of original CASSCF states by U0 * Heff * U0^T
  ! Note that in the case of a normal MS-CASPT2 this and the next step
  ! do not have any effect on Heff and Ueff
  call mma_allocate(U0transpose,Nstate,Nstate,Label='U0transpose')
  call trnsps(Nstate,Nstate,U0,U0transpose)
  call transmat(Heff,U0transpose,Nstate)
  call mma_deallocate(U0transpose)

  ! Compute transformation matrix that diagonalizes the effective
  ! Hamiltonian expressed in the basis of original CASSCF states,
  ! i.e. simply combine the two transf matrices: Ueff = U0 * Ueff
  call mma_allocate(Utmp,Nstate,Nstate,Label='Utmp')
  call dgemm_('N','N',Nstate,Nstate,Nstate,One,U0,Nstate,Ueff,Nstate,Zero,Utmp,Nstate)
  Ueff = Utmp
  call mma_deallocate(Utmp)

end if

end subroutine Backtransform

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Assemble_PPGrd(rFinal,nZeta,la,lb,iZeta,Alpha,Beta,A_laplb,A_lamlb,A_lalbp,A_lalbm,JfGrad)

use Index_Functions, only: C_Ind3
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, iZeta
real(kind=wp), intent(inout) :: rFinal(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6)
real(kind=wp), intent(in) :: Alpha, Beta, A_laplb((la+2)*(la+3)/2,(lb+1)*(lb+2)/2), A_lamlb((la+0)*(la+1)/2,(lb+1)*(lb+2)/2), &
                             A_lalbp((la+1)*(la+2)/2,(lb+2)*(lb+3)/2), A_lalbm((la+1)*(la+2)/2,(lb+0)*(lb+1)/2)
logical(kind=iwp), intent(in) :: JfGrad(3,2)
integer(kind=iwp) :: i6, ix, iy, iz, jx, jy, jz

!                                                                      *
!***********************************************************************
!                                                                      *
!call RecPrt('X',' ',A_laplb,(la+2)*(la+3)/2,(lb+1)*(lb+2)/2)
!if (la > 0) Call RecPrt('X',' ',A_lamlb,(la+0)*(la+1)/2,(lb+1)*(lb+2)/2)
!call RecPrt('X',' ',A_lalbp,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2)
!if (lb > 0) Call RecPrt('X',' ',A_lalbm,(la+1)*(la+2)/2,(lb+0)*(lb+1)/2)
do ix=la,0,-1
  do iy=la-ix,0,-1
    iz = la-ix-iy

    do jx=lb,0,-1
      do jy=lb-jx,0,-1
        jz = lb-jx-jy

        i6 = 0
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Ax

        if (JfGrad(1,1)) then
          i6 = i6+1
          if (ix == 0) then
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Alpha*A_laplb(C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz))
          else
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Alpha*A_laplb(C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz))- &
                                                                 real(ix,kind=wp)*A_lamlb(C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz))
          end if
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Bx

        if (JfGrad(1,2)) then
          i6 = i6+1
          if (jx == 0) then
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Beta*A_lalbp(C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz))
          else
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Beta*A_lalbp(C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz))- &
                                                                 real(jx,kind=wp)*A_lalbm(C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz))
          end if
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Ay

        if (JfGrad(2,1)) then
          i6 = i6+1
          if (iy == 0) then
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Alpha*A_laplb(C_Ind3(ix,iy+1,iz),C_Ind3(jx,jy,jz))
          else
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Alpha*A_laplb(C_Ind3(ix,iy+1,iz),C_Ind3(jx,jy,jz))- &
                                                                 real(iy,kind=wp)*A_lamlb(C_Ind3(ix,iy-1,iz),C_Ind3(jx,jy,jz))
          end if
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        ! By

        if (JfGrad(2,2)) then
          i6 = i6+1
          if (jy == 0) then
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Beta*A_lalbp(C_Ind3(ix,iy,iz),C_Ind3(jx,jy+1,jz))
          else
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Beta*A_lalbp(C_Ind3(ix,iy,iz),C_Ind3(jx,jy+1,jz))- &
                                                                 real(jy,kind=wp)*A_lalbm(C_Ind3(ix,iy,iz),C_Ind3(jx,jy-1,jz))
          end if
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Az

        if (JfGrad(3,1)) then
          i6 = i6+1
          if (iz == 0) then
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Alpha*A_laplb(C_Ind3(ix,iy,iz+1),C_Ind3(jx,jy,jz))
          else
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Alpha*A_laplb(C_Ind3(ix,iy,iz+1),C_Ind3(jx,jy,jz))- &
                                                                 real(iz,kind=wp)*A_lamlb(C_Ind3(ix,iy,iz-1),C_Ind3(jx,jy,jz))
          end if
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Bz

        if (JfGrad(3,2)) then
          i6 = i6+1
          if (jz == 0) then
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Beta*A_lalbp(C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz+1))
          else
            rFinal(iZeta,C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz),i6) = Two*Beta*A_lalbp(C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz+1))- &
                                                                 real(jz,kind=wp)*A_lalbm(C_Ind3(ix,iy,iz),C_Ind3(jx,jy,jz-1))
          end if
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
      end do
    end do
  end do
end do
!call RecPrt('rFinal',' ',rFinal,nZeta*nTri0Elem(la)*nTri0Elem(lb),6)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Assemble_PPGrd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!***********************************************************************

#include "compiler_features.h"

module test_fortran_strings_mod
    use fruit
    use fortran_strings, only: StringWrapper_t, split, str
    use filesystem, only: basename
    implicit none
    private
    public :: test_split

contains

    subroutine test_split()
        character(*), parameter :: path = '/home/mustermann/file.txt'
        character(*), parameter :: names = 'Schroedinger Born Oppenheimer'

        type(StringWrapper_t), allocatable :: splitted(:)

! Bug in GFortran at least up to 10.01
! https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96047
! If the problem persists in higher versions, adjust the following line.
#if (__GNUC__) && defined(_WARNING_WORKAROUND_)
        allocate(splitted(0))
#endif

        call split(path, '/', splitted)
        call assert_true(str(splitted(1)%str) == '')
        call assert_true(str(splitted(2)%str) == 'home')
        call assert_true(str(splitted(3)%str) == 'mustermann')
        call assert_true(str(splitted(4)%str) == 'file.txt')

        call split(names, ' ', splitted)
        call assert_true(str(splitted(1)%str) == 'Schroedinger')
        call assert_true(str(splitted(2)%str) == 'Born')
        call assert_true(str(splitted(3)%str) == 'Oppenheimer')

        call assert_true('file.txt' == basename(path))
        call assert_true('files' == basename('/home/mustermann/files/'))
    end subroutine

end module test_fortran_strings_mod

program test_fortran_strings
    use fruit
    use test_fortran_strings_mod

    implicit none
    integer :: failed_count, i
    integer, parameter :: seed_size = 50
    integer, parameter :: seed(seed_size) = [(i, i = 1, seed_size)]

    call random_seed(put=seed)
    call init_fruit()
    call inimem()

    call test_fortran_strings_driver()

    call fruit_summary()
    call fruit_finalize()
    call get_failed_count(failed_count)

    if (failed_count /= 0) error stop

contains

    subroutine test_fortran_strings_driver()
        call run_test_case(test_split, "test_split")
    end subroutine
end program test_fortran_strings

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1987, Bjorn O. Roos                                    *
!***********************************************************************
!--------------------------------------------*
! 1987  B. O. ROOS                           *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND, SWEDEN                 *
!--------------------------------------------*

subroutine tr2nsa3(CMO,X1,nX1,X2,nX2,pqUs,npqUS,pqrU,npqrU)
! SECOND ORDER TWO-ELECTRON TRANSFORMATION ROUTINE
!
! THIS ROUTINE IS CALLED FOR EACH SYMMETRY BLOCK OF INTEGRALS
! (ISP,ISQ,ISR,ISS) WITH ISP >= ISQ AND ISR >= ISS.
! P,Q,R,S are SO indices.
! A,B are MO indices, counting only non-frozen and non-deleted.
! T,U are occupied MO indices, only non-frozen and non-deleted.
! INTEGRALS (AB/TU) ARE ALWAYS GENERATED
! EXCHANGE INTEGRALS (AT/BU) ARE GENERATED AS FOLLOWS:
! (AT/BU) IF ISP >= ISR
! (AT/UB) IF ISP > ISS AND ISP /= ISQ
! (TA/BU) IF ISQ > ISR AND ISP /= ISQ
! (TA/UB) IF ISQ >= ISS AND ISP /= ISQ
!
! This and tr2NsB routines transform non-squared AO integrals. The
! transformed MO integrals are stored as the same as Tr2Sq
! subroutine does.

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
#include "rasdim.fh"
#include "caspt2.fh"
integer(kind=iwp), intent(in) :: nX1, nX2, npqUS, npqrU
real(kind=wp), intent(in) :: CMO(NCMO)
real(kind=wp), intent(out) :: X1(nX1), X2(nX2)
real(kind=wp), intent(inout) :: pqUS(npqUS), pqrU(npqrU)
integer(kind=iwp) :: IAD1S, IAD2, IAD2S, icxc3, icxc7, IPQMX1, IPQMX2, IPQST, IRU, IS, ISPQRS, IST, ITU, IUS, KKTU, LAS, LS, NA, &
                     NAT, NORU, NOTU, NOUS, NS, NSYMP, NT, NTM, NTMAX, NU, Num, NUMAX
#include "trafo.fh"
#include "intgrl.fh"

NSYMP = NSYM*(NSYM+1)/2
NOTU = NOCR*NOCS
if (ISR == ISS) NOTU = (NOCR**2+NOCR)/2
NOUS = NOCR*NBS
NORU = NBR*NOCS
icxc3 = NOP*NOCQ*NOCR*NOS
icxc7 = NOCP*NOQ*NOCR*NOS

! Check for in core or out of core transformation

! 1. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|US) ON UNIT LUHLF1
IPQMX1 = NBPQ
if (NBPQ*NOUS > LURPQ) then
  IPQMX1 = LURPQ/NOUS
  !write(u6,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|US)',IPQMX1
  IAD1S = 0
  call dDAFILE(LUHLF1,0,PQUS,IPQMX1,IAD1S)
end if
! 2. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|RU) ON UNIT LUHLF2
IPQMX2 = NBPQ
if (NBPQ*NORU > LRUPQ) then
  IPQMX2 = LRUPQ/NORU
  !write(u6,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|RU)',IPQMX2
  IAD2S = 0
  call dDAFILE(LUHLF2,0,PQRU,IPQMX2,IAD2S)
end if
IAD2 = 0
! 3. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|TU) ON UNIT LUHLF3
!IPQMX3 = NBPQ
!if (NBPQ*NOTU > LTUPQ) then
!  IPQMX3 = LTUPQ/NOTU
!  !write(u6,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|TU)',IPQMX3
!  IAD3S = 0
!  call dDAFILE(LUHLF3,0,PQTU,IPQMX3,IAD3S)
!end if
!IAD3 = 0
!IOUT3 = 0

!-----------------------------------------------------------------------
! Second half transformation Case 3 (AT,UB)
!  Calculated if ISR /= ISS. Both type 1 and 2. ISQ /= ISR, since
!  equality makes integral to be zero symmetrically.
!  Case 4 (BU,TA) need not be calculated, since always ISP > ISS.
!-----------------------------------------------------------------------
NOTU = NOCQ*NOCR
if ((ISR /= ISS) .and. (icxc3 /= 0)) then
  LAS = (LRUPQ+LTUPQ)/NOTU
  LS = LAS/NOP
  if (LS > NBS) LS = NBS
  LAS = NOP*LS
  IAD2S = 0
  call dDAFILE(LUHLF2,0,PQRU,LAS,IAD2S)
  IAD2 = 0
  ! Loop over u,s pair
  IS = 0
  do NS=1,NBS
    IS = IS+1
    do NU=1,NOCR
      ! Square if necessary
      IUS = NBS*(NU-1)+NS
      IPQST = 1+NBPQ*(IUS-1)
      if (IPQMX1 < NBPQ) then
        call RBuf_tra2(LUHLF1,PQUS,NBPQ,IPQMX1,NOUS,IUS,IPQST,IAD1S)
      end if
      if (ISP == ISQ) then
        call Square(PQUS(IPQST),X2,1,NBP,NBP)
      else
        call dcopy_(NBPQ,PQUS(IPQST),1,X2,1)
      end if
      ! Always ISQ /= ISR  i.e. s(T) /= s(U)
      ! (pq,Us) -> (pT,Us)
      call DGEMM_('T','N',NBP,NOCQ,NBQ,One,X2,NBQ,CMO(LMOQ2),NBQ,Zero,X1,NBP)
      ! (pT,Us) -> (AT,Us)
      call DGEMM_('T','N',NOCQ,NOP,NBP,One,X1,NBP,CMO(LMOP),NBP,Zero,X2,NOCQ)
      ! Store buffer
      if (IS > LS) then
        IS = 1
        !vv do I=1,NOTU
        !vv   call dDAFILE(LUHLF2,1,PQRU(1+LAS*(I-1)),LAS,IAD2)
        !vv end do
        call dDAFILE(LUHLF2,1,PQRU,LAS*NOTU,IAD2)
      end if
      ! Sort
      NAT = 0
      do NA=1,NOP
        do NT=1,NOCQ
          ITU = NOCR*(NT-1)+NU-1
          if (ISQ < ISR) ITU = NOCQ*(NU-1)+NT-1
          NAT = NAT+1
          PQRU(LAS*ITU+NOP*(IS-1)+NA) = X2(NAT)
        end do
      end do
      ! End of loop over u,s pair
    end do
  end do
  ! Store last buffer
  if (LS < NBS) then
    !vv do I=1,NOTU
    !vv   call dDAFILE(LUHLF2,1,PQRU(1+LAS*(I-1)),LAS,IAD2)
    !vv end do
    call dDAFILE(LUHLF2,1,PQRU,LAS*NOTU,IAD2)
  end if

  ! Trasform last index

  if (ISQ >= ISR) then
    ! Store(type 1)
    ISPQRS = ((ISQ**2-ISQ)/2+ISR-1)*NSYMP+(ISP**2-ISP)/2+ISS
    IAD2M(2,ISPQRS) = IAD13
    NTMAX = NOCQ
    NUMAX = NOCR
  else
    ! Store(type 2)
    ISPQRS = ((ISR**2-ISR)/2+ISQ-1)*NSYMP+(ISP**2-ISP)/2+ISS
    IAD2M(3,ISPQRS) = IAD13
    NTMAX = NOCR
    NUMAX = NOCQ
  end if
  ! Loop over t,u pair, always ISQ /= ISR
  IST = 1-NBS*NOP
  KKTU = 0
  do NT=1,NTMAX
    do NU=1,NUMAX
      IST = IST+NBS*NOP
      KKTU = KKTU+1
      if (LS < NBS) then
        call RBuf_tra2(LUHLF2,PQRU,NBS*NOP,LAS,NOTU,KKTU,IST,IAD2S)
      end if
      ! (AT,Us) -> (AT,UB)
      call DGEMM_('T','T',NOS,NOP,NBS,One,CMO(LMOS2),NBS,PQRU(IST),NOP,Zero,X2,NOS)

      ! WRITE THESE BLOCK OF INTEGRALS ON LUINTM

      call GADSum(X2,NOP*NOS)
      call dDAFILE(LUINTM,1,X2,NOP*NOS,IAD13)
    end do
  end do
  ! End of loop over t,u pair
end if
!-----------------------------------------------------------------------
! Case 7 (TA,UB) and 8 (UB,TA)
!  Calculated if (ISP /= ISQ) .and. (ISR /= ISS)
!   Case 7, if ISQ >= ISS, always type 1
!   Case 8, if (ISQ < ISS) .and. (ISP /= ISR), always type 2
!-----------------------------------------------------------------------
NOTU = NOCP*NOCR
if (((ISS <= ISQ) .or. (ISP /= ISR)) .and. (ISP /= ISQ) .and. (ISR /= ISS) .and. (icxc7 /= 0)) then
  LAS = (LRUPQ+LTUPQ)/NOTU
  LS = LAS/NOQ
  if (LS > NBS) LS = NBS
  LAS = NOQ*LS
  IAD2S = 0
  call dDAFILE(LUHLF2,0,PQRU,LAS,IAD2S)
  IAD2 = 0
  IRU = 0
  ! Loop over u,s pair
  IS = 0
  do NS=1,NBS
    IS = IS+1
    do NU=1,NOCR
      IRU = NBS*(NU-1)+NS
      IPQST = 1+NBPQ*(IRU-1)
      if (IPQMX1 < NBPQ) then
        call RBuf_tra2(LUHLF1,PQUS,NBPQ,IPQMX1,NOUS,IRU,IPQST,IAD1S)
      end if
      ! Always ISP > ISQ
      ! Square unnecessary
      if (ISP == ISR) then
        ! (pq,Us) -> (Tq,Us)
        call DGEMM_('N','N',NBQ,NOCP-NU+1,NBP,One,PQUS(IPQST),NBQ,CMO(LMOP2+NBP*(NU-1)),NBP,Zero,X1,NBQ)
        ! (Tq,Us) -> (TA,Us)
        call DGEMM_('T','N',NOCP-NU+1,NOQ,NBQ,One,X1,NBQ,CMO(LMOQ),NBQ,Zero,X2,NOCP-NU+1)
      else
        ! (pq,Us) -> (Tq,Us)
        call DGEMM_('N','N',NBQ,NOCP,NBP,One,PQUS(IPQST),NBQ,CMO(LMOP2),NBP,Zero,X1,NBQ)
        ! (Tq,Us) -> (TA,Us)
        call DGEMM_('T','N',NOCP,NOQ,NBQ,One,X1,NBQ,CMO(LMOQ),NBQ,Zero,X2,NOCP)
      end if
      ! Store buffer
      if (IS > LS) then
        IS = 1
        !vv do I=1,NOTU
        !vv   call dDAFILE(LUHLF2,1,PQRU(1+LAS*(I-1)),LAS,IAD2)
        !vv end do
        call dDAFILE(LUHLF2,1,PQRU,LAS*NOTU,IAD2)
      end if
      ! Sorting
      ! Note: LAS is supposed to be small enough that (NOCP*NOCR)*LAS is
      ! at most = (LRUPQ+LTUPQ). NU can be as large as NOCR, so ITU
      ! can become NOCR*NOCP-1.
      ! Thus (LAS*ITU+NOQ*(IS-1)+NA can become as large as:
      ! LAS*(NOCP*NOCR-1)+NOQ*(NBS-1)+NOQ=LAS*(NOCP*NOCR-1)+NOQ*NBS
      ! which may become nearly as large as (LRUPQ+LTUPQ)+NOQ*NBS.
      ! But when called, only the size LRUPQ has been reserved for
      ! use (tractl:LW6=LW5+LRUPQ) by the array PQRU!
      ! This may be deliberate, if it is intended that PQRU is
      ! overlaying i.e. extended above the LW6 address which is
      ! then assumed not to be used any longer....
      NAT = 0
      do NA=1,NOQ
        NTM = 1
        if (ISP == ISR) NTM = NU
        do NT=NTM,NOCP
          ITU = NOCR*(NT-1)+NU-1
          if (ISP == ISR) ITU = (NT*NT-NT)/2+NU-1
          NAT = NAT+1
          PQRU(LAS*ITU+NOQ*(IS-1)+NA) = X2(NAT)
        end do
      end do
      ! End of Loop over u,s pair
    end do
  end do
  ! Store the last buffer
  if (LS < NBS) then
    !vv do I=1,NOTU
    !vv   call dDAFILE(LUHLF2,1,PQRU(1+LAS*(I-1)),LAS,IAD2)
    !vv end do
    call dDAFILE(LUHLF2,1,PQRU,LAS*NOTU,IAD2)
  end if
  if (ISQ >= ISS) then
    ! Store(Only type1)
    ISPQRS = ((ISP**2-ISP)/2+ISR-1)*NSYMP+(ISQ**2-ISQ)/2+ISS
    IAD2M(2,ISPQRS) = IAD13
  else if ((ISP /= ISR) .and. (ISQ < ISS)) then
    ! Store(Only type2)
    ISPQRS = ((ISP**2-ISP)/2+ISR-1)*NSYMP+(ISS**2-ISS)/2+ISQ
    IAD2M(3,ISPQRS) = IAD13
  end if
  IST = 1-NOQ*NBS
  KKTU = 0
  ! Loop over t,u pair, If (ISP == ISR) then loop should be triangle
  do NT=1,NOCP
    Num = NOCR
    if (ISP == ISR) Num = NT
    do NU=1,Num
      ! (TA,Us) -> (TA,UB)
      IST = IST+NOQ*NBS
      KKTU = KKTU+1
      if (LS < NBS) then
        call RBuf_tra2(LUHLF2,PQRU,NBS*NOQ,LAS,NOTU,KKTU,IST,IAD2S)
      end if
      if (ISQ >= ISS) then
        call DGEMM_('T','T',NOS,NOQ,NBS,One,CMO(LMOS),NBS,PQRU(IST),NOQ,Zero,X2,NOS)
      else if ((ISP /= ISR) .and. (ISS > ISQ)) then
        call DGEMM_('N','N',NOQ,NOS,NBS,One,PQRU(IST),NOQ,CMO(LMOS),NBS,Zero,X2,NOQ)
      end if

      ! WRITE THESE BLOCK OF INTEGRALS ON LUINTM

      call GADSum(X2,NOQ*NOS)
      call dDAFILE(LUINTM,1,X2,NOQ*NOS,IAD13)
    end do
  end do
  ! End of Loop over t,u pair
end if

return

end subroutine tr2nsa3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine o7a_cvb(nparm)
      implicit real*8 (a-h,o-z)
#include "opt2_cvb.fh"
      save one
      data one/1d0/

      call ddnewopt_cvb()
      have_solved_it=.false.
      call ddguess_cvb([one],1,0)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(nparm)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine expand2(a,b,dimp,dimqr,dims,dimq)
! expand a(p,qr,s) -> b(p,q,r,s)
! assumption: p>q, a(p,q,r,s)=-a(p,r,q,s)
! RISC version

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimqr, dims, dimq
real(kind=wp), intent(in) :: a(dimp,dimqr,dims)
real(kind=wp), intent(out) :: b(dimp,dimq,dimq,dims)
integer(kind=iwp) :: q, qr, r, s

if (dimq > 1) then

  do s=1,dims
    qr = 0
    do q=2,dimq
      do r=1,q-1
        qr = qr+1
        b(:,q,r,s) = a(:,qr,s)
        b(:,r,q,s) = -a(:,qr,s)
      end do
    end do
  end do

end if

do q=1,dimq
  b(:,q,q,:) = Zero
end do

return

end subroutine expand2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
      Subroutine xB88(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object: To compute the functional called x_B88 in the Density        *
* Functional Repository (http://www.cse.clrc.ac.uk/qcg/dft)            *
* Following older code by Roland Lindh, this routine computes only     *
* the GGA addition to the LDA part.                                    *
* Original reference article:                                          *
*                                                                      *
*                                                                      *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author:Per Ake Malmqvist, Department of Theoretical Chemistry,  *
*             University of Lund, SWEDEN. June 2006                    *
************************************************************************
      use KSDFT_Info, only: F_xca, F_xcb, tmpB
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
#include "ksdft.fh"
      Real*8 Rho(nRho,mGrid),
     &       dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
cGLM     &       F_xca(mGrid),F_xcb(mGrid),tmpB(mGrid)

* IDORD=Order of derivatives to request from XPBE:
      idord=1
*
      Rho_Min=T_X*1.0D-2
*
      if (ispin.eq.1) then
* ispin=1 means spin zero.

* T_X: Screening threshold of total density.
        Ta=0.5D0*T_X
        do iGrid=1,mgrid
         Rhoa=Rho(ipR,iGrid)
         if(Rhoa.lt.Ta) goto 110
         grdrhoa_x=Rho(ipdRx,iGrid)
         grdrhoa_y=Rho(ipdRy,iGrid)
         grdrhoa_z=Rho(ipdRz,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2

         call xB88_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*(2.0D0*Fa)
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*dFdrhoa
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*dFdgammaaa
* Note: For xpbe, dFdgammaab is zero.
 110     continue
        end do

      else
* ispin .ne. 1, use both alpha and beta components.

        do iGrid=1,mgrid
         rhoa=Max(Rho_Min,rho(ipRa,iGrid))
         rhob=Max(Rho_Min,rho(ipRb,iGrid))
         rho_tot=rhoa+rhob
         if(rho_tot.lt.T_X) goto 210
         grdrhoa_x=rho(ipdRxa,iGrid)
         grdrhoa_y=rho(ipdRya,iGrid)
         grdrhoa_z=rho(ipdRza,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         call xB88_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)

         grdrhob_x=rho(ipdRxb,iGrid)
         grdrhob_y=rho(ipdRyb,iGrid)
         grdrhob_z=rho(ipdRzb,iGrid)
         sigmabb=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
         call xB88_(idord,rhob,sigmabb,Fb,dFdrhob,dFdgammabb,
     &          d2Fdrb2,d2Fdrbdgbb,d2Fdgbb2)

         F_xc(iGrid) =F_xc(iGrid) +Coeff*(Fa+Fb)
         F_xca(iGrid)=F_xca(iGrid)+Coeff*(Fa)
         F_xcb(iGrid)=F_xcb(iGrid)+Coeff*(   Fb)
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+Coeff*dFdrhoa
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+Coeff*dFdrhob
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
* Note: For xpbe, dFdgammaab is zero.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*dFdgammaaa
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*dFdgammabb
 210     continue
        end do
        tmpB(:)=F_xc(:)
      end if

      Return
      End

      subroutine xB88_(idord,rho_s,gamma_s,B88,dB88dr,dB88dg,d2B88dr2,
     &                d2B88drdg,d2B88dg2)
      implicit real*8 (a-h,o-z)
      parameter(third=1.0d0/3.0d0)
      parameter(four3=4.0d0/3.0d0)
      parameter(seven3=7.0d0/3.0d0)
      parameter(dcoef=0.0042d0)
C     parameter(xldacff=0.930525736349100025D0)

      rho=rho_s+1.0D-16
      gamma=gamma_s+1.0D-16
      r43 = rho**four3
      rhoinv=1.0d0/rho
* lda part:
*     xlda=-xldacff*r43
* Note: Use x=sqrt(gamma)/rho**four3
      x = sqrt(gamma_s)/r43
      hgi = 0.5D0/gamma
      p =sqrt(1.0D0+x**2)
      ash = log(x+p)
      d6 = 6.0D0*dcoef
      a = 1.0D0+d6*x*ash
      f = x**2/a

* Let b88(rho,gamma)=b(rho,x)
      dr43=-dcoef*r43
* The LDA part has been removed, just GGA part left.
*     b=dr43*f+xlda
      b=dr43*f
      b88 = b

      if(idord.lt.1) goto 99
      dxdr = -four3*x*rhoinv
      dxdg = hgi*x
      dadx = d6*(ash+x/p)
      dfdx = (2.0D0*x-f*dadx)/a
      dbdr = four3*b*rhoinv
      dbdx = dr43*dfdx
      db88dr = dbdr+dxdr*dbdx
      db88dg = dxdg*dbdx

      if(idord.lt.2) goto 99
      d2xdr2 = -seven3*dxdr*rhoinv
      d2xdrdg = hgi*dxdr
      d2xdg2 = -hgi*dxdg
      d2adx2 = d6*(1.0D0+p**2)/(p**3)
      d2fdx2 = (2.0D0-2.0D0*dadx*dfdx-d2adx2*f)/a
      d2bdr2 = third*dbdr*rhoinv
      d2bdx2 = dr43*d2fdx2
      d2bdrdx = four3*dbdx*rhoinv
      d2b88dr2 = d2bdr2+2.D0*dxdr*d2bdrdx+d2xdr2*dbdx+dxdr**2*d2bdx2
      d2b88dg2 = d2xdg2*dbdx+dxdg**2*d2bdx2
      d2b88drdg = dxdg*d2bdrdx+d2xdrdg*dbdx+dxdr*dxdg*d2bdx2

  99  continue

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
function ILEX_FOR_CONF(ICONF,NOCC_ORB,NORB,NEL,IARCW,IDOREO,IREO)
! A configuration ICONF of NOCC_ORB orbitals are given
! ICONF(I) = IORB implies  IORB is singly occupied
! ICONF(I) = -IORB  implies that IORB is doubly occupied
!
! Find lexical address
!
! IF IDOREO /= 0, IREO is used to reorder lexical number
! Jeppe Olsen, November 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: ILEX_FOR_CONF
integer(kind=iwp), intent(in) :: NOCC_ORB, ICONF(NOCC_ORB), NORB, NEL, IARCW(NORB,NEL,2), IDOREO, IREO(*)
integer(kind=iwp) :: IEL, ILEX, IOCC

IEL = 0
ILEX = 1

do IOCC=1,NOCC_ORB
  if (ICONF(IOCC) > 0) then
    IEL = IEL+1
    ILEX = ILEX+IARCW(ICONF(IOCC),IEL,1)
  else if (ICONF(IOCC) < 0) then
    IEL = IEL+2
    ILEX = ILEX+IARCW(-ICONF(IOCC),IEL,2)
  end if
end do

if (IDOREO /= 0) then
  ILEX_FOR_CONF = IREO(ILEX)
else
  ILEX_FOR_CONF = ILEX
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Configuration'
call IWRTMA(ICONF,1,NOCC_ORB,1,NOCC_ORB)
write(u6,*) ' Lexical number = ',ILEX
if (IDOREO /= 0) write(u6,*) ' Reordered number = ',ILEX_FOR_CONF
#endif

end function ILEX_FOR_CONF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Print_NQ_Info(iSpin)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "nq_info.fh"
      Logical Reduce_Prt
      External Reduce_Prt
*                                                                      *
************************************************************************
*                                                                      *
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0
*                                                                      *
************************************************************************
*                                                                      *
      If (iPL.ge.3) Then
         Call GAIGOP_SCAL(nTotGP,'+')
         Call GADGOP_SCAL(Flop,'+')
         Write (6,*)
         Write (6,'(6X,A,T52,F17.10)')
     &            'Integrated DFT Energy   ',Energy_integrated
         Write (6,'(6X,A,T56,G17.10)')
     &            'Integrated number of electrons',Dens_I
         If (Grad_I.ne.Zero)
     &   Write (6,'(6X,A,T56,G17.10)')
     &            'Integrated |grad|             ',Grad_I
         If (Tau_I .ne.Zero)
     &   Write (6,'(6X,A,T56,G17.10)')
     &            'Integrated tau                ',Tau_I
         Write (6,'(6X,A,T54,I13)')
     &            'Total number of prunned grid points  ',nTotGP
         Write (6,'(6X,A,T52,F17.1)')
     &            'Number of grid points per SO-integral  ',Flop
         Write (6,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Add_Info('DFT_Energy',[Energy_integrated],1,6)
      Call Add_Info('NQ_Density',[Dens_I],1,8)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iSpin)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine aikcof_cvb(aikcof,bikcof,
     > ndet,ifns,kbasis,share,
     > sovr)
      implicit real*8 (a-h,o-z)
      logical share
      dimension aikcof(ndet,ifns),bikcof(ndet,ifns)
      dimension sovr(ifns,ifns)

      if(kbasis.eq.6)return
c
c  Generate mapping from determinants to spin functions
c  (If KBASIS<=2 then AIKCOF=BIKCOF and they (probably) share memory)
      if(kbasis.gt.2)then
        call mxattb_cvb(bikcof,bikcof,ifns,ndet,ifns,sovr)
        call mxinv_cvb(sovr,ifns)
        call mxatb_cvb(bikcof,sovr,ndet,ifns,ifns,aikcof)
      elseif(.not.share)then
        call fmove_cvb(bikcof,aikcof,ndet*ifns)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Funi_Init()

use nq_Info, only: Angular_Pruning, Crowding, Fade, Grid_Type, iOpt_Angular, L_Quad, MBC, Moving_Grid, NQ_Direct, nR, ntotgp, Off, &
                   On, Packing, Quadrature, Rotational_Invariance, T_Y, Threshold, R_Max
use Constants, only: Zero, Three, Six
use Definitions, only: wp, iwp

implicit none

!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize the default values of the parameters.

! Default Grid
Quadrature = 'MHL '
nR = 75
L_Quad = 29
Crowding = Three
Fade = Six
MBC = ' '

ntotgp = 0

! Various default thresholds for the integral evaluation.

T_Y = 1.0e-11_wp
Threshold = 1.0e-25_wp

Angular_Pruning = On
Grid_Type = Moving_Grid
Rotational_Invariance = On
NQ_Direct = Off
!NQ_Direct = On
!Packing = On
Packing = Off

! Bit 0: set Lobatto, not set Gauss and Gauss-Legendre
! Bit 1: set scan the whole atomic grid, not set use subset
! Bit 2: set Lebedev, override bit 0
iOpt_Angular = ibset(0_iwp,2)
!                                                                      *
!***********************************************************************
!                                                                      *
R_Max(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Funi_Init

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ABSTR_TO_ORDSTR(IA_OC,IB_OC,NAEL,NBEL,IDET_OC,IDET_SP,SGN)
! An alpha string (IA) and a betastring (IB) is given.
! Combine these two strings to give an determinant with
! orbitals in ascending order. For doubly occupied orbitals
! the alphaorbital is given first.
! The output is given as IDET_OC : Orbital occupation (configuration)
!                        IDET_SP : Spin projections
!
! The phase required to change IA IB into IDET is computed as SGN
!
! Jeppe Olsen, November 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NAEL, IA_OC(NAEL), NBEL, IB_OC(NBEL)
integer(kind=iwp), intent(out) :: IDET_OC(NAEL+NBEL), IDET_SP(NAEL+NBEL), SGN
integer(kind=iwp) :: NEXT_AL, NEXT_BE, NEXT_EL

NEXT_AL = 1
NEXT_BE = 1
SGN = 1
! Loop over next electron in outputstring
do NEXT_EL=1,NAEL+NBEL
  if ((NEXT_AL <= NAEL) .and. (NEXT_BE <= NBEL)) then

    if (IA_OC(NEXT_AL) <= IB_OC(NEXT_BE)) then
      ! Next electron is alpha electron
      IDET_OC(NEXT_EL) = IA_OC(NEXT_AL)
      IDET_SP(NEXT_EL) = 1
      NEXT_AL = NEXT_AL+1
    else
      ! Next electron is beta electron
      IDET_OC(NEXT_EL) = IB_OC(NEXT_BE)
      IDET_SP(NEXT_EL) = -1
      NEXT_BE = NEXT_BE+1
      SGN = SGN*(-1)**(NAEL-NEXT_AL+1)
    end if
  else if (NEXT_BE > NBEL) then
    ! Next electron is alpha electron
    IDET_OC(NEXT_EL) = IA_OC(NEXT_AL)
    IDET_SP(NEXT_EL) = 1
    NEXT_AL = NEXT_AL+1
  else if (NEXT_AL > NAEL) then
    ! Next electron is beta electron
    IDET_OC(NEXT_EL) = IB_OC(NEXT_BE)
    IDET_SP(NEXT_EL) = -1
    NEXT_BE = NEXT_BE+1
    SGN = SGN*(-1)**(NAEL-NEXT_AL+1)
  end if
end do
! End of loop over electrons in outputlist

#ifdef _DEBUGPRINT_
write(u6,*) ' ABSTR to ORDSTR :'
write(u6,*) ' ================='
write(u6,*) ' Input alpha and beta strings'
call IWRTMA(IA_OC,1,NAEL,1,NAEL)
call IWRTMA(IB_OC,1,NBEL,1,NBEL)
write(u6,*) ' Configuration'
call IWRTMA(IDET_OC,1,NAEL+NBEL,1,NAEL+NBEL)
write(u6,*) ' Spin projections'
call IWRTMA(IDET_SP,1,NAEL+NBEL,1,NAEL+NBEL)
#endif

end subroutine ABSTR_TO_ORDSTR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKTDM2(LSYM1,MSPROJ1,IFSBTAB1,LSYM2,MSPROJ2,IFSBTAB2,ISSTAB,MAPORB,DET1,DET2,NTDM2,TDM2,OrbTab)

#ifdef _DMRG_
use rasscf_global, only: doDMRG
#endif
use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: MUL
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp
#if defined (_DEBUGPRINT_) || defined (_DMRG_)
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: LSYM1, MSPROJ1, IFSBTAB1(*), LSYM2, MSPROJ2, IFSBTAB2(*), ISSTAB(*), MAPORB(*), NTDM2, OrbTab(*)
real(kind=wp), intent(in) :: DET1(*), DET2(*)
real(kind=wp), intent(out) :: TDM2(NTDM2)
integer(kind=iwp) :: IAAAA, IABAB, IABBA, IAKA, IAKB, IBAAB, IBABA, IBBBB, IBIA, IBKA, IBKB, IJ, IJIJ, IORB, IORBA, IORBB, ISYOP, &
                     ITABS, ITU, ITUVX, IUABS, IVABS, IVX, IXABS, JALA, JALB, JBJA, JBLA, JBLB, JORB, JORBA, JORBB, KORB, KORBA, &
                     KORBB, LORB, LORBA, LORBB, MS2OP, NASGEM, NASHT, NASORB, NSPD2
real(kind=wp) :: GAAAA, GABAB, GABBA, GBAAB, GBABA, GBBBB, GVAL, SGNIK, SGNJL
real(kind=wp), allocatable :: SPD2(:)

! Given two CI expansions, using a biorthonormal set of SD's,
! calculate the spin-summed 2-particle transition density matrix
! in the biorthonormal active orbital basis.

! Pick out nr of active orbitals from orbital table:
NASORB = ORBTAB(4)
NASHT = NASORB/2
NASGEM = nTri_Elem(NASORB-1)
NSPD2 = NASGEM**2
call mma_allocate(SPD2,nSPD2,Label='SPD2')
SPD2(:) = Zero
ISYOP = MUL(LSYM1,LSYM2)
MS2OP = MSPROJ1-MSPROJ2

#ifdef _DMRG_
if (.not. doDMRG) then
#endif
  call SPIND2(ISYOP,MS2OP,ORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,DET1,DET2,SPD2)
#ifdef _DMRG_
else

  write(u6,*) '2-TDM import with QCMaquis in MPSSI not implemented yet'
  call Quit_OnUserError()
end if
! Old interface import
!#define BLUBB
!if (doMPSSICheckpoints) then
!  call dmrg_interface_ctl( &
!    task='imp rdmY', &
!#   ifndef BLUBB
!    x2=spd2, &
!    mdim=nasgem, &
!#   else
!    x2=tdm2, &
!    mdim=ntdm2, &
!#   endif
!    checkpoint1=qcm_group_names(job1)%states(ist), &
!    checkpoint2=qcm_group_names(job2)%states(jst), &
!    msproj=msproj1, &
!    msprojL=msproj2, &
!    multiplet=MPLET1-1, & ! (we need 2*S)
!    multipletL=MPLET2-1, & ! (we need 2*S)
!    rdm1=.false., &
!    rdm2=.true. &
!  )
!else
!  call dmrg_interface_ctl( &
!    task='imp rdmY', &
!#   ifndef BLUBB
!    x2=spd2, &
!    mdim=nasgem, &
!#   else
!    x2=tdm2, &
!    mdim=ntdm2, &
!#   endif
!    state=iWork(lLROOT+ISTATE-1), &
!    stateL=iWork(lLROOT+JSTATE-1), &
!    msproj=msproj1, &
!    msprojL=msproj2, &
!    multiplet=MPLET1-1, & ! (we need 2*S)
!    multipletL=MPLET2-1, & ! (we need 2*S)
!    rdm1=.false., &
!    rdm2=.true. &
!  )
!end if
!#ifdef BLUBB
!if (.false.) then
!#endif
#endif

SGNJL = One ! dummy initialize
SGNIK = One ! dummy initialize
IAKA = 0    ! dummy initialize
IAKB = 0    ! dummy initialize
IBIA = 0    ! dummy initialize
IBKA = 0    ! dummy initialize
IBKB = 0    ! dummy initialize
JALA = 0    ! dummy initialize
JALB = 0    ! dummy initialize
JBLA = 0    ! dummy initialize
JBLB = 0    ! dummy initialize
JBJA = 0    ! dummy initialize
do JORB=1,NASHT
  JORBA = 2*JORB-1
  JORBB = 2*JORB
  IUABS = MAPORB(JORBA)
  do IORB=1,NASHT
    IORBA = 2*IORB-1
    IORBB = 2*IORB
    ITABS = MAPORB(IORBA)
    ITU = ITABS+NASHT*(IUABS-1)
    do LORB=1,NASHT
      LORBA = 2*LORB-1
      LORBB = 2*LORB
      IXABS = MAPORB(LORBA)
      if (JORB > LORB) then
        SGNJL = One
        JALA = nTri_Elem(JORBA-2)+LORBA
        JALB = nTri_Elem(JORBA-2)+LORBB
        JBLA = nTri_Elem(JORBB-2)+LORBA
        JBLB = nTri_Elem(JORBB-2)+LORBB
      else if (JORB == LORB) then
        JBJA = nTri_Elem(JORBB-2)+JORBA
      else
        SGNJL = -One
        JALA = nTri_Elem(LORBA-2)+JORBA
        JALB = nTri_Elem(LORBB-2)+JORBA
        JBLA = nTri_Elem(LORBA-2)+JORBB
        JBLB = nTri_Elem(LORBB-2)+JORBB
      end if
      do KORB=1,NASHT
        KORBA = 2*KORB-1
        KORBB = 2*KORB
        IVABS = MAPORB(KORBA)
        IVX = IVABS+NASHT*(IXABS-1)
        if (ITU < IVX) cycle
        if (IORB > KORB) then
          SGNIK = One
          IAKA = nTri_Elem(IORBA-2)+KORBA
          IAKB = nTri_Elem(IORBA-2)+KORBB
          IBKA = nTri_Elem(IORBB-2)+KORBA
          IBKB = nTri_Elem(IORBB-2)+KORBB
        else if (IORB == KORB) then
          IBIA = nTri_Elem(IORBB-2)+IORBA
        else
          SGNIK = -One
          IAKA = nTri_Elem(KORBA-2)+IORBA
          IAKB = nTri_Elem(KORBB-2)+IORBA
          IBKA = nTri_Elem(KORBA-2)+IORBB
          IBKB = nTri_Elem(KORBB-2)+IORBB
        end if
        if (IORB /= KORB) then
          if (JORB /= LORB) then
            IAAAA = IAKA+NASGEM*(JALA-1)
            IABBA = IAKB+NASGEM*(JALB-1)
            IBAAB = IBKA+NASGEM*(JBLA-1)
            IBBBB = IBKB+NASGEM*(JBLB-1)
            GAAAA = SPD2(IAAAA)
            GABBA = SPD2(IABBA)
            GBAAB = SPD2(IBAAB)
            GBBBB = SPD2(IBBBB)
            GVAL = SGNIK*SGNJL*(GAAAA+GABBA+GBAAB+GBBBB)
          else
            IABAB = IAKB+NASGEM*(JBJA-1)
            IBAAB = IBKA+NASGEM*(JBJA-1)
            GABAB = SPD2(IABAB)
            GBAAB = SPD2(IBAAB)
            GVAL = SGNIK*(-GABAB+GBAAB)
          end if
        else
          if (JORB /= LORB) then
            IBABA = IBIA+NASGEM*(JALB-1)
            IBAAB = IBIA+NASGEM*(JBLA-1)
            GBABA = SPD2(IBABA)
            GBAAB = SPD2(IBAAB)
            GVAL = SGNJL*(-GBABA+GBAAB)
          else
            IBAAB = IBIA+NASGEM*(JBJA-1)
            GBAAB = SPD2(IBAAB)
            GVAL = Two*GBAAB
          end if
        end if
        ! Position determined by active orbital index in external order:
        ITUVX = nTri_Elem(ITU-1)+IVX
        TDM2(ITUVX) = GVAL
      end do
    end do
  end do
end do

!#ifdef BLUBB
!end if
!#endif

#ifdef _DEBUGPRINT_
write(u6,*) ' final 2-TDM'
do IJ=1,ntdm2
  write(u6,*) ' IJ, value = ',IJ,TDM2(IJ)
end do
#endif

call mma_deallocate(SPD2)
! DIAGONAL ELEMENTS HALF-SIZED (This is for proper contraction with TUVX):
IJIJ = 0
do IJ=1,NASHT**2
  IJIJ = IJIJ+IJ
  TDM2(IJIJ) = Half*TDM2(IJIJ)
end do

return

end subroutine MKTDM2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MATCAS(     CIN,    COUT,   NROWI,   NROWO,  IROWO1,
     &                     NGCOL,    ISCA,  SCASGN)
*
* COUT(IR+IROWO1-1,ISCA(IC)) =
* COUT(IR+IROWO1-1,ISCA(IC)) + CIN(IR,IC)*SCASGN(IC)
* (if IGAT(IC).ne.0)
*
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION CIN(NROWI,*),COUT(NROWO,*)
      INTEGER ISCA(*)
      DIMENSION SCASGN(*)
*
      MAXCOL = 0
      DO 100 IC = 1, NGCOL
        IF(ISCA(IC).NE.0) THEN
          ICEXP = ISCA(IC)
          MAXCOL = MAX(MAXCOL,ICEXP)
          SIGN = SCASGN(IC)
          DO 50 IR = 1,NROWI
            COUT(IR+IROWO1-1,ICEXP) =
     &      COUT(IR+IROWO1-1,ICEXP) + SIGN*CIN(IR,IC)
   50     CONTINUE
        END IF
  100 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' Output from MATCAS '
        CALL WRTMAT(COUT,NROWO,MAXCOL,NROWO,MAXCOL)
      END IF
*
      RETURN
      END
C                 CALL MATCG(C,CB(ICGOFF),NROW,NIBTC,IBOT,
C                            NKBTC,I1,XI1S)

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!0      maximal # of Groups, SubGroups
!       maxGrp, maxSGrp
!
!1.1    Basic parameters for CCSD procedure
!
!       no - # of occupied orbitals
!       nv - # of virtual orbitals
!       nc - # of Cholesky vectors
!       nfr- # if frozen orbitals
!
!       mhkey - FTN/BLAS switch
!       maxiter - Maximal number of iterations
!       restkey - key for restart [1/0]
!       generkey - key for generation of integrals from L vectors [1/0]
!       intkey - key for generation of (vv|vv) and (vv|vo) integrals [1/0]
!       W34DistKey - 1 - only required W34 files are stored on each node
!                    0 - all W34 files are stored on each node
!       JoinLkey - key to control the cummulation of L L(ml)->L(m)
!                  0 - no cummulation of L files are needed
!                  1 - cummulation immidiately afret L(ml) are produced
!                      (before I, -> I and W are generated using full L)
!                  2 - cummulation after I
!                      (I are generated per partes using L(ml) + gadgop
!                       and W are generated using full L)
!                  3 - cummulation after W
!                      (also W34 are generated per partes using L(ml) +g)
!
!       printkey -  1 - Only basic info is printed (default)
!                   2 - 1 + timings
!                  10 - debug info
!
!1.2    position of Permanent arrays
!
!       Fock matrix             - PosFoo,PosFvv,PosFvo
!       Orbital energies        - PosOE
!       T1 amplitudes, old, new - PosT1o,PosT1n
!       N2 Intermediates for T1 - PosHoo,PosHvv,PosHvo
!       N2 Intermediates for T2 - PosGoo,PosGvv
!       O2OO Intermediate A     - PosA - @@ na zamyslenie, ci nie cez worky
!       O2OO Intermediate Aex   - PosAex - @@ na zamyslenie, ci nie cez worky
!       position of Free space  - PosFree
!
!1.3    Checkeroo part
!       T1c, T2c, OEo, OEv, Q0, Q1, Q21, Q22, Q3, Q4, L0k, L1k, L2k,
!       Jc, Kc, Ac, Bc, Hooc, Hvvc, Hvoc, Gooc, Gvvc
!
!2      for routines evaluating o3v3 contributions
!
!2.1    Dimensions of groups
!       DimGrpv
!
!2.2    Dimensions of groups (a,b)
!       DimGrpaR
!
!3      for routines evaluating o2v4 contributions
!
!3.1    Groups borders (which subgroup is low and upper limit of given group)
!       GrpaLow, GrpbeLow, GrpaUp, GrpbeUp
!
!3.2    Dimensions of groups
!       DimGrpa, DimGrpbe
!
!3.3    Dimensions of subgroups
!       DimSGrpa, DimSGrpbe
!
!4      Timing
!       TWall, TCpu     - pomocne
!       TWall0, TCpu0   - zaciatocne hodnoty
!       TWall_l, TCpu_l - lokalne hodnoty
!
!5      Names of all used files
!
!5.1    Names of L0-L2 files
!       L0Name, L1Name, L2Name
!
!5.2    Names of T2 files
!       T2Name
!
!5.3    Names of I0-3 files
!       I0Name, I1Name, I2Name, I3Name
!
!5.4    Names of Tmp1,2 files
!       Tmp1Name, Tmp2Name
!
!5.5    Names of Tmp3 file
!       Tmp3Name
!
!6      for parallel computing
!
!6.1    BetaID(myRank,beGrp) - indicates if contributions that need to be
!       realized only once per each beta' will be realized on this node (myRank)
!        =1, contributions will be realized on this node
!        =0, not to be realized on this node
!
!6.2.1  BeAID(myRank,beGrp,bGrp) - indicates which be' a' combinations
!       are to be evaluated on this node (myRank)
!        =1, this be' a' combination is to be realized on this node
!        =0, not to be realized on this node
!
!6.2.2  ABID(myRank,aGrp,bGrp) - indicates which a'b' values are to be evaluated
!       on this node (myRank)
!        =1, this a'b' combination is to be realized on this node
!        =0, not to be realized on this node
!
!6.3    Xyes(p,q) - indicates if in Tmp2(p,q) is a record of X from
!       o3v3chol part on this node
!        =1, there is a record from o3v3chol part on this node
!        =0, file is leaving empty from o3v3chol  on this node
!
!6.4    XYyes(p,q) - indicates if in Tmp2(p,q) is a record of XY from
!       o3v3t2 part on this node
!        =1, there is a record from o3v3t2 part on this node
!        =0, there is no record from o3v3t2  on this node
!            (but there still can be record from o3v3chol on this node)
!
!6.5    T2o2v4yes(p,q) - indicates if in Tmp3(p,q) is a record of T2n from
!       o2v4 part on this node
!        =1, there is a record from o2v4 part on this node
!        =0, there is no record from o2v4  on this node
!
!6.6    Local number of Cholesky vectors on each node
!       NChLoc
!
!6.7    Files, containing information which W3 and W4 files are used on this node
!       InqW3, InqW4

module chcc_global

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: maxGrp = 32, maxSGrp = 64, &
                                maxNod = 512

integer(kind=iwp) :: ABID(0:maxNod-1,maxGrp,maxGrp), BeAID(0:maxNod-1,maxGrp,maxGrp), BetaID(0:maxNod-1,maxGrp), DimGrpa(maxGrp), &
                     DimGrpaR(maxGrp), DimGrpbe(maxGrp), DimGrpv(maxGrp), DimSGrpa(maxSGrp), DimSGrpbe(maxSGrp), generkey, &
                     GrpaLow(maxGrp), GrpaUp(maxGrp), GrpbeLow(maxGrp), GrpbeUp(maxGrp), intkey, JoinLkey, maxiter, mhkey, nc, &
                     NChLoc(0:maxnod-1), nfr, no, nv, PosA, PosAex, PosFoo, PosFree, PosFvo, PosFvv, PosGoo, PosGvv, PosHoo, &
                     PosHvo, PosHvv, PosOE, PosT1n, PosT1o, printkey, restkey, T2o2v4yes(maxSGrp,maxSGrp), W34DistKey, &
                     Xyes(maxGrp,maxGrp), XYyes(maxGrp,maxGrp)
real(kind=wp) :: conv, TCpu, TCpu0, TCpu_l, TWall, TWall0, TWall_l
character(len=6) :: I0Name, I1Name(maxGrp), I2Name(maxGrp,maxGrp), I3Name(maxGrp,maxGrp), L0Name, L1Name(maxGrp), &
                    L2Name(maxGrp,maxGrp), T2Name(maxGrp,maxGrp), Tmp1Name(maxGrp,maxGrp), Tmp2Name(maxGrp,maxGrp), &
                    Tmp3Name(maxSGrp,maxSGrp)
logical(kind=iwp) :: InqW3(maxSGrp*(maxSGrp+1)/2,maxSGrp), InqW4(maxSGrp*(maxSGrp+1)/2,maxSGrp*(maxSGrp+1)/2)
real(kind=wp), allocatable :: Ac(:,:,:,:), Bc(:,:,:,:), Gooc(:,:), Gvvc(:,:), Hooc(:,:), Hvoc(:,:), Hvvc(:,:), Jc(:,:,:,:), &
                              Kc(:,:,:,:), L0k(:,:,:), L1k(:,:,:), L2k(:,:,:), OEo(:), OEv(:), Q0(:,:,:,:), Q1(:,:,:,:), &
                              Q21(:,:,:,:), Q22(:,:,:,:), Q3(:,:,:,:), Q4(:,:,:,:), T1c(:,:), T2c(:,:,:,:)

public :: ABID, Ac, Bc, BeAID, BetaID, conv, deallocate_arrays, DimGrpa, DimGrpaR, DimGrpbe, DimGrpv, DimSGrpa, DimSGrpbe, &
          generkey, Gooc, GrpaLow, GrpaUp, GrpbeLow, GrpbeUp, Gvvc, Hooc, Hvoc, Hvvc, I0Name, I1Name, I2Name, I3Name, InqW3, &
          InqW4, intkey, Jc, JoinLkey, Kc, L0k, L0Name, L1k, L1Name, L2k, L2Name, maxGrp, maxiter, maxSGrp, mhkey, nc, NChLoc, &
          nfr, no, nv, OEo, OEv, PosA, PosAex, PosFoo, PosFree, PosFvo, PosFvv, PosGoo, PosGvv, PosHoo, PosHvo, PosHvv, PosOE, &
          PosT1n, PosT1o, printkey, Q0, Q1, Q21, Q22, Q3, Q4, restkey, T1c, T2c, T2Name, T2o2v4yes, TCpu, TCpu0, TCpu_l, Tmp1Name, &
          Tmp2Name, Tmp3Name, TWall, TWall0, TWall_l, W34DistKey, Xyes, XYyes

contains

subroutine deallocate_arrays()

  use stdalloc, only: mma_deallocate

  call mma_deallocate(T1c,safe='*')
  call mma_deallocate(T2c,safe='*')
  call mma_deallocate(OEo,safe='*')
  call mma_deallocate(OEv,safe='*')
  call mma_deallocate(Q0,safe='*')
  call mma_deallocate(Q1,safe='*')
  call mma_deallocate(Q21,safe='*')
  call mma_deallocate(Q22,safe='*')
  call mma_deallocate(Q3,safe='*')
  call mma_deallocate(Q4,safe='*')
  call mma_deallocate(L0k,safe='*')
  call mma_deallocate(L1k,safe='*')
  call mma_deallocate(L2k,safe='*')
  call mma_deallocate(Jc,safe='*')
  call mma_deallocate(Kc,safe='*')
  call mma_deallocate(Ac,safe='*')
  call mma_deallocate(Bc,safe='*')
  call mma_deallocate(Hooc,safe='*')
  call mma_deallocate(Hvvc,safe='*')
  call mma_deallocate(Hvoc,safe='*')
  call mma_deallocate(Gooc,safe='*')
  call mma_deallocate(Gvvc,safe='*')

end subroutine deallocate_arrays

end module chcc_global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine VecPhase(A,nA)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nA
real(kind=wp), intent(inout) :: A(nA)
integer(kind=iwp) :: i
real(kind=wp) :: Phase

Phase = Zero
do i=1,nA
  Phase = Phase+A(i)*i
end do
if (Phase < Zero) then
  A(:) = -A(:)
  Phase = -Phase
end if

return

end subroutine VecPhase

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1998  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MLTCTL(HEFF,EIGVEC,U0)
      use output_caspt2, only:iPrGlb,terse,usual,verbose
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      INTEGER LAXITY
      INTEGER  Cho_X_GetTol
      EXTERNAL Cho_X_GetTol
      CHARACTER(LEN=8) INLAB
      character(len=3) variant
      DIMENSION HEFF(NSTATE,NSTATE),EIGVEC(NSTATE,NSTATE)
      real(8) U0(Nstate,Nstate)
      real(8),allocatable :: Utmp(:,:)


      IF(IPRGLB.GE.TERSE) THEN
        CALL CollapseOutput(1,'Multi-State CASPT2 section:')
        WRITE(6,'(20A4)')('****',I=1,20)
        WRITE(6,*)' MULTI-STATE CASPT2 SECTION'
        IF(IPRGLB.GE.USUAL) THEN
          WRITE(6,'(20A4)')('----',I=1,20)
          WRITE(6,*)
        END IF
      END IF

C Write out the effective Hamiltonian, for use in e.g. RASSI:
      INLAB='HEFF'
      CALL put_darray(INLAB,HEFF,NSTATE**2)

C Analyze the effective Hamiltonian:
      DSHIFT=0.0D0
      IF(HEFF(1,1).LE.-100.0D0) THEN
        DSHIFT=-DBLE(INT(-HEFF(1,1)))
      END IF
      DO I=1,NSTATE
        HEFF(I,I)=HEFF(I,I)-DSHIFT
      END DO

      IF(IPRGLB.GE.TERSE .and. DSHIFT.NE.0.0D0) THEN
        WRITE(6,*)
     &  ' Output diagonal energies have been shifted. Add ',DSHIFT
       END IF

      IF((IPRGLB.GE.VERBOSE).OR.JMS) THEN
        WRITE(6,*)' Effective Hamiltonian matrix (Asymmetric):'
        DO ISTA=1,NSTATE,5
          IEND=MIN(ISTA+4,NSTATE)
          WRITE(6,*)
          WRITE(6,'(1x,5I16)')(MSTATE(I),I=ISTA,IEND)
          DO J=1,NSTATE
            WRITE(6,'(1x,I3,3X,5F16.8)')
     &            MSTATE(J),(HEFF(J,I),I=ISTA,IEND)
          END DO
        END DO
      END IF

C Diagonalize:
C Use a symmetrized matrix, in triangular storage:
      NUMAT=NSTATE**2
      NHTRI=(NUMAT+NSTATE)/2
      CALL GETMEM('UMAT','ALLO','REAL',LUMAT,NUMAT)
      CALL GETMEM('HTRI','ALLO','REAL',LHTRI,NHTRI)
      IJ=0
      DO I=1,NSTATE
        DO J=1,I
          IJ=IJ+1
          WORK(LHTRI-1+IJ)=0.5D0*(HEFF(I,J)+HEFF(J,I))
        END DO
      END DO
      IF(IPRGLB.GE.USUAL) THEN
        WRITE(6,*)
        WRITE(6,*)' Effective Hamiltonian matrix (Symmetric):'
        DO ISTA=1,NSTATE,5
          IEND=MIN(ISTA+4,NSTATE)
          WRITE(6,*)
          WRITE(6,'(1x,5I16)')(MSTATE(I),I=ISTA,IEND)
          DO I=ISTA,NSTATE
            II0=(I*(I-1))/2
            WRITE(6,'(1x,I3,3X,5F16.8)')
     &            MSTATE(I),(WORK(LHTRI-1+II0+J),J=ISTA,MIN(I,IEND))
          END DO
        END DO
      END IF
      CALL DCOPY_(NSTATE**2,[0.0D0],0,WORK(LUMAT),1)
      CALL DCOPY_(NSTATE,[1.0D0],0,WORK(LUMAT),NSTATE+1)
      CALL NIDiag(WORK(LHTRI),WORK(LUMAT),NSTATE,NSTATE)
      CALL JACORD(WORK(LHTRI),WORK(LUMAT),NSTATE,NSTATE)
      DO I=1,NSTATE
        ENERGY(I)=DSHIFT+WORK(LHTRI-1+(I*(I+1))/2)
        DO J=1,NSTATE
          EIGVEC(J,I)=WORK(LUMAT-1+J+NSTATE*(I-1))
        END DO
      END DO
      CALL GETMEM('UMAT','FREE','REAL',LUMAT,NUMAT)
      CALL GETMEM('HTRI','FREE','REAL',LHTRI,NHTRI)

      IF(IPRGLB.GE.TERSE) THEN
        If (IFRMS) Then
          variant = 'RMS'
        Else if (IFXMS.and.IFDW) then
          variant = 'XDW'
        Else if (IFXMS) then
          variant = 'XMS'
        Else if (IFDW) then
          variant = 'DW '
        Else
          variant = 'MS '
        End If
          WRITE(6,*)
          WRITE(6,'(6X,A,A)')' Total ',trim(variant)//
     &      '-CASPT2 energies:'
          DO I=1,NSTATE
            Call PrintResult(6,'(6x,A,I3,5X,A,F16.8)',trim(variant)//
     &      '-CASPT2 Root',I,'Total energy:',ENERGY(I),1)
          END DO
      END IF

      IF(IPRGLB.GE.USUAL) THEN
        WRITE(6,*)
        WRITE(6,'(6X,A)')' Eigenvectors:'
        DO ISTA=1,NSTATE,5
          IEND=MIN(ISTA+4,NSTATE)
          DO J=1,NSTATE
            WRITE(6,'(6x,5F16.8)')(EIGVEC(J,I),I=ISTA,IEND)
          END DO
          WRITE(6,*)
        END DO
        if (IFXMS.or.IFRMS) then
* Transform eigenvectors into the original input basis
          call mma_allocate(Utmp,Nstate,Nstate,Label='Utmp')
          call dgemm_('N','N',Nstate,Nstate,Nstate,
     &                1.0d0,U0,Nstate,eigvec,Nstate,
     &                0.0d0,Utmp,Nstate)
          WRITE(6,'(6X,A)')' In terms of the input states:'
          DO ISTA=1,NSTATE,5
            IEND=MIN(ISTA+4,NSTATE)
            DO J=1,NSTATE
              WRITE(6,'(6x,5F16.8)')(Utmp(J,I),I=ISTA,IEND)
            END DO
            WRITE(6,*)
          END DO
          call mma_deallocate(Utmp)
        end if
        CALL CollapseOutput(0,'Multi-State CASPT2 section:')
        WRITE(6,*)
      END IF

* Restore original effective Hamiltonian
      DO I=1,NSTATE
        HEFF(I,I)=HEFF(I,I)+DSHIFT
      END DO

* In automatic verification calculations, the precision is lower
* in case of Cholesky calculation.
      LAXITY=8
      IF(IfChol) LAXITY=Cho_X_GetTol(LAXITY)
      Call Add_Info('E_MSPT2',ENERGY,nState,LAXITY)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine DrvN2(Hess,nGrad)
************************************************************************
*                                                                      *
* Object: to compute the molecular gradient contribution due to the    *
*         nuclear repulsion energy.                                    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October 1991                                             *
*             Anders Bernhardsson, Dept. of Theoretical Chemistry,     *
*             University of Lund, SWEDEN                               *
*             September 1995                                           *
************************************************************************
      use Basis_Info
      use Center_Info
      use PCM_arrays
      use Symmetry_Info, only: nIrrep, iChTbl
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "disp.fh"
#include "disp2.fh"
#include "WrkSpc.fh"
#include "rctfld.fh"
      Real*8 A(3), B(3), RB(3), Hess(nGrad*(nGrad+1)/2),prmt(0:7),
     &       C(3), D(3), SD(3)
      Integer iDCRR(0:7),IndGrd(3,2,0:7),ii(2), iStb(0:7),jStb(0:7),
     &        iDCRS(0:7),IndHss(2,3,2,3,0:7),nop(2),kop(2)
      Logical EQ, TstFnc,TF, NoLoop
      Data Prmt/1.d0,-1.d0,-1.d0,1.d0,-1.d0,1.d0,1.d0,-1.d0/
*                                                                      *
************************************************************************
*                                                                      *
*     Statement Function
*
      xPrmt(i,j) = Prmt(iAnd(i,j))
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
      iTri(i1,i2)=Max(i1,i2)*(Max(i1,i2)-1)/2+Min(i1,i2)
*                                                                      *
************************************************************************
*                                                                      *
*
c     iRout = 33
c     iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the nuclear repulsion contributions                      *
*                                                                      *
************************************************************************
*                                                                      *
      nHess = nGrad*(nGrad+1)/2
      call dcopy_(nHess,[Zero],0,Hess,1)
*
      mdc = 0
*-----Loop over centers with the same change
      Do iCnttp = 1, nCnttp
       ZA = dbsc(iCnttp)%Charge
       If (ZA.eq.Zero) Go To 101
*--------Loop over all unique centers of this group
       Do 110 iCnt = 1, dbsc(iCnttp)%nCntr
        A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
*
         ndc = 0
         Do jCnttp = 1, iCnttp
           ZB=dbsc(jCnttp)%Charge
           If (ZB.eq.Zero) Go To 201
           ZAZB = ZA * ZB
           jCntMx = dbsc(jCnttp)%nCntr
           If (iCnttp.eq.jCnttp) jCntMx = iCnt
           Do jCnt = 1, jCntMx
             B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
*
             Fact = One
*                 Factor due to resticted summation
             If (EQ(A,B)) Fact = Half
*
*                 Find the DCR for the two centers
*
             Call DCR(LmbdR,dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,
     &                      dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                      iDCRR,nDCRR)
*
             PreFct = Fact*ZAZB*DBLE(nIrrep)/DBLE(LmbdR)
             Do iR = 0, nDCRR-1
               Call OA(iDCRR(iR),B,RB)
               nOp(1) = NrOpr(0)
               nOp(2) = NrOpr(iDCRR(iR))
               kop(1)=0
               kop(2)=iDCRR(iR)
               If (EQ(A,RB)) Go To 301
               r12 = Sqrt((A(1)-RB(1))**2 +
     &                    (A(2)-RB(2))**2 +
     &                    (A(3)-RB(3))**2 )
*
*              The factor u/g will ensure that the value of the
*              gradient in symmetry adapted and no symmetry basis
*              will have the same value.
*
               fab = One
               dfab=Zero
               ddfab=Zero
*
               If (dbsc(iCnttp)%ECP) Then
*-----------------Add contibution from M1 operator
                  Cnt0M1=Zero
                  Cnt1M1=Zero
                  Cnt2M1=Zero
                  Do iM1xp = 1, dbsc(iCnttp)%nM1
                     Gamma =dbsc(iCnttp)%M1xp(iM1xp)
                     CffM1 =dbsc(iCnttp)%M1cf(iM1xp)
                     Cnt0M1=Cnt0M1+(CffM1*Exp(-Gamma*r12**2))
                     Cnt1M1=Cnt1M1+Gamma*(CffM1*Exp(-Gamma*r12**2))
                     Cnt2M1=Cnt2M1+Gamma**2*(CffM1*Exp(-Gamma*r12**2))
                  End Do
                  fab=fab+Cnt0M1
                  dfab=dfab-Two*r12*Cnt1M1
                  ddfab=-Two*Cnt1M1+Four*r12**2*Cnt2M1
*-----------------Add contibution from M2 operator
                  Cnt0M2=Zero
                  Cnt1M2=Zero
                  Cnt2M2=Zero
                  Do iM2xp = 1, dbsc(iCnttp)%nM2
                     Gamma =dbsc(iCnttp)%M2xp(iM2xp)
                     CffM2 =dbsc(iCnttp)%M2cf(iM2xp)
                     Cnt0M2=Cnt0M2+(CffM2*Exp(-Gamma*r12**2))
                     Cnt1M2=Cnt1M2+Gamma*(CffM2*Exp(-Gamma*r12**2))
                     Cnt2M2=Cnt2M2+Gamma**2*(CffM2*Exp(-Gamma*r12**2))
                  End Do
                  fab=fab+r12*Cnt0M2
                  dfab=dfab+Cnt0M2-Two*r12**2*Cnt1M2
                  ddfab=ddfab-Six**r12*Cnt1M2+Four*r12*Three*Cnt2M2
               End If
               If (dbsc(jCnttp)%ECP) Then
*-----------------Add contibution from M1 operator
                  Cnt0M1=Zero
                  Cnt1M1=Zero
                  Cnt2M1=Zero
                  Do iM1xp = 1, dbsc(jCnttp)%nM1
                     Gamma =dbsc(jCnttp)%M1xp(iM1xp)
                     CffM1 =dbsc(jCnttp)%M1cf(iM1xp)
                     Cnt0M1=Cnt0M1+(CffM1*Exp(-Gamma*r12**2))
                     Cnt1M1=Cnt1M1+Gamma*(CffM1*Exp(-Gamma*r12**2))
                     Cnt2M1=Cnt2M1+Gamma**2*(CffM1*Exp(-Gamma*r12**2))
                  End Do
                  fab=fab+Cnt0M1
                  dfab=dfab-Two*r12*Cnt1M1
                  ddfab=-Two*Cnt1M1+Four*r12**2*Cnt2M1
*-----------------Add contibution from M2 operator
                  Cnt0M2=Zero
                  Cnt1M2=Zero
                  Cnt2M2=Zero
                  Do iM2xp = 1, dbsc(jCnttp)%nM2
                     Gamma =dbsc(jCnttp)%M2xp(iM2xp)
                     CffM2 =dbsc(jCnttp)%M2cf(iM2xp)
                     Cnt0M2=Cnt0M2+(CffM2*Exp(-Gamma*r12**2))
                     Cnt1M2=Cnt1M2+Gamma*(CffM2*Exp(-Gamma*r12**2))
                     Cnt2M2=Cnt2M2+Gamma**2*(CffM2*Exp(-Gamma*r12**2))
                  End Do
                  fab=fab+r12*Cnt0M2
                  dfab=dfab+Cnt0M2-Two*r12**2*Cnt1M2
                  ddfab=ddfab-Six**r12*Cnt1M2+Four*r12*Three*Cnt2M2
               End If
*
               df_dr=(dfab*r12-fab)/r12**2
               d2f_dr2= ( (ddfab*r12)   * r12**2
     &                  - (dfab*r12-fab)* Two*r12 ) / r12**4
*
               Call ICopy(nirrep*36,[0],0,Indhss,1)
               Call ICopy(nirrep*6,[0],0,indgrd,1)
*
*          Determine which displacement in all IR's, each center is *
*          associated with
*
               nnIrrep=nIrrep
               If (sIrrep) nnIrrep=1

               Do  iIrrep=0,nnIrrep-1
                 nDisp1 = IndDsp(mdc+iCnt,iIrrep)
                 nDisp2 = IndDsp(ndc+jCnt,iIrrep)
                 Do  iCar = 0,2
                   iComp = 2**iCar
                   If ( TF(mdc+iCnt,iIrrep,iComp)) Then
                     nDisp1 = nDisp1 + 1
                     IndGrd(iCar+1,1,iIrrep) = nDisp1
                   Else
                     IndGrd(iCar+1,1,iIrrep)=0
                   End If
                   iComp = 2**iCar
                   If ( TF(ndc+jCnt,iIrrep,iComp)) Then
                     nDisp2 = nDisp2 + 1
                     IndGrd(iCar+1,2,iIrrep) = nDisp2
                   Else
                     IndGrd(iCar+1,2,iIrrep)=0
                   End If
                 End Do ! iCar
               End Do   ! iIrrep
*
*          Determine index for each 2'nd derivative
*
*
           Do  iIrrep=0,nnIrrep-1
             Do iAtom=1,2
               Do iCar=1,3
                 Do jAtom=1,iAtom
                   jCar_Max=3
                   if (iAtom.eq.jAtom) jCar_Max=iCar
                   Do jCar=1,jCar_Max
                     If ((IndGrd(iCar,iAtom,iIrrep).gt.0) .and.
     &                   (IndGrd(jCar,jAtom,iIrrep).gt.0)) Then
*
                       IndHss(iAtom,iCar,jAtom,jCar,iIrrep)=
     &                  iTri(IndGrd(iCar,iAtom,iIrrep),
     &                       IndGrd(jCar,jAtom,iIrrep))
*
                     Else
*
                       IndHss(iAtom,iCar,jAtom,jCar,iIrrep)=0
*
                     End If
                   End Do ! jCar
                 End Do   ! jAtom
               End Do     ! iCar
             End Do       ! iAtom
           End Do         ! iIrrep
*
           ii(1)=dc(mdc+icnt)%nStab
           ii(2)=dc(ndc+jcnt)%nStab
*
           Do iIrrep=0,nnIrrep-1
             Do iCent=1,2
               Do jCent=1,iCent
                 Do  iCar = 1, 3
                   jCar_Max=3
                   If (iCent.eq.jCent) jCar_Max=iCar
                   Do  jCar=1,jCar_Max
                    iCh1=2**(iCar-1)
                    iCh2=2**(jCar-1)
                    g=DBLE(iChTbl(iIrrep,nOp(icent)))*
     &                    xPrmt(kOp(icent),iCh1)*
     &                    DBLE(ii(icent))/
     &                    DBLE(nIrrep)
                    g=g*DBLE(iChTbl(iIrrep,nOp(jcent)))*
     &                     xPrmt(kOp(jcent),iCh2)*
     &                     DBLE(ii(jcent))/
     &                     DBLE(nIrrep)
                    g=g*(-One)**(icent+jcent)
                    if ((iCent.ne.jCent).and.(iCar.eq.jCar).and.
     &               (Abs(indgrd(iCar,iCent,iIrrep)).eq.
     &                Abs(indgrd(jCar,jCent,iIrrep)))) Then
                      ps=Two
                    Else
                      ps=One
                    End if

                    Index=indHss(iCent,iCar,jCent,jCar,iIrrep)
                    If (index.ne.0) Then
                       dr_dAi=(A(iCar)-RB(iCar))/r12
                       dr_dAj=(A(jCar)-RB(jCar))/r12
                       d2r_dAidAj=-(A(iCar)-RB(iCar))*dr_dAj
                       If (iCar.eq.jCar) d2r_dAidAj=d2r_dAidAj+r12
                       d2r_dAidAj=d2r_dAidAj/r12**2
                       Hess(Index) = Hess(index)+ g*PreFct*ps
     &                             *(d2r_dAidAj*df_dr +
     &                               dr_dAi*dr_dAj*d2f_dr2)
                    End If
                   End Do ! jCar
                 End Do   ! iCar
               End Do     ! jCent
             End Do       ! iCent
           End Do         ! iIrrep
*
*          call triprt(' ',' ',Hess,ldisp(0))
 301       Continue
           End Do
*
               End Do
 201           Continue
               ndc = ndc + dbsc(jCnttp)%nCntr
            End Do
 110     Continue
 101     Continue
         mdc = mdc + dbsc(iCnttp)%nCntr
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     PCM contributions
*                                                                      *
************************************************************************
*                                                                      *
      If (PCM) Then
*
*     We will have three contributions here.
*                                                                      *
************************************************************************
*                                                                      *
*
*     1) Process the contribution
*
*        Sum(i) q_i V_in^xy
*
*---- Loop over tiles
*
*
      Do iTs = 1, nTs
         ZA   = PCM_SQ(1,iTs)+PCM_SQ(2,iTs)
         NoLoop = ZA.eq.Zero
         If (NoLoop) Go To 112
         ZA = ZA / DBLE(nIrrep)
         A(1:3) = PCMTess(1:3,iTs)
*
*------- Tile only stabilized by the unit operator
*
         nStb=1
         iStb(0)=0
*
         ndc = 0
         Do jCnttp = 1, nCnttp
            ZB = dbsc(jCnttp)%Charge
            If (ZB.eq.Zero) Go To 212
            If (dbsc(jCnttp)%pChrg) Go To 212
            If (dbsc(jCnttp)%Frag) Go To 212
            ZAZB = ZA * ZB
            Do jCnt = 1, dbsc(jCnttp)%nCntr
               B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
*
*              Find the DCR for the two centers
*
               Call DCR(LmbdR,iStb,nStb,
     &                        dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                        iDCRR,nDCRR)
*
               PreFct = ZAZB * DBLE(nIrrep)/DBLE(LmbdR)
               Do iR = 0, nDCRR-1
                  Call OA(iDCRR(iR),B,RB)
                  nOp(1) = NrOpr(0)
                  nOp(2) = NrOpr(iDCRR(iR))
                  r12 = Sqrt((A(1)-RB(1))**2 +
     &                       (A(2)-RB(2))**2 +
     &                       (A(3)-RB(3))**2 )
*
*                 The factor u/g will ensure that the value of the
*                 gradient in symmetry adapted and no symmetry basis
*                 will have the same value.
*
                  fab  =One
                  dfab =Zero
                  ddfab=Zero
                  If (dbsc(jCnttp)%ECP) Then
*--------------------Add contibution from M1 operator
                     Cnt0M1=Zero
                     Cnt1M1=Zero
                     Cnt2M1=Zero
                     Do iM1xp = 1, dbsc(jCnttp)%nM1
                        Gamma =dbsc(jCnttp)%M1xp(iM1xp)
                        CffM1 =dbsc(jCnttp)%M1cf(iM1xp)
                        Cnt0M1=Cnt0M1+(CffM1*Exp(-Gamma*r12**2))
                        Cnt1M1=Cnt1M1+Gamma*(CffM1*Exp(-Gamma*r12**2))
                        Cnt2M1=Cnt2M1
     &                        +Gamma**2*(CffM1*Exp(-Gamma*r12**2))
                     End Do
                     fab=fab+Cnt0M1
                     dfab=dfab-Two*r12*Cnt1M1
                     ddfab=-Two*Cnt1M1+Four*r12**2*Cnt2M1
*--------------------Add contibution from M2 operator
                     Cnt0M2=Zero
                     Cnt1M2=Zero
                     Cnt2M2=Zero
                     Do iM2xp = 1, dbsc(jCnttp)%nM2
                        Gamma =dbsc(jCnttp)%M2xp(iM2xp)
                        CffM2 =dbsc(jCnttp)%M2cf(iM2xp)
                        Cnt0M2=Cnt0M2+(CffM2*Exp(-Gamma*r12**2))
                        Cnt1M2=Cnt1M2+Gamma*(CffM2*Exp(-Gamma*r12**2))
                        Cnt2M2=Cnt2M2
     &                        +Gamma**2*(CffM2*Exp(-Gamma*r12**2))
                     End Do
                     fab=fab+r12*Cnt0M2
                     dfab=dfab+Cnt0M2-Two*r12**2*Cnt1M2
                     ddfab=ddfab-Six**r12*Cnt1M2+Four*r12*Three*Cnt2M2
                  End If
*
                  df_dr=(dfab*r12-fab)/r12**2
                  d2f_dr2= ( (ddfab*r12)   * r12**2
     &                     - (dfab*r12-fab)* Two*r12) / r12**4
*
               Call ICopy(nirrep*36,[0],0,Indhss,1)
               Call ICopy(nirrep*6,[0],0,indgrd,1)
*
*          Determine which displacement in all IRs, each center is *
*          associated with
*
               nnIrrep=nIrrep
               If (sIrrep) nnIrrep=1

               Do  iIrrep=0,nnIrrep-1
                 nDisp1 = IndDsp(ndc+jCnt,iIrrep)
                 Do  iCar = 0,2
                   iComp = 2**iCar
                   If ( TF(ndc+jCnt,iIrrep,iComp)) Then
                     nDisp1 = nDisp1 + 1
                     IndGrd(iCar+1,1,iIrrep) = nDisp1
                   Else
                     IndGrd(iCar+1,1,iIrrep)=0
                   End If
                 End Do ! iCar
               End Do   ! iIrrep
*
*          Determine index for each 2nd derivative
*
*          Note that each term is only associated with one basis
*          set center.
*
*
           iAtom=1
           jAtom=1
           Do  iIrrep=0,nnIrrep-1
             Do iCar=1,3
               jCar_Max=iCar
               Do jCar=1,jCar_Max
                 If ((IndGrd(iCar,iAtom,iIrrep).gt.0) .and.
     &               (IndGrd(jCar,jAtom,iIrrep).gt.0)) Then
*
                   IndHss(iAtom,iCar,jAtom,jCar,iIrrep)=
     &              iTri(IndGrd(iCar,iAtom,iIrrep),
     &                   IndGrd(jCar,jAtom,iIrrep))
*
                 Else
*
                   IndHss(iAtom,iCar,jAtom,jCar,iIrrep)=0
*
                 End If
               End Do ! jCar
             End Do     ! iCar
           End Do         ! iIrrep
*
           ii(1)=dc(ndc+jcnt)%nStab
*
           iCent=1
           jCent=1
           Do iIrrep=0,nnIrrep-1
              Do  iCar = 1, 3
                jCar_Max=iCar
                Do  jCar=1,jCar_Max
                 iCh1=2**(iCar-1)
                 iCh2=2**(jCar-1)
                 g=DBLE(iChTbl(iIrrep,nOp(icent)))*
     &                 xPrmt(kOp(icent),iCh1)*
     &                 DBLE(ii(icent))/
     &                 DBLE(nIrrep)
                 g=g*DBLE(iChTbl(iIrrep,nOp(jcent)))*
     &                  xPrmt(kOp(jcent),iCh2)*
     &                  DBLE(ii(jcent))/
     &                  DBLE(nIrrep)
                 g=g*(-One)**(icent+jcent)
*
                 Index=indHss(iCent,iCar,jCent,jCar,iIrrep)
                 If (Index.ne.0) Then
                    dr_dAi=(A(iCar)-RB(iCar))/r12
                    dr_dAj=(A(jCar)-RB(jCar))/r12
                    d2r_dAidAj=-(A(iCar)-RB(iCar))*dr_dAj
                    If (iCar.eq.jCar) d2r_dAidAj=d2r_dAidAj+r12
                    d2r_dAidAj=d2r_dAidAj/r12**2
                    Hess(Index) = Hess(Index)+ g*PreFct
     &                          *(d2r_dAidAj*df_dr +
     &                            dr_dAi*dr_dAj*d2f_dr2)
                 End If
                End Do ! jCar
              End Do   ! iCar
           End Do         ! iIrrep
*
*          Call TriPrt(' ',' ',Hess,ldisp(0))
*
               End Do      ! End loop over DCR operators, iR
*
            End Do         ! End over centers, jCnt
 212        Continue
            ndc = ndc + dbsc(jCnttp)%nCntr
         End Do            ! End over basis set types, jCnttp
 112     Continue
      End Do               ! End of tiles
*                                                                      *
************************************************************************
*                                                                      *
*     2) Process the contribution
*
*        Sum(i,j) V_i,n^x Q_ij V_j,n^y
*
      Do iTs = 1, nTs
         A(1:3) = PCMTess(1:3,iTs)
*
*------- Tile only stabilized by the unit operator
*
         nStb=1
         iStb(0)=0
*
      Do jTs = 1, iTs
         Fact=Two
         If (jTs.eq.iTs) Fact=One
         Q_ij = DMElm(nTs,iTs,jTs,PCMDM)
         NoLoop = Q_ij.eq.Zero
         If (NoLoop) Go To 122
         C(1:3) = PCMTess(1:3,jTs)
*
         mStb=1
         jStb(0)=0
*
*        Loop over the basis functions
*
         mdc = 0
         Do iCnttp = 1, nCnttp
            ZA = dbsc(iCnttp)%Charge
            If (ZA.eq.Zero) Go To 222
            If (dbsc(iCnttp)%pChrg) Go To 222
            If (dbsc(iCnttp)%Frag) Go To 222
*
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               B(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
*
*              Find the DCR for the two centers (
*
               Call DCR(LmbdR,iStb,nStb,
     &                        dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,
     &                        iDCRR,nDCRR)
*
               PreFct_AB = DBLE(nIrrep)/DBLE(LmbdR)
               Do iR = 0, nDCRR-1
                  Call OA(iDCRR(iR),B,RB)
                  nOp(1) = NrOpr(iDCRR(iR))
                  r12_AB = Sqrt((A(1)-RB(1))**2 +
     &                          (A(2)-RB(2))**2 +
     &                          (A(3)-RB(3))**2 )
                  fab  =One
                  dfab =Zero
                  If (dbsc(iCnttp)%ECP) Then
*--------------------Add contibution from M1 operator
                     Cnt0M1=Zero
                     Cnt1M1=Zero
                     Do iM1xp = 1, dbsc(iCnttp)%nM1
                        Gamma =dbsc(iCnttp)%M1xp(iM1xp)
                        CffM1 =dbsc(iCnttp)%M1cf(iM1xp)
                        Cnt0M1=Cnt0M1+(CffM1*Exp(-Gamma*r12_AB**2))
                        Cnt1M1=Cnt1M1
     &                        +Gamma*(CffM1*Exp(-Gamma*r12_AB**2))
                     End Do
                     fab=fab+Cnt0M1
                     dfab=dfab-Two*r12_AB*Cnt1M1
*--------------------Add contibution from M2 operator
                     Cnt0M2=Zero
                     Cnt1M2=Zero
                     Do iM2xp = 1, dbsc(iCnttp)%nM2
                        Gamma =dbsc(iCnttp)%M2xp(iM2xp)
                        CffM2 =dbsc(iCnttp)%M2cf(iM2xp)
                        Cnt0M2=Cnt0M2+(CffM2*Exp(-Gamma*r12_AB**2))
                        Cnt1M2=Cnt1M2
     &                        +Gamma*(CffM2*Exp(-Gamma*r12_AB**2))
                     End Do
                     fab=fab+r12_AB*Cnt0M2
                     dfab=dfab+Cnt0M2-Two*r12_AB**2*Cnt1M2
                  End If
                  df_dr_AB=(dfab*r12_AB-fab)/r12_AB**2
*
         ndc = 0
         Do jCnttp = 1, nCnttp
            ZB = dbsc(jCnttp)%Charge
            If (ZB.eq.Zero) Go To 232
            If (dbsc(jCnttp)%pChrg) Go To 232
            If (dbsc(jCnttp)%Frag) Go To 232
*
            Do jCnt = 1, dbsc(jCnttp)%nCntr
               D(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
*
*              Find the DCR for the two centers (
*
               Call DCR(LmbdS,iStb,nStb,
     &                        dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                        iDCRS,nDCRS)
*
               PreFct_CD = DBLE(nIrrep)/DBLE(LmbdS)
               Do iS = 0, nDCRS-1
                  Call OA(iDCRS(iS),D,SD)
                  nOp(2) = NrOpr(iDCRS(iS))
                  r12_CD = Sqrt((C(1)-SD(1))**2 +
     &                          (C(2)-SD(2))**2 +
     &                          (C(3)-SD(3))**2 )
*
                  fcd  =One
                  dfcd =Zero
                  If (dbsc(jCnttp)%ECP) Then
*--------------------Add contibution from M1 operator
                     Cnt0M1=Zero
                     Cnt1M1=Zero
                     Do iM1xp = 1, dbsc(jCnttp)%nM1
                        Gamma =dbsc(jCnttp)%M1xp(iM1xp)
                        CffM1 =dbsc(jCnttp)%M1cf(iM1xp)
                        Cnt0M1=Cnt0M1+(CffM1*Exp(-Gamma*r12_CD**2))
                        Cnt1M1=Cnt1M1
     &                        +Gamma*(CffM1*Exp(-Gamma*r12_CD**2))
                     End Do
                     fcd=fcd+Cnt0M1
                     dfcd=dfcd-Two*r12_CD*Cnt1M1
*--------------------Add contibution from M2 operator
                     Cnt0M2=Zero
                     Cnt1M2=Zero
                     Do iM2xp = 1, dbsc(jCnttp)%nM2
                        Gamma =dbsc(jCnttp)%M2xp(iM2xp)
                        CffM2 =dbsc(jCnttp)%M2cf(iM2xp)
                        Cnt0M2=Cnt0M2+(CffM2*Exp(-Gamma*r12_CD**2))
                        Cnt1M2=Cnt1M2
     &                        +Gamma*(CffM2*Exp(-Gamma*r12_CD**2))
                     End Do
                     fcd=fcd+r12_CD*Cnt0M2
                     dfcd=dfcd+Cnt0M2-Two*r12_CD**2*Cnt1M2
                  End If
                  df_dr_CD=(dfcd*r12_CD-fcd)/r12_CD**2
*
               Call ICopy(nirrep*36,[0],0,Indhss,1)
               Call ICopy(nirrep*6,[0],0,indgrd,1)
*
*          Determine which displacement in all IR's, each center is *
*          associated with
*
               nnIrrep=nIrrep
               If (sIrrep) nnIrrep=1

               Do  iIrrep=0,nnIrrep-1
                 nDisp1 = IndDsp(mdc+iCnt,iIrrep)
                 nDisp2 = IndDsp(ndc+jCnt,iIrrep)
                 Do  iCar = 0,2
                   iComp = 2**iCar
*
                   If ( TF(mdc+iCnt,iIrrep,iComp)) Then
                     nDisp1 = nDisp1 + 1
                     IndGrd(iCar+1,1,iIrrep) = nDisp1
                   Else
                     IndGrd(iCar+1,1,iIrrep)=0
                   End If
*
                   If ( TF(ndc+jCnt,iIrrep,iComp)) Then
                     nDisp2 = nDisp2 + 1
                     IndGrd(iCar+1,2,iIrrep) = nDisp2
                   Else
                     IndGrd(iCar+1,2,iIrrep)=0
                   End If
                 End Do ! iCar
               End Do   ! iIrrep
*
*          Determine index for each 2'nd derivative
*
*
           Do  iIrrep=0,nnIrrep-1
             Do iAtom=1,2
               Do iCar=1,3
                 Do jAtom=1,iAtom
                   jCar_Max=3
                   if (iAtom.eq.jAtom) jCar_Max=iCar
                   Do jCar=1,jCar_Max
                     If ((IndGrd(iCar,iAtom,iIrrep).gt.0) .and.
     &                   (IndGrd(jCar,jAtom,iIrrep).gt.0)) Then
*
                       IndHss(iAtom,iCar,jAtom,jCar,iIrrep)=
     &                  iTri(IndGrd(iCar,iAtom,iIrrep),
     &                       IndGrd(jCar,jAtom,iIrrep))
*
                     Else
*
                       IndHss(iAtom,iCar,jAtom,jCar,iIrrep)=0
*
                     End If
                   End Do ! jCar
                 End Do   ! jAtom
               End Do     ! iCar
             End Do       ! iAtom
           End Do         ! iIrrep
*
           ii(1)=dc(mdc+icnt)%nStab
           ii(2)=dc(ndc+jcnt)%nStab
*
*          Note that we have two different cases here, depending on if
*          iTs=jTs or not!
*          For iTs=jTs and iCent.eq.jCent we do
*          dV_i/dx*dV_i/dy only and exclude dV_i/dy*dV_i/dx since they
*          are the same. For iTs=/=jTs we need both dV_i/dx*dV_j/dy and
*          dV_i/dy*dV_j/dx.
*
           Do iIrrep=0,nnIrrep-1
             Do iCent=1,2
               Do jCent=1,iCent
                 Do  iCar = 1, 3
                   jCar_Max=3
                   If (iCent.eq.jCent.and.iTs.eq.jTs) jCar_Max=iCar
                   Do  jCar=1,jCar_Max
                    iCh1=2**(iCar-1)
                    iCh2=2**(jCar-1)
                    g=DBLE(iChTbl(iIrrep,nOp(icent)))*
     &                    xPrmt(kOp(icent),iCh1)*
     &                    DBLE(ii(icent))/
     &                    DBLE(nIrrep)
                    g=g*DBLE(iChTbl(iIrrep,nOp(jcent)))*
     &                     xPrmt(kOp(jcent),iCh2)*
     &                     DBLE(ii(jcent))/
     &                     DBLE(nIrrep)
                    g=g*(-One)**(icent+jcent)
*
                    If ((iCent.ne.jCent).and.(iCar.eq.jCar).and.
     &               (Abs(IndGrd(iCar,iCent,iIrrep)).eq.
     &                Abs(IndGrd(jCar,jCent,iIrrep)))) Then
                      ps=Two
                    Else
                      ps=One
                    End if

                    Index=IndHss(iCent,iCar,jCent,jCar,iIrrep)
                    If (Index.ne.0) Then
                       dr_dB=-(A(iCar)-RB(iCar))/r12_AB
                       dr_dD=-(C(jCar)-SD(jCar))/r12_CD
                       Hess(Index) = Hess(Index)
     &                             + Fact*g*ps
     &                             * ZA * ZA * Q_ij
     &                             * PreFct_AB * dr_dB * df_dr_AB
     &                             * PreFct_CD * dr_dD * df_dr_CD
                    End If
                   End Do ! jCar
                 End Do   ! iCar
               End Do     ! jCent
             End Do       ! iCent
           End Do         ! iIrrep
*
*          Call TriPrt(' ',' ',Hess,ldisp(0))
*
               End Do      ! iS
*
            End Do         ! jCnt
 232        Continue
            ndc = ndc + dbsc(jCnttp)%nCntr
         End Do            ! jCnttp
*
               End Do      ! iR
*
            End Do         ! iCnt
 222        Continue
            mdc = mdc + dbsc(iCnttp)%nCntr
         End Do            ! jCnttp
 122     Continue
      End Do               ! jTs
      End Do               ! iTs
*                                                                      *
************************************************************************
*                                                                      *
*       Add additional contributions
*
        nPCMHss = nGrad * nGrad
        Call Get_nAtoms_All(nAtoms)
        Call GetMem('PCM_Hss','Allo','Real',ip_pcmhss,nPCMHss)
        Call GetMem('Der1','Allo','Real',ip_Der1,nTs)
        Call GetMem('DerDM','Allo','Real',ip_DerDM,nTs*nTs)
        Call GetMem('Temp','Allo','Real',ip_Temp,nTs*nTs)
        Call Cav_Hss(nAtoms,nGrad,nTs,nS,Eps,PCMSph,
     &               PCMiSph,PCM_N,PCMTess,PCM_SQ,
     &               PCMDM,Work(ip_Der1),Work(ip_DerDM),Work(ip_Temp),
     &               dTes,DPnt,dRad,dCntr,Work(ip_pcmhss),nPCMHss)
        Call GetMem('PCM_Hss','Free','Real',ip_pcmhss,nPCMHss)
        Call GetMem('Der1','Free','Real',ip_Der1,nTs)
        Call GetMem('DerDM','Free','Real',ip_DerDM,nTs*nTs)
        Call GetMem('Temp','Free','Real',ip_Temp,nTs*nTs)
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Acore(iang,la,ishll,nordop,TC,A,Array,narr,Alpha,nalpha,fa1,fa2,jfgrad,jfhess,ld,debug)
! Calculates <A'|core> and <A"|core>
!
! @parameter iang Angular momenta for core
! @parameter la Angular momenta for bra
! @parameter ishll identification for core shell
! @parameter nordop order for operator
! @parameter TC Cartesian coordinates for core
! @parameter A Cartesian coordinates for bra
! @parameter Array Scratch
! @parameter narr size for scratch
! @parameter Alpha Bra exponents
! @parameter nalpha number of exponents
! @parameter FA1 First derivatives (out)
! @parameter FA2 2nd derivatives (out)
! @parameter jfgrad true for all 1-derivatives that are needed
! @parameter jfhess true for all 2-derivatives that are needed
! @parameter ld Order of derivatives
! @parameter debug guess

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: Shells
use Her_RW, only: HerR, HerW, iHerR, iHerW
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iang, la, ishll, nordop, narr, nalpha, ld
real(kind=wp), intent(in) :: TC(3), A(3), Alpha(nAlpha)
real(kind=wp), intent(_OUT_) :: Array(*), fa1(*)
real(kind=wp), intent(inout) :: fa2(*)
logical(kind=iwp), intent(in) :: jfgrad(3), jfhess(4,3,4,3), debug
integer(kind=iwp) :: i, iGamma, ip, ipA, ipAxyz, ipCxyz, ipK1, ipP1, ipQ1, ipRxyz, ipV, ipZ1, ipZI1, iStrt, n, nExpi, nHer, nVecAC
logical(kind=iwp) :: ABeq(3)
real(kind=r8), external :: DNrm2_

nExpi = Shells(iShll)%nExp
ip = 1
ipP1 = ip
ip = ip+3*nAlpha*nExpi
ipZ1 = ip
ip = ip+nAlpha*nExpi
ipK1 = ip
ip = ip+nAlpha*nExpi
ipZI1 = ip
ip = ip+nAlpha*nExpi
if (ip-1 > nArr) then
  write(u6,*) ' ip-1 > nArr in acore  (',ip,',',narr,')'
  call Abend()
end if

! Calculate Effective center and exponent for <A|core>

call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,nExpi,Alpha,Shells(iShll)%Exp)
call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))

! Calculate Overlap <A|core> and derivative <A'|core>

nHer = (la+1+iAng+1+ld)/2
ipAxyz = ip
ip = ip+nAlpha*nExpi*3*nHer*(la+1+ld)
ipCxyz = ip
ip = ip+nAlpha*nExpi*3*nHer*(iAng+1)
ipRxyz = ip
ip = ip+nAlpha*nExpi*3*nHer*(nOrdOp+1)
ipQ1 = ip
ip = ip+nAlpha*nExpi*3*(la+1+ld)*(iAng+1)*(nOrdOp+1)
ipA = ip
ip = ip+nAlpha*nExpi
if (ip-1 > nArr) then
  write(u6,*) '  ip-1 > nArr (1b) in acore (',ip,',',narr,')','Order',ld,Shells(ishll)%nExp,nalpha
  call Abend()
end if
ABeq(1) = A(1) == TC(1)
ABeq(2) = A(2) == TC(2)
ABeq(3) = A(3) == TC(3)
call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,A,Array(ipAxyz),la+ld,HerR(iHerR(nHer)),nHer,ABeq)
call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,TC,Array(ipCxyz),iAng,HerR(iHerR(nHer)),nHer,ABeq)
ABeq(1) = .false.
ABeq(2) = .false.
ABeq(3) = .false.
call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,A,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)
if (debug) then
  write(u6,*) ' nAlpha = ',nAlpha,' nExp(',ishll,')=',nExpi,' nHer=',nHer,' la=',la,' iAng=',iAng,' nOrdOp=',nOrdOp

  write(u6,*) ' Array(ipAxyz)=',DNrm2_(nAlpha*nExpi*3*nHer*(la+ld+1),Array(ipAxyz),1)
  write(u6,*) ' Array(ipCxyz)=',DNrm2_(nAlpha*nExpi*3*nHer*(iAng+1),Array(ipCxyz),1)
  write(u6,*) ' Array(ipRxyz)=',DNrm2_(nAlpha*nExpi*3*nHer*(nOrdOp+1),Array(ipRxyz),1)
end if

call Assmbl(Array(ipQ1),Array(ipAxyz),la+ld,Array(ipRxyz),nOrdOp,Array(ipCxyz),iAng,nAlpha*nExpi,HerW(iHerW(nHer)),nHer)
iStrt = ipA
do iGamma=1,nExpi
  Array(iStrt:iStrt+nAlpha-1) = Alpha
  iStrt = iStrt+nAlpha
end do
if (debug) then
  write(u6,*) ' Array(ipA)=',DNrm2_(nAlpha*nExpi,Array(ipA),1)
end if

call rKappa_Zeta(Array(ipK1),Array(ipZ1),nExpi*nAlpha)
call CmbnAC(Array(ipQ1),nAlpha*nExpi,la,iAng,Array(ipK1),FA1,Array(ipA),JfGrad,ld,nVecAC)
if (debug) then
  write(u6,*) 'nVecAC',nvecac
  write(u6,*) ' Array(ipQ1)=',DNrm2_(nAlpha*nExpi*3*(la+ld+1)*(iAng+1)*(nOrdOp+1),Array(ipQ1),1)
  write(u6,*) ' Array(ipA)=',DNrm2_(nAlpha*nExpi,Array(ipA),1)
  do i=1,nvecac
    ipV = 1
    n = nAlpha*nExpi*nTri_Elem1(la)*nTri_Elem1(iAng)
    write(u6,*) 'Cmbn(',i,')=',DNrm2_(n,FA1(ipV),1)
    ipV = ipV+n
  end do
end if

if (ld >= 2) then
  call CmbnS2a(Array(ipQ1),nAlpha*nExpi,la,iAng,Array(ipK1),FA2,Array(ipA),jfHess,ld)
  if (debug) then
    do i=1,6
      ipV = 1
      n = nAlpha*nExpi*nTri_Elem1(la)*nTri_Elem1(iAng)
      write(u6,*) 'Cmbn2(',i,')=',DNrm2_(n,FA2(ipV),1)
      ipV = ipV+n
    end do
  end if
end if

return

end subroutine Acore

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************

subroutine Kriging_Update(nQQ,iter,qInt,E_Disp)

use Slapaf_Info, only: BMx_kriging, Curvilinear, Degen, dqInt, dqInt_Aux, Energy, Energy0, Gx, Gx0, NAC, NADC
use Kriging_Mod, only: nSet
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nQQ, iter
real(kind=wp), intent(in) :: qInt(nQQ)
real(kind=wp), intent(out) :: E_Disp
integer(kind=iwp) :: nAtoms
real(kind=wp) :: Diff, Omega
real(kind=wp), allocatable :: Aux(:,:), Demp(:), Temp(:), vAux(:)

call mma_allocate(Temp,nSet,Label='Temp')
call mma_allocate(Demp,nSet,Label='Demp')
call mma_allocate(Aux,nQQ,nSet,Label='Aux')

!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt('Kriging_Update: qInt',' ',qInt,nQQ,1)
#endif

call Energy_Kriging_layer(qInt,Temp,nQQ)

call Dispersion_Kriging_Layer(qInt,Demp,nQQ)

call Gradient_Kriging_layer(qInt,Aux,nQQ)

#ifdef _DEBUGPRINT_
call RecPrt('Kriging_Update: Temp',' ',Temp,1,nSet)
call RecPrt('Kriging_Update: Demp',' ',Demp,1,nSet)
call RecPrt('Kriging_Update: Aux',' ',Aux,nQQ,nSet)
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
! Refold or undo the diabatization

if (nSet >= 2) then
  call mma_allocate(vAux,nQQ,Label='vAux')
  if ((nSet > 2) .and. NADC) then
    Diff = Half*(Temp(2)-Temp(1))
    Omega = atan2(Temp(3),Diff)
    ! energies and dispersion
    Temp(1) = Half*(Temp(1)+Temp(2))
    Demp(1) = Half*(Demp(1)+Demp(2))
    Temp(2) = Two*sqrt(Diff**2+Temp(3)**2)
    Temp(3) = Zero
    ! gradients
    vAux(:) = Half*(Aux(:,2)-Aux(:,1))
    Aux(:,1) = Half*(Aux(:,1)+Aux(:,2))
    Aux(:,2) = Two*(cos(Omega)*vAux+sin(Omega)*Aux(:,3))
    Aux(:,3) = -sin(Omega)*vAux+cos(Omega)*Aux(:,3)
  else
    ! energies and dispersion
    Diff = Temp(1)-Temp(2)
    Temp(1) = Half*(Temp(1)+Temp(2))
    Temp(2) = Diff
    Demp(1) = Half*(Demp(1)+Demp(2))
    Demp(2) = Demp(1)
    ! gradients
    vAux(:) = Aux(:,1)-Aux(:,2)
    Aux(:,1) = Half*(Aux(:,1)+Aux(:,2))
    Aux(:,2) = vAux
  end if
  call mma_deallocate(vAux)
end if

!                                                                      *
!***********************************************************************
!                                                                      *

Energy(iter) = Temp(1)

E_Disp = Demp(1)

dqInt(:,iter) = -Aux(:,1)

!                                                                      *
!***********************************************************************
!                                                                      *
!  For the energy difference

if (nSet > 1) then

  Energy0(iter) = Temp(2)

  ! Right now we do not use the dispersion for the additional surfaces

  dqInt_Aux(:,iter,1) = -Aux(:,2)

  ! The computation of the gradients of the constraints is always done in
  ! Cartesian coordinates. The GEK, however, predicts them in internal coordinates.
  ! Thus, we need to transfrom the GEK predicted gradients to Cartesian and put
  ! them at the place where the code to compute the value and the Cartesian gradient
  ! can find them, that is, in Gx, Gx0

  ! dE/dx = dq/dx dE/dq

  nAtoms = size(Gx0,2)

  call DGEMM_('N','N',3*nAtoms,1,nQQ,One,BMx_kriging,3*nAtoms,dqInt(:,iter),nQQ,Zero,Gx(:,:,iter),3*nAtoms)
  call DGEMM_('N','N',3*nAtoms,1,nQQ,One,BMx_kriging,3*nAtoms,dqInt_Aux(:,iter,1),nQQ,Zero,Gx0(:,:,iter),3*nAtoms)

  ! Modify with degeneracy factors.

  if (Curvilinear) then
    Gx(:,:,iter) = Gx(:,:,iter)/Degen(:,:)
    Gx0(:,:,iter) = Gx0(:,:,iter)/Degen(:,:)
  end if

  if (nSet > 2) then
    dqInt_Aux(:,iter,2) = Aux(:,3)
    call DGEMM_('N','N',3*nAtoms,1,nQQ,One,BMx_kriging,3*nAtoms,dqInt_Aux(:,iter,2),nQQ,Zero,NAC(:,:,iter),3*nAtoms)
    if (Curvilinear) NAC(:,:,iter) = NAC(:,:,iter)/Degen(:,:)
  end if

end if

call mma_deallocate(Temp)
call mma_deallocate(Demp)
call mma_deallocate(Aux)

end subroutine Kriging_Update

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Jeppe Olsen                                      *
************************************************************************
* Note pt. CC calculations can be restarted from CI
* calculations in the same space by specifying CI=>CC.
* This requires that the input CI vector and the CC
* vector is in the same space. It would be
* better to do the reformatting after the CI.
*
* One can then do f.ex a partial CISDTQ to initialize the
* CCSD.
*
* It would be
*
* Lucia.f : GAS implementing no pair relativistic Theory
*
* Version of March 2000 , Jeppe Olsen
*
      SUBROUTINE ZERORC(MBLOCK,IFIL,IAMPACKED)
*
* A record was known to be identical  zero
*
* Write corresponding info to file IFIL
*
* IAMPACKED added Oct. 98 / Jeppe Olsen
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER ISCR(2)
* Zero record
      ISCR(1) = 1
*. Packed form
      ISCR(2) = IAMPACKED
*
      CALL ITODS(ISCR,2,2,IFIL)
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(MBLOCK)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FndTess(iPrint,Xs,Ys,Zs,Rs,pNs,m)

use PCM_arrays, only: Centr, IntSph, MxSph, MxTs, MxVert, NewSph, NVert, PCM_N, PCMDM, PCMiSph, PCMSph, PCMTess, PCMTess, SSph, Vert
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Half, Angstrom, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, m, pNs(m)
real(kind=wp), intent(inout) :: Xs(m), Ys(m), Zs(m), Rs(m)
integer(kind=iwp) :: I, II, IPFlag, IPtype, iTs, iTsNum, ITsEff, ITYPC, J, K, KG, KP, N1, N2, N3, NE, NES, NET, NEV, NN, NN1, &
                     nPCM_info_i, nPCM_info_r, NSFE, NV
real(kind=wp) :: AREA, COSOM2, FC, FC1, Fro, HH, Omega, PP(3), PROD, R2GN, REG, REG2, REGD2, REN, REND2, REO, REO2, REP, REP2, &
                 REPD2, Ret, RGN, RIJ, RIJ2, RIK, RIK2, RJD, RJK, RJK2, RTDD, RTDD2, Scav, SENOM, SP, TEST, TEST1, TEST2, TEST3, &
                 TEST7, TEST8, TsAre, VCav, XEN, XI, XJ, XN, YEN, YI, YJ, YN, ZEN, ZI, ZJ, ZN
logical(kind=iwp) :: FIRST
integer(kind=iwp), allocatable :: JTR(:,:), pIntS(:,:), pISph(:), pNewS(:,:), pNVert(:)
real(kind=wp), allocatable :: At(:), CCC(:,:), CV(:,:), pCentr(:,:,:), pSSph(:), PTS(:,:), pVert(:,:,:), Xt(:), Yt(:), Zt(:)
#include "rctfld.fh"
#include "status.fh"

! Definition of solute cavity and computation of vertices,
! representative points and surfaces of the tesserae by the
! Gauss-Bonnet Theorem.

! Allocate space for X, Y, Z, Area, pISph (index of sphere to which
! tessera belongs); then allocate space for IntSph (indices of spheres
! cutting the tessera), pNewS (indices of spheres creating new smoothing
! spheres), SSph (surface of each sphere exposed to the solvent),
! Finally, allocate temporary space for NVert (number of vertices for
! any tessera), Vert (coordinates of vertices), Centr (center of arcs).

call mma_allocate(Xt,MxTs,Label='Xt')
call mma_allocate(Yt,MxTs,Label='Yt')
call mma_allocate(Zt,MxTs,Label='Zt')
call mma_allocate(At,MxTs,Label='At')
call mma_allocate(pVert,3,MxVert,MxTs,Label='pVert')
call mma_allocate(pCentr,3,MxVert,MxTs,Label='pCentr')
call mma_allocate(pSSph,MxSph,Label='pSSph')
call mma_allocate(CV,3,MxSph,Label='CV')

call mma_allocate(JTR,3,MxTs,Label='JTR')
call mma_allocate(pISph,MxTs,Label='pIShp')
call mma_allocate(pNVert,MxTs,Label='pNVert')
call mma_allocate(pIntS,MxVert,MxTs,Label='pIntS')
call mma_allocate(pNewS,2,MxSph,Label='pNewS')

Omega = RSlPar(2)
Ret = RSlPar(3)
Fro = RSlPar(4)
TsAre = RSlPar(7)
RSolv = RSlPar(19)
ITsNum = ISlPar(11)

! PEDRA works with Angstroms
NS = NSinit
Xs(1:NS) = Xs(1:NS)*Angstrom
Ys(1:NS) = Ys(1:NS)*Angstrom
Zs(1:NS) = Zs(1:NS)*Angstrom
if (IPRINT == 2) write(u6,800)

! creation of new spheres

pNewS(:,1:NS) = 0
ITYPC = 0
OMEGA = OMEGA*DEG2RAD
SENOM = sin(OMEGA)
COSOM2 = (cos(OMEGA))**2
RTDD = RET+RSOLV
RTDD2 = RTDD*RTDD
NET = NS
NN = 2
NE = NET-1 ! just to get the loop started
NEV = NS
FIRST = .true.
do while (NET /= NE)
  if (FIRST) then
    NE = NS
    FIRST = .false.
  else
    NN = NE+1
    NE = NET
    if (NE > MxSph) then
      write(u6,1111)
      call Abend()
    end if
  end if
  do I=NN,NE
    NES = I-1
    middle: do J=1,NES
      RIJ2 = (Xs(I)-Xs(J))**2+(Ys(I)-Ys(J))**2+(Zs(I)-Zs(J))**2
      RIJ = sqrt(RIJ2)
      RJD = Rs(J)+RSOLV
      TEST1 = Rs(I)+RJD+RSOLV
      if (RIJ >= TEST1) cycle middle
      REG = max(Rs(I),Rs(J))
      REP = min(Rs(I),Rs(J))
      REG2 = REG*REG
      REP2 = REP*REP
      TEST2 = REP*SENOM+sqrt(REG2-REP2*COSOM2)
      if (RIJ <= TEST2) cycle middle
      REGD2 = (REG+RSOLV)*(REG+RSOLV)
      TEST3 = (REGD2+REG2-RTDD2)/REG
      if (RIJ >= TEST3) cycle middle
      do K=1,NEV
        if ((K == J) .or. (K == I)) cycle
        RJK2 = (Xs(J)-Xs(K))**2+(Ys(J)-Ys(K))**2+(Zs(J)-Zs(K))**2
        if (RJK2 >= RIJ2) cycle
        RIK2 = (Xs(I)-Xs(K))**2+(Ys(I)-Ys(K))**2+(Zs(I)-Zs(K))**2
        if (RIK2 >= RIJ2) cycle
        RJK = sqrt(RJK2)
        RIK = sqrt(RIK2)
        SP = (RIJ+RJK+RIK)*Half
        HH = 4*(SP*(SP-RIJ)*(SP-RIK)*(SP-RJK))/RIJ2
        REO = Rs(K)*FRO
        if (K >= NE) REO = 2.0e-4_wp
        REO2 = REO*REO
        if (HH < REO2) cycle middle
      end do
      REPD2 = (REP+RSOLV)**2
      TEST8 = sqrt(REPD2-RTDD2)+sqrt(REGD2-RTDD2)
      if (RIJ <= TEST8) then
        R2GN = RIJ-REP+REG
        RGN = R2GN*Half
        FC = R2GN/(RIJ+REP-REG)
        REN = sqrt(REGD2+RGN*(RGN-(REGD2+RIJ2-REPD2)/RIJ))-RSOLV
      else
        REND2 = REGD2+REG2-(REG/RIJ)*(REGD2+RIJ2-REPD2)
        if (REND2 <= RTDD2) cycle middle
        REN = sqrt(REND2)-RSOLV
        FC = REG/(RIJ-REG)
        ITYPC = 1
      end if
      FC1 = FC+One
      TEST7 = REG-Rs(I)
      if (TEST7 <= 1.0e-9_wp) then
        KG = I
        KP = J
      else
        KG = J
        KP = I
      end if
      XEN = (Xs(KG)+FC*Xs(KP))/FC1
      YEN = (Ys(KG)+FC*Ys(KP))/FC1
      ZEN = (Zs(KG)+FC*Zs(KP))/FC1
      NET = NET+1
      Xs(NET) = XEN
      Ys(NET) = YEN
      Zs(NET) = ZEN
      Rs(NET) = REN

      ! Nella matrice pNewS(2,NS) sono memorizzati i numeri delle
      ! sfere "generatrici" della nuova sfera NET: se la nuova sfera e'
      ! del tipo A o B entrambi i numeri sono positivi, se e' di tipo
      ! C il numero della sfera "principale" e' negativo
      ! (per la definizione del tipo si veda JCC 11, 1047 (1990))

      if (ITYPC == 0) then
        pNewS(1,NET) = KG
        pNewS(2,NET) = KP
      else if (ITYPC == 1) then
        pNewS(1,NET) = -KG
        pNewS(2,NET) = KP
      end if

    end do middle
    NEV = NET
  end do
  if (NET == NE) exit
end do
NS = NET

! Division of the surface into tesserae

VCav = ZERO
Scav = ZERO

! Controlla se ciascuna tessera e' scoperta o va tagliata

call mma_allocate(CCC,3,MxVert,Label='CCC')
call mma_allocate(PTS,3,MxVert,Label='PTS')

NN1 = 0
do NSFE=1,NS
  XEN = Xs(NSFE)
  YEN = Ys(NSFE)
  ZEN = Zs(NSFE)
  REN = Rs(NSFE)
  if ((ITsNum == 0) .and. (TsAre == Zero)) then
    IPtype = 2
    IPFlag = 0
    ITsNum = 60
  else if ((ITsNum > 0) .and. (TsAre == Zero)) then
    IPFlag = 0
  else if (TsAre > Zero) then
    IPFlag = 1
  end if
  call PolyGen(MxTs,MxSph,IPtype,IPflag,TsAre,ITsNum,XEN,YEN,ZEN,REN,ITsEff,CV,JTR)
  do ITS=1,ITsEff
    N1 = JTR(1,ITS)
    N2 = JTR(2,ITS)
    N3 = JTR(3,ITS)
    PTS(:,1) = CV(:,N1)
    PTS(:,2) = CV(:,N2)
    PTS(:,3) = CV(:,N3)
    NV = 3
    PP(:) = ZERO

    ! Per ciascuna tessera, trova la porzione scoperta e ne
    ! calcola l'area con il teorema di Gauss-Bonnet; il punto
    ! rappresentativo e' definito come media dei vertici della porzione
    ! scoperta di tessera e passato in PP.
    ! I vertici di ciascuna tessera sono conservati in
    ! pVERT(3,MxVert,MxTs), il numero di vertici di ciascuna tessera e'
    ! in pNVERT(MxTs), e i centri dei cerchi di ciascun lato sono in
    ! pCENTR(3,MxVert,MxTs). In pIntS(MxVert,MxTs) sono registrate le
    ! sfere a cui appartengono i lati delle tessere.

    call TESSERA(iPrint,NS,NSFE,NV,Xs,Ys,Zs,Rs,pIntS(:,MxTs),PTS,CCC,PP,AREA)
    if (AREA == Zero) cycle
    NN1 = NN1+1
    NN = min(NN1,MxTs)
    Xt(NN) = PP(1)
    Yt(NN) = PP(2)
    Zt(NN) = PP(3)
    At(NN) = AREA

    pISph(NN) = NSFE
    pNVERT(NN) = NV
    pVERT(:,1:NV,NN) = PTS(:,1:NV)
    pCENTR(:,1:NV,NN) = CCC(:,1:NV)
    pIntS(1:NV,NN) = pIntS(1:NV,MxTs)
  end do
end do
NTS = NN

call mma_deallocate(CCC)
call mma_deallocate(PTS)

! Verifica se due tessere sono troppo vicine
TEST = 0.02_wp
TEST2 = TEST*TEST
do I=1,NTS-1
  if (At(I) == ZERO) cycle
  XI = Xt(I)
  YI = Yt(I)
  ZI = Zt(I)
  II = I+1
  do J=II,NTS
    if (pISph(I) == pISph(J)) cycle
    if (At(J) == ZERO) cycle
    XJ = Xt(J)
    YJ = Yt(J)
    ZJ = Zt(J)
    RIJ = (XI-XJ)**2+(YI-YJ)**2+(ZI-ZJ)**2
    if (RIJ > TEST2) cycle

    ! La routine originaria sostituiva le due tessere troppo vicine con una
    ! sola tessera. Nel caso Gauss-Bonnet, anche i vertici delle tessere
    ! e i centri degli archi vengono memorizzati ed e' impossibile sostituirli
    ! nello stesso modo: percio' l'area della tessera piu' piccola verra'
    ! trascurata per evitare problemi nella autopolarizzazione.
    if (IPRINT == 2) write(u6,1000) I,J,TEST2
    if (At(I) < At(J)) At(I) = ZERO
    if (At(I) >= At(J)) At(J) = ZERO
  end do
end do

! E' preferibile eliminare del tutto le tessere che per
! qualche motivo hanno AREA = 0, ridefinendo tutti gli
! indici: l'errore numerico cosi' introdotto e' in genere
! trascurabile e si evitano problemi di convergenza

! Define here the number of tesserae in electrostatic calculations
! to avoid problems in successive calcn.
ITS = 0
do while (ITS < NTS)
  ITS = ITS+1
  if (At(ITS) < 1.0e-10_wp) then
    do I=ITS,NTS-1
      At(I) = At(I+1)
      Xt(I) = Xt(I+1)
      Yt(I) = Yt(I+1)
      Zt(I) = Zt(I+1)
      pISph(I) = pISph(I+1)
      pNVERT(I) = pNVERT(I+1)
      pVERT(:,:,I) = pVERT(:,:,I+1)
      pCENTR(:,:,I) = pCENTR(:,:,I+1)
      pIntS(:,I) = pIntS(:,I+1)
    end do
    NTS = NTS-1
    ITS = ITS-1
  end if
end do
!***********************************************************************
! Calcola il volume della cavita' con la formula (t. di Gauss):
!            V=SOMMAsulleTESSERE{A r*n}/3
! dove r e' la distanza del punto rappresentativo dall'origine,
! n e' il versore normale alla tessera, A l'area della tessera,
! e * indica il prodotto scalare.
!***********************************************************************
VCav = ZERO
do ITS=1,NTS
  NSFE = pISph(ITS)
  ! Trova il versore normale
  XN = (Xt(ITS)-Xs(NSFE))/Rs(NSFE)
  YN = (Yt(ITS)-Ys(NSFE))/Rs(NSFE)
  ZN = (Zt(ITS)-Zs(NSFE))/Rs(NSFE)
  ! Trova il prodotto scalare
  PROD = Xt(ITS)*XN+Yt(ITS)*YN+Zt(ITS)*ZN
  VCav = VCav+At(ITS)*PROD/Three
end do
!***********************************************************************
! Stampa la geometria della cavita'
Scav = ZERO
pSSph(1:NS) = ZERO
do I=1,NTS
  K = pISph(I)
  pSSph(K) = pSSph(K)+At(I)
end do
OMEGA = OMEGA/DEG2RAD
if (IPRINT == 2) write(u6,1100) OMEGA,RSOLV,RET,FRO,NS
do I=1,NS
  if (IPRINT == 2) write(u6,1200) I,Xs(I),Ys(I),Zs(I),Rs(I),pSSph(I)
  Scav = Scav+pSSph(I)
end do
if (IPRINT == 2) write(u6,1300) NTS,Scav,VCav

! Trasforma i risultati in bohr
Rs(1:NS) = Rs(1:NS)/Angstrom
Xs(1:NS) = Xs(1:NS)/Angstrom
Ys(1:NS) = Ys(1:NS)/Angstrom
Zs(1:NS) = Zs(1:NS)/Angstrom
do I=1,NTS
  pVERT(:,1:pNVERT(I),I) = pVERT(:,1:pNVERT(I),I)/Angstrom
  pCENTR(:,1:pNVERT(I),I) = pCENTR(:,1:pNVERT(I),I)/Angstrom
end do
At(1:NTS) = At(1:NTS)/(Angstrom*Angstrom)
Xt(1:NTS) = Xt(1:NTS)/Angstrom
Yt(1:NTS) = Yt(1:NTS)/Angstrom
Zt(1:NTS) = Zt(1:NTS)/Angstrom
if (IPRINT == 3) then
  write(u6,1500)
  write(u6,1600)
  write(u6,1700) (I,pISph(I),At(I),Xt(I),Yt(I),Zt(I),I=1,NTS)
end if
if (NN1 > MxTs) then
  write(u6,1240) NN1,MxTs
  write(u6,1112)
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Re-allocate with actual dimensioning
if (RctFld_Status /= Active) then

  ! Allocate PCM arrays
  call mma_allocate(PCMSph,4,NS,Label='PCMSph')
  call mma_allocate(PCMTess,4,nTs,Label='PCMTess')
  call mma_allocate(Vert,3,MxVert,nTs,Label='Vert')
  call mma_allocate(Centr,3,MxVert,nTs,Label='Centr')
  call mma_allocate(SSph,NS,Label='SSph')
  call mma_allocate(PCMDM,nTs,nTs,Label='PCMDM')
  call mma_allocate(PCM_N,NS,Label='PCM_N')
  call mma_allocate(PCMiSph,nTs,Label='PCMiSph')
  call mma_allocate(NVert,nTs,Label='NVert')
  call mma_allocate(IntSph,MxVert,nTs,Label='IntSph')
  call mma_allocate(NewSph,2,NS,Label='NewSph')

  nPCM_info_r = 4*NS+4*nTs+3*MxVert*nTs+3*MxVert*nTs+NS+nTs**2
  nPCM_info_i = NS+nTs+nTs+MxVert*nTs+2*NS+nTs**2
  nPCM_info = nPCM_info_r+nPCM_info_i

end if

! PCMSph
PCMSph(1,:) = Xs(1:NS)
PCMSph(2,:) = Ys(1:NS)
PCMSph(3,:) = Zs(1:NS)
PCMSph(4,:) = Rs(1:NS)

! PCMTess
PCMTess(1,:) = Xt(1:nTs)
PCMTess(2,:) = Yt(1:nTs)
PCMTess(3,:) = Zt(1:nTs)
PCMTess(4,:) = At(1:nTs)

! Vert
Vert(:,:,:) = pVert(:,:,1:nTs)

! Centr
Centr(:,:,:) = pCentr(:,:,1:nTs)

! SSph
SSph(:) = pSSph(1:NS)

! nOrd
PCM_N(:) = pNs(1:NS)

! ISph
PCMiSph(:) = pISph(1:nTs)

! NVert
NVert(:) = pNVert(1:nTs)

! IntSph
IntSph(:,:) = pIntS(:,1:nTs)

! NewSph
NewSph(:,:) = pNewS(:,1:NS)
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate temporary memory

call mma_deallocate(pNewS)
call mma_deallocate(pIntS)
call mma_deallocate(pNVert)
call mma_deallocate(pISph)
call mma_deallocate(JTR)
call mma_deallocate(CV)
call mma_deallocate(pSSPh)
call mma_deallocate(pCentr)
call mma_deallocate(pVert)
call mma_deallocate(At)
call mma_deallocate(Zt)
call mma_deallocate(Yt)
call mma_deallocate(Xt)
!                                                                      *
!***********************************************************************
!                                                                      *
return

800 format(/,'**** POLARISABLE CONTINUUM MODEL - UNIVERSITIES OF NAPLES AND PISA *****')
1000 format(/,'ATTENZIONE: I CENTRI DELLE TESSERE ',I4,',',I4,' DISTANO MENO DI',F8.6,' A',/)
1100 format(/,'** CHARACTERISTICS OF THE CAVITY **',//,'  GEOMETRICAL PARAMETERS: OMEGA=',F8.3,' RSOLV=',F8.3,' RET=',F8.3, &
            ' FRO=',F8.3,//,'  TOTAL NUMBER OF SPHERES',I5,//,'  CENTERS AND RADII :',//, &
            '  SPHERE       CENTER  (X,Y,Z) (A)     RADIUS (A)','       AREA(A*A)')
1111 format(' Cavity: too many spheres; increase Omega')
1112 format('Too many tesserae.')
!1200 format(I5,4F15.9,F18.9)
1200 format(I5,4F10.3,F18.3)
1240 format(' NN1=',I10,' but MxTs=',I10,'.')
1300 format(/,' TOTAL NUMBER OF TESSERAE ',I8,//,' SURFACE AREA',F14.8,'(A**2)',8X,'CAVITY VOLUME',F14.8,' (A**3)')
!1400 format(/,'SFERA',I4,' COORD.',I4,'  DERIVATA   ',F10.6,/)
1500 format('1 *** SUDDIVISIONE DELLA SUPERFICIE  ***')
1600 format(' TESSERA  SFERA   AREA   X Y Z CENTRO TESSERA  X Y Z PUNTO NORMALE')
1700 format(2I4,7F12.7)
!1800 format(/,'**** END OF CAVITY DEFINITION ****',/)

end subroutine FndTess

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1973, Nelson H. F. Beebe                               *
!***********************************************************************

subroutine CHO_OUTPAK(AMATRX,NROW,NCTL,LUPRI)
!.......................................................................
!
! OUTPAK PRINTS A REAL SYMMETRIC MATRIX STORED IN ROW-PACKED LOWER
!
! TRIANGULAR FORM (SEE DIAGRAM BELOW) IN FORMATTED FORM WITH NUMBERED
!
! ROWS AND COLUMNS.  THE INPUT IS AS FOLLOWS:
!
!        AMATRX(*)...........PACKED MATRIX
!
!        NROW................NUMBER OF ROWS TO BE OUTPUT
!
!        NCTL................CARRIAGE CONTROL FLAG: 1 FOR SINGLE SPACE,
!                                                   2 FOR DOUBLE SPACE,
!                                                   3 FOR TRIPLE SPACE.
!
! THE MATRIX ELEMENTS ARE ARRANGED IN STORAGE AS FOLLOWS:
!
!        1
!        2    3
!        4    5    6
!        7    8    9   10
!       11   12   13   14   15
!       16   17   18   19   20   21
!       22   23   24   25   26   27   28
!       AND SO ON.
!
! OUTPAK IS SET UP TO HANDLE 6 COLUMNS/PAGE WITH A 6F20.14 FORMAT
! FOR THE COLUMNS.  IF A DIFFERENT NUMBER OF COLUMNS IS REQUIRED, CHANGE
! FORMATS 1000 AND 2000, AND INITIALIZE KCOL WITH THE NEW NUMBER OF
! COLUMNS.
!
! AUTHOR:  NELSON H.F. BEEBE, QUANTUM THEORY PROJECT, UNIVERSITY OF
!          FLORIDA, GAINESVILLE
!..........VERSION = 09/05/73/03
!.......................................................................

use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: AMATRX(*)
integer(kind=iwp), intent(in) :: NROW, NCTL, LUPRI
integer(kind=iwp) :: BEGIN, I, J, K, KCOL, KTOTAL, LAST, MCTL, NCOL
real(kind=wp) :: AMAX
character(len=20) :: PFMT
character :: CTL
integer(kind=iwp), parameter :: KCOLN = 6, KCOLP = 4
real(kind=wp), parameter :: FFMAX = 1.0e3_wp, FFMIN = 1.0e-3_wp
character(len=*), parameter :: ASA(3) = [' ','0','-'], BLNK = ' ', COLUMN = 'Column  '

if (NCTL < 0) then
  KCOL = KCOLN
else
  KCOL = KCOLP
end if
MCTL = abs(NCTL)
if ((MCTL <= 3) .and. (MCTL > 0)) then
  CTL = ASA(MCTL)
else
  CTL = BLNK
end if

J = nTri_Elem(NROW)
AMAX = Zero
do I=1,J
  AMAX = max(AMAX,abs(AMATRX(I)))
end do
if (AMAX == Zero) then
  write(LUPRI,'(/T6,A)') 'Zero matrix.'
else
  if ((FFMIN <= AMAX) .and. (AMAX <= FFMAX)) then
    ! use F output format
    PFMT = '(A1,I7,2X,8F15.8)'
  else
    ! use ES output format
    PFMT = '(A1,I7,2X,8ES15.6)'
  end if

  ! LAST IS THE LAST COLUMN NUMBER IN THE ROW CURRENTLY BEING PRINTED

  LAST = min(NROW,KCOL)

  ! BEGIN IS THE FIRST COLUMN NUMBER IN THE ROW CURRENTLY BEING PRINTED.

  !.....BEGIN NON STANDARD DO LOOP.
  BEGIN = 1
  do
    NCOL = 1
    write(LUPRI,1000) (COLUMN,I,I=BEGIN,LAST)
    do K=BEGIN,NROW
      KTOTAL = nTri_Elem(K-1)+BEGIN-1
      do I=1,NCOL
        if (AMATRX(KTOTAL+I) /= Zero) then
          write(LUPRI,PFMT) CTL,K,(AMATRX(J+KTOTAL),J=1,NCOL)
          exit
        end if
      end do
      if (K < (BEGIN+KCOL-1)) NCOL = NCOL+1
    end do
    LAST = min(LAST+KCOL,NROW)
    BEGIN = BEGIN+NCOL
    if (BEGIN > NROW) exit
  end do
end if

return

1000 format(/12X,6(3X,A6,I4,2X),(3X,A6,I4))
!2000 format(A1,'Row',I4,2X,8ES15.6)
!2000 format(A1,I7,2X,8ES15.6)

end subroutine CHO_OUTPAK

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine Get_Info_Static()
************************************************************************
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January 1992                                             *
************************************************************************
      use Symmetry_Info, only: Symmetry_Info_Get
      use Sizes_of_Seward, only: Size_Get
      use DKH_Info, only: DKH_Info_Get
      use Real_Info, only: Real_Info_Get
      use RICD_Info, only: RICD_Info_Get
      use Logical_Info, only: Logical_Info_Get

      Call Symmetry_Info_Get()
      Call Size_Get()
      Call DKH_Info_Get()
      Call Real_Info_Get()
      Call RICD_Info_Get()
      Call Logical_Info_Get()

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Free_HerRW()

use Her_RW, only: HerR, HerW, iHerR, iHerw
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(iHerR,safe='*')
call mma_deallocate(iHerW,safe='*')
call mma_deallocate(HerR,safe='*')
call mma_deallocate(HerW,safe='*')

return

end subroutine Free_HerRW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ParentWorkDir()

use subdirs, only: f_setsubdir, Sub, OldWorkDir, NewWorkDir
use filesystem, only: remove_, chdir_
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i

Sub = ''
call f_setsubdir(Sub)
call chdir_(OldWorkDir)

! Remove the subdirectory,
! try to make sure it is indeed a subdirectory
if (index(NewWorkDir,trim(OldWorkDir)) == 1) then
  i = len_trim(OldWorkDir)
  if ((len_trim(NewWorkDir) >= i+2) .and. (NewWorkDir(i+1:i+1) == '/') .and. (NewWorkDir(i+2:i+2) /= '/')) then
    call remove_(NewWorkDir)
  end if
end if

return

end subroutine ParentWorkDir

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************
Module TList_Mod
Real*8, Parameter:: Not_Used=-1.0D0
Real*8 QLast(2),P,PQ
Integer nTasks, igaTsk, iTCnSt, mTasks, iStrt_TList, iEnd_TList, iTskCan
Real*8, Allocatable:: TskQ(:,:)
Real*8, Allocatable:: TskM(:,:)
Integer, Allocatable, Target:: TskL(:)
Logical:: PP_Status=.False.
Logical:: GT_Status=.False.
End Module TList_Mod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1994-1997, Jeppe Olsen                            *
*               2012, Giovanni Li Manni                                *
************************************************************************
      SUBROUTINE ADAST_GAS(   IOBSM,   IOBTP,   NIGRP,    IGRP, ISPGPSM,
     &                           I1,    XI1S,   NKSTR,    IEND,   IFRST,
     &                        KFRST,    KACT,  SCLFAC,     IAC)
*
*
* Obtain creation or annihilation mapping
*
* IAC = 2 : Creation map
* a+IORB !KSTR> = +/-!ISTR>
*
* IAC = 1 : Annihilation map
* a IORB !KSTR> = +/-!ISTR>
*
* for orbitals of symmetry IOBSM and type IOBTP
* and Istrings defined by the NIGRP groups IGRP and symmetry ISPGPSM
*
* The results are given in the form
* I1(KSTR,IORB) =  ISTR if A+IORB !KSTR> = +/-!ISTR>
* (numbering relative to TS start)
* Above +/- is stored in XI1S
*
* if some nonvanishing excitations were found, KACT is set to 1,
* else it is zero
*
*
* Jeppe Olsen , Winter of 1991
*               January 1994 : modified to allow for several orbitals
*               August 95    : GAS version
*               October 96   : Improved version
*               September 97 : annihilation mappings added
*                              I groups defined by IGRP
*
* Giovanni Li Manni, February 2012
* Smart Loop over symmetry distributions
* in order to make the code faster
*
* ======
*. Input
* ======
*
*./BIGGY
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "strbas.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "csm.fh"
#include "lucinp.fh"
#include "distsym.fh"
#include "loff.fh"
#include "stdalloc.fh"
*. Input
      INTEGER IGRP(NIGRP)
*. Local scratch
      INTEGER ISMFGS(MXPNGAS)
      INTEGER MXVLI(MXPNGAS),MNVLI(MXPNGAS)
*      INTEGER MXVLK(MXPNGAS),MNVLK(MXPNGAS)
      INTEGER NNSTSGP(MXPNSMST,MXPNGAS)
      INTEGER IISTSGP(MXPNSMST,MXPNGAS)
      INTEGER KGRP(MXPNGAS)
      INTEGER IACIST(MXPNSMST), NACIST(MXPNSMST)
      ALLOCATABLE IOFFI(:)
*
*
* =======
*. Output
* =======
*
      INTEGER I1(*)
      DIMENSION XI1S(*)
*. Will be stored as an matrix of dimension
* (NKSTR,*), Where NKSTR is the number of K-strings of
*  correct symmetry . Nk is provided by this routine.
*
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' ==================== '
        WRITE(6,*) ' ADAST_GAS in service '
        WRITE(6,*) ' ==================== '
        WRITE(6,*)
        WRITE(6,*)'GAS space (IOBTP), Symm of it (IOBSM) :',IOBTP,IOBSM
        WRITE(6,*) ' Supergroup in action : '
        WRITE(6,'(A,I3  )') ' Number of active spaces ', NIGRP
        WRITE(6,'(A,20I3)') ' The active groups       ',
     &                      (IGRP(I),I=1,NIGRP)
        WRITE(6,*) '  Symmetry of supergroup : ', ISPGPSM
        WRITE(6,*) ' SCLFAC = ', SCLFAC
        IF(IAC.EQ.1) THEN
          WRITE(6,*) ' Annihilation mapping '
        ELSE IF(IAC.EQ.2) THEN
          WRITE(6,*) ' Creation mapping '
        ELSE
          WRITE(6,*) ' Unknown IAC parameter in ADAST ',IAC
        CALL SYSABENDMSG('lucia_util/adast_gas',
     &                    'Internal error',' ')
        END IF
      END IF
*. A few preparations
      NORBTS= NOBPTS(IOBTP,IOBSM)
      NORBT= NOBPT(IOBTP)
      IACGAS = IOBTP
      CALL mma_allocate(IOFFI,LOFFI,label='IOFFI')
*. First orbital of given GASpace
       IBORBSP = IELSUM(NOBPT,IOBTP-1)+1
*. First orbital of given GASpace and Symmetry
       IBORBSPS = IOBPTS(IOBTP,IOBSM)
      IF(NTEST.GE.100) THEN
        write(6,*) ' NORBTS per GAS and sym          :', NORBTS
        write(6,*) ' NORBT per GAS                   :', NORBT
        write(6,*) ' IACGAS GAS involved             :', IACGAS
        write(6,*) ' IBORBSP 1st orb per GAS         :', IBORBSP
        write(6,*) ' IBORBSPS 1st orb per GAS and sym:', IBORBSPS
      END IF
*
*====================================================
*. K strings : Supergroup, symmetry and distributions
*====================================================
      IF(IAC.EQ.1) THEN
       IDELTA = +1
      ELSE
       IDELTA = -1
      END IF
*. Is required mapping contained within current set of maps?
*. a:) Is active GASpace included in IGRP - must be
      IACGRP = 0
      DO JGRP = 1, NIGRP
       IF(IGSFGP(IGRP(JGRP)).EQ. IACGAS) IACGRP = JGRP
      END DO
*. Note : IACGRP is not the actual active group, it is the address of the
*         active group in IGRP
      IF(IACGRP.EQ.0) THEN
        WRITE(6,*) ' ADAST in problems '
        WRITE(6,*) ' Active GASpace not included in IGRP '
        WRITE(6,*) ' Active GASpace : ', IACGAS
        WRITE(6,'(A,20I3)') ' The active groups       ',
     &                      (IGRP(I),I=1,NIGRP)
        CALL SYSABENDMSG('lucia_util/adast_gas',
     &                    'Internal error',' ')
      END IF
*. b:) active group in K strings
      NIEL = NELFGP(IGRP(IACGRP))
      NKEL = NIEL + IDELTA
      IF(NTEST.GE.1000) WRITE(6,*) ' NIEL and NKEL ',NIEL,NKEL
      IF(NKEL.EQ.-1.OR.NKEL.EQ.NOBPT(IACGAS)+1) THEN
*. No strings with this number of elecs - be happy : No work
        NKSTR = 0
        KACT = 0
        KACGRP = 0
        GOTO 9999
      ELSE
*. Find group with NKEL electrons in IACGAS
        KACGRP = 0
        DO JGRP = IBGPSTR(IACGAS),IBGPSTR(IACGAS)+NGPSTR(IACGAS)-1
          IF(NELFGP(JGRP).EQ.NKEL) KACGRP = JGRP
        END DO
        IF(NTEST.GE.1000) WRITE(6,*) ' KACGRP = ',KACGRP
*. KACGRP is the Active group itself
        IF(KACGRP.EQ.0) THEN
          WRITE(6,*)' ADAST : cul de sac, active K group not found'
          WRITE(6,*)' GAS space and number of electrons ',
     &               IACGAS,NKEL
          CALL SYSABENDMSG('lucia_util/adast_gas',
     &                    'Internal error',' ')
        END IF
      END IF
*. Okay active K group was found and is nontrivial
      CALL SYMCOM(2,0,IOBSM,KSM,ISPGPSM)
*. The K supergroup
      CALL ICOPVE(IGRP,KGRP,NIGRP)
      KGRP(IACGRP) = KACGRP
*. Number of strings and symmetry distributions of K strings
      CALL NST_SPGRP( NIGRP,   KGRP,      KSM,iWORK(KNSTSGP(1)),NSMST,
     &                NKSTR,   NKDIST)
      IF(NTEST.GE.1000) WRITE(6,*) 'KSM,NKSTR,NKDIST:', KSM,NKSTR,NKDIST
      IF(NKSTR.EQ.0) GOTO 9999
*. Last active space in K strings and number of strings per group and sym
      NGASL = 1
      DO JGRP = 1, NIGRP
       IF(NELFGP(KGRP(JGRP)).GT.0) NGASL = JGRP
       CALL ICOPVE2(iWORK(KNSTSGP(1)),(KGRP(JGRP)-1)*NSMST+1,NSMST,
     &              NNSTSGP(1,JGRP))
       CALL ICOPVE2(iWORK(KISTSGP(1)),(KGRP(JGRP)-1)*NSMST+1,NSMST,
     &              IISTSGP(1,JGRP))
      END DO
      IF(NTEST.GE.100) WRITE(6,*) 'NGASL', NGASL
*. MIN/MAX for Kstrings
*      CALL MINMAX_FOR_SYM_DIST(NIGRP,KGRP,MNVLK,MXVLK,NKDIST_TOT)
*      IF(NTEST.GE.100) THEN
*        write(6,*) 'MNVLK and MXVLK '
*        CALL IWRTMA(MNVLK,1,NIGRP,1,NIGRP)
*        CALL IWRTMA(MXVLK,1,NIGRP,1,NIGRP)
*      END IF
*. (NKDIST_TOT is number of distributions, all symmetries )
* ==============
*. I Strings
* ==============
*. Generate symmetry distributions of I strings with given symmetry
      CALL TS_SYM_PNT2(    IGRP,   NIGRP,   MXVLI,   MNVLI, ISPGPSM,
     &                    IOFFI,   LOFFI)
*. Offset and dimension for active group in I strings
      CALL ICOPVE2(iWORK(KISTSGP(1)),(IGRP(IACGRP)-1)*NSMST+1,NSMST,
     &               IACIST)
*
      CALL ICOPVE2(iWORK(KNSTSGP(1)),(IGRP(IACGRP)-1)*NSMST+1,NSMST,
     &               NACIST)
*. Last entry in IGRP with a nonvanisking number of strings
      NIGASL = 1
      DO JGRP = 1, NIGRP
        IF(NELFGP(IGRP(JGRP)).GT.0) NIGASL = JGRP
      END DO
*. Number of electrons before active space
      NELB = 0
      DO JGRP = 1, IACGRP-1
        NELB = NELB + NELFGP(IGRP(JGRP))
      END DO
      IF(NTEST.GE.1000) WRITE(6,*) ' NELB = ', NELB
      IZERO = 0
      CALL ISETVC(I1,IZERO,NORBTS*NKSTR)
* Loop over symmetry distribtions of K strings
      KFIRST = 1
      KSTRBS = 1
      DO IGAS = 1, NIGRP
        ISMFGS(IGAS) = 1
      END DO
 1000 CONTINUE
cGLM        IF(KFIRST .EQ. 1 ) THEN
cGLM          DO IGAS = 1, NIGRP
cGLM            ISMFGS(IGAS) = MNVLI(IGAS)
cGLM          END DO
cGLM        ELSE
*. Next distribution
          CALL NEXT_SYM_DISTR_NEW(NSMST,NGRP,KGRP,NIGRP,
     &                           ISMFGS,KSM,KFIRST,NONEW,
     &                  iWork(ISMDFGP),iWork(NACTSYM),iWork(ISMSCR))
cGLM          IF(NONEW.EQ.1) GOTO 9999
cGLM        END IF
        IF(NTEST.GE.1000) THEN
          write(6,*) ' Symmetry distribution   '
          call iwrtma(ISMFGS,1,NIGRP,1,NIGRP)
        END IF
        IF(NONEW.EQ.1) GOTO 9999
        KFIRST = 0
*. Number of strings of this symmetry distribution
        NSTRIK = 1
        DO IGAS = 1, NGASL
          NSTRIK = NSTRIK*NNSTSGP(ISMFGS(IGAS),IGAS)
        END DO
*. Offset for corresponding I strings
        ISAVE = ISMFGS(IACGRP)
        CALL  SYMCOM(3,1,IOBSM,ISMFGS(IACGRP),IACSM)
        ISMFGS(IACGRP) = IACSM
        IBSTRINI = IOFF_SYM_DIST(ISMFGS,NIGASL,IOFFI,MXVLI,MNVLI)
c        write(6,*) 'IBSTRINI :', IBSTRINI
        ISMFGS(IACGRP) = ISAVE
*. Number of strings before active GAS space
        NSTB = 1
C       DO IGAS = 1, IOBTP-1
        DO IGAS = 1, IACGRP-1
          NSTB = NSTB*NNSTSGP(ISMFGS(IGAS),IGAS)
        END DO
*. Number of strings After active GAS space
        NSTA = 1
C       DO IGAS =  IOBTP +1, NIGRP
        DO IGAS =  IACGRP+1, NIGRP
          NSTA = NSTA*NNSTSGP(ISMFGS(IGAS),IGAS)
        END DO
*. Number and offset for active group
        NIAC  = NACIST(IACSM)
        IIAC =  IACIST(IACSM)
        NKAC = NNSTSGP(ISMFGS(IACGRP),IACGRP)
        IKAC = IISTSGP(ISMFGS(IACGRP),IACGRP)
*. I and K strings of given symmetry distribution
        NKSD = NSTB*NKAC*NSTA
        IF(NTEST.GE.1000) THEN
        write(6,*) ' nstb nsta niac nkac ',
     &               nstb,nsta,niac,nkac
        END IF
*. Obtain annihilation/creation mapping for all strings of this type
*. Are group mappings in expanded or compact form
        IF(IAC.EQ.1.AND.ISTAC(KACGRP,2).EQ.0) THEN
          IEC = 2
          LROW_IN = NKEL
        ELSE
          IEC = 1
          LROW_IN = NORBT
        END IF
        NKACT = NSTFGP(KACGRP)
*
        IF(NSTA*NSTB*NIAC*NKAC.NE.0)
     &  CALL ADAST_GASSM(NSTB,NSTA,IKAC,IIAC,IBSTRINI,KSTRBS,
     &                 iWORK(KSTSTM(KACGRP,1)),iWORK(KSTSTM(KACGRP,2)),
     &                 IBORBSPS,IBORBSP,NORBTS,NKAC,NKACT,NIAC,
     &                 NKSTR,KBSTRIN,NELB,NACGSOB,I1,XI1S,SCLFAC,IAC,
     &                 LROW_IN,IEC)
        KSTRBS = KSTRBS + NKSD
        GOTO 1000
*
 9999 CONTINUE
      CALL mma_deallocate(IOFFI)
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Output from ADAST_GAS '
        WRITE(6,*) ' ===================== '
        WRITE(6,*) ' Total number of K strings ', NKSTR
        IF(NKSTR.NE.0) THEN
          DO IORB = IBORBSPS,IBORBSPS + NORBTS  - 1
            IORBR = IORB-IBORBSPS +1
            WRITE(6,*) ' Info for orbital ', IORB
            WRITE(6,*) ' Excited strings and sign '
            CALL IWRTMA(  I1((IORBR-1)*NKSTR+1),1,NKSTR,1,NKSTR)
            CALL WRTMAT(XI1S((IORBR-1)*NKSTR+1),1,NKSTR,1,NKSTR)
          END DO
        END IF
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(IEND)
        CALL Unused_integer(IFRST)
        CALL Unused_integer(KFRST)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function nProp_Int(Do_Index,Index,nIndex)
      Implicit real*8 (a-h,o-z)
#include "real.fh"
      Character*8 Label
      Logical Do_Index
      Integer Index(4,nIndex)
      Dimension nInt(1)
*                                                                      *
************************************************************************
*                                                                      *
      nProp_Int=0
*                                                                      *
************************************************************************
*                                                                      *
c     Scan the ONEINT file for multipole moment operators
c
C     Write (*,*) ' Starting scan of ONEINT for multipole moments'
      do iMltpl=1,99
         nComp=(iMltpl+1)*(iMltpl+2)/2
c
         Write (Label,'(a,i2)') 'MLTPL ',iMltpl
         irc=-1
         iopt=1
         iComp=1
         Call iRdOne (irc,iopt,Label,iComp,nInt,iSmLbl)
         If (irc.ne.0) Go To 110
         If (Do_Index) Then
            Do iComp=1,nComp
               nProp_Int = nProp_Int + 1
               Index(1,nProp_Int) = 1
               Index(2,nProp_Int) = iMltpl
               Index(3,nProp_Int) = iComp
               Index(4,nProp_Int) = 0
            End Do
         Else
            nProp_Int=nProp_Int + nComp
         End If
      End Do
110   Continue
*                                                                      *
************************************************************************
*                                                                      *
c     Scan 'ONEINT' for electric field integrals
c
C     Write (*,*) ' Starting scan of ONEINT for various elec. field integrals'
c
      Do iEF=0,2
         nComp=(iEF+1)*(iEF+2)/2
c
         maxCen=9999
         Do iCent=1,maxCen
            write (Label,'(a,i1,i5)') 'EF',iEF,iCent
            irc=-1
            iopt=1
            iComp=1
            Call iRdOne (irc,iopt,Label,iComp,nInt,iSmLbl)
            If (irc.ne.0) Go To 201
            If (Do_Index) Then
               Do iComp=1,nComp
                  nProp_Int = nProp_Int + 1
                  Index(1,nProp_Int) = 2
                  Index(2,nProp_Int) = iEF
                  Index(3,nProp_Int) = iComp
                  Index(4,nProp_Int) = iCent
               End Do
            Else
               nProp_Int=nProp_Int + nComp
            End If
         End Do
201      Continue
      End Do
*                                                                      *
************************************************************************
*                                                                      *
c     Scan 'ONEINT' for contact term integrals
c
C     Write (*,*) ' Starting scan of ONEINT for various contact term integrals'
c
      nComp = 1
c
      maxCen=9999
      Do iCent=1,maxCen
         write (Label,'(a,i5)') 'Cnt',iCent
         irc=-1
         iopt=1
         iComp=1
         Call iRdOne (irc,iopt,Label,iComp,nInt,iSmLbl)
         If (irc.ne.0) Go To 301
         If (Do_Index) Then
            Do iComp=1,nComp
               nProp_Int = nProp_Int + 1
               Index(1,nProp_Int) = 3
               Index(2,nProp_Int) = 1
               Index(3,nProp_Int) = 1
               Index(4,nProp_Int) = iCent
            End Do
         Else
            nProp_Int=nProp_Int + nComp
         End If
      End Do
301   Continue
*                                                                      *
************************************************************************
*                                                                      *
C     If (Do_Index) Call iVcPrt('Index',' ',Index,4*nProp_Int)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Numerical solution of the vibrational Schroedinger equation
! for a diatomic molecule.
!
! PotR is the electronic energy given as input
! Redm is the reduced mass
! Jrot is the rotational quantum number
! G is the radial wave function in a logaritmic scale U=ln(R)
! Umin to Umax is the integration range
! del is the step length
! R=exp(U) is the radial coordinates
! E is the energy
! ndim is the number of integration steps
! E0 is the starting value for an eigenvalue search. E0 is simply
! put equal to the minimum value of the potential.
! nvib is the number of eigenvalues wanted.
! dE0 the original step length in the energy interpolation procedure
!
! ********** MOLCAS-2 Release 90 05 01 **********
subroutine Vibrot(ngrid,nvib,Umin,Umax,R,PotR,E0,dE0,Redm,Req,sc,Temp)

use Vibrot_globals, only: Atom1, Atom2, EoutO, iad12, iadrsp, iadvib, iobs, ispc, J1A, J2A, lambda, npoint, Titobs, Vibwvs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Four, Five, Six, Twelve
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ngrid, nvib
real(kind=wp), intent(in) :: Umin, Umax, R(ngrid+2), PotR(ngrid+2), dE0, Redm, Req, sc, Temp
real(kind=wp), intent(inout) :: E0
integer(kind=iwp) :: i, ii, ist, iter, ivib, J, ngrid1
real(kind=wp) :: Adif, AGi, Akk, AVi, const, D, D1, D1t, D2, dE, del, del12, del2, del56, delRN, diffm, DMem, E, E0x, E1, Emem, &
                 Est, Evib, fac, fact, GAM0, GAMn, Gmax, H11, H11a, H11c, Hnna, Hnnc, PotR0, PotRn1, R0, Redm2, Rn1, S11, S11a, &
                 S11c, Snna, Snnc, Svec0, SvecN1, term2, term4, V0, V1, Vmax, Vn, VN1, Wii, X2, Xrot
real(kind=wp), allocatable :: V(:), G(:), Svec(:), alpha(:), beta(:), B(:), W(:), Vec(:), Ener(:), S(:,:), H(:,:)
real(kind=wp), parameter :: Thre = 1.0e-8_wp, THR = 1.0e-3_wp
#include "warnings.h"

D = Zero    ! dummy initialize
DMem = Zero ! dummy initialize

if (ngrid > npoint) then
  write(u6,999) ngrid,npoint
  call Abend()
end if

call mma_allocate(V,ngrid,label='V')
call mma_allocate(G,ngrid,label='G')
call mma_allocate(Svec,ngrid,label='Svec')
call mma_allocate(alpha,ngrid,label='alpha')
call mma_allocate(beta,ngrid,label='beta')
call mma_allocate(B,ngrid,label='B')
call mma_allocate(W,ngrid-1,label='W')
call mma_allocate(Vec,ngrid+1,label='Vec')
call mma_allocate(Ener,nvib,label='Ener')
call mma_allocate(S,3,ngrid,label='S')
call mma_allocate(H,3,ngrid,label='H')

del = (Umax-Umin)/(ngrid-1)
del2 = del**2
del12 = del2/Twelve
del56 = del2*Five/Six
PotR0 = PotR(ngrid+1)
PotRn1 = PotR(ngrid+2)
R0 = R(ngrid+1)
Rn1 = R(ngrid+2)

write(u6,2700)

! Start loop over rotational quantum numbers
Est = E0
do J=J1A,J2A
  iad12(J-J1A+1) = iadvib
  Xrot = -One/Two+sqrt(One/Four+J*(J+1)-lambda**2)

  ! Construct effective potential V and overlap vector Svec
  const = One/Four+Xrot*(Xrot+1)
  Redm2 = Two*Redm
  Svec0 = Redm2*R0**2
  V0 = const+Svec0*PotR0
  SvecN1 = Redm2*Rn1**2
  VN1 = const+SvecN1*PotRn1
  do i=1,ngrid
    fact = Redm2*R(i)**2
    Svec(i) = fact
    V(i) = const+fact*PotR(i)
  end do

  ! Construct Hamilton and Overlap matrices
  ngrid1 = ngrid-1
  do i=2,ngrid1
    H(1,i) = One-del12*V(i-1)
    S(1,i) = -del12*Svec(i-1)
    H(2,i) = -Two-del56*V(i)
    S(2,i) = -del56*Svec(i)
    H(3,i) = One-del12*V(i+1)
    S(3,i) = -del12*Svec(i+1)
  end do
  H(3,1) = One-del12*V(2)
  S(3,1) = -del12*Svec(2)
  H(1,ngrid) = One-del12*V(ngrid1)
  S(1,ngrid) = -del12*Svec(ngrid1)

  ! H(1,1) and S(1,1) depends explicitly on energy and are
  ! therefore constructed during the iteration process
  !
  ! set up and solve secular problem
  ! search for eigenvalues starting from E0.
  fac = exp(-del*(Xrot+One/Two))
  X2 = Redm/(Two*Xrot+Three)
  term2 = fac*X2*R0**2
  term4 = X2*R(1)**2
  H11a = -Two-del56*V(1)
  Hnna = -Two-del56*V(ngrid)
  H11c = One-del12*V0
  Hnnc = One-del12*VN1
  S11a = -del56*Svec(1)
  Snna = -del56*Svec(ngrid)
  S11c = -del12*Svec0
  Snnc = -del12*SvecN1
  delRN = Rn1-R(ngrid)

  do ivib=1,nvib
    iter = 0
    E = E0-dE0
    ist = 0
    Emem = Zero
    dE = dE0
    do
      ! IFG Stop if above the dissociation limit
      !     (assuming energy at infinity is set to zero)
      if (E > zero) then
        call SysQuitMsg(_RC_NOT_CONVERGED_,'VibRot','Failed to find a state.','Try decreasing STEP.')
      end if
      E = E+dE
      ! Compute h(1,1) and s(1,1)
      GAM0 = (fac+(PotR0-E)*term2)/(One+(PotR0-E)*term4)
      H11 = H11a+GAM0*H11c
      S11 = S11a+GAM0*S11c
      H(2,1) = H11
      S(2,1) = S11
      ! Compute H(N,N) and S(N,N)
      GAMn = exp(-sqrt(-Redm2*E)*delRN-del/Two)
      H(2,ngrid) = HnnA+GAMn*HnnC
      S(2,ngrid) = SnnA+GAMn*SnnC
      ! Calculate secular determinant
      D1t = H11-E*S11
      D1 = D1t/abs(D1t)
      D2 = One
      do i=2,ngrid
        Akk = H(2,i)-E*S(2,i)
        D = D1*Akk/abs(Akk)-D2*(H(3,i-1)-E*S(3,i-1))*(H(1,i)-E*S(1,i))/abs((H(2,i-1)-E*S(2,i-1))*Akk)
        D2 = D1
        D1 = D
      end do

      if (ist /= 0) then
        if (D/Dmem < Zero) then
          ! an eigenvalue has been bracketed
          E1 = E
          E = E1-DE*D/(D-Dmem)
          if (abs(E-Emem) < Thre) exit
          Emem = E
          E = E-DE
          DE = DE/Three
          E = E-DE
          ist = 0
        else
          Dmem = D
        end if
      else
        ist = 1
        Dmem = D
      end if
    end do
    ! One eigenvalue found. Remove scaling
    Ener(ivib) = (E-Est)/sc
    E0 = E+dE0
    alpha(ngrid) = H(2,ngrid)-E*S(2,ngrid)
    beta(ngrid) = H(1,ngrid)-E*S(1,ngrid)
    do i=1,ngrid1
      ii = ngrid-i
      if (ii /= 1) beta(ii) = H(1,ii)-E*S(1,ii)
      Wii = (H(3,ii)-E*S(3,ii))/alpha(ii+1)
      alpha(ii) = H(2,ii)-E*S(2,ii)-Wii*beta(ii+1)
      W(ii) = Wii
    end do
    ! step 2: unit right hand side
    if (abs(alpha(1)) == Zero) alpha(1) = 1.0e-10_wp
    G(1) = One/alpha(1)
    do i=2,ngrid
      G(i) = (One-beta(i)*G(i-1))/alpha(i)
    end do
    ! step 3: g on the right hand side
    do
      B(ngrid) = G(ngrid)
      do i=1,ngrid1
        ii = ngrid-i
        B(ii) = G(ii)-W(ii)*B(ii+1)
      end do
      Vec(1) = B(1)/alpha(1)
      do i=2,ngrid
        Vec(i) = (B(i)-beta(i)*Vec(i-1))/alpha(i)
      end do
      ! normalize g and vec
      Gmax = Zero
      Vmax = Zero
      do i=1,ngrid
        AGi = abs(G(i))
        if (AGi > Gmax) Gmax = AGi
        AVi = abs(Vec(i))
        if (AVi > Vmax) Vmax = AVi
      end do
      diffm = Zero
      do i=1,ngrid
        G(i) = G(i)/Gmax
        Vec(i) = Vec(i)/Vmax
        Adif = abs(Vec(i))-abs(G(i))
        if (Adif > diffm) diffm = Adif
      end do
      if ((diffm < 1.e-06) .and. (iter /= 0)) exit
      iter = iter+1
      do i=1,ngrid
        G(i) = Vec(i)
      end do
    end do
    Evib = (E-Est)/sc
    !GG: Remove scaling
    Vec(ngrid+1) = E/sc
    call DDafile(Vibwvs,1,Vec(1),ngrid+1,iadvib)

    ! Print energies and notify on end point values
    V1 = abs(Vec(1))
    Vn = abs(Vec(ngrid))
    if ((V1 < THR) .and. (Vn < THR)) write(u6,3000) ivib-1,J,Evib
    if ((V1 < THR) .and. (Vn >= THR)) write(u6,3001) ivib-1,J,Evib,Vn
    if ((V1 >= THR) .and. (Vn < THR)) write(u6,3002) ivib-1,J,Evib,V1
    if ((V1 >= THR) .and. (Vn >= THR)) write(u6,3003) ivib-1,J,Evib,V1,Vn

  end do

  iadrsp(J-J1A+1) = iadvib
  call DDafile(Vibwvs,1,Ener(1),nvib,iadvib)
  E0 = Est
end do

! write address record to Vibwvs
iadvib = 0
call iDafile(Vibwvs,1,iad12,100,iadvib)

! Compute spectroscopic parameters
E0x = Est/sc
if (ispc /= 0) call Spectc(Req,E0x,Atom1,Atom2,nvib)

! Compute matrix elements of observables
if (iobs /= 0) then
  do i=1,iobs
    call Vibmat(nvib,ngrid,Umin,Umax,Titobs(i),R,EoutO(1,i),Temp)
  end do
end if

call mma_deallocate(V)
call mma_deallocate(G)
call mma_deallocate(Svec)
call mma_deallocate(alpha)
call mma_deallocate(beta)
call mma_deallocate(B)
call mma_deallocate(W)
call mma_deallocate(Vec)
call mma_deallocate(Ener)
call mma_deallocate(S)
call mma_deallocate(H)

return

999 format(/1x,'Number of gridpoints',i4,' is larger than' &
           /1x,' dimension npoint=',i3,' in VIBROT.' &
           /1x,' Program cannot continue.')
2700 format(//1x,'Eigenstates'//1x,' Vib. q.n.   Rot. q.n.    Energy')
3000 format(4x,i3,9x,i3,2x,f12.6)
3001 format(4x,i3,9x,i3,2x,f12.6,5x,'Warning:function value at Rmax is',f12.6)
3002 format(4x,i3,9x,i3,2x,f12.6,5x,'Warning:function value at Rmin is',f12.6)
3003 format(4x,i3,9x,i3,2x,f12.6,5x,'Warning:function value at Rmin is',f12.6,' and at Rmax',f12.6)

end subroutine Vibrot

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine utmu(EXCH,N,Z,M1,M2)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: EXCH, N
complex(kind=wp), intent(in) :: Z(N,N), M1(3,EXCH,EXCH)
complex(kind=wp), intent(out) :: M2(3,EXCH,EXCH)
integer(kind=iwp) :: I, L
real(kind=wp) :: R1, R2
complex(kind=wp), allocatable :: M1_TMP(:,:), M2_TMP(:,:), TMP(:,:)
real(kind=wp), external :: dznrm2_
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: J
#endif

if ((N <= 0) .or. (EXCH <= 0)) then
  write(u6,'(A)') 'in UTMU:   EXCH or N<=0 !!!'
  write(u6,*) 'EXCH=',EXCH
  write(u6,*) 'N   =',N
  call xFlush(u6)
  call abend()
end if

if (N > EXCH) then
  write(u6,'(A)') 'in UTMU:   EXCH < N !!!'
  write(u6,*) 'EXCH=',EXCH
  write(u6,*) 'N   =',N
  write(u6,'(A)') 'Nothing is to be done >> Return'
  call xFlush(u6)
  call abend()
end if

R1 = dznrm2_(3*EXCH*EXCH,M1,1)
R2 = dznrm2_(N*N,Z,1)
if ((R1 < 1.0e-25_wp) .or. (R2 < 1.0e-25_wp)) then
  write(u6,'(A)') 'in UTMU:   M1 or Z are empty!!!'
  write(u6,*) 'norm(M1)=',R1
  write(u6,*) 'norm(Z )=',R2
  return
end if

#ifdef _DEBUGPRINT_
write(u6,'(A)') 'UTMU :: input moment'
do i=1,EXCH
  do j=1,EXCH
    write(u6,'(A,i3,A,i3,A,3(2ES16.8,2x))') '<',i,'|M1_l|',j,'>',(M1(l,i,j),l=1,3)
  end do
end do
#endif

call mma_allocate(M1_TMP,N,EXCH,'M1_TMP')
call mma_allocate(M2_TMP,N,N,'M2_TMP')
call mma_allocate(TMP,N,EXCH,'TMP')

if (N == EXCH) then

  do L=1,3
    M1_TMP(:,:) = M1(L,:,:)
    call ZGEMM_('C','N',EXCH,EXCH,EXCH,cOne,Z,EXCH,M1_TMP,EXCH,cZero,TMP,EXCH)
    call ZGEMM_('N','N',EXCH,EXCH,EXCH,cOne,TMP,EXCH,Z,EXCH,cZero,M2_TMP,EXCH)
    M2(L,:,:) = M2_TMP(:,:)
  end do !L

else

  M2(:,:,:) = cZero

  do L=1,3
    M1_TMP(:,:) = M1(L,1:N,:)
    call ZGEMM_('C','N',N,N,N,cOne,Z,N,M1_TMP(:,1:N),N,cZero,TMP(:,1:N),N)
    call ZGEMM_('N','N',N,N,N,cOne,TMP(:,1:N),N,Z,N,cZero,M2_TMP,N)
    call ZGEMM_('C','N',N,EXCH,N,cOne,Z,N,M1_TMP,N,cZero,TMP,N)
    M2(L,1:N,1:N) = M2_TMP(:,:)

    do I=1,N
      M2(L,I,N+1:) = TMP(I,N+1:)
      M2(L,N+1:,I) = conjg(TMP(I,N+1:))
    end do
    M2(L,N+1:,N+1:) = M1(L,N+1:,N+1:)
  end do !L

end if !N == exch

#ifdef _DEBUGPRINT_
write(u6,'(A)') 'UTMU :: input moment'
do i=1,EXCH
  do j=1,EXCH
    write(u6,'(A,i3,A,i3,A,3(2ES16.8,2x))') '<',i,'|M_l|',j,'>',(M1(l,i,j),l=1,3)
  end do
end do
write(u6,'(A)') 'UTMU :: unitary transformtion matrix'
do i=1,N
  do j=1,N
    write(u6,'(A,i3,A,i3,A,3(2ES16.8,2x))') '<',i,'| U |',j,'>',(Z(i,j),l=1,3)
  end do
end do
write(u6,'(A)') 'UTMU :: output moment'
do i=1,EXCH
  do j=1,EXCH
    write(u6,'(A,i3,A,i3,A,3(2ES16.8,2x))') '<',i,'|M_l|',j,'>',(M2(l,i,j),l=1,3)
  end do
end do
#endif
call mma_deallocate(M1_TMP)
call mma_deallocate(M2_TMP)
call mma_deallocate(TMP)

return

end subroutine utmu

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CLagDXC_FG3(iSym,nAS,nAshT,NG3,NS,BDER,SDER,DF1,DF2,DF3,DG1,DG2,DG3,DEPSA,G2,SC,idxG3)

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use SUPERINDEX, only: KTUV
use caspt2_module, only: EPSA, IASYM, NTUVES
use Constants, only: Zero
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: iSym, nAS, nAshT, NG3, NS
real(kind=wp), intent(in) :: BDER(nAS,nAS), SDER(nAS,nAS), G2(nAshT,nAshT,nAshT,nAshT), SC(NS)
real(kind=wp), intent(inout) :: DF1(nAshT,nAshT), DF2(nAshT,nAshT,nAshT,nAshT), DF3(NG3), DG1(nAshT,nAshT), &
                                DG2(nAshT,nAshT,nAshT,nAshT), DG3(NG3), DEPSA(nAshT,nAshT)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: iG3, iST, iSU, ISUP, iSV, iSX, iSY, iSZ, iT, iTU, ituvs, iU, iV, iVX, iW, iX, ixyzs, iY, iYZ, iZ, JSUP, jSYM, &
                     NSEQ
real(kind=wp) :: F3VAL, G3VAL

do iG3=1,NG3
  iT = idxG3(1,iG3)
  iU = idxG3(2,iG3)
  iV = idxG3(3,iG3)
  iX = idxG3(4,iG3)
  iY = idxG3(5,iG3)
  iZ = idxG3(6,iG3)
  iST = IASYM(iT)
  iSU = IASYM(iU)
  iSV = IASYM(iV)
  iSX = IASYM(iX)
  iSY = IASYM(iY)
  iSZ = IASYM(iZ)
  ituvs = Mul(IST,Mul(ISU,ISV))
  ixyzs = Mul(ISX,Mul(ISY,ISZ))
  F3VAL = Zero
  G3VAL = Zero
  if (ituvs /= ixyzs) cycle
  iTU = iT+NASHT*(iU-1)
  iVX = iV+NASHT*(iX-1)
  iYZ = iY+NASHT*(iZ-1)
  !-SVC20100829: 12 equivalent cases, of which the second
  !  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
  !  - G(tuvxyz) -> SC(vut,xyz)
  jSYM = Mul(IASYM(iV),Mul(IASYM(iU),IASYM(iT)))
  if (jSYM == iSYM) then
    ISUP = KTUV(iV,iU,iT)-nTUVES(jSYM)
    JSUP = KTUV(iX,iY,iZ)-nTUVES(jSYM)
    F3VAL = F3VAL+BDER(iSup,jSup)
    G3VAL = G3VAL+SDER(iSup,jSup)
  end if
  if ((iTU /= iVX) .or. (iVX /= iYZ)) then
    if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
      !  - G(vxtuyz) -> SC(txv,uyz)
      jSYM = Mul(IASYM(iT),Mul(IASYM(iX),IASYM(iV)))
      if (jSYM == iSYM) then
        ISUP = KTUV(iT,iX,iV)-nTUVES(jSYM)
        JSUP = KTUV(iU,iY,iZ)-nTUVES(jSYM)
        F3VAL = F3VAL+BDER(iSup,jSup)
        G3VAL = G3VAL+SDER(iSup,jSup)
      end if
      !  - G(yzvxtu) -> SC(vzy,xtu)
      jSYM = Mul(IASYM(iV),Mul(IASYM(iZ),IASYM(iY)))
      if (jSYM == iSYM) then
        ISUP = KTUV(iV,iZ,iY)-nTUVES(jSYM)
        JSUP = KTUV(iX,iT,iU)-nTUVES(jSYM)
        F3VAL = F3VAL+BDER(iSup,jSup)
        G3VAL = G3VAL+SDER(iSup,jSup)
      end if
      !  - G(tuyzvx) -> SC(yut,zvx)
      jSYM = Mul(IASYM(iY),Mul(IASYM(iU),IASYM(iT)))
      if (jSYM == iSYM) then
        ISUP = KTUV(iY,iU,iT)-nTUVES(jSYM)
        JSUP = KTUV(iZ,iV,iX)-nTUVES(jSYM)
        F3VAL = F3VAL+BDER(iSup,jSup)
        G3VAL = G3VAL+SDER(iSup,jSup)
      end if
    end if
    !  - G(yztuvx) -> SC(tzy,uvx)
    jSYM = Mul(IASYM(iT),Mul(IASYM(iZ),IASYM(iY)))
    if (jSYM == iSYM) then
      ISUP = KTUV(iT,iZ,iY)-nTUVES(jSYM)
      JSUP = KTUV(iU,iV,iX)-nTUVES(jSYM)
      F3VAL = F3VAL+BDER(iSup,jSup)
      G3VAL = G3VAL+SDER(iSup,jSup)
    end if
    !  - G(vxyztu) -> SC(yxv,ztu)
    jSYM = Mul(IASYM(iY),Mul(IASYM(iX),IASYM(iV)))
    if (jSYM == iSYM) then
      ISUP = KTUV(iY,iX,iV)-nTUVES(jSYM)
      JSUP = KTUV(iZ,iT,iU)-nTUVES(jSYM)
      F3VAL = F3VAL+BDER(iSup,jSup)
      G3VAL = G3VAL+SDER(iSup,jSup)
    end if
  end if

  if (((iT /= iU) .or. (iV /= iX) .or. (iY /= iZ)) .and. ((iT /= iU) .or. (iV /= iZ) .or. (iX /= iY)) .and. &
      ((iX /= iV) .or. (iT /= iZ) .or. (iU /= iY)) .and. ((iZ /= iY) .or. (iV /= iU) .or. (iX /= iT))) then
    !  - G(utxvzy) -> SC(xtu,vzy)
    jSYM = Mul(IASYM(iX),Mul(IASYM(iT),IASYM(iU)))
    if (jSYM == iSYM) then
      ISUP = KTUV(iX,iT,iU)-nTUVES(jSYM)
      JSUP = KTUV(iV,iZ,iY)-nTUVES(jSYM)
      F3VAL = F3VAL+BDER(iSup,jSup)
      G3VAL = G3VAL+SDER(iSup,jSup)
    end if
    if ((iTU /= iVX) .or. (iVX /= iYZ)) then
      if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
        !  - G(xvutzy) -> SC(uvx,tzy)
        jSYM = Mul(IASYM(iU),Mul(IASYM(iV),IASYM(iX)))
        if (jSYM == iSYM) then
          ISUP = KTUV(iU,iV,iX)-nTUVES(jSYM)
          JSUP = KTUV(iT,iZ,iY)-nTUVES(jSYM)
          F3VAL = F3VAL+BDER(iSup,jSup)
          G3VAL = G3VAL+SDER(iSup,jSup)
        end if
        !  - G(zyxvut) -> SC(xyz,vut)
        jSYM = Mul(IASYM(iX),Mul(IASYM(iY),IASYM(iZ)))
        if (jSYM == iSYM) then
          ISUP = KTUV(iX,iY,iZ)-nTUVES(jSYM)
          JSUP = KTUV(iV,iU,iT)-nTUVES(jSYM)
          F3VAL = F3VAL+BDER(iSup,jSup)
          G3VAL = G3VAL+SDER(iSup,jSup)
        end if
        !  - G(utzyxv) -> SC(ztu,yxv)
        jSYM = Mul(IASYM(iZ),Mul(IASYM(iT),IASYM(iU)))
        if (jSYM == iSYM) then
          ISUP = KTUV(iZ,iT,iU)-nTUVES(jSYM)
          JSUP = KTUV(iY,iX,iV)-nTUVES(jSYM)
          F3VAL = F3VAL+BDER(iSup,jSup)
          G3VAL = G3VAL+SDER(iSup,jSup)
        end if
      end if
      !  - G(zyutxv) -> SC(uyz,txv)
      jSYM = Mul(IASYM(iU),Mul(IASYM(iY),IASYM(iZ)))
      if (jSYM == iSYM) then
        ISUP = KTUV(iU,iY,iZ)-nTUVES(jSYM)
        JSUP = KTUV(iT,iX,iV)-nTUVES(jSYM)
        F3VAL = F3VAL+BDER(iSup,jSup)
        G3VAL = G3VAL+SDER(iSup,jSup)
      end if
      !  - G(xvzyut) -> SC(zvx,yut)
      jSYM = Mul(IASYM(iZ),Mul(IASYM(iV),IASYM(iX)))
      if (jSYM == iSYM) then
        ISUP = KTUV(iZ,iV,iX)-nTUVES(jSYM)
        JSUP = KTUV(iY,iU,iT)-nTUVES(jSYM)
        F3VAL = F3VAL+BDER(iSup,jSup)
        G3VAL = G3VAL+SDER(iSup,jSup)
      end if
    end if
  end if

  !! last line of F3 transformation in mkfg3
  G3VAL = G3VAL-(EPSA(iU)+EPSA(iY))*F3VAL
  do iW=1,nAshT
    ISUP = KTUV(iV,iW,iT)-nTUVES(iSYM)
    JSUP = KTUV(iX,iY,iZ)-nTUVES(iSYM)
    NSEQ = iTri(iSup,jSup)
    DEPSA(iW,iU) = DEPSA(iW,iU)-F3VAL*SC(NSEQ)

    ISUP = KTUV(iV,iU,iT)-nTUVES(iSYM)
    JSUP = KTUV(iX,iW,iZ)-nTUVES(iSYM)
    NSEQ = iTri(iSup,jSup)
    DEPSA(iW,iY) = DEPSA(iW,iY)-F3VAL*SC(NSEQ)
  end do

  !! derivative of <0|EtuEwv,xwEyz|0>*fww
  DF3(iG3) = DF3(iG3)+F3VAL
  !! derivative of <0|EtuEvxEyz|0>
  DG3(iG3) = DG3(iG3)+G3VAL

  !! remaining F3 and G3 transformation in mkfg3
  if (iY == iX) then
    DF2(iT,iU,iV,iZ) = DF2(iT,iU,iV,iZ)-F3VAL
    DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ)-EPSA(iU)*F3VAL
    DEPSA(iU,:) = DEPSA(iU,:)-F3VAL*G2(iT,:,iV,iZ)
    DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ)-G3VAL
  end if
  if (iV == iU) then
    DF2(iT,iX,iY,iZ) = DF2(iT,iX,iY,iZ)-F3VAL
    DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ)-EPSA(iY)*F3VAL
    DEPSA(:,iY) = DEPSA(:,iY)-F3VAL*G2(iT,iX,:,iZ)
    DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ)-G3VAL
  end if
  if (iY == iU) then
    DF2(iV,iX,iT,iZ) = DF2(iV,iX,iT,iZ)-F3VAL
    DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ)-EPSA(iU)*F3VAL
    DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ)-G3VAL
  end if
  DEPSA(iY,iU) = DEPSA(iY,iU)-F3VAL*G2(iV,iX,iT,iZ)
  if ((iY == iX) .and. (iV == iU)) then
    DF1(iT,iZ) = DF1(iT,iZ)-F3VAL
    DG1(iT,iZ) = DG1(iT,iZ)-G3VAL
  end if
end do

return

end subroutine CLagDXC_FG3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine espf_write(MltOrd,iRMax,DeltaR,iGrdTyp,nGrdPt,DoTinker,
     &                      DoGromacs,lMorok,ipMltp,nMult,ipIsMM,natom,
     &                      Show_espf,Forces,DoDirect)
      Implicit Real*8 (A-H,O-Z)
#include "espf.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: Grad(:,:)
*
      Logical DoTinker,DoGromacs,lMorok,Show_espf,Forces,DoDirect,Exist
*
* Espf data are saved
*
      iPL = iPL_espf()
*
* Save data in the ESPF.DATA file
*
      IPotFl=12
      IPotFl=IsFreeUnit(IPotFl)
      Call Molcas_Open(IPotFl,'ESPF.DATA')
      Write(IPotFl,'(A10,I10)')    'MLTORD    ',MltOrd/4
      Write(IPotFl,'(A10,I10)')    'IRMAX     ',iRMax
      Write(IPotFl,'(A10,F12.9)')  'DELTAR    ',DeltaR
      Write(IPotFl,'(A10,I10)')    'GRIDTYPE  ',iGrdTyp
      Write(IPotFl,'(A10,I10)')    'GRID      ',nGrdPt
      If (DoTinker)  Write(IPotFl,'(A10)') 'TINKER    '
      If (DoGromacs) Write(IPotFl,'(A10)') 'GROMACS   '
      If (lMorok)    Write(IPotFl,'(A10)') 'LA_MOROK  '
      If (DoDirect)  Write(IPotFl,'(A10)') 'DIRECT    '
      If (ipMltp.ne.ip_Dummy) Then
         Write(IPotFl,'(A10,I10)') 'MULTIPOLE ',nMult
         iMlt = 0
         If (MltOrd.eq.1) Then
            Do iAt = 0, natom-1
               If (iWork(ipIsMM+iAt).eq.0) Then
                  Write(IPotFl,'(I6,4F15.8)') iAt+1,Work(ipMltp+iMlt),
     &                                        Zero,Zero,Zero
                  iMlt = iMlt+1
               End If
            End Do
         Else
            Do iAt = 0, natom-1
               If (iWork(ipIsMM+iAt).eq.0) Then
                  Write(IPotFl,'(I6,4F15.8)') iAt+1,
     &                                   (Work(ipMltp+iMlt+j),j=0,3)
                  iMlt = iMlt+4
               End If
            End Do
         End If
      End If
      Write(IPotFl,'(A10)')        'ENDOFESPF '
      Close (IPotFl)
*
      If (Show_espf .or. iPL.ge.4) Then
         Write(6,'(/,A,/)') ' Informations found in the ESPF data file:'
         Write(6,'(A10,I10)')    ' MLTORD   ',MltOrd/4
         Write(6,'(A10,I10)')    ' IRMAX    ',iRMax
         Write(6,'(A10,F12.9)')  ' DELTAR   ',DeltaR
         Write(6,'(A10,I10)')    ' GRIDTYPE ',iGrdTyp
         Write(6,'(A10,I10)')    ' GRID     ',nGrdPt
         If (DoTinker)  Write(6,'(A10)') ' TINKER   '
         If (DoGromacs) Write(6,'(A10)') ' GROMACS  '
         If (lMorok)    Write(6,'(A10)') ' LA_MOROK '
         If (DoDirect)  Write(6,'(A10)') ' DIRECT   '
         If (ipMltp.ne.ip_Dummy) Then
            Write(6,'(A10,I10)') ' MULTIPOLE ',nMult
            iMlt = 0
            If (MltOrd.eq.1) Then
               Do iAt = 0, natom-1
                  If (iWork(ipIsMM+iAt).eq.0) Then
                     Write(6,'(I6,4F15.8)') iAt+1,
     &                                           Work(ipMltp+iMlt),
     &                                           Zero,Zero,Zero
                     iMlt = iMlt+1
                  End If
               End Do
            Else
               Do iAt = 0, natom-1
                  If (iWork(ipIsMM+iAt).eq.0) Then
                     Write(6,'(I6,4F15.8)') iAt+1,
     &                                      (Work(ipMltp+iMlt+j),j=0,3)
                     iMlt = iMlt+4
                  End If
               End Do
            End If
         End If
         Write(6,'(A10)')        ' ENDOFESPF'
      End If
*
* Special case: Tinker is the driver of the QM/MM calculation.
* QM energy + gradient + ESPF multipoles are stored into the QMMM file
*
      Call F_Inquire('QMMM',Exist)
      If (Exist .and. Forces .and. .not. DoTinker) Then
         ITkQMMM=IsFreeUnit(15)
         Call Molcas_Open(ITkQMMM,'QMMM')
         Call Get_dScalar('Last energy',EQMMM)
         Write(ITkQMMM,'(F12.7,I5)') EQMMM,MltOrd/4
         Call mma_allocate(Grad,3,nAtom,Label='Grad')
         Call Get_Grad(Grad,3*nAtom)
         Do iAt = 1, natom
            iBlaQ = ipMltp + MltOrd*(iAt-1)
            Write(ITkQMMM,'(7F12.7)') Grad(1:3,iAt),
     &                    (Work(iBlaQ+J),J=0,MltOrd-1)
         End Do
         Close(ITkQMMM)
         Call mma_deallocate(Grad)
         Close(ITkQMMM)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine applyh_cvb(civec)

use casvb_global, only: icnt_ci, iform_ci, n_applyh, ncivb, ndet, nirrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: civec(0:ndet)
integer(kind=iwp) :: icivec, isyml, isymmx, nci
real(kind=wp) :: c_daxpy, cnrm
real(kind=wp), allocatable :: cim(:), cim2(:)
real(kind=wp), parameter :: thr2 = 1.0e-20_wp
real(kind=wp), external :: ddot_

c_daxpy = Zero

n_applyh = n_applyh+1
icivec = nint(civec(0))
icnt_ci(icivec) = 0
if (iform_ci(icivec) /= 0) then
  write(u6,*) ' Unsupported format in APPLYH :',iform_ci(icivec)
  call abend_cvb()
end if

! (NIRREP may be altered in loop)
isymmx = nirrep
do isyml=1,isymmx
  nci = ncivb(isyml)
  call mma_allocate(cim,nci,label='cim')
  cim(:) = Zero
  call vb2mol_cvb(civec(1:),cim,isyml)

  ! If only one irrep present keep down memory requirements:
  if ((isymmx > 1) .and. (nci /= ndet)) then
    call mma_allocate(cim2,nci,label='cim2')
    cim2(:) = Zero
    cnrm = ddot_(nci,cim,1,cim,1)
    ! If anything there, apply Hamiltonian to vector of this symmetry:
    if (cnrm > thr2) call sigmadet_cvb(cim,cim2,isyml,nci)
    if (c_daxpy /= Zero) cim2(:) = cim2(:)+c_daxpy*cim(:)
    call mol2vb_cvb(civec(1:),cim2,isyml)
    call mma_deallocate(cim2)
  else
    civec(1:nci) = Zero
    cnrm = ddot_(nci,cim,1,cim,1)
    ! If anything there, apply Hamiltonian to vector of this symmetry:
    if (cnrm > thr2) call sigmadet_cvb(cim,civec(1:),isyml,nci)
    if (c_daxpy /= Zero) civec(1:nci) = civec(1:nci)+c_daxpy*cim(:)
    cim(:) = civec(1:nci)
    call mol2vb_cvb(civec(1:),cim,isyml)
  end if
  call mma_deallocate(cim)
end do

return

end subroutine applyh_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine tpstr2tpidx(TYPESTRING,TYPEINDEX,NB)

use Definitions, only: iwp

#include "intent.fh"

implicit none
character, intent(in) :: TYPESTRING(*)
integer(kind=iwp), intent(_OUT_) :: TYPEINDEX(*)
integer(kind=iwp), intent(in) :: NB
integer(kind=iwp) :: i

do i=1,NB
  select case (TYPESTRING(i))
    case ('F','f')
      TYPEINDEX(i) = 1
    case ('I','i')
      TYPEINDEX(i) = 2
    case ('1')
      TYPEINDEX(i) = 3
    case ('2')
      TYPEINDEX(i) = 4
    case ('3')
      TYPEINDEX(i) = 5
    case ('S','s')
      TYPEINDEX(i) = 6
    case ('D','d')
      TYPEINDEX(i) = 7
  end select
end do

end subroutine tpstr2tpidx

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Do_Index(Indx,NrBas,NrBas_Eff,iCmp)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NrBas_Eff, iCmp, NrBas
integer(kind=iwp), intent(out) :: Indx(NrBas_Eff,iCmp)
integer(kind=iwp) :: iAdd, iB, iB_Eff, iC

iAdd = NrBas-NrBas_Eff
do iB_Eff=1,NrBas_Eff
  iB = iB_Eff+iAdd
  do iC=1,iCmp
    Indx(iB_Eff,iC) = (iC-1)*NrBas+iB
  end do
end do

return

end subroutine Do_Index

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1996, Roland Lindh                      *
*               1990, IBM                                              *
*               1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine Drv2El_dscf(Dens,TwoHam,nDens,nDisc,Thize,PreSch,
     &                       FstItr,NoCoul,ExFac)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals. The four outermost loops *
*          will control the type of the two-electron integral, e.g.    *
*          (ss|ss), (sd|pp), etc. The next four loops will generate    *
*          list of symmetry distinct centers that do have basis func-  *
*          tions of the requested type.                                *
*                                                                      *
*          Dens is the folded lower triangular of the 1st order        *
*               density matrix.                                        *
*          Twoham is the lower triangular of the two-electron contri-  *
*               bution to the Fock matrix.                             *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August '91                         *
*             Modified for direct SCF. January '93                     *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. '93          *
*             Modified by M.Schuetz @teokem.lu.se :                    *
*             parallel region split off in drvtwo.f, April '95         *
*             Modified by R. Lindh  @teokem.lu.se :                    *
*             total repacking of code September '96                    *
************************************************************************
      use k2_arrays, only: pDq, pFq
      use IOBUF
      use Gateway_Info, only: ThrInt, CutInt
      use Integral_Interfaces, only: DeDe_SCF
      Implicit Real*8 (a-h,o-z)
      External Rsv_GTList, No_Routine
#include "stdalloc.fh"
#include "print.fh"
#include "real.fh"
#include "nsd.fh"
#include "setup.fh"
      Logical NoCoul,NoExch
*
      Parameter(nTInt=1)
      Real*8, Target:: Dens(nDens), TwoHam(nDens)
      Real*8 TInt(nTInt)
      Logical W2Disc, FstItr, Semi_Direct,Rsv_GTList,
     &        PreSch, Free_K2, Verbose, Indexation,
     &        DoIntegrals, DoFock, DoGrad, Triangular
      Integer iTOffs(8,8,8)
      Character*72 SLine
      Real*8, Allocatable:: TMax(:,:), DMax(:,:)
      Integer, Allocatable:: ip_ij(:,:)
*                                                                      *
************************************************************************
*                                                                      *
      SLine='Computing 2-electron integrals'
      Call StatusLine(' SCF:',SLine)
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
*                                                                      *
************************************************************************
*                                                                      *
      Nr_Dens=1
      DoIntegrals=.False.
      NoExch=ExFac.eq.Zero
*                                                                      *
************************************************************************
*                                                                      *
*-----Set up for partial SO/AO integral storage.
*
*---- nDisc = file size in kbyte from input
      Semi_Direct = nDisc.ne.0
      If (Semi_Direct) Call Init_SemiDSCF(FstItr,Thize,Cutint)
*     Disc_Mx = file size in Real*8 128=1024/8
      Disc_Mx= DBLE(nDisc)*128.D00
*     Subtract for the last buffer
      Disc_Mx= Disc_Mx - lBuf
*                                                                      *
************************************************************************
*                                                                      *
*-----Desymmetrize differential densities.
*     Observe that the desymmetrized 1st order density matrices are
*     canonical, i.e. the relative order of the indices are canonically
*     ordered.
*
      Call DeDe_SCF(Dens,TwoHam,nDens,mDens)
*                                                                      *
************************************************************************
*                                                                      *
      Indexation=.False.
      ThrAO=Zero           ! Do not modify CutInt
      DoFock=.True.
      DoGrad=.False.
*
      Call SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
*                                                                      *
************************************************************************
*                                                                      *
      Disc = Zero
      W2Disc=.False.
      TskHi=Zero
      TskLw=Zero
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      Call mma_allocate(TMax,nSkal,nSkal,Label='TMax')
      Call Shell_MxSchwz(nSkal,TMax)
      TMax_all=Zero
      Do iS = 1, nSkal
         Do jS = 1, iS
            TMax_all=Max(TMax_all,TMax(iS,jS))
         End Do
      End Do
      Call mma_allocate(DMax,nSkal,nSkal,Label='DMax')
      Call Shell_MxDens(Dens,DMax,nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*     Create list of non-vanishing pairs
*
      Call mma_allocate(ip_ij,2,nSkal*(nSkal+1),Label='ip_ij')
      nij=0
      Do iS = 1, nSkal
         Do jS = 1, iS
            If (TMax_All*TMax(iS,jS).ge.CutInt) Then
               nij = nij + 1
               ip_ij(1,nij)=iS
               ip_ij(2,nij)=jS
            End If
         End Do
      End Do
      P_Eff=Dble(nij)
*
      PP_Eff=P_Eff**2
      PP_Eff_delta=0.10D0*PP_Eff
      PP_Count=Zero
*                                                                      *
************************************************************************
*                                                                      *
*.... For distributed parallel SCF initiate (sequential code is special
*     case when the number of nodes in the mpp is 1).
*
*     1: Task list (tlist)
*     2: Private priority list (pplist)
*     3: Global task list (gtlist)
*
      If (FstItr) Then
         Triangular=.True.
         Call Init_TList(Triangular,P_Eff)
         Call Init_PPList
         Call Init_GTList
      Else
         Call ReInit_PPList(Semi_Direct)
         Call ReInit_GTList
      End If
      iOpt=0
      If (.Not.FstItr.and.Semi_direct) iOpt=2
*
      Call CWTime(TCpu1,TWall1)
*
*     big loop over individual tasks, distributed over individual nodes

   10 Continue
*     make reservation of a task on global task list and get task range
*     in return. Function will be false if no more tasks to execute.
      If (.Not.Rsv_GTList(TskLw,TskHi,iOpt,W2Disc)) Go To 11
      Call Mode_SemiDSCF(W2Disc)
*     Write (6,*) 'TskLw,TskHi,W2Disc=',TskLw,TskHi,W2Disc
*
*     Now do a quadruple loop over shells
*
      ijS = Int((One+sqrt(Eight*TskLw-Three))/Two)
      iS = ip_ij(1,ijS)
      jS = ip_ij(2,ijS)
      klS = Int(TskLw-DBLE(ijS)*(DBLE(ijS)-One)/Two)
      kS = ip_ij(1,klS)
      lS = ip_ij(2,klS)
      Count=TskLw
      If (Count-TskHi.gt.1.0D-10) Go To 12
  13  Continue
*
      S_Eff=DBLE(ijS)
      T_Eff=DBLE(klS)
      ST_Eff=S_Eff*(S_Eff-One)/2D0 + T_Eff
      If (ST_Eff.ge.PP_Count) Then
         Write (SLine,'(A,F5.2,A)') 'Computing 2-electron integrals,',
     &        ST_Eff/PP_Eff,'% done so far.'
         Call StatusLine(' Seward:',SLine)
         PP_Count = PP_Count + PP_Eff_delta
      End If
*                                                                      *
************************************************************************
*                                                                      *
         Aint=TMax(iS,jS)*TMax(kS,lS)
         If (Semi_Direct) Then
*
*           No density screening in semi-direct case!
*           Cutint: Threshold for Integrals. In semi-direct case, this
*                   must be the final threshold used in the last scf
*                   iteration
*           Thrint: Threshold for Density screening. This the actual
*                   threshold
*                   for the current iteration
*
           If (AInt.lt.CutInt) Go To 14
         Else
           If(NoCoul) then
              Dtst=Max(DMax(is,ls)/Four,DMax(is,ks)/Four,
     &                 DMax(js,ls)/Four,DMax(js,ks)/Four)
           Else If(NoExch) then
              Dtst=Max(DMax(is,js),DMax(ks,ls))
           Else
              Dtst=Max(DMax(is,ls)/Four,DMax(is,ks)/Four,
     &                 DMax(js,ls)/Four,DMax(js,ks)/Four,
     &                 DMax(is,js),DMax(ks,ls))
           End If
           If (Aint*Dtst.lt.ThrInt) goto 14
         End if
*                                                                      *
************************************************************************
*                                                                      *
         Call Eval_Ints_New_Inner
     &                  (iS,jS,kS,lS,TInt,nTInt,
     &                   iTOffs,No_Routine,
     &                   pDq,pFq,mDens,[ExFac],Nr_Dens,
     &                   [NoCoul],[NoExch],
     &                   Thize,W2Disc,PreSch,Disc_Mx,Disc,
     &                   Count,DoIntegrals,DoFock)

*
 14      Continue
         Count=Count+One
         If (Count-TskHi.gt.1.0D-10) Go To 12
         klS = klS + 1
         If (klS.gt.ijS) Then
            ijS = ijS + 1
            klS = 1
         End If
         iS = ip_ij(1,ijS)
         jS = ip_ij(2,ijS)
         kS = ip_ij(1,klS)
         lS = ip_ij(2,klS)
         Go To 13
*
*     Task endpoint
*
 12   Continue
*
      If (Semi_Direct) Then
         If (W2Disc) Then
            Call Put_QLast
         Else
            Call Pos_QLast(Disc)
         End If
      End If
*
*     Use a time slot to save the number of tasks and shell
*     quadruplets processed by an individual node
      Call SavStat(1,One,'+')
      Call SavStat(2,TskHi-TskLw+One,'+')
      Go To 10
 11   Continue
*     End of big task loop
      Call CWTime(TCpu2,TWall2)
      Call SavTim(1,TCpu2-TCpu1,TWall2-TWall1)
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*                                                                      *
      If (Semi_Direct) Call Close_SemiDSCF
      FstItr=.False.
*
      Call mma_deallocate(ip_ij)
      Call mma_deallocate(DMax)
      Call mma_deallocate(TMax)
*
      Verbose=.False.
      Free_K2=.False. ! Call to freek2 is external to the driver.
      Call Term_Ints(Verbose,Free_K2)
*
      Call Free_DeDe(Dens,TwoHam,nDens)
*
*
*     Broadcast contributions to the Fock matrix
*
      Call Sync_TH(TwoHam,nDens)
*                                                                      *
************************************************************************
*                                                                      *
CMAW start
C     CALL fmm_call_get_J_matrix(nDens,1,dens,TwoHam)
CMAW end
      Call Free_iSD()
      Return
      End
      Subroutine Init_SemiDSCF(FstItr,Thize,Cutint)
      use dEAF
      use IOBUF
      implicit real*8 (a-h,o-z)
#include "SysDef.fh"
      real*8 control(4)
      Logical FstItr
*     Write (6,*) 'Enter: Init_SemiDSCF'
*     Write (6,*) 'Ondisk=',Ondisk
*     Write (6,*) 'lBuf=',lBuf
*
*---- Initiate asynchronous double buffer I/O.
*
      IODone = .False.
      Disk = 0.0D0
      iBuf=1
      iPos = 1
      If (FstItr) Then
         iStatIO = Mode_Write
*        write(6,*) 'write istatio=',istatio
         control(1)=Dble(lbuf)
         control(2)=Dble(nbuf)
         control(3)=thize
         control(4)=cutint
*        write(6,*) 'control written:',control
C        Write (6,*) ' Initiate write @', Disk,'iBuf=',iBuf
         If(OnDisk) Call dEAFAwrite(LuTmp,control,4*RtoI,Disk,id)
      Else
         iStatIO = Mode_Read
*        write(6,*) 'read istatio=',istatio
*
*------- Initiate first read ahead of time.
*
*        Write (6,*) 'lBuf*RtoI=',lbuf*RtoI,' rtoi=',Rtoi
         If (OnDisk) then
C           Write (6,*) ' Initiate read @', Disk,'iBuf=',iBuf
            Call dEAFread(LuTmp,control,4*RtoI,Disk)
            Disk_2 = Disk
            Disk_1 = Disk
*           write(6,*) 'control read:',control
            lbufold=nint(control(1))
            nbufold=nint(control(2))
            thizeold=control(3)
            cutintold=control(4)
            if (lbufold.lt.lbuf) then
              write(6,*) 'Reducing the buffer size from ',lbuf,
     &                  ' to',lbufold
              lbuf=lbufold
            else if(lbufold.gt.lbuf) then
              write(6,*) 'Inconsistent buffer lengths. Old:',lbufold,
     &                   '  current:',lbuf
              call Abend()
            end if
            if(nbuf.ne.nbufold) then
              write(6,*) 'Inconsistent buffer number. Old:',nbufold,
     &                   '  current:',nbuf
              call Abend()
            end if
            if(abs(thize-thizeold).gt.1.d-10) then
              write(6,*) 'Resetting thize from',thize,' to',thizeold
              thize=thizeold
            end if
            if(cutintold.gt.cutint) then
              write(6,*) 'Inconsistent Cutint. Old:',cutintold,
     &                   '  current:',cutint
              call Abend()
            end if
c           Write (6,*) ' Initiate read @', Disk,'iBuf=',iBuf
*           If(OnDisk) Write (6,*) ' Initial EAFARead'
            Call dEAFARead(LuTmp,Buffer(1,iBuf),lBuf*RtoI,Disk,id)
         End If
      End If
*
*     Write (*,*) 'Exit: Init_SemiDSCF'
      Return
      End
      Subroutine Close_SemiDSCF()
      use IOBUF
*     Write (6,*) 'Enter: Close_SemiDSCF'
*
*---- If data was transfered to the I/O buffer write buffer on disc.
*
C  If buffer empty force the write :
      If (iPos.EQ.1) iPos=2
      If (OnDisk) Call WLBuf
*
      iPos = lStRec+1
      iStatIO = Mode_None
      iBuf = -99
*     Write (6,*) 'Exit: Close_SemiDSCF'
*
      Return
      End
      Subroutine Mode_SemiDSCF(Wr_Mode)
      use IOBUF
      Logical Wr_Mode
*
*     Write (6,*) 'Mode_SemiDSCF: Wr_Mode=',Wr_Mode
      If (Wr_Mode) Then
         If (iStatIO.eq.Mode_Read) Then
            Disk = Disk_2
            iStatIO = Mode_Write
*           Write (6,*) 'Changing to Write mode @',Disk
         End If
      Else
         If (iStatIO.eq.Mode_Write) Then
            Write (6,*) 'Change from Write to Read mode not implemented'
            Call Abend()
         End If
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3aphlp6(a1,a2,b,dimp,dimq,dimr,dimpq,ns,szkey)
! this routine realizes following procedure
! for symp=symq/=symr
!
! B(pq,r)=B(pq,r)+ns*(A1(q,r,p)-A2(p,r,q))
!
! a1    - A1 matrix (I)
! a2    - A2 matrix (I)
! b     - B  matrix (I/O)
! dimp  - dimension of p index (I)
! dimq  - dimension of q index (I)
! dimr  - dimension of r index (I)
! dimpq - dimension of pq (I)
! ns    - signum of the permutation (+-1) (I)
! szkey - set zero key (I)
!         = 0 no vanishing
!         = 1 set B=0 at the beginning

use CCT3_global, only: nshf
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dimr, dimpq, ns, szkey
real(kind=wp), intent(in) :: a1(dimq,dimr,dimp), a2(dimp,dimr,dimq)
real(kind=wp), intent(inout) :: b(dimpq,dimr)
integer(kind=iwp) :: p, pq0, r

if (szkey == 1) b(:,:) = Zero

if (ns == 1) then
  ! phase +1

  do r=1,dimr
    do p=2,dimp
      pq0 = nshf(p)
      b(pq0+1:pq0+p-1,r) = b(pq0+1:pq0+p-1,r)-a2(p,r,1:p-1)
    end do
  end do

  do p=2,dimp
    pq0 = nshf(p)
    b(pq0+1:pq0+p-1,:) = b(pq0+1:pq0+p-1,:)+a1(1:p-1,:,p)
  end do

else
  ! phase -1

  do r=1,dimr
    do p=2,dimp
      pq0 = nshf(p)
      b(pq0+1:pq0+p-1,r) = b(pq0+1:pq0+p-1,r)+a2(p,r,1:p-1)
    end do
  end do

  do p=2,dimp
    pq0 = nshf(p)
    b(pq0+1:pq0+p-1,:) = b(pq0+1:pq0+p-1,:)-a1(1:p-1,:,p)
  end do

end if

return

end subroutine t3aphlp6

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine AODKHEXP(NBasis,M,MX,M0,Ep,E0,EL,ES,OL,
     &                    W,TA,TB,A1,A2,O2,E2,F2,WS)
      Implicit Real*8(A-H,O-Z)
C
C     Do the Douglas-Kroll-Hess Arbitrary order term
C
C     Storage requirements:
C     Ep,E0 - NBasis
C     EL,ES,OL - NBasis*NBasis
C     W,TA,TB,A1,A2 - NBasis*NBasis
C     O2,E2,F2 - Nbasis*Nbasis*M (M=order of DKH)
C
      Dimension Ep(*),E0(*),EL(NBasis,*),ES(NBasis,*),OL(NBasis,*),
     &  W(NBasis,*),A1(NBasis,*),A2(NBasis,*),TA(NBasis,*),TB(NBasis,*),
     &  O2(NBasis,NBasis,*),E2(NBasis,NBasis,*),F2(NBasis,NBasis,*),
     &  WS(Nbasis,NBasis,*)
      Logical Ifodd
      Save Zero, One, Half
      Data Zero/0.d0/, One/1.d0/, Half/0.5d0/
C
C     Copy 1st order DKH effective potential
C     E2(upper-left) O2(upper-right) F2(lower-right)
C
      Do J = 1, NBasis
        Do I = 1, NBasis
          E2(I,J,1) = EL(I,J)
          F2(I,J,1) = ES(I,J)
          O2(I,J,1) = OL(I,J)
        End Do
      End Do
C
C     Apply [M/2] times Douglas-Kroll-Hess Unitary transformations
C
      Do Iut = 1, M/2
        Do I = 1, NBasis
          Do J = 1, NBasis
            W(J,I) = O2(J,I,Iut)/(Ep(I) + Ep(J))
            If(Iut.le.MX) WS(J,I,Iut*2-1) = W(J,I)
          End Do
        End Do
C      ! Apply W_{Iut} to O/E_{Ks}
        Do 40 Ks = M-Iut, 1, -1
C         ! W_{1} only apply to O/E_{1}
          If(Iut.eq.1.and.Ks.ge.2) Goto 40
          Do 50 Ioe = 1, 2
C           ! O_{k,k<Iut} was eliminated
            If(Ioe.eq.1.and.Ks.lt.Iut) Goto 50
            Ifodd = Ioe.eq.1
            Do I = 1, NBasis
              Do J = 1, NBasis
C               ! Copy O/E_{Ks} terms to temp arrays
                If(Ifodd)then
                  TA(J,I) = O2(J,I,Ks)
                Else
                  TA(J,I) = E2(J,I,Ks)
                  TB(J,I) = F2(J,I,Ks)
                Endif
              End Do
            End Do
            Do 60 K = Ks, M, Iut
C             ! skip terms do not contribute to final DKH Hamiltonian (even,upper-left)
              If(K+Iut+Iut.gt.M.and.(K+Iut.gt.M.or..not.Ifodd)) Goto 60
              KK = (K - Ks)/Iut + 1
              If(Ioe.eq.1.and.Ks.eq.Iut)then
C               ! see Eq.(74) of JCP130(2009)044102
                If(KK.eq.1)Then
                  Cof = Half
                Else
                  Cof = Dble(KK)/(KK*KK - One)
                Endif
              Else
C               ! see Eq.(71) of JCP130(2009)044102
                Cof = One/KK
              Endif
              If(Ifodd)then
C               ! skip terms do not contribute to final DKH Hamiltonian (even,upper-left)
                If(K+Iut+Iut+Iut.le.M)then
                  Call DGEMM_('T','N',NBasis,NBasis,NBasis,Cof,
     $                       W,NBasis,TA,NBasis,Zero,A2,NBasis)
                Endif
                Call DGEMM_('N','T',NBasis,NBasis,NBasis,Cof,
     $                     W,NBasis,TA,NBasis,Zero,A1,NBasis)
C               ! ( 0  W)(0  O)   (0  O)( 0  W)   ( WO'+(WO')'     0       )
C               ! (-W' 0)(O' 0) - (O' 0)(-W' 0) = (    0       -W'O-(W'O)' )
C               !  where W'=W^{\dag} O'=O^{\dag}
                Do I = 1, NBasis
                  Do J = 1, NBasis
                    If(K+Iut+Iut+Iut.le.M)then
                      TB(J,I) =-A2(J,I) - A2(I,J)
                      F2(J,I,K+Iut) = F2(J,I,K+Iut) + TB(J,I)
                    Endif
                    TA(J,I) = A1(J,I) + A1(I,J)
                    E2(J,I,K+Iut) = E2(J,I,K+Iut) + TA(J,I)
                  End Do
                End Do
              Else
                Call DGEMM_('N','N',NBasis,NBasis,NBasis,Cof,
     $                     W,NBasis,TB,NBasis,Zero,A1,NBasis)
                Call DGEMM_('N','N',NBasis,NBasis,NBasis,Cof,
     $                     TA,NBasis,W,NBasis,Zero,A2,NBasis)
C               ! ( 0  W)(E 0)   (E 0)( 0  W)   (    0     WF-EW )
C               ! (-W' 0)(0 F) - (0 F)(-W' 0) = ( (WF-EW)'   0   )
C               !  where W'=W^{\dag}
                Do I = 1, NBasis
                  Do J = 1, NBasis
                    TA(J,I) = A1(J,I) - A2(J,I)
                    O2(J,I,K+Iut) = O2(J,I,K+Iut) + TA(J,I)
                  End Do
                End Do
              Endif
              Ifodd = .not.Ifodd
   60       Continue
   50     Continue
   40   Continue
      End Do
C
C     Sum all even terms to Douglas-Kroll-Hess Hamiltonian
C
      Do I = 1, NBasis
        EL(I,I) = EL(I,I) + E0(I)
      End Do
      Do I = 2, M0
        Do J = 1, NBasis
          Do K = 1, Nbasis
            EL(K,J) = EL(K,J) + E2(K,J,I)
          End Do
        End Do
      End Do
C
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine HighFm(F,T,m,n)
************************************************************************
*  Object: to compute the auxiliary function for orders which we do    *
*          not use Shavitt's method of tables.                         *
*                                                                      *
* Called from: Auxil                                                   *
*                                                                      *
* Calling    : None                                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 F(n), T(n)
#include "real.fh"
*
*     Find T for which the asympotic formula can be used
*
      Tmax=50.0D0
 88   gTmp=Gamma2(m,Tmax)
         i = 1
         ii = 2*m-1
         sum1 = One
         sum0 =  One
 77      Sum1 = Sum1 * DBLE(ii) / (Two*Tmax)
         Sum0 = Sum0 + Sum1
         ii = ii - 2
         i = i + 1
         If (i.ge.m .and. Sum1/sum0.gt.1.0d-11) Go to 77
      Tnew = Log( sum0 / (2.0D-16*Tmax*gTmp)  )
      If (Abs(Tnew-Tmax).lt.1.0d-9) Go To 97
      Tmax = Tnew
      Go To 88
*
*     Compute the auxiliary functions
*
 97   Tmax = Tnew
      Do 100 k = 1, n
         If (T(k).lt.Tmax) Then
            Fvalue = Zero
            i = 0
            Term = One
 99         Continue
               Term = Term  / DBLE(2*(m+i)+1)
               Fvalue = Fvalue + Term
               i = i + 1
               Term = Term * (Two*T(k))
               If (Abs(Term/Fvalue).gt.1.0d-18) Go To 99
            F(k) = Exp(-T(k))*Fvalue
         Else
            F(k) = Gamma2(m,T(k))
         End If
 100  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module nq_Grid

use Definitions, only: wp, iwp

implicit none
private

! nGridMax: size of the array Grid
integer(kind=iwp) :: kAO = 0, nGridMax = 128, nRho = 0
logical(kind=iwp) :: l_CASDFT = .false.
integer(kind=iwp), allocatable :: Angular(:), iBfn_Index(:,:), IndGrd(:), iTab(:,:), List_G(:,:), nR_Eff(:)
real(kind=wp), allocatable :: Coor(:,:), D1Unzip(:,:), Dens_AO(:,:,:), dRho_dR(:,:,:), dW_dR(:,:), F_xc(:), F_xca(:), F_xcb(:), &
                              Fact(:,:), GradRho(:,:), Grid(:,:), Grid_AO(:,:,:,:), Lapl(:,:), Mem(:), P2Unzip(:,:,:,:), Pax(:,:), &
                              R2_trial(:), Rho(:,:), Sigma(:,:), Tau(:,:), Temp(:), vLapl(:,:), vRho(:,:), vSigma(:,:), vTau(:,:), &
                              Weights(:)
real(kind=wp), allocatable, target :: TabAO(:,:,:), TabAO_Short(:,:,:)
real(kind=wp), pointer :: TabAO_pack(:) => null()

public :: Angular, Coor, D1Unzip, Dens_AO, dRho_dR, dW_dR, F_xc, F_xca, F_xcb, Fact, GradRho, Grid, Grid_AO, iBfn_Index, IndGrd, &
          iTab, kAO, l_CASDFT, Lapl, List_G, Mem, nGridMax, nR_Eff, nRho, P2Unzip, Pax, R2_trial, Rho, Sigma, TabAO, TabAO_pack, &
          TabAO_Short, Tau, Temp, vLapl, vRho, vSigma, vTau, Weights

end module nq_Grid

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Vqr(LUQRP,MPLBL,ISIM,ZETA,NZ,OPMAT)
C
C...  Matrix of the atomic quasi-relativistic potential in the
C     1-center basis set. Mass-velocity and Darwin potentials,
*     which are read from the library in atomic units.
C
      Implicit Real*8 (A-H,O-Z)
      Character OrbLab*4, MPLbl*20, Keyw*40,
     &          RdName*40, DumCha*40, Line*80
      Real*8        ZETA(NZ),OPMAT(NZ*(NZ+1)/2)

*     Internal
      Parameter (MPoint=250)
      Real*8        R(Mpoint),V(Mpoint),FI(Mpoint),FIVFJ(Mpoint)

C...  auxiliar constant pool:    only DFAC is used here.
      PARAMETER (lp1=5,lp12=lp1*lp1,lp13=(lp1*lp1+lp1)/2)
      COMMON/CONST/RCA(lp1,lp13),DFAC(lp12),KOSUU(lp13),NYU(lp1,lp13)
      EXTERNAL      RDNAME,SIMPLM
      DATA          PI/3.141592653589793D0/
C...  Flags: MV bit 2, DW bit 3
*     Data iMVPot/2/,iDWPot/4/
C
      LU6=6
      N=ISIM
C
C...  Reads the Mass Velocity and Darwin potentials for the
C     valence orbitals
C
*     WRITE (LU6,600) ISIM,LUQRP
C
C               locate the beginning of the data
      KEYW=MPLBL
        DUMCHA=RDNAME(LUQRP,KEYW)
        IF (DUMCHA.EQ.' ') THEN
          WRITE (6,'(1X,A20'//
     &       ','' MV & DW potentials not found in unit '',I3)')
     &       KEYW,LUQRP
          Call Quit_OnUserError()
        ENDIF
*     Write (*,*) 'Data found in libray. Start reading.'
      Read (LUQRP,*) Npoint
      If (NPOINT.GT.MPoint) Then
        Write (6,*) 'VQR: nPoint',nPoint
        Write (6,*) 'Abend: Increade mPoint'
        Call Quit_OnUserError()
      Endif
      Read (LUQRP,'(4d20.13)') (R(k),k=1,Npoint)
*
1     Read (LUQRP,'(a80)',End=999) Line
      IF (Line(1:8).eq.MPLbl(1:8)) THEN
C...                             there is no potential for this symmetry
*       WRITE (*,603)
        Do  IJ=1,NZ*(NZ+1)/2
          OPMAT(IJ)=0D0
        End Do
        RETURN
      ELSE
        Read (Line,'(a4)') OrbLab
        Read (LUQRP,'(4d20.13)') (V(k),k=1,Npoint)
C
C...    check the symmetry
        IF (    ((INDEX(ORBLAB,'S').NE.0).AND.(ISIM.NE.1))
     .      .OR.((INDEX(ORBLAB,'P').NE.0).AND.(ISIM.NE.2))
     .      .OR.((INDEX(ORBLAB,'D').NE.0).AND.(ISIM.NE.3))
     .      .OR.((INDEX(ORBLAB,'F').NE.0).AND.(ISIM.NE.4))
     .         ) THEN
          GO TO 1
        ENDIF
      ENDIF
*     WRITE (*,601) ORBLAB,NPOINT,R(1),R(NPOINT)
C
C...  Matrix of a numerical local operator V(r)
C     given in a logaritmic mesh
C
      PREN=2D0**(N+1)/(sqrt(DFAC(2*N  )*sqrt(2D0*PI)))
      N2P1=2*N+1
      IJ=0
C
      DO 20 I=1,NZ
        ZI=ZETA(I)
        RNORI=PREN*sqrt(sqrt(ZI**N2P1))
        DO 210 K=1,NPOINT
          ERRE=R(K)
          FI(K)=RNORI*ERRE**(N-1)*EXP(-ZI*ERRE*ERRE)
210     CONTINUE
C
        DO 21 J=1,I
          ZJ=ZETA(J)
          RNORJ=PREN*sqrt(sqrt(ZJ**N2P1))
          DO 220 K=1,NPOINT
            ERRE=R(K)
            ERRE2=ERRE*ERRE
            FIVFJ(K)=RNORJ*ERRE**(N-1)*EXP(-ZJ*ERRE2)*FI(K)*V(K)*ERRE2
220       CONTINUE
C
          RES=SIMPLM(NPOINT,FIVFJ,R)
C
C...      add up the contribution from 0 to R(1)
          IJ=IJ+1
          OPMAT(IJ)=RES+FIVFJ(1)*R(1)/3D0
21      CONTINUE
20    CONTINUE
C
      RETURN
999   CONTINUE
      Write (6,*)
     &   ' Troubles reading MV and DW potentials from QRP library'
      Call Quit_OnUserError()
C
*600   FORMAT (/1X,'Symmetry ',I1,' : '
*     .        ,'Mass Velocity and Darwin potentials are read'
*     .        ,'  from unit ',I2)
*601   FORMAT (/' Orbital ',A4,' : ',I5,' points in the logarithmic ',
*     &         'mesh from ',F10.6,' to ',F10.6)
*602   FORMAT (/1X,' The symmetry label of one of the relativistic'
*     .,' potentials is not S, P, D, or F')
*603   FORMAT (/1X,' There is no potential for this symmetry.')
C
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!module_grad works for the ci gradient calculations.
! subroutine ci_grad
! subroutine ci_density_label
! subroutine convert_vector
! subroutine trans_ijkl_intpos
! subroutine trans_intpos_ijkl
! subroutine square_canonical
! subroutine moread
! subroutine lagran
! subroutine cidensity_test

!subroutine ci_grad()
!
!implicit none
!
!!================================================
!! the main subroutine for ci gradient calculations.
!! ican_a and ican_b save canonical order.
!! e(*) save the scf orbital energies.
!! xlgrn(*) save the lagrangian matrix.
!
!! ci gradient is still in development, so we do not include it in current
!! version of xian-ci
!
!return
!
!!write(u6,'(a18,2x,f10.2,2x,a1)') 'end of grad, takes',sc5-sc0,'s'
!end subroutine ci_grad

!subroutine convert_vector()
!
!implicit none
!
!!=====================================================
!! this just uses at debug.
!
!!open(10,file='cigmsvector')
!!do i=1,nci_dim
!!  read(10,*) iiii,val1,j,val2
!!  vector1(j) = val1
!!  if ((val2 > Zero) .and. (val1 < Zero)) vector1(j) = -vector1(j)
!!  if ((val2 < Zero) .and. (val1 > Zero)) vector1(j) = -vector1(j)
!!end do
!!close(10)
!
!end subroutine convert_vector

!subroutine moread(ii,jj,kk,ll,val)
!
!use gugaci_global, only: ican_a, ican_b, vector1
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: ii, jj, kk, ll
!real(kind=wp), intent(in) :: val
!integer(kind=iwp) :: lri, lrj, lrk, lrl, lrn, nij, nijkl, nkl
!
!!====================================================
!! transfer the ci mo indices to scf mo indices
!! and use library function ishft() to save
!! two electron mo indices to dm2_index().
!
!lrj = min(ii,jj)
!lri = max(ii,jj)
!lrl = min(kk,ll)
!lrk = max(kk,ll)
!if (lri < lrk) then
!  lrn = lrk
!  lrk = lri
!  lri = lrn
!  lrn = lrl
!  lrl = lrj
!  lrj = lrn
!end if
!if ((lri == lrk) .and. (lrj < lrl)) then
!  lrn = lrj
!  lrj = lrl
!  lrl = lrn
!end if
!
!nij = ican_a(lri)+lrj
!nkl = ican_a(lrk)+lrl
!nijkl = ican_b(nij)+nkl
!vector1(nijkl) = val
!!write(nf2,'(4i4,f18.10)') lri,lrj,lrk,lrl,vector1(nijkl)
!
!end subroutine moread

subroutine trans_ijkl_intpos(ii,jj,kk,ll,nxo)

use gugaci_global, only: ican_a, ican_b
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ii, jj, kk, ll
integer(kind=iwp), intent(out) :: nxo
integer(kind=iwp) :: lri, lrj, lrk, lrl, lrn, nij, nkl

!====================================================
! transfer the ci mo indices to scf mo indices
! and use library function ishft() to save
! two electron mo indices to dm2_index().
!write(nf2,'(4i4)') ii,jj,kk,ll

!i = map_orb_order_t(ii)
!j = map_orb_order_t(jj)
!k = map_orb_order_t(kk)
!l = map_orb_order_t(ll)

lrj = min(ii,jj)
lri = max(ii,jj)
lrl = min(kk,ll)
lrk = max(kk,ll)
if (lri < lrk) then
  lrn = lrk
  lrk = lri
  lri = lrn
  lrn = lrl
  lrl = lrj
  lrj = lrn
end if
if ((lri == lrk) .and. (lrj < lrl)) then
  lrn = lrj
  lrj = lrl
  lrl = lrn
end if

nij = ican_a(lri)+lrj
nkl = ican_a(lrk)+lrl
nxo = ican_b(nij)+nkl

!if (nxo == 3003) then
!  write(nf2,'(8i4,i8)') ii,jj,kk,ll,lri,lrj,lrk,lrl,nxo
!end if

end subroutine trans_ijkl_intpos

!subroutine trans_intpos_ijkl()
!
!implicit none
!
!!=========================================================
!! read the saved two electron mo indices.
!
!return
!
!end subroutine trans_intpos_ijkl

!subroutine lagran_act(x1e)
!
!use gugaci_global, only: dm1, ican_a, ican_b, norb_all, vector1, vector2, xlgrn
!use stdalloc, only: mma_allocate, mma_deallocate
!use Constants, only: Zero, Two
!use Definitions, only: wp, iwp
!
!implicit none
!real(kind=wp), intent(in) :: x1e(50000)
!integer(kind=iwp) :: i, i0, j, j0, k, k0, kl, l, l0, m, mik, mjk, nik, nil, niljk, nimkl, nji, njikl, njk, njmkl, nkl, norbf
!real(kind=wp) :: dum, dumtmp
!real(kind=wp), allocatable :: fock(:,:)
!
!!================================================
!! lyb
!! xlgrn(norb_all,norb_all) is the lagrange matrix.
!
!norbf = n_frz+1
!!norbf = 1
!
!xlgrn(1:n_all,1:n_all) = Zero
!
!call mma_allocate(fock,n_all,n_all,label='fock')
!call lagran_fock(x1e,fock)
!
!! form two electron contributions to the lagrangian with frozen mo
!
!do i=ndbl+1,n_all
!  do j=1,n_frz
!    dum = fock(j,i)*Two
!    do k=norbf,n_all
!      do l=norbf,n_all
!        i0 = max(i,j)
!        j0 = min(i,j)
!        nji = ican_a(i0)+j0
!        k0 = max(k,l)
!        l0 = min(k,l)
!        nkl = ican_a(k0)+l0
!        if (nji >= nkl) then
!          njikl = ican_b(nji)+nkl
!        else
!          njikl = ican_b(nkl)+nji
!        end if
!        dum = dum+dm1(k0,l0)*vector1(njikl)*Two
!
!        i0 = max(i,l)
!        l0 = min(i,l)
!        nil = ican_a(i0)+l0
!        j0 = max(j,k)
!        k0 = min(j,k)
!        njk = ican_a(j0)+k0
!        if (nil >= njk) then
!          niljk = ican_b(nil)+njk
!        else
!          niljk = ican_b(njk)+nil
!        end if
!        dum = dum-dm1(k0,l0)*vector1(niljk)
!      end do
!    end do
!    xlgrn(i,j) = xlgrn(i,j)+dum
!  end do
!end do
!
!do i=1,n_frz
!  do j=ndbl+1,n_all
!    dum = fock(j,i)*Two
!    do k=norbf,n_all
!      do l=norbf,n_all
!        i0 = max(i,j)
!        j0 = min(i,j)
!        nji = ican_a(i0)+j0
!        k0 = max(k,l)
!        l0 = min(k,l)
!        nkl = ican_a(k0)+l0
!        if (nji >= nkl) then
!          njikl = ican_b(nji)+nkl
!        else
!          njikl = ican_b(nkl)+nji
!        end if
!        dum = dum+dm1(k0,l0)*vector1(njikl)*Two
!
!        i0 = max(i,l)
!        l0 = min(i,l)
!        nil = ican_a(i0)+l0
!        j0 = max(j,k)
!        k0 = min(j,k)
!        njk = ican_a(j0)+k0
!        if (nil >= njk) then
!          niljk = ican_b(nil)+njk
!        else
!          niljk = ican_b(njk)+nil
!        end if
!        dum = dum-dm1(k0,l0)*vector1(niljk)
!      end do
!    end do
!    xlgrn(i,j) = xlgrn(i,j)+dum
!  end do
!end do
!
!! form two electron contributions to the lagrangian with active mo
!
!do i=norbf,ndbl
!  do j=ndbl+1,n_all
!    dum = Zero
!    do m=norbf,n_all
!      i0 = ican_a(max(i,m))+min(i,m)
!      j0 = ican_a(max(j,m))+min(j,m)
!      kl = 0
!      do k=norbf,n_all
!        dumtmp = Zero
!        do l=norbf,k-1
!          kl = kl+1
!          if (kl > i0) then
!            nimkl = ican_b(kl)+i0
!          else
!            nimkl = ican_b(i0)+kl
!          end if
!
!          if (kl > j0) then
!            njmkl = ican_b(kl)+j0
!          else
!            njmkl = ican_b(j0)+kl
!          end if
!          dumtmp = dumtmp+vector1(nimkl)*vector2(njmkl)
!          !if ((i == 1) .and. (j == 5)) write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl)
!        end do
!
!        dum = dum+dumtmp*Two
!
!        kl = kl+1
!        if (kl > i0) then
!          nimkl = ican_b(kl)+i0
!        else
!          nimkl = ican_b(i0)+kl
!        end if
!
!        if (kl > j0) then
!          njmkl = ican_b(kl)+j0
!        else
!          njmkl = ican_b(j0)+kl
!        end if
!
!        dum = dum+vector1(nimkl)*vector2(njmkl)
!        !if (nimkl /= njmkl) write(nf2,'(2i8,2f18.10)') nimkl,njmkl,vector1(nimkl),vector2(njmkl)
!        !if ((i == 1) .and. (j == 5)) write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl
!      end do
!    end do
!
!    xlgrn(i,j) = xlgrn(i,j)+dum*Two
!    !write(2,'(a7,2i4,f18.10)') 'xlgrn_2',i,j,xlgrn(i,j)
!  end do
!end do
!do i=norbf,ndbl
!  do j=ndbl+1,n_all
!    dum = Zero
!    do k=norbf,norb_all
!      mik = max(i,k)
!      nik = min(i,k)
!      mjk = max(j,k)
!      njk = min(j,k)
!      dum = dum+fock(mik,nik)*dm1(mjk,njk)
!
!      !write(nf2,'(2f18.10)') x1e(mnik),dm1(mjk,njk)
!    end do
!    xlgrn(i,j) = xlgrn(i,j)+dum
!    !write(2,'(a9,2i4,f18.10)') 'xlgrn_all',i,j,xlgrn(i,j)
!  end do
!end do
!
!do i=ndbl+1,n_all
!  do j=norbf,ndbl
!    dum = Zero
!    do m=norbf,n_all
!      i0 = ican_a(max(i,m))+min(i,m)
!      j0 = ican_a(max(j,m))+min(j,m)
!      kl = 0
!      do k=norbf,n_all
!        dumtmp = Zero
!        do l=norbf,k-1
!          kl = kl+1
!          if (kl > i0) then
!            nimkl = ican_b(kl)+i0
!          else
!            nimkl = ican_b(i0)+kl
!          end if
!
!          if (kl > j0) then
!            njmkl = ican_b(kl)+j0
!          else
!            njmkl = ican_b(j0)+kl
!          end if
!          dumtmp = dumtmp+vector1(nimkl)*vector2(njmkl)
!          !if ((i == 1) .and. (j == 5)) write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl)
!        end do
!
!        dum = dum+dumtmp*Two
!
!        kl = kl+1
!        if (kl > i0) then
!          nimkl = ican_b(kl)+i0
!        else
!          nimkl = ican_b(i0)+kl
!        end if
!
!        if (kl > j0) then
!          njmkl = ican_b(kl)+j0
!        else
!          njmkl = ican_b(j0)+kl
!        end if
!
!        dum = dum+vector1(nimkl)*vector2(njmkl)
!        !if (nimkl /= njmkl) write(nf2,'(2i8,2f18.10)') nimkl,njmkl,vector1(nimkl),vector2(njmkl)
!        !if ((i == 1) .and. (j == 5)) write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl
!      end do
!    end do
!
!    xlgrn(i,j) = xlgrn(i,j)+dum*Two
!    !write(2,'(a7,2i4,f18.10)') 'xlgrn_2',i,j,xlgrn(i,j)
!  end do
!end do
!
!do i=ndbl+1,n_all
!  do j=norbf,ndbl
!    dum = Zero
!    do k=norbf,norb_all
!      mik = max(i,k)
!      nik = min(i,k)
!      mjk = max(j,k)
!      njk = min(j,k)
!      dum = dum+fock(mik,nik)*dm1(mjk,njk)
!
!      !write(nf2,'(2f18.10)') x1e(mnik),dm1(mjk,njk)
!    end do
!    xlgrn(i,j) = xlgrn(i,j)+dum
!    !write(2,'(a9,2i4,f18.10)') 'xlgrn_all',i,j,xlgrn(i,j)
!  end do
!end do
!call mma_deallocate(fock)
!
!end subroutine lagran_act

!subroutine lagran_all(x1e)
!
!use gugaci_global, only: dm1, ican_a, ican_b, norb_all, vector1, vector2, xlgrn
!use Constants, only: Zero, Two
!use Definitions, only: wp, iwp
!
!implicit none
!real(kind=wp), intent(in) :: x1e(50000)
!integer(kind=iwp) :: i, i0, j, j0, k, kl, l, m, mik, mjk, mnik, nik, nimkl, njk, njmkl
!real(kind=wp) :: dum, dumtmp
!
!!================================================
!! lyb
!! xlgrn(norb_all,norb_all) is the lagrange matrix.
!
!!norbf = n_frz+1
!!norbf = 1
!
!xlgrn(1:norb_all,1:norb_all) = Zero
!
!! form two electron contributions to the lagrangian
!do i=1,norb_all
!  do j=1,norb_all
!    dum = Zero
!    do m=1,norb_all
!      i0 = ican_a(max(i,m))+min(i,m)
!      j0 = ican_a(max(j,m))+min(j,m)
!      kl = 0
!      do k=1,norb_all
!        dumtmp = Zero
!        do l=1,k-1
!          kl = kl+1
!          if (kl > i0) then
!            nimkl = ican_b(kl)+i0
!          else
!            nimkl = ican_b(i0)+kl
!          end if
!
!          if (kl > j0) then
!            njmkl = ican_b(kl)+j0
!          else
!            njmkl = ican_b(j0)+kl
!          end if
!          dumtmp = dumtmp+vector1(nimkl)*vector2(njmkl)
!          !if ((i == 1) .and. (j == 5)) write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl)
!        end do
!
!        dum = dum+dumtmp*Two
!
!        kl = kl+1
!        if (kl > i0) then
!          nimkl = ican_b(kl)+i0
!        else
!          nimkl = ican_b(i0)+kl
!        end if
!
!        if (kl > j0) then
!          njmkl = ican_b(kl)+j0
!        else
!          njmkl = ican_b(j0)+kl
!        end if
!
!        dum = dum+vector1(nimkl)*vector2(njmkl)
!        !if (nimkl /= njmkl) write(nf2,'(2i8,2f18.10)') nimkl,njmkl,vector1(nimkl),vector2(njmkl)
!        !if ((i == 1) .and. (j == 5)) write(nf2,'(6i4,i8,f18.10)') i,j,m,k,l,kl,njmkl,vector2(njmkl)
!      end do
!    end do
!
!    xlgrn(i,j) = xlgrn(i,j)+dum*Two
!    !write(2,'(a7,2i4,f18.10)') 'xlgrn_2',i,j,xlgrn(i,j)
!  end do
!end do
!do i=1,norb_all
!  do j=1,norb_all
!    dum = Zero
!    do k=1,norb_all
!      mik = max(i,k)
!      nik = min(i,k)
!      mjk = max(j,k)
!      njk = min(j,k)
!      mnik = ican_a(mik)+nik
!      dum = dum+x1e(mnik)*dm1(mjk,njk)
!
!      !write(nf2,'(2f18.10)') x1e(mnik),dm1(mjk,njk)
!    end do
!    xlgrn(i,j) = xlgrn(i,j)+dum
!    !write(2,'(a9,2i4,f18.10)') 'xlgrn_all',i,j,xlgrn(i,j)
!  end do
!end do
!
!end subroutine lagran_all

!subroutine writedm2(nx)
!
!!use gugaci_global, only: len_str, tmpdir
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: nx
!!character(len=256) :: filename
!
!!filename = tmpdir(1:len_str)//'/density'
!!len = len_str+8
!! Need debug
!!open(nf22,file=filename(1:len),form='unformatted')
!
!!open(nf22,file='density',form='unformatted')
!!write(nf22) (vector2(i),i=1,nx)
!!close(nf22)
!
!end subroutine writedm2
!
!subroutine readdm2(nx)
!
!!use gugaci_global, only: len_str, tmpdir
!use gugaci_global, only: vector2
!use Constants, only: Zero
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: nx
!!character(len=256) :: filename
!
!vector2(1:nx) = Zero
!
!!filename = tmpdir(1:len_str)//'/density'
!!len = len_str+8
!
!!open(nf22,file=filename(1:len),form='unformatted')
!
!!open(nf22,file='density',form='unformatted')
!!read(nf22) (vector2(i),i=1,nx)
!!close(nf22)
!
!end subroutine readdm2

!subroutine backtrans_test()
!
!use gugaci_global, only: cf, ican_a, ican_b, norb_all, norb_frz, vector2
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp) :: i, i0, j, j0, k, k0, l, l0, nij, nijkl, nkl
!real(kind=wp) :: sum_, val
!
!!-------------------------------------------------------------
!! this subroutine for test the backtrans result by just one density matr
!! ao, such as (ij|kl)
!
!sum_ = Zero
!i0 = 6
!j0 = 6
!k0 = 6
!l0 = 6
!
!do i=norb_frz+1,norb_all
!  do j=norb_frz+1,norb_all
!    if (i >= j) then
!      nij = ican_a(i)+j
!    else
!      nij = ican_a(j)+i
!    end if
!
!    do k=norb_frz+1,norb_all
!      do l=norb_frz+1,norb_all
!        if (k >= l) then
!          nkl = ican_a(k)+l
!        else
!          nkl = ican_a(l)+k
!        end if
!        if (nij >= nkl) then
!          nijkl = ican_b(nij)+nkl
!        else
!          nijkl = ican_b(nkl)+nij
!        end if
!        val = vector2(nijkl)
!        sum_ = sum_+val*cf(i0,i)*cf(j0,j)*cf(k0,k)*cf(l0,l)
!      end do
!    end do
!  end do
!end do
!
!!write(nf2,*) 'num 1 sum=',sum_
!
!end subroutine backtrans_test

!subroutine grad_two()
!
!use gugaci_global, only: dxyz, ican_a, ican_b, numat, vector1 !, len_str, tmpdir
!use stdalloc, only: mma_allocate, mma_deallocate
!use Constants, only: Zero, One, Two, auTokcalmol
!use Definitions, only: wp, iwp, u6
!
!implicit none
!integer(kind=iwp) :: i, i0, ind, j, j0, k, k0, l, l0, ncon, nij, nijkl, nkl, nnij, npat
!real(kind=wp) :: aa, bb, val, val1, val2
!!character(len=256) :: filename
!integer(kind=iwp), allocatable :: index_atom(:,:), ndi0(:), ndj0(:), ndk0(:), ndl0(:)
!real(kind=wp), allocatable :: daoint1(:), daoxyz(:,:), dgxyz(:,:)
!
!npat = numat*(numat+1)/2
!call mma_allocate(index_atom,3,npat,label='index_atom')
!index_atom(1:3,1:npat) = 0
!
!call mma_allocate(ndi0,ndao,label='ndi0')
!call mma_allocate(ndj0,ndao,label='ndj0')
!call mma_allocate(ndk0,ndao,label='ndk0')
!call mma_allocate(ndl0,ndao,label='ndl0')
!call mma_allocate(daoint1,ndao,label='daoint1')
!ndi0(:) = 0
!ndj0(:) = 0
!ndk0(:) = 0
!ndl0(:) = 0
!daoint1(:) = Zero
!
!!filename=  tmpdir(1:len_str)//'/daoints'
!!len = len_str+8
!
!!open(40,file=filename(1:len),form='formatted')
!
!!open(40,file='daoints',form='formatted')
!!read(40,*)
!
!!do i=1,3
!!  read(40,*) (index_atom(i,j),j=1,npat)
!!end do
!!read(40,*) (ndi0(i),i=1,ndao)
!!read(40,*) (ndj0(i),i=1,ndao)
!!read(40,*) (ndk0(i),i=1,ndao)
!!read(40,*) (ndl0(i),i=1,ndao)
!!read(40,*) (daoint1(i),i=1,ndao)
!!
!!close(40)
!
!ncon=0
!
!call mma_allocate(daoxyz,3,numat,label='daoxyz')
!do i=1,numat
!  do j=1,i-1
!    nnij = ican_a(i)+j
!    !write(nf2,*) i,ican_a(i)
!    do k=1,3
!      ind = index_atom(k,nnij)
!      val = Zero
!      do l=1,ind
!        ncon = ncon+1
!        i0 = ndi0(ncon)
!        j0 = ndj0(ncon)
!        k0 = ndk0(ncon)
!        l0 = ndl0(ncon)
!        val2 = daoint1(ncon)
!        !write(2,'(4i4,f18.10)') i0,j0,k0,l0,val2
!        nij = ican_a(j0)+i0
!        nkl = ican_a(l0)+k0
!        nijkl = ican_b(nij)+nkl
!        val1 = vector1(nijkl)
!        aa = One
!        bb = One
!        if (i0 /= j0) aa = Two*aa
!        if (k0 /= l0) bb = Two*bb
!        !===============================================================
!        ! this place should multiple two, because the gradient
!        ! integral always exist the relation that :
!        ! index nij=i*(i-1)/2+j
!        ! index nkl=k*(k-1)/2+l
!        ! but here always the nij >= nkl.
!
!        val = val+val1*val2*aa*bb*Two
!      end do
!      daoxyz(k,i) = daoxyz(k,i)+val
!      daoxyz(k,j) = daoxyz(k,j)-val
!
!      dxyz(k,i) = dxyz(k,i)+val
!      dxyz(k,j) = dxyz(k,j)-val
!    end do
!  end do
!end do
!call mma_deallocate(index_atom)
!call mma_deallocate(ndi0)
!call mma_deallocate(ndj0)
!call mma_deallocate(ndk0)
!call mma_deallocate(ndl0)
!call mma_deallocate(daoint1)
!
!call mma_allocate(dgxyz,3,numat,label='dgxyz')
!!dgxyz(1:3,1:numat) = Zero
!!do i=1,numat
!!  do j=1,3
!!    dgxyz(j,i) = daoxyz(j,i)*auTokcalmol
!!  end do
!!end do
!call mma_deallocate(daoxyz)
!
!
!!write(nf2,'(//10x,'cartesian coordinate derivatives',//3x,'number  atom ',5x,'x',12x,'y',12x,'z',/)')
!
!!do i=1,numat
!!  write(nf2,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
!!end do
!
!dgxyz(1:3,1:numat) = Zero
!do i=1,numat
!  do j=1,3
!    dgxyz(j,i) = dxyz(j,i)*auTokcalmol
!  end do
!end do
!
!!write(nf2,'(//10x,'cartesian coordinate derivatives',//3x,'number  atom ',5x,'x',12x,'y',12x,'z',/)')
!
!do i=1,numat
!  write(u6,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
!end do
!call mma_deallocate(dgxyz)
!
!end subroutine grad_two

!subroutine grad_one_ao()
!
!use gugaci_global, only: dxyz, ican_a, naorbs, numat, p !, len_str, tmpdir
!use stdalloc, only: mma_allocate, mma_deallocate
!use Constants, only: Zero, Two, auTokcalmol
!use Definitions, only: wp, iwp, u6
!
!implicit none
!integer(kind=iwp) :: i, j, k, l, nkl
!!character(len=256) :: filename
!real(kind=wp), allocatable :: dgxyz(:,:), dm1_act(:,:), dmo1xyz(:,:), dsaos(:,:,:)
!
!call mma_allocate(dsaos,3,numat,naorbs*(naorbs+1)/2,label='dsaos')
!dsaos(1:3,1:numat,1:naorbs*(naorbs+1)/2) = Zero
!
!!filename = tmpdir(1:len_str)//'/dfock1'
!!len = len_str+7
!
!!open(500,file=filename(1:len),form='unformatted')
!
!!open(500,file='dfock1',form='unformatted')
!!do i=1,numat
!!  do k=1,3
!!    read(500) (dsaos(k,i,j),j=1,naorbs*(naorbs+1)/2)
!!  end do
!!end do
!!close(500)
!
!call mma_allocate(dmo1xyz,3,numat,label='dmo1xyz')
!dmo1xyz(1:3,1:numat) = Zero
!
!!---------------------------------------------------
!! partial backtransform one electron density matrix
!
!call mma_allocate(dm1_act,naorbs,naorbs,label='dm1_act')
!dm1_act(1:naorbs,1:naorbs) = Zero
!call density_ci_one(dm1_act)
!
!!write(nf2,*) 'the new transformed dm1'
!
!do i=1,naorbs
!  do j=1,naorbs
!    dm1_act(i,j) = dm1_act(i,j)+Two*p(i,j)
!  end do
!end do
!
!!do i=1,naorbs
!!  do j=1,i
!!    write(nf2,'(2i8,f18.10)') i,j,dm1_act(i,j)
!!  end do
!!end do
!
!do i=1,3
!  do j=1,numat
!    do k=1,naorbs
!      do l=1,k
!        if (k == l) then
!          nkl = ican_a(k)+k
!          dxyz(i,j) = dxyz(i,j)+dsaos(i,j,nkl)*dm1_act(k,l)
!          dmo1xyz(i,j) = dmo1xyz(i,j)+dsaos(i,j,nkl)*dm1_act(k,l)
!
!        else
!          nkl = ican_a(k)+l
!          dxyz(i,j) = dxyz(i,j)+dsaos(i,j,nkl)*dm1_act(k,l)*Two
!
!          dmo1xyz(i,j) = dmo1xyz(i,j)+dsaos(i,j,nkl)*dm1_act(k,l)*Two
!        end if
!      end do
!    end do
!  end do
!end do
!call mma_deallocate(dsaos)
!call mma_deallocate(dm1_act)
!
!call mma_allocate(dgxyz,3,numat,label='dgxyz')
!!dgxyz(1:3,1:numat) = Zero
!!do i=1,numat
!!  do j=1,3
!!    dgxyz(j,i) = dmo1xyz(j,i)*auTokcalmol
!!  end do
!!end do
!call mma_deallocate(dmo1xyz)
!
!!write(nf2,'(//10x,"cartesian coordinate derivatives",//3x,"number  atom ",5x,"x",12x,"y",12x,"z",/)')
!!write(nf2,*) 'the one electron gradient'
!!do i=1,numat
!!  write(nf2,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
!!end do
!
!dgxyz(1:3,1:numat) = Zero
!do i=1,numat
!  do j=1,3
!    dgxyz(j,i) = dxyz(j,i)*auTokcalmol
!  end do
!end do
!
!write(u6,1000)
!
!do i=1,numat
!  write(u6,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
!end do
!call mma_deallocate(dgxyz)
!
!return
!
!1000 format(//10x,'cartesian coordinate derivatives',//3x,'number  atom ',5x,'x',12x,'y',12x,'z',/)
!
!end subroutine grad_one_ao

!subroutine grad_one_mo()
!
!use gugaci_global, only: cf, dm1, dxyz, ican_a, naorbs, norb_all, numat
!use stdalloc, only: mma_allocate, mma_deallocate
!use Constants, only: Zero, Two, auTokcalmol
!use Definitions, only: wp, iwp, u6
!
!implicit none
!integer(kind=iwp) :: i, i0, j, j0, k, l, nkl
!real(kind=wp) :: val
!real(kind=wp), allocatable :: dgxyz(:,:), dmo1xyz(:,:), dsaos(:,:,:)
!
!return
!
!call mma_allocate(dsaos,3,numat,naorbs*(naorbs+1)/2,label='dsaos')
!dsaos(1:3,1:numat,1:naorbs*(naorbs+1)/2) = Zero
!
!!open(500,file='dfock1',form='unformatted')
!!do i=1,numat
!!  do k=1,3
!!    do j=1,naorbs*(naorbs+1)/2
!!      read(500) dsaos(k,i,j)
!!    end do
!!  end do
!!end do
!!close(500)
!
!call mma_allocate(dmo1xyz,3,numat,label='dmo1xyz')
!dmo1xyz(1:3,1:numat) = Zero
!
!do i=1,3
!  do j=1,numat
!
!    do i0=1,norb_all
!      do j0=1,i0
!
!        val = Zero
!        do k=1,naorbs
!          do l=1,k
!            nkl = ican_a(k)+l
!
!            if (k == l) then
!              val = val+dsaos(i,j,nkl)*cf(k,i0)*cf(l,j0)
!            else
!              val = val+dsaos(i,j,nkl)*cf(k,i0)*cf(l,j0)+dsaos(i,j,nkl)*cf(k,j0)*cf(l,i0)
!            end if
!          end do
!        end do
!        if (i0 == j0) then
!          dxyz(i,j) = dxyz(i,j)+dm1(i0,j0)*val
!          dmo1xyz(i,j) = dmo1xyz(i,j)+dm1(i0,j0)*val
!
!        else
!          dxyz(i,j) = dxyz(i,j)+dm1(i0,j0)*val*Two
!          dmo1xyz(i,j) = dmo1xyz(i,j)+dm1(i0,j0)*val*Two
!
!        end if
!        write(u6,'(2i4,2f18.10)') i0,j0,dm1(i0,j0),val
!      end do
!    end do
!  end do
!end do
!call mma_deallocate(dsaos)
!
!call mma_allocate(dgxyz,3,numat,label='dgxyz')
!dgxyz(1:3,1:numat) = Zero
!do i=1,numat
!  do j=1,3
!    dgxyz(j,i) = dmo1xyz(j,i)*auTokcalmol
!  end do
!end do
!call mma_deallocate(dmo1xyz)
!
!write(u6,1000)
!
!do i=1,numat
!  write(u6,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
!end do
!
!dgxyz(1:3,1:numat) = Zero
!do i=1,numat
!  do j=1,3
!    dgxyz(j,i) = dxyz(j,i)*auTokcalmol
!  end do
!end do
!
!write(u6,1000)
!
!do i=1,numat
!  write(u6,'(6x,i6,3f13.6)') i,(dgxyz(j,i),j=1,3)
!end do
!call mma_deallocate(dgxyz)
!
!return
!
!1000 format(//10x,'cartesian coordinate derivatives',//3x,'number  atom ',5x,'x',12x,'y',12x,'z',/)
!
!end subroutine grad_one_mo

!subroutine density_ci_one(dm1_act)
!
!use gugaci_global, only: cf, dm1, naorbs, norb_all, norb_frz
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!real(kind=wp), intent(out) :: dm1_act(naorbs,naorbs)
!integer(kind=iwp) :: i, j, norbf, np, nq
!
!norbf = norb_frz+1
!do i=1,naorbs
!  do j=1,i
!    dm1_act(i,j) = Zero
!    do np=norbf,norb_all
!      do nq=norbf,np
!        if (np == nq) then
!          dm1_act(i,j) = dm1_act(i,j)+dm1(np,nq)*cf(i,np)*cf(j,nq)
!        else
!          dm1_act(i,j) = dm1_act(i,j)+dm1(np,nq)*cf(i,np)*cf(j,nq)+dm1(np,nq)*cf(j,np)*cf(i,nq)
!        end if
!      end do
!    end do
!    dm1_act(j,i) = dm1_act(i,j)
!  end do
!end do
!
!end subroutine density_ci_one

!subroutine lagran_fock(x1e,fock)
!
!use gugaci_global, only: ican_a, ican_b, vector1
!use Constants, only: Zero, Two
!use Definitions, only: wp, iwp
!
!implicit none
!real(kind=wp), intent(in) :: x1e(50000)
!real(kind=wp), intent(out) :: fock(n_all,n_all)
!integer(kind=iwp) :: i, i0, j, j0, k, k0, nij, nijkk, nik, nikjk, njk, nkk
!real(kind=wp) :: val
!
!fock(1:n_all,1:n_all) = Zero
!
!do i=1,n_all
!  do j=1,i
!    nij = ican_a(i)+j
!    fock(i,j) = x1e(nij)
!    val = Zero
!    do k=1,n_frz
!      nkk = ican_a(k)+k
!      if (nij >= nkk) then
!        nijkk = ican_b(nij)+nkk
!      else
!        nijkk = ican_b(nkk)+nij
!      end if
!      val = val+vector1(nijkk)*Two
!
!      i0 = max(i,k)
!      k0 = min(i,k)
!      nik = ican_a(i0)+k0
!      j0 = max(j,k)
!      k0 = min(j,k)
!      njk = ican_a(j0)+k0
!      nikjk = ican_b(nik)+njk
!      val = val-vector1(nikjk)
!    end do
!    fock(i,j) = fock(i,j)+val
!    fock(j,i) = fock(i,j)
!  end do
!end do
!
!end subroutine lagran_fock

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkQ3 (V)
c
c        Q1(a,b,c,l) <- V(ab,cl)
c
        implicit none
#include "chcc1.fh"
        real*8 V(1:nv*(nv+1)/2,1:no,1:nv)
c
c        help variables
        integer a,b,ab,c,l
c
        do l=1,no
        do c=1,nv
          ab=0
          do a=1,nv
          do b=1,a
          ab=ab+1
            Q3(a,b,c,l)=V(ab,l,c)
            Q3(b,a,c,l)=V(ab,l,c)
          end do
          end do
        end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CRESTR(STRING,NSTINI,NSTINO,NEL,NORB,Z,NEWORD,LSGSTR,ISGSTI,ISGSTO,TI,TTO,ISTMPL,ISTMPO,LROW,I1TYP)
! A set of strings containing NEL electrons are given
! set up all possible ways of adding an electron to this set of strings
!
!========
! Input :
!========
!
! STRING : Input strings containing NEL electrons
! NSTINI : Number of input  strings
! NSTINO : Number of output strings
! NEL    : Number of electrons in input strings
! NORB   : Number of orbitals
! Z      : Lexical ordering matrix for output strings containing
!          NEL + 1 electrons
! NEWORD : Reordering array for N+1 strings
! LSGSTR : /= 0 => Include sign arrays ISGSTI,ISGSTO of strings
! ISGSTI : Sign array for NEL   strings
! ISGSTO : Sign array for NEL+1 strings
!
! LROW   : Length of tables for each string, negative number
!          indicates compact form
!=========
! Output :
!=========
!
!TI      : TI(I,ISTRIN) > 0 indicates that orbital I can be added
!          to string ISTRIN.
!TTO     : Resulting NEL + 1 strings
!          if the resulting string has carries a negative sign
!          then the string number is negative
!          TTO(I,ISTRIN) = LSTRIN /= 0 indicates that I added to
!                          ISTRIN  gives LSTRIN. If LSTRIN is
!                          gt. NSTINO then
!                          A+(I)!ISTRIN>=-!LSTRIN-NSTINO>.
! If lrow <= 0 TI and TTO are constructed in sparse form using
! ISTMPO and ISTMPL as pointers
! ISTST

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NSTINI, NEL, STRING(NEL,NSTINI), NSTINO, NORB, Z(NORB,NEL+1), NEWORD(NSTINO), LSGSTR, &
                                 ISGSTI(NSTINI), ISGSTO(NSTINO), LROW, I1TYP
integer(kind=iwp), intent(_OUT_) :: TI(*), TTO(*), ISTMPL(*), ISTMPO(*)
integer(kind=iwp) :: IEL, IIISGN, IOFF, IORB, IPLACE, ISTRIN, ITYPE, JSTRIN, LCR, STRIN2(NEL+1)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I, NPR
integer(kind=iwp), parameter :: MAXPR = 60
#endif
integer(kind=iwp), external :: IOCTP2_MCLR, ISTRNM

! LCR NOT DECLARED !!!!!!
!  I SET IT TO ZERO
LCR = 0
#ifdef _DEBUGPRINT_
write(u6,*) ' ==============='
write(u6,*) ' CRESTR speaking'
write(u6,*) ' ==============='
#endif

IOFF = 0     ! dummy initialize
IPLACE = -1  ! dummy initialize
do ISTRIN=1,NSTINI
  ! Offset for current creations from this string
  if (ISTRIN == 1) then
    IOFF = 1
  else
    if (LROW > 0) then
      IOFF = (ISTRIN-1)*LROW+1
    else
      IOFF = IOFF+LCR
    end if
  end if
  LCR = 0
  do IORB=1,NORB

    if (NEL == 0) then
      IPLACE = 1

    else if (NEL /= 0) then

      do IEL=1,NEL
        if ((IEL == 1) .and. (STRING(1,ISTRIN) > IORB)) then
          IPLACE = 1
          exit
        else if (((IEL == NEL) .and. (IORB > STRING(IEL,ISTRIN))) .or. &
                 ((IEL < NEL) .and. (IORB > STRING(IEL,ISTRIN)) .and. (IORB < STRING(min(NEL,IEL+1),ISTRIN)))) then
          IPLACE = IEL+1
          exit
        else if (STRING(IEL,ISTRIN) == IORB) then
          IPLACE = 0
          exit
        end if
      end do

    end if

    if (IPLACE == 0) cycle

    ! Generate next string
    STRIN2(1:IPLACE-1) = STRING(1:IPLACE-1,ISTRIN)
    STRIN2(IPLACE) = IORB
    STRIN2(IPLACE+1:NEL+1) = STRING(IPLACE:NEL,ISTRIN)
    ! Is new string allowed?
    ITYPE = IOCTP2_MCLR(STRIN2,NEL+1,I1TYP)
    if (ITYPE /= 0) then
      JSTRIN = ISTRNM(STRIN2,NORB,NEL+1,Z,NEWORD,1)
      ! Save it!
      if (LROW > 0) then
        LCR = IORB
      else
        LCR = LCR+1
      end if

      TTO(IOFF-1+LCR) = JSTRIN
      IIISGN = (-1)**(IPLACE-1)
      if (LSGSTR /= 0) IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
      if (IIISGN == -1) TTO(IOFF-1+LCR) = -TTO(IOFF-1+LCR)
      TI(IOFF-1+LCR) = IORB

      !TTO(IORB,ISTRIN) = JSTRIN
      !IIISGN = (-1)**(IPLACE-1)
      !if (LSGSTR /= 0) IIISGN = IIISGN*ISGSTO(JSTRIN)*ISGSTI(ISTRIN)
      !if (IIISGN == -1) TTO(IORB,ISTRIN) = -TTO(IORB,ISTRIN)
      !TI(IORB,ISTRIN) = IORB
    end if
  end do

  if (LROW < 0) then
    ISTMPO(ISTRIN) = IOFF
    ISTMPL(ISTRIN) = LCR
    !write(u6,*) ' ISTRIN ISTMPO ISTMPL'
    !write(u6,*) ISTRIN,ISTMPO(ISTRIN),ISTMPL(ISTRIN)
  end if
end do

#ifdef _DEBUGPRINT_
NPR = min(NSTINI,MAXPR)
write(u6,*) ' Output from CRESTR :'
write(u6,*) '==================='

if (LROW > 0) then
  write(u6,*) ' Full map'
  write(u6,*)
  write(u6,*) ' Strings with an electron added'
  do ISTRIN=1,NPR
    write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' New strings.. ',(TTO((ISTRIN-1)*LROW+I),I=1,NORB)
  end do
  do ISTRIN=1,NPR
    write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' orbitals added or removed ',(TI((ISTRIN-1)*LROW+I),I=1,NORB)
  end do
else
  write(u6,*) ' Compact map'
  write(u6,*)
  write(u6,*) ' Strings with an electron added'
  do ISTRIN=1,NPR
    write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' New strings.. ',(TTO(ISTMPO(ISTRIN)-1+I),I=1,ISTMPL(ISTRIN))
  end do
  do ISTRIN=1,NPR
    write(u6,'(2X,A,I4,A,/,(10I5))') 'String..',ISTRIN,' orbitals added or removed ',(TI(ISTMPO(ISTRIN)-1+I),I=1,ISTMPL(ISTRIN))
  end do
end if
#endif

return

end subroutine CRESTR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Bond_List(nq,nsAtom,iIter,nIter,Cx,Process,Valu,nB,qLbl,fconst,rMult,LuIC,Indq,Proc_dB,iTabBonds,nBonds,iTabAI,mAtoms, &
                     mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,mqB)

use Symmetry_Info, only: nIrrep, iOper
use Slapaf_Info, only: ANr, AtomLbl, Fragments_Bond, iOptC, jStab, Magic_Bond, nStab, vdW_Bond
use ddvdt, only: A_StrH, aAV, alpha_vdW, f_Const_Min, r_ref_vdW, rAV, rkr, rkr_vdW
use Molcas, only: LenIn
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nsAtom, iIter, nIter, nB, LuIC, nBonds, iTabBonds(3,nBonds), mAtoms, iTabAI(2,mAtoms), nB_Tot, &
                                 ndB_Tot
integer(kind=iwp), intent(inout) :: nq, Indq(3,nB), mB_Tot, mdB_Tot, iBM(nB_Tot), idBM(2,ndB_Tot), mqB(nB)
real(kind=wp), intent(in) :: Cx(3,nsAtom,nIter)
logical(kind=iwp), intent(in) :: Process, Proc_dB
real(kind=wp), intent(inout) :: Valu(nB,nIter), fconst(nB), rMult(nB), BM(nB_Tot), dBM(ndB_Tot)
character(len=14), intent(inout) :: qLbl(nB)
integer(kind=iwp), parameter :: mB = 2*3
integer(kind=iwp) :: iAtom, iAtom_, iBond, iBondType, iCase, iDeg, iDCR(2), iDCRR(0:7), iE1, iE2, iF1, iF2, Ind(2), iRow, &
                     iStabM(0:7), jAtom, jAtom_, jRow, kDCRR, Lambda, nCent, nDCRR, nqB, nStabM
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif
real(kind=wp) :: A(3,2), Alpha, Deg, f_Const, Grad(mB), Hess(mB**2), r0, Rab, RabCov, Rij2, Val
logical(kind=iwp) :: Help
character(len=14) :: Label
character(len=LenIn+4) :: Lbls(2)
integer(kind=iwp), parameter :: iChOp(0:7) = [1,1,1,2,1,2,2,3]
character(len=*), parameter :: ChOp(0:7) = ['E  ','X  ','Y  ','XY ','Z  ','XZ ','YZ ','XYZ']
real(kind=wp), external :: CovRad
logical(kind=iwp), external :: R_Stab_A

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
if (nBonds < 1) return

nqB = 0
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ---> Enter Bonds.'
write(u6,*)
write(u6,*) 'Process=',Process
call RecPrt('CX',' ',CX,3*nsAtom,nIter)
write(u6,'(20(1X,A))') (AtomLbl(i),i=1,nsAtom)
write(u6,*)
write(u6,*) ' iTabAI'
write(u6,*)
do iAtom=1,mAtoms
  write(u6,*) iTabAI(1,iAtom),iTabAI(2,iAtom)
end do
#endif

! Loop over bonds

nCent = 2
do iBond=1,nBonds
  iBondType = iTabBonds(3,iBond)

  ! We will only incorpotate covalent and fragment bonds

  if (iBondType == vdW_Bond) cycle   ! vdW bonds
  if (iBondType > Magic_Bond) cycle  ! magic bonds

  do iCase=1,2

    if (iCase == 1) then
      iAtom_ = iTabBonds(1,iBond)
      jAtom_ = iTabBonds(2,iBond)
    else
      iAtom_ = iTabBonds(2,iBond)
      jAtom_ = iTabBonds(1,iBond)
    end if
    iAtom = iTabAI(1,iAtom_)
    jAtom = iTabAI(1,jAtom_)

    iDCR(1) = iTabAI(2,iAtom_)
    iDCR(2) = iTabAI(2,jAtom_)
    if (jAtom > iAtom) cycle
    if (iDCR(1) /= iOper(0)) cycle
    if (R_Stab_A(iDCR(2),jStab(0,iAtom),nStab(iAtom)) .and. (iDCR(2) /= iOper(0))) cycle
    iRow = max(ANr(iAtom),1)
    jRow = max(ANr(jAtom),1)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iAtom,jAtom=',iAtom,jAtom
#   endif
    Help = (iRow > 3) .or. (jRow > 3)
    Ind(1) = iAtom
    Ind(2) = jAtom
    A(:,1) = Cx(:,iAtom,iIter)
    write(Label,'(A,I2,A,I2,A)') 'B(',iAtom,',',jAtom,')'

#   ifdef _DEBUGPRINT_
    call RecPrt('A',' ',Cx(:,iAtom,iIter),1,3)
    call RecPrt('B',' ',Cx(:,jAtom,iIter),1,3)
#   endif

    ! Form double coset representatives

    call DCR(Lambda,jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),iDCRR,nDCRR)
    kDCRR = iDCR(2)

#   ifdef _DEBUGPRINT_
    write(u6,'(10A)') 'U={',(ChOp(jStab(i,iAtom)),i=0,nStab(iAtom)-1),'}  '
    write(u6,'(10A)') 'V={',(ChOp(jStab(i,jAtom)),i=0,nStab(jAtom)-1),'}  '
    write(u6,'(10A)') 'R={',(ChOp(iDCRR(i)),i=0,nDCRR-1),'}  '
    write(u6,'(2A)') 'R=',ChOp(iDCR(2))
#   endif

    call OA(iDCR(2),Cx(:,jAtom,iIter),A(:,2))

    ! Compute the stabilizer of A & R(B), this is done in two ways.
    !
    ! A=/=B, the stabilizer is formed as the intersection of
    !        the stabilizers of A and B.
    !
    ! A=B, the stabilizer is formed as union of U and R(U)

    if (iAtom /= jAtom) then
      call Inter(jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),iStabM,nStabM)
    else
      call Union(jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),kDCRR,iStabM,nStabM)
    end if
#   ifdef _DEBUGPRINT_
    write(u6,'(10A)') 'M={',(ChOp(iStabM(i)),i=0,nStabM-1),'}  '
#   endif

    ! Now evaluate the degeneracy of the bond.

    iDeg = nIrrep/nStabM
    Deg = sqrt(real(iDeg,kind=wp))
#   ifdef _DEBUGPRINT_
    write(u6,*) ' nIrrep,nStabM=',nIrrep,nStabM
#   endif

    nq = nq+1
    if (.not. Process) mB_Tot = mB_Tot+mB
    if (.not. Proc_dB) mdB_Tot = mdB_Tot+mB**2

    nqB = nqB+1
    iF1 = 1
    call NxtWrd(AtomLbl(iAtom),iF1,iE1)
    Lbls(1) = AtomLbl(iAtom)(iF1:iE1)
    iF2 = 1
    call NxtWrd(AtomLbl(jAtom),iF2,iE2)
    Lbls(2) = AtomLbl(jAtom)(iF2:iE2)
    if (kDCRR /= 0) then
      Lbls(2)(iE2+1:iE2+1) = '('
      Lbls(2)(iE2+2:iE2+1+iChOp(kDCRR)) = ChOp(kDCRR)(1:iChOp(kDCRR))
      Lbls(2)(iE2+2+iChOp(kDCRR):iE2+2+iChOp(kDCRR)) = ')'
      call NxtWrd(Lbls(2),iF2,iE2)
    end if
    write(LuIC,'(A,I3.3,4A)') 'b',nqB,' = Bond ',Lbls(1)(iF1:iE1),' ',Lbls(2)(iF2:iE2)
#   ifdef _DEBUGPRINT_
    write(u6,'(A,I3.3,4A)') 'b',nqB,' = Bond ',Lbls(1)(iF1:iE1),' ',Lbls(2)(iF2:iE2)
#   endif
    Label = ' '
    write(Label,'(A,I3.3)') 'b',nqB
    if (.not. Proc_dB) Hess(:) = Zero
    call Strtch(A,nCent,Val,Grad,.false.,'        ',Hess,Proc_dB)

    if (Process) then

      Indq(1,nq) = 1
      Indq(2,nq) = (jAtom-1)*nsAtom+iAtom
      Indq(3,nq) = kDCRR+1

      Rij2 = (A(1,1)-A(1,2))**2+(A(2,1)-A(2,2))**2+(A(3,1)-A(3,2))**2
      Rab = sqrt(Rij2)
      if (Help) then
        RabCov = CovRad(ANr(iAtom))+CovRad(ANr(jAtom))
        !if ((iRow == 1) .and. (jRow == 1)) then
        !  ! Bond a la Fischer & Almlof
        f_Const = A_StrH(1)*exp(-A_StrH(2)*(Rab-RabCov))
        !else
        !  ij = iTri(iRow+1,jRow+1)-1
        !  f_Const = A_Str/(Rab-B_Str(ij))**3
        !end if
      else
        if (btest(iOptC,11) .and. (iBondType == 1)) then
          r0 = r_ref_vdW(iRow,jRow)
          f_Const = rkr_vdW*exp(-Alpha_vdW*(Rab-r0)**2)
        else
          r0 = rAV(iRow,jRow)
          Alpha = aAV(iRow,jRow)
          f_Const = rkr*exp(Alpha*(r0**2-rij2))
        end if
      end if

      f_Const = max(f_Const,f_Const_Min)
      if (iBondType == Fragments_Bond) f_Const = f_Const*1.0e3_wp
      fconst(nq) = sqrt(f_Const)
      rMult(nq) = Deg

      Valu(nq,iIter) = Val
      qLbl(nq) = Label

      ! Project the gradient vector

      call ProjSym(nCent,Ind,A,iDCR,Grad,Hess,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,Proc_dB,mqB,nB,nq,rMult(nq))

    end if

  end do     ! iCase

end do       ! iBond

return

end subroutine Bond_List

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CREIPH()
! RASSCF program: version IBM 3090: input section
!
! Purpose: to set up an result file (JOBIPH = 15) where the most
!          important results of the calculation are collected as
!          an interphase to other programs. JOBIPH is a direct
!          acces file where the first record is a table of content.
!          The address to this record is zero. The table of content
!          has presently the length 15 and is stored in
!          COMMON/INTAUX/ as IADR15(15).
! Subsections of JOBIPH:
! IADR15(1):  List of input data written here with WR_RASSCF_Info
! IADR15(2):  Molecular orbitals first written here and then updated
!             at the end of SXCTL in each MCSCF itration.
!             To be used as starting orbitals for restarts|
!             Modified finally by NEWORB to pseudo-nat orbitals
!             Average occupation numbers appended.
! IADR15(3):  density matrices for active orbitals
!             (4 matrices per root)
!             D  : one-body density matrix
!             DS : spin density matrix
!             P  : symmetric two-body density matrix
!             PA : antsymmetric two-body density matrix
! IADR15(4):  The CI-vectors corresponding to the LROOTS lowest
!             roots written in CICTL after each iteration.
! IADR15(5):  The Fock matrix for the occupied orbitals.
!             written in FOCKOC at the end of the calculation.
! IADR15(6):  Energies given in array ENER(10,50) in COMMON/RELAUX/.
! IADR15(7):  Convergence parameters in array CONV(6,50) in RELAUX.
! IADR15(8):  Not used
! IADR15(9):  Canonical MO's constructed and written in FCKPT2 at
!             the end of the calculation.
! IADR15(10): Inactive Fock matrix for CASPT2 in MO basis
!             Note: Frozen and deleted orbitals not included,
!             Modified to include the CASPT2 matrix FP 900608 (BOR)
! IADR15(11): The diagonal of the CASPT Fock matrix.
! IADR15(12): Natural orbitals for the final wave functions.
!             Note: These orbitals do not correspond to the same
!             CI wave function and should only be used to compute
!             properties.
!             One set of orbitals is stored for each root.
!             Each set of NO's is followed by a record
!             containing the corresponding occupation numbers.
! IADR15(13): One-body spin density matrices (one for each root)
! IADR15(14): Spin orbitals for the final wave functions.
!             Note: These orbitals do not correspond to the same
!             CI wave function and should only be used to compute
!             spin properties.
!             One set of orbitals for each root in an average
!             calculation. Stored sequentially (891219).
!             Each set of NO's is followed by a record
!             containing the corresponding occupation numbers.
! IADR15(15): First unwritten disk address, if positive;
!             If = -1, it means a new JOBIPH structure is used,
!             same as before, except:
! IADR15(16): First unwritten disk address (new layout),
! IADR15(17): Effective Hamiltonian, written here by MS-CASPT2,
!             LROOTS**2 elements, Fortran standard layout.
! IADR15(18): Table that translates between levels and absolute
!             orbital indices, setup by setsxci.
! IADR15(19)--IADR15(30): Presently unused.
! ********** IBM 3090 MOLCAS Release 90 02 22 **********

use sxci, only: IDXCI, IDXSX
use rasscf_global, only: BName, header, IADR15, IPT2, iRoot, lRoots, NACPAR, NACPR2, nOrbT, nRoots, NTOT3, POTNUC, Title, Weight
use general_data, only: ISPIN, JOBIPH, NACTEL, NASH, NBAS, NCONF, NDEL, NELEC3, NFRO, NHOLE1, NISH, NRS1, NRS2, NRS3, NSYM, NTOT, &
                        NTOT2, STSYM
use Molcas, only: LenIn, MxAct, MxOrb, MxRoot, MxSym
use RASDim, only: MxIter, MxTit
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: I, IAD15, NFOCK
real(kind=wp) :: Dum(1)
real(kind=wp), allocatable :: HEFF(:,:)

IADR15(1:15) = 0
! Dummy write table of contents.
! New layout scheme; length is 30 integers.
IAD15 = 0
call IDAFILE(JOBIPH,1,IADR15,30,IAD15)
IADR15(1) = IAD15

! DUMMY WRITE THE REMAINING RECORDS TO OBTAIN ADDRESSES

call WR_RASSCF_Info(JOBIPH,1,iAD15,NACTEL,ISPIN,NSYM,STSYM,NFRO,NISH,NASH,NDEL,NBAS,MxSym,BName,(LenIn+8)*mxOrb,NCONF,HEADER,144, &
                    TITLE,4*18*mxTit,POTNUC,LROOTS,NROOTS,IROOT,MxRoot,NRS1,NRS2,NRS3,NHOLE1,NELEC3,IPT2,WEIGHT)
IADR15(2) = IAD15

call DDAFILE(JOBIPH,0,DUM,NTOT2,IAD15)
call DDAFILE(JOBIPH,0,DUM,NTOT,IAD15)
IADR15(3) = IAD15
do i=1,lRoots
  call DDafIle(JOBIPH,0,Dum,NACPAR,IAD15)
  call DDafIle(JOBIPH,0,Dum,NACPAR,IAD15)
  call DDafIle(JOBIPH,0,Dum,NACPR2,IAD15)
  call DDafIle(JOBIPH,0,Dum,NACPR2,IAD15)
end do
IADR15(4) = IAD15
do i=1,lRoots
  call DDafIle(JOBIPH,0,Dum,nConf,IAD15)
end do
IADR15(5) = IAD15
NFOCK = sum((NISH(1:NSYM)+NASH(1:NSYM))**2)
call DDAFILE(JOBIPH,0,DUM,NFOCK,IAD15)
IADR15(6) = IAD15
call DDAFILE(JOBIPH,0,DUM,mxRoot*mxIter,IAD15)
IADR15(7) = IAD15
call DDAFILE(JOBIPH,0,DUM,6*mxIter,IAD15)
IADR15(8) = IAD15
IADR15(9) = IAD15
call DDAFILE(JOBIPH,0,DUM,NTOT2,IAD15)
IADR15(10) = IAD15
call DDAFILE(JOBIPH,0,DUM,NTOT3,IAD15)
call DDAFILE(JOBIPH,0,DUM,NTOT3,IAD15)
IADR15(11) = IAD15
call DDAFILE(JOBIPH,0,DUM,NORBT,IAD15)
IADR15(12) = IAD15
do i=1,lRoots
  call DDAFILE(JOBIPH,0,DUM,NTOT2,IAD15)
  call DDAFILE(JOBIPH,0,DUM,NTOT,IAD15)
end do
IADR15(13) = IAD15
IADR15(14) = IAD15
do i=1,lroots
  call DDAFILE(JOBIPH,0,DUM,NTOT2,IAD15)
  call DDAFILE(JOBIPH,0,DUM,NTOT,IAD15)
end do
! New layout scheme:
IADR15(15) = -1
call mma_allocate(HEFF,LROOTS,LROOTS,Label='HEFF')
call unitmat(HEFF,LROOTS)
HEFF(:,:) = 1.0e12_wp*HEFF(:,:)
IADR15(17) = IAD15
call DDAFILE(JOBIPH,1,HEFF,LROOTS**2,IAD15)
call mma_deallocate(HEFF)
IADR15(18) = IAD15
!SVC: translates levels to orbital index (L2ACT in caspt2)
call IDAFILE(JOBIPH,1,IDXSX,mxAct,IAD15)
!SVC: translates orbital index to levels (LEVEL in caspt2)
call IDAFILE(JOBIPH,1,IDXCI,mxAct,IAD15)
IADR15(19:30) = 0
! First unused disk address at IADR(16):
IADR15(16) = IAD15

! Write table of content: IADR15

IAD15 = 0
call IDAFILE(JOBIPH,1,IADR15,30,IAD15)

end subroutine CREIPH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE CNHCNM(HSUB,ISYM,ILCNF,NLCNF,IRCNF,NRCNF,NLCSF,NRCSF,
     &                  SCR,ICONF,NEL,
     &                  IREFSM,NAEL,NBEL,NINOB,NACOB,ECORE,
     &                  IPRODT,DTOC,INTSPC,ICOMBI,PSSIGN,
     &                  NTEST)
*
* Calculate  Hamiltonian block defined by configuration
* lists ILCNF,IRCNF
* If ISYM.Ne. 0 only the lower half of the matrix is constructed
*
* Jeppe Olsen April 1990
* ========================
*
* No modifications
* ================
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Specific input
      DIMENSION ILCNF(*),IRCNF(*)
*. General input
      DIMENSION ICONF(*),IPRODT(*),DTOC(*)
*.Output
      DIMENSION HSUB(*)
*.Scratch
      DIMENSION SCR(*)
*. Length of scratch : 2 * NEL + MXCSFC                   (used in CNHCNM)
*                    + 6*MXDTFC+MXDTFC**2+MXDTFC+MXCSFC   (used in CNHCN2)
*                    + MAX(MXDTFC*NEL+2*NEL,4*NORB+2*NEL) (used in DIHDJ,CNFSTR)
*.Standard common block
#include "detdim.fh"
#include "spinfo_mclr.fh"
*
      CALL CNHCNM_INTERNAL(SCR)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NRCSF)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE CNHCNM_INTERNAL(SCR)
      USE ISO_C_BINDING
      REAL*8, TARGET :: SCR(*)
      INTEGER, POINTER :: iSCRl(:),iSCRr(:)
*
      NTERMS = 0
      NDIF0 = 0
      NDIF1 = 0
      NDIF2 = 0
*. Largest configuration block possible
      MXCSFC = 0
      DO 10 ITYP = 1, NTYP
        MXCSFC = MAX(MXCSFC,NCPCNT(ITYP) )
   10 CONTINUE
*
*
      KLFREE = 1
*
      KLCONF = KLFREE
      KLFREE = KLFREE + NEL
*
      KRCONF = KLFREE
      KLFREE = KLFREE + NEL
*
      KLPHPS = KLFREE
      KLFREE = KLFREE + MXCSFC ** 2
*
*. LHR
      IILB = 1
      CALL C_F_POINTER(C_LOC(SCR(KLCONF)),iSCRl,[1])
      CALL C_F_POINTER(C_LOC(SCR(KRCONF)),iSCRr,[1])
      DO 200 ICNL = 1, NLCNF
        CALL GETCNF(iSCRl,ILTYP,ILCNF(ICNL),ICONF,IREFSM,NEL,NTEST)
        NCSFL = NCPCNT(ILTYP)
        IIRB = 1
        IF(ISYM.EQ.0) THEN
          MXR = NRCNF
        ELSE
          MXR = ICNL
        END IF
        DO 190 ICNR = 1, MXR
          CALL GETCNF(iSCRr,IRTYP,IRCNF(ICNR),ICONF,IREFSM,NEL,NTEST)
          NCSFR = NCPCNT(IRTYP)
          CALL CNHCN2(iSCRl,ILTYP,iSCRr,IRTYP,SCR(KLPHPS),
     &               SCR(KLFREE),NEL,NAEL,NBEL,INTSPC,
     &               NINOB,ECORE,
     &               IPRODT,DTOC,NACOB,ICOMBI,PSSIGN,
     &               NTERMS,MDIF0,MDIF1,MDIF2,NTEST)
          NDIF0 = NDIF0 + MDIF0
          NDIF1 = NDIF1 + MDIF1
          NDIF2 = NDIF2 + MDIF2
*

* Copy to HSUB matrix
          IF(ISYM.NE.0) THEN
*. Copy to lower half format
            DO 160 IIL = 1, NCSFL
              IF(IILB.EQ.IIRB) THEN
                IIRMAX = IIL
              ELSE
                IIRMAX = NCSFR
              END IF
              DO 150 IIR = 1, IIRMAX
                IIRACT = IIRB - 1 + IIR
                IILACT = IILB - 1 + IIL
                ILRO = IILACT*(IILACT-1)/2 + IIRACT
                ILRI = (IIR-1)*NCSFL + IIL
                HSUB(ILRO) = SCR(KLPHPS-1+ILRI)
  150         CONTINUE
  160       CONTINUE
          ELSE
*. Pack to full format
            DO 260 IIL = 1, NCSFL
              DO 250 IIR = 1, NCSFR
                IIRACT = IIRB - 1 + IIR
                IILACT = IILB - 1 + IIL
                ILRO = (IIRACT-1)*NLCSF + IILACT
                ILRI = (IIR-1)*NCSFL + IIL
                HSUB(ILRO) = SCR(KLPHPS-1+ILRI)
  250         CONTINUE
  260       CONTINUE
          END IF
          IIRB = IIRB + NCSFR
  190   CONTINUE
      IILB = IILB + NCSFL
 200  CONTINUE
      NULLIFY(iSCRl,iSCRr)
*
*
      RETURN
      END SUBROUTINE CNHCNM_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Anders Bernhardsson                              *
!               1994, Roland Lindh                                     *
!***********************************************************************

subroutine CmbnT2(Rnxyz,nZeta,la,lb,Zeta,rKappa,rFinal,Alpha,Beta,Hess,nHess,DAO,IfHss,IndHss,indgrd,iu,iv,nOp)
!***********************************************************************
!                                                                      *
! Object: compute the 2nd derivative of the overlap matrix.            *
!                                                                      *
!***********************************************************************

use Index_Functions, only: C_Ind, iTri, nTri_Elem1
use Symmetry_Info, only: nIrrep, iChTbl
use Constants, only: One, Two, Four, Six, Half, OneHalf
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nHess, IndHss(0:1,0:2,0:1,0:2,0:nIrrep-1), indgrd(0:2,0:1,0:nirrep-1), iu, iv, &
                                 nOp(2)
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la+2,0:lb+2), Zeta(nZeta), Alpha(nZeta), Beta(nZeta), &
                             DAO(nZeta,nTri_Elem1(la),nTri_Elem1(lb))
real(kind=wp), intent(inout) :: rKappa(nZeta), rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),6), Hess(nHess)
logical(kind=iwp), intent(in) :: IfHss(0:1,0:2,0:1,0:2)
integer(kind=iwp) :: i, ia(3), iax, iay, ib(3), ibx, iby, iCar, ich, iCnt, iCoor, iHess, iIrrep, iMax, ipa, ipb, istab(0:1), &
                     iyaMax, iybMax, jCar, jCnt, jCoor, kCoor, nDAO
real(kind=wp) :: Fact, oj, ps
integer(kind=iwp), external :: iPrmt
real(kind=r8), external :: DDot_

!iRout = 134
iStab(0) = iu
iStab(1) = iv
!iPrint = nPrint(iRout)

rKappa(:) = Half*rKappa*Zeta**(-OneHalf)
!if (iPrint >= 99) then
!  call RecPrt(' In CmbnT2: Zeta  ',' ',Zeta,1,nZeta)
!  call RecPrt(' In CmbnT2: rKappa',' ',rKappa,1,nZeta)
!  call RecPrt(' In CmbnT2: Alpha ',' ',Alpha,1,nZeta)
!  call RecPrt(' In CmbnT2: Beta  ',' ',Beta,1,nZeta)
!end if
do iax=0,la
  ia(1) = iax
  iyaMax = la-ia(1)
  do ibx=0,lb
    ib(1) = ibx
    iybMax = lb-ib(1)
    do iay=0,iyaMax
      ia(2) = iay
      ia(3) = la-ia(2)-ia(1)
      ipa = C_Ind(la,ia(1),ia(3))
      do iby=0,iybMax
        ib(2) = iby
        ib(3) = lb-ib(2)-ib(1)
        ipb = C_Ind(lb,ib(1),ib(3))

        ! Combine overlap integrals

        ! Integrals like dI/dx1dx1

        do iCoor=1,3
          jCoor = mod(iCoor,3)+1
          kCoor = mod(jCoor,3)+1
          i = iTri(iCoor,iCoor)
          if (.not. IfHss(0,iCoor-1,0,iCoor-1)) cycle
          rFinal(:,ipa,ipb,i) = rKappa(:)*((Two*Alpha(:))**2*((Two*Beta(:))**2*(Rnxyz(:,iCoor,ia(iCoor)+2,ib(iCoor)+2)* &
                                                                                Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                                Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                                                Rnxyz(:,iCoor,ia(iCoor)+2,ib(iCoor))* &
                                                                                Rnxyz(:,jCoor,ia(jCoor),ib(jCoor)+2)* &
                                                                                Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                                                Rnxyz(:,iCoor,ia(iCoor)+2,ib(iCoor))* &
                                                                                Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                                Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)+2))- &
                                                              Six*Beta(:)*Rnxyz(:,iCoor,ia(iCoor)+2,ib(iCoor))* &
                                                                          Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                          Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))- &
                                           Two*Alpha(:)*((Two*Beta(:))**2*(Rnxyz(:,iCoor,ia(iCoor),ib(iCoor)+2)* &
                                                                           Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                           Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                                           Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                                           Rnxyz(:,jCoor,ia(jCoor),ib(jCoor)+2)* &
                                                                           Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                                           Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                                           Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                           Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)+2))- &
                                                         Six*Beta(:)*Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))))
          if (lb > 0) &
            rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                  ((Two*Alpha(:))**2*Four*Beta(:)*real(lb,kind=wp)*Rnxyz(:,iCoor,ia(iCoor)+2,ib(iCoor))* &
                                                                                   Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                                   Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))- &
                                   Two*Alpha(:)*(Four*Beta(:))*real(lb,kind=wp)*Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                                                Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                                Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
          if (ib(icoor) > 1) &
            rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                  ((Two*Alpha(:))**2*real(ib(icoor)*(ib(icoor)-1),kind=wp)*Rnxyz(:,iCoor,ia(iCoor)+2,ib(iCoor)-2)* &
                                                                                           Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                                           Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))- &
                                   Two*Alpha(:)*real(ib(icoor)*(ib(icoor)-1),kind=wp)*Rnxyz(:,iCoor,ia(iCoor),ib(iCoor)-2)* &
                                                                                      Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                                      Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
          if (ib(jcoor) > 1) &
            rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                  ((Two*Alpha(:))**2*real(ib(jcoor)*(ib(jcoor)-1),kind=wp)*Rnxyz(:,iCoor,ia(iCoor)+2,ib(iCoor))* &
                                                                                           Rnxyz(:,jCoor,ia(jCoor),ib(jCoor)-2)* &
                                                                                           Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))- &
                                   Two*Alpha(:)*real(ib(jcoor)*(ib(jcoor)-1),kind=wp)*Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                                                      Rnxyz(:,jCoor,ia(jCoor),ib(jCoor)-2)* &
                                                                                      Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
          if (ib(kcoor) > 1) &
            rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                  ((Two*Alpha(:))**2*real(ib(kcoor)*(ib(kcoor)-1),kind=wp)*Rnxyz(:,iCoor,ia(iCoor)+2,ib(iCoor))* &
                                                                                           Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                                           Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)-2)- &
                                   Two*Alpha(:)*real(ib(kcoor)*(ib(kcoor)-1),kind=wp)*Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                                                      Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                                                      Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)-2))
          if (ia(iCoor) > 0) then
            rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)*Four*Alpha(:)*real(ia(iCoor),kind=wp)* &
                                  ((Two*Beta(:))**2*(Rnxyz(:,iCoor,ia(iCoor),ib(iCoor)+2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor)+2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)+2))- &
                                   Six*Beta(:)*Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                               Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                               Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
            if (lb > 0) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                              Four*Beta(:)*real(lb,kind=wp)*Four*Alpha(:)*real(ia(iCoor),kind=wp)* &
                                              Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                              Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                              Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(iCoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                                     real(ib(icoor)*(ib(icoor)-1),kind=wp)*Four*Alpha(:)*real(ia(iCoor),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor),ib(iCoor)-2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(jCoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                                     real(ib(jcoor)*(ib(jcoor)-1),kind=wp)*Four*Alpha(:)*real(ia(iCoor),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor)-2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(kCoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                                     real(ib(kcoor)*(ib(kcoor)-1),kind=wp)*Four*Alpha(:)*real(ia(iCoor),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor),ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)-2)
          end if
          if (ia(iCoor) > 1) then
            rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)*real(ia(iCoor)*(ia(iCoor)-1),kind=wp)* &
                                  ((Two*Beta(:))**2*(Rnxyz(:,iCoor,ia(iCoor)-2,ib(iCoor)+2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor)-2,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor)+2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor)-2,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)+2))- &
                                   Six*Beta(:)*Rnxyz(:,iCoor,ia(iCoor)-2,ib(iCoor))* &
                                               Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                               Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
            if (lb > 0) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                              real(ia(iCoor)*(ia(iCoor)-1),kind=wp)*Four*Beta(:)*real(lb,kind=wp)* &
                                              Rnxyz(:,iCoor,ia(iCoor)-2,ib(iCoor))* &
                                              Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                              Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(iCoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                                     real(ia(iCoor)*(ia(iCoor)-1)*ib(iCoor)*(ib(iCoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)-2,ib(iCoor)-2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(jCoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                                     real(ia(iCoor)*(ia(iCoor)-1)*ib(jCoor)*(ib(jCoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)-2,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor)-2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(kCoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                                     real(ia(iCoor)*(ia(iCoor)-1)*ib(kCoor)*(ib(kCoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)-2,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor),ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)-2)
          end if
        end do

        ! Integrals like dI/dxdz

        do kCoor=1,3
          iCoor = mod(kCoor,3)+1
          jCoor = mod(iCoor,3)+1
          iMax = max(iCoor,jCoor)
          jCoor = min(iCoor,jCoor)
          iCoor = iMax
          i = iTri(iCoor,jCoor)
          if (.not. IfHss(0,iCoor-1,0,jCoor-1)) cycle
          rFinal(:,ipa,ipb,i) = rKappa(:)*(Two*Alpha(:))**2*((Two*Beta(:))**2*(Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor)+2)* &
                                                                               Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                                                               Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                                               Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                                                               Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor)+2)* &
                                                                               Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                                               Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                                                               Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                                                               Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)+2))- &
                                                             Six*Beta(:)*Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                                                         Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                                                         Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
          if (lb > 0) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)*(Two*Alpha(:))**2*Four*Beta(:)*real(lb,kind=wp)* &
                                            Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                            Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                            Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
          if (ib(icoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                                   (Two*Alpha(:))**2*real(ib(icoor)*(ib(icoor)-1),kind=wp)* &
                                                   Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor)-2)* &
                                                   Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                                   Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
          if (ib(jcoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                                   (Two*Alpha(:))**2*real(ib(jcoor)*(ib(jcoor)-1),kind=wp)* &
                                                   Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                                   Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor)-2)* &
                                                   Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
          if (ib(kcoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                                   (Two*Alpha(:))**2*real(ib(kcoor)*(ib(kcoor)-1),kind=wp)* &
                                                   Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                                   Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                                   Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)-2)
          if (ia(icoor) > 0) then
            rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)*real(ia(icoor),kind=wp)*Two*Alpha(:)* &
                                  ((Two*Beta(:))**2*(Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor)+2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor)+2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)+2))- &
                                   Six*Beta(:)*Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                               Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                               Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
            if (lb > 0) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                              Two*Alpha(:)*real(ia(iCoor))*Four*Beta(:)*real(lb,kind=wp)* &
                                              Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                              Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                              Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(icoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                                     Two*Alpha(:)*real(ia(iCoor)*ib(icoor)*(ib(icoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor)-2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(jcoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                                     Two*Alpha(:)*real(ia(iCoor)*ib(jcoor)*(ib(jcoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor)-2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(kcoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                                     Two*Alpha(:)*real(ia(iCoor)*ib(kcoor)*(ib(kcoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)+1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)-2)
          end if
          if (ia(jcoor) > 0) then
            rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)*real(ia(jcoor),kind=wp)*Two*Alpha(:)* &
                                  ((Two*Beta(:))**2*(Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor)+2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor)+2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)+2))- &
                                   Six*Beta(:)*Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                               Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                               Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
            if (lb > 0) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                              Two*Alpha(:)*real(ia(jCoor))*Four*Beta(:)*real(lb,kind=wp)* &
                                              Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                              Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                              Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(icoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                                     Two*Alpha(:)*real(ia(jCoor)*ib(icoor)*(ib(icoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor)-2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(jcoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                                     Two*Alpha(:)*real(ia(jCoor)*ib(jcoor)*(ib(jcoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor)-2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(kcoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                                     Two*Alpha(:)*real(ia(jCoor),kind=wp)*real(ib(kcoor)*(ib(kcoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)+1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)-2)
          end if
          if ((ia(iCoor) > 0) .and. (ia(jCoor) > 0)) then
            rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)*real(ia(iCoor)*ia(jCoor),kind=wp)* &
                                  ((Two*Beta(:))**2*(Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor)+2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor)+2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))+ &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)+2))- &
                                   Six*Beta(:)*Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                               Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                               Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)))
            if (lb > 0) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)-rKappa(:)* &
                                              real(ia(iCoor)*ia(jCoor),kind=wp)*Four*Beta(:)*real(lb,kind=wp)* &
                                              Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                              Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                              Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(icoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                                     real(ia(iCoor)*ia(jCoor)*ib(icoor)*(ib(icoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor)-2)* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(jcoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                                     real(ia(iCoor)*ia(jCoor)*ib(jcoor)*(ib(jcoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor)-2)* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor))
            if (ib(kcoor) > 1) rFinal(:,ipa,ipb,i) = rFinal(:,ipa,ipb,i)+rKappa(:)* &
                                                     real(ia(iCoor)*ia(jCoor)*ib(kcoor)*(ib(kcoor)-1),kind=wp)* &
                                                     Rnxyz(:,iCoor,ia(iCoor)-1,ib(iCoor))* &
                                                     Rnxyz(:,jCoor,ia(jCoor)-1,ib(jCoor))* &
                                                     Rnxyz(:,kCoor,ia(kCoor),ib(kCoor)-2)
          end if
        end do
      end do
    end do
  end do
end do

! Trace the Hessian integrals

nDAO = nZeta*nTri_Elem1(la)*nTri_Elem1(lb)
!if (iPrint >= 99) then
!  call RecPrt(' S(1)',' ',rFinal,nDAO,21)
!  call RecPrt('   D ',' ',DAO,nDAO,1)
!end if
do iIrrep=0,nIrrep-1
  do iCnt=0,1
    do iCar=1,3
      do jCnt=0,1
        do jCar=1,3
          i = iTri(iCar,jCar)
          if (IndHss(iCnt,iCar-1,jCnt,jCar-1,iIrrep) /= 0) then

            ! Accumulate contribution to the Hessian

            ! Get the characteristics of the diff operator

            iCh = ieor(2**(iCar-1)*iCnt,2**(jCar-1)*jCnt)

            ! Get the character of the operator in the present irrep

            ps = real(iChTbl(iIrrep,nOp(2))**(iCnt+jCnt),kind=wp)

            ! Get the transf. character of the diff. operator

            ps = ps*real(iPrmt(nOp(2),iCh),kind=wp)

            ! If the over triangular diff. are needed multiply by two instead

            if ((iCnt /= jCnt) .and. (iCar == jCar) .and. &
                (abs(indgrd(iCar-1,iCnt,iIrrep)) == abs(indgrd(jCar-1,jCnt,iIrrep)))) ps = ps*Two
            iHess = abs(IndHss(iCnt,iCar-1,jCnt,jCar-1,iIrrep))
            Fact = real(iStab(iCnt)*iStab(jCnt),kind=wp)/real(nIrrep**2,kind=wp)
            Fact = Fact*ps
            if (IndHss(iCnt,iCar-1,jCnt,jCar-1,iIrrep) <= 0) Fact = Fact*(-One)**(iCnt+jCnt)
            oj = DDot_(nDAO,DAO,1,rFinal(:,:,:,i),1)
            Hess(iHess) = Hess(iHess)+Fact*oj
          end if
        end do
      end do
    end do
  end do
end do

return

end subroutine CmbnT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine basis2run()
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit None
#include "stdalloc.fh"
      integer :: nPrim
      integer :: kExp
      integer :: iPrim, iCnttp, icnt, mdc, jSh, iShSrt, iAng, iBasis
      real*8, allocatable :: primitives(:,:)
      integer, allocatable :: primitive_ids(:,:), IndC(:)
      integer :: iyy, iCo, iAtoms, index_center
*
************************************************************************
*
      iAtoms=0
************************************************************************
*     Generate list of primitive basis functions
*
*     Loop over distinct shell types
      nPrim=0
*     Loop over basis sets
      Do iCnttp = 1, nCnttp
        If (iCnttp.eq.iCnttp_Dummy) cycle
        If (dbsc(iCnttp)%iVal.eq.0) Cycle
        mdc = dbsc(iCnttp)%mdci
        iShSrt = dbsc(iCnttp)%iVal
*       Loop over distinct centers
        Do icnt = 1, dbsc(iCnttp)%nCntr
          mdc = mdc + 1
*         Loop over symmetry-related centers
          Do iCo = 0, nIrrep/dc(mdc)%nStab-1
*           Loop over shells associated with this center
*           Start with s type shells
            jSh = iShSrt
            if (Shells(jSh)%Aux.or.
     &          Shells(jSh)%Frag) cycle
            Do iAng = 0, dbsc(iCnttp)%nVal-1
              nPrim = nPrim + Shells(jSh)%nExp * Shells(jSh)%nBasis
              jSh = jSh + 1
            End Do
          End Do
        End Do
      End Do

      call put_iScalar('nPrim',nPrim)

      Call mma_allocate(IndC,2*S%mCentr,label='IndC')
      call mma_allocate(primitive_ids, 3, nPrim,label='primitive_ids')
      call mma_allocate(primitives, 2, nPrim,label='primitives')

*     Loop over distinct shell types
      iPrim  =0
*     Loop over basis sets
      Do iCnttp = 1, nCnttp
        if (iCnttp.eq.iCnttp_Dummy) cycle
        If (dbsc(iCnttp)%iVal.eq.0) Cycle
        mdc = dbsc(iCnttp)%mdci
        iShSrt = dbsc(iCnttp)%iVal
*     Loop over distinct centers
        Do icnt = 1, dbsc(iCnttp)%nCntr
          mdc = mdc + 1
*     Loop over symmetry-related centers
          Do iCo = 0, nIrrep/dc(mdc)%nStab-1
*     Loop over shells associated with this center
*     Start with s type shells
            jSh = iShSrt
            if (Shells(jSh)%Aux.or.
     &          ShellS(jSh)%Frag) cycle
*     Get the flat, desymmetrized id of the center
            iyy=Index_Center(mdc,iCo,IndC,iAtoms,S%mCentr)
            Do iAng = 0, dbsc(iCnttp)%nVal-1
*     Pointer to the untouched contraction matrix as after input.
              Do iBasis = 1, Shells(jSh)%nBasis
                Do kExp = 1, Shells(jSh)%nExp
                  iPrim  = iPrim  + 1
                  primitive_ids(1,iPrim) = iyy
                  primitive_ids(2,iPrim) = iAng
                  primitive_ids(3,iPrim) = iBasis
                  primitives(1,iPrim) = Shells(jSh)%Exp(kExp)
                  primitives(2,iPrim) = Shells(jSh)%Cff_c(kExp,iBasis,2)
                End Do
              End Do
              jSh = jSh + 1
            End Do
          End Do
        End Do
*
      End Do

      call put_iArray('primitive ids', primitive_ids, 3*nPrim)
      call put_dArray('primitives', primitives, 2*nPrim)

      call mma_deallocate(primitive_ids)
      call mma_deallocate(primitives)
      call mma_deallocate(IndC)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Sebastian Wouters                                *
!               2016, Quan Phung                                       *
!***********************************************************************
! CheMPS2-Molcas main interface
! Based on Block interface, writen by N. Nakatani
! Written by Quan Phung and Sebastian Wouters, Leuven, Aug 2016

subroutine CHEMPS2_DENSI_RASSCF(jRoot,D,DS,PS,PA,PT)

use rasscf_data, only: NACPAR, NACPR2, NAC, mxSym
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: jRoot
real(kind=wp), intent(out) :: D(NACPAR), DS(NACPAR), PS(NACPR2), PA(NACPR2), PT(NAC,NAC,NAC,NAC)
#include "general.fh"
integer(kind=iwp) :: I, IJ_pack, IJKL_pack, J, K, L, LLIM
real(kind=wp) :: D1sum

D(:) = Zero
DS(:) = Zero
PS(:) = Zero
PA(:) = Zero

if (NACTEL <= 1) then
  ! special case for NACTEL = 1
  write(u6,*) 'CheMPS2 does not allow 1 electron.'
  return
end if

call chemps2_load2pdm(NAC,PT,jRoot)
IJ_pack = 1
do J=1,NAC
  do I=1,J
    D1sum = Zero
    do K=1,NAC
      D1sum = D1sum+PT(K,K,I,J)
    end do
    D(IJ_pack) = D1sum/(NACTEL-1)
    IJ_pack = IJ_pack+1
  end do
end do

IJKL_pack = 0
do I=1,NAC
  do J=1,I
    do K=1,I
      LLIM = K
      if (K == I) LLIM = J
      do L=1,LLIM
        IJKL_pack = IJKL_pack+1
        if (K == L) then
          PS(IJKL_pack) = Half*PT(L,K,J,I)
        else
          PS(IJKL_pack) = Half*(PT(L,K,J,I)+PT(K,L,J,I))
          PA(IJKL_pack) = Half*(PT(L,K,J,I)-PT(K,L,J,I))
        end if
      end do
    end do
  end do
end do

return

end subroutine CHEMPS2_DENSI_RASSCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      Logical Function SymDsp(iBsFnc)
************************************************************************
*                                                                      *
* Object: to establish if a translation or a rotation belongs to the   *
*         total symmetric irreducible representation.                  *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             April '92                                                *
************************************************************************
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (A-H,O-Z)
      Integer jPrmt(0:7)
#include "real.fh"
      Data jPrmt/1,-1,-1,1,-1,1,1,-1/
*
*     Statement function
*
      iPrmt(i,j) = jPrmt(iAnd(i,j))
*
*     Write (*,*) ' iBsFnc=',iBsFnc
      SymDsp = .True.
      mask = 0
      Do 20 i = 0, nIrrep-1
         Do 21 j = 1, 3
            If (iAnd(iOper(i),2**(j-1)).ne.0) mask = iOr(mask,2**(j-1))
 21      Continue
 20   Continue
      jBsFnc = iAnd(mask,iBsFnc)
*     Write (*,*) ' jBsFnc=',jBsFnc
*
*     Loop over operators
*
      iAcc = 0
      Do 10 i = 0, nIrrep-1
         iAcc = iAcc + iPrmt(iOper(i),jBsFnc)
 10   Continue
      If (iAcc.eq.0) SymDsp = .False.
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************
!  OverLq
!
!> @brief
!>   Compute overlap between primitive bases, which for bases of other type than s,
!>   will mean that several overlaps between basis-functions are computed. One
!>   function is on the solvent, the other in the QM-region. Observe that we do not
!>   care about overlaps within the QM-region or among the solvent molecules.
!> @author A. Ohrn
!>
!> @details
!> Uses the formulas in \cite Tak1966-JPSJ-21-2313. It is hard to give any
!> easy explanation, so if you want to understand exactly what is
!> going on below, see the article, especially equations (2.4) and
!> (2.12); then the source-code comments will provide you with
!> sufficient information.
!>
!> @param[in]  Bori   Center for the QM-region contracted basis-function
!> @param[in]  Cori   Like Bori, but for the solvent basis-function
!> @param[in]  Alfa   Exponents for the primitive basis-functions that build this contracted function
!> @param[in]  Beta   Like \p alfa, but for solvent
!> @param[in]  iQ1    = ``1`` if s-type, = ``2`` if p-type, etc. for the function in the QM-region
!> @param[in]  iQ2    Like \p iQ1, but for solvent function
!> @param[in]  nExp1  How many primitives there are in this contracted function
!> @param[in]  nExp2  Like \p nExp1, but for (surprise) the solvent
!> @param[out] PSint  The matrix of overlaps
!***********************************************************************

subroutine OverLq(Bori,Cori,Alfa,Beta,iQ1,iQ2,nExp1,nExp2,PSint)

use qmstat_global, only: MxAngqNr, Trans
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, Pi
use Definitions, only: wp, iwp

implicit none
! MaxAngqNr=4 means f-function is top. There is no limit in the algorithm though, so if higher is needed, change this number.
integer(kind=iwp), intent(in) :: iQ1, iQ2, nExp1, nExp2
real(kind=wp), intent(in) :: Bori(3), Cori(3), Alfa(nExp1), Beta(nExp2)
real(kind=wp), intent(out) :: PSint(2*iQ1-1,nExp1,2*iQ2-1,nExp2)
integer(kind=iwp) :: i, icompo, ind, ind1, ind2, iP1, iP2, iSp1, iSp2, iUpX, iUpY, iUpZ, ix, ixxx, iy, iyyy, iz, izzz, j, Kaunt, &
                     kaunter, krakna, loneX, loneY, loneZ, lsumX, lsumY, lsumZ, ltwoX, ltwoY, ltwoZ, nCartxC(nTri_Elem(MxAngqNr)), &
                     nCartxQ(nTri_Elem(MxAngqNr)), nCartyC(nTri_Elem(MxAngqNr)), nCartyQ(nTri_Elem(MxAngqNr)), &
                     nCartzC(nTri_Elem(MxAngqNr)), nCartzQ(nTri_Elem(MxAngqNr)), nSizeCart, nSizeSph, nSpecific1, nSpecific2, &
                     nSph1, nSph2
real(kind=wp) :: Divide, Expo, Extra, FactorX(2*MxAngqNr+1), FactorY(2*MxAngqNr+1), FactorZ(2*MxAngqNr+1), PAxyz(3), PBxyz(3), &
                 Piconst, Primequals, Separation, SqPiconst, SummaX, SummaY, SummaZ, TheCent(3), TheFirstFac
real(kind=wp), allocatable :: PInte(:,:), Pps(:), PsphS(:)
integer(kind=iwp), external :: iDubFac

!----------------------------------------------------------------------*
! Prepare some numbers for later.                                      *
!----------------------------------------------------------------------*
ind = 0
! Remember that each base consist of many functions - this is how many.
nSpecific1 = nTri_Elem(iQ1)
nSpecific2 = nTri_Elem(iQ2)
icompo = nSpecific1
! Then follows the NEW loops that compute how the cartesian components are ordered in various basis functions.
do ix=0,iQ1-1
  do iy=0,iQ1-1-ix
    iz = iQ1-1-iy-ix
    ncartxQ(icompo) = ix
    ncartyQ(icompo) = iy
    ncartzQ(icompo) = iz
    icompo = icompo-1
  end do
end do
icompo = nSpecific2
! And for the solvent orbitals.
do ix=0,iQ2-1
  do iy=0,iQ2-1-ix
    iz = iQ2-1-iy-ix
    ncartxC(icompo) = ix
    ncartyC(icompo) = iy
    ncartzC(icompo) = iz
    icompo = icompo-1
  end do
end do
nSph1 = 2*iQ1-1
nSph2 = 2*iQ2-1
nSizeCart = nSpecific1*nSpecific2
nSizeSph = nSph1*nSph2
call mma_allocate(PpS,nSizeCart,label='PrimCar')
call mma_allocate(PsphS,nSizeSph,label='PrimSph')
PSint(:,:,:,:) = Zero
Separation = ((Bori(1)-Cori(1))**2+(Bori(2)-Cori(2))**2+(Bori(3)-Cori(3))**2)
!----------------------------------------------------------------------*
! Start loop over primitives.                                          *
!----------------------------------------------------------------------*
Kaunt = 0
do iP1=1,nExp1
  do iP2=1,nExp2
    Kaunt = Kaunt+1
    TheCent(:) = (Alfa(iP1)*Bori(:)+Beta(iP2)*Cori(:))
    Divide = One/(Alfa(iP1)+Beta(iP2)) !gamma in article
    TheCent(:) = TheCent(:)*Divide !The new center, P
    Piconst = Pi*Divide
    SqPiconst = sqrt(Piconst)
    Piconst = Piconst*SqPiconst !That constant to the power of 3/2
    Expo = Alfa(iP1)*Beta(iP2)*Separation*Divide
    TheFirstFac = Piconst*exp(-Expo) !This is the exponential factor
    ! Now we should get those difficult f-functions.
    PAxyz(:) = TheCent-Bori
    PBxyz(:) = TheCent-Cori
    kaunter = 0
    do iSp1=1,nSpecific1
      do iSp2=1,nSpecific2
        kaunter = kaunter+1
        loneX = ncartxQ(iSp1)
        ltwoX = ncartxC(iSp2)
        lsumX = loneX+ltwoX
        loneY = ncartyQ(iSp1)
        ltwoY = ncartyC(iSp2)
        lsumY = loneY+ltwoY
        loneZ = ncartzQ(iSp1)
        ltwoZ = ncartzC(iSp2)
        lsumZ = loneZ+ltwoZ
        call fFactor(loneX,ltwoX,lsumX,loneY,ltwoY,lsumY,loneZ,ltwoZ,lsumZ,PAxyz,PBxyz,FactorX,FactorY,FactorZ)
        ! Now we have the f-factors for this specific angular type of this
        ! specific primitive basis-function. Now put things together.
        iUpX = lsumX/2 !Yes, it should be like this, even when lsumX is odd.
        iUpY = lsumY/2
        iUpZ = lsumZ/2
        SummaX = Zero
        SummaY = Zero
        SummaZ = Zero
        ! This is just a matter of putting things together according to the formula
        do ixxx=0,iUpX
          Extra = iDubFac(2*ixxx-1)*(Half*Divide)**ixxx
          SummaX = SummaX+FactorX(2*ixxx+1)*Extra
        end do
        do iyyy=0,iUpY
          Extra = iDubFac(2*iyyy-1)*(Half*Divide)**iyyy
          SummaY = SummaY+FactorY(2*iyyy+1)*Extra
        end do
        do izzz=0,iUpZ
          Extra = iDubFac(2*izzz-1)*(Half*Divide)**izzz
          SummaZ = SummaZ+FactorZ(2*izzz+1)*Extra
        end do
        Primequals = TheFirstFac*SummaX*SummaY*SummaZ
        PpS(kaunter) = Primequals
      end do
    end do
    !------------------------------------------------------------------*
    ! This was the overlap for the primitives in terms of cartesian    *
    ! functions, but in the new qmstat we use spherical functions, so  *
    ! we need to transform if any d-function or higher is involved. In *
    ! the matrix Trans the numbers for how spherical functions are     *
    ! expressed in cartesian functions are stored, including the extra *
    ! normalization so that all d-functions (and higher) have the same *
    ! combined contraction and normalization coefficient. The rest is  *
    ! just a matter of getting the matrix multiplications right. The   *
    ! convention I use is this: The matrix with the overlaps contains  *
    ! elements such as <psi_QM|psi_Solv> in other words, the           *
    ! QM-orbitals count over the rows and the solvent orbitals over the*
    ! columns; observe however that this is NOT the way the matrix     *
    ! enters from above, since there the fastest couting index is over *
    ! solvent orbitals (iSp2), so given this and the knowledge of how  *
    ! Fortran stores multidimensional matrices, we can figure out when *
    ! to transpose. All this means that if it is the QM-orbitals that  *
    ! are to be transformed, the transformation matrix is multiplied   *
    ! from left, while it is multiplied from the right -- transposed of*
    ! course -- if it is the solvent orbitals that are to be           *
    ! transformed. In the case that both orbitals are to be transformed*
    ! we simply apply the transformation matrix from both directions.  *
    !------------------------------------------------------------------*
    if ((iQ1 >= 3) .or. (iQ2 >= 3)) then !Check if any transformations are necessary.
      if (iQ2 < 3) then !If only the base of the QM-region needs!to be transformed.
        ind = 1+(iQ1-3)*(3*iQ1**3+5*iQ1**2+12*iQ1+40)/12
        call Dgemm_('N','T',nSph1,nSpecific2,nSpecific1,One,Trans(ind),nSph1,PpS,nSpecific2,Zero,PsphS,nSph1)
      else if (iQ1 < 3) then !If only solvent base needs to be transformed.
        ind = 1+(iQ2-3)*(3*iQ2**3+5*iQ2**2+12*iQ2+40)/12
        call Dgemm_('T','T',nSph1,nSph2,nSpecific2,One,PpS,nSpecific2,Trans(ind),nSph2,Zero,PsphS,nSph1)
      else !Both QM-region and Solvent need to be transformed.
        ind1 = 1+(iQ1-3)*(3*iQ1**3+5*iQ1**2+12*iQ1+40)/12
        ind2 = 1+(iQ2-3)*(3*iQ2**3+5*iQ2**2+12*iQ2+40)/12
        call mma_allocate(PInte,nSph1,nSpecific2,label='Intmd')
        call Dgemm_('N','T',nSph1,nSpecific2,nSpecific1,One,Trans(ind1),nSph1,PpS,nSpecific2,Zero,PInte,nSph1)
        call Dgemm_('N','T',nSph1,nSph2,nSpecific2,One,PInte,nSph1,Trans(ind2),nSph2,Zero,PsphS,nSph1)
        call mma_deallocate(PInte)
      end if
    else  !Here we only transpose to get integrals in right order.
      krakna = 0
      do i=1,nSph1
        do j=1,nSph2
          krakna = krakna+1
          PsphS(krakna) = PpS(i+(j-1)*nSph1)
        end do
      end do
    end if
    !------------------------------------------------------------------*
    ! Put this thing in the slowly growing overlap matrix for the      *
    ! primitive basis functions. The reason the index is so nasty is   *
    ! that we compute small blocks of the matrix and now have to fit it*
    ! in the right place in the growing, much larger, matrix. Nasty!   *
    !------------------------------------------------------------------*
    krakna = 0
    do j=1,nSph2
      do i=1,nSph1
        krakna = krakna+1
        PSint(i,iP1,j,iP2) = PsphS(krakna)
      end do
    end do
  end do
end do
!----------------------------------------------------------------------*
! Deallocate and ta'ta!                                                *
!----------------------------------------------------------------------*
call mma_deallocate(PpS)
call mma_deallocate(PsphS)

return

end subroutine OverLq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine diish3 (wrk,wrksize,
     & mapd0,mapd1,mapd2,mapd3,mapd4,cdiis,ndiis)
c
c     this routine produce new vector
c     v(0) = sum(i) [cdiis(i) . V(i)]
c
c     mapd0  - direct map of V0 vector (I)
c     mapd1  - direct map of V1 vector (I)
c     mapd2  - direct map of V2 vector (I)
c     mapd3  - direct map of V3 vector (I)
c     mapd4  - direct map of V4 vector (I)
c     cdiis  - vector of diis coeficients (I)
c     ndiis  - size of diis (2-4) (I)
c
#include "wrk.fh"
c
       integer mapd0(0:512,1:6)
       integer mapd1(0:512,1:6)
       integer mapd2(0:512,1:6)
       integer mapd3(0:512,1:6)
       integer mapd4(0:512,1:6)
       real*8 cdiis(1:4)
       integer ndiis
c
c     help variables
c
       integer poss0,poss1,poss2,poss3,poss4,nhelp,length
c
c
       if (ndiis.eq.2) then
c     2 dimensional DIIS
c
       poss0=mapd0(1,1)
       poss1=mapd1(1,1)
       poss2=mapd2(1,1)
c
       nhelp=mapd1(0,5)
       length=mapd1(nhelp,1)+mapd1(nhelp,2)-mapd1(1,1)
c
       if (length.gt.0) then
       do 20 nhelp=0,length-1
       wrk(poss0+nhelp)=cdiis(1)*wrk(poss1+nhelp)
     & +cdiis(2)*wrk(poss2+nhelp)
 20     continue
       end if
c
       else if (ndiis.eq.3) then
c     3 dimensional DIIS
c
       poss0=mapd0(1,1)
       poss1=mapd1(1,1)
       poss2=mapd2(1,1)
       poss3=mapd3(1,1)
c
       nhelp=mapd1(0,5)
       length=mapd1(nhelp,1)+mapd1(nhelp,2)-mapd1(1,1)
c
       if (length.gt.0) then
       do 30 nhelp=0,length-1
       wrk(poss0+nhelp)=cdiis(1)*wrk(poss1+nhelp)
     & +cdiis(2)*wrk(poss2+nhelp)
     & +cdiis(3)*wrk(poss3+nhelp)
 30     continue
       end if
c
       else if (ndiis.eq.4) then
c     4 dimensional DIIS
c
       poss0=mapd0(1,1)
       poss1=mapd1(1,1)
       poss2=mapd2(1,1)
       poss3=mapd3(1,1)
       poss4=mapd4(1,1)
c
       nhelp=mapd1(0,5)
       length=mapd1(nhelp,1)+mapd1(nhelp,2)-mapd1(1,1)
c
       if (length.gt.0) then
       do 40 nhelp=0,length-1
       wrk(poss0+nhelp)=cdiis(1)*wrk(poss1+nhelp)
     & +cdiis(2)*wrk(poss2+nhelp)
     & +cdiis(3)*wrk(poss3+nhelp)
     & +cdiis(4)*wrk(poss4+nhelp)
 40     continue
       end if
c
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Eugeniusz Bednarz                                      *
************************************************************************
*  AllocateC
*
*> @brief
*>   Pseudo allocation of memory for a string of length \p nipM of a vector of dimension \p nip
*> @author Eugeniusz Bednarz
*>
*> @details
*> Pseudo allocation of memory for a string of length \p nipM of a vector of dimension \p nip.
*>
*> Example: A call
*> \code
*> Call AllocateC('Label',ip,m,n)
*> \endcode
*> will allocate a character vector of \c n elements, where any element of this vector has a length \c m.
*> It corresponds to the classical declaration: ``Character*(m) A(n)``, where \c A is a variable name.
*> Moreover, a memory is allocated as multiplicity of real number. The reason of such allocation
*> is the ::get_carray subroutine which always returns a characters of length of multiplicity of 8 bytes (``real*8``).
*>
*> @param[in]  label The label of allocated memory
*> @param[out] ip    The index to proper element of the character vector
*> @param[in]  nipM  The length of the character
*> @param[in]  nip   The dimension of character vector
************************************************************************
      Subroutine AllocateC(label,ip,nipM,nip)
      Implicit None
#include "WrkSpc.fh"
#include "SysDef.fh"
      !
      Character*(*)
     +     label
      Integer
     +     ip,
     +     nipM,
     +     nip
      !
      Integer
     +     i,
     +     j

      ! fitt character size to the multiplicity of the real number
      i=nipM*nip
      j=mod(i,RtoB)
      If(j.Gt.0) i=i+j

      ! Allocate memory
      Call GetMem(label,'Allo','Char',ip,i)

      Return
      End

************************************************************************
*  DeAllocateC
*
*> @brief
*>   Pseudo deallocation of memory for a string of length \p nipM of a vector of dimension \p nip
*> @author Eugeniusz Bednarz
*>
*> @details
*> Pseudo deallocation of memory for a string of length \p nipM of a vector of dimension \p nip.
*>
*> Example: A call
*> \code
*> Call DeAllocateC('Label',ip,m,n)
*> \endcode
*> will deallocate a character vector of \p n elements, where any element of this vector has a length \p m.
*>
*> @param[in]  label The label of allocated memory
*> @param[out] ip    The index to proper element of the character vector
*> @param[in]  nipM  The length of the character
*> @param[in]  nip   The dimension of character vector
************************************************************************
      Subroutine DeAllocateC(label,ip,nipM,nip)
      Implicit None
#include "WrkSpc.fh"
#include "SysDef.fh"
      !
      Character*(*)
     +     label
      Integer
     +     ip,
     +     nipM,
     +     nip
      !
      Integer
     +     i

      i=nipM*nip
      ! DeAllocate memory
      Call GetMem(label,'Free','Char',ip,i)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine check_use(nToc,i_run_used,Label)

use RunFile_data, only: lw
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nToc, i_run_used(nToc)
character(len=*), intent(in) :: Label
integer(kind=iwp) :: i, nData, RecTyp
character(len=60) :: Line
character(len=lw), allocatable :: RecLab(:)
integer(kind=iwp), parameter :: MakeWarn = 40 !, MakeErr = 100
#ifdef _HAVE_EXTRA_
! FIXME: This include file should be created, as it contains a shared common block
!# include "lfalcon.fh"
#else
logical(kind=iwp), parameter :: isFalcon = .false.
#endif

do i=1,nToc
  if ((i_run_used(i) > MakeWarn) .and. (.not. isFalcon)) then
    if (.not. allocated(RecLab)) then
      call mma_allocate(RecLab,nToc,label='RecLab')
      call ffRun(Label//' labels',nData,RecTyp)
      call cRdRun(Label//' labels',RecLab,lw*nToc)
    end if
    !write(u6,*) Label//' label ',i,' used ',i_run_used(i), ' times'
    write(Line,'(A,A,A,I8,A)') 'RunFile label ',RecLab(i),';was used ',i_run_used(i),' times'
    call WarningMessage(1,Line)
  end if
end do
call mma_deallocate(RecLab,safe='*')

end subroutine check_use

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ZMatReader(iZMUnit,LuWr,nAtoms,nXAtoms,nBasis,nAskAtoms,iErr)
! nAtoms : Total number of real atoms. Include X dummy atoms: NAT(i)= 0
! nXAtoms: Total number of ghost (Z) atoms:                   NAT(i)=-1
! nBasis : Nummer of atom types requiring Basis Set
!  ***  nAskAtoms == -1  =>  Seward ZMAT input  => Use "End of"
!  ***  nAskAtoms /= -1  =>  GateWay ZMAT input => Use nAskAtoms

use ZMatConv_Mod, only: BasReq, iZmat, NAT, Symbols, Zmat
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iZMUnit, LuWR, nAskAtoms
integer(kind=iwp), intent(out) :: nAtoms, nXAtoms, nBasis, iErr
integer(kind=iwp) :: i, NA, NAtom, NB, NT, Nwords
integer(kind=iwp) :: istatus
real(kind=wp) :: Beta, Dist, Theta
character(len=80) :: Line
character(len=24) :: Words(7)
character(len=3) :: Command

iErr = 0
nAtoms = 0
nXAtoms = 0
nBasis = 0

do
  ! Read Line (or COMMAND)
  if ((nAtoms+nXAtoms) == nAskAtoms) exit
  read(iZMUnit,'(A)',iostat=istatus) Line
  if (istatus < 0) write(LuWr,*) ' [ZMatReader]: Unable to read z-matrix file !'
  if (istatus /= 0) return
  if (Line(1:1) == '*') cycle
  if (Line == ' ') exit
  Command = Line(1:3)
  call UpCase(Command)
  if (Command == 'END') exit
  iErr = 0
  NA = 0
  NB = 0
  NT = 0
  Dist = Zero
  Beta = Zero
  Theta = Zero

  ! Read Symbol           [ Symb ]
  call Pick_Words(Line,7,Nwords,Words)
  if (Nwords < 1) then
    call error(5)
    return
  end if
  call FoundAtomicNumber(LuWr,Words(1),NAtom,iErr)
  if (iErr /= 0) then
    call error(6)
    return
  end if
  if (NAtom >= 0) nAtoms = nAtoms+1
  if (NAtom == -1) nXAtoms = nXAtoms+1
  if (nAtoms+nXAtoms > size(NAT)) then
    call error(7)
    return
  end if
  NAT(nAtoms+nXAtoms) = NAtom
  Symbols(nAtoms+nXAtoms) = trim(Words(1))
  if (NAtom > 0) BasReq(NAtom) = .true.
  if ((nAtoms+nXAtoms) == 1) cycle ! Read Only the First Atom

  ! Read Distance         [ Symb   NA Dist ]
  call Pick_Words(Line,7,Nwords,Words)
  if (Nwords < 3) then
    call error(5)
    return
  end if
  call Get_iNumber(Words(2),NA,iErr)
  if (iErr /= 0) then
    call error(6)
    return
  end if
  if (NA >= (nAtoms+nXAtoms)) then
    call error(1)
    return
  end if
  call Get_dNumber(Words(3),Dist,iErr)
  if (iErr /= 0) then
    call error(6)
    return
  end if
  if (Dist <= Zero) then
    call error(2)
    return
  end if
  iZmat(1,nAtoms+nXAtoms) = NA
  Zmat(1,nAtoms+nXAtoms) = Dist
  if ((nAtoms+nXAtoms) == 2) cycle ! Read Only the Second Atom

  ! Read Planar angle     [ Symb   NA Dist   NB Beta ]
  call Pick_Words(Line,7,Nwords,Words)
  if (Nwords < 5) then
    call error(5)
    return
  end if
  call Get_iNumber(Words(4),NB,iErr)
  if (iErr /= 0) then
    call error(6)
    return
  end if
  if (NB >= (nAtoms+nXAtoms)) then
    call error(1)
    return
  end if
  call Get_dNumber(Words(5),Beta,iErr)
  if (iErr /= 0) then
    call error(6)
    return
  end if
  if ((Beta <= Zero) .or. (Beta >= 180.0_wp)) then
    call error(3)
    return
  end if
  iZmat(2,nAtoms+nXAtoms) = NB
  Zmat(2,nAtoms+nXAtoms) = Beta
  if (NA == NB) then
    call error(4)
    return
  end if
  if ((nAtoms+nXAtoms) == 3) cycle ! Read Only the Second Atom

  ! Read Dihedral angle   [ Symb   NA Dist   NB Beta   NT Theta]
  call Pick_Words(Line,7,Nwords,Words)
  if (Nwords < 7) then
    call error(5)
    return
  end if
  call Get_iNumber(Words(6),NT,iErr)
  if (iErr /= 0) then
    call error(6)
    return
  end if
  if (NT >= (nAtoms+nXAtoms)) then
    call error(1)
    return
  end if
  call Get_dNumber(Words(7),Theta,iErr)
  if (iErr /= 0) then
    call error(6)
    return
  end if
  iZmat(3,nAtoms+nXAtoms) = NT
  Zmat(3,nAtoms+nXAtoms) = Theta
  if ((NA == NB) .or. (NB == NT) .or. (NA == NT)) then
    call error(4)
    return
  end if
end do

! Pre-check Basis Set consistency  BasReq: Atom requiring Basis Set
nBasis = 0
do i=1,size(BasReq)
  if (BasReq(i)) nBasis = nBasis+1
end do

return

contains

subroutine error(code)
  integer(kind=iwp), intent(in) :: code
  iErr = 1
  select case (code)
    case (1)
      write(LuWr,*) ' [ZMatReader]: Wrong index in line'
    case (2)
      write(LuWr,*) ' [ZMatReader]: Wrong distance in line'
    case (3)
      write(LuWr,*) ' [ZMatReader]: Wrong planar angle in line'
    case (4)
      write(LuWr,*) ' [ZMatReader]: Multiple index in line'
    case (5)
      write(LuWr,*) ' [ZMatReader]: Z-Matrix incomplete in line'
    case (6)
      write(LuWr,*) ' [ZMatReader]: Error in line'
    case (7)
      write(LuWr,*) ' [ZMatReader]: Too many atoms'
    case default
  end select
  write(LuWr,*) '               ',Line
end subroutine error

end subroutine ZMatReader

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
      INTEGER FUNCTION NOVERM(N,M)
      IMPLICIT REAL*8 (A-H,O-Z)
      SAVE INIT,NOMTAB
      DIMENSION NOMTAB(225)
      DATA INIT / 0 /
      NOVERM=0
      IF(N.LT.0) RETURN
      MM=M
      IF(2*MM.GT.N) MM=N-M
      IF(MM.LT.0) RETURN
      NOVERM=1
      IF(MM.EQ.0) RETURN
      NOVERM=N
      IF(MM.EQ.1) RETURN
      IF(INIT.EQ.0) THEN
        IPOS=0
        DO I=4,32
         X=DBLE(I)
         DO J=2,I/2
          IPOS=IPOS+1
          X=(X*DBLE(I+1-J))/DBLE(J)
          NOMTAB(IPOS)=NINT(X)
         END DO
        END DO
CPAM      write(*,'(1x,5I9)') NOMTAB
        INIT=1
      END IF
      IF(N.LE.32) THEN
        NOVERM=NOMTAB(((N-3)**2)/4+MM-1)
      ELSE
        X=DBLE(NOVERM)
        DO K=2,MM
         X=(X*DBLE(N+1-K))/DBLE(K)
        END DO
        NOVERM=NINT(X)
        IF(X.NE.DBLE(NOVERM)) THEN
          WRITE(6,*)' NOVERM: Unable to compute N over M'
          WRITE(6,*)' N=',N
          WRITE(6,*)' M=',M
          CALL ABEND()
        END IF
      END IF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine MakeMO(AOInt,Temp,nTemp,nInt,
     &                  MOInt,nMOInt,
     &                  iCmp,iCmpa,
     &                  ibasi,jbasj,kbask,lbasl,
     &                  nGr,index,
     &                  moip,naco,nop,indgrd,
     &                  ishll,ishell,rmoin,nmoin,iuvwx,iao,iaost,
     &                  buffer,ianga,c)
*
*   this is the driver for the two index transformation
*   it is not very efficent, but on the other hand it
*   usually to take more than a few percent of the total
*   CPU time, if someone notice something else I will
*   rewrite it, in the mean time, dont worry.
*

      Use Basis_Info, only: Shells
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "buffer.fh"
*
*
      Logical pert(0:7),lc
      Integer iCmpa(4),
     &         index(3,4),ipPert(0:7),icmp(4),ibas(4),
     &         indgrd2(3,4,0:7),indgrd(3,4,0:nirrep-1),
     &         moip(0:7),nop(4),ishell(4),iuvwx(4),
     &         iao(4),iAOST(4),ianga(4),ishll(4)
      Real*8 Temp(nTemp),AOInt(nInt),rmoin(nmoin),MOInt(nMOInt),
     &       C(12),buffer(*)
*
      iMax=0
      nMax=0
      mSum=0
      nabcd=iBasi*jBasj*kBask*lBasl
      nijkl=icmp(1)*icmp(2)*icmp(3)*icmp(4)
      iBas(1)=iBasi
      iBas(2)=jBasj
      iBas(3)=kBask
      iBas(4)=lBasl
      Do ii=1,4
       imax=Max(iBas(ii)*iCmp(ii),imax)
       mSum=mSum+iBas(ii)*iCmp(ii)
      End Do
      imax=Max(iMax,nAco)
*
      nInt2=nabcd*nijkl

      ip=1
      ip0=ip
      ip=ip+nGr*nijkl*nabcd
      ip1=ip
      nScrtch=imax**4
      ip=ip+nScrtch
      ip2=ip
      ip=ip+nScrtch
      ip3=ip
      ip=ip+nScrtch
      ip5=ip
      ip=ip+iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)*
     &   iBas(1)*iBas(2)*iBas(3)*iBas(4)
      If (ip-1.gt.nTemp) Then
         Write (6,*) 'MakeMO: ip-1.gt.nTemp'
         Write (6,*) 'ip,nTemp=',ip,nTemp
         Call Abend()
      End If
*     ip=2
*     Temp(ip-1)=0.0d0
*     ip0=ip
*     ip=ip+nGr*nijkl*nabcd+1
*     Temp(ip-1)=0.0d0
*     ip1=ip
*     nScrtch=imax**4+1
*     ip=ip+nScrtch
*     Temp(ip-1)=0.0d0
*     ip2=ip
*     ip=ip+nScrtch
*     Temp(ip-1)=0.0d0
*     ip3=ip
*     ip=ip+nScrtch
*     Temp(ip-1)=0.0d0
*     ip5=ip
*     ip=ip+iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)*
*    &   iBas(1)*iBas(2)*iBas(3)*iBas(4)+1
*     Temp(ip-1)=0.0d0
*
      ipc=1
      ipD=ipc
*     nD=nACO**4
*     ipC=ipC+nd
      ipci=ipc
*     nCi=iBas(1)*iCmp(1)*nACO
      ipcj=ipc
*     nCj=iBas(2)*iCmp(2)*nACO
      ipck=ipc
      nCk=iBas(3)*iCmp(3)*nACO
      ipc=ipc+nCk
      ipcl=ipc
      nCl=iBas(4)*iCmp(4)*nAcO
      ipc=ipc+nCl
      nij=iCmp(1)*iBas(1)*iBas(2)*iCmp(2)
      nkl=iCmp(3)*iBas(3)*iBas(4)*iCmp(4)
      If (ipc-1.ne.nMoIn) Then
         Write (6,*) 'MakeMO: ipc-1.ne.nMoIn'
         Write (6,*) 'ipc,nMoIn=',ipc,nMoIn
         Call Abend()
      End If

*
      Call Sort_mck(AOInt,Temp(ip0),
     &          iBas(1),iBas(2),iBas(3),iBas(4),
     &          iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &          iBas(1),iBas(2),iBas(3),iBas(4),
     &          iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4),
     &          nGr,nop,ianga,
     &          indgrd,indgrd2,ishll,C)
*
      Do iCent=1,4
       lc=.false.
       Do iCar=1,3
        Call ICopy(nIrrep,[0],0,ipPert,1)
        Call lCopy(nIrrep,[.false.],0,pert,1)
        lc=.false.
        Do iIrrep=0,nIrrep-1
         If (indgrd(icar,icent,iIrrep).ne.0) Then
            ipPert(iIrrep)=ipMO(abs(indgrd(iCar,iCent,iIrrep)),1)
            pert(iIrrep)=.true.
         End If
        If (IndGrd(iCar,icent,iirrep).ne.0) lC=.true.
        End Do
        If (lc) Then
        If (Index(iCar,iCent).gt.0) Then

*
         iGr=index(icar,icent)
         Call MOAcc(Temp(ip0+(iGr-1)*nijkl*nabcd),nINT2,
     &              Temp(ip1),Temp(ip2),Temp(ip3),nScrtch,
     &              MOInt,nMOINt,ishell,
     &              rmoin(ipCi),nCi,rmoin(ipCj),nCj,
     &              rmoin(ipCk),nCk,rmoin(ipCl),nCl,
     &              Moip,nACO,pert,nOp,ibas,icmpa,
     &              iCar,icent,indgrd,rmoin(ipD),
     &              DBLE(iuvwx(iCent))/DBLE(nIrrep),iao,iaost,
     &              buffer,Temp(ip2),nij,nkl,
     &              Shells(ishll(1))%nBasis,Shells(ishll(2))%nBasis,
     &            icmpa(1),icmpa(2))
*
        Else If (Index(iCar,iCent).lt.0) Then
         call dcopy_(nabcd*nijkl,[Zero],0,Temp(ip5),1)
         Do iCnt=1,4
           iGr=Index(iCar,iCnt)
           If (iGr.gt.0)Then
             ipFin=(iGr-1)*nijkl*nabcd+ip0
             Do ii=1,nabcd*nijkl
                Temp(ip5+ii-1)=Temp(ip5+ii-1)-Temp(ipFin-1+ii)
             End Do
           End If
         End Do
         Call MOAcc(Temp(ip5),nInt2,
     &              Temp(ip1),Temp(ip2),Temp(ip3),nScrtch,
     &              MOInt,nMOINt,ishell,
     &              rmoin(ipCi),nCi,rmoin(ipCj),nCj,
     &              rmoin(ipCk),nCk,rmoin(ipCl),nCl,
     &              moip,nACO,pert,nOp,ibas,icmpa,
     &              iCar,icent,indgrd,rMoin(ipD),
     &              DBLE(iuvwx(iCent))/DBLE(nIrrep),iao,iaost,
     &              buffer,Temp(ip2),nij,nkl,
     &              Shells(ishll(1))%nBasis,Shells(ishll(2))%nBasis,
     &              icmpa(1),icmpa(2))
*
        End If
        End If
       End Do
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_Col_Comp(Col,nDim,iCol,nCol,Vec,nVec,Buf,lBuf,
     &                           Fac,irc)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: compute columns from a set of vectors.
C
#include "implicit.fh"
      Real*8  Col(nDim,nCol), Vec(nDim,nVec), Buf(lBuf)
      Integer iCol(nCol)

      irc = 0
      If (nDim.lt.1 .or. nCol.lt.1) Return
      If (nVec .lt. 1) Then
         If (Fac .ne. 1.0D0) Call dScal_(nDim*nCol,Fac,Col,1)
         Return
      End iF

      If (nCol.gt.1 .and. lBuf.ge.nVec) Then

         NumCol = min(lBuf/nVec,nCol)
         NumBat = (nCol - 1)/NumCol + 1

         Do iBat = 1,NumBat

            If (iBat .eq. NumBat) Then
               NumC = nCol - NumCol*(NumBat-1)
            Else
               NumC = NumCol
            End If
            iC1 = NumCol*(iBat-1) + 1

            If (lBuf .lt. NumC*nVec) Then
               irc = -1
               Return
            End If

            Call ChoMP2_Col_cp(Vec,nDim,nVec,Buf,NumC,iCol(iC1))
            Call DGEMM_('N','T',nDim,NumC,nVec,
     &                 1.0D0,Vec,nDim,Buf,NumC,
     &                 Fac,Col(1,iC1),nDim)

         End Do

      Else

         Do iC = 1,nCol
            Call dGeMV_('N',nDim,nVec,
     &                 1.0D0,Vec(1,1),nDim,Vec(iCol(iC),1),nDim,
     &                 Fac,Col(1,iC),1)
         End Do

      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Giovanni Ghigo                              *
************************************************************************
*  ChoMP2_TraCtl
*
*> @brief
*>   Driver for the generation of the two-electrons integrals file (``MOLINT``)
*>   from the AO-based Cholesky Full Vectors for MBPT2 program
*> @author Giovanni Ghigo
*>
*> @details
*> This routine is similar to ::Cho_TraCtl routine but only the
*> transformed vectors type ``C`` (TCVC) are generated. See ::Cho_TraCtl
*> and related routines for more details.
*>
*> @note
*> The number of frozen and deleted MO used in the post-SCF
*> must be written in the RunFile in \c nFroPT and \c nDelPT arrays.
*>
*> @param[in] LUINTM Unit number of two-electrons integrals file (``MOLINT``)
*> @param[in] CMO    MO coefficients
*> @param[in] NCMO   Total number of MO coefficients
************************************************************************
      Subroutine ChoMP2_TraCtl(LUINTM,CMO,NCMO)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden                                    *
*           October 2004                                               *
* Modified for Cholesky-MP2 May 2005                                   *
*----------------------------------------------------------------------*
* This is the routine for the transformation from AO basis to MO basis *
* of the Cholesky Full Vectors & Two-electrons integral generation.    *
* Reads the Cholesky Full Vectors (CHFV), generate new Transformed     *
* Cholesky Full Vectors (TCVx) then generate the Two-electrons inte-   *
* gral file (MOLINT).                                                  *
*  <p,q|k,l>  where p,q: All MO; k,l: Occupied                         *
* THIS CODE IS ONLY FOR MBPT2 AND IT IS SPLIT FROM THE GENERAL CODE    *
* BUT IT IS STILL INTEGRATED AND DEPENDENT ON THE GENERAL CODE         *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Dimension CMO(NCMO)
      Character*4 CHNm
      Character*6 CHName
      Parameter (CHNm='CHFV')
      Logical Found

      MulD2h(i,j) = iEor(i-1,j-1)+1

      IfTest=.False.

      Call Timing(CPU0,CPE,TIO0,TIOE)

***   INIZIALIZATION   *************************************************

* --- Define what has to be calculated. ---
*      DoTCVA flag for the generation of TCVA
*      DoFull flag for the generation of TCVF
*      DoCoul flag for the generation of coulomb integrals

*     MBPT2
        DoTCVA = .False.
        DoFull = .False.
        DoCoul = .False.

* --- Get Informations from RunFile. ---
*      The following informations must be passed to the Cholesky
*      transformation routine through RunFile. COMMON blocks could
*      not be used due to several conflicts.
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      Call Get_iArray('nFroPT',nFro,nSym)
      Call Get_iArray('nDelPT',nDel,nSym)
      Call Get_iArray('nIsh',nIsh,nSym)
*PAM07      Call Get_iArray('nAsh',nAsh,nSym)
* Replaced by:
      Do i=1,nSym
        nAsh(i)=0
      End Do
      Call qpg_iArray('nAsh',Found,nData)
      If(Found .and. nData.eq.nSym) Then
        Call Get_iArray('nAsh',nAsh,nSym)
      End If
* End of replacement
      Call Get_iArray('NumCho',NumCho,nSym)
      nBasT=0
      Do i=1,nSym
        nBasT   = nBasT + nBas(i)
        nOrb(i) = nBas(i) - nFro(i) - nDel(i)
        nIsh(i) = nIsh(i) - nFro(i)
        nOsh(i) = nIsh(i) + nAsh(i)
        nSsh(i) = nOrb(i) - nOsh(i)
      EndDo

* --- Inizialize information arrays. ---

*     The TCVx existing flag and the Memory Allocation & Length array:
      Do iType=1,MxTCVx
        Do iSym=1,MaxSym
          Do jSym=1,MaxSym
            TCVXist(iType,iSym,jSym)=.False. ! TCVx existing flag.
            iMemTCVX(iType,iSym,jSym,1)=0 ! Memory Address and
            iMemTCVX(iType,iSym,jSym,2)=0 ! Length in Work(TCVx)
          EndDo
        EndDo
      EndDo

*     The Address Field for MOLINT:
      LenIAD2M=3*36*36
      Do i=1,36*36
       IAD2M(1,i)=0
       IAD2M(2,i)=0
       IAD2M(3,i)=0
      EndDo
      iAddrIAD2M=0
      Call iDaFile(LUINTM,1,IAD2M,LenIAD2M,iAddrIAD2M)

*     The Timing:
      CPU_Tra=0.0d0
      TIO_Tra=0.0d0
      CPU_Gen=0.0d0
      TIO_Gen=0.0d0

* *** START LOOP iSymL on TOTAL SYMMETRY of L (iSym * jSym)   **********
      DO iSymL=1,nSym

*       Re-Inizialize the TCVx & iMemTCVX
        Do iSym=1,MaxSym
          Do jSym=1,MaxSym
            TCVXist(3,iSym,jSym)=.False. ! TCVx existing flag.
            iMemTCVX(3,iSym,jSym,1)=0 ! Memory Address and
            iMemTCVX(3,iSym,jSym,2)=0 ! Length in Work(TCVx)
          EndDo
        EndDo
        Call Mem_Est(iSymL,nVec,nFVec)
        If (nVec.GT.0 .and. nFVec.GT.0) then
          nBatch =(NumCho(iSymL)-1)/nVec + 1
        else
          Write(6,*)
          Write(6,*) ' ************************************'
          Write(6,*) ' *  Insufficient memory for batch ! *'
          Write(6,*) ' ************************************'
          Write(6,*)
          Call XFlush(6)
          Call Abend()
        EndIf

*  ---  START LOOP iBatch  ---------------------------------------------
        DO iBatch=1,nBatch
          If (iBatch.EQ.nBatch) then
            NumV = NumCho(iSymL) -nVec * (nBatch-1)
          else
            NumV = nVec
          EndIf
          nFBatch = (NumV-1) / nFVec + 1

*   ---   Start Transformation of Cholesy Vectors  CHFV -> TCVx
          Call Timing(CPU1,CPE,TIO1,TIOE)

*         Start Loop on CHFV-iSym-jSym
          Do iSym=1,nSym
          lUCHFV = -1
           If(nBas(iSym).GT.0) then
            Do jSym=1,iSym
            lUCHFV = -1
             If(nBas(jSym).GT.0 .and. MulD2h(iSym,jSym).EQ.iSymL) then
              lUCHFV=7
              iStrtVec_AB = nVec * (iBatch-1) + 1
              Write(CHName,'(A4,I1,I1)') CHNm,iSym,jSym
              Call dAName_MF_WA(lUCHFV,CHName)
              If (iSym.EQ.jSym) then
               Call ChoMP2_TraS(iSymL, iSym,jSym, NumV, CMO,NCMO,
     &                      lUCHFV, iStrtVec_AB, nFVec,nFBatch)
              Else
               Call ChoMP2_TraA(iSymL, iSym,jSym ,NumV, CMO,NCMO,
     &                      lUCHFV, iStrtVec_AB, nFVec,nFBatch)
              EndIf
              Call dAClos(lUCHFV)
             EndIf
            EndDo
           EndIf
          EndDo
*         End Loop on CHFV-iSym-jSym

          Call Timing(CPU2,CPE,TIO2,TIOE)
          CPU_Tra=CPU_Tra+CPU2-CPU1
          TIO_Tra=TIO_Tra+TIO2-TIO1
*   ---   End Transformation of Cholesky Vectors  CHFV -> TCVx

*   ---   Start Generation of Integrals files  TCVx -> MOLINT

*         Start Loop on I, J, A, B Symmetries
          nSymP=(nSym**2+nSym)/2
          Do iSymI = 1, nSym
            Do iSymJ = 1, iSymI
              Do iSymA = 1, nSym
                Do iSymB = 1, nSym
                  iSymAI = MulD2h(iSymA,iSymI)
                  iSymBJ = MulD2h(iSymB,iSymJ)

                  If (iSymAI.EQ.iSymL .and. iSymBJ.EQ.iSymL)
     &              Call ChoMP2_TwoEl(iBatch,nBatch,NumV,LUINTM,
     &                        iAddrIAD2M,iSymI,iSymJ,iSymA,iSymB, iSymL)

                EndDo
              EndDo
            EndDo
          EndDo
*         End Loop on I, J, A, B Symmetries

          Do iSym=1,MaxSym
           Do jSym=1,MaxSym
            If(iMemTCVX(3,iSym,jSym,1).GT.0) then
             iAddr=iMemTCVX(3,iSym,jSym,1)
             iLen =iMemTCVX(3,iSym,jSym,2)
             Call GetMem('iAddr','Free','Real',iAddr,iLen)
             iMemTCVX(3,iSym,jSym,1)=0
             iMemTCVX(3,iSym,jSym,2)=0
            EndIf
           EndDo
          EndDo
          Call Timing(CPU3,CPE,TIO3,TIOE)
          CPU_Gen=CPU_Gen+CPU3-CPU2
          TIO_Gen=TIO_Gen+TIO3-TIO2
*   ---   End Generation of Two-Electrons Integrals files

        ENDDO
*  ---  END LOOP iBatch  -----------------------------------------------

      ENDDO
* *** END MAIN LOOP iSymL on TOTAL SYMMETRY of L (iSym * jSym)   *******

      iAddrIAD2M=0
      Call iDaFile(LUINTM,1,IAD2M,LenIAD2M,iAddrIAD2M)

      Write(6,*)'TIMING INFORMATION:   CPU(s)   %CPU   Elapsed(s)'
      Write(6,'(A,F9.2,1X,F6.1,1X,F12.2)') ' Transformation     ',
     & CPU_Tra, 1.0d2*(CPU_Tra+5.0d-5)/(TIO_Tra+5.0d-5), TIO_Tra
      Write(6,'(A,F9.2,1X,F6.1,1X,F12.2)') ' Generation         ',
     & CPU_Gen, 1.0d2*(CPU_Gen+5.0d-5)/(TIO_Gen+5.0d-5), TIO_Gen
      Call Timing(CPU4,CPE,TIO4,TIOE)
      CPU_Tot=CPU4-CPU0
      TIO_Tot=TIO4-TIO0
      Write(6,'(A,F9.2,1X,F6.1,1X,F12.2)') ' TOTAL              ',
     & CPU_Tot, 1.0d2*(CPU_Tot+5.0d-5)/(TIO_Tot+5.0d-5), TIO_Tot
      Call XFlush(6)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE HAM3(OP0,OP1,NOP2,OP2,NOP3,OP3,ISYCI,CI,SGM)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: Zero, One, Two
      use stdalloc, only: mma_allocate, mma_deallocate
      use gugx, only: SGS, CIS, EXS
      use caspt2_module, only: NSYM,NASHT,ISCF,NACTEL,NCONF,IASYM
      use gugx, only: MxLev
      use pt2_guga, only: MxCI
      IMPLICIT NONE

      integer(kind=iwp), intent(in):: NOP2,NOP3,ISYCI
      real(kind=wp) , intent(in)::OP0
      real(kind=wp), intent(in):: OP1(NASHT,NASHT),OP2(NOP2),OP3(NOP3)
      real(kind=wp), intent(in):: CI(*)
      real(kind=wp), intent(inout):: SGM(*)
C Local arrays:
      integer(kind=iwp) IATOG(MXLEV)
      real(kind=wp), Allocatable:: SGM1(:), SGM2(:)
      Integer(kind=iwp) nLev,ITABS,ISYM,I,IZ,IY,IYZ,ISYZ,ISYM1,NSGM1,
     &                  LEVY,LEVZ,ISTU,ISVX,ISVXYZ,ISYM2,IT,ITMIN,ITU,
     &                  ITUVXYZ,IU,IV,IVMIN,IVX,IVXYZ,IX,LEVT,LEVU,LEVV,
     &                  LEVX,NSGM2
      real(kind=wp) OCCNO,X

      nLev = SGS%nLev

C Purpose: Compute and add a contribution to SGM which is
C obtained from a sum of zero- one- two- and three-electron
C operators acting on wave function CI.

C Note that the coefficients in OP1 and OP2 must have been
C modified by adding elements from OP2 and OP3, as done in
C subroutine MODOP.

C Presently symmetry blocking is disregarded for OP2, OP3, but
C index pair C permutation symmetry is used.
C NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
C NOP3=(NASHT**2+2 over 3)  (Binomial coefficient)

      IF(NCONF.EQ.0) RETURN
      IF(ABS(OP0).GT.1.0D-15) CALL DAXPY_(NCONF,OP0,CI,1,SGM,1)
      IF(NACTEL.EQ.0) RETURN

C Unless this is a special-case wave function, reserve space
C for intermediate results of elementary excitations.
      IF(ISCF.EQ.0) THEN
        CALL mma_allocate(SGM1,MXCI,Label='SGM1')
        IF(NACTEL.GE.2) CALL mma_allocate(SGM2,MXCI,Label='SGM2')
      END IF
C Special cases:
      OCCNO=Zero
      IF(ISCF.EQ.1) OCCNO=Two
      IF(ISCF.EQ.2) OCCNO=One

C Create reorder table giving the GUGA level, i.e. CI-coupling
C ordinal number of each active orbital.
      ITABS=0
      DO ISYM=1,NSYM
        DO I=1,NLEV
          IF(SGS%ISM(I).EQ.ISYM) THEN
            ITABS=ITABS+1
            IATOG(ITABS)=I
          END IF
        END DO
      END DO

      DO IZ=1,NASHT
       DO IY=1,NASHT
        IYZ=IY+(IZ-1)*NASHT
        ISYZ=Mul(IASYM(IY),IASYM(IZ))
        ISYM1=Mul(ISYZ,ISYCI)
        NSGM1=CIS%NCSF(ISYM1)
        IF(NSGM1.EQ.0) CYCLE
        IF(ISCF.EQ.0) THEN
C The general case:
C Compute SGM1:=E(IY,IZ) PSI
          CALL DCOPY_(NSGM1,[Zero],0,SGM1,1)
          LEVY=IATOG(IY)
          LEVZ=IATOG(IZ)
          CALL SIGMA1(SGS,CIS,EXS,
     &                LEVY,LEVZ,One,ISYCI,CI,SGM1)
C Add non-zero 1-el contribution to SGM:
          IF(ISYZ.EQ.1) THEN
            X=OP1(IY,IZ)
            IF(ABS(X).GT.1.0D-15) THEN
              CALL DAXPY_(NCONF,X,SGM1,1,SGM,1)
            END IF
          END IF
        ELSE
C Closed-shell or hi-spin case:
          IF(IY.NE.IZ) CYCLE
          X=OCCNO*OP1(IY,IZ)
          SGM(1)=SGM(1)+X*CI(1)
        END IF
        IF(NACTEL.EQ.1) CYCLE
        DO IX=IZ,NASHT
         IVMIN=1
         IF(IX.EQ.IZ) IVMIN=IY
         DO IV=IVMIN,NASHT
          IVX=IV+(IX-1)*NASHT
          ISVX=Mul(IASYM(IV),IASYM(IX))
          ISVXYZ=Mul(ISVX,ISYZ)
          IVXYZ=(IVX*(IVX-1))/2+IYZ
          ISYM2=Mul(ISVX,ISYM1)
          NSGM2=CIS%NCSF(ISYM2)
          IF(NSGM2.EQ.0) CYCLE
          IF(ISCF.EQ.0) THEN
C The general case:
C Compute SGM2:=E(IV,IX) SGM1
            CALL DCOPY_(NSGM2,[Zero],0,SGM2,1)
            LEVV=IATOG(IV)
            LEVX=IATOG(IX)
            CALL SIGMA1(SGS,CIS,EXS,
     &                  LEVV,LEVX,One,ISYM1,SGM1,SGM2)
C Add non-zero 2-el contribution to SGM:
            IF(ISVXYZ.EQ.1) THEN
              X=OP2(IVXYZ)
              IF(ABS(X).GT.1.0D-15) THEN
                CALL DAXPY_(NCONF,X,SGM2,1,SGM,1)
              END IF
            END IF
          ELSE
C Closed-shell or hi-spin case:
            IF(IY.NE.IZ) CYCLE
            IF(IV.NE.IX) CYCLE
            X=(OCCNO**2)*OP2(IVXYZ)
            SGM(1)=SGM(1)+X*CI(1)
          END IF
          IF(NACTEL.EQ.2) CYCLE
          DO IU=IX,NASHT
           ITMIN=1
           IF(IU.EQ.IX) ITMIN=IV
           DO IT=ITMIN,NASHT
            ITU=IT+(IU-1)*NASHT
            ISTU=Mul(IASYM(IT),IASYM(IU))
            IF(ISTU.NE.ISVXYZ) CYCLE
            ITUVXYZ=((ITU+1)*ITU*(ITU-1))/6+IVXYZ
            X=OP3(ITUVXYZ)
            IF(ABS(X).LT.1.0D-15) CYCLE
C Add non-zero 3-el contribution to SGM:
            IF(ISCF.EQ.0) THEN
              LEVT=IATOG(IT)
              LEVU=IATOG(IU)
              CALL SIGMA1(SGS,CIS,EXS,
     &                    LEVT,LEVU,X,ISYM2,SGM2,SGM)
            ELSE
C Closed-shell or hi-spin case:
              IF(IT.NE.IU) CYCLE
              IF(IV.NE.IX) CYCLE
              IF(IY.NE.IZ) CYCLE
              X=(OCCNO**3)*OP3(ITUVXYZ)
              SGM(1)=SGM(1)+X*CI(1)
            END IF
           END DO
          END DO
         END DO
        END DO
       END DO
      END DO

C Deallocate temporary arrays, if any:
      IF(ISCF.EQ.0) THEN
        CALL mma_deallocate(SGM1)
        IF(NACTEL.GE.2) CALL mma_deallocate(SGM2)
      END IF

      END SUBROUTINE HAM3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine contf32 (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3)
c
c     this routine do:
c     FIII2 f3(e,m) <- sum(n,f) [ <ef||mn> . T1o(n,f) ]
c
c     N.B use and destroy : V1,V2,M1
c     N.B # of read : 3
c
       use Para_Info, only: MyRank
#include "ccsd2.fh"
#include "parallel.fh"
#include "wrk.fh"
       integer lunabij1,lunabij2,lunabij3
c
c     help variables
c
       integer posst,rc,ssc
c
c1    f3(e,m)aa <- sum(n,f-aa) [ <ef||mn>aaaa . T1o(n,f)aa ]
c
cpar
      if (myRank.eq.idbaab) then
c
c1.1  read V1(ef,mn) <= <ef||mn>aaaa
       call filemanager (2,lunabij1,rc)
       call getmediate (wrk,wrksize,
     & lunabij1,possv10,mapdv1,mapiv1,rc)
c
c1.2  expand V2(e,f,m,n) <= V1(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c1.3  map V1(e,m,f,n) <= V2(e,f,m,n)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv2,mapiv2,1,mapdv1,mapiv1,possv10,posst,
     &           rc)
c
c1.4  mult M1(e,m) = V1(e,m,f,n) . T1o(f,n)aa
       call mult (wrk,wrksize,
     & 4,2,2,2,mapdv1,mapiv1,1,mapdt11,mapit11,1,mapdm1,
     &            mapim1,ssc,possm10,rc)
c
c1.5  add f3(e,m)aa <- M1(e,m)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdf31,mapif31,1,rc)
c
        end if
c
c
c2    f3(e,m)bb <- sum(n,f-bb) [ <ef||mn>bbbb . T1o(n,f)bb ]
c
cpar
      if (myRank.eq.idaabb) then
c
c2.1  read V1(ef,mn) <= <ef||mn>bbbb
       call filemanager (2,lunabij2,rc)
       call getmediate (wrk,wrksize,
     & lunabij2,possv10,mapdv1,mapiv1,rc)
c
c2.2  expand V2(e,f,m,n) <= V1(ef,mn)
       call expand (wrk,wrksize,
     & 4,4,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c2.3  map V1(e,m,f,n) <= V2(e,f,m,n)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv2,mapiv2,1,mapdv1,mapiv1,possv10,posst,
     &           rc)
c
c2.4  mult M1(e,m) = V1(e,m,f,n) . T1o(f,n)bb
       call mult (wrk,wrksize,
     & 4,2,2,2,mapdv1,mapiv1,1,mapdt12,mapit12,1,mapdm1,
     &            mapim1,ssc,possm10,rc)
c
c2.5  add f3(e,m)bb <- M1(e,m)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdf32,mapif32,1,rc)
c
       end if
c
c
c3    f3(e,m)aa <- sum(n,f-bb) [ <ef||mn>abab . T1o(n,f)bb ]
c4    f3(e,m)bb <- sum(n,f-aa) [ <fe||nm>abab . T1o(n,f)aa ]
c
cpar
      if ((myRank.eq.idbaab).or.(myRank.eq.idaabb)) then
c34.1 read V1(c,d,k,l) <= <cd||kl>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv10,mapdv1,mapiv1,rc)
       end if
c
c
cpar
      if (myRank.eq.idbaab) then
c
c3.1  map V2(e,m,f,n) <= V1 (e,f,m,n)
       call map (wrk,wrksize,
     & 4,1,3,2,4,mapdv1,mapiv1,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
c
c3.2  mult M1(e,m) = V2(e,m,f,n) . T1o(f,n)bb
       call mult (wrk,wrksize,
     & 4,2,2,2,mapdv2,mapiv2,1,mapdt12,mapit12,1,mapdm1,
     &            mapim1,ssc,possm10,rc)
c
c3.3  add f3(e,m)aa <- M1(e,m)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdf31,mapif31,1,rc)
c
       end if
c
c
cpar
      if (myRank.eq.idaabb) then
c
c4.1  map V2(e,m,f,n) <= V1 (f,e,n,m)
       call map (wrk,wrksize,
     & 4,3,1,4,2,mapdv1,mapiv1,1,mapdv2,mapiv2,possv20,posst,
     &           rc)
c
c4.2  mult M1(e,m) = V2(e,m,f,n) . T1o(f,n)aa
       call mult (wrk,wrksize,
     & 4,2,2,2,mapdv2,mapiv2,1,mapdt11,mapit11,1,mapdm1,
     &            mapim1,ssc,possm10,rc)
c
c4.3  add f3(e,m)bb <- M1(e,m)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,1.0d0,mapdm1,1,mapdf32,mapif32,1,rc)
c
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ALLOC()
! RASSCF: allocation of core memory
!
! Called from inpctl
!
! No subroutine calls
!
! ********** IBM-3090 Release 88 10 11 **********

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use rasscf_global, only: ISTORD, ISTORP, nFint
use general_data, only: NASH, NORB, NSYM
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IORD, IORP, NAP, NAQ, NAR, NAS, NOP, NRS, NSP, NSPQ, NSPQR, NSQ, NSR, NSS

#ifdef _DEBUGPRINT_
write(u6,*) ' Entering ALLOC'
#endif

! Compute space needed for transformed two-electron integrals

ISTORD(1) = 0
ISTORP(1) = 0
IORD = 0
IORP = 0
do NSP=1,NSYM
  NOP = NORB(NSP)
  NAP = NASH(NSP)
  do NSQ=1,NSYM
    NAQ = NASH(NSQ)
    NSPQ = Mul(NSP,NSQ)
    do NSR=1,NSYM
      NSPQR = Mul(NSPQ,NSR)
      NAR = NASH(NSR)
      do NSS=1,NSR
        if (NSPQR /= NSS) cycle
        NAS = NASH(NSS)
        NRS = NAR*NAS
        if (NSS == NSR) NRS = nTri_Elem(NAR)
        IORD = IORD+NOP*NAQ*NRS
        IORP = IORP+NAP*NAQ*NRS
      end do
    end do
  end do
  ISTORD(NSP+1) = IORD
  ISTORP(NSP+1) = IORP
end do
NFINT = ISTORD(NSYM+1)

#ifdef _DEBUGPRINT_
write(u6,'(1X,A,5X,9I5)') 'ISTORD-vector:',ISTORD(1:NSYM+1)
#endif

end subroutine ALLOC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Per-Olof Widmark                                 *
*               1993, Markus P. Fuelscher                              *
*               1996, Luis Serrano-Andres                              *
*               2012, Victor P. Vysotskiy                              *
************************************************************************
      Subroutine FIOInit()
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     set initial values of all arguments in the common blocks         *
*     /FIO1/, /FIO2/ and /FIO3/                                        *
*     /PFIO1/,/PFIO2/,/PFIO3/,/PFIO4/                                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, IBM Sweden, 1991                                   *
*     M.P. Fuelscher, University of Lund, Sweden, 1993                 *
*     L. Serrano-Andres, University of Lund, Sweden, 1996              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* History:                                                             *
*     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
#include "fio.fh"
#ifdef _OLD_IO_STAT_
#include "ofio.fh"
#else
#include "pfio.fh"
#endif
#include "ComDat.fh"
*
      Do i = 1, MxFile
         isOpen(i)=0
         FSCB(i)=0
         Addr(i)=0
         Multi_File(i)=.False.
#ifdef _OLD_IO_STAT_
         MxAddr(i)=0
         Do j = 1, 4
            Count(j,i)=0
         End Do
#else
         Do j=1,8
            PRofData(j,i)=0.d0
         End Do
#endif
         LuName(i)(1:2)='FT'
         Write (LuName(i)(3:4),'(I2.2)') i
         LuName(i)(5:8)='F001'
         LuMark(i)=-1
         Do j = 0, MaxSplitFile-1
            MPUnit(j,i)=0
         End Do
         MBL(i)=0
      End Do
*
#ifndef _OLD_IO_STAT_
      NProfFiles=0
#endif
      MaxFileSize=0
      FirstCall=.true.
      Trace=.false.
      Query=.false.
*
*---- Initiate the COMFILE as closed
*
      AuxCom(pOpen)=NaN
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Xo2v4ctl (NvGrp,NvSGrp,LunAux)
c
c!      drajver procesu na testovanie ktory W3/W4 file
c        treba na ktorom node
c        N.B. upraveny drajver o2v4 procesu
c
        use Para_Info, only: nProcs
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
#include "parcc.fh"
c
        integer NvGrp,NvSGrp,LunAux
c
c        help variables
        integer NaGrp,NbeGrp,NaSGrp,NbeSgrp
        integer mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe
c##
        integer aGrp,bGrp,proc,i,j
        integer nJobs,addJobs,actJobs
c
c
c1      Inicializacia premennych (Predbezna)
c
        NaGrp=NvGrp
        NbeGrp=NvGrp
        NaSGrp=NvSGrp
        nbeSGrp=NvSGrp
c
c
c2      define all groups and ssungroup parameters
c
        call DefParo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c                   mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
c
c3        distribute work among nodes (def ABID)
c
        do proc=0,(nProcs-1)
        do aGrp=1,NaGrp
        do bGrp=1,NaGrp
          ABID(proc,aGrp,bGrp)=0
        end do
        end do
        end do
c
c
        if ((nProcs.eq.1).or.(NaGrp.eq.1)) then
c3.1        nP = <1>
c        all jobs to one node
c
          do aGrp=1,NaGrp
          do bGrp=1,NaGrp
            ABID(0,aGrp,bGrp)=1
          end do
          end do
c
c
        else
c3.2        nP = <2, inf)
c        N.B. cele zatial trochu odflaknute, lebo sa neberie do uvahy,
c        ze pre half joby je lepsie ked nadvazuju na plne joby s
c        rovnakymi indexami
c
c3.2.1        Full Jobs
c
          i=(NaGrp*(NaGrp-1))/2
          nJobs=int(i/nProcs)
          addJobs=mod(i,nProcs)
c
c          first nodes: 0-addJobs
c             will have int(N'(N'-1)/2 /nProc)+1 Full Jobs
c          rest nodes: addJobs-nProcs-1
c               will have int(N'(N'-1)/2 /nProc)
c
          proc=0
          actJobs=nJobs
          do aGrp=2,NaGrp
          do bGrp=1,aGrp-1
            ABID(proc,aGrp,bGrp)=1
            actJobs=actJobs-1
            if (actJobs.eq.-1) then
              proc=proc+1
              actJobs=nJobs
            else if (actJobs.eq.0) then
              if (addJobs.gt.0) then
                addJobs=addJobs-1
              else
                proc=proc+1
                actJobs=nJobs
              end if
            end if
          end do
          end do
c
c
c3.2.2        Half Jobs
c
c        distribution of Half Jobs
c          - first distribution - addjobs-nProcs-1
c          - second distribution - addjobs-nProcs-1
c          - other distributions - 0 - nProcs-1
c
          addJobs=mod(i,nProcs)
          proc=addJobs
          j=0
c
          do aGrp=1,NaGrp
            ABID(proc,aGrp,aGrp)=1
            proc=proc+1
            if (proc.eq.nProcs) then
              if (j.eq.0) then
c              first distribution - addjobs-nProcs-1
                proc=addJobs
                j=1
              else if (j.eq.1) then
c              second distribution - addjobs-nProcs-1
                proc=addJobs
                j=2
              else
c              other distributions - 0 - nProcs-1
                proc=0
              end if
            end if
          end do
c
        end if
c
c
c        Printing ABID
        do proc=0,nProcs-1
        if (printkey.ge.10) then
        write (6,*)   ' For myRank = ',proc
        end if
          do aGrp=1,NaGrp
          do bGrp=1,aGrp
          if (ABID(proc,aGrp,bGrp).eq.1) then
          if (printkey.ge.10) then
          write (6,*) '    aGrp,bGrp ',aGrp,bGrp
          end if
          end if
          end do
          end do
        end do
c
c
c
c4      A ideme na to
c
        call InsReqo2v4 (NaGrp,NbeGrp,NaSGrp,NbeSgrp,
     c             mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe)
c
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_integer(LunAux)
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ASIND(IAS,ISYM,ICASE,IP,IQ,IR)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"

      GOTO (12,13) ICASE

  12  CONTINUE
      IABABS=IAS+NAGEBES(ISYM)
      IAABS=MAGEB(1,IABABS)
      IBABS=MAGEB(2,IABABS)
      GOTO 1213
  13  CONTINUE
      IABABS=IAS+NAGTBES(ISYM)
      IAABS=MAGTB(1,IABABS)
      IBABS=MAGTB(2,IABABS)
 1213 CONTINUE
      IP=IEXTIS(IAABS)
      IQ=IEXTIS(IBABS)
      IR=0
      RETURN

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MoldenDump(iC,CooRef,nP,nA,nC)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "WrkSpc.fh"
#include<constants.fh>
#include "real.fh"

      Parameter (AuAng=1d10*CONST_BOHR_RADIUS_IN_SI_)

      Dimension CooRef(MxCen,3),Coo(MxCen,3)
      Dimension iC(3)

      Logical ValidOrNot

*
*-- Clarifying words.
*
      Write(6,*)
      Write(6,*)
      Write(6,*)'   * Coordinates given in form for Molden *'
      Write(6,*)
      Write(6,*)' Put everything within the lines in a separate file'
     &//' and view with Molden.'
      Write(6,*)' Observe that the identity of molecules that are not'
     &//' valid water molecules is unknown.'
      Write(6,*)
      Write(6,*)'------------------------------------------------------'
     &//'------------------------------'

*
*-- Print total number of particles.
*
      Write(6,*)'  Substitue this line with number of atoms.'
      Write(6,*)
      Do 101, iP=1,nP
        ind=nC*(iP-1)
        Do 102, jC=1,nC
          Coo(jC,1)=Work(iC(1)+ind+jC-1)
          Coo(jC,2)=Work(iC(2)+ind+jC-1)
          Coo(jC,3)=Work(iC(3)+ind+jC-1)
102     Continue
        Call IsItValid(Coo,CooRef,ValidOrNot)
        If(.not.ValidOrNot) then
          Do 103, jC=1,nC
            Write(6,92)'C  ',(AuAng*Coo(jC,kk),kk=1,3)
103       Continue
        Else
          Write(6,92)'O  ',(AuAng*Coo(1,kk),kk=1,3)
          Write(6,92)'H  ',(AuAng*Coo(2,kk),kk=1,3)
          Write(6,92)'H  ',(AuAng*Coo(3,kk),kk=1,3)
        Endif
101   Continue
      Write(6,*)
      Write(6,*)'------------------------------------------------------'
     &//'------------------------------'

*
*-- Formats
*
92    Format(A,3(F10.6))

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nA)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grc33C(a,b,c,mvec,ssa,ssb,pbar,ix)

use ccsd_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
type(Map_Type), intent(in) :: a, b
type(Map_Type), intent(inout) :: c
integer(kind=iwp), intent(out) :: mvec(4096,7)
integer(kind=iwp), intent(in) :: ssa, ssb, pbar
integer(kind=iwp), intent(inout) :: ix
integer(kind=iwp) :: ia, ib, ic, nhelp1, nhelp2, nhelp21, nhelp22, nhelp3, nhelp31, nhelp32, nhelp4, nhelp41, nhelp42, nsyma2, &
                     ntest1, ntest2, posct, sa1, sa12, sa2, sa3, sb1, sb12, sb2, sb3

!1*

if (pbar == 1) then

  ! structure A(p,qr)*B(qr,s)=C(p,s)

  !1.0 prepare c%d,c%i

  call grc0(2,0,a%d(0,1),b%d(0,3),0,0,mmul(ssa,ssb),posct,c)

  !1.1 define limitations - p,q>r must be tested - ntest1

  if (a%d(0,6) == 2) then
    ntest1 = 1
  else
    ntest1 = 0
  end if

  !1.2 def symm states and test the limitations

  ix = 1
  do sa1=1,nsym

    do sa2=1,nsym
      sa12 = mmul(sa1,sa2)
      sb1 = sa2

      sa3 = mmul(ssa,sa12)
      ! Meggie out
      if ((ntest1 == 1) .and. (sa2 < sa3)) cycle
      sb2 = sa3
      sb12 = mmul(sb1,sb2)

      sb3 = mmul(ssb,sb12)

      !1.3 def mvec,c%d and c%i

      ia = a%i(sa1,sa2,1)
      ib = b%i(sb1,sb2,1)
      ic = c%i(sa1,sb3,1)

      ! yes/no
      if ((a%d(ia,2) <= 0) .or. (b%d(ib,2) <= 0)) cycle
      nhelp1 = 1

      ! rowA
      nhelp2 = dimm(a%d(0,1),sa1)

      ! colB
      nhelp3 = dimm(b%d(0,3),sb3)

      ! sum
      nhelp41 = dimm(a%d(0,2),sa2)
      nhelp42 = dimm(a%d(0,3),sa3)
      if ((ntest1 == 1) .and. (sa2 == sa3)) then
        nhelp4 = nhelp41*(nhelp41-1)/2
      else
        nhelp4 = nhelp41*nhelp42
      end if

      mvec(ix,1) = nhelp1
      mvec(ix,2) = a%d(ia,1)
      mvec(ix,3) = b%d(ib,1)
      mvec(ix,4) = c%d(ic,1)
      mvec(ix,5) = nhelp2
      mvec(ix,6) = nhelp4
      mvec(ix,7) = nhelp3

      ix = ix+1

    end do
  end do

else if (pbar == 2) then

  ! structure A(pq,r)*B(r,st)=C(pq,st)

  !2.1 define limitations - A p>q,r must be tested - ntest1
  !                       - B p,q>r must be tested - ntest2

  if (a%d(0,6) == 1) then
    ntest1 = 1
  else
    ntest1 = 0
  end if

  if (b%d(0,6) == 2) then
    ntest2 = 1
  else
    ntest2 = 0
  end if

  !2.0 prepare c%d,c%i

  if ((ntest1 == 1) .and. (ntest2 == 1)) then
    nhelp1 = 4
  else if (ntest1 == 1) then
    nhelp1 = 1
  else if (ntest2 == 1) then
    nhelp1 = 3
  else
    nhelp1 = 0
  end if

  call grc0(4,nhelp1,a%d(0,1),a%d(0,2),b%d(0,2),b%d(0,3),mmul(ssa,ssb),posct,c)

  !2.2 def symm states and test the limitations

  ix = 1
  do sa1=1,nsym
    if (ntest1 == 1) then
      nsyma2 = sa1
    else
      nsyma2 = nsym
    end if

    do sa2=1,nsyma2
      sa12 = mmul(sa1,sa2)

      sa3 = mmul(ssa,sa12)
      sb1 = sa3

      do sb2=1,nsym
        sb12 = mmul(sb1,sb2)

        sb3 = mmul(ssb,sb12)
        ! Meggie out
        if ((ntest2 == 1) .and. (sb2 < sb3)) cycle

        !2.3 def mvec,c%d and c%i

        ia = a%i(sa1,sa2,sa3)
        ib = b%i(sb1,sb2,sb3)
        ic = c%i(sa1,sa2,sb2)

        ! yes/no
        if ((a%d(ia,2) <= 0) .or. (b%d(ib,2) <= 0)) cycle
        nhelp1 = 1

        ! rowA
        nhelp21 = dimm(a%d(0,1),sa1)
        nhelp22 = dimm(a%d(0,2),sa2)
        if ((ntest1 == 1) .and. (sa1 == sa2)) then
          nhelp2 = nhelp21*(nhelp21-1)/2
        else
          nhelp2 = nhelp21*nhelp22
        end if

        ! colB
        nhelp31 = dimm(b%d(0,2),sb2)
        nhelp32 = dimm(b%d(0,3),sb3)
        if ((ntest2 == 1) .and. (sb2 == sb3)) then
          nhelp3 = nhelp31*(nhelp31-1)/2
        else
          nhelp3 = nhelp31*nhelp32
        end if

        ! sum
        nhelp4 = dimm(a%d(0,3),sa3)

        mvec(ix,1) = nhelp1
        mvec(ix,2) = a%d(ia,1)
        mvec(ix,3) = b%d(ib,1)
        mvec(ix,4) = c%d(ic,1)
        mvec(ix,5) = nhelp2
        mvec(ix,6) = nhelp4
        mvec(ix,7) = nhelp3

        ix = ix+1

      end do
    end do
  end do

end if
ix = ix-1

return

end subroutine grc33C

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NEMO_Opt1()
      use Basis_Info
      use Symmetry_Info, only: nIrrep
      Implicit real*8(a-h,o-z)
#include "Molcas.fh"
#include "warnings.fh"
#include "rinfo.fh"
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
      Integer nBas_Prim(0:7), nBas_cont(0:7), lOper(3)
      Parameter(MxMltPl=10)
      Integer ipMP((MxMltPl+1)*(MxMltPl+2)*(MxMltPl+3)/6),
     &        iSm((MxMltPl+1)*(MxMltPl+2)*(MxMltPl+3)/6)
      Integer ip(3), iSml(3)
      Character*8 Label
      Real*8, Dimension(:), Allocatable :: P_Matrix, MP_Matrix
      Dimension Length(1),nInt(1)
*
      iRout=77
      iPrint=nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*     Save basis set info from contracted run
*
      if(iprint.ge.10) write(6,*) ' In NEMO_Opt1', ncnttp
      kCof=0
      kAng=0
      kExp=0
      kC=0
*
*     Normalize coefficients
*
      do iCnttp=1,nCnttp
*
*-- Make a check that no cartesian d or higher have been used.
*   The reason for this restriction is found in tr_prm_cnt.
*   If that routine is generalized, then remove this check.
*
        lSh=0
        kShStr = dbsc(iCnttp)%iVal
        kShEnd = dbsc(iCnttp)%iVal+dbsc(iCnttp)%nVal-1
        Do kSh = kShStr, kShEnd
          If(.not.Shells(kSh)%Transf.and.lSh.ge.2) then
            Call WarningMessage(2,'   NEMO Error')
            Write(6,*)
            Write(6,*)
            Write(6,*)'Error! The NEMO keyword does not work with'
     &//' cartesian d-functions or higher.'
            Write(6,*)'Request spherical functions to proceed.'
            Write(6,*)
            Write(6,*)
            Call Quit(_RC_INPUT_ERROR_)
          Endif
          lSh=lSh+1
        Enddo
*
*-- End check.
*
        Do icnt = 1, dbsc(iCnttp)%nCntr
        kC=kC+1
c           Do iAngr=0,nAngr(icnt)
           Do iAngr=0,nAngr(kC)
c              rI=iAngr+1.0d0+half
               rI=DBLE(iAngr)+One+Half
              kAng=kAng+1
              Do iBas=1,nBasisr(kAng)
                 Sum=Zero
                 kExpi=kExp
                 kCofi=kCof
                 Do iExp=1,nPrimr(kAng)
                    kExpi=kExpi+1
                    kCofi=kCofi+1
                    rExpi=rExp(kExpi)
c                    write(6,'(a11,f20.8)') ' Exponents',rExpi
                    rCofi=rCof(kCofi)
                    kExpj=kExp
                    kCofj=kCof
                    Do jExp=1,nPrimr(kAng)
                       kExpj=kExpj+1
                       kCofj=kCofj+1
                       rExpj=rExp(kExpj)
                       rCofj=rCof(kCofj)
                       Sum=Sum+rCofi*rCofj*
     &                 (Two*sqrt(rExpi*rExpj)/(rExpi+rExpj))**rI
                    End Do
                 End Do
                 rNorm=One/sqrt(Sum)
                 if(iprint.ge.10) write(6,*) ' rNorm', kAng,rNorm
                   Do iExp=1,nPrimr(kAng)
                      rCof(kCof+iExp)=rCof(kCof+iExp)*rNorm
                     if(iprint.ge.10) then
                         write(6,'(a24,f20.6)')
     &                   ' normalized coefficients',
     &                   rCof(kCof+iExp)
                     endif
                   End Do
                 kCof=kCof+nPrimr(kAng)
              End Do
              kExp=kExp+nPrimr(kAng)
           End Do
        End Do
      End Do
*
      If (iPrint.ge.10) Then
      i=0
      Do L=1,nrSym
         write(6,*) ' Irreducible representation', L
         Do ibas=1,nrBas(L)
            i=i+1
            Write (6,'(20i4)') i, icent(i),lnang(i),lmag(i)
         End Do
      End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Close ONEINT and re-open ONEREL
*
      Call iCopy(8,nBas,1,nBas_Cont,1)
*
      nSym=nIrrep
      iOpt=0
      Call ClsOne(iRC,iOpt)
      iOpt = 0
      iRC = -1
      Lu_One=2
      Call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
      If (iRC.ne.0) Go To 9999
*
      Call OneBas('PRIM')
      Call Get_iArray('nBas_Prim',nBas_Prim,nIrrep)
*
      If(iPrint.ge.10) then
         write(6,'(a,8i5)') ' Symmetries          ', nSym
         write(6,'(a,8i5)') ' Primitive basis fcns',
     &                          (nBas_Prim(i),i=0,nSym-1)
      Endif
*                                                                      *
************************************************************************
*                                                                      *
*     Read P_Matrix from ONEREL
*
      nComp=3
      nLength_Tot=0
      Do iComp = 1, nComp
         iOpt=1
         iRC=-1
         Call iRdOne(iRC,iOpt,'P_matrix',iComp,Length,iSmLbl)
         If (iRC.ne.0) Then
            Call WarningMessage(2,'Error reading length of P-Matrix')
            Write (6,*) 'iComp=',iComp
            Call Abend()
         End If
         iSml(iComp)=iSmLbl
         lOper(iComp)=1
         ip(iComp)=1 + nLength_Tot
         nLength_Tot = nLength_Tot + Length(1) + 4
      End Do
*
      Call mma_allocate(P_Matrix,nLength_Tot,label='P_Matrix')
      Call FZero(P_Matrix,nLength_Tot)
*
      Do iComp = 1, nComp
         iOpt=0
         iRC=-1
         iSmLbl=iSml(iComp)
         ip(iComp) = ip(iComp)
         Call RdOne(iRC,iOpt,'P_matrix',iComp,P_Matrix(ip(iComp)),
     &              iSmLbl)
         If (iRC.ne.0) Then
            Call WarningMessage(2,'Error reading P-Matrix')
            Write (6,*) 'iComp=',iComp
            Call Abend()
         End If
      End Do
      If (iPrint.ge.10) Call PrMtrx('P_matrix',lOper,nComp,ip,P_Matrix)
*                                                                      *
************************************************************************
*                                                                      *
*     Read multipole integrals from ONEREL
*
      nip = 0
      nInt_Tot = 0
      Do iMltPl = 0, MxMltPl
         Write (Label,'(a,i2)') 'MLTPL ',iMltPl
         nComp = (iMltPl+1)*(iMltPl+2)/2
         Do iComp = 1, nComp
            iRC = -1
            iOpt = 1
            nInt=0
            Call iRdOne(iRC,iOpt,Label,iComp,nInt,iSmLbl)
            If (iRC.ne.0) Then
               If (iComp.ne.1) Then
                  Call WarningMessage(2,' Error reading length!')
                  Write (6,*) ' Label=', Label,' Comp=',iComp
                  Call Abend()
               Else
                  Go To 100
               End If
            End If
            nip = nip + 1
            iSm(nip)=iSmLbl
            ipMP(nip)= 1 + nInt_Tot
            nInt_Tot = nInt_Tot + nInt(1)+4
         End Do
      End Do
 100  Continue
*
      Call mma_allocate(MP_Matrix,nInt_Tot,label='MP_Matrix')
*
      iip=0
      Do iMltPl = 0, MxMltPl
         Write (Label,'(a,i2)') 'MLTPL ',iMltPl
         nComp = (iMltPl+1)*(iMltPl+2)/2
         Do iComp = 1, nComp
            iip = iip + 1
            if (iip.gt.nip) Go To 200
            iRC=-1
            iOpt=0
            ipMP(iip) = ipMP(iip)
            iSmLbl=iSm(iip)
            Call RdOne(iRC,iOpt,Label,iComp,MP_Matrix(ipMP(iip)),iSmLbl)
            If (iRC.ne.0) Then
               Call WarningMessage(2,' Error reading integrals!')
               Write (6,*) ' Label=', Label,' Comp=',iComp
               Call Abend()
            End If
         End Do
      End Do
 200  Continue
*                                                                      *
************************************************************************
*                                                                      *
*     Close ONEREL and re-open ONEINT
*
      iOpt = 0
      iRC = -1
      Call ClsOne(iRC,iOpt)
      If (iRC.ne.0) Go To 9999
      iOpt = 0
      iRC = -1
      Lu_One=2
      Call OpnOne(iRC,iOpt,'ONEINT',Lu_One)
      If (iRC.ne.0) Go To 9999
*
      Call OneBas('PRIM')
*                                                                      *
************************************************************************
*                                                                      *
*     Put the transformation matrix on RUNFILE
*
      idbg=0
      Call tr_prm_cnt(idbg,nBas_Cont,nBas_Prim)
*                                                                      *
************************************************************************
*                                                                      *
*     Process the P-matrix
*
      nComp=3
      iOpt=0
      Do iComp = 1, nComp
         iRC=-1
         Call WrOne(iRC,iOpt,'P_matrix',iComp,P_Matrix(ip(iComp)),
     &              iSml(iComp))
         If (iRC.ne.0) Then
            Call WarningMessage(2,'Error reading P-Matrix')
            Write (6,*) 'iComp=',iComp
            Call Abend()
         End If
      End Do
      Call mma_deallocate(P_Matrix)
*                                                                      *
************************************************************************
*                                                                      *
*     Process multipole integrals
*
      iip = 0
      Do iMltPl = 0, MxMltPl
         Write (Label,'(a,i2)') 'PLTPL ',iMltpl
         nComp = (iMltpl+1)*(iMltpl+2)/2
         Do iComp = 1, nComp
            iip = iip + 1
            If (iip.gt.nip) Go To 300
            iRC = -1
            iOpt = 0
            Call WrOne(iRC,iOpt,Label,iComp,MP_Matrix(ipMP(iip)),
     &                 iSm(iip))
            If (iRC.ne.0) Then
               Call WarningMessage(2,' Error writing integrals!')
               Write (6,*) ' Label=', Label,' Comp=',iComp
               Call Abend()
            End If
         End Do
      End Do
 300  Continue
      Call mma_deallocate(MP_Matrix)
*                                                                      *
************************************************************************
*                                                                      *
*     And now change it back!
*
      Call OneBas('CONT')
*                                                                      *
************************************************************************
*                                                                      *
      Return
*
 9999 Continue
      Call WarningMessage(2,
     &            ' *** Error in subroutine NEMO_Opt1 ***;'
     &          //'     Abend in subroutine OpnOne or ClsOne')
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA_Freezer()

! Thomas Bondo Pedersen (CTCC,UiO), July 2013.
!
! Figure out symmetry distribution of frozen occupied orbitals.

use RPA_globals, only: iPrint, nFreeze, nFro, nOcc, nSym, OccEn
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iUHF, iSym, iSpin, l_Fro
logical(kind=iwp) :: Freeze, Prnt
integer(kind=iwp), allocatable :: Fro(:)
integer(kind=iwp), external :: RPA_iUHF

! set restricted(1)/unrestricted(2)
iUHF = RPA_iUHF()

! freeze orbitals (if requested)
iSpin = 1
Freeze = nFreeze(iSpin) > 0
do while ((.not. Freeze) .and. (iSpin < iUHF))
  iSpin = iSpin+1
  Freeze = Freeze .or. (nFreeze(iSpin) > 0)
end do
if (Freeze) then
  Prnt = iPrint >= 0
  l_Fro = nSym
  call mma_allocate(Fro,l_Fro,label='OccFrz')
  do iSpin=1,iUHF
    if (nFreeze(iSpin) > 0) then
      call RPA_Frz(nFreeze(iSpin),Prnt,nSym,OccEn(:,iSpin),nFro(1,iSpin),nOcc(1,iSpin),Fro)
      do iSym=1,nSym
        nFro(iSym,iSpin) = nFro(iSym,iSpin)+Fro(iSym)
      end do
    end if
  end do
  call mma_deallocate(Fro)
end if

! correct number of active occupied orbitals
do iSpin=1,iUHF
  do iSym=1,nSym
    nOcc(iSym,iSpin) = nOcc(iSym,iSpin)-nFro(iSym,iSpin)
  end do
end do

end subroutine RPA_Freezer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine distnodes
c
c        this routine distribute nodes to different parts
c
        use Para_Info, only: nProcs
        implicit none
#include "parallel.fh"
c
        integer i
        REAL*8 efftot
c
ctmp ta zatial takto
        if (nProcs.eq.1) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=0
        idbbaa=0
        idbbbb=0
        idaabb=0
        idabba=0
c
cIII        def node for finale
        idfin=0
c
c
        else if (nProcs.eq.2) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=1
        idbbaa=1
        idbbbb=1
        idaabb=1
        idabba=1
c
cIII        def node for finale
        idfin=1
c
c
        else if (nProcs.eq.3) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=1
        idbbaa=1
        idbbbb=2
        idaabb=2
        idabba=2
c
cIII        def node for finale
        idfin=1
c
c
        else if (nProcs.eq.4) then
c
cI        def nodes for sumoverab
        nprocab=4
        idab(1)=0
        idab(2)=1
        idab(3)=2
        idab(4)=3
        ideffab(1)=0.25
        ideffab(2)=0.25
        ideffab(3)=0.25
        ideffab(4)=0.25
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=1
        idbbaa=1
        idbbbb=2
        idaabb=2
        idabba=3
c
cIII        def node for finale
        idfin=3
c
c
        else if (nProcs.eq.5) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=1
        idbbaa=2
        idbbbb=3
        idaabb=3
        idabba=4
c
cIII        def node for finale
        idfin=2
c
c
        else if (nProcs.eq.6) then
c
cI        def nodes for sumoverab
        nprocab=6
        idab(1)=0
        idab(2)=1
        idab(3)=2
        idab(4)=3
        idab(5)=4
        idab(6)=5
        ideffab(1)=1.0
        ideffab(2)=1.0
        ideffab(3)=1.0
        ideffab(4)=1.0
        ideffab(5)=1.0
        ideffab(6)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=1
        idbbaa=2
        idbbbb=3
        idaabb=4
        idabba=5
c
cIII        def node for finale
        idfin=3
c
        else if (nProcs.eq.10) then
c
cI        def nodes for sumoverab
        nprocab=4
          idab(1)=0
          idab(2)=1
          idab(3)=2
          idab(4)=3
          ideffab(1)=1.0
          ideffab(2)=1.0
          ideffab(3)=1.0
          ideffab(4)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=4
        idbaab=5
        idbbaa=6
        idbbbb=7
        idaabb=8
        idabba=9
c
cIII        def node for finale
        idfin=5
c
        else
c
cI        def nodes for sumoverab
        nprocab=nProcs
        do i=1,nprocab
          idab(i)=i-1
          ideffab(i)=1.0
        end do
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=1
        idbbaa=2
        idbbbb=3
        idaabb=4
        idabba=5
c
cIII        def node for finale
        idfin=6

        end if
c
         return
c
ctmp         koniec tmp riesenia
c
c
c
        if (nProcs.eq.1) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=0
        idbbaa=0
        idbbbb=0
        idaabb=0
        idabba=0
c
cIII        def node for finale
        idfin=0
c
c
        else if (nProcs.eq.2) then
c
cI        def nodes for sumoverab
        nprocab=2
        idab(1)=0
        idab(2)=1
        ideffab(1)=0.5
        ideffab(2)=0.5
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=0
        idbbaa=0
        idbbbb=1
        idaabb=1
        idabba=1
c
cIII        def node for finale
        idfin=0
c
c
        else if (nProcs.eq.3) then
c
cI        def nodes for sumoverab
        nprocab=3
        idab(1)=0
        idab(2)=1
        idab(3)=2
        ideffab(1)=0.333
        ideffab(2)=0.333
        ideffab(3)=0.333
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=1
        idbbaa=1
        idbbbb=2
        idaabb=2
        idabba=2
c
cIII        def node for finale
        idfin=0
c
c
        else if (nProcs.eq.4) then
c
cI        def nodes for sumoverab
        nprocab=2
        idab(1)=2
        idab(2)=3
        ideffab(1)=1.0
        ideffab(2)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=0
        idbbaa=0
        idbbbb=1
        idaabb=1
        idabba=1
c
cIII        def node for finale
        idfin=0
c
c
        else
c
cI        def nodes for sumoverab
c
        nprocab=nProcs-2
        idab(1)=1
        idab(2)=2
        idab(3)=4
        idab(4)=5
        idab(5)=6
        idab(6)=7
        do i=1,nprocab
        ideffab(i)=1.0d0/nprocab
        end do
        ideffab(1)=ideffab(1)/2
        ideffab(2)=ideffab(2)/2
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=0
        idbbaa=0
        idbbbb=2
        idaabb=3
        idabba=3
c
cIII        def node for finale
        idfin=1
c
        end if
c
c        renormalize ideffab
c
        efftot=0.0d0
        do i=1,nprocab
        efftot=efftot+ideffab(i)
        end do
c
        do i=1,nprocab
        ideffab(i)=ideffab(i)/efftot
        end do

c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Giovanni Li Manni                                *
!               2019, Oskar Weser                                      *
!***********************************************************************
module fcidump_dump
  use fcidump_tables
  implicit none
  private
  public :: dump_ascii, dump_hdf5
contains

!>  @brief
!>    Create FCIDUMP file
!>
!>  @author Oskar Weser
!>
!>  @details
!>  Create an ASCII formatted FCIDUMP with core energy,
!>  orbital energies, Fock matrix elements and two electron integrals.
!>  Contains information about \p nAsh, \p nSym, \p nActEl,
!>  \p iSpin, and \p lSym.
!>
!>  @param[in] EMY Core energy
!>  @param[in] orbital_table Orbital energies with index
!>  @param[in] fock_table
!>  @param[in] two_el_table
  subroutine dump_ascii(path, EMY, orbital_table, fock_table, &
                        two_el_table, orbsym)
    use general_data, only : nSym, nActEl, iSpin, lSym, nAsh
    implicit none
    character(len=*), intent(in) :: path
    real*8, intent(in) :: EMY
    type(OrbitalTable), intent(in) :: orbital_table
    type(FockTable), intent(in) :: fock_table
    type(TwoElIntTable), intent(in) :: two_el_table
    integer, intent(in) :: orbsym(:)
    integer :: i, j, ireturn, isFreeUnit, LuFCI

    LuFCI = isFreeUnit(38)
    call molcas_open(LuFCI, path)

    write(LuFCI,'(1X,A11,I3,A7,I3,A5,I3,A)') ' &FCI NORB=',sum(nAsh), &
       ',NELEC=',nActEl,',MS2=',int((ISPIN-1.0d0)),','
    write(LuFCI,'(A,500(I2,","))')'  ORBSYM=',(orbsym(i),i=1,size(orbsym))
    write(LuFCI,'(2X,A5,I1)') 'ISYM=', LSYM -1
    write(LuFCI,'(A)') ' &END'

    do j = 1, length(two_el_table)
      write(LuFCI, '(1X,G20.11,4I5)') &
        two_el_table%values(j), (two_el_table%index(i, j), i = 1, 4)
    end do

    do j = 1, length(fock_table)
      write(LuFCI, '(1X,G20.11,4I5)') &
        fock_table%values(j), (fock_table%index(i, j), i = 1, 2), 0, 0
    end do

    do j = 1, length(orbital_table)
      write(LuFCI, '(1X,G20.11,4I5)') &
        orbital_table%values(j), orbital_table%index(j), 0, 0, 0
    end do

    write(LuFCI,'(1X,G20.11,4I5)') EMY, 0, 0, 0, 0

    close(LuFCI)

! ========== For testing purposes FROM HERE =============
    if (length(orbital_table) /= 0 .and. length(fock_table) /=0 &
        .and. length(two_el_table) /= 0) then
      call Add_Info('core energy', [EMY], 1, 8)
      call Add_Info('Orbital Energy', orbital_table%values(1), 1, 8)
      call Add_Info('Fock element', fock_table%values(1), 1, 8)
      call Add_Info('TwoEl Integral element', two_el_table%values(1), 1, 8)
    end if
! ========== For testing purposes TO HERE ===============

    call FastIO('STATUS')
    ireturn = 0

    return
  end subroutine dump_ascii

!>  @brief
!>    Create H5FCIDUMP file
!>
!>  @author Oskar Weser
!>
!>  @details
!>  Create an FCIDUMP in HDF5-file format with core energy,
!>  orbital energies, Fock matrix elements and two electron integrals.
!>  Contains information about \p nAsh, \p nSym, \p nActEl,
!>  \p iSpin, and \p lSym.
!>
!>  @param[in] EMY Core energy
!>  @param[in] orbital_table Orbital energies with index
!>  @param[in] fock_table
!>  @param[in] two_el_table
  subroutine dump_hdf5(path, EMY, orbital_table, fock_table, two_el_table, orbsym)
    use general_data, only : nSym, nActEl, multiplicity => iSpin, lSym, nAsh
    use gas_data, only : iDoGAS
    use gugx_data, only : IfCAS
#ifdef _HDF5_
    use mh5
#endif
    implicit none
    character(len=*), intent(in) :: path
    real*8, intent(in) :: EMY
    type(OrbitalTable), intent(in) :: orbital_table
    type(FockTable), intent(in) :: fock_table
    type(TwoElIntTable), intent(in) :: two_el_table
    integer, intent(in) :: orbsym(:)
#ifdef _HDF5_
    integer :: file_id, dset_id
    integer :: ireturn
    character :: lIrrep(24)

    file_id = mh5_create_file(path)

!   symmetry information
    call Get_cArray('Irreps', lIrrep, 24)
    call mh5_init_attr(file_id, 'IRREP_LABELS', 1, [nSym], lIrrep, 3)
    call mh5_init_attr(file_id, 'ORBSYM', 1, [size(orbsym)], orbsym)
    call mh5_init_attr(file_id, 'NORB', sum(nAsh(:nSym)))

    ! Set wavefunction type
    if (iDoGAS) then
      call mh5_init_attr(file_id, 'CI_TYPE', 'GAS')
    else if (IfCAS .eq. 0) then
      call mh5_init_attr(file_id, 'CI_TYPE', 'CAS')
    else
      call mh5_init_attr(file_id, 'CI_TYPE', 'RAS')
    end if

    call mh5_init_attr(file_id, 'MOLCAS_MODULE', 'RASSCF')
    call mh5_init_attr(file_id, 'CORE_ENERGY', EMY)
    call mh5_init_attr(file_id, 'NELEC', nActEl)
    call mh5_init_attr(file_id, 'MULTIPLICITY', multiplicity)
    call mh5_init_attr(file_id, 'ISYM', lSym - 1)

    dset_id = mh5_create_dset_int(file_id, 'ORBITAL_INDEX', &
      1, [length(orbital_table)])
    call mh5_init_attr(dset_id, 'DESCRIPTION', &
      'Index for the orbitals in active space.')
    call mh5_put_dset_array_int(dset_id, orbital_table%index)
    call mh5_close_dset(dset_id)

    dset_id = mh5_create_dset_real(file_id, 'ORBITAL_ENERGIES', &
      1, [length(orbital_table)])
    call mh5_init_attr(dset_id, 'DESCRIPTION', &
      'Energies of orbitals in active space.')
    call mh5_put_dset_array_real(dset_id, orbital_table%values)
    call mh5_close_dset(dset_id)

    dset_id = mh5_create_dset_int(file_id, 'FOCK_INDEX', &
      2, [2, length(fock_table)])
    call mh5_init_attr(dset_id, 'DESCRIPTION', &
      'The index i, j for the Fock matrix elements <i| F |j>.')
    call mh5_put_dset_array_int(dset_id, fock_table%index)
    call mh5_close_dset(dset_id)

    dset_id = mh5_create_dset_real(file_id, 'FOCK_VALUES', &
      1, [length(fock_table)])
    call mh5_init_attr(dset_id, 'DESCRIPTION', &
      'The Fock matrix elements <i| F |j>.')
    call mh5_init_attr(dset_id, 'CUTOFF', fock_table%cutoff)
    call mh5_put_dset_array_real(dset_id, fock_table%values)
    call mh5_close_dset(dset_id)

    dset_id = mh5_create_dset_int(file_id, 'TWO_EL_INT_INDEX', &
      2, [4, length(two_el_table)])
    call mh5_init_attr(dset_id, 'DESCRIPTION', &
      'The index i, j, k, l for the two electron integrals <i j | 1/r_{12} | k l >.')
    call mh5_put_dset_array_int(dset_id, two_el_table%index)
    call mh5_close_dset(dset_id)

    dset_id = mh5_create_dset_real(file_id, 'TWO_EL_INT_VALUES', &
      1, [length(two_el_table)])
    call mh5_init_attr(dset_id, 'DESCRIPTION', &
      'The two electron integrals <i j | 1/r_{12} | k l >.')
    call mh5_init_attr(dset_id, 'CUTOFF', two_el_table%cutoff)
    call mh5_put_dset_array_real(dset_id, two_el_table%values)
    call mh5_close_dset(dset_id)

    call mh5_close_file(file_id)

    call FastIO('STATUS')
    ireturn = 0
#else
! Avoid unused argument warnings
#ifdef _WARNING_WORKAROUND_
    if (.false.) then
      call unused_real(EMY)
      call unused_character(path)
      call unused(orbital_table)
      call unused(fock_table)
      call unused(two_el_table)
      call unused_integer_array(orbsym)
    end if
#endif
#endif
  end subroutine dump_hdf5
end module fcidump_dump

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine CHO_SUBTR0(XINT,WRK,LWRK,ISYM)
!
! Purpose: subtract contributions from previous vectors
!          from the qualified integrals (in XINT).
!          This version is memory-driven.
!
! Screening in subtraction introduced Jan. 2006, TBP.

use Cholesky, only: Cho_SScreen, DSPNm, DSubScr, iiBstR, iiBstRSh, iQuAB, LQ, LuPri, nDGM_call, nnBstR, nnBstRSh, nnShl, nQual, &
                    NumCho, nVec_in_Buf, SSNorm, SSTau, SubScrStat, TDECOM
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LWRK, ISYM
real(kind=wp), intent(inout) :: XINT(*), WRK(LWRK)
integer(kind=iwp) :: IAB, IBATCH, ISHGD, IVEC1, J, JAB, KCHO1, KCHO2, KEND2, KOFB0, KOFF1, KOFF2, KOFF3, KOFFA, KOFFB, LREAD, &
                     LWRK1, LWRK2, MMEM, NBATCH, NGD, NUMV, NVEC, NVEC_TO_READ
real(kind=wp) :: C1, C2, TST, W1, W2, XDON, XTOT
character(len=*), parameter :: SECNAM = 'CHO_SUBTR0'
integer(kind=iwp), external :: CHO_LREAD

! Return if nothing to do.
! ------------------------

if (NUMCHO(ISYM) < 1) return

NVEC_TO_READ = NUMCHO(ISYM)-NVEC_IN_BUF(ISYM)
if (NVEC_TO_READ == 0) return
if (NVEC_TO_READ < 0) call CHO_QUIT('Vector buffer error in '//SECNAM,104)

! Initialize.
! -----------

XTOT = Zero
XDON = Zero

! Reserve space needed for reading previous vectors.
! --------------------------------------------------

LREAD = CHO_LREAD(ISYM,LWRK)
if (LREAD < 1) then
  write(LUPRI,*) SECNAM,': CHO_LREAD returned ',LREAD
  call CHO_QUIT('Memory error in '//SECNAM,101)
  LWRK1 = 0 ! to avoid compiler warnings
else
  LWRK1 = LWRK-LREAD
end if

! Set up batch.
! -------------

MMEM = NNBSTR(ISYM,2)+NQUAL(ISYM)
NVEC = min(LWRK1/MMEM,NVEC_TO_READ)
if (NVEC < 1) call CHO_QUIT('Batch failure in '//SECNAM,101)
NBATCH = (NVEC_TO_READ-1)/NVEC+1

! Start batch loop.
! -----------------

do IBATCH=1,NBATCH

  if (IBATCH == NBATCH) then
    NUMV = NVEC_TO_READ-NVEC*(NBATCH-1)
  else
    NUMV = NVEC
  end if
  IVEC1 = NVEC_IN_BUF(ISYM)+NVEC*(IBATCH-1)+1

  ! Complete allocation.
  ! --------------------

  KCHO1 = 1
  KCHO2 = KCHO1+NNBSTR(ISYM,2)*NUMV
  KEND2 = KCHO2+NQUAL(ISYM)*NUMV
  LWRK2 = LWRK-KEND2+1
  if (LWRK2 < LREAD) call CHO_QUIT('Batch error in '//SECNAM,104)

  ! Read previous vectors.
  ! ----------------------

  call CWTIME(C1,W1)
  call CHO_GETVEC(WRK(KCHO1),NNBSTR(ISYM,2),NUMV,IVEC1,ISYM,WRK(KEND2),LWRK2)
  call CWTIME(C2,W2)
  TDECOM(1,2) = TDECOM(1,2)+C2-C1
  TDECOM(2,2) = TDECOM(2,2)+W2-W1

  ! Screened or unscreened subtraction section.
  ! The screened version uses level 2 blas, while the unscreened
  ! one employs level 3 blas.
  ! ------------------------------------------------------------

  call CWTIME(C1,W1)

  if (CHO_SSCREEN) then ! screened subtraction

    KOFB0 = KCHO1-1-IIBSTR(ISYM,2)
    do J=1,NUMV
      KOFFA = KCHO2+J-1
      KOFFB = KOFB0+NNBSTR(ISYM,2)*(J-1)
      do IAB=1,NQUAL(ISYM)
        WRK(KOFFA+NUMV*(IAB-1)) = WRK(KOFFB+IQUAB(IAB,ISYM))
      end do
    end do

    ! Subtract:
    ! (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L(#J,{ab})
    ! for each ab in {ab}.
    ! ----------------------------------------------------

    call CHO_SUBSCR_DIA(WRK(KCHO1),NUMV,iSym,2,SSNorm)
    do IAB=1,NQUAL(ISYM)
      do ISHGD=1,NNSHL
        NGD = NNBSTRSH(ISYM,ISHGD,2)
        if (NGD > 0) then
          XTOT = XTOT+One
          JAB = IQUAB(IAB,ISYM)-IIBSTR(ISYM,2)
          TST = sqrt(DSPNM(ISHGD)*DSUBSCR(JAB))
          if (TST > SSTAU) then
            XDON = XDON+One
            KOFF1 = KCHO1+IIBSTRSH(ISYM,ISHGD,2)
            KOFF2 = KCHO2+NUMV*(IAB-1)
            KOFF3 = NNBSTR(ISYM,2)*(IAB-1)+IIBSTRSH(ISYM,ISHGD,2)+1
            call DGEMV_('N',NGD,NUMV,-One,WRK(KOFF1),NNBSTR(ISYM,2),WRK(KOFF2),1,One,XINT(KOFF3),1)
          end if
        end if
      end do
    end do

  else ! unscreened subtraction

    if (associated(LQ(ISYM)%A)) then

      ! If the qualified block, L({ab},#J), is already in core,
      ! use this block.
      ! -------------------------------------------------------

      call DGEMM_('N','T',NNBSTR(ISYM,2),NQUAL(ISYM),NUMV,-One,WRK(KCHO1),NNBSTR(ISYM,2),LQ(ISYM)%A(:,IVEC1),size(LQ(ISYM)%A,1), &
                  One,XINT,NNBSTR(ISYM,2))

    else

      ! Copy out sub-blocks corresponding to qualified diagonals:
      ! L({ab},#J)
      ! ---------------------------------------------------------

      do J=1,NUMV
        do IAB=1,NQUAL(ISYM)
          KOFF1 = KCHO2+NQUAL(ISYM)*(J-1)+IAB-1
          KOFF2 = KCHO1+NNBSTR(ISYM,2)*(J-1)+IQUAB(IAB,ISYM)-IIBSTR(ISYM,2)-1
          WRK(KOFF1) = WRK(KOFF2)
        end do
      end do

      ! Subtract:
      ! (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L({ab},#J)
      ! ----------------------------------------------------

      call DGEMM_('N','T',NNBSTR(ISYM,2),NQUAL(ISYM),NUMV,-One,WRK(KCHO1),NNBSTR(ISYM,2),WRK(KCHO2),NQUAL(ISYM),One,XINT, &
                  NNBSTR(ISYM,2))

    end if

    ! Update DGEMM-call counter.
    ! --------------------------

    NDGM_CALL = NDGM_CALL+1

  end if

  call CWTIME(C2,W2)
  TDECOM(1,3) = TDECOM(1,3)+C2-C1
  TDECOM(2,3) = TDECOM(2,3)+W2-W1

end do

! Update screening statistics.
! ----------------------------

if (CHO_SSCREEN) then
  SUBSCRSTAT(1) = SUBSCRSTAT(1)+XTOT
  SUBSCRSTAT(2) = SUBSCRSTAT(2)+XDON
end if

end subroutine CHO_SUBTR0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE COPVEC(FROM,TO,NDIM)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
c     COMMON/COPVECST/XNCALL_COPVEC, XNMOVE_COPVEC
      DIMENSION FROM(*),TO(*)
C
c     XNCALL_COPVEC = XNCALL_COPVEC + 1.0D0
c     XNMOVE_COPVEC = XNMOVE_COPVEC + DBLE(NDIM)
      DO 100 I=1,NDIM
       TO(I)=FROM(I)
  100 CONTINUE
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!               2021, Roland Lindh                                     *
!***********************************************************************

subroutine CHO_GetShFull(LabJ,lLabJ,JNUM,JSYM,IREDC,ChoV,SvShp,mmShl,iShp_rs,mmShl_tot)

use ChoArr, only: iBasSh, iRS2F, iShlSO, iSOShl, nDimRS
use ChoSwp, only: IndRed, IndRSh
use Symmetry_Info, only: Mul
use Data_Structures, only: L_Full_Type
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: lLabJ, JNUM, JSYM, IREDC, mmShl, mmShl_tot, iShp_rs(mmShl_tot)
real(kind=wp), intent(in) :: LabJ(lLabJ)
type(L_Full_Type), intent(_OUT_) :: ChoV
real(kind=wp), intent(out) :: SvShp(mmShl,2)
#include "cholesky.fh"
integer(kind=iwp) :: i1, iag, ias, iaSg, iaSh, ibg, ibs, ibSg, ibSh, iLoc, iRab, iShp, iSyma, iSymb, jRab, jShp, JVEC, kLabJ, &
                     kRab, NREAD
integer(kind=iwp), external :: cho_isao

!*********************************************************
!
! From Reduced sets to full storage
! ---------------------------------
!
!  L{a,b,J} ---> L(a,J,b)
!
!*********************************************************

iLoc = 3 ! use scratch location in reduced index arrays

ChoV%A0(:) = Zero
SvShp(:,:) = Zero

if (JSYM == 1) then

  NREAD = 0

  do JVEC=1,JNUM

    kLabJ = NREAD
    NREAD = NREAD+nDimRS(jSym,IREDC)

    do jRab=1,nnBstR(jSym,iLoc)

      kRab = iiBstr(jSym,iLoc)+jRab
      iRab = IndRed(kRab,iLoc) ! addr in 1st red set

      iShp = IndRSh(iRab) ! shell pair to which it belongs

      iag = iRS2F(1,iRab) ! global address
      ibg = iRS2F(2,iRab)

      iaSh = iSOShl(iag) ! shell to which it belongs
      ibSh = iSOShl(ibg) ! iaSh >= ibSh !!!!!!

      iaSg = iShlSO(iag) ! index of SO within its shell
      ibSg = iShlSO(ibg)

      iSyma = cho_isao(iag) ! symmetry block sym(a)=sym(b)

      ias = iaSg-iBasSh(iSyma,iaSh) ! addr within its shell
      ibs = ibSg-iBasSh(isyma,ibSh)

      kLabJ = kLabJ+1

      ChoV%SPB(iSyma,iShp_rs(iShp),1)%A3(ias,JVEC,ibs) = LabJ(kLabJ)

      i1 = 1
      if (ibSh /= iaSh) i1 = 2

      ChoV%SPB(iSyma,iShp_rs(iShp),i1)%A3(ibs,JVEC,ias) = LabJ(kLabJ)

      SvShp(iShp_rs(iShp),2) = SvShp(iShp_rs(iShp),2)+LabJ(kLabJ)**2

    end do

    do jShp=1,nnShl_tot ! Maximize over vectors
      if (iShp_rs(jShp) > 0) then
        SvShp(iShp_rs(jShp),1) = max(SvShp(iShp_rs(jShp),1),SvShp(iShp_rs(jShp),2))
        SvShp(iShp_rs(jShp),2) = zero
      end if
    end do

  end do

else

  NREAD = 0

  do JVEC=1,JNUM

    kLabJ = NREAD
    NREAD = NREAD+nDimRS(jSym,IREDC)

    do jRab=1,nnBstR(jSym,iLoc)

      kRab = iiBstr(jSym,iLoc)+jRab
      iRab = IndRed(kRab,iLoc) ! addr in 1st red set

      iShp = IndRSh(iRab) ! shell pair to which it belongs

      iag = iRS2F(1,iRab) ! global address
      ibg = iRS2F(2,iRab)

      iaSh = iSOShl(iag) ! shell to which it belongs
      ibSh = iSOShl(ibg) ! ibsh<=>iaSh

      iaSg = iShlSO(iag) ! index of SO within its shell
      ibSg = iShlSO(ibg)

      iSyma = cho_isao(iag) ! symmetry block
      iSymb = Mul(jSym,iSyma) ! iSyma >= iSymb

      i1 = 1
      if (iaSh < ibSh) i1 = 2

      ias = iaSg-iBasSh(iSyma,iaSh) ! addr within its shell
      ibs = ibSg-iBasSh(iSymb,ibSh)

      kLabJ = kLabJ+1

      ChoV%SPB(iSyma,iShp_rs(iShp),i1)%A3(ias,JVEC,ibs) = LabJ(kLabJ)

      SvShp(iShp_rs(iShp),2) = SvShp(iShp_rs(iShp),2)+LabJ(kLabJ)**2

    end do

    do jShp=1,nnShl_tot
      if (iShp_rs(jShp) > 0) then
        SvShp(iShp_rs(jShp),1) = max(SvShp(iShp_rs(jShp),1),SvShp(iShp_rs(jShp),2))
        SvShp(iShp_rs(jShp),2) = zero
      end if
    end do

  end do

end if

return

end subroutine CHO_GetShFull

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This module simply provides an interface for the EAF subroutines with
! real buffers instead of integers, note that nBuf is still the length
! of the integer buffer.

module dEAF

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Definitions, only: wp, iwp

implicit none
private

public :: dEAFARead, dEAFAWrite, dEAFRead, dEAFWrite

contains

subroutine dEAFARead(Lu,Buf,nBuf,Disk,id)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  real(kind=wp), target, intent(out) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp), intent(out) :: id
  integer(kind=iwp), pointer :: iBuf(:)

  call c_f_pointer(c_loc(Buf),iBuf,[nBuf])
  call EAFARead(Lu,iBuf,nBuf,Disk,id)
  nullify(iBuf)

end subroutine dEAFARead

subroutine dEAFAWrite(Lu,Buf,nBuf,Disk,id)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  real(kind=wp), target, intent(in) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp), intent(out) :: id
  integer(kind=iwp), pointer :: iBuf(:)

  call c_f_pointer(c_loc(Buf),iBuf,[nBuf])
  call EAFAWrite(Lu,iBuf,nBuf,Disk,id)
  nullify(iBuf)

end subroutine dEAFAWrite

subroutine dEAFRead(Lu,Buf,nBuf,Disk)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  real(kind=wp), target, intent(out) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp), pointer :: iBuf(:)

  call c_f_pointer(c_loc(Buf),iBuf,[nBuf])
  call EAFRead(Lu,iBuf,nBuf,Disk)
  nullify(iBuf)

end subroutine dEAFRead

subroutine dEAFWrite(Lu,Buf,nBuf,Disk)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  real(kind=wp), target, intent(in) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp), pointer :: iBuf(:)

  call c_f_pointer(c_loc(Buf),iBuf,[nBuf])
  call EAFWrite(Lu,iBuf,nBuf,Disk)
  nullify(iBuf)

end subroutine dEAFWrite

end module dEAF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKWWOPH(IVEC,JVEC,OP0)
! Given the coefficients for two excitation operators, available in
! vectors numbered IVEC and JVEC on file, use the blocks for
! excitation case BJAI, i.e. cases 12 and 13, to express the
! product (Op in IVEC conjugated)(Op in JVEC) as a zero-body
! operator, i.e. a scalar factor, in the CASSCF space.
! Formula used:
!  (W1(ij,ab) conj)*(W2(kl,cd)) = dik*djl*dac*dbd
! the same for both cases 10 and 11.

use EQSOLV, only: MODVEC
use caspt2_module, only: NASUP, NINDEP, NISUP, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC
real(kind=wp), intent(inout) :: OP0
integer(kind=iwp) :: ICASE, IIEND, IISTA, ISCT, ISYM, MDVEC, NAS, NCOL, NIS, NSCT
real(kind=wp), allocatable :: W1(:), W2(:)
real(kind=wp), external :: DDot_

! Loop over cases
do ICASE=12,13
  ! Loop over symmetry ISYM
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (NINDEP(ISYM,ICASE) == 0) cycle
    ! Allocate space for one section of excitation amplitudes:
    MDVEC = MODVEC(ISYM,ICASE)
    call mma_allocate(W1,NAS*MDVEC,Label='W1')
    call mma_allocate(W2,NAS*MDVEC,Label='W2')
    ! Sectioning loop added:
    ISCT = 0
    do IISTA=1,NIS,MDVEC
      ISCT = ISCT+1
      IIEND = min(IISTA-1+MDVEC,NIS)
      NCOL = 1+IIEND-IISTA
      NSCT = NAS*NCOL
      call RDSCTC(ISCT,ISYM,ICASE,IVEC,W1,NAS*MDVEC)
      call RDSCTC(ISCT,ISYM,ICASE,JVEC,W2,NAS*MDVEC)
      ! Pick up a symmetry block of W1 and W2
      OP0 = OP0+DDOT_(NSCT,W1,1,W2,1)
    end do
    call mma_deallocate(W1)
    call mma_deallocate(W2)
  end do
  ! End of loop over cases.
end do

end subroutine MKWWOPH

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine isoloop(double)

use Isotopes, only: ElementList, Initialize_Isotopes, Isotope, MaxAtomNum, PTab
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: UtoAU
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: double
integer(kind=iwp) :: AtNum, AtNum2, i, iElement, iMass, ineg, IsoNum, j, k, l, m, mAtoms, n, nAt, nTemp, Subs, Subs2
real(kind=wp) :: dMass, dMass1, dMass2, MassIso
logical(kind=iwp) :: Changed, EQ, Found, lmass
real(kind=wp), allocatable :: Coord(:,:), DefMass(:), H(:,:), H2(:,:), Mass(:), Temp(:), umass(:), Val(:), Vec(:,:)
character(len=3), allocatable :: cmass(:)
character(len=2), allocatable :: Element(:)
integer(kind=iwp), external :: iNuclearChargeFromSymbol

!                                                                      *
!***********************************************************************
!                                                                      *
write(u6,*)
call CollapseOutput(1,'   Isotopic shifts:')
write(u6,'(3X,A)') '   ----------------'
write(u6,*)

call Get_nAtoms_All(mAtoms)
call mma_allocate(Coord,3,mAtoms,label='Coord')
call Get_Coord_All(Coord,mAtoms)
call mma_allocate(Element,mAtoms,label='Element')
call Get_Name_All(Element)

write(u6,*)
write(u6,*)
write(u6,*) '****************************************'
write(u6,*) '*                                      *'
write(u6,*) '* Isotope shifted frequencies in cm-1  *'
write(u6,*) '*                                      *'
write(u6,*) '****************************************'
write(u6,*)
n = 3*mAtoms
nTemp = 6*2*n**2
call mma_allocate(Temp,nTemp,label='ISOLOOP')
call mma_allocate(H,n,n,label='H')
call mma_allocate(H2,n,n,label='H2')
call mma_allocate(Vec,2*n,n,label='Vec')
call mma_allocate(Val,2*n,label='Val')
!                                                                      *
!***********************************************************************
!                                                                      *
call qpg_iscalar('iMass',lmass)
if (lmass) then
  call Get_iScalar('iMass',iMass)
  call mma_allocate(cmass,iMass,label='cmass')
  call mma_allocate(umass,iMass,label='umass')
  call Get_cArray('cmass',cmass,3*iMass)
  call Get_dArray('umass',umass,iMass)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Read the unsymmetrized Hessian from run file

call Get_dArray('FC-Matrix',H,n**2)

! Put in the initial masses and take backup copy

call mma_allocate(Mass,mAtoms,label='Mass')
call mma_allocate(DefMass,mAtoms,label='DefaultMass')
call Get_Mass_All(Mass,mAtoms)
DefMass(:) = Mass(:)

do i=1,mAtoms
  Coord(1,i) = abs(Coord(1,i))
  Coord(2,i) = abs(Coord(2,i))
  Coord(3,i) = abs(Coord(3,i))
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over common isotopes

call Initialize_Isotopes()
!                                                                      *
!***********************************************************************
!                                                                      *
! Single substitutions

write(u6,*)
write(u6,*) ' Single substitutions:'
write(u6,*) ' -----------------------'
write(u6,*)
do i=1,mAtoms

  if (i > 1) then
    if (EQ(Coord(1,i),Coord(1,i-1))) cycle
  end if

  AtNum = iNuclearChargeFromSymbol(Element(i))
  Subs = 0
  if (lmass) then

    ! Do according to user list of isotopes.

    do nAt=1,iMass
      if (Element(i) == cmass(nAt)) then
        Mass(i) = UtoAU*umass(nAt)
        Subs = 1
      end if
    end do
  else if (AtNum > 0) then

    ! Get list of natural isotopes

    Subs = max(ElementList(AtNum)%Natural,1)
  end if

  dMass = Mass(i)
  do k=1,Subs
    if (.not. lmass) then
      IsoNum = ElementList(AtNum)%Isotopes(k)%A
      if (IsoNum == nint(dMass/UtoAU)) cycle
      call Isotope(IsoNum,AtNum,Mass(i))
    end if

    H2(:,:) = H(:,:)
    write(u6,*) 'Masses:'
    write(u6,*) '======='
    write(u6,'(20I4)') (nint(mass(l)/UtoAU),l=1,mAtoms)
    write(u6,*)
    write(u6,*)
    write(u6,*) 'Frequencies:'
    write(u6,*) '============'
    call freq_i(n,H2,mass,Vec,Val,ineg)
    call GFPrnt_i(Val,n)
  end do
  ! Put back the original mass
  Mass(i) = dMass
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Full substitutions

write(u6,*)
write(u6,*) ' Full substitutions:'
write(u6,*) ' -----------------------'
write(u6,*)
do iElement=1,MaxAtomNum

  Found = .false.
  do i=1,mAtoms
    Found = Found .or. (PTab(iElement) == Element(i))
  end do

  ! Process if element found in the molecule.

  if (Found) then

    ! Loop over all natural isotopes of this element.

    do k=1,max(ElementList(iElement)%Natural,1)
      IsoNum = ElementList(iElement)%Isotopes(k)%A
      call Isotope(IsoNum,iElement,MassIso)

      ! Substitute all instances.

      Changed = .false.
      do i=1,mAtoms
        if (PTab(iElement) == Element(i)) then
          if (IsoNum /= nint(DefMass(i)/UtoAU)) Changed = .true.
          Mass(i) = MassIso
        end if
      end do

      if (Changed) then
        H2(:,:) = H(:,:)
        write(u6,*) 'Masses:'
        write(u6,*) '======='
        write(u6,'(20I4)') (nint(mass(l)/UtoAU),l=1,mAtoms)
        write(u6,*)
        write(u6,*)
        write(u6,*) 'Frequencies:'
        write(u6,*) '============'
        call Freq_i(n,H2,mass,Vec,Val,ineg)
        call GFPrnt_i(Val,n)
      end if

    end do

    ! Restore the initial mass array

    Mass(1:mAtoms) = DefMass(:)

  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Double substitutions

if (double) then
  write(u6,*)
  write(u6,*) ' Double substitutions:'
  write(u6,*) ' -----------------------'
  write(u6,*)

  do i=1,mAtoms
    AtNum = iNuclearChargeFromSymbol(Element(i))
    if (lmass) then
      Subs = 0
      do nAt=1,iMass
        if (Element(i) == cmass(nAt)) then
          Mass(i) = UtoAU*umass(nAt)
          Subs = 1
        end if
      end do
    else
      Subs = max(ElementList(AtNum)%Natural,1)
    end if

    ! All isotopes first atom
    dMass1 = Mass(i)
    do k=1,Subs
      if (.not. lmass) then
        IsoNum = ElementList(AtNum)%Isotopes(k)%A
        if (IsoNum == nint(dMass1/UtoAU)) cycle
        call Isotope(IsoNum,AtNum,Mass(i))
      end if

      ! Second atom
      do j=i+1,mAtoms
        AtNum2 = iNuclearChargeFromSymbol(Element(j))
        if (lmass) then
          Subs2 = 0
          do nAt=1,iMass
            if (Element(j) == cmass(nAt)) then
              Mass(j) = UtoAU*umass(nAt)
              Subs2 = 1
            end if
          end do
        else
          Subs2 = max(ElementList(AtNum2)%Natural,1)
        end if

        ! All isotopes for second atom
        dMass2 = Mass(j)
        do l=1,Subs2
          if (.not. lmass) then
            IsoNum = ElementList(AtNum2)%Isotopes(l)%A
            if (IsoNum == nint(dMass2/UtoAU)) cycle
            call Isotope(IsoNum,AtNum2,Mass(j))
          end if

          H2(:,:) = H(:,:)
          write(u6,*) 'Masses:'
          write(u6,*) '======='
          write(u6,'(20I4)') (nint(mass(m)/UtoAU),m=1,mAtoms)
          write(u6,*)
          write(u6,*)
          write(u6,*) 'Frequencies:'
          write(u6,*) '============'
          call freq_i(n,H2,mass,Vec,Val,ineg)
          call GFPrnt_i(Val,n)

        end do
        ! Put back the original mass
        Mass(j) = dMass2
      end do   ! End inner loop over atoms

    end do
    ! Put back the original mass
    Mass(i) = dMass1
  end do ! End outer loop over atoms
!                                                                      *
!***********************************************************************
!                                                                      *
end if
if (lmass) then
  call mma_deallocate(cmass)
  call mma_deallocate(umass)
end if
call mma_deallocate(Mass)
call mma_deallocate(DefMass)
call mma_deallocate(Temp)
call mma_deallocate(H)
call mma_deallocate(H2)
call mma_deallocate(Vec)
call mma_deallocate(Val)
call mma_deallocate(Element)
call mma_deallocate(Coord)

call CollapseOutput(0,'   Isotopic shifts:')
write(u6,*)

return

end subroutine isoloop

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_grc0(nind,typ,typp,typq,typr,typs,stot,med,post)
! this routine defines med%d and med%i for given intermediate
!
! !N.B. (this routine cannot run with +OP2)

use CCT3_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nind, typ, typp, typq, typr, typs, stot
type(Map_Type), intent(inout) :: med
integer(kind=iwp), intent(out) :: post
integer(kind=iwp) :: i, nhelp1, nhelp2, nhelp3, nhelp4, nsymq, nsymr, pos, sp, spq, spqr, sq, sr, ss

! vanishing med%i files

med%i(1:nsym,1:nsym,1:nsym) = 0

select case (nind)

  case (1)

    ! matrix A(p)

    i = 1
    pos = med%pos0
    sp = mmul(stot,1)

    nhelp1 = dimm(typp,sp)

    ! def med%i
    med%i(1,1,1) = i

    ! def position
    med%d(i,1) = pos

    ! def length
    med%d(i,2) = nhelp1

    ! def sym p,q
    med%d(i,3) = sp
    med%d(i,4) = 0
    med%d(i,5) = 0
    med%d(i,6) = 0

    pos = pos+med%d(i,2)
    i = i+1

  case (2)

    ! matrix A(p,q)

    i = 1
    pos = med%pos0

    do sp=1,nsym

      sq = mmul(stot,sp)
      ! Meggie out
      if ((typ == 1) .and. (sp < sq)) cycle

      nhelp1 = dimm(typp,sp)
      nhelp2 = dimm(typq,sq)

      ! def med%i
      med%i(sp,1,1) = i

      ! def position
      med%d(i,1) = pos

      ! def length
      if ((typ == 1) .and. (sp == sq)) then
        med%d(i,2) = nhelp1*(nhelp1-1)/2
      else
        med%d(i,2) = nhelp1*nhelp2
      end if

      ! def sym p,q
      med%d(i,3) = sp
      med%d(i,4) = sq
      med%d(i,5) = 0
      med%d(i,6) = 0

      pos = pos+med%d(i,2)
      i = i+1

    end do

  case (3)

    ! matrix A(p,q,r)

    i = 1
    pos = med%pos0

    do sp=1,nsym
      if (typ == 1) then
        nsymq = sp
      else
        nsymq = nsym
      end if

      do sq=1,nsymq
        spq = mmul(sp,sq)

        sr = mmul(stot,spq)
        ! Meggie out
        if ((typ == 2) .and. (sq < sr)) cycle

        nhelp1 = dimm(typp,sp)
        nhelp2 = dimm(typq,sq)
        nhelp3 = dimm(typr,sr)

        ! def med%i
        med%i(sp,sq,1) = i

        ! def position
        med%d(i,1) = pos

        ! def length
        if ((typ == 1) .and. (sp == sq)) then
          med%d(i,2) = nhelp1*(nhelp1-1)*nhelp3/2
        else if ((typ == 2) .and. (sq == sr)) then
          med%d(i,2) = nhelp1*nhelp2*(nhelp2-1)/2
        else
          med%d(i,2) = nhelp1*nhelp2*nhelp3
        end if

        ! def sym p,q,r
        med%d(i,3) = sp
        med%d(i,4) = sq
        med%d(i,5) = sr
        med%d(i,6) = 0

        pos = pos+med%d(i,2)
        i = i+1

      end do
    end do

  case (4)

    ! matrix A(p,q,r,s)

    i = 1
    pos = med%pos0

    do sp=1,nsym
      if ((typ == 1) .or. (typ == 4)) then
        nsymq = sp
      else
        nsymq = nsym
      end if

      do sq=1,nsymq
        spq = mmul(sp,sq)
        if (typ == 2) then
          nsymr = sq
        else
          nsymr = nsym
        end if

        do sr=1,nsymr
          spqr = mmul(spq,sr)

          ss = mmul(stot,spqr)
          ! Meggie out
          if (((typ == 3) .or. (typ == 4)) .and. (sr < ss)) cycle

          nhelp1 = dimm(typp,sp)
          nhelp2 = dimm(typq,sq)
          nhelp3 = dimm(typr,sr)
          nhelp4 = dimm(typs,ss)

          ! def med%i
          med%i(sp,sq,sr) = i

          ! def position
          med%d(i,1) = pos

          ! def length
          if ((typ == 1) .and. (sp == sq)) then
            med%d(i,2) = nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
          else if ((typ == 2) .and. (sq == sr)) then
            med%d(i,2) = nhelp1*nhelp2*(nhelp3-1)*nhelp4/2
          else if ((typ == 3) .and. (sr == ss)) then
            med%d(i,2) = nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
          else if (typ == 4) then
            if ((sp == sq) .and. (sr == ss)) then
              med%d(i,2) = nhelp1*(nhelp2-1)*nhelp3*(nhelp4-1)/4
            else if (sp == sq) then
              med%d(i,2) = nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
            else if (sr == ss) then
              med%d(i,2) = nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
            else
              med%d(i,2) = nhelp1*nhelp2*nhelp3*nhelp4
            end if
          else
            med%d(i,2) = nhelp1*nhelp2*nhelp3*nhelp4
          end if

          ! def sym p,q,r,s
          med%d(i,3) = sp
          med%d(i,4) = sq
          med%d(i,5) = sr
          med%d(i,6) = ss

          pos = pos+med%d(i,2)
          i = i+1

        end do
      end do
    end do

  case default
    ! To fix some compiler warnings
    pos = 0
    i = 0
end select

post = pos

! definition of other coll

med%d(0,1) = typp
med%d(0,2) = typq
med%d(0,3) = typr
med%d(0,4) = typs
med%d(0,5) = i-1
med%d(0,6) = typ

return

end subroutine cct3_grc0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1994, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

subroutine vRys2D(xyz2D,nArg,lRys,nabMax,ncdMax,PAWP,QCWQ,B10,B00,B01)
!***********************************************************************
!                                                                      *
! Object: to compute the 2-dimensional integrals of the Rys            *
!         quadrature. The z components are assumed to be pre-          *
!         conditioned with the weights of the roots of the             *
!         Rys polynomial.                                              *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
! Modified loop structure for RISC 1991 R. Lindh Dept. of Theoretical  *
! Chemistry, University of Lund, Sweden.                               *
! Further modifications in Jan-Feb. 1994.                              *
!***********************************************************************

use Constants, only: One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nArg, lRys, nabMax, ncdMax
real(kind=wp), intent(inout) :: xyz2D(nArg*lRys,3,0:nabMax,0:ncdMax)
real(kind=wp), intent(in) :: PAWP(nArg*lRys,3), QCWQ(nArg*lRys,3), B10(nArg*lRys), B00(nArg*lRys), B01(nArg*lRys)
integer(kind=iwp) :: iab, icd
real(kind=wp) :: Fac1, Fac2, Fact
logical(kind=iwp) :: lPAWP, lQCWQ
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
character(len=30) :: Label
#endif

#ifdef _DEBUGPRINT_
if (nabMax > 0) call RecPrt('PAWP',' ',PAWP,lRys,nArg*3)
if (ncdMax > 0) call RecPrt('QCWQ',' ',QCWQ,lRys,nArg*3)
call RecPrt(' B10',' ',B10,lRys,nArg)
call RecPrt(' B00',' ',B00,lRys,nArg)
call RecPrt(' B01',' ',B01,lRys,nArg)
#endif

if ((nabMax /= 0) .or. (ncdMax /= 0)) then

  ! General code

  ! Store away PAWPz and QCPQz

  lPAWP = nabMax > 2
  lQCWQ = ncdMax > 2
  if ((nabMax >= 1) .and. (ncdMax >= 1)) then
    if (ncdMax <= nabMax) then
      lPAWP = .true.
    else
      lQCWQ = .true.
    end if
  end if
  if (lPAWP) xyz2D(:,1,0,0) = PAWP(:,3)
  if (lQCWQ) xyz2D(:,2,0,0) = QCWQ(:,3)

  ! Compute 2D integrals with index (i,0)

  if (nabMax == 0) then

  else if (nabMax == 1) then
    xyz2D(:,3,1,0) = xyz2D(:,3,1,0)*xyz2D(:,3,0,0)
  else if (nabMax >= 2) then
    xyz2D(:,1,2,0) = xyz2D(:,1,1,0)**2+B10(:)
    xyz2D(:,2,2,0) = xyz2D(:,2,1,0)**2+B10(:)
    xyz2D(:,3,2,0) = (xyz2D(:,3,1,0)**2+B10(:))*xyz2D(:,3,0,0)
    xyz2D(:,3,1,0) = xyz2D(:,3,1,0)*xyz2D(:,3,0,0)
    if (nabMax > 2) then
      Fact = Two
      do iab=2,nabMax-1
        xyz2D(:,1,iab+1,0) = xyz2D(:,1,1,0)*xyz2D(:,1,iab,0)+Fact*B10(:)*xyz2D(:,1,iab-1,0)
        xyz2D(:,2,iab+1,0) = xyz2D(:,2,1,0)*xyz2D(:,2,iab,0)+Fact*B10(:)*xyz2D(:,2,iab-1,0)
        xyz2D(:,3,iab+1,0) = xyz2D(:,1,0,0)*xyz2D(:,3,iab,0)+Fact*B10(:)*xyz2D(:,3,iab-1,0)
        Fact = Fact+One
      end do
    end if
  end if

  ! Compute 2D integrals with index (0,i)

  if (ncdMax == 1) then
    xyz2D(:,3,0,1) = xyz2D(:,3,0,1)*xyz2D(:,3,0,0)
  else if (ncdMax >= 2) then
    xyz2D(:,1,0,2) = xyz2D(:,1,0,1)**2+B01(:)
    xyz2D(:,2,0,2) = xyz2D(:,2,0,1)**2+B01(:)
    xyz2D(:,3,0,2) = (xyz2D(:,3,0,1)**2+B01(:))*xyz2D(:,3,0,0)
    xyz2D(:,3,0,1) = xyz2D(:,3,0,1)*xyz2D(:,3,0,0)
    if (ncdMax > 2) then
      Fact = Two
      do icd=2,ncdMax-1
        xyz2D(:,1,0,icd+1) = xyz2D(:,1,0,1)*xyz2D(:,1,0,icd)+Fact*B01(:)*xyz2D(:,1,0,icd-1)
        xyz2D(:,2,0,icd+1) = xyz2D(:,2,0,1)*xyz2D(:,2,0,icd)+Fact*B01(:)*xyz2D(:,2,0,icd-1)
        xyz2D(:,3,0,icd+1) = xyz2D(:,2,0,0)*xyz2D(:,3,0,icd)+Fact*B01(:)*xyz2D(:,3,0,icd-1)
        Fact = Fact+One
      end do
    end if
  end if

  ! Compute 2D integrals with index (i,j)

  if (ncdMax <= nabMax) then
    Fac1 = One
    do icd=1,ncdMax
      if (icd == 1) then
        xyz2D(:,1,1,1) = xyz2D(:,1,1,0)*xyz2D(:,1,0,1)+B00(:)
        xyz2D(:,2,1,1) = xyz2D(:,2,1,0)*xyz2D(:,2,0,1)+B00(:)
        xyz2D(:,3,1,1) = xyz2D(:,1,0,0)*xyz2D(:,3,0,1)+B00(:)*xyz2D(:,3,0,0)
      else
        xyz2D(:,1,1,icd) = xyz2D(:,1,1,0)*xyz2D(:,1,0,icd)+Fac1*B00(:)*xyz2D(:,1,0,icd-1)
        xyz2D(:,2,1,icd) = xyz2D(:,2,1,0)*xyz2D(:,2,0,icd)+Fac1*B00(:)*xyz2D(:,2,0,icd-1)
        xyz2D(:,3,1,icd) = xyz2D(:,1,0,0)*xyz2D(:,3,0,icd)+Fac1*B00(:)*xyz2D(:,3,0,icd-1)
      end if
      if (nabMax == 2) then
        xyz2D(:,1,2,icd) = xyz2D(:,1,1,0)*xyz2D(:,1,1,icd)+B10(:)*xyz2D(:,1,0,icd)+Fac1*B00(:)*xyz2D(:,1,1,icd-1)
        xyz2D(:,2,2,icd) = xyz2D(:,2,1,0)*xyz2D(:,2,1,icd)+B10(:)*xyz2D(:,2,0,icd)+Fac1*B00(:)*xyz2D(:,2,1,icd-1)
        xyz2D(:,3,2,icd) = xyz2D(:,1,0,0)*xyz2D(:,3,1,icd)+B10(:)*xyz2D(:,3,0,icd)+Fac1*B00(:)*xyz2D(:,3,1,icd-1)
      else if (nabMax > 2) then
        Fac2 = One
        do iab=1,nabMax-1
          xyz2D(:,1,iab+1,icd) = xyz2D(:,1,1,0)*xyz2D(:,1,iab,icd)+Fac2*B10(:)*xyz2D(:,1,iab-1,icd)+Fac1*B00(:)*xyz2D(:,1,iab,icd-1)
          xyz2D(:,2,iab+1,icd) = xyz2D(:,2,1,0)*xyz2D(:,2,iab,icd)+Fac2*B10(:)*xyz2D(:,2,iab-1,icd)+Fac1*B00(:)*xyz2D(:,2,iab,icd-1)
          xyz2D(:,3,iab+1,icd) = xyz2D(:,1,0,0)*xyz2D(:,3,iab,icd)+Fac2*B10(:)*xyz2D(:,3,iab-1,icd)+Fac1*B00(:)*xyz2D(:,3,iab,icd-1)
          Fac2 = Fac2+One
        end do
      end if
      Fac1 = Fac1+One
    end do
  else
    Fac1 = One
    do iab=1,nabMax
      if (iab == 1) then
        xyz2D(:,1,1,1) = xyz2D(:,1,0,1)*xyz2D(:,1,1,0)+B00(:)
        xyz2D(:,2,1,1) = xyz2D(:,2,0,1)*xyz2D(:,2,1,0)+B00(:)
        xyz2D(:,3,1,1) = xyz2D(:,2,0,0)*xyz2D(:,3,1,0)+B00(:)*xyz2D(:,3,0,0)
      else
        xyz2D(:,1,iab,1) = xyz2D(:,1,0,1)*xyz2D(:,1,iab,0)+Fac1*B00(:)*xyz2D(:,1,iab-1,0)
        xyz2D(:,2,iab,1) = xyz2D(:,2,0,1)*xyz2D(:,2,iab,0)+Fac1*B00(:)*xyz2D(:,2,iab-1,0)
        xyz2D(:,3,iab,1) = xyz2D(:,2,0,0)*xyz2D(:,3,iab,0)+Fac1*B00(:)*xyz2D(:,3,iab-1,0)
      end if
      if (ncdMax == 2) then
        xyz2D(:,1,iab,2) = xyz2D(:,1,0,1)*xyz2D(:,1,iab,1)+B01(:)*xyz2D(:,1,iab,0)+Fac1*B00(:)*xyz2D(:,1,iab-1,1)
        xyz2D(:,2,iab,2) = xyz2D(:,2,0,1)*xyz2D(:,2,iab,1)+B01(:)*xyz2D(:,2,iab,0)+Fac1*B00(:)*xyz2D(:,2,iab-1,1)
        xyz2D(:,3,iab,2) = xyz2D(:,2,0,0)*xyz2D(:,3,iab,1)+B01(:)*xyz2D(:,3,iab,0)+Fac1*B00(:)*xyz2D(:,3,iab-1,1)
      else if (ncdMax > 2) then
        Fac2 = One
        do icd=1,ncdmax-1
          xyz2D(:,1,iab,icd+1) = xyz2D(:,1,0,1)*xyz2D(:,1,iab,icd)+Fac2*B01(:)*xyz2D(:,1,iab,icd-1)+Fac1*B00(:)*xyz2D(:,1,iab-1,icd)
          xyz2D(:,2,iab,icd+1) = xyz2D(:,2,0,1)*xyz2D(:,2,iab,icd)+Fac2*B01(:)*xyz2D(:,2,iab,icd-1)+Fac1*B00(:)*xyz2D(:,2,iab-1,icd)
          xyz2D(:,3,iab,icd+1) = xyz2D(:,2,0,0)*xyz2D(:,3,iab,icd)+Fac2*B01(:)*xyz2D(:,3,iab,icd-1)+Fac1*B00(:)*xyz2D(:,3,iab-1,icd)
          Fac2 = Fac2+One
        end do
      end if
      Fac1 = Fac1+One
    end do
  end if
end if

#ifdef _DEBUGPRINT_
do iab=0,nabMax
  do icd=0,ncdMax
    write(Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(x)'
    call RecPrt(Label,' ',xyz2D(:,1,iab,icd),lRys,nArg)
    write(Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(y)'
    call RecPrt(Label,' ',xyz2D(:,2,iab,icd),lRys,nArg)
    write(Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(z)'
    call RecPrt(Label,' ',xyz2D(:,3,iab,icd),lRys,nArg)
  end do
end do
#endif

return

end subroutine vRys2D

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RDJOB(JOB,READ_STATES)

use Cntrl, only: bNAME, HAVE_DIAG, HAVE_HEFF, HEAD1, HEff, IDCMO, IFEJOB, IFHEFF, IROOT1, IRREP, ISTAT, iTOC15, JBNAME, LROT1, &
                 LSYM1, LuIPH, MLTPLT, MPLET1, NACTE, NACTE1, NASH1, NBAS1, NCONF, NCONF1, NDEL1, NELE3, NELE31, NFRO1, NHOL11, &
                 NHOLE1, NISH1, NROOT1, NRS11, NRS21, NRS31, NSTAT, NSTATE, NSYM1, RASTYP, RefEne, TITLE1
use Molcas, only: LenIn, MxOrb, MxRoot, MxSym, MxLev
use rasdef, only: NRS1, NRS2, NRS3
use RASDim, only: MxIter, MxTit
use rassi_aux, only: ipglob, Level
use rassi_data, only: WFTYPE, NASH, NSSH, NDEL, NOSH, NASH, NISH, NFRO, NBASF, NDEL, NFRO, NISH
use rassi_global_arrays, only: JBNUM, LROOT
use Symmetry_Info, only: nIrrep
#ifdef _HDF5_
use Cntrl, only: NDET, NROOTS, QDPT2SC
use mh5, only: mh5_close_file, mh5_exists_attr, mh5_exists_dset, mh5_fetch_attr, mh5_fetch_dset, mh5_is_hdf5, mh5_open_file_r
#endif
#ifdef _DMRG_
use qcmaquis_info, only: qcm_group_names, qcm_prefixes, qcmaquis_info_init
use rasscf_global, only: doDMRG
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: JOB
logical(kind=iwp), intent(in) :: READ_STATES
integer(kind=iwp) :: I, IAD, IAD15, IDISK, IDUM(1), IPT2, ISNUM, ISTATE, ISY, IT, J, JSNUM, JSTATE, NEJOB, NHEFF, NIS, NIS1, &
                     NMAYBE, NROOT0, NTIT1
real(kind=wp) :: E, ENUCDUMMY, HIJ
logical(kind=iwp) :: ISZERO
real(kind=wp), allocatable :: EJOB(:), EREAD(:), H_Eff(:), Weight(:)
#ifdef _HDF5_
integer(kind=iwp) :: ref_iSpin, ref_nactel, ref_nash(mxSym), ref_nBas(mxSym), ref_nconf, ref_ndel(mxSym), ref_ndet, ref_nelec3, &
                     ref_nfro(mxSym), ref_nhole1, ref_nish(mxSym), ref_nroots, ref_nrs1(mxSym), ref_nrs2(mxSym), ref_nrs3(mxSym), &
                     ref_nssh(mxSym), ref_nstates, ref_nSym, ref_stSym, refwfn_id
character(len=21) :: pt2_e_string
character(len=16) :: molcas_module
character(len=8) :: heff_string
integer(kind=iwp), allocatable :: ref_rootid(:), root2state(:)
real(kind=wp), allocatable :: ref_energies(:), ref_Heff(:,:)
character, allocatable :: typestring(:)
#endif
#ifdef _DMRG_
integer(kind=iwp) :: idx
character(len=300) :: WorkDir
#endif

#ifdef _HDF5_
if (mh5_is_hdf5(jbname(job))) then
  !*********************************************************************
  !
  ! For HDF5 formatted job files
  !
  !*********************************************************************

  if (IPGLOB >= 2) then
    if (JOB == 1) then
      write(u6,*)
      write(u6,'(6X,A)') repeat('*',80)
      write(u6,'(6X,A1,78X,A1)') '*','*'
      write(u6,'(6X,A1,24X,A,24X,A1)') '*','     General data section     ','*'
      write(u6,'(6X,A1,78X,A1)') '*','*'
      write(u6,'(6X,A)') repeat('*',80)
    end if
    write(u6,*)
    write(u6,*) '  Specific data for HDF5 file ',trim(JBNAME(JOB))
    write(u6,*) '  -------------------------------------'
  end if

  refwfn_id = mh5_open_file_r(jbname(job))

  call mh5_fetch_attr(refwfn_id,'MOLCAS_MODULE',molcas_module)
  call mh5_fetch_attr(refwfn_id,'SPINMULT',ref_iSpin)
  call mh5_fetch_attr(refwfn_id,'NSYM',ref_nSym)
  call mh5_fetch_attr(refwfn_id,'LSYM',ref_stSym)
  call mh5_fetch_attr(refwfn_id,'NBAS',ref_nBas)

  call mh5_fetch_attr(refwfn_id,'NACTEL',ref_nactel)
  call mh5_fetch_attr(refwfn_id,'NHOLE1',ref_nhole1)
  call mh5_fetch_attr(refwfn_id,'NELEC3',ref_nelec3)
  call mh5_fetch_attr(refwfn_id,'NCONF',ref_nconf)
  call mh5_fetch_attr(refwfn_id,'NSTATES',ref_nstates)
  if (mh5_exists_attr(refwfn_id,'NROOTS')) then
    call mh5_fetch_attr(refwfn_id,'NROOTS',ref_nroots)
  else
    ref_nroots = ref_nstates
  end if
  ! NDET array is read only from HDF5, the number is not in JOBIPH
  if (mh5_exists_attr(refwfn_id,'NDET')) then
    call mh5_fetch_attr(refwfn_id,'NDET',ref_ndet)
  else
    ! to avoid runtime error
    ref_ndet = 1
  end if

  call mma_allocate(typestring,sum(ref_nbas(1:ref_nsym)))
  call mh5_fetch_dset(refwfn_id,'MO_TYPEINDICES',typestring)
  call tpstr2orb(ref_nsym,ref_nbas,typestring,ref_nfro,ref_nish,ref_nrs1,ref_nrs2,ref_nrs3,ref_nssh,ref_ndel)
  ref_nash(1:nIrrep) = ref_nrs1(1:nIrrep)+ref_nrs2(1:nIrrep)+ref_nrs3(1:nIrrep)
  call mma_deallocate(typestring)

# ifdef _DMRG_
  if ((.not. mh5_exists_dset(refwfn_id,'CI_VECTORS')) .and. (.not. doDMRG)) then
    ! Leon: TODO: This must be also extended for other DMRG interfaces
    ! than QCMaquis
# else
  if (.not. mh5_exists_dset(refwfn_id,'CI_VECTORS')) then
# endif
    write(u6,'(1X,A)') 'The HDF5 file does not contain CI vectors,'
    write(u6,'(1X,A)') 'make sure it was created by rasscf/caspt2.'
    call AbEnd()
  end if
  if (.not. mh5_exists_dset(refwfn_id,'MO_VECTORS')) then
    write(u6,'(1X,A)') 'The HDF5 file does not contain MO vectors,'
    write(u6,'(1X,A)') 'make sure it was created by rasscf/caspt2/nevpt2.'
    call AbEnd()
  end if

  !call mh5_fetch_attr (refwfn_id,'L2ACT', L2ACT)
  call mh5_fetch_attr(refwfn_id,'A2LEV',LEVEL)

  call mma_allocate(ref_rootid,ref_nstates)
  call mh5_fetch_attr(refwfn_id,'STATE_ROOTID',ref_rootid)
  call mma_allocate(root2state,MxRoot,Label='root2state')
  root2state(:) = 0
  if (mh5_exists_attr(refwfn_id,'ROOT2STATE')) then
    call mh5_fetch_attr(refwfn_id,'ROOT2STATE',root2state)
  else
    root2state(1:ref_nroots) = [(i,i=1,ref_nroots)]
  end if
  if (read_states) then
    ! Do not update the state number here, because it's already read in
    ! rdjob_nstates()
    !NSTAT(JOB) = ref_nstates
    !NSTATE = NSTATE+ref_nstates
    ! store the root IDs of each state
    LROOT(ISTAT(JOB):ISTAT(JOB)+NSTAT(JOB)-1) = ref_rootid(1:NSTAT(JOB))
    JBNUM(ISTAT(JOB):ISTAT(JOB)+NSTAT(JOB)-1) = JOB
  end if
  LROT1 = ref_nroots
  do I=0,NSTAT(JOB)-1
    NROOT0 = root2state(LROOT(ISTAT(JOB)+I))
    if ((NROOT0 <= 0) .or. (NROOT0 > LROT1)) call Error(2)
  end do

  if (qdpt2sc .and. (molcas_module(1:6) == 'NEVPT2')) then
    heff_string = 'H_EFF_SC'
    pt2_e_string = 'STATE_PT2_ENERGIES_SC'
  else
    heff_string = 'H_EFF'
    pt2_e_string = 'STATE_PT2_ENERGIES'
  end if

  if (mh5_exists_dset(refwfn_id,heff_string)) then
    ! read the ms-caspt2/qd-nevpt2 effective hamiltonian if it is available
    call mma_allocate(ref_Heff,ref_nstates,ref_nstates)
    call mh5_fetch_dset(refwfn_id,heff_string,ref_Heff)
    HAVE_HEFF = .true.
    ! with ejob, only read diagonal
    if (ifejob) then
      HAVE_DIAG = .true.
      !call WarningMessage(0,'Effective Hamiltonian found in  reference file, but "EJOB" was requested: off-diagonal elements '// &
      !                    'will be ignored!')
      do I=1,NSTAT(JOB)
        ISTATE = ISTAT(JOB)-1+I
        ISNUM = root2state(LROOT(ISTATE))
        REFENE(istate) = ref_Heff(ISNUM,ISNUM)
      end do
    else
      write(u6,'(2x,a)') ' Effective Hamiltonian from MRPT2 in action'
      write(u6,'(2x,a)') ' ------------------------------------------'
      do I=1,NSTAT(JOB)
        ISTATE = ISTAT(JOB)-1+I
        ISNUM = root2state(LROOT(ISTATE))
        do J=1,NSTAT(JOB)
          JSTATE = ISTAT(JOB)-1+J
          JSNUM = root2state(LROOT(JSTATE))
          HEff(jState,iState) = ref_Heff(ISNUM,JSNUM)
        end do
      end do
    end if
    call mma_deallocate(ref_Heff)
  else if (mh5_exists_dset(refwfn_id,pt2_e_string)) then
    ! read the caspt2/qdnevpt2 reference energies if available
    HAVE_DIAG = .true.
    call mma_allocate(ref_energies,ref_nstates)
    call mh5_fetch_dset(refwfn_id,pt2_e_string,ref_energies)
    do I=1,NSTAT(JOB)
      ISTATE = ISTAT(JOB)-1+I
      ISNUM = root2state(LROOT(ISTATE))
      REFENE(istate) = ref_energies(ISNUM)
      ! put the energies on the Heff diagonal too, just in case
      HEff(iState,iState) = ref_energies(ISNUM)
    end do
    call mma_deallocate(ref_energies)
  else if (mh5_exists_dset(refwfn_id,'ROOT_ENERGIES')) then
    ! read rasscf energies
    HAVE_DIAG = .true.
    call mma_allocate(ref_energies,ref_nroots)
    call mh5_fetch_dset(refwfn_id,'ROOT_ENERGIES',ref_energies)
    do I=1,NSTAT(JOB)
      ISTATE = ISTAT(JOB)-1+I
      ISNUM = root2state(LROOT(ISTATE))
      REFENE(istate) = ref_energies(ISNUM)
      ! put the energies on the Heff diagonal too, just in case
      HEff(iState,iState) = ref_energies(ISNUM)
    end do
    call mma_deallocate(ref_energies)
  end if
  call mma_deallocate(root2state)

# ifdef _DMRG_
  call getenvf('WorkDir',WorkDir)
  ! Leon 5/12/2016: Fetch QCMaquis checkpoint names if requested
  if (doDMRG) then
    if (mh5_exists_dset(refwfn_id,'QCMAQUIS_CHECKPOINT')) then
      write(u6,*) '  QCMaquis checkpoint files:'
      write(u6,*) '  --------------------------'
      write(u6,*) '  State   Checkpoint file'

      !> allocate space for the file name strings of job JOB
      call qcmaquis_info_init(job,nstat(job),1)

      do I=1,NSTAT(JOB)
        ISTATE = ISTAT(JOB)-1+I
        call mh5_fetch_dset(refwfn_id,'QCMAQUIS_CHECKPOINT',qcm_group_names(job)%states(i:i),[1],[LROOT(ISTATE)-1])
        write(u6,'(5X,I3,3X,A)') ISTATE,trim(qcm_group_names(job)%states(i))
      end do
      write(u6,*) '  --------------------------'
      ! save QCMaquis prefix
      ! by cutting off the last '.checkpoint_state.X.h5'
      ! and adding the full path
      if (size(qcm_group_names(job)%states) > 0) then
        idx = index(qcm_group_names(job)%states(1),'.checkpoint_state.')
        if (idx > 0) then
          qcm_prefixes(job) = trim(WorkDir)//'/'//trim(qcm_group_names(job)%states(1)(1:idx-1))
        else
          call WarningMessage(2,'Faulty QCMaquis checkpoint name')
          write(u6,*) 'Must contain "checkpoint_state"'
          call Abend()
        end if
      end if
    else
      call WarningMessage(2,'QCMaquis checkpoint names not found on HDF5 files. Make sure you created them with the MOLCAS '// &
                          'version which supports them')
      call Quit_OnUserError()
    end if
  end if
# endif
  if (ref_nsym /= nIrrep) then
    call WarningMessage(2,'NSYM not consistent with RunFile')
    call Quit_OnUserError()
  end if
  do i=1,nIrrep
    if (ref_nbas(i) /= nbasf(i)) then
      call WarningMessage(2,'NBAS not consistent with RunFile')
      call Quit_OnUserError()
    end if
  end do

  NACTE(JOB) = ref_nactel
  NHOLE1(JOB) = ref_nhole1
  NELE3(JOB) = ref_nelec3
  MLTPLT(JOB) = ref_iSpin
  IRREP(JOB) = ref_stSym
  NCONF(JOB) = ref_nConf
  NROOTS(JOB) = ref_nroots
  ! in singlet case the number of determinants is doubled in rassi
  ! compare to the rasscf routine, storing here due to rassi procedure
  if (mltplt(JOB) == 1) then
    nDet(JOB) = 2*ref_ndet-1
  else
    nDet(JOB) = ref_ndet
  end if

  if (job == 1) then
    ! first wavefunction file, set global variables
    NFRO(1:nIrrep) = 0
    NISH(1:nIrrep) = ref_nfro(1:nIrrep)+ref_nish(1:nIrrep)
    NASH(1:nIrrep) = ref_nash(1:nIrrep)
    NRS1(1:nIrrep) = ref_NRS1(1:nIrrep)
    NRS2(1:nIrrep) = ref_NRS2(1:nIrrep)
    NRS3(1:nIrrep) = ref_NRS3(1:nIrrep)
    NOSH(1:nIrrep) = NISH(1:nIrrep)+NASH(1:nIrrep)
    NDEL(1:nIrrep) = 0
    NSSH(1:nIrrep) = NBASF(1:nIrrep)-NFRO(1:nIrrep)-NISH(1:nIrrep)-NASH(1:nIrrep)-NDEL(1:nIrrep)
  else
    ! subsequent wavefunction file, check against global variables
    if ((ref_nhole1 /= nhole1(1)) .or. (ref_nelec3 /= nele3(1))) then
      call WarningMessage(2,'inconsistent RAS holes/electrons')
      call Quit_OnUserError()
    end if
    do i=1,nIrrep
      if ((ref_nfro(i)+ref_nish(i) /= nish(i)) .or. (ref_nash(i) /= nash(i)) .or. (ref_nrs1(i) /= nrs1(i)) .or. &
          (ref_nrs2(i) /= nrs2(i)) .or. (ref_nrs3(i) /= nrs3(i))) then
        call WarningMessage(2,'inconsistent orbital partitioning')
        call Quit_OnUserError()
      end if
    end do
  end if

  WFTYPE = 'GENERAL'
  if (ref_nactel == 2*sum(NASH(1:nIrrep))) WFTYPE = 'CLOSED'
  if (ref_nactel == 0) WFTYPE = 'EMPTY'
  RASTYP(JOB) = WFTYPE

  if (IPGLOB >= 2) then
    write(u6,'(A,I9)') '  STATE IRREP:        ',IRREP(JOB)
    write(u6,'(A,I9)') '  SPIN MULTIPLICITY:  ',MLTPLT(JOB)
    write(u6,'(A,I9)') '  ACTIVE ELECTRONS:   ',NACTE(JOB)
#   ifdef _DMRG_
    if (.not. doDMRG) then
#   endif
      write(u6,'(A,I9)') '  MAX RAS1 HOLES:     ',NHOLE1(JOB)
      write(u6,'(A,I9)') '  MAX RAS3 ELECTRONS: ',NELE3(JOB)
      write(u6,'(A,I9)') '  NR OF CONFIG:       ',NCONF(JOB)
#   ifdef _DMRG_
    end if
#   endif
  end if
  if (IPGLOB >= 3) write(u6,*) '  Wave function type WFTYPE=',WFTYPE

  call mma_deallocate(ref_rootid)
  call mh5_close_file(refwfn_id)

else
#endif
  !*********************************************************************
  !
  ! For JOBIPH/JOBMIX formatted job files
  !
  !*********************************************************************
# ifdef _DMRG_
  if (doDMRG) then
    call WarningMessage(3,'QCMaquis requires checkpoint names from JOBxxx. This works only with HDF5 JobIph files. Please make '// &
                        'sure you use a .h5 file as JOBxxx.')
    call abend()
  end if
# endif
  if (IPGLOB >= 2) then
    if (JOB == 1) then
      write(u6,*)
      write(u6,'(6X,A)') repeat('*',80)
      write(u6,'(6X,A1,78X,A1)') '*','*'
      write(u6,'(6X,A1,24X,A,24X,A1)') '*','     General data section     ','*'
      write(u6,'(6X,A1,78X,A1)') '*','*'
      write(u6,'(6X,A)') repeat('*',80)
    end if
    write(u6,*)
    write(u6,*) '  Specific data for JOBIPH file ',trim(JBNAME(JOB))
    write(u6,*) '  -------------------------------------'
  end if
  ! Open JOBIPH file:
  call DANAME(LUIPH,JBNAME(JOB))
  ! READ TABLE OF CONTENTS ON THIS JOBIPH FILE:
  IAD = 0
  call IDAFILE(LUIPH,2,ITOC15,30,IAD)
  ! SCATTER-READ VARIOUS DATA:
  ! PAM Mar2014: Note that ENUC1 (=POTNUC) replaced by dummy placeholder
  IAD = ITOC15(1)
  call mma_allocate(Weight,MxRoot,Label='Weight')
  call WR_RASSCF_Info(LUIPH,2,IAD,NACTE1,MPLET1,NSYM1,LSYM1,NFRO1,NISH1,NASH1,NDEL1,NBAS1,mxSym,bNAME,(LenIn+8)*mxOrb,NCONF1, &
                      HEAD1,2*72,TITLE1,4*mxTit*18,ENUCDUMMY,LROT1,NROOT1,IROOT1,mxRoot,NRS11,NRS21,NRS31,NHOL11,NELE31,IPT2,Weight)
  call mma_deallocate(Weight)
  ! Response field contribution to zero-electron energies
  ! is added in GETH1.
  if (READ_STATES) then
    ! Do not update the state number here, because it's already read in
    ! rdjob_nstates()
    !ISTAT(JOB) = NSTATE+1
    !NSTAT(JOB) = NROOT1
    !NSTATE = NSTATE+NROOT1
    ! store the root IDs of each state

    ! If unset yet, set now
    if (LROOT(ISTAT(JOB)) == 0) then
      LROOT(ISTAT(JOB):ISTAT(JOB)+NSTAT(JOB)-1) = IROOT1(1:NSTAT(JOB))
      JBNUM(ISTAT(JOB):ISTAT(JOB)+NSTAT(JOB)-1) = JOB
    end if
  end if
  do I=0,NSTAT(JOB)-1
    NROOT0 = LROOT(ISTAT(JOB)+I)
    if (NROOT0 > LROT1) call Error(2)
  end do

  ! First read energies, which may be used in any case
  NEJOB = MXROOT*MXITER
  call mma_allocate(EJOB,NEJOB,Label='EJOB')
  IAD = ITOC15(6)
  call DDAFILE(LUIPH,2,EJOB,NEJOB,IAD)
  ! Note that there is no info on nr of iterations
  ! so we cannot know what energies to pick...
  ! Let us make a guess: The correct set of energy values in the
  ! table of energies/iteration is the last one with not all zeroes.
  NMAYBE = 0
  do IT=1,MXITER
    if (maxval(abs(EJOB(MXROOT*(IT-1)+1:MXROOT*IT)))  <= 1.0e-12_wp) exit
    NMAYBE = IT
  end do
  call mma_allocate(EREAD,NSTATE,Label='EREAD')
  do I=1,NSTAT(JOB)
    ISTATE = ISTAT(JOB)-1+I
#   ifdef _DMRG_
    if (doDMRG) then
      E = EJOB(LROOT(ISTATE)-ISTAT(JOB)+1+MXROOT*(NMAYBE-1))
    else
#   endif
      E = EJOB(LROOT(ISTATE)+MXROOT*(NMAYBE-1))
#   ifdef _DMRG_
    end if
#   endif
    EREAD(istate) = E
  end do
  call mma_deallocate(EJOB)

  ! Using energy data from JobIph?
  if (IFEJOB) then
    if (ITOC15(15) == -1) HAVE_HEFF = .true.
    if (NMAYBE == 0) then
      write(u6,*) " Sorry. Keyword 'EJOB' has been used"
      write(u6,*) ' but there are no energies available on'
      write(u6,*) ' the JOBIPH file nr',JOB
      call ABEND()
    end if
    HAVE_DIAG = .true.
    ! Put the energies into diagonal of Hamiltonian:
    do I=1,NSTAT(JOB)
      ISTATE = ISTAT(JOB)-1+I
      REFENE(istate) = EREAD(istate)
    end do
  end if

  ! Using effective Hamiltonian from JobIph file?
  if (IFHEFF) then
    if (ITOC15(15) /= -1) then
      write(u6,*) 'RDJOB Error: HEFF not found on JOBIPH.'
      write(u6,*) 'The HEFF keyword was used, but the JOBIPH file'
      write(u6,*) 'uses an old layout where this data field is'
      write(u6,*) 'not present. Recompute JOBIPH file, or put'
      write(u6,*) 'effective Hamiltonian in input after keyword'
      write(u6,*) 'HEXT. Program stops here.'
      call ABEND()
    end if
    HAVE_HEFF = .true.
    NHEFF = LROT1**2
    call mma_allocate(H_EFF,NHEFF,Label='H_Eff')
    IAD15 = ITOC15(17)
    call DDAFILE(LUIPH,2,H_EFF,NHEFF,IAD15)
    ! If both EJOB and HEFF are given, read only the diagonal
    if (IFEJOB) then
      HAVE_DIAG = .true.
      do I=1,NSTAT(JOB)
        ISTATE = ISTAT(JOB)-1+I
        ISNUM = LROOT(ISTATE)
        HIJ = H_EFF(LROOT(ISTATE)+LROT1*(ISNUM-1))
        REFENE(istate) = HIJ
        HEff(iState,iState) = HIJ
      end do
    else
      do I=1,NSTAT(JOB)
        ISTATE = ISTAT(JOB)-1+I
        ISNUM = LROOT(ISTATE)
        ISZERO = .true.
        do J=1,NSTAT(JOB)
          JSTATE = ISTAT(JOB)-1+J
          JSNUM = LROOT(JSTATE)
          HIJ = H_EFF(ISNUM+LROT1*(JSNUM-1))
          HEff(jState,iState) = HIJ
          if (I == J) REFENE(istate) = HIJ
          if (abs(HIJ) > Zero) ISZERO = .false.
        end do
        if (ISZERO) then
          Heff(iState,iState) = EREAD(istate)
        end if
      end do
    end if
    call mma_deallocate(H_Eff)
  end if
  call mma_deallocate(EREAD)
  ! Read the level to orbital translations
  IDISK = ITOC15(18)
  call IDAFILE(LUIPH,0,IDUM,MXLEV,IDISK) ! L2ACT
  call IDAFILE(LUIPH,2,LEVEL,MXLEV,IDISK)
  ! Close JobIph file
  call DACLOS(LUIPH)

  ! The RASSCF program is not certain to give consistent data. For
  ! pure CASSCF cases, it may not bother to set the NRS1..NRS3 arrays.
  ! Check and repair:
  if (NHOL11+NELE31 == 0) then
    if (any(NRS11(1:NSYM1) /= 0) .or. any(NRS21(1:NSYM1) /= NASH1(1:NSYM1)) .or. any(NRS31(1:NSYM1) /= 0)) then
      write(u6,*)
      write(u6,*) ' (NOTE: The nr of RAS1, RAS2 and RAS3 orbitals as recorded on the JOBIPH file do not match'
      write(u6,*) ' the number of active orbitals. But this is a pure CASSCF case. Maybe the RASSCF programmer did'
      write(u6,*) ' not bother with the RAS1..RAS3 arrays in that case. RASSI will reset these arrays as needed.)'
      write(u6,*)
      NRS11(1:NSYM1) = 0
      NRS21(1:NSYM1) = NASH1(NSYM1)
      NRS31(1:NSYM1) = 0
    end if
  end if

  if (JOB == 1) then
    ! FIRST JOB FILE. TRANSFER DATA TO COMMON:
    nIrrep = NSYM1
    NFRO(1:nIrrep) = 0
    NISH(1:nIrrep) = NFRO1(1:nIrrep)+NISH1(1:nIrrep)
    NASH(1:nIrrep) = NASH1(1:nIrrep)
    NRS1(1:nIrrep) = NRS11(1:nIrrep)
    NRS2(1:nIrrep) = NRS21(1:nIrrep)
    NRS3(1:nIrrep) = NRS31(1:nIrrep)
    NOSH(1:nIrrep) = NISH(1:nIrrep)+NASH(1:nIrrep)
    NDEL(1:nIrrep) = 0
    NBASF(1:nIrrep) = NBAS1(1:nIrrep)
    NSSH(1:nIrrep) = NBASF(1:nIrrep)-NFRO(1:nIrrep)-NISH(1:nIrrep)-NASH(1:nIrrep)-NDEL(1:nIrrep)
  else
    ! THIS IS NOT THE FIRST JOBIPH.
    ! CHECK THAT DATA IS CONSISTENT WITH EARLIER:
    if (NSYM1 /= nIrrep) call Error(1)
    if ((NHOL11 /= NHOLE1(JOB-1)) .or. (NELE31 /= NELE3(JOB-1))) call Error(3)
    do ISY=1,NSYM1
      NIS1 = NISH1(ISY)+NFRO1(ISY)
      NIS = NISH(ISY)
      if (NIS1 /= NIS) call Error(4)
      if ((NRS11(ISY) /= NRS1(ISY)) .or. (NRS21(ISY) /= NRS2(ISY)) .or. (NRS31(ISY) /= NRS3(ISY))) call Error(5)
      if (NBAS1(ISY) /= NBASF(ISY)) call Error(6)
    end do
  end if

  ! DATA PARTICULAR TO THIS JOBIPH:
  if (IPGLOB >= 2) then
    write(u6,*)
    write(u6,*) '  Header from SEWARD:'
    write(u6,'(7X,36A2)') (HEAD1(I),I=1,36)
    write(u6,'(7X,36A2)') (HEAD1(I),I=37,72)
    ! NOTE: AT PRESENT, JOBIPH FILE GIVES NO INFORMATION ON THE
    ! AMOUNT OF TITLE LINES.
    NTIT1 = 1
    write(u6,*)
    write(u6,*) '  CASSCF title (first line only):'
    write(u6,'(7X,18A4)') ((TITLE1(I,J),I=1,18),J=1,NTIT1)
    write(u6,*)
    write(u6,'(A,I9)') '  STATE IRREP:        ',LSYM1
    write(u6,'(A,I9)') '  SPIN MULTIPLICITY:  ',MPLET1
    write(u6,'(A,I9)') '  ACTIVE ELECTRONS:   ',NACTE1
    write(u6,'(A,I9)') '  MAX RAS1 HOLES:     ',NHOL11
    write(u6,'(A,I9)') '  MAX RAS3 ELECTRONS: ',NELE31
    write(u6,'(A,I9)') '  NR OF CONFIG:       ',NCONF1
  end if
  WFTYPE = 'GENERAL'
  !if (MPLET1 == (SUM(NASH(1:nIrrep))+1)) WFTYPE = 'HISPIN'
  ! Note: the HISPIN case may be buggy and is not used presently.
  if (MPLET1 == (sum(NASH(1:nIrrep))+1)) then
    write(u6,*) ' This wave function is of HISPIN type.'
    write(u6,*) ' However, the special handling for that case'
    write(u6,*) ' is suspected to be buggy. So the variable'
    write(u6,*) ' WFTYPE is set to GENERAL.'
  end if
  if (NACTE1 == 2*sum(NASH(1:nIrrep))) WFTYPE = 'CLOSED'
  if (NACTE1 == 0) WFTYPE = 'EMPTY'
  RASTYP(JOB) = WFTYPE
  if (IPGLOB >= 3) write(u6,*) '  Wave function type WFTYPE=',WFTYPE
  NACTE(JOB) = NACTE1
  MLTPLT(JOB) = MPLET1
  IRREP(JOB) = LSYM1
  NHOLE1(JOB) = NHOL11
  NELE3(JOB) = NELE31
  NCONF(JOB) = NCONF1
  ! Where is the CMO data set stored?
  IDCMO(JOB) = ITOC15(2)
  if (IPT2 /= 0) IDCMO(JOB) = ITOC15(9)

#ifdef _HDF5_
end if
#endif

call XFLUSH(u6)

contains

!***********************************************************************
!
! Error exits
!
!***********************************************************************
subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  select case (code)
    case (1)
      write(u6,*) ' SYMMETRY GROUPS MUST BE EQUAL.'
      write(u6,*) ' NSYM1:',NSYM1,'NSYM :',nIrrep
    case (2)
      write(u6,*) ' ROOT NOT AVAILABLE.'
      write(u6,*) '             REQUESTED ROOT:',NROOT0
      write(u6,*) '  MAXIMUM ROOT IN THIS FILE:',LROT1
    case (3)
      write(u6,*) ' RAS SPECIFICATIONS DIFFER.'
      write(u6,*) '     THIS STATE: MAX NR OF RAS-1 HOLES:',NHOL11
      write(u6,*) '             MAX NR OF RAS-3 ELECTRONS:',NELE31
      write(u6,*) ' PREVIOUS STATE: MAX NR OF RAS-1 HOLES:',NHOLE1(JOB-1)
      write(u6,*) '             MAX NR OF RAS-3 ELECTRONS:',NELE3(JOB-1)
    case (4)
      write(u6,*) ' NR. OF (FROZEN+INACTIVE) ORBITALS DIFFER.'
      write(u6,'(A,8I4)') ' THIS STATE:',NFRO1(1:NSYM1)+NISH1(1:NSYM1)
      write(u6,'(A,8I4)') '   PREVIOUS:',NISH(1:nIrrep)
    case (5)
      write(u6,*) ' NR. OF ACTIVE ORBITALS DIFFER.'
      write(u6,'(A,8I4)') ' THIS STATE, ACTIVE:',NASH1(1:NSYM1)
      write(u6,'(A,8I4)') '               RAS1:',NRS11(1:NSYM1)
      write(u6,'(A,8I4)') '               RAS2:',NRS21(1:NSYM1)
      write(u6,'(A,8I4)') '               RAS3:',NRS31(1:NSYM1)
      write(u6,'(A,8I4)') '   PREVIOUS, ACTIVE:',NASH(1:nIrrep)
      write(u6,'(A,8I4)') '               RAS1:',NRS1(1:NSYM1)
      write(u6,'(A,8I4)') '               RAS2:',NRS2(1:NSYM1)
      write(u6,'(A,8I4)') '               RAS3:',NRS3(1:NSYM1)
    case (6)
      write(u6,*) ' NR. OF BASIS FUNCTION DIFFER.'
      write(u6,'(A,8I4)') ' THIS JOBIPH:',NBAS1(1:NSYM1)
      write(u6,'(A,8I4)') '    PREVIOUS:',NBASF(1:nIrrep)
  end select
  write(u6,*) ' DATA IN JOBIPH FILE NAMED ',trim(JBNAME(JOB)),' WERE'
  write(u6,*) ' INCONSISTENT WITH EARLIER DATA. PROGRAM STOPS.'
  write(u6,*)
  write(u6,*) ' Errors occured in RASSI/RDJOB.'
  call ABEND()

end subroutine

end subroutine RDJOB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

function IrrFnc(iFnc)

use Symmetry_Info, only: iOper, nIrrep
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IrrFnc
integer(kind=iwp), intent(in) :: iFnc
integer(kind=iwp) :: i, iCh, iTest(8)
logical(kind=iwp) :: ix, iy, iz, jx, jy, jz
integer(kind=iwp), external :: iNew

ix = btest(iFnc,0)
iy = btest(iFnc,1)
iz = btest(iFnc,2)
do i=1,nIrrep
  jx = btest(iOper(i-1),0)
  jy = btest(iOper(i-1),1)
  jz = btest(iOper(i-1),2)
  iCh = 1
  if (ix .and. jx) iCh = -iCh
  if (iy .and. jy) iCh = -iCh
  if (iz .and. jz) iCh = -iCh
  iTest(i) = iCh
end do
IrrFnc = iNew(iTest,nIrrep)-1

return

end function IrrFnc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2006, Markus Reiher                               *
************************************************************************
      subroutine sort_op1 (dkhorder,opcounter,operleng,oporder,
     *                     evenodd,doperators,operators)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.3
c
c   last modified: 19.10.2006 (MR, ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,opcounter,operleng(maxoperators),
     *        oporder(maxoperators,3),evenodd(maxoperators),
     *        opcounter2
      REAL*8 doperators(maxoperators)
#if defined(_MOLCAS_) || defined(MOLPRO)
#include "WrkSpc.fh"
      integer operleng2,oporder2,evenodd2,doperators2,operators2
      integer intrea,nwop,lwop
      character operators(*)
#else
      integer operleng2(maxoperators),oporder2(maxoperators,3),
     *        evenodd2(maxoperators)
Cfrueher_benutzt      common/cdkhops2/ operators2
c:      character*(maxlength) operators(maxoperators),operators2(maxoperators)
      REAL*8 doperators2(maxoperators)
#endif

      integer j,k,l
#if defined(_MOLCAS_) || defined(MOLPRO)
      lwop=8/intrea()
      nwop=(maxlength-1)/lwop+1
      call getmem('doperators2','Allo','Real',doperators2,maxoperators)
      call getmem('operators2','Allo','Inte',operators2,
     >             maxoperators*nwop)
      call getmem('operleng2','Allo','Inte',operleng2,maxoperators)
      call getmem('oporder2','Allo','Inte',oporder2,maxoperators*3)
      call getmem('evenodd2','Allo','Inte',evenodd2,maxoperators)
c
      opcounter2=0
      do j=0,dkhorder
       do k=0,dkhorder
        do l=1,opcounter
          if (oporder(l,3).eq.j .and. oporder(l,2).eq.k) then
            iwork(operleng2+opcounter2)=operleng(l)
            iwork(oporder2+opcounter2)=oporder(l,1)
            iwork(oporder2+maxoperators+opcounter2)=oporder(l,2)
            iwork(oporder2+2*maxoperators+opcounter2)=oporder(l,3)
            iwork(evenodd2+opcounter2)=evenodd(l)
            work(doperators2+opcounter2)=doperators(l)
            opcounter2=opcounter2+1
            call copy_dkoperators_ci(l,operators,
     *             opcounter2,iwork(operators2))
          endif
        end do
       end do
      end do
#else
        do 120 j=1,opcounter
          operleng2(j)=0
          do 121 k=1,3
            oporder2(j,k)=0
 121      continue
          evenodd2(j)=0
          doperators2(j)=0.0d0
          do 130 k=1,operleng2(j)
            operators2(j)(k:k)=' '
 130      continue
 120    continue
c
c       Write operators in ascending order in V(X) to operators2
c
        opcounter2=0
        do 350 j=0,dkhorder
         do 351 k=0,dkhorder
          do 360 l=1,opcounter
            if (oporder(l,3).eq.j .and. oporder(l,2).eq.k) then
              opcounter2=opcounter2+1
              operleng2(opcounter2)=operleng(l)
              oporder2(opcounter2,1)=oporder(l,1)
              oporder2(opcounter2,2)=oporder(l,2)
              oporder2(opcounter2,3)=oporder(l,3)
              evenodd2(opcounter2)=evenodd(l)
              doperators2(opcounter2)=doperators(l)
              operators2(opcounter2)=operators(l)
            endif
 360      continue
 351     continue
 350    continue
#endif
      if (opcounter2.ne.opcounter) then
        write (stdout,1043) opcounter2,opcounter
1043    format (/2X,'ERROR in sort_op1: opcounter2 = ',I8,
     *          ' not equal to opcounter = ',I8,'.',//2X,'STOP.',/)
            CALL Abend
      endif
#if defined(_MOLCAS_) || defined(MOLPRO)
      do l=1,opcounter
        operleng(l)=iwork(operleng2-1+l)
        oporder(l,1)=iwork(oporder2-1+l)
        oporder(l,2)=iwork(oporder2-1+l+maxoperators)
        oporder(l,3)=iwork(oporder2-1+l+maxoperators*2)
        evenodd(l)=iwork(evenodd2-1+l)
        doperators(l)=work(doperators2-1+l)
        call copy_dkoperators_ic(l,iwork(operators2),l,operators)
      end do
      call getmem('evenodd2','Free','Inte',evenodd2,maxoperators)
      call getmem('oporder2','Free','Inte',oporder2,maxoperators*3)
      call getmem('operleng2','Free','Inte',operleng2,maxoperators)
      call getmem('operators2','Free','Inte',operators2,
     >             maxoperators*nwop)
      call getmem('doperators2','Free','Real',doperators2,maxoperators)
#else
      do 361 l=1,opcounter
        operleng(l)=operleng2(l)
        oporder(l,1)=oporder2(l,1)
        oporder(l,2)=oporder2(l,2)
        oporder(l,3)=oporder2(l,3)
        evenodd(l)=evenodd2(l)
        doperators(l)=doperators2(l)
        operators(l)=operators2(l)
 361  continue
#endif
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Init_SCF()

use InfSCF, only: Dens, MapDns, Two_Thresholds, TwoHam, Vxc
use RICD_Info, only: Do_DCCD
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, nActEl

! Clear Dens and TwoHam matrices
Dens(:,:,:) = Zero
TwoHam(:,:,:) = Zero
Vxc(:,:,:) = Zero

! Set number of active shells on the RUNFILE to zero

call Peek_iScalar('nSym',i)
nActEl = 0
call Put_iScalar('nActel',nActEl)

call IniLLs()
! clear MapDns ...
MapDns(:) = 0

Two_Thresholds = .not. Do_DCCD

return

end subroutine Init_SCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine two2mean12b(carteSO,carteOO,occup,AOcoeffs,onecart,ncontmf,norbsum,noccorb,sameorb)

use AMFI_global, only: MxcontL
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ncontmf, norbsum, noccorb
real(kind=wp), intent(in) :: carteSO(ncontmf,norbsum,ncontmf,norbsum), carteOO(ncontmf,norbsum,ncontmf,norbsum), occup(*), &
                             AOcoeffs(MxcontL,*)
real(kind=wp), intent(inout) :: onecart(MxcontL,MxcontL)
logical(kind=iwp), intent(in) :: sameorb
integer(kind=iwp) :: icartleft, icartright, jrun, Mrun
real(kind=wp) :: coeff

if (sameorb) then
  do icartleft=1,norbsum
    do icartright=1,norbsum
      coeff = Zero
      do Mrun=1,noccorb
        coeff = coeff+occup(Mrun)*AOcoeffs(icartleft,Mrun)*AOcoeffs(icartright,Mrun)
      end do
      coeff = Half*coeff
      do jrun=1,ncontmf
        onecart(1:ncontmf,jrun) = onecart(1:ncontmf,jrun)+coeff*carteSO(jrun,icartleft,1:ncontmf,icartright)
      end do
    end do
  end do
else
  do icartleft=1,norbsum
    do icartright=1,norbsum
      coeff = Zero
      do Mrun=1,noccorb
        coeff = coeff+occup(Mrun)*AOcoeffs(icartleft,Mrun)*AOcoeffs(icartright,Mrun)
      end do
      coeff = Half*coeff
      do jrun=1,ncontmf
        onecart(1:ncontmf,jrun) = onecart(1:ncontmf,jrun)+ &
                                  coeff*(carteSO(jrun,icartleft,1:ncontmf,icartright)+ &
                                         Two*carteOO(jrun,icartleft,1:ncontmf,icartright))
      end do
    end do
  end do
end if

return

end subroutine two2mean12b

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICEnSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Oskar Weser                                      *
************************************************************************
#include "intent.h"
      module orthonormalization
        use definitions, only: wp
        use stdalloc, only : mma_allocate, mma_deallocate
        use fortran_strings, only : to_upper, str
        use blockdiagonal_matrices, only : t_blockdiagonal, new, delete,
     &    from_raw, to_raw, from_symm_raw, blocksizes
        use linalg_mod, only: mult, norm, dot_product_,
     &      Gram_Schmidt, Lowdin, Canonical

        implicit none
        save
        private
        public ::
     &    t_ON_scheme, ON_scheme, ON_scheme_values, orthonormalize

! TODO: Should be changed to default construction in the future.
! As of July 2019 the Sun and PGI compiler have problems.
        type :: t_ON_scheme_values
          integer :: no_ON, Gram_Schmidt, Lowdin, Canonical
        end type
        type(t_ON_scheme_values), parameter ::
! TODO: Dear fellow MOLCAS developer of the future:
! Please replace the following explicit constructur
! with the default constructor
!     instance = type()
! as soon as possible.
! As of July 2019 the Sun compiler requires explicit construction
! for parameter variables. (Which is wrong IMHO.)
     &    ON_scheme_values =
     &    t_ON_scheme_values(no_ON = 1, Gram_Schmidt = 2,
     &                       Lowdin = 3, Canonical = 4)

        type :: t_ON_scheme
          integer :: val = ON_scheme_values%Gram_Schmidt
        end type
        type(t_ON_scheme) :: ON_scheme = t_ON_scheme()


!>  @brief
!>    Orthonormalize a basis.
!>
!>  @author
!>    Oskar Weser
!>
!>  @details
!>  Reads in the overlap matrix and orthonormalizes accordingly.
!>
!>  @param[in] basis Can be raw memory i.e. a 1D double array
!>    or a t_blockdiagonal matrix.
!>    return type depends on input type.
!>  @param[in] scheme Optional argument. The orthonormalization scheme to use.
!>    The possibilities are Gram_Schmidt, Lowdin, Canonical, or no_ON
!>    (no_orthonormalization)
!>    as given by orthonormalization::ON_scheme_values.
!>    For a detailed explanation see \cite szabo_ostlund (p. 143).
        interface orthonormalize
          module procedure orthonormalize_raw, orthonormalize_blocks
        end interface

      contains

      subroutine orthonormalize_blocks(basis, scheme, ONB)
        use general_data, only : nSym, nBAs, nDel, nDelt, nSSH, nOrb
        use rasscf_data, only : nSec, nOrbt, nTot3, nTot4
        type(t_blockdiagonal), intent(in) :: basis(:)
        type(t_ON_scheme), intent(in) :: scheme
        type(t_blockdiagonal), intent(_OUT_) :: ONB(:)

        type(t_blockdiagonal), allocatable :: S(:)

        integer :: n_to_ON(nSym), n_new(nSym)

! gfortran -O0 warning bug
        allocate(S(0))
        call new(S, blocksizes=blocksizes(basis))
        call read_S(S)

        select case (scheme%val)
          case(ON_scheme_values%no_ON)
            continue
          case(ON_scheme_values%Lowdin)
            call Lowdin_Blocks(basis, S, ONB)
          case(ON_scheme_values%Canonical)
            n_to_ON(:) = nBas(:nSym) - nDel(:nSym)
            call Canonical_Blocks(basis, S, n_to_ON, ONB, n_new)
            call update_orb_numbers(n_to_ON, n_new,
     &          nDel, nSSH, nOrb, nDelt, nSec, nOrbt, nTot3, nTot4)
          case(ON_scheme_values%Gram_Schmidt)
            n_to_ON(:) = nBas(:nSym) - nDel(:nSym)
            call Gram_Schmidt_Blocks(basis, S, n_to_ON, ONB, n_new)
            call update_orb_numbers(n_to_ON, n_new,
     &          nDel, nSSH, nOrb, nDelt, nSec, nOrbt, nTot3, nTot4)
        end select

        call delete(S)
      end subroutine orthonormalize_blocks

      subroutine orthonormalize_raw(CMO, scheme, ONB_v)
        use general_data, only : nBas, nSym
        real(wp), intent(in) :: CMO(:)
        type(t_ON_scheme), intent(in) :: scheme
        real(wp), intent(out) :: ONB_v(:)

        type(t_blockdiagonal), allocatable :: basis(:), ONB(:)

! gfortran -O0 warning bug
        allocate(basis(0))
        call new(basis, blocksizes=nBAS(:nSym))
        call new(ONB, blocksizes=nBAS(:nSym))

        call from_raw(CMO, basis)
        call orthonormalize(basis, scheme, ONB)
        call to_raw(ONB, ONB_v)

        call delete(ONB)
        call delete(basis)
      end subroutine

! TODO: It would be nice, to use `impure elemental`
! instead of the manual looping.
! As of July 2019 some compilers don't support it.
      subroutine Lowdin_Blocks(basis, S, ONB)
        type(t_blockdiagonal), intent(in) :: basis(:), S(:)
        type(t_blockdiagonal), intent(_OUT_) :: ONB(:)

        integer :: i

        do i = 1, size(basis)
          call Lowdin(basis(i)%block, ONB(i)%block, S(i)%block)
        end do
      end subroutine Lowdin_Blocks




! TODO: It would be nice, to use `impure elemental`
! instead of the manual looping.
! As of July 2019 some compilers don't support it.
      subroutine Canonical_Blocks(basis, S, n_to_ON, ONB, n_new)
        type(t_blockdiagonal), intent(in) :: basis(:), S(:)
        integer, intent(in) :: n_to_ON(:)
        type(t_blockdiagonal), intent(_OUT_) :: ONB(:)
        integer, intent(out) :: n_new(:)

        integer :: i

        do i = 1, size(basis)
          call Canonical(basis(i)%block, n_to_ON(i),
     &                   ONB(i)%block, n_new(i), S(i)%block)
        end do
      end subroutine Canonical_Blocks



! TODO: It would be nice, to use `impure elemental`
! instead of the manual overloading.
! As of July 2019 some compilers don't support it.
      subroutine Gram_Schmidt_Blocks(basis, S, n_to_ON, ONB, n_new)
        type(t_blockdiagonal), intent(in) :: basis(:), S(:)
        integer, intent(in) :: n_to_ON(:)
        type(t_blockdiagonal), intent(_OUT_) :: ONB(:)
        integer, intent(out) :: n_new(:)

        integer :: i

        do i = 1, size(basis)
          call Gram_Schmidt(basis(i)%block, n_to_ON(i), ONB(i)%block,
     &                      n_new(i), S(i)%block)
        end do
      end subroutine Gram_Schmidt_Blocks



      subroutine update_orb_numbers(
     &    n_to_ON, nNew,
     &    nDel, nSSH, nOrb, nDelt, nSec, nOrbt, nTot3, nTot4)
      use general_data, only : nSym
#include "warnings.fh"
#include "output_ras.fh"
      integer, intent(in) :: n_to_ON(:), nNew(:)
      integer, intent(inout) :: nDel(:), nSSH(:), nOrb(:),
     &  nDelt, nSec, nOrbt, nTot3, nTot4
      parameter(ROUTINE='update_orb_numbe')

      integer :: iSym, remove(nSym), total_remove


      remove = n_to_ON(:nSym) - nNew(:nSym)
      total_remove = sum(remove(:nSym))
      if (total_remove > 0) then
        do iSym = 1, nSym
          if (nSSH(iSym) < remove(iSym)) then
            call WarningMessage(2,'Orthonormalization Error')
            Write(LF,*) 'Exact or very near linear dependence '
            Write(LF,*) 'forces RASSCF to stop execution.'
            Write(LF,*) 'Symmetry block:', iSym
            Write(LF,*) 'Effective NR of orthonormal orbs:', nNew(iSym)
            Write(LF,*) 'Earlier number of deleted orbs:', nDel(iSym)
            Write(LF,*) 'Earlier number of secondary orbs:', nSSH(iSym)
            Write(LF,*) 'New number of deleted orbs:',
     &                  nDel(iSym) + remove(iSym)
            Write(LF,*) 'New number of secondary orbs:',
     &                  nSSH(iSym) - remove(iSym)
            call quit(_RC_GENERAL_ERROR_)
          else if (iPRLoc(1) >= usual) then
            call WarningMessage(1,'Orthonormalization Warning')
            Write(LF,*) 'Exact or very near linear dependence'
            Write(LF,*) 'forces RASSCF to delete additional orbitals.'
            Write(LF,*) 'Symmetry block:', iSym
            Write(LF,*) 'Earlier number of deleted orbs =', nDel(iSym)
            Write(LF,*) 'New number of deleted orbs =',
     &                  nDel(iSym) + remove(iSym)
          end if
        end do
        nDel(:nSym) = nDel(:nSym) + remove(:nSym)
        nSSH(:nSym) = nSSH(:nSym) - remove(:nSym)
        nOrb(:nSym) = nOrb(:nSym) - remove(:nSym)
        nDelt = nDelt + total_remove
        nSec = nSec - total_remove
        nOrbt = nOrbt - total_remove
        nTot3 = sum((nOrb(:nSym) + nOrb(:nSym)**2) / 2)
        nTot4 = sum(nOrb(:nSym)**2)
      end if
      end subroutine update_orb_numbers


      subroutine read_raw_S(S_buffer)
        real(wp), intent(inout) :: S_buffer(:)
        integer :: i_Rc, i_Opt, i_Component, i_SymLbl
#include "warnings.fh"

        i_Rc = 0
        i_Opt = 2
        i_Component = 1
        i_SymLbl = 1
        Call RdOne(i_Rc, i_Opt, 'Mltpl  0', i_Component,
     &             S_buffer, i_SymLbl)
        if ( i_rc /= 0 ) then
          write(6,*)' RASSCF is trying to orthonormalize orbitals but'
          write(6,*)' could not read overlaps from ONEINT. Something'
          write(6,*)' is wrong with the file, or possibly with the'
          write(6,*)' program. Please check.'
          call quit(_RC_IO_ERROR_READ_)
        end if
      end subroutine


      subroutine read_S(S)
        use general_data, only : nBas, nSym, nActEl
        use rasscf_data, only : nFr, nIn, Tot_Nuc_Charge
#include "warnings.fh"
#include "output_ras.fh"
        type(t_blockdiagonal) :: S(nSym)

        parameter(ROUTINE='update_orb_numbe')
        integer :: size_S_buffer
        real(wp) :: Mol_Charge
        real(wp), allocatable :: S_buffer(:)


        size_S_buffer = sum(nBas(:nSym) * (nBas(:nSym) + 1) / 2)
        call mma_allocate(S_buffer, size_S_buffer + 4)
        call read_raw_S(S_buffer)
        Tot_Nuc_Charge = S_buffer(size_S_buffer + 4)
        call from_symm_raw(S_buffer, S)
        call mma_deallocate(S_buffer)

        Mol_Charge = Tot_Nuc_Charge - dble(2 * (nFr + nIn) + nActEl)
        call put_dscalar('Total Charge    ', Mol_Charge)
        if (IPRLOC(1) >= usual) then
          write(6,*)
          write(6,'(6x,A,f8.2)') 'Total molecular charge',Mol_Charge
        end if

      end subroutine

      end module orthonormalization

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_X_Init
!
!> @brief
!>   Initialize Cholesky vector information for external use.
!> @author Thomas Bondo Pedersen
!>
!> @details
!> This routine reads and processes the information
!> stored on the runfile/restart files by the Cholesky
!> decomposition utility.
!> This routine is also used for setting up the environment in
!> density fitting (DF or RI) runs.
!> Index arrays are allocated and initialized.
!> All information is stored in the module Cholesky
!>
!> \p BufFrac is the fraction of total available memory that will be
!> allocated as Cholesky vector buffer. For example, \p BufFrac = ``0.35``
!> implies that 35% of the total available memory (after the
!> allocations of this routine) will be allocated for Cholesky
!> vectors. The vectors will be read into the buffer as part of
!> the initialization. The reading routines can then be used as
!> usual; the buffer is automatically taken care of by the reading
!> routines. If \p BufFrac is less than or equal to zero, no buffer
!> will be used.
!>
!> Return codes:
!>
!> - \p irc = ``-2``: Local DF not implemented here
!> - \p irc = ``-1``: Cholesky flag not found on runfile
!> - \p irc =  ``0``: initialization success
!> - \p irc =  ``1``: runfile info corrupted
!> - \p irc =  ``2``: restart file info corrupted
!> - \p irc =  ``3``: inconsistent include file(s) detected (typically an internal error/bug)
!> - \p irc =  ``4``: error in parallel setup
!>
!> @note
!> The two-electron repulsion integrals must have been decomposed by Seward.
!>
!> @param[out] irc     Return code
!> @param[in]  BufFrac Fraction of memory to be used as buffer
!***********************************************************************

subroutine Cho_X_Init(irc,BufFrac)

use Index_Functions, only: nTri_Elem
use Para_Info, only: Is_Real_Par
use Cholesky, only: BkmThr, BkmVec, Cho_AdrVec, Cho_Fake_Par, Cho_IOVec, ChoIniCheck, Cho_Real_Par, iBas, iBasSh, iiBstRSh, &
                    iiBstRSh_Hidden, IndRed, IndRed_Hidden, IndRSh, IndRSh_Hidden, IPRINT, iRS2F, iShlSO, iSOShl, iSP2F, LuCho, &
                    LuMap, LuPri, LuRed, LuRst, MaxRed, MaxVec, mmBstRT, Mx2Sh, MxOrSh, MySP, N1_VecRd, N2_VecRd, n_MySP, nBas, &
                    nBasSh, nBasT, nBstSh, nCol_BkmThr, nCol_BkmVec, nDGM_call, nDimRS, nnBstRSh, nnBstRSh_Hidden, nnBstR, &
                    nnBstRT, nnShl, nnShl_SP, nnShl_Tot, nRow_BkmThr, nRow_BkmVec, nShell, nSym, nSys_call, NumCho, NumChT, &
                    RUN_EXTERNAL, RUN_MODE
use stdalloc, only: mma_allocate, mma_deallocate
#ifdef _DEBUGPRINT_
use stdalloc, only: mma_maxDBLE
#endif
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: BufFrac
integer(kind=iwp) :: ChoIsIni, iErr, ijShl, iLoc, iRed, iShl, iSym, jShl, l, Numij
real(kind=wp) :: Frac
logical(kind=iwp) :: DidCholesky, DoDummy, FirstCall = .true., isDF
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: is1CCD, l_Max
real(kind=wp) :: Byte
character(len=2) :: Unt
#endif
integer(kind=iwp), allocatable :: BkmDim(:)
character(len=*), parameter :: SecNam = 'Cho_X_Init'

#ifdef _DEBUGPRINT_
call mma_maxDBLE(l_Max)
call Cho_Word2Byte(l_Max,8,Byte,Unt)
write(u6,*) '>>>>> Available memory on entry to ',SecNam,': ',l_Max,' = ',Byte,Unt
#endif

! Check that this is a Cholesky run.
! ----------------------------------

call DecideOnCholesky(DidCholesky)
if (.not. DidCholesky) then
  call Finish_this(-1)
  return
end if

! Check if already initialized.
! -----------------------------

if (FirstCall) then ! it cannot be already done
  FirstCall = .false.
else ! might be already done
  call Get_iScalar('ChoIni',ChoIsIni)
  if (ChoIsIni == ChoIniCheck) then ! already done
    irc = 0
    call Finish_this(0)
    return
  end if
end if

! Check if this is density fitting (DF).
! --------------------------------------

call DecideOnDF(isDF)

! Define entries in Cholesky module.
! ----------------------------------

call Cho_X_SetInc(irc)
if (irc /= 0) then  ! include file inconsistency detected
  call Finish_this(3)
  return
end if

! Set parallel info (picked up from para_info).
! ---------------------------------------------

CHO_FAKE_PAR = .false.
Cho_Real_Par = Is_Real_Par() .and. (.not. CHO_FAKE_PAR)

! Define n_MySP.
! --------------

n_MySP = 0

! Set run mode to "external".
! ---------------------------

Run_Mode = Run_External

! Set output unit used by the decomposition core routines.
! --------------------------------------------------------

LuPri = u6

! Set print level to -5 (ensuring that Cho_X_Checkdiag will
! print information, if called). All other routines will be
! silent.
! ---------------------------------------------------------

iPrint = -5

! Get nSym: the number of irreps.
! -------------------------------

call Get_iScalar('nSym',nSym)
if ((nSym < 1) .or. (nSym > 8)) then
  write(u6,*) SecNam,': nSym out of bounds: ',nSym
  call Finish_this(1)
  return
end if

! Get Cho_AdrVec: addressing of vector files (1=WA, 2=DA).
! --------------------------------------------------------

call Get_iScalar('ChoVec Address',Cho_AdrVec)

! Open files with red. set and vector info.
! -----------------------------------------

LURED = 0
LUCHO(1:NSYM) = 0
LURST = 0
LUMAP = 0
call Cho_OpenVR(1,2)

! Set vector I/O model etc.
! -------------------------

Cho_IOVec = 3
N1_VecRd = 2
N2_VecRd = 3
nSys_Call = 0
nDGM_Call = 0

! Get info (derived) from the runfile.
! nBas  : #basis functions in each irrep
! iSOShl: shell index for each basis function (SO)
! NumCho: #Cholesky vectors in each irrep
! MaxVec: max. element in NumCho (used to allocate InfVec)
! --------------------------------------------------------

call Get_iArray('nBas',nBas,nSym)
iBas(1) = 0
nBasT = nBas(1)
do iSym=2,nSym
  iBas(iSym) = nBasT
  nBasT = nBasT+nBas(iSym)
end do
if (nBasT < 1) then
  write(u6,*) SecNam,': nBasT out of bounds: ',nBasT
  call Finish_this(1)
  return
end if
call mma_allocate(iSOShl,nBasT,Label='iSOShl')
call Get_iArray('ISOSHL',iSOShl,nBasT)

call Get_iArray('NumCho',NumCho,nSym)
NumChT = sum(NumCho(1:nSym))
MaxVec = NumCho(1)
do iSym=2,nSym
  MaxVec = max(MaxVec,NumCho(iSym))
end do

! Read Cholesky restart file. Allocate InfRed and InfVec.
! nShell: #shells
! nnShl_Tot : total #shell pairs
! nnShl : #shell pairs contributing in diagonal
! MaxRed: #reduced sets (used to allocate InfRed)
! InfRed: InfRed(i) is the disk address of reduced set i
! InfVec: InfVec(i,1,iSym) is the parent index of vector i in irrep
!                          iSym in first reduced set
!         InfVec(i,2,iSym) is the reduced set of this vector
!         InfVec(i,3,iSym) is the disk address for reading this
!                          vector
!         InfVec(i,4,iSym) is the WA disk address of this vector.
!         InfVec(i,5,iSym) in a parallel run is the global index
!                          of the i-th vector in iSym for this node
!                          (in serial: InfVec(i,5,iSym) = i)
! Note: InfVec(i,5,iSym) is treated in a quite dirty way here:
!   for DF:
!       not defined in serial, thus it will be defined by the call
!       to Cho_X_DefineInfVec_5.
!       defined in parallel (simply read from disk and not modified
!       by Cho_X_DefineInfVec_5).
!   for Cholesky:
!       not defined in serial, thus it will be defined by the call
!       to Cho_X_DefineInfVec_5.
!       not defined in parallel, thus it will be defined by the call
!       to Cho_X_DefineInfVec_5. It is later modified by
!       Cho_X_Init_Par.
! ------------------------------------------------------------------

ierr = 0
call Cho_X_RdRst(ierr)
if (ierr /= 0) then
  call Finish_this(2)
  return
end if
nnShl_Tot = nTri_Elem(nShell)
call Cho_X_DefineInfVec_5(isDF)

! nnShl_SP makes it possible to use function Cho_F2SP.
! (Stored in module Cholesky)
! ----------------------------------------------------

nnShl_SP = nnShl

! Allocate and initialize index arrays.
! -------------------------------------

call mma_allocate(iiBstRSh_Hidden,nSym,nnShl,3,Label='iiBstRSh_Hidden')
iiBstRSh => iiBstRSh_Hidden
call mma_allocate(nnBstRSh_Hidden,nSym,nnShl,3,Label='nnBstRSh_Hidden')
nnBstRSh => nnBstRSh_Hidden
call Cho_RstD_GetInd1()
mmBstRT = nnBstRT(1)

call mma_allocate(IndRed_Hidden,nnBstRT(1),3,Label='IndRed_Hidden')
IndRed => IndRed_Hidden
call mma_allocate(IndRSh_Hidden,nnBstRT(1),Label='IndRSh_Hidden')
IndRSh => IndRSh_Hidden
call Cho_RstD_GetInd2()

call mma_allocate(iSP2F,nnShl,Label='iSP2F')
call Cho_RstD_GetInd3(iSP2F,size(iSP2F))

! Allocate and read bookmarks (if available on runfile).
! ------------------------------------------------------

if (isDF) then
  nRow_BkmVec = 0
  nCol_BkmVec = 0
  nRow_BkmThr = 0
  nCol_BkmThr = 0
else
  l = 4
  call mma_allocate(BkmDim,l,Label='BkmDim')
  call Get_iArray('Cholesky BkmDim',BkmDim,l)
  nRow_BkmVec = BkmDim(1)
  nCol_BkmVec = BkmDim(2)
  nRow_BkmThr = BkmDim(3)
  nCol_BkmThr = BkmDim(4)
  call mma_deallocate(BkmDim)
  if ((nRow_BkmVec > 0) .and. (nCol_BkmVec > 0) .and. (nRow_BkmThr > 0) .and. (nCol_BkmThr > 0)) then
    call mma_allocate(BkmVec,nRow_BkmVec,nCol_BkmVec,Label='BkmVec')
    call Get_iArray('Cholesky BkmVec',BkmVec,size(BkmVec))
    call mma_allocate(BkmThr,nRow_BkmThr,nCol_BkmThr,Label='BkmThr')
    call Get_dArray('Cholesky BkmThr',BkmThr,size(BkmThr))
  else
    nRow_BkmVec = 0
    nCol_BkmVec = 0
    nRow_BkmThr = 0
    nCol_BkmThr = 0
  end if
end if

! mySP is set because a few core routines may use it.
! After the decomposition is done, it must be a trivial mapping and
! the user (programmer) should not worry about it at all.
! -----------------------------------------------------------------

call mma_allocate(MySP,nnShl,Label='MySP')
do ijShl=1,nnShl
  MySP(ijShl) = ijShl
end do

! Copy reduced set 1 to location 2.
! ---------------------------------

call Cho_RSCopy(1,2)

! Get dimensions of reduced sets.
! -------------------------------

call mma_allocate(nDimRS,nSym,MaxRed,Label='nDimRS')
nDimRS(:,1) = nnBstR(1:nSym,1)
iLoc = 3
do iRed=2,MaxRed
  call Cho_GetRed(iRed,iLoc,.false.)
  call Cho_SetRedInd(iLoc)
  nDimRS(:,iRed) = nnBstR(1:nSym,iLoc)
end do

! Copy reduced set 1 to location 3.
! ---------------------------------

call Cho_RSCopy(1,3)

! Derive:
! nBasSh: #basis functions in sym. block of shell.
! nBstSh: #basis functions in each shell.
! Mx2Sh : max. shell pair dimension.
! iShlSO: index of SO within its shell.
! ------------------------------------------------

call mma_allocate(iBasSh,nSym,nShell,Label='iBasSh')
call mma_allocate(nBasSh,nSym,nShell,Label='nBasSh')
call mma_allocate(nBstSh,nShell,Label='nBstSh')
call Cho_SetSh(iBasSh,nBasSh,nBstSh,iBas,nBas,iSOShl,nSym,nShell,nBasT)

MxOrSh = nBstSh(1)
do iShl=2,nShell
  MxOrSh = max(MxOrSh,nBstSh(iShl))
end do

Mx2Sh = 0
do ijShl=1,nnShl
  call Cho_InvPck(iSP2F(ijShl),iShl,jShl,.true.)
  if (iShl == jShl) then
    Numij = nTri_Elem(nBstSh(iShl))
  else
    Numij = nBstSh(iShl)*nBstSh(jShl)
  end if
  Mx2Sh = max(Mx2Sh,Numij)
end do

call mma_allocate(iShlSO,nBasT,Label='iShlSO')
call Cho_SetSh2(iShlSO,iSOShl,nBstSh,nBasT,nShell)

! Allocate and compute mapping RS1->Full.
! ---------------------------------------

call mma_allocate(iRS2F,2,nnBstRT(1),Label='iRS2F')
call Cho_RSTOF(iRS2F,2,nnBstRT(1),1)

! Allocate integer scratch array used for Cholesky vector I/O.
! ------------------------------------------------------------

DoDummy = .not. ((Cho_IOVec == 1) .or. (Cho_IOVec == 2) .or. (Cho_IOVec == 3) .or. (Cho_IOVec == 4))
call Cho_Allo_iScr(DoDummy)

! Setup for parallel runs.
! ------------------------

call Cho_X_Init_Par(irc,isDF)
if (irc /= 0) then
  call Finish_this(4)
  return
end if

#ifdef _DEBUGPRINT_
! Debug: test bookmarks.
! Note that 1C-CD flag must be available on runfile
! (make sure _DEBUGPRINT_ is defined also in Cho_Final().
! -------------------------------------------------------

if (allocated(BkmVec) .and. allocated(BkmThr)) then
  call Get_iScalar('1C-CD',is1CCD)
  call Cho_TestBookmark(irc,.true.,is1CCD == 1)
  if (irc /= 0) call Cho_Quit('Bookmark test failed!',104)
end if
#endif

! Allocate and initialize (i.e. read vectors) vector buffer.
! ----------------------------------------------------------

Frac = min(max(BufFrac,Zero),One)
call Cho_VecBuf_Init(Frac,nnBstR(1,1)) ! allocate
call Cho_VecBuf_Ini2() ! read

! Normal exit point.
! ------------------

ChoIsIni = ChoIniCheck
call Put_iScalar('ChoIni',ChoIsIni)
irc = 0
call Finish_this(0)

contains

subroutine Finish_this(num)

  integer(kind=iwp), intent(in) :: num

  ! Error branches.
  ! ===============
  select case (num)
    case (-1)
      ! Cholesky flag not found on runfile
      irc = -1
      write(u6,'(//,A,A,//)') SecNam,': two-electron integrals not Cholesky decomposed!'
    case (1)
      ! Bad info obtained from runfile
      irc = 1
      write(u6,'(//,A,A,//)') SecNam,': WARNING: error reading runfile!'
    case (2)
      ! restart info corrupted
      irc = 2
      write(u6,'(//,A,A)') SecNam,': WARNING: error reading restart info!'
      write(u6,'(A,A,I6,//)') SecNam,': return code from read:',ierr
    case (3)
      ! include file inconsistency detected
      irc = 3
      write(u6,'(//,A,A,//)') SecNam,': WARNING: include file inconsistency detected!'
    case (4)
      ! error in parallel setup
      irc = 4
      write(u6,'(//,A,A,//)') SecNam,': WARNING: error in parallel setup!'
    case default
  end select

  ! Return.
  ! =======

# ifdef _DEBUGPRINT_
  call mma_maxDBLE(l_Max)
  call Cho_Word2Byte(l_Max,8,Byte,Unt)
  write(u6,*) '>>>>> Available memory on exit from ',SecNam,': ',l_Max,' = ',Byte,Unt
  call xFlush(u6)
# endif

end subroutine Finish_this

end subroutine Cho_X_Init

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine DIN(Dens)
*
      use Basis_Info, only: nBas
      use pso_stuff
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "etwas.fh"
#include "WrkSpc.fh"
      Real*8 Dens(nDens)
*                                                                      *
************************************************************************
*                                                                      *
      nTemp2=0
      Do iIrr=0,nIrrep-1
         nTemp2=Max(nTemp2,nBas(iIrr))
      End Do
      Call GetMem('Temp2','ALLO','REAL',ipTemp2,nTemp2**2)
      ip=1
      ipD=0
      Do iIrr=0,nIrrep-1
         If (nBas(iIrr).ne.0) Then
            Call DGEMM_('N','T',
     &                  nBas(iIrr),nBas(iIrr),nIsh(iIrr),
     &                  1.0d0,CMO(ip,1),nBas(iIrr),
     &                        CMO(ip,1),nBas(iIrr),
     &                  0.0d0,Work(ipTemp2),nBas(iIrr))
            Do iBas=1,nBas(iIrr)
               Do jBas=1,iBas-1
                  ip1=(iBas-1)*nBas(iIrr)+jBas
                  ip2=iBas*(iBas-1)/2+jBas
                  Dens(ipD+ip2)=Work(ipTemp2+ip1-1)*Four
               End Do
               ip1=(iBas-1)*nBas(iIrr)+iBas
               ip2=iBas*(iBas+1)/2
               Dens(ipD+ip2)=Work(ipTemp2+ip1-1)*Two
            End Do
            ip=ip+nBas(iIrr)**2
            ipd=ipD+nBas(iIrr)*(nBas(iIrr)+1)/2
         End If
      End Do
      Call GetMem('Temp2','FREE','REAL',ipTemp2,nTemp2**2)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine get_Umn(PHP,EnIn,DHAM,IPCSF,IPCNF,MXPDIM,DTOC,IPRODT,ICONF,IREFSM,ONEBOD,ECORE,NACTOB,NCONF,NEL,NAEL,NBEL,NPCSF,NPCNF, &
                   TUVX,iterSplit,ITER,NTEST,ExFac,IREOTS)
! ARGUMENTS :
! ===========
! PHP    : AA Block Hamiltonian un-dressed                  (Output)
! EnIn   : energy value of the root selected                (Input)
! DHAM   : Dressed AA block Hamiltonian                     (Output)
! IPCSF  : CSF's order - Index Array -                      (Input)
! IPCNF  : CNF's order - Index Array -                      (Input)
! MXPDIM : Total number of CSFs                             (Input)
! DTOC   : Transformation matrix between CSF's and DET's    (Input)
! IPRODT : Prototype determinants                           (Input)
! ICONF  : List of configurations                           (Input)
! IREFSM : symmetry of considered CI space                  (Input)
! Onebod : one body hamilton matrix in rectangular form     (Input)
! ECORE  : Core energy                                      (Input)
! NACTOB : Number of active orbitals                        (Input)
! NCONF  : Number of CNFs of symmetry IREFSM                (Input)
! NEL    : total number of active electrons                 (Input)
! NAEL   : number of alpha active electron                  (Input)
! NBEL   : number of beta active electron                   (Input)
! NPCSF  : Number of CSFs in AA block                       (Input)
! NPCNF  : Number of CNFs in AA block                       (Input)
! TUVX   : Two-electron integrals (MO space)                (Input)
! NTEST  :
! ExFac  :
! IREOTS : Type => symmetry reordering array

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: MXPDIM, NCONF, IPCSF(MXPDIM), IPCNF(NCONF), IPRODT(*), ICONF(*), IREFSM, NACTOB, NEL, NAEL, NBEL, &
                                 NPCSF, NPCNF, iterSplit, ITER, IREOTS(NACTOB)
real(kind=wp), intent(in) :: EnIn, DTOC(*), ONEBOD(NACTOB,NACTOB), ECORE, TUVX(*), ExFac
real(kind=wp), intent(out) :: PHP(NPCSF*(NPCSF+1)/2), DHAM(NPCSF*(NPCSF+1)/2)
integer(kind=iwp), intent(inout) :: NTEST
integer(kind=iwp) :: iAlpha, IATYP, IIA, IIAB, IIL, IILACT, IILB, IIR, IIRACT, IIRB, IIRMAX, iKACONF, iKLCONF, iKRCONF, ILAI, &
                     ILRI, ILRO, ILTYP, IRTYP, ITYP, KACONF, KLAUXD, KLCONF, KLFREE, KLPHPS, KRCONF, Mindex, MXCSFC, MXXWS, NCSFA, &
                     NCSFL, NCSFR, Nindex
real(kind=wp), allocatable :: AuxC(:,:), AuxD(:), AuxV(:,:), Scr(:)
integer(kind=iwp), external :: ip_of_iWork_d, ip_of_Work
#include "spinfo.fh"
#include "WrkSpc.fh"

if (NTEST >= 30) then
  write(u6,*) ' Input in get_Umn'
  write(u6,*) ' =================='
  write(u6,*) ' Number of CNFs ',NCONF
  write(u6,*) ' Number of CSFs ',MXPDIM
  write(u6,*) ' Configurations included :'
  call IWRTMA(IPCNF,1,NCONF,1,NCONF)
  write(u6,*) ' CSFs included :'
  call IWRTMA(IPCSF,1,MXPDIM,1,MXPDIM)
  write(u6,*) ' Number of CNFs in AA block:',NPCNF
  write(u6,*) ' Number of CSFs in AA block:',NPCSF
end if

DHAM(:) = Zero
! construct the Dressed Hamiltonian matrix
MXCSFC = 0
do ITYP=1,NTYP
  MXCSFC = max(MXCSFC,NCSFTP(ITYP))
end do
!write(u6,*) 'MXCSFC = ',MXCSFC
call mma_allocate(AuxD,MXCSFC,label='AuxDia')
call mma_allocate(AuxV,NPCSF,MXCSFC,label='AuxVer')
call mma_allocate(AuxC,NPCSF,MXCSFC,label='AuxCopy')
call mma_maxDBLE(MXXWS)
MXXWS = MXXWS/2
call mma_allocate(Scr,MXXWS,label='EXHSCR')

KACONF = ip_of_Work(Scr(1))
KLCONF = KACONF+NEL
KRCONF = KLCONF+NEL
KLAUXD = KRCONF+NEL
KLPHPS = KLAUXD+MXCSFC*MXCSFC
KLFREE = KLPHPS+MXCSFC*MXCSFC

! Shape of PHP matrix:
!
!           CNFL (n)
!
!      1  2  4  7 11 16 22 ...
!  C   -  3  5  8 12 17 23 ...
!  N   -  -  6  9 13 18 24 ...
!  F   -  -  - 10 14 19 25 ...
!  R   -  -  -  - 15 20 26 ...
! (m)  -  -  -  -  - 21 27 ...
!      -  -  -  -  -  - 28 ...
!      -  -  -  -  -  -  - ...

!***********************************************************************
! Now a loop over alpha will start to calculate:                       *
!   1) BB-Block DIAGONAL element 1/(En-H(alpha,alpha))                 *
!   2) AB-Block array H(m,alpha)
!***********************************************************************
if ((ITER /= 1) .or. (iterSplit /= 1)) then
  IIAB = 1
  do iAlpha=NPCNF+1,NCONF ! Loop over alpha
    call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
    !write(u6,*) 'iAlpha = ',iAlpha
    iKACONF = ip_of_iWork_d(Work(KACONF))
    call GETCNF_LUCIA(iWork(iKACONF),IATYP,IPCNF(iAlpha),ICONF,IREFSM,NEL)
    NCSFA = NCSFTP(IATYP)
    !write(u6,*) 'NCSFA = ',NCSFA
    iKACONF = ip_of_iWork_d(Work(KACONF))
    call CNHCN(iWork(iKACONF),IATYP,iWork(iKACONF),IATYP,Work(KLAUXD),Work(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX, &
               NTEST,ExFac,IREOTS)
    do IIA=1,NCSFA
      ILAI = IIA*IIA
      if (NTEST >= 30) write(u6,*) 'ILAI =',ILAI
      !AuxD(IIA) = Work(KLAUXD+ILAI-1)
      !write(u6,*) 'AuxD(IIA)',AuxD(IIA)
      AuxD(IIA) = One/(EnIn-Work(KLAUXD+ILAI-1))
      if (NTEST >= 30) write(u6,*) 'AuxD(IIA)',AuxD(IIA)
    end do
    !*************** 2) AB-Block Array (alpha Column) ********************
    IILB = 1
    do Mindex=1,NPCNF ! Loop over AB-Block
      call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
      !write(u6,*) 'Mindex',Mindex
      iKLCONF = ip_of_iWork_d(Work(KLCONF))
      call GETCNF_LUCIA(iWork(iKLCONF),ILTYP,IPCNF(Mindex),ICONF,IREFSM,NEL)
      NCSFL = NCSFTP(ILTYP)
      !write(u6,*) 'NCSFL = ',NCSFL
      iKACONF = ip_of_iWork_d(Work(KACONF))
      iKLCONF = ip_of_iWork_d(Work(KLCONF))
      call CNHCN(iWork(iKACONF),IATYP,iWork(iKLCONF),ILTYP,Work(KLAUXD),Work(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB, &
                 TUVX,NTEST,ExFac,IREOTS)
      if (NTEST >= 30) then
        write(u6,*) 'M_Alpha elements'
        call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
      end if
      do IIL=1,NCSFL
        do IIA=1,NCSFA
          IILACT = IILB-1+IIL
          ILAI = (IIL-1)*NCSFA+IIA
          !ILAI = (IIA-1)*MXCSFC+IIL
          !ILAI = (IIL-1)*MXCSFC+IIA
          AuxV(IILACT,IIA) = Work(KLAUXD+ILAI-1)
          !write(u6,*) 'ILAI, ILACT, IIA = ',ILAI,ILACT,IIA
          if (NTEST >= 30) write(u6,*) 'AuxV(IILACT,IIA)',AuxV(IILACT,IIA)
          AuxC(IILACT,IIA) = AuxV(IILACT,IIA)*AuxD(IIA)
          if (NTEST >= 30) write(u6,*) 'AuxC(IILACT,IIA)',AuxC(IILACT,IIA)
        end do
      end do
      IILB = IILB+NCSFL
    end do ! End loop over AB-Block
    if (NTEST >= 30) then
      write(u6,*) 'AB-Block Vertical Vector'
      call wrtmat(AuxV,NPCSF,NCSFA,NPCSF,NCSFA)
      write(u6,*) 'AB-Block Vertical Vector times Daa'
      call wrtmat(AuxC,NPCSF,NCSFA,NPCSF,NCSFA)
    end if
    !*********************************************************************
    call dGeMM_Tri('N','T',NPCSF,NPCSF,NCSFA,One,AuxC,NPCSF,AuxV,NPCSF,One,DHAM,NPCSF)
    if (NTEST >= 30) call TRIPRT('correction to the AA block',' ',DHAM,NPCSF)
    IIAB = IIAB+NCSFA
  end do ! End of the loop over iAlpha
end if
!***********************************************************************
!    1. A-Block matrix element                                         *
!***********************************************************************
IILB = 1
do Nindex=1,NPCNF ! Loop over the AA-block (vertical index)
  if (NTEST >= 30) write(u6,*) 'Nindex',Nindex
  !write(u6,*) 'IILB',IILB
  iKLCONF = ip_of_iWork_d(Work(KLCONF))
  call GETCNF_LUCIA(iWork(iKLCONF),ILTYP,IPCNF(Nindex),ICONF,IREFSM,NEL)
  NCSFL = NCSFTP(ILTYP)
  !write(u6,*) 'NCSFL = ',NCSFL

  IIRB = 1
  do Mindex=1,Nindex ! Loop over the AA-block (horizontal index)
    call FZero(Work(KLPHPS),MXCSFC*MXCSFC)
    !write(u6,*) 'Nindex,Mindex',Nindex,Mindex
    iKRCONF = ip_of_iWork_d(Work(KRCONF))
    call GETCNF_LUCIA(iWork(iKRCONF),IRTYP,IPCNF(Mindex),ICONF,IREFSM,NEL)
    NCSFR = NCSFTP(IRTYP)
    !write(u6,*) 'NCSFR = ',NCSFR
    iKLCONF = ip_of_iWork_d(Work(KLCONF))
    iKRCONF = ip_of_iWork_d(Work(KRCONF))
    call CNHCN(iWork(iKLCONF),ILTYP,iWork(iKRCONF),IRTYP,Work(KLPHPS),Work(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX, &
               NTEST,ExFac,IREOTS)
    if (NTEST >= 30) then
      write(u6,*) 'AA block elements'
      call wrtmat(Work(KLPHPS),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
    end if
    do IIL=1,NCSFL
      if (IILB == IIRB) then
        IIRMAX = IIL
      else
        IIRMAX = NCSFR
      end if
      do IIR=1,IIRMAX
        IIRACT = IIRB-1+IIR
        IILACT = IILB-1+IIL
        !ILRI = (IIR-1)*MXCSFC+IIL
        ILRI = (IIR-1)*NCSFL+IIL
        !^ Forse questo e' quello giusto; la precedente formula
        !  potrebbe essere fonte di BUGS! Vedremo!
        ILRO = ((IILACT*IILACT-IILACT)/2)+IIRACT
        PHP(ILRO) = Work(KLPHPS+ILRI-1)
        !write(u6,*) 'ILRI, ILRO = ',ILRI,ILRO
        !write(u6,*) 'PHP(ILRO)',PHP(ILRO)
      end do
    end do
    IIRB = IIRB+NCSFR
  end do ! End loop over the AA-block (horizontal index)
  IILB = IILB+NCSFL
end do ! End loop over the AA-block (vertical index)

!***********************************************************************
! Let's add Hmn (PHP) to the correction (DHAM)
DHAM(:) = DHAM(:)+PHP(:)
!***********************************************************************
if (NTEST >= 30) then
  write(u6,*) 'AA-Block matrix un-dressed'
  call wrtmat(PHP,NPCSF*(NPCSF+1)/2,1,NPCSF*(NPCSF+1)/2,1)
  write(u6,*) 'AA-Block matrix dressed'
  call wrtmat(DHAM,NPCSF*(NPCSF+1)/2,1,NPCSF*(NPCSF+1)/2,1)
end if

if (NTEST >= 30) then
  call TRIPRT('AA block Hamiltonian Matrix un-dressed',' ',PHP,NPCSF)
  call TRIPRT('Dressed AA block Hamiltonian Matrix',' ',DHAM,NPCSF)
end if
call mma_deallocate(AuxD)
call mma_deallocate(AuxV)
call mma_deallocate(AuxC)
call mma_deallocate(Scr)

return

end subroutine get_Umn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine weightfl_cvb(ix,n,nel)
      dimension ix(0:nel,0:n)
      call izero(ix,(n+1)*(nel+1))
      ix(0,0)=1
      do 1200 iel=1,nel
      do 1201 ik=max(iel-nel+n,0),min(iel,n)
      if(ik.ne.0)then
        ix(iel,ik)=ix(iel-1,ik) + ix(iel-1,ik-1)
      else
        ix(iel,ik)=ix(iel-1,ik)
      endif
1201  continue
1200  continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2000  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE GETSGM2(ILEV,JLEV,ISYCI,CI,SGM)
      use Symmetry_Info, only: Mul
      use gugx, only:  SGS, CIS, EXS
      use pt2_guga, only: MxCI
      IMPLICIT None


      Integer :: ILEV, JLEV, ISYCI
      Real*8, Intent(In) ::  CI(MXCI)
      Real*8, Intent(Out)::  SGM(MXCI)
      Integer IS, JS, IJS, ISSG, NSGM

C GIVEN CI COUPLING LEVELS ILEV, JLEV, COMPUTE SGM=E(ILEV,JLEV)*CI
C ILEV,JLEV ARE IN PRINCIPLE ACTIVE ORBITAL NUMBERS, BUT POSSIBLY
C IN ANOTHER ORDER THAN THE USUAL ONE -- HERE WE USE THE ORDER
C FOLLOWED BY THE GUGA COUPLING SCHEME.
C
C THIS ROUTINE REPLACES EARLIER GETSGM, TO GET RID OF THE PACKING AND
C STORING USED EARLIER.

C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C NOTE!! THE EARLIER CALL GETSGM(ILEV,JLEV,IDARR,SGM) IS REPLACED BY
C GETSGM2(ILEV,JLEV,CI,SGM)!!
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      IS=SGS%ISM(ILEV)
      JS=SGS%ISM(JLEV)
      IJS=Mul(IS,JS)
      ISSG=Mul(IJS,ISYCI)
      NSGM=CIS%NCSF(ISSG)
      IF(NSGM.EQ.0) RETURN

      SGM(1:NSGM)=0.0D0
      CALL SIGMA1(SGS,CIS,EXS,ILEV,JLEV,1.0D00,ISYCI,CI,SGM)

      END SUBROUTINE GETSGM2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Reord_Vk(ip_V_k,nProcs,myProc,nV_k,nV_t,nA,jSym,Array)

use ChoSwp, only: InfVec
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nProcs, ip_V_k(nProcs), myProc, jSym, nV_k(jSym), nV_t(jSym), nA(jSym)
real(kind=wp), intent(inout) :: Array(*)
integer(kind=iwp) :: ifr, ik, iSym, ito, jOff, kOff, nAV_t
real(kind=wp), allocatable :: Scr(:)

nAV_t = 0
do iSym=1,jSym
  nAV_t = nAV_t+nA(iSym)*nV_t(iSym)
end do
call mma_allocate(Scr,nAV_t,Label='Scr')
Scr(:) = Zero

! On input Array first blocked over the processes
!    pointer to the block is ip_V_K(i)
!    Each block is symmetry blocked
!         Each symmetry is nA(iSym)*nV_k(iSym)
!
! Scr is also symmetry blocked
!    Each symmetry is nA(iSym)*nV_t(iSym)
!
! InfVec(ik,5,iSym) translates the local ik'th index into
! the global index of V

jOff = 0
kOff = 0
do iSym=1,jSym
  do ik=1,nV_k(iSym)   ! loop over the local vector

    ifr = ip_V_k(myProc)+jOff+nA(iSym)*(ik-1)
    ito = 1+kOff+nA(iSym)*(InfVec(ik,5,iSym)-1)
    Scr(ito:ito+nA(iSym)-1) = Array(ifr:ifr+nA(iSym)-1)

  end do
  jOff = jOff+nA(iSym)*nV_k(iSym)
  kOff = kOff+nA(iSym)*nV_t(iSym)
end do

! Copy Scr => Array
Array(ip_V_k(1):ip_V_k(1)+nAV_t-1) = Scr(1:nAV_t)

! Make a global add to get the contributions from all nodes.

call GADGOP(Array(ip_V_k(1)),nAV_t,'+')

call mma_deallocate(Scr)

return

end subroutine Reord_Vk

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE SBDIAG()
      use output_caspt2, only:iPrGlb,usual,verbose
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"


      IF(IPRGLB.GE.VERBOSE) THEN
        WRITE(6,*)
        WRITE(6,*)' Find transformation matrices to eigenbasis'//
     &     ' of block-diagonal part of H0.'
        WRITE(6,*)' Eliminate linear dependency. Thresholds for:'
        WRITE(6,'(A,G12.4)')'   Initial squared norm  :',THRSHN
        WRITE(6,'(A,G12.4)')'   Eigenvalue of scaled S:',THRSHS
      END IF

C SVC.20100904: there are now two SBDIAG versions: a replicate
C subroutine expecting replicate S and B matrices (in upper triangular
C column-wise storage) and performing transformations on each process,
C and a global array subroutine expecting S and B matrices in global
C arrays (full column-wise storage) spread over processes.  The latter
C is currently used only for cases 1 (A) and 4 (C), for which global
C array mksmat and mkbmat routines have been implemented, as these can
C grow very big with increasing size of the active space.  For now, we
C still use the replicate routines for the other cases as they have more
C modest array sizes.

      IF(IPRGLB.GE.VERBOSE) THEN
        WRITE(6,*)
        WRITE(6,*)' Condition numbers are computed after diagonal'//
     &     ' scaling and after removal of'
        WRITE(6,*)' linear dependency. Resulting sizes, condition'//
     &     ' numbers, and times:'
        WRITE(6,'(3X,A10,4A12,A9)')
     &     'CASE(SYM)','NASUP','NISUP','NINDEP','COND NR','CPU (s)'
      ENDIF

      DO iCASE=1,11
        DO ISYM=1,NSYM
#ifdef _MOLCAS_MPP_
            IF (IS_REAL_PAR() .AND.
     &          (ICASE.EQ.1.OR.ICASE.EQ.4)) THEN
              CALL SBDIAG_MPP(ISYM,ICASE,CONDNR,CPU)
            ELSE
              CALL SBDIAG_SER(ISYM,ICASE,CONDNR,CPU)
            END IF
#else
            CALL SBDIAG_SER(ISYM,ICASE,CONDNR,CPU)
#endif
            IF (IPRGLB.GE.VERBOSE) THEN
              WRITE(6,'(3X,A6,A1,I1,A1,1X,3I12,G11.2,I9)')
     &         CASES(ICASE),'(',ISYM,')',
     &         NASUP(ISYM,ICASE),NISUP(ISYM,ICASE),
     &         NINDEP(ISYM,ICASE),CONDNR,NINT(CPU)
            END IF

        END DO
      END DO

C usually print info on the total number of parameters
      IPAR0=0
      IPAR1=0
      DO ICASE=1,13
        DO ISYM=1,NSYM
          IPAR0=IPAR0+NASUP(ISYM,ICASE)*NISUP(ISYM,ICASE)
          IPAR1=IPAR1+NINDEP(ISYM,ICASE)*NISUP(ISYM,ICASE)
        END DO
      END DO
      IF(IPRGLB.GE.USUAL) THEN
        WRITE(6,*)
        WRITE(6,*)' Total nr of CASPT2 parameters:'
        WRITE(6,'(a,i12)')'   Before reduction:',IPAR0
        WRITE(6,'(a,i12)')'   After  reduction:',IPAR1
      ENDIF


      RETURN
      END

      SUBROUTINE SBDIAG_SER(ISYM,ICASE,CONDNR,CPU)
      use output_caspt2, only:iPrGlb,insane
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

* For fooling some compilers:
      DIMENSION WGRONK(2)

C On entry, the file LUSBT contains overlap matrices SMAT at disk
C addresses IDSMAT(ISYM,ICASE), ISYM=1..NSYM, ICASE=1..11, and
C similarly BMAT matrices at IDBMAT(ISYM,ICASE).
C These matrices are stored in a triangular format.
C The rectangular matrices TRANS are computed, such that
C    Sum(J) of BMAT(I,J)*TRANS(J,MU) =
C       Sum(J) of  SMAT(I,J)*TRANS(J,MU)*BDIAG(MU)
C where I,J are in 1..NASUP(ISYM,ICASE)
C        MU is in 1..NINDEP(ISYM,ICASE)
C NINDEP is the numerically effective rank of SMAT, and the
C columns of TRANS are orthonormal:
C    Sum(I,J) of  SMAT(I,J)*TRANS(J,MU)*TRANS(J,NU) = Kron(MU,NU)
C BMAT is destroyed, and is overwritten by BDIAG(MU) and
C TRANS(I,MU), with addresses IDBMAT(ISYM,ICASE) and
C IDTMAT(ISYM,ICASE). Enough file space was thus originally
C reserved on LUSBT to allow this overlay.
C LUSOLV is assumed not to be in use yet, so we use it
C for temporary storage.

      SD = 0.0D0 ! dummy initialize

      CPU=0.0D0
      CONDNR=0.0D0
      NAS=NASUP(ISYM,ICASE)
      NIS=NISUP(ISYM,ICASE)
      NCOEF=NAS*NIS

      IF(NCOEF.EQ.0) RETURN

      IF (IPRGLB.GE.INSANE) THEN
        WRITE(6,'("DEBUG> ",A12,A7,I2,A2,A6,A2,A5,I1)')
     &  'SBDIAG_SER: ','CASE ',ICASE,' (',CASES(ICASE),') ','SYM ',ISYM
      END IF

      NS=(NAS*(NAS+1))/2
      CALL GETMEM('LS','ALLO','REAL',LS,NS)
      IDS=IDSMAT(ISYM,ICASE)
      CALL DDAFILE(LUSBT,2,WORK(LS),NS,IDS)
      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NS,WORK(LS),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'SMAT NORM: ', FP
      END IF

C For some purposes, we need to save the diagonal elements:
      IF(BMATRIX.EQ.'YES') THEN
        IF(BTRANS.NE.'YES') THEN
          CALL GETMEM('LSD','ALLO','REAL',LSD,NAS)
          IDIAG=0
          DO I=1,NAS
            IDIAG=IDIAG+I
            WORK(LSD-1+I)=WORK(LS-1+IDIAG)
          END DO
        END IF
      END IF

C FIRST, FIND NIN ORTHONORMAL VECTORS BY SCALED SYMMETRIC ON.
C Addition, for the scaled symmetric ON: the S matrix is scaled
C to make the diagonal elements close to 1.
C Extremely small values give scale factor exactly zero.
      CALL GETMEM('LSCA','ALLO','REAL',LSCA,NAS)
      IDIAG=0
      DO I=1,NAS
        IDIAG=IDIAG+I
        SD=WORK(LS-1+IDIAG)
        IF(SD.GT.THRSHN) THEN
* Small variations of the scale factor were beneficial
          WORK(LSCA-1+I)=(1.0D00+DBLE(I)*3.0D-6)/SQRT(SD)
        ELSE
          WORK(LSCA-1+I)=0.0D0
        END IF
      END DO
      IJ=0
      DO J=1,NAS
        DO I=1,J
          IJ=IJ+1
          WORK(LS-1+IJ)=WORK(LS-1+IJ)*
     &        WORK(LSCA-1+I)*WORK(LSCA-1+J)
        END DO
      END DO
C End of addition.
      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NS,WORK(LS),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'SMAT NORM AFTER SCALING: ', FP
      END IF

C DIAGONALIZE THE SCALED S MATRIX:
      CALL GETMEM('LVEC','ALLO','REAL',LVEC,NAS**2)
      CALL GETMEM('LEIG','ALLO','REAL',LEIG,NAS)

      CALL TIMING(CPU1,CPUE,TIO,TIOE)
      IJ=0
      DO J=1,NAS
        DO I=1,J
          IJ=IJ+1
          WORK(LVEC-1+NAS*(J-1)+I)=WORK(LS-1+IJ)
        END DO
      END DO
      INFO=0
      call dsyev_('V','L',NAS,WORK(LVEC),NAS,WORK(LEIG),WGRONK,-1,INFO)
      NSCRATCH=INT(WGRONK(1))
      CALL GETMEM('SCRATCH','ALLO','REAL',LSCRATCH,NSCRATCH)
      call dsyev_('V','U',NAS,WORK(LVEC),NAS,WORK(LEIG),WORK(LSCRATCH),
     &            NSCRATCH,INFO)
      CALL GETMEM('SCRATCH','FREE','REAL',LSCRATCH,NSCRATCH)
      CALL GETMEM('LS','FREE','REAL',LS,NS)

      CALL TIMING(CPU2,CPUE,TIO,TIOE)
      CPU=CPU+CPU2-CPU1
      ! fingerprint eigenvalues
      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NAS,WORK(LEIG),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'SMAT EIGENVALUE NORM: ', FP
      END IF

C Form orthonormal vectors by scaling eigenvectors
      NIN=0
      DO I=1,NAS
        EVAL=WORK(LEIG-1+I)
        IF(EVAL.LT.THRSHS) CYCLE
        FACT=1.0D00/SQRT(EVAL)
        NIN=NIN+1
        LVSTA=LVEC+NAS*(I-1)
        IF(NIN.EQ.I) THEN
          CALL DSCAL_(NAS,FACT,WORK(LVSTA),1)
        ELSE
          LVNEW=LVEC+NAS*(NIN-1)
          CALL DYAX(NAS,FACT,WORK(LVSTA),1,WORK(LVNEW),1)
        END IF
      END DO
      NINDEP(ISYM,ICASE)=NIN
      CALL GETMEM('LEIG','FREE','REAL',LEIG,NAS)
C Addition, for the scaled symmetric ON.
      DO I=1,NAS
        SCA=WORK(LSCA-1+I)
        CALL DSCAL_(NIN,SCA,WORK(LVEC-1+I),NAS)
      END DO
      CALL GETMEM('LSCA','FREE','REAL',LSCA,NAS)
C The condition number, after scaling, disregarding linear dep.
      IF(NIN.GE.2) THEN
        SZMIN=1.0D99
        SZMAX=0.0D0
        DO I=1,NIN
          SZ=DNRM2_(NAS,WORK(LVEC+NAS*(I-1)),1)
          SZMIN=MIN(SZMIN,SZ)
          SZMAX=MAX(SZMAX,SZ)
        END DO
        CONDNR=(SZMAX/SZMIN)**2
      END IF
C End of addition.
      IF(NIN.EQ.0) THEN
        CALL GETMEM('LVEC','FREE','REAL',LVEC,NAS**2)
        RETURN
      END IF

      IF(BMATRIX.EQ.'NO') THEN
C In some calculations, we do not use B matrices.
C Just write the transformation matrix and branch out:
        IDT=IDTMAT(ISYM,ICASE)
        CALL DDAFILE(LUSBT,1,WORK(LVEC),NAS*NIN,IDT)
        CALL GETMEM('LVEC','FREE','REAL',LVEC,NAS**2)
        IF (IPRGLB.GE.INSANE) THEN
          WRITE(6,'("DEBUG> ",A)') 'SBDIAG: skip B matrix'
        END IF
        RETURN
      ELSE IF (BTRANS.NE.'YES') THEN
C In other calculations, B matrix is used, but not transformed.
C We may need the diagonal active energies: the diagonal values of
C B divided by the diagonal values of S. These are placed where
C the eigenvalues would go in ordinary CASPT2.
C NOTE: On LUSBT, the transformation matrices partly overwrite
C and destroy the B matrices. The diagonal elements of B must be
C extracted before the transformation matrix is written.
        CALL GETMEM('LBD','ALLO','REAL',LBD,NAS)
        NB=(NAS*(NAS+1))/2
        CALL GETMEM('LB','ALLO','REAL',LB,NB)
        IDB=IDBMAT(ISYM,ICASE)
        CALL DDAFILE(LUSBT,2,WORK(LB),NB,IDB)
        IDIAG=0
        DO I=1,NAS
          IDIAG=IDIAG+I
          WORK(LBD-1+I)=WORK(LB-1+IDIAG)
        END DO
        CALL GETMEM('LB','FREE','REAL',LB,NB)
C Now, the transformation matrix can be written out.
        IDT=IDTMAT(ISYM,ICASE)
        CALL DDAFILE(LUSBT,1,WORK(LVEC),NAS*NIN,IDT)
        CALL GETMEM('LVEC','FREE','REAL',LVEC,NAS**2)
        DO I=1,NAS
          SD=WORK(LSD-1+I)+1.0d-15
          WORK(LBD-1+I)=WORK(LBD-1+I)/SD
        END DO
        IDB=IDBMAT(ISYM,ICASE)
        CALL DDAFILE(LUSBT,1,WORK(LBD),NAS,IDB)
        CALL GETMEM('LSD','FREE','REAL',LSD,NAS)
        CALL GETMEM('LBD','FREE','REAL',LBD,NAS)
        IF (IPRGLB.GE.INSANE) THEN
          WRITE(6,'("DEBUG> ",A)')'SBDIAG: skip B matrix transformation'
          WRITE(6,'("DEBUG> ",A)')'        but keep B_ii/S_ii values'
        END IF
        RETURN
      END IF

C TRANSFORM B MATRIX TO O-N BASIS. BUT FIRST, SAVE O-N VECTORS.
C USE LUSOLV AS TEMPORARY STORAGE. WE MAY NEED SECTIONING.
C NOTE: SECTIONING MUST BE  PRECISELY THE SAME AS WHEN LATER
C READ BACK (SEE BELOW).
      NAUX=MIN(19,NIN)
      IDTMP=0
      CALL DDAFILE(LUSOLV,1,WORK(LVEC),NAS*NAUX,IDTMP)
      DO KSTA=NAUX+1,NIN,NAUX
        KEND=MIN(KSTA-1+NAUX,NIN)
        NCOL=1+KEND-KSTA
        LVSTA=LVEC+NAS*(KSTA-1)
        CALL DDAFILE(LUSOLV,1,WORK(LVSTA),NAS*NCOL,IDTMP)
      END DO
      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NAS**2,WORK(LVEC),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)')
     &   'EIGENVECTOR NORM BEFORE B TRANS: ', FP
      END IF

C TRANSFORM B. NEW B WILL OVERWRITE AND DESTROY WORK(LVEC)
      IDB=IDBMAT(ISYM,ICASE)
      NB=NS
      CALL GETMEM('LB','ALLO','REAL',LB,NB)
      CALL DDAFILE(LUSBT,2,WORK(LB),NB,IDB)
      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NB,WORK(LB),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'BMAT NORM: ', FP
      END IF

      CALL GETMEM('LBX','ALLO','REAL',LBX,NAS)
      CALL GETMEM('LXBX','ALLO','REAL',LXBX,NAS)
      DO J=NIN,1,-1
        LVSTA=LVEC+NAS*(J-1)
        CALL DCOPY_(NAS,[0.0D0],0,WORK(LBX),1)
#ifdef _CRAY_C90_
        CALL SSPMV('U',NAS,1.0D+00,WORK(LB),WORK(LVSTA),1,
     &                           1.0D+00,WORK(LBX),1)
#else
*        CALL DSLMX(NAS,1.0D+00,WORK(LB),WORK(LVSTA),1,
*     &                                   WORK(LBX),1)
        CALL DSPMV_('U',NAS,1.0D+00,WORK(LB),WORK(LVSTA),1,
     &                           1.0D+00,WORK(LBX),1)
#endif
C WORK(LBX): B * Vector number J.
        CALL DCOPY_(J,[0.0D0],0,WORK(LXBX),1)
        CALL DGEMM_('T','N',
     &              J,1,NAS,
     &              1.0d0,WORK(LVEC),NAS,
     &              WORK(LBX),NAS,
     &              0.0d0,WORK(LXBX),J)
C WORK(LXBX) CONTAINS NOW THE UPPERTRIANGULAR
C ELEMENTS OF THE J-th COLUMN OF TRANSFORMED B MATRIX.
        CALL DCOPY_(J,WORK(LXBX),1,WORK(LVSTA),1)
      END DO
      CALL GETMEM('LBX','FREE','REAL',LBX,NAS)
      CALL GETMEM('LXBX','FREE','REAL',LXBX,NAS)
      CALL GETMEM('LB','FREE','REAL',LB,NB)
C WORK(LVEC) HAS NOW BEEN DESTROYED (OVERWRITTEN BY NEW B).
C COPY TO TRIANGULAR STORAGE.
      NBNEW=(NIN*(NIN+1))/2
      CALL GETMEM('LB','ALLO','REAL',LB,NBNEW)
      DO J=1,NIN
        JOFF=(J*(J-1))/2
        CALL DCOPY_(J,WORK(LVEC+NAS*(J-1)),1,WORK(LB+JOFF),1)
      END DO
      CALL GETMEM('LVEC','FREE','REAL',LVEC,NAS**2)
      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NBNEW,WORK(LB),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'BMAT NORM AFTER TRANS: ', FP
      END IF

C DIAGONALIZE THE TRANSFORMED B MATRIX.
      CALL GETMEM('LEIG','ALLO','REAL',LEIG,NIN)
      CALL GETMEM('LVEC','ALLO','REAL',LVEC,NIN**2)
      CALL TIMING(CPU1,CPUE,TIO,TIOE)
C - Alt 0: Use diagonal approxim., if allowed:
      IF(BSPECT.NE.'YES')  THEN
        IDIAG=0
        DO I=1,NIN
          IDIAG=IDIAG+I
          WORK(LEIG-1+I)=WORK(LB-1+IDIAG)/SD
        END DO
      ELSE
        IJ=0
        DO J=1,NIN
          DO I=1,J
            IJ=IJ+1
            WORK(LVEC-1+NIN*(J-1)+I)=WORK(LB-1+IJ)
          END DO
        END DO
        CALL DSYEV_('V','U',NIN,WORK(LVEC),NIN,WORK(LEIG),
     &              WGRONK,-1,INFO)
        NSCRATCH=INT(WGRONK(1))
        CALL GETMEM('SCRATCH','ALLO','REAL',LSCRATCH,NSCRATCH)
        CALL DSYEV_('V','U',NIN,WORK(LVEC),NIN,WORK(LEIG),
     &              WORK(LSCRATCH),NSCRATCH,INFO)
        CALL GETMEM('SCRATCH','FREE','REAL',LSCRATCH,NSCRATCH)
        CALL GETMEM('LB','FREE','REAL',LB,NB)
      END IF
      CALL TIMING(CPU2,CPUE,TIO,TIOE)
      CPU=CPU+CPU2-CPU1
      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NIN,WORK(LEIG),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'BMAT EIGENVALUE NORM: ', FP
      END IF

C The eigenvalues are written back at same position as the
C original B matrix, which is destroyed:
      IDB=IDBMAT(ISYM,ICASE)
      CALL DDAFILE(LUSBT,1,WORK(LEIG),NIN,IDB)
      CALL GETMEM('LEIG','FREE','REAL',LEIG,NIN)

C Finally, we must form the composite transformation matrix,
C  = (NAS*NIN matrix on disk) * (NIN*NIN matrix in core).
C Assume enough space since we got rid of S/B matrices.
C Specifically, assume we have enough space for the two
C full matrices, plus an additional 19 columns of results.
      NAUX=MIN(19,NIN)
      CALL GETMEM('LTRANS','ALLO','REAL',LTRANS,NAS*NIN)
      CALL GETMEM('LAUX'  ,'ALLO','REAL',LAUX  ,NAS*NAUX)
      IDTMP=0
      CALL DDAFILE(LUSOLV,2,WORK(LAUX),NAS*NAUX,IDTMP)
      IF(BTRANS.EQ.'YES') THEN
        CALL DGEMM_('N','N',
     &              NAS,NIN,NAUX,
     &              1.0d0,WORK(LAUX),NAS,
     &              WORK(LVEC),NIN,
     &              0.0d0,WORK(LTRANS),NAS)
      ELSE
        CALL DCOPY_(NAS*NAUX,WORK(LAUX),1,WORK(LTRANS),1)
      END IF
      DO KSTA=NAUX+1,NIN,NAUX
        KEND=MIN(KSTA-1+NAUX,NIN)
        NCOL=1+KEND-KSTA
        CALL DDAFILE(LUSOLV,2,WORK(LAUX),NAS*NCOL,IDTMP)
        IF(BTRANS.EQ.'YES') THEN
          CALL DGEMM_('N','N',NAS,NIN,NCOL,1.0D00,
     &              WORK(LAUX),NAS,WORK(LVEC-1+KSTA),NIN,
     &              1.0D00,WORK(LTRANS),NAS)
        ELSE
          LTRANS1=LTRANS+NAS*(KSTA-1)
          CALL DCOPY_(NAS*NCOL,WORK(LAUX),1,WORK(LTRANS1),1)
        END IF
      END DO
      CALL GETMEM('LAUX'  ,'FREE','REAL',LAUX  ,NAS*NAUX)
      CALL GETMEM('LVEC','FREE','REAL',LVEC,NIN**2)
      IDT=IDTMAT(ISYM,ICASE)
      CALL DDAFILE(LUSBT,1,WORK(LTRANS),NAS*NIN,IDT)
      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NAS*NIN,WORK(LTRANS),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'TMAT NORM: ', FP
      END IF

C-SVC: compute S*T and store on disk for later use by RHS vector
C      utilities.
      NS=(NAS*(NAS+1))/2
      CALL GETMEM('LS','ALLO','REAL',LS,NS)
      IDS=IDSMAT(ISYM,ICASE)
      CALL DDAFILE(LUSBT,2,WORK(LS),NS,IDS)
      CALL GETMEM('LST','ALLO','REAL',LST,NAS*NIN)
      CALL DCOPY_(NAS*NIN,[0.0D0],0,WORK(LST),1)
      CALL TRIMUL(NAS,NIN,1.0D00,WORK(LS),WORK(LTRANS),
     &            NAS,WORK(LST),NAS)
      CALL GETMEM('LS','FREE','REAL',LS,NS)
      CALL GETMEM('LTRANS','FREE','REAL',LTRANS,NAS*NIN)
      IDST=IDSTMAT(ISYM,ICASE)
      CALL DDAFILE(LUSBT,1,WORK(LST),NAS*NIN,IDST)
      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NAS*NIN,WORK(LST),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'STMAT NORM: ', FP
      END IF
      CALL GETMEM('LST','FREE','REAL',LST,NAS*NIN)

      END

C SVC2010: The following subroutine computes the transformation
C matrices using global arrays rather than replicate arrays.  Currently,
C the maximum memory scales approximately as 3*(NAS**2), which is twice
C what is needed in the replicate routines.  It can be reduced to
C 2*(NAS**2), if the matrix multiplications are rewritten to occur in
C batch mode.  However, unlike in the replicate routine, this amount is
C divided over processors.
#ifdef _MOLCAS_MPP_
      SUBROUTINE SBDIAG_MPP(ISYM,ICASE,CONDNR,CPU)
      use output_caspt2, only:iPrGlb,insane
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: King
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

C-SVC20100902: global arrays header files
#include "global.fh"
#include "mafdecls.fh"
#ifndef _SCALAPACK_
      DIMENSION WGRONK(2)
#endif
      LOGICAL bSTAT
      CHARACTER(LEN=2) cSYM,cCASE

C On entry, the DRA metafiles contain the matrices S and B for cases A
C (iCASE=1) en C (iCASE=4).  These symmetric matrices are stored on disk
C in full square format.  The rectangular matrices T are computed, such
C that Sum_(J) [B(I,J)*T(J,MU)] = Sum_(J) [S(I,J)*T(J,MU)*BD(MU)], where
C I,J are in the range (1,NASUP(ISYM,ICASE)) and MU is in the range
C (1,NINDEP(ISYM,ICASE)).  NINDEP is the numerically effective rank of
C S, and the columns of T are orthonormal: Sum_(I,J)
C [S(I,J)*T(J,MU)*T(J,NU)] = Kron(MU,NU).  B is destroyed, and is
C overwritten by BD(MU) and T(I,MU), which is stored in a DRA metafile.

C Initialize the DRA I/O subsystem with default values.

      IF (iCASE.NE.1.AND.iCASE.NE.4) THEN
        WRITE(6,*) 'Invalid CASE number used for global SBDIAG, Abort'
        CALL AbEnd()
      END IF

      write(unit=cCase, fmt='(I2.2)') iCase
      write(unit=cSYM, fmt='(I2.2)') iSYM
C Start a long loop over irreps:

      CPU=0.0D0
      CONDNR=0.0D0
      NAS=NASUP(ISYM,ICASE)
      NIS=NISUP(ISYM,ICASE)
      NCOEF=NAS*NIS
      IF(NCOEF.EQ.0) RETURN

      IF (IPRGLB.GE.INSANE) THEN
        WRITE(6,'("DEBUG> ",A12,A5,I2,A2,A6,A2,A5,I1)')
     &  'SBDIAG_MPP: ','CASE ',ICASE,' (',CASES(ICASE),') ','SYM ',ISYM
      END IF

C Allocate memory for the S matrix and read it from disk:
      CALL PSBMAT_GETMEM ('S',lg_S,NAS)
      CALL PSBMAT_READ ('S',iCase,iSym,lg_S,NAS)
      IF (IPRGLB.GE.INSANE) THEN
        FP=PSBMAT_FPRINT(lg_S,NAS)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'SMAT NORM: ', FP
      END IF

C The S matrices are needed later on by non-global routines.  Take the
C oportunity to save them to LUSBT here.  FIXME: Should be removed once
C full parallelization of use of S matrices is achieved.
      IF (KING()) THEN
        NCOL=NAS
        NTMP=(NAS*(NAS+1))/2
        CALL GETMEM('COL','ALLO','REAL',LCOL,NCOL)
        CALL GETMEM('TMP','ALLO','REAL',LTMP,NTMP)
        iOFF=0
        DO J=1,NAS
          call GA_Get (lg_S, 1, J, J, J, WORK(LCOL), NAS)
          CALL DCOPY_(J,WORK(LCOL),1,WORK(LTMP+iOFF),1)
          iOFF=iOFF+J
        END DO
        CALL GETMEM('COL','FREE','REAL',LCOL,NCOL)
        IDS=IDSMAT(ISYM,ICASE)
        CALL DDAFILE(LUSBT,1,WORK(LTMP),NTMP,IDS)
        CALL GETMEM('TMP','FREE','REAL',LTMP,NTMP)
      END IF

C Save the diagonal elements from the S matrix for easy access later on.
C FIXME: nicer way to do this?
      CALL GETMEM('SD','ALLO','REAL',LSD,NAS)
      CALL DCOPY_(NAS,[0.0D0],0,WORK(LSD),1)
      myRank = GA_NodeID()
      call GA_Distribution (lg_S, myRank, iLo, iHi, jLo, jHi)
      ISTA=MAX(ILO,JLO)
      IEND=MIN(IHI,JHI)
      IF (ISTA.NE.0) THEN
        call GA_Access (lg_S, iLo, iHi, jLo, jHi, mS, LDS)
        DO I=ISTA,IEND
          WORK(LSD+I-1)=DBL_MB(mS+I-ILO+LDS*(I-JLO))
        END DO
        call GA_Release (lg_S, iLo, iHi, jLo, jHi)
      END IF
      CALL GADSUM (WORK(LSD),NAS)

C Calculate the scaling factors and store them in array LSCA.
      CALL GETMEM('SCA','ALLO','REAL',LSCA,NAS)
      DO I=1,NAS
        SD=WORK(LSD+I-1)
        IF(SD.GT.THRSHN) THEN
          WORK(LSCA-1+I)=(1.0D00+DBLE(I)*3.0D-6)/SQRT(SD)
        ELSE
          WORK(LSCA-1+I)=0.0D0
        END IF
      END DO

C Scale the elements S(I,J) with the factor SCA(I)*SCA(J).
      myRank = GA_NodeID()
      call GA_Distribution (lg_S, myRank, iLo, iHi, jLo, jHi)
      IF (iLo.NE.0) THEN
        call GA_Access (lg_S, iLo, iHi, jLo, jHi, mS, LDS)
        call S_SCALE (NAS,WORK(LSCA),DBL_MB(mS),iLo,iHi,jLo,jHi,LDS)
        call GA_Release_Update (lg_S, iLo, iHi, jLo, jHi)
      END IF
      call GA_Sync()
      CALL TIMING(CPU1,CPUE,TIO,TIOE)

      IF (IPRGLB.GE.INSANE) THEN
        FP=PSBMAT_FPRINT(lg_S,NAS)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'SMAT NORM AFTER SCALING: ', FP
      END IF

      CALL GETMEM('LEIG','ALLO','REAL',LEIG,NAS)
      CALL DCOPY_(NAS,[0.0D0],0,WORK(LEIG),1)
C Diagonalize the global array S.  Some (old) reports about parallel
C performance recommend PDSYEVX or PDSYEVR as fastest methods if
C eigenvectors are needed (FIXME: should time this).  For the linear
C dependence removal, split eigenvectors in horizontal stripes so that
C each processor has a row window of all column vectors
#ifdef _SCALAPACK_
      CALL PSBMAT_GETMEM('VMAT',lg_V,NAS)
      CALL GA_PDSYEVX_ (lg_S, lg_V, WORK(LEIG), 0)
      bSTAT = GA_Destroy (lg_S)
#else
C here for the non-ScaLAPACK version: copy matrix to master process,
C diagonalize using the serial DSYEV routine, and copy the resulting
C eigenvectors back to a global array.  Then distribute the eigenvalues.
      IF (myRank.EQ.0) THEN
        CALL GETMEM('LVEC','ALLO','REAL',LVEC,NAS**2)
        CALL GA_Get (lg_S, 1, NAS, 1, NAS, WORK(LVEC), NAS)
      END IF
      bSTAT = GA_Destroy (lg_S)
      IF (myRank.EQ.0) THEN
        CALL DSYEV_('V','L',NAS,WORK(LVEC),NAS,WORK(LEIG),
     &              WGRONK,-1,INFO)
        NSCRATCH=INT(WGRONK(1))
        CALL GETMEM('SCRATCH','ALLO','REAL',LSCRATCH,NSCRATCH)
        CALL DSYEV_('V','L',NAS,WORK(LVEC),NAS,WORK(LEIG),
     &              WORK(LSCRATCH),NSCRATCH,INFO)
        CALL GETMEM('SCRATCH','FREE','REAL',LSCRATCH,NSCRATCH)
      END IF
      CALL PSBMAT_GETMEM('VMAT',lg_V,NAS)
      IF (myRank.EQ.0) THEN
        CALL GA_Put (lg_V, 1, NAS, 1, NAS, WORK(LVEC), NAS)
        CALL GETMEM('LVEC','FREE','REAL',LVEC,NAS**2)
      END IF
      CALL GADSUM(WORK(LEIG),NAS)
#endif

      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NAS,WORK(LEIG),1)
        WRITE(6,'("DEBUG> ",A,ES21.14)') 'SMAT EIGENVALUE NORM: ', FP
      END IF

      NIN=0
      DO J=1,NAS
        IF(WORK(LEIG+J-1).GE.THRSHS) NIN=NIN+1
      END DO
      NINDEP(ISYM,ICASE)=NIN
      IF (NIN.EQ.0) THEN
        CALL GETMEM('SCA','FREE','REAL',LSCA,NAS)
        CALL GETMEM('LEIG','FREE','REAL',LEIG,NAS)
        CALL GETMEM('SD','FREE','REAL',LSD,NAS)
        bSTAT = GA_Destroy (lg_V)
        RETURN
      END IF

      CALL TIMING(CPU2,CPUE,TIO,TIOE)
      CPU=CPU+CPU2-CPU1

      CALL GETMEM('COND','ALLO','REAL',LCOND,NIN)
      CALL DCOPY_(NIN,[0.0D0],0,WORK(LCOND),1)
C Form orthonormal transformation vectors by scaling the eigenvectors.
      call GA_Sync()
      myRank = GA_NodeID()
      call GA_Distribution (lg_V, myRank, iLo, iHi, jLo, jHi)
      IF (iLo.NE.0) THEN
        call GA_Access (lg_V, iLo, iHi, jLo, jHi, mV, LDV)
        IF ((jHi-jLo+1).NE.NAS) THEN
          WRITE(6,*) 'SBDIAG_MPP: error in striping of lg_V, ABORT'
          CALL ABEND()
        END IF
        call V_SCALE (WORK(LEIG),WORK(LSCA+iLo-1),DBL_MB(mV),
     &              iHi-iLo+1,jHi-jLo+1,LDV,NIN,WORK(LCOND))
        call GA_Release_Update (lg_V, iLo, iHi, jLo, jHi)
      END IF
      call GA_Sync()

      CALL GETMEM('LEIG','FREE','REAL',LEIG,NAS)
      CALL GETMEM('LSCA','FREE','REAL',LSCA,NAS)

C The condition number, after scaling, disregarding linear dep.
C FIXME: adapt to local subroutine for global array lg_V
      IF(NIN.GE.2) THEN
        CALL GADSUM (WORK(LCOND),NIN)
        SZMIN=1.0D99
        SZMAX=0.0D0
        DO I=1,NIN
          SZ=WORK(LCOND+I-1)
          SZMIN=MIN(SZMIN,SZ)
          SZMAX=MAX(SZMAX,SZ)
        END DO
        CONDNR=SZMAX/SZMIN
      END IF
      CALL GETMEM('COND','FREE','REAL',LCOND,NIN)

C Copy the NIN non-linear dependent eigenvectors to the transformation
C matrix T(NAS,NIN).
      CALL GA_CREATE_STRIPED ('H',NAS,NIN,'TMAT',lg_T)
#ifdef _GA_
      call GA_Copy_Patch ('N', lg_V, 1, NAS, 1, NIN,
     &                         lg_T, 1, NAS, 1, NIN)
#else
      call GA_Distribution (lg_V, myRank, iLoV, iHiV, jLoV, jHiV)
      call GA_Distribution (lg_T, myRank, iLoT, iHiT, jLoT, jHiT)
      IF (iLoV.NE.0 .AND. iLoT.NE.0) THEN
        NROW=iHiT-iLoT+1
        NCOL=jHiT-jLoT+1
        call GA_Access (lg_V, iLoV, iHiV, jLoV, jHiV, mV, LDV)
        call GA_Access (lg_T, iLoT, iHiT, jLoT, jHiT, mT, LDT)
        IF (LDV.NE.LDT) THEN
          WRITE(6,'(1X,A)') 'SBDIAG_MPP: LDV != LDT, abort!'
        END IF
        CALL DCOPY_(NROW*NCOL,DBL_MB(mV),1,DBL_MB(mT),1)
        call GA_Release_Update (lg_T, iLoT, iHiT, jLoT, jHiT)
        call GA_Release (lg_V, iLoV, iHiV, jLoV, jHiV)
      END IF
#endif
      bStat = GA_Destroy (lg_V)

      IF(BMATRIX.EQ.'NO      ') THEN
C In some calculations, we do not use B matrices.
C Write the T matrix to disk and exit.  FIXME: This
C should be removed when the transformation matrices are stored as disk
C resident arrays only.
        IF (KING()) THEN
          CALL GETMEM('LTRANS','ALLO','REAL',LTRANS,NAS*NIN)
          call GA_Get (lg_T, 1, NAS, 1, NIN, WORK(LTRANS), NAS)
          IF (iPrGlb.GE.INSANE) THEN
            dTRANS=dNRM2_(NAS*NIN,WORK(LTRANS),1)
            WRITE(6,'("DEBUG> ",A,ES21.14)') 'TMAT NORM: ', dTRANS
          END IF
          IDT=IDTMAT(ISYM,ICASE)
          CALL DDAFILE(LUSBT,1,WORK(LTRANS),NAS*NIN,IDT)
          CALL GETMEM('LTRANS','FREE','REAL',LTRANS,NAS*NIN)
        END IF
        bStat = GA_Destroy (lg_T)
        RETURN
      ELSE IF(BTRANS.NE.'YES') THEN
C In other calculations, the B matrix is used but not transformed.  We
C may need the diagonal active energies, i.e. the diagonal values of B
C divided by the diagonal values of S. These are placed where the
C eigenvalues would go in ordinary CASPT2.
        CALL PSBMAT_GETMEM ('B',lg_B,NAS)
        CALL PSBMAT_READ ('B',iCase,iSym,lg_B,NAS)
        CALL GETMEM('BD','ALLO','REAL',LBD,NAS)
        CALL DCOPY_(NAS,[0.0D0],0,WORK(LBD),1)
        myRank = GA_NodeID()
        call GA_Distribution (lg_B, myRank, iLo, iHi, jLo, jHi)
        ISTA=MAX(ILO,JLO)
        IEND=MIN(IHI,JHI)
        IF (ISTA.NE.0) THEN
          call GA_Access (lg_B, iLo, iHi, jLo, jHi, mB, LDB)
          DO I=ISTA,IEND
            WORK(LBD+I-1)=DBL_MB(mB+I-ILO+LDB*(I-JLO))
          END DO
          call GA_Release (lg_B, iLo, iHi, jLo, jHi)
        END IF
        CALL GADSUM (WORK(LBD),NAS)
        bStat = GA_Destroy (lg_B)
        DO I=1,NAS
          SD=WORK(LSD-1+I)+1.0d-15
          WORK(LBD-1+I)=WORK(LBD-1+I)/SD
        END DO
        IDB=IDBMAT(ISYM,ICASE)
        CALL DDAFILE(LUSBT,1,WORK(LBD),NAS,IDB)
        CALL GETMEM('BD','FREE','REAL',LBD,NAS)
C Write the transformation matrices after the diagonal values of B.
C FIXME: This should be removed when the transformation matrices are
C stored as disk resident arrays only.
        IF (KING()) THEN
          CALL GETMEM('LTRANS','ALLO','REAL',LTRANS,NAS*NIN)
          call GA_Get (lg_T, 1, NAS, 1, NIN, WORK(LTRANS), NAS)
          IF (iPrGlb.GE.INSANE) THEN
            dTRANS=dNRM2_(NAS*NIN,WORK(LTRANS),1)
            WRITE(6,'("DEBUG> ",A,ES21.14)') 'TMAT NORM: ', dTRANS
          END IF
          IDT=IDTMAT(ISYM,ICASE)
          CALL DDAFILE(LUSBT,1,WORK(LTRANS),NAS*NIN,IDT)
          CALL GETMEM('LTRANS','FREE','REAL',LTRANS,NAS*NIN)
        END IF
        bStat = GA_Destroy (lg_T)
        RETURN
      END IF
      CALL GETMEM('SD','FREE','REAL',LSD,NAS)

C TRANSFORM B MATRIX TO O-N BASIS. BUT FIRST, SAVE O-N VECTORS.
      CALL PSBMAT_WRITE ('T',iCase,iSym,lg_T,NAS*NIN)

      IF (IPRGLB.GE.INSANE) THEN
        FP=PSBMAT_FPRINT(lg_T,NAS)
        WRITE(6,'(1X,A,ES21.14)')
     &   'EIGENVECTOR NORM BEFORE B TRANS: ', FP
      END IF

      CALL PSBMAT_GETMEM ('B',lg_B,NAS)
      CALL PSBMAT_READ ('B',iCase,iSym,lg_B,NAS)

      IF (IPRGLB.GE.INSANE) THEN
        FP=PSBMAT_FPRINT(lg_B,NAS)
        WRITE(6,'(1X,A,ES21.14)') 'BMAT NORM: ', FP
      END IF

C FIXME: Perform transformation of B using horizontal stripes of B or
C vertical stripes of T to reduce memory usage if necessary as indicated
C by the available memory, which is now scaling as approx. 3*(NAS**2).
#ifdef _GA_
      CALL GA_CREATE_STRIPED ('H',NAS,NIN,'XMAT',lg_X)
      call GA_DGEMM ('N', 'N', NAS, NIN, NAS, 1.0D0,
     &               lg_B, lg_T, 0.0D0, lg_X )
      bStat = GA_Destroy (lg_B)

      CALL GA_CREATE_STRIPED ('H',NIN,NIN,'BMAT',lg_B)
      call GA_DGEMM ('T', 'N', NIN, NIN, NAS, 1.0D0,
     &               lg_T, lg_X, 0.0D0, lg_B )
      bStat = GA_Destroy (lg_X)
#else
C FIXME: Remove second part if DGA supports DGEMM.
      IF (KING()) THEN
        CALL GETMEM('TMAT','ALLO','REAL',LT,NAS*NIN)
        CALL GA_GET (LG_T, 1, NAS, 1, NIN, WORK(LT), NAS)
        CALL GETMEM('BMAT','ALLO','REAL',LB,NAS*NAS)
        CALL GA_Get (lg_B, 1, NAS, 1, NAS, WORK(LB), NAS)
        CALL GETMEM('XMAT','ALLO','REAL',LX,NAS*NIN)
        CALL DGEMM_ ('N', 'N', NAS, NIN, NAS, 1.0D0,
     &               WORK(LB), NAS, WORK(LT), NAS,
     &               0.0D0, WORK(LX), NAS)
        CALL GETMEM('BMAT','FREE','REAL',LB,NAS*NAS)
      END IF
      bStat = GA_Destroy (lg_B)
      CALL PSBMAT_GETMEM ('B',lg_B,NIN)
      IF (KING()) THEN
        CALL GETMEM('BMAT','ALLO','REAL',LB,NIN*NIN)
        CALL DGEMM_ ('T', 'N', NIN, NIN, NAS, 1.0D0,
     &               WORK(LT), NAS, WORK(LX), NAS,
     &               0.0D0, WORK(LB), NIN)
        CALL GA_Put (lg_B, 1, NIN, 1, NIN, WORK(LB), NIN)
        CALL GETMEM('BMAT','FREE','REAL',LB,NIN*NIN)
        CALL GETMEM('XMAT','FREE','REAL',LX,NAS*NIN)
        CALL GETMEM('TMAT','FREE','REAL',LT,NAS*NIN)
      END IF
#endif
      bStat = GA_Destroy (lg_T)

      IF (IPRGLB.GE.INSANE) THEN
        FP=PSBMAT_FPRINT(lg_B,NIN)
        WRITE(6,'(1X,A,ES21.14)') 'BMAT NORM AFTER TRANS: ', FP
      END IF

      CALL TIMING(CPU1,CPUE,TIO,TIOE)

C Diagonalize the transformed B matrix.
      CALL GETMEM('LEIG','ALLO','REAL',LEIG,NIN)
      CALL DCOPY_(NIN,[0.0D0],0,WORK(LEIG),1)
      IF(BSPECT.NE.'YES')  THEN
C Use diagonal approxim., if allowed.
C        call GA_Fill (lg_V, 0.0D0)
        call GA_Zero (lg_V)
C FIXME: this original code seemed wrong, using uninitialized SD?
*       IDIAG=1
*       DO I=1,NIN
*         WORK(LEIG-1+I)=WORK(LB-1+IDIAG)/SD
*         IDIAG=IDIAG+1+NIN-I
*       END DO
        WRITE(6,*) 'GLOB_SBDIAG: option not implemented'
        call AbEnd()
      ELSE
#ifdef _SCALAPACK_
        CALL GA_CREATE_STRIPED ('H',NIN,NIN,'VMAT',lg_V)
        CALL GA_PDSYEVX_ (lg_B, lg_V, WORK(LEIG), 0)
        bStat = GA_Destroy (lg_B)
#else
        IF (myRank.EQ.0) THEN
          CALL GETMEM('LVEC','ALLO','REAL',LVEC,NIN**2)
          CALL GA_Get (lg_B, 1, NIN, 1, NIN, WORK(LVEC), NIN)
        END IF
        bSTAT = GA_Destroy (lg_B)
        IF (myRank.EQ.0) THEN
          call dsyev_('V','L',NIN,WORK(LVEC),NIN,WORK(LEIG),
     &               WGRONK,-1,INFO)
          NSCRATCH=INT(WGRONK(1))
          CALL GETMEM('SCRATCH','ALLO','REAL',LSCRATCH,NSCRATCH)
          call dsyev_('V','L',NIN,WORK(LVEC),NIN,WORK(LEIG),
     &               WORK(LSCRATCH),NSCRATCH,INFO)
          CALL GETMEM('SCRATCH','FREE','REAL',LSCRATCH,NSCRATCH)
        END IF
        call GA_Sync()
        CALL GA_CREATE_STRIPED ('H',NIN,NIN,'VMAT',lg_V)
        IF (myRank.EQ.0) THEN
          CALL GA_Put (lg_V, 1, NIN, 1, NIN, WORK(LVEC), NIN)
          CALL GETMEM('LVEC','FREE','REAL',LVEC,NIN**2)
        END IF
        CALL GADSUM(WORK(LEIG),NIN)
#endif
      END IF

      IF (IPRGLB.GE.INSANE) THEN
        FP=DNRM2_(NIN,WORK(LEIG),1)
        WRITE(6,'(1X,A,ES21.14)') 'BMAT EIGENVALUE NORM: ', FP
      END IF

C The eigenvalues are written back at same position as the
C original B matrix, which is destroyed:
      IDB=IDBMAT(ISYM,ICASE)
      CALL DDAFILE(LUSBT,1,WORK(LEIG),NIN,IDB)
      CALL GETMEM('LEIG','FREE','REAL',LEIG,NIN)

      CALL TIMING(CPU2,CPUE,TIO,TIOE)
      CPU=CPU+CPU2-CPU1

C Finally, we must form the composite transformation matrix: T(NAS,NIN)
C matrix on disk * V(NIN*NIN) matrix in core.  FIXME: for now, asume
C there is enough memory for the full transformation, scaling as
C approx. 3*(NAS**2).  Should be determined by the available memory.
      CALL GA_CREATE_STRIPED ('H',NAS,NIN,'XMAT',lg_X)
      CALL PSBMAT_READ ('T',iCase,iSym,lg_X,NAS*NIN)
      CALL GA_CREATE_STRIPED ('H',NAS,NIN,'TMAT',lg_T)
#ifdef _GA_
      call GA_DGEMM ('N', 'N', NAS, NIN, NIN, 1.0D0,
     &               lg_X, lg_V, 0.0D0, lg_T )
#else
      IF (KING()) THEN
        CALL GETMEM('XMAT','ALLO','REAL',LX,NAS*NIN)
        CALL GA_GET (LG_X, 1, NAS, 1, NIN, WORK(LX), NAS)
        CALL GETMEM('VMAT','ALLO','REAL',LV,NIN*NIN)
        CALL GA_Get (lg_V, 1, NIN, 1, NIN, WORK(LV), NIN)
        CALL GETMEM('TMAT','ALLO','REAL',LT,NAS*NIN)
        CALL DGEMM_ ('N', 'N', NAS, NIN, NIN, 1.0D0,
     &               WORK(LX), NAS, WORK(LV), NIN,
     &               0.0D0, WORK(LT), NAS)
        CALL GA_Put (lg_T, 1, NAS, 1, NIN, WORK(LT), NAS)
        CALL GETMEM('XMAT','FREE','REAL',LX,NAS*NIN)
        CALL GETMEM('VMAT','FREE','REAL',LV,NIN*NIN)
      END IF
#endif
      bStat = GA_Destroy (lg_X)
      bStat = GA_Destroy (lg_V)

C Write the composite transformation matrix to disk.
      CALL PSBMAT_WRITE ('T',iCase,iSym,lg_T,NAS*NIN)

C Additonally, compute S*T and store in on disk for later use by the RHS
C vector utitlities
      CALL PSBMAT_GETMEM ('S',lg_S,NAS)
      CALL PSBMAT_READ ('S',iCase,iSym,lg_S,NAS)

      CALL GA_CREATE_STRIPED ('H',NAS,NIN,'STMAT',lg_ST)
#ifdef _GA_
      call GA_DGEMM ('N', 'N', NAS, NIN, NAS, 1.0D0,
     &               lg_S, lg_T, 0.0D0, lg_ST )
#else
      IF (KING()) THEN
        CALL GETMEM('SMAT','ALLO','REAL',LS,NAS*NAS)
        CALL GA_GET (LG_S, 1, NAS, 1, NAS, WORK(LS), NAS)
        CALL GETMEM('STMAT','ALLO','REAL',LST,NAS*NIN)
        CALL DGEMM_ ('N', 'N', NAS, NIN, NAS, 1.0D0,
     &               WORK(LS), NAS, WORK(LT), NAS,
     &               0.0D0, WORK(LST), NAS)
        CALL GA_Put (lg_ST, 1, NAS, 1, NIN, WORK(LST), NAS)
        CALL GETMEM('STMAT','FREE','REAL',LST,NAS*NIN)
        CALL GETMEM('SMAT','FREE','REAL',LS,NAS*NAS)
        CALL GETMEM('TMAT','FREE','REAL',LT,NAS*NIN)
      END IF
#endif
      bStat = GA_Destroy (lg_S)

      CALL PSBMAT_WRITE ('M',iCase,iSym,lg_ST,NAS*NIN)
      bStat = GA_Destroy (lg_ST)

C For now, also keep the transformation matrix on disk as a
C replicate array.  FIXME: Should be removed later.
      IF (KING()) THEN
        CALL GETMEM('LTRANS','ALLO','REAL',LTRANS,NAS*NIN)
        call GA_Get (lg_T, 1, NAS, 1, NIN, WORK(LTRANS), NAS)
        dTRANS=dNRM2_(NAS*NIN,WORK(LTRANS),1)
        IF (iPrGlb.GE.INSANE) THEN
          WRITE(6,'("DEBUG> ",A,ES21.14)') 'TMAT NORM: ', dTRANS
        END IF
        IDT=IDTMAT(ISYM,ICASE)
        CALL DDAFILE(LUSBT,1,WORK(LTRANS),NAS*NIN,IDT)
        CALL GETMEM('LTRANS','FREE','REAL',LTRANS,NAS*NIN)
      END IF

      call ga_sync()
      bStat = GA_Destroy (lg_T)

      END

      SUBROUTINE S_SCALE (NAS,SCA,S,iLo,iHi,jLo,jHi,LDS)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
      DIMENSION SCA(NAS),S(LDS,*)
      DO J=jLo,jHi
        DO I=iLo,iHi
        S(I-iLo+1,J-jLo+1)=SCA(I)*SCA(J)*S(I-iLo+1,J-jLo+1)
        END DO
      END DO
      END

      SUBROUTINE V_SCALE (EIG,SCA,V,nRows,NAS,LDV,NIN,COND)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
      DIMENSION EIG(NAS),SCA(NAS),V(LDV,*),COND(NIN)
      jVEC=0
      DO J=1,NAS
        EVAL=EIG(J)
        IF(EVAL.GE.THRSHS) THEN
          jVEC=jVEC+1
          FACT=1.0D00/SQRT(EVAL)
          IF(jVEC.EQ.J) THEN
            CALL DSCAL_(nRows,FACT,V(1,J),1)
          ELSE
            CALL DYAX(nRows,FACT,V(1,J),1,V(1,jVEC),1)
          END IF
        END IF
      END DO
      IF (jVEC.NE.NIN) THEN
        WRITE(6,*) 'V_SCALE: '//
     &      'inconsitency in linear dependence removal, ABORT'
        call AbEnd()
      END IF
C Addition, for the scaled symmetric ON.
      DO I=1,nRows
        CALL DSCAL_(NIN,SCA(I),V(I,1),LDV)
      END DO
C The condition number, after scaling, disregarding linear dep.
      IF(NIN.GE.2) THEN
        DO jVEC=1,NIN
          SZ=0.0D0
          DO iVEC=1,nRows
            SZ=SZ+V(iVEC,jVEC)**2
          END DO
          COND(jVEC)=SZ
        END DO
      END IF
      END
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine o12sa_cvb(nparm1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "opt2_cvb.fh"
#include "malloc_cvb.fh"

      call ddnewopt_cvb()
      have_solved_it=.false.

c  Find CIVBS :
      ivuse=0
      do 10 iv=1,nv
      if(tstcnt_cvb(w(lc(iv)),4))ivuse=iv
10    continue
      ivuse2=3
      if(ivuse.eq.3)ivuse2=2
      if(ivuse2.gt.nv)ivuse2=1
      if(ivuse.ne.0)then
        i1 = mstackr_cvb(nparm1)
        i2 = mstackr_cvb(nparm1)
        i3 = mstackr_cvb(nvb+nprorb)
        call o12sa2_cvb(w(i1),w(i2),nparm1,
     >    w(lc(ivuse2)),w(lc(ivuse)),
     >    w(lw(9)),w(lv(2)),w(i3))
        call mfreer_cvb(i1)
      else
        if(strucopt)then
          call ddguess_cvb(w(lv(2)),nvb,nprorb)
        else
          call ddguess_cvb([one],1,0)
        endif
      endif

      i1 = mstackr_cvb(nparm1)
      call o12sa3_cvb(w(ix(1)),w(lv(2)),
     >  w(lv(1)),w(lw(4)),w(lw(5)),w(lw(6)),
     >  w(lc(1)),w(lc(2)),w(lc(3)),w(lw(9)),w(i1),
     >  nvb,nprorb,nparm1,strucopt)
      call mfreer_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2017, Roland Lindh                                     *
!***********************************************************************

subroutine Start3(CMO,TrM,mBB,nD,OneHam,Ovrlp,mBT)
!***********************************************************************
!                                                                      *
!     purpose: Get starting orbitals from density matrix read as input.*
!                                                                      *
!***********************************************************************

use InfSCF, only: nBas, nBB, nBO, nBT, nSym
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mBB, nD, mBT
real(kind=wp), intent(out) :: CMO(mBB,nD), TrM(mBB,nD)
real(kind=wp), intent(in) :: OneHam(mBT), Ovrlp(mBT)
integer(kind=iwp) :: iD, iSym, nBasX(8), nSymX
character(len=8) :: Location

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

Location = 'Start3'

! Compute transformation matrix
do iD=1,nD
  call TrGen(TrM(:,iD),nBB,Ovrlp,OneHam,nBT)
  CMO(1:nBO,iD) = TrM(1:nBO,iD)
end do

! read old system definitions
! check for compatibility of the calculations

!call get_iScalar('nSym',nSymX)
call Peek_iScalar('nSym',nSymX)
if (nSymX /= nSym) then
  call SysWarnMsg(Location,'Error inconsistent number of Irreps',' ')
  call SysCondMsg('nSymX=nSym',nSymX,'/=',nSym)
end if
call Get_iArray('nBas',nBasX,nSymX)
do iSym=1,nSym
  if (nBasX(iSym) /= nBas(iSym)) then
    call SysWarnMsg(Location,'Error inconsistent nBas',' ')
    call SysCondMsg('nBasX(iSym)=nBas (iSym)',nBasX(iSym),'/=',nBas(iSym))
  end if
end do

! read old density matrix
!call mma_allocate(Dens,nBT,nD,Label='Dens')
!call Get_dArray_chk('D1AO',Dens(:,1),nBT)
!if (nD == 2) then
!  call Get_dArray_chk('D1sao',Dens(:,2),nBT)
!  ! now we need to fix interface - actually we read a+b,a-b
!  call mma_allocate(Tmp,nBT,Label='Tmp')
!  Tmp(:) = Half*(Dens(:,1)-Dens(:,2))
!  Dens(:,1) = Half*(Dens(:,1)+Dens(:,2))
!  Dens(:,2) = Tmp(:)
!  call mma_deallocate(Tmp)
!end if
!call mma_deallocate(Dens)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine Start3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine read_abdata
      implicit none
#include "SysDef.fh"
#include "abtab.fh"
      character(len=*), parameter :: ABDATA_NAME = 'ABDATA'
      integer, parameter :: lu_abdata = 22
      logical :: found_abdata
*
      character(len=8) :: key
      integer :: i, itab, ipos, k, nerr
*
      call f_Inquire(ABDATA_NAME,found_abdata)
      if (.not.found_abdata) then
        call warningmessage(2,
     &              ' the abdata.ascii file does not exist.')
        call abend()
      end if
      call molcas_open(lu_abdata,ABDATA_NAME)

  10  read(lu_abdata,'(a8)') key
      if(key.ne.'NTAB1, N') goto 10
      read(lu_abdata,*) ntab1,ntab2,maxdeg
      nerr=0
      if(ntab2-ntab1+1.gt.mxsiz2) then
        call warningmessage(2,' mxsiz2 is too small in readab.')
        write(6,*)' recompile. needs mxsiz2=',ntab2-ntab1+1
        nerr=1
      end if
      if(maxdeg.gt.mxsiz1) then
        call warningmessage(2,' mxsiz1 is too small in readab.')
        write(6,*)' recompile. needs mxsiz1=',maxdeg
        nerr=1
      end if
      if(nerr.eq.1) call abend()
      ipos=0
      do i=ntab1,ntab2
  20    read(lu_abdata,'(a8)') key
        if(key.ne.'TAB POIN') goto 20
        ipos=ipos+1
        read(lu_abdata,*) itab, tvalue(ipos), p0(ipos)
        read(lu_abdata,*)
        read(lu_abdata,*)(atab(k,ipos),k=0,maxdeg)
        read(lu_abdata,*)
        read(lu_abdata,*)(btab(k,ipos),k=0,maxdeg)
      end do
*
      close (lu_abdata)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1992,1995, Roland Lindh                           *
!***********************************************************************

subroutine CmbnRF1(Rnxyz,nZeta,la,lb,lr,Zeta,rKappa,rFinal,nComp,Fact,Temp,Alpha,Beta,Grad,nGrad,DAO,IfGrad,IndGrd,iStab,jStab, &
                   kOp,EF)
!***********************************************************************
!                                                                      *
! Object: to compute gradient integrals for SC Reaction Fields         *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             Modified for reaction field calculations July '92        *
!             Modified for gradient calculations May '95               *
!***********************************************************************

use Symmetry_Info, only: nIrrep, iChBas
use Index_Functions, only: C_Ind, nTri_Elem1, nTri3_Elem
use Constants, only: Two, Three
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, lr, nComp, nGrad, IndGrd(3,2), iStab, jStab, kOp(2)
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la+1,0:lb+1,0:lr), Zeta(nZeta), rKappa(nZeta), Alpha(nZeta), Beta(nZeta), &
                             DAO(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2), EF(nComp)
real(kind=wp), intent(out) :: rFinal(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp,6), Fact(nZeta), Temp(nZeta)
real(kind=wp), intent(inout) :: Grad(nGrad)
logical(kind=iwp), intent(in) :: IfGrad(3,2)
integer(kind=iwp) :: i1, i2, iCar, iCn, iComp, iEF, iGrad, ipa, ipb, iPrint, ir, iRout, ix, ixa, ixb, iy, iya, iyaMax, iyb, &
                     iybMax, iz, iza, izb, iZeta, nDAO
real(kind=wp) :: Fct, ps, xa, xb, ya, yb, za, zb
real(kind=wp), parameter :: exp32 = -Three/Two
integer(kind=iwp), external :: iPrmt
real(kind=r8), external :: DDot_
#include "print.fh"

iRout = 134
iPrint = nPrint(iRout)
if (iPrint >= 99) then
  call RecPrt(' In CmbnRF1: EF',' ',EF,nComp,1)
end if

do iZeta=1,nZeta
  Fact(iZeta) = rKappa(iZeta)*Zeta(iZeta)**exp32
end do

! Loop over angular components of the basis set

do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        ! Combine multipole moment integrals

        if (IfGrad(1,1)) then
          do ix=0,lr
            do iy=0,lr-ix
              if (ixa > 0) then
                xa = -ixa
                do iZeta=1,nZeta
                  Temp(iZeta) = Fact(iZeta)* &
              (Two*Alpha(iZeta)*Rnxyz(iZeta,1,ixa+1,ixb,ix)+ &
                             xa*Rnxyz(iZeta,1,ixa-1,ixb,ix))* &
                                Rnxyz(iZeta,2,iya,iyb,iy)
                end do
              else
                do iZeta=1,nZeta
                  Temp(iZeta) = Fact(iZeta)* &
               Two*Alpha(iZeta)*Rnxyz(iZeta,1,ixa+1,ixb,ix)* &
                                Rnxyz(iZeta,2,iya,iyb,iy)
                end do
              end if

              do ir=ix+iy,lr
                iz = ir-ix-iy
                iComp = C_Ind(ir,ix,iz)+nTri3_Elem(ir)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,iComp,1) = Temp(iZeta)*Rnxyz(iZeta,3,iza,izb,iz)
                end do
              end do
            end do
          end do
        end if
        if (IfGrad(1,2)) then
          do ix=0,lr
            do iy=0,lr-ix
              if (ixb > 0) then
                xb = -ixb
                do iZeta=1,nZeta
                  Temp(iZeta) = Fact(iZeta)* &
               (Two*Beta(iZeta)*Rnxyz(iZeta,1,ixa,ixb+1,ix)+ &
                             xb*Rnxyz(iZeta,1,ixa,ixb-1,ix))* &
                                Rnxyz(iZeta,2,iya,iyb,iy)
                end do
              else
                do iZeta=1,nZeta
                  Temp(iZeta) = Fact(iZeta)* &
                Two*Beta(iZeta)*Rnxyz(iZeta,1,ixa,ixb+1,ix)* &
                                Rnxyz(iZeta,2,iya,iyb,iy)
                end do
              end if

              do ir=ix+iy,lr
                iz = ir-ix-iy
                iComp = C_Ind(ir,ix,iz)+nTri3_Elem(ir)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,iComp,4) = Temp(iZeta)*Rnxyz(iZeta,3,iza,izb,iz)
                end do
              end do
            end do
          end do
        end if
        if (IfGrad(2,1)) then
          do ix=0,lr
            do iy=0,lr-ix
              if (iya > 0) then
                ya = -iya
                do iZeta=1,nZeta
                  Temp(iZeta) = Fact(iZeta)* &
                                Rnxyz(iZeta,1,ixa,ixb,ix)* &
              (Two*Alpha(iZeta)*Rnxyz(iZeta,2,iya+1,iyb,iy)+ &
                             ya*Rnxyz(iZeta,2,iya-1,iyb,iy))
                end do
              else
                do iZeta=1,nZeta
                  Temp(iZeta) = Fact(iZeta)* &
                                Rnxyz(iZeta,1,ixa,ixb,ix)* &
               Two*Alpha(iZeta)*Rnxyz(iZeta,2,iya+1,iyb,iy)
                end do
              end if

              do ir=ix+iy,lr
                iz = ir-ix-iy
                iComp = C_Ind(ir,ix,iz)+nTri3_Elem(ir)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,iComp,2) = Temp(iZeta)*Rnxyz(iZeta,3,iza,izb,iz)
                end do
              end do
            end do
          end do
        end if
        if (IfGrad(2,2)) then
          do ix=0,lr
            do iy=0,lr-ix
              if (iyb > 0) then
                yb = -iyb
                do iZeta=1,nZeta
                  Temp(iZeta) = Fact(iZeta)* &
                                Rnxyz(iZeta,1,ixa,ixb,ix)* &
               (Two*Beta(iZeta)*Rnxyz(iZeta,2,iya,iyb+1,iy)+ &
                             yb*Rnxyz(iZeta,2,iya,iyb-1,iy))
                end do
              else
                do iZeta=1,nZeta
                  Temp(iZeta) = Fact(iZeta)* &
                                Rnxyz(iZeta,1,ixa,ixb,ix)* &
                Two*Beta(iZeta)*Rnxyz(iZeta,2,iya,iyb+1,iy)
                end do
              end if

              do ir=ix+iy,lr
                iz = ir-ix-iy
                iComp = C_Ind(ir,ix,iz)+nTri3_Elem(ir)
                do iZeta=1,nZeta
                  rFinal(iZeta,ipa,ipb,iComp,5) = Temp(iZeta)*Rnxyz(iZeta,3,iza,izb,iz)
                end do
              end do
            end do
          end do
        end if
        if (IfGrad(3,1)) then
          do ix=0,lr
            do iy=0,lr-ix
              do iZeta=1,nZeta
                Temp(iZeta) = Fact(iZeta)* &
                              Rnxyz(iZeta,1,ixa,ixb,ix)* &
                              Rnxyz(iZeta,2,iya,iyb,iy)
              end do

              do ir=ix+iy,lr
                iz = ir-ix-iy
                iComp = C_Ind(ir,ix,iz)+nTri3_Elem(ir)
                if (iza > 0) then
                  za = -iza
                  do iZeta=1,nZeta
                    rFinal(iZeta,ipa,ipb,iComp,3) = Temp(iZeta)* &
                                  (Two*Alpha(iZeta)*Rnxyz(iZeta,3,iza+1,izb,iz)+ &
                                                 za*Rnxyz(iZeta,3,iza-1,izb,iz))
                  end do
                else
                  do iZeta=1,nZeta
                    rFinal(iZeta,ipa,ipb,iComp,3) = Temp(iZeta)*Two*Alpha(iZeta)*Rnxyz(iZeta,3,iza+1,izb,iz)
                  end do
                end if
              end do
            end do
          end do
        end if
        if (IfGrad(3,2)) then
          do ix=0,lr
            do iy=0,lr-ix
              do iZeta=1,nZeta
                Temp(iZeta) = Fact(iZeta)* &
                              Rnxyz(iZeta,1,ixa,ixb,ix)* &
                              Rnxyz(iZeta,2,iya,iyb,iy)
              end do

              do ir=ix+iy,lr
                iz = ir-ix-iy
                iComp = C_Ind(ir,ix,iz)+nTri3_Elem(ir)
                if (izb > 0) then
                  zb = -izb
                  do iZeta=1,nZeta
                    rFinal(iZeta,ipa,ipb,iComp,6) = Temp(iZeta)* &
                                   (Two*Beta(iZeta)*Rnxyz(iZeta,3,iza,izb+1,iz)+ &
                                                 zb*Rnxyz(iZeta,3,iza,izb-1,iz))
                  end do
                else
                  do iZeta=1,nZeta
                    rFinal(iZeta,ipa,ipb,iComp,6) = Temp(iZeta)*Two*Beta(iZeta)*Rnxyz(iZeta,3,iza,izb+1,iz)
                  end do
                end if
              end do
            end do
          end do
        end if

      end do
    end do
  end do
end do
if (iPrint >= 99) then
  call RecPrt('In CmbnRF1: DAO',' ',DAO,nZeta,nTri_Elem1(la)*nTri_Elem1(lb))
  call RecPrt('In CmbnRF1: rFinal',' ',rFinal,nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp,6)
end if

! Trace the gradient integrals

nDAO = nZeta*(la+1)*(la+2)/2*(lb+1)*(lb+2)/2
do iEF=1,nComp
  do iCn=1,2
    do iCar=1,3
      if (IndGrd(iCar,iCn) /= 0) then
        ! Accumulate contribution to the gradient
        iGrad = abs(IndGrd(iCar,iCn))
        if (iCn == 1) then
          i1 = iCar
          i2 = iCar+3
          ps = real(iPrmt(kOp(1),iChBas(1+iCar)),kind=wp)
          Fct = real(iStab,kind=wp)/real(nIrrep,kind=wp)
        else
          i1 = iCar+3
          i2 = iCar
          ps = real(iPrmt(kOp(2),iChBas(1+iCar)),kind=wp)
          Fct = ps*real(jStab,kind=wp)/real(nIrrep,kind=wp)
        end if
        if (IndGrd(iCar,iCn) < 0) then
          ! Gradient via the translational invariance.
          Grad(iGrad) = Grad(iGrad)-Fct*EF(iEF)*DDot_(nDAO,DAO,1,rFinal(1,1,1,iEF,i2),1)
        else
          Grad(iGrad) = Grad(iGrad)+Fct*EF(iEF)*DDot_(nDAO,DAO,1,rFinal(1,1,1,iEF,i1),1)
        end if
      end if
    end do ! End loop over cartesian components, iCar
  end do   ! End loop over centers, iCn
end do     ! End loop over EF components, iEF

return

end subroutine CmbnRF1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine EigDer(NBSQT,nAshT,DPT2,DPT2C,FPT2AO,FPT2CAO,RDMEIG,CMO,Trf,FPT2,FPT2C,FIFA,FIMO,RDMSA)

use caspt2_global, only: OLag
use caspt2_module, only: NASH, NBAS, NBAST, NDEL, NFRO, NFROT, NISH, NORB, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NBSQT, nAshT
real(kind=wp), intent(in) :: DPT2(NBSQT), DPT2C(NBSQT), FPT2AO(NBSQT), FPT2CAO(NBSQT), CMO(NBSQT), Trf(NBSQT), FPT2(NBSQT), &
                             FPT2C(NBSQT), FIFA(NBSQT), FIMO(NBSQT), RDMSA(nAshT**2)
real(kind=wp), intent(inout) :: RDMEIG(nAshT**2)
integer(kind=iwp) :: iAO, iCMO, iSQ, iSQA, iSym, iT, iTabs, iTU, iTUA, iU, iUabs, nAshI, nBasI, nCor, nFroI, nIshI, nOrbI
real(kind=wp), allocatable :: FPT2_loc(:), FPT2C_loc(:), RDMqc(:), WRK1(:)

call mma_allocate(WRK1,NBSQT,Label='WRK1')
call mma_allocate(FPT2_loc,NBSQT,Label='FPT2_loc')
call mma_allocate(FPT2C_loc,NBSQT,Label='FPT2C_loc')

!! AO -> MO transformation
iCMO = 1
iAO = 1
if (nfrot /= 0) then
  FPT2_loc(1:NBSQT) = FPT2(1:NBSQT)
  FPT2C_loc(1:NBSQT) = FPT2C(1:NBSQT)
else
  do iSym=1,nSym
    iCMO = iCMO+nBas(iSym)*nFro(iSym)
    !iOFF = iWTMP+nBas(iSym)*nBas(iSym)
    if (nOrb(iSym) > 0) then
      nBasI = nBas(iSym)
      nOrbI = nOrb(iSym)
      !! First, FPT2(AO) -> FPT2(MO)
      call DGEMM_('T','N',nOrbI,nBasI,nBasI,One,CMO(iCMO),nBasI,FPT2AO(iAO),nBasI,Zero,WRK1,nOrbI)
      call DGEMM_('N','N',nOrbI,nOrbI,nBasI,One,WRK1,nOrbI,CMO(iCMO),nBasI,Zero,FPT2_loc(iAO),nOrbI)
      !! Second, FPT2C(AO) -> FPT2C(MO)
      call DGEMM_('T','N',nOrbI,nBasI,nBasI,One,CMO(iCMO),nBasI,FPT2CAO(iAO),nBasI,Zero,WRK1,nOrbI)
      call DGEMM_('N','N',nOrbI,nOrbI,nBasI,One,WRK1,nOrbI,CMO(iCMO),nBasI,Zero,FPT2C_loc(iAO),nOrbI)
    end if
    iCMO = iCMO+nBas(iSym)*(nOrb(iSym)+nDel(iSym))
    iAO = iAO+nBasI*nBasI
    !iMO = iMO+nBasI*nBasI
  end do
end if

FPT2_loc(:) = Two*FPT2_loc(:)
FPT2C_loc(:) = Two*FPT2C_loc(:)
!! construct Fock in MO

iSQ = 1
do iSym=1,nSym
  nOrbI = nBas(iSym)-nDel(iSym) !! nOrb(iSym)
  nFroI = nFro(iSym)
  nIshI = nIsh(iSym)
  nAshI = nAsh(iSym)
  ! nSshI = nSsh(iSym)
  ! nDelI = nDel(iSym)
  nCor = nFroI+nIshI
  !! Inactive orbital contributions: (p,q) = (all,inact)
  OLAG(iSQ:iSQ+nOrbI*nCor-1) = OLAG(iSQ:iSQ+nOrbI*nCor-1)+Two*FPT2_loc(iSQ:iSQ+nOrbI*nCor-1)
  !! Active orbital contributions: (p,q) = (all,act)
  call mma_allocate(RDMqc,nAshI**2,Label='RDMqc')
  ! Construct the active density of the orbital energy
  ! Assume the state-averaged density (SS- and XMS-CASPT2)
  !nSeq = 0
  !WRK1(1:nAshI**2) = Zero
  !do iState=1,nState
  !  Wgt = DWgt(iState,iState)/real(nState,kind=wp)
  !  WRK1(1:nDRef) = WRK1(1:nDRef)+Wgt*DMIX(:,iState)
  !end do
  ! RDM of CASSCF
  ! RDMSA is defined by a set of natural orbitals.
  ! Here, we have to transform to a set of quasi-canonical
  ! orbitals (RDMqc), so forward transformation is appropriate.
  !call SQUARE(WRK1,RDMqc,1,nAshI,nAshI)
  RDMqc(1:nAshI**2) = RDMSA(1:nAshI**2)
  !! nbast?
  call DGemm_('T','N',nAshT,nAshT,nAshT,One,Trf(iSQ+nBasT*nCor+nCor),nBasT,RDMqc,nAshT,Zero,WRK1,nAshT)
  call DGemm_('N','N',nAshT,nAshT,nAshT,One,WRK1,nAshT,Trf(iSQ+nBasT*nCor+nCor),nBasT,Zero,RDMqc,nAshT)
  ! Then just multiply with G(DPT2)
  call DGEMM_('N','N',nOrbI,nAshI,nAshI,One,FPT2_loc(iSQ+nOrbI*nCor),nOrbI,RDMqc,nAshI,One,OLAG(iSQ+nOrbI*nCor),nOrbI)
  call mma_deallocate(RDMqc)
  !! From the third term of U_{ij}
  ! FIFA is already in quasi-canonical basis
  !if (nFroI == 0) then
  !  call SQUARE(FIFA(iSQ),WRK1,1,nOrbI,nOrbI)
  !else
  !  call OLagFroSq(iSym,NBSQT,FIFA(iSQ),WRK1)
  !end if
  call DGEMM_('N','T',nOrbI,nOrbI,nOrbI,Two,FIFA(iSQ),nOrbI,DPT2(iSQ),nOrbI,One,OLAG,nOrbI)

  !! explicit derivative of the effective Hamiltonian
  !! dfpq/da = d/da(C_{mu p} C_{nu q} f_{mu nu})
  !!         = f_{mu nu}^a + (C_{mu m} U_{mp} C_{nu q}
  !!                       + C_{mu p} C_{nu m} U_{mq}) * f_{mu nu}
  !!         = f_{mu nu}^a + U_{mp} f_{mq} + U_{mq} f_{pm}
  !! U_{pq}  = f_{pm} df_{qm} + f_{mp} df_{mq}
  call DGEMM_('N','T',nOrbI,nOrbI,nOrbI,One,FIMO(iSQ),nOrbI,DPT2C(iSQ),nOrbI,One,OLAG,nOrbI)
  call DGEMM_('T','N',nOrbI,nOrbI,nOrbI,One,FIMO(iSQ),nOrbI,DPT2C(iSQ),nOrbI,One,OLAG,nOrbI)
  !end if
  !! Implicit derivative of inactive orbitals (DPT2C)
  OLAG(iSQ:iSQ+nOrbI*nCor-1) = OLAG(iSQ:iSQ+nOrbI*nCor-1)+Two*FPT2C_loc(iSQ:iSQ+nOrbI*nCor-1)
  iSQ = iSQ+nOrbI*nOrbI
end do

! ----- CASSCF density derivative contribution in active space

iSQ = 1
iSQA = 1
do iSym=1,nSym
  nOrbI = nBas(iSym)-nDel(iSym) !! nOrb(iSym)
  nFroI = nFro(iSym)
  nIshI = nIsh(iSym)
  nAshI = nAsh(iSym)
  nCor = nFroI+nIshI
  do iT=1,nAshI
    iTabs = nCor+iT
    do iU=1,nAshI
      iUabs = nCor+iU
      iTU = iTabs-1+nOrbI*(iUabs-1)
      iTUA = iT-1+nAshI*(iU-1)
      RDMEIG(iSQA+iTUA) = RDMEIG(iSQA+iTUA)+FPT2_loc(iSq+iTU)
      !write(u6,'(2i3,f20.10)') it,iu,FPT2(iSq+iTU)
    end do
  end do
  iSQ = iSQ+nOrbI*nOrbI
  iSQA = iSQA+nAshI*nAshI
end do

call mma_deallocate(WRK1)
call mma_deallocate(FPT2_loc)
call mma_deallocate(FPT2C_loc)

end subroutine EigDer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombErrorAnalysis(ComputeF,Mode,PackedD,PackedF,nD,FactC,ip_D,F)
! Thomas Bondo Pedersen, January 2011.
!
! Purpose: analyze Coulomb error
!
!      F(uv)-Ftilde(uv)= FactC * sum_kl { (uv|kl)-[uv|kl] } * D(kl)
!
!      where [uv|kl] are the LDF integrals, and compare to the upper bound.
!
! If ComputF: the LDF Fock matrix is computed here
! Else: on input, F should be the Fock matrix computed from
! LDF integrals (replaced with the error on exit)!

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, r8

implicit none
logical(kind=iwp), intent(in) :: ComputeF, PackedD, PackedF
integer(kind=iwp), intent(in) :: Mode, nD, ip_D(nD)
real(kind=wp), intent(inout) :: FactC(nD), F(*)
real(kind=wp) :: Stat(7,3), RMS1, RMS2, RMS3
logical(kind=iwp) :: Add, Packed_myF
integer(kind=iwp) :: ipF, lF, iD, i
real(kind=wp), allocatable :: myF(:)
character(len=*), parameter :: SecNam = 'LDF_Fock_CoulombErrorAnalysis'
logical(kind=iwp), parameter :: PrintNorm = .false.
real(kind=r8), external :: ddot_
#include "localdf_bas.fh"

if (nD < 1) return

! Compute error
call LDF_Fock_CoulombError(PrintNorm,ComputeF,Mode,PackedD,PackedF,nD,FactC,ip_D,F)

! Compute upper bound
Add = .false.
Packed_myF = PackedF
if (Packed_myF) then
  lF = nBas_Valence*(nBas_Valence+1)/2
else
  lF = nBas_Valence**2
end if
call mma_allocate(myF,nD*lF,label='myF')
call LDF_Fock_CoulombUpperBound_Full(PrintNorm,Add,PackedD,Packed_myF,nD,FactC,ip_D,myF)

! Analysis
call Cho_Head('Coulomb Error','-',80,u6)
do iD=1,nD
  ipF = (iD-1)*lF+1
  call Statistics(myF(ipF),lF,Stat(1,1),1,2,3,4,5,6,7)
  RMS1 = dDot_(lF,myF(ipF),1,myF(ipF),1)
  call Statistics(F(ipF),lF,Stat(1,2),1,2,3,4,5,6,7)
  RMS2 = dDot_(lF,F(ipF),1,F(ipF),1)
  do i=1,lF
    myF(ipF-1+i) = myF(ipF-1+i)-abs(F(ipF-1+i))
  end do
  call Statistics(myF(ipF),lF,Stat(1,3),1,2,3,4,5,6,7)
  RMS3 = dDot_(lF,myF(ipF),1,myF(ipF),1)
  write(u6,'(/,2X,A,I10,A)') 'Coulomb error for density',iD,' (Upper bound,Actual,Diff):'
  write(u6,'(2X,A,1P,3D20.10)') 'Average error......',Stat(1,1),Stat(1,2),Stat(1,3)
  write(u6,'(2X,A,1P,3D20.10)') 'Abs average error..',Stat(2,1),Stat(2,2),Stat(2,3)
  write(u6,'(2X,A,1P,3D20.10)') 'Min error..........',Stat(3,1),Stat(3,2),Stat(3,3)
  write(u6,'(2X,A,1P,3D20.10)') 'Max error..........',Stat(4,1),Stat(4,2),Stat(4,3)
  write(u6,'(2X,A,1P,3D20.10)') 'Max abs error......',Stat(5,1),Stat(5,2),Stat(5,3)
  write(u6,'(2X,A,1P,3D20.10)') 'Variance...........',Stat(6,1),Stat(6,2),Stat(6,3)
  write(u6,'(2X,A,1P,3D20.10)') 'Norm...............',sqrt(RMS1),sqrt(RMS2),sqrt(RMS3)
  if (lF > 0) then
    RMS1 = sqrt(RMS1/real(lF,kind=wp))
    RMS2 = sqrt(RMS2/real(lF,kind=wp))
    RMS3 = sqrt(RMS3/real(lF,kind=wp))
  else
    RMS1 = Zero
    RMS2 = Zero
    RMS3 = Zero
  end if
  write(u6,'(2X,A,1P,3D20.10)') 'RMS error..........',RMS1,RMS2,RMS3
  call xFlush(u6)
  if ((Stat(5,1)-Stat(5,2)) < Zero) then
    if (abs(Stat(5,1)-Stat(5,2)) > 1.0e-6_wp) then
      call WarningMessage(2,SecNam//': max abs error is greater than upper bound!')
      call LDF_Quit(1)
    end if
  end if
end do

! Deallocations
call mma_deallocate(myF)

end subroutine LDF_Fock_CoulombErrorAnalysis

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ModGauss(Z,A,Xi,w)
      Implicit Real*8 (a-h,o-z)
#include "constants.fh"
      Real*8 Facts(2,0:12), Errors(0:12), g(2), H(2,2), HInv(2,2),
     &       Step(2)
      Integer A
      Data Facts/ 0.0D0, 0.0D0,
     &            1.0D0, 0.0D0,
     &           -1.0D0, 0.0D0,
     &            2.0D0, 0.0D0,
     &           -2.0D0, 0.0D0,
     &            0.0D0, 1.0D0,
     &            0.0D0,-1.0D0,
     &            0.0D0, 2.0D0,
     &            0.0D0,-2.0D0,
     &            1.0D0, 1.0D0,
     &           -1.0D0, 1.0D0,
     &            1.0D0,-1.0D0,
     &           -1.0D0,-1.0D0/
*                                                                      *
************************************************************************
*                                                                      *
      f(x,w)=(1.0D0+w*x**2)*exp(-x**2)
      R(w)=Sqrt(2.0D0*RMS**2*(3.0D0*w+2.0D0)/(3.0D0*(2.0D0+5.0D0*w)))
      E(x1,x2,w) = (f(x1,w)-0.9D0)**2 + (f(x2,w)-0.1D0)**2
*                                                                      *
************************************************************************
*                                                                      *
C     Write (*,*) 'A=',A
      A3    = 1.0d0*DBLE(A)**(1.0d0/3.0d0)
*     DA Eq. 51
      RMS=0.836d0*A3+0.570d0                    ! fm
      RMS=RMS*1.0D-15/CONST_BOHR_RADIUS_IN_SI_  ! bohr
C     Write (6,*) 'RMS:',RMS
      w=0.0D0
      Xi=1.0D0/R(w)**2
      If (A.le.9) Then
C        Write (*,*) 'Use the Gaussian model!'
         Return
      End If
C     Write (*,*) 'Xi:',Xi
C     Xi=1.5D0/RMS**2
C     Write (*,*) 'Xi:',Xi
*
      T=2.30D0                              ! fm
      T=T*1.0D-15/CONST_BOHR_RADIUS_IN_SI_  ! bohr
*
*     Start seeds
*
      w=0.5D0
      r_90=RMS/2.0D0
*                                                                      *
************************************************************************
*                                                                      *
*     Start of iterations
*
      Thr=1.0D-7
      MaxIter=100
      Iter=0
*
 777  Continue
*
      Iter=Iter+1
C     Write (6,*)
C     Write (6,*) 'Iteration:', Iter
C     Write (6,*) 'w.r_90:', w,r_90
      Delta_w=0.0001D0*w
      Delta_r=0.0001D0*r_90
*                                                                      *
************************************************************************
*                                                                      *
*     The error is a function of r_90 and w
*
C     RMS_s=RMS
C     RMS=RMS*1.0D-15/CONST_BOHR_RADIUS_IN_SI_  ! bohr
C     Write (6,*) 'RMS:',RMS
C     Xi = 1.0D0/R(w)**2
C     Write (*,*) 'Xi=',Xi
C     RMS=RMS_s
      Do i = 0, 12
         w0 = w    + Facts(1,i) * Delta_w
         r0 = r_90 + Facts(2,i) * Delta_r
*
         Errors(i)= E(r0/R(w0),(r0+T)/R(w0),w0)
*
C        If (i.eq.0) Then
C           Write (*,*) 'r_90,f(x_90)=',r0,f(r0    /R(w0),w0)
C           Write (*,*) 'r_10,f(x_10)=',r0+T,f((r0+T)/R(w0),w0)
C           Write (*,*) 'w,R(w)      =',w0,R(w0)
C        End If
*
      End Do
C     Write (*,*) 'Error=',Errors(0)
C     Call RecPrt('Errors',' ',Errors,13,1)
      g(1)=(Errors(1)-Errors(2))/(2.0D0*Delta_w)
      H(1,1)=(Errors(3)+Errors(4)-2.0D0*Errors(0))/(2.0D0*Delta_w)**2
      g(2)=(Errors(5)-Errors(6))/(2.0D0*Delta_r)
      H(2,2)=(Errors(7)+Errors(8)-2.0D0*Errors(0))/(2.0D0*Delta_r)**2
      H(1,2)=(Errors(9)+Errors(12)-Errors(10)-Errors(11))
     &      / ((2.0D0*Delta_w)*(2.0D0*Delta_r))
      H(2,1)=H(1,2)
C     Call RecPrt('gradient',' ',g,1,2)
C     Call RecPrt('Hessian ',' ',H,2,2)
*
      Call DiagMtrx_x(H,2,iNeg)
C     Write (6,*) 'iNeg=',iNeg
C     Call RecPrt('Hessian ',' ',H,2,2)
      Call MInv(H,HInv,iSig,Det,2)
C     Call RecPrt('HInv ',' ',HInv,2,2)
      Step(1)=HInv(1,1)*g(1)+HInv(1,2)*g(2)
      Step(2)=HInv(2,1)*g(1)+HInv(2,2)*g(2)
C     Call RecPrt('Step',' ',Step,1,2)
      Step(1)=Sign(Min(Abs(Step(1)),0.1D0*w),Step(1))
      Step(2)=Sign(Min(Abs(Step(2)),0.1D0*r_90),Step(2))
C     Call RecPrt('Step',' ',Step,1,2)
      w    = w    - Step(1)
      r_90 = r_90 - Step(2)

      If (Iter.lt.MaxIter.and.Errors(0).gt.Thr) Go To 777
      w0=w
      r0=r_90
C     Write (*,*)
C     Write (*,*) 'Iterations:',Iter
C     Write (*,*) 'Error=',Errors(0)
C     Write (*,*) 'r_90,f(x_90)=',r0,f(r0    /R(w0),w0)
C     Write (*,*) 'r_10,f(x_10)=',r0+T,f((r0+T)/R(w0),w0)
C     Write (*,*) 'w,R(w)      =',w0,R(w0)
C     Write (*,*)
*                                                                      *
************************************************************************
*                                                                      *
      Xi=1.0D0/R(w)**2
      w=w*Xi
C     Write (*,*) 'Xi:',Xi
C     Write (*,*) ' w:', w
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(Z)
      End
      Subroutine DiagMtrx_x(H,nH,iNeg)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8, Allocatable :: EVal(:), EVec(:,:), Diag(:,:), HU(:,:)
      Real*8 H(nH,nH)
*
      Lu=6
*
      Call mma_allocate(EVal,nH*(nH+1)/2,label='EVal')
      Call mma_allocate(EVec,nH,nH,label='EVec')
*
*---- Copy elements for H
*
      SumHii=Zero
      Do i = 1, nH
         Do j = 1, i
            ij = i*(i-1)/2 + j
            EVal(ij)=H(i,j)
         End Do
         SumHii=SumHii+H(i,i)
      End Do
*     Write (Lu,*) ' SumHii=',SumHii
*
*---- Set up a unit matrix
*
      call dcopy_(nH*nH,[Zero],0,EVec,1)
      call dcopy_(nH,[One],0,EVec,nH+1)
*
*---- Compute eigenvalues and eigenvectors
*
      Call Jacob (EVal,EVec,nH,nH)
      Call Jacord(EVal,EVec,nH,nH)
*
*---- Print out the result
*
      iNeg=0
      Do i = 1, nH
         ii = i*(i+1)/2
         If (EVal(ii).lt.Zero) iNeg=iNeg+1
      End Do
*
      Call mma_allocate(Diag,nH,nH,label='Diag')
      Call mma_allocate(HU,nH,nH,label='HU')
*
      call dcopy_(nH*nH,[Zero],0,Diag,1)
      Do i = 1, nH
         ii=i*(i+1)/2
         temp = EVal(ii)
C        Write (Lu,'(A,G10.4)') 'Hii=',temp
         Diag(i,i)=Max(Abs(temp),1.0D-15)
      End Do
*
      Call DGEMM_('N','N',
     &            nH,nH,nH,
     &            1.0d0,EVec,nH,
     &                  Diag,nH,
     &            0.0d0,HU,nH)
      Call DGEMM_('N','T',
     &            nH,nH,nH,
     &            1.0d0,HU,nH,
     &                  EVec,nH,
     &            0.0d0,H,nH)
*
      Call mma_deallocate(HU)
      Call mma_deallocate(Diag)
      Call mma_deallocate(EVec)
      Call mma_deallocate(EVal)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine report_cvb(orbs,norb)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: norb
real(kind=wp), intent(in) :: orbs(norb,norb)
real(kind=wp), allocatable :: tmp(:,:)

write(u6,'(/,a)') ' Orbital coefficients :'
write(u6,'(a)') ' ----------------------'
call mxprint_cvb(orbs,norb,norb,0)
write(u6,'(/,a)') ' Overlap between orbitals :'
write(u6,'(a)') ' --------------------------'

call mma_allocate(tmp,norb,norb,label='tmp')
call mxattb_cvb(orbs,orbs,norb,norb,norb,tmp)
call mxprint_cvb(tmp,norb,norb,0)
call mma_deallocate(tmp)

return

end subroutine report_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mkrestgs_cvb(orbsao,irdorbs,cvb,
     >  cvbdet,iapr,ixapr,iabind,cvbdet1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "mo_cvb.fh"
      dimension orbsao(nbas_mo,norb),irdorbs(norb),cvb(nvb)
      dimension cvbdet(ndetvb),iapr(ndetvb),ixapr(nda+1)
      dimension iabind(*),cvbdet1(*)
      dimension idum(1)

      ioffs=0
      call rdis_cvb(idum,1,recn_tmp04,ioffs)
      ndetvb1=idum(1)
      call rdis_cvb(idum,1,recn_tmp04,ioffs)
      norb1=idum(1)
      call rdis_cvb(idum,1,recn_tmp04,ioffs)
      nalf1=idum(1)
      call rdis_cvb(idum,1,recn_tmp04,ioffs)
      nbet1=idum(1)
      if(norb1.ne.norb.or.nalf1.ne.nalf.or.nbet1.ne.nbet)then
        write(6,'(2a)')' Inconsistency between previous and current',
     >    ' VB wavefunction definitions.'
        write(6,*)' NORB now ',norb,' before ',norb1
        write(6,*)' NALF now ',nalf,' before ',nalf1
        write(6,*)' NBET now ',nbet,' before ',nbet1
        call abend_cvb()
      endif
      do 100 iorb=1,norb
      irdorbs(iorb)=1
      call rdrs_cvb(orbsao(1,iorb),norb,recn_tmp04,ioffs)
100   continue
      call rdis_cvb(iabind,ndetvb1,recn_tmp04,ioffs)
      call rdrs_cvb(cvbdet1,ndetvb1,recn_tmp04,ioffs)

      call fzero(cvbdet,ndetvb)
      do 200 idetvb1=1,ndetvb1
c  NDA & string definitions assumed the same :
      ib=(iabind(idetvb1)-1)/nda+1
      ia=iabind(idetvb1)-(ib-1)*nda
      do 300 ixa=ixapr(ia),ixapr(ia+1)-1
      if(ib.eq.iapr(ixa))cvbdet(ixa)=cvbdet1(idetvb1)
300   continue
200   continue
      kbasiscvb=kbasis
      call vb2strc_cvb(cvbdet,cvb)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine TMatrix(TMx)
      Implicit None
************************************************************************
*     subroutine to get the T matrix that defines the constrained and  *
*     unconstrained subspaces.                                         *
************************************************************************
#include "info_slapaf.fh"
#include "real.fh"
#include "stdalloc.fh"
      Real*8, Intent(InOut) :: TMx(mInt,mInt)
*
      Integer Lambda1,Lambda2
      Logical Invert
      Real*8, Allocatable, Dimension(:,:) :: C1,C2,CT
*
*     Get the global constraint vectors
*
      Call mma_Allocate(C1,mInt,nLambda)
      Call get_drdq(C1,Lambda1)
*
*     Get the NG constraint vectors
*
      Call Merge_Constraints('UDC.NG','','UDC',nLambda,iRow_c)
      Call Fix_UDC(iRow_c,nLambda,AtomLbl,nsAtom,nStab,.True.)
      Call mma_Allocate(C2,mInt,nLambda)
      Call get_drdq(C2,Lambda2)
*
*     Combine both sets of constraints and get the T matrix
*
      nLambda=Lambda1+Lambda2
      Call mma_Allocate(CT,mInt,mInt)
      Call dCopy_(mInt*Lambda1,C1,1,CT(1,1),1)
      Call dCopy_(mInt*Lambda2,C2,1,CT(1,Lambda1+1),1)
      Call FZero(CT(1,nLambda+1),mInt*(mInt-nLambda))
      If (nLambda.gt.0) Then
        Call GS(CT,nLambda,TMx,mInt,.False.,.True.)
      Else
        Call FZero(TMx,mInt**2)
        Call dCopy_(mInt,[One],0,TMx,mInt+1)
      End If
*
*     If NG constraints are to be inverted, combine the complement
*     with the global constraints instead
*
      Call Qpg_iScalar('Invert constraints',Invert)
      If (Invert) Call Get_lScalar('Invert constraints',Invert)
      If (Invert) Then
        Lambda2=mInt-nLambda
        Call dCopy_(mInt*Lambda1,C1,1,CT(1,1),1)
        Call dCopy_(mInt*Lambda2,TMx(1,nLambda+1),1,CT(1,Lambda1+1),1)
        nLambda=Lambda1+Lambda2
        Call FZero(CT(1,nLambda+1),mInt*(mInt-nLambda))
        If (nLambda.gt.0) Then
          Call GS(CT,nLambda,TMx,mInt,.False.,.True.)
        Else
          Call FZero(TMx,mInt**2)
          Call dCopy_(mInt,[One],0,TMx,mInt+1)
        End If
      End If
*
      Call mma_Deallocate(C1)
      Call mma_Deallocate(C2)
      Call mma_Deallocate(CT)
*
      End Subroutine TMatrix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine PLF_RI_3(AOint,ijkl,jCmp,kCmp,lCmp,iShell,iAO,iAOst,jBas,kBas,lBas,kOp,TInt,nTInt,iOff,iShlSO,nBasSh,iSOShl,nSO,nShell, &
                    nSym,iSSOff)
!***********************************************************************
!                                                                      *
!  object: to sift and index the petite list format integrals.         *
!                                                                      *
!          the indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          May '90                                                     *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri
use Basis_Info, only: nBas
use SOAO_Info, only: iAOtSO
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ijkl, jCmp, kCmp, lCmp, iShell(4), iAO(4), iAOst(4), jBas, kBas, lBas, kOp(4), nTInt, iOff(3), &
                                 nSO, iShlSO(nSO), nShell, nSym, nBasSh(0:nSym-1,nShell), iSOShl(nSO), iSSOff
real(kind=wp), intent(in) :: AOint(ijkl,jCmp,kCmp,lCmp)
real(kind=wp), intent(_OUT_) :: TInt(nTInt)
integer(kind=iwp) :: i2, i3, i4, iAux, iC, iD, iOff1, iShC, iSOs(4), jSOj, kl, kl_B, kSOk, lCmp_Max, lSOl, n3C, nC, nijkl
logical(kind=iwp) :: Shkl

!                                                                      *
!***********************************************************************
!                                                                      *
!define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
Shkl = iShell(3) == iShell(4)
iOff1 = nBas(0)
n3C = iOff(3)
if (iShell(4) > iShell(3)) then
  write(u6,*) 'iShell(4) > iShell(3)'
  call Abend()
end if

do i2=1,jCmp
  iSOs(2) = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
  do i3=1,kCmp
    iSOs(3) = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
    lCmp_Max = lCmp
    if (Shkl) lCmp_Max = i3
    do i4=1,lCmp_Max
      iSOs(4) = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
      !                                                                *
      !*****************************************************************
      !                                                                *
      if (Shkl .and. (i3 == i4)) then
        !                                                              *
        !***************************************************************
        !                                                              *
        nijkl = 0
        do lSOl=iSOs(4),iSOs(4)+lBas-1
          iD = iShlSO(lSOl)                  ! Relative index
          do kSOk=iSOs(3),iSOs(3)+kBas-1
            iC = iShlSO(kSOk)
            iShC = iSOShl(kSOk)
            nC = nBasSh(0,iShC)

            kl = iTri(iC,iD)+iSSOff

            do jSOj=iSOs(2),iSOs(2)+jBas-1
              nijkl = nijkl+1
              if (lSOl > kSOk) cycle
              iAux = jSOj-iOff1

              kl_B = (iAux-1)*n3C+kl
              TInt(kl_B) = AOint(nijkl,i2,i3,i4)

            end do
          end do
        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      else
        !                                                              *
        !***************************************************************
        !                                                              *
        nijkl = 0
        do lSOl=iSOs(4),iSOs(4)+lBas-1
          iD = iShlSO(lSOl)
          do kSOk=iSOs(3),iSOs(3)+kBas-1
            iC = iShlSO(kSOk)
            iShC = iSOShl(kSOk)
            nC = nBasSh(0,iShC)

            if (Shkl) then
              kl = iTri(iC,iD)
            else
              kl = (iD-1)*nC+iC
            end if
            kl = kl+iSSOff

            do jSOj=iSOs(2),iSOs(2)+jBas-1
              iAux = jSOj-iOff1
              nijkl = nijkl+1

              kl_B = (iAux-1)*n3C+kl
              TInt(kl_B) = AOint(nijkl,i2,i3,i4)

            end do
          end do
        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine PLF_RI_3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_Check(irc)
!
! Purpose: check settings for parallel Cholesky.
!
!-TODO/FIXME: The features not allowed in parallel execution of the
!             Cholesky decomposition should be implemented later. Thus,
!             this subroutine is, in effect, a TODO-list.

use Para_Info, only: Is_Real_Par, nProcs
use Cholesky, only: Cho_AdrVec, Cho_DecAlg, Cho_Fake_Par, Cho_IntChk, Cho_Real_Par, Cho_ReOrd, Cho_SimRI, Cho_SScreen, &
                    Cho_TstScreen, IFCSew, LuPri, MxShPr, RstCho, RstDia
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
logical(kind=iwp) :: WriteBlank

irc = 0
WriteBlank = .true.

if (Cho_Real_Par) then ! TRUE PARALLEL
  if ((Cho_DecAlg /= 4) .and. (Cho_DecAlg /= 5) .and. (Cho_DecAlg /= 6)) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    write(Lupri,'(A)') 'Only possible parallel Cholesky decomposition algorithm is "PARAllel".'
    write(Lupri,'(A,I3,A)') 'Resetting Cho_DecAlg from ',Cho_DecAlg,' to 5 (parallel two-step algorithm),'
    Cho_DecAlg = 5
  end if
  if (MxShPr /= 1) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    write(Lupri,'(A)') 'Max. number of shell pair distributions calculated in each pass is 1 for parallel Cholesky.'
    write(Lupri,'(A,I6,A)') 'Resetting MxShPr from ',MxShPr,' to 1'
    MxShPr = 1
  end if
  if (Cho_IntChk) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    write(Lupri,'(A)') 'You have requested integral checking.'
    write(Lupri,'(A)') 'Integral checking is not possible for parallel Cholesky.'
    irc = irc+1
  end if
  if (RstDia .or. RstCho) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    if (RstDia) then
      write(Lupri,'(A)') 'You have requested diagonal restart.'
      irc = irc+1
    end if
    if (RstCho) then
      write(Lupri,'(A)') 'You have requested decomposition restart.'
      irc = irc+1
    end if
    write(Lupri,'(A)') 'Restart is not possible for parallel Cholesky.'
  end if
  if (Cho_ReOrd) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    write(Lupri,'(A)') 'Vector reordering is not possible for parallel Cholesky.'
    irc = irc+1
  end if
  if (Cho_AdrVec /= 1) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    write(Lupri,'(A)') 'Address mode for vector I/O must be word-addressable for parallel Cholesky.'
    write(Lupri,'(A,I4,A)') 'Resetting Cho_AdrVec from ',Cho_AdrVec,' to 1'
    Cho_AdrVec = 1
  end if
  if (IfcSew /= 2) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    write(Lupri,'(A)') 'Seward interface must be directly in reduced sets for parallel Cholesky.'
    write(Lupri,'(A,I4,A)') 'Resetting IfcSew from ',IfcSew,' to 2'
    IfcSew = 2
  end if
  if (Cho_TstScreen) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    write(Lupri,'(A)') 'Test of subtraction screening is not possible for parallel Cholesky.'
    write(Lupri,'(A)') 'Turning Cho_TstScreen off.'
    Cho_TstScreen = .false.
  end if
  if (Cho_SScreen) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    write(Lupri,'(A)') 'Subtraction screening is not possible for parallel Cholesky.'
    irc = irc+1
  end if
  if (Cho_SimRI) then
    if (WriteBlank) then
      write(Lupri,*)
      WriteBlank = .false.
    end if
    write(Lupri,'(A)') 'Simulation of RI is not possible for parallel Cholesky.'
    irc = irc+1
  end if
else
  if (CHO_FAKE_PAR .and. (nProcs > 1) .and. Is_Real_Par()) then ! FAKE PARALLEL
    if (Cho_ReOrd) then
      if (WriteBlank) then
        write(Lupri,*)
        WriteBlank = .false.
      end if
      write(Lupri,'(A)') 'Vector reordering is not possible for parallel Cholesky.'
      irc = irc+1
    end if
  end if
end if

end subroutine Cho_P_Check

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
#define _Old_Code_
#ifdef _Old_Code_
      SubRoutine Screen_mck(PAO,Scrtch,mPAO,
     &                  nZeta,nEta,mZeta,mEta,lZeta,lEta,
     &                  Zeta,ZInv,P,xA,xB,rKA,
     &                  Data1,IndZ,ztmx,abmax,zexpmax,
     &                  nAlpha,nBeta,
     &                  Eta, EInv,Q,xG,xD,rKC,Data2,IndE,
     &                  etmx,cdmax,eexpmax,nGamma,nDelta,
     &                  xpre,
     &                  iphX1,iphY1,iphZ1,iphX2,iphY2,iphZ2,CutInt,
     &                  PreScr,IndZet,IndEta,ldot)
************************************************************************
*                                                                      *
* Object: to prescreen the integral derivatives.                       *
*                                                                      *
*   nZeta, nEta : unpartioned length of primitives.                    *
*                                                                      *
*   mZeta, mEta : section length due to partioning. These are usually  *
*                 equal to nZeta and nEta.                             *
*                                                                      *
*   lZeta, lEta : section length after prescreening.                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             March '92                                                *
*                                                                      *
*             April '92 modified for gradient estimate                 *
*                                                                      *
*             Anders Bernhardsson 1995                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
      Real*8 PAO(mZeta*mEta*mPAO),Scrtch(mZeta*mEta*(1+mPAO*2)),
     &       Zeta(nZeta), ZInv(nZeta),  P(nZeta,3),
     &        Eta(nEta),  EInv(nEta),   Q(nEta, 3),
     &       xA(nZeta), xB(nZeta), xG(nEta), xD(nEta),
     &       Data1(nZeta*nDArray),
     &       Data2(nEta *nDArray),
     &       rKA(nZeta),rKC(nEta),
     &       xpre(mZeta*mEta)
      Logical PreScr,ldot
      Integer IndEta(nEta),IndZet(nZeta), IndZ(mZeta), IndE(mEta)
#include "real.fh"
#ifdef _DEBUGPRINT_
#include "print.fh"
#endif
*
#ifdef _DEBUGPRINT_
      iRout = 180
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt(' Data1',' ',Data1,nZeta,nDArray)
         Call RecPrt(' Data2',' ',Data2,nEta ,nDArray)
         Call RecPrt('2nd order density matrix',' ',
     &               PAO,mZeta*mEta,mPAO)
      End If
#endif
*
      ip=1
      ipPAO = ip
      ip = ip + mZeta*mEta*mPAO
*
*-----Compress all indices except zeta
*
      ipOAP = ip
      ip = ip + mZeta*mEta*mPAO
      If (ldot) Call DGetMO(PAO,mZeta,mZeta,mEta*mPAO,
     &                      Scrtch(ipOAP),mEta*mPAO)
*
*-----Prescreen Zeta
*
      lZeta=0
      Call IZero(IndZet,nZeta)
      If (PreScr) Then
         Do iZeta = 1, mZeta
            jZeta = IndZ(iZeta)
            IndZet(jZeta) = -lZeta
            abcd= Data1(ip_ab(iZeta,nZeta)) * cdMax
            If (Abs(abcd).ge.CutInt) Then
               lZeta=lZeta+1
               IndZet(jZeta) = lZeta
               Zeta(lZeta)  = Data1(ip_Z(iZeta,nZeta))
               rKA(lZeta)   = Data1(ip_Kappa(iZeta,nZeta))
               P(lZeta,1)   = Data1(ip_PCoor(iZeta        ,nZeta))
               P(lZeta,2)   = Data1(ip_PCoor(iZeta+  nZeta,nZeta))
               P(lZeta,3)   = Data1(ip_PCoor(iZeta+2*nZeta,nZeta))
               xA(lZeta)    = Data1(ip_Alpha(iZeta,nZeta,1))
               xB(lZeta)    = Data1(ip_Beta (iZeta,nZeta,2))
               ZInv(lZeta)  = Data1(ip_ZInv (iZeta,nZeta))
               ip1 = ipOAP + mEta*mPAO*(iZeta-1)
               ip2 = ipPAO + mEta*mPAO*(lZeta-1)
               If (lDot) call dcopy_(mEta*mPAO,Scrtch(ip1),1,
     &                                        Scrtch(ip2),1)
            End If
         End Do
      Else
         Do iZeta = 1, mZeta
            lZeta=lZeta+1
            jZeta = IndZ(iZeta)
            IndZet(jZeta) = lZeta
            Zeta(lZeta)  = Data1(ip_Z(iZeta,nZeta))
            rKA(lZeta)   = Data1(ip_Kappa(iZeta,nZeta))
            P(lZeta,1)   = Data1(ip_PCoor(iZeta        ,nZeta))
            P(lZeta,2)   = Data1(ip_PCoor(iZeta+  nZeta,nZeta))
            P(lZeta,3)   = Data1(ip_PCoor(iZeta+2*nZeta,nZeta))
            xA(lZeta)    = Data1(ip_Alpha(iZeta,nZeta,1))
            xB(lZeta)    = Data1(ip_Beta (iZeta,nZeta,2))
            ZInv(lZeta)  = Data1(ip_ZInv (iZeta,nZeta))
            ip1 = ipOAP + mEta*mPAO*(iZeta-1)
            ip2 = ipPAO + mEta*mPAO*(lZeta-1)
            If (lDot) call dcopy_(mEta*mPAO,Scrtch(ip1),1,
     &                                     Scrtch(ip2),1)
         End Do
      End If
      If (lZeta.eq.0) Go To 999
*
      If (iphX1.ne.1) Call DScal_(lZeta,-One,P(1,1),1)
      If (iphY1.ne.1) Call DScal_(lZeta,-One,P(1,2),1)
      If (iphZ1.ne.1) Call DScal_(lZeta,-One,P(1,3),1)
*
*-----Transpose eta,mPAO,zeta to mPAO,zeta,eta
*
      If (lDot) Call DGetMO(Scrtch(ipPAO),mEta,mEta,mPAO*lZeta,
     &                      Scrtch(ipOAP),mPAO*lZeta)
*
*-----Prescreen Eta
*
      lEta=0
      Call IZero(IndEta,nEta)
      If (PreScr) Then
         Do iEta = 1, mEta
            jEta = IndE(iEta)
            IndEta(jEta) = - lEta ! To be removed
            abcd= Data2(ip_ab(iEta,nEta)) * abMax
            If (Abs(abcd).ge.CutInt) Then
               lEta=lEta+1
               IndEta(jEta) = lEta
               Eta(lEta)   = Data2(ip_Z   (iEta,nEta))
               rKC(lEta)   = Data2(ip_Kappa(iEta,nEta))
               Q(lEta,1)   = Data2(ip_PCoor(iEta       ,nEta))
               Q(lEta,2)   = Data2(ip_PCoor(iEta+  nEta,nEta))
               Q(lEta,3)   = Data2(ip_PCoor(iEta+2*nEta,nEta))
               xG(lEta)    = Data2(ip_Alpha(iEta,nEta,1))
               xD(lEta)    = Data2(ip_Beta (iEta,nEta,2))
               EInv(lEta)  = Data2(ip_ZInv (iEta,nEta))
               ip1 = ipOAP + mPAO*lZeta*(iEta-1)
               ip2 = ipPAO + mPAO*lZeta*(lEta-1)
               If (ldot) call dcopy_(lZeta*mPAO,Scrtch(ip1),1,
     &                                         Scrtch(ip2),1)
            End If
         End Do
      Else
         Do iEta = 1, mEta
            lEta=lEta+1
            jEta = IndE(iEta)
            IndEta(jEta) = lEta
            Eta(lEta)   = Data2(ip_Z   (iEta,nEta))
            rKC(lEta)   = Data2(ip_Kappa(iEta,nEta))
            Q(lEta,1)   = Data2(ip_PCoor(iEta       ,nEta))
            Q(lEta,2)   = Data2(ip_PCoor(iEta+  nEta,nEta))
            Q(lEta,3)   = Data2(ip_PCoor(iEta+2*nEta,nEta))
            xG(lEta)    = Data2(ip_Alpha(iEta,nEta,1))
            xD(lEta)    = Data2(ip_Beta (iEta,nEta,2))
            EInv(lEta)  = Data2(ip_ZInv (iEta,nEta))
            ip1 = ipOAP + mPAO*lZeta*(iEta-1)
            ip2 = ipPAO + mPAO*lZeta*(lEta-1)
            if (ldot) call dcopy_(lZeta*mPAO,Scrtch(ip1),1,
     &                                      Scrtch(ip2),1)
         End Do
      End If
      If (lEta.eq.0) Go To 999
*
      If (iphX2.ne.1) Call DScal_(lEta,-One,Q(1,1),1)
      If (iphY2.ne.1) Call DScal_(lEta,-One,Q(1,2),1)
      If (iphZ2.ne.1) Call DScal_(lEta,-One,Q(1,3),1)
*
*-----Transpose mPAO,zeta,eta to zeta,eta,mPAO
*
      If (ldot) Call DGeTMO(Scrtch(ipPAO),mPAO,mPAO,lZeta*lEta,
     &                                          PAO,lZeta*lEta)
*
 999  Continue
*
      ij = 0
      Do iEta = 1,lEta
         Et   = Eta(iEta)
         rKCD = rkC(iEta)
         Do iZeta = 1,lZeta
            Zt   = Zeta(iZeta)
            rKAB = rkA(iZeta)
            ij = ij + 1
            xpre(ij) = rKAB*rKCD*Sqrt(1.0d0/(Zt+Et))
         End Do
      End Do
      If (ldot) Then
         jPAO = 0
         Do iPAO = 1, mPAO
            Do iZE = 0, lZeta*lEta-1
               jPAO=jPAO+1
               PAO(jPAO)=xpre(iZE+1)*PAO(jPAO)
            End Do
         End Do
      End If
#ifdef _DEBUGPRINT_
      If (iPrint.ge.39) Call RecPrt(' PAO',' ',
     &                              PAO,lZeta*lEta,mPAO)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(ztmx)
         Call Unused_real(zexpmax)
         Call Unused_integer(nAlpha)
         Call Unused_integer(nBeta)
         Call Unused_real(etmx)
         Call Unused_real(eexpmax)
         Call Unused_integer(nGamma)
         Call Unused_integer(nDelta)
      End If
      End
#else
      SubRoutine Screen_mck(PAO,Scrtch,mPAO,
     &                  nZeta,nEta,mZeta,mEta,lZeta,lEta,
     &                  Zeta,ZInv,P,xA,xB,rKA,
     &                  Data1,IndZ,ztmx,abmax,zexpmax,
     &                  nAlpha,nBeta,
     &                  Eta, EInv,Q,xG,xD,rKC,Data2,IndE,
     &                  etmx,cdmax,eexpmax,nGamma,nDelta,
     &                  xpre,
     &                  iphX1,iphY1,iphZ1,iphX2,iphY2,iphZ2,CutInt,
     &                  PreScr,IndZet,IndEta,ldot)
************************************************************************
*                                                                      *
* Object: to prescreen the integral derivatives.                       *
*                                                                      *
*   nZeta, nEta : unpartioned length of primitives.                    *
*                                                                      *
*   mZeta, mEta : section length due to partioning. These are usually  *
*                 equal to nZeta and nEta.                             *
*                                                                      *
*   lZeta, lEta : section length after prescreening.                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             March '92                                                *
*                                                                      *
*             April '92 modified for gradient estimate                 *
*                                                                      *
*             Anders Bernhardsson 1995                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
      Real*8 PAO(mZeta*mEta*mPAO),Scrtch(mZeta*mEta*(1+mPAO*2)),
     &       Zeta(nZeta), ZInv(nZeta),  P(nZeta,3),
     &        Eta(nEta),  EInv(nEta),   Q(nEta, 3),
     &       xA(nZeta), xB(nZeta), xG(nEta), xD(nEta),
     &       Data1(nZeta*nDArray),
     &       Data2(nEta *nDArray),
     &       rKA(nZeta),rKC(nEta),
     &       xpre(mZeta*mEta)
      Logical PreScr,ldot
      Integer IndEta(nEta),IndZet(nZeta), IndZ(mZeta), IndE(mEta)
#include "real.fh"
#ifdef _DEBUGPRINT_
#include "print.fh"
#endif
*
#ifdef _DEBUGPRINT_
      iRout = 180
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt(' Data1',' ',Data1,nZeta,nDArray)
         Call RecPrt(' Data2',' ',Data2,nEta ,nDArray)
         Call RecPrt('2nd order density matrix',' ',
     &               PAO,mZeta*mEta,mPAO)
      End If
#endif
*
      ip=1
      ipPAO = ip
      ip = ip + mZeta*mEta*mPAO
*
*-----Compress all indices except zeta
*
      ipOAP = ip
      ip = ip + mZeta*mEta*mPAO
      If (ldot) Call DGetMO(PAO,mZeta,mZeta,mEta*mPAO,
     &                      Scrtch(ipOAP),mEta*mPAO)
*
*-----Prescreen Zeta
*
      lZeta=0
      If (PreScr) Then
         Do iZeta = 1, mZeta
            jZeta = IndZ(iZeta)
            abcd= Data1(ip_ab(jZeta,nZeta)) * cdMax
            If (Abs(abcd).ge.CutInt) Then
               lZeta=lZeta+1
               IndZet(lZeta) = IndZ(iZeta)
               Zeta(lZeta)  = Data1(ip_Z(iZeta,nZeta))
               rKA(lZeta)   = Data1(ip_Kappa(iZeta,nZeta))
               P(lZeta,1)   = Data1(ip_PCoor(iZeta        ,nZeta))
               P(lZeta,2)   = Data1(ip_PCoor(iZeta+  nZeta,nZeta))
               P(lZeta,3)   = Data1(ip_PCoor(iZeta+2*nZeta,nZeta))
               xA(lZeta)    = Data1(ip_Alpha(iZeta,nZeta,1))
               xB(lZeta)    = Data1(ip_Beta (iZeta,nZeta,2))
               ZInv(lZeta)  = Data1(ip_ZInv (iZeta,nZeta))
               ip1 = ipOAP + mEta*mPAO*(iZeta-1)
               ip2 = ipOAP + mEta*mPAO*(lZeta-1)
               If (lDot) call dcopy_(mEta*mPAO,Scrtch(ip1),1,
     &                                        Scrtch(ip2),1)
            End If
         End Do
      Else
         Do iZeta = 1, mZeta
            lZeta=lZeta+1
            IndZet(lZeta) = IndZ(iZeta)
            Zeta(lZeta)  = Data1(ip_Z(iZeta,nZeta))
            rKA(lZeta)   = Data1(ip_Kappa(iZeta,nZeta))
            P(lZeta,1)   = Data1(ip_PCoor(iZeta        ,nZeta))
            P(lZeta,2)   = Data1(ip_PCoor(iZeta+  nZeta,nZeta))
            P(lZeta,3)   = Data1(ip_PCoor(iZeta+2*nZeta,nZeta))
            xA(lZeta)    = Data1(ip_Alpha(iZeta,nZeta,1))
            xB(lZeta)    = Data1(ip_Beta (iZeta,nZeta,2))
            ZInv(lZeta)  = Data1(ip_ZInv (iZeta,nZeta))
            ip1 = ipOAP + mEta*mPAO*(iZeta-1)
            ip2 = ipOAP + mEta*mPAO*(lZeta-1)
            If (lDot) call dcopy_(mEta*mPAO,Scrtch(ip1),1,
     &                                     Scrtch(ip2),1)
         End Do
      End If
      If (lZeta.eq.0) Go To 999
*
      If (iphX1.ne.1) Call DScal_(lZeta,-One,P(1,1),1)
      If (iphY1.ne.1) Call DScal_(lZeta,-One,P(1,2),1)
      If (iphZ1.ne.1) Call DScal_(lZeta,-One,P(1,3),1)
*
*-----Transpose eta,mPAO,zeta to mPAO,zeta,eta
*
      If (lDot) Call DGetMO(Scrtch(ipOAP),mEta,mEta,mPAO*lZeta,
     &                      Scrtch(ipPAO),mPAO*lZeta)
*
*-----Prescreen Eta
*
      lEta=0
      If (PreScr) Then
         Do iEta = 1, mEta
            jEta = IndE(iEta)
            abcd= Data2(ip_ab(jEta,nEta)) * abMax
            If (Abs(abcd).ge.CutInt) Then
               lEta=lEta+1
               IndEta(lEta) = IndE(iEta)
               Eta(lEta)   = Data2(ip_Z   (iEta,nEta))
               rKC(lEta)   = Data2(ip_Kappa(iEta,nEta))
               Q(lEta,1)   = Data2(ip_PCoor(iEta       ,nEta))
               Q(lEta,2)   = Data2(ip_PCoor(iEta+  nEta,nEta))
               Q(lEta,3)   = Data2(ip_PCoor(iEta+2*nEta,nEta))
               xG(lEta)    = Data2(ip_Alpha(iEta,nEta,1))
               xD(lEta)    = Data2(ip_Beta (iEta,nEta,2))
               EInv(lEta)  = Data2(ip_ZInv (iEta,nEta))
               ip1 = ipPAO + mPAO*lZeta*(iEta-1)
               ip2 = ipPAO + mPAO*lZeta*(lEta-1)
               If (ldot) call dcopy_(lZeta*mPAO,Scrtch(ip1),1,
     &                                         Scrtch(ip2),1)
            End If
         End Do
      Else
         Do iEta = 1, mEta
            lEta=lEta+1
            IndEta(lEta) = IndE(iEta)
            Eta(lEta)   = Data2(ip_Z   (iEta,nEta))
            rKC(lEta)   = Data2(ip_Kappa(iEta,nEta))
            Q(lEta,1)   = Data2(ip_PCoor(iEta       ,nEta))
            Q(lEta,2)   = Data2(ip_PCoor(iEta+  nEta,nEta))
            Q(lEta,3)   = Data2(ip_PCoor(iEta+2*nEta,nEta))
            xG(lEta)    = Data2(ip_Alpha(iEta,nEta,1))
            xD(lEta)    = Data2(ip_Beta (iEta,nEta,2))
            EInv(lEta)  = Data2(ip_ZInv (iEta,nEta))
            ip1 = ipPAO + mPAO*lZeta*(iEta-1)
            ip2 = ipPAO + mPAO*lZeta*(lEta-1)
            if (ldot) call dcopy_(lZeta*mPAO,Scrtch(ip1),1,
     &                                      Scrtch(ip2),1)
         End Do
      End If
      If (lEta.eq.0) Go To 999
*
      If (iphX2.ne.1) Call DScal_(lEta,-One,Q(1,1),1)
      If (iphY2.ne.1) Call DScal_(lEta,-One,Q(1,2),1)
      If (iphZ2.ne.1) Call DScal_(lEta,-One,Q(1,3),1)
*
*-----Transpose mPAO,zeta,eta to zeta,eta,mPAO
*
      If (ldot) Call DGeTMO(Scrtch(ipPAO),mPAO,mPAO,lZeta*lEta,
     &                                          PAO,lZeta*lEta)
*
 999  Continue
*
      ij = 0
      Do iEta = 1,lEta
         Et   = Eta(iEta)
         rKCD = rkC(iEta)
         Do iZeta = 1,lZeta
            Zt   = Zeta(iZeta)
            rKAB = rkA(iZeta)
            ij = ij + 1
            xpre(ij) = rKAB*rKCD*Sqrt(1.0d0/(Zt+Et))
         End Do
      End Do
      If (ldot) Then
         jPAO = 0
         Do iPAO = 1, mPAO
            Do iZE = 0, lZeta*lEta-1
               jPAO=jPAO+1
               PAO(jPAO)=xpre(iZE+1)*PAO(jPAO)
            End Do
         End Do
      End If
#ifdef _DEBUGPRINT_
      If (iPrint.ge.39) Call RecPrt(' PAO',' ',
     &                              PAO,lZeta*lEta,mPAO)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(ztmx)
         Call Unused_real(zexpmax)
         Call Unused_integer(nAlpha)
         Call Unused_integer(nBeta)
         Call Unused_real(etmx)
         Call Unused_real(eexpmax)
         Call Unused_integer(nGamma)
         Call Unused_integer(nDelta)
      End If
      End
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989-1992,1998,1999, Roland Lindh                      *
*               1990, IBM                                              *
*               2000-2015, Valera Veryazov                             *
************************************************************************
      subroutine Grid_it(iRun,ireturn)
c  iRun =1 normal run, 0=truncated from scf
************************************************************************
*                                                                      *
*  Object: Driver for evaluation MO values on a grid.                  *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA     *
*          July '89 - May '90                                          *
*                                                                      *
*          Modified to gradient calculations September 1991 -          *
*          February 1992.                                              *
*                                                                      *
*          Modified to evaluating the spin density and spin density    *
*          gradients on a grid                                         *
*                                                                      *
*          Modified to interface with the MSI Cerius 2.                *
*          April 1998                                                  *
*                                                                      *
*          Modified at June- Sept 1999                                 *
*                                                                      *
*   This code was rewritten from scratch by V. Veryazov                *
*          Lund, 2000-2015                                             *
************************************************************************
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "Molcas.fh"
#include "grid.fh"
c      Character*120 Lines(17)
      Character(Len=1024) INPORB
      Logical DoRys
#include "warnings.fh"
*
*     Prologue
*
      levelprint=IPRINTLEVEL(-1)
      if(iRun.eq.0.and.levelprint.lt.3) then
        levelprint=0
        levelprint=IPRINTLEVEL(levelprint)
      endif
      if(iRun.eq.1) then
      iRout=1
      Call SetTim
*
c      Call bXML('GRID_IT')
*
*     Get the work space size
*
      endif
*
      nDiff=0
      DoRys=.False.
      Call IniSew(DoRys,nDiff)
*
*---- Read the input
*
      iReturn=0
      Call Input_Grid_It(iRun,INPORB,iReturn)
      if (iReturn.eq._RC_INVOKED_OTHER_MODULE_) then
c* take care to close files and release the potential memory...
c       close(unit=LuOrb)
        close(unit=LuVal)
        if(isUHF.eq.1) close(unit=LuVal_ab)
      goto 999
      endif
*
*     Start computing the spin density and spin density gradient
*     at the grid.
*
      Call DrvMO(iRun,INPORB)
*
*-----At the end of the calculation free all memory to check for
*     corruption of the memory.
*
999   continue

      Call ClsSew()
*
*     Epilogue
*
      if(iRun.eq.1) then
c        Call eXML('GRID_IT')
c      else
c      write(6,*) 'Input file for molcasgv was generated'
      endif
c      ireturn=0

      return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETVECINF(IVEC,ISYM,IAB,IPASS,ILOC)
C
C     Purpose: set info for vector IVEC of sym. ISYM.
C
      use ChoSwp, only: InfVec
#include "implicit.fh"
#include "cholesky.fh"

      CHARACTER*13 SECNAM
      PARAMETER (SECNAM = 'CHO_SETVECINF')

      IF (IVEC .GT. MAXVEC) THEN
         WRITE(LUPRI,*) SECNAM,': too many Cholesky vectors!'
         WRITE(LUPRI,*) SECNAM,': symmetry: ',ISYM
         WRITE(LUPRI,*) SECNAM,': max. allowed is ',MAXVEC
         WRITE(LUPRI,*) SECNAM,': please increase max. ',
     &                  'allowed'
         CALL CHO_QUIT('Too many Cholesky vectors in '
     &                 //SECNAM,104)
      ELSE IF (IVEC .EQ. MAXVEC) THEN ! no set next addr.
         INFVEC(IVEC,1,ISYM) = IAB    ! diag. index red. set 1
         INFVEC(IVEC,2,ISYM) = IPASS  ! global red. set
      ELSE
         INFVEC(IVEC,1,ISYM)   = IAB   ! diag. index red. set 1
         INFVEC(IVEC,2,ISYM)   = IPASS ! global red. set
         INFVEC(IVEC+1,4,ISYM) = INFVEC(IVEC,4,ISYM)
     &                         + NNBSTR(ISYM,ILOC) ! next addr.
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine hotred (nx,n,a,d,e,z)
      implicit real*8  (a-h,o-z)
      dimension a(nx*(nx+1)/2),z(nx,nx),d(nx),e(nx)
      if(n.le.2) go to 200
      ij=0
      do 10 i=1,n
      do 11 j=1,i
      ij=ij+1
      z(i,j)=a(ij)
   11 continue
   10 continue
      do 100 ip=2,n
      i=n-ip+2
      l=i-2
      f=z(i,i-1)
      g=0.0d0
      if(l.eq.0) go to 25
      do 20 k=1,l
      g=g+z(i,k)*z(i,k)
   20 continue
   25 h=g+f*f
      if(g.gt.1d-12) go to 30
      e(i)=f
      h=0.0d0
      go to 90
   30 l=l+1
      g=sqrt(h)
      if(f.ge.0.0d0) g=-g
      e(i)=g
      h=h-f*g
      z(i,i-1)=f-g
      f=0.0d0
      do 70 j=1,l
      z(j,i)=z(i,j)/h
      g=0.0d0
      do 40 k=1,j
      g=g+z(j,k)*z(i,k)
   40 continue
      jn=j+1
      if(l.lt.jn) go to 60
      do 50 k=jn,l
      g=g+z(k,j)*z(i,k)
   50 continue
   60 e(j)=g/h
      f=f+g*z(j,i)
   70 continue
      hh=f/(h+h)
      do 80 j=1,l
      f=z(i,j)
      g=e(j)-hh*f
      e(j)=g
      do 81 k=1,j
      z(j,k)=z(j,k)-f* e(k)-g*z(i,k)
   81 continue
   80 continue
   90 d(i)=h
  100 continue
      d(1)=z(1,1)
      z(1,1)=1.0d0
      e(1)=0.0d0
      do 150 i=2,n
      l=i-1
      if(d(i).eq.0.0d0) go to 130
      do 120 j=1,l
      g=0.0d0
      do 110 k=1,l
      g=g+z(i,k)*z(k,j)
  110 continue
      do 121 k=1,l
      z(k,j)=z(k,j)-g*z(k,i)
  121 continue
  120 continue
  130 d(i)=z(i,i)
      z(i,i)=1.0d0
      do 151 j=1,l
      z(i,j)=0.0d0
      z(j,i)=0.0d0
  151 continue
  150 continue
      return
  200 go to (210,220),n
  210 d(1)=a(1)
      e(1)=0.0d0
      z(1,1)=1.0d0
      return
  220 d(1)=a(1)
      d(2)=a(3)
      e(1)=0.0d0
      e(2)=a(2)
      z(1,1)=1.0d0
      z(2,2)=1.0d0
      z(1,2)=0.0d0
      z(2,1)=0.0d0
      return
      end
c
      subroutine qlcm(nx,n,d,e,z)
      implicit real*8 (a-h,o-z)
      dimension z(nx,nx),d(nx),e(nx)
      do 10 i=2,n
      e(i-1)=e(i)
   10 continue
      e(n)=0.0d0
      b=0.0d0
      f=0.0d0
      do 150 l=1,n
      j=0
      h=1d-12*(abs(d(l))+abs(e(l)))
      if(b.ge.h) go to 20
      b=h
   20 do 30 m=l,n
      if(abs(e(m)).le.b) go to 40
   30 continue
   40 if(m.eq.l) go to 140
   50 if(j.eq.nx+1) go to 200
      j=j+1
      g=d(l)
      p=(d(l+1)-g)/(2*e(l))
      r=sqrt(p*p+1.0d0)
      if(p.lt.0.0d0) go to 60
      pp=p+r
      go to 70
   60 pp=p-r
   70 d(l)=e(l)/pp
      h=g-d(l)
      if(l.eq.n)  go to 85
      ll=l+1
      do 80 i=ll,n
      d(i)=d(i)-h
   80 continue
   85 f=f+h
      p=d(m)
      c=1.0d0
      s=0.0d0
      mm=m-1
      do 110 kk=l,mm
      i=mm+l-kk
      g=c*e(i)
      h=c*p
      if(abs(p).lt.abs(e(i))) go to 90
        c=e(i)/p
        r=sqrt(c*c+1.0d0)
      e(i+1)=s*p*r
      s=c/r
      c=1.0d0/r
      go to 100
   90 c=p/e(i)
      r=sqrt(c*c+1.0d0)
      e(i+1)=s*e(i)*r
      s=1.0d0/r
      c=c/r
  100 p=c*d(i)-s*g
      d(i+1)=h+s*(c*g+s*d(i))
      do 111 k=1,n
      h=z(k,i+1)
      z(k,i+1)=s*z(k,i)+c*h
      z(k,i)=c*z(k,i)-s*h
  111 continue
  110 continue
      e(l)=s*p
      d(l)=c*p
      if(abs(e(l)).gt.b) go to 50
  140 d(l)=d(l)+f
  150 continue
      do 180 i=1,n
      k=i
      p=d(i)
      l=i+1
      if(l.gt.n) go to 165
      do 160 j=l,n
      if(d(j).ge.p) go to 160
      k=j
      p=d(j)
  160 continue
  165 if(k.eq.i) go to 180
      d(k)=d(i)
      d(i)=p
      do 170 j=1,n
      p=z(j,i)
      z(j,i)=z(j,k)
      z(j,k)=p
  170 continue
  180 continue
      return
  200 write(6,250)
  250 format(1x///5x,'***the subroutine qlcm is fail,so this',
     *       'computation must stop***')
#ifdef MOLPRO
#else
      call abend()
#endif
#ifdef _XIANEST_
#endif
!     call abend
!      stop
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RdCmo_motra(CMO,Ovlp)
!***********************************************************************
!                                                                      *
! Purpose:                                                             *
! Read molecular orbitals from input                                   *
! iVecTyp=1  : obsolete, regarded as error                             *
! iVecTyp=2  : read from unit INPORB in the same format                *
! iVecTyp=3  : read from an old casscf interface unit JOBIPH.          *
!                                                                      *
!***********************************************************************

#include "intent.fh"

use motra_global, only: FnInpOrb, FnJobIph, iVecTyp, LuInpOrb, LuJobIph, nBas, nDel, nSym, nTot2, VecTit
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(_OUT_) :: CMO(*)
real(kind=wp), intent(in) :: Ovlp(*)
#include "mxdm.fh"
integer(kind=iwp) :: iDisk, iDummy(1), iErr, iPt2, TcJobIph(10)
real(kind=wp) :: Dummy(1)
integer(kind=iwp), allocatable :: itemp2(:)
real(kind=wp), allocatable :: temp2(:)
character, allocatable :: ctemp2(:)
logical(kind=iwp) :: okay

!----------------------------------------------------------------------*
! Read MO coefficients from input                                      *
!----------------------------------------------------------------------*
if (iVecTyp == 1) then
  write(u6,*) 'RdCmo_motra: iVecTyp == 1'
  write(u6,*) 'This error means someone has put a bug into MOTRA!'
  call Abend()
end if
!----------------------------------------------------------------------*
! Read MO coefficients from a formatted vector file                    *
!----------------------------------------------------------------------*
if (iVecTyp == 2) then
  call f_Inquire(FnInpOrb,okay)
  if (okay) then
    call RdVec(FnInpOrb,LuInpOrb,'C',nSym,nBas,nBas,Cmo,Dummy,Dummy,iDummy,VecTit,0,iErr)
  else
    write(u6,*) 'RdCMO_motra: Error finding MO file'
    call Abend()
  end if
end if
!----------------------------------------------------------------------*
! Read MO coefficients from JOBIPH generated by RASSCF                 *
!----------------------------------------------------------------------*
if (iVecTyp == 3) then
  call f_Inquire(FnJobIph,okay)
  if (okay) then
    call DaName(LuJobIph,FnJobIph)
    iDisk = 0
    call iDaFile(LuJobIph,2,TcJobIph,10,iDisk)
    iDisk = TcJobIph(1)
    call mma_allocate(itemp2,max(MxSym,MxRoot),label='itemp2')
    call mma_allocate(temp2,MxRoot,label='temp2')
    call mma_allocate(ctemp2,max(LenIn8*mxOrb,144,4*18*mxTit),label='ctemp2')
    call WR_RASSCF_Info(LuJobIph,2,iDisk,itemp2(1),itemp2(1),itemp2(1),itemp2(1),itemp2,itemp2,itemp2,itemp2,itemp2,mxSym,ctemp2, &
                        LenIn8*mxOrb,itemp2(1),ctemp2,144,ctemp2,4*18*mxTit,temp2(1),itemp2(1),itemp2(1),itemp2,mxRoot,itemp2, &
                        itemp2,itemp2,itemp2(1),itemp2(1),iPt2,temp2)
    call mma_deallocate(itemp2)
    call mma_deallocate(temp2)
    call mma_deallocate(ctemp2)
    iDisk = TcJobIph(2)
    if (iPt2 /= 0) iDisk = TcJobIph(9)
    call dDaFile(LuJobIph,2,Cmo,nTot2,iDisk)
    call DaClos(LuJobIph)
    VecTit = 'JOBIPH'
  else
    write(u6,*) 'RdCMO_motra: Error finding JOBIPH file'
    call Abend()
  end if
end if
!----------------------------------------------------------------------*
! Normal termination                                                   *
!----------------------------------------------------------------------*
call Ortho_Motra(nSym,nBas,nDel,Ovlp,Cmo)

return

end subroutine RdCmo_motra

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,2021,2022, Roland Lindh                           *
!***********************************************************************

subroutine Do_NInt_d()

use nq_Grid, only: GradRho, Grid_AO, iBfn_Index, TabAO, vLapl, vRho, vSigma, vTau, Weights
use nq_Info, only: Functional_type, GGA_type, LDA_type, meta_GGA_type1, meta_GGA_type2
use Constants, only: Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: iCB, iGrid, mGrid, nBfn, nD
real(kind=wp) :: gx, gxa, gxb, gy, gya, gyb, gz, gza, gzb, Temp0, Temp0a, Temp0b, Temp1, Temp1a, Temp1b, Temp2, Temp2a, Temp2b, &
                 Temp3, Temp3a, Temp3b, Temp4, Temp45, Temp45a, Temp45b, Temp4a, Temp4b, Temp5, Temp5a, Temp5b, Tmp, Tmp1, Tmp2

!                                                                      *
!***********************************************************************
!                                                                      *
nD = size(Grid_AO,4)
mGrid = size(TabAO,2)
nBfn = size(iBfn_Index,2)
!                                                                      *
!***********************************************************************
!                                                                      *
select case (Functional_type)

  case (LDA_type)
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    ! F(Rho)
    !
    ! for the integrals we need:
    !
    ! phi_i dF/dRho phi_j
    !
    ! Grid_AO contains
    ! 1: phi_i dF/dRho
    !
    ! Final integral assembled as, done in do_nIntx.
    !
    ! Grid_AO(1)_i phi_j
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    select case (nD)
      !                                                                *
      !*****************************************************************
      !                                                                *
      case (1)
        !                                                              *
        !***************************************************************
        !                                                              *
        do iGrid=1,mGrid

          !if (Rho(1,iGrid) < Thr) cycle
          Tmp = vRho(1,iGrid)*Weights(iGrid)

          do iCB=1,nBfn
            Grid_AO(1,iGrid,iCB,1) = TabAO(1,iGrid,iCB)*Tmp
          end do

        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      case (2)
        !                                                              *
        !***************************************************************
        !                                                              *
        do iGrid=1,mGrid

          !if (Rho(1,iGrid)+Rho(2,iGrid) < Thr) cycle
          Tmp1 = vRho(1,iGrid)*Weights(iGrid)
          Tmp2 = vRho(2,iGrid)*Weights(iGrid)

          do iCB=1,nBfn
            Grid_AO(1,iGrid,iCB,1) = TabAO(1,iGrid,iCB)*Tmp1
            Grid_AO(1,iGrid,iCB,2) = TabAO(1,iGrid,iCB)*Tmp2
          end do

        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      case default
        write(u6,*) 'Invalid nD value:',nD
        call Abend()
    end select  ! nD
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  case (GGA_type)
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    ! F(Rho,Sigma) : Sigma=GradRho*GradRho
    !
    ! dF/dGradRho = dF/dSigma dSigma/dGradRho = 2 dF/dSigma GradRho
    !
    ! for the integrals we need:
    !
    !    phi_i dF/dRho phi_j
    ! +  phi_i 2 (dF/dSigma) {GradRho Grad(phi_j)}
    ! +  {Grad(phi_i) GradRho} 2 (dF/dSigma) phi_j
    !
    ! Grid_AO contains
    !    1:  0.5 * phi_i dF/dRho
    !      + {Grad(phi_i GradRho} 2 (dF/dSigma)
    !
    ! Final integral assembled as, done in do_nIntx.
    !
    !    Grid_AO(1)_i phi_j
    !  + phi_i Grid_AO(1)_j
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    select case (nD)
      !                                                                *
      !*****************************************************************
      !                                                                *
      case (1)
        !                                                              *
        !***************************************************************
        !                                                              *
        do iGrid=1,mGrid

          !if (Rho(1,iGrid) < Thr) cycle
          gx = GradRho(1,iGrid)*Weights(iGrid)
          gy = GradRho(2,iGrid)*Weights(iGrid)
          gz = GradRho(3,iGrid)*Weights(iGrid)

          Temp0 = Half*vRho(1,iGrid)*Weights(iGrid)
          Temp1 = gx*Two*vSigma(1,iGrid)
          Temp2 = gy*Two*vSigma(1,iGrid)
          Temp3 = gz*Two*vSigma(1,iGrid)

          do iCB=1,nBfn

            Grid_AO(1,iGrid,iCB,1) = TabAO(1,iGrid,iCB)*Temp0+TabAO(2,iGrid,iCB)*Temp1+TabAO(3,iGrid,iCB)*Temp2+ &
                                     TabAO(4,iGrid,iCB)*Temp3
          end do

        end do
        !                                                              *
        !**************************************************************
        !                                                              *
      case (2)
        !                                                              *
        !***************************************************************
        !                                                              *
        do iGrid=1,mGrid

          !if (Rho(1,iGrid)+Rho(2,iGrid) < Thr) cycle
          gxa = Gradrho(1,iGrid)*Weights(iGrid)
          gya = Gradrho(2,iGrid)*Weights(iGrid)
          gza = Gradrho(3,iGrid)*Weights(iGrid)
          gxb = Gradrho(4,iGrid)*Weights(iGrid)
          gyb = Gradrho(5,iGrid)*Weights(iGrid)
          gzb = Gradrho(6,iGrid)*Weights(iGrid)

          Temp0a = Half*vRho(1,iGrid)*Weights(iGrid)
          Temp0b = Half*vRho(2,iGrid)*Weights(iGrid)
          Temp1a = Two*vSigma(1,iGrid)*gxa+vSigma(2,iGrid)*gxb
          Temp1b = Two*vSigma(3,iGrid)*gxb+vSigma(2,iGrid)*gxa
          Temp2a = Two*vSigma(1,iGrid)*gya+vSigma(2,iGrid)*gyb
          Temp2b = Two*vSigma(3,iGrid)*gyb+vSigma(2,iGrid)*gya
          Temp3a = Two*vSigma(1,iGrid)*gza+vSigma(2,iGrid)*gzb
          Temp3b = Two*vSigma(3,iGrid)*gzb+vSigma(2,iGrid)*gza

          do iCB=1,nBfn

            Grid_AO(1,iGrid,iCB,1) = TabAO(1,iGrid,iCB)*Temp0a+TabAO(2,iGrid,iCB)*Temp1a+TabAO(3,iGrid,iCB)*Temp2a+ &
                                     TabAO(4,iGrid,iCB)*Temp3a
            Grid_AO(1,iGrid,iCB,2) = TabAO(1,iGrid,iCB)*Temp0b+TabAO(2,iGrid,iCB)*Temp1b+TabAO(3,iGrid,iCB)*Temp2b+ &
                                     TabAO(4,iGrid,iCB)*Temp3b
          end do

        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      case default
        write(u6,*) 'Invalid nD value:',nD
        call Abend()
    end select  ! nD
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  case (meta_GGA_type1)
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    ! F(Rho,Sigma,Tau) : Sigma=GradRho*GradRho
    !
    ! dF/dGradRho = dF/dSigma dSigma/dGradRho = 2 dF/dSigma GradRho
    !
    ! for the integrals we need:
    !
    !    phi_i dF/dRho phi_j
    ! +  phi_i 2 (dF/dSigma) {GradRho Grad(phi_j)}
    ! +  {Grad(phi_i) GradRho} 2 (dF/dSigma) phi_j
    ! +  dF/dTau {Grad(phi_i) Grad(phi_j)}
    !
    ! Grid_AO contains
    !    1: 0.5 * phi_i dF/dRho + {Grad(phi_i) GradRho} 2 (dF/dSigma)
    !    2: Grad(phi_i)_x dF/dTau
    !    3: Grad(phi_i)_y dF/dTau
    !    4: Grad(phi_i)_z dF/dTau
    !
    ! Final integral assembled as, done in do_nIntx.
    !
    !    Grid_AO(1)_i phi_j
    !  + Phi_i * Grid_AO(1)_j
    !  + Grid_AO(2)_i Grad(phi_j)_x
    !  + Grid_AO(3)_i Grad(phi_j)_y
    !  + Grid_AO(4)_i Grad(phi_j)_z
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    select case (nD)
      !                                                                *
      !*****************************************************************
      !                                                                *
      case (1)
        !                                                              *
        !***************************************************************
        !                                                              *
        do iGrid=1,mGrid

          !if (Rho(1,iGrid) < Thr) cycle
          gx = GradRho(1,iGrid)*Weights(iGrid)
          gy = GradRho(2,iGrid)*Weights(iGrid)
          gz = GradRho(3,iGrid)*Weights(iGrid)

          Temp0 = Half*vRho(1,iGrid)*Weights(iGrid)
          Temp1 = gx*Two*vSigma(1,iGrid)
          Temp2 = gy*Two*vSigma(1,iGrid)
          Temp3 = gz*Two*vSigma(1,iGrid)

          Temp4 = Half*vTau(1,iGrid)*Weights(iGrid)

          do iCB=1,nBfn

            Grid_AO(1,iGrid,iCB,1) = TabAO(1,iGrid,iCB)*Temp0+TabAO(2,iGrid,iCB)*Temp1+TabAO(3,iGrid,iCB)*Temp2+ &
                                     TabAO(4,iGrid,iCB)*Temp3
            Grid_AO(2,iGrid,iCB,1) = TabAO(2,iGrid,iCB)*Temp4
            Grid_AO(3,iGrid,iCB,1) = TabAO(3,iGrid,iCB)*Temp4
            Grid_AO(4,iGrid,iCB,1) = TabAO(4,iGrid,iCB)*Temp4
          end do

        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      case (2)
        !                                                              *
        !***************************************************************
        !                                                              *
        do iGrid=1,mGrid

          !if (Rho(1,iGrid)+Rho(2,iGrid) < Thr) cycle
          gxa = Gradrho(1,iGrid)*Weights(iGrid)
          gya = Gradrho(2,iGrid)*Weights(iGrid)
          gza = Gradrho(3,iGrid)*Weights(iGrid)
          gxb = Gradrho(4,iGrid)*Weights(iGrid)
          gyb = Gradrho(5,iGrid)*Weights(iGrid)
          gzb = Gradrho(6,iGrid)*Weights(iGrid)

          Temp0a = Half*vRho(1,iGrid)*Weights(iGrid)
          Temp0b = Half*vRho(2,iGrid)*Weights(iGrid)
          Temp1a = Two*vSigma(1,iGrid)*gxa+vSigma(2,iGrid)*gxb
          Temp1b = Two*vSigma(3,iGrid)*gxb+vSigma(2,iGrid)*gxa
          Temp2a = Two*vSigma(1,iGrid)*gya+vSigma(2,iGrid)*gyb
          Temp2b = Two*vSigma(3,iGrid)*gyb+vSigma(2,iGrid)*gya
          Temp3a = Two*vSigma(1,iGrid)*gza+vSigma(2,iGrid)*gzb
          Temp3b = Two*vSigma(3,iGrid)*gzb+vSigma(2,iGrid)*gza
          Temp4a = Half*vTau(1,iGrid)*Weights(iGrid)
          Temp4b = Half*vTau(2,iGrid)*Weights(iGrid)

          do iCB=1,nBfn

            Grid_AO(1,iGrid,iCB,1) = TabAO(1,iGrid,iCB)*Temp0a+TabAO(2,iGrid,iCB)*Temp1a+TabAO(3,iGrid,iCB)*Temp2a+ &
                                     TabAO(4,iGrid,iCB)*Temp3a
            Grid_AO(2,iGrid,iCB,1) = TabAO(2,iGrid,iCB)*Temp4a
            Grid_AO(3,iGrid,iCB,1) = TabAO(3,iGrid,iCB)*Temp4a
            Grid_AO(4,iGrid,iCB,1) = TabAO(4,iGrid,iCB)*Temp4a

            Grid_AO(1,iGrid,iCB,2) = TabAO(1,iGrid,iCB)*Temp0b+TabAO(2,iGrid,iCB)*Temp1b+TabAO(3,iGrid,iCB)*Temp2b+ &
                                     TabAO(4,iGrid,iCB)*Temp3b
            Grid_AO(2,iGrid,iCB,2) = TabAO(2,iGrid,iCB)*Temp4b
            Grid_AO(3,iGrid,iCB,2) = TabAO(3,iGrid,iCB)*Temp4b
            Grid_AO(4,iGrid,iCB,2) = TabAO(4,iGrid,iCB)*Temp4b

          end do

        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      case default
        write(u6,*) 'Invalid nD value:',nD
        call Abend()
    end select  ! nD
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  case (meta_GGA_type2)
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    ! F(Rho,Sigma,Tau,Lapl) : Sigma=GradRho*GradRho
    !
    ! dF/dGradRho = dF/dSigma dSigma/dGradRho = 2 dF/dSigma GradRho
    !
    ! for the integrals we need:
    !
    !    phi_i dF/dRho phi_j
    ! +  phi_i 2 dF/dSigma {GradRho Grad(phi_j)}
    ! +  {Grad(phi_i) GradRho} 2 (dF/dSigma) phi_j
    ! +  dF/dTau {Grad(phi_i) Grad(phi_j)}
    ! +  dF/dLapl Lapl(phi_i) phi_j
    ! +  dF/dLapl 2 {Grad(phi_i) Grad(phi_j)}
    ! +  dF/dLapl phi_i Lapl(phi_j)
    !
    ! Grid_AO contains
    !    1: 0.5 phi_i dF/dRho + {Grad(phi_i) GradRho} 2 (dF/dSigma)
    !      +Lapl(phi_i) dF/dLapl
    !    2: Grad(phi_i)_x (dF/dTau + 2 dF/dLapl)
    !    3: Grad(phi_i)_y (dF/dTau + 2 dF/dLapl)
    !    4: Grad(phi_i)_z (dF/dTau + 2 dF/dLapl)
    !
    ! Final integral assembled as, done in do_nIntx.
    !
    !    Grid_AO(1)_i phi_j
    !  + phi_i Grid_AO(1)_j
    !  + Grid_AO(2)_i Grad(phi_j)_x
    !  + Grid_AO(3)_i Grad(phi_j)_y
    !  + Grid_AO(4)_i Grad(phi_j)_z
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    select case (nD)
      !                                                                *
      !*****************************************************************
      !                                                                *
      case (1)
        !                                                              *
        !***************************************************************
        !                                                              *

        do iGrid=1,mGrid

          !if (Rho(1,iGrid) < Thr) cycle
          gx = GradRho(1,iGrid)*Weights(iGrid)
          gy = GradRho(2,iGrid)*Weights(iGrid)
          gz = GradRho(3,iGrid)*Weights(iGrid)

          Temp0 = Half*vRho(1,iGrid)*Weights(iGrid)
          Temp1 = gx*Two*vSigma(1,iGrid)
          Temp2 = gy*Two*vSigma(1,iGrid)
          Temp3 = gz*Two*vSigma(1,iGrid)

          Temp4 = Half*vTau(1,iGrid)*Weights(iGrid)
          Temp5 = vLapl(1,iGrid)*Weights(iGrid)
          Temp45 = Temp4+Two*Temp5

          do iCB=1,nBfn

            Grid_AO(1,iGrid,iCB,1) = TabAO(1,iGrid,iCB)*Temp0+TabAO(2,iGrid,iCB)*Temp1+TabAO(3,iGrid,iCB)*Temp2+ &
                                     TabAO(4,iGrid,iCB)*Temp3+(TabAO(5,iGrid,iCB)+TabAO(8,iGrid,iCB)+TabAO(10,iGrid,iCB))*Temp5
            Grid_AO(2,iGrid,iCB,1) = TabAO(2,iGrid,iCB)*Temp45
            Grid_AO(3,iGrid,iCB,1) = TabAO(3,iGrid,iCB)*Temp45
            Grid_AO(4,iGrid,iCB,1) = TabAO(4,iGrid,iCB)*Temp45
          end do

        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      case (2)
        !                                                              *
        !***************************************************************
        !                                                              *
        do iGrid=1,mGrid

          !if (Rho(1,iGrid)+Rho(2,iGrid) < Thr) cycle
          gxa = Gradrho(1,iGrid)*Weights(iGrid)
          gya = Gradrho(2,iGrid)*Weights(iGrid)
          gza = Gradrho(3,iGrid)*Weights(iGrid)
          gxb = Gradrho(4,iGrid)*Weights(iGrid)
          gyb = Gradrho(5,iGrid)*Weights(iGrid)
          gzb = Gradrho(6,iGrid)*Weights(iGrid)

          Temp0a = Half*vRho(1,iGrid)*Weights(iGrid)
          Temp0b = Half*vRho(2,iGrid)*Weights(iGrid)
          Temp1a = Two*vSigma(1,iGrid)*gxa+vSigma(2,iGrid)*gxb
          Temp1b = Two*vSigma(3,iGrid)*gxb+vSigma(2,iGrid)*gxa
          Temp2a = Two*vSigma(1,iGrid)*gya+vSigma(2,iGrid)*gyb
          Temp2b = Two*vSigma(3,iGrid)*gyb+vSigma(2,iGrid)*gya
          Temp3a = Two*vSigma(1,iGrid)*gza+vSigma(2,iGrid)*gzb
          Temp3b = Two*vSigma(3,iGrid)*gzb+vSigma(2,iGrid)*gza
          Temp4a = Half*vTau(1,iGrid)*Weights(iGrid)
          Temp4b = Half*vTau(2,iGrid)*Weights(iGrid)
          Temp5a = vLapl(1,iGrid)*Weights(iGrid)
          Temp5b = vLapl(2,iGrid)*Weights(iGrid)
          Temp45a = Temp4a+Two*Temp5a
          Temp45b = Temp4b+Two*Temp5b

          do iCB=1,nBfn

            Grid_AO(1,iGrid,iCB,1) = TabAO(1,iGrid,iCB)*Temp0a+TabAO(2,iGrid,iCB)*Temp1a+TabAO(3,iGrid,iCB)*Temp2a+ &
                                     TabAO(4,iGrid,iCB)*Temp3a+(TabAO(5,iGrid,iCB)+TabAO(8,iGrid,iCB)+TabAO(10,iGrid,iCB))*Temp5a
            Grid_AO(2,iGrid,iCB,1) = TabAO(2,iGrid,iCB)*Temp45a
            Grid_AO(3,iGrid,iCB,1) = TabAO(3,iGrid,iCB)*Temp45a
            Grid_AO(4,iGrid,iCB,1) = TabAO(4,iGrid,iCB)*Temp45a

            Grid_AO(1,iGrid,iCB,2) = TabAO(1,iGrid,iCB)*Temp0b+TabAO(2,iGrid,iCB)*Temp1b+TabAO(3,iGrid,iCB)*Temp2b+ &
                                     TabAO(4,iGrid,iCB)*Temp3b+(TabAO(5,iGrid,iCB)+TabAO(8,iGrid,iCB)+TabAO(10,iGrid,iCB))*Temp5b
            Grid_AO(2,iGrid,iCB,2) = TabAO(2,iGrid,iCB)*Temp45b
            Grid_AO(3,iGrid,iCB,2) = TabAO(3,iGrid,iCB)*Temp45b
            Grid_AO(4,iGrid,iCB,2) = TabAO(4,iGrid,iCB)*Temp45b
          end do

        end do
        !                                                              *
        !***************************************************************
        !                                                              *
      case default
        write(u6,*) 'Invalid nD value:',nD
        call Abend()
    end select  ! nD
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  case default
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    write(u6,*) 'DFT_Int: Illegal functional type!'
    call Abend()
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
end select
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Do_NInt_d

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Fock_CoulombOnly(IntegralOption,
     &                                Timing,Mode,ThrPS,
     &                                Add,PackedD,PackedF,
     &                                nD,FactC,ip_D,ip_F)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Compute Coulomb contribution to Fock matrix using local
C              Density Fitting coefficients.
C
C     Args:    - IntegralOption (integer)
C                  111  => use two-electron integrals computed from
C                          LDF coefficients (for debugging)
C                  222  => use conventional two-electron integrals
C                          (for debugging)
C                  333  => use conventional or LDF two-electron
C                          integrals depending on positivity of the
C                          latter (for debugging)
C                  444  => use exact integral diagonal (blocks), all
C                          other blocks are LDF
C                  all other values => use production-level LDF code
C                  (INPUT)
C              - Timing (boolean) .True. if detailed timing (incl total)
C                should be printed from this routine (INPUT)
C              - Mode (integer) 1:robust, 2:nonrobust, 3:half-and-half
C                to be used (INPUT)
C              - ThrPS(2): prescreening thresholds (INPUT)
C                          ThrPS(1): integral prescreening threshold
C                          ThrPS(2): prescreening threshold on
C                                    contributions
C              - Add (boolean): .True. if Coulomb contribution should be
C                added to the Fock matrix (INPUT). Not available in
C                parallel execution!!
C              - PackedD (boolean): .True. if density matrices
C                are stored in lower triangular format; else quadratic
C                storage (INPUT)
C              - PackedF (boolean): .True. if Fock matrices
C                are stored in lower triangular format; else quadratic
C                storage (INPUT)
C              - nD: Number of densities/Fock matrices (INPUT)
C              - FactC(nD): scaling factor for each density (INPUT)
C              - ip_D(nD): pointers to nD density matrices (if PackedD:
C                lower triangular storage) (INPUT)
C              - ip_F(nD): pointers to nD Fock matrices (if PackedF:
C                lower triangular storage) (INPUT)
C
C              If (Add):  [NOT IMPLEMENTED IN PARALLEL]
C       (1)       F(uv) = F(uv) + FactC * sum_kl (uv|kl)*D(kl)
C              Else:
C       (2)       F(uv) = FactC * sum_kl (uv|kl)*D(kl)
C
C              where the integrals are given by the robust LDF
C              representation (Mode=1)
C
C              (uv|kl) = ([uv]|kl) + (uv|[kl]) - ([uv]|[kl])
C
C              or the non-robust representation (Mode=2)
C
C              (uv|kl) = ([uv]|[kl])
C
C              or the half-and-half representation (Mode=3)
C
C              (uv|kl) = 0.5*([uv]|kl) + 0.5*(uv|[kl])
C
C              The fitted products are given by
C
C              |[uv]) = sum_J C(uv,J) |J)
C
C              where the fitting functions |J) are centered on the atom
C              pair to which the product |uv) belongs.
C
C              In more detail (assuming robust fitting representation):
C
C              F(uv) = FactC * {sum_J C(uv,J)*W(J) + sum_K (uv|K)*V(K)}
C
C              W(J) = sum_kl (J|kl)*D(kl) - sum_K (J|K)*V(K)
C
C              V(K) = sum_kl C(kl,K)*D(kl)
C
C     NOTES:
C       - The density matrices are assumed to be symmetric.
C       - It is the complete sum over kl in Eqs(1,2)! This means that
C         the input density matrices should NOT be scaled by 2 on the
C         off-diagonal (scaling factors are handled internally).
C       - LDF information must be properly set up before calling this
C         routine (use subroutine LDF_X_Init).
C       - Two-center functions may or mat not be included in the fitting
C         basis for a given atom pair.
C       - The algorithm is integral driven: the integrals are computed
C         once.
C       - The fitting coefficients are read from disk twice (for Coulomb
C         [V] intermediates and for the final contractions to give the
C         Fock matrix). This is not a problem if they are fully
C         buffered, but could impose an I/O bottleneck. Since the number
C         of coefficients scales linearly with system size, this should
C         be less of a problem than the quadratic scaling of full
C         Cholesky vectors.
C       - The max number of processes for which the algorithm can
C         possibly scale well equals the number of LDF atom pairs.
C       - Integral prescreening info will be set up here if not done
C         prior to calling this routine.
C       - Add is not implemented in parallel !!!
C
C     ALGORITHM:
C=======================================================================
C
C
C     If (Mode=3): FactC := 0.5*FactC
C     Scale off-diagonal density blocks:
C                  D[u_A v_B] <-- 2*D[u_A v_B] iff A != B
C
C     Initialize V(J)=0 for all J
C     *Parallel loop over atom pairs AB (A>=B):
C        - V(J) += sum_[u_A v_B] C(u_A v_B,J)*D(u_A v_B)
C          where J belongs to AB [1C and 2C funcs].
C     *End parallel loop AB
C     Add V over nodes.
C
C     Initialize F(uv) for all significant uv.
C     Initialize W(J) for all J.
C
C     If (Mode=1 or Mode=3):
C        Compute 3-index contributions:
C        *Parallel loop over atom pairs AB (A>=B):
C           *Loop over atoms C
C              - Compute (u_A v_B|K) for K belonging to C [1C func]
C              - F(u_A v_B) += sum_K (u_A v_B|K)*V(K)
C              - W(K) += sum_[u_A v_B] (u_A v_B|K)*D(u_A v_B)
C           *End loop C
C           If (LDF2):
C              *loop over atom pairs CD
C                 - Compute (u_A v_B|K) for K belonging to CD [2C func]
C                 - F(u_A v_B) += sum_[K] (u_A v_B|K)*V(K)
C                 - W(K) += sum_[u_A v_B] (u_A v_B|K)*D(u_A v_B)
C              *End loop over CD
C           End If
C        *End parallel loop AB
C     End If
C
C     Compute 2-index contributions:
C     If (Mode=1 or Mode=2):
C        If (Mode=1):
C           - const=-1.0d0
C        Else:
C           - const=1.0d0
C        End If
C        *Parallel loop over atoms A:
C           *Loop over atoms B=1,A-1:
C              - Compute (J|K) for J in A and K in B [1C func]
C              - W(J) += const * sum_K (J|K)*V(K)
C              - W(K) += const * sum_J V(J)*(J|K)
C           *End loop B
C           - Compute (J|K) for J,K in A [1C func]
C           - W(J) += const* sum_K (J|K)*V(K)
C           If (LDF2):
C              *Loop over atom pairs CD (C>=D):
C                 - Compute (J|K) for J in A [1C func], K in CD [2Cfunc]
C                 - W(J) += const * sum_K (J | K)*V(K)
C                 - W(K) += const * sum_J V(J)*(J|K)
C              *End loop CD
C           End If
C        *End parallel loop A
C        If (LDF2):
C           *Parallel loop over atom pairs AB (A>=B):
C              *Loop over atom pairs CD=1,AB-1:
C                 - Compute (J|K) for J in AB and K in CD [2C func]
C                 - W(J) += const * sum_K (J|K)*V(K)
C                 - W(K) += const * sum_J V(J)*(J|K)
C              *End loop B
C              - Compute (J|K) for J,K in AB [2C func]
C              - W(J) += const* sum_K (J|K)*V(K)
C           *End loop AB
C        End If
C     End If
C     Add W over nodes
C
C     *Parallel loop over atom pairs AB (A>=B):
C        - Read coefficient C(u_A v_B,J) for J in AB [1C,2C func]
C        - F(u_A v_B) += sum_J C(u_a v_B,J)*W(J)
C     *End parallel loop AB
C     Add F over nodes
C
C     ALGORITHM DONE: Return F
C=======================================================================
C
C     Note that arrays V, W, and F are stored locally as O(N) arrays,
C     which should keep the communication bottleneck reasonable as the
C     system size grows.
C
C     Integral prescreening is based on the Cauchy-Schwarz inequality
C     and involves estimation of the max integral in a given block.
C     Integral prescreening is done at atom/atom pair block level as
C     well as on shell level.
C
C     Contribution prescreening is based on the submultiplicative
C     property of the Frobenius norm in combination with the Cauchy-
C     Schwarz inequality for positive (semi-) definite matrices.
C     Specifically, an upper bound to the norm of the matrix-vector
C     product
C
C     y = A*x
C
C     where A is a subblock of a positive (semi-) definite matrix,
C     is given by
C
C     ||y|| <= ||A||*||x||                  {submultiplicative property}
C            = sqrt[sum_ij A(i,j)**2]*sqrt[sum_j x(j)**2]
C           <= sqrt[sum_ij A(i,i)*A(j,j)]*sqrt[sum_j x(j)**2]
C                                                       {Cauchy-Schwarz}
C            = sqrt[sum_i A(i,i)]*sqrt[sum_j A(j,j)]*sqrt[sum_j x(j)**2]
C
C     This upper bound is used to avoid calculation of contributions
C     below a given threshold. Contribution prescreening is done at
C     atom/atom pair block level only, f.ex. for K on atom C
C
C     ||sum_K (AB|K)*V(K)|| <= sqrt[sum_[u_A v_B] (u_A v_B | u_A v_B)]
C                             *sqrt[sum_K (K|K)]
C                             *sqrt[sum_K V(K)**2]
C
      Implicit None
      Integer IntegralOption
      Logical Timing
      Integer Mode
      Real*8  ThrPS(2)
      Logical Add
      Logical PackedD
      Logical PackedF
      Integer nD
      Real*8  FactC(nD)
      Integer ip_D(nD)
      Integer ip_F(nD)
#include "para_info.fh"
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Character*20 SecNam
      Parameter (SecNam='LDF_Fock_CoulombOnly')

      Logical  LDF_IntegralPrescreeningInfoIsSet
      External LDF_IntegralPrescreeningInfoIsSet

      Integer  LDF_nAtom
      External LDF_nAtom

#if defined (_DEBUGPRINT_)
      Logical  LDF_X_IsSet, LDF_TestBlockMatrix
      External LDF_X_IsSet, LDF_TestBlockMatrix
      Logical  DoTest
      Real*8   x, y
#endif

      Logical UseOldCode
      Logical IPI_set_here

      Real*8 tau(2)

      Integer i
      Integer nBas
      Integer iD, ip0, l
      Integer ip_DBlocks, l_DBlocks
      Integer ip_FBlocks, l_FBlocks
      Integer ip_VP, l_VP
      Integer ip_DNorm, l_DNorm
      Integer ip_CNorm, l_CNorm
      Integer ip_VNorm, l_VNorm
      Integer ip_FactC, l_FactC

      Real*8 tTotC1, tTotC2
      Real*8 tTotW1, tTotW2

      ! Start total timing.
      If (Timing) Then
         Write(6,'(/,84A1)') ('-',i=1,84)
         Call CWTime(tTotC1,tTotW1)
      End If

      UseOldCode=IntegralOption.eq.111 .or. IntegralOption.eq.222 .or.
     &           IntegralOption.eq.333
      If (UseOldCode) Then
         Call WarningMessage(0,
     &                   SecNam//': Using atom pair-driven (old) code!')
         Call xFlush(6)
         Call LDF_Fock_CoulombOnly0(IntegralOption,ThrPS(1),
     &                              Mode,Add,PackedD,PackedF,
     &                              nD,FactC,ip_D,ip_F)
         Go To 1 ! Return
      End If

      ! Return if nothing to do
      If (nD.lt.1) Go To 1

      ! Get number of basis functions (from localdf_bas.fh)
      nBas=nBas_Valence
      If (nBas.lt.1) Then
         Call WarningMessage(1,
     &                  SecNam//': nBas<1 -- Fock matrix NOT computed!')
         Write(6,'(A,I9)') 'nBas=',nBas
         Call xFlush(6)
         Go To 1  ! return
      End If

#if defined (_DEBUGPRINT_)
      If (.not.LDF_X_IsSet()) Then
         Call WarningMessage(2,SecNam//': LDF data not initialized!')
         Call LDF_Quit(1)
      End If
#endif

#if defined (_MOLCAS_MPP_)
      If (Add) Then
         If (nProcs.gt.1 .and. Is_Real_Par()) Then
            Write(6,'(A,A)') SecNam,
     &        ': >>Add<< feature not implemented in parallel execution!'
            Call LDF_NotImplemented()
         End If
      End If
#endif

      ! For half-and-half integral representation, scale FactC by 1/2.
      ! Save a copy of FactC (restored at the end)
      If (Mode.eq.3) Then
         l_FactC=nD
         Call GetMem('FactCBak','Allo','Real',ip_FactC,l_FactC)
         Call dCopy_(nD,FactC,1,Work(ip_FactC),1)
         Call dScal_(nD,0.5d0,FactC,1)
      Else
         l_FactC=0
         ip_FactC=0
      End If

      ! Set prescreening info (if not already done)
      If (.not.LDF_IntegralPrescreeningInfoIsSet()) Then
         Call LDF_SetIntegralPrescreeningInfo()
         IPI_set_here=.True.
      Else
         IPI_set_here=.False.
      End If
      tau(1)=max(ThrPS(1),0.0d0) ! integral prescreening threshold
      tau(2)=max(ThrPS(2),0.0d0) ! contribution prescreening threshold

      ! Initialize Fock matrices (if not Add)
      If (.not.Add) Then
         If (PackedF) Then
            l=nBas*(nBas+1)/2
         Else
            l=nBas**2
         End If
         Do iD=1,nD
            Call Cho_dZero(Work(ip_F(iD)),l)
         End Do
      End If

      ! Allocate and set blocked density matrices (atom pair blocks)
      l_DBlocks=nD
      Call GetMem('DBlk_P','Allo','Inte',ip_DBlocks,l_DBlocks)
      ip0=ip_DBlocks-1
#if defined (_DEBUGPRINT_)
      x=dble(NumberOfAtomPairs)
      y=dble(LDF_nAtom())*(dble(LDF_nAtom())+1.0d0)/2.0d0
      DoTest=int(x-y).eq.0
#endif
      Do iD=1,nD
         Call LDF_AllocateBlockMatrix('Den',iWork(ip0+iD))
         Call LDF_Full2Blocked(Work(ip_D(iD)),PackedD,iWork(ip0+iD))
#if defined (_DEBUGPRINT_)
         If (DoTest) Then
            If (.not.LDF_TestBlockMatrix(iWork(ip0+iD),PackedD,
     &                                   Work(ip_D(iD)))) Then
               Call WarningMessage(2,
     &                            SecNam//': block matrix test failure')
               Write(6,'(A,I4,A,I9,3X,A,L1)')
     &         'Density matrix',iD,' at location',ip_D(iD),
     &         'Packed: ',PackedD
               Call LDF_Quit(1)
            End If
         End If
#endif
         Call LDF_ScaleOffdiagonalMatrixBlocks(iWork(ip0+iD),2.0d0)
      End Do

      ! Allocate and set blocked Fock matrices (atom pair blocks)
      l_FBlocks=nD
      Call GetMem('FBlk_P','Allo','Inte',ip_FBlocks,l_FBlocks)
      ip0=ip_FBlocks-1
      Do iD=1,nD
         Call LDF_AllocateBlockMatrix('Fck',iWork(ip0+iD))
         Call LDF_Full2Blocked(Work(ip_F(iD)),PackedF,iWork(ip0+iD))
      End Do

      ! Allocate and compute Frobenius norm of blocked density matrices
      l_DNorm=NumberOfAtomPairs*nD
      Call GetMem('DNorm','Allo','Real',ip_DNorm,l_DNorm)
      ip0=ip_DNorm
      Do iD=0,nD-1
         Call LDF_BlockMatrixNorm(iWork(ip_DBlocks+iD),ip0)
         ip0=ip0+NumberOfAtomPairs
      End Do

      ! Allocate Coulomb intermediates
      l_VP=nD
      Call GetMem('VP','Allo','Inte',ip_VP,l_VP)
      Do iD=0,nD-1
         Call LDF_AllocateAuxBasVector('CIn',iWork(ip_VP+iD))
      End Do

      ! Allocate array for norm of fitting coefficients
      l_CNorm=4*NumberOfAtomPairs
      Call GetMem('CNorm','Allo','Real',ip_CNorm,l_CNorm)

      ! Compute Coulomb intermediates
      ! V(J) = sum_uv C(uv,J)*D(uv)
      ! for each density matrix
      ! Compute Frobenius norm of fitting coefficients.
      Call LDF_ComputeCoulombIntermediates(Timing,nD,iWork(ip_DBlocks),
     &                                            iWork(ip_VP),ip_CNorm)

      ! Allocate and compute Frobenius norm of Coulomb intermediates
      l_VNorm=(LDF_nAtom()+NumberOfAtomPairs)*nD
      Call GetMem('VNorm','Allo','Real',ip_VNorm,l_VNorm)
      ip0=ip_VNorm
      Do iD=0,nD-1
         Call LDF_AuxBasVectorNorm(iWork(ip_VP+iD),ip0)
         ip0=ip0+LDF_nAtom()+NumberOfAtomPairs
      End Do

      ! Compute Coulomb contributions
      Call LDF_Fock_CoulombOnly_(IntegralOption.eq.444,Timing,Mode,tau,
     &                           nD,FactC,iWork(ip_DBlocks),
     &                           iWork(ip_VP),iWork(ip_FBlocks),
     &                           ip_CNorm,ip_DNorm,ip_VNorm)

      ! Get full storage (triangular or quadratic) Fock matrices from
      ! blocked ones.
      ip0=ip_FBlocks-1
      Do iD=1,nD
         Call LDF_Blocked2Full(iWork(ip0+iD),PackedF,Work(ip_F(iD)))
      End Do

      ! Deallocation
      Call GetMem('VNorm','Free','Real',ip_VNorm,l_VNorm)
      Call GetMem('CNorm','Free','Real',ip_CNorm,l_CNorm)
      Do iD=0,nD-1
         Call LDF_DeallocateAuxBasVector('CIn',iWork(ip_VP+iD))
      End Do
      Call GetMem('VP','Free','Inte',ip_VP,l_VP)
      Call GetMem('DNorm','Free','Real',ip_DNorm,l_DNorm)
      Do iD=0,nD-1
         Call LDF_DeallocateBlockMatrix('Fck',iWork(ip_FBlocks+iD))
      End Do
      Call GetMem('FBlk_P','Free','Inte',ip_FBlocks,l_FBlocks)
      Do iD=0,nD-1
         Call LDF_DeallocateBlockMatrix('Den',iWork(ip_DBlocks+iD))
      End Do
      Call GetMem('DBlk_P','Free','Inte',ip_DBlocks,l_DBlocks)

      ! Unset prescreening info (if set in this routine)
      If (IPI_set_here) Then
         Call LDF_UnsetIntegralPrescreeningInfo()
      End If

      ! Restore FactC
      If (l_FactC.gt.0) Then
         Call dCopy_(nD,Work(ip_FactC),1,FactC,1)
         Call GetMem('FactCBak','Free','Real',ip_FactC,l_FactC)
      End If

    1 Continue
      If (Timing) Then
         Call CWTime(tTotC2,tTotW2)
         Write(6,'(A,A,A,2(1X,F12.2),A)')
     &   'Total time spent in ',SecNam,':         ',
     &   tTotC2-tTotC1,tTotW2-tTotW1,' seconds'
         Write(6,'(84A1)') ('-',i=1,84)
         Call xFlush(6)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Fock_CoulombOnly_(UseExactIntegralDiagonal,
     &                                 Timing,Mode,tau,
     &                                 nD,FactC,ip_DBlocks,ip_V,
     &                                 ip_FBlocks,
     &                                 ip_CNorm,ip_DNorm,ip_VNorm)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Compute Coulomb contributions to the Fock matrix using
C              Coulomb intermediates V. Integral-driven algorithm.
C
C     See LDF_Fock_CoulombOnly for more details.
C
      Implicit None
      Logical UseExactIntegralDiagonal
      Logical Timing
      Integer Mode
      Real*8  tau(2)
      Integer nD
      Real*8  FactC(nD)
      Integer ip_DBlocks(nD)
      Integer ip_V(nD)
      Integer ip_FBlocks(nD)
      Integer ip_CNorm
      Integer ip_DNorm
      Integer ip_VNorm
#include "WrkSpc.fh"
#include "localdf.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_integral_prescreening_info.fh"
#include "ldf_a2ap.fh"
#include "para_info.fh"

      Character*21 SecNam
      Parameter (SecNam='LDF_Fock_CoulombOnly_')

      Logical  Rsv_Tsk
      External Rsv_Tsk

      Integer  LDF_nAtom, LDF_nBas_Atom, LDF_nBasAux_Atom
      Integer  LDF_nBasAux_Pair_wLD
      External LDF_nAtom, LDF_nBas_Atom, LDF_nBasAux_Atom
      External LDF_nBasAux_Pair_wLD

      Integer ip_WBlkP, l_WBlkP
      Integer iD
      Integer nAtom
      Integer TaskListID
      Integer jAB, AB, A, B
      Integer CD, C
      Integer nuv, M, MA, MB, MAB, MCD
      Integer ip_Int, l_Int
      Integer ipD, ipV, ipF, ipW
      Integer ip_C, l_C, ipC
      Integer ip_tauW, l_tauW, ip_tauWA
      Integer ip, l
      Integer ip_VNrm, l_VNrm
      Integer ip_DNrm, l_DNrm

      Real*8  Const
      Real*8  tC1, tC2, tIC1, tIC2
      Real*8  tW1, tW2, tIW1, tIW2
      Real*8  tIC, tIW
      Real*8  tauW
      Real*8  GABCD, GCDAB

      Integer i, j
      Integer ip_W
      Integer AP_Atoms
      Integer AP_2CFunctions
      Integer A2AP
      Real*8  IAB
      Real*8  GA, GAB
      Real*8  VA, VAB
      Real*8  DAB
      Real*8  CAB_A, CAB_B, CAB_AB
      ip_W(i)=iWork(ip_WBlkP-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      A2AP(i,j)=iWork(ip_A2AP-1+2*(j-1)+i)
      IAB(i)=Work(ip_IDiag_Sm-1+i)
      GA(i)=Work(ip_GDiag_1C_Sm-1+i)
      GAB(i)=Work(ip_GDiag_2C_Sm-1+i)
      VA(i)=Work(ip_VNrm-1+i)
      VAB(i)=Work(ip_VNrm-1+nAtom+i)
      DAB(i)=Work(ip_DNrm-1+i)
      CAB_A(i)=Work(ip_CNorm+4*(i-1)+1)
      CAB_B(i)=Work(ip_CNorm+4*(i-1)+2)
      CAB_AB(i)=Work(ip_CNorm+4*(i-1)+3)

      ! Get number of atoms
      nAtom=LDF_nAtom()

      ! Set up prescreening info
      If (nD.eq.1) Then
         l_VNrm=0
         ip_VNrm=ip_VNorm
         l_DNrm=0
         ip_DNrm=ip_DNorm
      Else
         l_VNrm=nAtom+NumberOfAtomPairs
         Call GetMem('VNrm','Allo','Real',ip_VNrm,l_VNrm)
         Call Cho_dZero(Work(ip_VNrm),l_VNrm)
         Do iD=0,nD-1
            ip=ip_VNorm+(nAtom+NumberOfAtomPairs)*iD
            Do AB=0,nAtom+NumberOfAtomPairs-1
               Work(ip_VNrm+AB)=max(Work(ip_VNrm+AB),Work(ip+AB))
            End Do
         End Do
         l_DNrm=NumberOfAtomPairs
         Call GetMem('DNrm','Allo','Real',ip_DNrm,l_DNrm)
         Call Cho_dZero(Work(ip_DNrm),l_DNrm)
         Do iD=0,nD-1
            ip=ip_DNorm+NumberOfAtomPairs*iD
            Do AB=0,NumberOfAtomPairs-1
               Work(ip_DNrm+AB)=max(Work(ip_DNrm+AB),Work(ip+AB))
            End Do
         End Do
      End If
      l_tauW=nAtom+NumberOfAtomPairs
      Call GetMem('tauW','Allo','Real',ip_tauW,l_tauW)
      If (tau(2).gt.0.0d0) Then
         Call LDF_SetA2AP()
         Do A=1,nAtom
            l=A2AP(1,A)
            ip=A2AP(2,A)-1
            ip_tauWA=ip_tauW-1+A
            Work(ip_tauWA)=0.0d0
            Do jAB=1,l
               AB=iWork(ip+jAB)
               If (AP_Atoms(1,AB).eq.A) Then
                  Work(ip_tauWA)=max(Work(ip_tauWA),CAB_A(AB))
               Else If (AP_Atoms(2,AB).eq.A) Then
                  Work(ip_tauWA)=max(Work(ip_tauWA),CAB_B(AB))
               Else
                  Call WarningMessage(2,
     &                                 SecNam//': logical error [A2AP]')
                  Call LDF_Quit(1)
               End If
            End Do
            If (Work(ip_tauWA).gt.1.0d-16) Then
               tauW=tau(2)/Work(ip_tauWA)
            Else
               tauW=1.0d99
            End If
            Work(ip_tauWA)=tauW
         End Do
         Call LDF_UnsetA2AP()
         Do AB=1,NumberOfAtomPairs
            If (AP_2CFunctions(1,AB).gt.0) Then
               If (CAB_AB(AB).gt.1.0d-16) Then
                  Work(ip_tauW-1+nAtom+AB)=tau(2)/CAB_AB(AB)
               Else
                  Work(ip_tauW-1+nAtom+AB)=1.0d99
               End If
            Else
               Work(ip_tauW-1+nAtom+AB)=1.0d99
            End If
         End Do
      Else
         Call Cho_dZero(Work(ip_tauW),l_tauW)
      End If

      ! Allocate and initialize W intermediates
      l_WBlkP=nD
      Call GetMem('WBlkP','Allo','Inte',ip_WBlkP,l_WBlkP)
      Do iD=1,nD
         Call LDF_AllocateAuxBasVector('Win',iWork(ip_WBlkP-1+iD))
         Call LDF_ZeroAuxBasVector(ip_W(iD))
      End Do

C==========================
C     3-index contributions
C==========================

      If (Mode.eq.1 .or. Mode.eq.3) Then
         If (Timing) Then
            tIC=0.0d0
            tIW=0.0d0
            Call CWTime(tC1,tW1)
         End If
         Call Init_Tsk(TaskListID,NumberOfAtomPairs)
         Do While (Rsv_Tsk(TaskListID,AB))
            A=AP_Atoms(1,AB)
            B=AP_Atoms(2,AB)
            nuv=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
            Do C=1,nAtom
               tauW=Work(ip_tauW-1+C)
               If (IAB(AB)*GA(C)*VA(C).ge.tau(2) .or.
     &             IAB(AB)*GA(C)*DAB(AB).ge.tauW) Then
                  ! Compute integrals (u_A v_B|J_C)
                  M=LDF_nBasAux_Atom(C)
                  l_Int=nuv*M
                  Call GetMem('Fck3Int1','Allo','Real',ip_Int,l_Int)
                  If (Timing) Call CWTime(tIC1,tIW1)
                  Call LDF_Compute3IndexIntegrals_1(AB,C,tau(1),l_Int,
     &                                              Work(ip_Int))
                  If (Timing) Then
                     Call CWTime(tIC2,tIW2)
                     tIC=tIC+(tIC2-tIC1)
                     tIW=tIW+(tIW2-tIW1)
                  End If
                  ! Compute Fock matrix contribution
                  ! F(u_A v_B)+=FactC*sum_J_C (u_A v_B|J_C)*V(J_C)
                  Do iD=1,nD
                     ipV=iWork(ip_V(iD)-1+C)
                     ipF=iWork(ip_FBlocks(iD)-1+AB)
                     Call dGeMV_('N',nuv,M,
     &                          FactC(iD),Work(ip_Int),nuv,
     &                          Work(ipV),1,1.0d0,Work(ipF),1)
                  End Do
                  ! Compute W contribution
                  ! W(J_C)+=sum_u_Av_B (u_A v_B|J_C)*D(u_A v_B)
                  Do iD=1,nD
                     ipD=iWork(ip_DBlocks(iD)-1+AB)
                     ipW=iWork(ip_W(iD)-1+C)
                     Call dGeMV_('T',nuv,M,
     &                          1.0d0,Work(ip_Int),nuv,
     &                          Work(ipD),1,1.0d0,Work(ipW),1)
                  End Do
                  Call GetMem('Fck3Int1','Free','Real',ip_Int,l_Int)
               End If
            End Do
            If (LDF2) Then
               ! Contributions from two-center aux functions
               Do CD=1,NumberOfAtomPairs
                  MCD=AP_2CFunctions(1,CD)
                  If (MCD.gt.0) Then
                     tauW=Work(ip_tauW-1+nAtom+CD)
                     If (IAB(AB)*GAB(CD)*VAB(CD).ge.tau(2) .or.
     &                   IAB(AB)*GAB(CD)*DAB(AB).ge.tauW) Then
                        ! Compute integrals (u_A v_B|J_CD)
                        l_Int=nuv*MCD
                        Call GetMem('Fck3Int2','Allo','Real',ip_Int,
     &                                                        l_Int)
                        If (Timing) Call CWTime(tIC1,tIW1)
                        Call LDF_Compute3IndexIntegrals_2(AB,CD,tau(1),
     &                                                    l_Int,
     &                                                    Work(ip_Int))
                        If (Timing) Then
                           Call CWTime(tIC2,tIW2)
                           tIC=tIC+(tIC2-tIC1)
                           tIW=tIW+(tIW2-tIW1)
                        End If
                        ! Compute Fock matrix contribution
                        ! F(u_A v_B)+=
                        ! FactC*sum_J_CD (u_A v_B|J_CD)*V(J_CD)
                        Do iD=1,nD
                           ipV=iWork(ip_V(iD)-1+nAtom+CD)
                           ipF=iWork(ip_FBlocks(iD)-1+AB)
                           Call dGeMV_('N',nuv,MCD,
     &                                FactC(iD),Work(ip_Int),nuv,
     &                                Work(ipV),1,1.0d0,Work(ipF),1)
                        End Do
                        ! Compute W contribution
                        ! W(J_CD)+=sum_u_Av_B (u_A v_B|J_CD)*D(u_A v_B)
                        Do iD=1,nD
                           ipD=iWork(ip_DBlocks(iD)-1+AB)
                           ipW=iWork(ip_W(iD)-1+nAtom+CD)
                           Call dGeMV_('T',nuv,MCD,
     &                                1.0d0,Work(ip_Int),nuv,
     &                                Work(ipD),1,1.0d0,Work(ipW),1)
                        End Do
                        Call GetMem('Fck3Int2','Free','Real',ip_Int,
     &                                                        l_Int)
                     End If
                  End If
               End Do
            End If
         End Do
         Call Free_Tsk(TaskListID)
         If (Timing) Then
            Call CWTime(tC2,tW2)
            Write(6,'(A,2(1X,F12.2),A)')
     &      'Time spent on 3-index contributions:              ',
     &      tC2-tC1,tW2-tW1,' seconds'
            Write(6,'(A,2(1X,F12.2),A)')
     &      '      - of which integrals required:              ',
     &      tIC,tIW,' seconds'
         End If
      End If

C==========================
C     2-index contributions
C==========================

      If (Mode.eq.1 .or. Mode.eq.2) Then
         If (Timing) Then
            tIC=0.0d0
            tIW=0.0d0
            Call CWTime(tC1,tW1)
         End If
         If (Mode.eq.1) Then
            Const=-1.0d0
         Else
            Const=1.0d0
         End If
         Call Init_Tsk(TaskListID,nAtom)
         Do While (Rsv_Tsk(TaskListID,A))
            MA=LDF_nBasAux_Atom(A)
            If (MA.gt.0) Then
               Do B=1,A-1
                  MB=LDF_nBasAux_Atom(B)
                  If (MB.gt.0) Then
                     If (GA(A)*GA(B)*VA(B).ge.Work(ip_tauW-1+A) .or.
     &                   GA(A)*GA(B)*VA(A).ge.Work(ip_tauW-1+B)) Then
                        ! Compute integrals (J_A|K_B)
                        l_Int=MA*MB
                        Call GetMem('Fck2Int11','Allo','Real',ip_Int,
     &                                                         l_Int)
                        If (Timing) Call CWTime(tIC1,tIW1)
                        Call LDF_Compute2IndexIntegrals_11(A,B,tau(1),
     &                                                     l_Int,
     &                                                     Work(ip_Int))
                        If (Timing) Then
                           Call CWTime(tIC2,tIW2)
                           tIC=tIC+(tIC2-tIC1)
                           tIW=tIW+(tIW2-tIW1)
                        End If
                        ! Compute W contribution
                        ! W(J_A)+=Const*sum_K_B (J_A|K_B)*V(K_B)
                        Do iD=1,nD
                           ipV=iWork(ip_V(iD)-1+B)
                           ipW=iWork(ip_W(iD)-1+A)
                           Call dGeMV_('N',MA,MB,
     &                                Const,Work(ip_Int),MA,
     &                                Work(ipV),1,1.0d0,Work(ipW),1)
                        End Do
                        ! Compute W contribution
                        ! W(K_B)+=Const*sum_J_A (J_A|K_B)*V(J_A)
                        Do iD=1,nD
                           ipV=iWork(ip_V(iD)-1+A)
                           ipW=iWork(ip_W(iD)-1+B)
                           Call dGeMV_('T',MA,MB,
     &                                Const,Work(ip_Int),MA,
     &                                Work(ipV),1,1.0d0,Work(ipW),1)
                        End Do
                        Call GetMem('Fck2Int11','Free','Real',ip_Int,
     &                                                         l_Int)
                     End If
                  End If
               End Do
               If (GA(A)*GA(A)*VA(A).ge.Work(ip_tauW-1+A)) Then
                  ! Compute integrals (J_A|K_A)
                  l_Int=MA**2
                  Call GetMem('Fck2Int11','Allo','Real',ip_Int,l_Int)
                  If (Timing) Call CWTime(tIC1,tIW1)
                  Call LDF_Compute2IndexIntegrals_11(A,A,tau(1),l_Int,
     &                                               Work(ip_Int))
                  If (Timing) Then
                     Call CWTime(tIC2,tIW2)
                     tIC=tIC+(tIC2-tIC1)
                     tIW=tIW+(tIW2-tIW1)
                  End If
                  ! Compute W contribution
                  ! W(J_A)+=Const*sum_K_A (J_A|K_A)*V(K_A)
                  Do iD=1,nD
                     ipV=iWork(ip_V(iD)-1+A)
                     ipW=iWork(ip_W(iD)-1+A)
                     Call dGeMV_('N',MA,MA,
     &                          Const,Work(ip_Int),MA,
     &                          Work(ipV),1,1.0d0,Work(ipW),1)
                  End Do
                  Call GetMem('Fck2Int11','Free','Real',ip_Int,l_Int)
               End If
               If (LDF2) Then
                  ! Two-center contributions
                  Do CD=1,NumberOfAtomPairs
                     MCD=AP_2CFunctions(1,CD)
                     If (MCD.gt.0) Then
                        If (GA(A)*GAB(CD)*VAB(CD).ge.Work(ip_tauW-1+A)
     &                      .or.
     &                      GA(A)*GAB(CD)*VA(A).ge.
     &                                         Work(ip_tauW-1+nAtom+CD))
     &                  Then
                           ! Compute integrals (J_A|K_CD)
                           l_Int=MA*MCD
                           Call GetMem('Fck2Int12','Allo','Real',ip_Int,
     &                                                            l_Int)
                           If (Timing) Call CWTime(tIC1,tIW1)
                           Call LDF_Compute2IndexIntegrals_12(A,CD,
     &                                                        tau(1),
     &                                                        l_Int,
     &                                                     Work(ip_Int))
                           If (Timing) Then
                              Call CWTime(tIC2,tIW2)
                              tIC=tIC+(tIC2-tIC1)
                              tIW=tIW+(tIW2-tIW1)
                           End If
                           ! Compute W contribution
                           ! W(J_A)+=Const*sum_K_CD (J_A|K_CD)*V(K_CD)
                           Do iD=1,nD
                              ipV=iWork(ip_V(iD)-1+nAtom+CD)
                              ipW=iWork(ip_W(iD)-1+A)
                              Call dGeMV_('N',MA,MCD,
     &                                   Const,Work(ip_Int),MA,
     &                                   Work(ipV),1,1.0d0,Work(ipW),1)
                           End Do
                           ! Compute W contribution
                           ! W(K_CD)+=Const*sum_J_A (J_A|K_CD)*V(J_A)
                           Do iD=1,nD
                              ipV=iWork(ip_V(iD)-1+A)
                              ipW=iWork(ip_W(iD)-1+nAtom+CD)
                              Call dGeMV_('T',MA,MCD,
     &                                   Const,Work(ip_Int),MA,
     &                                   Work(ipV),1,1.0d0,Work(ipW),1)
                           End Do
                           Call GetMem('Fck2Int12','Free','Real',ip_Int,
     &                                                            l_Int)
                        End If
                     End If
                  End Do
               End If
            End If
         End Do
         Call Free_Tsk(TaskListID)
         If (LDF2) Then
            Call Init_Tsk(TaskListID,NumberOfAtomPairs)
            Do While (Rsv_Tsk(TaskListID,AB))
               MAB=AP_2CFunctions(1,AB)
               If (MAB.gt.0) Then
                  Do CD=1,AB-1
                     MCD=AP_2CFunctions(1,CD)
                     If (MCD.gt.0) Then
                        GABCD=GAB(AB)*GAB(CD)*VAB(CD)
                        GCDAB=GAB(AB)*GAB(CD)*VAB(AB)
                        If (GABCD.ge.Work(ip_tauW-1+nAtom+AB) .or.
     &                      GCDAB.ge.Work(ip_tauW-1+nAtom+CD)) Then
                           ! Compute integrals (J_AB|K_CD)
                           l_Int=MAB*MCD
                           Call GetMem('Fck2Int22','Allo','Real',ip_Int,
     &                                                            l_Int)
                           If (Timing) Call CWTime(tIC1,tIW1)
                           Call LDF_Compute2IndexIntegrals_22(AB,CD,
     &                                                        tau(1),
     &                                                        l_Int,
     &                                                     Work(ip_Int))
                           If (Timing) Then
                              Call CWTime(tIC2,tIW2)
                              tIC=tIC+(tIC2-tIC1)
                              tIW=tIW+(tIW2-tIW1)
                           End If
                           ! Compute W contribution
                           ! W(J_AB)+=Const*sum_K_CD (J_AB|K_CD)*V(K_CD)
                           Do iD=1,nD
                              ipV=iWork(ip_V(iD)-1+nAtom+CD)
                              ipW=iWork(ip_W(iD)-1+nAtom+AB)
                              Call dGeMV_('N',MAB,MCD,
     &                                   Const,Work(ip_Int),MAB,
     &                                   Work(ipV),1,1.0d0,Work(ipW),1)
                           End Do
                           ! Compute W contribution
                           ! W(K_CD)+=Const*sum_J_AB (J_AB|K_CD)*V(J_AB)
                           Do iD=1,nD
                              ipV=iWork(ip_V(iD)-1+nAtom+AB)
                              ipW=iWork(ip_W(iD)-1+nAtom+CD)
                              Call dGeMV_('T',MAB,MCD,
     &                                   Const,Work(ip_Int),MAB,
     &                                   Work(ipV),1,1.0d0,Work(ipW),1)
                           End Do
                           Call GetMem('Fck2Int22','Free','Real',ip_Int,
     &                                                            l_Int)
                        End If
                     End If
                  End Do
                  ! Compute integrals (J_AB|K_AB)
                  If (GAB(AB)*GAB(AB)*VAB(AB).ge.
     &                                         Work(ip_tauW-1+nAtom+AB))
     &            Then
                     l_Int=MAB**2
                     Call GetMem('Fck2Int22','Allo','Real',ip_Int,l_Int)
                     If (Timing) Call CWTime(tIC1,tIW1)
                     Call LDF_Compute2IndexIntegrals_22(AB,AB,tau(1),
     &                                                  l_Int,
     &                                                  Work(ip_Int))
                     If (Timing) Then
                        Call CWTime(tIC2,tIW2)
                        tIC=tIC+(tIC2-tIC1)
                        tIW=tIW+(tIW2-tIW1)
                     End If
                     ! Compute W contribution
                     ! W(J_AB)+=Const*sum_K_AB (J_AB|K_AB)*V(K_AB)
                     Do iD=1,nD
                        ipV=iWork(ip_V(iD)-1+nAtom+AB)
                        ipW=iWork(ip_W(iD)-1+nAtom+AB)
                        Call dGeMV_('N',MAB,MAB,
     &                             Const,Work(ip_Int),MAB,
     &                             Work(ipV),1,1.0d0,Work(ipW),1)
                     End Do
                     Call GetMem('Fck2Int22','Free','Real',ip_Int,l_Int)
                  End If
               End If
            End Do
            Call Free_Tsk(TaskListID)
         End If
         If (Timing) Then
            Call CWTime(tC2,tW2)
            Write(6,'(A,2(1X,F12.2),A)')
     &      'Time spent on 2-index contributions:              ',
     &      tC2-tC1,tW2-tW1,' seconds'
            Write(6,'(A,2(1X,F12.2),A)')
     &      '      - of which integrals required:              ',
     &      tIC,tIW,' seconds'
         End If
      End If

      ! Deallocate prescreening info
      Call GetMem('tauW','Free','Real',ip_tauW,l_tauW)
      If (l_DNrm.gt.0) Then
         Call GetMem('DNrm','Free','Real',ip_DNrm,l_DNrm)
      End If
      If (l_VNrm.gt.0) Then
         Call GetMem('VNrm','Free','Real',ip_VNrm,l_VNrm)
      End If

#if defined (_MOLCAS_MPP_)
      ! Add W over nodes
      If (nProcs.gt.1 .and. Is_Real_Par()) Then
         If (Timing) Call CWTime(tC1,tW1)
         Do iD=1,nD
            Call LDF_P_AddAuxBasVector(ip_W(iD))
         End Do
         If (Timing) Then
            Call CWTime(tC2,tW2)
            Write(6,'(A,2(1X,F12.2),A)')
     &      'Parallel overhead for W intermediates:            ',
     &      tC2-tC1,tW2-tW1,' seconds'
         End If
      End If
#endif

C===================
C     Compute F+=C*W
C===================

      If (Timing) Call CWTime(tC1,tW1)
      Call Init_Tsk(TaskListID,NumberOfAtomPairs)
      Do While (Rsv_Tsk(TaskListID,AB))
         ! Read coefficients
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         nuv=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
         l_C=nuv*LDF_nBasAux_Pair_wLD(AB)
         Call GetMem('FckCoef','Allo','Real',ip_C,l_C)
         Call LDF_CIO_ReadC_wLD(AB,Work(ip_C),l_C)
         ! Compute F(u_A v_B) += FactC*sum_J C(u_A v_B,J)*W(J)
         ipC=ip_C
         MA=LDF_nBasAux_Atom(A)
         If (MA.gt.0) Then
            Do iD=1,nD
               ipF=iWork(ip_FBlocks(iD)-1+AB)
               ipW=iWork(ip_W(iD)-1+A)
               Call dGeMV_('N',nuv,MA,
     &                    FactC(iD),Work(ipC),nuv,
     &                    Work(ipW),1,1.0d0,Work(ipF),1)
            End Do
            ipC=ipC+nuv*MA
         End If
         If (B.ne.A) Then
            MB=LDF_nBasAux_Atom(B)
            If (MB.gt.0) Then
               Do iD=1,nD
                  ipF=iWork(ip_FBlocks(iD)-1+AB)
                  ipW=iWork(ip_W(iD)-1+B)
                  Call dGeMV_('N',nuv,MB,
     &                       FactC(iD),Work(ipC),nuv,
     &                       Work(ipW),1,1.0d0,Work(ipF),1)
               End Do
               ipC=ipC+nuv*MB
            End If
         End If
         MAB=AP_2CFunctions(1,AB)
         If (MAB.gt.0) Then
            Do iD=1,nD
               ipF=iWork(ip_FBlocks(iD)-1+AB)
               ipW=iWork(ip_W(iD)-1+nAtom+AB)
               Call dGeMV_('N',nuv,MAB,
     &                    FactC(iD),Work(ipC),nuv,
     &                    Work(ipW),1,1.0d0,Work(ipF),1)
            End Do
         End If
         Call GetMem('FckCoef','Free','Real',ip_C,l_C)
      End Do
      Call Free_Tsk(TaskListID)
      If (Timing) Then
         Call CWTime(tC2,tW2)
         Write(6,'(A,2(1X,F12.2),A)')
     &   'Time spent computing C*W contribution:            ',
     &   tC2-tC1,tW2-tW1,' seconds'
      End If

      ! Deallocate W intermediates
      Do iD=0,nD-1
         Call LDF_DeallocateAuxBasVector('Win',iWork(ip_WBlkP+iD))
      End Do
      Call GetMem('WBlkP','Free','Inte',ip_WBlkP,l_WBlkP)

      ! Use exact integral diagonal blocks if requested.
      ! Computed by adding the correction
      ! dF(uv) = FactC * sum_kl { (uv|kl) - [uv|kl] }*D(kl)
      ! where |uv) and |kl) belong to the same atom pair
      ! and [uv|kl] is an LDF integral approximation.
      If (UseExactIntegralDiagonal) Then
         If (Timing) Call CWTime(tC1,tW1)
         Call LDF_Fock_CoulombOnly_XIDI(Mode,tau(1),nD,FactC,
     &                                  ip_DBlocks,ip_FBlocks)
         If (Timing) Then
            Call CWTime(tC2,tW2)
            Write(6,'(A,2(1X,F12.2),A)')
     &      'Time spent computing XIDI corrections:            ',
     &      tC2-tC1,tW2-tW1,' seconds'
         End If
      End If

#if defined (_MOLCAS_MPP_)
      If (nProcs.gt.1 .and. Is_Real_Par()) Then
         If (Timing) Call CWTime(tC1,tW1)
         Do iD=1,nD
            Call LDF_P_AddBlockMatrix(ip_FBlocks(iD))
         End Do
         If (Timing) Then
            Call CWTime(tC2,tW2)
            Write(6,'(A,2(1X,F12.2),A)')
     &      'Parallel overhead for F blocks:                   ',
     &      tC2-tC1,tW2-tW1,' seconds'
         End If
      End If
#endif

      If (Timing) Call xFlush(6)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCC                                                          CCCCCCC
CCCCCCC                      OLD CODE                            CCCCCCC
CCCCCCC                                                          CCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Fock_CoulombOnly0(IntegralOption,tau,
     &                                 Mode,Add,PackedD,PackedF,
     &                                 nD,FactC,ip_D,ip_F)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Compute Coulomb contribution to Fock matrix using local
C              Density Fitting coefficients. Use only for debugging!
C              Poor performance!
C
C     Args:    - IntegralOption (integer)
C                  111  => use two-electron integrals computed from
C                          LDF coefficients (for debugging)
C                  222  => use conventional two-electron integrals
C                          (for debugging)
C                  333  => use conventional or LDF two-electron
C                          integrals depending on positivity of the
C                          latter (for debugging)
C                  all other values => use production-level LDF code
C                  (INPUT)
C              - tau (real*8) integral prescreening threshold (INPUT).
C                Only used with IntegralOption=111.
C              - Mode (integer) 1:robust,2:nonrobust,3:half-and-half
C              - Add (boolean): .True. if Coulomb contribution should be
C                added to the Fock matrix (INPUT). Not available in
C                parallel execution!!
C              - PackedD (boolean): .True. if density matrices
C                are stored in lower triangular format; else quadratic
C                storage (INPUT)
C              - PackedF (boolean): .True. if Fock matrices
C                are stored in lower triangular format; else quadratic
C                storage (INPUT)
C              - nD: Number of densities/Fock matrices (INPUT)
C              - FactC(nD): scaling factor for each density (INPUT)
C              - ip_D(nD): pointers to nD density matrices (if PackedD:
C                lower triangular storage) (INPUT)
C              - ip_F(nD): pointers to nD Fock matrices (if PackedF:
C                lower triangular storage) (INPUT)
C
C              If (Add):  [NOT IMPLEMENTED IN PARALLEL]
C       (1)       F(uv) = F(uv) + FactC * sum_kl (uv|kl)*D(kl)
C              Else:
C       (2)       F(uv) = FactC * sum_kl (uv|kl)*D(kl)
C
C              where the integrals are given by the robust LDF
C              representation
C
C              (uv|kl) = ([uv]|kl) + (uv|[kl]) - ([uv]|[kl])
C
C              or the non-robust representation
C
C              (uv|kl) = ([uv]|[kl])
C
C              or the half-and-half representation
C
C              (uv|kl) = 0.5*([uv]|kl) + 0.5*(uv|[kl])
C
C              and the fitted products are given by
C
C              |[uv]) = sum_J C(uv,J) |J)
C
C              where the fitting functions |J) are centered on the atom
C              pair to which the product |uv) belongs.
C
C              In more detail (assuming robust fitting representation):
C
C              F(uv) = FactC * {sum_J C(uv,J)*W(J) + sum_K (uv|K)*V(K)}
C
C              W(J) = sum_kl (J|kl)*D(kl) - sum_K (J|K)*V(K)
C
C              V(K) = sum_kl C(kl,K)*D(kl)
C
C     NOTES:
C       - The density matrices are assumed to be symmetric.
C       - It is the complete sum over kl in Eqs(1,2)! This means that
C         the input density matrices should NOT be scaled by 2 on the
C         off-diagonal (scaling factors are handled internally).
C       - LDF information must be properly set up before calling this
C         routine (use subroutine LDF_X_Init).
C       - Two-center functions may or mat not be included in the fitting
C         basis for a given atom pair.
C       - The algorithm is NOT integral driven. This means that 3-center
C         integrals (4-center integrals if 2-center fitting functions
C         are included) are computed several times, causing quite poor
C         performance.
C       - The max number of processes for which the algorithm can
C         possibly scale well equals the number of LDF atom pairs.
C       - No screening has been implemented.
C       - Add is not implemented in parallel !!!
C
C     Outline of the algorithm (robust representation):
C     =================================================
C
C     *If (Mode=3): FactC := 0.5*FactC
C
C     *Scale off-diagonal density blocks:
C      D[u_A v_B] <-- 2*D[u_A v_B] iff A != B
C
C     *Parallel loop over atom pairs AB (A>=B):
C        - V(J_AB) = sum_[u_A v_B] C(u_A v_B,J_AB)*D(u_A v_B)
C     *End loop AB
C     Add V over nodes.
C
C     *Parallel loop over atom pairs AB (A>=B):
C        *Loop over atom pairs CD (C>=D):
C           - F(u_A v_B) = F(u_A v_B)
C                        + sum_[K_CD] (u_A v_B | K_CD)*V(K_CD)
C           - W(J_AB) = W(J_AB)
C                     + sum_[k_C l_D] (J_AB | k_C l_D)*D(k_C l_D)
C           - W(J_AB) = W(J_AB)
C                     - sum_[K_CD] (J_AB | K_CD)*V(K_CD)
C        *End loop CD
C        - F(u_A v_B) = F(u_A v_B)
C                     + sum_[J_AB] C(u_A v_B,J_AB)*W(J_AB)
C     *End loope AB
C     Add F over nodes
C
C     Note that both arrays V and F are stored locally as O(N) arrays,
C     which should keep the communication bottleneck at a minimum as the
C     system size grows.
C
      Implicit None
      Integer IntegralOption
      Real*8  tau
      Integer Mode
      Logical Add
      Logical PackedD
      Logical PackedF
      Integer nD
      Real*8  FactC(nD)
      Integer ip_D(nD)
      Integer ip_F(nD)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"
#include "para_info.fh"

      Character*21 SecNam
      Parameter (SecNam='LDF_Fock_CoulombOnly0')

#if defined (_DEBUGPRINT_)
      Logical  LDF_X_IsSet, LDF_TestBlockMatrix
      External LDF_X_IsSet, LDF_TestBlockMatrix
      Integer  LDF_nAtom
      External LDF_nAtom
      Logical  DoTest
      Real*8   x, y
#endif

      Logical UsePartPermSym

      Integer nBas
      Integer iD, ip0, l
      Integer ip_DBlocks, l_DBlocks
      Integer ip_FBlocks, l_FBlocks
      Integer ip_VBlocks, l_VBlocks
      Integer ip_FactC, l_FactC

      ! Return if nothing to do
      If (nD.lt.1) Return

      ! Get number of basis functions (from localdf_bas.fh)
      nBas=nBas_Valence
      If (nBas.lt.1) Then
         Call WarningMessage(1,
     &                  SecNam//': nBas<1 -- Fock matrix NOT computed!')
         Write(6,'(A,I9)') 'nBas=',nBas
         Call xFlush(6)
         Return
      End If

#if defined (_DEBUGPRINT_)
      If (.not.LDF_X_IsSet()) Then
         Call WarningMessage(2,SecNam//': LDF data not initialized!')
         Call LDF_Quit(1)
      End If
#endif

#if defined (_MOLCAS_MPP_)
      If (Add) Then
         If (nProcs.gt.1 .and. Is_Real_Par()) Then
            Write(6,'(A,A)') SecNam,
     &        ': >>Add<< feature not implemented in parallel execution!'
            Call LDF_NotImplemented()
         End If
      End If
#endif

      ! For half-and-half integral representation, scale FactC by 1/2.
      ! Save a copy of FactC (restored at the end)
      If (Mode.eq.3) Then
         l_FactC=nD
         Call GetMem('FactCBak','Allo','Real',ip_FactC,l_FactC)
         Call dCopy_(nD,FactC,1,Work(ip_FactC),1)
         Call dScal_(nD,0.5d0,FactC,1)
      Else
         l_FactC=0
         ip_FactC=0
      End If

      ! Initialize Fock matrices (if not Add)
      If (.not.Add) Then
         If (PackedF) Then
            l=nBas*(nBas+1)/2
         Else
            l=nBas**2
         End If
         Do iD=1,nD
            Call Cho_dZero(Work(ip_F(iD)),l)
         End Do
      End If

      ! Allocate and set blocked density matrices (atom pair blocks)
      l_DBlocks=nD
      Call GetMem('DBlk_P','Allo','Inte',ip_DBlocks,l_DBlocks)
      ip0=ip_DBlocks-1
#if defined (_DEBUGPRINT_)
      x=dble(NumberOfAtomPairs)
      y=dble(LDF_nAtom())*(dble(LDF_nAtom())+1.0d0)/2.0d0
      DoTest=int(x-y).eq.0
#endif
      Do iD=1,nD
         Call LDF_AllocateBlockMatrix('Den',iWork(ip0+iD))
         Call LDF_Full2Blocked(Work(ip_D(iD)),PackedD,iWork(ip0+iD))
#if defined (_DEBUGPRINT_)
         If (DoTest) Then
            If (.not.LDF_TestBlockMatrix(iWork(ip0+iD),PackedD,
     &                                   Work(ip_D(iD)))) Then
               Call WarningMessage(2,
     &                            SecNam//': block matrix test failure')
               Write(6,'(A,I4,A,I9,3X,A,L1)')
     &         'Density matrix',iD,' at location',ip_D(iD),
     &         'Packed: ',PackedD
               Call LDF_Quit(1)
            End If
         End If
#endif
         Call LDF_ScaleOffdiagonalMatrixBlocks(iWork(ip0+iD),2.0d0)
      End Do

      ! Allocate and set blocked Fock matrices (atom pair blocks)
      l_FBlocks=nD
      Call GetMem('FBlk_P','Allo','Inte',ip_FBlocks,l_FBlocks)
      ip0=ip_FBlocks-1
      Do iD=1,nD
         Call LDF_AllocateBlockMatrix('Fck',iWork(ip0+iD))
         Call LDF_Full2Blocked(Work(ip_F(iD)),PackedF,iWork(ip0+iD))
      End Do

      If (IntegralOption.eq.111) Then
         ! Compute Fock matrix using LDF integrals (debug)
         Call WarningMessage(0,
     &               SecNam//': Using integrals from LDF coefficients!')
         Call xFlush(6)
         UsePartPermSym=.True.
         If (Mode.eq.3) Then
            Call LDF_FVIFC(UsePartPermSym,Mode,max(tau,0.0d0),
     &                     nD,Work(ip_FactC),iWork(ip_DBlocks),
     &                     iWork(ip_FBlocks))
         Else
            Call LDF_FVIFC(UsePartPermSym,Mode,max(tau,0.0d0),
     &                     nD,FactC,iWork(ip_DBlocks),
     &                     iWork(ip_FBlocks))
         End If
      Else If (IntegralOption.eq.222) Then
         ! Compute Fock matrix using conventional integrals (debug)
         Call WarningMessage(0,
     &                        SecNam//': Using conventional integrals!')
         Call xFlush(6)
         UsePartPermSym=.True.
         Call LDF_FCI(UsePartPermSym,nD,FactC,iWork(ip_DBlocks),
     &                                        iWork(ip_FBlocks))
      Else If (IntegralOption.eq.333) Then
         ! Compute Fock matrix using conventional or LDF integrals
         ! depending on positivity of the latter (debug)
         Call WarningMessage(0,
     &                  SecNam//': Using PSD (LDF or conv.) integrals!')
         Call xFlush(6)
         UsePartPermSym=.True.
         If (Mode.eq.3) Then
            Call LDF_FTst(UsePartPermSym,Mode,max(tau,0.0d0),
     &                    nD,Work(ip_FactC),iWork(ip_DBlocks),
     &                    iWork(ip_FBlocks))
         Else
            Call LDF_FTst(UsePartPermSym,Mode,max(tau,0.0d0),
     &                    nD,FactC,iWork(ip_DBlocks),
     &                    iWork(ip_FBlocks))
         End If
      Else
         ! Allocate Coulomb intermediates
         l_VBlocks=nD
         Call GetMem('VBlk_P','Allo','Inte',ip_VBlocks,l_VBlocks)
         Do iD=0,nD-1
            Call LDF_AllocateBlockVector('CIn',iWork(ip_VBlocks+iD))
         End Do
         ! Compute Coulomb intermediates,
         ! V(J) = sum_uv C(uv,J)*D(uv)
         ! for each density matrix
         Call LDF_ComputeCoulombIntermediates0(nD,iWork(ip_DBlocks),
     &                                            iWork(ip_VBlocks))
         ! Compute Coulomb contributions
         Call LDF_Fock_CoulombOnly0_(Mode,nD,FactC,
     &                              iWork(ip_DBlocks),iWork(ip_VBlocks),
     &                              iWork(ip_FBlocks))
         ! Deallocate Coulomb intermediates
         Do iD=0,nD-1
            Call LDF_DeallocateBlockVector('CIn',iWork(ip_VBlocks+iD))
         End Do
         Call GetMem('VBlk_P','Free','Inte',ip_VBlocks,l_VBlocks)
      End If

      ! Get full storage (triangular or quadratic) Fock matrices from
      ! blocked ones.
      ip0=ip_FBlocks-1
      Do iD=1,nD
         Call LDF_Blocked2Full(iWork(ip0+iD),PackedF,Work(ip_F(iD)))
      End Do

      ! Restore FactC
      If (l_FactC.gt.0) Then
         Call dCopy_(nD,Work(ip_FactC),1,FactC,1)
         Call GetMem('FactCBak','Free','Real',ip_FactC,l_FactC)
      End If

      ! Deallocation
      Do iD=0,nD-1
         Call LDF_DeallocateBlockMatrix('Fck',iWork(ip_FBlocks+iD))
      End Do
      Call GetMem('FBlk_P','Free','Inte',ip_FBlocks,l_FBlocks)
      Do iD=0,nD-1
         Call LDF_DeallocateBlockMatrix('Den',iWork(ip_DBlocks+iD))
      End Do
      Call GetMem('DBlk_P','Free','Inte',ip_DBlocks,l_DBlocks)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Fock_CoulombOnly0_(Mode,nD,FactC,
     &                                 ip_DBlocks,ip_VBlocks,ip_FBlocks)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Compute Coulomb contributions to the Fock matrix using
C              Coulomb intermediates V.
C
C     See LDF_Fock_CoulombOnly for an outline of the algorithm.
C
      Implicit None
      Integer Mode
      Integer nD
      Real*8  FactC(nD)
      Integer ip_DBlocks(nD)
      Integer ip_VBlocks(nD)
      Integer ip_FBlocks(nD)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*22 SecNam
      Parameter (SecNam='LDF_Fock_CoulombOnly0_')

      Logical  Rsv_Tsk
      External Rsv_Tsk

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Integer ip_WBlkP, l_WBlkP
      Integer iD
      Integer TaskListID
      Integer AB, CD
      Integer ip, l
      Integer nuv, M
      Integer ipW, ipF


      Integer i, j
      Integer ip_WBlocks
      Integer AP_Atoms
      ip_WBlocks(i)=iWork(ip_WBlkP-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Allocate and initialize W intermediates
      l_WBlkP=nD
      Call GetMem('WBlk_P','Allo','Inte',ip_WBlkP,l_WBlkP)
      Do iD=1,nD
         Call LDF_AllocateBlockVector('Win',iWork(ip_WBlkP-1+iD))
         Call LDF_ZeroBlockVector(ip_WBlocks(iD))
      End Do

      If (Mode.eq.1 .or. Mode.eq.3) Then
         ! Parallel loop over atom pairs AB (A>=B)
         Call Init_Tsk(TaskListID,NumberOfAtomPairs)
         Do While (Rsv_Tsk(TaskListID,AB))
            ! Serial loop over atom pairs CD (C>=D)
            Do CD=1,NumberOfAtomPairs
               ! F(u_A v_B) = F(u_A v_B)
               !            + sum_[K_CD] (u_A v_B | K_CD)*V(K_CD)
               Call LDF_Fock_CoulombOnly0_1(nD,FactC,ip_VBlocks,
     &                                      ip_FBlocks,AB,CD)
               ! W(J_AB) = W(J_AB)
               !         + sum_[k_C l_D] (J_AB | k_C l_D)*D(k_C l_D)
               Call LDF_Fock_CoulombOnly0_2(nD,ip_DBlocks,
     &                                      iWork(ip_WBlkP),AB,CD)
               If (Mode.eq.1) Then
                  ! W(J_AB) = W(J_AB)
                  !         - sum_[K_CD] (J_AB | K_CD)*V(K_CD)
                  Call LDF_Fock_CoulombOnly0_3(-1.0d0,nD,ip_VBlocks,
     &                                         iWork(ip_WBlkP),AB,CD)
               End If
            End Do ! end serial loop over atom pairs CD
            ! F(u_A v_B) = F(u_A v_B)
            !            + sum_[J_AB] C(u_A v_B,J_AB)*W(J_AB)
            nuv=LDF_nBas_Atom(AP_Atoms(1,AB))
     &         *LDF_nBas_Atom(AP_Atoms(2,AB))
            M=LDF_nBasAux_Pair(AB)
            l=nuv*M
            Call GetMem('C_AB','Allo','Real',ip,l)
            Call LDF_CIO_ReadC(AB,Work(ip),l)
            Do iD=1,nD
               ipF=iWork(ip_FBlocks(iD)-1+AB)
               ipW=iWork(ip_WBlocks(iD)-1+AB)
               Call dGeMV_('N',nuv,M,
     &                    FactC(iD),Work(ip),nuv,
     &                    Work(ipW),1,1.0d0,Work(ipF),1)
            End Do
            Call GetMem('C_AB','Free','Real',ip,l)
         End Do ! end parallel loop over atom pairs AB
         Call Free_Tsk(TaskListID)
      Else If (Mode.eq.2) Then ! non-robust fitting
         ! Parallel loop over atom pairs AB (A>=B)
         Call Init_Tsk(TaskListID,NumberOfAtomPairs)
         Do While (Rsv_Tsk(TaskListID,AB))
            ! Serial loop over atom pairs CD (C>=D)
            Do CD=1,NumberOfAtomPairs
               ! W(J_AB) = W(J_AB)
               !         + sum_[K_CD] (J_AB | K_CD)*V(K_CD)
               Call LDF_Fock_CoulombOnly0_3(1.0d0,nD,ip_VBlocks,
     &                                      iWork(ip_WBlkP),AB,CD)
            End Do ! end serial loop over atom pairs CD
            ! F(u_A v_B) = F(u_A v_B)
            !            + sum_[J_AB] C(u_A v_B,J_AB)*W(J_AB)
            nuv=LDF_nBas_Atom(AP_Atoms(1,AB))
     &         *LDF_nBas_Atom(AP_Atoms(2,AB))
            M=LDF_nBasAux_Pair(AB)
            l=nuv*M
            Call GetMem('C_AB','Allo','Real',ip,l)
            Call LDF_CIO_ReadC(AB,Work(ip),l)
            Do iD=1,nD
               ipF=iWork(ip_FBlocks(iD)-1+AB)
               ipW=iWork(ip_WBlocks(iD)-1+AB)
               Call dGeMV_('N',nuv,M,
     &                    FactC(iD),Work(ip),nuv,
     &                    Work(ipW),1,1.0d0,Work(ipF),1)
            End Do
            Call GetMem('C_AB','Free','Real',ip,l)
         End Do ! end parallel loop over atom pairs AB
         Call Free_Tsk(TaskListID)
      Else
         Write(6,'(A,A,I6)') SecNam,': unknown Mode:',Mode
         Call LDF_NotImplemented()
      End If

#if defined (_MOLCAS_MPP_)
      ! Add F over nodes
      Do iD=1,nD
         Call LDF_P_AddBlockMatrix(ip_FBlocks(iD))
      End Do
#endif

      ! Deallocate W intermediates
      Do iD=0,nD-1
         Call LDF_DeallocateBlockVector('Win',iWork(ip_WBlkP+iD))
      End Do
      Call GetMem('WBlk_P','Free','Inte',ip_WBlkP,l_WBlkP)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Fock_CoulombOnly0_1(nD,FactC,ip_VBlocks,ip_FBlocks,
     &                                   AB,CD)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Compute
C
C              F(u_A v_B) = F(u_A v_B)
C                         + FactC*sum_[K_CD] (u_A v_B | K_CD)*V(K_CD)
C
      Implicit None
      Integer nD
      Real*8  FactC(nD)
      Integer ip_VBlocks(nD)
      Integer ip_FBlocks(nD)
      Integer AB, CD
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Integer nuv, M
      Integer ip_Int, l_Int
      Integer iD
      Integer ipV, ipF

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Get row and column dimensions of integrals
      nuv=LDF_nBas_Atom(AP_Atoms(1,AB))
     &   *LDF_nBas_Atom(AP_Atoms(2,AB))
      M=LDF_nBasAux_Pair(CD)

      ! Return if nothing to do
      If (nuv.lt.1 .or. M.lt.1) Return

      ! Allocate integrals (u_A v_B | K_CD)
      l_Int=nuv*M
      Call GetMem('LDFFuvJ1','Allo','Real',ip_Int,l_Int)

      ! Compute integrals (u_A v_B | K_CD)
      Call LDF_ComputeIntegrals_uvJ_2P(AB,CD,l_Int,Work(ip_Int))

      ! Compute contributions
      Do iD=1,nD
         ipV=iWork(ip_VBlocks(iD)-1+CD)
         ipF=iWork(ip_FBlocks(iD)-1+AB)
         Call dGeMV_('N',nuv,M,
     &              FactC(iD),Work(ip_Int),nuv,
     &              Work(ipV),1,1.0d0,Work(ipF),1)
      End Do

      ! Deallocate integrals
      Call GetMem('LDFFuvJ1','Free','Real',ip_Int,l_Int)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Fock_CoulombOnly0_2(nD,ip_DBlocks,ip_WBlocks,AB,CD)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Compute
C
C              W(J_AB) = W(J_AB)
C                      + sum_[k_C l_D] (k_C l_D|J_AB)*D(k_C l_D)
C
      Implicit None
      Integer nD
      Integer ip_DBlocks(nD)
      Integer ip_WBlocks(nD)
      Integer AB, CD
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Integer nkl, M
      Integer ip_Int, l_Int
      Integer iD
      Integer ipD, ipW

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Get row and column dimensions of integrals
      nkl=LDF_nBas_Atom(AP_Atoms(1,CD))
     &   *LDF_nBas_Atom(AP_Atoms(2,CD))
      M=LDF_nBasAux_Pair(AB)

      ! Return if nothing to do
      If (nkl.lt.1 .or. M.lt.1) Return

      ! Allocate integrals (k_C l_D | J_AB)
      l_Int=nkl*M
      Call GetMem('LDFFuvJ2','Allo','Real',ip_Int,l_Int)

      ! Compute integrals (k_C l_D | J_AB)
      Call LDF_ComputeIntegrals_uvJ_2P(CD,AB,l_Int,Work(ip_Int))

      ! Compute contributions
      Do iD=1,nD
         ipD=iWork(ip_DBlocks(iD)-1+CD)
         ipW=iWork(ip_WBlocks(iD)-1+AB)
         Call dGeMV_('T',nkl,M,
     &              1.0d0,Work(ip_Int),nkl,
     &              Work(ipD),1,1.0d0,Work(ipW),1)
      End Do

      ! Deallocate integrals
      Call GetMem('LDFFuvJ2','Free','Real',ip_Int,l_Int)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Fock_CoulombOnly0_3(Const,nD,ip_VBlocks,ip_WBlocks,
     &                                  AB,CD)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Compute
C
C              W(J_AB) = W(J_AB)
C                      + Const * sum_[K_CD] (J_AB | K_CD)*V(K_CD)
C
      Implicit None
      Real*8  Const
      Integer nD
      Integer ip_VBlocks(nD)
      Integer ip_WBlocks(nD)
      Integer AB, CD
#include "WrkSpc.fh"

      Integer  LDF_nBasAux_Pair
      External LDF_nBasAux_Pair

      Integer MAB, MCD
      Integer ip_Int, l_Int
      Integer iD
      Integer ipV, ipW

      ! Get row and column dimension of integrals
      MAB=LDF_nBasAux_Pair(AB)
      MCD=LDF_nBasAux_Pair(CD)

      ! Return if nothing to do
      If (MAB.lt.1 .or. MCD.lt.1) Return

      ! Allocate integrals (J_AB | K_CD)
      l_Int=MAB*MCD
      Call GetMem('LDFFJK','Allo','Real',ip_Int,l_Int)

      ! Compute integrals (J_AB | K_CD)
      Call LDF_ComputeIntegrals_JK_2P(AB,CD,l_Int,Work(ip_Int))

      ! Compute contributions
      Do iD=1,nD
         ipV=iWork(ip_VBlocks(iD)-1+CD)
         ipW=iWork(ip_WBlocks(iD)-1+AB)
         Call dGeMV_('N',MAB,MCD,
     &              Const,Work(ip_Int),MAB,
     &              Work(ipV),1,1.0d0,Work(ipW),1)
      End Do

      ! Deallocate integrals
      Call GetMem('LDFFJK','Free','Real',ip_Int,l_Int)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mv0sv (dd,length,mat,f)
C
c      A = A .f
c
#include "chcc1.fh"
       integer dd
       integer length
       real*8  mat(1:dd)
       real*8 f
C
C      help variables
C
       integer init
C
C
       if (mhkey.eq.1) then
c      ESSL
c
       do  5 init=1,length
       mat(init) = mat(init)*f
  5    continue
c
       else
c      Fortran matrix handling
C
       do 10 init=1,length
       mat(init) = mat(init)*f
 10    continue
c
       end if
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LDF_Quit(irc)
C
C     Quit with special error codes:
C       irc=-1 => _RC_INPUT_ERROR_
C       irc=1  => _RC_INTERNAL_ERROR
C       other  => _RC_GENERAL_ERROR
C
      Implicit None
      Integer irc
#include "warnings.fh"

      If (irc.eq.-1) Then
         Call xQuit(_RC_INPUT_ERROR_)
      Else If (irc.eq.1) Then
         Call xQuit(_RC_INTERNAL_ERROR_)
      Else
         Call xQuit(_RC_GENERAL_ERROR_)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Roland Lindh                                     *
!***********************************************************************

subroutine SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
!***********************************************************************
!                                                                      *
!     Object: to set up data and allocate memory for integral calcula- *
!             tions. The whole data structure is hidden to the user.   *
!                                                                      *
!     nSkal(output): returns the number of shells                      *
!     Indexation(input): logical flag to initiate index tables         *
!     ThrAO(input): if ThrAO /= Zero CutInt is reset to ThrAO          *
!                                                                      *
!     Author: Roland Lindh, Chemical Physics, University of Lund,      *
!             Sweden. January '98.                                     *
!***********************************************************************

use setup, only: MxPrm, nAux, nSOs
use k2_arrays, only: Aux, create_braket_base, FT, iSOSym, MxFT, nFT
use Basis_Info, only: nBas, nBas_Aux
use Gateway_Info, only: CutInt
use Symmetry_Info, only: nIrrep
use BasisMode, only: Auxiliary_Mode, Basis_Mode, Valence_Mode, With_Auxiliary_Mode
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: nSkal
logical(kind=iwp), intent(in) :: Indexation, DoFock, DoGrad
real(kind=wp), intent(in) :: ThrAO
integer(kind=iwp) :: i, iIrrep, iSOs, nBas_iIrrep

if (allocated(iSOSym)) then
  call Nr_Shells(nSkal)
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (thrao /= Zero) CutInt = ThrAO

! Compute the total number of symmetry adapted basis functions

nSOs = 0
do iIrrep=0,nIrrep-1
  select case (Basis_Mode)
    case (Valence_Mode)
      nSOs = nSOs+nBas(iIrrep)
    case (Auxiliary_Mode)
      nSOs = nSOs+nBas_Aux(iIrrep)
    case (With_Auxiliary_Mode)
      nSOs = nSOs+nBas(iIrrep)+nBas_Aux(iIrrep)
  end select
end do

! Generate a two-dimensional array of the length of nSOs.
! The first entry gives the irrep of a SO and the second entry
! gives the relative index of a SO in its irrep.

call mma_allocate(iSOSym,2,nSOs,Label='iSOSym')
iSOs = 1
nBas_iIrrep = 0
do iIrrep=0,nIrrep-1
  select case (Basis_Mode)
    case (Valence_Mode)
      nBas_iIrrep = nBas(iIrrep)
    case (Auxiliary_Mode)
      nBas_iIrrep = nBas_Aux(iIrrep)
    case (With_Auxiliary_Mode)
      nBas_iIrrep = nBas(iIrrep)+nBas_Aux(iIrrep)
  end select
  do i=1,nBas_iIrrep
    iSOSym(1,iSOs) = iIrrep    ! Irreducible reps.
    iSOSym(2,iSOs) = i         ! Relative index in irrep.
    iSOs = iSOs+1
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the number of shells and set up the shell information
! tables(iSD).

call Nr_Shells(nSkal)
!                                                                      *
!                                                                      *
!***********************************************************************
!                                                                      *
! allocate Integer memory for resulting SO info...
! memory basepointers are declared in inftra common block

if (Indexation) call SOFSh1(nSkal,nIrrep,nSOs)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate auxiliary array for symmetry transformation

nAux = nIrrep**3
if (nIrrep == 1) nAux = 1
call mma_allocate(Aux,nAux,Label='Aux')
!                                                                      *
!***********************************************************************
!                                                                      *
! Preallocate memory for k2 entities

call Create_BraKet_Base(MxPrm**2)
!                                                                      *
!***********************************************************************
!                                                                      *
if (DoFock) then
  nFT = MxFT
else
  nFT = 1
end if
call mma_allocate(FT,MxFT,Label='FT')
!                                                                      *
!***********************************************************************
!                                                                      *
! Precompute k2 entities

call Drvk2(DoFock,DoGrad)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine SetUp_Ints

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
*  Get_Grad_Full
*
*> @brief
*>   Get gradient from RUNFILE
*> @author I. Fdez. Galv&aacute;n
*>
*> @details
*> Place Cartesian gradient (in a.u.) into array \p Grad_Full(3,*).
*> Includes MM atoms otherwise invisible to gateway/slapaf.
*>
*> @param[out] Grad_Full   Array of gradient
*> @param[in]  nAtoms_Full Number of atoms
************************************************************************
      Subroutine Get_Grad_Full(Grad_Full,nAtoms_Full)
      Implicit None
      Integer nAtoms_Full, nAtoms_Fullx, nAtoms_All, nGrad, nGradMM
      Real*8 Grad_Full(3,nAtoms_Full)
      Logical Found
*
      Call Get_nAtoms_Full(nAtoms_Fullx)
      If (nAtoms_Full.ne.nAtoms_Fullx) Then
        Write (6,*) 'Get_Grad_Full: nAtoms_Full.ne.nAtoms_Fullx'
        Write (6,*) 'nAtoms_Full=',nAtoms_Full
        Write (6,*) 'nAtoms_Fullx=',nAtoms_Fullx
        Call Abend
      End If
      Call Get_nAtoms_All(nAtoms_All)
      If (nAtoms_Full.lt.nAtoms_All) Then
        Write (6,*) 'Get_Coord_Full: nAtoms_Full.lt.nAtoms_All'
        Write (6,*) 'nAtoms_Full=',nAtoms_Full
        Write (6,*) 'nAtoms_Fullx=',nAtoms_All
        Call Abend
      End If
      Call Qpg_dArray('GRAD',Found,nGrad)
      If(.not.Found .or. nGrad.eq.0) Then
        Write (6,*) 'Get_Grad_Full: Did not find GRAD'
        Call Abend
      End If
      Call Get_dArray('GRAD',Grad_Full,nGrad)
      Call Qpg_dArray('MMO Grad',Found,nGradMM)
      If (Found) Then
        Call Get_dArray('MMO Grad',Grad_Full(1,nAtoms_All+1),nGradMM)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine autoSegmentation(Nprocs, maxspace,
     & Jal1, Jal2,
     & NvGrp, NvSGrp, NchBlk, wrksize, maxdim)
c
c           Issues:
c
c           1) o2v4: n'(n'+1)/2 + n' "poltaskov"
c           2) odhadnut overhead? on-the-fly vs precalculate?
c
        implicit none

c MaxGrp, MaxSGrp, ...
#include "chcc1.fh"

        integer Nprocs, NvGrp, NvSGrp, NchBlk
        real*8 eff_thrs, eff
        parameter (eff_thrs = 80.0d0)

        logical requireEfficiency
        parameter (requireEfficiency=.true.)
c
        integer Jal1,Jal2
        integer wrksize, maxspace, maxdim
c
        write (6,*)
        write (6,*) "==============================="
        write (6,*) 'Autogenerating segmentation'
        write (6,'(A,i8)') ' Nprocs: ',Nprocs
        write (6,*)
c
c reset small segmentation
        NvSGrp = 1
c
c get rough estimated of N', e.g. Nprocs == nntasks
        NvGrp = int(sqrt(2.0d0*Nprocs))
        if (printkey.ge.2) then
          write (6,'(A,i4)')
     & " 1st Np estimate: ",
     & NvGrp
        end if

c if no such Np, get the smallest Np for which nntasks > Nprocs
        if ((NvGrp*NvGrp/2.0d0).lt.Nprocs) then
          NvGrp = NvGrp + 1
          if (printkey.ge.2) then
            write (6,'(A,i4)')
     & " Corrected 1st Np estimate: ",
     & NvGrp
          end if
        end if

c make correction for efficiency, if required
        if (requireEfficiency) then
           call findNextEffSeg(NvGrp, eff,
     & Nprocs, eff_thrs, maxGrp, printkey)
           if (printkey.ge.2) then
             write (6,'(A,i4,A,f6.2)')
     & " (maybe) further correction for efficiency: ",
     & NvGrp,", efficiency: ",eff*100
           end if
        endif

        write (6,*)

c does the segmentation fit into memory (start with Npp = 1)?
        call checkMem(NvGrp, NvSGrp, NchBlk,
     & Jal1, Jal2, wrksize, maxdim)
c
12      continue
        if (wrksize.gt.maxspace) then
c
           if (printkey.ge.10) then
             write (6,'(A,i13)') " Not enough memory. Max: ",
     & maxspace,", Current: ",wrksize
           end if
c
c          increase small segmentation, if possible
c
           if ((NvSGrp.lt.8).and.
     & ((NvGrp*(NvSGrp+1)).le.maxSGrp)) then
             NvSGrp = NvSGrp + 1
             if (printkey.ge.10) then
               write (6,'(A,i4)') ' Npp increased: ',NvSGrp
             end if
c
c          if not, increase large segmentation and reset small
c
           else
c
c            reset small segmentation in any case
             NvSGrp = 1
c
c            increment large segmentation
             NvGrp = NvGrp + 1
             if (printkey.ge.10) then
               write (6,'(A,i4)') " Np increased: ",NvGrp
             end if
c
c            make correction for efficiency, if required
             if (requireEfficiency) then
               call findNextEffSeg(NvGrp, eff,
     & Nprocs, eff_thrs, maxGrp, printkey)
                if (printkey.ge.10) then
                  write (6,'(A,i4)')
     & " Np increased (corrected for efficiency): ",NvGrp
                end if
             endif
c
c            check new large segmentation
c
             if (NvGrp.gt.maxGrp) then
               write (6,*)
               write (6,*) " No suitable segmentation found, quiting"
               call abend
             endif
c
           endif ! increase small or large
c
c          print final results and
c          recompute memory requirements
           if (printkey.ge.10) then
             write (6,'(2(A,i4))') " Current Np: ",NvGrp,', Npp: ',
     & NvSgrp
           end if
c
           call checkMem(NvGrp, NvSGrp, NchBlk,
     & Jal1, Jal2, wrksize, maxdim)
           goto 12

        endif ! we fit to memory

        write (6,*)
        write (6,'(A,2(i4),i8)')
     & " Final segmentation (Large/Small/Cholesky): ",
     & NvGrp,NvSGrp,NchBlk
        write (6,*) "==============================="
        write (6,*)

        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Module Period
*     mAdCell, lthCell - information on atoms in the unit cell         *
*     If iAt = 1..lthCell, then
*        iWork(mAdCell+(iAt-1)) - total sequence # of the cell's atom in the full list          *
*     VCell        - unit cell vectors
*     ispread      - how many steps to spread the unit cell along each unit cell vector

      Integer mAdCell, lthCell , nAtC
      Equivalence(lthCell,nAtC)

      Integer ispread(3)
      Real*8 VCell(3,3)
      Logical Cell_l
      Integer, Allocatable :: AdCell(:)
      End Module Period

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CoSet(iCoSet,nCoSet,iChAtom)

use Symmetry_Info, only: nIrrep, iOper
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: iCoSet(0:7), nCoSet
integer(kind=iwp), intent(in) :: iChAtom
integer(kind=iwp) :: iIrrep, itest, jCoSet, jtest
logical(kind=iwp) :: Same

! Find the coset representatives

iCoSet(0) = 0 ! Put in the unit operator
nCoSet = 1
do iIrrep=1,nIrrep-1
  itest = iand(iChAtom,iOper(iIrrep))
  Same = .false.
  do jCoSet=0,nCoSet-1
    jTest = iand(iChAtom,iCoSet(jCoSet))
    if (jTest == iTest) then
      Same = .true.
      exit
    end if
  end do
  if (.not. Same) then
    nCoSet = nCoSet+1
    iCoSet(nCoSet-1) = iOper(iIrrep)
  end if
end do

return

end subroutine CoSet

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Complex*16 FUNCTION CDET(MA,N,A)
C================================================= ========
c MA is the MAximal dimension
c N is the dimension N<MA
c A is the Complex matrix
c================================================= ======
      Implicit None
      Integer, parameter            :: wp=kind(0.d0)
      Integer, intent(in)            :: N,MA
      Complex(kind=8), intent(inout):: A(MA,MA)
      Integer                        :: I,J,K,L,K1
      Real(kind=8)                  :: P,Q
      Complex(kind=8)               :: CP,CQ
C
      I=0
      CDET = (0.0_wp,0.0_wp)

      Do K=1,N
      P = 0.0_wp

         Do J=K,N
            Q = ABS(A(J,K))
            If (Q.gt.P) Then
               P = Q
               I = J
            End If
         End Do

         CP = (1.0_wp,0.0_wp)/A(I,K)

         If (I.ne.K) Then
            CDET = -CDET
            Do L=K,N
               CQ = A(I,L)
               A(I,L) = A(K,L)
               A(K,L) = CQ
            End Do
         End If

         CDET = CDET*A(K,K)

         If (K.lt.N) Then
            K1 = K+1
            Do I = K1,N
               CQ=A(I,K)*CP
               Do L = K1,N
                  A(I,L) = A(I,L)-CQ*A(K,L)
               End Do
            End Do
         End If

      End Do ! K

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Bernd Artur Hess                                 *
************************************************************************
      SubRoutine Ass_pXp(Beta,nZeta,Final,la,lb,Slalbp,Slalbm,nComp)
************************************************************************
*                                                                      *
* Object: to assemble the pVp integrals                                *
*                                                                      *
*     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
*             Chemie, University of Bonn, Germany, August 1994         *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8  Final (nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp),
     *        Slalbp(nZeta,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2,3,nComp),
     *        Slalbm(nZeta,(la+1)*(la+2)/2, lb   *(lb+1)/2,3,nComp),
     *        Beta(nZeta)
      Character*80 Label
*
*     Statement function for cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
      nElem(ix) = (ix+1)*(ix+2)/2
*
      iRout = 211
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Write (6,*)
         Write (6,*) ' In Ass_pXp la,lb,nComp,=',la,lb,nComp
         Write (6,*)
         Call RecPrt('Beta','(10G15.8)',Beta,nZeta,1)
         Do iComp = 1, nComp
            Write (6,*) 'iComp=',iComp
            Write (Label,'(A,I2,A)')
     &            ' Ass_pXp: Slalbp(1,iComp=',iComp,')'
            Call RecPrt(Label,'(10G15.8)',Slalbp(1,1,1,1,iComp),
     &                   nZeta,nElem(la)*nElem(lb+1))
            Write (Label,'(A,I2,A)')
     &            ' Ass_pXp: Slalbp(2,iComp=',iComp,')'
            Call RecPrt(Label,'(10G15.8)',Slalbp(1,1,1,2,iComp),
     &                   nZeta,nElem(la)*nElem(lb+1))
            Write (Label,'(A,I2,A)')
     &            ' Ass_pXp: Slalbp(3,iComp=',iComp,')'
            Call RecPrt(Label,'(10G15.8)',Slalbp(1,1,1,3,iComp),
     &                   nZeta,nElem(la)*nElem(lb+1))
         If (lb.gt.0) Then
            Write (Label,'(A,I2,A)')
     &             'Ass_pXp: Slalbm(1,iComp=',iComp,')'
            Call RecPrt(Label,'(10G15.8)',Slalbm(1,1,1,1,iComp),
     &                  nZeta,nElem(la)*nElem(lb-1))
            Write (Label,'(A,I2,A)')
     &             'Ass_pXp: Slalbm(2,iComp=',iComp,')'
            Call RecPrt(Label,'(10G15.8)',Slalbm(1,1,1,2,iComp),
     &                  nZeta,nElem(la)*nElem(lb-1))
            Write (Label,'(A,I2,A)')
     &             'Ass_pXp: Slalbm(3,iComp=',iComp,')'
            Call RecPrt(Label,'(10G15.8)',Slalbm(1,1,1,3,iComp),
     &                  nZeta,nElem(la)*nElem(lb-1))
         End If
         End Do
      End If
*
      Do iComp = 1, nComp
*
      Do 10 ixa = la, 0, -1
         Do 11 iya = la-ixa, 0, -1
            iza = la-ixa-iya
            ipa = Ind(la,ixa,iza)
*
      Do 20 ixb = lb, 0, -1
         Do 21 iyb = lb-ixb, 0, -1
            izb = lb-ixb-iyb
            ipb = Ind(lb,ixb,izb)
*
            Do 30 iZeta = 1, nZeta
               Final(iZeta,ipa,ipb,iComp) =
     &                  Two*Beta(iZeta) *
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb  ),1,iComp)
     &                 +Two*Beta(iZeta) *
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb  ,izb  ),2,iComp)
     &                 +Two*Beta(iZeta) *
     &                  Slalbp(iZeta,ipa,Ind(lb+1,ixb  ,izb+1),3,iComp)
30          Continue
*
            If (ixb.gt.0) Then
               Do 31 iZeta = 1, nZeta
                 Final(iZeta,ipa,ipb,iComp)=Final(iZeta,ipa,ipb,iComp)
     &          -Dble(ixb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),1,iComp)
31             Continue
            End If
*
            If (iyb.gt.0) Then
               Do 32 iZeta = 1, nZeta
                 Final(iZeta,ipa,ipb,iComp)=Final(iZeta,ipa,ipb,iComp)
     &          -Dble(iyb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb),2,iComp)
32             Continue
            End If
*
            If (izb.gt.0) Then
               Do 33 iZeta = 1, nZeta
                 Final(iZeta,ipa,ipb,iComp)=Final(iZeta,ipa,ipb,iComp)
     &          -Dble(izb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),3,iComp)
33             Continue
            End If
*
21       Continue
20    Continue
*
11       Continue
10    Continue
*
      End Do ! iComp
*
      If (iPrint.ge.49) Then
         Do iComp = 1, nComp
            Write (Label,'(A,I2,A,I2,A,I2,A)')
     &            ' Ass_pXp: pXp(iComp=',iComp,')'
            Call RecPrt(Label,'(10G15.8)',Final(1,1,1,iComp),
     &                              nZeta,nElem(la)*nElem(lb))
         End Do
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_PTS_Final(NVT,l_NVT)
C
C     Thomas Bondo Pedersen, April 2010.
C
      Implicit None
      Integer l_NVT
      Integer NVT(l_NVT)
#include "choglob.fh"

      Integer i

      Call iCopy(l_NVT,NVT,1,NumCho_G,1)
      NumChT_G=NumCho_G(1)
      Do i=2,l_NVT
         NumChT_G=NumChT_G+NumCho_G(i)
      End Do
      Call Cho_Final(.False.)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

module Symmetry_Info

use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: iChCar(3) = 0, iChTbl(0:7,0:7) = 0, iOper(0:7) = 0, iSkip(0:7) = 0, MxFnc, nIrrep = 1
logical(kind=iwp) :: VarR = .false., VarT = .false.
character(len=80) :: lBsFnc(0:7) = ''
character(len=3) :: lIrrep(0:7) = '', SymLab
integer, allocatable :: iChBas(:)
integer(kind=iwp), parameter :: Mul(8,8) = reshape([1,2,3,4,5,6,7,8, &
                                                    2,1,4,3,6,5,8,7, &
                                                    3,4,1,2,7,8,5,6, &
                                                    4,3,2,1,8,7,6,5, &
                                                    5,6,7,8,1,2,3,4, &
                                                    6,5,8,7,2,1,4,3, &
                                                    7,8,5,6,3,4,1,2, &
                                                    8,7,6,5,4,3,2,1],[8,8]), &
                                Prmt(0:7,0:7) = reshape([1, 1, 1, 1, 1, 1, 1, 1, &
                                                         1,-1, 1,-1, 1,-1, 1,-1, &
                                                         1, 1,-1,-1, 1, 1,-1,-1, &
                                                         1,-1,-1, 1, 1,-1,-1, 1, &
                                                         1, 1, 1, 1,-1,-1,-1,-1, &
                                                         1,-1, 1,-1,-1, 1,-1, 1, &
                                                         1, 1,-1,-1,-1,-1, 1, 1, &
                                                         1,-1,-1, 1,-1, 1, 1,-1],[8,8])

public :: iChBas, iChCar, iChTbl, iOper, iSkip, lBsFnc, lIrrep, Mul, nIrrep, Prmt, SymLab, Symmetry_Info_Dmp, Symmetry_Info_Free, &
          Symmetry_Info_Get, Symmetry_Info_Set, Symmetry_Info_Setup, VarR, VarT

!***********************************************************************
!***********************************************************************

contains

!***********************************************************************
!***********************************************************************

subroutine Symmetry_Info_Dmp()

  use fortran_strings, only: char_array
  use stdalloc, only: mma_allocate, mma_deallocate
# ifdef _DEBUGPRINT_
  use Definitions, only: u6
# endif

  integer(kind=iwp) :: i, j, lcDmp, liDmp
  integer(kind=iwp), allocatable :: iDmp(:)
  character, allocatable :: cDmp(:)

  if (.not. allocated(iChBas)) then
    call WarningMessage(2,'Symmetry_Info_Dmp: iChBas is not allocated!')
    call Abend()
  end if

  liDmp = 1+8+8*8+3+MxFnc+8+2
  call mma_allocate(iDmp,liDmp,Label='iDmp')

  i = 0
  iDmp(i+1) = nIrrep
  i = i+1
  iDmp(i+1:i+8) = iOper(:)
  i = i+8
  iDmp(i+1:i+8*8) = reshape(iChTbl(:,:),[8*8])
  i = i+8*8
  iDmp(i+1:i+3) = iChCar(1:3)
  i = i+3
  iDmp(i+1:i+MxFnc) = iChBas(1:MxFnc)
  i = i+MxFnc
  iDmp(i+1:i+8) = iSkip(0:7)
  i = i+8
  iDmp(i+1) = merge(1,0,VarR)
  i = i+1
  iDmp(i+1) = merge(1,0,VarT)
  i = i+1

# ifdef _DEBUGPRINT_
  write(u6,*) 'Symmetry_Info_Dmp'
  write(u6,*) 'liDmp=',liDmp
  write(u6,*) 'MxFnc=',MxFnc
  write(u6,*) 'nIrrep=',nIrrep
  write(u6,*) 'iOper:'
  write(u6,'(8I4)') (iOper(i),i=0,nIrrep-1)
  write(u6,*)
  write(u6,'(9I4)') (iDmp(i),i=1,liDmp)
  write(u6,*)
  write(u6,*) 'lIrrep:'
  do i=0,nIrrep-1
    write(u6,'(A)') lIrrep(i)
  end do
  write(u6,*) 'lBsFnc:'
  do i=0,nIrrep-1
    write(u6,'(A)') lBsFnc(i)
  end do
  write(u6,'(2A)') 'SymLab:',SymLab
# endif

  call Put_iArray('Symmetry Info',iDmp,liDmp)
  call mma_deallocate(iDmp)

  lcDmp = 3*8+80*8+3
  call mma_allocate(cDmp,lcDmp,Label='cDmp')
  j = 0
  do i=0,7
    cDmp(j+1:j+3) = char_array(lIrrep(i))
    j = j+3
  end do
  do i=0,7
    cDmp(j+1:j+80) = char_array(lBsFnc(i))
    j = j+80
  end do
  cDmp(j+1:j+3) = char_array(SymLab)
  j = j+3
  call put_cArray('SymmetryCInfo',cDmp(1),lcDmp)
  call mma_deallocate(cDmp)

end subroutine Symmetry_Info_Dmp

!***********************************************************************
!***********************************************************************

subroutine Symmetry_Info_Get()

  use fortran_strings, only: str
  use stdalloc, only: mma_allocate, mma_deallocate
# ifdef _DEBUGPRINT_
  use Definitions, only: u6
# endif

  integer(kind=iwp) i, j, liDmp, lcDmp
  logical(kind=iwp) :: Found
  integer(kind=iwp), allocatable :: iDmp(:)
  character, allocatable :: cDmp(:)

  if (allocated(iChBas)) return
  call Qpg_iArray('Symmetry Info',Found,liDmp)
  call mma_allocate(iDmp,liDmp,Label='iDmp')
  call Get_iArray('Symmetry Info',iDmp,liDmp)

  MxFnc = liDmp-(1+8+8*8+3+8+2)
  call mma_allocate(iChBas,MxFnc,Label='iChBas')

  i = 0
  nIrrep = iDmp(i+1)
  i = i+1
  iOper(:) = iDmp(i+1:i+8)
  i = i+8
  iChTbl(:,:) = reshape(iDmp(i+1:i+8*8),[8,8])
  i = i+8*8
  iChCar(1:3) = iDmp(i+1:i+3)
  i = i+3
  iChBas(1:MxFnc) = iDmp(i+1:i+MxFnc)
  i = i+MxFnc
  iSKip(0:7) = iDmp(i+1:i+8)
  i = i+8
  VarR = iDmp(i+1) > 0
  i = i+1
  VarT = iDmp(i+1) > 0
  i = i+1
  call mma_deallocate(iDmp)

  lcDmp = 3*8+80*8+3
  call mma_allocate(cDmp,lcDmp,Label='cDmp')
  call get_carray('SymmetryCInfo',cDmp(1),lcDmp)
  j = 0
  do i=0,7
    lIrrep(i) = str(cDmp(j+1:j+3))
    j = j+3
  end do
  do i=0,7
    lBsFnc(i) = str(cDmp(j+1:j+80))
    j = j+80
  end do
  SymLab = str(cDmp(j+1:j+3))
  j = j+3
  call mma_deallocate(cDmp)
# ifdef _DEBUGPRINT_
  write(u6,*) 'Symmetry_Info_Get'
  write(u6,*) 'liDmp=',liDmp
  write(u6,*) 'MxFnc=',MxFnc
  write(u6,*) 'nIrrep=',nIrrep
  write(u6,*)
  write(u6,'(2A)') 'SymLab:',SymLab
  write(u6,*) 'iOper:'
  write(u6,'(8I4)') (iOper(i),i=0,nIrrep-1)
  write(u6,*)
  write(u6,*) 'lIrrep:'
  do i=0,nIrrep-1
    write(u6,'(A)') lIrrep(i)
  end do
  do i=0,nIrrep-1
    write(u6,'(A)') lBsFnc(i)
  end do
# endif

end subroutine Symmetry_Info_Get

!***********************************************************************
!***********************************************************************

subroutine Symmetry_Info_Free()

  use stdalloc, only: mma_deallocate

  if (.not. allocated(iChBas)) return
  call mma_deallocate(iChBas)
  MxFnc = 0

end subroutine Symmetry_Info_Free

!***********************************************************************
!***********************************************************************

subroutine Symmetry_Info_Setup(nOper,Oper,iAng)

  use Definitions, only: u6

  integer(kind=iwp), intent(in) :: nOper, iAng
  character(len=3), intent(in) :: Oper(3)
  integer(kind=iwp) :: i, j

  if (allocated(iChBas)) return   ! Return if already initiated.

  nIrrep = 2**nOper
  call Put_iScalar('NSYM',nIrrep)

  iOper(0) = 0
  do i=1,nOper
    iOper(i) = 0
    do j=1,3
      if (Oper(i)(j:j) == 'X') iOper(i) = iOper(i)+1
      if (Oper(i)(j:j) == 'Y') iOper(i) = iOper(i)+2
      if (Oper(i)(j:j) == 'Z') iOper(i) = iOper(i)+4
    end do
    if (iOper(i) == 0) then
      call WarningMessage(2,'RdCtl: Illegal symmetry operator!')
      write(u6,*) 'Oper=',Oper(i)
      write(u6,*)
      call Abend()
    end if
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Generate all operations of the group

  if (nOper >= 2) then
    iOper(4) = iOper(3)
    iOper(3) = ieor(iOper(1),iOper(2))
  end if
  if (nOper == 3) then
    iOper(5) = ieor(iOper(1),iOper(4))
    iOper(6) = ieor(iOper(2),iOper(4))
    iOper(7) = ieor(iOper(1),ieor(iOper(2),iOper(4)))
  end if

  call Put_iArray('Symmetry operations',iOper,nIrrep)

  ! Generate the Character table for all Irreps, iChTbl

  ! All Irreps are one dimensional, i.e. the Character for the
  ! unit operator is 1 in all irreps.
  ! The totally symmetric representation will have the character
  ! of 1 for any given operation
  ! Now, the Irreps are due to classes of operations and will
  ! present the character of this class. In case of Abelian groups
  ! or other one dimensional groups the classes will have one
  ! and only one operation. Hence, the operations themselves can
  ! be used to present the character of the Irreps.

  ! Generate iChTbl, lIrrep, lBsFnc (iSigma)
  call ChTab(iOper,nIrrep,iChTbl)

  ! Generate iChCar, iChBas, MxFnc
  call Symmetry_Info_Set(iAng)

end subroutine Symmetry_Info_Setup

!***********************************************************************
!***********************************************************************

subroutine Symmetry_Info_Set(iAng)

  use stdalloc, only: mma_allocate
# ifdef _DEBUGPRINT_
  use Definitions, only: u6
# endif

  integer(kind=iwp), intent(in) :: iAng
  integer(kind=iwp) :: i, iIrrep, iSymX, iSymY, iSymZ, ix, ixyz, iy, iyMax, iz, jIrrep, jx, jxyz, jy, jz, lxyz

  if (allocated(iChBas)) return

  ! Setup characteristics for cartesian basis functions.
  ! Observe that this is affected by the defined generators.
  ! In the array we will set the bit corresponding to a symop
  ! if that symop will alter the sign of the basis function.

  iSymX = 0
  iSymY = 0
  iSymZ = 0
  do i=0,nIrrep-1
    if (btest(iOper(i),0)) iSymX = 2**0
    if (btest(iOper(i),1)) iSymY = 2**1
    if (btest(iOper(i),2)) iSymZ = 2**2
  end do
  iChCar(1) = iSymX
  iChCar(2) = iSymY
  iChCar(3) = iSymZ

  MxFnc = (iAng+1)*(iAng+2)*(iAng+3)/6
  call mma_allocate(iChBas,MxFnc,Label='iChBas')
# ifdef _DEBUGPRINT_
  write(u6,*) 'Symmetry_Info_Set:'
  write(u6,*) 'iAng,MxFnc=',iAng,MxFnc
# endif

  lxyz = 0
  do ixyz=0,iAng
    do ix=ixyz,0,-1
      jx = mod(ix,2)
      iyMax = ixyz-ix
      do iy=iyMax,0,-1
        jy = mod(iy,2)
        lxyz = lxyz+1
        iz = ixyz-ix-iy
        jz = mod(iz,2)
        jxyz = jx*iSymX+jy*iSymY+jz*iSymZ
        iChBas(lxyz) = jxyz
      end do
    end do
  end do

  do iIrrep=0,nIrrep-2
    do jIrrep=iIrrep+1,nIrrep-1
      if (iOper(iIrrep) == iOper(jIrrep)) then
        call WarningMessage(2,' The generators of the point group are over defined, correct input!;'// &
                            'Abend: correct symmetry specifications!')
        call Quit_OnUserError()
      end if
    end do
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) 'Symmetry_Info_Set:'
  write(u6,*) 'MxFnc=',MxFnc
  write(u6,*) 'nIrrep=',nIrrep
  write(u6,'(A,8I4)') 'iOper:',iOper(0:nIrrep-1)
  write(u6,*) 'iChTbl:'
  do i=0,nIrrep-1
    write(u6,'(8I4)') iChTbl(0:nIrrep-1,i)
  end do
# endif

end subroutine Symmetry_Info_Set

!***********************************************************************
!***********************************************************************

subroutine ChTab(iOper,nIrrep,outChTbl)
  !*********************************************************************
  !                                                                    *
  ! Object: to generate the character table of a point group within    *
  !         D2h.                                                       *
  !                                                                    *
  !     Author: Roland Lindh, Dept. of Theoretical Chemistry,          *
  !             University of Lund, SWEDEN                             *
  !             September '91                                          *
  !*********************************************************************

  use Definitions, only: u6

  integer(kind=iwp), intent(in) :: nIrrep, iOper(nIrrep)
  integer(kind=iwp), intent(out) :: outChTbl(1:8,1:8) ! ugly dimensions change to 0:7!
  integer(kind=iwp) :: i, i1, ia, ib, iCh, iFnc, iIrrep, iRot, iSigma = 1, iSub, iTest(8), ix, iy, iz, j, jIrrep, jx, jy, jz
  logical(kind=iwp) :: Inv, Rot, SymX, SymY, SymZ
  character(len=80) :: Tmp
  character(len=*), parameter :: xyz(0:7) = ['      ', &
                                             'x     ', &
                                             'y     ', &
                                             'xy, Rz', &
                                             'z     ', &
                                             'xz, Ry', &
                                             'yz, Rx', &
                                             'I     ']

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (nIrrep == 1) then
    SymLab = 'C1 '
    iSigma = 1
  else if (nIrrep == 2) then
    if (iOper(2) == 7) then
      SymLab = 'Ci '
      iSigma = 1
    else if ((iOper(2) == 1) .or. (iOper(2) == 2) .or. (iOper(2) == 4)) then
      SymLab = 'Cs'
      iSigma = 1
    else
      SymLab = 'C2'
      iSigma = 2
    end if
  else if (nIrrep == 4) then
    if ((iOper(2) == 7) .or. (iOper(3) == 7) .or. (iOper(4) == 7)) then
      SymLab = 'C2h'
      iSigma = 2
    else
      Rot = .true.
      do i=1,nIrrep
        if ((iOper(i) == 1) .or. (iOper(i) == 2) .or. (iOper(i) == 4)) Rot = .false.
      end do
      if (Rot) then
        SymLab = 'D2 '
        iSigma = 2
      else
        SymLab = 'C2v'
        iSigma = 2
      end if
    end if
  else if (nIrrep == 8) then
    SymLab = 'D2h'
    iSigma = 2
  else
    call WarningMessage(2,'ChTab: Illegal value of nIrrep')
    write(u6,*) 'nIrrep=',nIrrep
    call Abend()
  end if
  outChTbl(:,:) = 0

  ! Go through the functions x, y, and z, and the dyadic functions.

  SymX = .false.
  SymY = .false.
  SymZ = .false.
  do i=1,nIrrep
    SymX = SymX .or. btest(iOper(i),0)
    SymY = SymY .or. btest(iOper(i),1)
    SymZ = SymZ .or. btest(iOper(i),2)
  end do

  ! Loop over basis functions (a' la Malmqvist)

  lBsFnc(0:nIrrep-1) = '' ! For this to work we need a clean slate.
  do iFnc=0,7
    Tmp = xyz(iFnc)

    ! Generate a row in the character table of this function

    ix = merge(1,0,SymX .and. btest(iFnc,0))
    iy = merge(1,0,SymY .and. btest(iFnc,1))
    iz = merge(1,0,SymZ .and. btest(iFnc,2))
    ! Loop over all operators
    do i=1,nIrrep
      jx = merge(1,0,SymX .and. btest(iOper(i),0))
      jy = merge(1,0,SymY .and. btest(iOper(i),1))
      jz = merge(1,0,SymZ .and. btest(iOper(i),2))
      iCh = 1
      if ((ix /= 0) .and. (jx /= 0)) iCh = -iCh
      if ((iy /= 0) .and. (jy /= 0)) iCh = -iCh
      if ((iz /= 0) .and. (jz /= 0)) iCh = -iCh
      iTest(i) = iCh
    end do

    ! Compute place of Irrep

    if (nIrrep == 1) then
      jIrrep = 1
    else if (nIrrep == 2) then
      jIrrep = 1+(1-iTest(2))/2
    else if (nIrrep == 4) then
      jIrrep = 1+((1-iTest(2))+2*(1-iTest(3)))/2
    else if (nIrrep == 8) then
      jIrrep = 1+((1-iTest(2))+2*(1-iTest(3))+4*(1-iTest(5)))/2
    else
      jIrrep = -1
      call WarningMessage(2,'ChTab: Illegal nIrrep value!')
      write(u6,*) 'nIrrep=',nIrrep
      call Abend()
    end if
    if (lBsFnc(jIrrep-1)(1:1) == ' ') then
      lBsFnc(jIrrep-1) = Tmp
      outChTbl(jIrrep,1:nIrrep) = iTest(1:nIrrep)
    else
      lBsFnc(jIrrep-1) = trim(lBsFnc(jIrrep-1))//', '//trim(Tmp)
    end if
  end do

  ! Set up some Mulliken symbols for the irreps

  do iIrrep=1,nIrrep
    lIrrep(iIrrep-1) = 'a'
    do i=1,nIrrep

      ! If the character of an rotation in an irreps is -1 then
      ! the irreps is assigned the character B, otherwise A.

      if (((iOper(i) == 3) .or. (iOper(i) == 5) .or. (iOper(i) == 6)) .and. (outChTbl(iIrrep,i) == -1)) lIrrep(iIrrep-1) = 'b'

    end do
  end do
  iSub = 0

  ! Subscript according to C2 operations

  Rot = .false.
  do i=1,nIrrep
    if ((iOper(i) == 3) .or. (iOper(i) == 5) .or. (iOper(i) == 6)) Rot = .true.
  end do
  if (Rot .and. (SymLab /= 'C2v')) then
    iSub = iSub+1

    ! Find the number of A's and B's

    ia = 0
    ib = 0
    do i=1,nIrrep
      if (lIrrep(i-1)(1:1) == 'a') ia = ia+1
      if (lIrrep(i-1)(1:1) == 'b') ib = ib+1
    end do
    if (nIrrep == 8) then
      ia = ia/2
      ib = ib/2
    end if
    if (SymLab == 'C2h') then
      ia = ia/2
      ib = ib/2
    end if

    ! Find the rotations

    iRot = 0
    do i=1,nIrrep
      if ((iOper(i) == 3) .or. (iOper(i) == 5) .or. (iOper(i) == 6)) then
        iRot = iRot+1
        write(Tmp,'(I1)') iRot
        if (ia > 1) then
          do j=1,nIrrep
            if ((lIrrep(j-1)(1:1) == 'a') .and. (outChTbl(j,i) == 1)) lIrrep(j-1) = lIrrep(j-1)(1:1)//Tmp(1:1)
          end do
        end if
        if (ib > 1) then
          do j=1,nIrrep
            if ((lIrrep(j-1)(1:1) == 'b') .and. (outChTbl(j,i) == 1)) lIrrep(j-1) = lIrrep(j-1)(1:1)//Tmp(1:1)
          end do
        end if
      end if
    end do
  else if (Rot .and. (SymLab == 'C2v')) then

    ! Find the Rotation

    iRot = -1
    do i=1,nIrrep
      if ((iOper(i) == 3) .or. (iOper(i) == 5) .or. (iOper(i) == 6)) iRot = iOper(i)
    end do

    ! Find the first vertical mirror plane to this axis

    do i=1,nIrrep
      if ((iOper(i) /= 3) .and. (iOper(i) /= 5) .and. (iOper(i) /= 6) .and. (iOper(i) /= 7) .and. (iand(iOper(i),iRot) /= 1)) &
        iRot = i
    end do
    do i=1,nIrrep
      if (outChTbl(i,iRot) == 1) then
        j = 1
      else
        j = 2
      end if
      write(Tmp,'(I1)') j
      lIrrep(i-1) = lIrrep(i-1)(1:1)//Tmp(1:1)
    end do
  end if

  ! Subscript according to inversion if present

  Inv = .false.
  do i=1,nIrrep
    Inv = (iOper(i) == 7) .or. Inv
  end do
  if (Inv) then
    iSub = iSub+1

    ! Loop over each Irrep

    do iIrrep=1,nIrrep
      i1 = 1+len_trim(lIrrep(iIrrep-1))

      ! Loop over operators

      do i=1,nIrrep
        if (iOper(i) == 7) then
#         ifdef _WARNING_WORKAROUND_
          ! see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=101827
          i1 = min(i1,len(lIrrep))
#         endif
          if (outChTbl(iIrrep,i) == 1) then
            lIrrep(iIrrep-1)(i1:i1) = 'g'
          else if (outChTbl(iIrrep,i) == -1) then
            lIrrep(iIrrep-1)(i1:i1) = 'u'
          end if
        end if
      end do
    end do
  end if

  ! Fix labels for Cs

  if (SymLab(1:2) == 'Cs') then
    lIrrep(0) = "a'"
    lIrrep(1) = 'a"'
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call Put_iScalar('Rotational Symmetry Number',iSigma)
  call Put_cArray('Irreps',lIrrep(0),24)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  return

end subroutine ChTab

!***********************************************************************
!***********************************************************************

end module Symmetry_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Cp_Prop_Int(AInt,nAInt,BInt,nBInt,nBas,nIrrep,Label)
************************************************************************
*                                                                      *
* Object: replace the diagonal blocks of the property integrals.       *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 AInt(nAInt+4), BInt(nBInt+4)
      Integer nBas(0:nIrrep-1)
*
      iCmp = 1
      iExp = 1
      Do iIrrep = 0, nIrrep-1
         Do 20 jIrrep = 0, iIrrep
            ij = iEor(iIrrep,jIrrep)
            If (iAnd(Label,2**ij).eq.0) Go To 20
            If (iIrrep.eq.jIrrep) Then
*
               Len = nBas(iIrrep)*(nBas(iIrrep)+1)/2
               Do iLen = 0, Len-1
C                 Write (*,*) AInt(iExp+iLen), BInt(iCmp+iLen)
                  AInt(iExp+iLen) = BInt(iCmp+iLen)
               End Do
               iCmp = iCmp + Len
               iExp = iExp + Len
            Else
               Len = nBas(iIrrep)*nBas(jIrrep)
               iExp = iExp + Len
            End If
 20      Continue
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine set_nm( exch, ncut, encut_definition, nk, mg,
     &                   nTempMagn, hmax, w, encut_rate, TempMagn,
     &                   nM, EM, dbg )

      Implicit None
#include "warnings.h"
c input data:
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)        :: exch, ncut, encut_definition, nk,
     &                              mg, nTempMagn
      Real(kind=8), intent(in)  :: hmax, W(exch), encut_rate,
     &                              TempMagn(nTempMagn)
      Logical, intent(in)        :: dbg
c output data:
      Integer,       intent(out) :: nM
      Real(kind=8), intent(out) :: EM
c local variables:
      Integer       :: i
      Real(kind=8) :: diff, T_High
      Real(kind=8) :: boltz_k, mu_bohr

      ! Constants:
      boltz_k=0.6950356_wp                    !   in cm^-1*K-1
      mu_bohr=0.466864374_wp                  !   in cm-1*T-1

      nM     = 1
      EM     = 0.0_wp
      diff   = 0.0_wp
      T_High = 0.0_wp
      If(nTempMagn>0) T_High = MAXVAL(TempMagn(1:nTempMagn))

      If (dbg) Write(6,*) 'exch             = ', exch
      If (dbg) Write(6,*) 'ncut             = ', ncut
      If (dbg) Write(6,*) 'encut_definition = ', encut_definition
      If (dbg) Write(6,*) 'nk               = ', nk
      If (dbg) Write(6,*) 'mg               = ', mg
      If (dbg) Write(6,*) 'nM               = ', nM
      If (dbg) Write(6,*) 'nTempMagn        = ', nTempMagn
      If (dbg) Write(6,*) 'hmax             = ', hmax
      If (dbg) Write(6,*) 'encut_rate       = ', encut_rate
      If (dbg) Write(6,*) 'EM               = ', EM
      If (dbg) Write(6,*) 'TempMagn()       = ', TempMagn(1:nTempMagn)
      If (dbg) Write(6,*) 'W()              = ', W(1:exch)


      If(encut_definition==1) Then

         If ( ncut>exch ) Then
            nm = exch
            em = w(exch)
         Else
            nm = ncut
            em = w(nm)
         End If


      Else If(encut_definition==2) Then

         nm = exch
         em = nk*boltz_k*T_High + mg*mu_bohr*abs(hmax)

         Do i=1,exch
            If ( i>1 ) diff = w(i) - w(i-1)
            If( ( w(i)>em ) .and. ( diff>1.0d-4 ) ) Then
               nm=i-1
               Go To 309
            End If
         End Do


      Else If(encut_definition==3) Then

         nm = exch
         em = w(exch)*encut_rate

         Do i=1,exch
            If(i>1) diff = w(i) - w(i-1)
            If( ( w(i)>em ) .and. ( diff>1.0d-4 ) ) Then
               nm=i-1
               Go To 309
            End If
         End Do


      Else

         Write(6,'(A)') 'something is wrong with "encut_definition" '
         Call quit(_RC_INPUT_ERROR_)

      End If !encut_definition

309   Continue

      Return
      End subroutine set_nm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CmbnCB(Rnxyz,nZeta,la,lb,rKappa,rFinal,Beta,IfGrad,ld,nVecCB)
!***********************************************************************
!                                                                      *
! Object: compute the gradient of the overlap matrix.                  *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91.                                             *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, ld
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la,0:lb+ld), rKappa(nZeta), Beta(nZeta)
real(kind=wp), intent(inout) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),4)
logical(kind=iwp), intent(in) :: IfGrad(3)
integer(kind=iwp), intent(out) :: nVecCB
integer(kind=iwp) :: ipa, ipb, ixa, ixb, iya, iyaMax, iyb, iybMax, iza, izb
real(kind=wp) :: xB, yB, zB

#ifdef _DEBUGPRINT_
call RecPrt(' In CmbnCB: rKappa',' ',rKappa,1,nZeta)
call RecPrt(' In CmbnCB: Beta  ',' ',Beta,1,nZeta)
#endif
do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        ! Combine overlap integral gradients

        nVecCB = 1
        rFinal(:,ipa,ipb,nVecCB) = rKappa(:)*Rnxyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)
        if (IfGrad(1)) then
          nVecCB = nVecCB+1
          if (ixb > 0) then
            xb = real(-ixb,kind=wp)
            rFinal(:,ipa,ipb,nVecCB) = rKappa(:)*(Two*Beta(:)*Rnxyz(:,1,ixa,ixb+1)+xb*Rnxyz(:,1,ixa,ixb-1))* &
                                       Rnxyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)
          else
            rFinal(:,ipa,ipb,nVecCB) = rKappa(:)*Two*Beta(:)*Rnxyz(:,1,ixa,ixb+1)*Rnxyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)
          end if
        end if
        if (IfGrad(2)) then
          nVecCB = nVecCB+1
          if (iyb > 0) then
            yb = real(-iyb,kind=wp)
            rFinal(:,ipa,ipb,nVecCB) = rKappa(:)*Rnxyz(:,1,ixa,ixb)*(Two*Beta(:)*Rnxyz(:,2,iya,iyb+1)+yb*Rnxyz(:,2,iya,iyb-1))* &
                                       Rnxyz(:,3,iza,izb)
          else
            rFinal(:,ipa,ipb,nVecCB) = rKappa(:)*Rnxyz(:,1,ixa,ixb)*Two*Beta(:)*Rnxyz(:,2,iya,iyb+1)*Rnxyz(:,3,iza,izb)
          end if
        end if
        if (IfGrad(3)) then
          nVecCB = nVecCB+1
          if (izb > 0) then
            zb = real(-izb,kind=wp)
            rFinal(:,ipa,ipb,nVecCB) = rKappa(:)*Rnxyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)*(Two*Beta(:)* &
                                       Rnxyz(:,3,iza,izb+1)+zb*Rnxyz(:,3,iza,izb-1))
          else
            rFinal(:,ipa,ipb,nVecCB) = rKappa(:)*Rnxyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)*Two*Beta(:)*Rnxyz(:,3,iza,izb+1)
          end if
        end if

      end do
    end do
  end do
end do

return

end subroutine CmbnCB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Roland Lindh                                     *
!***********************************************************************

subroutine Set_CanInd()
!***********************************************************************
!                                                                      *
!     Object: to set up a table which resolves the canonical           *
!             angular index, ip, into ix, iy, and iz.                  *
!                                                                      *
!     Author: Roland Lindh                                             *
!             Dept of Chem. Phys.                                      *
!             Univ. of Lund, Sweden                                    *
!             February 1999                                            *
!***********************************************************************

use define_af, only: lab, iCan
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ip, ix, iy, iz, la

ip = 0
do la=0,lab-1
  do ix=la,0,-1
    do iy=la-ix,0,-1
      iz = la-ix-iy
      ip = ip+1
      iCan(1,ip) = ix
      iCan(2,ip) = iy
      iCan(3,ip) = iz
    end do
  end do
end do

end subroutine Set_CanInd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Ignacio Fdez. Galvan                             *
!***********************************************************************

module text_file

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
private

public :: extend_line, next_non_comment

contains

!=======================================================================
! Read the next non-comment line, no matter its length.
! Return .false. if the file ends.
function next_non_comment(lu,line)

logical(kind=iwp) :: next_non_comment
integer(kind=iwp), intent(in) :: lu
character(len=:), allocatable, intent(inout) :: line
integer(kind=iwp) :: stat

next_non_comment = .false.
do
  call next_line(lu,line,stat)
  if (is_iostat_end(stat)) then
    ! if file ended, return false
    exit
  else if (stat == 0) then
    ! if line is not empty or comment, return true
    ! if it is empty or comment, read another line
    line(:) = adjustl(line)
    if ((line(1:1) /= '*') .and. (line /= '')) then
      next_non_comment = .true.
      exit
    end if
  else
    ! any other error, abort
    call abend()
  end if
end do

return

end function next_non_comment

!=======================================================================
! Read the next line, no matter its length.
subroutine next_line(lu,line,stat)

integer(kind=iwp), intent(in) :: lu
character(len=:), allocatable, intent(inout) :: line
integer(kind=iwp), intent(out) :: stat
integer(kind=iwp) :: readl
character(len=128) :: buf

if (allocated(line)) call mma_deallocate(line)
do
  read(lu,'(A)',iostat=stat,advance='no',size=readl) buf
  if (is_iostat_eor(stat)) then
    ! if line ended, add the chunk and return success
    call extend_line(line,buf(:readl),chop=.true.)
    stat = 0
    exit
  else if (stat == 0) then
    ! if line didn't end, add the chunk and read next
    call extend_line(line,buf,chop=.true.)
  else
    ! any other error, return
    exit
  end if
end do

end subroutine next_line

!=======================================================================
! Concatenate two strings into a longer one
! (if chop, the last character of the first string is removed)
subroutine extend_line(dynline,line,chop)

character(len=:), allocatable, intent(inout) :: dynline
character(len=*), intent(in) :: line
logical(kind=iwp), optional, intent(in) :: chop
logical(kind=iwp) :: chop_
character(len=:), allocatable :: aux

chop_ = .false.
if (present(chop)) chop_ = chop

! adding always a space to avoid 0-length strings
if (allocated(dynline)) then
  if (chop_) then
    call mma_allocate(aux,len(dynline)+len(line),label='AuxLine')
    aux(:) = dynline(:len(dynline)-1)//line//' '
  else
    call mma_allocate(aux,len(dynline)+len(line)+1,label='AuxLine')
    aux(:) = dynline//line//' '
  end if
  call mma_deallocate(dynline)
  ! move_alloc does not work properly in all compilers
# ifdef _USE_MOVE_ALLOC_
  call move_alloc(aux,dynline)
# else
  call mma_allocate(dynline,len(aux),label='ExtLine')
  dynline(:) = aux
  call mma_deallocate(aux)
# endif
else
  call mma_allocate(dynline,len(line)+1,label='Ext2Line')
  dynline(:) = line//' '
end if

end subroutine extend_line

end module text_file

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE NSTRSO_GAS(    NEL,  NORB1,  NORB2,  NORB3, NELMN1,
     &                       NELMX1, NELMN3, NELMX3,    IOC,   NORB,
     &                       NSTASO, ISTASO, NOCTYP,  NSMST,  IOTYP,
     &                        IPRNT)
*
* Number of strings per symmetry for group IOTYP
*
* Gas version, no check of type : set to 1
*
* Jeppe Olsen Winter of 1994
*
      IMPLICIT REAL*8           ( A-H,O-Z)
C     DIMENSION IOC(*),NSTASO(NOCTYP,NSMST)
      DIMENSION IOC(*),NSTASO(NSMST,*),ISTASO(NSMST,*)
*
      CALL ISETVC(NSTASO(1,IOTYP),0,NSMST)
      NTEST0 = 0
      NTEST = MAX(IPRNT,NTEST0)
      NSTRIN = 0
      IORB1F = 1
      IORB1L = IORB1F+NORB1-1
      IORB2F = IORB1L + 1
      IORB2L = IORB2F+NORB2-1
      IORB3F = IORB2L + 1
      IORB3L = IORB3F+NORB3-1
* Loop over possible partitionings between RAS1,RAS2,RAS3
      DO 1001 IEL1 = NELMX1,NELMN1,-1
      DO 1003 IEL3 = NELMN3,NELMX3, 1
       IF(IEL1.GT. NORB1 ) GOTO 1001
       IF(IEL3.GT. NORB3 ) GOTO 1003
       IEL2 = NEL - IEL1-IEL3
       IF(IEL2 .LT. 0 .OR. IEL2 .GT. NORB2 ) GOTO 1003
       IFRST1 = 1
* Loop over RAS 1 occupancies
  901  CONTINUE
         IF( IEL1 .NE. 0 ) THEN
           IF(IFRST1.EQ.1) THEN
            CALL ISTVC2(IOC(1),0,1,IEL1)
            IFRST1 = 0
           ELSE
             CALL NXTORD(IOC,IEL1,IORB1F,IORB1L,NONEW1)
             IF(NONEW1 .EQ. 1 ) GOTO 1003
           END IF
         END IF
         IF( NTEST .GE.500) THEN
           WRITE(6,*) ' RAS 1 string '
           CALL IWRTMA(IOC,1,IEL1,1,IEL1)
         END IF
         IFRST2 = 1
         IFRST3 = 1
* Loop over RAS 2 occupancies
  902    CONTINUE
           IF( IEL2 .NE. 0 ) THEN
             IF(IFRST2.EQ.1) THEN
              CALL ISTVC2(IOC(IEL1+1),IORB2F-1,1,IEL2)
              IFRST2 = 0
             ELSE
               CALL NXTORD(IOC(IEL1+1),IEL2,IORB2F,IORB2L,NONEW2)
               IF(NONEW2 .EQ. 1 ) THEN
                 IF(IEL1 .NE. 0 ) GOTO 901
                 IF(IEL1 .EQ. 0 ) GOTO 1003
               END IF
             END IF
           END IF
           IF( NTEST .GE.500) THEN
             WRITE(6,*) ' RAS 1 2 string '
             CALL IWRTMA(IOC,1,IEL1+IEL2,1,IEL1+IEL2)
           END IF
           IFRST3 = 1
* Loop over RAS 3 occupancies
  903      CONTINUE
             IF( IEL3 .NE. 0 ) THEN
               IF(IFRST3.EQ.1) THEN
                CALL ISTVC2(IOC(IEL1+IEL2+1),IORB3F-1,1,IEL3)
                IFRST3 = 0
               ELSE
                 CALL NXTORD(IOC(IEL1+IEL2+1),
     &           IEL3,IORB3F,IORB3L,NONEW3)
                 IF(NONEW3 .EQ. 1 ) THEN
                   IF(IEL2 .NE. 0 ) GOTO 902
                   IF(IEL1 .NE. 0 ) GOTO 901
                   GOTO 1003
                 END IF
               END IF
             END IF
             IF( NTEST .GE. 500) THEN
               WRITE(6,*) ' RAS 1 2 3 string '
               CALL IWRTMA(IOC,1,NEL,1,NEL)
             END IF
* Next string has been constructed , Enlist it !.
             NSTRIN = NSTRIN + 1
*. Symmetry of string
             ISYM = ISYMST(IOC,NEL)
C                   ISYMST(STRING,NEL)
*. occupation type of string
COLD         ITYP = IOCTP2(IOC,NEL,IOTYP)
C                   IOCTP2(STRING,NEL)
*
             NSTASO(ISYM,IOTYP) = NSTASO(ISYM,IOTYP)+ 1
*
           IF( IEL3 .NE. 0 ) GOTO 903
           IF( IEL3 .EQ. 0 .AND. IEL2 .NE. 0 ) GOTO 902
           IF( IEL3 .EQ. 0 .AND. IEL2 .EQ. 0 .AND. IEL1 .NE. 0)
     &     GOTO 901
 1003 CONTINUE
 1001 CONTINUE
*
*. The corresponding offset
*
      DO ISM = 1, NSMST
        IF(ISM.EQ.1) THEN
          ISTASO(ISM,IOTYP) = 1
        ELSE
          ISTASO(ISM,IOTYP) = ISTASO(ISM-1,IOTYP)+NSTASO(ISM-1,IOTYP)
        END IF
      END DO

      IF(NTEST.GE.5)
     &WRITE(6,*) ' Number of strings generated   ', NSTRIN
      IF(NTEST .GE. 10 ) THEN
        WRITE(6,*)
        WRITE(6,*) ' Number of strings per sym for group = ', IOTYP
        WRITE(6,*) '================================================'
        CALL IWRTMA(NSTASO(1,IOTYP),1,NSMST,1,NSMST)
        WRITE(6,*) ' Offset for given symmetry for group = ', IOTYP
        WRITE(6,*) '================================================'
        CALL IWRTMA(ISTASO(1,IOTYP),1,NSMST,1,NSMST)
      END IF
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NORB)
        CALL Unused_integer(NOCTYP)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine TransNow(iV,ipS)
      Implicit Real*8 (a-h,o-z)

#include "input.fh"
#include "WrkSpc.fh"


*
*-- Be informative.
*
      If(ComStk(2,1,1,0)) then
        Write(6,*)
        Write(6,*)'    The DIPO perturbation is translated.'
      Else
        Write(6,*)
        Write(6,*)'    No translation of the perturbation',
     &    ' (only implemented for DIPO.'
        Write(6,*)'OBSERVE! Your result can be origo dependent!'
      Endif

*
*-- Translate the perturbation. Why, oh why, is the sign of Trana
*   the opposite of what it should be according to the formula?
*   Answer: Our charge is positive in the MLTPL integrals, hence
*   the field strength should be of opposite sign, see ptdipo.f
*   for example. Hence the minus in the translation formula becomes
*   a plus. Oh yeah!
*
      If((.not.ComStk(2,1,1,1)).and.(.not.ComStk(2,1,1,2)).and.
     &     (.not.ComStk(2,1,1,3))) Then
        Write(6,*)
        Write(6,*)'A strange error has occured. ComStk modified?'
        Call Abend()
      Endif
      kaunter=0
c      Write(6,*)'Trancoo',(TranCoo(i),i=1,3)
      Do 1009, i=1,nBas(1)
        Do 1008, j=1,i
          Do 1007, iXYZ=1,3
            If(ComStk(2,1,1,iXYZ)) Then
              Trana=ComVal(2,1,1,iXYZ)*TranCoo(iXYZ)*Work(ipS+kaunter)
*-----------Sign of Trana? See source code comment above.
              Work(iV+kaunter)=Work(iV+kaunter)+Trana
            EndIf
 1007     Continue
          kaunter=kaunter+1
 1008   Continue
 1009 Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine ZTRNSF_MASKED(N,UR,UI,AR,AI,IJ,IST,INUM,JST,JNUM)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, IJ(4), INUM, IST(INUM), JNUM, JST(JNUM)
real(kind=wp), intent(in) :: UR(N,N), UI(N,N)
real(kind=wp), intent(inout) :: AR(N,N), AI(N,N)
integer(kind=iwp) :: I, II, J, JJ, NI, NJ
real(kind=wp), allocatable :: MI(:,:), MR(:,:), TI(:,:), TR(:,:), VI(:,:), VR(:,:)

NI = IJ(2)-IJ(1)+1
NJ = IJ(4)-IJ(3)+1

call mma_allocate(MR,INUM,JNUM,LABEL='MR')
call mma_allocate(MI,INUM,JNUM,LABEL='MI')
do J=1,JNUM
  do I=1,INUM
    MR(I,J) = AR(IST(I),JST(J))
    MI(I,J) = AI(IST(I),JST(J))
  end do
end do

call mma_allocate(VR,JNUM,NJ,LABEL='VR')
call mma_allocate(VI,JNUM,NJ,LABEL='VI')
do J=1,NJ
  JJ = IJ(3)+J-1
  do I=1,JNUM
    VR(I,J) = UR(JST(I),JJ)
    VI(I,J) = UI(JST(I),JJ)
  end do
end do

call mma_allocate(TR,INUM,NJ,LABEL='TR')
call mma_allocate(TI,INUM,NJ,LABEL='TI')
call DGEMM_('N','N',INUM,NJ,JNUM,One,MR,INUM,VR,JNUM,Zero,TR,INUM)
call DGEMM_('N','N',INUM,NJ,JNUM,-One,MI,INUM,VI,JNUM,One,TR,INUM)
call DGEMM_('N','N',INUM,NJ,JNUM,One,MR,INUM,VI,JNUM,Zero,TI,INUM)
call DGEMM_('N','N',INUM,NJ,JNUM,One,MI,INUM,VR,JNUM,One,TI,INUM)

call mma_deallocate(VR)
call mma_deallocate(VI)
call mma_allocate(VR,INUM,NI,LABEL='VR')
call mma_allocate(VI,INUM,NI,LABEL='VI')
do J=1,NI
  JJ = IJ(1)+J-1
  do I=1,INUM
    VR(I,J) = UR(IST(I),JJ)
    VI(I,J) = UI(IST(I),JJ)
  end do
end do

call mma_deallocate(MR)
call mma_deallocate(MI)
call mma_allocate(MR,NI,NJ,LABEL='MR')
call mma_allocate(MI,NI,NJ,LABEL='MI')
call DGEMM_('T','N',NI,NJ,INUM,One,VR,INUM,TR,INUM,Zero,MR,NI)
call DGEMM_('T','N',NI,NJ,INUM,One,VI,INUM,TI,INUM,One,MR,NI)
call DGEMM_('T','N',NI,NJ,INUM,One,VR,INUM,TI,INUM,Zero,MI,NI)
call DGEMM_('T','N',NI,NJ,INUM,-One,VI,INUM,TR,INUM,One,MI,NI)

AR(:,:) = Zero
AI(:,:) = Zero
do J=1,NJ
  JJ = IJ(3)+J-1
  do I=1,NI
    II = IJ(1)+I-1
    AR(II,JJ) = MR(I,J)
    AI(II,JJ) = MI(I,J)
  end do
end do

call mma_deallocate(TR)
call mma_deallocate(TI)
call mma_deallocate(VR)
call mma_deallocate(VI)
call mma_deallocate(MR)
call mma_deallocate(MI)

return

end subroutine ZTRNSF_MASKED

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function gammln(x)
! This is a Lanczos approximation for ln(Gamma(x))
! The constants below appear in multiple sources, but few give a reason
!
! The values can be computed with the following Maxima script:
! (http://www.mrob.com/pub/ries/lanczos-gamma.html)
!=======================================================================
! load("diag");
! Dc(n) := diag(makelist(2*double_factorial(2*k-1),k,0,n));
! cmatrix_element[row,col]:=
!   if is(col>row) then 0
!   else if row=1 and col=1 then 1/2
!   else (-1)^(row+col)*4^(col-1)*(row-1)*(row+col-3)!/(row-col)!/(2*col-2)!;
! C(n) := genmatrix(cmatrix_element, n+1);
! f(g,n):=sqrt(2)*(%e/(2*(n+g)+1))^(n+1/2);
! Dr(k) := diag(append([1],makelist(-(2*n+2)!/(2*n!*(n+1)!),n,0,k-1)));
! bmatrix_element[row,col] :=
!   if row = 1 then 1
!   else if is(row > col) then 0
!   else (-1)^(col-row)*binomial(col+row-3,2*row-3);
! B(k) := genmatrix(bmatrix_element,k+1);
! lanczos_coeff(g, n) :=
!   block([M : (Dr(n) . B(n)) . (C(n) . Dc(n)),
!          f : transpose(matrix(makelist(f(g,k), k, 0, n)))],
!     (M . f));
! /* Remove bfloat for symbolic expressions */
! tlg1(g,n) := bfloat(lanczos_coeff(g,n-1)*exp(g)/sqrt(2*%pi));
!
! fpprec:100;
! fpprintprec:20;
! print(tlg1(5,7));
! quit();
!=======================================================================

use Constants, only: One, Two, Half, Pi
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: gammln
real(kind=wp), intent(in) :: x
integer(kind=iwp) :: j
real(kind=wp) :: ser, tmp, y
integer(kind=iwp), parameter :: g = 5, n = 7
real(kind=wp), parameter :: cof(0:n-1) = [1.000000000190014824_wp,76.180091729471463483_wp,-86.505320329416767652_wp, &
                                          24.01409824083091049_wp,-1.2317395724501553875_wp,1.2086509738661785061e-3_wp, &
                                          -5.3952393849531283785e-6_wp], &
                            stp = sqrt(Two*Pi)

y = x
tmp = x+real(g,kind=wp)+Half
tmp = (x+Half)*log(tmp)-tmp
ser = cof(0)
do j=1,n-1
  y = y+One
  ser = ser+cof(j)/y
end do
gammln = tmp+log(stp*ser/x)

return

end function gammln

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Per-Olof Widmark                                 *
!               1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine iWrOne(rc,Option,InLab,Comp,rData,SymLab)
!***********************************************************************
!                                                                      *
!     Purpose: write data to one-electron integral file                *
!                                                                      *
!     Calling parameters:                                              *
!     rc      : Return code                                            *
!     Option  : Switch to set options                                  *
!     InLab   : Identifier for the data to write                       *
!     Comp    : Composite identifier to select components              *
!     rData   : contains on input the data to store on disk            *
!     SymLab  : symmetry label of the provided data                    *
!                                                                      *
!     Global data declarations (Include file):                         *
!     Parm    : Table of paramaters                                    *
!     rcParm  : Table of return codes                                  *
!     Switch  : Table of options                                       *
!     Common  : Common block containing TocOne                         *
!     Data    : Data definitions                                       *
!                                                                      *
!     Local data declarations:                                         *
!     Label   : character(len=8), used to covert incoming names        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark and M.P. Fuelscher                                  *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use OneDat, only: AuxOne, LenOp, lTocOne, MxOp, NaN, nAuxDt, nBas, nSym, oAddr, oComp, oLabel, oSymLb, pNext, pOp, rcOne, sDbg, &
                  TocOne
use Definitions, only: iwp, u6, RtoI, ItoB

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp), intent(in) :: Option, Comp, SymLab
character(len=*), intent(in) :: InLab
integer(kind=iwp), intent(_IN_) :: rData(*)
integer(kind=iwp) :: i, iDisk, ij, iOpt, iRC, j, k, LabTmp(2), Length, LuOne
character(len=8) :: Label
logical(kind=iwp) :: debug, doclose
integer(kind=iwp), external :: isFreeUnit

!----------------------------------------------------------------------*
! Start procedure:                                                     *
! Pick up the file definitions                                         *
!----------------------------------------------------------------------*
rc = rcOne%good
LuOne = AuxOne%Lu
!----------------------------------------------------------------------*
! Check the file status                                                *
!----------------------------------------------------------------------*
doclose = .false.
if (.not. AuxOne%Opn) then

  ! Well, I'll open and close it for you under the default name

  LuOne = 77
  LuOne = isFreeUnit(LuOne)
  Label = 'ONEINT  '
  !write(u6,*) 'WrOne: opening OneInt'
  iRC = -1
  iOpt = 0
  call OpnOne(iRC,iOpt,Label,LuOne)
  if (iRC /= 0) then
    write(u6,*) 'WrOne: Error opening file'
    call Abend()
  end if
  doclose = .true.
end if
!----------------------------------------------------------------------*
! Truncate the label to 8 characters and convert it to upper case      *
!----------------------------------------------------------------------*
Label = InLab
call UpCase(Label)
Length = len(Label)/ItoB
LabTmp(:Length) = transfer(Label,LabTmp,Length)
!----------------------------------------------------------------------*
! Print debugging information                                          *
!----------------------------------------------------------------------*
debug = .false.
if (btest(option,sDbg)) debug = .true.
if (debug) then
  call DmpOne()
  write(u6,*) '<<< Entering WrOne >>>'
  write(u6,'(a,z8)') ' rc on entry:     ',rc
  write(u6,'(a,a)') ' Label on entry:  ',Label
  write(u6,'(a,z8)') ' Comp on entry:   ',Comp
  write(u6,'(a,z8)') ' SymLab on entry: ',SymLab
  write(u6,'(a,z8)') ' Option on entry: ',Option
end if
!----------------------------------------------------------------------*
! Store operators as individual records on disk                        *
! Note: If the incoming operator has already been stored               *
! previously (label, component and symmetry labels are identical)      *
! it will replace the existing one.                                    *
!----------------------------------------------------------------------*
k = 0
do i=MxOp,1,-1
# ifdef _I8_
  if ((TocOne(pOp+LenOp*(i-1)+oLabel) == LabTmp(1)) .and. (TocOne(pOp+LenOp*(i-1)+oComp) == Comp) .and. &
      (TocOne(pOp+LenOp*(i-1)+oSymLb) == SymLab)) k = i
# else
  if ((TocOne(pOp+LenOp*(i-1)+oLabel) == LabTmp(1)) .and. (TocOne(pOp+LenOp*(i-1)+oLabel+1) == LabTmp(2)) .and. &
      (TocOne(pOp+LenOp*(i-1)+oComp) == Comp) .and. (TocOne(pOp+LenOp*(i-1)+oSymLb) == SymLab)) k = i
# endif
end do
iDisk = TocOne(pOp+LenOp*(k-1)+oAddr)
if (k == 0) then
  do i=MxOp,1,-1
    if (TocOne(pOp+LenOp*(i-1)+oLabel) == NaN) k = i
  end do
  iDisk = TocOne(pNext)
end if
if (k == 0) then
  rc = rcOne%WR11
  write(u6,*) 'WrOne: The total number of operators exceeds the limit'
  write(u6,*) 'k == 0'
  call Abend()
end if
Length = 0
do i=1,nSym
  do j=1,i
    ij = Mul(i,j)-1
    if (btest(SymLab,ij)) then
      if (i == j) then
        Length = Length+nTri_Elem(nBas(i))
      else
        Length = Length+nBas(i)*nBas(j)
      end if
    end if
  end do
end do
Length = RtoI*(Length+nAuxDt)
TocOne(pOp+LenOp*(k-1)+oLabel) = LabTmp(1)
#ifndef _I8_
TocOne(pOp+LenOp*(k-1)+oLabel+1) = LabTmp(2)
#endif
TocOne(pOp+LenOp*(k-1)+oComp) = Comp
TocOne(pOp+LenOp*(k-1)+oSymLb) = SymLab
TocOne(pOp+LenOp*(k-1)+oAddr) = iDisk
call iDaFile(LuOne,1,rData,Length,iDisk)
TocOne(pNext) = max(TocOne(pNext),iDisk)
!----------------------------------------------------------------------*
! Finally copy the TocOne back to disk                                 *
!----------------------------------------------------------------------*
iDisk = 0
call iDaFile(LuOne,1,TocOne,lTocOne,iDisk)

if (doclose) then
  iRC = -1
  iOpt = 0
  call ClsOne(iRC,iOpt)
  if (iRC /= 0) then
    write(u6,*) 'WrOne: Error closing file'
    call Abend()
  end if
end if

!----------------------------------------------------------------------*
! Terminate procedure                                                  *
!----------------------------------------------------------------------*
return

end subroutine iWrOne

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NDSD_Ts(mGrid,Rho,nRho,nDmat,F_xc,dF_dRho,
     &                   ndF_dRho,Coeff,T_X)
************************************************************************
*                                                                      *
* Object:  compute Func for Thomas-Fermi KE functional                 *
*          compute non-TF part (rho_B dependent) of NDSD potential     *
*                                                                      *
*          (see J.-M. Garcia Lastra, J. W. Kaminski, T. A. Wesolowski, *
*                                   J. Chem. Phys.  129 (2008) 074107.)*
*                                                                      *
*          Note: for a spin-polarized rho_B (environment density), the *
*                NDSD potential is computed using the alpha+beta       *
*                density, gradient and laplacian.                      *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
      Real*8 Fexp, Vt_lim
      External Fexp, Vt_lim
      Real*8 wGradRho(2:4)
*                                                                      *
************************************************************************
*                                                                      *
*
      Two3=Two/Three
      Five3=Five/Three
      Cf=(Three/Ten)*(three*Pi**Two)**Two3
      Rho_min=T_X*1.0D-2
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute value of energy and integrand on the grid
*                                                                      *
************************************************************************
*                                                                      *
      If (nDmat.eq.1) Then
         Do iGrid = 1, mGrid
            d_sys=Two*Rho(1,iGrid)
            If (d_sys.lt.T_X) Go To 100
*
*------- Kinetic energy contributions
*
            functional = Cf*d_sys**Five3
            F_xc(iGrid)=F_xc(iGrid)+Coeff*functional
*
*------- Contributions to the potential
*
            Do k=2,4
               wGradRho(k)=Two*Rho(k,iGrid)
            End Do
            wLaplRho=Two*Rho(6,iGrid)
*
            dfunc_NDSD = Fexp(d_sys,wGradRho(2))
     &                 * Vt_lim(d_sys,wGradRho(2),wLaplRho)
            dF_dRho(1,iGrid) = dF_dRho(1,iGrid)
     &                       + Coeff*dfunc_NDSD
*
 100        Continue
*
         End Do
*
      ElseIf (nDmat.eq.2) Then

         Cf = Cf*(Two**Two3)

         Do iGrid = 1, mGrid
            da_sys =Max(Rho_Min,Rho(1,iGrid))
            db_sys =Max(Rho_Min,Rho(2,iGrid))
            DTot=da_sys+db_sys
            If (DTot.lt.T_X) Go To 200
*
*------- Kinetic energy contributions
*
            functional=Cf*(da_sys**Five3+db_sys**Five3)
            F_xc(iGrid)=F_xc(iGrid)+Coeff*functional
*
*------- Contributions to the potential
*
            Do k=2,4
               ik=k+1
               jk=ik+3
               wGradRho(k)=Rho(ik,iGrid)+Rho(jk,iGrid)
            End Do
            wLaplRho=Rho(11,iGrid)+Rho(12,iGrid)
*
            dfunc_NDSD_alpha = Fexp(DTot,wGradRho(2))
     &                       * Vt_lim(DTot,wGradRho(2),wLaplRho)
            dfunc_NDSD_beta  = dfunc_NDSD_alpha
*
            dF_dRho(1,iGrid) = dF_dRho(1,iGrid)
     &                       + Coeff*dfunc_NDSD_alpha
            dF_dRho(2,iGrid) = dF_dRho(2,iGrid)
     &                       + Coeff*dfunc_NDSD_beta
*
 200        Continue
*
         End Do

      Else
         write(6,*) 'In NDSD_Ts: invalid # of densities. nDmat=  ',nDmat
         Call Abend()
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine RPA_RdRun()

! Thomas Bondo Pedersen
!
! Read data from Runfile.

use RPA_globals, only: DFTFunctional, nBas, nDel, nFro, nOcc, nOrb, nSym, NuclearRepulsionEnergy, nVir, Reference
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iUHF, iSym, i
logical(kind=iwp) :: Warn
character(len=8) :: Model
character(len=*), parameter :: SecNam = 'RPA_RdRun'
integer(kind=iwp), external :: RPA_iUHF

! Set type of SCF reference wave function
! Note: in RPA, iUHF=1 means restricted, 2 means unrestricted.
call Get_cArray('Relax Method',Model,8)
call Get_iScalar('SCF mode',iUHF)
iUHF = iUHF+1 ! correct for convention in SCF
if (Model(1:7) == 'RHF-SCF') then
  if (iUHF == 1) then
    Reference = 'RHF'
    Warn = .false.
  else
    Reference = 'UHF'
    warn = .true.
  end if
else if (Model(1:7) == 'UHF-SCF') then
  if (iUHF == 1) then
    Reference = 'RHF'
    Warn = .true.
  else
    Reference = 'UHF'
    Warn = .false.
  end if
else if (Model(1:6) == 'KS-DFT') then
  Warn = .false.
  if (iUHF == 1) then
    Reference = 'RKS'
  else
    Reference = 'UKS'
  end if
else if ((Model(1:8) == 'dRPA@RHF') .or. (Model(1:8) == 'SOSX@RHF')) then
  if (iUHF == 1) then
    Reference = 'RHF'
    Warn = .false.
  else
    Reference = 'UHF'
    Warn = .true.
  end if
else if ((Model(1:8) == 'dRPA@UHF') .or. (Model(1:8) == 'SOSX@UHF')) then
  if (iUHF == 1) then
    Reference = 'RHF'
    Warn = .true.
  else
    Reference = 'UHF'
    Warn = .false.
  end if
else if ((Model(1:8) == 'dRPA@RKS') .or. (Model(1:8) == 'SOSX@RKS')) then
  if (iUHF == 1) then
    Reference = 'RKS'
    Warn = .false.
  else
    Reference = 'UKS'
    Warn = .true.
  end if
else if ((Model(1:8) == 'dRPA@UKS') .or. (Model(1:8) == 'SOSX@UKS')) then
  if (iUHF == 1) then
    Reference = 'RKS'
    Warn = .true.
  else
    Reference = 'UKS'
    Warn = .false.
  end if
else
  write(u6,'(A,A)') 'Reference model from Runfile: ',Model
  write(u6,'(A,I8)') 'iUHF from Runfile:            ',iUHF-1
  call RPA_Warn(2,'Illegal reference wave function in RPA')
  Reference = 'Non'
  Warn = .false.
end if
if (Warn) then
  call RPA_Warn(1,'Runfile restricted/unrestricted conflict in RPA')
  write(u6,'(A,A)') 'Reference model from Runfile: ',Model
  write(u6,'(A,I8)') 'iUHF from Runfile:            ',iUHF-1
  write(u6,'(A,A,A)') 'Assuming ',Reference,' reference!'
  call xFlush(u6)
end if

! Get nuclear potential energy
call Get_dScalar('PotNuc',NuclearRepulsionEnergy(1))

! Get DFT functional
if (Reference(2:3) == 'KS') then
  call Get_cArray('DFT functional',DFTFunctional,80)
else
  DFTFunctional = 'Hartree-Fock'
end if

! Get number of irreps
call Get_iScalar('nSym',nSym)
if ((nSym < 1) .or. (nSym > 8)) then
  call RPA_Warn(3,'nSym out of bonds in RPA')
end if

! Get iUHF (RPA convention: 1->RHF, 2->UHF)
!          (as opposed to SCF: 0->RHF, 1->UHF)
iUHF = RPA_iUHF()

! Get number of basis functions, orbitals, occupied,
! frozen (in SCF), deleted
call Get_iArray('nBas',nBas,nSym)
call Get_iArray('nOrb',nOrb,nSym)
call Get_iArray('nDel',nDel(1,1),nSym)
call Get_iArray('nFro',nFro(1,1),nSym)
call Get_iArray('nIsh',nOcc(1,1),nSym)
if (iUHF == 2) then
  ! unrestricted: read data for beta spin
  call Get_iArray('nIsh_ab',nOcc(1,2),nSym)
end if

! Check for orbitals frozen in SCF and check consistency.
do iSym=1,nSym
  if (nFro(iSym,1) /= 0) then
    write(u6,'(A,8I8)') 'nFro=',(nFro(i,1),i=1,nSym)
    call RPA_Warn(4,SecNam//': Some orbitals were frozen in SCF!')
  end if
  if (nDel(iSym,1) /= (nBas(iSym)-nOrb(iSym))) then
    write(u6,'(A,8I8)') 'nBas=     ',(nBas(i),i=1,nSym)
    write(u6,'(A,8I8)') 'nOrb=     ',(nOrb(i),i=1,nSym)
    write(u6,'(A,8I8)') 'nBas-nOrb=',((nBas(i)-nOrb(i)),i=1,nSym)
    write(u6,'(A,8I8)') 'nDel=     ',(nDel(i,1),i=1,nSym)
    call RPA_Warn(4,SecNam//': nDel != nBas-nOrb')
  end if
end do

! Set default frozen (core) orbitals
call Get_iArray('Non valence orbitals',nFro(1,1),nSym)
do iSym=1,nSym
  if (nFro(iSym,1) > nOcc(iSym,1)) then
    if (iUHF == 1) then
      write(u6,'(A,8I8)') 'nOcc=',(nOcc(i,1),i=1,nSym)
      write(u6,'(A,8I8)') 'nFro=',(nFro(i,1),i=1,nSym)
      call RPA_Warn(4,SecNam//': nFro > nOrb')
    else
      write(u6,'(A,8I8)') 'nOcc(alpha)=',(nOcc(i,1),i=1,nSym)
      write(u6,'(A,8I8)') 'nFro(alpha)=',(nFro(i,1),i=1,nSym)
      call RPA_Warn(4,SecNam//': nFro > nOrb [alpha]')
    end if
  end if
end do
if (iUHF == 2) then
  do iSym=1,nSym
    nFro(iSym,2) = nFro(iSym,1)
    if (nFro(iSym,2) > nOcc(iSym,2)) then
      write(u6,'(A,8I8)') 'nOcc(beta)=',(nOcc(i,2),i=1,nSym)
      write(u6,'(A,8I8)') 'nFro(beta)=',(nFro(i,2),i=1,nSym)
      call RPA_Warn(4,SecNam//': nFro > nOrb [beta]')
    end if
  end do
else
  do iSym=1,nSym
    nFro(iSym,2) = 0
  end do
end if

! Compute number of virtual orbitals
do i=1,iUHF
  do iSym=1,nSym
    nVir(iSym,i) = nOrb(iSym)-nOcc(iSym,i)
  end do
end do

! Set default deleted (virtual) orbitals
nDel(:,:) = 0

end subroutine RPA_RdRun

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine EX23(Y,X,I1,I2,J1,J2)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: I1, I2, J1, J2
real(kind=wp), intent(in) :: Y(I1,I2,J1,J2)
real(kind=wp), intent(out) :: X(I1,J1,I2,J2)
integer(kind=iwp) :: I, J, L

do J=1,J2
  do L=1,I2
    do I=1,J1
      X(:,I,L,J) = Y(:,L,I,J)
    end do
  end do
end do

return

end subroutine EX23

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

c
c     this file contains following routines:
c     grc34c
c     grc33c
c     grc32c
c     grc24c
c     grc23c
c     grc22c
c
c     -------------------------------------------------------
c
       subroutine cct3_grc34C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,pbar,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer pbar,possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4
       integer nhelp31,nhelp32
       integer nhelp41,nhelp42
       integer ntest1,ntest2
       integer sa1,sa2,sa3,sb1,sb2,sb3,sb4,sa12,sb12,sb123
       integer ia,ib,ic,ix
       integer possct
c
c1*
c
       if (pbar.eq.1) then
c
c     sctructure A(p,qr)*B(qr,st)=C(p,st)
c
c1.1  define limitations - q>r,s,t must be tested - ntest1
c     - q,r,s>t must be tested - ntest2
c
       if ((mapdb(0,6).eq.1).or.(mapdb(0,6).eq.4)) then
       ntest1=1
       else
       ntest1=0
       end if
c
       if ((mapdb(0,6).eq.3).or.(mapdb(0,6).eq.4)) then
       ntest2=1
       else
       ntest2=0
       end if
c
c1.0  prepare mapdc,mapic
c
       if (ntest2.eq.1) then
       nhelp1=2
       else
       nhelp1=0
       end if
c
       call cct3_grc0 (3,nhelp1,mapda(0,1),mapdb(0,3),mapdb(0,4),
     & 0,mmul(ssa,ssb),possc0,possct,mapdc,mapic)
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 130 sa1=1,nsym
c
       do 120 sa2=1,nsym
       sa12=mmul(sa1,sa2)
       sb1=sa2
c
       sa3=mmul(ssa,sa12)
       sb2=sa3
       sb12=mmul(sb1,sb2)
       if ((ntest1.eq.1).and.(sa2.lt.sa3)) then
c     Meggie out
       goto 120
       end if
c
       do 100 sb3=1,nsym
       sb123=mmul(sb12,sb3)
c
       sb4=mmul(ssb,sb123)
       if ((ntest2.eq.1).and.(sb3.lt.sb4)) then
c     Meggie out
       goto 100
       end if
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,1)
       ib=mapib(sb1,sb2,sb3)
       ic=mapic(sa1,sb3,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 100
       end if
c
c     rowA
       nhelp2=dimm(mapda(0,1),sa1)
c
c     colB
       nhelp31=dimm(mapdb(0,3),sb3)
       nhelp32=dimm(mapdb(0,4),sb4)
       if ((ntest2.eq.1).and.(sb3.eq.sb4)) then
       nhelp3=nhelp31*(nhelp31-1)/2
       else
       nhelp3=nhelp31*nhelp32
       end if
c
c     sum
       nhelp41=dimm(mapda(0,2),sa2)
       nhelp42=dimm(mapda(0,3),sa3)
       if ((ntest1.eq.1).and.(sa2.eq.sa3)) then
       nhelp4=nhelp41*(nhelp41-1)/2
       else
       nhelp4=nhelp41*nhelp42
       end if
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(ic,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=nhelp3
c
       ix=ix+1
c
 100    continue
 120    continue
 130    continue
c
       else if (pbar.eq.3) then
c
c     sctructure A(pq,r)*B(r,stu)=C(pq,stu)
c     not used
c
       end if
       ix=ix-1
c
       return
       end
c
c     -----------------------------
c
       subroutine cct3_grc33C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,pbar,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer pbar,possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4
       integer nhelp21,nhelp22,nhelp31,nhelp32
       integer nhelp41,nhelp42
       integer ntest1,ntest2
       integer sa1,sa2,sa3,sb1,sb2,sb3,sa12,sb12
       integer nsyma2
       integer ia,ib,ic,ix
       integer possct
c
c1*
c
       if (pbar.eq.1) then
c
c     sctructure A(p,qr)*B(qr,s)=C(p,s)
c
c1.0  prepare mapdc,mapic
c
       call cct3_grc0 (2,0,mapda(0,1),mapdb(0,3),0,0,mmul(ssa,ssb),
     & possc0,possct,mapdc,mapic)
c
c1.1  define limitations - p,q>r must be tested - ntest1
c
       if (mapda(0,6).eq.2) then
       ntest1=1
       else
       ntest1=0
       end if
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sa1=1,nsym
c
       do 101 sa2=1,nsym
       sa12=mmul(sa1,sa2)
       sb1=sa2
c
       sa3=mmul(ssa,sa12)
       if ((ntest1.eq.1).and.(sa2.lt.sa3)) then
c     Meggie out
       goto 101
       end if
       sb2=sa3
       sb12=mmul(sb1,sb2)
c
       sb3=mmul(ssb,sb12)
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,1)
       ib=mapib(sb1,sb2,1)
       ic=mapic(sa1,sb3,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 101
       end if
c
c     rowA
       nhelp2=dimm(mapda(0,1),sa1)
c
c     colB
       nhelp3=dimm(mapdb(0,3),sb3)
c
c     sum
       nhelp41=dimm(mapda(0,2),sa2)
       nhelp42=dimm(mapda(0,3),sa3)
       if ((ntest1.eq.1).and.(sa2.eq.sa3)) then
       nhelp4=nhelp41*(nhelp41-1)/2
       else
       nhelp4=nhelp41*nhelp42
       end if
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(ic,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=nhelp3
c
       ix=ix+1
c
 101    continue
 100    continue
c
       else if (pbar.eq.2) then
c
c     sctructure A(pq,r)*B(r,st)=C(pq,st)
c
c2.1  define limitations - A p>q,r must be tested - ntest1
c     B p,q>r must be tested - ntest2
c
       if (mapda(0,6).eq.1) then
       ntest1=1
       else
       ntest1=0
       end if
c
       if (mapdb(0,6).eq.2) then
       ntest2=1
       else
       ntest2=0
       end if
c
c2.0  prepare mapdc,mapic
c
       if ((ntest1.eq.1).and.(ntest2.eq.1)) then
       nhelp1=4
       else if (ntest1.eq.1) then
       nhelp1=1
       else if (ntest2.eq.1) then
       nhelp1=3
       else
       nhelp1=0
       end if
c
       call cct3_grc0 (4,nhelp1,mapda(0,1),mapda(0,2),mapdb(0,2),
     & mapdb(0,3),mmul(ssa,ssb),possc0,possct,mapdc,mapic)
c
c2.2  def symm states and test the limitations
c
       ix=1
       do 240 sa1=1,nsym
       if (ntest1.eq.1) then
       nsyma2=sa1
       else
       nsyma2=nsym
       end if
c
       do 230 sa2=1,nsyma2
       sa12=mmul(sa1,sa2)
c
       sa3=mmul(ssa,sa12)
       sb1=sa3
c
       do 220 sb2=1,nsym
       sb12=mmul(sb1,sb2)
c
       sb3=mmul(ssb,sb12)
       if ((ntest2.eq.1).and.(sb2.lt.sb3)) then
c     Meggie out
       goto 220
       end if
c
c2.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,sa3)
       ib=mapib(sb1,sb2,sb3)
       ic=mapic(sa1,sa2,sb2)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 220
       end if
c
c     rowA
       nhelp21=dimm(mapda(0,1),sa1)
       nhelp22=dimm(mapda(0,2),sa2)
       if ((ntest1.eq.1).and.(sa1.eq.sa2)) then
       nhelp2=nhelp21*(nhelp21-1)/2
       else
       nhelp2=nhelp21*nhelp22
       end if
c
c     colB
       nhelp31=dimm(mapdb(0,2),sb2)
       nhelp32=dimm(mapdb(0,3),sb3)
       if ((ntest2.eq.1).and.(sb2.eq.sb3)) then
       nhelp3=nhelp31*(nhelp31-1)/2
       else
       nhelp3=nhelp31*nhelp32
       end if
c
c     sum
       nhelp4=dimm(mapda(0,3),sa3)
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(ic,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=nhelp3
c
       ix=ix+1
c
 220    continue
 230    continue
 240    continue
c
c
       end if
       ix=ix-1
c
       return
       end
c
c     -----------------------------
c
       subroutine cct3_grc32C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,pbar,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer pbar,possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4
       integer nhelp21,nhelp22
       integer ntest1
       integer sa1,sa2,sa3,sb1,sb2,sa12
       integer nsyma2
       integer ia,ib,ic,ix
       integer possct
c
c1*
c
       if (pbar.eq.1) then
c
c     sctructure A(p,qr)*B(qr)=y(p)
c     implemented in grc32y
c
       else if (pbar.eq.2) then
c
c     sctructure A(pq,r)*B(r,s)=C(pq,s)
c
c1.0  prepare mapdc,mapic
c
       call cct3_grc0 (3,mapda(0,6),mapda(0,1),mapda(0,2),mapdb(0,2),0,
     &            mmul(ssa,ssb),
     & possc0,possct,mapdc,mapic)
c
c1.1  define limitations - p>q,r must be tested - ntest1
c
       if (mapda(0,6).eq.1) then
       ntest1=1
       else
       ntest1=0
       end if
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 130 sa1=1,nsym
       if (ntest1.eq.1) then
       nsyma2=sa1
       else
       nsyma2=nsym
       end if
c
       do 120 sa2=1,nsyma2
       sa12=mmul(sa1,sa2)
c
       sa3=mmul(ssa,sa12)
       sb1=sa3
c
       sb2=mmul(ssb,sb1)
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,1)
       ib=mapib(sb1,1,1)
       ic=mapic(sa1,sa2,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 120
       end if
c
c     rowA
       nhelp21=dimm(mapda(0,1),sa1)
       nhelp22=dimm(mapda(0,2),sa2)
       if ((ntest1.eq.1).and.(sa1.eq.sa2)) then
       nhelp2=nhelp21*(nhelp21-1)/2
       else
       nhelp2=nhelp21*nhelp22
       end if
c
c     colB
       nhelp3=dimm(mapdb(0,2),sb2)
c
c     sum
       nhelp4=dimm(mapda(0,3),sa3)
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(ic,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=nhelp3
c
       ix=ix+1
c
 120    continue
 130    continue
c
c
       end if
       ix=ix-1
c
       return
       end
c
c     -----------------------------
c
       subroutine cct3_grc24C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,pbar,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer pbar,possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4
       integer nhelp31,nhelp32,nhelp33
       integer ntest1,ntest2
       integer sa1,sa2,sb1,sb2,sb3,sb4,sb12,sb123
       integer nsymb3
       integer ia,ib,ic,ix
       integer possct
c
c1*
c
       if (pbar.eq.1) then
c
c     sctructure A(p,q)*B(q,rst)=C(p,rst)
c
c1.0  prepare mapdc,mapic
c
       call cct3_grc0 (4,mapdb(0,6),mapda(0,1),mapdb(0,2),mapdb(0,3),
     & mapdb(0,4),mmul(ssa,ssb),possc0,possct,mapdc,mapic)
c
c1.1  define limitations - q,r>s,t must be tested - ntest1
c     - q,r,s>t must be tested - ntest2
c
       if (mapdb(0,6).eq.2) then
       ntest1=1
       else
       ntest1=0
       end if
c
       if (mapdb(0,6).eq.3) then
       ntest2=1
       else
       ntest2=0
       end if
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sa1=1,nsym
c
       sa2=mmul(ssa,sa1)
       sb1=sa2
c
       do 101 sb2=1,nsym
       sb12=mmul(sb1,sb2)
       if (ntest1.eq.1) then
       nsymb3=sb2
       else
       nsymb3=nsym
       end if
c
       do 102 sb3=1,nsymb3
       sb123=mmul(sb12,sb3)
c
       sb4=mmul(ssb,sb123)
       if ((ntest2.eq.1).and.(sb3.lt.sb4)) then
c     Meggie out
       goto 102
       end if
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,1,1)
       ib=mapib(sb1,sb2,sb3)
       ic=mapic(sa1,sb2,sb3)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 102
       end if
c
c     rowA
       nhelp2=dimm(mapda(0,1),sa1)
c
c     colB
       nhelp31=dimm(mapdb(0,2),sb2)
       nhelp32=dimm(mapdb(0,3),sb3)
       nhelp33=dimm(mapdb(0,4),sb4)
       if ((ntest1.eq.1).and.(sb2.eq.sb3)) then
       nhelp3=nhelp31*(nhelp31-1)*nhelp33/2
       else if ((ntest2.eq.1).and.(sb3.eq.sb4)) then
       nhelp3=nhelp31*nhelp32*(nhelp32-1)/2
       else
       nhelp3=nhelp31*nhelp32*nhelp33
       end if
c
c     sum
       nhelp4=dimm(mapda(0,2),sa2)
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(ic,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=nhelp3
c
       ix=ix+1
c
 102    continue
 101    continue
 100    continue
c
c
       end if
       ix=ix-1
c
       return
       end
c
c     -----------------------------
c
       subroutine cct3_grc23C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,pbar,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer pbar,possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4
       integer nhelp31,nhelp32
       integer ntest1
       integer sa1,sa2,sb1,sb2,sb3,sb12
       integer ia,ib,ic,ix
       integer possct
c
c1*
c
       if (pbar.eq.1) then
c
c     sctructure A(p,q)*B(q,rs)=C(p,rs)
c
c1.0  prepare mapdc,mapic
c
       call cct3_grc0 (3,mapdb(0,6),mapda(0,1),mapdb(0,2),mapdb(0,3),0,
     &            mmul(ssa,ssb),
     & possc0,possct,mapdc,mapic)
c
c1.1  define limitations - q,r>s must be tested - ntest1
c
       if (mapdb(0,6).eq.2) then
       ntest1=1
       else
       ntest1=0
       end if
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sa1=1,nsym
c
       sa2=mmul(ssa,sa1)
       sb1=sa2
c
       do 101 sb2=1,nsym
       sb12=mmul(sb1,sb2)
c
       sb3=mmul(ssb,sb12)
       if ((ntest1.eq.1).and.(sb2.lt.sb3)) then
c     Meggie out
       goto 101
       end if
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,1,1)
       ib=mapib(sb1,sb2,1)
       ic=mapic(sa1,sb2,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 101
       end if
c
c     rowA
       nhelp2=dimm(mapda(0,1),sa1)
c
c     colB
       nhelp31=dimm(mapdb(0,2),sb2)
       nhelp32=dimm(mapdb(0,3),sb3)
       if ((ntest1.eq.1).and.(sb2.eq.sb3)) then
       nhelp3=nhelp31*(nhelp31-1)/2
       else
       nhelp3=nhelp31*nhelp32
       end if
c
c     sum
       nhelp4=dimm(mapda(0,2),sa2)
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(ic,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=nhelp3
c
       ix=ix+1
c
 101    continue
 100    continue
c
c
       end if
       ix=ix-1
c
       return
       end
c
c     -----------------------------
c
       subroutine cct3_grc22C (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,pbar,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer pbar,possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4
       integer sa1,sa2,sb1,sb2
       integer ia,ib,ic,ix
       integer possct
c
c1*
c
       if (pbar.eq.1) then
c
c     sctructure A(p,q)*B(q,r)=C(p,r)
c
c1.0  prepare mapdc,mapic
c
       call cct3_grc0 (2,0,mapda(0,1),mapdb(0,2),0,0,mmul(ssa,ssb),
     & possc0,possct,mapdc,mapic)
c
c1.1  define limitations - no limitations
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sa1=1,nsym
c
       sa2=mmul(ssa,sa1)
       sb1=sa2
c
       sb2=mmul(ssb,sb1)
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,1,1)
       ib=mapib(sb1,1,1)
       ic=mapic(sa1,1,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 100
       end if
c
c     rowA
       nhelp2=dimm(mapda(0,1),sa1)
c
c     colB
       nhelp3=dimm(mapdb(0,2),sb2)
c
c     sum
       nhelp4=dimm(mapda(0,2),sa2)
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(ic,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=nhelp3
c
       ix=ix+1
c
 100    continue
c
c
       end if
       ix=ix-1
c
       return
       end
c
c     -----------------------------
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Extract(iLu,i9,Etot,xyzMy,Hmat,C,nMatBas,xyzQuQ,ExpVal,ExpCento,ENR,ENP)

use qmstat_global, only: iExtr_Eig, lExtr, QmType
use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iLu, i9, nMatBas
real(kind=wp), intent(in) :: Etot, xyzMY(3), Hmat(nTri_Elem(iExtr_Eig)), C(nMatBas,nMatBas), xyzQuQ(6), ExpVal(4,*), &
                             ExpCento(4,*), ENR, ENP

! Just pass on the numbers according to QM-method.

if (QmType(1:4) == 'RASS') then
  call ExtractR(iLu,i9,Etot,xyzMy,Hmat,C,nMatBas,xyzQuQ,lExtr,iExtr_Eig,ExpVal,ExpCento,ENR,ENP)
else if (QmType(1:3) == 'SCF') then
  call ExtractS(iLu,i9,Etot,xyzMy,xyzQuQ,lExtr,ExpVal,ExpCento,ENR,ENP)
end if

return

end subroutine Extract

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine ClsFls_RASSCF
************************************************************************
*                                                                      *
*     Close files.                                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
#ifdef _HDF5_
      use mh5, only: mh5_close_file
#endif
      Implicit Real*8 (A-H,O-Z)
      Logical DoCholesky
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"

#include "qnctl.fh"
#include "raswfn.fh"
*----------------------------------------------------------------------*
*     Start                                                            *
*-------------------------------------- -------------------------------*
C Local print level (if any)
*---  close the JOBOLD file -------------------------------------------*
      If(JOBOLD.gt.0.and.JOBOLD.ne.JOBIPH) Then
        Call DaClos(JOBOLD)
        JOBOLD=-1
      Else If (JOBOLD.gt.0) Then
        JOBOLD=-1
      End If
*---  close the JOBIPH file -------------------------------------------*
      If(JOBIPH.gt.0) Then
        Call DaClos(JOBIPH)
        JOBIPH=-1
      End If
#ifdef _HDF5_
      if (wfn_fileid.ne.0) then
        call mh5_close_file(wfn_fileid)
        wfn_fileid=0
      end if
#endif
*---  close the ORDINT file -------------------------------------------*
      CALL DecideOnCholesky(DoCholesky)
       If (.not.DoCholesky) then
         iRc=-1
         iOpt=0
         Call ClsOrd(iRc,iOpt)
         If ( iRc.ne.0 ) Then
           Call WarningMessage(1,'Failed to close the ORDINT file.')
         End If
       End If
*---  close the file carrying the transformed two-electron integrals --*
      Call DaClos(LUINTM)
*---  close the DAVID file carrying temporary CI and sigma vectros ----*
      Call DaClos(LUDAVID)
*---  open the file carrying the hessian update vectors ---------------*
      Call DaClos(LuQune)
*---  close the file for storage of informations on CI-iterations
      Close(ITERFILE)
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE IFOCK(FC,NI,NJ,NK,FINI,II)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FC(*)
      IF(NI.GT.0)RETURN
      IF(NJ.LE.0.OR.NK.LE.0)RETURN
      JKPOS=NJ*(NJ-1)/2+NK
      IF(NK.GT.NJ)JKPOS=NK*(NK-1)/2+NJ
      IF(II.EQ.0)GO TO 10
      FC(JKPOS)=FC(JKPOS)+FINI+FINI
      RETURN
10    FC(JKPOS)=FC(JKPOS)-FINI
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pack321(ap,am,b,dimp,dimq,dimr,rc)
! this routine does: B(p,q,r) = A+(p,q,r) - A-(p,r,q) for symq>symr

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dimr
real(kind=wp), intent(in) :: ap(dimp,dimq,dimr), am(dimp,dimr,dimq)
real(kind=wp), intent(out) :: b(dimp,dimq,dimr)
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: r

rc = 0
do r=1,dimr
  b(:,:,r) = ap(:,:,r)-am(:,r,:)
end do

return

end subroutine pack321

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine istkpush_cvb(iarr,ival)
      implicit real*8(a-h,o-z)
      dimension iarr(*)

      iarr(2)=iarr(2)+1
      if(iarr(2).gt.iarr(1))then
        write(6,*)' Stack dimension too small :',iarr(1)
        write(6,*)' Tried push of :',ival
        call abend_cvb()
      endif
      iarr(iarr(2))=ival
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NoverP(n,i,x)
      Implicit Real*8 (a-h,o-z)

      rn=1.0D0
      rp=1.0D0
      If((i.eq.0).or.(i.eq.n)) Then
         x=1
      Else
         Do j=1,i
            rn=rn*(n-j+1)
            rp=rp*j
         EndDo
         x=rn/rp
      EndIf
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Roland Lindh                                     *
!***********************************************************************

subroutine Update_inner(kIter,Beta,Beta_Disp,Step_Trunc,nWndw,mIter,Kriging_Hessian,qBeta,iOpt_RS,First_MicroIteration,Iter, &
                        qBeta_Disp,Hide)
!***********************************************************************
!     Object: to update coordinates                                    *
!                                                                      *
!    Input:                                                            *
!      kIter          : iteration counter                              *
!      Beta           : damping factor step length                     *
!      Beta_Disp      : damping factor variance                        *
!                                                                      *
!    OutPut:                                                           *
!      Step_Trunc     : character label to denote truncation type      *
!                                                                      *
!                                                                      *
!     Author: Roland Lindh                                             *
!             2000                                                     *
!***********************************************************************

use Slapaf_Info, only: BMx, Curvilinear, Degen, dqInt, Energy, FindTS, GNrm, GNrm_Threshold, GrdMax, HrmFrq_Show, iInt, iNeg, &
                       iOptC, iOptH, iRow_c, Lambda, Lbl, Mode, nBVec, nDimBC, nFix, nLambda, nStab, qInt, Shift, Smmtrc, StpMax, &
                       TSConstraints
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Five, Ten, Half
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: kIter, nWndw, mIter, iOpt_RS, Iter
real(kind=wp), intent(inout) :: Beta
real(kind=wp), intent(in) :: Beta_Disp, qBeta_Disp
character, intent(out) :: Step_Trunc
logical(kind=iwp), intent(in) :: Kriging_Hessian, First_MicroIteration, Hide
real(kind=wp), intent(out) :: qBeta
integer(kind=iwp) :: i, iAd, iAtom, iDo_DipM, iDum(1), iEnd, iIter, iLambda, iOptH_, ix, ixyz, j, jAtom, jPrint, jx, jxyz, k, &
                     kStart, lIter, LudRdx, M, Mode_Save, N, n1, nA, nLoop, nQQ, NRHS, nRP, nsAtom
real(kind=wp) :: Disp(1), dxdx, dxdx_last, fact, fCart, gBeta, gg, gg_last, rCart, rInter, Sf, tBeta, Thr, Thr_RS, xBeta
logical(kind=iwp) :: Found, lWrite
character(len=8) :: File1, File2
character :: Step_Trunc_
integer(kind=iwp), allocatable :: iFlip(:), Indx(:)
real(kind=wp), allocatable :: AMat(:), BM(:,:), BVec(:,:), CInt(:), CInt0(:), d2L(:,:,:), dBM(:,:,:), dBVec(:), dEdq(:,:), &
                              dEdx(:,:), dRdq(:,:,:), du(:), dx(:,:), dy(:), EMtrx(:,:), Energy_L(:), ErrVec(:,:), Hessian(:,:), &
                              Mult(:), R(:,:), RHS(:), Scr1(:), Scr2(:), T(:,:), Tmp(:), Val(:), Value0(:), Wess(:,:), x(:,:)
character(len=8), allocatable :: Lbl_Tmp(:)
real(kind=wp), external :: DDot_
!                                                                      *
!***********************************************************************
!                                                                      *
! This option should be more carefully debugged.
!                                              RL December 2020
#define _NEW_CODE_
#ifdef _NEW_CODE_
real(kind=wp), allocatable :: QC(:,:,:)
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
nQQ = size(qInt,1)
nsAtom = size(Degen,2)
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'Update_inner:iOpt_RS,Beta,Beta_Disp=',iOpt_RS,Beta,Beta_Disp
call RecPrt('Update_inner: qInt',' ',qInt,nQQ,kIter)
call RecPrt('Update_inner: Shift',' ',Shift,nQQ,kIter-1)
call RecPrt('Update_inner: GNrm',' ',GNrm,kIter,1)
call RecPrt('Update_inner: Energy',' ',Energy,kIter,1)
n1 = 3*nsAtom
call RecPrt('Update_inner: dQ/dx(BMx)',' ',BMx,n1,nQQ)
#endif

GrdMax = Zero
StpMax = Zero

Step_Trunc = 'N'
nA = (max(nQQ,kIter)+1)**2
call mma_Allocate(AMat,nA,Label='AMat')
call mma_Allocate(Indx,kIter,Label='Indx')
call mma_Allocate(ErrVec,nQQ,(kIter+1),Label='ErrVec')
call mma_Allocate(EMtrx,kIter+1,kIter+1,Label='EMtrx')
call mma_Allocate(RHS,kIter+1)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Pick up the Hessian in internal coordinates and then update it
! according to some Hessian update method (BFGS, MSP, etc.)

if (Kriging_Hessian) then
  iOptH_ = ibset(0,3)
else
  iOptH_ = iOptH
end if
call mma_Allocate(Hessian,nQQ,nQQ,Label='Hessian')
call Get_dArray('Hss_Q',Hessian,nQQ**2)

! Perform the Hessian update, in case of GEK it essentially will
! modify the Hessian if it is needed to guide 2nd order
! optimization towards a minimum or a TS.

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*)
write(u6,*) ' *** Updating the molecular Hessian ***'
write(u6,*)
jPrint = 99
#else
jPrint = 5
#endif
call Update_H(nWndw,Hessian,nQQ,mIter,iOptC,Shift(:,kIter-mIter+1),dqInt(:,kIter-mIter+1),iOptH_,jPrint,GNrm(kIter),nsAtom,.true., &
              First_MicroIteration)

!call RecPrt('Update_inner: Hessian',' ',Hessian,nQQ,nQQ)
!write(u6,*) 'After corrections'
!call DiagMtrx(Hessian,nQQ,jNeg)

! Save the number of internal coordinates on the runfile.

call Put_iScalar('No of Internal coordinates',nQQ)

! Save the force constant matrix on the runfile.

call Put_dArray('Hess',Hessian,nQQ**2)

! Optional frequency analysis

if (HrmFrq_Show) call GF_on_the_fly(iDo_DipM)

!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! If this is a constrained optimization with the goal of finding a
! transition state and we have one negative eigenvalue of the
! Hessian then shift over to Mode Following RF to find the TS.

! If TSConstraints were given, merge them with global constraints if
! they exist, unless we are in TS regime.
! If TS constraints were not given, remove global constraints when in
! TS regime.

call qpg_darray('TanVec',Found,nRP)
if (FindTS .and. First_MicroIteration) then
  File1 = 'UDC'
  File2 = 'TSC'
  if (.not. TSConstraints) File2 = ''
  if (iNeg(1) >= 1) then
    if ((GNrm(kIter) <= GNrm_Threshold) .or. Found) then
      ! Change to MFRF optimization.
      iOptC = ibclr(iOptC,7)
      iOptC = ibclr(iOptC,12)
      call Put_lScalar('TS Search',.true.)
      if (TSConstraints) then
        File2 = ''
      else
        File1 = ''
      end if
    end if
  end if
  call Merge_Constraints(File1,File2,'UDC',nLambda,iRow_c)
  call Fix_UDC(iRow_c,nLambda,nsAtom,nStab,.false.)
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (nLambda == 0) then
  M = 3*nsAtom
  N = nQQ
  NRHS = 1
  call mma_Allocate(Tmp,M,Label='Tmp:M')

  ! Iterate to avoid too large displacement in cartesians.
  ! If the maximum displacement is more than 2*Beta, reduce the step.

  ! Initial setup to ensure fCart=1.0 at first iteration.
  rInter = Beta
  fCart = Ten
  rCart = fCart*rInter
  nLoop = 0
  do while (rCart >= Two*Beta)
    nLoop = nLoop+1
    if (nLoop > 10) exit
    if (rCart > rInter) then
      fCart = fCart*rInter/rCart
    else
      fCart = fCart*0.9_wp
    end if
    nA = (max(nQQ,kIter)+1)**2
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    gBeta = One
    xBeta = One
    gg_last = Beta
    dxdx_last = Beta
    Sf = sqrt(Two)
    if (iOpt_RS == 0) then
      kStart = max(1,kIter-4)
      iEnd = kIter
    else
      kStart = max(1,Iter-4)
      iEnd = Iter
    end if
    Thr = 1.0e-6_wp
    do iIter=kStart,iEnd

      if (iIter /= kIter) then
        dxdx = sqrt(DDot_(nQQ,Shift(:,iIter),1,Shift(:,iIter),1))

        if ((dxdx < 0.75_wp*dxdx_last) .and. (dxdx < Beta-Thr)) then
          ! Increase trust radius
          !xBeta = xBeta*Sf
          xBeta = min(Two,xBeta*Sf)
        else if ((dxdx > 1.25_wp*dxdx_last) .or. (dxdx >= Beta+Thr)) then
          ! Reduce trust radius
          xBeta = max(One/Five,xBeta/Sf)
        end if
        dxdx_last = dxdx
      end if

      gg = sqrt(DDot_(nQQ-nLambda,dqInt(:,iIter),1,dqInt(:,iIter),1))
      if ((gg < 0.75_wp*gg_last) .and. (gg < Beta-Thr)) then
        ! Increase trust radius
        !gBeta = gBeta*Sf
        gBeta = min(Two,gBeta*Sf)
      else if ((gg > 1.25_wp*gg_last) .or. (gg >= Beta+Thr)) then
        ! Reduce trust radius
        gBeta = max(One/Five,gBeta/Sf)
      end if
      gg_last = gg

    end do
    tBeta = max(Beta*min(xBeta,gBeta),Beta/Ten)
    !write(u6,*) 'tBeta=',tBeta
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Compute updated geometry in Internal coordinates

    fact = One
    qBeta = fCart*tBeta
    Thr_RS = 1.0e-7_wp
    do
      Step_Trunc_ = Step_Trunc
      call Newq(qInt,nQQ,kIter,Shift,Hessian,dqInt,ErrVec,EMtrx,RHS,AMat,nA,qBeta,nFix,Indx,Energy,Step_Trunc_,Thr_RS)
      if (Step_Trunc == 'N') Step_Trunc = ' '
      if (iOpt_RS == 0) then
        if (Step_Trunc_ == 'N') Step_Trunc_ = ' '
        Step_Trunc = Step_Trunc_
        exit
      end if
      if (Step_Trunc//Step_Trunc_ == ' *') Step_Trunc = '.'

      qInt(:,kIter+1) = qInt(:,kIter)+Shift(:,kIter)
      call Dispersion_Kriging_Layer(qInt(:,kIter+1),Disp,nQQ)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Disp,Beta_Disp=',Disp(1),Beta_Disp
#     endif
      fact = Half*fact
      qBeta = Half*qBeta
      if (One-disp(1)/Beta_Disp > 1.0e-3_wp) exit
      if ((fact < 1.0e-5_wp) .or. (disp(1) < Beta_Disp)) exit
      Step_Trunc = '*'
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Step_Trunc=',Step_Trunc
#   endif

    call MxLbls(nQQ,dqInt(:,kIter),Shift(:,kIter),Lbl)

    ! Set shift vector to zero for frozen internal coordinates.

    if (nFix > 0) Shift(iInt+1:iInt+nFix,kIter) = Zero

    ! Rough conversion to Cartesians

    call Eq_Solver('T',M,N,NRHS,BMx,Curvilinear,Degen,Shift(:,kIter),Tmp)
    rInter = sqrt(dDot_(N,Shift(:,kIter),1,Shift(:,kIter),1))
    rCart = Zero
    do i=1,nsAtom
      rCart = max(rCart,sqrt(dDot_(3,Tmp(i),nsAtom,Tmp(i),nsAtom)))
    end do
  end do
  call mma_deallocate(Tmp)
  call Put_dScalar('Max error',Zero)
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Optimization with constraints using Lagrangian technique.

  ! Allocate memory for the new arrays

  call mma_allocate(R,nLambda,kIter,Label='R')
  call mma_allocate(dRdq,nQQ,nLambda,kIter,Label='dRdq')
  dRdq(:,:,:) = Zero
  call mma_allocate(T,nQQ,nQQ,Label='T')
  T(:,:) = Zero
  call mma_allocate(dy,nLambda,Label='dy')
  call mma_allocate(dx,(nQQ-nLambda),kIter,Label='dx')
  dx(:,:) = Zero
  call mma_allocate(dEdq,nQQ,kIter,Label='dEdQ')
  call mma_allocate(du,nQQ,Label='du')
  call mma_allocate(X,(nQQ-nLambda),(kIter+1),Label='X')
  X(:,:) = Zero
  call mma_allocate(dEdx,nQQ-nLambda,kIter,Label='dEdx')
  call mma_allocate(Wess,nQQ-nLambda,nQQ-nLambda,Label='Wess')
  Wess(:,:) = Zero
  call mma_allocate(Energy_L,kIter,Label='Energy_L')

  Energy_L(:) = Energy(1:kIter)

  if (nQQ+nLambda > size(Lbl)) then
    call mma_allocate(Lbl_tmp,nQQ+nLambda,Label='Lbl_tmp')
    Lbl_tmp(:) = ''
    Lbl_tmp(1:size(Lbl)) = Lbl(:)
    call mma_deallocate(Lbl)
    call mma_allocate(Lbl,nQQ+nLambda,Label='Lbl')
    Lbl(:) = Lbl_tmp(:)
    call mma_deallocate(Lbl_tmp)
  end if

  nBVec = iRow_c-nLambda-1

  n1 = 3*nsAtom
  call mma_allocate(BM,n1,nLambda,Label='BM')
  call mma_allocate(dBM,n1,n1,nLambda,Label='dBM')

  call mma_allocate(BVec,3*nsAtom,nBVec,Label='BVec')
  call mma_allocate(Val,nBVec,Label='Val')
  call mma_allocate(Value0,nBVec,Label='Value0')
  call mma_allocate(CInt,nLambda,Label='CInt')
  call mma_allocate(CInt0,nLambda,Label='CInt0')
  call mma_allocate(Mult,nBVec**2,Label='Mult')
  call mma_allocate(iFlip,nBVec,Label='iFlip')
  call mma_allocate(dBVec,nBVec*(3*nsAtom)**2,Label='dBVec')
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute the constraints
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do lIter=1,kIter
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    lWrite = (lIter == kIter) .and. First_MicroIteration
    lWrite = lWrite .and. (.not. Hide)
    call DefInt2(BVec,dBVec,nBVec,BM,nLambda,nsAtom,iRow_c,Val,cInt,cInt0,Lbl(nQQ+1),lWrite,Mult,dBM,Value0,lIter,iFlip)

    ! Assemble r

    R(:,lIter) = cInt(:)-cInt0(:)

    ! Assemble dC/dQ: Solve  B dC/dQ = dC/dx

    ! where B = dQ/dx

    dRdq(:,:,lIter) = Zero
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Update_inner: lIter=',lIter
    call RecPrt('Update_inner: dQ/dx(BMx)',' ',BMx,n1,nQQ)
    call RecPrt('Update_inner: dC/dx(BM)',' ',BM,n1,nLambda)
#   endif

    M = n1
    N = nQQ
    NRHS = nLambda

    ! Temporary fix of the dC/dx vector which always
    ! is propted up with the full degeneracy factor.

    if (.not. Curvilinear) then
      do iLambda=1,nLambda
        do i=1,n1
          iAtom = (i+2)/3
          ixyz = i-(iAtom-1)*3
          BM(i,iLambda) = BM(i,iLambda)/Degen(ixyz,iAtom)
        end do
      end do
    end if
    if (lIter == kIter) then
      LudRdX = 30
      call DaName(LudRdX,'dRdX')
      iAd = 0
      iDum(1) = nLambda
      call iDaFile(LudRdX,1,iDum,1,iAd)
      iDum(1) = n1
      call iDaFile(LudRdX,1,iDum,1,iAd)
      call dDaFile(LudRdX,1,BM,nLambda*n1,iAd)
      call DaClos(LudRdX)
    end if
    call Eq_Solver('N',M,N,NRHS,BMx,Curvilinear,Degen,BM,dRdq(:,:,lIter))
#   ifdef _DEBUGPRINT_
    call RecPrt('Update_inner: dRdq(:,:,lIter)',' ',dRdq(:,:,lIter),nQQ,nLambda)
#   endif
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end do     ! lIter
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call mma_deallocate(dBVec)
  call mma_deallocate(iFlip)
  call mma_deallocate(Mult)
  call mma_deallocate(cInt0)
  call mma_deallocate(cInt)
  call mma_deallocate(Value0)
  call mma_deallocate(Val)
  call mma_deallocate(BVec)

# ifdef _DEBUGPRINT_
  call RecPrt('Update_inner: R',' ',R,nLambda,kIter)
  call RecPrt('Update_inner: dRdq',' ',dRdq,nQQ*nLambda,kIter)
  do i=1,nLambda
    write(u6,*) ' iLambda=',i
    call RecPrt('Update_inner: d2C/dx2',' ',dBM(:,:,i),n1,n1)
  end do
  if (Curvilinear) call dBPrint(nQQ,nDimBC)
# endif
  call mma_deallocate(BM)
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Assemble d^2C/dQ^2
  !
  !  The expression is written as
  !
  !  dQ/dx * d^2C/dQ^2 * (dQ/dx)^T = d^2C/dx^2 - Sum (d^2Q/dx^2 * dC/dQ)
  !
  !  Dimensions
  !  dQ/dx     :  3*nsAtom x nQQ
  !  d^2C/dx^2 :  3*nsatom x 3*nsatom
  !  d^2C/dQ^2 :  nQQ   x nQQ

# ifdef _NEW_CODE_
  ! Compute Sum (d^2Q/dx^2 * dC/dQ)

  call mma_allocate(QC,nDimBC,nDimBC,nLambda,Label='QC')
  QC(:,:,:) = Zero
  if (Curvilinear) call dBMult(dRdq(:,:,kIter),QC,nQQ,nDimBC,nLambda)
# ifdef _DEBUGPRINT_
  write(u6,*) 'Update_inner: kIter=',kIter
  call RecPrt('dRdq(:,1,kIter)',' ',dRdq(:,1,kIter),nQQ,1)
  do iLambda=1,nLambda
    write(u6,*) 'Update_inner: iLambda=',iLambda
    call RecPrt('Update_inner: QC',' ',QC(:,:,iLambda),nDimBC,nDimBC)
  end do
# endif

  ! Subtract the term from d^2C/dx^2

  do k=1,nLambda
    j = 0
    do jx=1,n1
      jAtom = (jx+2)/3
      jxyz = jx-(jAtom-1)*3
      if (Smmtrc(jxyz,jAtom)) then
        j = j+1

        i = 0
        do ix=1,n1
          iAtom = (ix+2)/3
          ixyz = ix-(iAtom-1)*3
          if (Smmtrc(ixyz,iAtom)) then
            i = i+1
            dBM(ix,jx,k) = dBM(ix,jx,k)-QC(i,j,k)
          end if
        end do
      end if
    end do
  end do
  call mma_deallocate(QC)
# endif

  call mma_allocate(Scr2,nQQ*n1*nLambda,Label='Scr2')
  call mma_allocate(Scr1,nQQ*n1*nLambda,Label='Scr1')
# ifdef _DEBUGPRINT_
  call RecPrt('Update_inner: d^2C/dx^2(dBM)',' ',dBM,n1**2,nLambda)
# endif

  ! Temporary fix of the d^2C/dx^2 vector which always
  ! is propted up with the full degeneracy factor.

  if (.not. Curvilinear) then
    do k=1,nLambda
      do j=1,n1
        jAtom = (j+2)/3
        jxyz = j-(jAtom-1)*3
        do i=1,n1
          iAtom = (i+2)/3
          ixyz = i-(iAtom-1)*3
          dBM(i,j,k) = dBM(i,j,k)/(Degen(ixyz,iAtom)*Degen(jxyz,jAtom))
        end do
      end do
    end do
  end if
# ifdef _DEBUGPRINT_
  call RecPrt('Update_inner: d^2C/dx^2(dBM)',' ',dBM,n1**2,nLambda)
# endif

  ! Solve first for y in
  !         dQ/dx y = d^2C/dx^2 - Sum (d^2Q/dx^2 * dC/dQ)
  !
  ! where y   = d^2C/dQ^2 * (dQ/dx)^T
  !
  ! and   y^T = dQ/dx * d^2C/dQ^2

  M = 3*nsAtom
  N = nQQ
  NRHS = n1*nLambda
  call Eq_Solver('N',M,N,NRHS,BMx,Curvilinear,Degen,dBM,Scr1)

  ! Generate y^T in Scr2

  call TRNSPS(nQQ,n1*nLambda,Scr1,Scr2)
# ifdef _DEBUGPRINT_
  call RecPrt('d^2C/dQ^2 * (dQ/dx)^T',' ',Scr1,nQQ,n1*nLambda)
  call RecPrt('dQ/dx * d^2C/dQ^2',' ',Scr2,n1*nLambda,nQQ)
# endif
  call mma_deallocate(dBM)

  ! Followed by solve for x in B x = y^T for which B = dQ/dx

  NRHS = nLambda*nQQ
  call Eq_Solver('N',M,N,NRHS,BMx,Curvilinear,Degen,Scr2,Scr1)
  call mma_allocate(d2L,nQQ,nQQ,nLambda,Label='d2L')

  call TRNSPS(nQQ*nLambda,nQQ,Scr1,d2L)
# ifdef _DEBUGPRINT_
  call RecPrt('Scr1',' ',Scr1,nQQ*nLambda,nQQ)
  do i=1,nLambda
    write(u6,*) ' iLambda=',i
    call RecPrt('Update_inner: d2L',' ',d2L(:,:,i),nQQ,nQQ)
  end do
# endif
  call mma_deallocate(Scr2)
  call mma_deallocate(Scr1)
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Compute updated geometry in Internal coordinates

  Mode_Save = Mode
  Mode = 0
  M = 3*nsAtom
  N = nQQ
  NRHS = 1
  call mma_Allocate(Tmp,M,Label='Tmp:M')

  ! Iterate to avoid too large displacement in cartesians.
  ! If the maximum displacement is more than 2*Beta, reduce the step.

  ! Initial setup to ensure fCart=1.0 at first iteration.
  Thr_RS = 1.0e-7_wp
  rInter = Beta
  fCart = Ten
  rCart = fCart*rInter
  nLoop = 0
  do while (rCart >= Two*Beta)
    nLoop = nLoop+1
    if (nLoop > 100) exit
    if (rCart > rInter) then
      fCart = fCart*rInter/rCart
    else
      fCart = fCart*0.9_wp
    end if
    call Con_Opt(R,dRdq,T,dqInt,Lambda,qInt,Shift,dy,dx,dEdq,du,x,dEdx,Wess,GNrm(kIter),nWndw,Hessian,nQQ,kIter,iOptH_,jPrint, &
                 Energy_L,nLambda,ErrVec,EMtrx,RHS,AMat,nA,Beta,fCart,qBeta_Disp,nFix,Indx,Step_Trunc,Lbl,d2L,nsAtom,iOpt_RS, &
                 Thr_RS,iter,First_Microiteration)
    qBeta = fCart*Beta
    if (iOpt_RS == 1) exit

    ! Rough conversion to Cartesians

    call Eq_Solver('T',M,N,NRHS,BMx,Curvilinear,Degen,Shift(:,kIter),Tmp)
    rInter = sqrt(dDot_(N,Shift(:,kIter),1,Shift(:,kIter),1))
    rCart = Zero
    do i=1,nsAtom
      rCart = max(rCart,sqrt(dDot_(3,Tmp(i),nsAtom,Tmp(i),nsAtom)))
    end do
  end do
  Mode = Mode_Save
  call mma_deallocate(Tmp)

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) '********************************************'
  write(u6,*) '* Lagrange multipliers for the constraints *'
  write(u6,*) '********************************************'
  write(u6,'(1X,A,2X,ES13.6)') (Lbl(nQQ+i),-One*Lambda(i,mIter),i=1,nLambda)
  write(u6,*)
# endif

  call mma_deallocate(d2L)
  call mma_deallocate(Energy_L)
  call mma_deallocate(Wess)
  call mma_deallocate(dEdx)
  call mma_deallocate(x)
  call mma_deallocate(du)
  call mma_deallocate(dEdq)
  call mma_deallocate(dx)
  call mma_deallocate(dy)
  call mma_deallocate(T)
  call mma_deallocate(dRdq)
  call mma_deallocate(R)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_Deallocate(Hessian)
call mma_Deallocate(RHS)
call mma_Deallocate(EMtrx)
call mma_Deallocate(ErrVec)
call mma_Deallocate(Indx)
call mma_Deallocate(AMat)
#ifdef _WARNING_WORKAROUND_
if (Smmtrc(1,1)) i = nDimBC
#endif

return

end subroutine Update_inner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine orthcvb_init_cvb()

use casvb_global, only: cvb, cvbnrm, cvbnrm_fr, nfrag, nvb, nvb_fr
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ifr_off, ifrag
real(kind=wp), external :: ddot_

if (nfrag <= 1) then
  cvbnrm = ddot_(nvb,cvb,1,cvb,1)
else
  ifr_off = 1
  do ifrag=1,nfrag
    cvbnrm_fr(ifrag) = ddot_(nvb_fr(ifrag),cvb(ifr_off:),1,cvb(ifr_off:),1)
    ifr_off = ifr_off+nvb_fr(ifrag)
  end do
end if

return

end subroutine orthcvb_init_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKFOP(FIFA,NGRP,JSTATE_OFF,FOPXMS)

      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "SysDef.fh"
#include "WrkSpc.fh"
#include "pt2_guga.fh"

      DIMENSION FIFA(NFIFA)
      DIMENSION FOPXMS(NGRP,NGRP)

* Procedure for computing the matrix FOPXMS, which is the matrix
* of the average Fock operator in the basis of input CASSCF w.f.
* In: The average Fock matrix, active indices only, over the original
* CASSCF MO-orbitals.
* Compute the matrix elements of this Fock operator over the basis
* of CASSCF states that are treated together in XMS fashion.


      CALL DCOPY_(NGRP**2,[0.0D0],0,FOPXMS,1)

* Loop over bra functions:
      DO J1=1,NGRP
        IBRA=JSTATE_OFF+J1
* Loop over ket functions:
        DO J2=1,J1
          IKET=JSTATE_OFF+J2
* Compute matrix element and put it into FOPXMS:
          CALL FOPAB(FIFA,IBRA,IKET,FOPXMS(J1,J2))
* FOPXMS is symmetric
          FOPXMS(J2,J1) = FOPXMS(J1,J2)
        END DO
      END DO

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1982,1983, Per Ake Malmqvist                           *
************************************************************************
      SUBROUTINE DOOL(NDIMEN,MDIM,N,M,A,B,DET,IPIV,JPIV,BUF)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NDIMEN,NDIMEN),B(NDIMEN,MDIM)
      DIMENSION IPIV(NDIMEN),JPIV(NDIMEN),BUF(NDIMEN)
C
C     SOLVES THE MATRIX EQUATION AX=B BY DOOLITTLE''S METHOD
C     ACTUAL DIMENSIONS ARE N*N AND N*M
C     ALLOCATED DIMENSIONS ARE NDIMEN*NDIMEN AND NDIMEN*MDIM
C     A AND B ARE DESTROYED, AND X IS RETURNED AS MATRIX B
C                                       (MALMQUIST 82-11-12)
C                                        (UPDATE 83-09-28)
C
C  EQUATION IS SOLVED BY FACTORIZING A=L*R IN SAME SPACE AS A.
C  PIVOTING IS ACHIEVED BY INDIRECT INDEXING.
C  FIRST PIVOTING INDICES ARE ASSIGNED START VALUES.
C
      IP=0 ! dummy initialize
      JP=0 ! dummy initialize
      DO I=1,N
       IPIV(I)=I
       JPIV(I)=I
      END DO
      DET=1.0D00
      DO I=1,N
C  NOW FIND BETTER PIVOT ELEMENT:
       AMAX=-1.0D00
       DO K=I,N
        DO L=I,N
        AM=ABS(A(IPIV(K),JPIV(L)))
        IF(AMAX.LE.AM) THEN
         AMAX=AM
         IP=K
         JP=L
        END IF
        END DO
       END DO
       IF(IP.NE.I) THEN
        DET=-DET
        IDUM=IPIV(I)
        IPIV(I)=IPIV(IP)
        IPIV(IP)=IDUM
       END IF
       IF(JP.NE.I) THEN
        DET=-DET
        IDUM=JPIV(I)
        JPIV(I)=JPIV(JP)
        JPIV(JP)=IDUM
       END IF
       IP=IPIV(I)
       JP=JPIV(I)
       DIAG=A(IP,JP)
       BUF(I)=DIAG
       DET=DET*DIAG
       DO K=I+1,N
        KP=IPIV(K)
        C=A(KP,JP)/DIAG
        A(KP,JP)=C
        DO L=I+1,N
         LP=JPIV(L)
         A(KP,LP)=A(KP,LP)-C*A(IP,LP)
        END DO
       END DO
      END DO
C
C  FIRST RESUBSTITUTION STEP:
C
      DO J=1,M
       DO I=2,N
        IP=IPIV(I)
        SUMMA=B(IP,J)
        DO K=1,I-1
         SUMMA=SUMMA-A(IP,JPIV(K))*B(IPIV(K),J)
        END DO
        B(IP,J)=SUMMA
       END DO
      END DO
C
C  SECOND RESUBSTITUTION STEP:
C
      DO J=1,M
       DO I=N,1,-1
        IP=IPIV(I)
        SUMMA=B(IP,J)
        DO K=I+1,N
         SUMMA=SUMMA-A(IP,JPIV(K))*B(IPIV(K),J)
        END DO
        B(IP,J)=SUMMA/BUF(I)
       END DO
      END DO
C
C  REORGANIZATION PART:
C
      DO J=1,M
       DO I=1,N
        BUF(I)=B(IPIV(I),J)
       END DO
       DO I=1,N
        B(JPIV(I),J)=BUF(I)
       END DO
      END DO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Giovanni Ghigo                                   *
!***********************************************************************

! Contains:
!   ISCD_Rate
!   ISCD_Ene
!   ISCD_LogEVec
!   ISCD_MakeGraphs
!   ISCD_MakenMat
!   ISCD_MakenIncDec
!   ISCD_ReloadNMAT
!   ISCD_FCval

!  InterSystem Crossing rate
!  Author: Giovanni Ghigo
!          Dip. Chimica Generale e Chimica Organica, Torino (ITALY)
!          June 2009

subroutine ISCD_Rate(iPrint,nOsc,max_nOrd,iMaxYes,nYes,dMinWind,lBatch,nIndex,VibWind2,lNMAT0,lNMAT,lNINC,lNDEC,lnTabDim,nnTabDim, &
                     C1,C2,W2,det0,det1,det2,C,W,r01,r02,m_max,n_max,FC00,dRho,nMat,nInc,nDec)

use mula_global, only: hbarcm, maxMax_n, TranDip
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Pi, auTocm
use Definitions, only: wp, iwp, u6, ItoB

implicit none
integer(kind=iwp), intent(in) :: iPrint, nOsc, iMaxYes, nYes, lBatch, nIndex(3,0:maxMax_n), VibWind2(nYes), lNMAT0, lNMAT, lNINC, &
                                 lNDEC, lnTabDim, nnTabDim(0:lnTabDim), m_max, n_max
integer(kind=iwp), intent(out) :: max_nOrd, nMat(nOsc,lBatch), nInc(nOsc,lBatch), nDec(nOsc,lBatch)
real(kind=wp), intent(in) :: dMinWind, C1(nOsc,nOsc), C2(nOsc,nosc), W2(nOsc,nOsc), det0, det1, det2, C(nOsc,nOsc), W(nOsc,nOsc), &
                             r01(nOsc), r02(nOsc), dRho
real(kind=wp), intent(out) :: FC00
integer(kind=iwp) :: ii, m_max_ord, max_nInc, mx_max_ord, n_max_ord, nvTabDim, nx_max_ord
real(kind=wp) :: const, dLT, dRate, dSoc, dSum
real(kind=wp), allocatable :: FCWind2(:)
integer(kind=iwp), parameter :: MB = 1048576

call TabDim(n_max,nOsc,nvTabDim)
max_nOrd = nvTabDim-1
call TabDim(m_max,nOsc,nvTabDim)
m_max_ord = nvTabDim-1
call TabDim(min(n_max,m_max+1),nOsc,nvTabDim)
mx_max_ord = nvTabDim-1
call TabDim(min(m_max,n_max+1),nOsc,nvTabDim)
nx_max_ord = nvTabDim-1
call TabDim(n_max-1,nOsc,nvTabDim)
max_nInc = nvTabDim-1
call TabDim(n_max,nOsc,nvTabDim)
n_max_ord = nvTabDim-1

mx_max_ord = 0 ! CGGn
if (iPrint >= 3) write(u6,*) ' Memory allocated for U matrix:',(n_max_ord+1)*(mx_max_ord+1),' words,  ', &
                             (n_max_ord+1)*(mx_max_ord+1)*ItoB/MB,' MB.'
call XFlush(u6)

!GGt -------------------------------------------------------------------
!write(u6,*) '     lnTabDim+1=',lnTabDim+1,':'
!do i=0,lnTabDim
!  iIndex0 = nnTabDim(i)
!  call iDaFile(lNMAT0,2,nMat0,nOsc,iIndex0)
!  write(u6,*) i,' read at',nnTabDim(i),'  M:',(nMat0(j),j=1,nOsc)
!end do
!write(u6,*) '-----------------------------------------------'
!GGt -------------------------------------------------------------------
!call XFlush(u6)

call mma_allocate(FCWind2,nYes,label='FCWind2')
call ISCD_FCval(iPrint,iMaxYes,lnTabDim,nnTabDim,lNMAT0,lNMAT,lNINC,lNDEC,lBatch,nIndex,C1,det1,r01,C2,W2,det2,r02,m_max_ord, &
                n_max_ord,mx_max_ord,max_nInc,nx_max_ord,nMat,nInc,nDec,C,W,det0,FC00,nOsc,nYes,VibWind2,FCWind2)

const = Two*Pi/hbarcm
if (iPrint >= 4) then
  write(u6,*)
  write(u6,*) '  const =',const
  write(u6,*) '  dRho/cm =',dRho/auTocm
  write(u6,*) '  const*dRho=',const*dRho/auTocm
end if
const = const*dRho/auTocm

dSum = Zero
do ii=1,nYes
  dSum = dSum+FCWind2(ii)**2
end do
call mma_deallocate(FCWind2)

dSoc = Zero
do ii=1,3
  dSOC = dSOC+TranDip(ii)**2
end do

dRate = const*dSum*dSoc/dMinWind
dLT = One/dRate

if (iPrint >= 3) then
  write(u6,*) '  Sum of squares of FC factors =',dSum
  write(u6,*) '  Root-square of the sum =',sqrt(dSum)
  write(u6,*) '  dSOC =',dSOC
end if

if (iPrint >= 1) then
  write(u6,*)
  write(u6,*) ' InterSystem Crossing rate constant:'
  write(u6,*) ' ===================================='
  write(u6,'(a,e10.2,a)') '  ISC Rate Constant  ',dRate,' sec-1'
  write(u6,'(a,e10.2,a)') '  Lifetime           ',dLT,' sec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' msec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' microsec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' nsec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' psec'
  dLT = dLT*1.0e3_wp
  if ((dLT > One) .and. (dLT <= 1.0e3_wp)) write(u6,'(a19,f5.1,a)') ' ',dLT,' fsec'
  write(u6,*) ' ------------------------------------'
  write(u6,*)
  write(u6,*)
  call XFlush(u6)
end if

return

end subroutine ISCD_Rate

subroutine ISCD_Ene(iPrint,nOsc,max_nOrd,nYes,lNMAT,lnTabDim,GE1,GE2,harmfreq1,harmfreq2,x_anharm1,x_anharm2,dMinWind,dRho,nMat0, &
                    nTabDim,lVec)
! Calculate Energy of Levels  GG 30-Dec-08 - 08-Jan-09

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, auTocm
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, nOsc, max_nOrd, lNMAT, lnTabDim, nTabDim(0:lnTabDim)
integer(kind=iwp), intent(inout) :: nYes, lVec(0:lnTabDim)
real(kind=wp), intent(in) :: GE1, GE2, harmfreq1(nOsc), harmfreq2(nOsc), x_anharm1(nOsc,nOsc), x_anharm2(nOsc,nOsc), dRho
real(kind=wp), intent(inout) :: dMinWind
integer(kind=iwp), intent(out) :: nMat0(nOsc)
integer(kind=iwp) :: i, iIndex, iOrd, j, l_harm, loc_n_max, nYes_start
real(kind=wp) :: dEne, dWlow, dWup
logical(kind=iwp) :: lUpdate
integer(kind=iwp), allocatable :: level1(:), level2(:), lTVec(:)
real(kind=wp), allocatable :: EneMat(:)

if (dMinWind == Zero) then
  lUpDate = .true.
  dMinWind = One
else
  lUpDate = .false.
end if
call mma_allocate(lTVec,[0,max_nOrd],label='lTVec')
lTVec(:) = lVec(0:max_nOrd)

! Energy calculation

if (iPrint >= 4) then
  write(u6,*)
  write(u6,*) ' States in the preliminar window :'
  if (nOsc <= 24) then
    write(u6,'(a,108a)') '  ',('=',i=1,108)
    write(u6,*) '     jOrd    ene/au    ene/cm-1 Vibrational quantum numbers'
    write(u6,'(a,108a)') '  ',('-',i=1,108)
  else
    write(u6,'(a,36a)') '  ',('=',i=1,36)
    write(u6,*) '        #    jOrd   ene/au      ene/cm-1'
    write(u6,'(a,36a)') '  ',('-',i=1,36)
  end if
  call XFlush(u6)
end if

call mma_allocate(level1,nOsc,label='level1')
call mma_allocate(level2,nOsc,label='level2')
call mma_allocate(EneMat,[0,max_nOrd],label='EneMat')
level1(:) = 0
rewind(lNMAT)
do iOrd=0,max_nOrd
  if (lVec(iOrd) == 1) then
    iIndex = nTabDim(iOrd)
    call iDaFile(lNMAT,2,nMat0,nOsc,iIndex)
    level2(:) = nMat0
    l_harm = nOsc
    call TransEnergy(GE1,x_anharm1,harmfreq1,level1,GE2,x_anharm2,harmfreq2,level2,dEne,l_harm)
    EneMat(iOrd) = dEne
    if (iPrint >= 4) then
      if (nOsc <= 24) then
        loc_n_max = 0
        do j=1,nOsc
          loc_n_max = loc_n_max+nMat0(j)
        end do
        write(u6,'(a2,i8,f11.6,f11.4,i4,a2,24i3)') ' ',iOrd,dEne,dEne*auTocm,loc_n_max,': ',(nMat0(j),j=1,nOsc)
      else
        write(u6,'(a2,i8,f11.6,f11.4,i4        )') ' ',iOrd,dEne,dEne*auTocm,loc_n_max
      end if
    end if
  end if
end do

! Energy selection

if (iPrint >= 3) then
  write(u6,*)
  write(u6,*) ' States in the window :'
  if (nOsc <= 24) then
    write(u6,'(a,108a)') '  ',('=',i=1,108)
    write(u6,*) '     jOrd    ene/au    ene/cm-1 Vibrational quantum numbers'
    write(u6,'(a,108a)') '  ',('-',i=1,108)
  else
    write(u6,'(a,36a)') '  ',('=',i=1,36)
    write(u6,*) '        #    jOrd   ene/au      ene/cm-1'
    write(u6,'(a,36a)') '  ',('-',i=1,36)
  end if
  call XFlush(u6)
end if

nYes_start = nYes
do
  dWlow = Half*dMinWind/dRho
  dWup = dWlow
  do iOrd=0,max_nOrd
    lVec(iOrd) = lTVec(iOrd)
    if (lVec(iOrd) == 1) then
      dEne = EneMat(iOrd)
      if ((dEne < -dWlow) .or. (dEne > dWup)) then
        lVec(iOrd) = 0
        nYes = nYes-1
      else
        lVec(iOrd) = 1
        if (iPrint >= 3) then
          if (nOsc <= 24) then
            iIndex = nTabDim(iOrd)
            call iDaFile(lNMAT,2,nMat0,nOsc,iIndex)
            loc_n_max = 0
            do j=1,nOsc
              loc_n_max = loc_n_max+nMat0(j)
            end do
            write(u6,'(a2,i8,f11.6,f11.4,i4,a2,24i3)') ' ',iOrd,dEne,dEne*auTocm,loc_n_max,': ',(nMat0(j),j=1,nOsc)
          else
            write(u6,'(a2,i8,f11.6,f11.4,i4        )') ' ',iOrd,dEne,dEne*auTocm,loc_n_max
          end if
        end if
      end if
    end if
  end do
  if ((nYes > 1) .or. (.not. lUpDate)) exit
  dMinWind = dMinWind+One
  nYes = nYes_start
end do

call mma_deallocate(lTVec)
call mma_deallocate(level1)
call mma_deallocate(level2)
call mma_deallocate(EneMat)

if (iPrint >= 3) then
  if (nOsc <= 30) write(u6,'(a,108a)') '  ',('-',i=1,108)
  if (nOsc > 30) write(u6,'(a,36a)') '  ',('-',i=1,36)
  write(u6,'(a,f12.9,a,f12.9,a)') '  Window: ',-dWlow,' / ',dWup,' (au)'
  write(u6,'(a,f12.6,a,f12.6,a)') '  Window: ',-dWlow*auTocm,' / ',dWup*auTocm,' (cm-1)'
end if
if (iPrint >= 2) then
  write(u6,*) ' Final number of States=',nYes
end if
if ((dMinWind > One) .and. lUpDate .and. (iPrint >= 1)) then
  write(u6,*)
  write(u6,*) ' *** Warning: Expansion factor has been set to ',dMinWind
  write(u6,*)
end if
call XFlush(u6)

return

end subroutine ISCD_Ene

subroutine ISCD_LogEVec(iPrint,nOsc,max_nOrd,minQ,nYes,lNMAT,lnTabDim,nTabDim,nMaxQ,nMat0,lVec)
! Generate Logical Vector of useful States

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, nOsc, max_nOrd, minQ, lNMAT, lnTabDim, nTabDim(0:lnTabDim), nMaxQ(nOsc)
integer(kind=iwp), intent(out) :: nYes, nMat0(nOsc), lVec(0:lnTabDim)
integer(kind=iwp) :: iIndex, iOrd, iOsc, nSumQ

if (iPrint >= 3) then
  write(u6,*) ' Original number of States=',max_nOrd+1
end if
rewind(lNMAT)
iIndex = 0
do iOrd=0,max_nOrd
  iIndex = nTabDim(iOrd)
  call iDaFile(lNMAT,2,nMat0,nOsc,iIndex)
  nSumQ = 0
  lVec(iOrd) = 1
  do iOsc=1,nOsc
    if (nMat0(iOsc) > nMaxQ(iOsc)) lVec(iOrd) = 0
    nSumQ = nSumQ+nMat0(iOsc)
  end do
  if (nSumQ < minQ) lVec(iOrd) = 0
end do

nYes = 0
do iOrd=0,max_nOrd
  if (lVec(iOrd) == 1) nYes = nYes+1
end do

if (iPrint >= 3) then
  write(u6,*) ' Selected number of States=',nYes
end if

return

end subroutine ISCD_LogEVec

subroutine ISCD_MakeGraphs(m_max,maxOrd,Graph1,Graph2,nOsc)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: m_max, nOsc
integer(kind=iwp), intent(out) :: maxOrd, Graph1(m_max+1,nOsc+1), Graph2(m_max+1,m_max+1,nOsc)
integer(kind=iwp) :: i, iOsc, iQ1, iQ2, m, n, nQuanta, nTabDim
integer(kind=iwp), allocatable :: Num(:)

! Initialize.
if (m_max == 0) return
call TabDim(m_max,nOsc,nTabDim)
maxOrd = nTabDim-1

! Set up the vertex table
Graph1(:,:) = 0
Graph1(:,2) = 1
Graph1(1,:) = 1
if (nOsc > 1) then
  do iOsc=2,nOsc
    n = 0
    do nQuanta=0,m_max
      n = n+Graph1(nQuanta+1,iOsc)
      Graph1(nQuanta+1,iOsc+1) = n
    end do
  end do
end if

! set up the arc table
call mma_allocate(Num,[0,m_max],label='Number')
Num(0) = 0
N = 0
do m=1,m_max
  N = N+Graph1(m,nosc+1)
  Num(m) = N
end do
Graph2(:,:,:) = 0
do iOsc=1,nosc
  do iQ1=0,m_max      ! Where we are going
    do iQ2=0,iQ1-1    ! Where we came from
      do i=iQ2+1,iq1  ! Sum over preceding paths
        Graph2(iQ1+1,iQ2+1,iOsc) = Graph1(i+1,iOsc)+Graph2(iQ1+1,iQ2+1,iOsc)
      end do
    end do
  end do
end do

do iQ1=0,m_max  ! Where we are going
  do iQ2=0,iq1  ! Where we came from
    Graph2(iQ1+1,iQ2+1,nOsc) = Graph2(iQ1+1,iQ2+1,nOsc)+Num(iQ1)
  end do
end do

call mma_deallocate(Num)

return

end subroutine ISCD_MakeGraphs

subroutine ISCD_MakenMat(n_max,nOsc,lNMAT,lnTabDim,Graph2,nTabDim,nMat0)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n_max, nOsc, lNMAT, lnTabDim, Graph2(n_max+1,n_max+1,nOsc)
integer(kind=iwp), intent(out) :: nTabDim(0:lnTabDim), nMat0(nOsc)
integer(kind=iwp) :: i, iDet, iDNR, iIndex, iQ, iQuanta, nd, nD_0, nvTabDim
integer(kind=iwp), allocatable :: iVec(:)
integer(kind=iwp), external :: iDetnr

! Initialize.
nMat0(:) = 0
iIndex = 0
nTabDim(0) = iIndex
call iDaFile(lNMAT,1,nMat0,nOsc,iIndex)
call mma_allocate(iVec,nOsc,label='iVec')

! Macrocycle on iQuanta
nD_0 = 0
do iQuanta=1,n_max
  iVec(:) = 0
  iQ = -1
  iVec(1) = -1
  call TabDim(iQuanta,nOsc,nd)
  call TabDim(iQuanta-1,nOsc,nvTabDim)
  nd = nd-nvTabDim

  ! Microcycle on iDet
  do iDet=1,nD
    iVec(1) = iVec(1)+1
    iQ = iQ+1
    if (iQ > iQuanta) then
      do i=1,nOsc-1
        if (iQ <= iQuanta) exit
        iQ = iQ-iVec(i)+1
        iVec(i) = 0
        iVec(i+1) = iVec(i+1)+1
      end do
    end if
    iVec(nOsc) = iQuanta-iq
    iDNR = iDetnr(iVec,Graph2,nosc,n_max)
    iDNR = iDNR-nD_0
    nMat0(:) = iVec
    nTabDim(iDNR+nD_0) = iIndex
    call iDaFile(lNMAT,1,nMat0,nOsc,iIndex)
  end do
  nD_0 = nD_0+nD
end do
call mma_deallocate(iVec)

return

end subroutine ISCD_MakenMat

subroutine ISCD_MakenIncDec(n_max,nOrd,nOsc,lNMAT,lNINC,lNDEC,lBatch,nBatch,leftBatch,nIndex,Graph2,nMat,nInc,nDec)

use mula_global, only: maxMax_n
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n_max, nOrd, nOsc, lNMAT, lNINC, lNDEC, lBatch, nBatch, leftBatch, Graph2(n_max+1,n_max+1,nOsc)
integer(kind=iwp), intent(inout) :: nIndex(3,0:maxMax_n)
integer(kind=iwp), intent(out) :: nMat(nOsc,lBatch), nInc(nOsc,lBatch), nDec(nOsc,lBatch)
integer(kind=iwp) :: iBatch, ii, iIndex, iOrd, iv, j, jIndex, kIndex
integer(kind=iwp), allocatable :: iVecD(:), iVecI(:)
integer(kind=iwp), external :: iDetnr

!GGt -------------------------------------------------------------------
!write(u6,*)
!write(u6,*) 'CGGt[ISCD_Mk_nIncDec] Infos:'
!write(u6,*) '     nMat(',nOsc,',',lBatch,')'
!write(u6,*) '     n_max,nOrd,nOsc==',n_max,nOrd,nOsc
!write(u6,*) '     lBatch,nBatch,leftBatch==',lBatch,nBatch,leftBatch
!write(u6,*) '----------------------------------------------'
!write(u6,*) '  The nIndex file:'
!do i=1,nBatch+1
!  write(u6,*) i,': ',nIndex(1,i)
!end do
!  write(u6,*) '----------------------------------------------'
!call XFlush(u6)
!GGt -------------------------------------------------------------------

! Initialize

call mma_allocate(iVecI,nOsc,label='iVecI')
call mma_allocate(iVecD,nOsc,label='iVecD')

! Macrocycle iBatch
! Reading nMat

iIndex = 0
jIndex = 0
do iBatch=1,nBatch
  nInc(:,:) = -1
  nDec(:,:) = -1
  kIndex = nIndex(1,iBatch)
  !write(u6,*)'          iBatch=',iBatch,'  kIndex=',kIndex
  call iDaFile(lNMAT,2,nMat,nOsc*lBatch,kIndex)
  !GGt -----------------------------------------------------------------
  !do i=0,lBatch-1
  !  write(u6,*) i+(iBatch-1)*lBatch,': ',(nMat(k,i+1),k=1,nOsc)
  !end do
  !write(u6,*) '----------------------------------------------'
  !call XFlush(u6)
  !GGt -----------------------------------------------------------------
  do ii=1,lBatch

    ! Create nInc.

    iVecI(:) = nMat(:,ii)
    do j=1,nOsc
      iVecI(j) = iVecI(j)+1
      nInc(j,ii) = iDetnr(iVecI,Graph2,nOsc,n_max)
      iVecI(j) = iVecI(j)-1
    end do

    ! Create nDec.

    do j=1,nOsc
      if (nMat(j,ii) /= 0) then
        iVecD(:) = nMat(:,ii)
        iVecD(j) = iVecD(j)-1
        nDec(j,ii) = iDetnr(iVecD,Graph2,nosc,n_max)
        do iv=1,nOsc
          iVecD(iv) = iVecD(j)+1
        end do
      else
        nDec(j,ii) = -1
      end if
    end do

  end do

  nIndex(2,iBatch) = iIndex
  call iDaFile(lNINC,1,nInc,nOsc*lBatch,iIndex)
  nIndex(3,iBatch) = jIndex
  call iDaFile(lNDEC,1,nDec,nOsc*lBatch,jIndex)
  !GGt -----------------------------------------------------------------
  !do i=0,lBatch-1
  !  write(u6,*) i+(iBatch-1)*lBatch,':I',(nInc(k,i+1),k=1,nOsc)
  !  write(u6,*) i+(iBatch-1)*lBatch,':D',(nDec(k,i+1),k=1,nOsc)
  !end do
  !call XFlush(u6)
  !GGt -----------------------------------------------------------------
  !  write(u6,*) '            nInc Written at ',nIndex(2,iBatch)
  !  write(u6,*) '            nDec Written at ',nIndex(3,iBatch)
  !  write(u6,*) '----------------------------------------------'
  !call XFlush(u6)
  !GGt -----------------------------------------------------------------

end do

if (leftBatch > 0) then
  kIndex = nIndex(1,nBatch+1)
  !write(u6,*) '          nBatch+1',nBatch+1,'  kIndex=',kIndex
  call iDaFile(lNMAT,2,nMat,nOsc*lBatch,kIndex)
  !GGt -----------------------------------------------------------------
  !write(u6,*) '  --------- last Batch'
  !do i=0,lBatch-1
  !  write(u6,*) i+(iBatch-1)*lBatch,': ',(nMat(k,i+1),k=1,nOsc)
  !end do
  !call XFlush(u6)
  !GGt -----------------------------------------------------------------

  !write(u6,*) 'CGGt nBatch*lBatch,nOrd==',nBatch*lBatch,nOrd
  !call XFlush(u6)
  nInc(:,:) = -1
  nDec(:,:) = -1
  do iOrd=nBatch*lBatch,nOrd
    ii = 1+iOrd-nBatch*lBatch

    ! Create nInc.

    iVecI(:) = nMat(:,ii)
    do j=1,nOsc
      iVecI(j) = iVecI(j)+1
      nInc(j,ii) = iDetnr(iVecI,Graph2,nOsc,n_max)
      iVecI(j) = iVecI(j)-1
    end do

    ! Create nDec.

    do j=1,nOsc
      if (nMat(j,ii) /= 0) then
        iVecD(:) = nMat(:,ii)
        iVecD(j) = iVecD(j)-1
        nDec(j,ii) = iDetnr(iVecD,Graph2,nosc,n_max)
        do iv=1,nOsc
          iVecD(iv) = iVecD(j)+1
        end do
      else
        nDec(j,ii) = -1
      end if
    end do

  end do

  nIndex(2,nBatch+1) = iIndex
  call iDaFile(lNINC,1,nInc,nOsc*lBatch,iIndex)
  nIndex(3,nBatch+1) = jIndex
  call iDaFile(lNDEC,1,nDec,nOsc*lBatch,jIndex)
  !GGt -----------------------------------------------------------------
  !do i=0,lBatch-1
  !  write(u6,*) i+(iBatch-1)*lBatch,':I',(nInc(k,i+1),k=1,nOsc)
  !  write(u6,*) i+(iBatch-1)*lBatch,':D',(nDec(k,i+1),k=1,nOsc)
  !end do
  !call XFlush(u6)
  !GGt -----------------------------------------------------------------
  !write(u6,*) '            nInc Written at ',nIndex(2,nBatch+1)
  !write(u6,*) '            nDec Written at ',nIndex(3,nBatch+1)
  !write(u6,*) '----------------------------------------------'
  !call XFlush(u6)
  !GGt -----------------------------------------------------------------
end if

!write(u6,*) '----------------------------------------------'
!call XFlush(u6)

call mma_deallocate(iVecI)
call mma_deallocate(iVecD)

return

end subroutine ISCD_MakenIncDec

subroutine ISCD_ReloadNMAT(lnTabDim,nOrd,nOsc,lNMAT0,lNMAT,lBatch,nBatch,leftBatch,nIndex,nTabDim,nMat0,nMat)

use mula_global, only: maxMax_n
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lnTabDim, nOrd, nOsc, lNMAT0, lNMAT, lBatch, nBatch, leftBatch, nTabDim(0:lnTabDim)
integer(kind=iwp), intent(out) :: nIndex(3,0:maxMax_n), nMat0(nOsc), nMat(nOsc,lBatch)
integer(kind=iwp) :: iBatch, ii, iIndex0, iOrd, iOsc, jIndex

! Initialize

!GGt -------------------------------------------------------------------
!write(u6,*)
!write(u6,*) 'CGGt[ISCD_ReloadNMAT] Infos:'
!write(u6,*) '     nMat(',nOsc,',',lBatch,')'
!write(u6,*) '     lnTabDim,nOrd,nOsc==',lnTabDim,nOrd,nOsc
!write(u6,*) '     lBatch,nBatch,leftBatch==',lBatch,nBatch,leftBatch
!write(u6,*) '     lnTabDim+1=',lnTabDim+1,':'
!do i=0,lnTabDim
!  write(u6,*) i,' read at ',nTabDim(i)
!  iIndex0 = nTabDim(i)
!  call iDaFile(lNMAT0,2,nMat0,nOsc,iIndex0)
!  write(u6,*) i,' read at',nTabDim(i),'  M:',(nMat0(j),j=1,nOsc)
!end do
!write(u6,*) '----------------------------------------------'
!call XFlush(u6)
!GGt -------------------------------------------------------------------
jIndex = 0
rewind(lNMAT0)
do iBatch=1,nBatch
  do ii=0,lBatch-1
    iOrd = ii+(iBatch-1)*lBatch
    iIndex0 = nTabDim(iOrd)
    call iDaFile(lNMAT0,2,nMat0,nOsc,iIndex0)
    do iOsc=1,nOsc
      nMat(iOsc,ii+1) = nMat0(iOsc)
    end do
  end do
  nIndex(1,iBatch) = jIndex
  call iDaFile(lNMAT,1,nMat,nOsc*lBatch,jIndex)
  !GGt -----------------------------------------------------------------
  !write(u6,*)'  --------- iBatch =',iBatch
  !do i=0,lBatch-1
  !  write(u6,*) i+(iBatch-1)*lBatch,':M',(nMat(k,i+1),k=1,nOsc)
  !end do
  !call XFlush(u6)
  !GGt -----------------------------------------------------------------
end do
if (leftBatch > 0) then
  do iOrd=nBatch*lBatch,nOrd
    ii = iOrd-nBatch*lBatch
    iIndex0 = nTabDim(iOrd)
    call iDaFile(lNMAT0,2,nMat0,nOsc,iIndex0)
    do iOsc=1,nOsc
      nMat(iOsc,ii+1) = nMat0(iOsc)
    end do
  end do
  nIndex(1,nBatch+1) = jIndex
  call iDaFile(lNMAT,1,nMat,nOsc*lBatch,jIndex)
  !GGt -----------------------------------------------------------------
  !write(u6,*) '  --------- last Batch'
  !do i=0,lBatch-1
  !  write(u6,*) i+(iBatch-1)*lBatch,':M',(nMat(k,i+1),k=1,nOsc)
  !end do
  !call XFlush(u6)
  !GGt -----------------------------------------------------------------
end if
!GGt -------------------------------------------------------------------
!write(u6,*) '----------------------------------------------'
!write(u6,*) '  The nIndex file:'
!do i=1,nBatch+1
! write(u6,*) i,': ',nIndex(1,i)
!end do
!write(u6,*) '----------------------------------------------'
!call XFlush(u6)
!GGt -------------------------------------------------------------------

return

end subroutine ISCD_ReloadNMAT

subroutine ISCD_FCval(iPrint,iMaxYes,lnTabDim,nnTabDim,lNMAT0,lNMAT,lNINC,lNDEC,lBatch,nIndex,C1,det1,r01,C2,W2,det2,r02,max_mOrd, &
                      max_nOrd,max_nOrd2,max_nInc,max_nInc2,nMat,nInc,nDec,C,W,det0,FC00,nOsc,nYes,VibWind2,FCWind2)

use mula_global, only: maxMax_n
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, iMaxYes, lnTabDim, nnTabDim(0:lnTabDim), lNMAT0, lNMAT, lNINC, lNDEC, lBatch, &
                                 nIndex(3,0:maxMax_n), max_mOrd, max_nOrd, max_nOrd2, max_nInc2, nOsc, nYes, VibWind2(nYes)
real(kind=wp), intent(in) :: C1(nOsc,nOsc), det1, r01(nOsc), C2(nOsc,nOsc), W2(nOsc,nOsc), det2, r02(nOsc), C(nOsc,nOsc), &
                             W(nOsc,nOsc), det0
integer(kind=iwp), intent(inout) :: max_nInc
integer(kind=iwp), intent(out) :: nMat(nOsc,lBatch), nInc(nOsc,lBatch), nDec(nOsc,lBatch)
real(kind=wp), intent(out) :: FC00, FCWind2(nYes)
integer(kind=iwp) :: i, iBatch, ii, iIndex, iIndex0, iiOrd, iOrd, j, jIndex, jjOrd, jOrd, kDelta, kIndex, kOsc, kOsc_start, &
                     loc_n_max, lOsc, n, nMaxMat, nTabDim
real(kind=wp) :: const, det, dFC, FC00_exp
integer(kind=iwp), allocatable :: nMat0(:)
real(kind=wp), allocatable :: A2(:,:), A2B2T(:,:), Alpha(:,:), Alpha1(:,:), Alpha2(:,:), B2(:,:), Beta(:,:), d2(:), L(:,:), &
                              r_temp1(:), r_temp2(:), sqr(:), temp(:,:), temp1(:,:), temp2(:,:), U(:,:)
real(kind=wp), external :: Ddot_

call mma_allocate(nMat0,nOsc,label='nMat0')

!GGt -------------------------------------------------------------------
!write(u6,*) 'CGGt[ISCD_FCval] Enter'
!write(u6,*) '     nYes = ',nYes
!write(u6,*) '     VibWind2 :',(VibWind2(i),i=1,nYes)
!write(u6,*) '     L matrix:',max_mOrd,max_nInc2
!write(u6,*) '     U matrix:',max_nOrd,max_nOrd2
!do i=0,iMaxYes
!  write(u6,*) (nInc(i,j),j=1,nOsc)
!end do
!write(u6,*) '     lnTabDim+1=',lnTabDim+1,':'
!do i=0,lnTabDim
!  iIndex0 = nnTabDim(i)
!  !call iDaFile(lNMAT0,2,nMat0,nOsc,iIndex0)
!  write(u6,*) i,' read at',nnTabDim(i),'  M:',(nMat0(j),j=1,nOsc)
!end do
!write(u6,*) '-----------------------------------------------'
!call XFlush(u6)
!GGt -------------------------------------------------------------------

! Initialize.
rewind(lnMAT0)
rewind(lnMAT)
rewind(lnINC)
rewind(lnDEC)
nMaxMat = max(max_mOrd+1,max_nOrd+1)
!write(u6,*) '            nMaxMat=',nMaxMat
nTabDim = max(nMaxMat,8)
!write(u6,*) '            nTabDim=',nTabDim
call mma_allocate(temp,nOsc,nOsc,label='temp')
call mma_allocate(temp1,nOsc,nOsc,label='temp1')
call mma_allocate(temp2,nOsc,nOsc,label='temp2')

! Setup sqr table.
n = nTabDim+1
call mma_allocate(sqr,[0,n],label='sqr')
do i=0,nTabDim+1
  sqr(i) = sqrt(real(i,kind=wp))
end do

! Calculate alpha1, alpha2 and alpha.
!write(u6,*) 'CGGt[FCVal] Calculate alpha(s)'
!call XFlush(u6)
call mma_allocate(Alpha,nOsc,nOsc,label='Alpha')
call mma_allocate(Alpha1,nOsc,nOsc,label='Alpha1')
call mma_allocate(Alpha2,nOsc,nOsc,label='Alpha2')
call DGEMM_('T','N',nOsc,nOsc,nOsc,Half,C1,nOsc,C1,nOsc,Zero,Alpha1,nOsc)
call DGEMM_('T','N',nOsc,nOsc,nOsc,Half,C2,nOsc,C2,nOsc,Zero,Alpha2,nOsc)
temp(:,:) = alpha1+alpha2
Alpha(:,:) = Half*temp

!call xxDgemul(C,nOsc,'T',C,nOsc,'N',alpha,nOsc,nOsc,nOsc,nOsc)
!alpha(:,:) = Half*alpha

! Calculate C using a Cholesky factorization of 2*alpha.
!call Cholesky(temp,C)

! Calculate W.
!W(:,:) = Zero
!do i=1,nOsc
!  W(i,i) = One
!end do
!temp(:,:) = C
!call Dool_MULA(temp,W,det0)

! Calculate r00.
call mma_allocate(r_temp1,nOsc,label='r_temp1')
call mma_allocate(r_temp2,nOsc,label='r_temp2')

! Calculate beta.
!write(u6,*) 'CGGt[FCVal] Calculate beta.'
!call XFlush(u6)
call mma_allocate(Beta,nOsc,nOsc,label='Beta')
do i=1,nOsc
  do j=1,nOsc
    temp1(j,i) = C1(i,j)
  end do
  !write(u6,*) 'CGGt C1(',i,',j)=',(C1(i,jj),jj=1,nOsc)
end do
!call XFlush(u6)
temp1(:,:) = Alpha1
temp(:,:) = Two*Alpha

call Dool_MULA(temp,nOsc,nOsc,temp1,nOsc,nOsc,det)
call DGEMM_('N','N',nOsc,nOsc,nOsc,One,Alpha2,nOsc,temp1,nOsc,Zero,Beta,nOsc)

call mma_deallocate(Alpha1)
call mma_deallocate(Alpha2)

! Calculate FC00.
!r_temp1(:) = r02-r01
r_temp1(:) = r01-r02

call DGEMM_('N','N',nOsc,1,nOsc,One,Beta,nOsc,r_temp1,nOsc,Zero,r_temp2,nOsc)
FC00_exp = Ddot_(nOsc,r_temp1,1,r_temp2,1)
FC00 = (sqrt(det1)*sqrt(det2)/det0)*exp(-FC00_exp)
!write(u6,*) 'CGGt[FCVal] FC00_exp,FC00=',FC00_exp,FC00
!call XFlush(u6)

call mma_deallocate(Beta)

! Calculate A, B and d matrices.
call mma_allocate(A2,nOsc,nOsc,label='A2')
call mma_allocate(B2,nOsc,nOsc,label='B2')
call mma_allocate(d2,nOsc,label='d2')

call DGEMM_('N','N',nOsc,nOsc,nOsc,One,C2,nOsc,W,nOsc,Zero,A2,nOsc)
call DGEMM_('T','T',nOsc,nOsc,nOsc,One,W2,nOsc,C,nOsc,Zero,temp,nOsc)
B2(:,:) = A2-temp

const = -sqr(8)
call DGEMM_('T','N',nOsc,1,nOsc,const,W2,nOsc,r_temp2,nOsc,Zero,d2,nOsc)

! Calculate A2B2T.
call mma_allocate(A2B2T,nOsc,nOsc,label='A2B2T')

call DGEMM_('N','T',nOsc,nOsc,nOsc,One,A2,nOsc,B2,nOsc,Zero,A2B2T,nOsc)

! Initialize L matrix.
call mma_allocate(L,[0,max_mOrd],[0,max_nInc2],label='L')
L(:,:) = Zero
L(0,0) = One

! If max_mOrd > 0 then set up L(m,0).
if (max_mOrd > 0) then
  write(u6,*) '*****************************************'
  write(u6,*) ' Hot initial state not implemented yet !'
  write(u6,*) '*****************************************'
  write(u6,*)
  call Quit_OnUserError()
end if

! Initialize U matrix.
!write(u6,*) 'CGGt[FCVal] Initialize U matrix.'
!call XFlush(u6)
call mma_allocate(U,[0,max_nOrd],[0,max_nOrd2],label='U')
U(:,:) = Zero
U(0,0) = One
!do kOsc=1,nOsc
!  write(u6,*) 'CGGt[FCVal] d2(..)=',d2(kOsc)
!  call XFlush(u6)
!end do

! Reading for first batch nMat, nInc, nDec

iIndex = nIndex(1,1)
jIndex = nIndex(2,1)
kIndex = nIndex(3,1)
!write(u6,*) 'CGGt[FCVal] Reading nMat at ',iIndex
!call XFlush(u6)
call iDaFile(lNMAT,2,nMat,nOsc*lBatch,iIndex)
!GGt -------------------------------------------------------------------
!write(u6,*) 'CGGt-nMat:'
!do i=0,lBatch-1
!  write(u6,*) i,'-M:',(nMat(j,i+1),j=1,nOsc)
!end do
!write(u6,*) '-----------------------------------------------'
!GGt -------------------------------------------------------------------

!write(u6,*) 'CGGt[FCVal] Reading nInc at ',jIndex
!call XFlush(u6)
call iDaFile(lNINC,2,nInc,nOsc*lBatch,jIndex)
!GGt -------------------------------------------------------------------
!write(u6,*) 'CGGt-nInc:'
!do i=0,lBatch-1
!  write(u6,*) i,'-I:',(nInc(j,i+1),j=1,nOsc)
!end do
!write(u6,*) '-----------------------------------------------'
!GGt -------------------------------------------------------------------

!write(u6,*) 'CGGt[FCVal] Reading nDec at ',kIndex
!call XFlush(u6)
call iDaFile(lNDEC,2,nDec,nOsc*lBatch,kIndex)
!GGt -------------------------------------------------------------------
!write(u6,*) 'CGGt-nDec:'
!do i=0,lBatch-1
!  write(u6,*) i,'-D:',(nDec(j,i+1),j=1,nOsc)
!end do
!write(u6,*) '-----------------------------------------------'
!GGt -------------------------------------------------------------------

! If max_nOrd > 0 then set up U(n,0).

!GGt -------------------------------------------------------------------
!write(u6,*) 'CGGt[FCVal] max_nOrd > 0 then set up U(n,0).'
!Call XFlush(u6)
!GGt -------------------------------------------------------------------
do kOsc=1,nOsc
  U(nInc(kOsc,1),0) = d2(kOsc)
end do
max_nInc = min(max_nInc,iMaxYes)
!GGt -------------------------------------------------------------------
!do kOsc=1,nOsc
!  write(u6,*) 'CGGt[FCVal] U(',nInc(kOsc,1),',0) =',U(nInc(kOsc,1),0)
!end do
!write(u6,*) 'CGGt[FCVal] max_nInc=',max_nInc
!write(u6,*) 'CGGt[FCVal]  iMaxYes=',iMaxYes
!call XFlush(u6)
!GGt -------------------------------------------------------------------

iBatch = 1
if (max_nInc > 0) then
  do iOrd=1,max_nInc
    !write(u6,*) '              iOrd=',iOrd,'    iBatch=',iBatch
    !call XFlush(u6)
    iiOrd = iOrd-(iBatch-1)*lBatch+1
    if (iiOrd == (lBatch+1)) then
      iBatch = iBatch+1
      iIndex = nIndex(1,iBatch)
      jIndex = nIndex(2,iBatch)
      kIndex = nIndex(3,iBatch)
      !write(u6,*) 'CGGt[] iBatch=',iBatch,': Reading nMat at ',iIndex
      !call XFlush(u6)
      call iDaFile(lNMAT,2,nMat,nOsc*lBatch,iIndex)
      !write(u6,*) 'CGGt[] iBatch=',iBatch,': Reading nInc at ',iIndex
      !call XFlush(u6)
      call iDaFile(lNINC,2,nInc,nOsc*lBatch,jIndex)
      !write(u6,*) 'CGGt[] iBatch=',iBatch,': Reading nDec at ',iIndex
      !call XFlush(u6)
      call iDaFile(lNDEC,2,nDec,nOsc*lBatch,kIndex)
      iiOrd = iOrd-(iBatch-1)*lBatch+1
    end if
    !write(u6,*) '              iOrd=',iOrd,'  iiOrd=',iiOrd
    !write(u6,*) iOrd,'-MID:',(nMat(j,iiOrd),j=1,nOsc),' /',(nInc(j,iiOrd),j=1,nOsc),' /',(nDec(j,iiOrd),j=1,nOsc)
    !call XFlush(u6)
    kOsc_start = nOsc
    do while ((nMat(kOsc_start,iiOrd) == 0) .and. (kOsc_start > 1))
      kOsc_start = kOsc_start-1
    end do
    do kOsc=kOsc_start,nOsc
      do lOsc=1,nOsc
        !write(u6,*) 'iOrd,kOsc_start,kOsc,lOsc==',iOrd,kOsc_start,kOsc,lOsc
        !call XFlush(u6)
        if (nMat(lOsc,iiOrd) > 0) then
          U(nInc(kOsc,iiOrd),0) = U(nInc(kOsc,iiOrd),0)+sqr(nMat(lOsc,iiOrd))*A2B2T(kOsc,lOsc)*U(nDec(lOsc,iiOrd),0)
          !write(u6,*) iOrd,' U(',nInc(kOsc,iiOrd),')=',U(nInc(kOsc,iiOrd),0)
          !call XFlush(u6)
        end if
      end do
      !write(u6,*) iOrd,' jOrd=',nInc(kOsc,iiOrd)
      jOrd = nInc(kOsc,iiOrd)
      jjOrd = jOrd-(iBatch-1)*lBatch+1
      if ((jjOrd < 1) .or. (jjOrd > lBatch)) then
        iIndex0 = nnTabDim(jOrd)
        call iDaFile(lNMAT0,2,nMat0,nOsc,iIndex0)
        !write(u6,*) jOrd,' read at',nnTabDim(jOrd),'  M:',(nMat0(j),j=1,nOsc),'  jjOrd=',jjOrd
        kDelta = nMat0(kOsc)
      else
        !GGn kDelta = nMat(kOsc,nInc(kOsc,iiOrd)+1)
        kDelta = nMat(kOsc,jjOrd)
      end if
      !Write(u6,*) '         ',iOrd,' >',kDelta
      !Write(u6,*) iOrd,' jOrd=',jOrd  ,'  kDelta=',kDelta
      U(nInc(kOsc,iiOrd),0) = (U(nInc(kOsc,iiOrd),0)+d2(kOsc)*U(iOrd,0))/sqr(kDelta) ! nMat(kOsc,nInc(kOsc,iiOrd)))
    end do
  end do
end if

! Use recursion formula to obtain the rest of U.
!write(u6,*) '            Use recursion ... rest of U.'
!write(u6,*) '            max_nOrd2=',max_nOrd2
!call XFlush(u6)
!!do jOrd=1,max_nOrd2
!!  lOsc = nOsc
!!  do while ((nMat(jOrd,lOsc) == 0) .and. (lOsc > 1))
!!    lOsc = lOsc-1
!!  end do
!!  do iOrd=0,max_nOrd
!!    do kOsc=1,nOsc
!!      if (nMat(iOrd,kOsc) > 0) then
!!        !write(u6,*) '              ',iOrd,kOsc,nMat(iOrd,kOsc)
!!        U(iOrd,jOrd) = U(iOrd,jOrd)+sqr(nMat(iOrd,kOsc))/sqr(nMat(jOrd,lOsc))*A2(kOsc,lOsc)*U(nDec(iOrd,kOsc),nDec(jOrd,lOsc))
!!      end if
!!    end do
!!  end do
!!end do

call mma_deallocate(A2)
call mma_deallocate(B2)
call mma_deallocate(d2)
call mma_deallocate(A2B2T)

! Calculate Franck-Condon factors.
if (iPrint >= 3) then
  write(u6,*) ' Franck-Condon factors for States in the Window:'
  write(u6,'(a,36a)') '  ',('=',i=1,36)
  write(u6,*) '     #     jOrd   FC factor     jSum'
  write(u6,'(a,36a)') '  ',('-',i=1,36)
end if
do ii=1,nYes
  jOrd = VibWind2(ii)
  dFC = FC00*L(0,0)*U(jOrd,0)
  FCWind2(ii) = dFC
  if (iPrint >= 3) then
    loc_n_max = 0
    kIndex = nnTabDim(jOrd)
    call iDaFile(lNMAT0,2,nMat0,nOsc,kIndex)
    do j=1,nOsc
      loc_n_max = loc_n_max+nMat0(j)
    end do
    write(u6,'(a2,i5,i9,e15.6,a2,i4)') ' ',ii,jOrd,FCWind2(ii),' ',loc_n_max
  end if
end do
if (iPrint >= 3) then
  write(u6,'(a,36a)') '  ',('-',i=1,36)
  write(u6,*) ' FC_00 =',FC00
  write(u6,*)
end if

if (iPrint >= 4) then
  write(u6,*)
  write(u6,*) ' Full Franck-Condon factors (FC_00=',FC00,'):'
  write(u6,*) ' =================================================='
  write(u6,*) '    jOrd   FC            level'
  write(u6,*) ' --------------------------------------------------'
  do jOrd=0,max_nInc ! max_nOrd
    loc_n_max = 0
    kIndex = nnTabDim(jOrd)
    call iDaFile(lNMAT0,2,nMat0,nOsc,kIndex)
    do j=1,nOsc
      loc_n_max = loc_n_max+nMat0(j)
    end do
    dFC = FC00*L(0,0)*U(jOrd,0)
    write(u6,'(a,i8,e15.6,a2,i4,a2,24i3)') ' ',jOrd,dFC,' ',loc_n_max,' ',(nMat0(j),j=1,nOsc)
  end do
  write(u6,*) ' --------------------------------------------------'
end if

call mma_deallocate(r_temp1)
call mma_deallocate(r_temp2)
call mma_deallocate(Alpha)
call mma_deallocate(sqr)
call mma_deallocate(temp)
call mma_deallocate(temp1)
call mma_deallocate(temp2)
call mma_deallocate(L)
call mma_deallocate(U)
call mma_deallocate(nMat0)

!write(u6,*) 'CGGt[FCVal] Exit'
!call XFlush(u6)

end subroutine ISCD_FCval

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Naoki Nakatani                                   *
************************************************************************
      SUBROUTINE TWO2ONERDM_BIS(NA,NE,G2,G1)
      IMPLICIT REAL*8 (A-H,O-Z)
* Compute 1-RDM from 2-RDM
* Written by N. Nakatani, Oct. 2014
      DIMENSION G2(NA,NA,NA,NA), G1(NA,NA)

      Do I=1,NA
        Do J=1,NA
          G1TMP=0.0D0
          Do K=1,NA
            G1TMP=G1TMP+G2(K,K,J,I)
          End Do
          G1(J,I)=G1TMP/(NE-1)
        End Do
      End Do

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_mkK()
! make K(be,u,i,a)

use chcc_global, only: Kc, no, nv, Q1, Q21, Q22, Q3, T1c, T2c
use stdalloc, only: mma_allocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: a, b, be, i, j, u
real(kind=wp) :: s

call mma_allocate(Kc,no,nv,no,nv,label='Kc')

do a=1,nv
  do i=1,no
    do u=1,no
      do be=1,nv

        s = Zero

        s = s+Q22(be,a,i,u)

        do j=1,no
          s = s-Q1(a,j,i,u)*T1c(be,j)
        end do

        do b=1,nv
          s = s+Q3(a,be,b,i)*T1c(b,u)
        end do

        do j=1,no
          do b=1,nv
            s = s-Q21(b,i,a,j)*(T2c(b,be,u,j)*Half+T1c(b,u)*T1c(be,j))
          end do
        end do

        Kc(i,be,u,a) = s

      end do
    end do
  end do
end do

write(u6,*) ' K done '

return

end subroutine Chck_mkK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! like cdafile, but for single-byte integers

subroutine i1DaFile(Lu,iOpt,Buf,lBuf_,iDisk_)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Fast_IO, only: MBL
use Definitions, only: iwp, byte

implicit none
integer(kind=iwp), intent(in) :: Lu, iOpt, lBuf_
integer(kind=byte), intent(inout) :: Buf(lBuf_)
integer(kind=iwp), intent(inout) :: iDisk_
integer(kind=iwp) :: lBuf, iDisk

call i1DaFile_Internal(Buf)

! This is to allow type punning without an explicit interface
contains

subroutine i1DaFile_Internal(Buf)

  integer(kind=byte), target, intent(inout) :: Buf(lBuf_)
  character, pointer :: cBuf(:)

  lBuf = lBuf_
  iDisk = iDisk_*MBL(Lu)

  call c_f_pointer(c_loc(Buf(1)),cBuf,[lBuf_])
  call bDaFile(Lu,iOpt,cBuf,lBuf,iDisk)
  nullify(cBuf)

  iDisk_ = (iDisk+MBL(Lu)-1)/MBL(Lu)

  return

end subroutine i1DaFile_Internal

end subroutine i1DaFile

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1994, Jeppe Olsen                                 *
!***********************************************************************

subroutine CIDIA4(NAEL,IASTR,NBEL,IBSTR,NORB,DIAG,NSM,H,ISM,IBLTP,XB,RJ,RK,NSSOA,NSSOB,IOCOC,NOCTPA,NOCTPB,ISSOA,ISSOB,LUDIA, &
                  ECORE,PSSIGN,NTOOB,ICISTR)
! Calculate determinant diagonal
! Turbo-ras version
!
! ========================
! General symmetry version
! ========================
!
! Jeppe Olsen, Winter of 1991
! K => J - K moved outside, April 1994

use Symmetry_Info, only: Mul
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NAEL, IASTR(NAEL,*), NBEL, IBSTR(NBEL,*), NORB, NSM, ISM, IBLTP(*), NOCTPA, NSSOA(NOCTPA,*), &
                                 NOCTPB, NSSOB(NOCTPB,*), IOCOC(NOCTPA,NOCTPB), ISSOA(NOCTPA,*), ISSOB(NOCTPB,*), LUDIA, NTOOB, &
                                 ICISTR
real(kind=wp), intent(_OUT_) :: DIAG(*)
real(kind=wp), intent(in) :: H(NORB), RJ(NTOOB,NTOOB), RK(NTOOB,NTOOB), ECORE, PSSIGN
real(kind=wp), intent(out) :: XB(NORB)
integer(kind=iwp) :: IA, IAEL, IASM, IASTOP, IASTRT, IATP, IB, IBEL, IBREL, IBSM, IBSTOP, IBSTRT, IBTP, IDET, IDUM(1), IEL, &
                     IREST1, ITDET, JEL, MXBTP
real(kind=wp) :: EB, HB, RJBB, X1, X2, XADD

if (PSSIGN == -One) then
  XADD = 1.0e6_wp
else
  XADD = Zero
end if

!*3 Diagonal elements according to Handys formulae
!   (corrected for error)
!
!   DIAG(IDET) = HII*(NIA+NIB)
!              + 0.5 * ( J(I,J)-K(I,J) ) * NIA*NJA
!              + 0.5 * ( J(I,J)-K(I,J) ) * NIB*NJB
!              +         J(I,J) * NIA*NJB

! K goes to J - K

IDET = 0
ITDET = 0
if (LUDIA /= 0) rewind(LUDIA)
do IASM=1,NSM
  IBSM = Mul(IASM,ISM)
  if ((IBSM == 0) .or. (IBLTP(IASM) == 0)) cycle
  if (IBLTP(IASM) == 2) then
    IREST1 = 1
  else
    IREST1 = 0
  end if

  do IATP=1,NOCTPA
    if (IREST1 == 1) then
      MXBTP = IATP
    else
      MXBTP = NOCTPB
    end if
    do IBTP=1,MXBTP
      if (IOCOC(IATP,IBTP) == 0) cycle
      IBSTRT = ISSOB(IBTP,IBSM)
      IBSTOP = IBSTRT+NSSOB(IBTP,IBSM)-1
      do IB=IBSTRT,IBSTOP
        IBREL = IB-IBSTRT+1

        ! Terms depending only on IB

        XB(:) = Zero
        HB = Zero
        RJBB = Zero

        do IEL=1,NBEL
          IBEL = IBSTR(IEL,IB)
          HB = HB+H(IBEL)

          do JEL=1,NBEL
            RJBB = RJBB+RK(IBSTR(JEL,IB),IBEL)
          end do

          XB(:) = XB(:)+RJ(1:NORB,IBEL)
        end do
        EB = HB+Half*RJBB+ECORE

        if ((IREST1 == 1) .and. (IATP == IBTP)) then
          IASTRT = ISSOA(IATP,IASM)-1+IBREL
        else
          IASTRT = ISSOA(IATP,IASM)
        end if
        IASTOP = ISSOA(IATP,IASM)+NSSOA(IATP,IASM)-1
        do IA=IASTRT,IASTOP
          IDET = IDET+1
          ITDET = ITDET+1
          X1 = EB
          X2 = Zero
          do IEL=1,NAEL
            IAEL = IASTR(IEL,IA)
            X1 = X1+(H(IAEL)+XB(IAEL))
            do JEL=1,NAEL
              X2 = X2+RK(IASTR(JEL,IA),IAEL)
            end do
          end do
          DIAG(IDET) = X1+Half*X2
          if (IB == IA) DIAG(IDET) = DIAG(IDET)+XADD
        end do
      end do
      ! Yet a RAS block of the diagonal has been constructed
      if (ICISTR >= 2) then
        IDUM(1) = IDET
        call ITODS(IDUM,1,-1,LUDIA)
        call TODSC_MCLR(DIAG,IDET,-1,LUDIA)
        IDET = 0
      end if
    end do
  end do

end do

if (ICISTR >= 2) then
  IDUM(1) = -1
  call ITODS(IDUM,1,-1,LUDIA)
end if

end subroutine CIDIA4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Tra2A(ij_pair,ij_Bas_pairs,kl_Orb_pairs,
     &                 kSym,lSym,
     &                 kBas,lBas,
     &                 kAsh,lAsh,
     &                 CMO_k,CMO_l,
     &                 IJKL,IJKX,IJVX,VXIJ)
************************************************************************
*                                                                      *
*     run the first two quarter AO --> MO transformations with         *
*     both transformed indices being active, i.e.                      *
*     (ij!kl) --> (ij!vx)                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 CMO_k(kBas,kAsh),  CMO_l(lBas,lAsh),
     &       IJKL(lBas*kBas), IJKX(kBas*lAsh),
     &       IJVX(lAsh*kAsh), VXIJ(ij_bas_pairs,kl_Orb_pairs)
*
*
*     (ij|kl) -> (ij|kx)
      Call DGEMM_('T','N',
     &            kBas,lAsh,lBas,
     &            1.0d0,IJKL,lBas,
     &            CMO_l,lBas,
     &            0.0d0,IJKX,kBas)
*
*     (ij|kx) -> (ij|vx)
      If ( kSym.eq.lSym ) then
*------ Triangular storage of target
        Call MxMt(IJKX,kBas,1,
     &            CMO_k,1,kBas,
     &            IJVX,kAsh,kBas)
      Else
*------ Rectangular storage of target
        Call DGEMM_('T','N',
     &              lAsh,kAsh,kBas,
     &              1.0d0,IJKX,kBas,
     &              CMO_k,kBas,
     &              0.0d0,IJVX,lAsh)
      End If
*
*     Scatter result onto half-transformed integral
*     list
      Do kl = 1,kl_Orb_pairs
        VXIJ(ij_pair,kl) = IJVX(kl)
      End Do
*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DispEnergy(EEDisp,BoMaH,BoMaO,dAtO1,dAtH1,dAtH2,Rab13i,Rab23i,Rab33i,indQAt)

use qmstat_global, only: DispDamp, uDisp
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: EEDisp
real(kind=wp), intent(in) :: BoMaH, BoMaO, dAtO1, dAtH1, dAtH2, Rab13i, Rab23i, Rab33i
integer(kind=iwp), intent(in) :: indQAt
integer(kind=iwp) :: k, kFac
real(kind=wp) :: BM(3), DampBarn(3), EfromH1, EfromH2, EfromO1

! If not damping, set factors to 1.0

DampBarn(:) = One

if (DispDamp) then

  ! If Damping, do it, otherwise easy stuff

  ! Get the damping, for the relevant QM-atom with all solvent atoms.
  BM(1) = BoMaH*dAtH1
  BM(2) = BoMaH*dAtH2
  BM(3) = BoMaO*dAtO1

  kFac = 1
  do k=1,6
    kFac = kFac*k
    DampBarn(:) = DampBarn(:)+BM(:)**k/real(kFac,kind=wp)
  end do
  DampBarn(:) = One-DampBarn(:)*exp(-BM(:))

end if

! Now evaluate the Dispersion energy.

EfromH1 = Rab23i**2*DampBarn(1)*uDisp(2,indQAt)
EfromH2 = Rab33i**2*DampBarn(2)*uDisp(2,indQAt)
EfromO1 = Rab13i**2*DampBarn(3)*uDisp(1,indQAt)

EEDisp = EEdisp+EfromO1+EfromH1+EfromH2

return

end subroutine DispEnergy

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
!EB      Subroutine Get_OrbCen(nPrim,nBas,NORBI,Q_MltPl,RCHC,
      Subroutine Get_OrbCen(nPrim,NORBI,Q_MltPl,RCHC,
     &CENTX,CENTY,CENTZ,OCOF)
      Implicit Real*8 (a-h,o-z)


      Dimension RCPO(3,NORBI), RCMI(3,NORBI)
      Dimension CENTX(nPrim*(nPrim+1)/2)
      Dimension CENTY(nPrim*(nPrim+1)/2)
      Dimension CENTZ(nPrim*(nPrim+1)/2)
      Dimension Q_MltPl(nPrim*(nPrim+1)/2)
      Dimension RCHC(3,NORBI)
      Dimension oCof(NORBI,nPrim)

C
C CALCULATE A CENTER OF CHARGE FOR EACH MOLECULAR ORBITAL
C
      Do I=1,NORBI
         RCPO(1,I) = 0.0
         RCPO(2,I) = 0.0
         RCPO(3,I) = 0.0
         RCMI(1,I) = 0.0
         RCMI(2,I) = 0.0
         RCMI(3,I) = 0.0
         QPOS = 0.0
         QMIN = 0.0
         Do J=1,nPrim
            Do K=1,J
C
C THE WEIGHTED AVERAGE OF THE POSITIVE AND NEGATIVE CONTRIBUTIONS
C
               OOQ = OCOF(I,J)*OCOF(I,K)*Q_MltPl(J*(J-1)/2+K)*2.0
               IF( OOQ .GE. 0.0 ) THEN
                  QPOS = QPOS + OOQ
                  RCPO(1,I) = RCPO(1,I) + OOQ*CENTX(J*(J-1)/2+K)
                  RCPO(2,I) = RCPO(2,I) + OOQ*CENTY(J*(J-1)/2+K)
                  RCPO(3,I) = RCPO(3,I) + OOQ*CENTZ(J*(J-1)/2+K)
               ELSE
                  QMIN = QMIN + OOQ
                  RCMI(1,I) = RCMI(1,I) + OOQ*CENTX(J*(J-1)/2+K)
                  RCMI(2,I) = RCMI(2,I) + OOQ*CENTY(J*(J-1)/2+K)
                  RCMI(3,I) = RCMI(3,I) + OOQ*CENTZ(J*(J-1)/2+K)
               ENDIF
            EndDo
            OOQ = OCOF(I,J)*OCOF(I,J)*Q_MltPl(J*(J+1)/2)
            IF( OOQ .GE. 0.0 ) THEN
               QPOS = QPOS - OOQ
               RCPO(1,I) = RCPO(1,I) - OOQ*CENTX(J*(J+1)/2)
               RCPO(2,I) = RCPO(2,I) - OOQ*CENTY(J*(J+1)/2)
               RCPO(3,I) = RCPO(3,I) - OOQ*CENTZ(J*(J+1)/2)
            ELSE
               QMIN = QMIN - OOQ
               RCMI(1,I) = RCMI(1,I) - OOQ*CENTX(J*(J+1)/2)
               RCMI(2,I) = RCMI(2,I) - OOQ*CENTY(J*(J+1)/2)
               RCMI(3,I) = RCMI(3,I) - OOQ*CENTZ(J*(J+1)/2)
            ENDIF
         EndDo
         RCHC(1,I) = (RCPO(1,I) - RCMI(1,I))/(QPOS-QMIN)
         RCHC(2,I) = (RCPO(2,I) - RCMI(2,I))/(QPOS-QMIN)
         RCHC(3,I) = (RCPO(3,I) - RCMI(3,I))/(QPOS-QMIN)
      EndDo
!EB 96   FORMAT(I5,3E15.8)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExA_X4(A,Ap,no)
! this routine does:
! Ap(i,u,v) <- A(ii,u,v)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: no
real(kind=wp), intent(in) :: A(nTri_Elem(no),no**2)
real(kind=wp), intent(out) :: Ap(no,no**2)
integer(kind=iwp) :: i, ii

do i=1,no
  ii = nTri_Elem(i)
  Ap(i,:) = A(ii,:)
end do

return

end subroutine ExA_X4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine axb2_cvb(asonc,ddres2upd,vec,
     >  resthr_inp,ioptc,iter,fx_exp,
     >  c,sxc,res,rhs,
     >  rhsp,solp,solp_res)
      implicit real*8 (a-h,o-z)
#include "direct_cvb.fh"
      external asonc,ddres2upd
      external axbsol_cvb,axbres_cvb,ddrestart_cvb
      dimension vec(nparm)
      dimension c(nparm,maxd),sxc(nparm,maxd),res(nparm),rhs(nparm)
      dimension rhsp(maxd),solp(maxd),solp_res(maxd),dum(1)

c  If RESTHR_INP unset use default:
      if(resthr_inp.ne.0d0)then
        resthr_use=resthr_inp
      else
        resthr_use=resthr
      endif
      call dirdiag_cvb(asonc,axbsol_cvb,
     >  axbres_cvb,ddres2upd,ddrestart_cvb,
     >  c,dum,sxc,.false.,vec,res,rhs,
     >  dum,rhsp,solp,solp_res,
     >  .false.,.false.,.true.,maxd,nparm,nfrdim,
     >  nvguess,nvrestart,isaddle,ifollow,mxit,
     >  resthr_use,orththr,nortiter,corenrg,
     >  ioptc,iter,fx_exp,ip)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dbdsdc(uplo,compq,n,d,e,u,ldu,vt,ldvt,q,iq,work,iwork,info)
use link_blas, only: lb_dbdsdc
use Definitions, only: BLASInt, BLASR8
implicit none
character :: compq, uplo
integer(kind=BLASInt) :: info, ldu, ldvt, n
integer(kind=BLASInt) :: iq(*), iwork(*)
real(kind=BLASR8) :: d(*), e(*), q(*), u(ldu,*), vt(ldvt,*), work(*)
call lb_dbdsdc(uplo,compq,n,d,e,u,ldu,vt,ldvt,q,iq,work,iwork,info)
end subroutine dbdsdc

subroutine dbdsqr(uplo,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,work,info)
use link_blas, only: lb_dbdsqr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, ldc, ldu, ldvt, n, ncc, ncvt, nru
real(kind=BLASR8) :: c(ldc,*), d(*), e(*), u(ldu,*), vt(ldvt,*), work(*)
call lb_dbdsqr(uplo,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,work,info)
end subroutine dbdsqr

subroutine dgebak(job,side,n,ilo,ihi,scale,m,v,ldv,info)
use link_blas, only: lb_dgebak
use Definitions, only: BLASInt, BLASR8
implicit none
character :: job, side
integer(kind=BLASInt) :: ihi, ilo, info, ldv, m, n
real(kind=BLASR8) :: scale(*), v(ldv,*)
call lb_dgebak(job,side,n,ilo,ihi,scale,m,v,ldv,info)
end subroutine dgebak

subroutine dgebal(job,n,a,lda,ilo,ihi,scale,info)
use link_blas, only: lb_dgebal
use Definitions, only: BLASInt, BLASR8
implicit none
character :: job
integer(kind=BLASInt) :: ihi, ilo, info, lda, n
real(kind=BLASR8) :: a(lda,*), scale(*)
call lb_dgebal(job,n,a,lda,ilo,ihi,scale,info)
end subroutine dgebal

subroutine dgebd2(m,n,a,lda,d,e,tauq,taup,work,info)
use link_blas, only: lb_dgebd2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, m, n
real(kind=BLASR8) :: a(lda,*), d(*), e(*), taup(*), tauq(*), work(*)
call lb_dgebd2(m,n,a,lda,d,e,tauq,taup,work,info)
end subroutine dgebd2

subroutine dgebrd(m,n,a,lda,d,e,tauq,taup,work,lwork,info)
use link_blas, only: lb_dgebrd
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, lwork, m, n
real(kind=BLASR8) :: a(lda,*), d(*), e(*), taup(*), tauq(*), work(*)
call lb_dgebrd(m,n,a,lda,d,e,tauq,taup,work,lwork,info)
end subroutine dgebrd

subroutine dgecon(norm,n,a,lda,anorm,rcond,work,iwork,info)
use link_blas, only: lb_dgecon
use Definitions, only: BLASInt, BLASR8
implicit none
character :: norm
integer(kind=BLASInt) :: info, lda, n
real(kind=BLASR8) :: anorm, rcond
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: a(lda,*), work(*)
call lb_dgecon(norm,n,a,lda,anorm,rcond,work,iwork,info)
end subroutine dgecon

subroutine dgees(jobvs,sort,select,n,a,lda,sdim,wr,wi,vs,ldvs,work,lwork,bwork,info)
use link_blas, only: lb_dgees
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobvs, sort
integer(kind=BLASInt) :: info, lda, ldvs, lwork, n, sdim
logical :: bwork(*)
real(kind=BLASR8) :: a(lda,*), vs(ldvs,*), wi(*), work(*), wr(*)
logical, external :: select
call lb_dgees(jobvs,sort,select,n,a,lda,sdim,wr,wi,vs,ldvs,work,lwork,bwork,info)
end subroutine dgees

subroutine dgeev(jobvl,jobvr,n,a,lda,wr,wi,vl,ldvl,vr,ldvr,work,lwork,info)
use link_blas, only: lb_dgeev
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobvl, jobvr
integer(kind=BLASInt) :: info, lda, ldvl, ldvr, lwork, n
real(kind=BLASR8) :: a(lda,*), vl(ldvl,*), vr(ldvr,*), wi(*), work(*), wr(*)
call lb_dgeev(jobvl,jobvr,n,a,lda,wr,wi,vl,ldvl,vr,ldvr,work,lwork,info)
end subroutine dgeev

subroutine dgehd2(n,ilo,ihi,a,lda,tau,work,info)
use link_blas, only: lb_dgehd2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihi, ilo, info, lda, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dgehd2(n,ilo,ihi,a,lda,tau,work,info)
end subroutine dgehd2

subroutine dgehrd(n,ilo,ihi,a,lda,tau,work,lwork,info)
use link_blas, only: lb_dgehrd
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihi, ilo, info, lda, lwork, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dgehrd(n,ilo,ihi,a,lda,tau,work,lwork,info)
end subroutine dgehrd

subroutine dgelq2(m,n,a,lda,tau,work,info)
use link_blas, only: lb_dgelq2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dgelq2(m,n,a,lda,tau,work,info)
end subroutine dgelq2

subroutine dgelqf(m,n,a,lda,tau,work,lwork,info)
use link_blas, only: lb_dgelqf
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, lwork, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dgelqf(m,n,a,lda,tau,work,lwork,info)
end subroutine dgelqf

subroutine dgels(trans,m,n,nrhs,a,lda,b,ldb,work,lwork,info)
use link_blas, only: lb_dgels
use Definitions, only: BLASInt, BLASR8
implicit none
character :: trans
integer(kind=BLASInt) :: info, lda, ldb, lwork, m, n, nrhs
real(kind=BLASR8) :: a(lda,*), b(ldb,*), work(*)
call lb_dgels(trans,m,n,nrhs,a,lda,b,ldb,work,lwork,info)
end subroutine dgels

subroutine dgeqr2(m,n,a,lda,tau,work,info)
use link_blas, only: lb_dgeqr2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dgeqr2(m,n,a,lda,tau,work,info)
end subroutine dgeqr2

subroutine dgeqrf(m,n,a,lda,tau,work,lwork,info)
use link_blas, only: lb_dgeqrf
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, lwork, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dgeqrf(m,n,a,lda,tau,work,lwork,info)
end subroutine dgeqrf

subroutine dgesdd(jobz,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,iwork,info)
use link_blas, only: lb_dgesdd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz
integer(kind=BLASInt) :: info, lda, ldu, ldvt, lwork, m, n
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: a(lda,*), s(*), u(ldu,*), vt(ldvt,*), work(*)
call lb_dgesdd(jobz,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,iwork,info)
end subroutine dgesdd

subroutine dgesv(n,nrhs,a,lda,ipiv,b,ldb,info)
use link_blas, only: lb_dgesv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, ldb, n, nrhs
integer(kind=BLASInt) :: ipiv(*)
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dgesv(n,nrhs,a,lda,ipiv,b,ldb,info)
end subroutine dgesv

subroutine dgesvd(jobu,jobvt,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,info)
use link_blas, only: lb_dgesvd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobu, jobvt
integer(kind=BLASInt) :: info, lda, ldu, ldvt, lwork, m, n
real(kind=BLASR8) :: a(lda,*), s(*), u(ldu,*), vt(ldvt,*), work(*)
call lb_dgesvd(jobu,jobvt,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,info)
end subroutine dgesvd

subroutine dgetrf(m,n,a,lda,ipiv,info)
use link_blas, only: lb_dgetrf
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, m, n
integer(kind=BLASInt) :: ipiv(*)
real(kind=BLASR8) :: a(lda,*)
call lb_dgetrf(m,n,a,lda,ipiv,info)
end subroutine dgetrf

recursive subroutine dgetrf2(m,n,a,lda,ipiv,info)
use link_blas, only: lb_dgetrf2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, m, n
integer(kind=BLASInt) :: ipiv(*)
real(kind=BLASR8) :: a(lda,*)
call lb_dgetrf2(m,n,a,lda,ipiv,info)
end subroutine dgetrf2

subroutine dgetri(n,a,lda,ipiv,work,lwork,info)
use link_blas, only: lb_dgetri
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, lwork, n
integer(kind=BLASInt) :: ipiv(*)
real(kind=BLASR8) :: a(lda,*), work(*)
call lb_dgetri(n,a,lda,ipiv,work,lwork,info)
end subroutine dgetri

subroutine dgetrs(trans,n,nrhs,a,lda,ipiv,b,ldb,info)
use link_blas, only: lb_dgetrs
use Definitions, only: BLASInt, BLASR8
implicit none
character :: trans
integer(kind=BLASInt) :: info, lda, ldb, n, nrhs
integer(kind=BLASInt) :: ipiv(*)
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dgetrs(trans,n,nrhs,a,lda,ipiv,b,ldb,info)
end subroutine dgetrs

subroutine dhseqr(job,compz,n,ilo,ihi,h,ldh,wr,wi,z,ldz,work,lwork,info)
use link_blas, only: lb_dhseqr
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihi, ilo, info, ldh, ldz, lwork, n
character :: compz, job
real(kind=BLASR8) :: h(ldh,*), wi(*), work(*), wr(*), z(ldz,*)
call lb_dhseqr(job,compz,n,ilo,ihi,h,ldh,wr,wi,z,ldz,work,lwork,info)
end subroutine dhseqr

function disnan(din)
use link_blas, only: lb_disnan
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: din
logical :: disnan
disnan = lb_disnan(din)
end function disnan

subroutine dlabad(small,large)
use link_blas, only: lb_dlabad
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: large, small
call lb_dlabad(small,large)
end subroutine dlabad

subroutine dlabrd(m,n,nb,a,lda,d,e,tauq,taup,x,ldx,y,ldy)
use link_blas, only: lb_dlabrd
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: lda, ldx, ldy, m, n, nb
real(kind=BLASR8) :: a(lda,*), d(*), e(*), taup(*), tauq(*), x(ldx,*), y(ldy,*)
call lb_dlabrd(m,n,nb,a,lda,d,e,tauq,taup,x,ldx,y,ldy)
end subroutine dlabrd

subroutine dlacn2(n,v,x,isgn,est,kase,isave)
use link_blas, only: lb_dlacn2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: kase, n
real(kind=BLASR8) :: est
integer(kind=BLASInt) :: isgn(*), isave(3)
real(kind=BLASR8) :: v(*), x(*)
call lb_dlacn2(n,v,x,isgn,est,kase,isave)
end subroutine dlacn2

subroutine dlacpy(uplo,m,n,a,lda,b,ldb)
use link_blas, only: lb_dlacpy
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: lda, ldb, m, n
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dlacpy(uplo,m,n,a,lda,b,ldb)
end subroutine dlacpy

subroutine dladiv(a,b,c,d,p,q)
use link_blas, only: lb_dladiv
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: a, b, c, d, p, q
call lb_dladiv(a,b,c,d,p,q)
end subroutine dladiv

subroutine dladiv1(a,b,c,d,p,q)
use link_blas, only: lb_dladiv1
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: a, b, c, d, p, q
call lb_dladiv1(a,b,c,d,p,q)
end subroutine dladiv1

function dladiv2(a,b,c,d,r,t)
use link_blas, only: lb_dladiv2
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: a, b, c, d, r, t
real(kind=BLASR8) :: dladiv2
dladiv2 = lb_dladiv2(a,b,c,d,r,t)
end function dladiv2

subroutine dlae2(a,b,c,rt1,rt2)
use link_blas, only: lb_dlae2
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: a, b, c, rt1, rt2
call lb_dlae2(a,b,c,rt1,rt2)
end subroutine dlae2

subroutine dlaebz(ijob,nitmax,n,mmax,minp,nbmin,abstol,reltol,pivmin,d,e,e2,nval,ab,c,mout,nab,work,iwork,info)
use link_blas, only: lb_dlaebz
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ijob, info, minp, mmax, mout, n, nbmin, nitmax
real(kind=BLASR8) :: abstol, pivmin, reltol
integer(kind=BLASInt) :: iwork(*), nab(mmax,*), nval(*)
real(kind=BLASR8) :: ab(mmax,*), c(*), d(*), e(*), e2(*), work(*)
call lb_dlaebz(ijob,nitmax,n,mmax,minp,nbmin,abstol,reltol,pivmin,d,e,e2,nval,ab,c,mout,nab,work,iwork,info)
end subroutine dlaebz

subroutine dlaed0(icompq,qsiz,n,d,e,q,ldq,qstore,ldqs,work,iwork,info)
use link_blas, only: lb_dlaed0
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: icompq, info, ldq, ldqs, n, qsiz
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: d(*), e(*), q(ldq,*), qstore(ldqs,*), work(*)
call lb_dlaed0(icompq,qsiz,n,d,e,q,ldq,qstore,ldqs,work,iwork,info)
end subroutine dlaed0

subroutine dlaed1(n,d,q,ldq,indxq,rho,cutpnt,work,iwork,info)
use link_blas, only: lb_dlaed1
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: cutpnt, info, ldq, n
real(kind=BLASR8) :: rho
integer(kind=BLASInt) :: indxq(*), iwork(*)
real(kind=BLASR8) :: d(*), q(ldq,*), work(*)
call lb_dlaed1(n,d,q,ldq,indxq,rho,cutpnt,work,iwork,info)
end subroutine dlaed1

subroutine dlaed2(k,n,n1,d,q,ldq,indxq,rho,z,dlamda,w,q2,indx,indxc,indxp,coltyp,info)
use link_blas, only: lb_dlaed2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, ldq, n, n1
real(kind=BLASR8) :: rho
integer(kind=BLASInt) :: coltyp(*), indx(*), indxc(*), indxp(*), indxq(*)
real(kind=BLASR8) :: d(*), dlamda(*), q(ldq,*), q2(*), w(*), z(*)
call lb_dlaed2(k,n,n1,d,q,ldq,indxq,rho,z,dlamda,w,q2,indx,indxc,indxp,coltyp,info)
end subroutine dlaed2

subroutine dlaed3(k,n,n1,d,q,ldq,rho,dlamda,q2,indx,ctot,w,s,info)
use link_blas, only: lb_dlaed3
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, ldq, n, n1
real(kind=BLASR8) :: rho
integer(kind=BLASInt) :: ctot(*), indx(*)
real(kind=BLASR8) :: d(*), dlamda(*), q(ldq,*), q2(*), s(*), w(*)
call lb_dlaed3(k,n,n1,d,q,ldq,rho,dlamda,q2,indx,ctot,w,s,info)
end subroutine dlaed3

subroutine dlaed4(n,i,d,z,delta,rho,dlam,info)
use link_blas, only: lb_dlaed4
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: i, info, n
real(kind=BLASR8) :: dlam, rho
real(kind=BLASR8) :: d(*), delta(*), z(*)
call lb_dlaed4(n,i,d,z,delta,rho,dlam,info)
end subroutine dlaed4

subroutine dlaed5(i,d,z,delta,rho,dlam)
use link_blas, only: lb_dlaed5
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: i
real(kind=BLASR8) :: dlam, rho
real(kind=BLASR8) :: d(2), delta(2), z(2)
call lb_dlaed5(i,d,z,delta,rho,dlam)
end subroutine dlaed5

subroutine dlaed6(kniter,orgati,rho,d,z,finit,tau,info)
use link_blas, only: lb_dlaed6
use Definitions, only: BLASInt, BLASR8
implicit none
logical :: orgati
integer(kind=BLASInt) :: info, kniter
real(kind=BLASR8) :: finit, rho, tau
real(kind=BLASR8) :: d(3), z(3)
call lb_dlaed6(kniter,orgati,rho,d,z,finit,tau,info)
end subroutine dlaed6

subroutine dlaed7(icompq,n,qsiz,tlvls,curlvl,curpbm,d,q,ldq,indxq,rho,cutpnt,qstore,qptr,prmptr,perm,givptr, &
                  givcol,givnum,work,iwork,info)
use link_blas, only: lb_dlaed7
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: curlvl, curpbm, cutpnt, icompq, info, ldq, n, qsiz, tlvls
real(kind=BLASR8) :: rho
integer(kind=BLASInt) :: givcol(2,*), givptr(*), indxq(*), iwork(*), perm(*), prmptr(*), qptr(*)
real(kind=BLASR8) :: d(*), givnum(2,*), q(ldq,*), qstore(*), work(*)
call lb_dlaed7(icompq,n,qsiz,tlvls,curlvl,curpbm,d,q,ldq,indxq,rho,cutpnt,qstore,qptr,prmptr,perm,givptr, &
               givcol,givnum,work,iwork,info)
end subroutine dlaed7

subroutine dlaed8(icompq,k,n,qsiz,d,q,ldq,indxq,rho,cutpnt,z,dlamda,q2,ldq2,w,perm,givptr,givcol,givnum,indxp, &
                  indx,info)
use link_blas, only: lb_dlaed8
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: cutpnt, givptr, icompq, info, k, ldq, ldq2, n, qsiz
real(kind=BLASR8) :: rho
integer(kind=BLASInt) :: givcol(2,*), indx(*), indxp(*), indxq(*), perm(*)
real(kind=BLASR8) :: d(*), dlamda(*), givnum(2,*), q(ldq,*), q2(ldq2,*), w(*), z(*)
call lb_dlaed8(icompq,k,n,qsiz,d,q,ldq,indxq,rho,cutpnt,z,dlamda,q2,ldq2,w,perm,givptr,givcol,givnum,indxp, &
               indx,info)
end subroutine dlaed8

subroutine dlaed9(k,kstart,kstop,n,d,q,ldq,rho,dlamda,w,s,lds,info)
use link_blas, only: lb_dlaed9
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, kstart, kstop, ldq, lds, n
real(kind=BLASR8) :: rho
real(kind=BLASR8) :: d(*), dlamda(*), q(ldq,*), s(lds,*), w(*)
call lb_dlaed9(k,kstart,kstop,n,d,q,ldq,rho,dlamda,w,s,lds,info)
end subroutine dlaed9

subroutine dlaeda(n,tlvls,curlvl,curpbm,prmptr,perm,givptr,givcol,givnum,q,qptr,z,ztemp,info)
use link_blas, only: lb_dlaeda
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: curlvl, curpbm, info, n, tlvls
integer(kind=BLASInt) :: givcol(2,*), givptr(*), perm(*), prmptr(*), qptr(*)
real(kind=BLASR8) :: givnum(2,*), q(*), z(*), ztemp(*)
call lb_dlaeda(n,tlvls,curlvl,curpbm,prmptr,perm,givptr,givcol,givnum,q,qptr,z,ztemp,info)
end subroutine dlaeda

subroutine dlaev2(a,b,c,rt1,rt2,cs1,sn1)
use link_blas, only: lb_dlaev2
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: a, b, c, cs1, rt1, rt2, sn1
call lb_dlaev2(a,b,c,rt1,rt2,cs1,sn1)
end subroutine dlaev2

subroutine dlaexc(wantq,n,t,ldt,q,ldq,j1,n1,n2,work,info)
use link_blas, only: lb_dlaexc
use Definitions, only: BLASInt, BLASR8
implicit none
logical :: wantq
integer(kind=BLASInt) :: info, j1, ldq, ldt, n, n1, n2
real(kind=BLASR8) :: q(ldq,*), t(ldt,*), work(*)
call lb_dlaexc(wantq,n,t,ldt,q,ldq,j1,n1,n2,work,info)
end subroutine dlaexc

subroutine dlagtf(n,a,lambda,b,c,tol,d,in,info)
use link_blas, only: lb_dlagtf
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, n
real(kind=BLASR8) :: lambda, tol
integer(kind=BLASInt) :: in(*)
real(kind=BLASR8) :: a(*), b(*), c(*), d(*)
call lb_dlagtf(n,a,lambda,b,c,tol,d,in,info)
end subroutine dlagtf

subroutine dlagts(job,n,a,b,c,d,in,y,tol,info)
use link_blas, only: lb_dlagts
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, job, n
real(kind=BLASR8) :: tol
integer(kind=BLASInt) :: in(*)
real(kind=BLASR8) :: a(*), b(*), c(*), d(*), y(*)
call lb_dlagts(job,n,a,b,c,d,in,y,tol,info)
end subroutine dlagts

subroutine dlahqr(wantt,wantz,n,ilo,ihi,h,ldh,wr,wi,iloz,ihiz,z,ldz,info)
use link_blas, only: lb_dlahqr
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihi, ihiz, ilo, iloz, info, ldh, ldz, n
logical :: wantt, wantz
real(kind=BLASR8) :: h(ldh,*), wi(*), wr(*), z(ldz,*)
call lb_dlahqr(wantt,wantz,n,ilo,ihi,h,ldh,wr,wi,iloz,ihiz,z,ldz,info)
end subroutine dlahqr

subroutine dlahr2(n,k,nb,a,lda,tau,t,ldt,y,ldy)
use link_blas, only: lb_dlahr2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: k, lda, ldt, ldy, n, nb
real(kind=BLASR8) :: a(lda,*), t(ldt,nb), tau(nb), y(ldy,nb)
call lb_dlahr2(n,k,nb,a,lda,tau,t,ldt,y,ldy)
end subroutine dlahr2

function dlaisnan(din1,din2)
use link_blas, only: lb_dlaisnan
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: din1, din2
logical :: dlaisnan
dlaisnan = lb_dlaisnan(din1,din2)
end function dlaisnan

subroutine dlaln2(ltrans,na,nw,smin,ca,a,lda,d1,d2,b,ldb,wr,wi,x,ldx,scale,xnorm,info)
use link_blas, only: lb_dlaln2
use Definitions, only: BLASInt, BLASR8
implicit none
logical :: ltrans
integer(kind=BLASInt) :: info, lda, ldb, ldx, na, nw
real(kind=BLASR8) :: ca, d1, d2, scale, smin, wi, wr, xnorm
real(kind=BLASR8) :: a(lda,*), b(ldb,*), x(ldx,*)
call lb_dlaln2(ltrans,na,nw,smin,ca,a,lda,d1,d2,b,ldb,wr,wi,x,ldx,scale,xnorm,info)
end subroutine dlaln2

function dlamc3(a,b)
use link_blas, only: lb_dlamc3
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: A, B
real(kind=BLASR8) :: dlamc3
dlamc3 = lb_dlamc3(a,b)
end function dlamc3

function dlamch(cmach)
use link_blas, only: lb_dlamch
use Definitions, only: BLASR8
implicit none
character :: cmach
real(kind=BLASR8) :: dlamch
dlamch = lb_dlamch(cmach)
end function dlamch

subroutine dlamrg(n1,n2,a,dtrd1,dtrd2,index)
use link_blas, only: lb_dlamrg
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: dtrd1, dtrd2, n1, n2
integer(kind=BLASInt) :: index(*)
real(kind=BLASR8) :: a(*)
call lb_dlamrg(n1,n2,a,dtrd1,dtrd2,index)
end subroutine dlamrg

function dlaneg(n,d,lld,sigma,pivmin,r)
use link_blas, only: lb_dlaneg
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: n, r
real(kind=BLASR8) :: pivmin, sigma
real(kind=BLASR8) :: d(*), lld(*)
integer(kind=BLASInt) :: dlaneg
dlaneg = lb_dlaneg(n,d,lld,sigma,pivmin,r)
end function dlaneg

function dlange(norm,m,n,a,lda,work)
use link_blas, only: lb_dlange
use Definitions, only: BLASInt, BLASR8
implicit none
character :: norm
integer(kind=BLASInt) :: lda, m, n
real(kind=BLASR8) :: a(lda,*), work(*)
real(kind=BLASR8) :: dlange
dlange = lb_dlange(norm,m,n,a,lda,work)
end function dlange

function dlansp(norm,uplo,n,ap,work)
use link_blas, only: lb_dlansp
use Definitions, only: BLASInt, BLASR8
implicit none
character :: norm, uplo
integer(kind=BLASInt) :: n
real(kind=BLASR8) :: ap(*), work(*)
real(kind=BLASR8) :: dlansp
dlansp = lb_dlansp(norm,uplo,n,ap,work)
end function dlansp

function dlanst(norm,n,d,e)
use link_blas, only: lb_dlanst
use Definitions, only: BLASInt, BLASR8
implicit none
character :: norm
integer(kind=BLASInt) :: n
real(kind=BLASR8) :: d(*), e(*)
real(kind=BLASR8) :: dlanst
dlanst = lb_dlanst(norm,n,d,e)
end function dlanst

function dlansy(norm,uplo,n,a,lda,work)
use link_blas, only: lb_dlansy
use Definitions, only: BLASInt, BLASR8
implicit none
character :: norm, uplo
integer(kind=BLASInt) :: lda, n
real(kind=BLASR8) :: a(lda,*), work(*)
real(kind=BLASR8) :: dlansy
dlansy = lb_dlansy(norm,uplo,n,a,lda,work)
end function dlansy

subroutine dlanv2(a,b,c,d,rt1r,rt1i,rt2r,rt2i,cs,sn)
use link_blas, only: lb_dlanv2
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: a, b, c, cs, d, rt1i, rt1r, rt2i, rt2r, sn
call lb_dlanv2(a,b,c,d,rt1r,rt1i,rt2r,rt2i,cs,sn)
end subroutine dlanv2

function dlapy2(x,y)
use link_blas, only: lb_dlapy2
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: x, y
real(kind=BLASR8) :: dlapy2
dlapy2 = lb_dlapy2(x,y)
end function dlapy2

function dlapy3(x,y,z)
use link_blas, only: lb_dlapy3
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: x, y, z
real(kind=BLASR8) :: dlapy3
dlapy3 = lb_dlapy3(x,y,z)
end function dlapy3

subroutine dlaqr0(wantt,wantz,n,ilo,ihi,h,ldh,wr,wi,iloz,ihiz,z,ldz,work,lwork,info)
use link_blas, only: lb_dlaqr0
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihi, ihiz, ilo, iloz, info, ldh, ldz, lwork, n
logical :: wantt, wantz
real(kind=BLASR8) :: h(ldh,*), wi(*), work(*), wr(*), z(ldz,*)
call lb_dlaqr0(wantt,wantz,n,ilo,ihi,h,ldh,wr,wi,iloz,ihiz,z,ldz,work,lwork,info)
end subroutine dlaqr0

subroutine dlaqr1(n,h,ldh,sr1,si1,sr2,si2,v)
use link_blas, only: lb_dlaqr1
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: si1, si2, sr1, sr2
integer(kind=BLASInt) :: ldh, n
real(kind=BLASR8) :: h(ldh,*), v(*)
call lb_dlaqr1(n,h,ldh,sr1,si1,sr2,si2,v)
end subroutine dlaqr1

subroutine dlaqr2(wantt,wantz,n,ktop,kbot,nw,h,ldh,iloz,ihiz,z,ldz,ns,nd,sr,si,v,ldv,nh,t,ldt,nv,wv,ldwv, &
                  work,lwork)
use link_blas, only: lb_dlaqr2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihiz, iloz, kbot, ktop, ldh, ldt, ldv, ldwv, ldz, lwork, n, nd, nh, ns, nv, nw
logical :: wantt, wantz
real(kind=BLASR8) :: h(ldh,*), si(*), sr(*), t(ldt,*), v(ldv,*), work(*), wv(ldwv,*), z(ldz,*)
call lb_dlaqr2(wantt,wantz,n,ktop,kbot,nw,h,ldh,iloz,ihiz,z,ldz,ns,nd,sr,si,v,ldv,nh,t,ldt,nv,wv,ldwv, &
               work,lwork)
end subroutine dlaqr2

subroutine dlaqr3(wantt,wantz,n,ktop,kbot,nw,h,ldh,iloz,ihiz,z,ldz,ns,nd,sr,si,v,ldv,nh,t,ldt,nv,wv,ldwv, &
                  work,lwork)
use link_blas, only: lb_dlaqr3
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihiz, iloz, kbot, ktop, ldh, ldt, ldv, ldwv, ldz, lwork, n, nd, nh, ns, nv, nw
logical :: wantt, wantz
real(kind=BLASR8) :: h(ldh,*), si(*), sr(*), t(ldt,*), v(ldv,*), work(*), wv(ldwv,*), z(ldz,*)
call lb_dlaqr3(wantt,wantz,n,ktop,kbot,nw,h,ldh,iloz,ihiz,z,ldz,ns,nd,sr,si,v,ldv,nh,t,ldt,nv,wv,ldwv, &
               work,lwork)
end subroutine dlaqr3

subroutine dlaqr4(wantt,wantz,n,ilo,ihi,h,ldh,wr,wi,iloz,ihiz,z,ldz,work,lwork,info)
use link_blas, only: lb_dlaqr4
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihi, ihiz, ilo, iloz, info, ldh, ldz, lwork, n
logical :: wantt, wantz
real(kind=BLASR8) :: h(ldh,*), wi(*), work(*), wr(*), z(ldz,*)
call lb_dlaqr4(wantt,wantz,n,ilo,ihi,h,ldh,wr,wi,iloz,ihiz,z,ldz,work,lwork,info)
end subroutine dlaqr4

subroutine dlaqr5(wantt,wantz,kacc22,n,ktop,kbot,nshfts,sr,si,h,ldh,iloz,ihiz,z,ldz,v,ldv,u,ldu,nv,wv,ldwv, &
                  nh,wh,ldwh)
use link_blas, only: lb_dlaqr5
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihiz, iloz, kacc22, kbot, ktop, ldh, ldu, ldv, ldwh, ldwv, ldz, n, nh, nshfts, nv
logical :: wantt, wantz
real(kind=BLASR8) :: h(ldh,*), si(*), sr(*), u(ldu,*), v(ldv,*), wh(ldwh,*), wv(ldwv,*), z(ldz,*)
call lb_dlaqr5(wantt,wantz,kacc22,n,ktop,kbot,nshfts,sr,si,h,ldh,iloz,ihiz,z,ldz,v,ldv,u,ldu,nv,wv,ldwv, &
               nh,wh,ldwh)
end subroutine dlaqr5

subroutine dlar1v(n,b1,bn,lambda,d,l,ld,lld,pivmin,gaptol,z,wantnc,negcnt,ztz,mingma,r,isuppz,nrminv,resid, &
                  rqcorr,work)
use link_blas, only: lb_dlar1v
use Definitions, only: BLASInt, BLASR8
implicit none
logical :: wantnc
integer(kind=BLASInt) :: b1, bn, n, negcnt, r
real(kind=BLASR8) :: gaptol, lambda, mingma, nrminv, pivmin, resid, rqcorr, ztz
integer(kind=BLASInt) :: isuppz(*)
real(kind=BLASR8) :: d(*), l(*), ld(*), lld(*), work(*)
real(kind=BLASR8) :: z(*)
call lb_dlar1v(n,b1,bn,lambda,d,l,ld,lld,pivmin,gaptol,z,wantnc,negcnt,ztz,mingma,r,isuppz,nrminv,resid, &
               rqcorr,work)
end subroutine dlar1v

subroutine dlarf(side,m,n,v,incv,tau,c,ldc,work)
use link_blas, only: lb_dlarf
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side
integer(kind=BLASInt) :: incv, ldc, m, n
real(kind=BLASR8) :: tau
real(kind=BLASR8) :: c(ldc,*), v(*), work(*)
call lb_dlarf(side,m,n,v,incv,tau,c,ldc,work)
end subroutine dlarf

subroutine dlarfb(side,trans,direct,storev,m,n,k,v,ldv,t,ldt,c,ldc,work,ldwork)
use link_blas, only: lb_dlarfb
use Definitions, only: BLASInt, BLASR8
implicit none
character :: direct, side, storev, trans
integer(kind=BLASInt) :: k, ldc, ldt, ldv, ldwork, m, n
real(kind=BLASR8) :: c(ldc,*), t(ldt,*), v(ldv,*), work(ldwork,*)
call lb_dlarfb(side,trans,direct,storev,m,n,k,v,ldv,t,ldt,c,ldc,work,ldwork)
end subroutine dlarfb

subroutine dlarfg(n,alpha,x,incx,tau)
use link_blas, only: lb_dlarfg
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
real(kind=BLASR8) :: alpha, tau
real(kind=BLASR8) :: x(*)
call lb_dlarfg(n,alpha,x,incx,tau)
end subroutine dlarfg

subroutine dlarft(direct,storev,n,k,v,ldv,tau,t,ldt)
use link_blas, only: lb_dlarft
use Definitions, only: BLASInt, BLASR8
implicit none
character :: direct, storev
integer(kind=BLASInt) :: k, ldt, ldv, n
real(kind=BLASR8) :: t(ldt,*), tau(*), v(ldv,*)
call lb_dlarft(direct,storev,n,k,v,ldv,tau,t,ldt)
end subroutine dlarft

subroutine dlarfx(side,m,n,v,tau,c,ldc,work)
use link_blas, only: lb_dlarfx
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side
integer(kind=BLASInt) :: ldc, m, n
real(kind=BLASR8) :: tau
real(kind=BLASR8) :: c(ldc,*), v(*), work(*)
call lb_dlarfx(side,m,n,v,tau,c,ldc,work)
end subroutine dlarfx

subroutine dlarnv(idist,iseed,n,x)
use link_blas, only: lb_dlarnv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: idist, n
integer(kind=BLASInt) :: iseed(4)
real(kind=BLASR8) :: x(*)
call lb_dlarnv(idist,iseed,n,x)
end subroutine dlarnv

subroutine dlarra(n,d,e,e2,spltol,tnrm,nsplit,isplit,info)
use link_blas, only: lb_dlarra
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, n, nsplit
real(kind=BLASR8) :: spltol, tnrm
integer(kind=BLASInt) :: isplit(*)
real(kind=BLASR8) :: d(*), e(*), e2(*)
call lb_dlarra(n,d,e,e2,spltol,tnrm,nsplit,isplit,info)
end subroutine dlarra

subroutine dlarrb(n,d,lld,ifirst,ilast,rtol1,rtol2,offset,w,wgap,werr,work,iwork,pivmin,spdiam,twist,info)
use link_blas, only: lb_dlarrb
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ifirst, ilast, info, n, offset, twist
real(kind=BLASR8) :: pivmin, rtol1, rtol2, spdiam
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: d(*), lld(*), w(*), werr(*), wgap(*), work(*)
call lb_dlarrb(n,d,lld,ifirst,ilast,rtol1,rtol2,offset,w,wgap,werr,work,iwork,pivmin,spdiam,twist,info)
end subroutine dlarrb

subroutine dlarrc(jobt,n,vl,vu,d,e,pivmin,eigcnt,lcnt,rcnt,info)
use link_blas, only: lb_dlarrc
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobt
integer(kind=BLASInt) :: eigcnt, info, lcnt, n, rcnt
real(kind=BLASR8) :: pivmin, vl, vu
real(kind=BLASR8) :: d(*), e(*)
call lb_dlarrc(jobt,n,vl,vu,d,e,pivmin,eigcnt,lcnt,rcnt,info)
end subroutine dlarrc

subroutine dlarrd(range,order,n,vl,vu,il,iu,gers,reltol,d,e,e2,pivmin,nsplit,isplit,m,w,werr,wl,wu,iblock, &
                  indexw,work,iwork,info)
use link_blas, only: lb_dlarrd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: order, range
integer(kind=BLASInt) :: il, info, iu, m, n, nsplit
real(kind=BLASR8) :: pivmin, reltol, vl, vu, wl, wu
integer(kind=BLASInt) :: iblock(*), indexw(*), isplit(*), iwork(*)
real(kind=BLASR8) :: d(*), e(*), e2(*), gers(*), w(*), werr(*), work(*)
call lb_dlarrd(range,order,n,vl,vu,il,iu,gers,reltol,d,e,e2,pivmin,nsplit,isplit,m,w,werr,wl,wu,iblock, &
               indexw,work,iwork,info)
end subroutine dlarrd

subroutine dlarre(range,n,vl,vu,il,iu,d,e,e2,rtol1,rtol2,spltol,nsplit,isplit,m,w,werr,wgap,iblock,indexw, &
                  gers,pivmin,work,iwork,info)
use link_blas, only: lb_dlarre
use Definitions, only: BLASInt, BLASR8
implicit none
character :: range
integer(kind=BLASInt) :: il, info, iu, m, n, nsplit
real(kind=BLASR8) :: pivmin, rtol1, rtol2, spltol, vl, vu
integer(kind=BLASInt) :: iblock(*), isplit(*), iwork(*), indexw(*)
real(kind=BLASR8) :: d(*), e(*), e2(*), gers(*), w(*), werr(*), wgap(*), work(*)
call lb_dlarre(range,n,vl,vu,il,iu,d,e,e2,rtol1,rtol2,spltol,nsplit,isplit,m,w,werr,wgap,iblock,indexw, &
               gers,pivmin,work,iwork,info)
end subroutine dlarre

subroutine dlarrf(n,d,l,ld,clstrt,clend,w,wgap,werr,spdiam,clgapl,clgapr,pivmin,sigma,dplus,lplus,work,info)
use link_blas, only: lb_dlarrf
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: clstrt, clend, info, n
real(kind=BLASR8) :: clgapl, clgapr, pivmin, sigma, spdiam
real(kind=BLASR8) :: d(*), dplus(*), l(*), ld(*), lplus(*), w(*), wgap(*), werr(*), work(*)
call lb_dlarrf(n,d,l,ld,clstrt,clend,w,wgap,werr,spdiam,clgapl,clgapr,pivmin,sigma,dplus,lplus,work,info)
end subroutine dlarrf

subroutine dlarrj(n,d,e2,ifirst,ilast,rtol,offset,w,werr,work,iwork,pivmin,spdiam,info)
use link_blas, only: lb_dlarrj
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ifirst, ilast, info, n, offset
real(kind=BLASR8) :: pivmin, rtol, spdiam
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: d(*), e2(*), w(*), werr(*), work(*)
call lb_dlarrj(n,d,e2,ifirst,ilast,rtol,offset,w,werr,work,iwork,pivmin,spdiam,info)
end subroutine dlarrj

subroutine dlarrk(n,iw,gl,gu,d,e2,pivmin,reltol,w,werr,info)
use link_blas, only: lb_dlarrk
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, iw, n
real(kind=BLASR8) :: pivmin, reltol, gl, gu, w, werr
real(kind=BLASR8) :: d(*), e2(*)
call lb_dlarrk(n,iw,gl,gu,d,e2,pivmin,reltol,w,werr,info)
end subroutine dlarrk

subroutine dlarrr(n,d,e,info)
use link_blas, only: lb_dlarrr
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: n, info
real(kind=BLASR8) :: d(*), e(*)
call lb_dlarrr(n,d,e,info)
end subroutine dlarrr

subroutine dlarrv(n,vl,vu,d,l,pivmin,isplit,m,dol,dou,minrgp,rtol1,rtol2,w,werr,wgap,iblock,indexw,gers,z, &
                  ldz,isuppz,work,iwork,info)
use link_blas, only: lb_dlarrv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: dol, dou, info, ldz, m, n
real(kind=BLASR8) :: minrgp, pivmin, rtol1, rtol2, vl, vu
integer(kind=BLASInt) :: iblock(*), indexw(*), isplit(*), isuppz(*), iwork(*)
real(kind=BLASR8) :: d(*), gers(*), l(*), w(*), werr(*), wgap(*), work(*)
real(kind=BLASR8) :: z(ldz,*)
call lb_dlarrv(n,vl,vu,d,l,pivmin,isplit,m,dol,dou,minrgp,rtol1,rtol2,w,werr,wgap,iblock,indexw,gers,z,ldz, &
               isuppz,work,iwork,info)
end subroutine dlarrv

subroutine dlartg(f,g,cs,sn,r)
use link_blas, only: lb_dlartg
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: cs, f, g, r, sn
call lb_dlartg(f,g,cs,sn,r)
end subroutine dlartg

subroutine dlaruv(iseed,n,x)
use link_blas, only: lb_dlaruv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: n
integer(kind=BLASInt) :: iseed(4)
real(kind=BLASR8) :: x(n)
call lb_dlaruv(iseed,n,x)
end subroutine dlaruv

subroutine dlas2(f,g,h,ssmin,ssmax)
use link_blas, only: lb_dlas2
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: f, g, h, ssmax, ssmin
call lb_dlas2(f,g,h,ssmin,ssmax)
end subroutine dlas2

subroutine dlascl(type,kl,ku,cfrom,cto,m,n,a,lda,info)
use link_blas, only: lb_dlascl
use Definitions, only: BLASInt, BLASR8
implicit none
character :: type
integer(kind=BLASInt) :: info, kl, ku, lda, m, n
real(kind=BLASR8) :: cfrom, cto
real(kind=BLASR8) :: a(lda,*)
call lb_dlascl(type,kl,ku,cfrom,cto,m,n,a,lda,info)
end subroutine dlascl

subroutine dlasd0(n,sqre,d,e,u,ldu,vt,ldvt,smlsiz,iwork,work,info)
use link_blas, only: lb_dlasd0
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, ldu, ldvt, n, smlsiz, sqre
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: d(*), e(*), u(ldu,*), vt(ldvt,*), work(*)
call lb_dlasd0(n,sqre,d,e,u,ldu,vt,ldvt,smlsiz,iwork,work,info)
end subroutine dlasd0

subroutine dlasd1(nl,nr,sqre,d,alpha,beta,u,ldu,vt,ldvt,idxq,iwork,work,info)
use link_blas, only: lb_dlasd1
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, ldu, ldvt, nl, nr, sqre
real(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: idxq(*), iwork(*)
real(kind=BLASR8) :: d(*), u(ldu,*), vt(ldvt,*), work(*)
call lb_dlasd1(nl,nr,sqre,d,alpha,beta,u,ldu,vt,ldvt,idxq,iwork,work,info)
end subroutine dlasd1

subroutine dlasd2(nl,nr,sqre,k,d,z,alpha,beta,u,ldu,vt,ldvt,dsigma,u2,ldu2,vt2,ldvt2,idxp,idx,idxc,idxq, &
                  coltyp,info)
use link_blas, only: lb_dlasd2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, ldu, ldu2, ldvt, ldvt2, nl, nr, sqre
real(kind=BLASR8) :: alpha, beta
integer(kind=BLASInt) :: coltyp(*), idx(*), idxc(*), idxp(*), idxq(*)
real(kind=BLASR8) :: d(*), dsigma(*), u(ldu,*), u2(ldu2,*), vt(ldvt,*), vt2(ldvt2,*), z(*)
call lb_dlasd2(nl,nr,sqre,k,d,z,alpha,beta,u,ldu,vt,ldvt,dsigma,u2,ldu2,vt2,ldvt2,idxp,idx,idxc,idxq, &
               coltyp,info)
end subroutine dlasd2

subroutine dlasd3(nl,nr,sqre,k,d,q,ldq,dsigma,u,ldu,u2,ldu2,vt,ldvt,vt2,ldvt2,idxc,ctot,z,info)
use link_blas, only: lb_dlasd3
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, ldq, ldu, ldu2, ldvt, ldvt2, nl, nr, sqre
integer(kind=BLASInt) :: ctot(*), idxc(*)
real(kind=BLASR8) :: d(*), dsigma(*), q(ldq,*), u(ldu,*), u2(ldu2,*), vt(ldvt,*), vt2(ldvt2,*), z(*)
call lb_dlasd3(nl,nr,sqre,k,d,q,ldq,dsigma,u,ldu,u2,ldu2,vt,ldvt,vt2,ldvt2,idxc,ctot,z,info)
end subroutine dlasd3

subroutine dlasd4(n,i,d,z,delta,rho,sigma,work,info)
use link_blas, only: lb_dlasd4
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: i, info, n
real(kind=BLASR8) :: rho, sigma
real(kind=BLASR8) :: d(*), delta(*), work(*), z(*)
call lb_dlasd4(n,i,d,z,delta,rho,sigma,work,info)
end subroutine dlasd4

subroutine dlasd5(i,d,z,delta,rho,dsigma,work)
use link_blas, only: lb_dlasd5
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: i
real(kind=BLASR8) :: dsigma, rho
real(kind=BLASR8) :: d(2), delta(2), work(2), z(2)
call lb_dlasd5(i,d,z,delta,rho,dsigma,work)
end subroutine dlasd5

subroutine dlasd6(icompq,nl,nr,sqre,d,vf,vl,alpha,beta,idxq,perm,givptr,givcol,ldgcol,givnum,ldgnum,poles,difl, &
                  difr,z,k,c,s,work,iwork,info)
use link_blas, only: lb_dlasd6
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: givptr, icompq, info, k, ldgcol, ldgnum, nl, nr, sqre
real(kind=BLASR8) :: alpha, beta, c, s
integer(kind=BLASInt) :: givcol(ldgcol,*), idxq(*), iwork(*), perm(*)
real(kind=BLASR8) :: d(*), difl(*), difr(*), givnum(ldgnum,*), poles(ldgnum,*), vf(*), vl(*), work(*), z(*)
call lb_dlasd6(icompq,nl,nr,sqre,d,vf,vl,alpha,beta,idxq,perm,givptr,givcol,ldgcol,givnum,ldgnum,poles,difl, &
               difr,z,k,c,s,work,iwork,info)
end subroutine dlasd6

subroutine dlasd7(icompq,nl,nr,sqre,k,d,z,zw,vf,vfw,vl,vlw,alpha,beta,dsigma,idx,idxp,idxq,perm,givptr, &
                  givcol,ldgcol,givnum,ldgnum,c,s,info)
use link_blas, only: lb_dlasd7
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: givptr, icompq, info, k, ldgcol, ldgnum, nl, nr, sqre
real(kind=BLASR8) :: alpha, beta, c, s
integer(kind=BLASInt) :: givcol(ldgcol,*), idx(*), idxp(*), idxq(*), perm(*)
real(kind=BLASR8) :: d(*), dsigma(*), givnum(ldgnum,*), vf(*), vfw(*), vl(*), vlw(*), z(*), zw(*)
call lb_dlasd7(icompq,nl,nr,sqre,k,d,z,zw,vf,vfw,vl,vlw,alpha,beta,dsigma,idx,idxp,idxq,perm,givptr, &
               givcol,ldgcol,givnum,ldgnum,c,s,info)
end subroutine dlasd7

subroutine dlasd8(icompq,k,d,z,vf,vl,difl,difr,lddifr,dsigma,work,info)
use link_blas, only: lb_dlasd8
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: icompq, info, k, lddifr
real(kind=BLASR8) :: d(*), difl(*), difr(lddifr,*), dsigma(*), vf(*), vl(*), work(*), z(*)
call lb_dlasd8(icompq,k,d,z,vf,vl,difl,difr,lddifr,dsigma,work,info)
end subroutine dlasd8

subroutine dlasda(icompq,smlsiz,n,sqre,d,e,u,ldu,vt,k,difl,difr,z,poles,givptr,givcol,ldgcol,perm,givnum,c,s, &
                  work,iwork,info)
use link_blas, only: lb_dlasda
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: icompq, info, ldgcol, ldu, n, smlsiz, sqre
integer(kind=BLASInt) :: givcol(ldgcol,*), givptr(*), iwork(*), k(*), perm(ldgcol,*)
real(kind=BLASR8) :: c(*), d(*), difl(ldu,*), difr(ldu,*), e(*), givnum(ldu,*), poles(ldu,*), s(*), u(ldu,*), &
          vt(ldu,*), work(*), z(ldu,*)
call lb_dlasda(icompq,smlsiz,n,sqre,d,e,u,ldu,vt,k,difl,difr,z,poles,givptr,givcol,ldgcol,perm,givnum,c,s, &
               work,iwork,info)
end subroutine dlasda

subroutine dlasdq(uplo,sqre,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,work,info)
use link_blas, only: lb_dlasdq
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, ldc, ldu, ldvt, n, ncc, ncvt, nru, sqre
real(kind=BLASR8) :: c(ldc,*), d(*), e(*), u(ldu,*), vt(ldvt,*), work(*)
call lb_dlasdq(uplo,sqre,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,work,info)
end subroutine dlasdq

subroutine dlasdt(n,lvl,nd,inode,ndiml,ndimr,msub)
use link_blas, only: lb_dlasdt
use Definitions, only: BLASInt
implicit none
integer(kind=BLASInt) :: lvl, msub, n, nd
integer(kind=BLASInt) :: inode(*), ndiml(*), ndimr(*)
call lb_dlasdt(n,lvl,nd,inode,ndiml,ndimr,msub)
end subroutine dlasdt

subroutine dlaset(uplo,m,n,alpha,beta,a,lda)
use link_blas, only: lb_dlaset
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: lda, m, n
real(kind=BLASR8) :: alpha, beta
real(kind=BLASR8) :: a(lda,*)
call lb_dlaset(uplo,m,n,alpha,beta,a,lda)
end subroutine dlaset

subroutine dlasq1(n,d,e,work,info)
use link_blas, only: lb_dlasq1
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, n
real(kind=BLASR8) :: d(*), e(*), work(*)
call lb_dlasq1(n,d,e,work,info)
end subroutine dlasq1

subroutine dlasq2(n,z,info)
use link_blas, only: lb_dlasq2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, n
real(kind=BLASR8) :: z(*)
call lb_dlasq2(n,z,info)
end subroutine dlasq2

subroutine dlasq3(i0,n0,z,pp,dmin,sigma,desig,qmax,nfail,iter,ndiv,ieee,ttype,dmin1,dmin2,dn,dn1,dn2,g,tau)
use link_blas, only: lb_dlasq3
use Definitions, only: BLASInt, BLASR8
implicit none
logical :: ieee
integer(kind=BLASInt) :: i0, iter, n0, ndiv, nfail, pp, ttype
real(kind=BLASR8) :: desig, dmin, dmin1, dmin2, dn, dn1, dn2, g, qmax, sigma, tau
real(kind=BLASR8) :: z(*)
call lb_dlasq3(i0,n0,z,pp,dmin,sigma,desig,qmax,nfail,iter,ndiv,ieee,ttype,dmin1,dmin2,dn,dn1,dn2,g,tau)
end subroutine dlasq3

subroutine dlasq4(i0,n0,z,pp,n0in,dmin,dmin1,dmin2,dn,dn1,dn2,tau,ttype,g)
use link_blas, only: lb_dlasq4
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: i0, n0, n0in, pp, ttype
real(kind=BLASR8) :: dmin, dmin1, dmin2, dn, dn1, dn2, g, tau
real(kind=BLASR8) :: z(*)
call lb_dlasq4(i0,n0,z,pp,n0in,dmin,dmin1,dmin2,dn,dn1,dn2,tau,ttype,g)
end subroutine dlasq4

subroutine dlasq5(i0,n0,z,pp,tau,sigma,dmin,dmin1,dmin2,dn,dnm1,dnm2,ieee,eps)
use link_blas, only: lb_dlasq5
use Definitions, only: BLASInt, BLASR8
implicit none
logical :: ieee
integer(kind=BLASInt) :: i0, n0, pp
real(kind=BLASR8) :: dmin, dmin1, dmin2, dn, dnm1, dnm2, tau, sigma, eps
real(kind=BLASR8) :: z(*)
call lb_dlasq5(i0,n0,z,pp,tau,sigma,dmin,dmin1,dmin2,dn,dnm1,dnm2,ieee,eps)
end subroutine dlasq5

subroutine dlasq6(i0,n0,z,pp,dmin,dmin1,dmin2,dn,dnm1,dnm2)
use link_blas, only: lb_dlasq6
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: i0, n0, pp
real(kind=BLASR8) :: dmin, dmin1, dmin2, dn, dnm1, dnm2
real(kind=BLASR8) :: z(*)
call lb_dlasq6(i0,n0,z,pp,dmin,dmin1,dmin2,dn,dnm1,dnm2)
end subroutine dlasq6

subroutine dlasr(side,pivot,direct,m,n,c,s,a,lda)
use link_blas, only: lb_dlasr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: direct, pivot, side
integer(kind=BLASInt) :: lda, m, n
real(kind=BLASR8) :: a(lda,*), c(*), s(*)
call lb_dlasr(side,pivot,direct,m,n,c,s,a,lda)
end subroutine dlasr

subroutine dlasrt(id,n,d,info)
use link_blas, only: lb_dlasrt
use Definitions, only: BLASInt, BLASR8
implicit none
character :: id
integer(kind=BLASInt) :: info, n
real(kind=BLASR8) :: d(*)
call lb_dlasrt(id,n,d,info)
end subroutine dlasrt

subroutine dlassq(n,x,incx,scale,sumsq)
use link_blas, only: lb_dlassq
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
real(kind=BLASR8) :: scale, sumsq
real(kind=BLASR8) :: x(*)
call lb_dlassq(n,x,incx,scale,sumsq)
end subroutine dlassq

subroutine dlasv2(f,g,h,ssmin,ssmax,snr,csr,snl,csl)
use link_blas, only: lb_dlasv2
use Definitions, only: BLASR8
implicit none
real(kind=BLASR8) :: csl, csr, f, g, h, snl, snr, ssmax, ssmin
call lb_dlasv2(f,g,h,ssmin,ssmax,snr,csr,snl,csl)
end subroutine dlasv2

subroutine dlaswp(n,a,lda,k1,k2,ipiv,incx)
use link_blas, only: lb_dlaswp
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, k1, k2, lda, n
integer(kind=BLASInt) :: ipiv(*)
real(kind=BLASR8) :: a(lda,*)
call lb_dlaswp(n,a,lda,k1,k2,ipiv,incx)
end subroutine dlaswp

subroutine dlasy2(ltranl,ltranr,isgn,n1,n2,tl,ldtl,tr,ldtr,b,ldb,scale,x,ldx,xnorm,info)
use link_blas, only: lb_dlasy2
use Definitions, only: BLASInt, BLASR8
implicit none
logical :: ltranl, ltranr
integer(kind=BLASInt) :: info, isgn, ldb, ldtl, ldtr, ldx, n1, n2
real(kind=BLASR8) :: scale, xnorm
real(kind=BLASR8) :: b(ldb,*), tl(ldtl,*), tr(ldtr,*), x(ldx,*)
call lb_dlasy2(ltranl,ltranr,isgn,n1,n2,tl,ldtl,tr,ldtr,b,ldb,scale,x,ldx,xnorm,info)
end subroutine dlasy2

subroutine dlatrd(uplo,n,nb,a,lda,e,tau,w,ldw)
use link_blas, only: lb_dlatrd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: lda, ldw, n, nb
real(kind=BLASR8) :: a(lda,*), e(*), tau(*), w(ldw,*)
call lb_dlatrd(uplo,n,nb,a,lda,e,tau,w,ldw)
end subroutine dlatrd

subroutine dlatrs(uplo,trans,diag,normin,n,a,lda,x,scale,cnorm,info)
use link_blas, only: lb_dlatrs
use Definitions, only: BLASInt, BLASR8
implicit none
character :: diag, normin, trans, uplo
integer(kind=BLASInt) :: info, lda, n
real(kind=BLASR8) :: scale
real(kind=BLASR8) :: a(lda,*), cnorm(*), x(*)
call lb_dlatrs(uplo,trans,diag,normin,n,a,lda,x,scale,cnorm,info)
end subroutine dlatrs

subroutine dopgtr(uplo,n,ap,tau,q,ldq,work,info)
use link_blas, only: lb_dopgtr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, ldq, n
real(kind=BLASR8) :: ap(*), q(ldq,*), tau(*), work(*)
call lb_dopgtr(uplo,n,ap,tau,q,ldq,work,info)
end subroutine dopgtr

subroutine dopmtr(side,uplo,trans,m,n,ap,tau,c,ldc,work,info)
use link_blas, only: lb_dopmtr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans, uplo
integer(kind=BLASInt) :: info, ldc, m, n
real(kind=BLASR8) :: ap(*), c(ldc,*), tau(*), work(*)
call lb_dopmtr(side,uplo,trans,m,n,ap,tau,c,ldc,work,info)
end subroutine dopmtr

subroutine dorg2l(m,n,k,a,lda,tau,work,info)
use link_blas, only: lb_dorg2l
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dorg2l(m,n,k,a,lda,tau,work,info)
end subroutine dorg2l

subroutine dorg2r(m,n,k,a,lda,tau,work,info)
use link_blas, only: lb_dorg2r
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dorg2r(m,n,k,a,lda,tau,work,info)
end subroutine dorg2r

subroutine dorgbr(vect,m,n,k,a,lda,tau,work,lwork,info)
use link_blas, only: lb_dorgbr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: vect
integer(kind=BLASInt) :: info, k, lda, lwork, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dorgbr(vect,m,n,k,a,lda,tau,work,lwork,info)
end subroutine dorgbr

subroutine dorghr(n,ilo,ihi,a,lda,tau,work,lwork,info)
use link_blas, only: lb_dorghr
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: ihi, ilo, info, lda, lwork, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dorghr(n,ilo,ihi,a,lda,tau,work,lwork,info)
end subroutine dorghr

subroutine dorgl2(m,n,k,a,lda,tau,work,info)
use link_blas, only: lb_dorgl2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dorgl2(m,n,k,a,lda,tau,work,info)
end subroutine dorgl2

subroutine dorglq(m,n,k,a,lda,tau,work,lwork,info)
use link_blas, only: lb_dorglq
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, lwork, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dorglq(m,n,k,a,lda,tau,work,lwork,info)
end subroutine dorglq

subroutine dorgql(m,n,k,a,lda,tau,work,lwork,info)
use link_blas, only: lb_dorgql
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, lwork, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dorgql(m,n,k,a,lda,tau,work,lwork,info)
end subroutine dorgql

subroutine dorgqr(m,n,k,a,lda,tau,work,lwork,info)
use link_blas, only: lb_dorgqr
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, lwork, m, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dorgqr(m,n,k,a,lda,tau,work,lwork,info)
end subroutine dorgqr

subroutine dorgtr(uplo,n,a,lda,tau,work,lwork,info)
use link_blas, only: lb_dorgtr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, lwork, n
real(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_dorgtr(uplo,n,a,lda,tau,work,lwork,info)
end subroutine dorgtr

subroutine dorm2l(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
use link_blas, only: lb_dorm2l
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, m, n
real(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_dorm2l(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
end subroutine dorm2l

subroutine dorm2r(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
use link_blas, only: lb_dorm2r
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, m, n
real(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_dorm2r(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
end subroutine dorm2r

subroutine dormbr(vect,side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_dormbr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans, vect
integer(kind=BLASInt) :: info, k, lda, ldc, lwork, m, n
real(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_dormbr(vect,side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
end subroutine dormbr

subroutine dormhr(side,trans,m,n,ilo,ihi,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_dormhr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: ihi, ilo, info, lda, ldc, lwork, m, n
real(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_dormhr(side,trans,m,n,ilo,ihi,a,lda,tau,c,ldc,work,lwork,info)
end subroutine dormhr

subroutine dorml2(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
use link_blas, only: lb_dorml2
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, m, n
real(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_dorml2(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
end subroutine dorml2

subroutine dormlq(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_dormlq
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, lwork, m, n
real(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_dormlq(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
end subroutine dormlq

subroutine dormql(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_dormql
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, lwork, m, n
real(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_dormql(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
end subroutine dormql

subroutine dormqr(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_dormqr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, lwork, m, n
real(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_dormqr(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
end subroutine dormqr

subroutine dormtr(side,uplo,trans,m,n,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_dormtr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans, uplo
integer(kind=BLASInt) :: info, lda, ldc, lwork, m, n
real(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_dormtr(side,uplo,trans,m,n,a,lda,tau,c,ldc,work,lwork,info)
end subroutine dormtr

subroutine dposv(uplo,n,nrhs,a,lda,b,ldb,info)
use link_blas, only: lb_dposv
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, ldb, n, nrhs
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dposv(uplo,n,nrhs,a,lda,b,ldb,info)
end subroutine dposv

subroutine dpotrf(uplo,n,a,lda,info)
use link_blas, only: lb_dpotrf
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, n
real(kind=BLASR8) :: a(lda,*)
call lb_dpotrf(uplo,n,a,lda,info)
end subroutine dpotrf

recursive subroutine dpotrf2(uplo,n,a,lda,info)
use link_blas, only: lb_dpotrf2
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, n
real(kind=BLASR8) :: a(lda,*)
call lb_dpotrf2(uplo,n,a,lda,info)
end subroutine dpotrf2

subroutine dpotrs(uplo,n,nrhs,a,lda,b,ldb,info)
use link_blas, only: lb_dpotrs
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, ldb, n, nrhs
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dpotrs(uplo,n,nrhs,a,lda,b,ldb,info)
end subroutine dpotrs

subroutine dpptrf(uplo,n,ap,info)
use link_blas, only: lb_dpptrf
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, n
real(kind=BLASR8) :: ap(*)
call lb_dpptrf(uplo,n,ap,info)
end subroutine dpptrf

subroutine dpstf2(uplo,n,a,lda,piv,rank,tol,work,info)
use link_blas, only: lb_dpstf2
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: tol
integer(kind=BLASInt) :: info, lda, n, rank
character :: uplo
real(kind=BLASR8) :: a(lda,*), work(2*n)
integer(kind=BLASInt) :: piv(n)
call lb_dpstf2(uplo,n,a,lda,piv,rank,tol,work,info)
end subroutine dpstf2

subroutine dpstrf(uplo,n,a,lda,piv,rank,tol,work,info)
use link_blas, only: lb_dpstrf
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: tol
integer(kind=BLASInt) :: info, lda, n, rank
character :: uplo
real(kind=BLASR8) :: a(lda,*), work(2*n)
integer(kind=BLASInt) :: piv(n)
call lb_dpstrf(uplo,n,a,lda,piv,rank,tol,work,info)
end subroutine dpstrf

function droundup_lwork(lwork)
use link_blas, only: lb_droundup_lwork
use Definitions, only: BLASInt, BLASR8
implicit none
real(kind=BLASR8) :: droundup_lwork
integer(kind=BLASInt) :: lwork
droundup_lwork = lb_droundup_lwork(lwork)
end function droundup_lwork

subroutine drscl(n,sa,sx,incx)
use link_blas, only: lb_drscl
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
real(kind=BLASR8) :: sa
real(kind=BLASR8) :: sx(*)
call lb_drscl(n,sa,sx,incx)
end subroutine drscl

subroutine dspev(jobz,uplo,n,ap,w,z,ldz,work,info)
use link_blas, only: lb_dspev
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, uplo
integer(kind=BLASInt) :: info, ldz, n
real(kind=BLASR8) :: ap(*), w(*), work(*), z(ldz,*)
call lb_dspev(jobz,uplo,n,ap,w,z,ldz,work,info)
end subroutine dspev

subroutine dspgst(itype,uplo,n,ap,bp,info)
use link_blas, only: lb_dspgst
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, itype, n
real(kind=BLASR8) :: ap(*), bp(*)
call lb_dspgst(itype,uplo,n,ap,bp,info)
end subroutine dspgst

subroutine dspgv(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,info)
use link_blas, only: lb_dspgv
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, uplo
integer(kind=BLASInt) :: info, itype, ldz, n
real(kind=BLASR8) :: ap(*), bp(*), w(*), work(*), z(ldz,*)
call lb_dspgv(itype,jobz,uplo,n,ap,bp,w,z,ldz,work,info)
end subroutine dspgv

subroutine dsptrd(uplo,n,ap,d,e,tau,info)
use link_blas, only: lb_dsptrd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, n
real(kind=BLASR8) :: ap(*), d(*), e(*), tau(*)
call lb_dsptrd(uplo,n,ap,d,e,tau,info)
end subroutine dsptrd

subroutine dstebz(range,order,n,vl,vu,il,iu,abstol,d,e,m,nsplit,w,iblock,isplit,work,iwork,info)
use link_blas, only: lb_dstebz
use Definitions, only: BLASInt, BLASR8
implicit none
character :: order, range
integer(kind=BLASInt) :: il, info, iu, m, n, nsplit
real(kind=BLASR8) :: abstol, vl, vu
integer(kind=BLASInt) :: iblock(*), isplit(*), iwork(*)
real(kind=BLASR8) :: d(*), e(*), w(*), work(*)
call lb_dstebz(range,order,n,vl,vu,il,iu,abstol,d,e,m,nsplit,w,iblock,isplit,work,iwork,info)
end subroutine dstebz

subroutine dstedc(compz,n,d,e,z,ldz,work,lwork,iwork,liwork,info)
use link_blas, only: lb_dstedc
use Definitions, only: BLASInt, BLASR8
implicit none
character :: compz
integer(kind=BLASInt) :: info, ldz, liwork, lwork, n
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: d(*), e(*), work(*), z(ldz,*)
call lb_dstedc(compz,n,d,e,z,ldz,work,lwork,iwork,liwork,info)
end subroutine dstedc

subroutine dstein(n,d,e,m,w,iblock,isplit,z,ldz,work,iwork,ifail,info)
use link_blas, only: lb_dstein
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, ldz, m, n
integer(kind=BLASInt) :: iblock(*), ifail(*), isplit(*), iwork(*)
real(kind=BLASR8) :: d(*), e(*), w(*), work(*), z(ldz,*)
call lb_dstein(n,d,e,m,w,iblock,isplit,z,ldz,work,iwork,ifail,info)
end subroutine dstein

subroutine dstemr(jobz,range,n,d,e,vl,vu,il,iu,m,w,z,ldz,nzc,isuppz,tryrac,work,lwork,iwork,liwork,info)
use link_blas, only: lb_dstemr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, range
logical :: tryrac
integer(kind=BLASInt) :: il, info, iu, ldz, nzc, liwork, lwork, m, n
real(kind=BLASR8) :: vl, vu
integer(kind=BLASInt) :: isuppz(*), iwork(*)
real(kind=BLASR8) :: d(*), e(*), w(*), work(*)
real(kind=BLASR8) :: z(ldz,*)
call lb_dstemr(jobz,range,n,d,e,vl,vu,il,iu,m,w,z,ldz,nzc,isuppz,tryrac,work,lwork,iwork,liwork,info)
end subroutine dstemr

subroutine dsteqr(compz,n,d,e,z,ldz,work,info)
use link_blas, only: lb_dsteqr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: compz
integer(kind=BLASInt) :: info, ldz, n
real(kind=BLASR8) :: d(*), e(*), work(*), z(ldz,*)
call lb_dsteqr(compz,n,d,e,z,ldz,work,info)
end subroutine dsteqr

subroutine dsterf(n,d,e,info)
use link_blas, only: lb_dsterf
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, n
real(kind=BLASR8) :: d(*), e(*)
call lb_dsterf(n,d,e,info)
end subroutine dsterf

subroutine dstevr(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz,isuppz,work,lwork,iwork,liwork,info)
use link_blas, only: lb_dstevr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, range
integer(kind=BLASInt) :: il, info, iu, ldz, liwork, lwork, m, n
real(kind=BLASR8) :: abstol, vl, vu
integer(kind=BLASInt) :: isuppz(*), iwork(*)
real(kind=BLASR8) :: d(*), e(*), w(*), work(*), z(ldz,*)
call lb_dstevr(jobz,range,n,d,e,vl,vu,il,iu,abstol,m,w,z,ldz,isuppz,work,lwork,iwork,liwork,info)
end subroutine dstevr

subroutine dsyev(jobz,uplo,n,a,lda,w,work,lwork,info)
use link_blas, only: lb_dsyev
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, uplo
integer(kind=BLASInt) :: info, lda, lwork, n
real(kind=BLASR8) :: a(lda,*), w(*), work(*)
call lb_dsyev(jobz,uplo,n,a,lda,w,work,lwork,info)
end subroutine dsyev

subroutine dsyevd(jobz,uplo,n,a,lda,w,work,lwork,iwork,liwork,info)
use link_blas, only: lb_dsyevd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, uplo
integer(kind=BLASInt) :: info, lda, liwork, lwork, n
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: a(lda,*), w(*), work(*)
call lb_dsyevd(jobz,uplo,n,a,lda,w,work,lwork,iwork,liwork,info)
end subroutine dsyevd

subroutine dsyevr(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z,ldz,isuppz,work,lwork,iwork,liwork,info)
use link_blas, only: lb_dsyevr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, range, uplo
integer(kind=BLASInt) :: il, info, iu, lda, ldz, liwork, lwork, m, n
real(kind=BLASR8) :: abstol, vl, vu
integer(kind=BLASInt) :: isuppz(*), iwork(*)
real(kind=BLASR8) :: a(lda,*), w(*), work(*), z(ldz,*)
call lb_dsyevr(jobz,range,uplo,n,a,lda,vl,vu,il,iu,abstol,m,w,z,ldz,isuppz,work,lwork,iwork,liwork,info)
end subroutine dsyevr

subroutine dsygs2(itype,uplo,n,a,lda,b,ldb,info)
use link_blas, only: lb_dsygs2
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, itype, lda, ldb, n
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dsygs2(itype,uplo,n,a,lda,b,ldb,info)
end subroutine dsygs2

subroutine dsygst(itype,uplo,n,a,lda,b,ldb,info)
use link_blas, only: lb_dsygst
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, itype, lda, ldb, n
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dsygst(itype,uplo,n,a,lda,b,ldb,info)
end subroutine dsygst

subroutine dsygv(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,info)
use link_blas, only: lb_dsygv
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, uplo
integer(kind=BLASInt) :: info, itype, lda, ldb, lwork, n
real(kind=BLASR8) :: a(lda,*), b(ldb,*), w(*), work(*)
call lb_dsygv(itype,jobz,uplo,n,a,lda,b,ldb,w,work,lwork,info)
end subroutine dsygv

subroutine dsytd2(uplo,n,a,lda,d,e,tau,info)
use link_blas, only: lb_dsytd2
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, n
real(kind=BLASR8) :: a(lda,*), d(*), e(*), tau(*)
call lb_dsytd2(uplo,n,a,lda,d,e,tau,info)
end subroutine dsytd2

subroutine dsytrd(uplo,n,a,lda,d,e,tau,work,lwork,info)
use link_blas, only: lb_dsytrd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, lwork, n
real(kind=BLASR8) :: a(lda,*), d(*), e(*), tau(*), work(*)
call lb_dsytrd(uplo,n,a,lda,d,e,tau,work,lwork,info)
end subroutine dsytrd

subroutine dtrevc3(side,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,mm,m,work,lwork,info)
use link_blas, only: lb_dtrevc3
use Definitions, only: BLASInt, BLASR8
implicit none
character :: howmny, side
integer(kind=BLASInt) :: info, ldt, ldvl, ldvr, lwork, m, mm, n
logical :: select(*)
real(kind=BLASR8) :: t(ldt,*), vl(ldvl,*), vr(ldvr,*), work(*)
call lb_dtrevc3(side,howmny,select,n,t,ldt,vl,ldvl,vr,ldvr,mm,m,work,lwork,info)
end subroutine dtrevc3

subroutine dtrexc(compq,n,t,ldt,q,ldq,ifst,ilst,work,info)
use link_blas, only: lb_dtrexc
use Definitions, only: BLASInt, BLASR8
implicit none
character :: compq
integer(kind=BLASInt) :: ifst, ilst, info, ldq, ldt, n
real(kind=BLASR8) :: q(ldq,*), t(ldt,*), work(*)
call lb_dtrexc(compq,n,t,ldt,q,ldq,ifst,ilst,work,info)
end subroutine dtrexc

subroutine dtrsen(job,compq,select,n,t,ldt,q,ldq,wr,wi,m,s,sep,work,lwork,iwork,liwork,info)
use link_blas, only: lb_dtrsen
use Definitions, only: BLASInt, BLASR8
implicit none
character :: compq, job
integer(kind=BLASInt) :: info, ldq, ldt, liwork, lwork, m, n
real(kind=BLASR8) :: s, sep
logical :: select(*)
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: q(ldq,*), t(ldt,*), wi(*), work(*), wr(*)
call lb_dtrsen(job,compq,select,n,t,ldt,q,ldq,wr,wi,m,s,sep,work,lwork,iwork,liwork,info)
end subroutine dtrsen

subroutine dtrsyl(trana,tranb,isgn,m,n,a,lda,b,ldb,c,ldc,scale,info)
use link_blas, only: lb_dtrsyl
use Definitions, only: BLASInt, BLASR8
implicit none
character :: trana, tranb
integer(kind=BLASInt) :: info, isgn, lda, ldb, ldc, m, n
real(kind=BLASR8) :: scale
real(kind=BLASR8) :: a(lda,*), b(ldb,*), c(ldc,*)
call lb_dtrsyl(trana,tranb,isgn,m,n,a,lda,b,ldb,c,ldc,scale,info)
end subroutine dtrsyl

subroutine dtrti2(uplo,diag,n,a,lda,info)
use link_blas, only: lb_dtrti2
use Definitions, only: BLASInt, BLASR8
implicit none
character :: diag, uplo
integer(kind=BLASInt) :: info, lda, n
real(kind=BLASR8) :: a(lda,*)
call lb_dtrti2(uplo,diag,n,a,lda,info)
end subroutine dtrti2

subroutine dtrtri(uplo,diag,n,a,lda,info)
use link_blas, only: lb_dtrtri
use Definitions, only: BLASInt, BLASR8
implicit none
character :: diag, uplo
integer(kind=BLASInt) :: info, lda, n
real(kind=BLASR8) :: a(lda,*)
call lb_dtrtri(uplo,diag,n,a,lda,info)
end subroutine dtrtri

subroutine dtrtrs(uplo,trans,diag,n,nrhs,a,lda,b,ldb,info)
use link_blas, only: lb_dtrtrs
use Definitions, only: BLASInt, BLASR8
implicit none
character :: diag, trans, uplo
integer(kind=BLASInt) :: info, lda, ldb, n, nrhs
real(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_dtrtrs(uplo,trans,diag,n,nrhs,a,lda,b,ldb,info)
end subroutine dtrtrs

function ieeeck(ispec,zero,one)
use link_blas, only: lb_ieeeck
use Definitions, only: BLASInt, BLASR4
implicit none
integer(kind=BLASInt) :: ispec
real(kind=BLASR4) :: one, zero
integer(kind=BLASInt) :: ieeeck
ieeeck = lb_ieeeck(ispec,zero,one)
end function ieeeck

function iladlc(m,n,a,lda)
use link_blas, only: lb_iladlc
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: m, n, lda
real(kind=BLASR8) :: a(lda,*)
integer(kind=BLASInt) :: iladlc
iladlc = lb_iladlc(m,n,a,lda)
end function iladlc

function iladlr(m,n,a,lda)
use link_blas, only: lb_iladlr
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: m, n, lda
real(kind=BLASR8) :: a(lda,*)
integer(kind=BLASInt) :: iladlr
iladlr = lb_iladlr(m,n,a,lda)
end function iladlr

function ilaenv(ispec,name,opts,n1,n2,n3,n4)
use link_blas, only: lb_ilaenv
use Definitions, only: BLASInt
implicit none
character(len=*) :: name, opts
integer(kind=BLASInt) :: ispec, n1, n2, n3, n4
integer(kind=BLASInt) :: ilaenv
ilaenv = lb_ilaenv(ispec,name,opts,n1,n2,n3,n4)
end function ilaenv

function ilazlc(m,n,a,lda)
use link_blas, only: lb_ilazlc
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: m, n, lda
complex(kind=BLASR8) :: a(lda,*)
integer(kind=BLASInt) :: ilazlc
ilazlc = lb_ilazlc(m,n,a,lda)
end function ilazlc

function ilazlr(m,n,a,lda)
use link_blas, only: lb_ilazlr
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: m, n, lda
complex(kind=BLASR8) :: a(lda,*)
integer(kind=BLASInt) :: ilazlr
ilazlr = lb_ilazlr(m,n,a,lda)
end function ilazlr

function iparam2stage(ispec,name,opts,ni,nbi,ibi,nxi)
use link_blas, only: lb_iparam2stage
use Definitions, only: BLASInt
implicit none
character(len=*) :: name, opts
integer(kind=BLASInt) :: ispec, ni, nbi, ibi, nxi
integer(kind=BLASInt) :: iparam2stage
iparam2stage = lb_iparam2stage(ispec,name,opts,ni,nbi,ibi,nxi)
end function iparam2stage

function iparmq(ispec,name,opts,n,ilo,ihi,lwork)
use link_blas, only: lb_iparmq
use Definitions, only: BLASInt
implicit none
integer(kind=BLASInt) :: ihi, ilo, ispec, lwork, n
character(len=*) :: name, opts
integer(kind=BLASInt) :: iparmq
iparmq = lb_iparmq(ispec,name,opts,n,ilo,ihi,lwork)
end function iparmq

subroutine zheev(jobz,uplo,n,a,lda,w,work,lwork,rwork,info)
use link_blas, only: lb_zheev
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, uplo
integer(kind=BLASInt) :: info, lda, lwork, n
real(kind=BLASR8) :: rwork(*), w(*)
complex(kind=BLASR8) :: a(lda,*), work(*)
call lb_zheev(jobz,uplo,n,a,lda,w,work,lwork,rwork,info)
end subroutine zheev

subroutine zhetd2(uplo,n,a,lda,d,e,tau,info)
use link_blas, only: lb_zhetd2
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, n
real(kind=BLASR8) :: d(*), e(*)
complex(kind=BLASR8) :: a(lda,*), tau(*)
call lb_zhetd2(uplo,n,a,lda,d,e,tau,info)
end subroutine zhetd2

subroutine zhetrd(uplo,n,a,lda,d,e,tau,work,lwork,info)
use link_blas, only: lb_zhetrd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, lwork, n
real(kind=BLASR8) :: d(*), e(*)
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zhetrd(uplo,n,a,lda,d,e,tau,work,lwork,info)
end subroutine zhetrd

subroutine zhpev(jobz,uplo,n,ap,w,z,ldz,work,rwork,info)
use link_blas, only: lb_zhpev
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobz, uplo
integer(kind=BLASInt) :: info, ldz, n
real(kind=BLASR8) :: rwork(*), w(*)
complex(kind=BLASR8) :: ap(*), work(*), z(ldz,*)
call lb_zhpev(jobz,uplo,n,ap,w,z,ldz,work,rwork,info)
end subroutine zhpev

subroutine zhptrd(uplo,n,ap,d,e,tau,info)
use link_blas, only: lb_zhptrd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, n
real(kind=BLASR8) :: d(*), e(*)
complex(kind=BLASR8) :: ap(*), tau(*)
call lb_zhptrd(uplo,n,ap,d,e,tau,info)
end subroutine zhptrd

subroutine zlacgv(n,x,incx)
use link_blas, only: lb_zlacgv
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
complex(kind=BLASR8) :: x(*)
call lb_zlacgv(n,x,incx)
end subroutine zlacgv

function zladiv(x,y)
use link_blas, only: lb_zladiv
use Definitions, only: BLASR8
implicit none
complex(kind=BLASR8) :: x, y
complex(kind=BLASR8) :: zladiv
zladiv = lb_zladiv(x,y)
end function zladiv

function zlange(norm,m,n,a,lda,work)
use link_blas, only: lb_zlange
use Definitions, only: BLASInt, BLASR8
implicit none
character :: norm
integer(kind=BLASInt) :: lda, m, n
real(kind=BLASR8) :: work(*)
complex(kind=BLASR8) :: a(lda,*)
real(kind=BLASR8) :: zlange
zlange = lb_zlange(norm,m,n,a,lda,work)
end function zlange

function zlanhe(norm,uplo,n,a,lda,work)
use link_blas, only: lb_zlanhe
use Definitions, only: BLASInt, BLASR8
implicit none
character :: norm, uplo
integer(kind=BLASInt) :: lda, n
real(kind=BLASR8) :: work(*)
complex(kind=BLASR8) :: a(lda,*)
real(kind=BLASR8) :: zlanhe
zlanhe = lb_zlanhe(norm,uplo,n,a,lda,work)
end function zlanhe

function zlanhp(norm,uplo,n,ap,work)
use link_blas, only: lb_zlanhp
use Definitions, only: BLASInt, BLASR8
implicit none
character :: norm, uplo
integer(kind=BLASInt) :: n
real(kind=BLASR8) :: work(*)
complex(kind=BLASR8) :: ap(*)
real(kind=BLASR8) :: zlanhp
zlanhp = lb_zlanhp(norm,uplo,n,ap,work)
end function zlanhp

subroutine zlarf(side,m,n,v,incv,tau,c,ldc,work)
use link_blas, only: lb_zlarf
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side
integer(kind=BLASInt) :: incv, ldc, m, n
complex(kind=BLASR8) :: tau
complex(kind=BLASR8) :: c(ldc,*), v(*), work(*)
call lb_zlarf(side,m,n,v,incv,tau,c,ldc,work)
end subroutine zlarf

subroutine zlarfb(side,trans,direct,storev,m,n,k,v,ldv,t,ldt,c,ldc,work,ldwork)
use link_blas, only: lb_zlarfb
use Definitions, only: BLASInt, BLASR8
implicit none
character :: direct, side, storev, trans
integer(kind=BLASInt) :: k, ldc, ldt, ldv, ldwork, m, n
complex(kind=BLASR8) :: c(ldc,*), t(ldt,*), v(ldv,*), work(ldwork,*)
call lb_zlarfb(side,trans,direct,storev,m,n,k,v,ldv,t,ldt,c,ldc,work,ldwork)
end subroutine zlarfb

subroutine zlarfg(n,alpha,x,incx,tau)
use link_blas, only: lb_zlarfg
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
complex(kind=BLASR8) :: alpha, tau
complex(kind=BLASR8) :: x(*)
call lb_zlarfg(n,alpha,x,incx,tau)
end subroutine zlarfg

subroutine zlarft(direct,storev,n,k,v,ldv,tau,t,ldt)
use link_blas, only: lb_zlarft
use Definitions, only: BLASInt, BLASR8
implicit none
character :: direct, storev
integer(kind=BLASInt) :: k, ldt, ldv, n
complex(kind=BLASR8) :: t(ldt,*), tau(*), v(ldv,*)
call lb_zlarft(direct,storev,n,k,v,ldv,tau,t,ldt)
end subroutine zlarft

subroutine zlascl(type,kl,ku,cfrom,cto,m,n,a,lda,info)
use link_blas, only: lb_zlascl
use Definitions, only: BLASInt, BLASR8
implicit none
character :: type
integer(kind=BLASInt) :: info, kl, ku, lda, m, n
real(kind=BLASR8) :: cfrom, cto
complex(kind=BLASR8) :: a(lda,*)
call lb_zlascl(type,kl,ku,cfrom,cto,m,n,a,lda,info)
end subroutine zlascl

subroutine zlaset(uplo,m,n,alpha,beta,a,lda)
use link_blas, only: lb_zlaset
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: lda, m, n
complex(kind=BLASR8) :: alpha, beta
complex(kind=BLASR8) :: a(lda,*)
call lb_zlaset(uplo,m,n,alpha,beta,a,lda)
end subroutine zlaset

subroutine zlasr(side,pivot,direct,m,n,c,s,a,lda)
use link_blas, only: lb_zlasr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: direct, pivot, side
integer(kind=BLASInt) :: lda, m, n
real(kind=BLASR8) :: c(*), s(*)
complex(kind=BLASR8) :: a(lda,*)
call lb_zlasr(side,pivot,direct,m,n,c,s,a,lda)
end subroutine zlasr

subroutine zlassq(n,x,incx,scale,sumsq)
use link_blas, only: lb_zlassq
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: incx, n
real(kind=BLASR8) :: scale, sumsq
complex(kind=BLASR8) :: x(*)
call lb_zlassq(n,x,incx,scale,sumsq)
end subroutine zlassq

subroutine zlatrd(uplo,n,nb,a,lda,e,tau,w,ldw)
use link_blas, only: lb_zlatrd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: lda, ldw, n, nb
real(kind=BLASR8) :: e(*)
complex(kind=BLASR8) :: a(lda,*), tau(*), w(ldw,*)
call lb_zlatrd(uplo,n,nb,a,lda,e,tau,w,ldw)
end subroutine zlatrd

subroutine zsteqr(compz,n,d,e,z,ldz,work,info)
use link_blas, only: lb_zsteqr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: compz
integer(kind=BLASInt) :: info, ldz, n
real(kind=BLASR8) :: d(*), e(*), work(*)
complex(kind=BLASR8) :: z(ldz,*)
call lb_zsteqr(compz,n,d,e,z,ldz,work,info)
end subroutine zsteqr

subroutine zung2l(m,n,k,a,lda,tau,work,info)
use link_blas, only: lb_zung2l
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zung2l(m,n,k,a,lda,tau,work,info)
end subroutine zung2l

subroutine zung2r(m,n,k,a,lda,tau,work,info)
use link_blas, only: lb_zung2r
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zung2r(m,n,k,a,lda,tau,work,info)
end subroutine zung2r

subroutine zungql(m,n,k,a,lda,tau,work,lwork,info)
use link_blas, only: lb_zungql
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zungql(m,n,k,a,lda,tau,work,lwork,info)
end subroutine zungql

subroutine zungqr(m,n,k,a,lda,tau,work,lwork,info)
use link_blas, only: lb_zungqr
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zungqr(m,n,k,a,lda,tau,work,lwork,info)
end subroutine zungqr

subroutine zungtr(uplo,n,a,lda,tau,work,lwork,info)
use link_blas, only: lb_zungtr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, lwork, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zungtr(uplo,n,a,lda,tau,work,lwork,info)
end subroutine zungtr

subroutine zupgtr(uplo,n,ap,tau,q,ldq,work,info)
use link_blas, only: lb_zupgtr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, ldq, n
complex(kind=BLASR8) :: ap(*), q(ldq,*), tau(*), work(*)
call lb_zupgtr(uplo,n,ap,tau,q,ldq,work,info)
end subroutine zupgtr

subroutine zlacpy(uplo,m,n,a,lda,b,ldb)
use link_blas, only: lb_zlacpy
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: lda, ldb, m, n
complex(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_zlacpy(uplo,m,n,a,lda,b,ldb)
end subroutine zlacpy

subroutine zbdsqr(uplo,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,rwork,info)
use link_blas, only: lb_zbdsqr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, ldc, ldu, ldvt, n, ncc, ncvt, nru
real(kind=BLASR8) :: d(*), e(*), rwork(*)
complex(kind=BLASR8) :: c(ldc,*), u(ldu,*), vt(ldvt,*)
call lb_zbdsqr(uplo,n,ncvt,nru,ncc,d,e,vt,ldvt,u,ldu,c,ldc,rwork,info)
end subroutine zbdsqr

subroutine zgebd2(m,n,a,lda,d,e,tauq,taup,work,info)
use link_blas, only: lb_zgebd2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, m, n
real(kind=BLASR8) :: d(*), e(*)
complex(kind=BLASR8) :: a(lda,*), taup(*), tauq(*), work(*)
call lb_zgebd2(m,n,a,lda,d,e,tauq,taup,work,info)
end subroutine zgebd2

subroutine zgebrd(m,n,a,lda,d,e,tauq,taup,work,lwork,info)
use link_blas, only: lb_zgebrd
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, lwork, m, n
real(kind=BLASR8) :: d(*), e(*)
complex(kind=BLASR8) :: a(lda,*), taup(*), tauq(*), work(*)
call lb_zgebrd(m,n,a,lda,d,e,tauq,taup,work,lwork,info)
end subroutine zgebrd

subroutine zgelq2(m,n,a,lda,tau,work,info)
use link_blas, only: lb_zgelq2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zgelq2(m,n,a,lda,tau,work,info)
end subroutine zgelq2

subroutine zgelqf(m,n,a,lda,tau,work,lwork,info)
use link_blas, only: lb_zgelqf
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zgelqf(m,n,a,lda,tau,work,lwork,info)
end subroutine zgelqf

subroutine zgels(trans,m,n,nrhs,a,lda,b,ldb,work,lwork,info)
use link_blas, only: lb_zgels
use Definitions, only: BLASInt, BLASR8
implicit none
character :: trans
integer(kind=BLASInt) :: m, n, nrhs, lda, ldb, lwork, info
complex(kind=BLASR8) :: a(lda,*), b(ldb,*), work(*)
call lb_zgels(trans,m,n,nrhs,a,lda,b,ldb,work,lwork,info)
end subroutine zgels

subroutine zgeqr2(m,n,a,lda,tau,work,info)
use link_blas, only: lb_zgeqr2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zgeqr2(m,n,a,lda,tau,work,info)
end subroutine zgeqr2

subroutine zgeqrf(m,n,a,lda,tau,work,lwork,info)
use link_blas, only: lb_zgeqrf
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zgeqrf(m,n,a,lda,tau,work,lwork,info)
end subroutine zgeqrf

subroutine zgesvd(jobu,jobvt,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,rwork,info)
use link_blas, only: lb_zgesvd
use Definitions, only: BLASInt, BLASR8
implicit none
character :: jobu, jobvt
integer(kind=BLASInt) :: info, lda, ldu, ldvt, lwork, m, n
real(kind=BLASR8) :: rwork(*), s(*)
complex(kind=BLASR8) :: a(lda,*), u(ldu,*), vt(ldvt,*), work(*)
call lb_zgesvd(jobu,jobvt,m,n,a,lda,s,u,ldu,vt,ldvt,work,lwork,rwork,info)
end subroutine zgesvd

subroutine zlabrd(m,n,nb,a,lda,d,e,tauq,taup,x,ldx,y,ldy)
use link_blas, only: lb_zlabrd
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: lda, ldx, ldy, m, n, nb
real(kind=BLASR8) :: d(*), e(*)
complex(kind=BLASR8) :: a(lda,*), taup(*), tauq(*), x(ldx,*), y(ldy,*)
call lb_zlabrd(m,n,nb,a,lda,d,e,tauq,taup,x,ldx,y,ldy)
end subroutine zlabrd

subroutine zlacrm(m,n,a,lda,b,ldb,c,ldc,rwork)
use link_blas, only: lb_zlacrm
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: lda, ldb, ldc, m, n
real(kind=BLASR8) :: b(ldb,*), rwork(*)
complex(kind=BLASR8) :: a(lda,*), c(ldc,*)
call lb_zlacrm(m,n,a,lda,b,ldb,c,ldc,rwork)
end subroutine zlacrm

subroutine zlaed0(qsiz,n,d,e,q,ldq,qstore,ldqs,rwork,iwork,info)
use link_blas, only: lb_zlaed0
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, ldq, ldqs, n, qsiz
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: d(*), e(*), rwork(*)
complex(kind=BLASR8) :: q(ldq,*), qstore(ldqs,*)
call lb_zlaed0(qsiz,n,d,e,q,ldq,qstore,ldqs,rwork,iwork,info)
end subroutine zlaed0

subroutine zlaed7(n,cutpnt,qsiz,tlvls,curlvl,curpbm,d,q,ldq,rho,indxq,qstore,qptr,prmptr,perm,givptr,givcol, &
                  givnum,work,rwork,iwork,info)
use link_blas, only: lb_zlaed7
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: curlvl, curpbm, cutpnt, info, ldq, n, qsiz, tlvls
real(kind=BLASR8) :: rho
integer(kind=BLASInt) :: givcol(2,*), givptr(*), indxq(*), iwork(*), perm(*), prmptr(*), qptr(*)
real(kind=BLASR8) :: d(*), givnum(2,*), qstore(*), rwork(*)
complex(kind=BLASR8) :: q(ldq,*), work(*)
call lb_zlaed7(n,cutpnt,qsiz,tlvls,curlvl,curpbm,d,q,ldq,rho,indxq,qstore,qptr,prmptr,perm,givptr,givcol, &
               givnum,work,rwork,iwork,info)
end subroutine zlaed7

subroutine zlaed8(k,n,qsiz,q,ldq,d,rho,cutpnt,z,dlamda,q2,ldq2,w,indxp,indx,indxq,perm,givptr,givcol,givnum, &
                  info)
use link_blas, only: lb_zlaed8
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: cutpnt, givptr, info, k, ldq, ldq2, n, qsiz
real(kind=BLASR8) :: rho
integer(kind=BLASInt) :: givcol(2,*), indx(*), indxp(*), indxq(*), perm(*)
real(kind=BLASR8) :: d(*), dlamda(*), givnum(2,*), w(*), z(*)
complex(kind=BLASR8) :: q(ldq,*), q2(ldq2,*)
call lb_zlaed8(k,n,qsiz,q,ldq,d,rho,cutpnt,z,dlamda,q2,ldq2,w,indxp,indx,indxq,perm,givptr,givcol,givnum, &
               info)
end subroutine zlaed8

subroutine zstedc(compz,n,d,e,z,ldz,work,lwork,rwork,lrwork,iwork,liwork,info)
use link_blas, only: lb_zstedc
use Definitions, only: BLASInt, BLASR8
implicit none
character :: compz
integer(kind=BLASInt) :: info, ldz, liwork, lrwork, lwork, n
integer(kind=BLASInt) :: iwork(*)
real(kind=BLASR8) :: d(*), e(*), rwork(*)
complex(kind=BLASR8) :: work(*), z(ldz,*)
call lb_zstedc(compz,n,d,e,z,ldz,work,lwork,rwork,lrwork,iwork,liwork,info)
end subroutine zstedc

subroutine zstein(n,d,e,m,w,iblock,isplit,z,ldz,work,iwork,ifail,info)
use link_blas, only: lb_zstein
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, ldz, m, n
integer(kind=BLASInt) :: iblock(*), ifail(*), isplit(*), iwork(*)
real(kind=BLASR8) :: d(*), e(*), w(*), work(*)
complex(kind=BLASR8) :: z(ldz,*)
call lb_zstein(n,d,e,m,w,iblock,isplit,z,ldz,work,iwork,ifail,info)
end subroutine zstein

subroutine ztrtrs(uplo,trans,diag,n,nrhs,a,lda,b,ldb,info)
use link_blas, only: lb_ztrtrs
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo, trans, diag
integer(kind=BLASInt) :: n, nrhs, lda, ldb, info
complex(kind=BLASR8) :: a(lda,*), b(ldb,*)
call lb_ztrtrs(uplo,trans,diag,n,nrhs,a,lda,b,ldb,info)
end subroutine ztrtrs

subroutine zungbr(vect,m,n,k,a,lda,tau,work,lwork,info)
use link_blas, only: lb_zungbr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: vect
integer(kind=BLASInt) :: info, k, lda, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zungbr(vect,m,n,k,a,lda,tau,work,lwork,info)
end subroutine zungbr

subroutine zungl2(m,n,k,a,lda,tau,work,info)
use link_blas, only: lb_zungl2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zungl2(m,n,k,a,lda,tau,work,info)
end subroutine zungl2

subroutine zunglq(m,n,k,a,lda,tau,work,lwork,info)
use link_blas, only: lb_zunglq
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, k, lda, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), tau(*), work(*)
call lb_zunglq(m,n,k,a,lda,tau,work,lwork,info)
end subroutine zunglq

subroutine zunm2l(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
use link_blas, only: lb_zunm2l
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, m, n
complex(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_zunm2l(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
end subroutine zunm2l

subroutine zunm2r(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
use link_blas, only: lb_zunm2r
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, m, n
complex(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_zunm2r(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
end subroutine zunm2r

subroutine zunmbr(vect,side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_zunmbr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans, vect
integer(kind=BLASInt) :: info, k, lda, ldc, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_zunmbr(vect,side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
end subroutine zunmbr

subroutine zunml2(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
use link_blas, only: lb_zunml2
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, m, n
complex(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_zunml2(side,trans,m,n,k,a,lda,tau,c,ldc,work,info)
end subroutine zunml2

subroutine zunmlq(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_zunmlq
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_zunmlq(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
end subroutine zunmlq

subroutine zunmql(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_zunmql
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_zunmql(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
end subroutine zunmql

subroutine zunmqr(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_zunmqr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans
integer(kind=BLASInt) :: info, k, lda, ldc, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_zunmqr(side,trans,m,n,k,a,lda,tau,c,ldc,work,lwork,info)
end subroutine zunmqr

subroutine zunmtr(side,uplo,trans,m,n,a,lda,tau,c,ldc,work,lwork,info)
use link_blas, only: lb_zunmtr
use Definitions, only: BLASInt, BLASR8
implicit none
character :: side, trans, uplo
integer(kind=BLASInt) :: info, lda, ldc, lwork, m, n
complex(kind=BLASR8) :: a(lda,*), c(ldc,*), tau(*), work(*)
call lb_zunmtr(side,uplo,trans,m,n,a,lda,tau,c,ldc,work,lwork,info)
end subroutine zunmtr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Bernd Artur Hess                                 *
!***********************************************************************

subroutine SCFCLI2(idbg,S,H,V,PVP,N,ISIZE,VELIT,BU,P,G,EV2,EIG,SINV,REVT,AUX,OVE,EW,E,AA,RR,TT)
! $Id: relsewb.r,v 1.4 1995/05/08 14:08:53 hess Exp $
! calculate relativistic operators
!   Bernd Artur Hess, hess@uni-bonn.de

use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: idbg, N, ISIZE
real(kind=wp), intent(in) :: S(ISIZE), V(ISIZE), PVP(ISIZE), VELIT
real(kind=wp), intent(inout) :: H(ISIZE)
real(kind=wp), intent(out) :: BU(ISIZE), P(ISIZE), G(ISIZE), EIG(N,N), EV2(ISIZE), SINV(N,N), REVT(N,N), AUX(N,N), OVE(N,N), &
                              EW(N), E(N), AA(N), RR(N), TT(N)
integer(kind=iwp) :: I, icontr, iex, ii, IJ, j, K
real(kind=wp) :: CON, CON2, det, dtol, PREA, RATIO, TOL, TV1, TV2, TV3, TV4

TOL = 1.0e-14_wp
PREA = 1/(VELIT*VELIT)
CON2 = PREA+PREA
CON = One/PREA
do I=1,ISIZE
  BU(I) = S(I)
end do
ii = 0
do i=1,n
  do j=1,i
    ii = ii+1
    aux(I,J) = s(ii)
    aux(J,I) = s(ii)
  end do
end do
!write(u6,*) 'OVERLAP MATRIX'
!do i=1,n
!  write(u6,'(5f10.5)') (aux(i,j),j=1,n)
!end do

! CALCULATE DETERMINANT

icontr = -1
dtol = tol
call dcopiv(aux,aux,n,1,n,dtol,det,iex,icontr,p)
!if (idbg > 0) write(idbg,2016) icontr,det,iex
if (icontr /= 0) then
  !write(u6,2016) icontr,det,iex
  !write(u6,2012) dtol
  write(u6,'(a)') ' relsewb| singular overlap matrix'
  call Abend()
end if

! SCHMIDT-ORTHOGONALIZE

call Sogr(iDbg,N,BU,SINV,P,OVE,EW)

call Square(BU,OVE,N,1,N)
!call FilMar(N,BU,OVE)

! ** SINV CONTAINS TRANSFORMATION TO ORTHOGONAL AO-BASIS
! ** OVE  CONTAINS OVERLAP MATRIX IN FULL
!-----------------------------------------------------------------------
! NON-RELATIVISTIC KINETIC ENERGY
!-----------------------------------------------------------------------

call Diagr(H,N,EIG,EW,SINV,AUX,BU)

!if (idbg > 0) write(idbg,556)
do I=1,N
  if (ew(i) < Zero) then
    !write(u6,*) ' scfcli2| ew(',i,') = ',ew(i)
    write(u6,'(a)') 'kinetic energy eigenvalue less than zero'
    call Abend()
  end if

  ! IF T SUFFICIENTLY SMALL, USE SERIES EXPANSION TO AVOID CANCELLATIO

  RATIO = EW(I)/VELIT

  ! CALCULATE RELATIVISTIC ENERGY AND MOMENTUM

  !SR = sqrt(Two*EW(I))
  TT(I) = EW(I)
  if (RATIO > 0.02_wp) then
    TV1 = EW(I)
    EW(I) = CON*(sqrt(One+CON2*EW(I))-One)
    !if (idbg > 0) write(idbg,100) I,TV1,RATIO,EW(I),SR
  else
    TV1 = EW(I)
    TV2 = -TV1*EW(I)*PREA*Half
    TV3 = -TV2*EW(I)*PREA
    TV4 = -TV3*EW(I)*PREA*1.25_wp
    EW(I) = TV1+TV2+TV3+TV4
    !if (idbg > 0) write(idbg,100) I,TV1,RATIO,EW(I),SR,TV2,TV3,TV4
  end if
  E(I) = EW(I)+CON
end do
!-----------------------------------------------------------------------
! CALCULATE REVERSE TRANSFORMATION
!-----------------------------------------------------------------------
do I=1,N
  do J=1,N
    AUX(I,J) = Zero
    do K=I,N
      AUX(I,J) = AUX(I,J)+SINV(I,K)*EIG(K,J)
    end do
  end do
end do
do I=1,N
  do J=1,N
    REVT(I,J) = Zero
    do K=1,N
      REVT(I,J) = REVT(I,J)+OVE(I,K)*AUX(K,J)
    end do
  end do
end do
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    H(IJ) = Zero
    do K=1,N
      H(IJ) = H(IJ)+REVT(I,K)*REVT(J,K)*EW(K)
    end do
  end do
end do

! CALCULATE KINEMATICAL FACTORS

do I=1,N
  AA(I) = sqrt((CON+E(I))/(Two*E(I)))
  RR(I) = sqrt(CON)/(CON+E(I))
end do

! POTENTIAL

! BEYOND THIS POINT, OVE IS USED AS SCRATCH ARRAY

! TRANSFORM V TO T-BASIS

call TrSmr(V,SINV,G,N,AUX,OVE)

call TrSmr(G,EIG,BU,N,AUX,OVE)

!ulf
if (idbg > 0) call PRMAT(IDBG,V,N,0,'v oper  ')

! MULTIPLY

IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    P(IJ) = BU(IJ)
    BU(IJ) = BU(IJ)*AA(I)*AA(J)
  end do
end do

call TrSmtr(BU,REVT,G,Zero,N,AUX,OVE)

!ulf
if (idbg > 0) call PRMAT(IDBG,g,N,0,'g oper  ')

H(:) = H+G

! PVP INTEGRALS AND TRANSFORM THEM TO T-BASIS

if (idbg > 0) call PRMAT(IDBG,pvp,N,0,'raw pvp integrals  ')
call TrSmr(PVP,SINV,G,N,AUX,OVE)

call TrSmr(G,EIG,BU,N,AUX,OVE)

! MULTIPLY

IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    G(IJ) = BU(IJ)
    BU(IJ) = BU(IJ)*AA(I)*RR(I)*AA(J)*RR(J)
  end do
end do

call TrSmtr(BU,REVT,EV2,Zero,N,AUX,OVE)
!ulf
if (idbg > 0) call PRMAT(IDBG,ev2,n,0,'pvp oper')

H(:) = H+EV2

! CALCULATE Even2r OPERATOR

!if (idbg > 0) call Even2r(idbg,N,P,G,E,AA,RR,TT,EIG,AUX,OVE)

! TRANSFORM BACK

!ulf
if (idbg > 0) call PRMAT(IDBG,g,n,0,'ev2 orig')
!call TrSmtr(G,REVT,EV2,Zero,N,AUX,OVE)
!ulf
!if (idbg > 0) call PRMAT(IDBG,ev2,n,0,'ev2 oper')
!H(:) = H+EV2
!ulf
if (idbg > 0) call PRMAT(IDBG,h,n,0,'h   oper')
!call Sogr(iDbg,N,S,SINV,P,OVE,EW)
!call Diagr(H,N,EIG,EW,SINV,AUX,0)
!write(u6,*) 'END OF SCFCLI2 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'

!if (idbg > 0) write(idbg,*) '--- EIGENVALUES OF H MATRIX ---'
!if (idbg > 0) write(idbg,'(4D20.12)') EW

return

!100 format(1X,I4,7(2X,D14.8))
!556 format(//,7X,'- NREL. ENERG.  -  DIVIDED BY C - REL.  ENERG.  -  MOMENTUM    - TERMS OF POWER SERIES (LOW ENERGY ONLY)'//)
!2012 format('  relsewb|****** '/,'        |****** WARNING - OVERLAP MATRIX SINGULAR '/, &
!            '        |****** PIVOTAL ELEMENT LESS THAN ',D20.4,' FOUND'/,'        |******'//)
!2016 format(' relsewb| DCOPIV rc=',I2,', |S|=',D20.6,'x 10**(',I4,') ')

end subroutine SCFCLI2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine axesxres_cvb(axc,sxc,dum,res,
     >  solp_res,maxdav,n,itdav,eig_res,
     >  is_converged)
      implicit real*8 (a-h,o-z)
      logical is_converged
#include "direct_cvb.fh"
      dimension axc(n,maxdav),sxc(n,maxdav),res(n)
      dimension solp_res(maxdav)

      call fzero(res,n)
      do 300 i=1,itdav
      do 301 ivb=1,n
      res(ivb)=res(ivb)+(axc(ivb,i)-eig_res*sxc(ivb,i))*solp_res(i)
301   continue
300   continue

      is_converged=(jroot.eq.iroot)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_real(dum)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module nq_pdft

use Definitions, only: wp, iwp

implicit none
private

! ThrsRho: threshold of total density
! ThrsOMR: threshold of (1 - R)
! ThrsFT : threshold for doing full translation in ft functionals
!          a.k.a. R0 in the ft paper
! ThrsNT : threshold for not doing any translation in ft functionals
!          a.k.a. R1 in the ft paper

real(kind=wp), parameter :: fta = -475.6065601_wp, ftb = -379.4733192_wp, ftc = -85.3814968_wp, ThrsFT = 0.9_wp, ThrsNT = 1.15_wp, &
                            ThrsOMR = 1.0e-15_wp, ThrsRho = 1.0e-15_wp
logical(kind=iwp) :: lft = .false., lGGA = .false.
real(kind=wp), allocatable :: d2RdRho2(:), d2RdRhodPi(:), d2ZdR2(:), dEdPi(:), dEdPiMO(:,:), dEdPix(:), dEdPiy(:), dEdPiz(:), &
                              dEdRho(:), dEdRhox(:), dEdRhoy(:), dEdRhoz(:), dF_dRhoamb(:), dF_dRhoapb(:), dF_dRhoxamb(:), &
                              dF_dRhoxapb(:), dF_dRhoyamb(:), dF_dRhoyapb(:), dF_dRhozamb(:), dF_dRhozapb(:), dRdPi(:), dRdRho(:), &
                              dRhodX(:), dRhodY(:), dRhodZ(:), dZdR(:), dZdRho(:), GdEdPiMO(:,:), GradPidFdRho(:), GradRdFdRho(:), &
                              GradRhodFdRho(:), MOas(:,:), MOax(:,:), MOay(:,:), MOaz(:,:), OneMZ(:), OnePZ(:), RatioA(:), &
                              RhoAB(:), ZetaA(:)
logical(kind=iwp), allocatable :: Pass1(:), Pass2(:), Pass3(:)

public :: d2RdRho2, d2RdRhodPi, d2ZdR2, dEdPi, dEdPiMO, dEdPix, dEdPiy, dEdPiz, dEdRho, dEdRhox, dEdRhoy, dEdRhoz, dF_dRhoamb, &
          dF_dRhoapb, dF_dRhoxamb, dF_dRhoxapb, dF_dRhoyamb, dF_dRhoyapb, dF_dRhozamb, dF_dRhozapb, dRdPi, dRdRho, dRhodX, dRhodY, &
          dRhodZ, dZdR, dZdRho, fta, ftb, ftc, GdEdPiMO, GradPidFdRho, GradRdFdRho, GradRhodFdRho, lft, lGGA, MOas, MOax, MOay, &
          MOaz, OneMZ, OnePZ, Pass1, Pass2, Pass3, RatioA, RhoAB, ThrsFT, ThrsNT, ThrsOMR, ThrsRho, ZetaA

end module nq_pdft

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DistMemo3v3t2(maxdim,PosV1,PosV2,PosV3,PosV4,PosH1,PosH2,PosH3,PosH4,PosK,PosQ,PosT)
! This routine does:
! define initial positions of H,V, QK
!
! I/O parameter description:
! maxdim   - maximal dimension of V'
! Posx     - initial positions of arrays (O-all)
! PosT     - initial and last position (I/O)
!
! requirements for o3v3t2:
! H1 - max {v'o}
! H2 - max {v'o}
! H3 - max {v'v',ooo}
! H4 - max {v'o}
! V1 - max {v'ov'o, vv'}
! V2 - max {v'ov'o}
! V3 - max {v'ov'o, o2oo}
! V4 - max {v'ov'o}
! PX - max {v'ov'o}
! QY - max {v'ov'o}

use Index_Functions, only: nTri_Elem
use chcc_global, only: no, nv, printkey
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: maxdim
integer(kind=iwp), intent(out) :: PosV1, PosV2, PosV3, PosV4, PosH1, PosH2, PosH3, PosH4, PosK, PosQ
integer(kind=iwp), intent(inout) :: PosT
integer(kind=iwp) :: length

!1 Q,K (used also as X,Y)

length = no*no*maxdim*maxdim

PosQ = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Q  ',PosQ,length
PosK = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM K  ',PosK,length

!2.1 V1 file - max {v'ov'o, vv'}

length = no*no*maxdim*maxdim
if (nv*maxdim > length) length = maxdim*nv

PosV1 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V1 ',PosV1,length

!2.2 V2-4 files
!    V2 - max {v'ov'o}
!    V3 - max {v'ov'o, o2oo}
!    V4 - max {v'ov'o}

length = no*no*maxdim*maxdim
if (no*no*no*maxdim > length) length = no*no*no*maxdim

PosV2 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V2 ',PosV2,length

length = no*no*maxdim*maxdim
if (nTri_Elem(no)*no*no > length) length = no*no*nTri_Elem(no)

PosV3 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V3 ',PosV3,length

length = no*no*maxdim*maxdim
PosV4 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM V4 ',PosV4,length

!3 H1,2 files

length = no*maxdim

PosH1 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM H1 ',PosH1,length
PosH2 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM H2 ',PosH2,length

!3.2 H3 file

length = maxdim*maxdim
if (no*maxdim > length) length = no*maxdim
if (no*no*no > length) then
  length = no*no*no
end if

PosH3 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM H3 ',PosH3,length

!3.3 H4 file

length = no*maxdim

PosH4 = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM H4 ',PosH4,length

if (printkey >= 10) write(u6,*) 'PosT ',PosT

return

end subroutine DistMemo3v3t2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function trace_exch2(n1,n2,A,O1,O2)

use Constants, only: cZero
use Definitions, only: wp, iwp

implicit none
complex(kind=wp) :: trace_exch2
integer(kind=iwp), intent(in) :: n1, n2
complex(kind=wp), intent(in) :: A(n1,n1,n2,n2), O1(n1,n1), O2(n2,n2)
integer(kind=iwp) :: i1, i2, k1, k2

trace_exch2 = cZero
do i1=1,n1
  do k1=1,n1
    do i2=1,n2
      do k2=1,n2
        trace_exch2 = trace_exch2+A(i1,k1,i2,k2)*O1(k1,i1)*O2(k2,i2)
      end do
    end do
  end do
end do

end function trace_exch2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine loind_cvb(nel,n,nk,nkmin,nkmax,
     >  locc,lunocc,index,ix,*)
      dimension nk(0:nel),nkmin(0:nel),nkmax(0:nel),
     >  locc(n),lunocc(nel-n),ix(0:nel,0:n)

      do 1100 iel=1,nel-1
      ik=nk(iel)
c Tests: (1) IK+1 OCCUPIED; (2) IK NOT OCCUPIED; (3) IK MINIMAL
      if(.not.(nk(iel+1)-ik .eq.1 .or.
     >   ik.eq.nk(iel-1) .or. ik.eq.nkmin(iel)))goto 1200
1100  continue
c Maximize the loop on exit
      call imove_cvb(nkmax,nk,nel)
      call occupy_cvb(nk,nel,locc,lunocc)
      index=minind_cvb(locc,n,nel,ix)
      return
c
c SITUATION IS :  IEL       \     <= NOT MINIMAL
c                 IEL+1     |
1200  nk(iel)=ik-1
      do 1300 jel=1,iel-1
      nk(jel)=min(nkmax(jel),ik-1)
1300  continue
      call occupy_cvb(nk,nel,locc,lunocc)
      index=minind_cvb(locc,n,nel,ix)
      return 1
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_TranslateErrorCode(iErr,MolcasCode)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iErr
integer(kind=iwp), intent(out) :: MolcasCode

#include "warnings.h"

select case (iErr)
  case (3) ! special code used in parallel
    MolcasCode = _RC_NOT_AVAILABLE_
  case (100)
    MolcasCode = _RC_CHO_DUM_
  case (101)
    MolcasCode = _RC_CHO_MEM_
  case (102)
    MolcasCode = _RC_CHO_INI_
  case (103)
    MolcasCode = _RC_CHO_LOG_
  case (104)
    MolcasCode = _RC_CHO_RUN_
  case (105)
    MolcasCode = _RC_CHO_INP_
  case default
    MolcasCode = _RC_GENERAL_ERROR_
end select

end subroutine Cho_TranslateErrorCode

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mfreer_cvb(ipoint)
c  Memory allocator. Releases pointer.
      implicit real*8 (a-h,o-z)
#include "memman_cvb.fh"


      if(memdebug)write(6,*)'     Enter mfreer: pointer :',ipoint
c  Check if allocated using mstack :
      do 100 ifield=1,nfield
      if(iaddr(ifield).eq.ipoint)then
        do 200 jfield=ifield,nfield
        ipoint_g=iaddr(jfield)-ioff_r
        if(memdebug)write(6,*)'     Release pointer :',iaddr(jfield)
        call getmem('casvb','FREE','REAL',ipoint_g,nword)
200     continue
        nfield=ifield-1
        return
      endif
100   continue
c  Allocated through mheap :
      ipoint_g=ipoint-ioff_r
      call getmem('casvb','FREE','REAL',ipoint_g,nword)
      return
      end
      subroutine mhpfreer_cvb(ipoint)
c  Memory allocator. Releases pointer.
      implicit real*8 (a-h,o-z)
#include "memman_cvb.fh"


      if(memdebug)write(6,*)'     Enter mfreer: pointer :',ipoint
c  Check if allocated using mstack :
      do 100 ifield=1,nfield
      if(iaddr(ifield).eq.ipoint)then
        do 200 jfield=ifield,nfield
        ipoint_g=iaddr(jfield)-ioff_r
        if(memdebug)write(6,*)'     Release pointer :',iaddr(jfield)
        call getmem('casvb','FREE','REAL',ipoint_g,nword)
200     continue
        nfield=ifield-1
        return
      endif
100   continue
c  Allocated through mheap :
      ipoint_g=ipoint-ioff_r
      call getmem('casvb','FREE','REAL',ipoint_g,nword)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function GETH2A(I,J,K,L,TUVX)

use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: GETH2A
integer(kind=iwp), intent(in) :: I, J, K, L
real(kind=wp), intent(in) :: TUVX(*)
integer(kind=iwp) :: IJ, KL, NI, NIJ, NIJKL, NJ, NK, NKL, NL

NI = max(I,J)
NJ = min(I,J)
IJ = NJ+NI*(NI-1)/2
NK = max(K,L)
NL = min(K,L)
KL = NL+NK*(NK-1)/2
NIJ = max(IJ,KL)
NKL = min(IJ,KL)
NIJKL = NKL+NIJ*(NIJ-1)/2
GETH2A = TUVX(NIJKL)

return

end function GETH2A

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine Freek2
************************************************************************
*                                                                      *
*  Object: deallocate memory for pair entities                         *
*                                                                      *
* Called from: ClsSew                                                  *
*                                                                      *
* Calling    : GetMem                                                  *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden. November '92                            *
************************************************************************
      use k2_setup
      use k2_arrays
      Implicit Real*8 (A-H,O-Z)
#include "stdalloc.fh"
#include "setup.fh"
#include "status.fh"
*
      If (.Not.Allocated(Data_k2)) Return

*     Deallocate k2 entities
*
      Call mma_deallocate(Data_k2)
      Call mma_deallocate(Indk2)
      k2_Status=InActive
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function R_Stab_A(R,S,nS)

use Definitions, only: iwp

implicit none
logical(kind=iwp) :: R_Stab_A
integer(kind=iwp), intent(in) :: nS, R, S(nS)
integer(kind=iwp) :: iS

R_Stab_A = .false.
do iS=1,nS
  if (R == S(iS)) then
    R_Stab_A = .true.
    return
  end if
end do

return

end function R_Stab_A

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION CHO_ISAO(IAO)
C
C     Purpose: return symmetry of AO number IAO (in global list).
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choorb.fh"

      INTEGER  CHO_IRANGE
      EXTERNAL CHO_IRANGE

#if defined (_DEBUGPRINT_)
      CHARACTER*8 SECNAM
      PARAMETER (SECNAM = 'CHO_ISAO')

      IF ((IAO.GT.NBAST) .OR. (IAO.LT.1)) THEN
         WRITE(LUPRI,'(//,1X,A,A,I10)')
     &   SECNAM,': AO index out of bounds: ',IAO
         WRITE(LUPRI,'(A,I10,A,/)')
     &   'Maximum possible: NBAST = ',NBAST,'(from common block)'
         IF (NBAST .LT. 1) THEN
            CALL CHO_QUIT('Initialization error detected in '//SECNAM,
     &                    102)
         ELSE
            CALL CHO_QUIT('Internal error detected in '//SECNAM,
     &                    103)
         END IF
      END IF
#endif

      CHO_ISAO = CHO_IRANGE(IAO,IBAS,NSYM,.FALSE.)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3intpck2(vint,r,dimv1,dimv2,dimv3,dima,dimb,dimc,symq,symr,syms,nob,nvb)
! this routine packs integral block symi,symq,symr,syms
! R_i(a,b,c) = V_i(b,a,c)
! for symq(b)>syms(c)
! and writes R block onto proper place of open t3nam file - lunt3
!
! vint  - integrals for given symmetries for given i (I)
! r     - final R_i matrix (O)
! dimv1 - 1st dimension of V (I)
! dimv2 - 2nd dimension of V (I)
! dimv3 - 3rd dimension of V (I)
! dima  - dimension of a in R (I)
! dimb  - dimension of b in R (I)
! dimc  - dimension of c in R (I)
! symq  - symmetry of q (b) (I)
! symr  - symmetry of r (a) (I)
! syms  - symmetry of s (c) (I)
! nob   - number of beta occupied in each irrep (I)
! nvb   - number of beta virtuals in each irrep (I)

use ccsort_global, only: daddr, lunt3
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimv1, dimv2, dimv3, dima, dimb, dimc, symq, symr, syms, nob(8), nvb(8)
real(kind=wp), intent(in) :: vint(dimv1,dimv2,dimv3)
real(kind=wp), intent(out) :: r(dima,dimb,dimc)
integer(kind=iwp) :: a, adda, addb, addc, b, c, iaddr, length

! if there are no beta virtuals - skip
if (nvb(symq)*nvb(symr)*nvb(syms) == 0) return

! calc additional constants for a,b,c
adda = nob(symr)
addb = nob(symq)
addc = nob(syms)

! do packing

do c=1,nvb(syms)
  do b=1,nvb(symq)
    do a=1,nvb(symr)
      r(a,b,c) = vint(b+addb,a+adda,c+addc)
    end do
  end do
end do

! write section

length = dima*dimb*dimc
if (length > 0) then
  iaddr = daddr(lunt3)
  call ddafile(lunt3,1,r(1,1,1),length,iaddr)
end if

return

end subroutine t3intpck2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine prefac(Lmax,preroots,clebsch)
      implicit real*8 (a-h,o-z)
      dimension preroots(2,0:Lmax),
     *clebsch(3,2,-Lmax:Lmax,0:Lmax)
cbs   the roots appearing in front of all
cbs   the contributions
c     write(6,*) 'begin of prefac'
      do L=0,Lmax
      fact=1d0/sqrt(DBLE(L+L+1))
      preroots(1,L)=sqrt(DBLE(L))*fact
      preroots(2,L)=sqrt(DBLE(L+1))*fact
      enddo
cbs   there are Clebsch-Gordan-Coefficients
cbs   which always appear:
cbs
cbs   -----                       ------
cbs  |                                 |
cbs  |  l +/- 1     1        |      l  |
cbs  |                       |         |
cbs  |                       |         |
cbs  |  m+/-1,0   -1,1,0     |      m  |
cbs  |                       |         |
cbs  |                                 |
cbs   -----                       -----
cbs
cbs
cbs  array clebsch (3,2,-Lmax:Lmax,0:Lmax)
cbs  first index    1:  m-1
cbs                 2:  m
cbs                 3:  m+1
cbs  second index   1:  l-1
cbs                 2:  l+1
cbs  third index        m
cbs  fourth index       l
cbs
c     write(6,*),'start to generate CGs'
      do L=0,Lmax
      L2=L+L
      do M=-L,L
c     write(6,*) 'L,M: ',L,M
      M2=M+M
cbs   getCG calculates CG-coeffecients. In order to avoid fractions,
cbs   e.g. for spins, arguments are doubled values...
      clebsch(1,1,M,L)=
     *getCG(L2-2,2,L2,M2-2,2,M2)
      clebsch(2,1,M,L)=
     *getCG(L2-2,2,L2,M2,0,M2)
      clebsch(3,1,M,L)=
     *getCG(L2-2,2,L2,M2+2,-2,M2)
      clebsch(1,2,M,L)=
     *getCG(L2+2,2,L2,M2-2,2,M2)
      clebsch(2,2,M,L)=
     *getCG(L2+2,2,L2,M2,0,M2)
      clebsch(3,2,M,L)=
     *getCG(L2+2,2,L2,M2+2,-2,M2)
      enddo
      enddo
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SPIND(ISYOP,MS2OP,IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB2,
     &                 PSI1,PSI2,SPD12)
      use stdalloc, only: mma_allocate, mma_deallocate
      use rassi_global_arrays, only: FSBANN1, FSBANN2
      use Symmetry_Info, only: MUL
      IMPLICIT NONE
      REAL*8 PSI1(*),PSI2(*),SPD12(*)
      REAL*8 COEFF,OVERLAP_RASSI,OVLP
      INTEGER IORBTAB(*),NASORB
      INTEGER ISSTAB(*)
      INTEGER IFSBTAB1(*),IFSBTAB2(*)
      INTEGER IJSORB,IMODE,ISORB
      INTEGER NDETS1,NDETS2
      INTEGER JSORB
      INTEGER ISYOP,MS2OP,KOINFO
      INTEGER ISMLAB,ISPLAB,JSYM,JMS2,JSMLAB,JSPLAB
      EXTERNAL OVERLAP_RASSI
      Real*8, Allocatable:: ANN1(:), ANN2(:)

CTEST      write(*,*)' Test prints in SPIND.'
C Nr of active spin-orbitals
      NASORB= IORBTAB(4)
C Loop over pairs of spin orbitals ISORB,JSORB:
      KOINFO=19
      DO ISORB=1,NASORB
       ISMLAB=IORBTAB(KOINFO+1+8*(ISORB-1))
CUNUSED       ISOIND=IORBTAB(KOINFO+2+8*(ISORB-1))
       ISPLAB=IORBTAB(KOINFO+3+8*(ISORB-1))
C Annihilate a single orbital:
       COEFF=1.0D0
       IMODE=-1
       Call FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB1,1)
       NDETS1=FSBANN1(5)
       CALL mma_allocate(ANN1,NDETS1,Label='ANN1')
       ANN1(:)=0.0D0
       CALL PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,FSBANN1,
     &                   IFSBTAB1,COEFF,ANN1,PSI1)
CTEST       write(*,*)' Prior to call to PRIMSGM.'
CTEST       write(*,*)' FS block structure at FSBANN1:'
CTEST       CALL PRFSBTAB(FSBANN1)
CTEST       write(*,*)' Wave function ANN1 after PRIMSGM:'
CTEST       PRTHR=0.01D0
CTEST       CALL PRWVF(IORBTAB,ISSTAB,FSBANN1,PRTHR,ANN1)
C Compute those ANN2 wave functions, which have the correct properties:
       JSYM=MUL(ISMLAB,ISYOP)
       JMS2= MS2OP+ISPLAB
       DO JSORB=1,NASORB
        OVLP=0.0D0
        JSMLAB=IORBTAB(KOINFO+1+8*(JSORB-1))
        IF(JSMLAB.NE.JSYM) GOTO 100
CUNUSED        JSOIND=IORBTAB(KOINFO+2+8*(JSORB-1))
        JSPLAB=IORBTAB(KOINFO+3+8*(JSORB-1))
        IF(JSPLAB.NE.JMS2) GOTO 100
        COEFF=1.0D0
        IMODE=-1
        Call FSBOP(IMODE,JSORB,IORBTAB,ISSTAB,IFSBTAB2,2)
        NDETS2=FSBANN2(5)
        CALL mma_allocate(ANN2,NDETS2,Label='ANN2')
        ANN2(:)=0.0D0
        CALL PRIMSGM(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN2,
     &                   IFSBTAB2,COEFF,ANN2,PSI2)

C Compute the spin transition density matrix element:
        OVLP=OVERLAP_RASSI(FSBANN1,FSBANN2,ANN1,ANN2)
CTEST       write(*,*)' Their overlap:',OVLP
        CALL mma_deallocate(ANN2)
        CALL mma_deallocate(FSBANN2)
 100    CONTINUE
        IJSORB=ISORB+NASORB*(JSORB-1)
        SPD12(IJSORB)=OVLP
       END DO
       CALL mma_deallocate(ANN1)
       CALL mma_deallocate(FSBANN1)
      END DO

      END SUBROUTINE SPIND

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_Density3(irc,CMO)
!***********************************************************************
!     Jonas Bostrom, March 2010.                                       *
!                                                                      *
!     Purpose: Finalize MP2 Density.                                   *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Cholesky, only: nSym
use Cholesky_procedures, only: Build_Mp2Dens
use ChoMP2, only: MP2D, MP2D_e, MP2W, MP2W_e, nDel, nOrb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp) :: i, iSym, j, lTriDens, nOrbAll(8)
real(kind=wp), allocatable :: AOTriDens(:), WAOTriDens(:)

!                                                                      *
!***********************************************************************
!                                                                      *
irc = 0

nOrbAll(:) = nOrb(:)+nDel(:)

lTriDens = 0
do iSym=1,nSym
  lTriDens = lTriDens+nTri_Elem(nOrbAll(iSym))
end do

do iSym=1,nSym
  do i=1,nOrbAll(iSym)
    do j=1,nOrbAll(iSym)
      if ((i <= nOrb(iSym)) .and. (j <= nOrb(iSym))) then
        MP2D_e(iSym)%A(i,j) = MP2D(iSym)%A(i,j)
        MP2W_e(iSym)%A(i,j) = MP2W(iSym)%A(i,j)
      else
        MP2D_e(iSym)%A(i,j) = Zero
        MP2W_e(iSym)%A(i,j) = Zero
      end if
    end do
  end do
end do

call mma_allocate(AOTriDens,lTriDens,Label=' AOTriDens')
call mma_allocate(WAOTriDens,lTriDens,Label='WAOTriDens')
AOTriDens(:) = Zero
WAOTriDens(:) = Zero

call Build_Mp2Dens(AOTriDens,lTriDens,MP2D_e,CMO,nSym,nOrbAll,.true.)
call Build_Mp2Dens(WAOTriDens,lTriDens,MP2W_e,CMO,nSym,nOrbAll,.false.)

call Put_dArray('D1aoVar',AOTriDens,lTriDens)
call Put_dArray('FockOcc',WAOTriDens,lTriDens)

call mma_deallocate(AOTriDens)
call mma_deallocate(WAOTriDens)

end subroutine ChoMP2g_Density3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,2017, Roland Lindh                                *
*               1995, Per-Olof Widmark                                 *
*               1995, Markus P. Fuelscher                              *
*               1995, Piotr Borowski                                   *
*               1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine DIIS_x(nD,CInter,nCI,QNRStp,HDiag,mOV,Ind)
************************************************************************
*                                                                      *
*     purpose: Accelerate convergence using DIIS method                *
*                                                                      *
*     input:                                                           *
*                                                                      *
*     output:                                                          *
*       CInter  : Interpolation coefficients of length nCI             *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*     calls to: GrdClc, Gauss, OptClc                                  *
*               uses SubRoutines and Functions from Module lnklst.f    *
*               -linked list implementation to store series of vectors *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     modified by:                                                     *
*     P.O. Widmark, M.P. Fuelscher, P. Borowski & M.Schuetz            *
*     University of Lund, Sweden, 1995                                 *
*                                                                      *
*     Derived from code for c1- and c2-DIIS as implemented by          *
*     R. Lindh in Slapaf and SCF in 1994.                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
*
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
#include "stdalloc.fh"
#include "file.fh"
#include "llists.fh"
*
      Real*8 CInter(nCI,nD), HDiag(mOV,nD)
      Real*8, Dimension(:,:), Allocatable:: EVector, Bij
      Real*8, Dimension(:), Allocatable:: EValue, Err1, Err2, Scratch
*
*---- Define local variables
      Integer Ind(MxOptm)
      Real*8 GDiis(MxOptm + 1),BijTri(MxOptm*(MxOptm + 1)/2)
      Logical QNRstp
*define _NEW_CODE_
#ifdef _NEW_CODE_
      Logical Ignore
#endif
      Character*80 Text,Fmt
*
*---- Statement function for triangular index
      iTri(i,j) = i*(i-1)/2 + j
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Call Timing(Cpu1,Tim1,Tim2,Tim3)
*
#ifdef _NEW_CODE_
      Do i = kOptim, 1, -1
         Ind(i)=0
*
         tmp0= 0.0D0
         Do j = 1, iter
*
            Ignore=.False.
            Do k = kOptim, i+1, -1
               Ignore = Ignore .or. Ind(k).eq.j
            End Do
            If (Ignore) Cycle
*
            tmp = 0.0D0
            Do iD = 1, nD
               tmp = tmp + Elst(j,iD)
            End Do
*
            If (tmp.lt.tmp0) Then
               tmp0=tmp
               Ind(i)=j
            End If
*
         End Do
      End Do
      Write (6,*) (Ind(i),i=1,kOptim)
#else
      Do i = 1, kOptim
         Ind(i) = iter-kOptim+i
      End Do
#endif
*
*-----The following piece of code computes the DIIS coeffs
*     with error vectors chosen as the grds (DIIS only)
*     or as delta=-Hinv*grd (QNR/DIIS)
*
*-----in case of QNR step: grd already calculated in LinSer
*     or above...
*     in case of DIIS only: grd already calculated above
*
*     Allocate memory for error vectors (gradient or delta)
*
      Call mma_allocate(Err1,nOV*nD,Label='Err1')
      Call mma_allocate(Err2,nOV*nD,Label='Err2')
      nBij=kOptim+1
      Call mma_allocate(Bij,nBij,nBij)
      Call FZero(Bij,nBij**2)
*
*---- Compute norms, <e_i|e_j>
*
      Do i=1,kOptim
         Call ErrV(nOV*nD,Ind(i),QNRstp,Err1,HDiag)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
         Call NrmClc(Err1,nOV*nD,'Diis  ','Err1  ')
#endif
         Do j=1,i-1

            Call ErrV(nOV*nD,Ind(j),QNRstp,Err2,HDiag)
#ifdef _DEBUGPRINT_
            Call NrmClc(Err2,nOV*nD,'Diis  ','Err2  ')
#endif
            Bij(i,j) = DBLE(nD)*DDot_(nOV*nD,Err1,1,Err2,1)
            Bij(j,i) = Bij(i,j)
         End Do
         Bij(i,i) = DBLE(nD)*DDot_(nOV*nD,Err1,1,Err1,1)
      End Do
*
*---- Deallocate memory for error vectors & gradient
      Call mma_deallocate(Err2)
      Call mma_deallocate(Err1)
*
*---- Should we perform emergency convergence?
*
      Bsmall=Bij(1,1)
      Do i=2,kOptim
         Bsmall=Min(Bsmall,Bij(i,i))
      End Do
*
      If (Bsmall.lt.1.0d-30) Then
*        EmConv=.true.
*        Write (6,*) 'Bsmall.lt.1.0D-30'
*        Write (6,*) 'Bsmall=',BSmall
      End If
*
#ifdef _DEBUGPRINT_
      Write(6,*)'   Calculation of the norms in Diis :'
      Fmt  = '(6f16.8)'
      Text = 'B-matrix squared in Diis :'
      Call RecPrt(Text,Fmt,Bij,nBij,nBij)
      Write(6,*)
      Write(6,*)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Here, the DIIS coeffs for DIIS only or QNR/DIIS are
*     computed, either with C1DIIS or C2DIIS
*     (-> stored in vector CInter)
*                                                                      *
************************************************************************
*                                                                      *
      If (.not.c1Diis) Then
*                                                                      *
*-------   C2DIIS case                                                 *
*                                                                      *
*         References:                                                  *
*         H. Sellers, Int. J. Quantum Chem. 45, 31-41(1993).           *
*         doi:10.1002/qua.560450106                                    *
*                                                                      *
************************************************************************
*                                                                      *
         If (QNRStp) Then
            AccCon = 'QNRc2DIIS'
         Else
            AccCon = 'c2DIIS   '
         End If
*
*------- Form a unit eigenvector matrix
         Call mma_allocate(EVector,kOptim,kOptim)
         Call mma_allocate(EValue,kOptim)
*
         call dcopy_(kOptim**2,[Zero],0,EVector,       1)
         call dcopy_(kOptim,   [One], 0,EVector,kOptim+1)
*
*------- Form a triangular B-matrix
*
         ij = 1
         Do i = 1, kOptim
            call dcopy_(i,Bij(i,1),nBij,BijTri(ij),1)
            ij = ij + i
         End Do
*
#ifdef _DEBUGPRINT_
         Fmt  = '(5g25.15)'
         Text = 'B-matrix before Jacobi :'
         Call TriPrt(Text,Fmt,BijTri,kOptim)
         Text = 'EigenVectors before Jacobi :'
         Call RecPrt(Text,Fmt,EVector,kOptim,kOptim)
         Write(6,*)
         Write(6,*)
#endif
*
*------- Diagonalize B-matrix
*
         EMax=0.0D0
         Do i = 1, kOptim*(kOptim+1)/2
            EMax=Max(EMax,Abs(BijTri(i)))
         End Do
         Do i = 1, kOptim*(kOptim+1)/2
            If (Abs(BijTri(i)).lt.EMax*1.0D-14) BijTri(i)=0.0D0
         End Do
*
         Call mma_allocate(Scratch,kOptim**2,Label='Scratch')
*
         Dummy=0.0D0
         iDum=0
         Call Diag_Driver('V','A','L',kOptim,BijTri,
     &                    Scratch,kOptim,Dummy,Dummy,iDum,iDum,
     &                    EValue,EVector,kOptim,1,0,'J',
     &                    nFound,iErr)
*
         Call mma_deallocate(Scratch)
         Call dCopy_(kOptim*(kOptim+1)/2,[Zero],0,BijTri,1)
*
         iDiag = 0
         Do i = 1,kOptim
            iDiag = iDiag + i
            BijTri(iDiag) = EValue(i)
         End Do
*
#ifdef _DEBUGPRINT_
         Fmt  = '(5g25.15)'
         Text = 'B-matrix after Jacobi :'
         Call TriPrt(Text,Fmt,BijTri,kOptim)
         Text = 'EigenValues :'
         Call RecPrt(Text,Fmt,EValue,1,kOptim)
         Text = 'EigenVectors :'
         Call RecPrt(Text,Fmt,EVector,kOptim,kOptim)
         Write(6,*)
         Write(6,*)
#endif
*
*------  Renormalize the eigenvectors and eigenvalues to the
*        C1-DIIS format
*
#ifdef _DEBUGPRINT_
         Write(6,*)' Normalization constants :'
#endif
*
         Do iVec = 1, kOptim
            Alpha = Zero
            Do i = 1, kOptim
               Alpha = Alpha + EVector(i,iVec)
            End Do
*
#ifdef _DEBUGPRINT_
            Fmt = '(A7,i2,A4,f16.8)'
            Write(6,Fmt)' Alpha(',iVec,') = ',Alpha
#endif
*
            Alpha = One/Alpha
            Call DScal_(kOptim,Alpha,EVector(1,iVec),1)
            iPos = iTri(iVec,iVec)
            BijTri(iPos) = BijTri(iPos) * Alpha**2
            EValue(iVec) = EValue(iVec)   * Alpha**2
         End Do
*
#ifdef _DEBUGPRINT_
         Fmt  = '(6e16.8)'
         Text = 'B-matrix after scaling :'
         Call TriPrt(Text,Fmt,BijTri,kOptim)
         Text = 'EigenValues after scaling :'
         Call RecPrt(Text,Fmt,EValue,1,kOptim)
         Text = 'EigenVectors after scaling :'
         Call RecPrt(Text,Fmt,EVector,kOptim,kOptim)
         Write(6,*)
         Write(6,*)
#endif
*------  Set up thresholds
         Thrld  = 1.0D-15
         ThrCff = 1.0d+00*Ten
*
*------  Select a vector.
         ee1   = 1.0D+72
         cDotV = 1.0D+72
         t1    = 0.0D0
         ipBst =-99999999
         Do iVec = 1, kOptim
*
*           Pick up eigenvalue (ee2) and the norm of the
*           eigenvector (c2).
*
            ee2 = BijTri(iTri(iVec,iVec))
            c2 = DDot_(kOptim,EVector(1,iVec),1,EVector(1,iVec),1)
            t2 = Abs(EVector(kOptim,iVec))/Sqrt(c2)
*
*---------  Reject if <e|e> is too low (round-off),
*           analys further.
*
            If (ee2.lt.Thrld) Then
#ifdef _DEBUGPRINT_
               Fmt  = '(A,i2,5x,g12.6)'
               Text = '<e|e> is low,         iVec, <e|e> = '
               Write(6,Fmt)Text(1:36),iVec,ee2
#endif
*
*------------  Reject if coefficients are too large (linear dep.).
*
               If (Sqrt(c2).gt.ThrCff) Then
#ifdef _DEBUGPRINT_
                  Fmt  = '(A,i2,5x,g12.6)'
                  Text = 'c**2 is too large,     iVec, c**2 = '
                  Write(6,Fmt)Text(1:36),iVec,c2
#endif
                  Go To 520
               End If
            End If
*
*---------  Reject if coefficients are too large (linear dep.).
*
            If (Sqrt(c2).gt.ThrCff*Two) Then
#ifdef _DEBUGPRINT_
               Fmt  = '(A,i2,5x,g12.6)'
               Text = 'c**2 is too large,     iVec, c**2 = '
               Write(6,Fmt)Text(1:36),iVec,c2
#endif
               Go To 520
            End If
*
*-----------Keep the best candidate
*
            If (ee2*Five.lt.ee1) Then
*-----------   New vector much lower eigenvalue.
               ee1   = ee2
               ipBst = iVec
               cDotV = c2
               t2 = t1
            Else If (ee2.le.ee1*Three) Then
*-----------   New vector is close to the old vector.
*              Selection based on relative weight of the last
*              density.
               If (t2.gt.t1*4.0d0) Then
*--------------   New vector much better relative weight.
                  ee1   = ee2
                  ipBst = iVec
                  cDotV = c2
                  t2 = t1
               Else If (t2*1.2d0.lt.t1) Then
*--------------   Vectors are close in relative weight too!
*                 Select on eigenvalue only
                  If (ee2.lt.ee1) Then
                     ee1   = ee2
                     ipBst = iVec
                     cDotV = c2
                     t2 = t1
                  End If
               End If
            End If
*
 520        Continue
*
         End Do
*
         If (ipBst.lt.1 .or. ipBst.gt.kOptim) Then
            Write(6,*)' No proper solution found in C2-DIIS !'
            Fmt  = '(6e16.8)'
            Text = 'EigenValues :'
            Call RecPrt(Text,Fmt,EValue,1,kOptim)
            Text = 'EigenVectors :'
            Call RecPrt(Text,Fmt,EVector,kOptim,kOptim)
            Call ErrTra
            Call Quit_OnConvError()
         End If
         call dcopy_(kOptim,EVector(1,ipBst),1,CInter(1,1),1)
*
#ifdef _DEBUGPRINT_
         Write(6,*)
         Write(6,*)' Selected root :',ipBst
         Write(6,'(A,f16.8)')'  c**2 =         ',cDotV
#endif
*
         Call mma_deallocate(EValue)
         Call mma_deallocate(EVector)
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
*------- C1DIIS                                                        *
*                                                                      *
*         References:                                                  *
*         P. Csaszar and P. Pulay, J. Mol. Struc., 114, 31-34 (1984).  *
*         doi:10.1016/S0022-2860(84)87198-7                            *
*                                                                      *
************************************************************************
*                                                                      *
         If (QNRStp) Then
            AccCon = 'QNRc1DIIS'
         Else
            AccCon = 'c1DIIS   '
         End If
*
*        Set up the missing part of the matrix in Eq. (5) and the
*        vector on the RHS in the same equation. Note the sign change!
*
         Do i = 1, kOptim
            Bij(kOptim + 1,i) = - One ! note sign change
            Bij(i,kOptim + 1) = - One ! note sign change
            GDiis(i)          =   Zero
         End Do
         Bij(kOptim + 1,kOptim + 1) =   Zero
         GDiis(kOptim + 1)          = - One  ! note sign change
*
#ifdef _DEBUGPRINT_
         Write(6,*)' B matrix in DIIS_e:'
         Do i = 1, kOptim + 1
            Write(6,'(7f16.8)')(Bij(i,j),j = 1, kOptim + 1),
     &                          GDiis(i)
         End Do
#endif
*
*------- Add penalty function, new version
*
* ...    Pfact1: c_k tend to one
* ...    Pfact2: c_i (i!=k) tend to zero
* ...    Pfact3: c_k tend to zero
*
         Pfact1 = Max(0.0d0  * Bsmall, 0.0d0  )
         Pfact2 = Max(1.0d-2 * Bsmall, 1.0d-14)
         Pfact3 = Max(1.0d-2 * Bsmall, 1.0d-14)
*
         Do i=1,kOptim
            Bij(i,i)=Bij(i,i)+Pfact2
         End Do
         Bij(kOptim,kOptim) = Bij(kOptim,kOptim) + Pfact1
         Bij(kOptim,kOptim) = Bij(kOptim,kOptim) + Pfact3 -Pfact2
         GDiis(kOptim) = Pfact1
*
*------- Condition the B matrix
*
         B11 = Sqrt(Bij(1,1)*Bij(kOptim,kOptim))
         Do i = 1, kOptim
            Do j = 1, kOptim
               Bij(i,j) = Bij(i,j)/B11
            End Do
         End Do
*
*------- Solve for the coefficients, solve the equations.
*
         Call Gauss(kOptim + 1,nBij,Bij,CInter(1,1),GDiis)
*
*------- Normalize sum of interpolation coefficients
*
         Fact = Zero
         Do i = 1, kOptim
            Fact = Fact + CInter(i,1)
         End Do
*
         Fact = One/Fact
         Do i = 1, kOptim
            CInter(i,1) = Fact*CInter(i,1)
         End Do
*
*------- Make sure new density gets a weight
         Call C_Adjust(CInter(1,1),kOptim,0.05D0)
*                                                                      *
************************************************************************
*                                                                      *
      End If
*
      Call mma_deallocate(Bij)
*
*     Temporary fix for UHF.
*
      If (nD.eq.2) Call DCopy_(nCI,CInter(1,1),1,CInter(1,2),1)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Fmt  = '(6e16.8)'
      Text = 'The solution vector :'
      Call RecPrt(Text,Fmt,CInter(1,1),1,kOptim)
#endif
*
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld( 6) = TimFld( 6) + (Cpu2 - Cpu1)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Precaii(iB,is,js,nd,ir,rOut,nbai,nbaj,
     &                   fockii,fockai,fockti,
     &                   focki,focka,fock,sign,
     &                   A_J,A_K,Scr,nScr)
************************************************************************
*                                                                      *
*                                        [2]                           *
*   Calculates the diagonal submatrix of E    that couple              *
*                                                                      *
*   kappa                with   kappa                for a             *
*        kactive,inactive            kactive,inactive                  *
*                                                                      *
*   single active index.                                               *
*   Used for preconditioner.                                           *
*                                                                      *
*   See Olsen,Yeager, Joergensen:                                      *
*    "Optimization and characterization of an MCSCF state"             *
*                                                                      *
*     Eq. C.12a                                                        *
*                                                                      *
*   Called by prec                                                     *
*                                                                      *
*   ib,is       :       active index for the submatrix                 *
*   js          :       symmetry of inactive,inactive                  *
*   rOut        :       Submatrix                                      *
*                                                                      *
************************************************************************
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "WrkSpc.fh"
#include "Pointers.fh"
      Real*8 Fock(nbaj,nbaj),FockA(nBaj,nBaj),Focki(nbaj,nbaj)
      Real*8 rout(nd*(nd+1)/2), A_J(nScr), A_K(nScr), Scr(nScr)
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      iTri1(i,j)=nTri-itri(nd-Min(i,j)+1,nd-Min(i,j)+1)
     &          +Max(i,j)-Min(i,j)+1
*                                                                      *
************************************************************************
*                                                                      *
      nTri=itri(nd,nd)
      iBB=ib+nA(is)
      iiB=ib+nish(is)
*                                                                      *
************************************************************************
*                                                                      *
      Do jA=1,nIsh(jS)
         Do jB=1,jA
*
            i=itri1(ja,jb)
*
            Do kS=1,nSym
*
               Call Coul(kS,kS,jS,jS,jA,jB,A_J,Scr)
               Call Exch(kS,jS,kS,jS,jA,jB,A_K,Scr)
*
               Do jC=1,nAsh(ks)
                  jCC=jC+nA(ks)
                  jjC=jC+nIsh(ks)
                  Do jD=1,nAsh(kS)
                     jDD=jD+nA(ks)
                     jjD=jD+nIsh(ks)
*
*                    gamma(cdbb)=gamma(bbcd)
*
                     rDens1=sign*Work(ipg2-1+itri(itri(jCC,jDD),
     &                           itri(iBB,iBB)))
*
*                    gamma(bdcb)
*
                     rDens2=sign*work(ipg2-1+itri(itri(iBB,jDD),
     &                           itri(jCC,iBB)))
*
*                    (cd|ij)
*
                     icd=(jjD-1)*nBas(kS)+jjC
                     cdij=A_J(icd)
                     cidj=A_K(icd)
                     rout(i) = rout(i) + 2.0d0*(rDens2*cidj
     &                                 + 2.0d0* rDens1*cdij)
                  End Do
               End Do
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Do iC=1,nAsh(is)
         iCC=ic+nA(is)
         iiC=iC+nIsh(is)
*
*        2*(delta(bc)-D(bc))
*
         rDens=sign*(-work(ipg1-1+itri(iCC,iBB)))
         If (iCC.eq.iBB) rdens=rdens+sign
         rDens=2.0D0*rDens
*
         Call Coul(jS,jS,iS,iS,iiB,iiC,A_J,Scr)
         Call Exch(jS,iS,jS,iS,iiB,iiC,A_K,Scr)
*
         Do jA=1,nIsh(jS)
            Do jB=1,jA
               i=itri1(jA,jB)
*
*              (ci|bj)
*              (bi|cj)
*
               icb = (jB-1)*nBas(jS) + jA
               ibc = (jA-1)*nBas(jS) + jB
               cibj=A_K(icb)
               bicj=A_K(ibc)
*
*              (bc|ij)
*
               bcij=A_J(ibc)
*
               rout(i)=rout(i)+rdens*(       7.0d0*cibj
     &                                 -sign*      bicj
     &                                 -sign*2.0D0*bcij )
*
            End Do
         End Do
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      rFock = sign*2.0d0*Fockii + sign*2.0d0*Fockai - sign*Fockti
      rdens=sign*2.0d0*Work(ipG1-1+itri(ibb ,ibb))
      i=0 ! dummy initialize
*
      Do jA=1,nIsh(jS)
         Do jB=1,jA
*
            i=itri1(ja,jb)
*
            rout(i) = rout(i) - sign*4.0d0*( Focka(jA,jB)
     &                                      +Focki(jA,jB) )
     &                        + rdens*Focki(ja,jb)
         End Do
         rout(i) = rout(i) + 2.0d0*rfock
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(ir)
         Call Unused_integer(nbai)
         Call Unused_real_array(fock)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

function CalcNSumVee(RotMat,DDg)

use rasscf_global, only: lRoots
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp

implicit none
real(kind=wp) :: CalcNSumVee
real(kind=wp), intent(in) :: RotMat(lRoots,lRoots), DDG(lRoots,lRoots,lRoots,lRoots)
real(kind=wp), allocatable :: Vee(:)

call mma_allocate(Vee,lRoots)
call CalcVee(Vee,RotMat,DDg)
CalcNSumVee = sum(Vee(:))
call mma_deallocate(Vee)

end function CalcNSumVee

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Bingbing Suo                                     *
!***********************************************************************
! Jul. 3, 2009 -BSUO- External space loops

!subroutine dd_ext_plpmode(ilnodesm,irnodesm)
!
!use gugaci_global, only: logic_g13, logic_g1415, logic_g36a, logic_g36b
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: ilnodesm, irnodesm
!
!logic_g36a = .false.
!logic_g36b = .false.
!logic_g1415 = .false.
!logic_g13 = .false.
!if (ilnodesm < irnodesm) then
!  logic_g36a = .true.
!else if (ilnodesm == irnodesm) then
!  logic_g36a = .true.
!  logic_g36b = .true.
!  logic_g1415 = .true.
!  logic_g13 = .true.
!else
!  logic_g36b = .true.
!end if
!
!end subroutine dd_ext_plpmode

subroutine external_space_plpmode_value_dv()

use gugaci_global, only: w0g25, w0g25a, w1g25a

use Constants, only: One

implicit none

! sd   lpmode_value
w0g25 = -One
w0g25a = -One
w1g25a = -One

end subroutine external_space_plpmode_value_dv

subroutine external_space_plpmode_value_vd()

use gugaci_global, only: v_sqtwo, w0g25, w0g25a, w1g25a

implicit none

! sd   lpmode_value
w0g25 = -v_sqtwo
w0g25a = -v_sqtwo
w1g25a = -v_sqtwo

end subroutine external_space_plpmode_value_vd

subroutine g12_t_diffsym(isma,ismb,ismc)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, ngw2, nlsm_ext, &
                         value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ismc
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, ip2cd, ip3smabc, ipos_intbasetmp, iposint, nsma, num_smab

if (isma < ismb) then
  ip3smabc = isma+jp2(ismb)+jp3(ismc)
  ip2cd = m_jc+(m_jd-1)*nlsm_ext(ismc)   !severe_new_error_1206
  num_smab = nlsm_ext(isma)*nlsm_ext(ismb)  !need checking
  ipos_intbasetmp = ip4_abcd_ext_base(ip3smabc)+(ip2cd-1)*num_smab*3
  ibsta = ibsm_ext(ismb)
  ibend = iesm_ext(ismb)
  iasta = ibsm_ext(isma)
  iaend = iesm_ext(isma)
  ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
  iposint = ipos_intbasetmp
  do ib=ibsta,ibend
    do ia=iasta,iaend
      value_lpext(ilwei) = vint_ci(iposint+1)-vint_ci(iposint+2)
      ilwei = ilwei+1
      iposint = iposint+3
    end do
  end do
else
  ip3smabc = isma+jp2(ismb)+jp3(ismc)
  ip2cd = m_jc+NGW2(m_jd)
  nsma = nlsm_ext(isma)
  num_smab = nsma*(nsma-1)/2   !need checking
  ipos_intbasetmp = ip4_abcd_ext_base(ip3smabc)+(ip2cd-1)*num_smab*3
  ibsta = ibsm_ext(ismb)+1
  ibend = iesm_ext(ismb)
  iasta = ibsm_ext(isma)
  iaend = iesm_ext(isma)
  ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
  iposint = ipos_intbasetmp
  do ib=ibsta,ibend
    do ia=iasta,ib-1
      value_lpext(ilwei) = vint_ci(iposint+1)-vint_ci(iposint+2)
      ilwei = ilwei+1
      iposint = iposint+3
    end do
  end do
end if

end subroutine g12_t_diffsym

subroutine g11a_t_diffsym(isma,ismb,ismc)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, nlsm_ext, &
                         value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ismc
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, ipos_intbasetmp, iposint, ipsmabc, jcoffset, jdoffset, num_smab

ipsmabc = isma+jp2(ismc)+jp3(ismb)
ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)
jdoffset = (m_jd-1)*nlsm_ext(ismb)
jcoffset = (m_jc-1)*nlsm_ext(isma)
num_smab = nlsm_ext(isma)*nlsm_ext(ismc)*3
ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
ipos_intbasetmp = ipos_intbasetmp+jdoffset*num_smab+jcoffset*3
do ib=ibsta,ibend
  iposint = ipos_intbasetmp
  do ia=iasta,iaend
    value_lpext(ilwei) = vint_ci(iposint)-vint_ci(iposint+2)
    iposint = iposint+3
    ilwei = ilwei+1
  end do
  ipos_intbasetmp = ipos_intbasetmp+num_smab
end do

end subroutine g11a_t_diffsym

subroutine g11b_t_diffsym(isma,ismb,ismc)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, nlsm_ext, &
                         value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ismc
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, ipos_intbasetmp, iposint, ipsmabc, jcoffset, jdoffset, num_smab, &
                     numint_jc

ipsmabc = ismc+jp2(isma)+jp3(ismb)
ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)
jdoffset = (m_jd-1)*nlsm_ext(ismb)
jcoffset = m_jc-1
num_smab = nlsm_ext(isma)*nlsm_ext(ismc)*3
numint_jc = nlsm_ext(ismc)*3
ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
ipos_intbasetmp = ipos_intbasetmp+jdoffset*num_smab+jcoffset*3
do ib=ibsta,ibend
  iposint = ipos_intbasetmp      !+jcoffset*3
  do ia=iasta,iaend
    value_lpext(ilwei) = vint_ci(iposint)-vint_ci(iposint+1)
    ilwei = ilwei+1
    iposint = iposint+numint_jc
  end do
  ipos_intbasetmp = ipos_intbasetmp+num_smab
end do

end subroutine g11b_t_diffsym

subroutine g1112_t_symaaaa(isma,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, ngw2, ngw3, ngw4, value_lpext, &
                         vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ic, id
integer(kind=iwp) :: ia, iabcdpos_11b, iasta, ib, ibcdpos_11a, ibcdpos_11b, ibsta, icdpos_11a, icdpos_11b, icdpos_12, ilwei, &
                     ipos_intbasetmp, iposint, ipsmabc, ja, jb

ipsmabc = isma+jp2(isma)+jp3(isma)
ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)

icdpos_12 = NGW4(m_jd)+NGW3(m_jc)
iasta = ibsm_ext(isma)
ibsta = iasta+1
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
iposint = ipos_intbasetmp+icdpos_12*3         !-3 unnecessary ?
do ib=ibsta,ic-1
  do ia=iasta,ib-1
    value_lpext(ilwei) = vint_ci(iposint+1)-vint_ci(iposint+2)
    ilwei = ilwei+1
    iposint = iposint+3
  end do
end do

icdpos_11a = NGW4(m_jd)+NGW2(m_jc)
jb = m_jc
do ib=ic+1,id-1
  jb = jb+1
  ibcdpos_11a = icdpos_11a+NGW3(jb)
  iposint = ipos_intbasetmp+ibcdpos_11a*3
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    value_lpext(ilwei) = vint_ci(iposint)-vint_ci(iposint+2)
    ilwei = ilwei+1
    iposint = iposint+3
  end do
end do

icdpos_11b = NGW4(m_jd)+m_jc
jb = m_jc+1
do ib=ic+2,id-1
  jb = jb+1
  ibcdpos_11b = icdpos_11b+NGW3(jb)
  ja = m_jc
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,ib-1
    ja = ja+1
    iabcdpos_11b = ibcdpos_11b+NGW2(ja)
    iposint = ipos_intbasetmp+iabcdpos_11b*3-3
    value_lpext(ilwei) = vint_ci(iposint)-vint_ci(iposint+1)
    ilwei = ilwei+1
  end do
end do

end subroutine g1112_t_symaaaa

subroutine g11a11b_t_symaacc(isma,ismc,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, ngw2, nlsm_ext, &
                         value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismc, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibdpos, ibsta, ilwei, ipos_intbasetmp, iposint, ipsmabc, ja, num_smab

ipsmabc = isma+jp2(isma)+jp3(ismc)
ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)
num_smab = nlsm_ext(isma)
num_smab = (num_smab*(num_smab-1))/2*3
ibsta = ibsm_ext(ismc)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)

ibdpos = NGW2(m_jd)
ipos_intbasetmp = ipos_intbasetmp+ibdpos*num_smab+NGW2(m_jc)*3
do ib=ibsta,id-1
  iposint = ipos_intbasetmp
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    value_lpext(ilwei) = vint_ci(iposint)-vint_ci(iposint+2)
    ilwei = ilwei+1
    iposint = iposint+3
  end do
  ipos_intbasetmp = ipos_intbasetmp+num_smab
end do

ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)
ibdpos = NGW2(m_jd)
ipos_intbasetmp = ipos_intbasetmp+ibdpos*num_smab+m_jc*3
do ib=ibsta,id-1
  iposint = ipos_intbasetmp
  ja = m_jc
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,iaend
    ja = ja+1
    iposint = ipos_intbasetmp+NGW2(ja)*3-3
    value_lpext(ilwei) = vint_ci(iposint)-vint_ci(iposint+1)
    ilwei = ilwei+1
  end do
  ipos_intbasetmp = ipos_intbasetmp+num_smab
end do

end subroutine g11a11b_t_symaacc

subroutine g36_t_ext(ismc,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, ip2_aa_ext_base, ip3_abd_ext_base, iwt_orb_ext, np3_abd_ext, value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismc, ic, id
integer(kind=iwp) :: ia, iasta, ilwei, ipos_g36, ipos_intbasetmp, iposint

ipos_intbasetmp = ip3_abd_ext_base+(id-1)*np3_abd_ext   !severe_new_
iasta = ibsm_ext(ismc)
ilwei = icnt_base+iwt_orb_ext(iasta,id)
do ia=iasta,ic-1
  ipos_g36 = iwt_orb_ext(ia,ic)-1
  iposint = ipos_intbasetmp+ipos_g36*2         !severe_new_error
  value_lpext(ilwei) = vint_ci(iposint+1)-vint_ci(iposint)+vint_ci(ip2_aa_ext_base+ipos_g36)
  ilwei = ilwei+1
end do

end subroutine g36_t_ext

subroutine g5_t_ext(ismd,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, ip2_aa_ext_base, ip3_abd_ext_base, iwt_orb_ext, np3_abd_ext, value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismd, ic, id
integer(kind=iwp) :: ib, ibsta, ilwei, ipos_g5, ipos_intbasetmp, iposint

ipos_intbasetmp = ip3_abd_ext_base+(ic-1)*np3_abd_ext
ibsta = ibsm_ext(ismd)
do ib=max(ic+1,ibsta),id-1
  ipos_g5 = iwt_orb_ext(ib,id)-1            !severe_new_error
  iposint = ipos_intbasetmp+ipos_g5*2         !severe_new_error
  ilwei = icnt_base+iwt_orb_ext(ic,ib)
  value_lpext(ilwei) = vint_ci(iposint+1)-vint_ci(iposint)+vint_ci(ip2_aa_ext_base+ipos_g5)
end do

end subroutine g5_t_ext

subroutine g9_t_ext(ismd,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, ip2_aa_ext_base, ip3_abd_ext_base, iwt_orb_ext, np3_abd_ext, value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismd, ic, id
integer(kind=iwp) :: ia, iasta, ilwei, ipos_g9, ipos_intbasetmp, iposint

ipos_intbasetmp = ip3_abd_ext_base+(ic-1)*np3_abd_ext
iasta = ibsm_ext(ismd)
ilwei = icnt_base+iwt_orb_ext(iasta,ic)
do ia=iasta,ic-1                     !severe_new_error
  ipos_g9 = iwt_orb_ext(ia,id)-1
  iposint = ipos_intbasetmp+ipos_g9*2      !severe_new_error
  value_lpext(ilwei) = vint_ci(iposint)-vint_ci(iposint+1)-vint_ci(ip2_aa_ext_base+ipos_g9)         !severe_new_
  ilwei = ilwei+1
end do

end subroutine g9_t_ext

subroutine gsd_determine_extarmode_paras(ismnodes,ismnoded,logic_sd)

use gugaci_global, only: ibsm_ext, ivaluesta_g26, iweista_g25, iweista_g26, iweista_g28, iwt_orb_ext, iwt_sm_s_ext, logic_g25a, &
                         logic_g25b, logic_g26, logic_g28a, nint_g25, nint_g28, nlsm_ext, nwei_g25, nwei_g26, nwei_g28
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismnodes, ismnoded
logical(kind=iwp), intent(in) :: logic_sd
integer(kind=iwp) :: iorbid, iorbisd, ismnodesd, numsmd, numsmsd

ismnodesd = Mul(ismnodes,ismnoded)
numsmd = nlsm_ext(ismnoded)
numsmsd = nlsm_ext(ismnodesd)
iorbid = ibsm_ext(ismnoded)
iorbisd = ibsm_ext(ismnodesd)

logic_g25a = .false.
logic_g25b = .false.
logic_g28a = .false.
logic_g26 = .false.
if (ismnoded > ismnodesd) then
  logic_g28a = .true.
  iweista_g28 = iwt_orb_ext(iorbisd,iorbid)
  nwei_g28 = numsmd
  nint_g28 = numsmsd
else if (ismnoded == ismnodesd) then
  logic_g25b = .true.
  iweista_g25 = iwt_orb_ext(iorbisd,iorbisd+1)
  nwei_g25 = numsmd
  nint_g25 = numsmsd
  iweista_g28 = iwt_orb_ext(iorbisd,iorbisd+1)
  nwei_g28 = numsmd
  nint_g28 = numsmsd
else
  logic_g25a = .true.
  iweista_g25 = iwt_orb_ext(iorbid,iorbisd)
  nwei_g25 = numsmd
  nint_g25 = numsmsd
end if
if ((ismnodes == 1) .and. logic_sd) then
  logic_g26 = .true.
  iweista_g26 = iwt_sm_s_ext+iorbid
  nwei_g26 = numsmd
  ivaluesta_g26 = 0
end if

end subroutine gsd_determine_extarmode_paras

subroutine g_dd_ext_sequence(ism)

use gugaci_global, only: ibsm_ext, icano_nnend, icano_nnsta, icnt_base, iesm_ext, norb_number, value_lpext, voint
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ism
integer(kind=iwp) :: ia, iasta, ib, ibend, ibsta, ilwei, lra, lrb

icano_nnsta = 2
icnt_base = 0
iasta = ibsm_ext(ism)
ibsta = iasta+1
ibend = iesm_ext(ism)
ilwei = 0
do ib=ibsta,ibend
  lrb = norb_number(ib)
  do ia=iasta,ib-1
    lra = norb_number(ia)
    ilwei = ilwei+1
    value_lpext(ilwei) = voint(lrb,lra)
  end do
end do
icano_nnend = ibend-iasta+1
call complete_ext_loop()

end subroutine g_dd_ext_sequence

subroutine g_ss_ext_sequence(ism,itype)

use gugaci_global, only: ibsm_ext, icano_nnend, icano_nnsta, icnt_base, iesm_ext, iwt_orb_ext, iwt_sm_s_ext, m_jc, m_jd, &
                         max_tmpvalue, ng_sm, norb_ext
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ism, itype
integer(kind=iwp) :: ic, ic_sta, icano_nn, icend, id, id_sta, idend, idsta, isma, ismb, ismc, ismd

icano_nnsta = 2
icnt_base = 0
do ismd=1,ng_sm
  ismc = Mul(ism,ismd)
  if (ismc > ismd) cycle
  id_sta = ibsm_ext(ismd)
  idsta = id_sta
  idend = iesm_ext(ismd)
  ic_sta = ibsm_ext(ismc)
  icend = iesm_ext(ismc)
  if (ismd == ismc) idsta = idsta+1
  do id=idsta,idend
    m_jd = id-id_sta+1
    do ic=ic_sta,min(icend,id-1)
      m_jc = ic-ic_sta+1
      icano_nn = iwt_orb_ext(ic,id)
      if (icnt_base+icano_nn-1 > max_tmpvalue) then
        call complete_ext_loop()
        icnt_base = 0
        icano_nnsta = icano_nn
      end if
      icano_nnend = icano_nn
      do ismb=1,ismd-1
        isma = Mul(ism,ismb)
        if (isma > ismb) cycle
        if (ismc > ismb) then
          call g12_diffsym(isma,ismb,ismc)
        else if (ismc > isma) then
          call g11a_diffsym(isma,ismb,ismc)
        else
          call g11b_diffsym(isma,ismb,ismc)
        end if
      end do
      if (ism == 1) then
        isma = ismd
        call g1112_symaaaa(isma,ic,id)
      else
        isma = Mul(ism,ismd)
        call g11a11b_symaacc(isma,ismd,ic,id)
      end if
      call g10_ext(ismc,ic,id)
      call g5_ext(ismd,ic,id)
      if (ism == 1) call g9_ext(ismd,ic,id)
      icnt_base = icnt_base+icano_nn-1
    end do
  end do
end do
if ((ism == 1) .and. (itype == 4)) then
  do id=1,norb_ext
    icano_nn = id+iwt_sm_s_ext
    if (icnt_base+icano_nn-1 > max_tmpvalue) then
      call complete_ext_loop()
      icnt_base = 0
      icano_nnsta = icano_nn
    end if
    icano_nnend = icano_nn
    call ext_lp_ab_s1(id)
    icnt_base = icnt_base+icano_nn-1
  end do
end if
call complete_ext_loop()

end subroutine g_ss_ext_sequence

subroutine g12_diffsym(isma,ismb,ismc)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, ngw2, nlsm_ext, &
                         value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ismc
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, ip2cd, ip3smabc, ipos_intbasetmp, iposint, nsma, num_smab

if (isma < ismb) then
  ip3smabc = isma+jp2(ismb)+jp3(ismc)
  ip2cd = m_jc+(m_jd-1)*nlsm_ext(ismc)      !severe_new_error_1206
  num_smab = nlsm_ext(isma)*nlsm_ext(ismb)  !need checking
  ipos_intbasetmp = ip4_abcd_ext_base(ip3smabc)+(ip2cd-1)*num_smab*3
  ibsta = ibsm_ext(ismb)
  ibend = iesm_ext(ismb)
  iasta = ibsm_ext(isma)
  iaend = iesm_ext(isma)
  ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
  iposint = ipos_intbasetmp
  do ib=ibsta,ibend
    do ia=iasta,iaend
      value_lpext(ilwei) = vint_ci(iposint+1)+vint_ci(iposint+2)
      ilwei = ilwei+1
      iposint = iposint+3
    end do
  end do
else
  ip3smabc = isma+jp2(ismb)+jp3(ismc)
  ip2cd = m_jc+NGW2(m_jd)
  nsma = nlsm_ext(isma)
  num_smab = nsma*(nsma-1)/2   !need checking
  ipos_intbasetmp = ip4_abcd_ext_base(ip3smabc)+(ip2cd-1)*num_smab*3
  ibsta = ibsm_ext(ismb)+1
  ibend = iesm_ext(ismb)
  iasta = ibsm_ext(isma)
  iaend = iesm_ext(isma)
  ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
  iposint = ipos_intbasetmp
  do ib=ibsta,ibend
    do ia=iasta,ib-1
      value_lpext(ilwei) = vint_ci(iposint+1)+vint_ci(iposint+2)
      ilwei = ilwei+1
      iposint = iposint+3
    end do
  end do
end if

end subroutine g12_diffsym

subroutine g11a_diffsym(isma,ismb,ismc)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, nlsm_ext, &
                         value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ismc
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, ipos_intbasetmp, iposint, ipsmabc, jcoffset, jdoffset, num_smab

ipsmabc = isma+jp2(ismc)+jp3(ismb)
ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)
jdoffset = (m_jd-1)*nlsm_ext(ismb)
jcoffset = (m_jc-1)*nlsm_ext(isma)
num_smab = nlsm_ext(isma)*nlsm_ext(ismc)*3
ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
ipos_intbasetmp = ipos_intbasetmp+jdoffset*num_smab+jcoffset*3
do ib=ibsta,ibend
  iposint = ipos_intbasetmp
  do ia=iasta,iaend
    value_lpext(ilwei) = vint_ci(iposint)+vint_ci(iposint+2)
    iposint = iposint+3
    ilwei = ilwei+1
  end do
  ipos_intbasetmp = ipos_intbasetmp+num_smab
end do

end subroutine g11a_diffsym

subroutine g11b_diffsym(isma,ismb,ismc)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, nlsm_ext, &
                         value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ismc
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, ipos_intbasetmp, iposint, ipsmabc, jcoffset, jdoffset, num_smab, &
                     numint_jc

ipsmabc = ismc+jp2(isma)+jp3(ismb)
ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)
jdoffset = (m_jd-1)*nlsm_ext(ismb)
jcoffset = m_jc-1
num_smab = nlsm_ext(isma)*nlsm_ext(ismc)*3
numint_jc = nlsm_ext(ismc)*3
ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
ipos_intbasetmp = ipos_intbasetmp+jdoffset*num_smab+jcoffset*3
do ib=ibsta,ibend
  iposint = ipos_intbasetmp      !+jcoffset*3
  do ia=iasta,iaend
    value_lpext(ilwei) = vint_ci(iposint)+vint_ci(iposint+1)
    ilwei = ilwei+1
    iposint = iposint+numint_jc
  end do
  ipos_intbasetmp = ipos_intbasetmp+num_smab
end do

end subroutine g11b_diffsym

subroutine g1112_symaaaa(isma,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, ngw2, ngw3, ngw4, value_lpext, &
                         vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ic, id
integer(kind=iwp) :: ia, iabcdpos_11b, iasta, ib, ibcdpos_11a, ibcdpos_11b, ibsta, icdpos_11a, icdpos_11b, icdpos_12, ilwei, &
                     ipos_intbasetmp, iposint, ipsmabc, ja, jb

ipsmabc = isma+jp2(isma)+jp3(isma)
ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)

icdpos_12 = NGW4(m_jd)+NGW3(m_jc)
iasta = ibsm_ext(isma)
ibsta = iasta+1
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
iposint = ipos_intbasetmp+icdpos_12*3         !-3 unnecessary ?
do ib=ibsta,ic-1
  !jb = jb+1
  do ia=iasta,ib-1
    value_lpext(ilwei) = vint_ci(iposint+1)+vint_ci(iposint+2)
    ilwei = ilwei+1
    iposint = iposint+3
  end do
end do

icdpos_11a = NGW4(m_jd)+NGW2(m_jc)
jb = m_jc
do ib=ic+1,id-1
  jb = jb+1
  ibcdpos_11a = icdpos_11a+NGW3(jb)
  iposint = ipos_intbasetmp+ibcdpos_11a*3
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    value_lpext(ilwei) = vint_ci(iposint)+vint_ci(iposint+2)
    ilwei = ilwei+1
    iposint = iposint+3
  end do
end do

icdpos_11b = NGW4(m_jd)+m_jc
jb = m_jc+1
do ib=ic+2,id-1
  jb = jb+1
  ibcdpos_11b = icdpos_11b+NGW3(jb)
  ja = m_jc
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,ib-1
    ja = ja+1
    iabcdpos_11b = ibcdpos_11b+NGW2(ja)
    iposint = ipos_intbasetmp+iabcdpos_11b*3-3
    value_lpext(ilwei) = vint_ci(iposint)+vint_ci(iposint+1)
    ilwei = ilwei+1
  end do
end do

end subroutine g1112_symaaaa

subroutine g11a11b_symaacc(isma,ismc,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, ip4_abcd_ext_base, iwt_orb_ext, jp2, jp3, m_jc, m_jd, ngw2, nlsm_ext, &
                         value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismc, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibdpos, ibsta, ilwei, ipos_intbasetmp, iposint, ipsmabc, ja, num_smab

ipsmabc = isma+jp2(isma)+jp3(ismc)
ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)
num_smab = nlsm_ext(isma)
num_smab = (num_smab*(num_smab-1))/2*3
ibsta = ibsm_ext(ismc)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)

ibdpos = NGW2(m_jd)
ipos_intbasetmp = ipos_intbasetmp+ibdpos*num_smab+NGW2(m_jc)*3
do ib=ibsta,id-1
  iposint = ipos_intbasetmp
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    value_lpext(ilwei) = vint_ci(iposint)+vint_ci(iposint+2)
    ilwei = ilwei+1
    iposint = iposint+3
  end do
  ipos_intbasetmp = ipos_intbasetmp+num_smab
end do

ipos_intbasetmp = ip4_abcd_ext_base(ipsmabc)
ibdpos = NGW2(m_jd)
ipos_intbasetmp = ipos_intbasetmp+ibdpos*num_smab+m_jc*3
do ib=ibsta,id-1
  iposint = ipos_intbasetmp
  ja = m_jc
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,iaend
    ja = ja+1
    iposint = ipos_intbasetmp+NGW2(ja)*3-3
    value_lpext(ilwei) = vint_ci(iposint)+vint_ci(iposint+1)
    ilwei = ilwei+1
  end do
  ipos_intbasetmp = ipos_intbasetmp+num_smab
end do

end subroutine g11a11b_symaacc

subroutine g10_ext(ismc,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, ip2_aa_ext_base, ip3_abd_ext_base, iwt_orb_ext, np3_abd_ext, value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismc, ic, id
integer(kind=iwp) :: ia, iasta, ilwei, ipos_g10, ipos_intbasetmp, iposint

ipos_intbasetmp = ip3_abd_ext_base+(id-1)*np3_abd_ext   !severe_new_
iasta = ibsm_ext(ismc)
ilwei = icnt_base+iwt_orb_ext(iasta,id)
do ia=iasta,ic-1
  ipos_g10 = iwt_orb_ext(ia,ic)-1
  iposint = ipos_intbasetmp+ipos_g10*2
  value_lpext(ilwei) = vint_ci(iposint+1)+vint_ci(iposint)+vint_ci(ip2_aa_ext_base+ipos_g10)
  ilwei = ilwei+1
end do

end subroutine g10_ext

subroutine g5_ext(ismd,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, ip2_aa_ext_base, ip3_abd_ext_base, iwt_orb_ext, np3_abd_ext, value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismd, ic, id
integer(kind=iwp) :: ib, ibsta, ilwei, ipos_g5, ipos_intbasetmp, iposint

ipos_intbasetmp = ip3_abd_ext_base+(ic-1)*np3_abd_ext
ibsta = ibsm_ext(ismd)
do ib=max(ic+1,ibsta),id-1
  ipos_g5 = iwt_orb_ext(ib,id)-1            !severe_new_error
  iposint = ipos_intbasetmp+ipos_g5*2         !severe_new_error
  ilwei = icnt_base+iwt_orb_ext(ic,ib)
  value_lpext(ilwei) = vint_ci(iposint+1)+vint_ci(iposint)+vint_ci(ip2_aa_ext_base+ipos_g5)
end do

end subroutine g5_ext

subroutine g9_ext(ismd,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, ip2_aa_ext_base, ip3_abd_ext_base, iwt_orb_ext, np3_abd_ext, value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismd, ic, id
integer(kind=iwp) :: ia, iasta, ilwei, ipos_g9, ipos_intbasetmp, iposint

ipos_intbasetmp = ip3_abd_ext_base+(ic-1)*np3_abd_ext
iasta = ibsm_ext(ismd)
ilwei = icnt_base+iwt_orb_ext(iasta,ic)
do ia=iasta,ic-1                     !severe_new_error
  ipos_g9 = iwt_orb_ext(ia,id)-1
  iposint = ipos_intbasetmp+ipos_g9*2      !severe_new_error
  value_lpext(ilwei) = vint_ci(iposint+1)+vint_ci(iposint)+vint_ci(ip2_aa_ext_base+ipos_g9)
  ilwei = ilwei+1
end do

end subroutine g9_ext

subroutine ext_lp_ab_s1(id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, ip2_aa_ext_base, ip2_dd_ext_base, ip3_abd_ext_base, ng_sm, ngw2, &
                         np3_abd_ext, v_sqtwo, value_lpext, vint_ci
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: id
integer(kind=iwp) :: ia, iasta, ib, ibend, ibsta, ic, ilwei, ipos_intbasetmp, iposint, iposintaa, ismb

ipos_intbasetmp = ip3_abd_ext_base+(id-1)*np3_abd_ext
ilwei = icnt_base
iposintaa = ip2_aa_ext_base-1
iposint = ipos_intbasetmp
do ismb=1,ng_sm
  iasta = ibsm_ext(ismb)
  ibend = iesm_ext(ismb)
  ibsta = iasta+1
  do ib=ibsta,ibend
    do ia=iasta,ib-1
      iposintaa = iposintaa+1
      if ((ib == id) .or. (ia == id)) then
        ! g2   arar+ar(head)ar
        ilwei = ilwei+1
        value_lpext(ilwei) = v_sqtwo*(vint_ci(iposintaa)+vint_ci(iposint))
      else
        ! g6g7g8
        ilwei = ilwei+1
        value_lpext(ilwei) = v_sqtwo*vint_ci(iposint)
      end if
      iposint = iposint+2
    end do
  end do
end do
! g1
!lw = lw0
iposint = ip2_dd_ext_base+NGW2(id)
do ic=1,id-1
  ilwei = ilwei+1
  value_lpext(ilwei) = vint_ci(iposint)
  iposint = iposint+1
end do

end subroutine ext_lp_ab_s1

subroutine g31_diffsym(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, intind_iabc, iwt_orb_ext, m_jd, nabc, ngw2, ngw3, value_lpext, vint_ci, &
                         w0plp31, w1plp31
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, iabc, iabc0, iaend, iasta, ib, ibend, ibsta, ic, ilwei, iposint

iabc0 = (lri-1)*nabc
ic = m_jd
ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
if (isma == ismb) ibsta = ibsta+1
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)
do ib=ibsta,ibend
  if (isma == ismb) iaend = ib-1
  do ia=iasta,iaend
    ! g31   type_12 arbrb^ra^r
    iabc = iabc0+ia+ngw2(ib)+ngw3(ic)
    iposint = intind_iabc(iabc)
    value_lpext(ilwei) = vint_ci(iposint+1)*w0plp31+vint_ci(iposint+2)*w1plp31
    ilwei = ilwei+1
  end do
end do

end subroutine g31_diffsym

subroutine g32a_diffsym(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, intind_iabc, iwt_orb_ext, m_jd, nabc, ngw2, ngw3, value_lpext, vint_ci, &
                         w0plp32, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, iabc, iabc0, iaend, iasta, ib, ibend, ibsta, ic, ilwei, iposint

iabc0 = (lri-1)*nabc

ic = m_jd

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)
do ib=ibsta,ibend
  do ia=iasta,iaend
    iabc = iabc0+ia+ngw2(ic)+ngw3(ib)
    iposint = intind_iabc(iabc)
    value_lpext(ilwei) = vint_ci(iposint+2)*w0plp32-vint_ci(iposint)*w1plp32
    ilwei = ilwei+1
  end do
end do

end subroutine g32a_diffsym

subroutine g32b_diffsym(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, intind_iabc, iwt_orb_ext, m_jd, nabc, ngw2, ngw3, value_lpext, vint_ci, &
                         w0plp32, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, iabc, iabc0, iaend, iasta, ib, ibend, ibsta, ic, ilwei, iposint

iabc0 = (lri-1)*nabc

ic = m_jd

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
if (ismb == isma) ibsta = ibsta+1         !severe_new_error
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
do ib=ibsta,ibend
  do ia=iasta,min(iaend,ib-1)
    ! g32b
    iabc = iabc0+ic+ngw2(ia)+ngw3(ib)
    iposint = intind_iabc(iabc)
    value_lpext(ilwei) = vint_ci(iposint+1)*w0plp32-vint_ci(iposint)*w1plp32 !severe_new_err
    ilwei = ilwei+1
  end do
end do

end subroutine g32b_diffsym

!subroutine assign_segmode_paras(indl,indr,ilrdivnodesm)
!
!use gugaci_global, only: ilsegdownwei, irsegdownwei, iseg_downwei, iseg_sta
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: indl, indr, ilrdivnodesm
!
!ilsegdownwei = iseg_downwei(indl)
!irsegdownwei = iseg_downwei(indr)
!irsegstawei = iseg_sta(indr)
!ip2_intbase = ip2_ab_inn_base(ilrdivnodesm)
!ip2_intspace = int2ind_space_extsmab(ilrdivnodesm)
!ip2_intsymspace = int2ind_numijkl_extsmab(ilrdivnodesm)
!
!end subroutine assign_segmode_paras

subroutine external_space_plpmode_value_st()   !tt

use gugaci_global, only: v_sqthree, v_sqthreevsqtwo, w0g14a, w0g15a, w0g2a, w0g2b, w0g34a, w0g34b, w0g35a, w0g35b, w0g36a, w0g36b, &
                         w0g4a, w0g4b, w1g14a, w1g15a, w1g2a, w1g2b, w1g34a, w1g34b, w1g35a, w1g35b, w1g36a, w1g36b, w1g4a, w1g4b
use Constants, only: Zero

implicit none

w0g36a = Zero
w0g36b = Zero
w0g34a = Zero
w0g34b = Zero
w0g35a = Zero
w0g35b = Zero
w0g2a = Zero
w0g2b = Zero
w0g4a = Zero
w0g4b = Zero
w0g14a = Zero
w0g15a = Zero
!w0g13a = Zero

! st
w1g36a = v_sqthreevsqtwo
w1g36b = v_sqthreevsqtwo
w1g34a = -w1g36a
w1g34b = -w1g36a
w1g35a = w1g36a
w1g35b = -w1g36a
w1g2a = Zero      !g2a   ab_d
w1g2b = -v_sqthree   !severe_error
w1g4a = Zero
w1g4b = v_sqthree
w1g14a = w1g36a
w1g15a = -w1g36a

end subroutine external_space_plpmode_value_st

subroutine external_space_plpmode_value_ts()   !tt

use gugaci_global, only: v_onevsqtwo, w0g14a, w0g15a, w0g2a, w0g2b, w0g34a, w0g34b, w0g35a, w0g35b, w0g36a, w0g36b, w0g4a, w0g4b, &
                         w1g14a, w1g15a, w1g2a, w1g2b, w1g34a, w1g34b, w1g35a, w1g35b, w1g36a, w1g36b, w1g4a, w1g4b
use Constants, only: Zero, One

implicit none

w0g36a = Zero
w0g36b = Zero
w0g34a = Zero
w0g34b = Zero
w0g35a = Zero
w0g35b = Zero
w0g2a = Zero
w0g2b = Zero
w0g4a = Zero
w0g4b = Zero
w0g14a = Zero
w0g15a = Zero
! ts
w1g36a = -v_onevsqtwo
w1g36b = -v_onevsqtwo
w1g34a = -w1g36a
w1g34b = -w1g36a
w1g35a = -w1g36a   !severe_error
w1g35b = w1g36a
w1g2a = One       !g2a   ab_d
w1g2b = Zero
w1g4a = -One
w1g4b = Zero
w1g14a = w1g36a
w1g15a = -w1g36a

end subroutine external_space_plpmode_value_ts

subroutine external_space_plpmode_value_ss()   !ss

use gugaci_global, only: v_onevsqtwo, v_sqtwo, w0g13a, w0g14a, w0g15a, w0g2a, w0g2b, w0g34a, w0g34b, w0g35a, w0g35b, w0g36a, &
                         w0g36b, w0g4a, w0g4b, w1g14a, w1g15a, w1g2a, w1g2b, w1g34a, w1g34b, w1g35a, w1g35b, w1g36a, w1g36b, &
                         w1g4a, w1g4b
use Constants, only: Zero, One

implicit none

w0g36a = -v_onevsqtwo
w0g36b = -v_onevsqtwo
w0g34a = w0g36a
w0g34b = w0g36a
w0g35a = w0g36a
w0g35b = w0g36a
w0g2a = -One
w0g2b = -One
w0g4a = -One
w0g4b = -One
w0g14a = w0g36a
w0g15a = w0g36a
w0g13a = -v_sqtwo
w1g36a = Zero
w1g36b = Zero
w1g34a = Zero
w1g34b = Zero
w1g35a = Zero
w1g35b = Zero
w1g2a = Zero
w1g2b = Zero
w1g4a = Zero
w1g4b = Zero
w1g14a = Zero
w1g15a = Zero

end subroutine external_space_plpmode_value_ss

subroutine external_space_plpmode_value_tt()   !tt

use gugaci_global, only: v_onevsqtwo, w0g14a, w0g15a, w0g2a, w0g2b, w0g34a, w0g34b, w0g35a, w0g35b, w0g36a, w0g36b, w0g4a, w0g4b, &
                         w1g14a, w1g15a, w1g2a, w1g2b, w1g34a, w1g34b, w1g35a, w1g35b, w1g36a, w1g36b, w1g4a, w1g4b
use Constants, only: Zero, One

implicit none

w0g36a = -v_onevsqtwo
w0g36b = -v_onevsqtwo
w0g34a = w0g36a
w0g34b = w0g36a
w0g35a = -w0g36a
w0g35b = -w0g36a
w0g2a = Zero
w0g2b = Zero
w0g4a = Zero
w0g4b = Zero
w0g14a = w0g36a
w0g15a = w0g36a
!w0g13a = -v_sqtwo

w1g36a = One
w1g36b = One
w1g34a = w1g36a
w1g34b = w1g36a
w1g35a = -w1g36a
w1g35b = -w1g36a
w1g2a = Zero      !g2a   ab_d
w1g2b = Zero
w1g4a = Zero
w1g4b = Zero
w1g14a = w1g36a
w1g15a = w1g36a

end subroutine external_space_plpmode_value_tt

subroutine external_space_plpmode_value_sd()

use gugaci_global, only: v_sqtwo, w0g25, w0g25a, w0g26a, w0g27, w0g28a, w0g29, w0g30, w0g31, w0g32, w0plp25, w0plp26, w0plp27, &
                         w0plp28, w0plp29, w0plp30, w0plp31, w0plp32, w1g25a, w1g26a, w1g27, w1g28a, w1g31, w1g32, w1plp27, &
                         w1plp31, w1plp32
use Constants, only: One

implicit none

! sd   lpmode_value
w0g29 = v_sqtwo
w0g30 = v_sqtwo
w0g26a = v_sqtwo
w1g26a = v_sqtwo
w0g25 = One
w0g25a = One
w1g25a = One
w0g27 = One
w1g27 = -One
w0g28a = One
w1g28a = One
w0g31 = One
w1g31 = One
w0g32 = One
w1g32 = -One

w0plp25 = w0g25a
w0plp26 = w0g26a
w0plp27 = w0g27
w1plp27 = w1g27
w0plp28 = w0g28a
w0plp29 = w0g29
w0plp30 = w0g30
w0plp31 = w0g31
w1plp31 = w1g31
w0plp32 = w0g32
w1plp32 = w1g32

end subroutine external_space_plpmode_value_sd

subroutine external_space_plpmode_value_td()

use gugaci_global, only: w0g25, w0g25a, w0g26a, w0g27, w0g28a, w0g29, w0g30, w0g31, w0g32, w0plp25, w0plp26, w0plp27, w0plp28, &
                         w0plp31, w0plp32, w1g25a, w1g26a, w1g27, w1g28a, w1g31, w1g32, w1plp27, w1plp31, w1plp32
use Constants, only: Zero, One

implicit none

! td   lpmode_value
w0g29 = Zero
w0g30 = Zero
w0g26a = Zero
w1g26a = Zero
w0g25 = One
w0g25a = One
w1g25a = One
w0g27 = -One
w1g27 = -One
w0g28a = -One
w1g28a = -One
w0g31 = One
w1g31 = -One
w0g32 = -One
w1g32 = -One

w0plp25 = w0g25a
w0plp26 = w0g26a
w0plp27 = w0g27
w1plp27 = w1g27
w0plp28 = w0g28a
w0plp31 = w0g31
w1plp31 = w1g31
w0plp32 = w0g32
w1plp32 = w1g32

end subroutine external_space_plpmode_value_td

subroutine external_space_plpmode_value_ds()

use gugaci_global, only: v_onevsqtwo, w0g25, w0g25b, w0g26b, w0g28b, w0plp25, w0plp26, w0plp28, w1g25b, w1g26b, w1g28b
use Constants, only: One

implicit none

! ds   lpmode_value
w0g25 = -v_onevsqtwo
w0g25b = -v_onevsqtwo
w1g25b = -v_onevsqtwo
w0g28b = -v_onevsqtwo
w1g28b = -v_onevsqtwo
w0g26b = -One
w1g26b = -One

w0plp25 = w0g25
w0plp28 = w0g28b
w0plp26 = w0g26b

end subroutine external_space_plpmode_value_ds

subroutine external_space_plpmode_value_dt()

use gugaci_global, only: v_sqthreevsqtwo, w0g25, w0g25b, w0g26b, w0g28b, w1g25b, w1g26b, w1g28b
use Constants, only: Zero

implicit none

! dt   lpmode_value
w0g25 = v_sqthreevsqtwo   !v_onevsqtwo      !severe_new_error
w0g25b = v_sqthreevsqtwo
w1g25b = v_sqthreevsqtwo
w0g28b = -v_sqthreevsqtwo
w1g28b = -v_sqthreevsqtwo
w0g26b = Zero
w1g26b = Zero

end subroutine external_space_plpmode_value_dt

!subroutine ss_ext_plpmode(ilnodesm,irnodesm,iltype,irtype,lptype)
!
!use gugaci_global, only: idownwei_g131415, ilsegdownwei, irsegdownwei, ism_g1415, ism_g2g4, logic_g13, logic_g1415, logic_g2g4a, &
!                         logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, lpend34a, lpend34b, &
!                         lpend35a, lpend35b, lpend36a, lpend36b, lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, lpsta36b, &
!                         nvalue_space_ss
!use Symmetry_Info, only: Mul
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: ilnodesm, irnodesm, iltype, irtype, lptype
!integer(kind=iwp) :: iii, ilrsm
!
!ilrsm = Mul(ilnodesm,irnodesm)
!iii = 1   !index to determine lwei rwei iposint and nlinkorb
!! G2G4a G2G4b G1415 G13
!logic_g36a = .false.
!logic_g36b = .false.
!logic_g35a = .false.
!logic_g35b = .false.
!logic_g34a = .false.
!logic_g34b = .false.
!!if ((ilnodesm == 1) .and. (irnodesm == 3)) then
!!  write(u6,*)
!!end if
!
!! G36b
!lpsta36a = iii
!call do_g36mode(ilrsm,ilnodesm,iii)
!lpend36a = iii-4
!if (lpend36a >= lpsta36a) logic_g36a = .true.   !severe_new_erro
!lpsta35a = iii
!call do_g35mode(ilrsm,ilnodesm,iii)
!lpend35a = iii-4
!if (lpend35a >= lpsta35a) logic_g35a = .true.
!lpsta34a = iii
!call do_g34mode(ilrsm,ilnodesm,iii)
!lpend34a = iii-4
!if (lpend34a >= lpsta34a) logic_g34a = .true.
!if (ilrsm /= 1) then
!  lpsta36b = iii
!  call do_g36mode(ilrsm,irnodesm,iii)
!  lpend36b = iii-4
!  if (lpend36b >= lpsta36b) logic_g36b = .true.
!  lpsta35b = iii
!  call do_g35mode(ilrsm,irnodesm,iii)
!  lpend35b = iii-4
!  if (lpend35b >= lpsta35b) logic_g35b = .true.
!  lpsta34b = iii
!  call do_g34mode(ilrsm,irnodesm,iii)
!  lpend34b = iii-4
!  if (lpend34b >= lpsta34b) logic_g34b = .true.
!else
!  logic_g36b = logic_g36a
!  lpsta36b = lpsta36a
!  lpend36b = lpend36a
!  logic_g35b = logic_g35a
!  lpsta35b = lpsta35a
!  lpend35b = lpend35a
!  logic_g34b = logic_g34a
!  lpsta34b = lpsta34a
!  lpend34b = lpend34a
!end if
!
!! G2G4a G2G4b G1415 G13
!logic_g2g4a = .false.
!logic_g2g4b = .false.
!logic_g1415 = .false.
!logic_g13 = .false.
!
!if ((irnodesm == 1) .and. (irtype == 4)) then
!  logic_g2g4a = .true.
!  ism_g2g4 = ilnodesm
!end if
!if ((ilnodesm == 1) .and. (iltype == 4)) then
!  logic_g2g4b = .true.
!  ism_g2g4 = irnodesm
!end if
!
!if ((lptype /= 2) .and. (ilrsm == 1)) then
!  logic_g1415 = .true.
!  ism_g1415 = ilnodesm
!  if ((ilnodesm == 1) .and. (iltype == 4) .and. (irtype == 4)) then
!    logic_g13 = .true.
!  end if
!  if (iltype == 4) then          !severe_error
!    idownwei_g131415 = irsegdownwei
!  else
!    idownwei_g131415 = ilsegdownwei
!  end if
!end if
!
!nvalue_space_ss = ip2_intsymspace/3
!
!end subroutine ss_ext_plpmode

subroutine do_g36mode(ilrsm,ilnodesm,iii)

use gugaci_global, only: ng_sm
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ilrsm, ilnodesm
integer(kind=iwp), intent(inout) :: iii
integer(kind=iwp) :: isma, ismb, ismlink

do ismb=1,ng_sm
  isma = Mul(ismb,ilrsm)
  if (isma > ismb) cycle
  ismlink = Mul(isma,ilnodesm)
  if (ismlink > isma) cycle
  call g36_form(isma,ismb,ismlink,iii)
end do

end subroutine do_g36mode

subroutine do_g34mode(ilrsm,ilnodesm,iii)

use gugaci_global, only: ng_sm
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ilrsm, ilnodesm
integer(kind=iwp), intent(inout) :: iii
integer(kind=iwp) :: isma, ismb, ismlink

do ismb=1,ng_sm
  isma = Mul(ismb,ilrsm)
  if (isma > ismb) cycle
  ismlink = Mul(isma,ilnodesm)
  if (ismlink < ismb) cycle
  call g34_form(isma,ismb,ismlink,iii)
end do

end subroutine do_g34mode

subroutine do_g35mode(ilrsm,ilnodesm,iii)

use gugaci_global, only: ng_sm
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ilrsm, ilnodesm
integer(kind=iwp), intent(inout) :: iii
integer(kind=iwp) :: isma, ismb, ismlink

do ismb=1,ng_sm
  isma = Mul(ismb,ilrsm)
  if (isma > ismb) cycle
  ismlink = Mul(isma,ilnodesm)
  if ((ismlink > ismb) .or. (ismlink < isma)) cycle
  call g35_form(isma,ismb,ismlink,iii)
end do

end subroutine do_g35mode

subroutine g36_form(isma,ismb,ismlink,iii)

use gugaci_global, only: ibsm_ext, iesm_ext, iwt_orb_ext, lpext_wei
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ismlink
integer(kind=iwp), intent(inout) :: iii
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, icsta, ilinkend, ilinksta, nlinkorb

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilinksta = ibsm_ext(ismlink)
ilinkend = iesm_ext(ismlink)
if (isma == ismlink) iasta = iasta+1
if (ismb == isma) ibsta = ibsta+1
if (ismb == ismlink) ibsta = ibsta+1

do ib=ibsta,ibend
  do ia=iasta,min(iaend,ib-1)
    icsta = ilinksta
    nlinkorb = min(ilinkend,ia-1)-ilinksta+1
    if (nlinkorb <= 0) cycle
    lpext_wei(iii) = iwt_orb_ext(icsta,ia)
    lpext_wei(iii+1) = iwt_orb_ext(icsta,ib)
    lpext_wei(iii+2) = iwt_orb_ext(ia,ib)
    lpext_wei(iii+3) = nlinkorb
    iii = iii+4
  end do
end do

end subroutine g36_form

subroutine g34_form(isma,ismb,ismlink,iii)

use gugaci_global, only: ibsm_ext, iesm_ext, iwt_orb_ext, lpext_wei
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ismlink
integer(kind=iwp), intent(inout) :: iii
integer(kind=iwp) :: iaend, iasta, ib, ibend, ibsta, ilink, ilinkend, ilinksta, naorb

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilinksta = ibsm_ext(ismlink)
ilinkend = iesm_ext(ismlink)
if (ismlink == ismb) ilinksta = ilinksta+1
if (ismlink == isma) ilinksta = ilinksta+1
if (ismb == isma) ibsta = ibsta+1

do ilink=ilinksta,ilinkend
  do ib=ibsta,min(ibend,ilink-1)
    naorb = min(iaend,ib-1)-iasta+1
    if (naorb <= 0) cycle
    lpext_wei(iii) = iwt_orb_ext(iasta,ilink)
    lpext_wei(iii+1) = iwt_orb_ext(ib,ilink)
    lpext_wei(iii+2) = iwt_orb_ext(iasta,ib)
    lpext_wei(iii+3) = naorb
    iii = iii+4
  end do
end do

end subroutine g34_form

subroutine g35_form(isma,ismb,ismlink,iii)

use gugaci_global, only: ibsm_ext, iesm_ext, iwt_orb_ext, lpext_wei
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ismlink
integer(kind=iwp), intent(inout) :: iii
integer(kind=iwp) :: iaend, iasta, ib, ibend, ibsta, ilink, ilinkend, ilinksta, naorb

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilinksta = ibsm_ext(ismlink)
ilinkend = iesm_ext(ismlink)
if (ismb == ismlink) ibsta = ibsta+1
if (ismb == isma) ibsta = ibsta+1
if (ismlink == isma) ilinksta = ilinksta+1

do ib=ibsta,ibend
  do ilink=ilinksta,min(ilinkend,ib-1)
    naorb = min(iaend,ilink-1)-iasta+1
    if (naorb <= 0) cycle
    lpext_wei(iii) = iwt_orb_ext(iasta,ilink)
    lpext_wei(iii+1) = iwt_orb_ext(ilink,ib)
    lpext_wei(iii+2) = iwt_orb_ext(iasta,ib)
    lpext_wei(iii+3) = naorb
    iii = iii+4
  end do
end do

end subroutine g35_form

!function ibfunction(ib,istep)
!
!use Definitions, only: iwp, u6
!
!implicit none
!integer(kind=iwp) :: ibfunction
!integer(kind=iwp), intent(in) :: ib, istep
!
!select case (istep)
!  case (2)
!    ibfunction = ib-1
!  case (3)
!    ibfunction = ib+1
!  case default
!    ibfunction = ib
!end select
!if (ibfunction < 0) then
!  write(u6,*) 'error'
!end if
!
!end function ibfunction

subroutine determine_para_array_for_int1ind()

use gugaci_global, only: ng_sm, ngw2, ngw3, nlsm_ext, norb_ext
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: isma, ismab, ismabc, ismb, ismc, nintcount, numa, numb, numc, numint

do ismabc=1,ng_sm
  nintcount = 0
  do ismc=1,ng_sm
    ismab = Mul(ismabc,ismc)
    numc = nlsm_ext(ismc)
    do ismb=1,ismc
      isma = Mul(ismab,ismb)
      if (isma > ismb) cycle
      numb = nlsm_ext(ismb)
      numa = nlsm_ext(isma)
      numint = 0
      if (isma == ismc) then         !aaa
        !numint = numa-2+ip2(numb-1)+ip3(numc)
        if (numb > 1) then
          numint = numa-2+ngw2(numb-1)+ngw3(numc)
        end if
      else if (isma == ismb) then      !aac
        !numint = (numa-1+ip2(numb))*numc
        if (numb > 0) then
          if ((numa-1+ngw2(numb)) > 0) then
            numint = (numa-1+ngw2(numb))*numc
          end if
        end if
      else if (ismb == ismc) then      !acc
        !numint = (numb-1+ip2(numc))*numa
        if (numc > 0) then
          if ((numb-1+ngw2(numc)) > 0) then
            numint = (numb-1+ngw2(numc))*numa
          end if
        end if
      else                        !abc
        numint = numa*numb*numc
      end if
      if (numint <= 0) cycle            !severe_new_error
      numint = numint*3
      nintcount = nintcount+numint
    end do
  end do
  numint = nlsm_ext(ismabc)*norb_ext*2
  nintcount = nintcount+numint
  numint = nlsm_ext(ismabc)
end do

end subroutine determine_para_array_for_int1ind

subroutine g_dd_ext_sequence_G(ism)

use gugaci_global, only: ibsm_ext, ican_a, icano_nnend, icano_nnsta, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, &
                         norb_number, value_lpext2
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ism
integer(kind=iwp) :: ia, iasta, ib, ibend, ibsta, ilwei, lra, lrb, nac

icano_nnsta = 2
icnt_base = 0
iasta = ibsm_ext(ism)
ibsta = iasta+1
ibend = iesm_ext(ism)
ilwei = 0
do ib=ibsta,ibend
  lrb = norb_number(ib)
  do ia=iasta,ib-1
    lra = norb_number(ia)
    ilwei = ilwei+1
    index_lpext(ilwei) = 0
    index_lpext1(ilwei) = 0

    NAC = ICAN_A(LRA)+LRB
    index_lpext2(ilwei) = NAC
    value_lpext2(ilwei) = One
  end do
end do
icano_nnend = ibend-iasta+1
call complete_ext_loop_G()

end subroutine g_dd_ext_sequence_G

subroutine g_tt_ext_sequence_G(ism)

use gugaci_global, only: ibsm_ext, icano_nnend, icano_nnsta, icnt_base, iesm_ext, iwt_orb_ext, m_jc, m_jd, max_tmpvalue, ng_sm
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ism
integer(kind=iwp) :: ic, ic_sta, icano_nn, icend, id, id_sta, idend, idsta, isma, ismb, ismc, ismd

icano_nnsta = 2
icnt_base = 0
do ismd=1,ng_sm
  ismc = Mul(ism,ismd)
  if (ismc > ismd) cycle
  id_sta = ibsm_ext(ismd)
  idsta = id_sta
  idend = iesm_ext(ismd)
  ic_sta = ibsm_ext(ismc)
  icend = iesm_ext(ismc)
  if (ismd == ismc) idsta = idsta+1
  do id=idsta,idend
    m_jd = id-id_sta+1
    do ic=ic_sta,min(icend,id-1)
      m_jc = ic-ic_sta+1
      icano_nn = iwt_orb_ext(ic,id)
      if (icnt_base+icano_nn-1 > max_tmpvalue) then
        call complete_ext_loop_G()
        icnt_base = 0
        icano_nnsta = icano_nn
      end if
      icano_nnend = icano_nn
      do ismb=1,ismd-1
        isma = Mul(ism,ismb)
        if (isma > ismb) cycle
        if (ismc > ismb) then
          call g12_t_diffsym_G(isma,ismb,ic,id)
        else if (ismc > isma) then
          call g11a_t_diffsym_G(isma,ismb,ic,id)
        else
          call g11b_t_diffsym_G(isma,ismb,ic,id)
        end if
      end do
      if (ism == 1) then
        isma = ismd
        call g1112_t_symaaaa_G(isma,ic,id)
      else
        isma = Mul(ism,ismd)
        call g11a11b_t_symaacc_G(isma,ismd,ic,id)
      end if
      call g36_t_ext_G(ismc,ic,id)
      call g5_t_ext_G(ismd,ic,id)
      if (ism == 1) call g9_t_ext_G(ismd,ic,id)
      icnt_base = icnt_base+icano_nn-1
    end do
  end do
end do
call complete_ext_loop_G()

end subroutine g_tt_ext_sequence_G

subroutine g_ss_ext_sequence_G(ism,itype)

use gugaci_global, only: ibsm_ext, icano_nnend, icano_nnsta, icnt_base, iesm_ext, iwt_orb_ext, iwt_sm_s_ext, m_jc, m_jd, &
                         max_tmpvalue, ng_sm, norb_ext
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ism, itype
integer(kind=iwp) :: ic, ic_sta, icano_nn, icend, id, id_sta, idend, idsta, isma, ismb, ismc, ismd

icano_nnsta = 2
icnt_base = 0
do ismd=1,ng_sm
  ismc = Mul(ism,ismd)
  if (ismc > ismd) cycle
  id_sta = ibsm_ext(ismd)
  idsta = id_sta
  idend = iesm_ext(ismd)
  ic_sta = ibsm_ext(ismc)
  icend = iesm_ext(ismc)
  if (ismd == ismc) idsta = idsta+1
  do id=idsta,idend
    m_jd = id-id_sta+1
    do ic=ic_sta,min(icend,id-1)
      m_jc = ic-ic_sta+1
      icano_nn = iwt_orb_ext(ic,id)
      if (icnt_base+icano_nn-1 > max_tmpvalue) then
        call complete_ext_loop_G()
        icnt_base = 0
        icano_nnsta = icano_nn
      end if
      icano_nnend = icano_nn
      do ismb=1,ismd-1
        isma = Mul(ism,ismb)
        if (isma > ismb) cycle
        if (ismc > ismb) then
          call g12_diffsym_G(isma,ismb,ic,id)
        else if (ismc > isma) then
          call g11a_diffsym_G(isma,ismb,ic,id)
        else
          call g11b_diffsym_G(isma,ismb,ic,id)
        end if
      end do
      if (ism == 1) then
        isma = ismd
        call g1112_symaaaa_G(isma,ic,id)
      else
        isma = Mul(ism,ismd)
        call g11a11b_symaacc_G(isma,ismd,ic,id)
      end if
      call g10_ext_G(ismc,ic,id)
      call g5_ext_G(ismd,ic,id)
      if (ism == 1) then
        call g9_ext_G(ismd,ic,id)
      end if
      icnt_base = icnt_base+icano_nn-1
    end do
  end do
end do
if ((ism == 1) .and. (itype == 4)) then
  do id=1,norb_ext
    icano_nn = id+iwt_sm_s_ext
    if (icnt_base+icano_nn-1 > max_tmpvalue) then
      call complete_ext_loop_G()
      icnt_base = 0
      icano_nnsta = icano_nn
    end if
    icano_nnend = icano_nn
    call ext_lp_ab_s1_G(id)
    icnt_base = icnt_base+icano_nn-1
  end do
end if
call complete_ext_loop_G()

end subroutine g_ss_ext_sequence_G

subroutine g12_diffsym_G(isma,ismb,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

!write(nf2,*) 'g12_diff'
lrc = norb_number(ic)
lrd = norb_number(id)

if (isma < ismb) then
  ibsta = ibsm_ext(ismb)
  ibend = iesm_ext(ismb)
  iasta = ibsm_ext(isma)
  iaend = iesm_ext(isma)
  ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)

  do ib=ibsta,ibend
    lrb = norb_number(ib)
    do ia=iasta,iaend
      lra = norb_number(ia)
      call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
      index_lpext(ilwei) = NXO
      value_lpext(ilwei) = One
      call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
      index_lpext1(ilwei) = NXO
      value_lpext1(ilwei) = One
      index_lpext2(ilwei) = 0
      ilwei = ilwei+1

    end do
  end do
else

  ibsta = ibsm_ext(ismb)+1
  ibend = iesm_ext(ismb)
  iasta = ibsm_ext(isma)
  iaend = iesm_ext(isma)
  ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)

  do ib=ibsta,ibend
    lrb = norb_number(ib)
    do ia=iasta,ib-1
      lra = norb_number(ia)
      call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
      index_lpext(ilwei) = NXO
      value_lpext(ilwei) = One
      call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
      index_lpext1(ilwei) = NXO
      value_lpext1(ilwei) = One
      index_lpext2(ilwei) = 0
      ilwei = ilwei+1
    end do
  end do
end if

end subroutine g12_diffsym_G

subroutine g11a_diffsym_G(isma,ismb,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

!write(nf2,*) 'g11a_diff'
lrc = norb_number(ic)
lrd = norb_number(id)

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)

do ib=ibsta,ibend
  lrb = norb_number(ib)
  do ia=iasta,iaend
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

end subroutine g11a_diffsym_G

subroutine g11b_diffsym_G(isma,ismb,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

!write(nf2,*) 'g11b_diff'
lrc = norb_number(ic)
lrd = norb_number(id)

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
do ib=ibsta,ibend
  lrb = norb_number(ib)
  do ia=iasta,iaend
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

end subroutine g11b_diffsym_G

subroutine g1112_symaaaa_G(isma,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, value_lpext, &
                         value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ic, id
integer(kind=iwp) :: ia, iasta, ib, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

!write(nf2,*) 'g1112_symaaaa'
lrc = norb_number(ic)
lrd = norb_number(id)

iasta = ibsm_ext(isma)
ibsta = iasta+1
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)

do ib=ibsta,ic-1
  lrb = norb_number(ib)
  do ia=iasta,ib-1
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

do ib=ic+1,id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

do ib=ic+2,id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,ib-1
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

end subroutine g1112_symaaaa_G

subroutine g11a11b_symaacc_G(isma,ismc,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismc, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

!write(nf2,*) 'g11a11b_symaacc'
lrc = norb_number(ic)
lrd = norb_number(id)

ibsta = ibsm_ext(ismc)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)

do ib=ibsta,id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

do ib=ibsta,id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,iaend
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

end subroutine g11a11b_symaacc_G

subroutine g10_ext_G(ismc,ic,id)

use gugaci_global, only: ibsm_ext, ican_a, icnt_base, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1, value_lpext2
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismc, ic, id
integer(kind=iwp) :: ia, iasta, ilwei, lra, lrc, lrd, nac, nxo

!write(nf2,*) 'g10_ext'
lrc = norb_number(ic)
lrd = norb_number(id)
iasta = ibsm_ext(ismc)
ilwei = icnt_base+iwt_orb_ext(iasta,id)
do ia=iasta,ic-1
  lra = norb_number(ia)
  call TRANS_IJKL_INTPOS(lra,lrc,lrd,lrd,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = One
  call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrd,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = One
  NAC = ICAN_A(LRA)+LRC
  index_lpext2(ilwei) = NAC
  value_lpext2(ilwei) = One
  ilwei = ilwei+1
end do

end subroutine g10_ext_G

subroutine g5_ext_G(ismd,ic,id)

use gugaci_global, only: ibsm_ext, ican_a, icnt_base, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1, value_lpext2
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismd, ic, id
integer(kind=iwp) :: ib, ibsta, ilwei, lrb, lrc, lrd, nac, nxo

!write(nf2,*) 'g5_ext'
lrc = norb_number(ic)
lrd = norb_number(id)
ibsta = ibsm_ext(ismd)
do ib=max(ic+1,ibsta),id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(ic,ib)
  call TRANS_IJKL_INTPOS(lrb,lrd,lrc,lrc,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = One
  call TRANS_IJKL_INTPOS(lrb,lrc,lrd,lrc,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = One
  NAC = ICAN_A(LRB)+LRD
  index_lpext2(ilwei) = NAC
  value_lpext2(ilwei) = One
end do

end subroutine g5_ext_G

subroutine g9_ext_G(ismd,ic,id)

use gugaci_global, only: ibsm_ext, ican_a, icnt_base, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1, value_lpext2
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismd, ic, id
integer(kind=iwp) :: ia, iasta, ilwei, lra, lrc, lrd, nac, nxo

!write(nf2,*) 'g9_ext'
lrc = norb_number(ic)
lrd = norb_number(id)
iasta = ibsm_ext(ismd)
ilwei = icnt_base+iwt_orb_ext(iasta,ic)
do ia=iasta,ic-1
  lra = norb_number(ia)
  call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrc,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = One
  call TRANS_IJKL_INTPOS(lra,lrc,lrd,lrc,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = One
  NAC = ICAN_A(LRA)+LRD
  index_lpext2(ilwei) = NAC
  value_lpext2(ilwei) = One
  ilwei = ilwei+1
end do

end subroutine g9_ext_G

subroutine ext_lp_ab_s1_G(id)

use gugaci_global, only: ibsm_ext, ican_a, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, ng_sm, norb_number, &
                         v_sqtwo, value_lpext, value_lpext2
use Constants, only: Two
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: id
integer(kind=iwp) :: ia, iasta, ib, ibend, ibsta, ic, ilwei, ismb, lra, lrb, lrc, lrd, nac, nxo

!write(nf2,*) 'ext_lp_ab_s1'
lrd = norb_number(id)
ilwei = icnt_base

do ismb=1,ng_sm
  iasta = ibsm_ext(ismb)
  ibend = iesm_ext(ismb)
  ibsta = iasta+1
  do ib=ibsta,ibend
    lrb = norb_number(ib)
    do ia=iasta,ib-1
      lra = norb_number(ia)
      if ((ib == id) .or. (ia == id)) then
        ! g2   arar+ar(head)ar
        ilwei = ilwei+1
        call TRANS_IJKL_INTPOS(lra,lrd,lrb,lrd,NXO)
        index_lpext(ilwei) = NXO
        value_lpext(ilwei) = v_sqtwo
        index_lpext1(ilwei) = 0
        NAC = ICAN_A(LRA)+LRB
        index_lpext2(ilwei) = NAC
        value_lpext2(ilwei) = v_sqtwo
      else
        ! g6g7g8
        ilwei = ilwei+1
        call TRANS_IJKL_INTPOS(lra,lrd,lrb,lrd,NXO)
        index_lpext(ilwei) = NXO
        value_lpext(ilwei) = v_sqtwo
        index_lpext1(ilwei) = 0
        index_lpext2(ilwei) = 0
      end if
    end do
  end do
end do
! g1
!=======================================================================
! Drr-DRR
! WL=Two but not One is based on that the non-diagonal just uses th
! non-triangle <Ci|H|Cj> which designates that I > J.

do ic=1,id-1
  lrc = norb_number(ic)
  ilwei = ilwei+1
  call TRANS_IJKL_INTPOS(lrc,lrd,lrc,lrd,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = Two
  index_lpext1(ilwei) = 0
  index_lpext2(ilwei) = 0
end do

end subroutine ext_lp_ab_s1_G

subroutine g12_t_diffsym_G(isma,ismb,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

lrc = norb_number(ic)
lrd = norb_number(id)

if (isma < ismb) then
  ibsta = ibsm_ext(ismb)
  ibend = iesm_ext(ismb)
  iasta = ibsm_ext(isma)
  iaend = iesm_ext(isma)
  ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)

  do ib=ibsta,ibend
    lrb = norb_number(ib)
    do ia=iasta,iaend
      lra = norb_number(ia)
      call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
      index_lpext(ilwei) = NXO
      value_lpext(ilwei) = One
      call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
      index_lpext1(ilwei) = NXO
      value_lpext1(ilwei) = -One
      index_lpext2(ilwei) = 0
      ilwei = ilwei+1

    end do
  end do
else

  ibsta = ibsm_ext(ismb)+1
  ibend = iesm_ext(ismb)
  iasta = ibsm_ext(isma)
  iaend = iesm_ext(isma)
  ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)

  do ib=ibsta,ibend
    lrb = norb_number(ib)
    do ia=iasta,ib-1
      lra = norb_number(ia)
      call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
      index_lpext(ilwei) = NXO
      value_lpext(ilwei) = One
      call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
      index_lpext1(ilwei) = NXO
      value_lpext1(ilwei) = -One
      index_lpext2(ilwei) = 0
      ilwei = ilwei+1
    end do
  end do
end if

end subroutine g12_t_diffsym_G

subroutine g11a_t_diffsym_G(isma,ismb,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

lrc = norb_number(ic)
lrd = norb_number(id)

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)

do ib=ibsta,ibend
  lrb = norb_number(ib)
  do ia=iasta,iaend
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

end subroutine g11a_t_diffsym_G

subroutine g11b_t_diffsym_G(isma,ismb,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismb, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

lrc = norb_number(ic)
lrd = norb_number(id)

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
do ib=ibsta,ibend
  lrb = norb_number(ib)
  do ia=iasta,iaend
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

end subroutine g11b_t_diffsym_G

subroutine g1112_t_symaaaa_G(isma,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, value_lpext, &
                         value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ic, id
integer(kind=iwp) :: ia, iasta, ib, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

lrc = norb_number(ic)
lrd = norb_number(id)

iasta = ibsm_ext(isma)
ibsta = iasta+1
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)

do ib=ibsta,ic-1
  lrb = norb_number(ib)
  do ia=iasta,ib-1
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

do ib=ic+1,id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

do ib=ic+2,id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,ib-1
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

end subroutine g1112_t_symaaaa_G

subroutine g11a11b_t_symaacc_G(isma,ismc,ic,id)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: isma, ismc, ic, id
integer(kind=iwp) :: ia, iaend, iasta, ib, ibsta, ilwei, lra, lrb, lrc, lrd, nxo

lrc = norb_number(ic)
lrd = norb_number(id)

ibsta = ibsm_ext(ismc)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)

do ib=ibsta,id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

do ib=ibsta,id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,iaend
    lra = norb_number(ia)
    call TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = One
    call TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -One
    index_lpext2(ilwei) = 0
    ilwei = ilwei+1
  end do
end do

end subroutine g11a11b_t_symaacc_G

subroutine g36_t_ext_G(ismc,ic,id)

use gugaci_global, only: ibsm_ext, ican_a, icnt_base, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1, value_lpext2
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismc, ic, id
integer(kind=iwp) :: ia, iasta, ilwei, lra, lrc, lrd, nac, nxo

lrc = norb_number(ic)
lrd = norb_number(id)
iasta = ibsm_ext(ismc)
ilwei = icnt_base+iwt_orb_ext(iasta,id)
do ia=iasta,ic-1
  lra = norb_number(ia)
  call TRANS_IJKL_INTPOS(lra,lrc,lrd,lrd,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = One
  call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrd,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = -One
  NAC = ICAN_A(LRA)+LRC
  index_lpext2(ilwei) = NAC
  value_lpext2(ilwei) = One
  ilwei = ilwei+1
end do

end subroutine g36_t_ext_G

subroutine g5_t_ext_G(ismd,ic,id)

use gugaci_global, only: ibsm_ext, ican_a, icnt_base, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1, value_lpext2
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismd, ic, id
integer(kind=iwp) :: ib, ibsta, ilwei, lrb, lrc, lrd, nac, nxo

lrc = norb_number(ic)
lrd = norb_number(id)
ibsta = ibsm_ext(ismd)
do ib=max(ic+1,ibsta),id-1
  lrb = norb_number(ib)
  ilwei = icnt_base+iwt_orb_ext(ic,ib)
  call TRANS_IJKL_INTPOS(lrb,lrd,lrc,lrc,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = One
  call TRANS_IJKL_INTPOS(lrb,lrc,lrd,lrc,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = -One
  NAC = ICAN_A(LRB)+LRD
  index_lpext2(ilwei) = NAC
  value_lpext2(ilwei) = One
end do

end subroutine g5_t_ext_G

subroutine g9_t_ext_G(ismd,ic,id)

use gugaci_global, only: ibsm_ext, ican_a, icnt_base, index_lpext, index_lpext1, index_lpext2, iwt_orb_ext, norb_number, &
                         value_lpext, value_lpext1, value_lpext2
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ismd, ic, id
integer(kind=iwp) :: ia, iasta, ilwei, lra, lrc, lrd, nac, nxo

lrc = norb_number(ic)
lrd = norb_number(id)
iasta = ibsm_ext(ismd)
ilwei = icnt_base+iwt_orb_ext(iasta,ic)
do ia=iasta,ic-1
  lra = norb_number(ia)
  call TRANS_IJKL_INTPOS(lra,lrd,lrc,lrc,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = -One
  call TRANS_IJKL_INTPOS(lra,lrc,lrd,lrc,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = One
  NAC = ICAN_A(LRA)+LRD
  index_lpext2(ilwei) = NAC
  value_lpext2(ilwei) = -One
  ilwei = ilwei+1
end do

end subroutine g9_t_ext_G

subroutine g31_diffsym_G(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, iwt_orb_ext, m_jd, norb_number, value_lpext, &
                         value_lpext1, w0plp31, w1plp31
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, lra, lrb, lrc, nxo

LRC = norb_number(m_jd)

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
if (isma == ismb) ibsta = ibsta+1
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)
do ib=ibsta,ibend
  LRB = norb_number(IB)
  if (isma == ismb) iaend = ib-1
  do ia=iasta,iaend
    LRA = norb_number(IA)
    ! g31   type_12 arbrb^ra^r

    call TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp31
    call TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRB,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = w1plp31

    ilwei = ilwei+1
  end do
end do

end subroutine g31_diffsym_G

subroutine g32a_diffsym_G(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, iwt_orb_ext, m_jd, norb_number, value_lpext, &
                         value_lpext1, w0plp32, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, lra, lrb, lrc, nxo

LRC = norb_number(m_jd)
ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)
do ib=ibsta,ibend
  LRB = norb_number(IB)
  do ia=iasta,iaend
    LRA = norb_number(IA)
    call TRANS_IJKL_INTPOS(LRA,LRI,LRB,LRC,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp32
    call TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -w1plp32

    ilwei = ilwei+1
  end do
end do

end subroutine g32a_diffsym_G

subroutine g32b_diffsym_G(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, iwt_orb_ext, m_jd, norb_number, value_lpext, &
                         value_lpext1, w0plp32, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ilwei, lra, lrb, lrc, nxo

LRC = norb_number(m_jd)
ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
if (ismb == isma) ibsta = ibsta+1
ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)
do ib=ibsta,ibend
  LRB = norb_number(IB)
  do ia=iasta,min(iaend,ib-1)
    LRA = norb_number(IA)
    ! g32b
    call TRANS_IJKL_INTPOS(LRC,LRB,LRA,LRI,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp32
    call TRANS_IJKL_INTPOS(LRC,LRA,LRB,LRI,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -w1plp32

    ilwei = ilwei+1
  end do
end do

end subroutine g32b_diffsym_G

subroutine gsd_samesym_aaa_G(lri,isma)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, iwt_orb_ext, m_jd, norb_number, value_lpext, &
                         value_lpext1, w0g28a, w0plp27, w0plp28, w0plp31, w0plp32, w1plp27, w1plp31, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma
integer(kind=iwp) :: ia, iasta, ib, ibend, ibsta, ic, ilwei, lra, lrb, lrc, nxo

ic = m_jd
lrc = norb_number(ic)

iasta = ibsm_ext(isma)
ibend = iesm_ext(isma)
ibsta = iasta+1

ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)
do ib=ibsta,ic-1
  LRB = norb_number(IB)
  do ia=iasta,ib-1
    LRA = norb_number(IA)
    ! g31   type_12 arbrb^ra^r
    call TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp31
    call TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRB,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = w1plp31

    ilwei = ilwei+1
  end do
end do

ib = ic
ilwei = icnt_base+iwt_orb_ext(iasta,ib)
do ia=iasta,ib-1
  LRA = norb_number(IA)
  ! g28     Cw-Ar                    330
  call TRANS_IJKL_INTPOS(LRA,LRC,LRI,LRC,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = w0plp28/w0g28a
  call TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRC,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = w0plp28

  ilwei = ilwei+1
end do

ia = ic
do ib=ic+1,ibend
  LRB = norb_number(IB)
  ! g25,g27: Bl(20)-Drl(11)         220

  ilwei = icnt_base+iwt_orb_ext(ic,ib)

  call TRANS_IJKL_INTPOS(LRB,LRC,LRI,LRC,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = w0plp27
  call TRANS_IJKL_INTPOS(LRB,LRI,LRC,LRC,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = -w1plp27

end do

do ib=ic+1,ibend
  LRB = norb_number(IB)

  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    LRA = norb_number(IA)

    ! g32a   type g12
    call TRANS_IJKL_INTPOS(LRA,LRI,LRB,LRC,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp32
    call TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -w1plp32

    ilwei = ilwei+1
  end do
end do

do ib=ic+2,ibend
  LRB = norb_number(IB)

  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,ib-1
    LRA = norb_number(IA)

    ! g32b  type 11
    call TRANS_IJKL_INTPOS(LRC,LRB,LRA,LRI,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp32
    call TRANS_IJKL_INTPOS(LRC,LRA,LRB,LRI,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -w1plp32

    ilwei = ilwei+1
  end do
end do

end subroutine gsd_samesym_aaa_G

subroutine gsd_diffsamesym_abb_G(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, iwt_orb_ext, m_jd, norb_number, value_lpext, &
                         value_lpext1, w0g28a, w0plp28, w0plp31, w0plp32, w1plp31, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ic, ilwei, lra, lrb, lrc, nxo

ic = m_jd
lrc = norb_number(ic)

iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)

ilwei = icnt_base+iwt_orb_ext(iasta,ibsta)
do ib=ibsta,ic-1
  LRB = norb_number(IB)
  do ia=iasta,iaend
    LRA = norb_number(IA)

    ! g31   type_12 arbrb^ra^r
    call TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp31
    call TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRB,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = w1plp31

    ilwei = ilwei+1
  end do
end do

ilwei = icnt_base+iwt_orb_ext(iasta,ic+1)
do ib=ic+1,ibend
  LRB = norb_number(IB)
  do ia=iasta,iaend
    LRA = norb_number(IA)
    ! g32a
    call TRANS_IJKL_INTPOS(LRA,LRI,LRB,LRC,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp32
    call TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -w1plp32

    ilwei = ilwei+1
  end do
end do

ib = ic
ilwei = icnt_base+iwt_orb_ext(iasta,ib)
do ia=iasta,iaend      !ib-1      !severe_error_1020
  LRA = norb_number(IA)

  ! g28
  call TRANS_IJKL_INTPOS(LRA,LRC,LRI,LRC,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = w0plp28/w0g28a
  call TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRC,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = w0plp28

  ilwei = ilwei+1
end do

end subroutine gsd_diffsamesym_abb_G

subroutine gsd_diffsamesym_aab_G(lri,isma,ismb)

use gugaci_global, only: ibsm_ext, icnt_base, iesm_ext, index_lpext, index_lpext1, iwt_orb_ext, m_jd, norb_number, value_lpext, &
                         value_lpext1, w0plp27, w0plp32, w1plp27, w1plp32
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, isma, ismb
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ic, ilwei, lra, lrb, lrc, nxo

ic = m_jd
lrc = norb_number(ic)

ibsta = ibsm_ext(ismb)
ibend = iesm_ext(ismb)
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)

do ib=ibsta,ibend
  LRB = norb_number(IB)
  ilwei = icnt_base+iwt_orb_ext(iasta,ib)
  do ia=iasta,ic-1
    LRA = norb_number(IA)
    ! g32a
    call TRANS_IJKL_INTPOS(LRA,LRI,LRB,LRC,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp32
    call TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -w1plp32

    ilwei = ilwei+1
  end do
end do

do ib=ibsta,ibend
  LRB = norb_number(IB)
  ilwei = icnt_base+iwt_orb_ext(ic+1,ib)
  do ia=ic+1,iaend
    LRA = norb_number(IA)
    ! g32b
    call TRANS_IJKL_INTPOS(LRC,LRB,LRA,LRI,NXO)
    index_lpext(ilwei) = NXO
    value_lpext(ilwei) = w0plp32
    call TRANS_IJKL_INTPOS(LRC,LRA,LRB,LRI,NXO)
    index_lpext1(ilwei) = NXO
    value_lpext1(ilwei) = -w1plp32

    ilwei = ilwei+1
  end do
end do

ia = ic
do ib=ibsta,ibend
  LRB = norb_number(IB)
  ! g25
  ilwei = icnt_base+iwt_orb_ext(ic,ib)

  call TRANS_IJKL_INTPOS(LRB,LRC,LRI,LRC,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = w0plp27
  call TRANS_IJKL_INTPOS(LRB,LRI,LRC,LRC,NXO)
  index_lpext1(ilwei) = NXO
  value_lpext1(ilwei) = -w1plp27

end do

end subroutine gsd_diffsamesym_aab_G

subroutine gsd_arlp_s1_G(lri)

use gugaci_global, only: icnt_base, index_lpext, index_lpext1, isegdownwei, m_jd, norb_ext, norb_number, value_lpext, w0plp26, &
                         w0plp29, w0plp30
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp) :: ic, ilwei, is1orb, lrc, lrk, nxo

ic = m_jd
lrc = norb_number(ic)

ilwei = icnt_base+isegdownwei-norb_ext+1
do is1orb=1,ic-1
  ! g30 -B^rD^rr
  lrk = norb_number(is1orb)
  call TRANS_IJKL_INTPOS(LRC,LRK,LRI,LRK,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = w0plp30
  index_lpext1(ilwei) = 0

  ilwei = ilwei+1
end do

! g26 -A^r     610
lrk = norb_number(ic)
call TRANS_IJKL_INTPOS(LRC,LRK,LRI,LRK,NXO)
index_lpext(ilwei) = NXO
value_lpext(ilwei) = w0plp26
index_lpext1(ilwei) = 0

ilwei = ilwei+1

! g29 -Dl^rA^l
do is1orb=ic+1,norb_ext
  lrk = norb_number(is1orb)
  call TRANS_IJKL_INTPOS(LRC,LRK,LRI,LRK,NXO)
  index_lpext(ilwei) = NXO
  value_lpext(ilwei) = w0plp29
  index_lpext1(ilwei) = 0

  ilwei = ilwei+1
end do

end subroutine gsd_arlp_s1_G

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GETINT_td(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                  IKSM,JLSM,ICTL,ieaw )
      use Arrays, only: pInt2, KINT2, KINT2a
*
* Outer routine for accessing integral block
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "detdim.fh"
*./CRUN/ : INTIMP used ....
* and NOHSOO (no spin-other-orbit) added by Merethe 19/10-95
#include "crun_mclr.fh"
*./ORBINP/  : NOBPTS used
#include "Input.fh"
#include "orbinp_mclr.fh"
#include "csm.fh"
#include "genop.fh"
*. Type of operator in action
      Dimension XINT(*)
*
       NTEST=0
*
*          Write(*,*)'square in getint_td',square
          IF(.not.square) THEN
           IXCHNG=0
           ICOUL=0
           If (ictl.eq.2) ICOUL=1
           If (ictl.eq.3) ICOUL=1
           If (ictl.eq.4) IXCHNG=1
           If (ieaw.ne.0) Then
              CALL GETINC_ABT(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                        IXCHNG,IKSM,JLSM,KINT2a,
     &                        pINT2,NSMOB,ICOUL,ieaw )
           Else
              CALL GETINC_ABT(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                        IXCHNG,IKSM,JLSM,KINT2,
     &                        pINT2,NSMOB,ICOUL,ieaw )
           End If
          ELSE
           CALL GETINC_ABS_td(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                  IKSM,JLSM,KINT2,
     &                  pINT2,NSMOB,ICTL)
C
          End If
*
      IF(NTEST.NE.0) THEN
        NI = NOBPTS(ITP,ISM)
        NK = NOBPTS(KTP,KSM)
        IF(IKSM.EQ.0) THEN
          NIK = NI * NK
        ELSE
          NIK = NI*(NI+1)/2
        END IF
        NJ = NOBPTS(JTP,JSM)
        NL = NOBPTS(LTP,LSM)
        IF(JLSM.EQ.0) THEN
          NJL = NJ * NL
        ELSE
          NJL = NJ*(NJ+1)/2
        END IF
        IF(ICOUL.EQ.0) THEN
          WRITE(6,*) ' 2 electron integral block for TS blocks '
          WRITE(6,*) ' Ixchng :', IXCHNG
          WRITE(6,'(1H ,4(A,I2,A,I2,A))')
     &    '(',ITP,',',ISM,')','(',JTP,',',JSM,')',
     &    '(',KTP,',',KSM,')','(',LTP,',',LSM,')'
           CALL WRTMAT(XINT,NIK,NJL,NIK,NJL)
        ELSE
          WRITE(6,*) ' Integrals in Coulomb form '
          WRITE(6,'(1H ,4(A,I2,A,I2,A))')
     &   '(',ITP,',',ISM,')','(',JTP,',',JSM,')',
     &   '(',KTP,',',KSM,')','(',LTP,',',LSM,')'
          NIJ = NI*NJ
          NKL = NK*NL
          CALL WRTMAT(XINT,NIJ,NKL,NIJ,NKL)
        END IF

      END IF
*
C     STOP ' Jeppe forced me to stop in GETINT '
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SCF_Gradient()
! Compute and store the (local) gradient at the current orbitals and iteration

use LnkLst, only: LLlGrd, PutVec
use InfSCF, only: CMO, Iter, FockMO, kOV, mOV, nBO, nBT, nD, nOO, OneHam, Ovrlp
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp

implicit none
real(kind=wp), allocatable :: GrdOO(:,:), GrdOV(:)

call mma_allocate(GrdOO,nOO,nD,Label='GrdOO')
call mma_allocate(GrdOV,mOV,Label='GrdOV')

! Compute the last gradient
call Mk_FockMO(OneHam,Ovrlp,nBT,CMO,nBO,FockMO,nOO,nD,Iter)
call EGrad(OneHam,Ovrlp,nBT,CMO,nBO,GrdOO,nOO,nD,Iter)
call vOO2OV(GrdOO,nOO,GrdOV,mOV,nD,kOV)

! Write gradient to linked list
call PutVec(GrdOV,mOV,Iter,'OVWR',LLlGrd)

call mma_deallocate(GrdOO)
call mma_deallocate(GrdOV)

end subroutine SCF_Gradient

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION NDXFSM(NSMOB,NSMSX,MXPOBS,NO1PS,NO2PS,NO3PS,NO4PS,
     &         IDXSM,ADSXA,SXDXSX,IS12,IS34,IS1234,IPRNT)
*
* Number of double excitations with total symmetry IDXSM
*
* IS12 (0,1,-1)   : Permutational symmetry between index 1 and 2
* IS34 (0,1,-1)   : Permutational symmetry between index 3 and 3
* IS1234 (0,1,-1) : permutational symmetry between index 12 and 34
*
*. General input
      INTEGER ADSXA(MXPOBS,2*MXPOBS),SXDXSX(2*MXPOBS,4*MXPOBS)
*. Specific input
      INTEGER NO1PS(*),NO2PS(*),NO3PS(*),NO4PS(*)
*
*
      N12 = 0
      N34 = 0
      MDX = 0
      DO 200 I12SM = 1, NSMSX
        DO 190 I1SM = 1, NSMOB
          I2SM = ADSXA(I1SM,I12SM)
          IF(IS12.NE.0.AND.I1SM.LT.I2SM) GOTO 190
          IF(IS12.EQ.0) THEN
           I12NUM = (I1SM-1)*NSMSX+I2SM
          ELSE
           I12NUM =  I1SM*(I1SM+1)/2+I2SM
          END IF
          IF(IS12.EQ.0.OR.I1SM.NE.I2SM) THEN
            N12 = NO1PS(I1SM)*NO2PS(I2SM)
          ELSE IF(IS12.EQ.1.AND.I1SM.EQ.I2SM) THEN
            N12 = NO1PS(I1SM)*(NO1PS(I1SM)+1)/2
          ELSE IF(IS12.EQ.-1.AND.I1SM.EQ.I2SM) THEN
            N12 = NO1PS(I1SM)*(NO1PS(I1SM)-1)/2
          END IF
          I34SM = SXDXSX(I12SM,IDXSM)
          DO 90 I3SM = 1, NSMOB
            I4SM = ADSXA(I3SM,I34SM)
            IF(IS34.NE.0.AND.I3SM.LT.I4SM) GOTO 90
            IF(IS34.EQ.0) THEN
             I34NUM = (I3SM-1)*NSMSX+I4SM
            ELSE
             I34NUM =  I3SM*(I3SM+1)/2+I4SM
            END IF
            IF(IS1234.NE.0.AND.I12NUM.LT.I34NUM) GOTO 90
            IF(IS34.EQ.0.OR.I3SM.NE.I4SM) THEN
            N34 = NO3PS(I3SM)*NO4PS(I4SM)
            ELSE IF(IS34.EQ.1.AND.I3SM.EQ.I4SM) THEN
              N34 = NO3PS(I3SM)*(NO3PS(I3SM)+1)/2
            ELSE IF(IS34.EQ.-1.AND.I3SM.EQ.I4SM) THEN
              N34 = NO3PS(I3SM)*(NO3PS(I3SM)-1)/2
            END IF
            IF(IS1234.EQ.0.OR.I12NUM.NE.I34NUM) THEN
              MDX = MDX + N12 * N34
            ELSE IF( IS1234.EQ.1.AND.I12NUM.EQ.I34NUM) THEN
              MDX =  MDX + N12*(N12+1)/2
              ELSE IF( IS1234.EQ.-1.AND.I12NUM.EQ.I34NUM) THEN
              MDX =  MDX + N12*(N12-1)/2
            END IF
C?          WRITE(6,*) ' I1SM I2SM I3SM I4SM MDX '
C?          WRITE(6,*)   I1SM,I2SM,I3SM,I4SM,MDX
   90       CONTINUE
C 100     CONTINUE
  190   CONTINUE
  200 CONTINUE
*
      NDXFSM = MDX
*
      NTEST = 0
      NTEST = MAX(NTEST,IPRNT)
      IF(NTEST.NE.0) THEN
         WRITE(6,*) ' Number of double excitations obtained ', MDX
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

subroutine Trans_K(X,Y,nInter,nIter)

use kriging_mod, only: layer_U
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nInter, nIter
real(kind=wp), intent(in) :: X(nInter,nIter)
real(kind=wp), intent(out) :: Y(nInter,nIter)

!call RecPrt('layer_U',' ',layer_U,nInter,nInter)
!call RecPrt('X',' ',X,nInter,nIter)
call DGEMM_('T','N',nInter,nIter,nInter,One,layer_U,nInter,X,nInter,Zero,Y,nInter)
!call RecPrt('Y',' ',Y,nInter,nIter)

return

end subroutine Trans_K

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Per Ake Malmqvist                                *
************************************************************************
      SUBROUTINE MKSXY(CMO1,CMO2,SXY)
      use OneDat, only: sNoNuc, sNoOri
      use stdalloc, only: mma_allocate, mma_deallocate
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NSXY,NCMO,NBASF,NOSH
      IMPLICIT None
      Real*8 SXY(NSXY),CMO1(NCMO),CMO2(NCMO)

      character(len=8) :: LABEL
C  PURPOSE: FORM THE OVERLAP MATRIX SXY FOR ORBITAL BASES CMO1, CMO2.
C  CODED 1987-02-18, P-AA M.
      Real*8, Allocatable:: SZZ(:), SSQ(:), PROD(:)
      INTEGER NSZZ,NSSQ,NPROD,ISY,NO,NB,IRC,IOPT,ICMP,ISYLAB,LSZZ1,
     &        ISXY,ICMO
C  CALCULATE SIZE AND ALLOCATE A FIELD SZZ FOR OVERLAP MATRIX
C  IN COMMON BASIS SET (TRIANGULAR), SSQ TEMPORARY STORAGE
C  FOR EACH OF ITS SYMMETRY BLOCKS (SQUARE), AND PROD FOR
C  INTERMEDIATE MATRIX PRODUCTS.
      NSZZ=0
      NSSQ=0
      NPROD=0
      DO ISY=1,NSYM
        NO=NOSH(ISY)
        NB=NBASF(ISY)
        NSZZ=NSZZ+(NB*(NB+1))/2
        NSSQ=MAX(NSSQ,NB**2)
        NPROD=MAX(NPROD,NO*NB)
      end do
      CALL mma_allocate(SZZ,NSZZ,Label='SZZ')
      CALL mma_allocate(SSQ,NSSQ,Label='SSQ')
      CALL mma_allocate(PROD,NPROD,Label='PROD')
C  READ OVERLAP MATRIX SZZ:
      IRC=-1
      IOPT=ibset(ibset(0,sNoOri),sNoNuc)
      ICMP=1
      ISYLAB=1
      LABEL='MLTPL  0'
      CALL RDONE(IRC,IOPT,LABEL,ICMP,SZZ,ISYLAB)
      IF ( IRC.NE.0 ) THEN
        WRITE(6,*)
        WRITE(6,*)'      *** ERROR IN SUBROUTINE MKSXY ***'
        WRITE(6,*)'     OVERLAP INTEGRALS ARE NOT AVAILABLE'
        WRITE(6,*)
        CALL ABEND()
      ENDIF
C  LOOP OVER SYMMETRIES:
      LSZZ1=1
      ISXY=1
      ICMO=1
      DO ISY=1,NSYM
        NB=NBASF(ISY)
        IF(NB.EQ.0) cycle
        NO=NOSH(ISY)
        if (NO /= 0) then
        CALL SQUARE(SZZ(LSZZ1),SSQ,1,NB,NB)
C  PROD:=SSQ*CMO2
        CALL DGEMM_('N','N',NB,NO,NB,1.0D0,SSQ,NB,CMO2(ICMO),NB,
     &             0.0D0,PROD,NB)
C  SXY:=(CMO1(TRANSP))*PROD
        CALL DGEMM_('T','N',NO,NO,NB,1.0D0,CMO1(ICMO),NB,PROD,NB,
     &             0.0D0,SXY(ISXY),NO)
        ISXY=ISXY+NO**2
        ICMO=ICMO+NO*NB
        end if
        LSZZ1=LSZZ1+(NB*(NB+1))/2
      end do
      CALL mma_deallocate(SZZ)
      CALL mma_deallocate(SSQ)
      CALL mma_deallocate(PROD)

      END SUBROUTINE MKSXY

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine inter1(Label,iBas_Lab,Coor,ZNUC,N_Cent)
      Use Basis_Info
      Use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8(a-h,o-z)
#include "Molcas.fh"
      Real*8 A(3),Coor(3,*),ZNUC(*)
      integer Ibas_Lab(*)
      Character*(LENIN) Lbl
      Character*(LENIN) Label(*)
      Logical DSCF
*
      DSCF=.False.
      nDiff=0
      Call IniSew(DSCF,nDiff)
*
      mdc=0
      ndc=0
      Do iCnttp=1,nCnttp
         If(dbsc(iCnttp)%Aux.or.
     &      dbsc(iCnttp)%Frag.or.
     &      dbsc(iCnttp)%pChrg) Then
           mdc = mdc + dbsc(iCnttp)%nCntr
           Go To 99
         End If
         Do iCnt=1,dbsc(iCnttp)%nCntr
            mdc=mdc+1
            Lbl=dc(mdc)%LblCnt(1:LENIN)
            A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
            Do iCo=0,nIrrep/dc(mdc)%nStab-1
               ndc=ndc+1
               kop=dc(mdc)%iCoSet(iCo,0)
               Call OA(kOp,A,Coor(1:3,ndc))
               Label(ndc)=Lbl(1:LENIN)
               iBas_Lab(ndc)=iCnttp
               ZNUC(ndc)=DBLE(dbsc(iCnttp)%AtmNr)
            End Do
         End Do
 99      Continue
      End Do
      n_cent=ndc
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Per Ake Malmqvist                                *
!               2019, Stefano Battaglia                                *
!***********************************************************************

subroutine GRPINI(IGROUP,NGRP,JSTATE_OFF,HEFF,H0,U0,nState)
! 2012  PER-AKE MALMQVIST
! Multi-State and XMS initialization phase
! Purpose: For a selected set IGROUP, create a set of CMO coefficients
! and orbital energies which are to be used in common for the
! calculations belonging to this set. Also, change the CI arrays in this
! group such that they diagonalize the H0 matrix.
! The states in the group can be obtained from the ordered MSTATE array,
! for which a group offset JSTATE_OFF is passed in.

use fciqmc_interface, only: DoFCIQMC
#ifdef _DMRG_
use qcmaquis_interface, only: qcmaquis_interface_set_param
#endif
use PrintLevel, only: DEBUG, USUAL, VERBOSE
use caspt2_global, only: CMO, CMO_Internal, CMOPT2, DMIX, DREF, FIFA, FIMO, iPrGlb, LUONEM, NCMO, TORB, Weight
use caspt2_module, only: CIThr, CPUFMB, CPUGIN, CPUINT, DMRG, DoCumulant, HZERO, iAd1m, IEOF1M, IfChol, IfDW, IfsadRef, IfXMS, &
                         jState, mState, nConf, NoTri, STSym, TIOFMB, TIOGIN, TIOINT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IGROUP, NGRP, JSTATE_OFF, nState
real(kind=wp), intent(inout) :: Heff(Nstate,Nstate), H0(Nstate,Nstate), U0(Nstate,Nstate)
integer(kind=iwp) :: I, iDisk, iState, J, K
real(kind=wp) :: CPE, CPTF0, CPTF10, CPU, CPU0, CPU1, TIO, TIO0, TIO1, TIOE, TIOTF0, TIOTF10
logical(kind=iwp) :: Initiate
character(len=27) :: STLNE2
real(kind=wp), allocatable :: CIRef(:,:), CIXMS(:), HONE(:)

! ----------------------------------------------------------------------
call TIMING(CPTF0,CPE,TIOTF0,TIOE)
! ----------------------------------------------------------------------
! Number of states in this group.
if (IPRGLB == DEBUG) then
  write(u6,*) ' Entered GRPINI.'
  write(u6,*) ' NSTATE=',NSTATE
  write(u6,*) ' The MSTATE array:'
  write(u6,'(1x,20I4)') (MSTATE(J),J=1,NSTATE)
  write(u6,*) ' IGROUP,NGRP=',IGROUP,NGRP
end if

if (NGRP == 0) then
  write(u6,*) ' Number of states in the (X)MS group is 0!'
  write(u6,*) ' This should never happen, aborting...'
  call ABEND()
end if

write(STLNE2,'(A,I0)') 'Initial phase for group ',IGROUP
call StatusLine('CASPT2: ',STLNE2)
if (IPRGLB >= USUAL) then
  write(u6,'(A)') repeat('*',80)
  write(u6,'(A,I3)') ' Multi-State initialization phase begins for group ',IGROUP
  write(u6,'(A)') repeat('-',80)
end if

! ----------------------------------------------------------------------

! Load the CASSCF naural orbital MO coefficients
call mma_allocate(CMO_Internal,NCMO,Label='CMO_Internal')
CMO => CMO_Internal

IDISK = IAD1M(1)
call ddafile(LUONEM,2,CMO,NCMO,IDISK)

! IEOF1M is the next free disk address on LUOneM
IEOF1M = IDISK

! Allocate memory for HONE, used exclusivly in MkFock.
! Since MkFock might be called several times with the same
! CMOs but different density matrices we controll the computation
! of the one- and two-electron integrals from the outside. This to
! remove redundant work.

call mma_allocate(HONE,NoTri,Label='HONE')
Initiate = .true.

! Loop over states, selecting those belonging to this group.
! For each such state, compute the Fock matrix in original MO basis,
! and then the zeroth-order Hamiltonian elements between states.

! Timer for Fock matrix build
call timing(CPU0,CPU,TIO0,TIO)
! Loop over all states in group
do J=1,Ngrp
  Jstate = J+JSTATE_OFF

  ! Copy the 1-RDM of Jstate from DMIX into DREF
  ! this might be obsolete if we remove sadref
  if (IFSADREF) then
    !! This DREF is used only for constructing the Fock in H0.
    !! DREF used in other places will be constructed in elsewhere
    !! (STINI).
    DREF(:) = Zero
    do K=1,Nstate
      DREF(:) = DREF(:)+Weight(K)*DMIX(:,K)
    end do
  else
    DREF(:) = DMIX(:,Jstate)
  end if

  ! Compute the Fock matrix in MO basis for state Jstate
  call MkFock(CMO,nCMO,FIMO,size(FIMO),FIFA,size(FIFA),DREF,size(DREF),HONE,size(HONE),Initiate)

  ! NN.15, TODO:
  ! the following transformation are skipped in DMRG-CASPT2 run
  ! for the time, this will be fixed later to implement DMRG-MS-CASPT2
  if (DoCumulant .or. DoFCIQMC .or. DMRG) then
    call GPRINI_FINISH()
    return
  end if

  ! Loop over bra functions
  do I=1,Ngrp
    Istate = I+JSTATE_OFF
    ! Compute matrix element and put it into H0
    call FOPAB(FIFA,size(FIFA),Istate,Jstate,H0(Istate,Jstate))
  end do

  if (IPRGLB >= VERBOSE) then
    ! In case of MS- and XDW-CASPT2 calculations, compute off-diagonal
    ! elements of the Fock matrix as a sanity check of the diagonal
    ! approximation within the generalized Bloch equation.
    if (IFDW .or. (.not. IFXMS)) then
      write(u6,*)
      write(u6,*) 'Fock matrix couplings'
      write(u6,*) '---------------------'
      write(u6,*)
      write(u6,'(10X,6X,A3,I4,A3)') ' | ',MSTATE(Jstate),' > '
      do Istate=1,Nstate
        if (Istate /= Jstate) then
          ! Compute matrix element and print it out
          call FOPAB(FIFA,size(FIFA),Istate,Jstate,H0(Istate,Jstate))
          write(u6,'(A3,I4,A3,F16.8)') ' < ',MSTATE(Istate),' | ',H0(Istate,Jstate)
          ! Then set it to zero because we are within the diagonal approximation
          H0(Istate,Jstate) = Zero
        else
          ! Just print out the already computed diagonal element
          write(u6,'(A3,I4,A3,F16.8)') ' < ',MSTATE(Istate),' | ',H0(Istate,Jstate)
        end if
      end do
      write(u6,*)
    end if
  end if

! End of long loop over Jstate
end do
! End timer Fock matrix build
call timing(CPU1,CPU,TIO1,TIO)
CPUFMB = CPU1-CPU0
TIOFMB = TIO1-TIO0

! In case of a XMS calculation, i.e. Ngrp > 1 and not DW, transform
! the CI arrays of this group of states to make the Fock matrix
! diagonal in the model space.
! Note that this is only done for XMS here. For XDW and RMS it is
! done in the xdwinit subroutine. This code duplication is silly,
! but we will get rid of it once we drop the groups of states
if ((Ngrp > 1) .and. IFXMS .and. (.not. IFDW) .and. (HZERO /= 'DYALL')) then

  ! In case of XMS-CASPT2, printout H0 in original basis
  if (IPRGLB >= USUAL) then
    write(u6,*)
    write(u6,*) ' H0 in the original model space basis:'
    call prettyprint(H0,Ngrp,Ngrp)
  end if
  ! Diagonalize H0 and save eigenvectors in U0
  call eigen(H0,U0,Ngrp)

  ! Transform the Fock matrix in the new basis
  call transmat(H0,U0,Ngrp)
  if (IPRGLB >= USUAL) then
    write(u6,*) ' H0 eigenvectors:'
    call prettyprint(U0,Ngrp,Ngrp)
  end if
  if (IPRGLB >= DEBUG) then
    write(u6,*) ' H0 in the rotated model space basis:'
    call prettyprint(H0,Ngrp,Ngrp)
  end if

  ! As well as Heff
  call transmat(Heff,U0,Ngrp)
  if (IPRGLB >= VERBOSE) then
    write(u6,*) ' Heff[1] in the rotated model space basis:'
    call prettyprint(Heff,Ngrp,Ngrp)
  end if

  ! Mix the CI arrays according to the H0 eigenvectors. Assume we can
  ! put all the original ones in memory, but put the resulting vectors
  ! one by one in a buffer.
  if (IPRGLB >= VERBOSE) then
    write(u6,'(A)') ' The CASSCF states are now rotated according to the H0 eigenvectors'
    write(u6,*)
  end if

  call mma_allocate(CIref,Nconf,Ngrp,Label='CIRef')
  ! Load the CI arrays into memory
  do I=1,Ngrp
    call loadCI(CIref(:,I),I)
  end do

  call mma_allocate(CIXMS,Nconf,Label='CIXMS')
  do J=1,Ngrp
    ! Transform the states
    call dgemm_('N','N',Nconf,1,Ngrp,One,CIREF,Nconf,U0(:,J),Ngrp,Zero,CIXMS,Nconf)

    ! Write the rotated CI coefficients back into LUCIEX and REPLACE the
    ! original unrotated CASSCF states. Note that the original states
    ! are still available in the JobIph file
    call writeCI(CIXMS,J)

    if (IPRGLB >= VERBOSE) then
      write(u6,'(1x,a,i3)') ' The CI coefficients of rotated model state nr. ',MSTATE(J)
      call PRWF_CP2(STSYM,NCONF,CIXMS,CITHR)
    end if
  end do

  call mma_deallocate(CIREF)
  call mma_deallocate(CIXMS)

end if

call GPRINI_FINISH()

contains

subroutine GPRINI_FINISH()

  call mma_deallocate(HONE)
  ! We now know FIFA as expressed in initial RAS (natural) orbitals.
  ! Transform it to a new basis in which the non-diagonal couplings
  ! between subspaces (inactive, ras1, etc) are zero. As a by-product,
  ! the CI arrays will be transformed so they still represent the
  ! model functions, but using the new orbitals.
  ! Note that the matrices FIFA, FIMO, etc are transformed as well

  call ORBCTL(CMO,NCMO,TORB,size(TORB),FIFA,size(FIFA),FIMO,size(FIMO))

  ! In subroutine stini, the individual RHS, etc, arrays will be computed
  ! for the states. If this is a true XMS calculation (Ngrp > 1) then
  ! there is one data set that is in common for these calculations,
  ! namely the transformed MO integrals (if conventional), or the
  ! transformed Cholesky vectors (if IfChol), so these are computed here

  call TIMING(CPU0,CPU,TIO0,TIO)

  ! TRACHO3 computes MO-transformed Cholesky vectors without computing
  ! Fock matrices
  ! TRACTL(nCMO,CMO,0) computes transformed 2-body MO integrals
  if (IfChol) then
    call TRACHO3(CMO,NCMO)
  else
    if (.not. DoFCIQMC) call TRACTL(nCMO,CMO,0)
  end if

  call TIMING(CPU1,CPU,TIO1,TIO)
  CPUINT = CPU1-CPU0
  TIOINT = TIO1-TIO0
  CMOPT2(:) = CMO(:)

  call mma_deallocate(CMO_Internal)
  nullify(CMO)

# ifdef _DMRG_
  if (DMRG) then
    !*******************************************************************
    ! load back two-electron integrals (pu|vx)
    !*******************************************************************
    ! Load the integrals in memory
    call read_integrals()

    ! set to compute 2-, 3- and 4-rdm
    call qcmaquis_interface_set_param('MEASURE[1rdm]','1')
    call qcmaquis_interface_set_param('MEASURE[2rdm]','1')
    call qcmaquis_interface_set_param('MEASURE[3rdm]','1')
    ! call qcmaquis_interface_set_param('MEASURE[4rdm]','1')
  end if
# endif
  ! --------------------------------------------------------------------
  call TIMING(CPTF10,CPE,TIOTF10,TIOE)
  CPUGIN = CPTF10-CPTF0
  TIOGIN = TIOTF10-TIOTF0
  ! --------------------------------------------------------------------

end subroutine GPRINI_FINISH

end subroutine GRPINI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Steven Vancoillie                                *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
!
! Common information regarding the parallel runtime
!
! GLOBAL rank and number of processes. This reflects the _entire_ MPI runtime,
! regardless of whether we are running in fake parallel or not!
!
!     mpp_procid
!     mpp_nprocs
!
! rank number of the root process, i.e., the mpp_procid of the "king"
!
!     mpp_rootid
!
! variable that describes if the MPI processes are sharing work, so if this is
! false, it means we are using a fake parallel environment and work is replicated.
!
!     mpp_workshare
!
! global variables describing the parallel environment
!
! S. Vancoillie, Aug 2014, in an effort to clean up use of parallel
! header files and global variables with overlapping functionality.
!
!     MyRank   - rank of process, starting from 0
!     nProcs   - number of processes
!
! NOTE: MyRank and nProcs are the LOCAL view of the rank and number
! of processes. That means that for a "fake" parallel run (where each
! process actually runs in serial), MyRank=0 and nProcs=1.
! This also means that in a FAKE parallel run, MyRank=0 does NOT give
! you a single "master" process or "king" of all processes!!! For that,
! you need to use the logical function KING().

module Para_Info

use Definitions, only: iwp

implicit none
private

#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: mpp_procid, mpp_nprocs
logical(kind=iwp) :: mpp_workshare
public :: mpp_procid, mpp_nprocs, mpp_workshare
#endif
integer(kind=iwp) :: MyRank, nProcs
integer(kind=iwp), parameter :: mpp_rootid = 0
public :: MyRank, nProcs, mpp_rootid, mpp_id, Is_Real_Par, King, Set_Do_Parallel

contains

function Is_Real_Par()
! SVC: determine if multiple processes are working together
  logical(kind=iwp) :: Is_Real_Par
# ifdef _MOLCAS_MPP_
  Is_Real_Par = mpp_workshare
# else
  Is_Real_Par = .false.
# endif
end function Is_Real_Par

function King()
! SVC: determine if this is the absolute master process,
!       regardless of the parallel environment
  logical(kind=iwp) :: King
# ifdef _MOLCAS_MPP_
  King = mpp_procid == mpp_rootid
# else
  King = .true.
# endif
end function King

function mpp_id()
! returns the absolute id of the process,
! regardless of the parallel environment
  integer(kind=iwp) :: mpp_id
# ifdef _MOLCAS_MPP_
  mpp_id = mpp_procid
# else
  mpp_id = mpp_rootid
# endif
end function mpp_id

subroutine Set_Do_Parallel(Par_Status)
  logical(kind=iwp), intent(in) :: Par_Status
# ifdef _MOLCAS_MPP_
  mpp_workshare = (Par_Status .and. (mpp_nprocs > 1))
  if (mpp_workshare) then
    MyRank = mpp_procid
    nProcs = mpp_nprocs
  else
    MyRank = 0
    nProcs = 1
  end if
# else
# include "macros.fh"
  unused_var(Par_Status)
  return
# endif
end subroutine Set_Do_Parallel

end module Para_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mxattb_cvb(a,b,n1,n2,n3,c)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n1, n2, n3
real(kind=wp), intent(in) :: a(n2,n1), b(n2,n3)
real(kind=wp), intent(out) :: c(n1,n3)

call DGEMM_('T','N',n1,n3,n2,One,a,n2,b,n2,Zero,c,n1)

return

end subroutine mxattb_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Subroutine PLF2(AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iShell,
     &                iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,kOp)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use k2_arrays, only: Sew_Scr
      use lw_Info
      use Gateway_Info, only: ThrInt
      use sort_data, only: DimSyB, lSll
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
*
      Real*8 AOint(ijkl,iCmp,jCmp,kCmp,lCmp)
      Integer iShell(4), iAO(4), kOp(4), iAOst(4), iSOs(4)
      Logical Shijij
*
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*
      irout = 109
      iprint = nprint(irout)
      If (iPrint.ge.49) Then
         r1=DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,[One],0)
         r2=DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1)
         Write (6,*) ' Sum=',r1
         Write (6,*) ' Dot=',r2
      End If
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt(' In Plf2: AOInt',' ',
     &                              AOInt,ijkl,iCmp*jCmp*kCmp*lCmp)
#endif
*
*     Allocate space to store integrals together with their
*     Symmetry batch and sequence number.
*     To avoid conflicts in using memory this is done in the
*     subroutine PSOAO
*
      nUt=-1
      nij=DimSyB(1,1)
      mij=lSll(1)/nij
C     Write (*,*) 'nij,mij=',nij,mij
*
*     quadruple loop over elements of the basis functions angular
*     description. loops are reduced to just produce unique SO integrals
*     observe that we will walk through the memory in AOint in a
*     sequential way.
*
      iAOsti=iAOst(1)
      iAOstj=iAOst(2)
      iAOstk=iAOst(3)
      iAOstl=iAOst(4)
      iAOi=iAO(1)
      iAOj=iAO(2)
      iAOk=iAO(3)
      iAOl=iAO(4)
*
      ijklCmp=iCmp*jCmp*kCmp*lCmp
      Call DCopy_(ijkl*2*ijklCmp,[One],0,Sew_Scr(lwSyB),1)
*
      Do 100 i1 = 1, iCmp
         iSOs(1)=iAOtSO(iAOi+i1,kOp(1))+iAOsti
         Do 200 i2 = 1, jCmp
            iSOs(2)=iAOtSO(iAOj+i2,kOp(2))+iAOstj
            Do 300 i3 = 1, kCmp
               iSOs(3)=iAOtSO(iAOk+i3,kOp(3))+iAOstk
               Do 400 i4 = 1, lCmp
                  iSOs(4)=iAOtSO(iAOl+i4,kOp(4))+iAOstl
*
                iSO =iSOs(1)
                jSO =iSOs(2)
                kSO =iSOs(3)
                lSO =iSOs(4)
*
                nijkl = 0
                Do 120 lSOl = lSO, lSO+lBas-1
                   Do 220 kSOk = kSO, kSO+kBas-1
                      iSOkl = iTri(kSOk,lSOl)
                      Do 320 jSOj = jSO, jSO+jBas-1
                         Do 420 iSOi = iSO, iSO+iBas-1
                            nijkl = nijkl + 1
                            AInt=AOint(nijkl,i1,i2,i3,i4)
                            If (Abs(AInt).lt.ThrInt) Go To 420
                            iSOij = iTri(iSOi,jSOj)
*
C                           Write (*,*) 'iSOij,iSOkl=',iSOij,iSOkl
*
                            nUt=nUt+1
                            Sew_Scr(lwInt+nUt)=Aint
                            iBin=(iSOkl-1)/mij
C                           Write (*,*) 'iBin=',iBin+1
                            Sew_Scr(lwSyB+nUt)=DBLE(iBin+1)
                            Sew_Scr(lwSqN+nUt)=DBLE((iSOkl-1-iBin*mij)
     &                                      *nij+iSOij)
C                           Write (*,*) 'iSq=',Sew_Scr(lwSqN+nUt)
*
                            If (iSOij.ne.iSOkl) Then
                               nUt=nUt+1
                               Sew_Scr(lwInt+nUt)=Aint
                               iBin=(iSOij-1)/mij
C                              Write (*,*) 'iBin=',iBin+1
                               Sew_Scr(lwSyB+nUt)=DBLE(iBin+1)
                               Sew_Scr(lwSqN+nUt)=
     &                               DBLE((iSOij-1-iBin*mij)*nij+iSOkl)
C                              Write (*,*) 'iSq=',Sew_Scr(lwSqN+nUt)
                            End If
*
420                      Continue
320                   Continue
220                Continue
120             Continue
*
400            Continue
300         Continue
200      Continue
100   Continue
*
*     pass the integral to phase 1 of the bin sorting algorithm
*
      Call R8PREP(nUt+1,Sew_Scr(lwInt))
      Call SORT1A(nUt+1,Sew_Scr(lwInt),Sew_Scr(lwSqN),Sew_Scr(lwSyB))
      nUt=0
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(iShell)
         Call Unused_logical(Shijij)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine multi_opendir(FNAM, iunit)
      implicit none
c
c Direct fortran I/O with irregular data records
c
c Assume here RECL in byte units  (Same assumption in t3smat.f).
c
c PV/LAOG, 22 may 2003.
c
c
      character FNAM*(*)
      integer iunit, iost
#include "ndisk.fh"
      Logical is_error
*     open(unit=iunit, file=FNAM, access='direct',
*    $     form='unformatted', status='unknown', recl=nblock*8)
      Call MOLCAS_Open_Ext2(iUnit,FNam,
     &                      'direct','unformatted',
     &                      iost,.TRUE.,
     &                      nblock*8,'unknown',is_error)
      If (iost.gt.0 .or. is_error) Then
         Write (6,*) 'Multi_OpenDir: Error opening file!'
      End If
      return
      end



      subroutine multi_readir(G,lg,ifile,ias)
c
c  Direct fortran I/O with irregular data records
c
c  Each data record is assumed to begin aligned with a disk record
c  but may span several disk records.
c
c  The price to pay for this flexibility is
c  1) remembering the correspondance between data record numbers
c     and corresponding initial disk records.
c  2) wasting some disk space, in average about nu*nblock/2
c     where nu is the number of data records and nblock the disk
c     record size.
c
c  Arguments
c     G        Buffer (real*8 words)
c     lg       Buffer length
c     ifile    file unit
c     ias      direct access record to start with
c     (nblock  direct access record length, defined in include file)
c
c  PV/LAOG, 22 may 2003.
c
      implicit none
#include "ndisk.fh"
      integer lg, ifile, ias, iloc,irest,kas,k, last,iopt
      common/ioind/iopt(96)
      real*8 G(lg)
c
      iloc=1
      irest=lg
      kas=ias
c
      do while(irest.gt.0)
      k=min(irest,nblock)
      IF(kas.le.iopt(27))then
      call readir(G(iloc),k,ifile,kas)
      else
      call readir(G(iloc),k,ifile+1,kas-iopt(27))
      endif
      iloc=iloc+k
      irest=irest-k
      kas=kas+1
      enddo
      return
c
c
c
      entry multi_wridir(G,lg,ifile,ias,last)
c
      iloc=1
      irest=lg
      kas=ias

c
      do while(irest.gt.0)
      k=min(irest,nblock)
      IF(kas.le.iopt(27))then
      call wridir(G(iloc),k,ifile,kas)
      else
      call wridir(G(iloc),k,ifile+1,kas-iopt(27))
      endif
      iloc=iloc+k
      irest=irest-k
      kas=kas+1
      enddo
      last=kas-1
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1988, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE TRACI_LUCIA(      X,  LUCIN, LUCOUT,  IXSPC,   IXSM,
     &                          VEC1,   VEC2)
*
* A rotation matrix X is defining expansion from
* old to new orbitals
*        PHI(NEW) = PHI(OLD) * X
*
* change CI coefficients(sym IXSM, space IXSPC )
* so they corresponds to PHI(NEW) basis
*
* The input CI vector is on LUCIN and the transformed CI vector
* will be delivered on LUCOUT.
*
* Transformation as conceived by Per-AAke Malmquist
* (I.J.Q.C. vol XXX, p479 ,1986 (OCTOBER ISSUE ))
*
*  Jeppe Olsen 1988
*
* New LUCIA version of Jan 1998
*
* note The transformation matrix X is supposed to be in complete form
* as a matrix over NTOOB orbitals.
*
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "lucinp.fh"
#include "clunit.fh"
*. Common block for communicating with sigma
#include "cands.fh"
*
      DIMENSION X(*),VEC1(*),VEC2(*)
* Some dummy initializations
      IOFF = 0 ! jwk-cleanup
*
      NTEST = 0
      IF(NTEST.GE.5) THEN
        WRITE(6,*) ' ================'
        WRITE(6,*) ' Welcome to TRACI '
        WRITE(6,*) ' ================'
        WRITE(6,*)
        WRITE(6,*) ' IXSPC,IXSM = ', IXSPC,IXSM
      END IF
*. Memory allocation
* for a matrix T
      CALL GETMEM('TMAT  ','ALLO','REAL',KLT,NTOOB**2)
*. Scratch in PAMTMT
      LSCR = NTOOB**2 +NTOOB*(NTOOB+1)/2
      CALL GETMEM('KLSCR ','ALLO','REAL',KLSCR,LSCR)
*. Obtain T matrix used for transformation, for each symmetry separately
      DO ISM = 1, NSMOB
        IF(ISM.EQ.1) THEN
          IOFF = 1
        ELSE
          IOFF = IOFF + NTOOBS(ISM-1)**2
        END IF
        IF(NTOOBS(ISM).GT.0) THEN
         CALL PAMTMT(X(IOFF),WORK(KLT-1+IOFF),WORK(KLSCR),NTOOBS(ISM))
        END IF
      END DO
*. Transform CI-vector
      ICSPC = IXSPC
      ICSM  = ICSM
      ISSPC = IXSPC
      ISSM  = IXSM
*
      CALL TRACID(WORK(KLT),    LUCIN,   LUCOUT,    LUSC1,    LUSC2,
     &                LUSC3,     VEC1,     VEC2)
*
      CALL GETMEM('TMAT  ','FREE','REAL',KLT,NTOOB**2)
      CALL GETMEM('KLSCR ','FREE','REAL',KLSCR,LSCR)
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine abc_axes(cryst,coord,xyz,abc,Do_option,iReturn)
! this Subroutine performs a transformation of the main axes
! (magnetic, anisotropic etc.) from a xyz system in
! crystallographic "abc" system, and vice-versa;
!    Do_option = 1 =>  transform from xyz to abc
!    Do_option = 2 =>  transform from abc to xyz
!    If Do_option has other value, abort
!    coord(3)-- Cartesian coordinates of the main magnetic center

use Constants, only: Zero, One, Two, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: cryst(6), coord(3)
real(kind=wp), intent(inout) :: xyz(3,3), abc(3,3)
integer(kind=iwp), intent(in) :: Do_option
integer(kind=iwp), intent(out) :: iReturn
integer(kind=iwp) :: i
real(kind=wp) :: a, al, b, bt, c, cal, cbt, cgm, gm, pX(3), pY(3), pZ(3), sgm, v, x, y, z

! initializations
a = cryst(1)
b = cryst(2)
c = cryst(3)
al = cryst(4)*deg2rad
bt = cryst(5)*deg2rad
gm = cryst(6)*deg2rad
cal = cos(al)
cbt = cos(bt)
cgm = cos(gm)
sgm = sin(gm)

v = sqrt(One-cal*cal-cbt*cbt-cgm*cgm+Two*cal*cbt*cgm)

if (Do_option == 1) then

  do i=1,3
    X = xyz(1,i)+coord(1)
    Y = xyz(2,i)+coord(2)
    Z = xyz(3,i)+coord(3)

    pX(1) = One/a
    pY(1) = -cgm/(a*sgm)
    pZ(1) = ((cal*cgm-cbt)/(a*v*sgm))

    pX(2) = Zero
    pY(2) = One/(b*sgm)
    pZ(2) = (cbt*cgm-cal)/(b*v*sgm)

    pX(3) = Zero
    pY(3) = Zero
    pZ(3) = sgm/(c*v)

    abc(:,i) = pX(:)*X+pY(:)*Y+pZ(:)*Z
  end do

else if (Do_option == 2) then

  do i=1,3
    X = abc(1,i)*a
    Y = abc(2,i)*b
    Z = abc(3,i)*c

    pX(1) = One
    pY(1) = cgm
    pZ(1) = cbt

    pX(2) = Zero
    pY(2) = sgm
    pZ(2) = (cal-cbt*cgm)/sgm

    pX(3) = Zero
    pY(3) = Zero
    pZ(3) = v/sgm

    xyz(1,i) = X+Y*cgm+Z*cbt
    xyz(2,i) = Y*sgm+Z*((cal-cbt*cgm)/sgm)
    xyz(3,i) = Z*v/sgm

    xyz(:,i) = pX(:)*X+pY(:)*Y+pZ(:)*Z
  end do
else
  write(u6,'(A)') 'the Do_option is not specified. '
  write(u6,'(A)') 'the program continues without ABCC option'
  iReturn = 1
end if

return

end subroutine abc_axes

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  DENS   := calculate two-electron (transition) densities          *
c  *                                                                   *
c  *********************************************************************
      subroutine dens_2_cvb(v1,v2,cfrom,d2mata,d2matb,
     > i1alf,i1bet,iafrm,ibfrm,iato,ibto,phato,phbto,
     > d1mata,d1matb,
     > nda,ndb,n1a,n1b,nam1,nbm1,norb,commut,sc,absym)
c  Calculates V1 EijEkl CFROM and V2 EijEkl CFROM
      implicit real*8 (a-h,o-z)
      logical commut,sc,absym
      dimension v1(nda,ndb),v2(nda,ndb),cfrom(nda,ndb)
      dimension d2mata(norb*norb,norb*norb),d2matb(norb*norb,norb*norb)
      dimension i1alf(n1a,norb),i1bet(n1b,norb)
      dimension iafrm(norb,nda),ibfrm(norb,ndb)
      dimension iato(norb,0:nam1),ibto(norb,0:nbm1)
      dimension phato(norb,nam1),phbto(norb,nbm1)
      dimension d1mata(norb,norb),d1matb(norb,norb)
      dimension res1(20*20),res2(20*20)
      save thresh,two
      data thresh/1d-10/,two/2d0/

      call dev1b2_cvb(v1,cfrom,d1mata,
     >  i1alf,i1bet,iato,ibto,phato,phbto,
     >  norb*norb,nda,ndb,n1a,n1b,nam1,nbm1,norb,commut,sc,.true.,absym)
      call dev1b2_cvb(v1,v2,d1matb,
     >  i1alf,i1bet,iato,ibto,phato,phbto,
     >  norb*norb,nda,ndb,n1a,n1b,nam1,nbm1,norb,commut,sc,.true.,absym)

      do 9379 ip1=1,norb*norb
      iorb=(ip1-1)/norb+1
      jorb=ip1-(iorb-1)*norb
      call fzero(res1,ip1)
      call fzero(res2,ip1)

c  1) Alpha excitation
      do 3100 ia=1,n1a
      iaxtmp=i1alf(ia,iorb)
      jax=iato(jorb,iaxtmp)
      if(jax.ne.0)then
        iax=iato(iorb,iaxtmp)
        tcof=phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
        do 93791 ip2=1,ip1
        korb=(ip2-1)/norb+1
        lorb=ip2-(korb-1)*norb
c 2. alpha k -> l
        itmp=iafrm(korb,jax)
        kax=iato(lorb,itmp)
        if(kax.ne.0)then
c  I -> J
          do 3200 ibx=1,ndb
          if(abs(cfrom(iax,ibx)).gt.thresh)then
            phase=phato(korb,itmp)*phato(lorb,itmp)
            term=tcof*phase*cfrom(iax,ibx)
            res1(ip2)=res1(ip2)+v1(kax,ibx)*term
            res2(ip2)=res2(ip2)+v2(kax,ibx)*term
          endif
3200      continue
        endif
93791   continue
c 2. beta  k -> l
        do 3201 ibx=1,ndb
        if(abs(cfrom(iax,ibx)).gt.thresh)then
          do 93792 ip2=1,ip1
          korb=(ip2-1)/norb+1
          lorb=ip2-(korb-1)*norb
          itmp=ibfrm(korb,ibx)
          kbx=ibto(lorb,itmp)
          if(kbx.ne.0)then
            phase=phbto(korb,itmp)*phbto(lorb,itmp)
            term=tcof*phase*cfrom(iax,ibx)
            res1(ip2)=res1(ip2)+v1(jax,kbx)*term
            res2(ip2)=res2(ip2)+v2(jax,kbx)*term
          endif
93792     continue
        endif
3201    continue
      endif
3100  continue

      if(.not.absym)then
c  2) Beta excitation
      do 4100 ib=1,n1b
      ibxtmp=i1bet(ib,iorb)
      jbx=ibto(jorb,ibxtmp)
      if(jbx.ne.0)then
        ibx=ibto(iorb,ibxtmp)
        tcof=phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
        do 93793 ip2=1,ip1
        korb=(ip2-1)/norb+1
        lorb=ip2-(korb-1)*norb
c 2. beta  k -> l
        itmp=ibfrm(korb,jbx)
        kbx=ibto(lorb,itmp)
        if(kbx.ne.0)then
c  I -> J
          do 4200 iax=1,nda
          if(abs(cfrom(iax,ibx)).gt.thresh)then
            phase=phbto(korb,itmp)*phbto(lorb,itmp)
            term=tcof*phase*cfrom(iax,ibx)
            res1(ip2)=res1(ip2)+v1(iax,kbx)*term
            res2(ip2)=res2(ip2)+v2(iax,kbx)*term
          endif
4200      continue
        endif
93793   continue
c 2. alpha k -> l
        do 4201 iax=1,nda
        if(abs(cfrom(iax,ibx)).gt.thresh)then
          do 93794 ip2=1,ip1
          korb=(ip2-1)/norb+1
          lorb=ip2-(korb-1)*norb
          itmp=iafrm(korb,iax)
          kax=iato(lorb,itmp)
          if(kax.ne.0)then
            phase=phato(korb,itmp)*phato(lorb,itmp)
            term=tcof*phase*cfrom(iax,ibx)
            res1(ip2)=res1(ip2)+v1(kax,jbx)*term
            res2(ip2)=res2(ip2)+v2(kax,jbx)*term
          endif
93794     continue
        endif
4201    continue
      endif
4100  continue
      else
        do 93795 ip2=1,ip1
        res1(ip2)=two*res1(ip2)
        res2(ip2)=two*res2(ip2)
93795   continue
      endif

      do 93796 ip2=1,ip1
      korb=(ip2-1)/norb+1
      lorb=ip2-(korb-1)*norb
      d2mata(ip1,ip2)=res1(ip2)
      d2matb(ip1,ip2)=res2(ip2)
c  D(lk|ji) = E_lk E_ji - \delta_kj E_li
      if(korb.eq.jorb)then
        d2mata(ip1,ip2)=d2mata(ip1,ip2)-d1mata(lorb,iorb)
        d2matb(ip1,ip2)=d2matb(ip1,ip2)-d1matb(lorb,iorb)
      endif
      d2mata(ip2,ip1)=d2mata(ip1,ip2)
      d2matb(ip2,ip1)=d2matb(ip1,ip2)
93796 continue
9379  continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Ttotal(T1,T2,T3,T4,Ttot,Ttot_Inv,nDim)
      Implicit ReaL*8 (A-H,O-Z)
#include "WrkSpc.fh"
      Real*8 T1(nDim*nDim),T2(nDim*nDim),T3(nDim*nDim),
     &       T4(nDim,nDim),Ttot(nDim,nDim),
     &       Ttot_Inv(nDim,nDim)
*
      Call Allocate_Work(ipTemp,nDim**2)
      Call Allocate_Work(ipTemp2,nDim**2)
      Call Ttotal_(T1,T2,T3,T4,Ttot,Ttot_Inv,nDim,Work(ipTemp),
     &            Work(ipTemp2))
      Call Free_Work(ipTemp2)
      Call Free_Work(ipTemp)
*
      Return
      End
      Subroutine Ttotal_(T1,T2,T3,T4,Ttot,Ttot_Inv,nDim,Temp,Temp2)
      Implicit Real*8 (A-H,O-Z)
      Real*8 T1(nDim*nDim),T2(nDim*nDim),T3(nDim*nDim),
     &       T4(nDim,nDim),Ttot(nDim,nDim),
     &       Ttot_Inv(nDim,nDim),
     &       Temp(nDim,nDim), Temp2(nDim,nDim)
*                                                                      *
************************************************************************
*                                                                      *
*     Ttot=T1*T2*T3*T4
*
clg   write (*,*) 'Ttotal ', nDim
      Call DGEMM_('N','N',
     &            nDim,nDim,nDim,
     &            1.0d0,T1,nDim,
     &            T2,nDim,
     &            0.0d0,Temp,nDim)
      Call DGEMM_('N','N',
     &            nDim,nDim,nDim,
     &            1.0d0,Temp,nDim,
     &            T3,nDim,
     &            0.0d0,Temp2,nDim)
      Call DGEMM_('N','N',
     &            nDim,nDim,nDim,
     &            1.0d0,Temp2,nDim,
     &            T4,nDim,
     &            0.0d0,Ttot,nDim)
clg   Call RecPrt('T_TOT',' ',Ttot,nDim,nDim)
      Call MINV(Ttot,Ttot_Inv,ISING,DET,nDim)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Filler(N,M,A)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, M
real(kind=wp), intent(out) :: A(N,M)
integer(kind=iwp) :: i, j, k

k = 0
do i=1,N
  do j=1,M
    k = k+1
    A(i,j) = One*j+0.1_wp*i+0.001_wp*k
  end do
end do

return

end subroutine Filler

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
CPAM97      Subroutine Vibtrm(ndim,Vib1,Vib2,Umin,Umax,Teas,R,PotR,Title)
      Subroutine Vibtrm(ndim,Umin,Umax,Teas,R,PotR,Title)
C
C Calculation of transition matrix elements over vibrational
C wave functions of a given series of observables by a Simpson
C quadrature. The vibrational wave functions have been computed
C in vibrot and stored on units Vibwvs1 = 12 (potential 1) and
C Vibwvs2 = 13 (potential 2) for each rotational quantum number.
C The observables are read as input for a sequence of r-values
C and fitted to an analytical form in subroutine Pot.
C Integration is performed on a logarithmic scale (u=ln(r))
C between Umin and Umax with a grid size del corresponding to
C ndim integration steps. ndim has to be odd.
C Lifetimes are computed for the upper state (potential 2)
C no degeneracy factor is included in these values.
C Oscillator strengths are computed for all vibrational levels.
C
C     ********** MOLCAS Release 91 05 01 **********
C
      Implicit Real*8 (A-H,O-Z)
      Integer print
      Character*80 Title
      Character*1 hyph
#include "dimensions.fh"
      Parameter(nemax=nVib_Max,ndimmx=5000,
     &          lwork=2*nemax*ndimmx)
#include "intinp.fh"

#include "WrkSpc.fh"
#include "SysDef.fh"
      Dimension S(2*nemax**2+nemax),Obs(2*nemax**2+nemax)
C-POW Dimension nv1w(6),nv2w(6),Sw(6),
************************************************************************
      Dimension nv1w(2*nemax**2+nemax),nv2w(2*nemax**2+nemax),
     &          Sw(2*nemax**2+nemax),
     &          E(nemax,nemax),Taui(nemax,nemax),Tau(nemax),
     &          Osc(nemax,nemax)
      Dimension R(*),PotR(*)
      Character*80 TmpLine
*
      ChkSum=0.0d0
C
      hyph='-'
CPAM97      write(6,1001) Title,Teas
CPAM971001  format(1h1,1x,'Matrix elements of observables'/1x,A80//
CPAM97     *       1x,'Asymtotic energy difference (au):',E14.6)
      Write(6,*)
      Call CollapseOutput(1,'Matrix elements of observable: '//Title)
      Write(6,'(a,e15.8)')' Asymptotic energy difference (au):',Teas
      print=2
c
c     check dimensions
c
      ne1=nvib1+1
      ne2=nvib21+1
      ndim1=ndim+1
      nwork=(ne1+ne2)*ndim1
      IERR=0
      if(nwork.gt.lwork) Then
        Write(6,*)'VIBTRM Error: NWork.gt.LWork'
        Write(6,'(1x,a,2i8)')'NWork,LWork:',NWork,LWork
        IERR=1
      end if
      if(ne1.gt.nemax) Then
        Write(6,*)'VIBTRM Error: NE1.gt.NEMax'
        Write(6,'(1x,a,2i8)')'NE1,NEMax:',NE1,NEMax
        IERR=1
      end if
      if(ne2.gt.nemax) Then
        Write(6,*)'VIBTRM Error: NE2.gt.NEMax'
        Write(6,'(1x,a,2i8)')'NE2,NEMax:',NE2,NEMax
        IERR=1
      end if
      if(NDim1.gt.NDimMx) Then
        Write(6,*)'VIBMAT Error: NDim1.gt.NDimMx'
        Write(6,'(1x,a,2i8)')'NDim1,NDimMx:',NDim1,NDimMx
        IERR=1
      end if
      If(IERR.ne.0) Then
        Call Abend
      End If

C Allocate memory
      Call GetMem('VecVib','Allo','Real',indexVib,lwork)
      Call GetMem('VecX','Allo','Real',indexX,ndim)

C Set up grid size
      del=(Umax-Umin)/(ndim-1)

C Loop over rotational quantum numbers
      JEndA=J1A
      JEndB=J1B
      If (iallrot.eq.1) Then
        JEndA=J2A
        JEndB=J2B
      End If
      Do 100 J1=J1A,JEndA
       Jad1=J1-J1A+1
      Do 101 J2=J1B,JEndB
       Jad2=J2-J1B+1
       Write(6,*)
       Write(TmpLine,1002) J1,J2
       Call CollapseOutput(1,TmpLine)
       Write(6,1003) (hyph,i=1,80)
1002   Format('Rotational quantum number for potential 1: ',I3,
     *        ', for potential 2: ',I3)
1003   Format(1x,80A1)

C Read vibrational functions for this pair of J-values.
       Do 35 ipot=1,2
        If(ipot.eq.1) then
         ne=ne1
         ist=1
         iadr1=iad12(Jad1)
         Do 20 nv=1,ne1
          Call DDafile(Vibwvs1,2,Work(indexVib+ist-1),ndim1,iadr1)
          E(1,nv)=Work(indexVib+ist+ndim-1)
          ist=ist+ndim1
20       Continue
        Else
         ne=ne2
         ist=ndim1*ne1+1
         iadr2=iad13(Jad2)
         Do 21 nv=1,ne2
          Call DDafile(Vibwvs2,2,Work(indexVib+ist-1),ndim1,iadr2)
          E(2,nv)=Work(indexVib+ist+ndim-1)+Teas
          ist=ist+ndim1
21       Continue
        Endif

C compute overlap matrix S
        ist1=-ndim1+ndim1*(ipot-1)*ne1
        nv12=(ipot-1)*(ne1**2+ne1)/2
        Do nv1=1,ne
         ist1=ist1+ndim1
         ist2=-ndim1+ndim1*(ipot-1)*ne1
         Do nv2=1,nv1
          ist2=ist2+ndim1
          nv12=nv12+1

C Set up scalar product and integrate
          Do i=1,ndim
           Work(indexX+i-1)=Work(indexVib+i+ist1-1)*
     &                      Work(indexVib+i+ist2-1)*R(i)**2
          End Do
          Call Simpsn(Work(indexX),del,ndim,S(nv12))
         End Do
        End Do

c check overlap matrix for non-orthogonality
       nv12=(ipot-1)*(ne1**2+ne1)/2
       Smax=0.0D0
       Do 32 nv1=1,ne
        Do 33 nv2=1,nv1
         nv12=nv12+1
         If(nv1.eq.nv2) go to 33
         If(abs(S(nv12)).gt.abs(Smax)) Smax=S(nv12)
33      Continue
32     Continue
       If(abs(Smax).gt.1.d-04) Write(6,1200) ipot,Smax
1200   Format(/1x,'*****Warning: non-orthogonality between vibrational',
     *                       1x,'wave functions for potential',I2
     *      /13x,'largest overlap matrix element is',d14.6)

C Print overlap matrix
       if ( Print.ge.1 ) then
          Write(6,*)
          Write(6,'(1x,A,I3)')
     &         'Overlap matrix for vibrational wave functions '//
     &         'for potential number',ipot
          iwr=0
          nv12=(ipot-1)*(ne1**2+ne1)/2
          Do nv1=1,ne
             Do nv2=1,nv1
                iwr=iwr+1
                nv12=nv12+1
                nv1w(iwr)=nv1-1
                nv2w(iwr)=nv2-1
                Sw(iwr)=S(nv12)
             End Do
          End Do
          Write(6,'(6(3X,2I3,F12.6))')
     &         (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
       End If
35    Continue
C
C     Compute overlap matrix between pot1 and pot2 functions
C
      nv11=0
      nv12s=(ne1**2+ne1+ne2**2+ne2)/2
      nv12=nv12s
      ist1=-ndim1
      Do 50 nv1=1,ne1
       ist1=ist1+ndim1
       nv11=nv11+nv1
       ist2=ndim1*(ne1-1)
       nv22=(ne1**2+ne1)/2
       Do 51 nv2=1,ne2
        ist2=ist2+ndim1
        nv12=nv12+1
        nv22=nv22+nv2
C       Set up scalar product and integrate
        Do 45 i=1,ndim
         Work(indexX+i-1)=Work(indexVib+i+ist1-1)*
     &                    Work(indexVib+i+ist2-1)*R(i)**2
45      Continue
        Call Simpsn(Work(indexX),del,ndim,S(nv12))
        S(nv12)=S(nv12)/sqrt(S(nv11)*S(nv22))
        ChkSum=ChkSum + S(nv12)
51     Continue
50    Continue
c
c      print overlap matrix
c
       Write(6,1310)
1310   Format(/1x,'Overlap matrix for pot-1 and pot-2 functions')
       nv12=nv12s-ne2
       Do 52 nv1=1,ne1
        nv12=nv12+ne2
        Write(6,'(6(3X,2I3,F12.6))')
     &       (nv1-1,i-1,S(i+nv12),i=1,ne2)
52     Continue
c
c      compute transition moment
c
       nv11=0
       nv12=0
       ist1=-ndim1
       Do nv1=1,ne1
        ist1=ist1+ndim1
        nv11=nv11+nv1
        ist2=ndim1*(ne1-1)
        nv22=(ne1**2+ne1)/2
        Do nv2=1,ne2
         ist2=ist2+ndim1
         nv12=nv12+1
         nv22=nv22+nv2
C        Set up scalar product and integrate
         do 55 i=1,ndim
          Work(indexX+i-1)=Work(indexVib+i+ist1-1)*
     &                     Work(indexVib+i+ist2-1)*PotR(i)*R(i)**2
55       Continue
         Call Simpsn(Work(indexX),del,ndim,Obsr)
         Obs(nv12)=Obsr/sqrt(S(nv11)*S(nv22))

C Taui is the contribution to the inverse lifetime from
C vibrational states nv1 (lower) and nv2 (upper)
         Taui(nv1,nv2)=21.419474D0*(E(2,nv2)-E(1,nv1))**3*Obs(nv12)**2
C computed oscillator strengths
         Osc(nv1,nv2)=2.D0*(E(2,nv2)-E(1,nv1))*Obs(nv12)**2/3.d0

cc         ChkSum=ChkSum + Taui(nv1,nv2)
        End Do
       End Do
c
c      write matrix elements
c
       Write(6,*)
       Write(6,'(1x,A)')
     &      'Transition moments over vibrational wave functions '//
     &      '(atomic units)'
       iwr=0
       Do nv1=1,ne1
          Do nv2=1,ne2
             iwr=iwr+1
             nv1w(iwr)=nv1-1
             nv2w(iwr)=nv2-1
             Sw(iwr)=Obs(iwr)
          End Do
       End Do
       Write(6,'(6(2X,I3,1X,I3,1X,F11.6))')
     &      (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
       Write(6,*)
       Write(6,'(1x,A)')
     &      'Energy differences for vibrational wave functions'//
     &      '(atomic units)'
       iwr=0
       Do nv1=1,ne1
          Do nv2=1,ne2
             iwr=iwr+1
             nv1w(iwr)=nv1-1
             nv2w(iwr)=nv2-1
             Sw(iwr)=E(2,nv2)-E(1,nv1)
          End Do
       End Do
       Write(6,'(6(2X,I3,1X,I3,1X,F11.6))')
     &      (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
        Write(6,'(1x,A)')
     &      'Energy differences for vibrational wave functions'//
     &      '(cm-1)'
       iwr=0
       Do nv1=1,ne1
          Do nv2=1,ne2
             iwr=iwr+1
             nv1w(iwr)=nv1-1
             nv2w(iwr)=nv2-1
             Sw(iwr)=(E(2,nv2)-E(1,nv1))*219474.51
          End Do
       End Do
      Write(6,'(6(2X,I3,1X,I3,1X,F11.1))')
     &      (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
C
C      Print oscillator strengths
C
       Write(6,'(1x,A)')
     &      'Oscillator strengths for vibrational wave functions'
       iwr=0
       Do nv1=1,ne1
          Do nv2=1,ne2
             iwr=iwr+1
             nv1w(iwr)=nv1-1
             nv2w(iwr)=nv2-1
             Sw(iwr)=Osc(nv1,nv2)
          End Do
       End Do
       Write(6,'(6(2X,I3,1X,I3,1X,E12.5))')
     &      (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
C
C      Print lifetime
C
       Write(6,*)
       Write(6,'(1x,A,/,A)')
     &      'Contributions to inverse lifetimes (ns-1)',
     &      'No degeneracy factor is included in these values.'
       iwr=0
       Do nv1=1,ne1
          Do nv2=1,ne2
             iwr=iwr+1
             nv1w(iwr)=nv1-1
             nv2w(iwr)=nv2-1
             Sw(iwr)=Taui(nv1,nv2)
          End Do
       End Do
       Write(6,'(6(2X,I3,1X,I3,1X,E12.5))')
     &      (nv1w(i),nv2w(i),Sw(i),i=1,iwr)
C Compute lifetimes for upper state
       Write(6,1600)
1600   Format(/1x,'Lifetimes (in nano seconds)'/3x,'v',7x,'tau')
       Do 75 nv2=1,ne2
        Tau(nv2)=0.0D0
        Do 74 nv1=1,ne1
         Tau(nv2)=Tau(nv2)+Taui(nv1,nv2)
74      Continue
        Tau(nv2)=1.0D0/Tau(nv2)
cc        ChkSum=ChkSum + Tau(nv2)
        Write(6,1700) nv2-1,Tau(nv2)
1700    Format(1x,i3,f10.2)
75     Continue
       Call CollapseOutput(0,TmpLine)

C End of loop over rotational quantum number
101   Continue
100   Continue
      Call CollapseOutput(0,'Matrix elements of observable: '//Title)

C Deallocate memory
      Call GetMem('VecVib','Free','Real',indexVib,lwork)
      Call GetMem('VecX','Free','Real',indexX,ndim)

CPAM97CPAM97 New code begins:
CPAM97      Do J1=J1A,J2A
CPAM97      Do J2=J1B,J2B
CPAM97C Read vibrational function for pot-1, with rot q.n.=J1:
CPAM97       iadr1=iad12(J1-J1A+1)
CPAM97       Do nv=0,nvib1
CPAM97        Call Dafile(Vibwvs1,2,Vibbuf,RtoI*ndim,iadr1)
CPAM97        call dcopy_(ndim,Vibbuf,1,Vib1(1,nv),1)
CPAM97        ERoVib1(nv,J1)=Vibbuf(ndim+1)
CPAM97       Continue
CPAM97C Normalize vibrational function:
CPAM97       Do nv=0,nvib1
CPAM97         Do i=1,ndim
CPAM97           Vibbuf(i)=Vib1(i,nv)**2*R(i)**2
CPAM97         End Do
CPAM97         Call Simpsn(Vibbuf,del,ndim,ovlp)
CPAM97         xnrm=1.0d0/sqrt(ovlp)
CPAM97         Do i=1,ndim
CPAM97           Vib1(i,nv)=xnrm*Vib1(i,nv)
CPAM97         End Do
CPAM97       End Do
CPAM97C Check orthonormality:
CPAM97       ovlmax=0.0d0
CPAM97       Do nv1=1,nvib1
CPAM97         Do nv2=0,nv1-1
CPAM97           Do i=1,ndim
CPAM97             Vibbuf(i)=Vib1(i,nv1)*Vib1(i,nv2)*R(i)**2
CPAM97           End Do
CPAM97           Call Simpsn(Vibbuf,del,ndim,ovlp)
CPAM97           ovlmax=max(ovlp,ovlmax)
CPAM97         End Do
CPAM97       End Do
CPAM97       If(ovlmax.ge.1.0D-4) then
CPAM97         Write(6,*)' Warning from VIBTRM:'//
CPAM97     &     ' Vibrational wave functions for potential 1'
CPAM97         Write(6,*)' are not orthonormal. Max overlap:',ovlmax
CPAM97       End If
CPAM97C Read vibrational function for pot-2, with rot q.n.=J2:
CPAM97       iadr2=iad13(J2-J1B+1)
CPAM97       Do nv=0,nvib21
CPAM97        Call Dafile(Vibwvs2,2,Vibbuf,RtoI*ndim,iadr2)
CPAM97        call dcopy_(ndim,Vibbuf,1,Vib2(1,nv),1)
CPAM97        ERoVib2(nv,J2)=Vibbuf(ndim+1)
CPAM97       Continue
CPAM97C Normalize vibrational function:
CPAM97       Do nv=0,nvib21
CPAM97         Do i=1,ndim
CPAM97           Vibbuf(i)=Vib2(i,nv)**2*R(i)**2
CPAM97         End Do
CPAM97         Call Simpsn(Vibbuf,del,ndim,ovlp)
CPAM97         xnrm=1.0d0/sqrt(ovlp)
CPAM97         Do i=1,ndim
CPAM97           Vib2(i,nv)=xnrm*Vib2(i,nv)
CPAM97         End Do
CPAM97       End Do
CPAM97C Check orthonormality:
CPAM97       ovlmax=0.0d0
CPAM97       Do nv1=1,nvib21
CPAM97         Do nv2=0,nv1-1
CPAM97           Do i=1,ndim
CPAM97             Vibbuf(i)=Vib2(i,nv1)*Vib2(i,nv2)*R(i)**2
CPAM97           End Do
CPAM97           Call Simpsn(Vibbuf,del,ndim,ovlp)
CPAM97           ovlmax=max(ovlp,ovlmax)
CPAM97         End Do
CPAM97       End Do
CPAM97       If(ovlmax.ge.1.0D-4) then
CPAM97         Write(6,*)' Warning from VIBTRM:'//
CPAM97     &     ' Vibrational wave functions for potential 2'
CPAM97         Write(6,*)' are not orthonormal. Max overlap:',ovlmax
CPAM97       End If
CPAM97C Compute Franck-Condon overlaps and transition moment integrals:
CPAM97       Do nv1=0,nvib1
CPAM97         Do nv2=0,nvib21
CPAM97           If(J1.eq.J2) Then
CPAM97             Do i=1,ndim
CPAM97               Vibbuf(i)=Vib1(i,nv1)*Vib2(i,nv2)*R(i)**2
CPAM97             End Do
CPAM97             Call Simpsn(Vibbuf,del,ndim,FC(nv1,nv2,J1))
CPAM97           End If
CPAM97           If(abs(nv1-nv2).le.NSel) Then
CPAM97             Do i=1,ndim
CPAM97               X(i)=PotR(i)*Vibbuf(i)
CPAM97             End Do
CPAM97             Call Simpsn(X,del,ndim,Obs(nv1,nv2,J1,J2))
CPAM97           Else
CPAM97             TD(nv1,nv2,J1,J2)=0.0d0
CPAM97           End If
CPAM97           EDiff=ERoVib2(nv2,J2)-ERoVib1(nv1,J1)+TeDiff
CPAM97           TauPrt(nv1,nv2,J1,J2)=21.419474D0*EDiff**3*TD(nv1,nv2,J1,J2)**2
CPAM97         End Do
CPAM97       End Do
CPAM97      End Do
CPAM97      End Do
CPAM97CPAM97 New code ends
      Call Add_Info('VIBROT_VIBTRM',[ChkSum],1,6)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ccsort_t3grc0(nind,typ,typp,typq,typr,typs,stot,pos0,post,mapd,mapi)
! N.B. This routine is in principle copy of those in T3,
! but some changes were done:
! 1) mmul is substituted by mul
! 2) dimm is added, since using of ccsd1.com is impossible
! 3) ccsd1.com is replaced by ccsort_global
!
! nind   - number of indices (I)
! typ    - typ of mediate (I)
! typp   - typ of index p (I)
! typq   - typ of index q (I)
! typr   - typ of index r (I)
! typs   - typ of index s (I)
! stot   - overall symmetry of the mediate (I)
! pos0   - initial position of mediate (I)
! post   - final position of the mediate (O)
! mapd   - direct map of the mediate (O)
! mapi   - inverse map of the mediate (O)
!
! this routine defines mapd and mapi for given intermediate
! it can done exactly the same maps like grc0 in CCSD
! plus additional types of mediates are introduced:
! type    meaning
! 5       p>q>r,s ; also p>q>r
! 6       p,q>r>s
! 7       p>=q,r,s ; also p>=q,r; p>=q
! 8       p,q>=r,s ; also p,q>=s
! 9       p,q,q>=s
! 10      p>=q,r>=s
! 11      p>=q>=r,s ; also p>=q>=r
! 12      p,q>=r>=s
!
! currently, these new types are implemented only for nind=3
!
! N.B. (this routine cannot run with +OP2)
! N.B. this routine does not test stupidities

use ccsort_global, only: noa, nob, NSYM, nva, nvb
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nind, typ, typp, typq, typr, typs, stot, pos0
integer(kind=iwp), intent(out) :: post, mapd(0:512,6), mapi(8,8,8)
integer(kind=iwp) :: dimm(5,8), i, nhelp1, nhelp2, nhelp3, nhelp4, nsymq, nsymr, pos, rsk1, rsk2, sp, spq, spqr, sq, sr, ss

! !!!!!!!! def dimm to je tu len terazky, lebo nemozeme pouzivat ccsd1.com !!!!

! Tutok musim cosi inicializovat
ss = 0
pos = 0
rsk1 = 0
rsk2 = 0
dimm(1,1:nsym) = noa(1:nsym)
dimm(2,1:nsym) = nob(1:nsym)
dimm(3,1:nsym) = nva(1:nsym)
dimm(4,1:nsym) = nvb(1:nsym)
dimm(5,1:nsym) = nva(1:nsym)+noa(1:nsym)

! vanishing mapi files

mapi(1:nsym,1:nsym,1:nsym) = 0

i = 1
pos = pos0
if (nind == 1) then

  ! matrix A(p)

  sp = mul(stot,1)

  nhelp1 = dimm(typp,sp)

  ! def mapi
  mapi(1,1,1) = i

  ! def position
  mapd(i,1) = pos

  ! def length
  mapd(i,2) = nhelp1

  ! def sym p,q
  mapd(i,3) = sp
  mapd(i,4) = 0
  mapd(i,5) = 0
  mapd(i,6) = 0

  pos = pos+mapd(i,2)
  i = i+1

else if (nind == 2) then

  ! matrix A(p,q)

  do sp=1,nsym

    sq = mul(stot,sp)
    ! Meggie out
    if ((typ == 1) .and. (sp < sq)) cycle

    nhelp1 = dimm(typp,sp)
    nhelp2 = dimm(typq,sq)

    ! def mapi
    mapi(sp,1,1) = i

    ! def position
    mapd(i,1) = pos

    ! def length
    if ((typ == 1) .and. (sp == sq)) then
      mapd(i,2) = nhelp1*(nhelp1-1)/2
    else
      mapd(i,2) = nhelp1*nhelp2
    end if

    ! def sym p,q
    mapd(i,3) = sp
    mapd(i,4) = sq
    mapd(i,5) = 0
    mapd(i,6) = 0

    pos = pos+mapd(i,2)
    i = i+1

  end do

else if (nind == 3) then

  ! matrix A(p,q,r)

  ! def reucion summation keys : rsk1 for pq, rsk2 for qr

  if (typ == 0) then
    rsk1 = 0
    rsk2 = 0
  else if (typ == 1) then
    rsk1 = 1
    rsk2 = 0
  else if (typ == 2) then
    rsk1 = 0
    rsk2 = 1
  else if (typ == 5) then
    rsk1 = 1
    rsk2 = 1
  else if (typ == 7) then
    rsk1 = 1
    rsk2 = 0
  else if (typ == 8) then
    rsk1 = 0
    rsk2 = 1
  else if (typ == 11) then
    rsk1 = 1
    rsk2 = 1
  end if

  do sp=1,nsym
    if (rsk1 == 1) then
      nsymq = sp
    else
      nsymq = nsym
    end if

    do sq=1,nsymq
      spq = mul(sp,sq)

      sr = mul(stot,spq)
      ! Meggie out
      if ((rsk2 == 1) .and. (sq < sr)) cycle

      nhelp1 = dimm(typp,sp)
      nhelp2 = dimm(typq,sq)
      nhelp3 = dimm(typr,sr)

      ! def mapi
      mapi(sp,sq,1) = i

      ! def position
      mapd(i,1) = pos

      ! def length
      if ((typ == 1) .and. (sp == sq)) then
        mapd(i,2) = nhelp1*(nhelp1-1)*nhelp3/2
      else if ((typ == 2) .and. (sq == sr)) then
        mapd(i,2) = nhelp1*nhelp2*(nhelp2-1)/2
      else if (typ == 5) then
        if (sp == sr) then
          mapd(i,2) = nhelp1*(nhelp1-1)*(nhelp1-2)/6
        else if (sp == sq) then
          mapd(i,2) = nhelp1*(nhelp1-1)*nhelp3/2
        else if (sq == sr) then
          mapd(i,2) = nhelp1*nhelp2*(nhelp2-1)/2
        else
          mapd(i,2) = nhelp1*nhelp2*nhelp3
        end if
      else if ((typ == 7) .and. (sp == sq)) then
        mapd(i,2) = nhelp1*(nhelp1+1)*nhelp3/2
      else if ((typ == 8) .and. (sq == sr)) then
        mapd(i,2) = nhelp1*nhelp2*(nhelp2+1)/2
      else if (typ == 11) then
        if (sp == ss) then
          mapd(i,2) = nhelp1*(nhelp1+1)*(nhelp1+2)/6
        else if (sp == sq) then
          mapd(i,2) = nhelp1*(nhelp1+1)*nhelp3/2
        else if (sq == sr) then
          mapd(i,2) = nhelp1*nhelp2*(nhelp2+1)/2
        else
          mapd(i,2) = nhelp1*nhelp2*nhelp3
        end if
      else
        mapd(i,2) = nhelp1*nhelp2*nhelp3
      end if

      ! def sym p,q,r
      mapd(i,3) = sp
      mapd(i,4) = sq
      mapd(i,5) = sr
      mapd(i,6) = 0

      pos = pos+mapd(i,2)
      i = i+1

    end do
  end do

else if (nind == 4) then

  ! matrix A(p,q,r,s)

  do sp=1,nsym
    if ((typ == 1) .or. (typ == 4)) then
      nsymq = sp
    else
      nsymq = nsym
    end if

    do sq=1,nsymq
      spq = mul(sp,sq)
      if (typ == 2) then
        nsymr = sq
      else
        nsymr = nsym
      end if

      do sr=1,nsymr
        spqr = mul(spq,sr)

        ss = mul(stot,spqr)
        ! Meggie out
        if (((typ == 3) .or. (typ == 4)) .and. (sr < ss)) cycle

        nhelp1 = dimm(typp,sp)
        nhelp2 = dimm(typq,sq)
        nhelp3 = dimm(typr,sr)
        nhelp4 = dimm(typs,ss)

        ! def mapi
        mapi(sp,sq,sr) = i

        ! def position
        mapd(i,1) = pos

        ! def length
        if ((typ == 1) .and. (sp == sq)) then
          mapd(i,2) = nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
        else if ((typ == 2) .and. (sq == sr)) then
          mapd(i,2) = nhelp1*nhelp2*(nhelp3-1)*nhelp4/2
        else if ((typ == 3) .and. (sr == ss)) then
          mapd(i,2) = nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
        else if (typ == 4) then
          if ((sp == sq) .and. (sr == ss)) then
            mapd(i,2) = nhelp1*(nhelp2-1)*nhelp3*(nhelp4-1)/4
          else if (sp == sq) then
            mapd(i,2) = nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
          else if (sr == ss) then
            mapd(i,2) = nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
          else
            mapd(i,2) = nhelp1*nhelp2*nhelp3*nhelp4
          end if
        else
          mapd(i,2) = nhelp1*nhelp2*nhelp3*nhelp4
        end if

        ! def sym p,q,r,s
        mapd(i,3) = sp
        mapd(i,4) = sq
        mapd(i,5) = sr
        mapd(i,6) = ss

        pos = pos+mapd(i,2)
        i = i+1

      end do
    end do
  end do

end if

post = pos

! definition of other coll

mapd(0,1) = typp
mapd(0,2) = typq
mapd(0,3) = typr
mapd(0,4) = typs
mapd(0,5) = i-1
mapd(0,6) = typ

return

end subroutine ccsort_t3grc0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Dzyaloshinsky_Morya_Exchange(Jex,N1,N2,S1,S2,HAM)
! this Subroutine calculates the Dzyaloshinsky-Morya exchange interaction between
! two sites, of the one interacting pair

use Constants, only: Zero, cZero, cOne
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Jex(3)
integer(kind=iwp), intent(in) :: N1, N2
complex(kind=wp), intent(in) :: S1(3,N1,N1), S2(3,N2,N2)
complex(kind=wp), intent(out) :: HAM(N1,N1,N2,N2)
integer(kind=iwp) :: i1, i2, j1, j2
complex(kind=wp) :: Jc(3), X, Y, Z
real(kind=wp), external :: dnrm2_

if ((N1 <= 0) .or. (N2 <= 0)) return
HAM(:,:,:,:) = cZero
if (dnrm2_(3,Jex,1) == Zero) return

Jc(:) = -Jex(:)*cOne

do i1=1,N1
  do j1=1,N1
    do i2=1,N2
      do j2=1,N2

        X = S1(2,i1,j1)*S2(3,i2,j2)-S1(3,i1,j1)*S2(2,i2,j2)

        Y = S1(3,i1,j1)*S2(1,i2,j2)-S1(1,i1,j1)*S2(3,i2,j2)

        Z = S1(1,i1,j1)*S2(2,i2,j2)-S1(2,i1,j1)*S2(1,i2,j2)

        HAM(i1,j1,i2,j2) = HAM(i1,j1,i2,j2)+Jc(1)*X+Jc(2)*Y+Jc(3)*Z

      end do
    end do
  end do
end do

return

end subroutine Dzyaloshinsky_Morya_Exchange

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015,2016, Steven Vancoillie                           *
*               2018, Ignacio Fdez. Galvan                             *
************************************************************************
      subroutine cre_scfwfn
*     SVC: Create a wavefunction file. If another .scf.h5 file already
*     exists, it will be overwritten.
#ifdef _HDF5_
      use mh5, only: mh5_create_file, mh5_init_attr,
     &               mh5_create_dset_real, mh5_create_dset_str
#endif
      implicit none
#ifdef _HDF5_
#  include "mxdm.fh"
#  include "stdalloc.fh"
#  include "scfwfn.fh"
#  include "infscf.fh"

*     create a new wavefunction file!
      wfn_fileid = mh5_create_file('SCFWFN')

*     set module type
      call mh5_init_attr (wfn_fileid,'MOLCAS_MODULE', 'SCF')

*     copy basic molecular information to the HDF5 file
      call run2h5_molinfo(wfn_fileid)
      call one2h5_ovlmat(wfn_fileid, nsym, nbas)
      call one2h5_fckint(wfn_fileid, nsym, nbas)
      call one2h5_crtmom(wfn_fileid, nsym, nbas)

*     energy
      wfn_energy = mh5_create_dset_real (wfn_fileid,'ENERGY')
      call mh5_init_attr(wfn_energy, 'DESCRIPTION',
     $        'Total '//trim(KSDFT)//' energy')

      if (iUHF.eq.0) then

*     RHF *
***********
        call mh5_init_attr (wfn_fileid,
     $          'ORBITAL_TYPE', trim(KSDFT)//'-RHF')

*     typestring
        wfn_tpidx = mh5_create_dset_str(wfn_fileid,
     $          'MO_TYPEINDICES', 1, [nnB], 1)
        call mh5_init_attr(wfn_tpidx, 'DESCRIPTION',
     $          'Type index of the molecular orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital coefficients
        wfn_mocoef = mh5_create_dset_real(wfn_fileid,
     $          'MO_VECTORS', 1, [nBB])
        call mh5_init_attr(wfn_mocoef, 'DESCRIPTION',
     $          'Coefficients of the molecular orbitals, '//
     $          'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')
*     molecular orbital occupation numbers
        wfn_occnum = mh5_create_dset_real(wfn_fileid,
     $          'MO_OCCUPATIONS', 1, [nnB])
        call mh5_init_attr(wfn_occnum, 'DESCRIPTION',
     $          'Occupation numbers of the molecular orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital energies
        wfn_orbene = mh5_create_dset_real(wfn_fileid,
     $          'MO_ENERGIES', 1, [nnB])
        call mh5_init_attr(wfn_orbene, 'DESCRIPTION',
     $          'Orbital energies of the molecular orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')

      else

*     UHF *
***********
        call mh5_init_attr (wfn_fileid,
     $          'ORBITAL_TYPE', trim(KSDFT)//'-UHF')

*     typestring
        wfn_tpidx = mh5_create_dset_str(wfn_fileid,
     $          'MO_TYPEINDICES', 1, [nnB], 1)
        call mh5_init_attr(wfn_tpidx, 'DESCRIPTION',
     $          'Type index of the natural orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital coefficients
        wfn_mocoef = mh5_create_dset_real(wfn_fileid,
     $          'MO_VECTORS', 1, [nBB])
        call mh5_init_attr(wfn_mocoef, 'DESCRIPTION',
     $          'Coefficients of the natural orbitals, '//
     $          'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')
*     molecular orbital occupation numbers
        wfn_occnum = mh5_create_dset_real(wfn_fileid,
     $          'MO_OCCUPATIONS', 1, [nnB])
        call mh5_init_attr(wfn_occnum, 'DESCRIPTION',
     $          'Occupation numbers of the natural orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital energies
        wfn_orbene = mh5_create_dset_real(wfn_fileid,
     $          'MO_ENERGIES', 1, [nnB])
        call mh5_init_attr(wfn_orbene, 'DESCRIPTION',
     $          'Orbital energies of the natural orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     typestring: alpha
        wfn_tpidx_a = mh5_create_dset_str(wfn_fileid,
     $          'MO_ALPHA_TYPEINDICES', 1, [nnB], 1)
        call mh5_init_attr(wfn_tpidx_a, 'DESCRIPTION',
     $          'Type index of the alpha orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital coefficients: alpha
        wfn_mocoef_a = mh5_create_dset_real(wfn_fileid,
     $          'MO_ALPHA_VECTORS', 1, [nBB])
        call mh5_init_attr(wfn_mocoef_a, 'DESCRIPTION',
     $          'Coefficients of the alpha orbitals, '//
     $          'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')
*     molecular orbital occupation numbers: alpha
        wfn_occnum_a = mh5_create_dset_real(wfn_fileid,
     $          'MO_ALPHA_OCCUPATIONS', 1, [nnB])
        call mh5_init_attr(wfn_occnum_a, 'DESCRIPTION',
     $          'Occupation numbers of the alpha orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital energies: alpha
        wfn_orbene_a = mh5_create_dset_real(wfn_fileid,
     $          'MO_ALPHA_ENERGIES', 1, [nnB])
        call mh5_init_attr(wfn_orbene_a, 'DESCRIPTION',
     $          'Orbital energies of the alpha orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     typestring: beta
        wfn_tpidx_b = mh5_create_dset_str(wfn_fileid,
     $          'MO_BETA_TYPEINDICES', 1, [nnB], 1)
        call mh5_init_attr(wfn_tpidx_b, 'DESCRIPTION',
     $          'Type index of the beta orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital coefficients: beta
        wfn_mocoef_b = mh5_create_dset_real(wfn_fileid,
     $          'MO_BETA_VECTORS', 1, [nBB])
        call mh5_init_attr(wfn_mocoef_b, 'DESCRIPTION',
     $          'Coefficients of the beta orbitals, '//
     $          'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')
*     molecular orbital occupation numbers: beta
        wfn_occnum_b = mh5_create_dset_real(wfn_fileid,
     $          'MO_BETA_OCCUPATIONS', 1, [nnB])
        call mh5_init_attr(wfn_occnum_b, 'DESCRIPTION',
     $          'Occupation numbers of the beta orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
*     molecular orbital energies: beta
        wfn_orbene_b = mh5_create_dset_real(wfn_fileid,
     $          'MO_BETA_ENERGIES', 1, [nnB])
        call mh5_init_attr(wfn_orbene_b, 'DESCRIPTION',
     $          'Orbital energies of the beta orbitals '//
     $          'arranged as blocks of size [NBAS(i)], i=1,#irreps')
      end if

#endif
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Write_QMMM(Coord,nAtIn,Iter)

      IMPLICIT NONE

#include "constants2.fh"
#include "Molcas.fh"
#include "periodic_table.fh"
#include "qmmm.fh"
#include "stdalloc.fh"

      INTEGER, INTENT(IN) :: Iter,nAtIn
      REAL*8, DIMENSION(3*nAtIn,Iter), INTENT(IN) :: Coord

      INTEGER :: i,iAtIn,iAtNum,iAtOut,iAtTot,iFirst,k,Lu_XYZ,nAtOut
      INTEGER :: nAtTot
      INTEGER, DIMENSION(:), ALLOCATABLE :: AT
      REAL*8, DIMENSION(:), ALLOCATABLE :: Charge
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: CoordMMO
      CHARACTER(LEN=16) :: FileName
      CHARACTER(LEN=LENIN) :: Symbol
      CHARACTER(LEN=LENIN), DIMENSION(:), ALLOCATABLE :: LabMMO
      LOGICAL :: Found,isMMI,isMMO,isQM

      CALL Qpg_dArray('MMO Coords',Found,nAtOut)
      IF (Found) THEN
         nAtOut = nAtOut/3
         nAtTot = nAtIn+nAtOut
         CALL mma_allocate(Charge,nAtIn)
         CALL mma_allocate(CoordMMO,3,nAtOut)
         CALL mma_allocate(LabMMO,nAtOut)
         CALL mma_allocate(AT,nAtTot)
         CALL Get_dArray('Nuclear charge',Charge,nAtIn)
         CALL Get_dArray('MMO Coords',CoordMMO,3*nAtOut)
         CALL Get_cArray('MMO Labels',LabMMO,LENIN*nAtOut)
         CALL Get_iArray('Atom Types',AT,nAtTot)

! Write one file per iteration and one for the current geometry
         DO k = 1,2
            IF (k==1) THEN
               WRITE(FileName,'(I16.4)') Iter
               FileName = 'QMMMITXYZ.'//TRIM(ADJUSTL(FileName))
            ELSE
               FileName='QMMMENDXYZ'
            END IF
            Lu_XYZ = 1
            CALL molcas_open(Lu_XYZ,FileName)
            WRITE(Lu_XYZ,'(I6)') nAtTot
            WRITE(Lu_XYZ,*)
            iAtIn = 1
            iAtOut = 1
100         FORMAT (A6,3(1X,F12.6))
            DO iAtTot = 1,nAtTot
               isQM = AT(iAtTot)==QM
               isMMI = AT(iAtTot)==MMI
               isMMO = AT(iAtTot)==MMO
               IF (isQM.OR.isMMI) THEN
                  iAtNum = NINT(Charge(iAtIn))
                  iFirst = INDEX(PTab(iAtNum),' ')+1
                  Symbol = PTab(iAtNum)(iFirst:2)
                  WRITE(Lu_XYZ,100) Symbol,
     &                 (Coord(3*(iAtIn-1)+i,Iter)*Angstrom,i=1,3)
                  iAtIn = iAtIn+1
               ELSE IF (isMMO) THEN
                  Symbol = LabMMO(iAtOut)
                  IF (INDEX(Symbol,'_')>1) THEN
                     Symbol=Symbol(1:INDEX(Symbol,'_')-1)
                  END IF
                  WRITE(Lu_XYZ,100) Symbol,
     &                 (CoordMMO(i,iAtOut)*Angstrom,i=1,3)
                  iAtOut = iAtOut+1
               END IF
            END DO
            CLOSE(Lu_XYZ)
         END DO
         CALL mma_deallocate(Charge)
         CALL mma_deallocate(CoordMMO)
         CALL mma_deallocate(LabMMO)
         CALL mma_deallocate(AT)
      END IF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Roland Lindh                                     *
!***********************************************************************

subroutine genCxCTL(iStop,Cartesian,rDelta)
!***********************************************************************
!                                                                      *
! subroutine for automatic generation of coordinates for numerical     *
! differentiation based on the rlxctl.f routine.                       *
!                                                                      *
! Author: R. Lindh, Uppsala University                                 *
!         2013, November                                               *
!***********************************************************************

use Slapaf_Info, only: Coor, Shift, qInt, BMx, Free_Slapaf
use Slapaf_Parameters, only: Curvilinear, HSet, BSet, PrQ, Numerical, nLambda, iRef, nDimBC, mTROld, mTtAtm, nWndw, iter
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: iStop
logical(kind=iwp), intent(out) :: Cartesian
real(kind=wp), intent(in) :: rDelta
#include "print.fh"
integer(kind=iwp) :: iDisp, iRow_c, jInter, Jter, LuSpool, mInt
logical(kind=iwp) :: Found, TSC, Error
real(kind=wp), allocatable :: DList(:), CList(:,:), du(:), TMx(:), RefCoor(:,:)

!                                                                      *
!***********************************************************************
!                                                                      *
!-----Process the input

LuSpool = 21
call SpoolInp(LuSpool)

call RdCtl_Slapaf(LuSpool,.true.)
mInt = nDimBC-mTROld
Curvilinear = .false.
Cartesian = .not. Curvilinear
Numerical = .false. ! Just to define it, value is irrelevant here!

call Close_LuSpool(LuSpool)
!                                                                      *
!***********************************************************************
!                                                                      *
!-----Compute the Wilson B-matrix, these describe the transformations
!     between internal and Cartesian coordinates. Values of the
!     Internal coordinates are computed too.

BSet = .true.
HSet = .false.
PrQ = .false.

nWndw = iter
iRef = 0
call BMtrx(size(Coor,2),Coor,iter,mTtAtm,nWndw)

nPrint(30) = nPrint(30)-1
!                                                                      *
!***********************************************************************
!                                                                      *
call Put_dArray('BMtrx',BMx,size(Coor)*mInt)
call Put_iScalar('No of Internal coordinates',mInt)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Generate list of coordinates for numerical differentiation
!                                                                      *
!***********************************************************************
!                                                                      *
! Make lists for all Cartesian coordinates and the
! corresponding displacement in internal coordinates

call mma_allocate(CList,size(Coor),2*mInt,Label='CList')
CList(:,:) = Zero
call mma_allocate(DList,mInt,Label='DList')
DList(:) = Zero
call mma_allocate(RefCoor,3,size(Coor,2),Label='RefCoor')
!                                                                      *
!***********************************************************************
!                                                                      *
! If in TS-search regime and without TSConstraints, remove
! constraints (in slapaf this is done differently)

call qpg_iScalar('TS Search',Found)
if (Found) call Get_lScalar('TS Search',Found)
call f_Inquire('TSC',TSC)
if (Found .and. (.not. TSC)) call Merge_Constraints('','','UDC',nLambda,iRow_c)
!                                                                      *
!***********************************************************************
!                                                                      *
!     Get the T-matrix

call mma_allocate(TMx,mInt**2,Label='TMx')
call TMatrix(TMx,mInt)
call Put_iScalar('nLambda',nLambda)
call Put_dArray('T-matrix',TMx,mInt**2)
!call RecPrt('T-matrix',' ',TMx,mInt,mInt)
!                                                                      *
!***********************************************************************
!                                                                      *
! Now start generating the displaced structure to be used in the
! numerical differentiation.
!
! Take a copy of the current structure - the reference
! coordinates.

RefCoor(:,:) = Coor(:,:)

! Loop over all displacements which are in the subspace in
! which we like to minimize the energy. Hence, this will
! eliminate naturally translational and rotational degrees
! (3N-6) but also eliminate constrained degrees (3N-6-m)

call mma_allocate(du,mInt,Label='du')

! Loop only over displacement which do not change the constraint.
! Note that the constraints are placed first.

do iDisp=1+2*nLambda,2*mInt

  ! Get a virgin copy of the reference structure

  Coor(:,:) = RefCoor(:,:)

  ! Compute the effective index where to find the data

  Jter = Iter+1

  ! Update the shift vector, in the space in which we split
  ! the constraints and the reduced subspace.

  du(:) = Zero
  Shift(:,iter) = Zero
  jInter = (iDisp+1)/2
  if (mod(iDisp,2) == 0) then
    du(jInter) = -rDelta
  else
    du(jInter) = rDelta
  end if
  !call RecPrt('du',' ',du,mInt,1)

  ! Transform displacement to the internal coordinate
  ! space. This is a simple unitary transformation.

  call DGEMM_('N','N',mInt,1,mInt,One,TMx,mInt,du,mInt,Zero,Shift(:,iter),mInt)
  !call RecPrt('shf',' ',Shift(:,iter),mInt,1)

  ! Save the value of the displacement in the list.

  DList(jInter) = rDelta

  ! Take a copy of the current values of the internal
  ! coordinates.

  call dcopy_(mInt,qInt(:,Iter),1,qInt(:,Jter),1)
  !call RecPrt('Int_Ref',' ',qInt(:,Jter),1,mInt)

  ! To the second set of coordinates add the shift.
  ! This set of internal coordinates corresponds to
  ! the set for which we like to get the Cartesian
  ! coordinates.

  call DaXpY_(mInt,One,Shift(:,iter),1,qInt(:,Jter),1)
  !call RecPrt('Int    ',' ',qInt(:,Jter),1,mInt)

  !------Transform the new internal coordinates to Cartesians

  PrQ = .false.
  BSet = .false.
  Error = .false.
  nWndw = Iter
  iRef = 0
  call NewCar(Iter,size(Coor,2),Coor,mTtAtm,Error)

  ! Move the new Cartesian coordinate to the list.

  call dcopy_(size(Coor),Coor,1,CList(:,iDisp),1)
end do

call mma_deallocate(du)
call mma_deallocate(TMx)

!call RecPrt('DList',' ',DList,1,mInt)
!call RecPrt('CList',' ',CList,SIZE(Coor),2*mInt)

! Save the lists on the runfile. To be used in the
! numerical gradient module.

call Put_dArray('DList',DList,size(DList))
call Put_dArray('CList',CList,size(CList))

! Deallocate temporary memory.

call mma_deallocate(RefCoor)
call mma_deallocate(DList)
call mma_deallocate(CList)

! Alaska only
iStop = 3

! Done!

call Free_Slapaf()

!-----Terminate the calculations.

return

end subroutine GenCxCTL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_REOVEC(IRS2F,N,LRDIM,WRK,LWRK)
C
C     Purpose: reorder Cholesky vectors on disk to full storage.
C
#include "implicit.fh"
      INTEGER   IRS2F(N,LRDIM)
      DIMENSION WRK(LWRK)
#include "cholesky.fh"
#include "choorb.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_REOVEC')

      INTEGER  CHO_ISAO
      EXTERNAL CHO_ISAO

      ITRI(I,J) = MAX(I,J)*(MAX(I,J)-3)/2 + I + J


C     Set up mapping from rs1 to full storage.
C     ----------------------------------------

      IF (N .LT. 3) THEN
         CALL CHO_QUIT('Dimension error [1] in '//SECNAM,104)
      END IF
      IF (LRDIM .NE. MMBSTRT) THEN
         CALL CHO_QUIT('Dimension error [2] in '//SECNAM,104)
      END IF
      CALL CHO_RSTOF(IRS2F,N,MMBSTRT,1)
      DO IRS1 = 1,NNBSTRT(1)
         IA = IRS2F(1,IRS1)
         IB = IRS2F(2,IRS1)
         ISYMA = CHO_ISAO(IA)
         ISYMB = CHO_ISAO(IB)
         JA = IA - IBAS(ISYMA)
         JB = IB - IBAS(ISYMB)
         IF (ISYMA .EQ. ISYMB) THEN
            JAB = ITRI(JA,JB)
         ELSE
           JAB = NBAS(ISYMA)*(JB - 1) + JA
         END IF
         IRS2F(1,IRS1) = ISYMA
         IRS2F(2,IRS1) = ISYMB
         IRS2F(3,IRS1) = JAB
      END DO

C     Set up index arrays and open files for storing full vectors.
C     ------------------------------------------------------------

      CALL CHO_REOINI()

C     Reorder vectors on disk.
C     ------------------------

      CALL CHO_REOVC1(IRS2F,N,LRDIM,WRK,LWRK)


      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine schmidtd2_cvb(c1,sxc1,nvec1,c2,nvec2,n)
      implicit real*8 (a-h,o-z)
      dimension c1(n,nvec1),sxc1(n,nvec1),c2(n,nvec2)

      do 100 i=1,nvec2
      do 101 j=1,nvec1
      call daxpy_(n,-ddot_(n,c2(1,i),1,sxc1(1,j),1),c1(1,j),1,c2(1,i),1)
101   continue
100   continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Roland Lindh                                     *
!***********************************************************************

subroutine Get_H(F,nX)
!***********************************************************************
!                                                                      *
!     Object: to get the force constant matrix in cartesians           *
!                                                                      *
!                                                                      *
!     Author: Roland Lindh                                             *
!             Department of Quantum Chemistry                          *
!             Uppsala University, Sweden                               *
!             October 2010                                             *
!***********************************************************************

use Slapaf_Info, only: Coor, mTROld, nDimBC, Smmtrc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nX
real(kind=wp), intent(out) :: F(nX**2)
integer(kind=iwp) :: i, ii, iix, ij, ik, ix, j, jj, jjx, jx, k, nAtom, nBMx, nDoF, nHss, nInter
real(kind=wp) :: tmp_ij
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: BMtrx(:,:), H(:,:), Tmp2(:)

!#define _DEBUGPRINT_
nDoF = nDimBC
nInter = nDimBC-mTROld
nAtom = size(Coor,2)

call mma_allocate(Tmp2,nX**2,Label='Tmp2')
call mma_allocate(H,nInter,nInter,Label='H')
! If there is an updated Hessian in the runfile, use it;
! otherwise use the last computed one.
! (Hss_upd must be removed every time Hss_Q is added)
call Qpg_dArray('Hss_upd',Found,nHss)
if (Found .and. (nHss == nInter**2)) then
  call Get_dArray('Hss_upd',H,nInter**2)
else
  call Get_dArray('Hss_Q',H,nInter**2)
end if
call mma_allocate(BMtrx,nX,nInter,Label='BMtrx')
! If there is an old BMx stored, use it;
! otherwise use the current BMx
call Qpg_dArray('BMxOld',Found,nBMx)
if (Found .and. (nBMx == nX*nInter)) then
  call Get_dArray('BMxOld',BMtrx,nX*nInter)
else
  call Get_dArray('BMtrx',BMtrx,nX*nInter)
end if

!                                                                      *
!***********************************************************************
!                                                                      *
! The Hessian matrix (zero elements over translations and
! rotations are explicitly excluded).

#ifdef _DEBUGPRINT_
call RecPrt('BMtrx',' ',BMtrx,nX,nInter)
#endif
ii = 0
do i=1,nAtom
  do ix=1,3

    if (Smmtrc(ix,i)) then
      iix = (i-1)*3+ix
      ii = ii+1
      do j=1,nInter
        ij = (j-1)*nDoF+ii

        tmp_ij = Zero
        do k=1,nInter
          tmp_ij = tmp_ij+BMtrx(iix,k)*H(k,j)
        end do
        Tmp2(ij) = tmp_ij

      end do
    end if

  end do
end do

do i=1,nDoF

  jj = 0
  do j=1,nAtom
    do jx=1,3

      if (Smmtrc(jx,j)) then
        jjx = (j-1)*3+jx
        jj = jj+1
        ij = (jj-1)*nDoF+i
        tmp_ij = Zero
        do k=1,nInter
          ik = (k-1)*nDoF+i
          tmp_ij = tmp_ij+Tmp2(ik)*BMtrx(jjx,k)
        end do
        F(ij) = tmp_ij
      end if

    end do
  end do

end do

#ifdef _DEBUGPRINT_
call RecPrt('Hessian (cartesian)',' ',F,nDoF,nDoF)
#endif
call Put_dArray('FC-Matrix',F,nDoF**2)

call mma_deallocate(BMtrx)
call mma_deallocate(H)
call mma_deallocate(Tmp2)

!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Get_H

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Luca De Vico                                     *
*               Valera Veryazov                                        *
************************************************************************
*  NAT_BOND_ORDER
*
*> @brief
*>   Compute Natural Bond Order
*> @author Luca De Vico
*> @modified_by V. Veryazov
*>
*> @details
*> For a given set of atomic orbitals compute the
*> Natural Bond Order (NBO) as described in
*> Jensen's "Introduction to Computational Chemistry" \cite Jensen-1999.
*> The atomic orbital are taken as generated by LoProp,
*> in order to be localised. In the future, hopefully, it
*> will consider also triatomic bonds
*> and then put everything into a molden file and/or gv.
*> Treatment of UHF should be included.
*>
*> - \p iCase = ``0``: First UHF run, no print just dump
*> - \p iCase = ``1``: Second UHF run, final print
*> - \p iCase = ``2``: Normal run, print
*>
*> @param[in] NSYM  Number of irreducible representations
*> @param[in] NBAS  Number of basis functions per irred. rep.
*> @param[in] NAME  Center and function type label
*> @param[in] iCase Type of run
************************************************************************
      SUBROUTINE NAT_BOND_ORDER(NSYM,NBAS,NAME,iCase)
************************************************************************
*                                                                      *
*     Author: Luca De Vico, University of Lund, 2006                   *
*                                                                      *
************************************************************************
*
************************************************************************
*                                                                      *
*     Subroutine Scheme                                                *
*          Initialization                                              *
*          Retrieve of the LoProp density matrix from the RunFile      *
*          Loop over atoms i                                           *
*            generate submatrix SUBDNAO from DS(i)                     *
*            if (eigenvalues > thr_CO) => core orbital                 *
*               depletion of orbital                                   *
*            if (eigenvalues > thr_LP) => lone pair orbital            *
*               depletion of orbital                                   *
*          Double loop over atoms i,j with i<j                         *
*            generate submatrix SUBDNAO from DS(i) and DS(j)           *
*            diagonalize SUBDNAO                                       *
*            if (eigenvalues > threshold) => NBO                       *
*          if NBO-OCCN + CORE-OCCN + LP-OCCN << electrons              *
*            search for single occupied orbitals                       *
*            same as core orbitals, with thr_SO                        *
*            or                                                        *
*            (search for three-center bonds)                           *
*          print out                                                   *
*                                                                      *
************************************************************************
*
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "real.fh"
#include "WrkSpc.fh"
#include "Molcas.fh"
*
      DIMENSION NBAS(*)

      Integer NBAST, tNUC, tRealNUC, NPBonds, AtomA, AtomB
      CHARACTER*(LENIN8) NAME(*)
      Integer ICNT(MXBAS), nStab(MxAtom)
      CHARACTER*(LENIN) CNAME(MXATOM)
      Character*(LENIN4) LblCnt4(MxAtom)
c      Character*(LENIN) LblCnt(MxAtom)
      Character*(LENIN) TLbl(MXATOM)
      Character*(LENIN4) Atom_A, Atom_B, Atom_C, Atom_D
      Character*16 Label
      Character*1 Sign
      Character*36 LabelSym
      Character*36 LabelNoSym
      Character*49 Label3ASym
      Character*49 Label3ANoSym
      External Get_SuperName
      Character*100 Get_SuperName

      Logical Exist, SearchedSingle, SearchedTriple, Reduce_Prt
      External Reduce_Prt

*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0
*                                                                      *
************************************************************************
*                                                                      *
      If (iPL.lt.2) Return
*                                                                      *
************************************************************************
*                                                                      *
*     Since LoProp gives a complete density matrix after the second    *
*     run in UHF case, we simply skip the first run                    *
      If (iCase.eq.0) Return
*
*----------------------------------------------------------------------*
*     Parameters                                                       *
*----------------------------------------------------------------------*
*
* Core Orbitals threshold, default 1.999
      thr_CO = 1.999
* Lone Pairs threshold .le. Core Orbitals threshold, default 1.90
*     thr_LP = 1.90
*     thr_LP = 1.85
      thr_LP = 1.80
      thr_LP_Orig = thr_LP
* Bond occupation threshold .le. Lone Pairs Orbitals threshold
* Guessed to 1.90. Minimum possible threshold thr_MIN guessed to 1.50
      thr_BO = 1.999
      thr_Orig = thr_BO
      thr_MIN =1.50
* Non-assigned threshold, guessed to 0.90
      thr_NA = 0.90
* Single occupied orbitals threshold, guessed to 0.999
      thr_SO = 0.90
* Not so Dummy thresholds
      thr_Dummy = 4.0
      thr_Dummy1 = 2.02
      thr_Dummy2 = 1.02
      ipDummy = 1

* Decreasing threshold and decrease step
      thr_DecrStep = 0.01
      thr_Decr = 0.0
*
      SearchedSingle = .False.
      SearchedTriple = .False.
      ix_Triple=0
      ix_Single=0
*
*----------------------------------------------------------------------*
*     GET THE TOTAL NUMBER OF BASIS FUNCTIONS AND CHECK LIMITS         *
*----------------------------------------------------------------------*
*
      NBAST=0
      Do I=1,NSYM
        NBAST=NBAST+NBAS(I)
      End Do
      IF(NBAST.GT.MXBAS) GOTO 991

      NBAST2=NBAST**2
*
*----------------------------------------------------------------------*
*     Find the list of unique center labels                            *
*----------------------------------------------------------------------*
*
      Call Get_iScalar('Unique atoms',nNUC)
      Call Get_cArray('Unique Atom Names',CNAME,(LENIN)*nNuc)
      Call Get_iArray('nStab',nStab,nNuc)

*
*----------------------------------------------------------------------*
*     Find the center label for each basis function                    *
*----------------------------------------------------------------------*
*
      Do I=1,NBAST
         ICNT(I)=-1
         Do J=1,NNUC
            If (NAME(I)(1:LENIN).EQ.CNAME(J)) ICNT(I)=J
         End Do
         If (ICNT(I).lt.0) Then
           Write(6,*)
           Write(6,*) 'NBO analysis not implemented with pseudo atoms'
           Write(6,*) '(yet). Continuing normal execution.'
           Write(6,*)
           Return
         End If
      End Do
*
*----------------------------------------------------------------------*
*     Get the total number of atoms tNUC, regardless of symmetry       *
*----------------------------------------------------------------------*
*
      Call Get_iScalar('LP_nCenter', tNUC)
      If (tNUC.eq.1) Return
*
*----------------------------------------------------------------------*
*     Find the center label for each atom, regardless of symmetry      *
*----------------------------------------------------------------------*
*
*     Just atom label. It's a double of the next one,
*     but someone could find it usefull in the future

      Call Get_LblCnt_All(TLbl)

*     Atom label plus symmetry generator

      Call Get_cArray('LP_L',LblCnt4,(LENIN4)*tNUC)
c      Do i=1,tNUC
c       LblCnt(i)(1:LENIN)=LblCnt4(i)(1:LENIN)
c      EndDo
*
*----------------------------------------------------------------------*
*     Check for extra atoms in tnuc, caused by Mr. Choleski            *
*----------------------------------------------------------------------*
*
      tRealNUC = tNUC
      If (tNUC.gt.NNUC) Then
        iNoNuc = 0
        Do i = 1, tNUC
          iTry = 0
          Do j = 1, NNuc
            If (Tlbl(i).eq.CNAME(J)) iTry = 1
          End Do
          If (iTry.eq.0) iNoNuc = iNoNuc + 1
        End Do
        tRealNUC = tNUC - iNoNuc
      End If
*
*----------------------------------------------------------------------*
*     Get the coordinates of the atoms                                 *
*----------------------------------------------------------------------*
*
      Call Allocate_Work(ipAll, 3*tRealNUC)
      Call FZero(Work(ipAll), 3*tRealNUC)

      Call Get_Coord_All(Work(ipAll),tRealNUC)

#ifdef _DEBUGPRINT_
      Call RecPrt('Coordinates',' ',Work(ipAll),3,tRealNUC)
#endif

*
*----------------------------------------------------------------------*
*     Get the atoms numbers                                            *
*----------------------------------------------------------------------*
*
      Call Allocate_Work(ipCM  ,tRealNUC)
      Call Get_Nuc_Charge_All(Work(ipCM), tRealNUC)
#ifdef _DEBUGPRINT_
      Call RecPrt(' Charges',' ',Work(ipCM),tRealNUC,1)
#endif

*
*     Transform charges to masses (C=12)
*
      ii = ipCM
      Call GetMem('ANr','Allo','Inte',ipANr,tRealNUC)
      jj = ipANr
      Do 110 isAtom = 1, tRealNUC
         iWork(jj)=Int(Work(ii))
         ii = ii + 1
         jj = jj + 1
110   Continue

#ifdef _DEBUGPRINT_
      Call ivcPrt(' Atoms',' ',iWork(ipANr),tRealNUC)
#endif

      Call Free_Work(ipCM)
*
*----------------------------------------------------------------------*
*     Initialize bond order vectors                                    *
*     + 10 added to stay on the safe side                              *
*----------------------------------------------------------------------*
*
      NPBonds = tRealNUC*(tRealNUC-1)/2 + 10
      Call Allocate_Work(ipBonds, NPBonds)
      Call Allocate_iWork(ipBondAtomA, NPBonds)
      Call Allocate_iWork(ipBondAtomB, NPBonds)

      Call FZero(Work(ipBonds),NPBonds)
      Call IZero(iWork(ipBondAtomA), NPBonds)
      Call IZero(iWork(ipBondAtomB), NPBonds)

*
*----------------------------------------------------------------------*
*     In case of symmetry we need the desymmetrization matrix          *
*----------------------------------------------------------------------*
*
      If (nSym.gt.1) then
*
         Call Allocate_Work(ipP,NBAST2)
         Call Allocate_Work(ipPInv,NBAST2)

         Call FZero(Work(ipP),NBAST2)
         Call FZero(Work(ipPInv),NBAST2)

         Call Get_dArray('SM',Work(ipP),NBAST2)
#ifdef _DEBUGPRINT_
         Call RecPrt('SM',' ',Work(ipP),NBAST,NBAST)
#endif
         Call MINV(Work(ipP),Work(ipPInv),ISING,DET,NBAST)
#ifdef _DEBUGPRINT_
         Call RecPrt('SMInv',' ',Work(ipPInv),NBAST,NBAST)
#endif
         Call DGeTMi(Work(ipPInv),NBAST,NBAST)
      End If
*
*----------------------------------------------------------------------*
*     Pick up index array of which center a basis function belongs to  *
*----------------------------------------------------------------------*
*
      Call Allocate_iWork(ip_center,NBAST)
      Call Get_iArray('Center Index',iWork(ip_center),NBAST)

#ifdef _DEBUGPRINT_
      Write (6,*) 'iWork(ip_center) ='
      Do I =1, NBAST
          Write (6,*) iWork(ip_center+I-1)
      End Do
#endif
*
*----------------------------------------------------------------------*
*     Get the Number of Basis Functions per Atom                       *
*----------------------------------------------------------------------*
*
      Call Allocate_iWork(ipNBFpA,tNUC)

      Do I = 1, tNUC
          iWork(ipNBFpA+I-1) = 0
      End Do

      Do I = 1, NBAST
          iWork(ipNBFpA+iWork(ip_center+I-1)-1) =
     &     iWork(ipNBFpA+iWork(ip_center+I-1)-1) + 1
      End Do

#ifdef _DEBUGPRINT_
      Write (6,*) 'number of basis per atom iWork(ipNBFpA) ='
      Do I = 1, tNUC
          Write (6,*) iWork(ipNBFpA+I-1)
      End Do
#endif
*
*----------------------------------------------------------------------*
*     Allocation and Initialization of matrices                        *
*----------------------------------------------------------------------*
*
      Call Allocate_Work(ipS    , (NBAST2))
      Call Allocate_Work(ipS_tmp, (NBAST2))

      Call FZero(Work(ipS    ),(NBAST2))
      Call FZero(Work(ipS_tmp),(NBAST2))

      nBas2=0
      Do I=1, nsym
          nBas2=nBas2+nBas(i)*nBas(i)
      End Do

      If (nSym.gt.1) then
          Call Allocate_Work(ipS_blo, nBas2)

          Call FZero(Work(ipS_blo), nBas2)
      End If

      iSElem = 0
      Do ISYM = 1, NSYM
          iSElem = iSElem + (NBAS(ISYM)*(NBAS(ISYM)+1)/2)
      End Do
      Call Allocate_Work(ipS_orig, iSElem)
      Call FZero(Work(ipS_orig), iSElem)
*
*----------------------------------------------------------------------*
*     Read overlap matrix SMAT                                         *
*----------------------------------------------------------------------*
*
      i_Rc=0
      i_Opt=6
      i_Component=1
      i_SymLbl=1
      Call RdOne(i_Rc,i_Opt,'Mltpl  0',i_Component,
     &           Work(ipS_orig),i_SymLbl)
      If ( i_Rc.ne.0 ) Then
        Write(6,*)'NBO Error: Could not read overlaps from ONEINT.'
        Call Abend
      End If

#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'Original Overlap Matrix'
      Write(6,'(2X,8F12.8)')(Work(ipS_orig+J-1),J=1,iSElem)
#endif
*
*----------------------------------------------------------------------*
*    Overlap matrix is retrieved in matrix form                        *
*----------------------------------------------------------------------*
*
      IB=0
      IS=0
      Do ISYM=1,NSYM
        NB=NBAS(ISYM)
        IF ( NB.NE.0 ) THEN
          IMN=0
          Do MY=1,NB
*           If (ICNT(IB+MY).le.0) Go To 97         ! skip pseudo center
            Do NY=1,MY
*             If (ICNT(IB+NY).le.0) Go To 96  ! skip pseudo center
              IMN=IMN+1
*  Save the Overlap matrix element (my.ny) and (ny,my) in work(ipS_orig)
              Work(ipS_tmp + (NY+IB-1) * NBAST + MY+IB -1)=
     &                             Work(ipS_orig + IMN+IS -1)
              Work(ipS_tmp + (MY+IB-1) * NBAST + NY+IB -1)=
     &                             Work(ipS_orig + IMN+IS -1)

*96            Continue
            End Do
*97          Continue
           End Do
           IB=IB+NB
           IS=IS+(NB+NB**2)/2
         End If
      End Do

#ifdef _DEBUGPRINT_
      Write(6,*)
      Write(6,*) 'Before desymmetrization'
      Call RecPrt('Overlap Matrix = ', ' ',
     &             Work(ipS_tmp), NBAST, NBAST)
#endif
*
*----------------------------------------------------------------------*
*     In case of symmetry, we desymmetrize S through S_blo             *
*----------------------------------------------------------------------*
*
      If (nSym.gt.1) then
        iBlo = 0
        iSum = 0
        Do i = 1, NSYM
            If (nbas(i).ne.0) then
                Do j = 0, nbas(i) - 1
                    Do k = 0, nbas(i) - 1
                        Work(ipS_blo + iBlo) = Work(ipS_tmp +
     &                            (j+iSum)*NBAST + iSum + k)
                        iBlo = iBlo +1
                    End Do
                End Do
                iSum = iSum + nbas(i)
            End IF
        End Do

#ifdef _DEBUGPRINT_
        Write(6,*) 'S_blo = '
        Do i=1,nBas2
            Write(6,*) (Work(ipS_blo +I -1))
        End Do
#endif

        nBasMax = 0
        Do i = 1, nSym
          nBasMax = Max(nBasMax,nBas(i))
        End Do

#ifdef _DEBUGPRINT_
        Write(6,*)'nBasMax = ', nBasMax
#endif

        nScr=nBasMax*NBAST
        iSyLbl=1

        Call Allocate_Work(ipScr,nScr)
        Call Desymmetrize(Work(ipS_blo),nBas2,Work(ipScr),nScr,
     &                    Work(ipS),nBas,NBAST,Work(ipPInv),nSym,
     &                    iSyLbl)
        Call Free_Work(ipScr)
*
*----------------------------------------------------------------------*
*     Otherwise we simply copy S_tmp into S                            *
*----------------------------------------------------------------------*
*
      Else
          Do I=1,NBAST2
              Work(ipS+I-1)=Work(ipS_tmp+I-1)
          End Do
      End If

#ifdef _DEBUGPRINT_
      Write(6,*)
      Write(6,*) 'After desymmetrization'
      Call RecPrt('S Matrix = ', ' ',
     &             Work(ipS), NBAST, NBAST)
#endif
*
*----------------------------------------------------------------------*
*     Some deallocation of work                                        *
*----------------------------------------------------------------------*
*
      Call Free_Work(ipS_tmp)
      Call Free_Work(ipS_orig)
      If (nSym.gt.1) then
          Call Free_Work(ipP)
          Call Free_Work(ipPInv)
          Call Free_Work(ipS_blo)
      End If
*
*----------------------------------------------------------------------*
*     Retrieve the density matrix as produced by LoProp                *
*----------------------------------------------------------------------*
*
      Call Allocate_Work(ipDNAO , (NBAST2))
      Call FZero(Work(ipDNAO ),(NBAST2))

      Write(Label,'(A,I1)') 'LoProp Dens ',0
      Call qpg_dArray(Label,Exist,nDens)
      If (.NOT. Exist .or. nDens .eq. 0) Then
         Call SysAbendMsg('get_density_matrix',
     &                       'Could not locate:',Label)
      End If
      Call Allocate_Work(ipTmp,(nDens))
      Call FZero(Work(ipTmp),(nDens))

      Call Get_dArray(Label,Work(ipTmp),nDens)

#ifdef _DEBUGPRINT_
      Call TriPrt('Density Matrix',' ',Work(ipTmp),NBAST)
#endif

*     Square the density matrix

      Do i = 1, nBast-1
        Do j = 1, i
          Work(ipTmp+j+i*(i+1)/2-1) = Work(ipTmp+j+i*(i+1)/2-1)/2
        End Do
      End Do

      Call Square(Work(ipTmp),Work(ipDNAO),1,NBAST,NBAST)

      Call Free_Work(ipTmp)



#ifdef _DEBUGPRINT_
      Call RecPrt('Loprop D Matrix squared = ', ' ',
     &             Work(ipDNAO), NBAST, NBAST)

      E=Zero
      Do I=1, NBAST
          Do J=1, NBAST
              E=E+ Work(ipDNAO + (J-1) * NBAST + I - 1) *
     &             Work(ipS + (J-1) * NBAST + I - 1)
          End Do
      End Do
      Write(6,*)
      Write(6,*) 'Number of electrons as sum of D and S elements = ', E
#endif

*
*----------------------------------------------------------------------*
*     DS matrix                                                        *
*----------------------------------------------------------------------*
*
      Call Allocate_Work(ipDS,(NBAST2))
      Call FZero(Work(ipDS),(NBAST2))
      Call DGEMM_('N','N',
     &            NBAST,NBAST,NBAST,
     &            1.0d0,Work(ipDNAO),NBAST,
     &            Work(ipS),NBAST,
     &            0.0d0,Work(ipDS),NBAST)

#ifdef _DEBUGPRINT_
      Call RecPrt('DS-NAO Matrix = ', ' ',
     &             Work(ipDS), NBAST, NBAST)
      E=Zero
      Do I=1,NBAST
          E=E+Work(ipDS + (I-1) * NBAST + I -1)
      End Do
      Write(6,*)
      Write(6,*) 'Number of electrons as sum of the DS diagonal = ', E
#endif

c       Call Get_iScalar('nSym',nSym)
#ifdef VV_MAL
       if(nSym.eq.1) then
       Call Allocate_Work(ip_Charge,tNuc)
      Call Get_dArray('Effective nuclear charge',
     &      Work(ip_Charge),tNuc)
      Call Allocate_Work(ip_VV_QAB,tNuc)
      Call Allocate_Work(ip_VV_WAB,tNuc*tNuc)
      Call Allocate_Work(ip_VV_CAB,tNuc)
      Call Allocate_Work(ip_VV_VAB,tNuc)
      Call Allocate_iWork(ip_VV_N,tNuc+1)
      Call Vale(tNUC,iWork(ipNBFpA),Work(ip_Charge),
     &     NBAST,Work(ipDS),CNAME,LENIN,iWork(ip_VV_N),
     &     Work(ip_VV_QAB),Work(ip_VV_WAB),
     &     Work(ip_VV_CAB), Work(ip_VV_VAB))
      Call Free_Work(ip_VV_N)
      Call Free_Work(ip_VV_VAB)
      Call Free_Work(ip_VV_CAB)
      Call Free_Work(ip_VV_WAB)
      Call Free_Work(ip_VV_QAB)
      Call Free_Work(ip_Charge)
      endif
#endif
*
*----------------------------------------------------------------------*
*     Some more deallocation of work and variables inizialization      *
*----------------------------------------------------------------------*
*
      Call Free_Work(ipS)
      Call Free_Work(ipDNAO)

      Call Allocate_Work(ipDS_Orig,(NBAST2))
      Call FZero(Work(ipDS_Orig),(NBAST2))
      Do I = 1, (NBAST2)
        Work(ipDS_Orig + I - 1) = Work(ipDS + I - 1)
      End Do

      isThereAtLeastABond = 0

*----------------------------------------------------------------------*
888   Continue
*----------------------------------------------------------------------*

      TotCoreElec = Zero
      TotLoneElec = Zero
      TotBondElec = Zero
      TotSingleElec = Zero
      TotTriplBondElec = Zero
      iBondNumb = 0
      iSingNumb = 0
      iTriplBondNumb = 0
*
*----------------------------------------------------------------------*
*     How many electrons we have                                       *
*----------------------------------------------------------------------*
*
      TotEl=Zero
      Do I=1,NBAST
          TotEl=TotEl+Work(ipDS + (I-1) * NBAST + I -1)
      End Do

#ifdef _DEBUGPRINT_
      Write(6,*)
      Write(6,*) 'Number of electrons = ', TotEl
#endif

*
*----------------------------------------------------------------------*
*     Depletion of core orbitals. First we build and diagonalize       *
*     a one center matrix of pre-NBO from the DS matrix and then       *
*     we eliminate those contributions with eigenvalues > thr_CO from  *
*     the DNAO density matrix. DS = DS - eival * eivect * eivect T     *
*----------------------------------------------------------------------*
*
      Do IAtom = 1, tRealNUC

          nBasAtoms = iWork(ipNBFpA+IAtom-1)
          nDimSubD = nBasAtoms*nBasAtoms

*
*     extraction of sub matrix from DNAO
*     ipSubDNAO -> sub matrix
*     ipSubVec  -> will contain eigen vectors
*     ipSubVal  -> will contain eigen values, real part
*     ipSubIVal -> will contain eigen values, imaginary part
*

          Call Allocate_Work(ipSubDNAO,       nDimSubD)
          Call Allocate_iWork(ipSubDNAOindex, nDimSubD)
          Call Allocate_Work(ipSubVec,        nDimSubD)
          Call Allocate_Work(ipSubVal,        nBasAtoms)
          Call Allocate_Work(ipSubIVal,       nBasAtoms)

          Call FZero(Work(ipSubDNAO),       nDimSubD)
          Call IZero(iWork(ipSubDNAOindex), nDimSubD)
          Call FZero(Work(ipSubVec),        nDimSubD)
          Call FZero(Work(ipSubVal),        nBasAtoms)
          Call FZero(Work(ipSubIVal),       nBasAtoms)

          iSubD = 0

          Do MY = 1, NBAST
           AtomA=iWork(ip_center+MY-1)
*          If (ICNT(MY).le.0) Go To 93   ! skip pseudo center
           If (AtomA.ne.IAtom) Go To 93 ! we want just one atom a time
           Do NY = 1, NBAST
            AtomB=iWork(ip_center+NY-1)
*           If (ICNT(NY).le.0) Go To 92 ! skip pseudo center
            If (AtomA.ne.AtomB) Go To 92 ! they have to be the same atom

            Work(ipSubDNAO+iSubD) = Work(ipDS+(MY-1)*NBAST+NY-1)
            iWork(ipSubDNAOindex+iSubD) = (MY-1)*NBAST + NY-1
            iSubD = iSubD + 1

92            Continue
           End Do
93           Continue
          End Do

#ifdef _DEBUGPRINT_
           Write (6,*)
           Call RecPrt('SubDNAO Matrix = ', ' ',
     &             Work(ipSubDNAO), nBasAtoms, nBasAtoms)
           Write (6,*)
           Call iVcPrt('SubDNAO index Matrix = ', ' ',
     &             iWork(ipSubDNAOindex), nDimSubD)
      Write(6,*)'SubDNAO diagonal elements'
      Do I=1,nBasAtoms
          Write(6,*) Work(ipSubDNAO + (I-1) * nBasAtoms + I -1)
      End Do

*     Write (6,*)
*     Write (6,*) 'SubDS=',DDot_(nDimSubD,Work(ipSubDNAO),1,
*    &                                   Work(ipSubDNAO),1),
*    &                     DDot_(nDimSubD,Work(ipSubDNAO),1,One,0)
#endif
*
*---- Diagonalization
*
           Call xEigen(1,nBasAtoms,nBasAtoms,work(ipSubDNAO),
     &                 Work(ipSubVal),Work(ipSubIVal),Work(ipSubVec),
     &                 iErr)

           If (iErr.ne.0) Then
               Write(6,*) 'Something went wrong when diagonalizing.'
               Write(6,*) 'NBO analysis cannot be finished, sorry.'
               Return
           End If

#ifdef _DEBUGPRINT_
           Write (6,*)
           Write (6,*) 'One atom submatrix diagonalization'
           Call RecPrt('Eigen vectors Matrix = ', ' ',
     &             Work(ipSubVec), nBasAtoms, nBasAtoms)
           Write (6,*)
            Call RecPrt('Eigen values, real = ', ' ',
     &             Work(ipSubVal), nBasAtoms, 1)
           Write (6,*)
            Call RecPrt('Eigen values, imaginary = ', ' ',
     &             Work(ipSubIVal), nBasAtoms, 1)

#endif

          Call Seek_n_Destroy(nBasAtoms, nDimSubD, ipSubVal, ipSubVec,
     &     nBast, thr_CO, thr_Dummy, TotCoreElec, ipSubDNAOindex, ipDS,
     &         0,ipDummy, ipDummy, 0, IAtom, IAtom, ipDummy,
     &           ipDummy, IAtom)

*
*----------------------------------------------------------------------*
*     Depletion of lone pair orbitals. We use the already diagonalized *
*     one center matrix of pre-NBO from the DS matrix and then we      *
*     eliminate those contributions with thr_LP <= eigenval <= thr_CO  *
*     from the DNAO density matrix. DS =DS - eival * eivect * eivect T *
*----------------------------------------------------------------------*
*

          Call Seek_n_Destroy(nBasAtoms, nDimSubD, ipSubVal, ipSubVec,
     &        nBast, thr_LP, thr_CO, TotLoneElec, ipSubDNAOindex, ipDS,
     &         0,ipDummy, ipDummy, 0, IAtom, IAtom, ipDummy,
     &           ipDummy, IAtom)

          Call Free_Work(ipSubDNAO)
          Call Free_iWork(ipSubDNAOindex)
          Call Free_Work(ipSubVec)

          Call Free_Work(ipSubVal)

          Call Free_Work(ipSubIVal)

      End Do

#ifdef _DEBUGPRINT_
      E=Zero
      Do I=1,NBAST
          E=E+Work(ipDS + (I-1) * NBAST + I -1)
      End Do
      Write(6,*)
      Write(6,*) 'Number of electrons as sum of the DS diagonal = ', E
#endif
*
*----------------------------------------------------------------------*
*     Now for the real thing: NBO generation                           *
*----------------------------------------------------------------------*
*
*----------------------------------------------------------------------*
999   Continue
*----------------------------------------------------------------------*
*
*----------------------------------------------------------------------*
*     Copy of DS matrix for the depletion                              *
*----------------------------------------------------------------------*
*
      Call Allocate_Work(ipDS_tmp, (NBAST2))
      Call FZero(Work(ipDS_tmp), (NBAST2))
      Do I = 1, (NBAST2)
        Work(ipDS_tmp + I - 1) = Work(ipDS + I - 1)
      End Do
*
*----------------------------------------------------------------------*
*    2 atoms loop                                                      *
*----------------------------------------------------------------------*
*
      Do IAtom = 1, tRealNUC - 1
        Do JAtom = IAtom+1, tRealNUC

*-----If the two atoms are far from each other we do not consider them.
*-----Distance checked against covalent radius. The threshold is used
*-----to tune the acceptance coefficient

          x = Work(ipAll+(IAtom-1)*3)   - Work(ipAll+(JAtom-1)*3)
          y = Work(ipAll+(IAtom-1)*3+1) - Work(ipAll+(JAtom-1)*3+1)
          z = Work(ipAll+(IAtom-1)*3+2) - Work(ipAll+(JAtom-1)*3+2)
          rij2 = x**2 + y**2 + z**2
          rij = Sqrt(rij2)

*-----To avoid warnings for Atomic Nr > 86
*
          iANr=iWork(ipANr+IAtom-1)
          If (iANr.gt.86) Then
             Covrad1=2.70d0
          Else
             Covrad1=Covrad(iANr)
          EndIf

          jANr=iWork(ipANr+JAtom-1)
          If (jANr.gt.86) Then
             Covrad2=2.70d0
          Else
             Covrad2=Covrad(jANr)
          EndIf

          covij = Covrad1 + Covrad2

          thr_Diff = thr_Orig - thr_BO
          coeff = 1.25 + thr_Diff

          If (rij.gt.(coeff*covij)) Then
            GOTO 91
          Else
            isThereAtLeastABond = 1
          End If

#ifdef _DEBUGPRINT_
          Write(6,*)
          Write(6,*) 'Good rij = ', rij
          Write(6,*) 'covalent = ', covij
#endif
*-----

          nBasAtomsA = iWork(ipNBFpA+IAtom-1)
          nBasAtomsB = iWork(ipNBFpA+JAtom-1)

          nBasAtoms = nBasAtomsA + nBasAtomsB
          nDimSubD = nBasAtoms*nBasAtoms

*
*     extraction of sub matrix from DNAO
*     ipSubDNAO -> sub matrix
*     ipSubVec  -> will contain eigen vectors
*     ipSubVal  -> will contain eigen values, real part
*     ipSubIVal -> will contain eigen values, imaginary part
*

          Call Allocate_Work(ipSubDNAO,       nDimSubD)
          Call Allocate_iWork(ipSubDNAOindex, nDimSubD)
          Call Allocate_Work(ipSubVec,        nDimSubD)
          Call Allocate_Work(ipSubVal,        nBasAtoms)
          Call Allocate_Work(ipSubIVal,       nBasAtoms)

          Call FZero(Work(ipSubDNAO),       nDimSubD)
          Call IZero(iWork(ipSubDNAOindex), nDimSubD)
          Call FZero(Work(ipSubVec),        nDimSubD)
          Call FZero(Work(ipSubVal),        nBasAtoms)
          Call FZero(Work(ipSubIVal),       nBasAtoms)

          iSubD = 0

          Do MY = 1, NBAST
           AtomA=iWork(ip_center+MY-1)
*          If (ICNT(MY).le.0) Go To 95   ! skip pseudo center
           Do NY = 1, NBAST
            AtomB=iWork(ip_center+NY-1)
*           If (ICNT(NY).le.0) Go To 94 ! skip pseudo center

            If (((AtomA.eq.IAtom).OR.(AtomA.eq.JAtom))
     &          .AND.
     &          ((AtomB.eq.IAtom).OR.(AtomB.eq.JAtom))) Then

              Work(ipSubDNAO+iSubD) = Work(ipDS+(MY-1)*NBAST+NY-1)
              iWork(ipSubDNAOindex+iSubD) = (MY-1)*NBAST + NY-1
              iSubD = iSubD + 1

            End If

*94            Continue
           End Do
*95           Continue
          End Do

#ifdef _DEBUGPRINT_
           Write (6,*)
            Call RecPrt('SubDNAO Matrix = ', ' ',
     &             Work(ipSubDNAO), nBasAtoms, nBasAtoms)

#endif
*
*---- Diagonalization
*
           Call xEigen(1,nBasAtoms,nBasAtoms,work(ipSubDNAO),
     &                 Work(ipSubVal),Work(ipSubIVal),Work(ipSubVec),
     &                 iErr)

           If (iErr.ne.0) Then
               Write(6,*) 'Something went wrong when diagonalizing.'
               Write(6,*) 'NBO analysis cannot be finished, sorry.'
               Return
           End If

#ifdef _DEBUGPRINT_
           Write (6,*)
           Write (6,*) 'Two atoms submatrix diagonalization'
           Call RecPrt('Eigen vectors Matrix = ', ' ',
     &             Work(ipSubVec), nBasAtoms, nBasAtoms)
           Write (6,*)
            Call RecPrt('Eigen values, real = ', ' ',
     &             Work(ipSubVal), nBasAtoms, 1)
           Write (6,*)
            Call RecPrt('Eigen values, imaginary = ', ' ',
     &             Work(ipSubIVal), nBasAtoms, 1)

#endif

          Call Seek_n_Destroy(nBasAtoms, nDimSubD, ipSubVal, ipSubVec,
     & nBast, thr_BO, thr_Dummy1+thr_Diff, TotBondElec, ipSubDNAOindex,
*    & nBast, thr_BO, thr_Dummy1, TotBondElec, ipSubDNAOindex,
     & ipDS_tmp, 1, ipBondAtomA, ipBondAtomB, iBondNumb, IAtom, JAtom,
     &      ipBonds, ipDummy, IAtom)

          Call Free_Work(ipSubDNAO)
          Call Free_iWork(ipSubDNAOindex)
          Call Free_Work(ipSubVec)
          Call Free_Work(ipSubVal)
          Call Free_Work(ipSubIVal)

91      Continue
        End Do

      End Do
*
*----------------------------------------------------------------------*
*     Copy of DS matrix                                                *
*----------------------------------------------------------------------*
*
      Do I = 1, (NBAST2)
        Work(ipDS + I - 1) = Work(ipDS_tmp + I - 1)
      End Do
      Call Free_Work(ipDS_tmp)

#ifdef _DEBUGPRINT_
        Call RecPrt('DS-NAO depleted Matrix = ', ' ',
     &       Work(ipDS), NBAST, NBAST)
        E=Zero
        Do K=1,NBAST
            E=E+Work(ipDS + (K-1) * NBAST + K -1)
        End Do
        Write(6,*)
        Write(6,*)'Number of electrons as sum of the DS diagonal = '
     &             , E
#endif
*
*----------------------------------------------------------------------*
*     Search for non assigned electrons                                *
*----------------------------------------------------------------------*
*

      ElecNonAssgn = TotEl - TotCoreElec - TotLoneElec - TotBondElec

#ifdef _DEBUGPRINT_
      Write(6,*)
      Write(6,*)'Number of non assigned electrons = ', ElecNonAssgn
#endif
*
*----------------------------------------------------------------------*
*     First we decrease the bond threshold and do the NBO again        *
*----------------------------------------------------------------------*
*
      If (ElecNonAssgn .ge. 2*thr_NA) then
        thr_Decr = thr_Decr + thr_DecrStep
        thr_BO = thr_BO - thr_Decr
        If (thr_BO.ge.thr_MIN) GOTO 999
      End If

*
*----------------------------------------------------------------------*
*     Second: we search for three centre bonds. This part of the code  *
*     is quite experimental. If the result is inconsistent, it will be *
*     ignored.                                                         *
*----------------------------------------------------------------------*
*
      If ((ElecNonAssgn .ge. 2*thr_NA).AND.(tNUC.gt.2)) then

*
*----------------------------------------------------------------------*
*     Copy of DS matrix for the depletion                              *
*----------------------------------------------------------------------*
*
       Call Allocate_Work(ipDS_tmp, (NBAST2))
       Call FZero(Work(ipDS_tmp), (NBAST2))
       Do I = 1, (NBAST2)
         Work(ipDS_tmp + I - 1) = Work(ipDS + I - 1)
       End Do
*
*----------------------------------------------------------------------*
*     Creation of the three centre bond vector and other memory stuff  *
*     + 100 added to stay on the safe side to avoid memory problems    *
*----------------------------------------------------------------------*
*
       iElToAsgn = int(ElecNonAssgn + 0.5) + 100


       If (ix_Triple.lt.iElToAsgn) Then
          If (SearchedTriple) Then
             Call Free_Work(ipTripl)
             Call Free_iWork(ipTriplAtomA)
             Call Free_iWork(ipTriplAtomB)
             Call Free_iWork(ipTriplAtomC)
          End If
          SearchedTriple = .True.
          ix_Triple = iElToAsgn
          Call Allocate_Work(ipTripl,       iElToAsgn)
          Call Allocate_iWork(ipTriplAtomA, iElToAsgn)
          Call Allocate_iWork(ipTriplAtomB, iElToAsgn)
          Call Allocate_iWork(ipTriplAtomC, iElToAsgn)
       End If

       Call FZero(Work(ipTripl),       iElToAsgn)
       Call IZero(iWork(ipTriplAtomA), iElToAsgn)
       Call IZero(iWork(ipTriplAtomB), iElToAsgn)
       Call IZero(iWork(ipTriplAtomC), iElToAsgn)


*----Reset the bond threshold to the original value
       thr_BO = thr_Orig

*
*----------------------------------------------------------------------*
*    3 atoms loop                                                      *
*----------------------------------------------------------------------*
*
       Do IAtom = 1, tRealNUC - 2
        Do JAtom = IAtom+1, tRealNUC - 1
         Do KAtom = JAtom+1, tRealNUC

          nBasAtomsA = iWork(ipNBFpA+IAtom-1)
          nBasAtomsB = iWork(ipNBFpA+JAtom-1)
          nBasAtomsC = iWork(ipNBFpA+KAtom-1)

          nBasAtoms = nBasAtomsA + nBasAtomsB + nBasAtomsC
          nDimSubD = nBasAtoms*nBasAtoms

*
*     extraction of sub matrix from DNAO
*     ipSubDNAO -> sub matrix
*     ipSubVec  -> will contain eigen vectors
*     ipSubVal  -> will contain eigen values, real part
*     ipSubIVal -> will contain eigen values, imaginary part
*

          Call Allocate_Work(ipSubDNAO,       nDimSubD)
          Call Allocate_iWork(ipSubDNAOindex, nDimSubD)
          Call Allocate_Work(ipSubVec,        nDimSubD)
          Call Allocate_Work(ipSubVal,        nBasAtoms)
          Call Allocate_Work(ipSubIVal,       nBasAtoms)

          Call FZero(Work(ipSubDNAO),       nDimSubD)
          Call IZero(iWork(ipSubDNAOindex), nDimSubD)
          Call FZero(Work(ipSubVec),        nDimSubD)
          Call FZero(Work(ipSubVal),        nBasAtoms)
          Call FZero(Work(ipSubIVal),       nBasAtoms)

          iSubD = 0

          Do MY = 1, NBAST
           AtomA=iWork(ip_center+MY-1)
*          If (ICNT(MY).le.0) Go To 85   ! skip pseudo center
           Do NY = 1, NBAST
            AtomB=iWork(ip_center+NY-1)
*           If (ICNT(NY).le.0) Go To 84 ! skip pseudo center

            If (
     &      ((AtomA.eq.IAtom).OR.(AtomA.eq.JAtom).OR.(AtomA.eq.KAtom))
     &          .AND.
     &      ((AtomB.eq.IAtom).OR.(AtomB.eq.JAtom).OR.(AtomB.eq.KAtom))
     &             ) Then

              Work(ipSubDNAO+iSubD) = Work(ipDS+(MY-1)*NBAST+NY-1)
              iWork(ipSubDNAOindex+iSubD) = (MY-1)*NBAST + NY-1
              iSubD = iSubD + 1

            End If

*84            Continue
           End Do
*85           Continue
          End Do

#ifdef _DEBUGPRINT_
           Write (6,*)
            Call RecPrt('SubDNAO Matrix = ', ' ',
     &             Work(ipSubDNAO), nBasAtoms, nBasAtoms)

#endif
*
*---- Diagonalization
*
           Call xEigen(1,nBasAtoms,nBasAtoms,work(ipSubDNAO),
     &                 Work(ipSubVal),Work(ipSubIVal),Work(ipSubVec),
     &                 iErr)

           If (iErr.ne.0) Then
               Write(6,*) 'Something went wrong when diagonalizing.'
               Write(6,*) 'NBO analysis cannot be finished, sorry.'
               Return
           End If

#ifdef _DEBUGPRINT_
           Write (6,*)
            Call RecPrt('Eigen vectors Matrix = ', ' ',
     &             Work(ipSubVec), nBasAtoms, nBasAtoms)
           Write (6,*)
            Call RecPrt('Eigen values, real = ', ' ',
     &             Work(ipSubVal), nBasAtoms, 1)
           Write (6,*)
            Call RecPrt('Eigen values, imaginary = ', ' ',
     &             Work(ipSubIVal), nBasAtoms, 1)

#endif
          Call Free_Work(ipSubDNAO)

          Call Seek_n_Destroy(nBasAtoms, nDimSubD, ipSubVal, ipSubVec,
     & nBast, thr_LP, thr_Dummy1, TotTriplBondElec, ipSubDNAOindex,
     &                                                      ipDS_tmp,
     &   3, ipTriplAtomA, ipTriplAtomB, iTriplBondNumb, IAtom,
     &                                                JAtom, ipTripl,
     &      ipTriplAtomC, KAtom)

          Call Free_iWork(ipSubDNAOindex)
          Call Free_Work(ipSubVec)
          Call Free_Work(ipSubVal)
          Call Free_Work(ipSubIVal)

         End Do
        End Do
       End Do

       If (TotTriplBondElec.gt.ElecNonAssgn) Then

         iTriplBondNumb = 0

       Else

         ElecNonAssgn = ElecNonAssgn - TotTriplBondElec
         TotBondElec  = TotBondElec  + TotTriplBondElec
*
*----------------------------------------------------------------------*
*     Copy of DS matrix                                                *
*----------------------------------------------------------------------*
*
         Do I = 1, (NBAST2)
           Work(ipDS + I - 1) = Work(ipDS_tmp + I - 1)
         End Do

#ifdef _DEBUGPRINT_
         Call RecPrt('DS-NAO depleted Matrix = ', ' ',
     &        Work(ipDS), NBAST, NBAST)
         E=Zero
         Do K=1,NBAST
             E=E+Work(ipDS + (K-1) * NBAST + K -1)
         End Do
         Write(6,*)
         Write(6,*)'Number of electrons as sum of the DS diagonal = '
     &              , E
#endif

       End If
       Call Free_Work(ipDS_tmp)

      End If
*
*----------------------------------------------------------------------*
*     Third: if no bond has been found, but it should, we do           *
*     EVERYTHING from the beginning, with a lower threshold for lone   *
*     pairs.                                                           *
*----------------------------------------------------------------------*
*
      If ((isThereAtLeastABond.ne.0).AND.(TotBondElec.lt.0.1).AND.
     &    (thr_LP.eq.thr_LP_Orig)) Then
        thr_LP = thr_LP + 0.1
        Do I = 1, (NBAST2)
          Work(ipDS + I - 1) = Work(ipDS_Orig + I - 1)
        End Do
        GoTo 888
      End If

      Call Free_Work(ipDS_Orig)
*
*----------------------------------------------------------------------*
*     Fourth: we look for single occupied orbitals on each atom.       *
*     This part of the code is quite experimental, so if it will give  *
*     strange results, they will simply be ignored.                    *
*----------------------------------------------------------------------*
*
      If (ElecNonAssgn .ge. thr_NA) then

*        upper limit, overestimated to stay on the safe side
         iElToAsgn = int(ElecNonAssgn + 0.6) + 10
*        iElToAsgn = int(ElecNonAssgn + 0.6) + 1

         If (ix_Single.lt.iElToAsgn) Then
            If (SearchedSingle) Then
               Call Free_Work(ipSingEl)
               Call Free_iWork(ipSingElAtom)
            End If
            ix_Single=iElToAsgn
            SearchedSingle = .True.
            Call Allocate_Work(ipSingEl, iElToAsgn)
            Call Allocate_iWork(ipSingElAtom, iElToAsgn)
         End If

         Call FZero(Work(ipSingEl), iElToAsgn)
         Call IZero(iWork(ipSingElAtom), iElToAsgn)

         Do IAtom = 1, tRealNUC

          nBasAtoms = iWork(ipNBFpA+IAtom-1)
          nDimSubD = nBasAtoms*nBasAtoms

*
*     extraction of sub matrix from DNAO
*     ipSubDNAO -> sub matrix
*     ipSubVec  -> will contain eigen vectors
*     ipSubVal  -> will contain eigen values, real part
*     ipSubIVal -> will contain eigen values, imaginary part
*

          Call Allocate_Work(ipSubDNAO, nDimSubD)
          Call Allocate_iWork(ipSubDNAOindex, nDimSubD)
          Call Allocate_Work(ipSubVec,  nDimSubD)
          Call Allocate_Work(ipSubVal,  nBasAtoms)
          Call Allocate_Work(ipSubIVal,  nBasAtoms)

          Call FZero(Work(ipSubDNAO), nDimSubD)
          Call IZero(iWork(ipSubDNAOindex), nDimSubD)
          Call FZero(Work(ipSubVec),  nDimSubD)
          Call FZero(Work(ipSubVal),  nBasAtoms)
          Call FZero(Work(ipSubIVal), nBasAtoms)

          iSubD = 0

          Do MY = 1, NBAST
           AtomA=iWork(ip_center+MY-1)
*          If (ICNT(MY).le.0) Go To 73 ! skip pseudo center
           If (AtomA.ne.IAtom) Go To 73 ! we want just one atom a time
           Do NY = 1, NBAST
            AtomB=iWork(ip_center+NY-1)
*           If (ICNT(NY).le.0) Go To 72 ! skip pseudo center
            If (AtomA.ne.AtomB) Go To 72 ! they have to be the same atom

            Work(ipSubDNAO+iSubD) = Work(ipDS+(MY-1)*NBAST+NY-1)
            iWork(ipSubDNAOindex+iSubD) = (MY-1)*NBAST + NY-1
            iSubD = iSubD + 1

72          Continue
           End Do
73         Continue
          End Do

#ifdef _DEBUGPRINT_
           Write (6,*)
            Call RecPrt('SubDNAO Matrix = ', ' ',
     &             Work(ipSubDNAO), nBasAtoms, nBasAtoms)
#endif

*
*---- Diagonalization
*
           Call xEigen(1,nBasAtoms,nBasAtoms,work(ipSubDNAO),
     &                 Work(ipSubVal),Work(ipSubIVal),Work(ipSubVec),
     &                 iErr)

           If (iErr.ne.0) Then
               Write(6,*) 'Something went wrong when diagonalizing.'
               Write(6,*) 'NBO analysis cannot be finished, sorry.'
               Return
           End If

#ifdef _DEBUGPRINT_
           Write (6,*)
            Call RecPrt('Eigen vectors Matrix = ', ' ',
     &             Work(ipSubVec), nBasAtoms, nBasAtoms)
           Write (6,*)
            Call RecPrt('Eigen values, real = ', ' ',
     &             Work(ipSubVal), nBasAtoms, 1)
           Write (6,*)
            Call RecPrt('Eigen values, imaginary = ', ' ',
     &             Work(ipSubIVal), nBasAtoms, 1)

#endif

          Call Seek_n_Destroy(nBasAtoms, nDimSubD, ipSubVal, ipSubVec,
     &  nBast, thr_SO, thr_Dummy2, TotSingleElec, ipSubDNAOindex, ipDS,
     &     2, ipSingElAtom, ipDummy, iSingNumb, IAtom, IAtom, ipSingEl,
     &        ipDummy, IAtom)


          Call Free_Work(ipSubDNAO)
          Call Free_iWork(ipSubDNAOindex)
          Call Free_Work(ipSubVec)
          Call Free_Work(ipSubVal)
          Call Free_Work(ipSubIVal)
         End Do

         If (TotSingleElec.gt.ElecNonAssgn) Then
           iSingNumb=0
         Else
           ElecNonAssgn = ElecNonAssgn - TotSingleElec
         End If

      End If

*---- End of searching for non-assigned electrons


*
*----------------------------------------------------------------------*
*     Print out of the NBO analysis                                    *
*----------------------------------------------------------------------*
*
      Sign = '-'
      LabelSym =   'Atom A:Gen.  Atom B:Gen.  Bond Order'
      LabelNoSym = 'Atom A       Atom B       Bond Order'
      Label3ASym =   'Atom A:Gen.  Atom B:Gen.  Atom C:Gen.  Bond Order'
      Label3ANoSym = 'Atom A       Atom B       Atom C       Bond Order'

      Write(6,*)
      Call CollapseOutput(1,'   Natural Bond Order analysis')
      Write(6,'(3X,A)')     '   ---------------------------'

      Write(6,'(6X,A)') 'Based on LoProp computed density'
      Write(6,'(6X,85A)')(Sign,i=1,85)

      If (iBondNumb.gt.1) Then
*     Two columns format printing
        iHalf = Int(iBondNumb/2)
        iOdd = 0
        If (iHalf*2.ne.iBondNumb) iOdd = 1

        If (nSym.gt.1) then
            Write(6,'(6X,A)')   LabelSym//' | '//LabelSym
        Else
            Write(6,'(6X,A)') LabelNoSym//' | '//LabelNoSym
        End If
        Do I=0, iHalf -1
          Atom_A = LblCnt4(iWork(ipBondAtomA +I))
          Atom_B = LblCnt4(iWork(ipBondAtomB +I))
          Atom_C = LblCnt4(iWork(ipBondAtomA +I + iHalf))
          Atom_D = LblCnt4(iWork(ipBondAtomB +I + iHalf))
          Write(6,'(8X,A,3X,A,3X,F7.3,2X,A,3X,A,3X,A,3X,F7.3)')
     &     Atom_A, Atom_B, Work(ipBonds + I), '|',
     &     Atom_C, Atom_D, Work(ipBonds + I + iHalf)
        End Do
        If (iOdd.eq.1) Then
          Atom_A = LblCnt4(iWork(ipBondAtomA + iBondNumb - 1))
          Atom_B = LblCnt4(iWork(ipBondAtomB + iBondNumb - 1))
          Write(6,'(8X,A,3X,A,3X,F7.3,2X,A)')
     &     Atom_A, Atom_B, Work(ipBonds + iBondNumb - 1), '|'
        End If

      Else
*     One column format printing
        If (nSym.gt.1) then
          Write(6,'(6X,A)') LabelSym
        Else
          Write(6,'(6X,A)') LabelNoSym
        End If
        Do I=0, iBondNumb -1
          Atom_A = LblCnt4(iWork(ipBondAtomA +I))
*    &     TLbl(iWork(ipBondAtomA +I))//' -  '
*    &     //LblCnt(iWork(ipBondAtomA +I))
*    &     (Index(LblCnt(iWork(ipBondAtomA +I)),':')+1:)
*         Atom_A = TLbl(iWork(ipBondAtomA +I))
          Atom_B = LblCnt4(iWork(ipBondAtomB +I))
*    &     TLbl(iWork(ipBondAtomB +I))//' -  '
*    &     //LblCnt(iWork(ipBondAtomB +I))
*    &     (Index(LblCnt(iWork(ipBondAtomB +I)),':')+1:)
*         Atom_B = TLbl(iWork(ipBondAtomB +I))
          Write(6,'(8X,A,3X,A,3X,F7.3)')
     *     Atom_A, Atom_B, Work(ipBonds + I)
        End Do
      End If

      Write(6,'(6X,85A)')(Sign,i=1,85)

      If (iTriplBondNumb.gt.0) Then
        If (nSym.gt.1) then
          Write(6,'(6X,A)') Label3ASym
        Else
          Write(6,'(6X,A)') Label3ANoSym
        End If
        Do I=0, iTriplBondNumb -1
          Atom_A = LblCnt4(iWork(ipTriplAtomA +I))
          Atom_B = LblCnt4(iWork(ipTriplAtomB +I))
          Atom_C = LblCnt4(iWork(ipTriplAtomC +I))
          Write(6,'(8X,A,3X,A,3X,A,3X,F7.3)')
     &     Atom_A, Atom_B, Atom_C, Work(ipTripl + I)
        End Do

      Write(6,'(6X,85A)')(Sign,i=1,85)

      End if

      If (TotCoreElec.gt.Zero) Then
        Write(6,'(6X,A,F10.3,A)')
     &    'NBO located ', TotCoreElec, ' core electrons.'
      End If

      If (TotLoneElec.gt.Zero) Then
        Write(6,'(6X,A,F10.3,A)')
     &    'NBO located ', TotLoneElec, ' lone pair electrons.'
      End If

      If (TotBondElec.gt.Zero) Then
        Write(6,'(6X,A,F10.3,A,I4,A)')
     &    'NBO located ', TotBondElec, ' electrons involved in ',
     &     iBondNumb + iTriplBondNumb, ' bonds.'
      End If

      If (iSingNumb.gt.0) Then
        Do I = 0, iSingNumb - 1
          Atom_A = LblCnt4(iWork(ipSingElAtom +I))
          Write(6,'(6X,A,F10.3,A,A)')
     &      'NBO located ', Work(ipSingEl + I),
     &      ' non-bonded electrons on atom ', Atom_A

        End Do
      End If

      If (ElecNonAssgn.gt.0.0006) Then
        Write(6,'(6X,A,F8.3,A)')
     & 'The remaining ', ElecNonAssgn,
     & ' electrons are to be considered as diffuse'
*         Write(6,'(29X,A)')'diffuse on more than one bond.'
      ElseIf (ElecNonAssgn.lt.(Zero-0.01)) Then
        Write(6,'(6X,A)')
     &  'NBO analysis, and just that ONLY, did not converge to a'
        Write(6,'(6X,A)')
     &  'proper answer, sorry. Calculation will continue as normal.'
      End If

      Call CollapseOutput(0,'   Natural Bond Order analysis')
      Write(6,*)

*
*----------------------------------------------------------------------*
*     Deallocation of work                                             *
*----------------------------------------------------------------------*
*
      Call Free_Work(ipDS)
      Call Free_iWork(ip_center)
      Call Free_iWork(ipNBFpA)
      Call Free_iWork(ipBondAtomB)
      Call Free_iWork(ipBondAtomA)
      Call Free_Work(ipBonds)
      Call Free_Work(ipAll)
      Call Free_iWork(ipANr)

      If (SearchedSingle) Then
        Call Free_Work(ipSingEl)
        Call Free_iWork(ipSingElAtom)
      End If

      If (SearchedTriple) Then
        Call Free_Work(ipTripl)
        Call Free_iWork(ipTriplAtomA)
        Call Free_iWork(ipTriplAtomB)
        Call Free_iWork(ipTriplAtomC)
      End If

*
*----------------------------------------------------------------------*
*     That's All, Folks                                                *
*----------------------------------------------------------------------*
*
      Return

*
*----------------------------------------------------------------------*
*     Error Exits                                                      *
*----------------------------------------------------------------------*
*
991   Write(6,'(/6X,A)')
     &'The number of basis functions exceeds the present limit'
      Call Abend
      END
*
*----------------------------------------------------------------------*
*     Now for some subroutines                                         *
*----------------------------------------------------------------------*
*
*
*----------------------------------------------------------------------*
*     Seek n Destroy: search the sub matrix for eigen values >= Thrs   *
*     and deplete the corresponding scaled eigenvector from the main   *
*     matrix.                                                          *
*----------------------------------------------------------------------*
*
      Subroutine Seek_n_Destroy(nBasAtoms, nDimSubD, ipSubVal, ipSubVec,
     &           nBast, Threshold, ThrsD, TotElec, ipSubDNAOindex, ipDS,
     &          iWhat, ipAtomA, ipAtomB, iCounter, IAtom, JAtom, ipWhat,
     &                 ipAtomC, KAtom)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"

#include "Molcas.fh"
*

*define _DEBUGPRINT_

      Thrs = Threshold
      Thrs_Original = Threshold

*
*----------------------------------------------------------------------*
*     Now loop over the eigenvalues looking for orbitals >= Thrs


      Call Allocate_iWork(ipGood,nBasAtoms)
      Call Allocate_Work(ipEiVal,nBasAtoms)
      Call IZero(iWork(ipGood),nBasAtoms)
      Call FZero(Work(ipEiVal),nBasAtoms)

      iFoundOrb = 0
      iStHas2bFnd = 0
      TotElecCount = Zero
      TotElecAvail = Zero
      TotElecFound = Zero

      Do I = 1, nBasAtoms
          TotElecAvail = TotElecAvail + Work(ipSubVal+I-1)
      End Do

      If ((TotElecAvail.gt.2*ThrsD).AND.(iWhat.eq.1).AND.
     &                                 (Thrs.ge.1.999)) iStHas2bFnd = 1

      If (TotElecAvail.lt.Zero) Goto 666

#ifdef _DEBUGPRINT_
      Write(6,*)
      Write(6,*) 'Total electrons in eigenvalues = ', TotElecAvail
      Write(6,*) 'Something has to be found = ', iStHas2bFnd
#endif

      E=Zero
      Do K=1,NBAST
        E=E+Work(ipDS + (K-1) * NBAST + K -1)
      End Do

      If (E.lt.Zero) Goto 666

#ifdef _DEBUGPRINT_
      Write(6,*)
      Write(6,*)'Number of electrons as sum of the DS diagonal = ', E
#endif

*----------------------------------------------------------------------*
777   Continue
*----------------------------------------------------------------------*

      Do I = 1, nBasAtoms
          If ((Work(ipSubVal+I-1).gt.Thrs).AND.
     &        (Work(ipSubVal+I-1).le.ThrsD)) Then

*    One good orbital found
*    iFoundOrb: number of Good orbitals found
*    iWork(ipGood): which of the eigenvectors corresponds to the big
*                   eigenvalue
*    Work(ipEiVal): the big eigenvalue

            iFoundOrb = iFoundOrb + 1
            iWork(ipGood+iFoundOrb-1) = I
            Work(ipEiVal+iFoundOrb-1) = Work(ipSubVal+I-1)
*
*----It shouldn't be necessary, but in some cases (like radicals) a bit
*----more than 2 electrons are found in core or lone pair orbitals. This
*----way everything comes out cleaner. Possibly I'll try to remove this
*----later.
*
            If (Work(ipEiVal+iFoundOrb-1).gt.2)
     &          Work(ipEiVal+iFoundOrb-1) =  2

            TotElecFound = TotElecFound + Work(ipEiVal+iFoundOrb-1)
          End If
      End Do

#ifdef _DEBUGPRINT_
      If (TotElecFound.gt.TotElecAvail) Then
        Write(6,*)
        Write(6,*) 'Something fishy is going on'
        Write(6,*) 'iFoundOrb     = ', iFoundOrb
        Write(6,*) 'TotElecFound  = ', TotElecFound
        Write(6,*) 'TotElecAvail  = ', TotElecAvail
      End If
#endif

*
*----If we didn't find any bond, and something had to be found anyway,
*----we give it another try, with lower threshold, just once
*
      If ((iFoundOrb.eq.0).AND.(iStHas2bFnd.eq.1)) Then
        iStHas2bFnd = 0
*       Thrs = Thrs - 0.05
*       Thrs = Thrs - 0.01
        Thrs = Thrs - 0.005
        GoTo 777
      End If

      Thrs = Thrs_Original

      TotElecCount = TotElecFound - TotElecAvail

      If ((iFoundOrb.gt.0).AND.(TotElecCount.le.0.1)) Then

        TotElec = TotElec + TotElecFound

        If (iWhat.eq.1) Then
            iCounterOld  = iCounter
            iCounterTrue = iCounter

            If (iCounter.gt.0) Then
              iFound = -1
              Do I = 0, iCounter - 1
                If ((iWork(ipAtomA + I).eq.IAtom).AND.
     &              (iWork(ipAtomB + I).eq.JAtom))Then
                  iFound = I
                End If
              End Do
              If (iFound.ge.0) Then
                iCounterTrue = iFound
                iCounterOld  = iCounterOld -1
              End If
            End If

            iWork(ipAtomA + iCounterTrue) = IAtom
            iWork(ipAtomB + iCounterTrue) = JAtom
            Accumulate = Zero
            Do I = 1, iFoundOrb
              Accumulate = Accumulate + Work(ipEiVal+I-1)
            End Do
            Work(ipWhat + iCounterTrue) = Work(ipWhat + iCounterTrue) +
     &                                     (Accumulate/2)

#ifdef _DEBUGPRINT_
            Write(6,*)
            Write(6,*) 'NBO bond order between Atom ',
     &      iWork(ipAtomA + iCounterTrue), ' and Atom ',
     &      iWork(ipAtomB + iCounterTrue), ' is ',
     &      Work(ipWhat + iCounterTrue)
#endif

            iCounter = iCounterOld +1
        End If

        If (iWhat.eq.2) Then
          Do I = 1, iFoundOrb
            iWork(ipAtomA + iCounter) = IAtom
            Work(ipWhat + iCounter) = Work(ipEiVal+I-1)

#ifdef _DEBUGPRINT_
            Write(6,*)
            Write(6,*) 'NBO located ', Work(ipEiVal+I-1), ' electrons'
            Write(6,*) 'non bonding on atom ', iWork(ipAtomA + iCounter)
#endif

            iCounter = iCounter + 1
          End Do
        End If

        If (iWhat.eq.3) Then
          Do I = 1, iFoundOrb
            iWork(ipAtomA + iCounter) = IAtom
            iWork(ipAtomB + iCounter) = JAtom
            iWork(ipAtomC + iCounter) = KAtom
            Work(ipWhat + iCounter) = Work(ipEiVal+I-1)/2

#ifdef _DEBUGPRINT_
            Write(6,*)
            Write(6,*) 'NBO tricenter bond order between Atom ',
     &      iWork(ipAtomA + iCounter), ' and Atom ',
     &      iWork(ipAtomB + iCounter), ' and Atom ',
     &      iWork(ipAtomC + iCounter), ' is ',
     &      Work(ipWhat + iCounter)
#endif

            iCounter = iCounter + 1
          End Do
        End If


        Do I = 1, iFoundOrb
          Call Allocate_Work(ipScrM,nDimSubD)
          Call Allocate_Work(ipScrV,nBasAtoms)

          Call FZero(Work(ipScrM),nDimSubD)
          Call FZero(Work(ipScrV),nBasAtoms)

          Do J = 1, nBasAtoms
            Work(ipScrV+J-1) = Work(ipSubVec +
     &            (iWork(ipGood+I-1) - 1) * nBasAtoms + J - 1)
          End Do

#ifdef _DEBUGPRINT_
          Call RecPrt('Good orbital eigenvector',' ',Work(ipScrV),
     &                  nBasAtoms, 1)
#endif

          EigenNorm = DNORM2(nBasAtoms, Work(ipScrV), 1)

#ifdef _DEBUGPRINT_
          Write(6,*)
          Write(6,*)'Vector euclidean norm = ', EigenNorm
#endif

          Call DScal_(nBasAtoms,1/EigenNorm,Work(ipScrV),1)

#ifdef _DEBUGPRINT_
          Write(6,*)
          Call RecPrt('Normalized orbital eigenvector',' ',
     &                  Work(ipScrV), nBasAtoms, 1)
#endif



          Call DGEMM_('N','T',
     &                nBasAtoms,nBasAtoms,1,
     &                1.0d0,Work(ipScrV),nBasAtoms,
     &                Work(ipScrV),nBasAtoms,
     &                0.0d0,Work(ipScrM),nBasAtoms)

#ifdef _DEBUGPRINT_
          Call RecPrt('Multiplied Eigenvectors',' ',Work(ipScrM),
     &                  nBasAtoms, nBasAtoms)

              Write(6,*)'Eigen value to be multiplied = ',
     &                   Work(ipEiVal+I-1)
#endif

              Call DScal_(nDimSubD,Work(ipEiVal+I-1), Work(ipScrM),1)

#ifdef _DEBUGPRINT_
              Call RecPrt('Scaled Mult eigenvector',' ',Work(ipScrM),
     &                      nBasAtoms, nBasAtoms)
#endif

*
*     DS Matrix depletion not just along the diagonal
*

          Do J = 0, nDimSubD -1
            K = iWork(ipSubDNAOindex + J)
            Work(ipDS+K) = Work(ipDS+K) - Work(ipScrM+J)
          End Do

#ifdef _DEBUGPRINT_
          Call RecPrt('DS-NAO depleted Matrix = ', ' ',
     &         Work(ipDS), NBAST, NBAST)
          E=Zero
          Do K=1,NBAST
              E=E+Work(ipDS + (K-1) * NBAST + K -1)
          End Do
          Write(6,*)
          Write(6,*)'Number of electrons as sum of the DS diagonal = ',
     &               E
#endif

          Call Free_Work(ipScrV)
          Call Free_Work(ipScrM)
        End Do
      End If

666   Continue
      Call Free_iWork(ipGood)
      Call Free_Work(ipEiVal)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Not properly worked through. Do not use!
subroutine Mbpt2Corr(nBas,Cmo)

use qmstat_global, only: DenCorrD, iOrb, iPrint, Trace_MP2
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBas
real(kind=wp), intent(in) :: Cmo(nBas,nBas)
integer(kind=iwp) :: i, iB1, Ising, iT, j, kaunt1
real(kind=wp) :: Det
real(kind=wp), allocatable :: Diff(:), Inv(:,:), RedSq(:,:), SqD(:,:), SqE(:), TEMP(:,:)
#include "warnings.h"

write(u6,*)
write(u6,*) 'MP2 density correction is requested.'
write(u6,*) ' -- perturbative correlation correction to the solute density.'

! No-no zone!

write(u6,*)
write(u6,*) 'THIS OPTION IS NOT PROPERLY WORKED THROUGH! SHOULD NOT BE USED!'
call Quit(_RC_GENERAL_ERROR_)
! Check that the density difference is sound.
iT = nTri_Elem(nBas)
call mma_allocate(Diff,iT,Label='Diff')
call Get_D1ao(Diff,iT)
if (iPrint >= 10) call TriPrt('Non-reduced difference density matrix',' ',Diff,nBas)
! Transform density difference to orbital basis.
call mma_allocate(SqD,nBas,nBas,label='SqDenA')
call mma_allocate(SqE,nBas**2,label='SqDenM')
call mma_allocate(TEMP,nBas,nBas,label='TEMP')
call mma_allocate(Inv,nBas,nBas,label='Inv')
call mma_allocate(RedSq,nBas,nBas,label='RedSq')
! Do not forget the density matrix convention in Molcas.
call Dsq(Diff,SqD,1,nBas,nBas)
! Inverse of orbital file and transformation.
call Minv(Cmo,Inv,Ising,Det,nBas)
call Dgemm_('N','N',nBas,nBas,nBas,One,Inv,nBas,SqD,nBas,Zero,TEMP,nBas)
call Dgemm_('N','T',nBas,nBas,nBas,One,TEMP,nBas,Inv,nBas,Zero,SqE,nBas)
! Remove all except the suck-out orbitals.
do i=1,nBas
  do j=1,nBas
    if ((i <= iOrb(1)) .and. (j <= iOrb(1))) then
      RedSq(j,i) = SqE(j+(i-1)*nBas)
    else
      RedSq(j,i) = Zero
    end if
  end do
end do
! Make a check of the trace. Should be small.
Trace_MP2 = Zero
do iB1=1,nBas
  Trace_MP2 = Trace_MP2+RedSq(iB1,iB1)
end do
if (iPrint >= 10) then
  write(u6,*) 'Trace: ',Trace_MP2
end if
! Make things a bit more tidy.
kaunt1 = 0
do i=1,iOrb(1)
  do j=1,iOrb(1)
    kaunt1 = kaunt1+1
    SqE(kaunt1) = RedSq(j,i)
  end do
end do
call mma_allocate(DenCorrD,nTri_Elem(iOrb(1)),label='DenCorrD')
call SqToTri_q(SqE,DenCorrD,iOrb(1))

! Transform back if we want to keep things in AO-basis. Not
! used in QMSTAT at the present. If you wish, comment away the
! code below 'make things a bit more tidy' and you are in
! ready to rumble.
!call Dgemm_('N','N',nBas,nBas,nBas,One,Cmo,nBas,RedSq,nBas,Zero,TEMP,nBas)
!call Dgemm_('N','T',nBas,nBas,nBas,One,TEMP,nBas,Cmo,nBas,Zero,SqE,nBas)
!do i=1,nBas
!  do j=1,nBas
!    if (i /= j) SqE(j+(i-1)*nBas) = SqE(j+(i-1)*nBas)*Two
!  end do
!end do
!call SqToTri_q(SqE,TrDiffD,nBas)
!if (iPrint >= 10) call TriPrt('Reduced difference density matrix',' ',TrDiffD,nBas)

call mma_deallocate(Diff)
call mma_deallocate(SqD)
call mma_deallocate(SqE)
call mma_deallocate(TEMP)
call mma_deallocate(Inv)
call mma_deallocate(RedSq)

return

end subroutine Mbpt2Corr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETADDR(INFRED,INFVEC,MRED,MVEC,M2,MSYM)
C
C     Purpose: set first disk addresses for reduced set info and
C              vectors.
C
#include "implicit.fh"
      INTEGER INFRED(MRED), INFVEC(MVEC,M2,MSYM)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_SETADDR')

C     Set addresses.
C     --------------

      IF (XNPASS .EQ. 0) THEN
         INFRED(1) = 0
         DO ISYM = 1,NSYM
            INFVEC(1,3,ISYM) = 0
            INFVEC(1,4,ISYM) = 0
         END DO
      ELSE IF (XNPASS .GT. 0) THEN
         IRED  = 3
         IPASS = XNPASS
         KOFF1 = ip_NNBSTRSH + NSYM*NNSHL*(IRED - 1)
         KOFF2 = ip_INDRED   + MMBSTRT*(IRED - 1)
         CALL CHO_GETRED(IWORK(ip_INFRED),IWORK(KOFF1),
     &                   IWORK(KOFF2),IWORK(ip_INDRSH),IWORK(ip_iSP2F),
     &                   MAXRED,NSYM,NNSHL,MMBSTRT,IPASS,.FALSE.)
         CALL CHO_SETREDIND(IWORK(ip_IIBSTRSH),IWORK(ip_NNBSTRSH),
     &                      NSYM,NNSHL,IRED)
         IF (IPASS .EQ. 1) THEN
            INFRED(IPASS+1) = INFRED(IPASS)
     &                      + NSYM*NNSHL + 2*NNBSTRT(IRED) + NNSHL
         ELSE
            INFRED(IPASS+1) = INFRED(IPASS)
     &                      + NSYM*NNSHL + NNBSTRT(IRED)
         END IF
         DO ISYM = 1,NSYM
            IF (NUMCHO(ISYM) .EQ. 0) THEN
               INFVEC(1,3,ISYM) = 0
               INFVEC(1,4,ISYM) = 0
            ELSE IF (NUMCHO(ISYM) .GT. 0) THEN
               IF (CHO_ADRVEC .EQ. 1) THEN
                  JPASS = INFVEC(NUMCHO(ISYM),2,ISYM)
                  IF (JPASS .EQ. IPASS) THEN
                     INFVEC(NUMCHO(ISYM)+1,3,ISYM) =
     &               INFVEC(NUMCHO(ISYM),3,ISYM) + NNBSTR(ISYM,IRED)
                     INFVEC(NUMCHO(ISYM)+1,4,ISYM) =
     &               INFVEC(NUMCHO(ISYM),4,ISYM) + NNBSTR(ISYM,IRED)
                  ELSE IF (JPASS.LE.XNPASS .AND. JPASS.GT.0) THEN
                     IPASS = JPASS
                     KOFF1 = ip_NNBSTRSH + NSYM*NNSHL*(IRED - 1)
                     KOFF2 = ip_INDRED   + MMBSTRT*(IRED - 1)
                     CALL CHO_GETRED(IWORK(ip_INFRED),IWORK(KOFF1),
     &                               IWORK(KOFF2),IWORK(ip_INDRSH),
     &                               IWORK(ip_iSP2F),
     &                               MAXRED,NSYM,NNSHL,MMBSTRT,IPASS,
     &                               .FALSE.)
                     CALL CHO_SETREDIND(IWORK(ip_IIBSTRSH),
     &                                  IWORK(ip_NNBSTRSH),
     &                                  NSYM,NNSHL,IRED)
                     INFVEC(NUMCHO(ISYM)+1,3,ISYM) =
     &               INFVEC(NUMCHO(ISYM),3,ISYM) + NNBSTR(ISYM,IRED)
                     INFVEC(NUMCHO(ISYM)+1,4,ISYM) =
     &               INFVEC(NUMCHO(ISYM),4,ISYM) + NNBSTR(ISYM,IRED)
                  ELSE
                     CALL CHO_QUIT('[1] JPASS error in '//SECNAM,104)
                  END IF
               ELSE IF (CHO_ADRVEC .EQ. 2) THEN
                  JPASS = INFVEC(NUMCHO(ISYM),2,ISYM)
                  IF (JPASS .EQ. IPASS) THEN
                     LSA = NNBSTR(ISYM,IRED)
                     CALL CHO_MEM('SetAddr','ALLO','REAL',KSA,LSA)
                     IOPT = 2
                     IADR = INFVEC(NUMCHO(ISYM),3,ISYM)
                     CALL DDAFILE(LUCHO(ISYM),IOPT,WORK(KSA),LSA,IADR)
                     INFVEC(NUMCHO(ISYM)+1,3,ISYM) = IADR
                     INFVEC(NUMCHO(ISYM)+1,4,ISYM) =
     &                 INFVEC(NUMCHO(ISYM),4,ISYM) + NNBSTR(ISYM,IRED)
                     CALL CHO_MEM('SetAddr','FREE','REAL',KSA,LSA)
                  ELSE IF (JPASS.LE.XNPASS .AND. JPASS.GT.0) THEN
                     IPASS = JPASS
                     KOFF1 = ip_NNBSTRSH + NSYM*NNSHL*(IRED - 1)
                     KOFF2 = ip_INDRED   + MMBSTRT*(IRED - 1)
                     CALL CHO_GETRED(IWORK(ip_INFRED),IWORK(KOFF1),
     &                               IWORK(KOFF2),IWORK(ip_INDRSH),
     &                               IWORK(ip_iSP2F),
     &                               MAXRED,NSYM,NNSHL,MMBSTRT,IPASS,
     &                               .FALSE.)
                     CALL CHO_SETREDIND(IWORK(ip_IIBSTRSH),
     &                                  IWORK(ip_NNBSTRSH),
     &                                  NSYM,NNSHL,IRED)
                     LSA = NNBSTR(ISYM,IRED)
                     CALL CHO_MEM('SetAddr','ALLO','REAL',KSA,LSA)
                     IOPT = 2
                     IADR = INFVEC(NUMCHO(ISYM),3,ISYM)
                     CALL DDAFILE(LUCHO(ISYM),IOPT,WORK(KSA),LSA,IADR)
                     INFVEC(NUMCHO(ISYM)+1,3,ISYM) = IADR
                     INFVEC(NUMCHO(ISYM)+1,4,ISYM) =
     &                 INFVEC(NUMCHO(ISYM),4,ISYM) + NNBSTR(ISYM,IRED)
                     CALL CHO_MEM('SetAddr','FREE','REAL',KSA,LSA)
                  ELSE
                     CALL CHO_QUIT('[2] JPASS error in '//SECNAM,104)
                  END IF
               ELSE
                  CALL CHO_QUIT('CHO_ADRVEC error in '//SECNAM,102)
               END IF
            ELSE
               CALL CHO_QUIT('NUMCHO error in '//SECNAM,104)
            END IF
         END DO
      ELSE
         CALL CHO_QUIT('XNPASS error in '//SECNAM,104)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine DAN(Dens)

use Index_Functions, only: iTri, nTri_Elem
use Basis_Info, only: nBas
use pso_stuff, only: CMO, G1, nDens
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Dens(nDens)
#include "etwas.fh"
integer(kind=iwp) :: i, iB, iBas, iiB, ijB, ip1, ip2, ipCC, ipcm(0:7), ipD, iS, jB, jjB, na(0:7), ndenssq, nnA
real(kind=wp), allocatable :: Temp1(:), Temp2(:), Temp3(:)

ipD = 0
nnA = 0
ndenssq = 0
ipCC = 1
do i=0,nIrrep-1
  nDenssq = ndenssq+nBas(i)**2
  nA(i) = nnA
  ipcm(i) = ipCC
  nnA = nnA+nAsh(i)
  ipCC = ipCC+nBas(i)**2
end do

call mma_allocate(Temp1,nDensSQ,Label='Temp1')
call mma_allocate(Temp2,nDensSQ,Label='Temp2')
call mma_allocate(Temp3,nDensSQ,Label='Temp3')

do iS=0,nIrrep-1
  Temp1(:) = Zero
  if (nBas(is) > 0) then
    do iB=1,nAsh(iS)
      iiB = nA(iS)+iB
      do jB=1,nAsh(iS)
        jjB = nA(iS)+jB
        ijB = iTri(iiB,jjB)
        ip1 = nBas(iS)*(nISh(iS)+iB-1)+nIsh(is)+jb
        Temp1(ip1) = G1(ijB,1)
      end do
    end do

    call DGEMM_('N','N',nBas(is),nBas(is),nBas(is),One,CMO(ipCM(iS),1),nBas(is),Temp1,nBas(is),Zero,Temp3,nBas(is))
    call DGEMM_('N','T',nBas(is),nBas(is),nBas(is),One,Temp3,nBas(is),CMO(ipCM(is),1),nBas(is),Zero,Temp2,nBas(is))

    ip1 = 0
    ip2 = ipD
    do iBas=1,nBas(iS)
      Dens(ip2+1:ip2+iBas-1) = Two*Temp2(ip1+1:ip1+iBas-1)
      Dens(ip2+iBas) = Temp2(ip1+iBas)
      ip2 = ip2+iBas
      ip1 = ip1+nBas(iS)
    end do
    ipD = ipD+nTri_Elem(nBas(is))
  end if
end do

call mma_deallocate(Temp3)
call mma_deallocate(Temp2)
call mma_deallocate(Temp1)

return

end subroutine DAN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine Assemble_dTdmu(nZeta,Final,la,lb,Elalbp,Elalbm,Beta)
************************************************************************
*                                                                      *
* Object: to assemble the diamagnetic shielding integrals from         *
*         electric field integrals.                                    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             February '91                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8  Final (nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,3),
     &        Elalbp(nZeta,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2,3),
     &        Elalbm(nZeta,(la+1)*(la+2)/2,(lb  )*(lb+1)/2,3),
     &        Beta(nZeta)
      Character*80 Label
*
*     Statement function for cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
      nElem(ix) = (ix+1)*(ix+2)/2
*
      iRout = 231
      iPrint = nPrint(iRout)
*
*     Fact = -1.D6 * One2C2
      If (iPrint.ge.99) Then
          Write (6,*) ' In Assemble_dTdmu la,lb=',la,lb
          Do ia = 1, nElem(la)
             Do ib = 1, nElem(lb+1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalbp(',ia,',',ib,',x)'
                Call RecPrt(Label,' ',Elalbp(1,ia,ib,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalbp(',ia,',',ib,',y)'
                Call RecPrt(Label,' ',Elalbp(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalbp(',ia,',',ib,',z)'
                Call RecPrt(Label,' ',Elalbp(1,ia,ib,3),nZeta,1)
             End Do
          End Do
          Do ia = 1, nElem(la)
             ib_max=nElem(lb-1)
             If (lb.eq.0) ib_max=0
             Do ib = 1, ib_max
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalbm(',ia,',',ib,',x)'
                Call RecPrt(Label,' ',Elalbm(1,ia,ib,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalbm(',ia,',',ib,',y)'
                Call RecPrt(Label,' ',Elalbm(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Elalbm(',ia,',',ib,',z)'
                Call RecPrt(Label,' ',Elalbm(1,ia,ib,3),nZeta,1)
             End Do
          End Do
      End If
*
      Do ixa = la, 0, -1
         Do iya = la-ixa, 0, -1
            iza = la-ixa-iya
            ipa = Ind(la,ixa,iza)
*
      Do ixb = lb, 0, -1
         Do iyb = lb-ixb, 0, -1
            izb = lb-ixb-iyb
            ipb = Ind(lb,ixb,izb)
*
            Do iZeta = 1, nZeta
               xyTmp=-Two*Beta(nzeta)*Elalbp(iZeta,ipa,
     &                Ind(lb+1,ixb  ,izb  ),1)
               yxTmp=-Two*Beta(nzeta)*Elalbp(iZeta,ipa,
     &                Ind(lb+1,ixb+1,izb  ),2)
               yzTmp=-Two*Beta(nzeta)*Elalbp(iZeta,ipa,
     &                Ind(lb+1,ixb  ,izb+1),2)
               zyTmp=-Two*Beta(nzeta)*Elalbp(iZeta,ipa,
     &                Ind(lb+1,ixb  ,izb  ),3)
               zxTmp=-Two*Beta(nzeta)*Elalbp(iZeta,ipa,
     &                Ind(lb+1,ixb+1,izb  ),3)
               xzTmp=-Two*Beta(nzeta)*Elalbp(iZeta,ipa,
     &                Ind(lb+1,ixb  ,izb+1),1)
               If (ixb.ge.1) Then
                  yxTmp = yxTmp + Dble(ixb)*Elalbm(iZeta,ipa,
     &                                      Ind(lb-1,ixb-1,izb  ),2)
                  zxTmp = zxTmp + Dble(ixb)*Elalbm(iZeta,ipa,
     &                                      Ind(lb-1,ixb-1,izb  ),3)
               End If
               If (iyb.ge.1) Then
                  xyTmp = xyTmp + Dble(iyb)*Elalbm(iZeta,ipa,
     &                                      Ind(lb-1,ixb  ,izb  ),1)
                  zyTmp = xyTmp + Dble(iyb)*Elalbm(iZeta,ipa,
     &                                      Ind(lb-1,ixb  ,izb  ),3)
               End If
               If (izb.ge.1) Then
                  xzTmp = xzTmp + Dble(izb)*Elalbm(iZeta,ipa,
     &                                      Ind(lb-1,ixb  ,izb-1),1)
                  yzTmp = yzTmp + Dble(izb)*Elalbm(iZeta,ipa,
     &                                      Ind(lb-1,ixb  ,izb-1),2)
               End If
               Final(iZeta,ipa,ipb,1) = -(xyTmp - yxTmp)
               Final(iZeta,ipa,ipb,2) = -(yzTmp - zyTmp)
               Final(iZeta,ipa,ipb,3) = -(zxTmp - xzTmp)
            End Do
*
         End Do
      End Do
*
         End Do
      End Do
*
      If (iPrint.ge.49) Then
          Do iComp = 1, 3
             Write (Label,'(A,I2,A)') ' Final (',iComp,') '
             Call RecPrt(Label,' ',Final(1,1,1,iComp),nZeta,
     &                   nElem(la)*nELem(lb))
          End Do
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003-2005, Valera Veryazov                             *
!               2017, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DmpLLs(iDskPt)

use LnkLst, only: DmpLst, Init_LLs, LLDelt, LLdGrd, LLGrad, LLlGrd, LLx, LLy
use SCFFiles, only: LuDel, LuDgd, LuGrd, LulGd, Lux, Luy
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iDskPt(6)

if (Init_LLs) then
# ifdef _DEBUGPRINT_
  call StatLLs()
# endif
  call DmpLst(LLGrad,LuGrd,iDskPt(1))
  call DmpLst(LLlGrd,LulGd,iDskPt(2))
  call DmpLst(LLDgrd,LuDGd,iDskPt(3))
  call DmpLst(LLDelt,LuDel,iDskPt(4))
  call DmpLst(LLy,Lux,iDskPt(5))
  call DmpLst(LLx,Luy,iDskPt(6))
else
  write(u6,*) '****** W A R N I N G ! ******'
  write(u6,*) ' Linked list already killed!'
end if

return

end subroutine DmpLLs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine RWDTG(Num,DMat,lth,Option,DT,iDisk,MaxNum)
************************************************************************
*                                                                      *
* purpose: Read / write density matrix, two-electron hamiltonian       *
*          or gradient to the file if they are on disk / can't be      *
*          stored in core                                              *
*                                                                      *
* input:                                                               *
*   Num       - 'map number'                                           *
*   DMat(lth) - matrix to be written or read (Dens or TwoHam)          *
*   Option    - R- read, W- write                                      *
*   DT        - 'DENS  ', 'dVxcdR', 'TWOHAM', 'GRAD  '                 *
*   iDisk     - position in the file                                   *
*   MaxNum    - maximal number of density matrices that can be         *
*               stored on the disk                                     *
*                                                                      *
* output:                                                              *
*   DMat      - matrix read from the disk (if the option was read)     *
*                                                                      *
* called from: Diis, DMat, GetMat, GrdClc, MinDns, TraClc              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* written by:                                                          *
* P.O. Widmark, M.P. Fuelscher and P. Borowski                         *
* mod. by M. Schuetz                                                   *
* University of Lund, Sweden, 1992                                     *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Real*8 DMat(lth)
      Integer iDisk(MaxNum)
      Character Option,DT*6
#include "file.fh"

#include "SysDef.fh"


*
* Check Num; Subroutine is called with Num = - MapDns(i)
*
      If (Num.le.0) Then
         Write (6,*) 'RWDTG: Num.le.0'
         Write (6,*) 'Num=',Num
         Write (6,*) 'Wrong density number supplied.'
         Call Abend()
      End If
      If (Num.gt.MaxNum) Then
         Write (6,*) 'RWDTG: Num.gt.MaxNum'
         Write (6,*) 'Num,MaxNum=',Num,MaxNum
         Write (6,*) 'Wrong density number supplied.'
         Call Abend()
      End If

      If (DT.ne.'DENS  '.and.DT.ne.'TWOHAM'.and.DT.ne.'GRAD  ' .AND.
     &    DT.ne.'dVxcdR') Then
         Write (6,*) 'RWDTG: invalid value of DT'
         Write (6,*) '->DT<-=->',DT,'<-'
         Write (6,*) 'Valid values: "DENS  "'
         Write (6,*) '              "dVxcdR"'
         Write (6,*) '              "TWOHAM"'
         Write (6,*) '              "GRAD  "'
         Call Abend()
      End If

      If (Option.ne.'W'.and.Option.ne.'R') Then
         Write (6,*) 'RWDTG: invalid Option'
         Write (6,*) '->Option<-=->',Option,'<-'
         Write (6,*) 'Valid Options: R'
         Write (6,*) '               W'
      End If
*
      If (DT.eq.'DENS  ') Then
         LU =  LuDSt
      Else If (DT.eq.'TWOHAM') Then
         LU = LuTSt
      Else If (DT.eq.'GRAD  ') Then
         LU = LuGrd
      Else
         LU = LuOSt
      End If
*
      If (Option.eq.'W') Then
*
*        Write density matrix to DNS
*
         If (Num.eq.1) iDisk(Num) = 0
         jDisk = iDisk(Num)
         If (jDisk.eq.-1) Then
            Write (6,*) 'RWDTG: jDisk.eq.-1'
            Write (6,*) 'Num,MaxNum=',Num,MaxNum
            Write (6,*) 'The preceeding block was not written.'
            Call Abend()
         End If
         Call dDaFile(LU,1,DMat,lth,jDisk)
         If (Num + 1.le.MaxNum) iDisk(Num + 1) = jDisk
*
      Else If (Option.eq.'R') Then
*
*        Read density matrix from DNS
*
         jDisk = iDisk(Num)
         Call dDaFile(LU,2,DMat,lth,jDisk)
      End If

      end subroutine RWDTG

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Anders Bernhardsson                              *
!***********************************************************************

subroutine MCLR(ireturn)
!***********************************************************************
!                                                                      *
!               #     #  #####     #       ######                      *
!               ##   ## #     #    #       #     #                     *
!               # # # # #          #       #     #                     *
!               #  #  # #          #       ######                      *
!               #     # #          #       #   #                       *
!               #     # #     #    #       #    #                      *
!               #     #  #####     ####### #     #                     *
!                                                                      *
!     A linear response function program for general RASSCF states     *
!                                                                      *
!      OK right now we can just handle CASSCF, but the only thing      *
!      we need is yet another stupid PhD student who wants to code     *
!      the preconditioning elements between active and active orbitals *
!                                                                      *
!      The spin correction part of the code is a experimental          *
!      test platform, it is not finished and is not working,           *
!      If someone wants to help me finishing it please contact me      *
!                                                                      *
!                                                                      *
!   "Real programmers don't comment their codes.                       *
!    It was hard to write, and it must be hard to understand..."       *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use External_Centers, only: External_Centers_Free
use Symmetry_Info, only: Symmetry_Info_Free
use Str_Info, only: CFTP, CNSM, DFTP, DTOC
use ipPage, only: ipclose
use MCLR_Data, only: CMO, CMO_Inv, Do_Hybrid, F0SQMO, FAMO, FAMO_SpinM, FAMO_SpinP, FIMO, Fm, Fp, G1m, G1p, G1t, G2mm, G2mp, G2pp, &
                     G2sq, G2t, Hss, iAllo, Int1, INT2, LuPT2, nA, nAcPar, nAcPr2, NACSTATES, nNA, nrec, PDFT_Ratio, pINT1, pINT2, &
                     SA, SFock, SS, WF_Ratio
use PCM_grad, only: PCM_grad_final
use dmrginfo, only: DoDMRG, DoMCLR, RGRAS2
use input_mclr, only: double, Fail, iMCPD, iMethod, iMSPD, LuAChoVec, LuChoInt, LuIChoVec, McKinley, nAsh, nDisp, NewCho, nRS2, &
                      nSym, ntAsh, ntASqr, ntAtri, PT2, RASSI, SpinPol, StepType, TimeDep, TwoStep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(out) :: iReturn
#include "warnings.h"
integer(kind=iwp) :: CMSNACStates(2), I, iPL, iRC, istatus, iSym, LuInput, LuSpool2, nISP, nSymX
logical(kind=iwp) :: CalcNAC_Opt, converged(8), DoCholesky, Exists, MECI_via_SLAPAF
character(len=180) :: Line
character(len=128) :: FileName
character(len=16) :: StdIn
character(len=8) :: Method
real(kind=wp) :: TCPU1, TCPU2, TCPU3, TWall1, TWall2, TWall3
integer(kind=iwp), allocatable :: ifpCI(:), ifpK(:), ifpRHS(:), ifpRHSCI(:), ifpS(:), ifpSC(:)
integer(kind=iwp), external :: get_MBl_wa, iPrintLevel, isFreeUnit
logical(kind=iwp), external :: Reduce_Prt, RF_On

! This used to be after the CWTIME() functional call
!                                                                      *
!***********************************************************************
!                                                                      *
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = iPL-1
!                                                                      *
!***********************************************************************
!                                                                      *
! This is where you should put the information for CMS
call Get_cArray('Relax Method',Method,8)
if (Method == 'MSPDFT') then
  call Get_iArray('cmsNACstates',cmsNACstates,2)
  call Get_iArray('NACstatesOpt',NACstates,2)
  call Get_lscalar('CalcNAC_Opt',CalcNAC_Opt)
  call Get_lscalar('MECI_via_SLAPAF',MECI_via_SLAPAF)

  if (.not. MECI_via_SLAPAF) then
    if ((cmsNACstates(1) /= NACstates(1)) .or. (cmsNACstates(2) /= NACstates(2))) NACstates(:) = cmsNACstates(:)
  end if

  if ((cmsNACstates(1) /= NACstates(1)) .or. (cmsNACstates(2) /= NACstates(2))) then
    if (iPL >= 3) then
      write(u6,*)
      write(u6,*) 'MS-PDFT Potentials for root(s)'
      write(u6,*) cmsNACstates(1),cmsNACstates(2)
      write(u6,*) 'MCLR Lag. Mult. for root'
      write(u6,*) NACstates(1),NACstates(2)
      write(u6,*) 'MS-PDFT roots and MCLR roots do not match'
      write(u6,*) 'MCLR requests MCPDFT to be run before'
      write(u6,*) 'it states again'
      write(u6,*)
    end if

    LuInput = 11
    LuInput = IsFreeUnit(LuInput)
    call StdIn_Name(StdIn)
    call Molcas_open(LuInput,StdIn)

    write(LuInput,'(A)') '>ECHO OFF'
    write(LuInput,'(A)') '>export MCLR_OLD_TRAP=$MOLCAS_TRAP'
    write(LuInput,'(A)') '>export MOLCAS_TRAP=ON'

    write(LuInput,'(A)') ' &MCPDFT &END'
    write(LuInput,'(A)') ' KSDFT=T:PBE'
    write(LuInput,'(A)') ' MSPDft'
    write(LuInput,'(A)') ' GRAD'
    if (NACstates(2) /= 0) then
      write(LuInput,'(A)') 'NAC'
      write(LuInput,'(I5,1X,I5)') NACstates(1),NACstates(2)
      if (CalcNAC_Opt) write(LuInput,'(A)') 'MECI'
    end if
    write(LuInput,'(A)') 'End of Input'
    write(LuInput,'(A)') ''

    FileName = 'MCLRINP'
    call f_inquire(Filename,Exists)

    if (Exists) then
      LuSpool2 = 77
      LuSpool2 = IsFreeUnit(LuSpool2)
      call Molcas_Open(LuSpool2,Filename)
      do
        read(LuSpool2,'(A)',iostat=istatus) Line
        if (istatus > 0) call Abend()
        if (istatus < 0) exit
        write(LuInput,'(A)') Line
      end do
      close(LuSpool2)
    else
      write(LuInput,'(A)') ' &MCLR &End'
    end if

    write(LuInput,'(A)') '>export MOLCAS_TRAP=$MCLR_OLD_TRAP'
    write(LuInput,'(A)') '>ECHO ON'
    close(LuInput)
    call Finish(_RC_INVOKED_OTHER_MODULE_)
  end if
end if

! check the status; if quantities needed for MCLR have not been
! computed, call CASPT2
if (Method == 'CASPT2') call check_caspt2(0)
!                                                                      *
!***********************************************************************
!                                                                      *
!call MCLR_banner()
call CWTime(TCpu1,TWall1)
!                                                                      *
!***********************************************************************
!                                                                      *
iAllo = 0
!idp = RtoI
nrec = get_MBl_wa()/RtoB

call DecideOnCholesky(DoCholesky)
call get_iScalar('nSym',nSymX)

if (DoCholesky .and. (nSymX > 1)) then
  write(u6,*) '** Cholesky or RI/DF not implemented with symmetry **'
  call Quit(_RC_INPUT_ERROR_)
end if

call Init_Data()

doDMRG = .false.
doMCLR = .false.
!#ifdef _DMRG_
! read dmrg parameters for mclr part
!call read_dmrg_parameter_for_mclr()
!if (doDMRG) then
!  doMCLR = .true.
!  write(u6,*) 'ndets_RGLR : ',ndets_RGLR
!  write(u6,*) 'nstates_RGLR ',nstates_RGLR
!  write(u6,*) 'RGras2 : ',RGras2
!  write(u6,*) 'LRras2 : ',LRras2
!  open(unit=117,file='mclr_dets.initial')
!end if
!#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! open files

call OpnFls_MCLR(iPL)
!                                                                      *
!***********************************************************************
!                                                                      *
! Read input

call InpCtl_MCLR(iPL)
!                                                                      *
!***********************************************************************
!                                                                      *
! Transform integrals and calculate fock matrixes etc.

if (doDMRG) then  ! yma
  nAsh(:) = RGras2(:)
  nrs2(:) = RGras2(:)
end if
ntAsh = sum(nAsh(1:nSym))
ntAsqr = sum(nAsh(1:nSym)**2)
ntAtri = 0
nnA = 0
do iSym=1,nSym
  ntAtri = ntAtri+nTri_Elem(nAsh(iSym))
  nA(iSym) = nna
  nnA = nnA+nAsh(isym)
end do
nacpar = nTri_Elem(nnA)
nacpr2 = nTri_Elem(nacpar)

call Start_MCLR()

nisp = max(8,nDisp)
!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TCpu2,TWall2)
!                                                                      *
!***********************************************************************
!                                                                      *
! File pointers

call mma_allocate(ifpK,nisp,Label='ifpK')
ifpK(:) = -1
call mma_allocate(ifpS,nisp,Label='ifpS')
ifpS(:) = -1
call mma_allocate(ifpRHS,nisp,'ifpRHS')
ifpRHS(:) = -1
if (iMethod == 2) then
  call mma_allocate(ifpCI,nisp,Label='ifpCI')
  call mma_allocate(ifpSC,nisp,Label='ifpSC')
  call mma_allocate(ifpRHSCI,nisp,Label='ifpRHSCI')
else
  call mma_allocate(ifpCI,1,Label='ifpCI')
  call mma_allocate(ifpSC,1,Label='ifpSC')
  call mma_allocate(ifpRHSCI,1,Label='ifpRHSCI')
end if
ifpCI(:) = -1
ifpSC(:) = -1
ifpRHSCI(:) = -1
!                                                                      *
!***********************************************************************
!                                                                      *
! Calculate response

! Output is stored on disk

if (SPINPOL) then
  call WfCtl_SP(ifpK,ifpS,ifpCI,ifpSC,ifpRHS,ifpRHSCI)
!else if (ELECHESS) then
!  call WfCtl_PCG(ifpK,ifpS,ifpCI,ifpSC,ifpRHS,ifpRHSCI)
!  call Abend()
else if (iMCPD) then !pdft

  Do_Hybrid = .false.
  call qpg_DScalar('R_WF_HMC',Do_Hybrid)
  if (Do_Hybrid) then
    call Get_DScalar('R_WF_HMC',WF_Ratio)
    PDFT_Ratio = One-WF_Ratio
  end if

  if (iMSPD) then
    if (Do_Hybrid) then
      call WarningMessage(2,'Hybrid MS-PDFT gradient not supported yet')
      call Quit(_RC_EXIT_EXPECTED_)
    end if
    call WfCtl_MSPD(ifpK,ifpS,ifpCI,ifpSC,ifpRHS,converged,iPL)
  else
    call WfCtl_PDFT(ifpK,ifpS,ifpCI,ifpSC,ifpRHS,converged,iPL)
  end if
else if (SA .or. PT2) then
  call WfCtl_SA(ifpK,ifpS,ifpCI,ifpSC,ifpRHS,converged,iPL)
else if (TimeDep) then
  call WfCtl_td(ifpK,ifpS,ifpCI,ifpSC,ifpRHS,ifpRHSCI,converged)
else
  call WfCtl_Hess(ifpK,ifpS,ifpCI,ifpSC,ifpRHS,ifpRHSCI,converged)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Contract response to hessian etc

if (.not. (TwoStep .and. (StepType == 'RUN1'))) then
  if (PT2 .or. SA .or. iMCPD) then
    call Out_PT2(ifpK,ifpCI)
    if (PT2) close(LUPT2) !! this file is opend in wfctl_sa
  else if (TimeDep) then
    call Output_td(ifpK,ifpS,ifpCI,ifpSC,ifpRHS,ifpRHSCI,converged)
  else
    call Output_mclr(ifpK,ifpS,ifpCI,ifpSC,ifpRHS,ifpRHSCI,converged)
    if (mckinley) call isoloop(double)
  end if

  if (RASSI) call OutRAS(ifpK,ifpCI)

  if (TimeDep) call OutRAS_td(ifpK,ifpCI)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call ClsSew() ! corresponds to IniSew in RdInp_MCLR
call Symmetry_Info_Free()
call External_Centers_Free()
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate memory

! Arrays in csf.f
if (iMethod == 2) then
  call mma_deallocate(DTOC)
  call mma_deallocate(CFTP)
  call mma_deallocate(DFTP)
end if
do i=1,size(CNSM)
  call mma_deallocate(CNSM(i)%ICONF,safe='*')
  call mma_deallocate(CNSM(i)%ICTS,safe='*')
end do

! Free arrays allocated by memstr.f
if (iMethod == 2) call FreeStr()
! Arrays in inpone.f
call mma_deallocate(INT1)
! Arrays in detctl.f
if (iMethod == 2) then
  call mma_deallocate(pINT2)
  call mma_deallocate(pINT1)
end if

! Array in rdab.f
if (iMethod == 1) call mma_deallocate(CMO)
! Arrays in rdjobip_td.f and rdjobiph.f
if (iMethod == 2) then
  call mma_deallocate(G2t)
  if (Timedep) call mma_deallocate(G2sq)
  call mma_deallocate(G1t)
  call mma_deallocate(CMO)
end if

! Arrays allocated in stpert.f
call mma_deallocate(Hss)
if (SPINPOL) then
  call mma_deallocate(FAMO_SpinP)
  call mma_deallocate(FAMO_SpinM)
  call mma_deallocate(G2mm)
  call mma_deallocate(G2mp)
  call mma_deallocate(G2pp)
  call mma_deallocate(Fp)
  call mma_deallocate(Fm)
  call mma_deallocate(G1p)
  call mma_deallocate(G1m)
  call mma_deallocate(SFock)
end if
! Arrays allocated in fckmat.f
call mma_deallocate(FAMO)
call mma_deallocate(Int2)
call mma_deallocate(FIMO)
call mma_deallocate(F0SQMO)

call mma_deallocate(ifpRHSCI)
call mma_deallocate(ifpSC)
call mma_deallocate(ifpCI)
call mma_deallocate(ifpRHS)
call mma_deallocate(ifpS)
call mma_deallocate(ifpK)
call mma_deallocate(SS,safe='*')

! Close files

call ClsFls_MCLR()
if (RF_On() .and. (SA .or. PT2)) then
  call Free_RctFld()
  call PCM_grad_final()
end if

if (NewCho) then
  call Cho_X_Final(irc)
  do i=1,nSym
    call DACLOS(LuAChoVec(i))
    call DACLOS(LuIChoVec(i))
  end do
  call DACLOS(LuChoInt(1))
  call DACLOS(LuChoInt(2))
  call mma_deallocate(CMO_Inv)
end if

call ipclose(-1)
!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. fail) then
  if (iPL >= 2) then
    write(u6,*)
    write(u6,'(6X,A)') 'The response parameters are written to the file RESP.'
  end if
  ireturn = _RC_ALL_IS_WELL_
else
  ireturn = _RC_NOT_CONVERGED_
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TCpu3,TWall3)
if (iPL >= 3) then
  write(u6,*)
  write(u6,'(2X,A)') 'Timings'
  write(u6,'(2X,A)') '-------'
  write(u6,*)
  write(u6,'(2X,A)') '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,'(2X,A,T44,A,A,A)') ' ',' ','    CPU time','     elapsed'
  write(u6,'(2X,A,T44,A,2F12.2)') '1) Initialization',':',TCpu2-TCpu1,TWall2-TWall1
  write(u6,'(2X,A,T44,A,2F12.2)') '2) Response calculation',':',TCpu3-TCpu2,TWall3-TWall2
  write(u6,'(2X,A)') '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,'(2X,A,T44,A,2F12.2)') 'Total',':',TCpu3-TCpu1,TWall3-TWall1
  write(u6,'(2X,A)') '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'

end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (iPL >= 3) call FastIO('STATUS')
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Francesco Aquilante                              *
!***********************************************************************

subroutine Delete_Ghosts(irc,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,BName,nUniqAt,ThrS,isCASPT2,CMO,EOrb)
!***********************************************************************
!                                                                      *
! Purpose:  Eliminates MOs of ghost atoms from PT2 treatment           *
!                                                                      *
! Author:   F. Aquilante  (Geneva, July 2010)                          *
!                                                                      *
!***********************************************************************

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nFro(nSym), nIsh(nSym), nAsh(nSym), nUniqAt
integer(kind=iwp), intent(inout) :: nSsh(nSym), nDel(nSym)
character(len=LenIn8), intent(in) :: BName(*)
real(kind=wp), intent(in) :: ThrS
logical(kind=iwp), intent(in) :: isCASPT2
real(kind=wp), intent(inout) :: CMO(*), EOrb(*)
integer(kind=iwp) :: i, ia, iAt, iCMO, ik, iOff, iSym, isymlbl, iv, j, jBas, jOff, jZ, kBas, kCMO, lBas, mAsh, n_KO, n_OK(nSym), &
                     nActa, nBa, nBasT, nBax, nBmx, nBx, NCMO, nOkk, nSmx
character(len=LenIn) :: tmp
type(DSBA_Type) :: LCMO, S, SQ
integer(kind=iwp), allocatable :: iD(:), nBas_per_Atom(:), nBas_Start(:)
real(kind=wp), allocatable :: Q(:,:), Qa(:), Qt(:)
real(kind=wp), allocatable, target :: Ct(:), St(:), Xt(:), Zt(:)
real(kind=wp), pointer :: C(:,:), S2(:,:), X(:,:), Z(:,:)
character(len=LenIn), allocatable :: NamAct(:)
real(kind=r8), external :: ddot_

irc = 0

!----------------------------------------------------------------------*
!     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
!----------------------------------------------------------------------*

nBasT = 0
nBmx = 0
nSmx = 0
mAsh = 0
do i=1,nSym
  nBasT = nBasT+nBas(i)
  nBmx = max(nBmx,nBas(i))
  nSmx = max(nSmx,nSsh(i))
  mAsh = max(mAsh,nIsh(i)+nAsh(i))
end do
if (nBasT > mxBas) then
  write(u6,'(/6X,A)') 'The number of basis functions exceeds the present limit'
  call Abend()
end if

! nUniqAt = # of symm. unique atoms. Initialize NamAct to blanks.
! ---------------------------------------------------------------

if ((nUniqAt < 1) .or. (nUniqAt > MxAtom)) then
  write(u6,'(A,I9)') 'nUniqAt =',nUniqAt
  call Abend()
end if
call mma_allocate(NamAct,nUniqAt,label='NamAct')
NamAct(:) = ' '

! Allocate and get index arrays for basis functions per atom.
! -----------------------------------------------------------

call mma_allocate(nBas_per_Atom,nUniqAt,label='nB_per_Atom')
call mma_allocate(nBas_Start,nUniqAt,label='nB_Start')

!----------------------------------------------------------------------*
!     Read the overlap matrix                                          *
!----------------------------------------------------------------------*
call Allocate_DT(SQ,nBas,nBas,nSym,label='SMAT')
call Allocate_DT(S,nBas,nBas,nSym,aCase='TRI',label='SLT')
isymlbl = 1
call RdOne(irc,6,'Mltpl  0',1,S%A0,isymlbl)
if (irc /= 0) return
do iSym=1,nSym
  call Square(S%SB(iSym)%A1,SQ%SB(iSym)%A2,1,nBas(iSym),nBas(iSym))
end do
call Deallocate_DT(S)

call Allocate_DT(LCMO,nBas,nBas,nSym,label='LCMO')
NCMO = size(LCMO%A0)
LCMO%A0(:) = CMO(1:NCMO)

!----------------------------------------------------------------------*
!     Compute Mulliken atomic charges of each occupied orbital         *
!             on each center to define the Active Site                 *
!----------------------------------------------------------------------*
call mma_allocate(Q,nUniqAt,mAsh,label='Qai')
call mma_allocate(Qa,nUniqAt,label='Qa')
Qa(:) = Zero
call mma_allocate(Zt,nBmx*mAsh,label='Zm')
lBas = 0
do iSym=1,nSym
  nOkk = nIsh(iSym)+nAsh(iSym)
  nBx = max(1,nBas(iSym))
  Z(1:nBas(iSym),1:nOkk) => Zt(1:nBas(iSym)*nOkk)
  call DGEMM_('N','N',nBas(iSym),nOkk,nBas(iSym),One,SQ%SB(iSym)%A2,nBx,LCMO%SB(iSym)%A2(:,nFro(iSym)+1:),nBx,Zero,Z,nBx)
  jBas = lBas+1
  kBas = lBas+nBas(iSym)
  call BasFun_Atom_Sym(nBas_per_Atom,nBas_Start,BName,jBas,kBas,nUniqAt,.false.)
  do ik=1,nOkk
    do iAt=1,nUniqAt
      Q(iAt,ik) = ddot_(nBas_per_Atom(iAt),LCMO%SB(iSym)%A2(nBas_Start(iAt):,nFro(iSym)+ik),1,Z(nBas_Start(iAt):,ik),1)
    end do
  end do
  do iAt=1,nUniqAt
    Qa(iAt) = Qa(iAt)+ddot_(nOkk,Q(iAt,:),1,Q(iAt,:),1)
    if (sqrt(Qa(iAt)) >= ThrS) then
      if (nBas_per_Atom(iAt) > 0) NamAct(iAt) = BName(lBas+nBas_Start(iAt))(1:LenIn)
    end if
  end do
  lBas = lBas+nBas(iSym)
end do
nullify(Z)
call mma_deallocate(Zt)
call mma_deallocate(Q)
call mma_deallocate(Qa)

! We have now completed the definition of the active site
!----------------------------------------------------------------------*
call mma_allocate(iD,nUniqAt,label='ID_A')
nActa = 0
do iAt=1,nUniqAt
  if (NamAct(iAt)(1:4) /= ' ') then
    nActa = nActa+1
    iD(nActa) = iAt
  end if
end do
do iAt=1,nActa
  NamAct(iAt) = NamAct(iD(iAt))
end do
do iAt=nActa+1,nUniqAt
  NamAct(iAt)(1:4) = ' '
end do
write(u6,*)
write(u6,'(A,F6.3)') ' Threshold for atom selection: ',ThrS
write(u6,*)
if (nActa /= 0) then
  write(u6,'(A,I3,A)') ' Selected ',nActa,' atoms: '
  write(u6,*)
  write(u6,*) NamAct(1:nActa)
  write(u6,*)
else
  write(u6,*) ' None of the occupied non-frozen orbitals has been '
  write(u6,*) ' assigned to the Active region of the molecule.    '
  write(u6,*) ' This is presumably NOT what you want !!!          '
  write(u6,*) ' I will Stop here. Bye Bye !! '
  write(u6,*)
  call Abend()
end if

call mma_deallocate(iD)
call mma_deallocate(nBas_per_Atom)
call mma_deallocate(nBas_Start)

!----------------------------------------------------------------------*
!     Virtual orbital selection                                        *
!----------------------------------------------------------------------*
call mma_allocate(iD,nBmx+2*nSmx,label='ID_vir')
call mma_allocate(St,nBmx**2,label='St')
call mma_allocate(Qt,nSmx,label='Qt')
call mma_allocate(Ct,nBmx*nSmx,label='Ct')
call mma_allocate(Zt,nBmx*nSmx,label='Zt')
call mma_allocate(Xt,nBmx*nSmx,label='Xt')

iOff = 0
do iSym=1,nSym

  nBa = 0
  do ia=1,nBas(iSym)
    tmp = BName(iOff+ia)(1:LenIn)
    do j=1,nActa
      if (NamAct(j) == tmp) then
        nBa = nBa+1
        iD(nBa) = ia
      end if
    end do
  end do

  C(1:nBa,1:nSsh(iSym)) => Ct(1:nBa*nSsh(iSym))
  S2(1:nBas(iSym),1:nBa) => St(1:nBas(iSym)*nBa)
  X(1:nBas(iSym),1:nSsh(iSym)) => Xt(1:nBa*nSsh(iSym))
  Z(1:nBas(iSym),1:nSsh(iSym)) => Zt(1:nBa*nSsh(iSym))

  iCMO = nFro(iSym)+nIsh(iSym)+nAsh(iSym)+1
  do ia=1,nBa
    C(ia,:) = LCMO%SB(iSym)%A2(iD(ia),iCMO:)
    S2(:,ia) = SQ%SB(iSym)%A2(:,iD(ia))
  end do

  nBx = max(1,nBas(iSym))
  nBax = max(1,nBa)
  call DGEMM_('T','N',nBa,nSsh(iSym),nBas(iSym),One,S2,nBx,LCMO%SB(iSym)%A2(:,iCMO:),nBx,Zero,Z,nBax)
  do i=1,nSsh(iSym)
    Qt(i) = ddot_(nBa,C(:,i),1,Z(:,i),1)**2
  end do
  n_OK(iSym) = 0
  n_KO = 0
  do i=1,nSsh(iSym)
    if (sqrt(Qt(i)) >= ThrS) then
      n_OK(iSym) = n_OK(iSym)+1
      X(:,n_OK(iSym)) = LCMO%SB(iSym)%A2(:,iCMO+i-1)
      iD(nBmx+n_OK(iSym)) = i
    else
      n_KO = n_KO+1
      Z(:,n_KO) = LCMO%SB(iSym)%A2(:,iCMO+i-1)
      iD(nBmx+nSmx+n_KO) = i
    end if
  end do

  LCMO%SB(iSym)%A2(:,iCMO:iCMO+n_OK(iSym)-1) = X(:,1:n_OK(iSym))
  kCMO = iCMO+n_OK(iSym)
  LCMO%SB(iSym)%A2(:,kCMO:) = Z(:,1:n_KO)
  if (.not. isCASPT2) then
    jZ = 1
    jOff = iOff+nFro(iSym)+nOkk
    do i=nBmx+1,nBmx+n_OK(iSym)
      iv = jOff+iD(i)
      Z(jZ,1) = EOrb(iv)
      jZ = jZ+1
    end do
    do i=nBmx+nSmx+1,nBmx+nSmx+n_KO
      iv = jOff+iD(i)
      Z(jZ,1) = EOrb(iv)
      jZ = jZ+1
    end do
    EOrb(jOff+1:jOff+nSsh(iSym)) = Z(1:nSsh(iSym),1)
  end if

  iOff = iOff+nBas(iSym)
end do
nullify(C)
nullify(S2)
nullify(X)
nullify(Z)
call mma_deallocate(St)
call mma_deallocate(Qt)
call mma_deallocate(Ct)
call mma_deallocate(Zt)
call mma_deallocate(Xt)
call mma_deallocate(iD)
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Update nSsh, nDel for the Active site PT2
nDel(:) = nDel(:)+nSsh(:)-n_OK(:)
nSsh(:) = n_OK(:)

CMO(1:NCMO) = LCMO%A0

call Deallocate_DT(SQ)
call Deallocate_DT(LCMO)
call mma_deallocate(NamAct)

return

end subroutine Delete_Ghosts

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Tully_variables

use Definitions, only: wp, iwp

implicit none
private

logical(kind=iwp) :: tullyL, decoherence, tullySubVerb, fixedrandL, iseedL, rassi_ovlp, Run_rassi, firststep
real(kind=wp) :: DECO, Ethreshold, RandThreshold, FixedRand
integer(kind=iwp) :: NSUBSTEPS, InitSeed

public :: tullyL, decoherence, tullySubVerb, fixedrandL, iseedL, DECO, Ethreshold, RandThreshold, FixedRand, NSUBSTEPS, InitSeed, &
          rassi_ovlp, Run_rassi, firststep

end module

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995,1998, Niclas Forsberg                             *
!               1995,1998,1999, Anders Bernhardsson                    *
!***********************************************************************

!module TabMod

!  Contains:
!    MakeTab   (m_max,maxOrd,maxIncOrd,mMat,mInc,mDec)
!    MakeTab2  (m_max,maxOrd,maxIncOrd,msiz,mMat,mInc,mDec)
!    TabDim    (nDim,nOsc) Result(nTabDim)
!    iDetNr    (iocc,graph,nOsc,m_max)  Result(iDetNr)
!    Mul1      (nMat,F,iCre,iAnn,mat,rdx)
!    Mul2      (nMat,F,iCre,iAnn,mat,rdx)
!    Mul3      (nMat,F,iCre,iAnn,mat,rdx)
!    Mul4      (nMat,F,iCre,iAnn,mat,rdx)
!
!  Written by:
!    Niclas Forsberg & Anders Bernhardsson,
!    Dept. of Theoretical Chemistry, Lund University, 1995&1998.

!contains

subroutine MakeTab(m_max,maxOrd,maxIncOrd,mMat,mInc,mDec,nOsc)
!  Purpose:
!    Create tables used in FCval.
!
!  Input:
!    nOsc      : Integer - the the number of oscillators.
!    m_max     : Integer - the maximum sum of the quantum numbers.
!    maxOrd    : Integer - number of rows in mMat.
!    nTabDim   : Integer
!    Osc_Shift : Integer array
!
!  Output:
!    mMat      : Two dimensional integer array
!    mInc      : Two dimensional integer array
!    mDec      : Two dimensional integer array
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: m_max, nOsc
integer(kind=iwp), intent(inout) :: maxOrd
integer(kind=iwp), intent(out) :: maxIncOrd, mMat(0:maxOrd,nOsc), mInc(0:maxOrd,nOsc), mDec(0:maxOrd,nOsc)
integer(kind=iwp) :: i, irow, istart_row, j, jcol, jmax, jrow, k, l, m, mMat_row, mTempDim, n, num, numtemp
logical(kind=iwp) :: equal
integer(kind=iwp), allocatable :: mTemp(:,:), row(:), unitm(:,:)

! Initialize.
maxOrd = 0
maxIncOrd = 0
mMat(:,:) = 0
mInc(:,:) = 0
mDec(:,:) = 0
if (m_max == 0) return
if (nOsc == 1) then
  mTempDim = m_max
else
  mTempDim = (1-nOsc**(m_max+1))/(1-nOsc)
end if
call mma_allocate(mTemp,[0,mTempDim],[1,nOsc],label='mTemp')

call mma_allocate(row,nOsc,label='row')

mTemp(:,:) = 0
num = 1
istart_row = 0
irow = istart_row+1
call mma_allocate(unitm,nOsc,nOsc,label='unit')
unitm(:,:) = 0
do i=1,nOsc
  unitm(i,i) = 1
end do

! Create table mMat.
mMat_row = 1
do m=1,m_max
  irow = 1
  numtemp = 0
  ! Produce all combinations for a given total sum = m_max.
  do n=1,num
    do jrow=1,nOsc
      do jcol=1,nOsc
        mTemp(irow,jcol) = mMat(istart_row,jcol)+unitm(jrow,jcol)
      end do
      irow = irow+1
      numtemp = numtemp+1
    end do
    istart_row = istart_row+1
  end do
  num = numtemp
  ! Remove all entries which occur more than once.
  do i=1,num
    !row1 => mTemp(i,:)
    j = istart_row
    jmax = mMat_row
    equal = .false.
    do while ((j < jmax) .and. (.not. equal))
      !row2 => mMat(j,:)
      equal = .true.
      do l=1,nOsc
        !if (row1(l) /= row2(l)) then
        if (mTemp(i,l) /= mMat(j,l)) then
          equal = .false.
        end if
      end do
      j = j+1
    end do
    if (.not. equal) then
      do jcol=1,nOsc
        mMat(mMat_row,jcol) = mTemp(i,jcol)
      end do
      mMat_row = mMat_row+1
    end if
  end do
  num = mMat_row-istart_row
end do
maxOrd = mMat_row-1
call mma_deallocate(mTemp)

! Create mInc.
maxIncOrd = maxOrd-num
do i=0,maxIncOrd
  row(:) = mMat(i,:)
  do j=1,nOsc
    row(j) = row(j)+1
    equal = .false.
    k = i+1
    do while ((.not. equal) .and. (k <= maxOrd))
      !row2 => mMat(k,:)
      equal = .true.
      do l=1,nOsc
        if (row(l) /= mMat(k,l)) then
          equal = .false.
        end if
      end do
      if (equal) then
        mInc(i,j) = k
      else
        k = k+1
      end if
    end do
    row(j) = row(j)-1
  end do
end do

! Create mDec.
do i=1,maxOrd
  row(:) = mMat(i,:)
  do j=1,nOsc
    if (row(j) > 0) then
      row(j) = row(j)-1
      equal = .false.
      k = 0
      do while ((.not. equal) .and. (k <= maxOrd))
        !row2 => mMat(k,:)
        equal = .true.
        do l=1,nOsc
          if (row(l) /= mMat(k,l)) then
            equal = .false.
          end if
        end do
        if (equal) then
          mDec(i,j) = k
        else
          k = k+1
        end if
      end do
      row(j) = row(j)+1
    else
      mDec(i,j) = 0
    end if
  end do
end do

call mma_deallocate(row)
call mma_deallocate(unitm)

end subroutine MakeTab

subroutine MakeTab2(m_max,maxOrd,maxIncOrd,msiz,mMat,mInc,mDec,nOsc)
!  Purpose:
!    Create tables used in FCval.
!
!  Input:
!    nOsc      : Integer - the the number of oscillators.
!    m_max     : Integer - the maximum sum of the quantum numbers.
!    maxOrd    : Integer - number of rows in mMat.
!    nTabDim   : Integer
!    Osc_Shift : Integer array
!
!  Output:
!    mMat      : Two dimensional integer array
!    mInc      : Two dimensional integer array
!    mDec      : Two dimensional integer array
!
!  Calls:
!    none
!
!  Written by:
!    Niclas Forsberg Anders Bernhardsson,
!    Dept. of Theoretical Chemistry, Lund University, 1995&1998

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: m_max, msiz, nOsc
integer(kind=iwp), intent(inout) :: maxOrd, maxIncOrd
integer(kind=iwp), intent(out) :: mMat(0:msiz,nOsc), mInc(0:msiz,nOsc), mDec(0:msiz,nOsc)
integer(kind=iwp) :: i, iDet, iDNR, iOsc, iQ, iQ1, iQ2, iQuanta, iv, j, m, n, nd, nQuanta, nTabDim, nvTabDim
integer(kind=iwp), allocatable :: Graph1(:,:), Graph2(:,:,:), iVec(:), Num(:)
integer(kind=iwp), external :: iDetnr

! Initialize.

mInc(:,:) = 0
mDec(:,:) = 0
mMat(:,:) = 0
if (m_max == 0) return
call TabDim(m_max,nOsc,nTabDim)
maxOrd = nTabDim-1

! Set up the vertex table
call mma_allocate(Graph1,[0,m_max],[1,nOsc+1],label='Graph1')
call mma_allocate(Graph2,[0,m_max],[0,m_max],[1,nOsc],label='Graph2')
Graph1(:,:) = 0
Graph1(:,2) = 1
Graph1(0,:) = 1
if (nOsc > 1) then
  do iOsc=2,nOsc
    n = 0
    do nQuanta=0,m_max
      n = n+Graph1(nQuanta,iOsc)
      Graph1(nQuanta,iOsc+1) = n
    end do
  end do
end if

! set up the arc table
call mma_allocate(Num,[0,m_max],label='Number')
Num(0) = 0
N = 0
do m=1,m_max
  N = N+Graph1(m-1,nOsc+1)
  Num(m) = N
end do
Graph2(:,:,:) = 0
do iOsc=1,nOsc
  do iQ1=0,m_max      ! Where we are going
    do iQ2=0,iQ1-1    ! Where we came from
      do i=iQ2+1,iq1  ! Sum over preceding paths
        Graph2(iQ1,iQ2,iOsc) = Graph1(i,iOsc)+Graph2(iQ1,iQ2,iOsc)
      end do
    end do
  end do
end do

do iQ1=0,m_max  ! Where we are going
  do iQ2=0,iq1  ! Where we came from
    Graph2(iQ1,iQ2,nOsc) = Graph2(iQ1,iQ2,nOsc)+Num(iQ1)
  end do
end do

call mma_deallocate(Graph1)
call mma_deallocate(Num)

call mma_allocate(iVec,nOsc,label='iVec')
do iQuanta=1,m_max
  iVec(:) = 0
  iQ = -1
  iVec(1) = -1

  call TabDim(iQuanta,nOsc,nd)
  call TabDim(iQuanta-1,nOsc,nvTabDim)

  nd = nd-nvTabDim

  do iDet=1,nD
    iVec(1) = iVec(1)+1
    iQ = iQ+1
    if (iQ > iQuanta) then
      do i=1,nOsc-1
        if (iQ <= iQuanta) exit
        iQ = iQ-iVec(i)+1
        iVec(i) = 0
        iVec(i+1) = iVec(i+1)+1
      end do
    end if
    iVec(nOsc) = iQuanta-iq
    iDNR = iDetnr(iVec,Graph2,nOsc,m_max)
    mMat(iDnr,:) = iVec(:)
  end do
end do

! Create mInc.
!minc = -1
mInc(:,:) = -1

call TabDim(m_max-1,nOsc,nvTabDim)
maxIncOrd = nvTabDim-1
do i=0,maxIncOrd
  iVec(:) = mMat(i,:)
  do j=1,nOsc
    iVec(j) = iVec(j)+1
    mInc(i,j) = iDetnr(iVec,Graph2,nOsc,m_max)
    iVec(j) = iVec(j)-1
  end do
end do

! Create mDec.

mDec(0,:) = -1
do i=1,maxOrd
  do j=1,nOsc
    if (mmat(i,j) /= 0) then
      iVec(:) = mMat(i,:)
      iVec(j) = iVec(j)-1
      mDec(i,j) = iDetnr(iVec,Graph2,nOsc,m_max)
      do iv=1,nOsc
        iVec(iv) = iVec(j)+1
      end do
    else
      mdec(i,j) = -1
    end if
  end do
end do

call mma_deallocate(Graph2)
call mma_deallocate(iVec)

end subroutine MakeTab2

subroutine TabDim(nDim,nOsc,nTabDim)
!  Purpose:
!    Fill a nDim*nOsc matrix with binomial coefficients.
!    This matrix is then used to calculate the dimension
!    of a table containing excitations for nOsc oscillators.
!    nDim is the maximum sum of the oscillator quanta.
!
!  Input:
!    nDim    : Integer variable - maximun excitation.
!    nOsc    : Integer variable - number of dimensions.
!
!  Result:
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, nOsc
integer(kind=iwp), intent(out) :: nTabDim
integer(kind=iwp) :: iRow, jCol
integer(kind=iwp), allocatable :: binomCoef(:,:)

! Initialize.

! Calculate binomial coefficients.
if (nDim > 0) then
  call mma_allocate(binomCoef,[0,nDim],[1,nOsc],label='binomCoef')
  do jCol=1,nOsc
    binomCoef(0,jCol) = 1
  end do
  do iRow=0,nDim
    binomCoef(iRow,1) = 1
  end do
  do jCol=2,nOsc
    do iRow=1,nDim
      binomCoef(iRow,jCol) = binomCoef(iRow-1,jCol)+binomCoef(iRow,jCol-1)
    end do
  end do

  ! Sum all elements of the nOsc'th column.
  nTabDim = 0
  do iRow=0,nDim
    nTabDim = nTabDim+binomCoef(iRow,nOsc)
  end do
  call mma_deallocate(binomCoef)
else
  nTabDim = 1
end if

end subroutine TabDim

function iDetNr(iocc,graph2,nOsc,m)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iDetNr
integer(kind=iwp), intent(in) :: nOsc, iocc(nOsc), m, graph2(0:m,0:m,nOsc)
integer(kind=iwp) :: i, iqnew, iqold, n
! iocc: occupation vector
! graph2: vertex graph table
! nOsc: number of nodes
! m: number of quantas
! number of determinants in with lower number of quantas.

! Calculate the index of occupation string iocc

iqnew = 0
iqold = 0
n = 0
do i=1,nOsc
  iqnew = iqnew+iocc(i)
  n = n+graph2(iqnew,iqold,i)
  iqold = iqnew
end do

iDetNr = n

end function iDetNr

! Muln  is a set of subroutines that calculates
! <i|H|j> where H is a operator described
! M_1,2..,n(a_1+a^t_1)*(a_2+a^t_2)...(a_n+a^t_n)
! you can find n=1,2,3,4 in this file.
!
! nmat : Occupation of slater det.
! F    : Output <i|A|j>
! iCre,iAnn : Gives the resulting slater determinant if a^t (a) is acting on SD
! mat  : Matrix describing the operator expanded in Normal modes
! m_Ord: Number of slater determinants.
!
! Anders Bernhardsson Friday the 13th august 1999

subroutine Mul1(nMat,F,iCre,iAnn,mat,m_Ord,nOsc,rdx)

use mula_global, only: mdim1, ndim1, ndim2
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: m_Ord, nOsc, nMat(0:m_Ord,nOsc), iCre(0:ndim1,ndim2), iAnn(0:ndim1,ndim2)
real(kind=wp), intent(out) :: F(0:mdim1,0:ndim1)
real(kind=wp), intent(in) :: Mat(nOsc), rdx(1)
integer(kind=iwp) :: i, iOrd, iOsc, jOrd
real(kind=wp) :: fact, sqr(0:50)

do i=0,50
  sqr(i) = sqrt(Half*i)
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iAnn(iOrd,iOsc)
    if (jOrd >= 0) then
      Fact = sqr(nmat(iord,iosc))*rdx(1)
      F(iOrd,jOrd) = F(iOrd,jOrd)+Fact*Mat(iOsc)
    end if
  end do
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iCre(iOrd,iOsc)
    if (jOrd >= 0) then
      Fact = sqr(nmat(jord,iosc))
      F(iOrd,jOrd) = F(iOrd,jOrd)+Fact*Mat(iOsc)
    end if
  end do
end do

end subroutine Mul1

subroutine Mul2(nMat,F,iCre,iAnn,mat,m_Ord,nOsc,rdx)

use mula_global, only: mdim1, ndim1, ndim2
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: m_Ord, nOsc, nMat(0:m_Ord,nOsc), iCre(0:ndim1,ndim2), iAnn(0:ndim1,ndim2)
real(kind=wp), intent(inout) :: F(0:mdim1,0:ndim1)
real(kind=wp), intent(in) :: Mat(nOsc,nOsc), rdx(2)
integer(kind=iwp) :: i, iOrd, iOsc, jOrd, jOsc, kOrd
real(kind=wp) :: fact, r, rsym, sqr(0:50)

rsym = Half
do i=0,50
  sqr(i) = sqrt(Half*i)
end do
r = rdx(1)*rdx(2)
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iAnn(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iAnn(jOrd,jOsc)
        if (kOrd >= 0) then
          Fact = sqr(nmat(iord,iosc))*sqr(nmat(jord,josc))*r*rsym
          F(iOrd,kOrd) = F(iOrd,kOrd)+Fact*Mat(iOsc,josc)
        end if
      end do
    end if
  end do
end do
if (r /= Zero) then
  do iOrd=0,m_Ord
    do iOsc=1,nOsc
      jOrd = iann(iord,iosc)
      if (jOrd >= 0) then
        do jOsc=1,nOsc
          kOrd = iCre(jord,josc)
          if (kOrd >= 0) then
            r = rdx(1)*Mat(iosc,jOsc)+rdx(2)*Mat(josc,iOsc)
            Fact = sqr(nmat(iord,iosc))*sqr(nmat(kord,josc))*r*rsym
            F(iOrd,kOrd) = F(iOrd,kOrd)+Fact
          end if
        end do
      end if
    end do
  end do
end if
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iCre(iord,iosc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iCre(jord,josc)
        if (kOrd >= 0) then
          Fact = sqr(nmat(jord,iosc))*sqr(nmat(kord,josc))*rsym
          F(iOrd,kOrd) = F(iOrd,kOrd)+Fact*Mat(iosc,jOsc)
        end if
      end do
    end if
  end do
end do
r = rdx(2)
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    F(iOrd,iOrd) = F(iOrd,iOrd)+Mat(iosc,iOsc)*r*rsym*Half
  end do
end do

end subroutine Mul2

subroutine Mul3(nMat,F,iCre,iAnn,mat,m_Ord,nOsc,rdx)

use mula_global, only: mdim1, ndim1, ndim2
use Constants, only: One, Six, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: m_Ord, nOsc, nMat(0:m_Ord,nOsc), iCre(0:ndim1,ndim2), iAnn(0:ndim1,ndim2)
real(kind=wp), intent(inout) :: F(0:mdim1,0:ndim1)
real(kind=wp), intent(in) :: Mat(nOsc,nOsc,nOsc), rdx(3)
integer(kind=iwp) :: i, iOrd, iOsc, jOrd, jOsc, kOrd, kOsc, lOrd
real(kind=wp) :: fact, r, relem, rsym, sqr(0:50)

rsym = One/Six
do i=0,50
  sqr(i) = sqrt(Half*i)
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iAnn(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iAnn(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            lOrd = iAnn(kOrd,kOsc)
            if (lOrd >= 0) then
              r = rdx(1)*rdx(2)*rdx(3)
              Fact = sqr(nmat(iord,iosc))*sqr(nmat(jord,josc))*sqr(nmat(kord,kosc))*r*rsym
              F(iOrd,lOrd) = F(iOrd,lOrd)+Fact*Mat(iOsc,josc,kosc)
            end if
          end do
        end if
      end do
    end if
  end do
end do

do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iAnn(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iAnn(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            lOrd = iCre(kOrd,kOsc)
            if (lOrd >= 0) then
              r = rdx(1)*rdx(2)*Mat(iOsc,josc,kosc)+rdx(2)*rdx(3)*Mat(kOsc,iosc,josc)+rdx(3)*rdx(1)*Mat(iOsc,kosc,josc)
              Fact = sqr(nmat(iord,iosc))*sqr(nmat(jord,josc))*sqr(nmat(lord,kosc))*r*rsym
              F(iOrd,lOrd) = F(iOrd,lOrd)+Fact
            end if
          end do
        end if
      end do
    end if
  end do
end do

do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iAnn(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iCre(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            lOrd = iCre(kOrd,kOsc)
            if (lOrd >= 0) then
              r = rdx(1)*mat(iosc,josc,kosc)+rdx(2)*mat(josc,iosc,kosc)+rdx(3)*mat(josc,kosc,iosc)
              Fact = sqr(nmat(iord,iosc))*sqr(nmat(kord,josc))*sqr(nmat(lord,kosc))*rsym*r
              F(iOrd,lOrd) = F(iOrd,lOrd)+Fact
            end if
          end do
        end if
      end do
    end if
  end do
end do

do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iCre(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iCre(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            lOrd = iCre(kOrd,kOsc)
            if (lOrd >= 0) then
              Fact = sqr(nmat(jord,iosc))*sqr(nmat(kord,josc))*sqr(nmat(lord,kosc))*rsym
              F(iOrd,lOrd) = F(iOrd,lOrd)+Fact*Mat(iOsc,josc,kosc)
            end if
          end do
        end if
      end do
    end if
  end do
end do

do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iCre(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        Fact = sqr(nmat(jord,iosc))
        relem = Mat(josc,josc,iosc)*rdx(2)+rdx(3)*(mat(iosc,josc,josc)+mat(josc,iosc,josc))
        F(iOrd,jOrd) = F(iOrd,jOrd)+Fact*relem*rsym*Half
      end do
    end if
  end do
end do

do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iann(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        Fact = sqr(nmat(iord,iosc))
        relem = Mat(iosc,josc,josc)*rdx(1)*rdx(3)+rdx(2)*rdx(3)*(mat(josc,josc,iosc)+mat(josc,iosc,josc))
        F(iOrd,jOrd) = F(iOrd,jOrd)+Fact*relem*rsym*Half
      end do
    end if
  end do
end do

end subroutine Mul3

subroutine Mul4(nMat,F,iCre,iAnn,mat,m_Ord,nOsc,rdx)

use mula_global, only: mdim1, ndim1, ndim2
use Constants, only: One, Half, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: m_Ord, nOsc, nMat(0:m_Ord,nOsc), iCre(0:ndim1,ndim2), iAnn(0:ndim1,ndim2)
real(kind=wp), intent(inout) :: F(0:mdim1,0:ndim1)
real(kind=wp), intent(in) :: Mat(nOsc,nOsc,nOsc,nOsc), rdx(4)
integer(kind=iwp) :: i, iOrd, iOsc, jOrd, jOsc, kOrd, kOsc, lOrd, lOsc, mOrd
real(kind=wp) :: fact, r, relem, rsym, sqr(0:50)

do i=0,50
  sqr(i) = sqrt(Half*i)
end do
rsym = One/24.0_wp
r = Rdx(1)*rdx(2)*rdx(3)*rdx(4)
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iAnn(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iAnn(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            lOrd = iAnn(kOrd,kOsc)
            if (lOrd >= 0) then
              do lOsc=1,nOsc
                mOrd = iAnn(lOrd,lOsc)
                if (mOrd >= 0) then
                  Fact = sqr(nmat(iord,iosc))*sqr(nmat(jord,josc))*sqr(nmat(kord,kosc))*sqr(nmat(lord,losc))*r*rsym
                  F(iOrd,mOrd) = F(iOrd,mOrd)+Fact*Mat(iOsc,josc,kosc,losc)
                end if
              end do
            end if
          end do
        end if
      end do
    end if
  end do
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iAnn(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iAnn(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            lOrd = iAnn(kOrd,kOsc)
            if (lOrd >= 0) then
              do lOsc=1,nOsc
                mOrd = iCre(lOrd,lOsc)
                if (mOrd >= 0) then
                  r = rdx(1)*rdx(2)*rdx(3)*mat(iosc,josc,kosc,losc)+rdx(2)*rdx(3)*rdx(4)*mat(losc,iosc,josc,kosc)+ &
                      rdx(3)*rdx(4)*rdx(1)*mat(iosc,losc,josc,kosc)+rdx(4)*rdx(1)*rdx(2)*mat(iosc,josc,losc,kosc)
                  Fact = sqr(nmat(iord,iosc))*sqr(nmat(jord,josc))*sqr(nmat(kord,kosc))*sqr(nmat(mord,losc))*r*rsym
                  F(iOrd,mOrd) = F(iOrd,mOrd)+Fact
                end if
              end do
            end if
          end do
        end if
      end do
    end if
  end do
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iAnn(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iAnn(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            lOrd = iCre(kOrd,kOsc)
            if (lOrd >= 0) then
              do lOsc=1,nOsc
                mOrd = iCre(lOrd,lOsc)
                if (mOrd >= 0) then
                  r = rdx(1)*rdx(2)*mat(iosc,josc,kosc,losc)+rdx(2)*rdx(3)*mat(kosc,iosc,josc,losc)+ &
                      rdx(3)*rdx(4)*mat(kosc,losc,iosc,josc)+rdx(4)*rdx(1)*mat(iosc,kosc,losc,josc)+ &
                      rdx(1)*rdx(3)*mat(iosc,kosc,josc,losc)+rdx(4)*rdx(2)*mat(kosc,iosc,losc,josc)
                  Fact = sqr(nmat(iord,iosc))*sqr(nmat(jord,josc))*sqr(nmat(lord,kosc))*sqr(nmat(mord,losc))*r*rsym
                  F(iOrd,mOrd) = F(iOrd,mOrd)+Fact
                end if
              end do
            end if
          end do
        end if
      end do
    end if
  end do
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iAnn(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iCre(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            lOrd = icre(kOrd,kOsc)
            if (lOrd >= 0) then
              do lOsc=1,nOsc
                mOrd = iCre(lOrd,lOsc)
                if (mOrd >= 0) then
                  r = rdx(1)*mat(iosc,josc,kosc,losc)+rdx(2)*mat(josc,iosc,kosc,losc)+rdx(3)*mat(josc,kosc,iosc,losc)+ &
                      rdx(4)*mat(josc,kosc,losc,iosc)
                  Fact = sqr(nmat(iord,iosc))*sqr(nmat(kord,josc))*sqr(nmat(lord,kosc))*sqr(nmat(mord,losc))*r*rsym
                  F(iOrd,mOrd) = F(iOrd,mOrd)+Fact
                end if
              end do
            end if
          end do
        end if
      end do
    end if
  end do
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iCre(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iCre(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            lOrd = iCre(kOrd,kOsc)
            if (lOrd >= 0) then
              do lOsc=1,nOsc
                mOrd = iCre(lOrd,lOsc)
                if (mOrd >= 0) then
                  Fact = sqr(nmat(jord,iosc))*sqr(nmat(kord,josc))*sqr(nmat(lord,kosc))*sqr(nmat(mord,losc))*rsym
                  F(iOrd,mOrd) = F(iOrd,mOrd)+Fact*Mat(iOsc,josc,kosc,losc)
                end if
              end do
            end if
          end do
        end if
      end do
    end if
  end do
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iann(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iann(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            Fact = sqr(nmat(iord,iosc))*sqr(nmat(jord,josc))*rsym
            relem = rdx(1)*rdx(2)*rdx(4)*mat(iosc,josc,kosc,kosc)
            relem = relem+rdx(1)*rdx(3)*rdx(4)*(mat(iosc,kosc,kosc,josc)+mat(iosc,kosc,josc,kosc))
            relem = relem+rdx(2)*rdx(3)*rdx(4)*(mat(kosc,kosc,josc,iosc)+mat(kosc,iosc,kosc,josc)+mat(kosc,josc,iosc,kosc))
            F(iOrd,kOrd) = F(iOrd,kOrd)+Fact*relem*Half
          end do
        end if
      end do
    end if
  end do
end do

do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = icre(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = icre(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            Fact = sqr(nmat(jord,iosc))*sqr(nmat(kord,josc))*rsym
            relem = rdx(2)*mat(kosc,kosc,iosc,josc)
            relem = relem+rdx(3)*(mat(iosc,kosc,kosc,josc)+mat(kosc,iosc,kosc,josc))
            relem = relem+rdx(4)*(mat(iosc,josc,kosc,kosc)+mat(iosc,kosc,josc,kosc)+mat(kosc,iosc,josc,kosc))
            F(iOrd,kOrd) = F(iOrd,kOrd)+Fact*relem*Half
          end do
        end if
      end do
    end if
  end do
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    jOrd = iann(iOrd,iOsc)
    if (jOrd >= 0) then
      do jOsc=1,nOsc
        kOrd = iCre(jOrd,jOsc)
        if (kOrd >= 0) then
          do kOsc=1,nOsc
            Fact = sqr(nmat(iord,iosc))*sqr(nmat(kord,josc))*rsym
            relem = (Mat(jOsc,kosc,kosc,iosc)+Mat(kOsc,josc,kosc,iosc)+Mat(jOsc,kosc,iosc,kosc)+Mat(kOsc,josc,iosc,kosc))* &
                    rdx(3)*rdx(4)
            relem = relem+(Mat(kOsc,kosc,josc,iosc)+Mat(jOsc,iosc,kosc,kosc)+Mat(kOsc,iosc,josc,kosc))*rdx(2)*rdx(4)
            relem = relem+(Mat(kOsc,kosc,iosc,josc)+Mat(kOsc,iosc,kosc,josc))*rdx(2)*rdx(3)
            relem = relem+(Mat(iOsc,kosc,josc,kosc)+Mat(iOsc,josc,kosc,kosc))*rdx(1)*rdx(4)
            relem = relem+Mat(iOsc,kosc,kosc,josc)*rdx(1)*rdx(3)
            F(iOrd,kOrd) = F(iOrd,kOrd)+Fact*relem*Half
          end do
        end if
      end do
    end if
  end do
end do
do iOrd=0,m_Ord
  do iOsc=1,nOsc
    do jOsc=1,nOsc
      relem = rdx(4)*rdx(3)*(mat(iosc,josc,josc,iosc)+mat(iosc,josc,iosc,josc))
      relem = relem+rdx(2)*rdx(4)*mat(iosc,iosc,josc,josc)
      F(iOrd,iOrd) = F(iOrd,iOrd)+relem*rsym*Quart
    end do
  end do
end do

end subroutine Mul4

!end module TabMod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Print_MPPROP(rMP,xrMP,xnrMP,nij,nElem,lMax,EC,Polar,
     &                        Lbl,nAtoms,iANr,NoField,CoC,Coor,
     &                        nOcOb,Energy_Without_FFPT,ip_Ene_Occ,
     &                        MpProp_Level,Bond_Threshold,nReal_Centers)
*
*  rMP : Multipole moments moved to center of charge
* xrMP : Multipole moments kept on the expansion center
*
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "Molcas.fh"
      Real*8 rMP(nij,nElem),xrMP(nij,nElem),xnrMP(nij,nElem),CoC(3),
     &       EC(3,nij),Polar(6,nij),Polar_M(6),Coor(3,nAtoms)
      Integer iANr(nAtoms),nBas(8), lHeader
      Parameter (lHeader = 144)
      Character*(lHeader) Header
      Character*(LENIN) Lbl(nAtoms)
      Character*8 Method,Label
      Character*6 fName
      Logical NoField, Exist, Text, Bond_OK, Check_Bond
      Logical Use_Two_Centers_For_Atoms, Found
      Parameter (Use_Two_Centers_For_Atoms = .False.)
*
      MxMP = lMax
      If (lMax .gt. MpProp_Level) MxMP = MpProp_Level
*
      Call Qpg_carray('Relax Method',Found,iSize)
      If(Found) Then
         Call Get_cArray('Relax Method',Method,8)
      Else
         Method = 'UNDEF   '
      EndIf
      Call Get_cArray('Seward Title',Header,lHeader)
      j = 0
      Text = .False.
      Last_NonBlank = 0
      Do i = 1, 72
         If (Text .or. Header(i:i) .ne. ' ') Then
            Text = .True.
            j = j + 1
            Header(j:j) = Header(i:i)
            If (Header(i:i) .ne. ' ') Last_NonBlank = j
         End If
      End Do
*
      fName = 'MPPROP'
      iUnit = 11
      Call OpnFl(fName,iUnit,Exist)

      nCenters = nReal_Centers
      If (Use_Two_Centers_For_Atoms) Then
         nCenters = nCenters + nAtoms
      End If

      Write(iUnit,'(A)')
     &   '**************************************************'
      Write(iUnit,'(A)') '* Molecule'
      Write(iUnit,'(A)') Header(1:Last_NonBlank)
      Write(iUnit,'(A)') '* Method'
      Write(iUnit,'(A)') Method
      Write(iUnit,'(A)') '* Level of Multipoles and Polarizabilities'
      Write(iUnit,'(2I5)') MxMP,1
      Write(iUnit,'(A)') '* All centers'
      Write(iUnit,'(I5)') nCenters

* Insert atoms
      Do iAtom = 1, nAtoms
         ii = iAtom*(iAtom+1)/2
         Call ReExpand(xnrMP,nij,nElem,CoC,EC(1,ii),ii,lMax)

* Informations on the atom
         Write(iUnit, '(2I5,4X,A)') 2,1,Lbl(iAtom)
* The expansion center
         Write(iUnit,'(3F20.10)') (EC(iElem,ii),iElem = 1,3)
* The multipole moments
         iStrt = 1
         Do l = 0, MxMP
            iEnd  = iStrt + (l+1)*(l+2)/2 - 1
            Write(iUnit,'(3F20.10)') (xrMP(ii,iElem)+xnrMP(ii,iElem),
     &                                            iElem = iStrt,iEnd)
            iStrt = iEnd + 1
         End Do
* The size parameters (never higher than quadrupole)
         lMax_for_size = min(MxMP,2)
         iStrt = 1
         Do l = 0, lMax_for_size
            iEnd  = iStrt + (l+1)*(l+2)/2 - 1
            Write(iUnit,'(3F20.10)') (Zero,iElem = iStrt,iEnd)
            iStrt = iEnd + 1
         End Do
* Polarizabilities
         If (NoField) Then
            Write(iUnit,'(3F20.10)') (Zero,iElem=1,6)
         Else
            Polar_M(1) = Polar(1,ii)
            Polar_M(2) = Polar(2,ii)
            Polar_M(3) = Polar(4,ii)
            Polar_M(4) = Polar(3,ii)
            Polar_M(5) = Polar(5,ii)
            Polar_M(6) = Polar(6,ii)
            Write(iUnit,'(3F20.10)') (Polar_M(iElem),iElem=1,6)
         End If

         Call ReExpand(xnrMP,nij,nElem,EC(1,ii),CoC,ii,lMax)
      End Do
      If (Use_Two_Centers_For_Atoms) Then
* Insert real atoms and fake values
         Do iAtom = 1, nAtoms

* Informations on the center
            Write(iUnit, '(2I5,4X,A)') iANr(iAtom),1,Lbl(iAtom)
* The expansion center
            Write(iUnit,'(3F20.10)') (Coor(iElem,iAtom),iElem = 1,3)
* The multipole moments
            iStrt = 1
            Do l = 0, MxMP
               iEnd  = iStrt + (l+1)*(l+2)/2 - 1
               Write(iUnit,'(3F20.10)') (Zero,iElem = iStrt,iEnd)
               iStrt = iEnd + 1
            End Do
* The size parameters (never higher than quadrupole)
            lMax_for_size = min(MxMP,2)
            iStrt = 1
            Do l = 0, lMax_for_size
               iEnd  = iStrt + (l+1)*(l+2)/2 - 1
               Write(iUnit,'(3F20.10)') (One,iElem = iStrt,iEnd)
               iStrt = iEnd + 1
            End Do
* Polarizabilities
            Write(iUnit,'(3F20.10)') (Zero,iElem=1,6)

         End Do
      End If
* Insert bonds
      Do jAtom = 1, nAtoms
         Do iAtom = jAtom+1, nAtoms
            ij = iAtom*(iAtom-1)/2 + jAtom

            Bond_OK = Check_Bond(Coor(1,iAtom),Coor(1,jAtom),
     &                           iANr(iAtom),iANr(jAtom),Bond_Threshold)
            If (Bond_OK) Then
               Label = '       '
               Write(Label,'(I3,A,I3)') jAtom,'-',iAtom
               j = 0
               Do i = 1,8
                  If (Label(i:i) .ne. ' ') Then
                     j = j + 1
                     Label(j:j) = Label(i:i)
                  End If
               End Do
* Informations on the center
               Write(iUnit, '(2I5,4X,A)') 2,1,Label(1:j)
* The expansion center
               Write(iUnit,'(3F20.10)') (EC(iElem,ij),iElem = 1,3)
* The multipole moments
               iStrt = 1
               Do l = 0, MxMP
                  iEnd  = iStrt + (l+1)*(l+2)/2 - 1
                  Write(iUnit,'(3F20.10)')
     &               (xrMP(ij,iElem),iElem = iStrt,iEnd)
                  iStrt = iEnd + 1
               End Do
* The size parameters (never higher than quadrupole)
               lMax_for_size = min(MxMP,2)
               iStrt = 1
               Do l = 0, lMax_for_size
                  iEnd  = iStrt + (l+1)*(l+2)/2 - 1
                  Write(iUnit,'(3F20.10)') (One,iElem = iStrt,iEnd)
                  iStrt = iEnd + 1
               End Do
* Polarizabilities
               If (NoField) Then
                  Write(iUnit,'(3F20.10)') (Zero,iElem=1,6)
               Else
                  Polar_M(1) = Polar(1,ij)
                  Polar_M(2) = Polar(2,ij)
                  Polar_M(3) = Polar(4,ij)
                  Polar_M(4) = Polar(3,ij)
                  Polar_M(5) = Polar(5,ij)
                  Polar_M(6) = Polar(6,ij)
                  Write(iUnit,'(3F20.10)') (Polar_M(iElem),iElem=1,6)
               End If
            End If

         End Do
      End Do
*
******** Molecular properties
*
      Write(iUnit,'(A)') '* Molecule properties'
      Call Allocate_Work(iScratch_ele,nElem)
      Call Allocate_Work(iScratch_nuc,nElem)
      Do iElem = 1, nElem
         Work(iScratch_ele+iElem-1)=DDot_(nij,[One],0,rMP(1,iElem),1)
         Work(iScratch_nuc+iElem-1)=DDot_(nij,[One],0,xnrMP(1,iElem),1)
      End Do
      iStrt = 1
      Do l = 0, MxMP
         iEnd  = iStrt + (l+1)*(l+2)/2 - 1
         Write(iUnit,'(3F20.10)')
     &      (Work(iScratch_ele+iElem-1)+Work(iScratch_nuc+iElem-1),
     &                                          iElem = iStrt,iEnd)
         iStrt = iEnd + 1
      End Do
      Call Free_Work(iScratch_ele)
      Call Free_Work(iScratch_nuc)

      If (NoField) Then
         Write(iUnit,'(3F20.10)') (Zero,iElem=1,6)
      Else
         Polar_M(1)=DDot_(nij,[One],0,Polar(1,1),6)
         Polar_M(2)=DDot_(nij,[One],0,Polar(2,1),6)
         Polar_M(3)=DDot_(nij,[One],0,Polar(4,1),6)
         Polar_M(4)=DDot_(nij,[One],0,Polar(3,1),6)
         Polar_M(5)=DDot_(nij,[One],0,Polar(5,1),6)
         Polar_M(6)=DDot_(nij,[One],0,Polar(6,1),6)
         Write(iUnit,'(3F20.10)') (Polar_M(iElem),iElem=1,6)
      End If
*
******** Orbital information
*
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
*
      Write(iUnit,'(A)') '* Orbital information'
      Write(iUnit,'(2I5)') nBas(1), nOcOb
      Write(iUnit,'(F20.10)') Energy_Without_FFPT
      Write(iUnit,'(3F20.10)') (Work(ip_Ene_Occ+i),i=0,nOcOb-1)
*
      Call Free_Work(ip_Ene_Occ)
*
      Close(iUnit)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994,1997, Jeppe Olsen                                 *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SKICKJ(SKII,CKJJ,NKA,NKB,XIJKL,NI,NJ,NK,NL,MAXK,KBIB,XKBIB,KBJB,XKBJB,IKORD,FACS,IROUTE)
! Calculate S(Ka,Ib,i) = FACS*S(Ka,Ib,i)
!          +SUM(j,k,l,Kb) <Ib!a+ kb!Kb><Kb!a lb !Jb>*(ij!kl)*C(Ka,Jb,j)
!
! Jeppe Olsen, Spring of 94
!
! : Note : Route 1 has retired, March 97

use lucia_data, only: MXPTSOB
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: SKII(*), XIJKL(*)
integer(kind=iwp), intent(in) :: NKA, NKB, NI, NJ, NK, NL, MAXK, KBIB(MAXK,*), KBJB(MAXK,*), IKORD, IROUTE
real(kind=wp), intent(in) :: CKJJ(*), XKBIB(MAXK,*), XKBJB(MAXK,*), FACS
integer(kind=iwp) :: IB, ICOFF, IKINTOF, IMAX, INTOF, ISOFF, JB, JKINTOF, K, KB, KK, L, LL
real(kind=wp) :: FACTOR, SGNK, SGNL, XIJILS(MXPTSOB)

! To get rid of annoying and incorrect compiler warnings
JKINTOF = 0
IKINTOF = 0

if ((NI > MXPTSOB) .or. (NJ > MXPTSOB) .or. (NK > MXPTSOB) .or. (NL > MXPTSOB)) then
  write(u6,*) ' SKICKJ : Too many orbs : > MXPTSOB'
  write(u6,*) ' N, MXPTSOB ',max(NI,NJ,NK,NL),MXPTSOB
  !stop ' Redim MXPTSOB'
  call SYSABENDMSG('lucia_util/skickj','Redim MXPTSOB','')
end if

if (IROUTE == 3) then
  ! S(Ka,i,Ib) = S(Ka,i,Ib) + sum(j) (ji!kl) C(Ka,j,Jb)
  do KB=1,NKB
    ! Number of nonvanishing connections from KB
    LL = 0
    KK = 0
    do L=1,NL
      if (KBJB(KB,L) /= 0) LL = LL+1
    end do
    do K=1,NK
      if (KBIB(KB,K) /= 0) KK = KK+1
    end do

    if ((KK /= 0) .and. (LL /= 0)) then
      do K=1,NK
        IB = KBIB(KB,K)
        if (IB /= 0) then
          SGNK = XKBIB(KB,K)
          do L=1,NL
            JB = KBJB(KB,L)
#           ifdef _DEBUGPRINT_
            write(u6,*) ' KB,K,L,IB,JB',KB,K,L,IB,JB
#           endif
            if (JB /= 0) then
              SGNL = XKBJB(KB,L)
              FACTOR = SGNK*SGNL
              ! We have now a IB and Jb string, let's do it
              ISOFF = (IB-1)*NI*NKA+1
              ICOFF = (JB-1)*NJ*NKA+1
              INTOF = ((L-1)*NK+K-1)*NI*NJ+1
              IMAX = NI

              if (IKORD /= 0) then
                ! Restrict so (ij) <= (kl)
                IMAX = K
                JKINTOF = INTOF+(K-1)*NJ
                !XIJILS(1:NJ) = XIJKL(JKINTOF:JKINTOF+NJ-1)
                XIJILS(L:NL) = XIJKL(JKINTOF-1+L:JKINTOF-1+NL)
                XIJKL(JKINTOF-1+L) = Half*XIJKL(JKINTOF-1+L)
                XIJKL(JKINTOF+L:JKINTOF-1+NL) = Zero
              end if
              call MATML7(SKII(ISOFF),CKJJ(ICOFF),XIJKL(INTOF),NKA,IMAX,NKA,NJ,NJ,IMAX,FACS,FACTOR,0)
              if (IKORD /= 0) then
                XIJKL(JKINTOF-1+L:JKINTOF-1+NL) = XIJILS(L:NL)
                !XIJ(JKINTOF:JKINTOF+NJ-1) = XIJILS(1:NJ)
              end if

            end if
          end do

        end if
      end do
    end if
  end do
  ! (end over loop over Kb strings)
else if (IROUTE == 2) then
  ! S(I,Ka,Ib) = S(I,Ka,Ib) + sum(j) (ij!kl) C(j,Ka,Jb)
  do KB=1,NKB
    ! Number of nonvanishing connections from KB
    LL = 0
    KK = 0
    do L=1,NL
      if (KBJB(KB,L) /= 0) LL = LL+1
    end do
    do K=1,NK
      if (KBIB(KB,K) /= 0) KK = KK+1
    end do

    if ((KK /= 0) .and. (LL /= 0)) then
      do K=1,NK
        IB = KBIB(KB,K)
        if (IB /= 0) then
          SGNK = XKBIB(KB,K)
          do L=1,NL
            JB = KBJB(KB,L)
            if (JB /= 0) then
              SGNL = XKBJB(KB,L)
              FACTOR = SGNK*SGNL
              ! We have now a IB and Jb string, let's do it
              ISOFF = (IB-1)*NI*NKA+1
              ICOFF = (JB-1)*NJ*NKA+1
              INTOF = ((L-1)*NK+K-1)*NI*NJ+1

              if (IKORD /= 0) then
                ! Restrict so (ji) <= (kl)
                IKINTOF = INTOF+(K-1)*NI
                XIJILS(1:NI) = XIJKL(IKINTOF:IKINTOF+NI-1)
                XIJKL(IKINTOF-1+L) = Half*XIJKL(IKINTOF-1+L)
                XIJKL(IKINTOF+L:IKINTOF-1+NL) = Zero
              end if

              call MATML7(SKII(ISOFF),XIJKL(INTOF),CKJJ(ICOFF),NI,NKA,NI,NJ,NJ,NKA,FACS,FACTOR,0)

              if (IKORD /= 0) XIJKL(IKINTOF:IKINTOF+NI-1) = XIJILS(1:NI)

            end if
          end do
        end if
      end do
    end if
  end do
  ! (end over loop over Kb strings)

else if (IROUTE == 1) then
  write(u6,*) ' Sorry route 1 has retired, March 1997'
  !stop 'SKICKJ:Invalid route=1'
  call SYSABENDMSG('lucia_util/skickj','Internal error','')
  !do KB=1,NKB
  !  ! Number of nonvanishing a+lb !Kb>
  !  LL = 0
  !  do L=1,NL
  !    if (KBJB(KB,L) /= 0) LL = LL+1
  !  end do
  !
  !  IKEFF = 0
  !  do K=1,NK
  !    IB = KBIB(KB,K)
  !    if (IB == 0) cycle
  !    SGNK = XKBIB(KB,K)
  !
  !    if (IKORD == 0) then
  !       LI = NI
  !       IMIN = 1
  !    else
  !       LI = NI-K+1
  !       IMIN = K
  !    end if
  !
  !    do I=IMIN,NI
  !      IKEFF = IKEFF+1
  !      IOFF = (IKEFF-1)*NJ*LL
  !      ! Offset for S(1,IB,i)
  !      IBOFF(IKEFF) = (I-1)*NIB+IB
  !      LEFF = 0
  !      do L=1,NL
  !        JB = KBJB(KB,L)
  !        if (JB == 0) cycle
  !        LEFF = LEFF+1
  !        SGNL = XKBJB(KB,L)
  !        if ((IKORD == 1) .and. (I == K)) then
  !          FACTOR = Half*SGNK*SGNL
  !        else
  !          FACTOR = SGNK*SGNL
  !        end if
  !        JL0 = (LEFF-1)*NJ
  !        JLIK0 = (K-1)*NJ*NL*NI+(I-1)*NJ*NL+(L-1)*NJ
  !        do J=1,NJ
  !          JL = JL0+J
  !          ! Offsets for C(1,JB,j)
  !          JBOFF(JL) = (J-1)*NJB+JB
  !          ! integral * signs in SCR(jl,ik)
  !          ! Integrals are stored as (j l i k)
  !          SCR((IKEFF-1)*NJ*LL+JL) = FACTOR*XIJKL(JLIK)
  !          SCR(IOFF+JL) = FACTOR*XIJKL(JLIK0+J)
  !        end do
  !      end do
  !    end do
  !  end do
  !
  !  call GSAXPY_LUCIA(SKII,CKJJ,SCR,IKEFF,NJ*LL,NKA,IBOFF,JBOFF)
  !end do
end if
! End of IROUTE branchning

end subroutine SKICKJ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1998,2006,2007, Roland Lindh            *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drv2El_3Center_RI(Integral_WrOut,ThrAO)
************************************************************************
*                                                                      *
*  Object: driver for the 3 center integrals in the RI approach.       *
*                                                                      *
*          This code has three sections                                *
*          1) a 2-center section to generate the Q-vectors             *
*          2) a 3-center section to generate the R-vectors             *
*          3) a partial transpose section to generate the RI vectors   *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August '91                         *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. '93          *
*             Modified driver. Jan. '98                                *
*             Modified to 3-center ERIs for RI Jan '06                 *
*             Modified to out-of-core version Feb '07                  *
************************************************************************
      use iSD_data
      use Wrj12
      use Basis_Info, only: dbsc, nBas, nBas_Aux
      use Temporary_Parameters, only: force_out_of_core
      use Real_Info, only: CutInt
      use RICD_Info, only: LDF
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Integral_WrOut, Integral_RI_2, Rsv_Tsk
#include "Molcas.fh"
#include "j12.fh"
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "WrkSpc.fh"
*
#include "lRI.fh"
#include "setup.fh"
#include "nsd.fh"
#define _no_nShs_
#include "iTOffs.fh"
*
#include "para_info.fh"
      Character*6 Name_R*6
      Integer iOff_3C(3,0:7), Lu_R(0:7), iAddr_R(0:7), iMax_R(2,0:7),
     &        iTtmp(0:7), NoChoVec(0:7), iOff_Rv(0:7)
      Logical Verbose, Indexation, FreeK2, Distribute,
     &        DoGrad, DoFock, Out_of_Core, Rsv_Tsk, Reduce_Prt
      External Reduce_Prt
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*----- Statement functions
*
      TMax_Valence(i,j)=Work(ipTMax-1+(j-1)*nSkal_Valence+i)
      TMax_Auxiliary(i)=Work(ipTMax-1+nSkal_Valence**2+i)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 9
*
#ifdef  _MOLCAS_MPP_
      Distribute = nProcs.gt.1 .and. Is_Real_Par()
#else
      Distribute = .False.
#endif
*
*     Get global print level
*
      iPL=iPrintLevel(-1)
      If (iPL.eq.2) Then
         iPL=5
      Else If (iPL.eq.3) Then
         iPL=6
      Else If (iPL.eq.4) Then
         iPL=99
      Else If (iPL.eq.5) Then
         iPL=99
      End If
      nPrint(iRout)=iPL
*
*     Reduce print level if iterating
*
      If (Reduce_Prt().and.iPL.le.5) Then
         nPrint(iRout)=4
      End If
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.6) Call CWTime(TC0,TW0)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     2 - C E N T E R   S E C T I O N                                  *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Compute the two-center integrals over the auxiliary basis
*
      Call Drv2El_2Center_RI(Integral_RI_2,ThrAO,ipA_Diag,
     &                       nSO_Aux,MaxCntr,ipSO2C)
*
*     Post processing to generate the Q-vectors.
*
      If (LDF) Then
*
*        Local RI
*
         Call Post_2Center_LDF(ipA_Diag,ipAB,MaxCntr,Lu_AB,ipLocal_A,
     &                         nLocal_A,ipSO2C,nSO_Aux)
*
      Else
*
*        Standard RI
*
         Call Post_2Center_RI(ipA_Diag)
*
      End If
*
      Call Set_Basis_Mode('Auxiliary')
      Call Nr_Shells(nSkal_Auxiliary)
*
      If (iPrint.ge.6) Then
         Write (6,'(A)') ' 2-center integrals:'
         Call CWTime(TC1,TW1)
         Write (6,'(A,F8.2,A,/,A,F8.2,A)')
     &                  '      CPU time :',TC1-TC0,' sec.',
     &                  '      Wall time:',TW1-TW0,' sec.'
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     3 - C E N T E R   S E C T I O N                                  *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*
      Call StatusLine(' Seward:',' Computing 3-center RI integrals')
*
*     Handle both the valence and the auxiliary basis set
*
      Call Set_Basis_Mode('WithAuxiliary')
      Call SetUp_iSD
*                                                                      *
************************************************************************
*                                                                      *
*     Initialize for 2-electron integral evaluation. Do not generate
*     tables for indexation.
*
      Indexation = .False.
      DoGrad=.False.
      DoFock=.False.
      Call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
      nSkal_Valence=nSkal-nSkal_Auxiliary
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      nTMax=nSkal_Valence**2+nSkal_Auxiliary-1
      Call GetMem('TMax','Allo','Real',ipTMax,nTMax)
*
      Call Allocate_Work(ip_Tmp,nSkal**2)
      Call Shell_MxSchwz(nSkal,Work(ip_Tmp))
      TMax_all=Zero
      Do iS = 1, nSkal_Valence
         Do jS = 1, iS
            ip_Out=ip_Tmp + (jS-1)*nSkal + iS -1
            ip_In =ipTMax + (jS-1)*nSkal_Valence + iS -1
            Work(ip_In)=Work(ip_Out)
            ip_In =ipTMax + (iS-1)*nSkal_Valence + jS -1
            Work(ip_In)=Work(ip_Out)
            TMax_all=Max(TMax_all,Work(ip_Out))
         End Do
      End Do
      Do iS = 1, nSkal_Auxiliary-1
         iS_ = iS + nSkal_Valence
         jS_ = nSkal_Valence + nSkal_Auxiliary
         ip_Out = ip_Tmp + (iS_-1)*nSkal + jS_ -1
         ip_In  = ipTMax + nSkal_Valence**2 + iS -1
         Work(ip_In)=Work(ip_Out)
         TMax_all=Max(TMax_all,Work(ip_Out))
      End Do
*
      Call Free_Work(ip_Tmp)
*                                                                      *
************************************************************************
*                                                                      *
*     Set up indexation for Gaussian pairs.
*
*     Generate some offsets and dimensions for the J12 matrix and
*     the RI vectors.
*
      Call Setup_Aux(ip_SOShl,ip_ShlSO,ip_nBasSh,nIrrep,nBas,
     &               nSkal_Valence,nSkal_Auxiliary,nSO,ip_iSSOff,
     &               Work(ipTMax),CutInt,ip_iShij,nSkal2,nBas_Aux,
     &               nChV,iTOffs)
*
      Call GetMem('iRv','Allo','Inte',ip_iRv,nSkal2)
      Call IZero(iWork(ip_iRv),nSkal2)
*                                                                      *
************************************************************************
*                                                                      *
*     Let us now decide on the memory partitioning
*
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Preallocate some core for Seward!
*
      Call GetMem('MaxMem','Max','Real',iDummy,MemSew)
      MemLow=Min(MemSew/2,1024*128)
      MemSew=Max(MemSew/10,MemLow)
      Call xSetMem_Ints(MemSew)
*
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     During this phase we will have three memory sections
*
*     1) the three center intergrals for a fixed {kl}
*     2) a similar block for the R-vectors
*     3) a buffer to contain subsets of the Q-vectors
*
*     Compute the max size of 1 and 2
*
      n3CMax=0
      nRvMax=0
      Call IZero(iMax_R,2*nIrrep)
      Do klS = 1, nSkal2
         kS = iWork(ip_iShij+(klS-1)*2  )
         lS = iWork(ip_iShij+(klS-1)*2+1)
         nRv = nSize_Rv(kS,lS,iWork(ip_nBasSh),nSkal-1,nIrrep,iOff_Rv,
     &                  nChV)
         nRvMax = Max (nRvMax,nRv)
         n3C = nSize_3C(kS,lS,iWork(ip_nBasSh),nSkal-1,nIrrep,iOff_3C,
     &                  nBas_Aux)
         n3CMax = Max (n3CMax,n3C)
         Do iIrrep = 0, nIrrep-1
            iMax_R(1,iIrrep)=Max(iMax_R(1,iIrrep),iOff_3C(1,iIrrep))
            iMax_R(2,iIrrep)=iMax_R(2,iIrrep)+iOff_3C(1,iIrrep)
         End Do
      End Do
*
      Call GetMem('3C','Allo','Real',ip_3C,n3CMax)
      Call GetMem('Rv','Allo','Real',ip_Rv,nRvMax)
*
      Call GetMem('MemMax','Max','Real',iDummy,MaxMem)
      nQv=0
      Do iIrrep = 0, nIrrep-1
         lJ=nBas_Aux(iIrrep)
         If (iIrrep.eq.0) lJ=lJ-1 ! remove dummy basis function
         nQv = nQv + lJ*nChV(iIrrep)
      End Do
*
*     The Q-vectors can be read in a single whole block or in chunks.
*
      If (Force_Out_of_Core) MaxMem=(8*nQv)/10
      Out_of_Core = nQv.gt.MaxMem
      nQv = Min(nQv,MaxMem)  ! note that nQv is effectively reset here
      Call GetMem('Q_vector','Allo','Real',ip_Qv,nQv)
*                                                                      *
************************************************************************
*                                                                      *
*     In case of in-core mode read Q-vectors only once!
*
      If (.Not.Out_of_Core) Then
         mQv=0
         Do iIrrep = 0, nIrrep-1
            lJ=nBas_Aux(iIrrep)
            If (iIrrep.eq.0) lJ=lJ-1 ! remove dummy basis function
*
            If (lJ.gt.0) Then
               iAddr=0
               iOff = ip_Qv+mQv
               kQv = lJ*nChV(iIrrep)
               Call dDaFile(Lu_Q(iIrrep),2,Work(iOff),kQv,iAddr)
               mQv = mQv + kQv
            End If
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Open files for the R-vectors.
*
      Do iIrrep = 0, nIrrep-1
         nB_Aux=nBas_Aux(iIrrep)
         If (iIrrep.eq.0) nB_Aux=nB_Aux-1
         If (nB_Aux.ne.0) Then
            iSeed=55+iIrrep
            Lu_R(iIrrep)=IsFreeUnit(iSeed)
            Write(Name_R,'(A4,I2.2)') 'RVec',iIrrep
            Call DaName_MF_WA(Lu_R(iIrrep),Name_R)
         End If
         iAddr_R(iIrrep)=0
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu1,TWall1)
*
      kCenter=0  ! dummy initialize
      lCenter=0  ! dummy initialize
      iS = nSkal ! point to dummy shell
*     Save this field for the time being!
      Call ICopy(nIrrep,iTOffs(3),3,iTtmp,1)
*
      Call Init_Tsk(id,nSkal2)
*
*
      klS=0
       iTask=0
C      Do klS = 1, nSkal2
 100     Continue
         If (.Not.Rsv_Tsk(id,klS)) Go To 200
C        Write (*,*) 'Processing shell-pair:',klS
         iTask=iTask+1
*
         iWork(ip_iRv-1+iTask) = klS
         kS = iWork(ip_iShij+(klS-1)*2  )
         lS = iWork(ip_iShij+(klS-1)*2+1)
*
*        Logic to avoid integrals with mixed muonic and electronic
*        basis.
*
         kCnttp=iSD(13,kS)
         lCnttp=iSD(13,lS)
*
         If (LDF) Then
*
*           Pick up the corresponding (K|L)^{-1} block
*
            kCenter=iSD(10,kS)
            lCenter=iSD(10,lS)
C           Write (6,*) 'kCenter, lCenter=',kCenter, lCenter
            klCenter = kCenter*(kCenter-1)/2 + lCenter
            iAdr_AB=iWork(ipAB+(klCenter-1)*2  )
            nAB    =iWork(ipAB+(klCenter-1)*2+1)
            Call dDaFile(Lu_AB,2,Work(ipLocal_A),nAB**2,iAdr_AB)
C           Call RecPrt('A^-1',' ',Work(ipLocal_A),nAB,nAB)
*
*           Now I need some lookup tables to be used below. I need to
*           go from SO index to lO index and from a given lO index
*           back to the SO index.
*
            Call IZero(ISO2LO,2*(MaxBfn+MaxBfn_Aux))
            iLO=0
            nCase=1
            If (kCenter.ne.lCenter) nCase=2
            Do iCase = 1, nCase
               If (iCase.eq.1) Then
                  jCenter=kCenter
               Else
                  jCenter=lCenter
               End If
               Do iSO_Aux = 1, nSO_Aux
                  iCenter=iWork(ipSO2C+iSO_Aux-1)
C                 Write (6,*) 'iCenter=',iCenter
                  If (iCenter.eq.jCenter) Then
                     iLO = iLO + 1
C                    Write (6,*) 'iLO,iSO_Aux=',iLO,iSO_Aux
                     iSO2LO(1,iSO_Aux)=iLO
                     iSO2LO(2,iLO)=iSO_Aux
                  End If
               End Do
            End Do
         End If
*
         Aint_kl = TMax_Valence(kS,lS)
         If (dbsc(kCnttp)%fMass.ne.dbsc(lCnttp)%fMass) Aint_kl=0.0D0
*
         nRv = nSize_Rv(kS,lS,iWork(ip_nBasSh),nSkal-1,nIrrep,iOff_Rv,
     &                  nChV)
         n3C = nSize_3C(kS,lS,iWork(ip_nBasSh),nSkal-1,nIrrep,iOff_3C,
     &                  nBas_Aux)
         Call FZero(Work(ip_3C),n3C)
         Call FZero(Work(ip_Rv),nRv)
*
         Call ICopy(nIrrep,iOff_3C,3,iTOffs(3),3)
*
*        Loop over the auxiliary basis set
*
         Do jS = nSkal_Valence+1, nSkal-1
C           Write (6,*) 'jS,kS,lS=',jS,kS,lS
            If (LDF) Then
               jCenter=iSD(10,jS)
               If (jCenter.ne.kCenter .and.
     &             jCenter.ne.lCenter ) Go To 14
C              Write (6,*) 'jCenter=',jCenter
            End If
*
            Aint=Aint_kl * TMax_Auxiliary(jS-nSkal_Valence)
*
#ifdef _DEBUGPRINT_
            Write (6,*)
            Write (6,*) 'iS,jS,kS,lS=',iS,jS,kS,lS
            Write (6,*) 'AInt,CutInt=',AInt,CutInt
            Write (6,*)
#endif
            If (AInt.lt.CutInt) Go To 14
            Call Eval_IJKL(iS,jS,kS,lS,Work(ip_3C),n3C,Integral_WrOut)
 14         Continue
*
*           Use a time slot to save the number of tasks and shell
*           quadrupltes process by an individual node
            Call SavStat(1,One,'+')
            Call SavStat(2,One,'+')
*
         End Do    ! jS
*                                                                      *
************************************************************************
*                                                                      *
*        Multiply the 3-center integrals with the Q-vectors
*
*        Compute HQ
*
         Call Mult_3C_Qv_S(Work(ip_3C),n3C,Work(ip_Qv),nQv,Work(ip_Rv),
     &                     nRv,nChV,
     &                     iOff_3C,nIrrep,Out_of_Core,Lu_Q,'N')
*                                                                      *
************************************************************************
*                                                                      *
*        Write the R-vectors to disk. These will be retrieved and sort
*        afterwards in step 3.
*
         Do iIrrep = 0, nIrrep-1
            ip_R = ip_Rv + iOff_Rv(iIrrep)
            nRv=iOff_3C(1,iIrrep)*nChV(iIrrep)
C           Write (*,*) 'iAddr_R(iIrrep)=',iAddr_R(iIrrep)
            If (nRv.gt.0) Then
               Call dDaFile(Lu_R(iIrrep),1,Work(ip_R),nRv,
     &                      iAddr_R(iIrrep))
            End If
         End Do
*                                                                      *
************************************************************************
*                                                                      *
C      End Do    ! klS

      Go To 100
 200  Continue
      nTask=iTask
*
*     Restore iTOffs(3,*)
      Call ICopy(nIrrep,iTtmp,1,iTOffs(3),3)
*
      Call CWTime(TCpu2,TWall2)
      Call SavTim(1,TCpu2-TCpu1,TWall2-TWall1)
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_Tsk(id)
*
*     Set up array to store the load balance if this might be needed in
*     a gradient calculation.
*
      Call GetMem('TmpList','Allo','Inte',ip_tmp,nSkal2)
      Call ICopy(nSkal2,[0],0,iWork(ip_tmp),1)
      Call GetMem('LBList','Allo','Inte',ip_LB,nSkal2)
      Call ICopy(nSkal2,[-1],0,iWork(ip_LB),1)
      Do iTask = 1, nTask
         klS = iWork(ip_iRv-1+iTask)
         iWork(ip_tmp-1+klS) = 1
      End Do
*
      iLB=0
      Do klS = 1, nSkal2
         If (iWork(ip_tmp-1+klS).eq.1) Then
            iWork(ip_LB+iLB)=klS
            iLB=iLB+1
         End If
      End Do
*
*
      Call Put_iArray('LBList',iWork(ip_LB),nSkal2)
*
      Call GetMem('LBList','Free','Inte',ip_LB,nSkal2)
      Call GetMem('TmpList','Free','Inte',ip_tmp,nSkal2)
*
      Call GetMem('Rv','Free','Real',ip_Rv,nRvMax)
      Call GetMem('3C','Free','Real',ip_3C,n3CMax)
      Call GetMem('Q-vector','Free','Real',ip_Qv,nQv)
      Call xRlsMem_Ints
      Call GetMem('TMax','Free','Real',ipTMax,nSkal)
      If (LDF) Then
         Call GetMem('SO2C','Free','Inte',ipSO2C,nSO_Aux)
         Call GetMem('A-blocks','Free','Inte',ipAB,
     &               MaxCntr*(MaxCntr+1)/2)
         Call GetMem('Local_A','Free','Real',ipLocal_A,2*nLocal_A)
         Call DaClos(Lu_AB)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Each node does now have an incomplete set of R-vectors!
*                                                                      *
************************************************************************
*                                                                      *
*     Terminate integral environment.
*
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*
      Call Free_iWork(ip_iSSOff)
      Call Free_iWork(ip_ShlSO)
      Call Free_iWork(ip_SOShl)
      Call Free_iSD()
*
*     Let go off the Q-vectors for now!
*
      Do iIrrep = 0, nIrrep-1
         nB_Aux=nBas_Aux(iIrrep)
         If (iIrrep.eq.0) nB_Aux=nB_Aux-1
         If (nB_Aux.ne.0) Call DaClos(Lu_Q(iIrrep))
      End Do
*
      If (iPrint.ge.6) Then
         Write (6,'(A)') ' 3-center integrals:'
         Call CWTime(TC0,TW0)
         Write (6,'(A,F8.2,A,/,A,F8.2,A)')
     &                  '      CPU time :',TC0-TC1,' sec.',
     &                  '      Wall time:',TW0-TW1,' sec.'
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     P A R T I A L   T R A N S P O S E   S E C T I O N                *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     For the interface to work fix the tables of Seward
*
      Call Set_Basis_Mode('Valence')
      Call SetUp_iSD
*                                                                      *
************************************************************************
*                                                                      *
*     Initialize for 2-electron integral evaluation. Do generate
*     tables for indexation.
*
      Indexation = .True.
      Call Setup_Ints(nSkal_Valence,Indexation,ThrAO,DoFock,DoGrad)
*
*     Initiate stuff for Cholesky style storage.
*
      Call IniCho_RI(nSkal_Valence,nChV,nIrrep,iTOffs,
     &               iWork(ip_iShij),nSkal2)

      Call GetMem('Addr','Allo','Inte',ip_Addr,nSkal2) ! addr for read
      Call GetMem('NuMu','Allo','INTE',iLst,2*nSkal2)
*                                                                      *
************************************************************************
*                                                                      *
*     Write out the RI vectors in Cholesky format
*
*     Here we will read one chuck from the R-vector file, while we will
*     store an as large part of the RI vectors in Cholesky format.
*
      LenVec=0
      Do iIrrep = 0, nIrrep-1
         iChoVec=0
*
         nB_Aux=nBas_Aux(iIrrep)
         If (iIrrep.eq.0) nB_Aux=nB_Aux-1
         If (nB_Aux.eq.0) Go To 998
*
         iSym = iIrrep+1
*
*        NumVec: is no longer equal to the # of auxiliary functions
*
         NumVec=iTOffs(3*iIrrep+1)
         If (NumVec.eq.0) Go To 999
*
         iWork(ip_Addr) = 0
         Do i=2,nTask  ! init the addr for reading vectors
               klS = iWork(ip_iRv-1+i-1)
               kS = iWork(ip_iShij+(klS-1)*2  )
               lS = iWork(ip_iShij+(klS-1)*2+1)
               n3C = nSize_3C(kS,lS,iWork(ip_nBasSh),nSkal-1,nIrrep,
     &                        iOff_3C,nBas_Aux)
               nMuNu = iOff_3C(1,iIrrep)
               iWork(ip_Addr+i-1) = iWork(ip_Addr+i-2) + nMuNu*NumVec
         End Do
*
         LenVec_Red = iMax_R(1,iIrrep)
         n_Rv = NumVec*LenVec_Red
         Call GetMem('Vecs','Allo','Real',ip_Rv,n_Rv)
*
*        LenVec: # of valence Gaussian products in this irrep
*
         LenVec = iMax_R(2,iIrrep)
         Call Create_Chunk(ip_iMap,ip_ChoVec,LenVec,NumVec,IncVec)
*
         Do iVec = 1, NumVec, IncVec
            NumVec_ = Min(NumVec-iVec+1,IncVec)
*                                                                      *
************************************************************************
*                                                                      *
*           Read now the R-vectors for a fixed shell-pair and
*           irrep, but for all auxiliary functions.
*
            mMuNu=0
            Do klS = 1, nSkal2
               kS = iWork(ip_iShij+(klS-1)*2  )
               lS = iWork(ip_iShij+(klS-1)*2+1)
               n3C = nSize_3C(kS,lS,iWork(ip_nBasSh),nSkal-1,nIrrep,
     &                        iOff_3C,nBas_Aux)
               nMuNu = iOff_3C(1,iIrrep)
               m3C = nMuNu * NumVec_
*
               If (m3C.le.0) Go To 555
*
               MuNu_s=mMuNu+1
               MuNu_e=mMuNu+nMuNu
*
               iWork(iLst +(klS-1)*2  ) = MuNu_s
               iWork(iLst +(klS-1)*2+1) = MuNu_e
*
 555           Continue
               mMuNu = mMuNu + nMuNu
            End Do
*
            Do i = 1, nTask
               klS = iWork(ip_iRv-1+i)
               kS = iWork(ip_iShij+(klS-1)*2  )
               lS = iWork(ip_iShij+(klS-1)*2+1)
*
               n3C = nSize_3C(kS,lS,iWork(ip_nBasSh),nSkal-1,nIrrep,
     &                        iOff_3C,nBas_Aux)
               nMuNu = iOff_3C(1,iIrrep)
               m3C = nMuNu * NumVec_

               If (m3C.le.0) Go To 666
*
               Call dDaFile(Lu_R(iIrrep),2,Work(ip_Rv),m3C,
     &                                       iWork(ip_Addr+i-1))

*              Copy the appropriate section into the RI vectors in
*              Cholesky format.
*
               MuNu_s = iWork(iLst +(klS-1)*2  )
               MuNu_e = iWork(iLst +(klS-1)*2+1)
               j_s=1
               j_e=NumVec_
               Call Put_Chunk(ip_ChoVec,MuNu_s,MuNu_e,
     &                        j_s,j_e,Work(ip_Rv),nMuNu,LenVec)
*
 666           Continue
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*
*           Now transfer the RI vectors to disk
*
            Call Get_Chunk(ip_ChoVec,LenVec,NumVec_,iChoVec,iSym,
     &                     ip_iMap,iVec)
*
         End Do   ! iVec = 1, NumVec, IncVec
*

         Call Destroy_Chunk(ip_ChoVec,ip_iMap)
         Call GetMem('Vecs','Free','Real',ip_Rv,n_Rv)
*
 999     Continue
*
*        Let go off the R-vectors for good!
*
         Call DaClos(Lu_R(iIrrep))
 998     Continue
         NoChoVec(iIrrep)=iChoVec
*
      End Do    ! iIrrep
      Call GetMem('NuMu','Free','INTE',iLst,2*nSkal2)
      Call GetMem('Addr','Free','Inte',ip_Addr,nSkal2)
      Call GetMem('iRv','Free','Inte',ip_iRv,nSkal2)
      Call Free_iWork(ip_nBasSh)
      Call Free_iWork(ip_iShij)
*                                                                      *
************************************************************************
*                                                                      *
      iPass = 1
      iRed = 1
      Call Cho_RI_PutInfo(iPass,iRed)
*                                                                      *
************************************************************************
*                                                                      *
*     Terminate integral environment.
*
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
*
      If (iPrint.ge.6) Then
         Write (6,'(A)') ' Block-transpose:'
         Call CWTime(TC1,TW1)
         Write (6,'(A,F8.2,A,/,A,F8.2,A)')
     &                  '      CPU time :',TC1-TC0,' sec.',
     &                  '      Wall time:',TW1-TW0,' sec.'
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     D I A G O N A L   S E C T I O N                                  *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      nDiag = 0
      Do iIrrep = 0, nIrrep-1
         nDiag = nDiag+nBas(iIrrep)
      End Do
      nDiag = nDiag*(nDiag+1)/2
      Call Allocate_Work(ipDiag,nDiag)
      Call FZero(Work(ipDiag),nDiag)
*
      Call Drv2El_RI_Diag(ThrAO,Work(ipDiag),nDiag)
*
*     Write the diagonal to disk
*
      Call Cho_IODiag(Work(ipDiag),1)
*
      Call Free_Work(ipDiag)
*
      If (iPrint.ge.6) Then
         Write (6,*) 'Diagonal vector:'
         Call CWTime(TC0,TW0)
         Write (6,'(A,F8.2,A,/,A,F8.2,A)')
     &                  '      CPU time :',TC0-TC1,' sec.',
     &                  '      Wall time:',TW0-TW1,' sec.'
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Terminate Cholesky stuff here.
*
      irc = 0
      Call TermCho_RI(irc,NoChoVec,8)
      If (irc .ne. 0) Then
         Write(6,*) 'TermCho_RI returned ',irc
         Call SysAbendMsg('Drv2El_3Center_RI',
     &                    'Cholesky termination failed!',' ')
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE SHTOOB(  NSHPIR,  NIRREP,  MXPOBS,   NSMOB,  NOSPIR,
     &                    IOSPIR,   NOBPS,     NOB)
*
* Number of shells per irrep => Number of orbitals per symmetry
*
* =====
* Input
* =====
*
*  NSHPIR : Number of shells per irrep
*  NIRREP : Number of irreps
*  MXPOBS : Largest allowed number of orbitals symmetries
*  NSMOB  : Number of orbital symmetries
*  NOSPIR : Number of orbital symmetries per irrep
*  IOSPIR : Orbital symmetries per irrep
*
* ======
* Output
* ======
*  NOBPS  : Number of orbitals per symmetry
*  NOB    : Number of orbitals
*
* Jeppe Olsen, Winter of 1991
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION NSHPIR(*),NOSPIR(*),IOSPIR(MXPOBS,*)
*. Output
      DIMENSION NOBPS(*)
      CALL ISETVC(NOBPS,0,NSMOB)
      NOB = 0
      DO 100 IRREP = 1, NIRREP
        DO 90 ISM = 1, NOSPIR(IRREP)
          IISM = IOSPIR(ISM,IRREP)
          NOBPS(IISM) = NOBPS(IISM) + NSHPIR(IRREP)
          NOB = NOB + NSHPIR(IRREP)
   90   CONTINUE
  100 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
         WRITE(6,*) ' SHTOOB Speaking '
         WRITE(6,*) ' =============== '
         WRITE(6,*) ' Number of orbitals obtained ', NOB
         WRITE(6,*) ' Number of orbitals per symmetry '
         CALL IWRTMA(NOBPS,1,NSMOB,1,NSMOB)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005,2008, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine ChoMP2_DecChk(irc,iSym,Col,nDim,nCol,Wrk,lWrk,
     &                         ErrStat)
C
C     Thomas Bondo Pedersen, Jan. 2008.
C
C     Purpose: check Cholesky decomposition of the (ai|bj) integrals
C              or MP2 amplitudes (sym. block iSym).
C              The columns of the matrix are
C              compared nCol columns at a time. This
C              implies that the memory requirement of this routine
C              should be limited to approximately that of the
C              decomposition itself. Note, however, that since all
C              integrals are computed, this routine will consume
C              significantly more CPU time.
C              Files are assumed open.
C              On exit,
C              ErrStat(1) = min error
C              ErrStat(2) = max error
C              ErrStat(3) = rms error
C
      Implicit None
      Integer irc, iSym
      Integer nDim, nCol
      Real*8  Col(nDim,nCol)
      Integer lWrk
      Real*8  Wrk(lWrk)
      Real*8  ErrStat(3)
#include "chomp2_dec.fh"

      Character*6  ThisNm
      Character*13 SecNam
      Parameter (SecNam = 'ChoMP2_DecChk', ThisNm = 'DecChk')


      If (iOption_MP2CD .eq. 1) Then ! (ai|bj) int
         Call ChoMP2_DecChk_1(irc,iSym,Col,nDim,nCol,Wrk,lWrk,ErrStat)
      Else If (iOption_MP2CD .eq. 2) Then ! MP2 amp
         Call ChoMP2_DecChk_2(irc,iSym,Col,nDim,nCol,Wrk,lWrk,ErrStat)
      Else
         Write(6,*) SecNam,': WARNING! ',
     &              'Unknown option, iOption_MP2CD = ', iOption_MP2CD
         irc = -123456
      End If


      End
      SubRoutine ChoMP2_DecChk_1(irc,iSym,Col,nDim,nCol,Wrk,lWrk,
     &                           ErrStat)
C
C     Thomas Bondo Pedersen, Jan. 2005.
C
C     Purpose: check MP2 decomposition of the (ai|bj) integrals
C              (sym. block iSym). The columns of the (ai|bj) matrix are
C              compared nCol columns at a time. This
C              implies that the memory requirement of this routine
C              should be limited to approximately that of the
C              decomposition itself. Note, however, that since all
C              integrals are computed, this routine will consume
C              significantly more CPU time.
C              Files are assumed open.
C              On exit,
C              ErrStat(1) = min error
C              ErrStat(2) = max error
C              ErrStat(3) = rms error
C
      use ChoMP2, only: OldVec
#include "implicit.fh"
      Real*8  Col(nDim,nCol), Wrk(lWrk), ErrStat(3)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"
#include "WrkSpc.fh"

      external ddot_

      Character*8  ThisNm
      Character*15 SecNam
      Parameter (SecNam = 'ChoMP2_DecChk_1', ThisNm = 'DecChk_1')

      irc = 0

C     Check dimensions.
C     -----------------

      If (nDim.lt.1 .or. nCol.lt.1) Return
      If (nDim .ne. nT1am(iSym)) Then
         irc = -1
         Go To 1 ! exit
      End If

C     Initialize.
C     -----------

      ErrStat(1) =  9.9d15
      ErrStat(2) = -9.9d15
      ErrStat(3) =  0.0d0

C     Set up batching over columns of the (ai|bj) matrix.
C     ---------------------------------------------------

      NumCol  = min(nCol,nT1am(iSym))
      nBatCol = (nT1am(iSym) - 1)/NumCol + 1

C     Start column batch loop.
C     ------------------------

      Nai = nDim
      Do iBatCol = 1,nBatCol

C        Set batch info.
C        ---------------

         If (iBatCol .eq. nBatCol) Then
            Nbj = nT1am(iSym) - NumCol*(nBatCol - 1)
         Else
            Nbj = NumCol
         End If
         ibj1 = NumCol*(iBatCol - 1) + 1

C        Compute integrals from "new" vectors.
C        -------------------------------------

         lU     = lUnit_F(iSym,2)
         NumVec = nMP2Vec(iSym)
         Fac    = 0.0d0
         Call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,
     &                          Wrk,lWrk,Fac)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_DecChk_Int returned ',irc,' [1]'
            irc = 1
            Go To 1
         End If

C        Compute "old" and subtract "new".
C        ---------------------------------

         If (InCore(iSym)) Then
            Call DGEMM_('N','T',Nai,Nbj,NumCho(iSym),
     &                 1.0d0,OldVec,Nai,OldVec(ibj1),Nai,
     &                 -1.0d0,Col,Nai)
         Else
            lU     = lUnit_F(iSym,1)
            NumVec = NumCho(iSym)
            Fac    = -1.0d0
            Call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,
     &                             Wrk,lWrk,Fac)
            If (irc .ne. 0) Then
               Write(6,*) SecNam,': ChoMP2_DecChk_Int returned ',irc,
     &                    ' [2]'
               irc = 2
               Go To 1
            End If
         End If

C        Compute error stats.
C        --------------------

         Do kbj = 1,Nbj
            Do kai = 1,Nai
               ErrStat(1) = min(ErrStat(1),Col(kai,kbj))
               ErrStat(2) = max(ErrStat(2),Col(kai,kbj))
            End Do
         End Do
         ErrStat(3) = ErrStat(3) + dDot_(Nai*Nbj,Col,1,Col,1)

      End Do

C     Compute rms error.
C     ------------------

      xdim = dble(Nai)*dble(Nai)
      ErrStat(3) = sqrt(ErrStat(3)/xdim)

    1 Continue
      End
      SubRoutine ChoMP2_DecChk_2(irc,iSym,Col,nDim,nCol,Wrk,lWrk,
     &                           ErrStat)
C
C     Thomas Bondo Pedersen, Jan. 2008.
C
C     Purpose: check MP2 decomposition of the MP2 amplitudes
C              (sym. block iSym). The columns of the matrix are
C              compared nCol columns at a time. This
C              implies that the memory requirement of this routine
C              should be limited to approximately that of the
C              decomposition itself. Note, however, that since all
C              integrals are computed, this routine will consume
C              significantly more CPU time.
C              Files are assumed open.
C              On exit,
C              ErrStat(1) = min error
C              ErrStat(2) = max error
C              ErrStat(3) = rms error
C
      use ChoMP2, only: OldVec
#include "implicit.fh"
      Real*8  Col(nDim,nCol), Wrk(lWrk), ErrStat(3)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"
#include "WrkSpc.fh"

      external ddot_

      integer a, b

      Character*8  ThisNm
      Character*15 SecNam
      Parameter (SecNam = 'ChoMP2_DecChk_2', ThisNm = 'DecChk_2')

      MulD2h(k,l)=iEOr(k-1,l-1)+1
      Evir(k)=Work(ip_EVir-1+k)
      EOcc(k)=Work(ip_EOc-1+k)

      irc = 0

C     Check dimensions.
C     -----------------

      If (nDim.lt.1 .or. nCol.lt.1) Return
      If (nDim .ne. nT1am(iSym)) Then
         irc = -1
         Go To 1 ! exit
      End If

C     Initialize.
C     -----------

      ErrStat(1) =  9.9d15
      ErrStat(2) = -9.9d15
      ErrStat(3) =  0.0d0

C     Set up batching over columns of the (ai|bj) matrix.
C     ---------------------------------------------------

      NumCol  = min(nCol,nT1am(iSym))
      nBatCol = (nT1am(iSym) - 1)/NumCol + 1

C     Start column batch loop.
C     ------------------------

      Nai = nDim
      Do iBatCol = 1,nBatCol

C        Set batch info.
C        ---------------

         If (iBatCol .eq. nBatCol) Then
            Nbj = nT1am(iSym) - NumCol*(nBatCol - 1)
         Else
            Nbj = NumCol
         End If
         ibj1 = NumCol*(iBatCol - 1) + 1

C        Compute amplitudes from "old" vectors.
C        --------------------------------------

         If (InCore(iSym)) Then
            Call DGEMM_('N','T',Nai,Nbj,NumCho(iSym),
     &                 1.0d0,OldVec,Nai,OldVec(ibj1),Nai,
     &                 0.0d0,Col,Nai)
         Else
            lU     = lUnit_F(iSym,1)
            NumVec = NumCho(iSym)
            Fac    = 0.0d0
            Call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,
     &                             Wrk,lWrk,Fac)
            If (irc .ne. 0) Then
               Write(6,*) SecNam,': ChoMP2_DecChk_Int returned ',irc,
     &                    ' [2]'
               irc = 2
               Go To 1
            End If
         End If

         ibj0 = ibj1 - 1
         Do iCol = 1,Nbj
            ibj = ibj0 + iCol
            Call ChoMP2_Col_Invai(ibj,iSym,b,iSymb,j,iSymj)
            Ebj = EVir(iVir(iSymb)+b) - Eocc(iOcc(iSymj)+j)
            Do iSymi = 1,nSym
               iSyma = MulD2h(iSymi,iSym)
               Do i = 1,nOcc(iSymi)
                  iai0 = iT1am(iSyma,iSymi) + nVir(iSyma)*(i-1)
                  Do a = 1,nVir(iSyma)
                     iai = iai0 + a
                     DE = EVir(iVir(iSyma)+a) - EOcc(iOcc(iSymi)+i)
     &                  + Ebj
                     Col(iai,iCol) = Col(iai,iCol)/DE
                  End Do
               End Do
            End Do
         End Do

C        Compute amplitudes from "new" vectors and subtract "old".
C        ---------------------------------------------------------

         lU     = lUnit_F(iSym,2)
         NumVec = nMP2Vec(iSym)
         Fac    = -1.0d0
         Call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,
     &                          Wrk,lWrk,Fac)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_DecChk_Int returned ',irc,' [1]'
            irc = 1
            Go To 1
         End If

C        Compute error stats.
C        --------------------

         Do kbj = 1,Nbj
            Do kai = 1,Nai
               ErrStat(1) = min(ErrStat(1),Col(kai,kbj))
               ErrStat(2) = max(ErrStat(2),Col(kai,kbj))
            End Do
         End Do
         ErrStat(3) = ErrStat(3) + dDot_(Nai*Nbj,Col,1,Col,1)

      End Do

C     Compute rms error.
C     ------------------

      xdim = dble(Nai)*dble(Nai)
      ErrStat(3) = sqrt(ErrStat(3)/xdim)

    1 Continue
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LSDA5_emb(mGrid,Rho,nRho,P2_ontop,
     &                     nP2_ontop,nDmat,F_xc,
     &                     dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,
     &                     T_X)
************************************************************************
*                                                                      *
* Object:                                                              *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "hflda.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),
     &       P2_ontop(nP2_ontop,mGrid), F_xc(mGrid),
     &       dF_dP2ontop(ndF_dP2ontop,mGrid)
      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
*
************************************************************************
*
*---- Thomas-Fermi Kinetic energy functional
*
      Coeff=One
      Call TF_Ts(mGrid,Rho,nRho,nDmat,F_xc,
     &                 dF_dRho,ndF_dRho,Coeff,T_X)

      If (KEonly) Return
*
*---- LSDA5 for exchange-correlation energy functional
*
      Call LSDA5(mGrid,Rho,nRho,P2_ontop,
     &                 nP2_ontop,nDmat,F_xc,
     &                 dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,
     &                 T_X)

*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine change0_cvb()
#include "rls_cvb.fh"

      call touch_cvb('MEM0')
      release(1)=.false.
      return
      end
      function chpcmp_cvb(itst)
      implicit real*8 (a-h,o-z)
      logical chpcmp_cvb
#include "lstprm_cvb.fh"

      iprm=iprm+1
      if(iprm.gt.mxprm)then
        write(6,*)' Dimensioning error in CHPCMP!',iprm,mxprm
        call abend_cvb()
      endif
      chpcmp_cvb=(lstprm(iprm).ne.itst)
      lstprm(iprm)=itst
      return
      end
      function lchpcmp_cvb(ltst)
      implicit real*8 (a-h,o-z)
      logical lchpcmp_cvb,chpcmp_cvb
      logical ltst

      if(ltst)then
        itst=1
      else
        itst=0
      endif
      lchpcmp_cvb=chpcmp_cvb(itst)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_DiaSP()
!
! Thomas Bondo Pedersen, March 2006.
!
! Purpose: prescreening of diagonal.

use Index_Functions, only: iTri
use Cholesky, only: Cho_PreScreen, iSP2F, nnShl, nnShl_tot, nShell, Thr_PreScreen
#ifdef _DEBUGPRINT_
use Cholesky, only: LuPri
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i, ij, j
real(kind=wp) :: Tau, Tmax_All
real(kind=wp), allocatable :: TMax(:,:)

if (Cho_PreScreen) then ! prescreening with approx. diagonal

  call mma_allocate(Tmax,nShell,nShell,Label='nShell')

  call Shell_MxSchwz(nShell,Tmax)
  Tmax_All = Tmax(1,1)
  do i=2,nShell
    do j=1,i
      Tmax_All = max(Tmax_All,Tmax(i,j))
    end do
  end do

  Tau = Thr_PreScreen
  nnShl = 0
  do i=1,nShell
    do j=1,i
      if (Tmax_All*Tmax(i,j) > Tau) nnShl = nnShl+1
    end do
  end do
  call mma_allocate(iSP2F,nnShl,Label='iSP2F')

  ij = 0
  do i=1,nShell
    do j=1,i
      if (Tmax_All*Tmax(i,j) > Tau) then
        ij = ij+1
        iSP2F(ij) = iTri(i,j)
      end if
    end do
  end do

  call mma_deallocate(TMax)

else ! no prescreening, include all shell pairs.

  nnShl = nnShl_Tot
  call mma_allocate(iSP2F,nnShl,Label='iSP2F')

  do ij=1,nnShl
    iSP2F(ij) = ij
  end do

end if

#ifdef _DEBUGPRINT_
write(LuPri,*) '>>> Exit from Cho_DiaSP:'
if (Cho_PreScreen) write(LuPri,*) '    Screening threshold               : ',Tau
write(LuPri,*) '    Total number of shell pairs       : ',nnShl_Tot
write(LuPri,*) '    Contributing number of shell pairs: ',nnShl
if (nnShl_Tot /= 0) write(LuPri,*) '    Screening-%: ',1.0e2_wp*real(nnShl_Tot-nnShl,kind=wp)/real(nnShl_Tot,kind=wp)
#endif

end subroutine Cho_DiaSP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine Tr_prm_cnt(idbg,nBas_Cont,nBas_Prim)
      use Basis_Info
      use Symmetry_Info, only: nIrrep
      implicit real*8(a-h,o-z)
#include "itmax.fh"
#include "Molcas.fh"
#include "rinfo.fh"
#include "stdalloc.fh"
#include "real.fh"
      Integer icaddr(MxAO),numc(MxAO),ihelp(MxAtom,iTabMx),numb(MxAO),
     &        mcaddr(MxAO), nBas_Cont(8), nBas_Prim(0:7)
      Logical New_Center,New_l,New_m, Old_Center, Old_l
      Real*8, Dimension(:), Allocatable :: Tr
*     contracted basis, atomic basis functions
*
*     symmetry info
*
*     lant(i): number of atoms in i:th symmetry bf
*     expand the coefficient matrix into symmetry basis set
*     auxiliary
*     icaddr(i): adresses in coeff for a symmetry adapted function
*
*                                                                      *
* THIS ROUTINE ONLY WORKS WITH SPHERICAL FUNCTIONS. NO CARTESIAN D:S!  *
************************************************************************
*                                                                      *
      nSym=nIrrep
      iPrint=0
      If (iprint.ge.10.or.idbg.gt.0) then
         write(idbg,*) ' in repmat', nsym
         write(idbg,*) nSym, (nBas(i),i=0,nsym-1)
         write(idbg,*) nSym, (nrBas(i),i=1,nsym)
         write(idbg,*) nSym, (nBas_Prim(i),i=0,nsym-1)
         write(idbg,*) nSym, (nBas_Cont(i),i=1,nsym)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     set up pointer
*
      k=0
      ia=0  ! center index
      ka=0  ! shell index
      Do iCnttp=1,nCnttp
         Do icnt = 1, dbsc(iCnttp)%nCntr
            ia=ia+1
            Do la=1,nAngr(ia)+1
               ka=ka+1
               ihelp(ia,la)=k
               k=k+nPrimr(ka)*nBasisr(ka)
            End Do
         End Do
      End Do
      If (iPrint.ge.10.or.idbg.gt.0) Then
         write(idbg,*) ' Help vector'
         ia=0
         Do iCnttp=1,nCnttp
            Do icnt = 1, dbsc(iCnttp)%nCntr
               ia=ia+1
               write(idbg,'(10i5)') (ihelp(ia,j),j=1,nAngr(ia)+1)
           End Do
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Loop over irreps
*
      k=0
      Do iSym = 1, nSym
         numck=1
         numcl=0
         kbias=0
*
*        Loop over basis functions in irrep
*
         Do iCont = 1, nBas_Cont(iSym)
            k=k+1
            If (iCont.gt.1) Then
               New_Center=icent(k).ne.icent(k-1)
               New_l=lnang(k).ne.lnang(k-1)
               New_m=lmag(k).ne.lmag(k-1)
               If (New_m)  kbias=kbias-numc(k-1)
               If (New_Center.or.New_l)  kbias=0
            Else
               New_Center=.True.
               New_l=.True.
            End If
            kbias = kbias + 1
            ka=0
            ia=0
            Do iCnttp = 1, nCnttp
               Do iCnt = 1, dbsc(iCnttp)%nCntr
                  ia=ia+1
                  Do la = 1, nAngr(ia)+1
                     ka=ka+1
                     Old_Center=icent(k).eq.ia
                     Old_l=lnang(k).eq.(la-1)
                     If (idbg.gt.0) write(idbg,*) ' at numck', k,ia,
     &                   icent(k),la-1,lnang(k),ia,New_Center,New_l
                     If (Old_Center.and.Old_l) Then
                        numc(k)=nBasisr(ka)
                        numb(k)=nPrimr(ka)
                        icaddr(k)=ihelp(ia,la)+(kbias-1)*nPrimr(ka)
                        If (k.gt.1.and.kbias.eq.1) numck=numcl+numck
                        mcaddr(k)=numck
                        numcl=nPrimr(ka)
                     End If
                  End Do  ! la
               End Do     ! iCnt
            End Do        ! iCnttp
         End Do           ! iCont
      End Do              ! iSym
      k=0
      If (iPrint.ge.10.or.idbg.gt.0) then
         ic=0
         ip=0
         Do iSym = 1, nSym
            Write (idbg,*)        ' symmetry',iSym
            Write (idbg,*)        ' numb'
            Write (idbg,'(20i4)') (numb(i+ic),  i=1,nBas_Cont(iSym))
            Write (idbg,*)        ' numc'
            Write (idbg,'(20i4)') (numc(i+ic),  i=1,nBas_Cont(iSym))
            Write (idbg,*)        ' Pointer to contraction vector'
            Write (idbg,'(20i4)') (icaddr(i+ic),i=1,nBas_Cont(iSym))
            Write (idbg,*)        ' mcaddr'
            Write (idbg,'(20i4)') (mcaddr(i+ic),i=1,nBas_Cont(iSym))
            ic=ic+nBas_Cont(iSym)
            ip=ip+nBas_Prim(iSym-1)
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
      nSize=0
      Do iSym = 1, nSym
         nSize=nSize+nBas_Cont(iSym)*nBas_Prim(iSym-1)
      End Do
      Call mma_allocate(Tr,nSize,label='Tr')
      Call DCopy_(nSize,[Zero],0,Tr,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Generate the transformation matrix.
*
      ibasL=0
      iOff = 0
*
*---- Loop over irreps
*
      Do iSym = 1, nSym
*
*        loop over contracted
*
         Do iBas = 1, nBas_Cont(iSym)
            ibasL=ibasL+1
            ipbasL=mcaddr(ibasL) -1
*
*           loop over uncontracted
*
            Do iPrim=1,numb(ibasL)
               ipbasL = ipbasL+1
               index=iOff + (iBas-1)*nBas_Prim(iSym-1) + ipbasL
c              Write (*,*) iBas,ipbasL
               Tr(index)=rCof(icaddr(ibasL)+iPrim)
*
            End Do     ! iprim
         End Do
         iOff = iOff + nBas_Cont(iSym)*nBas_Prim(iSym-1)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call Put_dArray('NEMO TPC',Tr,nSize)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Tr)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Sorb2CMOs(CMO,nCMO,nD,Occ,nnB,nBas,nOrb,nSym,OrbType)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCMO, nD, nnB, nSym, nBas(nSym), nOrb(nSym)
real(kind=wp), intent(inout) :: CMO(nCMO,nD), Occ(nnB,nD)
integer(kind=iwp), intent(inout) :: OrbType(nnB,nD)
integer(kind=iwp) :: iD, iOff1, iOff2, iOrb, iSym, iTmp, jOrb, kOrb, nOcc
real(kind=wp) :: Occ_i, Occ_j
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iOff, jOff

do iD=1,nD
  iOff = 1
  jOff = 1
  do iSym=1,nSym
    call RecPrt('Occ','(10F6.2)',Occ(iOff,iD),1,nOrb(iSym))
    call RecPrt('CMO','(10F6.2)',CMO(jOff,iD),nBas(iSym),nOrb(iSym))
    iOff = iOff+nOrb(iSym)
    jOff = jOff+nBas(iSym)*nOrb(iSym)
  end do
end do
#endif

! Sort orbitals into
! 1) occupied and virtual orbitals
! 2) within each block sort according to the orbital energy

do iD=1,nD
  !write(u6,*)
  !write(u6,*) 'iD=',iD
  !write(u6,*)
  iOff1 = 0
  iOff2 = 1
  do iSym=1,nSym

    nOcc = 0

    ! Sort first the orbitals according to the occupation numbers.

    do iOrb=1,nOrb(iSym)-1

      Occ_i = Occ(iOff1+iOrb,iD)
      !write(u6,*) 'Occ_i,iOrb=',Occ_i,iOrb
      kOrb = 0
      do jOrb=iOrb+1,nOrb(iSym)
        Occ_j = Occ(iOff1+jOrb,iD)
        !write(u6,*) 'Occ_j,jOrb=',Occ_j,jOrb
        if ((Occ_i == Zero) .and. (Occ_j > Occ_i)) then
          Occ_i = Occ_j
          kOrb = jOrb
        end if
      end do
      !write(u6,*) 'kOrb=',kOrb
      if (kOrb /= 0) then
        iTmp = OrbType(iOff1+iOrb,iD)
        OrbType(iOff1+iOrb,iD) = OrbType(iOff1+kOrb,iD)
        OrbType(iOff1+kOrb,iD) = iTmp

        Occ_i = Occ(iOff1+iOrb,iD)
        Occ(iOff1+iOrb,iD) = Occ(iOff1+kOrb,iD)
        Occ(iOff1+kOrb,iD) = Occ_i
        call DSwap_(nBas(iSym),CMO(iOff2+(iOrb-1)*nBas(iSym),iD),1,CMO(iOff2+(kOrb-1)*nBas(iSym),iD),1)
      end if

      if (Occ(iOff1+iOrb,iD) /= Zero) nOcc = nOcc+1

    end do

    iOff1 = iOff1+nOrb(iSym)
    iOff2 = iOff2+nBas(iSym)*nOrb(iSym)
  end do    ! iSym
end do      ! iD
#ifdef _DEBUGPRINT_
do iD=1,nD
  iOff = 1
  jOff = 1
  do iSym=1,nSym
    call RecPrt('Occ','(10F6.2)',Occ(iOff,iD),1,nOrb(iSym))
    call RecPrt('CMO','(10F6.2)',CMO(jOff,iD),nBas(iSym),nOrb(iSym))
    iOff = iOff+nOrb(iSym)
    jOff = jOff+nBas(iSym)*nOrb(iSym)
  end do
end do
#endif

return

end subroutine Sorb2CMOs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************
subroutine UnzipP2(P2Unzip,P2MO,nP2Act)

use nq_Info, only: iOff_Ash, mIrrep, NASH, NASHT
use Index_Functions, only: iTri
use Constants, only: One, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: P2Unzip(NASHT,NASHT,NASHT,NASHT)
integer(kind=iwp), intent(in) :: nP2Act
real(kind=wp), intent(in) :: P2MO(nP2Act)
integer(kind=iwp) :: I, IAct, iIrrep, IJ, IJKL, J, JAct, jIrrep, K, kAct, kIrrep, KL, L, LAct, lIrrep
real(kind=wp) :: Fact

if (NASHT == 0) return

do IIrrep=0,mIrrep-1
  do I=1,NASH(iIrrep)
    IAct = iOff_Ash(iIrrep)+I
    do jIrrep=0,mIrrep-1
      do J=1,NASH(JIrrep)
        JAct = iOff_Ash(JIrrep)+J
        IJ = iTri(IAct,JAct)
        do kIrrep=0,mIrrep-1
          do K=1,NASH(KIrrep)
            KAct = IOff_Ash(KIrrep)+K
            do lIrrep=0,mIrrep-1
              do L=1,NASH(lIrrep)
                LAct = IOff_Ash(LIrrep)+L
                KL = iTri(KAct,LAct)
                IJKL = iTri(ij,kl)
                Fact = Half
                if ((ij >= kl) .and. (kAct == lAct)) Fact = One
                if ((kl >= ij) .and. (iAct == jAct)) Fact = One
                P2Unzip(LAct,KAct,JAct,IAct) = P2MO(ijkl)*Fact
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end do

return

end subroutine UnzipP2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_UnsetAtomPairInfo(irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: Unset atom pair info stored in ldf_atom_pair_info.fh
C              I.e. free memory allocated for this information and
C              garble the rest.
C
C     Return codes:
C       irc=0: success
C       irc=1: not set, i.e. info already unset and nothing is done
C
      Implicit None
      Integer irc
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

      Character*8 Label

      Integer iAtomPair
      Integer ip, l

      Integer  LDF_AtomPair_DiagDim
      External LDF_AtomPair_DiagDim

      Integer i, j
      Integer AP_2CFunctions, AP_1CLinDep
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)

      ! Init return code
      irc=0

      ! Check status
      If (LDF_AtomPairInfo_Status.eq.LDF_AtomPairInfo_Unset) Then
         Call WarningMessage(2,'LDF_UnsetAtomPairInfo: already unset!')
         irc=1
         Return
      End If

      ! Deallocate disk addresses for C
      Call GetMem('AP_DiskC','Free','Inte',ip_AP_DiskC,l_AP_DiskC)
      ip_AP_DiskC=0
      l_AP_DiskC=0

      ! Deallocate unique atom pairs
      Call GetMem('AP_Unique','Free','Inte',ip_AP_Unique,l_AP_Unique)
      ip_AP_Unique=0
      l_AP_Unique=0

      ! Deallocate AP_2CFunctions
      Do iAtomPair=1,NumberOfAtomPairs
         l=4*AP_2CFunctions(1,iAtomPair)
         If (l.gt.0) Then
            Write(Label,'(A,I5.5)') '2CF',iAtomPair-1
            ip=AP_2CFunctions(2,iAtomPair)
            Call GetMem(Label,'Free','Inte',ip,l)
         End If
      End Do
      Call GetMem('AP2CFN','Free','Inte',ip_AP_2CFunctions,
     &                                    l_AP_2CFunctions)
      ip_AP_2CFunctions=0
      l_AP_2CFunctions=0

      ! Deallocate AP_1CLinDep
      Do iAtomPair=1,NumberOfAtomPairs
         l=3*AP_1CLinDep(1,iAtomPair)
         If (l.gt.0) Then
            Write(Label,'(A,I5.5)') '1CL',iAtomPair-1
            ip=AP_1CLinDep(2,iAtomPair)
            Call GetMem(Label,'Free','Inte',ip,l)
         End If
      End Do
      Call GetMem('AP1CLD','Free','Inte',ip_AP_1CLinDep,l_AP_1CLinDep)
      ip_AP_1CLinDep=0
      l_AP_1CLinDep=0

      ! Deallocate diagonal blocks
      Call LDF_DeallocateBlockMatrix('APD',ip_AP_Diag)
      ip_AP_Diag=0
      l_AP_Diag=0
      Call LDF_DeallocateBlockMatrix('APB',ip_AP_DiagBak)
      ip_AP_DiagBak=0
      l_AP_DiagBak=0

      ! Deallocate AP_Atoms
      Call GetMem('LDFAPA','Free','Inte',ip_AP_Atoms,l_AP_Atoms)
      ip_AP_Atoms=0
      l_AP_Atoms=0

      ! Zero number of atom pairs
      NumberOfAtomPairs=0

      ! Mark info unset
      LDF_AtomPairInfo_Status=LDF_AtomPairInfo_Unset

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module PSO_Stuff

use Data_structures, only: DSBA_Type
use Definitions, only: wp, iwp

! --- Stuff for Aces 2 read of Gamma file:
! Bin G_Toc Gamma_On lBin LuGamma nGamma nSSDM SO2cI SSDM
!
! --- Stuff for CASTP2 Gradient
! CASPT2_On ReadBPT2 CMOPT2 WRK1 WRK2(:) LuCMOPT2 LuGamma_PT2 LuGamma2 nOcc nFro iOffAO nCalAO

implicit none
private

integer(kind=iwp) :: iD0Lbl, iOff_ij2K(8), kCMO, lBin, LuCMOPT2, LuGam, LuGamma, LuGamma2, LuGamma_PT2, m_Txy, mCMO, mG1, mG2, &
                     n_ij2K, n_Txy, nBasA, nBasASQ, nBasT, nCalAO, nDens, nFro(8), nG1, nG2, nGamma, nnP(0:7), nOcc(8), &
                     npos(0:7,3), nSOs1, nSSDM, nV_K, nZ_p_k
logical(kind=iwp) :: Case_2C, Case_3C, Case_mp2, CASPT2_On = .false., Gamma_mrcisd, Gamma_On, lPSO, lsa, NO_NUC, ReadBPT2 = .false.
character(len=7) :: FnGam
integer(kind=iwp), allocatable :: ij2K(:), iOffAO(:), SO2ci(:,:)
real(kind=wp), allocatable :: A_PT2(:,:), B_PT2(:,:,:), Bin(:,:), CMO(:,:), CMOPT2(:), D0(:,:), DMdiag(:,:), DS(:), DSVar(:), &
                              DVar(:,:), G1(:,:), G2(:,:), G_Toc(:), SSDM(:,:,:), Thpkl(:), Txy(:,:), U_k(:), V_k(:,:), WRK1(:), &
                              WRK2(:), Z_p_k(:,:)
type(DSBA_Type), allocatable, target :: AOrb(:)

public :: A_PT2, AOrb, B_PT2, Bin, Case_2C, Case_3C, Case_mp2, CASPT2_On, CMO, CMOPT2, D0, DMdiag, DS, DSVar, DVar, FnGam, G1, G2, &
          G_Toc, Gamma_mrcisd, Gamma_On, iD0Lbl, ij2K, iOff_ij2K, iOffAO, kCMO, lBin, lPSO, lsa, LuCMOPT2, LuGam, LuGamma, &
          LuGamma2, LuGamma_PT2, m_Txy, mCMO, mG1, mG2, n_ij2K, n_Txy, nBasA, nBasASQ, nBasT, nCalAO, nDens, nFro, nG1, nG2, &
          nGamma, nnP, NO_NUC, nOcc, npos, nSOs1, nSSDM, nV_K, nZ_p_k, ReadBPT2, SO2cI, SSDM, Thpkl, Txy, U_k, V_k, WRK1, WRK2, &
          Z_p_k

end module PSO_Stuff

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_grc32y(a,b,c,mvec,ssa,ssb,ix)

use CCT3_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
type(Map_Type), intent(in) :: a, b
type(Map_Type), intent(inout) :: c
integer(kind=iwp), intent(out) :: mvec(4096,7), ix
integer(kind=iwp), intent(in) :: ssa, ssb
integer(kind=iwp) :: ia, ib, iy, nhelp1, nhelp2, nhelp4, nhelp41, nhelp42, ntest2, posct, sa1, sa2, sa23, sa3, sb1, sb2

! structure A(p,qr)*B(qr)=YC(p)

!1.0  prepare c%d,c%i

call cct3_grc0(1,0,a%d(0,1),0,0,0,mmul(ssa,ssb),c,posct)

!1.1 define limitations - A p,q>r must be tested - ntest1
!                       - B p>q must be tested - ntest2

!if (a%d(0,6) == 2) then
!  ntest1 = 1
!else
!  ntest1 = 0
!end if

if (b%d(0,6) == 1) then
  ntest2 = 1
else
  ntest2 = 0
end if

!1.2 def symm states and test the limitations

ix = 0
do sb1=1,nsym
  sa2 = sb1

  sb2 = mmul(ssb,sb1)
  sa3 = sb2
  sa23 = mmul(sa2,sa3)
  ! Meggie out
  if ((ntest2 == 1) .and. (sb1 < sb2)) cycle

  sa1 = mmul(ssa,sa23)

  !1.3 def mvec,c%d and c%i

  ia = a%i(sa1,sa2,1)
  ib = b%i(sb1,1,1)
  iy = c%i(1,1,1)

  ! yes/no
  if ((a%d(ia,2) > 0) .and. (b%d(ib,2) > 0)) then
    nhelp1 = 1
  else
    cycle
  end if

  ! rowA
  nhelp2 = dimm(a%d(0,1),sa1)

  ! sum
  nhelp41 = dimm(a%d(0,2),sa2)
  nhelp42 = dimm(a%d(0,3),sa3)
  if ((ntest2 == 1) .and. (sa2 == sa3)) then
    nhelp4 = nhelp41*(nhelp41-1)/2
  else
    nhelp4 = nhelp41*nhelp42
  end if

  ix = ix+1
  mvec(ix,1) = nhelp1
  mvec(ix,2) = a%d(ia,1)
  mvec(ix,3) = b%d(ib,1)
  mvec(ix,4) = c%d(iy,1)
  mvec(ix,5) = nhelp2
  mvec(ix,6) = nhelp4
  mvec(ix,7) = 0

end do

return

end subroutine cct3_grc32y

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Anders Bernhardsson                              *
*               1994, Roland Lindh                                     *
************************************************************************
      SubRoutine CmbnS2a(Rnxyz,nZeta,la,lb,rKappa,Final,Alpha,
     &                  IfHss,ld)
************************************************************************
*                                                                      *
* Object: compute the 2nd derivative  of the overlap matrix.           *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
c#include "print.fh"
#include "real.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6),
     &       rKappa(nZeta),
     &       Rnxyz(nZeta,3,0:la+ld,0:lb), Alpha(nZeta)
      Logical IfHss(4,3,4,3)
      Integer ia(3),ib(3)
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
*     Index in the triang. local hessian
*
       iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*
      Do 10 iax = 0, la
         ia(1)=iax
         iyaMax=la-ia(1)
      Do 11 ibx = 0, lb
         ib(1)=ibx
         iybMax=lb-ib(1)
         Do 20 iay = 0, iyaMax
            ia(2)=iay
            ia(3) = la-ia(2)-ia(1)
            ipa= Ind(la,ia(1),ia(3))
         Do 21 iby = 0, iybMax
            ib(2)=iby
          ib(3) = lb-ib(2)-ib(1)
          ipb= Ind(lb,ib(1),ib(3))
*
*
*           Combine overlap integrals
*
*           Integrals like dI/dx1dx1
*
          Do 5 iCoor=1,3
            jCoor=Mod(iCoor,3)+1
            kCoor=Mod(jCoor,3)+1
            If (IfHss(1,iCoor,1,iCoor)) Then
                  Do 30 iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,itri(iCoor,iCoor))=rKappa(iZeta)*
     &                   ((Two*Alpha(iZeta))**2 *
     &                   Rnxyz(iZeta,iCoor,ia(iCoor)+2,ib(iCoor))*
     &                   Rnxyz(iZeta,jCoor,ia(jCoor),  ib(jCoor))*
     &                   Rnxyz(iZeta,kCoor,ia(kCoor),  ib(kCoor))-
     &                   Two *  Alpha(iZeta) *
     &                   Rnxyz(iZeta,iCoor,ia(iCoor),ib(iCoor))*
     &                   Rnxyz(iZeta,jCoor,ia(jCoor),ib(jCoor))*
     &                   Rnxyz(iZeta,kCoor,ia(kCoor),ib(kCoor)))
                     If (ia(iCoor).gt.0) Then
                        Final(iZeta,ipa,ipb,itri(iCoor,iCoor)) =
     &                      Final(iZeta,ipa,ipb,itri(iCoor,iCoor))
     &                      - rKappa(iZeta)*
     &                      (Four *  Alpha(iZeta)* Dble(ia(iCoor)) *
     &                      Rnxyz(iZeta,iCoor,ia(iCoor),ib(iCoor))*
     &                      Rnxyz(iZeta,jCoor,ia(jCoor),ib(jCoor))*
     &                      Rnxyz(iZeta,kCoor,ia(kCoor),ib(kCoor)))
                     End If
                     If (ia(iCoor).gt.1) Then
                        Final(iZeta,ipa,ipb,itri(iCoor,iCoor)) =
     &                      Final(iZeta,ipa,ipb,itri(iCoor,iCoor))
     &                      + rKappa(iZeta)*
     &                      (Dble(ia(iCoor)*(ia(iCoor)-1))*
     &                      Rnxyz(iZeta,iCoor,ia(iCoor)-2,ib(iCoor))*
     &                      Rnxyz(iZeta,jCoor,ia(jCoor),  ib(jCoor))*
     &                      Rnxyz(iZeta,kCoor,ia(kCoor),  ib(kCoor)))
                     End If
 30               Continue
            End If
 5       Continue
*

*
*           Integrals like dI/dxdz
*
            Do 56 iCoor=2,3
            Do 52 jCoor=1,iCoor-1
                 If (IfHss(1,iCoor,1,jCoor)) Then
                  Do 51 kCoor=1,3
                    Do 50 iZeta = 1, nZeta
                     If (kCoor.eq.1) Then
                        Final(iZeta,ipa,ipb,
     &                       itri(iCoor,jCoor))= rKappa(iZeta)
                     End If
                     If ((kCoor.eq.iCoor).or.(kCoor.eq.jCoor)) Then
                        rIc=Two*Alpha(iZeta)*
     &                      Rnxyz(iZeta,kCoor,ia(kCoor)+1,ib(kCoor))
*
                        If (ia(kCoor).gt.0)
     &                    rIc=rIc-Dble(ia(kCoor))*
     &                       Rnxyz(iZeta,kCoor,ia(kCoor)-1,ib(kCoor))
*
                        Final(iZeta,ipa,ipb,
     &                        itri(iCoor,jCoor))=
     &                  Final(iZeta,ipa,ipb,
     &                        itri(iCoor,jCoor))*
     &                                       rIc
                     Else
                        Final(iZeta,ipa,ipb,
     &                        itri(iCoor,jCoor))=
     &                  Final(iZeta,ipa,ipb,
     &                        itri(iCoor,jCoor))*
     &                                Rnxyz(iZeta,kCoor,ia(kCoor),
     &                                ib(kCoor))
                     End If
 50               Continue
 51             Continue
                End If
 52         Continue
 56         Continue
 21      Continue
 20      Continue
 11   Continue
 10   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************
!***********************************************************************
!*                                                                     *
!*  VB2CI[CF] := VB to CASSCF transformation.                          *
!*  CI2VB[CG] := CASSCF to VB transformation.                          *
!*  VB2CIAF   := Adds first-order term in CVBDET to CAS CI vector.     *
!*                                                                     *
!*  Transformation between VB vector and CASSCF vector (both defined   *
!*  in determinant basis).                                             *
!*                                                                     *
!*  Normally a simple indexed copy of the coefficients is all that     *
!*  is required. For direct-product wavefunctions, however, a          *
!*  partial contraction is also carried out (relevant for first-       *
!*  order changes and gradient back transformation).                   *
!*                                                                     *
!*  [C] : Transforms coefficients.                                     *
!*  [F] : Transforms a first-order change of the coefficients.         *
!*  [G] : Transforms a gradient-type quantity.                         *
!*                                                                     *
!***********************************************************************

subroutine vb2cif_cvb(cvbdet,civec)

use casvb_global, only: iapr, icnt_ci, iform_ci, ixapr, ndet, ndetvb, nfrag, vbdet
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: cvbdet(ndetvb), civec(0:ndet)
integer(kind=iwp) :: icivec
real(kind=wp) :: dum

icivec = nint(civec(0))

if (iform_ci(icivec) /= 0) then
  write(u6,*) ' Unsupported format in VB2CI :',iform_ci(icivec)
  call abend_cvb()
end if
if (nfrag <= 1) then
  call ci2vb2_cvb(civec(1:),cvbdet,iapr,ixapr,dum,1)
else
  call dpci2vb_cvb(civec(1:),cvbdet,vbdet,1,dum,1)
end if
icnt_ci(icivec) = 0

return

end subroutine vb2cif_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine PrintLine(unit,line,len,isBinLuscus)
************************************************************************
* Adapted from SAGIT to work with OpenMolcas (October 2020)            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "grid.fh"
      character line*128
      integer unit
      integer len,ll,li

      if (ISLUSCUS .eq. 1) then
        ll=len
        li=isBinLuscus
c       print *,'before pl ',line,' ',ll,li
        call prt_lusc(unit, line, ll,li)
      else
        if (isBinary .eq. 1) then
          write (unit) line(1:len)
        else
          write (unit,'(A)') line(1:len)
        endif
      end if
      Return
      End
***

************************************************************************
      SubRoutine PrintHeader(nMOs,nShowMOs,nShowMOs_ab,nCoor,nInc,
     &  iiCoord,nTypes,iCRSIZE,NBYTES,NINLINE,nBlocks )
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "grid.fh"
      character line*128
      Integer nTypes(7)
      LuVal_=LuVal
      if(isLUSCUS.eq.1) LuVal_=LID
      nShowMOs_=nShowMOs
c      call bXML('Header')
c      call iXML('UHF',isUHF)
      do iiUHF=0,isUHF
      if(iiUHF.eq.1) then
      LuVal_=LuVal_ab
      if(isLUSCUS.eq.1) LuVal_=LID_ab
      nShowMOs_=nShowMOs_ab
      endif
      IF (ISLUSCUS .EQ. 1) THEN
C debug
C        write(*,*) 'N_of_MO=', nMOs
C        write(*,*) 'N_of_Grids=', nShowMOs_
C        write(*,*) 'N_of_Points=', nCoor
C        write(*,*) 'Block_Size=', nInc
C        write(*,*) 'N_Blocks=', nBlocks
C        write(*,*) 'Is_cutoff=', isCutOff
C        write(*,*) 'CutOff=', Cutoff
C        write(*,*) 'N_P=', iiCoord
C end debug


        IF (nMOs .GT. 99999) THEN
          Write(6,*) 'Number of MO''s can''t be larger that 99999'
          Call Quit_OnUserError()
        END IF
        IF (nShowMOs_ .GT. 9999) THEN
          Write(6,*) 'Number of grids can''t be larger that 9999'
          Call Quit_OnUserError()
        END IF
        IF (nCoor .GT. 99999999) THEN
          Write(6,*) 'Number of points can''t be larger that 99999999'
          Call Quit_OnUserError()
        END IF
        IF (nInc .GT. 999999) THEN
          Write(6,*) 'Block size can''t be larger that 999999'
          Call Quit_OnUserError()
        END IF
        nBlocks=nCoor/nInc+1
        IF (nBlocks .GT. 9999) THEN
          Write(6,*) 'Number of blocks can''t be larger that 9999'
c          write(*,*) 'nBlocks = ', nBlocks
          Call Quit_OnUserError()
        END IF
        IF (isCutOff .GT. 9) THEN
          Write(6,*) 'Wrong cutoff'
          Call Quit_OnUserError()
        END IF
        IF (iiCoord .GT. 99999999) THEN
          Write(6,*) 'N_P can''t be larger that 99999999'
          Call Quit_OnUserError()
        END IF
        WRITE(LINE,'(''<GRID>'')')
        CALL PRINTLINE(LUVAL_, LINE,6,0)

        WRITE(LINE,1000)
     +         nMOs, nShowMOs_, nCoor, nInc, nBlocks,
     +         isCutOff, Cutoff, iiCoord
 1000   FORMAT(1X,'N_of_MO=',I5,1X,'N_of_Grids=',I4,
     +         1X,'N_of_Points=',I8,1X,'Block_Size=',I6,
     +         1X,'N_Blocks=',I4,1X,'Is_cutoff=',I1,
     +         1X,'CutOff=',F8.4,1X,'N_P=',I8)
        CALL PRINTLINE(LUVAL_, LINE, 124,0)
        WRITE(LINE,1010) (nTypes(i),i=1,7)
 1010   FORMAT(1X,'N_INDEX=',7I5)
        CALL PRINTLINE(LUVAL_, LINE, 44,0)
        if(isLUSCUS.eq.0) then
        WRITE(LINE,1020) iGridNpt(1)-1, iGridNpt(2)-1, iGridNpt(3)-1
        else
        WRITE(LINE,1020) iGridNpt(1), iGridNpt(2), iGridNpt(3)
        endif
 1020   FORMAT(1X,'Net=',3I5)
        CALL PRINTLINE(LUVAL_, LINE, 20,0)
        WRITE(LINE,1030) GridOrigin
 1030   FORMAT(1X,'Origin=',3(1X,F12.8))
        CALL PRINTLINE(LUVAL_, LINE, 47,0)
        WRITE(LINE,1040) GridAxis1
 1040   FORMAT(1X,'Axis_1=',3(1X,F12.3))
        CALL PRINTLINE(LUVAL_, LINE, 47,0)
        WRITE(LINE,1050) GridAxis2
 1050   FORMAT(1X,'Axis_2=',3(1X,F12.3))
        CALL PRINTLINE(LUVAL_, LINE, 47,0)
        WRITE(LINE,1060) GridAxis3
 1060   FORMAT(1X,'Axis_3=',3(1X,F12.3))
        CALL PRINTLINE(LUVAL_, LINE, 47,0)
c Here we dump all missing information
        if(isLUSCUS.eq.0) then
        WRITE(LINE,'(1x,A,I2)') 'CR_SIZE=',iCRSIZE
        CALL PRINTLINE(LUVAL_, LINE, 20,0)
        WRITE(LINE,'(1x,A,I2)') 'PACK=',imoPACK
        CALL PRINTLINE(LUVAL_, LINE, 20,0)
        WRITE(LINE,'(1x,A,I3)') 'BYTES=',NBYTES
        CALL PRINTLINE(LUVAL_, LINE, 20,0)
        WRITE(LINE,'(1x,A,I3)') 'N_in_Line=',NINLINE
        CALL PRINTLINE(LUVAL_, LINE, 20,0)
        NFIRST=nInc
        if(nBlocks.eq.1) NFIRST=nCoor
        WRITE(LINE,'(1x,A,I8)') 'N_FIRST=',NFIRST
        CALL PRINTLINE(LUVAL_, LINE, 20,0)

        NLAST=nCoor-(nBlocks-1)*nInc
        if(NLAST.eq.0) NLAST=nInc
        WRITE(LINE,'(1x,A,I8)') 'N_LAST=',NLAST
        CALL PRINTLINE(LUVAL_, LINE, 20,0)

        nn=(NFIRST/NINLINE)*(NBYTES*NINLINE+iCRSIZE)
        nn1=NFIRST-(NFIRST/NINLINE)*NINLINE
        if(nn1.gt.0) nn=nn+nn1*NBYTES+iCRSIZE

        WRITE(LINE,'(1x,A,I10)') 'N_OFFSET=',nn
        CALL PRINTLINE(LUVAL_, LINE, 30,0)

        nn=(NLAST/NINLINE)*(NBYTES*NINLINE+iCRSIZE)
        nn1=NLAST-(NLAST/NINLINE)*NINLINE
        if(nn1.gt.0) nn=nn+nn1*NBYTES+iCRSIZE
        WRITE(LINE,'(1x,A,I10)') 'N_LAST_OFFSET=',nn
        CALL PRINTLINE(LUVAL_, LINE, 30,0)
        endif

C
C skip file pointers
C skip end orbital section
C
      ELSE


      if(isLine.eq.0) then
       write (line,'(a,a)') 'VERSION=     ',VERSION
       call PrintLine(LuVal_,line,23,0)
c       write (line,'(a,a)') 'Extension=   ',0
c       call PrintLine(LuVal_,line,23,0)
       write (line,'(a,i10)') 'N_of_MO=     ',nMOs
c       call iXML('nMOs',nMOs)
       call PrintLine(LuVal_,line,23,0)
       write (line,'(a,i10)') 'N_of_Grids=  ',nShowMOs_
c       call iXML('nGrids',nShowMOs_)
       call PrintLine(LuVal_,line,23,0)
       write (line,'(a,i10)') 'N_of_Points= ',nCoor
c       call iXML('nPoints',nCoor)
       call PrintLine(LuVal_,line,23,0)
       write (line,'(a,i10)') 'Block_Size=  ',nInc
c       call iXML('Block Size',nInc)
       call PrintLine(LuVal_,line,23,0)
       nBlocks=nCoor/nInc+1
       write (line,'(a,i10)')   'N_Blocks=    ',nBlocks
c       call iXML('nBlocks',nBlocks)
       call PrintLine(LuVal_,line,23,0)
c new cut off
       write (line,'(a,i10)')   'Is_cutoff=   ',isCutOff
       call PrintLine(LuVal_,line,23,0)
       write (line,'(a,f10.4)') 'CutOff=      ',CutOff
       call PrintLine(LuVal_,line,23,0)
       write (line,'(a,i10)')   'N_P=         ',iiCoord
       call PrintLine(LuVal_,line,23,0)
       write (line,'(a,7I5)')   'N_INDEX=     ',nTypes
       call PrintLine(LuVal_,line,48,0)
      else
       write(line,'(a,2i10)') '# ', nShowMOs_ , nCoor
       call PrintLine(LuVal_,line,23,0)
      endif
      if (isTheOne .eq. 1) goto 777

      write (line,'(a,3i5)') 'Net=         ',iGridNpt(1)-1,
     *        iGridNpt(2)-1,iGridNpt(3)-1
c      call iaXML('Net',iGridNpt,3)
      call PrintLine(LuVal_,line,28,0)

      write (line,'(a,3f12.3)') 'Origin= ',GridOrigin
c      call daXML('Origin',GridOrigin,3)
      call PrintLine(LuVal_,line,44,0)

      write (line,'(a,3f12.3)') 'Axis_1= ',GridAxis1
c      call daXML('Axis 1',GridAxis1,3)
      call PrintLine(LuVal_,line,44,0)
      write (line,'(a,3f12.3)') 'Axis_2= ',GridAxis2
c      call daXML('Axis 2',GridAxis2,3)
      call PrintLine(LuVal_,line,44,0)
      write (line,'(a,3f12.3)') 'Axis_3= ',GridAxis3
c      call daXML('Axis 3',GridAxis3,3)
      call PrintLine(LuVal_,line,44,0)

777   continue
      END IF
      enddo
c      call eXML('Header')

      Return
      End

************************************************************************
      Subroutine OpenGrid(INPORB)
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "grid.fh"
      Character FullName*256
      Character RealName*306
      Character ss*2
      Character Env*40
      Character INPORB*(*)
      CHARACTER(LEN=512) TMPLUS
      INTEGER RC
c      logical exist
      Logical is_error
      Character Slash
      Character*12 Alpha
      INTEGER LUSOPEN
      EXTERNAL LUSOPEN
      Slash='/'

      LuOrb=isFreeUnit(46)
      iPRGM=0
      Call Chk_Vec_UHF(INPORB,LuOrb,isUHF)
      close(LuOrb)
      LuVal_ab=-99999
      if(isLuscus.eq.1) then
      Alpha='.lus'
      else
      Alpha='.grid'
      endif
      if(isUHF.eq.1) then
      if(isLuscus.eq.1) then
       Alpha='_a.lus'
      else
       Alpha='_a.grid'
      endif
      endif
      do iiUHF=0,isUHF
      if(iiUHF.eq.1) then
      if(isLuscus.eq.1) then
       Alpha='_b.lus'
      else
       Alpha='_b.grid'
      endif
      endif
      Env='WorkDir '
      Call getenvf(Env,FullName)
      iPRGM=0
      if(TheName.ne.' ') then
         call molcas_open(88,'extra.prgm')
         iPRGM=1
      endif
      if(FullName.eq.' '.or.TheName(1:1).eq.' ') then
         RealName='M2MSI'
      if(isUHF.eq.1) then
       if(isLuscus.eq.1) then
       if(iiUHF.eq.0) RealName='AM2L'
       if(iiUHF.eq.1) RealName='BM2L'
       else
       if(iiUHF.eq.0) RealName='AM2MSI'
       if(iiUHF.eq.1) RealName='BM2MSI'
       endif
      endif

      else
       l=1
       ii=1
c       fullname=outf
888     i=index(FullName(l:),Slash)
        if(i.gt.0) then
          ii=i+l
          l=l+i+1
          goto 888
        endif
        Call getenvf('Project',Project)
c        Project=FullName(ii:)
       if(TheName.eq.'NEW'.or.TheName.eq.'new'.or.TheName.eq.'New') then
        do i=1,99
         write(ss,'(i2)') i
         if(i.lt.10) ss(1:1)='0'
         RealName=FullName(1:index(FullName,' ')-1)//Slash
     +    //Project(1:index(Project,' ')-1)//'.'
     +    //ss//Alpha
        enddo

       else

         RealName=FullName(1:index(FullName,' ')-1)//Slash
     +    //Project(1:index(Project,' ')-1)//'.'
     +    //TheName(1:index(TheName,' ')-1)//Alpha
       endif
       write(6,*) 'Grid file: ',RealName(:mylen(RealName))
      endif

      if(TheName.ne.' ') then
c         open(88,file='extra.prgm')
         write(88,'(a,a,a)') ' (file) M2MSI ',
     *        RealName(1:index(RealName,' ')),'  rwsg'
c         close(88)
      endif
      if(iiUHF.eq.0) then
      LuVal=isFreeUnit(49)
      if (ISLUSCUS .EQ. 1) THEN
C FIXME: User can't define luscus input file name
        RC=-1
        if(Thename.eq.' ') then
        if(isUHF.eq.0) TMPLUS(1:)="LUSCUS"
        if(isUHF.eq.1.and.iiUHF.eq.0) TMPLUS(1:8)="alph.lus"
        if(isUHF.eq.1.and.iiUHF.eq.1) TMPLUS(1:8)="beta.lus"
        mm=mylen(TMPLUS)
c        print *,' before 2 lusop', mm
        RC=lusopen(LID,TMPLUS,mm)
        else
        mm=mylen(RealName)
c        print *,' before 2 lusop', mm
        RC=lusopen(LID,RealName,mm)
        endif
C        rc=AixOpn(LID,"LUSCUS",.TRUE.)
        IF (RC .NE. 0) THEN
          write(6,*) 'ERROR: Can''t open luscus file!'
          CALL Abend()
        END IF
      ELSE ! not luscus
      if(isBinary.eq.1) Then
      call molcas_open_ext2(LuVal,RealName,'sequential',
     & 'unformatted',iostat,.false.,irecl,'unknown',is_error)
c        open(unit=LuVal,access='sequential',
c     ,       form='unformatted', file=RealName)
c        write(6,*) '** Create Grid file:',
c     &        RealName(1:index(RealName,' '))
        write(LuVal) 'a'
        if (imoPack .ne. 0) then
          g=2003.9
          i=0
          write (LuVal) g
     +         nMOs, nShowMOs_, nCoor, nInc, nBlocks,
     +         isCutOff, Cutoff, iiCoord
          write (LuVal) i
        else
          g=1999.0
          write(LuVal) g
        endif
        write(LuVal) Title1
      endif

      if(isBinary.eq.0) Then
        call molcas_open(LuVal,RealName)
c        open(unit=LuVal,file=RealName,Form='FORMATTED')
        if(isLine.eq.1) then
          Write(LuVal,'(a)') '# data in GNUplot format'
          goto 999
        endif
c        write(6,*) '** Create Grid file (in ASCII format):',
c     &        RealName(1:index(RealName,' '))
          if (isTheOne.eq.1) then
            write(LuVal,'(a1)') '9'
          else
              write(LuVal,'(a1)') '0'
          endif
        if(isDebug.eq.0) then
        Write(Luval,'(a)') Title1
        else
        Write(Luval,'(a,a)') Title1,' DEBUG'
        endif
      endif
      END IF
      else ! iiUHF
      if (ISLUSCUS .EQ. 1) THEN
C FIXME: User can't define luscus input file name
        if(Thename.eq.' ') then
        if(isUHF.eq.1.and.iiUHF.eq.0) TMPLUS="AM2L"
        if(isUHF.eq.1.and.iiUHF.eq.1) TMPLUS="BM2L"
        mm=6
c        print *,' before 1 lusop', mm
        RC=lusopen(LID_ab,TMPLUS,mm)
        else
        mm=mylen(RealName)
c        print *,' before lusop', mm
        RC=lusopen(LID_ab,RealName,mm)
        endif
C        rc=AixOpn(LID,"LUSCUS",.TRUE.)
        IF (RC .NE. 0) THEN
          write(6,*) 'ERROR: Can''t open luscus file!'
          CALL Abend()
        END IF
      endif
      LuVal_ab=isFreeUnit(51)


      if(isBinary.eq.1) Then
      call molcas_open_ext2(LuVal_ab,RealName,'sequential',
     &  'unformatted',iostat,.false.,irecl,'unknown',is_error)
c        open(unit=LuVal_ab,access='sequential',
c     ,       form='unformatted', file=RealName)
c        write(6,*) '** Create Grid file',
c     &        RealName(1:index(RealName,' '))
        write(LuVal_ab) 'a'
        if (imoPack .ne. 0) then
          g=2003.9
          i=0
          write (LuVal_ab) g
          write (LuVal_ab) i
        else
          g=1999.0
          write(LuVal_ab) g
        endif
        write(LuVal_ab) Title1
      endif

      if(isBinary.eq.0) Then
        call molcas_open(LuVal_ab,RealName)
c        open(unit=LuVal_ab,file=RealName,Form='FORMATTED')
c        write(6,*) '** Create Grid file (in ASCII format):',
c     &        RealName(1:index(RealName,' '))
          if (isTheOne.eq.1) then
            write(LuVal_ab,'(a1)') '9'
          else
            if (imoPack .ne. 0) then
              write (LuVal_ab,'(a1)') '1'
              write (LuVal_ab,'(i5)') 0
            else
              write(LuVal_ab,'(a1)') '0'
            endif
          endif
        if(isDebug.eq.0) then
        Write(Luval_ab,'(a)') Title1
        else
        Write(Luval_ab,'(a,a)') Title1,' DEBUG'
        endif
      endif
      END IF
      enddo
999   continue
      if(iPRGM.eq.1) close(88)
      return
      end

************************************************************************
      Subroutine PrintTitles(LuVal,nShowMOs,isDensity,nMOs,
     &  iWipGRef, isEner,  WipOcc, iWipType, Crypt,
     &  iWipNZ, WipE, VBocc, ifpartial,isLine,isSphere,
     &  isColor, ISLUSCUS, nCoor,nBlocks,nInc)
      Implicit Real*8 (A-H,O-Z)

      Character Line*12000
      Character Crypt*7, bb
      Dimension iWipGRef(*), WipOcc(*), iWipType(*),
     &          iWipNZ(*), WipE(*)
       Character LineT*10
       integer Sizeof8
       Sizeof8=8
      iActOrb=0
       LineT='GridName= '
       if(isLine.eq.1) LineT='#GridName='
c       print *,'here',nInc, nBlocks, nCoor
      if(isLUSCUS.eq.1) then
        NFIRST=nInc

        if(nBlocks.eq.1) NFIRST=nCoor

      ii=0
c      do i=1,nShowMOs
c      write(Line,'(A17,1000i12)') ' File_pointers = ',
c     * ((nFirst*(j-1)+ii)*Sizeof8,j=1,nBlocks)
c      CALL PRINTLINE(LUVAL,LINE,12*nBlocks+17,0)
c      ii=ii+nFirst*nBlocks
c      enddo
      write(Line,'(A,i22)') ' ORBOFF = ', nCoor*nShowMOs*Sizeof8
c     * + 28*nShowMOs - 20
c ?? -20?
      CALL PRINTLINE(LUVAL,LINE,32,0)
      endif
      do i=1,nShowMOs-isDensity-isSphere-isColor
        j=iWipGRef(i)
        if(isEner.eq.1) then
          if(.not.(0.eq.1.and.
     >       WipOcc(j).gt.0d0.and.
     >       WipOcc(j).lt.2d0)) then
            ib=iWipType(j)
            bb=' '
            if(ib.gt.0.and.ib.lt.8) bb=Crypt(ib:ib)
            IF (ISLUSCUS .EQ. 1) THEN
              WRITE(LINE,1000) iWipNZ(j), iWipNZ(j+nMOs), WipE(j),
     +                         WipOcc(j), bb
              CALL PRINTLINE(LUVAL,LINE,72,0)
            ELSE
              write (line,'(a,i2,i5,f12.4,'' ('',f4.2,'')'',1x,a)')
     *                    LineT,
     *                    iWipNZ(j),iWipNZ(j+nMOs),
     *                    WipE(j),WipOcc(j),bb
              call PrintLine(LuVal,line,38,0)
            END IF
 1000       FORMAT(1X,'GridName= Orbital sym=',i2,' index=',i5,
     +             ' Energ=',F12.4,' occ=', F4.2,' type=',a1)
          else
            iActOrb=iActOrb+1
            IF (ISLUSCUS .EQ. 1) THEN
              WRITE(LINE,1010) 'VB orbital',iActOrb,' (',VBocc,')'
 1010         FORMAT(1X,'GridName= VB_orbital iActOrb= ',I4,
     +               ' occ= ',F4.2)
              CALL PRINTLINE(LUVAL,LINE,45,0)
            ELSE
              write (line,'(2a,i4,5x,a,f4.2,a)') LineT,
     *                    'VB orbital',iActOrb,' (',VBocc,')'
              call PrintLine(LuVal,line,38,0)
            END IF
          endif
        else
          if(.not.(0.eq.1.and.
     >       WipOcc(j).gt.0d0 .and.
     >       WipOcc(j).lt.2d0)) then
            ib=iWipType(j)
            bb=' '
            if(ib.gt.0.and.ib.lt.8) bb=Crypt(ib:ib)
            IF (ISLUSCUS .EQ. 1) THEN
              WRITE(LINE,1020) iWipNZ(j), iWipNZ(j+nMOs),
     +                         WipOcc(j), bb
 1020         FORMAT(1X,'GridName= Orbital sym=',I2,' index=',I5,
     +                  ' occ=',F4.2,' type=',A1)
              CALL PRINTLINE(LUVAL,LINE,53,0)
            ELSE
              write (line,'(a,i2,i5,'' ('',f8.6,'')'',1x,a)')
     *                    LineT,iWipNZ(j),
     *                    iWipNZ(j+nMOs), WipOcc(j),bb
              call PrintLine(LuVal,line,30,0)
            END IF
          else
            iActOrb=iActOrb+1
            IF (ISLUSCUS .EQ. 1) THEN
              WRITE(LINE,1010) iActOrb, VBocc
              CALL PRINTLINE(LUVAL,LINE,45,0)
            ELSE
              write (line,'(2a,i4,5x,a,f4.2,a)') LineT,
     *                         'VB orbital',iActOrb,' (',VBocc,')'
              call PrintLine(LuVal,line,30,0)
            END IF
          endif
        endif
      enddo
      if(isSphere.eq.1) Then
          write (line,'(a,a)') LineT,'  Sphere '
          call PrintLine(LuVal,line,19,0)
      endif
      if(isSphere.eq.1) Then
          write (line,'(a,a)') LineT,'0 Color  '
          call PrintLine(LuVal,line,19,0)
      endif
      if(isDensity.eq.1) Then
        if(ifpartial.eq.0) Then
          IF (ISLUSCUS .EQ. 1) THEN
            LINE=' GridName= Density'
            CALL PRINTLINE(LUVAL,LINE,18,0)
          ELSE
            write (line,'(a,a)') LineT,'  Density'
            call PrintLine(LuVal,line,19,0)
          END IF
        else
          IF (ISLUSCUS .EQ. 1) THEN
            LINE=' GridName= Density (partial)'
            CALL PRINTLINE(LUVAL,LINE,28,0)
          ELSE
            write (line,'(a,a)') LineT,'  Density (partial)'
            call PrintLine(LuVal,line,29,0)
          END IF
        endif
      endif
          IF (ISLUSCUS .EQ. 1) THEN
            LINE=' <DENSITY>'
            CALL PRINTLINE(LUVAL,LINE,10,0)
          endif

      return
      end
********************************
      Subroutine DumpM2Msi(iRun,Luval,LID,nShowMOs,isDensity,nMOs,
     &  iWipGRef,  WipOcc, WipMO, WipOut, mCoor,
     &   iGauss, nInc, imoPack, iWipPBlock,
     &  cMoBlock,nBytesPackedVal, dnorm, Crypt, VbOcc,
     &  isTheOne,isLine,isBinary, isEner, iWipType, iWipNZ,WipE,
     &  WLine,nLine,WCoor,iPrintCount,isDebug,
     &  isCutOff, iWipCutOff,isSphere,SphrDist,isColor,SphrColor,
     +  ISLUSCUS, NBYTES,NINLINE)
      Implicit Real*8 (A-H,O-Z)
#include "SysDef.fh"
      Dimension xLimits(4)
      Integer iYDelta(3)
      Character*1  cMoBlock(*)
      Character Crypt*7, bb
      Character Line*128
c     Character fmt*20
C test
      character*3 cint
      character*1 cx(64)
      data cx /
     +         '0','1','2','3','4','5','6','7','8','9',
     +         'a','b','c','d','e','f','g','h','i','j',
     +         'k','l','m','n','o','p','q','r','s','t',
     +         'u','v','w','x','y','z','A','B','C','D',
     +         'E','F','G','H','I','J','K','L','M','N',
     +         'O','P','Q','R','S','T','U','V','W','X',
     +         'Y','Z','@','#' /
C test end
      Dimension iWipGRef(*), WipOcc(*), WipMO(*), WipOut(*),
     &   iWipPBlock(*),iWipType(*), iWipNZ(*),WipE(*),
     &  WLine(nLine,mCoor),WCoor(3,mCoor),iWipCutOff(*),
     &  SphrDist(mCoor),SphrColor(mCoor)
       Dimension DumArr(2)
#include "WrkSpc.fh"
c          write(*,*) 'entering DumpM2Msi'
           if(irun.gt.100) print *, iGauss, nbytes, ninc, ninline
          iActOrb=0
          iPrintCount=iPrintCount+1
        do i=1, nShowMOs-isDensity-isSphere-isColor
          iMOs=iWipGRef(i)

          if(.not.(0.eq.1.and.
     >       WipOcc(iMOs).gt.0d0
     >        .and.
     >       WipOcc(iMOs).lt.2d0)) then
            call outmo(iMOs,1,WipMO,dumArr,WipOut,mCoor,nMOs)
c          else
c            iActOrb=iActOrb+1
c            call outmo(0,1,WipMO,WipVBmat(1+(iActOrb-1)*nMOs),
c     >           WipOut,mCoor,nMOs)
          endif

        if(isLine.eq.0.and.isLuscus.eq.0) then
            write (line,'(a,i4)') 'Title= ',iMOs
            call PrintLine(LuVal,line,12,1)
          endif
          if(isTheOne.eq.1)then
            if(isLine.eq.0 .AND. ISLUSCUS .eq. 0) then
              write(LuVal,'(f18.12)')
     *            (WipOut(j),j=1,mCoor)
            else
              if(i+1.le.nLine) then
                do j=1,mCoor
                  WLine(i+1,j)=WipOut(j)
                enddo
              endif
            endif
            goto 3939
          endif

          if (imoPack .ne. 0) then
c            Call PackBlock(WipOut,iWipPBlock,mCoor,
c     >                     xLimits,iYDelta)
            write (line,9000)
     *                     0,
     *                     (xLimits(j),j=1,4),(iYDelta(j),j=1,3)
            call PrintLine(LuVal,line,73,0)

9000        format ('BHeader=',I2,1X,(4(E10.4,1X),3(I5,1X)))
            if (isBinary .ne. 0) then
c              call IArrToChar(iWipPBlock,cMoBlock,mCoor)
cvv ! NOT CODED YET
              write (LuVal) (cMoBlock(j),j=1,mCoor*nBytesPackedVal)
            else
              write (LuVal,'(I5)') (iWipPBlock(j), j=0,mCoor-1)
            endif
          else
            if (isBinary .eq. 1) then
c packing late
              if(isCutOff.eq.1) then
                Call GetMem('TMP','ALLO','REAL',ipCMP,mCoor)
                call dcopy_(mCoor,WipOut,1,Work(ipCMP),1)
                iii=0
                do ii=1,mCoor
                  if(iWipCutOff(ii).eq.1) then
                   Work(ipCMP+iii)=WipOut(ii)
                   iii=iii+1
                  endif
                enddo

                write (LuVal) (Work(ipCMP+j),j=0,iii-1)
                Call GetMem('TMP','FREE','REAL',ipCMP,mCoor)
              else
c no cut off
                write (LuVal) (WipOut(j),j=1,mCoor)

              endif
            else !isBinary
              write(cint, '(i3.3)') i
              if(isDebug.eq.0) then
c normal output - just numbers
               if(isCutOff.eq.1) then
                  do j=1,mCoor
                    if(iWipCutOff(j).eq.1)
     &                write (LuVal, '(E10.4)') WipOut(j)
                  enddo
               else if (isLUSCUS .eq. 1) then
c NOPACKING
                if(imoPack.eq.0) then
                 call dump_lusc(LID, WipOut,mCoor)
c debug dump of data
c
c                  do j=1,mCoor,NINLINE
c                    num=mCoor-j
c                    if(num.gt.NINLINE) num=NINLINE
c                    write(fmt,'(A,I2,A,I2,A,A)')
c     &                       '(',NINLINE,'E',NBYTES,'.4',')'
c                    write(line, fmt) (WipOut(j-1+ij),ij=1,num)
c                    call printline(LID,line,NINLINE*NBYTES,0)
c                  enddo
                else
c PACKING NOT implemented
C                  open(unit=38, file='testgr_'//cint//'.txt')
                   do j = 1, min(mcoor,10)
                     iexpnt=int(log10(abs(wipout(j))))
                     write(6,*) 'num=', wipout(j), 'exp = ', iexpnt
                     dnum=(1.0D0 + wipout(j)/10.0D0**iexpnt)/2.0D0

                     in1 = int(dnum*64.0d0)
                     in2 = int((dnum-dble(in1)*64.0D0)*4096.0D0)
                     iexpnt = iexpnt + 50
                     write(6,'(1x,3(1x,e18.8),2x,3(1x,i3))')
     +                      wipout(j), dnum, dexpnt,
     +                      in1, in2, iexpnt
                     if (iexpnt .lt. 1) then
                       iexpnt=1
                     else if (iexpnt .gt. 64) then
                       iexpnt=64
                     end if
                     write(6,'(1x,3(1x,e18.8),2x,3(1x,i3))')
     +                      wipout(j), dnum, dexpnt,
     +                      in1, in2, iexpnt
c                     write(*,*) '-----------------------'

C     +                      cx(in1), cx(in2), cx(iexpnt)
                   end do
C                  close(38)
c                  xxxmin=9.99d+99
c                  xxxmax=-9.99d+99
c                  do j=1,mCoor
c                    if(wipout(j) .gt. xxxmax) xxxmax = wipout(j)
c                    if(wipout(j) .lt. xxxmin) xxxmin = wipout(j)
c                  end do
C                  write(*, *) 'test min/max', xxxmin, xxxmax


                endif !imoPack
               else!isCutOff
C writing of data
                  write (LuVal,'(E10.4)')
     *                      (WipOut(j),j=1,mCoor)
               endif !isCutOff, isLuscus
              else !isDebug
c extended output -
                write (LuVal,'(E10.4,3f8.4)')
     *       (WipOut(j),WCoor(1,j), WCoor(2,j), Wcoor(3,j) ,j=1,mCoor)
              endif !isDebug
            endif !isBinary
          endif !imoPack

        j=iWipGRef(i)

        if(isEner.eq.1) then
          if(.not.(0.eq.1.and.
     >       WipOcc(j).gt.0d0.and.WipOcc(j).lt.2d0))then
            ib=iWipType(j)
            bb=' '
            if(ib.gt.0.and.ib.lt.8) bb=Crypt(ib:ib)
            if(iRun.eq.1.and.iPrintCount.eq.1)
     *      write(6,'(a,i2,i5,f12.4,'' ('',f4.2,'') '',a)')
     *            'GridName= ',
     *            iWipNZ(j),iWipNZ(j+nMOs),
     *            WipE(j),WipOcc(j),bb
          else
c            iActOrb=iActOrb+1
            if(iRun.eq.1.and.iPrintCount.eq.1)
     *      write(6,'(2a,i4,5x,a,f4.2,a)') 'GridName= ',
     *            'VB orbital',iActOrb,' (',VBocc,')'
          endif
        else
          if(.not.(0.eq.1.and.
     >       WipOcc(j).gt.0d0.and.WipOcc(j).lt.2d0))then
            ib=iWipType(j)
            bb=' '
            if(ib.gt.0.and.ib.lt.8) bb=Crypt(ib:ib)
            if(iRun.eq.1.and.iPrintCount.eq.1)
     *      write(6,'(a,i2,i5,'' ('',f8.6,'') '',a)')
     *            'GridName= ',
     *            iWipNZ(j),iWipNZ(j+nMOs),
     *            WipOcc(j),bb
          else
c            iActOrb=iActOrb+1
            if(iRun.eq.1.and.iPrintCount.eq.1)
     *      write(6,'(2a,i4,5x,a,f4.2,a)') 'GridName= ',
     *            'VB orbital',iActOrb,' (',VBocc,')'
          endif
        endif
3939      continue
        enddo

        if(isSphere.eq.1) then
CVV FIXME: no packing.
            write (line,'(a,i4)') 'Title= ',-1
            call PrintLine(LuVal,line,12,1)
          if(isBinary.eq.0) then
           do j=1,mCoor
              write (LuVal,'(E18.12)')
     *        SphrDist(j)
           enddo
          else
              write(LuVal) (SphrDist(j),j=1,mCoor)
          endif
        endif

        if(isColor.eq.1) then
CVV FIXME: no packing.
            write (line,'(a,i4)') 'Title= ',-10
            call PrintLine(LuVal,line,12,1)
          if(isBinary.eq.0) then
           do j=1,mCoor
              write (LuVal,'(E18.12)')
     *        SphrColor(j)
           enddo
          else
              write(LuVal) (SphrColor(j),j=1,mCoor)
          endif
        endif

        if(isDensity.eq.1) then
          call outmo(0,2,WipMO,WipOcc,WipOut,
     >               mCoor,nMOs)
          do j=1, mCoor
            dNorm=dNorm+WipOut(j)
          enddo
*****
          old=0.000d0
c          write(6,*) " mCoor=",mCoor
*****
          if(isLine.eq.0.and.IsLuscus.eq.0) then
            write (line,'(a,i4)') 'Title= ',0
            call PrintLine(LuVal,line,12,1)
          endif
          if (imoPack.ne.0) then
c         print *,'pack code'
c            Call PackBlock(WipOut,iWipPBlock,mCoor,
c     >                     xLimits,iYDelta)
c            write (line,9000)
c     *                    0,
c     *                    (xLimits(j),j=1,4),(iYDelta(j),j=1,3)
c            call PrintLine(LuVal,line,73,0)
c
c            if (isBinary .ne. 0) then
c              call IArrToChar(iWipPBlock,cMoBlock,mCoor)
cvv!!!!!!!
c              IF (ISLUSCUS .EQ. 1) THEN
c                RC=C_WRITE(LID, CMOBLOCK, (mCoor*nBytesPackedVal)*RTOB) !!!!!!!!!!!!!!!!!!!!check mCoor*nBytesPackedVal
c                IF (RC .EQ. 0) THEN
c                  WRITE(6,*) 'error in writing luscus file!'
c                  CALL Abend()
c                END IF
c              ELSE
c                write (LuVal) (cMoBlock(j),j=1,mCoor*nBytesPackedVal)
c              END IF
c            else
c              IF (ISLUSCUS .EQ. 1) THEN
c                RC=C_WRITE(LID, IWIPPBLOCK, (mCoor)*RTOB) !!!!!!!!!!!!!!!!!!!!check mCoor*nBytesPackedVal
c                IF (RC .EQ. 0) THEN
c                  WRITE(6,*) 'error in writing luscus file!'
c                  CALL Abend()
c                END IF
c              ELSE
c                write (LuVal,'(I5)') (iWipPBlock(j), j=1,mCoor)
c              END IF
c            endif
          else
              IF (ISLUSCUS .EQ. 1) THEN
                 call dump_lusc(LID, WipOut,mCoor)
               Endif

            if (isBinary .eq. 1) then
c packing late
              if(isCutOff.eq.1) then
                Call GetMem('TMP','ALLO','REAL',ipCMP,mCoor)
                call dcopy_(mCoor,WipOut,1,Work(ipCMP),1)
                iii=0
                do ii=1,mCoor
                  if(iWipCutOff(ii).eq.1) then
                   Work(ipCMP+iii)=WipOut(ii)
                   iii=iii+1
                  endif
                enddo

            IF (ISLUSCUS .EQ. 1) THEN
              !!!!!!!!!!!!!!!!!!!!check iii-1
              RC=C_WRITE(LID, WORK(IPCMP), (III-1)*RTOB)
              IF (RC .EQ. 0) THEN
                WRITE(6,*) 'error in writing luscus file!'
                CALL Abend()
              END IF
            ELSE
              write (LuVal) (Work(ipCMP+j),j=0,iii-1)
            END IF
            Call GetMem('TMP','FREE','REAL',ipCMP,mCoor)
           else
c no cut off
C              IF (ISLUSCUS .EQ. 1) THEN
C                 call dump_lusc(LID, WipOut,mCoor)
C           print *,'here'
c                RC=C_WRITE(LID, WIPOUT, MCOOR*RTOB) !!!!!!!!!!!!!!!!!!!!check MCOOR
c                IF (RC .EQ. 0) THEN
c                  WRITE(6,*) 'error in writing luscus file!'
c                  CALL Abend()
c                END IF
C              ELSE
                 write (LuVal) (WipOut(j),j=1,mCoor)
C              END IF
            endif
            else

               if(isLine.eq.1) then
                do j=1,mCoor
                  WLine(1,j)=WipOut(j)
                enddo
               else
                 if (isDebug.eq.0) then
c normal output - just numbers
            if(isCutOff.eq.1) then
              do j=1,mCoor
                if(iWipCutOff(j).eq.1)
     &            write (LuVal, '(E18.12)') WipOut(j)
              enddo
             else

              if(ISLUSCUS.eq.0)
     &              write (LuVal,'(E18.12)') (WipOut(j),j=1,mCoor)
              endif
                 else
c extra output -
              if(ISLUSCUS.eq.0) write (LuVal,'(E18.12,3f8.4)')
     &       (WipOut(j),WCoor(1,j), WCoor(2,j), Wcoor(3,j) ,j=1,mCoor)
                 endif

               endif
CGG This is only for testing CASDFT functional. It will be restore.
CGG              write (LuVal,'(E10.4)') (Work(j),j=ipOut,ipOut+mCoor-1)
            endif
          endif
        endif

      if(isLine.eq.1.and.ISLUSCUS.eq.0) then
       do i=1,mCoor
        write(LuVal,'(3F10.6,22E20.12)')
     *  (WCoor(j,i),j=1,3),(WLine(j,i),j=1,nLine)
       enddo
      endif

*
      Return
      end
      SUBROUTINE PRTLUSENDGRID(LUVAL)
      CHARACTER LINE*128
      WRITE(LINE,'(A)') ' </INPORB>'
      CALL PRINTLINE(LUVAL, LINE,10,0)
      WRITE(LINE,'(A)') ' </GRID>'
      CALL PRINTLINE(LUVAL, LINE,8,0)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine str2vb2_cvb(bikcof,ikcoff,cvb,cvbdet,iway,
     >  idetvb,
     >  i2s,nS,nalf1,nMs,
     >  ifnss,ndetvbs,
     >  absym,mnion,mxion,nconf,ndetvb,nvb,kbasis,nel,nalf,neltot,
     >  w,nconfion)
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
      logical absym
      dimension bikcof(*),ikcoff(0:neltot,0:neltot,0:neltot)
      dimension cvb(nvb),cvbdet(ndetvb)
      dimension idetvb(ndetvb)
      dimension i2S(nS),nalf1(nMs)
      dimension ifnss(0:neltot,0:neltot),ndetvbs(0:neltot,0:neltot)
      dimension w(ndetvb),nconfion(0:*)
      save one,sqp5,sq2
      data one/1d0/,sqp5/.70710678118654752440d0/
      data sq2/1.41421356237309504880d0/

c
      i2s_keep      = 0 ! dummy initialize
      nalfsing_keep = 0 ! dummy initialize
c  Determinant to structure transformation
      if(iway.eq.1)then
        call fzero(cvb,nvb)
        do 100 idet=1,ndetvb
        w(idet)=cvbdet(idetvb(idet))
100     continue
      elseif(iway.eq.2)then
        call fzero(w,ndetvb)
      endif
      idadd=0
      isadd=0
      iconfadd=0
      do 200 ion=0,nel/2
      if(nconfion(ion).eq.0)goto 201
      nelsing=nel-2*ion
c  Investigate different S and Ms possibilities and
c  prepare to collect different BIKCOF matrices if
c  necessary :
      n_spin=0
      n_spin_values=0
      do 300 iS=1,nS
      if(i2s(iS).le.nelsing)then
        n_spin=n_spin+ifnss(nelsing,i2s(iS))
        n_spin_values=n_spin_values+1
        i2s_keep=i2s(iS)
      endif
300   continue
      n_det=0
      n_det_values=0
      do 400 iMs=1,nMs
      nalfsing=nalf1(iMs)-ion
      if(nalfsing.ge.0)then
        n_det=n_det+ndetvbs(nelsing,nalfsing)
        n_det_values=n_det_values+1
        nalfsing_keep=nalfsing
      endif
400   continue
      if(kbasis.eq.6)then
        do 500 iS=1,nS
        nalfsing_det=(nelsing+i2s(iS))/2
        if(i2s(iS).le.nelsing)then
          do 600 iMs=1,nMs
          nalfsing=nalf1(iMs)-ion
          if(nalfsing.ge.0)then
            if(nalfsing.ne.nalfsing_det)goto 600
            if(iway.eq.1)then
              do 700 idet=1,ifnss(nelsing,i2s(iS))
              if(i2s(iS).eq.0.and.absym.and.
     >          ndetvbs(nelsing,nalfsing).ne.1)then
                call daxpy_(nconfion(ion),sq2,w(idet+idadd),n_det,
     >            cvb(idet+isadd),n_spin)
              else
                call daxpy_(nconfion(ion),one,w(idet+idadd),n_det,
     >            cvb(idet+isadd),n_spin)
              endif
700           continue
            elseif(iway.eq.2)then
              do 800 idet=1,ifnss(nelsing,i2s(iS))
              if(i2s(iS).eq.0.and.absym.and.
     >          ndetvbs(nelsing,nalfsing).ne.1)then
                call daxpy_(nconfion(ion),sqp5,cvb(idet+isadd),n_spin,
     >            w(idet+idadd),n_det)
                call daxpy_(nconfion(ion),sqp5,cvb(idet+isadd),n_spin,
     >            w(ndetvbs(nelsing,nalfsing)-idet+1+idadd),n_det)
              else
                call daxpy_(nconfion(ion),one,cvb(idet+isadd),n_spin,
     >            w(idet+idadd),n_det)
              endif
800           continue
            endif
          endif
600       continue
        endif
500     continue
c  Skip collection if not necessary ...
      elseif(n_spin_values.eq.1.and.n_det_values.eq.1)then
        if(iway.eq.1)then
          call mxattbp_cvb(
     >      bikcof(1+ikcoff(nelsing,nalfsing_keep,i2s_keep)),
     >      w(1+idadd),n_spin,n_det,nconfion(ion),cvb(1+isadd))
        elseif(iway.eq.2)then
          call mxatbp_cvb(
     >      bikcof(1+ikcoff(nelsing,nalfsing_keep,i2s_keep)),
     >      cvb(1+isadd),n_det,n_spin,nconfion(ion),w(1+idadd))
        endif
      else
        i1 = mstackrz_cvb(n_det*n_spin)
        i_spin=0
        do 900 iS=1,nS
        if(i2s(iS).le.nelsing)then
          i_det=0
          do 1000 iMs=1,nMs
          nalfsing=nalf1(iMs)-ion
          if(nalfsing.ge.0)then
            if(ikcoff(nelsing,nalfsing,i2s(iS)).ne.-1)then
              ioff_bikcof=1+ikcoff(nelsing,nalfsing,i2s(iS))
              ioff_i1=i1+i_spin*n_det+i_det
              do 1100 j_spin=1,ifnss(nelsing,i2s(iS))
              call fmove_cvb(bikcof(ioff_bikcof),work(ioff_i1),
     >          ndetvbs(nelsing,nalfsing))
              ioff_bikcof=ioff_bikcof+ndetvbs(nelsing,nalfsing)
              ioff_i1=ioff_i1+n_det
1100          continue
            endif
            i_det=i_det+ndetvbs(nelsing,nalfsing)
          endif
1000    continue
        i_spin=i_spin+ifnss(nelsing,i2s(iS))
        endif
900     continue

        if(iway.eq.1)then
          call mxattbp_cvb(work(i1),w(1+idadd),
     >     n_spin,n_det,nconfion(ion),cvb(1+isadd))
        elseif(iway.eq.2)then
          call mxatbp_cvb(work(i1),cvb(1+isadd),
     >      n_det,n_spin,nconfion(ion),w(1+idadd))
        endif
        call mfreer_cvb(i1)
      endif
      isadd=isadd+nconfion(ion)*n_spin
      idadd=idadd+nconfion(ion)*n_det
201   iconfadd=iconfadd+nconfion(ion)
200   continue
      if(iway.eq.2)then
        do 1200 idet=1,ndetvb
        cvbdet(idetvb(idet))=w(idet)
1200    continue
      endif
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(mnion)
        call Unused_integer(mxion)
        call Unused_integer(nconf)
        call Unused_integer(nalf)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine torque_pa(nneq,nCenter,neq,neqv,nLoc,exch,nTempMagn,nH,nM,AngPoints,nexch,iopt,nss,mem,smagn,m_paranoid,m_accurate, &
                     TempMagn,w,hmin,hmax,dltH0,EM,zJ,THRS,hexp,dipexch,s_exch,dipso,s_so,eso,hinput,r_rot,XLM,ZLM,XRM,ZRM)
! correction to M from the local excited states:
!  XLM, ZLM, XRM, ZRM
! rotation matrices for equivalent sites:
!  R_ROT
! exchange spectum:
! exchange energies printed out in the previous part
!  W
! local spin-orbit spectum:
! spin-orbit energies from ANISO files
!  ESO
! magnetic and spin moments (i.e. the BIG matrices):
!  DIPEXCH, S_EXCH, dipso, s_so
! exchange data:
!  WEX : Zeeman exchange energies
!  ZEX : exchange statistical sum, Boltzmann distribution
!  SEX : spin magnetisation, from the exchange block
!  MEX : magnetisation, form the exchange block
! data for individual sites (all states):
!  ZL : local statistical sum, Boltzmann distribution
!  WL : Zeeman local energies
!  SL : spin magnetisation, from the local sites, using ALL states
!  ML : magnetisation, from local sites, using ALL states
! data for individual sites (only states that enter exchange):
!  ZR : local statistical sum, Boltzmann distribution, using only NEXCH states
!  WR : Zeeman local reduced energies, using only NEXCH states
!  SR : spin magnetisation, from the local sites, using only NEXCH states
!  MR : magnetisation, from local sites, using only NEXCH states
! total vectors in general coordinate system:
!  ZRT, ZLT, MRT, MLT, SRT, SLT
! data for total system:
!  ZT : total statistical sum, Boltzmann distribution
!  ST : total spin magnetisation,
!  MT : total magnetisation
! magnetic field strength and orientation data:
!  nPlanes, dlth, H, dX, dY, dZ, Ang
! magnetic torque
!  tx : magnetization torque, X
!  ty : magnetization torque, Y
!  tz : magnetization torque, Z
!  sx : spin magnetization torque, X
!  sy : spin magnetization torque, Y
!  sz : spin magnetization torque, Z

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten, mBohr, rNAVO
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: nneq, nCenter, neq(nneq), neqv, nLoc, exch, nTempMagn, nH, nM, AngPoints, nexch(nneq), iopt, &
                                 nss(nneq), mem
logical(kind=iwp), intent(in) :: smagn, m_paranoid, m_accurate, hinput
real(kind=wp), intent(in) :: TempMagn(nTempMagn), W(exch), hmin, hmax, dltH0, EM, zJ, THRS, Hexp(nH), ESO(nneq,nLoc), &
                             R_ROT(nneq,neqv,3,3), XLM(nCenter,nTempMagn,3,3), ZLM(nCenter,nTempMagn), XRM(nCenter,nTempMagn,3,3), &
                             ZRM(nCenter,nTempMagn)
complex(kind=wp), intent(in) :: DIPEXCH(3,EXCH,EXCH), S_EXCH(3,EXCH,EXCH), dipso(nneq,3,nLoc,nLoc), s_so(nneq,3,nLoc,nLoc)
integer(kind=iwp) :: I, IH, IM, iPl, isite, it, J, k, mem_local, n
real(kind=wp) :: dlth
real(kind=wp), allocatable :: Ang(:), dX(:,:), dY(:,:), dZ(:,:), ESO_TMP(:), H(:), MEX(:,:), ML(:,:,:), MLT(:,:,:), MR(:,:,:), &
                              MRT(:,:,:), MT(:,:), SEX(:,:), SL(:,:,:), SLT(:,:,:), SR(:,:,:), SRT(:,:,:), ST(:,:), sx(:,:,:,:), &
                              sy(:,:,:,:), sz(:,:,:,:), tx(:,:,:,:), ty(:,:,:,:), tz(:,:,:,:), WEX(:), WL(:,:), WR(:,:), ZEX(:), &
                              ZL(:,:), ZLT(:,:), ZR(:,:), ZRT(:,:), ZT(:)
complex(kind=wp), allocatable :: dipso_tmp(:,:,:), dipso_tmp2(:,:,:), s_so_tmp(:,:,:), s_so_tmp2(:,:,:)
integer(kind=iwp), parameter :: nPlanes = 3
real(kind=wp), parameter :: cm3tomB = rNAVO*mBohr/Ten ! in cm3 * mol-1 * T
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: DBG = _DBG_

#ifndef _DEBUGPRINT_
#include "macros.fh"
unused_var(mem)
#endif

write(u6,*)
write(u6,'(A)') repeat('%',96)
write(u6,'(20X,A)') 'ANGULAR DEPENDENCE OF THE MAGNETIZATION TORQUE'
write(u6,'(A)') repeat('%',96)
write(u6,*)
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
write(u6,'(2X,A,i3,A)') 'Magnetization torque is calculated for the ',NH,' field points, in the field Domain:'
write(u6,'(2X,F4.1,1x,a,1X,F4.1,a,30(F6.3,a))') HMIN,'--',HMAX,' T., at the following temperatures:'
do i=11,nTempMagn,10
  j = min(nTempMagn,i+9)
  write(u6,'(17x,10(F9.3,A))') (TempMagn(k),' K.;',k=i,j)
end do
write(u6,'(2x,A,i3,A)') 'Angular dependence of the magnetization torque is computed for ',AngPoints,' angular points distributed'
write(u6,'(2x,A)') 'in the domain 0-180 deg.'
write(u6,'(2X,A)') 'The cut-off energy for the exact diagonalization of the Zeeman Hamiltonian is:'
write(u6,'(2x,a,F15.9,A)') 'E = ',EM,' cm(-1).'
if (NM < 10) then
  write(u6,'(2X,A,i2,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 10) .and. (NM < 100)) then
  write(u6,'(2X,A,i3,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 100) .and. (NM < 1000)) then
  write(u6,'(2X,A,i4,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
else if ((NM >= 1000) .and. (NM < 10000)) then
  write(u6,'(2X,A,i5,a)') 'The exact diagonalization of the Zeeman Hamiltonian included ',NM,' exchange states.'
end if
if (m_accurate) then
  write(u6,'(2x,A)') 'The contribution of local excited states is computed exactly.'
else
  write(u6,'(2x,A)') 'The contribution of local excited states is computed approximately (by using the susceptibility data). '
end if
!-----------------------------------------------------------------------
#ifdef _DEBUGPRINT_
write(u6,*) 'nM       = ',nM
write(u6,*) 'nTempMagn= ',nTempMagn
write(u6,*) 'nneq     = ',nneq
write(u6,*) 'nCenter  = ',nCenter
write(u6,*) 'AngPoints= ',AngPoints
write(u6,*) 'nPlanes  = ',nPlanes
write(u6,*) 'nH       = ',nH
write(u6,*) 'nLoc     = ',nLoc
write(u6,*) 'nexch()  = ',(nexch(i),i=1,nneq)
write(u6,*) 'neq()    = ',(neq(i),i=1,nneq)
write(u6,*) 'exch     = ',exch
write(u6,*) 'iopt     = ',iopt
write(u6,*) 'neqv     = ',neqv
write(u6,*) 'nss()    = ',(nss(i),i=1,nneq)
write(u6,*) 'W()      = ',(W(i),i=1,exch)
write(u6,*) 'zJ       = ',zJ
write(u6,*) 'EM       = ',EM
write(u6,*) 'm_paranoi= ',m_paranoid
write(u6,*) 'm_accurat= ',m_accurate
write(u6,*) 'smagn    = ',smagn
write(u6,*) 'hinput   = ',hinput
#endif

! Allocate memory for this calculation:
mem_local = 0
! Zeeman exchange energy spectrum
call mma_allocate(Wex,nM,'Wex')
mem_local = mem_local+size(Wex)*RtoB

#ifdef _DEBUGPRINT_
write(u6,*) 'mem_local 1 = ',mem_local
#endif

! exchange statistical sum, Boltzmann distribution
call mma_allocate(Zex,nTempMagn,'Zex')
mem_local = mem_local+size(Zex)*RtoB
! spin magnetisation, from the exchange block
call mma_allocate(SEX,3,nTempMagn,'SEX')
mem_local = mem_local+size(SEX)*RtoB
! magnetisation, from the exchange block
call mma_allocate(MEX,3,nTempMagn,'MEX')
mem_local = mem_local+size(MEX)*RtoB

! total statistical sum, Boltzmann distribution
call mma_allocate(ZT,nTempMagn,'ZT')
mem_local = mem_local+size(ZT)*RtoB
! total spin magnetisation
call mma_allocate(ST,3,nTempMagn,'ST')
mem_local = mem_local+size(ST)*RtoB
! total magnetisation
call mma_allocate(MT,3,nTempMagn,'MT')
mem_local = mem_local+size(MT)*RtoB

#ifdef _DEBUGPRINT_
write(u6,*) 'mem_local 2 = ',mem_local
#endif
! local statistical sum, Boltzmann distribution
call mma_allocate(ZL,nTempMagn,nneq,'ZL')
mem_local = mem_local+size(ZL)*RtoB
! spin magnetisation, from the local sites, using ALL states
call mma_allocate(SL,3,nTempMagn,nneq,'SL')
mem_local = mem_local+size(SL)*RtoB
! magnetisation, from local sites, using ALL states
call mma_allocate(ML,3,nTempMagn,nneq,'ML')
mem_local = mem_local+size(ML)*RtoB

! local statistical sum, Boltzmann distribution
call mma_allocate(ZR,nTempMagn,nneq,'ZR')
mem_local = mem_local+size(ZR)*RtoB
! spin magnetisation, from the local sites, using only NEXCH states
call mma_allocate(SR,3,nTempMagn,nneq,'SR')
mem_local = mem_local+size(SR)*RtoB
! magnetisation, from the local sites, using only NEXCH states
call mma_allocate(MR,3,nTempMagn,nneq,'MR')
mem_local = mem_local+size(MR)*RtoB

#ifdef _DEBUGPRINT_
write(u6,*) 'mem_local 3 = ',mem_local
#endif
! ZRT(nCenter,nTempMagn)
call mma_allocate(ZRT,nCenter,nTempMagn,'ZRT')
mem_local = mem_local+size(ZT)*RtoB
! ZLT(nCenter,nTempMagn)
call mma_allocate(ZLT,nCenter,nTempMagn,'ZLT')
mem_local = mem_local+size(ZLT)*RtoB
! MRT(nCenter,3,nTempMagn)
call mma_allocate(MRT,nCenter,3,nTempMagn,'MRT')
mem_local = mem_local+size(MRT)*RtoB
! MLT(nCenter,3,nTempMagn)
call mma_allocate(MLT,nCenter,3,nTempMagn,'MLT')
mem_local = mem_local+size(MLT)*RtoB
! SRT(nCenter,3,nTempMagn)
call mma_allocate(SRT,nCenter,3,nTempMagn,'SRT')
mem_local = mem_local+size(SRT)*RtoB
! SLT(nCenter,3,nTempMagn)
call mma_allocate(SLT,nCenter,3,nTempMagn,'SLT')
mem_local = mem_local+size(SLT)*RtoB

#ifdef _DEBUGPRINT_
write(u6,*) 'mem_local 4 = ',mem_local
#endif
! magnetic torque
call mma_allocate(tx,nPlanes,AngPoints,nH,nTempMagn,'tx')
call mma_allocate(ty,nPlanes,AngPoints,nH,nTempMagn,'ty')
call mma_allocate(tz,nPlanes,AngPoints,nH,nTempMagn,'tz')
call mma_allocate(sx,nPlanes,AngPoints,nH,nTempMagn,'sx')
call mma_allocate(sy,nPlanes,AngPoints,nH,nTempMagn,'sy')
call mma_allocate(sz,nPlanes,AngPoints,nH,nTempMagn,'sz')
mem_local = mem_local+size(tx)*RtoB
mem_local = mem_local+size(ty)*RtoB
mem_local = mem_local+size(tz)*RtoB
mem_local = mem_local+size(sx)*RtoB
mem_local = mem_local+size(sy)*RtoB
mem_local = mem_local+size(sz)*RtoB
#ifdef _DEBUGPRINT_
write(u6,*) 'mem_local 5 = ',mem_local
#endif

! Zeeman local energies
call mma_allocate(WL,nLoc,nneq,'WL')
mem_local = mem_local+size(WL)*RtoB
! Zeeman local reduced energies, using only NEXCH states
call mma_allocate(WR,nLoc,nneq,'WR')
mem_local = mem_local+size(WR)*RtoB
#ifdef _DEBUGPRINT_
write(u6,*) 'mem_local 6 = ',mem_local
#endif

call mma_allocate(Ang,AngPoints,'Ang')
mem_local = mem_local+size(Ang)*RtoB
call mma_allocate(dX,AngPoints,nPlanes,'dX')
call mma_allocate(dY,AngPoints,nPlanes,'dY')
call mma_allocate(dZ,AngPoints,nPlanes,'dZ')
mem_local = mem_local+size(dX)*RtoB
mem_local = mem_local+size(dY)*RtoB
mem_local = mem_local+size(dZ)*RtoB
#ifdef _DEBUGPRINT_
write(u6,*) 'mem_local 7 = ',mem_local
#endif

call mma_allocate(H,nH,'H')
mem_local = mem_local+size(H)*RtoB

#ifdef _DEBUGPRINT_
write(u6,*) 'TORQ:  memory allocated (local):'
write(u6,*) 'mem_local=',mem_local
write(u6,*) 'TORQ:  memory allocated (total):'
write(u6,*) 'mem_total=',mem+mem_local
#endif

!-----------------------------------------------------------------------
! set up the field points:
if (HINPUT) then
  do iH=1,nH
    H(iH) = HEXP(iH)
    if (H(iH) == Zero) H(iH) = 0.0001_wp
  end do
else
  DLTH = (HMAX-HMIN)/real(NH-1,kind=wp)
  do iH=1,nH
    if (iH == 1) then
      H(IH) = HMIN+dltH0
    else
      H(IH) = HMIN+DLTH*real(IH-1,kind=wp)
    end if
    if (H(iH) == Zero) H(iH) = 0.0001_wp
  end do
end if
!-----------------------------------------------------------------------

do IH=1,NH
  ! ///  opening the loop over field points:
  do iPl=1,nPlanes
    ! ///  opening the loop over different planes of rotation of the applied magnetic field:
    !  loop over various angular grids  (iPl = 1, 2 or 3)
    !  iPl=1 (X) , angular grid in the plane YZ ( half of the plane , 0-180 degrees)
    !  iPl=2 (Y) , angular grid in the plane XZ ( half of the plane , 0-180 degrees)
    !  iPl=3 (Z) , angular grid in the plane XY ( half of the plane , 0-180 degrees)

    call hdir2(AngPoints,iPl,dX(:,iPl),dY(:,iPl),dZ(:,iPl),Ang,4)

#   ifdef _DEBUGPRINT_
    write(u6,*) 'iPl, dX, dY, dZ=',iPl,dX(:,iPl),dY(:,iPl),dZ(:,iPl),Ang
#   endif
    do IM=1,AngPoints
      ! ///  opening the loop over different directions of the magnetic field

      ! exchange magnetization:
      call MAGN(EXCH,NM,dX(iM,iPl),dY(iM,iPl),dZ(iM,iPl),H(iH),W,zJ,THRS,DIPEXCH,S_EXCH,nTempMagn,TempMagn,smagn,Wex,Zex,Sex,Mex, &
                m_paranoid,DBG)

#     ifdef _DEBUGPRINT_
      if (iPl == 2) &
        write(u6,'(A,I3,1x,F8.4,2x, 3F19.14,2x,3F19.14)') 'MEX: iM,',iM,H(iH),(Mex(i,1),i=1,3),dX(iM,iPl),dY(iM,iPl),dZ(iM,iPl)
#     endif
      !iT = 1

      !write(u6,'(F10.4,1x,2I3,3F18.14,3x,3F20.14,2x,F20.14)') H(iH),iL,iM,dX(iM,iPl),dY(iM,iPl),dZ(iM,iPl),(Mex(j,iT),j=1,3), &
      !                                                        Mex(1,iT)*dX(iM,iPl)+Mex(2,iT)*dY(iM,iPl)+Mex(3,iT)*dZ(iM,iPl)
      ! compute local magnetizations:
      if (m_accurate) then
        call mma_allocate(ESO_TMP,NSS(i),label='ESO_TMP')
        call mma_allocate(dipso_tmp,3,nLoc,nLoc,label='dipso_tmp')
        call mma_allocate(s_so_tmp,3,nLoc,nLoc,label='s_so_tmp')
        do i=1,nneq
          ! all states:
          if (NSS(i) > NEXCH(i)) then
            ! this check is meant to avoid the unnecessary
            ! computation, in cases when no local excited
            ! states are present
            ESO_TMP(:) = ESO(i,1:NSS(i))
            dipso_tmp(:,:,:) = DIPSO(i,:,:,:)
            s_so_tmp(:,:,:) = S_SO(i,:,:,:)
            call MAGN(NSS(i),NEXCH(i),dX(iM,iPl),dY(iM,iPl),dZ(iM,iPl),H(iH),ESO_TMP,zJ,THRS,DIPSO_TMP,S_SO_TMP,nTempMagn, &
                      TempMagn,smagn,WL(:,i),ZL(:,i),SL(:,:,i),ML(:,:,i),m_paranoid,DBG)
            ! only local "exchange states":
            call mma_allocate(dipso_tmp2,3,NEXCH(i),NEXCH(i),label='dipso_tmp2')
            call mma_allocate(s_so_tmp2,3,NEXCH(i),NEXCH(i),label='s_so_tmp2')
            dipso_tmp2(:,:,:) = DIPSO(i,:,1:NEXCH(i),1:NEXCH(i))
            s_so_tmp2(:,:,:) = S_SO(i,:,1:NEXCH(i),1:NEXCH(i))
            call MAGN(NEXCH(i),NEXCH(i),dX(iM,iPl),dY(iM,iPl),dZ(iM,iPl),H(iH),ESO_TMP(1:NEXCH(i)),zJ,THRS,DIPSO_TMP,S_SO_TMP, &
                      nTempMagn,TempMagn,smagn,WR(1:Nexch(i),i),ZR(:,i),SR(:,:,i),MR(:,:,i),m_paranoid,DBG)
            call mma_deallocate(dipso_tmp2)
            call mma_deallocate(s_so_tmp2)
          end if
        end do
        call mma_deallocate(dipso_tmp)
        call mma_deallocate(s_so_tmp)
        ! expand the basis and rotate local vectors to the
        ! general coordinate system:
        MRT(:,:,:) = Zero
        MLT(:,:,:) = Zero
        SRT(:,:,:) = Zero
        SLT(:,:,:) = Zero

        isite = 0
        do i=1,NNEQ
          do j=1,NEQ(i)
            isite = isite+1
            ! statistical distributions
            ZLT(isite,:) = ZL(:,i)
            ZRT(isite,:) = ZR(:,i)
            ! magnetizations:
            ! use R_rot matrices, which have determinant +1.
            !  >> note that  R_lg matrices may have arbitrary
            !  >> sign of the determinant.
            do iT=1,nTempMagn
              do n=1,3
                MLT(isite,:,iT) = MLT(isite,:,iT)+r_rot(i,j,:,n)*ML(n,iT,i)

                SLT(isite,:,iT) = SLT(isite,:,iT)+r_rot(i,j,:,n)*SL(n,iT,i)

                MRT(isite,:,iT) = MRT(isite,:,iT)+r_rot(i,j,:,n)*MR(n,iT,i)

                SRT(isite,:,iT) = SRT(isite,:,iT)+r_rot(i,j,:,n)*SR(n,iT,i)
              end do
            end do

          end do ! j, neq(i)
        end do ! i, nneq
      end if ! m_accurate

      ! compute the total magnetizations according
      ! to the derived formulas:
      if (m_accurate) then
        do iT=1,nTempMagn
          if (smagn) call MSUM(nCenter,Sex(:,iT),Zex(iT),SLT(:,:,iT),ZLT(:,iT),SRT(:,:,iT),ZRT(:,iT),iopt,ST(:,iT),ZT(iT))
          call MSUM(nCenter,Mex(:,iT),Zex(iT),MLT(:,:,iT),ZLT(:,iT),MRT(:,:,iT),ZRT(:,iT),iopt,MT(:,iT),ZT(iT))
        end do

      else ! (m_accurate)

        ! add the contribution from local excited states
        ! using the approximate X*H expression:
        do iT=1,nTempMagn
          do isite=1,nCenter

            MRT(isite,:,iT) = H(iH)*(XRM(isite,iT,:,1)*dX(iM,iPl)+XRM(isite,iT,:,2)*dY(iM,iPl)+XRM(isite,iT,:,3)*dZ(iM,iPl))/cm3tomB

            MLT(isite,:,iT) = H(iH)*(XLM(isite,iT,:,1)*dX(iM,iPl)+XLM(isite,iT,:,2)*dY(iM,iPl)+XLM(isite,iT,:,3)*dZ(iM,iPl))/cm3tomB

          end do ! isite

          if (smagn) call MSUM(nCenter,Sex(:,iT),Zex(iT),SLT(:,:,iT),ZLM(:,iT),SRT(:,:,iT),ZRM(:,iT),iopt,ST(:,iT),ZT(iT))
          call MSUM(nCenter,Mex(:,iT),Zex(iT),MLT(:,:,iT),ZLM(:,iT),MRT(:,:,iT),ZRM(:,iT),iopt,MT(:,iT),ZT(iT))
        end do ! iT
      end if ! (m_accurate)

      ! at this point we have MT and ST computed
      ! in the direction of applied field
      ! compute the M and S torque
      tx(iPl,iM,iH,:) = MT(2,:)*dZ(iM,iPl)*H(iH)-MT(3,:)*dY(iM,iPl)*H(iH)

      ty(iPl,iM,iH,:) = MT(3,:)*dX(iM,iPl)*H(iH)-MT(1,:)*dZ(iM,iPl)*H(iH)

      tz(iPl,iM,iH,:) = MT(1,:)*dY(iM,iPl)*H(iH)-MT(2,:)*dX(iM,iPl)*H(iH)

      if (smagn) then
        sx(iPl,iM,iH,:) = ST(2,:)*dZ(iM,iPl)*H(iH)-ST(3,:)*dY(iM,iPl)*H(iH)

        sy(iPl,iM,iH,:) = ST(3,:)*dX(iM,iPl)*H(iH)-ST(1,:)*dZ(iM,iPl)*H(iH)

        sz(iPl,iM,iH,:) = ST(1,:)*dY(iM,iPl)*H(iH)-ST(2,:)*dX(iM,iPl)*H(iH)
      end if

      ! ///  closing the loops over field strengths and directions
    end do ! iL
  end do ! iM
end do ! iH
! ----------------------------------------------------------------------
! WRITING SOME OF THE OUTPUT....
! ----------------------------------------------------------------------
write(u6,*)
write(u6,'(25X,A)') 'ANGULAR DEPENDENCE OF THE MAGNETIZATION TORQUE'
write(u6,'(30X,A)') '(Units of torque: [energy, cm-1])'
write(u6,*)

write(u6,'(5x,A)') 'Orientation of the applied magnetic field employed:'
write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)

write(u6,'(2x,A,3(10x,A))') 'Angle |','rotation in the YZ plane          |','rotation in the XZ plane          |', &
                            'rotation in the XY plane          |'
write(u6,'(10A)') '--------|',('--- proj X ---|','--- proj Y ---|','--- proj Z ---|',i=1,3)
do iM=1,AngPoints
  write(u6,'(F7.3,1x,A,3(F13.10,1x,A,F13.10,1x,A,F13.10,1x,A))') Ang(iM),'|',(dX(iM,iPl),' ',dY(iM,iPl),' ',dZ(iM,iPl),'|',iPl=1,3)
end do
write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)

do iH=1,nH
  do iT=1,nTempMagn
    write(u6,*)
    write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)
    write(u6,'(A,F9.4,A)') 'Magnetic field strength = ',H(iH),' tesla'
    write(u6,'(12x,A,F9.4,A)') 'Temperature = ',TempMagn(iT),' kelvin'
    write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)

    write(u6,'(2x,A,3(10x,A))') 'Angle |','rotation in the YZ plane          |','rotation in the XZ plane          |', &
                                'rotation in the XY plane          |'
    write(u6,'(10A)') '--------|',('-- torque X --|','-- torque Y --|','-- torque Z --|',i=1,3)
    do iM=1,AngPoints
      write(u6,'(F7.3,1x,A,3(ES13.6,1x,A,ES13.6,1x,A,ES13.6,1x,A))') Ang(iM),'|', &
                                                                     (tx(iPl,iM,iH,iT),' ',ty(iPl,iM,iH,iT),' ',tz(iPl,iM,iH,iT), &
                                                                      '|',iPl=1,3)
    end do
    write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)
  end do !iT
end do !iH

! ----------------------------------------------------------------------
if (smagn) then
  write(u6,*)
  write(u6,'(25X,A)') 'ANGULAR DEPENDENCE OF THE SPIN MAGNETIZATION TORQUE'
  write(u6,'(30X,A)') '(Units of torque: [energy, cm-1])'
  write(u6,*)

  write(u6,'(5x,A)') 'Orientation of the applied magnetic field employed:'
  write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)

  write(u6,'(2x,A,3(10x,A))') 'Angle |','rotation in the YZ plane          |','rotation in the XZ plane          |', &
                              'rotation in the XY plane          |'
  write(u6,'(10A)') '--------|',('--- proj X ---|','--- proj Y ---|','--- proj Z ---|',i=1,3)
  do iM=1,AngPoints
    write(u6,'(F7.3,1x,A,3(F13.10,1x,A,F13.10,1x,A,F13.10,1x,A))') Ang(iM),'|', &
                                                                   (dX(iM,iPl),' ',dY(iM,iPl),' ',dZ(iM,iPl),'|',iPl=1,3)
  end do
  write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)

  do iH=1,nH
    do iT=1,nTempMagn
      write(u6,*)
      write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)
      write(u6,'(A,F9.4,A)') 'Magnetic field strength = ',H(iH),' tesla'
      write(u6,'(12x,A,F9.4,A)') 'Temperature = ',TempMagn(iT),' kelvin'
      write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)

      write(u6,'(2x,A,3(10x,A))') 'Angle |','rotation in the YZ plane          |','rotation in the XZ plane          |', &
                                  'rotation in the XY plane          |'
      write(u6,'(10A)') '--------|',('Spin torque X |','Spin torque Y |','Spin torque Z |',i=1,3)
      do iM=1,AngPoints
        write(u6,'(F7.3,1x,A,3(ES13.6,1x,A,ES13.6,1x,A,ES13.6,1x,A))') Ang(iM),'|', &
                                                                       (sx(iPl,iM,iH,iT),' ',sy(iPl,iM,iH,iT),' ', &
                                                                        sz(iPl,iM,iH,iT),'|',iPl=1,3)
      end do
      write(u6,'(10A)') '--------|',('--------------------------------------------|',i=1,3)
    end do !iT
  end do !iH

end if !smagn

! 199 continue
!-----------------------------------------------------------------------
! Deallocate memory for this calculation:
call mma_deallocate(Wex)

call mma_deallocate(Zex)
call mma_deallocate(SEX)
call mma_deallocate(MEX)
call mma_deallocate(ZT)
call mma_deallocate(ST)
call mma_deallocate(MT)

call mma_deallocate(ZL)
call mma_deallocate(SL)
call mma_deallocate(ML)
call mma_deallocate(ZR)
call mma_deallocate(SR)
call mma_deallocate(MR)

call mma_deallocate(ZRT)
call mma_deallocate(ZLT)
call mma_deallocate(MRT)
call mma_deallocate(MLT)
call mma_deallocate(SRT)
call mma_deallocate(SLT)

call mma_deallocate(tx)
call mma_deallocate(ty)
call mma_deallocate(tz)
call mma_deallocate(sx)
call mma_deallocate(sy)
call mma_deallocate(sz)

call mma_deallocate(WL)
call mma_deallocate(WR)

call mma_deallocate(Ang)
call mma_deallocate(dX)
call mma_deallocate(dY)
call mma_deallocate(dZ)

call mma_deallocate(H)

#ifdef _DEBUGPRINT_
write(u6,*) 'TORQ: allocated memory was sucessfully deallocated'
#endif

return

end subroutine torque_pa

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
*               Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine PipekMezey(Functional,CMO,Thrs,ThrRot,ThrGrad,
     &                      Name,
     &                      nBas,nOrb2Loc,nFro,
     &                      nSym,nAtoms,nMxIter,
     &                      Maximisation,Converged,Debug,Silent)
C
C     Author: Y. Carissan [modified by T.B. Pedersen].
C
C     Purpose: Pipek-Mezey localisation of occupied orbitals.
C
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
      Real*8  CMO(*)
      Integer nBas(nSym), nOrb2Loc(nSym), nFro(nSym)
      Logical Maximisation, Converged, Debug, Silent
      Character*(LENIN8) Name(*) ! dimension should be tot. #bf
#include "WrkSpc.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: PA(:,:,:)

      Character*10 SecNam
      Parameter (SecNam = 'PipekMezey')

      Character*8 Label

C     Symmetry is NOT allowed!!
C     -------------------------

      If (nSym .ne. 1) Then
         Call SysAbendMsg(SecNam,'Symmetry not implemented!','Sorry!')
      End If

C     Initializations.
C     ----------------

      Functional = -9.9D9

      nBasT     = nBas(1)
      nOrb2LocT = nOrb2Loc(1)
      nFroT     = nFro(1)

      Converged = .False.

C     Read overlap matrix.
C     --------------------

      lOaux = nBasT*(nBasT+1)/2 + 4
      lOvlp = nBasT**2
      Call GetMem('Ovlp','Allo','Real',ipOvlp,lOvlp)
      Call GetMem('AuxOvlp','Allo','Real',ipOaux,lOaux)

      irc    = -1
      iOpt   = 2
      iComp  = 1
      iSyLbl = 1
      Label  = 'Mltpl  0'
      Call RdOne(irc,iOpt,Label,iComp,Work(ipOaux),iSyLbl)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': RdOne returned ',irc
         Write(6,*) 'Label = ',Label,'  iSyLbl = ',iSyLbl
         Call SysAbendMsg(SecNam,'I/O error in RdOne',' ')
      End If

      If (Debug) Then
         Write (6,*)
         Write (6,*) ' Triangular overlap matrix at start'
         Write (6,*) ' ----------------------------------'
         Call TriPrt('Overlap',' ',Work(ipOaux),nBasT)
      End If

      Call Tri2Rec(Work(ipOaux),Work(ipOvlp),nBasT,Debug)
      Call GetMem('AuxOvlp','Free','Real',ipOaux,lOaux)

C     Allocate and get index arrays for basis functions per atom.
C     -----------------------------------------------------------

      l_nBas_per_Atom = nAtoms
      l_nBas_Start    = l_nBas_per_Atom
      Call GetMem('nB_per_Atom','Allo','Inte',
     &            ip_nBas_per_Atom,l_nBas_per_Atom)
      Call GetMem('nB_Start','Allo','Inte',
     &            ip_nBas_Start,l_nBas_Start)
      Call BasFun_Atom(iWork(ip_nBas_per_Atom),iWork(ip_nBas_Start),
     &                 Name,nBasT,nAtoms,Debug)

C     Allocate PA array.
C     ------------------
      Call mma_Allocate(PA,nOrb2LocT,nOrb2LocT,nAtoms,Label='PA')
      PA(:,:,:)=0.0D0

C     Localise orbitals.
C     ------------------

      kOffC = nBasT*nFroT + 1
      Call PipekMezey_Iter(Functional,CMO(kOffC),
     &                     Work(ipOvlp),Thrs,ThrRot,ThrGrad,PA,
     &                     iWork(ip_nBas_per_Atom),iWork(ip_nBas_Start),
     &                     Name,nBasT,nOrb2LocT,nAtoms,nMxIter,
     &                     Maximisation,Converged,Debug,Silent)

C     De-allocations.
C     ---------------

      Call mma_deallocate(PA)
      Call GetMem('nB_Start','Free','Inte',
     &            ip_nBas_Start,l_nBas_Start)
      Call GetMem('nB_per_Atom','Free','Inte',
     &            ip_nBas_per_Atom,l_nBas_per_Atom)
      Call GetMem('Ovlp','Free','Real',ipOvlp,lOvlp)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DerPhi(IOpt,IC,NESFJ,L1,L2,DP,DA,Vert,Centr,Sphere,IntSph,ISphe)

use PCM_Arrays, only: MxVert
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IOpt, IC, NESFJ, L1, L2, IntSph(MxVert), ISphe
real(kind=wp), intent(in) :: DP(MxVert,3), Vert(3,MxVert), Centr(3,MxVert), Sphere(4,*)
real(kind=wp), intent(out) :: DA
integer(kind=iwp) :: JJ, NS1, NS2
real(kind=wp) :: COSPHI, COSTH, D_COS, Delta, Dist2, DNORM1, DNORM2, DPHI, FACT, PROD, RC2, SENPHI, V1(3), V2(3), T12(3), VEC1(3), &
                 VEC2(3), VEC3(3), VEC4(3)
real(kind=wp), parameter :: Small1 = 1.0e-6_wp, Small = 1.0e-12_wp

! Find the derivative of: Phi(L1) Cos[Theta(L1)]
!
! IOpt = 0 : refers to the L1 side of tessera ITS, knowing the derivatives
!            of the position of the vertices by which is delimited
!
! IOpt = 1 : refers to the L1 side of tessera ITS wrt the radius of the
!            NSJ sphere knowing the derivatives of the positions of the
!            vertices by which is delimited
!
! NS1 is the sphere to which the tessera belongs, NS2 is the sphere that
! creates the side L1 by intersecting NS1

NS1 = ISPHE
NS2 = INTSPH(L1)

! Finds the coordinates of the vertices wrt the center of the circle on
! which is the arc L1 and the radius of the circle

V1(:) = VERT(:,L1)-CENTR(:,L1)
V2(:) = VERT(:,L2)-CENTR(:,L1)
RC2 = V1(1)**2+V1(2)**2+V1(3)**2
PROD = V1(1)*V2(1)+V1(2)*V2(2)+V1(3)*V2(3)
COSPHI = PROD/RC2

! If the tessera is intersected very near its vertex the numerical
! approximation could lead to PROD>RC2 and COSPHI>1. Avoid this by:

Delta = 1.0e-12_wp
if (abs(CosPhi) > One) CosPhi = sign(One-Delta,CosPhi)
SENPHI = sqrt(One-COSPHI*COSPHI)

! Compute the derivative of Phi(L1)

VEC1(:) = V1(:)-COSPHI*V2(:)
VEC2(:) = DP(L2,:)
VEC3(:) = V2(:)-COSPHI*V1(:)
VEC4(:) = DP(L1,:)

! If the side is just that created by the moving sphere some components
! are corrected
! IOpt = 0: due to the derivative of the distance between sphere centers
! IOpt = 1: due to the derivative of the radius of sphere NESFJ

if (NS2 == NESFJ) then
  T12(:) = Sphere(1:3,NESFJ)-Sphere(1:3,NS1)
  DIST2 = T12(1)*T12(1)+T12(2)*T12(2)+T12(3)*T12(3)
  if (IOpt == 0) then
    FACT = (Sphere(4,NS1)**2-Sphere(4,NESFJ)**2+DIST2)/(Two*DIST2)
    VEC2(IC) = VEC2(IC)-FACT
    VEC4(IC) = VEC4(IC)-FACT
  else if (IOpt == 1) then
    VEC2(:) = VEC2(:)+Sphere(4,NESFJ)*T12(:)/DIST2
    VEC4(:) = VEC4(:)+Sphere(4,NESFJ)*T12(:)/DIST2
  else
    write(u6,'(a)') 'Illegal IOpt in DerPhi.'
    call Abend()
  end if
end if

DPHI = Zero
do JJ=1,3
  DPHI = DPHI-(VEC1(JJ)*VEC2(JJ)+VEC3(JJ)*VEC4(JJ))
end do
if (abs(SenPhi) < Small) then
  if (abs(DPhi) > Small1) then
    write(u6,'(a)') 'SenPhi small but not DPhi in DerPhi.'
    call Abend()
  end if
  DPhi = Zero
else
  DPHI = DPHI/(RC2*SENPHI)
end if

! Compute the cosine of the polar angle

DNORM1 = Zero
DNORM2 = Zero
V1(:) = VERT(:,L1)-Sphere(1:3,NS1)
V2(:) = Sphere(1:3,NS2)-Sphere(1:3,NS1)
do JJ=1,3
  DNORM1 = DNORM1+V1(JJ)*V1(JJ)
  DNORM2 = DNORM2+V2(JJ)*V2(JJ)
end do
DNORM1 = sqrt(DNORM1)
DNORM2 = sqrt(DNORM2)
COSTH = (V1(1)*V2(1)+V1(2)*V2(2)+V1(3)*V2(3))/(DNORM1*DNORM2)

! If the side is not that formed by the moving sphere the derivative of
! the polar angle vanishes

D_COS = Zero

! Otherwise:

if (NS2 == NESFJ) then
  do JJ=1,3
    D_COS = D_COS+V2(JJ)*DP(L1,JJ)
  end do
  if (IOpt == 0) D_COS = D_COS+V1(IC)-Sphere(4,NS1)*COSTH*V2(IC)/DNORM2
  D_COS = D_COS/(Sphere(4,NS1)*DNORM2)
end if
DA = COSTH*DPHI+acos(COSPHI)*D_COS
DA = Sphere(4,NS1)*Sphere(4,NS1)*DA

return

end subroutine DerPhi

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Inter_PCM(XE,YE,ZE,RE,P1,P2,P3,P4,I,IPRINT)

use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: XE, YE, ZE, RE, P1(3), P2(3), P3(3)
real(kind=wp), intent(out) :: P4(3)
integer(kind=iwp), intent(in) :: I, IPRINT
integer(kind=iwp) :: M
real(kind=wp) :: ALPHA, DELTA, DIFF, DIFF2, DNORM, R, R2
real(kind=wp), parameter :: TOL = 1.0e-12_wp

! Trova il punto P4, sull'arco P1-P2 sotteso dal centro P3, che
! si trova sulla superficie della sfera XE,YE,ZE,RE
! P4 e' definito come combinazioe lineare di P1 e P2, con
! il parametro ALPHA ottimizzato per tentativi.

R2 = (P1(1)-P3(1))**2+(P1(2)-P3(2))**2+(P1(3)-P3(3))**2
R = sqrt(R2)
ALPHA = Half
DELTA = Zero
M = 1
do
  if (M > 100) then
    if (IPRINT > 0) write(u6,'(/,10X," INTER: too many iterations")')
    return
  end if
  ALPHA = ALPHA+DELTA
  DNORM = Zero
  P4(:) = P1(:)+ALPHA*(P2(:)-P1(:))-P3(:)
  DNORM = DNORM+P4(1)*P4(1)+P4(2)*P4(2)+P4(3)*P4(3)
  DNORM = sqrt(DNORM)
  P4(:) = P4(:)*R/DNORM+P3(:)
  DIFF2 = (P4(1)-XE)**2+(P4(2)-YE)**2+(P4(3)-ZE)**2
  DIFF = sqrt(DIFF2)-RE
  if (abs(DIFF) < TOL) exit
  if (I == 0) then
    if (DIFF > Zero) DELTA = One/(Two**(M+1))
    if (DIFF < Zero) DELTA = -One/(Two**(M+1))
    M = M+1
  else
    if (DIFF > Zero) DELTA = -One/(Two**(M+1))
    if (DIFF < Zero) DELTA = One/(Two**(M+1))
    M = M+1
  end if
end do

return

end subroutine Inter_PCM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      SUBROUTINE CHO_SUBTR1(XINT,WRK,LWRK,ISYM,FXDMEM)
C
C     Purpose: subtract contributions from previous vectors
C              from the qualified integrals (in XINT).
C              This version is I/O-driven.
C
C     Screening in subtraction introduced Jan. 2006, TBP.
C
#include "implicit.fh"
      DIMENSION XINT(*), WRK(LWRK)
      LOGICAL   FXDMEM
#include "cholesky.fh"
#include "chovecbuf.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "chosubscr.fh"
#include "cholq.fh"
#include "WrkSpc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_SUBTR1')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

      PARAMETER (N2 = INFVEC_N2)

      INTEGER IOFF(0:1), IVSTAT(2,2)

      DIMENSION TIMLOC(2,3)

      PARAMETER (INFO = INF_SUBTR1)
      PARAMETER (XMONE = -1.0D0, ZERO = 0.0D0, ONE = 1.0D0)

      INTEGER  CHO_X_NUMRD
      EXTERNAL CHO_X_NUMRD

      ISCR(I)=IWORK(ip_ISCR-1+I)
      INFVEC(I,J,K)=IWORK(ip_INFVEC-1+MAXVEC*N2*(K-1)+MAXVEC*(J-1)+I)
      IQUAB(I,J)=IWORK(ip_IQUAB-1+MAXQUAL*(J-1)+I)
      IIBSTRSH(I,J,K)=IWORK(ip_IIBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      DSUBSCR(I)=WORK(ip_DSUBSCR-1+I)
      DSPNM(I)=WORK(ip_DSPNM-1+I)

C     Return if nothing to do.
C     ------------------------

      IF (NUMCHO(ISYM) .LT. 1) RETURN

      NVEC_TO_READ = NUMCHO(ISYM) - NVEC_IN_BUF(ISYM)
      IF (NVEC_TO_READ .EQ. 0) RETURN
      IF (NVEC_TO_READ .LT. 0) THEN
         CALL CHO_QUIT('Vector buffer error in '//SECNAM,104)
      END IF

C     Allocate "junk yard".
C     ---------------------

      KJUNK = 1
      KEND0 = KJUNK + 1
      LWRK0 = LWRK  - KEND0 + 1

      MUST = NNBSTR(ISYM,1) + NNBSTR(ISYM,2) + NQUAL(ISYM)
      IF (LWRK0 .LT. MUST) THEN
         WRITE(LUPRI,*)
         WRITE(LUPRI,*)
         WRITE(LUPRI,*) SECNAM,': insufficient memory:'
         WRITE(LUPRI,*) 'Need at least: ',MUST+KEND0-1
         WRITE(LUPRI,*) 'Available    : ',LWRK
         WRITE(LUPRI,*) '(A significant increase of memory is ',
     &                  'needed for efficient execution.)'
         WRITE(LUPRI,*)
         WRITE(LUPRI,*) 'Memory available in ',
     &                  SECNAM,' may also be increased by reducing:'
         WRITE(LUPRI,*)
     &   '1) max. #qualified per symmetry, currently: ',MAXQUAL,
     &   '   to less than than ',NQUAL(ISYM)
         WRITE(LUPRI,*)
     &   '2) max. memory fraction used by qualified, ',
     &   ' currently: ',N1_QUAL,'/',N2_QUAL
         CALL CHO_QUIT('Insufficient memory in '//SECNAM//' [0]',101)
      END IF

      WRK(KJUNK) = ZERO
      IOFF(0)    = KJUNK

C     Split memory for subtraction of previous vectors:
C     {Read buffer},{L(cd,#J),L({ab},#J)}
C     Initially, the fraction N1_VECRD/N2_VECRD of total memory is
C     reserved for reading. Then, the split aims at
C              1<=#J<=MAX(NQUAL(ISYM),N_SUBTR)
C     I.e., the number of vectors in the read buffer is at least #J.
C     Obviously, if MAX(NQUAL(ISYM),N_SUBTR) > NVEC_TO_READ then
C     1<=#J<=NVEC_TO_READ. (Keeping #J within bounds is the role of
C     NUMSMN).
C     N1_VECRD, N2_VECRD, and N_SUBTR can be user-defined (input)
C     and should have been checked as part of configuration check
C     (CHO_CHKCONF) during initialization.
C     --------------------------------------------------------------

      KREAD = KEND0 ! pointer to read buffer
      IREDC = -1    ! id of red. set index array at location 3

      X1 = DBLE(N1_VECRD)
      X2 = DBLE(N2_VECRD)
      XM = DBLE(LWRK0)
      XREAD  = XM*X1/X2  ! initial guess for buffer size (from input)
      LREAD  = INT(XREAD)
      LEFT   = LWRK0 - LREAD
      MINLFT = NNBSTR(ISYM,2) + NQUAL(ISYM)

      IF (FXDMEM) THEN ! fixed-size read buffer

         IF (LEFT .LT. MINLFT) THEN
            LEFT  = MINLFT
            LREAD = LWRK0 - LEFT
         END IF

      ELSE ! attempt to optimize the split

         NUMSMN = MIN(MAX(NQUAL(ISYM),N_SUBTR),NVEC_TO_READ)
         NUMSUB = MAX(MIN(NUMSMN,LEFT/MINLFT),1) ! 1<=NUMSUB<=NUMSMN
         LREAD  = LWRK0 - NUMSUB*MINLFT

         NUMRD = CHO_X_NUMRD(1,ISYM,IREDC,LREAD) ! # that can be read
         IF (NUMRD .LT. 0) CALL CHO_QUIT('NUMRD error in '//SECNAM,104)
         DO WHILE (NUMRD .LT. NUMSUB) ! reduce NUMSUB until NUMRD=NUMSUB
            NUMSUB = NUMSUB - 1
            IF (NUMSUB .LT. 1) THEN ! should never occur (checked above)
               CALL CHO_QUIT('Insufficient memory for split in '
     &                       //SECNAM,101)
            END IF
            LREAD = LWRK0 - NUMSUB*MINLFT
            NUMRD = CHO_X_NUMRD(1,ISYM,IREDC,LREAD)
            IF (NUMRD .LT. 0) THEN
               CALL CHO_QUIT('NUMRD error in '//SECNAM,104)
            END IF
         END DO

      END IF

C     Initializations.
C     ----------------

      NUMRD  = 0
      NUMBAT = 0
      XTOT = 0.0D0
      XDON = 0.0D0
      CALL CHO_IZERO(IVSTAT,4)
      CALL CHO_DZERO(TIMLOC,6)

C     Start buffer batch loop.
C     ------------------------

      IVEC1 = NVEC_IN_BUF(ISYM) + 1
      IMAPC = -1
      DO WHILE (IVEC1 .LE. NUMCHO(ISYM))

C        Read as many vectors as possible into buffer.
C        ---------------------------------------------

         CALL CHO_TIMER(C1,W1)
         IRED1 = INFVEC(IVEC1,2,ISYM)
         NVRD  = 0
         MUSED = 0
         CALL CHO_VECRD(WRK(KREAD),LREAD,IVEC1,NUMCHO(ISYM),ISYM,
     &                  NVRD,IREDC,MUSED)
         NUMRD = NUMRD + 1
         CALL CHO_TIMER(C2,W2)
         TIMLOC(1,1) = TIMLOC(1,1) + C2 - C1
         TIMLOC(2,1) = TIMLOC(2,1) + W2 - W1

C        Quit if no vectors were read.
C        -----------------------------

         IF (NVRD .LT. 1) THEN
            CALL CHO_QUIT('Insufficient scratch space for read in '
     &                    //SECNAM,101)
         END IF

C        Compute memory available for subtraction batching.
C        --------------------------------------------------

         KEND1 = KREAD + MUSED
         LWRK1 = LWRK  - KEND1 + 1

         IF (LWRK1 .LT. 1) THEN
            CALL CHO_QUIT('Insufficient memory in '//SECNAM//' [1]',101)
         END IF

C        Set up batch.
C        -------------

         MMEM = NNBSTR(ISYM,2) + NQUAL(ISYM)
         IF (MMEM .LT. 1) THEN
            CALL CHO_QUIT('Batch setup corrupted in '//SECNAM,104)
            NVEC = -999999
         ELSE
            NVEC = MIN(LWRK1/MMEM,NVRD)
         END IF
         IF (NVEC .LT. 1) THEN
            CALL CHO_QUIT('Batch failure in '//SECNAM,101)
            NBATCH = -999999
         ELSE
            NBATCH = (NVRD - 1)/NVEC + 1
         END IF

C        Set local statistics info.
C        --------------------------

         NUMBAT = NUMBAT + NBATCH
         IF (NUMRD .EQ. 1) THEN
            DO I = 1,2
               IVSTAT(I,1) = NVRD
               IVSTAT(I,2) = NVEC
            END DO
         ELSE
            IVSTAT(1,1) = MIN(IVSTAT(1,1),NVRD)
            IVSTAT(2,1) = MAX(IVSTAT(2,1),NVRD)
            IVSTAT(1,2) = MIN(IVSTAT(1,2),NVEC)
            IVSTAT(2,2) = MAX(IVSTAT(2,2),NVEC)
         END IF

C        Start batch loop.
C        -----------------

         IOFF(1) = KREAD - 1
         DO IBATCH = 1,NBATCH

            IF (IBATCH .EQ. NBATCH) THEN
               NUMV = NVRD - NVEC*(NBATCH - 1)
            ELSE
               NUMV = NVEC
            END IF
            IVEC1_1 = IVEC1 + NVEC*(IBATCH-1)

C           Set memory pointers for this batch.
C           -----------------------------------

            KCHO1 = KEND1
            KCHO2 = KCHO1 + NNBSTR(ISYM,2)*NUMV
            KEND2 = KCHO2 + NQUAL(ISYM)*NUMV
            LWRK2 = LWRK  - KEND2 + 1
            IF (LWRK2 .LT. 0) THEN
               CALL CHO_QUIT('Batch error in '//SECNAM,104)
            END IF

C           Get the next NUMV vectors sorted according to current
C           reduced set (originally, this section was part of the
C           I/O; hence, it is timed as if it was I/O for
C           compatibility).
C           -----------------------------------------------------

            CALL CHO_TIMER(C1,W1)

            JVEC1   = NVEC*(IBATCH - 1) + 1
            JVEC2   = JVEC1 + NUMV - 1
            JRED1   = INFVEC(IVEC1+JVEC1-1,2,ISYM)
            JRED2   = INFVEC(IVEC1+JVEC2-1,2,ISYM)
            LVEC1   = JVEC1
            KVEC1   = 1
            DO JRED = JRED1,JRED2

               LNUM = 0
               LVEC = LVEC1 - 1
               DO WHILE (LVEC.LT.JVEC2)
                  LVEC = LVEC + 1
                  LRED = INFVEC(IVEC1+LVEC-1,2,ISYM)
                  IF (LRED .EQ. JRED) THEN
                     LNUM = LNUM + 1
                  ELSE
                     LVEC = JVEC2
                  END IF
               END DO

               IF (LNUM .GT. 0) THEN

                  IF (JRED .NE. IREDC) THEN
                     ILOC = 3
                     KOFF1 = ip_NNBSTRSH + NSYM*NNSHL*(ILOC - 1)
                     KOFF2 = ip_INDRED   + MMBSTRT*(ILOC - 1)
                     CALL CHO_GETRED(IWORK(ip_INFRED),IWORK(KOFF1),
     &                               IWORK(KOFF2),IWORK(ip_INDRSH),
     &                               IWORK(ip_iSP2F),
     &                               MAXRED,NSYM,NNSHL,MMBSTRT,JRED,
     &                               .FALSE.)
                     CALL CHO_SETREDIND(IWORK(ip_IIBSTRSH),
     &                                  IWORK(ip_NNBSTRSH),NSYM,NNSHL,
     &                                  ILOC)
                     IREDC = JRED
                  END IF

                  IF (JRED .NE. IMAPC) THEN
                     CALL CHO_RS2RS(IWORK(ip_ISCR),l_ISCR,2,3,JRED,ISYM)
                     IMAPC = JRED
                  END IF

                  DO LVEC = 1,LNUM
                     KVEC = KVEC1 + LVEC - 1
                     DO IAB = 1,NNBSTR(ISYM,2)
                        KOFF1 = KCHO1 + NNBSTR(ISYM,2)*(KVEC - 1) + IAB
     &                        - 1
                        KOFF2 = IOFF(MIN(ISCR(IAB),1)) + ISCR(IAB)
                        WRK(KOFF1) = WRK(KOFF2)
                     END DO
                     IOFF(1) = IOFF(1) + NNBSTR(ISYM,3)
                  END DO

                  LVEC1 = LVEC1 + LNUM
                  KVEC1 = KVEC1 + LNUM

               END IF

            END DO

            CALL CHO_TIMER(C2,W2)
            TIMLOC(1,2) = TIMLOC(1,2) + C2 - C1
            TIMLOC(2,2) = TIMLOC(2,2) + W2 - W1

C           Screened or unscreened subtraction section.
C           The screened version uses level 2 blas, while the unscreened
C           one employs level 3 blas.
C           ------------------------------------------------------------

            CALL CHO_TIMER(C1,W1)

            IF (CHO_SSCREEN) THEN ! screened subtraction

C              Copy out sub-blocks corresponding to qualified diagonals:
C              L(#J,{ab})
C              ---------------------------------------------------------

               KOFB0 = KCHO1 - 1 - IIBSTR(ISYM,2)
               DO J = 1,NUMV
                  KOFFA = KCHO2 + J - 1
                  KOFFB = KOFB0 + NNBSTR(ISYM,2)*(J - 1)
                  DO IAB = 1,NQUAL(ISYM)
                     WRK(KOFFA+NUMV*(IAB-1))=WRK(KOFFB+IQUAB(IAB,ISYM))
                  END DO
               END DO

C              Subtract:
C              (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L(#J,{ab})
C              for each ab in {ab}.
C              ----------------------------------------------------

               CALL CHO_SUBSCR_DIA(WRK(KCHO1),NUMV,ISYM,2,SSNORM)
               DO IAB = 1,NQUAL(ISYM)
                  DO ISHGD = 1,NNSHL
                     NGD = NNBSTRSH(ISYM,ISHGD,2)
                     IF (NGD .GT. 0) THEN
                        XTOT = XTOT + 1.0D0
                        JAB = IQUAB(IAB,ISYM) - IIBSTR(ISYM,2)
                        TST = SQRT(DSPNM(ISHGD)*DSUBSCR(JAB))
                        IF (TST .GT. SSTAU) THEN
                           XDON  = XDON + 1.0D0
                           KOFF1 = KCHO1 + IIBSTRSH(ISYM,ISHGD,2)
                           KOFF2 = KCHO2 + NUMV*(IAB-1)
                           KOFF3 = NNBSTR(ISYM,2)*(IAB-1)
     &                           + IIBSTRSH(ISYM,ISHGD,2) + 1
                           CALL DGEMV_('N',NGD,NUMV,
     &                                XMONE,WRK(KOFF1),NNBSTR(ISYM,2),
     &                                WRK(KOFF2),1,ONE,XINT(KOFF3),1)
                        END IF
                     END IF
                  END DO
               END DO

            ELSE ! unscreened subtraction

               IF (L_LQ_SYM(ISYM) .GT. 0) THEN

C                 If the qualified block, L({ab},#J), is already in
C                 core, use this block.
C                 -------------------------------------------------

                  LOFF = IP_LQ_SYM(ISYM) + LDLQ(ISYM)*(IVEC1_1-1)

                  CALL DGEMM_('N','T',NNBSTR(ISYM,2),NQUAL(ISYM),NUMV,
     &                       XMONE,WRK(KCHO1),NNBSTR(ISYM,2),
     &                             WORK(LOFF),LDLQ(ISYM),
     &                       ONE,XINT,NNBSTR(ISYM,2))

               ELSE

C                 Copy out sub-blocks corresponding to qualified
C                 diagonals: L({ab},#J)
C                 ----------------------------------------------

                  KOFB0 = KCHO1 - 1 - IIBSTR(ISYM,2)
                  DO J = 1,NUMV
                     KOFFA = KCHO2 + NQUAL(ISYM)*(J - 1) - 1
                     KOFFB = KOFB0 + NNBSTR(ISYM,2)*(J - 1)
                     DO IAB = 1,NQUAL(ISYM)
                        WRK(KOFFA+IAB) = WRK(KOFFB+IQUAB(IAB,ISYM))
                     END DO
                  END DO

C                 Subtract:
C                 (gd|{ab}) <- (gd|{ab}) - sum_J L(gd,#J) * L({ab},#J)
C                 ----------------------------------------------------

                  CALL DGEMM_('N','T',NNBSTR(ISYM,2),NQUAL(ISYM),NUMV,
     &                       XMONE,WRK(KCHO1),NNBSTR(ISYM,2),
     &                       WRK(KCHO2),NQUAL(ISYM),
     &                       ONE,XINT,NNBSTR(ISYM,2))

               END IF

            END IF

            CALL CHO_TIMER(C2,W2)
            TIMLOC(1,3) = TIMLOC(1,3) + C2 - C1
            TIMLOC(2,3) = TIMLOC(2,3) + W2 - W1

         END DO

C        Update counter.
C        ---------------

         IVEC1 = IVEC1 + NVRD

      END DO

C     Update global statistics info.
C     ------------------------------

      NSYS_CALL   = NSYS_CALL + NUMRD
      NDGM_CALL   = NDGM_CALL + NUMBAT
      TDECOM(1,2) = TDECOM(1,2) + TIMLOC(1,1) + TIMLOC(1,2)
      TDECOM(2,2) = TDECOM(2,2) + TIMLOC(2,1) + TIMLOC(2,2)
      TDECOM(1,3) = TDECOM(1,3) + TIMLOC(1,3)
      TDECOM(2,3) = TDECOM(2,3) + TIMLOC(2,3)
      IF (CHO_SSCREEN) THEN
         SUBSCRSTAT(1) = SUBSCRSTAT(1) + XTOT
         SUBSCRSTAT(2) = SUBSCRSTAT(2) + XDON
      END IF

C     Print statistics.
C     -----------------

      IF (LOCDBG .OR. IPRINT.GE.INFO) THEN
         IF (NUMRD .EQ. 0) THEN
            XAVERD = -9.99999D5
         ELSE
            XAVERD = DBLE(NUMCHO(ISYM))/DBLE(NUMRD)
         END IF
         IF (NUMBAT .EQ. 0) THEN
            XAVEVC = -9.99999D5
         ELSE
            XAVEVC = DBLE(NUMCHO(ISYM))/DBLE(NUMBAT)
         END IF
         WRITE(LUPRI,'(A)') '*****'
         WRITE(LUPRI,'(A,A,I2,A)')
     &   SECNAM,' statistics, symmetry',ISYM,':'
         WRITE(LUPRI,'(A,I12)')
     &   'Number of previous vectors                           : ',
     &   NUMCHO(ISYM)
         WRITE(LUPRI,'(A,I12)')
     &   'Number of vectors in buffer                          : ',
     &   NVEC_IN_BUF(ISYM)
         WRITE(LUPRI,'(A,I12)')
     &   'Memory available for subtraction of previous vectors : ',
     &   LWRK
         WRITE(LUPRI,'(A,I12)')
     &   'Memory reserved for buffered vector read             : ',
     &   LREAD
         WRITE(LUPRI,'(A,I12)')
     &   'Number of batches needed for reading vectors         : ',
     &   NUMRD
         IF (CHO_SSCREEN) THEN
            WRITE(LUPRI,'(A,F12.2)')
     &      'Number of calls to DGEMV                             : ',
     &      XDON
            WRITE(LUPRI,'(A,1P,D12.2)')
     &      'Screening threshold                                  : ',
     &      SSTAU
            IF (XTOT .GT. 0.0D0) THEN
               SCRPCT = 1.0D2*(XTOT-XDON)/XTOT
            ELSE
               SCRPCT = 1.0D15
            END IF
            WRITE(LUPRI,'(A,F12.2,A)')
     &      'Screening percent                                    : ',
     &      SCRPCT,'%'
         ELSE
            WRITE(LUPRI,'(A,I12)')
     &      'Number of calls to DGEMM                             : ',
     &      NUMBAT
         END IF
         WRITE(LUPRI,'(A,I12,I12,F12.2)')
     &   'Minimum, maximum, and average #vectors read          : ',
     &   IVSTAT(1,1),IVSTAT(2,1),XAVERD
         WRITE(LUPRI,'(A,I12,I12,F12.2)')
     &   'Minimum, maximum, and average #vecs per call to BLAS : ',
     &   IVSTAT(1,2),IVSTAT(2,2),XAVEVC
         WRITE(LUPRI,'(A,2F12.2)')
     &   'Time for reading vectors into buffer (CPU/Wall; sec.): ',
     &   TIMLOC(1,1),TIMLOC(2,1)
         WRITE(LUPRI,'(A,2F12.2)')
     &   'Time for reduced set vector reorder  (CPU/Wall; sec.): ',
     &   TIMLOC(1,2),TIMLOC(2,2)
         WRITE(LUPRI,'(A,2F12.2)')
     &   'Time for qual. copy + subtraction    (CPU/Wall; sec.): ',
     &   TIMLOC(1,3),TIMLOC(2,3)
         WRITE(LUPRI,'(A)') '*****'
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function D_Trsn(Ind,iOp_,nSym)

use Slapaf_Info, only: jStab, nStab
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: D_Trsn
integer(kind=iwp), intent(in) :: Ind(4), iOp_(4), nSym
integer(kind=iwp) :: iAtom, iDeg, iOp_E, iOp_ER, iOp_ES, iOp_ET, iOp_R, iOp_S, iOp_T, iOp_TS, iU_A, iU_AB, iU_ABCD, iU_B, iU_C, &
                     iU_CD, iU_D, jAtom, kAtom, lAtom, nU_A, nU_ABCD, nU_B, nU_C, nU_D
integer(kind=iwp), external :: iU, iUR, nU

!                                                                      *
!***********************************************************************
!                                                                      *
! T O R S I O N S ((iAtom,R(jAtom)),T(kAtom,S(lAtom)))

D_Trsn = Zero

iAtom = Ind(1)
jAtom = Ind(2)
kAtom = Ind(3)
lAtom = Ind(4)
iOp_E = iOp_(1)
iOp_R = iOp_(2)
iOp_T = iOp_(3)
iOp_TS = iOp_(4)
iOp_S = ieor(iOp_T,iOp_TS)
!write(u6,*) iAtom,jAtom,kAtom,lAtom
!write(u6,*) iOp_E,iOp_R,iOp_T,iOp_TS,iOp_S

nU_A = nStab(iAtom)
iU_A = iU(jStab(0,iAtom),nU_A)
nU_B = nStab(jAtom)
iU_B = iU(jStab(0,jAtom),nU_B)
nU_C = nStab(kAtom)
iU_C = iU(jStab(0,kAtom),nU_C)
nU_D = nStab(lAtom)
iU_D = iU(jStab(0,lAtom),nU_D)

!write(u6,*) ' U_A:',iU_A,nU_A
!write(u6,*) ' U_B:',iU_B,nU_B
!write(u6,*) ' U_C:',iU_C,nU_C
!write(u6,*) ' U_D:',iU_D,nU_D

! Form stabilizer for (iAtom,jAtom)

iOp_ER = ieor(iOp_E,iOp_R)
if (iAtom == jAtom) then
  iU_AB = ior(iU_A,iUR(iOp_ER,iU_B))
else
  iU_AB = iand(iU_A,iU_B)
end if
!write(u6,*) iAtom == jAtom
!write(u6,*) ' U_AB:',iU_AB,nU(iU_AB)

! Form stabilizer for (kAtom,lAtom)

iOp_ES = ieor(iOp_E,iOp_S)
if (kAtom == lAtom) then
  iU_CD = ior(iU_C,iUR(iOp_ES,iU_D))
else
  iU_CD = iand(iU_C,iU_D)
end if
!write(u6,*) kAtom == lAtom
!write(u6,*) ' U_CD:',iU_CD,nU(iU_CD)

! Form the stabilizer for the torsion

if ((iAtom /= lAtom) .or. (jAtom /= kAtom) .or. ((iAtom == lAtom) .and. (jAtom == kAtom) .and. (iOp_ER /= iOp_ES))) then
  iU_ABCD = iand(iU_AB,iU_CD)
  !write(u6,*) ' Ops!'
else
  iOp_ET = ieor(iOp_E,iOp_T)
  iU_ABCD = ior(iU_AB,iUR(iOp_ET,iU_CD))
end if
!write(u6,*) iAtom /= lAtom
!write(u6,*) jAtom /= kAtom
!write(u6,*) ((iAtom == lAtom) .and. (jAtom == kAtom) .and. (iOp_ER /= iOp_ES))
nU_ABCD = nU(iU_ABCD)
!write(u6,*) ' U_ABCD:',iU_ABCD,nU(iU_ABCD)

! Compute the degeneracy of the torsion

iDeg = nSym/nU_ABCD
D_Trsn = real(iDeg,kind=wp)

!write(u6,*) ' D_Trsn=',D_Trsn

return

end function D_Trsn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine insert_ri (length,operator)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 13.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer length,k,istart,v1pos,v2pos,p1pos,p2pos,idum1,idum2,idum3,
     *        idum4, iMax
      character*(maxlength) operator
c
      istart=1
      iMax=0
c
 300  continue
c
      iMax = iMax + 1
      If (iMax.gt.30) Call Abend
      v1pos=0
      v2pos=0
      p1pos=0
      p2pos=0
      idum1=index(operator(istart:length),'V')
      idum4=index(operator(istart:length),'X')
      if ((idum4.gt.0.and.idum4.lt.idum1) .or. idum1.eq.0) idum1=idum4
      if (idum1.gt.0) v1pos=idum1+istart-1
      idum2=index(operator(istart:length),'E01')
      idum4=index(operator(istart:length),'CE0')
      if ((idum4.gt.0.and.idum4.lt.idum2) .or. idum2.eq.0) idum2=idum4
      if (idum2.gt.0) then
        if (v1pos.eq.0) then
          v1pos=idum2+istart-1
        else
          if (idum2+istart-1.lt.v1pos) v1pos=idum2+istart-1
        endif
      endif
      idum3=index(operator(istart:length),'S')
      if (idum3.gt.0) then
        if (v1pos.eq.0) then
          v1pos=idum3+istart-1
        else
          if (idum3+istart-1.lt.v1pos) v1pos=idum3+istart-1
        endif
      endif
      if (v1pos.eq.0) then
        goto 200
      endif
c
      idum1=index(operator(istart:length),'P')
      if (idum1.gt.0) p1pos=idum1+istart-1
      if (v1pos.lt.p1pos) then
        istart=v1pos+1
        goto 300
c
      else
c
        idum1=index(operator(v1pos+1:length),'V')
        idum4=index(operator(v1pos+1:length),'X')
        if ((idum4.gt.0.and.idum4.lt.idum1) .or. idum1.eq.0) idum1=idum4
        if (idum1.gt.0) v2pos=v1pos+idum1
        idum2=index(operator(v1pos+1:length),'E01')
        idum4=index(operator(v1pos+1:length),'CE0')
        if ((idum4.gt.0.and.idum4.lt.idum2) .or. idum2.eq.0) idum2=idum4
        if (idum2.gt.0) then
          if (v2pos.eq.0) then
            v2pos=v1pos+idum2
          else
            if (idum2+v1pos.lt.v2pos) v2pos=v1pos+idum2
          endif
        endif
        idum3=index(operator(v1pos+1:length),'S')
        if (idum3.gt.0) then
          if (v2pos.eq.0) then
            v2pos=v1pos+idum3
          else
            if (idum3+v1pos.lt.v2pos) v2pos=v1pos+idum3
          endif
        endif
c
        if (p1pos.eq.0) then
          p2pos=0
        else
          idum1=index(operator(p1pos+1:length),'P')
          if (idum1.gt.0) p2pos=idum1+p1pos
        endif
c
        if (v2pos.lt.p2pos .and. v2pos.ne.0) then
          if (length+3.gt.maxlength) then
            write (stdout,2002) maxlength
2002        format (/2X,'ERROR in insert_ri: maxlength = ',I3,
     *              ' is to small.'//2X,'Increase it in parameters.h.',
     *              //2X,'STOP.',/)
            CALL Abend
          endif
          do 100 k=length,v2pos,-1
             operator(k+3:k+3)=operator(k:k)
 100      continue
          operator(v2pos:v2pos+2)='PQP'
          istart=v2pos+2
          length=length+3
          goto 300
        else
          if (p1pos.eq.0.and.p2pos.eq.0) then
            goto 200
          else
            istart=p2pos+1
            goto 300
          endif
        endif
c
      endif
c
 200  continue
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, IBM                                              *
************************************************************************
      Logical Function EQ(A,B)
************************************************************************
*                                                                      *
* Object: to return the value .true. if A and B are the same centers.  *
*                                                                      *
************************************************************************
      Real*8, Intent(In):: A(3),B(3)
      EQ = A(1).eq.B(1) .and. A(2).eq.B(2) .and. A(3).eq.B(3)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************

subroutine GetGDMat(GDMat)

use Index_Functions, only: iTri, nTri_Elem
use lucia_data, only: DStmp, Dtmp
use Lucia_Interface, only: Lucia_Util
use rasscf_global, only: iAdr15, lRoots, nAc
use general_data, only: JOBIPH, NCONF
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: GDMat(nTri_Elem(lRoots),NAC,NAC)
integer(kind=iwp) :: CIDisk1, CIDisk2, iOrb, jRoot, kRoot
real(kind=wp), allocatable :: SDtmp(:), TmpD(:), VecL(:), VecR(:)

call mma_allocate(VecL,NConf,Label='VecL')
call mma_allocate(VecR,NConf,Label='VecR')
call mma_allocate(TmpD,NAC**2,Label='TmpD')
call mma_allocate(SDtmp,NAC**2,Label='SDtmp')
SDtmp(:) = DStmp(:)
DStmp(:) = Zero
TmpD(:) = Dtmp(:)
Dtmp(:) = Zero
CIDisk1 = IADR15(4)
do jRoot=1,lRoots
  call DDafile(JOBIPH,2,VecL,nConf,CIDisk1)
  CIDisk2 = IADR15(4)
  do kRoot=1,jRoot
    call DDafile(JOBIPH,2,VecR,nConf,CIDisk2)
    !write(u6,*) 'VecL and VecR for states',jRoot,kRoot
    !write(u6,*) (VecL(I),I=0,NConf-1)
    !write(u6,*) (VecR(I),I=0,NConf-1)
    call Lucia_Util('Densi',CI_Vector=VecL(:),RVEC=VECR(:))
    !write(u6,*) 'GDMat for states',jRoot,kRoot
    do IOrb=1,NAC
      GDMat(iTri(jRoot,kRoot),:,IOrb) = Dtmp((IOrb-1)*NAC+1:IOrb*NAC)
      !write(u6,'(10(F8.4,2X))') (GDMat(iTri(jRoot,kRoot),JOrb,IOrb),JOrb=1,NAC)
    end do
  end do
end do
DStmp(:) = SDtmp(:)
DTmp(:) = TmpD(:)
call mma_deallocate(SDtmp)
call mma_deallocate(TmpD)
call mma_deallocate(VecL)
call mma_deallocate(VecR)

end subroutine GetGDMat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine vRysRW(la,lb,lc,ld,Arg,Root,Weight,nArg,nRys)
!***********************************************************************
!                                                                      *
!  Object: to compute the roots and weights of the Rys polynomials.    *
!          This is done with two approximations. For low arguments     *
!          we will use a 6th order polynomial and for high arguments   *
!          we will use the asymptotic formulas which are based on the  *
!          roots and weight of Hermite polynomials.                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             September '90                                            *
!***********************************************************************

use vRys_RW, only: Cff, ddx, HerR2, HerW2, iCffR, iCffW, iHerR2, iHerW2, iMap, ix0, Map, nMap, nMxRys, nx0, TMax, x0
use Gateway_global, only: asymptotic_Rys
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: la, lb, lc, ld, nArg, nRys
real(kind=wp), intent(in) :: Arg(nArg)
real(kind=wp), intent(inout) :: Root(nRys,nArg)
real(kind=wp), intent(out) :: Weight(nRys,nArg)
integer(kind=iwp) :: labcd
real(kind=wp) :: Tmax_

#ifdef _DEBUGPRINT_
iRout = 78
iPrint = nPrint(iRout)
if (iPrint >= 99) call RecPrt('In vRysRW:Arg',' ',Arg,nArg,1)
#endif
labcd = 1

if (nRys > nMxRys) then
  call WarningMessage(2,'vRysrw: nRys in vRysRW is larger than nMxRys!')
  write(u6,*) ' nRys  =',nRys
  write(u6,*) ' nMxRys=',nMxRys
  call Abend()
end if

! For the FMM we use the asymptotic limit to compute the
! multipole-component of the integrals

TMax_ = TMax(nRys)
if (asymptotic_Rys) TMax_ = huge(TMax_)

select case (nRys)

  case (1)
    labcd = la+lb+lc+ld
    if (labcd == 0) then
      call Rys01(Arg,nArg,Weight,Map(iMap(1)),nMap(1),x0(ix0(1)),nx0(1),Cff(iCffW(6,1)),Cff(iCffW(5,1)),Cff(iCffW(4,1)), &
                 Cff(iCffW(3,1)),Cff(iCffW(2,1)),Cff(iCffW(1,1)),Cff(iCffW(0,1)),ddx(nRys),HerW2(iHerW2(1)),TMax_)
    else
      call Rys11(Arg,nArg,Root,Weight,Map(iMap(1)),nMap(1),x0(ix0(1)),nx0(1),Cff(iCffR(6,1)),Cff(iCffR(5,1)),Cff(iCffR(4,1)), &
                 Cff(iCffR(3,1)),Cff(iCffR(2,1)),Cff(iCffR(1,1)),Cff(iCffR(0,1)),Cff(iCffW(6,1)),Cff(iCffW(5,1)),Cff(iCffW(4,1)), &
                 Cff(iCffW(3,1)),Cff(iCffW(2,1)),Cff(iCffW(1,1)),Cff(iCffW(0,1)),ddx(nRys),HerW2(iHerW2(1)),HerR2(iHerR2(1)),TMax_)
    end if

  case (2)
    call Rys22(Arg,nArg,Root,Weight,Map(iMap(2)),nMap(2),x0(ix0(2)),nx0(2),Cff(iCffR(6,2)),Cff(iCffR(5,2)),Cff(iCffR(4,2)), &
               Cff(iCffR(3,2)),Cff(iCffR(2,2)),Cff(iCffR(1,2)),Cff(iCffR(0,2)),Cff(iCffW(6,2)),Cff(iCffW(5,2)),Cff(iCffW(4,2)), &
               Cff(iCffW(3,2)),Cff(iCffW(2,2)),Cff(iCffW(1,2)),Cff(iCffW(0,2)),ddx(nRys),HerW2(iHerW2(2)),HerR2(iHerR2(2)),TMax_)

  case (3)
    call Rys33(Arg,nArg,Root,Weight,Map(iMap(3)),nMap(3),x0(ix0(3)),nx0(3),Cff(iCffR(6,3)),Cff(iCffR(5,3)),Cff(iCffR(4,3)), &
               Cff(iCffR(3,3)),Cff(iCffR(2,3)),Cff(iCffR(1,3)),Cff(iCffR(0,3)),Cff(iCffW(6,3)),Cff(iCffW(5,3)),Cff(iCffW(4,3)), &
               Cff(iCffW(3,3)),Cff(iCffW(2,3)),Cff(iCffW(1,3)),Cff(iCffW(0,3)),ddx(nRys),HerW2(iHerW2(3)),HerR2(iHerR2(3)),TMax_)

  case (4)
    call Rys44(Arg,nArg,Root,Weight,Map(iMap(4)),nMap(4),x0(ix0(4)),nx0(4),Cff(iCffR(6,4)),Cff(iCffR(5,4)),Cff(iCffR(4,4)), &
               Cff(iCffR(3,4)),Cff(iCffR(2,4)),Cff(iCffR(1,4)),Cff(iCffR(0,4)),Cff(iCffW(6,4)),Cff(iCffW(5,4)),Cff(iCffW(4,4)), &
               Cff(iCffW(3,4)),Cff(iCffW(2,4)),Cff(iCffW(1,4)),Cff(iCffW(0,4)),ddx(nRys),HerW2(iHerW2(4)),HerR2(iHerR2(4)),TMax_)

  case (5)
    call Rys55(Arg,nArg,Root,Weight,Map(iMap(5)),nMap(5),x0(ix0(5)),nx0(5),Cff(iCffR(6,5)),Cff(iCffR(5,5)),Cff(iCffR(4,5)), &
               Cff(iCffR(3,5)),Cff(iCffR(2,5)),Cff(iCffR(1,5)),Cff(iCffR(0,5)),Cff(iCffW(6,5)),Cff(iCffW(5,5)),Cff(iCffW(4,5)), &
               Cff(iCffW(3,5)),Cff(iCffW(2,5)),Cff(iCffW(1,5)),Cff(iCffW(0,5)),ddx(nRys),HerW2(iHerW2(5)),HerR2(iHerR2(5)),TMax_)

  case (6)
    call Rys66(Arg,nArg,Root,Weight,Map(iMap(6)),nMap(6),x0(ix0(6)),nx0(6),Cff(iCffR(6,6)),Cff(iCffR(5,6)),Cff(iCffR(4,6)), &
               Cff(iCffR(3,6)),Cff(iCffR(2,6)),Cff(iCffR(1,6)),Cff(iCffR(0,6)),Cff(iCffW(6,6)),Cff(iCffW(5,6)),Cff(iCffW(4,6)), &
               Cff(iCffW(3,6)),Cff(iCffW(2,6)),Cff(iCffW(1,6)),Cff(iCffW(0,6)),ddx(nRys),HerW2(iHerW2(6)),HerR2(iHerR2(6)),TMax_)

  case (7)
    call Rys77(Arg,nArg,Root,Weight,Map(iMap(7)),nMap(7),x0(ix0(7)),nx0(7),Cff(iCffR(6,7)),Cff(iCffR(5,7)),Cff(iCffR(4,7)), &
               Cff(iCffR(3,7)),Cff(iCffR(2,7)),Cff(iCffR(1,7)),Cff(iCffR(0,7)),Cff(iCffW(6,7)),Cff(iCffW(5,7)),Cff(iCffW(4,7)), &
               Cff(iCffW(3,7)),Cff(iCffW(2,7)),Cff(iCffW(1,7)),Cff(iCffW(0,7)),ddx(nRys),HerW2(iHerW2(7)),HerR2(iHerR2(7)),TMax_)

  case (8)
    call Rys88(Arg,nArg,Root,Weight,Map(iMap(8)),nMap(8),x0(ix0(8)),nx0(8),Cff(iCffR(6,8)),Cff(iCffR(5,8)),Cff(iCffR(4,8)), &
               Cff(iCffR(3,8)),Cff(iCffR(2,8)),Cff(iCffR(1,8)),Cff(iCffR(0,8)),Cff(iCffW(6,8)),Cff(iCffW(5,8)),Cff(iCffW(4,8)), &
               Cff(iCffW(3,8)),Cff(iCffW(2,8)),Cff(iCffW(1,8)),Cff(iCffW(0,8)),ddx(nRys),HerW2(iHerW2(8)),HerR2(iHerR2(8)),TMax_)

  case (9)
    call Rys99(Arg,nArg,Root,Weight,Map(iMap(9)),nMap(9),x0(ix0(9)),nx0(9),Cff(iCffR(6,9)),Cff(iCffR(5,9)),Cff(iCffR(4,9)), &
               Cff(iCffR(3,9)),Cff(iCffR(2,9)),Cff(iCffR(1,9)),Cff(iCffR(0,9)),Cff(iCffW(6,9)),Cff(iCffW(5,9)),Cff(iCffW(4,9)), &
               Cff(iCffW(3,9)),Cff(iCffW(2,9)),Cff(iCffW(1,9)),Cff(iCffW(0,9)),ddx(nRys),HerW2(iHerW2(9)),HerR2(iHerR2(9)),TMax_)

  case default
    call WarningMessage(2,' vRysRW: nRys in vRysRW is larger than MaxRys!')
    call Abend()

end select

#ifdef _DEBUGPRINT_
if (iPrint >= 99) then
  if (labcd /= 0) call Recprt(' In vRysRW: Roots ',' ',Root,nRys,nArg)
  call Recprt(' In vRysRW: Weight',' ',Weight,nRys,nArg)
end if
#endif
return

end subroutine vRysRW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function SelfEn(nChg)
! Compute the self interaction energy of input point charges

use external_centers, only: XF
use Constants, only: Zero, Three
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: SelfEn
integer(kind=iwp), intent(in) :: nChg
integer(kind=iwp) :: iChg, iPL, jChg
real(kind=wp) :: E, Qi, Qj, R, R2, R3, R5, X, XMui, XMuj, Y, YMui, YMuj, Z, ZMui, ZMuj
integer(kind=iwp), external :: iPL_espf

iPL = iPL_espf()
E = Zero
do iChg=2,nChg
  Qi = XF(4,iChg)
  XMui = XF(5,iChg)
  YMui = XF(6,iChg)
  ZMui = XF(7,iChg)
  do jChg=1,iChg-1
    X = XF(1,iChg)-XF(1,jChg)
    Y = XF(2,iChg)-XF(2,jChg)
    Z = XF(3,iChg)-XF(3,jChg)
    Qj = XF(4,jChg)
    XMuj = XF(5,jChg)
    YMuj = XF(6,jChg)
    ZMuj = XF(7,jChg)
    R2 = X*X+Y*Y+Z*Z
    R = sqrt(R2)
    R3 = R*R2
    R5 = R2*R3
    ! q_i interacts with q_j and mu_j
    if (Qi /= Zero) E = E+Qi*(Qj/R-XMuj*X/R3-YMuj*Y/R3-ZMuj*Z/R3)
    ! mu_x_i interacts with q_j and mu_j
    if (XMui /= Zero) E = E+XMui*(-Qj*X/R3+XMuj*(Three*X*X-R2)/R5+YMuj*Three*X*Y/R5+ZMuj*Three*X*Z/R5)
    ! mu_y_i interacts with q_j and mu_j
    if (YMui /= Zero) E = E+YMui*(-Qj*Y/R3+YMuj*(Three*Y*Y-R2)/R5+XMuj*Three*X*Y/R5+ZMuj*Three*Y*Z/R5)
    ! mu_z_i interacts with q_j and mu_j
    if (ZMui /= Zero) E = E+ZMui*(-Qj*Z/R3+ZMuj*(Three*Z*Z-R2)/R5+XMuj*Three*X*Z/R5+YMuj*Three*Y*Z/R5)
  end do
end do
SelfEn = E
if ((nChg > 0) .and. (iPL >= 2)) write(u6,'(A,F16.10)') ' (For info only) Self Energy of the charges =',SelfEn

return

end function SelfEn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine gencoul(l1,l2,l3,l4,makemean,
     *                   bonn,breit,sameorb,cont4SO,cont4OO,icont4,
     *                   powexp,coulovlp)
      implicit real*8(a-h,o-z)
cbs   SUBROUTINE to generate all required radial
cbs   integrals for the four angular momenta l1-l4
#include "para.fh"
#include "param.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: Scr1(:), Scr2(:), Prim(:),
     &                      Quot1(:), Quot2(:), QuotP1(:), QuotP2(:)
      logical makemean,bonn,breit,sameorb
      dimension cont4SO(*),cont4OO(*),
     *          powexp(MxprimL,MxprimL,0:Lmax,0:Lmax,0:(Lmax+Lmax+5)),
     *          coulovlp(*)
*
      max1=1  !starting values for limits of precalculated
c             ! powers of function Cfunct(X)
      max2=1
cbs   first of all, this routine determines, for which L
cbs   values the radial integrals have to be solved
cbs   initialize the number of blocks for the different
cbs   l-combinations
cbs   no (ss|ss) contributions
      if (l1.eq.0.and.l2.eq.0.and.l3.eq.0.and.l4.eq.0) return
c      ! no integrals for <ss|ss>
      if (makemean) then
         nblock=1  ! sp sp are the first, so the first block
         Lstarter(1)=1
      else
         Call SysAbendMsg('gencoul',
     &                    'only mean-field with this version',' ')
      endif
cbs   keep track of L-values for later purposes
      Lvalues(1)=l1
      Lvalues(2)=l2
      Lvalues(3)=l3
      Lvalues(4)=l4
cbs   now nanz is given the new value
      nanz=ncontrac(l1)*ncontrac(l2)*ncontrac(l3)*ncontrac(l4)
      nprimprod=nprimit(l1)*nprimit(l2)*nprimit(l3)*nprimit(l4)
*
      Call mma_allocate(Quot1,nPrimProd,Label='Quot1')
      Call mma_allocate(Quot2,nPrimProd,Label='Quot2')
      Call mma_allocate(QuotP1,nPrimProd,Label='QuotP1')
      Call mma_allocate(QuotP2,nPrimProd,Label='QuotP2')
      Call mma_allocate(Prim,nPrimProd,Label='Prim')
      Call mma_allocate(Scr1,nPrimProd,Label='Scr1')
      Call mma_allocate(Scr2,nPrimProd,Label='Scr2')
c
      call initfrac(nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4),
     *              Quot1,Quot2,exponents(1,l1),exponents(1,l2),
     *              exponents(1,l3),exponents(1,l4))
cbs   prepare the powers needed for cfunctx
c
c
c     There are seven different CASES of integrals following
c       (   A  --  C)
c
c     The structure is the same for all cases, therefore comments can be found only on case A
c
c
c
cbs   ###########################################################################################################
cbs   the (+2) cases          CASE A
cbs   ##########################################################################################################
      incl1=1  !  Those increments define the case
      incl3=1
cbs   determine the possible L-values for the integrals by checking for triangular equation
c
      call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
c
cbs   returns first and last L-values (Lanf,Lend), for which
cbs   radial integrals have to be calculated
      if(Lend-Lanf.ge.0) then
cbs   if there are blocks
              Lblocks(1)=(Lend-Lanf)/2+1 ! L increases in steps of 2,
cbs                                       due to parity conservation
              Lfirst(1)=Lanf
              Llast(1)=Lend
      else
              Lblocks(1)=0
      endif
      if (Lblocks(1).gt.0) then    ! integrals have to be calculated
cbs### check, whether integrals fit on array ################
      if  (Lstarter(1)+nanz*Lblocks(1).gt.icont4) then
      write(6,*) 'end at: ',Lstarter(1)+nanz*Lblocks(1)
       Call SysAbendMsg('gencoul','increase icont4 in amfi.f',' ')
      endif
cbs### check, whether integrals fit on array ################
      istart=Lstarter(1)
c      ! gives the address, where to write the contracted integrals
cbs   ipow1 and ipow2 are the the numbers of powers in the prefactor
cbs   of the function Cfunct
cbs   now loop over possible L-values
      do Lrun= Lfirst(1),Llast(1),2
                      ipow1=2+(l2+l4+Lrun)/2
                      ipow2=2+(l1+l3+incl1+incl3+Lrun)/2
cbs   those powers have to be generated...
      call getpow(ipow1,Quot1,QuotP1,
     *            nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4))
cbs   those powers have to be generated...
      call getpow(ipow2,Quot2,QuotP2,
     *            nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4))
c     in buildcoul the radial integrals are calculated
                      call buildcoul(l1,l2,l3,l4,incl1,incl3,
     *         Lrun,Prim,nprimit(l1),nprimit(l2),nprimit(l3),
     *                nprimit(l4),
     *                exponents(1,l1),exponents(1,l2),
     *                exponents(1,l3),exponents(1,l4),
     *                powexp(1,1,l3,l1,lrun),powexp(1,1,l4,l2,lrun),
     *                QuotP1,QuotP2,coulovlp)
cbs   in the contcas_ routines the integrals are contracted, including exponents as prefactors...
                      if (bonn.or.breit.or.sameorb) then
                      call contcasASO(l1,l2,l3,l4,istart,Prim,
     *                                Scr1,Scr2,cont4SO)
                else
                      call contcasASO(l1,l2,l3,l4,istart,Prim,
     *                                Scr1,Scr2,cont4SO)
                call contcasAOO(l1,l2,l3,l4,istart,Prim,
     *                          Scr1,Scr2,cont4OO)
                endif
                istart=istart+nanz! start for next block  contr integr.
      enddo
      endif
cbs   ##########################################################################################################
cbs   the (0) cases         CASE  B
cbs   ##########################################################################################################
      incl1=0
      incl3=0
      call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
      if(Lend-Lanf.ge.0) then
      Lblocks(2)=(Lend-Lanf)/2+1
      Lfirst(2)=Lanf
      Llast(2)=Lend
      Lblocks(3)=(Lend-Lanf)/2+1
      Lfirst(3)=Lanf
      Llast(3)=Lend
      else
      Lblocks(2)=0
      Lblocks(3)=0
      endif
      Lstarter(2)=Lstarter(1)+
     *nanz*Lblocks(1)
      Lstarter(3)=Lstarter(2)+
     *nanz*Lblocks(2)
cbs   primitive integrals are the same for type 2 and 3  !!!!!
      if (Lblocks(2).gt.0) then
cbs### check, whether integrals fit on array ################
      if  (Lstarter(2)+2*nanz*Lblocks(2).gt.icont4) then
      write(6,*) 'end at: ',Lstarter(2)+2*nanz*Lblocks(2)
       Call SysAbendMsg ('gencoul','increase icont4 in amfi.f',' ' )
      endif
cbs### check, whether integrals fit on array ################
      istart=Lstarter(2)
      istart2=Lstarter(3)
      do Lrun= Lfirst(2),Llast(2),2
      ipow1=2+(l2+l4+Lrun)/2
      ipow2=2+(l1+l3+incl1+incl3+Lrun)/2
      call getpow(ipow1,Quot1,QuotP1,
     *            nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4))
      call getpow(ipow2,Quot2,QuotP2,
     *            nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4))
      call buildcoul(l1,l2,l3,l4,incl1,incl3,
     *               Lrun,Prim,nprimit(l1),nprimit(l2),nprimit(l3),
     *               nprimit(l4),
     *               exponents(1,l1),exponents(1,l2),
     *               exponents(1,l3),exponents(1,l4),
     *               powexp(1,1,l3,l1,lrun),powexp(1,1,l4,l2,lrun),
     *               QuotP1,QuotP2,coulovlp)
      if (bonn.or.breit.or.sameorb) then
      call contcasB1SO(l1,l2,l3,l4,istart,Prim,
     *                 Scr1,Scr2,cont4SO)
      call contcasB2SO(l1,l2,l3,l4,istart2,Prim,
     *                 Scr1,Scr2,cont4SO)
      else
      call contcasB1SO(l1,l2,l3,l4,istart,Prim,
     *                 Scr1,Scr2,cont4SO)
      call contcasB2SO(l1,l2,l3,l4,istart2,Prim,
     *                 Scr1,Scr2,cont4SO)
      Call contcasB1OO(l1,l2,l3,l4,istart,Prim,
     *                 Scr1,Scr2,cont4OO)
      Call contcasB2OO(l1,l2,l3,l4,istart2,Prim,
     *                 Scr1,Scr2,cont4OO)
      endif
      istart=istart+nanz
      istart2=istart2+nanz
      enddo
      endif
cbs   ##########################################################################################################
cbs   the (-2) cases      CASE C
cbs   ##########################################################################################################
      if (l1.eq.0.or.l3.eq.0) then
      Lblocks(4)=0
      else
      incl1=-1
      incl3=-1
      call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
      if(Lend-Lanf.ge.0) then
      Lblocks(4)=(Lend-Lanf)/2+1
      Lfirst(4)=Lanf
      Llast(4)=Lend
      else
      Lblocks(4)=0
      endif
      endif
      Lstarter(4)=Lstarter(3)+
     *nanz*Lblocks(3)
      if (Lblocks(4).gt.0) then
cbs### check, whether integrals fit on array ################
      if  (Lstarter(4)+nanz*Lblocks(4).gt.icont4) then
      write(6,*) 'end at: ',Lstarter(4)+nanz*Lblocks(4)
      Call SysAbendMsg('gencoul', 'increase icont4 in amfi.f', ' ' )
      endif
cbs### check, whether integrals fit on array ################
      istart=Lstarter(4)
      do Lrun= Lfirst(4),Llast(4),2
      ipow1=2+(l2+l4+Lrun)/2
      ipow2=2+(l1+l3+incl1+incl3+Lrun)/2
      call getpow(ipow1,Quot1,QuotP1,
     *            nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4))
      call getpow(ipow2,Quot2,QuotP2,
     *            nprimit(l1),nprimit(l2),nprimit(l3),nprimit(l4))
      call buildcoul(l1,l2,l3,l4,incl1,incl3,
     *               Lrun,Prim,nprimit(l1),nprimit(l2),nprimit(l3),
     *               nprimit(l4),
     *               exponents(1,l1),exponents(1,l2),
     *               exponents(1,l3),exponents(1,l4),
     *               powexp(1,1,l3,l1,lrun),powexp(1,1,l4,l2,lrun),
     *               QuotP1,QuotP2,coulovlp)
      if (bonn.or.breit.or.sameorb) then
         call contcasCSO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4SO)
      else
         call contcasCSO(l1,l2,l3,l4,istart,Prim,Scr1,Scr2,cont4SO)
         call contcasCOO(l1,l2,l3,l4,istart,prim,Scr1,Scr2,cont4OO)
      endif
      istart=istart+nanz
      enddo
      endif
*
      Call mma_deallocate(Quot2)
      Call mma_deallocate(Quot1)
      Call mma_deallocate(QuotP2)
      Call mma_deallocate(QuotP1)
      Call mma_deallocate(Prim)
      Call mma_deallocate(Scr2)
      Call mma_deallocate(Scr1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine redabkm(iabkm,labkm,nabcbit,iabcbit,jatmp,jbtmp,jmtmp,kktmp)
! this subroutine unpacks ja jb jm kt from compressed arrays

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: labkm, iabkm(1:labkm), nabcbit, iabcbit
integer(kind=iwp), intent(out) :: jatmp, jbtmp, jmtmp, kktmp

call upacknod(iabkm,1,jatmp,nabcbit,iabcbit,labkm)
call upacknod(iabkm,2,jbtmp,nabcbit,iabcbit,labkm)
call upacknod(iabkm,3,jmtmp,nabcbit,iabcbit,labkm)
call upacknod(iabkm,4,kktmp,nabcbit,iabcbit,labkm)

return

end subroutine redabkm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ONCMO_m(CMO1,CMO2)
      Implicit Real*8 (A-H,O-Z)
      Dimension CMO1(*),CMO2(*)
#include "rasdim.fh"
#include "warnings.h"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Character*16 ROUTINE
      Parameter (ROUTINE='ONCMO   ')
#include "WrkSpc.fh"

C Local print level (if any)
      IPRLEV=IPRLOC(1)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF

      NBM=0
      NOM=0
      NSBUF=0
      DO ISYM=1,NSYM
       NB=NBAS(ISYM)
       NO=NB-NDEL(ISYM)
       NBM=MAX(NBM,NB)
       NOM=MAX(NOM,NO)
       NSBUF=NSBUF+(NB*(NB+1))/2
      END DO
      IF(NOM.eq.0) GOTO 900
      CALL GETMEM('SBUF','ALLO','REAL',LSBUF,NSBUF+4)
      CALL GETMEM('SMAT','ALLO','REAL',LSMAT,NBM**2)
      CALL GETMEM('SCTMP','ALLO','REAL',LSCTMP,NBM)
      CALL GETMEM('OVL','ALLO','REAL',LOVL,NBM)
* Read overlap matrix SMAT:
      i_Rc=0
      i_Opt=2
      i_Component=1
      i_SymLbl=1
      Call RdOne(i_Rc,i_Opt,'Mltpl  0',i_Component,WORK(LSBUF),i_SymLbl)
      If ( i_Rc.ne.0 ) Then
        Write(LF,*)' RASSCF is trying to orthonormalize orbitals but'
        Write(LF,*)' could not read overlaps from ONEINT. Something'
        Write(LF,*)' is wrong with the file, or possibly with the'
        Write(LF,*)' program. Please check.'
        Call Quit(_RC_IO_ERROR_READ_)
      End If
*
*---- Print out nuclear charge
*
      IF(IPRLEV.GE.USUAL) THEN
        Write(LF,*)
        Tot_Nuc_Charge=Work(LSBUF+NSBUF+3)
        xMol_Charge=Tot_Nuc_Charge-DBLE(2*(NFR+NIN)+NACTEL)
        Write(LF,'(6x,A,f8.2)') 'Total molecular charge',xMol_Charge
      End If
*
* Orthonormalize symmetry blocks:
*
      NDSAVE=NDELT
      NNEGSS=0
      ip_SBUF=LSBUF
      ip_CMO=1
      Do  iSym=1,nSym
       NB=nBas(iSym)
       NO=NB-nDel(iSym)
       If ( NB.gt.0 ) then
         IF (NO.GT.0) THEN
           Call SQUARE(WORK(ip_SBUF),WORK(LSMAT),1,NB,NB)
* NNEW=Nr of already orthonormal new CMO''s
           NNEW=0
           DO IOLD=1,NO
            IPOLD=ip_CMO+NB*(IOLD-1)
            IPNEW=ip_CMO+NB*NNEW
           IF(IPNEW.LT.IPOLD)CALL DCOPY_(NB,CMO1(IPOLD),1,CMO2(IPNEW),1)
  10        CONTINUE
            CALL DGEMM_('N','N',NB,1,NB,1.0D0,WORK(LSMAT),NB,
     &                 CMO2(IPNEW),NB,0.0D0,WORK(LSCTMP),NB)
            IF(NNEW.GT.0) THEN
              CALL DGEMM_('T','N',NNEW,1,NB,1.0D0,CMO2(ip_CMO),NB,
     &                  WORK(LSCTMP),NB,0.0D0,WORK(LOVL),NNEW)
              CALL DGEMM_('N','N',NB,1,NNEW,-1.0D0,CMO2(ip_CMO),NB,
     &                  WORK(LOVL),NNEW,1.0D0,CMO2(IPNEW),NB)
            END IF
            XNRM2=DDOT_(NB,WORK(LSCTMP),1,CMO2(IPNEW),1)
            XSCL=1.0D0/SQRT(XNRM2)
            IF (XNRM2.GT.1.0D-10) THEN
             CALL DSCAL_(NB,XSCL,CMO2(IPNEW),1)
             IF(XNRM2.LT.0.2D0) GOTO 10
             NNEW=NNEW+1
            END IF
           END DO
           NREMOV=NO-NNEW
           IF (NREMOV.GT.0) THEN
             ND=NDEL(ISYM)
             NS=NSSH(ISYM)
             NDNEW=NB-NNEW
             NSNEW=NS+ND-NDNEW
             IF(NSNEW.GE.0) THEN
              IF(IPRLEV.GE.TERSE) THEN
               Call WarningMessage(1,'ONCMO Warning')
               Write(LF,*)' * Exact or very near linear dependence '
               Write(LF,*)' * forces RASSCF to delete additional '//
     &                     'orbitals.'
               Write(LF,*)' *                  Symmetry block:',ISYM
               Write(LF,*)' * Earlier number of deleted orbs =',ND
               Write(LF,*)' *     New number of deleted orbs =',NDNEW
              END IF
             ELSE
              Write(LF,*)' **** ONCMO Error **************************'
              Write(LF,*)' * Exact or very near linear dependence '
              Write(LF,*)' * forces RASSCF to stop execution.'
              Write(LF,*)' *                  Symmetry block:',ISYM
              Write(LF,*)' * Effective nr of orthonormal orbs =',NNEW
              Write(LF,*)' *   Earlier number of deleted orbs =',ND
              Write(LF,*)' * Earlier number of secondary orbs =',NS
              Write(LF,*)' *       New number of deleted orbs =',NDNEW
              Write(LF,*)' *     New number of secondary orbs =',NSNEW
              NNEGSS=NNEGSS+1
             END IF
             NDEL(ISYM)=NDNEW
             NSSH(ISYM)=NSNEW
             NORB(ISYM)=NORB(ISYM)-NREMOV
             NDELT=NDELT+NREMOV
             NSEC =NSEC -NREMOV
             NORBT=NORBT-NREMOV
           END IF
         END IF
         ip_SBUF=ip_SBUF+(NB*NB+NB)/2
         ip_CMO=ip_CMO+NB*NB
       End If
      End Do
      IF(NNEGSS.GT.0) CALL QUIT(_RC_GENERAL_ERROR_)

      IF (NDSAVE.NE.NDELT) THEN
       NTOT3=0
       NTOT4=0
       DO ISYM=1,NSYM
          NTOT3=NTOT3+(NORB(ISYM)+NORB(ISYM)**2)/2
          NTOT4=NTOT4+NORB(ISYM)**2
       END DO
      END IF

      CALL GETMEM('SBUF','FREE','REAL',LSBUF,NSBUF)
      CALL GETMEM('SMAT','FREE','REAL',LSMAT,NBM)
      CALL GETMEM('SCTMP','FREE','REAL',LSCTMP,NBM)
      CALL GETMEM('OVL','FREE','REAL',LOVL,NBM)
*
 900  CONTINUE
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Leaving ',ROUTINE
      END IF
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AppDerCpl(natom,ChgNuc,Prop,DerCpl,HAM)
! Approximate derivative couplings:         <\Psi_I|\nabla H|\Psi_J>
!                                    f_IJ =  ----------------------
!                                                 E_J - E_I
!
! If the wfn are real-valued: f_II = 0 ; f_JI = - f_IJ -> lower triangular storage

use Index_Functions, only: iTri, nTri_Elem
use rassi_aux, only: ipglob
use Cntrl, only: ICOMP, NPROP, NSTATE, PNAME
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: natom
real(kind=wp), intent(in) :: ChgNuc(natom), Prop(nState,nState,NProp), Ham(Nstate,Nstate)
real(kind=wp), intent(out) :: DerCpl(nTri_Elem(nState),3,natom)
integer(kind=iwp) :: IST, ISTA, JSTA, KPROP, lAT
real(kind=wp) :: EI, EJ, SumX, SumY, SumZ

DerCpl(:,:,:) = Zero
do iSta=1,nState-1
  Ei = Ham(iSta,iSta)
  do jSta=iSta+1,nState
    Ej = Ham(jSta,jSta)
    iST = iTri(iSta,jSta)
    write(u6,1000) iSta,jSta,Ej-Ei
    do kProp=1,nProp
      if (PName(kProp)(1:3) == 'EF1') then
        read(PName(kProp)(5:8),'(i4)') lAt
        DerCpl(iST,IComp(kProp),lAt) = Prop(iSta,jSta,kProp)*ChgNuc(lAt)/(Ej-Ei)
      end if
    end do
    do lAt=1,natom
      write(u6,1100) lAt,DerCpl(iST,:,lAt)
    end do
    if (IPGLOB >= 4) then
      SumX = sum(DerCpl(iST,1,:))
      SumY = sum(DerCpl(iST,2,:))
      SumZ = sum(DerCpl(iST,3,:))
      write(u6,1200) SumX,SumY,SumZ
    end if
  end do
end do

1000 format(/,' Approximate derivative couplings for states ',2i3,/,' Energy difference = ',F15.8,/, &
            '   Atom          X              Y              Z')
1100 format(i7,3f15.8)
1200 format('   Sum:',3f15.8)

end subroutine AppDerCpl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine EEMax(n,A,B)
      Implicit Real*8 (a-h,o-z)
      Real*8 A(n), B(n)
      Do i = 1, n
         If (B(i).gt.A(i)) A(i)=B(i)
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Init_TList(Triangular,P_Eff)
      use definitions, only: iwp, wp, u6
      Use Para_Info, Only: MyRank, nProcs, Is_Real_Par
      use TList_Mod, only: nTasks,P,PQ,TskL,TskM,TskQ,Not_Used
      use stdalloc, only: mma_allocate
      use Constants, only: Zero, One, Two
      implicit none
      Logical(kind=iwp), intent(in):: Triangular
      real(kind=wp), intent(in):: P_Eff

      real(kind=wp)  distrib,PQpTsk,TskLw,TskHi,MinPQ1,a,fint,
     &               tskmin,tskmax

* parameters concerning task distribution...
      Integer(kind=iwp), Parameter:: iDen_PQ  = 2
      Integer(kind=iwp), Parameter:: iDen_Tsk = 4
      Integer(kind=iwp), Parameter:: MinPQ    = 4
* max number of tasks in tasklist per node...
      Integer(kind=iwp), Parameter:: MxnTsk = 100
      Integer(kind=iwp) iDen_PQ1,iDen_Tsk1,iTsk,kTsk,kTskHi,MxnTsk1,
     &                  nTaskpP,nTaskpP_seg

      fint(a)=dble(int(a))

      If (Allocated(TskL)) Return
      MinPQ1= MinPQ
      MxnTsk1=MxnTsk
      iDen_PQ1=iDen_PQ
      iDen_Tsk1=iDen_Tsk
c
      P = P_Eff
      If (Triangular) Then
         PQ = P*(P+One)/Two
      Else
         PQ = P*P
      End If
      nTasks = nint(Min(PQ,dble(MxnTsk1*nProcs)))
      If (.Not. Is_Real_Par() .OR. nProcs.eq.1) Return
*
      Call mma_allocate(TskM,2,nTasks,Label='TskM')
      TskM(:,:)=0
      Call mma_allocate(TskQ,2,nTasks,Label='TskQ')
      TskQ(:,:)=Not_Used
      Call mma_allocate(TskL,nTasks*2,Label='TskL')
*
      tskmin=1.d14
      tskmax=Zero
      TskLw=One
      TskHi=Zero
      iTsk=0

*     REPEAT
      Do
        distrib = fint(PQ/dble(iDen_PQ1))
        nTaskpP=nTasks/nProcs
        nTaskpP_seg=nTaskpP/iDen_Tsk1
        PQpTsk=MinPQ1
        If (nTaskpP_seg.ge.1)
     >    PQpTsk=fint(distrib/dble(nTaskpP_seg*nProcs))
        If (PQpTsk.gt.MinPQ1) Then
          PQpTsk  = fint(distrib/dble(nTaskpP_seg*nProcs))
          distrib = fint(PQpTsk*dble(nTaskpP_seg*nProcs))
          PQ=PQ-distrib
          kTskHi=nTaskpP_seg*nProcs
        Else If (PQ.gt.MinPQ1 .and. nTasks.gt.1) Then
          PQpTsk=Max(MinPQ1,fint((PQ+dble(nTasks)-Two)/dble(nTasks-1)))
          kTskHi=nint(fint(PQ/PQpTsk))
          PQ=PQ-dble(kTskHi)*PQpTsk
        Else If (PQ.gt.Zero) Then
          PQpTsk=PQ
          kTskHi=1
          PQ=0d0
        Else
          kTskHi=0
          Write (u6,*) 'Init_TList: you should not be here!'
          Call Abend()
        End If

        Do kTsk = 1, kTskHi
          TskHi=TskHi+PQpTsk
          iTsk=iTsk+1
          TskM(1,iTsk)=TskLw
          TskM(2,iTsk)=TskHi
          tskmin=min(tskmin,(TskHi-TskLw+One))
          tskmax=max(tskmax,(TskHi-TskLw+One))
          TskLw=TskHi+One
        End Do
        nTasks=nTasks-kTskHi

*       UNTIL (PQ == 0)
*       If (abs(PQ).gt.1.d-10) Cycle
*       Exit
        If (abs(PQ)<=1.d-10) Exit

      END DO

      If (nTasks.lt.0) Then
          Write (u6,*) 'nTasks.lt.0'
          Write (u6,*) 'MyRank=',MyRank
          Call Abend()
      End If
      nTasks=iTsk
*
      End Subroutine Init_TList
*
      Subroutine Free_TList()
      use TList_Mod, only: TskQ,TskM
      Use Para_Info, Only: nProcs, Is_Real_Par
      use stdalloc, only: mma_deallocate
      implicit None
*
      If (.Not.Allocated(TskQ)) Return
*
      If (.Not. Is_Real_Par() .OR. nProcs.eq.1) Return
      Call mma_deallocate(TskQ)
      Call mma_deallocate(TskM)
*
      End Subroutine Free_TList

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Tri2Rec(OvlTri,OvlRec,nBas,Debug)
c
      Implicit Real*8 (a-h,o-z)
      Real*8 OvlTri(*),OvlRec(nBas,nBas)
      Logical Debug
c
      ioffset=1
      Do nlig=1,nBas
        nElem=nlig
        ioffset=ioffset+(nlig-1)
        call dcopy_(nElem,OvlTri(ioffset),1,OvlRec(1,nlig),1)
      End Do
c
      Do iBas=1,nBas
        Do jBas=nBas,iBas,-1
          OvlRec(jBas,iBas)=OvlRec(iBas,jBas)
        End Do
      End Do
c
      If (Debug) Call RecPrt('OvlRec ',' ',OvlRec,nBas,nBas)
c
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************

module TList_Mod

use Para_Info, only: Is_Real_Par, MyRank, nProcs
use stdalloc, only: mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
private

integer(kind=iwp) :: iStrt_TList, iTCnSt, iTskCan, mTasks, nTasks
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iEnd_TList, igaTsk
#endif
real(kind=wp) :: P, PQ, QLast(2)
logical(kind=iwp) :: GT_Status = .false., PP_Status = .false.
integer(kind=iwp), allocatable, target :: TskL(:)
real(kind=wp), allocatable :: TskM(:,:), TskQ(:,:)
real(kind=wp), parameter :: Not_Used = -One

public :: Free_GTList, Free_PPList, Free_TList, Init_GTList, Init_PPList, Init_TList, Pos_QLast, Put_QLast, QLast, ReInit_GTList, &
          ReInit_PPList, Rsv_GTList

contains

subroutine Init_TList(Triangular,P_Eff)

  use stdalloc, only: mma_allocate
  use Constants, only: Zero, Two

  logical(kind=iwp), intent(in) :: Triangular
  real(kind=wp), intent(in) :: P_Eff
  integer(kind=iwp) :: iDen_PQ1, iDen_Tsk1, iTsk, kTsk, kTskHi, MxnTsk1, nTaskpP, nTaskpP_seg
  real(kind=wp) :: distrib, PQpTsk, TskLw, TskHi, MinPQ1, tskmin, tskmax
  integer(kind=iwp), parameter :: iDen_PQ = 2, iDen_Tsk = 4, MinPQ = 4, MxnTsk = 100

  if (allocated(TskL)) return
  MinPQ1 = MinPQ
  MxnTsk1 = MxnTsk
  iDen_PQ1 = iDen_PQ
  iDen_Tsk1 = iDen_Tsk

  P = P_Eff
  if (Triangular) then
    PQ = P*(P+One)/Two
  else
    PQ = P*P
  end if
  nTasks = nint(min(PQ,real(MxnTsk1*nProcs,kind=wp)))
  if ((.not. Is_Real_Par()) .or. (nProcs == 1)) return

  call mma_allocate(TskM,2,nTasks,Label='TskM')
  TskM(:,:) = 0
  call mma_allocate(TskQ,2,nTasks,Label='TskQ')
  TskQ(:,:) = Not_Used
  call mma_allocate(TskL,nTasks*2,Label='TskL')

  tskmin = 1.0e14_wp
  tskmax = Zero
  TskLw = One
  TskHi = Zero
  iTsk = 0

  ! REPEAT
  do
    distrib = fint(PQ/real(iDen_PQ1,kind=wp))
    nTaskpP = nTasks/nProcs
    nTaskpP_seg = nTaskpP/iDen_Tsk1
    PQpTsk = MinPQ1
    if (nTaskpP_seg >= 1) PQpTsk = fint(distrib/real(nTaskpP_seg*nProcs,kind=wp))
    if (PQpTsk > MinPQ1) then
      PQpTsk = fint(distrib/real(nTaskpP_seg*nProcs,kind=wp))
      distrib = fint(PQpTsk*real(nTaskpP_seg*nProcs,kind=wp))
      PQ = PQ-distrib
      kTskHi = nTaskpP_seg*nProcs
    else if ((PQ > MinPQ1) .and. (nTasks > 1)) then
      PQpTsk = max(MinPQ1,fint((PQ+real(nTasks,kind=wp)-Two)/real(nTasks-1,kind=wp)))
      kTskHi = int(PQ/PQpTsk)
      PQ = PQ-real(kTskHi,kind=wp)*PQpTsk
    else if (PQ > Zero) then
      PQpTsk = PQ
      kTskHi = 1
      PQ = Zero
    else
      kTskHi = 0
      write(u6,*) 'Init_TList: you should not be here!'
      call Abend()
    end if

    do kTsk=1,kTskHi
      TskHi = TskHi+PQpTsk
      iTsk = iTsk+1
      TskM(1,iTsk) = TskLw
      TskM(2,iTsk) = TskHi
      tskmin = min(tskmin,(TskHi-TskLw+One))
      tskmax = max(tskmax,(TskHi-TskLw+One))
      TskLw = TskHi+One
    end do
    nTasks = nTasks-kTskHi

    ! until (PQ == 0)
    ! if (abs(PQ) > 1.0e-10_wp) cycle
    ! exit
    if (abs(PQ) <= 1.0e-10_wp) exit

  end do

  if (nTasks < 0) then
    write(u6,*) 'nTasks < 0'
    write(u6,*) 'MyRank=',MyRank
    call Abend()
  end if
  nTasks = iTsk

end subroutine Init_TList

subroutine Free_TList()

  if (.not. allocated(TskQ)) return

  if ((.not. Is_Real_Par()) .or. (nProcs == 1)) return
  call mma_deallocate(TskQ)
  call mma_deallocate(TskM)

end subroutine Free_TList

subroutine Init_GTList()

  if (GT_Status) return
  GT_Status = .true.

  iTCnSt = 1
  if ((.not. Is_Real_Par()) .or. (nProcs == 1)) return
# ifdef _MOLCAS_MPP_
  ! create global tasklist...
  call GATskL(.true.,nTasks,igaTsk)
# endif

end subroutine Init_GTList

subroutine ReInit_GTList()

  if (.not. GT_Status) then
    write(u6,*) 'ReInit_GTList: List not active!'
    call Abend()
  end if
  iTCnSt = 1
  if ((.not. Is_Real_Par()) .or. (nProcs == 1)) return
# ifdef _MOLCAS_MPP_
  ! initialize global tasklist...
  call GATskL_Zero(igaTsk)
# endif

end subroutine ReInit_GTList

subroutine Free_GTList()

  if (.not. GT_Status) return
  GT_Status = .false.

  iTCnSt = 1
  if ((.not. Is_Real_Par()) .or. (nProcs == 1)) return
# ifdef _MOLCAS_MPP_
  ! create global tasklist...
  call GATskL(.false.,nTasks,igaTsk)
# endif

end subroutine Free_GTList

function Rsv_GTList(TskLw,TskHi,iOpt,NewBatch)

  logical(kind=iwp) :: Rsv_GTList
  real(kind=wp), intent(out) :: TskLw, TskHi
  integer(kind=iwp), intent(in) :: iOpt
  logical(kind=iwp), intent(out) :: NewBatch
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: MyTask
  integer(kind=iwp), external :: RsvTsk
# endif

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  Rsv_GTList = .false.
  if ((.not. Is_Real_Par()) .or. (nProcs == 1)) then
    if (iTCnSt == 1) then
      iTCnSt = iTCnSt+1
      iTskCan = iTskCan+1
      Rsv_GTList = .true.
      TskLw = One
      TskHi = PQ
      iStrt_TList = 1
      if (iOpt == 0) then
        NewBatch = .true.
      else
        NewBatch = .false.
      end if
    end if
# ifdef _MOLCAS_MPP_
  else
    !
    !---- NewBatch is true if
    !      1) Batch never processed by the node before
    !      2) The sequence of executed batches is broken

    if (iOpt == 0) then
      MyTask = RsvTsk(igaTsk,TskL,nTasks,nTasks,iTCnST,iStrt_TList,iEnd_TList)
      NewBatch = .true.
    else if (iOpt == 1) then
      MyTask = RsvTsk(igaTsk,TskL,nTasks,mTasks,iTCnST,iStrt_TList,iEnd_TList)
      NewBatch = iStrt_TList > mTasks
    else if (iOpt == 2) then
      MyTask = RsvTsk(igaTsk,TskL,nTasks,nTasks,iTCnST,iStrt_TList,iEnd_TList)
      NewBatch = (iStrt_TList > mTasks) .or. (iStrt_TList /= iTCnST)
    else
      MyTask = 0
      write(u6,*) 'Rsv_GTList: Invalid option:',iOpt
      call Abend()
    end if
    if (MyTask >= 1) then
      Rsv_GTList = .true.
      TskLw = TskM(1,MyTask)
      TskHi = TskM(2,MyTask)
      iTCnSt = iTCnSt+1
      iTskCan = iTskCan+1
    end if
# endif
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *

end function Rsv_GTList

subroutine Init_PPList()

  integer(kind=iwp) :: i, iE, iTsk
  integer(kind=iwp), pointer :: TskList(:,:)
  logical(kind=iwp), parameter :: Debug = .false.

  if (Debug) then
    if (PP_Status) then
      write(u6,*) 'Init_PPList: Active'
    else
      write(u6,*) 'Init_PPList: InActive'
    end if
  end if

  if (PP_Status) return
  PP_Status = .true.

  iTskCan = 0
  mTasks = 0
  iStrt_TList = 0
# ifdef _MOLCAS_MPP_
  iEnd_TList = nTasks+1
# endif
  if ((.not. Is_Real_Par()) .or. (nProcs == 1)) return

  TskList(1:nTasks,1:2) => TskL(1:2*nTasks)
  TskList(:,1) = 0
  do iTsk=0,nTasks-1
    TskList(1+iTsk,1) = mod(iTsk+MyRank,nTasks)+1
  end do

  ! Copy list in inverse order to ensure the proper order if
  ! reinitiated at once.

  iE = nTasks-1
  TskList(:,2) = 0
  do i=0,nTasks-1
    TskList(1+iE,2) = TskList(i+1,1)
    iE = iE-1
  end do
  nullify(TskList)

  QLast(1) = Not_Used
  QLast(2) = Not_Used

end subroutine Init_PPList

subroutine ReInit_PPList(Semi_Direct)

  logical(kind=iwp), intent(in) :: Semi_Direct
  integer(kind=iwp) :: i, iCount, iE
  integer(kind=iwp), pointer :: TskList(:,:)
  logical(kind=iwp), parameter :: Debug = .false.

  if (Debug) then
    if (PP_Status) then
      write(u6,*) 'ReInit_PPList: Active'
    else
      write(u6,*) 'ReInit_PPList: InActive'
    end if
  end if
  if (.not. PP_Status) then
    write(u6,*) 'ReInit_PPList: List is not active!'
    call Abend()
  end if
  iTskCan = 0
  mTasks = iStrt_TList
  if (nProcs == 1) then
    iStrt_TList = 0
#   ifdef _MOLCAS_MPP_
    iEnd_TList = nTasks+1
#   endif
  else
    if (Semi_Direct) then
      TskList(1:nTasks,1:2) => TskL(1:2*nTasks)

      ! Copy first the task indices of tasks that were exectuted
      TskList(1:mTasks,1) = TskList(1:mTasks,2)

      ! Now copy task indices of tasks which were not executed by this node.
      ! Change the order so that the first task it the largest in the list.

      iE = mTasks
      iCount = 1
      do i=mTasks,nTasks-1
        if (iCount > myRank) then
          TskList(1+i,1) = TskList(i+1,2)
        else
          TskList(1+i,1) = TskList(iE+1,2)
          iE = iE-1
          iCount = iCount+1
        end if
      end do

      nullify(TskList)
    end if

    iStrt_TList = 0
#   ifdef _MOLCAS_MPP_
    iEnd_TList = nTasks+1
#   endif

    QLast(1) = Not_Used
    QLast(2) = Not_Used
  end if

end subroutine ReInit_PPList

subroutine Free_PPList()

  if (.not. allocated(TskL)) return
  PP_Status = .false.

  if ((.not. Is_Real_Par()) .or. (nProcs == 1)) return
  call mma_deallocate(TskL)

end subroutine Free_PPList

subroutine Put_QLast()

  if (.not. allocated(TskQ)) return
  TskQ(1,iTskCan) = QLast(1)
  TskQ(2,iTskCan) = QLast(2)

  QLast(1) = Not_Used
  QLast(2) = Not_Used

end subroutine Put_QLast

subroutine Pos_QLast(Disc)

  use Definitions, only: RtoI

  real(kind=wp), intent(inout) :: Disc
  integer(kind=iwp) :: iWR(2), mInts
  real(kind=wp) :: Dummy(1), Quad_ijkl, RST_triplet
  logical(kind=iwp), parameter :: Copy = .true., NoCopy = .false.

  if (.not. allocated(TskQ)) return

  Quad_ijkl = TskQ(1,iTskCan)
  RST_triplet = TskQ(2,iTskCan)
  if (Quad_ijkl == Not_Used) return

  ! If already at the right position return

  if ((Quad_ijkl == QLast(1)) .and. (RST_triplet == QLast(2))) return

  do

    call iRBuf(iWR,2,Copy)
    call dRBuf(QLast,2,Copy)
    mInts = iWR(2)
    if ((QLast(1) == Quad_ijkl) .and. (QLast(2) == RST_triplet)) then
      if (mInts > 0) call dRBuf(Dummy,mInts,NoCopy)
      Disc = Disc+real(2/RtoI+2+mInts,kind=wp)
      return
    else if (QLast(1) <= Quad_ijkl) then
      if (mInts > 0) call dRBuf(Dummy,mInts,NoCopy)
      Disc = Disc+real(2/RtoI+2+mInts,kind=wp)
      cycle
    else
      write(u6,*) 'Pos_QLast: batch is lost!'
      write(u6,'(A,2F10.1)') 'Index,1.0:  ',QLast(1),QLast(2)
      write(u6,'(A,2F10.1)') 'Looking for ',Quad_ijkl,RST_triplet
      write(u6,*) ' iTskCan,=',iTskCan
      call RecPrt('TskQ',' ',TskQ,2,iTskCan)
      write(u6,*)
      call Abend()
    end if

  end do

  write(u6,*) 'Pos_QLast: Fatal problem!'
  call Abend()

end subroutine Pos_QLast

elemental function fint(a)

  real(kind=wp) :: fint
  real(kind=wp), intent(in) :: a

  fint = real(int(a),kind=wp)

end function fint

end module TList_Mod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine daopen(fname,lun,reclen)
! this routine opens direct access file
!
! fname - name of the file A8 (I)
! lun   - logical unit number (I)
! reclen- record length in R8 (I)

use Definitions, only: iwp

implicit none
character(len=8), intent(in) :: fname
integer(kind=iwp), intent(in) :: lun, reclen
integer(kind=iwp) :: f_iostat, recln
logical(kind=iwp) :: is_error

#ifdef _DECAXP_
recln = reclen*2
#else
recln = reclen*8
#endif

call molcas_open_ext2(lun,fname,'direct','unformatted',f_iostat,.true.,recln,'unknown',is_error)
!open(unit=lun,file=fname,form='unformatted',access='direct',recl=recln)

return

end subroutine daopen

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SpinDens(LS,RS,iL,iR,rP1,rp2,rp3,rp4,rp5,rDe1,rde2,itype)
! Input:
!
! LS : CI Coeff for left state
! RS : CI Coeff for right state
! iL : Symmetry of left state
! iR : Symmetry of right state
!
! Output:
!
!  rP1 : Two Electron -- Density
!  rP2 : Two Electron ++ Density
!  rP3 : Two Electron spin Density
!  rD1 : One Electron Spin adapted Density
!  rD1 : One Electron spin density Density
!
! itype=1
! Densities for:
!          0
! <L|[{Q:S} ,H]|R>
!          0
! itype 2
! Densities for
!           0       0
! <L||[{Q:S} ,[{Q:S} ,H]]|R>
!           0       0

use Index_Functions, only: iTri
use MCLR_Data, only: n1Dens, n2Dens, nNA, XISPSM
use CandS, only: ICSM, ISSM
use input_mclr, only: nCSF
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: LS(*), RS(*)
integer(kind=iwp), intent(in) :: iL, iR, iType
real(kind=wp), intent(out) :: rP1(nna,nna,nna,nna), rP2(nna,nna,nna,nna), rP3(nna,nna,nna,nna), rP4(nna,nna,nna,nna), &
                              rP5(nna,nna,nna,nna), rDe1(nna,nna), rde2(nna,nna)
integer(kind=iwp) :: iA, ijkl, ijklAB, ijklBA, jA, jilk, jilkAB, jilkBA, kA, lA, n2, nConfL, nConfR
real(kind=wp), allocatable :: CIL(:), CIR(:), Dens(:,:), Pens(:)

n2 = 2*n2Dens+nnA**4
call mma_allocate(Dens,n1Dens,2,Label='Dens')
call mma_allocate(Pens,n2,Label='Pens')
Dens(:,:) = Zero
Pens(:) = Zero
nConfL = max(ncsf(il),nint(xispsm(il,1)))
nConfR = max(ncsf(iR),nint(xispsm(iR,1)))

call mma_allocate(CIL,nConfL,Label='CIL')
call mma_allocate(CIR,nConfR,Label='CIR')
call CSF2SD(LS,CIL,iL)
call CSF2SD(RS,CIR,iR)
icsm = iR
issm = iL
call Densi2_mclr(2,Dens,Pens,CIL,CIR,0,0,1,n1Dens,n2Dens)

if (itype == 1) then

  !      0
  ! <0|[Q  ,H]|0>
  !      0pq

  do iA=1,nna
    do jA=1,nnA
      rde1(ia,ja) = Dens(nna*(ia-1)+ja,1)-Dens(nna*(ia-1)+ja,2)+Dens(nna*(ja-1)+ia,1)-Dens(nna*(ja-1)+ia,2)
    end do
  end do
  do iA=1,NnA
    do jA=1,nnA
      do kA=1,nnA
        do lA=1,nnA
          ijklab = (ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
          jilkab = (ja-1)*nna**3+(ia-1)*nna**2+(la-1)*nna+ka
          ijklba = (ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
          jilkba = (la-1)*nna**3+(ka-1)*nna**2+(ja-1)*nna+ia
          ijkl = iTri((ia-1)*nna+ja,(ka-1)*nna+la)
          jilk = iTri((ja-1)*nna+ia,(la-1)*nna+ka)
          rP1(ia,ja,ka,la) = Pens(ijkl)-Pens(ijkl+n2Dens)+Pens(n2Dens*2+ijklab)-Pens(ijklba+2*n2Dens)+Pens(jilk)- &
                             Pens(jilk+n2Dens)-Pens(n2Dens*2+jilkab)+Pens(jilkba+2*n2Dens)
        end do
      end do
    end do
  end do

else if (itype == 2) then
  ! OK CONSTRUCT

  ! --
  ! ++
  ! -+
  ! spindensity
  ! spin adapted density

  rde1(:,:) = reshape(Dens(:,2)-Dens(:,1),[nna,nna])
  rde2(:,:) = reshape(Dens(:,1)+Dens(:,2),[nna,nna])

  do iA=1,nnA
    do jA=1,nnA
      do kA=1,nnA
        do lA=1,nnA
          ijklab = (ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
          ijklba = (ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
          ijkl = iTri((ia-1)*nna+ja,(ka-1)*nna+la)
          rP1(ia,ja,ka,la) = Pens(ijkl)+Pens(n2Dens+ijkl)-Pens(ijklab+2*n2Dens)-Pens(ijklba+2*n2Dens)
        end do
      end do
    end do
  end do
  do iA=1,nnA
    do jA=1,nnA
      do kA=1,nnA
        do lA=1,nnA
          ijklab = (ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
          ijklba = (ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
          ijkl = iTri((ia-1)*nna+ja,(ka-1)*nna+la)
          rP2(ia,ja,ka,la) = Pens(ijkl)-Pens(n2Dens+ijkl)-Pens(ijklab+2*n2Dens)+Pens(ijklba+2*n2Dens)
        end do
      end do
    end do
  end do

  do iA=1,NnA
    do jA=1,nnA
      do kA=1,nnA
        do lA=1,nnA
          ijklab = (ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
          ijklba = (ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
          ijkl = iTri((ia-1)*nna+ja,(ka-1)*nna+la)
          rP3(ia,ja,ka,la) = Pens(ijkl)+Pens(ijkl+n2Dens)+Pens(n2Dens*2+ijklab)+Pens(ijklba+2*n2Dens)
        end do
      end do
    end do
  end do
  do iA=1,NnA
    do jA=1,nnA
      do kA=1,nnA
        do lA=1,nnA
          ijklab = (ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
          ijklba = (ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
          ijkl = iTri((ia-1)*nna+ja,(ka-1)*nna+la)
          rP4(ia,ja,ka,la) = -Pens(n2Dens*2+ijklab)+Pens(ijklba+2*n2Dens)
        end do
      end do
    end do
  end do
  do iA=1,NnA
    do jA=1,nnA
      do kA=1,nnA
        do lA=1,nnA
          ijklab = (ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
          ijklba = (ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
          ijkl = iTri((ia-1)*nna+ja,(ka-1)*nna+la)
          rP5(ia,ja,ka,la) = Pens(n2Dens*2+ijklab)+Pens(ijklba+2*n2Dens)
        end do
      end do
    end do
  end do
end if
call mma_deallocate(Dens)
call mma_deallocate(Pens)
call mma_deallocate(CIL)
call mma_deallocate(CIR)

end subroutine SpinDens

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine gr_svb1_cvb(civecp,civbs,civb,dvbdet,
     >   grad,grad1,grad2,gradx,vec1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "fx_cvb.fh"
      dimension civecp(ndet),civbs(ndet),civb(ndet)
      dimension dvbdet(ndetvb)
      dimension grad(npr),grad1(npr),grad2(npr),gradx(norb,norb)

c  VEC1 dimension is MAX(NPRORB,NDETVB)
      dimension vec1(*)

      aa1=one/sqrt(ovraa)
      aa2=-aa1/(two*ovraa)
      oaa2=two*ovrab*aa2
      oaa3=3d0*ovrab*aa1/(4d0*ovraa*ovraa)

      call fzero(gradx,norb*norb)
      call onedens_cvb(civb,civbs,gradx,.true.,1)

      call mkgrd_cvb(civb,civbs,grad1,dvbdet,npr,.true.)
      call mkgrd_cvb(civb,civecp,grad2,dvbdet,npr,.true.)

      do 100 i=1,npr
      vec1(i)=aa1*grad2(i)+oaa2*grad1(i)
      grad1(i)=two*grad1(i)
100   continue
      call prgrad_cvb(vec1,npr)

      call make_cvb('ORBFREE')
      call make_cvb('CIFREE')
      call all2free_cvb(vec1,grad,1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per Ake Malmqvist                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine uppercases a text string.                               *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-AAke Malmqvist                                          *
!          Lund University                                             *
!                                                                      *
!***********************************************************************

subroutine UpCase(string)

use Definitions, only: iwp

implicit none
character(len=*), intent(inout) :: string
integer(kind=iwp), save :: ifset = 0, itab(0:255)
integer(kind=iwp) :: i, ii
character(len=*), parameter :: up = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', &
                               lw = 'abcdefghijklmnopqrstuvwxyz'

if (ifset == 0) then
  ifset = 1
  do i=0,255
    itab(i) = i
  end do
  do ii=1,26
    i = ichar(lw(ii:ii))
    itab(i) = ichar(up(ii:ii))
  end do
end if

do ii=1,len(string)
  i = ichar(string(ii:ii))
  string(ii:ii) = char(itab(i))
end do

return

end subroutine UpCase

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE IIJJ(ICSPCK,INTSYM,HDIAG,FC,FIIJJ,FIJIJ)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION ICSPCK(*),INTSYM(*),HDIAG(*),
     *          FC(*),FIIJJ(*),FIJIJ(*)
      DIMENSION IOC(55)
*
      JO(L)=ICUNP(ICSPCK,L)
      JSYM(L)=JSUNP(INTSYM,L)
*
      IAD27=0
      II1=0
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      IRL=IRC(ILIM)
      DO 100 IR=1,IRL
      DO 110 I=1,LN
      II1=II1+1
      JOJ=JO(II1)
      IF(JOJ.GT.1)JOJ=JOJ-1
      IOC(I)=JOJ
110   CONTINUE
      NSS=MUL(JSYM(IR),LSYM)
      SUM=0.0D00
      DO 111 I=1,LN
        IJ=IROW(I)
        IF(IOC(I).EQ.0)GO TO 111
        DO 113 J=1,I-1
          IJ=IJ+1
          IF(IOC(J).EQ.0)GO TO 113
          SUM=SUM+IOC(I)*(IOC(J)*FIIJJ(IJ)-FIJIJ(IJ))
113     CONTINUE
        IJ=IJ+1
        SUM=SUM+(IOC(I)-1)*FIIJJ(IJ)+IOC(I)*FC(IJ)
111   CONTINUE
      IF(IR.GT.IRC(1))GO TO 120
      HDIAG(IR)=SUM
      IF(IR.NE.IRC(1))GO TO 100
      CALL dDAFILE(Lu_27,1,HDIAG,IRC(1),IAD27)
      GO TO 100
120   IND=0
      IF(IR.GT.IRC(2)) GOTO 130
      NA1=NVIRP(NSS)+1
      NA2=NVIRP(NSS)+NVIR(NSS)
      IF(NA2.LT.NA1)GO TO 100
      DO 121 NA=NA1,NA2
      IND=IND+1
      IA=IROW(LN+NA)
      SUM1=SUM+FC(IA+LN+NA)
      DO 122 I=1,LN
      IF(IOC(I).EQ.0)GO TO 122
      SUM1=SUM1+IOC(I)*FIIJJ(IA+I)-FIJIJ(IA+I)
122   CONTINUE
      HDIAG(IND)=SUM1
121   CONTINUE
      CALL dDAFILE(Lu_27,1,HDIAG,IND,IAD27)
      GO TO 100
130   IND=0
      DO 141 NA=1,NVIRT
      NSA=MUL(NSS,NSM(LN+NA))
      NB1=NVIRP(NSA)+1
      NB2=NVIRP(NSA)+NVIR(NSA)
      IF(NB2.GT.NA)NB2=NA
      IF(NB2.LT.NB1)GO TO 141
      IA=IROW(LN+NA)
      IAV=IA+LN
      DO 142 NB=NB1,NB2
      IND=IND+1
      IB=IROW(LN+NB)
      IBV=IB+LN
      TERM=SUM+FIIJJ(IAV+NB)+FC(IAV+NA)+FC(IBV+NB)
      IF(IR.LE.IRC(3)) THEN
        SUM1=TERM-FIJIJ(IAV+NB)
      ELSE
        SUM1=TERM+FIJIJ(IAV+NB)
      END IF
      DO 143 I=1,LN
      IF(IOC(I).EQ.0)GO TO 143
      TERM=IOC(I)*(FIIJJ(IA+I)+FIIJJ(IB+I))-FIJIJ(IA+I)-FIJIJ(IB+I)
      SUM1=SUM1+TERM
143   CONTINUE
      HDIAG(IND)=SUM1
142   CONTINUE
141   CONTINUE
      IF(IND.GT.0)CALL dDAFILE(Lu_27,1,HDIAG,IND,IAD27)
100   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Bernd Artur Hess                                 *
!***********************************************************************

subroutine Ass_pXp(Beta,nZeta,rFinal,la,lb,Slalbp,Slalbm,nComp)
!***********************************************************************
!                                                                      *
! Object: to assemble the pVp integrals                                *
!                                                                      *
!     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
!             Chemie, University of Bonn, Germany, August 1994         *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nComp
real(kind=wp), intent(in) :: Beta(nZeta), Slalbp(nZeta,nTri_Elem1(la),nTri_Elem1(lb+1),3,nComp), &
                             Slalbm(nZeta,nTri_Elem1(la),nTri_Elem1(lb-1),3,nComp)
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),nComp)
#include "print.fh"
integer(kind=iwp) :: iComp, ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyb, iza, izb
character(len=80) :: Label

iRout = 211
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  write(u6,*)
  write(u6,*) ' In Ass_pXp la,lb,nComp,=',la,lb,nComp
  write(u6,*)
  call RecPrt('Beta','(10G15.8)',Beta,nZeta,1)
  do iComp=1,nComp
    write(u6,*) 'iComp=',iComp
    write(Label,'(A,I2,A)') ' Ass_pXp: Slalbp(1,iComp=',iComp,')'
    call RecPrt(Label,'(10G15.8)',Slalbp(:,:,:,1,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb+1))
    write(Label,'(A,I2,A)') ' Ass_pXp: Slalbp(2,iComp=',iComp,')'
    call RecPrt(Label,'(10G15.8)',Slalbp(:,:,:,2,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb+1))
    write(Label,'(A,I2,A)') ' Ass_pXp: Slalbp(3,iComp=',iComp,')'
    call RecPrt(Label,'(10G15.8)',Slalbp(:,:,:,3,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb+1))
    if (lb > 0) then
      write(Label,'(A,I2,A)') 'Ass_pXp: Slalbm(1,iComp=',iComp,')'
      call RecPrt(Label,'(10G15.8)',Slalbm(:,:,:,1,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb-1))
      write(Label,'(A,I2,A)') 'Ass_pXp: Slalbm(2,iComp=',iComp,')'
      call RecPrt(Label,'(10G15.8)',Slalbm(:,:,:,2,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb-1))
      write(Label,'(A,I2,A)') 'Ass_pXp: Slalbm(3,iComp=',iComp,')'
      call RecPrt(Label,'(10G15.8)',Slalbm(:,:,:,3,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb-1))
    end if
  end do
end if

do iComp=1,nComp

  do ixa=la,0,-1
    do iya=la-ixa,0,-1
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)

      do ixb=lb,0,-1
        do iyb=lb-ixb,0,-1
          izb = lb-ixb-iyb
          ipb = C_Ind(lb,ixb,izb)

          rFinal(:,ipa,ipb,iComp) = Two*Beta*(Slalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),1,iComp)+ &
                                              Slalbp(:,ipa,C_Ind(lb+1,ixb,izb),2,iComp)+ &
                                              Slalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),3,iComp))

          if (ixb > 0) &
            rFinal(:,ipa,ipb,iComp) = rFinal(:,ipa,ipb,iComp)-real(ixb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb-1,izb),1,iComp)

          if (iyb > 0) &
            rFinal(:,ipa,ipb,iComp) = rFinal(:,ipa,ipb,iComp)-real(iyb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb),2,iComp)

          if (izb > 0) &
            rFinal(:,ipa,ipb,iComp) = rFinal(:,ipa,ipb,iComp)-real(izb,kind=wp)*Slalbm(:,ipa,C_Ind(lb-1,ixb,izb-1),3,iComp)

        end do
      end do

    end do
  end do

end do ! iComp

if (iPrint >= 49) then
  do iComp=1,nComp
    write(Label,'(A,I2,A,I2,A,I2,A)') ' Ass_pXp: pXp(iComp=',iComp,')'
    call RecPrt(Label,'(10G15.8)',rFinal(:,:,:,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb))
  end do
end if

return

end subroutine Ass_pXp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkmappqij()
! this routine prepares mapd,mapi
! for <pq|ij> for p,q, i>=j to mapd1,mapi1

use ccsort_global, only: mapd1, mapi1, noa, NORB, NSYM, pos10
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: length, nhelp, pos, symi, symj, symp, sympq, sympqi, symq

! set mapi1 to zero

mapi1(1:nsym,1:nsym,1:nsym) = 0

! def zero-th row

mapd1(0,1) = 5
mapd1(0,2) = 5
mapd1(0,3) = 1
mapd1(0,4) = 1
mapd1(0,6) = 3

nhelp = 0
pos = pos10
do symp=1,nsym
  do symq=1,nsym
    sympq = mul(symp,symq)
    do symi=1,nsym
      sympqi = mul(sympq,symi)
      symj = sympqi
      if (symj > symi) cycle
      nhelp = nhelp+1

      ! calc. length
      length = noa(symi)*noa(symj)*NORB(symp)*NORB(symq)

      mapd1(nhelp,1) = pos
      mapd1(nhelp,2) = length
      mapd1(nhelp,3) = symp
      mapd1(nhelp,4) = symq
      mapd1(nhelp,5) = symi
      mapd1(nhelp,6) = symj
      pos = pos+length

      mapi1(symp,symq,symi) = nhelp

    end do
  end do
end do

mapd1(0,5) = nhelp

return

end subroutine mkmappqij

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Giovanni Ghigo                                   *
!***********************************************************************
!***********************************************************************
! This routine finds in a -string- up to -MaxNWords- and put the words *
! in the array -Words(MaxNwords)- and the number in -Nwords-           *
!----------------------------------------------------------------------*
! Author:   Giovanni Ghigo - October 2006 - Torino (IT)                *
!***********************************************************************

subroutine Pick_Words(string,MaxNwords,Nwords,Words)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: string
integer(kind=iwp), intent(in) :: MaxNwords
integer(kind=iwp), intent(out) :: Nwords
character(len=*), intent(out) :: Words(MaxNwords)
integer(kind=iwp) :: i, ilett
character(len=64) :: Word

if (string == ' ') then
  Nwords = 0
  return
end if
Words(:) = ' '
NWords = 0
i = 0
do
  i = i+1
  Word = ''
  if (i > len(string)) exit
  if (string(i:i) == ' ') cycle
  NWords = NWords+1
  ilett = 1
  Word(ilett:ilett) = string(i:i) ! First letter of word
  if (i /= len(string)) then
    do
      i = i+1
      if ((string(i:i) == ' ') .or. (i > len(string))) exit
      ilett = ilett+1
      Word(ilett:ilett) = string(i:i)
    end do
  end if
  Words(NWords) = Word
  if ((i == len(string)) .or. (NWords == MaxNwords)) exit
end do

return

end subroutine Pick_Words

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Roland Lindh                                     *
!***********************************************************************

subroutine IniSew(DSCF,nDiff)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Chemical Physics,                 *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Basis_Info, only: Seward_Activated
use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: DSCF
integer(kind=iwp), intent(inout) :: nDiff

if (Seward_Activated) then
  call ClsSew()
  call xRlsMem_Ints()
end if

call Seward_Init()

call GetInf(DSCF,nDiff)

return

end subroutine IniSew

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine rad1(aa,aarr1,alpt,arp2,ccr,dfac,fctr2,kcrl,kcru,
     &  lamu,ltot1,ncr,qsum,rk,tol,zcr)
c
c  compute type 1 radial integrals
c
      implicit real*8 (a-h,o-z)
      parameter (a0=0.0d0, a2=2.0d0)
      dimension ccr(*), dfac(*), ncr(*), qsum(ltot1,*), zcr(*)
c
      do 40 kcr=kcrl,kcru
        npi=ncr(kcr)
        alpha=aa+zcr(kcr)
c       # exponential factor from q functions included in dum
        dum=aarr1+zcr(kcr)*arp2/alpha
        if(dum.gt.tol) go to 40
        prd=fctr2*ccr(kcr)*exp(-dum)
        if(rk.eq.a0) then
          t=a0
          do 20 n=1,ltot1-mod(ltot1-1,2),2
            qsum(n,1)=qsum(n,1)+prd*
     &                qcomp(alpha,dfac,npi+n-1,0,t,rk)
   20     continue
        else
          t=alpt/alpha
          do 30 lam=1,lamu
            qsum(lam,lam)=qsum(lam,lam)+prd*
     &                    qcomp(alpha,dfac,npi+lam-1,lam-1,t,rk)
   30     continue
        endif
   40 continue
c
      if(rk.ne.a0) then
        f2lam3=(lamu+lamu-3)
        do 60 lam=lamu-2,1,-1
          do 50 n=lam+2,lamu-mod(lamu-lam,2),2
            qsum(n,lam)=qsum(n,lam+2)+
     &                  (f2lam3/rk)*qsum(n-1,lam+1)
   50     continue
          f2lam3=f2lam3-a2
   60   continue
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Integral_RICD(iCmp,iShell,MapOrg,
     &                         iBas,jBas,kBas,lBas,kOp,
     &                         Shijij,IJeqKL,iAO,iAOst,ijkl,
     &                         AOInt,SOInt,nSOint,
     &                         iSOSym,nSkal,nSOs,
     &                         TInt,nTInt,iTOffs,nSym)
      Implicit Real*8 (A-H,O-Z)
*
      Real*8 AOInt(*), SOInt(*), TInt(nTInt)
      Integer iCmp(4), iShell(4), iAO(4),
     &        iAOst(4), kOp(4), iSOSym(2,nSOs),
     &        iTOffs(0:7,0:7,0:7), MapOrg(4)
      Logical Shijij,IJeqKL
*
      If (nSym==1) Then
        Call PLF_RICD(AOInt,ijkl,iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &                iShell,iAO,iAOst,Shijij.and.IJeqKL,
     &                iBas,jBas,kBas,lBas,kOp,TInt,
     &                iTOffs(1,0,0),iTOffs(2,0,0),iTOffs(0,0,0),
     &                iTOffs(3,0,0),iTOffs(4,0,0))
      Else
         Write (6,*) 'Integral_RICD: fatal error!'
         Call Abend()
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(MapOrg)
         Call Unused_real_array(SOInt)
         Call Unused_integer(nSOint)
         Call Unused_integer_array(iSOSym)
         Call Unused_integer(nSkal)
         Call Unused_integer(nSym)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine SOiniH(EOrb,nEOrb,HDiag,nH,nD)
************************************************************************
*                                                                      *
*     purpose: generate initial inverse Hessian (diagonal) from        *
*              orbital energies (for second order update)              *
*                                                                      *
*     output:                                                          *
*       HDiag   : inverse of initial, diagonal Hessian                 *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*     calls to: DOne                                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      use Orb_Type
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
*
*     declaration subroutine parameters
      Integer nEOrb,nH, nD
      Real*8 EOrb(nEOrb,nD),HDiag(nH,nD)
*
*     declaration local variables
      Integer iSym,ii,ia,ioffs,iHoffs,nOccmF,nOrbmF
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*     Set the array to silly large values. In the case of UHF these
*     will remain but should not make any difference. They are actully
*     needed to make the rs-rfo code work.
*
      call DCopy_(nH*nD,[1.0D+99],0,HDiag,1)
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*) 'nD=',nD
      Do iD = 1, nD
         Write (6,*) 'iD=',iD
         Write (6,'(A,8I3)') 'nOcc',(nOcc(iSym,iD),iSym=1,nSym)
      End Do
      Write (6,'(A,8I3)') 'nFro',(nFro(iSym),iSym=1,nSym)
      Write (6,'(A,8I3)') 'nOrb',(nOrb(iSym),iSym=1,nSym)
#endif
      Do iD = 1, nD
*
         ioffs=1
         iHoffs=1
         Do iSym=1,nSym
*
*            loop over all occ orbitals in sym block
*
             ioffs=ioffs+nFro(iSym)
             nOccmF=nOcc(iSym,iD)-nFro(iSym)
             nOrbmF=nOrb(iSym)-nFro(iSym)
*
#ifdef _DEBUGPRINT_
             iHoffs_ = iHoffs
#endif
             Do ii=ioffs,ioffs+nOccmF-1
*
*               loop over all virt orbitals in sym block
*
                Do ia=ioffs+nOccmF,ioffs+nOrbmF-1
*
                   If (OrbType(ia,iD).eq.OrbType(ii,iD))
     &             HDiag(iHoffs,iD)=Four*(EOrb(ia,iD)-EOrb(ii,iD))
     &                             /DBLE(nD)
*
                   iHoffs=iHoffs+1
*
                End Do  ! ia
*
             End Do     ! ii
*
#ifdef _DEBUGPRINT_
             Write (6,*) 'nOccmF,nOrbmF=',nOccmF,nOrbmF
             If ((nOrbmF-nOccmF)*nOccmF.gt.0)
     &          Call RecPrt('HDiag',' ',HDiag(iHoffs_,iD),
     &                      nOrbmF-nOccmF,nOccmF)
#endif
*
             ioffs=ioffs+nOrbmF
*
          End Do ! iSym
      End Do ! iD
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SG_Setup_MCLR(pState_Sym)

use molcas, only: MxLev
use sguga, only: SGS, CIS, EXS, MkCOT, MkCList, MkSGNum, SG_Init_Simple
use input_mclr, only: iSpin, nActEl, nElec3, nHole1, nRS1, nRS2, nRS3, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in):: pState_Sym
integer(kind=iwp) :: iBas, nLev, iSym, ISM(1:MxLev), Level(MxLev), iq

nLev = 0
do iSym=1,nSym
  do iBas=1,nRs1(iSym)
    nLev = nLev+1
    ISM(nLev) = iSym
  end do
end do
do iSym=1,nSym
  do iBas=1,nRs2(iSym)
    nLev = nLev+1
    ISM(nLev) = iSym
  end do
end do
do iSym=1,nSym
  do iBas=1,nRs3(iSym)
    nLev = nLev+1
    ISM(nLev) = iSym
  end do
end do

Level(1:MxLev)=[(iq,iq=1,MxLev)]

Call SG_Init_Simple(nSym,nActEl,iSpin,SGS,CIS,EXS,nHole1,nElec3,nRs1,nRs2,nRs3, &
                    xLevel=Level, xL2Act=Level,                                 &
                    xNLEV=nLev, xNSM=ISM)

! PURPOSE: FREE THE GUGA TABLES
! FORM VARIOUS OFFSET TABLES:
! NOTE: NIPWLK AND DOWNWLK ARE THE NUMER OF INTEGER WORDS USED
!       TO STORE THE UPPER AND LOWER WALKS IN PACKED FORM.

call MKCOT(SGS,CIS)

! CONSTRUCT THE CASE LIST

call MKCLIST(SGS,CIS)

! SET UP ENUMERATION TABLES

call MKSGNUM(pState_Sym,SGS,CIS,EXS)

end subroutine SG_Setup_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine DrvEMBg(Grad,Temp,nGrad)
!***********************************************************************
!                                                                      *
! Object: driver for computation of gradient with respect to the OFE   *
!         energy (DFT-type contribution only)                          *
!                                                                      *
!                                                                      *
!         int{ [Vxc^nad(r) + Ts^nad(r) + Vnuc^B(r)] (drhoA/dRk) dr }   *
!                                                                      *
!                                                                      *
! Note:  rho=rho_A+rho_B  where the dmat elements of rho_B on the bsfs *
!                         of A have been annihilated. This also gives  *
!                         drhoA/dRk=drho/dRk (for Rk in A)             *
!                                                                      *
! Called from: Alaska                                                  *
!                                                                      *
!                                                                      *
!     Author: F. Aquilante, Dept. of Phys. Chem.                       *
!             University of Geneva, Switzerland                        *
!***********************************************************************

use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Para_Info, only: King
use OFembed, only: OFE_KSDFT
use Constants, only: One
use Definitions, only: wp, iwp, u6
use nq_Info, only: Grid_Type, Moving_Grid

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Temp(nGrad)
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"
integer(kind=iwp) :: iEnd, iIrrep, iPrint, iRout, jPrint, LuWr, nDens
real(kind=wp) :: TCpu1, TCpu2, TWall1, TWall2
logical(kind=iwp) :: Do_Grad
character(len=80) :: Label

!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TCpu1,TWall1)
!                                                                      *
!***********************************************************************
!                                                                      *
!...  Prologue
iRout = 131
iPrint = nPrint(iRout)
LuWr = u6

call StatusLine(' Alaska:',' Computing OFembedding gradients')

call Set_Basis_Mode('Valence')
call Setup_iSD()
nDens = 0
do iIrrep=0,nIrrep-1
  nDens = nDens+nBas(iIrrep)*(nBas(iIrrep)+1)/2
end do

!     DFT-OFE    gradient                                              *
!***********************************************************************
!                                                                      *
Do_Grad = .true.
call DrvEMB_(nDens,OFE_KSDFT,Do_Grad,Temp,nGrad,'SCF ')

iEnd = 1
do
  if (OFE_KSDFT(iEnd:iEnd) == ' ') then
    iEnd = iEnd-1
    exit
  else
    iEnd = iEnd+1
  end if
end do
Label = 'DFT-OFE('//OFE_KSDFT(1:iEnd)//') contribution'
jPrint = nPrint(112)
if (jPrint >= 15) call PrGrad(Label,Temp,nGrad,ChDisp)
if (king()) call DaXpY_(nGrad,One,Temp,1,Grad,1)
if (iPrint >= 6) then
  write(LuWr,*)
  if (Grid_Type == Moving_Grid) then
    write(LuWr,*) 'DFT-OFE contribution computed for a moving grid.'
  else
    write(LuWr,*) 'DFT-OFE contribution computed for a fixed grid.'
  end if
  write(LuWr,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call Free_iSD()
call CWTime(TCpu2,TWall2)
call SavTim(5,TCpu2-TCpu1,TWall2-TWall1)

return

end subroutine DrvEMBg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine atens(moment,d,gtens,maxes,iprint)
!-----------------------------------------------------------------------
! d      -- size of the magnetic moment
!           d = muliplicity of the pseudospin ( 2*S+1, where S is the pseudospin);
! moment -- matrix of size (3,d,d) of the moment (magnetic, spin or angular)
! gtens  -- array of size (3) keeping the main values of the A tensor ( sqrt(main_values) )
! maxes  -- array of size (3,3) keeping the main axes of the A tensor Writen in
!           the right coordinate system (Determinant = +1)
! iprint -- the print level of the Subroutine
!           iprint = 1 => no output
!           iprint = 2 => standard
!           iprint = 3 => print for debug
!-----------------------------------------------------------------------

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Twelve, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: d, iprint
complex(kind=wp), intent(in) :: moment(3,d,d)
real(kind=wp), intent(out) :: gtens(3)
real(kind=wp), intent(out) :: maxes(3,3)
integer(kind=iwp) :: i, ic1, ic2, info, j
real(kind=wp) :: A_TENS_TERM(3,3), Det_gtens, diff12, diff23, dnorm, MAIN(3), W(3), Z(3,3), ZR(3,3)
complex(kind=wp) :: AC_TENS(3,3)
complex(kind=wp), allocatable :: tmp1(:,:), tmp2(:,:)
real(kind=wp), external :: dznrm2, FindDetR
complex(kind=wp), external :: trace

dnorm = Zero
dnorm = dznrm2(3*d*d,moment,1)

if (dnorm <= tiny(dnorm)) then
  write(u6,'(A)') 'Norm of the magnetic moment is zero.'
  write(u6,'(A)') 'Returning the default (dummy) values'
  gtens(:) = Zero
  call unitmat(maxes,3)
  return
end if

! initialization:

call mma_allocate(tmp1,d,d,label='tmp1')
call mma_allocate(tmp2,d,d,label='tmp2')
do ic1=1,3
  tmp1(:,:) = moment(ic1,:,:)
  do ic2=1,3
    tmp2(:,:) = moment(ic2,:,:)
    Ac_tens(ic1,ic2) = trace(d,tmp1,tmp2)
  end do
end do
call mma_deallocate(tmp1)
call mma_deallocate(tmp2)

do ic1=1,3
  do ic2=1,3
    A_TENS_TERM(ic1,ic2) = real(Ac_tens(ic1,ic2)+Ac_tens(ic2,ic1))*Half
  end do
end do

A_TENS_TERM(:,:) = Twelve/real(d**3-d,kind=wp)*A_TENS_TERM(:,:)

if (iprint > 2) then
  write(u6,'(/)')
  write(u6,'(5X,A)') 'A_TENS_TERM(ic1,ic2):'
  write(u6,*)
  do ic1=1,3
    write(u6,'(5X,3(2F14.7,3x))') (A_TENS_TERM(ic1,ic2),ic2=1,3)
  end do
end if

! Diagonalization of A_tens - g tensors

call DIAG_R2(A_TENS_TERM,3,info,W,Z)

if (INFO /= 0) return
if ((w(1) < Zero) .and. (w(2) < Zero) .and. (w(3) < Zero)) then
  write(u6,'(2x,A)') 'ALL EIGENVALUES OF THE A-TENSOR ARE NEGATIVE'
  write(u6,'(2X,A)') 'THIS IS A VERY UNUSUAL SITUATION. PLEASE CHECK MANUALLY '
  write(u6,'(2x,A)') 'THE FOLLOWING PART OF THE PSEUDOSPIN SECTION'
  write(u6,'(2x,A)') 'MUST BE DISREGARDED. THE RESULTS ARE NOT TRUSTABLE.'
  return
end if

if (iprint > 2) then
  write(u6,*)
  write(u6,'(4x,A)') 'A_TENS_TERM TENSOR:'
  write(u6,'(2a)') repeat('-',56),'|'
  write(u6,'(4x,A,4x,A,13x,A,5x,a,3x,a)') 'MAIN VALUES','|','MAIN MAGNETIC AXES','|','x , y , z  -- initial Cartesian axes'
  write(u6,'(4a,3x,a)') repeat('-',19),'|',repeat('-',36),'|','Xm, Ym, Zm -- main magnetic axes'
  write(u6,'(19x,a,4x,a,5x,a,9x,a,9x,a,5x,a)') '|','|','x','y','z','|'
  write(u6,'(6a)') repeat('-',19),'|',repeat('-',4),'|',repeat('-',31),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gX = ',w(1),' | Xm |',(z(j,1),j=1,3),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gY = ',w(2),' | Ym |',(z(j,2),j=1,3),'|'
  write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gZ = ',w(3),' | Zm |',(z(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',56),'|'
end if

do I=1,3
  if (W(I) < Zero) W(I) = 1.0e-24_wp
end do
MAIN(:) = sqrt(W(:))

! Check the sign of the coordinate system. If CS is Left-handed,
! Then change it to RIGHT-handed
ZR(:,:) = Z(:,:)

Det_gtens = FindDetR(ZR,3)

if (Det_gtens < Zero) then
  Z(:,1) = -Z(:,1)
  if (iprint > 2) then
    write(u6,'(a)') 'The coordinate system is LEFT-handed.'
    write(u6,'(a)') 'It has been changed to RIGHT-handed'
  end if
end if

diff12 = MAIN(2)-MAIN(1)
diff23 = MAIN(3)-MAIN(2)

if (iprint > 2) then
  write(u6,'(5x,a,3F19.15)') 'diff12 = ',diff12
  write(u6,'(5x,a,3F19.15)') 'diff23 = ',diff23
end if

maxes(:,:) = Zero
! set the main Z axis:
if (diff12 > diff23) then
  gtens(:) = MAIN(3:1:-1)

  if (Z(3,1) >= Zero) then
    maxes(:,3) = Z(:,1)
    maxes(:,1) = Z(:,3)
  else if (Z(3,1) < Zero) then
    maxes(:,3) = -Z(:,1)
    maxes(:,1) = Z(:,3)
  end if

  maxes(1,2) = maxes(2,3)*maxes(3,1)-maxes(2,1)*maxes(3,3)
  maxes(2,2) = maxes(1,1)*maxes(3,3)-maxes(1,3)*maxes(3,1)
  maxes(3,2) = maxes(1,3)*maxes(2,1)-maxes(1,1)*maxes(2,3)

else if (diff23 > diff12) then
  gtens(:) = MAIN(:)

  if (Z(3,3) >= Zero) then
    maxes(:,3) = Z(:,3)
    maxes(:,1) = Z(:,1)
  else if (Z(3,3) < Zero) then
    maxes(:,3) = -Z(:,3)
    maxes(:,1) = Z(:,1)
  end if

  maxes(1,2) = maxes(2,3)*maxes(3,1)-maxes(2,1)*maxes(3,3)
  maxes(2,2) = maxes(1,1)*maxes(3,3)-maxes(1,3)*maxes(3,1)
  maxes(3,2) = maxes(1,3)*maxes(2,1)-maxes(1,1)*maxes(2,3)

else !( diff23 == diff12)
  ! this special case is isotropic:
  ! therefore assign main axes as close as to be to the cartesian xyz
  gtens(:) = MAIN(:)
  call unitmat(maxes,3)

end if
if (iprint > 2) then
  write(u6,*)
  write(u6,'(20X,A)') 'A-TENSOR:'
  write(u6,*)
  write(u6,'(10X,A,10X,3(F11.5,2X))') '|  xx    xy    xz  |',(A_TENS_TERM(1,i),i=1,3)
  write(u6,'(10X,A,10X,3(F11.5,2X))') '|  yx    yy    yz  |',(A_TENS_TERM(2,i),i=1,3)
  write(u6,'(10X,A,10X,3(F11.5,2X))') '|  zx    zy    zz  |',(A_TENS_TERM(3,i),i=1,3)
end if

if (iprint >= 2) then
  write(u6,*)
  write(u6,'(4x,A)') 'g TENSOR:'
  write(u6,'(2a)') repeat('-',56),'|'
  write(u6,'(4x,A,4x,A,13x,A,5x,a,3x,a)') 'MAIN VALUES','|','MAIN MAGNETIC AXES','|','x , y , z  -- initial Cartesian axes'
  write(u6,'(4a,3x,a)') repeat('-',19),'|',repeat('-',4),'|','----- x ------- y ------- z ---|','Xm, Ym, Zm -- main magnetic axes'
  !write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gX = ',gtens(1),' | Xm |',(maxes(j,1),j=1,3),'|'
  !write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gY = ',gtens(2),' | Ym |',(maxes(j,2),j=1,3),'|'
  !write(u6,'(A,F12.9,A,3F10.6,1x,A)') ' gZ = ',gtens(3),' | Zm |',(maxes(j,3),j=1,3),'|'
  write(u6,'(A,F18.14,A,3F18.14,1x,A)') ' gX = ',gtens(1),' | Xm |',(maxes(j,1),j=1,3),'|'
  write(u6,'(A,F18.14,A,3F18.14,1x,A)') ' gY = ',gtens(2),' | Ym |',(maxes(j,2),j=1,3),'|'
  write(u6,'(A,F18.14,A,3F18.14,1x,A)') ' gZ = ',gtens(3),' | Zm |',(maxes(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',56),'|'
end if

return

end subroutine atens

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine LOOP2(KM,ISTOP,IT1,IT2)

use guga_global, only: BS1, BS2, COUP, IB, ICOUP, ICOUP1, IWAY, IY, J1, J2, K0, K1, K2, K3
use Constants, only: One
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: KM, IT1, IT2
integer(kind=iwp), intent(out) :: ISTOP
integer(kind=iwp) :: IWAYKM, KM1

ISTOP = 0
KM1 = KM+1
! FOUR POSSIBLE STARTS
IWAYKM = IWAY(KM)
if (IWAYKM == 1) then
  IWAY(KM) = 2
  if ((K0(IT2+J2(KM1)) == 0) .or. (K2(IT1+J1(KM1)) == 0)) then
    IWAYKM = 2
  else
    COUP(KM) = One
    J1(KM) = K2(IT1+J1(KM1))
    J2(KM) = K0(IT2+J2(KM1))
    ICOUP(KM) = 0
    ICOUP1(KM) = IY(IT1+J1(KM1),2)
  end if
end if
if (IWAYKM == 2) then
  IWAY(KM) = 3
  if ((K1(IT2+J2(KM1)) == 0) .or. (K3(IT1+J1(KM1)) == 0)) then
    IWAYKM = 3
  else
    COUP(KM) = BS1(IB(J2(KM1))+1)
    J1(KM) = K3(IT1+J1(KM1))
    J2(KM) = K1(IT2+J2(KM1))
    ICOUP(KM) = IY(IT2+J2(KM1),1)
    ICOUP1(KM) = IY(IT1+J1(KM1),3)
  end if
end if
if (IWAYKM == 3) then
  IWAY(KM) = 4
  if ((K0(IT2+J2(KM1)) == 0) .or. (K1(IT1+J1(KM1)) == 0)) then
    IWAYKM = 4
  else
    COUP(KM) = One
    J1(KM) = K1(IT1+J1(KM1))
    J2(KM) = K0(IT2+J2(KM1))
    ICOUP(KM) = 0
    ICOUP1(KM) = IY(IT1+J1(KM1),1)
  end if
end if
if (IWAYKM == 4) then
  IWAY(KM) = 5
  if ((K2(IT2+J2(KM1)) == 0) .or. (K3(IT1+J1(KM1)) == 0)) then
    IWAYKM = 5
  else
    COUP(KM) = BS2(IB(J2(KM1))+1)
    J1(KM) = K3(IT1+J1(KM1))
    J2(KM) = K2(IT2+J2(KM1))
    ICOUP(KM) = IY(IT2+J2(KM1),2)
    ICOUP1(KM) = IY(IT1+J1(KM1),3)
  end if
end if
if (IWAYKM == 5) ISTOP = 1

return

end subroutine LOOP2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE COMP(I,LJ,ITYP,L,IT1,IT2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "real_guga.fh"
#include "integ.fh"
#include "files_guga.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
      COMMON/D/JNDX(500 000)
*
      JO(L)=ICUNP(ICASE,L)
*
      IF (IT1.NE.IT2) Then
         Write (6,*) 'Comp: IT1.NE.IT2'
         Write (6,*) 'IT1,IT2=',IT1,IT2
         Write (6,*) 'ITYP,L=',ITYP,L
         Call Abend
      End If
      FAC=D1
      KM=I
25    KM=KM-1
      IF(KM.EQ.0)GO TO 26
      IWAY(KM)=1
27    CALL PATH(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 25
      KM=KM+1
      IF(KM.EQ.I)GO TO 71
      GO TO 27
26    IVL=J2(1)
      ITAIL=IX(IT1+LJ)
      IVV=IV0-IVL
      JJ=0
      JJD=0
      IF(IVV.NE.0)JJ=IRC(IVV)
      IF(IVV.NE.0)JJD=JRC(IVV)
      DO 90 IN=1,ITAIL
      IC1=ICOUP(1)+IN
      IC2=ICOUP1(1)+IN
      JND1=JNDX(JJ+IC1)
      IF(JND1.EQ.0)GO TO 90
      IF(ITYP.NE.1)GO TO 91
      II1=(JND1-1)*LN+L
      JOJ=JO(II1)
      IF(JOJ.GT.1)JOJ=JOJ-1
      FAC=JOJ
      IF(JOJ.EQ.0)GO TO 90
91    IC1=JND1-JJD
      JND2=JNDX(JJ+IC2)
      IF(JND2.EQ.0)GO TO 90
      IC2=JND2-JJD
      IOUT=IOUT+1
      IVL0=IV0-IVL
*      IND=IVL0+2**6*IC2
*      ICOP1(IOUT)=IND+2**19*IC1
      IND=IOR(IVL0,ISHFT(IC2,6))
      ICOP1(IOUT)=IOR(IND,ISHFT(IC1,19))

      COP(IOUT)=FAC*COUP(I)
      IF(IOUT.LT.NBUF)GO TO 90
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
90    CONTINUE
      IF(I.EQ.1)GO TO 71
      KM=1
      GO TO 27
*
71      Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TTMul(A,B,C,nRowA,nColA,nRowB)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nRowA, nColA, nRowB
real(kind=wp), intent(in) :: A(nRowA,nColA), B(nRowB,nRowA)
real(kind=wp), intent(out) :: C(nColA,nRowB)
integer(kind=iwp) :: i, Incj, jj, k, mCache, nCache_, njVec

nCache_ = (64/8)*1024
mCache = (nCache_*3)/4-nRowA*nColA
Incj = mCache/(nRowA+nColA)

! Sectioning of long index

do jj=1,nRowB,Incj
  njVec = min(Incj,nRowB-jj+1)

  do i=1,nColA
    ! Set target to zero
    C(i,jj:jj+njVec-1) = Zero
    do k=1,nRowA
      if (A(k,i) /= Zero) C(i,jj:jj+njVec-1) = C(i,jj:jj+njVec-1)+A(k,i)*B(jj:jj+njVec-1,k)
    end do
  end do

end do    ! End of sectioning

return

end subroutine TTMul

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombOnly_(UseExactIntegralDiagonal,Timing,Mode,tau,nD,FactC,ip_DBlocks,ip_V,ip_FBlocks,CNorm,DNorm,VNorm)
! Thomas Bondo Pedersen, October 2010.
!
! Purpose: Compute Coulomb contributions to the Fock matrix using
!          Coulomb intermediates V. Integral-driven algorithm.
!
! See LDF_Fock_CoulombOnly for more details.

#ifdef _MOLCAS_MPP_
use Para_Info, only: nProcs, Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: UseExactIntegralDiagonal, Timing
integer(kind=iwp), intent(in) :: Mode, nD, ip_DBlocks(nD), ip_V(nD), ip_FBlocks(nD)
real(kind=wp), intent(in) :: tau(2), FactC(nD), CNorm(4,*), DNorm(*), VNorm(*)
integer(kind=iwp) :: l_WBlkP, iD, nAtom, TaskListID, jAB, AB, A, B, CD, C, nuv, M, MA, MB, MAB, MCD, l_Int, ipD, ipV, ipF, ipW, &
                     l_C, ipC, l_tauW, ip, l, l_VNrm, l_DNrm
real(kind=wp) :: Const, tC1, tC2, tIC1, tIC2, tW1, tW2, tIW1, tIW2, tIC, tIW, tauWr, GABCD, GCDAB
integer(kind=iwp), allocatable :: WBlkP(:)
real(kind=wp), allocatable :: FckInt(:), FckCoef(:), tauW(:), VNrm(:), DNrm(:)
character(len=*), parameter :: SecNam = 'LDF_Fock_CoulombOnly_'
logical(kind=iwp), external :: Rsv_Tsk
integer(kind=iwp), external :: LDF_nAtom, LDF_nBas_Atom, LDF_nBasAux_Atom, LDF_nBasAux_Pair_wLD
#include "WrkSpc.fh"
#include "localdf.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_integral_prescreening_info.fh"
#include "ldf_a2ap.fh"

! Get number of atoms
nAtom = LDF_nAtom()

! Set up prescreening info
l_VNrm = nAtom+NumberOfAtomPairs
call mma_allocate(VNrm,l_VNrm,label='VNrm')
VNrm(:) = Zero
do iD=1,nD
  ip = (nAtom+NumberOfAtomPairs)*(iD-1)
  do AB=1,nAtom+NumberOfAtomPairs
    VNrm(AB) = max(VNrm(AB),VNorm(ip+AB))
  end do
end do
l_DNrm = NumberOfAtomPairs
call mma_allocate(DNrm,l_DNrm,label='DNrm')
DNrm(:) = Zero
do iD=1,nD
  ip = NumberOfAtomPairs*(iD-1)
  do AB=1,NumberOfAtomPairs
    DNrm(AB) = max(DNrm(AB),DNorm(ip+AB))
  end do
end do
l_tauW = nAtom+NumberOfAtomPairs
call mma_allocate(tauW,l_tauW,label='tauW')
if (tau(2) > Zero) then
  call LDF_SetA2AP()
  do A=1,nAtom
    l = iWork(ip_A2AP-1+2*(A-1)+1)
    ip = iWork(ip_A2AP-1+2*(A-1)+2)-1
    tauW(A) = Zero
    do jAB=1,l
      AB = iWork(ip+jAB)
      if (iWork(ip_AP_Atoms-1+2*(AB-1)+1) == A) then
        tauW(A) = max(tauW(A),CNorm(2,AB))
      else if (iWork(ip_AP_Atoms-1+2*(AB-1)+2) == A) then
        tauW(A) = max(tauW(A),CNorm(3,AB))
      else
        call WarningMessage(2,SecNam//': logical error [A2AP]')
        call LDF_Quit(1)
      end if
    end do
    if (tauW(A) > 1.0e-16_wp) then
      tauWr = tau(2)/tauW(A)
    else
      tauWr = 1.0e99_wp
    end if
    tauW(A) = tauWr
  end do
  call LDF_UnsetA2AP()
  do AB=1,NumberOfAtomPairs
    if (iWork(ip_AP_2CFunctions-1+2*(AB-1)+1) > 0) then
      if (CNorm(4,AB) > 1.0e-16_wp) then
        tauW(nAtom+AB) = tau(2)/CNorm(4,AB)
      else
        tauW(nAtom+AB) = 1.0e99_wp
      end if
    else
      tauW(nAtom+AB) = 1.0e99_wp
    end if
  end do
else
  tauW(:) = Zero
end if

! Allocate and initialize W intermediates
l_WBlkP = nD
call mma_allocate(WBlkP,l_WBlkP,label='WBlkP')
do iD=1,nD
  call LDF_AllocateAuxBasVector('Win',WBlkP(iD))
  call LDF_ZeroAuxBasVector(WBlkP(iD))
end do

!======================
! 3-index contributions
!======================

if ((Mode == 1) .or. (Mode == 3)) then
  if (Timing) then
    tIC = Zero
    tIW = Zero
    call CWTime(tC1,tW1)
  end if
  call Init_Tsk(TaskListID,NumberOfAtomPairs)
  do while (Rsv_Tsk(TaskListID,AB))
    A = iWork(ip_AP_Atoms-1+2*(AB-1)+1)
    B = iWork(ip_AP_Atoms-1+2*(AB-1)+2)
    nuv = LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
    do C=1,nAtom
      tauWr = tauW(C)
      if ((Work(ip_IDiag_Sm-1+AB)*Work(ip_GDiag_1C_Sm-1+C)*VNorm(C) >= tau(2)) .or. &
          (Work(ip_IDiag_Sm-1+AB)*Work(ip_GDiag_1C_Sm-1+C)*DNorm(AB) >= tauWr)) then
        ! Compute integrals (u_A v_B|J_C)
        M = LDF_nBasAux_Atom(C)
        l_Int = nuv*M
        call mma_allocate(FckInt,l_Int,label='Fck3Int1')
        if (Timing) call CWTime(tIC1,tIW1)
        call LDF_Compute3IndexIntegrals_1(AB,C,tau(1),l_Int,FckInt)
        if (Timing) then
          call CWTime(tIC2,tIW2)
          tIC = tIC+(tIC2-tIC1)
          tIW = tIW+(tIW2-tIW1)
        end if
        ! Compute Fock matrix contribution
        ! F(u_A v_B)+=FactC*sum_J_C (u_A v_B|J_C)*V(J_C)
        do iD=1,nD
          ipV = iWork(ip_V(iD)-1+C)
          ipF = iWork(ip_FBlocks(iD)-1+AB)
          call dGeMV_('N',nuv,M,FactC(iD),FckInt,nuv,Work(ipV),1,One,Work(ipF),1)
        end do
        ! Compute W contribution
        ! W(J_C)+=sum_u_Av_B (u_A v_B|J_C)*D(u_A v_B)
        do iD=1,nD
          ipD = iWork(ip_DBlocks(iD)-1+AB)
          ipW = iWork(WBlkP(iD)-1+C)
          call dGeMV_('T',nuv,M,One,FckInt,nuv,Work(ipD),1,One,Work(ipW),1)
        end do
        call mma_deallocate(FckInt)
      end if
    end do
    if (LDF2) then
      ! Contributions from two-center aux functions
      do CD=1,NumberOfAtomPairs
        MCD = iWork(ip_AP_2CFunctions-1+2*(CD-1)+1)
        if (MCD > 0) then
          tauWr = tauW(nAtom+CD)
          if ((Work(ip_IDiag_Sm-1+AB)*Work(ip_GDiag_2C_Sm-1+CD)*VNorm(nAtom+CD) >= tau(2)) .or. &
              (Work(ip_IDiag_Sm-1+AB)*Work(ip_GDiag_2C_Sm-1+CD)*DNorm(AB) >= tauWr)) then
            ! Compute integrals (u_A v_B|J_CD)
            l_Int = nuv*MCD
            call mma_allocate(FckInt,l_Int,label='Fck3Int2')
            if (Timing) call CWTime(tIC1,tIW1)
            call LDF_Compute3IndexIntegrals_2(AB,CD,tau(1),l_Int,FckInt)
            if (Timing) then
              call CWTime(tIC2,tIW2)
              tIC = tIC+(tIC2-tIC1)
              tIW = tIW+(tIW2-tIW1)
            end if
            ! Compute Fock matrix contribution
            ! F(u_A v_B)+=
            ! FactC*sum_J_CD (u_A v_B|J_CD)*V(J_CD)
            do iD=1,nD
              ipV = iWork(ip_V(iD)-1+nAtom+CD)
              ipF = iWork(ip_FBlocks(iD)-1+AB)
              call dGeMV_('N',nuv,MCD,FactC(iD),FckInt,nuv,Work(ipV),1,One,Work(ipF),1)
            end do
            ! Compute W contribution
            ! W(J_CD)+=sum_u_Av_B (u_A v_B|J_CD)*D(u_A v_B)
            do iD=1,nD
              ipD = iWork(ip_DBlocks(iD)-1+AB)
              ipW = iWork(WBlkP(iD)-1+nAtom+CD)
              call dGeMV_('T',nuv,MCD,One,FckInt,nuv,Work(ipD),1,One,Work(ipW),1)
            end do
            call mma_deallocate(FckInt)
          end if
        end if
      end do
    end if
  end do
  call Free_Tsk(TaskListID)
  if (Timing) then
    call CWTime(tC2,tW2)
    write(u6,'(A,2(1X,F12.2),A)') 'Time spent on 3-index contributions:              ',tC2-tC1,tW2-tW1,' seconds'
    write(u6,'(A,2(1X,F12.2),A)') '      - of which integrals required:              ',tIC,tIW,' seconds'
  end if
end if

!======================
! 2-index contributions
!======================

if ((Mode == 1) .or. (Mode == 2)) then
  if (Timing) then
    tIC = Zero
    tIW = Zero
    call CWTime(tC1,tW1)
  end if
  if (Mode == 1) then
    Const = -One
  else
    Const = One
  end if
  call Init_Tsk(TaskListID,nAtom)
  do while (Rsv_Tsk(TaskListID,A))
    MA = LDF_nBasAux_Atom(A)
    if (MA > 0) then
      do B=1,A-1
        MB = LDF_nBasAux_Atom(B)
        if (MB > 0) then
          if ((Work(ip_GDiag_1C_Sm-1+A)*Work(ip_GDiag_1C_Sm-1+B)*VNorm(B) >= tauW(A)) .or. &
              (Work(ip_GDiag_1C_Sm-1+A)*Work(ip_GDiag_1C_Sm-1+B)*VNorm(A) >= tauW(B))) then
            ! Compute integrals (J_A|K_B)
            l_Int = MA*MB
            call mma_allocate(FckInt,l_Int,label='Fck2Int11')
            if (Timing) call CWTime(tIC1,tIW1)
            call LDF_Compute2IndexIntegrals_11(A,B,tau(1),l_Int,FckInt)
            if (Timing) then
              call CWTime(tIC2,tIW2)
              tIC = tIC+(tIC2-tIC1)
              tIW = tIW+(tIW2-tIW1)
            end if
            ! Compute W contribution
            ! W(J_A)+=Const*sum_K_B (J_A|K_B)*V(K_B)
            do iD=1,nD
              ipV = iWork(ip_V(iD)-1+B)
              ipW = iWork(WBlkP(iD)-1+A)
              call dGeMV_('N',MA,MB,Const,FckInt,MA,Work(ipV),1,One,Work(ipW),1)
            end do
            ! Compute W contribution
            ! W(K_B)+=Const*sum_J_A (J_A|K_B)*V(J_A)
            do iD=1,nD
              ipV = iWork(ip_V(iD)-1+A)
              ipW = iWork(WBlkP(iD)-1+B)
              call dGeMV_('T',MA,MB,Const,FckInt,MA,Work(ipV),1,One,Work(ipW),1)
            end do
            call mma_deallocate(FckInt)
          end if
        end if
      end do
      if (Work(ip_GDiag_1C_Sm-1+A)*Work(ip_GDiag_1C_Sm-1+A)*VNorm(A) >= tauW(A)) then
        ! Compute integrals (J_A|K_A)
        l_Int = MA**2
        call mma_allocate(FckInt,l_Int,label='Fck2Int11')
        if (Timing) call CWTime(tIC1,tIW1)
        call LDF_Compute2IndexIntegrals_11(A,A,tau(1),l_Int,FckInt)
        if (Timing) then
          call CWTime(tIC2,tIW2)
          tIC = tIC+(tIC2-tIC1)
          tIW = tIW+(tIW2-tIW1)
        end if
        ! Compute W contribution
        ! W(J_A)+=Const*sum_K_A (J_A|K_A)*V(K_A)
        do iD=1,nD
          ipV = iWork(ip_V(iD)-1+A)
          ipW = iWork(WBlkP(iD)-1+A)
          call dGeMV_('N',MA,MA,Const,FckInt,MA,Work(ipV),1,One,Work(ipW),1)
        end do
        call mma_deallocate(FckInt)
      end if
      if (LDF2) then
        ! Two-center contributions
        do CD=1,NumberOfAtomPairs
          MCD = iWork(ip_AP_2CFunctions-1+2*(CD-1)+1)
          if (MCD > 0) then
            if ((Work(ip_GDiag_1C_Sm-1+A)*Work(ip_GDiag_2C_Sm-1+CD)*VNorm(nAtom+CD) >= tauW(A)) .or. &
                (Work(ip_GDiag_1C_Sm-1+A)*Work(ip_GDiag_2C_Sm-1+CD)*VNorm(A) >= tauW(nAtom+CD))) then
              ! Compute integrals (J_A|K_CD)
              l_Int = MA*MCD
              call mma_allocate(FckInt,l_Int,label='Fck2Int12')
              if (Timing) call CWTime(tIC1,tIW1)
              call LDF_Compute2IndexIntegrals_12(A,CD,tau(1),l_Int,FckInt)
              if (Timing) then
                call CWTime(tIC2,tIW2)
                tIC = tIC+(tIC2-tIC1)
                tIW = tIW+(tIW2-tIW1)
              end if
              ! Compute W contribution
              ! W(J_A)+=Const*sum_K_CD (J_A|K_CD)*V(K_CD)
              do iD=1,nD
                ipV = iWork(ip_V(iD)-1+nAtom+CD)
                ipW = iWork(WBlkP(iD)-1+A)
                call dGeMV_('N',MA,MCD,Const,FckInt,MA,Work(ipV),1,One,Work(ipW),1)
              end do
              ! Compute W contribution
              ! W(K_CD)+=Const*sum_J_A (J_A|K_CD)*V(J_A)
              do iD=1,nD
                ipV = iWork(ip_V(iD)-1+A)
                ipW = iWork(WBlkP(iD)-1+nAtom+CD)
                call dGeMV_('T',MA,MCD,Const,FckInt,MA,Work(ipV),1,One,Work(ipW),1)
              end do
              call mma_deallocate(FckInt)
            end if
          end if
        end do
      end if
    end if
  end do
  call Free_Tsk(TaskListID)
  if (LDF2) then
    call Init_Tsk(TaskListID,NumberOfAtomPairs)
    do while (Rsv_Tsk(TaskListID,AB))
      MAB = iWork(ip_AP_2CFunctions-1+2*(AB-1)+1)
      if (MAB > 0) then
        do CD=1,AB-1
          MCD = iWork(ip_AP_2CFunctions-1+2*(CD-1)+1)
          if (MCD > 0) then
            GABCD = Work(ip_GDiag_2C_Sm-1+AB)*Work(ip_GDiag_2C_Sm-1+CD)*VNorm(nAtom+CD)
            GCDAB = Work(ip_GDiag_2C_Sm-1+AB)*Work(ip_GDiag_2C_Sm-1+CD)*VNorm(nAtom+AB)
            if ((GABCD >= tauW(nAtom+AB)) .or. (GCDAB >= tauW(nAtom+CD))) then
              ! Compute integrals (J_AB|K_CD)
              l_Int = MAB*MCD
              call mma_allocate(FckInt,l_Int,label='Fck2Int22')
              if (Timing) call CWTime(tIC1,tIW1)
              call LDF_Compute2IndexIntegrals_22(AB,CD,tau(1),l_Int,FckInt)
              if (Timing) then
                call CWTime(tIC2,tIW2)
                tIC = tIC+(tIC2-tIC1)
                tIW = tIW+(tIW2-tIW1)
              end if
              ! Compute W contribution
              ! W(J_AB)+=Const*sum_K_CD (J_AB|K_CD)*V(K_CD)
              do iD=1,nD
                ipV = iWork(ip_V(iD)-1+nAtom+CD)
                ipW = iWork(WBlkP(iD)-1+nAtom+AB)
                call dGeMV_('N',MAB,MCD,Const,FckInt,MAB,Work(ipV),1,One,Work(ipW),1)
              end do
              ! Compute W contribution
              ! W(K_CD)+=Const*sum_J_AB (J_AB|K_CD)*V(J_AB)
              do iD=1,nD
                ipV = iWork(ip_V(iD)-1+nAtom+AB)
                ipW = iWork(WBlkP(iD)-1+nAtom+CD)
                call dGeMV_('T',MAB,MCD,Const,FckInt,MAB,Work(ipV),1,One,Work(ipW),1)
              end do
              call mma_deallocate(FckInt)
            end if
          end if
        end do
        ! Compute integrals (J_AB|K_AB)
        if (Work(ip_GDiag_2C_Sm-1+AB)*Work(ip_GDiag_2C_Sm-1+AB)*VNorm(nAtom+AB) >= tauW(nAtom+AB)) then
          l_Int = MAB**2
          call mma_allocate(FckInt,l_Int,label='Fck2Int22')
          if (Timing) call CWTime(tIC1,tIW1)
          call LDF_Compute2IndexIntegrals_22(AB,AB,tau(1),l_Int,FckInt)
          if (Timing) then
            call CWTime(tIC2,tIW2)
            tIC = tIC+(tIC2-tIC1)
            tIW = tIW+(tIW2-tIW1)
          end if
          ! Compute W contribution
          ! W(J_AB)+=Const*sum_K_AB (J_AB|K_AB)*V(K_AB)
          do iD=1,nD
            ipV = iWork(ip_V(iD)-1+nAtom+AB)
            ipW = iWork(WBlkP(iD)-1+nAtom+AB)
            call dGeMV_('N',MAB,MAB,Const,FckInt,MAB,Work(ipV),1,One,Work(ipW),1)
          end do
          call mma_deallocate(FckInt)
        end if
      end if
    end do
    call Free_Tsk(TaskListID)
  end if
  if (Timing) then
    call CWTime(tC2,tW2)
    write(u6,'(A,2(1X,F12.2),A)') 'Time spent on 2-index contributions:              ',tC2-tC1,tW2-tW1,' seconds'
    write(u6,'(A,2(1X,F12.2),A)') '      - of which integrals required:              ',tIC,tIW,' seconds'
  end if
end if

! Deallocate prescreening info
call mma_deallocate(tauW)
if (l_DNrm > 0) then
  call mma_deallocate(DNrm)
end if
if (l_VNrm > 0) then
  call mma_deallocate(VNrm)
end if

#ifdef _MOLCAS_MPP_
! Add W over nodes
if ((nProcs > 1) .and. Is_Real_Par()) then
  if (Timing) call CWTime(tC1,tW1)
  do iD=1,nD
    call LDF_P_AddAuxBasVector(WBlkP(iD))
  end do
  if (Timing) then
    call CWTime(tC2,tW2)
    write(u6,'(A,2(1X,F12.2),A)') 'Parallel overhead for W intermediates:            ',tC2-tC1,tW2-tW1,' seconds'
  end if
end if
#endif

!===============
! Compute F+=C*W
!===============

if (Timing) call CWTime(tC1,tW1)
call Init_Tsk(TaskListID,NumberOfAtomPairs)
do while (Rsv_Tsk(TaskListID,AB))
  ! Read coefficients
  A = iWork(ip_AP_Atoms-1+2*(AB-1)+1)
  B = iWork(ip_AP_Atoms-1+2*(AB-1)+2)
  nuv = LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
  l_C = nuv*LDF_nBasAux_Pair_wLD(AB)
  call mma_allocate(FckCoef,l_C,label='FckCoef')
  call LDF_CIO_ReadC_wLD(AB,FckCoef,l_C)
  ! Compute F(u_A v_B) += FactC*sum_J C(u_A v_B,J)*W(J)
  ipC = 1
  MA = LDF_nBasAux_Atom(A)
  if (MA > 0) then
    do iD=1,nD
      ipF = iWork(ip_FBlocks(iD)-1+AB)
      ipW = iWork(WBlkP(iD)-1+A)
      call dGeMV_('N',nuv,MA,FactC(iD),FckCoef(ipC),nuv,Work(ipW),1,One,Work(ipF),1)
    end do
    ipC = ipC+nuv*MA
  end if
  if (B /= A) then
    MB = LDF_nBasAux_Atom(B)
    if (MB > 0) then
      do iD=1,nD
        ipF = iWork(ip_FBlocks(iD)-1+AB)
        ipW = iWork(WBlkP(iD)-1+B)
        call dGeMV_('N',nuv,MB,FactC(iD),FckCoef(ipC),nuv,Work(ipW),1,One,Work(ipF),1)
      end do
      ipC = ipC+nuv*MB
    end if
  end if
  MAB = iWork(ip_AP_2CFunctions-1+2*(AB-1)+1)
  if (MAB > 0) then
    do iD=1,nD
      ipF = iWork(ip_FBlocks(iD)-1+AB)
      ipW = iWork(WBlkP(iD)-1+nAtom+AB)
      call dGeMV_('N',nuv,MAB,FactC(iD),FckCoef(ipC),nuv,Work(ipW),1,One,Work(ipF),1)
    end do
  end if
  call mma_deallocate(FckCoef)
end do
call Free_Tsk(TaskListID)
if (Timing) then
  call CWTime(tC2,tW2)
  write(u6,'(A,2(1X,F12.2),A)') 'Time spent computing C*W contribution:            ',tC2-tC1,tW2-tW1,' seconds'
end if

! Deallocate W intermediates
do iD=1,nD
  call LDF_DeallocateAuxBasVector('Win',WBlkP(iD))
end do
call mma_deallocate(WBlkP)

! Use exact integral diagonal blocks if requested.
! Computed by adding the correction
! dF(uv) = FactC * sum_kl { (uv|kl) - [uv|kl] }*D(kl)
! where |uv) and |kl) belong to the same atom pair
! and [uv|kl] is an LDF integral approximation.
if (UseExactIntegralDiagonal) then
  if (Timing) call CWTime(tC1,tW1)
  call LDF_Fock_CoulombOnly_XIDI(Mode,tau(1),nD,FactC,ip_DBlocks,ip_FBlocks)
  if (Timing) then
    call CWTime(tC2,tW2)
    write(u6,'(A,2(1X,F12.2),A)') 'Time spent computing XIDI corrections:            ',tC2-tC1,tW2-tW1,' seconds'
  end if
end if

#ifdef _MOLCAS_MPP_
if ((nProcs > 1) .and. Is_Real_Par()) then
  if (Timing) call CWTime(tC1,tW1)
  do iD=1,nD
    call LDF_P_AddBlockMatrix(ip_FBlocks(iD))
  end do
  if (Timing) then
    call CWTime(tC2,tW2)
    write(u6,'(A,2(1X,F12.2),A)') 'Parallel overhead for F blocks:                   ',tC2-tC1,tW2-tW1,' seconds'
  end if
end if
#endif

if (Timing) call xFlush(u6)

end subroutine LDF_Fock_CoulombOnly_

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Step1(iCenter,Matrix,nDim,TMatrix,iType,Matrix0,Temp)
! Step 1. LO S0 ->S1
! occupied virtual on the same center
! and orthonormalization of the original AO basis
! The call to lowdin gives me a transformation A1, and a transformed
! S matrix

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, iCenter(nDim), iType(nDim)
real(kind=wp), intent(inout) :: Matrix(nDim,nDim), TMatrix(nDim,nDim), Matrix0(nDim,nDim)
real(kind=wp), intent(out) :: Temp(nDim,nDim)
integer(kind=iwp) :: i, j

do i=1,nDim
  do j=1,nDim
    !write(u6,*) iCenter(i),iCenter(j), Matrix(j,i)
    if (iCenter(i) /= iCenter(j)) then
      Matrix(j,i) = Zero
    end if
  end do
end do
call GramSchmidt(Matrix,TMatrix,nDim,iType,iCenter,0)
Matrix(:,:) = Matrix0(:,:)

! Now apply T1 to original S: S2=T1(T)*S*T1

call DGEMM_('N','N',nDim,nDim,nDim,One,Matrix,nDim,TMatrix,nDim,Zero,Temp,nDim)
call DGEMM_('T','N',nDim,nDim,nDim,One,TMatrix,nDim,Temp,nDim,Zero,Matrix,nDim)

return

end subroutine Step1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function EFP_On()

use Definitions, only: iwp

implicit none
logical(kind=iwp) :: EFP_On
#ifdef _EFP_
logical(kind=iwp) :: lEFP

call Get_lScalar('EFP',lEFP)

EFP_On = lEFP
#else
EFP_On = .false.
#endif

return

end function EFP_On

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine realz_cvb(arr,nmax,nread,ifc)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nmax, ifc
real(kind=wp), intent(out) :: arr(nmax)
integer(kind=iwp), intent(out) :: nread
integer(kind=iwp), parameter :: nbuf = 100
integer(kind=iwp) :: nleft, nread1
real(kind=wp) :: tmp(nbuf)

nread = 0
do
  tmp(:) = Zero
  nleft = nmax-nread
  call real_cvb(tmp,min(nbuf,nleft),nread1,ifc)
  arr(nread+1:nread+nread1) = tmp(1:nread1)
  nread = nread+nread1
  if (nread1 <= 0) exit
end do

return

end subroutine realz_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GGL_Grid(L_Max)
!***********************************************************************
!                                                                      *
!     Computes data useful for the angular quadrature.                 *
!                                                                      *
!***********************************************************************

use do_grid, only: Do_GGL
use nq_Structure, only: Info_Ang
use nq_Info, only: nAngularGrids
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: L_Max
integer(kind=iwp) :: L_Eff

!                                                                      *
!***********************************************************************
!                                                                      *
! Generate angular grid from Gauss and Gauss-Legendre quadrature
!
!-- Theta (polar angle): 0 <= theta <= pi
!   Gauss-Legendre Quadrature (L_Quad+1)/2 points
!-- Phi (azimuthal angle): 0 <= phi <= 2*pi
!   Gauss-Quadrature (L_Quad+1) points

do L_Eff=1,L_Max
  nAngularGrids = nAngularGrids+1

  Info_Ang(nAngularGrids)%L_eff = L_eff
  call Do_GGL(L_Eff,Info_Ang(nAngularGrids)%nPoints,Info_Ang(nAngularGrids)%R)

end do ! L_Eff
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine GGL_Grid

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Aces_Gamma()
      use Basis_Info, only: nBas
      use Aces_Stuff
      use Index_arrays, only: iSO2Sh
      use Gateway_Info, only: CutInt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "setup.fh"
#include "stdalloc.fh"
       Integer, Allocatable:: iTable(:,:)
       Real*8, Allocatable:: Buf(:), Bin3(:,:,:)
*                                                                      *
************************************************************************
*                                                                      *
      nShell=mSkal
      nPair=nShell*(nShell+1)/2
      nQuad=nPair*(nPair+1)/2
*                                                                      *
************************************************************************
*                                                                      *
*---- Allocate Table Of Content for half sorted gammas.
*
      Call mma_allocate(G_Toc,nQuad,Label='G_Toc')
*
*---- Tabel SO to contigeous index
*
      Call mma_allocate(SO2cI,2,nSOs,Label='SO2cI')
*
*     Both should be deallocated in CloseP!
*                                                                      *
************************************************************************
*                                                                      *
*---- Generate table with information regarding the symmetry blocks
*     of the gammas as stored in Aces 2 format
*
      If (nIrrep.eq.8) nBlocks=106
      If (nIrrep.eq.4) nBlocks= 19
      If (nIrrep.eq.2) nBlocks=  4
      If (nIrrep.eq.1) nBlocks=  1
      Call mma_Allocate(iTable,6,nBlocks,Label='iTable')
      Call Gamma_Blocks(iTable,nBlocks,nIrrep)
*                                                                      *
************************************************************************
*                                                                      *
*---- Allocate memory for read buffer
*
      Call GetMem('Buff','Max','Real',iDummy,MaxMem)
      nReq=0
      Do iBlock = 1, nBlocks
         iType=iTable(1,iBlock)
         iIrrep_A=iTable(2,iBlock)
         iIrrep_B=iTable(3,iBlock)
         iIrrep_C=iTable(4,iBlock)
         iIrrep_D=iTable(5,iBlock)
*
         nA=nBas(iIrrep_A)
         nB=nBas(iIrrep_B)
         nC=nBas(iIrrep_C)
         nD=nBas(iIrrep_D)
         If (iType.eq.1 .or. iType.eq.2) Then
            nAB = nA*(nA+1)/2
            nCD = nC*(nC+1)/2
         Else
            nAB=nA*nB
            nCD=nC*nD
         End If
*
         nReq=Max(nReq,nAB*nCD)
      End Do
      nReq=Min(MaxMem/4,nReq)
      Call mma_allocate(Buf,nReq,Label='Buf')
*                                                                      *
************************************************************************
*                                                                      *
*---- Allocate bins for shell quadruplets
*
      Call GetMem('Buff','Max','Real',iDummy,MaxMem)
      lBin=Min(MaxMem/(2*nQuad),1024)
      Call mma_allocate(Bin3,2,lBin,nQuad,Label='Bin3')
*                                                                      *
************************************************************************
*                                                                      *
*---- Open the bin file with half sorted gammas.
*
      LuGamma=60
      LuGamma=isfreeunit(LuGamma)
      Call DaName_MF(LuGamma,'GAMMA')
*                                                                      *
************************************************************************
*                                                                      *
*---- Read the blocks off the Aces 2 file and put into half sorted bin
*     file. The second half sort is done on the fly as needed.
*
      Call Read_Blocks(iTable,nBlocks,nBas,nIrrep,Buf,nReq,
     &                 iSO2Sh,nSOs,Bin3,lBin,nQuad,G_Toc,SO2cI,CutInt)
*                                                                      *
************************************************************************
*                                                                      *
*---- Deallocate memory
*
      Call mma_deallocate(Bin3)
      Call mma_deallocate(Buf)
      Call mma_deallocate(iTable)
*                                                                      *
************************************************************************
*                                                                      *
*---- Allocate buffer for reading the bins
*
      Call mma_allocate(Bin,2,lBin,Label='Bin')
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1998,2005, Roland Lindh                 *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Post_2Center_LDF(A_Diag,AB,MaxCntr,Lu_AB,Local_A,
     &                            SO2C,nSO_Aux)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals.                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March 1990                                               *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for k2 loop. August 1991                        *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. 1993         *
*             Modified driver. Jan. 1998                               *
*             Modified to 2-center ERIs for RI June 2005               *
************************************************************************
      use Basis_Info, only: nBas_Aux
      use RI_glob, only: iOffA, Lu_A, Lu_Q, nChV
      use Gateway_global, only: force_out_of_core
      use RICD_Info, only: Thrshld_CD
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "setup.fh"
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "nsd.fh"
      Character Name_Q*6
      Integer nQvec(0:7)
      Real*8 :: A_Diag(*)
      Real*8, Allocatable :: Local_A(:,:)
      Integer, Allocatable :: SO2C(:), AB(:,:)

      Real*8, Allocatable :: Scr(:)
      Integer, Allocatable :: iDiag(:), SO2lO(:)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the number of AB blocks
*
      nAB=MaxCntr*(MaxCntr+1)/2
      Call mma_allocate(AB,2,nAB,Label='AB')
      AB(:,:)=0
*
*     Find the size of the largest AB block!
*
      Max_AA=0
      Do iCenter = 1, MaxCntr
         nCenter=0
         Do i = 1, nSO_Aux
            jCenter=SO2C(i)
            If (jCenter.eq.iCenter) nCenter=nCenter+1
         End Do
         Max_AA = Max(Max_AA,nCenter)
      End Do
      nLocal_A=(2*Max_AA)**2
      Call mma_allocate(Local_A,nLocal_A,2,Label='Local_A')
      Call mma_allocate(SO2lO,nSO_Aux,Label='SO2lO')
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Some setup for the generation of the Q-vectors
*
      nB=0
      nXZ=0
      nQm_Tot=0
      lScr=0
      Do iIrrep = 0, nIrrep-1
         iOffA(3,iIrrep)=nB
         mB=nBas_Aux(iIrrep)
         If (iIrrep.eq.0) mB = mB - 1
         nB=nB+mB
         nQm_Tot=nQm_Tot + mB**2
         nXZ = Max(nXZ,mB)
      End Do
*
      nA_Diag=nB
      lScr=3*nXZ
      Call mma_allocate(iDiag,nA_Diag,Label='iDiag')
      Call mma_allocate(Scr,lScr,Label='Scr')
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*                                                                      *
*     Process the atomic and diatomic blocks of the A matrix
*
      iAdr_AB=0
      Lu_AB=22
      Call DaName_MF_WA(Lu_AB,'ABLOCKS')
      Do iCenter = 1, MaxCntr
         niSO=0
         nlO=0
         Do iSO = 1, nSO_Aux
            kCenter = SO2C(iSO)
            If (kCenter.eq.iCenter) Then
               niSO=niSO+1
               nlO = nlO + 1
               SO2lO(iSO)=nlO
            End If
         End Do

         Do jCenter = 1, iCenter
            ijCenter = iCenter*(iCenter-1)/2 + jCenter
*
*           Process the atomic blocks
*
            iAddr=0
            iIrrep=0
            If (jCenter.eq.iCenter) Then
*
               Local_A(1:niSO**2,1)=Zero
*
               Do iSO = 1, nSO_Aux
                  Call dDaFile(Lu_A(iIrrep),2,Scr,
     &                         nSO_Aux,iAddr)
C                 Call RecPrt('Scr','(6G23.15)',Scr,1,nSO_Aux)
                  kCenter = SO2C(iSO)
                  If (kCenter.eq.iCenter) Then
                      ilO=SO2lO(iSO)
                      Do jSO = 1, iSO
                         lCenter = SO2C(jSO)
                         If (lCenter.eq.iCenter) Then
                            AElement=Scr(jSO)
                            jlO=SO2lO(jSO)
                            ij = (ilO-1)*nlO + jlO
                            ji = (jlO-1)*nlO + ilO
                            AElement=Scr(jSO)
                            Local_A(ij,1)=AElement
                            Local_A(ji,1)=AElement
                         End If
                      End Do
                  End If
               End Do
C              Call RecPrt('Local_A','(6G23.15)',
C    &                     Local_A(:,1),nlO,nlO)
*
               Call CD_AInv(Local_A(:,1),nlO,Local_A(:,2),Thrshld_CD)
*
C              Call RecPrt('Local_AInv','(6G23.15)',
C    &                     Local_A(:,2),nlO,nlO)
*
*              Store the address of the matrix, size and write the
*              matrix to *              disk.
*
               AB(1,ijCenter)=iAdr_AB
               AB(2,ijCenter)=nlO
               Call dDaFile(Lu_AB,1,Local_A(:,2),nlO**2,iAdr_AB)
*
            Else
*
*              Process the diatomic blocks
*
               njSO=0
               mlO = 0
               Do jSO = 1, nSO_Aux
                  lCenter = SO2C(jSO)
                  If (lCenter.eq.jCenter) Then
                     njSO=njSO+1
                     mlO = mlO + 1
                     SO2lO(jSO)=mlO+nlO
                  End If
               End Do
*
               Local_A(1:(niSO+njSO)**2,1)=Zero
*
               Do iSO = 1, nSO_Aux
                  Call dDaFile(Lu_A(iIrrep),2,Scr,nSO_Aux,iAddr)
                  kCenter = SO2C(iSO)
                  If (kCenter.eq.iCenter.or.
     &                kCenter.eq.jCenter) Then
                      ilO=SO2lO(iSO)
                      Do jSO = 1, iSO
                         lCenter = SO2C(jSO)
                         If (lCenter.eq.iCenter.or.
     &                       lCenter.eq.jCenter) Then
                            AElement=Scr(jSO)
                            jlO=SO2lO(jSO)
                            ij = (ilO-1)*(nlO+mlO) + jlO
                            ji = (jlO-1)*(nlO+mlO) + ilO
                            AElement=Scr(jSO)
                            Local_A(ij,1)=AElement
                            Local_A(ji,1)=AElement
                         End If
                      End Do
                  End If
               End Do
*
               Call CD_AInv(Local_A(:,1),nlO+mlO,Local_A(:,2),
     &                      Thrshld_CD)
*
*              Store the address of the matrix, size and write the
*               matrix to *              disk.
*
               AB(1,ijCenter)=iAdr_AB
               AB(2,ijCenter)=nlO+mlO
               Call dDaFile(Lu_AB,1,Local_A(:,2),(nlO+mlO)**2,iAdr_AB)
*
            End If
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Fill in the lower part of the A matrix as it is stored on disk.
*
      Call mma_maxDBLE(MaxMem)
      Do iIrrep = 0, nIrrep-1
         nB = nBas_Aux(iIrrep)
         If (iIrrep.eq.0) nB = nB - 1 ! subtract dummay af
         Call Square_A(Lu_A(iIrrep),nB,MaxMem,Force_Out_of_Core)
      End Do
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      ThrQ=1.0D-12
      ichk=0
      is=1
      Do iIrrep = 0, nIrrep-1
         nB = nBas_Aux(iIrrep)
         If (iIrrep.eq.0) nB = nB - 1 ! subtract dummy aux. func.
         If (nB.gt.0) Then
*
            iSeed=55+iIrrep
            Lu_Q(iIrrep)=IsFreeUnit(iSeed)
            Write(Name_Q,'(A4,I2.2)') 'QVec',iIrrep
            Call DaName_MF_WA(Lu_Q(iIrrep),Name_Q)
*
            Call get_pivot_idx(A_Diag(is),nB,nQvec(iIrrep),
     &                         Lu_A(iIrrep),Lu_Q(iIrrep),
     &                         iDiag(is),Scr,lScr,ThrQ)
            nChV(iIrrep)=nQvec(iIrrep)
            ichk=ichk+Min(1,nB-nQvec(iIrrep))
            is=is+nB
         End If
         Call DaClos(Lu_A(iIrrep))
      End Do
*
      If (ichk.ne.0) Then
         Write(6,*)
         Write(6,*)'Detected lin. dependences in the auxiliary basis.'
         Write(6,'(A,8I6)')
     & ' # of AuxBas before l. d. removal: ',
     &   nBas_Aux(0)-1,(nBas_Aux(i),i=1,nIrrep-1)
         Write(6,'(A,8I6)')
     & ' # of AuxBas after  l. d. removal: ',(nQvec(i),i=0,nIrrep-1)
         Write(6,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Scr)
      Call mma_deallocate(iDiag)
      Call mma_deallocate(SO2lO)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_Hvo(Hvo)
! check Hvo

use chcc_global, only: Hvoc, no, nv, Q21, T1c
use stdalloc, only: mma_allocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Hvo(nv,no)
integer(kind=iwp) :: a, b, bad, i, j, tot
real(kind=wp) :: s

call mma_allocate(Hvoc,nv,no,label='Hvoc')

bad = 0
tot = 0

do i=1,no
  do a=1,nv

    s = Zero

    do j=1,no
      do b=1,nv
        s = s+(Two*Q21(b,j,a,i)-Q21(b,i,a,j))*T1c(b,j)
      end do
    end do

    Hvoc(a,i) = s

    if (abs(Hvo(a,i)-s) > 1.0e-10_wp) bad = bad+1
    tot = tot+1

  end do
end do

write(u6,*) ' Hvo Chck :',bad

return

end subroutine Chck_Hvo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Vqr(LUQRP,MPLBL,ISIM,ZETA,NZ,OPMAT)
! Matrix of the atomic quasi-relativistic potential in the
! 1-center basis set. Mass-velocity and Darwin potentials,
! which are read from the library in atomic units.

use Constants, only: Zero, Two, Three, Pi
use AMatrix, only: DFAC
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LUQRP, ISIM, NZ
character(len=20), intent(in) :: MPLbl
real(kind=wp), intent(in) :: ZETA(NZ)
real(kind=wp), intent(out) :: OPMAT(NZ*(NZ+1)/2)
integer(kind=iwp), parameter :: MPoint = 250
integer(kind=iwp) :: I, IJ, istatus, J, k, N, N2P1, Npoint
character(len=80) :: Line
character(len=40) :: DumCha, Keyw
character(len=4) :: OrbLab
real(kind=wp) :: ERRE, ERRE2, FI(Mpoint), FIVFJ(Mpoint), PREN, R(Mpoint), RES, RNORI, RNORJ, V(Mpoint), ZI, ZJ
real(kind=wp), external :: SIMPLM
character(len=40), external :: RdName

N = ISIM

! Reads the Mass Velocity and Darwin potentials for the valence orbitals

!WRITE(u6,600) ISIM,LUQRP

! locate the beginning of the data
KEYW = MPLBL
DUMCHA = RDNAME(LUQRP,KEYW)
if (DUMCHA == ' ') then
  write(u6,'(1X,A20," MV & DW potentials not found in unit ",I3)') KEYW,LUQRP
  call Quit_OnUserError()
end if
!write(u6,*) 'Data found in libray. Start reading.'
read(LUQRP,*) Npoint
if (NPOINT > MPoint) then
  write(u6,*) 'VQR: nPoint',nPoint
  write(u6,*) 'Abend: Increade mPoint'
  call Quit_OnUserError()
end if
read(LUQRP,'(4d20.13)') (R(k),k=1,Npoint)

do
  read(LUQRP,'(a80)',iostat=istatus) Line
  if (istatus < 0) call Error()
  if (Line(1:8) == MPLbl(1:8)) then
    ! there is no potential for this symmetry
    !write(u6,603)
    OPMAT(:) = Zero
    return
  else
    read(Line,'(a4)') OrbLab
    read(LUQRP,'(4d20.13)') (V(k),k=1,Npoint)

    ! check the symmetry
    if (((index(ORBLAB,'S') == 0) .or. (ISIM == 1)) .and. ((index(ORBLAB,'P') == 0) .or. (ISIM == 2)) .and. &
        ((index(ORBLAB,'D') == 0) .or. (ISIM == 3)) .and. ((index(ORBLAB,'F') == 0) .or. (ISIM == 4))) exit
  end if
end do
!write(u6,601) ORBLAB,NPOINT,R(1),R(NPOINT)

! Matrix of a numerical local operator V(r) given in a logarithmic mesh

PREN = Two**(N+1)/(sqrt(DFAC(2*N)*sqrt(Two*PI)))
N2P1 = 2*N+1
IJ = 0

do I=1,NZ
  ZI = ZETA(I)
  RNORI = PREN*sqrt(sqrt(ZI**N2P1))
  do K=1,NPOINT
    ERRE = R(K)
    FI(K) = RNORI*ERRE**(N-1)*exp(-ZI*ERRE*ERRE)
  end do

  do J=1,I
    ZJ = ZETA(J)
    RNORJ = PREN*sqrt(sqrt(ZJ**N2P1))
    do K=1,NPOINT
      ERRE = R(K)
      ERRE2 = ERRE*ERRE
      FIVFJ(K) = RNORJ*ERRE**(N-1)*exp(-ZJ*ERRE2)*FI(K)*V(K)*ERRE2
    end do

    RES = SIMPLM(NPOINT,FIVFJ,R)

    ! add up the contribution from 0 to R(1)
    IJ = IJ+1
    OPMAT(IJ) = RES+FIVFJ(1)*R(1)/Three
  end do
end do

return

!600   FORMAT (/1X,'Symmetry ',I1,' : ','Mass Velocity and Darwin potentials are read from unit ',I2)
!601   FORMAT (/' Orbital ',A4,' : ',I5,' points in the logarithmic mesh from ',F10.6,' to ',F10.6)
!602   FORMAT (/1X,' The symmetry label of one of the relativistic potentials is not S, P, D, or F')
!603   FORMAT (/1X,' There is no potential for this symmetry.')

contains

subroutine Error()

  write(u6,*) ' Troubles reading MV and DW potentials from QRP library'
  call Quit_OnUserError()

end subroutine Error

end subroutine Vqr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_OPFVEC(ISYM,IOPT)
!
! Purpose: open/close files for full storage vectors, sym. ISYM.

use Symmetry_Info, only: Mul
use Cholesky, only: LUFV, nSym, REONAM
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ISYM, IOPT
integer(kind=iwp) :: ISYMA, ISYMB, LUNIT
character(len=6) :: FNAME
character(len=*), parameter :: SECNAM = 'CHO_OPFVEC'

if (IOPT == 0) then
  LUFV(1:NSYM,1:NSYM) = -1
else if (IOPT == 1) then
  do ISYMB=1,NSYM
    ISYMA = MUL(ISYMB,ISYM)
    if (ISYMA >= ISYMB) then
      write(FNAME,'(A4,I1,I1)') REONAM,ISYMA,ISYMB
      LUNIT = 7
      call DANAME_MF_WA(LUNIT,FNAME)
      LUFV(ISYMA,ISYMB) = LUNIT
      LUFV(ISYMB,ISYMA) = LUNIT
    end if
  end do
else if (IOPT == 2) then
  do ISYMB=1,NSYM
    ISYMA = MUL(ISYMB,ISYM)
    if (ISYMA >= ISYMB) then
      LUNIT = LUFV(ISYMA,ISYMB)
      call DACLOS(LUNIT)
      LUFV(ISYMA,ISYMB) = -1
      LUFV(ISYMB,ISYMA) = -1
    end if
  end do
else
  call CHO_QUIT('IOPT error in '//SECNAM,104)
end if

end subroutine CHO_OPFVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine TestLoc(irc)
! Author: T.B. Pedersen
!
! Purpose: test localisation:
!
!          1) CC^T = XX^T ?
!          2) U=C^TSX , UU^T = diag ?
!          3) If C^TSC=1, X^TSX=1 ?
!
!          where C are the original MOs and X the localised ones.
!
!          Return codes: irc=0 (all OK), irc=1 (failure).

use Localisation_globals, only: CMO, LocPAO, MOrig, nBas, nFro, nOrb2Loc, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(out) :: irc
#include "debug.fh"
integer(kind=iwp) :: i, iComp, iOpt, ip0, iSyLbl, iSym, j, jrc, kC, kC1, kD, kOff, kSqr, kTri, kU, lOaux, lOvlp, lScr, lUmat, &
                     mErr, nB2, nErr, nTO
real(kind=wp) :: Tol, Tst, xErr, xNrm
character(len=80) :: Txt
character(len=8) :: Label
logical(kind=iwp) :: Prnt
real(kind=wp), allocatable :: DenC(:), DenX(:), Ddff(:), Oaux(:), Ovlp(:), Scr(:), Umat(:)
character(len=*), parameter :: SecNam = 'TestLoc'
integer(kind=iwp), external :: iPrintLevel
real(kind=r8), external :: ddot_

call Untested('TestLoc')

! Set return code.
! ----------------

irc = 0

! Set tolerance; allow more deviation for PAOs.
! ---------------------------------------------

if (LocPAO) then
  Tol = 1.0e-4_wp
else
  Tol = 1.0e-6_wp
end if

! Get the AO overlap matrix.
! --------------------------

lOvlp = nBas(1)**2
lOaux = 4+nBas(1)*(nBas(1)+1)/2
do iSym=2,nSym
  lOvlp = lOvlp+nBas(iSym)**2
  lOaux = lOaux+nBas(iSym)*(nBas(iSym)+1)/2
end do
call mma_allocate(Ovlp,lOvlp,label='TstOvlp')
call mma_allocate(Oaux,lOaux,label='TstOaux')
jrc = -1
iOpt = 2
iComp = 1
iSyLbl = 1
Label = 'Mltpl  0'
call RdOne(jrc,iOpt,Label,iComp,Oaux,iSyLbl)
if (jrc /= 0) then
  write(Txt,'(A,I4)') 'RdOne returned',jrc
  call SysAbendMsg(SecNam,'I/O error!',Txt)
end if
Prnt = Debug .and. (iPrintLevel(-1) >= 5)
kTri = 1
kSqr = 1
do iSym=1,nSym
  call Tri2Rec(Oaux(kTri),Ovlp(kSqr),nBas(iSym),Prnt)
  kTri = kTri+nBas(iSym)*(nBas(iSym)+1)/2
  kSqr = kSqr+nBas(iSym)**2
end do
call mma_deallocate(Oaux)

! Memory allocation.
! ------------------

lUmat = nOrb2Loc(1)**2
lScr = nBas(1)*nOrb2Loc(1)
do iSym=2,nSym
  lUmat = lUmat+nOrb2Loc(iSym)**2
  lScr = max(lScr,nBas(iSym)*nOrb2Loc(iSym))
end do
call mma_allocate(DenC,lOvlp,label='DenC')
call mma_allocate(DenX,lOvlp,label='DenX')
call mma_allocate(Ddff,lOvlp,label='Ddff')
call mma_allocate(Scr,lScr,label='Scratch')
call mma_allocate(Umat,lUmat,label='Umat')

! Test 1) density.
! ----------------

nErr = 0

kD = 1
kC = 1
do iSym=1,nSym
  kC1 = kC+nBas(iSym)*nFro(iSym)
  call GetDens_Localisation(DenC(kD),MOrig(kC1),nBas(iSym),nOrb2Loc(iSym))
  call GetDens_Localisation(DenX(kD),CMO(kC1),nBas(iSym),nOrb2Loc(iSym))
  nB2 = nBas(iSym)**2
  call dCopy_(nB2,DenC(kD),1,Ddff(kD),1)
  call dAXPY_(nB2,-One,DenX(kD),1,Ddff(kD),1)
  xNrm = sqrt(dDot_(nB2,Ddff(kD),1,Ddff(kD),1))
  if (xNrm > Tol) then
    write(u6,'(A,A,D16.8,A,I2,A)') SecNam,': ERROR: ||CC^T - XX^T|| = ',xNrm,' (sym.',iSym,')'
    nErr = nErr+1
  end if
  kD = kD+nB2
  kC = kC+nB2
end do
if (nErr /= 0) then
  call Error(1) ! exit, after de-allocations
  return
end if

! Test 2) U^TU = diag.
! --------------------

nErr = 0

kU = 1
kC = 1
do iSym=1,nSym
  kC1 = kC+nBas(iSym)*nFro(iSym)
  call GetUmat_Localisation(Umat(kU),MOrig(kC1),Ovlp(kC),CMO(kC1),Scr,nBas(iSym),nOrb2Loc(iSym))
  nTO = max(nOrb2Loc(iSym),1)
  call DGEMM_('T','N',nOrb2Loc(iSym),nOrb2Loc(iSym),nOrb2Loc(iSym),One,Umat(kU),nTO,Umat(kU),nTO,Zero,Scr,nTO)
  xErr = -huge(xErr)
  ip0 = 0
  do j=1,nOrb2Loc(iSym)
    kOff = ip0+nOrb2Loc(iSym)*(j-1)
    do i=j+1,nOrb2Loc(iSym)
      Tst = abs(Scr(kOff+i))
      xErr = max(xErr,Tst)
    end do
  end do
  if (xErr > Tol) then
    write(u6,'(A,A,D16.8,A,I2,A)') SecNam,': ERROR: max. U^TU off-diag. = ',xErr,' (sym.',iSym,')'
    nErr = nErr+1
  end if
  nB2 = nBas(iSym)**2
  kU = kU+nOrb2Loc(iSym)**2
  kC = kC+nB2
end do
if (nErr /= 0) then
  call Error(1) ! exit, after de-allocations
  return
end if

! Test 3) X^TSX=1.
! ----------------

nErr = 0

kU = 1
kC = 1
do iSym=1,nSym
  kC1 = kC+nBas(iSym)*nFro(iSym)
  call GetUmat_Localisation(Umat(kU),MOrig(kC1),Ovlp(kC),MOrig(kC1),Scr,nBas(iSym),nOrb2Loc(iSym))
  mErr = 0
  xErr = -huge(xErr)
  ip0 = kU-1
  do j=1,nOrb2Loc(iSym)
    kOff = ip0+nOrb2Loc(iSym)*(j-1)
    Tst = abs(Umat(kOff+j)-One)
    if (Tst > Tol) then
      mErr = mErr+1
    end if
    do i=j+1,nOrb2Loc(iSym)
      Tst = abs(Umat(kOff+i))
      xErr = max(xErr,Tst)
    end do
  end do
  if (xErr > Tol) then
    mErr = mErr+1
  end if
  if (mErr == 0) then
    call GetUmat_Localisation(Umat(kU),CMO(kC1),Ovlp(kC),CMO(kC1),Scr,nBas(iSym),nOrb2Loc(iSym))
    xErr = -huge(xErr)
    ip0 = kU-1
    do j=1,nOrb2Loc(iSym)
      kOff = ip0+nOrb2Loc(iSym)*(j-1)
      Tst = abs(Umat(kOff+j)-One)
      if (Tst > Tol) then
        mErr = mErr+1
      end if
      do i=j+1,nOrb2Loc(iSym)
        Tst = abs(Umat(kOff+i))
        xErr = max(xErr,Tst)
      end do
    end do
    if (xErr > Tol) then
      write(u6,'(A,A,D16.8,A,I2,A)') SecNam,': ERROR: max. X^TSX off-diag. = ',xErr,' (sym.',iSym,')'
      mErr = mErr+1
    end if
    if (mErr /= 0) nErr = nErr+1
  else
    write(u6,*) SecNam,': original orbitals not orthonormal!'
    write(u6,*) 'Orthonormality test is skipped (sym. ',iSym,')'
  end if
  nB2 = nBas(iSym)**2
  kU = kU+nOrb2Loc(iSym)**2
  kC = kC+nB2
end do
if (nErr /= 0) then
  call Error(1) ! exit, after de-allocations
  return
end if

! De-allocations and return.
! --------------------------

call Error(0)

contains

subroutine Error(code)
  integer(kind=iwp), intent(in) :: code
  if (code /= 0) irc = code
  call mma_deallocate(Ovlp)
  call mma_deallocate(DenC)
  call mma_deallocate(DenX)
  call mma_deallocate(Ddff)
  call mma_deallocate(Scr)
  call mma_deallocate(Umat)
end subroutine Error

end subroutine TestLoc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FMMM(A,B,C,NROW,NCOL,NSUM)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NROW,NSUM),B(NSUM,NCOL),C(NROW,NCOL)
      PARAMETER (KS=48)
C
      DO 100 I = 1, NROW
         DO 200 J = 1, NCOL
            C(I,J) = 0.0D0
 200     CONTINUE
 100  CONTINUE
C
      DO 300 KK = 1, NSUM, KS
         DO 400 I = 1, NROW
            DO 500 J = 1, NCOL
               T = C(I,J)
               DO 600 K = KK,MIN(KK+KS-1,NSUM)
                  T = T + B(K,J) * A(I,K)
 600           CONTINUE
               C(I,J) = T
 500        CONTINUE
 400     CONTINUE
 300  CONTINUE
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine momloc2(N,NL,nneq,neq,neqv,r_rot,nsites,nexch,W,Z,dipexch,s_exch,dipso,s_so)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero, cOne, gElectron
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, NL, nneq, neq(nneq), neqv, nsites, nexch(nneq)
real(kind=wp), intent(in) :: R_rot(NNEQ,neqv,3,3), W(N)
complex(kind=wp), intent(in) :: Z(N,N), dipexch(3,N,N), s_exch(3,N,N), dipso(nneq,3,NL,NL), s_so(nneq,3,NL,NL)
integer(kind=iwp) :: i, i1, ib(N,nsites), icod(nsites), icoord(nsites), isite, iss1, j, j1, jss1, k, L, nb1, nb2, nind(nsites,2), &
                     nmult, norder
real(kind=wp) :: E_thres, gtens(3), H, maxes(3,3), st(3), zJ
real(kind=wp), allocatable :: JM(:,:,:), LM(:,:,:), MM(:,:,:), RWORK(:), SM(:,:,:), WM(:)
complex(kind=wp), allocatable :: aux(:,:,:), HZEE(:), TMP(:,:), VL(:,:), W_c(:), WORK(:), ZM(:,:)
real(kind=wp), parameter :: g_e = -gElectron
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
integer(kind=iwp) :: iss, jEnd, m
character(len=60) :: fmtline
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: DBG = _DBG_

if (N > 1) return

call mma_allocate(WM,N,'WM')
call mma_allocate(MM,nsites,3,N,'MM')
call mma_allocate(LM,nsites,3,N,'LM')
call mma_allocate(SM,nsites,3,N,'SM')
call mma_allocate(JM,nsites,3,N,'JM')
call mma_allocate(ZM,N,N,'ZM')
call mma_allocate(VL,N,N,'VL')
call mma_allocate(TMP,N,N,'TMP')
! temporary arrays used in ZEEM_SA:
call mma_allocate(RWORK,(3*N-2),'ZEEM_RWORK')
call mma_allocate(HZEE,(nTri_Elem(N)),'ZEEM_HZEE')
call mma_allocate(WORK,(2*N-1),'ZEEM_WORK')
call mma_allocate(W_c,N,'ZEEM_W_c')

! initialisations:
isite = 0
nind = 0
do i=1,nneq
  do j=1,neq(i)
    isite = isite+1
    nind(isite,1) = i
    nind(isite,2) = j
  end do
end do
isite = 0
icod = 0
icod(1) = 1
do i=2,nsites
  isite = nind(i-1,1)
  icod(i) = icod(i-1)*nexch(isite)
end do
ib = 0
do i=1,N
  j = i-1
  do isite=1,nsites
    k = nsites-isite+1
    ib(i,k) = j/icod(k)
    j = j-ib(i,k)*icod(k)
  end do
end do
! find the multiplicity of the low-lying group of states,
! energy threshold E_thres = 1.0e-2 cm-1;
nmult = 0
E_thres = 1.0e-3_wp
do i=1,N
  if (abs(W(i)-W(1)) < E_thres) nmult = nmult+1
end do
if (nmult < 2) nmult = 2 !minimum value needed to compute g-tensor
! find the main magnetic axes of this manifold:
if (N < nmult) then
  ! FIXME: this is a hack, atens should be made to work with size 1
  call mma_allocate(aux,3,nmult,nmult,label='aux')
  aux(:,:,:) = cZero
  aux(:,1:N,1:N) = dipexch(:,:,:)
  call atens(aux,nmult,gtens,maxes,1)
  call mma_deallocate(aux)
else
  call atens(dipexch,nmult,gtens,maxes,1)
end if
#ifdef _DEBUGPRINT_
write(u6,'(A)') 'MOMLOC2:  g tensor of the ground manifold:'
write(u6,*)
write(u6,'((A,F12.6,A,3F12.7))') 'gX=',gtens(1),' axis X: ',(maxes(j,1),j=1,3)
write(u6,'((A,F12.6,A,3F12.7))') 'gY=',gtens(2),' axis Y: ',(maxes(j,2),j=1,3)
write(u6,'((A,F12.6,A,3F12.7))') 'gZ=',gtens(3),' axis Z: ',(maxes(j,3),j=1,3)
#endif
! construct the Zeeman matrix in the lowest N exchange states  and diagonalize it
st(:) = Zero
H = 1.0e-4_wp ! tesla
zJ = Zero ! absence of intermolecular interaction
call zeem_sa(N,H,maxes(1,3),maxes(2,3),maxes(3,3),W,dipexch,s_exch,ST,zJ,WM,ZM,DBG,RWORK,HZEE,WORK,W_c)
!cc  eigenvectors
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,'(a)') repeat('%',96)
write(u6,'(10x,a)') 'MOMLOC2:  EigenVectors of the Total Magnetic Interaction'
write(u6,'(a)') repeat('%',96)

write(u6,'(A,16A)') '-',('---',m=1,nsites),'|',('---------------------------|',i=1,4)
write(fmtline,'(A,i2,A)') '(1x,',nsites,'A,39x,A,38x,A)'
write(u6,fmtline) ('   ',m=1,nsites),'eigenvectors of the exchange matrix','|'
do J=1,N,4
  jEnd = min(N,J+3)
  write(u6,'(A,16A)') '-',('---',m=1,nsites),'|',('---------------------------|',i=j,jEnd)

  write(u6,'(A,5A)') 'Exch.  |',('      exchange state       |',i=j,jEnd)

  write(u6,'(A,6A)') 'basis  |',('                           |',i=j,jEnd)
  write(u6,'(A,6(a,i5,a))') 'on site|',('         ',i,'             |',i=j,jEnd)
  write(fmtline,'(A,i2,A)') '(A,',nsites,'i3,a,6(a,f19.12,2x,a))'
  write(u6,fmtline) ' ',(i,i=1,nsites),'|',('  E =',wm(i)-wm(1),' |',i=j,jEnd)

  write(u6,'(A,16A)') '-',('---',m=1,nsites),'|',('----- Real ------- Imag ---|',i=j,jEnd)

  write(fmtline,'(A,i2,A)') '(A,',nsites,'i3,A,5(2F13.9,1x,a))'
  do iss=1,N
    write(u6,fmtline) '<',(ib(iss,m)+1,m=1,nsites),'|',(ZM(iss,i),'|',i=j,jEnd)
  end do  !iss
  write(u6,'(A,16A)') '-',('---',m=1,nsites),'|',('---------------------------|',i=j,jEnd)
  write(u6,*)
end do ! j
#endif

! generate the exchange basis:
do isite=1,nsites
  do L=1,3
    VL(:,:) = Zero
    do nb1=1,N
      icoord(:) = ib(nb1,:)
      i1 = nind(isite,1)
      j1 = nind(isite,2)
      iss1 = ib(nb1,isite)+1

      do jss1=1,nexch(i1)
        icoord(isite) = jss1-1
        nb2 = norder(icoord,icod,nsites)
        VL(nb1,nb2) = VL(nb1,nb2)+r_rot(i1,j1,l,1)*dipso(i1,1,iss1,jss1)+r_rot(i1,j1,l,2)*dipso(i1,2,iss1,jss1)+ &
                      r_rot(i1,j1,l,3)*dipso(i1,3,iss1,jss1)
      end do  ! jss1
    end do  ! nb1
    ! rotate this matrix to exchange basis:
    call ZGEMM_('C','N',N,N,N,cOne,Z,N,VL,N,cZero,TMP,N)
    call ZGEMM_('N','N',N,N,N,cOne,TMP,N,Z,N,cZero,VL,N)
    ! rotate this matrix to Zeeman basis:
    call ZGEMM_('C','N',N,N,N,cOne,ZM,N,VL,N,cZero,TMP,N)
    call ZGEMM_('N','N',N,N,N,cOne,TMP,N,ZM,N,cZero,VL,N)
    do i=1,N
      MM(isite,L,i) = real(VL(i,i))
    end do
    ! spin moment
    VL(:,:) = Zero
    do nb1=1,N
      icoord(:) = ib(nb1,:)
      i1 = nind(isite,1)
      j1 = nind(isite,2)
      iss1 = ib(nb1,isite)+1

      do jss1=1,nexch(i1)
        icoord(isite) = jss1-1
        nb2 = norder(icoord,icod,nsites)
        VL(nb1,nb2) = VL(nb1,nb2)+r_rot(i1,j1,l,1)*s_so(i1,1,iss1,jss1)+r_rot(i1,j1,l,2)*s_so(i1,2,iss1,jss1)+ &
                      r_rot(i1,j1,l,3)*s_so(i1,3,iss1,jss1)
      end do  ! jss1
    end do  ! nb1
    ! rotate this matrix to exchange basis and to Zeeman basis
    call ZGEMM_('C','N',N,N,N,cOne,Z,N,VL,N,cZero,TMP,N)
    call ZGEMM_('N','N',N,N,N,cOne,TMP,N,Z,N,cZero,VL,N)
    call ZGEMM_('C','N',N,N,N,cOne,ZM,N,VL,N,cZero,TMP,N)
    call ZGEMM_('N','N',N,N,N,cOne,TMP,N,ZM,N,cZero,VL,N)
    do i=1,N
      SM(isite,L,i) = real(VL(i,i))
    end do
  end do  ! L
end do  ! isite
! compute and print the calculated expectation values:
write(u6,*)
write(u6,'(A)') 'EXPECTATION VALUES'
write(u6,'(5A)') '--------|----|',('------------------------------|',i=1,4)
write(u6,'(A)') 'Exchange|Site|   MAGNETIC MOMENT (M=-L-2S)  |        SPIN MOMENT (S)       |      ORBITAL MOMENT (L)      |'// &
                '     TOTAL MOMENT (J=L+S)     |'
write(u6,'(5A)') ' state  | Nr.|',('     X         Y         Z    |',i=1,4)
write(u6,'(5A)') '--------|----|',('------------------------------|',i=1,4)
do i=1,N
  ! we proceed to compute expectation values for this nb1 exchange state
  LM(:,:,i) = -MM(:,:,i)-g_e*SM(:,:,i)
  JM(:,:,i) = LM(:,:,i)+SM(:,:,i)

  do isite=1,nsites
    if (isite == (nsites+1)/2) then
      write(u6,'(i5,3x,A,1x,i2,1x,A,4(3(F9.5,1x),A))') i,'|',isite,'|',MM(isite,1,i),MM(isite,2,i),MM(isite,3,i),'|', &
                                                       SM(isite,1,i),SM(isite,2,i),SM(isite,3,i),'|',LM(isite,1,i),LM(isite,2,i), &
                                                       LM(isite,3,i),'|',JM(isite,1,i),JM(isite,2,i),JM(isite,3,i),'|'
    else
      write(u6,'(8x,A,1x,i2,1x,A,4(3(F9.5,1x),A))') '|',isite,'|',MM(isite,1,i),MM(isite,2,i),MM(isite,3,i),'|',SM(isite,1,i), &
                                                    SM(isite,2,i),SM(isite,3,i),'|',LM(isite,1,i),LM(isite,2,i),LM(isite,3,i), &
                                                    '|',JM(isite,1,i),JM(isite,2,i),JM(isite,3,i),'|'
    end if
  end do
  write(u6,'(5A)') '--------|----|',('------------------------------|',i1=1,4)
end do

! deallocate temporary arrays:
call mma_deallocate(WM)
call mma_deallocate(MM)
call mma_deallocate(LM)
call mma_deallocate(SM)
call mma_deallocate(JM)
call mma_deallocate(ZM)
call mma_deallocate(VL)
call mma_deallocate(TMP)
call mma_deallocate(RWORK)
call mma_deallocate(HZEE)
call mma_deallocate(WORK)
call mma_deallocate(W_c)

return

end subroutine momloc2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TdmTrans(nBas)

use qmstat_global, only: iPrint, MoAveRed, MxSymQ, nRedMO, NrFiles, NrStates, nState, RassiM, EigV
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBas(MxSymQ)
integer(kind=iwp) :: i, iDisk, j, kaunt, Lu, nStatePrim
character(len=6) :: TDMchar
logical(kind=iwp) :: Exists
real(kind=wp), allocatable :: Eig2(:,:), NonH(:), NonS(:)
#include "warnings.h"

! Sag hej till publiken.

write(u6,*)
write(u6,*) '     Transforming the transition density matrices.'

! Inquire if the ToFile is in WorkDir.

call f_Inquire(RassiM,Exists)
if (.not. Exists) then
  write(u6,*)
  write(u6,*) 'No Transition density matrix file found.'
  write(u6,*) 'Did you use the TOFIle keyword in RASSI?'
  call Quit(_RC_IO_ERROR_READ_)
end if
call f_Inquire(EigV,Exists)
if (.not. Exists) then
  write(u6,*)
  write(u6,*) 'No Rassi eigenvectors found.'
  write(u6,*) 'Did you use the TOFIle keyword in RASSI?'
  call Quit(_RC_IO_ERROR_READ_)
end if

! Compute number of 'primitive' states.

nStatePrim = 0
do i=1,NrFiles
  nStatePrim = nStatePrim+NrStates(i)
end do

! Open EigV file and read information.

Lu = 92
call DaName(Lu,EigV)
iDisk = 0

! Read RASSCF overlap and H-matrix.

call mma_allocate(NonH,nTri_Elem(nStatePrim),label='NonOrtH')
call mma_allocate(NonS,nTri_Elem(nStatePrim),label='NonOrtS')
kaunt = 0
do i=1,nStatePrim
  do j=1,i
    kaunt = kaunt+1
    call dDaFile(Lu,2,NonH(kaunt),1,iDisk)
  end do
end do
kaunt = 0
do i=1,nStatePrim
  do j=1,i
    kaunt = kaunt+1
    call dDaFile(Lu,2,NonS(kaunt),1,iDisk)
  end do
end do
if (iPrint >= 10) then
  call TriPrt('RASSCF Hamiltonian',' ',NonH,nStatePrim)
  call TriPrt('RASSCF Overlaps',' ',NonS,nStatePrim)
end if
call DaClos(Lu)

! Construct CASSI state basis.

call mma_allocate(Eig2,nStatePrim,nStatePrim,label='RedEigV1')
call ContRASBas(nStatePrim,NonH,NonS,Eig2)
call mma_deallocate(NonH)
call mma_deallocate(NonS)

! Now transform from 'primitive' RASSCF to 'contracted' RASSI states.

call RasRasTrans(nBas(1),nStatePrim,Eig2,iPrint)
call mma_deallocate(Eig2)

! If requested, obtain reduced MO-basis, otherwise just go as usual.

if (MoAveRed) then
  call MoReduce(nBas,nRedMO)
  write(TDMchar,'(A)') 'TDMSCR'
  call FetchTDM(nRedMO,nState,TDMchar)
else
  write(u6,*) '     ----- Use AO-representation of the transition density matrix.'
  nRedMO = 0 !Only a dummy.
end if

! Finished!

write(u6,*) '     ...Done!'

return

end subroutine TdmTrans

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
*               1993, Per Ake Malmqvist                                *
*               Pavel Neogrady                                         *
************************************************************************
       Subroutine RdInpPN(run_triples,run_sort)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     - read input                                                     *
*     - set defaults                                                   *
*                                                                      *
*     calling parameters: none                                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and P.-AA. Malmqvist                              *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*     reduced by P.N.                                                  *
*                                                                      *
************************************************************************
       Implicit Real*8 (A-H,O-Z)


#include "SysDef.fh"
#include "ccsort.fh"
#include "reorg.fh"
#include "motra.fh"
*
       Real*8 Weights(mxRoot)
       Parameter ( nCmd =20 )
       Character*4 Command,Cmd(nCmd)
       Character*72  Line,Blank
       Data Cmd /'TITL','END ','CCSD','CCT ','CLOS',
     &           'OPEN','FROZ','DELE','PRIN','NOOP','IOKE','ZROF',
     &           'DENO','SHIF','ACCU','ADAP','EXTR','TRIP','NOSO',
     &           'ITER'/
       Logical run_triples,run_sort

*
*---  Initialize -------------------------------------------------------*
       Do i=1,72
       Blank(i:i)=' '
       End Do
       LROOT=0
       MAXIT=0
       CONV=1.0D-06
       THRSHN=1.0D-10
       THRSHS=1.0D-08
       THRSHF=0.05D0
       ORBIN='DEFAULT '
       THRENE=1.50D0
       ORBIT='DEFAULT '
       THROCC=0.0D0
       FOCKTYPE='STANDARD'
       HZERO='STANDARD'
       METHOD='CONJ'
       IFJAC=0
       RFpert=.false.
       CITHR=0.05D00
       NTIT=0
c
       lunsta=21
       luna1=22
       luna2=23
       luna3=24
       luna4=25
       lunab=50
       lunt3=26
       lunda1=9
       lunda2=10
c
*---  Open JOBIPH and LUONEM files ------------------------------------*
*
*.    Job interface
       JOBIPH=15
*.    Job interface
       CALL DANAME(JOBIPH,'JOBIPH')
*
*---  Read input from JOBIPH file -------------------------------------*
       IAD15=0
       CALL iDAFILE(JOBIPH,2,IADR15,15,IAD15)
cDIVNUO
       IAD15=IADR15(1)
       CALL WR_RASSCF_Info(JOBIPH,2,iAd15,
     &                     NACTEL,ISPIN,NSYM,LSYM,
     &                     NFRO,NISH,NASH,NDEL,NBAS,8,
     &                     NAME,LENIN8*MXORB,
     &                     NCONF,HEADER,2*72,
     &                     TITLE,4*18*MXTIT,POTNUC,
     &                     LROOTS,NROOTS,IROOT,MXROOT,NRAS1,
     &                     NRAS2,NRAS3,NHOLE1,NELE3,IPT2,Weights)
       SPIN=DBLE(ISPIN-1)/2
c
c     define defaults for REORG
c
       ntAsh = 0
       do isym = 1,nSym
         ntAsh = ntAsh+nAsh(iSym)
       end do
       cckey=1
       t3key=1
       clopkey=1
       if ( ntAsh.eq.0 ) clopkey=2
       do nhelp=1,nsym
         ndelr(nhelp)=NDEL(nhelp)
         nfror(nhelp)=NFRO(nhelp)
       end do
       maxsize=0
CGG       fullprint=0
       noop=0
       iokey=1
       zrkey=1
       run_triples=.true.
       run_sort=.true.
*
*---  Read input from TRAONE file -------------------------------------*
      Call RdTraOne
      Do iSym=1,nSym
        nFror(iSym) = nFroX(iSym)
        nDelr(iSym) = nDelX(iSym)
      End Do
*
*---  Read input from LuSpool -----------------------------------------*
      LuSpool = 17
      Call SpoolInp(LuSpool)
      Rewind(LuSpool)
       Command='&REO'
       Call RdNlst(LuSpool,'CCSDT')
 10    Read(LuSpool,'(A)',End=9910) Line
       If ( Line(1:1).eq.'*' ) Goto 10
       If ( Line.eq.Blank ) Goto 10
       Command=Line(1:4)
       Call UpCase(Command)
       jCmd=0
       Do iCmd=1,nCmd
       If ( Command.eq.Cmd(iCmd) ) jCmd=iCmd
       End Do
       If ( jCmd.eq.0 ) Goto 9930
 20     Goto (100,2100,200,300,400,500,600,700,900,1000,1100,1200,
     & 1300,1400,1500,1600,1700,1800,1900,2000) jCmd
*
*---  process TITLE    command ----------------------------------------*
 100   continue
       Read(LuSpool,'(A)',End=9910) Line
       Command=Line(1:4)
       Call UpCase(Command)
       If ( Command(1:1).eq.'*' ) Goto 100
       jCmd=0
       Do iCmd=1,nCmd
       If ( Command.eq.Cmd(iCmd) ) jCmd=iCmd
       End Do
       If ( jCmd.ne.0 ) Goto 20
       if (nTit.ge.mxTit) Goto 100
       nTit=nTit+1
       If ( nTit.le.mxTit ) Read (Line,'(18A4)') (Title(nTit,i),i=1,18)
       Goto 100
c---  CCSD command ------------
 200   continue
       cckey=1
       t3key=0
       run_triples=.false.
       goto 100
c---  CCT  command ------------
 300   continue
       cckey=1
       t3key=1
       run_triples=.true.
       goto 100
c---  CLOSed  command ------------
 400   continue
       clopkey=2
       goto 100
c---  OPEN  command ------------
 500   continue
       clopkey=1
       goto 100
c---  FROZen  command ------------
 600   continue
       read (LuSpool,*) (nfror(nhelp),nhelp=1,nsym)
       goto 100
c---  DELEte  command ------------
 700   continue
       read (LuSpool,*) (ndelr(nhelp),nhelp=1,nsym)
       goto 100
*
c---  PRINt  command ------------
 900   continue
       read (LuSpool,*) fullprint
       goto 100
*
c---  NOOPeration  command ------------
 1000  continue
       noop=1
       goto 100
*
c---  IOKEy  command ------------
 1100  continue
       read (LuSpool,*) iokey
       if ((iokey.lt.1).or.(iokey.gt.2)) then
       iokey=2
       end if
       goto 100
*
c---  ZROFf  command ------------
 1200  continue
       zrkey=0
       goto 100

c---  DENO command ---------
1300  continue
      goto 100
*
c---  SHIF command ---------
1400  continue
      goto 100
c---  ACCU command ---------
1500  continue
      goto 100
c---  ADAP command ---------
1600  continue
      goto 100
c---  EXTR command ---------
1700  continue
      goto 100
c---  TRIP command ---------
1800  continue
      goto 100
c---  NOSOrt  command ------------
1900   continue
       run_sort=.false.
       goto 100
c---  ITER command ---------
2000  continue
      goto 100
*
*
*---  The end of the input section, complete input processing ---------*
 2100  continue
       NFROT=0
       NISHT=0
       NASHT=0
       NRAS1T=0
       NRAS2T=0
       NRAS3T=0
       NOSHT=0
       NSSHT=0
       NDELT=0
       NORBT=0
       NBAST=0
       NBAS2=0
       NORB1=0
       DO ISYM=1,NSYM
         NIES(ISYM)=NISHT
         NAES(ISYM)=NASHT
         NSES(ISYM)=NSSHT
         NOSH(ISYM)=NISH(ISYM)+NASH(ISYM)
         NSSH(ISYM)=NBAS(ISYM)-NFRO(ISYM)-NOSH(ISYM)-NDEL(ISYM)
         NORB(ISYM)=NOSH(ISYM)+NSSH(ISYM)
         NORBT=NORBT+NORB(ISYM)
         NBAS2=NBAS2+NBAS(ISYM)**2
         NORB1=NORB1+(NORB(ISYM)**2+NORB(ISYM))/2
         NFROT=NFROT+NFRO(ISYM)
         NISHT=NISHT+NISH(ISYM)
         NASHT=NASHT+NASH(ISYM)
         NOSHT=NOSHT+NOSH(ISYM)
         NRAS1T=NRAS1T+NRAS1(ISYM)
         NRAS2T=NRAS2T+NRAS2(ISYM)
         NRAS3T=NRAS3T+NRAS3(ISYM)
         NSSHT=NSSHT+NSSH(ISYM)
         NDELT=NDELT+NDEL(ISYM)
         NBAST=NBAST+NBAS(ISYM)
       END DO
*
*---  Identify the wave function type ---------------------------------*
       ISCF=0
       IF(NASHT.EQ.0) ISCF=1
       IF(NACTEL.EQ.2*NASHT) ISCF=1
       if ( iSpin.gt.1 )  then
         IF((ISPIN.EQ.NACTEL+1).AND.(NACTEL.EQ.NASHT)) ISCF=2
       end if
c
c     test agreement between REORG input and JOBIPH
c       if (clopkey.ne.(3-ISCF)) then
c         write(6,*) ' Diference in closed/open specification'
c         write(6,*) ' Plaese, correct REORG input file'
c         write(6,*)   clopkey,ISCF
c         Call Quit(16)
c       end if
*
c      Should not be necessary anymore, let's just hardwire it in.
c      This will save a keyword
       clopkey = 3-ISCF
*---  Identify the reference function ---------------------------------*
       IF(ISCF.GT.0) THEN
       LROOT=1
       NROOTS=1
       IROOT(1)=1
       END IF
       IF(LROOT.EQ.0 .AND. NROOTS.EQ.1) LROOT=IROOT(1)
*
*---  Create the symmetry multiplication table ------------------------*
       MUL(1,1)=1
       M=1
       DO N=1,3
         DO I=1,M
           DO J=1,M
             MUL(I+M,J)=M+MUL(I,J)
             MUL(I,J+M)=MUL(I+M,J)
             MUL(I+M,J+M)=MUL(I,J)
           END DO
         END DO
         M=2*M
       END DO
       Call Close_LuSpool(LuSpool)

*
*
*---  Exit ------------------------------------------------------------*
       Return
*
*---  Error exits -----------------------------------------------------*
 9910  Write(6,*)
       Write(6,*) ' *** input error ***'
       Write(6,*) ' hitting end of file mark'
       Write(6,*)
       Call Quit_OnUserError()
 9930  Write(6,*)
       Write(6,*) ' *** input error ***'
       Write(6,*) ' unknown input'
       Write(6,*) ' line: ',Line
       Write(6,*)
       Call Quit_OnUserError()
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine mean_field( EXCH, N, H, X,Y,Z, zJ, T, W, thrs,
     &                       dM, sM, ST, dbg )

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)

      Integer, intent(in)          :: EXCH, N
      Real(kind=8), intent(in)    :: H, X,Y,Z, zJ, T
      Real(kind=8), intent(in)    :: thrs
      Real(kind=8), intent(in)    :: W(EXCH)
      Complex(kind=8), intent(in) :: DM(3,EXCH,EXCH)
      Complex(kind=8), intent(in) :: SM(3,EXCH,EXCH)
      Logical, intent(in)          :: dbg
      ! output
      Real(kind=8), intent(out)   :: ST(3)

      Integer                      :: iopt

      iopt=2

      If (iopt .eq. 1) Then

          If (dbg) Write(6,'(A)') 'mean_field: enter mean_field_exch'
          Call  mean_field_exch( N, H, X,Y,Z, zJ, T, thrs, W(1:N),
     &                           DM(1:3,1:N,1:N), SM(1:3,1:N,1:N), ST )
          If (dbg) Write(6,'(A)') 'mean_field: exit mean_field_exch'

      Else If (iopt .eq. 2) Then

          If (dbg) Write(6,'(A)') 'mean_field: enter mean_field_all'
          Call  mean_field_all( EXCH, N, H, X,Y,Z, zJ, T, thrs,
     &                          W, DM, SM, ST )
          If (dbg) Write(6,'(A)') 'mean_field: exit mean_field_all'

      Else

         Write(6,'(A)') 'MEAN_FIELD:  iopt is not defined:', iopt

      End If

      Return
      End subroutine mean_field







      Subroutine mean_field_exch( N, H, X,Y,Z, zJ, T, thrs, W,
     &                               dM, sM, ST )
!     this Subroutine computes the mean field of neighboring spins ST(3)
!     for zJ .ne. 0.0_wp
!     using ONLY Zeeman basis (N)

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)

      Integer, intent(in)       :: N
      Real(kind=8), intent(in) :: H, X,Y,Z, zJ, T, W(N)
      Complex(kind=8), intent(in) :: DM(3,N,N), SM(3,N,N)
      ! output
      Real(kind=8), intent(out) :: ST(3)

#include "stdalloc.fh"
      ! local variables:
      Integer :: i, l, mxIter, iter
      Logical :: DBG
      Real(kind=8)    :: WM(N), S(3), ZB, SCHK, THRS, SL(3)
      Complex(kind=8) :: ZM(N,N), SZ(3,N,N)
      Real(kind=8), allocatable :: RWORK(:)
      Complex(kind=8), allocatable :: HZEE(:), WORK(:), W_c(:)

      DBG=.false.

      MxIter=100
      THRS = 1.0D-12
      SCHK = 0.0_wp
      S = 0.0_wp
      ST = 0.0_wp

      ! temporary arrays used in ZEEM_SA:
      Call mma_allocate(RWORK,(3*N-2),'ZEEM_RWORK')
      Call mma_allocate(HZEE,(N*(N+1)/2),'ZEEM_HZEE')
      Call mma_allocate(WORK,(2*N-1),'ZEEM_WORK')
      Call mma_allocate(W_c,N,'ZEEM_W_c')

      ! zero everything:
      Call dcopy_(3*N-2,[0.0_wp],0,RWORK,1)
      Call zcopy_(N*(N+1)/2,[(0.0_wp,0.0_wp)],0,HZEE,1)
      Call zcopy_(2*N-1,[(0.0_wp,0.0_wp)],0,WORK,1)
      Call zcopy_(N,[(0.0_wp,0.0_wp)],0,W_c,1)
      ! determine first the average spin of neighboring
      ! molecules for each temperature point
      Do iter=1,mxIter
          WM(1:N) = 0.0_wp
          ZM(1:N,1:N) =(0.0_wp,0.0_wp)
          ! build and diagonalize the Zeeman Hamiltonian (size N x N)
          ! for the field direction (X,Y,Z) and strength (H)
          Call ZEEM_SA( N, H, X,Y,Z,  W(1:N), dM(1:3,1:N,1:N),
     &               sM(1:3,1:N,1:N), ST(1:3), zJ,
     &               WM(1:N), ZM(1:N,1:N),
     &               DBG, RWORK, HZEE, WORK, W_c )
          !Write(6,'(A,3ES16.8)') 'WM:',(WM(l),l=1,N)
          !Write(6,'(A,9(2ES16.8,2x))') 'ZM:',((ZM(l,i),l=1,N),i=1,N)
          ! transform the spin momenta to the Zeeman eigenstate basis
          SZ(1:3,1:N,1:N)=(0.0_wp,0.0_wp)
          Call UTMU( N, N, ZM(1:N,1:N), SM(1:3,1:N,1:N),
     &                                  SZ(1:3,1:N,1:N) )
!         compute the spin magnetization vector at this temperature (T):
          If(iter==mxIter) Then
            SL=0.0_wp
            SL(1)=S(1)
            SL(2)=S(2)
            SL(3)=S(3)
          End If
          Do l=1,3
            S(l)=0.0_wp
            ZB=0.0_wp
            Call calcmagn1( N, WM(1:N), SZ(l,1:N,1:N), T, S(l), ZB )
          End Do


          ! check if average spin is converged
          SCHK=0.0_wp
          Do L=1,3
            SCHK = SCHK + SQRT( (S(L)-ST(L))*(S(L)-ST(L)) )
          End Do

          If(DBG) Write(6,'(A,i4,1x,A,3ES20.10,2x,A,3ES20.10)')
     &                    'ST:   End of iteration',iter,':',
     &                    (ST(l),l=1,3),'DIFF:',(S(l)-ST(l) ,l=1,3)
          If(DBG) Write(6,'(A,i4,1x,A,3ES20.10,2x,A,3ES20.10)')
     &                    'SCHK: End of iteration',iter,':',SCHK

          ! decide to continue the iterative process or exit
          If( SCHK < THRS ) Then
             Go To 1001
          Else
             Do l=1,3
                ST(l)=0.0_wp
                ST(l)=S(l)
             End Do
          End If
        End Do ! iter


        Write(6,'(A, ES24.14)') 'This message shows that the '//
     &                          'average spin did NOT converge '//
     &                          'after 100 iterations. Temp.(in K)=',T
        Write(6,'(A,4ES24.14)') 'Field: (X, Y, Z), and (H):',X,Y,Z,H
        Write(6,'(A,4ES24.14)') 'Last values of the average spin: '//
     &                          '(Sx,Sy,Sz):',(ST(i),i=1,3)
        Write(6,'(A,4ES24.14)') 'Last values of the deviation:    '//
     &                          '          :',(SL(i)-ST(i),i=1,3)
        Write(6,'(A,4ES24.14)') 'Absolute value of the deviation: '//
     &                          '          :',SCHK
        Write(6,'(A,4ES24.14)') 'Convergence threshold:    THRS = '//
     &                          '          :',THRS
        Write(6,'(A         )') 'The program will continue, using '//
     &                          'the last value of the average spin'


        Return
1001  Continue

      ! deallocate temporary data:
      Call mma_deallocate(RWORK)
      Call mma_deallocate(HZEE)
      Call mma_deallocate(WORK)
      Call mma_deallocate(W_c)

      Return
      End subroutine mean_field_exch











      Subroutine mean_field_all( EXCH, N, H, X,Y,Z, zJ, T, thrs, W,
     &                           dM, SM, ST)
!     this Subroutine computes the mean field of neighboring spins ST(3)
!     for zJ .ne. 0.0_wp
!     using ONLY Zeeman basis (N)

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)

      Integer, intent(in)          :: EXCH, N
      Real(kind=8), intent(in)    :: H, X,Y,Z, zJ, T, W(EXCH)
      Complex(kind=8), intent(in) :: DM(3,EXCH,EXCH), SM(3,EXCH,EXCH)
      ! output
      Real(kind=8), intent(out) :: ST(3)

#include "stdalloc.fh"
      ! local variables:
      Integer :: i, l, mxIter, iter
      Logical :: DBG
      Real(kind=8)    :: WM(EXCH), S(3), ZB, SCHK, THRS, SL(3)
      Complex(kind=8) :: ZM(N,N), SZ(3,EXCH,EXCH)
      Real(kind=8), allocatable :: RWORK(:)
      Complex(kind=8), allocatable :: HZEE(:), WORK(:), W_c(:)

      DBG=.false.

      MxIter=100
      THRS = 1.0D-12
      SCHK = 0.0_wp
      S = 0.0_wp
      ST = 0.0_wp

      ! temporary arrays used in ZEEM_SA:
      Call mma_allocate(RWORK,(3*N-2),'ZEEM_RWORK')
      Call mma_allocate(HZEE,(N*(N+1)/2),'ZEEM_HZEE')
      Call mma_allocate(WORK,(2*N-1),'ZEEM_WORK')
      Call mma_allocate(W_c,N,'ZEEM_W_c')

      ! zero everything:
      Call dcopy_(3*N-2,[0.0_wp],0,RWORK,1)
      Call zcopy_(N*(N+1)/2,[(0.0_wp,0.0_wp)],0,HZEE,1)
      Call zcopy_(2*N-1,[(0.0_wp,0.0_wp)],0,WORK,1)
      Call zcopy_(N,[(0.0_wp,0.0_wp)],0,W_c,1)
      ! determine first the average spin of neighboring
      ! molecules for each temperature point
      Do iter=1,mxIter
          WM(1:N) = 0.0_wp
          ZM(1:N,1:N) =(0.0_wp,0.0_wp)
          ! build and diagonalize the Zeeman Hamiltonian (size N x N)
          ! for the field direction (X,Y,Z) and strength (H)
          Call ZEEM_SA( N, H, X,Y,Z,  W(1:N), dM(1:3,1:N,1:N),
     &               sM(1:3,1:N,1:N), ST(1:3), zJ,
     &               WM(1:N), ZM(1:N,1:N),
     &               DBG, RWORK, HZEE, WORK, W_c  )
          If(N.ne.EXCH) Then
            Do i=N+1,EXCH
                WM(i)=W(i)
            End Do
          End If

!         transform the spin momenta to the Zeeman eigenstate basis
          Call zcopy_(3*EXCH*EXCH,[(0.0_wp,0.0_wp)],0,SZ,1)
          Call UTMU( EXCH, N, ZM(1:N,1:N), SM, SZ )
!         compute the spin magnetization vector at this temperature (T):
          If(iter==mxIter) Then
            SL=0.0_wp
            SL(1)=S(1)
            SL(2)=S(2)
            SL(3)=S(3)
          End If


          ZB=0.0_wp
          S(1:3)=0.0_wp
          If (N.eq.EXCH) Then
            Do L=1,3
                Call calcmagn1( EXCH, WM, SZ(l,1:EXCH,1:EXCH),
     &                          T, S(l), ZB)
            End Do
          Else
            Do L=1,3
               Call calcmagn2( EXCH, N, WM, T, H,
     &                         SZ, X, Y, Z,
     &                         L, S(l), ZB)
             End Do
          End If


          ! check if average spin is converged
          SCHK=0.0_wp
          Do L=1,3
            SCHK = SCHK + SQRT( (S(L)-ST(L))*(S(L)-ST(L)) )
          End Do

          If(DBG) Write(6,'(A,i4,1x,A,3ES20.10,2x,A,3ES20.10)')
     &                    'ST:   End of iteration',iter,':',
     &                    (ST(l),l=1,3),'DIFF:',(S(l)-ST(l) ,l=1,3)
          If(DBG) Write(6,'(A,i4,1x,A,3ES20.10,2x,A,3ES20.10)')
     &                    'SCHK: End of iteration',iter,':',SCHK

          ! decide to continue the iterative process or exit
          If( SCHK < THRS ) Then
             Go To 1001
          Else
             Do l=1,3
                ST(l)=0.0_wp
                ST(l)=S(l)
             End Do
          End If
        End Do ! iter


        Write(6,'(A, ES24.14)') 'This message shows that the '//
     &                          'average spin did NOT converge '//
     &                          'after 100 iterations. Temp.(in K)=',T
        Write(6,'(A,4ES24.14)') 'Field: (X, Y, Z), and (H):',X,Y,Z,H
        Write(6,'(A,4ES24.14)') 'Last values of the average spin: '//
     &                          '(Sx,Sy,Sz):',(ST(i),i=1,3)
        Write(6,'(A,4ES24.14)') 'Last values of the deviation:    '//
     &                          '          :',(SL(i)-ST(i),i=1,3)
        Write(6,'(A,4ES24.14)') 'Absolute value of the deviation: '//
     &                          '          :',SCHK
        Write(6,'(A,4ES24.14)') 'Convergence threshold:    THRS = '//
     &                          '          :',THRS
        Write(6,'(A         )') 'The program will continue, using '//
     &                          'the last value of the average spin'


        Return
1001  Continue

      ! deallocate temporary data:
      Call mma_deallocate(RWORK)
      Call mma_deallocate(HZEE)
      Call mma_deallocate(WORK)
      Call mma_deallocate(W_c)


      Return
      End subroutine mean_field_all

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               2024, Matthew R. Hennefarth                            *
!***********************************************************************

subroutine close_files_mcpdft()

use Fock_util_global, only: docholesky
use general_data, only: jobiph, jobold, luintm
use Definitions, only: iwp, u6

implicit none
#include "warnings.h"
integer(kind=iwp) :: iOpt, return_code

!---  close the JOBOLD file -------------------------------------------*
if ((JOBOLD > 0) .and. (JOBOLD /= JOBIPH)) then
  call DaClos(JOBOLD)
  JOBOLD = -1
else if (JOBOLD > 0) then
  JOBOLD = -1
end if
!---  close the JOBIPH file -------------------------------------------*
if (JOBIPH > 0) then
  call DaClos(JOBIPH)
  JOBIPH = -1
end if
!---  close the ORDINT file -------------------------------------------*
if (.not. DoCholesky) then
  return_code = -1
  call ClsOrd(return_code)
  if (return_code /= _RC_ALL_IS_WELL_) call WarningMessage(1,'Failed to close the ORDINT file.')
end if
!---  close the file carrying the transformed two-electron integrals --*
call DaClos(LUINTM)

!--- close the one-electorn integral file
return_code = -1
iOpt = 0
call clsone(return_code,iOpt)
if (return_code /= _RC_ALL_IS_WELL_) then
  write(u6,*) 'Error when trying to close the one-electron integral file.'
  call abend()
end if

end subroutine close_files_mcpdft

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine span1_cvb(c,nvec,s,n,metr)

use casvb_global, only: nvecmx, nvtot, span
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nvec, n, metr
real(kind=wp), intent(in) :: c(n,nvec), s(*)
integer(kind=iwp) :: nvmove, nvremain

nvremain = nvec
do
  nvmove = min(nvremain,nvecmx-nvtot)
  if ((nvmove == 0) .and. (nvremain > 0)) then
    write(u6,*) ' Fatal error in SPAN_CVB!',nvmove,nvremain
    call abend_cvb()
  end if
  span(:,nvtot+1:nvtot+nvmove) = c(:,nvec-nvremain+1:nvec-nvremain+nvmove)
  nvtot = nvtot+nvmove
  if (nvtot == nvecmx) call span_cvb(span,nvtot,nvtot,s,n,metr)
  nvremain = nvremain-nvmove
  if (nvremain <= 0) exit
end do

return

end subroutine span1_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine CloseR
************************************************************************
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             September '90                                            *
************************************************************************
      use vRys_RW
      use Leg_RW
      Implicit Real*8 (A-H,O-Z)
#include "stdalloc.fh"
*
#ifdef _RYS_SCRATCH_
      Call UnSetAux()
#endif
      If (.Not.Allocated(iHerW2)) Return
      Call mma_deallocate(iHerW2)
      Call mma_deallocate(iHerR2)
      Call mma_deallocate(HerW2)
      Call mma_deallocate(HerR2)
      Call mma_deallocate(Cff)
      Call mma_deallocate(x0)
      Call mma_deallocate(Map)
      call mma_deallocate(ddx)
      Call mma_deallocate(TMax)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ComputeGMat(iAtomPair,M,G)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Compute G matrix for given atom pair:
C
C        G[JK] = (J|K)
C
C     where J and K are auxiliary functions of atom pair iAtomPair,
C     J,K=1,2,3,....,M.
C
C     M is the total number of auxiliary functions (1C and 2C) minus the
C     number of linearly dependent functions, as computed by the
C     function LDF_nBasAux_Pair(iAtomPair).
C
      Implicit None
      Integer iAtomPair
      Integer M
      Real*8  G(M,M)
#include "ldf_atom_pair_info.fh"
#include "localdf_mem.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      Character*15 SecNam
      Parameter (SecNam='LDF_ComputeGMat')
      Logical  isSymmetric, hasNonnegativeDiagonal, obeysCauchySchwarz
      External isSymmetric, hasNonnegativeDiagonal, obeysCauchySchwarz
      Integer irc
#endif

      Integer iAtom, jAtom
      Integer iS, jS, klS, uvS, nnShl
      Integer ipi, ipj
      Integer iShell, jShell, kShell, lShell, uShell, vShell, dShell
      Integer nAuxShell_i, nAuxShell_j
      Integer l_IndxG, l_IndxG2, l_2CList
      Integer ip_SewWrk, l_SewWrk
      Integer l_G

      Logical IndxG_Here

      Integer  LDF_nAuxShell_Atom
      Integer  LDF_lAuxShell_Atom
      External LDF_nAuxShell_Atom
      External LDF_lAuxShell_Atom

      External Integral_WrOut_LDF_G

      Integer i, j
      Integer AP_Atoms
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Check if G indexation needs to be done; if so, do it.
      l_IndxG=l_IndxG_1*l_IndxG_2
      l_IndxG2=l_IndxG2_1*l_IndxG2_2
      l_2CList=l_2CList_1*l_2CList_2
      IndxG_Here=l_IndxG.lt.1.and.l_IndxG2.lt.1.and.l_2CList.lt.1
      If (IndxG_Here) Then
         Call LDF_SetIndxG(iAtomPair)
      End If

      ! Allocate memory for Seward
      Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
      l_SewWrk = min(l_SewWrk,MaxLDFSew)
      Call xSetMem_Ints(l_SewWrk)

      ! Get atoms of pair
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)

      ! Compute G matrix
      nRow_G=M
      l_G=M*M
      Call FZero(G,l_G)
      dShell=nShell_Valence+nShell_Auxiliary+1
      SHA=dShell
      SHC=dShell
      ipi=LDF_lAuxShell_Atom(iAtom)-1
      nAuxShell_i=LDF_nAuxShell_Atom(iAtom)
      Do jS=1,nAuxShell_i
         jShell=iWork(ipi+jS)
         SHD=jShell
         Do iS=jS,nAuxShell_i
            iShell=iWork(ipi+iS)
            SHB=iShell
            Call Eval_IJKL(dShell,iShell,dShell,jShell,G,l_G,
     &                     Integral_WrOut_LDF_G)
         End Do
      End Do
      If (jAtom.ne.iAtom) Then
         ipj=LDF_lAuxShell_Atom(jAtom)-1
         nAuxShell_j=LDF_nAuxShell_Atom(jAtom)
         Do jS=1,nAuxShell_j
            jShell=iWork(ipj+jS)
            SHD=jShell
            Do iS=1,nAuxShell_i
               iShell=iWork(ipi+iS)
               SHB=iShell
               Call Eval_IJKL(dShell,iShell,dShell,jShell,G,l_G,
     &                        Integral_WrOut_LDF_G)
            End Do
         End Do
         Do jS=1,nAuxShell_j
            jShell=iWork(ipj+jS)
            SHD=jShell
            Do iS=jS,nAuxShell_j
               iShell=iWork(ipj+iS)
               SHB=iShell
               Call Eval_IJKL(dShell,iShell,dShell,jShell,G,l_G,
     &                        Integral_WrOut_LDF_G)
            End Do
         End Do
      End If
      If (AP_2CFunctions(1,iAtomPair).gt.0) Then
         nnShl=l_2CList_2
         Do uvS=0,nnShl-1
            uShell=iWork(ip_2CList+3*uvS)
            vShell=iWork(ip_2CList+3*uvS+1)
            SPCD=iWork(ip_2CList+3*uvS+2)
            SHC=uShell
            SHD=vShell
            Do iS=1,nAuxShell_i
               iShell=iWork(ipi+iS)
               SHB=iShell
               Call Eval_IJKL(dShell,iShell,uShell,vShell,G,l_G,
     &                        Integral_WrOut_LDF_G)
            End Do
         End Do
         If (jAtom.ne.iAtom) Then
            ipj=LDF_lAuxShell_Atom(jAtom)-1
            nAuxShell_j=LDF_nAuxShell_Atom(jAtom)
            Do uvS=0,nnShl-1
               uShell=iWork(ip_2CList+3*uvS)
               vShell=iWork(ip_2CList+3*uvS+1)
               SPCD=iWork(ip_2CList+3*uvS+2)
               SHC=uShell
               SHD=vShell
               Do jS=1,nAuxShell_j
                  jShell=iWork(ipj+jS)
                  SHB=jShell
                  Call Eval_IJKL(dShell,jShell,uShell,vShell,G,l_G,
     &                           Integral_WrOut_LDF_G)
               End Do
            End Do
         End If
         Do klS=0,nnShl-1
            kShell=iWork(ip_2CList+3*klS)
            lShell=iWork(ip_2CList+3*klS+1)
            SPCD=iWork(ip_2CList+3*klS+2)
            SHC=kShell
            SHD=lShell
            Do uvS=klS,nnShl-1
               uShell=iWork(ip_2CList+3*uvS)
               vShell=iWork(ip_2CList+3*uvS+1)
               SPAB=iWork(ip_2CList+3*uvS+2)
               SHA=uShell
               SHB=vShell
               Call Eval_IJKL(uShell,vShell,kShell,lShell,G,l_G,
     &                        Integral_WrOut_LDF_G)
            End Do
         End Do
      End If

      ! Release Seward memory
      Call xRlsMem_Ints()

      ! Unset G indexation (if it was set here)
      If (IndxG_Here) Then
         Call LDF_UnsetIndxG()
      End If

#if defined (_DEBUGPRINT_)
      ! Check G matrix for symmetry and non-negative diagonals
      ! and Cauchy-Schwarz inequality
      irc=0
      If (.not.isSymmetric(G,M,1.0d-15)) Then
         Write(6,'(A,A)')
     &   SecNam,': G matrix is not symmetric!'
         irc=irc+1
      End If
      If (.not.hasNonnegativeDiagonal(G,M)) Then
         Write(6,'(A,A)')
     &   SecNam,': G matrix has negative diagonals!'
         irc=irc+1
      End If
      If (.not.obeysCauchySchwarz(G,M,1.0d-14)) Then
         Write(6,'(A,A)')
     &   SecNam,
     &   ': G matrix does not obey the Cauchy-Schwarz inequality!'
         irc=irc+1
      End If
      If (irc.ne.0) Then
         Write(6,'(A,A)')
     &   SecNam,': => G matrix not PSD!!'
         Call LDF_Quit(1)
      End If
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRFSBTAB(IFSBTAB)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IFSBTAB(*)
integer(kind=iwp) :: IFSB, ISPART, ISTA, KPOS, NASPRT, NDET, NFSB, NHEAD

if (IFSBTAB(2) /= 73) then
  write(u6,*) ' PRFSBTAB error: Not a Fock Sector Block Table.'
  write(u6,*) ' Table type code  =',IFSBTAB(2)
  call ABEND()
end if
write(u6,*)
write(u6,*) '============================================='
write(u6,*) ' Fock Sector Table printout'
write(u6,'(a,i9)') '               Table size:',IFSBTAB(1)
write(u6,'(a,i9)') '          Table type code:',IFSBTAB(2)
write(u6,'(a,i9)') ' Nr of Fock Sector Blocks:',IFSBTAB(3)
write(u6,'(a,i9)') '      Nr of Subpartitions:',IFSBTAB(4)
write(u6,'(a,i9)') ' Total nr of Determinants:',IFSBTAB(5)
write(u6,'(a,i9)') '        Hash Map Capacity:',IFSBTAB(6)
write(u6,'(a,i9)') '        Hash Map 1st word:',IFSBTAB(7)
write(u6,*)
write(u6,*) 'FS Block   BlkSiz    Start indx     Substring Types'
NFSB = IFSBTAB(3)
NASPRT = IFSBTAB(4)
NHEAD = 7
KPOS = NHEAD+1
do IFSB=1,NFSB
  NDET = IFSBTAB(KPOS+NASPRT)
  ISTA = IFSBTAB(KPOS+NASPRT+1)
  write(u6,'(1X,I6,3X,I7,3x,I10,5X,10I4)') IFSB,NDET,ISTA,(IFSBTAB(KPOS-1+ISPART),ISPART=1,NASPRT)
  KPOS = KPOS+NASPRT+2
end do
write(u6,*) '============================================='

return

end subroutine PRFSBTAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Out_Pt2(iKapDisp,iCIDisp)
********************************************************************
*                                                                  *
********************************************************************
      use Arrays, only: CMO
      use ipPage, only: W
      Implicit Real*8 (a-h,o-z)
#include "detdim.fh"
#include "Input.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "disp_mclr.fh"
#include "cicisp_mclr.fh"
#include "stdalloc.fh"
#include "real.fh"
#include "sa.fh"
#include "dmrginfo_mclr.fh"
#include "SysDef.fh"
      Character*8 Method
      Logical CI, Is_Roots_Set
      Character(LEN=80) Note
! Added for DMRG calculation
      real*8,allocatable::tmpDe(:,:),tmpP(:),tmpDeM(:,:),tmpPM(:,:,:,:)
      Integer iKapDisp(nDisp),iCiDisp(nDisp)
      Character(Len=16) mstate
      Dimension rdum(1),idum(7,8)
      Real*8, Allocatable:: D_K(:), Tmp(:), K1(:), K2(:), DAO(:),
     &                      D_CI(:), D1(:), P_CI(:), P1(:), Conn(:),
     &                      OCCU(:), CMON(:), DTmp(:), G1q(:), G1m(:),
     &                      Temp(:), tTmp(:), DM(:), DMs(:)
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
       isym=1
       CI=.true.
       Call Setup_MCLR(iSym)
       nbas_tot=0
       ntot1=0
       nDLMO=0
       nLCMO=0
       Do is=1,nsym
          nbas_tot=nbas_tot+nbas(is)
          ntot1=ntot1+nbas(is)*(nbas(is)+1)/2
          nDLMO=nDLMO+nash(is)
          nLCMO=nLCMO+nbas(is)*nbas(is)
       End Do
       nNAC=(nDLMO+nDLMO**2)/2
       nDLMO=nDLMO*(nDLMO+1)/2
       nPLMO=nDLMO*(nDLMO+1)/2
*
       Call mma_allocate(K1,  nDens2,Label='K1')
       Call mma_allocate(K2,  nDens2,Label='K2')
       Call mma_allocate(DAO,nDens2,Label='DAO')
       Call mma_allocate(D_CI,n1Dens,Label='D_CI')
       Call mma_allocate(D1,n1Dens,Label='D1')
       Call mma_allocate(P_CI,n2Dens,Label='P_CI')
       Call mma_allocate(P1,n2Dens,Label='P1')
       Call mma_allocate(Conn,nDens2,Label='Conn')
       Call mma_allocate(OCCU,nbas_tot,Label='OCCU')
       Call mma_allocate(CMON,ndens2,Label='CMON')
*      OBS nBuf might not be def.
       Call mma_MaxDBLE(nBuf)
       Call mma_allocate(Dtmp,nDens2,Label='DTmp')

*
*
*
* 1)   CI Part
*
*      All multipliers are introduced as densities
*

       If (CI) Then
         nconf1=ncsf(State_sym)
         ilen=nconf1*nroots ! nroot = # of roots in SA
         ipcip=ipget(nconf1*nroots)
         iDisk=iCIDisp(1)
         irc=ipin(ipCIp)
         Call dDaFile(LuTemp,2,W(ipCIp)%Vec,iLen,iDisk)
*
*-------Calculate the densities that correct the nonvariational CI stuff
*
         Call CIDens_sa(.true.,ipCIp,ipCI,
     &                  State_sym,State_sym,
     &                  P_CI,D_CI) ! \bar{d} and \bar{D}

! ======================================================================
         if(doDMRG)then  ! yma
           call dmrg_dim_change_mclr(LRras2(1:8),ntash,0)
           call dmrg_dim_change_mclr(RGras2(1:8),ndim,0)

           call mma_allocate(tmpDe,ndim,ndim,Label='TmpDe')
           call mma_allocate(tmpP,ndim**2*(ndim**2+1)/2,Label='tmpP')
           call mma_allocate(tmpDeM,ntash,ntash,Label='tmpDeM')
           call mma_allocate(tmpPM,ntash,ntash,ntash,ntash,
     &                       Label='tmpPM')
           tmpDe=0.0d0
           tmpP=0.0d0
           tmpDeM=0.0d0
           tmpPM=0.0d0

           ij=0
           do i=1,ntash
             do j=1,ntash
               ij=ij+1
               if(abs(D_CI(ij)).lt.1.0e-12)then
                 D_CI(ij)=0.0d0
               end if
               tmpDeM(i,j)=D_CI(ij)
             end do
           end do

           ij=0
           do i=1,ndim
             do j=1,ndim
               ij=ij+1
               if(i.gt.ntash.or.j.gt.ntash)then
                 tmpDe(i,j)=0.0d0
               else
                 tmpDe(i,j)=tmpDeM(i,j)
               end if
             end do
           end do

           Do i=1,ntash
             Do j=1,ntash
               Do k=1,ntash
                 Do l=1,ntash
                   ij1=ntash*(i-1)+j
                   ij2=ntash*(j-1)+i
                   kl1=ntash*(k-1)+l
                   kl2=ntash*(l-1)+k
                   if(ij1.ge.kl1)then
                   if(abs(P_CI(itri(ij1,kl1))).lt.1.0e-12)then
                     P_CI(itri(ij1,kl1))=0.0d0
                   end if
                   tmpPM(i,j,k,l)=P_CI(itri(ij1,kl1))
                   end if
                 End Do
               End Do
             End Do
           End Do

           do i=1,ndim
             do j=1,ndim
               do k=1,ndim
                 do l=1,ndim
                   ij1=ndim*(i-1)+j
                   ij2=ndim*(j-1)+i
                   kl1=ndim*(k-1)+l
                   kl2=ndim*(l-1)+k
                   if(ij1.ge.kl1)then
         if(i.gt.ntash.or.j.gt.ntash.or.k.gt.ntash.or.l.gt.ntash)then
                       tmpP(itri(ij1,kl1))=0.0d0
                     else
                       tmpP(itri(ij1,kl1))=tmpPM(i,j,k,l)
                     end if
                   end if
                 end do
               end do
             end do
           end do

           ij=0
           do i1=1,ndim
             do j1=1,ndim
               ij=ij+1
               D_CI(ij)=tmpDe(i1,j1)
             end do
           end do
           do i=1,n2dens
             P_CI(i)=tmpP(i)
           end do
           call mma_deallocate(tmpDe)
           call mma_deallocate(tmpDeM)
           call mma_deallocate(tmpP)
           call mma_deallocate(tmpPM)
           call dmrg_dim_change_mclr(RGras2(1:8),
     &                               ntash,0)
         end if
! ===================================================================

*
*-------Some administrative shit
*
*       Store densities in triangular form
*
         Do i=1,ntAsh
          Do j=1,i
           D1(itri(i,j))=D_CI((i-1)*ntash+j)
          End Do
         End Do

         Do i=1,ntAsh
          Do j=1,i
           ij=itri(i,j)
           ij2=i+(j-1)*ntash
           ji2=j+(i-1)*ntash
           Do k=1,i
            Do l=1,k
             kl=itri(k,l)
             kl2=k+(l-1)*ntash
             lk2=l+(k-1)*ntash
             ijkl=itri(ij2,kl2)
             jikl=itri(ji2,kl2)
             ijlk=itri(ij2,lk2)
             jilk=itri(ji2,lk2)
             P1(itri(ij,kl))=Quart*(P_CI(ijkl)+P_CI(jikl)+
     &                              P_CI(ijlk)+P_CI(jilk))
            End Do
           End Do
          End Do
         End Do

        DO  K=1,NTASH
         DO L = 1, K
          KL = K*(K-1)/2 + L
          KLROW = KL*(KL-1)/2
          IF( L .EQ. K ) THEN
           IMAX = K
          ELSE
           IMAX = K-1
          END IF
          DO I = 1,IMAX
           II= I*(I+1)/2
           IIKL= KLROW + II
           P1(IIKL) = P1(IIKL)*Half
          End Do
         End Do
         End Do


C         Do i=1,ntAsh
C         Do j=1,i
C         ij=itri(i,j)
C         ij2=i+(j-1)*ntash
C         ji2=j+(i-1)*ntash
C         Do k=1,ntAsh
C         Do l=1,k
C          kl=itri(k,l)
C          kl2=k+(l-1)*ntash
C          ijkl=itri(ij2,kl2)
C          jikl=itri(ji2,kl2)
C          fact=Half
C          if(ij.ge.kl .and. k.eq.l) fact=Quart
C          if(ij.lt.kl .and. i.eq.j) fact=Quart
C          P1(itri(ij,kl))=
C     &        fact*(P_CI(ijkl)+P_CI(jikl))
C         End Do
C         End Do
C         End Do
C         End Do
C         If (debug) Call triprt('P1',' ',P1,(ntash**2+ntash)/2)
c
c Write the 'bar' densities to disk,  not symmetry blocked.
c

!         Call Put_DLMO(D1,ndim1) ! \bar{D} triangular  ! yma
!         Call Put_PLMO(P1,ndim2) ! \bar{d} triangular  ! yma

         Call Put_DLMO(D1,nDLMO) ! \bar{D} triangular ! original
         Call Put_PLMO(P1,nPLMO) ! \bar{d} triangular ! original
*
       End If
*
*      2) Orbital response
*         ================
*
*       Read in from disk
*
       iDisk=iKapDisp(1)
       Call dDaFile(LuTemp,2,K1,nDensC,iDisk) ! Read \bar{kappa}
       Call Uncompress(K1,K2,1)
c
c If we want to estimate the error
c
       If (esterr) Then
*        Do iestate=1,lroots
*          Call calcerr(K2,iestate)
*        End do
         Call calcerr(K2,istate)
       End If
*
*----- First we fix the renormalization contribution
*
       Call mma_allocate(D_K,nLCMO,Label='D_K')
       Call Get_Fock_Occ(D_K,nLCMO)
*      Calculates the effective Fock matrix
       Call Make_Conn(Conn,K2,P_CI,D_CI)   !D_CI not changed
       Call DaxPy_(ndens2,One,D_K,1,Conn,1)
*      call dcopy_(ndens2,D_K,1,Conn,1)
       Call Put_Fock_Occ(Conn,nTot1)
*
*      Transposed one index transformation of the density
*      (only the inactive density to store it separately)
*
       Call OITD(K2,1,DAO,Dtmp,.False.)
*
*      Transformation to AO basis (covariant)
*
c
c Transforms to AO differently dep on last arg.
c
       Call TCMO(DAO,1,-2)
*
*      Fold AO density and write to disk
c Mult all terms that are not diag by 2
*
       Call FOLD2(nsym,nbas,DAO,K1)
*
       Call Put_DLAO(K1,ntot1)
*
*      Now with active density too, to form the variational density
*
!      gives \tilde{D}
       Call OITD(K2,1,D_K,Dtmp,.True.)
*
       Do iS=1,nsym
c
c C*\tilde{\kappa} --> ipDAO
c
          If (nBas(is).ge.1)
     &       CALL DGEMM_('N','N',
     &                   NBAS(is),NBAS(is),NBAS(is),
     &                   One,CMO(ipCM(is)),NBAS(is),
     &                   K2(ipmat(is,is)),NBAS(is),
     &                   Zero,DAO(ipCM(is)),NBAS(is))
       End Do
*
       Call Put_LCMO(DAO,nLCMO)
*
       if(doDMRG)then  ! yma
         call dmrg_dim_change_mclr(RGras2(1:8),ntash,0)
         call dmrg_spc_change_mclr(RGras2(1:8),nash)
       end if
*
       If (isNAC) Then
         ng1=nNAC
         Call mma_allocate(G1q,ng1,Label='G1q')
         Call Get_D1MO(G1q,ng1)
         iR = 0 ! set to dummy value.
       Else
         iR=iroot(istate)
         jdisk=itoc(3)
         ng1=itri(ntash,ntash)
         ng2=itri(ng1,ng1)
         Call mma_allocate(G1q,n1dens,Label='G1q')
c
c Read active one el dens for state j from JOBIPH and store in G1q
c
         Call Get_cArray('Relax Method',Method,8)
         if(Method.eq.'MSPDFT  ') then
          Call Get_DArray('D1MOt           ',G1q,ng1)
         else
         Do i=1,iR-1  ! Dummy read until state j
           Call dDaFile(LUJOB ,0,rdum,ng1,jDisk)
           Call dDaFile(LUJOB ,0,rdum,ng1,jDisk)
           Call dDaFile(LUJOB ,0,rdum,ng2,jDisk)
           Call dDaFile(LUJOB ,0,rdum,ng2,jDisk)
         End Do
         Call dDaFile(LUJOB ,2,G1q,ng1,jDisk)
         end if
       EndIf
*
*    Construct a variationally stable density matrix. In MO
c
c D_eff = D^j + \tilde{D} +\bar{D}
c D_K = (G1q + inact) + D_K + D_CI
*
C
       If (isNAC) Then
*
** For NAC, first build DAO and then DAO_var
*
         Do is=1,nSym
c Note: no inactive part for transition densities
          Do iA=1,nash(is)
           Do jA=1,nash(is)
            i=iA+nish(is)
            j=jA+nish(is)
            iAA=iA+na(is)
            jAA=jA+na(is)
            D_K(ipmat(is,is)+i-1+(j-1)*nbas(is))=
     &       D_K(ipmat(is,is)+i-1+(j-1)*nbas(is))
     &      +D_CI(iAA+(jAA-1)*ntash)
     &      +G1q(itri(iAA,jAA))
           End Do
          End Do
         End Do
         Call mma_allocate(Temp,nBuf/2,Label='Temp')
         Call NatOrb(D_K,CMO,CMON,OCCU)
         Call dmat_MCLR(CMON,OCCU,Temp)
         Call Put_D1ao_var(Temp,nTot1)
         Call mma_deallocate(Temp)
*
** Transform the antisymmetric transition density matrix to AO
**  (there is no guarantee the symmetry will work here)
*
         iDisk=0
         LuDens=20
         Call DaName(LuDens,'MCLRDENS')
         Call dDaFile(LuDens,2,G1q,ng1,iDisk)
         Call DaClos(LuDens)
         Call mma_allocate(G1m,ndens2,Label='G1m')
         G1m(:)=Zero
* Reconstruct the square matrix
         Do is=1,nSym
          Do iA=1,nash(is)
           i=iA+nish(is)
           iAA=iA+na(is)
           Do jA=1,iA-1
            j=jA+nish(is)
            jAA=jA+na(is)
            G1m(ipmat(is,is)+i-1+(j-1)*nbas(is))=
     &           G1q(itri(iAA,jAA))
            G1m(ipmat(is,is)+j-1+(i-1)*nbas(is))=
     &          -G1q(itri(iAA,jAA))
           End Do
           G1m(ipmat(is,is)+i-1+(i-1)*nbas(is))=Zero
          End Do
         End Do
* Transform
         Call TCMO(G1m,1,-2)
* Save the triangular form
         iOff=0
         Do is=1,nSym
          ibas=nbas(is)
          Do i=1,ibas
           Do j=1,i
            G1m(iOff+itri(i,j))=
     &        G1m(ipmat(is,is)+j-1+(i-1)*nbas(is))
           End Do
          End Do
          iOff=iOff+(ibas*ibas+ibas)/2
         End Do
         Call Put_dArray('D1ao-',G1m,nTot1)
         Call mma_deallocate(G1m)
*
       Else
*
** Normal SA gradient (no NAC)
*
         Do is=1,nSym
          Do i=1,nish(is)
c
c The inactive density
c
           D_K(ipmat(is,is)+i-1+(i-1)*nbas(is))=
     &     D_K(ipmat(is,is)+i-1+(i-1)*nbas(is))+Two
          End DO
          Do iA=1,nash(is)
           Do jA=1,nash(is)
            i=iA+nish(is)
            j=jA+nish(is)
            iAA=iA+na(is)
            jAA=jA+na(is)
c
c The active density G1q and \bar{D}
c
            D_K(ipmat(is,is)+i-1+(j-1)*nbas(is))=
     &       D_K(ipmat(is,is)+i-1+(j-1)*nbas(is))
     &      +D_CI(iAA+(jAA-1)*ntash)
     &      +G1q(itri(iAA,jAA))
           End Do
          End Do
         End Do
c
c Diagonalize the effective density to be able to use Prpt
c OCCU eigenvalues of eff dens
c CMON eigenvectors (new orb coef)
c
         Call NatOrb(D_K,CMO,CMON,OCCU)
         Call mma_Allocate(Tmp,nBuf/2,Label='Tmp')
         Call dmat_MCLR(CMON,OCCU,Tmp)
         Call Put_D1ao_Var(Tmp,nTot1)
         Call mma_deallocate(Tmp)

         Call mma_allocate(TEMP,nNac,Label='TEMP')
         Call mma_allocate(tTmp,nNac,Label='tTmp')
         Call get_D1MO(TEMP,nNac)
         Call get_DLMO(tTmp,nNac)
         Call DaxPy_(nNac,1.0d0,tTmp,1,TEMP,1)
         Call mma_deallocate(TEMP)
         Call mma_deallocate(tTmp)

         Note='var'
         LuTmp=50
         LuTmp=IsFreeUnit(LuTmp)
         Call WrVec('TMPORB',LuTmp,'O',nSym,nBas,nBas,
     &            rDum,OCCU,rDum,iDum,Note)
         Call Prpt()
*                                                                      *
************************************************************************
*        There should now be dipole moments on the runfile which
*        corresponds to the gradient of the energy w.r.t. the
*        electric field. Let's update the list of values stored
*        on the runfile.
*
         Is_Roots_Set = .False.
         Call Qpg_iScalar('Number of roots',Is_Roots_Set)
         nRoots = 1
         If (Is_Roots_Set) Then
            Call Get_iScalar('Number of roots',nRoots)
         End If
*
         If (nRoots.ne.1) Then
*           Write (*,*) 'iR=',iR
            Call mma_allocate(DM,3,Label='DM')
            Call mma_allocate(DMs,3*nROOTS,Label='DMs')
            Call Get_dArray('Last Dipole Moments',DMs,3*nRoots)
*           Call RecPrt('Last Dipole Moments',' ',DMS,3,nRoots)
            Call Get_dArray('Dipole Moment',DM,3)
*           Call RecPrt('Dipole Moment',' ',DM,1,3)
            Call DCopy_(3,DM,1,DMS(1+(iR-1)*3),1)
*           Call RecPrt('Last Dipole Moments',' ',DMS,3,nRoots)
            Call Put_dArray('Last Dipole Moments',DMs,3*nRoots)
            Call mma_deallocate(DMs)
            Call mma_deallocate(DM)
         End If
************************************************************************
*                                                                      *
       End If
       Call mma_deallocate(G1q)
C
c--------------------------  debug -----
c
       if(doDMRG)then ! yma
         call dmrg_dim_change_mclr(LRras2(1:8),ntash,0)
         call dmrg_spc_change_mclr(LRras2(1:8),nash)
       end if

c
c  Write the effective active one el density to disk in the same format as g1q
c
c       Call mma_allocate(Deff_act,ndens2,Label='Deff_act')
c       call dcopy_(nDens2,D_K,1,Deff_act,1)
c       Do is=1,nSym
c        Do i=1,nish(is)
c
c Subtract the inactive density
c
c         Deff_act(ipmat(is,is)+i-1+(i-1)*nbas(is))=
c     &   D_K(ipmat(is,is)+i-1+(i-1)*nbas(is))-Two
c        End Do
c       End Do
c
c      Call Put_DEff(Deff_act,ndens2)
c
c       Call mma_deallocate(Deff_act)
c
c--------------------------------------------------
c
c Diagonalize the effective density to be able to use Prpt
c OCCU eigenvalues of eff dens
c CMON eigenvectors (new orb coef)
c
c      Call NatOrb(D_K,CMO,CMON,OCCU)
c      Call mma_allocate(Temp,nBuf/2,Label='Temp')
c      Call dmat_MCLR(CMON,OCCU,Temp)
c      Call Put_D1ao_Var(Temp,nTot1)
c      Note='var'
c      LuTmp=50
c      LuTmp=IsFreeUnit(LuTmp)
c      Call WrVec('TMPORB',LuTmp,'O',nSym,nBas,nBas,
c    &            Dum,OCCU,Dum,iDum,Note)
c      Call Prpt()

c
c Standard routine, Temp effective dens in AO
c
*       Call dmat_MCLR(CMON,OCCU,Temp)
c
*       Call Put_D1ao_Var(Temp,nTot1)
c      Call mma_deallocate(Temp)

       Call Put_iScalar('SA ready',1)
       If (isNAC) Then
         Write(mstate,'(1X,I7,",",I7)') NACStates(1),NACStates(2)
       Else
         Write(mstate,'(I16)') irlxroot
       End If
       If (override) mstate(1:1)='+'
       Call Put_cArray('MCLR Root',mstate,16)
*
       Call mma_deallocate(K1)
       Call mma_deallocate(K2)
       Call mma_deallocate(DAO)
       Call mma_deallocate(D_CI)
       Call mma_deallocate(D1)
       Call mma_deallocate(P_CI)
       Call mma_deallocate(P1)
       Call mma_deallocate(Conn)
       Call mma_deallocate(OCCU)
       Call mma_deallocate(CMON)
       Call mma_deallocate(Dtmp)
       Call mma_deallocate(D_K)

       irc=ipclose(-1)
*
       Return
#ifdef _WARNING_WORKAROUND_
       If (.False.) Call Unused_integer(irc)
#endif
       End

c --------------------------------------------------------------------------
c
      Subroutine OITD(rK,isym,D,Dtmp,act)
*
      use Arrays, only: G1t
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "real.fh"
#include "sa.fh"
      Real*8 rK(*),D(*),Dtmp(*)
      Logical act
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
      call dcopy_(ndens2,[Zero],0,Dtmp,1)
*
*     Note: even with NAC we set the inactive block,
*     because this is the SA density, not the transition density
      Do iS=1,nSym
        Do iB=1,nIsh(iS)
          Dtmp(1+(ipCM(iS)+(ib-1)*nOrb(iS)+ib-1)-1) = Two
        End Do
      End Do
      If (act) Then
       Do iS=1,nSym
        Do iB=1,nAsh(iS)
         Do jB=1,nAsh(iS)
          Dtmp(1+(ipCM(iS)+ib+nIsh(is)+(jB+nIsh(is)-1)*nOrb(is)-1)-1)=
     &    G1t((itri((nA(is)+ib),(nA(is)+jb))))
         End Do
        End Do
       End Do
      End If
*
      Do iS=1,nsym
         jS=ieor(iS-1,isym-1)+1
         If (nOrb(iS)*nOrb(jS).ge.1) Then
            Call DGEMM_('N','T',nOrb(iS),nOrb(jS),nOrb(iS),One,
     &                 Dtmp(1+ipCM(iS)-1),nOrb(iS),
     &                 rK(ipMat(jS,iS)),nOrb(jS),
     &                 Zero,D(ipMat(iS,jS)),nOrb(iS))
            Call DGEMM_('T','N',nOrb(iS),nOrb(jS),nOrb(jS),-One,
     &                 rK(ipMat(jS,iS)),nOrb(jS),
     &                 Dtmp(1+ipCM(jS)-1),nOrb(jS),
     &                 One,D(ipMat(iS,jS)),nOrb(iS))
         End If
      End Do
      Return
      End
      Subroutine NatOrb(Dens,CMOO,CMON,OCCN)
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
#include "real.fh"
      Real*8 Dens(*),CMOO(*),CMON(*),OCCN(*)
      Real*8, Allocatable:: EVal(:), EVec(:)

      Call mma_allocate(EVec,ndens2,Label='EVec')
      Call mma_allocate(EVal,ndens2,Label='EVal')
C
C         Diagonalize the density matrix and transform orbitals
C
      If (iAnd(kprint,8).eq.8) Then
         Write(6,*)
         Write(6,*) '           Effective natural population '
         Write(6,*) '           ============================ '
         Write(6,*)
      End If
      io=0
      Do is=1,nsym
         ij=0
         Do i=0,nbas(is)-1
            Do j=0,i
               ij=ij+1
               Eval(ij)=Dens(ipMat(is,is)+i+j*nbas(is))
            End DO
         End DO
         EVec(:)=Zero
         Call dCopy_(nBas(is),[One],0,EVec,nbas(is)+1)
         CALL JACOB(EVal,EVec,nbas(is),nbas(is))
         ii=0
         DO i=1,nbas(is)
            ii=ii+i
            OCCN(io+i)=Eval(ii)
         END DO
         IST=IO+1
         IEND=IO+NBAS(is)
         If (iAnd(kprint,2).eq.2)
     &      Write (6,'(6X,A3,I2,A1,10F11.6,/,(12X,10F11.6))')
     &             'sym',iS,':',(OCCN(I),I=IST,IEND)
         If (nBas(is).ge.1)
     &      CALL DGEMM_('N','N',
     &                  NBAS(is),NBAS(is),NBAS(is),
     &                  One,CMOO(ipCM(is)),NBAS(is),
     &                  EVec,NBAS(is),
     &                  Zero,CMON(ipCM(is)),NBAS(is))
         io=io+nbas(is)
      End DO

      Call mma_deallocate(EVec)
      Call mma_deallocate(Eval)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GSTTBL_MCLR(C,CTT,IATP,IASM,IBTP,IBSM,NOCTPA,NOCTPB,NSASO,NSBSO,PSSIGN,ICOOSC,IDC,PLSIGN,LUC,SCR)
! obtain  determinant block (iatp iasm, ibtp ibsm)
! from vector packed in combination format according to IDC

use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: C(*), PSSIGN, PLSIGN
real(kind=wp), intent(_OUT_) :: CTT(*), SCR(*)
integer(kind=iwp), intent(in) :: IATP, IASM, IBTP, IBSM, NOCTPA, NOCTPB, NSASO(NOCTPA,*), NSBSO(NOCTPB,*), &
                                 ICOOSC(NOCTPA,NOCTPB,*), IDC, LUC
integer(kind=iwp) :: IBASE, IDUM(1), IMZERO, ISGVST, LBL, LCOMB, LDET, NAST, NBST, NCI, NCOL, NELMNT, NRI, NROW
real(kind=wp) :: PLSSGN, PSIGN

PSIGN = Zero ! dummy initialize

! =================
! Read in from disc
! =================
if (LUC /= 0) then
  call IFRMDS(IDUM,1,-1,LUC)
  LBL = IDUM(1)
  call FRMDSC_MCLR(SCR,LBL,-1,LUC,IMZERO)
  NAST = NSASO(IATP,IASM)
  NBST = NSBSO(IBTP,IBSM)
  ! ISGVST is undefined
  if (LBL /= 0) call SDCMRF_MCLR_2(CTT,SCR,IATP,IBTP,IASM,IBSM,NAST,NBST,IDC,PSSIGN,PLSIGN,ISGVST,LDET,LCOMB)
  ! ISGVST and PLSIGN missing to make it work for IDC = 3,4
else
  ! ===============
  ! Pack out from C
  ! ===============
  ! Permutation sign
  if (IDC == 2) then
    PSIGN = PSSIGN
  else if (IDC == 3) then
    PSIGN = PLSIGN
  else
    PSIGN = Zero
  end if
  PLSSGN = PLSIGN*PSSIGN
  ! check for different packing possibilities and unpack
  if ((IASM > IBSM) .or. (IDC == 1) .or. ((IDC == 3) .and. (IASM >= IBSM))) then
    !************
    ! IASM > IBSM
    !************
    if (IDC < 4) then
      ! Simple copy
      IBASE = ICOOSC(IATP,IBTP,IASM)
      NELMNT = NSASO(IATP,IASM)*NSBSO(IBTP,IBSM)
      CTT(1:NELMNT) = C(IBASE:IBASE+NELMNT-1)
    else if (IDC == 4) then
      ! MLMS packed
      if (IATP > IBTP) then
        IBASE = ICOOSC(IATP,IBTP,IASM)
        NELMNT = NSASO(IATP,IASM)*NSBSO(IBTP,IBSM)
        CTT(1:NELMNT) = C(IBASE:IBASE+NELMNT-1)
      else if (IATP == IBTP) then
        IBASE = ICOOSC(IATP,IATP,IASM)
        NAST = NSASO(IATP,IASM)
        call TRIPK2_2(CTT,C(IBASE),NAST,NAST,PLSIGN*PSSIGN)
      else if (IATP < IBTP) then
        IBASE = ICOOSC(IBTP,IATP,IASM)
        NROW = NSASO(IBTP,IASM)
        NCOL = NSBSO(IATP,IBSM)
        call TRNSPS(NROW,NCOL,C(IBASE),CTT)
        NELMNT = NROW*NCOL
        CTT(1:NELMNT) = PLSIGN*PSSIGN*CTT(1:NELMNT)
      end if
    end if
  else if (IASM == IBSM) then
    !************
    ! IASM = IBSM
    !************
    if ((IATP > IBTP) .or. (IDC == 3)) then
      ! simple copying
      IBASE = ICOOSC(IATP,IBTP,IASM)
      NELMNT = NSASO(IATP,IASM)*NSBSO(IBTP,IBSM)
      CTT(1:NELMNT) = C(IBASE:IBASE+NELMNT-1)
    else if (IATP == IBTP) then
      ! expand triangular packed matrix
      IBASE = ICOOSC(IATP,IBTP,IASM)
      NAST = NSASO(IATP,IASM)
      call TRIPK2_2(CTT,C(IBASE),NAST,NAST,PSSIGN)
    else if (IATP < IBTP) then
      ! transpose ibtp iasm iatp ibsm block
      IBASE = ICOOSC(IBTP,IATP,IASM)
      NRI = NSASO(IBTP,IASM)
      NCI = NSBSO(IATP,IASM)
      call TRNSPS(NRI,NCI,C(IBASE),CTT)
      if (PSSIGN == -One) CTT(1:NRI*NCI) = -CTT(1:NRI*NCI)
    end if
  else if (IASM < IBSM) then
    !************
    ! IASM < IBSM
    !************
    ! transpose ibtp ibsm iatp iasm block
    if (IDC < 4) then
      IBASE = ICOOSC(IBTP,IATP,IBSM)
      NRI = NSASO(IBTP,IBSM)
      NCI = NSBSO(IATP,IASM)
      if (IDC == 2) then
        call TRNSPS(NRI,NCI,C(IBASE),CTT)
      else if (IDC == 3) then
        CTT(1:NRI*NCI) = C(IBASE:IBASE+NRI*NCI-1)
      end if
      if (PSIGN == -One) CTT(1:NRI*NCI) = -CTT(NRI*NCI)
    else if (IDC == 4) then
      if (IBTP > IATP) then
        IBASE = ICOOSC(IBTP,IATP,IBSM)
        NRI = NSASO(IBTP,IBSM)
        NCI = NSBSO(IATP,IASM)
        call TRNSPS(NRI,NCI,C(IBASE),CTT)
        if (PSSIGN == -One) CTT(1:NRI*NCI) = -CTT(1:NRI*NCI)
      else if (IBTP == IATP) then
        IBASE = ICOOSC(IBTP,IATP,IBSM)
        NRI = NSASO(IATP,IBSM)
        NCI = NSBSO(IATP,IASM)
        call TRIPK2_2(CTT,C(IBASE),NRI,NCI,PLSSGN)
        if (PLSIGN == -One) CTT(1:NRI*NCI) = -CTT(1:NRI*NCI)
      else if (IBTP < IATP) then
        IBASE = ICOOSC(IATP,IBTP,IBSM)
        NELMNT = NSASO(IATP,IBSM)*NSBSO(IBTP,IASM)
        if (PLSIGN == -One) then
          CTT(1:NELMNT) = -C(IBASE:IBASE+NELMNT-1)
        else
          CTT(1:NELMNT) = C(IBASE:IBASE+NELMNT-1)
        end if
      end if
    end if
  end if
end if

end subroutine GSTTBL_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHORAS_DRV(nSym,nBas,nOcc,W_DSQ,W_DLT,W_FLT,ExFac,FSQ,W_CMO)

use Fock_util_global, only: ALGO, Deco, Lunit, REORD
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, Integer_Pointer
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(8)
integer(kind=iwp), target, intent(in) :: nOcc(nSym)
real(kind=wp), intent(in) :: W_DSQ(*), W_DLT(*), ExFac, W_CMO(*)
real(kind=wp), intent(inout) :: W_FLT(*)
type(DSBA_Type), intent(inout) :: FSQ(1)
integer(kind=iwp), parameter :: MaxDs = 1
integer(kind=iwp) :: i, nD, ja, loff1, MinMem(8), nDen, NumV, rc
real(kind=wp) :: FactC(MaxDs), FactX(MaxDs), Thr, Ymax
logical(kind=iwp) :: DoCoulomb(MaxDs), DoExchange(MaxDs)
type(DSBA_Type) :: DDec, DLT(1), DSQ(1), FLT(1), MSQ(MaxDs), Vec
type(Integer_Pointer) :: pNocc(1)
integer(kind=iwp), allocatable, target :: nVec(:)

!                                                                      *
!***********************************************************************
!                                                                      *
rc = 0

Lunit(:) = -1

nDen = 1
DoCoulomb(1) = .true.
DoExchange(1) = ExFac /= Zero
FactC(1) = One
FactX(1) = Half*ExFac ! ExFac used for hybrid functionals

call Allocate_DT(DLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_DLT)
call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FLT)

call Allocate_DT(DSQ(1),nBas,nBas,nSym,Ref=W_DSQ)

nD = 1

if (DECO) then ! use decomposed density
  ! ==============  Alternative A: Use decomposed density matrix =====
  call mma_allocate(nVec,nSym,Label='nVec')

  ! Allocate vectors representing decomposed density matrix:
  call Allocate_DT(Vec,nBas,nBas,nSym)

  ! ------------------------------------------------------------------
  call Allocate_DT(Ddec,nBas,nBas,nSym)
  DDec%A0(:) = DSQ(1)%A0(:)
  do i=1,nSym
    ! Loop over symmetries
    if (nBas(i) > 0) then
      Ymax = Zero
      do ja=1,nBas(i)
        Ymax = max(Ymax,DDec%SB(i)%A2(ja,ja))
      end do
      Thr = 1.0e-13_wp*Ymax
      ! Call for decomposition:
      call CD_InCore(DDec%SB(i)%A2,nBas(i),Vec%SB(i)%A2,nBas(i),NumV,Thr,rc)
      if (rc /= 0) call Error(rc)
      nVec(i) = NumV

      if (NumV /= nOcc(i)) then
        write(u6,*) 'Warning! The number of occupied from the decomposition of the density matrix is ',numV,' in symm. ',i
        write(u6,*) 'Expected value = ',nOcc(i)
        write(u6,*) 'Max diagonal of the density in symm. ',i,' is equal to ',Ymax
      end if

    else
      nVec(i) = 0
    end if
    ! End of loop over symmetries
  end do
  call Deallocate_DT(DDec)
  ! ------------------------------------------------------------------

  pNocc(1)%I1(1:) => nVec(1:)

  call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=Vec%A0)

  ! ========End of  Alternative A: Use decomposed density matrix =====
else

  pNocc(1)%I1(1:) => nOcc(1:)

  call Allocate_DT(MSQ(1),nBas,nBas,nSym,Ref=W_CMO)

end if

call CHOSCF_MEM(nSym,nBas,nD,DoExchange,pNocc,ALGO,REORD,MinMem,loff1)

! Here follows a long if nest with six combinations:
! ALGO is 1,  REORD is .true. or .false., or
! ALGO is 2,  REORD is .true. or .false., DECO is .true.or .false.
if (ALGO == 1) then
  if (REORD) then
    ! (ALGO == 1) .and. REORD:
    call CHO_FOCKTWO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,FactC,FactX,DLT,DSQ,FLT,FSQ,pNocc,MinMem)
    if (rc /= 0) call Error(rc)

  else
    ! (ALGO == 1) .and. (.not. REORD):
    call CHO_FOCKTWO_RED(rc,nBas,nDen,DoCoulomb,DoExchange,FactC,FactX,DLT,DSQ,FLT,FSQ,pNocc,MinMem)
    if (rc /= 0) call Error(rc)
  end if

else if (ALGO == 2) then
  if (DECO) then ! use decomposed density

    FactX(1) = Half*ExFac ! vectors are scaled by construction
    if (REORD) then
      ! (ALGO == 2) .and. DECO .and. REORD:
      call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
      if (rc /= 0) call Error(rc)

    else
      ! (ALGO == 2) .and. DECO .and. (.not. REORD):
      call CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
      if (rc /= 0) call Error(rc)
    end if

  else
    if (REORD) then
      ! (ALGO == 2) .and. (.not. DECO) .and. REORD:
      FactX(1) = One*ExFac ! because MOs coeff. are not scaled
      call CHO_FTWO_MO(rc,nSym,nBas,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
      if (rc /= 0) call Error(rc)
    else
      ! (ALGO == 2) .and. (.not. DECO) .and. (.not. REORD):
      FactX(1) = One*ExFac ! because MOs coeff. are not scaled
      call CHO_FMO_red(rc,nDen,DoCoulomb,DoExchange,lOff1,FactC,FactX,DLT,DSQ,FLT,FSQ,MinMem,MSQ,pNocc)
      if (rc /= 0) call Error(rc)
    end if
  end if

else
  rc = 99
  write(u6,*) 'Illegal Input. Specified Cholesky Algorithm= ',ALGO
  call QUIT(rc)
end if

call CHO_SUM(rc,nSym,nBas,nD,DoExchange,FLT,FSQ)

if (rc /= 0) call Error(rc)

pNocc(1)%I1 => null()
call Deallocate_DT(MSQ(1))
if (DECO) then
  call Deallocate_DT(Vec)
  call mma_deallocate(nVec)
end if
call Deallocate_DT(DSQ(1))
call Deallocate_DT(DLT(1))
call Deallocate_DT(FLT(1))

return

contains

subroutine Error(rc)

  integer(kind=iwp), intent(in) :: rc

  write(u6,*) 'CHORAS_DRV. Non-zero return code. rc= ',rc
  call QUIT(rc)

end subroutine Error

end subroutine CHORAS_DRV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
*               1993, Per Boussard                                     *
************************************************************************
      SubRoutine M2Int(
#define _CALLING_
#include "int_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of M2 integrals used in   *
*         ECP calculations. The operator is a s-type gaussian          *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by ECPMem                 *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
*             Physics, University of Stockholm, Sweden, October '93.   *
************************************************************************
      use Basis_Info
      use Center_Info
      use Her_RW
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables.
      Real*8 TC(3), C(3)
      Character*80 Label
      Logical ABeq(3)
      Integer iDCRT(0:7)
*
*-----Statement function for Cartesian index
*
      nElem(k)=(k+1)*(k+2)/2
*
      iRout = 122
      iPrint = nPrint(iRout)
*     Call GetMem(' Enter M2Int','LIST','REAL',iDum,iDum)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+1)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+1)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer
      ipQxyz = nip
      nip = nip + nZeta*3*(la+1)*(lb+1)
      ipK = nip
      nip = nip + nZeta
      ipZ = nip
      nip = nip + nZeta
      ipPx= nip
      nip = nip + nZeta
      ipPy= nip
      nip = nip + nZeta
      ipPz= nip
      nip = nip + nZeta
      ipRes = nip
      nip = nip + nZeta*nComp*nElem(la)*nElem(lb)
      If (nip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'M2Int: nip-1.gt.nArr*nZeta')
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Write (6,*) ' Abend in M2Int'
         Call Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In M2Int: A',' ',A,1,3)
         Call RecPrt(' In M2Int: RB',' ',RB,1,3)
         Call RecPrt(' In M2Int: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In M2Int: Kappa',' ',rKappa,nAlpha,nBeta)
         Call RecPrt(' In M2Int: Zeta',' ',Zeta,nAlpha,nBeta)
         Call RecPrt(' In M2Int: P',' ',P,nZeta,3)
         Write (6,*) ' In M2Int: la,lb,nHer=',la,lb,nHer
      End If
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
*-----Loop over nuclear centers
*
      kdc=0
      Do 100 kCnttp = 1, nCnttp
         If (.Not.dbsc(kCnttp)%ECP) Go To 111
         If (dbsc(kCnttp)%nM2.eq.0) Go To 111
*
         Do 101 kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab, dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
            Do 102 lDCRT = 0, nDCRT-1
               Call OA(iDCRT(lDCRT),C,TC)
*
               Do 1011 iM2xp = 1, dbsc(kCnttp)%nM2
                  Gamma = dbsc(kCnttp)%M2xp(iM2xp)
                  If (iPrint.ge.99) Write (6,*) ' Gamma=',Gamma
*
*-----------------Modify the original basis.
*
                  Do 1012 iZeta = 1, nZeta
                     PTC2 = (P(iZeta,1)-TC(1))**2
     &                    + (P(iZeta,2)-TC(2))**2
     &                    + (P(iZeta,3)-TC(3))**2
                     Tmp0 = Zeta(iZeta)+Gamma
                     Tmp1 = Exp(-Zeta(iZeta)*Gamma*PTC2/Tmp0)
                     Array(ipK+iZeta-1)    = rKappa(iZeta) * Tmp1
                     Array(ipZ+iZeta-1)    = Tmp0
                     Array(ipPx+iZeta-1)   =
     &                  (Zeta(iZeta)*P(iZeta,1)+Gamma*TC(1))/Tmp0
                     Array(ipPy+iZeta-1)   =
     &                  (Zeta(iZeta)*P(iZeta,2)+Gamma*TC(2))/Tmp0
                     Array(ipPz+iZeta-1)   =
     &                  (Zeta(iZeta)*P(iZeta,3)+Gamma*TC(3))/Tmp0
 1012             Continue
                  If (iPrint.ge.99) Then
                     Write (6,*) ' The modified basis set'
                     Call RecPrt(' In M2Int: Kappa',' ',
     &                            Array(ipK),nAlpha,nBeta)
                     Call RecPrt(' In M2Int: Zeta',' ',
     &                            Array(ipZ),nAlpha,nBeta)
                     Call RecPrt(' In M2Int: P',' ',Array(ipPx),nZeta,3)
                  End If
*
*-----------------Compute the cartesian values of the basis functions
*                 angular part
*
                  ABeq(1) = A(1).eq.RB(1) .and. A(1).eq.TC(1)
                  ABeq(2) = A(2).eq.RB(2) .and. A(2).eq.TC(2)
                  ABeq(3) = A(3).eq.RB(3) .and. A(3).eq.TC(3)
                  Call CrtCmp(Array(ipZ),Array(ipPx),nZeta,A,
     &                        Array(ipAxyz),la,HerR(iHerR(nHer)),
     &                        nHer,ABeq)
                  Call CrtCmp(Array(ipZ),Array(ipPx),nZeta,RB,
     &                        Array(ipBxyz),lb,HerR(iHerR(nHer)),
     &                        nHer,ABeq)
*
*-----------------Compute the contribution from the multipole moment
*                 operator
*
                  ABeq(1) = .False.
                  ABeq(2) = .False.
                  ABeq(3) = .False.
                  Call CrtCmp(Array(ipZ),Array(ipPx),nZeta,TC,
     &                        Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),
     &                        nHer,ABeq)
*
*-----------------Compute the cartesian components for the multipole
*                 moment integrals. The integrals are factorized into
*                 components.
*
                  Call Assmbl(Array(ipQxyz),
     &                        Array(ipAxyz),la,
     &                        Array(ipRxyz),nOrdOp,
     &                        Array(ipBxyz),lb,
     &                        nZeta,HerW(iHerW(nHer)),nHer)
*
*-----------------Combine the cartesian components to the full one
*                 electron integral.
*
                  Call CmbnMP(Array(ipQxyz),nZeta,la,lb,nOrdOp,
     &                        Array(ipZ),Array(ipK),Array(ipRes),nComp)
                  If (iPrint.ge.99) Then
                     Write (6,*) ' Intermediate result in M2Int'
                     Do 9101 ia = 1, nElem(la)
                        Do 9201 ib = 1, nElem(lb)
                           iab = (ib-1)*nElem(la) + ia
                           ipab = (iab-1)*nZeta + ipRes
                           Write (Label,'(A,I2,A,I2,A)')
     &                          ' Array(',ia,',',ib,')'
                           If (nComp.ne.1) Then
                              Call RecPrt(Label,' ',
     &                                    Array(ipab),nZeta,nComp)
                           Else
                              Call RecPrt(Label,' ',
     &                                    Array(ipab),nAlpha,nBeta)
                           End If
 9201                   Continue
 9101                Continue
                  End If
*
*-----------------Multiply result by Zeff*Const
*
                  Factor = -dbsc(kCnttp)%Charge*dbsc(kCnttp)%M2cf(iM2xp)
     &                   * Fact
                  If (iPrint.ge.99) Write (6,*) ' Factor=',Factor
                  Call DaXpY_(nZeta*nElem(la)*nElem(lb)*nIC,Factor,
     &                       Array(ipRes),1,Final,1)
*
 1011          Continue
*
 102        Continue
 101     Continue
 111     kdc = kdc + dbsc(kCnttp)%nCntr
*
 100  Continue
*
      If (iPrint.ge.99) Then
         Write (6,*) ' Result in M2Int'
         Do 9100 ia = 1, nElem(la)
            Do 9200 ib = 1, nElem(lb)
               Write (Label,'(A,I2,A,I2,A)')
     &              ' Final(ia=',ia,',ib=',ib,')'
               Call RecPrt(Label,' ',Final(1,ia,ib,1),nAlpha,nBeta)
 9200       Continue
 9100    Continue
      End If
*
*     Call GetMem(' Exit M2Int','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_real_array(ZInv)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iChO)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************
Module Slapaf_Parameters
Implicit none
Private
Public:: iRow, iRow_c, iInt, nFix, ddV_Schlegel, HWRS, iOptH, HUpMet, HrmFrq_Show, IRC, &
         nBVec, nDimBC, Curvilinear, Redundant, FindTS, User_Def, Analytic_Hessian, MaxItr, &
         UpMeth, iOptC, HSet, BSet, rHidden, CnstWght, PrQ, lOld, Numerical, Beta, Beta_Disp, &
         Line_Search, iNeg, TSConstraints, GNrm_Threshold, Mode, GrdLbl, GrdMax, &
         StpLbl, StpMax, E_Delta, ThrEne, ThrGrd, nLambda, iRef, ThrCons, ThrMEP, Baker,  &
         eMEPTest, rMEP, MEP, nMEP, MEPNum, MEPCons, dMEPStep, MEP_Type, MEP_Algo, Header, &
         Max_Center, mTROld, Delta, RtRnc, rFuzz, lNmHss, Cubic, lRP, Request_Alaska, Request_RASSI, &
         lOld_Implicit, CallLast, lSoft, lCtoF, Track, TwoRunFiles, isFalcon, Stop, NmIter, MxItr, &
         mTtAtm, nWndw, iter, WeightedConstraints, mB_Tot, mdB_Tot, mq, Force_dB, NADC, EDiffZero, ApproxNADC, iState


Integer i

Integer:: iRow=0
Integer:: iRow_c=0
Integer:: iInt=0
Integer:: nFix=0
Integer:: IRC=0
Integer:: nBVec=0
Integer:: nDimBC=0
Integer, Parameter:: MaxItr=2000
Integer:: iNeg(2)=[0,0]
Integer:: Mode=-1
Integer:: nLambda=0
Integer:: iRef=0
Integer:: nMEP=MaxItr
Integer:: MEPNum=0
Integer:: Max_Center=15
Integer:: mTROld=0
Integer:: NmIter=0
Integer:: MxItr=0
Integer:: mTtAtm=0
Integer:: nWndw=5
Integer:: iter=0
Integer:: mB_Tot=0
Integer:: mdB_Tot=0
Integer:: mq=0
Integer:: iState(2)=[0,0]

Logical:: Curvilinear=.True.
Logical:: Redundant=.False.
Logical:: FindTS=.False.
Logical:: HrmFrq_Show=.False.
Logical:: ddV_Schlegel=.False.
Logical:: HWRS=.True.
Logical:: User_Def=.False.
Logical:: Analytic_Hessian=.False.
Logical:: HSet=.False.
Logical:: BSet=.False.
Logical:: PrQ=.False.
Logical:: lOld=.False.
Logical:: Numerical=.False.
Logical:: Line_Search=.True.
Logical:: TSConstraints=.False.
Logical:: Baker=.False.            ! convergence a la Baker
Logical:: eMEPTest=.True.
Logical:: rMEP=.False.
Logical:: MEP=.False.
Logical:: MEPCons=.False.
Logical:: lNmHss=.False.
Logical:: Cubic=.False.
Logical:: lRP=.False.
Logical:: Request_Alaska=.False.
Logical:: Request_RASSI=.False.
Logical:: lOld_Implicit=.False.
Logical:: CallLast=.True.
Logical:: lSoft=.False.
Logical:: lCtoF=.False.
Logical:: Track=.False.
Logical:: TwoRunFiles=.False.
Logical:: isFalcon=.False.
Logical:: Stop=.False.
Logical:: WeightedConstraints=.False.
Logical:: Force_dB=.False.
Logical:: NADC=.False.
Logical:: EDiffZero=.False.
Logical:: ApproxNADC=.False.


#include "real.fh"
Real*8:: rHidden=Zero
Real*8:: CnstWght=One
Real*8:: Beta = 0.30D0    !     The threshold for restricted step optimization.
Real*8:: Beta_Disp=0.30D0 !     The threshold for restricted variance optimization.
Real*8:: GNrm_Threshold=0.2D0
Real*8:: GrdMax=Zero, StpMax=Zero
Real*8:: E_Delta=Zero
Real*8:: ThrEne=Zero, ThrGrd=Zero
Real*8:: ThrCons=Zero, ThrMEP=Zero
Real*8:: dMEPStep=0.1D0
Real*8:: Delta=1.0D-2
Real*8:: RtRnc=Three
Real*8:: rFuzz=Half

Character(LEN=8):: GrdLbl='', StpLbl=''
Character(LEN=10):: MEP_TYPE='SPHERE'
Character(LEN=2):: MEP_Algo='GS'
Character(LEN=1):: Header(144)=[('',i=1,144)]
!                                                                      *
!***********************************************************************
!                                                                      *
!     Hessian update
! 1   iOptH=00000001 (  1) Meyer (disabled)
! 2   iOptH=00000010 (  2) BP (disabled)
! 3   iOptH=00000100 (  4) BFGS
! 4   iOptH=00001000 (  8) None
! 5   iOptH=00010000 ( 16) MPS, for TS search
! 6   iOptH=-.1..... ( 32) Not used
! 7   iOptH=01000000 ( 64) EU, for TS search
! 8   iOptH=10000000 (128) TS-BFGS, for TS search
!
Integer:: iOptH=4
Character(LEN=6):: HUpMet=' None '
!                                                                      *
!***********************************************************************
!                                                                      *
!.... Optimization method. DO NOT EVER GO BEYOND BIT 30!!!
!
!      iOptC=000000000 (  0) No optimization
!   0  iOptC=000000001 (  1) Quasi Newton-Raphson
!   1  iOptC=000000010 (  2) c1-DIIS
!   2  iOptC=000000100 (  4) c2-DIIS
!   3  iOptC=000001000 (  8) RS-RFO
!   4  iOptC=00001.... ( 16) DIIS, <dx|dx>
!   5  iOptC=00010.... ( 32) DIIS, <dx|g>
!   6  iOptC=00100.... ( 64) DIIS, <g|g>
!   7  iOptC=01....... (128) Minimum, if not set TS search
!   8  iOptC=10....... (256) Optimization with constraint
!   9  iOptC           (512) set: RS-I-RFO, unset: RS-P-RFO
!  10  iOptC          (1024) HMF augmented with weak interactions
!  11  iOptC          (2048) augmented HMF used for selection of
!                            internal coordinates
!  12  iOptC          (4096) set if FindTS
!  13  iOptC          (8192) set if FindTS and in TS regime
!
Integer:: iOptC=2**3 + 2**6 + 2**7 + 2**9 + 2**10 + 2**11
Character(LEN=6):: UpMeth='  RF  '
End Module Slapaf_Parameters

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_P_Distrib_SP(iOpt,mySP,N_mySP)
!
! Thomas Bondo Pedersen, June 2007.
!
! Determine distribution of ShellPairs.
! iOpt=1: each node has same number of ShellPairs.
! iOpt=2: each node has same dimension.

use Cholesky, only: nnShl
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iOpt
integer(kind=iwp), intent(_OUT_) :: mySP(*)
integer(kind=iwp), intent(out) :: N_mySP

N_mySP = 0
if (iOpt == 1) then
  call Cho_P_Distrib_Vec(1,nnShl,mySP,N_mySP)
else
  call Cho_P_Distrib_SP_byDim(mySP,N_mySP)
end if

end subroutine Cho_P_Distrib_SP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992, Roland Lindh                                *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Drvk2_mck(mdede,New_Fock)
************************************************************************
*                                                                      *
*  Object: to precompute all pair entites as zeta, kappa, P.           *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             June '91, modified for k2 loop.                          *
*             January '92, modified to gradient calculations.          *
*             April '92, modified to use the Cauchy-Schwarz inequality *
*              to estimate the integral derivatives.                   *
*              Modified 1995 for 2nd derivatives by AB                 *
************************************************************************
      use k2_setup
      use k2_arrays
      use iSD_data
      use Basis_Info
      use Symmetry_Info, only: nIrrep, iOper
      use Sizes_of_Seward, only: S
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "ndarray.fh"
#include "real.fh"
#include "disp.fh"
#include "disp2.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "nsd.fh"
#include "setup.fh"
      Real*8  Coor(3,2)
      Integer iDCRR(0:7), iShllV(2), iAngV(4), iCmpV(4)
      Logical New_fock
      Real*8, Dimension(:), Allocatable :: Data_k2_local
*                                                                      *
************************************************************************
*                                                                      *
*-----Statement functions
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu1,TWall1)
      Call GetMem('k2','Max','Real',idum,maxk2)
      maxk2 = maxk2 / 2
      Call mma_allocate(Data_k2_local,Maxk2)
      jpk2 = 1
      nk2 = 0
      mdede=0
      mk2 = 0
*
      DoGrad_=.False.
      DoHess_=.True.
*                                                                      *
************************************************************************
*                                                                      *
      Call Nr_Shells(nSkal)
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('Con','Allo','Real',ipCon,S%m2Max)
*                                                                      *
************************************************************************
*                                                                      *
      MemTmp=0
      Do iAng = 0, S%iAngMx
         MemTmp=Max(MemTmp,(S%MaxPrm(iAng)*nElem(iAng))**2)
      End Do
      Call GetMem('Temp1','Allo','Real',ipTmp1,MemTmp )
      Call GetMem('Temp2','Allo','Real',ipTmp2,MemTmp )
      Call GetMem('Temp3','Allo','Real',ipTmp3,MemTmp )
      Call GetMem('Knew ','Allo','Real',ipKnew,S%m2Max  )
      Call GetMem('Lnew ','Allo','Real',ipLnew,S%m2Max  )
      Call GetMem('Pnew ','Allo','Real',ipPnew,3*S%m2Max)
      Call GetMem('Qnew ','Allo','Real',ipQnew,3*S%m2Max)
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('MemMax','Max','Real',iDum,MaxMem)
      Call GetMem('MemMax','Allo','Real',ipM001,MaxMem)
*                                                                      *
************************************************************************
*                                                                      *
      Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         Coor(1:3,1)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
         iAngV(1) = iAng
         iShllV(1) = iShll
         iCmpV(1) = (iAng+1)*(iAng+2)/2
*
         Do jS = 1, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
            Coor(1:3,2)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
            iAngV(2) = jAng
            iShllV(2) = jShll
            iCmpV(2) = (jAng+1)*(jAng+2)/2
*
*-------Compute FLOP's for the transfer equation.
*
            Call mHrr(iAng  ,jAng  ,nHrrab,nMemab)
            ijCmp = nElem(iAng)*nElem(jAng)
*
            iPrimi   = iPrim
            jPrimj   = jPrim
            nBasi    = Shells(iShllV(1))%nBasis
            nBasj    = Shells(iShllV(2))%nBasis
*
            kPrimk = 1
            lPriml = 1
            iBasi = iPrimi
            jBasj = jPrimj
            kBask = 1
            lBasl = 1
*
            nZeta = iPrimi * jPrimj
*
            Call ConMax(Work(ipCon),iPrimi,jPrimj,
     &                  Shells(iShll)%pCff,nBasi,
     &                  Shells(jShll)%pCff,nBasj)
*
            Call ICopy(2,iAngV,1,iAngV(3),1)
            Call ICopy(2,iCmpV,1,iCmpV(3),1)
*
            If (iShell.ge.jShell) Then
               ijShll = iShell*(iShell-1)/2 + jShell
            Else
               ijShll = jShell*(jShell-1)/2 + iShell
            End If
*
            nSO = 1
*
*-----------Compute memory request for the primitives, i.e.
*           how much memory is needed up to the transfer
*           equation.
*
            Call MemRys(iAngV,MemPrm)
*
*-----------Decide on the partioning of the shells based on
*           the available memory and the requested memory.
*
            Call PSOAO0_h(nSO,nMemab,nMemab,MemPrm,
     &                    MaxMem,iAngV,iCmpV,
     &                    iBasi,iBsInc,jBasj,jBsInc,
     &                    kBask,kBsInc,lBasl,lBsInc,
     &                    iPrimi,iPrInc,jPrimj,jPrInc,
     &                    kPrimk,kPrInc,lPriml,lPrInc,
     &                    ipM001,ipM002,ipM003,ipM004, ipM00d,
     &                    M001,  M002,  M003,  M004,     M00d)
            If (iBasi.ne.iBsInc .or.jBasj.ne.jBsInc) Then
                Write (6,*)
     &             'Drvk2: iBasi.ne.iBsInc .or.jBasj.ne.jBsInc'
                Write (6,*) 'iBasi,iBsInc=',iBasi,iBsInc
                Write (6,*) 'jBasj,jBsInc=',jBasj,jBsInc
                Call Abend()
            End If
*
*-----------Find the Double Coset Representatives
*           for center A and B.
*
            iDCRR(0:nIrrep-1)=iOper(0:nIrrep-1)
            nDCRR=nIrrep
*
*---------- Compute all pair entities (zeta, kappa, Px, Py,
*           Pz, ZInv, alpha, beta, [nm|nm] and derivative
*           entity, a total of ten different entities) for
*           all possible unique pairs of centers generated
*           for the symmetry unique centers A and B.
*
            Call k2Loop_mck(Coor,
     &                      iAngV,iCmpV,
     &                      iDCRR,nDCRR,Data_k2_local(jpk2),
     &                      ijCmp,
     &                      Shells(iShllV(1))%Exp,iPrimi,
     &                      Shells(iShllV(2))%Exp,jPrimj,
     &                      Shells(iShllV(1))%pCff,iBas,
     &                      Shells(iShllV(2))%pCff,jBas,
     &                      nMemab,Work(ipCon),
     &                      Work(ipM002),M002,Work(ipM003),M003,
     &                      Work(ipM004),M004,
     &                      mdci,mdcj,
     &                      ipTmp1,ipTmp2,ipTmp3,
     &                      ipKnew,ipLnew,ipPnew,ipQnew)
*
            Indk2(1,ijShll) = jpk2
            Indk2(2,ijShll) = nDCRR
            nk2 = nk2 + (nZeta*nDArray+nDScalar)*nDCRR
            mk2 = mk2 + nDCRR
*
            If (New_Fock) Then
               iDeSiz = 1 + iPrim*jPrim + iCmp*jCmp
            Else
               iDeSiz = 1 + iPrim*jPrim
     &                + (iBas*jBas+1)*iCmp*jCmp
            End If
            iSmLbl = 1
            nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            If (nSO.gt.0) mDeDe = mDeDe + iDeSiz*nDCRR

            jpk2 = 1 + nk2
*
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('MemMax', 'Free','Real',ipM001, MemMax )
      Call GetMem(' Qnew',  'Free','Real',ipQnew, 3*S%m2Max)
      Call GetMem(' Pnew',  'Free','Real',ipPnew, 3*S%m2Max)
      Call GetMem(' Lnew',  'Free','Real',ipLnew, S%m2Max  )
      Call GetMem(' Knew',  'Free','Real',ipKnew, S%m2Max  )
      Call GetMem('Temp3',  'Free','Real',ipTmp3, MemTmp )
      Call GetMem('Temp2',  'Free','Real',ipTmp2, MemTmp )
      Call GetMem('Temp1',  'Free','Real',ipTmp1, MemTmp )
      Call GetMem('Con','Free','Real',ipCon,S%m2Max)
*                                                                      *
************************************************************************
*                                                                      *
*     Resize the memory to the actual size
*
      Call mma_allocate(Data_k2,nk2)
      Call dCopy_(nk2,Data_k2_local,1,Data_k2,1)
      Call mma_deallocate(Data_k2_local)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,'(20X,A)')
     &  ' *** The k2 entities has been precomputed ***'
      Write (6,'(I7,A,I7,A)')
     &                   mk2,' blocks of k2 data were computed and',
     &                   nk2,' Word(*8) of memory is used for storage.'
      Write (6,'(A,A)')
     &   ' The presceening is based on the ',
     &   ' integral estimates.'
#endif
*
      Call CWTime(TCpu2,TWall2)
      Call SavTim(2,TCpu2-TCpu1,TWall2-TWall1)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine touch_cvb(chr)

use casvb_global, only: charobj, iprint, j_dep_on_i, joffs, mustdeclare, nobj, up2date
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: chr
integer(kind=iwp) :: i, iobj, n_touched

do
  iobj = 0
  do i=1,nobj
    if (charobj(i) == chr) iobj = i
  end do
  if (iobj /= 0) exit
  if (mustdeclare) then
    write(u6,*) ' Make object not found :',chr
    call abend_cvb()
  end if
  call decl_cvb(chr)
end do
up2date(iobj) = .false.
if (iprint >= 1) write(u6,'(/,a,i3,2a)') ' Touch (1) of object no.',iobj,', name : ',charobj(iobj)

! Mark all "child" objects as out-of-date:
do
  n_touched = 0
  do iobj=1,nobj
    if (.not. up2date(iobj)) then
      do i=joffs(iobj)+1,joffs(iobj+1)
        call touchrules_cvb(charobj(j_dep_on_i(i)))
        if (up2date(j_dep_on_i(i))) then
          up2date(j_dep_on_i(i)) = .false.
          if (iprint >= 1) write(u6,'(/,a,i3,2a)') ' Touch (2) of object no.',j_dep_on_i(i),', name : ',charobj(j_dep_on_i(i))
          n_touched = n_touched+1
        end if
      end do
    end if
  end do
  if (n_touched == 0) exit
end do

return

end subroutine touch_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Gunnar Karlstrom                                 *
!***********************************************************************

subroutine Rowel(nZeta,r0,Beta,K,alpha,P,a,gri,grin,jsum)
!***********************************************************************
! 1992                                                                 *
! Gunnar Karlstrom                                                     *
! Department of Theoretical Chemistry                                  *
! University of Lund                                                   *
! Lund                                                                 *
! Sweden                                                               *
!***********************************************************************

use welcom, only: Fac, ipot3
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, k, jSum
real(kind=wp), intent(in) :: r0, Beta, alpha(nZeta), P(nZeta,3)
real(kind=wp), intent(out) :: a(nZeta), grin((k+1)*(k/2+1)*(k/4+1)*nZeta)
real(kind=wp), intent(inout) :: gri(nZeta*jsum)
integer(kind=iwp) :: i, iSum

call poti(k,ipot3)
!call IecPrt(' ipot3(0:k+1)',ipot3,k+2,1)
isum = ipot3(k+1)
call bino(k+6)
call fiin(k+1)
call tetin(k+1)
call ylmnor(k+1)

a(:) = sqrt(P(:,1)**2+P(:,2)**2+P(:,3)**2)
!call RecPrt(' In Rowel: Distances',' ',a,nZeta,1)

fac(0) = One
do i=1,k+2
  fac(i) = fac(i-1)*real(i,kind=wp)
end do
call priwel(k,alpha,beta,r0,a,gri,nZeta,isum,grin)
!call RecPrt('Internal well integrals',' ',gri,nZeta,isum)

return

end subroutine Rowel

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RBufO_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IST,IADXS)
      Implicit real*8(a-h,o-z)

#include "SysDef.fh"
      Dimension W(*)
      Call GetMem('MaxMem','MAX','REAL',KDUM,MEMX)
      IADX=(KKTU-1)*IADXS
      IST=1
      Length=LBuf
      IEnd=LBuf
   52 CALL dDAFILE(LUHLFX,2,W(IST),Length,IADX)
      IST=IST+LBuf
      IEnd=IEnd+LBuf
      If(IEnd.gt.LL)Length=mod(LL,LBuf)
      IADX=IADX+(NOTU-1)*IADXS
      IF(IST.LE.LL) GO TO 52
      IST=1
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Roland Lindh                                     *
!***********************************************************************

subroutine DstChk(xyz,Lbls,mCentr)
!***********************************************************************
!                                                                      *
! Object: to check that the structure is realistic.                    *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Constants, only: Zero, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
#include "LenIn.fh"
integer(kind=iwp), intent(in) :: mCentr
real(kind=wp), intent(in) :: xyz(3,mCentr)
character(len=LenIn), intent(in) :: Lbls(mCentr)
integer(kind=iwp) :: icc, iLarge, jcc
real(kind=wp) :: R, RMax, RMin, x1, x2, y1, y2, z1, z2

if (mCentr < 5) return

iLarge = 0
do icc=1,mCentr
  if (index('1234567890',Lbls(icc)(2:2)) == 0) iLarge = 1
end do
if (iLarge == 1) return

RMax = Zero
RMin = huge(RMin)
do icc=1,mCentr
  x1 = xyz(1,icc)
  y1 = xyz(2,icc)
  z1 = xyz(3,icc)
  do jcc=1,icc-1
    x2 = xyz(1,jcc)
    y2 = xyz(2,jcc)
    z2 = xyz(3,jcc)
    R = sqrt((x2-x1)**2+(y2-y1)**2+(z2-z1)**2)
    RMin = min(RMin,R)
    RMax = max(RMax,r)
  end do
end do

if (RMax*Angstrom < 0.7_wp) then
  write(u6,*) 'All bonds shorter than 0.7 angstrom, this is probably wrong!'
  write(u6,*) 'The program will stop execution. To proceed, correct the '
  write(u6,*) 'input or use the "Expert" keyword to force execution'
  call AbEnd()
end if
if (RMin*Angstrom > 2.8_wp) then
  write(u6,*) 'All bonds longer than 2.8 angstrom, this is probably wrong!'
  write(u6,*) 'The program will stop execution. To proceed, correct the '
  write(u6,*) 'input or use the "Expert" keyword to force execution'
  call AbEnd()
end if

return

end subroutine DstChk

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETSTOR_S(VCSTOR,ISYM)
!
! Purpose: get total vector storage (in words), symmetry ISYM.

use Cholesky, only: InfVec, nDimRS, nnBstR, NumCho
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: VCSTOR
integer(kind=iwp), intent(in) :: ISYM
integer(kind=iwp) :: IRED, JRED

if (NUMCHO(ISYM) < 1) then
  VCSTOR = Zero
else if (.not. allocated(nDimRS)) then
  IRED = INFVEC(NUMCHO(ISYM),2,ISYM)
  JRED = 3
  call CHO_GETRED(IRED,JRED,.false.)
  call CHO_SETREDIND(JRED)
  VCSTOR = real(INFVEC(NUMCHO(ISYM),4,ISYM),kind=wp)+real(NNBSTR(ISYM,JRED),kind=wp)
else
  IRED = INFVEC(NUMCHO(ISYM),2,ISYM)
  VCSTOR = real(INFVEC(NUMCHO(ISYM),4,ISYM),kind=wp)+real(NDIMRS(ISYM,IRED),kind=wp)
end if

end subroutine CHO_GETSTOR_S

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Write_Data()

use stdalloc, only: mma_Allocate, mma_Deallocate
use False_Global, only: Mode, Will_Print
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: nAtoms, nCart, nHess, nRoots, nRelax, mRoots, i, j, k, l, LU, EOF
real(kind=wp), allocatable :: Energies(:), Gradient(:), NAC(:), Hessian(:), Dipoles(:,:), &
                              mEnergies(:), mGradient(:), mHessian(:), mNAC(:), mDipoles(:,:)
integer(kind=iwp), allocatable :: not_grad(:), not_nac(:,:)
character(len=16) :: line
logical(kind=iwp) :: Found, Too_Late
integer(kind=iwp), external :: IsFreeUnit, Read_Grad

call Get_nAtoms_All(nAtoms)
nCart = 3*nAtoms
nHess = nCart*(nCart+1)/2
if (Will_Print) write(u6,*)

! read data from interface output file
! write to RUNFILE or GRADS as we read it
LU = IsFreeUnit(11)
call Molcas_Open(LU,'OUTPUT')
Too_Late = .false.
nRoots = 0
do
  read(LU,100,iostat=EOF) line
  if (EOF < 0) exit
  call UpCase(line)
  select case (line)
    case ('[ROOTS]')
      read(LU,*) nRoots
      nRelax = nRoots
      call Check_nRoots(nRoots)
      if (Will_Print) write(u6,200) nRoots
      if (Mode == 'ADD') then
        call Get_iScalar('Number of roots',mRoots)
        call Check_nRoots(mRoots)
      else
        call Put_iScalar('Number of roots',nRoots)
        call Put_iScalar('Relax CASSCF root',nRelax)
      end if
      call mma_Allocate(not_grad,nRoots)
      call mma_Allocate(not_nac,nRoots,nRoots)
      not_grad(:) = 1
      not_nac(:,:) = 1
    case ('[RELAX ROOT]')
      call Check_Too_Late()
      call Check_nRoots()
      read(LU,*) nRelax
      call Check_Root_Number(nRelax)
      if (Will_Print) write(u6,201) nRelax
      call Put_iScalar('Relax CASSCF root',nRelax)
    case ('[ENERGIES]')
      call Check_nRoots()
      Too_Late = .true.
      call mma_Allocate(Energies,nRoots,label='Energies')
      read(LU,*) Energies(:)
      if (Will_Print) call RecPrt('Root energies','',Energies,nRoots,1)
      call Put_cArray('Relax Method','EXTERNAL',8)
      if (Mode == 'ADD') then
        call mma_Allocate(mEnergies,mRoots,label='mEnergies')
        call Get_dArray('Last energies',mEnergies,mRoots)
        if (nRoots > 1) then
          mEnergies(:) = mEnergies(:)+Energies(1)
        else
          mEnergies(:) = mEnergies(:)+Energies(:)
        end if
        call Store_Energies(mRoots,mEnergies,nRelax)
        call mma_Deallocate(mEnergies)
      else
        call Store_Energies(nRoots,Energies,nRelax)
      end if
      call mma_Deallocate(Energies)
    case ('[GRADIENT]')
      call Check_nRoots()
      read(LU,*) i
      call Check_Root_Number(i)
      call mma_Allocate(Gradient,nCart,label='Gradient')
      read(LU,*) Gradient(:)
      if (Will_Print) write(u6,202) i
      not_grad(i) = 0
      if (Mode == 'ADD') then
        call mma_Allocate(mGradient,nCart,label='mGradient')
        if (nRoots == 1) then
          ! modify all existing gradients
          do j=1,mRoots
            if (Read_Grad(mGradient,nCart,j,0,0) == 1) then
              mGradient(:) = mGradient(:)+Gradient(:)
              call Store_Grad(mGradient,nCart,j,0,0)
            end if
          end do
        else
          ! modify only this gradient
          if (Read_Grad(mGradient,nCart,i,0,0) == 1) then
            mGradient(:) = mGradient(:)+Gradient(:)
            call Store_Grad(mGradient,nCart,i,0,0)
          end if
        end if
        call mma_Deallocate(mGradient)
      else
        call Store_Grad(Gradient,nCart,i,0,0)
      end if
      call mma_Deallocate(Gradient)
    case ('[NAC]')
      call Check_nRoots()
      read(LU,*) i,j
      call Check_Root_Pair(i,j)
      call mma_Allocate(NAC,nCart,label='NAC')
      read(LU,*) NAC(:)
      if (Will_Print) write(u6,203) i,j
      not_nac(i,j) = 0
      not_nac(j,i) = 0
      if (Mode == 'ADD') then
        call mma_Allocate(mNAC,nCart,label='mNAC')
        if (nRoots == 1) then
          ! modify all existing couplings
          do k=1,mRoots
            do l=k+1,mRoots
              if (Read_Grad(mNAC,nCart,0,k,l) == 1) then
                mNAC(:) = mNAC(:)+NAC(:)
                call Store_Grad(mNAC,nCart,0,k,l)
              end if
            end do
          end do
        else
          ! modify only this coupling
          if (Read_Grad(mNAC,nCart,0,i,j) == 1) then
            mNAC(:) = mNAC(:)+NAC(:)
            call Store_Grad(mNAC,nCart,0,i,j)
          end if
        end if
        call mma_Deallocate(mNAC)
      else
        call Store_Grad(NAC,nCart,0,i,j)
      end if
      call mma_Deallocate(NAC)
    case ('[HESSIAN]')
      call Check_nRoots()
      Too_Late = .true.
      read(LU,*) i
      call Check_Root_Number(i)
      if (i == nRelax) then
        call mma_Allocate(Hessian,nHess,label='Hessian')
        read(LU,*) Hessian(:)
        if (Mode == 'ADD') then
          call mma_Allocate(mHessian,nHess,label='mHessian')
          call Qpg_dArray('Analytic Hessian',Found,j)
          if (Found) then
            call Get_AnalHess(mHessian,nHess)
            mHessian(:) = mHessian(:)+Hessian(:)
            call Put_AnalHess(mHessian,nHess)
          end if
          call mma_Deallocate(mHessian)
        else
          call Put_AnalHess(Hessian,nHess)
        end if
        call mma_Deallocate(Hessian)
      end if
      if (Will_Print) write(u6,204) i
    case ('[DIPOLES]')
      call Check_nRoots()
      call mma_Allocate(Dipoles,3,nRoots,label='Dipoles')
      do i=1,nRoots
        read(LU,*) Dipoles(:,i)
      end do
      if (Will_Print) write(u6,*) 'Found dipole moments'
      if (Mode == 'ADD') then
        call mma_Allocate(mDipoles,3,mRoots,label='mDipoles')
        call Get_dArray('Last dipole momentes',mDipoles,3*mRoots)
        if (nRoots > 1) then
          do j=1,mRoots
            mDipoles(:,j) = mDipoles(:,j)+Dipoles(:,1)
          end do
        else
          mDipoles(:,:) = mDipoles(:,:)+Dipoles(:,:)
        end if
        call Put_dArray('Last dipole moments',mDipoles,3*nRoots)
        call mma_Deallocate(mDipoles)
      else
        call Put_dArray('Last dipole moments',Dipoles,3*nRoots)
      end if
      call mma_Deallocate(Dipoles)
    case default
  end select
end do
close(LU)

! mark non-computable gradients
if (allocated(not_grad)) then
  if (Mode == 'REPLACE') then
    do j=1,nRoots
      if (not_grad(j) /= 0) call Store_Not_Grad(j,0,0)
      do i=j+1,nRoots
        if (not_nac(i,j) /= 0) call Store_Not_Grad(0,i,j)
      end do
    end do
  end if
  call mma_Deallocate(not_grad)
  call mma_Deallocate(not_nac)
end if

return

100 format(a)
200 format('Found data for ',i3,' roots')
201 format('Relaxing on root ',i3)
202 format('Found gradient for root ',i3)
203 format('Found coupling vector for roots ',i3,' and ',i3)
204 format('Found Hessian for root ',i3)

contains

subroutine Check_nRoots(n)
  integer(kind=iwp), intent(in), optional :: n
  if (nRoots < 1) then
    if (present(n)) then
      call WarningMessage(2,'The number of roots must be positive.')
    else
      call WarningMessage(2,'[ROOTS] should be defined first.')
    end if
    call AbEnd()
  else if ((Mode == 'ADD') .and. present(n)) then
    ! if nRoots == 1 and mRoots /= 1, the same values will be added to all roots
    if ((nRoots /= 1) .and. (nRoots /= n)) then
      call WarningMessage(2,'The number of roots does not agree with the runfile')
      call AbEnd()
    end if
  end if
end subroutine Check_nRoots

subroutine Check_Too_Late()
  if (Too_Late) then
    call WarningMessage(2,'[RELAX] should have been given earlier.')
    call AbEnd()
  end if
end subroutine Check_Too_Late

subroutine Check_Root_Number(n)
  integer(kind=iwp), intent(in) :: n
  character(len=6) :: a, b
  call Check_nRoots()
  if ((n < 1) .or. (n > nRoots)) then
    write(a,'(I6)') n
    write(b,'(I6)') nRoots
    a = adjustl(a)
    b = adjustl(b)
    call WarningMessage(2,'Root number '//trim(a)//' must be between 1 and '//trim(b)//'.')
    call AbEnd()
  end if
end subroutine Check_Root_Number

subroutine Check_Root_Pair(n,m)
  integer(kind=iwp), intent(in) :: n, m
  character(len=6) :: a
  call Check_Root_Number(n)
  call Check_Root_Number(m)
  if (n == m) then
    write(a,'(I6)') n
    a = adjustl(a)
    call WarningMessage(2,'Roots in pair '//trim(a)//' '//trim(a)//' cannot be equal.')
    call AbEnd()
  end if
end subroutine Check_Root_Pair

end subroutine Write_Data

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3sglh11(w,dima,dimab,dimabc,s1,d1,ns)
! this routine adds following contribution to W
! for syma=symb=symc
!
! W(abc)  <-  + S1 _i(a) . D1 _jk(bc)
! - S1 _i(b) . D1 _jk(ac)
! + S1 _i(c) . D1 _jk(ab)
!
! w      - W matrix (I/O)
! dima   - dimension of a (b,c) index (I)
! dimab  - dimension of ab (ac,bc) index (I)
! dimabc - dimension of abc index (I)
! s1     - S1 matrix (I)
! d1     - D1 matrix (I)
! ns     - signum of the contribution (+-1) (I)

use CCT3_global, only: nshf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimab, dimabc, ns
real(kind=wp), intent(inout) :: w(dimabc)
real(kind=wp), intent(in) :: s1(dima), d1(dimab)
integer(kind=iwp) :: a, ab0, abc, ac0, b, bc0

if (ns == 1) then
  ! phase +1

  abc = 0
  do a=3,dima
    do b=2,a-1
      bc0 = nshf(b)
      w(abc+1:abc+b-1) = w(abc+1:abc+b-1)+d1(bc0+1:bc0+b-1)*s1(a)
      abc = abc+b-1
    end do
  end do

  abc = 0
  do a=3,dima
    ac0 = nshf(a)
    do b=2,a-1
      w(abc+1:abc+b-1) = w(abc+1:abc+b-1)-d1(ac0+1:ac0+b-1)*s1(b)
      abc = abc+b-1
    end do
  end do

  abc = 0
  do a=3,dima
    ab0 = nshf(a)
    do b=2,a-1
      w(abc+1:abc+b-1) = w(abc+1:abc+b-1)+s1(1:b-1)*d1(ab0+b)
      abc = abc+b-1
    end do
  end do

else
  ! phase -1

  abc = 0
  do a=3,dima
    do b=2,a-1
      bc0 = nshf(b)
      w(abc+1:abc+b-1) = w(abc+1:abc+b-1)-d1(bc0+1:bc0+b-1)*s1(a)
      abc = abc+b-1
    end do
  end do

  abc = 0
  do a=3,dima
    ac0 = nshf(a)
    do b=2,a-1
      w(abc+1:abc+b-1) = w(abc+1:abc+b-1)+d1(ac0+1:ac0+b-1)*s1(b)
      abc = abc+b-1
    end do
  end do

  abc = 0
  do a=3,dima
    ab0 = nshf(a)
    do b=2,a-1
      w(abc+1:abc+b-1) = w(abc+1:abc+b-1)-s1(1:b-1)*d1(ab0+b)
      abc = abc+b-1
    end do
  end do

end if

return

end subroutine t3sglh11

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Extract(iLu,i9,Etot,xyzMy,Hmat,iC,iDt,nMatBas,HMatOld
     &                  ,xyzQuQ,ip_ExpVal,ip_ExpCento,ENR,ENP)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"

      Dimension xyzMy(3),Hmat(*),HMatOld(*),xyzQuQ(6)
      Dimension iDt(3)

*
*---  Just pass on the numbers according to QM-method.
*
      If(QmType(1:4).eq.'RASS') then
        Call ExtractR(iLu,i9,Etot,xyzMy,Hmat,iC,iDt,nMatBas,HMatOld
     &               ,xyzQuQ,lExtr,iExtr_Eig,iExtr_Atm,ip_ExpVal
     &               ,ip_ExpCento,ENR,ENP)
      ElseIf(QmType(1:3).eq.'SCF') then
        Call ExtractS(iLu,i9,Etot,xyzMy,Hmat,iC,iDt,nMatBas,xyzQuQ
     &               ,lExtr,iExtr_Atm,ip_ExpVal,ip_ExpCento,ENR,ENP)
      Endif

      Return
      End


      Subroutine ExtractR(iLu,i9,Etot,xyzMy,Hmat,iC,iDt,nState,HMatOld
     &                   ,xyzQu,lExtr,iExtr_Eig,iExtr_Atm,ip_ExpVal
     &                   ,ip_ExpCento,ENR,ENP)
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"

      Dimension xyzMy(3),Hmat(*),HMatOld(*),xyzQu(6)
      Dimension iDt(3),iExtr_Atm(*)
      Logical lExtr(*)

      Write(iLu,*)'<<<<<<<Configuration ',i9,'>>>>>>>'
      If(lExtr(1)) then
        Write(iLu,*)'Total Energy'
        Write(iLu,'(F15.8)')Etot
      Endif
      If(lExtr(2)) then
        Write(iLu,*)'QM-Dipole'
        Write(iLu,'(3(F12.5))')(xyzMy(k),k=1,3)
      Endif
      If(lExtr(3)) then
        Write(iLu,*)'QM-Quadrupole'
        Write(iLu,'(6(F12.5))')(xyzQu(k),k=1,6)
      Endif
      If(lExtr(4)) then
        Write(iLu,*)'Eigenvalues of RASSI-matrix'
        Do 1, i=1,iExtr_Eig
          ind=i*(i+1)/2
          Write(iLu,'(F15.8)')Hmat(ind)
1       Continue
      Endif
      If(lExtr(5)) then
        Write(iLu,*)'Corresponding eigenvectors'
        Do 2, j=0,iExtr_Eig-1
          Write(iLu,'(5(F15.8))')(Work(iC+j*nState+k),k=0,nState-1)
2       Continue
      Endif
      If(lExtr(6)) then
        Write(iLu,*)'Expectation values (H_0,V_el,V_pol,V_pp)'
        Write(iLu,*)'  Nuc cont:',ENR
        If(lExtr(4)) nDim=iExtr_Eig
        If(.not.lExtr(4)) nDim=nState
        Do 3, i=1,nDim
          Write(iLu,'(4(F15.8))')(Work(ip_ExpVal+4*(i-1)+k),k=0,3)
3       Continue
        Call GetMem('ExpVals','Free','Real',ip_ExpVal,4*nDim)
      Endif
      If(lExtr(7)) then
        Write(iLu,*)'Expectation values partial V_el, V_pol'
        Write(iLu,*)'  Nuc cont:',ENP
        If(lExtr(4)) nDim=iExtr_Eig
        If(.not.lExtr(4)) nDim=nState
        Do 4, j=1,nDim
          Write(iLu,'(2(F15.8))')(Work(ip_ExpCento+4*(j-1)+k),k=1,2)
4       Continue
        Call GetMem('ExpVals','Free','Real',ip_ExpCento,4*nDim)
      Endif

      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer_array(iDt)
        Call Unused_real_array(HMatOld)
        Call Unused_integer_array(iExtr_Atm)
      End If
      End


      Subroutine ExtractS(iLu,i9,Etot,xyzMy,Hmat,iC,iDt,nBas,xyzQu
     &                   ,lExtr,iExtr_Atm,ip_ExpVal,ip_ExpCento
     &                   ,ENR,ENP)
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"

      Dimension xyzMy(3),Hmat(*),xyzQu(6)
      Dimension iDt(3),iExtr_Atm(*)
      Logical lExtr(*)

      Write(iLu,*)'<<<<<<<Configuration ',i9,'>>>>>>>'
      If(lExtr(1)) then
        Write(iLu,*)'Total Energy'
        Write(iLu,'(F15.8)')Etot
      Endif
      If(lExtr(2)) then
        Write(iLu,*)'QM-Dipole'
        Write(iLu,'(3(F12.5))')(xyzMy(k),k=1,3)
      Endif
      If(lExtr(3)) then
        Write(iLu,*)'QM-Quadrupole'
        Write(iLu,'(6(F12.5))')(xyzQu(k),k=1,6)
      Endif
      If(lExtr(6)) then
        Write(iLu,*)'Expectation values (T+H_nuc,V_el,V_pol,V_pp)'
        Write(iLu,*)'  Nuc cont:',ENR
        Write(iLu,'(4(F15.8))')(Work(ip_ExpVal+k),k=0,3)
        Call GetMem('ExpVals','Free','Real',ip_ExpVal,4)
      Endif
      If(lExtr(7)) then
        Write(iLu,*)'Expectation values partial V_el, V_pol'
        Write(iLu,*)'  Nuc cont:',ENP
        Write(iLu,'(2(F15.8))')(Work(ip_ExpCento+k),k=1,2)
        Call GetMem('ExpVals','Free','Real',ip_ExpCento,4)
      Endif

      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(Hmat)
        Call Unused_integer(iC)
        Call Unused_integer_array(iDt)
        Call Unused_integer(nBas)
        Call Unused_integer_array(iExtr_Atm)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

function FindMx(n,X)
!-----------------------------------------------------------------------
! Function : Find Maximum norm in X(n)
!-----------------------------------------------------------------------

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: FindMx
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: X(n)
integer(kind=iwp) :: I
real(kind=wp) :: XMax

XMax = Zero
do I=1,n
  XMax = max(XMax,abs(X(I)))
end do
FindMx = XMax

return

end function FindMx

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine EXPCSF(ICS,NLEV,IMS,LEX)
! Expand IMS component of ICS(NLEV) in determinants using the
! procedure from Shavitt in "The Unitary Group", "Lecture Notes in
! Chemistry" Vol. 22, pp. 55.

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NLEV, ICS(NLEV), IMS
integer(kind=iwp), intent(out) :: LEX(NLEV)
integer(kind=iwp) :: I, IA, IALPHA, IB, IBETA, ICOEF(2), ILEX, ISOMO, J, K, NALPHA, NSOMO
character(len=256) :: LINE
character(len=6) :: STRING
logical(kind=iwp) :: LAST, LPHASE

! find number of singly occupied orbitals
NSOMO = 0
do I=1,NLEV
  if ((ICS(I) == 1) .or. (ICS(I) == 2)) NSOMO = NSOMO+1
end do
NALPHA = (NSOMO+IMS)/2
call INIT_LEX(NALPHA,LEX)
! Loop over possible determinants
LAST = .false.
do while (.not. LAST)
  ICOEF(1) = 1
  ICOEF(2) = 1
  LPHASE = .true.
  IALPHA = 0
  IBETA = 0
  ISOMO = 0
  ILEX = 1
  IA = 0
  IB = 0
  LINE = ' '
  K = 26
  write(LINE(K:K),'(A)') '|'
  K = K+NLEV+1
  write(LINE(K:K),'(A)') '|'
  K = 26
  do I=1,NLEV
    K = K+1
    if (ICS(I) == 0) then
      LINE(K:K) = '0'
    else if (ICS(I) == 1) then
      IB = IB+1
      ISOMO = ISOMO+1
      if (ISOMO == LEX(ILEX)) then
        ILEX = ILEX+1
        ICOEF(1) = ICOEF(1)*(IA+IB-IBETA)
        IALPHA = IALPHA+1
        LINE(K:K) = 'a'
      else
        ICOEF(1) = ICOEF(1)*(IA+IB-IALPHA)
        IBETA = IBETA+1
        LINE(K:K) = 'b'
      end if
      ICOEF(2) = ICOEF(2)*IB
    else if (ICS(I) == 2) then
      IA = IA+1
      IB = IB-1
      ISOMO = ISOMO+1
      if (ISOMO == LEX(ILEX)) then
        ILEX = ILEX+1
        ICOEF(1) = ICOEF(1)*(IBETA-IA+1)
        if (mod(IB,2) == 0) LPHASE = .not. LPHASE
        IALPHA = IALPHA+1
        LINE(K:K) = 'a'
      else
        ICOEF(1) = ICOEF(1)*(IALPHA-IA+1)
        if (mod(IB,2) /= 0) LPHASE = .not. LPHASE
        IBETA = IBETA+1
        LINE(K:K) = 'b'
      end if
      ICOEF(2) = ICOEF(2)*(IB+2)
    else
      IA = IA+1
      IALPHA = IALPHA+1
      IBETA = IBETA+1
      if (mod(IB,2) /= 0) LPHASE = .not. LPHASE
      LINE(K:K) = '2'
    end if
    if (ICOEF(1) == 0) exit
  end do
  if (ICOEF(1) /= 0) then
    ! If non-zero coefficient, print the thing
    call SIMPLIFY(ICOEF)
    if (LPHASE) then
      write(LINE(1:9),'(2X,A7)') '+ sqrt('
    else
      write(LINE(1:9),'(2X,A7)') '- sqrt('
    end if
    write(LINE(10:16),'(I6,A1)') ICOEF(1),'/'
    write(STRING(1:6),'(I6)') ICOEF(2)
    J = 17
    do I=1,6
      if (STRING(I:I) /= ' ') then
        LINE(J:J) = STRING(I:I)
        J = J+1
      end if
    end do
    write(LINE(23:23),'(A1)') ')'
    write(u6,*) LINE(1:K+1)
    ! End of print-out
  end if
  ! Get the next determinant
  call LEX_ITER(NSOMO,NALPHA,LEX,LAST)
end do

end subroutine EXPCSF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995,2001, Roland Lindh                                *
!***********************************************************************

subroutine PCMgrd( &
#                 define _CALLING_
#                 include "grd_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of nuclear attraction     *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, May '95                                 *
!                                                                      *
!             Modified to PCM gradients September 2001, Lund, by       *
!             R. Lindh.                                                *
!***********************************************************************

use PCM_arrays, only: PCM_SQ, PCMTess
use Center_Info, only: dc
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: i, iAlpha, iAnga(4), iBeta, iCar, iDAO, iDCRT(0:7), ipA, ipAOff, ipB, ipBOff, ipDAO, iPrint, iRout, &
                     iStb(0:7), iTs, iuvwx(4), iZeta, j, JndGrd(3,4), lDCRT, LmbdT, lOp(4), mGrad, mRys, nArray, nDAO, nDCRT, &
                     nDiff, nip, nStb
real(kind=wp) :: C(3), CoorAC(3,2), Coori(3,4), EInv, Eta, Fact, Q, TC(3)
logical(kind=iwp) :: JfGrad(3,4)
!character(len=3), parameter :: ChOper(0:7) = ['E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz']
integer(kind=iwp), external :: NrOpr
external :: Fake, TNAI1, XCff2D
#include "print.fh"
#include "rctfld.fh"
integer(kind=iwp) :: nElem, ixyz
nElem(ixyz) = (ixyz+1)*(ixyz+2)/2

#include "macros.fh"
unused_var(rFinal)
unused_var(nHer)
unused_var(Ccoor(1))
unused_var(nComp)

iRout = 151
iPrint = nPrint(iRout)

nip = 1
ipA = nip
nip = nip+nAlpha*nBeta
ipB = nip
nip = nip+nAlpha*nBeta
ipDAO = nip
nip = nip+nAlpha*nBeta*nElem(la)*nElem(lb)*nElem(nOrdOp)
if (nip-1 > nZeta*nArr) then
  write(u6,*) 'nip-1 > nZeta*nArr'
  call ErrTra()
  call Abend()
end if
nArray = nZeta*nArr-nip+1

iAnga(1) = la
iAnga(2) = lb
iAnga(3) = nOrdOp
iAnga(4) = 0
Coori(:,1) = A(:)
Coori(:,2) = RB(:)
if (la >= lb) then
  CoorAC(:,1) = A(:)
else
  CoorAC(:,1) = RB(:)
end if
iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
lOp(1) = kOp(1)
lOp(2) = kOp(2)

ipAOff = ipA
do iBeta=1,nBeta
  call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB
do iAlpha=1,nAlpha
  call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
  ipBOff = ipBOff+1
end do

! Modify the density matrix with the prefactor

nDAO = nElem(la)*nElem(lb)
do iDAO=1,nDAO
  do iZeta=1,nZeta
    Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
    DAO(iZeta,iDAO) = Fact*DAO(iZeta,iDAO)
  end do
end do
if (iPrint >= 99) call RecPrt('DAO',' ',DAO,nZeta,nDAO)

! Generate stabilizer of C, i.e. a center of a tile.

nStb = 1
iStb(0) = 0

! Loop over the tiles

do iTs=1,nTs
  Q = PCM_SQ(1,iTs)+PCM_SQ(2,iTs)
  if (Q == Zero) cycle
  ! Pick up the tile coordinates
  C(1:3) = PCMTess(1:3,iTs)

  if (iPrint >= 99) call RecPrt('C',' ',C,1,3)
  call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
  Fact = -Q*real(nStabM,kind=wp)/real(LmbdT,kind=wp)

  Array(ipDAO:ipDAO+nZeta*nDAO-1) = Fact*pack(DAO,.true.)

  iuvwx(3) = nStb
  iuvwx(4) = nStb
  JndGrd(:,1:2) = IndGrd(:,:)
  do i=1,3
    do j=1,2
      JfGrad(i,j) = IfGrad(i,j)
    end do
  end do

  ! No derivatives with respect to the third or fourth center.
  ! The positions of the points in the external field are frozen.

  JndGrd(:,3) = 0
  JfGrad(1,3) = .false.
  JfGrad(2,3) = .false.
  JfGrad(3,3) = .false.
  JndGrd(:,4) = 0
  JfGrad(1,4) = .false.
  JfGrad(2,4) = .false.
  JfGrad(3,4) = .false.
  mGrad = 0
  do iCar=1,3
    do i=1,2
      if (JfGrad(iCar,i)) mGrad = mGrad+1
    end do
  end do
  if (iPrint >= 99) write(u6,*) ' mGrad=',mGrad
  if (mGrad == 0) cycle

  do lDCRT=0,nDCRT-1
    lOp(3) = NrOpr(iDCRT(lDCRT))
    lOp(4) = lOp(3)
    call OA(iDCRT(lDCRT),C,TC)
    CoorAC(:,2) = TC(:)
    Coori(:,3) = TC(:)
    Coori(:,4) = TC(:)

    ! Compute integrals with the Rys quadrature.

    nDiff = 1
    mRys = (la+lb+2+nDiff+nOrdOp)/2
    Eta = One
    EInv = One
    call Rysg1(iAnga,mRys,nZeta,Array(ipA),Array(ipB),[One],[One],Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,TC,1,Coori,Coori,CoorAC, &
               Array(nip),nArray,TNAI1,Fake,XCff2D,Array(ipDAO),nDAO*nElem(nOrdOp),Grad,nGrad,JfGrad,JndGrd,lOp,iuvwx)

    !call RecPrt(' In PCMgrd:Grad',' ',Grad,nGrad,1)
  end do  ! End loop over DCRs

end do    ! End loop over centers in the external field

return

end subroutine PCMgrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKRAW(IDOWN,IUP,IRAW,IPRINT)
C
C     PURPOSE: CONSTRUCT UPCHAIN INDEX TABLE AND REVERSE ARC WEIGHTS
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "gugx.fh"
#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
C
      DIMENSION IDOWN(NVERT,0:3),IUP(NVERT,0:3),IRAW(NVERT,0:4)

C
C     BEGIN BY CONSTRUCTING THE UPCHAIN TABLE IUP:
C
      DO IV=1,NVERT
        DO IC=0,3
          IUP(IV,IC)=0
        END DO
      END DO
      DO IU=1,NVERT-1
        DO IC=0,3
          IDWN=IDOWN(IU,IC)
          IF(IDWN.EQ.0) GOTO 20
          IUP(IDWN,IC)=IU
20        CONTINUE
        END DO
      END DO
C
      IF( IPRINT.GE.5 ) THEN
        Write(LF,*)
        Write(LF,*)' THE UPCHAIN TABLE IN MKRAW:'
        DO IV=1,NVERT
          Write(LF,'(1X,I4,5X,4(1X,I6))') IV,(IUP(IV,IC),IC=0,3)
        END DO
        Write(LF,*)
      ENDIF
C
C     USE UPCHAIN TABLE TO CALCULATE THE REVERSE ARC WEIGHT TABLE:
C
      DO IC=0,3
        IRAW(1,IC)=0
      END DO
      IRAW(1,4)=1
      DO IV=2,NVERT
        ISUM=0
        DO IC=0,3
          IRAW(IV,IC)=0
          IU=IUP(IV,IC)
          IF(IU.EQ.0) GOTO 120
          IRAW(IV,IC)=ISUM
          ISUM=ISUM+IRAW(IU,4)
120     CONTINUE
        END DO
        IRAW(IV,4)=ISUM
      END DO
C
      IF( IPRINT.GE.5 ) THEN
        Write(LF,*)
        Write(LF,*)' THE REVERSE ARC WEIGHT TABLE IN MKRAW:'
        DO IV=1,NVERT
          Write(LF,'(1X,I4,5X,5(1X,I6))') IV,(IRAW(IV,IC),IC=0,4)
        END DO
        Write(LF,*)
      ENDIF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FndSph(NAt,ICharg,C,IAt,ITypRad,NSphInp,Alpha,XSph,YSph,ZSph,Rad,NOrd,m,iPrint)

use Solvent_Data, only: Pauling
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NAt, ICharg, IAt(NAt), ITypRad, NSphInp, m, iPrint
real(kind=wp), intent(in) :: C(3,NAt)
real(kind=wp), intent(inout) :: Alpha
real(kind=wp), intent(out) :: XSph(m), YSph(m), ZSph(m), Rad(m)
integer(kind=iwp), intent(out) :: NOrd(m)
integer(kind=iwp) :: I
real(kind=wp), allocatable :: Chg(:)
#include "rctfld.fh"

! Assign GEPOL sphere positions and radii according to solute atoms nature
select case (ITypRad)
  case (1)
    ! United Atom Topological Model (UATM) radii:
    call mma_allocate(Chg,NAt,label='Chg')
    Chg(:) = Zero
    call UATM(u6,ICharg,NAt,NSinit,m,Rad,Alpha,C,IAt,NOrd,Chg,iPrint)
    call mma_deallocate(Chg)
  case (2)
    ! Pauling radii on each atom:
    do I=1,NAt
      NOrd(I) = I
      Rad(I) = Pauling(IAt(I))
    end do
    Alpha = 1.2_wp
    NSinit = NAt
  case (3)
    ! Sphere radii given in the input
    NOrd(1:NSphInp) = NOrdInp(1:NSphInp)
    Rad(1:NSphInp) = RadInp(1:NSphInp)
    Alpha = 1.2_wp
    NSinit = NSphInp
  case default
    write(u6,'(a)') 'Unrecognized radii type !'
    call Abend()
end select
if (((ITypRad == 2) .or. (ITypRad == 3)) .and. (iPrint > 5)) call PrtCav(u6,ITypRad,NSinit,NOrd,Alpha,Rad)

do I=1,NSinit
  XSph(I) = C(1,NOrd(I))
  YSph(I) = C(2,NOrd(I))
  ZSph(I) = C(3,NOrd(I))
end do
Rad(1:NSinit) = Rad(1:NSinit)*Alpha

return

end subroutine FndSph

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
**********************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE PRWF_CP2(ISYCI,NCO,CI,THR)
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: ISYCI, NCO
      REAL*8, INTENT(IN) :: CI(NCO), THR
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "pt2_guga.fh"
#include "WrkSpc.fh"

      INTEGER I

      WRITE(6,'(20A4)')('----',I=1,20)
      WRITE(6,'(a,d9.2)')' CI COEFFICIENTS LARGER THAN ',THR
      CALL PRWF1_CP2(IWORK(LNOCSF),IWORK(LIOCSF),IWORK(LNOW),
     &           IWORK(LIOW),ISYCI,CI,THR)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function Multipole_Expansion(q_A,q_B,Dipole_A,Dipole_B,
     &                  R_A,R_B,R,Absolute)
      Implicit Real*8 (A-H,O-Z)
      Real*8 Multipole_Expansion
      Logical Absolute
#include "real.fh"
*
      dR_A  = R_A-R
      dR_B  = R_B-R
      Call Multipole_E(q_A,Dipole_A,dR_A,E_A)
      Call Multipole_E(q_B,Dipole_B,dR_B,E_B)
*
      If (Absolute) Then
         Multipole_Expansion = Abs(E_A + E_B)
      Else
         Multipole_Expansion = E_A + E_B
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine molden_cvb()

use rctfld_module,only: lRF
use rasscf_global, only: iADR15
use general_data, only: JOBIPH
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none

integer(kind=iwp) :: iDisk
real(kind=wp) :: Dummy(1)

call daname_cvb(JOBIPH,'JOBIPH')
iDisk = 0
call idafile(JOBIPH,2,iadr15,15,iDisk)
if (.not. lRF) then
  Dummy(1) = Zero
  call interf(0,Dummy,0,1)
end if

end subroutine molden_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GET_SPGP_INF(ISPGP,ITP,IGRP)
! Obtain groups defining supergroup ISPGP,ITP
!
! Jeppe Olsen, November 97

use lucia_data, only: IBSPGPFTP, ISPGPFTP, NGAS
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ISPGP, ITP
integer(kind=iwp), intent(out) :: IGRP(NGAS)
integer(kind=iwp) :: ISPGPABS

! Absolute group number
!write(u6,*) ' GET_SPGP_INF : ISPGP, ITP',ISPGP,ITP
ISPGPABS = ISPGP+IBSPGPFTP(ITP)-1
IGRP(:) = ISPGPFTP(1:NGAS,ISPGPABS)

#ifdef _DEBUGPRINT_
write(u6,*) ' GET_SPGP_INF : ISPGP ITP ISPGPABS',ISPGP,ITP,ISPGPABS
write(u6,*) ' Groups of supergroups'
call IWRTMA(IGRP,1,NGAS,1,NGAS)
#endif

end subroutine GET_SPGP_INF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKMID_MCLR(NVERT,NLEV,IDRT,IDOWN,IDAW,IUP,IRAW,LTV,
     &                 MIDLEV,NMIDV,MIDV1,MIDV2,MXUP,MXDWN,IPRINT)
C
C     PURPOSE: FIND THE MIDLEVEL
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION IDRT(NVERT,5)
      DIMENSION IDOWN(NVERT,0:3),IDAW(NVERT,0:4)
      DIMENSION IUP(NVERT,0:3),IRAW(NVERT,0:4)
      DIMENSION LTV(-1:NLEV)
C
C
C     SET UP A LEVEL-TO-VERTEX TABLE, LTV, AND IDENTIFY MIDVERTICES:
C
      LTAB=1
      DO  LEV=-1,NLEV
        LTV(LEV)=0
      END DO
      DO IV=1,NVERT
        LEV=IDRT(IV,LTAB)
        LTV(LEV)=LTV(LEV)+1
      END DO
      DO  LEV=NLEV,0,-1
       LTV(LEV-1)=LTV(LEV-1)+LTV(LEV)
      END DO
      DO LEV=-1,NLEV-1
        LTV(LEV)=1+LTV(LEV+1)
      END DO
C
C     USE IDAW,IRAW TABLES TO DETERMINE MIDLEV.
C     THE ASSUMPTION IS THAT A BALANCED NUMBER OF UPPER/LOWER WALKS
C     IS THE BEST CHOICE.
C
      IF (NLEV.eq.0) Then
       MIDLEV=0
      Else
      MIDLEV=1
      End If
      MINW=1000000
      DO 160 IL=1,NLEV-1
        NW=0
        DO 150 IV=LTV(IL),LTV(IL-1)-1
          NW=NW+IRAW(IV,4)-IDAW(IV,4)
150     CONTINUE
        NW=ABS(NW)
        IF(NW.GE.MINW) GOTO 160
        MIDLEV=IL
        MINW=NW
160   CONTINUE
      MIDV1=LTV(MIDLEV)
      MIDV2=LTV(MIDLEV-1)-1
      NMIDV=1+MIDV2-MIDV1
C
C     NOW FIND THE MAX NUMBERS OF UPPER AND LOWER WALKS. RESPECTIVELY
C     (DISREGARDING SYMMETRY)
C
      MXUP=0
      MXDWN=0
      DO 200 MV=MIDV1,MIDV2
        MXUP=MAX(MXUP,IRAW(MV,4))
        MXDWN=MAX(MXDWN,IDAW(MV,4))
200   CONTINUE
C
      IF( IPRINT.GE.5 ) THEN
        WRITE(6,*)
        WRITE(6,'(A,I3)')' MIDLEVEL =             ',MIDLEV
        WRITE(6,'(A,I3)')' NUMBER OF MIDVERTICES =',NMIDV
        WRITE(6,'(A,I3)')' FIRST MIDVERTEX =      ',MIDV1
        WRITE(6,'(A,I3)')' LAST MIDVERTEX =       ',MIDV2
        WRITE(6,'(A,I3)')' MAX. NO UPPER WALKS=   ',MXUP
        WRITE(6,'(A,I3)')' MAX. NO LOWER WALKS=   ',MXDWN
        WRITE(6,*)
      ENDIF
C
C
C     EXIT
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(IDOWN)
        CALL Unused_integer_array(IUP)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRCHAM(NSS,CHAMR,CHAMI)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 CHAMR(NSS,NSS),CHAMI(NSS,NSS)
C Write out a complex Hamiltonian (or other hermitian matrix)
C in a triangular format.
      DO JSTA=1,NSS,2
       JEND=MIN(NSS,JSTA+1)
       WRITE(6,*)
       WRITE(6,'(1X,A8,11X,I4,33X,I4)')'SO-STATE',(JSS,JSS=JSTA,JEND)
       DO ISS=JSTA,NSS
       WRITE(6,'(1X,I4,2x,2(A1,F15.11,A1,F15.11,A1,3x))')
     &           ISS,('(',CHAMR(ISS,JSS),',',CHAMI(ISS,JSS),
     &           ')',JSS=JSTA,MIN(ISS,JEND))
       END DO
      END DO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine RHS_SR2C(ITYP,IREV,NAS,NIS,NIN,lg_V1,lg_V2,ICASE,ISYM)
!SVC: this routine transforms the RHS arrays from SR format (V1) to C
!     format (V2) (IREV=0) and back (IREV=1), with ITYP specifying if
!     only the T matrix is used (ITYP=0) or the product of S and T
!     (ITYP=1).

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_Destroy, GA_NodeId
#endif
use caspt2_global, only: LUSBT
use EQSOLV, only: IDSTMAT, IDTMAT
use fake_GA, only: GA_Arrays
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ITYP, IREV, NAS, NIS, NIN, lg_V1, lg_V2, ICASE, ISYM
integer(kind=iwp) :: IDT
real(kind=wp), allocatable :: T(:)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iHiV1, iHiV2, iLoV1, iLoV2, jHiV1, jHiV2, jLoV1, jLoV2, LDV1, LDV2, lg_T, mV1, mV2, myRank, NCOL1, NCOL2, &
                     NROW1, NROW2
logical(kind=iwp) :: bStat

if (Is_Real_Par()) then
  if ((ICASE == 1) .or. (ICASE == 4)) then
    !-SVC: if case is A or C, the S/ST matrices are loaded as global arrays,
    !      then use the dgemm from GA to operate.
    call GA_CREATE_STRIPED('H',NAS,NIN,'TMAT',lg_T)
    if (ITYP == 0) then
      call PSBMAT_READ('T',iCase,iSym,lg_T,NAS*NIN)
    else if (ITYP == 1) then
      call PSBMAT_READ('M',iCase,iSym,lg_T,NAS*NIN)
    else
      write(u6,*) 'RHS_SR2C: invalid type = ',ITYP
      call AbEnd()
    end if

    if (IREV == 0) then
      call GA_DGEMM('N','N',NAS,NIS,NIN,One,lg_T,lg_V1,Zero,lg_V2)
    else
      call GA_DGEMM('T','N',NIN,NIS,NAS,One,lg_T,lg_V2,Zero,lg_V1)
    end if
    bStat = GA_Destroy(lg_T)
#   include "macros.fh"
    unused_var(bStat)
  else
    !-SVC: if case is not A or C, the S/ST matrices are stored in replicate
    !      fashion, and the RHS are stored as vertical stripes, so use dgemm
    !      on local memory, after accessing the local patch of the vector.
    call mma_allocate(T,NAS*NIN,Label='T')
    if (ITYP == 0) then
      IDT = IDTMAT(ISYM,ICASE)
    else if (ITYP == 1) then
      IDT = IDSTMAT(ISYM,ICASE)
    else
      write(u6,*) 'RHS_SR2C: invalid type = ',ITYP
      call AbEnd()
    end if
    call DDAFILE(LUSBT,2,T,NAS*NIN,IDT)
    !-SVC: get the local vertical stripes of the V1 and V2 vectors
    call GA_Sync()
    myRank = GA_NodeID()
    call GA_Distribution(lg_V1,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
    call GA_Distribution(lg_V2,myRank,iLoV2,iHiV2,jLoV2,jHiV2)
    if ((jLoV1 /= 0) .and. (jLoV2 /= 0)) then
      NROW1 = iHiV1-iLoV1+1
      NROW2 = iHiV2-iLoV2+1
      NCOL1 = jHiV1-jLoV1+1
      NCOL2 = jHiV2-jLoV2+1
      if ((NCOL1 /= NCOL2) .or. (NROW1 /= NIN) .or. (NROW2 /= NAS)) then
        write(u6,*) 'RHS_SR2C: inconsistent stripe size'
        write(u6,'(A,I3)') 'ICASE = ',ICASE
        write(u6,'(A,I3)') 'ISYM  = ',ISYM
        write(u6,'(A,2I6)') 'NCOL1, NCOL2 = ',NCOL1,NCOL2
        write(u6,'(A,2I6)') 'NROW1, NIN   = ',NROW1,NIN
        write(u6,'(A,2I6)') 'NROW2, NAS   = ',NROW2,NAS
        call AbEnd()
      end if
      call GA_Access(lg_V1,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)
      call GA_Access(lg_V2,iLoV2,iHiV2,jLoV2,jHiV2,mV2,LDV2)
      if (IREV == 0) then
        call DGEMM_('N','N',NAS,NCOL1,NIN,One,T,NAS,DBL_MB(mV1),LDV1,Zero,DBL_MB(mV2),LDV2)
      else
        call DGEMM_('T','N',NIN,NCOL1,NAS,One,T,NAS,DBL_MB(mV2),LDV2,Zero,DBL_MB(mV1),LDV1)
        !write(u6,*) 'Fingerprint =',RHS_DDOT(NAS,NIN,lg_V1,lg_V1)
      end if
      call GA_Release_Update(lg_V1,iLoV1,iHiV1,jLoV1,jHiV1)
      call GA_Release_Update(lg_V2,iLoV2,iHiV2,jLoV2,jHiV2)
    end if
    call mma_deallocate(T)
    call GA_Sync()
  end if
else
#endif
  call mma_allocate(T,NAS*NIN,Label='T')
  if (ITYP == 0) then
    IDT = IDTMAT(ISYM,ICASE)
  else if (ITYP == 1) then
    IDT = IDSTMAT(ISYM,ICASE)
  else
    write(u6,*) 'RHS_SR2C: invalid type = ',ITYP
    call AbEnd()
  end if
  call DDAFILE(LUSBT,2,T,NAS*NIN,IDT)
  if (IREV == 0) then
    call DGEMM_('N','N',NAS,NIS,NIN,One,T,NAS,GA_Arrays(lg_V1)%A,NIN,Zero,GA_Arrays(lg_V2)%A,NAS)
  else
    call DGEMM_('T','N',NIN,NIS,NAS,One,T,NAS,GA_Arrays(lg_V2)%A,NAS,Zero,GA_Arrays(lg_V1)%A,NIN)
  end if
  call mma_deallocate(T)
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine RHS_SR2C

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_RSTD_GETIND1()
C
C     Purpose: read and set some index arrays for diagonal restart.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

C     Read info.
C     ----------

      IOPT = 2
      IADR = 0
      LTOT = NSYM*NNSHL
      CALL IDAFILE(LURED,IOPT,IWORK(ip_NNBSTRSH),LTOT,IADR)

C     Set up IIBSTRSH etc.
C     --------------------

      IRED = 1
      CALL CHO_SETREDIND(IWORK(ip_IIBSTRSH),IWORK(ip_NNBSTRSH),
     &                   NSYM,NNSHL,IRED)

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE RSSBCBN_td(IASM,IATP,IBSM,IBTP,JASM,JATP,JBSM,JBTP,
     &                  IAEL1,IAEL3,IBEL1,IBEL3,
     &                  JAEL1,JAEL3,JBEL1,JBEL3,
     &                  NAEL,NBEL,
     &                  IJAGRP,IJBGRP,
     &                  SB,CB,IDOH2,
     &                  ADSXA,SXSTST,STSTSX,DXSTST,STSTDX,SXDXSX,
     &                  NTSOB,IBTSOB,ITSOB,MAXI,MAXK,
     &                  SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,
     &                  XINT,C2,NSMOB,NSMST,NSMSX,NSMDX,
     &                  NIA,NIB,NJA,NJB,MXPOBS,IPRNT,IST,
     &                  CJRES,SIRES,NOPART,TimeDep)
*
* Contributions to sigma block (iasm iatp, ibsm ibtp ) from
* C block (jasm jatp , jbsm, jbtp)
*
* =====
* Input
* =====
*
* IASM,IATP : Symmetry and type of alpha strings in sigma
* IBSM,IBTP : Symmetry and type of beta  strings in sigma
* JASM,JATP : Symmetry and type of alpha strings in C
* JBSM,JBTP : Symmetry and type of beta  strings in C
* IAEL1,IAEL3 : Number of elecs in RAS1(RAS3) for alpha strings in sigma
* IBEL1,IBEL3 : Number of elecs in RAS1(RAS3) for  beta strings in sigma
* JAEL1,JAEL3 : Number of elecs in RAS1(RAS3) for alpha strings in C
* JBEL1,JBEL3 : Number of elecs in RAS1(RAS3) for  beta strings in C
* NAEL : Number of alpha electrons
* NBEL : Number of  beta electrons
* IJAGRP    : IA and JA belongs to this group of strings
* IJBGRP    : IB and JB belongs to this group of strings
* CB : Input c block
* IDOH2 : = 0 => no two electron operator
* IDOH2 : = 1 =>    two electron operator
* ADASX : sym of a+, a => sym of a+a
* ADSXA : sym of a+, a+a => sym of a
* SXSTST : Sym of sx,!st> => sym of sx !st>
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
*          is nonvanishing by symmetry
* DXSTST : Sym of dx,!st> => sym of dx !st>
* STSTDX : Sym of !st>,dx!st'> => sym of dx so <st!dx!st'>
*          is nonvanishing by symmetry
* NTSOB  : Number of orbitals per type and symmetry
* IBTSOB : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* MAXI   : Largest Number of ' spectator strings 'treated simultaneously
* MAXK   : Largest number of inner resolution strings treated at simult.
*
* IST, IDOH2 : See RASSG3 input description
*
* ======
* Output
* ======
* SB : fresh sigma block
*
* =======
* Scratch
* =======
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* C2 : Must hold largest STT block of sigma or C
*
* XINT : Scratch space for integrals.
*
* Jeppe Olsen , Winter of 1991
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER  ADSXA(*),SXSTST(*)
      INTEGER  STSTSX(*),DXSTST(*),STSTDX(*),SXDXSX(*)
      Logical TimeDep
*. Output
      DIMENSION CB(*),SB(*)
*. Scratch
      DIMENSION SSCR(*),CSCR(*)
      DIMENSION I1(MAXK,*),XI1S(MAXK,*),I2(MAXK,*),XI2S(MAXK,*),
     &          I3(MAXK,*),XI3S(MAXK,*),I4(MAXK,*),XI4S(MAXK,*)
      DIMENSION C2(*),CJRES(*),SIRES(*),XINT(*)
      DIMENSION NTSOB(*),IBTSOB(*),ITSOB(*)
*
      NTEST =  0
      NTEST = MAX(NTEST,IPRNT)
      icheck=3
*
      ieaw=0
      if (ist.eq.2) ieaw=1
*
*
* =============================
* Sigma beta beta contribution
* =============================
*
* Sigma aa(IA,IB) = sum(i.gt.k,j.gt.l)<IB!Eb(ij)Eb(kl)!JB>
*                 * ((ij!kl)-(il!kj)) C(IA,JB)
*                 + sum(ij) <IB!Eb(ij)!JB> H(ij) C(IA,JB)
*
      IF(IATP.EQ.JATP.AND.JASM.EQ.IASM) THEN
*
*         One electron part
*
         IF(IST.EQ.1) THEN
           SIGN = 1.0D0
         ELSE
           SIGN = -1.0D0
         END IF
         IF(NBEL.GE.1) THEN
            CALL RSBB1E(IBSM,IBTP,JBSM,JBTP,IJBGRP,NIA,
     &         IBEL1,IBEL3,JBEL1,JBEL3,
     &         SB,CB,
     &         ADSXA,SXSTST,STSTSX,NTSOB,IBTSOB,ITSOB,MAXI,MAXK,
     &         SSCR,CSCR,I1,XI1S,XINT,
     &         NSMOB,NSMST,NSMSX,MXPOBS,SIGN)
*
*               Call RECPRT('SSCR after RSBB1E',' ',SSCR,5,1)
         END IF
*
*         Two electron part
*
         IF((iand(icheck,1).eq.1).and.IDOH2.NE.0.AND.NBEL.GE.2)
     &   THEN
*         Write(*,*)'Timedep in rssbcbn_td',TimeDep
         CALL RSBB2A(IBSM,IBTP,JBSM,JBTP,IJBGRP,NIA,
     &                IBEL1,IBEL3,JBEL1,JBEL3,
     &                SB,CB,
     &                ADSXA,DXSTST,STSTDX,SXDXSX,
     &                NTSOB,IBTSOB,ITSOB,MAXI,MAXK,
     &                SSCR,CSCR,I1,XI1S,XINT,
     &                NSMOB,NSMST,NSMSX,NSMDX,MXPOBS,SIGN,
     &                NOPART,TimeDep,ieaw )
*
*               Call RECPRT('SSCR after RSBB2A',' ',SSCR,5,1)
         END IF
      END IF
*
*====================================*
* Mixed alpha-beta double excitations
*====================================*
*
      IF((iand(icheck,2).eq.2).and.IDOH2.NE.0.AND.
     &    NAEL.GE.1.AND.NBEL.GE.1) THEN
*
          ieaw=0
          if (ist.eq.2) ieaw=1
*          Write(*,*)'ieaw in rssbcbn_td ',ieaw
          CALL TRPMAT(CB,NJA,NJB,C2)
          CALL DCOPY_(NJA*NJB,C2,1,CB,1)
          CALL TRPMAT(SB,NIA,NIB,C2)
          CALL DCOPY_(NIA*NIB,C2,1,SB,1)
          IIITRNS = 1
          IF(IIITRNS.EQ.1.AND.NIB.GT.NIA.AND.NJB.GT.NJA) THEN
             JJJTRNS = 1
          ELSE
             JJJTRNS = 0
          END IF
          IF(JJJTRNS.EQ.1.AND.IST.EQ.2) THEN
            IFACTOR = -1
          ELSE
            IFACTOR = 1
          END IF
          IF (JJJTRNS.EQ.0) THEN
          CALL RSBB2BN(IASM,IATP,IBSM,IBTP,NIA,NIB,
     &                JASM,JATP,JBSM,JBTP,NJA,NJB,
     &                IJAGRP,IJBGRP,
     &                IAEL1,IAEL3,JAEL1,JAEL3,
     &                IBEL1,IBEL3,JBEL1,JBEL3,
     &                SB,CB,
     &                ADSXA,STSTSX,
     &                NTSOB,IBTSOB,ITSOB,MAXK,
     &                SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,
     &                XINT,
     &                NSMOB,NSMST,NSMSX,NSMDX,MXPOBS,0,1,
     &                CJRES,SIRES,C2,NTEST,IFACTOR,ieaw,
     &                TimeDep )
*
*          Call RECPRT('SSCR after RSBB2BN',' ',SSCR,5,1)
*
          ELSE IF ( JJJTRNS.EQ.1) THEN
            CALL TRPMAT(SB,NIB,NIA,C2)
            CALL DCOPY_(NIA*NIB,C2,1,SB,1)
            CALL TRPMAT(CB,NJB,NJA,C2)
            CALL DCOPY_(NJA*NJB,C2,1,CB,1)
*
            CALL RSBB2BN(IBSM,IBTP,IASM,IATP,NIB,NIA,
     &                JbSM,JbTP,JaSM,JaTP,NJb,NJa,
     &                IJbGRP,IJaGRP,
     &                IbEL1,IbEL3,JbEL1,JbEL3,
     &                IaEL1,IaEL3,JaEL1,JaEL3,
     &                SB,CB,
     &                ADSXA,STSTSX,
     &                NTSOB,IBTSOB,ITSOB,MAXK,
     &                SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,
     &                XINT,
     &                NSMOB,NSMST,NSMSX,NSMDX,MXPOBS,0,1,
     &                CJRES,SIRES,C2,NTEST,IFACTOR,ieaw,
     &                TimeDep)
*
*                Call RECPRT('SSCR after RSBB2BN',' ',SSCR,5,1)
*
            CALL TRPMAT(SB,NIA,NIB,C2)
            CALL DCOPY_(NIA*NIB,C2,1,SB,1)
            CALL TRPMAT(CB,NJA,NJB,C2)
            CALL DCOPY_(NJA*NJB,C2,1,CB,1)
          END IF
*.        Restore order !
          CALL TRPMAT(CB,NJB,NJA,C2)
          CALL DCOPY_(NJA*NJB,C2,1,CB,1)
          CALL TRPMAT(SB,NIB,NIA,C2)
          CALL DCOPY_(NIA*NIB,C2,1,SB,1)
      END IF
*
* =============================
* Sigma alpha contribution
* =============================
*
*. Transpose for alpha excitations
*
      IF(NAEL.GE.1.AND.IBTP.EQ.JBTP.AND.IBSM.EQ.JBSM) THEN
           CALL TRPMAT(CB,NJA,NJB,C2)
           CALL DCOPY_(NJA*NJB,C2,1,CB,1)
           CALL TRPMAT(SB,NIA,NIB,C2)
           CALL DCOPY_(NIA*NIB,C2,1,SB,1)
*
* alpha single excitation
*
           SIGN = 1.0D0
           CALL RSBB1E(IASM,IATP,JASM,JATP,IJAGRP,NIB,
     &                IAEL1,IAEL3,JAEL1,JAEL3,
     &                SB,CB,
     &                ADSXA,SXSTST,STSTSX,
     &                NTSOB,IBTSOB,ITSOB,MAXI,MAXK,
     &                SSCR,CSCR,I1,XI1S,XINT,
     &                NSMOB,NSMST,NSMSX,MXPOBS,SIGN)
*
*                Call RECPRT('SSCR after RSBB1E',' ',SSCR,5,1)
*
* alpha double excitation
*
           IF((iand(icheck,1).eq.1).and.NAEL.GE.2.AND.IDOH2.NE.0)
     &     Then
*            Write(*,*)'Timedep in rssbcbn_td',TimeDep
            CALL RSBB2A(IASM,IATP,JASM,JATP,IJAGRP,NIB,
     &           IAEL1,IAEL3,JAEL1,JAEL3,
     &           SB,CB,
     &           ADSXA,DXSTST,STSTDX,SXDXSX,
     &           NTSOB,IBTSOB,ITSOB,MAXI,MAXK,
     &           SSCR,CSCR,I1,XI1S,XINT,
     &           NSMOB,NSMST,NSMSX,NSMDX,MXPOBS,SIGN,
     &           NOPART,TimeDep,ieaw)
*
*                Call RECPRT('SSCR after RSBB2A',' ',SSCR,5,1)
*
           END IF
* Restore order !
           CALL TRPMAT(SB,NIB,NIA,C2)
           CALL DCOPY_(NIA*NIB,C2,1,SB,1)
           CALL TRPMAT(CB,NJB,NJA,C2)
           CALL DCOPY_(NJA*NJB,C2,1,CB,1)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PLF2_BP(AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
!***********************************************************************
!                                                                      *
!  object: to sift and index the petite list format integrals.         *
!                                                                      *
!          the indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          May '90                                                     *
!***********************************************************************

use SOAO_Info, only: iAOtSO
use Breit, only: D_tensor
use eval_arrays, only: PAO
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ijkl, iCmp, jCmp, kCmp, lCmp, iAO(4), iAOst(4), iBas, jBas, kBas, lBas, kOp(4)
real(kind=wp), intent(in) :: AOint(ijkl,6,iCmp,jCmp,kCmp,lCmp)
integer(kind=iwp) :: i1, i2, i3, i4, iAOi, iAOj, iAOk, iAOl, iAOSti, iAOStj, iAOStk, iAOStl, iSO, iSOi, iSOs(4), jSO, jSOj, kSO, &
                     kSOk, lSO, lSOl, nijkl

! quadruple loop over elements of the basis functions angular
! description. loops are reduced to just produce unique SO integrals
! observe that we will walk through the memory in AOint in a
! sequential way.

#ifdef _DEBUGPRINT_
write(u6,*) ' PLF2_BP'
call RecPrt('Plf2_BP: AOINT',' ',AOInt,ijkl*6,iCmp*jCmp*kCmp*lCmp)
call RecPrt('Plf2_BP: PAO',' ',PAO,ijkl,iCmp*jCmp*kCmp*lCmp)
#endif

if (.not. associated(PAO)) call Abend()

iAOsti = iAOst(1)
iAOstj = iAOst(2)
iAOstk = iAOst(3)
iAOstl = iAOst(4)
iAOi = iAO(1)
iAOj = iAO(2)
iAOk = iAO(3)
iAOl = iAO(4)

do i1=1,iCmp
  iSOs(1) = iAOtSO(iAOi+i1,kOp(1))+iAOsti
  do i2=1,jCmp
    iSOs(2) = iAOtSO(iAOj+i2,kOp(2))+iAOstj
    do i3=1,kCmp
      iSOs(3) = iAOtSO(iAOk+i3,kOp(3))+iAOstk
      do i4=1,lCmp
        iSOs(4) = iAOtSO(iAOl+i4,kOp(4))+iAOstl

        iSO = iSOs(1)
        jSO = iSOs(2)
        kSO = iSOs(3)
        lSO = iSOs(4)

        nijkl = 0
        do lSOl=lSO,lSO+lBas-1
          do kSOk=kSO,kSO+kBas-1
            do jSOj=jSO,jSO+jBas-1
              do iSOi=iSO,iSO+iBas-1
                nijkl = nijkl+1
                D_tensor(1,1) = D_tensor(1,1)+AOint(nijkl,1,i1,i2,i3,i4)*PAO(nijkl,i1,i2,i3,i4)
                D_tensor(2,1) = D_tensor(2,1)+AOint(nijkl,2,i1,i2,i3,i4)*PAO(nijkl,i1,i2,i3,i4)
                D_tensor(3,1) = D_tensor(3,1)+AOint(nijkl,3,i1,i2,i3,i4)*PAO(nijkl,i1,i2,i3,i4)
                D_tensor(2,2) = D_tensor(2,2)+AOint(nijkl,4,i1,i2,i3,i4)*PAO(nijkl,i1,i2,i3,i4)
                D_tensor(2,3) = D_tensor(2,3)+AOint(nijkl,5,i1,i2,i3,i4)*PAO(nijkl,i1,i2,i3,i4)
                D_tensor(3,3) = D_tensor(3,3)+AOint(nijkl,6,i1,i2,i3,i4)*PAO(nijkl,i1,i2,i3,i4)

              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do

end subroutine PLF2_BP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE VPACK4(IN,IND,NBI,NINT)
      implicit none
      integer IN,IND,NBI,NINT, I
CR8   1
C     INTEGER*2 IND
      DIMENSION IN(*),IND(*)
CREA  2
C     DATA I1,I2,I3 /48,32,16/
C      NBV=4*NBI
CR8   2
      DO 2 I=1,NINT
      IND(I)=IN(I)
 2    CONTINUE
CREA  4
C     IF(NINT.NE.NBV)THEN
C     DO 1 I=NINT+1,NBV
C1     IN(I)=0
C      ENDIF
CCDC 11
C     CALL Q8SHIFTV (X'08',,IN(1;NBI),,I1,,IND(1;NBI))
C      NN=NBI+1
C     CALL Q8LINKV  (X'10')
C     CALL Q8SHIFTV (X'08',,IN(NN;NBI),,I2,,IN(1;NBI))
C     CALL Q8ORV    (X'02',,IND(1;NBI),,IN(1;NBI),,IND(1;NBI))
C      NN=NBI+NN
C     CALL Q8LINKV  (X'10')
C     CALL Q8SHIFTV (X'08',,IN(NN;NBI),,I3,,IN(1;NBI))
C     CALL Q8ORV    (X'02',,IND(1;NBI),,IN(1;NBI),,IND(1;NBI))
C      NN=NBI+NN
C      CALL Q8ORV    (X'02',,IND(1;NBI),,IN(NN;NBI),,IND(1;NBI))
CREA 11
C      DO 2 I=1,NBI
C2     IND(I)=SHIFT(IN(I),I1)
C      NN=NBI
C      DO 3 I=1,NBI
C3     IND(I)=OR(IND(I),SHIFT(IN(I+NN),I2))
C      NN=NBI*2
C      DO 4 I=1,NBI
C4     IND(I)=OR(IND(I),SHIFT(IN(I+NN),I3))
C      NN=NBI*3
C      DO 5 I=1,NBI
C5     IND(I)=OR(IND(I),      IN(I+NN))
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NBI)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Jeppe Olsen                                      *
************************************************************************
      FUNCTION ISTRNM(IOCC,NORB,NEL,Z,NEWORD,IREORD)
*
* Adress of string IOCC
*
* version of Winter 1990 , Jeppe Olsen
*
      INTEGER Z
      DIMENSION IOCC(*),NEWORD(*),Z(NORB,*)
*
      IZ = 1
      DO 100 I = 1,NEL
        IZ = IZ + Z(IOCC(I),I)
  100 CONTINUE
*
      IF(IREORD.EQ.0) THEN
        ISTRNM = IZ
      ELSE
        ISTRNM = NEWORD(IZ)
      END IF
*
      NTEST = 0
      IF ( NTEST .GT. 1 ) THEN
        WRITE(6,*) ' STRING'
        CALL IWRTMA(IOCC,1,NEL,1,NEL)
        WRITE(6,*) ' Z matrix '
        CALL IWRTMA(Z,NORB,NEL,NORB,NEL)
C       WRITE(6,*) ' First two elements of reorder array'
C       CALL IWRTMA(NEWORD,1,2,1,2)
        WRITE(6,*) ' ADRESS OF STRING ',ISTRNM
        WRITE(6,*) ' REV LEX number : ', IZ
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Yoshio Nishimoto                                 *
!***********************************************************************
!
! See cgs_mod.F90 for details

subroutine CGS_x(nDensC,nConf1,nRoots,iSym,jspin,iter,ipCI,ipDia,ipS1,ipS2,ipST,ipCIT,ipCId,ipPre2,reco,Fancy,Kappa,dKappa,Sigma, &
                 Temp4,Sc1,iPre,delta,resk,resci,deltak,deltac)

use ipPage, only: ipIn, opOut, W
use ISRotation, only: DMInvISR, InvSCF, ISR
use cgs_mod, only: CGSvec, PCGS
use Definitions, only: wp, iwp

implicit none

integer(kind=iwp), intent(in) :: nDensC, nConf1, nRoots, jspin, iPre(*)
integer(kind=iwp), intent(inout) :: iSym, iter
integer(kind=iwp), intent(in) :: ipCI, ipDia, ipS1, ipS2, ipST, ipCIT, ipCId, ipPre2
real(kind=wp), intent(inout) :: reco, Fancy(*), Kappa(*), dKappa(*), Sigma(*), Temp4(*), Sc1(*), delta, resk, resci, deltak, deltac
real(kind=wp) :: ralpha, rAlphaC, rAlphaK, rbeta
real(kind=wp), external :: ddot_

select case (PCGS)
  case (4)
    !! precondition p (K-1*p)
    call ipIn(ipS2)
    call DMinvCI_SA(CGSvec%ipPvec,W(ipCId)%A,Fancy)
    call opOut(ipCI)
    call opOut(ipDia)

    call ipIn(ipPre2)
    call DMInvKap(W(ipPre2)%A,iPre,CGSvec%Pvec,dKappa,Sc1,iSym,iter)
    call opOut(ipPre2)

    if (.not. InvSCF) call DMInvISR(ISR%Pvec,ISR%p)

    !! A*K-1*p
    call TimesE2(dKappa,ipCId,1,reco,jspin,ipS2,Temp4,ipS1)
  case (5)
    if (.not. InvSCF) ISR%p(:,:) = ISR%Pvec(:,:)
    !! A*p
    call TimesE2(CGSvec%Pvec,CGSvec%ipPvec,1,reco,jspin,ipS2,dKappa,ipCId)

    !! precondition A*p (K-1*A*p)
    call ipIn(ipS2)
    call DMinvCI_SA(ipCId,W(ipS1)%A,Fancy)
    call opOut(ipCI)
    call opOut(ipDia)

    call ipIn(ipPre2)
    call DMInvKap(W(ipPre2)%A,iPre,dKappa,Temp4,Sc1,iSym,iter)
    call opOut(ipPre2)

    if (.not. InvSCF) then
      ISR%p(:,:) = ISR%Ap(:,:)
      call DMInvISR(ISR%p,ISR%Ap)
    end if
end select

!! compute alpha
rAlphaK = ddot_(nDensC,CGSvec%R0,1,Temp4,1)
rAlphaC = ddot_(nConf1*nroots,W(CGSvec%ipR0)%A,1,W(ipS1)%A,1)
if (.not. InvSCF) rAlphaC = rAlphaC+ddot_(nRoots**2,ISR%R0,1,ISR%Ap,1)
rAlpha = delta/(rAlphaK+rAlphaC)

! Algorithm 4: q_k = u_k - alpha*(A*K-1*p)
! Algorithm 5: q_k = u_k - alpha*(K-1*A*p)
CGSvec%Qvec(1:nDensC) = CGSvec%Uvec(1:nDensC)-ralpha*Temp4(1:nDenSC)
W(CGSvec%ipQvec)%A(1:nConf1*nRoots) = W(CGSvec%ipUvec)%A(1:nConf1*nRoots)-ralpha*W(ipS1)%A(1:nConf1*nRoots)
if (.not. InvSCF) ISR%Qvec(:,:) = ISR%Uvec(:,:)-ralpha*ISR%Ap(:,:)

!! construct u = u + q
CGSvec%Uvec(1:nDensC) = CGSvec%Uvec(1:nDensC)+CGSvec%Qvec(1:nDensC)
W(CGSvec%ipUvec)%A(1:nConf1*nRoots) = W(CGSvec%ipUvec)%A(1:nConf1*nRoots)+W(CGSvec%ipQvec)%A(1:nConf1*nRoots)
if (.not. InvSCF) ISR%Uvec(:,:) = ISR%Uvec(:,:)+ISR%Qvec(:,:)

select case (PCGS)
  case (4)
    !! precondition u + q
    call ipIn(ipS2)
    call DMinvCI_SA(CGSvec%ipUvec,W(ipCId)%A,Fancy)
    call opOut(ipCI)
    call opOut(ipDia)

    call ipIn(ipPre2)
    call DMInvKap(W(ipPre2)%A,iPre,CGSvec%Uvec,dKappa,Sc1,iSym,iter)
    call opOut(ipPre2)

    if (.not. InvSCF) call DMInvISR(ISR%Uvec,ISR%p)

    !! x_k+1 = x_k + alpha*K-1*(u+q)
    Kappa(1:nDensC) = Kappa(1:nDensC)+ralpha*dKappa(1:nDensC)
    W(ipCIT)%A(1:nConf1*nRoots) = W(ipCIT)%A(1:nConf1*nRoots)+ralpha*W(ipCId)%A(1:nConf1*nRoots)
    if (.not. InvSCF) ISR%Xvec(:,:) = ISR%Xvec(:,:)+ralpha*ISR%p(:,:)

    !! A*K-1*(u+q)
    call TimesE2(dKappa,ipCId,1,reco,jspin,ipS2,Temp4,ipS1)
  case (5)
    !! x_k+1 = x_k + alpha*(u+q)
    Kappa(1:nDensC) = Kappa(1:nDensC)+ralpha*CGSvec%Uvec(1:nDensC)
    W(ipCIT)%A(1:nConf1*nRoots) = W(ipCIT)%A(1:nConf1*nRoots)+ralpha*W(CGSvec%ipUvec)%A(1:nConf1*nRoots)
    if (.not. InvSCF) ISR%Xvec(:,:) = ISR%Xvec(:,:)+ralpha*ISR%Uvec(:,:)

    !! A*(u+q)
    if (.not. InvSCF) ISR%p(:,:) = ISR%Uvec(:,:)
    call TimesE2(CGSvec%Uvec,CGSvec%ipUvec,1,reco,jspin,ipS2,dKappa,ipCId)

    !! precondition A*(u+q)
    !! rather than computing K-1*r_k+1, accumulate -K^1*A*(u+q)
    call ipIn(ipS2)
    call DMinvCI_SA(ipCId,W(ipS1)%A,Fancy)
    call opOut(ipCI)
    call opOut(ipDia)

    call ipIn(ipPre2)
    call DMInvKap(W(ipPre2)%A,iPre,dKappa,Temp4,Sc1,iSym,iter)
    call opOut(ipPre2)

    if (.not. InvSCF) then
      ISR%p(:,:) = ISR%Ap(:,:)
      call DMInvISR(ISR%p,ISR%Ap)
    end if
end select

!! r_k+1 = r_k - alpha*A*(u+q)
Sigma(1:nDensC) = Sigma(1:nDensC)-ralpha*Temp4(1:nDensC)
resk = sqrt(ddot_(nDensC,Sigma,1,Sigma,1))
W(ipST)%A(1:nConf1*nRoots) = W(ipST)%A(1:nConf1*nRoots)-ralpha*W(ipS1)%A(1:nConf1*nRoots)
resci = sqrt(ddot_(nconf1*nroots,W(ipST)%A,1,W(ipST)%A,1))
if (.not. InvSCF) then
  ISR%Rvec(:,:) = ISR%Rvec(:,:)-ralpha*ISR%Ap(:,:)
  resci = resci+sqrt(ddot_(nRoots**2,ISR%Rvec,1,ISR%Rvec,1))
end if

!! compute beta
deltaK = ddot_(nDensC,CGSvec%R0,1,Sigma,1)
deltaC = ddot_(nConf1*nroots,W(CGSvec%ipR0)%A,1,W(ipST)%A,1)
if (.not. InvSCF) deltaC = deltaC+ddot_(nRoots**2,ISR%R0,1,ISR%Rvec,1)
rbeta = (deltaC+deltaK)/delta
delta = deltac+deltaK

!! u_k = r_k + beta*q
CGSvec%Uvec(1:nDensC) = Sigma(1:nDensC)+rbeta*CGSvec%Qvec(1:nDensC)
W(CGSvec%ipUvec)%A(1:nConf1*nRoots) = W(ipST)%A(1:nConf1*nRoots)+rbeta*W(CGSvec%ipQvec)%A(1:nConf1*nRoots)
if (.not. InvSCF) ISR%Uvec(:,:) = ISR%Rvec(:,:)+rbeta*ISR%Qvec(:,:)

!! p = u + beta*q + beta*beta*p
CGSvec%Pvec(1:nDensC) = CGSvec%Uvec(1:nDensC)+rbeta*CGSvec%Qvec(1:nDensC)+(rbeta**2)*CGSvec%Pvec(1:nDensC)
W(CGSvec%ipPvec)%A(1:nConf1*nRoots) = W(CGSvec%ipUvec)%A(1:nConf1*nRoots)+rbeta*W(CGSvec%ipQvec)%A(1:nConf1*nRoots)+ &
                                      (rbeta**2)*W(CGSvec%ipPvec)%A(1:nConf1*nRoots)
if (.not. InvSCF) ISR%Pvec(:,:) = ISR%Uvec(:,:)+rbeta*ISR%Qvec(:,:)+rbeta*rbeta*ISR%Pvec(:,:)

end subroutine CGS_x

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AUXC(N,NBC,TC,ANSC)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, NBC
real(kind=wp), intent(in) :: TC
real(kind=wp), intent(out) :: ANSC
integer(kind=iwp) :: I
real(kind=wp) :: DUM, X, Y

X = One/(One+TC)
Y = TC*X
X = sqrt(X**(NBC+1))
DUM = One
if (N > 1) then
  do I=N,2,-1
    DUM = DUM*Y*real(NBC+2*I-3,kind=wp)/real(2*I-2,kind=wp)+One
  end do
end if
ANSC = X*DUM

return

end subroutine AUXC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ADD_SKAIIB(SB,NI,NIA,SKAIIB,NKA,NIB,I,ISCA,SSCA)
! Update Transposed sigma block with contributions for given orbital index j
! from the matrix S(Ka,i,Ib)
!
! S(Ib,Isca(Ka)) =  S(Ib,Isca(Ka)) + Ssca(Ka)*S(Ka,I,Ib)
!
! For efficient processing of alpha-beta loop

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NI, NIA, NKA, NIB, I, ISCA(*)
real(kind=wp), intent(inout) :: SB(NIB,NIA)
real(kind=wp), intent(in) :: SKAIIB(*), SSCA(*)
integer(kind=iwp) :: IADR, IADR0, IB, ICBL, ICEND, ICOFF, ICONST, IROW, KA, LBLK, NBLK
real(kind=wp) :: S

! To get rid of annoying and incorrect compiler warnings
ICOFF = 0

!LBLK = 100
LBLK = 40
NBLK = NIB/LBLK
if (LBLK*NBLK < NIB) NBLK = NBLK+1
do ICBL=1,NBLK
  if (ICBL == 1) then
    ICOFF = 1
  else
    ICOFF = ICOFF+LBLK
  end if
  ICEND = min(ICOFF+LBLK-1,NIB)
  ICONST = NKA*NI
  IADR0 = (I-1)*NKA+(ICOFF-1-1)*NKA*NI
  if (ICEND > ICOFF) then
    ! Use form with Inner loop over IB
    do KA=1,NKA
      if (ISCA(KA) /= 0) then
        S = SSCA(KA)
        IROW = ISCA(KA)
        !IADR = KA+(I-1)*NKA+(ICOFF-1-1)*NKA*NI
        IADR = IADR0+KA
        do IB=ICOFF,ICEND
          ! Address of S(Ka,i,Ib)
          IADR = IADR+ICONST
          SB(IB,IROW) = SB(IB,IROW)+S*SKAIIB(IADR)
        end do
      end if
    end do
  else
    ! Form with no loop over IB
    do KA=1,NKA
      if (ISCA(KA) /= 0) then
        S = SSCA(KA)
        IROW = ISCA(KA)
        IADR = IADR0+KA+ICONST
        !do IB=ICOFF,ICEND
        ! Address of S(Ka,i,Ib)
        !IADR = IADR+ICONST
        SB(ICOFF,IROW) = SB(ICOFF,IROW)+S*SKAIIB(IADR)
        !end do
      end if
    end do
  end if
  ! End of test of ICOFF=ICEND
end do

end subroutine ADD_SKAIIB

***********************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SymTrafo(LUPROP,ip,lOper,nComp,nBas,nIrrep,Label,
     &                    MolWgh,SOInt,LenTot)
cbs
cbs   Purpose: combine SO-integrals from amfi to symmetry-adapted
cbs   integrals on one file AOPROPER_MF_SYM
cbs
cbs
      implicit real*8 (a-h,o-z)
#include "para.fh"
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: AMFI_Int(:,:), Scr(:,:)
      Integer, Allocatable:: iSO_info(:,:)
      parameter(maxorbs=MxOrb)
      parameter(maxcent=MxAtom)
      Real*8 SOInt(LenTot)
      character*8 xa,ya,za,xa2
      character*3 END
CBS   character*20 filename
      logical  EX
CBS   namelist /SYMTRA/ none
      dimension xa(4),ya(4),za(4)
      dimension xa2(4)
      dimension ncent(maxorbs), Lval(maxorbs),mval(maxorbs),
     *          nadpt(maxorbs),nphase(8,maxorbs),idummy(8),
     *          Lhighcent(maxcent),Lcent(MxCart),Mcent(MxCart),
     *          ncontcent(0:Lmax),numballcart(maxcent)
      allocatable ifirstLM(:,:,:)
      Integer ip(nComp), nBas(0:nIrrep-1), lOper(nComp), ipC(MxAtom)
      Character Label*8
c#######################################################################
      IPNT(I,J)=(max(i,j)*max(i,j)-max(i,j))/2 +min(i,j)
*
      END='   '  ! added due to cray warnings. B.S. 04/10/04
      xa(1)='********'
      ya(1)='********'
      za(1)='********'
      xa(2)='        '
      ya(2)='        '
      Za(2)='        '
      xa(3)='ANTISYMM'
      ya(3)='ANTISYMM'
      Za(3)='ANTISYMM'
      xa(4)='X1SPNORB'
      ya(4)='Y1SPNORB'
      ZA(4)='Z1SPNORB'
      call mma_allocate(ifirstLM,[0,Lmax],[-Lmax,Lmax],[1,maxcent],
     &                  label='ifirstLM')
c
c     read information from SYMINFO
      isymunit=isfreeunit(58)
      call f_inquire('SYMINFO',EX)
      if (.not.EX) Call SysAbendMsg('systrafo',
     &                  'SYMINFO not present','Sorry')
      call molcas_open(isymunit,'SYMINFO')
      rewind(isymunit)
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      write(6,*) 'Symmetry adapation of the SO-integrals'
#endif
      read(isymunit,*)
      read(isymunit,*)
      read(isymunit,*)
      numboffunct=0
      do while(END.ne.'END')
         numboffunct=numboffunct+1
         read(isymunit,'(A3)') END
      enddo
#ifdef _DEBUGPRINT_
      write(6,*) 'there are totally ',numboffunct,' functions'
#endif
      if (numboffunct.gt.maxorbs)
     &Call SysAbendMsg('symtrafo','increase maxorbs in symtrafo',' ')
      rewind isymunit
      read(isymunit,*)
      read(isymunit,*)
      numbofcent=0
      do irun=1,numboffunct
         read(isymunit,*) index,ncent(irun),lval(irun),
     &                    mval(irun),nadpt(irun),
     &                    (nphase(I,irun),I=1,nadpt(irun))
         numbofcent=max(numbofcent,ncent(irun))
         if (index.ne.irun)
     &      Call SysAbendMsg('symtrafo',
     &                       'weird numbering  on SYMINFO',' ' )
      End Do
      Close(iSymUnit)
#ifdef _DEBUGPRINT_
      write(6,*) 'number of unique centres' , numbofcent
#endif
c
c     clean up arrays for new integrals
      numboffunct3=(numboffunct*numboffunct+numboffunct)/2
*
      Call mma_allocate(AMFI_Int,numboffunct3,3,Label='AMFI_Int')
      AMFI_Int(:,:)=Zero
*
      nSOs=0
      Do iIrrep = 0, nIrrep-1
         nSOs=nSOs+nBas(iIrrep)
      End Do
      Call mma_allocate(iSO_info,2,nSOs,Label='iSO_info')
      iSO_a=0
      Do iIrrep=0,nIrrep-1
         iSO_r=0
         Do iBas = 1, nBas(iIrrep)
            iSO_a=iSO_a+1
            iSO_r=iSO_r+1
            iSO_info(1,iSO_a)=iIrrep
            iSO_info(2,iSO_a)=iSO_r
         End Do
      End Do
*
*     loop over unique centres to read integrals and information
*
      iunit=LUPROP
      nSCR=numboffunct3*3
      Call mma_allocate(Scr,numboffunct3,3,Label='Scr')
      Scr(:,:)=Zero
      ipSCR=1
      length3_tot=0
*
*     In a MPI run not all atomic block will be available in
*     all processes. Make up so we know later if a particular
*     atom is present.
*
      ipC(1:numbofcent)=-99
      do jcent=1,numbofcent
*
#ifdef _DEBUGPRINT_
      write(6,*) 'read integrals and info for centre ',jcent
#endif
*
*        Note that when running in parallel this list is incomplete.
*        Hence, we process the centers which each process host.
*
              read(iunit,END=199)  iCent
              read(iunit)  xa2
     &        ,numbofsym,(idummy(I),
     &        i=1,numbofsym),
     &        numballcart(icent),(Lcent(i),
     &        I=1,numballcart(icent)),
     &        (mcent(i),I=1,numballcart(icent)),
     &        Lhighcent(icent),(ncontcent(I),I=0,Lhighcent(icent))
#ifdef _DEBUGPRINT_
              write(6,*) numballcart(icent) ,
     &        'functions on centre ',icent
#endif
              length3=ipnt(numballcart(icent),numballcart(icent))
              ipC(iCent)=ipSCR
              read(iunit) (Scr(i,1),i=ipSCR,ipSCR+length3-1)
              read(iunit)  Ya
              read(iunit) (Scr(i,2),i=ipSCR,ipSCR+length3-1)
              read(iunit)  Za
              read(iunit) (Scr(i,3),i=ipSCR,ipSCR+length3-1)
              ipScr=ipScr+length3
              length3_tot=length3_tot+length3
culf
c      check if any L-value is missing
      LLhigh = Lhighcent(icent)
      do i=1,Lhighcent(icent)
         if(ncontcent(I).eq.0) LLhigh=LLhigh-1
      enddo
      Lhighcent(icent)=LLhigh
cbs   determize where the first function of a special type is..
      not_defined=ipnt(numboffunct,numboffunct)+1
      do Lrun=0,Lhighcent(icent)
         do Mrun=-Lrun,Lrun
            ifirstLM(Lrun,Mrun,icent)=not_defined
         enddo
      enddo
      do iorb=1,numballcart(icent)
         Lrun=Lcent(iorb)
         Mrun=Mcent(iorb)
#ifdef _DEBUGPRINT_
         write(6,*) 'iorb,Lrun,mrun',iorb,Lrun,mrun
#endif
         ifirstLM(Lrun,Mrun,icent)=min(iorb,ifirstLM(Lrun,Mrun,icent))
      enddo
*
cbs   determined..
cbs   check if all of them were found
      do Lrun=0,Lhighcent(icent)
         do Mrun=-Lrun,Lrun
            if (ifirstLM(Lrun,Mrun,icent).eq.not_defined) then
               write(6,*) 'problems for centre,L,M ',icent,Lrun,Mrun
               Call SysAbendMsg('symtrafo',
     &                          'problems with L- and M-values',' ')
            endif
          enddo
      enddo
      enddo    !end of loop over centres
 199  Continue
#ifdef _DEBUGPRINT_
      Write (6,*) 'length3_tot=',length3_tot
      Call RecPrt('SCR(1,1)',' ',Scr(1,1),1,length3_tot)
      Call RecPrt('SCR(1,2)',' ',Scr(1,2),1,length3_tot)
      Call RecPrt('SCR(1,3)',' ',Scr(1,3),1,length3_tot)
      Do iCent = 1, numbofcent
         Write (6,*) ipC(iCent)
      End Do
#endif
*     If this process does not have any blocks of integrals proceed
*     directly to the distribution step.
      If (Length3_tot.eq.0) Go To 299
cbs
cbs   Finally the transformation!!!!
cbs
cbs
      icentprev=0
      jcentprev=0
      ilcentprev=-1
      jlcentprev=-1
      imcentprev=20
      jmcentprev=20
      isame=1
      jsame=1
      lauf=0
      do irun=1,numboffunct
*        Skip if center corresponding to this basis function is
*        not available at this process.
         if (ncent(irun).eq.icentprev.AND.ilcentprev.eq.lval(irun)
     &       .AND.imcentprev.eq.mval(irun)) then
            isame=isame+1
         else
            isame=1
            icentprev=ncent(irun)
            ilcentprev=lval(irun)
            imcentprev=mval(irun)
         endif
      do jrun=1,irun
      lauf=lauf+1
      if (ncent(jrun).eq.jcentprev.and.jlcentprev.eq.lval(jrun)
     &    .AND.jmcentprev.eq.mval(jrun)) then
         jsame=jsame+1
      else
         jsame=1
         jcentprev=ncent(jrun)
         jlcentprev=lval(jrun)
         jmcentprev=mval(jrun)
      endif
cbs   check for same centers
      if (ncent(irun).eq.ncent(jrun)) then
      if (lval(irun).eq.lval(jrun).and.lval(irun).gt.0) then
      if (iabs(iabs(mval(irun))-iabs(mval(jrun))).le.1) then
*
*
*
cbs   the only cases  where non-zero integrals occur
      if (nadpt(irun).eq.1) then
         coeff=1d0
      else
         icoeff=0
         do icc=1,nadpt(irun)
            icoeff=icoeff+nphase(icc,irun)*nphase(icc,jrun)
         enddo
         coeff=DBLE(icoeff)
         If (MolWgh.eq.2) Then
            coeff=coeff/DBLE(nadpt(irun))
         Else
            coeff=coeff/DBLE(nadpt(irun)*nadpt(irun))
         End If
      endif
cbs   determine indices of atomic integrals
      indexi=ifirstLM(lval(irun),mval(irun),ncent(irun))+isame-1
      indexj=ifirstLM(lval(irun),mval(jrun),ncent(irun))+jsame-1
      laufalt=ipnt(indexi,indexj)
*
      If (ipC(nCent(iRun)).ne.-99) Then
         ipSCR=ipC(ncent(irun))-1+laufalt
cDebugDebug
c        Write (6,*) 'laufalt=',laufalt
c        Write (6,*) 'ip''s:',ipSCR
c        Write (6,*) Scr(ipSCR,1),Scr(ipSCR,2),Scr(ipSCR,3)
cDebugDebug
         Sgn=One
         if (indexi.gt.indexj) Sgn=-Sgn
         AMFI_Int(lauf,1)=Sgn*coeff*Scr(ipScr,1)
         AMFI_Int(lauf,2)=Sgn*coeff*Scr(ipScr,2)
         AMFI_Int(lauf,3)=Sgn*coeff*Scr(ipScr,3)
      End If
*
*
      endif
      endif
      endif
      enddo ! jrun
      enddo ! irun
 299  Continue
*     This test is not valid for parallel execusion, since here
*     we have only incomplete lists.
*     if (lauf.ne.numboffunct3)
*    & Call SysAbendMsg('symtrafo', 'error in numbering ',' ' )
      Do iComp = 1, nComp
         Do iSO=1, numboffunct
            j1=   iSO_info(1,iSO)
            iSO_r=iSO_info(2,iSO)
            Do jSO = 1, iSO
               j2=   iSO_info(1,jSO)
               jSO_r=iSO_info(2,jSO)
               j12=iEor(j1,j2)
               If (iAnd(lOper(iComp),2**j12).eq.0) Go To 99
*
               iOff = iPntSO(Max(j1,j2),Min(j1,j2),lOper(iComp),nBas)
               iOff = iOff + ip(iComp)-1
*
               iOff2= iPnt(iSO,jSO)
*
               tmp=-AMFI_Int(iOff2,iComp)
               If (j1.eq.j2) Then
                  ijSO=iPnt(iSO_r,jSO_r)
               Else
                  ijSO=(jSO_r-1)*nBas(j1)+iSO_r
               End If
               SOInt(iOff+ijSO)=tmp
*
 99            Continue
            End Do
         End Do
*
*------- Write out integrals to ONEINT for this specific component of the
*        operator.
*
*
         iOpt=0
         iRC=-1
         iSmLbl=lOper(iComp)
         Call GADSum(SOInt(ip(iComp)),n2Tri(iSmLbl))
         Call WrOne(iRC,iOpt,Label,iComp,SOInt(ip(iComp)),iSmLbl)
         If (iRC.ne.0) then
            Call SysAbendMsg('symtrafo',
     &            '     Error in subroutine ONEEL ',
     &      '     Abend in subroutine WrOne')
         End If
*
      End Do
*
#ifdef _DEBUGPRINT_
      Call PrMtrx(Label,lOper,nComp,ip,SOInt)
#endif
*
      Call mma_deallocate(ifirstLM)
      Call mma_deallocate(iSO_info)
      Call mma_deallocate(Scr)
      Call mma_deallocate(AMFI_Int)
CBS   write(6,*) 'Symmetry transformation successfully done'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine CDJOELas(EO,NBEG,NEND,BvWN,YH,WARN,V,WF0,RM2,RCNST)
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!  Subroutine solving the linear inhomogeneous differential equations
!  formulated by J.M. Hutson [J.Phys.B14, 851 (1982)] for treating
!  centrifugal distortion as a perturbation, to determine centrifugal
!  distortion constants of a diatomic molecule.  Uses the algorithm of
!  J. Tellinghuisen [J.Mol.Spectrosc. 122, 455 (1987)].  The current
!  version calculates Bv, Dv, Hv, Lv, Mv, Nv and Ov and writes them out,
!  but does not return values to the calling program.
!
!** On entry:   EO    is the eigenvalue (in units [cm-1])
!               NBEG & NEND  the mesh point range over which the input
! wavefunction  WF0  (in units 1/sqrt(angstrom))  has non-negligible values
!               BvWn  is the numerical factor (hbar^2/2mu) [cm-1 angstrom^2]
!               YH    is the integration stepsize
!               WARN  is an integer flag: > 0 print internal warnings,
!               V(i)  is the effective potential (including centrifugal
!                     term if calculation performed at  J > 0) in
!                     'internal' units, including the factor  YH**2/BvWN
!               RM2(i) is the array  (r')^2/(distance**2)
!** On exit:    RCNST(i)  is the set of 7 rotational constants: Bv, -Dv,
!                       Hv, Lv, Mv, Nv & Ov
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!** Dimension:  potential arrays  and  vib. level arrays.

use LEVEL_COMMON, only: DRDY2, NDIMR
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Twelve, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NBEG, NEND, WARN
real(kind=wp), intent(in) :: EO, BvWN, YH, V(NEND), WF0(NEND), RM2(NEND)
real(kind=wp), intent(out) :: RCNST(7)
integer(kind=iwp) :: I, IPASS, M, M1, M2
real(kind=wp) :: AMB, AMB1, AMB2, AR, DV, DVV, E, G2, G3, HV2, HVV, LV2, LVV, MV2, MVV, NVV, OV, OV01, OV02, OV03, OV11, OV12, &
                 OV13, OV22, OV23, OV33, OVV, P0, P1, P2, P3, PER01, PER02, PER03, PER11, PER12, PER13, PER22, PER23, PER33, PI, &
                 PIF, PRS, PRT, R2IN, R2XX, TSTHv, TSTLv, TSTMv, V1, V2, V3, Y1, Y2, Y3, YH2, ZTW
logical(kind=iwp) :: Break
real(kind=wp), allocatable :: P(:), WF1(:), WF2(:)

P0 = 0
MV2 = 0
LV2 = 0
G3 = 0
if (NEND > NDIMR) then
  write(u6,602) NEND,NDIMR
  return
end if
call mma_allocate(P,NEND,LABEL='P')
call mma_allocate(WF1,NEND,LABEL='WF1')
call mma_allocate(WF2,NEND,LABEL='WF2')
ZTW = One/Twelve
YH2 = YH*YH
DV = YH2*ZTW
E = EO*YH2/BvWN
OV01 = Zero
OV02 = Zero
OV03 = Zero
OV11 = Zero
OV22 = Zero
OV12 = Zero
OV33 = Zero
OV23 = Zero
OV13 = Zero
PER01 = Zero
PER02 = Zero
PER03 = Zero
PER11 = Zero
PER12 = Zero
PER13 = Zero
PER22 = Zero
PER23 = Zero
PER33 = Zero
DVV = Zero
HVV = Zero
LVV = Zero
MVV = Zero
HV2 = Zero
!** First, calculate the expectation value of  1/r**2  and hence Bv
R2IN = Half*(RM2(NBEG)*WF0(NBEG)**2+RM2(NEND)*WF0(NEND)**2)
R2IN = R2IN+sum(RM2(NBEG+1:NEND-1)*WF0(NBEG+1:NEND-1)**2)*YH
RCNST(1) = R2IN*BvWN

! On First pass  IPASS=1  and calculate first-order wavefx., Dv & Hv
! On second pass IPASS=2  and calculate second-order wavefx., Lv & Mv
! On third pass  IPASS=3  and calculate third-order wavefx., Nv & Ov

do IPASS=1,3
  P1 = Zero
  P2 = Zero

  !P1 = WF0(NEND)
  !P2 = WF0(NEND-1)

  P(NEND) = P1
  P(NEND-1) = P2
  V1 = V(NEND)-E*DRDY2(NEND)
  V2 = V(NEND-1)-E*DRDY2(NEND-1)
  select case (IPASS)
    case (1)
      Y1 = P1*(One-ZTW*V1)-DV*(RM2(NEND)-R2IN*DRDY2(NEND))*WF0(NEND)
      G2 = (RM2(NEND-1)-R2IN*DRDY2(NEND-1))*WF0(NEND-1)
    case (2)
      Y1 = P1*(One-ZTW*V1)+DV*(DVV*WF0(NEND)-(RM2(NEND)-R2IN*DRDY2(NEND))*WF1(NEND))
      G2 = (RM2(NEND-1)-R2IN*DRDY2(NEND-1))*WF1(NEND-1)-DVV*WF0(NEND-1)*DRDY2(NEND-1)
    case (3)
      Y1 = P1*(One-ZTW*V1)+DV*(DVV*WF1(NEND)-HVV*WF0(NEND)-(RM2(NEND)-R2IN*DRDY2(NEND))*WF2(NEND))
      G2 = (RM2(NEND-1)-R2IN*DRDY2(NEND-1))*WF2(NEND-1)-(DVV*WF1(NEND-1)+HVV*WF0(NEND-1))*DRDY2(NEND-1)
  end select
  Y2 = P2*(One-ZTW*V2)-DV*G2
  M = NEND-1
  ! Now - integrate inward from outer end of range
  Break = .false.
  do I=NBEG+2,NEND
    M = M-1
    Y3 = Y2+Y2-Y1+YH2*G2+V2*P2
    R2XX = R2IN*DRDY2(M)
    select case (IPASS)
      case (1)
        G3 = (RM2(M)-R2XX)*WF0(M)
      case (2)
        G3 = (RM2(M)-R2XX)*WF1(M)-DVV*WF0(M)*DRDY2(M)
      case (3)
        G3 = (RM2(M)-R2XX)*WF2(M)-(DVV*WF1(M)+HVV*WF0(M))*DRDY2(M)
    end select
    V3 = V(M)-E*DRDY2(M)
    P3 = (Y3+DV*G3)/(One-ZTW*V3)
    if (V3 < Zero) then
      Break = .true.
      exit
    end if
    P(M) = P3
    Y1 = Y2
    Y2 = Y3
    V2 = V3
    P2 = P3
    G2 = G3
  end do
  ! Escaped loop at outer turning point:  initialize outward integration
  if (Break) then
    PRS = P3
    PRT = P(M+1)
    P1 = Zero
    P2 = Zero

    !P1 = WF0(NBEG)
    !P2 = WF0(NBEG+1)

    P(NBEG) = P1
    P(NBEG+1) = P2
    V1 = V(NBEG)-E*DRDY2(NBEG)
    V2 = V(NBEG+1)-E*DRDY2(NBEG+1)
    select case (IPASS)
      case (1)
        Y1 = P1*(One-ZTW*V1)-DV*(RM2(NBEG)-R2IN*DRDY2(NBEG))*WF0(NBEG)
        G2 = (RM2(NBEG+1)-R2IN*DRDY2(NBEG+1))*WF0(NBEG+1)
      case (2)
        Y1 = P1*(One-ZTW*V1)+DV*(DVV*WF0(NEND)*DRDY2(NBEG)-(RM2(NBEG)-R2IN*DRDY2(NBEG))*WF1(NBEG))
        G2 = (RM2(NBEG+1)-R2IN*DRDY2(NBEG+1))*WF1(NBEG+1)-DVV*WF0(NBEG+1)*DRDY2(NBEG+1)
      case (3)
        Y1 = P1*(One-ZTW*V1)+DV*((DVV*WF1(NEND)+HVV*WF0(NEND))*DRDY2(NBEG)-(RM2(NBEG)-R2IN*DRDY2(NBEG))*WF2(NBEG))
        G2 = (RM2(NBEG+1)-R2IN*DRDY2(NBEG+1))*WF2(NBEG+1)-(DVV*WF1(NBEG+1)+HVV*WF0(NBEG+1))*DRDY2(NBEG+1)
    end select
    Y2 = P2*(One-ZTW*V2)-DV*G2
    AR = Zero
    M1 = M+1
    ! Now ... integrate outward from inner end of range
    do I=NBEG+2,M1
      Y3 = Y2+Y2-Y1+YH2*G2+V2*P2
      P0 = WF0(I)
      R2XX = R2IN*DRDY2(I)
      select case (IPASS)
        case (1)
          G3 = (RM2(I)-R2XX)*P0
        case (2)
          G3 = (RM2(I)-R2XX)*WF1(I)-DVV*P0*DRDY2(I)
        case (3)
          G3 = (RM2(I)-R2XX)*WF2(I)-(DVV*WF1(I)+HVV*P0)*DRDY2(I)
      end select
      V3 = V(I)-E*DRDY2(I)
      P3 = (Y3+DV*G3)/(One-ZTW*V3)
      P(I) = P3
      Y1 = Y2
      Y2 = Y3
      V2 = V3
      P2 = P3
      G2 = G3
      AR = AR+P0*P3*DRDY2(I)
    end do
    ! Average for 2 adjacent mesh points to get Joel's "(a-b)"
    AMB2 = (P3-PRT)/P0
    AMB1 = (P(M)-PRS)/WF0(M)
    AMB = (AMB1+AMB2)*Half
    M2 = M+2
    ! Find the rest of the overlap with zero-th order solution ...
    do I=M2,NEND
      P0 = WF0(I)
      PI = P(I)+AMB*P0
      P(I) = PI
      AR = AR+PI*P0*DRDY2(I)
    end do
    OV = AR*YH
    do I=NBEG,NEND
      P0 = WF0(I)
      ! ... and project out contribution of zero'th-order part of solution
      PI = P(I)-OV*P0
      PIF = PI*RM2(I)
      select case (IPASS)
        case (1)
          ! Now - on first pass accumulate integrals for Dv and Hv
          WF1(I) = PI
          OV01 = OV01+PI*P0*DRDY2(i)
          OV11 = OV11+PI*PI*DRDY2(i)
          PER01 = PER01+PIF*P0
          PER11 = PER11+PI*PIF
        case (2)
          ! ... and on next pass, accumulate integrals for Lv and Mv
          WF2(I) = PI
          P1 = WF1(I)
          OV02 = OV02+PI*P0*DRDY2(i)
          OV12 = OV12+PI*P1*DRDY2(i)
          OV22 = OV22+PI*PI*DRDY2(i)
          PER02 = PER02+PIF*P0
          PER12 = PER12+PIF*P1
          PER22 = PER22+PI*PIF
        case (3)
          ! ... and on next pass, accumulate integrals for Nv and Ov
          P1 = WF1(I)
          P2 = WF2(I)
          OV03 = OV03+PI*P0*DRDY2(i)
          OV13 = OV13+PI*P1*DRDY2(i)
          OV23 = OV23+PI*P2*DRDY2(i)
          OV33 = OV33+PI*PI*DRDY2(i)
          PER03 = PER03+PIF*P0
          PER13 = PER13+PIF*P1
          PER23 = PER23+PIF*P2
          PER33 = PER33+PIF*PI
      end select
    end do
    select case (IPASS)
      case (1)
        DVV = YH*PER01
        HVV = YH*(PER11-R2IN*OV11)
        RCNST(2) = DVV*BvWN
        RCNST(3) = HVV*BvWn
      case (2)
        HV2 = YH*PER02*BvWN
        LVV = YH*(PER12-R2IN*OV12-DVV*OV11)
        MVV = YH*(PER22-R2IN*OV22-Two*DVV*OV12-HVV*OV11)
        RCNST(4) = LVV*BvWN
        RCNST(5) = MVV*BvWN
      case (3)
        LV2 = YH*PER03*BvWN
        MV2 = YH*(PER13-R2IN*OV13-DVV*OV12-HVV*OV11)*BvWN
        NVV = YH*(PER23-R2IN*OV23-DVV*(OV13+OV22)-Two*HVV*OV12-LVV*OV11)
        OVV = YH*(PER33-R2IN*OV33-Two*DVV*OV23-HVV*(Two*OV13+OV22)-Two*LVV*OV12-MVV*OV11)
        RCNST(6) = NVV*BvWN
        RCNST(7) = OVV*BvWN
        if (WARN > 0) then
          if (max(abs(OV01),abs(OV02),abs(OV01)) > 1.0e-9_wp) write(u6,604) OV01,OV02,OV03
          TSTHV = abs(RCNST(3)/HV2-One)
          TSTLV = abs(RCNST(4)/LV2-One)
          TSTMV = abs(RCNST(5)/MV2-One)
          if (max(TSTHV,TSTLV,TSTMV) > 1.0e-5_wp) write(u6,603) TSTHV,TSTLV,TSTMV
        end if
    end select
  else
    write(u6,601) EO
    exit
  end if
end do
call mma_deallocate(P)
call mma_deallocate(WF1)
call mma_deallocate(WF2)

return

601 format(' *** ERROR in CDJOEL *** for input energy  E =',f12.4,'  never reach outer turning point')
602 format(/' *** Dimensioning PROBLEM in CDJOEL ***   NEND=',i6,' > NDIMR=',i6)
603 format(' ** CAUTION ** Comparison tests for Hv, Lv & Mv give:',3(es9.1))
604 format(' ** CAUTION ** CDJOEL orthogonality tests OV01,OV02 & OV03:',3(es9.1))

end subroutine CDJOELas

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Yubin Wang                                       *
!               2009, Bingbing Suo                                     *
!***********************************************************************
! Sep. 28, 2009 -BSuo- Firstly write by YBWang, revised by BSuo
! Active space partial loops

subroutine link_b1_at_given_orb(mh)       !b^l:lstep<rstep

use gugaci_global, only: istep_occ, iy, iyl, jb, jj_sub, jjl_sub, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, lpnew_head, &
                         lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp) :: iactploop, idb, idocc, ilc, ilstep, ind0, irc, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: ismb1(8) = [3,8,34,35,40,44,66,76]

lpnew = 0
do iactploop=1,mh
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  do ilstep=1,4
    ilc = istep_occ(ilstep)
    lpnextltail = jjl_sub(ilstep,lpltail)
    if (lpnextltail == 0) cycle
    do irstep=ilstep+1,4
      irc = istep_occ(irstep)
      idocc = abs(ilc-irc)
      if (idocc /= 1) cycle
      lpnextrtail = jj_sub(irstep,lprtail)
      if (lpnextrtail == 0) cycle
      ind0 = (idb+2)*16+(ilstep-1)*4+irstep
      jbr = jb(lprtail)
      do ni=1,8
        if (ind0 /= ismb1(ni)) cycle
        call segmidb1(w,ww,ni,jbr)
        lpnew = lpnew+1
        lpnew_head(lpnew) = lphead
        lpnew_ltail(lpnew) = lpnextltail
        lpnew_rtail(lpnew) = lpnextrtail
        lplwei = lplwei0
        lprwei = lprwei0
        if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
        if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
        lpnew_lwei(lpnew) = lplwei
        lpnew_rwei(lpnew) = lprwei
        vplpnew_w0(lpnew) = w0*w
        vplpnew_w1(lpnew) = w1*ww
        if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
          lpnew = lpnew-1
        end if
      end do
    end do
  end do
end do
mh = lpnew
call change_vplp_pointer_arrays()

return

end subroutine link_b1_at_given_orb

subroutine link_b2_at_given_orb(mh)        !b^r:lstep>rstep

use gugaci_global, only: istep_occ, iy, iyl, jb, jj_sub, jjl_sub, logic_br, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, &
                         lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp) :: iactploop, idb, idocc, ilc, ilstep, ind0, irc, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
logical(kind=iwp) :: logic_plbr
integer(kind=iwp), parameter :: ismb2(8) = [5,15,37,41,46,47,73,78]

lpnew = 0
do iactploop=1,mh
  logic_plbr = logic_br(iactploop)
  if (.not. logic_plbr) cycle
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  do ilstep=1,4
    ilc = istep_occ(ilstep)
    lpnextltail = jjl_sub(ilstep,lpltail)
    if (lpnextltail == 0) cycle
    do irstep=1,ilstep-1
      irc = istep_occ(irstep)
      idocc = abs(ilc-irc)
      if (idocc /= 1) cycle
      lpnextrtail = jj_sub(irstep,lprtail)
      if (lpnextrtail == 0) cycle
      ind0 = (idb+2)*16+(ilstep-1)*4+irstep
      jbr = jb(lprtail)
      do ni=1,8
        if (ind0 /= ismb2(ni)) cycle
        call segmidb2(w,ww,ni,jbr)
        lpnew = lpnew+1
        !if (lpnew == 103) write(u6,*) 'bbs_tmp'
        lpnew_head(lpnew) = lphead
        lpnew_ltail(lpnew) = lpnextltail
        lpnew_rtail(lpnew) = lpnextrtail
        lplwei = lplwei0
        lprwei = lprwei0
        if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
        if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
        lpnew_lwei(lpnew) = lplwei
        lpnew_rwei(lpnew) = lprwei
        vplpnew_w0(lpnew) = w0*w
        vplpnew_w1(lpnew) = w1*ww
        if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
          lpnew = lpnew-1
        end if
      end do
    end do
  end do
end do
mh = lpnew
call change_vplp_pointer_arrays()

return

end subroutine link_b2_at_given_orb

subroutine link_b3_at_given_orb(mh)      !b&l:lstep>rstep

use gugaci_global, only: istep_occ, iy, iyl, jb, jj_sub, jjl_sub, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, lpnew_head, &
                         lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp) :: iactploop, idb, idocc, ilc, ilstep, ind0, irc, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: ismb3(8) = [21,25,30,31,53,57,62,63]

lpnew = 0
do iactploop=1,mh
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  do ilstep=1,4
    ilc = istep_occ(ilstep)
    lpnextltail = jjl_sub(ilstep,lpltail)
    if (lpnextltail == 0) cycle
    do irstep=1,ilstep-1
      irc = istep_occ(irstep)
      idocc = abs(ilc-irc)
      if (idocc /= 1) cycle
      lpnextrtail = jj_sub(irstep,lprtail)
      if (lpnextrtail == 0) cycle
      ind0 = (idb+2)*16+(ilstep-1)*4+irstep
      jbr = jb(lprtail)
      do ni=1,8
        if (ind0 /= ismb3(ni)) cycle
        call segmidb3(w,ww,ni,jbr)
        lpnew = lpnew+1
        lpnew_head(lpnew) = lphead
        lpnew_ltail(lpnew) = lpnextltail
        lpnew_rtail(lpnew) = lpnextrtail
        lplwei = lplwei0
        lprwei = lprwei0
        if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
        if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
        lpnew_lwei(lpnew) = lplwei
        lpnew_rwei(lpnew) = lprwei
        vplpnew_w0(lpnew) = w0*w
        vplpnew_w1(lpnew) = w1*ww
        if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
          lpnew = lpnew-1
        end if
      end do
    end do
  end do
end do
mh = lpnew
call change_vplp_pointer_arrays()

return

end subroutine link_b3_at_given_orb

subroutine link_b4_at_given_orb(mh)         !b&r:lstep<rstep

use gugaci_global, only: istep_occ, iy, iyl, jb, jj_sub, jjl_sub, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, lpnew_head, &
                         lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp) :: iactploop, idb, idocc, ilc, ilstep, ind0, irc, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: ismb4(8) = [18,19,24,28,50,51,56,60]

lpnew = 0
do iactploop=1,mh
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  do ilstep=1,4
    ilc = istep_occ(ilstep)
    lpnextltail = jjl_sub(ilstep,lpltail)
    if (lpnextltail == 0) cycle
    do irstep=ilstep+1,4
      irc = istep_occ(irstep)
      idocc = abs(ilc-irc)
      if (idocc /= 1) cycle
      lpnextrtail = jj_sub(irstep,lprtail)
      if (lpnextrtail == 0) cycle
      ind0 = (idb+2)*16+(ilstep-1)*4+irstep
      jbr = jb(lprtail)
      do ni=1,8
        if (ind0 /= ismb4(ni)) cycle
        call segmidb4(w,ww,ni,jbr)
        lpnew = lpnew+1
        lpnew_head(lpnew) = lphead
        lpnew_ltail(lpnew) = lpnextltail
        lpnew_rtail(lpnew) = lpnextrtail
        lplwei = lplwei0
        lprwei = lprwei0
        if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
        if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
        lpnew_lwei(lpnew) = lplwei
        lpnew_rwei(lpnew) = lprwei
        vplpnew_w0(lpnew) = w0*w
        vplpnew_w1(lpnew) = w1*ww
        if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
          lpnew = lpnew-1
        end if
      end do
    end do
  end do
end do
mh = lpnew
call change_vplp_pointer_arrays()

return

end subroutine link_b4_at_given_orb

subroutine link_d10_at_given_orb(mh)

use gugaci_global, only: iy, iyl, jb, jj_sub, jjl_sub, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, lpnew_head, lpnew_ltail, &
                         lpnew_lwei, lpnew_rtail, lpnew_rwei, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp) :: iactploop, idb, ilstep, ind0, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, lpnextltail, lpnextrtail, &
                     lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: ismd10(2) = [29,61]

lpnew = 0
do iactploop=1,mh
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  ilstep = 4
  lpnextltail = jjl_sub(ilstep,lpltail)
  if (lpnextltail == 0) cycle
  irstep = 1
  lpnextrtail = jj_sub(irstep,lprtail)
  if (lpnextrtail == 0) cycle
  ind0 = (idb+2)*16+(ilstep-1)*4+irstep
  jbr = jb(lprtail)
  do ni=1,2
    if (ind0 /= ismd10(ni)) cycle
    call segmidd10(w,ww,ni,jbr)
    lpnew = lpnew+1
    lpnew_head(lpnew) = lphead
    lpnew_ltail(lpnew) = lpnextltail
    lpnew_rtail(lpnew) = lpnextrtail
    lplwei = lplwei0
    lprwei = lprwei0
    if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
    if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
    lpnew_lwei(lpnew) = lplwei
    lpnew_rwei(lpnew) = lprwei
    vplpnew_w0(lpnew) = w0*w
    vplpnew_w1(lpnew) = w1*ww
    if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
      lpnew = lpnew-1
    end if
  end do
end do
mh = lpnew
call change_vplp_pointer_arrays()

return

end subroutine link_d10_at_given_orb

subroutine link_c2_to_given_orb(mh,lrsta,lrend)

use gugaci_global, only: istep_occ, iy, iyl, jb, jj_sub, jjl_sub, jpad, jpadl, logic_br, logic_newbr, lp_head, lp_ltail, lp_lwei, &
                         lp_rtail, lp_rwei, lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, norb_act, norb_dz, &
                         vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp), intent(in) :: lrsta, lrend
integer(kind=iwp) :: iactploop, idb, ilc, ilstep, ind0, iorb, irc, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
logical(kind=iwp) :: logic_plbr
integer(kind=iwp), parameter :: ismc2(16) = [1,6,7,11,16,33,38,39,42,43,48,65,70,74,75,80]

if ((norb_act == 0) .or. (lrsta == norb_dz+1)) then
  mh = 1
  lp_head(mh) = 0
  lp_ltail(mh) = jpadl
  lp_rtail(mh) = jpad
  lp_lwei(mh) = 0
  lp_rwei(mh) = 0
  vplp_w0(mh) = One
  vplp_w1(mh) = One
  !logic_br(mh) = .true.
end if
if (norb_act == 0) return
do iorb=lrsta,lrend
  lpnew = 0
  do iactploop=1,mh
    lphead = lp_head(iactploop)
    lpltail = lp_ltail(iactploop)
    lprtail = lp_rtail(iactploop)
    lplwei0 = lp_lwei(iactploop)
    lprwei0 = lp_rwei(iactploop)
    w0 = vplp_w0(iactploop)
    w1 = vplp_w1(iactploop)
    logic_plbr = logic_br(iactploop)
    idb = jb(lprtail)-jb(lpltail)
    do ilstep=1,4
      ilc = istep_occ(ilstep)
      lpnextltail = jjl_sub(ilstep,lpltail)
      if (lpnextltail == 0) cycle
      do irstep=1,4
        irc = istep_occ(irstep)
        if (ilc /= irc) cycle
        lpnextrtail = jj_sub(irstep,lprtail)
        if (lpnextrtail == 0) cycle
        jbr = jb(lprtail)
        ind0 = (idb+2)*16+(ilstep-1)*4+irstep
        if ((ilstep == 3) .and. (irstep == 2) .and. (.not. logic_plbr)) cycle
        do ni=1,16
          if (ind0 /= ismc2(ni)) cycle
          call segmidc2(w,ww,ni,jbr)
          lpnew = lpnew+1
          !if (lpnew == 57) write(u6,*) 'bbs_tmp'
          lpnew_head(lpnew) = lphead
          lpnew_ltail(lpnew) = lpnextltail
          lpnew_rtail(lpnew) = lpnextrtail
          lplwei = lplwei0
          lprwei = lprwei0
          if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
          if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
          lpnew_lwei(lpnew) = lplwei
          lpnew_rwei(lpnew) = lprwei
          logic_newbr(lpnew) = logic_plbr
          if (irstep > ilstep) logic_newbr(lpnew) = .true.
          vplpnew_w0(lpnew) = w0*w
          vplpnew_w1(lpnew) = w1*ww
          if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
            lpnew = lpnew-1
            cycle
          end if
        end do
      end do
    end do
  end do
  mh = lpnew
  call change_vplp_pointer_arrays()
  call change_br_pointer_arrays()
end do

end subroutine link_c2_to_given_orb

subroutine link_c1_to_given_orb(mh,lrsta,lrend)

use gugaci_global, only: istep_occ, iy, iyl, jb, jj_sub, jjl_sub, jpad, jpadl, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, &
                         lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, norb_act, norb_dz, vplp_w0, vplp_w1, &
                         vplpnew_w0, vplpnew_w1
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp), intent(in) :: lrsta, lrend
integer(kind=iwp) :: iactploop, idb, ilc, ilstep, ind0, iorb, irc, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: ismc1(10) = [17,22,23,27,32,49,54,58,59,64]

if ((norb_act == 0) .or. (lrsta == norb_dz+1)) then
  mh = 1
  lp_head(mh) = 0
  lp_ltail(mh) = jpadl
  lp_rtail(mh) = jpad
  lp_lwei(mh) = 0
  lp_rwei(mh) = 0
  vplp_w0(mh) = One
  vplp_w1(mh) = One
end if
if (norb_act == 0) return
do iorb=lrsta,lrend
  lpnew = 0
  do iactploop=1,mh
    lphead = lp_head(iactploop)
    lpltail = lp_ltail(iactploop)
    lprtail = lp_rtail(iactploop)
    lplwei0 = lp_lwei(iactploop)
    lprwei0 = lp_rwei(iactploop)
    w0 = vplp_w0(iactploop)
    w1 = vplp_w1(iactploop)
    jbr = jb(lprtail)
    idb = jb(lprtail)-jb(lpltail)
    do ilstep=1,4
      ilc = istep_occ(ilstep)
      lpnextltail = jjl_sub(ilstep,lpltail)
      if (lpnextltail == 0) cycle
      do irstep=1,4
        irc = istep_occ(irstep)
        if (ilc /= irc) cycle
        lpnextrtail = jj_sub(irstep,lprtail)
        if (lpnextrtail == 0) cycle
        ind0 = (idb+2)*16+(ilstep-1)*4+irstep
        do ni=1,10
          if (ind0 /= ismc1(ni)) cycle
          call segmidc1(w,ww,ni,jbr)
          lpnew = lpnew+1
          !if (lpnew == 15) write(u6,*) 'bbs_tmp'
          lpnew_head(lpnew) = lphead
          lpnew_ltail(lpnew) = lpnextltail
          lpnew_rtail(lpnew) = lpnextrtail
          lplwei = lplwei0
          lprwei = lprwei0
          if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
          if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
          lpnew_lwei(lpnew) = lplwei
          lpnew_rwei(lpnew) = lprwei
          vplpnew_w0(lpnew) = w0*w
          vplpnew_w1(lpnew) = w1*ww
          if ((vplpnew_w0(lpnew) /= 0) .or. (vplpnew_w1(lpnew) /= 0)) exit
          lpnew = lpnew-1
        end do
      end do
    end do
  end do
  mh = lpnew
  call change_vplp_pointer_arrays()
end do

end subroutine link_c1_to_given_orb

subroutine link_c1_to_given_orb_coe(mh,lrsta,lrend)

use gugaci_global, only: istep_occ, iy, iyl, jb, jj_sub, jjl_sub, jpad, jpadl, lp_coe, lp_head, lp_ltail, lp_lwei, lp_rtail, &
                         lp_rwei, lpnew_coe, lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, norb_act, norb_dz, &
                         vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp), intent(in) :: lrsta, lrend
integer(kind=iwp) :: iactploop, idb, ilc, ilstep, ind0, iorb, irc, irstep, jbl, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, lr, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: ismc1(10) = [17,22,23,27,32,49,54,58,59,64]
integer(kind=iwp), external :: k_coe

if ((norb_act == 0) .or. (lrsta == norb_dz+1)) then
  mh = 1
  lp_head(mh) = 0
  lp_ltail(mh) = jpadl
  lp_rtail(mh) = jpad
  lp_lwei(mh) = 0
  lp_rwei(mh) = 0
  vplp_w0(mh) = One
  vplp_w1(mh) = One
end if
if (norb_act == 0) return
do iorb=lrsta,lrend
  lpnew = 0
  do iactploop=1,mh
    lphead = lp_head(iactploop)
    lpltail = lp_ltail(iactploop)
    lprtail = lp_rtail(iactploop)
    lplwei0 = lp_lwei(iactploop)
    lprwei0 = lp_rwei(iactploop)
    w0 = vplp_w0(iactploop)
    w1 = vplp_w1(iactploop)
    jbl = jb(lpltail)
    jbr = jb(lprtail)
    idb = jbr-jbl
    !iposib = jb(lprtail)*80
    do ilstep=1,4
      ilc = istep_occ(ilstep)
      lpnextltail = jjl_sub(ilstep,lpltail)
      if (lpnextltail == 0) cycle
      do irstep=1,4
        irc = istep_occ(irstep)
        if (ilc /= irc) cycle
        lpnextrtail = jj_sub(irstep,lprtail)
        if (lpnextrtail == 0) cycle
        ind0 = (idb+2)*16+(ilstep-1)*4+irstep
        do ni=1,10
          if (ind0 /= ismc1(ni)) cycle
          call segmidc1(w,ww,ni,jbr)
          lpnew = lpnew+1
          lpnew_head(lpnew) = lphead
          lpnew_ltail(lpnew) = lpnextltail
          lpnew_rtail(lpnew) = lpnextrtail
          lplwei = lplwei0
          lprwei = lprwei0
          if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
          if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
          lpnew_lwei(lpnew) = lplwei
          lpnew_rwei(lpnew) = lprwei
          vplpnew_w0(lpnew) = w0*w
          vplpnew_w1(lpnew) = w1*ww
          if ((vplpnew_w0(lpnew) /= 0) .or. (vplpnew_w1(lpnew) /= 0)) then
            do lr=norb_dz+1,iorb-1
              lpnew_coe(lr,lpnew) = lp_coe(lr,iactploop)
            end do
            lpnew_coe(iorb,lpnew) = k_coe(jbl,jbr,ilstep,irstep)
            exit
          end if
          lpnew = lpnew-1
        end do
      end do
    end do
  end do
  mh = lpnew
  call change_vplp_pointer_arrays()
  call change_coe_pointer_arrays()
end do

end subroutine link_c1_to_given_orb_coe

subroutine head_drr_at_given_orb(mh,lri)

use gugaci_global, only: iy, iyl, jj_sub, jjl_sub, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, no, vplp_w0, vplp_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: mh
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp) :: iactploop, ind0, jdl, jdr, jl, jp, jpend, jpsta, jr
real(kind=wp) :: w, ww
integer(kind=iwp), parameter :: ishdrr = 36

iactploop = 0
jpsta = no(lri-1)+1
jpend = no(lri)
do jp=jpsta,jpend
  if ((iy(1,jp) == 0) .or. (iyl(1,jp) == 0)) cycle
  jdl = 1
  jl = jjl_sub(jdl,jp)        ! no cycle
  if (jl == 0) cycle
  jdr = 4
  jr = jj_sub(jdr,jp)
  if (jr == 0) cycle
  ind0 = 32+(jdl-1)*4+jdr
  !start '^'
  if (ind0 /= ishdrr) cycle
  call stermhd5(w,ww)
  iactploop = iactploop+1
  lp_head(iactploop) = jp
  lp_ltail(iactploop) = jl
  lp_rtail(iactploop) = jr
  vplp_w0(iactploop) = w
  vplp_w1(iactploop) = ww
  lp_lwei(iactploop) = 0
  lp_rwei(iactploop) = 0
  if (jdl /= 1) lp_lwei(iactploop) = iyl(jdl,jp)
  if (jdr /= 1) lp_rwei(iactploop) = iy(jdr,jp)
end do
mh = iactploop

return

end subroutine head_drr_at_given_orb

subroutine head_drl_at_given_orb(mh,lri)

use gugaci_global, only: istep_occ, iy, iyl, jb, jj_sub, jjl_sub, logic_br, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, no, &
                         vplp_w0, vplp_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: mh
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp) :: iactploop, ind0, jbr, jdl, jdr, jl, jp, jpend, jpsta, jr, ndl, ndr, ni
real(kind=wp) :: w, ww
integer(kind=iwp), parameter :: ishd1(4) = [38,39,43,48]

jpsta = no(lri-1)+1
jpend = no(lri)
iactploop = 0
do jp=jpsta,jpend
  if ((iy(1,jp) == 0) .or. (iyl(1,jp) == 0)) cycle
  do jdl=2,4
    jl = jjl_sub(jdl,jp)
    if (jl == 0) cycle
    ndl = istep_occ(jdl)
    do jdr=jdl,4
      ndr = istep_occ(jdr)
      if (ndr /= ndl) cycle
      jr = jj_sub(jdr,jp)
      if (jr == 0) cycle
      jbr = jb(jp)
      ind0 = 32+(jdl-1)*4+jdr
      !start '^'
      do ni=1,4
        if (ind0 /= ishd1(ni)) cycle
        call stermhd1(w,ww,ni,jbr)
        iactploop = iactploop+1
        lp_head(iactploop) = jp
        lp_ltail(iactploop) = jl
        lp_rtail(iactploop) = jr
        vplp_w0(iactploop) = w
        vplp_w1(iactploop) = ww
        lp_lwei(iactploop) = 0
        lp_rwei(iactploop) = 0
        if (jdl /= 1) lp_lwei(iactploop) = iyl(jdl,jp)
        if (jdr /= 1) lp_rwei(iactploop) = iy(jdr,jp)
        logic_br(iactploop) = .false.
        if (jdr > jdl) logic_br(iactploop) = .true.
      end do
    end do
  end do
end do
mh = iactploop

return

end subroutine head_drl_at_given_orb

subroutine head_ar_at_given_orb(mh,lri)

use gugaci_global, only: istep_occ, iy, iyl, jb, jj_sub, jjl_sub, lp_coe, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, no, &
                         vplp_w0, vplp_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: mh
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp) :: iactploop, ind0, jbr, jd_occ, jdl, jdl_occ, jdr, jdr_occ, jl, jp, jpend, jpsta, jr, ni
real(kind=wp) :: w, ww
logical(kind=iwp) :: found
integer(kind=iwp), parameter :: isha4(4) = [34,35,40,44]

iactploop = 0
jpsta = no(lri-1)+1
jpend = no(lri)
do jp=jpsta,jpend
  if ((iy(1,jp) == 0) .or. (iyl(1,jp) == 0)) cycle
  do jdl=1,3
    jl = jjl_sub(jdl,jp)
    if (jl == 0) cycle
    jdl_occ = istep_occ(jdl)
    do jdr=jdl+1,4
      jr = jj_sub(jdr,jp)
      if (jr == 0) cycle
      jdr_occ = istep_occ(jdr)
      jd_occ = jdr_occ-jdl_occ
      if (jd_occ /= 1) cycle
      jbr = jb(jp)
      ind0 = 32+(jdl-1)*4+jdr
      !start '^'
      found = .false.
      do ni=1,4
        if (ind0 == isha4(ni)) then
          call stermha4(w,ww,ni,jbr)
          found = .true.
          exit
        end if
      end do
      if (.not. found) cycle
      iactploop = iactploop+1
      !if (iactploop == 4) write(u6,*) 'bbs_tmp'
      lp_head(iactploop) = jp
      lp_ltail(iactploop) = jl
      lp_rtail(iactploop) = jr
      lp_coe(lri,iactploop) = 0
      if (jdr_occ == 2) lp_coe(lri,iactploop) = 100
      vplp_w0(iactploop) = w
      vplp_w1(iactploop) = ww
      lp_lwei(iactploop) = 0
      lp_rwei(iactploop) = 0
      if (jdl /= 1) lp_lwei(iactploop) = iyl(jdl,jp)
      if (jdr /= 1) lp_rwei(iactploop) = iy(jdr,jp)
    end do
  end do
end do
mh = iactploop

return

end subroutine head_ar_at_given_orb

subroutine tail_ar_at_given_orb(mh)       !a^r:lstep>rstep

use gugaci_global, only: istep_occ, iy, iyl, ja, jb, jj_sub, jjl_sub, jm, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, &
                         lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp) :: iactploop, idb, idocc, ilc, ilstep, ind0, irc, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: isla2(4) = [21,31,57,62]

lpnew = 0
do iactploop=1,mh
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  do ilstep=1,4
    ilc = istep_occ(ilstep)
    lpnextltail = jjl_sub(ilstep,lpltail)
    if (lpnextltail == 0) cycle
    do irstep=1,ilstep-1
      irc = istep_occ(irstep)
      idocc = abs(ilc-irc)
      if (idocc /= 1) cycle
      lpnextrtail = jj_sub(irstep,lprtail)
      if (lpnextrtail == 0) cycle

      if (ja(lpnextltail) /= ja(lpnextrtail)) cycle
      if (jb(lpnextltail) /= jb(lpnextrtail)) cycle
      if (jm(lpnextltail) /= jm(lpnextrtail)) cycle

      ind0 = (idb+2)*16+(ilstep-1)*4+irstep
      jbr = jb(lprtail)
      do ni=1,4
        if (ind0 /= isla2(ni)) cycle
        call stermla2(w,ww,ni,jbr)
        lpnew = lpnew+1
        lpnew_head(lpnew) = lphead
        lpnew_ltail(lpnew) = lpnextltail
        lpnew_rtail(lpnew) = lpnextrtail
        lplwei = lplwei0
        lprwei = lprwei0
        if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
        if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
        lpnew_lwei(lpnew) = lplwei
        lpnew_rwei(lpnew) = lprwei
        vplpnew_w0(lpnew) = w0*w
        vplpnew_w1(lpnew) = w1*ww
        if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
          lpnew = lpnew-1
        end if
      end do
    end do
  end do
end do
mh = lpnew
!call change_vplp_pointer_arrays()

return

end subroutine tail_ar_at_given_orb

subroutine tail_al_at_given_orb(mh)       !a^l:lstep<rstep

use gugaci_global, only: istep_occ, iy, iyl, ja, jb, jj_sub, jjl_sub, jm, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, &
                         lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp) :: iactploop, idb, idocc, ilc, ilstep, ind0, irc, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: isla1(4) = [19,24,50,60]

lpnew = 0
do iactploop=1,mh
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  do ilstep=1,4
    ilc = istep_occ(ilstep)
    lpnextltail = jjl_sub(ilstep,lpltail)
    if (lpnextltail == 0) cycle
    do irstep=ilstep+1,4
      irc = istep_occ(irstep)
      idocc = abs(ilc-irc)
      if (idocc /= 1) cycle
      lpnextrtail = jj_sub(irstep,lprtail)
      if (lpnextrtail == 0) cycle

      if (ja(lpnextltail) /= ja(lpnextrtail)) cycle
      if (jb(lpnextltail) /= jb(lpnextrtail)) cycle
      if (jm(lpnextltail) /= jm(lpnextrtail)) cycle

      ind0 = (idb+2)*16+(ilstep-1)*4+irstep
      jbr = jb(lprtail)
      do ni=1,4
        if (ind0 /= isla1(ni)) cycle
        call stermla1(w,ww,ni,jbr)
        lpnew = lpnew+1
        lpnew_head(lpnew) = lphead
        lpnew_ltail(lpnew) = lpnextltail
        lpnew_rtail(lpnew) = lpnextrtail
        lplwei = lplwei0
        lprwei = lprwei0
        if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
        if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
        lpnew_lwei(lpnew) = lplwei
        lpnew_rwei(lpnew) = lprwei
        vplpnew_w0(lpnew) = w0*w
        vplpnew_w1(lpnew) = w1*ww
        if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
          lpnew = lpnew-1
        end if
      end do
    end do
  end do
end do
mh = lpnew
!call change_vplp_pointer_arrays()

return

end subroutine tail_al_at_given_orb

subroutine tail_drr_at_given_orb(mh)       !d^r^r(3,0):locc=

use gugaci_global, only: iy, iyl, ja, jb, jj_sub, jjl_sub, jm, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, lpnew_head, &
                         lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
integer(kind=iwp) :: iactploop, idb, ilstep, ind0, irstep, lphead, lpltail, lplwei, lplwei0, lpnew, lpnextltail, lpnextrtail, &
                     lprtail, lprwei, lprwei0
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: isld6 = 45

lpnew = 0
do iactploop=1,mh
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  ilstep = 4
  lpnextltail = jjl_sub(ilstep,lpltail)
  if (lpnextltail == 0) cycle
  irstep = 1
  lpnextrtail = jj_sub(irstep,lprtail)
  if (lpnextrtail == 0) cycle

  if (ja(lpnextltail) /= ja(lpnextrtail)) cycle
  if (jb(lpnextltail) /= jb(lpnextrtail)) cycle
  if (jm(lpnextltail) /= jm(lpnextrtail)) cycle

  ind0 = (idb+2)*16+(ilstep-1)*4+irstep
  if (ind0 /= isld6) cycle
  call stermld6(w,ww)
  lpnew = lpnew+1
  lpnew_head(lpnew) = lphead
  lpnew_ltail(lpnew) = lpnextltail
  lpnew_rtail(lpnew) = lpnextrtail
  lplwei = lplwei0
  lprwei = lprwei0
  if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
  if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
  lpnew_lwei(lpnew) = lplwei
  lpnew_rwei(lpnew) = lprwei
  vplpnew_w0(lpnew) = w0*w
  vplpnew_w1(lpnew) = w1*ww
  if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
    lpnew = lpnew-1
  end if
end do
mh = lpnew
!call change_vplp_pointer_arrays()

return

end subroutine tail_drr_at_given_orb

subroutine tail_drl_at_given_orb(mh)       !d^r^l:locc=rocc

use gugaci_global, only: istep_occ, iy, iyl, ja, jb, jj_sub, jjl_sub, jm, logic_br, lp_head, lp_ltail, lp_lwei, lp_rtail, lp_rwei, &
                         lpnew_head, lpnew_ltail, lpnew_lwei, lpnew_rtail, lpnew_rwei, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: mh
logical(kind=iwp) :: logic_plbr
integer(kind=iwp) :: iactploop, idb, idocc, ilc, ilstep, ind0, irc, irstart, irstep, jbr, lphead, lpltail, lplwei, lplwei0, lpnew, &
                     lpnextltail, lpnextrtail, lprtail, lprwei, lprwei0, ni
real(kind=wp) :: w, w0, w1, ww
integer(kind=iwp), parameter :: isld2(5) = [7,38,43,48,74]

lpnew = 0
do iactploop=1,mh
  lphead = lp_head(iactploop)
  lpltail = lp_ltail(iactploop)
  lprtail = lp_rtail(iactploop)
  lplwei0 = lp_lwei(iactploop)
  lprwei0 = lp_rwei(iactploop)
  w0 = vplp_w0(iactploop)
  w1 = vplp_w1(iactploop)
  idb = jb(lprtail)-jb(lpltail)
  logic_plbr = logic_br(iactploop)
  do ilstep=1,4
    ilc = istep_occ(ilstep)
    lpnextltail = jjl_sub(ilstep,lpltail)
    if (lpnextltail == 0) cycle
    irstart = 1
    if (.not. logic_plbr) irstart = ilstep+1
    do irstep=irstart,4
      irc = istep_occ(irstep)
      idocc = abs(ilc-irc)
      if (idocc /= 0) cycle
      lpnextrtail = jj_sub(irstep,lprtail)
      if (lpnextrtail == 0) cycle

      if (ja(lpnextltail) /= ja(lpnextrtail)) cycle
      if (jb(lpnextltail) /= jb(lpnextrtail)) cycle
      if (jm(lpnextltail) /= jm(lpnextrtail)) cycle

      ind0 = (idb+2)*16+(ilstep-1)*4+irstep
      jbr = jb(lprtail)
      do ni=1,5
        if (ind0 /= isld2(ni)) cycle
        call stermld2(w,ww,ni,jbr)
        lpnew = lpnew+1
        lpnew_head(lpnew) = lphead
        lpnew_ltail(lpnew) = lpnextltail
        lpnew_rtail(lpnew) = lpnextrtail
        lplwei = lplwei0
        lprwei = lprwei0
        if (ilstep /= 1) lplwei = lplwei+iyl(ilstep,lpltail)
        if (irstep /= 1) lprwei = lprwei+iy(irstep,lprtail)
        lpnew_lwei(lpnew) = lplwei
        lpnew_rwei(lpnew) = lprwei
        vplpnew_w0(lpnew) = w0*w
        vplpnew_w1(lpnew) = w1*ww
        if ((vplpnew_w0(lpnew) == 0) .and. (vplpnew_w1(lpnew) == 0)) then
          lpnew = lpnew-1
        end if
      end do
    end do
  end do
end do
mh = lpnew
!call change_vplp_pointer_arrays()

return

end subroutine tail_drl_at_given_orb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GugaCtl_dmrg()
*

      Implicit Real*8 (A-H,O-Z)
      Integer A0,B0,C0
*
#include "Input.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
#include "detdim.fh"
#include "csfbas_mclr.fh"
#include "spinfo_mclr.fh"
      Integer OrbSym(2*mxBas)
      Parameter (iPrint=0)
*
*
      ntRas1=0
      ntRas2=0
      ntRas3=0
      Do iSym=1,nSym
         ntRas1=ntRas1+nRs1(iSym)
         ntRas2=ntRas2+nRs2(iSym)
         ntRas3=ntRas3+nRs3(iSym)
      End Do
*
      B0=iSpin-1
      A0=(nActEl-B0)/2
      C0=ntASh-A0-B0
      If ( (2*A0+B0).ne.nActEl ) then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine GUGACTL ***'
         Write (6,*) ' 2*A0+B0.ne.nActEl '
         Write (6,*)
      End If
      If ( A0.lt.0 ) then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine GUGACTL ***'
         Write (6,*) ' A0.lt.0'
         Write (6,*)
      End If
      If ( B0.lt.0 ) then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine GUGACTL ***'
         Write (6,*) ' B0.lt.0'
         Write (6,*)
      End If
      If ( C0.lt.0 ) then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine GUGACTL ***'
         Write (6,*) ' C0.lt.0'
         Write (6,*)
      End If
*
      iOrb=0
      Do iSym=1,nSym
         Do iBas=1,nRs1(iSym)
            iOrb=iOrb+1
            OrbSym(iOrb)=iSym
         End Do
      End Do
      Do iSym=1,nSym
         Do iBas=1,nRs2(iSym)
            iOrb=iOrb+1
            OrbSym(iOrb)=iSym
         End Do
      End Do
      Do iSym=1,nSym
         Do iBas=1,nRs3(iSym)
            iOrb=iOrb+1
            OrbSym(iOrb)=iSym
         End Do
      End Do
*
      NLEV=ntASh
      IAC=MIN(A0,C0)
      NVERT0=((A0+1)*(C0+1)*(2*B0+IAC+2))/2-(IAC*(IAC+1)*(IAC+2))/6
      NDRT0=5*NVERT0
      NDOWN0=4*NVERT0
      NTMP=((NLEV+1)*(NLEV+2))/2
      Call GetMem('DRT0','ALLO','INTEGER',LDRT0,NDRT0)
      Call GetMem('DOWN','ALLO','INTEGER',LDOWN0,NDOWN0)
      Call GetMem('LTMP','ALLO','INTEGER',LTMP,NTMP)
      Call DRT0_MCLR  ! Set up the guga table
     &     (A0,B0,C0,NVERT0,iWork(LDRT0),iWork(LDOWN0),
     &      NTMP,IWORK(LTMP))

      If ( iPrint.ge.5 )
     &   Call PRDRT_MCLR(NVERT0,iWork(LDRT0),iWork(LDOWN0))
      Call GetMem('LTMP','FREE','INTEGER',LTMP,NTMP)
*
      LV1RAS=ntRas1
      LV3RAS=LV1RAS+ntRas2
      LM1RAS=2*LV1RAS-nHole1
      LM3RAS=nActEl-nElec3
      Call GetMem('LV11','ALLO','INTEGER',LV,NVERT0)
      Call RESTR_MCLR   ! PUT THE RAS CONSTRAINT TO THE DRT TABLE
     &     (NVERT0,iWork(LDRT0),iWork(LDOWN0),iWork(LV),
     &      LV1RAS,LV3RAS,LM1RAS,LM3RAS,NVERT)
*

      NDRT=5*NVERT
      NDOWN=4*NVERT
      Call GetMem('DRT1','ALLO','INTEGER',LDRT,NDRT)
      Call GetMem('DWN1','ALLO','INTEGER',LDOWN,NDOWN)
      Call DRT_MCLR  ! Set up the DRT table used in calculation
     &     (NVERT0,NVERT,iWork(LDRT0),iWork(LDOWN0),iWork(LV),
     &      iWork(LDRT),iWork(LDOWN))
      Call GetMem('LV11','FREE','INTEGER',LV,NVERT0)
      Call GetMem('DRT0','FREE','INTEGER',LDRT0,NDRT0)
      Call GetMem('DOWN','FREE','INTEGER',LDOWN0,NDOWN0)
*
      NDAW=5*NVERT
      Call GetMem('DAW1','ALLO','INTEGER',LDAW,NDAW)
      Call MKDAW_MCLR(NVERT,iWork(LDOWN),iWork(LDAW),iPrint)
*
      NUP=4*NVERT
      NRAW=5*NVERT
      Call GetMem('LUP1','ALLO','INTEGER',LUP,NUP)
      Call GetMem('RAW1','ALLO','INTEGER',LRAW,NRAW)
      Call MKRAW_MCLR
     &     (NVERT,iWork(LDOWN),iWork(LDAW),iWork(LUP),iWork(LRAW),
     &           iPrint)
*
      NLTV=NLEV+2
      Call GetMem('LTV1','ALLO','INTEGER',LLTV,NLTV)
      Call MKMID_MCLR
     &     (NVERT,NLEV,iWork(LDRT),
     &      iWork(LDOWN),iWork(LDAW),iWork(LUP),iWork(LRAW),
     &      iWork(LLTV),
     &      MIDLEV,NMIDV,MIDV1,MIDV2,MXUP,MXDWN,iPrint)
      Call GetMem('LTV1','FREE','INTEGER',LLTV,NLTV)
*
      NIPWLK=1+(MIDLEV-1)/15
      NIPWLK=MAX(NIPWLK,1+(NLEV-MIDLEV-1)/15)
      NNOW=2*NMIDV*nSym
      NIOW=NNOW
      NNOCSF=NMIDV*(nSym**2)
      NIOCSF=NNOCSF
      NSCR=3*(NLEV+1)
      Call GetMem('NOW1','ALLO','INTEGER',LNOW,NNOW)
      Call GetMem('IOW1','ALLO','INTEGER',LIOW,NIOW)
      Call GetMem('NCSF','ALLO','INTEGER',LNOCSF,NNOCSF)
      Call GetMem('ICSF','ALLO','INTEGER',LIOCSF,NIOCSF)
      Call GetMem('SCR1','ALLO','INTEGER',LSCR,NSCR)
*     Call GetMem('NCSF','ALLO','INTEGER',LNCSF,nSym)
      Call MKCOT_MCLR
     &     (nSym,NLEV,NVERT,MIDLEV,NMIDV,MIDV1,MIDV2,NWALK,NIPWLK,
     &      OrbSym,iWork(LDOWN),iWork(LNOW),iWork(LIOW),
     &      NCSF,iWork(LIOCSF),iWork(LNOCSF),
     &      iWork(LSCR),iPrint)
*
      If ( nConf.ne.NCSF(state_sym).and.(nConf.ne.1) ) then
         Write (6,*) "Set nConf=NCSF(state_sym)"
         Write (6,*)
         nConf=NCSF(state_sym)
      End If
*
      Call GetMem('ICSF','FREE','INTEGER',LIOCSF,NIOCSF)
      Call GetMem('NCSF','FREE','INTEGER',LNOCSF,NNOCSF)
      Call GetMem('IOW1','FREE','INTEGER',LIOW,NIOW)
      Call GetMem('NOW1','FREE','INTEGER',LNOW,NNOW)
      Call GetMem('RAW1','FREE','INTEGER',LRAW,NRAW)
      Call GetMem('LUP1','FREE','INTEGER',LUP,NUP)
      Call GetMem('DAW1','FREE','INTEGER',LDAW,NDAW)
      Call GetMem('DWN1','FREE','INTEGER',LDOWN,NDOWN)
      Call GetMem('DRT1','FREE','INTEGER',LDRT,NDRT)
      Call GetMem('SCR1','FREE','INTEGER',LSCR,NSCR)
*
*

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mktauhelp2(t2,t1,dimab,dimij,dima,dimi,fact)
! this routine does:
! t2(ab,ij) = t2(ab,ij) + fact* (T1(a,i).t1(b,j)-t1(b,i).t1(a,j))
! for spin and symmetry of all indices equal
!
! t2    - T2 matrix (I/O)
! t1    - t1 matrix (I)
! dimab - 1 dimension of T2 (I)
! dimij - 3 dimension of T2 (I)
! dima  - number of a in this spin and symm of a (I)
! dimi  - number of a in this spin and symm of i (I)
! fact  - numerical factor (I)
!
! N.B. Since for T1 i and a are of the same spin, there is no reason
! to specify spin of dp. It must be automatically the same spin as i and a.

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimab, dimij, dima, dimi
real(kind=wp), intent(inout) :: t2(dimab,dimij)
real(kind=wp), intent(in) :: t1(dima,dimi), fact
integer(kind=iwp) :: a, ab, b, i, ij, j

ij = 0
do i=2,dimi
  do j=1,i-1
    ij = ij+1

    ab = 0
    do a=2,dima
      do b=1,a-1
        ab = ab+1
        t2(ab,ij) = t2(ab,ij)+fact*(t1(a,i)*t1(b,j)-t1(b,i)*t1(a,j))

      end do
    end do
  end do
end do

return

end subroutine mktauhelp2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine serber_cvb(bikcof,
     > nel,nalf,nbet,ndet,ifns,
     > minspn,maxspn,nkspn,locca,lnocca,xspin,
     > ialfs,ibets,ianti)
      implicit real*8 (a-h,o-w,y-z),integer(x)
      dimension bikcof(ndet,ifns)
      dimension minspn(0:nel), maxspn(0:nel), nkspn(0:nel)
      dimension locca(nel), lnocca(nel)
      dimension xspin((nel+1)*(nalf+1))
      dimension ialfs(nalf),ibets(nbet),ianti(ifns)
      dimension dum(1)

c
c Serber spin functions
c

c For each Rumer spin function we determine (minus) the "antisymmetry"
c number, as explained in [Spin Eigenfunctions, R. Pauncz, Sec. 5.5].

c Spin function weight arrays:
      do 2000 iorb=0,nel
      minspn(iorb)=max(iorb-nalf,0)
      maxspn(iorb)=min(iorb/2,nbet)
2000  continue
      call weight_cvb(xspin,minspn,maxspn,nbet,nel)
      if(ifns.ne.xspin((nel+1)*(nbet+1)))then
        write(6,*) ' Discrepancy in IFNS:',ifns,xspin((nel+1)*(nbet+1))
        call abend_cvb()
      endif
      call imove_cvb(maxspn,nkspn,nel+1)
      call occupy_cvb(nkspn,nel,locca,lnocca)
c Loop:
      index=1
c Determine pairings
2100  continue
      do 2200 ib=1,nbet
      ibets(ib)=locca(ib)
      do 2300 ia=nalf,1,-1
      ialfs(ib)=lnocca(ia)
      if(ialfs(ib).lt.ibets(ib))then
        do 2400 iachek=1,ib-1
        if(ialfs(iachek).eq.ialfs(ib))goto 2300
2400    continue
        goto 2500
      endif
2300  continue
2500  continue
2200  continue

      ianti(index)=0
      do 2600 ib=1,nbet
      if(mod(ialfs(ib),2).eq.1.and.ialfs(ib).eq.ibets(ib)-1)
     >  ianti(index)=ianti(index)-1
2600  continue
      call loind_cvb(nel,nbet,nkspn,minspn,maxspn,
     >                       locca,lnocca,index,xspin,*2100)

c Sort according to decreasing values of IANTI :
      nc=0
      do 4000 iantival=nbet,0,-1
      do 4001 k=1,ifns
      if(ianti(k).eq.-iantival)then
        nc=nc+1
        ianti(k)=nc
      endif
4001  continue
4000  continue

      do 5000 k=1,ifns
      if(ianti(k).ne.k)then
        do 5100 l=1,ifns
        if(ianti(l).eq.k)goto 5200
5100    continue
        write(6,*)' Error - swap function not found!',k,ianti(k)
        call abend_cvb()
5200    call dswap_(ndet,bikcof(1,k),1,bikcof(1,l),1)
        ianti(l)=ianti(k)
        ianti(k)=k
      endif
5000  continue

c Orthonormalize :
      call schmidtn_cvb(bikcof,ifns,dum,ndet,0)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine Rysg2(iAnga,nRys,nT,Alpha,Beta,Gmma,Delta,Zeta,ZInv,nZeta,Eta,EInv,nEta,P,lP,Q,lQ,Coori,Coora,CoorAC,Array,nArray, &
                 Tvalue,ModU2,Cff2D,PAO,nPAO,Hess,nHess,IfGrd,IndGrd,IfHss,IndHss,nOp,iuvwx,IfG,mVec,Index_Out,lGrad,lHess,Tr)
!***********************************************************************
!                                                                      *
! Object: to compute the gradient of the two-electron integrals.       *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Modified to 1st order derivatives October '91            *
!             Modified to 2nd order derviatives Mars '95 by            *
!             Anders Bernhardsson Theoretical Chemistry,               *
!             University of Lund                                       *
!***********************************************************************
!   @parameter iAnga     Angular momenta for each center
!   @parameter nRys      Order of Rys polynomia
!   @parameter nT        Number of alpha-beta-gamma-delta multiplies
!   @parameter Alpha     Exponents on 1st center
!   @parameter Beta      Exponents on 2nd center
!   @parameter Gmma      Exponents on 3rd center
!   @parameter Delta     Exponents on 4th center
!   @parameter Zeta      Alpha*Beta
!   @parameter Zeta      Zeta inverse
!   @parameter nZeta     Alpha Beta multiplies
!   @parameter Eta       Gmma*Delta
!   @parameter Eta       Eta inverse
!   @parameter nEta      Gmma Delta multiplies
!   @parameter P
!   @parameter lP        Length of P
!   @parameter Q
!   @parameter lQ        Length of Q
!   @parameter Coori     Coordinates of center just used to check AeqB CeqD etc.
!   @parameter Coora     Coordinates of center used in hor. recursion
!   @parameter CoorAC    Coordinates of center <max(la,lb),max(lc,ld)>
!   @parameter Array     Scratch and output area for 1st derivatives
!   @parameter nArray    Size of scratch area
!   @parameter PAO       Density
!   @parameter nPAO      Length of density
!   @parameter Hess      Output area for Hessian (added)
!   @parameter nHess     Size of Hessian
!   @parameter IfGrad    True for all 1st derivatives that are needed
!   @parameter IndGrad   Index in gradient on which integrals should be added
!   @parameter IfHss     True for all 2nd derivatives that are needed
!   @parameter IndHss    Index in Hess on which contracted integrals should be added
!   @parameter nOp       Operator number for the operator that generates center
!   @parameter iuvwx     Number of stabilizers
!   @parameter IfG       True for all centers on which derivatives should be calculated
!   @parameter Index_Out Index where first derivatives are stored (out)
!   @parameter lHess     True if 2nd derivatives should be calculated
!   @parameter lGrad     True if 1st derivatives should be calculated
!   @parameter Tr        True for all centers on which should be calculated via translation invariance

use vRys_RW, only: nMxRys
use Symmetry_Info, only: nIrrep, iOper
use Gateway_Info, only: ChiI2
use Gateway_global, only: IsChi, NoTab
use Index_Functions, only: nTri_Elem1
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iAnga(4), nRys, nT, nZeta, nEta, lP, lQ, nArray, nPAO, nHess, IndGrd(3,4,0:7), nOp(4), iuvwx(4)
real(kind=wp), intent(in) :: Alpha(nZeta), Beta(nZeta), Gmma(nEta), Delta(nEta), Zeta(nZeta), ZInv(nZeta), Eta(nEta), EInv(nEta), &
                             P(lP,3), Q(lQ,3), Coori(3,4), Coora(3,4), CoorAC(3,2), PAO(nT,nPAO)
real(kind=wp), intent(inout) :: Array(nArray), Hess(nHess)
external :: Tvalue, ModU2, Cff2D
logical(kind=iwp), intent(inout) :: IfGrd(3,4), IfHss(4,3,4,3), IfG(4), Tr(4)
integer(kind=iwp), intent(inout) :: IndHss(4,3,4,3,0:7)
integer(kind=iwp), intent(out) :: mVec, Index_Out(3,4)
logical(kind=iwp), intent(in) :: lGrad, lHess
integer(kind=iwp) :: i, iCent, iEta, Index1(3,4), Index2(3,4,4), Index3(3,3), Index4(2,6,3), iOff, ip, ip2D0, ip2D1, ip2D2, ipB00, &
                     ipB01, ipB10, ipDiv, ipEInv, ipEta, ipg2, ipP, ipPAQP, ipQ, ipQCPQ, ipScr, ipScr2, ipTmp, ipTv, ipU2, ipWgh, &
                     ipZeta, ipZInv, iStop, iZeta, jCar, JndGrd(3,4,0:7), kCent, la, lab, labMax, lb, lB00, lB01, lB10, lc, lCar, &
                     lcd, ld, lla, llb, llc, lld, lOp(4), MemFinal, n2D0, n2D1, n2D2, nabMax, ncdMax, ng(3), nh(3), nTR
logical(kind=iwp) :: KfGrd(3,4)
external :: Exp_1, Exp_2

KfGrd(:,:) = .false.
lOp(1) = iOper(nOp(1))
lOp(2) = iOper(nOp(2))
lOp(3) = iOper(nOp(3))
lOp(4) = iOper(nOp(4))
la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)
lla = 0
llb = 0
llc = 0
lld = 0
if (any(IfGrd(:,1))) lla = 1
if (any(IfGrd(:,2))) llb = 1
if (any(IfGrd(:,3))) llc = 1
if (any(IfGrd(:,4))) lld = 1
do i=1,3
  if (IfHss(1,i,1,i)) lla = 2
  if (IfHss(2,i,2,i)) llb = 2
  if (IfHss(3,i,3,i)) llc = 2
  if (IfHss(4,i,4,i)) lld = 2
end do
lab = max(lla,llb)
lcd = max(llc,lld)
nabMax = la+lb+lab
ncdMax = lc+ld+lcd

! Allocate memory for the integral gradients.

ip = 1

MemFinal = 9*nT*nTri_Elem1(la)*nTri_Elem1(lb)*nTri_Elem1(lc)*nTri_Elem1(ld)
ip = ip+MemFinal

! Allocate memory for the 2D-integrals.

ip2D0 = ip
n2D0 = max((nabMax+1)*(ncdMax+1),(la+3)*(lb+3)*(ncdMax+1),(la+3)*(lb+3)*(lc+3)*(ld+3))
ip = ip+n2D0*3*nT*nRys

! Allocate memory for the 2nd order derivatives of the 2D-integrals.

ip2D1 = ip
n2D1 = max((nabMax+1)*(ncdMax+1),(la+3)*(lb+3)*(ncdMax+1),(la+1)*(lb+1)*(lc+1)*(ld+1)*3)
ip = ip+n2D1*3*nT*nRys

! Allocate memory for the coefficients in the recurrence relation
! of the 2D-integrals.

nTR = nT*nRys
ipPAQP = ip
ip = ip+nTR*3
ipQCPQ = ip
ip = ip+nTR*3
ipB10 = ip
lB10 = max(min(nabMax-1,1),0)
ip = ip+nTR*3*lB10
labMax = min(nabMax,ncdMax)
ipB00 = ip
lB00 = max(min(labMax,1),0)
ip = ip+nTR*3*lB00
ipB01 = ip
lB01 = max(min(ncdMax-1,1),0)
ip = ip+nTR*3*lB01
! Allocate memory for the roots.
ipU2 = ip
ip = ip+nT*nRys
! Allocate memory for Zeta, ZInv, Eta, EInv
ipZeta = ip
ip = ip+nT
ipEta = ip
ip = ip+nT
ipZInv = ip
ip = ip+nT
ipEInv = ip
ip = ip+nT
! Allocate memory for P and Q
ipP = ip
ip = ip+3*nT
ipQ = ip
ip = ip+3*nT
! Allocate memory for the inverse.
ipDiv = ip
ip = ip+nT
! Allocate memory for the arguments.
ipTv = ip
ip = ip+nT
if (ip-1 > nArray) then
  call WarningMessage(2,'Rysg2: ip-1 > nArray (pos. 1)')
  write(u6,*) 'ip,nArray=',ip,nArray
  call Abend()
end if

! Expand Zeta, ZInv, Eta, EInv, P, and Q

do iEta=1,nEta
  iOff = (iEta-1)*nZeta
  call dcopy_(nZeta,Zeta,1,Array(iOff+ipZeta),1)
  call dcopy_(nZeta,ZInv,1,Array(iOff+ipZInv),1)
  call dcopy_(nZeta,P(1,1),1,Array(iOff+ipP),1)
  iOff = iOff+nZeta*nEta
  call dcopy_(nZeta,P(1,2),1,Array(iOff+ipP),1)
  iOff = iOff+nZeta*nEta
  call dcopy_(nZeta,P(1,3),1,Array(iOff+ipP),1)
end do
do iZeta=1,nZeta
  iOff = iZeta-1
  call dcopy_(nEta,Eta,1,Array(iOff+ipEta),nZeta)
  call dcopy_(nEta,EInv,1,Array(iOff+ipEInv),nZeta)
  call dcopy_(nEta,Q(1,1),1,Array(iOff+ipQ),nZeta)
  iOff = iOff+nZeta*nEta
  call dcopy_(nEta,Q(1,2),1,Array(iOff+ipQ),nZeta)
  iOff = iOff+nZeta*nEta
  call dcopy_(nEta,Q(1,3),1,Array(iOff+ipQ),nZeta)
end do

! Compute the arguments for which we will compute the roots and the weights.

call Tvalue(Array(ipZeta),Array(ipEta),Array(ipP),Array(ipQ),nT,Array(ipTv),Array(ipDiv),IsChi,ChiI2)

! Compute roots and weights. Make sure that the weights ends up in
! the array where the z component of the 2D integrals will be.
! Call vRysRW if roots and weights are tabulated in various Taylor
! expansions. If not tabulated call RtsWgh.

! Pointer to z-component of 2D-integrals where the weights will be
! put directly. This corresponds to xyz2D(1,1,3,0,0).
ipWgh = ip2D0+2*nT*nRys
if ((nRys > nMxRys) .or. NoTab) then
  if (ip-1 > nArray) then
    call WarningMessage(2,'Rysg2: ip-1 > nArray (pos. 2)')
    write(u6,*) 'ip,nArray=',ip,nArray
    call Abend()
  end if

  call RtsWgh(Array(ipTv),nT,Array(ipU2),Array(ipWgh),nRys)
else
  if (ip-1 > nArray) then
    call WarningMessage(2,'Rysg2: ip-1 > nArray (pos. 3)')
    write(u6,*) 'ip,nArray=',ip,nArray
    call Abend()
  end if

  ! Make sure rys11/her11 is called  (la+1)
  call vRysRW(la+1,lb,lc,ld,Array(ipTv),Array(ipU2),Array(ipWgh),nT,nRys)
end if
! Drop ipTv
ip = ip-nT

! Modify the roots.

call ModU2(Array(ipU2),nT,nRys,Array(ipDiv))

! Drop ipDiv
ip = ip-nT

! Compute coefficients for the recurrence relations of the 2D-integrals

call Cff2D(max(nabMax-1,0),max(ncdMax-1,0),nRys,Array(ipZeta),Array(ipZInv),Array(ipEta),Array(ipEInv),nT,Coori,CoorAC,Array(ipP), &
           Array(ipQ),la+lab,lb,lc+lcd,ld,Array(ipU2),Array(ipPAQP),Array(ipQCPQ),Array(ipB10),Array(ipB00),labMax,Array(ipB01))
! Drop ipU2
ip = ip-nT*nRys
! Let go of Zeta, ZInv, Eta, and EInv
ip = ip-nT*4
! Let go of P and Q
ip = ip-6*nT

! -------------------------------
! Compute the intermediate 2D-integrals from the roots and weights.

call Rs2Dmm(Array(ip2D0),nT,nRys,nabMax,ncdMax,Array(ipPAQP),Array(ipQCPQ),Array(ipB10),Array(ipB00),Array(ipB01),la,lb,lc,ld, &
            IfHss,IfGrd)

! Drop ipB01
ip = ip-nTR*3*lB01
! Drop ipB00
ip = ip-nTR*3*lB00
! Drop ipB10
ip = ip-nTR*3*lB10
! Drop ipQCPQ
ip = ip-nTR*3
! Drop ipPAQP
ip = ip-nTR*3

! Apply the transfer equation to the intermediate 2D-integrals.

call HrrCtl_mck(Array(ip2D0),n2D0,Array(ip2D1),n2D1,la,lb,lc,ld,nabmax,ncdmax,nTR,Coora(1,1),Coora(1,2),Coora(1,3),Coora(1,4), &
                IfHss,IfGrd)

! Compute the gradients of the 2D-integrals. Copy some information
! which will be modified. This has to be done in order to facilitate
! partitioning.

ip2D2 = ip
n2D2 = (la+1)*(lb+1)*(lc+1)*(ld+1)*18
ip = ip+n2D2*nT*nRys
ipScr = ip
ip = ip+nT*nRys
ipTmp = ip
ip = ip+nT*nRys
ipScr2 = ip
ip = ip+nT*nRys
if (ip-1 > nArray) then
  call WarningMessage(2,'Rysg2: ip-1 > nArray (pos. 4)')
  write(u6,*) 'ip,nArray=',ip,nArray
  call Abend()
end if
JndGrd(:,:,:) = IndGrd(:,:,:)
do iCent=1,4
  do jCar=1,3
    do kCent=1,i
      if (iCent == kCent) then
        iStop = 3
      else
        iStop = jCar-1
      end if
      do lCar=1,istop
        if (jCar /= lCar) then
          if (IfHss(iCent,jCar,kCent,lCar)) then
            KfGrd(jCar,iCent) = .true.
            KfGrd(lCar,kCent) = .true.
          end if
        end if
      end do
    end do
  end do
end do
KfGrd(:,:) = KfGrd .or. IfGrd

call Rs2Dgh(Array(ip2D0),nT,nRys,la,lb,lc,ld,Array(ip2D1),Array(ip2D2),IfHss,IndHss,KfGrd,JndGrd,IfG,Coora,Alpha,Beta,Gmma,Delta, &
            nZeta,nEta,Array(ipScr),Array(ipScr2),Array(ipTmp),Index1,Index2,Index3,Index4,ng,nh,Exp_1,Exp_2,nZeta,nEta,nIrrep,Tr)
! Drop ipScr
ip = ip-nTR
! Drop ipScr2
ip = ip-nTR
! Drop ipTmp
ip = ip-nTR

! G2

ipg2 = ip
ip = ip+78
if (ip-1 > nArray) then
  call WarningMessage(2,'Rysg2: ip-1 > nArray (pos. 5)')
  write(u6,*) 'ip,nArray=',ip,nArray
  call Abend()
end if

if (lGrad) then
  KfGrd(:,:) = KfGrd .and. IfGrd
  call Assg1_mck(Array,nT,nRys,la,lb,lc,ld,Array(ip2D0),Array(ip2D1),KfGrd,Index1,mVec,Index_out)

end if

if (lHess) then
  call Assg2(Array(ipg2),nT,nRys,la,lb,lc,ld,Array(ip2D0),Array(ip2D1),Array(ip2D2),IfHss,Index3,Index4,ng,nh,PAO)

  ! Distribute the contributions to the molecular static hessian

  call Distg2(Array(ipg2),Hess,nHess,JndGrd,IfHss,IndHss,iuvwx,lOp,nop,Tr,IfG)
end if

! Drop ipg2
ip = ip-78
! Drop ip2D1
ip = ip-nTR*3*n2D1
! Drop ip2D0
ip = ip-nTR*3*n2D0
! Drop ip2D2
ip = ip-n2D2*nT*nRys

if (ip /= 1+MemFinal) then
  call WarningMessage(2,'Rysg2: ip /= 1+MemFinal (pos. 5)')
  write(u6,*) 'ip,MemFinal=',ip,MemFinal
  call Abend()
end if
IfGrd(:,:) = KfGrd

return

end subroutine Rysg2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module RASDim

use Definitions, only: iwp

implicit none
private

! Parameter definitions
! Note, these parameters define the size of the problems which
! can be treated by the RASSCF program. Changing any of these
! requires, that the program is totaly recompiled and linked.
!
! mxRef  max number of reference configurations in root selectioning
! mxIter max number of macro iterations
! mxCiIt max number of micro iterations for the CI section
! mxSxIt max number of micro iterations for the SX section
! mxTit  max number of title lines

integer(kind=iwp), parameter :: mxCiIt = 502, mxIter = 200, mxRef = 5, mxSxIt = 100, mxTit = 1

public :: mxCiIt, mxIter, mxRef, mxSxIt, mxTit

end module RASDim

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_INT_1_DBG1(DIAG,IRED)
C
C     Purpose: test diagonal, reduced set IRED. Note that the
C              diagonal *must* be the original diagonal stored
C              in reduced set 1.
C
#include "implicit.fh"
      DIMENSION DIAG(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*18 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_INT_1_DBG1')

      LOGICAL PRTINT
      PARAMETER (PRTINT = .FALSE.)

      IIBSTRSH(I,J,K)=IWORK(ip_IIBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)
      INDRSH(I)=IWORK(ip_INDRSH-1+I)
      NBSTSH(I)=IWORK(ip_NBSTSH-1+I)
      ISP2F(I)=IWORK(ip_iSP2F-1+I)

      WRITE(LUPRI,*)
      WRITE(LUPRI,*)
      WRITE(LUPRI,*) SECNAM,': testing diagonal, reduced set ',IRED
      WRITE(LUPRI,*)

C     Force computation of full shell quadruple.
C     ------------------------------------------

      IF (IFCSEW .NE. 1) THEN
         WRITE(LUPRI,*) SECNAM,': WARNING: resetting IFCSEW from ',
     &                  IFCSEW,' to 1.'
         IFCSEW = 1
      END IF

      LINT1 = MX2SH*MX2SH
      CALL GETMEM('Int1.dbg1.1','ALLO','REAL',KINT,LINT1)
      CALL GETMEM('Int1.dbg1.2','MAX ','REAL',KSEW,LSEW)
      CALL XSETMEM_INTS(LSEW)

      NERR = 0
      NTST = 0
      DO ISHLAB = 1,NNSHL

C        Allocate memory for shell quadruple (AB|AB).
C        --------------------------------------------

         CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.TRUE.)
         IF (ISHLB .EQ. ISHLA) THEN
            NUMAB = NBSTSH(ISHLA)*(NBSTSH(ISHLB) + 1)/2
         ELSE
            NUMAB = NBSTSH(ISHLA)*NBSTSH(ISHLB)
         END IF
         LINT = NUMAB*NUMAB

C        Calculate integrals.
C        --------------------

         CALL CHO_DZERO(WORK(KINT),LINT)
         CALL CHO_MCA_INT_1(ISHLAB,ISHLAB,WORK(KINT),LINT,PRTINT)

C        Look up all diagonal elements in DIAG and compare to
C        values just calculated.
C        ----------------------------------------------------

         IERR = 0
         IF (IRED .EQ. 1) THEN

            DO ISYM = 1,NSYM

               JAB1 = IIBSTR(ISYM,1) + IIBSTRSH(ISYM,ISHLAB,1)
     &              + 1
               JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,1) - 1

               DO JAB = JAB1,JAB2   ! loop over elements in diagonal

                  IF ((JAB.LT.1) .OR. (JAB.GT.NNBSTRT(1))) THEN
                     WRITE(LUPRI,*) SECNAM,': JAB = ',JAB
                     WRITE(LUPRI,*) SECNAM,
     &                              ': should be between 1 and ',
     &                              NNBSTRT(1)
                     CALL CHO_QUIT(SECNAM//': index error (IRED=1)',
     &                             103)
                  END IF

                  JSHLAB = INDRSH(JAB)
                  IF (JSHLAB .NE. ISP2F(ISHLAB)) THEN
                     WRITE(LUPRI,*) SECNAM,': test is meaningless!'
                     WRITE(LUPRI,*) SECNAM,': JSHLAB must equal ',
     &                              'ISP2F(ISHLAB)'
                     WRITE(LUPRI,*) SECNAM,': JSHLAB,ISP2F(ISHLAB): ',
     &                              JSHLAB,ISP2F(ISHLAB)
                     CALL CHO_QUIT(SECNAM//': shell bug (IRED=1)',
     &                             103)
                  END IF

                  IAB = INDRED(JAB,1)
                  IF ((IAB.LT.1) .OR. (IAB.GT.NUMAB)) THEN
                     WRITE(LUPRI,*) SECNAM,': IAB = ',IAB
                     WRITE(LUPRI,*) SECNAM,
     &                             ': should be between 1 and ',NUMAB
                     CALL CHO_QUIT(SECNAM//': index error (IRED=1)',
     &                             103)
                  END IF

                  KABAB = KINT + NUMAB*(IAB - 1) + IAB - 1
                  DIFF  = DIAG(JAB) - WORK(KABAB)
                  IF (ABS(DIFF) .GT. 1.0D-14) THEN
                     WRITE(LUPRI,*)
     &               SECNAM,': ISHLA,ISHLB,JAB,IAB,DIFF: ',
     &               ISHLA,ISHLB,JAB,IAB,DIFF
                     IERR = IERR + 1
                  END IF

                  NTST = NTST + 1

               END DO

            END DO

            WRITE(LUPRI,*)
     &      SECNAM,': ISHLA,ISHLB,#errors: ',ISHLA,ISHLB,IERR

            NERR = NERR + IERR

         ELSE IF ((IRED.EQ.2) .OR. (IRED.EQ.3)) THEN

            DO ISYM = 1,NSYM

               JAB1 = IIBSTR(ISYM,IRED) + IIBSTRSH(ISYM,ISHLAB,IRED)
     &              + 1
               JAB2 = JAB1 + NNBSTRSH(ISYM,ISHLAB,IRED) - 1

               DO JAB = JAB1,JAB2   ! loop over elements in diagonal

                  IF ((JAB.LT.1) .OR. (JAB.GT.NNBSTRT(IRED))) THEN
                     WRITE(LUPRI,*) SECNAM,': JAB = ',JAB
                     WRITE(LUPRI,*) SECNAM,
     &                              ': should be between 1 and ',
     &                              NNBSTRT(IRED)
                     CALL CHO_QUIT(SECNAM//': index error (IRED>1)',
     &                             103)
                  END IF

                  JSHLAB = INDRSH(INDRED(JAB,IRED))
                  IF (JSHLAB .NE. ISP2F(ISHLAB)) THEN
                     WRITE(LUPRI,*) SECNAM,': test is meaningless!'
                     WRITE(LUPRI,*) SECNAM,': JSHLAB must equal ',
     &                              'ISP2F(ISHLAB)'
                     WRITE(LUPRI,*) SECNAM,': JSHLAB,ISP2F(ISHLAB): ',
     &                              JSHLAB,ISP2F(ISHLAB)
                     CALL CHO_QUIT(SECNAM//': shell bug (IRED>1)',
     &                             103)
                  END IF

                  KAB = INDRED(JAB,IRED)  ! index in red. set 1
                  IF ((KAB.LT.1) .OR. (KAB.GT.NNBSTRT(1))) THEN
                     WRITE(LUPRI,*) SECNAM,': KAB = ',KAB
                     WRITE(LUPRI,*) SECNAM,
     &                              ': should be between 1 and ',
     &                              NNBSTRT(1)
                     CALL CHO_QUIT(SECNAM//': index error (IRED>1)',
     &                             103)
                  END IF

                  IAB = INDRED(KAB,1)
                  IF ((IAB.LT.1) .OR. (IAB.GT.NUMAB)) THEN
                     WRITE(LUPRI,*) SECNAM,': IAB = ',IAB
                     WRITE(LUPRI,*) SECNAM,
     &                             ': should be between 1 and ',NUMAB
                     CALL CHO_QUIT(SECNAM//': index error (IRED>1)',
     &                             103)
                  END IF

                  KABAB = KINT + NUMAB*(IAB - 1) + IAB - 1
                  DIFF  = DIAG(KAB) - WORK(KABAB)
                  IF (ABS(DIFF) .GT. 1.0D-14) THEN
                     WRITE(LUPRI,*)
     &               SECNAM,': ISHLA,ISHLB,JAB,IAB,DIFF: ',
     &               ISHLA,ISHLB,JAB,IAB,DIFF
                     IERR = IERR + 1
                  END IF

                  NTST = NTST + 1

               END DO

            END DO

            WRITE(LUPRI,*)
     &      SECNAM,': ISHLA,ISHLB,#errors: ',ISHLA,ISHLB,IERR

            NERR = NERR + IERR

         ELSE

            CALL CHO_QUIT(SECNAM//': IRED out of bounds!',104)

         END IF

      END DO

      CALL XRLSMEM_INTS
      CALL GETMEM('Int1.flsh','FLUSH','REAL',KINT,LINT1)
      CALL GETMEM('Int1.free','FREE','REAL',KINT,LINT1)

      WRITE(LUPRI,*) '***END OF ',SECNAM,': #tests: ',NTST,
     &               ' #errors: ',NERR

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SetGlob()
C
C     Purpose: define entries in choglob.fh
C
      Implicit None
#include "choglob.fh"

      Integer N, iSym

      Integer, Parameter:: iLarge=999999

      nnShl_G = 0
      mmBstRT_G = 0

      N = 8*nLoc_G
      Call iZero(iiBstR_G,N)
      Call iZero(nnBstR_G,N)
      Call iZero(nnBstRT_G,nLoc_G)
      Call iZero(NumCho_G,8)
      NumChT_G = 0

      Do iSym = 1,8
         LuCho_G(iSym) = -iLarge
      End Do
      LuRed_G = -iLarge
      LuRst_G = -iLarge

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine HrrMtrx(HMtrx,np,la,lb,A,B,Sph_a,CS_a,nSph_a,Sph_b,Cs_b,nSph_b)
!***********************************************************************
!                                                                      *
!     Object: to compute the matrix which corresponds to the transfer  *
!             equation.                                                *
!                                                                      *
!     Author: Roland Lindh                                             *
!             Dept of Chem. Phys.                                      *
!             Univ. of Lund, Sweden                                    *
!             February 1999                                            *
!***********************************************************************

use Index_Functions, only: C3_Ind3, nTri_Elem1, nTri3_Elem
use define_af, only: Binom, iCan, iTabMx
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: np, la, lb, nSph_a, nSph_b
real(kind=wp), intent(out) :: HMtrx(np,nSph_a,nSph_b)
real(kind=wp), intent(in) :: A(3), B(3), CS_a(nTri_Elem1(la),nSph_a), CS_b(nTri_Elem1(lb),nSph_b)
logical(kind=iwp), intent(in) :: Sph_a, Sph_b
integer(kind=iwp) :: i, ipa, ipb, ipe, iSph_a, iSph_b, ix, ixLow, iy, iyLow, iz, izLow, jOff, jx, jxLow, jy, jyLow, jz, jzLow, kx, &
                     ky, kz, lta, ltb, na, nab, nb
real(kind=wp) :: AB(3,0:iTabMx), ABx, ABy, ABz, C_A, C_B
logical(kind=iwp), external :: EQ
#ifdef _DEBUGPRINT_
real(kind=wp), external :: DDot_
#endif

lta = nTri_Elem1(la)
ltb = nTri_Elem1(lb)
#ifdef _DEBUGPRINT_
call RecPrt('A',' ',A,1,3)
call RecPrt('B',' ',B,1,3)
call RecPrt('CS_a',' ',CS_a,lta,nSph_a)
call RecPrt('CS_b',' ',CS_b,ltb,nSph_b)
write(u6,*) 'np=',np
#endif
HMtrx(:,:,:) = Zero

AB(:,0) = One
if (la >= lb) then
  AB(:,1) = A(:)-B(:)
else
  AB(:,1) = B(:)-A(:)
end if
do i=2,min(la,lb)
  AB(:,i) = AB(:,i-1)*AB(:,1)
end do

na = nTri3_Elem(la)
nb = nTri3_Elem(lb)
nab = nTri3_Elem(la+lb)

if (la >= lb) then

  if (Sph_a .and. Sph_b) then

    do iSph_a=1,nSph_a
      do ipa=1,lta
        C_a = CS_a(ipa,iSph_a)
        if (C_a == Zero) cycle
        ix = iCan(1,na+ipa)
        iy = iCan(2,na+ipa)
        iz = iCan(3,na+ipa)
        do iSph_b=1,nSph_b
          do ipb=1,ltb
            C_b = CS_b(ipb,iSph_b)
            if (C_b == Zero) cycle
            jx = iCan(1,nb+ipb)
            jy = iCan(2,nb+ipb)
            jz = iCan(3,nb+ipb)

            if (EQ(A,B)) then
              ixLow = ix+jx
              iyLow = iy+jy
              izLow = iz+jz
              jOff = nab
            else
              ixLow = ix
              iyLow = iy
              izLow = iz
              jOff = na
            end if
            do kx=ixLow,ix+jx
              do ky=iyLow,iy+jy
                do kz=izLow,iz+jz
                  ipe = C3_Ind3(kx,ky,kz)-jOff

                  ABx = AB(1,ix+jx-kx)*Binom(jx,kx-ix)
                  ABy = AB(2,iy+jy-ky)*Binom(jy,ky-iy)
                  ABz = AB(3,iz+jz-kz)*Binom(jz,kz-iz)
                  HMtrx(ipe,iSph_a,iSph_b) = HMtrx(ipe,iSph_a,iSph_b)+ABx*ABy*ABz*C_a*C_b
                end do
              end do
            end do

          end do
        end do
      end do
    end do

  else if (Sph_a) then

    do iSph_a=1,nSph_a
      do ipa=1,lta
        C_a = CS_a(ipa,iSph_a)
        if (C_a == Zero) cycle
        ix = iCan(1,na+ipa)
        iy = iCan(2,na+ipa)
        iz = iCan(3,na+ipa)
        do ipb=1,ltb
          jx = iCan(1,nb+ipb)
          jy = iCan(2,nb+ipb)
          jz = iCan(3,nb+ipb)

          if (EQ(A,B)) then
            ixLow = ix+jx
            iyLow = iy+jy
            izLow = iz+jz
            jOff = nab
          else
            ixLow = ix
            iyLow = iy
            izLow = iz
            jOff = na
          end if
          do kx=ixLow,ix+jx
            do ky=iyLow,iy+jy
              do kz=izLow,iz+jz
                ipe = C3_Ind3(kx,ky,kz)-jOff

                ABx = AB(1,ix+jx-kx)*Binom(jx,kx-ix)
                ABy = AB(2,iy+jy-ky)*Binom(jy,ky-iy)
                ABz = AB(3,iz+jz-kz)*Binom(jz,kz-iz)
                HMtrx(ipe,iSph_a,ipb) = HMtrx(ipe,iSph_a,ipb)+ABx*ABy*ABz*C_a
              end do
            end do
          end do

        end do
      end do
    end do

  else if (Sph_b) then

    do ipa=1,lta
      ix = iCan(1,na+ipa)
      iy = iCan(2,na+ipa)
      iz = iCan(3,na+ipa)
      do iSph_b=1,nSph_b
        do ipb=1,ltb
          C_b = CS_b(ipb,iSph_b)
          if (C_b == Zero) cycle
          jx = iCan(1,nb+ipb)
          jy = iCan(2,nb+ipb)
          jz = iCan(3,nb+ipb)

          if (EQ(A,B)) then
            ixLow = ix+jx
            iyLow = iy+jy
            izLow = iz+jz
            jOff = nab
          else
            ixLow = ix
            iyLow = iy
            izLow = iz
            jOff = na
          end if
          do kx=ixLow,ix+jx
            do ky=iyLow,iy+jy
              do kz=izLow,iz+jz
                ipe = C3_Ind3(kx,ky,kz)-jOff

                ABx = AB(1,ix+jx-kx)*Binom(jx,kx-ix)
                ABy = AB(2,iy+jy-ky)*Binom(jy,ky-iy)
                ABz = AB(3,iz+jz-kz)*Binom(jz,kz-iz)
                HMtrx(ipe,ipa,iSph_b) = HMtrx(ipe,ipa,iSph_b)+ABx*ABy*ABz*C_b
              end do
            end do
          end do

        end do
      end do
    end do

  else

    do ipa=1,lta
      ix = iCan(1,na+ipa)
      iy = iCan(2,na+ipa)
      iz = iCan(3,na+ipa)
      do ipb=1,ltb
        jx = iCan(1,nb+ipb)
        jy = iCan(2,nb+ipb)
        jz = iCan(3,nb+ipb)

        if (EQ(A,B)) then
          ixLow = ix+jx
          iyLow = iy+jy
          izLow = iz+jz
          jOff = nab
        else
          ixLow = ix
          iyLow = iy
          izLow = iz
          jOff = na
        end if
        do kx=ixLow,ix+jx
          do ky=iyLow,iy+jy
            do kz=izLow,iz+jz
              ipe = C3_Ind3(kx,ky,kz)-jOff

              ABx = AB(1,ix+jx-kx)*Binom(jx,kx-ix)
              ABy = AB(2,iy+jy-ky)*Binom(jy,ky-iy)
              ABz = AB(3,iz+jz-kz)*Binom(jz,kz-iz)
              HMtrx(ipe,ipa,ipb) = HMtrx(ipe,ipa,ipb)+ABx*ABy*ABz
            end do
          end do
        end do

      end do
    end do

  end if

else

  if (Sph_a .and. Sph_b) then

    do iSph_a=1,nSph_a
      do ipa=1,lta
        C_a = CS_a(ipa,iSph_a)
        if (C_a == Zero) cycle
        ix = iCan(1,na+ipa)
        iy = iCan(2,na+ipa)
        iz = iCan(3,na+ipa)
        do iSph_b=1,nSph_b
          do ipb=1,ltb
            C_b = CS_b(ipb,iSph_b)
            if (C_b == Zero) cycle
            jx = iCan(1,nb+ipb)
            jy = iCan(2,nb+ipb)
            jz = iCan(3,nb+ipb)

            if (EQ(A,B)) then
              jxLow = ix+jx
              jyLow = iy+jy
              jzLow = iz+jz
              jOff = nab
            else
              jxLow = jx
              jyLow = jy
              jzLow = jz
              jOff = nb
            end if
            do kx=jxLow,ix+jx
              do ky=jyLow,iy+jy
                do kz=jzLow,iz+jz
                  ipe = C3_Ind3(kx,ky,kz)-jOff

                  ABx = AB(1,ix+jx-kx)*Binom(ix,kx-jx)
                  ABy = AB(2,iy+jy-ky)*Binom(iy,ky-jy)
                  ABz = AB(3,iz+jz-kz)*Binom(iz,kz-jz)
                  HMtrx(ipe,iSph_a,iSph_b) = HMtrx(ipe,iSph_a,iSph_b)+ABx*ABy*ABz*C_a*C_b
                end do
              end do
            end do

          end do
        end do
      end do
    end do

  else if (Sph_a) then

    do iSph_a=1,nSph_a
      do ipa=1,lta
        C_a = CS_a(ipa,iSph_a)
        if (C_a == Zero) cycle
        ix = iCan(1,na+ipa)
        iy = iCan(2,na+ipa)
        iz = iCan(3,na+ipa)
        do ipb=1,ltb
          jx = iCan(1,nb+ipb)
          jy = iCan(2,nb+ipb)
          jz = iCan(3,nb+ipb)

          if (EQ(A,B)) then
            jxLow = ix+jx
            jyLow = iy+jy
            jzLow = iz+jz
            jOff = nab
          else
            jxLow = jx
            jyLow = jy
            jzLow = jz
            jOff = nb
          end if
          do kx=jxLow,ix+jx
            do ky=jyLow,iy+jy
              do kz=jzLow,iz+jz
                ipe = C3_Ind3(kx,ky,kz)-jOff

                ABx = AB(1,ix+jx-kx)*Binom(ix,kx-jx)
                ABy = AB(2,iy+jy-ky)*Binom(iy,ky-jy)
                ABz = AB(3,iz+jz-kz)*Binom(iz,kz-jz)
                HMtrx(ipe,iSph_a,ipb) = HMtrx(ipe,iSph_a,ipb)+ABx*ABy*ABz*C_a
              end do
            end do
          end do

        end do
      end do
    end do

  else if (Sph_b) then

    do ipa=1,lta
      ix = iCan(1,na+ipa)
      iy = iCan(2,na+ipa)
      iz = iCan(3,na+ipa)
      do iSph_b=1,nSph_b
        do ipb=1,ltb
          C_b = CS_b(ipb,iSph_b)
          if (C_b == Zero) cycle
          jx = iCan(1,nb+ipb)
          jy = iCan(2,nb+ipb)
          jz = iCan(3,nb+ipb)

          if (EQ(A,B)) then
            jxLow = ix+jx
            jyLow = iy+jy
            jzLow = iz+jz
            jOff = nab
          else
            jxLow = jx
            jyLow = jy
            jzLow = jz
            jOff = nb
          end if
          do kx=jxLow,ix+jx
            do ky=jyLow,iy+jy
              do kz=jzLow,iz+jz
                ipe = C3_Ind3(kx,ky,kz)-jOff

                ABx = AB(1,ix+jx-kx)*Binom(ix,kx-jx)
                ABy = AB(2,iy+jy-ky)*Binom(iy,ky-jy)
                ABz = AB(3,iz+jz-kz)*Binom(iz,kz-jz)
                HMtrx(ipe,ipa,iSph_b) = HMtrx(ipe,ipa,iSph_b)+ABx*ABy*ABz*C_b
              end do
            end do
          end do

        end do
      end do
    end do

  else

    do ipa=1,lta
      ix = iCan(1,na+ipa)
      iy = iCan(2,na+ipa)
      iz = iCan(3,na+ipa)
      do ipb=1,ltb
        jx = iCan(1,nb+ipb)
        jy = iCan(2,nb+ipb)
        jz = iCan(3,nb+ipb)

        if (EQ(A,B)) then
          jxLow = ix+jx
          jyLow = iy+jy
          jzLow = iz+jz
          jOff = nab
        else
          jxLow = jx
          jyLow = jy
          jzLow = jz
          jOff = nb
        end if
        do kx=jxLow,ix+jx
          do ky=jyLow,iy+jy
            do kz=jzLow,iz+jz
              ipe = C3_Ind3(kx,ky,kz)-jOff

              ABx = AB(1,ix+jx-kx)*Binom(ix,kx-jx)
              ABy = AB(2,iy+jy-ky)*Binom(iy,ky-jy)
              ABz = AB(3,iz+jz-kz)*Binom(iz,kz-jz)
              HMtrx(ipe,ipa,ipb) = HMtrx(ipe,ipa,ipb)+ABx*ABy*ABz
            end do
          end do
        end do

      end do
    end do

  end if

end if
#ifdef _DEBUGPRINT_
call RecPrt('HMat ( np x (nSph_a*nSph_b) )','(30F4.1)',HMtrx,np,nSph_a*nSph_b)
write(u6,*) DDot_(np*nSph_a*nSph_b,HMtrx,1,HMtrx,1)
#endif

return

end subroutine HrrMtrx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine CpOvlp(from,to)
      Implicit Real*8 (a-h,o-z)
      Dimension from(*),to(*)
#include "parm.fh"
#include "common.fh"
      logical oki,okj
#include "symlab.fh"
      Do 100 iBlk=1,(MxLqn+1)*(MxLqn+1)
         indx=0
         ijBas=0
         iBasX=0
         Do 110 iSym=1,nSym
         Do 111 iBas=1,nBas(iSym)
         iBasX=iBasX+1
         oki=Name(iBasX)(1:LENIN).eq.Center
         oki=oki .and. Name(iBasX)(LENIN1:LENIN8).eq.type(iBlk)
         If(oki) indx=indx+1
         jndx=0
         jBasX=iBasX-iBas
         Do 112 jBas=1,iBas
            jBasX=jBasX+1
            ijBas=ijBas+1
            okj=Name(jBasX)(1:LENIN).eq.Center
            okj=okj .and. Name(jBasX)(LENIN1:LENIN8).eq.type(iBlk)
            If(okj) jndx=jndx+1
            If(oki .and. okj) Then
               ind=jndx+indx*(indx-1)/2+iSymBk(iBlk)-1
               to(ind)=from(ijBas)
            End If
112      Continue
111      Continue
110      Continue
100   Continue
*     Write(*,*) '*** Overlap matrix in CpOvlp ***'
      iBlk=0
      Do 200 iLqn=0,MxLqn
         Do 210 iShell=-iLqn,iLqn
            iBlk=iBlk+1
            If(nPrim(iLqn).gt.0) Then
*              Write(*,'(a,2i5)') ' Block',iLqn,iShell
*              Call Triprt(' ','(6F12.6)',to(iSymBk(iBlk)),nPrim(iLqn))
            End If
210      Continue
200   Continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Local_Properties(Coor,nAtoms,ip_sq_mu,nElem,
     &                            Sq_Temp,Origin,iCenter,Ttot_Inv,
     &                            Temp,nij,nPert,ip_D,rMP,lMax,rMPq,
     &                            C_o_C,EC,iANr,Standard,nBas1,nTemp,
     &                            Q_Nuc,Bond_Threshold,Utility,
     &                            Opt_Method,iPlot,iPrint,nSym)
      Implicit Real*8 (a-h,o-z)
#include "itmax.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Coor(3,nAtoms), A(3), B(3), Sq_Temp(nTemp),
     &        Origin(3,0:lMax), Ref(3), C_o_C(3), EC(3,nij),
     &       Ttot_Inv(nBas1**2), Temp(nTemp), Q_Nuc(nAtoms),
     &       rMP(nij,0:nElem-1,0:nPert-1), rMPq(0:nElem-1)
      Integer ip_sq_Mu(0:nElem-1), iCenter(nBas1), ip_D(0:6),
     &        iANr(nAtoms)
      Logical Standard,Utility,Reduce_Prt
      External Reduce_Prt
      Character*12  Opt_Method

#include "Molcas.fh"
      CHARACTER*(LENIN) CNAME(MXATOM)
      integer tNuc
      Data Ref/0.0D0,0.0D0,0.0D0/
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Binom()
*                                                                      *
************************************************************************
*                                                                      *
*---- Loop over perturbations
*
      Do iPert = 0, nPert-1
*
*        Transform the density matrix to the LoProp basis
*
         iOffD=ip_D(iPert)-1
         Do i = 1, nBas1
            Do j = 1, i-1
               ij = i * (i-1)/2 + j
               ij_ = (j-1)*nBas1+i
               ji_ = (i-1)*nBas1+j
               Sq_Temp(ij_)=Half*Work(ij+iOffD)
               Sq_Temp(ji_)=Sq_Temp(ij_)
            End Do
            ii = i*(i+1)/2
            ii_= (i-1)*nBas1+i
            Sq_Temp(ii_)=Work(ii+iOffD)
         End Do
*
         Call DGEMM_('N','T',
     &               nBas1,nBas1,nBas1,
     &               1.0d0,Sq_Temp,nBas1,
     &               Ttot_Inv,nBas1,
     &               0.0d0,Temp,nBas1)
         Call DGEMM_('N','N',
     &               nBas1,nBas1,nBas1,
     &               1.0d0,Ttot_Inv,nBas1,
     &               Temp,nBas1,
     &               0.0d0,Sq_Temp,nBas1)
*
cvv
      Call Get_iScalar('Unique atoms',nNUC)
      Call Get_cArray('Unique Atom Names',CNAME,(LENIN)*nNuc)

      Call Get_iScalar('LP_nCenter', tNuc)
c someday this code will use symmetry
*
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0
*
      if(nSym.eq.1.and.tNuc.eq.nNuc.and.iPL.ge.2) then

       NBAST=nBas1
      Call Allocate_iWork(ip_center,NBAST)
      Call Get_iArray('Center Index',iWork(ip_center),NBAST)
      Call Allocate_iWork(ipNBFpA,tNUC)
      Do I = 1, tNUC
          iWork(ipNBFpA+I-1) = 0
      End Do
      Do I = 1, NBAST
          iWork(ipNBFpA+iWork(ip_center+I-1)-1) =
     &     iWork(ipNBFpA+iWork(ip_center+I-1)-1) + 1
      End Do
        Call Allocate_Work(ip_Charge,tNuc)
      Call Get_dArray('Effective nuclear charge',
     &      Work(ip_Charge),tNuc)
#ifdef VV_VALE
      Call Allocate_Work(ip_VV_QAB,tNuc)
      Call Allocate_Work(ip_VV_WAB,tNuc*tNuc)
      Call Allocate_Work(ip_VV_CAB,tNuc)
      Call Allocate_Work(ip_VV_VAB,tNuc)
      Call Allocate_iWork(ip_VV_N,tNuc+1)

       call VALE(tNuc,iWork(ipNBFpA),Work(ip_Charge),
     &           nBast,Sq_Temp,
     &     CName,LenIn,iWork(ip_VV_N),
     &     Work(ip_VV_QAB),Work(ip_VV_WAB),
     &     Work(ip_VV_CAB), Work(ip_VV_VAB))


      Call Free_Work(ip_VV_N)
      Call Free_Work(ip_VV_VAB)
      Call Free_Work(ip_VV_CAB)
      Call Free_Work(ip_VV_WAB)
      Call Free_Work(ip_VV_QAB)
#endif
      Call Free_Work(ip_Charge)
      Call Free_Work(ipNBFpA)
      Call Free_Work(ip_center)
      endif
cvv
         iMu = -1
         Do l = 0, lMax
         Do ix = l, 0, -1
         Do iy = l-ix, 0, -1
            iz = l-ix-iy
            iMu = iMu + 1
*
*....... Compute local properties
*
         Do iAtom = 1, nAtoms
            call dcopy_(3,Coor(1,iAtom),1,A,1)
            Do jAtom = 1, iAtom
               call dcopy_(3,Coor(1,jAtom),1,B,1)
*
*
*              Sum up contibutions to the domain ij
*
               Acc=Zero
               iOffO=ip_sq_mu(iMu)-1
               Do j = 1, nBas1
                  Do i = 1, nBas1
                     If ((iCenter(i).eq.iAtom .and.
     &                    iCenter(j).eq.jAtom) .or.
     &                   (iCenter(i).eq.jAtom .and.
     &                    iCenter(j).eq.iAtom)) Then
                        ij = (j-1)*nBas1+i
                        Acc = Acc + Sq_Temp(ij)*Work(ij+iOffO)
                     End If
                  End Do
               End Do
               ij=iAtom*(iAtom-1)/2+jAtom
               rMP(ij,iMu,iPert)=-Acc
*
            End Do   ! jAtom
            End Do   ! iAtom
*
         End Do   ! iy
         End Do   ! ix
         End Do   ! l
*                                                                      *
************************************************************************
*                                                                      *
         Call Free_Work(ip_D(iPert))
      End Do         ! iPert
*                                                                      *
************************************************************************
*                                                                      *
*     Modify all multipole moments
*
*     1) Modify first all to a common origin (0.0,0.0,0.0)
*     2) Modify to local moments
*
#ifdef _DEBUGPRINT_
      Call xSpot ('Middle  Local_Properties')
      Call RecPrt('rMP',' ',rMP,nij,nElem*nPert)
#endif
      Do iAtom = 1, nAtoms
         ii = iAtom*(iAtom+1)/2
*
*        Observe the loop order to make sure that element (ii) and
*        (jj) always are processed before (ij)!
*
         Do jAtom = iAtom, 1, -1
            ij = iAtom*(iAtom-1)/2+jAtom
            jj = jAtom*(jAtom+1)/2
C           Write (*,*) 'ij=',ij
*
*           Step 1
*
            Do l = 1, lMax-1
               mElem = (l+1)*(l+2)*(l+3)/6
               Do iPert = 0, nPert-1
                  Call ReExpand(rMP(1,0,iPert),nij,mElem,Origin(1,l),
     &                          Origin(1,l+1),ij,l)
               End Do
               If (ij.eq.1) Call ReExpand(rMPq,1,mElem,Origin(1,l),
     &                                    Origin(1,l+1),1,l)
            End Do
C           Write (6,*) 'End step 1a'
            mElem = (lMax+1)*(lMax+2)*(lMax+3)/6
            Do iPert = 0, nPert-1
               Call ReExpand(rMP(1,0,iPert),nij,mElem,Origin(1,lMax),
     &                       Ref,ij,lMax)
            End Do
            If (ij.eq.1) Call ReExpand(rMPq,1,mElem,Origin(1,lMax),
     &                                 C_o_C,1,lmax)
C           Write (6,*) 'End step 1b'
*
*           Step 2
*
*           Establish the initial expansion centers for each domain.
*
*           Default values
*
            If (iAtom.eq.jAtom) Then
               A(1)=Coor(1,iAtom)
               A(2)=Coor(2,iAtom)
               A(3)=Coor(3,iAtom)
            Else
               A(1) = (EC(1,ii)+EC(1,jj))*Half
               A(2) = (EC(2,ii)+EC(2,jj))*Half
               A(3) = (EC(3,ii)+EC(3,jj))*Half
            End If
            call dcopy_(3,A,1,EC(1,ij),1)
            Do iPert = 0, nPert-1
               Call ReExpand(rMP(1,0,iPert),nij,mElem,Ref,A,ij,lMax)
            End Do
C           Write (6,*) 'End step 2'
*
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
* Distributes the contributions from the bonds that doesn't fulfill the requirement
* Bond_Length <= Bond_Threshold*(Bragg_Slater(iAtom)+Bragg_Slater(jAtom) to the
* two atoms involved in the bond.
*
      Call Move_Prop(rMP,EC,lMax,nElem,nAtoms,nPert,
     &               nij,iANr,Bond_Threshold)
*
*           Modify the expansion centers
*
      Num_Warnings = 0
      Call Allocate_Work(iT_values,nij)
      Call Allocate_iWork(iT_sets,nij)
      Call Allocate_iWork(iWarnings,nij)
      Call iCopy(nij,[0],0,iWork(iWarnings),1)
      Call iCopy(nij,[0],0,iWork(iT_Sets),1)
      Call dCopy_(nij,[Zero],0,Work(iT_Values),1)
      If (.Not. Standard) Then
         Call Allocate_Work(iScratch_1,nij*(2*lMax+1))
         Call Allocate_Work(iScratch_2,nij*(2*lMax+1))
         Call Allocate_Work(iScratch_A,3*nij)
         Call Allocate_Work(iScratch_B,3*nij)
         Call Allocate_Work(ixrMP,nij*nElem)
         Call Allocate_Work(ixxrMP,nij*nElem)
         Call Allocate_Work(ixnrMP,nij*nElem)
*
         Call Move_EC(rMP,EC,Work(iScratch_1),Work(iScratch_2),
     &                Work(ixrMP),Work(ixxrMP),Work(ixnrMP),lMax,
     &                Work(iScratch_A),Work(iScratch_B),nij,
     &                nElem,Coor,nAtoms,Q_Nuc,C_o_C,nPert,
     &                Bond_Threshold,iANr,Work(iT_Values),
     &                iWork(iT_Sets),iWork(iWarnings),Num_Warnings,
     &                Opt_Method,iPlot,iPrint)
*
         Call Free_Work(ixnrMP)
         Call Free_Work(ixxrMP)
         Call Free_Work(ixrMP)
         Call Free_Work(iScratch_B)
         Call Free_Work(iScratch_A)
         Call Free_Work(iScratch_2)
         Call Free_Work(iScratch_1)
      End If
      If (iPrint .ge. 1 .OR. iPlot .ge. 1 .OR. Num_Warnings .gt. 0) Then
         Call Print_T_Values(Work(iT_Values),iWork(iT_Sets),iANr,EC,
     &                       Bond_Threshold,nAtoms,nij,Standard,
     &                       iWork(iWarnings),Num_Warnings,iPrint)
      End If
      Call Free_iWork(iWarnings)
      Call Free_iWork(iT_values)
      Call Free_iWork(iT_sets)
*
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Call RecPrt('EC',' ',EC,3,nij)
      Call RecPrt('rMP',' ',rMP,nij,nElem*nPert)
      Call RecPrt('rMPq',' ',rMPq,1,nElem)
      Call xSpot('Exit  Local_Properties')
#endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(Utility)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION ISYMS1(STRING,NEL)
*
* Symmmetry of string, D2H version
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
#include "mxpdim.fh"
#include "orbinp.fh"
*
      INTEGER SYMPRO(8,8)
      DATA  SYMPRO/1,2,3,4,5,6,7,8,
     &             2,1,4,3,6,5,8,7,
     &             3,4,1,2,7,8,5,6,
     &             4,3,2,1,8,7,6,5,
     &             5,6,7,8,1,2,3,4,
     &             6,5,8,7,2,1,4,3,
     &             7,8,5,6,3,4,1,2,
     &             8,7,6,5,4,3,2,1 /
*. Specific input
      INTEGER STRING(*)
*
      ISYM = 1
      DO 100 IEL = 1, NEL
        ISYM = SYMPRO(ISYM,ISMFTO(STRING(IEL)))
  100 CONTINUE
*
      ISYMS1 = ISYM
*
      NTEST = 0
      IF(NTEST .NE. 0 ) THEN
        WRITE(6,*) ' ISYMS1, String and symmetry '
        CALL IWRTMA(STRING,1,NEL,1,NEL)
        WRITE(6,*) ISYM
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrB(dB,nq,nDim)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: nq, nDim
real(kind=wp) :: dB(nq,nDim,nDim)
integer(kind=iwp) :: i_Dim, iq

do iq=1,nQ
  write(u6,*) ' iq=',iq
  do i_Dim=1,nDim
    write(u6,'(9F10.6)') dB(iq,i_Dim,:)
  end do
end do

return

end subroutine PrB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine CHO_RASSI_RDINP(DFonly,LuSpool)
************************************************************************
*
*  Purpose:   If DFonly, use defaults only.
*             Else, read and process input for Cholesky section
*             in RASSI
*
************************************************************************
      Use Fock_util_global, only: Deco, Estimate, PseudoChoMOs, Update
      Use Cholesky, only: timings
      use cntrl, only: ALGO, Nscreen, dmpk
      use rassi_data, only: CHFRACMEM

      Implicit None
      Logical  DFonly
      Integer LuSpool
      Character(len=180) KWord, Key
      Character(len=180), External:: Get_Ln
      Integer iChrct,last
      Integer, External:: iCLast
      Real*8 dmpk_dfl
*
***** Algorithms for using Cholesky vectors in RASSI ******************
*
*   ALGO:
*
*          1  --->  compute fock matrices in AO-basis from vectors
*                   read in reduced sets and transformed on the fly.
*                   (TU|VX) integrals are also returned
*
*          2  --->  compute fock matrices in AO-basis from vectors
*                   read in reduced sets and transformed on the fly
*                   (TU|VX) integrals are also returned.
*                   Exchange contributions are computed using the
*                   "Local K" scheme
*                                                                      *
************************************************************************
*                                                                      *
*     Default  parameters
#ifdef _MOLCAS_MPP_
      ChFracMem=0.3d0
#else
      ChFracMem=0.0d0
#endif
      ALGO  = 2
      timings=.false.
      dmpk=1.0d-1
      Nscreen=10  ! to be reset to 0 if doing RI calculation
      Deco=.true.
      Update=.true.
      Estimate=.false.

      IF (.not. DFonly) THEN
*
*    set some parameters if not specified in ChoInput section
        PseudoChoMOs=.false.
        dmpk_dfl=1.0d-1
*                                                                      *
************************************************************************
*                                                                      *
*-----Process the input
*
*-------------------------------------------------------------------*
      do
*-------------------------------------------------------------------*
* Use Get_Ln to read the lines.                                     *
*-------------------------------------------------------------------*
      Key=Get_Ln(LuSpool)
      Kword=Key
      Call UpCase(Kword)
*-------------------------------------------------------------------*
* The keywords and their labels.                                    *
*-------------------------------------------------------------------*
      If (KWord(1:1).eq.'*') cycle
      If (KWord.eq.'') cycle
      select case (Kword(1:4))
      case ('ALGO')
****** ALGO ************************************************************
*                                                                      *
*-----Read Cholesky algorithm parameters
*
c      Call Get_F1(1,Eps)
c      Call Get_F1(2,rds)
c      Call Get_I1(1,ALGO)
C      If (nToken(KWord).gt.1) call abend()
*
       READ(LuSpool,*) ALGO
      if(ALGO.eq.1)then
        Write(6,*) 'Default CD-RASSI algorithm reset to  ',ALGO
        Write(6,*)
      else if (ALGO.eq.2) then
        Write(6,*) 'Default CD-RASSI algorithm reset to  ',ALGO
        Write(6,*)
      else
        Write(6,*) 'The specified algorithm is not implemented.'
        Write(6,*) 'Option Ignored '
        Write(6,*)
      endif
*
      case ('LOCK')
        algo=2
        Write(6,*) 'Default CD-RASSI algorithm reset to  ',ALGO
        Write(6,*) 'Using Local K scheme for Exchange matrices '

      case ('NOLK')
        algo=1
        Write(6,*) 'Default CD-RASSI algorithm reset to  ',ALGO
        Write(6,*) 'Local K scheme for Exchange matrices turned off ! '

      case ('SCRN')
       READ(LuSpool,*) Nscreen

      case ('DMPK')
      READ(LuSpool,*) DMPK
      If (dmpk .lt. 0.0d0) Then
      write(6,*)'OBS! Specified Negative DMPK value. Restore Defaults'
      dmpk=dmpk_dfl
      End If

      case ('TIME')
            timings=.true.

      case ('UPDA')
        Update=.true.
        Write(6,*) 'Local-K with updating of the true diagonals'
        Write(6,*)

      case ('ESTI')
        Estimate=.true.
        Write(6,*)
     &'Local-K with evaluation of the diagonals from the current vec '
        Write(6,*)
      case ('MEMF')
        read(LuSpool,*) ChFracMem

      case ('NODE')
        If (PseudoChoMOs) Then
          Write(6,*) ' The keyword NODEcompose is incompatible with'//
     &               ' the previously specified keyword PSEUdo.'//
     &               ' NODEcompose will be ignored'
        Else
          Deco=.false.
          Write(6,*)'Canonical inactive orbitals used in LK CD-RASSI.'
        End If
        Write(6,*)

      case ('PSEU')
        If (.not.Deco) Then
          Write(6,*) ' The keyword PSEUdo is incompatible with'//
     &               ' the previously specified keyword NODEco'//
     &               'mpose. PSEUdo will be ignored'
        Else
          PseudoChoMOs=.true.
          Write(6,*)'Pseudo Cholesky orbitals used in LK CD-RASSI.'
        EndIf
      Write(6,*)

      case ('ENDC')
        exit
      case ('END ')
        exit
      case ('ENDO')
        exit

      case default
        iChrct=Len(KWord)
        Last=iCLast(KWord,iChrct)
        Write (6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
        Write (6,*) 'CHO_RASSI_RDINP: Error in keyword.'
        Call AbEnd()

      end select

      end do

      end if

      end subroutine CHO_RASSI_RDINP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine IvoGen(OneHam,nOneH,CMO,nCMO,EOrb,nEOrb,mynOcc)
!***********************************************************************
!                                                                      *
!     purpose: Generate improved virtual orbitals by diagonalization   *
!              of the one-electron hamiltonian in the subspace spanned *
!              by the virtual orbitals                                 *
!                                                                      *
!     input:                                                           *
!       OneHam  : one-electron hamiltonian of length nOneH             *
!       CMO     : molecular orbital coefficients of length nCMO        *
!                                                                      *
!     output:                                                          *
!       CMO     : molecular orbital coefficients with virtual orbitals *
!                 modified                                             *
!       EOrb    : orbital energies (set to zero for virtual orbitals)  *
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
!     University of Lund, Sweden, 1992                                 *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: MaxBas, MaxBOO, MaxOrO, nBas, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOneH, nCMO, nEOrb, mynOcc(*)
real(kind=wp), intent(in) :: OneHam(nOneH)
real(kind=wp), intent(inout) :: CMO(nCMO)
real(kind=wp), intent(out) :: EOrb(nEOrb)
integer(kind=iwp) :: iCMO, iDum, i_EOr, iErr, ij, iSym, nFound, nOrbi
real(kind=wp) :: Dummy
real(kind=wp), allocatable :: FckH(:), FckS(:), FckT(:), Scratch(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Allocate memory for squared modified Fock matrix
call mma_allocate(FckS,MaxBas**2,Label='FckS')

! Allocate memory for half transformed Fock matrix
call mma_allocate(FckH,MaxBOO,Label='FckH')

! Allocate memory for transformed Fock matrix
call mma_allocate(FckT,nTri_Elem(MaxOrO),Label='FckT')

ij = 1
iCMO = 1
i_EOr = 1
do iSym=1,nSym
  nOrbi = nOrb(iSym)-mynOcc(iSym)

  ! If nOrbi == 0 - no virtual orbitals; iCMO and i_EOr must be
  ! updated anyway (occupied orbitals may exist)
  iCMO = iCMO+nBas(iSym)*mynOcc(iSym)
  i_EOr = i_EOr+mynOcc(iSym)

  if (nOrbi > 0) then

    ! Transform OneHam to space spanned by virtual orbitals
    call Square(OneHam(ij),FckS,1,nBas(iSym),nBas(iSym))
    call DGEMM_('N','N',nBas(iSym),nOrbi,nBas(iSym), &
                One,FckS,nBas(iSym), &
                CMO(iCMO),nBas(iSym), &
                Zero,FckH,nBas(iSym))
    call DGEMM_Tri('T','N',nOrbi,nOrbi,nBas(iSym), &
                   One,CMO(iCMO),nBas(iSym), &
                   FckH,nBas(iSym), &
                   Zero,FckT,nOrbi)

    ! Diagonalize OneHam within virtual space and form orbital energies
    call mma_allocate(Scratch,nOrbi**2,Label='Scratch')
    Dummy = Zero
    iDum = 0
    call Diag_Driver('V','A','L',nOrbi,FckT,Scratch,nOrbi,Dummy,Dummy,iDum,iDum,EOrb(i_EOr),CMO(iCMO),nBas(iSym),0,-1,'J',nFound, &
                     iErr)
    call mma_deallocate(Scratch)

    ! Orbital energies are now meaningless; set them to zero
    EOrb(i_EOr:i_EOr+nOrbi-1) = Zero

  end if

  ! Update pointers
  iCMO = iCMO+nOrbi*nBas(iSym)
  i_EOr = i_EOr+nOrbi
  ij = ij+nTri_Elem(nBas(iSym))

end do

! Deallocate memory
call mma_deallocate(FckS)
call mma_deallocate(FckH)
call mma_deallocate(FckT)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine IvoGen

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Bjorn O. Roos                                    *
!***********************************************************************

subroutine AFREEZ(NSYM,NBAS,NFRO,NISH,NASH,NSSH,NDEL,bNAME,nName,NAMFRO,LNFRO,DPQ,nDPQ,THRFR,THRDE,IFQCAN,CMO,NCMO)
!***********************************************************************
!                                                                      *
! Purpose: to select orbitals, which will be frozen in the CASPT2      *
! calculations based on a selection of atoms controlled by the input   *
! keyword AFREeze.                                                     *
! Each inactive orbital is checked for the fraction of electrons       *
! located on the selected atoms. If smaller than a given threshold,    *
! the orbital will be frozen.                                          *
! Called by READIN_CASPT2                                              *
! Author: B. O. Roos in July 2007 for MOLCAS-7                         *
!     Calling parameters:                                              *
!     NSYM   : Number of symmetries                                    *
!     NFRO   : Number of frozen orbitals (modified by the program)     *
!     NISH   : Number of inactive orbitals                             *
!     bName  : Center and function type label per basis function       *
!     Namfro : names of atoms to be selected (length lnfro)            *
!     Labfro : labels for orbitals to be frozen                        *
!     CMO    : Orbital coefficients                                    *
!     DPQ    : The charge matrix for a given orbital                   *
!     THRFR  : Threshold for freezing orbitals                         *
!     THRDE  : Threshold for deleting orbitals                         *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use Molcas, only: LenIn, MxBas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSYM, NBAS(NSYM), NASH(NSYM), nName, LnFro, nDPQ, NCMO
integer(kind=iwp), intent(inout) :: NFRO(NSYM), NISH(NSYM), NSSH(NSYM), NDEL(NSYM), IFQCAN
character(len=LenIn+8), intent(in) :: bNAME(nName)
character(len=4), intent(in) :: NAMFRO(LnFro)
real(kind=wp), intent(out) :: DPQ(nDPQ)
real(kind=wp), intent(in) :: THRFR, THRDE
real(kind=wp), intent(inout) :: CMO(nCMO)
integer(kind=iwp) :: ib, iComp, imo, imo0, iname, iopt, ipp, ipq0, ipq1, iqq, irc, ist1, ist2, isym, isymlbl, LABFRO(MxBas), &
                     NBAST, nbi, ndi, nfi, nfro1, ni, nin, np, nq, nsi, NSMAT, ntri
real(kind=wp) :: chksum, selch, Swap
character(len=8) :: Label
real(kind=wp), allocatable :: SMAT(:)
real(kind=wp), parameter :: Thrs = 1.0e-6_wp

!----------------------------------------------------------------------*
!     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
!----------------------------------------------------------------------*

!write(u6,*) 'Entering AFreez'
NBAST = sum(NBAS(1:NSYM))
ntri = sum(nTri_Elem(NBAS(1:NSYM)))
if (NBAST > MXBAS) then
  write(u6,'(/6X,A)') 'The number of basis functions exceeds the present limit'
  call Abend()
end if

!----------------------------------------------------------------------*
!     Read the overlap matrix                                          *
!----------------------------------------------------------------------*
NSMAT = NTRI+6
call MMA_ALLOCATE(SMAT,NSMAT)
isymlbl = 1
iopt = ibset(ibset(0,sNoOri),sNoNuc)
Label = 'Mltpl  0'
iComp = 1
call RdOne(irc,iopt,Label,iComp,SMAT,isymlbl)

!----------------------------------------------------------------------*
!write(u6,*) 'molecular orbitals before localization'
!imo = 0
!do isym=1,nsym
!  nbi = nbas(isym)
!  do ib=1,nbi
!    write(u6,*) 'orbital',isym,ib
!    write(u6,'(4ES19.12)') (CMO(imo+i),i=1,nbi)
!  imo = imo+nbi
!  end do
!end do
!----------------------------------------------------------------------*
!     Localize the inactive and virtual orbitals                       *
!----------------------------------------------------------------------*
call Cho_x_Loc(irc,Thrs,nSym,nBas,nFro,nIsh,nAsh,nSsh,CMO,nCMO)
if (irc /= 0) then
  write(u6,*) 'Localization failed. The AFRE option cannot be used'
  call Abend()
end if
!write(u6,*) 'molecular orbitals after localization'
!imo = 0
!do isym=1,nsym
!  nbi = nbas(isym)
!  do ib=1,nbi
!    write(u6,*) 'orbital',isym,ib
!    write(u6,'(4ES19.12)') (CMO(imo+i),i=1,nbi)
!  imo = imo+nbi
!  end do
!end do
!----------------------------------------------------------------------*
!     Compute Mulliken atomic charges for each center and              *
!     each orbital.                                                    *
!----------------------------------------------------------------------*

!write(u6,*) 'Starting the calculation',ntri
DPQ(1:ntri) = Zero
ib = 0
imo0 = 0
ipq0 = 0
do isym=1,nsym
  nbi = nbas(isym)
  nfi = nfro(isym)
  nin = nish(isym)
  imo = imo0+nbi*nfi
  if (nin /= 0) then
    labfro(1:nin) = 0
    do ni=1,nin
      !write(u6,*) 'loop over sym and inactive orbitals',isym,ni
      ipq1 = 0
      do np=1,nbi
        DPQ(ipq1+1:ipq1+np) = CMO(imo+np)*CMO(imo+1:imo+np)*SMAT(ipq0+ipq1+1:ipq0+ipq1+np)
        ipq1 = ipq1+np
      end do
      ! DPQ is the charge matrix for orbital ni in symmetry isym
      ! Now add non-diagonal elements to the diagonal
      ipq1 = 0
      ipp = 0
      do np=1,nbi
        ipp = ipp+np
        iqq = 0
        do nq=1,np
          iqq = iqq+nq
          ipq1 = ipq1+1
          if (np /= nq) then
            DPQ(ipp) = DPQ(ipp)+DPQ(ipq1)
            DPQ(iqq) = DPQ(iqq)+DPQ(ipq1)
          end if
        end do
      end do

      ! The diagonal now contains the charges for each basis function
      ! Add charges for basis functions centered on the selected atoms
      ! First check that the sum is equal to one
      chksum = Zero
      ipp = 0
      do np=1,nbi
        ipp = ipp+np
        !write(u6,*) 'diagonal element',ipp,DPQ(ipp)
        chksum = chksum+DPQ(ipp)
      end do
      if (abs(chksum-One) > 1.0e-8_wp) then
        write(u6,*) 'Error on Checksum in Afreez. Value is not equal to 1:',isym,ni,chksum
        write(u6,*) 'Freezing extra orbitals in CASPT2 stops.'
        call Abend()
      end if
      ! Add diagonal elements that belong to selected atoms
      selch = Zero
      ipp = 0
      do np=1,nbi
        ipp = ipp+np
        do iname=1,lnfro
          if (bNAME(ib+np)(1:4) == namfro(iname)) selch = selch+DPQ(ipp)
        end do
      end do
      if (abs(selch) < thrfr) labfro(ni) = 1
      !write(u6,*) selch
      imo = imo+nbi
    end do
    ! Sort the inactive CMO's such that frozen orbitals are first.
    nfro1 = nfro(isym)
    do ni=1,nin
      if (labfro(ni) == 1) then
        ! Exchange this orbital with the first inactive orbital
        ist1 = nfro(isym)*nbi+imo0
        ist2 = (nfro1+ni-1)*nbi+imo0
        !write(u6,*) 'nfro,nish',nfro(isym),nish(isym),ist1,ist2
        do np=1,nbi
          Swap = CMO(ist1+np)
          CMO(ist1+np) = CMO(ist2+np)
          CMO(ist2+np) = Swap
        end do
        nfro(isym) = nfro(isym)+1
        nish(isym) = nish(isym)-1
      end if
    end do
  end if
  ipq0 = ipq0+nTri_Elem(nbi)
  imo0 = imo0+nbi**2
  ib = ib+nbi
end do
! Now sort virtual orbitals
! Orbitals with too low population on selected atoms will be deleted
DPQ(1:ntri) = Zero
ib = 0
imo0 = 0
ipq0 = 0
do isym=1,nsym
  nbi = nbas(isym)
  ndi = ndel(isym)
  nsi = nssh(isym)
  nssh(isym) = 0
  ndel(isym) = ndi+nsi
  imo = imo0+nbi*(nfro(isym)+nish(isym)+nash(isym))
  if (nsi /= 0) then
    labfro(1:nsi) = 0
    do ni=1,nsi
      !write(u6,*) 'loop over sym and secondary orbitals',isym,ni
      ipq1 = 0
      do np=1,nbi
        DPQ(ipq1+1:ipq1+np) = CMO(imo+np)*CMO(imo+1:imo+np)*SMAT(ipq0+ipq1+1:ipq0+ipq1+np)
        ipq1 = ipq1+np
      end do
      ! DPQ is the charge matrix for orbital ni in symmetry isym
      ! Now add non-diagonal elements to the diagonal
      ipq1 = 0
      ipp = 0
      do np=1,nbi
        ipp = ipp+np
        iqq = 0
        do nq=1,np
          iqq = iqq+nq
          ipq1 = ipq1+1
          if (np /= nq) then
            DPQ(ipp) = DPQ(ipp)+DPQ(ipq1)
            DPQ(iqq) = DPQ(iqq)+DPQ(ipq1)
          end if
        end do
      end do

      ! The diagonal now contains the charges for each basis function
      ! Add charges for basis functions centered on the selected atoms
      ! First check that the sum is equal to one
      chksum = Zero
      ipp = 0
      do np=1,nbi
        ipp = ipp+np
        !write(u6,*) 'diagonal element',ipp,DPQ(ipp)
        chksum = chksum+DPQ(ipp)
      end do
      if (abs(chksum-One) > 1.0e-8_wp) then
        write(u6,*) 'Error on Checksum in Afreez. Value is not equal to 1:',isym,ni,chksum
        write(u6,*) 'Deleting extra orbitals in CASPT2 stops.'
        call Abend()
      end if
      !write(u6,*) 'Checksum',isym,ni,chksum
      ! Add diagonal elements that belong to selected atoms
      selch = Zero
      ipp = 0
      do np=1,nbi
        ipp = ipp+np
        do iname=1,lnfro
          if (bNAME(ib+np)(1:4) == namfro(iname)) selch = selch+DPQ(ipp)
        end do
      end do
      if (abs(selch) > thrde) labfro(ni) = 1
      !write(u6,*) selch
      imo = imo+nbi
    end do
    ! Sort the CMO's such that secondary orbitals are first.
    do ni=1,nsi
      if (labfro(ni) == 1) then
        ! Exchange this orbital with the first deleted orbital
        ist1 = (nfro(isym)+nish(isym)+nash(isym)+nssh(isym))*nbi+imo0
        ist2 = (nfro(isym)+nish(isym)+nash(isym)+ni-1)*nbi+imo0
        do np=1,nbi
          Swap = CMO(ist1+np)
          CMO(ist1+np) = CMO(ist2+np)
          CMO(ist2+np) = Swap
        end do
        !write(u6,*) 'Orbital number',ni,ist1,ist2
        !write(u6,'(4ES19.12)') (CMO(ist1+np),np=1,nbi)
        !write(u6,'(4ES19.12)') (CMO(ist2+np),np=1,nbi)
        ndel(isym) = ndel(isym)-1
        nssh(isym) = nssh(isym)+1
      end if
    end do
  end if
  ipq0 = ipq0+nTri_Elem(nbi)
  imo0 = imo0+nbi**2
  ib = ib+nbi
end do

!imo = 0
!do isym=1,nsym
!  nbi = nbas(isym)
!  do ib=1,nbi
!    write(u6,*) 'orbital',isym,ib
!    write(u6,'(4ES19.12)') (CMO(imo+i),i=1,nbi)
!  imo = imo+nbi
!  end do
!end do
! Write the resorted MO's back to JobIph

if (IFQCAN /= 0) IFQCAN = 0 ! MOs to be recanonicalized on exit

call MMA_DEALLOCATE(SMAT)

end subroutine AFREEZ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MatPCM(NTs,Eps,Conductor,ISphe,Coor_Sph,Tessera,
     &                  DMat,SMat,SDMat,TMat,RMat)
      Implicit Real*8 (A-H,O-Z)
      Logical Conductor
*  Compute PCM matrix with the formalism in
*  M. Cossi, N. Rega, G. Scalmani, V. Barone JCP in press;
*  D.M. Chipman JCP 112, 5558 (2000).
*  Solvation charges are defined through
*  Tq = RV
*  where V is the solute electrostatic potential. Here T^-1*R is computed
*  and finally returned in DMat.
      Dimension ISphe(*),Tessera(4,nTs)
      Dimension Coor_Sph(4,*)
      Dimension SMat(NTs,*),TMat(NTs,*),RMat(NTs,*),DMat(NTs,*)
      Dimension SDMat(NTs,*)
      Data Zero, One, Two, Four /0.0d0, 1.0d0, 2.0d0, 4.0d0/
      Data PotFac /1.0694d0/
      PI  = Four*ATan(One)
      TPI = Two * PI
      FPI = Two * TPI
      If(Conductor) goto 100
*
* Dielectric model:
*
* S and D* matrices
      call dcopy_(nTs*nTs,[Zero],0,DMat,1)
      Do 1000 ITs = 1, NTs
        XI = Tessera(1,iTs)
        YI = Tessera(2,iTs)
        ZI = Tessera(3,iTs)
        LI = ISphe(ITs)
        XNI = (XI - Coor_Sph(1,LI)) / Coor_Sph(4,LI)
        YNI = (YI - Coor_Sph(2,LI)) / Coor_Sph(4,LI)
        ZNI = (ZI - Coor_Sph(3,LI)) / Coor_Sph(4,LI)
        SMat(ITs,ITs) = PotFac * Sqrt(FPI / Tessera(4,ITs))
        DMat(ITs,ITs) = DMat(ITs,ITs) - TPI / Tessera(4,ITs)
        Do 1001 JTs = 1, NTs
          If(JTs.eq.ITs) goto 1001
          XJ = Tessera(1,jTs)
          YJ = Tessera(2,jTs)
          ZJ = Tessera(3,jTs)
          RIJ = Sqrt( (XI - XJ)**2 + (YI - YJ)**2 + (ZI - ZJ)**2 )
          SMat(ITs,JTs) = One / RIJ
          Prod = (XI-XJ) * XNI + (YI-YJ) * YNI + (ZI-ZJ) * ZNI
          DMat(ITs,JTs) = - Prod / RIJ**3
          DMat(JTs,JTs) = DMat(JTs,JTs)
     &                  - DMat(ITs,JTs)*Tessera(4,ITs) / Tessera(4,JTs)
 1001   Continue
 1000 Continue
*
* S*A*D matrix
      call dcopy_(nTs*nTs,[Zero],0,SDMat,1)
      Do 1500 ITs = 1, NTs
        Do 1501 JTs = 1, NTs
          Do 1502 KTs = 1, NTs
            SDMat(ITs,JTs) = SDMat(ITs,JTs) +
     &      SMat(ITs,KTs) * Tessera(4,KTs) * DMat(KTs,JTs)
 1502     Continue
 1501   Continue
 1500 Continue
*
* The charges are defined as
* q = T-1 R V,         T = f(e)*S - SAD / 2p
*
* T and R matrices
      Fac = (Eps + One) / (Eps - One)
      Do 2000 ITs = 1, NTs
        Rad = Coor_Sph(4,ISphe(ITs))
        TMat(ITs,ITs) = Fac * SMat(ITs,ITs) - SDMat(ITs,ITs) / TPI
        RMat(ITs,ITs) = - One + DMat(ITs,ITs) * Tessera(4,ITs) / TPI
        Do 2001 JTs = 1, NTs
          If(JTs.eq.ITs) goto 2001
          TMat(ITs,JTs) = Fac * SMat(ITs,JTs) - SDMat(ITs,JTs) / TPI
          RMat(ITs,JTs) = Tessera(4,JTs) * DMat(JTs,ITs) / TPI
 2001   Continue
 2000 Continue
*
* Invert T matrix
*
      If (Eps.gt.One) Then
         Call MatInvert(TMat,nTs)
      Else
         Call FZero(TMat,nTs**2)
      End If
*
* Form T^-1 * R and store it in D
*
      Call DGEMM_('N','N',
     &            nTs,nTs,nTs,
     &            1.0d0,TMat,nTs,
     &            RMat,nTs,
     &            0.0d0,DMat,nTs)
      Return
  100 Continue
*
* Conductor model
*
* S matrix
      EpsFac = Eps / (Eps - One)
      call dcopy_(nTs*nTs,[Zero],0,SMat,1)
      Do 1010 ITs = 1, NTs
        XI = Tessera(1,iTs)
        YI = Tessera(2,iTs)
        ZI = Tessera(3,iTs)
        SMat(ITs,ITs) = - PotFac * EpsFac * Sqrt(FPI / Tessera(4,ITs))
        Do 1011 JTs = 1, ITs-1
          XJ = Tessera(1,jTs)
          YJ = Tessera(2,jTs)
          ZJ = Tessera(3,jTs)
          RIJ = Sqrt( (XI - XJ)**2 + (YI - YJ)**2 + (ZI - ZJ)**2 )
          SMat(ITs,JTs) = - EpsFac * One / RIJ
          SMat(JTs,ITs) = SMat(ITs,JTs)
 1011   Continue
 1010 Continue
*
* Invert S matrix and store it in D
*
      If (Eps.gt.One) Then
         Call MatInvert(SMat,nTs)
         call dcopy_(nTs*nTs,SMat,1,DMat,1)
      Else
         Call FZero(DMat,nTs**2)
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ClasClas(iCNum,nClas,FP,GP,DT,FI,Dist,DistIm,Elene,Edisp,Exrep,E2Die,ExDie)

use qmstat_global, only: CordIm, Cordst, Disp, Exdt1, ExdTal, nCent, nCha, nPart, nPol, Pol, QIm, QSta
use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One, Ten, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iCNum, nClas
real(kind=wp), intent(out) :: FP(3,nPol*nPart), GP(3,nPol*nPart), DT(3,nPol*nPart), FI(3,nPol*nPart), &
                              Dist(nCent,nCent,nTri_Elem(nClas-1)), DistIm(nCent,nClas,nCent,nClas), Elene, Edisp, Exrep, E2Die, &
                              ExDie
integer(kind=iwp) :: i, ii, ij, Ind, Ind1, indF, IndMa, indR, j, jj, k, l, nSize
real(kind=wp) :: Adisp, aLim, Dampfunk, Epoll, F, Q, Q1, Q2, r, r3, ri, Sum1, Sum2, Sum3, Sum4, X, Y, Z
real(kind=wp), parameter :: Const = 2.2677_wp, ExLim = Ten ! What is Const?
real(kind=wp), external :: ExNemo

!----------------------------------------------------------------------*
! Compute the distance matrices between the classical centers and the  *
! classical image centers.                                             *
!----------------------------------------------------------------------*
Adisp = Disp(1,2)
nSize = nTri_Elem(nClas-1)
Ind = 0
do ii=iCNum+2,nPart
  do jj=iCNum+1,ii-1
    Ind = Ind+1
    do ij=1,nCent
      i = (ii-1)*nCent+ij
      do k=1,nCent
        j = (jj-1)*nCent+k
        r = (Cordst(1,i)-Cordst(1,j))**2+(Cordst(2,i)-Cordst(2,j))**2+(Cordst(3,i)-Cordst(3,j))**2
        Dist(k,ij,Ind) = One/sqrt(r)
      end do
    end do
  end do
end do
do ii=iCNum+1,nPart
  do i=1,nCent
    k = i+(ii-1)*nCent
    do jj=iCNum+1,nPart
      do j=1,nCent
        l = j+(jj-1)*nCent
        r = (CordIm(1,k)-Cordst(1,l))**2+(CordIm(2,k)-Cordst(2,l))**2+(CordIm(3,k)-Cordst(3,l))**2
        DistIm(j,jj-iCNum,i,ii-iCNum) = One/sqrt(r)
      end do
    end do
  end do
end do
!----------------------------------------------------------------------*
! Compute the pairwise interaction between the solvent. Classical all  *
! the  way... early NEMO all the way.                                  *
!----------------------------------------------------------------------*
aLim = One/ExLim
! The electrostatic part

! This loop ONLY works for the early Nemo model of water.
! If the solvent model is changed this loop must be rewritten.
Sum1 = Zero
Sum2 = Zero
Sum3 = Zero
Sum4 = Zero
do i=1,nSize
  Sum1 = Sum1+Dist(2,2,i)*Qsta(1)*Qsta(1) !H-H
  Sum2 = Sum2+Dist(3,2,i)*Qsta(1)*Qsta(2) !H-H
  Sum3 = Sum3+Dist(4,2,i)*Qsta(1)*Qsta(3) !H-V
  Sum4 = Sum4+Dist(5,2,i)*Qsta(1)*Qsta(4) !H-V
  Sum1 = Sum1+Dist(2,3,i)*Qsta(2)*Qsta(1) !H-H
  Sum2 = Sum2+Dist(3,3,i)*Qsta(2)*Qsta(2) !H-H
  Sum3 = Sum3+Dist(4,3,i)*Qsta(2)*Qsta(3) !H-V
  Sum4 = Sum4+Dist(5,3,i)*Qsta(2)*Qsta(4) !H-V
  Sum1 = Sum1+Dist(4,4,i)*Qsta(3)*Qsta(3) !V-V
  Sum2 = Sum2+Dist(5,4,i)*Qsta(3)*Qsta(4) !V-V
  Sum3 = Sum3+Dist(2,4,i)*Qsta(3)*Qsta(1) !V-H
  Sum4 = Sum4+Dist(3,4,i)*Qsta(3)*Qsta(2) !V-H
  Sum1 = Sum1+Dist(4,5,i)*Qsta(4)*Qsta(3) !V-V
  Sum2 = Sum2+Dist(5,5,i)*Qsta(4)*Qsta(4) !V-V
  Sum3 = Sum3+Dist(2,5,i)*Qsta(4)*Qsta(1) !V-H
  Sum4 = Sum4+Dist(3,5,i)*Qsta(4)*Qsta(2) !V-H
end do
Elene = Sum1+Sum2+Sum3+Sum4

Sum1 = Zero
Sum2 = Zero
Sum3 = Zero
Sum4 = Zero
! The dispersion, now with damping.
do i=1,nSize
  DampFunk = One-exp(-One/(Dist(1,1,i)*Const))**4
  Sum1 = Sum1+Dist(1,1,i)**6*DampFunk
  DampFunk = One-exp(-One/(Dist(2,1,i)*Const))**4
  Sum2 = Sum2+Dist(2,1,i)**6*DampFunk
  DampFunk = One-exp(-One/(Dist(3,1,i)*Const))**4
  Sum2 = Sum2+Dist(3,1,i)**6*DampFunk
  DampFunk = One-exp(-One/(Dist(1,2,i)*Const))**4
  Sum2 = Sum2+Dist(1,2,i)**6*DampFunk
  DampFunk = One-exp(-One/(Dist(2,2,i)*Const))**4
  Sum3 = Sum3+Dist(2,2,i)**6*DampFunk
  DampFunk = One-exp(-One/(Dist(3,2,i)*Const))**4
  Sum3 = Sum3+Dist(3,2,i)**6*DampFunk
  DampFunk = One-exp(-One/(Dist(1,3,i)*Const))**4
  Sum2 = Sum2+Dist(1,3,i)**6*DampFunk
  DampFunk = One-exp(-One/(Dist(2,3,i)*Const))**4
  Sum3 = Sum3+Dist(2,3,i)**6*DampFunk
  DampFunk = One-exp(-One/(Dist(3,3,i)*Const))**4
  Sum3 = Sum3+Dist(3,3,i)**6*DampFunk
end do
Edisp = Sum1*Disp(1,1)+Sum2*Disp(1,2)+Sum3*Disp(2,2)
!The exchange repulsion
Exrep = Zero
do i=1,nSize
  if (Dist(1,1,i) > aLim) Exrep = Exrep+ExNemo(1,1,Dist(1,1,i))
  if (Dist(2,1,i) > aLim) Exrep = Exrep+ExNemo(1,2,Dist(2,1,i))
  if (Dist(3,1,i) > aLim) Exrep = Exrep+ExNemo(1,2,Dist(3,1,i))
  if (Dist(1,2,i) > aLim) Exrep = Exrep+ExNemo(1,2,Dist(1,2,i))
  if (Dist(2,2,i) > aLim) Exrep = Exrep+ExNemo(2,2,Dist(2,2,i))
  if (Dist(3,2,i) > aLim) Exrep = Exrep+ExNemo(2,2,Dist(3,2,i))
  if (Dist(1,3,i) > aLim) Exrep = Exrep+ExNemo(1,2,Dist(1,3,i))
  if (Dist(2,3,i) > aLim) Exrep = Exrep+ExNemo(2,2,Dist(2,3,i))
  if (Dist(3,3,i) > aLim) Exrep = Exrep+ExNemo(2,2,Dist(3,3,i))
end do
!----------------------------------------------------------------------*
! Compute pair-wise interaction with image charges.                    *
!----------------------------------------------------------------------*
Sum1 = Zero
Sum2 = Zero
do i=iCNum+1,nPart
  do j=nCent-nCha+1,nCent !Only count over charged centers.
    Q1 = QIm((i-1)*nCent+j) !The image charge.
    do k=nCent-nCha+1,nCent
      Q2 = QSta(k-nCent+nCha)
      ! Here is the electrostatic interaction computed.
      ! Observe the difference with the real charges,
      ! since here interaction between ALL real-image charge pair is computed.
      do l=iCNum+1,nPart
        Sum1 = Sum1+Q1*Q2*DistIm(k,l-iCNum,j,i-iCNum)
        !                                                                      should this be Const=2.2677 ?
        Sum1 = Sum1-Adisp*DistIm(k,l-iCNum,j,i-iCNum)**6*(One-exp(-One/(DistIm(k,l-iCNum,j,i-iCNum)*2.9677_wp)**6))
      end do
    end do
  end do
  ! Include a repulsion with the boundary to prevent the waters to merge
  ! into the dielectric continuum. Its construction is such that the
  ! repulsion only is between the particle and the image of the particle,
  ! no other repulsion over the boundary.
  Sum2 = Sum2+ExNemo(1,1,DistIm(1,i-iCNum,1,i-iCNum))*Exdt1
  Sum2 = Sum2+ExNemo(1,2,DistIm(2,i-iCNum,2,i-iCNum))
  Sum2 = Sum2+ExNemo(1,2,DistIm(3,i-iCNum,3,i-iCNum))
end do
! The half is added since what we actually have
! computed is the interaction between charge and a part
! of its reaction field (recall:0.5*q*fi_q).
E2Die = sum1*Half
EXDie = sum2*Half*ExdTal
!----------------------------------------------------------------------*
! Compute the static electric field on the polarizabilities and obtain *
! initial guess of induced dipoles.                                    *
!----------------------------------------------------------------------*
IndMa = nPol*nPart
! Explanation: FP-field GP plus reaction field,
!              GP-field from real charges on polarizable centers,
!              FI-induced field.
FP(:,:) = Zero
GP(:,:) = Zero
DT(:,:) = Zero
FI(:,:) = Zero
! Real centers: The field at the polarizabilities - no reaction field.
Ind = 0
do ii=iCNum+2,nPart
  do jj=iCNum+1,ii-1
    Ind = Ind+1
    do ij=1,nCent
      i = (ii-1)*nCent+ij
      do l=1,nCent
        j = (jj-1)*nCent+l
        X = Cordst(1,i)-Cordst(1,j)
        Y = Cordst(2,i)-Cordst(2,j)
        Z = Cordst(3,i)-Cordst(3,j)
        ri = Dist(l,ij,Ind)**3
        if ((ij > nCent-nCha) .and. (l <= nPol)) then
          ! Given that ij is
          ! counting on centers with charges and
          ! l on polarizable centers, then compute
          ! the field from charge ij on center l.
          Q1 = Qsta(ij-nCent+nCha)
          Ind1 = (jj-1)*nPol+l
          GP(1,Ind1) = GP(1,Ind1)+x*Q1*ri
          GP(2,Ind1) = GP(2,Ind1)+y*Q1*ri
          GP(3,Ind1) = GP(3,Ind1)+z*Q1*ri
        end if
        if ((l > nCent-nCha) .and. (ij <= nPol)) then
          ! If ij is
          ! on center with polarizability and l is on
          ! center with charge, then compute the field
          ! from charge l on center ij.
          Q2 = Qsta(l-nCent+nCha)
          Ind1 = (ii-1)*nPol+ij
          GP(1,Ind1) = GP(1,Ind1)-x*Q2*ri
          GP(2,Ind1) = GP(2,Ind1)-y*Q2*ri
          GP(3,Ind1) = GP(3,Ind1)-z*Q2*ri
        end if
      end do
    end do
  end do
end do
Epoll = Zero
! Compute polarization energy.
! This is only for checking, and will
! not enter the energy expression.
do i=1+nPol*iCNum,IndMa
  k = i-((i-1)/nPol)*nPol
  FP(:,i) = GP(:,i)
  F = (FP(1,i)**2+FP(2,i)**2+FP(3,i)**2)*Pol(k)
  Epoll = Epoll+F
end do
Epoll = -Epoll*Half
! Image centers: The field at the polarizabilities - reaction field to the point charges added.
do jj=iCNum+1,nPart
  do ii=1,nCent
    i = ii+(jj-1)*nCent
    Q = Qim(i)
    do k=1,nPol
      indR = k+iCNum*nCent
      indF = k+iCNum*nPol
      do j=1,nClas
        x = CordIm(1,i)-Cordst(1,indR)
        y = CordIm(2,i)-Cordst(2,indR)
        z = CordIm(3,i)-Cordst(3,indR)
        r3 = DistIm(k,j,ii,jj-iCNum)**3
        FP(1,indF) = FP(1,indF)+x*Q*r3
        FP(2,indF) = FP(2,indF)+y*Q*r3
        FP(3,indF) = FP(3,indF)+z*Q*r3
        indR = indR+nCent
        indF = indF+nPol
      end do
    end do
  end do
end do
! We obtain an initial guess of the induced dipoles on the solvent.
do i=1+nPol*iCnum,IndMa
  k = i-((i-1)/nPol)*nPol
  DT(:,i) = FP(:,i)*Pol(k)
end do

return

end subroutine ClasClas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MODRHS(IVEC,FIMO,NFIMO)
      use definitions, only: iwp, wp
      USE SUPERINDEX, only: KTUV, KTU
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM,NINDEP,NTUV,NISH,NASH,NAES,NACTEL,
     &                         NASHT,NTUVES,NORB,NSSH,NISUP,NASUP,NTUES
      IMPLICIT None
      integer(kind=iwp), intent(In):: IVEC, NFIMO
      real(kind=wp), Intent(in):: FIMO(NFIMO)

      real(kind=wp), ALLOCATABLE:: WA(:), WC(:), WD(:)
      integer(kind=iwp) ICASE, IFOFF, ISYM, NAS, NIS, NWA, ISYJ, ISYT,
     &                         NAT, NIT, IT, ITTOT, ITABS, IJ, IVABS,
     &                         IW1, IW2, IA, IAJ, IATOT, ISYU, IU,
     &                         IUABS, IUU, IWD, IX, IXABS, IXTOT, IYABS,
     &                         IYYW, lg_A, lg_C, lg_D, NAJ, NAX, NIJ,
     &                         NIX, NO, NSJ, NSX, NWC, NWD, IYYWA
      real(kind=wp) ONEADD, SUM, VALUE

***************************************************************
* Case A:
      ICASE=1
      IFOFF=0
      DO ISYM=1,NSYM
       NAS=NTUV(ISYM)
       NIS=NISH(ISYM)
       NWA=NAS*NIS
       IF(NINDEP(ISYM,1)*NWA/=0) THEN
       CALL mma_allocate(WA,NWA,Label='WA')
       CALL RHS_ALLO (NAS,NIS,lg_A)
C Read W from disk:
       CALL RHS_READ (NAS,NIS,lg_A,ICASE,ISYM,IVEC)
       CALL RHS_GET (NAS,NIS,lg_A,WA)
* Insert one-electron contribution to coupling <A|0>:
* WA(tvv,j)=FIMO(t,j)/NACTEL (+two-electron part)
       ISYJ=ISYM
       ISYT=ISYM
       NAT=NASH(ISYT)
       NIT=NISH(ISYT)
       DO IT=1,NAT
        ITTOT=NIT+IT
        ITABS=NAES(ISYT)+IT
        DO IJ=1,NIT
         VALUE=FIMO(IFOFF+(ITTOT*(ITTOT-1))/2+IJ)/DBLE(MAX(1,NACTEL))
         DO IVABS=1,NASHT
          IW1=KTUV(ITABS,IVABS,IVABS)-NTUVES(ISYM)
          IW2=IJ
          WA(IW1+NAS*(IW2-1))=WA(IW1+NAS*(IW2-1))+VALUE
         END DO
        END DO
       END DO
       CALL RHS_PUT (NAS,NIS,lg_A,WA)
C Put W on disk:
       CALL RHS_SAVE (NAS,NIS,lg_A,ICASE,ISYM,IVEC)
       CALL RHS_FREE (lg_A)
       CALL mma_deallocate(WA)

       END IF
* End of loop over ISYM.
       NO=NORB(ISYM)
       IFOFF=IFOFF+(NO*(NO+1))/2
      END DO

***************************************************************
* Case C:
      ICASE=4
      IFOFF=0
      DO ISYM=1,NSYM
       NAS=NTUV(ISYM)
       NIS=NSSH(ISYM)
       NWC=NAS*NIS
       IF(NINDEP(ISYM,4)*NWC/=0) THEN
       CALL mma_allocate(WC,NWC,LABEL='WC')
       CALL RHS_ALLO (NAS,NIS,lg_C)
C Read W from disk:
       CALL RHS_READ (NAS,NIS,lg_C,ICASE,ISYM,IVEC)
       CALL RHS_GET (NAS,NIS,lg_C,WC)
* Insert one-electron contribution to coupling <C|0>:
* WC(xuu,a)=(FIMO(a,x)-sum((ay,yx), y=1,NASHT) )/NACTEL (+ two-el part)
       NIX=NISH(ISYM)
       NAX=NASH(ISYM)
       NSX=NSSH(ISYM)
       DO IX=1,NAX
        IXTOT=NIX+IX
        IXABS=NAES(ISYM)+IX
        DO IA=1,NSX
         IATOT=NIX+NAX+IA
         SUM=FIMO(IFOFF+(IATOT*(IATOT-1))/2+IXTOT)
         DO IYABS=1,NASHT
          IYYW=KTUV(IYABS,IYABS,IXABS)-NTUVES(ISYM)
          IYYWA=IYYW+NAS*(IA-1)
          SUM=SUM-WC(IYYWA)
         END DO
         ONEADD=SUM/DBLE(MAX(1,NACTEL))
         DO IUABS=1,NASHT
          IW1=KTUV(IXABS,IUABS,IUABS)-NTUVES(ISYM)
          IW2=IA
          WC(IW1+NAS*(IW2-1))= WC(IW1+NAS*(IW2-1))+ONEADD
         END DO
        END DO
       END DO
       CALL RHS_PUT (NAS,NIS,lg_C,WC)
C Put W on disk:
       CALL RHS_SAVE (NAS,NIS,lg_C,ICASE,ISYM,IVEC)
       CALL RHS_FREE (lg_C)
       CALL mma_deallocate(WC)

       END IF
* End of loop over ISYM.
       NO=NORB(ISYM)
       IFOFF=IFOFF+(NO*(NO+1))/2
      END DO

***************************************************************
* Case D1:
      ICASE=5
      ISYM=1

      NAS=NASUP(ISYM,5)
      NIS=NISUP(ISYM,5)
      NWD=NAS*NIS
      IF(NINDEP(ISYM,5)*NWD/=0) THEN
      CALL mma_allocate(WD,NWD,LABEL='WD')
      CALL RHS_ALLO (NAS,NIS,lg_D)
C Read W from disk:
      CALL RHS_READ (NAS,NIS,lg_D,ICASE,ISYM,IVEC)
      CALL RHS_GET (NAS,NIS,lg_D,WD)

* Insert one-electron contribution to coupling <D1|0>:
* Compute WD1(vv,aj)=FIMO(a,j)/NACTEL (+ two-el part)
      IFOFF=0
      IAJ=0
      DO ISYJ=1,NSYM
       NIJ=NISH(ISYJ)
       NAJ=NASH(ISYJ)
       NSJ=NSSH(ISYJ)
       DO IA=1,NSJ
        IATOT=NIJ+NAJ+IA
        DO IJ=1,NIJ
         ONEADD=FIMO(IFOFF+(IATOT*(IATOT-1))/2+IJ)/DBLE(MAX(1,NACTEL))
         IAJ=IAJ+1
         DO ISYU=1,NSYM
          DO IU=1,NASH(ISYU)
           IUABS=NAES(ISYU)+IU
           IUU=KTU(IUABS,IUABS)-NTUES(ISYM)
           IWD=IUU+NAS*(IAJ-1)
           WD(IWD)=WD(IWD)+ONEADD
          END DO
         END DO
        END DO
       END DO
       NO=NORB(ISYJ)
       IFOFF=IFOFF+(NO*(NO+1))/2
      END DO
      CALL RHS_PUT (NAS,NIS,lg_D,WD)

C Put W on disk:
      CALL RHS_SAVE (NAS,NIS,lg_D,ICASE,ISYM,IVEC)
      CALL RHS_FREE (lg_D)
      CALL mma_deallocate(WD)
      END IF

      END SUBROUTINE MODRHS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Oskar Weser                                      *
!***********************************************************************

#include "compiler_features.h"

module test_filesystem_mod
    use fruit
    use filesystem, only: basename, inquire_, mkdir_, remove_, chdir_, getcwd_, copy_
    implicit none
    private
    public :: test_filesystem

contains

    subroutine test_filesystem()
        integer :: err
        character(*), parameter :: test_dir = 'test_dir'
        character(len=512) :: cwd, root

        call getcwd_(root)

        if (inquire_(test_dir)) then
            call remove_(test_dir, err)
            call assert_true(err == 0)
        end if
        call mkdir_(test_dir, err)
        call assert_true(err == 0)
        call assert_true(inquire_(test_dir))

        call chdir_(test_dir)
            call getcwd_(cwd)
            call assert_true(basename(cwd) == test_dir)

            block
                integer :: file_id, err
                character(*), parameter :: test_file = 'asdf', new_file = 'hallo Wrzlbrmft'
                call assert_false(inquire_(test_file))
                open(newunit=file_id, file=test_file)
                    write(file_id, '(A)') 'Hello World'
                close(file_id)
                call assert_true(inquire_(test_file))
                call copy_(test_file, new_file)
                call assert_true(inquire_(new_file))
                call remove_(new_file)
                call remove_(test_file, err)
                call assert_true(err == 0)
                call assert_false(inquire_(test_file))

                call copy_(test_file, new_file, err)
                call assert_true(err /= 0)
            end block
        call chdir_(root)

        call remove_(test_dir, err)
        call assert_true(err == 0)
        call assert_false(inquire_(test_dir))
    end subroutine

end module test_filesystem_mod

program test_filesystem_prog
    use fruit
    use test_filesystem_mod, only: test_filesystem

    implicit none
    integer :: failed_count, i, seed_size

    call random_seed(size=seed_size)
    call random_seed(put=[(i, i = 1, seed_size)])
    call init_fruit()
    call inimem()

    call run_test_case(test_filesystem, "test_filesystem")

    call fruit_summary()
    call fruit_finalize()
    call get_failed_count(failed_count)

    if (failed_count /= 0) error stop

end program test_filesystem_prog

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine diiswa1 (wrk,wrksize,
     & diispoint)
c
c     this routine
c     a) upgrade diispoint
c     b) write write new amplitudes T21,T22,T23,T13,T14 into
c     proper possition
c
c     diispoint - array of lun's where N-1, N-2 .. amplitudes
c     are stored (I/O)
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer diispoint(1:4)
c
c     help variables
c
       integer lun1,rc,p
c
c
c1    upgrade diispoint
c
       lun1=diispoint(cycext)
c
       do 10 p=cycext-1,1,-1
       diispoint(p+1)=diispoint(p)
 10     continue
c
       diispoint(1)=lun1
c
c
c2    save aplitudes
c
c2.1  rewind lun1 file
       lun1=diispoint(1)
       call filemanager (2,lun1,rc)
c
c2.2  write T21
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt21,mapit21,rc)
c
c2.3  write T22
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt22,mapit22,rc)
c
c2.4  write T23
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt23,mapit23,rc)
c
c2.5  write T13
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt13,mapit13,rc)
c
c2.6  write T14
       call wrtmediate (wrk,wrksize,
     & lun1,mapdt14,mapit14,rc)
c
c2.1  rewind lun1 file
       call filemanager (2,lun1,rc)
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SUBTR(XINT,WRK,LWRK,ISYM)
!
! Purpose: driver for subtracting contributions from previous vectors
!          from the qualified integrals (in XINT).

use Cholesky, only: Cho_DiaChk, Cho_IOVec, LuPri, nnBstR, nnBstRT, nQual, NumCho, Tol_DiaChk
use Cholesky_procedures, only: Cho_VecBuf_Subtr
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: LWRK
real(kind=wp), intent(inout) :: XINT(*), WRK(LWRK)
integer(kind=iwp), intent(in) :: ISYM
integer(kind=iwp) :: KDIAG, KEND, NERR
real(kind=wp) :: TOL
logical(kind=iwp) :: FXDMEM
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_SUBTR'

! Return if nothing to do.
! ------------------------

if (NUMCHO(ISYM) < 1) then ! no prev. vectors.
  if (LOCDBG) write(LUPRI,*) SECNAM,': nothing done because NUMCHO = ',NUMCHO(ISYM),' (sym. ',ISYM,')'
  return
else if (NNBSTR(ISYM,2) < 1) then ! nothing to do (this sym.)
  if (LOCDBG) write(LUPRI,*) SECNAM,': nothing done because NNBSTR = ',NNBSTR(ISYM,2),' (sym. ',ISYM,')'
  return
else if (NQUAL(ISYM) < 1) then ! no qualifieds in this sym.
  if (LOCDBG) write(LUPRI,*) SECNAM,': nothing done because NQUAL  = ',NQUAL(ISYM),' (sym. ',ISYM,')'
  return
end if

! Debug: read original diagonal and check that these elements are
!        included in the integrals
! ---------------------------------------------------------------

if (CHO_DIACHK .or. LOCDBG) then
  KDIAG = 1
  KEND = KDIAG+NNBSTRT(1)
  LWRK = LWRK-KEND+1
  if (LWRK < 0) then
    write(LUPRI,*) SECNAM,': diagonal/integral check skipped due to insufficient memory'
  else
    TOL = TOL_DIACHK
    NERR = 0
    call CHO_CHKINTO(XINT,WRK(KDIAG),ISYM,NERR,TOL,.true.)
    if (NERR /= 0) then
      write(LUPRI,*) SECNAM,': ',NERR,' diagonal errors found!'
      write(LUPRI,*) '          #tests: ',NQUAL(ISYM)
      !write(LUPRI,*) '          Printing integrals:'
      !call CHO_OUTPUT(XINT,1,NNBSTR(ISYM,2),1,NQUAL(ISYM),NNBSTR(ISYM,2),NQUAL(ISYM),1,LUPRI)
      call CHO_QUIT('Diagonal errors in '//SECNAM,104)
    else
      write(LUPRI,*) SECNAM,': comparison of qual. integrals and original diagonal: no errors !'
    end if
  end if
end if

! Subtract contributions for vectors in buffer.
! (Returns immediately if nothing to do.)
! ---------------------------------------------

call CHO_VECBUF_SUBTR(XINT,WRK,LWRK,ISYM,.true.,.true.)

! Subtract contributions for vectors on disk.
! -------------------------------------------

if ((CHO_IOVEC == 3) .or. (CHO_IOVEC == 4)) then
  FXDMEM = CHO_IOVEC == 4
  call CHO_SUBTR1(XINT,WRK,LWRK,ISYM,FXDMEM)
else
  call CHO_SUBTR0(XINT,WRK,LWRK,ISYM)
end if

end subroutine CHO_SUBTR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Roland Lindh                                     *
************************************************************************
* Version of Oct 21

      SUBROUTINE COPDIA(A,VEC,NDIM,IPACK)
*
* Copy diagonal of matrix A into vector VEC
*
*   IPACK = 0 : Full matrix
*   IPACK = 1 : Lower triangular matrix
*
      IMPLICIT REAL*8 ( A-H,O-Z)
      DIMENSION A(*),VEC(*)
      INTEGER   ip_CPDIA
*
#include "WrkSpc.fh"
*VVP
*Workaround for dummy aliasing
      CALL GETMEM('CPDIA','ALLO','REAL',ip_CPDIA,NDIM)
      IF(IPACK .EQ. 0 ) THEN
        DO 100 I = 1,NDIM
          Work(ip_CPDIA+I-1) = A((I-1)*NDIM+I)
  100   CONTINUE
      ELSE
        DO 200 I = 1, NDIM
          Work(ip_CPDIA+I-1) = A(I*(I+1)/2)
  200   CONTINUE
      END IF
*
      CALL DCOPY_(NDIM,Work(ip_CPDIA),1,VEC,1)
      CALL GETMEM('CPDIA','FREE','REAL',ip_CPDIA,NDIM)

      RETURN
      END
      SUBROUTINE SQRTMT(A,NDIM,ITASK,ASQRT,AMSQRT,SCR)
*
* Calculate square root of positive definite symmetric matrix A
* if(ITASK .EQ. 2 ) Inverted square root matrix is also calculated
* In case of singularities in A A -1/2 is defined to have the same
* singularity
      IMPLICIT REAL*8( A-H,O-Z)
*
      DIMENSION A(NDIM,NDIM)
      DIMENSION ASQRT(NDIM,NDIM),AMSQRT(NDIM,NDIM)
      DIMENSION SCR(*)
* Length of SCR should at least be 2 * NDIM ** 2 + NDIM*(NDIM+1)/2
      KLFREE = 1
*
      KLASYM = KLFREE
      KLAVAL = KLASYM
      KLFREE = KLASYM + NDIM*(NDIM+1)/2
*
      KLAVEC = KLFREE
      KLFREE = KLFREE + NDIM ** 2
*
      NTEST = 0
*
C          TRIPAK(AUTPAK,APAK,IWAY,MATDIM,NDIM)
      CALL TRIPAK(A,SCR(KLASYM),1,NDIM,NDIM)
      Call DCopy_(NDIM**2,[0.0D0],0,SCR(KLAVEC),1)
      Call DCopy_(NDIM,[1.0D0],0,SCR(KLAVEC),1+NDIM)
      Call NIDiag(SCR(KLASYM),SCR(KLAVEC),NDIM,NDIM,0)
      Call JACORD(SCR(KLASYM),SCR(KLAVEC),NDIM,NDIM)
      CALL COPDIA(SCR(KLASYM),SCR(KLAVAL),NDIM,1)
      IF( NTEST .GE. 1 ) THEN
        WRITE(6,*) ' Eigenvalues of matrix : '
        CALL WRTMAT(SCR(KLAVAL),NDIM,1,NDIM,1)
      END IF
*. Check for negative eigenvalues
      DO I = 1, NDIM
       IF(Abs(SCR(KLAVAL-1+I)).LT.1.0D-14) SCR(KLAVAL)=0.0D0
       IF(SCR(KLAVAL-1+I).LT.0.0D0) THEN
*         WRITE(6,*) ' SQRTMT : Negative eigenvalue ', SCR(KLAVAL-1+I)
*         WRITE(6,*) ' SQRTMT : I will STOP '
*         STOP       ' SQRTMT : Negative eigenvalue '
        CALL SYSABENDMSG('lucia_util/sqrtmt','Internal error',
     &                   'Negative eigenvalue')
       END IF
      END DO
*
      DO 100 I = 1,NDIM
        SCR(KLAVAL-1+I) = SQRT(SCR(KLAVAL-1+I))
  100 CONTINUE
C     XDIAXT(XDX,X,DIA,NDIM,SCR)
      CALL XDIAXT(ASQRT,SCR(KLAVEC),SCR(KLAVAL),NDIM,SCR(KLFREE))
*
      IF(ITASK .EQ. 2 ) THEN
        DO 200 I = 1,NDIM
          IF(SCR(KLAVAL-1+I) .GT. 1.0D-13 ) then
            SCR(KLAVAL-1+I) = 1.0D0/SCR(KLAVAL-1+I)
          ELSE
            SCR(KLAVAL-1+I) = SCR(KLAVAL-1+I)
          END IF
  200   CONTINUE
        CALL XDIAXT(AMSQRT,SCR(KLAVEC),SCR(KLAVAL),NDIM,SCR(KLFREE))
      END IF
*
      IF( NTEST .GE. 1 ) THEN
        WRITE(6,*) ' Info from SQRTMT '
        WRITE(6,*) ' ================='
        WRITE(6,*) ' Input matrix to SQRTMT '
        CALL WRTMAT(A,NDIM,NDIM,NDIM,NDIM)
        WRITE(6,*) ' Square root of matrix '
        CALL WRTMAT(ASQRT,NDIM,NDIM,NDIM,NDIM)
        IF(ITASK .EQ. 2 ) THEN
          WRITE(6,*) ' Inverse square root of matrix '
          CALL WRTMAT(AMSQRT,NDIM,NDIM,NDIM,NDIM)
        END IF
      END IF
*
      RETURN
      END

      SUBROUTINE XDIAXT(XDX,X,DIA,NDIM,SCR)
*
* Obtain XDX = X * DIA * X(Transposed)
* where DIA is an diagonal matrix stored as a vector
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XDX(NDIM,NDIM)
      DIMENSION X(NDIM,NDIM),DIA(NDIM)
      DIMENSION SCR(NDIM,NDIM)
*
* DIA * X(transposed)
      DO 100 I=1,NDIM
        CALL COPVEC(X(1,I),SCR(1,I),NDIM)
        CALL SCALVE(SCR(1,I),DIA(I),NDIM)
  100 CONTINUE
* X * DIA * X(Transposed)
      CALL MATML4(XDX,X,SCR,NDIM,NDIM,NDIM,NDIM,NDIM,NDIM,2)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HAM3(OP0,OP1,NOP2,OP2,NOP3,OP3,ISYCI,CI,SGM,NCI)
! Purpose: Compute and add a contribution to SGM which is
! obtained from a sum of zero- one- two- and three-electron
! operators acting on wave function CI.

! Note that the coefficients in OP1 and OP2 must have been
! modified by adding elements from OP2 and OP3, as done in
! subroutine MODOP.

! Presently symmetry blocking is disregarded for OP2, OP3, but
! index pair C permutation symmetry is used.
! NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
! NOP3=(NASHT**2+2 over 3)  (Binomial coefficient)

use Index_Functions, only: iTri, nTri3_Elem
use Symmetry_Info, only: Mul
use sguga, only: CIS, EXS, SGS
use Molcas, only: MxLev
use caspt2_module, only: IASYM, ISCF, MxCI, NACTEL, NASHT, NCONF, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NOP2, NOP3, ISYCI, NCI
real(kind=wp), intent(in) :: OP0, OP1(NASHT,NASHT), OP2(NOP2), OP3(NOP3), CI(NCI)
real(kind=wp), intent(inout) :: SGM(NCI)
integer(kind=iwp) :: I, IATOG(MXLEV), ISTU, ISVX, ISVXYZ, ISYM, ISYM1, ISYM2, ISYZ, IT, ITABS, ITMIN, ITU, ITUVXYZ, IU, IV, IVMIN, &
                     IVX, IVXYZ, IX, IY, IYZ, IZ, LEVT, LEVU, LEVV, LEVX, LEVY, LEVZ, nLev, NSGM1, NSGM2
real(kind=wp) :: OCCNO, X
real(kind=wp), allocatable :: SGM1(:), SGM2(:)

nLev = SGS%nLev

if (NCONF == 0) return
if (abs(OP0) > 1.0e-15_wp) SGM(1:NCONF) = SGM(1:NCONF)+OP0*CI(1:NCONF)
if (NACTEL == 0) return

! Unless this is a special-case wave function, reserve space
! for intermediate results of elementary excitations.
if (ISCF == 0) then
  call mma_allocate(SGM1,MXCI,Label='SGM1')
  if (NACTEL >= 2) call mma_allocate(SGM2,MXCI,Label='SGM2')
end if
! Special cases:
OCCNO = Zero
if (ISCF == 1) OCCNO = Two
if (ISCF == 2) OCCNO = One

! Create reorder table giving the GUGA level, i.e. CI-coupling
! ordinal number of each active orbital.
ITABS = 0
do ISYM=1,NSYM
  do I=1,NLEV
    if (SGS%ISM(I) == ISYM) then
      ITABS = ITABS+1
      IATOG(ITABS) = I
    end if
  end do
end do

do IZ=1,NASHT
  do IY=1,NASHT
    IYZ = IY+(IZ-1)*NASHT
    ISYZ = Mul(IASYM(IY),IASYM(IZ))
    ISYM1 = Mul(ISYZ,ISYCI)
    NSGM1 = CIS%NCSF(ISYM1)
    if (NSGM1 == 0) cycle
    if (ISCF == 0) then
      ! The general case:
      ! Compute SGM1:=E(IY,IZ) PSI
      SGM1(1:nSGM1) = Zero
      LEVY = IATOG(IY)
      LEVZ = IATOG(IZ)
      call SG_Epq_Psi(SGS,CIS,EXS,LEVY,LEVZ,One,ISYCI,CI,SGM1)
      ! Add non-zero 1-el contribution to SGM:
      if (ISYZ == 1) then
        X = OP1(IY,IZ)
        if (abs(X) > 1.0e-15_wp) SGM(1:nConf) = SGM(1:nConf)+X*SGM1(1:nConf)
      end if
    else
      ! Closed-shell or hi-spin case:
      if (IY /= IZ) cycle
      X = OCCNO*OP1(IY,IZ)
      SGM(1) = SGM(1)+X*CI(1)
    end if
    if (NACTEL == 1) cycle
    do IX=IZ,NASHT
      IVMIN = 1
      if (IX == IZ) IVMIN = IY
      do IV=IVMIN,NASHT
        IVX = IV+(IX-1)*NASHT
        ISVX = Mul(IASYM(IV),IASYM(IX))
        ISVXYZ = Mul(ISVX,ISYZ)
        IVXYZ = iTri(IVX,IYZ)
        ISYM2 = Mul(ISVX,ISYM1)
        NSGM2 = CIS%NCSF(ISYM2)
        if (NSGM2 == 0) cycle
        if (ISCF == 0) then
          ! The general case:
          ! Compute SGM2:=E(IV,IX) SGM1
          SGM2(1:nSGM2) = Zero
          LEVV = IATOG(IV)
          LEVX = IATOG(IX)
          call SG_Epq_Psi(SGS,CIS,EXS,LEVV,LEVX,One,ISYM1,SGM1,SGM2)
          ! Add non-zero 2-el contribution to SGM:
          if (ISVXYZ == 1) then
            X = OP2(IVXYZ)
            if (abs(X) > 1.0e-15_wp) SGM(1:nConf) = SGM(1:nConf)+X*SGM2(1:nConf)
          end if
        else
          ! Closed-shell or hi-spin case:
          if (IY /= IZ) cycle
          if (IV /= IX) cycle
          X = (OCCNO**2)*OP2(IVXYZ)
          SGM(1) = SGM(1)+X*CI(1)
        end if
        if (NACTEL == 2) cycle
        do IU=IX,NASHT
          ITMIN = 1
          if (IU == IX) ITMIN = IV
          do IT=ITMIN,NASHT
            ITU = IT+(IU-1)*NASHT
            ISTU = Mul(IASYM(IT),IASYM(IU))
            if (ISTU /= ISVXYZ) cycle
            ITUVXYZ = nTri3_Elem(ITU-1)+IVXYZ
            X = OP3(ITUVXYZ)
            if (abs(X) < 1.0e-15_wp) cycle
            ! Add non-zero 3-el contribution to SGM:
            if (ISCF == 0) then
              LEVT = IATOG(IT)
              LEVU = IATOG(IU)
              call SG_Epq_Psi(SGS,CIS,EXS,LEVT,LEVU,X,ISYM2,SGM2,SGM)
            else
              ! Closed-shell or hi-spin case:
              if (IT /= IU) cycle
              if (IV /= IX) cycle
              if (IY /= IZ) cycle
              X = (OCCNO**3)*OP3(ITUVXYZ)
              SGM(1) = SGM(1)+X*CI(1)
            end if
          end do
        end do
      end do
    end do
  end do
end do

! Deallocate temporary arrays, if any:
if (ISCF == 0) then
  call mma_deallocate(SGM1)
  if (NACTEL >= 2) call mma_deallocate(SGM2)
end if

end subroutine HAM3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
cmp      SUBROUTINE t3loopb(oeh,oep,t1a,t1b,g,nga,ngb,ngc,vblock,energ,
      SUBROUTINE t3loopb(oeh,oep,t1a,t1b,nga,ngb,ngc,vblock,energ,
     $ isp,LU,ifvo,lastcall,scored,jjj,enx)
C  implemented integer offsets, PV, 16 may 2004.
      IMPLICIT NONE
#include "ndisk.fh"
#include "WrkSpc.fh"
cmp      real*8 g(*),energ(*),oeh(*),oep(*),enx,t1a(*),t1b(*)
      real*8 energ(*),oeh(*),oep(*),enx,t1a(*),t1b(*)
      logical ifvo,lastcall,scored
      integer isp,vblock,n,lu(6),nga,ngb,ngc,adim,bdim,cdim
      integer en_offset_ah,en_offset_bh,en_offset_ap,en_offset_bp
      integer t1_offset_a,t1_offset_b
      integer nuga,nugc
      INTEGER iasblock(5),aset,bset,cset
      CHARACTER ich*1
      INTEGER IOPT,NOAB,NNOAB,NUAB,NNUAB
cmp
        integer jjj
cmp
      COMMON/UHF/NOAB(2),NNOAB(3),NUAB(2),NNUAB(3),ICH(3)
      COMMON/IOIND/IOPT(96)
      integer kab,kca,kcb,kac,kbc,kc,la,lb,lxa,lxb,lxc,t3a,t3b,
     $     vab,vbc,vac,mij,mi
cmp      SAVE      kab,kca,kcb,kac,kbc,kc,la,lb,lxa,lxb,lxc,t3a,t3b,
cmp     $     vab,vbc,vac,mij,mi,
cmp     $     iasblock,nuga,nugc
C
      en_offset_ah=(isp-1)*noab(1)
      en_offset_bh=(2-isp)*noab(1)
      en_offset_ap=(isp-1)*nuab(1)
      en_offset_bp=(2-isp)*nuab(1)
      t1_offset_a=(isp-1)*noab(1)*nuab(1)
      t1_offset_b=(2-isp)*noab(1)*nuab(1)
      N=noab(isp)+nuab(isp)
c
cmp
        scored=.true.
cmp!!!        if (lastcall) goto 321
cmp
      enx=0.d0
cmpn        write (*,*) 'Bef isp, energ(isp), enx = ',isp,energ(isp),enx
cmp!!!      if(energ(isp).eq.0.d0)then
C this is a first entry - initialization (makes no harm if reapeated)
      nuga=nuab(isp)/vblock
      if((nuga*vblock).lt.nuab(isp))nuga=nuga+1
!!      write(6,*)'first,nuga,vblock',nuga,vblock
      nugc=nuab(3-isp)/vblock
      if((nugc*vblock).lt.nuab(3-isp))nugc=nugc+1
!!      write(6,*)'first,nugc,vblock',nugc,vblock

      iasblock(1)=vblock*vblock*N/nblock
      if((iasblock(1)*nblock).lt.(vblock*vblock*N))
     $iasblock(1)=iasblock(1)+1

      iasblock(2)=nnoab(isp)*vblock*N/nblock
      if((iasblock(2)*nblock).lt.(nnoab(isp)*vblock*N))
     $iasblock(2)=iasblock(2)+1

      iasblock(3)=nnoab(3)*vblock*N/nblock
      if((iasblock(3)*nblock).lt.(nnoab(3)*vblock*N))
     $iasblock(3)=iasblock(3)+1

      iasblock(4)=nnoab(isp)*vblock*vblock/nblock
      if((iasblock(4)*nblock).lt.(nnoab(isp)*vblock*vblock))
     $iasblock(4)=iasblock(4)+1

      iasblock(5)=nnoab(3)*vblock*vblock/nblock
      if((iasblock(5)*nblock).lt.(nnoab(3)*vblock*vblock))
     $iasblock(5)=iasblock(5)+1

cmp      call w_rescope(G,'GT3loopb')
cmp      call w_free(g,0,'GT3loopb')
c  allocations
      if(nuga.ne.1)then
cmp      call w_alloc(kab,noab(isp)*vblock*vblock*n,'kaT3loopb')
        Call GetMem('loopb_kab','Allo','Real',kab,
     & noab(isp)*vblock*vblock*n)
cmp      call w_alloc(kcb,noab(isp)*vblock*vblock*n,'kbT3loopb')
        Call GetMem('loopb_kcb','Allo','Real',kcb,
     & noab(isp)*vblock*vblock*n)
cmp      call w_alloc(kbc,vblock*vblock*n,'kcT3loopb')
        Call GetMem('loopb_kbc','Allo','Real',kbc,
     & vblock*vblock*n)
      else
cmp      call w_alloc(kab,noab(isp)*N*nnuab(isp),'kaT3loopb')
        Call GetMem('loopb_kab','Allo','Real',kab,
     & noab(isp)*N*nnuab(isp))
      endif
cmp      call w_alloc(kac,vblock*vblock*n,'kcT3loopb')
        Call GetMem('loopb_kac','Allo','Real',kac,
     & vblock*vblock*n)
cmp      call w_alloc(kca,noab(isp)*vblock*vblock*n,'kbT3loopb')
        Call GetMem('loopb_kca','Allo','Real',kca,
     & noab(isp)*vblock*vblock*n)
cmp      call w_alloc(kc,vblock*vblock*n,'kcT3loopb')
        Call GetMem('loopb_kc','Allo','Real',kc,
     & vblock*vblock*n)
cmp      call w_alloc(la,nnoab(isp)*vblock*n,'laT3loopb')
        Call GetMem('loopb_la','Allo','Real',la,
     & nnoab(isp)*vblock*n)
cmp      call w_alloc(lxa,nnoab(3)*vblock*n,'lbaT3loopb')
        Call GetMem('loopb_lxa','Allo','Real',lxa,
     & nnoab(3)*vblock*n)
cmpn        write (*,*) 'check lxa'
cmpn        write (*,*) 'nnoab(1), (2), (3) = ',
cmpn     &               nnoab(1),nnoab(2),nnoab(3)
cmpn        write (*,*) 'nnuab(1), (2), (3) = ',
cmpn     &               nnuab(1),nnuab(2),nnuab(3)
       if(nuga.ne.1)then
cmp      call w_alloc(lb,nnoab(isp)*vblock*n,'lbT3loopb')
        Call GetMem('loopb_lb','Allo','Real',lb,
     & nnoab(isp)*vblock*n)
cmp      call w_alloc(lxb,nnoab(3)*vblock*n,'labT3loopb')
        Call GetMem('loopb_lxb','Allo','Real',lxb,
     & nnoab(3)*vblock*n)
       endif
cmp      call w_alloc(lxc,nnoab(3)*vblock*n,'lacT3loopb')
        Call GetMem('loopb_lxc','Allo','Real',lxc,
     & nnoab(3)*vblock*n)
cmp      call w_alloc(t3a,vblock*vblock*vblock,'t3aT3loopb')
        Call GetMem('loopb_t3a','Allo','Real',t3a,
     & vblock*vblock*vblock)
cmp      call w_alloc(t3b,vblock*vblock*vblock,'t3bT3loopb')
        Call GetMem('loopb_t3b','Allo','Real',t3b,
     & vblock*vblock*vblock)
cmp      call w_alloc(vac,vblock*vblock*nnoab(3),'vbcT3loopb')
        Call GetMem('loopb_vac','Allo','Real',vac,
     & vblock*vblock*nnoab(3))
      if(nuga.ne.1) then
cmp      call w_alloc(vab,vblock*vblock*nnoab(isp),'vabT3loopb')
        Call GetMem('loopb_vab','Allo','Real',vab,
     & vblock*vblock*nnoab(isp))
cmp      call w_alloc(vbc,vblock*vblock*nnoab(3),'vacT3loopb')
        Call GetMem('loopb_vbc','Allo','Real',vbc,
     & vblock*vblock*nnoab(3))
      else
cmp      call w_alloc(vab,nnoab(isp)*nnuab(isp),'vabT3loopb')
        Call GetMem('loopb_vab','Allo','Real',vab,
     & nnoab(isp)*nnuab(isp))
      endif
cmp      call w_alloc(mi,noab(isp)*vblock**3,'miT3loopb')
        Call GetMem('loopb_mi','Allo','Real',mi,
     & noab(isp)*vblock**3)
cmp
cmpn        write (*,*) 'mi check = ',noab(isp)*vblock**3
cmpn        write (*,*) 'nnoab(1), (2), (3) = ',
cmpn     &               nnoab(1),nnoab(2),nnoab(3)
cmpn        write (*,*) 'nnuab(1), (2), (3) = ',
cmpn     &               nnuab(1),nnuab(2),nnuab(3)
cmp
cmp      call w_alloc(mij,N*vblock,'mijT3loopb')
        Call GetMem('loopb_mij','Allo','Real',mij,
     & N*vblock)
cmp!!!      endif     ! energ = 0 - initialization
C
      aset=(nga-1)*vblock
      adim=min(vblock,nuab(isp)-aset)
      bset=(ngb-1)*vblock
      bdim=min(vblock,nuab(isp)-bset)
      cset=(ngc-1)*vblock
      cdim=min(vblock,nuab(3-isp)-cset)
C
C case1 nga=ngb=ngc
C
      if(nga.eq.ngb) then
C
C
cmp      call t3_bta_aac(nuga,nugc,g(kab),g(kca),g(kac),g(kc),g(la),g(lxa),
cmp     $g(lxc),g(mi),g(mij),adim,cdim,N,noab(isp),nuab(isp),
cmpn        write (*,*) 'ide call t3_bta_aac'
      call t3_bta_aac(nuga,nugc,Work(kab),Work(kca),Work(kac),Work(kc),
     &Work(la),Work(lxa),
     $Work(lxc),Work(mi),Work(mij),adim,cdim,N,noab(isp),nuab(isp),
     $noab(3-isp),nuab(3-isp),lu,iasblock,nga,ngc,
     $oeh(en_offset_ah+1),oeh(en_offset_bh+1),
     $oep(aset+en_offset_ap+1),oep(cset+en_offset_bp+1)
     $,enx,Work(vab),Work(vac),t1a(noab(isp)*aset+t1_offset_a+1),
     $t1b(noab(isp)*aset+t1_offset_a+1),
     $t1a(noab(3-isp)*cset+t1_offset_b+1),
     $t1b(noab(3-isp)*cset+t1_offset_b+1),Work(t3a),Work(t3b),ifvo)
cmp     $,enx,g(vab),g(vac),t1a(noab(isp)*aset+t1_offset_a+1),
cmp     $t1b(noab(isp)*aset+t1_offset_a+1),
cmp     $t1a(noab(3-isp)*cset+t1_offset_b+1),
cmp     $t1b(noab(3-isp)*cset+t1_offset_b+1),g(t3a),g(t3b),ifvo)
      else
cmp      call t3_bta_abc(nuga,nugc,g(kab),g(kcb),g(kca),g(kac),g(kbc),g(kc)
cmp     $,g(la),g(lb),
cmp     $g(lxa),g(lxb),g(lxc),g(mi),g(mij),adim,bdim,cdim,N,noab(isp),
cmpn        write (*,*) 'ide call t3_bta_abc'
cmp
      call t3_bta_abc(nuga,nugc,Work(kab),Work(kcb),Work(kca),Work(kac),
     &Work(kbc),Work(kc),Work(la),Work(lb),
     $Work(lxa),Work(lxb),Work(lxc),Work(mi),Work(mij),adim,bdim,cdim,
     &N,noab(isp),
     $nuab(isp),noab(3-isp),nuab(3-isp),lu,iasblock,nga,ngb,ngc,
     $oeh(en_offset_ah+1),oeh(en_offset_bh+1),oep(aset+en_offset_ap+1),
     $oep(bset+en_offset_ap+1),oep(cset+en_offset_bp+1)
     $,enx,Work(vab),Work(vbc),Work(vac),t1a(noab(isp)*aset+
     &t1_offset_a+1),
     $t1b(noab(isp)*aset+t1_offset_a+1),
     $t1a(noab(isp)*bset+t1_offset_a+1),
     $t1b(noab(isp)*bset+t1_offset_a+1),
     $t1a(noab(3-isp)*cset+t1_offset_b+1),
     $t1b(noab(3-isp)*cset+t1_offset_b+1),Work(t3a),Work(t3b),ifvo)
cmp     $,enx,g(vab),g(vbc),g(vac),t1a(noab(isp)*aset+t1_offset_a+1),
cmp     $t1b(noab(isp)*aset+t1_offset_a+1),
cmp     $t1a(noab(isp)*bset+t1_offset_a+1),
cmp     $t1b(noab(isp)*bset+t1_offset_a+1),
cmp     $t1a(noab(3-isp)*cset+t1_offset_b+1),
cmp     $t1b(noab(3-isp)*cset+t1_offset_b+1),g(t3a),g(t3b),ifvo)
      endif   ! cases
cmpn        write (*,*) 'isp, energ(isp), enx = ',isp,energ(isp),enx
      energ(isp)=energ(isp)+enx
cmp!!!        write (*,'(A,i5,x,3(i5,2x),f21.19)') 'Tsk, nga, ngb, ngc, inc = ',
cmp!!!     & jjj,nga,ngb,ngc,enx
c321     continue
cmp        write (6,*)
cmp        write (6,*) 'deallocating arrays in t3loob'
cmp        write (6,*)
cmp
        Call GetMem('loopb_mij','Free','Real',mij,
     & N*vblock)
        Call GetMem('loopb_mi','Free','Real',mi,
     & noab(isp)*vblock**3)
      if(nuga.ne.1) then
        Call GetMem('loopb_vbc','Free','Real',vbc,
     & vblock*vblock*nnoab(3))
        Call GetMem('loopb_vab','Free','Real',vab,
     & vblock*vblock*nnoab(isp))
      else
        Call GetMem('loopb_vab','Free','Real',vab,
     & nnoab(isp)*nnuab(isp))
      endif
        Call GetMem('loopb_vac','Free','Real',vac,
     & vblock*vblock*nnoab(3))
        Call GetMem('loopb_t3b','Free','Real',t3b,
     & vblock*vblock*vblock)
        Call GetMem('loopb_t3a','Free','Real',t3a,
     & vblock*vblock*vblock)
        Call GetMem('loopb_lxc','Free','Real',lxc,
     & nnoab(3)*vblock*n)
       if(nuga.ne.1)then
        Call GetMem('loopb_lxb','Free','Real',lxb,
     & nnoab(3)*vblock*n)
        Call GetMem('loopb_lb','Free','Real',lb,
     & nnoab(isp)*vblock*n)
       endif
        Call GetMem('loopb_lxa','Free','Real',lxa,
     & nnoab(3)*vblock*n)
        Call GetMem('loopb_la','Free','Real',la,
     & nnoab(isp)*vblock*n)
        Call GetMem('loopb_kc','Free','Real',kc,
     & vblock*vblock*n)
        Call GetMem('loopb_kca','Free','Real',kca,
     & noab(isp)*vblock*vblock*n)
        Call GetMem('loopb_kac','Free','Real',kac,
     & vblock*vblock*n)
      if(nuga.ne.1)then
        Call GetMem('loopb_kbc','Free','Real',kbc,
     & vblock*vblock*n)
        Call GetMem('loopb_kcb','Free','Real',kcb,
     & noab(isp)*vblock*vblock*n)
        Call GetMem('loopb_kab','Free','Real',kab,
     & noab(isp)*vblock*vblock*n)
      else
        Call GetMem('loopb_kab','Free','Real',kab,
     & noab(isp)*N*nnuab(isp))
      endif
cmp
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_logical(lastcall)
        call Unused_integer(jjj)
      end if
      end

      subroutine t3_bta_aac(nuga,nugc,kab,kca,kac,kc,la,lxa,lxc,mi,mij,
     $adim,cdim,N,noab_a,nuab_a,noab_b,nuab_b,lu,iasblock,nga,ngc,
     $oehi,oehk,oepa,oepc,enx,vab,vca,t1aa,t1ba,t1ac,t1bc,t3a,t3b,ifvo)
      implicit none
      real*8 one,zero,den,dena,denb,denc,enx,xx,yy
      parameter (one=1.d0,zero=0.d0)
      integer nadim,adim,ncdim,cdim,i,j,k,iasblock(5),lu(6),N
      integer noab_a,nuab_a,noab_b,nuab_b,nuga,nno_a,nnoab,nugc,
     $ngab_offset,ngca_offset,ngac_offset,nuga_offset,nugc_offset
      integer ias,jk,ij,ik,kj,ki,nga,ngc,a,b,c,ab,abb,bab
      integer iasabi,iascai,iasack
      real*8 kca(adim*cdim,N,*),kac(adim*cdim,N,*)
     $,kab(adim*(adim-1)/2,N,*)
     $,kc(*),la(N*adim,*),lxa(N*adim,*),lxc(N*cdim,*)
      real*8 t3a(*),t3b(*)
      real*8 mi(cdim*adim*(adim-1)/2,*),mij(*),
     $       vab(adim*(adim-1)/2,*),vca(adim*cdim,*)
      real*8 t1aa(noab_a,*),t1ba(noab_a,*),t1ac(noab_b,*),t1bc(noab_b,*)
      real*8 oehi(*),oehk(*),oepa(*),oepc(*)
      logical ifvo
C
C iasblock(1) > ka,kb,kc   iasblock(2) > la,lb iasblock(3) > lxa,lxc,lxb
      if(adim.eq.1)return
      nno_a=noab_a*(noab_a-1)/2
      nnoab=noab_a*noab_b
      nadim=adim*(adim-1)/2
      ncdim=adim*cdim
      nuga_offset=iasblock(1)*nuga*(nuga+1)/2
      nugc_offset=iasblock(1)*nuga*nugc
      ias=iasblock(2)*(nga-1)+1
      call multi_readir(la,nno_a*adim*N,lu(2),ias)
      ias=iasblock(3)*(nga-1)+1
      call multi_readir(lxa,nnoab*adim*N,lu(5),ias)
      ias=iasblock(3)*(ngc-1)+1
      call multi_readir(lxc,nnoab*cdim*N,lu(6),ias)
C vvoo ints reading
      ngab_offset=iasblock(4)*(nga*(nga-1)/2+nga-1)+1
      ias=iasblock(2)*nuga+ngab_offset
      call multi_readir(vab,nno_a*nadim,lu(2),ias)
      ngca_offset=iasblock(5)*(nugc*(nga-1)+ngc-1)+1
      ias=iasblock(2)*nuga+iasblock(4)*nuga*(nuga+1)/2+ngca_offset
      call multi_readir(vca,nnoab*adim*cdim,lu(2),ias)
!!      ngac_offset=iasblock(5)*(nuga*(ngc-1)+nga-1)+1
C end readin vvoo ints
      ngab_offset=iasblock(1)*(nga*(nga-1)/2+nga-1)+1
      ngac_offset=iasblock(1)*(nuga*(ngc-1)+nga-1)+1
      ngca_offset=iasblock(1)*(nugc*(nga-1)+ngc-1)+1

                do i=1,noab_a
                iasabi=(i-1)*nuga_offset+ngab_offset
                call multi_readir(kab(1,1,i),N*nadim,lu(1),iasabi)
                enddo
                do i=1,noab_a
                iascai=(i-1)*nugc_offset+ngca_offset
                call multi_readir(kca(1,1,i),N*ncdim,lu(3),iascai)
                enddo
         do k=1,noab_b
         do i=1,noab_a
         ik=(k-1)*noab_a +i
         ki=(i-1)*noab_b +k
C  K_ab^ir x L_rc^ik     cba
      call DGEMM_('T','T',cdim,nadim,N,one,lxc(1,ik),N,kab(1,1,i),nadim,
     $                      zero,mi(1,i),cdim)
C
C  K_ac^ir x L_rb^ki     cab
      call DGEMM_('N','N',ncdim,adim,N,one,kca(1,1,i),ncdim,lxa(1,ki),N,
     $                    zero,t3b,ncdim)
        ab=1
      do a=2,adim
      abb=(a-1)*cdim+1
      bab=(a-1)*ncdim+1
      do b=1,a-1
      call daxpy_(cdim,-1.d0,t3b(abb),1,mi(ab,i),1)
      call daxpy_(cdim,1.d0,t3b(bab),1,mi(ab,i),1)
      ab=ab+cdim
      abb=abb+ncdim
      bab=bab+cdim
      enddo
      enddo
          enddo    ! i
! end prefactors
         iasack=(k-1)*nugc_offset+ngac_offset
         call multi_readir(kac,N*ncdim,lu(4),iasack)
         ij=0
         do i=2,noab_a
         ki=(i-1)*noab_b +k
         ik=(k-1)*noab_a +i
         kj=k-noab_b
         jk=(k-1)*noab_a
         do j=1,i-1
         ij=ij+1
         kj=kj+noab_b
         jk=jk+1
C  K_bc^kr x L_ra^ij
         call DGEMM_('N','N',ncdim,adim,N,one,kac,ncdim,la(1,ij),N,
     $                     zero,t3a,ncdim)
C transpose the first two inicesd
         ab=1
         do a=1,adim
         call transm(t3a(ab),t3b(ab),adim,cdim)
         ab=ab+ncdim
         enddo
C  K_ab^ir x L_rc^jk -K_ab^jr x L_rc^ik
         call vsub(kab(1,1,j),1,kab(1,1,i),1,kc,1,N*nadim)
         call vadd(lxc(1,jk),1,lxc(1,ik),1,mij,1,N*cdim)
         call DGEMM_('T','T',cdim,nadim,N,one,mij,N,kc,nadim,
     $                     zero,t3a,cdim)
C  K_ab^ir x L_rc^jk
!!         call DGEMM_('T','T',cdim,nadim,N,one,lxc(1,jk),N,ka,nadim,
!!     $                     zero,t3a,cdim)
C  -K_ab^jr x L_rc^ik
!!         call DGEMM_('T','T',cdim,nadim,N,-one,lxc(1,ik),N,kb,nadim,
!!     $                      one,t3a,cdim)
C
C  K_bc^ir x L_ra^kj -K_bc^jr x L_ra^ki
         call vsub(kca(1,1,j),1,kca(1,1,i),1,kc,1,N*ncdim)
         call vadd(lxa(1,kj),1,lxa(1,ki),1,mij,1,N*adim)
         call DGEMM_('N','N',ncdim,adim,N,one,kc,ncdim,mij,N,
     $                     one,t3b,ncdim)
C  K_bc^ir x L_ra^kj
!!         call DGEMM_('N','N',ncdim,adim,N,one,ka,ncdim,lxa(1,kj),N,
!!     $                     one,t3b,ncdim)
C  -K_bc^jr x L_ra^ki
!!         call DGEMM_('N','N',ncdim,adim,N,-one,kb,ncdim,lxa(1,ki),N,
!!     $                     one,t3b,ncdim)
       ab=1
      do a=2,adim
      abb=(a-1)*cdim+1
      bab=(a-1)*ncdim+1
      do b=1,a-1
      call daxpy_(cdim,-1.d0,t3b(abb),1,t3a(ab),1)
      call daxpy_(cdim,1.d0,t3b(bab),1,t3a(ab),1)
      ab=ab+cdim
      abb=abb+ncdim
      bab=bab+cdim
      enddo
      enddo
!!
      call daxpy_(nadim*cdim,-1.d0,mi(1,i),1,t3a,1)
      call daxpy_(nadim*cdim,1.d0,mi(1,j),1,t3a,1)
         den=oehi(i)+oehi(j)+oehk(k)
      ab=0
      do a=2,adim
      dena=den-oepa(a)
      do b=1,a-1
      denb=dena-oepa(b)
      do c=1,cdim
      denc=denb-oepc(c)
      ab=ab+1
      xx=t3a(ab)
      yy=xx/denc
      enx=enx+yy*xx
      t3a(ab)=yy
!!      t1aa(j,a)=t1aa(j,a)-yy*vca((a-1)*cdim+c,ki)
      enddo
      enddo
      enddo
      call expa2_uhf(t3a,cdim,adim,-1,t3b)
         call DGEMM_('N','T',1,cdim,nadim, one,vab(1,ij),1,
     $  t3a,cdim,one,t1ac(k,1),noab_b)
         call DGEMM_('N','N',1,adim,ncdim, one,vca(1,kj),1,
     $  t3b,ncdim,one,t1aa(i,1),noab_a)
         call DGEMM_('N','N',1,adim,ncdim,-one,vca(1,ki),1,
     $  t3b,ncdim,one,t1aa(j,1),noab_a)
C ccsd(T) part t2*t3
         if(ifvo) then
         call DGEMM_('N','T',1,cdim,nadim, one,kab(1,i,j),1,
     $  t3a,cdim,one,t1bc(k,1),noab_b)
         call DGEMM_('N','N',1,adim,ncdim,-one,kca(1,k,j),1,
     $  t3b,ncdim,one,t1ba(i,1),noab_a)
         call DGEMM_('N','N',1,adim,ncdim, one,kca(1,k,i),1,
     $  t3b,ncdim,one,t1ba(j,1),noab_a)
         endif
         enddo !j
         enddo !i
         enddo !k
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(nuab_a)
        call Unused_integer(nuab_b)
      end if
      end

      subroutine t3_bta_abc(nuga,nugc,kab,kcb,kca,kac,kbc,kc,la,lb,lxa,
     $lxb,lxc,mi,mij,adim,bdim,cdim,N,noab_a,nuab_a,noab_b,nuab_b,lu,
     $iasblock,nga,ngb,ngc,oehi,oehk,oepa,oepb,oepc,enx,vab,vcb,vca,
     $t1aa,t1ba,t1ab,t1bb,t1ac,t1bc,t3a,t3b,ifvo)
      implicit none
cmp
c     integer imm
cmp
      real*8 one,zero,den,dena,denb,denc,enx,xx,yy
c     real*8 sumt3
      parameter (one=1.d0,zero=0.d0)
      integer nadim,adim,ncdim,cdim,bdim,nbdim,i,j,k,iasblock(5),lu(6),N
      integer noab_a,nuab_a,noab_b,nuab_b,nuga,nno_a,nnoab,nugc,
     $ngab_offset,ngca_offset,ngac_offset,nuga_offset,nugc_offset,
     $ngcb_offset,ngbc_offset
      integer ias,jk,ij,ik,kj,ki,nga,ngb,ngc,a,b,c,ab,ba
      integer iasabi,iascai,iasack,iascbi,iasbck
      real*8 kab(adim*bdim,N,*),kcb(cdim*bdim,N,*),kca(cdim*adim,N,*)
     $,kac(cdim*adim,N),kbc(cdim*bdim,N),kc(*),lxb(N*bdim,*)
      real*8 la(N*adim,*),lb(N*bdim,*),lxa(N*adim,*),lxc(N*cdim,*),
     $t3a(*),t3b(*),vab(adim*bdim,*),vca(adim*cdim,*),vcb(bdim*cdim,*)
      real*8 mi(adim*bdim*cdim,*),mij(*)
      real*8 t1aa(noab_a,*),t1ba(noab_a,*),t1ac(noab_b,*)
     $        ,t1bc(noab_b,*),t1ab(noab_a,*),t1bb(noab_a,*)
      real*8 oehi(*),oehk(*),oepa(*),oepb(*),oepc(*)
      logical ifvo
cmp
c
C iasblock(1) > ka,kb,kc   iasblock(2) > la,lb iasblock(3) > lxa,lxc,lxb
!!      sumt3=0.d0
      nno_a=noab_a*(noab_a-1)/2
      nnoab=noab_a*noab_b
      nadim=adim*bdim
      nbdim=bdim*cdim
      ncdim=adim*cdim
      nuga_offset=iasblock(1)*nuga*(nuga+1)/2
      nugc_offset=iasblock(1)*nuga*nugc
      ias=iasblock(2)*(nga-1)+1
      call multi_readir(la,nno_a*adim*N,lu(2),ias)
      ias=iasblock(2)*(ngb-1)+1
      call multi_readir(lb,nno_a*bdim*N,lu(2),ias)
      ias=iasblock(3)*(nga-1)+1
      call multi_readir(lxa,nnoab*adim*N,lu(5),ias)
      ias=iasblock(3)*(ngb-1)+1
      call multi_readir(lxb,nnoab*bdim*N,lu(5),ias)
      ias=iasblock(3)*(ngc-1)+1
      call multi_readir(lxc,nnoab*cdim*N,lu(6),ias)
C
C vvoo ints reading
      ngab_offset=iasblock(4)*(nga*(nga-1)/2+ngb-1)+1
      ias=iasblock(2)*nuga+ngab_offset
      call multi_readir(vab,nno_a*nadim,lu(2),ias)
      ngca_offset=iasblock(5)*(nugc*(nga-1)+ngc-1)+1
      ias=iasblock(2)*nuga+iasblock(4)*nuga*(nuga+1)/2+ngca_offset
      call multi_readir(vca,nnoab*ncdim,lu(2),ias)
      ngcb_offset=iasblock(5)*(nugc*(ngb-1)+ngc-1)+1
      ias=iasblock(2)*nuga+iasblock(4)*nuga*(nuga+1)/2+ngcb_offset
      call multi_readir(vcb,nnoab*nbdim,lu(2),ias)
C end readin vvoo ints
C
      ngab_offset=iasblock(1)*(nga*(nga-1)/2+ngb-1)+1
      ngac_offset=iasblock(1)*(nuga*(ngc-1)+nga-1)+1
      ngbc_offset=iasblock(1)*(nuga*(ngc-1)+ngb-1)+1
      ngca_offset=iasblock(1)*(nugc*(nga-1)+ngc-1)+1
      ngcb_offset=iasblock(1)*(nugc*(ngb-1)+ngc-1)+1
C saves reading:
      do i=1,noab_a
      iasabi=(i-1)*nuga_offset+ngab_offset
      call multi_readir(kab(1,1,i),N*nadim,lu(1),iasabi)
      enddo
      do i=1,noab_a
      iascai=(i-1)*nugc_offset+ngca_offset
      call multi_readir(kca(1,1,i),N*ncdim,lu(3),iascai)
cmp
cmp        write (*,*) 'ze tak teraz ju dam',i
cmp        call check_mat(kca(1,1,i),1,N*ncdim)
cmp
      enddo
      do i=1,noab_a
         iascbi=(i-1)*nugc_offset+ngcb_offset
         call multi_readir(kcb(1,1,i),N*nbdim,lu(3),iascbi)
      enddo
         do k=1,noab_b
         iasbck=(k-1)*nugc_offset+ngbc_offset
         call multi_readir(kbc,N*nbdim,lu(4),iasbck)
         iasack=(k-1)*nugc_offset+ngac_offset
         call multi_readir(kac,N*ncdim,lu(4),iasack)
C start calculating prefactors:
cmp
         do i=1,noab_a
         ik=(k-1)*noab_a +i
         ki=(i-1)*noab_b +k
cmp
C  K_ab^ir x L_rc^ik     cba
       call DGEMM_('T','T',cdim,nadim,N,one,lxc(1,ik),N,
     &  kab(1,1,i),nadim,
     $                      zero,mi(1,i),cdim)
C  K_bc^ir x L_ra^ki          cba
       call DGEMM_('N','N',nbdim,adim,N,one,kcb(1,1,i),nbdim,
     &  lxa(1,ki),N,
     $                     one ,mi(1,i),nbdim)
cmp
cmp        do imm=0,adim*nbdim-1
cmp        if (abs(mi(1+imm,i)).gt.10000) then
cmp          write (*,*) 'uz mi dojebane 2',imm+1,i,mi(1+imm,i)
cmp          stop
cmp        end if
cmp        end do
cmp
C
C  K_ac^ir x L_rb^ki     cab
      call DGEMM_('N','N',ncdim,bdim,N,one,kca(1,1,i),ncdim,
     &    lxb(1,ki),N,
     $                    zero,t3b,ncdim)
cmp
         ab=1
      do a=1,adim
      ba=(a-1)*cdim+1
      do b=1,bdim
      call daxpy_(cdim,-1.d0,t3b(ba),1,mi(ab,i),1)
      ab=ab+cdim
      ba=ba+ncdim
      enddo
      enddo
          enddo    ! i
cmp
! end prefactors
         ij=0
         do i=2,noab_a
         ki=(i-1)*noab_b +k
         ik=(k-1)*noab_a +i
         kj=k-noab_b
         jk=(k-1)*noab_a
         do j=1,i-1
         ij=ij+1
         kj=kj+noab_b
         jk=jk+1
cmp
C  K_ac^kr x L_rb^ij        bac
         call DGEMM_('T','T',bdim,ncdim,N,-one,lb(1,ij),N,kac,ncdim,
     $                     zero,t3b,bdim)
C  K_bc^kr x L_ra^ij        abc
         call DGEMM_('T','T',adim,nbdim,N,one,la(1,ij),N,kbc,nbdim,
     $                     zero,t3a,adim)
C transpose the first two indices
cmp
         ab=1
         do c=1,cdim
         ba=(c-1)*nadim+1
         do b=1,bdim
         call daxpy_(adim,1.d0,t3a(ab),1,t3b(ba),bdim)
         ba=ba+1
         ab=ab+adim
         enddo
         enddo
C t3b  bac
         call transm(t3b,t3a,nadim,cdim)
C      cba in t3a
C K_ab^ir x L_rc^jk  -K_ab^jr x L_rc^ik
         call vsub(kab(1,1,j),1,kab(1,1,i),1,kc,1,N*nadim)
C         call daxpy_(N*nadim,-one,kb,1,ka,1)
         call vadd(lxc(1,jk),1,lxc(1,ik),1,mij,1,N*cdim)
         call DGEMM_('T','T',cdim,nadim,N,one,mij,N,kc,nadim,
     $                      one,t3a,cdim)
C  K_ab^ir x L_rc^jk
!!         call DGEMM_('T','T',cdim,nadim,N,one,lxc(1,jk),N,ka,nadim,
!!     $                      one,t3a,cdim)
C  -K_ab^jr x L_rc^ik
!!         call DGEMM_('T','T',cdim,nadim,N,-one,lxc(1,ik),N,kb,nadim,
!!     $                      one,t3a,cdim)
C
C  K_bc^ir x L_ra^kj -K_bc^jr x L_ra^ki         cba
         call vsub(kcb(1,1,j),1,kcb(1,1,i),1,kc,1,N*nbdim)
         call vadd(lxa(1,kj),1,lxa(1,ki),1,mij,1,N*adim)
         call DGEMM_('N','N',nbdim,adim,N,one,kc,nbdim,mij,N,
     $                     one,t3a,nbdim)
C  K_bc^ir x L_ra^kj          cba
!!         call DGEMM_('N','N',nbdim,adim,N,one,ka,nbdim,lxa(1,kj),N,
!!     $                     one,t3a,nbdim)
C  -K_bc^jr x L_ra^ki         cba
!!         call DGEMM_('N','N',nbdim,adim,N,-one,kb,nbdim,lxa(1,ki),N,
!!     $                     one,t3a,nbdim)
C  K_ac^ir x L_rb^kj  -K_ac^jr x L_rb^ki      cab
         call vsub(kca(1,1,j),1,kca(1,1,i),1,kc,1,N*ncdim)
         call vadd(lxb(1,kj),1,lxb(1,ki),1,mij,1,N*bdim)
         call DGEMM_('N','N',ncdim,bdim,N,one,kc,ncdim,mij,N,
     $                    zero,t3b,ncdim)
C  K_ac^ir x L_rb^kj      cab
!!         call DGEMM_('N','N',ncdim,bdim,N,one,ka,ncdim,lxb(1,kj),N,
!!     $                    zero,t3b,ncdim)
C  -K_ac^jr x L_rb^ki     cab
!!         call DGEMM_('N','N',ncdim,bdim,N,-one,kb,ncdim,lxb(1,ki),N,
!!     $                     one,t3b,ncdim)
cmp
         ab=1
      do a=1,adim
      ba=(a-1)*cdim+1
      do b=1,bdim
      call daxpy_(cdim,-1.d0,t3b(ba),1,t3a(ab),1)
      ab=ab+cdim
      ba=ba+ncdim
      enddo
      enddo
c
cmp        do a=1,adim
cmp        do b=1,bdim
cmp        do c=1,cdim
cmp        ab=c+(b-1)*cdim+(a-1)*bdim*cdim
cmp        ba=c+(a-1)*cdim+(b-1)*adim*cdim
cmp        t3a(ab)=t3a(ab)-t3b(ba)
cmp        end do
cmp        end do
cmp        end do
c
cmp
c
      call daxpy_(nadim*cdim,-1.d0,mi(1,i),1,t3a,1)
      call daxpy_(nadim*cdim,1.d0,mi(1,j),1,t3a,1)
         den=oehi(i)+oehi(j)+oehk(k)
      ab=0
      do a=1,adim
      ba=ab+1
      dena=den-oepa(a)
      do b=1,bdim
      denb=dena-oepb(b)
      do c=1,cdim
      denc=denb-oepc(c)
      ab=ab+1
cmp        if ((i.eq.14).and.(j.eq.1).and.(k.eq.1)) then
cmp          write (*,'(A,3(i5,x),3(f18.10,x))')
cmp     &               'a,b,c, oepa(a), oepb(b), oepc(c)',
cmp     &                a,b,c,oepa(a),oepb(b),oepc(c)
cmp          write (*,*) 'denc = ',denc
cmp          write (*,*) 'ab, t3a(ab) ',ab,t3a(ab)
cmp        end if
      xx=t3a(ab)
      yy=xx/denc
!!      sumt3=sumt3+xx
      enx=enx+yy*xx
cmp        if ((i.eq.14).and.(j.eq.1).and.(k.eq.1)) then
cmp          write (*,'(A,3(f18.10,x))') 'xx,yy,enx = ',xx,yy,enx
cmp        end if
      t3a(ab)=yy
      enddo
      enddo
      call transm(t3a(ba),t3b(ba),cdim,bdim)
      enddo
      call DGEMM_('N','T',1,cdim,nadim, one,vab(1,ij),1,
     $  t3a,cdim,one,t1ac(k,1),noab_b)
       call DGEMM_('N','N',1,adim,nbdim,-one,vcb(1,kj),1,
     $  t3a,nbdim,one,t1aa(i,1),noab_a)
       call DGEMM_('N','N',1,adim,nbdim,one,vcb(1,ki),1,
     $  t3a,nbdim,one,t1aa(j,1),noab_a)
      call DGEMM_('N','T',1,bdim,ncdim,-one,vca(1,ki),1,
     $  t3b,bdim,one,t1ab(j,1),noab_a)
      call DGEMM_('N','T',1,bdim,ncdim,one,vca(1,kj),1,
     $  t3b,bdim,one,t1ab(i,1),noab_a)
       if(ifvo) then
      call DGEMM_('N','T',1,cdim,nadim, one,kab(1,i,j),1,
     $  t3a,cdim,one,t1bc(k,1),noab_b)
       call DGEMM_('N','N',1,adim,nbdim,one,kcb(1,k,j),1,
     $  t3a,nbdim,one,t1ba(i,1),noab_a)
       call DGEMM_('N','N',1,adim,nbdim,-one,kcb(1,k,i),1,
     $  t3a,nbdim,one,t1ba(j,1),noab_a)
      call DGEMM_('N','T',1,bdim,ncdim,one,kca(1,k,i),1,
     $  t3b,bdim,one,t1bb(j,1),noab_a)
      call DGEMM_('N','T',1,bdim,ncdim,-one,kca(1,k,j),1,
     $  t3b,bdim,one,t1bb(i,1),noab_a)
      endif
cmp        write (*,'(3(i5,x),f18.10)') i,j,k,enx
         enddo !j
         enddo !i
         enddo !k
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(nuab_a)
        call Unused_integer(nuab_b)
      end if
      end
c
c -----------
c
        subroutine check_mat(mat,dima,dimb)
c
        implicit none
        integer dima,dimb,i,j
        real*8 mat(dima,dimb)
c
        do i=1,dima
        do j=1,dimb
        if (abs(mat(i,j)).gt.10000) then
          write (6,*) 'i,j,mat(i,j) ',i,j,mat(i,j)
        end if
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      function qcomp(alpha,dfac,n,l,t,xk)
c
c  compute q(n,l) scaled by sqrt(pi)*exp(-t) to prevent overflows
c  arguments are alpha, xk, and t=xk**2/(4*alpha)
c  no restriction on the magnitude of t
c  increase dfac array to raise n, l restrictions
c
      implicit real*8 (a-h,o-z)
      parameter (am1=-1.0d0, a0=0.0d0, accpow=1.0d-14,
     1  accasy=1.0d-10, a1rtpi=0.56418958354775629d0, a1=1.0d0,
     2  a2=2.0d0, a4=4.0d0)
      dimension dfac(*)
      dimension tmin(0:8)
      data tmin/31.0d0,28.0d0,25.0d0,23.0d0,22.0d0,20.0d0,19.0d0,
     1  18.0d0,15.0d0/
c
      if(mod(n+l,2).ne.0.or.n.le.l) go to 30
c
c  use alternating series (n+l.le.22.and.l.le.10)
c
      if(l.eq.0) then
        xkp=a1
      else
        xkp=(xk/(alpha+alpha))**l
      endif
      prefac=xkp * dfac(n+l+1)/
     1  ((alpha+alpha)**((n-l)/2) * sqrt(a4*alpha) * dfac(l+l+3))
      num=l-n+2
      xden=(l+l+3)
      term=a1
      sum=term
      xc=am1
   10 if(num.ne.0) then
        fnum=num
        term=term*fnum*t/(xden*xc)
        xc=xc+am1
        sum=sum+term
        num=num+2
        xden=xden+a2
        go to 10
      endif
c
      qcomp=prefac*sum
      return
c
   30 if(t.lt.tmin(min(n,8))) go to 60
c
c  use asymptotic series (arbitrary n,l)
c
      xkp=(xk/(alpha+alpha))**(n-2)
      prefac=xkp/((alpha+alpha)*sqrt(a4*alpha))
      sum=a1
      term=a1
      fac1=(l-n+2)
      fac2=(1-l-n)
      xc=a1
   40 term=term*fac1*fac2/(a4*xc*t)
      if(term.eq.a0) go to 50
      sum=sum+term
      if(abs(term/sum).lt.accasy) go to 50
      fac1=fac1+a2
      fac2=fac2+a2
      xc=xc+a1
      go to 40
   50 qcomp=prefac*sum
      return
c
c  use power series (n+l.le.22.and.l.le.10)
c
   60 if(l.eq.0) then
        xkp=a1
      else
        xkp=(xk/(alpha+alpha))**l
      endif
      prefac=exp(-t)*xkp/(alpha+alpha)**((n-l+1)/2)
      if(mod(n+l,2).eq.0) then
        prefac=prefac/sqrt(a4*alpha)
      else
        prefac=a1rtpi*prefac
      endif
      xnum=(l+n-1)
      xden=(l+l+1)
      term=dfac(l+n+1)/dfac(l+l+3)
      sum=term
      xj=a0
   70 xnum=xnum+a2
      xden=xden+a2
      xj=xj+a1
      term=term*t*xnum/(xj*xden)
      sum=sum+term
      if((term/sum).gt.accpow) go to 70
      qcomp=prefac*sum
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_PTS_Stat()
      use ChoArr, only: IntMap
      Implicit None
#include "cholesky.fh"
#include "choglob.fh"
#include "cho_para_info.fh"
#include "stdalloc.fh"

      Integer iTmp

      If (.NOT.Allocated(IntMap)) Then
         Call mma_allocate(IntMap,nnShl,Label='IntMap')
         iTmp=0
         Call IDAFile(LuMap,2,IntMap,nnShl,iTmp)
      End If

      If (Cho_Real_Par) Then
         Call iSwap(nSym,NumCho,1,NumCho_G,1)
         iTmp = NumChT
         NumChT = NumChT_G
         Call Cho_Stat()
         NumChT = iTmp
         Call iSwap(nSym,NumCho,1,NumCho_G,1)
      Else
         Call Cho_Stat()
      End If

      If (Allocated(IntMap)) Call mma_deallocate(IntMap)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function regge3j(j1,j2,j3,m1,m2,m3)
!bs uses magic square of regge (see Lindner pp. 38-39)
!bs
!bs  ---                                            ---
!bs |                                                  |
!bs | -j1+j2+j3     j1-j2+j3         j1+j2-j3          |
!bs |                                                  |
!bs |                                                  |
!bs |  j1-m1        j2-m2            j3-m3             |
!bs |                                                  |
!bs |                                                  |
!bs |  j1+m1        j2+m2            j3+m3             |
!bs |                                                  |
!bs  ---                                            ---

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: regge3j
integer(kind=iwp), intent(in) :: j1, j2, j3, m1, m2, m3
integer(kind=iwp), parameter :: mxLinRE = 36, nprim = 11
integer(kind=iwp) :: I, ibm, icheck, icoeff, ICOL, icount, Idenom, IDUMMY, IFIRST, imaxi, imini, IROW, ISECOND, Isigma, isgn, &
                     isum, iwork(nprim), J, LIMIT, MAT(3,3)
real(kind=wp) :: down, factor, up
!BS logical(kind=iwp) :: testup,testdown
! decompose factorials into powers of prime numbers
integer(kind=iwp), parameter :: facul(nprim,0:mxLinRE) = reshape([0,0,0,0,0,0,0,0,0,0,0,   &
                                                                  0,0,0,0,0,0,0,0,0,0,0,   &
                                                                  1,0,0,0,0,0,0,0,0,0,0,   &
                                                                  1,1,0,0,0,0,0,0,0,0,0,   &
                                                                  3,1,0,0,0,0,0,0,0,0,0,   &
                                                                  3,1,1,0,0,0,0,0,0,0,0,   &
                                                                  4,2,1,0,0,0,0,0,0,0,0,   &
                                                                  4,2,1,1,0,0,0,0,0,0,0,   &
                                                                  7,2,1,1,0,0,0,0,0,0,0,   &
                                                                  7,4,1,1,0,0,0,0,0,0,0,   &
                                                                  8,4,2,1,0,0,0,0,0,0,0,   &
                                                                  8,4,2,1,1,0,0,0,0,0,0,   &
                                                                  10,5,2,1,1,0,0,0,0,0,0,  &
                                                                  10,5,2,1,1,1,0,0,0,0,0,  &
                                                                  11,5,2,2,1,1,0,0,0,0,0,  &
                                                                  11,6,3,2,1,1,0,0,0,0,0,  &
                                                                  15,6,3,2,1,1,0,0,0,0,0,  &
                                                                  15,6,3,2,1,1,1,0,0,0,0,  &
                                                                  16,8,3,2,1,1,1,0,0,0,0,  &
                                                                  16,8,3,2,1,1,1,1,0,0,0,  &
                                                                  18,8,4,2,1,1,1,1,0,0,0,  &
                                                                  18,9,4,3,1,1,1,1,0,0,0,  &
                                                                  19,9,4,3,2,1,1,1,0,0,0,  &
                                                                  19,9,4,3,2,1,1,1,1,0,0,  &
                                                                  22,10,4,3,2,1,1,1,1,0,0, &
                                                                  22,10,6,3,2,1,1,1,1,0,0, &
                                                                  23,10,6,3,2,2,1,1,1,0,0, &
                                                                  23,13,6,3,2,2,1,1,1,0,0, &
                                                                  25,13,6,4,2,2,1,1,1,0,0, &
                                                                  25,13,6,4,2,2,1,1,1,1,0, &
                                                                  26,14,7,4,2,2,1,1,1,1,0, &
                                                                  26,14,7,4,2,2,1,1,1,1,1, &
                                                                  31,14,7,4,2,2,1,1,1,1,1, &
                                                                  31,15,7,4,3,2,1,1,1,1,1, &
                                                                  32,15,7,4,3,3,1,1,1,1,1, &
                                                                  32,15,8,5,3,3,1,1,1,1,1, &
                                                                  34,17,8,5,3,3,1,1,1,1,1  &
                                                                 ],shape(facul)), &
                                ihigh(0:mxLinRE) = [0,0,1,2,2,3,3,4,4,4,4,5,5,6,6,6,6,7,7,8,8,8,8,9,9,9,9,9,9,10,10,11,11,11,11, &
                                                    11,11], &
                                prim(nprim) = [2,3,5,7,11,13,17,19,23,29,31]        !prime numbers
!bs facul,   integer array (nprim,0:mxLinRE) prime-expansion of factorials
!bs mxLinRE, integer max. number for facul is given
!bs nprim,   number of primes for expansion of factorials
!bs prim,    integer array with the first nprim prime numbers
!bs iwork)   integer array of size nprim

regge3j = Zero
!write(u6,'(A24,6I3)') '3J to be calculated for ',j1,j2,j3,m1,m2,m3
!bs quick check  if =/= 0 at all
icheck = m1+m2+m3
if (icheck /= 0) then
  !write(u6,*) 'sum over m =/= 0'
  return
end if
!bs check triangular relation (|j1-j2|<= j3 <= j1+j2 )
imini = abs(j1-j2)
imaxi = j1+j2
if ((j3 < imini) .or. (j3 > imaxi)) then
  !write(u6,*) 'triangular relation not fulfilled'
  return
end if
!bs quick check  if =/= 0 at all  end
!bs
!bs 3J-symbol is not zero by simple rules
!bs
!bs initialize MAT
MAT(1,1) = -j1+j2+j3
MAT(2,1) = j1-m1
MAT(3,1) = j1+m1
MAT(1,2) = j1-j2+j3
MAT(2,2) = j2-m2
MAT(3,2) = j2+m2
MAT(1,3) = j1+j2-j3
MAT(2,3) = j3-m3
MAT(3,3) = j3+m3
do I=1,3
  do J=1,3
    !bs check for even numbers (2*integer) and positive or zero
    if ((mod(MAT(J,I),2) /= 0) .or. (MAT(J,I) < 0)) then
      !write(u6,*) 'J,I,MAT(J,I): ',J,I,MAT(J,I)
      return
    end if
    MAT(J,I) = MAT(J,I)/2
    if (Mat(j,i) > mxLinRE) call SysAbendMsg('regge3j','increase mxLinRE for regge3j',' ')
  end do
end do
Isigma = (j1+j2+j3)/2
!bs check the magic sums
do I=1,3
  IROW = 0
  ICOL = 0
  do J=1,3
    IROW = IROW+MAT(I,J)
    ICOL = ICOL+MAT(J,I)
  end do
  if ((IROW /= Isigma) .or. (ICOL /= Isigma)) then
    !write(u6,*) 'I,IROW,ICOL ',I,IROW,ICOL
    return
  end if
end do
!bs if j1+j2+j3 is odd: check for equal rows or columns
isgn = 1
if (abs(mod(Isigma,2)) == 1) then
  isgn = -1
  do I=1,3
    do J=I+1,3
      if ((MAT(1,I) == MAT(1,J)) .and. (MAT(2,I) == MAT(2,J)) .and. (MAT(3,I) == MAT(3,J))) return
      if ((MAT(I,1) == MAT(J,1)) .and. (MAT(I,2) == MAT(J,2)) .and. (MAT(I,3) == MAT(J,3))) return
    end do
  end do
end if
!bs look for the lowest element indices: IFIRST,ISECOND
imini = MAT(1,1)
IFIRST = 1
ISECOND = 1
do I=1,3
  do J=1,3
    if (MAT(J,I) < imini) then
      IFIRST = J
      ISECOND = I
      imini = MAT(J,I)
    end if
  end do
end do
!write(u6,*) 'Matrix before commuting vectors'
!do ibm=1,3
!  write(u6,'(3I5)') (Mat(ibm,j),j=1,3)
!end do
if (IFIRST /= 1) then  !interchange rows
  !write(u6,*) 'IFIRST = ',ifirst
  do I=1,3
    IDUMMY = MAT(1,I)
    MAT(1,I) = MAT(IFIRST,I)
    MAT(IFIRST,I) = IDUMMY
  end do
end if
if (ISECOND /= 1) then  !interchange columns
  !write(u6,*) 'ISECOND = ',isecond
  do I=1,3
    IDUMMY = MAT(I,1)
    MAT(I,1) = MAT(I,ISECOND)
    MAT(I,ISECOND) = IDUMMY
  end do
end if
!bs lowest element is now on (1,1)
!write(u6,*) 'Matrix after commuting vectors'
!do ibm=1,3
!  write(u6,'(3I5)') (Mat(ibm,j),j=1,3)
!end do
!bs begin to calculate Sum over s_n
!bs first the simple cases
if (Mat(1,1) == 0) then
  isum = 1
else if (Mat(1,1) == 1) then
  isum = Mat(2,3)*Mat(3,2)-Mat(2,2)*Mat(3,3)
else if (Mat(1,1) == 2) then
  isum = Mat(2,3)*(Mat(2,3)-1)*Mat(3,2)*(Mat(3,2)-1)-2*Mat(2,3)*Mat(3,2)*Mat(2,2)*Mat(3,3)+Mat(2,2)*(Mat(2,2)-1)*Mat(3,3)* &
         (Mat(3,3)-1)
else !  all the cases with Mat(1,1) >= 3
  icoeff = 1
  do ibm=Mat(3,2)-Mat(1,1)+1,Mat(3,2)
    icoeff = icoeff*ibm
  end do
  do ibm=Mat(2,3)-Mat(1,1)+1,Mat(2,3)
    icoeff = icoeff*ibm
  end do
  isum = icoeff
  do icount=1,MAT(1,1)
    icoeff = -icoeff*(Mat(1,1)+1-icount)*(Mat(2,2)+1-icount)*(Mat(3,3)+1-icount)
    Idenom = icount*(Mat(2,3)-Mat(1,1)+icount)*(Mat(3,2)-Mat(1,1)+icount)
    icoeff = icoeff/Idenom
    isum = isum+icoeff
  end do
end if
!bs additional sign from interchanging rows or columns
if (ifirst /= 1) isum = isum*isgn
if (isecond /= 1) isum = isum*isgn
!write(u6,*) 'isum = ',isum
!bs Mat(2,3)+Mat(3,2)
!bs (-)
if (abs(mod((Mat(2,3)+Mat(3,2)),2)) == 1) isum = -isum
!bs final factor
LIMIT = ihigh(max(Mat(1,1),Mat(1,2),Mat(1,3),Mat(2,1),Mat(2,2),Mat(2,3),Mat(3,1),Mat(3,2),Mat(3,3),(Isigma+1)))
do I=1,LIMIT
  iwork(I) = facul(I,Mat(1,2))+facul(I,Mat(2,1))+facul(I,Mat(3,1))+facul(I,Mat(1,3))-facul(I,Mat(1,1))-facul(I,Mat(2,2))- &
             facul(I,Mat(3,3))-facul(I,(Isigma+1))-facul(I,Mat(2,3))-facul(I,Mat(3,2))
end do
!write(u6,*) 'Iwork: ',(iwork(i),i=1,LIMIT)
factor = One
!bs iup = 1
!BS idown = 1
!BS testup = .true.
!BS testdown = .true.
!BS do I=1,LIMIT
!BS   do J=1,iwork(I)
!BS     iup = iup*prim(i)
!BS     if (iup < 0) testup = .false. !check for Integer overflow
!BS   end do
!BS end do
!BS up = real(iup,kind=wp)
!BS if  (.not. testup) then ! if the integers did not run correctly
up = One
do I=1,LIMIT
  do J=1,iwork(I)
    up = up*real(prim(i),kind=wp)
  end do
end do
!BS endif
!BS do I=1,LIMIT
!BS   do J=1,-iwork(I)
!BS     idown = idown*prim(i)
!BS     if (idown < 0) testdown = .false.
!BS   end do
!BS end do
!BS down = real(idown,kind=wp)
!BS if (.not. testdown) then
down = One
do I=1,LIMIT
  do J=1,-iwork(I)
    down = down*real(prim(i),kind=wp)
  end do
end do
!BS endif
!if (.not. (testup .and. testdown)) then
!  write(u6,*) 'j1,j2,j3,m1,m2,m3 ',j1,j2,j3,m1,m2,m3
!  write(u6,*) 'iup,idown ',iup,idown,'up,down ',up,down
!end if
factor = factor*up/down
!bs final result
regge3j = sqrt(factor)*real(isum,kind=wp)

return

end function regge3j

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Giovanni Ghigo                                   *
************************************************************************
      Subroutine MkL1(iSymA,iSymI,iI, numV, LyType,iJy, iAddLx0, SameLx)
************************************************************************
* Author :  Giovanni Ghigo                                             *
*           Lund University, Sweden & Torino University, Italy         *
*           February 2005                                              *
*----------------------------------------------------------------------*
* Purpuse:  Generation of the Cholesky matrix of Inactive(iSymA) for   *
*           occupied iI(iSymI) for numV vectors.                       *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Implicit Integer (i-n)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "cho_tra.fh"
      Logical SameLx

*     Build Lx
      If (iI.LE.nIsh(iSymI)) then
        LxType = 1
        iIx = iI
        nIx = nIsh(iSymI)
      else
        LxType = 7
        iIx = iI - nIsh(iSymI)
        nIx = nAsh(iSymI)
      EndIf
      iAddLx  = iAddLx0

      If (.NOT.SameLx) then
        LyType=LxType
        iJy   =iIx
      else
        If (LyType.EQ.LxType .and. iIx.EQ.iJy) then
          Return
        else
          SameLx=.False.
        EndIf
      EndIf

      iAddTCVX= iMemTCVX(LxType,iSymA,iSymI,1)+nIsh(iSymA)*(iIx-1)
      Do iV=1,numV
        Call dCopy_(nIsh(iSymA),Work(iAddTCVX),1,Work(iAddLx),1)
        iAddTCVX= iAddTCVX +  nIsh(iSymA) * nIx
        iAddLx  = iAddLx + nIsh(iSymA)
      EndDo

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dmxma(n,transa,transb,a,b,c,alpha)
! Square real matrices multiplication

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
character, intent(in) :: transa, transb
real(kind=wp), intent(in) :: a(n,n), b(n,n), alpha
real(kind=wp), intent(out) :: c(n,n)

call dgemm_(transa,transb,n,n,n,alpha,a,n,b,n,Zero,c,n)

return

end subroutine dmxma

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MandatoryInp(YesNo)
      Implicit Real*8 (a-h,o-z)

#include "warnings.fh"

      Logical YesNo(20)

      If(.not.YesNo(8).and..not.YesNo(7)) then
        Write(6,*)
        Write(6,*)' You have not specified what type of calculation'
     &//' this is.'
        Write(6,*)' Use either the RUN keyword or the SINGle-point'
     &//' keyword.'
        Call Quit(_RC_INPUT_ERROR_)
      Endif

      If(YesNo(3).and.YesNo(4)) then
        Write(6,*)
        Write(6,*)' You have specified both a SCFSection and a'
     &//' RASSisection.'
        Write(6,*)' They are mutually exclusive. Remove one.'
        Call Quit(_RC_INPUT_ERROR_)
      Endif

      If(YesNo(7).and..not.YesNo(6)) then
        Write(6,*)
        Write(6,*)' You have requested a single-point calculation, but'
     &//' no input coordinates were given.'
        Write(6,*)' Provide these in the SOLVent section.'
        Call Quit(_RC_INPUT_ERROR_)
      Endif

      If(YesNo(5).and..not.YesNo(6)) then
        Write(6,*)
        Write(6,*)' You have specified that initial coordinates are to'
     &//' be given in input, but no coordinates are found.'
        Write(6,*)' Provide these in the SOLVent section.'
        Call Quit(_RC_INPUT_ERROR_)
      Endif

      If(.not.YesNo(2).and..not.YesNo(7)) then
        Write(6,*)
        Write(6,*)' You fail to specify where from initial'
     &//' configuration should be collected.'
        Write(6,*)' Do this with the CONFiguration keyword.'
        Call Quit(_RC_INPUT_ERROR_)
      Endif

      If(YesNo(9).and..not.YesNo(10)) then
        Write(6,*)
        Write(6,*)' Your file specification implies that an'
     &//' extraction file is to be generated.'
        Write(6,*)' However, you have no EXTRact section.'
        Call Quit(_RC_INPUT_ERROR_)
      Endif

      If(.not.YesNo(9).and.YesNo(10)) then
        Write(6,*)
        Write(6,*)' You have a EXTRact section, but the file to'
     &//' read from is not a sampfile.'
        Write(6,*)' Change this after the FILE keyword.'
        Call Quit(_RC_INPUT_ERROR_)
      Endif

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine undepend2_cvb(chr1,chr2,ic1)

use casvb_global, only: charobj, i_dep_on_j, ioffs, iprint, j_dep_on_i, joffs, mustdeclare, ndep_ij, ndep_ji, nobj
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: chr1, chr2
integer(kind=iwp), intent(in) :: ic1
integer(kind=iwp) :: i, ic, iobj, jobj, m_cancelled, n_cancelled
logical(kind=iwp) :: done

ic = ic1

do
  iobj = 0
  jobj = 0
  do i=1,nobj
    if (charobj(i) == chr1) iobj = i
    if (charobj(i) == chr2) jobj = i
  end do
  if (iobj == 0) then
    if (mustdeclare) then
      write(u6,*) ' Make object not found :',chr1
      call abend_cvb()
    end if
    call decl_cvb(chr1)
  else if (jobj == 0) then
    if (mustdeclare) then
      write(u6,*) ' Make object not found :',chr2
      call abend_cvb()
    end if
    call decl_cvb(chr2)
  else
    exit
  end if
end do

if (iprint >= 10) write(u6,*) ' Cancel I depends on J :',iobj,jobj
n_cancelled = 0
if (mod(ic,2) == 1) then
  do
    done = .false.
    do i=ioffs(iobj)+1,ioffs(iobj+1)
      if (i_dep_on_j(i) == jobj) then
        i_dep_on_j(i:ioffs(nobj+1)-1) = i_dep_on_j(i+1:ioffs(nobj+1))
        ioffs(iobj+1:nobj+1) = ioffs(iobj+1:nobj+1)-1
        n_cancelled = n_cancelled+1
        done = .true.
        exit
      end if
    end do
    if (.not. done) exit
  end do
end if

m_cancelled = 0
if (ic >= 2) then
  do
    done = .false.
    do i=joffs(jobj)+1,joffs(jobj+1)
      if (j_dep_on_i(i) == iobj) then
        j_dep_on_i(i:joffs(nobj+1)-1) = j_dep_on_i(i+1:joffs(nobj+1))
        joffs(jobj+1:nobj+1) = joffs(jobj+1:nobj+1)-1
        m_cancelled = m_cancelled+1
        done = .true.
        exit
      end if
    end do
    if (.not. done) exit
  end do
end if

ndep_ij = ndep_ij-n_cancelled
ndep_ji = ndep_ji-m_cancelled

return

end subroutine undepend2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine CalcVee2(Vee,GD,Gtuvx)

use Index_Functions, only: nTri_Elem
use rasscf_global, only: lRoots, NAC
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Vee(lRoots)
real(kind=wp), intent(in) :: GD(nTri_Elem(lRoots),NAC,NAC), Gtuvx(NAC,NAC,NAC,NAC)
integer(kind=iwp) :: I, III, v, x

Vee(:) = Zero
do I=1,lRoots
  III = nTri_Elem(I)
  do x=1,nac
    do v=1,nac
      Vee(I) = Vee(I)+GD(III,v,x)*sum(GD(III,:,:)*Gtuvx(:,:,v,x))
    end do
  end do
end do
Vee(:) = Half*Vee(:)

end subroutine CalcVee2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Thomas Bondo Pedersen                            *
************************************************************************
      Integer Function Cho_iFindSmallest(iVec,n)
C
C     Thomas Bondo Pedersen, June 2007.
C
C     Return index of smallest element in array iVec.
C
      Implicit None
      Integer n
      Integer iVec(n)

      Integer i, imin

      If (n .lt. 1) Then
         imin = 0
      Else
         imin = n
         Do i = n-1,1,-1
            If (iVec(i) .lt. iVec(imin)) Then
               imin = i
            End If
         End Do
      End If

      Cho_iFindSmallest = imin

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Put_QLast
      use TList_Mod
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
*
      if(.NOT.Allocated(TskQ)) return
c     Call RecPrt('TskQ',' ',TskQ,2,nTasks)
c     Write (*,'(A,2F10.1)') 'Last indices of the task (QLast)=',QLast
c     Write (*,'(A,4I9)') 'iTCnSt_c,nTasks,iTskCan=',
c    &                     iTCnSt_c,nTasks,iTskCan
      TskQ(1,iTskCan) = QLast(1)
      TskQ(2,iTskCan) = QLast(2)
*
      QLast(1)=Not_Used
      QLast(2)=Not_Used
c     Call RecPrt('TskQ',' ',TskQ,2,nTasks)
c     Write (*,*)
c     Call XFlush(6)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine getAOs(lhigh)
      Implicit Real*8 (a-h,o-z)
cbs   get expansions of atomic orbitals in contracted functions
#include "para.fh"
#include "param.fh"
      character*12    occtext,occread
      character*18  textnorbmf,textnorbmf2
      logical EX
      occtext='OCCUPATION: '
      textnorbmf='Number of orbitals'
      Inquire(File='AO-expansion',exist=EX)
      if (.not.EX)  then
CBS      write(6,*) 'get occupations from DATA-block'
         call getAOs2(lhigh)
         return
      endif
      Lu_33=33
      Lu_33=IsFreeUnit(Lu_33)
      call molcas_open(Lu_33,'AO-expansion')
c      open(unit=Lu_33,file='AO-expansion',STATUS='UNKNOWN')
CBS   write(6,*) 'Orbitals for mean-field'
      do lrun=0,lhigh
CBS   write(6,'(A3,I3)') 'L= ',lrun
      read(Lu_33,'(A18,I3)') textnorbmf2,noccorb(lrun)
      if (textnorbmf.ne.textnorbmf2) call SysAbendMsg('getAOs',
     *'wrong keyword for number of orbitals in getAOs',' ')
CBS   write(6,*) 'number of orbitals ',noccorb(lrun)
      do iorbital=1,noccorb(lrun)
      read(Lu_33,'(A12,F5.3)')  occread,occup(iorbital,lrun)
CBS   write(6,'(A,F8.4)') occtext,occup(iorbital,lrun)
      if (occread.ne.occtext) call SysAbendMsg('getAOs',
     & 'error reading AOs',' ')
      read(Lu_33,*) (AOcoeffs(icont,iorbital,lrun),
     *icont=1,ncontrac(lrun))
CBS   write(6,'(8F10.4)') (AOcoeffs(icont,iorbital,lrun),
CBS  *icont=1,ncontrac(lrun))
CBS   write(6,*) ' '
      read(Lu_33,*)
      enddo
      enddo
      close(Lu_33)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine asonc10_cvb( &
#                      define _CALLING_
#                      include "ddasonc_interface.fh"
                      )

use casvb_global, only: cpu0, ipp10, iter10
use Definitions, only: wp, iwp, u6

implicit none
#include "ddasonc_interface.fh"
integer(kind=iwp) :: ivec
real(kind=wp), external :: tim_cvb

#include "macros.fh"
unused_var(sxc)

iter10 = iter10+1
if (ipp10 >= 2) then
  write(u6,'(/,a,i5,a,f10.3,a)') ' Davidson iteration',iter10,' at',tim_cvb(cpu0),' CPU seconds'
  write(u6,'(a)') ' -----------------------------------------------'
end if

axc(:,:) = c(:,:)
do ivec=1,nvec
  call hess_cvb(axc(:,ivec))
  call ddproj_cvb(axc(:,ivec),nprm)
end do

return

end subroutine asonc10_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine depend_cvb(chr1,chr2)

use casvb_global, only: i_dep_on_j, ioffs, iprint, j_dep_on_i, joffs, ndep_ij, ndep_ji, nobj
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: chr1, chr2
integer(kind=iwp) :: ii

call mkafter_cvb(chr1,chr2)
call touchdepend_cvb(chr1,chr2)

if (iprint >= 10) then
  write(u6,*) ' IOFFS :',(ioffs(ii),ii=1,nobj+1)
  write(u6,*) ' JOFFS :',(joffs(ii),ii=1,nobj+1)
  write(u6,*) ' I_DEP_ON_J :',(i_dep_on_j(ii),ii=1,ndep_ij)
  write(u6,*) ' J_DEP_ON_I :',(j_dep_on_i(ii),ii=1,ndep_ji)
end if

return

end subroutine depend_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE DELTAB(NREF,IOCR,L0,L1,L2,L3,INTNUM,LV,IFCORE,
     *ICOR,NONE,JONE,K00,K11,K22,K33,L00,L11,L22,L33)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IOCR(*),L0(*),L1(*),L2(*),L3(*),ICOR(*),JONE(*),
     *K00(*),K11(*),K22(*),K33(*),L00(*),L11(*),L22(*),L33(*)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      DIMENSION IOC(55),ISP(55)
      DIMENSION K0M(MXVERT),K1M(MXVERT),K2M(MXVERT),K3M(MXVERT)
      DIMENSION L0M(MXVERT),L1M(MXVERT),L2M(MXVERT),L3M(MXVERT)
      DO 2 I=1,4*MXVERT
      K0(I)=0
      K1(I)=0
      K2(I)=0
      K3(I)=0
      L0(I)=0
      L1(I)=0
      L2(I)=0
      L3(I)=0
2     CONTINUE
      IBS=0
      IEL=2
      LSYM=1
      LNS=NIORB+LV+1
      IRR=0
      DO 5 I=LNS,LN
      IRR=IRR+1
      IF(IOCR(IRR).EQ.1)LSYM=MUL(LSYM,NSM(I))
5     CONTINUE
      DO 10 IIJ=1,ILIM
      ISTA=(IIJ-1)*MXVERT
      DO 3 I=1,IV0
      K0M(I)=0
      K1M(I)=0
      K2M(I)=0
      K3M(I)=0
      L0M(I)=0
      L1M(I)=0
      L2M(I)=0
      L3M(I)=0
3     CONTINUE
      IJJ=IV0+1-IIJ
      KM=1
      J2(KM)=IJJ
11    KM=KM+1
      IWAY(KM)=0
12    KM1=KM-1
      IF(L00(J2(KM1)).EQ.0.OR.IWAY(KM).GE.1)GO TO 14
      J2(KM)=L00(J2(KM1))
      IWAY(KM)=1
      IOC(KM1)=0
      ISP(KM1)=0
      GO TO 20
14    IF(L11(J2(KM1)).EQ.0.OR.IWAY(KM).GE.2)GO TO 15
      J2(KM)=L11(J2(KM1))
      IWAY(KM)=2
      IOC(KM1)=1
      ISP(KM1)=1
      GO TO 20
15    IF(L22(J2(KM1)).EQ.0.OR.IWAY(KM).GE.3)GO TO 16
      J2(KM)=L22(J2(KM1))
      IWAY(KM)=3
      IOC(KM1)=1
      ISP(KM1)=2
      GO TO 20
16    IF(L33(J2(KM1)).EQ.0.OR.IWAY(KM).GE.4)GO TO 17
      J2(KM)=L33(J2(KM1))
      IWAY(KM)=4
      IOC(KM1)=2
      ISP(KM1)=3
      GO TO 20
17    KM=KM-1
      IF(KM.EQ.1)GO TO 210
      GO TO 12
20    IF(KM1.EQ.NIORB+LV)IBS=IB(J2(KM))
      IF(KM.NE.LN+1)GO TO 11
      NSJ=1
      INHOLE=0
      DO 110 I=1,LN
      IF(IOC(I).EQ.1)NSJ=MUL(NSJ,NSM(I))
      IF(I.LE.NIORB+LV.AND.I.GT.LV)INHOLE=INHOLE+2-IOC(I)
110   CONTINUE
C     STRIKE OUT INTERNAL CONFIGURATIONS
      IPART=0
      IF(IIJ.GT.1)IPART=IPART+1
      IF(IIJ.GT.2)IPART=IPART+1
      JJ1=0
      DO 111 IREF=1,NREF
      JHOLE=0
      JPART=IPART
      DO 112 I=1,LN
      IF(I.GT.LV)GO TO 250
      IDIF=IOC(I)
      GO TO 251
250   IF(I.GT.NIORB+LV)GO TO 252
      IDIF=IOC(I)-2
      GO TO 251
252   JJ1=JJ1+1
      IF(IOC(I).EQ.IOCR(JJ1))GO TO 112
      IDIF=IOC(I)-IOCR(JJ1)
251   IF(IDIF.GT.0)GO TO 114
      JHOLE=JHOLE-IDIF
      GO TO 112
114   JPART=JPART+IDIF
112   CONTINUE
      If (JPART.NE.JHOLE) Then
         Write (6,*) 'DeltaB: JPART.NE.JHOLE'
         Write (6,*) 'JPART,JHOLE=',JPART,JHOLE
         Write (6,*) 'iREF=',iREF
         Call Abend
      End If
      IF(JPART.LE.IEL)GO TO 113
111   CONTINUE
      GO TO 12
113   IF(IPART.EQ.0.AND.NSJ.NE.LSYM)GO TO 12
      IF(IPART.NE.2.OR.INTNUM.EQ.0)GO TO 115
C     INTERACTING SPACE
      IF(INHOLE.EQ.2.AND.IBS.NE.0)GO TO 12
C     NO CORE-CORE CORRELATION
115   IF(IFCORE.EQ.0)GO TO 116
      NCORR=0
      DO 117 I=1,LN
      IF(ICOR(I).EQ.0)GO TO 117
      NCORR=NCORR+2-IOC(I)
117   CONTINUE
      IF(NCORR.GT.1)GO TO 12
C     SINGLY OCCUPIED ORBITALS
116   IF(NONE.EQ.0)GO TO 118
      DO 119 I=1,NONE
      IF(IOC(JONE(I)).NE.1)GO TO 12
119   CONTINUE
118   DO 130 K=1,LN
      IF (ISP(K)-1.LT.0) THEN
         GO TO 131
      ELSE IF (ISP(K)-1.EQ.0) THEN
         GO TO 132
      ELSE
         GO TO 133
      END IF
131   K0M(J2(K+1))=K00(J2(K+1))
      L0M(J2(K))=L00(J2(K))
      GO TO 130
132   K1M(J2(K+1))=K11(J2(K+1))
      L1M(J2(K))=L11(J2(K))
      GO TO 130
133   IF(ISP(K).EQ.3)GO TO 134
      K2M(J2(K+1))=K22(J2(K+1))
      L2M(J2(K))=L22(J2(K))
      GO TO 130
134   K3M(J2(K+1))=K33(J2(K+1))
      L3M(J2(K))=L33(J2(K))
130   CONTINUE
      GO TO 12
210   DO 1 I=1,IV0
      K0(ISTA+I)=K0M(I)
      K1(ISTA+I)=K1M(I)
      K2(ISTA+I)=K2M(I)
      K3(ISTA+I)=K3M(I)
      L0(ISTA+I)=L0M(I)
      L1(ISTA+I)=L1M(I)
      L2(ISTA+I)=L2M(I)
      L3(ISTA+I)=L3M(I)
1     CONTINUE
10    CONTINUE
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine XEIGEN(NVEC,NA,N,A,EVR,EVI,VECS,IERR)
! Computes eigenvalues and optionally (right) eigenvectors of a
! general square matrix

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NVEC, NA, N
real(kind=wp), intent(inout) :: A(NA,N)
real(kind=wp), intent(out) :: EVR(N), EVI(N), VECS(NA,N)
integer(kind=iwp), intent(out) :: IERR
integer(kind=iwp) :: NW
real(kind=wp) :: TMP(1)
character :: JL, JR
real(kind=wp), allocatable :: WRK(:)

JL = 'N'
JR = 'N'
if (NVEC /= 0) JR = 'V'
IERR = 0
call DGEEV_(JL,JR,N,A,NA,EVR,EVI,VECS,NA,VECS,NA,TMP,-1,IERR)
NW = int(TMP(1))
call mma_allocate(WRK,NW)
call DGEEV_(JL,JR,N,A,NA,EVR,EVI,VECS,NA,VECS,NA,WRK,NW,IERR)
call mma_deallocate(WRK)

end subroutine XEIGEN

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Per Ake Malmqvist                                *
!               2018, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Print_CI_Mix(EigVec)

use RefWfn, only: iadr15, refwfn_active, refwfn_close, refwfn_filename, refwfn_id, refwfn_is_h5
use caspt2_module, only: CIThr, nConf, nState, STSym
#ifdef _HDF5_
use mh5, only: mh5_fetch_dset, mh5_open_file_r
use caspt2_module, only: mState
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: EigVec(nState,nState)
integer(kind=iwp) :: iDisk, iiState, iState
#ifdef _HDF5_
integer(kind=iwp) :: jSNum
#endif
logical(kind=iwp) :: Close_refwfn
real(kind=wp), allocatable :: cCI(:), mCI(:)

call mma_allocate(mCI,nConf,Label='MixCICoeff')
call mma_allocate(cCI,nConf,Label='CICoeff')

Close_refwfn = .false.
if (.not. refwfn_active) then
  ! bypass refwfn_open, because we don't want to set global stuff
  if (refwfn_is_h5) then
#   ifdef _HDF5_
    refwfn_id = mh5_open_file_r(refwfn_filename)
#   else
    ! This should never happen
    call AbEnd()
#   endif
  else
    refwfn_id = 15
    call DAName(refwfn_id,refwfn_filename)
  end if
  Close_refwfn = .true.
end if

call CollapseOutput(1,'Mixed CI coefficients:')

write(u6,*)
write(u6,*) ' The original CI arrays are now mixed as linear'
write(u6,*) ' combinations, given by the eigenvectors.'
write(u6,*)

do iState=1,nState
  mCI(:) = Zero
  iDisk = iAdr15(4)
  do iiState=1,nState
    if (refwfn_is_h5) then
#     ifdef _HDF5_
      jSNum = mState(iiState)
      call mh5_fetch_dset(refwfn_id,'CI_VECTORS',cCI,[nConf,1],[0,jSNum-1])
#     else
      ! This should never happen
      call AbEnd()
#     endif
    else
      call dDAFile(refwfn_id,2,cCI,nConf,iDisk)
    end if
    mCI(:) = EigVec(iiState,iState)*cCI(:)
  end do
  write(u6,'(1X,A,I3)') ' The CI coefficients for the MIXED state nr. ',iState
  call PrWf_CP2(stSym,nConf,mCI,CITHR)
end do

call CollapseOutput(0,'Mixed CI coefficients:')
write(u6,*)

if (Close_refwfn) call refwfn_close()

call mma_deallocate(mCI)
call mma_deallocate(cCI)

end subroutine Print_CI_Mix

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003,2020, Roland Lindh                                *
*               2020, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine Con_Opt(r,drdq,T,dEdq,rLambda,q,dq,dy,dx,dEdq_,du,x,
     &                   dEdx,W,GNrm,nWndw,
     &                   Hess,nInter,nIter,
     &                   iOptH,jPrint,Energy,nLambda,
     &                   Err,EMx,RHS,A,nA,
     &                   Beta,Beta_Disp,nFix,iP,
     &                   Step_Trunc,Lbl,
     &                   d2rdq2,nsAtom,
     &                   iOpt_RS,Thr_RS,iter_,
     &                   First_Microiteration)
************************************************************************
*                                                                      *
*     Object: to perform an constrained optimization. The constraints  *
*             are optimized directly as a linear problem in the        *
*             subspace defined by the gradients of the constraints.    *
*             The minimization is performed in the complemental        *
*             subspace with the ordinary routines.                     *
*                                                                      *
*             L(q,l) = E(q) - l^T r(q)                                 *
*                                                                      *
*             Ref:                                                     *
*             "A Reduced-Restricted-Quasi-Newton-Raphson Method for    *
*              Locating and Optimizing Energy Crossing Points Between  *
*              Two Potential Energy Surfaces",                         *
*             J. M. Anglada and J. M. Bofill,                          *
*             J. Comput. Chem., 18, 992-1003 (1997)                    *
*                                                                      *
*             For more details consult:                                *
*             "New General Tools for Constrained Geometry Optimization"*
*             L. De Vico, M. Olivucci, and R. Lindh,                   *
*             JCTC, 1:1029-1037, 2005                                  *
*             doi:10.1021/ct500949                                     *
*                                                                      *
*     Author: Roland Lindh, Dept. of Chemical Physics,                 *
*             University of Lund, SWEDEN                               *
*             July 2003                                                *
************************************************************************
      Use kriging_mod, only: Max_MicroIterations
      use Slapaf_Info, only: MF
      use Slapaf_Parameters, only: IRC, iOptC, CnstWght, StpLbl,
     &                             StpMax, GrdMax, E_Delta
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Integer nInter
      Real*8 r(nLambda,nIter), drdq(nInter,nLambda,nIter),
     &       T(nInter,nInter), dEdq(nInter,nIter),
     &       rLambda(nLambda,nIter+1), q(nInter,nIter+1),
     &       dq(nInter,nIter), dy(nLambda), dx(nInter-nLambda,nIter),
     &       dEdq_(nInter,nIter), du(nInter),
     &       x(nInter-nLambda,nIter+1),
     &       dEdx(nInter-nLambda,nIter),
     &       W(nInter-nLambda,nInter-nLambda),
     &       Hess(nInter,nInter),
     &       Energy(nIter),
     &       Err(nInter,nIter+1), EMx((nIter+1)**2), RHS(nIter+1),
     &       A(nA), d2rdq2(nInter,nInter,nLambda)
      Integer iP(nInter)
      Logical Found, IRC_setup, First_MicroIteration,
     &        Recompute_disp
      Character Step_Trunc*1, Lbl(nInter+nLambda)*8,
     &          StpLbl_Save*8, Step_Trunc_*1
      Real*8, Allocatable:: dq_xy(:), Trans(:), Tmp1(:), Tmp2(:,:)
      Real*8, Allocatable:: RT(:,:), RTInv(:,:), RRR(:,:), RRInv(:,:),
     &                      RR(:,:), Tdy(:), Tr(:), WTr(:),
     &                      Hessian(:,:)
      Character*8, Allocatable :: LblSave(:)
      Real*8, Save:: Beta_Disp_Save=Zero,disp_Save=Zero
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) '****************************************************'
      Write (6,*) '**** Con_Opt: Input data ***************************'
      Write (6,*) '****************************************************'
      Write (6,*)
      Write (6,*) 'iOpt_RS=',iOpt_RS
      Write (6,*)
      Write (6,*) 'First_Microiteration=',First_Microiteration
      Write (6,*)
      Call RecPrt('Con_Opt: Energy',' ',Energy,nIter,1)
      Call RecPrt('Con_Opt: q',' ',q,nInter,nIter)
      Call RecPrt('Con_Opt: dEdq',' ',dEdq,nInter,nIter)
      Call RecPrt('Con_Opt: Hess(in)',' ',Hess,nInter,nInter)
      Call RecPrt('Con_Opt: r',' ',r,nLambda,nIter)
      Do iIter = 1, nIter
         Write (6,*)' iIter=',iIter
         Call RecPrt('Con_Opt: drdq(orig)',' ',drdq(1,1,iIter),
     &               nInter,nLambda)
      End Do
      Do iLambda = 1, nLambda
         Call RecPrt('Con_Opt: d2rdq2(iLambda)',' ',
     &                            d2rdq2(1,1,iLambda),nInter,nInter)
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
      ipTb=1
      ipTti=ipTb+nLambda
*
      yBeta=One
      gBeta=One
      xBeta=One
      dydy_last=Beta
      gg_last=Beta
      dxdx_last=Beta
      Sf=Sqrt(Two)
      dxdx=Zero
      dydy=Zero
      Thr=1.0D-6
      Beta_Disp_Min=1.0D-10
      Call Get_iScalar('iOff_Iter',iOff_Iter)
      Call mma_allocate(dq_xy,nInter,Label='dq_xy')
      Call mma_allocate(Hessian,nInter,nInter,Label='Hessian')
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      iSt=Max(iOff_Iter+1,nIter-nWndw+1)
      Do iIter = iSt, nIter
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*) '>>>>>> iIter=',iIter
         Write (6,*)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*------- Compute the lambda values (Eqn. 17)
*
*        dEdq=drdq l ; from  h(q_0,l)=dEdq - drdq l = 0
*
*        drdq^T dEdq= (drdq^T drdq) l
*
*        l =  (drdq^T drdq)^{-1} drdq^T dEdq
*
         Call mma_allocate(RRR,nLambda,nInter,Label='RRR')
         Call mma_allocate(RRInv,nLambda,nLambda,Label='RRInv')
         Call mma_allocate(RR,nLambda,nLambda,Label='RR')
*
*        drdq^T drdq
*
         Call DGEMM_('T','N',nLambda,nLambda,nInter,
     &               One,drdq(1,1,iIter),nInter,
     &                   drdq(1,1,iIter),nInter,
     &               Zero,RR,nLambda)
*
*        (drdq^T drdq)^{-1}
*
         Call MInv(RR,RRInv,iSing,Det,nLambda)
         Call mma_deallocate(RR)
*
*        (drdq^T drdq)^{-1} drdq^T
*
         Call DGEMM_('N','T',nLambda,nInter,nLambda,
     &               One,RRInv,nLambda,
     &                   drdq(1,1,iIter),nInter,
     &               Zero,RRR,nLambda)
         Call mma_deallocate(RRInv)
*
*        l = (T_b^T drdq)^{-1} drdq^T dEdq
*
*        Note the sign conflict due to dEdq stored as a force.
*
         Call DGEMM_('N','N',nLambda,1,nInter,
     &               -One,RRR,nLambda,    ! Sign conflict
     &                    dEdq(1,iIter),nInter,
     &               Zero,rLambda(1,iIter),nLambda)
         Call mma_deallocate(RRR)
#ifdef _DEBUGPRINT_
         Call RecPrt('rLambda(iIter)',' ',rLambda(1,iIter),nLambda,1)
#endif
      End Do
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Do iIter = iSt, nIter
*     Do iIter = iOff_Iter+1, nIter
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*) '>>>>>> iIter=',iIter
         Write (6,*)
#endif
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- If we have that the derivative of the constraint is a null
*        vector replace it with an arbitrary vector which is orthogonal
*        to the gradient.
*
*        In case of the first macro iteration of an IRC search replace
*        it with the reaction vector.
*
         Do iLambda = 1, nLambda
            RR_=Sqrt(DDot_(nInter,drdq(1,iLambda,iIter),1,
     &                          drdq(1,iLambda,iIter),1))
*
*           Make sure that we don't mess up gradients which are zero vectors.
*
            If ( RR_.lt.1.0D-12 ) Then
*           If ( RR_.lt.1.0D-12 .and.
*    &           Abs(r(iLambda,iIter)).gt.1.0D-12 ) Then
*
               xBeta = xBeta*Half
*
               If (Abs(IRC).ne.0) Then
                  iMEP=0
                  Call Qpg_iScalar('nMEP',Found)
                  If (Found) Call Get_iScalar('nMEP',iMEP)
                  IRC_Setup=iIter.eq.1.and.iMEP.eq.0
               Else
                  IRC_Setup=.False.
               End If
*
               If (iIter.eq.nIter) Then
*
                  Write (6,*) 'Warning: constraint ',iLambda,
     &                        ' has a null vector, I''ll fix it!'
*
                  If (IRC_Setup.and.IRC.eq.1) Then
                     Write (6,*) ' IRC forward direction.'
                  Else If (IRC_Setup.and.IRC.eq.-1) Then
                     Write (6,*) ' IRC backward direction.'
                  End If
               End If
               r(iLambda,iIter)=Zero
*
               If (IRC_SetUp) Call ReacQ(MF,3*nsAtom,dEdq(1,iIter),
     &                                   nInter)
*
*              Try to use the transverse direction if the gradient is
*              too small
*
               RR_=Sqrt(DDot_(nInter,dEdq(1,iIter),1,dEdq(1,iIter),1))
               If (RR_.lt.1.0D-12) Then
                  Call qpg_dArray('Transverse',Found,nTrans)
                  If (Found.and.(nTrans.eq.3*nsAtom)) Then
                     Call mma_Allocate(Trans,3*nsAtom,Label='Trans')
                     Call Get_dArray('Transverse',Trans,nTrans)
                     Call ReacQ(Trans,3*nsAtom,dEdq(1,iIter),nInter)
                     RR_=Sqrt(DDot_(nInter,dEdq(1,iIter),1,
     &                                   dEdq(1,iIter),1))
                     Call DScal_(nInter,One/RR_,dEdq(1,iIter),1)
                     Call mma_deallocate(Trans)
                  End If
               Else
                  Call DScal_(nInter,One/RR_,dEdq(1,iIter),1)
               End If
*
               Do iInter = 1, nInter
c                 drdq(iInter,iLambda,iIter) =
c    &              dEdq(iInter,iIter)
                  drdq(iInter,iLambda,iIter) =
     &              Sign(One,dEdq(iInter,iIter))
                  If (Abs(dEdq(iInter,iIter)).le.1.0D-6)
     &               drdq(iInter,iLambda,iIter) = Zero
               End Do
#ifdef _DEBUGPRINT_
               Call RecPrt('Con_Opt: drdq(1)',' ',drdq,nInter,
     &                                            nLambda*nIter)
#endif
*
*------------- Orthogonalize against the gradient and all other
*              constraints
*
               RG=DDot_(nInter,drdq(1,iLambda,iIter),1,
     &                        dEdq(1,        iIter),1)
               Call DaXpY_(nInter,-RG,dEdq(1,        iIter),1,
     &                                drdq(1,iLambda,iIter),1)
               RR_=Sqrt(DDot_(nInter,drdq(1,iLambda,iIter),1,
     &                             drdq(1,iLambda,iIter),1))
C              Call DScal_(nInter,One/RR_,drdq(1,iLambda,iIter),1)
               Do jLambda = 1, nLambda
                  If (jLambda.ne.iLambda) Then
                     RG=DDot_(nInter,drdq(1,iLambda,iIter),1,
     &                              drdq(1,jLambda,iIter),1)
                     Call DaXpY_(nInter,-RG,drdq(1,jLambda,iIter),1,
     &                                     drdq(1,iLambda,iIter),1)
                     RR_=Sqrt(DDot_(nInter,drdq(1,iLambda,iIter),1,
     &                                   drdq(1,iLambda,iIter),1))
                     Call DScal_(nInter,One/RR_,drdq(1,iLambda,iIter),1)
                  End If
               End Do
*
#ifdef _DEBUGPRINT_
               Call RecPrt('Con_Opt; drdq(2)',' ',drdq,nInter,
     &                                            nLambda*nIter)
#endif
            End If
         End Do
************************************************************************
*                                                                      *
*        NOTE: for historical reasons the code stores the force rather *
*              than the gradient. Hence, be careful of the sign when   *
*              ever the term dEdq, dEdq_h show up.                     *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- Set up the T-matrix which separates the space into the
*        subspace in which the constraint is accomplished and
*        the complemental subspace.
*
*        [T_b,T_{ti}]
*
*        With the properties
*
*        drdq^T T_b =/= 0 (but not = 1, see note below)
*
*        drdq^T T_{ti} = T_b^T T_{ti} = 0
*
*        T_{ti}^T T_{ti} = 1
*
         Call GS(drdq(1,1,iIter),nLambda,T,nInter,.False.,.False.)
#ifdef _DEBUGPRINT_
         Call RecPrt('Con_Opt: T-Matrix',' ',T,nInter,nInter)
         Call RecPrt('Con_Opt: T_b',' ',T(1,ipTB),nInter,nLambda)
         Call RecPrt('Con_Opt: T_ti',' ',T(1,ipTti),nInter,
     &                                              nInter-nLambda)
#endif
*                                                                      *
*       Note that the paper by Anglada and Bofill has some errors on   *
*       the properties of T. Especially with respect to the properties *
*       of T_b.                                                        *
*                                                                      *
************************************************************************
*                                                                      *
*------- Compute delta y  (Eqn. 11) -- in case of full relaxation --
*
*        r(q)+drdq^T dq=0
*
*        dq = [T_b, T_{ti}] (dy,dx)^T
*
*        r(q) = - drdq^T T_b dy - drdq^T T_{ti} dx
*
*        r(q) = - drdq^T T_b dy
*
*        dy = - (drdq^T T_b)^{-1} r(q)
*
         Call mma_Allocate(RTInv,nLambda,nLambda,Label='RTInv')
         Call mma_Allocate(RT   ,nLambda,nLambda,Label='RT   ')
*
*        drdq^T T_b
*
         Call DGEMM_('T','N',nLambda,nLambda,nInter,
     &               One,drdq(1,1,iIter),nInter,
     &                   T(1,ipTb),nInter,
     &               Zero,RT,nLambda)
#ifdef _DEBUGPRINT_
         Call RecPrt('Con_Opt: RT',' ',RT,nLambda,nLambda)
#endif
*
         Call MInv(RT,RTInv,iSing,Det,nLambda)
         Call mma_deallocate(RT)
#ifdef _DEBUGPRINT_
         Call RecPrt('Con_Opt: RTInv',' ',RTInv,nLambda,nLambda)
#endif
*
*        dy = - (drdq^T T_b)^{-1} r(q)
*
         Call DGEMM_('N','N',nLambda,1,nLambda,
     &               -One,RTInv,nLambda,
     &                    r(1,iIter),nLambda,
     &               Zero,dy,nLambda)
         Call mma_deallocate(RTInv)
#ifdef _DEBUGPRINT_
         Call RecPrt('Con_Opt: dy(full)',' ',dy,nLambda,1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        Add contributions from constraints according to the last
*        iterations. See Eqn. 7,
*
*        The Hessian of the Lagrangian expressed in the full space.
*
*        W^0 = H^0 - Sum(i) l_{0,i} d2rdq2(q_0)
         If (iOpt_RS.eq.0) Then
            Hessian(:,:) = Hess(:,:)
            If (iIter.eq.nIter) Then
               Do iLambda = 1, nLambda
                  Call DaXpY_(nInter**2,-rLambda(iLambda,iIter),
     &                                  d2rdq2(1,1,iLambda),1,Hessian,1)
               End Do
            End If
         Else
            Call Hessian_Kriging_Layer(q(1,iIter),Hessian,nInter)
            Do iLambda = 1, nLambda
               Call DaXpY_(nInter**2,-rLambda(iLambda,iIter),
     &                               d2rdq2(1,1,iLambda),1,Hessian,1)
            End Do
         End If
#ifdef _DEBUGPRINT_
         Call RecPrt('W',' ',Hessian,nInter,nInter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*------- Transform various vectors and matrices to the nInter-nLambda
*        subspace. See Eqn. 10 and text following.
*
*------- Compute x, the coordinates of the reduced space.
*
         If (nInter-nLambda.gt.0) Then
*
*           q = T_b y + T_{ti} x = T [y,x]^T
*
*           x = T_{ti}^T q, since T_{ti}^T T_b = 0
*
            Call DGEMM_('T','N',nInter-nLambda,1,nInter,
     &                  One,T(1,ipTti),nInter,
     &                      q(1,iIter),nInter,
     &                  Zero,x(1,iIter),nInter-nLambda)
*
*---------- Compute dx
*
*           dx = T_{ti}^T dq
*
            Call DGEMM_('T','N',nInter-nLambda,1,nInter,
     &                  One,T(1,ipTti),nInter,
     &                      dq(1,iIter),nInter,
     &                  Zero,dx(1,iIter),nInter-nLambda)
*
*           Compute step restriction based on information from the
*           minimization in the x subspace. This restriction is based
*           on the step length in the x subspace.
*
            If (iIter.ne.nIter) Then
*
*              Compute dq step in the x subspace
*
*              du = [0,dx]^T
*
*              dq = T [0,dx]^T
*
               du(:)=Zero
               call dcopy_(nInter-nLambda,dx(1,iIter),1,du(1+nLambda),1)
               Call Backtrans_T(du,dq_xy)
               dxdx=Sqrt(DDot_(nInter,dq_xy,1,dq_xy,1))
*              dxdx=Sqrt(DDot_(nInter-nLambda,dx(1,iIter),1,
*    &                                        dx(1,iIter),1))
*
               If (dxdx.lt.0.75D0*dxdx_last.and.
     &             dxdx.lt.(Beta-Thr)) Then
*                 Increase trust radius
                  xBeta=Min(One,xBeta*Sf)
C                 xBeta=xBeta*Sf
C
C
               Else If (dxdx.gt.1.25D0*dxdx_last.or.
     &                  dxdx.ge.(Beta+Thr)) Then
*                 Reduce trust radius
                  xBeta=Max(One/Five,xBeta/Sf)
               End If
               dxdx_last=dxdx
C              Write (6,*) 'dxdx=',dxdx
C              Write (6,*) 'xBeta=',xBeta
            End If
*                                                                      *
************************************************************************
*                                                                      *
*---------- Compute the reduced gradient, observe again that we store
*           the forces rather than the gradients.
*
*           See text after Eqn. 13.
*
*           dEdx = T_{ti}^T (dEdq + W_{ex}T_b dy)
*
            Call mma_allocate(Tmp1,nInter,Label='Tmp1')
            Call mma_allocate(Tmp2,nInter,nLambda,Label='Tmp2')
*
#ifdef _DEBUGPRINT_
            Call RecPrt('Con_Opt: dEdq',' ',dEdq(1,iIter),1,nInter)
            Call RecPrt('Con_Opt: W',' ',Hessian,nInter,nInter)
            Call RecPrt('Con_Opt: T',' ',T,nInter,nInter)
            Write (6,*) 'ipTb,ipTti=',ipTb,ipTti
            Call RecPrt('Con_Opt: dy',' ',dy,1,nLambda)
#endif
*
*           W_{ex} T_b
*
            Call DGEMM_('N','N',nInter,nLambda,nInter,
     &                  One,Hessian,nInter,
     &                      T(1,ipTb),nInter,
     &                  Zero,Tmp2,nInter)
#ifdef _DEBUGPRINT_
            Call RecPrt('W_{ex} T_b',' ',Tmp2,nInter,nLambda)
#endif
*
*           dEdq + W_{ex} T_b dy
*
*           Since we are computing the force we have the conflicting
*           sign below.
*
            Tmp1(:)=dEdq(:,iIter)
            Call DGEMM_('N','N',nInter,1,nLambda,
     &                  -One,Tmp2,nInter,   ! Sign conflict
     &                       dy,nLambda,
     &                  One,Tmp1,nInter)
            Call mma_deallocate(Tmp2)
#ifdef _DEBUGPRINT_
            Call RecPrt('dEdq + W_{ex} T_b dy',' ',Tmp1,1,nInter)
#endif
*
*           dEdx = T^t_{ti} (dEdq + W_{ex} T_b dy)
*
            Call DGEMM_('T','N',nInter-nLambda,1,nInter,
     &                  One,T(1,ipTti),nInter,
     &                      Tmp1,nInter,
     &                  Zero,dEdx(1,iIter),nInter-nLambda)
#ifdef _DEBUGPRINT_
            Write (6,*) 'iIter=',iIter
            Call RecPrt('dEdx(1,iIter)',' ',dEdx(1,iIter),1,
     &                  nInter-nLambda)
#endif
            Call mma_deallocate(Tmp1)
*
*           Compute step restriction based on information from the
*           minimization in the x subspace. This restriction is based
*           on the gradient in the x subspace.
*
            gg=Sqrt(DDot_(nInter-nLambda,dEdx(1,iIter),1,
     &                                   dEdx(1,iIter),1))
            If (gg.lt.0.75D0*gg_last.and.gg.lt.(Beta-Thr)) Then
*              Increase trust radius
               gBeta=Min(One,gBeta*Sf)
C              gBeta=gBeta*Sf
            Else If (gg.gt.1.25D0*gg_last.or.gg.ge.(Beta+Thr)) Then
*              Reduce trust radius
               gBeta=Max(One/Five,gBeta/Sf)
            End If
            gg_last=gg
C           Write (6,*) 'gg=',gg
C           Write (6,*) 'gBeta=',gBeta
*
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- Add contributions to the Lagrangian energy change
*
         If (iIter.eq.nIter) Then
*
*---------- Term due to constraint
*
            Call mma_allocate(Tmp1,nLambda,Label='Tmp1')
            Call mma_allocate(Tdy,nInter,Label='Tdy')
*
*           T_b dy
*
            Call DGEMM_('N','N',nInter,1,nLambda,
     &                  One,T(1,ipTb),nInter,
     &                      dy,nLambda,
     &                  Zero,Tdy,nInter)
*
*           drdq^T dq = drdq^T T_b dy
*
            Call DGEMM_('T','N',nLambda,1,nInter,
     &                  One,drdq(1,1,iIter),nInter,
     &                      Tdy,nInter,
     &                  Zero,Tmp1,nLambda)
            Call mma_deallocate(Tdy)
*
*           r + drdq^T dq
*
            Call DaXpY_(nLambda,One,r(1,iIter),1,Tmp1,1)
*
*           l^T (r + drdq^T dq)
*
            E_Delta = E_Delta
     &              - DDot_(nLambda,rLambda(1,iIter),1,Tmp1,1)
            Call mma_deallocate(Tmp1)
*
*---------- Term due to coupling
*
            Call mma_allocate(Tr,nInter,Label='Tr')
*
*           T_b dy
*
            Call DGEMM_('N','N',nInter,1,nLambda,
     &                  One,T(1,ipTb),nInter,
     &                      dy,nLambda,
     &                  Zero,Tr,nInter)
*
*           dEdq^T T_b dy
*
*           Note the sign conflict.
*
            E_Delta = E_Delta - DDot_(nInter,Tr,1,dEdq,1)
*
            Call mma_allocate(WTr,nInter,Label='WTr')
*
*           W T_b dy
*
            Call DGEMM_('N','N',nInter,1,nInter,
     &                  One,Hessian,nInter,
     &                      Tr,nInter,
     &                  Zero,WTr,nInter)
*
*            dy^T T_b^T W T_b dy
            E_Delta = E_Delta + Half * DDot_(nInter,Tr,1,WTr,1)
            Call mma_deallocate(WTr)
            Call mma_deallocate(Tr)
         End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- Restrict actual step, dy
*
*        Step in direction which fulfills the restriction is given
*        priority. This step is only reduced if it is larger than
*        half the overall step restriction.
*
         If (iOpt_RS.eq.0) Then
*
*           Compute dq step in the y subspace
*
*           dq_y = T [dy, 0]^T

            du(:)=Zero
            du(1:nLambda)=dy(:)
            Call Backtrans_T(du,dq_xy)
            dydy=Sqrt(DDot_(nInter,dq_xy,1,dq_xy,1))
*
*
*           Reduce y step size if larger than some maximum size
*           (the x step or half the total max step times a factor)
*
            dydymax=CnstWght*max(dxdx,Half*Beta)
            If (dydy.gt.dydymax) Then
*              Write (6,*) 'Reduce dydy!',dydy,' -> ',dydymax
               dy(:) = (dydymax/dydy) * dy(:)
*              Write(6,*) 'Factor=',(dydymax/dydy)
               dydy=dydymax
               Step_Trunc='*'
            Else
*              Write (6,*) 'No reduce dydy!',dydy,' < ',dydymax
               Step_Trunc=' '
            End If
*
*           The step reduction in the space which we minimize is such
*           that while the fulfillment of the constraint is not
*           improving from step to step we reduce the step length in
*           the subspace in which we do the minimization.

            If (dydy.lt.0.75D0*dydy_last.or.dydy.lt.1.0D-2) Then
*------------- Recent step in the space for the restriction is smaller
*              than the previous, or the recent step is smaller than
*              some threshold. Then increase step length for x, however
*              not more than the overall step restriction.
               yBeta=Min(Two,yBeta*Sf)
            Else If (dydy.gt.1.25D0*dydy_last.and.dydy.ge.1.0D-5) Then
*              Otherwise decrease step direction.
               yBeta=Max(One/Ten,yBeta/Sf)
            End If
*                                                                      *
************************************************************************
*                                                                      *
         Else
*                                                                      *
************************************************************************
*                                                                      *
*           Here in the case of kriging and restricted-variance
*           optimization.
*
*           We only need this for the last point.
*
            Fact=One
            If (iIter.ne.nIter) Go to 667
*
            tmp=Zero
            Do i = 1, nLambda
               Do j = 1, nInter
                  tmp = Max(tmp,Abs(drdq(j,i,iIter)))
               End Do
            End Do
            tmp=Min(tmp,0.30D0) ! Some constraints can have huge
                                ! gradients. So be a bit careful.
*           Allowed dispersion in the y subspace
            Beta_Disp_=Max(Beta_Disp_Min,
     &                     tmp*CnstWght/(CnstWght+One)*Beta_Disp)
            If (.Not.First_MicroIteration) Then
               Beta_Disp_=Min(disp_Save+Beta_Disp_,Beta_Disp_Save)
            End If
*
#ifdef _DEBUGPRINT_
            Write (6,*) 'Step_trunc=',Step_trunc
            Write (6,*) 'Beta_Disp_=',Beta_Disp_
            Write (6,*) 'Start: dy(:)=',dy(:)
#endif
*
            If (disp_Save/Beta_Disp_.gt.0.99D0) Go To 667
            dydy=DDot_(nLambda,dy,1,dy,1)
            If (dydy.lt.1.0D-12) Go To 667
*           Restrict dy step during micro iterations
            Fact=Max(Sqrt(dydy)/(CnstWght/(CnstWght+One)*Beta),One)
*
            iCount=1
            iCount_Max=100
            If (Step_Trunc.eq.'N') Step_Trunc=' '
 666        Continue
               du(1:nLambda)=(One/Fact)*dy(:)
               du(1+nLambda:nInter)=Zero
               Call Backtrans_T(du,dq_xy)
               q(:,iIter+1)=q(:,iIter)+dq_xy(:)
*
               Call Dispersion_Kriging_Layer(q(1,iIter+1),disp,nInter)
*
               If (iCount.eq.1) Then
                  Fact_long=Fact
                  disp_long=disp
                  Fact_short=Zero
                  disp_short=disp_long+One
               End If
#ifdef _DEBUGPRINT_
               Write (6,*) 'disp,Fact,iCount=', disp,Fact,iCount
#endif
               If (disp.gt.Beta_Disp_ .or. iCount.gt.1) Then
                  If (Abs(Beta_Disp_-disp).lt.Thr_RS) Go To 667
                  iCount=iCount+1
                  If (iCount.gt.iCount_Max) Then
                     Write (6,*) 'iCount.gt.iCount_Max'
                     Call Abend()
                  End If
                  Call Find_RFO_Root(Fact_long,disp_long,
     &                               Fact_short,disp_short,
     &                               Fact,disp,Beta_Disp_)
                  Step_Trunc='*'
                  Go To 666
               End If
 667        Continue
            dy(:)=(One/Fact)*dy(:)
#ifdef _FindTS_
*
*           If a FindTS optimization hold back a bit. The purpose of
*           the constrained optimization phase is actually not to
*           find the constrained structure.
*
            If (iAnd(iOptC,4096).eq.4096) Then
               dydy=DDot_(nLambda,dy,1,dy,1)
               Thrdy=0.075D0
               If (dydy.gt.Thrdy**2) Then
                  dy(:) = (Thrdy/Sqrt(dydy)) * dy(:)
                  Step_Trunc='*'
               End If
            End If
#endif
#ifdef _DEBUGPRINT_
            Write (6,*) 'Step_trunc=',Step_trunc
            Write (6,*) 'Final: dy(:)=',dy(:)
#endif
*
*                                                                      *
************************************************************************
*                                                                      *
         End If
*                                                                      *
************************************************************************
*                                                                      *
*        Twist for MEP optimizations.
*
         If (iIter.eq.iOff_iter+1 .and. dydy.lt.1.0D-4
     &       .and. iIter.ne.1) xBeta=xBeta*Half
         dydy_last=dydy
*
#ifdef _DEBUGPRINT_
         Call RecPrt('Con_Opt: dy(actual)',' ',dy,nLambda,1)
#endif
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      End Do ! Do iIter = iSt, nIter
*
************************************************************************
************************************************************************
*                                                                      *
*
#ifdef _DEBUGPRINT_
      Call RecPrt('Con_Opt: dEdx',' ',dEdx,nInter-nLambda,nIter)
      Call RecPrt('Con_Opt: Lambda',' ',rLambda,nLambda,nIter)
      Call RecPrt('Con_Opt: x',' ',x,nInter-nLambda,nIter)
      Call RecPrt('Con_Opt: dx',' ',dx,nInter-nLambda,nIter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the h vectors.   (Eqn. 16)
*
*     h(q,l) = dEdq - drdq l_0^T
*
*     Note the sign conflict due to storage of the force rather than the
*     gradient.
#ifdef _DEBUGPRINT_
      Call RecPrt('Con_Opt: dEdq',' ',dEdq,nInter,nIter)
#endif
      dEdq_(:,:) = dEdq(:,:)
      Do iIter = iOff_iter+1, nIter
         Do iLambda = 1, nLambda
            Call DaXpY_(nInter,rLambda(iLambda,nIter),   ! Sign conflict
     &                          drdq(1,iLambda,iIter),1,
     &                          dEdq_(1,iIter),1)
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Con_Opt: dEdq_',' ',dEdq_,nInter,nIter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the value of the Lagrangian
*
*     L = E + l r(q)
*
      Do iIter = iOff_iter+1, nIter
         Temp = Energy(iIter)
         Do iLambda = 1, nLambda
            Temp = Temp + rLambda(iLambda,iIter)*r(iLambda,iIter)
         End Do
         Energy(iIter)=Temp
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Con_Opt: Lagrangian',' ',Energy,nIter,1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Update the Hessian in the m subspace
*     There should be no negative eigenvalue, if so change the sign.
*
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*)
      Write (6,*) ' *** Updating the reduced Hessian ***'
      Write (6,*)
#endif
*
      If (iAnd(iOptC,4096).eq.4096) Then
*
*        If FINDTS option force minimization option during
*        the Hessian update.
*
         iOptC_Temp=128
      Else
         iOptC_Temp=iOptC
      End If
*
      Dummy = Zero
#ifdef _DEBUGPRINT_
      Call RecPrt('Con_Opt: Hessian(raw)',' ',Hessian,nInter,nInter)
      Write (6,*) 'iOptH=',iOptH
#endif
      If (Step_Trunc.eq.'N') Step_Trunc=' '
      Call Update_H(nWndw,Hessian,nInter,
     &              nIter,iOptC_Temp,
     &              dq,dEdq_,iOptH,
     &              jPrint,Dummy,nsAtom,.False.,.False.)

#ifdef _DEBUGPRINT_
      Call RecPrt('Con_Opt: Hessian(updated)',' ',Hessian,nInter,nInter)
      Write (6,*) 'Step_Trunc=',Step_trunc
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the reduced Hessian
*
*     See text after Eqn. 13.
*
*     T_{ti}^T W T_{ti}
*
      If (nInter-nLambda.gt.0) Then
*
         Call mma_allocate(Tmp2,nInter-nLambda,nInter,Label='Tmp2')
         Call DGEMM_('T','N',nInter-nLambda,nInter,nInter,
     &               One,T(1,ipTti),nInter,
     &                   Hessian,nInter,
     &               Zero,Tmp2,nInter-nLambda)
         Call DGEMM_('N','N',nInter-nLambda,nInter-nLambda,nInter,
     &               One,Tmp2,nInter-nLambda,
     &                   T(1,ipTti),nInter,
     &               Zero,W,nInter-nLambda)
         Call mma_deallocate(Tmp2)
#ifdef _DEBUGPRINT_
         Call RecPrt('Con_Opt: W',' ',W,nInter-nLambda,nInter-nLambda)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*----    Update dx
*
*        Set threshold depending on if restriction is w.r.t. step-size
*        or variance.
*
         If (iOpt_RS.eq.0) Then
            Beta_Disp_= One ! Dummy assign
         Else
*
*           Note that we use the dEdx data for the last point on the
*           real PES.
*
#ifdef _DEBUGPRINT_
            Write (6,*) 'Beta_Disp_=',Beta_Disp_
#endif
            tmp=Zero
            Do i = 1, nInter-nLambda
               tmp = Max(tmp,Abs(dEdx(i,iter_)))
            End Do
*           Add the allowed dispersion in the x subspace.
            If (First_MicroIteration) Then
               Beta_Disp_Save=Max(Beta_Disp_+tmp*Beta_Disp,
     &                            Beta_Disp_Min)
            End If
            Beta_Disp_=Beta_Disp_Save
#ifdef _DEBUGPRINT_
            Write (6,*) 'tmp,Beta_Disp_=',tmp,Beta_Disp_
#endif
         End If
*                                                                      *
************************************************************************
*                                                                      *
*------- Compute updated geometry in internal coordinates
*
         fact=One
         tBeta= Max(Beta*yBeta*Min(xBeta,gBeta),Beta/Ten)
         Thr_RS=1.0D-7
#ifdef _DEBUGPRINT_
         Write (6,*) 'Step_Trunc(0)=',Step_Trunc
#endif
         Do
            Step_Trunc_=Step_Trunc
            Call Newq(x,nInter-nLambda,nIter,dx,W,dEdx,Err,EMx,
     &                RHS,A,nA,tBeta,nFix,ip,Energy,Step_Trunc_,
     &                Thr_RS)
            If (Step_Trunc.eq.'N') Step_Trunc=' '
            If (iOpt_RS.eq.0) Then
               If (Step_Trunc_.eq.'N') Step_Trunc_=' '
               Step_Trunc=Step_Trunc_
               Exit
            End If
            If (Step_Trunc//Step_Trunc_.eq.' *') Step_Trunc='.'
*
            du(1:nLambda)=dy(:)
            du(1+nLambda:nInter)=dx(:,nIter)
            Call Backtrans_T(du,dq_xy)
            q(:,nIter+1)=q(:,nIter)+dq_xy(:)
*
            Call Dispersion_Kriging_Layer(q(1,nIter+1),disp,nInter)
            disp_Save=disp
#ifdef _DEBUGPRINT_
            Write (6,*) 'disp=',disp
#endif
            fact=Half*fact
            tBeta=Half*tBeta
            If (One-disp/Beta_Disp_.gt.1.0D-3) Exit
            If ((fact.lt.1.0D-5) .or. (disp.lt.Beta_Disp_)) Exit
            Step_Trunc='*'
         End Do
#ifdef _DEBUGPRINT_
         Write (6,*) 'Step_Trunc(n)=',Step_Trunc
#endif
         GNrm=
     &    Sqrt(DDot_(nInter-nLambda,dEdx(1,nIter),1,dEdx(1,nIter),1))
*
      Else
*        Negative norm should serve as sign that there is no gradient
         GNrm=-One
      End If
*
#ifdef _DEBUGPRINT_
      Write (6,*) 'Step_Trunc=',Step_trunc
      Call RecPrt('Con_Opt: dx',' ',dx,nInter-nLambda,nIter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Back transform dy and dx to dq.
*
*     See Eqn. 10.
*
#ifdef _DEBUGPRINT_
*
*     dy only, constraint
*
      du(:)=Zero
      du(1:nLambda)=dy(:)
      Call Backtrans_T(du,dq_xy)
      dydy=Sqrt(DDot_(nInter,dq,1,dq,1))
      Call RecPrt('dq(dy)',' ',dq,nInter,nIter)
      Write (6,*) '<R(q_0)|dy>=',DDot_(nInter,
     &              dRdq(1,1,nIter),1,dq(1,nIter),1)
*
*     dx only, constrained minimization
*
      du(:)=Zero
      du(nLambda+1:nInter)=dx(:,nIter)
      Call Backtrans_T(du,dq_xy)
      dxdx=Sqrt(DDot_(nInter,dq,1,dq,1))
      Call RecPrt('dq(dx)',' ',dq,nInter,nIter)
      Write (6,*) '<R(q_0)|dx>=',DDot_(nInter,
     &              dRdq(1,1,nIter),1,dq(1,nIter),1)
#endif
*
*     dy+dx, full step
*
*     dq = T [dy, dx]
*
      du(:)=Zero
      du(1:nLambda)=dy(1:nLambda)
      du(1+nLambda:nInter)=dx(:,nIter)
*     For kriging, in the last 10 micro iterations, give up trying to
*     optimize and just focus on fulfilling the constraints.
      Recompute_disp=.False.
      If ((Max_MicroIterations.ge.50) .and.
     &    (niter-iter_+1.gt.Max_Microiterations-10)) Then
         dydy=Sqrt(DDot_(nLambda,dy,1,dy,1))
         If (dydy.gt.1.0D-12) du(1+nLambda:nInter)=Zero
         Recompute_disp=.True.
      End If
      Call Backtrans_T(du,dq(1,nIter))
*
*     Compute q for the next iteration
*
      q(:,nIter+1) = q(:,nIter) + dq(:,nIter)
      If (Recompute_disp)
     &   Call Dispersion_Kriging_Layer(q(1,nIter+1),disp_Save,nInter)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('Con_Opt: q',' ',q,nInter,nIter+1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     StpMax from q
*
      Call MxLbls(nInter,dEdq_(1,nIter),dq(1,nIter),Lbl)
*
*     GrdMax for dEdx
*
      If (nInter-nLambda.gt.0) Then
*
         StpMax_Save=StpMax
         StpLbl_Save=StpLbl
         Call mma_allocate(LblSave,Size(Lbl),Label='LblSave')
         LblSave(:) = Lbl
         GrdMax=Zero
         Do i = 1, nInter-nLambda
            Write (Lbl(i),'(A,I3.3)') 'dEdx',i
         End Do
         Call MxLbls(nInter-nLambda,dEdx(1,nIter),dx(1,nIter),LblSave)
         Call mma_deallocate(LblSave)
         StpMax=StpMax_Save
         StpLbl=StpLbl_Save
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(dq_xy)
      Call mma_deallocate(Hessian)
      Return
*                                                                      *
************************************************************************
*                                                                      *
      Contains
*
      Subroutine Backtrans_T(du,dq)
      Implicit None
      Real*8, Intent(In) :: du(nInter)
      Real*8, Intent(Out) :: dq(nInter)
      Call DGEMM_('N','N',
     &            nInter,1,nInter,
     &            One,T,nInter,
     &            du,nInter,
     &            Zero,dq,nInter)
      End Subroutine Backtrans_T
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Destroy_Chunk(ip_Chunk,ip_iMap)
      Integer ip_Chunk
#include "para_info.fh"
*
#ifdef _MOLCAS_MPP_
      If (Is_Real_Par()) Then
         Call GA_Destroy(ip_Chunk)
         Call Free_iWork(ip_iMap)
      Else
         Call Free_Work(ip_Chunk)
      End If
#else
      Call Free_Work(ip_Chunk)
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(ip_iMap)
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Integer Function MltLbl(Lbl1,Lbl2)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             February '91                                             *
************************************************************************
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      Integer Lbl1, Lbl2
*
      Integer iIrrep, jIrrep, ijSym
*
      MltLbl = 0
      Do iIrrep = 0, nIrrep - 1
         If (iAnd(Lbl1,2**iIrrep).eq.0) Cycle
         Do jIrrep = 0, nIrrep - 1
            If (iAnd(Lbl2,2**jIrrep).eq.0) Cycle
            ijSym = iEor(iIrrep,jIrrep)
            If (iAnd(MltLbl,2**ijSym).eq.0) MltLbl = MltLbl + 2**ijSym
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Comp_F(h0,Ei,nBas,Delta_i,Energy,S,Refx,Originx)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Real*8 h0(*),Ei(*),S(*)
*
      nInts = nBas*(nBas+1)/2
      Call Allocate_Work(ip_h0,nInts+4)
      Call Comp_F_(h0,Ei,nBas,Delta_i,Energy,Work(ip_h0),S,Refx,
     &             Originx,nInts)
      Call Free_Work(ip_h0)
*
      Return
      End
      Subroutine Comp_F_(h0,Ei,nBas,Delta_i,Energy,h0_temp,S,Refx,
     &                   Originx,nInts)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "real.fh"
      Real*8 h0(nInts+4), h0_temp(nInts+4),
     &       Ei(nInts+4), S(nInts+4)
      Character*8 Method, Label
      Integer mBas(8)
*
      iOpt1=1
      iOpt2=2
*
      Call Get_cArray('Relax Method',Method,8)
      Call Allocate_Work(ipC,1)
      Call Get_iScalar('nSym',i)
      Call Get_iArray('nBas',mBas,i)
      nsize=nInts + 4
*
*     Add perturbations to h0
*
      call dcopy_(nSize,h0,1,h0_temp,1)
      Call DaXpY_(nSize,Delta_i,Ei,1,h0_temp,1)
      Call DaXpY_(nSize,Delta_i*(Originx-Refx),S ,1,h0_temp,1)
      Call Get_dScalar('PotNuc',PotNuc_Save)
      Call Put_dScalar('PotNuc',h0_temp(nInts+4))
*
*---- Write the one-electron hamiltonian.
*
C     Call TriPrt('H0 before wrone',' ',h0,nBas)
      iComp=1
      iSyLbl=1
      Label='OneHam  '
      iRc=-1
      Call WrOne(iRc,0,Label,iComp,h0_temp,iSyLbl)
C     Call TriPrt('H0_temp after wrone',' ',h0_temp,nBas)
*
      If (Method.eq.'RHF-SCF' .or.
     &    Method.eq.'UHF-SCF' .or.
     &    Method.eq.'KS-DFT' ) Then
*
         Call StartLight('scf')
         Call Disable_Spool()
         Call xml_open('module',' ',' ',0,'scf')
         Call SCF(ireturn)
         Call xml_close('module')
         If (iReturn.ne.0) Go To 99
         Call GetMem('PT2','Flush','Real',ipC,iDum)
*
      Else If (Method(1:5).eq.'MBPT2') Then
*
         Call StartLight('scf')
         Call Disable_Spool()
         Call xml_open('module',' ',' ',0,'scf')
         Call SCF(ireturn)
         Call xml_close('module')
         If (iReturn.ne.0) Go To 99
         Call GetMem('PT2','Flush','Real',ipC,iDum)
         Call StartLight('mbpt2')
         Call Disable_Spool()
         Call mp2_driver(ireturn)
         If (iReturn.ne.0) Go To 99
         Call GetMem('PT2','Flush','Real',ipC,iDum)
*
      Else If (Method.eq.'RASSCF' .or.
     &         Method.eq.'CASSCF' ) Then
*
         Call StartLight('rasscf')
         Call Disable_Spool()
         Call RASSCF(ireturn)
         If (iReturn.ne.0) Go To 99
         Call GetMem('PT2','Flush','Real',ipC,iDum)
*
      Else If (Method.eq.'CASPT2') Then
*
         Call StartLight('rasscf')
         Call Disable_Spool()
         Call RASSCF(ireturn)
         If (iReturn.ne.0) Go To 99
         Call GetMem('PT2','Flush','Real',ipC,iDum)
         Call StartLight('caspt2')
         Call Disable_Spool()
         Call CASPT2(ireturn)
         If (iReturn.ne.0) Go To 99
         Call GetMem('PT2','Flush','Real',ipC,iDum)
*
      Else
         Write (6,*) 'Method=',Method
         Write (6,*) ' Oups!'
         Call Abend()
      End If
*
C     Call Get_Energy(Energy)
      Call Get_dScalar('Last energy',Energy)
      Call Free_Work(ipC)
*
      Call WrOne(iRc,0,Label,iComp,h0,iSyLbl)
      Call Put_dScalar('PotNuc',PotNuc_Save)
      Return
*
 99   Continue
      Write (6,*)
      Write (6,*) 'Comp_f: Wave function calculation failed!'
      Write (6,*)
      Call Abend()
* Avoid unused argument warnings
      If (.False.) Call Unused_integer(nBas)
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Map3_213(A,B,d1,d2,d3)
! this routine does:
! map B(213) <- A(123)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: d1, d2, d3
real(kind=wp), intent(in) :: A(d1,d2,d3)
real(kind=wp), intent(out) :: B(d2,d1,d3)
integer(kind=iwp) :: i1

do i1=1,d1
  b(:,i1,:) = a(i1,:,:)
end do

return

end subroutine Map3_213

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine rhs_mp2_help1(iSymA, iSymB, iSymI, iSymJ)
*                                                                      *
************************************************************************
*                                                                      *
      Implicit Real*8 (a-h,o-z)
*
*defining One etc.
#include "real.fh"
#include "trafo.fh"
#include "WrkSpc.fh"
#include "files_mbpt2.fh"
#include "mp2grad.fh"
#include "corbinf.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      iVirVir(i,j,k) = nFro(k) + nOcc(k) +  j-1 +
     &                (nOrb(k) + nDel(k))*
     &                (i + nFro(k) + nOcc(k) -1)
      iOccOcc(i,j,k) = nFro(k) + j-1 + (nOrb(k)+nDel(k))
     &                               * (i + nFro(k)-1)
      iVirDel(i,j,k) = nFro(k) + nOcc(k) + j-1 +
     &                (nOrb(k) + nDel(k)) *
     &                (i + nFro(k) + nOcc(k) + nExt(k) - 1)
      iOccFro(i,j,k) = j-1 + (nOrb(k) +nDel(k))
     &                               * (i + nFro(k) -1)
      iVirOcc(i,j,k) = j-1 + nFro(k) + nOcc(k) + (nOrb(k) + nDel(k))
     &                                *(i-1)
      iMp2Lagr(i,j,k) = ip_Mp2Lagr(k) +
     &                           j-1 + (nOcc(k)+nFro(k))*(i-1)
*                                                                      *
************************************************************************
*                                                                      *
*    First we read in blocks of all integrals of the form <I.|J.>
*    If the I and J is of the same symmetry we only need to
*    consider blocks with OrbJ < OrbI
      nJ = nOcc(iSymJ)
      Do iI = 1, nOcc(iSymI)
*        Check if we need to consider all combinations of orbitals
         if(iSymI.eq.iSymJ) nJ = iI
         Do iJ = 1, nJ
*            Write(6,*) 'iSymI, iSymJ', iSymI,iSymJ
*            Write(6,*) 'iI, iJ', iI, iJ
*           If only blocks with OrbJ < OrbI is used we need
*           to multiply the result with two for offdiag terms.
            fac_ij = One
            if((iI.ne.iJ).and.(iSymI.eq.iSymJ)) fac_ij = Two
*           If I is not equal J there is a symmetry J I B A
*           that is identical and not stored.
            if(iSymI.ne.iSymJ) fac_ij = Two
*           Needed?
*
*           Copy one AB-block of integrals to the workspace
            Call Exch(iSymA,iSymI,iSymB,iSymJ,
     &                iI+nFro(iSymI),iJ+nFro(iSymJ),
     &                Work(ipInt1),Work(ipScr1))
            If(iSymI.ne.iSymJ) then
               Call Exch(iSymB,iSymI,iSymA,iSymJ,
     &                   iI+nFro(iSymI),iJ+nFro(iSymJ),
     &                   Work(ipInt2),Work(ipScr1))
            End If
*            Write(6,*) 'Rhs_mp2_help1'
*            Write(6,*) ' *  i,j = ',iI, iJ
*            Call RecPrt('Int1:','(8F10.6)',Work(ipInt1),
*     &                  nOrb(iSymA)+nDel(iSymA),
*     &                  nOrb(iSymB)+nDel(iSymB))
*            If(iSymI.ne.iSymJ) Then
*               Call RecPrt('Int2:','(8F10.6)',Work(ipInt2),
*     &                     nOrb(iSymB)+nDel(iSymB),
*     &                     nOrb(iSymA)+nDel(iSymA))
*            End If
*            write(6,*) ''
*
*           Calculates the EMP2-energy as a test
            iAB = nFro(iSymA) + nOcc(iSymA)  +
     &           (nFro(iSymB) + nOcc(iSymB))
     &          *(nOrb(iSymA) + nDel(iSymA))
            iBA = nFro(iSymB) + nOcc(iSymB)  +
     &           (nFro(iSymA) + nOcc(iSymA))
     &          *(nOrb(iSymB) + nDel(iSymB))
*
            Do iA = 1, nExt(iSymA)
            nB = nExt(iSymB)
            if(iSymA.eq.iSymB) nB = iA
               Do iB = 1, nB
                   EDiff = One/(work(mAdOcc(iSymI)+iI-1)
     &                       + work(mAdOcc(iSymJ)+iJ-1)
     &                       - work(mAdVir(iSymA)+iA-1)
     &                       - work(mAdVir(iSymB)+iB-1) )

                  xiajb=work(ipInt1 + iAB + iA-1 + (iB-1)*
     &                       (nOrb(iSymA)+nDel(iSymA)))
                  If(iSymI.eq.iSymJ) then
                     xibja=work(ipInt1 + iAB +
     &                          iB-1 + (iA-1)*(nOrb(iSymB)+nDel(iSymB)))
                  Else
                     xibja=work(ipInt2 + iBA +
     &                          iB-1 + (iA-1)*(nOrb(iSymB)+nDel(iSymB)))
                  End If
                  EMP2 = EMP2 + Ediff*Fac_ij * (xiajb*(Two*xiajb-xibja))
                  VECL2=VECL2 + Ediff**2*Fac_ij*
     &                  (xiajb*(Two*xiajb-xibja))
                  If(((iA.ne.iB).and.(iSymA.eq.iSymB))
     &                .or. (iSymI.ne.iSymJ)) Then
                     EMP2= EMP2+ Ediff*Fac_ij*(xibja*(Two*xibja-xiajb))
                     VECL2=VECL2 + Ediff**2*Fac_ij*
     &                     (xibja*(Two*xibja-xiajb))
                  End If
               End Do           !iOrbB
            End Do              !iOrbA
*                                                                      *
************************************************************************
*                                                                      *
*           P Virtual-Virtual
*                                                                      *
************************************************************************
*                                                                      *
*           Calculate the virtual-virtual perturbation to the
*           P-matrix
*           In this and all other things we calculate from now on
*           we need to do an extra loop over symmetries where J is
*           not equal to I since only symmetries where I > J is saved.
*           In the extra loops we do some special handling to get the
*           results from the symmetries with I < J.
*
               iAC = nFro(iSymA) + nOcc(iSymA)  +
     &              (nFro(iSymB) + nOcc(iSymB))
     &             *(nOrb(iSymA) + nDel(iSymA))
               iCA = nFro(iSymB) + nOcc(iSymB)  +
     &              (nFro(iSymA) + nOcc(iSymA))
     &             *(nOrb(iSymB) + nDel(iSymB))
               iBC = iAC
               iCB = iCA
               Do iC = 1, nExt(iSymB)
                  Do iA = 1, nExt(iSymA)
                     xiajc=work(ipInt1 + iAC + iA-1 +
     &                             (iC-1)*(nOrb(iSymA) + nDel(iSymA)))
                     If(ISymI.Eq.iSymJ) then
                        xicja=work(ipInt1 + iCA + iC-1 +
     &                       (iA-1)*(nOrb(iSymB)+nDel(iSymB)))
                     Else
                        xicja=work(ipInt2 + iCA + iC-1 +
     &                       (iA-1)*(nOrb(iSymB)+nDel(iSymB)))
                     End If
                     EDiffac = work(mAdOcc(iSymI)+iI-1)
     &                       + work(mAdOcc(iSymJ)+iJ-1)
     &                       - work(mAdVir(iSymA)+iA-1)
     &                       - work(mAdVir(iSymB)+iC-1)
                     T_ij = (Two*xiajc-xicja)/EDiffac
                     T_ji = (Two*xicja-xiajc)/EDiffac
                     Do iB = 1, nExt(iSymA)
                        xibjc=work(ipInt1 + iBC + iB-1 +
     &                       (iC-1)*(nOrb(iSymA) + nDel(iSymA)))
                        If(ISymI.Eq.iSymJ) then
                           xicjb=work(ipInt1 + iCB + iC-1 +
     &                          (iB-1)*(nOrb(iSymB) +nDel(iSymB)))
                        Else
                           xicjb=work(ipInt2 + iCB + iC-1 +
     &                          (iB-1)*(nOrb(iSymB) +nDel(iSymB)))
                        endif
                        EDiffbc = work(mAdOcc(iSymI)+iI-1)
     &                          + work(mAdOcc(iSymJ)+iJ-1)
     &                          - work(mAdVir(iSymB)+iC-1)
     &                          - work(mAdVir(iSymA)+iB-1)
                        Work(ip_Density(iSymA) +
     &                       iVirVir(iA,iB,iSymA)) =
     &                       Work(ip_Density(iSymA) +
     &                       iVirVir(iA,iB,iSymA)) +
     &                       Fac_ij * ((xibjc*T_ij) +
     &                       (xicjb*T_ji)) /EDiffbc
                         Work(ip_WDensity(iSymA) +
     &                       iVirVir(iB,iA,iSymA)) =
     &                       Work(ip_WDensity(iSymA) +
     &                       iVirVir(iB,iA,iSymA)) -
     &                       Fac_ij * ((xibjc*T_ij) +
     &                       (xicjb*T_ji))
                     End Do
*                     Write(6,*) 'IJABC',iI,iJ,iA,iB,iC
*                     Write(6,*) 'Symm', iSymI,iSymJ,iSymA,iSymB,iSymC
*                        write(6,*) 'EDiffBC', EDiffbc
*                        Write(6,*) 'EDiffAC', EDiffac
*                        write(6,*) 'xicja', xicja
*                        write(6,*) 'xicjb', xicjb
*                        write(6,*) 'xiajc', xiajc
*                        write(6,*) 'xibjc', xibjc
                     Do iBDel = 1, nDel(iSymA)
                        xibjc=work(ipInt1 + iBC +
     &                        iBDel-1 + nExt(iSymA)+
     &                        (iC-1)*(nOrb(iSymA) + nDel(iSymA)))
                        If(ISymI.Eq.iSymJ) then
                           xicjb=work(ipInt1 + iBC + iC-1 +
     &                          (iBDel + nExt(iSymA)-1)
     &                          *(nOrb(iSymB) +nDel(iSymB)))
                        Else
                           xicjb=work(ipInt2 + iCB + iC-1 +
     &                          (iBDel + nExt(iSymA)-1)
     &                          *(nOrb(iSymB) +nDel(iSymB)))

                        End If
                        EDiffbc = Work(madVir(iSymA)+iA-1)
     &                             - Work(mAdDel(iSymA)+iBDel-1)
                        Work(ip_Density(iSymA) +
     &                       iVirDel(iBDel,iA,iSymA)) =
     &                       Work(ip_Density(iSymA) +
     &                       iVirDel(iBDel,iA,iSymA)) +
     &                       Fac_ij *
     &                       ((xibjc*T_ij) +
     &                       (xicjb*T_ji)) /EDiffbc
                        Work(ip_WDensity(iSymA) +
     &                       iVirDel(iBDel,iA,iSymA)) =
     &                       Work(ip_WDensity(iSymA) +
     &                       iVirDel(iBDel,iA,iSymA)) -
     &                       Fac_ij *
     &                       ((xibjc*T_ij) +
     &                       (xicjb*T_ji))
*--------------------------------------------------------
*                        Write(6,*) 'index Dens', iVirDel(iBDel,iA,iSymA)
*                        Write(6,*) 'xicjb', xicjb
*                        Write(6,*) 'xibjc', xibjc
*                        Write(6,*) 'EDiffbc', EDiffbc
*                        Write(6,*) 'E_a', Work(madVir(iSymA)+iA-1)
*                        Write(6,*) 'E_B', Work(mAdDel(iSymA)+iBDel-1)
*                        Write(6,*) 'Tij', T_ij
*                        Write(6,*) 'Tji', T_ji
*                        Write(6,*) 'iB, iC', iBDel+nExt(iSymA), iC
*                        Write(6,*) 'iI, iJ', iI, iJ
*-------------------------------------
                        End Do
*                         work(indexW) = work(indexW) -
*     &                     Fac_ij*EDiffbc*(Two*(xijac*xijbc+
*     &                     xijca*xijcb) - xijac*xijcb-xijca*xijbc)
*-----------------------------------------------------------------------
*                        write (6,*) 'The Denom is', EDenom
*                        write(6,*) 'xicja', xicja
*                        write(6,*) 'xicjb', xicjb
*                        write(6,*) 'xiajc', xiajc
*                        write(6,*) 'xibjc', xibjc
*                        write(6,*) 'this is with the unmirrored'
*------------------------------------------------------------------------
*
                  enddo         !iOrbB
               enddo            !iOrbA
*
*
*              Here is the extra loop.
               if (iSymA.ne.iSymB) then
               iAC = nFro(iSymB) + nOcc(iSymB)  +
     &              (nFro(iSymA) + nOcc(iSymA))
     &             *(nOrb(iSymB) + nDel(iSymB))
               iCA = nFro(iSymA) + nOcc(iSymA) +
     &              (nFro(iSymB) + nOcc(iSymB))
     &             *(nOrb(iSymA) + nDel(iSymA))
               iBC = iAC
               iCB = iCA
               Do iC = 1, nExt(iSymA)
                  Do iA = 1, nExt(iSymB)
                     EDiffac = work(mAdOcc(iSymI)+iI-1)
     &                       + work(mAdOcc(iSymJ)+iJ-1)
     &                       - work(mAdVir(iSymB)+iA-1)
     &                       - work(mAdVir(iSymA)+iC-1)
                     xiajc=work(ipInt1 + iCA + iC-1 +
     &                             (iA-1)*(nOrb(iSymA) + nDel(iSymA)))
                     xicja=work(ipInt2 + iAC + iA-1 +
     &                             (iC-1)*(nOrb(iSymB) + nDel(iSymB)))
                     T_ij = (Two*xiajc-xicja)/EDiffac
                     T_ji = (Two*xicja-xiajc)/EDiffac
                     Do iB = 1,nExt(iSymB)
                        EDiffbc = work(mAdOcc(iSymI)+iI-1)
     &                          + work(mAdOcc(iSymJ)+iJ-1)
     &                          - work(mAdVir(iSymA)+iC-1)
     &                          - work(mAdVir(iSymB)+iB-1)
                        xibjc=work(ipInt1 + iCB + iC-1 +
     &                             (iB-1)*(nOrb(iSymA) + nDel(iSymA)))
                        xicjb=work(ipInt2 + iBC + iB-1 +
     &                             (iC-1)*(nOrb(iSymB) + nDel(iSymB)))
                        Work(ip_Density(iSymB) + iVirVir(iA,iB,iSymB)) =
     &                  Work(ip_Density(iSymB) + iVirVir(iA,iB,iSymB)) +
     &                                 Fac_ij  *
     &                                ((xibjc*T_ij) +
     &                                 (xicjb*T_ji)) / EDiffbc
                        Work(ip_WDensity(iSymB) + iVirVir(iB,iA,iSymB))=
     &                  Work(ip_WDensity(iSymB) + iVirVir(iB,iA,iSymB))-
     &                                 Fac_ij  *
     &                                ((xibjc*T_ij) +
     &                                 (xicjb*T_ji))

                     End Do
                     Do iBDel = 1, nDel(iSymB)
                        xibjc=work(ipInt1 + iBC +
     &                             iBDel-1 + nExt(iSymB) +
     &                        (iC-1)
     &                       *(nOrb(iSymB) + nDel(iSymB)))
                        xicjb=work(ipInt2 + iCB + iC-1 +
     &                             (iBdel + nExt(iSymB)-1)*
     &                             (nOrb(iSymA) + nDel(iSymA)))
                        EDiffbc = Work(madVir(iSymB)+iA-1)
     &                          - Work(mAdDel(iSymB)+iBDel-1)
                        Work(ip_Density(iSymA) +
     &                       iVirDel(iBDel,iA,iSymB)) =
     &                       Work(ip_Density(iSymB) +
     &                       iVirDel(iBDel,iA,iSymB)) +
     &                       Fac_ij *
     &                       ((xibjc*T_ij) +
     &                       (xicjb*T_ji)) /EDiffbc
                        Work(ip_WDensity(iSymA) +
     &                       iVirDel(iBDel,iA,iSymB)) =
     &                       Work(ip_WDensity(iSymB) +
     &                       iVirDel(iBDel,iA,iSymB)) -
     &                       Fac_ij *
     &                       ((xibjc*T_ij) +
     &                       (xicjb*T_ji))
                     End Do
*-----------------------------------------------------------------------
*                        write (6,*) 'The Denom is', EDenom
*                        write(6,*) 'xicja', xicja
*                        write(6,*) 'xicjb', xicjb
*                        write(6,*) 'xiajc', xiajc
*                        write(6,*) 'xibjc', xibjc
*                        write(6,*) 'this is with the mirrored symmetry'
*------------------------------------------------------------------------


                  enddo         !iOrbB
               enddo            !iOrbA
            endif
*                                                                      *
************************************************************************
*                                                                      *
*           Lagrangian term 2
*                                                                      *
************************************************************************
*                                                                      *
            iAB = nFro(iSymA) + nOcc(iSymA) +
     &           (nFro(iSymB) + nOcc(iSymB)) *
     &           (nOrb(iSymA) + nDel(iSymA))
            iBA = nFro(iSymB) + nOcc(iSymB) +
     &           (nFro(iSymA) + nOcc(iSymA)) *
     &           (nOrb(iSymB) + nDel(iSymB))
            iKB = (nFro(iSymB) + nOcc(iSymB))
     &            *(nOrb(iSymA) + nDel(iSymA))
            iBK = nFro(iSymB) + nOcc(iSymB)
            Do iA = 1, nExt(iSymA)
               Do iB = 1,nExt(iSymB)
                  EDenom =(work(mAdOcc(iSymI)+iI-1)
     &                   + work(mAdOcc(iSymJ)+iJ-1)
     &                   - work(mAdVir(iSymA)+iA-1)
     &                   - work(mAdVir(iSymB)+iB-1) )
                  xiajb=work(ipInt1 + iAB + iA-1 +
     &                  (iB-1)*(nOrb(iSymA) + nDel(iSymA)))
                  If(isymI.Eq.iSymJ) Then
                     xibja=work(ipInt1 + iBA + iB-1 +
     &                          (iA-1)*(nOrb(iSymB)+nDel(iSymB)))
                  Else
                     xibja=work(ipInt2 + iBA + iB-1 +
     &                          (iA-1)*(nOrb(iSymB)+nDel(iSymB)))
                  End If
                  Tij= (Two*xiajb-xibja)/EDenom
                  Tji= (Two*xibja-xiajb)/EDenom
                  Do iK = 1 , nFro(iSymA) + nOcc(iSymA)
                     xikjb=work(ipInt1 + iKB + iK-1 +
     &                     (iB-1)*(nOrb(iSymA) + nDel(iSymA)))
                     If(isymI.Eq.iSymJ) Then
                        xibjk=work(ipInt1 + iBK + iB-1 +
     &                             (iK-1)*(nOrb(iSymB)+nDel(iSymB)))
                     Else
                        xibjk=work(ipInt2 + iBK + iB-1 +
     &                             (iK-1)*(nOrb(iSymB)+nDel(iSymB)))
                     Endif
                     Work(iMp2Lagr(iA,iK,iSymA)) =
     &                 Work(iMp2Lagr(iA,iK,iSymA)) + Fac_ij*
     &                               (Tij*Xikjb+Tji*Xibjk)
                     Work(ip_WDensity(iSymA) + iVirOcc(iK,iA,iSymA))=
     &                 Work(ip_WDensity(iSymA) + iVirOcc(iK,iA,iSymA))-
     &                     2.0d0*Fac_ij*(Tij*Xikjb+Tji*Xibjk)
*-------------------------------------------------------
*                     write(6,*) 'The Denom is', EDenom
*                     write(6,*) 'Tij  ', Tij
*                     write(6,*) 'Tji  ', Tji
*                     write(6,*) 'xiajb', xiajb
*                     write(6,*) 'xiajb', xiajb
*                     write(6,*) 'xibja', xibja
*                     write(6,*) 'xikjb', xikjb
*                     write(6,*) 'xibjk', xibjk
*-----------------------------------------------------------------------
                  End Do         !OrbK
               End Do            !OrbA
            End Do               !OrbB
*
*     In the case that the symmetries A and B are not the same
*     only the case where A is greater than B is written on disk
*     so we must do an extra loop for where B is greater than A
*
            If(iSymA.ne.iSymB) Then
               iAB = nFro(iSymB) + nOcc(iSymB) +
     &              (nFro(iSymA) + nOcc(iSymA))
     &             *(nOrb(iSymB) + nDel(iSymB))
               iBA = nFro(iSymA) + nOcc(iSymA) +
     &              (nFro(iSymB) + nOcc(iSymB))
     &             *(nOrb(iSymA) + nDel(iSymB))
               iKB = (nFro(iSymA) +nOcc(iSymA))
     &             *(nOrb(iSymB)+nDel(iSymB))
               iBK = nFro(iSymA) + nOcc(iSymA)
               Do iA = 1, nExt(iSymB)
                  Do iB = 1, nExt(iSymA)
                     EDenom = (work(mAdOcc(iSymI)+iI-1)
     &                       + work(mAdOcc(iSymJ)+iJ-1)
     &                       - work(mAdVir(iSymB)+iA-1)
     &                       - work(mAdVir(iSymA)+iB-1) )
                     xiajb=work(ipInt1 + iBA + iB-1 +
     &                             (iA-1)*(nOrb(iSymA)+nDel(iSymA)))
                     xibja=work(ipInt2 + iAB + iA-1 +
     &                             (iB-1)*(nOrb(iSymB)+nDel(iSymB)))
                     Tij= (Two*xiajb-xibja)/EDenom
                     Tji= (Two*xibja-xiajb)/EDenom
                     Do iK = 1 , nFro(iSymB) + nOcc(iSymB)
                        xikjb=work(ipInt1 + iBK + iB-1 +
     &                             (iK-1)*(nOrb(iSymA)+nDel(iSymA)))

                        xibjk=work(ipInt2 + iKB + iK-1 +
     &                             (iB-1)*(nOrb(iSymB)+nDel(iSymB)))
*
                        Work(iMp2Lagr(iA,iK,iSymB)) =
     &                    Work(iMp2Lagr(iA,iK,iSymB)) + Fac_ij*
     &                                 (Tij*Xikjb+Tji*Xibjk)
                        Work(ip_WDensity(iSymB) + iVirOcc(iK,iA,iSymB))=
     &                  Work(ip_WDensity(iSymB) + iVirOcc(iK,iA,iSymB))-
     &                     2.0d0*Fac_ij*(Tij*Xikjb+Tji*Xibjk)
*-----------------------------------------------------------------------
*                        write (6,*) 'The Denom is', EDenom
*                        write(6,*) 'Tij  ', Tij
*                        write(6,*) 'Tji  ', Tji
*                        write(6,*) 'xijab', xijab
*                        write(6,*) 'xijba', xijba
*                        write(6,*) 'xijkb', xijkb
*                        write(6,*) 'xijbk', xijbk
*                        write(6,*) 'this is with the mirrored symmetry'
*------------------------------------------------------------------------
                     EndDo      !OrbK
                  EndDo         !OrbA
               EndDo            !OrbB
            EndIf
*
*           When we are done with a block we free the memory again.
*
         End Do                  !OrbI
      End Do
*
******************************************************************************************
*
*             Terms that need <A.|B.>-integrals
*
******************************************************************************************
*
*
*
      nB = nExt(iSymB)
      Do iA = 1, nExt(iSymA)
*        Decide i the AB-matrix is symmetric, if so
*        only loop over lower triangle
         If(iSymA.Eq.iSymB) nB = iA

         Do iB = 1, nB
*            Write(6,*) 'iSymA, iSymB', iSymA, iSymB
*            Write(6,*) 'iA, iB', iA, iB
            fac_ab = One
            if((iA.Ne.iB).and.(iSymA.eq.iSymB)) fac_ab = Two
*           If I is not equal J there is a symmetry J I B A
*           that is identical and not stored.
            if(iSymA.Ne.iSymB) fac_ab = Two
*
            Call Exch(iSymI,iSymA,iSymJ,iSymB,
     &                iA + nOcc(iSymA)+nFro(iSymA),
     &                iB + nOcc(iSymB)+nFro(iSymB),
     &                Work(ipInt1), Work(ipScr1))
            If(iSymA.Ne.iSymB) Then
               Call Exch(iSymJ,iSymA,iSymI,iSymB,
     &                   iA + nOcc(iSymA)+nFro(iSymA),
     &                   iB + nOcc(iSymB)+nFro(iSymB),
     &                   Work(ipInt2),Work(ipScr1))
            End If
*            Write(6,*)
*            Write(6,*) ' *  A,B = ',iA,iB
*            Call RecPrt('Int1:','(8F10.6)',Work(ipInt1),
*     &                  nOrb(iSymI)+nDel(iSymI),
*     &                  nOrb(iSymJ)+nDel(iSymJ))
*            If (iSymA.Ne.iSymB) Then
*               Call RecPrt('Int2:','(8F10.6)',Work(ipInt2),
*     &                     nOrb(iSymJ) + nDel(iSymJ),
*     &                     nOrb(iSymI) + nDel(iSymI))
*            End If
*            Write(6,*)

*********************************************************************
*
*                   Calculate Pij
*
*********************************************************************
*
*           We start by taking i and j in symI and k in symJ
            iIK= nFro(iSymI) +
     &           nFro(iSymJ) * (nOrb(iSymI)+nDel(iSymI))
            iKI= nFro(iSymJ) +
     &           nFro(iSymI) * (nOrb(iSymJ)+nDel(iSymJ))
            iJK= iIK
            iKJ= iKI
            Do iK = 1, nOcc(iSymJ)
               Do iI=1, nOcc(iSymI)
                   EDiffik = work(mAdOcc(iSymI) + iI-1)
     &                     + work(mAdOcc(iSymJ)+ iK-1)
     &                     - work(mAdVir(iSymA)+iA-1)
     &                     - work(mAdVir(iSymB)+iB-1)
                   xiakb=Work(ipInt1 +iIK + iI-1 + (iK-1)*
     &                          (nOrb(iSymI) + nDel(iSymI)))
                   If(iSymA.Eq.iSymB) then
                      xkaib=Work(ipInt1+iKI +iK-1 +(iI-1)*
     &                             (nOrb(iSymJ) + nDel(iSymJ)))
                   Else
                      xkaib=Work(ipInt2+iKI+iK-1 +(iI-1)*
     &                             (nOrb(iSymJ) + nDel(iSymJ)))
                   End If
                   T_ab = (Two*xiakb-xkaib)/EDiffik
                   T_ba = (Two*xkaib-xiakb)/EDiffik
                   Do iJ= 1, nOcc(iSymI)
*                    Calculating the denominator

                     EDiffjk = work(mAdOcc(iSymI)+iJ-1)
     &                       + work(mAdOcc(iSymJ)+iK-1)
     &                       - work(mAdVir(iSymA)+iA-1)
     &                       - work(mAdVir(iSymB)+iB-1)

                     xjakb=Work(ipInt1 +iJK + iJ-1 + (iK-1)*
     &                          (nOrb(iSymI) + nDel(iSymI)))
                     if(iSymA.Eq.iSymB) then
                        xkajb=Work(ipInt1+iKJ +iK-1 +(iJ-1)*
     &                             (nOrb(iSymJ) + nDel(iSymJ)))
                     else
                        xkajb=Work(ipInt2+iKJ+iK-1 +(iJ-1)*
     &                             (nOrb(iSymJ) + nDel(iSymJ)))
                     endif
*---------------------------------------------------------------------
*                     write (6,*) 'The Denom is', EDenom
*                     write(6,*) 'xikab', xikab
*                     write(6,*) 'xjkab', xjkab
*                     write(6,*) 'xkiab', xkiab
*                     write(6,*) 'xkjab', xkjab
*-----------------------------------------------------------------------
                     Work(ip_Density(iSymI) + iOccOcc(iI,iJ,iSymI)) =
     &                  Work(ip_Density(iSymI) + iOccOcc(iI,iJ,iSymI)) -
     &                                         Fac_ab *
     &                                  (xjakb*T_ab +
     &                                   xkajb*T_ba)/EDiffjk
                     Work(ip_WDensity(iSymI) + iOccOcc(iI,iJ,iSymI)) =
     &                  Work(ip_WDensity(iSymI) + iOccOcc(iI,iJ,iSymI))-
     &                                         Fac_ab *
     &                                  (xjakb*T_ab +
     &                                   xkajb*T_ba)
*------------------------------------------------------------------------
                  End Do
                  Do iJFroz = 1, nFro(iSymI)
                     xjakb=Work(ipInt1 + iJFroz-1 +
     &                    (iK+nFro(iSymJ)-1)*
     &                    (nOrb(iSymI) + nDel(iSymI)))
                     if(iSymI.Eq.iSymJ) then
                        xkajb=Work(ipInt1 +iK-1
     &                       + nFro(iSymJ) +(iJFroz-1)*
     &                       (nOrb(iSymJ) + nDel(iSymJ)))
                     else
                        xkajb=Work(ipInt2+
     &                       iK-1 + nFro(iSymJ) +(iJFroz-1)*
     &                       (nOrb(iSymJ) + nDel(iSymJ)))
                     endif
                     EDiffjk = Work(madOcc(iSymI)+iI-1)
     &                       - Work(mAdFro(iSymI)+iJFroz-1)
                        Work(ip_Density(iSymI) +
     &                       iOccFro(iI,iJFroz,iSymI)) =
     &                       Work(ip_Density(iSymI) +
     &                       iOccFro(iI,iJFroz,iSymI)) +
     &                       Fac_ab *
     &                       ((xjakb*T_ab) +
     &                       (xkajb*T_ba)) /EDiffjk
                        Work(ip_WDensity(iSymI) +
     &                       iOccFro(iI,iJFroz,iSymI)) =
     &                       Work(ip_WDensity(iSymI) +
     &                       iOccFro(iI,iJFroz,iSymI)) -
     &                       Fac_ab *
     &                       ((xjakb*T_ab) +
     &                       (xkajb*T_ba))
                  End Do
               EndDo
            EndDo
*           And then we do the same thing with i and j in symJ and k in symI
            if(iSymI.ne.iSymJ) then
               iIK = nFro(iSymJ) +
     &               nFro(iSymI) * (nOrb(iSymJ)+nDel(iSymJ))
               iKI = nFro(iSymI) +
     &               nFro(iSymJ) * (nOrb(iSymI)+nDel(iSymI))
               iJK = iIK
               iKJ = iKI
                Do iK = 1, nOcc(iSymI)
                  Do iI = 1, nOcc(iSymJ)
                     EDiffik = work(mAdOcc(iSymJ)+iI-1)
     &                       + work(mAdOcc(iSymI)+iK-1)
     &                       - work(mAdVir(iSymA)+iA-1)
     &                       - work(mAdVir(iSymB)+iB-1)
                     xiakb = Work(ipInt1 + iKI +  iK-1 +
     &                               (iI-1)*(nOrb(iSymI)+nDel(iSymI)))
                     xkaib = Work(ipInt2 + iIK + iI-1 +
     &                               (iK-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                     T_ab = (Two*xiakb-xkaib)/EDiffik
                     T_ba = (Two*xkaib-xiakb)/EDiffik
                     Do iJ = 1, nOcc(iSymJ)
*                       Calculating the denominator

                        EDiffjk = work(mAdOcc(iSymJ)+iJ-1)
     &                          + work(mAdOcc(iSymI)+iK-1)
     &                          - work(mAdVir(iSymA)+iA-1)
     &                          - work(mAdVir(iSymB)+iB-1)
*
                        xjakb = Work(ipInt1 + iKJ + iK-1 +
     &                               (iJ-1)*(nOrb(iSymI)+nDel(iSymI)))
                        xkajb = Work(ipInt2 + iJK + iJ-1 +
     &                               (iK-1)*(nOrb(iSymJ)+nDel(iSymJ)))
*
                        Work(ip_Density(iSymJ) + iOccOcc(iI,iJ,iSymJ)) =
     &                  Work(ip_Density(iSymJ) + iOccOcc(iI,iJ,iSymJ)) -
     &                               Fac_ab *
     &                              (xjakb*T_ab +
     &                               xkajb*T_ba) /EDiffjk
                        Work(ip_WDensity(iSymJ)+iOccOcc(iI,iJ,iSymJ)) =
     &                   Work(ip_WDensity(iSymJ)+iOccOcc(iI,iJ,iSymJ)) -
     &                               Fac_ab *
     &                              (xjakb*T_ab +
     &                               xkajb*T_ba)


*--------------------------------------------------------------------
*                     write (6,*) 'The Denom is', EDenom
*                     write(6,*) 'xikab', xikab
*                     write(6,*) 'xjkab', xjkab
*                     write(6,*) 'xkiab', xkiab
*                     write(6,*) 'xkjab', xkjab
*--------------------------------------------------------------------
                     EndDo
                     Do iJFroz = 1, nFro(iSymJ)
                        xjakb=Work(ipInt1 + iK+nFro(iSymI)-1 +
     &                            (iJFroz-1)*
     &                            (nOrb(iSymI) + nDel(iSymI)))
                        xkajb=Work(ipInt2+
     &                             iJFroz-1 +(iK + nFro(iSymI)-1)*
     &                            (nOrb(iSymJ) + nDel(iSymJ)))
                        EDiffjk = Work(madOcc(iSymJ)+iI-1)
     &                          - Work(mAdFro(iSymJ)+iJFroz-1)
                        Work(ip_Density(iSymJ) +
     &                       iOccFro(iI,iJFroz,iSymJ)) =
     &                       Work(ip_Density(iSymJ) +
     &                       iOccFro(iI,iJFroz,iSymJ)) +
     &                       Fac_ab *
     &                       ((xjakb*T_ab) +
     &                       (xkajb*T_ba)) /EDiffjk
                        Work(ip_WDensity(iSymJ) +
     &                       iOccFro(iI,iJFroz,iSymJ)) =
     &                       Work(ip_WDensity(iSymJ) +
     &                       iOccFro(iI,iJFroz,iSymJ)) -
     &                       Fac_ab *
     &                       ((xjakb*T_ab) +
     &                       (xkajb*T_ba))
                     End Do
                  EndDo
               EndDo
            EndIf

***************************************************************************
*
*                  Lagrangian term 1
*
***************************************************************************
*
            iCJ = nFro(iSymI) + nOcc(iSymI) +
     &            nFro(iSymJ)*
     &           (nOrb(iSymI)+nDel(iSymI))
            iJC = nFro(iSymJ) +
     &           (nFro(iSymI) + nOcc(iSymI)) *
     &           (nOrb(iSymJ) + nDel(iSymJ))
            iIJ = nFro(iSymI) +
     &            nFro(iSymJ) *
     &           (nOrb(iSymI) + nDel(iSymI))
            IJI = nFro(iSymJ) +
     &            nFro(iSymI) *
     &           (nOrb(iSymJ) + nDel(iSymJ))
            Do iC = 1, nExt(iSymI) + nDel(iSymI)
               Do iI = 1, nOcc(iSymI)
                  Do iJ = 1, nOcc(iSymJ)
                     EDenom =  One/(work(mAdOcc(iSymI)+iI-1)
     &                    + work(mAdOcc(iSymJ)+iJ-1)
     &                    - work(mAdVir(iSymA)+iA-1)
     &                    - work(mAdVir(iSymB)+iB-1) )
                     xaibj = Work(ipInt1 + iIJ + iI-1 +
     &                            (iJ-1)*(nOrb(iSymI)+nDel(iSymI)))
                     xacbj = Work(ipInt1 + iCJ + iC-1 +
     &                            (iJ-1) * (nOrb(iSymI)+nDel(iSymI)))
                     if(iSymA.eq.iSymB) then
                        xbiaj = Work(ipInt1 + iJI + iJ-1
     &                        + (iI-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                        xbcaj = Work(ipInt1 + iJC + iJ-1
     &                        + (iC-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                     else
                        xbiaj = Work(ipInt2 + iJI + iJ-1
     &                        + (iI-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                        xbcaj = Work(ipInt2 + iJC + iJ-1
     &                        + (iC-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                     endif
                     Work(iMp2Lagr(iC,iI+nFro(iSymI),iSymI)) =
     &                    Work(iMp2Lagr(iC,iI+nFro(iSymI),iSymI)) +
     &                              EDenom * Fac_ab *(-Two*(xaibj*xacbj
     &                              + xbiaj*xbcaj) + xaibj*xbcaj +
     &                                xbiaj*xacbj)

*-------------------------------------------------------------------
*                     write(*,*) 'EDenom', EDenom
*                     write(*,*) 'Fac_ab', Fac_ab
*                     write(*,*) 'xaibj', xaibj
*                     write(*,*) 'xacbj', xacbj
*                     write(*,*) 'xbiaj', xbiaj
*                     write(*,*) 'xbcaj', xbcaj
*-------------------------------------------------------------------
                  EndDo
               EndDo
            EndDo
*           And now we switch symmetries and go again
            If(iSymA.Ne.iSymB) Then
               iCJ = nFro(iSymJ) + nOcc(iSymJ) +
     &               nFro(iSymI)*
     &              (nOrb(iSymJ)+nDel(iSymJ))
                 iJC = nFro(iSymI) +
     &                (nFro(iSymJ) + nOcc(iSymJ)) *
     &                (nOrb(iSymI) + nDel(iSymI))
                 iIJ = nFro(iSymJ) +
     &                 nFro(iSymI) *
     &                (nOrb(iSymJ) + nDel(iSymJ))
                 IJI = nFro(iSymI) +
     &                 nFro(iSymJ) *
     &                (nOrb(iSymI) + nDel(iSymI))
               Do iC = 1, nExt(iSymJ) + nDel(iSymJ)
                  Do iI = 1, nOcc(iSymJ)
                     Do iJ = 1, nOcc(iSymI)
                        EDenom =  One/(work(mAdOcc(iSymJ)+iI-1)
     &                          + work(mAdOcc(iSymI)+iJ-1)
     &                          - work(mAdVir(iSymA)+iA-1)
     &                          - work(mAdVir(iSymB)+iB-1) )
                        xaibj = Work(ipInt1 + iJI + iJ-1
     &                        + (iI-1)*(nOrb(iSymI)+nDel(iSymI)))
                        xacbj = Work(ipInt1 + iJC + iJ-1
     &                        + (iC-1)*(nOrb(iSymI)+nDel(iSymI)))
                        xajbi = Work(ipInt2 + iIJ + iI-1
     &                        + (iJ-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                        xajbc = Work(ipInt2 + iCJ + iC-1
     &                        + (iJ-1)*(nOrb(iSymJ)+nDel(iSymJ)))
                        Work(iMp2Lagr(iC,iI+nFro(iSymJ),iSymJ)) =
     &                    Work(iMp2Lagr(iC,iI+nFro(iSymJ),iSymJ)) +
     &                              EDenom * Fac_ab *(-Two*(xaibj*xacbj
     &                              + xajbi*xajbc) + xaibj*xajbc +
     &                              xajbi*xacbj)

*-----------------------------------------------------------------
*                        Write(*,*) 'EDenom', EDenom
*                        write(*,*) 'Fac_ab', Fac_ab
*                        write(6,*) 'xijab', xijab
*                        write(6,*) 'xcjab', xcjab
*                        write(6,*) 'xjiab', xjiab
*                        write(6,*) 'xjcab', xjcab
*-------------------------------------------------------------------
                  End Do
               End Do
            End Do
         End If
*
*
*
         EndDo
      EndDo

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
cmp      SUBROUTINE klvaa_vvv(G,ix,it,ig,iscr,vblock,N,nug,lu,last,
cmpn      SUBROUTINE klvaa_vvv(ix,it,ig,iscr,vblock,N,nug,lu,last,
      SUBROUTINE klvaa_vvv(ix,ig,iscr,vblock,N,nug,lu,last,
     $iasblock,K,ias)
C
C  creates K(alpha>alpha,alpha-alpha) or K(beta>beta,beta,beta)
C  DA files KMATICH(ISP)ICH(ISP)     ISP=A
C  generates antisymmetrized integrals from abab (T2) or bbaa (vvvo)
C  ix, it, ig iscr allocated in create_klvab_t3
C  K,ias defined in create_klvab_t3.f
C
C  parallelization (seems to be) irrelevant at the moment
C  implemented integer offsets, PV, 14 may 2004.
C
      IMPLICIT NONE
cmp
#include "WrkSpc.fh"
cmp
#include "ndisk.fh"
#include "dupfiles.fh"
cmp      real*8 G(*),ddot
cmpn
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "ccsd_t3compat.fh"
        integer i_blk,j_blk,b2_chk
        integer ngaf,ngal,ngbf,ngbl
        integer nind_ngbf,nind_ngbl,nind_ngaf,nind_ngal
        integer length,length1,length2
        integer it_exp,itmp,it2_tmp
        integer a_tmp,b1_tmp,j_tmp
cmp
c       integer jjj
        logical switch
cmp
cmpn
c     real*8 ddot_
cmpn      integer it,ix,ig,iscr, KADT, IJS, RAD, AADT
      integer ix,ig,iscr, KADT, IJS, AADT
      integer isp,ias,vblock,n,i,j,k,lu,iasblock,indab
      INTEGER A,A1,A2,B1,B2,NSTEP,ADIM,NUG,NGA,NGB,R,MAXDIMM,B
      INTEGER KI, last
      CHARACTER ich*1
c     CHARACTER FN*6
      INTEGER IOPT,NOAB,NNOAB,NUAB,NNUAB,NNU
      COMMON/UHF/NOAB(2),NNOAB(3),NUAB(2),NNUAB(3),ICH(3)
      COMMON/IOIND/IOPT(96)
      indab(i,j)=(max(i,j)-1)*max(i,j)/2+min(i,j)
C
      ISP=1          !
      nug=nuab(isp)/vblock
      if((vblock*nug).ne.nuab(isp))nug=nug+1
      NNU=NUAB(1)*(NUAB(1)+1)/2
        if (printkey.ge.11) then
           write(6,'(A,10I5)')'entering klvaa_vvv',
     & vblock,N,nug,lu,last,iasblock,K,ias
cmpn      write(6,*)ddot_(nnoab(3)*nnuab(3),Work(it),1,Work(it),1)
cmp      write(6,*)ddot_(nnoab(3)*nnuab(3),G(it),1,G(it),1)
        endif
      !!DO K=1,noab(isp)
         !!FN(1:5)='VVVOI'
         !!FN(6:6)=ICH(ISP)
         !!CALL GET3DM(FN,G(ig),NNUAB(isp),NUAB(ISP),K)
         !!call delf(FN,K,K)    all done in create_klvab_t3.f
         do nga=1,nug
            A1=(nga-1)*vblock+1
            adim=min(vblock,nuab(isp)-A1+1)
            A2=A1+adim-1
            do ngb=1,nga
               if(nga.eq.ngb)then
                  maxdimm=adim*(adim-1)/2
               else
                  maxdimm=adim*vblock
               endif
               call zeroma(Work(IX),1,N*maxdimm)
cmp               call zeroma(G(IX),1,N*maxdim)
               B1=(ngb-1)*vblock+1

cmp!        write (6,*)
cmp!        write (6,*) '================================='
cmp!        write (6,*) 'nga, ngb',nga,ngb
cmp!        write (6,*) '================================='
cmp!        write (6,*)
c`
cmpn
c - check the largest b2
c
cmp        b2_chk=b1-1+min(vblock,a2-b1)
cmpn        b2_chk=b1-1+vblock
        b2_chk=b1+min(vblock,nuab(isp)-b1+1)-1
c
c - find out which T2 blocked files will be needed
c   for particular nga, ngb
c
cmp!        write (6,'(A,4(i5,2x))') 'a1,a2,b1,b2_chk = ',a1,a2,b1,b2_chk
c
        call block_interf(a1,a2,b1,b2_chk,
     &   ngaf,ngal,nind_ngaf,nind_ngal,
     &   ngbf,ngbl,nind_ngbf,nind_ngbl)
c
cmp!        write (6,'(A,4(i5,2x))') 'ngaf, ngal, nind_ngaf, nind_ngal',
cmp!     & ngaf,ngal,nind_ngaf,nind_ngal
cmp!        write (6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',
cmp!     & ngbf,ngbl,nind_ngbf,nind_ngbl
cmp!        write (6,*) 'maxdim = ',maxdim
c
c - read amplitudes from T2_ngaf_ngbf ...  T2_ngaf_ngbl, nga>=ngb
c                           ....               ....
c                        T2ngal_ngbf  ...  T2_ngal_ngbl, nga>=ngb
c
c - calculate memory requirements (consider squared T2(a',a'))
c
          length1=0
        do i_blk=ngaf,ngal
          length1=length1+DimGrpaR(i_blk)
        end do
c
          length2=0
        do j_blk=ngbf,ngbl
          length2=length2+DimGrpaR(j_blk)
        end do
c
cmp!        write (6,*) 'length1, vblock = ',length1,vblock
cmp!        write (6,*) 'length2, vblock = ',length2,vblock
c
        length=length1*length2*no*no
cmp!        write (6,*) 'length for blocked T2 amplitudes = ',length
c
c - setup memory
c
cmp!        write (6,*) 'allocating t2_exp = ',length
        call GetMem('it1_exp','Allo','Real',it_exp,length)
c
c - read pertinent files and store them in the new blocked structure
c
        call GetMem('c1_it2tmp','Allo','Real',it2_tmp,
     & maxdim*maxdim*no*no)
        call GetMem('c1_itmp','Allo','Real',itmp,
     & maxdim*maxdim*no*no)
c
        switch=.false.
        call gather_t2_blocked(length1,length2,
     & ngaf,ngal,ngbf,ngbl,
     & Work(it_exp),Work(it2_tmp),Work(itmp),
     & switch)
c
        call GetMem('c1_itmp','Free','Real',itmp,
     & maxdim*maxdim*no*no)
        call GetMem('c1_it2tmp','Free','Real',it2_tmp,
     & maxdim*maxdim*no*no)

        call dscal_(length,-1.0d0,Work(it_exp),1)
c
cmp
               do a=a1,a2
                  B2=B1-1+min(vblock,A-B1)
                  NSTEP=B2-B1+1
cmp!                  write (6,*) 'NSTEP = ',NSTEP
                  if(nstep.ne.0)then
                     if(nga.eq.ngb)then
                        IJS=(a-a1-1)*(a-a1)/2+IX
!!         IJS=(a-a1-2+1)*(a-a1-1+1)/2+1
                     else
                        IJS=(a-a1)*vblock+IX
                     endif
                     do R=1,K-1
C copies (b1..b2,a,r,k)-(b1..b2,a,k,r)
                        !!KADT=(K-2)*(K-1)/2+R
                        !!KADT=(KADT-1)*NNUAB(ISP)
C address and block for the A1-A2x B1-B2
                        !!KADT=KADT+(a-1)*(a-2)/2 +B1 +IT -1
C    T2 >>> K
                        !!call dcopy_(NSTEP,G(KADT),1,G(IJS),1)
cmpn      KADT=(k-1)*noab(1)*NNUAB(3)+(r-1)*NNUAB(3)+(a-1)*nuab(1)+B1+IT-1
cmpn      AADT=(r-1)*noab(1)*NNUAB(3)+(k-1)*NNUAB(3)+(a-1)*nuab(1)+B1+IT-1
c
         a_tmp=a-nind_ngaf
        b1_tmp=b1-nind_ngbf
cmp!        write (6,'(A,4(i5,2x))') 'b1,   a     ,r,k = ',b1,a,r,k
cmp!        write (6,'(A,4(i5,2x))') 'a_tmp,b1_tmp,k,r = ',a_tmp,b1_tmp,k,r
c
        do j_tmp=0,NSTEP-1
c
      KADT=(r-1)*noab(1)*length1*length2+(k-1)*length1*length2+
     & (b1_tmp+j_tmp-1)*length1+a_tmp+it_exp-1
c
      AADT=(k-1)*noab(1)*length1*length2+(r-1)*length1*length2+
     & (b1_tmp+j_tmp-1)*length1+a_tmp+it_exp-1
c
        Work(IJS+j_tmp)=Work(AADT)-Work(KADT)
cmp!        write (6,'(A,2(i5,2x),3(f18.10,2x))') 'XXXN = ',a_tmp,b1_tmp+j_tmp-1,
cmp!     & Work(IJS+j_tmp),Work(AADT),Work(KADT)
c
        end do
c
cmp      call vsub(G(KADT),1,G(AADT),1,G(IJS),1,NSTEP)
cmpn      call vsub(Work(KADT),1,Work(AADT),1,Work(IJS),1,NSTEP)
       !!write(6,'(A,3I3,8D15.8)')'T',K,R,a,(G(I),I=IJS,IJS+NSTEP-1)
                        IJS=IJS+maxdimm
                     enddo      ! R
cmp                     call zeroma(G(IJS),1,NSTEP)
                     call zeroma(Work(IJS),1,NSTEP)
                     IJS=IJS+maxdimm
C    T2 >>> K  (transposed)
C copies (b1..b2,a,r,k)-(b1..b2,a,k,r)
cmpn
c
c (b1..b2,a,r,k) =? (a,b1...b2,k,r)
c (b1..b2,a,k,r) =? (a,b1...b2,r,k)
c
cmpn
                     do R=K+1,NOAB(ISP)
                        !!KADT=(R-2)*(R-1)/2+K
                        !!KADT=(KADT-1)*NNUAB(ISP)
                        !!KADT=KADT+(a-1)*(a-2)/2 +B1 +IT -1
                        !!call vneg_cht3(G(KADT),1,G(IJS),1,NSTEP)

cmpn      KADT=(k-1)*noab(1)*NNUAB(3)+(r-1)*nnUab(3)+(a-1)*nuab(1)+B1+IT-1
cmpn      AADT=(r-1)*noab(1)*NNUAB(3)+(k-1)*nnUab(3)+(a-1)*nuab(1)+B1+IT-1
c
         a_tmp=a-nind_ngaf
        b1_tmp=b1-nind_ngbf
cmp!        write (6,'(A,4(i5,2x))') 'b1,   a     ,r,k = ',b1,a,r,k
cmp!        write (6,'(A,4(i5,2x))') 'a_tmp,b1_tmp,k,r = ',a_tmp,b1_tmp,k,r
c
        do j_tmp=0,NSTEP-1
c
      KADT=(r-1)*noab(1)*length1*length2+(k-1)*length1*length2+
     & (b1_tmp+j_tmp-1)*length1+a_tmp+it_exp-1
c
      AADT=(k-1)*noab(1)*length1*length2+(r-1)*length1*length2+
     & (b1_tmp+j_tmp-1)*length1+a_tmp+it_exp-1
c
        Work(IJS+j_tmp)=Work(AADT)-Work(KADT)
cmp        write (6,'(A,2(i5,2x),3(f18.10,2x))') 'XXXN = ',a_tmp,b1_tmp+j_tmp-1,
cmp     & Work(IJS+j_tmp),Work(AADT),Work(KADT)
c
        end do
c
cmp      call vsub(G(KADT),1,G(AADT),1,G(IJS),1,NSTEP)
cmpn      call vsub(Work(KADT),1,Work(AADT),1,Work(IJS),1,NSTEP)
       !!write(6,'(A,3I3,8D15.8)')'T',K,R,a,(G(I),I=IJS,IJS+NSTEP-1)
!!         call daxpy_(NSTEP,-1.d0,G(KADT),1,G(IJS),1)
                        IJS=IJS+maxdimm
                     ENDDO      ! R
C    <VV|VO> >>> K original for aaaa
C    (VV|VO( >>> K now          aabb needed (AR|BK)-(BR|AK)

      !!CALL EXPA1_UHF(G(IJS),1,NUAB(IS2),1,G(ISCR))
                     !!KADT=IG-1+(a-1)*(a-2)/2 +B1
                     KADT=IG-1+(B1-1)*NNU
                     AADT=IG-1+(A-1)*NNU
                     DO R=1,NUAB(ISP)
           !!call dcopy_(NSTEP,G(KADT),1,G(IJS),1)
C first (AR|BK)
cmp           call dcopy_(NSTEP,G(KADT+indab(a,r)),NNU,G(IJS),1)
           call dcopy_(NSTEP,Work(KADT+indab(a,r)),NNU,Work(IJS),1)
C now  -(BR|AK)
           KI=IJS
           do B=B1,B2
cmp           G(KI)=G(KI)-G(AADT+indab(B,R))
           Work(KI)=Work(KI)-Work(AADT+indab(B,R))
           KI=KI+1
           ENDDO
       !!write(6,'(A,3I3,8D15.8)')'V',K,R,a,(G(I),I=IJS,IJS+NSTEP-1)
                        IJS=IJS+maxdimm
                        !!KADT=KADT+NNUAB(ISP)
                     enddo      !R
                  endif         ! nstep eq.0
               enddo            !A
C    <VV|VO> >>> K
cmp!      write(6,'(A,5I5,4x,5D15.10)')
cmp!     $'block-w: K,a1,b1,IAS,ddot',K,a1,b1,ias,maxdim,
cmp!     $ ddot_(N*maxdim,Work(IX),1,Work(IX),1),(Work(I),I=IX,IX+3)
cmp     $ ddot_(N*maxdim,G(IX),1,G(IX),1),(G(I),I=IX,IX+3)
cmp               call multi_wridir(G(IX),N*maxdim,LU,IAS, last)
cmp
cmp!!        do jjj=0,N*maxdimm-1
cmp!!        if (abs(Work(ix+jjj)).gt.10000) then
cmp!!          write (6,*) 'prasa 3 ',jjj,Work(ix+jjj)
cmp!!          stop
cmp!!        end if
cmp!!        end do
cmp
               call multi_wridir(Work(IX),N*maxdimm,LU,IAS, last)
               ias=ias+iasblock
cmpn
cmp        write (6,*) 'deallocating t2_exp = ',length
        call GetMem('it1_exp','Free','Real',it_exp,length)
cmpn
            enddo               ! ngb
         enddo                  ! nga
      !!enddo                     ! K
cmp!      write(6,'(A,10I5)')'leaving klvaa_vvv',
cmp!     $vblock,N,nug,lu,last,iasblock,K,ias
      call xflush(6)
      !!stop
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(iscr)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,2020,  Roland Lindh                               *
!               1990, IBM                                              *
!***********************************************************************
!***********************************************************************
!                                                                      *
!    Object: to read basis set Exponents and Contraction Coefficients  *
!            from a library file.                                      *
!            The contraction coefficients will at this point be radial *
!            normalized.                                               *
!                                                                      *
! Called from: Input                                                   *
!                                                                      *
!                                                                      *
!            DDName is the path to the library directory               *
!                                                                      *
!                                                                      *
! Calling    : RecPrt, Rdbsl                                           *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!***********************************************************************

subroutine GetBS(DDname,BSLbl,iShll,Ref,UnNorm,LuRd,BasisTypes,STDINP,iSTDINP,L_STDINP,Expert,ExtBasDir)

use Basis_Info, only: dbsc, nCnttp, Shells
use DKH_Info, only: iRELMP
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u5, u6

implicit none
#include "Molcas.fh"
character(len=*), intent(in) :: DDname, ExtBasDir
character(len=80), intent(inout) :: BSLbl
integer(kind=iwp), intent(inout) :: iShll, iSTDINP
character(len=180), intent(out) :: Ref(2)
logical(kind=iwp), intent(in) :: UnNorm, L_STDINP, Expert
integer(kind=iwp), intent(in) :: LuRd
integer(kind=iwp), intent(out) :: BasisTypes(4)
character(len=180), intent(in) :: STDINP(MxAtom*2)
#include "angtp.fh"
integer(kind=iwp) :: i, iAdded, iAIMP, iAng, iDominantSet, iEnd, iErr, iFlgOne, iFrst, iMPShll, iNow, iPrevNow, iPrim, iPrint, &
                     iPrSh, iValSh, j, j1, j2, jNow, jPrSh, jValSh, lAng, lUnit, LUQRP, mCGTO(0:iTabMx), mDel, mSOC, mVal, nAdded, &
                     nAIMP, nCGTO(0:iTabMx), nCntrc, nEorb, nPrim, nProj, Nwords
real(kind=wp) :: Coeff, RatioThres
character(len=263) :: Filename
character(len=256) :: Basis_Lib, DirName
character(len=180) :: Line
character(len=80) :: Atom, Filenm, bType
character(len=24) :: Words(2)  ! CGGn
character(len=20) :: MPLbl
logical(kind=iwp) :: Cart(0:iTabMx), Found, Hit, IfTest, inLn1, inLn2, inLn3, isEorb, isFock, UnContracted
real(kind=wp), allocatable :: ExpMerged(:), Temp(:,:)
integer(kind=iwp), external :: Lbl2Nr, StrnLn
character(len=180), external :: Get_Ln
character(len=*), parameter :: DefNm = 'basis_library'
character(len=*), parameter :: KWord(18) = ['END ','VALE','CORE','EXTE','EXCH','1STO','NOPA','NOP1','NOP2','NOP3','NOPF','RESC', &
                                            'RA0H','RA0F','RAIH','MIXE','SOC ','DKSO']

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
IfTest = .true.
iPrint = 99
#else
IfTest = .false.
iPrint = 5
#endif
if (IfTest) iPrint = 99
dbsc(nCnttp)%FOp = .true.
lAng = 0

Cart(:) = .false.
if (IfTest) write(u6,'(A,A)') 'DDName=',DDName
Line = DDName
call UpCase(Line)
if ((index(Line,'INLINE') /= 0) .and. (index(Line,'EXPERT') == 0)) then
  if (.not. Expert) then
    write(u6,*) 'INLINE keyword is detected'
    write(u6,*) 'EXPERT keyword is not set...'
    write(u6,*) '       We better abort right now!'
    call abend()
  end if
end if
! Locate the first word
iFrst = 1
call NxtWrd(DDName,iFrst,iEnd)
Filenm = DDName(iFrst:iEnd)
DirName = DDName(iFrst:iEnd)
call UpCase(Filenm)
if (index(Filenm,'INLINE') /= 0) then
  inLn1 = .true.
  inLn2 = .true.
  inLn3 = .true.
else if (index(Filenm,'MM') /= 0) then
  dbsc(nCnttp)%IsMM = 1
  inLn1 = .true.
  inLn2 = .false.
  inLn3 = .false.
else
  inLn1 = .false.
  inLn2 = .false.
  inLn3 = .false.
end if
iFrst = iEnd+1
iEnd = len(DDName)
! Check the 2nd and the 3rd field
if (index(DDName(iFrst:iEnd),'INLINE') /= 0) then
  ! Here if T T or F T
  inLn3 = .true.
  ! Locate the 2nd field
  call NxtWrd(DDName,iFrst,iEnd)
  ! Check the 2nd field
  if (index(DDName(iFrst:iEnd),'INLINE') /= 0) then
    inLn2 = .true.
  else
    inLn2 = .false.
  end if
end if
if (IfTest) write(u6,*) inLn1,inLn2,inLn3

if (.not. inLn1) then
  lUnit = 11

  ! Find and decode basis set label

  call Rdbsl(DirName,BSLbl,bType,nCGTO,mCGTO,lAng,Itabmx,lUnit,dbsc(nCnttp)%AtmNr,BasisTypes,ExtBasDir)
  Line = Get_Ln(lUnit)
  Ref(1) = Line
  Line = Get_Ln(lUnit)
  Ref(2) = Line
else
  Hit = .true.
  call Decode(BSLbl,atom,1,Hit)
  dbsc(nCnttp)%AtmNr = Lbl2Nr(atom)
  lUnit = LuRd
  Ref(1) = ''
  Ref(2) = ''
  Hit = .true.
  call Decode(BSLBl(1:80),bType,2,Hit)
  Basis_Lib = ' '
  i = 1
  Basis_Lib = DefNm
  call Find_Basis_Set(Basis_Lib,' ',' ')
  i = StrnLn(Basis_Lib)
  call BasisType(Basis_Lib(1:i)//'/'//bType,0,BasisTypes)
end if
Line(1:3) = bType(1:3)
call UpCase(Line(1:3))
if (Line(1:3) == 'AUX') dbsc(nCnttp)%Aux = .true.
if (IfTest) then
  write(u6,'(A,A)') 'Ref(1):',trim(Ref(1))
  write(u6,'(A,A)') 'Ref(2):',trim(Ref(2))
end if
Uncontracted = BasisTypes(1) == 6
if (dbsc(nCnttp)%IsMM == 1) then
  lAng = 0
  dbsc(nCnttp)%Charge = Zero
  return
end if

! begin parsing options
isEorb = .false.
isFock = .false.
if (L_STDINP .and. inLn1) then  ! CGGn
  iSTDINP = iSTDINP+1           ! CGGn
  Line = STDINP(iSTDINP)        ! CGGn
else                            ! CGGn
  Line = Get_Ln(lUnit)
end if                          ! CGGn
if (Line == 'Options') then
  do
    Line = Get_Ln(lUnit)
    if (Line /= 'EndOptions') then
      if (Line == 'OrbitalEnergies') then
        if (IfTest) write(u6,*) 'Orbital energies are included'
        isEorb = .true.
      else if (Line == 'FockOperator') then
        if (IfTest) write(u6,*) 'Fock operator is included'
        isEorb = .true.
        isFock = .true.
      else if (Line(1:9) == 'Cartesian') then
        Line = Line(10:)
        call LoCase(Line)
        ! Only d or higher shells are tested
        if (index(Line,'all') /= 0) then
          Cart(2:) = .true.
        else
          do i=2,iTabMx
            if (index(Line,AngTp(i)) /= 0) Cart(i) = .true.
          end do
        end if
      else
        write(u6,*) 'Illegal option: ',Line
        call Abend()
      end if
    else
      exit
    end if
  end do
  Line = Get_Ln(lUnit)
end if
! end parsing options
if (IfTest) write(u6,'(A,A)') 'Line=',Line
if (L_STDINP .and. inLn1) then                         ! CGGn
  call Pick_Words(Line,2,Nwords,Words)                 ! CGGn
  if (Nwords /= 2) call Abend()                        ! CGGn
  call Get_dNumber(Words(1),dbsc(nCnttp)%Charge,iErr)  ! CGGn
  if (iErr /= 0) call Abend()                          ! CGGn
  call Get_iNumber(Words(2),lAng,iErr)                 ! CGGn
  if (iErr /= 0) call Abend()                          ! CGGn
else                                                   ! CGGn
  call get_f1(1,dbsc(nCnttp)%Charge)
  if (inLn1) call get_i1(2,lAng)
end if                                                 ! CGGn
if (iPrint >= 99) then
  write(u6,*) 'lAng, Charge=',lAng,dbsc(nCnttp)%Charge
  write(u6,*) ' Start reading valence basis'
end if
if (lAng > iTabMx) then
  write(u6,*) 'GetBS: lAng > iTabMx'
  write(u6,*) 'lAng,iTabMx=',lAng,iTabMx
  call Abend()
end if
! Loop over each shell type (s,p,d,etc....)
iValSh = iShll
dbsc(nCnttp)%nVal = lAng+1
mVal = 0
dbsc(nCnttp)%iVal = iShll+1
do iAng=0,lAng
  if (IfTest) write(u6,*) 'iAng=',iAng
  iShll = iShll+1
  if (iShll > MxShll) then
    write(u6,*) 'GetBS: iShll > MxShll'
    write(u6,*) 'iShll,MxShll=',iShll,MxShll
    call Abend()
  end if
  if (IfTest) then
    write(u6,'(A,A)') 'Line=',Line
    write(u6,*) L_STDINP,inLn1
  end if
  if (L_STDINP .and. inLn1) then            ! CGGn
    iSTDINP = iSTDINP+1                     ! CGGn
    Line = STDINP(iSTDINP)                  ! CGGn
    call Pick_Words(Line,2,Nwords,Words)    ! CGGn
    if (Nwords /= 2) call Abend()           ! CGGn
    call Get_iNumber(Words(1),nPrim,iErr)   ! CGGn
    if (iErr /= 0) call Abend()             ! CGGn
    call Get_iNumber(Words(2),nCntrc,iErr)  ! CGGn
    if (iErr /= 0) call Abend()             ! CGGn
    nCGTO(iAng) = 0                         ! CGGn
    mCGTO(iAng) = 0                         ! CGGn
  else                                      ! CGGn
    Line = Get_Ln(lUnit)
    if (IfTest) write(u6,'(A,A)') 'Line=',Line
    call Get_i1(1,nPrim)
    if (inLn1) then
      call Get_i1(2,nCntrc)
      nCGTO(iAng) = 0
      mCGTO(iAng) = 0
    else
      nCntrc = nCGTO(iAng)
    end if
  end if                                    ! CGGn
  if (IfTest) write(u6,*) ' nPrim, nCntrc=',nPrim,nCntrc

  Shells(iShll)%nExp = nPrim
  Shells(iShll)%nBasis_c = nCntrc
  if (Cart(iAng)) then
    Shells(iShll)%Transf = .false.
    Shells(iShll)%Prjct = .false.
  end if
  call mma_allocate(Shells(iShll)%Exp,nPrim,Label='Exp')
  ! Read gaussian exponents
  if (nPrim > 0) then
    if (IfTest) write(u6,*) 'Read gaussian exponents'
    call Read_v(lUnit,Shells(iShll)%Exp,1,nPrim,1,Ierr)
    if (Ierr /= 0) then
      call WarningMessage(2,'GetBS: Error while reading the exponents')
      call Quit_OnUserError()
    end if
    if (IfTest) write(u6,*) 'Done with exponents'
  end if
  if (iPrint >= 99) call RecPrt(' Exponents',' ',Shells(iShll)%Exp,nPrim,1)

  ! Storage of coefficients for both contracted and uncontracted case.

  call mma_allocate(Shells(iShll)%Cff_c,nPrim,nCntrc,2,Label='Cff_c')
  Shells(iShll)%Cff_c(:,:,1) = Zero
  call mma_allocate(Shells(iShll)%pCff,nPrim,nCntrc,Label='pCff')
  Shells(iShll)%nBasis = nCntrc
  call mma_allocate(Shells(iShll)%Cff_p,nPrim,nPrim,2,Label='Cff_p')
  ! Read contraction coefficients
  ! Observe that the matrix will have nPrim rows and nCntrc columns
  if (IfTest) then
    write(u6,'(2A)') ' Type=',bType
    write(u6,*) 'mCGTO(iAng)=',mCGTO(iAng)
    write(u6,*) 'nCGTO(iAng)=',nCGTO(iAng)
    write(u6,*) 'nCntrc=',nCntrc
  end if
  if (IfTest) write(u6,*) ' Read/Process coefficients'

  if ((inLn1 .or. (mCGTO(iAng) == nCntrc)) .or. (nCntrc == 0)) then
    ! Read in coeffs. in GC format, as the standard case
    if (IfTest) write(u6,*) ' Standard case'
    Shells(iShll)%Cff_c(:,:,:) = Zero
    if (UnContracted) then
      do i=1,nPrim
        Shells(iShll)%Cff_c(i,i,1) = One
      end do
    else
      do iPrim=1,nPrim
        call Read_v(lUnit,Shells(iShll)%Cff_c(1,1,1),iPrim,nCntrc*nPrim,nPrim,Ierr)
        if (Ierr /= 0) then
          call WarningMessage(2,'GetBS: Error reading coeffs in GC format')
          call Quit_OnUserError()
        end if
      end do
    end if

  else

    ! Here, we want nCntrc generally contracted functions (gcf)
    ! of nPrim primitives resulting from the mCGTO(iAng) gcfs
    ! of the library plus the nCntrc-mCGTO(iAng) outermost
    ! primitive functions of the unextended basis set, that is,
    ! of the basis set which excludes any added polarization or
    ! diffuse functions.
    ! (Note that everything is in generally contraction format.)
    ! Example:  library:.6s.3s.  + input:.6s.5s.   -->   result
    !                  x x 0                          x x 0 0 0
    !                  x x 0                          x x 0 0 0
    !                  x x 0                          x x 0 0 0
    !                  x x 0                          x x 1 0 0
    !                  x x 0                          x x 0 1 0
    !                  0 0 1                          0 0 0 0 1

    if (IfTest) write(u6,*) ' Initial GC + outermost primitives'
    if (nCntrc > nPrim) then
      call WarningMessage(2,'Number of contracted more than the number of primitive: correct the basis set label!')
      call Quit_OnUserError()
    end if
    call mma_allocate(Temp,nPrim,max(nCntrc,mCGTO(iAng)),Label='Temp')
    Temp(:,:) = Zero
    ! read the block in the library as it is
    do iPrim=1,nPrim
      call Read_v(lUnit,Temp,iPrim,nPrim*mCGTO(iAng),nPrim,Ierr)
      if (Ierr /= 0) then
        call WarningMessage(2,'GetBS: Error reading the block')
        call Quit_OnUserError()
      end if
    end do

    ! Order the exponents

    call OrdExp1(nPrim,Shells(iShll)%Exp,mCGTO(iAng),Temp)

    ! identify the presence of added polarization and diffusse functions;
    iAdded = 0
    ! Examine all the contracted functions starting with the last
    Outer: do jNow=mCGTO(iAng),1,-1
      iFlgOne = 0
      ! Examine the primitives
      do iNow=1,nPrim
        Coeff = Temp(iNow,jNow)
        ! Stop if it is obvious that this is not a diffuse
        ! or polarization function.
        if ((Coeff /= Zero) .and. (Coeff /= One)) exit Outer
        if (Coeff == One) then
          if (iFlgOne == 1) cycle Outer
          iFlgOne = 1
        end if
      end do
      iAdded = iAdded+1
      if (IfTest) write(u6,*) 'function',jNow,' is an added one'
    end do Outer

    nAdded = iAdded
    if (nAdded == mCGTO(iAng)) nAdded = 0
    if (IfTest) write(u6,*) ' nAdded=',nAdded
    if (nAdded > 0) then
      ! shift the added polarization and diffuse functions to the right
      do jNow=1,nAdded
        j1 = nCntrc-jNow+1
        j2 = mCGTO(iAng)-jNow+1
        do iNow=1,nPrim
          Temp(iNow,j1) = Temp(iNow,j2)
        end do
      end do
    end if
    ! insert/append the outermost primitives (in GC format)
    do jNow=mCGTO(iAng)+1-nAdded,nCntrc-nAdded
      if (IfTest) write(u6,*) 'jNow=',jNow
      Temp(:,jNow) = Zero
      j = jNow-(mCGTO(iAng)-nAdded)
      iPrevNow = nPrim-nAdded-(nCntrc-mCGTO(iAng))
      iNow = iPrevNow+j
      Temp(iNow,jNow) = One
    end do
    Shells(iShll)%Cff_c(:,:,1) = Temp(:,1:nCntrc)
    call mma_deallocate(Temp)
  end if

  if (IfTest) write(u6,*) ' Done! Now Process.'

  ! Order the exponents

  call OrdExp(nPrim,Shells(iShll)%Exp,nCntrc,Shells(iShll)%Cff_c(1,1,1))
  if (nPrim*nCntrc /= 0) mVal = mVal+1

  ! Decontract if integrals required in the primitive basis

  if (nPrim /= 0) then
    Shells(iShll)%Cff_p(:,:,1) = Zero
    do i=1,nPrim
      Shells(iShll)%Cff_p(i,i,1) = One
    end do

    ! Save the contraction coefficients once more after the coefficients.
    ! The second set will not be normalized!

    Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
    Shells(iShll)%Cff_c(:,:,2) = Shells(iShll)%Cff_c(:,:,1)
    Shells(iShll)%Cff_p(:,:,2) = Shells(iShll)%Cff_p(:,:,1)

    ! The normalization coefficients are assumed to be for
    ! normalized Gaussians. In Nrmlz the contraction coefficients are
    ! multiplied with the normalization coefficient of each primitive
    ! Gaussian. The contracted Gaussian are then normalized with respect
    ! the radial overlap.

    if (.not. UnNorm) then
      call Nrmlz(Shells(iShll)%Exp,nPrim,Shells(iShll)%Cff_c(1,1,1),nCntrc,iAng)
      call Nrmlz(Shells(iShll)%Exp,nPrim,Shells(iShll)%Cff_p(1,1,1),nPrim,iAng)
    end if

    if (iPrint >= 99) then
      nPrim = Shells(iShll)%nExp
      nCntrc = Shells(iShll)%nBasis_C
      call RecPrt(' Coefficients (normalized)',' ',Shells(iShll)%Cff_c(1,1,1),nPrim,nCntrc)
      call RecPrt(' Coefficients (unnormalized)',' ',Shells(iShll)%Cff_c(1,1,2),nPrim,nCntrc)
    end if
  end if
  if (nPrim == 0) cycle
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Begin read orbital energies

  call mma_allocate(Shells(iShll)%FockOp,nCntrc,nCntrc,Label='FockOp')
  Shells(iShll)%nFockOp = nCntrc
  Shells(iShll)%FockOp(:,:) = Zero

  if (isFock) then
    !dbsc(nCnttp)%FOp = dbsc(nCnttp)%FOp .and. .true.
    Line = Get_Ln(lUnit)
    call Get_i1(1,nEorb)
    call mma_allocate(Temp,nEorb,nEorb,Label='Temp')
    do i=1,nEorb
      Line = Get_Ln(lUnit)
      call Get_F(1,Temp(1,i),nEOrb)
    end do
    Shells(iShll)%FockOp(1:min(nEorb,nCntrc),1:min(nEorb,nCntrc)) = Temp(1:min(nEorb,nCntrc),1:min(nEorb,nCntrc))
    call mma_deallocate(Temp)
#   ifdef _DEBUGPRINT_
    call RecPrt('Fock',' ',Shells(iShll)%FockOp,nCntrc,nCntrc)
#   endif
  else if (isEorb) then
    !dbsc(nCnttp)%FOp = dbsc(nCnttp)%FOp .and. .true.
    Line = Get_Ln(lUnit)
    call Get_i1(1,nEorb)
    call mma_allocate(Temp,nEorb,1,Label='Temp')
    if (nEorb > 0) then
      Line = Get_Ln(lUnit)
      call Get_F(1,Temp(1,1),nEorb)
    end if
    do i=1,min(nEOrb,nCntrc)
      Shells(iShll)%FockOp(i,i) = Temp(i,1)
    end do
    call mma_deallocate(Temp)
#   ifdef _DEBUGPRINT_
    call RecPrt('Eorb',' ',Shells(iShll)%FockOp,nCntrc,nCntrc)
#   endif
  else
    dbsc(nCnttp)%FOp = .false.
#   ifdef _DEBUGPRINT_
    call RecPrt('Empty',' ',Shells(iShll)%FockOp,nCntrc,nCntrc)
#   endif
  end if

  !  End read orbital energies
  !                                                                    *
  !*********************************************************************
  !                                                                    *

end do
if (mVal == 0) dbsc(nCnttp)%nVal = 0
!***********************************************************************
!
! If PAM basis set read the potentials and coefficient!

if (inLn2 .and. (.not. inLn1)) then
  if (IfTest) write(u6,*) ' Close library and start to read from standard input'
  close(lUnit)
  lUnit = u5
end if
if (index(BSLBl,'.PAM.') /= 0) then
  if (IfTest) write(u6,*) ' Process PAM'
  dbsc(nCnttp)%lPAM2 = .true.
  if (iPrint >= 99) write(u6,*) ' Start reading PAMs'
  call GetPAM(lUnit,nCnttp)

  if (inLn3 .and. (.not. inLn2)) then
    close(lUnit)
    lUnit = u5
  end if
end if
!***********************************************************************
!
! If FRAGMENT basis set read the fragment's coordinates, basis sets,
! orbital energies and density matrix

if (inLn2 .and. (.not. inLn1)) then
  if (IfTest) write(u6,*) ' Close library and start to read from standard input'
  close(lUnit)
  lUnit = u5
end if
if (index(BSLBl,'.FRAGMENT.') /= 0) then
  if (IfTest) write(u6,*) ' Process FRAGMENT'
  if (iPrint >= 99) write(u6,*) ' Start reading fragment data'
  call GetFragment(lUnit,nCnttp)

  if (inLn3 .and. (.not. inLn2)) then
    close(lUnit)
    lUnit = u5
  end if
end if
!***********************************************************************
!
! If ECP basis set read the rest!

if (inLn2 .and. (.not. inLn1)) then
  if (IfTest) write(u6,*) ' Close library and start to read from standard input'
  close(lUnit)
  lUnit = u5
end if

nProj = -1
nAIMP = -1
mSOC = -1
if ((index(BSLBl,'.ECP.') /= 0) .or. (index(BSLBl,'.REL.') /= 0)) then
  if (IfTest) write(u6,*) ' Process ECPs/RELs'
  dbsc(nCnttp)%ECP = .true.
  iPrSh = iShll
  if (iPrint >= 99) write(u6,*) ' Start reading ECPs/RELs'
  dbsc(nCnttp)%iPrj = iShll+1
  call GetECP(lUnit,iShll,nProj,UnNorm)
  dbsc(nCnttp)%nPrj = nProj+1

  if (inLn3 .and. (.not. inLn2)) then
    close(lUnit)
    lUnit = u5
  end if

  ! Now read the spectral resolvent basis set
  !Line = GetLn(lUnit)
  Line = Get_Ln(lUnit)
  call UpCase(Line)
  if (index(Line,'SPEC') == 0) then
    call WarningMessage(2,'ERROR: Keyword SPECTRAL expected, offending line : '//Line)
    call Quit_OnUserError()
  end if

  iMPShll = iShll
  do
    Line = Get_Ln(lUnit)
    call UpCase(Line)
    select case (Line(1:4))

      case default
        call WarningMessage(2,' Invalid keyword in GetBS;'//Line)
        call Quit_OnUserError()

      case (KWord(1)) ! END
        exit

      case (KWord(2)) ! VALE
        ! Valence basis set

        if (nAIMP /= -1) then
          call WarningMessage(2,' SR basis set is already defined!')
          call Quit_OnUserError()
        end if
        nAIMP = lAng
        dbsc(nCnttp)%nSRO = nAIMP+1
        dbsc(nCnttp)%iSRO = iShll+1
        jValSh = iValSh
        do iAIMP=0,nAIMP
          iShll = iShll+1
          if (iShll > MxShll) then
            write(u6,*) 'GetBS: iShll > MxShll'
            write(u6,*) 'iShll,MxShll=',iShll,MxShll
            call Abend()
          end if
          jValSh = jValSh+1
          call mma_allocate(Shells(iShll)%Exp,Shells(jValSh)%nExp,Label='Exp')
          Shells(iShll)%Exp(:) = Shells(jValSh)%Exp(:)
          Shells(iShll)%nExp = Shells(jValSh)%nExp
          Shells(iShll)%nBasis = 0
        end do

      case (KWord(3)) ! CORE
        ! Core basis set

        if (nAIMP /= -1) then
          call WarningMessage(2,' SR basis set is already defined!')
          call Quit_OnUserError()
        end if
        nAIMP = nProj
        dbsc(nCnttp)%nSRO = nAIMP+1
        dbsc(nCnttp)%iSRO = iShll+1
        jPrSh = iPrSh
        do iAIMP=0,nAIMP
          iShll = iShll+1
          if (iShll > MxShll) then
            write(u6,*) 'GetBS: iShll > MxShll'
            write(u6,*) 'iShll,MxShll=',iShll,MxShll
            call Abend()
          end if
          jPrSh = jPrSh+1
          call mma_allocate(Shells(iShll)%Exp,Shells(jPrSh)%nExp,Label='Exp')
          Shells(iShll)%Exp(:) = Shells(jPrSh)%Exp(:)
          Shells(iShll)%nExp = Shells(jPrSh)%nExp
          Shells(iShll)%nBasis = 0
        end do

      case (KWord(4)) ! EXTE
        ! External basis set

        if (nAIMP /= -1) then
          call WarningMessage(2,' SR basis set is already defined!')
          call Quit_OnUserError()
        end if
        !Line = GetLn(lUnit)
        Line = Get_Ln(lUnit)
        call Get_i1(1,nAIMP)
        dbsc(nCnttp)%nSRO = nAIMP+1
        dbsc(nCnttp)%iSRO = iShll+1
        do iAIMP=0,nAIMP
          iShll = iShll+1
          if (iShll > MxShll) then
            write(u6,*) 'GetBS: iShll > MxShll'
            write(u6,*) 'iShll,MxShll=',iShll,MxShll
            call Abend()
          end if
          Line = Get_Ln(lUnit)
          call Get_i1(1,nPrim)
          call mma_allocate(Shells(iShll)%Exp,nPrim,Label='Exp')
          Shells(iShll)%nExp = nPrim
          Shells(iShll)%nBasis = 0

          if (nPrim > 0) then
            call read_v(lUnit,Shells(iShll)%Exp,1,nPrim,1,Ierr)
            if (Ierr /= 0) then
              call WarningMessage(2,'GetBS: Error reading SRO exponents')
              call Quit_OnUserError()
            end if
          end if

        end do

      case (KWord(5)) ! NOPA
        ! Exchange operator

        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,0)

      case (KWord(6)) ! 1STO
        ! 1st order relativistic correction

        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,1)
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,2)
        Line = Get_Ln(lUnit)
        MPLbl = Line(1:20)

      case (KWord(7)) ! NOPA
        ! one-centre no-pair operators

        dbsc(nCnttp)%NoPair = .true.
        dbsc(nCnttp)%SODK = .true.
        if ((IRELMP >= 0) .and. (IRELMP /= 0)) call Error()
        IRELMP = 0
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,3)

      case (KWord(8)) ! NOP1
        ! one-centre no-pair operators (DK1)

        dbsc(nCnttp)%NoPair = .true.
        dbsc(nCnttp)%SODK = .true.
        if ((IRELMP >= 0) .and. (IRELMP /= 1)) call Error()
        IRELMP = 1
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,3)

      case (KWord(9)) ! NOP2
        ! one-centre no-pair operators (DK2)

        dbsc(nCnttp)%NoPair = .true.
        dbsc(nCnttp)%SODK = .true.
        if ((IRELMP >= 0) .and. (IRELMP /= 2)) call Error()
        IRELMP = 2
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,3)

      case (KWord(10)) ! NOP3
        ! one-centre no-pair operators (DK3)

        dbsc(nCnttp)%NoPair = .true.
        dbsc(nCnttp)%SODK = .true.
        if ((IRELMP >= 0) .and. (IRELMP /= 3)) call Error()
        IRELMP = 3
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,3)

      case (KWord(11)) ! NOPF
        ! one-centre no-pair operators (DK3)

        dbsc(nCnttp)%NoPair = .true.
        dbsc(nCnttp)%SODK = .true.
        if ((IRELMP >= 0) .and. (IRELMP /= 4)) call Error()
        IRELMP = 4
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,3)

      case (KWord(12)) ! RESC
        ! one-centre RESC operators

        dbsc(nCnttp)%NoPair = .true.
        if ((IRELMP >= 0) .and. (IRELMP /= 11)) call Error()
        IRELMP = 11
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,3)

      case (KWord(13)) ! RA0H
        ! one-centre ZORA operators

        dbsc(nCnttp)%NoPair = .true.
        if ((IRELMP >= 0) .and. (IRELMP /= 21)) call Error()
        IRELMP = 21
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,3)

      case (KWord(14)) ! RA0F
        ! one-centre ZORA-FP operators

        dbsc(nCnttp)%NoPair = .true.
        dbsc(nCnttp)%SODK = .true.
        if ((IRELMP >= 0) .and. (IRELMP /= 22)) call Error()
        IRELMP = 22
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,3)

      case (Kword(15)) ! RAIH
        ! one-centre IORA operators

        dbsc(nCnttp)%NoPair = .true.
        dbsc(nCnttp)%SODK = .true.
        if ((IRELMP >= 0) .and. (IRELMP /= 23)) call Error()
        IRELMP = 23
        dbsc(nCnttp)%nOpt = ibset(dbsc(nCnttp)%nOpt,3)

      case (KWord(16)) ! MIXE
        ! Mixed basis set (valence + core), with dominance of the
        ! valence basis set, i.e. the valence basis set plus those
        ! exponents in the core primitives not too close to the
        ! valence ones.

        if (nAIMP /= -1) then
          call WarningMessage(2,' SR basis set is already defined!')
          call Quit_OnUserError()
        end if

        ! Threshold for the ratio between consecutive exponents
        ! (if the ratio between two consecutive exponents is lower
        ! than the threshold, the exponent of the core basis set
        ! will be removed)

        Line = Get_Ln(lUnit)
        call Get_F1(1,RatioThres)

        nAIMP = lAng
        dbsc(nCnttp)%iSRO = iShll+1
        dbsc(nCnttp)%nSRO = nAIMP+1
        jValSh = iValSh
        jPrSh = iPrSh

        do iAIMP=0,nAIMP
          iShll = iShll+1
          if (iShll > MxShll) then
            write(u6,*) 'GetBS: iShll > MxShll'
            write(u6,*) 'iShll,MxShll=',iShll,MxShll
            call Abend()
          end if

          jValSh = jValSh+1
          nCntrc = Shells(jValSh)%nBasis

          if (iAIMP <= nProj) then
            jPrSh = jPrSh+1

            iDominantSet = 2
            call mma_allocate(ExpMerged,Shells(jPrSh)%nExp+Shells(jValSh)%nExp,Label='ExpMerged')
            call MergeBS(Shells(jPrSh)%Exp,Shells(jPrSh)%nExp,Shells(jValSh)%Exp,Shells(jValSh)%nExp,ExpMerged,Shells(iShll)%nExp, &
                         RatioThres,iDominantSet)
            call mma_allocate(Shells(iShll)%Exp,Shells(iShll)%nExp,Label='Exp')
            Shells(iShll)%Exp(:) = ExpMerged(1:Shells(iShll)%nExp)
            call mma_deallocate(ExpMerged)

          else

            Shells(iShll)%nExp = Shells(jValSh)%nExp
            call mma_allocate(Shells(iShll)%Exp,Shells(iShll)%nExp,Label='Exp')
            Shells(iShll)%Exp(:) = Shells(jValSh)%Exp(:)

          end if

          Shells(iShll)%nBasis = 0

        end do

      case (KWord(17)) ! SOC
        ! SOC basis set

        if (mSOC /= -1) then
          call WarningMessage(2,' SOC basis set is already defined!')
          call Quit_OnUserError()
        end if

        dbsc(nCnttp)%iSOC = iShll+1
        Line = Get_Ln(lUnit)
        call Get_I1(1,mSOC)
        dbsc(nCnttp)%nSOC = mSOC+1
        if (IfTest) write(u6,'(A,I4)') 'dbsc(nCnttp)%nSOC =',dbsc(nCnttp)%nSOC
        if (mSOC >= 0) then
          do iAng=0,mSOC
            if (IfTest) write(u6,'(A,I4)') ' iAng=',iAng
            iShll = iShll+1
            if (iShll > MxShll) then
              call WarningMessage(2,'Abend in GetBS: Increase MxShll')
              call Quit_OnUserError()
            end if
            Line = Get_Ln(lUnit)
            call Get_I1(1,nPrim)
            call Get_I1(2,nCntrc)
            call Get_I1(3,mDel)
            dbsc(nCnttp)%kDel(iAng) = mDel
            if (IfTest) write(u6,*) 'nPrim = ',nPrim,' nCntrc = ',nCntrc
            if (IfTest) write(u6,*) 'nDeleted = ',mDel
            call mma_allocate(Shells(iShll)%Exp,nPrim,Label='Exp')
            Shells(iShll)%nExp = nPrim
            Shells(iShll)%nBasis = nCntrc
            if (IfTest) write(u6,*) 'getBS: ishll,nCntrc',ishll,nCntrc
            if (IfTest) write(u6,'(A)') ' Reading Exponents'
            if (nPrim > 0) call Read_v(lUnit,Shells(iShll)%Exp,1,nPrim,1,ierr)
            if (IfTest) call RecPrt('Exponents',' ',Shells(iShll)%Exp,1,nPrim)
            call mma_allocate(Shells(iShll)%Cff_c,nPrim,nCntrc,2,Label='Cff_c')
            call mma_allocate(Shells(iShll)%pCff,nPrim,nCntrc,Label='pCff')
            Shells(iShll)%nBasis = nCntrc
            call mma_allocate(Shells(iShll)%Cff_p,nPrim,nPrim,2,Label='Cff_p')
            Shells(iShll)%Cff_p(:,:,:) = Zero
            if (IfTest) write(u6,'(A)') ' Reading coefficients'
            do iPrim=1,nPrim
              call Read_v(lUnit,Shells(iShll)%Cff_c(1,1,1),iPrim,nPrim*nCntrc,nPrim,ierr)
            end do

            Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
            Shells(iShll)%Cff_c(:,:,2) = Shells(iShll)%Cff_c(:,:,1)
            Shells(iShll)%Cff_p(:,:,2) = Shells(iShll)%Cff_p(:,:,1)

            if (IfTest) call RecPrt('Coefficients',' ',Shells(iShll)%Cff_c(1,1,1),nPrim,nCntrc)

          end do
        end if

      case (KWord(18)) ! DKSO
        ! Use DKSO on request

        dbsc(nCnttp)%SODK = .true.

    end select
  end do
  if (btest(dbsc(nCnttp)%nOpt,1) .and. btest(dbsc(nCnttp)%nOpt,3)) then
    call WarningMessage(2,' 1st order relativistic correction and no-pair approximation can not be used simultaneously!')
    call Quit_OnUserError()
  end if
  if (nAIMP >= 0) then
    Basis_Lib = DefNm
    call Find_Basis_Set(Basis_Lib,' ',' ')
    Filename = trim(Basis_Lib)//'/QRPLIB'
    call f_Inquire(Filename,Found)
    if (.not. Found) then
      write(u6,*) 'File '//trim(Filename)//' not found'
      call abend()
    end if
    LUQRP = 33
    call molcas_open(LUQRP,Filename)
    !open(LUQRP,file='QRPLIB',form='formatted')
    call CalcAMt(dbsc(nCnttp)%nOpt,LUQRP,MPLbl,nAIMP,iMPShll+1,nProj,iPrSh+1,real(dbsc(nCnttp)%AtmNr,kind=wp))
    close(LUQRP)
  end if
end if

lAng = max(lAng,nProj,nAIMP)
if (.not. inLn3) close(lUnit)

return

contains

subroutine Error()

  call WarningMessage(2,'Mixing of iRELMP values')
  call Untested('GetBS')

end subroutine Error

end subroutine GetBS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine bufio_chbuf_cvb(jbuf)
c  Change buffer position to JBUF. NB: Does not write current buffer,
c  neither is JBUF buffer read.
      implicit real*8 (a-h,o-z)
#include "bufio_cvb.fh"
#include "idbl_cvb.fh"

c  Dumy writes so that we don't exceed end-of-file:
      do 100 kbuf=nbuf+1,jbuf-1
      ibuf=kbuf
      call bufio_wrzbuf_cvb()
100   continue
      ibuf=jbuf
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine evb2cas_cvb(orbs,cvb,fx,ioptc,iter)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension orbs(norb,norb),cvb(nvb)

      if(tstfile_cvb(66000.2d0))then
        i1=mstackr_cvb(norb*norb+nvb)
        call rdr_cvb(w(i1),norb*norb+nvb,66000.2d0,0)
        call subvec(w(i1),orbs,w(i1),norb*norb)
        call subvec(w(norb*norb+i1),cvb,w(norb*norb+i1),nvb)
        dxnrm=dnrm2_(norb*norb+nvb,w(i1),1)
        call findamx_cvb(w(i1),norb*norb+nvb,dx_amx,idum)
        call mfreer_cvb(i1)
      endif
      call wrr_cvb(orbs,norb*norb,66000.2d0,0)
      call wrr_cvb(cvb,nvb,66000.2d0,norb*norb)
      call evb2cas2_cvb(orbs,cvb,ioptc,iter,fx,
     >  dxnrm,dx_amx,
     >  w(lc(1)),w(lc(2)),w(lc(3)),w(lc(4)),w(lc(5)),
     >  w(lw(2)),w(lw(3)))
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TSHinit(Energy)

use rasdef, only: NRAS, NRASEL, NRS1, NRS1T, NRS2, NRS3, NRSPRT
use rassi_aux, only: ipglob
use rassi_global_arrays, only: JBNUM, LROOT, PART
use sguga, only: CIStruct, EXStruct, SG_Free, SGStruct
use Cntrl, only: ChkHop, IRREP, ISTATE1, ISTATE2, LSYM1, LSYM2, MLTPLT, NACTE, nCI1, nCI2, NELE3, NHOLE1, NSTATE, RASTYP
use Symmetry_Info, only: nIrrep
use rassi_data, only: NDEL, NFRO, NISH, NSSH
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Energy(nState)
integer(kind=iwp) :: iRlxRoot, JOB1, JOB2, MPLET1, MPLET2, NACTE1, NACTE2, NELE31, NELE32, NHOL11, NHOL12
real(kind=wp) :: EDIFF
logical(kind=iwp) :: LOWROOT, UPROOT
type(SGStruct) :: SGS(2)
type(CIStruct) :: CIS(2)
type(EXStruct) :: EXS(2)
character(len=8) :: WFTYP1, WFTYP2
real(kind=wp), allocatable :: CI1(:), CI2(:)
real(kind=wp), parameter :: Ethr = 0.03_wp

! Print a banner

if (IPGLOB >= 2) then
  write(u6,*)
  write(u6,*)
  write(u6,'(6X,A)') repeat('*',100)
  write(u6,'(6X,A,98X,A)') '*','*'
  write(u6,'(6X,A,36X,A,37X,A)') '*',' Surface hopping section ','*'
  write(u6,'(6X,A,98X,A)') '*','*'
  write(u6,'(6X,A)') repeat('*',100)
  write(u6,*)
  write(u6,*)

  write(u6,'(6X,A)') 'Surface hopping section'
  write(u6,'(6X,A)') '-----------------------'
end if

! Get the current state and print it's energy

call Get_iScalar('Relax CASSCF root',iRlxRoot)
if (IPGLOB >= 2) then
  write(u6,'(6X,A,I14)') 'The current state is:',iRlxRoot
  write(u6,'(6X,A,6X,ES15.6,A,/)') 'Its energy is:',ENERGY(iRlxRoot),' a.u.'
end if

! Get wave function parameters for current state

ISTATE1 = iRlxRoot
JOB1 = JBNUM(ISTATE1)
NACTE1 = NACTE(JOB1)
MPLET1 = MLTPLT(JOB1)
LSYM1 = IRREP(JOB1)
NHOL11 = NHOLE1(JOB1)
NELE31 = NELE3(JOB1)
WFTYP1 = RASTYP(JOB1)
SGS(1)%IFRAS = 1
SGS(2)%IFRAS = 1

! Set the variables for the wave function of the current state

if (WFTYP1 == 'GENERAL') then
  NRSPRT = 3
  NRAS(:,1) = NRS1(:)
  NRAS(:,2) = NRS2(:)
  NRAS(:,3) = NRS3(:)
  NRASEL(1) = 2*NRS1T-NHOL11
  NRASEL(2) = NACTE1-NELE31
  NRASEL(3) = NACTE1
  call SG_Setup_RASSI(nIrrep,NACTE1,MPLET1,SGS(1),CIS(1))
  if (IPGLOB > 4) then
    write(u6,*) 'Split-graph structure for JOB1=',JOB1
    call SG_Print(SGS(1))
  end if
  call SG_CXInit(SGS(1),CIS(1),EXS(1))
  ! CI sizes, as function of symmetry, are now known.
  NCI1 = CIS(1)%NCSF(LSYM1)
else
  ! The only other cases are HISPIN, CLOSED or EMPTY.
  ! NOTE: The HISPIN case is suspected to be buggy. Not used now.
  NCI1 = 1
end if
call mma_allocate(CI1,NCI1,Label='CI1')

! Check for the possibility to hop to a lower root

if ((ISTATE1-1) >= 1) then
  LOWROOT = .true.
  if (IPGLOB >= 2) write(u6,'(6X,A,I2)') 'There is a lower root, which is: ',LROOT(ISTATE1-1)
else
  LOWROOT = .false.
  if (IPGLOB >= 2) write(u6,'(6X,A)') 'There is no lower root'
end if

! Check for the possibility to hop to an upper root

if ((ISTATE1+1) <= NSTATE) then
  UPROOT = .true.
  if (IPGLOB >= 2) write(u6,'(6X,A,I2,/)') 'There is an upper root, which is: ',LROOT(ISTATE1+1)
else
  UPROOT = .false.
  if (IPGLOB >= 2) write(u6,'(6X,A,/)') 'There is no upper root'
end if

! Check surface hopping to a root lower than the current one

if (LOWROOT) then
  ISTATE2 = ISTATE1-1
  if (IPGLOB >= 2) then
    write(u6,'(6X,A,I3)') 'The lower state is:',ISTATE2
    write(u6,'(6X,A,6X,ES15.6,A)') 'Its energy is:',ENERGY(ISTATE2),' a.u.'
    write(u6,'(6X,A,12X,ES15.6,A,/)') 'Ediff = ',ENERGY(iRlxRoot)-ENERGY(ISTATE2),' a.u.'
  end if
  !--------------------------------------------------------------------*
  ! Adapted from RASSI subroutines GTMCTL and READCI                   *

  ! Get wave function parameters for ISTATE2
  JOB2 = JBNUM(ISTATE2)
  NACTE2 = NACTE(JOB2)
  MPLET2 = MLTPLT(JOB2)
  LSYM2 = IRREP(JOB2)
  NHOL12 = NHOLE1(JOB2)
  NELE32 = NELE3(JOB2)
  WFTYP2 = RASTYP(JOB2)
  call NEWPRTTAB(nIrrep,NFRO,NISH,NRS1,NRS2,NRS3,NSSH,NDEL)
  if (IPGLOB >= 4) call PRPRTTAB(PART)
  ! For the second wave function
  if (WFTYP2 == 'GENERAL') then
    NRSPRT = 3
    NRAS(:,1) = NRS1(:)
    NRAS(:,2) = NRS2(:)
    NRAS(:,3) = NRS3(:)
    NRASEL(1) = 2*NRS1T-NHOL12
    NRASEL(2) = NACTE2-NELE32
    NRASEL(3) = NACTE2
    call SG_Setup_RASSI(nIrrep,NACTE2,MPLET2,SGS(2),CIS(2))
    if (IPGLOB > 4) then
      write(u6,*) 'Split-graph structure for JOB2=',JOB2
      call SG_Print(SGS(2))
    end if
    call SG_CXInit(SGS(2),CIS(2),EXS(2))
    ! CI sizes, as function of symmetry, are now known.
    NCI2 = CIS(2)%NCSF(LSYM2)
  else
    ! Presently, the only other cases are HISPIN, CLOSED or EMPTY.
    NCI2 = 1
  end if
  call mma_allocate(CI2,NCI2,Label='CI2')
  ! Check if the Energy gap is smaller than the threshold.
  Ediff = abs(ENERGY(ISTATE2)-ENERGY(ISTATE1))
  if (Ediff <= Ethr) then
    ChkHop = .true.
  else
    ChkHop = .false.
  end if
  if (IPGLOB >= 2) then
    write(u6,'(6X,A,I8,4X,A,I8)') 'ISTATE1=',iRlxRoot,'ISTATE2=',ISTATE2
    write(u6,'(6X,A,I11,4X,A,I11)') 'NCI1=',NCI1,'NCI2=',NCI2
  end if
# ifdef _DEBUGPRINT_
  write(u6,*) ' TSHinit calls TSHop.'
# endif
  call TSHop(CI1,CI2)
# ifdef _DEBUGPRINT_
  write(u6,*) ' TSHinit back from TSHop.'
# endif
  if (WFTYP2 == 'GENERAL') call SG_Free(SGS(2),CIS(2),EXS(2))
  call mma_deallocate(CI2)
  call mma_deallocate(PART)
end if

! Check surface hopping to a root higher than the current one

if (UPROOT) then
  ISTATE2 = ISTATE1+1
  if (IPGLOB >= 2) then
    write(u6,'(6X,A,I3)') 'The upper state is:',ISTATE2
    write(u6,'(6X,A,6X,ES15.6,A)') 'Its energy is:',ENERGY(ISTATE2),' a.u.'
    write(u6,'(6X,A,12X,ES15.6,A,/)') 'Ediff = ',ENERGY(ISTATE2)-ENERGY(iRlxRoot),' a.u.'
  end if
  !--------------------------------------------------------------------*
  ! Adapted from RASSI subroutines GTMCTL and READCI                   *

  ! Get wave function parameters for ISTATE2
  JOB2 = JBNUM(ISTATE2)
  NACTE2 = NACTE(JOB2)
  MPLET2 = MLTPLT(JOB2)
  LSYM2 = IRREP(JOB2)
  NHOL12 = NHOLE1(JOB2)
  NELE32 = NELE3(JOB2)
  WFTYP2 = RASTYP(JOB2)
  call NEWPRTTAB(nIrrep,NFRO,NISH,NRS1,NRS2,NRS3,NSSH,NDEL)
  if (IPGLOB >= 4) call PRPRTTAB(PART)
  ! For the second wave function
  if (WFTYP2 == 'GENERAL') then
    NRSPRT = 3
    NRAS(:,1) = NRS1(:)
    NRAS(:,2) = NRS2(:)
    NRAS(:,3) = NRS3(:)
    NRASEL(1) = 2*NRS1T-NHOL12
    NRASEL(2) = NACTE2-NELE32
    NRASEL(3) = NACTE2
    call SG_Setup_RASSI(nIrrep,NACTE2,MPLET2,SGS(2),CIS(2))
    if (IPGLOB > 4) then
      write(u6,*) 'Split-graph structure for JOB2=',JOB2
      call SG_Print(SGS(2))
    end if
    call SG_CXInit(SGS(2),CIS(2),EXS(2))
    ! CI sizes, as function of symmetry, are now known.
    NCI2 = CIS(2)%NCSF(LSYM2)
  else
    ! Presently, the only other cases are HISPIN, CLOSED or EMPTY.
    NCI2 = 1
  end if
  call mma_allocate(CI2,NCI2,Label='CI2')
  ! Check if the Energy gap is smaller than the threshold.
  Ediff = abs(ENERGY(ISTATE2)-ENERGY(ISTATE1))
  if (Ediff <= Ethr) then
    ChkHop = .true.
  else
    ChkHop = .false.
  end if
  if (IPGLOB >= 2) then
    write(u6,'(6X,A,I8,4X,A,I8)') 'ISTATE1=',iRlxRoot,'ISTATE2=',ISTATE2
    write(u6,'(6X,A,I11,4X,A,I11)') 'NCI1=',NCI1,'NCI2=',NCI2
  end if
# ifdef _DEBUGPRINT_
  write(u6,*) ' TSHinit calls TSHop.'
# endif
  call TSHop(CI1,CI2)
# ifdef _DEBUGPRINT_
  write(u6,*) ' TSHinit back from TSHop.'
# endif
  if (WFTYP2 == 'GENERAL') call SG_Free(SGS(2),CIS(2),EXS(2))
  call mma_deallocate(CI2)
  call mma_deallocate(PART)
end if

if (WFTYP1 == 'GENERAL') then
  call SG_Free(SGS(1),CIS(1),EXS(1))
end if
call mma_deallocate(CI1)

end subroutine TSHinit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991-1994, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE RSBB2BN(IASM,IATP,IBSM,IBTP,NIA,NIB,
     &                  JASM,JATP,JBSM,JBTP,NJA,NJB,
     &                  IAGRP,IBGRP,
     &                  IAEL1,IAEL3,JAEL1,JAEL3,
     &                  IBEL1,IBEL3,JBEL1,JBEL3,
     &                  SB,CB,
     &                  ADSXA,STSTSX,
     &                  NTSOB,IBTSOB,ITSOB,MAXK,
     &                  SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,
     &                  XINT,
     &                  NSMOB,NSMST,NSMSX,NSMDX,MXPOBS,IUSEAB,
     &                  ICJKAIB,CJRES,SIRES,S2,NTEST,ISIGN,ieaw,
     &                  TimeDep)
*
* Combined alpha-beta double excitation
* contribution from given C block to given S block
*. If IUSAB only half the terms are constructed
* =====
* Input
* =====
*
* IASM,IATP : Symmetry and type of alpha  strings in sigma
* IBSM,IBTP : Symmetry and type of beta   strings in sigma
* JASM,JATP : Symmetry and type of alpha  strings in C
* JBSM,JBTP : Symmetry and type of beta   strings in C
* NIA,NIB : Number of alpha-(beta-) strings in sigma
* NJA,NJB : Number of alpha-(beta-) strings in C
* IAGRP : String group of alpha strings
* IBGRP : String group of beta strings
* IAEL1(3) : Number of electrons in RAS1(3) for alpha strings in sigma
* IBEL1(3) : Number of electrons in RAS1(3) for beta  strings in sigma
* JAEL1(3) : Number of electrons in RAS1(3) for alpha strings in C
* JBEL1(3) : Number of electrons in RAS1(3) for beta  strings in C
* CB   : Input C block
* ADSXA : sym of a+, a+a => sym of a
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
* NTSOB  : Number of orbitals per type and symmetry
* IBTSOB : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* NSMOB,NSMST,NSMSX : Number of symmetries of orbitals,strings,
*       single excitations
* MAXK   : Largest number of inner resolution strings treated at simult.
*
* ICJKAIB =1 =>  construct C(Ka,Jb,j) and S(Ka,Ib,i) as intermediate
*                 matrices in order to reduce overhead
*
* ======
* Output
* ======
* SB : updated sigma block
*
* =======
* Scratch
* =======
*
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* I2, XI2S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* H : Space for two electron integrals
*
* Jeppe Olsen, Winter of 1991
*
* Feb 92 : Loops restructured ; Generation of I2,XI2S moved outside
* October 1993 : IUSEAB added
* January 1994 : Loop restructured + ICJKAIB introduced
* February 1994 : Fetching and adding to transposed blocks
*
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
      Logical TimeDep
      INTEGER ADSXA(MXPOBS,MXPOBS),STSTSX(NSMST,NSMST)
      INTEGER NTSOB(3,*),IBTSOB(3,*),ITSOB(*)
*.Input
      DIMENSION CB(*)
*.Output
      DIMENSION SB(*)
*.Scratch
      DIMENSION SSCR(*),CSCR(*),I1(MAXK,*),XI1S(MAXK,*)
      DIMENSION I2(MAXK,*),XI2S(MAXK,*)
      DIMENSION I3(MAXK,*),XI3S(MAXK,*)
      DIMENSION I4(MAXK,*),XI4S(MAXK,*)
      DIMENSION XINT(*)
      DIMENSION CJRES(*),SIRES(*)
      DIMENSION S2(*)
*.Local arrays
      DIMENSION ITP(3),JTP(3),KTP(3),LTP(3)
*
      ZERO = 0.0D0
      ONEM = -1.0D0
*     IUSEAB = 0
*     ICJKAIB = 1
      IROUTE = 1
*. Symmetry of allowed excitations
      IJSM = STSTSX(IASM,JASM)
      KLSM = STSTSX(IBSM,JBSM)
      IF(IJSM.EQ.0.OR.KLSM.EQ.0) GOTO 9999
*.Types of SX that connects the two strings
      CALL SXTYP(NKLTYP,KTP,LTP,IBEL1,IBEL3,JBEL1,JBEL3)
      CALL SXTYP(NIJTYP,ITP,JTP,IAEL1,IAEL3,JAEL1,JAEL3)
      IF(NIJTYP.EQ.0.OR.NKLTYP.EQ.0) GOTO 9999
      DO 2001 IJTYP = 1, NIJTYP
        ITYP = ITP(IJTYP)
        JTYP = JTP(IJTYP)
****. TESTTING
        N1IND = 0
        N2IND = 0
        N3IND = 0
        IF(ITYP.EQ.1) N1IND = N1IND + 1
        IF(ITYP.EQ.2) N2IND = N2IND + 1
        IF(ITYP.EQ.3) N3IND = N3IND + 1
*
        IF(JTYP.EQ.1) N1IND = N1IND + 1
        IF(JTYP.EQ.2) N2IND = N2IND + 1
        IF(JTYP.EQ.3) N3IND = N3IND + 1
*
        DO 1940 ISM = 1, NSMOB
          JSM = ADSXA(ISM,IJSM)
          IF(JSM.EQ.0) GOTO 1940
          IOFF = IBTSOB(ITYP,ISM)
          JOFF = IBTSOB(JTYP,JSM)
          NI = NTSOB(ITYP,ISM)
          NJ = NTSOB(JTYP,JSM)
          IF(NI.EQ.0.OR.NJ.EQ.0) GOTO 1940
*. Loop over batches of KA strings
          KABOT = 1 - MAXK
          KATOP = 0
 1801     CONTINUE
            KABOT = KABOT + MAXK
            KATOP = KATOP + MAXK
*. Find Ka strings that connect with Ja strings for given group of Jorbs
           CALL ADST(JOFF,NJ,JATP,JASM,IAGRP,KABOT,KATOP,
     &              I1(1,1),XI1S(1,1),MAXK,NKABTC,KAEND)
           CALL ADST(IOFF,NI,IATP,IASM,IAGRP,KABOT,KATOP,
     &               I3(1,1),XI3S(1,1),MAXK,NKABTC,KAEND)
           IF(NKABTC.EQ.0) GOTO 1940
*. Generate - if required C(Ka,Jb,j)
           IF(ICJKAIB.NE.0) THEN
             IIOFF = 1
             LCJ = NJB*NKABTC
             DO JJ = 1, NJ
               IF(JJ.EQ.1) THEN
                 IIOFF = 1
               ELSE
                 IIOFF = IIOFF + LCJ
               END IF
                CALL GATRMT(CB,NJA,NJB,CJRES(IIOFF),NKABTC,NJB,
     &                      I1(1,JJ),XI1S(1,JJ) )
             End Do
*
*. We have now C gathered in the form C(Ka,Jb,j).
*. If Ka is small, say 1, it can be advantageous to switch
* around to C(j,Ka,Jb). This is mediated by the switch IROUTE
* IROUTE = 1 : Normal (i.e. old) route,
* IROUTE = 2 : New route with j first
* IROUTE = 3 : C(Ka,j,Jb)
*
             IF(NJ.GE.NKABTC.AND.NI.GE.NKABTC ) THEN
               IROUTE = 2
             ELSE
                IROUTE = 3
             END IF
* DOES THIS WORK?
C9805EAW     IROUTE = 1
             If (TimeDep) IROUTE=1
*
             IF(IROUTE.EQ.2) THEN
*. C(Ka,Jb,j) => C(j,Ka,Jb)
               CALL TRPMAT(CJRES,LCJ,NJ,SIRES)
               CALL DCOPY_(NJ*LCJ,SIRES,1,CJRES,1)
             END IF
             IF(IROUTE.EQ.3) THEN
*. C(Ka,Jb,j) => C(Ka,j,JB)
               DO JB = 1,NJB
                 DO J = 1, NJ
                   IOFFIN = (J-1)*NJB*NKABTC+(JB-1)*NKABTC + 1
                   IOFFOUT =(JB-1)*NKABTC*NJ + (J-1)*NKABTC + 1
                   DO KA = 1, NKABTC
                     SIRES(IOFFOUT-1+KA) = CJRES(IOFFIN-1+KA)
                   END DO
                 END DO
               END DO
               CALL DCOPY_(NJ*LCJ,SIRES,1,CJRES,1)
             END IF
*
             CALL DCOPY_(NIB*NKABTC*NI,[ZERO],0,SIRES,1)

           END IF
*
           DO 2000 KLTYP = 1, NKLTYP
             KTYP = KTP(KLTYP)
             LTYP = LTP(KLTYP)
*. Testing
             N1IND = 0
             N2IND = 0
             N3IND = 0
             IF(ITYP.EQ.1) N1IND = N1IND + 1
             IF(ITYP.EQ.2) N2IND = N2IND + 1
             IF(ITYP.EQ.3) N3IND = N3IND + 1

             IF(JTYP.EQ.1) N1IND = N1IND + 1
             IF(JTYP.EQ.2) N2IND = N2IND + 1
             IF(JTYP.EQ.3) N3IND = N3IND + 1
*
             IF(KTYP.EQ.1) N1IND = N1IND + 1
             IF(KTYP.EQ.2) N2IND = N2IND + 1
             IF(KTYP.EQ.3) N3IND = N3IND + 1
*
             IF(LTYP.EQ.1) N1IND = N1IND + 1
             IF(LTYP.EQ.2) N2IND = N2IND + 1
             IF(LTYP.EQ.3) N3IND = N3IND + 1
             DO 1930 KSM = 1, NSMOB
              IFIRST = 1
              LSM = ADSXA(KSM,KLSM)
              IF(LSM.EQ.0) GOTO 1930
              KOFF = IBTSOB(KTYP,KSM)
              LOFF = IBTSOB(LTYP,LSM)
              NK = NTSOB(KTYP,KSM)
              NL = NTSOB(LTYP,LSM)
*. If IUSEAB  is used, only terms with i.ge.k will be generated so
              IKORD = 0
              IF(IUSEAB.EQ.1.AND.ISM.GT.KSM) GOTO 1930
              IF(IUSEAB.EQ.1.AND.ISM.EQ.KSM.AND.ITYP.GT.KTYP)
     &          GOTO 1930
              IF(IUSEAB.EQ.1.AND.ISM.EQ.KSM.AND.ITYP.EQ.KTYP)
     &           IKORD = 1
*
              IF(NK.EQ.0.OR.NL.EQ.0) GOTO 1930
*.Loop over batches of KB strings
              KBBOT = 1- MAXK
              KBTOP = 0
 1800         CONTINUE
               KBBOT = KBBOT + MAXK
               KBTOP = KBTOP + MAXK
*. obtain cb(KA,KB,jl) =  sum(JA,JB)<KA!a la!JA><KB!a jb !JB>C(JA,JB)
*
               CALL ADST(LOFF,NL,JBTP,JBSM,IBGRP,KBBOT,KBTOP,
     &                      I2(1,1),XI2S(1,1),MAXK,NKBBTC,KBEND)
               CALL ADST(KOFF,NK,IBTP,IBSM,IBGRP,KBBOT,KBTOP,
     &                   I4(1,1),XI4S(1,1),MAXK,NKBBTC,KBEND)
               IF(NKBBTC.EQ.0) GOTO 1930
*
*. Modern low copy version
               IF(IFIRST.EQ.1) THEN
                 IXCHNG = 0
                 IF(IROUTE.EQ.1) THEN
*. Integrals stored as (j l i k )
*                   Write(*,*)'Timedep in rsbb2bn;',TimeDep
                   If (TimeDep) Then
                      CALL GETINT_td(XINT,JTYP,JSM,ITYP,ISM,LTYP,LSM,
     &                       KTYP,KSM,0,0,iroute,ieaw)
                   Else
                      CALL GETINT_MCLR(XINT,JTYP,JSM,ITYP,ISM,LTYP,LSM,
     &                       KTYP,KSM,IXCHNG,0,0,0,ieaw)
                   End If
                 ELSE IF(IROUTE.EQ.2 ) THEN
*. Integrals stored as (i j k l )
                   If (TimeDep) Then
                      CALL GETINT_td(XINT,ITYP,ISM,JTYP,JSM,KTYP,KSM,
     &                         LTYP,LSM,0,0,iroute,ieaw)
                   Else
                       CALL GETINT_MCLR(XINT,ITYP,ISM,JTYP,JSM,KTYP,KSM,
     &                         LTYP,LSM,IXCHNG,0,0,1,ieaw)
                   End If
                 ELSE IF(IROUTE.EQ.3) THEN
*. Integrals stored as (j i k l )
                   If (TimeDep) Then
                        CALL GETINT_td(XINT,JTYP,JSM,ITYP,ISM,KTYP,KSM,
     &                         LTYP,LSM,0,0,iroute,ieaw)
                   Else
                       CALL GETINT_MCLR(XINT,JTYP,JSM,ITYP,ISM,KTYP,KSM,
     &                         LTYP,LSM,IXCHNG,0,0,1,ieaw)
                   End If
                 END IF
                 IF(ISIGN.EQ.-1) THEN
                   CALL DSCAL_(NI*NJ*NK*NL,ONEM,XINT,1)
                 END IF
                 IFIRST = 0
               END IF
               CALL SKICKJ(SIRES,CJRES,NKABTC,NIB,NJB,
     &                     NKBBTC,XINT,NI,NJ,NK,NL,MAXK,
     &                     I4,XI4S,I2,XI2S,IKORD,
     &                     IDUM,iXDUM,XDUM,IROUTE,NTEST )
*
               IF(KBEND.EQ.0) GOTO 1800
*. End of loop over partitioning of beta strings
 1930        CONTINUE
 2000      CONTINUE
*. Scatter out from s(Ka,Ib,i)
*. Restore order !!
           IF(IROUTE.EQ.2) THEN
             CALL TRPMAT(SIRES,NI,NIB*NKABTC,CJRES)
             CALL DCOPY_(NI*NIB*NKABTC,CJRES,1,SIRES,1)
           END IF
           IF(IROUTE.EQ.3) THEN
              DO JB = 1,NIB
                 DO J = 1, NI
                  IOFFIN = (J-1)*NIB*NKABTC+(JB-1)*NKABTC + 1
                  IOFFOUT =(JB-1)*NKABTC*NI + (J-1)*NKABTC + 1
                  DO KA = 1, NKABTC
                    CJRES(IOFFIN-1+KA) = SIRES(IOFFOUT-1+KA)
                  END DO
                 END DO
              END DO
              CALL DCOPY_(NI*NIB*NKABTC,CJRES,1,SIRES,1)
           END IF
           IF(ICJKAIB.EQ.1) THEN
              DO II = 1, NI
                CALL SCARMT(SIRES((II-1)*NKABTC*NIB+1),NKABTC,NIB,
     &                      SB,NIA,NIB,I3(1,II),XI3S(1,II))

              End Do
           END IF
           IF(KAEND.EQ.0) GOTO 1801
*. End of loop over partitioning of alpha strings
 1940     CONTINUE
 2001 CONTINUE
*
 9999 CONTINUE
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(ITSOB)
        CALL Unused_real_array(SSCR)
        CALL Unused_real_array(CSCR)
        CALL Unused_integer(NSMSX)
        CALL Unused_integer(NSMDX)
        CALL Unused_real_array(S2)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine JACSCF(A,B,C,NAA,NQQ,EPSLON)
! VERSION 4 AUGUST 1971
! SUBROUTINE TO FIND ALL THE EIGENVALUES AND EIGENVECTORS OF A
! BY THE JACOBI METHOD
! THIS PROGRAM TREATS THE ORTHOGONAL CASE (S=1)
! NAA=DIMENSION OF A,B,C
! A TRIANGULAR, B MATRIX OF VECTORS, C EIGENVALUES
! B CLEARED TO UNIT MATRIX IF NQ=-1, NOT CLEARED IF NQ= NO. ROWS B
! NQ MUST NOT BE LESS THAN NAA
! EPSLON IS THE CONVERGENCE CRITERIA FOR OFF DIAGONAL ELEMENTS

use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: A(*)
real(kind=wp), intent(_OUT_) :: B(*), C(*)
integer(kind=iwp), intent(in) :: NAA, NQQ
real(kind=wp), intent(in) :: EPSLON
integer(kind=iwp) :: I, ID, J, JD, JJ, K, KA, KB, KC, KD, KDX, L, LL, LOOPC, N, NA, NN, NQ
real(kind=wp) :: ALPHA, AMAX, BETA, CC, CSQ, ROOT, RSUM, S, SSQ, TEMPA, TERM, THRESH, THRSHG, TWOSC

! POW: Unnecessary but warning stopping initialization
TERM = huge(TERM)

NQ = NQQ
LOOPC = 0
NA = NAA
NN = (NA*(NA+1))/2
if (NQ <= 0) then
  K = 1
  NQ = NA
  do I=1,NA
    do J=1,NA
      if (I /= J) then
        B(K) = Zero
      else
        B(K) = One
      end if
      K = K+1
    end do
  end do
end if
RSUM = Zero
if (NA < 1) return
if (NA > 1) then
  K = 1
  AMAX = Zero
  do I=1,NA
    do J=1,I
      if ((I /= J) .and. (abs(A(K)) > AMAX)) AMAX = abs(A(K))
      TERM = A(K)*A(K)
      RSUM = RSUM+TERM+TERM
      K = K+1
    end do
    RSUM = RSUM-TERM
  end do
  RSUM = sqrt(RSUM)
  THRESH = RSUM/sqrt(real(NA,kind=wp))
  THRSHG = THRESH*EPSLON
  if (THRSHG < AMAX) then
    THRESH = AMAX/Three
    if (THRESH < THRSHG) THRESH = THRSHG
    do
      K = 2
      N = 0
      JD = 1
      KDX = 0
      do J=2,NA
        ID = 0
        JD = JD+J
        JJ = J-1
        KC = 0
        KDX = KDX+NQ
        do I=1,JJ
          ID = ID+I
          if (abs(A(K)) <= THRESH) then
            KC = KC+NQ
          else
            N = N+1
            ALPHA = (A(JD)-A(ID))/(Two*A(K))
            BETA = One/(One+ALPHA*ALPHA)
            ROOT = One+abs(ALPHA)*sqrt(BETA)
            SSQ = BETA/(2*ROOT)
            CSQ = ROOT/2
            CC = sqrt(CSQ)
            S = -sqrt(SSQ)*sign(One,ALPHA)
            TWOSC = 2*CC*S
            TEMPA = CSQ*A(ID)+TWOSC*A(K)+SSQ*A(JD)
            A(JD) = CSQ*A(JD)-TWOSC*A(K)+SSQ*A(ID)
            A(ID) = TEMPA
            A(K) = Zero
            KA = JD-J
            KB = ID-I
            KD = KDX
            do L=1,NQ
              KC = KC+1
              KD = KD+1
              TEMPA = CC*B(KC)+S*B(KD)
              B(KD) = -S*B(KC)+CC*B(KD)
              B(KC) = TEMPA
              if (L <= NA) then
                if (I == L) then
                  KB = KB+1
                  KA = KA+1
                else if (I < L) then
                  KB = KB+L-1
                  if (J == L) then
                    KA = KA+1
                  else
                    if (J > L) then
                      KA = KA+1
                    else
                      KA = KA+L-1
                    end if
                    TEMPA = CC*A(KB)+S*A(KA)
                    A(KA) = -S*A(KB)+CC*A(KA)
                    A(KB) = TEMPA
                  end if
                else
                  KB = KB+1
                  KA = KA+1
                  TEMPA = CC*A(KB)+S*A(KA)
                  A(KA) = -S*A(KB)+CC*A(KA)
                  A(KB) = TEMPA
                end if
              end if
            end do
          end if
          K = K+1
        end do
        K = K+1
      end do
      LOOPC = LOOPC+1
      if (LOOPC >= 50) return
      if (N <= NN/8) then
        if (THRESH /= THRSHG) then
          THRESH = THRESH/Three
          if (THRESH < THRSHG) THRESH = THRSHG
        else if (N == 0) then
          exit
        end if
      end if
    end do
  end if
end if
LL = 0
do L=1,NA
  LL = LL+L
  C(L) = A(LL)
end do

return

end subroutine JACSCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine divt (wrk,wrksize,
     & nind,mapdt,mapit,mapddp1,mapidp1,mapddp2,
     &                  mapidp2,rc)
c
c     this routine divide T amplitudes by denominators, ie differences in dp
c
c     nint         - number of indexes in T (2 or 4) (I)
c     mapdt   - direct map of T (I)
c     mapit        - inverse map of T (I)
c     mapddp1        - direct map of dpa (I)
c     mapidp1        - inverse map of dpa (I)
c     mapddp2        - direct map of dpb (I)
c     mapidp2        - inverse map of dpb (I)
c     rc        - return (error) code
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer nind,rc
c
       integer mapdt(0:512,1:6)
       integer mapit(1:8,1:8,1:8)
c
       integer mapddp1(0:512,1:6)
       integer mapidp1(1:8,1:8,1:8)
c
       integer mapddp2(0:512,1:6)
       integer mapidp2(1:8,1:8,1:8)
c
c     help variables
c
       integer posst,possdp,possdpa,possdpb,possdpi,possdpj
       integer dimi,dimj,dima,dimb,dimab,dimij,syma,symb,symi,symj
       integer iit,iidp,iidpa,iidpb,iidpi,iidpj
c
       rc=0
c
       if (nind.eq.2) then
cI    T1 amplitudes - 2 indexes
c
       if (mapdt(0,1).eq.3) then
cI.1  T1aa case
c
       do 100 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       dima=nva(syma)
       dimi=noa(syma)
       iidp=mapidp1(syma,1,1)
       possdp=mapddp1(iidp,1)
c
       if ((dima*dimi).gt.0) then
       call divthelp1 (wrk(posst),dima,dimi,wrk(possdp))
       end if
c
 100    continue
c
       else if (mapdt(0,1).eq.4) then
cI.2  T1bb case
c
       do 200 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       dima=nvb(syma)
       dimi=nob(syma)
       iidp=mapidp2(syma,1,1)
       possdp=mapddp2(iidp,1)
c
       if ((dima*dimi).gt.0) then
       call divthelp1 (wrk(posst),dima,dimi,wrk(possdp))
       end if
c
 200    continue
c
       else
cI.3  invalid T1 type
c     RC=1 : incorrect map for T1
       rc=1
       return
       end if
c
       else if (nind.eq.4) then
cII   T2 amplitudes - 4 indexes
c
       if (mapdt(0,6).eq.0) then
cII.1 T2abab case

       do 300 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       symb=mapdt(iit,4)
       symi=mapdt(iit,5)
       symj=mapdt(iit,6)
       dima=nva(syma)
       dimb=nvb(symb)
       dimi=noa(symi)
       dimj=nob(symj)
       iidpa=mapidp1(syma,1,1)
       iidpb=mapidp2(symb,1,1)
       iidpi=mapidp1(symi,1,1)
       iidpj=mapidp2(symj,1,1)
       possdpa=mapddp1(iidpa,1)
       possdpb=mapddp2(iidpb,1)
       possdpi=mapddp1(iidpi,1)
       possdpj=mapddp2(iidpj,1)
c
       if (mapdt(iit,2).gt.0) then
       call divthelp2 (wrk(posst),dima,dimb,dimi,dimj,
     & wrk(possdpa),wrk(possdpb),wrk(possdpi),wrk(possdpj),
     & noa(syma),nob(symb))
       end if
c
 300    continue
c
       else if ((mapdt(0,6).eq.4).and.(mapdt(0,1).eq.3)) then
cII.2 T2aaaa case
c
       do 400 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       symb=mapdt(iit,4)
       symi=mapdt(iit,5)
       symj=mapdt(iit,6)
       dima=nva(syma)
       dimb=nva(symb)
       dimi=noa(symi)
       dimj=noa(symj)
       iidpa=mapidp1(syma,1,1)
       iidpb=mapidp1(symb,1,1)
       iidpi=mapidp1(symi,1,1)
       iidpj=mapidp1(symj,1,1)
       possdpa=mapddp1(iidpa,1)
       possdpb=mapddp1(iidpb,1)
       possdpi=mapddp1(iidpi,1)
       possdpj=mapddp1(iidpj,1)
c
       if (mapdt(iit,2).eq.0) goto 400

       if (syma.ne.symb) then
c     different symmetries a,b; i,j
       call divthelp2 (wrk(posst),dima,dimb,dimi,dimj,
     & wrk(possdpa),wrk(possdpb),wrk(possdpi),wrk(possdpj),
     & noa(syma),noa(symb))
c
       else
c     same symmetries a,b; i,j
       dimab=(dima*(dima-1))/2
       dimij=(dimi*(dimi-1))/2
       call divthelp3 (wrk(posst),dimab,dimij,wrk(possdpa),wrk(possdpi),
     & dima,dimi,noa(syma))
       end if
c
 400    continue
c
       else if ((mapdt(0,6).eq.4).and.(mapdt(0,1).eq.4)) then
cII.3 T2bbbb case
c
       do 500 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       symb=mapdt(iit,4)
       symi=mapdt(iit,5)
       symj=mapdt(iit,6)
       dima=nvb(syma)
       dimb=nvb(symb)
       dimi=nob(symi)
       dimj=nob(symj)
       iidpa=mapidp2(syma,1,1)
       iidpb=mapidp2(symb,1,1)
       iidpi=mapidp2(symi,1,1)
       iidpj=mapidp2(symj,1,1)
       possdpa=mapddp2(iidpa,1)
       possdpb=mapddp2(iidpb,1)
       possdpi=mapddp2(iidpi,1)
       possdpj=mapddp2(iidpj,1)
c
       if (mapdt(iit,2).eq.0) goto 500

       if (syma.ne.symb) then
c     different symmetries a,b; i,j
       call divthelp2 (wrk(posst),dima,dimb,dimi,dimj,
     & wrk(possdpa),wrk(possdpb),wrk(possdpi),wrk(possdpj),
     & nob(syma),nob(symb))
c
       else
c     same symmetries a,b; i,j
       dimab=(dima*(dima-1))/2
       dimij=(dimi*(dimi-1))/2
       call divthelp3 (wrk(posst),dimab,dimij,wrk(possdpa),wrk(possdpi),
     & dima,dimi,nob(syma))
       end if
c
 500    continue
c
       else
cII.4 RC=2 : incorrect mapdt for T2
       rc=2
       return
       end if
c
       else
cIII  invalid nind
c     RC=3 : nind is not 2 or 4 (Stup)
       rc=3
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(mapit)
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005,2006, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine OrthoPAO_Localisation(X,nBas,nFro,nOrb2Loc,nSym,nPass,
     &                                 Test)
C
C     Thomas Bondo Pedersen, December 2005.
C     - revised January 2006.
C
C     Purpose: orthonormalization of Cholesky PAOs according to
C
C              V = X^T*S*X
C              X <- X*V^(-1/2)
C
C              where S is the AO overlap matrix.
C              The orthonormalization is carried out nPass times.
C              After this routine, X will satisfy X^T*S*X=1.
C
C     NOTE: X is assumed to contain all orbitals!!
C
      Implicit Real*8 (a-h,o-z)
      Real*8  X(*)
      Integer nBas(nSym), nFro(nSym), nOrb2Loc(nSym)
      Logical Test
#include "WrkSpc.fh"

      Character*21 SecNam
      Parameter (SecNam = 'OrthoPAO_Localisation')

      Parameter (Tol = 1.0d-10)

      external ddot_

C     Check for quick return.
C     -----------------------

      If (nPass .lt. 1) Return

C     Read S from disk, stored as full square.
C     ----------------------------------------

      l_S = nBas(1)**2
      Do iSym = 2,nSym
         l_S = l_S + nBas(iSym)**2
      End Do
      Call GetMem('S','Allo','Real',ip_S,l_S)
      Call GetOvlp_Localisation(Work(ip_S),'Sqr',nBas,nSym)

C     Allocations.
C     ------------

      nBasMax = nBas(1)
      nO2LMax = nOrb2Loc(1)
      Do iSym = 2,nSym
         nBasMax = max(nBasMax,nBas(iSym))
         nO2LMax = max(nO2LMax,nOrb2Loc(iSym))
      End Do

      l_V = nO2LMax**2
      l_VSqrt = l_V
      l_VISqrt = l_V
      l_Scr = 2*(nBasMax**2) + nBasMax*(nBasMax+1)/2  ! needed in SqrtMt
      Call GetMem('V','Allo','Real',ip_V,l_V)
      Call GetMem('VSqrt','Allo','Real',ip_VSqrt,l_VSqrt)
      Call GetMem('VISqrt','Allo','Real',ip_VISqrt,l_VISqrt)
      Call GetMem('Scr','Allo','Real',ip_Scr,l_Scr)

C     Orthonormalization passes.
C     --------------------------

      Do iPass = 1,nPass
         kX = 1
         kS = ip_S
         Do iSym = 1,nSym

C           Set pointer to PAO part of X.
C           ------------------------------

            kOffX = kX + nBas(iSym)*nFro(iSym)

C           Compute V = X^T*S*X.
C           --------------------

            Call GetUmat_Localisation(Work(ip_V),
     &                                X(kOffX),Work(kS),X(kOffX),
     &                                Work(ip_Scr),l_Scr,
     &                                nBas(iSym),nOrb2Loc(iSym))

C           Compute V^(-1/2).
C           -----------------

            iTask = 2 ! compute sqrt as well as inverse sqrt
            Call SqrtMt(Work(ip_V),nOrb2Loc(iSym),iTask,
     &                  Work(ip_VSqrt),Work(ip_VISqrt),Work(ip_Scr))

C           Compute orthonormal X <- X*V^(-1/2).
C           ------------------------------------

            nB = max(nBas(iSym),1)
            nO2L = max(nOrb2Loc(iSym),1)
            Call dCopy_(nBas(iSym)*nOrb2Loc(iSym),X(kOffX),1,
     &                                           Work(ip_Scr),1)
         Call DGEMM_('N','N',nBas(iSym),nOrb2Loc(iSym),nOrb2Loc(iSym),
     &                 1.0d0,Work(ip_Scr),nB,Work(ip_VISqrt),nO2L,
     &                 0.0d0,X(kOffX),nB)

C           Update pointers.
C           ----------------

            kX = kX + nBas(iSym)**2
            kS = kS + nBas(iSym)**2

         End Do
      End Do

C     Test orthonormalization (i.e. V=1?).
C     ------------------------------------

      If (Test) Then
         kX = 1
         kS = ip_S
         nErr = 0
         Do iSym = 1,nSym
            kOffX = kX + nBas(iSym)*nFro(iSym)
            Call GetUmat_Localisation(Work(ip_V),
     &                                X(kOffX),Work(kS),X(kOffX),
     &                                Work(ip_Scr),l_Scr,
     &                                nBas(iSym),nOrb2Loc(iSym))
            kOff = ip_V - 1
            Do i = 1,nOrb2Loc(iSym)
               Work(kOff+nOrb2Loc(iSym)*(i-1)+i) =
     &              Work(kOff+nOrb2Loc(iSym)*(i-1)+i) - 1.0d0
            End Do
            xNrm = sqrt(dDot_(nOrb2Loc(iSym)**2,Work(ip_V),1,
     &                                         Work(ip_V),1))
            If (xNrm .gt. Tol) Then
               Write(6,'(A,A,D16.8,A,I2,A)')
     &         SecNam,': ERROR: ||X^TSX - 1|| = ',xNrm,' (sym.',
     &         iSym,')'
               nErr = nErr + 1
            End If
            kX = kX + nBas(iSym)**2
            kS = kS + nBas(iSym)**2
         End Do
         If (nErr .ne. 0) Then
            Write(6,*) SecNam,': failure after ',nPass,' passes'
            Call SysAbendMsg(SecNam,'Orthonormalization failure!',' ')
         End If
      End If

C     De-allocations.
C     ---------------

      Call GetMem('Scr','Free','Real',ip_Scr,l_Scr)
      Call GetMem('VISqrt','Free','Real',ip_VISqrt,l_VISqrt)
      Call GetMem('VSqrt','Free','Real',ip_VSqrt,l_VSqrt)
      Call GetMem('V','Free','Real',ip_V,l_V)
      Call GetMem('S','Free','Real',ip_S,l_S)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine dpci2vb_cvb(civec,cvbdet,dvbdet,ic1,ret,ic)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension civec(nda,ndb),cvbdet(ndetvb),dvbdet(ndetvb),dum(1)

      k1 = mstacki_cvb(nfrag)
      k2 = mstacki_cvb(nfrag)
      k3 = mstacki_cvb(nfrag+1)
      k4 = mstacki_cvb(nfrag+1)
      mxstack=100
      k5 = mstacki_cvb(mxstack)
      k6 = mstackr_cvb(nfrag+1)
      k7 = mstacki_cvb(nfrag)
      k8 = mstacki_cvb(nfrag)
      k9 = mstacki_cvb(nfrag)
      k10= mstacki_cvb(nfrag)
      call dpci2vb2_cvb(civec,cvbdet,dvbdet,dum,ic1,ret,ic,
     >  nda,ndb,ndetvb,
     >  nfrag,nda_fr(1,1),ndb_fr(1,1),
     >  iwork(ll(7)),iwork(ll(8)),iwork(k1),iwork(k2),iwork(k3),
     >  iwork(k4),
     >  iwork(k5),mxstack,work(k6),iwork(k7),
     >  iwork(ll(20)),iwork(ll(21)),
     >  iwork(k8),iwork(k9),iwork(k10),
     >  ndetvb_fr,ndavb)
      call mfreei_cvb(k1)
      return
      end
      subroutine ci2ordr_cvb(civec,cvbdet,evbdet)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension civec(nda,ndb),cvbdet(ndetvb)
      dimension evbdet(*)
      icivec=nint(civec(1,1))
      if(nfrag.le.1)then
        call fzero(evbdet,ndetvb)
        return
      endif
      k1 = mstacki_cvb(nfrag)
      k2 = mstacki_cvb(nfrag)
      k3 = mstacki_cvb(nfrag+1)
      k4 = mstacki_cvb(nfrag+1)
      mxstack=100
      k5 = mstacki_cvb(mxstack)
      k6 = mstackr_cvb(nfrag+1)
      k7 = mstacki_cvb(nfrag)
      k8 = mstacki_cvb(nfrag)
      k9 = mstacki_cvb(nfrag)
      k10= mstacki_cvb(nfrag)
      call dpci2vb2_cvb(work(iaddr_ci(icivec)),cvbdet,work(lv(5)),
     >  evbdet,
     >  0,dum,5,
     >  nda,ndb,ndetvb,
     >  nfrag,nda_fr(1,1),ndb_fr(1,1),
     >  iwork(ll(7)),iwork(ll(8)),iwork(k1),iwork(k2),iwork(k3),
     >  iwork(k4),
     >  iwork(k5),mxstack,work(k6),iwork(k7),
     >  iwork(ll(20)),iwork(ll(21)),
     >  iwork(k8),iwork(k9),iwork(k10),
     >  ndetvb_fr,ndavb)
      call mfreei_cvb(k1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine QaaVerif(G2q,ng2,PUVX,NPUVX,IndTUVX)

use MCLR_Data, only: nNA
use input_mclr, only: ntAsh
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nG2, nPUVX, IndTUVX(ntAsh,ntAsh,ntAsh,ntAsh)
real(kind=wp), intent(in) :: G2q(nG2), PUVX(NPUVX)
integer(kind=iwp) :: I, IJKL, J, K, L, lMax
real(kind=wp) :: dQdX

ijkl = 0
dQdX = Zero
do i=1,nna
  do j=1,i
    do k=1,i
      if (i == k) then
        lmax = j
      else
        lmax = k
      end if
      do l=1,lmax
        ijkl = ijkl+1
        dQdX = dQdX+G2q(ijkl)*PUVX(IndTUVX(I,J,K,L))
      end do
    end do
  end do
end do

write(u6,*) 'dQdX in QaaVerif=',dQdX

end subroutine QaaVerif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
*               2001, Giovanni Li Manni                                *
*               2001, Dongxia Ma                                       *
************************************************************************
      SUBROUTINE NSTPTP_GAS(NGAS,ISPGRP,NSTSGP,NSMST,
     &                      NSTSSPGP,IGRP,MXNSTR,
     &                      NSMCLS,NSMCLSE,NSMCLSE1)
*
* Find number of strings per symmetry for the supergroup defined
* by the groups of ISPGRP. The obtained number of strings per sym
* is stored in NSTSSPGP(*,IGRP)
*
* Jeppe Olsen, Giovanni Li Manni, Dongxia Ma
* Dicember 2011 - the old version is too slow for many GAS spaces
*                 (new version simpler and quicker)
*
*. Also delivered:
*
* NSMCLS : MAX Number of symmetry classes for given supergroup,
*          i.e. number of combinations of symmetries of groups
*          containing strings
* NSMCLSE : Number of symmetry classes for given supergroup
*          obtained by restricting allowed symmetries in
*          a given group by a max and min.
* NSMCLSE1 : As NSMCLSE, but the symmetry of the last active
*            orbital space where there is more than one symmetry
*            is left out
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION ISPGRP(NGAS),NSTSGP(NSMST,*)
*. Input and Output (column IGRP updated)
      DIMENSION NSTSSPGP(NSMST,IGRP)
#include "mxpdim.fh"
#include "multd2h.fh"
*. Scratch
      INTEGER ISM,MNSM(MXPNGAS),MXSM(MXPNGAS)
      INTEGER MSM1(MXPNSMST),MSM2(MXPNSMST)
      INTEGER ISM1(MXPNSMST),ISM2(MXPNSMST)
*
      NTEST = 0
      IF(NTEST.GE.10) THEN
        WRITE(6,*) ' ======================='
        WRITE(6,*) ' NSTPTP_GAS is speaking '
        WRITE(6,*) ' ======================='
*
        WRITE(6,*) ' Supergroup in action '
        CALL IWRTMA(ISPGRP,1,NGAS,1,NGAS)
      END IF
*
*. The NSMCLS* parameters
*
*. Max and min for each GASpace


      DO IGAS = 1, NGAS
        MXSM(IGAS) = 1
        DO ISYM = 1, NSMST
          IF(NSTSGP(ISYM,ISPGRP(IGAS)) .NE. 0 ) MXSM(IGAS) = ISYM
        END DO
        MNSM(IGAS) = NSMST
        DO ISYM = NSMST,1, -1
          IF(NSTSGP(ISYM,ISPGRP(IGAS)) .NE. 0 ) MNSM(IGAS) = ISYM
        END DO
      END DO
*. Last space with more than one symmetry
      NGASL = 1
      DO IGAS = 1, NGAS
        IF(MXSM(IGAS).NE.MNSM(IGAS)) NGASL = IGAS
      END DO
*. NSMCLSE
      NSMCLSE = 1
      DO IGAS = 1, NGAS
        NSMCLSE = (MXSM(IGAS)-MNSM(IGAS)+1)*NSMCLSE
      END DO
*. NSMCLSE1
      NSMCLSE1 = 1
      DO IGAS = 1, NGASL-1
        NSMCLSE1 = (MXSM(IGAS)-MNSM(IGAS)+1)*NSMCLSE1
      END DO
      IZERO = 0
      DO IGAS = 1, NGAS
*. In ISM1, the number of strings per symmetry for the first
*  IGAS-1 spaces are given, obtain in ISM2 the number of strings per sym
*  for the first IGAS spaces
*. Also: in MSM1, MSM2, counts the number of nontrivial combinations per
*  sym
        IF(IGAS.EQ.1) THEN
*. ISM1: The number of strings per symmetry for zero electrons
         CALL ISETVC(ISM1,IZERO,NSMST)
         ISM1(1) = 1
         CALL ISETVC(MSM1,IZERO,NSMST)
         MSM1(1) = 1
        ELSE
*. copy from the ISM2 obtained for preceeding IGAS
         CALL ICOPVE(ISM2,ISM1,NSMST)
         CALL ICOPVE(MSM2,MSM1,NSMST)
        END IF
        CALL ISETVC(ISM2,IZERO,NSMST)
        CALL ISETVC(MSM2,IZERO,NSMST)
        DO ISM_IGASM1 = 1, NSMST
         DO ISM_IGAS = 1, NSMST
           ISM = MULTD2H(ISM_IGASM1,ISM_IGAS)
           ISM2(ISM) = ISM2(ISM) +
     &     ISM1(ISM_IGASM1)*NSTSGP(ISM_IGAS,ISPGRP(IGAS))
           IF(ISM1(ISM_IGASM1)*NSTSGP(ISM_IGAS,ISPGRP(IGAS)).NE.0)
     &     MSM2(ISM) = MSM2(ISM) + MSM1(ISM_IGASM1)
         END DO
        END DO
      END DO !loop over IGAS
      CALL ICOPVE(ISM2,NSTSSPGP(1,IGRP),NSMST)
*
      MXNSTR = 0
      NSMCLS = 0
      DO ISTRSM = 1, NSMST
        MXNSTR = MAX(MXNSTR,NSTSSPGP(ISTRSM,IGRP))
        NSMCLS = MAX(NSMCLS,MSM2(ISTRSM))
      END DO
*
      IF(NTEST.GE.10) THEN
        WRITE(6,*)
     &  ' Number of strings per symmetry for supergroup',IGRP
        CALL IWRTMA10(NSTSSPGP(1,IGRP),1,NSMST,1,NSMST)
        WRITE(6,*) ' Largest number of strings of given sym ',MXNSTR
*
        WRITE(6,'(A,3(2X,I8))') ' NSMCLS,NSMCLSE,NSMCLSE1=',
     &                       NSMCLS,NSMCLSE,NSMCLSE1
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA_ReadIntegerInput(Key,nInp,Lu,iVal,n)

use Definitions, only: iwp

implicit none
character(len=4), intent(in) :: Key
integer(kind=iwp), intent(in) :: nInp, Lu, n
integer(kind=iwp), intent(out) :: iVal(n)
character(len=180) :: Line
character(len=180), external :: Get_Ln

#include "macros.fh"

if (n >= nInp) then
  Line = Get_Ln(Lu)
  unused_var(Line)
  call Get_I(1,iVal,nInp)
else
  ! insufficent memory for reading (fix in calling routine)
  call RPA_Warn(3,'Integer read problem for keyword '//Key)
end if

return

end subroutine RPA_ReadIntegerInput

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine plot_barrier(nBlock,nMult,nDIM,E,M)

use Constants, only: Zero, One, Three, Five, Six, Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBlock, nMult, nDIM(nMult)
real(kind=wp), intent(in) :: E(nBlock)
complex(kind=wp), intent(in) :: M(3,nMult,10,nMult,10)
real(kind=wp) :: dlt, emax, emin, F, fact, RAVE, RAVEMAX, RAVEMIN, X, xend, xmax, xmin, xstart, Y, yend, ystart, Z, gnuplot_version
integer(kind=iwp) :: file_number, file_size, i, i1, iErr, j, j1, k, l, Length, LuData, LuPlt
logical(kind=iwp) :: execute_gnuplot_cmd, file_exist, is_file_open
character(len=1023) :: gnuplot_CMD, realname_e_dat, realname_eps, realname_m_dat, realname_plt, realname_png
character(len=100) :: cdummy, datafile_e, datafile_m, epsfile, fmtx, imagefile, line1, line2, plotfile
integer(kind=iwp), external :: AixRm, IsFreeUnit

#include "macros.fh"

iErr = 0

xmin = minval(real(M(3,:,:,:,:),kind=wp))-0.1_wp*maxval(real(M(3,:,:,:,:),kind=wp))
xmax = maxval(real(M(3,:,:,:,:),kind=wp))+0.1_wp*maxval(real(M(3,:,:,:,:),kind=wp))
dlt = 0.01_wp*(xmax-xmin)

F = maxval(E(:))
fact = One
if (F < Ten) then
  fact = One
!else if ((F >= Ten) .and. (F < 100.0_wp)) then
!  fact = Ten
!else if ((F >= 1.0e2_wp) .and. (F < 1.0e3_wp)) then
!  fact = 1.0e2_wp
!else if ((F >= 1.0e3_wp) .and. (F < 1.0e4_wp)) then
!  fact = 1.0e3_wp
else if ((F >= 1.0e4_wp) .and. (F < 1.0e5_wp)) then
  fact = 1.0e4_wp
else if ((F >= 1.0e5_wp) .and. (F < 1.0e6_wp)) then
  fact = 1.0e5_wp
end if
Emin = minval(E(:))/fact-0.05_wp*maxval(E(:))/fact
Emax = maxval(E(:))/fact+0.05_wp*maxval(E(:))/fact

RAVEMIN = 9999999999999999.0_wp
RAVEMAX = -9999999999999999.0_wp

l = 0
do i=1,nMult
  do i1=1,ndim(i)
    l = l+1
    k = 0
    do j=1,nMult
      do j1=1,ndim(j)
        k = k+1
        if ((i == j) .and. (i1 == j1)) cycle
        X = abs(M(1,i,i1,j,j1))
        Y = abs(M(2,i,i1,j,j1))
        Z = abs(M(3,i,i1,j,j1))
        RAVE = (X+Y+Z)/Three
        if (RAVE < RAVEMIN) RAVEMIN = RAVE
        if (RAVE > RAVEMAX) RAVEMAX = RAVE
      end do
    end do
  end do
end do

! generate the GNUPLOT script in the $WorkDir
line1 = ' '
line2 = ' '
gnuplot_CMD = ' '
file_exist = .false.
is_file_open = .false.
file_size = 0
execute_gnuplot_cmd = .false.
gnuplot_version = Zero

! check if the file lineOUT exists
inquire(file='lineOUT',exist=file_exist,opened=is_file_open,number=file_number)

if (file_exist) then
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'file "lineOUT" exists in WorkDir'
# endif
  if (is_file_open) then
#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'file "lineOUT" is opened'
#   endif
    ! close the file:
    close(unit=file_number,status='DELETE')
  end if
  ! delete the file
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'deleting the file...'
# endif
  iErr = AixRm('lineOUT')
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
else
  write(u6,'(A)') 'file "lineOUT" does not exist in WorkDir'
# endif
end if

! find the gnuplot
#ifdef _DEBUGPRINT_
write(u6,'(A)') 'inquire which GNUPLOT'
#endif

call systemf('which gnuplot >> lineOUT',iErr)
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif

inquire(file='lineOUT',exist=file_exist,opened=is_file_open,number=file_number,size=file_size)

#ifdef _DEBUGPRINT_
write(u6,*) 'File_number =',file_number
write(u6,*) 'Is_file_open=',is_file_open
write(u6,*) 'File_exist  =',file_exist
write(u6,*) 'File_size   =',file_size
#endif

if (file_exist) then
  if (file_size > 0) then

#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'new file "lineOUT" exists in WorkDir'
#   endif

    file_number = IsFreeUnit(45)
    call molcas_open(file_number,'lineOUT')

    read(file_number,'(A)') line1

#   ifdef _DEBUGPRINT_
    write(u6,*) 'line1=',line1
    write(u6,*) trim(line1)
#   endif
    line2 = trim(line1)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'line2=',line2
#   endif

    close(file_number)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Closing lineOUT file'
    call xFlush(u6)
#   endif
    execute_gnuplot_cmd = .true.
  else
    ! file_size =0
    write(u6,'(A)') 'file "lineOUT" has a size=0. gnuplot was not found on the system.'
    write(u6,'(A)') 'plots will not be created.'
  end if
else
  write(u6,'(A)') 'file "lineOUT" does not exist in WorkDir'
end if
! remove file "lineOUT"
iErr = AixRm('lineOUT')
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif

!!!!! check the version of the gnuplot:
if (execute_gnuplot_cmd) then
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'inquire which version of GNUPLOT is installed'
# endif
  ! attempt to execute the script
  write(gnuplot_CMD,'(2A)') trim(line2),' --version > lineOUT'
# ifdef _DEBUGPRINT_
  write(u6,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
# endif
  call systemf(gnuplot_CMD,iErr)
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif
  file_number = IsFreeUnit(42)
  call molcas_open(file_number,'lineOUT')
  read(file_number,*) cdummy,gnuplot_version
  unused_var(cdummy)
# ifdef _DEBUGPRINT_
  write(u6,'(A,F4.1)') 'gnuplot_version = ',gnuplot_version
# endif
  if (abs(gnuplot_version) < 0.1_wp) execute_gnuplot_cmd = .false.
  close(file_number)
  ! remove file "lineOUT"
  iErr = AixRm('lineOUT')
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif
end if

!-----------------------------------------------------------------------
! get the true real names of the files on disk:
write(datafile_e,'(3A)') 'BARRIER_ENE.dat'
write(datafile_m,'(3A)') 'BARRIER_TME.dat'
write(imagefile,'(3A)') 'BARRIER.png'
write(epsfile,'(3A)') 'BARRIER.eps'
write(plotfile,'(3A)') 'BARRIER.plt'
call prgmtranslate(datafile_e,realname_e_dat,Length)
call prgmtranslate(datafile_m,realname_m_dat,Length)
call prgmtranslate(imagefile,realname_png,Length)
call prgmtranslate(epsfile,realname_eps,Length)
call prgmtranslate(plotfile,realname_plt,Length)
#ifdef _DEBUGPRINT_
write(u6,'(3A)') 'realname_e_dat=',trim(realname_e_dat)
write(u6,'(3A)') 'realname_m_dat=',trim(realname_m_dat)
write(u6,'(3A)') 'realname_png=',trim(realname_png)
write(u6,'(3A)') 'realname_eps=',trim(realname_eps)
write(u6,'(3A)') 'realname_plt=',trim(realname_plt)
#endif

!!!!! prepare the energy data file:
inquire(file=datafile_e,exist=file_exist,opened=is_file_open,number=file_number)
if (file_exist) iErr = AixRm(trim(datafile_e))
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif
LuData = IsFreeUnit(75)
call molcas_open(LuData,datafile_e)
#ifdef _DEBUGPRINT_
write(u6,*) 'Opening "'//trim(datafile_e)//'" file'
write(u6,*) 'Opening "'//trim(realname_e_dat)//'" file'
call xFlush(u6)
#endif
! write energies
l = 0
do i=1,nMult
  do i1=1,ndim(i)
    l = l+1
    xstart = real(M(3,i,i1,i,i1),kind=wp)-dlt
    xend = real(M(3,i,i1,i,i1),kind=wp)+dlt

    write(LuData,'(3ES24.14)') xstart,E(l)/fact
    write(LuData,'(3ES24.14)') xend,E(l)/fact
    write(LuData,'(A)') ' '
  end do
end do
#ifdef _DEBUGPRINT_
write(u6,*) 'Writing into the "'//trim(datafile_e)//'" file'
write(u6,*) 'Writing into the "'//trim(realname_e_dat)//'" file'
#endif
close(LuData)
#ifdef _DEBUGPRINT_
write(u6,*) 'Closing the "'//trim(datafile_e)//'" file'
write(u6,*) 'Closing the "'//trim(realname_e_dat)//'" file'
call xFlush(u6)
#endif

!!!!!===================================================================
!!!!! prepare the transition matrix elements file:
inquire(file=datafile_m,exist=file_exist,opened=is_file_open,number=file_number)
if (file_exist) iErr = AixRm(trim(datafile_m))
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif
LuData = IsFreeUnit(76)
call molcas_open(LuData,datafile_m)
#ifdef _DEBUGPRINT_
write(u6,*) 'Opening "'//trim(datafile_m)//'" file'
write(u6,*) 'Opening "'//trim(realname_m_dat)//'" file'
call xFlush(u6)
#endif
! write energies,
l = 0
do i=1,nMult
  do i1=1,ndim(i)
    l = l+1
    k = 0
    do j=1,nMult
      do j1=1,ndim(j)
        k = k+1

        if ((i == j) .and. (i1 == j1)) cycle

        X = abs(M(1,i,i1,j,j1))
        Y = abs(M(2,i,i1,j,j1))
        Z = abs(M(3,i,i1,j,j1))
        RAVE = (X+Y+Z)/Three

        xstart = real(M(3,i,i1,i,i1),kind=wp)
        xend = real(M(3,j,j1,j,j1),kind=wp)

        ystart = E(l)/fact
        yend = E(k)/fact

        fmtx = '(ES24.14,ES24.14,ES24.14)'
        if (RAVE > RAVEMAX*5.0e-3_wp) then
          write(LuData,fmtx) xstart,ystart,RAVE
          write(LuData,fmtx) xend,yend,RAVE
          write(LuData,'(A)') ' '
        end if
      end do
    end do
  end do
end do
#ifdef _DEBUGPRINT_
write(u6,*) 'Writing into the "'//trim(datafile_m)//'" file'
#endif
close(LuData)
#ifdef _DEBUGPRINT_
write(u6,*) 'Closing the "'//trim(datafile_m)//'" file'
call xFlush(u6)
#endif

!!!!!===================================================================
!!!!! generate the GNUPLOT script in the $WorkDir

inquire(file=plotfile,exist=file_exist,opened=is_file_open,number=file_number)
if (file_exist) iErr = AixRm(trim(plotfile))
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif
LuPlt = IsFreeUnit(85)
call molcas_open(LuPlt,plotfile)
#ifdef _DEBUGPRINT_
write(u6,*) 'Opening "'//trim(plotfile)//'" file'
write(u6,*) 'Opening "'//trim(realname_plt)//'" file'
#endif

if (gnuplot_version < Five) then
  !===  GNUPLOT VERSION 4 and below ==>>  generate EPS
  write(LuPlt,'(A)') 'set terminal postscript eps enhanced color  size 3.0, 2.0 font "arial, 10"'
  write(LuPlt,'(A)') 'set output "'//trim(realname_eps)//'" '
  write(LuPlt,'(A)') 'set grid'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Axes'
  write(LuPlt,'(A)') '  set xlabel "Momentum / {/Symbol m}_{B}" font "Arial,12"'
  if (nint(fact) == 1) then
    write(LuPlt,'(A)') '  set ylabel "Energy / cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 10) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x10) / cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 100) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x100) / cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 1000) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x1000)/ cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 10000) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x10000)/ cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 100000) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x100000) / cm^{-1}" font "Arial,12"'
  end if
  write(LuPlt,'(A)')
  write(LuPlt,'(A,F24.14,A,F24.14,A)') '  set xrange[',xmin,':',xmax,']'
  write(LuPlt,'(A,F24.14,A,F24.14,A)') '  set yrange[',Emin,':',Emax,']'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Tics for axes'
  write(LuPlt,'(A)') '  set xtics nomirror'
  write(LuPlt,'(A)') '  set ytics nomirror'
  write(LuPlt,'(A)') '  set mxtics'
  write(LuPlt,'(A)') '  set mytics'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Margins'
  write(LuPlt,'(A)') '  set bmargin at screen 0.20'
  write(LuPlt,'(A)') '  set lmargin at screen 0.15'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# legend'
  write(LuPlt,'(A)') '  set key off' !right bottom'
  write(LuPlt,'(A)')

  write(LuPlt,'(A)')
  write(LuPlt,'(A,ES24.14,A,ES24.14,A)') 'set palette defined ( ',RAVEMIN," '#FFF0F0', ",RAVEMAX," 'red' )"

  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# actual plotting'
  write(LuPlt,'(A)') 'plot  "'//trim(realname_m_dat)//'" using 1:2:3 with lines lt 1  lw 1 lc palette , \'
  write(LuPlt,'(A)') '      "'//trim(realname_e_dat)//'" using 1:2   with lines lt 1  lw 8 lc rgb "black" '
  write(LuPlt,'(A)')

else if ((gnuplot_version >= Five) .and. (gnuplot_version < Six)) then
  !===  GNUPLOT VERSION 5 and above ==>>  generate PNG
  write(LuPlt,'(A)') 'set terminal pngcairo transparent enhanced font "arial,10" fontscale 4.0 size 1800, 1200'
  write(LuPlt,'(A)') 'set output "'//trim(realname_png)//'" '
  write(LuPlt,'(A)') 'set grid'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Axes'
  write(LuPlt,'(A)') '  set xlabel "Momentum / {/Symbol m}_{B}" font "Arial,12"'
  if (nint(fact) == 1) then
    write(LuPlt,'(A)') '  set ylabel "Energy / cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 10) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x10) / cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 100) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x100) / cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 1000) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x1000)/ cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 10000) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x10000)/ cm^{-1}" font "Arial,12"'
  else if (nint(fact) == 100000) then
    write(LuPlt,'(A)') '  set ylabel "Energy (x100000) / cm^{-1}" font "Arial,12"'
  end if
  write(LuPlt,'(A)')
  write(LuPlt,'(A,F24.14,A,F24.14,A)') '  set xrange[',xmin,':',xmax,']'
  write(LuPlt,'(A,F24.14,A,F24.14,A)') '  set yrange[',Emin,':',Emax,']'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Tics for axes'
  write(LuPlt,'(A)') '  set xtics nomirror'
  write(LuPlt,'(A)') '  set ytics nomirror'
  write(LuPlt,'(A)') '  set mxtics'
  write(LuPlt,'(A)') '  set mytics'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Margins'
  write(LuPlt,'(A)') '  set bmargin at screen 0.20'
  write(LuPlt,'(A)') '  set lmargin at screen 0.15'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# legend'
  write(LuPlt,'(A)') '  set key off' !right bottom'
  write(LuPlt,'(A)')

  write(LuPlt,'(A)')
  write(LuPlt,'(A,ES24.14,A,ES24.14,A)') 'set palette defined ( ',RAVEMIN," '#FFF0F0', ",RAVEMAX," 'red' )"

  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# actual plotting'
  write(LuPlt,'(A)') 'plot  "'//trim(realname_m_dat)//'" using 1:2:3 with lines lt 1  lw 1 lc palette , \'
  write(LuPlt,'(A)') '      "'//trim(realname_e_dat)//'" using 1:2   with lines lt 1  lw 8 lc rgb "black" '
  write(LuPlt,'(A)')
else
  write(u6,*) 'GNUPLOT has version: ',gnuplot_version
  write(u6,*) 'This version of GNUPLOT is not known and thus, unsupported.'
  execute_gnuplot_cmd = .false.
end if
close(LuPlt)

if (execute_gnuplot_cmd) then
  ! attempt to execute the script
  write(gnuplot_CMD,'(5A)') trim(line2),' < ',trim(realname_plt)
# ifdef _DEBUGPRINT_
  write(u6,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
# endif
  call systemf(gnuplot_CMD,iErr)
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif

  if (gnuplot_version < Five) then
    inquire(file=trim(realname_eps),exist=file_exist,opened=is_file_open,number=file_number)
    if (file_exist) then
      write(u6,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was created in Working directory.'
    else
      write(u6,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was NOT created in Working directory.'
    end if
  else
    inquire(file=trim(realname_png),exist=file_exist,opened=is_file_open,number=file_number)
    if (file_exist) then
      write(u6,'(A,i0,A)') 'File "'//trim(realname_png)//'" was created in Working directory.'
    else
      write(u6,'(A,i0,A)') 'File "'//trim(realname_png)//'" was NOT created in Working directory.'
    end if
  end if
end if

return

end subroutine plot_barrier

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Init_Tsk2(id,mTask,jOpt,List)
#include "WrkSpc.fh"
      Integer List(*)  ! either nTask or 0 long
      Common /Tsk2/ iRsv,iOpt,nTask
*
      nTask=mTask
      iOpt=jOpt
      If (iOpt.eq.0) Then
         Call Init_Tsk(id,nTask)
      Else If (iOpt.eq.1) Then
         Call GetMem('TskList','Allo','Inte',id,nTask)
         Call ICopy(nTask,List,1,iWork(id),1)
         iRsv=0
      Else
         Call WarningMessage(2,'Error in Init_Tsk2')
         Write (6,*) 'Init_Tsk2: illegal iOpt value!'
         Call Abend()
      End If
*
      Return
      End
      Logical Function Rsv_Tsk2(id,kls)
      External Rsv_Tsk
#include "WrkSpc.fh"
      Common /Tsk2/ iRsv,iOpt,nTask
      Logical Rsv_Tsk
*
      If (iOpt.eq.0) Then
         Rsv_Tsk2=Rsv_Tsk(id,kls)
      Else If (iOpt.eq.1) Then
         Rsv_Tsk2=.True.
         If (iRsv+1.gt.nTask) Then
            Rsv_Tsk2=.False.
         Else
            kls=iWork(id+iRsv)
            iRsv=iRsv+1
            If (kls.le.0) Rsv_Tsk2=.False.
            If (kls.gt.nTask) Rsv_Tsk2=.False.
         End If
      Else
         Rsv_Tsk2=.False.
         Call WarningMessage(2,'Error in Rsv_Tsk2')
         Write (6,*) 'Rsv_Tsk2: illegal iOpt value!'
         Call Abend()
      End If
*
      Return
      End
      Subroutine Free_Tsk2(id)
      Common /Tsk2/ iRsv,iOpt,nTask
*
      If (iOpt.eq.0) Then
         Call Free_Tsk(id)
      Else If (iOpt.eq.1) Then
         Call GetMem('TskList','Free','Inte',id,nTask)
         nTask=0
      Else
         Call WarningMessage(2,'Error in Free_Tsk2')
         Write (6,*) 'Free_Tsk2: illegal iOpt value!'
         Call Abend()
      End If
      iOpt=-1
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1984,1986, Bernd Artur Hess                            *
************************************************************************
      REAL*8 FUNCTION PHI(M,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CRELOP/ PI,ZWP,SQPI,VELIT,PREA,CSQ,ZWPH32,FAK(26),
     *ZWPH12,BCO(210),GAM(20),IMAX
      IF (MOD(N,2).EQ.1.OR.MOD(M,2).EQ.1) GOTO 10
      PHI=2.D0*GAM(M+1)*GAM(N+1)/GAM(M+N+2)
      RETURN
10    PHI=0.D0
      RETURN
      END
C *** PVP V 1.0 - 19.1.84 - BERND HESS
C *** PVP V 1.1 -  5.6.86 - BERND HESS
      REAL*8 FUNCTION
     *PVP(CHARGE,AL,BE,L1,M1,N1,L2,M2,N2)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /CRELOP/ PI,ZWP,SQPI,VELIT,PREA,CSQ,ZWPH32,FAK(26),
     *ZWPH12,BCO(210),GAM(20),IMAX
      INTEGER IS1(3),IS2(3)
C
C    CALCULATE ANGULAR AND RADIAL PART
C
      II=L1+L2
      JJ=M1+M2
      KK=N1+N2
CBS   LAMBDA set to zero, as it is not initialized.   98/02/17
      LAMBDA=0
      IMAX=II+JJ+KK+LAMBDA+3
      IF (IMAX.LE.20) GOTO 2
C
C    ERROR BRANCH: ANGULAR MOMENTUM  > MAXIMUM GIVEN BY ARRAY GAM
C
      WRITE (6,1002) L1,M1,N1,L2,M2,N2,LAMBDA
1002  FORMAT(' ILLEGAL ANGULAR MOMENTUM (PVP)'/,
     *       ' L1,M1,N1,L2,M2,N2,LAMBDA PRINTED'/,1X,7I5)
      Call Abend
C
C    COMPUTE INTEGRAL OVER DERIVATIVE OF THE FUNCTIONS
C
2     IS1(1)=L1
      IS1(2)=M1
      IS1(3)=N1
      IS2(1)=L2
      IS2(2)=M2
      IS2(3)=N2
      SUM=DER(1,IS1,IS2,AL,BE)+DER(2,IS1,IS2,AL,BE)+
     \    DER(3,IS1,IS2,AL,BE)
      SUM=SUM*CHARGE
      PVP=SUM
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_DECDRV(DIAG)
!
! Purpose: driver for the decomposition of the two-electron integral
!          matrix based on the reduced diagonal.

use Cholesky, only: CHO_DECALG, Cho_Real_Par, CHO_SIMP, DIAMIN, DID_DECDRV, FRAC_CHVBUF, INF_PASS, INF_VECBUF, InfRed, IPRINT, &
                    LuPri, LuSel, MaxRed, nDimRS, nnBstR, nnBstRT, nnBstRT_G, nnShl, nnShl_G, nSym, NumCho, TDECDRV, ThrCom, &
                    Trace_Idle, Span, XnPass
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Diag(*)
integer(kind=iwp) :: I, IPASS, IPASS_PREV, IRC, IRED, ISYLST(8), iSym, JPASS, KRED, LWRK, MPASS, NBIN, nDim_Now, NGSP, NPOTSH, NUM
real(kind=wp) :: BIN1, DIAMAX_SIMP(8), STEP, TCPU1, TCPU2, TLDEC, TLDEC1, TLDEC2, TLINT, TLINT1, TLINT2, TLTOT, TLTOT1, TLTOT2, &
                 TWALL1, TWALL2, WLDEC, WLDEC1, WLDEC2, WLINT, WLINT1, WLINT2, WLTOT, WLTOT1, WLTOT2
logical(kind=iwp) :: CONV, SYNC
character(len=20) :: STRING
character(len=7) :: FILSEL
integer(kind=iwp), allocatable :: KISYSH(:), LSTQSP(:)
real(kind=wp), allocatable :: KDIASH(:), KWRK(:)
logical(kind=iwp), parameter :: LOCDBG = .false.
character(len=*), parameter :: SECNAM = 'CHO_DECDRV'

! Start timing.
! -------------

call CWTIME(TCPU1,TWALL1)

! Initializations and static settings.
! IRED=2: points to current reduced set in index arrays.
! ------------------------------------------------------

IRED = 2
CONV = .false.

! Initialize Cholesky vector buffer.
! ----------------------------------

call CHO_VECBUF_INIT(FRAC_CHVBUF,NNBSTR(1,1))
if (LOCDBG .or. (IPRINT >= INF_VECBUF)) call CHO_VECBUF_PRINT(LUPRI,NSYM)

! Allocate memory for shell pair based diagonal.
! It is important that the DIASH allocation is first, as memory is
! released by flushing back to and including this allocation.
! ----------------------------------------------------------------

if (Cho_Real_Par) then
  NGSP = nnShl_G
else
  NGSP = nnShl
end if
call mma_allocate(KDIASH,NGSP,Label='KDIASH')
call mma_allocate(KISYSH,NGSP,Label='KISYSH')

! Set first integral pass.
! ------------------------

SYNC = .false.
NPOTSH = 0
call CHO_P_SETPASS(DIAG,SYNC,KDIASH,KISYSH,IRED,CONV,NPOTSH)
if (NPOTSH > 0) then
  if (CONV) call CHO_QUIT('Logical error [0.1] in '//SECNAM,103)
else
  if (.not. CONV) call CHO_QUIT('Logical error [0.2] in '//SECNAM,103)
end if

! Allocate shell pair list.
! -------------------------

call mma_allocate(LSTQSP,max(NPOTSH,1),Label='LSTQSP')

! Loop over integral passes. Continue until convergence or
! until the max. number of integral passes has been reached.
! To each integral pass there is associated a reduced set,
! so the IPASS counter is also used as identifier of reduced
! set during I/O.
! ----------------------------------------------------------

IPASS = XNPASS
JPASS = 0
if (Cho_Real_Par) then
  MPASS = nnBstRT_G(IRED)
else
  MPASS = nnBstRT(IRED)
end if
do while ((.not. CONV) .and. (JPASS < MPASS))

  ! Update integral pass counter.
  ! -----------------------------

  JPASS = JPASS+1
  IPASS = IPASS+1

  ! Print.
  ! ------

  if (IPRINT >= INF_PASS) then
    call CWTIME(TLTOT1,WLTOT1)
    write(STRING,'(A13,I7)') 'Integral Pass',IPASS
    call CHO_HEAD(STRING,'*',80,LUPRI)
  end if

  ! Update idle proc info.
  ! ----------------------

  if (Trace_Idle) then
    nDim_Now = sum(nnBstR(1:nSym,2))
    call Cho_TrcIdl_Update(nDim_Now < 1)
  end if

  ! Debug: print diagonal.
  ! ----------------------

  if (LOCDBG) then
    write(LUPRI,*) SECNAM,': debug: diagonal before pass ',IPASS
    do ISYM=1,NSYM
      ISYLST(ISYM) = ISYM
    end do
    SYNC = .false.
    call CHO_P_PRTDIA(DIAG,SYNC,ISYLST,NSYM,IRED)
    write(LUPRI,*)
    write(LUPRI,*) SECNAM,': INFRED before pass ',IPASS
    write(LUPRI,'(10I8)') (INFRED(I),I=1,min(IPASS,MAXRED))
  end if

  ! Write index arrays for reduced set to disk
  ! and update disk address.
  ! ------------------------------------------

  call CHO_P_PUTRED(IPASS,IRED)

  ! Maintain Cholesky vector buffer.
  ! The logicals request that statistics informations are updated
  ! in the maintainance routine.
  ! -------------------------------------------------------------

  IRC = 0
  IPASS_PREV = IPASS-1
  call CHO_VECBUF_MAINTAIN(IRC,IPASS_PREV,.true.,.true.)
  if (IRC /= 0) then
    write(LUPRI,*) SECNAM,': CHO_VECBUF_MAINTAIN returned ',IRC
    call CHO_QUIT('Error detected in '//SECNAM,IRC)
  end if

  ! Open scratch files for qualified integral columns.
  ! --------------------------------------------------

  do ISYM=1,NSYM
    if (NNBSTR(ISYM,2) > 0) then
      LUSEL(ISYM) = 7
      write(FILSEL,'(A6,I1)') 'CHOSEL',ISYM
      call DANAME_WA(LUSEL(ISYM),FILSEL)
    else
      LUSEL(ISYM) = -1
    end if
  end do

  ! Get integral columns on disk stored in current reduced set.
  ! -----------------------------------------------------------

  if (IPRINT >= INF_PASS) call CWTIME(TLINT1,WLINT1)
  NUM = 0
  call CHO_GETINT(DIAG,KDIASH,KISYSH,LSTQSP,NPOTSH,NUM)
  call XFLUSH(LUPRI)
  if (IPRINT >= INF_PASS) call CWTIME(TLINT2,WLINT2)

  ! Decompose the qualified integral columns.
  ! -----------------------------------------

  if (IPRINT >= INF_PASS) call CWTIME(TLDEC1,WLDEC1)
  if ((CHO_DECALG == 4) .or. (CHO_DECALG == 5) .or. (CHO_DECALG == 6)) then
    call CHO_DECOM_A4(DIAG,LSTQSP,NUM,IPASS)
  else
    if (CHO_SIMP) then
      call CHO_MAXDX(DIAG,DIAMAX_SIMP)
      do ISYM=1,NSYM
        DIAMIN(ISYM) = max(THRCOM,DIAMAX_SIMP(ISYM)*SPAN)
      end do
    end if
    call mma_maxDBLE(LWRK)
    call mma_allocate(KWRK,LWRK,Label='KWRK')
    call CHO_DECOM(DIAG,KWRK,LWRK,IPASS,NUM)
    call mma_deallocate(KWRK)
  end if
  call XFLUSH(LUPRI)
  if (IPRINT >= INF_PASS) call CWTIME(TLDEC2,WLDEC2)

  ! Sync global vector counter.
  ! ---------------------------

  call CHO_P_SYNCNUMCHO(NUMCHO,NSYM)

  ! Write restart info to disk.
  ! ---------------------------

  call CHO_P_WRRSTC(IPASS)

  ! Close scratch files for qualified integral columns.
  ! ---------------------------------------------------

  do ISYM=1,NSYM
    if (LUSEL(ISYM) > 0) call DACLOS(LUSEL(ISYM))
  end do

  ! Sync diagonal.
  ! --------------

  call CHO_P_SYNCDIAG(DIAG,2)

  ! Analyze diagonal.
  ! -----------------

  if (IPRINT >= INF_PASS) then
    BIN1 = 1.0e2_wp
    STEP = 1.0e-1_wp
    NBIN = 18
    SYNC = .false.
    call CHO_P_ANADIA(DIAG,SYNC,BIN1,STEP,NBIN,.false.)
  end if

  ! Get next reduced set.
  ! ---------------------

  SYNC = .false.
  call CHO_P_SETRED(DIAG,SYNC)
  KRED = IPASS+1
  call CHO_SETRSDIM(NDIMRS,NSYM,MAXRED,KRED,IRED)
  if (IPRINT >= INF_PASS) then
    call CHO_P_PRTRED(2)
    call XFLUSH(LUPRI)
  end if

  ! Check convergence and, if not converged, set next integral pass.
  ! ----------------------------------------------------------------

  SYNC = .false.
  NPOTSH = 0
  call CHO_P_SETPASS(DIAG,SYNC,KDIASH,KISYSH,IRED,CONV,NPOTSH)
  if (NPOTSH > 0) then
    if (CONV) call CHO_QUIT('Logical error [1.1] in '//SECNAM,103)
  else
    if (.not. CONV) call CHO_QUIT('Logical error [1.2] in '//SECNAM,103)
  end if

  ! Update bookmarks: store largest diagonal (integral accuracy)
  ! and number of Cholesky vectors.
  ! ------------------------------------------------------------

  call Cho_P_UpdateBookmarks(iPass)

  ! Print idle report.
  ! ------------------

  if (Trace_Idle) call Cho_TrcIdl_Report()

  ! Print timing for this pass.
  ! ---------------------------

  if (IPRINT >= INF_PASS) then
    TLINT = TLINT2-TLINT1
    WLINT = WLINT2-WLINT1
    TLDEC = TLDEC2-TLDEC1
    WLDEC = WLDEC2-WLDEC1
    call CWTIME(TLTOT2,WLTOT2)
    TLTOT = TLTOT2-TLTOT1
    WLTOT = WLTOT2-WLTOT1
    write(LUPRI,'(/,A,I7,A)') 'Overall timings for integral pass',IPASS,' (CPU/Wall in seconds):'
    write(LUPRI,'(A,F12.2,1X,F12.2)') 'Integrals (incl. qualified I/O etc.): ',TLINT,WLINT
    write(LUPRI,'(A,F12.2,1X,F12.2)') 'Decomposition of qualified columns  : ',TLDEC,WLDEC
    write(LUPRI,'(A,F12.2,1X,F12.2)') 'Total (incl. restart info I/O etc.) : ',TLTOT,WLTOT
  end if

end do

! Free memory for shell pair based diagonal.
! ------------------------------------------

call mma_deallocate(LSTQSP)
call mma_deallocate(KISYSH)
call mma_deallocate(KDIASH)

! Shut down the Cholesky vector buffer.
! -------------------------------------

call CHO_VECBUF_FINAL()

! Set stuff for statistics.
! -------------------------

DID_DECDRV = .true.
XNPASS = IPASS

! Timing.
! -------

call CWTIME(TCPU2,TWALL2)
TDECDRV(1) = TCPU2-TCPU1
TDECDRV(2) = TWALL2-TWALL1

end subroutine CHO_DECDRV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine Assg2(g2,nT,nRys,la,lb,lc,ld,xyz2D0,xyz2D1,xyz2D2,IfHss,Index1,Index2,ng,nh,PAO)
!***********************************************************************
!                                                                      *
! Object: to assemble the gradients of the ERI's.                      *
!                                                                      *
!     Author: Anders Bernhardsson                                      *
!             Dept. of Theoretical Chemistry,                          *
!             University of Lund, SWEDEN                               *
!             March '95                                                *
!***********************************************************************

use Index_Functions, only: C_Ind3_Rev, nTri_Elem, nTri_Elem1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: g2(78)
integer(kind=iwp), intent(in) :: nT, nRys, la, lb, lc, ld, Index1(3,3), Index2(2,6,3), ng(3), nh(3)
real(kind=wp), intent(in) :: xyz2D0(nRys,nT,0:la+2,0:lb+2,0:lc+2,0:ld+2,3), xyz2D1(nRys,nT,0:la,0:lb,0:lc,0:ld,9), &
                             xyz2D2(nRys,nT,0:la,0:lb,0:lc,0:ld,18), &
                             PAO(nT,nTri_Elem1(la),nTri_Elem1(lb),nTri_Elem1(lc),nTri_Elem1(ld))
logical(kind=iwp), intent(in) :: IfHss(4,3,4,3)
#include "itmax.fh"
integer(kind=iwp) :: I, ia1, ia2, ia3, ib1, ib2, ib3, ic1, ic2, ic3, iCar, iCent, icir(3), id1, id2, id3, iDer, ipa, ipb, ipc, &
                     ipd, iRys, it, ix1, ix2, jCar, jCent, jDer, kCar
real(kind=wp) :: tmp

!define _DEBUGPRINT_
!iRout = 248
!iPrint = nPrint(iRout)
g2(:) = Zero
#ifdef _DEBUGPRINT_
call RecPrt('Assg2: g2(0)',' ',g2,1,78)
#endif
kCar = 0 ! dummy initialize

! First we construct the non diagonal derivatives

do iCar=1,3
  do jCar=1,3

    ! Determine the permutation of the cartesian indices

    if (jCar == iCar) cycle
    if (iCar*jCar == 2) Kcar = 3
    if (iCar*jCar == 6) kCar = 1
    if (iCar*jCar == 3) KCar = 2

    ! Loop over the atomic centre, in order
    ! that the integrals are calculated in.

    do iDer=1,ng(iCar)
      do jDer=1,ng(jCar)
        iCent = Index1(iDer,iCar)
        jCent = Index1(jDer,jCar)

        if (IfHss(iCent,iCar,jCent,jCar)) then
          I = nTri_Elem((iCent-1)*3+iCar-1)+(jCent-1)*3+jCar
          ix1 = (iDer-1)*3+iCar
          ix2 = (jDer-1)*3+jCar

          ! Loop over angular momentas

          do ipd=1,nTri_Elem1(ld)
            icir(:) = C_Ind3_Rev(ipd,ld)
            id1 = icir(iCar)
            id2 = icir(jCar)
            id3 = icir(kCar)
            do ipc=1,nTri_Elem1(lc)
              icir(:) = C_Ind3_Rev(ipc,lc)
              ic1 = icir(iCar)
              ic2 = icir(jCar)
              ic3 = icir(kCar)
              do ipb=1,nTri_Elem1(lb)
                icir(:) = C_Ind3_Rev(ipb,lb)
                ib1 = icir(iCar)
                ib2 = icir(jCar)
                ib3 = icir(kCar)
                do ipa=1,nTri_Elem1(la)
                  icir(:) = C_Ind3_Rev(ipa,la)
                  ia1 = icir(iCar)
                  ia2 = icir(jCar)
                  ia3 = icir(kCar)

                  ! Loop over Rys-polynomia and exponents of the basis set!

                  tmp = Zero
                  do it=1,nt
                    do iRys=1,nRys
                      tmp = tmp+PAO(iT,ipa,ipb,ipc,ipd)*xyz2D0(iRys,iT,ia3,ib3,ic3,id3,kCar)*xyz2D1(iRys,iT,ia1,ib1,ic1,id1,ix1)* &
                            xyz2D1(iRys,iT,ia2,ib2,ic2,id2,ix2)
                    end do
                  end do
                  g2(I) = g2(I)+tmp
                end do
              end do
            end do
          end do
        end if
      end do
    end do
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('Assg2: g2 non-diagonal',' ',g2,1,78)
#endif

! Then construct the diagonal derivatives

do iCar=1,3
  jCar = mod(iCar,3)+1
  kCar = mod(jCar,3)+1
  do iDer=1,nh(iCar)
    ix1 = (iDer-1)*3+iCar
    iCent = Index2(1,iDer,iCar)
    jCent = Index2(2,iDer,iCar)
    if (IfHss(iCent,iCar,jCent,iCar)) then
      I = nTri_Elem((iCent-1)*3+iCar-1)+(jCent-1)*3+iCar

      do ipd=1,nTri_Elem1(ld)
        icir(:) = C_Ind3_Rev(ipd,ld)
        id1 = icir(iCar)
        id2 = icir(jCar)
        id3 = icir(kCar)
        do ipc=1,nTri_Elem1(lc)
          icir(:) = C_Ind3_Rev(ipc,lc)
          ic1 = icir(iCar)
          ic2 = icir(jCar)
          ic3 = icir(kCar)
          do ipb=1,nTri_Elem1(lb)
            icir(:) = C_Ind3_Rev(ipb,lb)
            ib1 = icir(iCar)
            ib2 = icir(jCar)
            ib3 = icir(kCar)
            do ipa=1,nTri_Elem1(la)
              icir(:) = C_Ind3_Rev(ipa,la)
              ia1 = icir(iCar)
              ia2 = icir(jCar)
              ia3 = icir(kCar)

              tmp = Zero
              do it=1,nt
                do iRys=1,nRys
                  tmp = tmp+PAO(iT,ipa,ipb,ipc,ipd)*xyz2D0(iRys,iT,ia2,ib2,ic2,id2,jCar)*xyz2D0(iRys,iT,ia3,ib3,ic3,id3,kCar)* &
                        xyz2D2(iRys,iT,ia1,ib1,ic1,id1,ix1)
                end do
              end do
              g2(I) = g2(I)+tmp

            end do
          end do
        end do
      end do
    end if
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('Assg2: g2 full',' ',g2,1,78)
#endif

return

end subroutine Assg2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Angular_Prune(Radius,nR,iAngular_Grid,Crowding,Fade,
     &                         R_BS,L_Quad,R_Min,lAng,nAngularGrids,
     &                         Info_Ang,LMax_NQ)
      Implicit Real*8 (a-h,o-z)
      Real*8 Radius(2,nR), R_Min(0:lAng)
      Integer iAngular_Grid(nR), Info_Ang(3,LMax_NQ)
#include "real.fh"
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      R_Test=R_BS/Crowding
#ifdef _DEBUGPRINT_
      Write (6,*) 'lAng=',lAng
      Write (6,*) 'Crowding=',Crowding
      Write (6,*) 'R_BS=',R_BS
      Write (6,*) 'L_Quad=',L_Quad
      Write (6,*) 'LMax_NQ=',LMax_NQ
      Write (6,*) 'nAngularGrids=',nAngularGrids
      Write (6,*) 'R_Test=',R_Test
      Write (6,'(A,10G10.3)') 'R_Min=',R_Min
      Write (6,*) 'Info_Ang(1,*)=',(Info_Ang(1,i),i=1,nAngularGrids)
#endif
      Do iR = 1, nR
*
         R_Value=Radius(1,iR)
#ifdef _DEBUGPRINT_
         Write (6,'(A,G10.3)') 'R_Value=',R_Value
#endif
*
*------- Establish L_Eff according to the crowding factor.
*
c        Avoid overflow by converting to Int at the end
         iAng=Int(Half*Min(L_Quad*R_Value/R_Test,DBLE(L_Quad)))
#ifdef _DEBUGPRINT_
         Write (6,*) 'iAng=',iAng
#endif
*
*------- Close to the nuclei we can use the alternative formula
*        given by the LMG radial grid.
*
         iAng=Max(iAng,lAng)
         Do jAng = lAng,1,-1
            If (R_Value.lt.R_Min(jAng)) iAng=Min(iAng,jAng-1)
         End Do
#ifdef _DEBUGPRINT_
         Write (6,*) 'iAng=',iAng
#endif
*
*       Fade the outer part
*
        R_Test2=Fade*R_BS
        If (R_Value.gt.R_Test2)
c          Avoid overflow by converting to Int at the end
     &     iAng=Int(Half*Min(L_Quad*R_Test2/R_Value,DBLE(L_Quad)))
*
*------- Since the Lebedev grid is not defined for any L_Eff
*        value we have to find the closest one, i.e. of the same
*        order or higher. Start loop from low order!
*
         kSet = 0
         Do jSet = 1, nAngularGrids
            If (Info_Ang(1,jSet).ge.2*iAng+1.and.kSet.eq.0) Then
               kSet=jSet
               iAng=Info_Ang(1,kSet)/2
            End If
         End Do
         If (kSet.eq.0) Then
            kSet = nAngularGrids
            iAng=Info_Ang(1,kSet)/2
         End If
*
         iAngular_Grid(iR)=kSet
*
      End Do
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) 'iAngular_Grid:'
      Write (6,*) 'R_Min     R_Max    kSet  nR   nPoints'
      RStart=Radius(1,1)
      kSet=iAngular_Grid(1)
      nTot=Info_Ang(2,1)
      mR=1
      Do iR = 2, nR
         nTot=nTot+Info_Ang(2,iAngular_Grid(iR))
         If (iAngular_Grid(iR).ne.kSet.or.iR.eq.nR) Then
            jR=iR-1
            If (iR.eq.nR) Then
               jR=nR
               mR = mR + 1
            End If
            Write (6,'(2G10.3,I3,2I5)') RStart,Radius(1,jR),kSet,
     &                                 mR,Info_Ang(2,kSet)
            RStart=Radius(1,iR)
            kSet=iAngular_Grid(iR)
            mR = 0
         End If
         mR = mR + 1
      End Do
      Write (6,*) 'Total grid size:',nTot
      Write (6,*)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Sizes_of_Seward

use Definitions, only: iwp

implicit none
private

public :: S, Size_Dmp, Size_Get

#include "itmax.fh"
integer(kind=iwp), parameter :: nLen = 16+2*iTabMx ! number of elements
type Sizes_of_Stuff
  integer(kind=iwp) :: m2Max = 0
  integer(kind=iwp) :: mCentr = 0
  integer(kind=iwp) :: mCentr_Aux = 0
  integer(kind=iwp) :: mCentr_Frag = 0
  integer(kind=iwp) :: Mx_mdc = 0
  integer(kind=iwp) :: Mx_Shll = 0
  integer(kind=iwp) :: n2Tot = 0
  integer(kind=iwp) :: jMax = 5
  integer(kind=iwp) :: MaxPrm(0:iTabMx) = 0
  integer(kind=iwp) :: MaxBas(0:iTabMx) = 0
  integer(kind=iwp) :: nDim = 0
  integer(kind=iwp) :: nShlls = 0
  integer(kind=iwp) :: Max_Center = 15
  integer(kind=iwp) :: kCentr = 0
  integer(kind=iwp) :: nMltpl = 2
  integer(kind=iwp) :: iAngMx = -1
end type Sizes_of_Stuff

type(Sizes_of_Stuff) :: S

contains

subroutine Size_Dmp()

  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp) :: i
  integer(kind=iwp), allocatable :: iDmp(:)

  call mma_allocate(iDmp,nLen,Label='iDmp')

  i = 0
  iDmp(i+1) = S%m2Max
  i = i+1
  iDmp(i+1) = S%mCentr
  i = i+1
  iDmp(i+1) = S%mCentr_Aux
  i = i+1
  iDmp(i+1) = S%mCentr_Frag
  i = i+1
  iDmp(i+1) = S%Mx_mdc
  i = i+1
  iDmp(i+1) = S%Mx_Shll
  i = i+1
  iDmp(i+1) = S%n2Tot
  i = i+1
  iDmp(i+1) = S%jMax
  i = i+1
  iDmp(i+1:i+iTabMx+1) = S%MaxPrm(0:iTabMx)
  i = i+iTabMx+1
  iDmp(i+1:i+iTabMx+1) = S%MaxBas(0:iTabMx)
  i = i+iTabMx+1
  iDmp(i+1) = S%nDim
  i = i+1
  iDmp(i+1) = S%nShlls
  i = i+1
  iDmp(i+1) = S%Max_Center
  i = i+1
  iDmp(i+1) = S%kCentr
  i = i+1
  iDmp(i+1) = S%nMltpl
  i = i+1
  iDmp(i+1) = S%iAngMx
  i = i+1

  call Put_iArray('Sizes',iDmp,nLen)
  call mma_deallocate(iDmp)

end subroutine Size_Dmp

subroutine Size_Get()

  use stdalloc, only: mma_allocate, mma_deallocate
  use Definitions, only: u6

  integer(kind=iwp) :: i, Len2
  logical(kind=iwp) :: Found
  integer(kind=iwp), allocatable :: iDmp(:)

  call mma_allocate(iDmp,nLen,Label='iDmp')

  call Qpg_iArray('Sizes',Found,Len2)
  if (.not. Found) then
    write(u6,*) 'Size_Get: Sizes not found.'
    call Abend()
  end if
  if (nLen /= Len2) then
    write(u6,*) 'Size_Get: nLen /= Len2.'
    call Abend()
  end if
  call Get_iArray('Sizes',iDmp,nLen)

  i = 0
  S%m2Max = iDmp(i+1)
  i = i+1
  S%mCentr = iDmp(i+1)
  i = i+1
  S%mCentr_Aux = iDmp(i+1)
  i = i+1
  S%mCentr_Frag = iDmp(i+1)
  i = i+1
  S%Mx_mdc = iDmp(i+1)
  i = i+1
  S%Mx_Shll = iDmp(i+1)
  i = i+1
  S%n2Tot = iDmp(i+1)
  i = i+1
  S%jMax = iDmp(i+1)
  i = i+1
  S%MaxPrm(0:iTabMx) = iDmp(i+1:i+1+iTabMx)
  i = i+iTabMx+1
  S%MaxBas(0:iTabMx) = iDmp(i+1:i+1+iTabMx)
  i = i+iTabMx+1
  S%nDim = iDmp(i+1)
  i = i+1
  S%nShlls = iDmp(i+1)
  i = i+1
  S%Max_Center = iDmp(i+1)
  i = i+1
  S%kCentr = iDmp(i+1)
  i = i+1
  S%nMltpl = iDmp(i+1)
  i = i+1
  S%iAngMx = iDmp(i+1)
  i = i+1

  call mma_deallocate(iDmp)

end subroutine Size_Get

end module Sizes_of_Seward

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DBLOCK(D)
C
c     RASSCF program version IBM-3090: SX section
C
c     Purpose: To symmetry-block a full matrix d over the active orbital
c              the result is overlaid on the input matrix.
C
c     ********** IBM-3090 release 88 10 10 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
      DIMENSION D(*)
C
      IA=NASH(1)
      NTU=ITRI(IA+1)
      DO ISYM=2,NSYM
       NA=NASH(ISYM)
       IF(NA.EQ.0) GO TO 10
       DO NAT=1,NA
        DO NAU=1,NAT
         NTU=NTU+1
         ITU=ITRI(NAT+IA)+NAU+IA
         D(NTU)=D(ITU)
        END DO
       END DO
       IA=IA+NASH(ISYM)
10    CONTINUE
      END DO
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Roland Lindh                                     *
!***********************************************************************
! Version of Oct 21

subroutine XDIAXT(XDX,X,DIA,NDIM,SCR)
! Obtain XDX = X * DIA * X(Transposed)
! where DIA is a diagonal matrix stored as a vector

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDIM
real(kind=wp), intent(out) :: XDX(NDIM,NDIM), SCR(NDIM,NDIM)
real(kind=wp), intent(in) :: X(NDIM,NDIM), DIA(NDIM)
integer(kind=iwp) :: I

! DIA * X
do I=1,NDIM
  SCR(:,I) = DIA(I)*X(:,I)
end do
! X * DIA * X(Transposed)
call dgemm_('N','T',NDIM,NDIM,NDIM,One,X,NDIM,SCR,NDIM,Zero,XDX,NDIM)

return

end subroutine XDIAXT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
* OBSERVE! If the output to the mpprop file that this subroutine generates
*   is modified, then notify the person responsible for qmstat, since that
*   program uses the mpprop outputfile.
!EB      Subroutine Wr_Files(nAtoms,nCenters,nMltPl,NORBI,NOCOB,OENE,iBond,
      Subroutine Wr_Files(nAtoms,nCenters,nMltPl,NORBI,NOCOB,NOCOB_b,
     &           OENE,OENE_b,LAllCenters)

      Implicit Real*8 (a-h,o-z)

#include "MpParam.fh"
#include "WrkSpc.fh"
#include "Address.fh"
#include "MolProp.fh"

      Dimension OENE(NOCOB)
      Dimension OENE_b(NOCOB_b)
!EB      Dimension iBond(2,nCenters)
      Real*8 MolPol(6)
      Character*8 Name
      Logical Exist
      Logical LAllCenters

      Do i=1,6
         MolPol(i)=0.0D0
      EndDo

      Lu=30
      Name='MPPROP'
      Call OpnFl(Name,Lu,Exist)
      Rewind(Lu)
*
      Write(Lu,6) '**************************************************'
      Write(Lu,6) '* Molecule'
      Write(Lu,6) Title
      Write(Lu,6) '* Method'
      Write(Lu,6) Method
      Write(Lu,6) '* Level of Multipoles and Polarizabilities'
      Write(Lu,3) nMltPl,1
*
C
C WE NOW HAVE THE MULTIPOLES IN TWO FORMS
C
C A) SUMMED ONTO ATOMIC TERMS ONLY
C B) SUMMED ONTO ATOMS AND BONDS
C
C EXPANSION TO BE USED FOR ELECTROSTATICS
C
C       CENTER
C       MULTIPOLE
C       POLARIZABILITY
C
      If(.not.LAllCenters) Then
      Write(Lu,'(A)') '* Atomic centers '
      Write(Lu,2) nAtoms
      Do i=1,nAtoms
         Write(Lu,3) iAtomType(i),iAtomPar(i),Cen_Lab(i*(i+1)/2)
         write(Lu,1) cor(1,i,i),cor(2,i,i),cor(3,i,i)
         Do iMltPl=0,nMltPl
            nComp=(iMltPl+1)*(iMltPl+2)/2
            Write(Lu,1)(Work(iAtMltPlAd(iMltPl)+nAtoms*(iComp-1)+i-1),
     &      iComp=1,nComp)
         EndDo
         Do iMltPl=0,2
            nComp=(iMltPl+1)*(iMltPl+2)/2
            Write(Lu,1)(Work(iAtBoMltPlAdCopy(iMltPl)+nCenters*
     &      (iComp-1)+i*(i-1)/2+i-1),iComp=1,nComp)
         EndDo
         Write(Lu,1) (Work(iAtPolAd+nAtoms*j+i-1),j=0,5)
         Do j=0,5
            MolPol(j+1)=MolPol(j+1)+Work(iAtPolAd+nAtoms*j+i-1)
         EndDo
      EndDo

      Else

      Write(Lu,6) '* All centers'
      WRITE(Lu,2) nCenters
      Do i=1,nAtoms
         WRITE(Lu,3) iAtomType(i),iAtomPar(i),Cen_Lab(i*(i+1)/2)
         WRITE(Lu,1) Cor(1,i,i),Cor(2,i,i),Cor(3,i,i)
         Do iMltPl=0,nMltPl
            nComp=(iMltPl+1)*(iMltPl+2)/2
            Write(Lu,1)(Work(iAtBoMltPlAd(iMltPl)+nCenters*
     &      (iComp-1)+i*(i-1)/2+i-1),iComp=1,nComp)
         EndDo
         Do iMltPl=0,2
            nComp=(iMltPl+1)*(iMltPl+2)/2
            Write(Lu,1)(Work(iAtBoMltPlAdCopy(iMltPl)+nCenters*
     &      (iComp-1)+i*(i-1)/2+i-1),iComp=1,nComp)
         EndDo
! Begin EB
! if "pointer" iAtBoPolAd is not associated with memory
! print zero
         If( iAtBoPolAd .Eq. 0 ) Then
            Write(Lu,1)0.0d0,0.0d0,0.0d0,0.0d0,0.0d0,0.0d0
         Else
! End EB
            Write(Lu,1)(Work(iAtBoPolAd+nCenters*k+i*(i-1)/2+i-1),k=0,5)
! Begin EB
         End If
! End EB
      EndDo
      Do i=1,nAtoms
         Do j=1,i-1
            If(BondMat(i,j)) Then
               WRITE(Lu,5)0,iBondPar(i),iAtomType(i),iAtomPar(i),
     &                     iAtomType(j),iAtomPar(j),Cen_Lab(i*(i-1)/2+j)
               WRITE(Lu,1) Cor(1,i,j),Cor(2,i,j),Cor(3,i,j)
               Do iMltPl=0,nMltPl
                  nComp=(iMltPl+1)*(iMltPl+2)/2
                  Write(Lu,1)(Work(iAtBoMltPlAd(iMltPl)+nCenters*
     &            (iComp-1)+i*(i-1)/2+j-1),iComp=1,nComp)
               EndDo
               Do iMltPl=0,2
                  nComp=(iMltPl+1)*(iMltPl+2)/2
                  Write(Lu,1)(Work(iAtBoMltPlAdCopy(iMltPl)+nCenters*
     &            (iComp-1)+i*(i-1)/2+j-1),iComp=1,nComp)
               EndDo
! Begin EB
! if "pointer" iAtBoPolAd is not associated with memory
! print zero
               If( iAtBoPolAd .Eq. 0 ) Then
                  Write(Lu,1)0.0d0,0.0d0,0.0d0,0.0d0,0.0d0,0.0d0
               Else
! End EB
                  Write(Lu,1)
     &                 (Work(iAtBoPolAd+nCenters*k+i*(i-1)/2+j-1),k=0,5)
! Begin EB
               End If
! End EB
            EndIf
         EndDo
      EndDo

      EndIf

      WRITE(Lu,6) '* Molecule properties '
      Do iMltPl=0,nMltPl
         nComp=(iMltPl+1)*(iMltPl+2)/2
         Write(Lu,1)(Work(iAtMltPlTotAd(iMltPl)+iComp-1),iComp=1,nComp)
      EndDo
      Write(Lu,1) (MolPol(i),i=1,6)
      WRITE(Lu,'(A)') '* Orbital information'
      WRITE(Lu,3) NORBI, NOCOB
      WRITE(Lu,1) EneV
      If(NOCOB.ne.0) WRITE(Lu,1) (OENE(I),I=1,NOCOB)
      If(Method.eq.'UHF-SCF') Then
         WRITE(Lu,3) NOCOB_b
         If(NOcOb_b.ne.0) WRITE(Lu,1) (OENE_b(I),I=1,NOCOB_b)
      EndIf

      Close(Lu)

1     format(3F20.10)
2     format(I5)
3     format(2I5,4X,2A)
!EB 4     format(I5,A1)
5     format(6I5,4X,A)
6     format(A)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1971, Nelson H. F. Beebe                               *
************************************************************************
      SUBROUTINE CHO_OUTPUT(AMATRX,ROWLOW,ROWHI,COLLOW,COLHI,ROWDIM,
     *                      COLDIM,NCTL,LUPRI)
C.......................................................................
C
C OUTPUT PRINTS A REAL MATRIX IN FORMATTED FORM WITH NUMBERED ROWS
C AND COLUMNS.  THE INPUT IS AS FOLLOWS;
C
C        AMATRX(',').........MATRIX TO BE OUTPUT
C
C        ROWLOW..............ROW NUMBER AT WHICH OUTPUT IS TO BEGIN
C
C        ROWHI...............ROW NUMBER AT WHICH OUTPUT IS TO END
C
C        COLLOW..............COLUMN NUMBER AT WHICH OUTPUT IS TO BEGIN
C
C        COLHI...............COLUMN NUMBER AT WHICH OUTPUT IS TO END
C
C        ROWDIM..............ROW DIMENSION OF AMATRX(',')
C
C        COLDIM..............COLUMN DIMENSION OF AMATRX(',')
C
C        NCTL................CARRIAGE CONTROL FLAG; 1 FOR SINGLE SPACE
C                                                   2 FOR DOUBLE SPACE
C                                                   3 FOR TRIPLE SPACE
C
C THE PARAMETERS THAT FOLLOW MATRIX ARE ALL OF TYPE INTEGER*4.  THE
C PROGRAM IS SET UP TO HANDLE 5 COLUMNS/PAGE WITH A 1P,5D24.15 FORMAT
C FOR THE COLUMNS.  IF A DIFFERENT NUMBER OF COLUMNS IS REQUIRED,
C CHANGE FORMATS 1000 AND 2000, AND INITIALIZE KCOL WITH THE NEW NUMBER
C OF COLUMNS.
C
C AUTHOR;  NELSON H.F. BEEBE, QUANTUM THEORY PROJECT, UNIVERSITY OF
C          FLORIDA, GAINESVILLE
C REVISED; FEBRUARY 26, 1971
C
C.......................................................................
C
#include "implicit.fh"
      INTEGER   ROWLOW,ROWHI,COLLOW,COLHI,ROWDIM,COLDIM,BEGIN,KCOL
      DIMENSION AMATRX(ROWDIM,COLDIM)
      CHARACTER*1 ASA(3), BLANK, CTL
      CHARACTER   PFMT*20, COLUMN*8
      PARAMETER (ZERO=0.D00, KCOLP=4, KCOLN=6)
      PARAMETER (FFMIN=1.D-3, FFMAX = 1.D3)
      DATA COLUMN/'Column  '/, BLANK/' '/, ASA/' ', '0', '-'/
C
      IF (ROWHI.LT.ROWLOW) GO TO 3
      IF (COLHI.LT.COLLOW) GO TO 3
C
      AMAX = ZERO
      DO J = COLLOW,COLHI
         DO I = ROWLOW,ROWHI
            AMAX = MAX( AMAX, ABS(AMATRX(I,J)) )
         END DO
      END DO
      IF (AMAX .EQ. ZERO) THEN
         WRITE (LUPRI,'(/T6,A)') 'Zero matrix.'
         GO TO 3
      END IF
      IF (FFMIN .LE. AMAX .AND. AMAX .LE. FFMAX) THEN
C        use F output format
         PFMT = '(A1,I7,2X,8F15.8)'
      ELSE
C        use 1PD output format
         PFMT = '(A1,I7,2X,1P,8D15.6)'
      END IF
C
      IF (NCTL .LT. 0) THEN
         KCOL = KCOLN
      ELSE
         KCOL = KCOLP
      END IF
      MCTL = ABS(NCTL)
      IF ((MCTL.LE.3).AND.(MCTL.GT.0)) THEN
         CTL = ASA(MCTL)
      ELSE
         CTL = BLANK
      END IF
C
      LAST = MIN(COLHI,COLLOW+KCOL-1)
      DO 2 BEGIN = COLLOW,COLHI,KCOL
         WRITE (LUPRI,1000) (COLUMN,I,I = BEGIN,LAST)
         DO 1 K = ROWLOW,ROWHI
            DO 4 I = BEGIN,LAST
               IF (AMATRX(K,I).NE.ZERO) GO TO 5
    4       CONTINUE
         GO TO 1
    5       WRITE (LUPRI,PFMT) CTL,K,(AMATRX(K,I), I = BEGIN,LAST)
    1    CONTINUE
         LAST = MIN(LAST+KCOL,COLHI)
    2 CONTINUE
    3 RETURN
 1000 FORMAT (/12X,6(3X,A6,I4,2X),(3X,A6,I4))
C2000 FORMAT (A1,'Row',I4,2X,1P,8D15.6)
C2000 FORMAT (A1,I7,2X,1P,8D15.6)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Martin Schuetz                                   *
!               2017,2022, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine TraFck(canorb,FOVMax)
!***********************************************************************
!                                                                      *
!     purpose: Transform Fock Matrix to get Orbital energies           *
!                                                                      *
!     input:                                                           *
!       canorb  : Boolean: TRUE, if canonical orbs are desired,        *
!                          FALSE otherwise                             *
!                                                                      *
!     output:                                                          *
!       FOVMax  : Max Element of occ/virt block in Fock Matrix,        *
!                 transformed into MO basis                            *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use SpinAV, only: Do_SpinAV
use InfSCF, only: CMO, EOrb, FckAuf, FockAO, MaxBas, nBas, nBO, nBT, nConstr, nFro, nnFr, nOcc, nOrb, nSym, Ovrlp, TimFld
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(out) :: FOVMax
logical(kind=iwp), intent(in) :: CanOrb
integer(kind=iwp) :: ia, iCMO, iD, iDiag, iDum, iErr, iiCMO, iiEigV, iiScratch, ioFckM, iOff, iptr, iptr2, iSym, jEOr, jjEOr, kk, &
                     kOcc, kOff, n2Sort, n2Zero, nD, nFound, nOccmF, nOrbmF, nVrt
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: jCMO
#endif
real(kind=wp) :: Cpu1, Cpu2, Dummy, Fia, Tim1, Tim2, Tim3, Tmp, Tmp0, Tmp1
real(kind=wp), allocatable :: CMOOld(:), COvrlp(:), Ctmp(:), EigV(:), FckM(:), FckS(:), HlfF(:), Scratch(:), Scrt(:)
integer(kind=iwp), external :: iDaMax_
real(kind=wp), external :: DDot_

nD = size(FockAO,2)

call Timing(Cpu1,Tim1,Tim2,Tim3)
#ifdef _DEBUGPRINT_
call NrmClc(FockAO,size(FockAO),'TraFck','FockAO')
#endif
! allocate memory for modified Fock matrix
call mma_allocate(FckM,nBT,Label='FckM')
! allocate memory for squared Fock matrix
call mma_allocate(FckS,MaxBas**2,Label='FckS')

FOVMax = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
do iD=1,nD
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! modify Fock matrix
  FckM(:) = FockAO(:,iD)
  if (nnFr > 0) call ModFck(FckM,Ovrlp,nBT,CMO(1,iD),nBO,nOcc(1,iD))

  ioFckM = 1
  iCMO = 1
  jEOr = 1
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do iSym=1,nSym
    !                                                                  *
    !*******************************************************************
    !                                                                  *
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iD=',iD
    call RecPrt('TraFck: Old CMO',' ',CMO(iCMO,iD),nBas(iSym),nOrb(iSym))
    jCMO = iCMO
#   endif

    nOrbmF = nOrb(iSym)-nFro(iSym)
    nOccmF = nOcc(iSym,iD)-nFro(iSym)
    nVrt = nOrb(iSym)-nOcc(iSym,iD)

    iCMO = iCMO+nBas(iSym)*nFro(iSym) ! pointer to CMO

    if (nOrbmF > 0) then

      ! allocate memory for half-transformed Fock matrix
      call mma_allocate(HlfF,nBas(iSym)*nOrbmF,Label='HlfF')
      ! transform Fock matrix into new MO space
      call Square(FckM(ioFckM),FckS,1,nBas(iSym),nBas(iSym))
      call DGEMM_('N','N',nBas(iSym),nOrbmF,nBas(iSym), &
                  One,FckS,nBas(iSym), &
                  CMO(iCMO,iD),nBas(iSym), &
                  Zero,HlfF,nBas(iSym))
      call DGEMM_Tri('T','N',nOrbmF,nOrbmF,nBas(iSym), &
                     One,CMO(iCMO,iD),nBas(iSym), &
                     HlfF,nBas(iSym), &
                     Zero,FckS,nOrbmF)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'transformed Fck in trafck:'
      call TriPrt(' ',' ',FckS,nOrbmF)
#     endif
      ! dispose memory of half-transformed Fock matrix
      call mma_deallocate(HlfF)

      if ((nOccmF > 0) .and. (nVrt > 0)) then
        iptr = 1+nTri_Elem(nOccmF)

        ! get max Fock Matrix Element in OV block...

        do ia=1,nVrt
          Fia = abs(FckS(iptr+IDAMAX_(nOccmF,FckS(iptr),1)-1))
          FOVMax = max(Fia,FOVMax)
          iptr = iptr+nOccmF+ia
        end do
      end if
      !                                                                *
      !----------------------------------------------------------------*
      !                                                                *
      ! eventually diagonalize occ/occ & virt/virt Block
      ! separately to form canonical orbitals

      if (canorb) call Mk_CanOrb()

    end if
    !                                                                  *
    !------------------------------------------------------------------*
    !                                                                  *
    ! Update pointers
    iCMO = iCMO+nOrbmF*nBas(iSym)
    ioFckM = ioFckM+nTri_Elem(nBas(iSym))
    jEOr = jEOr+nOrbmF
#   ifdef _DEBUGPRINT_
    call RecPrt('TraFck: New CMO',' ',CMO(jCMO,iD),nBas(iSym),nOrb(iSym))
#   endif
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end do ! iSym
  !                                                                    *
  !*********************************************************************
  !                                                                    *
# ifdef _DEBUGCHECK__
  ! Check orthogonality
  if (canorb) call ChkOrt(iD,Whatever)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end do ! iD
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate memory
call mma_deallocate(FckS)
call mma_deallocate(FckM)

call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(13) = TimFld(13)+(Cpu2-Cpu1)

return

contains

subroutine Mk_CanOrb()

  integer(kind=iwp) :: i, ia, ii, iOcc, j, jOcc

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! allocate space for Eigenvectors of occ/occ & virt/virt block
  call mma_allocate(EigV,max(nOccmF,nVrt)**2,Label='EigV')
  ! allocate space for temporary CMO (for MatMul)
  call mma_allocate(CTmp,max(nOccmF,nVrt)*nBas(iSym),Label='CTmpX')
  if (.not. FckAuf) then
    call mma_allocate(CMOOld,nOccmF*nBas(iSym),Label='CMOOld')
    CMOOld(:) = CMO(iCMO:iCMO+nOccmF*nBas(iSym)-1,iD)
    call mma_allocate(Scrt,nBas(iSym)**2,Label='Scrt')
    call mma_allocate(COvrlp,nBas(iSym)*nOccmF,Label='COvrlp')
  end if

  if (nOccmF > 0) then

    ! diagonalize occ/occ first find the proper pointer to EOr

    jEOr = jEOr+nFro(iSym)
    call mma_allocate(Scratch,nOccmF**2,Label='Scratch')
    Dummy = Zero
    iDum = 0
    nOccmF = nOccmF-nConstr(iSym)

    call Diag_Driver('V','A','L',nOccmF,FckS,Scratch,nOccmF,Dummy,Dummy,iDum,iDum,EOrb(jEOr,iD),EigV,nOccmF,1,0,'J',nFound,iErr)

    if (nConstr(iSym) > 0) then
      Scratch(1:(nOccmF+nConstr(iSym))**2) = Zero
      do j=1,nOccmF
        iiEigV = 1+nOccmF*(j-1)
        iiScratch = 1+(nOccmF+nConstr(iSym))*(j-1)
        Scratch(iiScratch:iiScratch+nOccmF-1) = EigV(iiEigV:iiEigV+nOccmF-1)
      end do
      do j=nOccmF+1,nOccmF+nConstr(iSym)
        iiScratch = 1+(nOccmF+nConstr(iSym))*(j-1)+j-1
        Scratch(iiScratch) = One
      end do
      EigV(1:(nOccmF+nConstr(iSym))**2) = Scratch(1:(nOccmF+nConstr(iSym))**2)
    end if
    nOccmF = nOccmF+nConstr(iSym)
    call mma_deallocate(Scratch)
    n2zero = nOccmF
    if (Do_SpinAV) n2zero = n2zero+nConstr(iSym)
    FckS(1:nTri_Elem(n2zero)) = Zero

    iDiag = 0
    do i=1,n2zero
      iDiag = iDiag+i
      FckS(iDiag) = EOrb(jEOr+i-1,iD)
    end do

    ! Rotate MOs to diagonalize occ/occ block
    do ii=0,nOccmF-1
      CTmp(nBas(iSym)*ii+1:nBas(iSym)*(ii+1)) = CMO(iCMO+nBas(iSym)*ii:iCMO+nBas(iSym)*(ii+1)-1,iD)
    end do
    call DGEMM_('N','N',nBas(iSym),nOccmF,nOccmF, &
                One,Ctmp,nBas(iSym), &
                EigV,nOccmF, &
                Zero,CMO(iCMO,iD),nBas(iSym))

    ! Fix standard phase pf the orbitals

    do i=1,nOccmF
      call VecPhase(CMO(iCMO+(i-1)*nBas(iSym),iD),nBas(iSym))
    end do

    ! Order the occupied orbitals by maximum overlap with the old MOs.

    if (.not. FckAuf) then

      COvrlp(:) = Zero
      call Square(Ovrlp(ioFckM),Scrt,1,nBas(iSym),nBas(iSym))
      call DGEMM_('T','N',nOccmF,nBas(iSym),nBas(iSym), &
                  One,CMO(iCMO,iD),nBas(iSym), &
                  Scrt,nBas(iSym), &
                  Zero,COvrlp,nOccmF)

      do iOcc=1,nOccmF-1  !  Loop over the new MOs

        iOff = (iOcc-1)*nBas(iSym)+iCMO
        kOcc = 0
        Tmp0 = Zero
        do jOcc=1,nOccmF !  Loop over the new MOs
          Tmp1 = abs(DDot_(nBas(iSym),COvrlp(jOcc),nOccmF,CMO(iOff,iD),1))
          if (Tmp1 > Tmp0) then
            Tmp0 = Tmp1
            kOcc = jOcc
          end if
        end do

        if (iOcc /= kOcc) then
          ii = iOcc+jEOr-1
          kk = kOcc+jEOr-1
          tmp = EOrb(ii,iD)
          EOrb(ii,iD) = EOrb(kk,iD)
          EOrb(kk,iD) = tmp
          kOff = (kOcc-1)*nBas(iSym)+iCMO
          call DSwap_(nBas(iSym),CMO(iOff,iD),1,CMO(kOff,iD),1)
        end if
      end do

      iDiag = 0
      do i=1,n2zero
        iDiag = iDiag+i
        FckS(iDiag) = EOrb(jEOr+i-1,iD)
      end do

    end if
  end if

  if (nVrt > 0) then

    ! now diagonalize virt/virt block
    ! setup virt/virt block in triangular Fock Matrix

    iptr = 1+nTri_Elem(nOccmF)+nOccmF
    iptr2 = 1
    do ia=1,nVrt
      FckS(iptr2:iptr2+ia-1) = FckS(iptr:iptr+ia-1)
      iptr = iptr+nOccmF+ia
      iptr2 = iptr2+ia
    end do
    call mma_allocate(Scratch,nVrt**2,Label='Scratch')
    if (Do_SpinAV) then
      nVrt = nVrt-nConstr(iSym)
      jEOr = jEOr+nConstr(iSym)
      iptr = 1+nTri_Elem(nOccmF)+nOccmF
      do ia=1,nConstr(iSym)
        iptr = iptr+nOccmF+ia
        FckS(iptr) = -0.666e3_wp*real(1000-ia,kind=wp)
      end do
    end if
    Dummy = Zero
    iDum = 0
    call Diag_Driver('V','A','L',nVrt,FckS,Scratch,nVrt,Dummy,Dummy,iDum,iDum,EOrb(jEOr+nOccmF,iD),EigV,nVrt,1,0,'J',nFound,iErr)
    if (Do_SpinAV) then
      nVrt = nVrt+nConstr(iSym)
      jEOr = jEOr-nConstr(iSym)
      Scratch(1:nVrt**2) = Zero
      do j=1,nVrt-nConstr(iSym)
        iiEigV = 1+(nVrt-nConstr(iSym))*(j-1)
        iiScratch = 1+nVrt*(nConstr(iSym)+j-1)
        Scratch(iiScratch:iiScratch+nVrt-nConstr(iSym)-1) = EigV(iiEigV:iiEigV+nVrt-nConstr(iSym)-1)
      end do
      do j=1,nConstr(iSym)
        iiScratch = 1+nVrt*(j-1)+j-1
        Scratch(iiScratch) = One
      end do
      EigV(1:nVrt**2) = Scratch(1:nVrt**2)
    end if
    call mma_deallocate(Scratch)
    ! rotate MOs to diagonalize virt/virt block
    iptr = iCMO+nOccmF*nBas(iSym)
    do ia=0,nVrt-1
      CTmp(nBas(iSym)*ia+1:nBas(iSym)*(ia+1)) = CMO(iptr+nBas(iSym)*ia:iptr+nBas(iSym)*(ia+1)-1,iD)
    end do
    call DGEMM_('N','N',nBas(iSym),nVrt,nVrt, &
                One,Ctmp,nBas(iSym), &
                EigV,nVrt, &
                Zero,CMO(iptr,iD),nBas(iSym))
  end if

  if (nConstr(iSym) > 0) then
    ! Sort non-wavelet eigenvalues/eigenvectors
    n2sort = nOccmF-nConstr(iSym)
    if (FckAuf) call SortEig(EOrb(jEOr,iD),CMO(iCMO,iD),n2sort,nBas(iSym),1,.true.)
    jjEOr = jEOr+nOccmF+nConstr(iSym)
    iiCMO = iCMO+nBas(iSym)*(nOccmF+nConstr(iSym))
    n2sort = nVrt-nConstr(iSym)
    if (FckAuf) call SortEig(EOrb(jjEOr,iD),CMO(iiCMO,iD),n2sort,nBas(iSym),1,.true.)
  else
    ! Sort all eigenvalues and eigenvectors
    if (FckAuf) call SortEig(EOrb(jEOr,iD),CMO(iCMO,iD),nOrbmF,nBas(iSym),1,.true.)
  end if
  ! dispose memory
  if (.not. FckAuf) then
    call mma_deallocate(COvrlp)
    call mma_deallocate(Scrt)
    call mma_deallocate(CMOOld)
  end if
  call mma_deallocate(CTmp)
  call mma_deallocate(EigV)

end subroutine Mk_CanOrb

end subroutine TraFck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function vdWRad(iAtmNr)
! A function that returns the van der Waals radie of an element, when
! such a radie is available. The user should exercise some care and
! check if the radie is zero, in which case the radie has not been
! reported. Reference: Bondi, J.Phys.Chem. 68 (1964) 441.

use Constants, only: Angstrom
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: vdwRad
integer(kind=iwp), intent(in) :: iAtmNr
real(kind=wp), parameter :: Radii(102) = [ &
  1.20_wp,                                                1.40_wp,                                                         & ! 1-2
  1.82_wp,0.00_wp,0.00_wp,1.70_wp,1.55_wp,1.52_wp,1.47_wp,1.54_wp,                                                         & ! 3-10
  2.27_wp,1.73_wp,0.00_wp,2.10_wp,1.80_wp,1.80_wp,1.75_wp,1.88_wp,                                                         & ! 11-18
  2.75_wp,0.00_wp,                                                                                                         &
          0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,1.63_wp,1.40_wp,1.39_wp,                                 &
                  1.87_wp,0.00_wp,1.85_wp,1.90_wp,1.85_wp,2.02_wp,                                                         & ! 19-36
  0.00_wp,0.00_wp,                                                                                                         &
          0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,1.63_wp,1.72_wp,1.58_wp,                                 &
                  1.93_wp,2.17_wp,0.00_wp,2.06_wp,1.98_wp,2.16_wp,                                                         & ! 37-54
  0.00_wp,0.00_wp,                                                                                                         &
          0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp, &
          0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,1.75_wp,1.66_wp,1.55_wp,                                 &
                  1.96_wp,2.02_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,                                                         & ! 54-86
  0.00_wp,0.00_wp,                                                                                                         &
          0.00_wp,0.00_wp,0.00_wp,1.86_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp,0.00_wp  & ! 87-102
]

if (iAtmNr > size(Radii)) then
  write(u6,*) 'vdWRad: Too high atom number!'
  write(u6,*) 'iAtmNr=',iAtmNr
  call Quit_OnUserError()
end if
vdWRad = Radii(iAtmNr)/Angstrom

return

end function vdWRad

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine gencoulDIM(l1,l2,l3,l4,makemean,
     *bonn,breit,sameorb,icont4)
      implicit real*8(a-h,o-z)
cbs   SUBROUTINE to calculate the dimemsion of the radial integral
cbs   arrays. BASICALLY GENCOUL WITHOUT EXPLICIT INTEGRAL CALCULATION
cbs   integrals for the four angular momenta l1-l4
#include "para.fh"
#include "param.fh"
      logical makemean,bonn,breit,sameorb
      max1=1  !starting values for limits of precalculated
c             ! powers of function Cfunct(X)
      max2=1
c
      incont4=0
c
cbs   first of all, this routine determines, for which L
cbs   values the radial integrals have to be solved
cbs   initialize the number of blocks for the different
cbs   l-combinations
cbs   no (ss|ss) contributions
      if (l1.eq.0.and.l2.eq.0.and.l3.eq.0.and.l4.eq.0) return
c      ! no integrals for <ss|ss>
      if (makemean) then
                    nblock=1  ! sp sp are the first, so the first block
                    Lstarter(1)=1
      else
      Call SysAbendMsg('gencoulDIM',
     & 'only mean-field with this version',' ' )
      endif
cbs   keep track of L-values for later purposes
      Lvalues(1)=l1
      Lvalues(2)=l2
      Lvalues(3)=l3
      Lvalues(4)=l4
cbs   now nanz is given the new value
      nanz=ncontrac(l1)*ncontrac(l2)*ncontrac(l3)*ncontrac(l4)
      nprimprod=nprimit(l1)*nprimit(l2)*nprimit(l3)*nprimit(l4)
c
cbs   prepare the powers needed for cfunctx
c
c
c     There are seven different CASES of integrals following
c       (   A  --  C)
c
c     The structure is the same for all cases, therefore comments can be found only on case A
c
c
c
cbs   ###########################################################################################################
cbs   the (+2) cases          CASE A
cbs   ##########################################################################################################
      incl1=1  !  Those increments define the case
      incl3=1
cbs   determine the possible L-values for the integrals by checking for triangular equation
c
      call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
c
cbs   returns first and last L-values (Lanf,Lend), for which
cbs   radial integrals have to be calculated
      if(Lend-Lanf.ge.0) then
cbs   if there are blocks
              Lblocks(1)=(Lend-Lanf)/2+1 ! L increases in steps of 2,
cbs                                       due to parity conservation
              Lfirst(1)=Lanf
              Llast(1)=Lend
      else
              Lblocks(1)=0
      endif
cbs   ##########################################################################################################
cbs   the (0) cases         CASE  B
cbs   ##########################################################################################################
      incl1=0
      incl3=0
      call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
      if(Lend-Lanf.ge.0) then
      Lblocks(2)=(Lend-Lanf)/2+1
      Lfirst(2)=Lanf
      Llast(2)=Lend
      Lblocks(3)=(Lend-Lanf)/2+1
      Lfirst(3)=Lanf
      Llast(3)=Lend
      else
      Lblocks(2)=0
      Lblocks(3)=0
      endif
      Lstarter(2)=Lstarter(1)+
     *nanz*Lblocks(1)
      Lstarter(3)=Lstarter(2)+
     *nanz*Lblocks(2)
cbs   ##########################################################################################################
cbs   the (-2) cases      CASE C
cbs   ##########################################################################################################
      if (l1.eq.0.or.l3.eq.0) then
      Lblocks(4)=0
      else
      incl1=-1
      incl3=-1
      call getlimit(l1+incl1,l2,l3+incl3,l4,Lanf,Lend)
      if(Lend-Lanf.ge.0) then
      Lblocks(4)=(Lend-Lanf)/2+1
      Lfirst(4)=Lanf
      Llast(4)=Lend
      else
      Lblocks(4)=0
      endif
      endif
      Lstarter(4)=Lstarter(3)+
     *nanz*Lblocks(3)
c
CBS   now the hole purpose of this routine
c
      icont4=Lstarter(4)+nanz*Lblocks(4)
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_logical(bonn)
        call Unused_logical(breit)
        call Unused_logical(sameorb)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mk_Coeffs(CoeffA,nPrimA,nConA,CoeffB,nPrimB,nConB,Coeff,nTheta_Full,nPhi,iD,NumCho,List2,mData,nPhi_All,Indkl,nkl,nk, &
                     iAng,jAng,CoeffAP,CoeffBP)

use Index_Functions, only: iTri
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nPrimA, nConA, nPrimB, nConB, nTheta_Full, nPhi, NumCho, iD(NumCho), mData, nPhi_All, &
                                 List2(mData,nPhi_All), nkl, Indkl(nkl), nk, iAng, jAng
real(kind=wp), intent(in) :: CoeffA(nPrimA,nConA), CoeffB(nPrimB,nConB), CoeffAP(nPrimA,nPrimA), CoeffBP(nPrimB,nPrimB)
real(kind=wp), intent(out) :: Coeff(nTheta_Full,nPhi)
integer(kind=iwp) :: iCho, ik, il, iPhi, iPhi_All, iPhi_Full, iPrimA, iPrimB, iTheta_Full
real(kind=wp) :: Cff

!                                                                      *
!***********************************************************************
!                                                                      *

!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt('CoeffA',' ',CoeffA,nPrimA,nConA)
call RecPrt('CoeffB',' ',CoeffB,nPrimB,nConB)
call iVcPrt('Indkl',' ',Indkl,nkl)
call iVcPrt('Mk_Coeffs: iD',' ',iD,NumCho)
write(u6,*) 'iAng,jAng=',iAng,jAng
#endif
do iCho=1,NumCho
  iPhi_All = iD(iCho)
  if ((List2(1,iPhi_All) == iAng) .and. (List2(2,iPhi_All) == jAng)) then
    ik = List2(5,iPhi_All)
    il = List2(6,iPhi_All)

    if (iAng == jAng) then
      iPhi_Full = iTri(ik,il)
      iPhi = Indkl(iPhi_Full)
      if (iPhi == 0) cycle
      do iPrimA=1,nPrimA
        do iPrimB=1,iPrimA
          Cff = (CoeffA(iPrimA,ik)*CoeffB(iPrimB,il)+CoeffA(iPrimA,il)*CoeffB(iPrimB,ik))/ &
                (CoeffAP(iPrimA,iPrimA)*CoeffBP(iPrimB,iPrimB))
          if (iPrimA == iPrimB) Cff = Half*Cff
          iTheta_Full = iTri(iPrimA,iPrimB)
          Coeff(iTheta_Full,iPhi) = Cff
        end do
      end do
    else
      iPhi_Full = (il-1)*nk+ik
      iPhi = Indkl(iPhi_Full)
      if (iPhi == 0) cycle
      do iPrimA=1,nPrimA
        do iPrimB=1,nPrimB
          iTheta_Full = (iPrimB-1)*nPrimA+iPrimA
          Coeff(iTheta_Full,iPhi) = CoeffA(iPrimA,ik)*CoeffB(iPrimB,il)/(CoeffAP(iPrimA,iPrimA)*CoeffBP(iPrimB,iPrimB))
        end do
      end do
    end if

  end if
end do
#ifdef _DEBUGPRINT_
call RecPrt('Coeff',' ',Coeff,nTheta_Full,nPhi)
#endif

return

end subroutine Mk_Coeffs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995,1999, Jeppe Olsen                                 *
!***********************************************************************

subroutine IAIBCM(ICISPC,IAIB)
! obtain allowed combinbation of alpha- and beta- supergroups
! for CI space ICISPC
!
! Master for IAIBCM_GAS
!
! Jeppe Olsen, august 1995
! I_RE_MS2 added, May 99

use lucia_data, only: IBSPGPFTP, ICMBSPC, IGSOCCX, ISPGPFTP, LCMBSPC, MXPNGAS, NELFGP, NGAS, NOCTYP
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICISPC
integer(kind=iwp), intent(_OUT_) :: IAIB(*)
integer(kind=iwp) :: IATP, IBTP, IOCTPA, IOCTPB, NOCTPA, NOCTPB

IATP = 1
IBTP = 2

NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)

IOCTPA = IBSPGPFTP(IATP)
IOCTPB = IBSPGPFTP(IBTP)

!write(u6,*) ' IAIB ::::::'
!write(u6,*) ' LCMBSPC, ICISPC, ICMBSPC'
!write(u6,*) ICISPC,LCMBSPC(ICISPC)
!write(u6,*) (ICMBSPC(II,ICISPC),II=1,LCMBSPC(ICISPC))

call IAIBCM_GAS(LCMBSPC(ICISPC),ICMBSPC(:,ICISPC),IGSOCCX,NOCTPA,NOCTPB,ISPGPFTP(:,IOCTPA),ISPGPFTP(:,IOCTPB),NELFGP,MXPNGAS,NGAS, &
                IAIB)

end subroutine IAIBCM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine ChoMP2_fno_Fll(irc,Delete,P_ab,P_ii,EOcc,EVir,Wrk,lWrk)
!
!  F. Aquilante, Geneva May 2008  (snick to Pedersen's code)

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Cholesky, only: nSym, NumCho
use ChoMP2, only: ChoAlg, DecoMP2, DeMP2, iOcc, iMatab, iT1am, iVir, LiMatij, lUnit_F, MP2_small, nBatch, nMP2Vec, nMatab, nOcc, &
                  nT1am, nVir, shf
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
logical(kind=iwp), intent(in) :: Delete
real(kind=wp), intent(inout) :: P_ab(*), P_ii(*)
real(kind=wp), intent(in) :: EOcc(*), EVir(*)
integer(kind=iwp), intent(in) :: lWrk
real(kind=wp), intent(out) :: Wrk(lWrk)
integer(kind=iwp) :: i, iAdr, iBat, iClos, ij, iOpt, iS, iSym, iSyma, iSymb, iSymi, iSymj, iTyp, iVaJi(8), iVec, iVec0, iVec1, j, &
                     ja, jb, kEnd0, kEnd1, kEnd2, kMabij, kOff1, kOff2, kOffi, kOffj, kOffM, kOffMM, kP(8), kVec, kVecai, kXaibj, &
                     LiT2am(8), LnT2am, lP(8), lTot, lWrk0, lWrk1, lWrk2, Nai, nBat, nEnrVec(8), NumVec, nVaJi, nVec
real(kind=wp) :: Dnom, xsDnom
character(len=*), parameter :: SecNam = 'ChoMP2_fno_Fll'
real(kind=wp), external :: ddot_

if (nBatch /= 1) then
  irc = -1
  return
end if

irc = 0

kP(1) = 1
lP(1) = 0
do iS=2,nSym
  kP(iS) = kP(iS-1)+nVir(iS-1)**2
  lP(iS) = lP(iS-1)+nOcc(iS-1)
end do

DeMP2 = Zero

! Determine if vector files are to be deleted after use.
! ------------------------------------------------------

if (Delete) then
  iClos = 3
else
  iClos = 2
end if

! Set number and type of vectors.
! -------------------------------

if (DecoMP2) then
  iTyp = 2
  nEnrVec(1:nSym) = nMP2Vec(1:nSym)
else
  iTyp = 1
  nEnrVec(1:nSym) = NumCho(1:nSym)
end if

! Set (ai|bj) indices.
! --------------------

call ChoMP2_Energy_GetInd(LnT2am,LiT2am,1,1)

! Allocate memory for integrals.
! ------------------------------

kXaibj = 1
kEnd0 = kXaibj+LnT2am
lWrk0 = lWrk-kEnd0+1
if (lWrk0 < 0) call SysAbendMsg(SecNam,'insufficient memory','[0]')

if ((ChoAlg == 2) .and. MP2_small) then ! level 3 BLAS algorithm

  kMabij = kXaibj ! rename pointer
  Wrk(kMabij:kMabij+LnT2am-1) = Zero ! initialize

  ! Loop over Cholesky symmetries.
  ! ------------------------------

  do iSym=1,nSym

    Nai = nT1am(iSym)
    if ((Nai > 0) .and. (nEnrVec(iSym) > 0)) then

      ! Reserve memory for reading a single vector.
      ! -------------------------------------------

      kVecai = kEnd0
      kEnd1 = kVecai+Nai
      lWrk1 = lWrk-kEnd1+1

      if (lWrk1 < Nai) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.1]')

      ! Set up batch over Cholesky vectors.
      ! -----------------------------------

      nVec = min(lWrk1/Nai,nEnrVec(iSym))
      if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.2]') ! should not happen
      nBat = (nEnrVec(iSym)-1)/nVec+1

      ! Open Cholesky vector files.
      ! ---------------------------

      call ChoMP2_OpenF(1,iTyp,iSym)

      ! Start vector batch loop.
      ! ------------------------

      do iBat=1,nBat

        if (iBat == nBat) then
          NumVec = nEnrVec(iSym)-nVec*(nBat-1)
        else
          NumVec = nVec
        end if
        iVec1 = nVec*(iBat-1)+1

        ! Set up index arrays for reordered vectors.
        ! ------------------------------------------

        nVaJi = 0
        do iSymi=1,nSym
          iSyma = Mul(iSymi,iSym)
          iVaJi(iSymi) = nVaJi
          nVaJi = nVaJi+nVir(iSyma)*NumVec*nOcc(iSymi)
        end do

        ! Pointer to reordered vectors: kVec.
        ! -----------------------------------

        kVec = kEnd1
        kEnd2 = kVec+nVaJi
        lWrk2 = lWrk-kEnd2+1
        if (lWrk2 < 0) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.3]') ! should not happen

        ! Read one vector at a time and reorder.
        ! --------------------------------------

        iVec0 = iVec1-1
        do iVec=1,NumVec

          iOpt = 2
          lTot = nT1am(iSym)
          iAdr = nT1am(iSym)*(iVec0+iVec-1)+1
          call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVecai),lTot,iAdr)

          do iSymi=1,nSym
            iSyma = Mul(iSymi,iSym)
            do i=1,nOcc(iSymi)
              kOff1 = kVecai+iT1am(iSyma,iSymi)+nVir(iSyma)*(i-1)
              kOff2 = kVec+iVaJi(iSymi)+nVir(iSyma)*NumVec*(i-1)+nVir(iSyma)*(iVec-1)
              Wrk(kOff2:kOff2+nVir(iSyma)-1) = Wrk(kOff1:kOff1+nVir(iSyma)-1)
            end do
          end do

        end do

        ! Compute M(ab,ii) .
        !-------------------

        do iSymj=1,nSym

          iSymb = Mul(iSymj,iSym)

          if (nVir(iSymb) > 0) then

            do j=1,nOcc(iSymj)

              i = j

              ij = LiMatij(iSymj,iSymj,1)+iTri(i,j)

              kOffi = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(i-1)
              kOffj = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(j-1)
              kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

              call dGeMM_('N','T',nVir(iSymb),nVir(iSymb),NumVec,One,Wrk(kOffi),nVir(iSymb),Wrk(kOffj),nVir(iSymb),One,Wrk(kOffM), &
                          nVir(iSymb))

            end do

          end if

        end do

      end do

      call Cho_GAdGOp(Wrk(kMabij),LnT2am,'+')

      ! Close (and possibly delete) Cholesky vector files.
      ! --------------------------------------------------

      call ChoMP2_OpenF(iClos,iTyp,iSym)

      ! Compute Energy contribution.
      ! ----------------------------

      do iSymj=1,nSym

        iSymb = Mul(iSymj,iSym)

        if (nVir(iSymb) > 0) then

          do j=1,nOcc(iSymj)

            i = j

            ij = LiMatij(iSymj,iSymj,1)+iTri(i,j)

            kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

            do jb=1,nVir(iSymb)
              do ja=1,nVir(iSymb)
                Dnom = EVir(iVir(iSymb)+ja)+EVir(iVir(iSymb)+jb)-Two*EOcc(iOcc(iSymj)+j)
                xsDnom = Dnom/(Dnom**2+shf**2) !Reg shf
                kOffMM = kOffM+nVir(iSymb)*(jb-1)+ja-1
                !DeMP2 = DeMP2+Wrk(kOffMM)**2/Dnom
                DeMP2 = DeMP2+Wrk(kOffMM)**2*xsDnom
              end do
            end do

          end do

        end if

      end do

    end if

  end do ! iSym

else if (ChoAlg == 2) then ! level 3 BLAS algorithm

  kMabij = kXaibj ! rename pointer
  Wrk(kMabij:kMabij+LnT2am-1) = Zero ! initialize

  ! Loop over Cholesky symmetries.
  ! ------------------------------

  do iSym=1,nSym

    Nai = nT1am(iSym)
    if ((Nai > 0) .and. (nEnrVec(iSym) > 0)) then

      ! Reserve memory for reading a single vector.
      ! -------------------------------------------

      kVecai = kEnd0
      kEnd1 = kVecai+Nai
      lWrk1 = lWrk-kEnd1+1

      if (lWrk1 < Nai) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.1]')

      ! Set up batch over Cholesky vectors.
      ! -----------------------------------

      nVec = min(lWrk1/Nai,nEnrVec(iSym))
      if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.2]') ! should not happen
      nBat = (nEnrVec(iSym)-1)/nVec+1

      ! Open Cholesky vector files.
      ! ---------------------------

      call ChoMP2_OpenF(1,iTyp,iSym)

      ! Start vector batch loop.
      ! ------------------------

      do iBat=1,nBat

        if (iBat == nBat) then
          NumVec = nEnrVec(iSym)-nVec*(nBat-1)
        else
          NumVec = nVec
        end if
        iVec1 = nVec*(iBat-1)+1

        ! Set up index arrays for reordered vectors.
        ! ------------------------------------------

        nVaJi = 0
        do iSymi=1,nSym
          iSyma = Mul(iSymi,iSym)
          iVaJi(iSymi) = nVaJi
          nVaJi = nVaJi+nVir(iSyma)*NumVec*nOcc(iSymi)
        end do

        ! Pointer to reordered vectors: kVec.
        ! -----------------------------------

        kVec = kEnd1
        kEnd2 = kVec+nVaJi
        lWrk2 = lWrk-kEnd2+1
        if (lWrk2 < 0) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.3]') ! should not happen

        ! Read one vector at a time and reorder.
        ! --------------------------------------

        iVec0 = iVec1-1
        do iVec=1,NumVec

          iOpt = 2
          lTot = nT1am(iSym)
          iAdr = nT1am(iSym)*(iVec0+iVec-1)+1
          call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVecai),lTot,iAdr)

          do iSymi=1,nSym
            iSyma = Mul(iSymi,iSym)
            do i=1,nOcc(iSymi)
              kOff1 = kVecai+iT1am(iSyma,iSymi)+nVir(iSyma)*(i-1)
              kOff2 = kVec+iVaJi(iSymi)+nVir(iSyma)*NumVec*(i-1)+nVir(iSyma)*(iVec-1)
              Wrk(kOff2:kOff2+nVir(iSyma)-1) = Wrk(kOff1:kOff1+nVir(iSyma)-1)
            end do
          end do

        end do

        ! Compute M(ab,ii) .
        ! ------------------

        do iSymj=1,nSym

          iSymb = Mul(iSymj,iSym)

          if (nVir(iSymb) > 0) then

            do j=1,nOcc(iSymj)

              i = j

              ij = LiMatij(iSymj,iSymj,1)+iTri(i,j)

              kOffi = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(i-1)
              kOffj = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(j-1)
              kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

              call dGeMM_('N','T',nVir(iSymb),nVir(iSymb),NumVec,One,Wrk(kOffi),nVir(iSymb),Wrk(kOffj),nVir(iSymb),One,Wrk(kOffM), &
                          nVir(iSymb))

            end do

          end if

        end do

      end do

      call Cho_GAdGOp(Wrk(kMabij),LnT2am,'+')

      ! Close (and possibly delete) Cholesky vector files.
      ! --------------------------------------------------

      call ChoMP2_OpenF(iClos,iTyp,iSym)

      do iSymj=1,nSym

        iSymb = Mul(iSymj,iSym)

        if (nVir(iSymb) > 0) then

          do j=1,nOcc(iSymj)

            i = j

            ij = LiMatij(iSymj,iSymj,1)+iTri(i,j)

            kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

            ! Compute T(a,b)[i] and energy contrib.
            ! -------------------------------------
            do jb=1,nVir(iSymb)
              do ja=1,nVir(iSymb)
                Dnom = EVir(iVir(iSymb)+ja)+EVir(iVir(iSymb)+jb)-Two*EOcc(iOcc(iSymj)+j)
                xsDnom = Dnom/(Dnom**2+shf**2) !Reg shf
                kOffMM = kOffM+nVir(iSymb)*(jb-1)+ja-1
                !DeMP2 = DeMP2+Wrk(kOffMM)**2/Dnom
                DeMP2 = DeMP2+Wrk(kOffMM)**2*xsDnom
                !Wrk(kOffMM) = Wrk(kOffMM)/Dnom
                Wrk(kOffMM) = Wrk(kOffMM)*xsDnom
              end do
            end do

            P_ii(lP(iSymj)+i) = P_ii(lP(iSymj)+i)+ddot_(nVir(iSymb)**2,Wrk(kOffM),1,Wrk(kOffM),1)

            ! Compute P(a,b) += sum_c T(a,c)*T(c,b)
            ! -------------------------------------
            call dGeMM_('N','N',nVir(iSymb),nVir(iSymb),nVir(iSymb),One,Wrk(kOffM),nVir(iSymb),Wrk(kOffM),nVir(iSymb),One, &
                        P_ab(kP(iSymb)),nVir(iSymb))

          end do

        end if

      end do

    end if

  end do ! iSym

end if ! ChoAlg

end subroutine ChoMP2_fno_Fll

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Start(ModuleName)
* Initialization procedure for a program module.
      Implicit None
      Character*(*) ModuleName
      Character*8 Prin
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
      Logical parallelized
#endif
#include "standard_iounits.fh"

#ifdef _DEBUGPRINT_
      Write (6,*) ' Start.'
#endif

* fill the returncode database with human-readable messages
      Call rc_msg_init
* initialize global counter for the maximum warning level
      Call WarningInit

*
* Initialize delayed BLAS+LAPACK
*
      Call Init_LinAlg
#  ifdef _DEBUGPRINT_
      Write (6,*) ' BLAS+LAPACK initialized '
#  endif
*
*  Initialize Timing
*
      Call SetTim
#ifdef _DEBUGPRINT_
      Write (6,*) ' TIMING set'
#endif
*
* Initialize the parallel environment
*
      Call GAInit
#ifdef _DEBUGPRINT_
      Write(6,*) ' GA initialized: MyRank, nProcs = ', MyRank, nProcs
#endif
*
* Now that each process is in its own directory, we can read/write
* files that are local to the' work directory of each process.
*
      call write_rc(-1)
      Call getenvinit()
*
* Enable proper functions to handle various signals (needs environment!)
*
      call set_sighandlers(myrank)
*
*  Unix-related information must be set or checked here or later, PID and
*  master/slave status may not have been set before now.
*
      call write_pid
*
* Have processes print their PID and then sleep for an amount of seconds
* specified by the environment variable MOLCAS_NAP. This is to allow for
* attaching a debugger to multiple processes.
      call nap_time
*
*  Check that binary was executed via molcas script (check $MOLCAS_STAMP)
*  (DO NOT MOVE FROM HERE)
*
      Call CheckRun()
#  ifdef _DEBUGPRINT_
      Write (6,*) ' CHECKRUN passed'
#  endif

*  Initialize Memory manager (MOLCAS_MEM)
*  (DO NOT MOVE FROM HERE)
*
      Call IniMem()
#  ifdef _DEBUGPRINT_
      Write (6,*) ' MEMORY MANAGER initialized'
#  endif
*
*  Get various unix-related information :
*  (DO NOT MOVE FROM HERE)
*
      Call UnixInfo(ModuleName,ModuleName)
#  ifdef _DEBUGPRINT_
      Write (6,*) ' UNIXINFO passed '
#  endif

      call prgminit(ModuleName)
#  ifdef _DEBUGPRINT_
      Write (6,*) ' PRGM initialized'
#  endif

*  Now that prgm has been initialized, we know if a module is supposed to
*  support parallel execution. If not, then we can serialize the
*  processes, after which the slaves jump to the finish and wait there.

#ifdef _MOLCAS_MPP_
      parallelized = .True.
      If (.not.parallelized) Then
        Call Set_Do_Parallel(.False.)
        Call GATerminate
        If (.not.King()) Then
          Call Finish(-2)
        End If
      End If
#endif
*
* Redirect standard input to a file 'stdin'.
*
      LuRd=5
      close(LuRd)
      call molcas_open(LuRd,'stdin')
#  ifdef _DEBUGPRINT_
      Write (6,*) ' STDIN opened '
#  endif
*
*  Redirect standard output for slaves to a file 'stdout'.
*
      LuWr=6
      If(.Not.King())Then
        Close(LuWr)
        call molcas_open(LuWr,'stdout')
        call Append_file(LuWr)
      Endif
#  ifdef _DEBUGPRINT_
      Write (6,*) ' STDOUT opened '
#  endif
*
* Initialize XML
*
      Call ColorizeInit()
      call xml_Open('module',' ',' ',0,ModuleName)
#  ifdef _DEBUGPRINT_
      Write (6,*) ' XML initialized '
#  endif
*
*  Initiate spool mode to read from standard input
*
      Spool=.True.
*
*  Initiate I/O
*
      Call FIOInit()
#  ifdef _DEBUGPRINT_
      Write (6,*) ' I/O initialized '
#  endif
*
*  Initialize timings and statistics
*
      Call IniTim()
      Call IniStat()
#  ifdef _DEBUGPRINT_
      Write (6,*) ' TIMINGS/STATISTICS initialized'
#  endif
*
* Set standard name for the runfile
*
      Call NameRun('RUNFILE')
#  ifdef _DEBUGPRINT_
      Write (6,*) ' RUNFILE initialized '
#  endif
      Call Init_Run_Use()
*
* Initialize the peek/poke utility
*
      Call Init_ppu(.true.)
      Call poke_iScalar("xml opened",0)
*
* Set Grid Set
*
      Call NQ_Init()
#  ifdef _DEBUGPRINT_
      Write (6,*) ' GRID initialized '
#  endif

************************************************************************
* At this point, everything should have been properly initialized!     *
************************************************************************
* Finally, print useful runtime information about the module
      call getenvf("MOLCAS_PRINT", Prin)
      if(Prin(1:1).ne.'0'.and.Prin(1:1).ne.'S') then
      Call Print_Module_Header(ModuleName)
* Force output to be written to stdout, such that in case of problems
* later on, at least all the start info has been printed.
      Call xFlush(6)
      endif
* Write to the status file that the moduel has started
      Call StatusLine(ModuleName,' properly started!')
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine CtrlMO(moip,nAcO)

use Symmetry_Info, only: nIrrep
use Definitions, only: Iwp

implicit none
#include "etwas.fh"
integer(kind=iwp), intent(out) :: moip(0:nIrrep-1), nAcO
integer(kind=iwp) :: iIrrep, iTot

iTot = 0
do iIrrep=0,nIrrep-1
  moip(iIrrep) = iTot
  iTot = iTot+nAsh(iIrrep)
end do
nACO = iTot

return

end subroutine CtrlMO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_SetLQ()
!
! Purpose: set local qualified indices from known global qualified.
!
! The local indices are stored in the Cholesky module:
!
! nQual_L(iSym)   : #qualified, irrep iSym (=1,2,..,nSym)
! iQuAB_L(iQ,iSym): address of qualified iQ of sym. iSym in current
!                   local reduced set (i.e. reduced set at location
!                   2). Not symmetry reduced, i.e. includes the
!                   offset iiBstR(iSym,2).
! iQL2G(iQ,iSym)  : returns index of the qualified in the global
!                   list.

use Cholesky, only: Cho_Real_Par, iiBstR, iL2G, IndRed, IndRed_G, iQL2G, iQuAB, iQuAB_L, nnBstR, nQual, nQual_L, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, i2, iQ, iQG, iSym, j, k, nQL

if (.not. Cho_Real_Par) return ! not truly parallel...

iQuAB_L(:,:) = 0
iQL2G(:,:) = 0
do iSym=1,nSym
  nQL = 0
  do iQ=1,nQual(iSym)
    iQG = IndRed_G(iQuAB(iQ,iSym),2) ! addr of qual in glob. rs1
    i2 = iiBstR(iSym,2)+nnBstR(iSym,2)
    i = iiBstR(iSym,2)
    do while (i < i2)
      i = i+1
      j = IndRed(i,2) ! addr in local rs1
      k = iL2G(j)     ! addr in global rs1
      if (k == iQG) then ! found qual in local set
        nQL = nQL+1
        iQuAB_L(nQL,iSym) = i
        iQL2G(nQL,iSym) = iQ
        i = i2 ! break while loop
      end if
    end do
  end do
  nQual_L(iSym) = nQL
end do

end subroutine Cho_P_SetLQ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Reset2CF(iAtomPair,ID,M2,M2_new)
C
C     Thomas Bondo Pedersen, July 2010.
C     - based on LDF_RemoveLinDep by T.B. Pedersen.
C
C     Purpose: Reset two-center function info.
C
      Implicit None
      Integer iAtomPair
      Integer M2, M2_new
      Integer ID(M2_new)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_int.fh"

      Integer  LDF_nShell_Atom, LDF_nBasSh_Atom
      External LDF_nShell_Atom, LDF_nBasSh_Atom

      Character*8 Label

      Integer ip, l, ip_new, l_new, K
      Integer ip_Included, l_Included
      Integer nShell_iAtom, n2CF, i2CF, iS, jS, ijS, ij
      Integer iAtom

      Integer i, j
      Integer Included
      Integer AP_Atoms
      Integer AP_2CFunctions
      Integer IndxG2
      Included(i)=iWork(ip_Included-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      IndxG2(i,j)=iWork(ip_IndxG2-1+l_IndxG2_1*(j-1)+i)

      If (M2.ne.AP_2CFunctions(1,iAtomPair)) Then
         Call WarningMessage(2,'LDF_Reset2CF: Illegal M2')
         Call LDF_Quit(1)
      End If
      If (M2_new.eq.M2) Return

      Write(Label,'(A,I5.5)') '2CF',iAtomPair-1

      If (M2_new.lt.0) Then
         Call WarningMessage(2,'LDF_Reset2CF: M2_new<0')
         Call LDF_Quit(1)
      Else If (M2_new.eq.0) Then
         l=4*M2
         ip=AP_2CFunctions(2,iAtomPair)
         Call GetMem(Label,'Free','Inte',ip,l)
         iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=0
         iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=0
      Else If (M2_new.lt.M2) Then
         l_Included=M2
         Call GetMem('Included','Allo','Inte',ip_Included,l_Included)
         Call iZero(iWork(ip_Included),l_Included)
         ip=ip_Included-1
         Do K=1,M2_new
            iWork(ip+ID(K))=1
         End Do
         l_new=4*M2_new
         Call GetMem(Label,'Allo','Inte',ip_new,l_new)
         ip=AP_2CFunctions(2,iAtomPair)
         iAtom=AP_Atoms(1,iAtomPair)
         nShell_iAtom=LDF_nShell_Atom(iAtom)
         n2CF=0
         Do i2CF=0,M2-1
            iS=iWork(ip+4*i2CF)
            i=iWork(ip+4*i2CF+1)
            jS=iWork(ip+4*i2CF+2)
            j=iWork(ip+4*i2CF+3)
            ijS=nShell_iAtom*(jS-1)+iS
            ij=LDF_nBasSh_Atom(iS,iAtom)*(j-1)+i
            K=IndxG2(ij,ijS)
            If (K.gt.0) Then
               If (Included(K).eq.1) Then
                  iWork(ip_new+4*n2CF)=iS
                  iWork(ip_new+4*n2CF+1)=i
                  iWork(ip_new+4*n2CF+2)=jS
                  iWork(ip_new+4*n2CF+3)=j
                  n2CF=n2CF+1
               End If
            End If
         End Do
#if defined (_DEBUGPRINT_)
         If (n2CF.ne.M2_new) Then
            Call WarningMessage(2,'LDF_Reset2CF: n2CF != M2_new')
            Call LDF_Quit(1)
         End If
#endif
         l=4*M2
         ip=AP_2CFunctions(2,iAtomPair)
         Call GetMem(Label,'Free','Inte',ip,l)
         iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=M2_new
         iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=ip_new
         Call GetMem('Included','Free','Inte',ip_Included,l_Included)
      Else
         Call WarningMessage(2,'LDF_Reset2CF: M2_new>M2')
         Call LDF_Quit(1)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003, Valera Veryazov                                  *
!               2022, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DMat(XCf,nXCf,nD)
!***********************************************************************
!                                                                      *
! Purpose: Compute aufbau density matrix                               *
!                                                                      *
!***********************************************************************

use Interfaces_SCF, only: dOne_SCF, MinDns
use InfSCF, only: CMO, DDnOFF, Dens, DNorm, iDisk, InVec, iPsLst, Iter, MapDns, MiniDN, nBas, nBT, nDens, nFrz, nIter, nIterP, &
                  nMem, nOrb, nSym, OccNo, TwoHam, Vxc
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nXCF, nD
real(kind=wp), intent(out) :: XCf(nXCf,nD)
integer(kind=iwp) :: iD, iFrom, iOnDsk, nCMO
logical(kind=iwp) :: alpha_density
real(kind=wp), allocatable :: Aux(:,:)
real(kind=wp), external :: DDot_

!----------------------------------------------------------------------*
! Start                                                                *
!----------------------------------------------------------------------*
nCMO = size(CMO,1)
!call Timing(Cpu1,Tim1,Tim2,Tim3)

! Form proper MapDns vector

if (MapDns(iter) == 0) then   ! Position not defined

  ! Update MapDns and eventually write earlier Dens, TwoHam,
  ! and Vxc matrices to disk.

  if (iter <= nMem) then    ! keep the array in memory

    MapDns(iter) = iter

  else

    iFrom = MapDns(iter-nMem) ! get index of array to dump

    MapDns(iter) = iFrom      ! assign to new array

    if (iter-nMem == 1) then
      MapDns(iter-nMem) = -1 !  Initiate
    else
      MapDns(iter-nMem) = MapDns(iter-nMem-1)-1
    end if

    ! Dump the vectors

    iOnDsk = -MapDns(iter-nMem)
    call RWDTG(iOnDsk,Dens(1,1,iFrom),nBT*nD,'W','DENS  ',iDisk,size(iDisk,1))
    call RWDTG(iOnDsk,TwoHam(1,1,iFrom),nBT*nD,'W','TWOHAM',iDisk,size(iDisk,1))
    call RWDTG(iOnDsk,Vxc(1,1,iFrom),nBT*nD,'W','dVxcdR',iDisk,size(iDisk,1))
  end if

end if

! Check if MapDns is correct

iPsLst = MapDns(iter)
if (iPsLst <= 0) then
  write(u6,*) 'DMat: iPsLst <= 0'
  write(u6,*) 'iPsLst=',iPsLst
  call Abend()
end if

! Form i-th density matrix in the position iPsLst

if ((InVec == 3) .and. (iter == 1)) then

  ! First density matrix is actually in the first position
  ! (read from RUNFILE) on the first iteration.

else

  ! Using the CMOs generate the new density in position iPsLst

  alpha_density = .true.
  do iD=1,nD
    call DOne_SCF(nSym,nBas,nOrb,nFrz,CMO(1,iD),nCMO,OccNo(1,iD),Dens(1,iD,iPsLst),alpha_density)
    alpha_density = .false.
  end do ! iD
end if

do iD=1,nD
  call ChkTrD(nSym,nBas,nOrb,OccNo(:,iD),size(OccNo,1),Dens(:,iD,iPsLst),size(Dens,1))
end do ! iD

#ifdef _DEBUGPRINT_
call NrmClc(Dens(1,1,iPsLst),nBT*nD,'DMat  ','D Iter    ')
#endif

! Put the actual densities on the run file.

! Note, this is from where the DFT part of the DrvXV code gets the
! total density when it computes the DFT contributions to the
! total energy and the Fock matrix.

call DensAB(nBT,iPsLst,nD,Dens)

! Form density difference (normal or minimized). Notice, that
! for minimized differences i-th density is copied to position
! nDens and kept there till the end of iteration.
! For normal differences position nDens is occupied by the density
! of the previous iteration, until
! (i)  OptClc is called (DIIS-only case), or
! (ii) after Diis (QNR case)
! after that, the actual density is stored at that memory location

if (MiniDn .and. (max(0,nIter(nIterP)-1) > 0)) then

  ! Minimized density option

  Dens(:,:,nDens) = Dens(:,:,iPsLst)
  if (iter > 1) call MinDns(Dens,nBT,nDens,XCf,nXCf,nD)

else if (.not. DDnOFF) then

  ! Do the density difference, D(iPsLst)-D(nDens)=D(k+1)-D(k)

  call mma_allocate(Aux,nBT,nD,Label='Aux')
  Aux(:,:) = Dens(:,:,iPsLst)
  Dens(:,:,iPsLst) = Dens(:,:,iPsLst)-Dens(:,:,nDens)
  Dens(:,:,nDens) = Aux(:,:)
  call mma_deallocate(Aux)

else

  Dens(:,:,nDens) = Dens(:,:,iPsLst)

end if

DNorm = real(nD,kind=wp)*DDot_(nBT*nD,Dens(1,1,iPsLst),1,Dens(1,1,iPsLst),1)

#ifdef _DEBUGPRINT_
write(u6,*) 'DNorm=',DNorm
call NrmClc(Dens(1,1,iPsLst),nBT*nD,'DMat  ','D iPsLst  ')
call NrmClc(Dens(1,1,nDens),nBT*nD,'DMat  ','D nDens   ')
#endif

!call Timing(Cpu2,Tim1,Tim2,Tim3)
!TimFld(4) = TimFld(4)+(Cpu2-Cpu1)
!----------------------------------------------------------------------*
! Exit                                                                 *
!----------------------------------------------------------------------*
return

end subroutine DMat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ReadIn_ESPF(natom,ipCord,ipExt,MltOrd,iRMax,DeltaR,
     &                       Forces,Show_espf,ipIsMM,StandAlone,iGrdTyp,
     &                       DoTinker,DoGromacs,DynExtPot,ipMltp,natMM,
     &                       lMorok,DoDirect,ipGradCl,EnergyCl)
      use external_centers
      Implicit Real*8 (a-h,o-z)
*
#include "espf.fh"
#include "opt_mmo.fh"
#include "stdalloc.fh"
*
#include "print.fh"
      Character*180 Key,Line,PotFile,UpKey
      Character*10 ESPFKey
      Character*12 ExtPotFormat
      Logical Convert,DoTinker_old,DoTinker,DoGromacs_old,DoGromacs,
     &        Exist,Forces,Show_espf,StandAlone,DynExtPot,lMorok_old,
     &        lMorok,NoExt,DoDirect_old,DoDirect
      Save fift
      Data fift/1.5d1/
      Character*180 Get_Ln
      External Get_Ln
*
*
* If some keywords are not given, what are the defauts ?
* 3 cases:
*   1) ESPF.DATA does not exist:
*      MULT: MltOrd = 0 (monopole)
*      GRID: Type = PNT ; iRMax = 4 shells ; DeltaR = 1 angstrom
*      EXTE: MANDATORY
*   2) ESPF.DATA exists:
*      Get back all values from ESPF.DATA
*      a) If the keyword "Forces" is read, only the old values
*      are retained, so it is clever not to include any other
*      ESPF keyword
*      b) If the keyword "Forces" is not read, all the new values
*      are compared to the old ones.
*
*
* Initialize values
*
      Write(ExtPotFormat,'(a4,i2,a6)') '(I4,',MxExtPotComp,'F10.5)'
      MltOrd = 1
      MltOrd_old = MltOrd
      nChg = -1
      iGrdTyp = 1
      iRMax = 4
*      iGrdTyp = 2
*      iRMax = 1
      DeltaR = One/Angstrom
      Convert = .False.
      DoTinker = .False.
      DoTinker_old = DoTinker
      DoGromacs = .False.
      DoGromacs_old = DoGromacs
      Forces = .Not.StandAlone
      Show_espf = .False.
      nMult = 0
      DynExtPot = .False.
      iQMChg = 1
      natMM = 0
      lMorok = .False.
      lMorok_old = lMorok
      NoExt = .False.
      DoDirect = .False.
      DoDirect_old = DoDirect
      nOrd_ext = 0
      MMIterMax = 0
      ConvF = 2.0D-4*AuToKjPerMolNm
*
* Print level
*
      iPL = iPL_espf()
*
* If the ESPF.DATA file exists, retrieve all data
* from it in "*_old" variables and arrays.
*
      IPotFl=15
      PotFile='***'
      Call F_Inquire('ESPF.DATA',Exist)
      If (Exist) Then
         IPotFl = IsFreeUnit(IPotFl)
         Call Molcas_Open(IPotFl,'ESPF.DATA')
10       Line = Get_Ln(IPotFl)
         ESPFKey = Line(1:10)
         If (ESPFKey.eq.'MLTORD    ') Then
            Call Get_I1(2,MltOrd_old)
            ibla = 0
            Do ii = 0, MltOrd_old
               ibla = ibla + (ii+2)*(ii+1)/2
            End Do
            MltOrd_old = ibla
         Else If (ESPFKey.eq.'IRMAX     ') Then
            Call Get_I1(2,iRMax_old)
         Else If (ESPFKey.eq.'DELTAR    ') Then
            Call Get_F1(2,DeltaR_old)
         Else If (ESPFKey.eq.'GRIDTYPE  ') Then
            Call Get_I1(2,iGrdTyp_old)
         Else If (ESPFKey.eq.'MULTIPOLE ') Then
            Call Get_I1(2,nMult)
            Call GetMem('ESPFMltp','ALLO','REAL',ipMltp,nMult)
            Do iMlt = 1, nMult, MltOrd_old
               Line = Get_Ln(IPotFl)
               Call Get_I1(1,iAt)
               Call Get_F(2,Work(ipMltp+iMlt-1),MltOrd_old)
            End Do
         Else If (ESPFKey.eq.'TINKER    ') Then
            DoTinker_old = .True.
         Else if (ESPFKey.eq.'GROMACS   ') Then
            DoGromacs_old = .True.
         Else If (ESPFKey.eq.'DIRECT    ') Then
            DoDirect_old = .True.
         Else If (ESPFKey.eq.'LA_MOROK  ') Then
            lMorok_old = .True.
         Else If (ESPFKey.eq.'ENDOFESPF ') Then
            Goto 11
         EndIf
         Goto 10
11       Close (IPotFl)
         iRMax = iRMax_old
         DeltaR = DeltaR_old
         MltOrd = MltOrd_old
         iGrdTyp = iGrdTyp_old
         DoTinker = DoTinker_old
         DoGromacs = DoGromacs_old
         lMorok = lMorok_old
      EndIf
      If (.Not.StandAlone) Go To 1999
*
* Copy input from standard input to a local scratch file
*
      LuSpool = isFreeUnit(IPotFl)
      Call SpoolInp(LuSpool)
*
*---- Locate "start of input"
      Rewind(LuSpool)
      Call RdNLst(LuSpool,'espf')
*
  999 Continue
      Key = Get_Ln(LuSpool)
      Line = Key
      Call UpCase(Line)
      If (Line(1:4).eq.'MULT') GoTo 1000
      If (Line(1:4).eq.'EXTE') GoTo 1001
      If (Line(1:4).eq.'GRID') GoTo 1002
      If (Line(1:4).eq.'FORC') Goto 1003
      If (Line(1:4).eq.'SHOW') Goto 1004
      If (Line(1:4).eq.'LAMO') Goto 1005
      If (Line(1:4).eq.'MMIT') Goto 1006
      If (Line(1:4).eq.'MMCO') Goto 1007
      If (Line(1:4).eq.'END ') GoTo 1999
      If (.not.Exist) Then
         Write (6,*)' Unidentified keyword:', Key
         Call FindErrorLine
         Call Quit_OnUserError()
      EndIf
*
*>>>>>>>>>>>>> MULT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1000 Continue
      Key = Get_Ln(LuSpool)
      Call Get_I1(1,MltOrd)
      If (MltOrd.lt.0) Then
         Write(6,'(A)')' Error in espf/readin: MltOrd < 0!'
         Call Quit_OnUserError()
      End If
      If (DoGromacs.and.(MltOrd.gt.0)) Then
         Write(6,'(A)')' Error in espf/readin: Gromacs calculation'//
     &                 ' requested with MltOrd > 0'
         Write(6,'(A)')' Only MltOrd = 0 is currently allowed'
         Call Quit_OnUserError()
      End If
      If (MltOrd.gt.1) Then
         Write(6,'(A)')' Error in espf/readin: MltOrd > 1 NYI!'
         Call Quit_OnUserError()
      End If
      ibla = 0
      Do ii = 0, MltOrd
         ibla = ibla + (ii+2)*(ii+1)/2
      End Do
      MltOrd = ibla
      GoTo 999
*
*>>>>>>>>>>>>> EXTE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1001 Continue
      If (Forces) Goto 999
      Key = Get_Ln(LuSpool)
      UpKey = Key
      Call Upcase(UpKey)
      Call Get_iNumber(Key(1:(Index(Key,' ')-1)),ibla,iErr)
      If (iErr .eq. 0) Then
         PotFile='* *'
         nChg = ibla
*
* nChg < 0: error
* nChg > 0: external potential is given as point charges and dipoles,
* like for the seward xfield keyword
* nchg = 0: external potential directly given on atom centers as:
* pot field_x field_y field_z dfield_xx dfield_yy dfield_zz
* dfield_xy dfield_xz dfield_yz (ONE LINE per CENTER)
*
*
         If (nChg .lt. 0) Then
            Write(6,*) 'Error in readin_espf: nChg < 0!'
            Call Quit_OnUserError()
         Else If (nChg.gt.0) Then
            Convert = (Index(UpKey,'ANGSTROM').ne.0)
            nXF=nChg
            nData_XF=7
            call mma_allocate(XF,nData_XF,nXF,Label='XF')
            Do iChg = 1, nChg
               Key = Get_Ln(LuSpool)
               Call Get_F(1,XF(1,iChg),7)
               If (Convert) Then
                  XF(1:3,iChg) = XF(1:3,iChg)/Angstrom
                  XF(5:7,iChg) = XF(5:7,iChg)/Angstrom
               End If
            End Do
            ESelf = SelfEn(nChg)
            Convert = .False.
         Else
            Do iAt = 1, natom
               Key = Get_Ln(LuSpool)
               Call Get_I1(1,jAt)
               If ((jAt.lt.1).or.(jAt.gt.natom)) Then
                  Write(6,'(A)')
     &               ' Error in espf/readin: atom out of range.'
                  Call Quit_OnUserError()
               End If
               Call Get_F(2,Work(ipExt+(jAt-1)*MxExtPotComp),
     &                    MxExtPotComp)
            End Do
         End If
      Else
         iAt = Index(UpKey,'NONE ')
         NoExt = (iAt .ne. 0)
*
* Is it a QM/MM computation ?
*
         iAt = Index(UpKey,'TINKER ')
         DoTinker = (iAt .ne. 0)
*
         iAt = Index(UpKey,'GROMACS ')
         If (iAt .ne. 0) Then
#ifdef _GROMACS_
            DoGromacs = .True.
#else
            Write(6,*) 'Interface to Gromacs not installed'
            Call Quit_OnUserError()
#endif
         End If
*
         DoDirect = (Index(UpKey(iAt+7:120),'DIRECT').ne.0)
ctmp
         If (DoDirect) Then
           Write(6,*) 'Direct not yet implemented, abort.'
           Call Quit_OnUserError()
         End If
ctmp
*
* What kind of charges Tinker or Gromacs will use in the
* microiterations
*
         If (NoExt) Then
            PotFile = '* *'
         Else If (DoTinker.Or.DoGromacs) Then
            PotFile = 'ESPF.EXTPOT'
            If (Index(UpKey(iAt+7:120),'MULL').ne.0) Then
               iQMChg = 2
            Else If (Index(UpKey(iAt+7:120),'LOPR').ne.0) Then
               iQMChg = 3
            End If
            If (DoDirect .and. iQMChg .eq. 1) iQMChg = 2
         Else
            PotFile = Key(1:Len(Key))
         End If
      End If
      GoTo 999
*
*>>>>>>>>>>>>> GRID <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1002 Continue
      Key = Get_Ln(LuSpool)
      Call Upcase(Key)
      If (Index(Key,'GEPOL').ne.0) Then
         iGrdTyp = 2
         Call Get_I1(2,iRMax)
         If(iRMax.le.0 .or. iRMax.gt.4) Then
           Write(6,'(A)')'Error in readin_espf: 1 <= iRMax <= 4 !!!'
           Call Quit_OnUserError()
         End If
      Else If(Index(Key,'PNT').ne.0) Then
         iGrdTyp = 1
         Call Get_I1(2,iRMax)
         If(iRMax.le.0) Then
           Write(6,'(A)')'Error in espf/readin: iRMax < 1 !!!'
           Call Quit_OnUserError()
         End If
         Call Get_F1(3,DeltaR)
         If(DeltaR.le.Zero) Then
           Write(6,'(A)')'Error in espf/readin: DeltaR < 0.0 !!!'
           Call Quit_OnUserError()
         End If
         If (Index(Key,'ANGSTROM').ne.0) Convert=.True.
         If(Convert) DeltaR = DeltaR/Angstrom
         Convert = .False.
      Else
         Write(6,'(A)') 'Unrecognized GRID: GEPOL or PNT(default)'
         Call Quit_OnUserError()
      End If
      GoTo 999
*
*>>>>>>>>>>>>> FORC <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1003 Continue
      If (.not.Exist) Then
         Write(6,*)'Error! Forces: the ESPF data are missing'
         Call Quit_OnUserError()
      EndIf
      If (DoTinker) Then
         Write(6,*)'Please erase the @Tinker call together with Forces'
         Call Quit_OnUserError()
      EndIf
      Forces = .True.
      Write(6,'(/,A,/,A)')' This ESPF run will compute energy gradient',
     &  ' Any other keyword is ignored !'
*
* Here I assume all I need can be retrieved from the $Project.espf file
*
      GoTo 999
*
*>>>>>>>>>>>>> SHOW <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1004 Continue
      Show_espf = .True.
      GoTo 999
*
*>>>>>>>>>>>>> LAMO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1005 Continue
      lMorok = .True.
      If (iPL.ge.2) Write(6,'(A)') ' Morokuma scheme on'
      GoTo 999
*
*>>>>>>>>>>>>> MMIT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1006 Continue
      If (.Not.DoGromacs) Then
         Write(6,'(A)')
     &      ' MM microiterations only available with Gromacs'
         Call Quit_OnUserError()
      End If
      Line = Get_Ln(LuSpool)
      Call Get_I1(1,MMIterMax)
      GoTo 999
*
*>>>>>>>>>>>>> MMCO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1007 Continue
      Line = Get_Ln(LuSpool)
      Call Get_F1(1,ConvF)
      ConvF = ConvF*AuToKjPerMolNm
      GoTo 999
*
*>>>>>>>>>>>>> END  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 1999 Continue
*
* Remove local copy of standard input
*
      If (StandAlone) Close(LuSpool)
*
* "Forces" case: retrieve all the data and update the MM gradient
*
      If (Forces) Then
         MltOrd = MltOrd_old
         iRMax = iRMax_old
         DeltaR = DeltaR_old
         iGrdTyp =iGrdTyp_old
         DoTinker = DoTinker_old
         DoGromacs = DoGromacs_old
         iQMChg = 0
         If (DoTinker) Call RunTinker(natom,ipCord,ipMltp,ipIsMM,
     &               MltOrd,DynExtPot,iQMchg,natMM,StandAlone,DoDirect)
#ifdef _GROMACS_
         If (DoGromacs) Call RunGromacs(natom,Work(ipCord),ipMltp,
     &                                  MltOrd,Forces,ipGradCl,EnergyCl)
#endif
         If (nAtMM.ne.0) Write(6,*) 'MM gradients have been updated'
         lMorok = lMorok_old
         IPotFl = IsFreeUnit(IPotFl)
         Call Molcas_Open(IPotFl,'ESPF.EXTPOT')
         Line = Get_Ln(IPotFl)
         Call Get_I1(1,nChg)
         Do iAt = 1, natom
            Line = Get_Ln(IPotFl)
            Call Get_I1(1,jAt)
            Call Get_F(2,Work(ipExt+(jAt-1)*MxExtPotComp),MxExtPotComp)
         End Do
         Close(IPotFl)
*
* No external potential
*
      Else If (NoExt) Then
         nChg = -1
         Write(6,'(/,A)')' No external electrostatic potential'
*
* External potential read from a file
*
      Else If (nChg .eq. -1) Then
         If (DoTinker) Call RunTinker(natom,ipCord,ipMltp,ipIsMM,
     &                  MltOrd,DynExtPot,iQMChg,natMM,StandAlone,
     &                  DoDirect)
#ifdef _GROMACS_
         If (DoGromacs) Call RunGromacs(natom,Work(ipCord),ipMltp,
     &                                  MltOrd,Forces,ipGradCl,EnergyCl)
#endif
         LuSpool = IsFreeUnit(1)
         Call Molcas_Open (LuSpool,PotFile(1:(Index(PotFile,' ')-1)))
         If (iPL.ge.3) Write(6,'(/,A,A)')' External potential read in ',
     &                           PotFile(1:(Index(PotFile,' ')-1))
         Key = Get_Ln(LuSpool)
         UpKey = Key
         Call Upcase(UpKey)
         Call Get_I1(1,nChg)
         If (nChg .lt. 0) Then
            Write(6,*) 'Error in readin_espf: nChg < 0!'
            Call Quit_OnUserError()
         Else If (nChg.gt.0) Then
            Call Get_I1(2,nOrd_ext)
            Convert = (Index(UpKey,'ANGSTROM').ne.0)
            nData_XF=4+3*nOrd_ext
            nXF=nChg
            call mma_allocate(XF,nData_XF,nXF,Label='XF')
            Do iChg = 1, nChg
               Key = Get_Ln(LuSpool)
               Call Get_F(1,XF(1,iChg),iShift)
               If (Convert) Then
                  XF(1:3,iChg) = XF(1:3,iChg)/Angstrom
                  If (nOrd_ext .ne. 0) Then
                     XF(5:7,iChg) = XF(5:7,iChg)*Angstrom
                  End If
               End If
            End Do
            If (.not.(DoTinker.Or.DoGromacs)) ESelf = SelfEn(nChg)
            Convert = .False.
         Else
            Do iAt = 1, natom
               Key = Get_Ln(LuSpool)
               Call Get_I1(1,jAt)
               If ((jAt.lt.1).or.(jAt.gt.natom)) Then
                  Write(6,'(A)')
     &               ' Error in espf/readin: atom out of range.'
                  Call Quit_OnUserError()
               End If
               Call Get_F(2,Work(ipExt+(jAt-1)*MxExtPotComp),
     &                    MxExtPotComp)
            End Do
         End If
         Close(LuSpool)
      End If
*
* If nChg > 0, 2 possibilities:
* a) read external point charges (only, no dipoles) for a direct
*    QM/MM electrostatic coupling
* b) external potential calculated from point charges and dipoles
*
      If (nChg .gt. 0 .and. DoDirect) Then
         nXF = nChg
         nOrd_XF = nOrd_ext
         iXPolType = 0
         nXMolnr = 0
         Call mma_deallocate(XF)
      Else If (nChg .gt. 0) Then
         Do iAt = 1, natom
            Do iChg = 1, nChg
               dx = Work(ipCord+(iAt-1)*3  )-XF(1,iChg)
               dy = Work(ipCord+(iAt-1)*3+1)-XF(2,iChg)
               dz = Work(ipCord+(iAt-1)*3+2)-XF(3,iChg)
               qChg = XF(4,iChg)
               dpxChg = XF(5,iChg)
               dpyChg = XF(6,iChg)
               dpzChg = XF(7,iChg)
               rAtChg = sqrt(dx*dx+dy*dy+dz*dz)

               rAC2 = rAtChg * rAtChg
               rAC3 = rAtChg * rAC2
               rAC5 = rAC2 * rAC3
               rAC7 = rAC2 * rAC5
               iStart = ipExt+(iAt-1)*MxExtPotComp
*      Potential E
               Work(iStart) = Work(iStart)
     &                 + qChg/rAtChg
     &                 - (dpxChg*dx + dpyChg*dy + dpzChg*dz)/rAC3
*      Field F / x
               Work(iStart+1) = Work(iStart+1)
     &                 - qChg*dx/rAC3
     &                 + (dpxChg*(three*dx*dx-rAC2)
     &                  + dpyChg*(three*dx*dy)
     &                  + dpzChg*(three*dx*dz))/rAC5
*      Field F / y
               Work(iStart+2) = Work(iStart+2)
     &                 - qChg*dy/rAC3
     &                 + (dpxChg*(three*dy*dx)
     &                  + dpyChg*(three*dy*dy-rAC2)
     &                  + dpzChg*(three*dy*dz))/rAC5
*      Field F / z
               Work(iStart+3) = Work(iStart+3)
     &                 - qChg*dz/rAC3
     &                 + (dpxChg*(three*dz*dx)
     &                  + dpyChg*(three*dz*dy)
     &                  + dpzChg*(three*dz*dz-rAC2))/rAC5
*      Gradient G / xx
               Work(iStart+4) = Work(iStart+4)
     &                 + qChg*(three*dx*dx-rAC2)/rAC5
     &                 - (dpxChg*(fift*dx*dx*dx-rnine*dx*rAC2)
     &                  + dpyChg*(fift*dx*dx*dy-three*dy*rAC2)
     &                  + dpzChg*(fift*dx*dx*dz-three*dz*rAC2))/rAC7
*      Gradient G / yy
               Work(iStart+5) = Work(iStart+5)
     &                 + qChg*(three*dy*dy-rAC2)/rAC5
     &                 - (dpxChg*(fift*dy*dy*dx-three*dx*rAC2)
     &                  + dpyChg*(fift*dy*dy*dy-rnine*dy*rAC2)
     &                  + dpzChg*(fift*dy*dy*dz-three*dz*rAC2))/rAC7
*      Gradient G / zz
               Work(iStart+6) = Work(iStart+6)
     &                 + qChg*(three*dz*dz-rAC2)/rAC5
     &                 - (dpxChg*(fift*dz*dz*dx-three*dx*rAC2)
     &                  + dpyChg*(fift*dz*dz*dy-three*dy*rAC2)
     &                  + dpzChg*(fift*dz*dz*dz-rnine*dz*rAC2))/rAC7
*      Gradient G / xy
               Work(iStart+7) = Work(iStart+7)
     &                 + qChg*(three*dx*dy)/rAC5
     &                 - (dpxChg*(fift*dx*dy*dx-three*dx*rAC2)
     &                  + dpyChg*(fift*dx*dy*dy-three*dy*rAC2)
     &                  + dpzChg*(fift*dx*dy*dz))/rAC7
*      Gradient G / xz
               Work(iStart+8) = Work(iStart+8)
     &                 + qChg*(three*dx*dz)/rAC5
     &                 - (dpxChg*(fift*dx*dz*dx-three*dx*rAC2)
     &                  + dpyChg*(fift*dx*dz*dy)
     &                  + dpzChg*(fift*dx*dz*dz-three*dz*rAC2))/rAC7
*      Gradient G / yz
               Work(iStart+9) = Work(iStart+9)
     &                 + qChg*(three*dy*dz)/rAC5
     &                 - (dpxChg*(fift*dy*dz*dx)
     &                  + dpyChg*(fift*dy*dz*dy-three*dy*rAC2)
     &                  + dpzChg*(fift*dy*dz*dz-three*dz*rAC2))/rAC7
            End Do
         End Do
         Call mma_deallocate(XF)
      End If
*
* Check the compatibility between old and new keywords
*
      If (Exist) Then
         If (.not.Forces.and.
     &         ((MltOrd.ne.MltOrd_old).or.
     &          (iRMax.ne.iRMax_old).or.
     &          (iGrdTyp.ne.iGrdTyp_old).or.
     &          (lMorok.neqv.lMorok_old).or.
     &          (DoDirect.neqv.DoDirect_old).or.
     &          (Abs(DeltaR-DeltaR_old).gt.1.0d-6))) Then
            Write(6,*)'Conficts between some old and new ESPF keywords'
            Write(6,*)'      ',
     &       'MltOrd     iRMax    DeltaR    iGrdTyp   lMorok   DoDirect'
            Write(6,*)' OLD: ',MltOrd_old,iRMax_old,DeltaR_old,
     &                            iGrdTyp_old,lMorok_old,DoDirect_Old
            Write(6,*)' NEW: ',MltOrd,iRMax,DeltaR,iGrdTyp,lMorok,
     &                            DoDirect
            Write(6,'(A)')' Check these values or erase ESPF.DATA'
         End If
      Else
         If (PotFile(1:(Index(PotFile,' ')-1)).eq.'***') Then
            Write(6,*)'Error! The EXTE data are missing'
            Call Quit_OnUserError()
         EndIf
      End If
*
* Some output
*
      If (iPL.ge.2) Then
         If (DoDirect) Then
            Write(6,'(A)') ' DIRECT keyword found',
     &                  ' The ESPF scheme is switched off'
            Write(6,'(A,I5,A)')' External potential due to',
     &                                     nChg,' point charges'
         Else
            If (nChg.eq.0) Then
               Write(6,'(A)')' External potential:'
            Else if (nChg.gt.0) Then
               Write(6,'(A,I5,A)')' External potential due to',
     &                                     nChg,' point charges:'
            End If
            If (nChg.ge.0)
     &   Write(6,'(A)')' Atom     E         Fx        Fy        Fz   '//
     &      '     Gxx       Gyy       Gzz       Gxy       Gxz       Gyz'
         End If
      End If
*
* Write the external potential in ESPF.EXTPOT for later use
*
      IPotFl = IsFreeUnit(IPotFl)
      Call Molcas_Open(IPotFl,'ESPF.EXTPOT')
      Write(IPotFl,'(I1)') 0
      Do iAt = 1, natom
         If (.not.DoDirect .and. nChg.ge.0 .and. iPL.ge.2)
     &      Write(6,ExtPotFormat) iAt,
     &         (Work(ipExt+(iAt-1)*MxExtPotComp+j),j=0,MxExtPotComp-1)
         Write(IPotFl,ExtPotFormat) iAt,
     &         (Work(ipExt+(iAt-1)*MxExtPotComp+j),j=0,MxExtPotComp-1)
      End Do
      Close(IPotFl)
      Write (6,*)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
#ifndef _GROMACS_
* Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(ipGradCl)
         Call Unused_real(EnergyCl)
      End IF
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Jie J. Bao                                       *
************************************************************************
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Aug. 06, 2020, created this file.               *
* ****************************************************************
      subroutine CalcbXbP(bX,bP,FMO1t,FMO2t,R,H,nTri)
      use stdalloc, only : mma_allocate, mma_deallocate
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"


****** Output
       Real*8,DIMENSION((nRoots-1)*nRoots/2)::bX
       Real*8,DIMENSION(nConf1*nRoots)::bP
****** Input
       INTEGER nTri
       Real*8,DIMENSION(nRoots*nTri)::FMO1t
       Real*8,DIMENSION(nRoots*nacpr2)::FMO2t
       Real*8,DIMENSION(nRoots**2)::R,H
****** Auxiliaries
       Real*8,DIMENSION(:),Allocatable::LOK,CSFOK

       CALL mma_allocate(CSFOK,nRoots*nConf1)
       CALL mma_allocate(LOK,nRoots**2)
       CALL CalcOMat(CSFOK,LOK,FMO1t,FMO2t,nTri)
       CALL CalcbP(bP,CSFOK,LOK,R)
       CALL CalcbX(bX,LOK,R,H)
       CALL mma_deallocate(CSFOK)
       CALL mma_deallocate(LOK)
       return
       end subroutine
******************************************************

      Subroutine CalcbX(bX,LOK,R,H)
#include "stdalloc.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
****** Output
      Real*8,DIMENSION((nRoots-1)*nRoots/2)::bX
****** Input
      Real*8,DIMENSION(nRoots**2)::R,H
      Real*8,DIMENSION(nRoots**2)::LOK
***** Auxiliaries
      INTEGER I,K,L,M,N,IKL,IIM,IIN,IKOL,IIK,IIL
      Real*8 TempD

      CALL FZero(bX,(nRoots-1)*nRoots/2)
      I=irlxroot
      DO K=2,nRoots
       IIK=(I-1)*nRoots+K
      DO L=1,K-1
       IIL=IIK-K+L
       IKL=(K-2)*(K-1)/2+L
       IKOL=(L-1)*nRoots+K
       ILOK=(K-1)*nRoots+L
       bX(IKL)=R(IIK)**2*LOK(ILOK)-R(IIL)**2*LOK(IKOL)
       Do M=2,nRoots
        IIM=IIK-K+M
       Do N=1,M-1
        TempD=0.0d0
        IIN=IIK-K+N
        IF(M.eq.K) TempD=TempD+H((L-1)*nRoots+N)
        IF(N.eq.K) TempD=TempD+H((M-1)*nRoots+L)
        IF(M.eq.L) TempD=TempD-H((K-1)*nRoots+N)
        IF(N.eq.L) TempD=TempD-H((M-1)*nRoots+K)
        bX(IKL)=bX(IKL)+TempD*R(IIM)*R(IIN)
       End Do
       End Do
       bX(IKL)=bX(IKL)*2.0d0
      END DO
      END DO
      RETURN
      END SUBROUTINE
******************************************************


******************************************************
      subroutine CalcbP(bP,CSFOK,LOK,R)
      use ipPage, only: W
#include "stdalloc.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
***** Output
      Real*8,DIMENSION(nConf1*nRoots)::bP
***** Input
      Real*8,DIMENSION(nRoots*nConf1)::CSFOK
      Real*8,DIMENSION(nRoots**2)::LOK
      Real*8,DIMENSION(nRoots**2)::R
***** Kind quantities that help
      INTEGER I,L,K,iLoc1,iLoc2
      Real*8 tempd
      I=irlxroot
      DO K=1,nRoots
       iLoc1=(K-1)*nConf1+1
       CALL DCopy_(nConf1,CSFOK(iLoc1),1,bP(iLoc1),1)
       Do L=K,K
        tempd=-LOK((K-1)*nRoots+L)
        iLoc2=(L-1)*nConf1+1
        CALL dAXpY_(nConf1,tempd,W(ipci)%Vec(iLoc2),1,bP(iLoc1),1)
       End Do

       Do L=1, nRoots
        IF (L.eq.K) CyCle
        tempd=-LOK((K-1)*nRoots+L)
        iLoc2=(L-1)*nConf1+1
        CALL dAXpY_(nConf1,tempd,W(ipci)%Vec(iLoc2),1,bP(iLoc1),1)
       End Do
       CALL DScal_(nConf1,2.0d0*R((I-1)*nRoots+K)**2,
     & bP(iLoc1),1)
      END DO
      RETURN
      End Subroutine
******************************************************

******************************************************
      subroutine CalcOMat(CSFOK,LOK,FMO1t,FMO2t,nTri)
      use ipPage, only: W
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "crun_mclr.fh"

*******Output
      Real*8,DIMENSION(nRoots*nConf1)::CSFOK
      Real*8,DIMENSION(nRoots**2)::LOK
*******Input
      INTEGER nTri
      Real*8,DIMENSION(nRoots*nTri)::FMO1t
      Real*8,DIMENSION(nRoots*nacpr2)::FMO2t
*******A little help from
      Real*8,DIMENSION(1)::rdum
      Real*8,DIMENSION(:),Allocatable::FMO1
      INTEGER ILoc1,ILoc2,ILoc3,iOff,iS,jS,iB,jB,ji,ij,I,iK
      INTEGER ILoc4,iptmp,nConf3
*                                                                      *
************************************************************************
*                                                                      *
      Interface
       SubRoutine CISigma_sa(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,
     &                       Int2a,nInt2a,ipCI1,ipCI2, Have_2_el)
       Integer iispin, iCsym, iSSym
       Integer nInt1, nInt2s, nInt2a
       Real*8, Target:: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
       Integer ipCI1, ipCI2
       Logical Have_2_el
       End SubRoutine CISigma_sa
      End Interface
*                                                                      *
************************************************************************
*                                                                      *


      nConf3=nint(Max(xispsm(State_SYM,1),xispsm(State_SYM,1)))
      iptmp=ipGet(nconf3*nRoots)
      CALL FZero(CSFOK,nRoots*nConf1)
      CALL FZero(W(iptmp)%Vec,nRoots*nConf3)
      CALL mma_allocate(FMO1,nDens2)

      DO i=1,nRoots
       iK=I
       ILoc1=  (IK-1)*nTri
       ILoc2=1+(IK-1)*NACPR2
       ILoc3=1+(IK-1)*nConf1
       iOff=0
       Do iS=1,nSym
         jS=iS
         IF (NBAS(IS)*NBAS(JS).NE.0) THEN
          do iB=1,nBas(iS)
            do jB=1,iB
             ioff = ioff+1
             ji= ipMat(is,js)-1 +(iB-1)*nbas(iS)+jB
             FMO1(ji) = FMO1t(ioff+iLoc1)
             if (iB.ne.jB) then
              ij= ipMat(is,js)-1 +(jB-1)*nbas(iS)+iB
              FMO1(ij) = FMO1t(ioff+iLoc1)
             end if
            end do
          end do
         END IF
       End do
*       irc=ipin(ipCI)
       CALL CISigma_SA(0,State_Sym,State_Sym,FMO1,nDens2,
     & FMO2t(iLoc2),NACPR2,rdum,1,ipci,iptmp,.True.)
       CALL Daxpy_(nConf1,Real(nRoots,8),W(iptmp)%Vec(iLoc3),1,
     &                                          CSFOK(iLoc3),1)

       Do L=1,nRoots
        ILoc4=(L-1)*NConf1+1
        LOK((I-1)*nRoots+L)=ddot_(nConf1,CSFOK(iLoc3),1,
     &                             W(ipCI)%Vec(iLoc4),1)
       End Do
      END DO
      CALL mma_deallocate(FMO1)
      RETURN
      End Subroutine
******************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine creatci_cvb(inumber,xident_ci,iaddr,iform,fileid)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      logical debug
      data debug/.false./

      ident_ci=inumber
      xident_ci=dble(ident_ci)
      ident_ci=inumber
      iaddr_ci(ident_ci)=iaddr
      iform_ci(ident_ci)=iform
      fileid_ci(ident_ci)=fileid
      if(debug)then
        write(6,*)' Creating CI vector :',inumber
        write(6,*)' Address            :',iaddr
        write(6,*)' Format             :',iform
        write(6,*)' File identifier    :',fileid
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE WRT_CONF_LIST(ICONF,NCONF_FOR_OPEN,MAXOP,NCONF,NELEC)
*
* Write list of configurations, given in packed form
*
* Jeppe Olsen, November 2001
*
#include "implicit.fh"
*
      INTEGER ICONF(*), NCONF_FOR_OPEN(MAXOP+1)
*
      IB = 1
      DO IOPEN = 0, MAXOP
        NCONF_OP = NCONF_FOR_OPEN(IOPEN+1)
        IF(NCONF_OP.NE.0) THEN
          WRITE(6,*) ' Number of configurations with ', IOPEN,
     &               ' open orbitals is ', NCONF_OP
*
          NOCC_ORB = IOPEN + (NELEC-IOPEN)/2
          DO JCONF = 1, NCONF_OP
            CALL IWRTMA(ICONF(IB),1,NOCC_ORB,1,NOCC_ORB)
            IB = IB + NOCC_ORB
          END DO
        END IF
      END DO
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NCONF)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_2darray_sort

! Sorting module with a very simple O(N^2) insertion sort algorithm
! for integer 2-d arrays like (3,:) according to input key 1-3

use fmm_global_paras, only: INTK
implicit none
private
! Public procedures
public :: fmm_insertion_sort

contains

!-------------------------------------------------------------------------------

subroutine fmm_insertion_sort(arr,xyz)

  implicit none
  integer(INTK), intent(inout) :: arr(:,:)
  integer(INTK), intent(in)    :: xyz

  integer(INTK) :: tmp(3)
  integer(INTK) :: i, j

  iloop: do i=1,size(arr,2)
    tmp(:) = arr(:,i)
    do j=(i-1),1,-1
      if (arr(xyz,j) > tmp(xyz)) then
        arr(:,j+1) = arr(:,j)
      else
        arr(:,j+1) = tmp(:)
        cycle iloop
      end if
    end do
    arr(:,1) = tmp(:)
  end do iloop

end subroutine fmm_insertion_sort

!-------------------------------------------------------------------------------

end module fmm_2darray_sort

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Stefan Knecht                                    *
!***********************************************************************
  subroutine set_as_solver()

! module dependencies
  use active_space_solver_cfg
#ifdef _DMRG_
  use qcmaquis_interface_cfg
#endif

  implicit none
! ----------------------------------------------------------------------
  character(len=8)   :: is_solver
  character(len=2)   :: onoff
  integer            :: luspool
  character(len=180) :: line, line2, blank

  external           :: get_ln, isfreeunit
  character(len=180) :: get_ln
  integer            :: isfreeunit
! ----------------------------------------------------------------------


  luspool = 18
  luspool = isfreeunit(luspool)
  call spoolinp(luspool)

  rewind(luspool)
  call rdnlst(luspool,'DMRGSCF')
  blank=' '

  !> find line as_solver; next unblank line should be the active space solver
  do
    line = get_ln(luspool)
    call leftad(line)
    call upcase(line)

    if(line == blank) cycle

    if(line(1:4) == 'ACTI')then
      do
        line2 = get_ln(luspool)
        call leftad(line2)
        call upcase(line2)
        if(line2 /= blank)then
          is_solver(1:8) = line2(1:8)
          exit
        end if
      end do
      !exit
    end if
    if(line(1:4) == 'CIDE')then
      do
        line2 = get_ln(luspool)
        call leftad(line2)
        call upcase(line2)
        if(line2 /= blank)then
          onoff(1:2) = line2(1:2)
#ifdef _DMRG_
          if(onoff(1:2) == 'ON') dmrg_warmup%doCIDEAS  = .true.
#endif
          exit
        end if
      end do
      !exit
    end if
    if(line(1:4) == 'FIED')then
      do
        line2 = get_ln(luspool)
        call leftad(line2)
        call upcase(line2)
        if(line2 /= blank)then
          onoff(1:2) = line2(1:2)
#ifdef _DMRG_
          if(onoff(1:2) == 'ON') dmrg_warmup%doFIEDLER  = .true.
#endif
          exit
        end if
      end do
      !exit
    end if
    if(line(1:6) == 'END OF' .or. line(1:6) == 'DMRGSE' .or. line(1:6) == 'OOPTIM') exit

  end do


  !> set user-selected DMRG driver as active space solver
  call upcase(is_solver)

  select case(is_solver)

    !> QCMaquis
    case('QCMAQUIS')

      as_solver(1:8) = 'qcmaquis'

    !> BLOCK
    case('BLOCK')

      as_solver(1:8) = 'block   '

    !> CheMPS2
    case('CHEMPS2')

      as_solver(1:8) = 'chemps2 '

    case default
      write(6,*) 'unknown DMRG active space solver'
      call abend()
  end select

  write(6,'(/5x,a,a )') ' DMRGSCF: active space solver is set to ',as_solver(1:8)
  write(6,'( 5x,a,a/)') ' -------                                ','--------'

  if(as_solver(1:8) == 'qcmaquis') then
#ifdef _DMRG_
    doDMRG = .true.
#endif
  end if

  call Close_LuSpool(LuSpool)

  end subroutine set_as_solver
! ----------------------------------------------------------------------

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
SUBROUTINE CASPT2_UDLDET(PSI,F,NAO,NMO,CMO,ONEINT,TWOINT)
  ! Computes the CASPT2 second-order energy of the wavefunction PSI, provided
  ! that the full Fock matrix and necessary 1- and 2-el integrals are given.

  ! Uses UDL decomposition of the Fock matrix and transforms the RHS according
  ! to the upper and lower triangular blocks Q of U and L by means of the
  ! exponential operator exp(Q). This version uses a determinant basis directly
  ! instead of a parameter exansion of excitation cases.

  USE ISO_FORTRAN_ENV, ONLY: REAL64
  USE SECOND_QUANTIZATION
  USE WAVEFUNCTION
  USE DENSITY
  USE FOCKMATRIX
  USE ORBINT
  IMPLICIT NONE

  TYPE(WFN), INTENT(INOUT) :: PSI
  TYPE(FMAT), INTENT(INOUT) :: F
  INTEGER, INTENT(IN) :: NAO, NMO
  REAL(REAL64), INTENT(INOUT) :: ONEINT(NMO,NMO), TWOINT(NMO,NMO,NMO,NMO)
  REAL(REAL64), INTENT(INOUT) :: CMO(NAO,NMO)

  INTEGER :: NI, NA, NS
  INTEGER :: NACTEL, NTOTEL, MULT

  TYPE(WFN) :: PSI1, SGM, TAU, RHS
  REAL(REAL64), ALLOCATABLE :: D1(:,:), D2(:,:,:,:), FTOT(:,:)
  REAL(REAL64) :: FACT

  REAL(REAL64), ALLOCATABLE :: V0(:), X(:)
  REAL(REAL64), ALLOCATABLE :: H0(:,:), S0(:,:)
  REAL(REAL64) :: E0, E2
  INTEGER :: ISD, JSD, NSD

  INTEGER :: INFO

  INTEGER, ALLOCATABLE :: IPIV(:)

  INTEGER :: A, I, T, P, Q, R, S, IA, IB
  INTEGER, ALLOCATABLE :: ADET(:), BDET(:)
  INTEGER :: DETA, DETB, TMPA, TMPB
  INTEGER, ALLOCATABLE :: IDXA(:), IDXB(:)

  REAL(REAL64), EXTERNAL :: DDOT_

  ! get appropriate orbital space dimensions from the supplied Fock matrix
  NI=SIZE(F%II,1)
  NA=SIZE(F%AA,1)
  NS=SIZE(F%SS,1)

#ifdef _DEBUG_
  WRITE(*,'(1X,A,I6)') '#inactive  orbitals = ', NI
  WRITE(*,'(1X,A,I6)') '#active    orbitals = ', NA
  WRITE(*,'(1X,A,I6)') '#secondary orbitals = ', NS
  WRITE(*,'(1X,A,I6)') '#molecular orbitals = ', NMO
#endif

  ! some sanity checks
  IF (PSI%NORB.NE.NA) STOP 'CASPT2_AXB: PSI%NORB does not match #active orbitals'
  IF (NMO.NE.NI+NA+NS) STOP 'CASPT2_AXB: supplied total #orbitals does not compute'

  NACTEL=PSI%NEL
  NTOTEL=2*NI+NACTEL
  MULT=PSI%MULT

  ! reconstruct density matrices
  ALLOCATE(D1(NA,NA))
  ALLOCATE(D2(NA,NA,NA,NA))
  CALL D1_ANN(PSI,D1)
  CALL D2_ANN(PSI,D2)

  WRITE(*,*) 'Before inactive/active orbital rotation:'
  WRITE(*,*)
  CALL WFN_PRINT(PSI,0.0D0)
  CALL WFN_ENERGY(NI,NA,NS,D1,D2,ONEINT,TWOINT)

  ! copy Fock matrix and apply UDL decomposition after shifting by E0!
  E0 = -4.39765297778118
  DO I=1,NI
    F%II(I,I)=F%II(I,I)-E0/NTOTEL
  END DO
  DO T=1,NA
    F%AA(T,T)=F%AA(T,T)-E0/NTOTEL
  END DO
  DO A=1,NS
    F%SS(A,A)=F%SS(A,A)-E0/NTOTEL
  END DO

  CALL FMAT_UDL(F)
  WRITE(*,*) 'After UDL decomposition'
  CALL FMAT_PRINT(F)

  ! store diagonal in FTOT
  ALLOCATE(FTOT(NMO,NMO))
  FTOT=0.0D0
  DO I=1,NI
    FTOT(I,I)=F%DI(I)
  END DO
  DO T=1,NA
    FTOT(NI+T,NI+T)=F%DA(T)
  END DO
  DO A=1,NS
    FTOT(NI+NA+A,NI+NA+A)=F%DS(A)
  END DO

!#ifdef _DEBUG_
  DO P=1,NMO
    WRITE(*,'(1X,7(2X,F21.14))') FTOT(P,:)
  END DO
!#endif

  ! copy and transform the wavefunction accordingly
  CALL WFN_ORBROT(PSI,F%AA)
  CALL ORBINT_TRANSFORM(CMO,ONEINT,TWOINT,F%II,F%AA,F%SS)

  ! reconstruct density matrices
  CALL D1_ANN(PSI,D1)
  CALL D2_ANN(PSI,D2)

  WRITE(*,*) 'After inactive/active orbital rotation:'
  WRITE(*,*)
  CALL WFN_PRINT(PSI,0.0D0)
  CALL WFN_ENERGY(NI,NA,NS,D1,D2,ONEINT,TWOINT)

  ! first, set up PSI1 as a (sparse) full-CI wavefunction for which we will use
  ! projectors to handle the restriction of single-double replacement states
  CALL WFN_INIT(PSI1,NTOTEL,NMO,MULT)

  PSI1%COEF=0.0D0
  CALL WFN_COPY0(NI,PSI,PSI1)

#ifdef _DEBUG_
  WRITE(*,'(1X,A)') 'The 0th-order wavefunction in FCI space:'
  CALL WFN_PRINT(PSI1,1.0D-15)
#endif

  DEALLOCATE(D1)
  DEALLOCATE(D2)

  ! compute the CASSCF energy for the 0-th order wavefunction
  ALLOCATE(D1(NMO,NMO))
  ALLOCATE(D2(NMO,NMO,NMO,NMO))
  CALL D1_ANN(PSI1,D1)
  CALL D2_ANN(PSI1,D2)

  CALL WFN_ENERGY(0,NMO,0,D1,D2,ONEINT,TWOINT)

  CALL WFN_INIT(SGM,NTOTEL,NMO,MULT)
  CALL WFN_INIT(TAU,NTOTEL,NMO,MULT)
  CALL WFN_INIT(RHS,NTOTEL,NMO,MULT)

  ! set up the RHS -V0 with V0_i  = <i|Ĥ|0>

  ! First, compute the 0-th order energy and construct the right hand side
  ! vector -V0, which is computed for each |i> that is non-zero. This still
  ! leaves an overcomplete basis for the VSD space, but that is solved later by
  ! diagonalization of S0 and removal of any linear dependency before solving
  ! Ax=b.

  ! step 1: |TAU> = Ĥ|0>
  TAU%COEF=0.0D0
  SGM%COEF=0.0D0
  RHS%COEF=0.0D0

  DETB=LEX_INIT(PSI%NELB,PSI%NORB)
  DO IB=1,PSI%NDETB
    TMPB=ISHFT(DETB,NI)+(2**NI-1)
    DETA=LEX_INIT(PSI%NELA,PSI%NORB)
    DO IA=1,PSI%NDETA
      TMPA=ISHFT(DETA,NI)+(2**NI-1)

      FACT=PSI%COEF(IA,IB)
      DO P=1,NMO
        DO Q=1,NMO
          ! h_pq, g_pqrs for TAU
          CALL DET_EX1(FACT*ONEINT(P,Q),P,Q,TMPA,TMPB,TAU)
          DO R=1,NMO
            DO S=1,NMO
              CALL DET_EX2(FACT*0.5D0*TWOINT(P,Q,R,S),P,Q,R,S,TMPA,TMPB,TAU)
            END DO
          END DO
        END DO
      END DO

      DETA=LEX_NEXT(DETA)
    END DO
    DETB=LEX_NEXT(DETB)
  END DO

  ! project out the non-SD determinants from H|0>
  CALL WFN_PSD(NI,NA,NS,TAU,RHS)

#ifdef _DEBUG_
  WRITE(*,'(1X,A)') 'wavefunction Ĥ|0>'
  CALL WFN_PRINT(TAU,1.0D-6)
#endif

  ! construct PSI1 = Sum_i |i>, store valid indices in separate index tables
  PSI1%COEF=0.0D0
  SGM%COEF=1.0D0
  CALL WFN_PSD(NI,NA,NS,SGM,PSI1)

  NSD=0
  DO IB=1,PSI1%NDETB
    DO IA=1,PSI1%NDETA
      IF (PSI1%COEF(IA,IB).NE.0.0D0) NSD=NSD+1
    END DO
  END DO

  WRITE(*,'(A,I9)') '#SD determinants in Psi1 = ', NSD

  ! store indices and determinants of non-zero Psi1 contributions in separate
  ! arrays
  ALLOCATE(IDXA(NSD))
  ALLOCATE(IDXB(NSD))
  ALLOCATE(ADET(NSD))
  ALLOCATE(BDET(NSD))

  ISD=0
  TMPB=LEX_INIT(PSI1%NELB,PSI1%NORB)
  DO IB=1,PSI1%NDETB
    TMPA=LEX_INIT(PSI1%NELA,PSI1%NORB)
    DO IA=1,PSI1%NDETA
      IF (PSI1%COEF(IA,IB).NE.0.0D0) THEN
        ISD=ISD+1
        IDXA(ISD)=IA
        IDXB(ISD)=IB
        ADET(ISD)=TMPA
        BDET(ISD)=TMPB
      END IF
      TMPA=LEX_NEXT(TMPA)
    END DO
    TMPB=LEX_NEXT(TMPB)
  END DO

  ! step 2: construct V0, V0_i = <i|H|0>

  ALLOCATE(V0(NSD))

  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    V0(ISD)=RHS%COEF(IA,IB)
  END DO

  ALLOCATE(H0(NSD,NSD))
  ALLOCATE(S0(NSD,NSD))

  H0 = 0.0D0
  S0 = 0.0D0

  ! construct elements <i|H_0|j>
  DO JSD=1,NSD
    TMPA=ADET(JSD)
    TMPB=BDET(JSD)
    SGM%COEF=0.0D0
    DO I=1,NMO
      ! accumulate Sum_i F_ii Ê_ii |j>
      CALL DET_EX1(FTOT(I,I),I,I,TMPA,TMPB,SGM)
    END DO
    DO ISD=1,NSD
      IA=IDXA(ISD)
      IB=IDXB(ISD)
      H0(ISD,JSD)=SGM%COEF(IA,IB)
    END DO
  END DO

  ! set RHS to -<i|H|0>
  RHS%COEF(:,:)=-RHS%COEF

  ! series of deexcitation operators exp(-Q_IA) exp(-Q_AS) exp(-Q_IS)

  ! exp(-Q_IS) = 1 - Sum_IS Q_IS E_IS + 0.5 ...
  SGM%COEF=0.0D0
  DO A=1,NS
    DO I=1,NI
      CALL WFN_EX1(-F%IS(I,A),I,NI+NA+A,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO A=1,NS
    DO I=1,NI
      CALL WFN_EX1(-0.5D0*F%IS(I,A),I,NI+NA+A,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_AS) = 1 - Sum_AS Q_AS E_AS + ...
  SGM%COEF=0.0D0
  DO A=1,NS
    DO T=1,NA
      CALL WFN_EX1(-F%AS(T,A),NI+T,NI+NA+A,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO A=1,NS
    DO T=1,NA
      CALL WFN_EX1(-0.5D0*F%AS(T,A),NI+T,NI+NA+A,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_IA) = 1 - Sum_IA Q_IA E_IA + ...
  SGM%COEF=0.0D0
  DO T=1,NA
    DO I=1,NI
      CALL WFN_EX1(-F%IA(I,T),I,NI+T,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO T=1,NA
    DO I=1,NI
      CALL WFN_EX1(-0.5D0*F%IA(I,T),I,NI+T,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ALLOCATE(X(NSD))

  ! contract into X_i = <i|exp(-Q_IA)|RHS>
  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    X(ISD)=RHS%COEF(IA,IB)
  END DO

  ! diagonal resolvent step

  ! method 1: invert H0 and multiply

  !ALLOCATE(U0(NSD,NSD))
  !U0=H0

  !NWORK=NSD**2
  !ALLOCATE(WORK(NWORK))
  !ALLOCATE(EVAL(NSD))

  !call dsyev_('V','U',NSD,U0,NSD,EVAL,WORK,NWORK,INFO)
  !IF (INFO.NE.0) STOP 'CASPT2_UDL: diagonalization of S0 failed'

  !S0=0.0D0
  !DO ISD=1,NSD
  !  S0(ISD,ISD)=1/EVAL(ISD)
  !END DO
  !H0=MATMUL(MATMUL(U0,S0),TRANSPOSE(U0))
  !X=MATMUL(H0,X)

  ! method 2: solve linear system H0 C = X

  ALLOCATE(IPIV(NSD))
  call dgesv_(NSD,1,H0,NSD,IPIV,X,NSD,INFO)
  IF (INFO.NE.0) THEN
    WRITE(*,*) 'INFO = ', INFO
    STOP 'Failed to solve linear equation system'
  END IF

  ! Now, continue with the transformation steps for L

  ! compute new RHS = Sum_i X_i |i>
  RHS%COEF=0.0D0
  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    RHS%COEF(IA,IB)=X(ISD)
  END DO

  ! apply second series of operators exp(-Q_SI) exp(-Q_SA) exp(-Q_SI)

  ! exp(-Q_AI) = 1 - Sum_AI Q_AI E_AI
  SGM%COEF=0.0D0
  DO I=1,NI
    DO T=1,NA
      CALL WFN_EX1(-F%AI(T,I),NI+T,I,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO I=1,NI
    DO T=1,NA
      CALL WFN_EX1(-0.5D0*F%AI(T,I),NI+T,I,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_SA) = 1 - Sum_SA Q_SA E_SA + ...
  SGM%COEF=0.0D0
  DO T=1,NA
    DO A=1,NS
      CALL WFN_EX1(-F%SA(A,T),NI+NA+A,NI+T,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO T=1,NA
    DO A=1,NS
      CALL WFN_EX1(-0.5D0*F%SA(A,T),NI+NA+A,NI+T,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! exp(-Q_SI) = 1 - Sum_SI Q_SI E_SI + ...
  SGM%COEF=0.0D0
  DO I=1,NI
    DO A=1,NS
      CALL WFN_EX1(-F%SI(A,I),NI+NA+A,I,RHS,SGM)
    END DO
  END DO
  PSI1%COEF(:,:)=SGM%COEF
  DO I=1,NI
    DO A=1,NS
      CALL WFN_EX1(-0.5D0*F%SI(A,I),NI+NA+A,I,PSI1,SGM)
    END DO
  END DO
  RHS%COEF(:,:)=RHS%COEF+SGM%COEF

  ! contract into X_i = <i|exp(-Q_IA)|RHS> and
  ! transform to adapt for the overcomplete basis
  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    X(ISD)=RHS%COEF(IA,IB)
  END DO


  ! compute the energy

  ! method 1: E2 = <V0|X>
  E2 = DDOT_(NSD,V0,1,X,1)
  WRITE(*,'(1X,A32,F21.14)') 'E2 as <V0|X> = ', E2

  ! method 2: E2 = <0|Ĥ|Psi1>
  ! first, form the first-order wavefunction |Psi1>
  PSI1%COEF=0.0D0
  DO ISD=1,NSD
    IA=IDXA(ISD)
    IB=IDXB(ISD)
    PSI1%COEF(IA,IB)=X(ISD)
  END DO

  !WRITE(*,*) 'Final first-order wavefunction from UDL method:'
  !CALL WFN_PRINT(PSI1,1.0D-8)

  ! TAU still contains Ĥ|0>, so contract with |Psi1>
  E2 = DDOT_(PSI1%NDET,PSI1%COEF,1,TAU%COEF,1)
  WRITE(*,'(1X,A32,F21.14)') 'E2 as <Psi1|H|0> = ', E2

END SUBROUTINE CASPT2_UDLDET

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine prbar(ist,s1,s2,M)

use Constants, only: Three
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ist
character(len=5), intent(in) :: s1, s2
complex(kind=wp), intent(in) :: M(3)
character(len=40) :: f1, f2
character(len=30) :: fx, fy, fz
real(kind=wp) :: R

write(fx,'(i2,5a)') ist,'. | <',s1,' | mu_X |',s2,' > |'
write(fy,'(i2,5a)') ist,'. | <',s1,' | mu_Y |',s2,' > |'
write(fz,'(i2,5a)') ist,'. | <',s1,' | mu_Z |',s2,' > |'
R = (abs(M(1))+abs(M(2))+abs(M(3)))/Three

f1 = '(2x,a,2ES19.11,1x,A,      23x,A)'
f2 = '(2x,a,2ES19.11,1x,A,ES22.12,1x,A)'
write(u6,f1) fx,M(1),'|','|'
write(u6,f2) fy,M(2),'|',R,'|'
write(u6,f1) fz,M(3),'|','|'

return

end subroutine prbar

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Newq(q,nInter,nIter,dq,H,g,error,B,RHS,Scrt1,nScrt1,Beta,nFix,iP,Energy,Step_Trunc,Thr_RS)
!***********************************************************************
!                                                                      *
! Object: Driver for optimization procedures.                          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             December '94                                             *
!***********************************************************************

use Slapaf_Info, only: E_Delta, iOptC, Line_Search, UpMeth
use PrintLevel, only: nPrint
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nInter, nIter, nScrt1, nFix
real(kind=wp), intent(inout) :: q(nInter,nIter+1), dq(nInter,nIter), H(nInter,nInter), g(nInter,nIter)
real(kind=wp), intent(out) :: error(nInter,nIter+1), B((nIter+1)**2), RHS(nIter+1), Scrt1(nScrt1)
real(kind=wp), intent(in) :: Beta, Energy(nIter), Thr_RS
integer(kind=iwp), intent(out) :: iP(nIter)
character, intent(inout) :: Step_Trunc
integer(kind=iwp) :: iPrint, iRout, MinWdw
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ix
#endif
real(kind=wp) :: Beta_New
real(kind=wp), allocatable :: t_dq(:), t_g(:), t_q(:)
real(kind=wp), external :: DDot_

iRout = 113
iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
write(u6,*) ' Newq: nIter,Beta=',nIter,Beta
call RecPrt(' Newq (Enter): q',' ',q,nInter,nIter+1)
call RecPrt(' Newq (Enter): dq',' ',dq,nInter,nIter)
call RecPrt(' Newq (Enter): g',' ',g,nInter,nIter)
call DiagMtrx(H,nInter,ix)
#endif

E_Delta = Zero

! Perform first a linear search for the last two points
! to find minimum along the direction of the last step.

! The new point will temporarily replace the last point!

if (iPrint >= 6) write(u6,*)
if (Line_Search) then
  if (nIter >= 2) then
    call mma_allocate(t_q,nInter,Label='t_q')
    call mma_allocate(t_g,nInter,Label='t_g')
    call mma_allocate(t_dq,nInter,Label='t_dq')

    t_dq(:) = dq(:,nIter-1)
    t_q(:) = q(:,nIter)
    t_g(:) = g(:,nIter)

    call LnSrch(Energy,q,dq,g,nInter,nIter,E_Delta)
  else
    if (iPrint >= 6) write(u6,*) '-- First iteration no line search'
  end if
else
  if (iPrint >= 6) write(u6,*) '-- Line search is disabled'
end if
if (iPrint >= 6) write(u6,*)

! Invoke the quadratic optimization procedure

! iOptC=0001   : quasi Newton-Raphson
! iOptC=0010   : C1-DIIS
! iOptC=0100   : C2-DIIS
! iOptC=1000   : Rational Function

Scrt1(1:nInter) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
if (iOptC == 0) then

  ! No update of the geometry

  dq(:,:) = Zero
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if (btest(iOptC,0)) then

  ! quasi Newton-Raphson

  UpMeth = ' qNR  '
  call QNR(nInter,nIter,dq,H,g)
  Beta_New = sqrt(DDot_(nInter,dq(:,nIter),1,dq(:,nIter),1))
  if (Beta_New > Beta) then
    dq(:,nIter) = dq(:,nIter)*Beta/Beta_New
    Step_Trunc = '*'
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if (btest(iOptC,1)) then

  ! C1-DIIS

  UpMeth = 'c1DIIS'
  MinWdw = 5
  call C1DIIS(q,nInter,nIter,dq,H,g,error,B,RHS,nFix,iP,MinWdw)
  Beta_New = sqrt(DDot_(nInter,dq(:,nIter),1,dq(:,nIter),1))
  if (Beta_New > Beta) then
    dq(:,nIter) = dq(:,nIter)*Beta/Beta_New
    Step_Trunc = '*'
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if (btest(iOptC,2)) then

  ! C2-DIIS

  UpMeth = 'c2DIIS'
  call C2DIIS(q,nInter,nIter,dq,H,g,error,B,RHS,Scrt1,nScrt1,nFix,iP)
  Beta_New = sqrt(DDot_(nInter,dq(:,nIter),1,dq(:,nIter),1))
  if (Beta_New > Beta) then
    dq(:,nIter) = dq(:,nIter)*Beta/Beta_New
    Step_Trunc = '*'
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if (btest(iOptC,3)) then

  ! Rational Function Optimization (RFO)

  UpMeth = '  RF  '

  if (.not. btest(iOptC,7)) then

    ! TS optimization

    if (.not. btest(iOptC,9)) then

      ! Restricted Step Partitioned RFO

      call RS_P_RFO(H,g(:,nIter),nInter,dq(:,nIter),UpMeth,E_Delta,Beta,Step_Trunc)
    else

      ! Restricted Step Image RFO

      call RS_I_RFO(H,g(:,nIter),nInter,dq(:,nIter),UpMeth,E_Delta,Beta,Step_Trunc,Thr_RS)
    end if

  else

    ! Restricted Step RFO

    call RS_RFO(H,g(:,nIter),nInter,dq(:,nIter),UpMeth,E_Delta,Beta,Step_Trunc,Thr_RS)

  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  call WarningMessage(2,'Error in NewQ')
  write(u6,*) ' Newq: Illegal setting of iOptC!'
  write(u6,*) '  iOptC=',iOptC
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! In case of a line search restore some data and add the replacements.

if (Line_Search .and. (nIter >= 2)) then
# ifdef _DEBUGPRINT_
  call RecPrt(' Newq: q ',' ',q,nInter,nIter+1)
  call RecPrt(' Newq: dq',' ',dq,nInter,nIter)
  call RecPrt(' Newq: g ',' ',g,nInter,nIter)
# endif
  q(:,nIter+1) = q(:,nIter)+dq(:,nIter)
  q(:,nIter) = t_q(:)
  dq(:,nIter) = q(:,nIter+1)-q(:,nIter)

  dq(:,nIter-1) = t_dq(:)
  g(:,nIter) = t_g(:)
# ifdef _DEBUGPRINT_
  call RecPrt(' Newq: q ',' ',q,nInter,nIter+1)
  call RecPrt(' Newq: dq',' ',dq,nInter,nIter)
  call RecPrt(' Newq: g ',' ',g,nInter,nIter)
# endif

  call mma_deallocate(t_q)
  call mma_deallocate(t_g)
  call mma_deallocate(t_dq)
end if

! Estimate energy at the relaxed geometry

if (.not. btest(iOptC,3)) then

  ! g(r)

  Scrt1(1:nInter) = -g(:,nIter)

  ! 1/2 H(r) (r -r)
  !            0

  call dGeMV_('N',nInter,nInter,Half,H,nInter,dq(:,nIter),1,One,Scrt1,1)
  E_Delta = DDot_(nInter,Scrt1,1,dq(:,nIter),1)
end if

q(:,nIter+1) = q(:,nIter)+dq(:,nIter)

#ifdef _DEBUGPRINT_
write(u6,*) ' E_Delta=',E_Delta
call RecPrt('Newq (Exit): q',' ',q,nInter,nIter+1)
call RecPrt('Newq (Exit): dq',' ',dq,nInter,nIter)
call RecPrt('Newq (Exit): g',' ',g,nInter,nIter)
#endif

end subroutine Newq

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_ZMem(irc,l_Z,NVT,l_NVT,DoPrint,DoCheck)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: compute dimension of Z vector array and print it to
!          output (if requested through DoPrint). Check if there
!          is sufficient memory at this point (if DoCheck).
!
! Return codes:
!
! irc=-1 : Input error (debug only)
! irc=0  : All ok
! irc=1  : Negative length of Z vector array (could be integer
!          overflow)
! irc=999: Insufficient memory for Z vectors (only if DoCheck)

use Cholesky, only: LuPri, nSym
use stdalloc, only: mma_maxDBLE
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc, l_Z
integer(kind=iwp), intent(in) :: l_NVT, NVT(l_NVT)
logical(kind=iwp), intent(in) :: DoPrint, DoCheck
integer(kind=iwp) :: iSym, l_Mx
real(kind=wp) :: Byte, Word(8), xl_Z
character(len=2) :: Unt
#if ! defined (_I8_) || defined (_DEBUGPRINT_)
character(len=*), parameter :: SecNam = 'Cho_ZMem'
#endif

#ifdef _DEBUGPRINT_
if (l_NVT < nSym) then
  irc = -1
  l_Z = -999999
  return
end if
#endif

irc = 0

xl_Z = Zero
do iSym=1,nSym
  Word(iSym) = real(NVT(iSym),kind=wp)*(real(NVT(iSym),kind=wp)+One)*Half
  xl_Z = xl_Z+Word(iSym)
end do
l_Z = int(xl_Z)

if (DoPrint) then
  call Cho_Head('Z Vector Storage Requirements','-',80,LuPri)
  write(LuPri,*)
  do iSym=1,nSym
    call Cho_RWord2Byte(Word(iSym),Byte,Unt)
    write(LuPri,'(A,I2,A,I8,A,F8.3,1X,A,A)') 'Symmetry',iSym,':   ',int(Word(iSym)),' words (',Byte,Unt,')'
  end do
  write(LuPri,'(A)') '------------------------------------------'
  call Cho_RWord2Byte(xl_Z,Byte,Unt)
  write(LuPri,'(A,I8,A,F8.3,1X,A,A)') 'Total:        ',l_Z,' words (',Byte,Unt,')'
end if

#if ! defined (_I8_) || defined (_DEBUGPRINT_)
if (l_Z < 0) then
  write(Lupri,'(A,A)') SecNam,': dimension of Z vector array is negative!'
  write(Lupri,'(A,I8)') 'l_Z=',l_Z
  if (xl_Z > Zero) then
    write(LuPri,'(A)') 'This seems to be an integer overflow!'
    call Cho_RWord2Byte(xl_Z,Byte,Unt)
    write(LuPri,'(A,ES15.6,A,ES15.6,1X,A,A)') 'In double precision, xl_Z=',xl_Z,' words (',Byte,Unt,')'
  end if
  irc = 1
  return
end if
#endif

if (DoCheck) then
  call mma_maxDBLE(l_Mx)
  if (l_Z > l_Mx) then
    irc = 999
    return
  end if
end if

end subroutine Cho_ZMem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Input_Seward(lOPTO)
************************************************************************
*                                                                      *
*     Object: to read the input to the integral package.               *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*                                                                      *
*             January '91 additional input for property calculations.  *
*             October '93 split up to RdCtl and SoCtl.                 *
************************************************************************
      use Sizes_of_Seward, only: S
      use Basis_Info, only: nBas
      use Temporary_Parameters, only: Test, PrPrt, Primitive_Pass
      use Logical_Info, only: Do_GuessOrb
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "SysDef.fh"
#include "print.fh"
#include "stdalloc.fh"
      Parameter (nMamn=MaxBfn+MaxBfn_Aux)
      Character*(LENIN8), Allocatable :: Mamn(:)
      Logical Show_Save, lOPTO
      Logical Reduce_Prt
      External Reduce_Prt
      Save Show_Save
*                                                                      *
************************************************************************
*                                                                      *
      iRout=2
*                                                                      *
************************************************************************
*                                                                      *
      LuWr=6
*
      If (Primitive_Pass) Then
         Show_Save=Show
      Else ! .Not.Primitive
         Show=Show_Save
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*
*     Adjust the print level and some other parameters depending on
*     if we are iterating or not.
*
*     Set Show to false if Seward is run in property mode.
      Show=Show.and..Not.Prprt
*
      If ((Reduce_Prt().and.nPrint(iRout).lt.6).and..Not.Prprt) Then
         Show=.False.
         Do_GuessOrb=.False.
      End If
*
      Show=Show.and..Not.Primitive_Pass
      Show = Show .or. Test
*                                                                      *
************************************************************************
*                                                                      *
*     Modify storage of basis functions to be in accordance with a
*     calculation in the primitive or contracted basis.
*
      Call Flip_Flop(Primitive_Pass)
*                                                                      *
************************************************************************
*                                                                      *
*     Start of output, collect all output to this routine!
*
      If (Show) Call Output1_Seward(lOPTO)
*                                                                      *
************************************************************************
*                                                                      *
*-----Generate the SO or AO basis set
*
      Call mma_allocate(Mamn,nMamn,label='Mamn')
      Call SOCtl_Seward(Mamn,nMamn)
*                                                                      *
************************************************************************
*                                                                      *
      If (Test) Then
         Return
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Write information on the run file.
*
      If (Primitive_Pass) Then
         Call Put_iArray('nBas_Prim',nBas,nIrrep)
         Call Info2Runfile()
      End If
      Call Put_cArray('Unique Basis Names',Mamn(1),(LENIN8)*S%nDim)
      Call Put_iArray('nBas',nBas,nIrrep)
      Call mma_deallocate(Mamn)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine diisof (diispoint,ndiis)
c
c     this routine open 1-ndiis Temp files for DIIS procedure
c     and store lun's in stack (diispoint)
c
c     diispoint - stack of lun numbers (I)
c     ndiis     - size of diis procedure (I)
c
       integer ndiis
       integer diispoint(1:4)
c
c     help variables
c
       integer lun,rc
c
c
       if (ndiis.gt.0) then
       call filemanager (1,lun,rc)
       diispoint(1)=lun
       end if
c
       if (ndiis.gt.1) then
       call filemanager (1,lun,rc)
       diispoint(2)=lun
       end if
c
       if (ndiis.gt.2) then
       call filemanager (1,lun,rc)
       diispoint(3)=lun
       end if
c
       if (ndiis.gt.3) then
       call filemanager (1,lun,rc)
       diispoint(4)=lun
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ReaInd(iGP,iDT,iDistIm,iCNum,indma,ncparm,Sum1,s90um)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "WrkSpc.fh"

      Dimension iGP(3),iDT(3)

      Sum1=0
*      irekn=0
*      xled=0
*      yled=0
*      zled=0
      Do 901, i=1+(nPol*iCnum),indma
        Do 902, j=1,3  !The energy of the induced dipoles (iDT) in
                       !the field from the real charges. Yes, this
                       !is the polarization energy in a system
                       !without permanent dipoles, see good old
                       !Bottcher, eq. (3.129). Observe also that
                       !we here include effects of the reaction
                       !field on the induced dipoles, see the
                       !polarization loop.
          Sum1=Sum1+Work(iGP(j)+i-1)*Work(iDT(j)+i-1)
902     Continue
* IF WE WISH TO MONITOR THE INDUCED DIPOLES, UNCOMMENT THIS, AND THE
* COMMENTED THING ABOVE.
*        irekn=irekn+1
*        xled=xled+Work(iDt(1)+i-1)
*        yled=yled+Work(iDt(2)+i-1)
*        zled=zled+Work(iDt(3)+i-1)
*        if(irekn.eq.3) then
*          irekn=0
*          TOT=sqrt(xled**2+yled**2+zled**2)
*          write(6,*)'HHH',TOT
*          xled=0
*          yled=0
*          zled=0
*        endif
901   Continue
      Sum1=Sum1*0.5
      S90um=0
      Do 911, i=iCnum+1,nPart !Energy of charge distribution
        Do 912, j=1,nPol    !in the reaction field to
          Q1=Qimp((i-1)*nPol+j) !the induced dipoles.
          D1x=Dim((i-1)*nPol+j,1) !Once more, see Bottcher eq.
          D1y=Dim((i-1)*nPol+j,2) !(4.69): we are computing the
          D1z=Dim((i-1)*nPol+j,3) !product between charges and the
          x=CordIm((i-1)*nCent+j,1) !potential connected with the
          y=CordIm((i-1)*nCent+j,2)  !reaction field.
          z=CordIm((i-1)*nCent+j,3)
          Inc=ncparm*nCent*(i-(iCnum+1))+(j-1)*ncparm
          Do 913, l=nCent-nCha+1,nCent
            Inc2=Inc+l
            Q2=Qsta(l-nCent+nCha)
            Do 914, k=iCnum+1,nPart
              X1=(X-Cordst(l+(k-1)*nCent,1))*D1x
              X1=(Y-Cordst(l+(k-1)*nCent,2))*D1y+X1
              X1=(Z-Cordst(l+(k-1)*nCent,3))*D1z+X1
         !Change sign on Q2 since we are in the backwards land, while
         !Q1 and X1 already are backward.
         S90um=S90um-(Q1+X1*Work(iDistIm-1+inc2+(k-(iCnum+1))*nCent)**2)
     &        *Q2*Work(iDistIm-1+inc2+(k-(iCnum+1))*nCent)
914         Continue
913       Continue
912     Continue
911   Continue

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995, Roland Lindh                                *
!***********************************************************************

subroutine EFInt( &
#                define _CALLING_
#                include "int_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of electric field         *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, January '91                             *
!                                                                      *
! Modified for explicit code, R. Lindh, February '95.                  *
!***********************************************************************

use Index_Functions, only: nTri_Elem1, nTri3_Elem1
use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: i, iAnga(4), iComp, iDCRT(0:7), iElem, ij, iOffxx, iOffyy, iOffzz, ip, ip1, ip2, ip3, ipIn, iPrint, iRout, &
                     iStabO(0:7), jElem, kab, lab, labcd, lcd, lDCRT, llOper, LmbdT, mabMax, mabMin, mArr, mcdMax, mcdMin, nDCRT, &
                     nFLOP, nMem, nOp, nStabO, nT, nzab
real(kind=wp) :: CoorAC(3,2), Coori(3,4), RR, TC(3), XX, YY
logical(kind=iwp) :: NoSpecial
character(len=80) :: Label
real(kind=wp), parameter :: ThreeI = One/Three
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ
external :: Fake, TNAI, XCff2D, XRys2D

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(nHer)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 200
iPrint = nPrint(iRout)

rFinal(:,:,:,:) = Zero

iAnga(1) = la
iAnga(2) = lb
iAnga(3) = nOrdOp
iAnga(4) = 0
Coori(:,1) = A
Coori(:,2) = RB
mabMin = nTri3_Elem1(max(la,lb)-1)
mabMax = nTri3_Elem1(la+lb)-1
if (EQ(A,RB)) mabMin = nTri3_Elem1(la+lb-1)
mcdMin = nTri3_Elem1(nOrdOp-1)
mcdMax = nTri3_Elem1(nOrdop)-1
lab = (mabMax-mabMin+1)
kab = nTri_Elem1(la)*nTri_Elem1(lb)
lcd = (mcdMax-mcdMin+1)
labcd = lab*lcd

! Compute Flop's and size of work array which HRR will Use.

call mHRR(la,lb,nFLOP,nMem)

! Distribute the work array

ip2 = 1
ip1 = ip2+nZeta*max(labcd,lcd*nMem)
mArr = nArr-max(labcd,lcd*nMem)

! Find center to accumulate angular momentum on. (HRR)

if (la >= lb) then
  CoorAC(:,1) = A
else
  CoorAC(:,1) = RB
end if

llOper = lOper(1)
do iComp=2,nComp
  llOper = ior(llOper,lOper(iComp))
end do
call SOS(iStabO,nStabO,llOper)
call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

do lDCRT=0,nDCRT-1
  call OA(iDCRT(lDCRT),CCoor,TC)
  CoorAC(:,2) = TC
  Coori(:,3) = TC
  Coori(:,4) = TC

  ! Compute integrals with the Rys-Gauss quadrature.

  nT = nZeta
  NoSpecial = .true.
  call Rys(iAnga,nT,Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,rKappa,[One],Coori,Coori,CoorAC,mabMin,mabMax,mcdMin,mcdMax, &
           Array(ip1),mArr*nZeta,TNAI,Fake,XCff2D,XRys2D,NoSpecial)

  ! The integrals are now ordered as ijkl,e,f

  ! a) Change the order to f,ijkl,e
  ! b) Unfold e to ab, f,ijkl,ab
  ! c) Change the order back to ijkl,ab,f

  ! a)

  call DGetMO(Array(ip1),nZeta*lab,nZeta*lab,lcd,Array(ip2),lcd)

  ! b) Use the HRR to unfold e to ab

  call HRR(la,lb,A,RB,Array(ip2),lcd*nZeta,nMem,ipIn)
  ip3 = ip2-1+ipIn

  ! c)

  call DGetMO(Array(ip3),lcd,lcd,nZeta*kab,Array(ip1),nZeta*kab)

  ! Modify to traceless form, the sixth element contains r*r and

  if (nOrdOp == 2) then
    !if (.false.) then
    nzab = nZeta*kab
    iOffxx = ip1
    iOffyy = ip1+nzab*3
    iOffzz = ip1+nzab*5
    do i=0,nzab-1
      RR = Array(iOffxx+i)+Array(iOffyy+i)+Array(iOffzz+i)
      XX = Two*Array(iOffxx+i)-Array(iOffyy+i)-Array(iOffzz+i)
      YY = Two*Array(iOffyy+i)-Array(iOffxx+i)-Array(iOffzz+i)
      Array(iOffxx+i) = XX*ThreeI
      Array(iOffyy+i) = YY*ThreeI
      Array(iOffzz+i) = RR
    end do
  end if

  ! Stored as nZeta,iElem,jElem,iComp

  if (iPrint >= 49) then
    write(u6,*) ' In EFInt la,lb=',la,lb
    nzab = nZeta*kab
    do iElem=1,nTri_Elem1(la)
      do jElem=1,nTri_Elem1(lb)
        ij = (jElem-1)*nTri_Elem1(la)+iElem
        ip = ip1+nZeta*(ij-1)
        do iComp=1,nComp
          write(Label,'(A,I2,A,I2,A,I2,A)') ' rFinal (',iElem,',',jElem,',',iComp,') '
          call RecPrt(Label,' ',Array(ip),nZeta,1)
          ip = ip+nzab
        end do
      end do
    end do
  end if

  ! Accumulate contributions

  nOp = NrOpr(iDCRT(lDCRT))
  call SymAdO(Array(ip1),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,One)

end do

return

end subroutine EFInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Jeppe Olsen                                      *
!***********************************************************************

!#define_DEBUGPRINT_
subroutine ICISPC(MNRS10,MXRS30)
! Obtain internal CI spaces relevant for MRSDCI
!       /STRINP/+/LUCINP/ = > /CICISP/
! Jeppe Olsen, Dec 1990
!
! Input
! =====
! Information in STRINP
!
! Output
! ======
! Common block CICISP
!
! Internal CI spaces
!*******************************************************************
!   *  Basic space  * Allowed internal excit * Delta NA * Delta Nb *
!*******************************************************************
! 1 *  Zero order   *           0            *    0     *    0     *
!*******************************************************************
! ====================
!  Input Module
! ====================
!./Str_Info
!./MCLR_Data
! ====================
!  Output Module
! ====================
!module MCLR_Data
! NICISP : Number of internal CI spaces constructed
! IASTFI : Alpha string type for internal CI space
! IBSTFI : Beta string type for internal CI space
! IACTI  : Given internal space is active
! MXR3IC : Max number of elecs in RAS 3 space for internal CI space
! MNR1IC : Min number of elecs in RAS 1 space for internal CI space
! IZCI   : Internal zero order space
! NELCI : Number of electrons per CI space
! obtained by (IEX-1) fold internal excitation, with a NAEL + DELTAA
! alpha electrons and  NBEL + DELTAB beta electrons

use Str_Info, only: IAZTP, IBZTP, NELEC
use MCLR_Data, only: IACTI, IASTFI, IBSTFI, MNR1IC, MNR3IC, MXR1IC, MXR3IC, NAELCI, NBELCI, NELCI, NICISP, NORB1, NORB2
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: MNRS10, MXRS30
integer(kind=iwp) :: ICI

ICI = 1
MNR1IC(ICI) = MNRS10
MXR3IC(ICI) = MXRS30
IASTFI(ICI) = IAZTP
IBSTFI(ICI) = IBZTP
NAELCI(ICI) = NELEC(IAZTP)
NBELCI(ICI) = NELEC(IBZTP)
NELCI(ICI) = NAELCI(ICI)+NBELCI(ICI)
IACTI(1) = 1
NICISP = ICI
! Number and distribution of electrons in each space
!do IEX=1,3
!  do IDA=-4,2
!    do IDB=-4,2
!      if (IRCI(IEX,IDA+5,IDB+5) /= 0) then
!        ICI = IRCI(IEX,IDA+5,IDB+5)
!        NAELCI(ICI) = NELEC(IASTFI(ICI))
!        NBELCI(ICI) = NELEC(IBSTFI(ICI))
!        NELCI(ICI) = NAELCI(ICI)+NBELCI(ICI)
!      end if
!    end do
!  end do
!end do

! Default max in RAS1 and min in RAS3
MXR1IC(1:NICISP) = min(2*NORB1,NELCI(1:NICISP))
MNR3IC(1:NICISP) = max(0,NELCI(1:NICISP)-2*(NORB1+NORB2))

#ifdef _DEBUGPRINT_
write(u6,*) ' Number of internal CI spaces ',NICISP
write(u6,*) ' Space a-type b-type nael nbel mnrs1 mxrs1 mnrs3 mxrs3'
write(u6,*) ' ====================================================='
do ICI=1,NICISP
  if (IACTI(ICI) == 1) &
    write(u6,'(I5,2I7,2I5,4I6)') ICI,IASTFI(ICI),IBSTFI(ICI),NAELCI(ICI),NBELCI(ICI),MNR1IC(ICI),MXR1IC(ICI),MNR3IC(ICI),MXR3IC(ICI)
end do
#endif

return

end subroutine ICISPC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHO_LK_SCF(rc,nDen,ipFLT,ipKLT,nForb,nIorb,
     &                         ipPorb,ipPLT,FactXI,nSCReen,dmpk,dFmat)

**********************************************************************
*  Author : F. Aquilante
*
C *************** INACTIVE AO-BASIS FOCK MATRIX **********************
C
C   F(ab) = sum_J  Lab,J * V(J)  -  sum_Jk  Lka,J * Lkb,J
C
C   Exchange term computed using the Local-exchange (LK) algorithm
C
**********************************************************************
C
C      V(J) = sum_gd  Lgd,J * Ptot(gd)
C
C      a,b,g,d:  AO-index
C      k:        MO-index   belonging to (Frozen+Inactive)
C
**********************************************************************

      Implicit Real*8 (a-h,o-z)

      Integer   rc,nDen
      Integer   ipOrb(8,2),nOrb(8,2)
      Integer   ISTLT(8),ISTSQ(8),ISSQ(8,8),kOff(8,2)
      Real*8    tread(2),tcoul(2),texch(2)
      Real*8    tscrn(2),tmotr(2)
      Real*8    FactCI,FactXI,dmpk,dFmat,tau(2),xtau(2),thrv(2)
      Integer   ipPLT(nDen),ipFLT(nDen),ipKLT(nDen)
      Integer   ipPorb(nDen), ipDIAH(1)
      Integer   nForb(8,nDen),nIorb(8,nDen)
      Logical   Debug,timings,DoRead,DoScreen
      Logical   Estimate,Update
      Character*50 CFmt
      Character*10 SECNAM
      Parameter (SECNAM = 'CHO_LK_SCF')
      COMMON    /CHOTIME /timings
      COMMON    /CHOSCREEN/ Estimate,Update

      parameter (zero = 0.0D0, one = 1.0D0, xone = -1.0D0)
      parameter (FactCI = one)

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
#if defined (_MOLCAS_MPP_)
#include "para_info.fh"
#endif
#include "warnings.fh"
      parameter ( N2 = InfVec_N2 )
      Logical add
      Character*6 mode
      Integer  Cho_F2SP
      External Cho_F2SP

      Real*8 LKThr
      Real*8   Cho_LK_ScreeningThreshold
      External Cho_LK_ScreeningThreshold
      Integer  Cho_LK_MaxVecPerBatch
      External Cho_LK_MaxVecPerBatch

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
******
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
******
      NBASSH(I,J)=IWORK(ip_NBASSH-1+NSYM*(J-1)+I)
******
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
******
      nnBfShp(j,i) = iWork(ip_nnBfShp-1+nnShl_tot*(i-1)+j)
******
      ipLab(i) = iWork(ip_Lab+i-1)
******
      kOffSh(i,j) = iWork(ip_kOffSh+nShell*(j-1)+i-1)
******
      iShp_rs(i) = iWork(ip_iShp_rs+i-1)
******
      SvShp(i) = Work(ip_SvShp+i-1)
****** next is a trick to save memory. Memory in "location 2" is used
******      to store this offset array defined later on
      iOffShp(i,j) = iWork(ip_iiBstRSh+nSym*nnShl-1+nSym*(j-1)+i)
************************************************************************

#ifdef _DEBUGPRINT_
c      Debug=.true.
      Debug=.false.! to avoid double printing in SCF-debug
#else
      Debug=.false.
#endif



      DoRead  = .false.

      IREDC= -1  ! unknwn reduced set

      iLoc = 3 ! use scratch location in reduced index arrays

      If (nDen.ne.1 .and. nDen.ne.2) then
         write(6,*)SECNAM//'Invalid parameter nDen= ',nDen
         call abend()
      EndIf


        CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        do i=1,2            ! 1 --> CPU   2 --> Wall
           tread(i) = zero  !time read/transform vectors
           tcoul(i) = zero  !time for computing Coulomb
           texch(i) = zero  !time for computing Exchange
           tmotr(i) = zero  !time for the half-transf of vectors
           tscrn(i) = zero  !time for screening overhead
        end do

C ==================================================================

c --- Various offsets
c --------------------
        MaxB=nBas(1)
        ISTLT(1)=0
        ISTSQ(1)=0
      DO ISYM=2,NSYM
        MaxB=Max(MaxB,nBas(iSym))
        NBB=NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
        NBQ=NBAS(ISYM-1)**2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NBB ! Inactive D and F matrices
        ISTSQ(ISYM)=ISTSQ(ISYM-1)+NBQ ! Diagonal integrals in full
      END DO

      nnBSQ=0
      DO LSYM=1,NSYM
         DO KSYM=LSYM,NSYM
            ISSQ(KSYM,LSYM) = nnBSQ
            ISSQ(LSYM,KSYM) = nnBSQ ! symmetrization
            nnBSQ = nnBSQ + nBas(kSym)*nBas(lSym)
         END DO
      END DO

**************************************************
      nnO=0
      nT1=0
      DO jDen=1,nDen

         DO ISYM=1,NSYM

            ipOrb(iSym,jDen) = ipPorb(jDen) + ISTSQ(iSym)

            nOrb(iSym,jDen)  = nForb(iSym,jDen)+nIorb(iSym,jDen)

            kOff(iSym,jDen) = nnO

            nnO = nnO + nOrb(iSym,jDen)

         END DO

         nT1 = nT1 + nnO*(2-jDen) ! tot # alpha orbitals

      END DO

      nT2 = nnO - nT1

C --- Define max number of vectors to be treated in core at once

      MaxVecPerBatch=Cho_LK_MaxVecPerBatch()

C --- Define the basic screening threshold

      LKThr=Cho_LK_ScreeningThreshold(dFmat)

C --- Adjust the damping according to the Abs(Max offDiag FMOmat)
Ctbp, may 2013: adjustment moved to Cho_LK_ScreeningThreshold
      fcorr = dmpk
Ctbp  If (dFmat.gt.zero ) Then
Ctbp     If ( dFmat.lt.1.0d3*LKThr ) Then
Ctbp        fcorr=dmpk*1.0d-2
Ctbp     EndIf
Ctbp     If (dFmat.le.LKThr) fcorr=fcorr*1.0d-2
Ctbp  EndIf

      tau(1) = (LKThr/Max(1,nT1))*fcorr ! screening alpha Fock matrix
      tau(2) = (LKThr/Max(1,nT2))*fcorr ! screening beta Fock matrix

      MaxRedT=MaxRed
      Call GAIGOP_SCAL(MaxRedT,'+')
      If (Estimate) Then
         Do i=1,nDen
            tau(i)=tau(i)/MaxRedT
         End Do
      EndIf

      xtau(1) = sqrt(tau(1))
      xtau(2) = sqrt(tau(2))

C --- Vector MO transformation screening thresholds
      NumVT=NumChT
      Call GAIGOP_SCAL(NumVT,'+')
      thrv(1) = ( sqrt(LKThr/(Max(1,nT1)*NumVT)) )*fcorr
      thrv(2) = ( sqrt(LKThr/(Max(1,nT2)*NumVT)) )*fcorr

      CALL GETMEM('diagI','Allo','Real',ipDIAG,NNBSTRT(1))

#if defined (_MOLCAS_MPP_)
      If (nProcs.gt.1 .and. Update .and. Is_Real_Par()) Then
         NNBSTMX=0
         Do i=1,nSym
            NNBSTMX = Max(NNBSTMX,NNBSTR(i,1))
         End Do
         CALL GETMEM('diagJ','Allo','Real',ipjDIAG,NNBSTMX)
         Call FZero(Work(ipjDIAG),NNBSTMX)
      EndIf
#endif

C *************** Read the diagonal integrals (stored as 1st red set)
      If (Update) CALL CHO_IODIAG(Work(ipDIAG),2) ! 2 means "read"

c --- allocate memory for sqrt(D(a,b)) stored in full (squared) dim
      CALL GETMEM('diahI','Allo','Real',ipDIAH(1),NNBSQ)
      CALL FZERO(Work(ipDIAH(1)),NNBSQ)

c --- allocate memory for the abs(C(l)[k])
      Call GetMem('absc','Allo','Real',ipAbs,MaxB)

c --- allocate memory for the Y(l)[k] vectors
      Call GetMem('yc','Allo','Real',ipY,MaxB*nnO)

c --- allocate memory for the ML[k] list of largest elements
c --- in significant shells
      Call GetMem('MLk','Allo','Real',ipML,nShell*nnO)

c --- allocate memory for the list of  S:= sum_l abs(C(l)[k])
c --- for each shell
      Call GetMem('SKsh','Allo','Real',ipSKsh,nShell*nnO)

c --- allocate memory for the Index array
      Call GetMem('Indx','Allo','Inte',ipIndx,(nShell+1)*nnO)

c --- allocate memory for ipLab
      Call GetMem('ip_Lab','Allo','Inte',ip_Lab,nShell)

c --- allocate memory for kOffSh
      Call GetMem('ip_kOffSh','Allo','Inte',ip_kOffSh,nShell*nSym)

c --- allocate memory for nnBfShp
      Call GetMem('ip_nnBfShp','Allo','Inte',ip_nnBfShp,nnShl_tot*nSym)

c --- allocate memory for iShp_rs
      Call GetMem('ip_iShp_rs','Allo','Inte',ip_iShp_rs,nnShl_tot)

c --- allocate memory for the shell-pair Frobenius norm of the vectors
      Call GetMem('ip_SvShp','Allo','Real',ip_SvShp,2*nnShl)

C *** Compute Shell Offsets ( MOs and transformed vectors)

      MxBasSh = 0

      Do iSyma=1,nSym

         LKsh=0

         Do iaSh=1,nShell    ! kOffSh(iSh,iSym)

            iWork(ip_kOffSh+nShell*(iSyma-1)+iaSh-1) = LKsh

            LKsh = LKsh + nBasSh(iSyma,iaSh)

            MxBasSh = Max(MxBasSh,nBasSh(iSyma,iaSh))

         End Do

      End Do

c --- allocate memory for the Diagonal of the Fock matrix
      Call GetMem('F(k)ss','Allo','Real',ipFk,MxBasSh+nShell)
      Call FZero(Work(ipFk),MxBasSh+nShell)

C *** Determine S:= sum_l C(l)[k]^2  in each shell of C(a,k)
      Do jDen=1,nDen
         Do kSym=1,nSym
            Do jK=1,nOrb(kSym,jDen)

               ipMO = ipOrb(kSym,jDen)
     &              + nBas(kSym)*(jK-1)

               ipSk = ipSKsh + nShell*(kOff(kSym,jDen) + jK - 1)

               Do iaSh=1,nShell

                  ipMsh = ipMO + kOffSh(iaSh,kSym)

                  SKsh=zero
                  Do ik=0,nBasSh(kSym,iaSh)-1
                     SKsh = SKsh + Work(ipMsh+ik)**2
                  End Do

                  Work(ipSk+iaSh-1) = SKsh

               End Do

            End Do
         End Do
      End Do

C *** Compute Shell-pair Offsets in the K-matrix

         Do iSyma=1,nSym

            LKshp=0

            Do iaSh=1,nShell

             Do ibSh=1,iaSh

               iShp = iaSh*(iaSh-1)/2 + ibSh

               iWork(ip_nnBfShp - 1 + nnShl_tot*(iSyma-1)
     &        + iShp) = LKShp   ! nnBfShp(iShp,iSyma)

               LKShp = LKShp + nBasSh(iSyma,iaSh)*nBasSh(iSyma,ibSh)
     &                       - (1-Min((iaSh-ibSh),1))*nBasSh(iSyma,iaSh)
     &                       * (nBasSh(iSyma,iaSh) - 1)/2

             End Do

            End Do

         End Do

C *** Mapping shell pairs from the full to the reduced set

      Do iaSh=1,nShell
         Do ibSh=1,iaSh
            iShp = iaSh*(iaSh-1)/2 + ibSh
            iWork(ip_iShp_rs+iShp-1) = Cho_F2SP(iShp)
         End Do
      End Do


C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
      DO jSym=1,nSym

         NumCV=NumCho(jSym)
         Call GAIGOP_SCAL(NumCV,'max')
         If (NumCV .lt. 1) GOTO 1000

C *** Compute Shell pair Offsets   iOffShp(iSyma,iShp)

         LFULL=0

         Do iaSh=1,nShell

          Do ibSh=1,iaSh

           iShp = iaSh*(iaSh-1)/2 + ibSh

           If (iShp_rs(iShp).gt.0) Then

            If (nnBstRSh(Jsym,iShp_rs(iShp),1).gt.0) Then

             Do iSymb=1,nSym

              iSyma=MulD2h(iSymb,Jsym)

              If (iSyma.ge.iSymb) Then

               iWork(ip_iiBstRSh + nSym*nnShl - 1
     &         + nSym*(iShp_rs(iShp)-1) + iSyma) = LFULL

                 LFULL = LFULL + nBasSh(iSyma,iaSh)*nBasSh(iSymb,ibSh)
     &        + Min(1,(iaSh-ibSh))*nBasSh(iSyma,ibSh)*nBasSh(iSymb,iaSh)

              EndIf

             End Do

            EndIf

           EndIf

          End Do

         End Do

C ****************     MEMORY MANAGEMENT SECTION    *****************
C ------------------------------------------------------------------
C --- compute memory needed to store at least 1 vector of JSYM
C --- half-transformed for a given MO-index k  --> La,[k]
C ------------------------------------------------------------------
         mTvec = 0  ! mem for storing the half-transformed vec

         do l=1,nSym
            k=Muld2h(l,JSYM)
            Mmax = 0
            do jDen=1,nDen
               Mmax = Max(Mmax,nForb(k,jDen)+nIorb(k,jDen))
            end do
            if (Mmax.gt.0) mTvec = Max(mTvec,nBas(l))
         end do

         mTvec=Max(mTvec,1)

C ------------------------------------------------------------------
C ------------------------------------------------------------------

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec
         myJRED1=JRED1 ! first red set present on this node

c --- entire red sets range for parallel run
         Call GAIGOP_SCAL(JRED1,'min')
         Call GAIGOP_SCAL(JRED2,'max')

         ntv0=0
         kscreen=1
         DoScreen=.true.

         Do JRED=JRED1,JRED2

            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               call Abend
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED)
c           !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.',
     &                        '   rc= ',irc
              call Abend
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            If(JSYM.eq.1)Then

               Call GetMem('rsPtot','Allo','Real',ipPab,nRS)
               Call GetMem('rsFC','Allo','Real',ipFab,nRS)
               Call Fzero(Work(ipPab),nRS)
               Call Fzero(Work(ipFab),nRS)

            EndIf

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec = min(LWORK/(nRS+mTvec+LFULL),min(nVrs,MaxVecPerBatch))

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) ' LWORK= ',LWORK
               WRITE(6,*) ' jsym= ',jsym
               WRITE(6,*) ' min. mem. need= ',nRS+mTvec+LFULL
               WRITE(6,*) ' nRS = ',nRS
               WRITE(6,*) ' mTvec = ',mTvec
               WRITE(6,*) ' LFULL = ',LFULL
               CALL Quit(_RC_MEMORY_ERROR_)
               nBatch = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
            Call GetMem('ChoT','Allo','Real',ipChoT,mTvec*nVec)
            CALL GETMEM('FullV','Allo','Real',ipLF,LFULL*nVec)

            If(JSYM.eq.1)Then
C --- Transform the density to reduced storage
               mode = 'toreds'
               add  = .false.
               nMat=1
               Call play_sto(irc,iLoc,nMat,JSYM,ISTLT,ISSQ,
     &                           ipPLT,ipPab,mode,add)
            EndIf

C --- BATCH over the vectors ----------------------------

            nBatch = (nVrs-1)/nVec + 1

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM ) then
                  rc=77
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

               If(JSYM.eq.1)Then
C ************ (alpha+beta) COULOMB CONTRIBUTION  ****************
C
C --- Contraction with the density matrix
C ---------------------------------------
C --- V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * P(rs)
C==========================================================
C
                  CALL CWTIME(TCC1,TWC1)

                  ipVJ = ipChoT

                  CALL DGEMV_('T',nRS,JNUM,
     &                       ONE,Work(ipLrs),nRS,
     &                       Work(ipPab),1,ZERO,Work(ipVJ),1)

C --- FI(rs){#J} <- FI(rs){#J} + FactCI * sum_J L(rs,{#J})*V{#J}
C===============================================================

                  Fact = dble(min(jVec-iVrs,1))

                  CALL DGEMV_('N',nRS,JNUM,
     &                       FactCI,Work(ipLrs),nRS,
     &                       Work(ipVJ),1,Fact,Work(ipFab),1)


                  CALL CWTIME(TCC2,TWC2)
                  tcoul(1) = tcoul(1) + (TCC2 - TCC1)
                  tcoul(2) = tcoul(2) + (TWC2 - TWC1)

               EndIf  ! Coulomb contribution

C *************** EXCHANGE CONTRIBUTIONS  ***********************

               CALL CWTIME(TCS1,TWS1)
C ---------------------------------------------------------------------
C --- Estimate the diagonals :   D(a,b) = sum_J (Lab,J)^2
C
               If (Estimate) Then

                  Call Fzero(Work(ipDiag+iiBstR(jSym,1)),NNBSTR(jSym,1))

                  Do krs=1,nRS

                     mrs = iiBstR(JSYM,iLoc) + krs
                     jrs = IndRed(mrs,iLoc) ! address in 1st red set

                     Do jvc=1,JNUM

                        ipL = ipLrs + nRS*(jvc-1)

                        Work(ipDiag+jrs-1) = Work(ipDiag+jrs-1)
     &                                  + Work(ipL+krs-1)**2

                     End Do

                  End Do

               EndIf

               CALL CWTIME(TCS2,TWS2)
               tscrn(1) = tscrn(1) + (TCS2 - TCS1)
               tscrn(2) = tscrn(2) + (TWS2 - TWS1)


               CALL CWTIME(TCX1,TWX1)

C *** Reorder vectors to Full-dimensions
C ***
C *** Vectors are returned in the storage LaJ,b with the restriction:
C ***
C ***    Sym(a).ge.Sym(b)
C ***
C *** and blocked in shell pairs

               CALL FZero(Work(ipLF),LFULL*JNUM)
               CALL FZero(Work(ip_SvShp),2*nnShl)

               CALL CHO_getShFull(Work(ipLrs),lread,JNUM,JSYM,
     &                            IREDC,ipLF,Work(ip_SvShp),
     &                            iWork(ip_iShp_rs))


               CALL CWTIME(TCX2,TWX2)
               texch(1) = texch(1) + (TCX2 - TCX1)
               texch(2) = texch(2) + (TWX2 - TWX1)


               IF (DoScreen) THEN

                  CALL CWTIME(TCS1,TWS1)

c --- Compute DH(a,b)=sqrt(D(a,b)) from the updated diagonals.
c ---                              Only the symmetry blocks with
c ---                              compound symmetry JSYM are computed
c --------------------------------------------------------------------
                   mode = 'tosqrt'
                   ired1 = 1 ! location of the 1st red set
                   add  = .false.
                   nMat = 1
                   Call play_sto(irc,ired1,nMat,JSYM,ISTLT,ISSQ,
     &                               ipDIAH,ipDIAG,mode,add)


                  CALL CWTIME(TCS2,TWS2)
                  tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                  tscrn(2) = tscrn(2) + (TWS2 - TWS1)

               ENDIF


               Do jDen=1,nDen

                  Do kSym=1,nSym

                     lSym=MulD2h(JSYM,kSym)

                     Do jK=1,nOrb(kSym,jDen)

                      CALL FZero(Work(ipChoT),nBas(lSym)*JNUM)

                      ipMO = ipOrb(kSym,jDen)
     &                     + nBas(kSym)*(jK-1)

                      ipYk = ipY + MaxB*(kOff(kSym,jDen) + jK - 1)
                      ipMLk = ipML + nShell*(kOff(kSym,jDen) + jK - 1)
                      ipIndSh = ipIndx + (nShell+1)*(kOff(kSym,jDen) +
     &                                   jK - 1)

                      ipSk= ipSKsh + nShell*(kOff(kSym,jDen) + jK - 1)

                      IF (DoScreen) THEN

                        CALL CWTIME(TCS1,TWS1)
C------------------------------------------------------------------
C --- Setup the screening
C------------------------------------------------------------------
                        ipDIH = ipDIAH(1) + ISSQ(lSym,kSym)

                        Do ik=0,nBas(kSym)-1
                           Work(ipAbs+ik) = abs(Work(ipMO+ik))
                        End Do

                        If (lSym.ge.kSym) Then
c --------------------------------------------------------------
C --- Y(l)[k] = sum_n  DH(l,n) * |C(n)[k]|
C===============================================================
                           nBs = Max(1,nBas(lSym))

                           CALL DGEMV_('N',nBas(lSym),nBas(kSym),
     &                                ONE,Work(ipDIH),nBs,
     &                                    Work(ipAbs),1,
     &                               ZERO,Work(ipYk),1)

                        Else
c --------------------------------------------------------------
C --- Y(l)[k] = sum_n  DH(n,l) * |C(n)[k]|
C===============================================================
                           nBs = Max(1,nBas(kSym))

                           CALL DGEMV_('T',nBas(kSym),nBas(lSym),
     &                                ONE,Work(ipDIH),nBs,
     &                                    Work(ipAbs),1,
     &                               ZERO,Work(ipYk),1)

                        EndIf
c            Call recprt('DH','',Work(ipDIH),nBas(lSym),nBas(kSym))
c            write(6,*)'Y(k)= ',(Work(ipYk+i-1),i=1,nBas(lSym))
c            write(6,*)'|C(k)|= ',(Work(ipAbs+i-1),i=1,nBas(kSym))

C --- List the shells present in Y(l)[k] by the largest element
                        Do ish=1,nShell
                           YshMax=zero
                           Do ibs=1,nBasSh(lSym,ish)
                              YshMax = Max(YshMax,
     &                               Work(ipYk+koffSh(ish,lSym)+ibs-1))
                           End Do
                           Work(ipMLk+ish-1) = YshMax
                        End Do

c            write(6,*)'ML(k)= ',(Work(ipMLk+i-1),i=1,nShell)

C --- Sort the list ML[k]
                        numSh=0  ! # of significant shells
                        jml=1

                        Do ish=1,nShell
                           iWork(ipIndSh+ish) = ish
                        End Do

                        Do while (jml.le.nShell)

                           YMax=Work(ipMLk+jml-1)
                           jmlmax=jml

                           Do iml=jml+1,nShell  ! get the max
                              If (Work(ipMLk+iml-1).gt.YMax) then
                                 YMax = Work(ipMLk+iml-1)
                                 jmlmax = iml
                              Endif
                           End Do

                           If (jmlmax.ne.jml) then  ! swap positions
                              xTmp = Work(ipMLk+jml-1)
                              iTmp = iWork(ipIndSh+jml)
                              Work(ipMLk+jml-1) = YMax
                              iWork(ipIndSh+jml) = iWork(ipIndSh+jmlmax)
                              Work(ipMLk+jmlmax-1) = xTmp
                              iWork(ipIndSh+jmlmax) = iTmp
                           Endif

c --- Exact bounds (quadratic scaling of the MO transformation)
ctbp, may 2013: reintroduce exact bound
                            If(Work(ipMLk+jml-1)*Work(ipMLk)
     &                                          .ge. tau(jDen))then
c
c --- Here we use a non-exact bound for the exchange matrix
c --- The positive definiteness of the exchange matrix
c --- combined with the structure of the density matrix makes this
c --- bound acceptable and likely to be almost exact for what concerns
c --- the exchange energy
ctbp                       If ( Work(ipMLk+jml-1) .ge. xtau(jDen) ) then
                              numSh = numSh + 1
                           else
                              jml=nShell  ! exit the loop
                           endif

                           jml=jml+1

                        End Do

                        iWork(ipIndSh)=numSh

c         write(6,*)'ord-ML(k)= ',(Work(ipMLk+i-1),i=1,nShell)
c         write(6,*)'Ind-ML(k)= ',(iWork(ipIndSh+i-1),i=1,nShell+1)
c         write(6,*)'lSym,kSym,jSym,jk,nShell,numSh= ',lSym,kSym,
c     &              jSym,jk,nShell,numSh

                        CALL CWTIME(TCS2,TWS2)
                        tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                        tscrn(2) = tscrn(2) + (TWS2 - TWS1)
C------------------------------------------------------------------
                      ENDIF    ! Screening setup


C --- Transform vectors for shells in the list ML[k]
C
C --- Screening based on the Frobenius norm: sqrt(sum_ij  A(i,j)^2)
C
C ---   || La,J[k] ||  .le.  || Lab,J || * || Cb[k] ||

                      CALL CWTIME(TCT1,TWT1)

                      IF (lSym.ge.kSym) Then


                         Do iSh=1,iWork(ipIndSh)

                            iaSh = iWork(ipIndSh+iSh)

                            iOffSha = kOffSh(iaSh,lSym)

                            iWork(ip_Lab+iaSh-1) = ipChoT + iOffSha*JNUM

                            ibcount=0

                            Do ibSh=1,nShell

                               iOffShb = kOffSh(ibSh,kSym)

                               iShp = iTri(iaSh,ibSh)

                               If ( iShp_rs(iShp) .gt. 0 ) Then

                                 If ( nnBstRSh(JSym,iShp_rs(iShp),iLoc)*
     &                              nBasSh(lSym,iaSh)*
     &                              nBasSh(kSym,ibSh) .gt. 0
     &                              .and. sqrt(abs(Work(ipSk+ibSh-1)*
     &                                         SvShp(iShp_rs(iShp)) ))
     &                              .ge. thrv(jDen) )Then

                                    ibcount = ibcount + 1

                                    jOff = iOffShp(lSym,iShp_rs(iShp)) -
     &                                     nBasSh(lSym,ibSh)*
     &                                     nBasSh(kSym,iaSh)*
     &                             Min(0,(iaSh-ibSh))/Max(1,(ibSh-iaSh))


C ---  LaJ,[k] = sum_b  L(aJ,b) * C(b)[k]
C ---------------------------------------

                                 CALL DGEMV_('N',nBasSh(lSym,iaSh)*JNUM,
     &                                        nBasSh(kSym,ibSh),
     &                                    ONE,Work(ipLF+jOff*JNUM),
     &                                        nBasSh(lSym,iaSh)*JNUM,
     &                                     Work(ipMO+ioffShb),1,
     &                                    ONE,Work(ipLab(iaSh)),1)


                                 EndIf

                               EndIf

                            End Do

c --- The following re-assignement is used later on to check if the
c --- iaSh vector LaJ[k] can be neglected because identically zero

                            iWork(ip_Lab+iaSh-1) = ipLab(iaSh)*
     &                                             Min(1,ibcount)
     &                                  + ipAbs*(1-Min(1,ibcount))

                         End Do


                      Else   ! lSym < kSym


                         Do iSh=1,iWork(ipIndSh)

                            iaSh = iWork(ipIndSh+iSh)

                            iOffSha = kOffSh(iaSh,lSym)

                            iWork(ip_Lab+iaSh-1) = ipChoT + iOffSha*JNUM

                            ibcount=0

                            Do ibSh=1,nShell

                               iOffShb = kOffSh(ibSh,kSym)

                               iShp = iTri(iaSh,ibSh)

                               If ( iShp_rs(iShp) .gt. 0 ) Then

                                 If (nnBstRSh(JSym,iShp_rs(iShp),iLoc)*
     &                             nBasSh(lSym,iaSh)*
     &                             nBasSh(kSym,ibSh) .gt. 0
     &                             .and. sqrt(abs(Work(ipSk+ibSh-1)*
     &                                        SvShp(iShp_rs(iShp)) ))
     &                             .ge. thrv(jDen) ) Then

                                   ibcount = ibcount + 1

                                   jOff = iOffShp(kSym,iShp_rs(iShp)) -
     &                                    nBasSh(kSym,iaSh)*
     &                                    nBasSh(lSym,ibSh)*
     &                             Min(0,(ibSh-iaSh))/Max(1,(iaSh-ibSh))


C ---  LJa,[k] = sum_b  L(b,Ja) * C(b)[k]
C ---------------------------------------

                                 CALL DGEMV_('T',nBasSh(kSym,ibSh),
     &                                       JNUM*nBasSh(lSym,iaSh),
     &                                    ONE,Work(ipLF+jOff*JNUM),
     &                                        nBasSh(kSym,ibSh),
     &                                     Work(ipMO+ioffShb),1,
     &                                    ONE,Work(ipLab(iaSh)),1)

                                 EndIf

                               Endif

                            End Do

c --- The following re-assignement is used later on to check if the
c --- iaSh vector LaJ[k] can be neglected because identically zero

                            iWork(ip_Lab+iaSh-1) = ipLab(iaSh)*
     &                                             Min(1,ibcount)
     &                                  + ipAbs*(1-Min(1,ibcount))

                         End Do

                      EndIf

                      CALL CWTIME(TCT2,TWT2)
                      tmotr(1) = tmotr(1) + (TCT2 - TCT1)
                      tmotr(2) = tmotr(2) + (TWT2 - TWT1)

C --- Prepare the J-screening

                      CALL CWTIME(TCS1,TWS1)

                      IF (lSym.ge.kSym) Then


                         Do iSh=1,iWork(ipIndSh)

                            iaSh = iWork(ipIndSh+iSh)

                            ipFaa = ipFk + MxBasSh + iaSh - 1

                            iaSkip= Min(1,Max(0,
     &                              abs(ipLab(iaSh)-ipAbs))) ! = 1 or 0

                            Do i=1,iaSkip

C ---  Faa,[k] = sum_J  (LaJ[k])**2
C ----------------------------------
                               Do jv=1,JNUM

                                  xfjv = dble(min(1,jv-1))

                                  Do ia=1,nBasSh(lSym,iaSh)

                                     ipFia = ipFk + ia - 1

                                     ipLaa = ipLab(iaSh)
     &                                     + nBasSh(lSym,iaSh)*(jv-1)
     &                                     + ia - 1

                                     Work(ipFia) = xfjv*Work(ipFia)
     &                                           + Work(ipLaa)**2
                                  End Do
                               End Do

                               CALL FindMax(ipFk,'N',
     &                                      nBasSh(lSym,iaSh),
     &                                      1,ipFaa)

                            End Do

                         End Do


                      Else   ! lSym < kSym


                         Do iSh=1,iWork(ipIndSh)

                            iaSh = iWork(ipIndSh+iSh)

                            ipFaa = ipFk + MxBasSh + iaSh - 1

                            iaSkip= Min(1,Max(0,
     &                              abs(ipLab(iaSh)-ipAbs))) ! = 1 or 0

                            Do i=1,iaSkip

C ---  Faa,[k] = sum_J  (LJa[k])**2
C ----------------------------------
                               Do ia=1,nBasSh(lSym,iaSh)

                                  ipFia = ipFk + ia - 1

                                  Do jv=1,JNUM

                                     xfjv = dble(min(1,jv-1))

                                     ipLaa = ipLab(iaSh)
     &                                     + JNUM*(ia-1)
     &                                     + jv - 1

                                     Work(ipFia) = xfjv*Work(ipFia)
     &                                           + Work(ipLaa)**2
                                  End Do
                               End Do

                               CALL FindMax(ipFk,'N',
     &                                      nBasSh(lSym,iaSh),
     &                                      1,ipFaa)

                            End Do

                         End Do


                      EndIf

                      CALL CWTIME(TCS2,TWS2)
                      tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                      tscrn(2) = tscrn(2) + (TWS2 - TWS1)


C------------------------------------------------------------
C --- Compute exchange matrix for the interacting shell pairs
C------------------------------------------------------------

                      CALL CWTIME(TCX1,TWX1)

                      IF (lSym.ge.kSym) Then

                         Do lSh=1,iWork(ipIndSh)

                            iaSh = iWork(ipIndSh+lSh)

                            ipFaa = ipFk + MxBasSh + iaSh - 1

                            iaSkip= Min(1,Max(0,
     &                              abs(ipLab(iaSh)-ipAbs))) ! = 1 or 0

                            iOffSha = kOffSh(iaSh,lSym)

                            mSh = 1

                            Do while (mSh.le.iWork(ipIndSh))

                               ibSh = iWork(ipIndSh+mSh)

                               ipFbb = ipFk + MxBasSh + ibSh - 1

                               ibSkip = Min(1,Max(0,
     &                                        abs(ipLab(ibSh)-ipAbs)))

                               iShp = iTri(iaSh,ibSh)

                               iOffShb = kOffSh(ibSh,lSym)

                               iOffAB = nnBfShp(iShp,lSym)

                               ipKI = ipKLT(jDen) + ISTLT(lSym) + iOffAB

                               xFab = sqrt(abs(Work(ipFaa)*Work(ipFbb)))

                               If ( Work(ipMLk+lSh-1)*Work(ipMLk+mSh-1)
     &                              .lt. tau(jDen) ) Then


                                   mSh = iWork(ipIndSh)  ! skip the rest


                               ElseIf(iaSh.eq.ibSh
     &                                .and.xFab.ge.tau(jDen)/MaxRedT
     &                                .and.iaSkip.eq.1)Then

C ---  F(a,b)[k] = F(a,b)[k] - FactXI * sum_J  L(a,J)[k] * L(b,J)[k]
C -------------------------------------------------------------------
                               nBs = Max(1,nBasSh(lSym,iaSh))

                               CALL DGEMM_Tri('N','T',nBasSh(lSym,iaSh),
     &                                           nBasSh(lSym,ibSh),JNUM,
     &                                       -FActXI,Work(ipLab(iaSh)),
     &                                           nBs,
     &                                           Work(ipLab(ibsh)),
     &                                           nBs,
     &                                       ONE,Work(ipKI),
     &                                               nBs)

c                         write(6,*)'Symm= ',lsym,' Sh-pair: ',iaSh,ibSh
c                               CALL TRIPRT('FI',' ',Work(ipKI),nBs)

                               ElseIf (iaSh.gt.ibSh
     &                                .and.xFab.ge.tau(jDen)/MaxRedT
     &                                 .and. iaSkip*ibSkip.eq.1) Then

C ---  F(a,b)[k] = F(a,b)[k] - FactXI * sum_J  L(a,J)[k] * L(b,J)[k]
C -------------------------------------------------------------------
                                  nBsa = Max(1,nBasSh(lSym,iaSh))
                                  nBsb = Max(1,nBasSh(lSym,ibSh))

                                  CALL DGEMM_('N','T',nBasSh(lSym,iaSh),
     &                                           nBasSh(lSym,ibSh),JNUM,
     &                                       -FactXI,Work(ipLab(iaSh)),
     &                                           nBsa,
     &                                           Work(ipLab(ibsh)),
     &                                           nBsb,
     &                                       ONE,Work(ipKI),
     &                                               nBsa)

c                         write(6,*)'Symm= ',lsym,' Sh-pair: ',iaSh,ibSh
c                               CALL TRIPRT('FI',' ',Work(ipKI),nBsa)

                               EndIf


                               mSh = mSh + 1  ! update shell counter


                            End Do

                         End Do


                      ELSE   ! lSym < kSym


                         Do lSh=1,iWork(ipIndSh)

                            iaSh = iWork(ipIndSh+lSh)

                            ipFaa = ipFk + MxBasSh + iaSh - 1

                            iaSkip= Min(1,Max(0,
     &                              abs(ipLab(iaSh)-ipAbs))) ! = 1 or 0

                            iOffSha = kOffSh(iaSh,lSym)

                            mSh = 1

                            Do while (mSh.le.iWork(ipIndSh))

                               ibSh = iWork(ipIndSh+mSh)

                               ipFbb = ipFk + MxBasSh + ibSh - 1

                               ibSkip= Min(1,Max(0,
     &                                 abs(ipLab(ibSh)-ipAbs)))

                               iShp = iTri(iaSh,ibSh)

                               iOffShb = kOffSh(ibSh,lSym)

                               iOffAB = nnBfShp(iShp,lSym)

                               ipKI = ipKLT(jDen) + ISTLT(lSym) + iOffAB

                               xFab = sqrt(abs(Work(ipFaa)*Work(ipFbb)))

                               If ( Work(ipMLk+lSh-1)*Work(ipMLk+mSh-1)
     &                              .lt. tau(jDen) ) Then


                                   mSh = iWork(ipIndSh)  ! skip the rest


                               ElseIf(iaSh.eq.ibSh
     &                                .and.xFab.ge.tau(jDen)/MaxRedT
     &                                .and.iaSkip.eq.1)Then

C ---  F(a,b)[k] = F(a,b)[k] - FactXI * sum_J  L(J,a)[k] * L(J,b)[k]
C -------------------------------------------------------------------

                               nBs = Max(1,nBasSh(lSym,iaSh))

                               CALL DGEMM_Tri('T','N',nBasSh(lSym,iaSh),
     &                                           nBasSh(lSym,ibSh),JNUM,
     &                                        -FActXI,Work(ipLab(iaSh)),
     &                                                JNUM,
     &                                                Work(ipLab(ibsh)),
     &                                                JNUM,
     &                                            ONE,Work(ipKI),
     &                                                nBs)


c                         write(6,*)'Symm= ',lsym,' Sh-pair: ',iaSh,ibSh
c                               CALL TRIPRT('FI',' ',Work(ipKI),nBs)

                               ElseIf (iaSh.gt.ibSh
     &                                .and.xFab.ge.tau(jDen)/MaxRedT
     &                                 .and. iaSkip*ibSkip.eq.1) Then

C ---  F(a,b)[k] = F(a,b)[k] - FactXI * sum_J  L(J,a)[k] * L(J,b)[k]
C -------------------------------------------------------------------

                                  nBs = Max(1,nBasSh(lSym,iaSh))

                                  CALL DGEMM_('T','N',nBasSh(lSym,iaSh),
     &                                           nBasSh(lSym,ibSh),JNUM,
     &                                       -FactXI,Work(ipLab(iaSh)),
     &                                           JNUM,
     &                                           Work(ipLab(ibsh)),
     &                                           JNUM,
     &                                       ONE,Work(ipKI),
     &                                               nBs)

c                         write(6,*)'Symm= ',lsym,' Sh-pair: ',iaSh,ibSh
c                               CALL TRIPRT('FI',' ',Work(ipKI),nBs)

                               EndIf


                               mSh = mSh + 1  ! update shell counter


                            End Do

                         End Do


                      ENDIF

                      CALL CWTIME(TCX2,TWX2)
                      texch(1) = texch(1) + (TCX2 - TCX1)
                      texch(2) = texch(2) + (TWX2 - TWX1)



                     End Do  ! loop over k MOs


                  End Do   ! loop over MOs symmetry


               End Do   ! loop over densities


               DoScreen=.false. ! avoid redo screening inside batch loop

C --- Diagonals updating. It only makes sense if Nscreen > 0

               If (Update .and. Nscreen.gt.0) Then

                  CALL CWTIME(TCS1,TWS1)
C ---------------------------------------------------------------------
C --- update the diagonals :   D(a,b) = D(a,b) - sum_J (Lab,J)^2
C
C --- subtraction is done in the 1st reduced set
#if defined (_MOLCAS_MPP_)
                  If (nProcs .gt. 1 .and. Is_Real_Par()) then

                   Do krs=1,nRS

                     mrs = iiBstR(JSYM,iLoc) + krs
                     jrs = IndRed(mrs,iLoc) - iiBstR(JSYM,1)

                     Do jvc=1,JNUM

                        ipL = ipLrs + nRS*(jvc-1)
                        Work(ipjDiag+jrs-1) = Work(ipjDiag+jrs-1)
     &                                      + Work(ipL+krs-1)**2
                     End Do

                   End Do

                  Else

                   Do krs=1,nRS

                     mrs = iiBstR(JSYM,iLoc) + krs
                     jrs = IndRed(mrs,iLoc) ! address in 1st red set

                     Do jvc=1,JNUM

                        ipL = ipLrs + nRS*(jvc-1)
                        Work(ipDiag+jrs-1) = Work(ipDiag+jrs-1)
     &                                     - Work(ipL+krs-1)**2
                     End Do

                   End Do

                  EndIf

#else
                  Do krs=1,nRS

                     mrs = iiBstR(JSYM,iLoc) + krs
                     jrs = IndRed(mrs,iLoc) ! address in 1st red set

                     Do jvc=1,JNUM

                        ipL = ipLrs + nRS*(jvc-1)
                        Work(ipDiag+jrs-1) = Work(ipDiag+jrs-1)
     &                                     - Work(ipL+krs-1)**2
                     End Do

                  End Do
#endif

                  CALL CWTIME(TCS2,TWS2)
                  tscrn(1) = tscrn(1) + (TCS2 - TCS1)
                  tscrn(2) = tscrn(2) + (TWS2 - TWS1)

               EndIf

C --------------------------------------------------------------------
C --------------------------------------------------------------------

            END DO  ! end batch loop


            If(JSYM.eq.1)Then
c --- backtransform fock matrix to full storage
               mode = 'tofull'
               add  = .true.
               nMat = nDen
               Call play_sto(irc,iLoc,nMat,JSYM,ISTLT,ISSQ,
     &                           ipFLT,ipFab,mode,add)
            EndIf

C --- free memory
            CALL GETMEM('FullV','Free','Real',ipLF,LFULL*nVec)
            Call GetMem('ChoT','Free','Real',ipChoT,mTvec*nVec)
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

            If(JSYM.eq.1)Then
              Call GetMem('rsFC','Free','Real',ipFab,nRS)
              Call GetMem('rsPtot','Free','Real',ipPab,nRS)
            EndIf

999         Continue

C --- Screening control section
            DoScreen = kscreen.eq.Nscreen

            if (.not.DoScreen) then
                kscreen = kscreen + 1
            else
                kscreen = 1
            endif

#if defined (_MOLCAS_MPP_)
            If (nProcs.gt.1 .and. Update .and. DoScreen
     &          .and. Is_Real_Par()) Then
               Call GaDsum(Work(ipjDiag),nnBSTR(JSYM,1))
               Call Daxpy_(nnBSTR(JSYM,1),xone,Work(ipjDiag),1,
     &                    Work(ipDiag+iiBstR(JSYM,1)),1)
               Call Fzero(Work(ipjDiag),nnBSTR(JSYM,1))
            EndIf
C--- Need to activate the screening to setup the contributing shell
C--- indeces the first time the loop is entered .OR. whenever other nodes
C--- have performed screening in the meanwhile
            If (nProcs.gt.1 .and. .not.DoScreen .and. nVrs.eq.0
     &          .and. Is_Real_Par()) Then
               ntv0=ntv0+1
               DoScreen = (JRED.lt.myJRED1 .or. ntv0.ge.Nscreen)
               if (DoScreen) ntv0=0
            EndIf
#endif

         END DO   ! loop over red sets

1000     CONTINUE

      END DO   !loop over JSYM

* --- Accumulate Coulomb and Exchange contributions
      Do jDen=1,nDen

         Do iSym=1,nSym

            ipFI = ipFLT(jDen) + ISTLT(iSym)
            ipKI = ipKLT(jDen) + ISTLT(iSym)

            Do iaSh=1,nShell

               ioffa = kOffSh(iaSh,iSym)

c --- ibSh < iaSh
c ---------------
               Do ibSh=1,iaSh-1

                  iShp = iaSh*(iaSh-1)/2 + ibSh

                  iOffAB = nnBfShp(iShp,iSym)

                  ioffb = kOffSh(ibSh,iSym)

                  Do ib=1,nBasSh(iSym,ibSh)

                   Do ia=1,nBasSh(iSym,iaSh)

                     iab = nBasSh(iSym,iaSh)*(ib-1) + ia

                     jK = ipKI - 1 + iOffAB + iab

                     iag = ioffa + ia
                     ibg = ioffb + ib

                     jF = ipFI - 1 + iTri(iag,ibg)

                     Work(jF) = Work(jF) + Work(jK)

                   End Do

                  End Do

               End Do

c --- ibSh = iaSh
c ---------------
               iShp = iaSh*(iaSh+1)/2

               iOffAB = nnBfShp(iShp,iSym)

               Do ib=1,nBasSh(iSym,iaSh)

                Do ia=ib,nBasSh(iSym,iaSh)

                  iab = ia*(ia-1)/2 + ib

                  jK = ipKI - 1 + iOffAB + iab

                  iag = ioffa + ia
                  ibg = ioffa + ib

                  jF = ipFI - 1 + iag*(iag-1)/2 + ibg

                  Work(jF) = Work(jF) + Work(jK)

                End Do

               End Do


            End Do

         End Do

      End Do


      CALL GETMEM('F(k)ss','Free','Real',ipFk,MxBasSh+nShell)
      Call GetMem('ip_SvShp','Free','Real',ip_SvShp,2*nnShl)
      Call GetMem('ip_iShp_rs','Free','Inte',ip_iShp_rs,nnShl_tot)
      Call GetMem('ip_nnBfShp','Free','Inte',ip_nnBfShp,nnShl_tot*nSym)
      Call GetMem('ip_kOffSh','Free','Inte',ip_kOffSh,nShell*nSym)
      Call GetMem('ip_Lab','Free','Inte',ip_Lab,nShell)
      Call GetMem('Indx','Free','Inte',ipIndx,(nShell+1)*nnO)
      Call GetMem('SKsh','Free','Real',ipSKsh,nShell*nnO)
      Call GetMem('MLk','Free','Real',ipML,nShell*nnO)
      Call GetMem('yc','Free','Real',ipY,MaxB*nnO)
      Call GetMem('absc','Free','Real',ipAbs,MaxB)
      CALL GETMEM('diahI','Free','Real',ipDIAH(1),NNBSQ)
#if defined (_MOLCAS_MPP_)
      If (nProcs.gt.1 .and. Update .and. Is_Real_Par())
     &    CALL GETMEM('diagJ','Free','Real',ipjDIAG,NNBSTMX)
#endif
      CALL GETMEM('diagI','Free','Real',ipDIAG,NNBSTRT(1))


      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1


*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky SCF timing from '//SECNAM
      Write(6,CFmt)'------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ VECTORS                     '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB                          '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'SCREENING OVERHEAD               '
     &                           //'         ',tscrn(1),tscrn(2)
         Write(6,'(2x,A26,2f10.2)')'MO HALF-TRANSFORM VECTORS        '
     &                           //'         ',tmotr(1),tmotr(2)
         Write(6,'(2x,A26,2f10.2)')'EXCHANGE                         '
     &                           //'         ',texch(1),texch(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


c Print the Fock-matrix
#ifdef _DEBUGPRINT_

      if(Debug) then !to avoid double printing in SCF-debug

      WRITE(6,'(6X,A)')'TEST PRINT FROM '//SECNAM
      WRITE(6,'(6X,A)')
      WRITE(6,'(6X,A)')'***** FOCK MATRIX AO-BASIS ***** '
      Do jDen=1,nDen
        if(nDen.eq.2) Then
          if(jden.eq.1) WRITE(6,'(6X,A)')'******** ALPHA SPIN ******** '
          if(jden.eq.2) WRITE(6,'(6X,A)')'******** BETA SPIN ********* '
        endif
        DO ISYM=1,NSYM
           ISFI=ipFLT(jDen)+ISTLT(ISYM)
           IF( NBAS(ISYM).GT.0 ) THEN
             WRITE(6,'(6X,A)')
             WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES: ',ISYM
             call TRIPRT('','',Work(ISFI),NBAS(ISYM))
           ENDIF
        END DO
      END DO

      endif

#endif

      rc  = 0


      Return
      END

**************************************************************
**************************************************************



      SUBROUTINE play_sto(irc,iLoc,nDen,JSYM,ISLT,ISSQ,
     &                        ipXLT,ipXab,mode,add)

      Implicit Real*8 (a-h,o-z)
      Integer  ISLT(8),ISSQ(8,8),cho_isao,nDen
      External cho_isao
      Integer ipXLT(nDen),ipXab
      Logical add
      Character*6 mode

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      iRS2F(i,j)  = iWork(ip_iRS2F-1+2*(j-1)+i)
************************************************************************



      xf=0.0d0
      if (add) xf=1.0d0 !accumulate contributions

      If (mode.eq.'toreds'.and.JSYM.eq.1) then ! TOTAL SYMMETRIC

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)
c           !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            Do jDen=1,nDen

               kfrom = ipXLT(jDen) + isLT(iSyma) + iab - 1

               Work(ipXab+jRab-1) = xf*Work(ipXab+jRab-1)
     &                            +    Work(kfrom)

            End Do

         End Do  ! jRab loop


      ElseIf (mode.eq.'tofull'.and.JSYM.eq.1) then
c      ! TOTAL SYMMETRIC

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            Do jDen=1,nDen

               kto = ipXLT(jDen) + isLT(iSyma) + iab - 1

               Work(kto) = xf*Work(kto)
     &                   +    Work(ipXab+jRab-1)

            End Do

         End Do  ! jRab loop


      ElseIf (mode.eq.'tosqrt'.and.JSYM.ne.1) then
c      ! NON TOTAL-SYMMETRIC

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab ! already in 1st red set

            iag   = iRS2F(1,kRab)  !global address
            ibg   = iRS2F(2,kRab)

            iSyma = cho_isao(iag)  !symmetry block
            iSymb = MulD2h(jSym,iSyma) ! sym(a) .gt. sym(b)

            ias   = iag - ibas(iSyma)
            ibs   = ibg - ibas(iSymb)

            iab   = nBas(iSyma)*(ibs-1) + ias

            Do jDen=1,nDen

               kto = ipXLT(jDen) - 1 + isSQ(iSyma,iSymb) + iab

               Work(kto) = sqrt(abs(Work(ipXab+kRab-1)))

            End Do

         End Do  ! jRab loop


      ElseIf (mode.eq.'tosqrt'.and.JSYM.eq.1) then

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab ! already in 1st red set

            iag   = iRS2F(1,kRab)  !global address
            ibg   = iRS2F(2,kRab)

            iSyma = cho_isao(iag)  ! sym(a)=sym(b)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)

            iab   = nBas(iSyma)*(ibs-1) + ias
            iba   = nBas(iSyma)*(ias-1) + ibs

            Do jDen=1,nDen

               kto = ipXLT(jDen) - 1 + isSQ(iSyma,iSyma)

               Work(kto+iab) = sqrt(abs(Work(ipXab+kRab-1)))

               Work(kto+iba) = sqrt(abs(Work(ipXab+kRab-1)))

            End Do

         End Do  ! jRab loop


      Else

         write(6,*)'Wrong input parameters. JSYM,mode = ',JSYM,mode
         irc = 66
         Call abend()

      EndIf

      irc = 0

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Ext_W4hlp2(V2,M1,nc,dimab,dimapp,dimbpp,addapp,addbpp)
! this routine does:
! Extract M1(m,a",b") <- V2(m,a'b')

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nc, dimab, dimapp, dimbpp, addapp, addbpp
real(kind=wp), intent(in) :: V2(nc,dimab)
real(kind=wp), intent(out) :: M1(nc,dimapp,dimbpp)
integer(kind=iwp) :: a, ab, app

do app=1,dimapp
  a = addapp+app
  ab = nTri_Elem(a-1)+addbpp

  M1(:,app,1:dimbpp) = V2(:,ab+1:ab+dimbpp)

end do

return

end subroutine Ext_W4hlp2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine facab(binom,na1,nb1,crda,crdb,xab)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: binom(*), crda(*), crdb(*)
integer(kind=iwp), intent(in) :: na1, nb1
real(kind=wp), intent(out) :: xab(na1+nb1-1)
integer(kind=iwp) :: ia1, ib1, naind, nbind

xab(:) = Zero
naind = (na1*(na1-1))/2
nbind = (nb1*(nb1-1))/2
do ia1=1,na1
  do ib1=1,nb1
    xab((ia1-1)+ib1) = xab((ia1-1)+ib1)+(binom(naind+ia1)*crda((na1+1)-ia1))*binom(nbind+ib1)*crdb((nb1+1)-ib1)
  end do
end do

return

end subroutine facab

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_QUIT(STRING,IERR)
!
! Purpose: echo message STRING and abort execution.

use Cholesky, only: LuPri
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: STRING
integer(kind=iwp), intent(in) :: IERR
integer(kind=iwp) :: MOLCASCODE

write(LUPRI,'(//,1X,A)') '***'
if ((IERR == 0) .or. (IERR == 100)) then
  write(LUPRI,'(1X,A)') '*** Execution stopped by Cholesky Decomposition Utility'
  write(LUPRI,'(1X,A,A)') '*** Message: ',STRING
else
  write(LUPRI,'(1X,A)') '*** Error in Cholesky Core Routine'
  write(LUPRI,'(1X,A,A)') '*** Message: ',STRING
  write(LUPRI,'(1X,A,I5)') '*** Code   : ',IERR
end if
write(LUPRI,'(1X,A,//)') '***'
call CHO_TRANSLATEERRORCODE(IERR,MOLCASCODE)
call QUIT(MOLCASCODE)

end subroutine CHO_QUIT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Roland Lindh                                     *
************************************************************************
      Subroutine Get_Subblock(Kernel,Func,ixyz,
     &                        Maps2p,list_s,list_exp,list_bas,
     &                        nShell,nSym, list_p,R2_trial,nNQ,
     &                        AOInt,nAOInt,
     &                        FckInt,nFckDim,nFckInt,SOTemp,nSOTemp,
     &                        Dens,nDens,nD,
     &                        Grid,Weights,Rho,mGrid,nRho,
     &                        ndF_dRho,nP2_ontop,ndF_dP2ontop,
     &                        Do_Mo,Do_TwoEl,l_Xhol,
     &                        TmpPUVX,nTmpPUVX,nMOs,CMOs,nCMO,DoIt,
     &                        P2mo,np2act,D1mo,nD1mo,P2_ontop,
     &                        Do_Grad,Grad,nGrad,List_G,IndGrd,iTab,
     &                        Temp,mGrad,F_xc,dF_dRho,
cGLM     &                        Temp,mGrad,F_xc,F_xca,F_xcb,dF_dRho,
     &                        dF_dP2ontop,
     &                        DFTFOCK,mAO,mdRho_dR,
     &                        LOE_DB,LTEG_DB)
************************************************************************
*                                                                      *
* Object: to generate the list of the shell and exponent that have an  *
*         influence on a subblock                                      *
*                                                                      *
*     Called from: Drvnq_                                              *
*                                                                      *
*     Author: Roland Lindh,                                            *
*             Dept of Chemical Physics,                                *
*             University of Lund, Sweden                               *
*             August 1999                                              *
************************************************************************
      use iSD_data
      use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
      External Kernel
#include "itmax.fh"
#include "nq_info.fh"
#include "Molcas.fh"
#include "nsd.fh"
#include "setup.fh"
#include "real.fh"
#include "grid_on_disk.fh"
#include "WrkSpc.fh"
#include "debug.fh"
#include "ksdft.fh"
      Integer Maps2p(nShell,0:nSym-1), list_s(2,*), List_G(3,*),
     &        list_exp(nSym*nShell), list_bas(2,nSym*nShell),
     &        list_p(nNQ), DoIt(nMOs), iTab(4,mGrad),IndGrd(mGrad)
      Real*8 R2_trial(nNQ), FckInt(nFckInt,nFckDim),
     &       AOInt(nAOInt,nAOInt,nD), SOTemp(nSOTemp,nD),
     &       Dens(nDens,nD), Grad(nGrad), Temp(mGrad),
     &       Grid(3,mGrid), Rho(nRho,mGrid), Weights(mGrid),
     &       CMOs(nCMO), P2mo(np2act), D1mo(nD1mo),
     &       P2_ontop(nP2_ontop,mGrid), Roots(3,3), F_xc(mGrid),
cGLM     &       F_xca(mGrid),F_xcb(mGrid),
     &       dF_dRho(ndF_dRho,mGrid),
     &       dF_dP2ontop(ndF_dP2ontop,mGrid),
     &       xyz0(3,2)
      Real*8 TmpPUVX(nTmpPUVX)
      Logical InBox(MxAtom), Do_Grad, lCar(3),
     &        More_to_come
      Logical Do_Mo,Do_TwoEl,l_Xhol
      Character*4 DFTFOCK
      Integer LOE_DB,LTEG_DB
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
#include "nq_structure.fh"
      declare_ip_coor
      declare_ip_r_max
      declare_ip_angular
      iGridInfo(i,iNQ)=iWork(ip_GridInfo+(iNQ-1)*2+i-1)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (Debug) Then
         Write(6,*) 'Enter Get_Subblock'
         Write(6,*) 'ip_nR_Eff GET_SBK',ip_nR_Eff
      End If
#endif
*
*-----Resolve triplet index
*
      iyz = 1 + (ixyz-1)/nx
      ix  = ixyz - (iyz-1)*nx
      iz  = 1 + (iyz-1)/ny
      iy  = iyz - (iz-1)*ny
*
*-----Get the extreme coordinates of the box.
*
      x_min_= x_min+DBLE(ix-2)*Block_Size
      x_max_= x_min_+Block_Size
      y_min_= y_min+DBLE(iy-2)*Block_Size
      y_max_= y_min_+Block_Size
      z_min_= z_min+DBLE(iz-2)*Block_Size
      z_max_= z_min_+Block_Size
      If (ix.eq.1 ) x_min_=-1.0D99
      If (ix.eq.nx) x_max_= 1.0D99
      If (iy.eq.1 ) y_min_=-1.0D99
      If (iy.eq.ny) y_max_= 1.0D99
      If (iz.eq.1 ) z_min_=-1.0D99
      If (iz.eq.nz) z_max_= 1.0D99
*                                                                      *
#ifdef _DEBUGPRINT_
      If (Debug) Then
         Write(6,*)
         Write(6,*) 'Block_Size=',Block_Size
         Write(6,*) 'ix,iy,iz=',ix,iy,iz
         Write(6,*) 'x_min_,x_max_',x_min_,x_max_
         Write(6,*) 'y_min_,y_max_',y_min_,y_max_
         Write(6,*) 'z_min_,z_max_',z_min_,z_max_
         Write(6,*) 'nNQ=',nNQ
      End If
#endif
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*-----Generate list over atoms which contribute to the subblock.
*                                                                      *
************************************************************************
*                                                                      *
      ilist_p=0
      Do 10 iNQ=1,nNQ
         InBox(iNQ)=.False.
*--------Get the coordinates of the partitionning
         x_NQ =Work(ip_Coor(iNQ)  )
         y_NQ =Work(ip_Coor(iNQ)+1)
         z_NQ =Work(ip_Coor(iNQ)+2)
*
*        1) center is in the box
*
         If   ((x_NQ.ge.x_min_).and.(x_NQ.le.x_max_)
     &    .and.(y_NQ.ge.y_min_).and.(y_NQ.le.y_max_)
     &    .and.(z_NQ.ge.z_min_).and.(z_NQ.le.z_max_))
     &     InBox(iNQ)=.True.
         If (InBox(iNQ)) Then
            ilist_p=ilist_p+1
            list_p(ilist_p)=iNQ
            GoTo 10
         EndIf
*
*        2) atomic grid of this center extends inside the box.
*
         RMax = Work(ip_R_Max(iNQ))
         t1=(x_NQ-x_min_)/(x_max_-x_min_)
         If (t1.lt.Zero) t1=Zero
         If (t1.gt.One ) t1=One
         t2=(y_NQ-y_min_)/(y_max_-y_min_)
         If (t2.lt.Zero) t2=Zero
         If (t2.gt.One ) t2=One
         t3=(z_NQ-z_min_)/(z_max_-z_min_)
         If (t3.lt.Zero) t3=Zero
         If (t3.gt.One ) t3=One
         R2_Trial(iNQ)= (x_NQ-(x_max_-x_min_)*t1-x_min_)**2
     &                + (y_NQ-(y_max_-y_min_)*t2-y_min_)**2
     &                + (z_NQ-(z_max_-z_min_)*t3-z_min_)**2
         If (R2_Trial(iNQ).le.RMax**2) Then
            ilist_p=ilist_p+1
            list_p(ilist_p)=iNQ
         EndIf
 10   Continue
      nlist_p=ilist_p
      If (nlist_p.eq.0) return
#ifdef _DEBUGPRINT_
      If (debug) Write (6,*) 'Get_Subblock: List_p:',List_p
#endif
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*-----Generate list over shells which contribute to the subblock.
*                                                                      *
************************************************************************
*                                                                      *
      ilist_s=0
      Do iShell=1,nShell
#ifdef _DEBUGPRINT_
         If (debug) Write (6,*) 'iShell,nShell=',iShell,nShell
#endif
         NrExp =iSD( 5,iShell)
         iAng  =iSD( 1,iShell)
         iShll =iSD( 0,iShell)
         NrBas =iSD( 3,iShell)
         mdci  =iSD(10,iShell)
         nDegi=nSym/dc(mdci)%nStab
*
         Do jSym = 0, nDegi-1
            iSym=dc(mdci)%iCoSet(jSym,0)
#ifdef _DEBUGPRINT_
            If (debug) Write (6,*) 'iSym,nDegi-1=',iSym,nDegi-1
#endif
*
            iNQ=Maps2p(iShell,NrOpr(iSym))
            RMax_NQ = Work(ip_R_Max(iNQ))
#ifdef _DEBUGPRINT_
            If (debug) Then
               Write (6,*) 'iNQ=',iNQ
               Write (6,*) 'RMax_NQ=',RMax_NQ
               Write (6,*) 'InBox(iNQ)=',InBox(iNQ)
            End If
#endif
*
*           1) the center of this shell is inside the box
*
            If (InBox(iNQ)) Then
               ilist_s=ilist_s+1
               list_s(1,ilist_s)=iShell
               list_s(2,ilist_s)=iSym
               list_exp(ilist_s)=NrExp
               list_bas(1,ilist_s)=NrBas
               GoTo 20
            End If
#ifdef _DEBUGPRINT_
            If (debug) Write (6,*) 'Passed here!'
#endif
*
*           2) the Gaussian has a grid point which extends inside the
*              box. The Gaussians are ordered from the most diffuse to
*              the most contracted.
*
            nExpTmp=0
            Do iExp=1,NrExp
*------------- Get the value of the exponent
               ValExp=Shells(iShll)%Exp(iExp)
*------------- If the exponent has an influence then increase the
*              number of actives exponents for this shell, else
*              there is no other active exponent (they ar ordered)
               RMax=Min(Eval_RMax(ValExp,iAng,Threshold),RMax_NQ)
#ifdef _DEBUGPRINT_
               If (Debug) Then
                  Write (6,*) 'iShell,iNQ=',iShell,iNQ
                  Write (6,*) 'ValExp=',ValExp
                  Write (6,*) 'RMax_NQ=',RMax_NQ
                  Write (6,*) 'RMax_Exp=',
     &                         Eval_RMax(ValExp,iAng,Threshold)
                  Write (6,*) 'RMax=',RMax
                  Write (6,*) 'R2_Trial(iNQ),RMax**2=',
     &                         R2_Trial(iNQ),RMax**2
               End If
#endif
               If (R2_Trial(iNQ).gt.RMax**2) Go To 99
               nExpTmp=nExpTmp+1
            End Do              !iExp
 99         Continue
            If (nExpTmp.ne.0) Then
               ilist_s=ilist_s+1
               list_s(1,ilist_s)=iShell
               list_s(2,ilist_s)=iSym
               list_exp(ilist_s)=nExpTmp
*              Write (6,*) 'iShell,NrExp,nExpTmp=',
*    &                      iShell,NrExp,nExpTm
*
*              Examine if contracted basis functions can be ignored.
*              This will be the case for segmented basis sets.
*
c              list_bas(1,ilist_s)=NrBas ! temporary full shell!
c              write (6,*) 'ilist_s,NrBas=',ilist_s,NrBas
c              crite (*,*) 'ilist_s,NrBas=',ilist_s,NrBas
               list_bas(1,ilist_s)=nBas_Eff(NrExp,NrBas,
     &                                      Shells(iShll)%Exp,
     &                                      Shells(iShll)%pCff,
     &                                      list_exp(ilist_s))
C              If (list_bas(1,ilist_s).ne.NrBas) Then
C                 Write (6,*) 'x,y=',list_bas(1,ilist_s),NrBas,'*'
C                 Call RecPrt('Exponents',' ',Shells(iShll)%Exp,1,
C    &                        list_exp(1,ilist_s))
C                 Call RecPrt('Cff',' ',Shells(iShll)%pCff,NrExp,NrBas)
C              Else
C                 Write (6,*) 'x,y=',list_bas(1,ilist_s),NrBas
C              End If
            End If
 20         Continue
         End Do ! iSym
      End Do    ! iShell
      nlist_s=ilist_s
#ifdef _DEBUGPRINT_
      If (Debug) Write (6,*) 'nList_s,nList_p=',nList_s,nList_p
#endif
      If (nList_s*nList_p.eq.0) return
*                                                                      *
************************************************************************
*                                                                      *
*     Generate index arrays to address the density matrix, which is in
*     the full shell and the reduced shell over which in the basis
*     functions will be evaluated.
*
      nIndex=0
      Do ilist_s=1, nlist_s
         iShell=list_s(1,ilist_s)
         NrBas_Eff=list_bas(1,ilist_s)
         iCmp  = iSD( 2,iShell)
         nIndex=nIndex + NrBas_Eff*iCmp
      End Do
*
      Call GetMem('Index','Allo','Inte',ipIndex,nIndex)
*
      iIndex=1
      nAOs=0
      nAOs_Eff=0
      Do ilist_s=1, nlist_s
         iShell=list_s(1,ilist_s)
         NrBas =iSD( 3,iShell)
         NrBas_Eff=list_bas(1,ilist_s)
         iCmp  = iSD( 2,iShell)
         nAOs=nAOs+NrBas*iCmp
         nAOs_Eff=nAOs_Eff+NrBas_Eff*iCmp
         list_bas(2,ilist_s)=iIndex
         Call Do_Index(iWork(ipIndex-1+iIndex),NrBas,NrBas_Eff,iCmp)
         iIndex=iIndex + NrBas_Eff*iCmp
      End Do
C     Write (6,*) 'nAOs**2,nAOs_Eff**2=',nAOs**2,nAOs_Eff**2
C     Write (6,*) 'Reduction=',DBLE(nAOs_Eff**2)/DBLE(nAOs**2)
*                                                                      *
************************************************************************
*                                                                      *
*
#ifdef _DEBUGPRINT_
      If (Debug) Then
         write(6,*) 'Contribution to the subblock :'
         write(6,*) 'NQ :',(list_p(ilist_p)  ,ilist_p=1,nlist_p)
         write(6,*) 'Sh :',(list_s(1,ilist_s),ilist_s=1,nlist_s)
         write(6,*) '   :',(list_s(2,ilist_s),ilist_s=1,nlist_s)
         write(6,*) 'Exp:',(list_exp(ilist_s),ilist_s=1,nlist_s)
      End If
#endif
*
      kTabAO=0
      Do iList_s = 1, nList_s
         iSkal = list_s(1,ilist_s)
         iCmp  = iSD( 2,iSkal)
         iBas  = iSD( 3,iSkal)
         mTabAO=iBas*iCmp
         kTabAO = kTabAO + mAO * mTabAO
      End Do
*
      nTabAO = mGrid * kTabAO
      Call Allocate_Work(ip_TabAO,nTabAO)
      Call Allocate_iWork(ipTabAO,2*(nlist_s+1))
*
      If ((Functional_Type.eq.CASDFT_Type).or.Do_MO.or.DO_TwoEl) Then
         nTabMO=mAO*nMOs*mGrid
         Call Allocate_Work(ipTabMO,nTabMO)
         nTabSO=mAO*nMOs*mGrid
         Call Allocate_Work(ipTabSO,nTabSO)
      Else
         ipTabMO=ip_Dummy
         ipTabSO=ip_Dummy
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Generate indexation of which shells contributes to which centers
*     and center index for each gradient contribution which is computed.
*
      nGrad_Eff=0
      If (Do_Grad) Then
         Call ICopy(3*nShell*nSym,[0],0,List_G,1)
         lCar(1)=.False.
         lCar(2)=.False.
         lCar(3)=.False.
         Do ilist_s = 1, nlist_s
            iShell=list_s(1,ilist_s)
            iSym  =list_s(2,ilist_s)
            mdci  =iSD(10,iShell)
            iNQ = Maps2p(iShell,NrOpr(iSym))
            Do iCar=0,2
               If ((iSD(16+iCar,iShell).ne.0 .or.
     &              iSD(12,iShell).eq.1) .and.
     &             List_G(1+iCar,ilist_s).eq.0) Then
                  nGrad_Eff=nGrad_Eff+1
                  lCar(iCar+1)=.True.
*
*                 For pseudo centers note that there will not be a
*                 gradient computed for this center.
*
                  iPseudo=iSD(12,iShell)
                  If (iPseudo.eq.0) Then
                     IndGrd(nGrad_Eff)=iSD(16+iCar,iShell)
                  Else
                     IndGrd(nGrad_Eff)=-1
                  End If
                  List_G(1+iCar,ilist_s)=nGrad_Eff
                  iTab(1,nGrad_Eff)=iCar+1
                  iTab(3,nGrad_Eff)=iNQ
                  kNQ=Maps2p(iShell,0)
                  Xref=Work(ip_Coor(kNQ)+iCar)
                  X   =Work(ip_Coor(iNQ)+iCar)
                  If (X.eq.Xref) Then
                     iTab(4,nGrad_Eff)=dc(mdci)%nStab
                  Else
                     iTab(4,nGrad_Eff)=-dc(mdci)%nStab
                  End If
*
*---------------- Find all other shells which contibute to the same
*                 gradient.
*
                  Do jlist_s = ilist_s+1, nlist_s
                     jShell=list_s(1,jlist_s)
                     If ( (iSD(16+iCar,iShell).eq.
     &                     iSD(16+iCar,jShell))
     &                    .and.
     &                    (iSym.eq.list_s(2,jlist_s))
     &                  ) Then
                        List_G(1+iCar,jlist_s)=nGrad_Eff
                     End If
                  End Do
*
*
*------- Include derivatives which will be used for
*        the translational invariance equation but which do not
*        contribute directly to a symmetry adapted gradient
*
               Else If (iSD(16+iCar,iShell).eq.0 .and.
     &                 List_G(1+iCar,ilist_s).eq.0) Then
                       nGrad_Eff=nGrad_Eff+1
                       IndGrd(nGrad_Eff)=-1
                       List_G(1+iCar,ilist_s)=nGrad_Eff
                       iTab(1,nGrad_Eff)=iCar+1
                       iTab(3,nGrad_Eff)=iNQ
                       iTab(4,nGrad_Eff)=dc(mdci)%nStab
*
*--------------------- Find all other shells which contibute to the same
*                      gradient.
*
                       Do jlist_s = ilist_s+1, nlist_s
                          jShell=list_s(1,jlist_s)
                          jSym  =list_s(2,jlist_s)
                          jNQ = Maps2p(jShell,NrOpr(jSym))
                          If (iNQ.eq.jNQ) Then
                             List_G(1+iCar,jlist_s)=nGrad_Eff
                          End If
                       End Do
               End If
            End Do
         End Do
         n_dRho_dR=Max(mdRho_dR*mGrid*nGrad_Eff,1)
         Call Allocate_Work(ip_dRho_dR,n_dRho_dR)
*
         If (Grid_Type.eq.Moving_Grid) Then
            ndW_dR=nGrad_Eff*mGrid
            Call GetMem('dW_dR','Allo','Real',ip_dW_dR,ndW_dR)
            ndW_Temp=3*nlist_p
            Call GetMem('dW_Temp','Allo','Real',ip_dW_Temp,ndW_Temp)
            ndPB=3*nlist_p**2
            Call GetMem('dPB','Allo','Real',ip_dPB,ndPB)
         Else
            ip_dW_dR  =ip_Dummy
            ip_dW_Temp=ip_Dummy
            ip_dPB    =ip_Dummy
         End If
      Else
         ip_dRho_dR=ip_Dummy
         ip_dW_dR  =ip_Dummy
         ip_dW_Temp=ip_Dummy
         ip_dPB    =ip_Dummy
      End If
      If (Do_Grad.and.nGrad_Eff.eq.0) Go To 998
      If (Grid_Status.eq.Use_Old) Go To 997
         Call ICopy(3*nBatch_Max,[0],0,iBatchInfo,1)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*-----For each partition active in the subblock create the grid
*     and perform the integration on it.
*                                                                      *
************************************************************************
*                                                                      *
      number_of_grid_points=0
      nBatch = 0
      Do ilist_p=1,nlist_p
         iNQ=list_p(ilist_p)
#ifdef _DEBUGPRINT_
         If (Debug) Write (6,*) 'ilist_p=',ilist_p
         If (Debug) Write (6,*) 'Get_SubBlock: iNQ=',iNQ
#endif
*
*------- Select which gradient contributions that should be computed.
*        For basis functions which have the center common with the grid
*        do not compute any contibution.
*
         If (Do_Grad) Then
            Call ICopy(nGrad_Eff,[On],0,iTab(2,1),4)
            If (Grid_Type.eq.Moving_Grid) Then
               Do iGrad = 1, nGrad_Eff
                  jNQ = iTab(3,iGrad)
                  If (iNQ.eq.jNQ) iTab(2,iGrad)=Off
               End Do
            End If
#ifdef _DEBUGPRINT_
            If (Debug) Then
             Write (6,*)
             Write (6,'(A,24I3)') '       i =',(       i ,i=1,nGrad_Eff)
             Write (6,'(A,24I3)') 'iTab(1,i)=',(iTab(1,i),i=1,nGrad_Eff)
             Write (6,'(A,24I3)') 'iTab(2,i)=',(iTab(2,i),i=1,nGrad_Eff)
             Write (6,'(A,24I3)') 'iTab(3,i)=',(iTab(3,i),i=1,nGrad_Eff)
             Write (6,'(A,24I3)') 'iTab(4,i)=',(iTab(4,i),i=1,nGrad_Eff)
             Write (6,*) 'IndGrd=',IndGrd
             Write (6,*)
            End If
#endif
*
         End If
*
*--------Get the coordinates of the partition
         x_NQ =Work(ip_Coor(iNQ)  )
         y_NQ =Work(ip_Coor(iNQ)+1)
         z_NQ =Work(ip_Coor(iNQ)+2)
*--------Get the maximum radius on which we have to integrate for the
*        partition
         RMax=Work(ip_R_Max(iNQ))
*
         Call Box_On_Sphere(x_Min_-x_NQ,x_Max_-x_NQ, y_Min_-y_NQ,
     &                      y_Max_-y_NQ, z_Min_-z_NQ,z_Max_-z_NQ,
     &                      xyz0(1,1), xyz0(1,2),
     &                      xyz0(2,1), xyz0(2,2),
     &                      xyz0(3,1), xyz0(3,2))
*                                                                      *
************************************************************************
*                                                                      *
*------- Establish R_Box_Max and R_Box_Min, the longest and the shortest
*        distance from the origin of the atomic grid to a point in the
*        box
*
         R_Box_Max=Zero
         R_Box_Min=RMax
*
         x_box_min = x_min_ - x_NQ
         x_box_max = x_max_ - x_NQ
         y_box_min = y_min_ - y_NQ
         y_box_max = y_max_ - y_NQ
         z_box_min = z_min_ - z_NQ
         z_box_max = z_max_ - z_NQ
*
         Roots(1,1)=x_box_min
         Roots(2,1)=x_box_max
         If (x_box_max*x_box_min.lt.Zero) Then
            nx_Roots=3
            Roots(3,1)=Zero
         Else
            nx_Roots=2
         End If
*
         Roots(1,2)=y_box_min
         Roots(2,2)=y_box_max
         If (y_box_max*y_box_min.lt.Zero) Then
            ny_Roots=3
            Roots(3,2)=Zero
         Else
            ny_Roots=2
         End If
*
         Roots(1,3)=z_box_min
         Roots(2,3)=z_box_max
         If (z_box_max*z_box_min.lt.Zero) Then
            nz_Roots=3
            Roots(3,3)=Zero
         Else
            nz_Roots=2
         End If
*
*        Check all stationary points
*
         Do ix = 1, nx_Roots
            x = Roots(ix,1)
            Do iy = 1, ny_Roots
               y = Roots(iy,2)
               Do iz = 1, nz_Roots
                  z = Roots(iz,3)
*
                  r=Sqrt(x**2+y**2+z**2)
*
                  R_Box_Max=Max(R_Box_Max,r)
                  R_Box_Min=Min(R_Box_Min,r)
*
              End Do
           End Do
        End Do
*
        If (Abs(R_Box_Min).lt.1.0D-12) R_Box_Min=Zero
        R_Box_Max=R_Box_Max+1.0D-15
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
         If (Debug) write(6,*) 'Get_Subblock ----> Subblock'
#endif
c
c        Note that in gradient calculations we process the grid points
c        for each atomic grid seperately in order to used the
c        translational invariance on the atomic contributions to the
c        gradient.
c
         nTotGP_Save = nTotGP
         ip_iA=ip_of_iWork_d(Work(ip_Angular(iNQ)))
         ip_A=iWork(ip_iA)
         nR_Eff=iWork(ip_nR_eff-1+iNQ)
         Call Subblock(iNQ,x_NQ,y_NQ,z_NQ,InBox(iNQ),
     &                 x_min_,x_max_, y_min_,y_max_, z_min_,z_max_,
     &                 list_p,nlist_p,Grid,Weights,mGrid,.True.,
     &                 number_of_grid_points,R_Box_Min,R_Box_Max,
     &                 iList_p,xyz0,iWork(ip_A),nR_Eff)
         nTotGP = nTotGP_Save
*
#ifdef _DEBUGPRINT_
         If (Debug) write(6,*) 'Subblock ----> Get_Subblock'
#endif
      End Do
      iWork(ip_GridInfo+(ixyz-1)*2)=iDisk_Grid
      iWork(ip_GridInfo+(ixyz-1)*2+1)=nBatch
      Call iDaFile(Lu_Grid,1,iBatchInfo,3*nBatch,iDisk_Grid)
*                                                                      *
************************************************************************
*                                                                      *
*     Process grid points on file
*
 997  Continue
*
      iDisk_Grid =iGridInfo(1,ixyz)
      nBatch=iGridInfo(2,ixyz)
      Call iDaFile(Lu_Grid,2,iBatchInfo,3*nBatch,iDisk_Grid)
*
      iBatch = 0
      nogp=0
 888     Continue
         iBatch = iBatch + 1
         If (iBatch.gt.nBatch) Go To 996
 887     Continue
         jDisk_Grid=           iBatchInfo(1,iBatch)
         number_of_grid_points=iBatchInfo(2,iBatch)
*
         iNQ=                  iBatchInfo(3,iBatch)
#ifdef _DEBUGPRINT_
         If (Debug) Then
            Write (6,*)
            Write (6,*)  'iNQ=',iNQ
            Write (6,*)
         End If
#endif
         ilist_p=-1
         Do klist_p = 1, nlist_p
            If (List_p(klist_p).eq.iNQ) ilist_p=klist_p
         End Do
*
         If (nogp+number_of_grid_points.le.mGrid) Then
            Call dDaFile(Lu_Grid,2,Grid(1,nogp+1),
     &                   3*number_of_grid_points,jDisk_Grid)
            Call dDaFile(Lu_Grid,2,Weights(nogp+1),
     &                   number_of_grid_points,jDisk_Grid)
            nogp = nogp+number_of_grid_points
*
*           If this is not a gradient evaluation read next buffer if the
*           current one is not the last one.
*
            More_to_Come=.False.
            If (.Not.Do_Grad.and.iBatch.ne.nBatch) Go To 888
         Else
            More_to_Come=.True.
         End If
*
*        Here if it is a gradient evaluation or we have a buffer to
*        process.
*
         If (Do_Grad) Then
            Call ICopy(nGrad_Eff,[On],0,iTab(2,1),4)
            If (Grid_Type.eq.Moving_Grid) Then
               Do iGrad = 1, nGrad_Eff
                  jNQ = iTab(3,iGrad)
                  If (iNQ.eq.jNQ) iTab(2,iGrad)=Off
               End Do
*
*------------- Generate derivative with respect to the weights
*              if needed.
*
               Call dWdR(Grid,ilist_p,Weights,list_p,nlist_p,
     &                   Work(ip_dW_dR),nGrad_Eff,iTab,Work(ip_dW_Temp),
     &                   Work(ip_dPB),number_of_grid_points)
            End If
         End If
*
         Call Do_Batch(Kernel,Func,Grid,Weights,Rho,
     &                 nogp,nRho,
     &                 list_s,nlist_s,List_Exp,List_Bas,
     &                 iWork(ipIndex),nIndex,AOInt,nAOInt,
     &                 FckInt,nFckDim,nFckInt,
     &                 SOTemp,nSOTemp,
     &                 Work(ip_TabAO),iWork(ipTabAO),mAO,
     &                 nTabAO,
     &                 nSym,Dens,nDens,nD,
     &                 ndF_dRho,nP2_ontop,ndF_dP2ontop,
     &                 nShell,
     &                 Do_Mo,Do_TwoEl,l_Xhol,
     &                 TmpPUVX,nTmpPUVX,
     &                 Work(ipTabMO),Work(ipTabSO),
     &                 nMOs,CMOs,nCMO,DoIt,
     &                 P2mo,np2act,D1mo,nd1mo,P2_ontop,
     &                 Do_Grad,Grad,nGrad,
     &                 Work(ip_dRho_dR),mdRho_dR,nGrad_Eff,
     &                 list_g,IndGrd,iTab,Temp,F_xc,
cGLM     &                 list_g,IndGrd,iTab,Temp,F_xc,F_xca,F_xcb,
     &                 Work(ip_dW_dR),iNQ,
     &                 Maps2p,dF_dRho,dF_dP2ontop,
     &                 DFTFOCK,LOE_DB,LTEG_DB)
*
         nTotGP=nTotGP+nogp
* update the "LuGridFile":
         do i=1,nogp
         write(LuGridFile,'(3ES24.14,1x,ES24.14)')
     &               (Grid(l,i),l=1,3), Weights(i)
         enddo
         nogp=0
         If (More_To_Come) Go To 887
         Go To 888
 996     Continue
*
*                                                                      *
************************************************************************
*                                                                      *
 998  Continue
*
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('Index','Free','Real',ipIndex,nIndex)
      Call Free_iWork(ipTabAO)
      Call Free_Work(ip_TabAO)
      If (Do_Grad) Call Free_Work(ip_dRho_dR)
      If (ipTabMO.ne.ip_Dummy) Call Free_Work(ipTabMO)
      If (ipTabSO.ne.ip_Dummy) Call Free_Work(ipTabSO)
      If (Do_Grad.and.Grid_Type.eq.Moving_Grid) Then
         Call GetMem('dPB','Free','Real',ip_dPB,ndPB)
         Call GetMem('dW_Temp','Free','Real',ip_dW_Temp,ndW_Temp)
         Call GetMem('dW_dR','Free','Real',ip_dW_dR,ndW_dR)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Roland Lindh                                           *
!               2018, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Get_Mass_All
!
!> @brief
!>   Get atomic masses from RUNFILE
!> @author Ignacio Fdez. Galn&aacute;n
!>
!> @details
!> Place atomic masses (in a.u.) into array \p Mass_All(*).
!>
!> @param[out] Mass_All   Array of masses
!> @param[in]  nAtoms_All Number of atoms
!***********************************************************************

subroutine Get_Mass_All(Mass_All,nAtoms_All)

use Symmetry_Info, only: iOper, nIrrep, Symmetry_Info_Get
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms_All
real(kind=wp), intent(out) :: Mass_All(nAtoms_All)
integer(kind=iwp) :: Active = 0, i, iChAtom, iCo, iCoSet(0:7,0:7), iGen(3), iStab(0:7), j, MaxDCR, nAtoms, nAtoms_Allx, nCoSet, &
                     nGen, nStab
real(kind=wp), allocatable :: CU(:,:), Mass(:)
integer(kind=iwp), external :: iChxyz

if (Active == 0) then
  call Symmetry_Info_Get()
  Active = 1
end if
! Obtain symmetry-unique masses
call Get_nAtoms_All(nAtoms_Allx)
if (nAtoms_All /= nAtoms_Allx) then
  write(u6,*) 'Get_Coord_All: nAtoms_All /= nAtoms_Allx'
  write(u6,*) 'nAtoms_All=',nAtoms_All
  write(u6,*) 'nAtoms_Allx=',nAtoms_Allx
  call Abend()
end if
call Get_iScalar('Unique atoms',nAtoms)
call mma_allocate(Mass,nAtoms)
call Get_Mass(Mass,nAtoms)

! Replicate masses
call mma_allocate(CU,3,nAtoms)
call Get_dArray('Unique Coordinates',CU,3*nAtoms)
nGen = 0
if (nIrrep == 2) nGen = 1
if (nIrrep == 4) nGen = 2
if (nIrrep == 8) nGen = 3
if (nGen >= 1) iGen(1) = iOper(1)
if (nGen >= 2) iGen(2) = iOper(2)
if (nGen == 3) iGen(3) = iOper(4)
MaxDCR = 0
j = 0
do i=1,nAtoms
  iChAtom = iChxyz(CU(:,i),iGen,nGen)
  call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
  nCoSet = nIrrep/nStab
  do iCo=0,nCoSet-1
    j = j+1
    Mass_all(j) = Mass(i)
  end do
end do
call mma_deallocate(CU)
call mma_deallocate(Mass)

return

end subroutine Get_Mass_All

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,1997, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE SKICKJ_LUCIA(   SKII,   CKJJ,    NKA,    NKB,  XIJKL,
     &                             NI,     NJ,     NK,     NL,   MAXK,
     &                           KBIB,  XKBIB,   KBJB,  XKBJB,  IKORD,
     &                           FACS, IROUTE)
*
*
* Calculate S(Ka,Ib,i) = FACS*S(Ka,Ib,i)
*          +SUM(j,k,l,Kb) <Ib!a+ kb!Kb><Kb!a lb !Jb>*(ij!kl)*C(Ka,Jb,j)
*
*
*
* Jeppe Olsen, Spring of 94
*
* : Note : Route 1 has retired, March 97
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION CKJJ(*)
      DIMENSION XIJKL(*)
      DIMENSION KBIB(MAXK,*),XKBIB(MAXK,*)
      DIMENSION KBJB(MAXK,*),XKBJB(MAXK,*)
*. Input and output
      DIMENSION SKII(*)
*. Scratch
#include "mxpdim.fh"
      DIMENSION XIJILS(MXPTSOB)
*. To get rid of annoying and incorrect compiler warnings
      JKINTOF = 0
      IKINTOF = 0
*
      IF(NI.GT.MXPTSOB.OR.NJ.GT.MXPTSOB.OR.NK.GT.MXPTSOB
     &   .OR.NL.GT.MXPTSOB) THEN
         WRITE(6,*) ' SKICKJ : Too many orbs : > MXPTSOB '
         WRITE(6,*) ' N, MXPTSOB ',MAX(NI,NJ,NK,NL),MXPTSOB
*         STOP ' Redim MXPTSOB '
        CALL SYSABENDMSG('lucia_util/skickj','Redim MXPTSOB',' ')
      END IF
*
      NTEST =  000
*
      IF(IROUTE.EQ.3) THEN
* S(Ka,i,Ib) = S(Ka,i,Ib) + sum(j) (ji!kl) C(Ka,j,Jb)
        DO KB = 1, NKB
*. Number of nonvanishing connections from KB
         LL = 0
         KK = 0
         DO L = 1, NL
           IF(KBJB(KB,L).NE.0) LL = LL + 1
         END DO
         DO K = 1, NK
           IF(KBIB(KB,K).NE.0) KK = KK + 1
         END DO
*
         IF(KK.NE.0.AND.LL.NE.0) THEN
           DO K = 1, NK
             IB = KBIB(KB,K)
             IF(IB.NE.0) THEN
               SGNK = XKBIB(KB,K)
               DO L = 1, NL
                 JB = KBJB(KB,L)
                 IF(NTEST.GE.100)
     &           WRITE(6,*) ' KB,K,L,IB,JB',KB,K,L,IB,JB
                 IF(JB.NE.0) THEN
                   SGNL = XKBJB(KB,L)
                   FACTOR = SGNK*SGNL
*. We have now a IB and Jb string, let's do it
                   ISOFF = (IB-1)*NI*NKA + 1
                   ICOFF = (JB-1)*NJ*NKA + 1
                   INTOF = ((L-1)*NK + K - 1 )*NI*NJ + 1
                   IMAX = NI
*
                   IF(IKORD.NE.0) THEN
*. Restrict so (ij) .le. (kl)
                     IMAX  = K
                     JKINTOF = INTOF + (K-1)*NJ
C                    CALL COPVEC(XIJKL(JKINTOF),XIJILS,NJ)
                     DO J = L,NL
                       XIJILS(J) = XIJKL(JKINTOF-1+J)
                     END DO
                     XIJKL(JKINTOF-1+L) = 0.5D0*XIJKL(JKINTOF-1+L)
                     DO J = L+1, NL
                      XIJKL(JKINTOF-1+J) = 0.0D0
                     END DO
                   END IF
C                  ONE = 1.0D0
                   CALL MATML7(SKII(ISOFF),
     &                         CKJJ(ICOFF),XIJKL(INTOF),NKA,IMAX,  NKA,
     &                              NJ,     NJ,   IMAX,   FACS,FACTOR ,
     &                               0)
                   IF(IKORD.NE.0) THEN
                      DO J = L,NL
                        XIJKL(JKINTOF-1+J) =  XIJILS(J)
                      END DO
C                    CALL COPVEC(XIJILS,XIJKL(JKINTOF),NJ)
                   END IF
*
                 END IF
               END DO
*
             END IF
           END DO
         END IF
       END DO
*. (end over loop over Kb strings )
      ELSE IF(IROUTE.EQ.2) THEN
* S(I,Ka,Ib) = S(I,Ka,Ib) + sum(j) (ij!kl) C(j,Ka,Jb)
        DO KB = 1, NKB
*. Number of nonvanishing connections from KB
         LL = 0
         KK = 0
         DO L = 1, NL
           IF(KBJB(KB,L).NE.0) LL = LL + 1
         END DO
         DO K = 1, NK
           IF(KBIB(KB,K).NE.0) KK = KK + 1
         END DO
*
         IF(KK.NE.0.AND.LL.NE.0) THEN
           DO K = 1, NK
             IB = KBIB(KB,K)
             IF(IB.NE.0) THEN
               SGNK = XKBIB(KB,K)
               DO L = 1, NL
                 JB = KBJB(KB,L)
                 IF(JB.NE.0) THEN
                   SGNL = XKBJB(KB,L)
                   FACTOR = SGNK*SGNL
*. We have now a IB and Jb string, let's do it
                   ISOFF = (IB-1)*NI*NKA + 1
                   ICOFF = (JB-1)*NJ*NKA + 1
                   INTOF = ((L-1)*NK + K - 1 )*NI*NJ + 1
*
                   IF(IKORD.NE.0) THEN
*. Restrict so (ji) .le. (kl)
                     IKINTOF = INTOF + (K-1)*NI
                     CALL COPVEC(XIJKL(IKINTOF),XIJILS,NI)
                     XIJKL(IKINTOF-1+L) = 0.5D0*XIJKL(IKINTOF-1+L)
                     DO I = L+1, NL
                      XIJKL(IKINTOF-1+I) = 0.0D0
                     END DO
                   END IF
*
C                  ONE = 1.0D0
                   CALL MATML7(SKII(ISOFF),
     &                         XIJKL(INTOF),CKJJ(ICOFF),NI,NKA, NI,
     &                              NJ,     NJ,    NKA,   FACS, FACTOR,
     &                               0)
*
                 IF(IKORD.NE.0) THEN
                   CALL COPVEC(XIJILS,XIJKL(IKINTOF),NI)
                 END IF
*
                 END IF
               END DO
             END IF
           END DO
         END IF
       END DO
*. (end over loop over Kb strings )
*

      ELSE IF (IROUTE.EQ.1) THEN
         WRITE(6,*) ' Sorry route 1 has retired, March 1997'
*         STOP'SKICKJ:Invalid route=1'
        CALL SYSABENDMSG('lucia_util/skickj','Internal error',' ')
C     DO 1000 KB = 1, NKB
*. Number of nonvanishing a+lb !Kb>
C       LL = 0
C       DO L = 1, NL
C         IF(KBJB(KB,L).NE.0) LL = LL + 1
C       END DO
*
C       IKEFF = 0
C       DO 900 K = 1, NK
C         IB = KBIB(KB,K)
C         IF(IB.EQ.0) GOTO 900
C         SGNK = XKBIB(KB,K)
*
C         IF(IKORD.EQ.0) THEN
C            LI = NI
C            IMIN = 1
C         ELSE
C            LI = NI-K+1
C            IMIN = K
C         END IF
*
C         DO 700 I = IMIN, NI
C           IKEFF = IKEFF + 1
C           IOFF = (IKEFF-1)*NJ*LL
*. Offset for S(1,IB,i)
C           IBOFF(IKEFF)  = (I-1)*NIB+IB
C           LEFF = 0
C           DO 800 L = 1, NL
C             JB = KBJB(KB,L)
C             IF(JB.EQ.0) GOTO 800
C             LEFF = LEFF + 1
C             SGNL = XKBJB(KB,L)
C             IF(IKORD.EQ.1.AND.I.EQ.K)THEN
C                FACTOR = 0.5D0*SGNK*SGNL
C             ELSE
C                FACTOR =       SGNK*SGNL
C             END IF
C             JL0 = (LEFF-1)*NJ
C             JLIK0 = (K-1)*NJ*NL*NI
C    &              + (I-1)*NJ*NL
C    &              + (L-1)*NJ
C             DO 600 J = 1, NJ
C               JL = JL0 + J
*. Offsets for C(1,JB,j)
C               JBOFF(JL) = (J-1)*NJB + JB
*. integral * signs in SCR(jl,ik)
*. Integrals are stored as (j l i k )
C               SCR((IKEFF-1)*NJ*LL+JL) = FACTOR*XIJKL(JLIK)
C               SCR(IOFF+JL) = FACTOR*XIJKL(JLIK0+J)
C 600         CONTINUE
C 800       CONTINUE
C 700     CONTINUE
C 900   CONTINUE
*
C       CALL GSAXPY_LUCIA(SKII,CKJJ,SCR,IKEFF,NJ*LL,NKA,IBOFF,JBOFF)
C1000 CONTINUE
      END IF
*. End of IROUTE branchning
*
      RETURN
      END

*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine DefW4bacd (W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,
     c                        aSGrp,bSGrp,cSGrp,dSGrp)
c
c        define W(a,b,c,d) from (ba|cd)
c
        implicit none
        integer dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp
        real*8 W(1:dima,1:dimb,1:dimc,1:dimd)
        real*8 Wx(1:abLen,1:cdLen)
c
c        help variables
        integer a,b,c,d,ba,cd
c
        if (cSGrp.eq.dSGrp) then
c        case (b,a|c=d)
          do c=2,dimc
          cd=c*(c-1)/2
          do d=1,c-1
          cd=cd+1
            ba=0
            do a=1,dima
            do b=1,dimb
            ba=ba+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ba,cd)
              W(a,b,d,c)=W(a,b,d,c)+Wx(ba,cd)
            end do
            end do
          end do
          end do
c
          do c=1,dimc
          cd=c*(c+1)/2
            ba=0
            do a=1,dima
            do b=1,dimb
            ba=ba+1
              W(a,b,c,c)=W(a,b,c,c)+Wx(ba,cd)
            end do
            end do
          end do
c
        else
c        case (b,a|c,d)
          cd=0
          do d=1,dimd
          do c=1,dimc
          cd=cd+1
            ba=0
            do a=1,dima
            do b=1,dimb
            ba=ba+1
              W(a,b,c,d)=W(a,b,c,d)+Wx(ba,cd)
            end do
            end do
          end do
          end do
c
        end if
c
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(aSGrp)
        call Unused_integer(bSGrp)
      end if
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GETINC_ABT(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                  IXCHNG,IKSM,JLSM,INTLST,IJKLOF,NSMOB,
     &                  ICOUL ,ieaw)
*
* Obtain integrals
* ICOUL = 0 :      XINT(IK,JL) = (IJ!KL) for IXCHNG = 0
*                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
* ICOUL = 1 :      XINT(IJ,KL) = (IJ!KL)
*
* Version for integrals stored in INTLST
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "detdim.fh"
#include "orbinp_mclr.fh"
      Real * 8 Intlst(*)
      Dimension IJKLof(NsmOB,NsmOb,NsmOB)
      DIMENSION XINT(*)
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      iOrb=NTSOB(ITP,ISM)
      jOrb=NTSOB(JTP,JSM)
      kOrb=NTSOB(KTP,KSM)
      lOrb=NTSOB(LTP,LSM)
      iOff=IBTSOB(ITP,ISM)
      jOff=IBTSOB(JTP,JSM)
      kOff=IBTSOB(KTP,KSM)
      lOff=IBTSOB(LTP,LSM)
*
*     Collect Coulomb terms
*
      IF(ICOUL.EQ.0) THEN
      iint=1
      Do lBas=lOff,lOff+lOrb-1
        jMin=jOff
        If ( JLSM.ne.0 ) jMin=lBas
        Do jBas=jMin,jOff+jOrb-1
          Do kBas=kOff,kOff+kOrb-1
            iMin=iOff
            If(IKSM.ne.0) iMin = kBas
            Do iBas=iMin,iOff+iOrb-1
              ij = itri(iBas,jBas)
              kl = itri(kBas,lBas)
              Sign=1.0d0
              If (ij.lt.kl.and.ieaw.ne.0) Sign=-1.0d0
              ijkl=itri(ij,kl)
              Xint(iInt) = Sign*Intlst(ijkl)
              iInt=iInt+1
            End Do
          End Do
        End Do
      End Do
*
*     Collect Exchange terms
*
      If ( IXCHNG.ne.0 ) Then
        iint=1
        Do lBas=lOff,lOff+lOrb-1
          jMin=jOff
          If ( JLSM.ne.0 ) jMin=lBas
          Do jBas=jMin,jOff+jOrb-1
            Do kBas=kOff,kOff+kOrb-1
              iMin=iOff
              If(IKSM.ne.0) iMin = kBas
              Do iBas=iMin,iOff+iOrb-1
*               jINT = (jBas-1)*nACOB**3
*    &              +(kBas-1)*nACOB**2
*    &              +(lBas-1)*nACOB
*    &              + iBas
                il = itri(iBas,lBas)
                jk = itri(jBas,kBas)
                ijkl=itri(il,jk)
                XInt(iInt)=XInt(iInt)-Intlst(ijkl)
                iInt=iInt+1
              End Do
            End Do
          End Do
        End Do
      End If
      ELSE IF(ICOUL.NE.0) THEN
        iint=1
        Do lBas=lOff,lOff+lOrb-1
          Do kBas=kOff,kOff+kOrb-1
           Do jBas=joff,jOff+jOrb-1
            Do iBas=ioff,iOff+iOrb-1
              ij = itri(iBas,jBas)
              kl = itri(kBas,lBas)
              ijkl=itri(ij,kl)
*             JINT = (LBAS-1)*nACOB**3
*    &              + (KBAS-1)*nACOB**2
*    &              + (JBAS-1)*nACOB
*    &              +  IBAS
              Xint(iInt) = Intlst(ijkl)
              iInt=iint+1
            End Do
          End Do
        End Do
      End Do
      END IF
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(IJKLOF)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_GetQD(QD)
!
! Purpose: copy qualified diagonal elements from global diagonal to
!          array QD.

use Cholesky, only: Diag_G, IndRed_G, iQuAB, nQual, nSym
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: QD(*)
integer(kind=iwp) :: iAB, iQ, iSym, kQD

kQD = 0
do iSym=1,nSym
  do iQ=1,nQual(iSym)
    iAB = IndRed_G(iQuAB(iQ,iSym),2)
    QD(kQD+iQ) = Diag_G(iAB)
  end do
  kQD = kQD+nQual(iSym)
end do

end subroutine Cho_P_GetQD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gugadrt_rst(id,nndd)
!*******************************************
! 10 may 2007 - revised by wyb

use gugadrt_global, only: iseg_downwei, iprint, iintbit, ja, ja_sys, jb, jb_sys, jc_sys, jd, jj, jm, jroute_sys, js, jt, jv, kk, &
                          lsm_inn, max_innorb, max_node, mxnode, n_ref, n16int, n32int, ng_sm, no, norb_act, norb_all, norb_dz, &
                          norb_inn, ns_sm, nu_ad
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: id, nndd
integer(kind=iwp) :: i, iabcbit, idd, iextbit, ii, iiabkm(1:n16int), iextii(n32int), iextjj(n32int), im, imd, ims, imt, it, &
                     ivalid, iysum, j, j1, j2, j3, j4, ja0, jac, jaj, jajk, jatmp, jb0, jbj, jbjk, jbtmp, jc0, jde, jds, ji, &
                     jjabkm(1:n16int), jk, jkabkm(1:n16int), jmj, jmjk, jmtmp, jp, jp0, jpe, jps, jq1, jq2, jq3, jq4, k0, kj1, &
                     kkj, kkjk, kktmp, kttmp, l, lr, mxtnode, nabcbit, nextbit, nm, node, nrefbit
logical(kind=iwp) :: flag
integer(kind=iwp), allocatable :: jabkm(:,:), ind(:,:), idjj(:,:), iwy(:,:), itm(:), noh(:)

! estimate memory
if (n_ref > 20) then
  if (norb_act >= 10) then
    if (iintbit == 32) mxtnode = 1000000
    if (iintbit == 64) mxtnode = 10000000
  else
    mxtnode = 1000000
  end if
else
  if (norb_act > 10) then
    mxtnode = 1000000
  else
    mxtnode = 500000
  end if
end if
write(u6,*)
write(u6,*) ' now generate distinct row tableau'
call mma_allocate(jabkm,n16int,mxtnode,label='jabkm')
call mma_allocate(ind,[1,n32int],[0,mxtnode],label='ind')
call mma_allocate(idjj,[1,4],[0,mxtnode],label='idjj')
call mma_allocate(iwy,[1,4],[0,mxtnode],label='iwy')
call mma_allocate(itm,[0,mxtnode],label='itm')
call mma_allocate(noh,max_innorb,label='noh')

nm = ns_sm
no(1:norb_dz+1) = 0
jabkm(1:n16int,1:mxtnode) = 0
ind(1:n32int,0:mxtnode) = 0
idjj(1:4,0:mxtnode) = 0
iwy = 0
itm = 0
nrefbit = n32int
jj(1:4,0:max_node) = 0

! 8 bits
iextbit = 2
nextbit = iintbit/iextbit
! 16 bits
iabcbit = 16
nabcbit = iintbit/iabcbit

! v node
j = 0
ja0 = ja_sys
jb0 = jb_sys
jc0 = jc_sys
write(u6,'(4(1x,i4))') ja0,jb0,jc0
! v_node
ja(1) = ja0
jb(1) = jb0
jm(1) = nm
kk(1) = norb_dz
jaj = ja(1)
jbj = jb(1)
jmj = jm(1)
kkj = kk(1)

jjabkm(1:n16int) = 0
call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
jabkm(1:n16int,1) = jjabkm(1:n16int)
ind(1:nrefbit,1) = 0

! d_node
imd = 0
do node=2,9
  imd = imd+1
  if (nu_ad(node) == 0) cycle
  ja(node) = ja(1)
  jb(node) = jb0+1
  jm(node) = imd
  kk(node) = norb_dz
  jaj = ja(node)
  jbj = jb(node)
  jmj = jm(node)
  kkj = kk(node)

  jjabkm(1:n16int) = 0
  call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
  jabkm(1:n16int,node) = jjabkm(1:n16int)
  ind(1:nrefbit,node) = 0
end do

! t_node
imt = 0
do node=10,17
  imt = imt+1
  if (nu_ad(node) == 0) cycle
  ja(node) = ja(1)
  jb(node) = jb0+2
  jm(node) = imt
  kk(node) = norb_dz
  jaj = ja(node)
  jbj = jb(node)
  jmj = jm(node)
  kkj = kk(node)

  jjabkm(1:n16int) = 0
  call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
  jabkm(1:n16int,node) = jjabkm(1:n16int)
  ind(1:nrefbit,node) = 0
end do
! s_node
ims = 0
do node=18,25
  ims = ims+1
  if (nu_ad(node) == 0) cycle
  ja(node) = ja(1)+1
  jb(node) = jb0
  jm(node) = ims
  kk(node) = norb_dz
  jaj = ja(node)
  jbj = jb(node)
  jmj = jm(node)
  kkj = kk(node)
  jjabkm(1:n16int) = 0
  call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
  jabkm(1:n16int,node) = jjabkm(1:n16int)
  ind(1:nrefbit,node) = 0
end do
if (jroute_sys > 1) then
  ! d'_node
  imd = 0
  do node=26,33
    imd = imd+1
    if (nu_ad(node) == 0) cycle
    ja(node) = ja(1)+1
    jb(node) = jb0-1
    jm(node) = imd
    kk(node) = norb_dz
    jaj = ja(node)
    jbj = jb(node)
    jmj = jm(node)
    kkj = kk(node)
    jjabkm(1:n16int) = 0
    call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
    jabkm(1:n16int,node) = jjabkm(1:n16int)
    ind(1:nrefbit,node) = 0
  end do
end if
if (jroute_sys > 2) then
  ! t'_node
  imt = 0
  do node=34,41
    imt = imt+1
    if (nu_ad(node) == 0) cycle
    ja(node) = ja(1)+2
    jb(node) = jb0-2
    jm(node) = imt
    kk(node) = norb_dz
    jaj = ja(node)
    jbj = jb(node)
    jmj = jm(node)
    kkj = kk(node)
    jjabkm(1:n16int) = 0
    call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
    jabkm(1:n16int,node) = jjabkm(1:n16int)
    ind(1:nrefbit,node) = 0
  end do
end if
no(norb_dz) = mxnode

j = 0
jk = mxnode
kk(jk) = norb_dz
!call packnod(idkk,jk,norb_dz,nabcbit,iabcbit,mxtnode)

!**********************************************************************

do
  j = j+1
  if (j <= mxnode) then
    if (nu_ad(j) == 0) cycle
  end if
  if (j < mxnode) then
    jaj = ja(j)
    jbj = jb(j)
    jmj = jm(j)
    kkj = kk(j)
    k0 = kkj
  else
    jjabkm(1:n16int) = jabkm(1:n16int,j)
    call redabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
    k0 = kkj
  end if
  jkabkm(1:n16int) = jabkm(1:n16int,jk)
  call redabkm(jkabkm,n16int,nabcbit,iabcbit,jajk,jbjk,jmjk,kkjk)
  if (kkjk /= k0+1) no(k0) = jk
  jk = jk+1

  if (jk > mxtnode) then
    write(u6,*) ' the number of j exceeds mxtnode',mxtnode
    call abend()
    !call errexit(777)
  end if
  !=========================================================
  ! ***********
  ! *   d=0   *
  ! ***********

  jatmp = jaj
  jbtmp = jbj
  jmtmp = jmj
  kktmp = kkj+1

  iextjj(1:nrefbit) = ind(1:nrefbit,j)
  call gugadrt_njexcit(iextjj,nrefbit,iextbit,nextbit,ivalid,0,kttmp,k0)

  flag = .false.
  if (ivalid == 0) then
    jk = jk-1
    flag = .true.
  else if (k0 == norb_inn-1) then
    ! act||ext
    if (((jatmp == 1) .or. (jbtmp == 2)) .and. (kttmp /= 0)) then
      jk = jk-1
      flag = .true.
    else if ((jbtmp == 1) .and. (kttmp == 2)) then
      jk = jk-1
      flag = .true.
    end if
  end if

  if (.not. flag) then
    call wrtabkm(jkabkm,n16int,nabcbit,iabcbit,jatmp,jbtmp,jmtmp,kktmp)
    outer_1: do ii=no(k0)+1,jk-1
      iiabkm(1:n16int) = jabkm(1:n16int,ii)
      do i=1,n16int
        if (iiabkm(i) /= jkabkm(i)) cycle outer_1
      end do
      if (k0 /= norb_inn-1) then
        iextii(1:nrefbit) = ind(1:nrefbit,ii)
        do i=1,nrefbit
          if (iextii(i) /= iextjj(i)) cycle outer_1
        end do
      end if
      jk = jk-1
      idjj(1,j) = ii
      flag = .true.
      if (flag) exit
    end do outer_1
  end if

  if (.not. flag) then
    ind(1:nrefbit,jk) = iextjj(1:nrefbit)
    idjj(1,j) = jk
    jabkm(1:n16int,jk) = jkabkm(1:n16int)

    iiabkm(1:n16int) = jabkm(1:n16int,jk-1)
    call upacknod(iiabkm,4,kj1,nabcbit,iabcbit,n16int)
    if (kktmp /= kj1) no(k0) = jk-1
  end if

  ! =========================================================
  if (jbj /= 0) then
    jk = jk+1
    ! ***********
    ! *   d=1   *
    ! ***********
    jatmp = jaj
    jbtmp = jbj-1
    jmtmp = Mul(lsm_inn(k0+1),jmj)
    kktmp = kkj+1

    iextjj(1:nrefbit) = ind(1:nrefbit,j)
    call gugadrt_njexcit(iextjj,nrefbit,iextbit,nextbit,ivalid,1,kttmp,k0)

    flag = .false.
    if (ivalid == 0) then
      jk = jk-1
      flag = .true.
    else if (k0 == norb_inn-1) then
      ! act||ext
      if (((jatmp == 1) .or. (jbtmp == 2)) .and. (kttmp /= 0)) then
        jk = jk-1
        flag = .true.
      else if ((jbtmp == 1) .and. (kttmp == 2)) then
        jk = jk-1
        flag = .true.
      end if
    end if

    if (.not. flag) then
      call wrtabkm(jkabkm,n16int,nabcbit,iabcbit,jatmp,jbtmp,jmtmp,kktmp)
      outer_2: do ii=no(k0)+1,jk-1
        iiabkm(1:n16int) = jabkm(1:n16int,ii)
        do i=1,n16int
          if (iiabkm(i) /= jkabkm(i)) cycle outer_2
        end do
        if (k0 /= norb_inn-1) then
          iextii(1:nrefbit) = ind(1:nrefbit,ii)
          do i=1,nrefbit
            if (iextii(i) /= iextjj(i)) cycle outer_2
          end do
        end if
        jk = jk-1
        idjj(2,j) = ii
        flag = .true.
        if (flag) exit
      end do outer_2
    end if

    if (.not. flag) then
      ind(1:nrefbit,jk) = iextjj(1:nrefbit)
      idjj(2,j) = jk
      jabkm(1:n16int,jk) = jkabkm(1:n16int)

      iiabkm(1:n16int) = jabkm(1:n16int,jk-1)
      call upacknod(iiabkm,4,kj1,nabcbit,iabcbit,n16int)
      if (kktmp /= kj1) no(k0) = jk-1
    end if
  end if
  ! =========================================================
  jac = norb_all-jaj-jbj
  if (jaj > 0) then
    if (jac /= 0) then
      jk = jk+1
      ! *************
      ! *    d=2    *
      ! *************
      jatmp = jaj-1
      jbtmp = jbj+1
      jmtmp = Mul(lsm_inn(k0+1),jmj)
      kktmp = kkj+1

      iextjj(1:nrefbit) = ind(1:nrefbit,j)
      call gugadrt_njexcit(iextjj,nrefbit,iextbit,nextbit,ivalid,2,kttmp,k0)

      flag = .false.
      if (ivalid == 0) then
        jk = jk-1
        flag = .true.
      else if (k0 == norb_inn-1) then
        ! act||ext
        if (((jatmp == 1) .or. (jbtmp == 2)) .and. (kttmp /= 0)) then
          jk = jk-1
          flag = .true.
        else if ((jbtmp == 1) .and. (kttmp == 2)) then
          jk = jk-1
          flag = .true.
        end if
      end if

      if (.not. flag) then
        call wrtabkm(jkabkm,n16int,nabcbit,iabcbit,jatmp,jbtmp,jmtmp,kktmp)
        outer_3: do ii=no(k0)+1,jk-1
          iiabkm(1:n16int) = jabkm(1:n16int,ii)
          do i=1,n16int
            if (iiabkm(i) /= jkabkm(i)) cycle outer_3
          end do
          if (k0 /= norb_inn-1) then
            iextii(1:nrefbit) = ind(1:nrefbit,ii)
            do i=1,nrefbit
              if (iextii(i) /= iextjj(i)) cycle outer_3
            end do
          end if
          jk = jk-1
          idjj(3,j) = ii
          flag = .true.
          if (flag) exit
        end do outer_3
      end if

      if (.not. flag) then
        ind(1:nrefbit,jk) = iextjj(1:nrefbit)
        idjj(3,j) = jk
        jabkm(1:n16int,jk) = jkabkm(1:n16int)

        iiabkm(1:n16int) = jabkm(1:n16int,jk-1)
        call upacknod(iiabkm,4,kj1,nabcbit,iabcbit,n16int)
        if (kktmp /= kj1) no(k0) = jk-1
      end if
    end if
    ! =========================================================
    ! ************
    ! *    d=3   *
    ! ************

    jk = jk+1
    jatmp = jaj-1
    jbtmp = jbj
    jmtmp = jmj
    kktmp = kkj+1

    iextjj(1:nrefbit) = ind(1:nrefbit,j)
    call gugadrt_njexcit(iextjj,nrefbit,iextbit,nextbit,ivalid,3,kttmp,k0)

    flag = .false.
    if (ivalid == 0) then
      jk = jk-1
      flag = .true.
    else if (k0 == norb_inn-1) then
      ! act||ext
      if (((jatmp == 1) .or. (jbtmp == 2)) .and. (kttmp /= 0)) then
        jk = jk-1
        flag = .true.
      else if ((jbtmp == 1) .and. (kttmp == 2)) then
        jk = jk-1
        flag = .true.
      end if
    end if

    if (.not. flag) then
      call wrtabkm(jkabkm,n16int,nabcbit,iabcbit,jatmp,jbtmp,jmtmp,kktmp)
      outer_4: do ii=no(k0)+1,jk-1
        iiabkm(1:n16int) = jabkm(1:n16int,ii)
        do i=1,n16int
          if (iiabkm(i) /= jkabkm(i)) cycle outer_4
        end do
        if (k0 /= norb_inn-1) then
          iextii(1:nrefbit) = ind(1:nrefbit,ii)
          do i=1,nrefbit
            if (iextii(i) /= iextjj(i)) cycle outer_4
          end do
        end if
        jk = jk-1
        idjj(4,j) = ii
        flag = .true.
        if (flag) exit
      end do outer_4
    end if

    if (.not. flag) then
      ind(1:nrefbit,jk) = iextjj(1:nrefbit)
      idjj(4,j) = jk
      jabkm(1:n16int,jk) = jkabkm(1:n16int)

      iiabkm(1:n16int) = jabkm(1:n16int,jk-1)
      call upacknod(iiabkm,4,kj1,nabcbit,iabcbit,n16int)
      if (kktmp /= kj1) no(k0) = jk-1
    end if
  end if
  !===========================================================
  if (k0 > norb_inn-1) exit
end do

!if(iprint == 1) then
!  open(100,file='tmp.dat')
!  do i=1,jk
!    jkabkm(1:n16int)=jabkm(1:n16int,i)
!    call redabkm(jkabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
!    j1 = idjj(1,i)
!    j2 = idjj(2,i)
!    j3 = idjj(3,i)
!    j4 = idjj(4,i)
!    write(100,'(5(1x,i8))') i,j1,j2,j3,j4
!  end do
!  close(100)
!end if
!write(u6,'(10(1x,i5))') no(1:norb_all)
write(u6,*)
!************** external space  *************
id = no(norb_inn)
!write(u6,508) 'befor,no=',(no(i),i=norb_dz,norb_inn)
do idd=no(norb_inn-1)+1,id
  jjabkm(1:n16int) = jabkm(1:n16int,idd)
  call redabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
  if ((jaj == 0) .and. (jbj == 0) .and. (jmj == 1)) jv = idd
  if ((jaj == 0) .and. (jbj == 1)) then
    do i=1,ng_sm
      if (jmj == i) then
        jd(i) = idd
      end if
    end do
  end if
  if ((jaj == 0) .and. (jbj == 2)) then
    do i=1,ng_sm
      if (jmj == i) then
        jt(i) = idd
      end if
    end do
  end if
  if ((jaj == 1) .and. (jbj == 0)) then
    do i=1,ng_sm
      if (jmj == i) then
        js(i) = idd
      end if
    end do
  end if
end do

iwy(1,jv) = 1
do im=1,ng_sm
  if ((jd(im) /= 0) .and. (iseg_downwei(1+im) /= 0)) iwy(1,jd(im)) = 1
  if ((jt(im) /= 0) .and. (iseg_downwei(9+im) /= 0)) iwy(1,jt(im)) = 1
  if ((js(im) /= 0) .and. (iseg_downwei(17+im) /= 0)) iwy(1,js(im)) = 1
end do

iwy(1:4,0) = 0
do l=norb_inn-1,norb_dz,-1
  jps = no(l-1)+1
  jpe = no(l)
  do jde=jps,jpe
    j1 = idjj(1,jde)
    j2 = idjj(2,jde)
    j3 = idjj(3,jde)
    j4 = idjj(4,jde)
    iwy(1,jde) = iwy(1,j1)+iwy(1,j2)+iwy(1,j3)+iwy(1,j4)
    if (iwy(1,jde) == 0) then
      do jp0=no(l-2)+1,no(l-1)
        if (idjj(1,jp0) == jde) idjj(1,jp0) = 0
        if (idjj(2,jp0) == jde) idjj(2,jp0) = 0
        if (idjj(3,jp0) == jde) idjj(3,jp0) = 0
        if (idjj(4,jp0) == jde) idjj(4,jp0) = 0
      end do
      cycle
    end if
    if ((j2 /= 0) .and. (iwy(1,j2) /= 0)) iwy(2,jde) = iwy(1,j1)
    if ((j3 /= 0) .and. (iwy(1,j3) /= 0)) iwy(3,jde) = iwy(1,j1)+iwy(1,j2)
    if ((j4 /= 0) .and. (iwy(1,j4) /= 0)) iwy(4,jde) = iwy(1,jde)-iwy(1,j4)
    if (jde == 1) cycle
    do jp=jps,jde-1
      if (iwy(1,jp) /= iwy(1,jde)) cycle
      jq1 = idjj(1,jp)
      jq2 = idjj(2,jp)
      jq3 = idjj(3,jp)
      jq4 = idjj(4,jp)
      if ((j1 == jq1) .and. (j2 == jq2) .and. (j3 == jq3) .and. (j4 == jq4)) then
        iwy(1,jde) = 0
        do jp0=no(l-2)+1,no(l-1)
          if (idjj(1,jp0) == jde) idjj(1,jp0) = jp
          if (idjj(2,jp0) == jde) idjj(2,jp0) = jp
          if (idjj(3,jp0) == jde) idjj(3,jp0) = jp
          if (idjj(4,jp0) == jde) idjj(4,jp0) = jp
        end do
        exit
      end if
    end do
  end do
end do

it = mxnode
itm(1) = 1
noh = 0
noh(norb_dz) = mxnode
do lr=norb_dz,norb_inn-1
  do jp=no(lr)+1,no(lr+1)
    itm(jp) = 0
    if (iwy(1,jp) /= 0) then
      it = it+1
      itm(jp) = it
    end if
  end do
  noh(lr+1) = it
end do

do jpe=1,mxnode
  if (nu_ad(jpe) == 0) cycle
  jj(1,jpe) = idjj(1,jpe)
  jj(2,jpe) = idjj(2,jpe)
  jj(3,jpe) = idjj(3,jpe)
  jj(4,jpe) = idjj(4,jpe)
end do

do jpe=mxnode+1,id
  jp = itm(jpe)
  if (jp == 0) cycle
  j1 = idjj(1,jpe)
  j2 = idjj(2,jpe)
  j3 = idjj(3,jpe)
  j4 = idjj(4,jpe)
  jjabkm(1:n16int) = jabkm(1:n16int,jpe)
  call redabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
  l = kkj
  jds = noh(l-2)+1
  jde = noh(l-1)
  do jp0=jds,jde
    if (jj(1,jp0) == jpe) jj(1,jp0) = jp
    if (jj(2,jp0) == jpe) jj(2,jp0) = jp
    if (jj(3,jp0) == jpe) jj(3,jp0) = jp
    if (jj(4,jp0) == jpe) jj(4,jp0) = jp
  end do
  ja(jp) = jaj
  jb(jp) = jbj
  jm(jp) = jmj
  kk(jp) = kkj
  do i=1,4
    iwy(i,jp) = iwy(i,jpe)
    ji = idjj(i,jpe)
    if (itm(ji) /= 0) then
      jj(i,jp) = ji
    end if
  end do
end do

!open(10,file='rst.out')
no(norb_dz) = 0
no(norb_dz+1) = mxnode
!write(u6,*) '   end of rst, drt ..........'
!write(u6,'(2x,2i10)')norb_dz+1,no(norb_dz+1)
do lr=norb_dz+1,norb_inn
  no(lr+1) = noh(lr)
end do
jv = itm(jv)
itm(0) = 0
do im=1,8
  jd(im) = itm(jd(im))
  jt(im) = itm(jt(im))
  js(im) = itm(js(im))
end do
iysum = 0
do j=1,mxnode
  iysum = iysum+iwy(1,j)
end do
id = it
if (it /= no(norb_inn+1)) then
  write(u6,*) '   rst id is wrong!!   no(norb_inn)=',no(norb_inn),it
  call abend()
end if

write(u6,*)
!iprint=1
if (iprint == 1) then
  write(u6,*) 'guga drt'
  write(u6,506)
end if
nndd = no(norb_inn)
do j=1,id
  kk(j) = kk(j)+1
  if (iprint == 1) write(u6,510) j,kk(j),ja(j),jb(j),jm(j),jj(1,j),jj(2,j),jj(3,j),jj(4,j)
end do
write(u6,*)
write(u6,*) 'end of rst, drt ..........'

call mma_deallocate(jabkm)
call mma_deallocate(ind)
call mma_deallocate(idjj)
call mma_deallocate(iwy)
call mma_deallocate(itm)
call mma_deallocate(noh)

!open(21,file='fort.drt',form='unformatted')
!write(21) id
!write(21) ja(1:id),jb(1:id),jm(1:id)
!write(21) jj(1:4,0:id)
!write(21) kk(0:id)
!write(21) no(0:norb_inn+1)
!write(21) jv,jd(1:8),jt(1:8),js(1:8)
!close(21)

call writedrt(id)

return

506 format('          j       k       a       b      jm      j0      j1      j2      j3')
!508 format(3x,a10,1x,i5,1x,16i8)
510 format(3x,9(1x,i7))

end subroutine gugadrt_rst

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018, Jesper Norell                                    *
*               2018, Joel Creutzberg                                  *
************************************************************************

!     Subroutine to correctly bunch together spin-free Dyson orbitals
!     and pass them to the molden_dysorb interface for .molden export

      SUBROUTINE WRITEDYS(DYSAMPS,SFDYS,NZ,ENERGY)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "rassi.fh"
#include "prgm.fh"
#include "symmul.fh"
#include "Files.fh"

      INTEGER   NZ,ORBNUM
      INTEGER   DYSCIND
      INTEGER   NDUM

      DIMENSION DYSAMPS(NSTATE,NSTATE)
      DIMENSION SFDYS(NZ,NSTATE,NSTATE)
      DIMENSION ENERGY(NSTATE)
      DIMENSION DYSEN(NSTATE)
      DIMENSION AMPS(NSTATE)
      DIMENSION CMO(NZ*NSTATE)

      Character*30 Filename

!+++  J. Creutzberg, J. Norell  - 2018 (.molden export )

! In principle we should here take into account the diagonalization
! matrix from RASSCF. This will only rarely be needed for regular
! Dyson calculations so we will leave it out for now.

      DO JSTATE=1,DYSEXPSF

!     For each initial state JSTATE up to DYSEXPSF we will gather all the obtained Dysorbs
!     and export to a shared .molden file
         DYSCIND=0 ! Orbital coeff. index
         ORBNUM=0 ! Dysorb index for given JSTATE
         CMO=0.0D0 ! Orbital coefficients
         DYSEN=0.0D0 ! Orbital energies
         AMPS=0.0D0 ! Transition amplitudes (shown as occupations)

         DO ISTATE=JSTATE+1,NSTATE

         IF (DYSAMPS(JSTATE,ISTATE).GT.1.0D-5) THEN
          DO NDUM=1,NZ
             DYSCIND=DYSCIND+1
             CMO(DYSCIND)=SFDYS(NDUM,ISTATE,JSTATE)
          END DO
          ORBNUM=ORBNUM+1
          DYSEN(ORBNUM)=ENERGY(ISTATE)-ENERGY(JSTATE)
          AMPS(ORBNUM)=DYSAMPS(JSTATE,ISTATE)*DYSAMPS(JSTATE,ISTATE)
         END IF

       END DO ! ISTATE

! If at least one orbital was found, export it/them
        IF(ORBNUM.GT.0) THEN
         Write(filename,'(A16,I0)') 'Dyson.SF.molden.',JSTATE
         Call Molden_DysOrb(0,filename,DYSEN,AMPS,CMO,ORBNUM,NZ)
        END IF

      END DO ! JSTATE

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Move_EC(rMP,EC,Scratch_New,Scratch_Org,xrMP,xxrMP,
     &                   xnrMP,lMax,A,B,nij,nElem,Coor,nAtoms,Q_Nuc,
     &                   C_o_C,nPert,Bond_Threshold,iANr,T_Values,
     &                   iT_Sets,iWarnings,Num_Warnings,Opt_Method,
     &                   iPlot,iPrint)
       use Real_Spherical
       Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "stdalloc.fh"
#include "status.fh"
      Real*8 rMP(nij,0:nElem-1,0:nPert-1), EC(3,nij)
      Real*8 Scratch_Org(nij*(2+lMax+1))
      Real*8 Scratch_New(nij*(2+lMax+1)), xrMP(nij,nElem),C_o_C(3)
      Real*8 xxrMP(nij,nElem),T_Values(nij)
      Real*8 xnrMP(nij,nElem),Coor(3,nAtoms),CX(3),Q_Nuc(nAtoms)
      Real*8 A(3,nij),B(3,nij)
      Logical Bond_OK, Check_Bond
      Character*12  Opt_Method
      Integer iAnr(nAtoms),iT_Sets(nij), iWarnings(nij)
C      Parameter (mxAtoms=500)
*
      Call Sphere(lMax)
*
      call dcopy_(3*nij,[Zero],0,B,1)
*
      iDim = nij*nElem
      Call dCopy_(nij*nElem,[Zero],0,xnrMP,1)
      ij = 0
      Do iAtom = 1, nAtoms
         Do jAtom = 1, iAtom
            ij = ij + 1
            If (iAtom.eq.jAtom) Then
               xnrMP(ij,1)=Q_nuc(iAtom)
               CX(1)=Coor(1,iAtom)
               CX(2)=Coor(2,iAtom)
               CX(3)=Coor(3,iAtom)
               Call ReExpand(xnrMP,nij,nElem,CX,C_o_C,ij,lMax)
            End If
         End Do
      End Do
*
      iPrint_Errors  = 0
      Do iAtom = 1, nAtoms
         ii = iAtom*(iAtom+1)/2
         Do jAtom = iAtom, 1, -1
            jj = jAtom*(jAtom+1)/2
            ij = iAtom*(iAtom-1)/2+jAtom
            call dcopy_(3*nij,EC,1,A,1)
*
            If (iAtom.eq.jAtom) Then
*--------------Atomic domain
C Do nothing for now - put appropriate expresion in later.
                  iT_sets(ij)  = 1
                  T_values(ij) = 0.0D0
                  B(1,ij) = EC(1,ij)
                  B(2,ij) = EC(2,ij)
                  B(3,ij) = EC(3,ij)
C??               End If
            Else
*--------------Bond domain
*
* --- Check whether bond is too long - if so skip it.
*
               Bond_OK = Check_Bond(EC(1,ii),EC(1,jj),iANr(iAtom),
     &                              iANr(jAtom),Bond_Threshold)
               If (.Not. Bond_OK) Then
                  T_values(ij) = 0.0D0
                  B(1,ij) = EC(1,ij)
                  B(2,ij) = EC(2,ij)
                  B(3,ij) = EC(3,ij)
               Else
*
* --- Bond is real bond - proceed
*
                  iT_sets(ij) = 1
                  If (Opt_Method(1:9) .eq. 'Multipole') Then
                     Call Rotate_Dipole(rMP,EC,nij,nElem,nPert,ij,ii,jj,
     &                          Dipole_Rot_A,Dipole_Rot_B,Dipole_Rot_AB,
     &                          R_A,R_B)
*
                     Call Find_Dipole_Center(rMP(ii,0,0),rMP(jj,0,0),
     &                        Dipole_Rot_A,Dipole_Rot_B,xnrMP(ii,1),
     &                        xnrMP(jj,1),R_A,R_B,EC(1,ii),EC(1,jj),
     &                        EC(1,ij),T_Values(ij),iPlot)
*
                     B(1,ij) = EC(1,ij)+T_Values(ij)*(EC(1,jj)-EC(1,ii))
                     B(2,ij) = EC(2,ij)+T_Values(ij)*(EC(2,jj)-EC(2,ii))
                     B(3,ij) = EC(3,ij)+T_Values(ij)*(EC(3,jj)-EC(3,ii))
                  Else
                     Call Min_Mult_Error(EC,A,B,EC(1,ii),EC(1,jj),rMP,
     &                                xrMP,xxrMP,xnrMP,lMax,
     &                                nij,nElem,iAtom,jAtom,nAtoms,
     &                                nPert,C_o_C,Scratch_New,
     &                                Scratch_Org,iPlot,T_Values,
     &                                iWarnings,Num_Warnings)
                  End If
               End If
*
            End If
         End Do
      End Do
*
      Do ij = 1,nij
         Do iPert = 0, nPert-1
            Call ReExpand(rMP(1,0,iPert),nij,nElem,EC(1,ij),
     &                    B(1,ij),ij,lMax)
         End Do
      End Do
      call dcopy_(3*nij,B,1,EC,1)
*
      Call Sphere_Free()
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iPrint)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKNSM_m
C     PUPROSE: CREATE THE SYMMETRY INDEX VECTOR
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
C
      NLEV=0
      DO IGAS=1,NGAS
        DO ISYM=1,NSYM
          NSTA=NLEV+1
          NLEV=NLEV+NGSSH(IGAS,ISYM)
          DO LEV=NSTA,NLEV
            NSM(LEV)=ISYM
          END DO
        END DO
      END DO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Anders Bernhardsson                              *
!***********************************************************************

subroutine Dens_IF(i_root,CA,CB,OCCA,OCCB)
! A small stupid interface for creating the alpha and beta
! occupation numbers and corresponding molecular orbitals,
! used in MOLDEN.
!
! EAW 990118

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: i_root
real(kind=wp), intent(_OUT_) :: CA(*), CB(*), OCCA(*), OCCB(*)
integer(kind=iwp) :: i, iA, iAC, iAC2, iad15, ii, IMO, IOCC, ip, ip1, ip2, iS, J, nAct
real(kind=wp) :: Dum(1), OCCNO
real(kind=wp), allocatable :: AM1(:,:), AM2(:,:), C(:), DA(:), DB(:), DS(:), DT(:), Unity(:), VB(:,:)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "casvb.fh"

call mma_allocate(DS,NACPAR,label='DS')
call mma_allocate(DT,NACPAR,label='DT')
call mma_allocate(DA,NACPAR,label='DA')
call mma_allocate(DB,NACPAR,label='DB')
call mma_allocate(C,NTOT2,label='C')
call mma_allocate(Unity,NAC*NAC,label='UNITY')

! READ IN ORBITALS
! Averaged...
if (iOrbTyp /= 2) iad15 = IADR15(2)
! Canonical...
if (iOrbTyp == 2) iad15 = IADR15(9)

! Read-in orbitals from Jobiph following instructions from previous lines...
call DDAFile(JOBIPH,2,C,NTOT2,IAD15)

! COEN WANTED IT AS A BLOCKED MATRIX, SO HERE THEY COME...
ip1 = 1
ip2 = 1
CA(:nTOT**2) = Zero
CB(:nTOT**2) = Zero
do iS=1,nSym
  do i=1,nbas(is)
    call dcopy_(nbas(is),C(ip1),1,CA(ip2),1)
    call dcopy_(nbas(is),C(ip1),1,CB(ip2),1)
    ip1 = ip1+nbas(is)
    ip2 = ip2+NTOT
  end do
  ip2 = ip2+nbas(is)
end do

! --- FOLLOWING FOR STANDARD (PSEUDO/AVERAGED/CANONICAL) ORBITALS ---
if (i_root == 0) then
  ! Averaged...
  if (iOrbTyp /= 2) then
    ! SIMPLY READ OCC NOS AS ALPHAS AND ZERO BETA OCC NOS
    iad15 = IADR15(2)
    Dum(1) = Zero
    call DDAFile(JOBIPH,0,Dum,NTOT2,IAD15)
    call DDAFILE(JOBIPH,2,OCCA,NTOT,IAD15)
    OCCB(:nTOT) = Zero
  end if
  ! Canonical...
  if (iOrbTyp == 2) then
    ! SIMPLY ZERO ALPHA and BETA OCC NOS
    OCCA(:nTOT) = Zero
    OCCB(:nTOT) = Zero
  end if

  if (IFVB /= 0) then
    call mma_allocate(VB,NAC,NAC,label='VB')
    call getvb2mo_cvb(VB)
    call mma_allocate(AM1,NTOT,NAC,label='ACTMO1')
    call mma_allocate(AM2,NTOT,NAC,label='ACTMO2')
    ! Gather active MOs ...
    ! Also count no of active electrons ...
    iAC = 1
    IMO = 1
    IOCC = 1
    OCCNO = Zero
    nAct = 0
    do iS=1,nSym
      call dcopy_(nTOT*nash(is),CA((NISH(iS)+NFRO(IS))*NTOT+IMO),1,AM1(:,IAC:IAC+NASH(iS)-1),1)
      do J=0,NASH(IS)-1
        OCCNO = OCCNO+OCCA(J+NISH(IS)+NFRO(IS)+IOCC)
      end do
      nAct = nAct+NASH(iS)
      IAC = IAC+NASH(iS)
      IMO = IMO+nBas(is)*ntot
      IOCC = IOCC+NBAS(iS)
    end do

    call DGEMM_('N','N',NTOT,NAC,NAC,One,AM1,NTOT,VB,NAC,Zero,AM2,NTOT)

    ! Scatter active MOs ...
    ! Also reset active occ nos - we choose nel/nact since that
    ! gives as much meaning as anything ...

    iAC = 1
    IMO = 1
    IOCC = 1
    do iS=1,nSym
      call dcopy_(nTOT*nash(is),AM2(:,IAC:IAC+NASH(iS)-1),1,CA((NISH(iS)+NFRO(IS))*NTOT+IMO),1)
      call dcopy_(nash(is),[OCCNO/real(nAct,kind=wp)],0,OCCA(NISH(iS)+NFRO(IS)+IOCC),1)
      IAC = IAC+NASH(iS)
      IMO = IMO+nBas(is)*ntot
      IOCC = IOCC+NBAS(iS)
    end do
    call mma_deallocate(VB)
    call mma_deallocate(AM1)
    call mma_deallocate(AM2)
  end if

else
!                                                                      *
!***********************************************************************
!                                                                      *
! --- FOLLOWING FOR NATURAL *SPIN* ORBITALS ---
!
! READ IN DENSITIES

  iad15 = IADR15(3)
  Dum(1) = Zero
  do i=1,i_root
    call DDAFile(JOBIPH,2,DS,NACPAR,IAD15)
    call DDAFile(JOBIPH,2,DT,NACPAR,IAD15)
    call DDAFile(JOBIPH,0,Dum,NACPR2,IAD15)
    call DDAFile(JOBIPH,0,Dum,NACPR2,IAD15)
  end do

  ! CREATE SPIN DENSITIES

  DA(:) = Half*(DS(:)+DT(:))
  DB(:) = Half*(DS(:)-DT(:))

  ! DIAGONALIZE THE SPIN DENSITIES

  ! FIRST ALPHA

  Unity(:) = Zero
  call dcopy_(nac,[One],0,Unity,nac+1)
  call Jacob(DA,UNITY,NAC,NAC)

  ! TRANSFORM THE ACTIVE ORBITALS

  iAC = 1
  iAC2 = 1
  ip = 1
  do iS=1,nSym
    if (nBas(iS) /= 0) then
      ip = ip+nBas(iS)*nIsh(iS)
      iAC2 = iAC2+nish(is)*nTot
      if (NASH(IS) > 0) call DGEMM_('N','N',NBAS(IS),NASH(IS),NASH(IS),One,C(ip),NBAS(IS),UNITY(IAC),NAC,Zero,CA(iAC2),NTOT)
      iAC = iAC+NASH(IS)*NAC+NASH(IS)
      iAC2 = iAC2+(nbas(is)-nish(is))*NTOT+nbas(is)
      ip = ip+nbas(is)*(nbas(is)-nish(is))
    end if
  end do

  ! COPY OCCUPATION NUMBERS

  ip = 1
  i = 0
  ii = 0
  do iS=1,nSYM
    OCCA(ip:ip+nBAS(is)-1) = Zero
    call dcopy_((nFro(is)+nish(is)),[One],0,OCCA(ip),1)
    ip = ip+nFro(is)+nish(is)
    do iA=1,nash(is)
      ii = ii+1
      i = i+ii
      OCCA(ip) = DA(i)
      ip = ip+1
    end do
    ip = ip+nbas(is)-nFro(is)-nish(is)-nash(is)
  end do

  ! THEN ONCE AGAIN FOR BETA....

  Unity(:) = Zero
  call dcopy_(nac,[One],0,Unity,nac+1)

  call Jacob(DB,UNITY,NAC,NAC)

  iAC = 1
  iAC2 = 1
  ip = 1
  do iS=1,nSym
    if (nbas(is) /= 0) then
      ip = ip+nBas(is)*nIsh(is)
      iAC2 = iAC2+nish(is)*NTOT
      if (NASH(IS) > 0) call DGEMM_('N','N',NBAS(IS),NASH(IS),NASH(IS),One,C(ip),NBAS(IS),UNITY(IAC),NAC,Zero,CB(iac2),NTOT)
      iAC = iAC+NASH(IS)*NAC+NASH(IS)
      iAC2 = iAC2+(nbas(is)-nish(is))*NTOT+nbas(is)
      ip = ip+nbas(is)*(nbas(is)-nish(is))
    end if
  end do

  ip = 1
  i = 0
  ii = 0
  do iS=1,nSYM
    OCCB(ip:ip+nBAS(is)-1) = Zero
    call dcopy_((nFro(is)+nish(is)),[One],0,OCCB(ip),1)
    ip = ip+nFro(is)+nish(is)
    do iA=1,nash(is)
      ii = ii+1
      i = i+ii
      OCCB(ip) = DB(i)
      ip = ip+1
    end do
    ip = ip+nbas(is)-nFro(is)-nish(is)-nash(is)
  end do
end if

! OK, CLEAN UP

call mma_deallocate(DS)
call mma_deallocate(DT)
call mma_deallocate(DA)
call mma_deallocate(DB)
call mma_deallocate(C)
call mma_deallocate(Unity)

return

end subroutine Dens_IF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Wr_Prop(nAtoms,nCenters,nBas,nMltPl,NOCOB,NOCOB_b,
     &           orbe,orbe_b,iPol,LAllCenters)

      IMPLICIT REAL*8 (A-H,O-Z)

      Character*8 MemLabel
      Dimension iCompMat(0:nMltPl,0:nMltPl,0:nMltPl)
      Dimension orbe(NOCOB)
      Dimension orbe_b(NOCOB_b)
      Logical   LAllCenters

#include "MpParam.fh"
#include "WrkSpc.fh"
#include "Address.fh"
#include "MolProp.fh"


      nTotCen=0
      Do i=1,nAtoms
         nTotCen=nTotCen+1
         WRITE(CEN_LAB(i*(i+1)/2),'(A)') Labe(i)
         Do j=1,i
            If(BondMat(i,j)) Then
              nTotCen=nTotCen+1
              WRITE(CEN_LAB(i*(i-1)/2+j),'(3A)')LABE(i),'- ',LABE(j)
            EndIf
         EndDo
      EndDo

      Do iMltpl = 0,nMltPl
         iComp=0
         nComp=(iMltPl+1)*(iMltPl+2)/2
         Write(MemLabel,'(A4,I4.4)') 'AtTo',iMltPl
         Call GetMem(MemLabel,'Allo','Real',iAtMltPlTotAd(iMltPl),nComp)
         Do i=0,nComp-1
            Work(iAtMltPlTotAd(iMltPl)+i)=0.0D0
         EndDo
         Write(MemLabel,'(A4,I4.4)') 'BoTo',iMltPl
         Call GetMem(MemLabel,'Allo','Real',iAtBoMltPlTotAd(iMltPl),
     &   nComp)
         Do i=0,nComp-1
            Work(iAtBoMltPlTotAd(iMltPl)+i)=0.0D0
         EndDo
         Do np=iMltpl,0,-1
            Do nq=iMltpl-np,0,-1
               nl=iMltpl-np-nq
               iComp=iComp+1
               iCompMat(np,nq,nl)=iComp
               Do nA=1,nAtoms
                  Do ip=0,np
                     Call NoverP(np,ip,rnPoveriP)
                     If(np.eq.ip) Then
                        xfac=rnpoverip
                     Else
                        xfac=rnPoveriP*(Cor(1,nA,nA)
     &                  )**(np-ip)
                     EndIf
                     Do iq=0,nq
                        Call NoverP(nq,iq,rnqoveriq)
                        If(nq.eq.iq) Then
                           yfac=rnqoveriq
                        Else
                           yfac=rnqoveriq*(Cor(2,nA,nA)
     &                      )**(nq-iq)
                        EndIf
                        Do il=0,nl
                           Call NoverP(nl,il,rnloveril)
                           If(nl.eq.il) Then
                              zfac=rnloveril
                           Else
                              zfac=rnloveril*(Cor(3,nA,nA)
     &                        )**(nl-il)
                           EndIf
                           fac=xfac*yfac*zfac*
     &                     Work(iAtMltPlAd(ip+iq+il)+
     &                     nAtoms*(iCompMat(ip,iq,il)-1)+
     &                     nA-1)
                           Work(iAtMltPlTotAd(iMltpl)+iComp-1)=
     &                     Work(iAtMltPlTotAd(iMltpl)+iComp-1)+fac
                        EndDo
                     EndDo
                  EndDo
                  Do nB=1,nA
                     If(nA.eq.nB.or.BondMat(nA,nB)) Then
                     Do ip=0,np
                        Call NoverP(np,ip,rnPoveriP)
                        If(np.eq.ip) Then
                           xfac=rnpoverip
                        Else
                           xfac=rnPoveriP*(Cor(1,nA,nB)
     &                     )**(np-ip)
                        EndIf
                        Do iq=0,nq
                           Call NoverP(nq,iq,rnqoveriq)
                           If(nq.eq.iq) Then
                              yfac=rnqoveriq
                           Else
                              yfac=rnqoveriq*(Cor(2,nA,nB)
     &                        )**(nq-iq)
                           EndIf
                           Do il=0,nl
                              Call NoverP(nl,il,rnloveril)
                              If(nl.eq.il) Then
                                 zfac=rnloveril
                              Else
                                 zfac=rnloveril*(Cor(3,nA,nB)
     &                           )**(nl-il)
                              EndIf
                              fac=xfac*yfac*zfac*
     &                        Work(iAtBoMltPlAd(ip+iq+il)+
     &                        nCenters*(iCompMat(ip,iq,il)-1)+
     &                        nA*(nA-1)/2+nB-1)
                              Work(iAtBoMltPlTotAd(iMltpl)+iComp-1)=
     &                        Work(iAtBoMltPlTotAd(iMltpl)+iComp-1)+fac
                           EndDo
                        EndDo
                     EndDo
                     EndIf
                  EndDo
               EndDo
            EndDo
         EndDo
      EndDo

      Call Wr_MpProp(nAtoms,nCenters,nMltPl,iPol)
!EB      Call Wr_Files(nAtoms,nCenters,nMltPl,nBas,NOCOB,orbe,iBond,
      Call Wr_Files(nAtoms,nCenters,nMltPl,nBas,NOCOB,NOCOB_b,
     &     orbe,orbe_b,LAllCenters)

      Do iMltpl = 0,nMltPl
         nComp=(iMltPl+1)*(iMltPl+2)/2
         Write(MemLabel,'(A4,I4.4)') 'AtTo',iMltPl
         Call GetMem(MemLabel,'Free','Real',iAtMltPlTotAd(iMltPl),
     &   iMltPl*nComp)
         Write(MemLabel,'(A4,I4.4)') 'BoTo',iMltPl
         Call GetMem(MemLabel,'Free','Real',iAtBoMltPlTotAd(iMltPl),
     &   iMltPl*nComp)
      EndDo

!EB 111   Format(A,3F15.5,6F10.3,10I5)
      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************

subroutine quater_sub(nAtoms,G1,G2,ireturn)

use Quater_globals, only: debug, rotate, translate, ngeoms, list
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms
real(kind=wp), intent(in) :: G1(3*nAtoms)
real(kind=wp), intent(inout) :: G2(3*nAtoms)
integer(kind=iwp), intent(out) :: ireturn
real(kind=wp) :: U1(3), U2(3), V1(3), V2(3), V1best(3), V2best(3), Q(0:3), Vtrans(3)
integer(kind=iwp), parameter :: XYZ(3) = [1,2,3]

#ifdef _DEBUGPRINT_
debug = .true.
#else
debug = .false.
#endif
rotate = .true.
translate = .true.
ngeoms = 1
list(1)%title = 'ORIGINAL'
list(2)%title = 'GEOHYPER'
list(3)%title = 'bALIGNED'

call quaterinit()

list(1)%nat = nAtoms
list(2)%nat = nAtoms
list(3)%nat = nAtoms

call mma_allocate(list(1)%geo,3,nAtoms,label='GEO0')
call mma_allocate(list(1)%geolbl,nAtoms,label='GEO0')
call mma_allocate(list(2)%geo,3,nAtoms,label='GEO1')
call mma_allocate(list(2)%geolbl,nAtoms,label='GEO1')
call mma_allocate(list(3)%geo,3,nAtoms,label='GEO2')
call mma_allocate(list(3)%geolbl,nAtoms,label='GEO2')

call dcopy_(3*nAtoms,G1,1,list(1)%geo,1)
call dcopy_(3*nAtoms,G2,1,list(2)%geo,1)

call SetVect(nAtoms,list(1)%geo,XYZ,V1,V2)
call SetVect(nAtoms,list(2)%geo,XYZ,U1,U2)

if (debug) then
  write(u6,*) 'Reference axis'
  call RecPrt('U1',' ',U1,3,1)
  call RecPrt('U2',' ',U2,3,1)
  write(u6,*) 'New axis'
  call RecPrt('V1',' ',V1,3,1)
  call RecPrt('V2',' ',V2,3,1)
end if

call QuaterSolve(U1,U2,V1,V2,Q)

if (debug) then
  write(u6,*) 'Normalized Reference axis'
  call RecPrt('U1',' ',U1,3,1)
  call RecPrt('U2',' ',U2,3,1)
  write(u6,*) 'Normalized New axis'
  call RecPrt('V1',' ',V1,3,1)
  call RecPrt('V2',' ',V2,3,1)
  call QuaterRotation(Q,U1,V1best)
  call QuaterRotation(Q,U2,V2best)
  call RecPrt('Best V1',' ',V1best,3,1)
  call RecPrt('Best V2',' ',V2best,3,1)
end if

list(3)%geo(:,:) = list(2)%geo(:,:)

call RotateGeoms(Q)
call SetVectTrans(list(1)%nat,list(1)%geo,XYZ,list(3)%nat,list(3)%geo,XYZ,Vtrans)
call TranslateGeoms(Vtrans)

if (debug) then
  call PrintGeom(-1_iwp,list(3)%nat,list(3)%title,list(3)%geo,list(3)%geolbl)
end if

call dcopy_(3*nAtoms,list(3)%geo,1,G2,1)

call mma_deallocate(list(1)%geo)
call mma_deallocate(list(1)%geolbl)
call mma_deallocate(list(2)%geo)
call mma_deallocate(list(2)%geolbl)
call mma_deallocate(list(3)%geo)
call mma_deallocate(list(3)%geolbl)

ireturn = 0

return

end subroutine quater_sub

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995,1997-1999, Jeppe Olsen                       *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GASDN2(I12,RHO1,RHO2,RHO2S,RHO2A,CB,SB,C2,NACOB,NSSOA,NSSOB,NAEL,IAGRP,NBEL,IBGRP,IOCTPA,IOCTPB,NOCTPA,NOCTPB,NSMST, &
                  NSMOB,MXPNGAS,NOBPTS,IOBPTS,MAXK,MAXI,CSCR,SSCR,NGAS,NELFSPGP,IDC,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,X,RHO1S,LUL, &
                  LUR,PSL,PSR,NBATCHL,LBATL,I1BATL,IBLOCKL,NBATCHR,LBATR,I1BATR,IBLOCKR,ICONSPA,ICONSPB,SCLFAC_L,SCLFAC_R, &
                  S2_TERM1,IPHGAS,IDOSRHO1,SRHO1,IPACK)
! SUBROUTINE GASDN2 --> 89
!
! Jeppe Olsen, Winter of 1991
! GAS modificatios, August 1995
!
! Table driven, June 97
!
! Last revision : Jan. 98 (IUSE_PH,IPHGAS added)
!                 Jan. 99 (IDOSRHO1,SRHO1 added)
!
! =====
! Input
! =====
!
! I12    : = 1 => calculate one-electrondensity matrix
!          = 2 => calculate one-and two- electrondensity matrix
! RHO1   : Initial one-electron density matrix
! RHO2   : Initial two-electron density matrix
! RHO2S  : Initial symmetric two-electron density matrix
! RHO2A  : Initial anti-symmetric two-electron density matrix
!
! ICOCOC : Allowed type combinations for C
! ISOCOC : Allowed type combinations for S(igma)
! ICSMOS : Symmetry array for C
! ISSMOS : Symmetry array for S
! ICBLTP : Block types for C
! ISBLTP : Block types for S
!
! NACOB : Number of active orbitals
! NSSOA : Number of strings per type and symmetry for alpha strings
! NAEL  : Number of active alpha electrons
! NSSOB : Number of strings per type and symmetry for beta strings
! NBEL  : Number of active beta electrons
!
! MAXIJ : Largest allowed number of orbital pairs treated simultaneously
! MAXK  : Largest number of N-2,N-1 strings treated simultaneously
! MAXI  : Max number of N strings treated simultaneously
!
! IPACK : Logical: If true calculate symmetry packed densities (i.e.
!         RHO2S and RHO2A instead of RHO2
!
! RHO1S: Scratch array for one body
! CSCR : Scratch array for C vector
! SSCR : Scratch array for S vector
!
! The L and R vectors are accessed through routines that
! either fetches/disposes symmetry blocks or
! Symmetry-occupation-occupation blocks

use lucia_data, only: IDISK
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: I12, NOCTPA, NOCTPB, NSMST, NACOB, NSSOA(NSMST,NOCTPA), NSSOB(NSMST,NOCTPB), NAEL, IAGRP, NBEL, &
                                 IBGRP, IOCTPA, IOCTPB, NSMOB, MXPNGAS, NOBPTS(MXPNGAS,NSMOB), IOBPTS(MXPNGAS,NSMOB), MAXK, MAXI, &
                                 NGAS, NELFSPGP(MXPNGAS,*), IDC, LUL, LUR, NBATCHL, LBATL(NBATCHL), I1BATL(NBATCHL), IBLOCKL(8,*), &
                                 NBATCHR, LBATR(NBATCHR), I1BATR(NBATCHR), IBLOCKR(8,*), ICONSPA(NOCTPA,NOCTPA), &
                                 ICONSPB(NOCTPB,NOCTPB), IPHGAS(*), IDOSRHO1
real(kind=wp), intent(inout) :: RHO1(*), RHO2(*), RHO2S(*), RHO2A(*), XI1S(*), XI2S(*), RHO1S(*), SCLFAC_L(*), SCLFAC_R(*), &
                                S2_TERM1, SRHO1(*)
real(kind=wp), intent(inout) :: CB(*), SB(*)
real(kind=wp), intent(_OUT_) :: C2(*), CSCR(*), SSCR(*), XI3S(*), XI4S(*), X(*)
integer(kind=iwp), intent(inout) :: I1(*), I2(*)
integer(kind=iwp), intent(_OUT_) :: I3(*), I4(*)
real(kind=wp), intent(in) :: PSL, PSR
logical(kind=iwp), intent(in) :: IPACK
integer(kind=iwp) :: IABEXC, IAEXC, IASM, IATP, IBATCHL, IBATCHR, IBEXC, IBSM, IBTP, IDUMMY(1), IIASM, IIATP, IIBSM, IIBTP, IIL, &
                     IIR, IL, ILPERM, INTERACT, IOFF, IPERM, IR, ISCALE, ISTRFL(1), JASM, JATP, JBSM, JBTP, JOFF, LASM(4), &
                     LATP(4), LBL(1), LBSM(4), LBTP(4), LCOL, LROW, LSGN(5), LTRP(5), NBLKL, NBLKR, NIA, NIB, NIIA, NIIB, NJA, &
                     NJB, NLPERM, NPERM, NRPERM, RASM(4), RATP(4), RBSM(4), RBTP(4), RSGN(5), RTRP(5)
integer(kind=iwp), allocatable :: ICOOSC(:,:), ISOOSC(:,:)
real(kind=wp) :: FACTOR, PCL, PL, PLR, PS, SCLFAC

! Some dummy initializations
INTERACT = 0 ! jwk-cleanup

#ifdef _DEBUGPRINT_
write(u6,*) ' ================='
write(u6,*) ' GASDN2 speaking :'
write(u6,*) ' ================='
write(u6,*)
write(u6,*) ' NACOB,MAXK,NGAS,IDC',NACOB,MAXK,NGAS,IDC
write(u6,*) ' LUL, LUR ',LUL,LUR
!write(u6,*) ' Initial L vector'
!if (LUL == 0) then
!  call WRTRS2(CB,ISSMOS,ISBLTP,ISOCOC,NOCTPA,NOCTPB,NSSOA,NSSOB,NSMST)
!else
!  call WRTVCD(CB,LUL,1,-1)
!end if
!write(u6,*) ' Initial R vector'
!if (LUR == 0) then
!  call WRTRS2(SB,ICSMOS,ICBLTP,ICOCOC,NOCTPA,NOCTPB,NSSOA,NSSOB,NSMST)
!else
!  call WRTVCD(SB,LUR,1,-1)
!end if
#endif
! Loop over batches over L blocks
if (LUL /= 0) IDISK(LUL) = 0
call mma_allocate(ICOOSC,NOCTPA,NOCTPB,Label='ICOOSC')
call mma_allocate(ISOOSC,NOCTPA,NOCTPB,Label='ISOOSC')
do IBATCHL=1,NBATCHL
  ! Obtain L blocks
  NBLKL = LBATL(IBATCHL)
# ifdef _DEBUGPRINT_
  write(u6,*) ' Left batch, number of blocks',IBATCHL,NBLKL
# endif
  do IIL=1,NBLKL
    IL = I1BATL(IBATCHL)-1+IIL
    IATP = IBLOCKL(1,IL)
    IBTP = IBLOCKL(2,IL)
    IASM = IBLOCKL(3,IL)
    IBSM = IBLOCKL(4,IL)
    IOFF = IBLOCKL(5,IL)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'IATP IBTP IASM IBSM',IATP,IBTP,IASM,IBSM
    write(u6,*) 'IOFF ',IOFF
#   endif
    ISCALE = 0
    call GSTTBL(CB,SB(IOFF),IATP,IASM,IBTP,IBSM,NOCTPA,NOCTPB,NSSOA,NSSOB,PSL,ISOOSC,IDC,PSL,LUL,C2,NSMST,ISCALE,SCLFAC_L(IL))
  end do
  ! Loop over batches  of R vector
  if (LUR /= 0) IDISK(LUR) = 0
  do IBATCHR=1,NBATCHR
    ! Read R blocks into core
    NBLKR = LBATR(IBATCHR)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Right batch, number of blocks',IBATCHR,NBLKR
#   endif
    do IIR=1,NBLKR
      IR = I1BATR(IBATCHR)-1+IIR
      JATP = IBLOCKR(1,IR)
      JBTP = IBLOCKR(2,IR)
      JASM = IBLOCKR(3,IR)
      JBSM = IBLOCKR(4,IR)
      JOFF = IBLOCKR(5,IR)
#     ifdef _DEBUGPRINT_
      write(u6,*) ' JATP JBTP JASM JBSM ',JATP,JBTP,JASM,JBSM
#     endif
      ! Read R blocks into core

      ! Only blocks interacting with current batch of L are read in
      ! Loop over L  blocks in batch
      do IIL=1,NBLKL
        IL = I1BATL(IBATCHL)-1+IIL
        IATP = IBLOCKL(1,IL)
        IBTP = IBLOCKL(2,IL)
        IASM = IBLOCKL(3,IL)
        IBSM = IBLOCKL(4,IL)
        ! Well, permutations of L blocks
        PS = One
        PL = One
        call PRMBLK(IDC,ISTRFL,IASM,IBSM,IATP,IBTP,PS,PL,LATP,LBTP,LASM,LBSM,LSGN,LTRP,NPERM)
        do IPERM=1,NPERM
          IIASM = LASM(IPERM)
          IIBSM = LBSM(IPERM)
          IIATP = LATP(IPERM)
          IIBTP = LBTP(IPERM)

          IAEXC = ICONSPA(IIATP,JATP)
          IBEXC = ICONSPB(IIBTP,JBTP)
          if ((IAEXC == 0) .and. (IIASM /= JASM)) IAEXC = 1
          if ((IBEXC == 0) .and. (IIBSM /= JBSM)) IBEXC = 1
          IABEXC = IAEXC+IBEXC
          if (IABEXC <= I12) INTERACT = 1
        end do
      end do
      ! End of checking whether C-block is needed
      ISCALE = 0
      if (INTERACT == 1) then
        ISCALE = 0
        call GSTTBL(SB,CB(JOFF),JATP,JASM,JBTP,JBSM,NOCTPA,NOCTPB,NSSOA,NSSOB,PSR,ICOOSC,IDC,PCL,LUR,C2,NSMST,ISCALE,SCLFAC_R(IR))
      else
        !write(u6,*) ' TTSS for C block skipped'
        !call IWRTMA(IBLOCKR(1,IR),4,1,4,1)
        call IDAFILE(LUR,2,LBL,1,IDISK(LUR))
        call IDAFILE(LUR,2,IDUMMY,1,IDISK(LUR))
        call SKPRCD2(LBL(1),-1,LUR)
        SCLFAC_R(IR) = Zero
      end if

#     ifdef _DEBUGPRINT_
      if (INTERACT == 1) then
        write(u6,*) ' TTSS for C block read in'
        call IWRTMA(IBLOCKR(1,IR),4,1,4,1)
      else
        write(u6,*) ' TTSS for C block skipped'
        call IWRTMA(IBLOCKR(1,IR),4,1,4,1)
      end if
#     endif
    end do

    ! Loop over L and R blocks in batches and obtain  contribution from
    ! given L and R blocks
    PLR = One
    do IIL=1,NBLKL
      IL = I1BATL(IBATCHL)-1+IIL
      if (SCLFAC_L(IL) /= Zero) then
        IATP = IBLOCKL(1,IL)
        IBTP = IBLOCKL(2,IL)
        IASM = IBLOCKL(3,IL)
        IBSM = IBLOCKL(4,IL)
        IOFF = IBLOCKL(5,IL)

        NIA = NSSOA(IASM,IATP)
        NIB = NSSOB(IBSM,IBTP)
        ! Possible permutations of L blocks
        call PRMBLK(IDC,ISTRFL,IASM,IBSM,IATP,IBTP,PSL,PLR,LATP,LBTP,LASM,LBSM,LSGN,LTRP,NLPERM)
        do ILPERM=1,NLPERM
          !write(u6,*) ' Loop 9999 ILPERM = ',ILPERM
          IIASM = LASM(ILPERM)
          IIBSM = LBSM(ILPERM)
          IIATP = LATP(ILPERM)
          IIBTP = LBTP(ILPERM)
          NIIA = NSSOA(IIASM,IIATP)
          NIIB = NSSOB(IIBSM,IIBTP)

          if (LTRP(ILPERM) == 1) then
            LROW = NSSOA(LASM(ILPERM-1),LATP(ILPERM-1))
            LCOL = NSSOB(LBSM(ILPERM-1),LBTP(ILPERM-1))
            call TRPMT3(SB(IOFF),LROW,LCOL,C2)
            SB(IOFF:IOFF+LROW*LCOL-1) = C2(1:LROW*LCOL)
          end if
          if (LSGN(ILPERM) == -1) SB(IOFF:IOFF+NIA*NIB-1) = -SB(IOFF:IOFF+NIA*NIB-1)

          do IIR=1,NBLKR
            IR = I1BATR(IBATCHR)-1+IIR
            if (SCLFAC_R(IR) /= Zero) then
              JATP = IBLOCKR(1,IR)
              JBTP = IBLOCKR(2,IR)
              JASM = IBLOCKR(3,IR)
              JBSM = IBLOCKR(4,IR)
              JOFF = IBLOCKR(5,IR)

              NJA = NSSOA(JASM,JATP)
              NJB = NSSOB(JBSM,JBTP)

              IAEXC = ICONSPA(JATP,IIATP)
              IBEXC = ICONSPB(JBTP,IIBTP)

              if ((IAEXC == 0) .and. (JASM /= IIASM)) IAEXC = 1
              if ((IBEXC == 0) .and. (JBSM /= IIBSM)) IBEXC = 1
              IABEXC = IAEXC+IBEXC

              if (IABEXC <= I12) then
                INTERACT = 1
              else
                INTERACT = 0
              end if

              if (INTERACT == 1) then
                ! Possible permutations of this block
                call PRMBLK(IDC,ISTRFL,JASM,JBSM,JATP,JBTP,PSR,PLR,RATP,RBTP,RASM,RBSM,RSGN,RTRP,NRPERM)
                ! Well, spin permutations are simple to handle
                ! if there are two terms just calculate and and multiply with
                ! 1+PSL*PSR
                if (NRPERM == 1) then
                  FACTOR = One
                else
                  FACTOR = One+PSL*PSR
                end if
                SCLFAC = FACTOR*SCLFAC_L(IL)*SCLFAC_R(IR)
                if ((INTERACT == 1) .and. (SCLFAC /= Zero)) then
#                 ifdef _DEBUGPRINT_
                  write(u6,*) ' RSDNBB will be called for'
                  write(u6,*) ' L block :'
                  write(u6,'(A,5I5)') ' IIASM IIBSM IIATP IIBTP',IIASM,IIBSM,IIATP,IIBTP
                  write(u6,*) ' R  block :'
                  write(u6,'(A,5I5)') ' JASM JBSM JATP JBTP',JASM,JBSM,JATP,JBTP
                  write(u6,*) ' IOFF,JOFF ',IOFF,JOFF
                  write(u6,*) ' SCLFAC = ',SCLFAC
#                 endif

                  call GSDNBB2(I12,RHO1,RHO2,RHO2S,RHO2A,IIASM,IIATP,IIBSM,IIBTP,JASM,JATP,JBSM,JBTP,NGAS, &
                               NELFSPGP(:,IOCTPA-1+IIATP),NELFSPGP(:,IOCTPB-1+IIBTP),NELFSPGP(:,IOCTPA-1+JATP), &
                               NELFSPGP(:,IOCTPB-1+JBTP),NAEL,NBEL,IAGRP,IBGRP,SB(IOFF),CB(JOFF),C2,MXPNGAS,NOBPTS,IOBPTS,MAXI, &
                               MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,X,NSMOB,NIIA,NIIB,NJA,NJB,NACOB,RHO1S,SCLFAC, &
                               S2_TERM1,IPHGAS,IDOSRHO1,SRHO1,IPACK)

                  ! CALL GSDNBB2 --> 66

#                 ifdef _DEBUGPRINT_
                  write(u6,*) ' Updated rho1'
                  call wrtmat(rho1,nacob,nacob,nacob,nacob)
                  write(u6,*) ' Updated srho1'
                  call wrtmat(srho1,nacob,nacob,nacob,nacob)
#                 endif

                end if
              end if
            end if
          end do
          ! End of loop over R blocks in Batch
        end do
        ! Transpose or scale L block to restore order ??
        if (LTRP(NLPERM+1) == 1) then
          call TRPMT3(SB(IOFF),NIB,NIA,C2)
          SB(IOFF:IOFF+NIA*NIB-1) = C2(1:NIA*NIB)
        end if
        if (LSGN(NLPERM+1) == -1) SB(IOFF:IOFF+NIA*NIB-1) = -SB(IOFF:IOFF+NIA*NIB-1)

      end if
    end do
    ! End of loop over L blocks in batch
  end do
  ! End of loop over batches of R blocks
end do
! End of loop over batches of L blocks

call mma_deallocate(ICOOSC)
call mma_deallocate(ISOOSC)

end subroutine GASDN2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Valera Veryazov                                  *
!***********************************************************************

subroutine SysDumpStr(str)

use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: str
integer(kind=iwp) :: i, iTooLong
character(len=20) :: frmt

iTooLong = 60
i = len(str)
if (i > iTooLong+8) then
  ! oops! too long
  write(u6,'(a,a)') ' ###    ',str
  return
end if
i = iTooLong+8-i
if (i == 0) then
  frmt = '(a,a,a)'
else
  write(frmt,'(a, i2,a)') '(a,a,',i,'x,a)'
end if
write(u6,frmt) ' ###    ',str,' ###'

return

end subroutine SysDumpStr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************
!#define _DEBUGPRINT_

Module Basis_Info
Implicit None
Private
Public :: Basis_Info_Dmp, Basis_Info_Get, Basis_Info_Free, Distinct_Basis_set_Centers, dbsc, nFrag_LineWords,&
          PAMExp, Shells, Max_Shells, nCnttp, iCnttp_Dummy, Point_Charge, Gaussian_type, mGaussian_Type,     &
          Nuclear_Model, Basis_Info_Init, nBas, nBas_Aux, nBas_Frag, MolWgh

#include "stdalloc.fh"
#include "Molcas.fh"
#include "itmax.fh"
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!    D E C L A R E   D E R I V E D   T Y P E S
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     Work in progress
!
!     nCntr : number of centers associated with a dbsc
!     Coor  : the coordinates of a dbsc
!
!     nM1   : number of ECP M1 type terms on the i''th unique center
!     M1xp  : ECP M1-type exponents for i''th unq center
!     M1cf  : ECP M1 type coefficients for i''th unq cntr
!     nM2   : number of ECP M2 type terms on the i''th unique center
!     M2xp  : ECP M2-type exponents for i''th unq center
!     M2cf  : ECP M2 type coefficients for i''th unq cntr
!
!     nFragType:  number of unique centers in a fragment (0=not a frag)
!     nFragCoor:  total number of centers in a fragment
!     nFragEner:  number of orbital energies/occupied orbitals in a given fragment
!     nFragDens:  size of the fragments density matrix
!     FragType : the data of the fragment''s unique centers (associated basis set, size nFragType)
!     FragCoor : the data of all fragment''s centers (atom type / relative coordinates, size nFragCoor)
!     FragEner : the fragment''s orbital''s energies (size nFragEner)
!     FragCoef : the fragment''s MO coefficients (size nFragDens*nFragEner)
!     ECP      : Flag if dbsc is a ECP basis set
!     Frag     : Flag if dbsc is a Fragment basis set
!     Aux      : Flag if dbsc is an auxiliary basis set
!     FOp      : Flag if dbsc has a Fock Operator
!     IsMM     : integer flag to indicate that associated centers are treated as MM centers in QM/MM calculations
!
Type Distinct_Basis_set_centers
    Sequence
    Real*8, Pointer:: Coor(:,:)=>Null()
    Real*8, Allocatable:: Coor_Hidden(:,:)
    Integer:: nCntr=0
    Integer:: nM1=0
    Real*8, Allocatable:: M1xp(:), M1cf(:)
    Integer:: nM2=0
    Real*8, Allocatable:: M2xp(:), M2cf(:)
    Integer:: nFragType=0, nFragCoor=0, nFragEner=0, nFragDens=0
    Real*8, Allocatable:: FragType(:,:), FragCoor(:,:), FragEner(:), FragCoef(:,:)
    Logical:: lPAM2=.False.
    Integer:: nPAM2=-1
    Real*8, Allocatable:: PAM2(:)
    Logical:: ECP=.False.
    Logical:: Aux =.False.
    Logical:: Frag=.False.
    Logical:: FOp =.False.
    Integer:: IsMM=0
    Integer:: Parent_iCnttp=0
    Integer:: lOffAO=0
    Integer:: nOpt=0
    Integer:: mdci=0
    Integer:: iVal=0, nVal=0
    Integer:: iPrj=0, nPrj=0
    Integer:: iSRO=0, nSRO=0
    Integer:: iSOC=0, nSOC=0
    Integer:: kDel(0:iTabMx)
    Integer:: iPP =0, nPP =0
    Integer:: nShells =0
    Integer:: AtmNr=0
    Real*8::  Charge=0.0D0
    Logical:: NoPair=.False.
    Logical:: SODK  =.False.
    Logical:: pChrg =.False.
    Logical:: Fixed =.False.
    Real*8::  CrRep=0.0D0
    Real*8::  FragCharge=0.0D0
    Real*8::  aCD_Thr=1.0D0
    Real*8::  fmass=1.0D0
    Real*8::  CntMass=0.0D0
    Real*8::  ExpNuc =-1.0D0
    Real*8::  w_mGauss =1.0D0
    Character(LEN=80) :: Bsl
    Character(LEN=80) :: Bsl_Old
End Type Distinct_Basis_set_centers
!
!     nExp  : number of exponents of the i''th shell
!     Exp   : the exponents of the i''th shell
!     nBasis: number of contracted radial functions of the i''th shell
!     Cff_c : Contraction coefficients in processed and raw input form
!     Cff_p : Contraction coefficient in the case of no contraction, processed and raw
!     Cff   : copy of Cff_c or Cff_p
!     Transf: Cartesian transformed to real sphericals.
!     Projct: real sphericals without contaminations (3s, 4d, etc.)
!     Bk    : ECP proj shift parameters for i''th shell.
!             the number of parameters is given by nBasis
!     Occ   : Occupation numbers for core ECP orbitals
!     FockOp: the Fock operator matrix
!     Aux   : Logical flag for auxiliary basis set shells
!     Frag  : Logical flag for fragment shells
!
Type Shell_Info
     Sequence
     Integer :: nExp=0
     Real*8, Allocatable:: Exp(:)
     Integer :: nBasis=0
     Integer :: nBasis_c=0
     Real*8, Allocatable:: pCff(:,:)
     Real*8, Allocatable:: Cff_c(:,:,:), Cff_p(:,:,:)
     Logical :: Transf=.True.
     Logical :: Prjct =.True.
     Integer :: nBk=0
     Real*8, Allocatable:: Bk(:)
     Real*8, Allocatable:: Occ(:)
     Integer :: nAkl=0
     Real*8, Allocatable:: Akl(:,:,:)
     Integer :: nFockOp=0
     Real*8, Allocatable:: FockOp(:,:)
     Logical :: Aux =.False.
     Logical:: Frag=.False.
     Integer:: kOffAO=0
End Type Shell_Info
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     E N D   D E C L A R E   D E R I V E D   T Y P E S
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     Actual content of Basis_Info
!
Integer, Parameter :: Point_Charge  = 0
Integer, Parameter :: Gaussian_type = 1
Integer, Parameter :: mGaussian_Type= 2

Real*8, Allocatable:: PAMexp(:,:)
Integer :: nFrag_LineWords = 0, nFields =33+(1+iTabMx), mFields = 11
Integer :: nCnttp = 0, iCnttp_Dummy = 0
Integer :: Max_Shells = 0
Logical :: Initiated = .FALSE.
Integer :: Nuclear_Model=Point_Charge
Integer :: nBas(0:7)     =[0,0,0,0,0,0,0,0]
Integer :: nBas_Aux(0:7) =[0,0,0,0,0,0,0,0]
Integer :: nBas_Frag(0:7)=[0,0,0,0,0,0,0,0]
Integer :: MolWgh=2
!     MolWgh: integer flag to indicate the normalization of the symmetry transformation
!             0: double coset represetative normalization
!             1: as in MOLECULE
!             2: as in MOLPRO


Type (Distinct_Basis_set_centers) , Allocatable, Target:: dbsc(:)
Type (Shell_Info), Allocatable :: Shells(:)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!
Interface
   Subroutine Abend()
   End Subroutine Abend
   Subroutine Put_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Put_iArray
   Subroutine Get_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Get_iArray
   Subroutine Qpg_iArray(Label,Found,nData)
   Character*(*) Label
   Logical       Found
   Integer       nData
   End Subroutine Qpg_iArray
   Subroutine Put_dArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Real*8        Data(nData)
   End Subroutine Put_dArray
   Subroutine Get_dArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Real*8        Data(nData)
   End Subroutine Get_dArray
   Subroutine Qpg_dArray(Label,Found,nData)
   Character*(*) Label
   Logical       Found
   Integer       nData
   End Subroutine Qpg_dArray
End Interface
!
!***********************************************************************
!***********************************************************************
!
Contains
!
!***********************************************************************
!***********************************************************************
!
!     This to make either the initial allocation of dbsc and Shells according to the default sizes
!     as defined by the parameters in Molcas.fh or according to the actual sizes as recorded on the
!     run file.
!
Subroutine Basis_Info_Init()
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Enter Basis_Info_Init'
Write (6,*)
#endif
If (Initiated) Then
   Write (6,*) ' Basis_Info already initiated!'
   Write (6,*) ' Maybe there is missing a Basis_Info_Free call.'
   Call Abend()
End If
If (nCnttp.eq.0) Then
   Allocate(dbsc(1:Mxdbsc))
   dbsc(1:Mxdbsc)%Bsl=""        ! I could not get this to work at the point of declaring the member.
   dbsc(1:Mxdbsc)%Bsl_Old=""
Else
   Allocate(dbsc(1:nCnttp))
   dbsc(1:nCnttp)%Bsl=""
   dbsc(1:nCnttp)%Bsl_Old=""
End If
If (Max_Shells.eq.0) Then
   Allocate(Shells(1:MxShll))
Else
   Allocate(Shells(1:Max_Shells))
End If
Initiated=.True.
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Exit Basis_Info_Init'
Write (6,*)
#endif
Return
End Subroutine Basis_Info_Init
!
!***********************************************************************
!***********************************************************************
!
Subroutine Basis_Info_Dmp()
!
Integer i, j, nAtoms, nAux, nM1, nM2, nFragCoor, nAux2, nBk, nAkl, nFockOp, nExp, nBasis, lcDmp
Integer, Allocatable:: iDmp(:,:)
Real*8, Allocatable, Target:: rDmp(:,:)
Real*8, Pointer:: qDmp(:,:)
Character(LEN=160), Allocatable:: cDmp(:)
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Enter Basis_Info_Dmp'
Write (6,*)
Write (6,*) 'Coordinates:'
Do i = 1, nCnttp
   Do j = 1, dbsc(i)%nCntr
      Write (6,*) dbsc(i)%Coor(:,j)
   End Do
End Do
#endif
!
!     Integer dbsc stuff
!
Call mma_Allocate(iDmp,nFields,nCnttp+1,Label='iDmp')
nAtoms=0
nAux   = 0
Do i = 1, nCnttp
   iDmp(1,i) = dbsc(i)%nCntr
   iDmp(2,i) = dbsc(i)%nM1
   iDmp(3,i) = dbsc(i)%nM2
   iDmp(4,i) = dbsc(i)%nFragType
   iDmp(5,i) = dbsc(i)%nFragCoor
   iDmp(6,i) = dbsc(i)%nFragEner
   iDmp(7,i) = dbsc(i)%nFragDens
   iDmp(8,i) = 0
   If (dbsc(i)%ECP) iDmp(8,i)=1
   iDmp(9,i) = 0
   If (dbsc(i)%Frag)iDmp(9,i)=1
   iDmp(10,i) = 0
   If (dbsc(i)%Aux )iDmp(10,i)=1
   iDmp(11,i) = 0
   If (dbsc(i)%FOp )iDmp(11,i)=1
   iDmp(12,i) = dbsc(i)%IsMM
   iDmp(13,i) = dbsc(i)%Parent_iCnttp
   iDmp(14,i) = dbsc(i)%lOffAO
   iDmp(15,i) = dbsc(i)%nOpt
   iDmp(16,i) = dbsc(i)%mdci
   iDmp(17,i) = dbsc(i)%iVal
   iDmp(18,i) = dbsc(i)%nVal
   iDmp(19,i) = dbsc(i)%iPrj
   iDmp(20,i) = dbsc(i)%nPrj
   iDmp(21,i) = dbsc(i)%iSRO
   iDmp(22,i) = dbsc(i)%nSRO
   iDmp(23,i) = dbsc(i)%iSOC
   iDmp(24,i) = dbsc(i)%nSOC
   iDmp(25,i) = dbsc(i)%iPP
   iDmp(26,i) = dbsc(i)%nPP
   iDmp(27,i) = dbsc(i)%nShells
   iDmp(28,i) = dbsc(i)%AtmNr
   iDmp(29,i) = 0
   If (dbsc(i)%NoPair)iDmp(29,i)=1
   iDmp(30,i) = 0
   If (dbsc(i)%SODk  )iDmp(30,i)=1
   iDmp(31,i) = 0
   If (dbsc(i)%pChrg )iDmp(31,i)=1
   iDmp(32,i) = 0
   If (dbsc(i)%Fixed )iDmp(32,i)=1
   iDmp(33,i) = 0
   If (dbsc(i)%lPAM2 )iDmp(33,i)=1
   Do j = 0, iTabMx
      iDmp(34+j,i) = dbsc(i)%kDel(j)
   End Do
   If (.NOT.dbsc(i)%Aux.or.i.eq.iCnttp_Dummy) Then
      nAtoms=nAtoms+dbsc(i)%nCntr
   End If
   nFragCoor=Max(0,dbsc(i)%nFragCoor)  ! Fix the misuse in FragExpand
   nAux = nAux + 2*dbsc(i)%nM1 + 2*dbsc(i)%nM2  &
         +nFrag_LineWords*dbsc(i)%nFragType     &
         +5              *        nFragCoor     &
                         +dbsc(i)%nFragEner     &
       +dbsc(i)%nFragDens*dbsc(i)%nFragEner
#ifdef _DEBUGPRINT_
   Write (6,'(A,8I4)') 'iCnttp=',i,                     &
          nFrag_LineWords,dbsc(i)%nFragType,    &
                          dbsc(i)%nFragCoor,    &
                          dbsc(i)%nFragEner,    &
                          dbsc(i)%nFragDens, nAux, &
                          dbsc(i)%iVal
#endif
!
   If (dbsc(i)%nPAM2.ne.-1) Then
      Write (6,*) 'Not yet implemented for PAM2 integrals.'
      Call Abend()
   End If
End Do
iDmp(1,nCnttp+1)=nFrag_LineWords
iDmp(2,nCnttp+1)=nCnttp
iDmp(3,nCnttp+1)=iCnttp_Dummy
iDmp(4,nCnttp+1)=Max_Shells
iDmp(5,nCnttp+1)=Nuclear_Model
iDmp(6:13,nCnttp+1)=nBas(0:7)
iDmp(14:21,nCnttp+1)=nBas_Aux(0:7)
iDmp(22:29,nCnttp+1)=nBas_Frag(0:7)
iDmp(30,nCnttp+1)=MolWgh
Call Put_iArray('iDmp',iDmp,nFields*(nCnttp+1))
Call mma_deallocate(iDmp)
!
!     Integer shells stuffs
!
Call mma_Allocate(iDmp,mFields,Max_Shells-1,Label='iDmp')
nAux2=0
Do i = 1, Max_Shells-1
   iDmp(1,i) = Shells(i)%nBK
   iDmp(2,i) = Shells(i)%nAkl
   iDmp(3,i) = Shells(i)%nFockOp
   iDmp(4,i) = Shells(i)%nExp
   iDmp(5,i) = Shells(i)%nBasis
   iDmp(6,i) = Shells(i)%nBasis_c
   iDmp(7,i) = 0
   If (Shells(i)%Transf) iDmp(7,i)=1
   iDmp(8,i) = 0
   If (Shells(i)%Prjct ) iDmp(8,i)=1
   iDmp(9,i) = 0
   If (Shells(i)%Frag  ) iDmp(9,i)=1
   iDmp(10,i) = 0
   If (Shells(i)%Aux   ) iDmp(10,i)=1
   iDmp(11,i) = Shells(i)%kOffAO
   nAux2 = nAux2 + 2*Shells(i)%nBK + 2*Shells(i)%nAkl**2 + Shells(i)%nFockOp**2  &
         + Shells(i)%nExp + 2*Shells(i)%nExp*Shells(i)%nBasis + 2*Shells(i)%nExp**2
#ifdef _DEBUGPRINT_
   Write (6,'(A,7I4)') 'iShll=',i,                     &
               Shells(i)%nBK,                          &
               Shells(i)%nAkl,                         &
               Shells(i)%nFockOp,                      &
               Shells(i)%nExp,                         &
               Shells(i)%nBasis
#endif

End Do
Call Put_iArray('iDmp:S',iDmp,mFields*(Max_Shells-1))
Call mma_deallocate(iDmp)
!
!    Real*8 Stuff
!
Call mma_allocate(rDmp,3,nAtoms+3*nCnttp,Label='rDmp')
nAtoms = 0
Do i = 1, nCnttp
!  Call RecPrt('dbsc(i)%Coor',' ',dbsc(i)%Coor(1,1),3,dbsc(i)%nCntr)
   If (.NOT.dbsc(i)%Aux.or.i.eq.iCnttp_Dummy) Then
      Do j = 1, dbsc(i)%nCntr
         nAtoms=nAtoms+1
         rDmp(1:3,nAtoms)=dbsc(i)%Coor(1:3,j)
      End Do
   End If
   nAtoms=nAtoms+1
   rDmp(1,nAtoms)=dbsc(i)%Charge
   rDmp(2,nAtoms)=dbsc(i)%CrRep
   rDmp(3,nAtoms)=dbsc(i)%FragCharge
   nAtoms=nAtoms+1
   rDmp(1,nAtoms)=dbsc(i)%aCD_Thr
   rDmp(2,nAtoms)=dbsc(i)%fMass
   rDmp(3,nAtoms)=dbsc(i)%CntMass
   nAtoms=nAtoms+1
   rDmp(1,nAtoms)=dbsc(i)%ExpNuc
   rDmp(2,nAtoms)=dbsc(i)%w_mGauss
   rDmp(3,nAtoms)=0.0D0
End Do
Call Put_dArray('rDmp',rDmp,3*nAtoms)
Call mma_deallocate(rDmp)
!
If (nAux.gt.0) Then
!  Write (*,*) 'nAux=',nAux
   Call mma_allocate(rDmp,nAux,1,Label='rDmp')
   nAux=0
   Do i = 1, nCnttp
      nM1 = dbsc(i)%nM1
      If (nM1.gt.0) Then
         Call RecPrt('M1xp',' ',dbsc(i)%M1xp,1,nM1)
!        Call RecPrt('M1cf',' ',dbsc(i)%M1cf,1,nM1)
         rDmp(nAux+1:nAux+nM1,1) = dbsc(i)%M1xp(:)
         nAux = nAux + nM1
         rDmp(nAux+1:nAux+nM1,1) = dbsc(i)%M1cf(:)
         nAux = nAux + nM1
      End If
      nM2 = dbsc(i)%nM2
      If (nM2.gt.0) Then
!        Call RecPrt('M2xp',' ',dbsc(i)%M2xp,1,nM2)
!        Call RecPrt('M2cf',' ',dbsc(i)%M2cf,1,nM2)
         rDmp(nAux+1:nAux+nM2,1) = dbsc(i)%M2xp(:)
         nAux = nAux + nM2
         rDmp(nAux+1:nAux+nM2,1) = dbsc(i)%M2cf(:)
         nAux = nAux + nM2
      End If
!
!     Write (*,*) 'iAux=',nAux
!     Write (*,*) nFrag_LineWords, dbsc(i)%nFragType
      If (dbsc(i)%nFragType.gt.0) Then
         qDmp(1:nFrag_LineWords,1:dbsc(i)%nFragType) => rDmp(nAux+1:nAux+nFrag_LineWords*dbsc(i)%nFragType,1)
         qDmp(:,:)=dbsc(i)%FragType(:,:)
         nAux = nAux + nFrag_LineWords*dbsc(i)%nFragType
         Nullify(qDmp)
      End If
!     Write (*,*) dbsc(i)%nFragCoor
      nFragCoor = Max(0,dbsc(i)%nFragCoor)
      If (        nFragCoor.gt.0) Then
         qDmp(1:5,1:        nFragCoor) => rDmp(nAux+1:nAux+5*        nFragCoor,1)
         qDmp(:,:)=dbsc(i)%FragCoor(:,:)
         nAux = nAux + 5*        nFragCoor
         Nullify(qDmp)
      End If
!     Write (*,*) dbsc(i)%nFragEner
      If (dbsc(i)%nFragEner.gt.0) Then
         rDmp(nAux+1:nAux+dbsc(i)%nFragEner,1)=dbsc(i)%FragEner(:)
         nAux = nAux + dbsc(i)%nFragEner
      End If
!     Write (*,*) dbsc(i)%nFragDens
      If (dbsc(i)%nFragDens*dbsc(i)%nFragEner.gt.0) Then
         qDmp(1:dbsc(i)%nFragDens,1:dbsc(i)%nFragEner) => rDmp(nAux+1:nAux+dbsc(i)%nFragDens*dbsc(i)%nFragEner,1)
         qDmp(:,:)=dbsc(i)%FragCoef(:,:)
         nAux = nAux + dbsc(i)%nFragDens*dbsc(i)%nFragEner
         Nullify(qDmp)
      End If
   End Do
!  Call RecPrt('rDmp:A',' ',rDmp,1,nAux)
   Call Put_dArray('rDmp:A',rDmp,nAux)
   Call mma_deallocate(rDmp)
End If
!
If (nAux2.gt.0) Then
   Call mma_allocate(rDmp,nAux2,1,Label='rDmp')
   nAux2=0
   Do i = 1, Max_Shells-1
      nBk=Shells(i)%nBk
      If (nBk.gt.0) Then
         rDmp(nAux2+1:nAux2+nBK,1)=Shells(i)%Bk(:)
         nAux2 = nAux2 + nBK
         rDmp(nAux2+1:nAux2+nBK,1)=Shells(i)%Occ(:)
         nAux2 = nAux2 + nBK
      End If
      nAkl=Shells(i)%nAkl
      If (nAkl.gt.0) Then
         Call DCopy_(2*nAkl**2,Shells(i)%Akl,1,rDmp(nAux2+1,1),1)
         nAux2 = nAux2 + 2*nAkl**2
      End If
      nFockOp=Shells(i)%nFockOp
      If (nFockOp.gt.0) Then
         Call DCopy_(nFockOp**2,Shells(i)%FockOp,1,rDmp(nAux2+1,1),1)
         nAux2 = nAux2 + nFockOp**2
      End If
      nExp=Shells(i)%nExp
      If (nExp.gt.0) Then
         Call DCopy_(nExp,Shells(i)%Exp,1,rDmp(nAux2+1,1),1)
         nAux2 = nAux2 + nExp
      End If
      nBasis=Shells(i)%nBasis
!     Note: the contraction coefficients are not always there.
      If (nExp*nBasis.gt.0) Then
         Call DCopy_(2*nExp**2,Shells(i)%Cff_p,1,rDmp(nAux2+1,1),1)
         nAux2 = nAux2 + 2*nExp**2
      End If
      If (nExp*nBasis.gt.0) Then
         Call DCopy_(2*nExp*nBasis,Shells(i)%Cff_c,1,rDmp(nAux2+1,1),1)
         nAux2 = nAux2 + 2*nExp*nBasis
      End If
   End Do
   Call Put_dArray('rDmp:S',rDmp,nAux2)
   Call mma_deallocate(rDmp)
End If
!
!  Character Stuff
!
Call mma_allocate(cDmp,nCnttp,Label='cDmp')
Do i = 1, nCnttp
   cDmp(i)(1:80)  =dbsc(i)%Bsl
   cDmp(i)(81:160)=dbsc(i)%Bsl_Old
End Do
lcDmp=160*nCnttp
Call Put_cArray('cDmp',cDmp(1),lcDmp)
Call mma_deallocate(cDmp)

#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Exit Basis_Info_Dmp'
Write (6,*)
#endif
Return
End Subroutine Basis_Info_Dmp
!
!***********************************************************************
!***********************************************************************
!
Subroutine Basis_Info_Get()
!
Integer, Allocatable:: iDmp(:,:)
Real*8, Allocatable, Target:: rDmp(:,:)
Real*8, Pointer:: qDmp(:,:), pDmp(:)
Character(LEN=160), Allocatable:: cDmp(:)
Logical Found
Integer Len, i, j, nAtoms, nAux, nM1, nM2, nBK,nAux2, nAkl, nFockOp, nExp, nBasis, Len2, lcDmp
Integer nFragType, nFragCoor, nFragEner, nFragDens
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Enter Basis_Info_Get'
Write (6,*)
#endif
Call qpg_iArray('iDmp',Found,Len)
Len2=Len/nFields
Call mma_Allocate(iDmp,nFields,Len2,Label='iDmp')
If (Found) Then
   Call Get_iArray('iDmp',iDmp,Len)
Else
   Write (6,*) 'Basis_Info_Get: iDmp not found!'
   Call Abend()
End If
nFrag_LineWords=iDmp(1,Len2)
nCnttp         =iDmp(2,Len2)
iCnttp_Dummy   =iDmp(3,Len2)
Max_Shells     =iDmp(4,Len2)
Nuclear_Model  =iDmp(5,Len2)
nBas(0:7)      =iDmp(6:13,Len2)
nBas_Aux(0:7)  =iDmp(14:21,Len2)
nBas_Frag(0:7) =iDmp(22:29,Len2)
MolWgh         =iDmp(30,Len2)
nAux = 0
!
!     Initiate the memory allocation of dsbc and Shells
!
If (.Not.Initiated) Call Basis_Info_Init()
!
Do i = 1, nCnttp
   dbsc(i)%nCntr        = iDmp( 1,i)
   dbsc(i)%nM1          = iDmp( 2,i)
   dbsc(i)%nM2          = iDmp( 3,i)
   dbsc(i)%nFragType    = iDmp( 4,i)
   dbsc(i)%nFragCoor    = iDmp( 5,i)
   dbsc(i)%nFragEner    = iDmp( 6,i)
   dbsc(i)%nFragDens    = iDmp( 7,i)
   dbsc(i)%ECP          = iDmp( 8,i).eq.1
   dbsc(i)%Frag         = iDmp( 9,i).eq.1
   dbsc(i)%Aux          = iDmp(10,i).eq.1
   dbsc(i)%FOp          = iDmp(11,i).eq.1
   dbsc(i)%IsMM         = iDmp(12,i)
   dbsc(i)%Parent_iCnttp= iDmp(13,i)
   dbsc(i)%lOffAO       = iDmp(14,i)
   dbsc(i)%nOpt         = iDmp(15,i)
   dbsc(i)%mdci         = iDmp(16,i)
   dbsc(i)%iVal         = iDmp(17,i)
   dbsc(i)%nVal         = iDmp(18,i)
   dbsc(i)%iPrj         = iDmp(19,i)
   dbsc(i)%nPrj         = iDmp(20,i)
   dbsc(i)%iSRO         = iDmp(21,i)
   dbsc(i)%nSRO         = iDmp(22,i)
   dbsc(i)%iSOC         = iDmp(23,i)
   dbsc(i)%nSOC         = iDmp(24,i)
   dbsc(i)%iPP          = iDmp(25,i)
   dbsc(i)%nPP          = iDmp(26,i)
   dbsc(i)%nShells      = iDmp(27,i)
   dbsc(i)%AtmNr        = iDmp(28,i)
   dbsc(i)%NoPair       = iDmp(29,i).eq.1
   dbsc(i)%SODK         = iDmp(30,i).eq.1
   dbsc(i)%pChrg        = iDmp(31,i).eq.1
   dbsc(i)%Fixed        = iDmp(32,i).eq.1
   dbsc(i)%lPAM2        = iDmp(33,i).eq.1
   Do j = 0, iTabMx
      dbsc(i)%kDel(j)   = iDmp(34+j,i)
   End Do
   nFragCoor=Max(0,dbsc(i)%nFragCoor)
   nAux = nAux + 2*dbsc(i)%nM1 + 2*dbsc(i)%nM2  &
         +nFrag_LineWords*dbsc(i)%nFragType     &
         +5              *        nFragCoor     &
                         +dbsc(i)%nFragEner     &
       +dbsc(i)%nFragDens*dbsc(i)%nFragEner
#ifdef _DEBUGPRINT_
   Write (6,'(A,8I4)') 'iCnttp=',i,                     &
          nFrag_LineWords,dbsc(i)%nFragType,    &
                          dbsc(i)%nFragCoor,    &
                          dbsc(i)%nFragEner,    &
                          dbsc(i)%nFragDens, nAux, &
                          dbsc(i)%iVal
#endif
End Do
Call mma_deallocate(iDmp)
!
!
Call qpg_iArray('iDmp:S',Found,Len)
Call mma_Allocate(iDmp,mFields,Len/mFields,Label='iDmp')
If (Found) Then
   Call get_iArray('iDmp:S',iDmp,Len)
Else
   Write (6,*) 'Basis_Info_Get: iDmp:S not found!'
   Call Abend()
End If
nAux2=0
Do i = 1, Max_Shells-1
   Shells(i)%nBK      = iDmp( 1,i)
   Shells(i)%nAkl     = iDmp( 2,i)
   Shells(i)%nFockOp  = iDmp( 3,i)
   Shells(i)%nExp     = iDmp( 4,i)
   Shells(i)%nBasis   = iDmp( 5,i)
   Shells(i)%nBasis_c = iDmp( 6,i)
   Shells(i)%Transf   = iDmp( 7,i).eq.1
   Shells(i)%Prjct    = iDmp( 8,i).eq.1
   Shells(i)%Frag     = iDmp( 9,i).eq.1
   Shells(i)%Aux      = iDmp(10,i).eq.1
   Shells(i)%kOffAO   = iDmp(11,i)
   nAux2 = nAux2 + 2*Shells(i)%nBK + 2*Shells(i)%nAkl**2 + Shells(i)%nFockOp**2  &
         + Shells(i)%nExp
!  Coefficients only there is nBasis =/=0
   If (Shells(i)%nBasis.gt.0) Then
      nAux2 = nAux2 + 2*Shells(i)%nExp*Shells(i)%nBasis + 2*Shells(i)%nExp**2
   End If
End Do
Call mma_deallocate(iDmp)
!
Call qpg_dArray('rDmp',Found,Len)
If (.Not.Found) Then
   Write (6,*) 'rDMP not found on the run file.'
   Call Abend()
End If
nAtoms=Len/3
Call mma_allocate(rDmp,3,nAtoms,Label='rDmp')
Call Get_dArray('rDmp',rDmp,3*nAtoms)
nAtoms = 0
Do i = 1, nCnttp
   If (.NOT.dbsc(i)%Aux.or.i.eq.iCnttp_Dummy) Then
      If (dbsc(i)%nCntr.gt.0) Then
         Call mma_Allocate(dbsc(i)%Coor_Hidden,3,dbsc(i)%nCntr,Label='dbsc:C')
         dbsc(i)%Coor => dbsc(i)%Coor_Hidden(:,:)
      End If
      Do j = 1, dbsc(i)%nCntr
         nAtoms=nAtoms+1
         dbsc(i)%Coor(1:3,j)=rDmp(1:3,nAtoms)
      End Do
   Else
      j=dbsc(i)%Parent_iCnttp
      dbsc(i)%Coor => dbsc(j)%Coor(1:3,1:dbsc(j)%nCntr)
    End If
   nAtoms=nAtoms+1
   dbsc(i)%Charge    =rDmp(1,nAtoms)
   dbsc(i)%CrRep     =rDmp(2,nAtoms)
   dbsc(i)%FragCharge=rDmp(3,nAtoms)
   nAtoms=nAtoms+1
   dbsc(i)%aCD_Thr   =rDmp(1,nAtoms)
   dbsc(i)%fMass     =rDmp(2,nAtoms)
   dbsc(i)%CntMass   =rDmp(3,nAtoms)
   nAtoms=nAtoms+1
   dbsc(i)%ExpNuc    =rDmp(1,nAtoms)
   dbsc(i)%w_mGauss  =rDmp(2,nAtoms)
End Do
Call mma_deallocate(rDmp)
!
If (nAux.gt.0) Then
   Call qpg_dArray('rDmp:A',Found,Len)
!  Write (*,*) 'nAux=',nAux
   Call mma_allocate(rDmp,nAux,1,Label='rDmp')
   Call Get_dArray('rDmp:A',rDmp,Len)
   nAux=0
   Do i = 1, nCnttp
!
!     ECP stuff
!
      nM1 = dbsc(i)%nM1
      If (nM1.gt.0) Then
         If (.Not.Allocated(dbsc(i)%M1xp)) Call mma_allocate(dbsc(i)%M1xp,nM1,Label='dbsc:M1xp')
         dbsc(i)%M1xp(:)=rDmp(nAux+1:nAux+nM1,1)
         nAux=nAux+nM1
         If (.Not.Allocated(dbsc(i)%M1cf)) Call mma_allocate(dbsc(i)%M1cf,nM1,Label='dbsc:M1cf')
         dbsc(i)%M1cf(:)=rDmp(nAux+1:nAux+nM1,1)
         nAux=nAux+nM1
!        Call RecPrt('M1xp',' ',dbsc(i)%M1xp,1,nM1)
!        Call RecPrt('M1cf',' ',dbsc(i)%M1cf,1,nM1)
      End If
      nM2 = dbsc(i)%nM2
      If (nM2.gt.0) Then
         If (.Not.Allocated(dbsc(i)%M2xp)) Call mma_allocate(dbsc(i)%M2xp,nM2,Label='dbsc:M2xp')
         dbsc(i)%M2xp(:)=rDmp(nAux+1:nAux+nM2,1)
         nAux=nAux+nM2
         If (.Not.Allocated(dbsc(i)%M2cf)) Call mma_allocate(dbsc(i)%M2cf,nM2,Label='dbsc:M2cf')
         dbsc(i)%M2cf(:)=rDmp(nAux+1:nAux+nM2,1)
         nAux=nAux+nM2
!        Call RecPrt('M2xp',' ',dbsc(i)%M2xp,1,nM2)
!        Call RecPrt('M2cf',' ',dbsc(i)%M2cf,1,nM2)
      End If
!
!     Fragment stuff
!
      nFragType  =dbsc(i)%nFragType
      If (nFragType.gt.0) Then
         If (.Not.Allocated(dbsc(i)%FragType)) Call mma_allocate(dbsc(i)%FragType,nFrag_LineWords,nFragType,Label='FragType')
         qDmp(1:nFrag_LineWords,1:nFragType) => rDmp(nAux+1:nAux+nFrag_LineWords*nFragType,1)
         dbsc(i)%FragType(:,:)=qDmp(:,:)
         nAux=nAux+nFrag_LineWords*nFragType
         Nullify(qDmp)
      End If
      nFragCoor  =Max(0,dbsc(i)%nFragCoor)
      If (nFragCoor.gt.0) Then
         If (.Not.Allocated(dbsc(i)%FragCoor)) Call mma_allocate(dbsc(i)%FragCoor,5,nFragCoor,Label='FragCoor')
         qDmp(1:5,1:nFragCoor) => rDmp(nAux+1:nAux+5*nFragCoor,1)
         dbsc(i)%FragCoor(:,:)=qDmp(:,:)
         nAux=nAux+5*nFragCoor
         Nullify(qDmp)
      End If
      nFragEner  =dbsc(i)%nFragEner
      If (nFragEner.gt.0) Then
         If (.Not.Allocated(dbsc(i)%FragEner)) Call mma_allocate(dbsc(i)%FragEner,nFragEner,Label='FragEner')
         pDmp(1:nFragEner) => rDmp(nAux+1:nAux+nFragEner,1)
         dbsc(i)%FragEner(:)=pDmp(:)
         nAux=nAux+nFragEner
         Nullify(pDmp)
      End If
      nFragDens  =dbsc(i)%nFragDens
      If (nFragDens*nFragEner.gt.0) Then
         If (.Not.Allocated(dbsc(i)%FragCoef)) Call mma_allocate(dbsc(i)%FragCoef,nFragDens,nFragEner,Label='FragCoef')
         qDmp(1:nFragDens,1:nFragEner) => rDmp(nAux+1:nAux+nFragDens*nFragEner,1)
         dbsc(i)%FragCoef(:,:)=qDmp(:,:)
         nAux=nAux+nFragDens*nFragEner
         Nullify(qDmp)
      End If
   End Do
   Call mma_deallocate(rDmp)
End If
!
If (nAux2.gt.0) Then
   Call qpg_dArray('rDmp:S',Found,Len)
   Call mma_allocate(rDmp,nAux2,1,Label='rDmp')
   Call Get_dArray('rDmp:S',rDmp,Len)
   nAux2=0
   Do i = 1, Max_Shells-1

      nBk=Shells(i)%nBK
      If (nBk.gt.0) Then
         If (.Not.Allocated(Shells(i)%Bk)) Call mma_allocate(Shells(i)%Bk,nBk,Label='Bk')
         Shells(i)%Bk(:)=rDmp(nAux2+1:nAux2+nBk,1)
         nAux2=nAux2+nBk
         If (.Not.Allocated(Shells(i)%Occ)) Call mma_allocate(Shells(i)%Occ,nBk,Label='Occ')
         Shells(i)%Occ(:)=rDmp(nAux2+1:nAux2+nBk,1)
         nAux2=nAux2+nBk
      End If

      nAkl=Shells(i)%nAkl
      If (nAkl.gt.0) Then
         If (.Not.Allocated(Shells(i)%Akl)) Call mma_allocate(Shells(i)%Akl,nAkl,nAkl,2,Label='Akl')
         Call DCopy_(2*nAkl**2,rDmp(nAux2+1,1),1,Shells(i)%Akl,1)
         nAux2=nAux2+2*nAkl**2
      End If

      nFockOp=Shells(i)%nFockOp
      If (nFockOp.gt.0) Then
         If (.Not.Allocated(Shells(i)%FockOp)) Call mma_allocate(Shells(i)%FockOp,nFockOp,nFockOp,Label='FockOp')
         Call DCopy_(nFockOp**2,rDmp(nAux2+1,1),1,Shells(i)%FockOp,1)
         nAux2=nAux2+nFockOp**2
      End If

      nExp=Shells(i)%nExp
      If (nExp.gt.0) Then
         If (.Not.Allocated(Shells(i)%Exp)) Call mma_allocate(Shells(i)%Exp,nExp,Label='Exp')
         Call DCopy_(nExp,rDmp(nAux2+1,1),1,Shells(i)%Exp,1)
         nAux2=nAux2+nExp
      End If

      nBasis=Shells(i)%nBasis
      If (nExp*nBasis.gt.0) Then
         If (.Not.Allocated(Shells(i)%Cff_p)) Call mma_allocate(Shells(i)%Cff_p,nExp,nExp,2,Label='Cff_p')
         Call DCopy_(2*nExp**2,rDmp(nAux2+1,1),1,Shells(i)%Cff_p,1)
         nAux2=nAux2+2*nExp**2
      End If

      If (nExp*nBasis.gt.0) Then
         If (.Not.Allocated(Shells(i)%Cff_c)) Call mma_allocate(Shells(i)%Cff_c,nExp,nBasis,2,Label='Cff_c')
         Call DCopy_(2*nExp*nBasis,rDmp(nAux2+1,1),1,Shells(i)%Cff_c,1)
         nAux2=nAux2+2*nExp*nBasis
!
         If (.Not.Allocated(Shells(i)%pCff)) Call mma_allocate(Shells(i)%pCff,nExp,nBasis,Label='Cff')
         Shells(i)%pCff(:,:)=Shells(i)%Cff_c(:,:,1)
      End If
   End Do
   Call mma_deallocate(rDmp)
End If
!
!  Character stuff
!
Call mma_allocate(cDmp,nCnttp,Label='cDmp')
lcDmp=160*nCnttp
Call Get_cArray('cDmp',cDmp(1),lcDmp)
Do i = 1, nCnttp
   dbsc(i)%Bsl    =cDmp(i)(1:80)
   dbsc(i)%Bsl_Old=cDmp(i)(81:160)
End Do
Call mma_deallocate(cDmp)
#ifdef _DEBUGPRINT_
Write (6,*)
Write (6,*) 'Coordinates:'
Do i = 1, nCnttp
   Do j = 1, dbsc(i)%nCntr
      Write (6,*) dbsc(i)%Coor(:,j)
   End Do
End Do
Write (6,*)
Write (6,*) 'Exit Basis_Info_Get'
Write (6,*)
#endif
Return
End Subroutine Basis_Info_Get
!
!***********************************************************************
!***********************************************************************
!
Subroutine Basis_Info_Free()
Integer i
#ifdef _DEBUGPRINT_
Write (6,*) 'Basis_Info_Free()'
#endif
!
!     Deallocate all allocatable parts of dbsc.
!
Do i = 1, nCnttp
!
!  Molecular Coordinates
!
   If (dbsc(i)%nCntr.gt.0) Then
       If (.NOT.dbsc(i)%Aux.or.i.eq.iCnttp_Dummy) Then
          Call mma_deallocate(dbsc(i)%Coor_Hidden)
       End If
       Nullify(dbsc(i)%Coor)
       dbsc(i)%nCntr=0
   End If
!
!  ECP stuff
!
   If (allocated(dbsc(i)%M1xp)) Call mma_deallocate(dbsc(i)%M1xp)
   If (allocated(dbsc(i)%M1cf)) Call mma_deallocate(dbsc(i)%M1cf)
   dbsc(i)%nM1=0
   If (allocated(dbsc(i)%M2xp)) Call mma_deallocate(dbsc(i)%M2xp)
   If (allocated(dbsc(i)%M2cf)) Call mma_deallocate(dbsc(i)%M2cf)
   dbsc(i)%nM2=0
!
!  Fragment stuff
!
   If (allocated(dbsc(i)%FragType)) Call mma_deallocate(dbsc(i)%FragType)
   dbsc(i)%nFragType=0
   If (allocated(dbsc(i)%FragCoor)) Call mma_deallocate(dbsc(i)%FragCoor)
   dbsc(i)%nFragCoor=0
   If (allocated(dbsc(i)%FragEner)) Call mma_deallocate(dbsc(i)%FragEner)
   dbsc(i)%nFragEner=0
   If (allocated(dbsc(i)%FragCoef)) Call mma_deallocate(dbsc(i)%FragCoef)
   dbsc(i)%nFragDens=0
!
!  PAM2 stuff
!
   If (allocated(dbsc(i)%PAM2)) Call mma_deallocate(dbsc(i)%PAM2)
   dbsc(i)%nPAM2=-1
End Do
nCnttp=0
iCnttp_Dummy=0
!
!     Stuff on unqiue basis set shells
!
Do i = 1, Max_Shells-1
   If (Allocated(Shells(i)%Bk)) Call mma_deallocate(Shells(i)%Bk)
   If (Allocated(Shells(i)%Occ)) Call mma_deallocate(Shells(i)%Occ)
   Shells(i)%nBk =0
   If (Allocated(Shells(i)%Akl)) Call mma_deallocate(Shells(i)%Akl)
   Shells(i)%nAkl=0
   If (Allocated(Shells(i)%FockOp)) Call mma_deallocate(Shells(i)%FockOp)
   Shells(i)%nFockOp=0
   If (Allocated(Shells(i)%Exp)) Call mma_deallocate(Shells(i)%Exp)
   Shells(i)%nExp=0
   If (Allocated(Shells(i)%pCff)) Call mma_deallocate(Shells(i)%pCff)
   If (Allocated(Shells(i)%Cff_c)) Call mma_deallocate(Shells(i)%Cff_c)
   If (Allocated(Shells(i)%Cff_p)) Call mma_deallocate(Shells(i)%Cff_p)
   Shells(i)%nBasis=0
   Shells(i)%Transf=.True.
End Do
Max_Shells=0
!
If (Allocated(dbsc))   Deallocate(dbsc)
If (Allocated(Shells)) Deallocate(Shells)
Initiated=.False.
!
Return
End Subroutine Basis_Info_Free
!
!***********************************************************************
!***********************************************************************
!
End Module Basis_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GF_Print(EVal,EVec,dDipM,iel,nDoF,nDim,ictl,IRInt,RedM,Lu_10,iOff)

use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Three, Four, aTokg, cLight, diel, elcharge, rNAVO
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iel, nDoF, nDim, ictl, Lu_10, iOff
real(kind=wp), intent(in) :: EVal(nDim), EVec(nDoF,nDim), dDipM(nDim,iel), RedM(nDim)
real(kind=wp), intent(out) :: IRInt(nDim)
integer(kind=iwp), parameter :: Inc = 6
integer(kind=iwp) :: i, iHarm, iInt, iIRInt, j, Jnc, l, nChDisp
real(kind=wp) :: Tmp(Inc)
character(len=LenIn+6) :: Label
character(len=120) :: Line
character(len=80) :: frmt
character(len=LenIn+6), allocatable :: ChDisp(:)
real(kind=wp), parameter :: RF = rNAVO/(Three*cLight**2)/(Four*diel)*elcharge**2/aTokg/1.0e3_wp

call Get_iScalar('nChDisp',nChDisp)
call mma_allocate(ChDisp,nChDisp,label='ChDisp')
call Get_cArray('ChDisp',ChDisp,(LenIn+6)*nChDisp)

iIRInt = 0
do iHarm=1,nDim,Inc
  Jnc = min(Inc,nDim-iHarm+1)
  Label = ' '
  write(frmt,'(A,I3,A)') '(5X,A,1x,',Jnc,'(I7,3X))'
  write(u6,frmt) Label,(i,i=iHarm,iHarm+Jnc-1)
  write(u6,*)

  Label = 'Frequency:'
  write(frmt,'(A,I3,A)') '(5X,A,1x,',Jnc,'F10.2)'
  Line = ' '
  write(Line,frmt) Label,(EVal(i),i=iHarm,iHarm+Jnc-1)

  ! Replace minus signs with sign for imaginary unit.

  do i=1,120
    if (Line(i:i) == '-') Line(i:i) = 'i'
  end do
  write(u6,'(A)') Line
  write(u6,*)

  if (ictl /= 0) then
    Label = 'Intensity:'
    write(frmt,'(A,I3,A)') '(5X,A,1x,',Jnc,'ES10.3)'
    Tmp(1:Jnc) = Zero
    do l=1,iel
      Tmp(1:Jnc) = Tmp(1:Jnc)+dDipM(iHarm:iHarm+Jnc-1,l)**2
    end do
    write(u6,frmt) Label,(RF*Tmp(i),i=1,Jnc)
    IRInt(iIRInt+1:iIRInt+Jnc) = RF*Tmp(1:Jnc)
    iIRInt = iIRInt+Jnc
    Label = 'Red. mass:'
    write(frmt,'(A,I3,A)') '(5X,A,1x,',Jnc,'F10.5)'
    write(u6,frmt) Label,(RedM(i),i=iHarm,iHarm+Jnc-1)
    write(u6,*)
  else
    IRInt(iIRInt+1:iIRInt+Jnc) = Zero
    iIRInt = iIRInt+Jnc
  end if

  write(frmt,'(A,I3,A)') '(5X,A,1x,',Jnc,'F10.5)'
  do iInt=1,nDoF
    write(u6,frmt) ChDisp(iInt+iOff),(EVec(iInt,i),i=iHarm,iHarm+Jnc-1)
  end do
  write(u6,*)
  write(u6,*)
end do
call mma_deallocate(ChDisp)

Line = '*FREQUENCIES'
call WRH(Lu_10,1,[nDoF],[nDim],EVec,EVal,1,Line)

if (ictl /= 0) then
  !write(Lu_10,*) '*BEGIN PROJECTED DIPOLE TRANSITIONS'
  Line = '*DIPOLE TRANSITIONS'
  do j=1,iel
    call WRH(Lu_10,1,[nDim],[nDim],[Zero],dDipM(1,j),2,Line)
  end do
  !write(Lu_10,*) '*END PROJECTED DIPOLE TRANSITIONS'
end if

return

end subroutine GF_Print

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_VecBuf_Print(Lupri,nSym)
C
C     Purpose: print allocation information of Cholesky vector buffer to
C              unit Lupri (if Lupri<1 nothing is printed).
C
      Implicit None
      Integer Lupri, nSym
#include "chovecbuf.fh"

      Character*16 SecNam
      Parameter (SecNam = 'Cho_VecBuf_Print')

      Integer     iSym
      Real*8      xGb
      Character*2 Unt

      If (Lupri .lt. 1) Return
      If (nSym.lt.1 .or. nSym.gt.8) Then
         Call Cho_Quit('nSym error in '//SecNam,104)
      End If

      Call Cho_Head('Size of Cholesky vector buffer','-',80,Lupri)
      Write(Lupri,*)
      Do iSym = 1,nSym
         Call Cho_Word2Byte(l_ChVBuf_Sym(iSym),8,xGb,Unt)
         Write(Lupri,'(A,I2,A,I10,A,F8.2,A,A,A)')
     &   'Dimension, sym.',iSym,': ',l_ChVBuf_Sym(iSym),
     &   ' 8-byte words (',xGb,' ',Unt,')'
      End Do
      Call Cho_Word2Byte(l_ChVBuf,8,xGb,Unt)
      Write(Lupri,'(/,A,I10,A,F8.2,A,A,A)')
     & 'Total dimension  : ',l_ChVBuf,' 8-byte words (',xGb,' ',Unt,')'

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MAGN(EXCH,N,X,Y,Z,H,W,zJ,THRS,dM,sM,nT,T,sopt,WZ,ZB,S,M,m_paranoid,DBG)
! this Subroutine is a wrapper for various MAGN subroutines

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: EXCH, N, nT
real(kind=wp), intent(in) :: X, Y, Z, H, W(EXCH), zJ, THRS, T(nT)
complex(kind=wp), intent(in) :: dM(3,EXCH,EXCH), sM(3,EXCH,EXCH)
logical(kind=iwp), intent(in) :: sopt, m_paranoid, DBG
real(kind=wp), intent(out) :: WZ(N), ZB(nT), S(3,nT), M(3,nT)

if (abs(zJ) < tiny(zJ)) then

  if (DBG) write(u6,*) 'Enter MAGN_NO_MF :'

  call MAGN_NO_MF(EXCH,N,X,Y,Z,H,W,dM,sM,nT,T,sopt,WZ,ZB,S,M,DBG)

  if (DBG) write(u6,*) 'Exit MAGN_NO_MF :'

else ! zJ /= 0.0

  if (DBG) write(u6,*) 'Enter MAGN_ZJ_PAR :'

  call MAGN_ZJ_PAR(EXCH,N,X,Y,Z,H,W,zJ,dM,sM,nT,T,sopt,WZ,ZB,S,M,thrs,m_paranoid,DBG)

  if (DBG) write(u6,*) 'Exit MAGN_ZJ_PAR :'

end if

return

end subroutine MAGN

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LDF_CheckConfig()

#ifdef _MOLCAS_MPP_
use Para_Info, only: nProcs, Is_Real_Par
#endif
use Definitions, only: u6

implicit none
#include "localdf.fh"

! Debug write of unconstrained coefficients:
! 1) makes no sense for unconstrained LDF => reset
! 2) not implemented in parallel => error
WriteUnconstrainedC = WriteUnconstrainedC .and. (LDF_Constraint /= -1)
#ifdef _MOLCAS_MPP_
if (WriteUnconstrainedC) then
  if ((nProcs > 1) .and. Is_Real_Par()) then
    call WarningMessage(2,'Write unconstrained coefficients not implemented in parallel')
    call Quit_OnUserError()
  end if
end if
#endif
! Using unique atom pairs is buggy, warn!
if (UseUniqueAtomPairs) then
  call WarningMessage(1,'WARNING: using unique atom pairs may cause erroneous results')
  call xFlush(u6)
end if

return

end subroutine LDF_CheckConfig

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Roland Lindh                                     *
************************************************************************
      Subroutine DFT_Int(Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
     &                   FckInt,nFckInt,SOTemp,nSOTemp,
     &                   TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
     &                   nSym,iSpin,Flop,Rho,nRho,Scr,mScr,
     &                   Fact,ndc,mAO,TabAOMax,T_X,
     &                   list_bas,Functional_type,nAOMax)
************************************************************************
*                                                                      *
* Object: Front-end for compting DFT integrals                         *
*                                                                      *
*      Author:Roland Lindh, Dept. of Theor. Chem., Lund Unibersity,   ,*
*             SWEDEN. November 2008                                    *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      External Do_NInt1_d, Do_nInt1,
     &         Do_NInt2_d, Do_nInt2,
     &         Do_NInt3_d, Do_nInt3,
     &         Do_NInt4_d, Do_nInt4
#include "functional_types.fh"
      Integer Functional_type
      Real*8 Weights(mGrid), SOTemp(nSOTemp,iSpin), Fact(ndc**2),
     &       TabAO(nTabAO), Scr(mScr), Rho(nRho,mGrid),
     &       AOInt(nAOInt*nAOInt,iSpin), FckInt(nFckInt,iSpin),
     &       dF_dRho(ndF_dRho,mGrid), TabAOMax(nlist_s)
      Integer list_s(2,nlist_s), ipTabAO(nlist_s), list_bas(2,nlist_s)
*                                                                      *
************************************************************************
*                                                                      *
      If (Functional_type.eq.LDA_type) Then
         nFn=1
         nScr=iSpin*nFn*nAOMax
         Call DFT_IntX(Do_NInt1_d,Do_NInt1,
     &                 Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
     &                 FckInt,nFckInt,SOTemp,nSOTemp,
     &                 TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
     &                 nSym,iSpin,Flop,Rho,nRho,Scr,nScr,
     &                 Fact,ndc,mAO,TabAOMax,T_X,
     &                 list_bas,nFn)
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Functional_type.eq.GGA_type) Then
         nFn=4
         nScr=iSpin*nFn*nAOMax
         Call DFT_IntX(Do_NInt2_d,Do_NInt2,
     &                 Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
     &                 FckInt,nFckInt,SOTemp,nSOTemp,
     &                 TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
     &                 nSym,iSpin,Flop,Rho,nRho,Scr,nScr,
     &                 Fact,ndc,mAO,TabAOMax,T_X,
     &                 list_bas,nFn)
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Functional_type.eq.meta_GGA_type1) Then
         nFn=4
         nScr=iSpin*nFn*nAOMax
         Call DFT_IntX(Do_NInt4_d,Do_NInt4,
     &                 Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
     &                 FckInt,nFckInt,SOTemp,nSOTemp,
     &                 TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
     &                 nSym,iSpin,Flop,Rho,nRho,Scr,nScr,
     &                 Fact,ndc,mAO,TabAOMax,T_X,
     &                 list_bas,nFn)
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Functional_type.eq.meta_GGA_type2) Then
         nFn=5
         nScr=iSpin*nFn*nAOMax
         Call DFT_IntX(Do_NInt3_d,Do_NInt3,
     &                 Weights,mGrid,list_s,nlist_s,AOInt,nAOInt,
     &                 FckInt,nFckInt,SOTemp,nSOTemp,
     &                 TabAO,ipTabAO,nTabAO,dF_dRho,ndF_dRho,
     &                 nSym,iSpin,Flop,Rho,nRho,Scr,nScr,
     &                 Fact,ndc,mAO,TabAOMax,T_X,
     &                 list_bas,nFn)
*                                                                      *
************************************************************************
*                                                                      *
      Else
         Write (6,*) 'DFT_Int: Illegal functional type!'
         Call Abend()
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!----------------------------------------------------------------------*
! Define files ( file names and unit numbers )                         *
!----------------------------------------------------------------------*
! FnOne, LuOne - logical file name and unit for one-electron integral  *
!                file                                                  *
! FnOrd, LuOrd - logical file name and unit for two-electron integral  *
!                file                                                  *
! FnOut, LuOut - logical file name and unit for output orbitals file   *
! FnInp, LuInp - logical file name and unit for input orbitals file    *
! FnDns, LuDns - logical file name and unit for input density file     *
! FnDOu, LuDOu - logical file name and unit for output density file    *
! FnDSt, LuDSt - logical file name and unit for file with density      *
!                differences                                           *
! FnOSt, LuOSt - logical file name and unit for file with dVxcdRa      *
!                contributions                                         *
! FnTSt, LuTSt - logical file name and unit for file with two-electron *
!                contributions                                         *
! FnGrd, LuGrd - logical file name and unit for file with gradients    *
!                used in DIIS                                          *
! FnlGd, LulGd - logical file name and unit for file with local grad.  *
!                used in DIIS                                          *
! FnDGd, LuDGd - logical file name and unit for file with gradient     *
!                differences of subsequent SO steps                    *
! Fnx, Lux     - logical file name and unit for file with orbital      *
!                rotation parameters x (for DIIS/QNR)                  *
! FnDel, LuDel - logical file name and unit for file with Delta for    *
!                recursive calculation of                              *
! Fny, Luy     - logical file name and unit for file with y-vector for *
!                recursive calculation of Dn=-HnGn (H:inv Hessian orb  *
!                rot) 2nd order update                                 *
!----------------------------------------------------------------------*

module SCFFiles

use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: LuDel = 39, LuDGd = 37, LuDSt = 34, LuGrd = 36, LuInp = 25, LulGd = 41, LuOne = 10, LuOrd = 40, LuOSt = 40, &
                     LuOut = 20, LuTSt = 35, Lux = 38, Luy = 29
character(len=8), parameter :: FnDel = 'SODELTA', FnDGd = 'SODGRAD', FnDSt = 'DNSMAT', FnGrd = 'GRADIENT', FnlGd = 'LOCGRAD', &
                               FnOne = 'ONEINT', FnOrd = 'ORDINT', FnOSt = 'DVXCDR', FnOut = 'SCFORB', FnTSt = 'TWOHAM', &
                               Fnx = 'SOXVEC', Fny = 'SOYVEC'

public :: FnDel, FnDGd, FnDSt, FnGrd, FnlGd, FnOne, FnOrd, FnOSt, FnOut, FnTSt, Fnx, Fny, LuDel, LuDGd, LuDSt, LuGrd, LuInp, &
          LulGd, LuOne, LuOrd, LuOSt, LuOut, LuTSt, Lux, Luy

end module SCFFiles

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995, Roland Lindh                                *
!***********************************************************************

subroutine DrvN1(Grad,Temp,nGrad)
!***********************************************************************
!                                                                      *
! Object: to compute the molecular gradient contribution due to the    *
!         nuclear repulsion energy.                                    *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!                                                                      *
!             Modified for ECP's and external electric fields, May '95 *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use PCM_arrays, only: PCM_SQ, PCMTess, MM
use External_Centers, only: iXPolType, nOrd_XF, nXF, XF
use Symmetry_Info, only: iChBas, nIrrep
use Constants, only: Zero, One, Two, Three, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Temp(nGrad)
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"
#include "rctfld.fh"
integer(kind=iwp) :: iCar, iChxyz, iCnt, iCnttp, iComp, iDCRR(0:7), iDum, iFd, igu, igv, iIrrep, iM1xp, iM2xp, ip, iPrint, iR, &
                     iRout, iStb(0:7), iTs, ix, iy, iz, jCnt, jCntMx, jCnttp, jCoSet(8,8), LmbdR, mdc, nCav, ndc, nDCRR, nDisp, &
                     nOp, nStb
real(kind=wp) :: A(3), B(3), CCoMx, CCoMxd, CCoMy, CCoMyd, CCoMz, CCoMzd, CffM1, CffM2, Cnt0M1, Cnt0M2, Cnt1M1, Cnt1M2, DA(3), &
                 DARB, df_dr, dfab, dr_dA, dr_dB, fab, fab0, fab1, fab2, Fact, Gam, PreFct, ps, r12, RB(3), Tempd(3), ZA, ZAZB, ZB
logical(kind=iwp) :: EQ, TstFnc, NoLoop
character(len=80) :: Lab
integer(kind=iwp), external :: iChAtm, iPrmt, NrOpr

iRout = 33
iPrint = nPrint(iRout)
!iPrint = 15

iIrrep = 0

!***********************************************************************
!                                                                      *
!            Compute the nuclear repulsion contribution                *
!                                                                      *
!***********************************************************************

Temp(:) = Zero

mdc = 0
! Loop over centers with the same charge
do iCnttp=1,nCnttp
  if (iCnttp > 1) mdc = mdc+dbsc(iCnttp-1)%nCntr
  if (dbsc(iCnttp)%Frag) then
    ZA = dbsc(iCnttp)%FragCharge
  else
    ZA = dbsc(iCnttp)%Charge
  end if
  if (ZA == Zero) cycle
  ! Loop over all unique centers of this group
  do iCnt=1,dbsc(iCnttp)%nCntr
    A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

    ndc = 0
    do jCnttp=1,iCnttp
      if (jCnttp > 1) ndc = ndc+dbsc(jCnttp-1)%nCntr
      if (dbsc(jCnttp)%Frag) then
        ZB = dbsc(jCnttp)%FragCharge
      else
        ZB = dbsc(jCnttp)%Charge
      end if
      if (ZB == Zero) cycle
      if (dbsc(iCnttp)%pChrg .and. dbsc(jCnttp)%pChrg) cycle
      if (dbsc(iCnttp)%Frag .and. dbsc(jCnttp)%Frag) cycle
      ZAZB = ZA*ZB
      jCntMx = dbsc(jCnttp)%nCntr
      if (iCnttp == jCnttp) jCntMx = iCnt
      do jCnt=1,jCntMx
        B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

        Fact = One
        ! Factor due to resticted summation
        if (EQ(A,B)) Fact = Half

        ! Find the DCR for the two centers

        call DCR(LmbdR,dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,iDCRR,nDCRR)

        PreFct = Fact*ZAZB*real(nIrrep,kind=wp)/real(LmbdR,kind=wp)
        do iR=0,nDCRR-1
          call OA(iDCRR(iR),B,RB)
          nOp = NrOpr(iDCRR(iR))
          if (EQ(A,RB)) cycle
          r12 = sqrt((A(1)-RB(1))**2+(A(2)-RB(2))**2+(A(3)-RB(3))**2)

          ! The factor u/g will ensure that the value of the
          ! gradient in symmetry adapted and no symmetry basis
          ! will have the same value.

          fab = One
          dfab = Zero
          if (dbsc(iCnttp)%ECP) then
            ! Add contribution from M1 operator
            Cnt0M1 = Zero
            Cnt1M1 = Zero
            do iM1xp=1,dbsc(iCnttp)%nM1
              Gam = dbsc(iCnttp)%M1xp(iM1xp)
              CffM1 = dbsc(iCnttp)%M1cf(iM1xp)
              Cnt0M1 = Cnt0M1+(CffM1*exp(-Gam*r12**2))
              Cnt1M1 = Cnt1M1+Gam*(CffM1*exp(-Gam*r12**2))
            end do
            fab = fab+Cnt0M1
            dfab = dfab-Two*r12*Cnt1M1
            ! Add contribution from M2 operator
            Cnt0M2 = Zero
            Cnt1M2 = Zero
            do iM2xp=1,dbsc(iCnttp)%nM2
              Gam = dbsc(iCnttp)%M2xp(iM2xp)
              CffM2 = dbsc(iCnttp)%M2cf(iM2xp)
              Cnt0M2 = Cnt0M2+(CffM2*exp(-Gam*r12**2))
              Cnt1M2 = Cnt1M2+Gam*(CffM2*exp(-Gam*r12**2))
            end do
            fab = fab+r12*Cnt0M2
            dfab = dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
          end if
          if (dbsc(jCnttp)%ECP) then
            ! Add contribution from M1 operator
            Cnt0M1 = Zero
            Cnt1M1 = Zero
            do iM1xp=1,dbsc(jCnttp)%nM1
              Gam = dbsc(jCnttp)%M1xp(iM1xp)
              CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
              Cnt0M1 = Cnt0M1+(CffM1*exp(-Gam*r12**2))
              Cnt1M1 = Cnt1M1+Gam*(CffM1*exp(-Gam*r12**2))
            end do
            fab = fab+Cnt0M1
            dfab = dfab-Two*r12*Cnt1M1
            ! Add contribution from M2 operator
            Cnt0M2 = Zero
            Cnt1M2 = Zero
            do iM2xp=1,dbsc(jCnttp)%nM2
              Gam = dbsc(jCnttp)%M2xp(iM2xp)
              CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
              Cnt0M2 = Cnt0M2+(CffM2*exp(-Gam*r12**2))
              Cnt1M2 = Cnt1M2+Gam*(CffM2*exp(-Gam*r12**2))
            end do
            fab = fab+r12*Cnt0M2
            dfab = dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
          end if
          df_dr = (dfab*r12-fab)/r12**2

          if (.not. dbsc(iCnttp)%pChrg) then
            nDisp = IndDsp(mdc+iCnt,iIrrep)
            igu = nIrrep/dc(mdc+iCnt)%nStab
            do iCar=0,2
              dr_dA = (A(iCar+1)-RB(iCar+1))/r12
              iComp = 2**iCar
              if (TstFnc(dc(mdc+iCnt)%iCoSet,iIrrep,iComp,dc(mdc+iCnt)%nStab)) then
                nDisp = nDisp+1
                if (Direct(nDisp)) then
                  Temp(nDisp) = Temp(nDisp)+One/real(igu,kind=wp)*PreFct*dr_dA*df_dr
                end if
              end if
            end do
          end if

          if (.not. dbsc(jCnttp)%pChrg) then
            nDisp = IndDsp(ndc+jCnt,iIrrep)
            igv = nIrrep/dc(ndc+jCnt)%nStab
            do iCar=0,2
              dr_dB = -(A(iCar+1)-RB(iCar+1))/r12
              iComp = 2**iCar
              if (TstFnc(dc(ndc+jCnt)%iCoSet,iIrrep,iComp,dc(ndc+jCnt)%nStab)) then
                nDisp = nDisp+1
                if (Direct(nDisp)) then
                  ps = real(iPrmt(nOp,iChBas(2+iCar)),kind=wp)
                  Temp(nDisp) = Temp(nDisp)+ps*One/real(igv,kind=wp)*PreFct*dr_dB*df_dr
                end if
              end if
            end do
          end if
        end do

      end do
    end do
  end do
end do
if (iPrint >= 15) then
  Lab = ' The Nuclear Repulsion Contribution'
  call PrGrad(Lab,Temp,nGrad,ChDisp)
end if

call DaXpY_(nGrad,One,Temp,1,Grad,1)

!***********************************************************************
!                                                                      *
!           Compute contribution due to the external field             *
!                                                                      *
!***********************************************************************

if (allocated(XF)) then

  if ((nOrd_XF > 1) .or. (iXPolType > 0)) then
    call WarningMessage(2,'Error in DrvN1')
    write(u6,*) 'Sorry, gradients are not implemented for'
    write(u6,*) 'higher XF than dipoles or for polarisabilities'
    call Quit_OnUserError()
  end if

  Temp(:) = Zero

  iDum = 0
  do iFd=1,nXF
    ZA = XF(4,iFd)
    if (nOrd_XF == 0) then
      DA(1:3) = Zero
    else
      DA(1:3) = XF(5:7,iFd)
    end if
    NoLoop = (ZA == Zero) .and. (DA(1) == Zero) .and. (DA(2) == Zero) .and. (DA(3) == Zero)
    if (NoLoop) cycle
    A(1:3) = XF(1:3,iFd)
    iChxyz = iChAtm(A)
    call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)

    ndc = 0
    do jCnttp=1,nCnttp
      if (jCnttp > 1) ndc = ndc+dbsc(jCnttp-1)%nCntr
      ZB = dbsc(jCnttp)%Charge
      if (ZB == Zero) cycle
      if (dbsc(jCnttp)%pChrg) cycle
      if (dbsc(jCnttp)%Frag) cycle
      ZAZB = ZA*ZB
      do jCnt=1,dbsc(jCnttp)%nCntr
        B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

        ! Find the DCR for the two centers

        call DCR(LmbdR,iStb,nStb,dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,iDCRR,nDCRR)

        PreFct = real(nIrrep,kind=wp)/real(LmbdR,kind=wp)
        do iR=0,nDCRR-1
          call OA(iDCRR(iR),B,RB)
          nOp = NrOpr(iDCRR(iR))
          if (EQ(A,RB)) cycle
          r12 = sqrt((A(1)-RB(1))**2+(A(2)-RB(2))**2+(A(3)-RB(3))**2)
          DARB = DA(1)*(A(1)-RB(1))+DA(2)*(A(2)-RB(2))+DA(3)*(A(3)-RB(3))

          ! The factor u/g will ensure that the value of the
          ! gradient in symmetry adapted and no symmetry basis
          ! will have the same value.

          fab0 = One
          fab1 = One
          fab2 = Three
          if (dbsc(jCnttp)%ECP) then
            ! Add contribution from M1 operator
            Cnt0M1 = Zero
            Cnt1M1 = Zero
            do iM1xp=1,dbsc(jCnttp)%nM1
              Gam = dbsc(jCnttp)%M1xp(iM1xp)
              CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
              Cnt0M1 = Cnt0M1+(CffM1*exp(-Gam*r12**2))
              Cnt1M1 = Cnt1M1+Gam*(CffM1*exp(-Gam*r12**2))
            end do
            fab0 = fab0+Cnt0M1-Two*r12**2*Cnt1M1
            fab1 = fab1+Cnt0M1
            fab2 = fab2+Three*Cnt0M1+Two*r12**2*Cnt1M1
            ! Add contribution from M2 operator
            Cnt0M2 = Zero
            Cnt1M2 = Zero
            do iM2xp=1,dbsc(jCnttp)%nM2
              Gam = dbsc(jCnttp)%M2xp(iM2xp)
              CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
              Cnt0M2 = Cnt0M2+(CffM2*exp(-Gam*r12**2))
              Cnt1M2 = Cnt1M2+Gam*(CffM2*exp(-Gam*r12**2))
            end do
            fab0 = fab0+Two*(r12*Cnt0M2-r12**3*Cnt1M2)
            fab1 = fab1+r12*Cnt0M2
            fab2 = fab2-Two*(r12*Cnt0M2-r12**3*Cnt1M2)
          end if

          nDisp = IndDsp(ndc+jCnt,iIrrep)
          igv = nIrrep/dc(ndc+jCnt)%nStab
          do iCar=0,2
            iComp = 2**iCar
            if (TstFnc(dc(ndc+jCnt)%iCoSet,iIrrep,iComp,dc(ndc+jCnt)%nStab)) then
              nDisp = nDisp+1
              if (Direct(nDisp)) then
                ps = real(iPrmt(nOp,iChBas(2+iCar)),kind=wp)
                Temp(nDisp) = Temp(nDisp)+ps*One/real(igv,kind=wp)*PreFct* &
                              (ZAZB*fab0*(A(iCar+1)-RB(iCar+1))/(r12**3)+ &
                               ZB*(fab1*DA(iCar+1)/(r12**3)-DARB*fab2*(A(iCar+1)-RB(iCar+1))/(r12**5)))
              end if
            end if
          end do   ! End loop over cartesian components, iCar

        end do     ! End loop over DCR operators, iR

      end do       ! End over centers, jCnt
    end do         ! End over basis set types, jCnttp
  end do           ! End of centers of the external field, iFD
  if (iPrint >= 15) then
    Lab = ' The Nuclear External Electric Field Contribution'
    call PrGrad(Lab,Temp,nGrad,ChDisp)
  end if

  call DaXpY_(nGrad,One,Temp,1,Grad,1)
end if

!***********************************************************************
!                                                                      *
!          Compute contributions due to the reaction field             *
!                 KirkWood Model                                       *
!                                                                      *
!***********************************************************************

if (lRF .and. (.not. lLangevin) .and. (.not. PCM)) then
  nCav = (lMax+1)*(lMax+2)*(lMax+3)/6

  ! Get the multipole moments

  call Get_dArray('RCTFLD',MM,nCav*2)
  if (iPrint >= 99) call RecPrt('Total Multipole Moments',' ',MM(1,1),1,nCav)
  if (iPrint >= 99) call RecPrt('Total Electric Field',' ',MM(1,2),1,nCav)

  Temp(:) = Zero

  ip = 0
  do ir=0,lMax
    do ix=ir,0,-1
      do iy=ir-ix,0,-1
        iz = ir-ix-iy
        ip = ip+1
        if (iPrint >= 99) write(u6,*) ' ix,iy,iz=',ix,iy,iz

        mdc = 0
        do iCnttp=1,nCnttp
          if (iCnttp > 1) mdc = mdc+dbsc(iCnttp-1)%nCntr
          if (dbsc(iCnttp)%Charge == Zero) cycle
          if (dbsc(iCnttp)%Frag) cycle
          ZA = dbsc(iCnttp)%Charge
          if (iPrint >= 99) then
            write(u6,*) ' Charge=',ZA
            call RecPrt(' Centers',' ',dbsc(iCnttp)%Coor,3,dbsc(iCnttp)%nCntr)
          end if
          do iCnt=1,dbsc(iCnttp)%nCntr
            A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

            if (ix == 0) then
              CCoMx = One
              CCoMxd = Zero
            else if (ix == 1) then
              CCoMx = A(1)
              CCoMxd = One
            else
              CCoMx = A(1)**ix
              CCoMxd = real(ix,kind=wp)*A(1)**(ix-1)
            end if

            if (iy == 0) then
              CCoMy = One
              CCoMyd = Zero
            else if (iy == 1) then
              CCoMy = A(2)
              CCoMyd = One
            else
              CCoMy = A(2)**iy
              CCoMyd = real(iy,kind=wp)*A(2)**(iy-1)
            end if

            if (iz == 0) then
              CCoMz = One
              CCoMzd = Zero
            else if (iz == 1) then
              CCoMz = A(3)
              CCoMzd = One
            else
              CCoMz = A(3)**iz
              CCoMzd = real(iz,kind=wp)*A(3)**(iz-1)
            end if
            tempd(1) = MM(ip,2)*ZA*CCoMxd*CCoMy*CCoMz
            tempd(2) = MM(ip,2)*ZA*CCoMx*CCoMyd*CCoMz
            tempd(3) = MM(ip,2)*ZA*CCoMx*CCoMy*CCoMzd
            if (iPrint >= 99) then
              write(u6,*) CCoMx,CCoMy,CCoMz
              write(u6,*) 'tempd=',tempd
            end if

            ! Distribute gradient

            nDisp = IndDsp(mdc+iCnt,iIrrep)
            do iCar=0,2
              iComp = 2**iCar
              if (TstFnc(dc(mdc+iCnt)%iCoSet,iIrrep,iComp,dc(mdc+iCnt)%nStab)) then
                nDisp = nDisp+1
                if (Direct(nDisp)) then
                  Temp(nDisp) = Temp(nDisp)-Tempd(iCar+1)
                end if
              end if
            end do

          end do
        end do

      end do
    end do
  end do
  if (iPrint >= 15) then
    Lab = ' The Nuclear Reaction Field (KirkWood) Contribution'
    call PrGrad(Lab,Temp,nGrad,ChDisp)
  end if

  call DaXpY_(nGrad,One,Temp,1,Grad,1)

else if (lRF .and. PCM) then

!***********************************************************************
!                                                                      *
!          Compute contributions due to the reaction field             *
!                      PCM Model                                       *
!                                                                      *
!***********************************************************************

  Temp(:) = Zero

  ! Loop over tiles

  do iTs=1,nTs
    ZA = PCM_SQ(1,iTs)+PCM_SQ(2,iTS)
    NoLoop = ZA == Zero
    ZA = ZA/real(nIrrep,kind=wp)
    if (NoLoop) cycle
    A(1:3) = PCMTess(1:3,iTs)

    ! Tile only stabilized by the unit operator

    nStb = 1
    iStb(0) = 0

    ndc = 0
    do jCnttp=1,nCnttp
      if (jCnttp > 1) ndc = ndc+dbsc(jCnttp-1)%nCntr
      ZB = dbsc(jCnttp)%Charge
      if (ZB == Zero) cycle
      if (dbsc(jCnttp)%pChrg) cycle
      if (dbsc(jCnttp)%Frag) cycle
      ZAZB = ZA*ZB
      do jCnt=1,dbsc(jCnttp)%nCntr
        B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

        ! Find the DCR for the two centers

        call DCR(LmbdR,iStb,nStb,dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,iDCRR,nDCRR)

        PreFct = ZAZB*real(nIrrep,kind=wp)/real(LmbdR,kind=wp)
        do iR=0,nDCRR-1
          call OA(iDCRR(iR),B,RB)
          nOp = NrOpr(iDCRR(iR))
          if (EQ(A,RB)) cycle
          r12 = sqrt((A(1)-RB(1))**2+(A(2)-RB(2))**2+(A(3)-RB(3))**2)

          ! The factor u/g will ensure that the value of the
          ! gradient in symmetry adapted and no symmetry basis
          ! will have the same value.

          fab = One
          dfab = Zero
          if (dbsc(jCnttp)%ECP) then
            ! Add contribution from M1 operator
            Cnt0M1 = Zero
            Cnt1M1 = Zero
            do iM1xp=1,dbsc(jCnttp)%nM1
              Gam = dbsc(jCnttp)%M1xp(iM1xp)
              CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
              Cnt0M1 = Cnt0M1+(CffM1*exp(-Gam*r12**2))
              Cnt1M1 = Cnt1M1+Gam*(CffM1*exp(-Gam*r12**2))
            end do
            fab = fab+Cnt0M1
            dfab = dfab-Two*r12*Cnt1M1
            ! Add contribution from M2 operator
            Cnt0M2 = Zero
            Cnt1M2 = Zero
            do iM2xp=1,dbsc(jCnttp)%nM2
              Gam = dbsc(jCnttp)%M2xp(iM2xp)
              CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
              Cnt0M2 = Cnt0M2+(CffM2*exp(-Gam*r12**2))
              Cnt1M2 = Cnt1M2+Gam*(CffM2*exp(-Gam*r12**2))
            end do
            fab = fab+r12*Cnt0M2
            dfab = dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
          end if
          df_dr = (dfab*r12-fab)/r12**2

          nDisp = IndDsp(ndc+jCnt,iIrrep)
          igv = nIrrep/dc(ndc+jCnt)%nStab
          do iCar=0,2
            dr_dB = -(A(iCar+1)-RB(iCar+1))/r12
            iComp = 2**iCar
            if (TstFnc(dc(ndc+jCnt)%iCoSet,iIrrep,iComp,dc(ndc+jCnt)%nStab)) then
              nDisp = nDisp+1
              if (Direct(nDisp)) then
                ps = real(iPrmt(nOp,iChBas(2+iCar)),kind=wp)
                Temp(nDisp) = Temp(nDisp)+ps*One/real(igv,kind=wp)*PreFct*dr_dB*df_dr
              end if
            end if
          end do   ! End loop over cartesian components, iCar

        end do     ! End loop over DCR operators, iR

      end do       ! End over centers, jCnt
    end do         ! End over basis set types, jCnttp
  end do           ! End of tiles

  if (iPrint >= 15) then
    Lab = ' The Nuclear Reaction Field (PCM) Contribution'
    call PrGrad(Lab,Temp,nGrad,ChDisp)
  end if

  call DaXpY_(nGrad,One,Temp,1,Grad,1)

  ! Add contribution due to the tiles.

  Temp(:) = Zero
  call PCM_Cav_grd(Temp,nGrad)
  if (iPrint >= 15) then
    Lab = ' The Cavity PCM Contribution'
    call PrGrad(Lab,Temp,nGrad,ChDisp)
  end if
  call DaXpY_(nGrad,One,Temp,1,Grad,1)

  ! Add contribution due to the electric field on the tiles.

  if (Conductor) then
    Temp(:) = Zero
    call PCM_EF_grd(Temp,nGrad)
    if (iPrint >= 15) then
      Lab = ' The EF PCM Contribution'
      call PrGrad(Lab,Temp,nGrad,ChDisp)
    end if
    call DaXpY_(nGrad,-One,Temp,1,Grad,1)
  end if

end if

return

end subroutine DrvN1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Kntc_GIAO(Txyz,Rxyz,Wxyz,na,nb,nr,Alpha,Beta,nZeta)
************************************************************************
*                                                                      *
* Object: to assemble the cartesian components of the kinetic energy   *
*         integral from the cartesian components of the overlap        *
*         integral.                                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Txyz(nZeta,3,0:na  ,0:nb,  0:1),
     &       Rxyz(nZeta,3,0:na+1,0:nb+1,0:1),
     &       Wxyz(nZeta,3,0:na  ,0:nb  ,  2),
     &       Alpha(nZeta), Beta(nZeta)
      Character*80 Label
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 115
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.99) Then
         Call RecPrt(' In Kntc: Alpha',' ',Alpha,nZeta,1)
         Call RecPrt(' In Kntc: Beta ',' ',Beta ,nZeta,1)
         Do ia = 0, na+1
            Do ib = 0, nb+1
               Write (Label,'(A,I2,A,I2,A)')
     &               ' In Kntc: Rxyz(',ia,',',ib,',0)'
               Call RecPrt(Label,' ',Rxyz(1,1,ia,ib,0),nZeta,3)
               Write (Label,'(A,I2,A,I2,A)')
     &               ' In Kntc: Rxyz(',ia,',',ib,',1)'
               Call RecPrt(Label,' ',Rxyz(1,1,ia,ib,1),nZeta,3)
            End Do
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Do ia = 0, na
         Do ib = 0, nb
            If (ia.eq.0 .and. ib.eq.0) Then
               Do iCar = 1, 3
                  Do iZeta = 1, nZeta
                     Txyz(iZeta,iCar,ia,ib,0) =
     &                   Two * Alpha(iZeta) * Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib+1,0)
                     Txyz(iZeta,iCar,ia,ib,1) =
     &                   Two * Alpha(iZeta) * Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib+1,1)
                     Wxyz(iZeta,iCar,ia,ib,1) =
     &                  -Two * Alpha(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib  ,0)
                     Wxyz(iZeta,iCar,ia,ib,2) =
     &                  -Two *  Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia  ,ib+1,0)
                  End Do
               End Do
            Else If (ia.eq.0) Then
               Do iCar = 1, 3
                  Do iZeta = 1, nZeta
                     Txyz(iZeta,iCar,ia,ib,0) =
     &                   Two * Alpha(iZeta) * Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib+1,0)
     &                - Alpha(iZeta) * ib * Rxyz(iZeta,iCar,ia+1,ib-1,0)
                     Txyz(iZeta,iCar,ia,ib,1) =
     &                   Two * Alpha(iZeta) * Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib+1,1)
     &                - Alpha(iZeta) * ib * Rxyz(iZeta,iCar,ia+1,ib-1,1)
                     Wxyz(iZeta,iCar,ia,ib,1) =
     &                  -Two * Alpha(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib  ,0)
                     Wxyz(iZeta,iCar,ia,ib,2) =
     &                  -Two *  Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia  ,ib+1,0)
     &                  +              ib * Rxyz(iZeta,iCar,ia  ,ib-1,0)
                  End Do
               End Do
            Else If (ib.eq.0) Then
               Do iCar = 1, 3
                  Do iZeta = 1, nZeta
                     Txyz(iZeta,iCar,ia,ib,0) =
     &                   Two * Alpha(iZeta) * Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib+1,0)
     &                - Beta(iZeta)  * ia * Rxyz(iZeta,iCar,ia-1,ib+1,0)
                     Txyz(iZeta,iCar,ia,ib,1) =
     &                   Two * Alpha(iZeta) * Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib+1,1)
     &                - Beta(iZeta)  * ia * Rxyz(iZeta,iCar,ia-1,ib+1,1)
                     Wxyz(iZeta,iCar,ia,ib,1) =
     &                  -Two * Alpha(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib  ,0)
     &                  +              ia * Rxyz(iZeta,iCar,ia-1,ib  ,0)
                     Wxyz(iZeta,iCar,ia,ib,2) =
     &                  -Two *  Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia  ,ib+1,0)
                  End Do
               End Do
            Else
               Do iCar = 1, 3
                  Do iZeta = 1, nZeta
                     Txyz(iZeta,iCar,ia,ib,0) =
     &                     Half * ia * ib * Rxyz(iZeta,iCar,ia-1,ib-1,0)
     &                - Beta(iZeta)  * ia * Rxyz(iZeta,iCar,ia-1,ib+1,0)
     &                - Alpha(iZeta) * ib * Rxyz(iZeta,iCar,ia+1,ib-1,0)
     &                + Two * Alpha(iZeta) * Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib+1,0)
                     Txyz(iZeta,iCar,ia,ib,1) =
     &                     Half * ia * ib * Rxyz(iZeta,iCar,ia-1,ib-1,1)
     &                - Beta(iZeta)  * ia * Rxyz(iZeta,iCar,ia-1,ib+1,1)
     &                - Alpha(iZeta) * ib * Rxyz(iZeta,iCar,ia+1,ib-1,1)
     &                + Two * Alpha(iZeta) * Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib+1,1)
                     Wxyz(iZeta,iCar,ia,ib,1) =
     &                  -Two * Alpha(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia+1,ib  ,0)
     &                  +              ia * Rxyz(iZeta,iCar,ia-1,ib  ,0)
                     Wxyz(iZeta,iCar,ia,ib,2) =
     &                  -Two *  Beta(iZeta) *
     &                                      Rxyz(iZeta,iCar,ia  ,ib+1,0)
     &                  +              ib * Rxyz(iZeta,iCar,ia  ,ib-1,0)
                  End Do
               End Do
            End If
*                                                                      *
************************************************************************
*                                                                      *
            If (iPrint.ge.99) Then
               Write (Label,'(A,I2,A,I2,A)') ' In Kntc: Txyz(',ia,',',
     &                ib,',0)'
               Call RecPrt(Label,' ',Txyz(1,1,ia,ib,0),nZeta,3)
               Write (Label,'(A,I2,A,I2,A)') ' In Kntc: Txyz(',ia,',',
     &                ib,',1)'
               Call RecPrt(Label,' ',Txyz(1,1,ia,ib,1),nZeta,3)
               Write (Label,'(A,I2,A,I2,A)') ' In Kntc: Wxyz(',ia,',',
     &                ib,',1)'
               Call RecPrt(Label,' ',Wxyz(1,1,ia,ib,1),nZeta,3)
               Write (Label,'(A,I2,A,I2,A)') ' In Kntc: Wxyz(',ia,',',
     &                ib,',2)'
               Call RecPrt(Label,' ',Wxyz(1,1,ia,ib,2),nZeta,3)
            End If
*                                                                      *
************************************************************************
*                                                                      *
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nr)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Igor Schapiro                                    *
************************************************************************
C
C *********************************************************************
C *                                                                   *
C *  Writes out the forces and energies for Gromacs                   *
C *                                                                   *
C * 18/01/2008                                                        *
C * Igor Schapiro                                                     *
C *                                                                   *
C *********************************************************************

C   . |  1    .    2    .    3    .    4    .    5    .    6    .    7 |  .    8

      SUBROUTINE GROM(irc)
#include "warnings.fh"
#include "Molcas.fh"
#include "prgm.fh"
#include "stdalloc.fh"
      PARAMETER   (ROUTINE='GROM')
#include "MD.fh"
#include "WrkSpc.fh"
      External    IsFreeUnit
      INTEGER     natom,i,j,irc,file,IsFreeUnit
      CHARACTER   filname*80
      REAL*8, ALLOCATABLE ::     xyz(:),force(:)
      CHARACTER, ALLOCATABLE ::  atom(:)*2
*
      IF(IPRINT.EQ.INSANE) WRITE(6,*)' Entering ',ROUTINE

      WRITE(6,*)'**** Writes out Forces and Energies for Gromacs ****'
*
      CALL DxRdNAtomStnd(natom)
      CALL mma_allocate(atom,natom)
      CALL mma_allocate(xyz,natom*3)
      CALL mma_allocate(force,natom*3)
*
C
C     Read atom, their coordinates and forces
C
      CALL DxRdStnd(natom,atom,xyz,force)
C
C     Write the energies and forces to file
C
      file=IsFreeUnit(81)
      filname='MOL2GROM'
      Call Molcas_Open(file,filname)
      WRITE(file,*) natom
      DO i=1, natom
         WRITE(file,'(3D20.10)') (force((i-1)*3+j),j=1,3)
      ENDDO
      CLOSE(file)
*
      CALL mma_deallocate(atom)
      CALL mma_deallocate(xyz)
      CALL mma_deallocate(force)
*
      irc=_RC_ALL_IS_WELL_
      RETURN
*
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016,2017, Roland Lindh                                *
************************************************************************
      SubRoutine PrFin0(Dens,Dens_ab,nDT,EOrb,nEO,CMO,nCMO,KntE)
************************************************************************
*                                                                      *
*     purpose: Final printout                                          *
*                                                                      *
*     input:                                                           *
*       Dens    : the last total density                               *
*       EOrb    : orbital energies of length nEO                       *
*       CMO     : molecular orbital coefficients of length nCMO        *
*                                                                      *
*     called from: Final                                               *
*                                                                      *
*     calls to: R1IntB, RelEny, SetUp, Ortho                           *
*                                                                      *
*----------------------------------------------------------------------*
*  cloned from prfin (the part to call ones)                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
#ifdef _HDF5_
      Use mh5, Only: mh5_put_dset
#endif
      Use KSDFT_Info, Only: CoefR, CoefX
      use OFembed, only: Do_OFemb
#ifdef _FDE_
      use Embedding_Global, only: Eemb, embPot
#endif
      use SpinAV, only: Do_SpinAV
      Implicit Real*8 (a-h,o-z)
*
      Real*8 Dens(nDT),Dens_ab(nDT), EOrb(nEO),CMO(nCMO), KntE(nDT)
      Integer iSpn, iMult
*
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "ldfscf.fh"
#include "file.fh"
#include "rctfld.fh"
#include "oneswi.fh"
#include "scfwfn.fh"

#include "addcorr.fh"
#include "dcscf.fh"

      Integer  Cho_X_GetTol
      External Cho_X_GetTol
*
*---- Define local variables
      Character*80 Lines(6), Fmt*60
      Logical Reduce_Prt
      External Reduce_Prt
      Dimension Dumm1(1)


#include "SysDef.fh"

*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      jPrint = iPrint
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0
      If (iPL.le.1) jPrint=1
*
*----------------------------------------------------------------------*
*
*---- Calculate kinetic energy
      If (iUHF.eq.1) then
         do i=1,nDT
            Dens(i)=Dens(i)+Dens_ab(i)
         end do
      End if
      EKin = DDot_(nBT,KntE,1,Dens,1)
*
*---- Print out header to final results
      Lines(1) = 'SCF/KS-DFT Program, Final results'
      Lines(2) = ' '
      Lines(3)=' '
c      if(.false.) Lines(3) = Molcas_revision
      Lines(4) = ' '
      Lines(5) = 'Final Results'
      If (jPrint.ge.2) Then
         Call Banner(Lines,5,lPaper-7)
         Write(6,*)
      End If
*
*---- Compute energies from aufbau density matrix
      If (Abs(EKin).gt.1.0D-6) Then
         Virial = - EneV/EKin
      Else
         Virial = Zero
      End If
*
*---- Compute estimate of FNO correlation energy from Delta_Tw
      If (Do_Tw) Call Tw_corr_drv(EOrb,nEO,CMO,nCMO,Ecorr)

*
*---- Print out final results
      If(WarnCfg) Then
         call WarningMessage(1,
     &     'Warning:; The program may have converged to a solution;'//
     &     'that does not correspond to the lowest energy!')
      End If
      If(WarnPocc) Then
         call WarningMessage(1,
     &     'Warning:; The program may have converged to a solution;'//
     &     'with partial occupation numbers!')
      End If
      If(WarnSlow) Then
         call WarningMessage(1,
     &     'Warning:; The program had convergence problems;'//
     &     'and terminated with looser convergence')
      End If
      Fmt = '(6X,A,T50,F19.10)'
      suhf=-0.5d0+sqrt(0.25d0+s2uhf)
      Call put_dscalar('UHFSPIN',SUHF)
      iTol = min(Cho_X_GetTol(8),8)
      If (doLDF) Then
         ! the non-robust integral representations are numerically
         ! unstable and may give much larger errors, depending on
         ! machine and compiler options. Be more tolerant in those
         ! cases.
         If (LDF_IntegralMode.ne.1) Then
            If (.not.LDF_UseConventionalIntegrals) Then
               iTol=max(iTol-4,2)
            End If
         End If
      End If
      If (jPrint.ge.2) Then
         If (MxConstr.gt.0) Then
            DE_KSDFT_c=0.0d0
            If (Do_Addc) Then
               Call SetUp_iSD()
               Call Get_DEcorr(nBT,Dumm1,iDumm,'SCF ')
               Call Free_iSD()
            End If
            ECNO=EneV+E_nondyn+DE_KSDFT_c
            If (KSDFT.ne.'SCF') ECNO=ECNO+Erest_xc
            call PrintResult(6,FMT, 'Total energy',0,' ',[ECNO],1)
            call PrintResult(6,FMT, 'Nondynamical correlation energy',
     &                       0,' ',[E_nondyn],1)
            If (KSDFT.ne.'SCF') Then
               call PrintResult(6,FMT, 'Energy-restoring term',
     &                          0,' ',[Erest_xc],1)
            EndIf
            If (Do_Addc) Then
              Call PrintResult(6,FMT,
     &        'Added correlation energy ('//ADDC_KSDFT(1:4)//') ',
     &         0,' ',[DE_KSDFT_c],1)
            EndIf
            Call Add_Info('E_CNO',[ECNO],1,iTol)
         EndIf
         If (Do_Tw) Then
            E_Tw=EneV+Ecorr
            call PrintResult(6,FMT, 'Total energy',0,' ',[E_Tw],1)
            call PrintResult(6,FMT, 'Delta_Tw correlation energy',
     &                       0,' ',[Ecorr],1)
            Call Add_Info('E_Tw',[E_Tw],1,iTol)
         EndIf
         If (KSDFT.eq.'SCF') Then
            call PrintResult(6,FMT, 'Total SCF energy',0,' ',[EneV],1)
c            Write(6,Fmt)'Total SCF energy',EneV
         Else
            call PrintResult(6,FMT, 'Total KS-DFT energy',0,' ',
     &          [EneV],1)
c            Write(6,Fmt)'Total KS-DFT energy',EneV
         End If
         Write(6,Fmt)'One-electron energy',E1V
#ifdef _FDE_
         ! Embedding
         if (embPot) then
          Write(6,Fmt)'E from embedding potential(<Psi|v_emb|Psi>)',Eemb
         end if
#endif
         Write(6,Fmt)'Two-electron energy',E2V
         Write(6,Fmt)'Nuclear repulsion energy',PotNuc
         Write(6,Fmt)'Kinetic energy (interpolated)',EKin
         Write(6,Fmt)'Virial theorem',Virial
         If (.not.Do_SpinAV) Then
            Write(6,Fmt)'Total spin, S(S+1)',s2uhf
            Write(6,Fmt)'Total spin, S',suhf
         EndIf
         If (MxConstr.gt.0) Write(6,Fmt)'Spin deviation',s2uhf-s2CNO
      End If
      iSpn = INT(suhf+0.5d0)
      iMult = 2*iSpn+1
      Call Put_iScalar('Multiplicity',iMult)
      Call Add_Info('E_SCF',[EneV],1,iTol)
#ifdef _HDF5_
      call mh5_put_dset(wfn_energy,EneV)
#endif
*
      If (nIter(nIterP).gt.0.and.jPrint.ge.2) Then
         Write(6,Fmt)'Max non-diagonal density matrix element',DMOMax
         Write(6,Fmt)'Max non-diagonal Fock matrix element',FMOMax
      End If
      if (CoefX.ne.1.0.or.CoefR.ne.1.0) Then
         Write(6,Fmt)'Exchange scaling factor',CoefX
         Write(6,Fmt)'Correlation scaling factor',CoefR
      End If
      If (jPrint.ge.2) Write(6,*)
c      If (jPrint.ge.2 .and. Do_OFemb) Call OFE_print(EneV)
      If (Do_OFemb) Call OFE_print(EneV)
*
* xml tagging
*
      If(KSDFT.eq.'SCF') Then
         Call xml_dDump('energy','Total SCF energy','a.u.',1,[EneV],1,1)
      Else
         Call xml_dDump('energy','Total KS-DFT energy','a.u.',1,
     &          [EneV],1,1)
      End If
      Call xml_dDump('kinetic','Kinetic energy','a.u.',2,[Ekin],1,1)
      Call xml_dDump('virial','Virial coefficient','a.u.',2,
     &         [Virial],1,1)
      Call xml_dDump('spin','UHF spin','',1,[suhf],1,1)
      Call xml_dDump('potnuc','Nuclear repulsion energy','a.u.',
     &         1,[potnuc],1,1)
      Call xml_dDump('energy1el','One electron energy','a.u.',1,
     &         [E1V],1,1)
      Call xml_dDump('energy2el','Two electron energy','a.u.',1,
     &         [E2V],1,1)
      Call xml_iDump('nsym','Number of irreps','',1,[nSym],1,1)
      Call xml_iDump('nbas','Number of basis functions','',
     &         1,nBas,nSym,1)
      Call xml_iDump('norb','Number of orbitals','',1,nOrb,nSym,1)
      If(iUHF.eq.0) Then
         Call xml_iDump('nocc','Number of occupied orbitals','',
     &                  1,nOcc(1,1),nSym,1)
      Else
         Call xml_iDump('nocc_a','Number of occupied alpha orbitals','',
     &                  1,nOcc(1,1),nSym,1)
         Call xml_iDump('nocc_b','Number of occupied beta orbitals','',
     &                  1,nOcc(1,2),nSym,1)
      End If
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_APD3IndexIntegrals_1(AB,C,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: get integrals (uv|J) using atom pair-driven code
C
C     NOTE: this code is for debugging only and requires that at least
C           one atom pair can be found for which
C           (a) it contains atom C
C           (b) it has no linear dependence in the one-center aux space
C
      Implicit None
      Integer AB
      Integer C
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_a2ap.fh"

      Character*24 SecNam
      Parameter (SecNam='LDF_APD3IndexIntegrals_1')

      Integer  LDF_nBas_Atom, LDF_nBasAux_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Atom, LDF_nBasAux_Pair

      Integer iCD, CD_, CD
      Integer ip, l
      Integer A, B
      Integer nuv, M
      Integer ip_Int, l_Int

      Integer i, j
      Integer A2AP
      Integer AP_Atoms
      Integer AP_1CLinDep
      A2AP(i,j)=iWork(ip_A2AP-1+2*(j-1)+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)

      ! Get an atom pair that contains atom C
      Call LDF_SetA2AP()
      CD=0
      l=A2AP(1,C)
      If (l.gt.0) Then
         ip=A2AP(2,C)-1
         iCD=0
         Do While (iCD.lt.l .and. CD.eq.0)
            iCD=iCD+1
            CD_=iWork(ip+iCD)
            If (AP_1CLinDep(1,CD_).eq.0) Then
               CD=CD_
            End If
         End Do
      End If
      If (CD.eq.0) Then
         Write(6,'(A,A,I5,A)')
     &   SecNam,': no atom pair containing atom ',C,
     &   ' has linearly independent one-center functions only!'
         Call WarningMessage(2,SecNam//': Suitable AP not found!')
         Call LDF_Quit(1)
      End If
      Call LDF_UnsetA2AP()

      ! Allocate integral array
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      nuv=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      M=LDF_nBasAux_Pair(CD)
      l_Int=nuv*M
      Call GetMem('APD3I_1','Allo','Real',ip_Int,l_Int)

      ! Compute integrals using atom pair-driven code
      Call LDF_ComputeIntegrals_uvJ_2P(AB,CD,l_Int,Work(ip_Int))

      ! Copy integrals to return
      l=nuv*LDF_nBasAux_Atom(C)
      If (l.gt.l_xInt_) Then
         Call WarningMessage(2,
     &               SecNam//': Insufficient integral array dimension!')
         Call LDF_Quit(1)
      Else
         If (AP_Atoms(1,CD).eq.C) Then
            Call dCopy_(l,Work(ip_Int),1,xInt,1)
         Else If (AP_Atoms(2,CD).eq.C) Then
            ip=ip_Int+nuv*LDF_nBasAux_Atom(AP_Atoms(1,CD))
            Call dCopy_(l,Work(ip),1,xInt,1)
         Else
            Call WarningMessage(2,SecNam//': Logical error!')
            Call LDF_Quit(1)
         End If
      End If

      ! Deallocate integral array
      Call GetMem('APD3I_1','Free','Real',ip_Int,l_Int)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_APD3IndexIntegrals_2(AB,CD,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: get integrals (uv|J) using atom pair-driven code
C
C     NOTE: this code is for debugging only.
C
      Implicit None
      Integer AB
      Integer CD
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*24 SecNam
      Parameter (SecNam='LDF_APD3IndexIntegrals_2')

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair, LDF_nBasAux_Atom
      External LDF_nBas_Atom, LDF_nBasAux_Pair, LDF_nBasAux_Atom

      Integer A, B, C, D
      Integer nuv, M
      Integer ip_Int, l_Int
      Integer ip, l

      Integer i, j
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Quick return
      If (AP_2CFunctions(1,CD).lt.1) Return

      ! Allocate memory for integrals
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      nuv=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      M=LDF_nBasAux_Pair(CD)
      l_Int=nuv*M
      Call GetMem('APD3I_2','Allo','Real',ip_Int,l_Int)

      ! Compute integrals
      Call LDF_ComputeIntegrals_uvJ_2P(AB,CD,l_Int,Work(ip_Int))

      ! Copy integrals to return
      C=AP_Atoms(1,CD)
      D=AP_Atoms(2,CD)
      If (C.eq.D) Then
         ip=ip_Int+nuv*(LDF_nBasAux_Atom(C)-AP_1CLinDep(1,CD))
      Else
         ip=ip_Int+nuv*(LDF_nBasAux_Atom(C)+LDF_nBasAux_Atom(D)
     &                 -AP_1CLinDep(1,CD))
      End If
      l=nuv*AP_2CFunctions(1,CD)
      If (l.gt.l_xInt_) Then
         Call WarningMessage(2,
     &               SecNam//': Insufficient integral array dimension!')
         Call LDF_Quit(1)
      Else
         Call dCopy_(l,Work(ip),1,xInt,1)
      End If

      ! Deallocate integrals
      Call GetMem('APD3I_2','Free','Real',ip_Int,l_Int)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C NOTE: THE FOLLOWING ROUTINE MAY NOT BE VECTORIZED.
C THERE IS A COMPILER BUG ON FORTRAN VERSION 2.2.0 (JUNE 1987).
C WRONG RESULTS PRODUCED EVEN ON VECTORIZED LEVEL 1.
      SUBROUTINE MKCXAL(NDIMEN,TRAL,CXAL)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TRAL(NDIMEN,NDIMEN),CXAL(NDIMEN,NDIMEN)
      DO I=1,NDIMEN
        DO J=I,NDIMEN
          CXAL(I,J)=0.0D00
        END DO
        CXAL(I,I)=1.0D00
      END DO
      DO K=1,NDIMEN
        DO I=1,K-1
          SUMMA=0.0D00
          DO J=1,K-1
            SUMMA=SUMMA+CXAL(I,J)*TRAL(J,K)
          END DO
          CXAL(I,K)=-(SUMMA/TRAL(K,K))
        END DO
        DO I=K,NDIMEN
          SUMMA=TRAL(I,K)
          IF (I.EQ.K) SUMMA=-1.0D00
          DO J=1,K-1
            SUMMA=SUMMA+CXAL(I,J)*TRAL(J,K)
          END DO
          CXAL(I,K)=-(SUMMA/TRAL(K,K))
        END DO
      END DO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

subroutine Get_D1A(CMO,D1A_MO,D1A_AO,nsym,nbas,nish,nash,ndens)

use Index_Functions, only: iTri
use Constants, only: Zero, One
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMO(*), D1A_MO(*)
real(kind=wp), intent(_OUT_) :: D1A_AO(*)
integer(kind=iwp), intent(in) :: nSym, nbas(nsym), nish(nsym), nash(nsym), nDens
integer(kind=iwp) :: i, iAsh, iBas, ii, iIsh, iOff2, iOff3, iSym, j
real(kind=wp), allocatable :: Scr1(:), Tmp1(:,:), Tmp2(:,:)

iOff2 = 1
iOff3 = 1
ii = 0
call mma_allocate(Scr1,2*nDens,Label='Scr1')
do iSym=1,nSym
  iBas = nBas(iSym)
  iAsh = nAsh(iSym)
  iIsh = nIsh(iSym)
  Scr1(iOff3:iOff3+iBas**2-1) = Zero
  if (iAsh /= 0) then
    call mma_allocate(Tmp1,iAsh,iAsh,Label='Tmp1')
    call mma_allocate(Tmp2,iBas,iAsh,Label='Tmp2')
    do i=1,iAsh
      do j=1,iAsh
        Tmp1(j,i) = D1A_MO(iTri(i+ii,j+ii))
      end do
    end do
    ii = ii+iAsh
    call DGEMM_('N','T',iBas,iAsh,iAsh,One,CMO(iOff2+iIsh*iBas),iBas,Tmp1,iAsh,Zero,Tmp2,iBas)
    call DGEMM_('N','T',iBas,iBas,iAsh,One,Tmp2,iBas,CMO(iOff2+iIsh*iBas),iBas,Zero,Scr1(iOff3),iBas)
    call mma_deallocate(Tmp2)
    call mma_deallocate(Tmp1)
  end if
  iOff2 = iOff2+iBas*iBas
  iOff3 = iOff3+iBas*iBas
end do
call Fold2(nSym,nBas,Scr1,D1A_AO)
call mma_deallocate(Scr1)

return

end subroutine Get_D1A

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_Distrib_Vec(Jin,Jfi,iDV,nV)

use Cholesky, only: Cho_Real_Par
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: Jin, Jfi
integer(kind=iwp), intent(_OUT_) :: iDV(*)
integer(kind=iwp), intent(out) :: nV
integer(kind=iwp) :: J, J0

if (Cho_Real_Par) then
  call Cho_Distrib_Vec(Jin,Jfi,iDV,nV)
else
  J0 = Jin-1
  nV = Jfi-J0
  do J=1,nV
    iDV(J) = J0+J
  end do
end if

end subroutine Cho_P_Distrib_Vec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cp_Prop_Int(A_Int,nAInt,B_Int,nBInt,nBas,nIrrep,Label)
!***********************************************************************
!                                                                      *
! Object: replace the diagonal blocks of the property integrals.       *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAInt, nBInt, nIrrep, nBas(0:nIrrep-1), Label
real(kind=wp), intent(out) :: A_Int(nAInt)
real(kind=wp), intent(in) :: B_Int(nBInt)
integer(kind=iwp) :: iCmp, iExp, iIrrep, iLen, jIrrep, Len_

iCmp = 1
iExp = 1
do iIrrep=1,nIrrep
  do jIrrep=1,iIrrep
    if (.not. btest(Label,Mul(iIrrep,jIrrep)-1)) cycle
    if (iIrrep == jIrrep) then
      Len_ = nBas(iIrrep-1)*(nBas(iIrrep-1)+1)/2
      do iLen=0,Len_-1
        !write(u6,*) A_Int(iExp+iLen),B_Int(iCmp+iLen)
        A_Int(iExp+iLen) = B_Int(iCmp+iLen)
      end do
      iCmp = iCmp+Len_
      iExp = iExp+Len_
    else
      Len_ = nBas(iIrrep-1)*nBas(jIrrep-1)
      iExp = iExp+Len_
    end if
  end do
end do

return

end subroutine Cp_Prop_Int

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*PAM04      SUBROUTINE READIN(HWork,iHWork)
      SUBROUTINE READIN_MRCI()
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "warnings.fh"
#include "mrci.fh"
#include "WrkSpc.fh"
#include "niocr.fh"
      DIMENSION IOCR(nIOCR),NOTOT(8)
*PAM04      DIMENSION HWork(*), iHWork(*)
*
      Parameter ( nCmd=20 )
      Parameter ( mxTit=10 )
      Character*4 Command,Cmd(nCmd)
      Character*72  Line,Title(mxTit)
      Character*88  ModLine
      Data Cmd /'TITL','THRP','PRIN','FROZ','DELE',
     *          'MAXI','ECON','REST','ROOT','ACPF',
     *          'SDCI','GVAL','PROR','REFC','SELE',
     *          'NRRO','MXVE','TRAN','EXTR','END '/
*
*---- convert a pointer in H to a pointer for iH
*     ipointer(i)=(i-1)*RtoI+1
*
*
*     Initialize data and set defaults
*
      IOM=MXORB
      KBUFF1=2*9600
      ETHRE=1.0D-08
      SQNLIM=1.0D-10
      CTRSH=0.05D00
      THRORB=1.0D-05
      ENP=1.0D00
      NRROOT=1
      NSEL=0
      IPRINT=1
      MAXIT=20
      IREST=0
      ICPF=0
      IREFCI=0
      ISDCI=1
      ITRANS=0
      IGFAC=0
      MXVC=0
      DO 1 I=1,8
        NFRO(I)=0
        NDEL(I)=0
        NBAS(I)=0
        NORB(I)=0
1     CONTINUE
      DO 2 I=1,IOM+1
        IROW(I)=I*(I-1)/2
2     CONTINUE
      DO 4 I=1,12
        IROOT(I)=I
4     CONTINUE
      nTit=0
*
*     Read the header of the ONEINT file
*
      NAMSIZ=LENIN8*MXORB
      IDISK=0
      CALL WR_MOTRA_Info(LUONE,2,iDisk,
     &                   ITOC17,64, POTNUC,
     &                   NSYM, NBAS, NORB,NFMO,NDMO,8,NAME,NAMSIZ)
*
*---  Read input from standard input ----------------------------------*
      Call RdNLst(5,'MRCI')
10    Read(5,'(A)',End=991) Line
      Command=Line(1:4)
      Call UpCase(Command)
      If ( Command(1:1).eq.'*' ) Goto 10
      if (Command.eq.' ') Goto 10
      jCmd=0
      Do iCmd=1,nCmd
         If ( Command.eq.Cmd(iCmd) ) jCmd=iCmd
      End Do
20    Goto ( 100, 200, 300, 400, 500, 600, 700 ,800, 900,1000,
     &      1100,1200,1300,1400,1500,1600,1700,1800,1900,2000 ) jCmd
      WRITE(6,*)'READIN Error: Command not recognized.'
      WRITE(6,*)'The command is:'//''''//Command//''''
      CALL QUIT(_RC_INPUT_ERROR_)
*
*---  process TITL command --------------------------------------------*
 100  Continue
      Read(5,'(A)',End=991) Line
      Command=Line(1:4)
      Call UpCase(Command)
      If ( Command(1:1).eq.'*' ) Goto 100
      jCmd=0
      Do iCmd=1,nCmd
         If ( Command.eq.Cmd(iCmd) ) jCmd=iCmd
      End Do
      If ( jCmd.ne.0 ) Goto 20
      nTit=nTit+1
      If ( nTit.le.mxTit ) Title(nTit)=Line
      Goto 100
*
*---  process THRP command --------------------------------------------*
 200  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 200
      Read(Line,*,Err=992) CTRSH
      Goto 10
*
*---  process PRIN command --------------------------------------------*
 300  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 300
      Read(Line,*,Err=992) IPRINT
      Goto 10
*
*---  process FROZ command --------------------------------------------*
 400  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 400
      ModLine=Line//' 0 0 0 0 0 0 0 0'
      Read(ModLine,*,Err=992) (NFRO(I),I=1,8)
      Goto 10
*
*---  process DELE command --------------------------------------------*
 500  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 500
      ModLine=Line//' 0 0 0 0 0 0 0 0'
      Read(ModLine,*,Err=992) (NDEL(I),I=1,8)
      Goto 10
*
*---  process MAXI command --------------------------------------------*
 600  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 600
      Read(Line,*,Err=992) MAXIT
      Goto 10
*
*---  process ECON command --------------------------------------------*
 700  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 700
      Read(Line,*,Err=992) ETHRE
      Goto 10
*
*---  process REST command --------------------------------------------*
 800  Continue
      IREST=1
      Goto 10
*
*---  process ROOT command --------------------------------------------*
 900  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 900
      Read(Line,*,Err=992) (IROOT(I),I=1,NRROOT)
      Goto 10
*
*---  process ACPF command --------------------------------------------*
1000  Continue
      ICPF=1
      ISDCI=0
      Goto 10
*
*---  process SDCI command --------------------------------------------*
1100  Continue
      ICPF=0
      ISDCI=1
      Goto 10
*
*---  process GVAL command --------------------------------------------*
1200  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1200
      Read(Line,*,Err=992) GFAC
      IGFAC=1
      Goto 10
*
*---  process PROR command --------------------------------------------*
1300  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1300
      Read(Line,*,Err=992) THRORB
      Goto 10
*
*---  process REFC command --------------------------------------------*
1400  Continue
      IREFCI=1
      Goto 10
*
*---  process SELE command --------------------------------------------*
1500  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1500
      Read(Line,*,Err=992) NSEL
      JJ=0
      Do 1510 I=1,NSEL
        Read(5,*,End=991,Err=992) NC,(CSEL(JJ+J),SSEL(JJ+J),J=1,NC)
        JJ=JJ+NC
        NCOMP(I)=NC
1510  CONTINUE
      Goto 10
*
*---  process NRRO command --------------------------------------------*
1600  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1600
      Read(Line,*,Err=992) NRROOT
      if(nrroot.gt.mxvec) then
       write(6,1610) nrroot,mxvec
1610   format('Too many roots,',i3,', max allowed is',i3)
       call quit(_RC_INPUT_ERROR_)
      endif
      DO  I=1,NRROOT
        IROOT(I)=I
      Enddo
      Goto 10
*
*---  process MXVE command --------------------------------------------*
1700  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1700
      Read(Line,*,Err=992) MXVC
       if(mxvc.gt.mxvec) then
       write(6,1710) mxvc,mxvec
1710   format('Too many vectors,',i3,', max allowed is',i3)
       call quit(_RC_INPUT_ERROR_)
      endif
      Goto 10
*
*---  process TRAN command --------------------------------------------*
1800  Continue
      ITRANS=1
      Goto 10
*
*---  process EXTR command --------------------------------------------*
1900  WRITE(6,*) 'The EXTRACT option is redundant and is ignored!'
      Goto 10
*
*---  The end of the input is reached, print the title ----------------*
2000  Continue
      if(ntit.eq.0) then
        ntit=1
        title(1)=' ( No title was given )'
      end if
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,'(6X,120A1)') ('*',i=1,120)
      CALL XFLUSH(6)
      WRITE(6,'(6X,120A1)') '*',(' ',i=1,118),'*'
      CALL XFLUSH(6)
      WRITE(6,'(6X,57A1,A6,57A1)')
     &        '*',(' ',i=1,56),'Title:',(' ',i=1,56),'*'
      CALL XFLUSH(6)
      Do i=1,nTit
         Call Center(Title(i))
         WRITE(6,'(6X,24A1,A72,24A1)')
     &        '*',(' ',j=1,23),Title(i),(' ',j=1,23),'*'
      CALL XFLUSH(6)
      End Do
      WRITE(6,'(6X,120A1)') '*',(' ',i=1,118),'*'
      CALL XFLUSH(6)
      WRITE(6,'(6X,120A1)') ('*',i=1,120)
      CALL XFLUSH(6)
      WRITE(6,*)
*
*---  print the coordinates of the system -----------------------------*
      CALL XFLUSH(6)
      Call PrCoor
*
*---  read the header of CIGUGA ---------------------------------------*
*
*     Read the header of the CIGUGA file
*
      IADD10=0
      CALL iDAFILE(LUSYMB,2,IAD10,9,IADD10)
      iOpt=2
      nMUL=64
      nJJS=18
      nIRC=4
      Call WR_GUGA(LUSYMB,iOpt,IADD10,
     &             NREF,SPIN,NELEC,LN,NSYM,NCSPCK,NINTSY,IFIRST,INTNUM,
     &             LSYM,NRF,LN1,NRLN1,MUL,nMUL,NASH,NISH,8,
     &             IRC,nIRC,JJS,nJJS,NVAL,IOCR,nIOCR)
      IF(ICPF.EQ.1) THEN
        WRITE(6,*)'      THIS IS AN   A C P F   CALCULATION'
      ELSE
        WRITE(6,*)'      THIS IS AN   S D C I   CALCULATION'
        WRITE(6,*)'      (But an ACPF correction will be computed)'
      END IF
      IF(IGFAC.EQ.0) THEN
        GFAC=2.0D00/NELEC
        WRITE(6,*)'      USE THE DEFAULT ACPF G-VALUE GFAC=',GFAC
      ELSE
        WRITE(6,*)'      THE ACPF G-VALUE HAS BEEN SET TO GFAC=',GFAC
      END IF
      WRITE(6,*)
      IF(IREST.NE.0) WRITE(6,*)'      RESTARTED CALCULATION.'
      WRITE(6,*)'      A SMALL CI IS PERFORMED INVOLVING ONLY'
     &        //' THE REFERENCE STATES.'
      WRITE(6,*)'      THIS REFERENCE CI WILL USE THE FOLLOWING ROOT'
     &        //' SELECTION CRITERIA:'
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,*)
      IF(MXVC.EQ.0) MXVC=MAX(NRROOT,10)
      IF(NSEL.EQ.0) THEN
        WRITE(6,*)'      ROOT SELECTION BY ENERGY ORDERING.'
        IF(NRROOT.EQ.1) THEN
          WRITE(6,'(A,I8)')'      ONE SINGLE ROOT, NUMBER ',IROOT(1)
        ELSE
          WRITE(6,*)'      THE FOLLOWING ROOTS WILL BE SELECTED:'
          WRITE(6,'(1X,/(1x,12I3))')  (IROOT(I),I=1,NRROOT)
        END IF
      ELSE
        WRITE(6,*)
     &       '      ROOT SELECTION BY PROJECTION: THE EIGENVECTORS OF'
        WRITE(6,*)
     &       '      THE REFERENCE CI ARE ORDERED BY DECREASING SIZE OF'
        WRITE(6,*)
     &       '      THEIR PROJECTIONS ONTO A SELECTION SPACE.'
        IF(NRROOT.EQ.1) THEN
          WRITE(6,*)
     &         '     SELECT THE EIGENVECTOR WITH LARGEST PROJECTION.'
        ELSE
          WRITE(6,'(A,I2,A)')'      SELECT THE ',NRROOT,
     *                       ' EIGENVECTORS WITH LARGEST PROJECTION.'
        END IF
        WRITE(6,*)
     &       '      THE SELECTION SPACE IS SPANNED BY THE FOLLOWING',
     *             'VECTORS (NONZERO COMPONENTS ONLY):'
        JJ=0
        DO 1234 I=1,NSEL
          WRITE(6,'(6X,A,I2)') ' VECTOR NR. ',I
          NC=NCOMP(I)
          WRITE(6,'(11X,I2,5X,A20,F12.8)')
     *          (J,SSEL(JJ+J),CSEL(JJ+J),J=1,NC)
          JJ=JJ+NC
1234  CONTINUE
      END IF
      WRITE(6,*)
      IF(IREFCI.EQ.0) THEN
        IF(IREST.EQ.0) THEN
      WRITE(6,*)'      THE REFERENCE CI IS FOLLOWED BY THE FULL SPACE'
      WRITE(6,*)'      CALCULATION, WHERE THE SELECTION CRITERION'
      WRITE(6,*)'      IS MAXIMUM OVERLAP WITH THE ROOT(S) SELECTED IN'
      WRITE(6,*)'      THE REFERENCE CI.'
        ELSE
      WRITE(6,*)'      THE REFERENCE CI IS FOLLOWED BY THE FULL SPACE'
      WRITE(6,*)'      CALCULATION, WITH ITERATIONS RESTARTED FROM'
      WRITE(6,*)'      CI VECTOR(S) READ FROM FILE. THE ROOT SELECTION'
      WRITE(6,*)'      CRITERION IS MAXIMUM OVERLAP WITH THE START'
      WRITE(6,*)'      VECTORS.'
        END IF
      ELSE
        WRITE(6,*)'      ONLY THE REFERENCE CI WAS REQUESTED.'
      END IF
      IF(LN.GT.IOM) THEN
        WRITE(6,*)'READIN Error: Too many orbitals.'
        WRITE(6,'(1X,A,2I5)')'actual,allowed:',LN,IOM
        CALL QUIT(_RC_INPUT_ERROR_)
      END IF
      NISHT=0
      LV=0
      DO 811 I=1,NSYM
        NISHT=NISHT+NISH(I)
        LV=LV+NVAL(I)
811   CONTINUE
      IN=0
      IR=0
      IVA=0
      IU=NISHT+LV
      IT=LV
      IV=LN
      NBAST=0
      NORBT=0
      NFMOT=0
      NFROT=0
      NASHT=0
      NVALT=0
      NVIRT=0
      NCSHT=0
      NDELT=0
      NDMOT=0
      DO 7 I=1,NSYM
        NORBI=NORB(I)
        NBASI=NBAS(I)
        NFMOI=NFMO(I)
        NFROI=NFRO(I)
        NISHI=NISH(I)
        NASHI=NASH(I)
        NVALI=NVAL(I)
        NDELI=NDEL(I)
        NDMOI=NDMO(I)
        NVIR(I)=NORBI-NFROI-NASHI-NISHI-NVALI-NDELI
        NVIRI=NVIR(I)
        NCSH(I)=NISHI+NASHI+NVALI+NVIRI
        NCSHI=NCSH(I)
        NBAST=NBAST+NBASI
        NORBT=NORBT+NORBI
        NFMOT=NFMOT+NFMOI
        NFROT=NFROT+NFROI
        NASHT=NASHT+NASHI
        NVALT=NVALT+NVALI
        NVIRT=NVIRT+NVIRI
        NCSHT=NCSHT+NCSHI
        NDELT=NDELT+NDELI
        NDMOT=NDMOT+NDMOI
        DO 8 J=1,NFROI
          IN=IN+1
          IR=IR-1
          ICH(IN)=IR
8       CONTINUE
        DO 9 J=1,NISHI
          IN=IN+1
          IT=IT+1
          ICH(IN)=IT
          NSM(IT)=I
9       CONTINUE
        DO 11 J=1,NASHI
          IN=IN+1
          IU=IU+1
          ICH(IN)=IU
          NSM(IU)=I
11      CONTINUE
        DO 12 J=1,NVALI
          IN=IN+1
          IVA=IVA+1
          ICH(IN)=IVA
          NSM(IVA)=I
12      CONTINUE
        DO 13 J=1,NVIRI
          IN=IN+1
          IV=IV+1
          ICH(IN)=IV
          NSM(IV)=I
13      CONTINUE
        DO 14 J=1,NDELI
          IN=IN+1
          ICH(IN)=0
14      CONTINUE
7     CONTINUE
      IORBS=0
      DO 721 ISYM=1,NSYM
        NOTOT(ISYM)=0
721   CONTINUE
      DO 723 ISYM=1,NSYM
        IO=NOTOT(ISYM)
        DO 722 I=1,NFMO(ISYM)+NFRO(ISYM)
          IO=IO+1
722     CONTINUE
        NOTOT(ISYM)=IO
723   CONTINUE
      DO 725 ISYM=1,NSYM
        IO=NOTOT(ISYM)
        DO 724 I=1,NISH(ISYM)
          IO=IO+1
          IORBS=IORBS+1
          IORB(IORBS)=IO
724     CONTINUE
        NOTOT(ISYM)=IO
725   CONTINUE
      DO 727 ISYM=1,NSYM
        IO=NOTOT(ISYM)
        DO 726 I=1,NASH(ISYM)
          IO=IO+1
          IORBS=IORBS+1
          IORB(IORBS)=IO
726     CONTINUE
        NOTOT(ISYM)=IO
727   CONTINUE
      DO 729 ISYM=1,NSYM
        IO=NOTOT(ISYM)
        DO 728 I=1,NVAL(ISYM)
          IO=IO+1
          IORBS=IORBS+1
          IORB(IORBS)=IO
728     CONTINUE
        NOTOT(ISYM)=IO
729   CONTINUE
      DO 731 ISYM=1,NSYM
        IO=NOTOT(ISYM)
        DO 730 I=1,NVIR(ISYM)
          IO=IO+1
          IORBS=IORBS+1
          IORB(IORBS)=IO
730     CONTINUE
        NOTOT(ISYM)=IO
731   CONTINUE
C NR OF VIRTUALS IN PREVIOUS SYMMETRIES:
      ISUM=0
      DO 732 I=1,NSYM
        NVIRP(I)=ISUM
        ISUM=ISUM+NVIR(I)
732   CONTINUE
      NCMO=0
      NBMAX=0
      DO 350 I=1,NSYM
        IF(NBAS(I).GT.NBMAX)NBMAX=NBAS(I)
        NCMO=NCMO+NBAS(I)**2
350   CONTINUE
      NBTRI=(NBAST*(NBAST+1))/2
      NVT=IROW(NVIRT+1)
      NVT2=IROW(NVIRT)
      WRITE(6,*)
      WRITE(6,'(A)')'      MALMQVIST DIAGONALIZATION'
      WRITE(6,*)
      WRITE(6,'(A,I8)')  '      PRINT LEVEL                   ',IPRINT
      WRITE(6,'(A,I12)') '      WORKSPACE WORDS, (Re*8)   '    ,MEMTOT
      WRITE(6,'(A,I8)')  '      MAXIMUM NR OF ORBITALS        ',IOM
      WRITE(6,'(A,I8)')  '      MAX NR OF STORED CI/SGM ARR.  ',MXVC
      WRITE(6,'(A,I8)')  '      MAX NR OF ITERATIONS          ',MAXIT
      WRITE(6,'(A,D9.2)')'      ENERGY CONVERGENCE THRESHOLD ' ,ETHRE
      WRITE(6,'(A,F8.1)')'      SPIN QUANTUM NUMBER           ',SPIN
      WRITE(6,'(A,I8)')  '      CORRELATED ELECTRONS          ',NELEC
      WRITE(6,'(A,I8)')  '      WAVE FUNCTION SYMMETRY LABEL  ',LSYM
      WRITE(6,'(A,I8)')  '      POINT GROUP ORDER             ',NSYM
      CALL XFLUSH(6)
      WRITE(6,*)
      WRITE(6,101)'SYMMETRY LABEL:',(I,I=1,NSYM)
      WRITE(6,101)'INACTIVE ORBITALS',(NISH(I),I=1,NSYM),NISHT
      WRITE(6,101)'ACTIVE ORBITALS',(NASH(I),I=1,NSYM),NASHT
      WRITE(6,101)'ADDED VALENCE ORB',(NVAL(I),I=1,NSYM),NVALT
      WRITE(6,101)'VIRTUAL ORBITALS',(NVIR(I),I=1,NSYM),NVIRT
      WRITE(6,*)
      WRITE(6,101)'SUM:CORREL ORBITALS',(NCSH(I),I=1,NSYM),NCSHT
      WRITE(6,*)
      WRITE(6,101)'FROZEN ORBITALS',(NFRO(I),I=1,NSYM),NFROT
      WRITE(6,101)'DELETED ORBITALS',(NDEL(I),I=1,NSYM),NDELT
      WRITE(6,*)
      WRITE(6,101)'SUM:ORBITALS IN CI',(NORB(I),I=1,NSYM),NORBT
      CALL XFLUSH(6)
      WRITE(6,*)
      WRITE(6,101)'PRE-FROZEN ORBITALS',(NFMO(I),I=1,NSYM),NFMOT
      WRITE(6,101)'PRE-DELETED ORBITALS',(NDMO(I),I=1,NSYM),NDMOT
      WRITE(6,101)'SUM:   TOTAL BASIS',(NBAS(I),I=1,NSYM),NBAST
101   FORMAT(6X,A,T47,9I5)
      WRITE(6,*)
      CALL XFLUSH(6)
      IF(LN1.EQ.0) THEN
         WRITE(6,*)'      ONE CLOSED SHELL REFERENCE STATE'
      CALL XFLUSH(6)
      ELSE
        WRITE(6,'(6X,I4,A)') NREF,' REFERENCE STATES'
        NREFWR=MIN(NREF,1000/LN1)
        LN2=MIN(32,LN1)
        WRITE(6,'(6X,A,T47)') 'Occupation of the reference states'
        IF(NREFWR.LT.NREF) THEN
          WRITE(6,'(6X,A,I3,A)')'( Only the ',NREFWR,
     &                                         ' first are listed)'
        END IF
        Write(6,'(6X,A,T25,32I2)')'Active orbital nr.',(I,I=1,LN2)
        jEnd=0
        Do iRef=1,NREFWR
          jStart=jEnd+1
          jEnd=jEnd+LN1
          Write(6,'(6X,A,I3,T25,32I2)')'Ref nr',IREF,
     &                              (IOCR(j),j=jStart,jStart-1+LN2)
        End Do
        CALL XFLUSH(6)
      END IF
      WRITE(6,*)
      CALL XFLUSH(6)
      IF(INTNUM.NE.0) WRITE(6,*)'      FIRST ORDER INTERACTING SPACE.'
      CALL XFLUSH(6)
      IX1=IRC(1)
      IX2=IRC(2)-IRC(1)
      ISC(1)=IX1
      ISC(2)=ISC(1)+IX2*NVIRT
      IY1=ISC(1)
      IY2=ISC(2)-ISC(1)
      IF(IFIRST.EQ.0) THEN
        ILIM=4
        IX3=IRC(3)-IRC(2)
        IX4=IRC(4)-IRC(3)
        ISC(3)=ISC(2)+IX3*NVT2
        ISC(4)=ISC(3)+IX4*NVT
        IY3=ISC(3)-ISC(2)
        IY4=ISC(4)-ISC(3)
        IF(IPRINT.GE.10) THEN
          WRITE(6,*)
      CALL XFLUSH(6)
          WRITE(6,*)'      INTERNAL WALKS:'
      CALL XFLUSH(6)
          WRITE(6,215)IX1,IX2,IX3,IX4
      CALL XFLUSH(6)
215       FORMAT(/,6X,'                 VALENCE',I7,
     *           /,6X,' DOUBLET COUPLED SINGLES',I7,
     *           /,6X,' TRIPLET COUPLED DOUBLES',I7,
     *           /,6X,' SINGLET COUPLED DOUBLES',I7)
          WRITE(6,*)
      CALL XFLUSH(6)
          WRITE(6,*)'      FORMAL CONFIGURATIONS:'
      CALL XFLUSH(6)
          WRITE(6,215)IY1,IY2,IY3,IY4
      CALL XFLUSH(6)
          WRITE(6,'(6X,A,I7)')'                  TOTAL:',ISC(ILIM)
      CALL XFLUSH(6)
        END IF
      ELSE
        ILIM=2
        IF(IPRINT.GE.10) THEN
          WRITE(6,*)
      CALL XFLUSH(6)
          WRITE(6,*)'      INTERNAL WALKS:'
      CALL XFLUSH(6)
          WRITE(6,216)IX1,IX2
      CALL XFLUSH(6)
216       FORMAT(/,6X,'                 VALENCE',I7,
     *           /,6X,' DOUBLET COUPLED SINGLES',I7)
          WRITE(6,*)
      CALL XFLUSH(6)
          WRITE(6,*)'      FORMAL CONFIGURATIONS:'
      CALL XFLUSH(6)
          WRITE(6,216)IY1,IY2
      CALL XFLUSH(6)
          WRITE(6,'(6X,A,I7)')'                  TOTAL:',ISC(ILIM)
      CALL XFLUSH(6)
        END IF
      END IF
      NIWLK=IRC(ILIM)
      NCVAL=IRC(1)
C ----------------------------------------------------------------
      IF (NVIRT.GT.255) THEN
        Write(6,*)
        Write(6,*)' Sorry -- The MRCI code uses internal integer codes'
        Write(6,*)' where the index of virtual orbitals is kept in'
        Write(6,*)' 8-bit fields. This cannot easily be increased'
        Write(6,*)' and limits the number of virtual orbitals to '
        Write(6,*)' 255. Your input asks for more virtuals than this.'
        Write(6,*)' The program cannot run.'
        Call Quit(_RC_INPUT_ERROR_)
      END IF
C ----------------------------------------------------------------
C ALLOCATION OF DATA PERMANENTLY IN CORE
*
*PAM04      LCSPCK=1
*
C ICSPCK - ARRAY OF BIT-PACKED GUGA CASE NUMBERS OF INTERNAL WALKS.
C CONSISTS OF NCSPCK INTEGERS.
*
*PAM04      CALL iDAFILE(LUSYMB,2,iHWork(iPointer(LCSPCK)),NCSPCK,IADD10)
      CALL GETMEM('CSPCK','ALLO','INTE',LCSPCK,NCSPCK)
      CALL iDAFILE(LUSYMB,2,IWORK(LCSPCK),NCSPCK,IADD10)
*
C INTSYM - ARRAY OF BIT-PACKED SYMMETRY LABELS OF INTERNAL WALKS.
C CONSISTS OF NINTSY INTEGERS.
*
*PAM04      LINTSY=LCSPCK+(NCSPCK+(RTOI-1))/RTOI
*PAM04      Changed to following line:
      CALL GETMEM('INTSY','ALLO','INTE',LINTSY,NINTSY)
*PAM04      CALL iDAFILE(LUSYMB,2,iHWork(iPointer(LINTSY)),NINTSY,IADD10)
      CALL iDAFILE(LUSYMB,2,IWork(LINTSY),NINTSY,IADD10)
*
C INDX - START POSITION IN CI ARRAY OF EACH INTERNAL-WALK-BLOCK
*
*PAM04      LINDX=LINTSY+(NINTSY+(RTOI-1))/RTOI
*PAM04      Changed to following line:
      CALL GETMEM('INDX','ALLO','INTE',LINDX,NIWLK)
*
C ISAB - ORDERING NR OF EACH VIRTUAL PAIR WITHIN ITS COMB-SYMM
*
*PAM04      LISAB=LINDX+NIWLK
*PAM04      Changed to following line:
      CALL GETMEM('ISAB','ALLO','INTE',LISAB,NVIRT**2)
*
C JREFX - FOR EACH VALENCE CSF, EITHER 0 OR ITS REFERENCE NR.
*
*PAM04      LJREFX=LISAB+(1+NVIRT**2)/RTOI
*PAM04      Changed to following line:
      CALL GETMEM('JREFX','ALLO','INTE',LJREFX,NCVAL)
      IADD10=IAD10(2)
      CALL iDAFILE(LUSYMB,2,iWork(LJREFX),NCVAL,IADD10)
*
C PROJECTION SELECTION VECTORS
*
*PAM04      LCISEL=LJREFX+(1+NCVAL)/RTOI
*PAM04      Changed to following line:
      CALL GETMEM('CISEL','ALLO','REAL',LCISEL,NSEL*NREF)
*
C START OF NON-PERMANENT AREA:
*
*PAM04      LPERMA=LCISEL+NSEL*NREF
*PAM04      CALL INDMAT(HWork(LCSPCK),HWork(LINTSY),HWork(LINDX),
*PAM04     *            HWork(LISAB),HWork(LJREFX),HWork(LCISEL))
      CALL INDMAT(IWork(LCSPCK),IWork(LINTSY),IWork(LINDX),
     *            IWork(LISAB),IWork(LJREFX),Work(LCISEL))
      IF(NREF.GT.MXREF) THEN
        WRITE(6,*)'READIN Error: Too many references.'
        WRITE(6,'(1X,A,2I6)')' actual, allowed:',NREF,MXREF
        CALL QUIT(_RC_INPUT_ERROR_)
      END IF

* Total available memory (at start of program) is MEMTOT
* Available now is MEMWRK
* Already (permanently) allocated is MEMPRM

      CALL GETMEM('HowMuch','MAX','REAL',LDUM,MemWrk)
      MEMPRM=MEMTOT-MEMWRK

      CALL ALLOC_MRCI
      RETURN
991   Continue
      WRITE(6,*)'READIN Error: Premature end of file while reading.'
      Call Quit(_RC_IO_ERROR_READ_)
992   Continue
      WRITE(6,*)'READIN Error: I/O error during internal read.'
      WRITE(6,*)'The line that could not be read is:'
      WRITE(6,*) Line
      Call Quit(_RC_IO_ERROR_READ_)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Disp

use Molcas, only: LenIn, MxAtom
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: IndDsp(MxAtom,0:7), IndxEq(MxAtom*3), InxDsp(MxAtom,3), lDisp(0:7), mult_Disp(MxAtom*3), nTR
real(kind=wp) :: CutGrd, Disp_Fac(3,0:7,MxAtom)
logical(kind=iwp) :: Dirct(MxAtom*3), HF_Force, l2DI, lEq, TRSymm
character(len=LenIn+6) :: ChDisp(MxAtom*3)

public :: ChDisp, CutGrd, Dirct, Disp_Fac, HF_Force, IndDsp, IndxEq, InxDsp, l2DI, lDisp, lEq, mult_Disp, nTR, TRSymm

end module Disp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module MPProp_globals

use Data_Structures, only: Alloc1DArray_Type, Alloc2DArray_Type
use Definitions, only: wp, iwp

implicit none
private

#include "LenIn.fh"

real(kind=wp) :: EneV
character(len=180) :: Title
character(len=8) :: Method
integer(kind=iwp), allocatable :: iAtomType(:), iAtomPar(:), nAtomPBas(:), iAtPrTab(:,:)
real(kind=wp), allocatable :: Cor(:,:,:), CordMltPl(:,:), Frac(:,:), AtPol(:,:), AtBoPol(:,:), Qnuc(:)
character(len=LenIn), allocatable :: Labe(:)
character(len=LenIn*2+2), allocatable :: Cen_Lab(:)
logical(kind=iwp), allocatable :: BondMat(:,:)
type(Alloc1DArray_Type), allocatable :: AtBoMltPlTot(:), AtMltPlTot(:)
type(Alloc2DArray_Type), allocatable :: AtBoMltPl(:), AtBoMltPlCopy(:), AtMltPl(:), MltPl(:)

public :: AtBoMltPl, AtBoMltPlCopy, AtBoMltPlTot, AtBoPol, AtMltPl, AtMltPlTot, AtPol, BondMat, Cen_Lab, Cor, CordMltPl, EneV, &
          Frac, iAtomPar, iAtomType, iAtPrTab, Labe, Method, MltPl, nAtomPBas, Qnuc, Title

end module MPProp_globals

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine CIDens_sa(RSP,iLS,iRS,iL,iR,rP,rD)
      use ipPage, only: W
      Implicit Real*8(a-h,o-z)
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "stdalloc.fh"
#include "crun_mclr.fh"

#include "Input.fh"
#include "Pointers.fh"
#include "spinfo_mclr.fh"
#include "cands.fh"
#include "dmrginfo_mclr.fh"
      Real*8 rP(*),rD(*)
      Logical RSP
      integer opout
      Real*8, Allocatable:: De(:), Pe(:), CIL(:), CIR(:)

      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

* LS = CI
*
*     Ok, we once more want to hide Jeppe's routines from
*     the eyes of the world, so everyone believes that I have done
*     all the work.
*     If we have spin dependent Hamiltonian we will work with
*     SD in all parts of the program, no CSF is necessary,
*     otherwise we will do the optimization in CSF's to increase
*     convergence.
*
*     Input:
*
*     RSP: true if the density should be used for response calculations
*     iLS: CI Coeff for left state
*     iRS: CI Coeff for right state
*     iL : Symmetry of left state
*     iR : Symmetry of right state
*
*
*               +       +
*     iS=1 E  =a  a  + a  a
*           pq  ap aq   Bp Bq
*
*                +       +
*     iS=-1 T  =a  a  - a a
*            pq  ap aq   Bp Bq
*
*     Output:
*
*      rP : Two Electron Density
*      rD : One Electron Density
*
*
      If (nconf1.eq.0) return

      if(doDMRG)then
        call dmrg_dim_change_mclr(LRras2(1:8),ndim,0)
        call dmrg_dim_change_mclr(LRras2(1:8),nna,0)
        n1dens=ndim**2
        n2dens=n1dens*(n1dens+1)/2
      end if

      Call mma_allocate(De,n1dens,Label='De')
      Call mma_allocate(Pe,n2dens,Label='Pe')
      call dcopy_(n1dens,[0.0d0],0,rD,1)
      call dcopy_(n2dens,[0.0d0],0,rP,1)

*
      nConfL=Max(ncsf(il),nint(xispsm(il,1)))
      nConfR=Max(ncsf(iR),nint(xispsm(iR,1)))

      Call mma_allocate(CIL,nConfL,Label='CIL')
      Call mma_allocate(CIR,nConfR,Label='CIR')
*
      Do i=0,nroots-1
        irc=ipin(iLS)
        irc=ipin(iRS)
        Call CSF2SD(W(iLS)%Vec(1+i*ncsf(il)),CIL,iL)
        irc=opout(iLS)
        Call CSF2SD(W(iRS)%Vec(1+i*ncsf(ir)),CIR,iR)
        irc=opout(iRS)
        irc=ipnout(-1)
        icsm=iR
        issm=iL
        Call Densi2(2,De,Pe,CIL,CIR,0,0,0,n1dens,n2dens)

        If (RSP) Then
           Do iA=1,nnA
             Do jA=1,nnA
               Do kA=1,nnA
                Do la=1,nnA
                 ij1=nnA*(iA-1)+ja
                 ij2=nna*(ja-1)+ia
                 kl1=nnA*(ka-1)+la
                 kl2=nna*(la-1)+ka
                 if (ij1.ge.kl1)
     &           rp(itri(ij1,kl1))=rp(itri(ij1,kl1))+weight(1+i)*(
     &            Pe(itri(ij1,kl1))+Pe(itri(ij2,kl2)))
                End Do
               End Do
             End Do
           End Do
           Do iA=1,nnA
              Do jA=1,nnA
                 ij1=nnA*(iA-1)+ja
                 ij2=nna*(ja-1)+ia
                 rD(ij1)=rD(ij1)+
     *                weight(1+i)*(De(ij1)+De(ij2))
              End Do
           End Do
        Else
           call daxpy_(n2dens,weight(i+1),Pe,1,rp,1)
           call daxpy_(n1dens,Weight(i+1),De,1,rD,1)
        End If
      End Do
*
      Call mma_deallocate(CIL)
      Call mma_deallocate(CIR)
      Call mma_deallocate(Pe)
      Call mma_deallocate(De)

      if(doDMRG)then
        call dmrg_dim_change_mclr(RGras2(1:8),ndim,0)
        call dmrg_dim_change_mclr(RGras2(1:8),nna,0)
        n1dens=ndim**2
        n2dens=n1dens*(n1dens+1)/2
      end if
*
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Anders Bernhardsson                              *
************************************************************************
      SubRoutine AddGrad_sp(rKappa,rMat,F,idsym,r1,r2)
*
*     Purpose:
*             Adds the contribution from the gradient to
*              [2]
*             E   Kappa. This is done to insure us about
*             a beautifull convergence of the PCG,
*             which is just the case if E is symmetric.
*
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
#include "WrkSpc.fh"
      Real*8 rkappa(*),rMat(*),F(*)
      Call Getmem('OJTEMP','ALLO','REAL',ipK,ndens2)
      Call Getmem('OJTEMP','ALLO','REAL',ipm,ndens2)
      Call Unc(rkappa,Work(ipK),idsym,r1)

      Do iS=1,nSym
        js=iEor(is-1,idsym-1)+1
        If (nOrb(is)*nOrb(js).gt.0) Then
        Call Getmem('OJTEMP','ALLO','REAL',ipTempi,nOrb(is)**2)
        Call Getmem('OJTEMP','ALLO','REAL',ipTempj,nOrb(js)**2)
*
*    T=Brillouin matrix
*

        Call DGeSub(F(ipCM(is)),nOrb(is),'N',
     &              F(ipCM(is)),nOrb(is),'T',
     &              Work(ipTempi),nOrb(is),
     &              nOrb(is),nOrb(is))
        Call DGeSub(F(ipCM(js)),nOrb(js),'N',
     &              F(ipCM(js)),nOrb(js),'T',
     &              Work(ipTempj),nOrb(js),
     &              nOrb(js),nOrb(js))
*
*               t             t
*        { Kappa T  r2 T kappa  }
*
*
        Call DGEMM_('T','N',nOrb(is),nOrb(js),nOrb(js),
     &             1.0d0,Work(ipK-1+ipMat(js,is)),nOrb(js),
     &             Work(ipTempj),nOrb(js),1.0d0,
     &             Work(ipM-1+ipMat(is,js)),nOrb(is))
        Call DGEMM_('N','T',nOrb(is),nOrb(js),nOrb(is),
     &             r2,Work(ipTempi),nOrb(is),
     &             Work(ipK-1+ipmat(js,is)),nOrb(js),1.0d0,
     &             Work(ipM-1+ipMat(is,js)),nOrb(is))
        Call Getmem('OJTEMP','FREE','REAL',ipTempi,nOrb(is)**2)
        Call Getmem('OJTEMP','FREE','REAL',ipTempj,nOrb(is)**2)
      End If
      End Do
      Call COMPRESS(work(ipM),rmat,idsym)
      Call Getmem('OJTEMP','FREE','REAL',ipK,ndens2)
      Call Getmem('OJTEMP','FREE','REAL',ipm,ndens2)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine InCSFSD(iState,State_sym)

use Symmetry_Info, only: Mul
use Str_Info, only: CNSM
use MCLR_Data, only: i1, iALLO, iAnders, lConf, llDet, LuCSF2SD
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iState, State_sym
integer(kind=iwp) :: i, iad, iAdr, idum(1), iSym

! Place pointer

iSym = Mul(State_Sym,iState)

if ((isym == 1) .and. (i1 == 1)) return
if (isym == iAnders) return

iAdr = 2
if (iSym == 1) iAdr = 1
iad = 0
do i=1,iState-1
  call iDafile(LUCSF2SD,0,idum,lldet,iad)
  call iDafile(LUCSF2SD,0,idum,lconf,iad)
end do

if (iSym /= 1) then
  if (iAnders == -9) then
    call mma_allocate(CNSM(2)%icts,lldet,Label='ICTS')
    call mma_allocate(CNSM(2)%iconf,lConf,Label='ICONF')
    iAllo = 1
  end if
  iAnders = isym
end if
if (iSym == 1) then
  if (i1 == -9) then
    call mma_allocate(CNSM(1)%icts,lldet,Label='ICTS')
    call mma_allocate(CNSM(1)%iconf,lConf,Label='ICONF')
    i1 = 1
  end if
end if

!open(unit=1422,file='det.index') ! yma
!do i=1,lldet
!  write(1422,*)CNSM(iAdr)%icts(i)
!end do
!close(1422)

! calculated from zoo.f, the GUGA number for determinent
call iDafile(LUCSF2SD,2,CNSM(iAdr)%icts,lldet,iad)
call iDafile(LUCSF2SD,2,CNSM(iAdr)%iconf,lconf,iad)

end subroutine InCSFSD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pgamma()
!***********************************************************************
!                                                                      *
! Object: to compute the arrays gammath and gammaph for the angular    *
!         integration within a R-matrix run                            *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, Two, Pi, Half
use rmat, only: gammaph, gammath, lgamma
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: m, n

! initialize arrays
gammath(:,:) = Zero
gammaph(:,:) = Zero

! Set intitial values for recursion of gammath
gammath(0,0) = Two
gammath(1,0) = Half*Pi

m = 0
!m_gam = m
do n=0,2*lgamma+2,2
  gammath(0,n+2) = real(n+1,kind=wp)/real(m+n+3,kind=wp)*gammath(0,n)
  !n_gam = n
  !hgt = gammat(x)
  !write(u6,*) ' m,n,gammath,hgt',m,n,gammath(m,n),hgt
end do
do n=1,2*lgamma+2,2
  gammath(0,n) = Zero
  !n_gam = n
  !hgt = gammat(x)
  !write(u6,*) ' m,n,gammath,hgt',m,n,gammath(m,n),hgt
end do

! m > 0
do m=1,2*lgamma+2
  !m_gam = m
  do n=0,2*lgamma+2,2
    gammath(m,n+2) = real(n+1,kind=wp)/real(m+n+3,kind=wp)*gammath(m,n)
    !n_gam = n
    !hgt = gammat(x)
    !write(u6,*) ' m,n,gammath,hgt',m,n,gammath(m,n),hgt
  end do
  do n=1,2*lgamma+2,2
    gammath(m,n) = Zero
    !n_gam = n
    !hgt = gammat(x)
    !write(u6,*) ' m,n,gammath,hgt',m,n,gammath(m,n),hgt
  end do
  gammath(m+1,0) = real(m+1,kind=wp)/real(m+2,kind=wp)*gammath(m-1,0)
end do

! Set intitial values for recursion of gammaph
gammaph(0,0) = Two*pi
gammaph(1,0) = Zero
gammaph(0,1) = Zero

m = 0
!m_gam = m
do n=0,2*lgamma+2
  gammaph(0,n+2) = real(n+1,kind=wp)/real(m+n+2,kind=wp)*gammaph(0,n)
  !n_gam = n
  !hgp = gammaf(x)
  !write(u6,*) ' m,n,gammaph,hgp',m,n,gammaph(m,n),hgp
end do

! m > 0
do m=1,2*lgamma+2
  !m_gam = m
  do n=0,2*lgamma+2
    gammaph(m,n+2) = real(n+1,kind=wp)/real(m+n+2,kind=wp)*gammaph(m,n)
    !n_gam = n
    !hgp = gammaf(x)
    !write(u6,*) ' m,n,gammaph,hgp',m,n,gammaph(m,n),hgp
  end do
  gammaph(m+1,0) = real(m,kind=wp)/real(m+1,kind=wp)*gammaph(m-1,0)
end do
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine pgamma

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function THETA(M,N)
! INTEGRATION OVER THETA. INCLUDES A FACTOR SIN(TH)
! FOR THE VOLUME ELEMENT

use crelop, only: GA
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: THETA
integer(kind=iwp), intent(in) :: M, N

if (mod(N,2) == 1) then
  THETA = Zero
else
  THETA = GA(M+2)*GA(N+1)/GA(M+N+3)
end if

return

end function THETA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Freq_Molden(Freq,nFreq,Vectors,nVectors,nSym,
     &                       Intens,mDisp,RedMas)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Freq(nFreq), Vectors(nVectors),Intens(nFreq),RedMas(nFreq)
      Integer mDisp(nSym)
#include "Molcas.fh"
      Character*2 Element(MxAtom*8)
*
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('Freq',' ',Freq,1,nFreq)
      Call RecPrt('Intens',' ',Intens,1,nFreq)
      Call RecPrt('Vectors',' ',Vectors,1,nVectors)
      Write (6,*) 'mDisp=',mDisp
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Open input file for MOLDEN
*
      Lu_9=9
      Lu_9=isFreeUnit(Lu_9)
      call molcas_open(Lu_9,'MD_FREQ')
*                                                                      *
************************************************************************
*                                                                      *
      Write (Lu_9,*) '[Molden Format]'
*                                                                      *
************************************************************************
*                                                                      *
*---- Write frequecnies to Molden input file
*
      Write(Lu_9,*) '[N_FREQ]'
      Write(Lu_9,*) nFreq
      Write (Lu_9,*) '[FREQ]'
      Do iFreq = 1, nFreq
         Write (Lu_9,*) Freq(iFreq)
      End Do
      Write (Lu_9,*) '[INT]'
      Do iFreq = 1, nFreq
         Write (Lu_9,*) Intens(iFreq)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Write coordinates of all centers
*
      Call Get_nAtoms_All(nCoord)
      Call Allocate_Work(ipCoord,3*nCoord)
      Call Get_Coord_All(Work(ipCoord),nCoord)
#ifdef _DEBUGPRINT_
      Call RecPrt('Coord(all)',' ',Work(ipCoord),3,nCoord)
#endif
      Call Get_Name_All(Element)
      ipTemp=ipCoord
      Write (Lu_9,*) '[NATOM]'
      Write (Lu_9,*) nCoord

      Write (Lu_9,*) '[FR-COORD]'
      Do iCoord = 1, nCoord
         Write (Lu_9,*) Element(iCoord),(Work(ipTemp+i),i=0,2)
         ipTemp=ipTemp+3
      End Do
      Call Free_Work(ipCoord)
*                                                                      *
************************************************************************
*                                                                      *
*---- Write normal modes, observe that the order here is the same as
*     for the coordinates.
*
      Call Get_iScalar('Unique atoms',nUnique_Atoms)
      Call Get_nAtoms_All(nAll_Atoms)
      Call GetMem('NMode','Allo','Real',ipNMode,3*nAll_Atoms*nFreq)
      Call FZero(Work(ipNMode),3*nAll_Atoms*nFreq)
      Call Get_NMode_All(Vectors,nVectors,nFreq,nUnique_Atoms,
     &                   Work(ipNMode),nAll_Atoms,mDisp)
      Write (Lu_9,*) '[FR-NORM-COORD]'
#ifdef _DEBUGPRINT_
      Call RecPrt('Normal Modes',' ',Work(ipNMode),3*nAll_Atoms,nFreq)
#endif
      ipTemp=ipNMode
      Do iFreq = 1, nFreq
         Write (Lu_9,*) 'vibration ', iFreq
         Do iCoor = 1, nAll_Atoms
            Write (Lu_9,*) (Work(ipTemp+i),i=0,2)
            ipTemp=ipTemp+3
         End Do
      End Do
      Call GetMem('NMode','Free','Real',ipNMode,3*nAll_Atoms*nFreq)
*                                                                      *
************************************************************************
*                                                                      *
*     Alessio Valentini 2018 - add reduced masses to freq.molden file
*     in order to use this file for computation of initial conditions
*     in semiclassical molecular dynamics
*
      Write (Lu_9,*) '[RMASS]'
      Do iFreq = 1, nFreq
         Write (Lu_9,*) RedMas(iFreq)
      End do


      Close(Lu_9)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Wr_Prop(nAtoms,nCenters,nBas,nMltPl,NOCOB,NOCOB_b,orbe,orbe_b,iPol,LAllCenters)

use MPProp_globals, only: AtBoMltPl, AtBoMltPlTot, AtMltPl, AtMltPlTot, BondMat, Cen_Lab, Cor, Labe
use Data_Structures, only: Allocate_DT, Deallocate_DT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nCenters, nBas, nMltPl, NOCOB, NOCOB_b, iPol
real(kind=wp), intent(in) :: orbe(NOCOB), orbe_b(NOCOB_b)
logical(kind=iwp), intent(in) :: LAllCenters
integer(kind=iwp) :: i, iComp, il, iMltpl, ip, iq, j, nA, nB, nComp, nl, np, nq, nTotCen
real(kind=wp) :: fac, rnloveril, rnPoveriP, rnqoveriq, xfac, yfac, zfac
character(len=8) :: MemLabel
integer(kind=iwp), allocatable :: iCompMat(:,:,:)

call mma_allocate(Cen_Lab,nAtoms*(nAtoms+1)/2,label='Cen_Lab')
call mma_allocate(iCompMat,[0,nMltPl],[0,nMltPl],[0,nMltPl],label='iCompMat')

nTotCen = 0
do i=1,nAtoms
  nTotCen = nTotCen+1
  write(Cen_Lab(i*(i+1)/2),'(A)') Labe(i)
  do j=1,i-1
    if (BondMat(i,j)) then
      nTotCen = nTotCen+1
      write(Cen_Lab(i*(i-1)/2+j),'(3A)') LABE(i),'- ',LABE(j)
    end if
  end do
end do

call Allocate_DT(AtMltPlTot,[0,nMltPl],'AtMltPlTot')
call Allocate_DT(AtBoMltPlTot,[0,nMltPl],'AtBoMltPlTot')
do iMltpl=0,nMltPl
  iComp = 0
  nComp = (iMltPl+1)*(iMltPl+2)/2
  write(MemLabel,'(a4,i4.4)') 'AtTo',iMltPl
  call mma_allocate(AtMltPlTot(iMltPl)%A,nComp,label=MemLabel)
  AtMltPlTot(iMltPl)%A(:) = Zero
  write(MemLabel,'(a4,i4.4)') 'BoTo',iMltPl
  call mma_allocate(AtBoMltPlTot(iMltPl)%A,nComp,label=MemLabel)
  AtBoMltPlTot(iMltPl)%A(:) = Zero
  do np=iMltpl,0,-1
    do nq=iMltpl-np,0,-1
      nl = iMltpl-np-nq
      iComp = iComp+1
      iCompMat(np,nq,nl) = iComp
      do nA=1,nAtoms
        do ip=0,np
          call NoverP(np,ip,rnPoveriP)
          if (np == ip) then
            xfac = rnpoverip
          else
            xfac = rnPoveriP*(Cor(1,nA,nA))**(np-ip)
          end if
          do iq=0,nq
            call NoverP(nq,iq,rnqoveriq)
            if (nq == iq) then
              yfac = rnqoveriq
            else
              yfac = rnqoveriq*(Cor(2,nA,nA))**(nq-iq)
            end if
            do il=0,nl
              call NoverP(nl,il,rnloveril)
              if (nl == il) then
                zfac = rnloveril
              else
                zfac = rnloveril*(Cor(3,nA,nA))**(nl-il)
              end if
              fac = xfac*yfac*zfac*AtMltPl(ip+iq+il)%A(iCompMat(ip,iq,il),nA)
              AtMltPlTot(iMltpl)%A(iComp) = AtMltPlTot(iMltpl)%A(iComp)+fac
            end do
          end do
        end do
        do nB=1,nA
          if ((nA == nB) .or. BondMat(nA,nB)) then
            do ip=0,np
              call NoverP(np,ip,rnPoveriP)
              if (np == ip) then
                xfac = rnpoverip
              else
                xfac = rnPoveriP*(Cor(1,nA,nB))**(np-ip)
              end if
              do iq=0,nq
                call NoverP(nq,iq,rnqoveriq)
                if (nq == iq) then
                  yfac = rnqoveriq
                else
                  yfac = rnqoveriq*(Cor(2,nA,nB))**(nq-iq)
                end if
                do il=0,nl
                  call NoverP(nl,il,rnloveril)
                  if (nl == il) then
                    zfac = rnloveril
                  else
                    zfac = rnloveril*(Cor(3,nA,nB))**(nl-il)
                  end if
                  fac = xfac*yfac*zfac*AtBoMltPl(ip+iq+il)%A(iCompMat(ip,iq,il),nA*(nA-1)/2+nB)
                  AtBoMltPlTot(iMltpl)%A(iComp) = AtBoMltPlTot(iMltpl)%A(iComp)+fac
                end do
              end do
            end do
          end if
        end do
      end do
    end do
  end do
end do

call mma_deallocate(iCompMat)

call Wr_MpProp(nAtoms,nCenters,nMltPl,iPol)
!EB call Wr_Files(nAtoms,nCenters,nMltPl,nBas,NOCOB,orbe,iBond,
call Wr_Files(nAtoms,nCenters,nMltPl,nBas,NOCOB,NOCOB_b,orbe,orbe_b,LAllCenters)

call Deallocate_DT(AtMltPlTot)
call Deallocate_DT(AtBoMltPlTot)

call mma_deallocate(Cen_Lab)

return

!EB 111 format(A,3F15.5,6F10.3,10I5)

end subroutine Wr_Prop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_ParConf(Fake)
C
C     Purpose: set parallel info used in Cholesky decomposition of
C              two-electron integrals. If Fake=.True., run the
C              decomposition in serial and distribute vectors over nodes
C              at the end (no distribution is actually done, of course;
C              the relevant vectors are simply kept on the relevant
C              nodes).
C
      Implicit None
      Logical Fake
#include "cho_para_info.fh"

      Cho_Real_Par = Is_Real_Par() .and. (.not.Fake)

      End
      SubRoutine Cho_GASync()
      Implicit None
#include "cho_para_info.fh"

      If (Cho_Real_Par) Call GASync

      End
      SubRoutine Cho_Init_Tsk(ID,n)
      Implicit None
      Integer ID, n
#include "cho_para_info.fh"

      If (Cho_Real_Par) Then
         Call Init_Tsk(ID,n)
      Else
         Call Cho_Init_Tsk_(ID,n)
      End If

      End
      SubRoutine Cho_Init_Tsk_(ID,n)
      Implicit None
      Integer ID, n
#include "cho_para_info.fh"
      Logical Parallel_Mode

      Parallel_Mode = Is_Real_Par()

      Call Set_Do_Parallel(.False.)
      Call Init_Tsk(ID,n)
      Call Set_Do_Parallel(Parallel_Mode)

      End
      SubRoutine Cho_Free_Tsk(ID)
      Implicit None
      Integer ID
#include "cho_para_info.fh"

      If (Cho_Real_Par) Then
         Call Free_Tsk(ID)
      Else
         Call Cho_Free_Tsk_(ID)
      End If

      End
      SubRoutine Cho_Free_Tsk_(ID)
      Implicit None
      Integer ID
#include "cho_para_info.fh"
      Logical Parallel_Mode

      Parallel_Mode = Is_Real_Par()

      Call Set_Do_Parallel(.False.)
      Call Free_Tsk(ID)
      Call Set_Do_Parallel(Parallel_Mode)

      End
      Logical Function Cho_Rsv_Tsk(ID,i)
      Implicit None
      Integer  ID, i
#include "cho_para_info.fh"
      Logical  Rsv_Tsk
      External Rsv_Tsk
      Logical  Cho_Rsv_Tsk_
      External Cho_Rsv_Tsk_

      If (Cho_Real_Par) Then
         Cho_Rsv_Tsk = Rsv_Tsk(ID,i)
      Else
         Cho_Rsv_Tsk = Cho_Rsv_Tsk_(ID,i)
      End If

      End
      Logical Function Cho_Rsv_Tsk_(ID,i)
      Implicit None
      Integer ID, i
#include "cho_para_info.fh"
      Logical Parallel_Mode
      Logical  Rsv_Tsk
      External Rsv_Tsk

      Parallel_Mode = Is_Real_Par()

      Call Set_Do_Parallel(.False.)
      Cho_Rsv_Tsk_ = Rsv_Tsk(ID,i)
      Call Set_Do_Parallel(Parallel_Mode)

      End
      SubRoutine Cho_GAdGOp(X,n,Op)
      Implicit None
      Integer n, iv, kv
      Real*8  X(n)
      Character*(*) Op
#include "cho_para_info.fh"

      If (Cho_Real_Par) Then
         iv=0
         do while (iv .lt. n)
            kv=Min(n-iv,32000000)
            Call GAdGOp(X(iv+1),kv,Op)
            iv=iv+kv
         end do
      EndIf

      End
      SubRoutine Cho_GAiGOp(X,n,Op)
      Implicit None
      Integer n, iv, kv
      Integer X(n)
      Character*(*) Op
#include "cho_para_info.fh"

      If (Cho_Real_Par) Then
         iv=0
         do while (iv .lt. n)
            kv=Min(n-iv,32000000)
            Call GAiGOp(X(iv+1),kv,Op)
            iv=iv+kv
         end do
      EndIf

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_VECRD(SCR,LSCR,JVEC1,IVEC2,ISYM,JNUM,IREDC,MUSED)
!
! Purpose: read as many vectors as fit into SCR array starting
!          at vector JVEC1 and reading at most until vector IVEC2.
!          On exit, JNUM is the number of vectors read.
!          On entry as well as exit, IREDC identifies the reduced
!          set stored in core (at position "3"; use -1 if none
!          or unkown). Vectors are taken from buffer, if possible.
!
! NOTE: if no vectors can be read, JNUM=0 and MUSED=0 are returned,
!       but execution is NOT stopped here!!!

use Cholesky, only: RUN_EXTERNAL, RUN_MODE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LSCR, JVEC1, IVEC2, ISYM
real(kind=wp), intent(inout) :: SCR(LSCR)
integer(kind=iwp), intent(out) :: JNUM, MUSED
integer(kind=iwp), intent(inout) :: IREDC
integer(kind=iwp) :: JN, JV1, KS, LFT, MU
logical(kind=iwp) :: DOREAD

! Initialize.
! -----------

JNUM = 0
MUSED = 0
if (LSCR < 1) return

! Copy vectors from buffer (if possible).
! Only relevant for "external" runs (else the vectors are stored in
! current reduced set).
! -----------------------------------------------------------------

if (RUN_MODE == RUN_EXTERNAL) call CHO_VECBUF_RETRIEVE(SCR,LSCR,JVEC1,IVEC2,ISYM,JNUM,IREDC,MUSED)

! Read remaining vectors from disk.
! ---------------------------------

DOREAD = .true.
JV1 = JVEC1+JNUM
LFT = LSCR-MUSED
if ((IVEC2 >= JV1) .and. (LFT > 0)) then
  KS = MUSED+1
  JN = 0
  MU = 0
  call CHO_VECRD1(SCR(KS),LFT,JV1,IVEC2,ISYM,JN,IREDC,MU,DOREAD)
  JNUM = JNUM+JN
  MUSED = MUSED+MU
end if

end subroutine CHO_VECRD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MakeWwdHlp2 (Ww,W1,
     c                       dima,dimbe,dimga)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c       for the case a"=b" , beSGrp.ne.gaSGrp
c       N.B. algoritmus nieje prilis vymakany
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       dimx   - dimension of a",be",ga" (I)
c
        implicit none
        integer dima,dimbe,dimga
        real*8 Ww(1:dima,1:dimbe,1:dimga)
        real*8 W1(1:dima,1:dimbe,1:dima,1:dimga)
c
c       help variables
        integer a,be,ga
c
c
CVpV 2014 Fix for Intel Compiler v14.*
#ifdef __INTEL_COMPILER
          do a=1,dima
          do ga=1,dimga
cDEC$ VECTOR UNALIGNED
          do be=1,dimbe
            Ww(a,be,ga)=W1(a,be,a,ga)
          end do
          end do
          end do
#else
          do ga=1,dimga
          do be=1,dimbe
          do a=1,dima
            Ww(a,be,ga)=W1(a,be,a,ga)
          end do
          end do
          end do
#endif
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Wr_Cord(nAtoms)

      Implicit real*8 (a-h,o-z)

#include "WrkSpc.fh"
#include "MpParam.fh"
#include "Address.fh"
#include "MolProp.fh"

      iStdOut = 6

      Write (iStdOut,*)
      Write (iStdOut,'(10X,A)')
     &      ' ************************************************ '
      Write (iStdOut,'(10X,A)')
     &      ' **** Cartesian Coordinates / Bohr, Angstrom **** '
      Write (iStdOut,'(10X,A)')
     &      ' ************************************************ '
      Write (iStdOut,*)
      Write (iStdOut,'(A11,A7,A)')  'Center',  'Label',
     &      '              X              Y              Z',
     &      '                     X              Y              Z'
      Do i=1,nAtoms
*Jose    Write (iStdOut,'(6X,I3,5X,A4,3(5X,F10.6),7X,3(5X,F10.6))')
         Write (iStdOut,'(6X,I3,5X,A6,3(5X,F10.6),7X,3(5X,F10.6))')
     &   i,Labe(i),Cor(1,i,i),Cor(2,i,i),Cor(3,i,i),
     &   Cor(1,i,i)*Bohr_to_Ang,
     &   Cor(2,i,i)*Bohr_to_Ang,Cor(3,i,i)*Bohr_to_Ang
      EndDo
      Write (iStdOut,*)
      Write (iStdOut,*)
      Write (iStdOut,'(A11,A7,A13,A25,A20)') 'Center','Label',
     &'Atomtype','Effective core charge','Atomic Parameter'
      Write (iStdOut,*)
      Do i=1,nAtoms
*Jose Write (iStdOut,'(6X,I3,5X,A4,10X,I3,19X,F6.1,10X,I10)')i,Labe(i),
      Write (iStdOut,'(6X,I3,5X,A6,10X,I3,19X,F6.1,10X,I10)')i,Labe(i),
     &iAtomType(i),Work(iQnuc+i-1), iAtomPar(i)
      EndDo
      Write (iStdOut,*)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021,2023, Vladislav Kochetov                          *
!***********************************************************************

subroutine read_rassd(nfile)
!***********************************************************************
! reads input RASSCF file RASSDX, where X = nfile
!***********************************************************************

use rhodyn_data, only: CI, DTOC, E, H_CSF, i_rasscf, ipglob, lroots, nconf, NDET, rassd_list, runmode
use mh5, only: mh5_close_file, mh5_exists_attr, mh5_exists_dset, mh5_fetch_attr, mh5_fetch_dset, mh5_open_file_r
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nfile
integer(kind=iwp) :: fileid
character(len=16) :: molcas_module
real(kind=wp), allocatable :: tmp(:,:)

fileid = mh5_open_file_r(rassd_list(nfile))

i_rasscf = 0
! if i_rasscf = 0 at the end of the file, that is sign of error
!               1 - spin-free H obtained (dset 'HCSF' is found)
!               2 - CIs and Es obtained (dsets 'CI_VECTORS' and 'ROOT_ENERGIES' in RASSCF)
!               3 - CIs and Es (dsets 'CI_VECTORS' and 'STATE_PT2_ENERGIES' from CASPT2)

! reading ci vectors and energies
if (mh5_exists_attr(fileid,'MOLCAS_MODULE')) then
  call mma_allocate(tmp,nconf(nfile),lroots(nfile),label='tmp')
  call mh5_fetch_attr(fileid,'MOLCAS_MODULE',molcas_module)
  if (molcas_module(1:6) == 'RASSCF') then
    ! rasscf input file:
    i_rasscf = 2
    if (ipglob > 2) write(u6,*) 'reading CI_VECTORS'
    call mh5_fetch_dset(fileid,'CI_VECTORS',tmp,[nconf(nfile),lroots(nfile)],[0,0])
    CI(1:nconf(nfile),1:lroots(nfile),nfile) = tmp(:,:)
    if (runmode /= 4) then
      if (ipglob > 2) write(u6,*) 'reading ROOT_ENERGIES'
      call mh5_fetch_dset(fileid,'ROOT_ENERGIES',E(1:lroots(nfile),nfile))
    end if
  else if (molcas_module(1:6) == 'CASPT2') then
    ! caspt2 input file:
    i_rasscf = 3
    !call mh5_fetch_dset(fileid,'H_EFF',H_CSF(1:nconf(nfile),1:nconf(nfile),nfile))
    if (mh5_exists_dset(fileid,'CI_VECTORS')) call mh5_fetch_dset(fileid,'CI_VECTORS',tmp)
    CI(1:nconf(nfile),1:lroots(nfile),nfile) = tmp(:,:)
    if (runmode /= 4) then
      if (mh5_exists_dset(fileid,'STATE_PT2_ENERGIES')) call mh5_fetch_dset(fileid,'STATE_PT2_ENERGIES',E(1:lroots(nfile),nfile))
    end if
  end if
  call mma_deallocate(tmp)
end if

! reading Hamiltonian (at the moment molcas does not write Hamiltonian in det basis to HDF5 file)
if (mh5_exists_dset(fileid,'HCSF')) then
  call mma_allocate(tmp,nconf(nfile),nconf(nfile),label='tmp')
  call mh5_fetch_dset(fileid,'HCSF',tmp)
  H_CSF(1:nconf(nfile),1:nconf(nfile),nfile) = tmp(:,:)
  call mma_deallocate(tmp)
  i_rasscf = 1
end if
if (mh5_exists_dset(fileid,'DTOC')) then
  call mma_allocate(tmp,NDET(nfile),nconf(nfile),label='tmp')
  call mh5_fetch_dset(fileid,'DTOC',tmp)
  DTOC(1:NDET(nfile),1:nconf(nfile),nfile) = tmp(:,:)
  call mma_deallocate(tmp)
end if

call mh5_close_file(fileid)

if (i_rasscf == 0) then
  write(u6,*) 'Error in reading RASSCF file ',rassd_list(nfile)
  write(u6,*) 'Required dsets has not been found in RASSD file'
  call abend()
end if

end subroutine read_rassd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Box(Coor,mTtAtm,iANr,TabB,TabA,nBonds,nMax)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 Coor(3,mTtAtm)
      Integer iANr(mTtAtm)
      Integer, Allocatable:: TabB(:,:), TabA(:,:,:), iBox(:,:),
     &                       Tab(:,:,:,:)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      If (mTtAtm.lt.2) Then
         Write (6,*) 'Too few atoms to relax: mTtAtm=',mTtAtm
         Call WarningMessage(2,'mTtAtm.lt.2')
         Call Abend()
      End If
*
      ThrB=0.40D0
#ifdef _DEBUGPRINT_
      Call RecPrt('Box: Coor',' ',Coor,3,mTtAtm)
      Write (6,*) 'Box: ThrB=',ThrB
#endif
*
      xmin= 1.0D+10
      ymin= 1.0D+10
      zmin= 1.0D+10
      xmax=-1.0D+10
      ymax=-1.0D+10
      zmax=-1.0D+10
*
*---- Establish boundaries
*
      Do iAtom = 1, mTtAtm
         xmin=Min(xmin,Coor(1,iAtom))
         xmax=Max(xmax,Coor(1,iAtom))
         ymin=Min(ymin,Coor(2,iAtom))
         ymax=Max(ymax,Coor(2,iAtom))
         zmin=Min(zmin,Coor(3,iAtom))
         zmax=Max(zmax,Coor(3,iAtom))
      End Do
      xmin=xmin-1.0D-2
      xmax=xmax+1.0D-2
      ymin=ymin-1.0D-2
      ymax=ymax+1.0D-2
      zmin=zmin-1.0D-2
      zmax=zmax+1.0D-2
*
      Box_Size = 8.0D0  !   a.u.
      nx = Max(1,INT((xmax-xmin)/Box_Size)+1)
      adjust = (DBLE(nx)*Box_size - (xmax-xmin))/Two
      xmin=xmin-adjust
      xmax=xmax+adjust
      ny = MAX(1,INT((ymax-ymin)/Box_Size)+1)
      adjust = (DBLE(ny)*Box_size - (ymax-ymin))/Two
      ymin=ymin-adjust
      ymax=ymax+adjust
      nz = MAX(1,INT((zmax-zmin)/Box_Size)+1)
      adjust = (DBLE(nz)*Box_size - (zmax-zmin))/Two
      zmin=zmin-adjust
      zmax=zmax+adjust
#ifdef _DEBUGPRINT_
      Write (6,*) 'nx,ny,nz=',nx,ny,nz
#endif
*
      nMax=100
cnf      nMax=40
c AOM Fixed this size to account for double VdW counting
      nBondMax=mTtAtm*(mTtAtm+1)
c AOM
      Call mma_allocate(TabB,3,nBondMax,Label='TabB')
      Call mma_allocate(TabA,[1,2],[0,nMax],[1,mTtAtm],Label='TabA')
      Call mma_allocate(Tab,[0,nMax],[1,nx],[1,ny],[1,nz],Label='Tab')
      Call mma_allocate(iBox,3,mTtAtm,Label='iBox')
*
      Call Sort_to_Box(Coor,mTtAtm,Tab,nMax,nx,ny,nz,
     &                 iBox,iANr,xmin,ymin,zmin,Box_Size)
*
      Call Find_Bonds(Coor,mTtAtm,Tab,nMax,nx,ny,nz,iBox,iANr,
     &                TabB,nBonds,nBondMax,TabA,ThrB)
*
      Call mma_deallocate(iBox)
      Call mma_deallocate(Tab)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2009, Francesco Aquilante                              *
************************************************************************
      SUBROUTINE Inv_FWT_Haar(n,m,B,X)
************************************************************************
*
*     Author :  F. Aquilante  (Geneva, April 2009)
*
*
*     Purpose : performs an inverse Fast Wavelet Transform (FWT)
*               of 2^m vectors Y_1(n),Y_2(n),...,Y_2^m(n)
*               using m-th order Haar wavelet.
*
*
*     n : number of components of each vector (input)
*     m : order of Haar wavelet = Log_2 of the number of vectors (input)
*     B(n,2^m) : scratch array (input)
*     X(n,2^m) : array of initial/transformed vectors (input/output)
*
************************************************************************
*
*     Mallat's pyramid algorithm (IEEE Trans PAMI, 11, 674-693, 1989) :
*
*      Y=(A[0],B[0],B[1],...,B[m-1]) ---> (X_1,X_2,X_3,X_4,...,X_2^m)
*
*        j=1,2,...,m
*                       A[j] = L[j]^t * A[j-1] + H[j]^t * B[j-1]
*
*
*        The matrices H[j] and L[j] have:
*
*        2^(j-1) orthonormal rows, and
*
*        2^j cols pair-orthonormal (merging col k and k+1, the result is
*                 2^(j-1) orthonormal cols each containing 2^j elements)
*
*        and very few nonzero entries.
*
*        High Pass (differencing) filters:
*
*                   [  1 -1                          ]
*                   [        1 -1                    ]
*        H[j] = 1/2 [              ....              ]
*                   [                    ....        ]
*                   [                          1 -1  ]
*
*        Low Pass (averaging) filters:
*
*                   [  1  1                          ]
*                   [        1  1                    ]
*        L[j] = 1/2 [              ....              ]
*                   [                    ....        ]
*                   [                          1  1  ]
*
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Integer n, m
      Real*8  B(n,*), X(n,*)
*
*
*
      If (m .le. 0) Then

         Write(6,*) ' Inv_FWT_Haar: Illegal value of m = ',m
         Call Abend

      ElseIf (n .le. 0) Then

         Write(6,*) ' Inv_FWT_Haar: Illegal value of n = ',n
         Call Abend

      Else  ! do not use BLAS

         fac=sqrt(0.5d0)
         nv=1
         Do j=1,m
            kB=-1
            Do k=1,nv
               kB=kB+2
               lB=kB+1
               kv=k+nv
               Do i=1,n
                  B(i,kB) = fac*(X(i,k)+X(i,kv))
                  B(i,lB) = fac*(X(i,k)-X(i,kv))
               End Do
            End Do
            nv=nv*2
            call dcopy_(n*nv,B,1,X,1)
         End Do

      EndIf
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!***********************************************************************

subroutine InitIA(I,mDeg)
! Purpose: Express the interaction tensor, defined by the
! quantities T(a,b,c) as functions of the vector R=(x,y,z),
! where a,b, and c are nonnegative integers and
! T(a,b,c)=((d/dx)**a)((d/dy)**b)((d/dz)**c) 1/R, in terms
! of a polynomial:
! T(a,b,c)=
!  (sum over p,q,r of I(a,b,c,p,q,r) x**p y**q z**r)/(R**(2*n+1)),
! where n=a+b+c.
! The polynomial coefficients are integers, and are 0 unless
! p+q+r=n.
! Author: PAM

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: mDeg
integer(kind=iwp), intent(out) :: I(0:mDeg,0:mDeg,0:mDeg,0:mDeg,0:mDeg,0:mDeg)
integer(kind=iwp) :: a, b, c, n, new, p, q, r

! initialize:
I(:,:,:,:,:,:) = 0
I(0,0,0,0,0,0) = 1
if (mDeg > 0) then
  I(1,0,0,1,0,0) = -1
  I(0,1,0,0,1,0) = -1
  I(0,0,1,0,0,1) = -1
end if
do n=2,mDeg
  do a=0,n
    do b=0,n-a
      c = n-a-b
      do p=0,n
        do q=0,n-p
          r = n-p-q
          new = 0
          if (a > 0) then
            if (p > 0) new = (p-(2*n))*I(a-1,b,c,p-1,q,r)
            if (q > 1) new = new+(p+1)*I(a-1,b,c,p+1,q-2,r)
            if (r > 1) new = new+(p+1)*I(a-1,b,c,p+1,q,r-2)
          else if (b > 0) then
            if (q > 0) new = (q-(2*n))*I(a,b-1,c,p,q-1,r)
            if (r > 1) new = new+(q+1)*I(a,b-1,c,p,q+1,r-2)
            if (p > 1) new = new+(q+1)*I(a,b-1,c,p-2,q+1,r)
          else
            if (r > 0) new = (r-(2*n))*I(a,b,c-1,p,q,r-1)
            if (p > 1) new = new+(r+1)*I(a,b,c-1,p-2,q,r+1)
            if (q > 1) new = new+(r+1)*I(a,b,c-1,p,q-2,r+1)
          end if
          I(a,b,c,p,q,r) = new
        end do
      end do
    end do
  end do
end do

! write out only elements with a>=b>=c. The others are obtained
! by index permutation.
! This restriction has been removed! (Roland Lindh)
!n = mDeg
!do a=n,0,-1
!  do b=n-a,0,-1
!    c = n-a-b
!    write(u6,'(5x,''T('',i1,'','',i1,'','',i1,'')='',i5)')a,b,c,C_Ind(n,a,c)
!    do p=n,0,-1
!      do q=n-p,0,-1
!        r = n-p-q
!        coef = I(a,b,c,p,q,r)
!        if (coef /= 0) write(u6,'(10x,i8,''*x**'',i1,'' *y**'',i1,'' *z**'',i1,i5)') coef,p,q,r,C_Ind(n,p,r)
!      end do
!    end do
!  end do
!end do

return

end subroutine InitIA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MkGrid(natom,ipCord,ipGrd,nGrdPt,iRMax,DeltaR,
     &                  Forces,ipIsMM,iGrdTyp,ipDGrd,nAtQM)
      use PCM_arrays
      use external_centers, only: iXPolType
      Implicit Real*8 (A-H,O-Z)
*
#include "espf.fh"
*
#include "rctfld.fh"
#include "stdalloc.fh"
      Logical Forces,Process,Dirty
*
      iPL = iPL_espf()
*
      iPrint = 5
      If (iPL.ge.3) iPrint = 50
      If (iPL.ge.4) iPrint = 99
      nDiff = 0
      Call GetMem('Atomic Numbers','Allo','Inte',ipAN,natom)
      Call GetMem('Get_Atoms','Allo','Real',ipChrg,natom)
      Call Get_dArray('Nuclear charge',Work(ipChrg),natom)
      Do iatom = 0, natom-1
         iWork(ipAN+iatom) = Int(Work(ipChrg+iatom))
      End Do
      Call GetMem('Get_Atoms','Free','Real',ipChrg,natom)
      nGrdPt_old = nGrdPt
*
*     PNT grid (it uses Angstroms !!!)
*
      If (Abs(iGrdTyp).eq.1) Then
         DeltaR = DeltaR * Angstrom
         Process = (iGrdTyp.eq.1)
         Call DScal_(3*natom,Angstrom,Work(ipCord),1)
         Call PNT(6,natom,Work(ipCord),iRMax,DeltaR,iWork(ipAN),
     &            nGrdPt,Work(ipGrd),iWork(ipIsMM),Process)
         Call DScal_(3*natom,One/Angstrom,Work(ipCord),1)
         DeltaR = DeltaR / Angstrom
         If (nGrdPt.le.0) Then
            Write(6,'(A)') ' Error in espf/mkgrid: nGrdPt < 0 !!!'
            Call Quit_OnUserError()
         End If
*
*        Printing the PNT point coordinates
*
         If(Process .and. .not. DoDeriv) Then
            If (iPL.ge.4) Then
               Write(6,'(A,I5,A)') ' PNT grid (in Angstrom) '
               Do iPt = 1, nGrdPt
                  iCur = 3*(iPt-1)
                  Write(6,'(A4,3F15.6)') ' X  ',Work(ipGrd+iCur),
     &                                          Work(ipGrd+iCur+1),
     &                                          Work(ipGrd+iCur+2)
               End Do
            End If
            Call DScal_(3*nGrdPt,One/Angstrom,Work(ipGrd),1)
         End If
c
c     GEPOL grid (made of iRMax surfaces)
c
      Else
         iXPolType = 0
         PCM = .True.
         DoDeriv = Forces
         nDer = nAtQM*3
         Do J = 0, iRMax-1
            If (iPL.ge.3) Write(6,'(A13,I1)') ' GEPOL shell ',J+1
            Call GetMem('LcCoor','Allo','Real',ip_LcCoor,3*natom)
            Call GetMem('LcANr','Allo','Inte',ip_LcANr,natom)
            nPCM_info = 0
            Call PCM_Cavity(iPrint,0,natom,Angstrom,Work(ipCord),
     &                      iWork(ipAN),iWork(ipIsMM),Work(ip_LcCoor),
     &                      iWork(ip_LcANr),J)
            Call GetMem('LcANr','Free','Inte',ip_LcANr,natom)
            Call GetMem('LcCoor','Free','Real',ip_LcCoor,3*natom)
            If(J.eq.0) Then
              nTmp = 0
              nGrdPt = nTs
              Call Allocate_Work(ipTmp,3*nGrdPt)
            Else
              nTmp = nGrdPt
              Call Allocate_Work(ipBla,3*nTmp)
              call dcopy_(3*nTmp,Work(ipTmp),1,Work(ipBla),1)
              nGrdPt = nTs + nGrdPt
              Call Free_Work(ipTmp)
              Call Allocate_Work(ipTmp,3*nGrdPt)
              call dcopy_(3*nTmp,Work(ipBla),1,Work(ipTmp),1)
              Call Free_Work(ipBla)
            End If
            If (DoDeriv) Call GetMem('ESPF_DGrid','Allo','Real',ipDGrd,
     &                               3*nGrdPt*nDer)
            Do I = 1, nTs
               call dcopy_(3,PCMTess(1,I),1,
     &                      Work(ipTmp   + 3*nTmp+3*(I-1)),1)
            End Do
            If (DoDeriv) call dcopy_(3*nGrdPt*nDer,DPnt,1,
     &                                            Work(ipDGrd ),1)
            Call mma_deallocate(NewSph)
            Call mma_deallocate(IntSph)
            Call mma_deallocate(NVert)
            Call mma_deallocate(PCMiSph)
            Call mma_deallocate(PCM_N)
            Call mma_deallocate(PCMDM)
            Call mma_deallocate(SSph)
            Call mma_deallocate(Centr)
            Call mma_deallocate(Vert)
            Call mma_deallocate(PCMTess)
            Call mma_deallocate(PCMSph)
            If (DoDeriv) Then
               Call mma_deallocate(dTes)
               Call mma_deallocate(dPnt)
               Call mma_deallocate(dRad)
               Call mma_deallocate(dCntr)
               Call mma_deallocate(PCM_SQ)
            End If
         End Do
         Call GetMem('ESPF_Grid','Allo','Real',ipGrd,3*nGrdPt)
         call dcopy_(3*nGrdPt,Work(ipTmp),1,Work(ipGrd),1)
         Call Free_Work(ipTmp)
*
*        Cleaning the GEPOL grid:
*        all grid points must be distant by 1 bohr at least
*
10       Dirty = .False.
         Call Allocate_iWork(ipKeep,nGrdPt)
         Do iPnt = 0, nGrdPt-1
            iWork(ipKeep+iPnt) = 1
         End Do
         Do iPnt = 0, nGrdPt-2
            If (iWork(ipKeep+iPnt) .eq. 0) Goto 11
            Do jPnt = iPnt+1, nGrdPt-1
               X = Work(ipGrd+3*jPnt  ) - Work(ipGrd+3*iPnt  )
               Y = Work(ipGrd+3*jPnt+1) - Work(ipGrd+3*iPnt+1)
               Z = Work(ipGrd+3*jPnt+2) - Work(ipGrd+3*iPnt+2)
               R = Sqrt(X*X+Y*Y+Z*Z)
               If (R .lt. One) iWork(ipKeep+jPnt) = 0
            End Do
11          Continue
         End Do
         New_nGrdPt = 0
         Do iPnt = 0, nGrdPt-1
            If(iWork(ipKeep+iPnt) .eq. 1) New_nGrdPt = New_nGrdPt + 1
         End Do
         Dirty = New_nGrdPt.lt.nGrdPt
         If(Dirty) Then
            Call Allocate_Work(ipTmpG,3*nGrdPt)
            call dcopy_(3*nGrdPt,Work(ipGrd),1,Work(ipTmpG),1)
            Call GetMem('ESPF_Grid','Free','Real',ipGrd,3*nGrdPt)
            Call GetMem('ESPF_Grid','Allo','Real',ipGrd,3*New_nGrdPt)
            If (DoDeriv) Then
               Call Allocate_Work(ipTmpDG,3*nGrdPt*NDer)
               call dcopy_(3*nGrdPt*NDer,Work(ipDGrd),1,Work(ipTmpDG),1)
               Call GetMem('ESPF_DGrid','Free','Real',ipDGrd,
     &                  3*nGrdPt*NDer)
               Call GetMem('ESPF_DGrid','Allo','Real',ipDGrd,
     &                  3*New_nGrdPt*NDer)
            End If
            ibla = -1
            Do iPnt = 0, nGrdPt-1
               If (iWork(ipKeep+iPnt) .eq. 1) Then
                  ibla = ibla + 1
                  call dcopy_(3,Work(ipTmpG+3*iPnt),1,
     &                         Work(ipGrd +3*ibla),1)
                  If (DoDeriv)
     &               call dcopy_(9*nAtQM,Work(ipTmpDG+iPnt),nGrdPt,
     &                                  Work(ipDGrd +ibla),New_nGrdPt)
               End If
            End Do
            If (DoDeriv) Call Free_Work(ipTmpDG)
            Call Free_Work(ipTmpG)
            nGrdPt = New_nGrdPt
         End If
         Call Free_iWork(ipKeep)
         If(Dirty) Goto 10
*
*        Printing the GEPOL point coordinates
*
         If (.not.DoDeriv .and. iPL.ge.4) Then
            Call DScal_(3*nGrdPt,Angstrom,Work(ipGrd),1)
            Write(6,'(A)') 'PCM grid (in Angstroms):'
            Do iPnt = 0, nGrdPt-1
               iCur = 3*iPnt
               Write(6,'(A4,3F15.6)') ' X  ',Work(ipGrd+iCur  ),
     &                                       Work(ipGrd+iCur+1),
     &                                       Work(ipGrd+iCur+2)
            End Do
            Call DScal_(3*nGrdPt,One/Angstrom,Work(ipGrd),1)
         End If
         PCM = .False.
      End If
      If(nGrdPt_old.ne.0 .and. nGrdPt.ne.nGrdPt_old) Then
        Write(6,'(A,2i10)') 'MkGrid: inconsistency in nGrdPt:',
     &                      nGrdPt_old,nGrdPt
        Call Abend()
      End If
      Call GetMem('Atomic Numbers','Free','Inte',ipAN,natom)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine span1_cvb(c,nvec,s,n,metr)
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "span_comcvb.fh"
      dimension c(n,nvec),s(*)

      nvremain=nvec
100   nvmove=min(nvremain,nvecmx-nvtot)
      if(nvmove.eq.0.and.nvremain.gt.0)then
        write(6,*)' Fatal error in SPAN_CVB!',nvmove,nvremain
        call abend_cvb()
      endif
      call fmove_cvb(c(1,1+nvec-nvremain),work(nvtot*n+iaddr),n*nvmove)
      nvtot=nvtot+nvmove
      if(nvtot.eq.nvecmx)call span_cvb(work(iaddr),nvtot,nvtot,s,n,metr)
      nvremain=nvremain-nvmove
      if(nvremain.gt.0)goto 100
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!ifdef _DEBUGPRINT_
subroutine SOEIG(PROP,USOR,USOI,ENSOR,NSS,ENERGY)

use rassi_aux, only: ipglob
use rassi_global_arrays, only: JBNUM
use sorting, only: argsort
use sorting_funcs, only: leq_r
use Cntrl, only: EMIN, ICOMP, IFJ2, IFJZ, LOOPDIVIDE, MLTPLT, NPROP, NSOThr_PRT, NSTATE, PNAME, REDUCELOOP, SOThr_PRT
#ifdef _HDF5_
use Dens2HDF5, only: UpdateIdx
use mh5, only: mh5_put_dset
use RASSIWfn, only: wfn_SOS_CoefI, wfn_SOS_CoefR, wfn_SOS_Energy, wfn_SOS_HSOI, wfn_SOS_HSOR, wfn_SOS_VSOI, wfn_SOS_VSOR
use Cntrl, only: IFTDM, IFTRD1, RHODYN
#endif
#ifdef _DMRG_
use rasscf_global, only: doDMRG
#endif
use wigner_util, only: dclebs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Ten, Half, Quart, auTocm, auToeV
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: PROP(NSTATE,NSTATE,NPROP)
integer(kind=iwp), intent(in) :: NSS
real(kind=wp), intent(inout) :: USOR(NSS,NSS), USOI(NSS,NSS), ENERGY(NSTATE)
real(kind=wp), intent(out) :: ENSOR(NSS)
integer(kind=iwp) :: IAMFIX, IAMFIY, IAMFIZ, IAMX, IAMY, IAMZ, IDX, IPROP, ISS, ISTATE, ITOL, JOB, JSS, JSTATE, MAGN, MPLET, &
                     MPLET1, MPLET2, MSPROJ, MSPROJ1, MSPROJ2, N
real(kind=wp) :: AMFIX, AMFIY, AMFIZ, CG0, CGM, CGP, CGX, CGY, E0, E1, E2, E3, E_TMP, EI, EPSH, EPSS, ERMS, FACT, FRAC, HSOI, &
                 HSOR, HSOTOT, OMEGA, S1, S2, SM1, SM2, SOTHR_MIN, X, X_THR, XJEFF
integer(kind=iwp), allocatable :: IndexE(:), MAPMS(:), MAPSP(:), MAPST(:)
real(kind=wp), allocatable :: ESO(:), HAMSOR(:,:), HTOTI(:,:), HTOTR(:,:), J2I(:,:), J2R(:,:), JXI(:), JXR(:), JYI(:), JYR(:), &
                              JZI(:), JZR(:), LXI(:), LYI(:), LZI(:), OMGI(:,:), OMGR(:,:)
#ifdef _DMRG_
integer(kind=iwp) :: info, lcwork
real(kind=wp), allocatable :: rwork(:)
complex(kind=wp), allocatable :: ccwork(:), hso_tmp(:,:)
#endif
integer(kind=iwp), external :: cho_x_gettol

! Identify AMFI and ANGMOM matrix elements:
IAMFIX = 0
IAMFIY = 0
IAMFIZ = 0
do IPROP=1,NPROP
  if (PNAME(IPROP)(1:4) == 'AMFI') then
    if (ICOMP(IPROP) == 1) IAMFIX = IPROP
    if (ICOMP(IPROP) == 2) IAMFIY = IPROP
    if (ICOMP(IPROP) == 3) IAMFIZ = IPROP
  else if (PNAME(IPROP)(1:6) == 'ANGMOM') then
    if (ICOMP(IPROP) == 1) IAMX = IPROP
    if (ICOMP(IPROP) == 2) IAMY = IPROP
    if (ICOMP(IPROP) == 3) IAMZ = IPROP
  end if
end do

! Mapping from spin states to spin-free state and to spin:
call mma_allocate(MAPST,NSS,Label='MAPST')
call mma_allocate(MAPSP,NSS,Label='MAPSP')
call mma_allocate(MAPMS,NSS,Label='MAPMS')
ISS = 0
do ISTATE=1,NSTATE
  JOB = JBNUM(ISTATE)
  MPLET = MLTPLT(JOB)
  do MSPROJ=-MPLET+1,MPLET-1,2
    ISS = ISS+1
    MAPST(ISS) = ISTATE
    MAPSP(ISS) = MPLET
    MAPMS(ISS) = MSPROJ
  end do
end do
! Complex hamiltonian matrix elements over spin states:
call mma_allocate(HTOTR,NSS,NSS,Label='HTOTR')
call mma_allocate(HTOTI,NSS,NSS,Label='HTOTI')

if (IPGLOB >= 1) then
  write(u6,*)
  write(u6,*)
  write(u6,*)
  write(u6,'(6X,A)') repeat('*',100)
  write(u6,'(6X,A,98X,A)') '*','*'
  write(u6,'(6X,A,34X,A,34X,A)') '*','       Spin-orbit section     ','*'
  write(u6,'(6X,A,98X,A)') '*','*'
  write(u6,'(6X,A)') repeat('*',100)
  write(u6,*)
end if

#ifdef _DEBUGPRINT_
write(u6,*) 'BLUBB BLUBB debug print of property matrix'
do istate=1,nstate
  do jstate=1,nstate
    do IPROP=1,NPROP
      if (abs(prop(istate,jstate,iprop)) > 1.0e-14_wp) &
        write(u6,*) 'prop(',istate,',',jstate,',',iprop,') = ',prop(istate,jstate,iprop)
    end do
  end do
end do
#endif

do ISS=1,NSS
  ISTATE = MAPST(ISS)
  MPLET1 = MAPSP(ISS)
  MSPROJ1 = MAPMS(ISS)
  S1 = Half*real(MPLET1-1,kind=wp)
  SM1 = Half*real(MSPROJ1,kind=wp)
  do JSS=1,NSS
    JSTATE = MAPST(JSS)
    MPLET2 = MAPSP(JSS)
    MSPROJ2 = MAPMS(JSS)
    S2 = Half*real(MPLET2-1,kind=wp)
    SM2 = Half*real(MSPROJ2,kind=wp)
    AMFIX = Zero
    if (IAMFIX /= 0) AMFIX = PROP(ISTATE,JSTATE,IAMFIX)
    AMFIY = Zero
    if (IAMFIY /= 0) AMFIY = PROP(ISTATE,JSTATE,IAMFIY)
    AMFIZ = Zero
    if (IAMFIZ /= 0) AMFIZ = PROP(ISTATE,JSTATE,IAMFIZ)
    ! PAM07 HSCAL = Zero
    ! PAM07 if (ISS == JSS) HSCAL = ENERGY(ISTATE)
    ! WIGNER-ECKART THEOREM:
    FACT = One/sqrt(real(MPLET1,kind=wp))
    if (MPLET1 == MPLET2-2) FACT = -FACT
    CGM = FACT*DCLEBS(S2,One,S1,SM2,-One,SM1)
    CG0 = FACT*DCLEBS(S2,One,S1,SM2,Zero,SM1)
    CGP = FACT*DCLEBS(S2,One,S1,SM2,One,SM1)
    CGX = sqrt(Half)*(CGM-CGP)
    CGY = -sqrt(Half)*(CGM+CGP)
    ! SPIN-ORBIT HAMILTONIAN MATRIX ELEMENTS:
    !  according to expressions between eqs. (5) and (6)
    !  in Malmqvist et all CPL 357 (2002) 230-240, but real and
    !  imaginary parts are swapped here!!! more precisely the Hamiltonian
    !  is multiplied by imaginary unit to keep its hermicity
    HSOR = CGY*AMFIY
    HSOI = CGX*AMFIX+CG0*AMFIZ
    ! PAM07: Delay addition of diagonal scalar part until later, see below:
    HTOTR(ISS,JSS) = HSOR
    HTOTI(ISS,JSS) = HSOI

  end do
end do

! VKochetov 2021 put SOC matrix elements to hdf5:
#ifdef _HDF5_
if (rhodyn) then
  call mh5_put_dset(wfn_sos_vsor,HTOTR)
  call mh5_put_dset(wfn_sos_vsoi,HTOTI)
end if
#endif

! Perhaps write out large spin-orbit coupling elements:
if (NSOTHR_PRT > 0) then
  ! Prevent infinite loop below:
  SOTHR_MIN = max(SOTHR_PRT,1.0e-6_wp)
  ! And work with quantities larger than 1:
  X_THR = SOTHR_PRT/SOTHR_MIN
  do
    N = count(sqrt(HTOTR(:,:)**2+HTOTI(:,:)**2)*auTocm > SOTHR_PRT)
    if (N <= NSOTHR_PRT) exit
    X_THR = X_THR*1.2_wp
    MAGN = int(log10(X_THR))
    X = X_THR/real(10**MAGN,kind=wp)
    X_THR = 0.1_wp*real(nint(Ten*X),kind=wp)*real(10**MAGN,kind=wp)
    SOTHR_PRT = X_THR*SOTHR_MIN
  end do

  if (N > 0) then
    write(u6,*)
    write(u6,*) 'Complex SO-Hamiltonian matrix elements over'
    write(u6,*) 'spin components of spin-free eigenstates (SFS):'
    write(u6,'(1x,A,F10.3,A)') '(In cm-1. Print threshold: ',SOTHR_PRT,' cm-1)'
    write(u6,'(1X,A)') repeat('-',70)
    write(u6,*)
    write(u6,'(A)') '  I1  S1  MS1    I2  S2  MS2    Real part    Imag part      Absolute'
    do ISS=1,NSS
      ISTATE = MAPST(ISS)
      MPLET1 = MAPSP(ISS)
      MSPROJ1 = MAPMS(ISS)
      S1 = Half*real(MPLET1-1,kind=wp)
      SM1 = Half*real(MSPROJ1,kind=wp)
      do JSS=1,ISS
        HSOR = HTOTR(ISS,JSS)
        HSOI = HTOTI(ISS,JSS)
        HSOTOT = sqrt(HSOR**2+HSOI**2)
        if (HSOTOT*auTocm >= SOTHR_PRT) then
          JSTATE = MAPST(JSS)
          MPLET2 = MAPSP(JSS)
          MSPROJ2 = MAPMS(JSS)
          S2 = Half*real(MPLET2-1,kind=wp)
          SM2 = Half*real(MSPROJ2,kind=wp)
          write(u6,'(1X,I5,F5.1,F5.1,I5,F5.1,F5.1,3F14.3)') ISS,S1,SM1,JSS,S2,SM2,HSOR*auTocm,HSOI*auTocm,HSOTOT*auTocm
        end if
      end do
    end do
    write(u6,'(1X,A)') repeat('-',70)

  end if
end if

! PAM07: Addition of scalar diagonal part was delayed until here, see above.
do ISS=1,NSS
  ISTATE = MAPST(ISS)
  HTOTR(ISS,ISS) = HTOTR(ISS,ISS)+ENERGY(ISTATE)
end do

if (IPGLOB >= 3) then
  write(u6,*)
  write(u6,*)
  write(u6,*) 'Complex Hamiltonian matrix including SO-coupling'
  write(u6,*) 'over spin components of spin-free eigenstates (SFS):'
  write(u6,'(1X,A)') repeat('-',77)
  call PRCHAM(NSS,HTOTR,HTOTI)
  write(u6,'(1X,A)') repeat('-',77)
end if
! save the Hamiltonian
call mma_allocate(HAMSOR,NSS,NSS,'HAMSOR')
HAMSOR(:,:) = HTOTR(:,:)
call put_darray('HAMSOR_SINGLE',HTOTR,NSS**2)
call put_darray('HAMSOI_SINGLE',HTOTI,NSS**2)
#ifdef _HDF5_
! unshift the diagonal
do ISS=1,NSS
  HAMSOR(ISS,ISS) = HAMSOR(ISS,ISS)+EMIN
end do
call mh5_put_dset(wfn_sos_hsor,HAMSOR)
call mh5_put_dset(wfn_sos_hsoi,HTOTI)
#endif
call mma_deallocate(HAMSOR)

!> use complex matrix diagonalization
#ifdef _DMRG_
if (doDMRG) then
  call mma_allocate(hso_tmp,nss,nss)
  call mma_allocate(ccwork,(2*nss-1))
  call mma_allocate(rwork,(3*nss-2))
  hso_tmp = 0; ccwork = 0; rwork = 0

  hso_tmp(:,:) = cmplx(HTOTR(:,:),HTOTI(:,:),kind=wp)
  !do jss=1,nss
  !  do iss=1,nss
  !    write(u6,*) ' hso_tmp(',iss,',',jss,') = ',hso_tmp(iss,jss)
  !  end do
  !end do

  lcwork = (2*nss-1); info = 0
  call zheev_('V','U',nss,hso_tmp,nss,ensor,ccwork,lcwork,rwork,info)

  if (info /= 0) then
    write(u6,*) '* WARNING in rassi/soeig *'
    write(u6,*) 'zheev did return with an error message,info=',info
  else
    write(u6,*) 'zheev in rassi/soeig succeeded!'
  end if

  !write(u6,*) 'eigenvalues of zheev, info=',info
  !do iss=1,nss
  !  write(u6,*) 'ensor(',iss,') =',ensor(iss)
  !end do

  !> save eigenvectors
  usor(:,:) = real(hso_tmp(:,:))
  usoi(:,:) = aimag(hso_tmp(:,:))

  !> sort eigenvalues in increasing sequence (using the same algorithm as zjac)
  call zorder(nss,nss,usor,usoi,ensor,0)

  call MMA_DEALLOCATE(hso_tmp)
  call MMA_DEALLOCATE(ccwork)
  call MMA_DEALLOCATE(rwork)
else
#endif
  !> diagonalize H_SO and get array of eigenvalues/eigenvectors
  call ZJAC(NSS,HTOTR,HTOTI,NSS,USOR,USOI)
  do ISS=1,NSS
    ENSOR(ISS) = HTOTR(ISS,ISS)
  end do
#ifdef _DMRG_
end if
#endif

!write(u6,*) 'eigenvectors of zheev/zjac (real)'
!do iss=1,nss
!  do jss=1,nss
!    write(u6,*) 'usor(',iss,',',jss,') =',usor(iss,jss)
!  end do
!end do
!write(u6,*) 'eigenvectors of zheev/zjac (imag)'
!do iss=1,nss
!  do jss=1,nss
!    write(u6,*) 'usoi(',iss,',',jss,') =',usoi(iss,jss)
!  end do
!end do

#ifdef _HDF5_
call mh5_put_dset(wfn_sos_energy,ENSOR(:)+EMIN)
call mh5_put_dset(wfn_sos_coefr,USOR)
call mh5_put_dset(wfn_sos_coefi,USOI)
#endif
!> free memory for H_SO - do not use it below!
!> eigenvalues are stored in ENSOR!
call mma_deallocate(HTOTR)
call mma_deallocate(HTOTI)

! BOR in Krapperup 070227
! Compute J-values and Omega here instead of in subroutine PRPROP

IAMFIX = 0
IAMFIY = 0
IAMFIZ = 0
IAMX = 0
IAMY = 0
IAMZ = 0
do IPROP=1,NPROP
  if (PNAME(IPROP)(1:4) == 'AMFI') then
    if (ICOMP(IPROP) == 1) IAMFIX = IPROP
    if (ICOMP(IPROP) == 2) IAMFIY = IPROP
    if (ICOMP(IPROP) == 3) IAMFIZ = IPROP
  else if (PNAME(IPROP)(1:6) == 'ANGMOM') then
    if (ICOMP(IPROP) == 1) IAMX = IPROP
    if (ICOMP(IPROP) == 2) IAMY = IPROP
    if (ICOMP(IPROP) == 3) IAMZ = IPROP
  end if
end do

! The following matrix elements  require angular moment integrals:
!if ((IAMX /= 0) .and. (IAMY /= 0) .and. (IAMZ /= 0)) then
! Complex matrix elements of Jx, Jy, and/or Jz over spin states:
call mma_allocate(LXI,NSS**2,Label='LXI')
LXI(:) = Zero
call mma_allocate(LYI,NSS**2,Label='LYI')
LYI(:) = Zero
call mma_allocate(LZI,NSS**2,Label='LZI')
LZI(:) = Zero

if (IAMX > 0) call SMMAT(PROP,LXI,NSS,IAMX,0)
if (IAMY > 0) call SMMAT(PROP,LYI,NSS,IAMY,0)
if (IAMZ > 0) call SMMAT(PROP,LZI,NSS,IAMZ,0)

call mma_allocate(JXR,NSS**2,Label='JXR')
call mma_allocate(JXI,NSS**2,Label='JIR')
JXR(:) = Zero
JXI(:) = Zero
call mma_allocate(JYR,NSS**2,Label='JYR')
call mma_allocate(JYI,NSS**2,Label='JYR')
JYR(:) = Zero
JYI(:) = Zero
call mma_allocate(JZR,NSS**2,Label='JZR')
call mma_allocate(JZI,NSS**2,Label='JZR')
JZR(:) = Zero
JZI(:) = Zero

call SMMAT(PROP,JXR,NSS,0,1)
call SMMAT(PROP,JYI,NSS,0,2)
call SMMAT(PROP,JZR,NSS,0,3)

JXI(:) = JXI(:)+LXI(:)
JYI(:) = JYI(:)+LYI(:)
JZI(:) = JZI(:)+LZI(:)

call mma_deallocate(LXI)
call mma_deallocate(LYI)
call mma_deallocate(LZI)

call mma_allocate(OMGR,NSS,NSS,Label='OMGR')
call mma_allocate(OMGI,NSS,NSS,Label='OMGI')

call DGEMM_('N','N',NSS,NSS,NSS,One,JZR,NSS,JZR,NSS,Zero,OMGR,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,-One,JZI,NSS,JZI,NSS,One,OMGR,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,One,JZR,NSS,JZI,NSS,Zero,OMGI,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,One,JZI,NSS,JZR,NSS,One,OMGI,NSS)

call mma_deallocate(JZR)
call mma_deallocate(JZI)

call mma_allocate(J2R,NSS,NSS,Label='J2R')
call mma_allocate(J2I,NSS,NSS,Label='J2I')

call DGEMM_('N','N',NSS,NSS,NSS,One,JXR,NSS,JXR,NSS,Zero,J2R,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,-One,JXI,NSS,JXI,NSS,One,J2R,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,One,JYR,NSS,JYR,NSS,One,J2R,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,-One,JYI,NSS,JYI,NSS,One,J2R,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,One,JXR,NSS,JXI,NSS,Zero,J2I,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,One,JXI,NSS,JXR,NSS,One,J2I,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,One,JYR,NSS,JYI,NSS,One,J2I,NSS)
call DGEMM_('N','N',NSS,NSS,NSS,One,JYI,NSS,JYR,NSS,One,J2I,NSS)

call mma_deallocate(JXR)
call mma_deallocate(JXI)
call mma_deallocate(JYR)
call mma_deallocate(JYI)
call ZTRNSF(NSS,USOR,USOI,OMGR,OMGI)
call ZTRNSF(NSS,USOR,USOI,J2R,J2I)

! Jump here to skip computing omega and/or J:
!end if

if (IPGLOB >= 1) then
  write(u6,*)
  write(u6,'(6X,A)') ' Total energies including SO-coupling:'
  do ISS=1,NSS
    E_tmp = ENSOR(ISS)+EMIN
    call PrintResult(u6,'(6x,A,I5,5X,A,F23.14)','SO-RASSI State',ISS,'Total energy:',[E_tmp],1)
  end do
end if

! Find E0=lowest energy, to use for printing table:
if (IPGLOB >= 1) then
  E0 = minval(ENSOR(:))
  write(u6,*)
  write(u6,*)
  write(u6,*) '  Eigenvalues of complex Hamiltonian:'
  write(u6,*) '  -----------------------------------'
  if (EMIN /= Zero) write(u6,'(1X,A,F22.10,A1)') ' (Shifted by EMIN (a.u.) =',EMIN,')'
  write(u6,*)
  if ((ifj2 /= 0) .and. (ifjz /= 0)) then
    write(u6,*) 'SO State       Relative EMIN(au)   Rel lowest level(eV)    D:o, cm**(-1)     J-value  Omega'
  else if ((ifj2 /= 0) .and. (ifjz == 0)) then
    write(u6,*) 'SO State       Relative EMIN(au)   Rel lowest level(eV)    D:o, cm**(-1)     J-value'
  else if ((ifj2 == 0) .and. (ifjz /= 0)) then
    write(u6,*) 'SO State       Relative EMIN(au)   Rel lowest level(eV)    D:o, cm**(-1)      Omega'
  else if ((ifj2 == 0) .and. (ifjz == 0)) then
    write(u6,*) 'SO State       Relative EMIN(au)   Rel lowest level(eV)    D:o, cm**(-1)'
  end if
  write(u6,*)
  E0 = minval(ENSOR(:))
  call MMA_ALLOCATE(ESO,NSS)
  do ISS=1,NSS
    E1 = ENSOR(ISS)
    E2 = auToeV*(E1-E0)
    E3 = auTocm*(E1-E0)
    if (IFJ2 > 0) XJEFF = sqrt(Quart+J2R(ISS,ISS))-Half
    if (IFJZ > 0) OMEGA = sqrt(1.0e-12_wp+OMGR(ISS,ISS))

    ! Added by Ungur Liviu on 04.11.2009
    ! Saving the SO energies in ESO array.
    ESO(ISS) = E3
    if ((ifj2 /= 0) .and. (ifjz /= 0)) then
      write(u6,'(1X,I5,7X,2(F18.10,2X),F18.4,4X,2(2X,F6.1))') ISS,E1,E2,E3,XJEFF,OMEGA
    else if ((ifj2 /= 0) .and. (ifjz == 0)) then
      write(u6,'(1X,I5,7X,2(F18.10,2X),F18.4,6X,F6.1)') ISS,E1,E2,E3,XJEFF
    else if ((ifj2 == 0) .and. (ifjz /= 0)) then
      write(u6,'(1X,I5,7X,2(F18.10,2X),F18.4,6X,F6.1)') ISS,E1,E2,E3,OMEGA
    else if ((ifj2 == 0) .and. (ifjz == 0)) then
      write(u6,'(1X,I5,7X,2(F18.10,2X),F18.4)') ISS,E1,E2,E3
    end if
  end do

  ! Added by Ungur Liviu on 04.11.2009
  ! Saving the ESO array in the RunFile.
  call Put_iscalar('NSS_SINGLE',NSS)
  call Put_dArray('ESO_SINGLE',ESO,NSS)
  call Put_dArray('ESO_LOW',ENSOR(:)+EMIN,NSS)
  call MMA_DEALLOCATE(ESO)
end if

call mma_deallocate(OMGR)
call mma_deallocate(OMGI)
call mma_deallocate(J2R)
call mma_deallocate(J2I)

! Put energy onto info file for automatic verification runs:
EPSS = 5.0e-11_wp
EPSH = max(5.0e-10_wp,abs(ENSOR(1)+EMIN)*EPSS)
IDX = 100
do ISS=1,NSS
  EI = (ENSOR(ISS)+EMIN)*EPSS
  ERMS = sqrt(EPSH**2+EI**2)*sum(USOR(:,ISS)**2+USOI(:,ISS)**2)
  IDX = min(IDX,int(-log10(ERMS)))
end do
iTol = cho_x_gettol(IDX) ! reset thr iff Cholesky
call Add_Info('ESO_LOW',ENSOR+EMIN,NSS,iTol)

if (IPGLOB >= 3) then
  write(u6,*)
  write(u6,*) ' Complex eigenvectors in basis of non-so eigenstates:'
  write(u6,*) '-----------------------------------------------------'
  write(u6,*)
  if (IPGLOB >= 4) then
    FRAC = Zero
  else
    FRAC = Quart
    write(u6,*) '    (A selection of the largest components)'
  end if
end if
call PRCEVC(NSS,FRAC,ENSOR,MAPST,MAPSP,MAPMS,USOR,USOI)

! Update LoopDivide (SUBSets keyword)
! Assume the SO "ground states" are mostly formed by the SF "ground states"
if (ReduceLoop) then
  call mma_Allocate(IndexE,nState,Label='IndexE')
  IndexE(:) = ArgSort(Energy,leq_r)
  n = 0
  do iState=1,LoopDivide
    Job = JbNum(IndexE(iState))
    n = n+Mltplt(Job)
  end do
  LoopDivide = n
# ifdef _HDF5_
  if (IFTRD1 .or. IFTDM) call UpdateIdx(IndexE,nSS,USOR,USOI,MapSt)
# endif
  call mma_deAllocate(IndexE)
end if

call mma_deallocate(MAPST)
call mma_deallocate(MAPSP)
call mma_deallocate(MAPMS)

end subroutine SOEIG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE SORTB_CPF(BUFOUT,INDOUT,ICAD,IBUFL,TIBUF,ACBDS,ACBDT,
     *ISAB,BUFACBD)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION BUFOUT(*),INDOUT(*)
      DIMENSION ICAD(*),IBUFL(*),TIBUF(NTIBUF),ACBDS(*),ACBDT(*)
      DIMENSION ISAB(*),BUFACBD(*)
      DIMENSION NORB0(9)
      PARAMETER (IPOW8=2**8)
C SORTS INTEGRALS (AB/CD) FOR FIXED A,C ALL B,D
*
      KBUFF1=2*9600
      NVT=IROW(NVIRT+1)
      NOV=(NVT-1)/IPASS+1
      NOVST=LN*NVIRT+1
      IAD16=0
      JBUF0=RTOI*JBUF
      JBUF1=JBUF0+JBUF+1
      JBUF2=JBUF1+1
      IDIV=RTOI
      NORB0(1)=0
      DO 4 I=1,NSYM
      NORB0(I+1)=NORB0(I)+NORB(I)
4     CONTINUE
      INSOUT=0
      IACMAX=0
      DO 50 ISTEP=1,IPASS
      IAD50=0
      CALL iDAFILE(Lu_TraInt,2,iTraToc,nTraToc,IAD50)
      IDISK=0
      IACMIN=IACMAX+1
      IACMAX=IACMAX+NOV
      IF(IACMAX.GT.NVT)IACMAX=NVT
      IF(IACMIN.GT.IACMAX)GO TO 50
      ID=0
      DO 5 IREC=1,NOV
      IBUFL(IREC)=0
      ICAD(IREC)=ID
      INDOUT(ID+JBUF2)=-1
      ID=ID+JBUF2
5     CONTINUE
C
C     TWO-ELECTRON INTEGRALS
C
      DO 313 NSP=1,NSYM
      NOP=NORB(NSP)
      DO 312 NSQ=1,NSP
      NSPQ=MUL(NSP,NSQ)
      NOQ=NORB(NSQ)
      DO 311 NSR=1,NSP
      NSPQR=MUL(NSPQ,NSR)
      NOR=NORB(NSR)
      NSSM=NSR
      IF(NSR.EQ.NSP)NSSM=NSQ
      DO 310 NSS=1,NSSM
      IF(NSS.NE.NSPQR)GO TO 310
      NOS=NORB(NSS)
      NORBP=NOP*NOQ*NOR*NOS
      IF(NORBP.EQ.0)GO TO 310
      CALL dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
      IOUT=0
      DO 309 NV=1,NOR
      NXM=NOS
      IF(NSR.EQ.NSS)NXM=NV
      DO 308 NX=1,NXM
      NTM=1
      IF(NSP.EQ.NSR)NTM=NV
      DO 307 NT=NTM,NOP
      NUMIN=1
      IF(NSP.EQ.NSR.AND.NT.EQ.NV)NUMIN=NX
      NUMAX=NOQ
      IF(NSP.EQ.NSQ)NUMAX=NT
      DO 306 NU=NUMIN,NUMAX
      IOUT=IOUT+1
      IF(IOUT.GT.NTIBUF) THEN
         CALL dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
         IOUT=1
      END IF
      M1=ICH(NORB0(NSP)+NT)
      M2=ICH(NORB0(NSQ)+NU)
      M3=ICH(NORB0(NSR)+NV)
      M4=ICH(NORB0(NSS)+NX)
      IF(M1.LE.LN.OR.M2.LE.LN)GO TO 306
      IF(M3.LE.LN.OR.M4.LE.LN)GO TO 306
C     ORDER THESE INDICES CANONICALLY
      N1=M1
      N2=M2
      IF(M1.GT.M2)GO TO 11
      N1=M2
      N2=M1
11    N3=M3
      N4=M4
      IF(M3.GT.M4)GO TO 12
      N3=M4
      N4=M3
12    NI=N1
      NJ=N2
      NK=N3
      NL=N4
      IF(NI.GT.NK)GO TO 502
      IF(NI.EQ.NK)GO TO 14
      NI=N3
      NJ=N4
      NK=N1
      NL=N2
      GO TO 502
14    IF(NJ.GT.NL)GO TO 502
      NL=N2
      NJ=N4
502   FINI=TIBUF(IOUT)
      IF(ABS(FINI).LT.1.D-09)GO TO 306
      NA=NI-LN
      NB=NJ-LN
      NC=NK-LN
      ND=NL-LN
      ITURN=0
      IF(NA.EQ.NB.AND.NC.EQ.ND)GO TO 306
107   IAC=IROW(NA)+NC
      IF(IAC.LT.IACMIN)GO TO 106
      IF(IAC.GT.IACMAX)GO TO 106
      IF(NA.EQ.NC.AND.NB.EQ.ND)FINI=FINI/D2
      NAC=IAC-IACMIN+1
      IBUFL(NAC)=IBUFL(NAC)+1
      ICQ=ICAD(NAC)
      ICP=ICQ/IDIV+IBUFL(NAC)
      BUFOUT(ICP)=FINI
      ICPP=ICQ+JBUF0+IBUFL(NAC)
CPAM97      INDOUT(ICPP)=IOR(NB,ISHFT(ND,8))
      INDOUT(ICPP)=NB+ND*IPOW8
      IF(IBUFL(NAC).LT.JBUF)GO TO 106
      INDOUT(ICQ+JBUF1)=JBUF
      JDISK=IDISK
      CALL iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),JBUF2,IDISK)
      INDOUT(ICQ+JBUF2)=JDISK
      IBUFL(NAC)=0
106   IF(ITURN.EQ.1)GO TO 306
      IF(NA.EQ.NC.AND.NB.EQ.ND)GO TO 306
      IF(NA.EQ.NB.OR.NC.EQ.ND)GO TO 306
      ITURN=1
      NC=NL-LN
      ND=NK-LN
      GO TO 107
306   CONTINUE
307   CONTINUE
308   CONTINUE
309   CONTINUE
310   CONTINUE
311   CONTINUE
312   CONTINUE
313   CONTINUE
C     EMPTY LAST BUFFERS
      NOVM=IACMAX-IACMIN+1
      If ( (NOVST+IACMIN-1+NOVM).gt.mAdr ) then
        WRITE(6,*)'SORTB_CPF Error: NOVST+IACMIN-1+NOVM > MADR'
        WRITE(6,*)'  (See code).'
        CALL Abend
      End If
      DO 150 I=1,NOVM
      ICQ=ICAD(I)
      INDOUT(ICQ+JBUF1)=IBUFL(I)
      JDISK=IDISK
      CALL iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),JBUF2,IDISK)
      LASTAD(NOVST+IACMIN-1+I)=JDISK
150   CONTINUE
      DO 40 ISYM=1,NSYM
      IST1=IRC(3)+JJS(ISYM+9)+1
      IFIN1=IRC(3)+JJS(ISYM+10)
      INPS=IFIN1-IST1+1
      IST2=IRC(2)+JJS(ISYM)+1
      IFIN2=IRC(2)+JJS(ISYM+1)
      INPT=IFIN2-IST2+1
      ITAIL=INPS+INPT
      IF(ITAIL.EQ.0)GO TO 40
      IN1=-NVIRT
      DO 55 NA=1,NVIRT
      IN1=IN1+NVIRT
      DO 60 NC=1,NA
      IAC=IROW(NA)+NC
      IF(IAC.LT.IACMIN)GO TO 60
      IF(IAC.GT.IACMAX)GO TO 60
      IF(NA.EQ.1)GO TO 60
      NSAC=MUL(NSM(LN+NA),NSM(LN+NC))
      NSACL=MUL(NSAC,LSYM)
      IF(NSACL.NE.ISYM)GO TO 60
      NDMAX=NSYS(NSM(LN+NC)+1)
      IF(NDMAX.GT.NA)NDMAX=NA
      INS=ISAB(IN1+NDMAX)
      DO 65 I=1,INS
      ACBDS(I)=D0
      ACBDT(I)=D0
65    CONTINUE
      IADR=LASTAD(NOVST+IAC)
201   CALL iDAFILE(Lu_TiABIJ,2,INDOUT,JBUF2,IADR)
      LENGTH=INDOUT(JBUF1)
      IADR=INDOUT(JBUF2)
      IF(LENGTH.EQ.0)GO TO 209
      DO 202 KK=1,LENGTH
      INND=INDOUT(JBUF0+KK)
*      NB=MOD(INND,IPOW8)
*      ND=MOD(INND/IPOW8,IPOW8)
      NB=IBITS(INND,0,8)
      ND=IBITS(INND,8,8)
      NBD=(NB-1)*NVIRT+ND
      IBDS=ISAB(NBD)
      ACBDS(IBDS)=ACBDS(IBDS)+BUFOUT(KK)
      IF(NB.GT.ND)ACBDT(IBDS)=ACBDT(IBDS)+BUFOUT(KK)
      IF(NB.LT.ND)ACBDT(IBDS)=ACBDT(IBDS)-BUFOUT(KK)
202   CONTINUE
209   IF(IADR.NE.-1) GO TO 201
      ILOOP=0
72    DO 75 I=1,INS
      INSOUT=INSOUT+1
      IF(ILOOP.EQ.0)BUFACBD(INSOUT)=ACBDS(I)
      IF(ILOOP.EQ.1)BUFACBD(INSOUT)=ACBDT(I)
      IF(INSOUT.LT.KBUFF1)GO TO 75
      CALL dDAFILE(Lu_TiABCD,1,BUFACBD,KBUFF1,IAD16)
      INSOUT=0
75    CONTINUE
      ILOOP=ILOOP+1
      IF(ILOOP.EQ.1)GO TO 72
60    CONTINUE
55    CONTINUE
40    CONTINUE
50    CONTINUE
C     EMPTY LAST BUFFER
      IF(INSOUT.EQ.0) THEN
         RETURN
      END IF
      CALL dDAFILE(Lu_TiABCD,1,BUFACBD,KBUFF1,IAD16)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it ana/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               1995,1996, Martin Schuetz                              *
!               2003, Valera Veryazov                                  *
!               2016,2017,2022, Roland Lindh                           *
!               2024, Daniel Wessling                                  *
!               2024, Ignacio Fdez. Galvan                             *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine WfCtl_SCF(iTerm,Meth,FstItr,SIntTh)
!***********************************************************************
!                                                                      *
!     purpose: Optimize SCF wavefunction.                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
!     University of Lund, Sweden, 1992                                 *
!     QNR/DIIS, M. Schuetz, 1995                                       *
!     NDDO start orbitals, M. Schuetz, 1996                            *
!     University of Lund, Sweden, 1992,95,96                           *
!     UHF, V.Veryazov, 2003                                            *
!     Cleanup, R. Lindh, 2016                                          *
!                                                                      *
!***********************************************************************

#ifdef _MSYM_
use, intrinsic :: iso_c_binding, only: c_ptr
use InfSCF, only: nBO
#endif
use Interfaces_SCF, only: OptClc_X, TraClc_i
use LnkLst, only: GetVec, LLDelt, LLGrad, LLx, LstPtr, PutVec, SCF_V
use InfSCF, only: AccCon, Aufb, CMO, CMO_Ref, CPUItr, Damping, DIIS, DIISTh, DltNrm, DltnTh, DMOMax, DoCholesky, DSCF, DThr, E1V, &
                  E2V, EDiff, Energy, EneV, EOrb, EThr, Expand, FckAuf, FMOMax, FThr, idKeep, iDMin, Iter, Iter_Ref, Iter_Start, &
                  iterGEK, iterSO, iterSO_Max, jPrint, kOptim, kOptim_Max, kOV, KSDFT, Loosen, MaxFlip, MiniDn, mOV, MSYMON, &
                  MxIter, MxOptm, nAufb, nBas, nBB, nBB, nBT, nD, Neg2_Action, nIter, nIterP, nnB, nnB, nOcc, nOrb, nSym, OccNo, &
                  One_Grid, Ovrlp, QNRTh, RGEK, RSRFO, rTemp, S2Uhf, Teee, TemFac, TimFld, TrDD, TrDh, TrDP, TrM, TStop, &
                  Two_Thresholds, WarnCfg, WarnPocc
use Cholesky, only: ChFracMem
use SCFFiles, only: LuOut
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Ten, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iTerm
character(len=*), intent(in) :: Meth
logical(kind=iwp), intent(inout) :: FstItr
real(kind=wp), intent(inout) :: SIntTh
integer(kind=iwp) :: i, iAufOK, iBas, iCMO, iDummy(7,8), Ind(MxOptm), iNode, iOffOcc, iOpt, iOpt_DIIS, iRC, iSym, iter_, &
                     Iter_DIIS, Iter_DIIS_min, Iter_no_DIIS, iTrM, itSave, jpxn, lth, MinDMx, nBs, nCI, nOr, nTr
real(kind=wp) :: ang, DD, DiisTH_Save, dqdq, dqHdq, Dummy(1), EnVOld, EThr_new, GradNorm, LastStatus, LastStep = 0.1_wp, TCP1, &
                 TCP2, TCPU1, TCPU2, TWall1, TWall2
logical(kind=iwp) :: AllowFlip, AufBau_Done, Converged, Diis_Save, FckAuf_save, FrstDs, Loosen_Active, QNR1st, Reset, Reset_GEK, &
                     Reset_NQ, Reset_Thresh, SORange
character(len=128) :: OrbName
character(len=72) :: Note
character(len=32) :: IterText
character(len=10) :: Meth_
character(len=9) :: StrSave
#ifdef _MSYM_
integer(kind=iwp) :: iD
real(kind=wp) :: Whatever
type(c_ptr) :: msym_ctx
#endif
real(kind=wp), allocatable :: CInter(:,:), D1Sao(:), Disp(:), Grd1(:), Prev(:), Xn(:), Xnp1(:)
real(kind=wp), parameter :: E2VTolerance = -1.0e-8_wp, StepMax = Ten
real(kind=wp), external :: DDot_, Seconds

#include "warnings.h"

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
!
! Allocate memory for some arrays

nTr = MxIter
call mma_allocate(TrDh,nTR,nTR,nD,Label='TrDh')
call mma_allocate(TrDP,nTR,nTR,nD,Label='TrDP')
call mma_allocate(TrDD,nTR,nTR,nD,Label='TrDD')
nCI = MxOptm+1
call mma_allocate(CInter,nCI,nD,Label='CInter')

!----------------------------------------------------------------------*

call CWTime(TCpu1,TWall1)
! Put empty spin density on the runfile.
call mma_allocate(D1Sao,nBT,Label='D1Sao')
D1Sao(:) = Zero
call Put_dArray('D1sao',D1Sao,nBT)
call mma_deallocate(D1Sao)

if (len_trim(Meth) > len(Meth_)) then
  Meth_ = '[...]'
else
  Meth_ = trim(Meth)
end if
iTerm = 0
iDMin = -1
! Choose between normal and minimized differences
MinDMx = 0
if (MiniDn) MinDMx = max(0,nIter(nIterP)-1)

! Optimization options
!
! iOpt=0: DIIS interpolation on density or/and Fock matrices
! iOpt=1: DIIS extrapolation on gradients w.r.t orbital rot.
! iOpt=2: DIIS extrapolation on the anti-symmetrix X matrix.
! iOpt=3: RS-RFO in the space of the anti-symmetric X matrix.
! iOpt=4: s-GEK/RVO in the space of the anti-symmetric X matrix.

iOpt = 0
QNR1st = .true.
FrstDs = .true.

! START INITIALIZATION

! Initialize Cholesky information if requested

if (DoCholesky) then
  call Cho_X_init(irc,ChFracMem)
  if (irc /= 0) then
    call WarningMessage(2,'WfCtl. Non-zero rc in Cho_X_init.')
    call Abend()
  end if
end if
!                                                                      *
!----------------------------------------------------------------------*
!----------------------------------------------------------------------*
!                                                                      *
IterSO = 0        ! number of second order steps.
IterGEK = 0       ! number of data points in S-GEK
kOptim = 1
Iter_Diis_min = 2
Iter_no_Diis = 2
Converged = .false.
SORange = Damping ! within 2nd-order range for S-GEK
Reset_GEK = .false.
Reset_NQ = .false.
IterText = 'Iterations'
!                                                                      *
!----------------------------------------------------------------------*
!----------------------------------------------------------------------*
!                                                                      *
! END INITIALIZATION
!                                                                      *
!----------------------------------------------------------------------*
!----------------------------------------------------------------------*
!                                                                      *
DiisTh = max(DiisTh,QNRTh)

! If DIIS is turned off make threshold for activation impossible

if (.not. DIIS) then
  DiisTh = Zero
  Iter_no_Diis = 1000000
end if

! If no damping to precede the DIIS make threshold being fulfilled at once.

if (.not. Damping) then
  DiisTh = DiisTh*1.0e99_wp
  Iter_no_Diis = 1
  Iter_Diis_min = 0
end if

! turn temporarily off DIIS & QNR/DIIS, if Aufbau is active...

DiisTh_save = DiisTh
Diis_Save = Diis
if (Aufb) then
  DiisTh = Zero
  Diis = .false.
end if

! Print header to iterations

if ((KSDFT == 'SCF') .or. One_Grid) call PrBeg(Meth_)
AufBau_Done = .false.
!                                                                      *
!======================================================================*
!======================================================================*
!                                                                      *
! If direct SCF modify thresholds temporarily

Reset = .false.
Reset_Thresh = .false.

! pow: temporary disabling of threshold switching

if ((DSCF .or. (KSDFT /= 'SCF')) .and. (nIter(nIterP) > 10)) then

  EThr_New = EThr*Ten**2

  if (DSCF .and. (KSDFT == 'SCF') .and. Two_Thresholds) then
    Reset = .true.
    Reset_Thresh = .true.
    call Reduce_Thresholds(EThr_New,SIntTh)
  end if

  if ((KSDFT /= 'SCF') .and. (.not. One_Grid)) then
    Reset = .true.
    call Modify_NQ_Grid()
    call PrBeg(Meth_)
  end if

end if
!                                                                      *
!======================================================================*
!======================================================================*
!                                                                      *
!                     I  t  e  r  a  t  i  o  n  s                     *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! nIterP=0: NDDO                                                       *
! nIterP=1: SCF                                                        *
!                                                                      *
!======================================================================*
!                                                                      *
! Set some parameters to starting defaults.

AllowFlip = .true.
Loosen_Active = .false.
iAufOK = 0
Iter_DIIS = 0
EDiff = Zero
DMOMax = 1.0e99_wp
FMOMax = Zero
DltNrm = Zero
LastStatus = -One

if (MSYMON) then
# ifdef _MSYM_
  write(u6,*) 'Symmetrizing orbitals during SCF calculation'
  call fmsym_create_context(msym_ctx)
  call fmsym_set_elements(msym_ctx)
  call fmsym_find_symmetry(msym_ctx)
# else
  write(u6,*) 'No msym support, skipping symmetrization of SCF orbitals...'
# endif
end if
!                                                                      *
!======================================================================*
!                                                                      *
! Start of iteration loop
!                                                                      *
!======================================================================*
!                                                                      *
do iter_=1,nIter(nIterP)
  iter = iter_
  WarnCfg = .false.

  if ((.not. Aufb) .and. (iter > MaxFlip)) AllowFlip = .false.

  TCP1 = seconds()
  if (LastStatus < Zero) LastStatus = TCP1

  iDMin = iDMin+1
  if (iDMin > MinDMx) iDMin = MinDMx

# ifdef _MSYM_
  if (MSYMON) then
    do iD=1,nD
      call fmsym_symmetrize_orbitals(msym_ctx,CMO(1,iD))
      call ChkOrt(iD,Whatever)
      call Ortho(CMO(1,iD),nBO,Ovrlp,nBT)
      call ChkOrt(iD,Whatever)
    end do
  end if
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Do Aufbau procedure, if active...

  if (Aufb) call Aufbau(nAufb,OccNo,nnB,iAufOK,nD)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Save the variational energy of the previous step

  EnVold = EneV
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  call SCF_Energy(FstItr,E1V,E2V,EneV)
  Energy(iter) = EneV
  if (iter == 1) then
    EDiff = Zero
  else
    EDiff = EneV-EnVold
  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  !      Select on the fly the current optimization method
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Test if this is a DIIS extrapolation iteration, alternatively
  ! the iteration is a DIIS interpolation iteration. The former
  ! is activated if the DMOMax is lower than the threshold
  ! after a specific number of iteration, or if the condition
  ! has already been achieved.
  !
  ! 2017-02-03: add energy criterion to make sure that the DIIS
  !             gets some decent to work with.

  if ((DMOMax < DiisTh) .and. (Iter > Iter_no_Diis) .and. (EDiff < 0.1_wp)) then

    if (iOpt == 0) kOptim = 2
    iOpt = max(1,iOpt)
    Iter_DIIS = Iter_DIIS+1
  end if

  ! Test if the DIIS scheme will be operating in an orbital
  ! rotation mode or linear combination of density matrices. This
  ! option is available only in the extrapolation mode of DIIS.
  !
  ! 2017-02-03: Make sure that the density based DIIS is in
  !             action for at least 2 iterations such that
  !             when the orbital rotation DIIS is turned on
  !             we are firmly in the NR region.

  if (RGEK .and. (.not. (Damping .or. Aufb))) then
    iOpt = 4
    if ((.not. SORange) .and. (Iter > 1)) then
      call mma_allocate(Grd1,mOV,Label='Grd1')
      call GetVec(iter-1,LLGrad,inode,Grd1,mOV)
      GradNorm = sqrt(ddot_(mov,Grd1,1,Grd1,1))
      call mma_deallocate(Grd1)
      if (GradNorm < QNRTh) Reset_GEK = .true.
    end if
  else if ((iOpt >= 2) .or. ((iOpt == 1) .and. (DMOMax < QNRTh) .and. (Iter_DIIS >= Iter_DIIS_min))) then
    if (RSRFO .or. RGEK) then
      if (RSRFO) then
        iOpt = 3
      else
        iOpt = 4
      end if
    else
      iOpt = 2
    end if

  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  select case (iOpt)

    case (0)
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
      ! Interpolation DIIS
      !
      ! Compute traces: TrDh, TrDP and TrDD.
      !
      !FckAuf_Save = FckAuf
      !FckAuf = .false.
      call TraClc_i(iter,nD)

      ! DIIS interpolation optimization: EDIIS, ADIIS, LDIIS

      iOpt_DIIS = 1 ! EDIIS option

      call DIIS_i(CInter,nCI,TrDh,TrDP,TrDD,MxIter,nD,iOpt_DIIS,Ind)

      ! Compute optimal density, dft potentials, and TwoHam

      call OptClc(CInter,nCI,nD,Ind,MxOptm)

      ! Update Fock Matrix from OneHam and extrapolated TwoHam & Vxc

      call mk_FockAO(nIter(nIterP))
      ! Diagonalize Fock matrix and obtain new orbitals

      call NewOrb_SCF(AllowFlip)

      ! Transform density matrix to MO basis

      call MODens()
      !FckAuf = FckAuf_Save
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
    case (1)
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
      ! Extrapolation DIIS
      !
      ! The section of the code operates on the derivatives of
      ! the energy w.r.t the elements of the anti-symmetric X matrix.
      !
      ! The optimal density matrix is found with the DIIS and
      ! canonical CMOs are generated by the diagonalization of the
      ! Fock matrix.

      FckAuf_Save = FckAuf
      FckAuf = .false.
      if (FrstDs) then
        Iter_Ref = 1
        Iter_Start = 1
        CMO_Ref(:,:) = CMO(:,:)
      end if
      call GrdClc(FrstDs)

      call DIIS_x(nD,CInter,nCI,.false.,Ind)

      ! Compute optimal density, dft potentials, and TwoHam

      call OptClc(CInter,nCI,nD,Ind,MxOptm)

      ! Update Fock Matrix from OneHam and extrapolated TwoHam & Vxc

      call mk_FockAO(nIter(nIterP))
      ! Diagonalize Fock matrix and obtain new orbitals

      call NewOrb_SCF(AllowFlip)

      ! Transform density matrix to MO basis

      call MODens()
      FckAuf = FckAuf_Save
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
    case (2,3,4)
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
      ! Extrapolation DIIS & QNR
      !
      ! or
      !
      ! Quasi-2nd order scheme (rational function optimization)
      ! with restricted.step.
      !
      ! In this section we operate directly on the anti-symmetric X
      ! matrix.
      !
      ! Initially the energy is determined through a line seach,
      ! followed by the Fock matrix etc. In this respect, this
      ! approach is doing in this iteration what was already done
      ! by the two other approaches in the end of the previous
      ! iteration.
      !
      ! Note also, that since we work directly with the X matrix we
      ! also rotate the orbitals with this matrix (note the call to
      ! RotMOs right before the call to SCF_Energy in the line
      ! search routine, linser). Thus, the orbitals here are not
      ! canonical and would require at the termination of the
      ! optimization that these are computed.
      !
      ! Initiate if the first QNR step

      if (QNR1st) then

        ! 1st QNR step, reset kOptim to 1

        kOptim = 1
        CInter(1,1) = One
        CInter(1,nD) = One

        Iter_Start = Iter
        QNR1st = .false.
      end if

      ! Set the reference set of parameters and the corresponding
      ! CMOs to be the current iteration.

      if (Iter == Iter_Start) then
        Iter_Ref = Iter
        CMO_Ref(:,:) = CMO(:,:)
        ! init 1st orb rot parameter X1 (set it to zero)
        call mma_allocate(Xn,mOV,Label='Xn')
        Xn(:) = Zero
        ! and store it on appropriate LList
        call PutVec(Xn,mOV,iter,'OVWR',LLx)
        call mma_deallocate(Xn)
      end if

      ! Compute the current gradient
      call SCF_Gradient()

      ! Set the reference set of parameters and the corresponding
      ! CMOs to be the current iteration.
      call Move_Ref(Iter)

      ! Update the Fock Matrix from actual OneHam, Vxc & TwoHam AO basis

      call mk_FockAO(nIter(nIterP))

      ! and transform the Fock matrix into the new MO space,

      call TraFck(.false.,FMOMax)

      ! compute initial diagonal Hessian, Hdiag

      call SOIniH()
      AccCon(8:8) = 'H'

      ! update the QNR iteration counter
      IterSO = min(IterSO+1,IterSO_Max)

      ! Allocate memory for the current gradient and displacement vector.

      call mma_allocate(Grd1,mOV,Label='Grd1')
      call mma_allocate(Disp,mOV,Label='Disp')
      call mma_allocate(Xnp1,mOV,Label='Xnp1')

      select case (iOpt)

        case (2) ! qNRC2DIIS
          !                                                            *
          !*************************************************************
          !*************************************************************
          !                                                            *
          ! Compute extrapolated g_x(n) and X_x(n)

          do
            call DIIS_x(nD,CInter,nCI,.true.,Ind)

            call OptClc_X(CInter,nCI,nD,Grd1,mOV,Ind,MxOptm,kOptim,kOV,LLGrad)
            call OptClc_X(CInter,nCI,nD,Xnp1,mOV,Ind,MxOptm,kOptim,kOV,LLx)

            ! compute new displacement vector delta
            ! dX_x(n) = -H(-1)*g_x(n) ! Temporary storage in Disp

            call SOrUpV(Grd1,mOV,Disp,'DISP','BFGS')

            DD = sqrt(DDot_(mOV,Disp,1,Disp,1))

            if (DD > Pi) then
#             ifdef _DEBUGPRINT_
              write(u6,*) 'WfCtl_SCF: Additional displacement is too large.'
              write(u6,*) 'DD=',DD
#             endif
              if (kOptim /= 1) then
#               ifdef _DEBUGPRINT_
                write(u6,*) 'Reset update depth in BFGS, redo the DIIS'
#               endif
                kOptim = 1
                Iter_Start = Iter
                IterSO = 1
                cycle
              else
#               ifdef _DEBUGPRINT_
                write(u6,*) 'Scale the step to be within the threshold.'
                write(u6,*) 'LastStep=',LastStep
#               endif
                Disp(:) = Disp(:)*(LastStep/DD)
              end if
            end if

            ! from this, compute new orb rot parameter X(n+1)
            !
            ! X(n+1) = X_x(n) - H(-1)g_x(n)
            ! X(n+1) = X_x(n) + dX_x(n)

            Xnp1(:) = Xnp1(:)-Disp(:)

            ! get address of actual X(n) in corresponding LList

            jpXn = LstPtr(iter,LLx)

            ! and compute actual displacement dX(n)=X(n+1)-X(n)

            Disp(:) = Xnp1(:)-SCF_V(jpXn)%A(:)

            DD = sqrt(DDot_(mOV,Disp,1,Disp,1))

            if (DD <= Pi) exit
#           ifdef _DEBUGPRINT_
            write(u6,*) 'WfCtl_SCF: Total displacement is too large.'
            write(u6,*) 'DD=',DD
#           endif
            if (kOptim /= 1) then
#             ifdef _DEBUGPRINT_
              write(u6,*) 'Reset update depth in BFGS, redo the DIIS'
#             endif
              kOptim = 1
              Iter_Start = Iter
              IterSO = 1
            else
#             ifdef _DEBUGPRINT_
              write(u6,*) 'Scale the step to be within the threshold.'
#             endif
              Disp(:) = Disp(:)*(LastStep/DD)
              DD = sqrt(DDot_(mOV,Disp,1,Disp,1))
              exit
            end if
          end do
          LastStep = min(DD,1.0e-2_wp)
          !                                                            *
          !*************************************************************
          !*************************************************************
          !                                                            *
        case (3) ! RS-RFO
          !                                                            *
          !*************************************************************
          !*************************************************************
          !                                                            *
          ! Get g(n)

          call GetVec(iter,LLGrad,inode,Grd1,mOV)
          !                                                            *
          !*************************************************************
          !                                                            *
          dqHdq = Zero
          do
            call rs_rfo_scf(Grd1,mOV,Disp,AccCon(1:6),dqdq,dqHdq,StepMax,AccCon(9:9),3)
            DD = sqrt(DDot_(mOV,Disp,1,Disp,1))
            if (DD <= Pi) exit
#           ifdef _DEBUGPRINT_
            write(u6,*) 'WfCtl_SCF: Total displacement is too large.'
            write(u6,*) 'DD=',DD
#           endif
            if (kOptim /= 1) then
#             ifdef _DEBUGPRINT_
              write(u6,*) 'Reset update depth in BFGS, redo the RS-RFO.'
#             endif
              kOptim = 1
              Iter_Start = Iter
              IterSO = 1
            else
              write(u6,*) 'Probably a bug.'
              call Abend()
            end if
          end do
          !                                                            *
          !*************************************************************
          !                                                            *
          ! Pick up X(n) and compute X(n+1)=X(n)+dX(n)

          call GetVec(iter,LLx,inode,Xnp1,mOV)

          Xnp1(:) = Xnp1(:)+Disp(:)
          !                                                            *
          !*************************************************************
          !*************************************************************
          !                                                            *
        case (4) ! S-GEK
          !                                                            *
          !*************************************************************
          !*************************************************************
          !                                                            *
          ! update the S-GEK iteration counter
          if (Reset_GEK) then
            ! Reset the GEK surrogate model if the NQ grid has been reset
            if (Reset_NQ) IterGEK = 1
            IterSO = 1
            kOptim = 1
            SORange = .true.
            Reset_GEK = .false.
            Reset_NQ = .false.
#           ifdef _DEBUGPRINT_
            write(u6,*) 'Reset GEK'
#           endif
          else
            IterGEK = min(IterGEK+1,IterSO_Max)
          end if
          Iter_Start = max(Iter_Start,Iter-IterGEK+1)
          IterText = 'Macro Iterations'

          ! Get g(n)

          call GetVec(iter,LLGrad,inode,Grd1,mOV)
          !                                                            *
          !*************************************************************
          !                                                            *
          ! Expand the subspace for GEK
          StrSave = AccCon
          itSave = Iter_Start
          select case (Expand)
            case (1) ! Use DIIS
              ! Compute extrapolated g_x(n) and X_x(n)

              call DIIS_x(nD,CInter,nCI,.true.,Ind)

              call OptClc_X(CInter,nCI,nD,Grd1,mOV,Ind,MxOptm,kOptim,kOV,LLGrad)
              call OptClc_X(CInter,nCI,nD,Xnp1,mOV,Ind,MxOptm,kOptim,kOV,LLx)

              ! compute new displacement vector delta
              ! dX_x(n) = -H(-1)*g_x(n) ! Temporary storage in Disp

              ! Reduce the BFGS update depth until the step is reasonable
              do i=1,IterSO
                call SOrUpV(Grd1,mOV,Disp,'DISP','BFGS')
                DD = sqrt(DDot_(mOV,Disp,1,Disp,1))
                if (DD <= Pi) exit
#               ifdef _DEBUGPRINT_
                if (i == 1) then
                  write(u6,*) 'WfCtl_SCF: Total displacement is large.'
                  write(u6,*) 'DD=',DD
                end if
#               endif
                if (IterSO > 1) then
                  if (i == 1) write(u6,*) 'Reset update depth in BFGS'
                  IterSO = IterSO-1
                  Iter_Start = Iter-IterSO+1
                  kOptim = min(kOptim,IterSO)
                end if
              end do
#             ifdef _DEBUGPRINT_
              if (i > 1) write(u6,*) 'IterSO=',IterSO
#             endif

              ! from this, compute new orb rot parameter X(n+1)
              !
              ! X(n+1) = X_x(n) - H(-1)g_x(n)
              ! X(n+1) = X_x(n) + dX_x(n)

              Xnp1(:) = Xnp1(:)-Disp(:)

              ! get address of actual X(n) in corresponding LList

              jpXn = LstPtr(iter,LLx)

              ! and compute actual displacement dX(n)=X(n+1)-X(n)

              Disp(:) = Xnp1(:)-SCF_V(jpXn)%A(:)
            case (2) ! Use BFGS
              ! Reduce the BFGS update depth until the step is reasonable
              do i=1,IterSO
                call SOrUpV(Grd1,mOV,Disp,'DISP','BFGS')
                DD = sqrt(DDot_(mOV,Disp,1,Disp,1))
                if (DD <= Pi) exit
#               ifdef _DEBUGPRINT_
                if (i == 1) then
                  write(u6,*) 'WfCtl_SCF: Total displacement is large.'
                  write(u6,*) 'DD=',DD
                end if
#               endif
                if (IterSO > 1) then
#                 ifdef _DEBUGPRINT_
                  if (i == 1) write(u6,*) 'Reset update depth in BFGS'
#                 endif
                  IterSO = IterSO-1
                  Iter_Start = Iter-IterSO+1
                  kOptim = min(kOptim,IterSO)
                end if
              end do
#             ifdef _DEBUGPRINT_
              if (i > 1) write(u6,*) 'IterSO=',IterSO
#             endif
            case (3) ! Use RS-RFO
              dqHdq = Zero
              call rs_rfo_scf(Grd1,mOV,Disp,AccCon(1:6),dqdq,dqHdq,StepMax,AccCon(9:9),1)
          end select
          AccCon = StrSave
          Iter_Start = itSave

          Loosen_Active = (Loosen%Factor > One)
          call S_GEK_Optimizer(Disp,mOV,dqdq,AccCon(1:6),AccCon(9:9),SORange)
          !                                                            *
          !*************************************************************
          !                                                            *
          ! Pick up X(n) and compute X(n+1)=X(n)+dX(n)

          call GetVec(iter,LLx,inode,Xnp1,mOV)

          !                                                            *
          !*************************************************************
          !                                                            *
          ! Undershoot avoidance,
          ! when consecutive steps have a large overlap

          if ((Loosen%Step > One) .and. (iterGEK > 1)) then
            call mma_allocate(Prev,mOV,Label='Prev')
            call GetVec(iter-1,LLDelt,inode,Prev,mOV)
            dqdq = DDot_(mOV,Disp,1,Disp,1)*DDot_(mOV,Prev,1,Prev,1)
            ang = DDot_(mOV,Prev,1,Disp,1)/sqrt(dqdq)
            if ((ang < Loosen%Thrs2) .or. (AccCon(9:9) /= ' ')) then
              Loosen%Factor = One
            else if (ang > Loosen%Thrs) then
              Loosen%Factor = Loosen%Factor*Loosen%Step
            end if
            call mma_deallocate(Prev)
          end if

          Xnp1(:) = Xnp1(:)+Disp(:)
          !                                                            *
          !*************************************************************
          !*************************************************************
          !                                                            *
      end select
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
      ! Store X(n+1) and dX(n)

      dqdq = sqrt(DDot_(mOV,Disp,1,Disp,1))
      call PutVec(Xnp1,mOV,iter+1,'OVWR',LLx)
      call PutVec(Disp,mOV,iter,'OVWR',LLDelt)

      ! compute Norm of dX(n)

      DltNrm = real(nD,kind=wp)*dqdq

      ! Generate the CMOs, rotate MOs accordingly to new point

      call RotMOs(Disp,mOV)

      ! and release memory...
      call mma_deallocate(Xnp1)
      call mma_deallocate(Disp)
      call mma_deallocate(Grd1)
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
    case default
      write(u6,*) 'WfCtl_SCF: Illegal option'
      call Abend()
  end select
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Update DIIS interpolation and BFGS depth kOptim

  if (idKeep == 0) then
    kOptim = 1
  else if (idKeep == 1) then
    kOptim = 2
  else
    kOptim = min(kOptim_Max,kOptim+1)
  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! End optimization section
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Save the new orbitals in case the SCF program aborts

  iTrM = 1
  iCMO = 1
  do iSym=1,nSym
    nBs = nBas(iSym)
    nOr = nOrb(iSym)
    lth = nBs*nOr
    TrM(iTrM:iTrM+lth-1,1:nD) = CMO(iCMO:iCMO+lth-1,1:nD)
    TrM(iTrm+nBs*nOr:iTrm+nBs*nBs-1,1:nD) = Zero
    iTrM = iTrM+nBs*nBs
    iCMO = iCMO+nBs*nOr
  end do

  if (nD == 1) then
    OrbName = 'SCFORB'
    Note = '*  intermediate SCF orbitals'

    call WrVec_(OrbName,LuOut,'CO',nD-1,nSym,nBas,nBas,TrM(:,1),Dummy,OccNo(:,1),Dummy,Dummy,Dummy,iDummy,Note,2)
    call Put_darray('SCF orbitals',TrM(:,1),nBB)
    call Put_darray('OrbE',Eorb(:,1),nnB)
    if (.not. Aufb) call Put_iarray('SCF nOcc',nOcc(:,1),nSym)
  else
    OrbName = 'UHFORB'
    Note = '*  intermediate UHF orbitals'
    call WrVec_(OrbName,LuOut,'CO',nD-1,nSym,nBas,nBas,TrM(:,1),TrM(:,2),OccNo(:,1),OccNo(:,2),Dummy,Dummy,iDummy,Note,3)
    call Put_darray('SCF orbitals',TrM(:,1),nBB)
    call Put_darray('SCF orbitals_ab',TrM(:,2),nBB)
    call Put_darray('OrbE',Eorb(:,1),nnB)
    call Put_darray('OrbE_ab',Eorb(:,2),nnB)
    if (.not. Aufb) then
      call Put_iarray('SCF nOcc',nOcc(:,1),nSym)
      call Put_iarray('SCF nOcc_ab',nOcc(:,2),nSym)
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  !====================================================================*
  !                                                                    *
  !      A U F B A U  section                                          *
  !                                                                    *
  !====================================================================*
  !                                                                    *
  if (Aufb .and. (.not. Teee)) then

    if ((iter /= 1) .and. (abs(EDiff) < 0.002_wp) .and. (.not. AufBau_Done)) then
      Aufbau_Done = .true.
      Diis = Diis_Save
      DiisTh = DiisTh_save
    end if

  else if (Aufb .and. Teee) then

    ! If one iteration has been performed with the end temperature and we
    ! have a stable aufbau Slater determinant, terminate.
    ! The temperature is scaled down each iteration until it reaches the end
    ! temperature

    ! !!! continue here
    if ((abs(RTemp-TStop) <= 1.0e-3_wp) .and. (iAufOK == 1) .and. (abs(Ediff) < 1.0e-2_wp)) then
      Aufbau_Done = .true.
      Diis = Diis_Save
      DiisTh = DiisTh_save
    end if
    RTemp = TemFac*RTemp
    !RTemp = max(TStop,RTemp)
    TSTop = min(TStop,RTemp)
  end if
  !                                                                    *
  !====================================================================*
  !====================================================================*
  !                                                                    *
  ! Print out necessary things

  TCP2 = seconds()
  CpuItr = TCP2-TCP1
  ! Update status every 10 seconds at most
  if (TCP2-LastStatus > Ten) then
    write(Note,'(A,I0)') 'Iteration ',Iter
    call StatusLine('SCF: ',Note)
    LastStatus = TCP2
  end if

  call PrIte(iOpt >= 2,CMO,nBB,nD,Ovrlp,nBT,OccNo,nnB)

  !--------------------------------------------------------------------*
  call Scf_Mcontrol(iter)
  !--------------------------------------------------------------------*

  ! Check that two-electron energy is positive.
  ! The integrals may not be positive definite, leading to
  ! negative eigenvalues of the ERI matrix - i.e. attractive forces
  ! between the electrons! When that occurs the SCF iterations
  ! still might find a valid SCF solution, but it will obviously be
  ! unphysical and we might as well just stop here.

  if (Neg2_Action /= 'CONT') then
    if (E2V < E2VTolerance) then
      call WarningMessage(2,'WfCtl_SCF: negative two-electron energy')
      write(u6,'(A,ES25.10)') 'Two-electron energy E2V=',E2V
      call xFlush(u6)
      if (Neg2_Action == 'STOP') call Abend()
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  ! Perform another iteration if necessary
  !
  ! Convergence criteria are
  !
  ! Either,
  !
  ! 1) it is not the first iteration
  ! 2) the absolute energy change is smaller than EThr
  ! 3) the absolute Fock matrix change is smaller than FThr
  ! 4) the absolute density matrix change is smaller than DThr,
  !    and
  ! 5) step is NOT a Quasi NR step
  !
  ! or
  !
  ! 1) step is a Quasi NR step, and
  ! 2) DltNrm <= DltNth
  !
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if ((EDiff > Zero) .and. (.not. Reset)) EDiff = Ten*EThr
  if ((iter /= 1) .and. (abs(EDiff) <= EThr) .and. (abs(FMOMax) <= FThr) .and. &
      (((abs(DMOMax) <= DThr) .and. (iOpt < 2)) .or. ((DltNrm <= DltNTh) .and. iOpt >= 2))) then
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    if (Aufb) WarnPocc = .true.

    ! If calculation with two different sets of parameters reset
    ! the convergence parameters to default values. This is
    ! possibly used for direct SCF and DFT.

    if (Reset) then
      ! Reset thresholds for direct SCF procedure

      Reset = .false.

      if (iOpt == 2) then
        iOpt = 1        ! True if step is QNR
        QNR1st = .true.
      end if
      IterSO = 0
      if (Reset_Thresh) call Reset_Thresholds()
      if (KSDFT /= 'SCF') then
        if (.not. One_Grid) then
          call Reset_NQ_grid()
          Reset_GEK = .true.
          Reset_NQ = .true.
        end if
        if (iOpt == 0) kOptim = 1
      end if
      cycle
    end if

    ! Here if we converged!

    if (Loosen_Active) then
      ! If in loosen mode, disable it
      Loosen%Factor = One
      Loosen%Step = One
    else
      ! Branch out of the iterative loop! Done!!!
      Converged = .true.
      exit
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  else if (Aufb .and. AufBau_Done) then
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Here if Aufbau stage is finished and the calculation will
    ! continue normally.

    Aufb = .false.
    if (jPrint >= 2) then
      write(u6,*)
      write(u6,'(6X,A)') ' Fermi aufbau procedure completed!'
    end if
    if (nD == 1) then
      iOffOcc = 0
      do iSym=1,nSym
        do iBas=1,nOrb(iSym)
          iOffOcc = iOffOcc+1
          if (iBas <= nOcc(iSym,1)) then
            OccNo(iOffOcc,1) = Two
          else
            OccNo(iOffOcc,1) = Zero
          end if
        end do
      end do
      if (jPrint >= 2) then
        write(u6,'(6X,A,8I5)') 'nOcc=',(nOcc(iSym,1),iSym=1,nSym)
        write(u6,*)
      end if
    else
      iOffOcc = 0
      do iSym=1,nSym
        do iBas=1,nOrb(iSym)
          iOffOcc = iOffOcc+1
          if (iBas <= nOcc(iSym,1)) then
            OccNo(iOffOcc,1) = One
          else
            OccNo(iOffOcc,1) = Zero
          end if
          if (iBas <= nOcc(iSym,2)) then
            OccNo(iOffOcc,2) = One
          else
            OccNo(iOffOcc,2) = Zero
          end if
        end do
      end do
      if (jPrint >= 2) then
        write(u6,'(6X,A,8I5)') 'nOcc(alpha)=',(nOcc(iSym,1),iSym=1,nSym)
        write(u6,'(6X,A,8I5)') 'nOcc(beta) =',(nOcc(iSym,2),iSym=1,nSym)
        write(u6,*)
      end if

    end if

    ! Now when nOcc is known compute standard sizes of arrays.

    call Setup_SCF()

  end if
  !                                                                    *
  !====================================================================*
  !                                                                    *
  ! End of iteration loop

end do ! iter_
!                                                                      *
!======================================================================*
!                                                                      *

if (Converged) then

  if (jPrint >= 2) then
    write(u6,*)
    write(u6,'(6X,A,I3,1X,A)') ' Convergence after ',iter,trim(IterText)
  end if

else

  ! Here if we didn't converge or if this was a forced one
  ! iteration calculation.

  iter = iter-1
  if (nIter(nIterP) > 1) then
    if (jPrint >= 1) then
      write(u6,*)
      write(u6,'(6X,A,I3,1X,A)') ' No convergence after ',iter,trim(IterText)
    end if
    iTerm = _RC_NOT_CONVERGED_
  else
    if (jPrint >= 2) then
      write(u6,*)
      write(u6,'(6X,A)') ' Single iteration finished!'
    end if
  end if

  if (jPrint >= 2) write(u6,*)

  if (Reset) then
    if (DSCF .and. (KSDFT == 'SCF')) call Reset_Thresholds()
    if ((KSDFT /= 'SCF') .and. (.not. One_Grid)) then
      call Reset_NQ_grid()
      Reset_GEK = .true.
      Reset_NQ = .true.
    end if
  end if

end if

!**********************************************************
!                      S   T   O   P                      *
!**********************************************************

if (jPrint >= 2) then
  call CollapseOutput(0,'Convergence information')
  write(u6,*)
end if
! Compute total spin (if UHF)
if (nD == 1) then
  s2uhf = Zero
else
  call s2calc(CMO(:,1),CMO(:,2),Ovrlp,nOcc(:,1),nOcc(:,2),nBas,nOrb,nSym,s2uhf)
end if

call Add_Info('SCF_ITER',[real(Iter,kind=wp)],1,8)
!call Scf_XML(0)

call KiLLs()

! If the orbitals are generated with orbital rotations in
! RotMOs we need to generate the canonical orbitals.

if (iOpt >= 2) then

  ! Generate canonical orbitals

  call TraFck(.true.,FMOMax)

  ! Transform density matrix to MO basis

  call MODens()

end if

! Compute correct orbital energies and put on the runfile.

call Mk_EOrb()

! Put orbital coefficients on the runfile.

call Put_darray('SCF orbitals',CMO(1,1),nBB)
if (nD == 2) call Put_darray('SCF orbitals_ab',CMO(1,2),nBB)
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Finalize Cholesky information if initialized
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
if (DoCholesky) then
  call Cho_X_Final(irc)
  if (irc /= 0) then
    call WarningMessage(2,'WfCtl. Non-zero rc in Cho_X_Final.')
    call Abend()
  end if
end if
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
#ifdef _MSYM_
if (MSYMON) call fmsym_release_context(msym_ctx)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
!     Exit                                                             *
!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TCpu2,TWall2)
TimFld(2) = TimFld(2)+(TCpu2-TCpu1)

call mma_deallocate(CInter)
call mma_deallocate(TrDD)
call mma_deallocate(TrDP)
call mma_deallocate(TrDh)

!                                                                      *
!***********************************************************************
!                                                                      *
end subroutine WfCtl_SCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RPA_Warn(Level,Message)
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Level <= 1 --- issue warning with message Message and return.
C     Level >= 2 --- issue warning with message Message and quit.
C                    Error codes used in xQuit:
C                    Level=2: _RC_INPUT_ERROR_
C                    Level=3: _RC_INTERNAL_ERROR_
C                    Level>3: _RC_GENERAL_ERROR_
C
      Implicit None
      Integer Level
      Character*(*) Message
#include "warnings.fh"

      Integer iLevel
      Integer rc

      If (Level.le.1) Then
         iLevel=max(Level,0)
         rc=0
      Else
         iLevel=2
         If (Level.eq.2) Then
            rc=_RC_INPUT_ERROR_
         Else If (Level.eq.3) Then
            rc=_RC_INTERNAL_ERROR_
         Else
            rc=_RC_GENERAL_ERROR_
         End If
      End If
      Call WarningMessage(iLevel,Message)
      Call xFlush(6)
      If (rc.ne.0) Then
         Call xQuit(rc)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SetAtomShl(irc,iAtomShl,n)
      use ChoArr, only: iSOShl
C
C     Purpose: set mapping from shell to atom (i.e., center).
C
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
      Integer iAtomShl(n)
#include "cholesky.fh"
#include "choprint.fh"
#include "choorb.fh"
#include "stdalloc.fh"

      Character(LEN=14), Parameter:: SecNam = 'Cho_SetAtomShl'

      Character(LEN=LENIN8) AtomLabel(MxBas)

      Integer, Parameter:: Info_Debug = 4

#if defined (_DEBUGPRINT_)
      Logical, Parameter:: Debug = .True.
#else
      Logical, Parameter:: Debug = .False.
#endif

      Integer, Allocatable:: nBas_per_Atom(:)
      Integer, Allocatable:: nBas_Start(:)

      If (Debug) Then
         Write(Lupri,*) '>>> Enter ',SecNam
      End If

C     Check.
C     ------

      irc = 0
      If (nSym .ne. 1) Then ! does not work with symmetry
         irc = 1
         If (Debug) Then
            Write(Lupri,*) '>>> Exit ',SecNam,
     &      ' (error exit: symmetry not allowed!)'
         End If
         Return
      End If
      If (n .lt. nShell) Then
         Call Cho_Quit(SecNam//': iAtomShl not allocated correctly!',
     &                 104)
      End If

C     Get number of atoms.
C     --------------------

C     Call Get_nAtoms_All(nAtom)
      Call Get_iScalar('Bfn Atoms',nAtom)

C     Get atomic labels and basis function labels.
C     --------------------------------------------

      Call Get_cArray('Unique Basis Names',AtomLabel,LENIN8*nBasT)

C     Allocate and get index arrays for indexation of basis functions on
C     each atom.
C     ------------------------------------------------------------------

      Call mma_allocate(nBas_per_Atom,nAtom,Label='nBas_per_Atom')
      Call mma_allocate(nBas_Start,nAtom,Label='nBas_Start')
      Call BasFun_Atom(nBas_per_Atom,nBas_Start,
     &                 AtomLabel,nBasT,nAtom,Debug)

C     Set shell-to-atom mapping.
C     --------------------------

      Do iAtom = 1,nAtom
         i1 = nBas_Start(iAtom)
         i2 = i1 + nBas_per_Atom(iAtom) - 1
         Do i = i1,i2
            iAtomShl(iSOShl(i)) = iAtom
         End Do
      End Do

      If (iPrint.ge.Info_Debug .or. Debug) Then
         nErr = 0
         Write(Lupri,*)
         Write(Lupri,*) SecNam,': shell-to-atom mapping:'
         numSh  = 7
         nBatch = (nShell-1)/numSh + 1
         Do iBatch = 1,nBatch
            If (iBatch .eq. nBatch) Then
               nSh = nShell - numSh*(nBatch-1)
            Else
               nSh = numSh
            End If
            iSh0 = numSh*(iBatch-1)
            iSh1 = iSh0 + 1
            iSh2 = iSh0 + nSh
            Write(Lupri,'(/,A,7(1X,I9))')
     &      'Shell:',(iSh,iSh=iSh1,iSh2)
            Write(Lupri,'(A,7(1X,I9))')
     &      'Atom :',(iAtomShl(iSh),iSh=iSh1,iSh2)
            Do iSh = iSh1,iSh2
               If (iAtomShl(iSh).lt.1 .or. iAtomShl(iSh).gt.nAtom) Then
                  nErr = nErr + 1
               End If
            End Do
         End Do
         If (nErr .ne. 0) Then
            Call Cho_Quit(SecNam//': shell-to-atom init failed!',104)
         End If
      End If

C     Deallocations.
C     --------------

      Call mma_deallocate(nBas_Start)
      Call mma_deallocate(nBas_per_Atom)

      If (Debug) Then
         Write(Lupri,*) '>>> Exit ',SecNam
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************
!***********************************************************************
!  WarningMessage
!
!> @brief
!>   Print warning message
!> @author V. Veryazov
!>
!> @details
!> Print message in uniform format.
!>
!> @note
!> Routine updates \c MaxWarnMess.
!>
!> Recommended levels:
!> - ``0``: for message without recording that it was an error
!> - ``1``: for warnings
!> - ``2``: for errors
!>
!> @param[in] Level Warning level
!> @param[in] STR   Message
!***********************************************************************

subroutine WarningMessage(Level,STR)

use warnings, only: MaxWarnMess
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: Level
character(len=*), intent(in) :: STR

if (Level > MaxWarnMess) MaxWarnMess = Level
call SysPutsStart()
if (Level == 1) then
  call SysPuts('WARNING: ',STR,' ')
else if (Level == 2) then
  call SysPuts('ERROR: ',STR,' ')
else
  call SysPuts(STR,' ',' ')
end if
call SysPutsEnd()

!write(u6,'(A)') '*** '
!jj = 1
!do
!  i = index(STR(jj:),';')
!  if (i == 0) exit
!  write(u6,'(A,A)') '*** ',STR(jj:jj+i-2)
!  jj = i+jj
!end do
!write(u6,'(A,A)') '*** ',STR(jj:)
!write(u6,'(A)') '*** '

return

end subroutine WarningMessage

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine TraPAB(nZeta,la,lb,AB,GInt,jSum,rKappa,Fac1,Fac2,Fac3,Fac4,Fac5,A,B,P)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Index_Functions, only: C_Ind3, C3_Ind3, nTri_Elem1
#ifdef _DEBUGPRINT_
use Index_Functions, only: nTri3_Elem1
#endif
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, jSum
real(kind=wp), intent(out) :: AB(nZeta,nTri_Elem1(la),nTri_Elem1(lb)), Fac1(nZeta), Fac2(nZeta), Fac3(nZeta), Fac4(nZeta), &
                              Fac5(nZeta)
real(kind=wp), intent(inout) :: GInt(nZeta,jSum)
real(kind=wp), intent(in) :: rKappa(nZeta), A(3), B(3), P(nZeta,3)
integer(kind=iwp) :: i, ia, iax, iay, iaz, ibx, iby, ibz, igx, igy, igz, ipa, ipb, ipg, iTrgt, ix, ixa, ixas, ixb, ixbs, iy, iya, &
                     iyaMax, iyas, iyb, iybMax, iybs, iz, iza, izas, izb, izbs, iZeta, jx, jy, jz, kOff, lOff
real(kind=wp) :: Ax, Ay, Az, Bx, By, Bz

#ifdef _DEBUGPRINT_
call RecPrt(' In TraPAB: GInt',' ',GInt,nZeta,jSum)
call RecPrt(' In TraPAB: P   ',' ',P,nZeta,3)
#endif

! Initialize

AB(:,:,:) = Zero

! Remove redundant elements in GInt. This is done in place.

kOff = 4
do i=2,la+lb

  do ix=i,0,-1
    do iy=i-ix,0,-1
      iz = i-ix-iy
      jx = ix
      jy = iy
      jz = iz

      lOff = 0
      do ia=1,i-1
        if (jz /= 0) then
          lOff = 3*(2+lOff)
          jz = jz-1
        else if (jy /= 0) then
          lOff = 3*(1+lOff)
          jy = jy-1
        else
          lOff = 3*lOff
          jx = jx-1
        end if
      end do
      if (jz == 1) lOff = lOff+3
      if (jy == 1) lOff = lOff+2
      if (jx == 1) lOff = lOff+1

      iTrgt = C3_Ind3(ix,iy,iz)
      !write(u6,*) ' ix,iy,iz,kOff,lOff,iTrgt=',ix,iy,iz,kOff,lOff,iTrgt
      GInt(:,iTrgt) = GInt(:,kOff+lOff)

    end do
  end do

  kOff = kOff+3**i
end do
#ifdef _DEBUGPRINT_
call RecPrt(' In TraPAB: GInt(unique)',' ',GInt,nZeta,nTri3_Elem1(la+lb))
#endif

! Loop over the elements of the basis functions on A and B

do ixa=la,0,-1
  iyaMax = la-ixa
  do iya=iyaMax,0,-1
    iza = la-ixa-iya
    ipa = C_Ind3(ixa,iya,iza)
    !write(u6,*) ' ipa,ixa,iya,iza=',ipa,ixa,iya,iza

    do ixb=lb,0,-1
      iybMax = lb-ixb
      do iyb=iybMax,0,-1
        izb = lb-ixb-iyb
        ipb = C_Ind3(ixb,iyb,izb)
        !write(u6,*) ' ipb,ixb,iyb,izb=',ipb,ixb,iyb,izb

        ! Loop over the elements of functions at P

        do ixas=0,ixa
          call Binom(ixa,ixas,iAx)
          Ax = real(iAx,kind=wp)
          do iZeta=1,nZeta
            if ((ixa-ixas) == 0) then
              Fac1(iZeta) = rKappa(iZeta)*Ax
            else
              Fac1(iZeta) = rKappa(iZeta)*Ax*(P(iZeta,1)-A(1))**(ixa-ixas)
            end if
          end do
          do iyas=0,iya
            call Binom(iya,iyas,iAy)
            Ay = real(iAy,kind=wp)
            do iZeta=1,nZeta
              if ((iya-iyas) == 0) then
                Fac2(iZeta) = Fac1(iZeta)*Ay
              else
                Fac2(iZeta) = Fac1(iZeta)*Ay*(P(iZeta,2)-A(2))**(iya-iyas)
              end if
            end do
            do izas=0,iza
              call Binom(iza,izas,iAz)
              Az = real(iAz,kind=wp)
              do iZeta=1,nZeta
                if ((iza-izas) == 0) then
                  Fac3(iZeta) = Fac2(iZeta)*Az
                else
                  Fac3(iZeta) = Fac2(iZeta)*Az*(P(iZeta,3)-A(3))**(iza-izas)
                end if
              end do

              do ixbs=0,ixb
                call Binom(ixb,ixbs,iBx)
                Bx = real(iBx,kind=wp)
                do iZeta=1,nZeta
                  if ((ixb-ixbs) == 0) then
                    Fac4(iZeta) = Fac3(iZeta)*Bx
                  else
                    Fac4(iZeta) = Fac3(iZeta)*Bx*(P(iZeta,1)-B(1))**(ixb-ixbs)
                  end if
                end do
                igx = ixas+ixbs
                do iybs=0,iyb
                  call Binom(iyb,iybs,iBy)
                  By = real(iBy,kind=wp)
                  do iZeta=1,nZeta
                    if ((iyb-iybs) == 0) then
                      Fac5(iZeta) = Fac4(iZeta)*By
                    else
                      Fac5(iZeta) = Fac4(iZeta)*By*(P(iZeta,2)-B(2))**(iyb-iybs)
                    end if
                  end do
                  igy = iyas+iybs
                  do izbs=0,izb
                    call Binom(izb,izbs,iBz)
                    Bz = real(iBz,kind=wp)
                    igz = izas+izbs
                    ipg = C3_Ind3(igx,igy,igz)
                    !write(u6,*) ' ipg,igx,igy,igz=', ipg,igx,igy,igz

                    do iZeta=1,nZeta
                      if ((izb-izbs) == 0) then
                        AB(iZeta,ipa,ipb) = AB(iZeta,ipa,ipb)+Fac5(iZeta)*GInt(iZeta,ipg)*Bz
                      else
                        AB(iZeta,ipa,ipb) = AB(iZeta,ipa,ipb)+Fac5(iZeta)*(P(iZeta,3)-B(3))**(izb-izbs)*GInt(iZeta,ipg)*Bz
                      end if
                    end do

                  end do
                end do
              end do

            end do
          end do
        end do

      end do
    end do

  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt(' In TraPAB: AB',' ',AB,nZeta,nTri_Elem1(la)*nTri_Elem1(lb))
#endif

end subroutine TraPAB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_PFake_VDist()
!
! Author: Thomas Bondo Pedersen, April 2007.
! Purpose: fake parallel distribution of vectors.

use Para_Info, only: Is_Real_Par, nProcs
use Cholesky, only: Cho_Fake_Par, InfVec, MaxVec, nSym, NumCho
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iRedC, iSym, iV, l_Wrk, nRead, nV
integer(kind=iwp), allocatable :: IDV(:), InfV(:,:)
real(kind=wp), allocatable :: Wrk(:)
character(len=*), parameter :: SecNam = 'Cho_PFake_VDist'

! Return if nothing to do.
! ------------------------

if ((nProcs == 1) .or. (.not. Is_Real_Par())) return ! serial run
if (.not. CHO_FAKE_PAR) return ! true parallel run

! Memory allocation.
! ------------------

call mma_allocate(InfV,2,MaxVec+1,Label='InfV')
call mma_allocate(IDV,MaxVec,Label='IDV')
call mma_maxDBLE(l_Wrk)
call mma_allocate(Wrk,l_Wrk,Label='Wrk')

! Distribute vectors in each symmetry:
! read from LuCho files; put into LuCho_G files.
! ----------------------------------------------

iRedC = -1
do iSym=1,nSym
  InfV(:,:) = 0
  nV = 0
  call Cho_Distrib_Vec(1,NumCho(iSym),IDV,nV)
  iV = 0
  do while (iV < nV)
    nRead = 0
    call Cho_PFake_GetVec(Wrk,size(Wrk),IDV(iV+1),nV-iV,InfV(:,iV+1),iSym,nRead,iRedC)
    if (nRead < 1) call Cho_Quit('Insufficient memory in '//SecNam,101)
    call Cho_PFake_PutVec(Wrk,InfV,nRead,iSym,iV+1)
    iV = iV+nRead
  end do
# ifdef _DEBUGPRINT_
  if (iV /= nV) call Cho_Quit('Logical error in '//SecNam,103)
# endif
  InfVec(1:nV,3,iSym) = InfV(2,1:nV)
end do

! Deallocation.
! -------------

call mma_deallocate(Wrk)
call mma_deallocate(IDV)
call mma_deallocate(InfV)

end subroutine Cho_PFake_VDist

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine VECSUM_CPFMCPF(A,RSUM,N)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: A(N)
real(kind=wp), intent(out) :: RSUM
integer(kind=iwp) :: I

RSUM = Zero
do I=1,N
  RSUM = RSUM+A(I)
end do

return

end subroutine VECSUM_CPFMCPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine dbl_upwalk()
#include "drt_h.fh"
#include "intsort_h.fh"

      if(norb_dbl.eq.1) then
c     v(1),d(2-9),s(18-25)           for s=0
c     v(1),d(2-9),s(18-25),d'(26-33)   for s<>0

        mxnode=17+ng_sm
        lri=norb_frz+1
        lsmi=lsm_inn(lri)
        lsmid=mul_tab(lsmi,ns_sm)
!for node_v
        nu_ad(1)=1
        jpad_upwei(1)=1
!for node_d
        nu_ad(1+lsmid)=1+lsmid
        jpad_upwei(1+lsmid)=1
!for node_s
        nu_ad(17+ns_sm)=17+ns_sm
        jpad_upwei(17+ns_sm)=1

        if(jroute_sys.eq.1) return
        mxnode=25+ng_sm
!for node_d'
        nu_ad(25+lsmid)=25+lsmid
        jpad_upwei(25+lsmid)=1
        return
      endif
      nu_ad=0
      jpad_upwei=0

      nu_ad(1)=1
      jpad_upwei(1)=1
      if(norb_dbl.eq.0) then
        mxnode=1
        return
      endif
      do lri=norb_frz+1,norb_dz
        lsmi=lsm_inn(lri)
        lsmid=mul_tab(lsmi,ns_sm)
        no_d=lsmid+1
        jpad_upwei(no_d)=jpad_upwei(no_d)+1
        do lrj=lri+1,norb_dz
          lsmj=lsm_inn(lrj)
          lsmij=mul_tab(lsmi,lsmj)
          lsmit=mul_tab(lsmij,ns_sm)
          no_t =lsmit+9
          jpad_upwei(no_t)=jpad_upwei(no_t)+1
        enddo
      enddo
c     v(1),d(2-9),t(10-17),s(18-25),d'(26-33),t'(34-41)
      goto(100,200,300) jroute_sys
100     mxnode=25                     !v,d,t,s
        jpad_upwei(18:25)=jpad_upwei(10:17)
        jpad_upwei(17+ns_sm)=jpad_upwei(17+ns_sm)+norb_dbl
        goto 500
200     mxnode=25+8
        jpad_upwei(18:25)=jpad_upwei(10:17)+jpad_upwei(10:17)
        jpad_upwei(17+ns_sm)=jpad_upwei(17+ns_sm)+norb_dbl
        jpad_upwei(26:33)=jpad_upwei(2:9)
        goto 500
300     mxnode=25+8+8
        jpad_upwei(18:25)=jpad_upwei(10:17)+jpad_upwei(10:17)
        jpad_upwei(17+ns_sm)=jpad_upwei(17+ns_sm)+norb_dbl
        jpad_upwei(26:33)=jpad_upwei(2:9)
        jpad_upwei(34:41)=jpad_upwei(10:17)

500   do node=2,mxnode
        iw=jpad_upwei(node)
        if(iw.eq.0) cycle
        nu_ad(node)=node
      enddo
      return
      end

      subroutine ext_downwalk()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
      dimension iwmij(8)
      nu_ae(1)=1
      do im=1,ng_sm
        nu_ae(1+im)=1+im
        nu_ae(9+im)=9+im
        nu_ae(17+im)=17+im
      enddo

      iwmij=0
      iseg_downwei(nu_ae(1))=1
      do imi=1,ng_sm
        iseg_downwei(nu_ae(1+imi))=nlsm_ext(imi)
        do imj=imi,ng_sm
          imij=mul_tab(imi,imj)
          if(imij.ne.1) then
           iwmij(imij)=iwmij(imij)+nlsm_ext(imi)*nlsm_ext(imj)
             cycle
          endif
         iwmij(1)=iwmij(1)+nlsm_ext(imi)*(nlsm_ext(imi)-1)/2
        enddo
      enddo
      do im=1,ng_sm
        iseg_downwei(nu_ae(9+im))=iwmij(im)
        iseg_downwei(nu_ae(17+im))=iwmij(im)
      enddo
      iseg_downwei(nu_ae(18))=iseg_downwei(nu_ae(18))+norb_ext
      return
      end

      subroutine readdrt(ludrt)
#include "drt_h.fh"
      !include "files_gugaci.fh"
#include "pl_structure_h.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
      dimension idx(2)

      idisk=0
      !  number of nodes
      call idafile(ludrt,2,idx,2,idisk)
      idisk=idx(2)
      call idafile(ludrt,2,idx,1,idisk)
      id=idx(1)
      call idafile(ludrt,2,ja,id,idisk)
      call idafile(ludrt,2,jb,id,idisk)
      call idafile(ludrt,2,jm,id,idisk)
      call idafile(ludrt,2,jj,4*(id+1),idisk)
      call idafile(ludrt,2,kk,1+id,idisk)
      call idafile(ludrt,2,no(0),norb_inn+2,idisk)
      call idafile(ludrt,2,idx,1,idisk)
      jv=idx(1)
      call idafile(ludrt,2,jd,8,idisk)
      call idafile(ludrt,2,jt,8,idisk)
      call idafile(ludrt,2,js,8,idisk)

      return
      end

c     juv,just(nost,nost),jud(nost)
c     |  \  1         |
c     | d,dd,s(i=i)   |
c     |    \ s,t,tt(i<j)|
c     |     \       1 2 |     deal with inner of dbl_space
c     |ss(i>j)\       |
c     |  2 1  \       |
      subroutine dbl_downwalk()
#include "drt_h.fh"
#include "intsort_h.fh"
c     integer lsml(10,10)       !to del
      if(norb_dbl.ne.0) goto 200
c----------- norb_dbl=0 ------------------------------------------------
      do im=1,ng_sm
        nnd=iseg_sta(1+im)
        nnt=iseg_sta(9+im)
        nns=iseg_sta(17+im)
        do lri=norb_dz,norb_frz+1,-1
          ismi=lsm_inn(lri)
         if(ismi.ne.im) cycle
          jud(lri)=nnd
          nnd=nnd+iseg_downwei(1+im)
        enddo
        do lrj=norb_dz,norb_frz+1,-1
         ismj=lsm_inn(lrj)
          do lri=lrj,1,-1
           ismi=lsm_inn(lri)
           ismij=mul_tab(ismi,ismj)
            if(ismij.ne.im) cycle
            just(lri,lrj)=nns
            nns=nns+iseg_downwei(17+im)
            if(lri.eq.lrj) cycle
           just(lrj,lri)=nnt
            nnt=nnt+iseg_downwei(9+im)
           enddo
        enddo
      enddo
c----------- norb_dbl=0 ------------------------------------------------
c----------- norb_dbl<>0 -----------------------------------------------
200   iwdownv=0
      do im=1,ng_sm
        nnd=0
        nns=0
        do lri=norb_frz+1,norb_dz
          ismi=mul_tab(lsm_inn(lri),ns_sm)
          if(ismi.ne.im) cycle
          jud(lri)=nnd
          nnd=nnd+1
        enddo
        do lri=norb_frz+1,norb_dz-1
          ismi=mul_tab(lsm_inn(lri),ns_sm)
          do lrj=lri+1,norb_dz      !tmp
            ismj=lsm_inn(lrj)
            ismij=mul_tab(ismi,ismj)
            if(ismij.ne.im) cycle
            just(lri,lrj)=nns
            nns=nns+1
          enddo
        enddo
        if(im.eq.ns_sm) then
          do lr0=norb_frz+1,norb_dz
            just(lr0,lr0)=nns
            nns=nns+1
          enddo
        endif
        do lri=norb_frz+1,norb_dz-1
          ismi=mul_tab(lsm_inn(lri),ns_sm)
          do lrj=lri+1,norb_dz      !tmp
           ismj=lsm_inn(lrj)
           ismij=mul_tab(ismi,ismj)
            if(ismij.ne.im) cycle
            just(lrj,lri)=nns
            nns=nns+1
         enddo
        enddo
      enddo
!      print*, "ns_sm",ns_sm
!      print*, just(1:4,1:4)
c     do i=norb_frz+1,norb_dz           !to del
c       lmi=lsm_inn(i)               !to del
c        do j=norb_frz+1,norb_dz         !to del
c       lmj=lsm_inn(j)                !to del
c       lsml(i,j)=mul_tab(lmi,lmj)       !to del
c        enddo                         !to del
c     enddo                         !to del
c     write(nf2,*)'   jud ...'             !to del
c     write(nf2,'(2x,12i8)')(jud(lr),lr=norb_frz+1,norb_dz)    !to del
c     write(nf2,*)'   just ...'           !to del
c     do i=norb_frz+1,norb_dz               !to del
c      write(nf2,'(2x,8i3)')             !to del
c    :         (lsml(i,lr),lr=norb_frz+1,norb_dz)  !to del
c      write(nf2,'(2x,8i3)')             !to del
c    :         (just(i,lr),lr=norb_frz+1,norb_dz)  !to del
c      write(nf2,*)
c     enddo                            !to del
c----------- norb_dbl<>0 -----------------------------------------------
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
       SubRoutine creq(q,rint,G2,idsym)
*
*      Constructs the Q matrix
*
       Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
       Real*8 Q(nDens2),rint(*),G2(*)
       itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

*
*      Q = (pj|kl)d
*       pi         ijkl
*
       call dcopy_(ndens2,[0.0d0],0,Q,1)
       Do iS=1,nSym
        ipS=iEOr(is-1,idsym-1)+1
         if (norb(ips).ne.0) Then

        Do jS=1,nsym
         ijS=iEOR(is-1,js-1)+1
         Do kS=1,nSym
          ls=iEOr(ijs-1,ks-1)+1
          Do iAsh=1,nAsh(is)
           Do jAsh=1,nAsh(js)
            iij=itri(iAsh+nA(is),jAsh+nA(jS))
            Do kAsh=1,nAsh(ks)
             Do lAsh=1,nAsh(ls)
              ikl=itri(lAsh+nA(lS),kAsh+nA(kS))
              ipQ=ipMatba(ips,is)+norb(ips)*(iAsh-1)
              ipG=itri(iij,ikl)
              ipi=ipMO(js,ks,ls)+
     &         (norb(ips)*(jAsh-1+nAsh(js)*
     6          (kAsh-1+nAsh(ks)*(lAsh-1))))
             call daxpy_(norb(ips),G2(ipG),rint(ipI),1,
     &                  Q(ipQ),1)
             End Do
            End Do
           End Do
          End Do
         End Do
        End Do
        end if
       End Do
       Return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Lucia_Ini()

use lucia_data, only: ECORE, ENVIRO, I2ELIMINATED_IN_GAS, I_ELIMINATE_GAS, IADVICE, ICISTR, ICJKAIB, ICMBSPC, IDC, IDIAG, &
                      IELIMINATED_IN_GAS, IGSOCCX, IH0INSPC, IH0SPC, ini_h0, IPART, IPRCIX, IPRDEN, IREFSM, IRESTR, ISIMSYM, &
                      LCMBSPC, LCSBLK, MOCAA, MS2, MULTS, MXINKA, N_2ELIMINATED_GAS, N_ELIMINATED_GAS, NACTEL, NCISPC, NCMBSPC, &
                      NGAS, NGSSH, NIRREP, NOINT, NPTSPC, NROOT, NSMOB, PSSIGN, Sigma_on_disk
use spinfo, only: DoComb, I2ELIMINATED_IN_GAS_MOLCAS, I_ELIMINATE_GAS_MOLCAS, IELIMINATED_IN_GAS_MOLCAS, IGSOCCX_MOLCAS, &
                  IPRCI_MOLCAS, ISPEED, ISPIN_MOLCAS, ITMAX_MOLCAS, LSYM_MOLCAS, MS2_MOLCAS, N_2ELIMINATED_GAS_MOLCAS, &
                  N_ELIMINATED_GAS_MOLCAS, NACTEL_MOLCAS, NGAS_MOLCAS, NGSSH_MOLCAS, NROOTS_MOLCAS, NSYM_MOLCAS, POTNUC_MOLCAS
#ifdef _DEBUGPRINT_
use lucia_data, only: NOCSF
use spinfo, only: IEXPAND_MOLCAS, INOCALC_MOLCAS, IPT2_MOLCAS, ISAVE_EXP_MOLCAS, THRE_MOLCAS
#endif
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), parameter :: MXPKW = 125
integer(kind=iwp) :: I, IDENSI, IDOPERT, IEXPERT, IRREP, isetkw(MXPKW), IUSED, MXCIV, NMISS, NWARN
real(kind=wp) :: ECORE_ENV
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ICLSSEL, IEXPAND, IFINMO, INOCALC, IRST2, ISKIPEI, ISAVE_EXP
real(kind=wp) :: PLSIGN, THRES_E
character(len=4) :: ITRACI_CN, ITRACI_CR
#endif

! ================================================
!  Some initialization to avoid compiler warnings
! ================================================
!MSCOMB_CC = 0
!I_USE_NEWCCP = 0
! =======================
!  Some initial settings
! =======================
INI_H0 = 1
! Flag for compatibility with normal MOLCAS input format

IEXPERT = 0
NWARN = 0
#ifdef _DEBUGPRINT_
ICLSSEL = 0
IFINMO = 0
IRST2 = 0
ISKIPEI = 0
#endif
! No cc as default
! Start out with normal integrals
!I_USE_SIMTRH = 0
! Initialize flag to be used by densi_master to check whether the
! sigma-vector is on disk.
Sigma_on_disk = .false.

! ===================
!  Initialize isetkw
! ===================
isetkw(:) = 0

! =========================
!  Point group of orbitals
! =========================
!PNTGRP = 1

! ==============================
!  Number of irreps of orbitals
! ==============================
nirrep = nsym_molcas
nsmob = nsym_molcas

! ============================
!  Number of active electrons
! ============================
nactel = nactel_Molcas

! =================
!  Inactive shells
! =================
!ninash(1:nirrep) = nish_molcas(1:nirrep)

! ==================
!  Secondary shells
! ==================

! ===========================
!  Two times spin projection
! ===========================
ms2 = ms2_molcas

! ===================
!  Spin multiplicity
! ===================
mults = iSpin_molcas

! ====================
!  Reference symmetry
! ====================
irefsm = lsym_molcas

! =======
!  Roots
! =======
nroot = nroots_molcas
!iroot(1:nroot) = iroot_molcas(1:nroot)
!iroot(1:nroot) = 0

! ============
!  Enviroment
! ============
enviro(1:6) = 'RASSCF'

! ====================
! 27: Ms combinations
! ====================
if ((MULTS == 1) .and. (ISPEED(1) == 1)) then
  ISETKW(27) = 1
  PSSIGN = One
else
  ISETKW(27) = 0
end if

! ==========================================================
! 33 : Largest allowed number of Vectors in diagonalization
! ==========================================================
MXCIV = 2*NROOT

! ==========================
!  Storage mode for vectors
! ==========================
icistr = 2
! =================================
!  Tell Lucia to use CSF-expansion
! =================================
!noscf = 0

! =============================================
! 39 : Define dimension of resolution matrices
! =============================================
MXINKA = 150

! ==========================================================
!  Generalized active space concept invoked, orbital spaces
! ==========================================================
ngas = ngas_molcas
ngssh = 0
do irrep=1,nirrep
  ngssh(irrep,1:ngas) = ngssh_molcas(1:ngas,irrep)
end do

! ==================================================
!  Generalized active space occupation restrictions
! ==================================================
ncispc = 1
igsoccx(1:ngas,:,1) = igsoccx_molcas(1:ngas,:)

#ifdef _DEBUGPRINT_
! ==========================
!  Energy convergence of CI
! ==========================
thres_e = thre_molcas
#endif

! ==========================================
!  Sequence of calculations to wavefunction
! ==========================================
ncmbspc = ncispc

#ifdef _DEBUGPRINT_
! =======================================================
!  No calculation, save CI vector info, expand CI vector
! =======================================================
INOCALC = INOCALC_MOLCAS
ISAVE_EXP = ISAVE_EXP_MOLCAS
IEXPAND = IEXPAND_MOLCAS
#endif

! ================================================
!  Length of smallest block og C an Sigma vectors
! ================================================
lcsblk = 3000000

! =================================
!  Calculation of density matrices
! =================================
idensi = 2

! ============================================
! 87 : Allow the sigma routine to take advice
! ============================================
!
IADVICE = 1

! ============================================================
!  Transform CI vectors to alternative orbital representation
! ============================================================
#ifdef _DEBUGPRINT_
itraci_cr = 'REST'
if (ipt2_molcas == 1) then
  itraci_cn = 'CANO'
else
  itraci_cn = 'NATU'
end if
#endif

! ==============================
!  HEXS - Highly excited states
!  DEXS - Doubly excited states
! ==============================
I_ELIMINATE_GAS = I_ELIMINATE_GAS_MOLCAS
N_ELIMINATED_GAS = N_ELIMINATED_GAS_MOLCAS
N_2ELIMINATED_GAS = N_2ELIMINATED_GAS_MOLCAS
!write(u6,*) I_ELIMINATE_GAS_MOLCAS,N_ELIMINATED_GAS_MOLCAS
IELIMINATED_IN_GAS(1:N_ELIMINATED_GAS) = IELIMINATED_IN_GAS_MOLCAS(1:N_ELIMINATED_GAS)
I2ELIMINATED_IN_GAS(1:N_2ELIMINATED_GAS) = I2ELIMINATED_IN_GAS_MOLCAS(1:N_2ELIMINATED_GAS)

! =============
!  Printlevels
! =============
iprcix = iprci_molcas-2
iprden = (iprci_molcas-2)/2

! ==============
!  Set defaults
! ==============

!***********************************************************************
!                                                                      *
! Part 2 : Insert defaults for missing optional keywords               *
!          and print error messages for missing mandatory keywords     *
!                                                                      *
!***********************************************************************

NMISS = 0

! 8 : Core orbitals, only of interest if EXTSPC /= 0

! 9 : RAS 1 orbitals

! 10 : RAS 2 orbitals

! 11 : RAS 3 orbitals

! 13 : Secondary space

! 14 : occupation restrictions for Reference space

! 15 : Selection of active configurations

! Standard is no selection

! 20 : Diagonalization routine

! Standard is currently MICDV*
IDIAG = 1

! 21 : Explicit Hamiltonian

! Default is no explicit Hamiltonian

! 22 : Largest allowed number of CI iterations per root

! Default is 20 (not active I expect)

! 23 : Restart option

! Default is no explicit Hamiltonian
IRESTR = 0

! 26 : DELETEd shells

! If CAS + Active have been set or RAS + Ras3 have been set,
! obtain for MOLCAS Interface from number of basis functions
!NDELSH(1:NIRREP) = 0

! 27 : Ms combinations

if (ISETKW(27) == 0) then
  PSSIGN = Zero
  ISETKW(27) = 2
else if (MS2 /= 0) then
  write(u6,*) ' Spin combinations only allowed with MS2 = 0'
  write(u6,*) ' Your value of MS2 = ',MS2,' differs from zero'
  write(u6,*) ' LUCIA will neglect your nice suggestion'
  write(u6,*) ' to use spin combinations'
  PSSIGN = Zero
  ISETKW(27) = 2
end if

! 28 : Ml combinations

#ifdef _DEBUGPRINT_
PLSIGN = Zero
#endif

if (PSSIGN == Zero) then
  DoComb = .false.
  IDC = 1
else
  DoComb = .true.
  IDC = 2
end if

!write(u6,*) ' TEST readin IDC = ',IDC

! ======================================================================
! 44 : Use Minimal operation count method for alpha-alpha and beta-beta
! ======================================================================
! TEST OF PERFORMANCE
MOCAA = ISPEED(3)
!MOCAB = ISPEED(4)

! 33 : Number of Ci vectors in subspace

if ((IDIAG == 2) .and. (MXCIV > 2)) then
  MXCIV = 2
  NWARN = NWARN+1
  write(u6,*) ' Warning : You have specified TERACI'
  write(u6,*) '           I allow myself to set MXCIV = 2'
  write(u6,*)
  write(u6,*) '                   Best Wishes'
  write(u6,*) '                      Lucia'
end if

! 34 : CI storage mode

! 35 : Employ CSF expansion ?

! Default is no (only possibility at the moment)
! CSF expansion must only be used when two vectors are stored in CORE

! 37 : Avoid any readin of integrals (useful for obtaining
!      size of CI expansion etc.)

NOINT = 0

! 38 : Dump integrals in formatted form : Default is No

!IDMPIN = 0

! 40 : Use CJKAKB intermediate matrices in alpha-beta loop,
!      Default is  YES !!!!!

ICJKAIB = 1

!  41 : Initial CI in reference space, default is : No

!  42 : Restart with CI in reference space

! Core energy : Default is 0 / MOLCAS : Value read in !

ECORE = Zero

! Use perturbation theory for zero order space . def is no !

if (ISETKW(47) == 0) ISETKW(47) = 2

! 48 : Approximate Hamiltonian in reference space : NO !!

if (ISETKW(48) == 0) ISETKW(48) = 2

! 49 : Approximate Hamiltonian in zero order space : NO !!

if (ISETKW(49) == 0) ISETKW(49) = 2

! 50 : GAS shells must be defined

! 52 : Combination of gasspaces : Default is just to take each  space
!      By itself

if (ISETKW(52) == 0) then
  NCMBSPC = NCISPC
  LCMBSPC(1:NCISPC) = 1
  ICMBSPC(1,1:NCISPC) = [(i,i=1,NCISPC)]
  ISETKW(52) = 2
end if

! 53 : Convergence threshold for CI

! 54 : General sequencer : default is just straight sequence
!      of CI with default number of iterations

! 55 : EKT calculation : Default is no

if (ISETKW(55) == 0) ISETKW(55) = 2

! 56 : Default Machine : Good old BIM machine

! 57 : Allow first order correction to be saved on DISC
!     (For vector free calculations)
!     Default is : NO !!
if (ISETKW(57) == 0) ISETKW(57) = 2

! 58 : Restrictions on interactions of perturbation

! Default is : no
if (ISETKW(58) == 0) then
  IH0SPC = 0
  ISETKW(58) = 2
end if

! 59 : Type of perturbation in subspaces spaces

! Default is specified by IPART from keyword PERTU
if (ISETKW(59) == 0) then
  ISETKW(59) = 2
  if (IH0SPC /= 0) IH0INSPC(1:NPTSPC) = IPART
end if

! 60 : Reference Root, default is NROOT

! Should be less or equal to NROOT
!if (ISETKW(60) == 1) then
!  if (IRFROOT > NROOT) then
!    write(u6,*) ' Reference root (RFROOT) larger'
!    write(u6,*) ' than total number of roots (NROOT)'
!    write(u6,*) ' CHANGE NROOT or RFROOT'
!    NMISS = NMISS+1
!  end if
!end if

if (ISETKW(60) == 0) ISETKW(60) = 2

! 61 : H0EX : Orbital spaces in which exaxt Hamiltonian is used
!      No default

! Is H0EX required (Has H0FRM = 5 been used)
IUSED = 0
if (ISETKW(59) == 1) then
  IUSED = 0
  if (any(IH0INSPC(1:NPTSPC) == 5)) IUSED = 1
end if
!if ((IUSED == 0) .and. (ISETKW(61) == 0)) then
!  ! No exact spaces included and none have been defined !
!  NH0EXSPC = 0
!end if
if ((IUSED == 1) .and. (ISETKW(61) == 0)) then
  ! Needed, but not supplied
  write(u6,*) ' You have specified that zero order operator'
  write(u6,*) ' Include exact Hamilton operator in subspace'
  write(u6,*) ' You should then also supply Keyword H0EX'
  NMISS = NMISS+1
end if

! If perturbation theory will be invoked be sure that the
! form of perturbation theory has been specified through
! KEYWORD PERTU (number 47 as you maybe know)
IDOPERT = 0
!do JCMBSPC=1,NCMBSPC
!  do JSEQCI=1,NSEQCI(JCMBSPC)
!    if (ISEQCI(JSEQCI,JCMBSPC) == -5) IDOPERT = 1
!  end do
!end do
if (itmax_molcas == -5) IDOPERT = 1

if (IDOPERT == 1) then
  write(u6,*) ' Perturbation theory will be used'
  write(u6,*) ' Please specify form through PERTU keyword'
  NMISS = NMISS+1
end if

! 62 : Default Handling of degenrences of initial CI vectors
!      Default is : No action

if (ISETKW(62) == 0) ISETKW(62) = 2

! 63 : Use F + Lambda(H-F) as operator instead of H
!      Default is : No i.e Lambda = 1

if (ISETKW(63) == 0) ISETKW(63) = 2

! 64 : Smallest block in batch of C and sigma
!      Default is zero

! 66 : NO MO file : Default is no access to MO-AO file

! 68 : Type of natural orbitals, default is natural orbitals

if (ISETKW(68) == 0) then
  ISETKW(68) = 2
# ifdef _DEBUGPRINT_
  IFINMO = 1
# endif
end if

! 69 : Default Threshold for individual energy correction = 0.0

if (ISETKW(69) == 0) ISETKW(69) = 2

! 70 : Default Threshold for wave individual function corrections = 0.0

if (ISETKW(70) == 0) ISETKW(70) = 2

! 71 : Default Threshold for total energy corrections = 0.0

if (ISETKW(71) == 0) ISETKW(71) = 2

! 72 : Default Threshold for total wave function correction = 0.0

if (ISETKW(72) == 0) ISETKW(72) = 2

! 73 : Perform Class selection : Default if Yes if TERACI is used

if (ISETKW(73) == 0) then
# ifdef _DEBUGPRINT_
  if (IDIAG == 1) then
    ICLSSEL = 0
  else if (IDIAG == 2) then
    ICLSSEL = 1
  end if
# endif
  ISETKW(73) = 2
end if

! 74 : Calculation of density matrices : Default is
!      calculation of one-body density

! If IDENSI was set to zero and properties were requested
! overwrite input to obtain 1-el matrix
if ((IDENSI == 0) .and. (ISETKW(80) == 1)) then
  write(u6,*) ' You have specified calculation of'
  write(u6,*) ' one-electron properties, and this'
  write(u6,*) ' requires the calculation of the'
  write(u6,*) ' one-electron density.'
  write(u6,*)
  write(u6,*) ' You have, however, specified IDENSI=0'
  write(u6,*) ' corresponding  to no densities'
  write(u6,*)
  write(u6,*) ' I will allow myself to modify your'
  write(u6,*) ' input to allow calculation of the'
  write(u6,*) ' one-electron densities, so property'
  write(u6,*) ' calculation can proceed as planned'
  write(u6,*)
  write(u6,*) ' Lucia'
  ! and do it
  IDENSI = 1
end if
! If CC is performed, one- and two- particle densities are
! used in current simple-minded implementation.
! Two-electron density also needed for MCSCF

! 75 : Perturbation expansion of EKT, default is no

if (ISETKW(75) == 0) then
  ISETKW(75) = 2
end if

! 76 : Root for zero order operator, default is NROOT

! Should be less or equal to NROOT
!if (ISETKW(76) == 1) then
!  if (IH0ROOT > NROOT) then
!    write(u6,*) ' Zero order operator root (H0ROOT) larger'
!    write(u6,*) ' than total number of roots (NROOT)'
!    write(u6,*) ' CHANGE NROOT or H0ROOT'
!    NMISS = NMISS+1
!  end if
!end if
if (ISETKW(76) == 0) ISETKW(76) = 2

! 77 : NO restart from previous vectors in calculation 2
!      Deafault is NO NO, ie. restart in calc 2

if (ISETKW(77) == 0) then
# ifdef _DEBUGPRINT_
  IRST2 = 1
# endif
  ISETKW(77) = 2
end if

! 78 : skip initial energy evaluations - if possible

if (ISETKW(78) == 0) then
# ifdef _DEBUGPRINT_
  ISKIPEI = 1
# endif
  ISETKW(78) = 2
end if

! 79 : Symmetry of x,y,z - needed for property calculations

if (ISETKW(79) == 0) then
  ! Problematic if Properties should be calculated
  if ((ISETKW(80) == 1) .or. (ISETKW(81) == 1) .or. (ISETKW(82) == 1)) then
    write(u6,*) ' Symmetry of X,Y,Z has not been given'
    write(u6,*) ' You have to specify this for property calc'
    write(u6,*) ' Please add KEYWORD XYZSYM'
    NMISS = NMISS+1
    ISETKW(79) = -1
  else
    ISETKW(79) = 2
  end if
end if

! 80 : Property calculation, default is no

if (ISETKW(80) == 0) ISETKW(80) = 2

! 81 : Transition properties, default is no

if (ISETKW(81) == 0) ISETKW(81) = 2

! 82 : Response properties, default is no

if (ISETKW(82) == 0) ISETKW(82) = 2
! Properties should be defined if transition properties are
! invoked
!if ((ITRAPRP /= 0) .and. (NPROP == 0)) then
!  write(u6,*) ' You have specified transition property calculation'
!  write(u6,*) ' (keyword TRAPRP) but no property labels have been supplied'
!  write(u6,*) '(Keyword PROPER). Transition densities will be obtained'
!end if

! 83 : Max number of iterations in linear equations

if (ISETKW(83) == 0) ISETKW(83) = 2

! 85 : Root homing, default is no

if (ISETKW(85) == 0) ISETKW(85) = 2

! 90 : Perturbation expansion of Fock matrix : default is no

if (ISETKW(90) == 0) ISETKW(90) = 2

! 91 : Print final CI vectors : default is no

if (ISETKW(91) == 0) ISETKW(91) = 2

! 93 : End Calculation with integral transformation

if (ISETKW(93) == 0) ISETKW(93) = 2

! 94 : Initialize Calculation with integral transformation

if (ISETKW(94) == 0) ISETKW(94) = 2
! Requires access to MO-AO file
!if ((ITRA_IN == 1) .and. (NOMOFL == 1)) then
!  write(u6,*) ' Integral transformation required,'
!  write(u6,*) ' but no mo-ao file accessible'
!  write(u6,*) ' REMOVE KEWORD NOMOFL'
!  ISETKW(94) = -1
!  NERROR = NERROR+1
!end if

! 95 : Multispace optimization in each run, default is no

if (ISETKW(95) == 0) ISETKW(95) = 2

! Expert mode (neglect mistyped keywords) : default is no expert

if (ISETKW(97) == 0) then
  IEXPERT = 0
  ISETKW(97) = 2
end if

! Number of roots to be converged : default is total number of roots

if (ISETKW(98) == 0) ISETKW(98) = 2

! 100 : Do quantum dot calculation, default is no

!if (ISETKW(100) == 0) then
!  IDODQ = 0
!  ISETKW(100) = 2
!end if

! 101: Restrict MS2 at some intermediate level : default is no way

if (ISETKW(101) == 0) ISETKW(101) = 2

! 103 : Treat all TT blocks with given types simultaneously : Default is no

ISIMSYM = 0

! Thresholds only active in connection with IDIAG = 2,
! Check and maybe issue a warning
if (IDIAG == 2) then
  ! Check to ensure that zero or two thresholds were  set,
  if (ISETKW(69) /= ISETKW(70)) then
    write(u6,*) ' Only a single threshold (E_THRE or C_THRE)'
    write(u6,*) ' on individual determinants given.'
    write(u6,*) ' One of the thresholds vanishes therefore and'
    write(u6,*) ' all determinants will therefore be included'
    write(u6,*)
    write(u6,*) '                   Warns'
    write(u6,*)
    write(u6,*) '                   LUCIA'
  end if
else
  ! Good old diagonalization, thresholds not active
  if ((ISETKW(69) == 1) .or. (ISETKW(70) == 1)) then
    write(u6,*) ' Thresholds on selection of individual coefficients'
    write(u6,*) ' are only active in connection with keyword TERACI'
    write(u6,*)
    write(u6,*) '                   Warns'
    write(u6,*)
    write(u6,*) '                   LUCIA'
  end if
end if

if (NMISS /= 0) then
  write(u6,'(1X,A,I9)') ' Number of missing required keyword ',NMISS
  write(u6,*) ' You have wounded me I give up'
  write(u6,*)
  write(u6,*)
  write(u6,*)
  write(u6,*) '     An expert is a man who has made all the mistakes,'
  write(u6,*) '     which can be made, in a very narrow field'
  write(u6,*)
  write(u6,*) '                                      Niels Bohr'
  if (IEXPERT == 0) then
    !stop
    call SYSABENDMSG('lucia_util/lucia_ini','Input error','')
  else
    write(u6,*) ' Processing continues (EXPERT mode)'
  end if
end if
! Open one-electron file to obtain core energy and
! Number of MO's and AO's
if ((NOINT == 0) .and. (ENVIRO(1:4) /= 'NONE')) then
  ecore_env = potnuc_molcas
  ECORE = ECORE_ENV
else
  write(u6,*) ' GETOBS and CHK_ORBDIM not called'
  ECORE = Zero
end if
! Check number of orbitals and insert occupations for ALL/REST

#ifdef _DEBUGPRINT_
!***********************************************************
!                                                          *
! Part 3 : Print input                                     *
!                                                          *
!***********************************************************

write(u6,*)
write(u6,*) '*************************************'
write(u6,*) '*  Symmetry and spin of CI vectors  *'
write(u6,*) '*************************************'
write(u6,*)
! Point group
write(u6,'(1X,A)') '     Point group ............ D2H'
! Spatial symmetry
write(u6,'(1X,A,I1)') '     Spatial symmetry ....... ',IREFSM
! Spin
write(u6,'(1X,A,I2)') '     2 times spinprojection  ',MS2
! Number of active electrons
write(u6,'(1X,A,I2)') '     Active electrons .....  ',NACTEL
write(u6,*)
write(u6,*) '*********************************************'
write(u6,*) '*  Shell spaces and occupation constraints  *'
write(u6,*) '*********************************************'
write(u6,*)

!if (XLAMBDA /= One) then
!  write(u6,*)
!  write(u6,'(A,F13.8)') ' Modified operator H(l) = l*F + l*(H-F) used with l =',XLAMBDA
!  !if (IUSEH0P == 0) then
!  write(u6,'(A)') ' Zero-order operator without projection used'
!  !else
!  !  write(u6,'(A)') ' Zero-order operator with projection used'
!  !end if
!  if (IRESTR == 0) then
!    write(u6,*) ' Notice : This madness starts  in second calculation'
!  else
!    write(u6,*) ' You have specified a calculation with modified'
!    write(u6,*) ' Hamiltonian (the LAMBDA option) and RESTART'
!    write(u6,*) ' so this is what I will do'
!    write(u6,*)
!    write(u6,*) '   1:) Perform CI in space 1 to obtain Hamiltonian'
!    write(u6,*) '       (no RESTART in this space)'
!    write(u6,*) '   2:) CI calculation in space 2  with'
!    write(u6,*) '       modified Hamiltonian and RESTART from LU21'
!    write(u6,*) ' Space 2 should therefore correspond to the'
!    write(u6,*) ' restarted calculation'
!  end if
!end if

write(u6,*)
write(u6,*) '***********'
write(u6,*) '*  Roots  *'
write(u6,*) '***********'
write(u6,*)
write(u6,'(1X,A,I3)') '     Number of roots to be included  ',NROOT
!write(u6,'(1X,A,(20I3))') '     Roots to be obtained ',(IROOT(I),I=1,NROOT)
!write(u6,'(1X,A,I3)') '     Number of roots to be converged ',NCNV_RT

write(u6,*)
write(u6,*) '**************************'
write(u6,*) '*  Run time definitions  *'
write(u6,*) '**************************'
write(u6,*)
! Program environment
write(u6,'(A,A6)') '      Program environment... ',ENVIRO

if (NOINT == 1) then
  ! Integral import
  write(u6,'(1X,A)') '     No integrals will be read in'
else if (NOINT == 0) then
  ! Integral storage
  write(u6,'(1X,A)') '     All integrals stored in core'
end if
write(u6,*)
! END IF for NOINT
! CSF or SD expansion
if (NOCSF == 0) then
  write(u6,'(1X,A)') "     CI optimization performed with CSF's"
else
  write(u6,'(1X,A)') "     CI optimization performed with SD's"
end if
! Ms,Ml combinations
if (ISETKW(27) == 1) write(u6,'(1X,A,F8.3)') '     Spin combinations used with sign ',PSSIGN
if (ISETKW(28) == 1) write(u6,'(1X,A,F8.3)') '     ML   combinations used with sign ',PLSIGN
! Initial approximation to vectors
write(u6,*)
!if ((IRESTR == 1) .and. (IRESTRF == 0)) then
if (IRESTR == 1) then
  write(u6,'(1X,A)') '     Restarted calculation'
!else if (IRESTRF == 1) then
!  write(u6,'(1X,A)') '     Restarted calculation from REFERENCE space expansion'
else
  !if (MXP1 /= 0) then
  !  write(u6,'(1X,A)') '     Initial vectors obtained from explicit Hamiltonian'
  !else if (MXP1 == 0) then
  write(u6,'(1X,A)') '     Initial vectors obtained from diagonal'
  !end if
end if
! Handling of degenerencies of initial vectors
!if (INIDEG == 1) then
!  write(u6,'(1X,A)') '     Symmetric combination of degenerate initial vectors'
!else if (INIDEG == -1) then
!  write(u6,'(1X,A)') '     Antiymmetric combination of degenerate initial vectors'
!else if (INIDEG == 0) then
!  write(u6,'(1X,A)') '     No combination of degenerate initial vectors'
!end if
! No calculation, save CI vector information and expand CI vector
if (INOCALC == 1) write(u6,'(1X,A)') ' No calculation will be performed'
if (ISAVE_EXP == 1) write(u6,'(1X,A)') ' Save CI vector information'
if (IEXPAND == 1) write(u6,'(1X,A)') ' Expand shorter CI vector in longer one'
! Ms,Ml combinations
!if (ISETKW(27) == 1) write(u6,'(1X,A,F8.3)') '     Spin combinations used with sign ',PSSIGN
!if (ISETKW(28) == 1) write(u6,'(1X,A,F8.3)') '     ML   combinations used with sign ',PLSIGN
! CI storage mode
write(u6,*)

write(u6,*) '     3 symmetry blocks will be held in core'

if (LCSBLK /= 0) write(u6,'(A,I10)') '      Smallest allowed size of sigma- and C-batch ',LCSBLK
write(u6,'(1X,A,I4)') '     Dimension of block of resolution strings ',MXINKA
!if (IUSE_PH == 1) then
!  WRITE(u6,'(1X,A)') '     Particle-hole separation used'
!else
write(u6,'(1X,A)') '      Particle-hole separation not used'
!end if

if (IADVICE == 1) write(u6,'(1X,A)') '     Advice routine call to optimize sigma generation'

!if (IUSE_PA == 1) then
!  write(u6,'(1X,A)') '     Strings divided into active and passive parts'
!else
write(u6,'(1X,A)') '     Strings not divided into active and passive parts'
!end if
!if (ISIMSYM == 1) write(u6,'(1X,A)') '     ALl TTS blocks with given types treated in sigma'
!if (IUSE_HW == 1) write(u6,*) ' Hardwired routines in use'

write(u6,*)
if (IDENSI == 0) then
  write(u6,'(1X,A)') '     No calculation of density matrices'
else if (IDENSI == 1) then
  write(u6,'(1X,A)') '     One-body density matrix calculated'
else if (IDENSI == 2) then
  write(u6,'(1X,A)') '     One- and two-body density matrices  calculated'
end if
write(u6,*)
!if (MOCAA /= 0) write(u6,*) '     MOC method used for alpha-alpha+beta-beta loop'
!if (MOCAB /= 0) write(u6,*) '     MOC method used for alpha-beta loop'

! Diagonalization information
write(u6,'(1X,A)') '     CI diagonalization :'
write(u6,'(1X,A)') '     ===================='
! Subspace Hamiltinian
!if (MXP1+MXP2+MXQ == 0) then
write(u6,'(1X,A)') '        No subspace Hamiltonian'
!else
!  write(u6,'(1X,A,3I4)') '        Dimensions of subspace Hamiltonian ',MXP1,MXP2,MXQ
!end if
! Diagonalizer
if ((IDIAG == 1) .and. (ICISTR == 1)) then
  write(u6,'(1X,A)') '        Diagonalizer : MINDV4'
else if ((IDIAG == 1) .and. (ICISTR >= 2)) then
  write(u6,'(1X,A)') '        Diagonalizer : MICDV*'
else if (IDIAG == 2) then
  write(u6,'(1X,A)') '        Diagonalizer : PICO*'
end if
write(u6,'(1X,A)') '        Simple diagonal used as preconditioner'
! Root homing
!if (IROOTHOMING == 1) then
!  write(u6,'(1X,A)') '        Root homing will be used'
!else
write(u6,'(1X,A)') '        No root homing'
!end if
! No restart in CI calc 2
if (IRST2 == 0) write(u6,'(1X,A)') '        No restart from previous vectors in second calc'
if (ISKIPEI == 1) then
  write(u6,'(1X,A)') '        Initial energy evaluations skipped after first calc'
  write(u6,'(1X,A)') '        (Only active in connection with TERACI)'
end if
! Number of iterations
!write(u6,'(1X,A,I2)') '        Allowed number of iterations    ',MAXIT
! Number of CI vectors in subspace
write(u6,'(1X,A,I2)') '        Allowed Dimension of CI subspace',MXCIV

write(u6,'(1X,A,ES12.5)') '        Convergence threshold for energy',THRES_E
! Multispace (multigrid info)
!if (MULSPC == 1) then
!  write(u6,'(1X,A,I3)') '        Multispace method in use from space ',IFMULSPC
!  write(u6,*) '        Pattern'
!  call IWRTMA(IPAT,1,LPAT,1,LPAT)
!else
write(u6,'(1X,A)') '        No multispace method in use'
!end if

write(u6,*)
if (IDIAG == 2) then
  !write(u6,'(1X,A,ES12.5)') '        Individual second order energy threshold',E_THRE
  !write(u6,'(1X,A,ES12.5)') '        Individual first order wavefunction threshold',C_THRE
  if (ICLSSEL == 1) then
    write(u6,*)
    write(u6,'(1X,A)') '         Class selection will be performed :'
    write(u6,'(1X,A)') '         ==================================='
    !write(u6,'(1X,A,ES12.5)') '          Total second order energy threshold',E_CONV
    !write(u6,'(1X,A,ES12.5)') '          Total first order wavefunction threshold',C_CONV
  else
    write(u6,'(1X,A)') '            No class selection in iterative procedure'
  end if
end if

!if (IPERT /= 0) then
!  write(u6,'(1X,A)') '     Perturbation calculation'
!  write(u6,'(1X,A)') '     ======================='
!  write(u6,*) '        Root Choosen as zero order state ',IRFROOT
!  !write(u6,*) '        Root used for zero order operator ',IH0ROOT
!  !OLD if (MPORENP == 1) then
!  !OLD   write(u6,*) '        Moller Plesset partitioning'
!  !OLD else if (MPORENP == 2) then
!  !OLD   write(u6,*) '        Epstein-Nesbet partitioning'
!  !OLD else if  (MPORENP == 0) then
!  !OLD   write(u6,*) '        One-body Hamiltonian readin'
!  !OLD end if
!  !if (IE0AVEX == 1) then
!  !  write(u6,*) '        Expectation value of H0 used as zero order energy'
!  !else if (IE0AVEX == 2) then
!  !  write(u6,*) '        Exact energy of reference used as zero order energy'
!  !end if
!  write(u6,*) '        Correction vectors obtained through  order ',NPERT
!  if (IH0SPC == 0) then
!    write(u6,*) '        No restrictions on perturbation interactions'
!  else
!    write(u6,*) '        Perturbation restricted to interactions in subspaces'
!  end if
!
!  if (IH0SPC /= 0) then
!    write(u6,*)
!    write(u6,*) '        Number of perturbation subspaces ',NPTSPC
!    write(u6,*)
!    write(u6,*) '        ========================'
!    write(u6,*) '        Perturbation subspaces :'
!    write(u6,*) '        ========================'
!    do JPTSPC=1,NPTSPC
!      !OLD write(u6,'(A)') ' ======================================================'
!      write(u6,'(A)')
!      write(u6,'(7X,A)') '         Min. occ    Max. occ'
!      write(u6,'(7X,A)') '         ========    ========'
!      do IGAS=1,NGAS
!        write(u6,'(7X,A,I2,3X,I3,9X,I3)') '   GAS',IGAS,IOCPTSPC(1,IGAS,JPTSPC),IOCPTSPC(2,IGAS,JPTSPC)
!      end do
!    end do

!    write(u6,*)
!    write(u6,'(7X,A)') ' ======================================='
!    write(u6,'(7X,A)') ' Approximate Hamiltonian in CI subspaces'
!    write(u6,'(7X,A)') ' ======================================='
!    write(u6,'(7X,A)')
!    write(u6,'(7X,A)') '    Subspace          H(apr)'
!    write(u6,'(7X,A)') '  ============================='
!    write(u6,'(7X,A)')
!    do JPTSPC=1,NPTSPC
!      if (IH0INSPC(JPTSPC) == 1) then
!        write(u6,'(12X,I3,8X,A)') JPTSPC,' Diagonal Fock operator'
!      else if (IH0INSPC(JPTSPC) == 2) then
!        write(u6,'(12X,I3,8X,A)') JPTSPC,' Epstein-Nesbet operator'
!      else if (IH0INSPC(JPTSPC) == 3) then
!        write(u6,'(12X,I3,8X,A)') JPTSPC,' Nondiagonal Fock operator'
!      else if (IH0INSPC(JPTSPC) == 4) then
!        write(u6,'(12X,I3,8X,A)') JPTSPC,' Complete Hamiltonian'
!      else if (IH0INSPC(JPTSPC) == 5) then
!        write(u6,'(12X,I3,8X,A)') JPTSPC,' Mix of Fock and Exact operator'
!      end if
!    end do
!    !if (ISETKW(61) > 0) then
!    !  write(u6,*)
!    !  write(u6,'(7X,A)') ' Orbital subspaces where exact Hamiltonian is used :'
!    !  write(u6,'(7X,A)') '===================================================='
!    !  write(u6,*)
!    !  write(u6,'(10X,10(2X,I3))') (IH0EXSPC(I),I=1,NH0EXSPC)
!    !  write(u6,*)
!    !end if
!
!  end if
!end if

!if (NPROP == 0) then
write(u6,*)
!write(u6,*) '     No calculation of properties'
!else
!  write(u6,'(7X,A,I3)') ' Number of properties to be calculated',NPROP
!  write(u6,*)
!  write(u6,'(9X,A)') ' Properties :'
!  write(u6,'(9X,A)') ' ============'
!  do IPROP=1,NPROP
!    write(u6,'(16X,A)') PROPER(IPROP)
!  end do
!
!  !if (IRELAX == 0) then
!  write(u6,'(7X,A)') ' No use of relaxed densities'
!  !else
!  !  write(u6,'(7X,A)') ' Relaxed densities used for property evaluation'
!  !  write(u6,'(7X,A)') ' (implemented only for pert)'
!  !end if
!end if

!if ((IEXTKOP == 0) .and. (IPTEKT == 0)) then
!  !write(u6,'(5X,A)') " No extended Koopmans' calculations"
!else if (IEXTKOP /= 0) then
!  write(u6,'(5X,A)') " Extended Koopmans' calculations"
!else if (IPTEKT /= 0) then
!  write(u6,'(5X,A)') ' Perturbation expansion of EKT equations'
!end if

!if (IPTFOCK == 1) then
!  write(u6,*) ' Perturbation expansion of Fock matrix'
!else
!  !write(u6,*) 'No  Perturbation expansion of Fock matrix'
!end if

!if (ITRAPRP == 0) then
!  !write(u6,*)
!  !write(u6,'(5X,A)') ' No transition properties will be calculated'
!else
!  write(u6,*)
!  write(u6,'(5X,A)') ' Transition properties will be calculated'
!  !write(u6,*) ' Symmetry of additional states :',IEXCSYM
!  write(u6,*) ' Number   of additional states :',NEXCSTATE
!  write(u6,*)
!end if

!if (IRESPONS /= 0) then
!  write(u6,*)
!  write(u6,*) '**************************'
!  write(u6,*) '*  Response Calculation  *'
!  write(u6,*) '**************************'
!  write(u6,*)
!  write(u6,*) ' CI-Response will be called after each CI calculation'
!  write(u6,*) ' Root used for response calculations (RFROOT) ',IRFROOT
!  write(u6,*)
!  !write(u6,*) ' Number of A-operators : ', N_AVE_OP
!  !write(u6,*) ' Labels of A-operators'
!  !write(u6,*) ' ====================='
!  !write(u6,*)
!  !do IAVE=1,N_AVE_OP
!  !  write(u6,'(1X, 6X,A)') AVE_OP(IAVE)
!  !end do
!  !write(u6,*)
!  !write(u6,*) ' Number of response calculations ', NRESP
!  write(u6,*) ' Perturbations :'
!  write(u6,*) ' ==============='
!  write(u6,*)
!  write(u6,*) ' Calc  Op1    Op2    Mxord1     Mxord2    Freq'
!  do IRESP=1,NRESP
!    write(u6,'(1X,I2,2X,A,A,3X,I4,3X,I4,2X,F12.7)') IRESP,RESP_OP(1,IRESP),RESP_OP(2,IRESP),MAXORD_OP(1,IRESP), &
!                                                    MAXORD_OP(2,IRESP),RESP_W(IRESP)
!  end do
!end if

!if (NOMOFL == 0) then
write(u6,*)
write(u6,'(7X,A)') ' Final orbitals :'
write(u6,'(7X,A)') ' ================'
write(u6,*)
if (IFINMO == 1) then
  write(u6,'(10X,A)') ' Natural orbitals'
else if (IFINMO == 2) then
  write(u6,'(10X,A)') ' Canonical orbitals'
else if (IFINMO == 3) then
  write(u6,'(10X,A)') ' Pseudo-natural orbitals'
  write(u6,'(10X,A)') ' (Density matrix diagonalized in orbital subspaces)'
else if (IFINMO == 4) then
  write(u6,'(10X,A)') ' Pseudo-canonical orbitals'
  write(u6,'(10X,A)') ' (FI+FA  diagonalized in orbital subspaces)'
else if (IFINMO == 5) then
  write(u6,'(10X,A)') ' Pseudo-natural-canonical orbitals (sic)'
  write(u6,'(10X,A)') ' (Pseudo natural orbitals are first obtained'
  write(u6,'(10X,A)') '  by diagonalizing density matrix in orbital subpspaces.'
  write(u6,'(10X,A)') '  FI+FA is transformed to this basis, and the transformed'
  write(u6,'(10X,A)') '  matrix is block diagonalized)'
  write(u6,*)
  !write(u6,'(10X,A)') ' Orbital spaces in which transformed FIFA is diagonalized'
  !write(u6,'(10X,A)') ' ========================================================'
  !do IPSSPC=1,NPSSPC
  !  write(u6,'(A,I2,A,10I4,6X,2I6)') '     SPACE',IPSSPC,'          ',(NPSSH(IRREP,IPSSPC),IRREP=1,NIRREP)
  !end do
end if
!end if
! Transformation of CI vectors
!if (ITRACI == 0) then
!  write(u6,'(5X,A)') ' No transformation of CI vectors'
!else
write(u6,'(5X,A)') ' CI vectors transformed in each run'
write(u6,'(7X,A,A)') ' Complete or restricted rotations :',ITRACI_CR
write(u6,'(7X,A,A)') ' Type of Final orbitals           :',ITRACI_CN
!end if

! Integral Transformations

!if (ITRA_FI == 1) write(u6,*) "      Integrals transformed to final MO's"
!if (ITRA_IN == 1) write(u6,*) "      Integrals transformed to initial MO's"

! Print levels

write(u6,*)
write(u6,'(1X,A,ES18.9)') '      Core energy : ',ECORE

!if (IDMPIN == 1) then
!  write(u6,'(1X,A)')
!  write(u6,*) '      Integrals written in formatted form (ES22.15)'
!  write(u6,*) '      on file 90'
!end if

write(u6,*) ' IPART before leaving READIN = ',IPART
#endif

! =============================================
!  Find largest unused vector for use in Lucia
! =============================================

! Allocate memory for lucia
! Set up string info

call lucia()

end subroutine Lucia_Ini

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Jie J. Bao                                       *
************************************************************************
        Subroutine MSPDFTGrad_Misc(LHRot)
********This subroutine does miscellaneous things needed
********in MS-PDFT gradient calculation.
#include "WrkSpc.fh"
#include "wadr.fh"
#include "rasdim.fh"
#include "warnings.h"
#include "input_ras_mcpdft.fh"
#include "rasscf.fh"
#include "general.fh"
#include "mspdft.fh"

      INTEGER LHRot,ij,iS,jRoot,iBas,jBas
      Real*8 RIK2

      Call Put_DArray('MS_FINAL_ROT    ',Work(LHRot),     lRoots**2)
      CALL Put_DArray('F1MS            ',Work(iF1MS),  nTot1*nRoots)
      CALL Put_DArray('F2MS            ',Work(iF2MS), NACPR2*nRoots)
      CALL Put_DArray('D1AO_MS         ',Work(D1AOMS), nTot1*nRoots)
      if (ispin.ne.1)
     &CALL Put_DArray('D1SAO_MS        ',Work(D1SAOMS),nTot1*nRoots)


**********Fock_Occ Part
      CALL FZero(Work(ipFocc),ntot1)
      DO JRoot=1,lRoots
      CALL daXpY_(ntot1,Work(LHRot+(irlxroot-1)*lRoots+jRoot-1)**2,
     &           Work(iFocMS+(JRoot-1)*nTot1),1,Work(ipFocc),1)
      END DO
      Call Put_Fock_Occ(Work(ipFocc),ntot1)
**********Now storing the density matrix needed for computing 1RDM
**********First rescale the off-diagonal elements as done in
**********integral_util/prep.f
      ij=-1
      Do iS=1,nSym
       do iBas=1,nBas(iS)
       do jBas=1,iBas-1
        ij=ij+1
        do jRoot=1,nRoots+1
         Work(iDIDA+ij+(jRoot-1)*nTot1)=0.5D0*
     &   Work(iDIDA+ij+(jRoot-1)*nTot1)
        end do
       end do
       ij=ij+1
       end do
      End Do
**********Then add the matrix for each state to the ground state
**********add put the ground state one in the runfile. Do not
**********forget to multiply the (R_IK)^2, where K is "jRoot" below
      RIK2=Work(LHRot+(irlxroot-1)*lRoots)**2
      CALL DScal_(nTot1,-RIK2,Work(iDIDA),1)
      CALL DScal_(nTot4,RIK2,Work(iFxyMS),1)
      CALL DScal_(NACPR2,RIK2,Work(iP2MOt),1)
      ij=0
      jRoot=1
********Work(LHRot+(iRlxRoot-1)*lRoots) should give me R_I1
      Do jRoot=2,lRoots
      ij=0
       RIK2=Work(LHRot+(irlxroot-1)*lRoots+jRoot-1)**2
*******DIDA for prepp
       CALL DaXpY_(nTot1,-RIK2,
     &            Work(iDIDA+(jRoot-1)*nTot1),1,Work(iDIDA),1)
*******FT99 for bk
       CALL DaXpY_(nTot4,RIK2,
     &            Work(iFxyMS+(jRoot-1)*nTot4),1,Work(iFxyMS),1)
*******P2MOt for active 2RDM
       CALL DaXpY_(NACPR2,RIK2,
     &            Work(IP2MOt+(jRoot-1)*NACPR2),1,Work(iP2MOt),1)
      End Do
********Work(iDIDA) is currently DA over intermediate states
      CALL Put_DArray('MSPDFTD6        ',Work(iDIDA),nTot1)
********Work(iDIDA+lRoots*nTot1) is currently DI
      CALL Put_DArray('MSPDFTD5        ',
     &                 Work(iDIDA+lRoots*nTot1),nTot1)
      CALL Put_DArray('FxyMS           ',Work(iFxyMS), nTot4)
      Call Put_P2MOt(Work(iP2MOt),NACPR2)
      RETURN
      End Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine o12sa3_cvb(vec,cvb,orbs,civec,civecp,civb,cvbdet,nparm1)

use casvb_global, only: ndet, ndetvb, norb, nprorb, nvb, strucopt
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nparm1
real(kind=wp), intent(out) :: vec(nparm1), cvbdet(ndetvb)
real(kind=wp), intent(_IN_) :: cvb(nvb)
real(kind=wp), intent(in) :: orbs(norb,norb)
real(kind=wp), intent(inout) :: civec(0:ndet), civecp(0:ndet), civb(0:ndet)
integer(kind=iwp) :: ic1
real(kind=wp), allocatable :: vec_all(:)
real(kind=wp), external :: ddot_

call makegjorbs_cvb(orbs)

call str2vbc_cvb(cvb,cvbdet)
call vb2cic_cvb(cvbdet,civb)

call makecivecp_cvb(civec,civecp,orbs)
call ci2vbg_cvb(civecp,cvbdet)
call mma_allocate(vec_all,nparm1,label='vec_all')
call vb2strg_cvb(cvbdet,vec_all(nprorb+1))
vec_all(1:nprorb) = Zero
call onedens_cvb(civb,civecp,vec_all,.false.,0)
! If no optimization of structure coefficients we are doing "Augmented" calc:
if (strucopt) then
  ic1 = 1
else
  ic1 = 2
end if
call all2free_cvb(vec_all,vec(ic1),1)
if (.not. strucopt) vec(1) = ddot_(nvb,cvb,1,vec_all(nprorb+1:),1)
call mma_deallocate(vec_all)
call ddrhs_cvb(vec,nparm1,0)

call str2vbc_cvb(cvb,cvbdet)
call vb2cic_cvb(cvbdet,civb)

return

end subroutine o12sa3_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_interface

use fmm_global_paras, only: INTK, REALK, LUPRI, LUINTM, fmm_basis, fmm_sh_pairs, scheme_paras, GFC_FMM, Zero, One, Two, Half
implicit none
private
! Public procedures
public :: fmm_initial, &
          fmm_final, &
          fmm_get_J_matrix, &
          fmm_get_boundary_potential
          !fmm_get_boundary_potential,   &
          !fefmm_get_J_matrix

type(fmm_basis), save :: basis

contains

!-------------------------------------------------------------------------------

! integer(INTK) :: NAtom    =  number of atoms
! integer(INTK) :: NShel    =  number of shells
! integer(INTK) :: NPrim    =  number of primitive exponents
! integer(INTK) :: NBF_Car  =  dimension of AO Fock matrix

! integer(INTK) :: MaxAngl  =  maximum angular momentum primitive
! integer(INTK) :: MaxSgm2  =  maximum number of primitive pairs in any AO-pair

! integer(INTK) :: KAtom(NShel)     =  map from shells to atoms
! integer(INTK) :: KType(NShel)     =  angular momentum of shell
! integer(INTK) :: KStart(NShel)    =  first primitive in this shell
! integer(INTK) :: KontG(NShel)     =  number of primitives in this shell
! integer(INTK) :: KLoc_Car(NShel)  =  first (contracted) AO in this shell -1

! real(REALK)   :: Centr(3,NAtom)   =  array of atomic positions
! real(REALK)   :: Expnt(NPrim)     =  primitive exponents
! real(REALK)   :: CCoef(NPrim)     =  contraction coefficients (normalized)

!-------------------------------------------------------------------------------

subroutine fmm_initial(NAtom,NShel,NPrim,NBF_Car,MaxAngl,MaxSgm2,KAtom,KType,KStart,KontG,KLoc_Car,Centr,Expnt,CCoef,mode)

  use fmm_scheme_builder, only: fmm_init_scheme, fmm_get_scheme
  use fmm_shell_pairs, only: fmm_get_shell_pairs

  implicit none
  integer(INTK), intent(in) :: NAtom, NShel, NPrim, NBF_Car
  integer(INTK), intent(in) :: MaxSgm2, MaxAngl, mode
  integer(INTK), intent(in) :: KAtom(NShel)
  integer(INTK), intent(in) :: KType(NShel)
  integer(INTK), intent(in) :: KStart(NShel)
  integer(INTK), intent(in) :: KontG(NShel)
  integer(INTK), intent(in) :: KLoc_Car(NShel)
  real(REALK), intent(in)   :: Centr(3,NAtom)
  real(REALK), intent(in)   :: Expnt(NPrim)
  real(REALK), intent(in)   :: CCoef(NPrim)

  type(fmm_sh_pairs), pointer :: sh_pairs(:)
  type(scheme_paras), pointer :: scheme
  integer(INTK) :: lmax

  ! Initialise FMM run-type parameters
  call fmm_init_scheme(mode)
  call fmm_get_scheme(scheme)
  lmax = scheme%raw_lmax

  ! Initialise basis set information
  call fmm_init_basis(NAtom,NShel,NPrim,NBF_Car,MaxAngl,lmax,maxsgm2,KAtom,KType,KStart,KontG,KLoc_Car,Centr,Expnt,CCoef)

  ! Get list of non-vanishing shell pairs
  call fmm_get_shell_pairs(basis,sh_pairs)

  ! Build and store on disk density-independent integral components
  select case (mode)
    !case (FE_FMM)
    !  call fmm_init_fefmm(scheme,basis,lmax,sh_pairs)
    case default
      call fmm_init_md4fmm(basis,lmax,sh_pairs)
  end select

  nullify(sh_pairs)

end subroutine fmm_initial

!-------------------------------------------------------------------------------

subroutine fmm_init_md4fmm(basis,lmax,sh_pairs)

  use fmm_multipole_ints, only: fmm_init_multipole_ints, &
                                fmm_free_multipole_ints, &
                                fmm_build_multipoles

  implicit none
  type(fmm_basis), intent(in)    :: basis
  type(fmm_sh_pairs), intent(in) :: sh_pairs(:)
  integer(INTK), intent(in)      :: lmax

  call fmm_init_multipole_ints(basis,lmax)
  call fmm_build_multipoles(basis,lmax,sh_pairs)
  call fmm_free_multipole_ints()

end subroutine fmm_init_md4fmm

!-------------------------------------------------------------------------------

subroutine fmm_get_J_matrix(nBas,dens,fockAO)

  use fmm_driver, only: fmm_build_J_matrix

  implicit none
  integer(INTK), intent(in)  :: nBas
  real(REALK), intent(in)    :: dens(nBas*(nBas+1)/2)
  real(REALK), intent(inoUt) :: fockAO(nBas*(nBas+1)/2)

  character(len=*), parameter :: FName = 'multipoles'
  character(len=255) :: FBuf
  real(REALK) :: J_matrix(nBas,nBas)
  real(REALK) :: sq_dens(nBas,nBas)
  integer(INTK) :: i, j, ij
  integer(INTK), external :: IsFreeUnit

  ! Write null header file for nuclear moments (not computed!)
  FBuf = trim(FName)//'.fmm2header'
  LUINTM = IsFreeUnit(LUINTM)
  open(unit=LUINTM,file=trim(FBuf),status='REPLACE',access='SEQUENTIAL',form='UNFORMATTED')
  write(LUINTM) 0
  close(unit=LUINTM,status='KEEP')

  sq_dens(:,:) = zero
  ij = 0
  do j=1,nBas
    do i=1,j
      ij = ij+1
      sq_dens(i,j) = two*dens(ij)
      sq_dens(j,i) = sq_dens(i,j)
    end do
    sq_dens(j,j) = half*sq_dens(j,j)
  end do

  call fmm_build_J_matrix('TWO_EL',sq_dens,J_matrix)

  ij = 0
  do j=1,nBas
    do i=1,j
      ij = ij+1
      fockAO(ij) = fockAO(ij)+J_matrix(i,j)
    end do
  end do

end subroutine fmm_get_J_matrix

!-------------------------------------------------------------------------------

subroutine fmm_get_boundary_potential(npoints,nBas,coor,dens,potential)

  use fmm_stats, only: stat_points
  use fmm_scheme_builder, only: fmm_get_scheme
  use fmm_driver, only: fmm_get_multipole_potential
  !use fmm_boxed_multipole_ints, only: fmm_pack_boxed_mpoles
  use fmm_utils, only: fmm_matrix_norm

  implicit none
  integer(INTK), intent(in) :: npoints, nBas
  real(REALK), intent(in)   :: coor(3,npoints)
  real(REALK), intent(in)   :: dens(nBas*(nBas+1)/2)
  real(REALK), intent(out)  :: potential(npoints)

  type(scheme_paras), pointer :: scheme
  real(REALK) :: sq_dens(nBas,nBas)
  real(REALK) :: Vtmp(1,npoints)
  !real(REALK) :: dummy_dens(1,1) = one
  integer(INTK) :: i, j, ij

  stat_points = npoints

  sq_dens(:,:) = zero
  ij = 0
  do j=1,nBas
    do i=1,j
      ij = ij+1
      sq_dens(i,j) = two*dens(ij)
      sq_dens(j,i) = sq_dens(i,j)
    end do
    sq_dens(j,j) = half*sq_dens(j,j)
  end do

  call fmm_get_scheme(scheme)
  ! Pack moments (with density) to reduce memory in FMM readin
  !call fmm_pack_boxed_mpoles(scheme%raw_lmax,nBas,sq_dens)

  ! Rewrite files for LHS potential grid points
  call fmm_initialise_gfc_grid(npoints,coor)

  !call fmm_get_multipole_potential(GFC_FMM,dummy_dens,Vtmp)
  call fmm_get_multipole_potential(GFC_FMM,sq_dens,Vtmp)
  potential(:) = Vtmp(1,:)
  call fmm_matrix_norm('fmm_V',potential,npoints)

end subroutine fmm_get_boundary_potential

!-------------------------------------------------------------------------------

subroutine fmm_initialise_gfc_grid(npoints,coor)

  implicit none
  integer(INTK), intent(in) :: npoints
  real(REALK), intent(in)   :: coor(3,npoints)

  character(len=*), parameter :: FName = 'multipoles'
  character(len=255) :: FBuf
  integer(INTK) :: i
  integer(INTK), external :: IsFreeUnit

  ! Write grid points to disk
  FBuf = trim(FName)//'.fmm2'
  LUINTM = IsFreeUnit(LUINTM)
  open(unit=LUINTM,file=trim(FBuf),status='REPLACE',access='SEQUENTIAL',FORM='UNFORMATTED')
  rewind(LUINTM)
  do i=1,npoints
    write(LUINTM) 0,0,0,0,0,coor(1,i),coor(2,i),coor(3,i),one
  end do
  close(unit=LUINTM,status='KEEP')

  ! Write header file
  FBuf = trim(FName)//'.fmm2header'
  LUINTM = IsFreeUnit(LUINTM)
  open(unit=LUINTM,file=trim(FBuf),status='REPLACE',access='SEQUENTIAL',form='UNFORMATTED')
  write(LUINTM) npoints
  close(unit=LUINTM,status='KEEP')

end subroutine fmm_initialise_gfc_grid

!-------------------------------------------------------------------------------

subroutine fmm_init_basis(NAtom,NShel,NPrim,NBF_Car,MaxAngl,lmax,maxsgm2,KAtom,KType,KStart,KontG,KLoc_Car,Centr,Expnt,CCoef)

  implicit none
  integer(INTK), intent(IN) :: NAtom, NShel, NPrim, NBF_Car
  integer(INTK), intent(IN) :: MaxAngl, lmax, maxsgm2
  integer(INTK), intent(IN) :: KAtom(NShel)
  integer(INTK), intent(IN) :: KType(NShel)
  integer(INTK), intent(IN) :: KStart(NShel)
  integer(INTK), intent(IN) :: KontG(NShel)
  integer(INTK), intent(IN) :: KLoc_Car(NShel)
  real(REALK), intent(IN)   :: Centr(3,NAtom)
  real(REALK), intent(IN)   :: Expnt(NPrim)
  real(REALK), intent(IN)   :: CCoef(NPrim)

  integer(INTK), allocatable :: tmp(:)
  integer(INTK) :: IL, It, Iu, Iv, Ituv, ii
  integer(INTK) :: Maxtuv, MaxLtuv

  Maxtuv = max(MaxAngl,lmax)
  MaxLtuv = (Maxtuv+1)*(Maxtuv+2)*(Maxtuv+3)/6

  allocate(basis%Centr(3,NAtom))
  allocate(basis%KAtom(NShel))
  allocate(basis%KType(NShel))
  allocate(basis%KStart(NShel))
  allocate(basis%KontG(NShel))
  allocate(basis%KLoc_Car(NShel))
  allocate(basis%Expnt(NPrim))
  allocate(basis%CCoef(NPrim))
  allocate(basis%LtuvMin_Car(0:Maxtuv))
  allocate(basis%LtuvMax_Car(0:Maxtuv))
  allocate(basis%Lt(MaxLtuv))
  allocate(basis%Lu(MaxLtuv))
  allocate(basis%Lv(MaxLtuv))

  basis%nshells = NShel
  basis%nbas = NBF_Car
  basis%maxangl = MaxAngl
  basis%maxsgm2 = MaxSgm2
  basis%Centr(:,:) = Centr(:,:)
  basis%KAtom(:) = KAtom(:)
  basis%KType(:) = KType(:)
  basis%KStart(:) = KStart(:)
  basis%KontG(:) = KontG(:)
  basis%KLoc_Car(:) = KLoc_Car(:)
  basis%Expnt(:) = Expnt(:)
  basis%CCoef(:) = CCoef(:)

  ! Now initialise LtuvMin_Car, LtuvMax_Car, Lt, Lu, Lv

  allocate(tmp(0:Maxtuv))
  tmp(0) = 1
  basis%LtuvMin_Car(0) = 1
  basis%LtuvMax_Car(0) = 1
  do IL=1,Maxtuv
    tmp(IL) = (IL+1)*(IL+2)/2
    basis%LtuvMin_Car(IL) = basis%LtuvMin_Car(IL-1)+tmp(IL-1)
    basis%LtuvMax_Car(IL) = basis%LtuvMax_Car(IL-1)+tmp(IL)
  end do

  Ituv = 0
  do IL=0,Maxtuv
    do It=Maxtuv,0,-1
      do Iu=Maxtuv,0,-1
        do Iv=Maxtuv,0,-1
          if (It+Iu+Iv == IL) then
            Ituv = Ituv+1
            basis%Lt(Ituv) = It
            basis%Lu(Ituv) = Iu
            basis%Lv(Ituv) = Iv
          end if
        end do
      end do
    end do
  end do
  deallocate(tmp)

  return

  ! Print section
  write(LUPRI,*) '------------'
  write(LUPRI,*) 'NAtom',NAtom
  write(LUPRI,*) 'NShel',NShel
  write(LUPRI,*) 'NPrim',NPrim
  write(LUPRI,*) 'NBF_Car',NBF_Car
  write(LUPRI,*) '------------'
  write(LUPRI,*) 'Maxangl',MaxAngl
  write(LUPRI,*) 'Maxsgm2',MaxSgm2
  write(LUPRI,*) '------------'
  write(LUPRI,*) 'katom:'
  do ii=1,nshel
    write(LUPRI,*) ii,KAtom(ii)
  end do
  write(LUPRI,*) '------------'
  write(LUPRI,*) 'ktype:'
  do ii=1,nshel
    write(LUPRI,*) ii,KType(ii)
  end do
  write(LUPRI,*) '------------'
  write(LUPRI,*) 'kstart:'
  do ii=1,nshel
    write(LUPRI,*) ii,KStart(ii)
  end do
  write(LUPRI,*) '------------'
  write(LUPRI,*) 'kontg:'
  do ii=1,nshel
    write(LUPRI,*) ii,KontG(ii)
  end do
  write(LUPRI,*) '------------'
  write(LUPRI,*) 'kloc_car:'
  do ii=1,nshel
    write(LUPRI,*) ii,KLoc_Car(ii)
  end do
  write(LUPRI,*) '------------'
  write(LUPRI,*) 'expnt:'
  do ii=1,nprim
    write(LUPRI,*) ii,Expnt(ii)
  end do
  write(LUPRI,*) '------------'
  write(LUPRI,*) 'ccoef:'
  do ii=1,nprim
    write(LUPRI,*) ii,CCoef(ii)
  end do
  write(LUPRI,*) '------------'

end subroutine fmm_init_basis

!-------------------------------------------------------------------------------

subroutine fmm_final()

  use fmm_shell_pairs, only: fmm_free_shell_pairs
  implicit none

  deallocate(basis%Centr)
  deallocate(basis%KAtom)
  deallocate(basis%KType)
  deallocate(basis%KStart)
  deallocate(basis%KontG)
  deallocate(basis%KLoc_Car)
  deallocate(basis%Expnt)
  deallocate(basis%CCoef)
  deallocate(basis%LtuvMin_Car)
  deallocate(basis%LtuvMax_Car)
  deallocate(basis%Lt)
  deallocate(basis%Lu)
  deallocate(basis%Lv)
  call fmm_free_shell_pairs()

end subroutine fmm_final

!-------------------------------------------------------------------------------

end module fmm_interface

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine Get_Int_Close()

use GetInt_mod, only: LuCVec, Vec2
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i

! Close files.
do i=1,2
  if (LuCVec(i) /= -1) then
    call DACLOS(LuCVec(i))
    LuCVec(i) = -1
  end if
end do

call mma_deallocate(Vec2,safe='*')

end subroutine Get_Int_Close

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1987, Per Ake Malmqvist                                *
!               2018, Jesper Norell                                    *
!               2018, Joel Creutzberg                                  *
!               2023, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine SODYSORB(NSS,USOR,USOI,DYSAMPS,NZ,SOENE)

use Index_Functions, only: nTri_Elem
use rassi_global_arrays, only: JBNUM, SFDYS, SODYSAMPS, SODYSAMPSI, SODYSAMPSR
use OneDat, only: sNoNuc, sNoOri
use Cntrl, only: DYSEXPORT, DYSEXPSO, MLTPLT, NSTATE
use Symmetry_Info, only: nIrrep
use rassi_data, only: NBASF
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSS, NZ
real(kind=wp), intent(in) :: USOR(NSS,NSS), USOI(NSS,NSS), DYSAMPS(NSTATE,NSTATE), SOENE(NSS)
integer(kind=iwp) :: ICMP, IEIG, IOPT, IRC, ISTATE, ISY, ISYLAB, JEIG, JOB1, JSTATE, LUNIT, MPLET1, MSPROJ, NB, NDUM, NOFF, NSZZ, &
                     ORBNUM, SFI, SFJ, SFTOT, SODYSCIND, SOTOT, ZI, ZJ
real(kind=wp) :: AMPLITUDE, CII, CIMAG, CIR, CJI, CJR, CREAL, MSPROJI, MSPROJJ
character(len=80) :: TITLE
character(len=30) :: Filename
character(len=8) :: Label
integer(kind=iwp), allocatable :: SO2SF(:)
real(kind=wp), allocatable :: AMPS(:), DYSEN(:), MSPROJS(:), SODYSCMOI(:), SODYSCMOR(:), SODYSCOFSI(:), SODYSCOFSR(:), SZZ(:), &
                              SZZFULL(:,:)
integer(kind=iwp), external :: IsFreeUnit

! +++ J.Norell 2018

! Calculates spin-orbit Dyson orbitals
! The routine was in some part adapted from DO_SONATORB

! Computes SO Dyson amplitudes by expanding the SF results with
! the SO eigenvectors (of the complex Hamiltonian)
! 1. (Fast): Compute the SO amplitudes directly from the SF amplitudes
!    (approximation) for all states
! 2. (Slower): Compute the full SO Dyson orbitals for the requested
!    initial states and export them to .molden format. SO amplitudes
!    are correctly calculated for these states.

! IFG: Added DysOrb export, not sure it's correct

! ****************************************************************

! Setup SO2SF list which contains the original SF state numbers
! as a function of the SO state number
! And MSPROJS which saves their ms projections for later use

call mma_allocate(SO2SF,NSS,Label='SO2SF')
call mma_allocate(MSPROJS,NSS,Label='MSPROJS')
SOTOT = 0
SFTOT = 0
do ISTATE=1,NSTATE
  JOB1 = JBNUM(ISTATE)
  MPLET1 = MLTPLT(JOB1)
  SFTOT = SFTOT+1

  do MSPROJ=-MPLET1+1,MPLET1-1,2
    SOTOT = SOTOT+1
    SO2SF(SOTOT) = SFTOT
    MSPROJS(SOTOT) = MSPROJ

  end do ! DO MSPROJ1=-MPLET1+1,MPLET1-1,2
end do ! DO ISTATE=1,NSTATE

if (.not. DYSEXPORT) then ! Approximative amplitude calculation

  ! Now construct the SF dysamps in the multiplicity expanded basis
  ! (initially all real, therefore put into SODYSAMPSR)
  SODYSAMPSR(:,:) = Zero
  SODYSAMPSI(:,:) = Zero
  do JSTATE=1,NSS
    do ISTATE=JSTATE+1,NSS
      SFJ = SO2SF(JSTATE)
      SFI = SO2SF(ISTATE)
      SODYSAMPSR(JSTATE,ISTATE) = DYSAMPS(SFJ,SFI)
      SODYSAMPSR(ISTATE,JSTATE) = DYSAMPS(SFJ,SFI)
    end do
  end do

  ! Now perform the transformation from SF dysamps to SO dysamps
  ! by combining the multiplicity expanded SF dysamps with the
  ! SO eigenvector in the ZTRNSF routine.
  call ZTRNSF(NSS,USOR,USOI,SODYSAMPSR,SODYSAMPSI)

  ! Compute the magnitude of the complex amplitudes as an approximation
  SODYSAMPSR(:,:) = SODYSAMPSR*SODYSAMPSR
  SODYSAMPSI(:,:) = SODYSAMPSI*SODYSAMPSI
  SODYSAMPS(:,:) = sqrt(SODYSAMPSR+SODYSAMPSI)

end if ! Approximative amplitude calculation

! ****************************************************************

if (DYSEXPORT) then

  ! Export part of the routine and exact calculation of amplitudes

  ! Read in the atomic overlap matrix, that will be needed below for
  ! for normalization of DOs
  ! (Code from mksxy)
  NSZZ = sum(nTri_Elem(NBASF(1:nIrrep)))
  call mma_allocate(SZZ,NSZZ,Label='SZZ')
  IRC = -1
  IOPT = ibset(ibset(0,sNoOri),sNoNuc)
  ICMP = 1
  ISYLAB = 1
  Label = 'MLTPL  0'
  call RDONE(IRC,IOPT,Label,ICMP,SZZ,ISYLAB)
  if (IRC /= 0) then
    write(u6,*)
    write(u6,*) '      *** ERROR IN SUBROUTINE SODYSORB ***'
    write(u6,*) '     OVERLAP INTEGRALS ARE NOT AVAILABLE'
    write(u6,*)
    call ABEND()
  end if

  call mma_allocate(SZZFULL,NZ,NZ,Label='SZZFULL')

  ! SZZ is originally given in symmetry-blocked triangular form,
  ! lets make it a full matrix for convenience
  SZZFULL(:,:) = Zero
  NDUM = 1
  NOFF = 0
  do ISY=1,nIrrep
    NB = NBASF(ISY)
    do ZJ=1,NB
      do ZI=1,ZJ
        SZZFULL(ZJ+NOFF,ZI+NOFF) = SZZ(NDUM)
        SZZFULL(ZI+NOFF,ZJ+NOFF) = SZZ(NDUM)
        NDUM = NDUM+1
      end do
    end do
    NOFF = NOFF+NB
  end do
  call mma_deallocate(SZZ)

  ! ****************************************************************

  ! Multiply together with the SO eigenvector coefficients with the SF
  ! Dyson orbital coefficients in the atomic basis to obtain the full
  ! SO Dyson orbitals

  ! Multiply together with the SO eigenvector coefficients with the SF
  ! Dyson orbital coefficients in the atomic basis to obtain
  ! SO Dyson orbitals

  call mma_allocate(SODYSCMOR,NZ*NSS,Label='SODYSCMOR')
  call mma_allocate(SODYSCMOI,NZ*NSS,Label='SODYSCMOI')
  call mma_allocate(AMPS,NSS,Label='AMPS')
  call mma_allocate(DYSEN,NSS,Label='DYSEN')
  call mma_allocate(SODYSCOFSR,NZ,Label='SODYSCOFSR')
  call mma_allocate(SODYSCOFSI,NZ,Label='SODYSCOFSI')

  SODYSAMPS(:,:) = Zero
  ! For all requested initial states J and all final states I
  do JSTATE=1,DYSEXPSO

    ! For each initial state JSTATE up to DYSEXPSFSO we will
    ! gather all the obtained Dysorbs
    ! and export to a shared .molden file
    SODYSCIND = 0 ! Orbital coeff. index
    ORBNUM = 0 ! Dysorb index for given JSTATE
    SODYSCMOR(:) = Zero ! Real orbital coefficients
    SODYSCMOI(:) = Zero ! Imaginary orbital coefficients
    DYSEN(:) = Zero ! Orbital energies
    AMPS(:) = Zero ! Transition amplitudes (shown as occupations)

    do ISTATE=JSTATE+1,NSS

      ! Reset values for next state combination
      SODYSCOFSR(:) = Zero
      SODYSCOFSI(:) = Zero

      ! Iterate over the eigenvector components of both states
      do JEIG=1,NSS

        ! Coefficient of first state
        CJR = USOR(JEIG,JSTATE)
        CJI = USOI(JEIG,JSTATE)
        ! Find the corresponding SF states
        SFJ = SO2SF(JEIG)

        do IEIG=1,NSS

          ! Coefficient of second state
          CIR = USOR(IEIG,ISTATE)
          CII = USOI(IEIG,ISTATE)
          ! Find the corresponding SF states
          SFI = SO2SF(IEIG)

          ! Check change in ms projection
          MSPROJJ = MSPROJS(JEIG)
          MSPROJI = MSPROJS(IEIG)
          ! Check |delta ms|=0.5 selection rule
          if (abs(MSPROJJ-MSPROJI) /= 1) cycle

          if (DYSAMPS(SFJ,SFI) > 1.0e-5_wp) then
            ! Multiply together coefficients
            CREAL = CJR*CIR+CJI*CII
            CIMAG = CJR*CII-CJI*CIR
            ! Multiply with the corresponding SF Dyson orbital
            SODYSCOFSR(:) = SODYSCOFSR(:)+CREAL*SFDYS(:,SFJ,SFI)
            SODYSCOFSI(:) = SODYSCOFSI(:)+CIMAG*SFDYS(:,SFJ,SFI)
          end if

        end do ! IEIG
      end do ! JEIG

      ! Normalize the overlap of SODYSCOFS expanded orbitals with the
      ! atomic overlap matrix SZZ to obtain correct amplitudes

      AMPLITUDE = Zero

      do ZI=1,NZ
        AMPLITUDE = AMPLITUDE+sum(SZZFULL(:,ZI)*(SODYSCOFSR(:)*(SODYSCOFSR(ZI)-SODYSCOFSI(ZI))+ &
                                                 SODYSCOFSI(:)*(SODYSCOFSR(ZI)+SODYSCOFSI(ZI))))
      end do ! ZI

      AMPLITUDE = sqrt(AMPLITUDE)
      SODYSAMPS(JSTATE,ISTATE) = AMPLITUDE
      SODYSAMPS(ISTATE,JSTATE) = AMPLITUDE

      ! Export Re and Im part of the coefficients
      if (AMPLITUDE > 1.0e-5_wp) then
        SODYSCMOR(SODYSCIND+1:SODYSCIND+NZ) = SODYSCOFSR(:)
        SODYSCMOI(SODYSCIND+1:SODYSCIND+NZ) = SODYSCOFSI(:)
        SODYSCIND = SODYSCIND+NZ
        ORBNUM = ORBNUM+1
        DYSEN(ORBNUM) = SOENE(ISTATE)-SOENE(JSTATE)
        AMPS(ORBNUM) = AMPLITUDE*AMPLITUDE
      end if

    end do ! ISTATE

    ! If at least one orbital was found, export it/them
    if (ORBNUM > 0) then
      write(filename,'(A,I0,A3)') 'MD_DYS.SO.',JSTATE,'.Re'
      call Molden_DysOrb(filename,DYSEN,AMPS,SODYSCMOR,ORBNUM,NZ)
      write(filename,'(A,I0,A3)') 'MD_DYS.SO.',JSTATE,'.Im'
      call Molden_DysOrb(filename,DYSEN,AMPS,SODYSCMOI,ORBNUM,NZ)

      ! This does not work for SO-Dyson orbitals, because they may
      ! contain contributions from several irreps.
      ! Either that's a bug elsewhere in the code, or the InpOrb
      ! format is not adequate for these orbitals.
      write(filename,'(A,I0,A3)') 'DYSORB.SO.',JSTATE,'.Re'
      LUNIT = IsFreeUnit(50)
      write(TITLE,'(A,I0,A)') '* Spin-orbit Dyson orbitals for state ',JSTATE,' (real part)'
      call WRVEC_DYSON(filename,LUNIT,nIrrep,NBASF,ORBNUM,SODYSCMOR,AMPS,DYSEN,trim(TITLE),NZ)
      write(filename,'(A,I0,A3)') 'DYSORB.SO.',JSTATE,'.Im'
      write(TITLE,'(A,I0,A)') '* Spin-orbit Dyson orbitals for state ',JSTATE,' (imaginary part)'
      call WRVEC_DYSON(filename,LUNIT,nIrrep,NBASF,ORBNUM,SODYSCMOI,AMPS,DYSEN,trim(TITLE),NZ)
      close(LUNIT)
    end if

  end do ! JSTATE

end if

call mma_deallocate(SODYSCMOR)
call mma_deallocate(SODYSCMOI)
call mma_deallocate(AMPS)
call mma_deallocate(DYSEN)
call mma_deallocate(SODYSCOFSR)
call mma_deallocate(SODYSCOFSI)
call mma_deallocate(SZZFULL)

! ****************************************************************

! Free all the allocated memory

call mma_deallocate(SO2SF)
call mma_deallocate(MSPROJS)

end subroutine SODYSORB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003, Valera Veryazov                                  *
!               1998,2022, Roland Lindh                                *
!***********************************************************************

subroutine SOrb(LuOrb,SIntTh,iTerm)
!***********************************************************************
!                                                                      *
!     purpose: Get starting orbitals from:                             *
!              -1) default choice                                      *
!               0) diagonalizaton of the core                          *
!               1) via intermediate calculation of HF AOs              *
!               2) input orbitals                                      *
!               3) input density matrix                                *
!                                                                      *
!***********************************************************************

use InfSCF, only: CMO, DoCholesky, EOrb, FockAO, InVec, KSDFT, nBas, nBB, nBB, nBT, nD, nnB, nOrb, nSym, OccNo, One_Grid, OneHam, &
                  Ovrlp, SCF_FileOrb, ScrFac, Scrmbl, StVec, TrM
#ifdef _HDF5_
use mh5, only: mh5_close_file
use InfSCF, only: FileOrb_ID, IsHDF5
#endif
use SCFFiles, only: LuOut
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: LuOrb
real(kind=wp), intent(inout) :: SIntTh
integer(kind=iwp), intent(out) :: iTerm
integer(kind=iwp) :: iD, IsUHF, nData
logical(kind=iwp) :: found, FstItr, Retry
character(len=512) :: FName
character(len=80) :: KSDFT_save

call DecideonCholesky(DoCholesky)
! Cholesky and NDDO are incompatible
if (DoCholesky .and. (InVec == 1)) then
  call WarningMessage(1,' In SORB: Cholesky and NDDO not implemented !!!;  NDDO option ignored')
  InVec = -1
end if

! Is default clause chosen?

if (InVec == -1) then
  call qpg_darray('SCF orbitals',found,ndata)
  if (found .and. (nData == nBB)) then
    call qpg_darray('OrbE',found,ndata)
    if (found) InVec = 8
  end if
end if
if (InVec == -1) then
  call qpg_darray('Guessorb',found,ndata)
  if (found .and. (nData == nBB)) then
    call qpg_darray('Guessorb energies',found,ndata)
    if (found) InVec = 9
  end if
end if
if (InVec == -1) InVec = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Has the user selected a method?

do
  Retry = .false.
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  select case (InVec)

    case (0)

      ! Diagonalize core
      call Start0()
      !                                                                *
      !*****************************************************************
      !                                                                *
    case (1)

      ! HF AO orbitals as intermediate step...

      ! NDDO, always none-DFT

      call SwiOpt(.false.,OneHam,Ovrlp,nBT,CMO,nBB,nD)
      call Start0()
      InVec = 0
      call SOrbCHk(OneHam,FockAO,nBT,nD)
      KSDFT_save = KSDFT
      KSDFT = 'SCF'
      call WrInp_SCF(SIntTh)
      FstItr = .true.
      call WfCtl_SCF(iTerm,'NDDO      ',FstItr,SIntTh)
      KSDFT = KSDFT_save
      call Free_TLists()
      if (iTerm /= 0) call Quit(iTerm)
      write(u6,*)
      write(u6,'(A)') 'Generation of NDDO vectors completed!'
      write(u6,*)
      write(u6,*) '2nd step: optimizing HF MOs...'
      write(u6,*) '------------------------------'
      call SwiOpt(.true.,OneHam,Ovrlp,nBT,CMO,nBB,nD)
      ! Reset to to start from the current MO set
      call Init_SCF()
      InVec = 5
      if (nD == 1) then
        FName = 'SCFORB'
      else
        FName = 'UHFORB'
      end if
      !IFG: I presume the arguments after LuOut in this call is correct,
      !     they were missing!
      call Start2(FName,LuOut,CMO,nBB,nD,Ovrlp,nBT,EOrb,OccNo,nnB)
      !                                                                *
      !*****************************************************************
      !                                                                *
    case (2)

      ! Read INPORB
      One_Grid = .true.
      FName = SCF_FileOrb
      call Start2(FName,LuOrb,CMO,nBB,nD,Ovrlp,nBT,EOrb,OccNo,nnB)
      !                                                                *
      !*****************************************************************
      !                                                                *
    case (3)

      ! Read COMOLD
      One_Grid = .true.
      call Start3(CMO,TrM,nBB,nD,OneHam,Ovrlp,nBT)
      !                                                                *
      !*****************************************************************
      !                                                                *
    case (6)

      write(u6,*)
      write(u6,*) '     Constrained SCF calculation '
      write(u6,*)
      StVec = 'Constrained orbitals'
      One_Grid = .true.
      FName = SCF_FileOrb
      call Chk_Vec_UHF(FName,LuOrb,isUHF)
      if (IsUHF == 1) then
        InVec = 2
        Retry = .true.
      end if
      call Start6(FName,LuOrb,CMO,nBB,nD,EOrb,OccNo,nnB)
      !                                                                *
      !*****************************************************************
      !                                                                *
    case (8)

      StVec = 'Detected old SCF orbitals'
      One_Grid = .true.
      call start0y(CMO,nBB,nD,EOrb,nnB)
      !                                                                *
      !*****************************************************************
      !                                                                *
    case (9)

      StVec = 'Detected guessorb starting orbitals'
      One_Grid = .true.
      call start0x(CMO,nBB,nD,EOrb,nnB)
      !                                                                *
      !*****************************************************************
      !                                                                *
    case default

      write(u6,*) 'Illegal inVec value:',InVec
      call Abend()
      !                                                                *
      !*****************************************************************
      !                                                                *
  end select
  if (.not. Retry) exit
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (Scrmbl) then
  do iD=1,nD
    call Scram(CMO(1,iD),nSym,nBas,nOrb,ScrFac)
  end do
end if

call SOrbCHk(OneHam,FockAO,nBT,nD)
#ifdef _HDF5_
if (isHDF5) call mh5_close_file(fileorb_id)
#endif

contains

subroutine Start0()
!***********************************************************************
!                                                                      *
!     purpose: Get starting orbitals from diagonalization of the core. *
!              The result is stored in CMO. Those orbitals are         *
!              then optimized in SubRoutine WfCtl. A set of orthogonal,*
!              symmetry adapted AOs is stored in TrM.                  *
!                                                                      *
!***********************************************************************

  use InfSCF, only: nBO, nOcc, nnB

  integer(kind=iwp) :: iD

  !--------------------------------------------------------------------*
  !     Start                                                          *
  !--------------------------------------------------------------------*

  ! Form transformation matrix
  call TrGen(TrM(1,1),nBB,Ovrlp,OneHam,nBT)
  if (nD == 2) TrM(:,2) = TrM(:,1)

  ! Diagonalize core
  do iD=1,nD
    call DCore(OneHam,nBT,CMO(1,iD),TrM(1,iD),nBO,EOrb(1,iD),nnB,nOcc(1,iD),Ovrlp)
  end do

  !--------------------------------------------------------------------*
  !     Exit                                                           *
  !--------------------------------------------------------------------*
  return

end subroutine Start0

subroutine Start0x(CMO,mBB,nD,E_Or,mmB)
!***********************************************************************
!                                                                      *
! This routine reads start orbitals generated by guessorb.             *
!                                                                      *
!***********************************************************************

  use InfSCF, only: nDel

  integer(kind=iwp) :: mBB, nD, mmB
  real(kind=wp) :: CMO(mBB,nD), E_Or(mmB,nD)
  integer(kind=iwp) :: iD, iRC, nSum

  !--------------------------------------------------------------------*
  ! Get start orbitals.                                                *
  !--------------------------------------------------------------------*

  iRC = 0
  call qpg_darray('Guessorb',Found,ndata)
  if (Found) then
    if (nData /= mBB) then
      write(u6,*) 'Start0x: nData /= mBB'
      write(u6,*) '         nData=',nData
      write(u6,*) '         mBB  =',mBB
      call Abend()
    end if
    call get_darray('Guessorb',CMO(:,1),ndata)
  else
    iRC = -1
  end if
  if (iRC /= 0) then
    write(u6,*) 'Start0x: no orbitals found!'
    call Abend()
  end if

  iRC = 0
  call qpg_darray('Guessorb energies',found,ndata)
  if (Found) then
    if (nData /= mmB) then
      write(u6,*) 'Start0x: nData /= mmB'
      write(u6,*) '         nData=',nData
      write(u6,*) '         mmB  =',mmB
      call Abend()
    end if
    call get_darray('Guessorb energies',E_Or(:,1),ndata)
  else
    iRC = -1
  end if
  if (iRC /= 0) then
    write(u6,*) 'Start0x: no energies found!'
    call Abend()
  end if

  if (nD == 2) then
    CMO(:,2) = CMO(:,1)
    E_Or(:,2) = E_Or(:,1)
  end if

  call qpg_iarray('nDel_go',Found,ndata)
  nSum = 0
  if (Found) then
    call Get_iArray('nDel_go',nDel,ndata)
    call Put_iArray('nDel',nDel,ndata)
    nSum = sum(nDel(1:nSym))
  end if

  if (nSum > 0) then
    nOrb(1:nSym) = nBas(1:nSym)-nDel(1:nSym)
    do iD=1,nD
      call TrimCMO(CMO(:,iD),nSym,nBas,nOrb)
      call TrimEor(E_Or(:,iD),nSym,nBas,nOrb)
    end do
  end if

  !--------------------------------------------------------------------*
  ! Done                                                               *
  !--------------------------------------------------------------------*
  return

end subroutine Start0x

subroutine Start0y(CMO,mBB,nD,E_Or,mmB)
!***********************************************************************
!                                                                      *
! This routine reads old SCf orbitals as start orbitals.               *
!                                                                      *
!***********************************************************************

  use InfSCF, only: nDel

  integer(kind=iwp) :: mBB, nD, mmB
  real(kind=wp) :: CMO(mBB,nD), E_Or(mmB,nD)
  integer(kind=iwp) :: iD, nSum

  !--------------------------------------------------------------------*
  ! Get start orbitals.                                                *
  !--------------------------------------------------------------------*

  call qpg_darray('SCF orbitals',found,ndata)
  if (Found) call get_darray('SCF orbitals',CMO(:,1),ndata)
  call qpg_darray('OrbE',found,ndata)
  if (Found) call get_darray('OrbE',E_Or(:,1),ndata)

  if (nD == 2) then

    CMO(:,2) = CMO(:,1)
    E_Or(:,2) = E_Or(:,1)

    call qpg_darray('SCF orbitals_ab',found,ndata)
    if (Found) call get_darray('SCF orbitals_ab',CMO(:,2),ndata)
    call qpg_darray('OrbE_ab',found,ndata)
    if (found) call get_darray('OrbE_ab',E_Or(:,2),ndata)
  end if

  call qpg_iarray('nDel',Found,ndata)
  nSum = 0
  if (Found) then
    call Get_iArray('nDel',nDel,ndata)
    nSum = sum(nDel(1:nSym))
  end if
  if (nSum > 0) then
    nOrb(1:nSym) = nBas(1:nSym)-nDel(1:nSym)
    do iD=1,nD
      call TrimCMO(CMO(:,iD),nSym,nBas,nOrb)
      call TrimEor(E_or(:,iD),nSym,nBas,nOrb)
    end do
  end if
  !--------------------------------------------------------------------*
  ! Done                                                               *
  !--------------------------------------------------------------------*
  return

end subroutine Start0y

subroutine SOrbChk(OneHam,Fock,mBT,nD)

  integer(kind=iwp) :: mBT, nD
  real(kind=wp) :: OneHam(mBT), Fock(mBT,nD)
  integer(kind=iwp) :: iD
  real(kind=wp) :: Whatever

  do iD=1,nD
    ! Check orthonormality of start orbitals
    call ChkOrt(iD,Whatever)

    ! Form the first Fock matrix
    Fock(:,iD) = OneHam(:)
  end do

  return

end subroutine SOrbChk

end subroutine SOrb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1998, Roland Lindh                      *
!               1990, IBM                                              *
!***********************************************************************

subroutine Drv2El_RI_Diag(ThrAO,TInt,nTInt)
!***********************************************************************
!                                                                      *
!  Object: driver for two-electron integrals.                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for k2 loop. August '91                         *
!             Modified to minimize overhead for calculations with      *
!             small basis sets and large molecules. Sept. '93          *
!             Modified driver. Jan. '98                                *
!***********************************************************************

use SOAO_Info, only: iOffSO
use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use RI_glob, only: nSkal_Valence
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: ThrAO
integer(kind=iwp), intent(in) :: nTInt
real(kind=wp), intent(out) :: TInt(nTInt)
integer(kind=iwp) :: iIrrep, nAcc, nSkal
logical(kind=iwp) :: DoFock, DoGrad, FreeK2, Indexation, Verbose

!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize for 2-electron integral evaluation. Do not generate
! tables for indexation.

DoFock = .false.
DoGrad = .false.
Indexation = .false.
call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
nSkal_Valence = nSkal
!                                                                      *
!***********************************************************************
!                                                                      *
! Update iOffSO and call the Cholesky code which does this.

nAcc = 0
do iIrrep=0,nIrrep-1
  iOffSO(iIrrep) = nAcc
  nAcc = nAcc+nBas(iIrrep)
end do
call RI_XDiag(TInt,nTInt)
!                                                                      *
!***********************************************************************
!                                                                      *
! Terminate integral environment.

Verbose = .false.
FreeK2 = .true.
call Term_Ints(Verbose,FreeK2)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Drv2El_RI_Diag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CONFG2(NORB1,NORB2,NORB3,NEL1MN,NEL3MX,MINOP,MAXOP,IREFSM,NEL,ICONF,NCNFTP)
! Generate array,ICONF,giving occupation of each configuration
! for CI space of reference symmetry IREFSM.
!
! Jeppe Olsen April 1989
!             August 1990 : Improved handling of large RAS 3 space
!
! Turbo configuration generator
! Iconf is ordered so all configurations of the same type are
! consecutively stored.
! ICONF is written so closed orbitals are given first and then single
! occupied orbitals

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NORB1, NORB2, NORB3, NEL1MN, NEL3MX, MINOP, MAXOP, IREFSM, NEL, NCNFTP(*)
integer(kind=iwp), intent(_OUT_) :: ICONF(*)
integer(kind=iwp) :: ICFREE, ICL, ICL1, IEL1, IEL1C, IEL3, IEL3C, IFRSTC, IFRSTO, IFSTR3, IIICHK, IOP, IORB, IORB1F, IORB1L, &
                     IORB2F, IORB2L, IORB3F, IORB3L, IPLACE, IPRORB, IR3CHK, ISYM, JCONF, K, KEL, KORB, MINCL1, MXMPTY, NCL, &
                     NEWORB, NOP, NORB
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I, IBAS, IOC, IOPEN, ITYPE, LICONF
#endif
logical(kind=iwp) :: Loop700, Loop800, Skip700, Skip800, Test
integer(kind=iwp), allocatable :: IICL(:), IIOC(:), IIOP(:)
integer(kind=iwp), external :: ISYMST_MCLR

#ifndef _DEBUGPRINT_
#include "macros.fh"
unused_var(NCNFTP(1))
#endif

IORB1F = 1
IORB1L = IORB1F+NORB1-1

IORB2F = IORB1L+1
IORB2L = IORB2F+NORB2-1

IORB3F = IORB2L+1
IORB3L = IORB3F+NORB3-1

NORB = NORB1+NORB2+NORB3

call mma_allocate(IIOC,NORB,Label='IIOC')
call mma_allocate(IIOP,NORB,Label='IIOP')
call mma_allocate(IICL,NORB,Label='IICL')

! Loop over types of configurations

JCONF = 0
ICFREE = 1
! Min number of doubly occupied orbitals in RAS 1
MINCL1 = max(0,NEL1MN-NORB1)
#ifdef _DEBUGPRINT_
write(u6,*) ' Min number of doubly occupied orbitals in RAS 1',MINCL1
#endif
outer: do NOP=MINOP,MAXOP,2
  NCL = (NEL-NOP)/2
# ifdef _DEBUGPRINT_
  ITYPE = NOP-MINOP+1
  write(u6,*) ' NOP NCL ITYPE',NOP,NCL,ITYPE
# endif

  ! first combination of double occupied orbitals
  IIOC(1:NCL) = 2
  IIOC(NCL+1:NORB) = 0
  IICL(1:NCL) = [(ICL,ICL=1,NCL)]
  IFRSTC = 1

  ! Loop over double occupied orbital configurations
  inner: do

    ! next double occupied configuration
    if ((IFRSTC == 1) .or. (NCL == 0)) then
      Skip800 = .true.
    else
      do IORB=1,NORB
        if (IIOC(IORB) == 1) IIOC(IORB) = 0
      end do

      IPLACE = 0
      Skip800 = .false.
    end if
    Loop800 = .true.
    do while (Loop800)
      Loop800 = .false.
      if (Skip800) then
        Skip800 = .false.
      else
        IPLACE = IPLACE+1

        IPRORB = IICL(IPLACE)
        IIOC(IPRORB) = 0
        NEWORB = IPRORB+1
        if (((IPLACE < NCL) .and. (NEWORB < IICL(IPLACE+1))) .or. (IPLACE == NCL) .and. (NEWORB <= NORB)) then

          IICL(IPLACE) = NEWORB
          IIOC(NEWORB) = 2
        else if ((IPLACE /= NCL) .or. (NEWORB < NORB)) then

          if (IPLACE == 1) then
            IICL(1) = 1
            IIOC(1) = 2
          else
            IICL(IPLACE) = IICL(IPLACE-1)+1
            IIOC(IICL(IPLACE)) = 2
          end if
          Loop800 = .true.
          cycle
        else
          ! No more inactive configurations
          exit inner
        end if
      end if
      IFRSTC = 0
      ! CHECK RAS1 and RAS 3
      IEL1C = 0
      IEL3C = 0
      ICL1 = 0
      do ICL=1,NCL
        IORB = IICL(ICL)
        if ((IORB1F <= IORB) .and. (IORB <= IORB1L)) then
          IEL1C = IEL1C+2
          ICL1 = ICL1+1
        else if ((IORB3F <= IORB) .and. (IORB <= IORB3L)) then
          IEL3C = IEL3C+2
        end if
      end do
      IIICHK = 1
      if ((ICL1 < MINCL1) .and. (IIICHK == 1)) then
        ! Next higher combination with a higher number of inactive orbitals
        do ICL=1,ICL1+1
          IIOC(IICL(ICL)) = 0
          IICL(ICL) = ICL
          IIOC(ICL) = 2
        end do
        IPLACE = ICL1+1
        if (IPLACE >= NCL) exit inner
        Loop800 = .true.
      end if
    end do
    if (IEL3C > NEL3MX) cycle inner
    ! Highest orbital not occupied
    MXMPTY = NORB
    IORB = NORB+1
    do
      IORB = IORB-1
      if (IIOC(IORB) == 2) then
        MXMPTY = IORB-1
        if (IORB == 1) exit
      else
        exit
      end if
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Next inactive configuration'
    call IWRTMA(IICL,1,NCL,1,NCL)
#   endif

    ! first active configuration
    IORB = 0
    IOP = 0
    do IORB=1,NORB
      if (IIOC(IORB) == 0) then
        IOP = IOP+1
        if (IOP > NOP) exit
        IIOC(IORB) = 1
        IIOP(IOP) = IORB
      end if
    end do
    IFRSTO = 1

    ! Next open shell configuration
    do
      if ((IFRSTO == 1) .or. (NOP == 0)) then
        Skip700 = .true.
      else
        IPLACE = 0
        Skip700 = .false.
      end if
      Loop700 = .true.
      do while (Loop700)
        Loop700 = .false.
        if (Skip700) then
          Skip700 = .false.
        else
          IPLACE = IPLACE+1
          IPRORB = IIOP(IPLACE)
          NEWORB = IPRORB+1
          IIOC(IPRORB) = 0

          ! PAM 2013: Searching for next orbital with IIOC=0:
          do
            Test = NEWORB <= MXMPTY
            if (Test) Test = IIOC(NEWORB) /= 0
            if (.not. Test) exit
            NEWORB = NEWORB+1
          end do

          Test = IPLACE < NOP
          if (Test) Test = NEWORB < IIOP(IPLACE+1)
          if (Test .or. (IPLACE == NOP) .and. (NEWORB <= MXMPTY)) then
            IIOP(IPLACE) = NEWORB
            IIOC(NEWORB) = 1
          else if (IPLACE /= NOP) then
            if (IPLACE == 1) then
              NEWORB = 1-1
            else
              NEWORB = IIOP(IPLACE-1)
            end if
            do
              NEWORB = NEWORB+1
              if ((IIOC(NEWORB) == 0) .or. (NEWORB >= MXMPTY)) exit
            end do
            IIOP(IPLACE) = NEWORB
            IIOC(NEWORB) = 1
            Loop700 = .true.
            cycle
          else
            ! No more active configurations, so
            if (NCL /= 0) cycle inner
            if (NCL == 0) exit outer
          end if
        end if
        IFRSTO = 0

#       ifdef _DEBUGPRINT_
        write(u6,*) ' Next active configuration'
        call IWRTMA(IIOP,1,NOP,1,NOP)
#       endif
        ! RAS  CONSTRAINTS
        IEL1 = IEL1C
        IEL3 = IEL3C
        ! CHECK RAS1 and RAS3
        do IOP=1,NOP
          IORB = IIOP(IOP)
          if ((IORB1F <= IORB) .and. (IORB <= IORB1L)) then
            IEL1 = IEL1+1
          else if ((IORB3F <= IORB) .and. (IORB <= IORB3L)) then
            IEL3 = IEL3+1
          end if
        end do
        ! Faster routine for RAS 3, added august 1990
        IR3CHK = 1
        if ((IEL3 > NEL3MX) .and. (IR3CHK == 1)) then
          ! Number of electrons in substring
          IFSTR3 = 0
          do IOP=1,NOP
            if (IIOP(IOP) >= IORB3F) then
              IFSTR3 = IOP
              exit
            end if
          end do
          if (IFSTR3 /= NOP) then

            ! Lowest possible string with NOP electrons
            do K=1,IFSTR3
              IIOC(IIOP(K)) = 0
            end do

            KEL = 0
            KORB = 0
            do
              KORB = KORB+1
              if (IIOC(KORB) /= 2) then
                KEL = KEL+1
                IIOC(KORB) = 1
                IIOP(KEL) = KORB
              end if
              if (KEL == IFSTR3) exit
            end do
            IPLACE = IFSTR3
            Loop700 = .true.
          end if
        end if
      end do
      if ((IEL1 >= NEL1MN) .and. (IEL3 <= NEL3MX)) then

        ! Spatial symmetry
        ISYM = ISYMST_MCLR(IIOP,NOP)
        if (ISYM == IREFSM) then
#         ifdef _DEBUGPRINT_
          write(u6,1120) (IIOC(I),I=1,NORB)
#         endif
          JCONF = JCONF+1

          ICONF(ICFREE:ICFREE+NCL-1) = IICL(1:NCL)
          ICONF(ICFREE+NCL:ICFREE+NCL+NOP-1) = IIOP(1:NOP)
          ICFREE = ICFREE+NOP+NCL
        end if
      end if

      ! LOOP OVER active configurations end

      if ((NOP == 0) .and. (NCL == 0)) exit outer
      if (NOP == 0) exit
    end do
  end do inner
end do outer

call mma_deallocate(IIOC)
call mma_deallocate(IIOP)
call mma_deallocate(IICL)

#ifdef _DEBUGPRINT_
write(u6,'(/A,I3)') '  Configurations of symmetry ',IREFSM
write(u6,*) ' ================================='
IBAS = 0
do IOPEN=MINOP,MAXOP
  ITYPE = IOPEN-MINOP+1
  ICL = (NEL-IOPEN)/2
  IOC = IOPEN+ICL
  LICONF = NCNFTP(ITYPE)
  write(u6,'(/A,2I3)') '  Type with number of closed and open orbitals ',ICL,IOPEN
  write(u6,'(A,I7)') '  Number of configurations of this type',LICONF
  do JCONF=1,LICONF
    write(u6,'(3X,20I3)') (ICONF(IBAS+IORB),IORB=1,IOC)
    IBAS = IBAS+IOC
  end do
end do

1120 format('0  configuration included ',15I3)
#endif

end subroutine CONFG2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************

module Definitions

use, intrinsic :: iso_fortran_env, only: int8, int32, int64, real64, error_unit, input_unit, output_unit
use, intrinsic :: iso_c_binding, only: c_double, c_int, c_size_t
#   ifdef _I8_
use, intrinsic :: iso_c_binding, only: c_long
#   endif

implicit none
private

public :: wp, iwp, byte, DefInt, MPIInt, HDF5Int
public :: LibxcInt, LibxcReal, LibxcSize
public :: MOLCAS_C_INT, MOLCAS_C_REAL
public :: i1, i4, i8, r4, r8
public :: ItoB, RtoB, RtoI, CtoR
public :: u0, u5, u6

! This is the working precision and should be preferably used
! (we assume logical kinds are the same as integer kinds).
#ifdef _I8_
integer(kind=int64), parameter :: iwp = int64, MOLCAS_C_INT = c_long
#else
integer(kind=int32), parameter :: iwp = int32, MOLCAS_C_INT = c_int
#endif
integer(kind=iwp), parameter :: wp = real64, MOLCAS_C_REAL = c_double

! Single byte integer
integer(kind=iwp), parameter :: byte = int8

! "default" integer, without using `-i8` flag or equivalent,
! this is needed for some intrinsic calls in some compilers
integer(kind=iwp), parameter :: DefInt = int32

! This is the type of Libxc arguments
integer(kind=iwp), parameter :: LibxcInt = c_int, &
                                LibxcReal = c_double, &
                                LibxcSize = c_size_t

! This is the type of MPI arguments
! NOTE: If legacy `integer*4` declarations are replaced with integer(MPIInt)
!       we can support 32bit and 64bit versions.
!       Which will require appropiate compile flags here.
integer(kind=iwp), parameter :: MPIInt = int32

! This is the type of HDF5 arguments
! NOTE: If legacy `integer*4` declarations are replaced with integer(HDF5Int)
!       we can support 32bit and 64bit versions.
!       Which will require appropiate compile flags here.
integer(kind=iwp), parameter :: HDF5Int = int32

! Size ratios between the different types
! (assume 'a' uses 1 byte)
#include "compiler_features.h"
integer(kind=iwp), parameter :: &
#ifdef SIZE_INITIALIZATION
                                ItoB = storage_size(1_iwp)/storage_size('a'), &
                                RtoB = storage_size(1.0_wp)/storage_size('a'), &
                                RtoI = storage_size(1.0_wp)/storage_size(1_iwp), &
                                CtoR = storage_size((1.0_wp,0.0_wp))/storage_size(1.0_wp)
#elif defined(_I8_)
                                ItoB = 8, RtoB = 8, RtoI = 1, CtoR = 2
#else
                                ItoB = 4, RtoB = 8, RtoI = 2, CtoR = 2
#endif

! Output, input and error units, typically 6, 5 & 0, but they could be something else
integer(kind=iwp), parameter :: u0 = error_unit, &
                                u5 = input_unit, &
                                u6 = output_unit

! Although the constants from `iso_fortran_env` or `selected_real_kind`
! are preferred over non-standard `real*8` etc.
! We define some kinds to refer to the non-standard notation.
! **DON'T USE THESE UNLESS YOU EXPLICILTY WANT TO REFER TO `real*8` etc.**
! `wp` etc. are always preferred.

real*4 :: r4_example
real*8 :: r8_example

integer*1 :: i1_example
integer*4 :: i4_example
integer*8 :: i8_example

integer(kind=iwp), parameter :: r4 = kind(r4_example), &
                                r8 = kind(r8_example), &
                                i1 = kind(i1_example), &
                                i4 = kind(i4_example), &
                                i8 = kind(i8_example)

end module Definitions

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Bjorn O. Roos                                    *
*               1992, Per Ake Malmqvist                                *
*               1998, Jun-ya Hasegawa                                  *
************************************************************************
*--------------------------------------------*
* 1987  B. O. ROOS                           *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE TRACTL(iPart)
C  SECOND ORDER TWO-ELECTRON TRANFORMATION PROGRAM. CONTROL SECTION
C
C  THIS SUBROUTINE SETS UP THE MEMORY ALLOCATIONS FOR TRA2 AND LOOPS
C  OVER THE SYMMETRY BLOCKS. TRA2 IS CALLED ONCE FOR EACH SYMMETRY
C  BLOCK OF INTEGRALS. SYMMETRY BLOCKED AO INTEGRALS MUST HAVE BEEN
C  GENERATED BY INTSORT ON UNIT LUINTA=40.
C
C WRITTEN IN GARCHING IN SEPTEMBER 1987
C AUTHOR: BYOERN ROOS
C         DEPARTMENT OF THEORETICAL CHEMISTRY
C         CHEMICAL CENTRE
C         P.O.B. 124
C         S-221 00 LUND SWEDEN     TEL: 46-10 82 51
C     ********** IBM-3090 RELEASE 87 09 14 **********
C 92-12-04 P-AA M: Changed for use with CASPT2 MOLCAS-3 version.
C Also transforms 1-el integrals. -> Actually that part is commented out
C
c 98-09-02 J.Hasegawa Modified for non-squared integrals.
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL IFTEST
#include "rasdim.fh"
#include "warnings.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "intgrl.fh"
#include "SysDef.fh"
#include "trafo.fh"
      DIMENSION nBasXX(8),Keep(8)
      Logical iSquar
      Logical DoCholesky

      IFTEST=.FALSE.
#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif

C Copy data to common ERI.
      NSYMZ=NSYM
      DO I=1,NSYM
        NORBZ(I)=NORB(I)
        NOSHZ(I)=NOSH(I)
        LUINTMZ=LUINTM
      END DO

C Open temporary files for half-transformed integrals.
C They are closed at end of TRACTL.

C The MO coefficients were allocated and read in STINI. They are
C available at WORK(LCMO).
C
C     RETRIEVE BASE DATA FROM UNIT LUINTA
C
**JHsta
      Call GetOrd(IRC,iSquar,nSymXX,nBasXX,Keep)
      IF ( OUTFMT.EQ.'LONG    ' ) THEN
        If(iSquar)      write(6,*)'TRACTL OrdInt status: squared'
        If(.not.iSquar) write(6,*)'TRACTL OrdInt status: non-squared'
      ENDIF
**JHend
      IF(IRC.NE.0) THEN
        WRITE(6,*)' TRACTL, called to transform the two-electron'
        WRITE(6,*)' integrals, got non-zero return code from'
        WRITE(6,*)' subroutine GETORD. The return code is IRC=',IRC
        WRITE(6,*)' Do you have a valid ORDINT file? If you do,'
        WRITE(6,*)' please inform the MOLCAS group -- this may be'
        WRITE(6,*)' a bug. Anyway, the calculations must stop, sorry.'
        CALL QUIT(_RC_IO_ERROR_READ_)
      END IF
** PAM2007: For unknown reasons, one extra word is needed.
*      lBuf = 1+MAX(255*255,NBMX**2)
* but note that tractl, being a utility, can be called from other
* programs and should not take the value NBMX from caspt2.fh...
* hence correction by AJS below.
c
c     Correction by AJS, Jan. 12, 2009. Defines the value
c     of NBMX
c     ---------------------------------------------------
c
      NBMX=1
      DO I=1,NSYM
c        WRITE(6,'(a,i2,a,i5)') 'ISYM=',I,'   nBas(ISYM)=',nBasXX(I)
        NBMX=MAX(NBMX,nBasXX(i))
      ENDDO
c     ---------------------------------------------------
*      lBuf = MAX(255*255,NBMX**2)
      lBuf = 1+NBMX**2
c      write(6,'(2(A,I10))') 'NBMX=',NBMX,'   lBuf=',lBuf
*
* COMPARE CONTENT OF 1EL and 2EL INTEGRAL FILE
      IERR=0
      IF ( NSYMXX.NE.NSYM ) THEN
        IERR=1
      ELSE
        DO ISYM=1,NSYM
          IF (NBAS(ISYM).NE.NBASXX(ISYM)) IERR=1
        END DO
      END IF
      IF(IERR.NE.0) THEN
        WRITE(6,*)'     *** ERROR IN SUBROUTINE TRACTL ***'
        WRITE(6,*)'          INCOMPATIBLE BASIS DATA'
        WRITE(6,*)
        WRITE(6,*)' JOBIPH NR OF SYMM:', NSYM
        WRITE(6,*)' JOBIPH NR OF BASIS FUNCTIONS/SYMM:'
        WRITE(6,'(1x,8I5)')(NBAS(I),I=1,NSYM)
        WRITE(6,*)
        WRITE(6,*)' ORDINT NR OF SYMM:', NSYMXX
        WRITE(6,*)' ORDINT NR OF BASIS FUNCTIONS/SYMM:'
        WRITE(6,'(1x,8I5)')(NBASXX(I),I=1,NSYMXX)
        CALL ERRTRA
        CALL SYSHALT('TRACTL')
      END IF
C
C     SET ADDRESS FIELD FOR OUTPUT INTEGRAL FILE
C
      LIADUT=3*36*36
      DO I=1,36*36
       IAD2M(1,I)=0
       IAD2M(2,I)=0
       IAD2M(3,I)=0
      END DO
      IAD13=0
      CALL iDAFILE(LUINTM,1,IAD2M,LIADUT,IAD13)
C
C     LOOP OVER QUADRUPLES OF SYMMETRIES (NSP,NSQ,NSR,NSS)
C     NOTE THAT THE INTEGRALS ON LUINTA HAVE TO BE SORTED IN THE SAME
C     ORDER AS THE LOOP STRUCTURE BELOW (USE PROGRAM INTSORT)
C
c Allocate largest possible array as work space:
      If ( IFTEST ) then
        Write(6,*)
     &  ' Symmetry  Basis functions   total orbitals    active orbitals'
        Write(6,*)
     &  ' -------------------------------------------------------------'
      End If
      CALL GETMEM('LW1','MAX','REAL',LW1,MEMX)
      MEMX=MAX(MEMX-1*MEMX/6,0)

C --- Reserve space for Integral generation from Cholesky vectors
      Call DecideOnCholesky(DoCholesky)
      If (DoCholesky) then
         MEMX = MAX(MEMX-MEMX/10,0)
         write(6,*)'Memx= ',MEMX
      End If
C -----------------------------------------------------------------
      CALL GETMEM('LW1','ALLO','REAL',LW1,MEMX)
      NCHAIN=0
      LMOP1=1
      ITP=0
      DO NSP=1,NSYM
       IF(NSP.NE.1) ITP=ITP+NASH(NSP-1)
       NBP=NBAS(NSP)
       IF(NSP.NE.1) LMOP1=LMOP1+NBAS(NSP-1)**2
       LMOP=LMOP1+NBP*NFRO(NSP)
       LMOP2=LMOP
       NOP=NORB(NSP)
       NOCP=NOSH(NSP)
       KEEPP=KEEP(NSP)
       ISP=NSP
       LMOQ1=1
       ITQ=0
       DO NSQ=1,NSP
        IF(NSQ.NE.1) ITQ=ITQ+NASH(NSQ-1)
        NBQ=NBAS(NSQ)
        IF(NSQ.NE.1) LMOQ1=LMOQ1+NBAS(NSQ-1)**2
        LMOQ=LMOQ1+NBQ*NFRO(NSQ)
        LMOQ2=LMOQ
        KEEPQ=KEEP(NSQ)
        NOQ=NORB(NSQ)
        NOCQ=NOSH(NSQ)
        ISQ=NSQ
        NSPQ=MUL(NSP,NSQ)
        LMOR1=1
        ITR=0
**JHsta
        NSymR=NSP
        If(iSquar)NSymR=NSYM
        DO NSR=1,NSymR
**JHend
         IF(NSR.NE.1) ITR=ITR+NASH(NSR-1)
         NBR=NBAS(NSR)
         IF(NSR.NE.1) LMOR1=LMOR1+NBAS(NSR-1)**2
         LMOR=LMOR1+NBR*NFRO(NSR)
         LMOR2=LMOR
         KEEPR=KEEP(NSR)
         NOR=NORB(NSR)
         NOCR=NOSH(NSR)
         NSPQR=MUL(NSPQ,NSR)
         ISR=NSR
         LMOS1=1
         ITS=0
**JHsta
         NSymS=NSR
         If(NSP.eq.NSR)NSymS=NSQ
         If(iSquar)NSymS=NSR
         DO NSS=1,NSymS
**JHend
          IF(NSS.NE.1) ITS=ITS+NASH(NSS-1)
          NBS=NBAS(NSS)
          IF(NSS.NE.1) LMOS1=LMOS1+NBAS(NSS-1)**2
          LMOS=LMOS1+NBS*NFRO(NSS)
          LMOS2=LMOS
          IF(NSPQR.NE.NSS) GO TO 101
          NOS=NORB(NSS)
          NOCS=NOSH(NSS)
          KEEPS=KEEP(NSS)
          ISS=NSS
C
          KEEPT=KEEPP+KEEPQ+KEEPR+KEEPS
          NOCCT=NOCP*NOCQ*NOCR*NOCS
          IF(NOCCT.NE.0.AND.KEEPT.NE.0) GO TO 901
          IF(KEEPT.EQ.0) NCHAIN=NCHAIN+1
          IF(NOP*NOQ*NOR*NOS.EQ.0) GO TO 101
C
C         CALLING SEQUENCE FOR SECOND ORDER TRANSFORMATION TRA2
C         FIRST ALLOCATE AND CHECK MEMORY
C
          NBPQ=NBP*NBQ
          IF(ISP.EQ.ISQ) NBPQ=(NBP**2+NBP)/2
          NBRS=NBR*NBS
          IF(ISR.EQ.ISS) NBRS=(NBR**2+NBR)/2
          NOTU=NOCR*NOCS
          IF(ISR.EQ.ISS) NOTU=(NOCR**2+NOCR)/2

          If ( IFTEST ) then
             Write(6,'(1X,4I2,2X,4I4,2X,4I4,2X,4I4)')
     &            NSP,NSQ,NSR,NSS,
     &            NBP,NBQ,NBR,NBS,
     &            NOP,NOQ,NOR,NOS,
     &            NOCP,NOCQ,NOCR,NOCS
          End If

CPAM      MEMX=MXMEM
CPAM      LW1=1
cJHsta
          Mxx1=max(lBuf,NOP*NBQ,NBP*NOCQ,NOCP*NBQ)
          Mxx2=max(NBR*NBS,NBP*NBQ,NOP*NOR,NOP*NOS,NOQ*NOR,NOQ*NOS)
          Mxx3=max(NOCR*NBS,NBR*NOCS)
          LW2=LW1+Mxx1
          LW3=LW2+Mxx2
          LW4=LW3+Mxx3
          LRUPQ=NBP*NBQ*NBR*NOCS
          LURPQ=NBP*NBQ*NOCR*NBS
          MEMLFT=MEMX-LW4+LW1
* I.E. MEMLFT=MEMX-MXX1-MXX2-MXX3, possibly negative...
          LPQTU=NBP*NBQ*NOCR*NOCS
          LATRU=NOP*NOCQ*NBR*NOCS
          LTARU=NOCP*NOQ*NBR*NOCS
          LATUS=NOP*NOCQ*NOCR*NBS
          LTAUS=NOCP*NOQ*NOCR*NBS
          LTUPQ=max(LPQTU,LATRU,LTARU)
          MEMT=LRUPQ+LURPQ+LTUPQ
          L2=max(LATUS,LTAUS)

          LRUPQM=NBR*NOCS
          If(LRUPQM.ne.0)LRUPQM=max(NBR*NOCS,NBPQ)
          LURPQM=NBS*NOCR
          If(LURPQM.ne.0)LURPQM=max(NBS*NOCR,NBPQ)
          LTUPQM=MAX(NOTU,NOCQ*NOCS*NOP,NOCP*NOCS*NOQ)
          If(LTUPQM.ne.0)  LTUPQM=max(LTUPQM,NBPQ,NBR*NOP,NBR*NOQ)
          L2M=MAX(NOCQ*NOCR*NOP,NOCP*NOCR*NOQ)
          If(L2M.ne.0)L2M=max(NOP*NBS,NOQ*NBS)

          IF(MEMT.GT.MEMLFT.OR.L2.GT.MEMLFT-LURPQ) THEN
C           LRUPQ=INT((1.0D0*MEMLFT*LRUPQ+MEMT-1)/MEMT)
C           LURPQ=INT((1.0D0*MEMLFT*LURPQ+MEMT-1)/MEMT)
            NX=MEMLFT/(LRUPQM+LURPQM+LTUPQM)
            iiPart=1
            if(iPart.gt.0) then
            iiPart=iPart
            endif
            LRUPQ=NX*LRUPQM*iiPart
            LURPQ=NX*LURPQM*iiPart
          ENDIF
          LTUPQ=MAX(0,MEMLFT-LRUPQ-LURPQ)
c          print *,'LRUPQ=',LRUPQ
c          print *,'LURPQ=',LURPQ
c          print *,'LTUPQ=',LTUPQ

          IF(LRUPQ.LT.LRUPQM) GO TO 902
          IF(LURPQ.LT.LURPQM) GO TO 902
          IF(LTUPQ.LT.LTUPQM) GO TO 902
          IF(LRUPQ+LTUPQ.LT.L2M) GO TO 902
          LW5=LW4+LURPQ
          LW6=LW5+LRUPQ

          If(.not.iSquar)then
* Keep addresses LW2, LW3, LW4, and save LTUPQ (in common /TRAFO/),
* for use in the calls to tr2Sq or to tr2NsA.
           LTUPQX=LTUPQ

* Recompute memory requirements, now for the tr2NsB call.
           Mxx1=max(lBuf,NBP*NOCQ,NBR*NOS,NOR*NBS)
           Mxx2=max(NBP*NBQ,NBR*NBS)
C LPQRS, MEMT integers, changed to Re*8. Defined and used in the
C following section only. Named XLPQRS, XMEMT, +small local changes.
           XLPQRS=DBLE(NBRS)
           XLPQRS=XLPQRS*DBLE(NBP*NBQ)
           LTURS=NOCP*NOCQ*NBR*NBS
* Mxx1 words needed...
           LW2B=LW1+Mxx1
* Another Mxx2 words needed...
           LW3B=LW2B+Mxx2
* The next line can also be written ''MEMLFT = MEMX-MXX1-MXX2''
* This could possibly be small or negative.
           MEMLFT=MAX(0,MEMX-LW3+LW1)
           XMEMT=XLPQRS+DBLE(LTURS)
* XMEMT is NBRS*NBP*NBQ + NOCP*NOCQ*NBR*NBS
           IF(XMEMT.GT.DBLE(MEMLFT)) THEN
            LPQRS=INT((DBLE(MEMLFT)*XLPQRS)/XMEMT+0.5d0)
           ELSE
            LPQRS=INT(XLPQRS)
           ENDIF
C XLPQRS, XMEMT not used after this.
           LRSmx=LPQRS/NBPQ
           If(LRSmx.gt.NBRS)LRSmx=NBRS
           Nread=NBRS/LRSmx
           Nrest=mod(NBRS,LRSmx)
           If(Nrest.ne.0)Nread=Nread+1
           LRS=NBRS/Nread
           Nrest=mod(NBRS,Nread)
           If(Nrest.ne.0)LRS=LRS+1
           LPQRS=LRS*NBPQ
           MaxRS=LRS
           LTURS=MEMLFT-LPQRS
           IF(LPQRS.LT.NBPQ) GO TO 903
           LTURSM=NOCP*NOCQ
           If(LTURSM.ne.0) LTURSM=max(LTURSM,NBRS)
           IF(LTURS.LT.LTURSM) GO TO 903
           LW4B=LW3B+LPQRS
           LTUPQ=LTURS
          Endif
          If (iSquar)then
*            TR2Sq(CMO,X1,X2,X3,URPQ,RUPQ,TUPQ,lBuf)
             Call tr2Sq(Work(LCMO),
     &                  Work(LW1),
     &                  Work(LW2),
     &                  Work(LW3),
     &                  Work(LW4),
     &                  Work(LW5),
     &                  Work(LW6),lBuf)
          Else
*            tr2NsA(CMO,X1,X2,X3,pqUs,pqrU,pqTU,lBuf)
c          LW2=LW1+Mxx1
c          LW3=LW2+Mxx2
c          LW4=LW3+Mxx3
c          LW5=LW4+LURPQ
c          LW6=LW5+LRUPQ

           If (IFTEST) then
            write(6,*) 'Calling tr2Nsa'
            write(6,*) 'MEMX=',MEMX
            write(6,*) 'lLW1=',LW2-LW1
            write(6,*) 'lLW2=',LW3-LW2
            write(6,*) 'lLW3=',LW4-LW3
            write(6,*) 'lLW4=',LW5-LW4
            write(6,*) 'lLW5=',LW6-LW5
            write(6,*) 'lLW6=',MEMX-(LW6-LW1)
            write(6,*)
           End If

             LTUPQ=LTUPQX
             Call tr2NsA1(Work(LCMO),
     &                   Work(LW1),LW2-LW1,
     &                   Work(LW2),LW3-LW2,
     &                   Work(LW3),LW4-LW3,
     &                   Work(LW4),LW5-LW4,
     &                   Work(LW5),LW6-LW5,
     &                   Work(LW6),MEMX-(LW6-LW1),lBuf)
             Call tr2NsA2(Work(LCMO),
     &                   Work(LW1),LW2-LW1,
     &                   Work(LW2),LW3-LW2,
     &                   Work(LW5),LW6-LW5,
     &                   Work(LW6),MEMX-(LW6-LW1))
             Call tr2NsA3(Work(LCMO),
     &                   Work(LW1),LW2-LW1,
     &                   Work(LW2),LW3-LW2,
     &                   Work(LW4),LW5-LW4,
     &                   Work(LW5),MEMX-(LW5-LW1))
*            tr2NsB(CMO,X1,X2,pqrs,TUrs,lBuf,MAXRS)
             LTUPQ=LTURS
             Call tr2NsB(Work(LCMO),
     &                   Work(LW1),
     &                   Work(LW2B),
     &                   Work(LW3B),
     &                   Work(LW4B),lBuf,MaxRS)
          End If
  101     CONTINUE
         END DO
        END DO
       END DO
      END DO
      If ( IFTEST ) then
       Write(6,*)
     & ' --------------------------------------------------------------'
      End If
      CALL GETMEM('LW1','FREE','REAL',LW1,MEMX)
C
C     FINALLY WRITE OUT THE DAFILE ADDRESS LIST ON UNIT 13
C
      IAD13=0
      CALL iDAFILE(LUINTM,1,IAD2M,LIADUT,IAD13)
C
CPAM01 Also transform 1-electron integrals, and put CMOs on LUONEM.
CPAM01      CALL TRAONE(WORK(LCMO),KEEP)

      RETURN
C
C     HERE IF INTERPHASE FROM SORT IN ERROR
C
  901 CONTINUE
      WRITE(6,'(/5X,A,8I6)')
     & 'ERROR IN KEEP PARAMETER FROM INTSORT FILE:  ',(KEEP(I),I=1,NSYM)
      WRITE(6,'(/5X,A,8I6)')
     & 'NOT CONSISTENT WITH OCCUPIED ORBITAL SPACE: ',(NOSH(I),I=1,NSYM)
      WRITE(6,'(/5X,A)') 'PROGRAM STOP IN SUBROUTINE TRACTL'
      GOTO 999
C
C     HERE IF NOT ENOUGH CORE SPACE
C
  902 CONTINUE
      WRITE(6,'(/1X,A)')'NOT ENOUGH CORE SPACE FOR SORTING IN TRA2'
      WRITE(6,'(/1X,A,I12)')'TOTAL SORTING SPACE IS',MEMLFT
      WRITE(6,'(/1X,A,I12,A,I12)')'STEP1: AVAILABLE IS',LRUPQ,
     &                                    '  NEEDED IS',LRUPQM
      WRITE(6,'(/1X,A,I12,A,I12)')'STEP2:    ''''         ',
     &                               LTUPQ,'  NEEDED IS',LTUPQM
      WRITE(6,'(/1X,A,I12,A,I12)')'STEP3:    ''''         ',
     &                            LRUPQ+LTUPQ,'  NEEDED IS',L2M
      GOTO 999

  903 CONTINUE
      WRITE(6,'(/1X,A)')'NOT ENOUGH CORE SPACE FOR SORTING IN TRATWO2'
      WRITE(6,'(/1X,A,I12)')'TOTAL SORTING SPACE IS',MEMLFT
      WRITE(6,'(/1X,A,I12,A,I12)')'STEP1: AVAILABLE IS',LPQRS,
     &                                    '  NEEDED IS',NBPQ
      WRITE(6,'(/1X,A,I12,A,I12)')'STEP1:     ''''        ',LTURS,
     &                                    '   ''''        ',LTURSM
      GOTO 999

 999  CONTINUE
      CALL Abend
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!               2017, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Optim2(E_Pred,G,H,D,C,n,n0,n1,r2)
!***********************************************************************
!                                                                      *
!    purpose: Solve a set of non-linear equations to get interpolation *
!             coefficients for damping                                 *
!                                                                      *
!     input:                                                           *
!       G       : linear energy terms                                  *
!       H       : bilinear energy terms                                *
!       D       : bilinear density terms                               *
!       n       : size of matrices                                     *
!       n0      : index number of the lowest energy                    *
!       n1      : index number of the second lowest energy             *
!       r2      : square of density change constraint                  *
!                                                                      *
!     output:                                                          *
!       C       : interpolation coefficients                           *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! The KISS method is employed here. Do a scan of the energy surface    *
! along lines parallel to the edges. Reduce the steplength gradually.  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark                                                     *
!     University of Lund, Sweden, 2003                                 *
!                                                                      *
!     hacked for optimization on a sphere by:                          *
!     Roland Lindh                                                     *
!     Uppsala University, Uppsala, Sweden, 2017.                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n, n0, n1
real(kind=wp), intent(out) :: E_Pred, C(n)
real(kind=wp), intent(in) :: G(n), H(n,n), D(n,n), r2
integer(kind=iwp) :: i, Iter, j, k, l, nLow
real(kind=wp) :: A, AI, AJ1, AJ2, AJK, AK1, AK2, B, BI, BJ1, BJ2, Eref, Es(4), Step, Step_mi, Step_mj, Step_mk, Step_pi, Step_pj, &
                 Step_pk, Steps(3,4)
#ifdef _DEBUGPRINT_
real(kind=wp) :: rSum
#endif
logical(kind=iwp) :: DidChange
real(kind=wp), external :: Optim_E

!----------------------------------------------------------------------*
! Initialize                                                           *
!----------------------------------------------------------------------*
!----------------------------------------------------------------------*
! Make first guess.                                                    *
!----------------------------------------------------------------------*
!
! The initial guessed values of the Cs are set by finding the
! coeffcients for the densities with the two lowest energies,
! n0 and n1. All other coefficients are assumed to be zero.
! The coefficient are found by solving the two simultaneous
! equations,
!
! Sum_i C(i) = 0
!
! Sum_i C(i) C(j) D(i,j) = r2

C(:) = Zero
A = Two*(D(n0,n1)-D(n1,n1))/(D(n0,n0)-Two*D(n0,n1)+D(n1,n1))
B = (D(n1,n1)-r2)/(D(n0,n0)-Two*D(n0,n1)+D(n1,n1))
C(n0) = -(A/Two)+sqrt((A/Two)**2-B)
if (C(n0) > One) C(n0) = -(A/Two)-sqrt((A/Two)**2-B)
if (C(n0) < Zero) then
  write(u6,*) 'C(n0) < Zero'
  call Abend()
end if
C(n1) = One-C(n0)
if (C(n1) > One) then
  write(u6,*) 'C(n1) > One'
  call Abend()
end if
if (C(n1) < Zero) then
  write(u6,*) 'C(n1) < Zero'
  call Abend()
end if

! At this point we have a set of Cs which fulfil the two contraints.
#ifdef _DEBUGPRINT_
write(u6,'(a)') 'Start C:'
write(u6,'(6F15.6)') (C(i),i=1,n)
write(u6,'(a)') 'Start G:'
write(u6,'(6F15.6)') (G(i),i=1,n)
call RecPrt('H',' ',H,n,n)
call RecPrt('D',' ',D,n,n)
#endif
!----------------------------------------------------------------------*
! Compute start energy.                                                *
!----------------------------------------------------------------------*
Eref = sum(C(:)*G(:))
do i=1,n
  Eref = Eref+Half*C(i)*sum(C(:)*H(i,:))
end do
#ifdef _DEBUGPRINT_
write(u6,'(a,F15.6)') 'Eref = ',Eref
#endif
!----------------------------------------------------------------------*
! Do a scan in all tripletwise directions.                             *
!----------------------------------------------------------------------*
Iter = 0
DidChange = .true.
Step = 0.1_wp
call Abend()

! Below we explore changes to all triplets that are consistent with
! that the constrains are not broken.

do Iter=1,500

  DidChange = .false.

  do i=1,n-2

    do j=i+1,n-1

      do k=j+1,n

        ! Make sure that step trivially is within the range.
        ! The first constraint. Now we vary d(j) and d(k)
        ! such that the constraints are not broken.

        Step_pi = min(Step,One-C(i))
        Steps(1,1) = Step_pi
        Steps(1,2) = Step_pi

        ! Given the change d(i) compute d(k) and d(l),
        ! subjects to the simultaneous equations.
        !
        ! Sum_i d(i) = 0
        !
        ! Sum_ij (2(C(i)+d(i))*d(j)*D(i,j) = 0

        AI = Two*(C(i)+Step_pi)*Step_pi*D(i,i)+C(k)*Step_pi*D(k,i)+C(j)*Step_pi*D(j,i)
        AJ1 = (C(i)+Two*Step_pi)*D(i,j)+C(j)*D(j,j)+C(k)*D(k,j)
        AK1 = (C(i)+Two*Step_pi)*D(i,k)+C(k)*D(k,k)+C(j)*D(j,k)
        AJK = Two*D(j,k)
        AJ2 = D(j,j)
        AK2 = D(k,k)

        BI = AI-AJ1*Step_pi+AJ2*Step_pi**2
        BJ1 = -AJ1+AK1-(AJK-Two*AJ2)*Step_pi
        BJ2 = -AJK+AJ2+AK2

        A = BJ1/(Two*BJ2)
        B = BI/BJ2

        Step_pk = -A+sqrt(A**2-B)
        Step_mk = -A-sqrt(A**2-B)

        Step_pj = -(Step_pi+Step_pk)
        Step_mj = -(Step_pi+Step_mk)

        C(i) = C(i)+Step_pi

        C(j) = C(j)+Step_mj
        C(k) = C(k)+Step_mk
        Steps(2,1) = Step_mj
        Steps(3,1) = Step_mk

        Es(1) = optim_E(C,G,H,n)

        C(j) = C(j)-Step_mj
        C(k) = C(k)-Step_mk

        C(j) = C(j)+Step_pj
        C(k) = C(k)+Step_pk
        Steps(2,2) = Step_pj
        Steps(3,2) = Step_pk

        Es(2) = optim_E(C,G,H,n)

        C(j) = C(j)-Step_pj
        C(k) = C(k)-Step_pk

        C(i) = C(i)-Step_pi

        Step_mi = min(C(i),Step)
        Steps(1,3) = Step_mi
        Steps(1,4) = Step_mi

        AI = Two*(C(i)+Step_mi)*Step_mi*D(i,i)+C(k)*Step_mi*D(k,i)+C(j)*Step_mi*D(j,i)
        AJ1 = (C(i)+Two*Step_mi)*D(i,j)+C(j)*D(j,j)+C(k)*D(k,j)
        AK1 = (C(i)+Two*Step_mi)*D(i,k)+C(k)*D(k,k)+C(j)*D(j,k)
        AJK = Two*D(j,k)
        AJ2 = D(j,j)
        AK2 = D(k,k)

        BI = AI-AJ1*Step_mi+AJ2*Step_mi**2
        BJ1 = -AJ1+AK1-(AJK-Two*AJ2)*Step_mi
        BJ2 = -AJK+AJ2+AK2

        A = BJ1/(Two*BJ2)
        B = BI/BJ2

        Step_pk = -A+sqrt(A**2-B)
        Step_mk = -A-sqrt(A**2-B)

        Step_pj = -(Step_mi+Step_pk)
        Step_mj = -(Step_mi+Step_mk)

        C(i) = C(i)+Step_mi

        C(j) = C(j)+Step_mj
        C(k) = C(k)+Step_mk
        Steps(2,3) = Step_mj
        Steps(3,3) = Step_mk

        Es(3) = optim_E(C,G,H,n)

        C(j) = C(j)-Step_mj
        C(k) = C(k)-Step_mk

        C(j) = C(j)+Step_pj
        C(k) = C(k)+Step_pk
        Steps(2,4) = Step_pj
        Steps(3,4) = Step_pk

        Es(4) = optim_E(C,G,H,n)

        C(j) = C(j)-Step_pj
        C(k) = C(k)-Step_pk

        C(i) = C(i)-Step_mi

#       ifdef _DEBUGPRINT_
        write(u6,'(a,3I3,4F20.10)') 'i,j,k,Es(i),i=1,4)=',i,j,k,(Es(l),l=1,4)
#       endif
        nLow = 0
        do l=1,4
          if (Es(l) < Eref) then
            nLow = l
            Eref = Es(l)
            DidChange = .true.
          end if
        end do
        if (nLow /= 0) then
          C(i) = C(i)+Steps(1,nLow)
          C(j) = C(j)+Steps(2,nLow)
          C(k) = C(k)+Steps(3,nLow)
        end if

      end do
    end do
  end do

  if (.not. DidChange) then
    if (Step > 0.9e-4_wp) then
      Step = 0.1_wp*Step
      DidChange = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Step is',Step
#     endif
    end if
  end if
# ifdef _DEBUGPRINT_

  ! Check that the constraint is fulfilled.

  rSum = sum(C(:))
  write(u6,*) 'optim: rSum-1',rSum-One

  rSum = Zero
  do i=1,n
    rSum = rSum+C(i)*sum(C(:)*D(i,:))
  end do
  write(u6,*) 'optim: rSum-r2',rSum-r2
# endif
  if (.not. DidChange) exit
end do
#ifdef _DEBUGPRINT_
write(u6,*) 'ERef=',ERef
#endif
E_Pred = ERef

end subroutine Optim2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
*               1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine AlloK2()
************************************************************************
*                                                                      *
*  Object: Allocate space for K2 entities.                             *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, Sweden. November '92                 *
*             Martin Schuetz, Dept. of Theoretical Chemistry,          *
*             University of Lund, Sweden. Jun '95                      *
************************************************************************
      use k2_setup
      use k2_arrays
      use iSD_data
      use IOBUF
      use Basis_Info
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "nsd.fh"
#include "setup.fh"
#include "status.fh"
*
*     declaration of local vars...
      Logical Debug
      Data Debug/.False./
*
*---- Statement function
*
      nElem(i)=(i+1)*(i+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
*
      If (Debug) Then
         If (Allocated(Data_k2)) Then
            Write (6,*) 'Enter Allok2, k2_Status=Active'
         Else If (k2_Status.eq.Produced) Then
            Write (6,*) 'Enter Allok2, k2_Status=Produced'
         Else
            Write (6,*) 'Enter Allok2, k2_Status=InActive'
         End If
      End If
      If (Allocated(Data_k2) .or. k2_Status.eq.Produced   ) Return
*
      Call Nr_Shells(nSkal)
*
*     determine memory size for K2 entities
*     for this, run dummy K2 loop...
      nk2 = 0
      nDeDe = 0
      MaxDe = 0
      nr_of_Densities=1 ! Hardwired option
*                                                                      *
************************************************************************
*                                                                      *
*-----Double loop over shells. These loops decide the integral type
*
      Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         If (Shells(iShll)%Aux .and. iS.ne.nSkal) Go To 100
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
*
         Do jS = 1, iS
            jShll  = iSD( 0,jS)
            If (Shells(jShll)%Aux .and. jS.eq.nSkal) Go To 200
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
*
            If (nIrrep.eq.1) Then
               iDeSiz = 1 + iPrim*jPrim +               iCmp*jCmp
            Else
               iDeSiz = 1 + iPrim*jPrim + (iBas*jBas+1)*iCmp*jCmp
            End If
            MaxDe = Max(MaxDe,iDeSiz)
            iSmLbl = 1
            nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            If (nSO.gt.0) Then
               nDeDe = nDeDe + nr_of_Densities*iDeSiz*nIrrep
            End If
*
            nZeta=iPrim*jPrim
            ijCmp=nElem(iAng)*nElem(jAng)
            If (.Not.DoGrad_) ijCmp=0
            nHm=iCmp*jCmp*(nabSz(iAng+jAng)-nabSz(Max(iAng,jAng)-1))
            nHm=nHm*nIrrep
            nData=nZeta*(nDArray+2*ijCmp)+nDScalar+nHm
            nk2 = nk2 + nData*nIrrep
 200        Continue
         End Do
 100     Continue
      End Do
*     now ... allocate memory
      Call mma_allocate(Data_k2,nk2,Label='Data_k2')
      Data_k2(:)=Zero
      nIndk2=S%nShlls*(S%nShlls+1)/2
      call mma_allocate(Indk2,2,nIndk2,Label='Indk2')
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,1995, Roland Lindh                                *
************************************************************************
      SubRoutine WelGrd(
#define _CALLING_
#include "grd_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: to compute the Pauli repulsion integrals with the            *
*         Gauss-Hermite quadrature.                                    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden. October '92.                            *
*                                                                      *
*             Modified to gradients, April '95. R. Lindh               *
************************************************************************
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "wldata.fh"
#include "print.fh"
#include "disp.fh"

#include "grd_interface.fh"

*
*     Statement function for Cartesian index
*
      nElem(i)=(i+1)*(i+2)/2
*
      iRout = 122
      iPrint = nPrint(iRout)
*     iQ = 1
      If (iPrint.ge.59) Then
         Write (6,*) ' In WelGrd'
         Write (6,*) ' r0, ExpB=',r0,ExpB
         Write (6,*) ' la,lb=',la,lb
         Write (6,*) '  A=',A
         Write (6,*) ' RB=',RB
      End If
*
      k = la + lb + 1
      jsump= 1
      Do i = 1, k
         jsump= jsump+ 3**i
      End Do
      k0 = Max(la + lb - 1,0)
      jsumm= 1
      Do i = 1, k0
         jsumm= jsumm+ 3**i
      End Do
*
      ip = 1
      ipGri = ip
      ip = ip + nZeta*jsump
      ipTGri = ip
      ip = ip + nZeta*jsump
      ipGrin= ip
      ip = ip + nZeta*(k+1)*(k/2+1)*(k/4+1)
      iPxyz = ip
      ip = ip + nZeta
      If (ip-1.gt.nZeta*nArr) Then
         Write (6,*) ' ip-1.gt.nZeta*nArr(pos.1)'
         Write (6,*) ip-1,'>',nZeta*nArr
         Call ErrTra
         Call Abend()
      End If
*
      Call Rowel(nZeta,r0,expB,k,Zeta,P,Array(iPxyz),Array(ipGri),
     &           Array(ipGrin),jsump)
      ip = ip - nZeta
      ip = ip - nZeta*(k+1)*(k/2+1)*(k/4+1)
      If (iPrint.ge.99) Call RecPrt(' In WelInt: Array(ipGri)l',' ',
     &   Array(ipGri),nZeta,jSumP)
*
      ipAMx = ip
      ip = ip + nZeta*9
      ipScr = ip
      ip = ip + nZeta*3**k
      If (ip-1.gt.nZeta*nArr) Then
         Write (6,*) ' ip-1.gt.nZeta*nArr(pos.2)'
         Write (6,*) ip-1,'>',nZeta*nArr
         Call ErrTra
         Call Abend()
      End If
*
*-----Transform each block to the global coordinate system
*
      iOff = ipgri + nZeta
      Do 100 ik = 1, k
         If (ik.eq.1) Call SetUpA(nZeta,Array(ipAMx),P)
         Call Traxyz(nZeta,ik,Array(iOff),Array(ipScr),Array(ipAMx))
         iOff = iOff + nZeta*3**ik
 100  Continue
      If (iPrint.ge.99) Call RecPrt(' In WelInt: Array(ipGri)g',' ',
     &   Array(ipGri),nZeta,jSumP)
      call dcopy_(nZeta*jsump,Array(ipGri),1,Array(ipTGri),1)
      ip = ip - nZeta*3**k
      ip = ip - nZeta*9
*
      ip1 = ip
      ip = ip + nZeta
      ip2 = ip
      ip = ip + nZeta
      ip3 = ip
      ip = ip + nZeta
      ip4 = ip
      ip = ip + nZeta
      ip5 = ip
      ip = ip + nZeta
      If (ip-1.gt.nZeta*nArr) Then
         Write (6,*) ' ip-1.gt.nZeta*nArr(pos.3)'
         Write (6,*) ip-1,'>',nZeta*nArr
         Call ErrTra
         Call Abend()
      End If
*
*----- Compute <a|O|b+1>
*
      ip0p=ip
      ip  =ip + nZeta*nElem(la)*nElem(lb+1)
      Call TraPAB(nZeta,la,lb+1,Array(ip0p),Array(ipgri),jSump,rKappa,
     &     Array(ip1),Array(ip2),Array(ip3),Array(ip4),Array(ip5),A,
     &     RB,P)
*
*----- Compute <a|O|b-1>
*
      If (lb.ge.1) Then
         ip0m=ip
         ip  =ip + nZeta*nElem(la)*nElem(lb-1)
         call dcopy_(nZeta*jsumm,Array(ipTGri),1,Array(ipGri),1)
         Call TraPAB(nZeta,la,lb-1,Array(ip0m),Array(ipgri),jSumm,
     &               rKappa,Array(ip1),Array(ip2),Array(ip3),Array(ip4),
     &               Array(ip5),A,RB,P)
      Else
         ip0m=1
      End If
*
*----- Compute <a+1|O|b>
*
      ipp0=ip
      ip  =ip + nZeta*nElem(la+1)*nElem(lb)
      call dcopy_(nZeta*jsump,Array(ipTGri),1,Array(ipGri),1)
      Call TraPAB(nZeta,la+1,lb,Array(ipp0),Array(ipgri),jSump,rKappa,
     &     Array(ip1),Array(ip2),Array(ip3),Array(ip4),Array(ip5),A,
     &     RB,P)
*
*----- Compute <a-1|O|b>
*
      If (la.ge.1) Then
         ipm0=ip
         ip  =ip + nZeta*nElem(la-1)*nElem(lb)
         call dcopy_(nZeta*jsumm,Array(ipTGri),1,Array(ipGri),1)
         Call TraPAB(nZeta,la-1,lb,Array(ipm0),Array(ipgri),jSumm,
     &               rKappa,Array(ip1),Array(ip2),Array(ip3),Array(ip4),
     &               Array(ip5),A,RB,P)
      Else
         ipm0=1
      End If
*
      ipAlph = ip
      ip = ip + nZeta
      ipBeta = ip
      ip = ip + nZeta
*
      jp = ipAlph
      Do iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(jp),1)
         jp = jp + nAlpha
      End Do
      jp = ipBeta
      Do iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(jp),nAlpha)
         jp = jp + 1
      End Do
*
*---- Assemble the derivative integrals and distribute contributions.
*
      Call CmbnW1(Array(ipp0),Array(ipm0),Array(ip0p),Array(ip0m),
     &            nZeta,la,lb,Zeta,rKappa,Final,Array(ipAlph),
     &            Array(ipBeta),Grad,nGrad,DAO,
     &            IfGrad,IndGrd,dc(mdc)%nStab,dc(ndc)%nStab,kOp)

*
      ip = ip - 5*nZeta
      ip = ip - 2*nZeta
      If (la.ge.1) ip = ip - nZeta*nElem(la-1)*nElem(lb)
      ip = ip - nZeta*nElem(la)*nElem(lb+1)
      If (lb.ge.1) ip = ip - nZeta*nElem(la)*nElem(lb-1)
      ip = ip - nZeta*nElem(la+1)*nElem(lb)
      ip = ip - 2*nZeta*jsump
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_integer(nHer)
         Call Unused_real_array(Ccoor)
         Call Unused_integer(nOrdOp)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iStabM)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gentkin(L,TKIN,nprims,exponents,rootOVLPinv)
!bs subroutine to generate the kinetic energy

use AMFI_global, only: MxprimL
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: L, nprims
real(kind=wp), intent(out) :: TKIN(nprims,nprims)
real(kind=wp), intent(in) :: exponents(nprims), rootOVLPinv(MxprimL,MxprimL)
integer(kind=iwp) :: irun1, irun2
real(kind=wp), allocatable :: dummy(:,:), dummy2(:,:)
real(kind=wp), external :: Tkinet

call mma_allocate(dummy,nprims,nprims,label='dummy')
call mma_allocate(dummy2,nprims,nprims,label='dummy2')

!bs build the symmetric matrix
do irun2=1,nprims
  do irun1=1,irun2
    dummy(irun1,irun2) = Tkinet(L,exponents(irun1),exponents(irun2))
    dummy(irun2,irun1) = dummy(irun1,irun2)
  end do
end do
!bs now transform by rootOVLPinv*dummy*rootOVLPinv
call dgemm_('N','N',nprims,nprims,nprims,One,dummy,nprims,rootOVLPinv,MxprimL,Zero,dummy2,nprims)
call dgemm_('N','N',nprims,nprims,nprims,One,rootOVLPinv,MxprimL,dummy2,nprims,Zero,Tkin,nprims)

call mma_deallocate(dummy)
call mma_deallocate(dummy2)

return

end subroutine gentkin

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This program tests the runfile utilities.                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
! Written: July 2003                                                   *
!          Lund University, Sweden                                     *
!                                                                      *
!***********************************************************************

program TestRF

use RunFile_data, only: TypDbl, TypInt, TypStr
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), parameter :: Mxdata=64
real(kind=wp), parameter :: Step=0.75_wp, Thr=1.0e-12_wp
integer(kind=iwp) :: i, iOpt, iRc, iSeed, Loop, nDataA, nDataAx, nDataB, nDataBx, nDataC, nDataCx, nDataD, nDataDx, nDataE, &
                     nDataEx, nDataF, nDataFx, RecTypA, RecTypB, RecTypC, RecTypD, RecTypE, RecTypF
integer(kind=iwp) :: DataC(MxData), DataD(MxData)
real(kind=wp) :: DataA(MxData), DataB(MxData)
character :: DataE(MxData), DataF(MxData)
logical(kind=iwp) :: UseOld
real(kind=wp), external :: Random_Molcas

call IniMem()
call Init_LinAlg()
call PrgmInit('TestRF')
call NameRun('RUNFILE')

UseOld = .false.
if (.not. UseOld) then

  iSeed = 12345
  nDataA = 0
  nDataB = 0
  nDataC = 0
  nDataD = 0
  nDataE = 0
  nDataF = 0

  do i=1,MxData
    DataA(i) = real(i,kind=wp)
    DataC(i) = i
    DataE(i) = char(64+mod(i,48))
  end do
  DataB(:) = -DataA(:)
  DataD(:) = -DataC(:)
  DataF(:) = DataE(:)

  iRc = 0
  iOpt = 0
  do Loop=1,16
    if (Random_Molcas(iSeed) > Step) then
      nDataA = int((MxData-4)*Random_Molcas(iSeed)+4)
      write(u6,*) 'Adding A',nDataA
      call dWrRun('Amat',DataA,nDataA)
    end if
    if (Random_Molcas(iSeed) > Step) then
      nDataB = int((MxData-4)*Random_Molcas(iSeed)+4)
      write(u6,*) 'Adding B',nDataB
      call dWrRun('Bmat',DataB,nDataB)
    end if
    if (Random_Molcas(iSeed) > Step) then
      nDataC = int((MxData-4)*Random_Molcas(iSeed)+4)
      write(u6,*) 'Adding C',nDataC
      call iWrRun('Cmat',DataC,nDataC)
    end if
    if (Random_Molcas(iSeed) > Step) then
      nDataD = int((MxData-4)*Random_Molcas(iSeed)+4)
      write(u6,*) 'Adding D',nDataD
      call iWrRun('Dmat',DataD,nDataD)
    end if
    if (Random_Molcas(iSeed) > Step) then
      call NameRun('RUNXXX')
      i = int((MxData-4)*Random_Molcas(iSeed)/4)
      nDataE = 4*i+4
      write(u6,*) 'Adding E',nDataE
      call cWrRun('Emat',DataE,nDataE)
      call NameRun('RUNFILE')
    end if
    if (Random_Molcas(iSeed) > Step) then
      i = int((MxData-4)*Random_Molcas(iSeed)/4)
      nDataF = 4*i+4
      write(u6,*) 'Adding F',nDataF
      call cWrRun('Fmat',DataF,nDataF)
    end if
  end do

end if

DataA(:) = Zero
DataB(:) = Zero
DataC(:) = 0
DataD(:) = 0
DataE(:) = char(0)
DataF(:) = char(0)

nDataAx = nDataA
nDataBx = nDataB
nDataCx = nDataC
nDataDx = nDataD
nDataEx = nDataE
nDataFx = nDataF

nDataA = 0
nDataB = 0
nDataC = 0
nDataD = 0
nDataE = 0
nDataF = 0

call ffRun('Amat',nDataA,RecTypA)
call ffRun('Bmat',nDataB,RecTypB)
call ffRun('Cmat',nDataC,RecTypC)
call ffRun('Dmat',nDataD,RecTypD)
call NameRun('RUNXXX')
call ffRun('Emat',nDataE,RecTypE)
call NameRun('RUNFILE')
call ffRun('Fmat',nDataF,RecTypF)

if (UseOld) then
  nDataAx = nDataA
  nDataBx = nDataB
  nDataCx = nDataC
  nDataDx = nDataD
  nDataEx = nDataE
  nDataFx = nDataF
end if

if (nDataA /= nDataAx) then
  write(u6,*) 'nDataA:',nDataA,nDataAx
  stop
end if

if (nDataB /= nDataBx) then
  write(u6,*) 'nDataB:',nDataB,nDataBx
  stop
end if

if (nDataC /= nDataCx) then
  write(u6,*) 'nDataC:',nDataC,nDataCx
  stop
end if

if (nDataD /= nDataDx) then
  write(u6,*) 'nDataD:',nDataD,nDataDx
  stop
end if

if (nDataE /= nDataEx) then
  write(u6,*) 'nDataE:',nDataE,nDataEx
  stop
end if

if (nDataF /= nDataFx) then
  write(u6,*) 'nDataF:',nDataF,nDataFx
  stop
end if

if (RecTypA /= TypDbl) then
  write(u6,*) 'RecTypA:',RecTypA,TypDbl
  stop
end if

if (RecTypB /= TypDbl) then
  write(u6,*) 'RecTypB:',RecTypB,TypDbl
  stop
end if

if (RecTypC /= TypInt) then
  write(u6,*) 'RecTypC:',RecTypC,TypInt
  stop
end if

if (RecTypD /= TypInt) then
  write(u6,*) 'RecTypD:',RecTypD,TypInt
  stop
end if

if (RecTypE /= TypStr) then
  write(u6,*) 'RecTypE:',RecTypE,TypStr
  stop
end if

if (RecTypF /= TypStr) then
  write(u6,*) 'RecTypF:',RecTypF,TypStr
  stop
end if

if (nDataA > 0) then
  write(u6,*) 'Testing A',nDataA
  call dRdRun('Amat',DataA,nDataA)
  do i=1,nDataA
    if (abs(DataA(i)-i) > Thr) write(u6,*) 'A:',i,DataA(i)
  end do
end if

if (nDataB > 0) then
  write(u6,*) 'Testing B',nDataB
  call dRdRun('Bmat',DataB,nDataB)
  do i=1,nDataB
    if (abs(DataB(i)+i) > Thr) write(u6,*) 'B:',i,DataB(i)
  end do
end if

if (nDataC > 0) then
  write(u6,*) 'Testing C',nDataC
  call iRdRun('Cmat',DataC,nDataC)
  do i=1,nDataC
    if (DataC(i)-i /= 0) write(u6,*) 'C:',i,DataC(i)
  end do
end if

if (nDataD > 0) then
  write(u6,*) 'Testing D',nDataD
  call iRdRun('Dmat',DataD,nDataD)
  do i=1,nDataD
    if (DataD(i)+i /= 0) write(u6,*) 'D:',i,DataD(i)
  end do
end if

if (nDataE > 0) then
  call NameRun('RUNXXX')
  write(u6,*) 'Testing E',nDataE
  call cRdRun('Emat',DataE,nDataE)
  do i=1,nDataE
    if (ichar(DataE(i))-64-mod(i,48) /= 0) write(u6,*) 'E:',i,DataE(i)
  end do
  call NameRun('RUNFILE')
end if

if (nDataF > 0) then
  write(u6,*) 'Testing F',nDataF
  call cRdRun('Fmat',DataF,nDataF)
  do i=1,nDataF
    if (ichar(DataF(i))-64-mod(i,48) /= 0) write(u6,*) 'F:',i,DataF(i)
  end do
end if

call DumpRun(iRc,iOpt)

call GetMem('Finish','LIST','REAL',I,0)
call GetMem('Finish','TERM','REAL',I,0)

end program TestRF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine cnfcheck2_cvb(iconfs,nconf1,nel1,iocc)
      implicit real*8 (a-h,o-z)
      logical locc,lorbs,locc_only,lorbs_only
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


      dimension iconfs(noe,nconf1),iocc(noe)

      if(nconf1.eq.0)then
c  Special case -- iconfs will be ok and adhere to occ no definition.
        nconf1=1
        return
      endif
c  Perform basic checks of configurations :
c  First determine if a consistent definition (orb list or
c  occ numbers) has been used for the configurations.
c
c  We do this in two parses. locc_only/lorbs_only are set in
c  first run through if *any* iconf unamiguously adheres to
c  one of the definitions.
c
c  Second run through if necessary we check again in case iconfs
c  contains *both* types of definitions.
c
      locc_only=.false.
      lorbs_only=.false.
      do 100 iconf=1,nconf1
c  Consistency with occ no definition ?
      locc=.true.
      do 200 i=norb+1,noe
      if(iconfs(i,iconf).ne.0)locc=.false.
200   continue
      nsum=0
      do 300 i=1,norb
      if(iconfs(i,iconf).lt.0.or.iconfs(i,iconf).gt.2)locc=.false.
      nsum=nsum+iconfs(i,iconf)
300   continue
      if(nsum.ne.nel1)locc=.false.
c  Consistency with orb list definition ?
      lorbs=.true.
      do 400 i=nel1+1,noe
      if(iconfs(i,iconf).ne.0)lorbs=.false.
400   continue
      call izero(iocc,norb)
      do 500 i=1,nel1
      if(iconfs(i,iconf).ge.1.and.
     >   iconfs(i,iconf).le.norb)then
        iocc(iconfs(i,iconf))=iocc(iconfs(i,iconf))+1
      else
        lorbs=.false.
      endif
500   continue
      do 600 i=1,norb
      if(iocc(i).gt.2)lorbs=.false.
600   continue
c
      if(locc.and..not.lorbs)then
        locc_only=.true.
      elseif(lorbs.and..not.locc)then
        lorbs_only=.true.
      elseif((.not.lorbs).and..not.locc)then
        write(6,*)' Illegal configuration read ',iconf
        write(6,*)(iconfs(ii,iconf),ii=1,noe)
        call abend_cvb()
      endif
100   continue

      locc=locc_only
      lorbs=lorbs_only
      do 1100 iconf=1,nconf1
      if(locc_only.and.lorbs_only)then
c  Check again ...
c  Consistency with occ no definition ?
        locc=.true.
        do 1200 i=norb+1,noe
        if(iconfs(i,iconf).ne.0)locc=.false.
1200    continue
        nsum=0
        do 1300 i=1,norb
        if(iconfs(i,iconf).lt.0.or.iconfs(i,iconf).gt.2)locc=.false.
        nsum=nsum+iconfs(i,iconf)
1300    continue
        if(nsum.ne.nel1)locc=.false.
c  Consistency with orb list definition ?
        lorbs=.true.
        do 1400 i=nel1+1,noe
        if(iconfs(i,iconf).ne.0)lorbs=.false.
1400    continue
        call izero(iocc,norb)
        do 1500 i=1,nel1
        if(iconfs(i,iconf).ge.1.and.
     >     iconfs(i,iconf).le.norb)then
          iocc(iconfs(i,iconf))=iocc(iconfs(i,iconf))+1
        else
          lorbs=.false.
        endif
1500    continue
        do 1600 i=1,norb
        if(iocc(i).gt.2)lorbs=.false.
1600    continue
      endif
      if(locc.and.lorbs)then
c  Comment out following 5 lines if default should be occ no definition:
        call izero(iocc,norb)
        do 1700 i=1,nel1
        iocc(iconfs(i,iconf))=iocc(iconfs(i,iconf))+1
1700    continue
        call imove_cvb(iocc,iconfs(1,iconf),norb)
        if(noe-norb.gt.0) call izero(iconfs(norb+1,iconf),noe-norb)
      elseif(lorbs)then
        call izero(iocc,norb)
        do 1800 i=1,nel1
        iocc(iconfs(i,iconf))=iocc(iconfs(i,iconf))+1
1800    continue
        call imove_cvb(iocc,iconfs(1,iconf),norb)
        if(noe-norb.gt.0) call izero(iconfs(norb+1,iconf),noe-norb)
      endif
      if(iconf.le.500)then
c Test for repeated configurations :
        do 1900 jconf=1,iconf-1
        do 2000 iorb=1,norb
        if(iconfs(iorb,iconf).ne.iconfs(iorb,jconf))goto 1900
2000    continue
        write(6,'(/,a,2i4)')
     >    ' Fatal error - spatial VB configuration repeated :',
     >    jconf,iconf
        write(6,'(i8,a,20i3)')jconf,'   =>  ',(iocc(ii),ii=1,norb)
        write(6,'(i8,a,20i3)')iconf,'   =>  ',(iocc(ii),ii=1,norb)
        call abend_cvb()
1900    continue
      endif
1100  continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Rysg1(iAnga,nRys,nT,
     &                 Alpha,Beta,Gamma,Delta,
     &                 Zeta,ZInv,nZeta,Eta,EInv,nEta,
     &                 P,lP,Q,lQ,Coori,Coora,CoorAC,
     &                 Array,nArray,
     &                 Tvalue,ModU2,Cff2D,
     &                 PAO,nPAO,Grad,nGrad,IfGrad,IndGrd,kOp,iuvwx)
************************************************************************
*                                                                      *
* Object: to compute the gradient of the two-electron integrals.       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Modified to 1st order derivatives October '91            *
************************************************************************
      use vRys_RW
      use Symmetry_Info, only: iOper
      use Real_Info, only: ChiI2
      use Temporary_Parameters, only: IsChi
      Implicit Real*8 (A-H,O-Z)
      External Tvalue, ModU2, Cff2D
      External Exp_1, Exp_2
#include "real.fh"
#include "notab.fh"
#include "print.fh"
      Real*8 Zeta(nZeta), ZInv(nZeta), P(lP,3),
     &       Eta(nEta),   EInv(nEta),  Q(lQ,3),
     &       Alpha(nZeta), Beta(nZeta), Gamma(nEta), Delta(nEta),
     &       CoorAC(3,2), Coora(3,4), Coori(3,4), Array(nArray),
     &       PAO(nT,nPAO), Grad(nGrad), Temp(9)
      Integer iAnga(4), IndGrd(3,4), Index(3,4),
     &          kOp(4), iuvwx(4),   JndGrd(3,4), lOp(4)
      Logical AeqB, CeqD, AeqC, EQ, IfGrad(3,4),
     &          JfGrad(3,4)
*
      lOp(1) = iOper(kOp(1))
      lOp(2) = iOper(kOp(2))
      lOp(3) = iOper(kOp(3))
      lOp(4) = iOper(kOp(4))
#ifdef _DEBUGPRINT_
      call dcopy_(lP-nZeta,[Zero],0,P(nZeta+1,1),1)
      call dcopy_(lP-nZeta,[Zero],0,P(nZeta+1,2),1)
      call dcopy_(lP-nZeta,[Zero],0,P(nZeta+1,3),1)
      Call RecPrt(' In Rysg1:P',' ',P,lP,3)
      call dcopy_(lQ-nEta,[Zero],0,Q(nEta+1,1),1)
      call dcopy_(lQ-nEta,[Zero],0,Q(nEta+1,2),1)
      call dcopy_(lQ-nEta,[Zero],0,Q(nEta+1,3),1)
      Call RecPrt(' In Rysg1:Q',' ',Q,lQ,3)
      Call RecPrt(' In Rysg1:Zeta',' ',Zeta,nZeta,1)
      Call RecPrt(' In Rysg1:ZInv',' ',ZInv,nZeta,1)
      Call RecPrt(' In Rysg1:Eta',' ',Eta,nEta,1)
      Call RecPrt(' In Rysg1:EInv',' ',EInv,nEta,1)
      Call RecPrt(' In Rysg1:Alpha',' ',Alpha,nZeta,1)
      Call RecPrt(' In Rysg1:Beta ',' ',Beta ,nZeta,1)
      Call RecPrt(' In Rysg1:Gamma',' ',Gamma,nEta,1)
      Call RecPrt(' In Rysg1:Delta',' ',Delta,nEta,1)
      Call RecPrt(' In Rysg1:Coora',' ',Coora,3,4)
      Call RecPrt(' In Rysg1:Coori',' ',Coori,3,4)
      Call RecPrt(' In Rysg1:CoorAC',' ',CoorAC,3,2)
      Write (6,*) ' In Rysg1: iAnga=',iAnga
#endif
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      AeqB = EQ(Coora(1,1),Coora(1,2))
      CeqD = EQ(Coora(1,3),Coora(1,4))
      AeqC = EQ(Coora(1,1),Coora(1,3))
      lla = 0
      llb = 0
      llc = 0
      lld = 0
      Do 10 i = 1, 3
         If (IfGrad(i,1)) Then
            lla = 1
         End If
         If (IfGrad(i,2)) Then
            llb = 1
         End If
         If (IfGrad(i,3)) Then
            llc = 1
         End If
         If (IfGrad(i,4)) Then
            lld = 1
         End If
 10   Continue
      lab = Max(lla,llb)
      lcd = Max(llc,lld)
      nabMax = la + lb + lab
      ncdMax = lc + ld + lcd
*
*     Allocate memory for the integral gradients.
*
      ip = 1
*     ipAC = ip
*     ip = ip + nT*nPAO * 9
*
*     Allocate memory for the 2D-integrals.
*
      ip2D0 = ip
      n2D0 = Max( (nabMax+1)*(ncdMax+1),
     &            (la+2)*(lb+2)*(ncdMax+1),
     &            (la+2)*(lb+2)*(lc+2)*(ld+2))
      ip = ip + n2D0*3*nT*nRys
*
*     Allocate memory for the 1st order derivatives of the 2D-integrals.
*
      ip2D1 = ip
      n2D1 = Max( (nabMax+1)*(ncdMax+1),
     &            (la+2)*(lb+2)*(ncdMax+1),
     &            (la+1)*(lb+1)*(lc+1)*(ld+1)*3)
      ip = ip + n2D1*3*nT*nRys
*
*     Allocate memory for the coefficients in the recurrence relation
*     of the 2D-integrals.
*
      nTR=nT*nRys
      ipPAQP = ip
      ip = ip + nTR*3
      ipQCPQ = ip
      ip = ip + nTR*3
      ipB10 = ip
      lB10=Max(Min(nabMax-1,1),0)
      ip = ip + nTR*3*lB10
      labMax = Min(nabMax,ncdMax)
      ipB00 = ip
      lB00=Max(Min(labMax,1),0)
      ip = ip + nTR*3*lB00
      ipB01 = ip
      lB01=Max(Min(ncdMax-1,1),0)
      ip = ip + nTR*3*lB01
*     Allocate memory for the roots.
      ipU2 = ip
      ip = ip + nT*nRys
*     Allocate memory for Zeta, ZInv, Eta, EInv
      ipZeta = ip
      ip = ip + nT
      ipEta  = ip
      ip = ip + nT
      ipZInv = ip
      ip = ip + nT
      ipEInv = ip
      ip = ip + nT
*     Allocate memory for P and Q
      ipP = ip
      ip = ip + 3*nT
      ipQ = ip
      ip = ip + 3*nT
*     Allocate memory for the inverse.
      ipDiv = ip
      ip = ip + nT
*     Allocate memory for the arguments.
      ipTv = ip
      ip = ip + nT
*define _CHECK_
#ifdef _CHECK_
      If (ip-1.gt.nArray) Then
         Call WarningMessage(2,'Rysg1: ip-1 =/= nArray (pos.1)')
         Write (6,*) ' nArray=',nArray
         Write (6,*) ' ip-1  =',ip-1
         Write (6,*) ' nRys  =',nRys
         Write (6,*) ' nZeta =',nZeta
         Write (6,*) ' nEta  =',nEta
         Call Abend()
      End If
#endif
*
*     Expand Zeta, ZInv, Eta ,EInv, P, and Q
*
      Do iEta = 1, nEta
         iOff = (iEta-1)*nZeta
         call dcopy_(nZeta,Zeta,  1,Array(iOff+ipZeta  ),1)
         call dcopy_(nZeta,ZInv,  1,Array(iOff+ipZInv  ),1)
         call dcopy_(nZeta,P(1,1),1,Array(iOff+ipP     ),1)
         iOff = iOff + nZeta*nEta
         call dcopy_(nZeta,P(1,2),1,Array(iOff+ipP     ),1)
         iOff = iOff + nZeta*nEta
         call dcopy_(nZeta,P(1,3),1,Array(iOff+ipP     ),1)
      End Do
      Do iZeta = 1, nZeta
         iOff = iZeta-1
         call dcopy_(nEta, Eta,  1,Array(iOff+ipEta) ,nZeta)
         call dcopy_(nEta,EInv,  1,Array(iOff+ipEInv),nZeta)
         call dcopy_(nEta,Q(1,1),1,Array(iOff+ipQ     ),nZeta)
         iOff = iOff + nZeta*nEta
         call dcopy_(nEta,Q(1,2),1,Array(iOff+ipQ     ),nZeta)
         iOff = iOff + nZeta*nEta
         call dcopy_(nEta,Q(1,3),1,Array(iOff+ipQ     ),nZeta)
      End Do
*
*     Compute the arguments for which we will compute the roots and
*     the weights.
*
      Call Tvalue(Array(ipZeta),Array(ipEta),Array(ipP),Array(ipQ),nT,
     &            Array(ipTv),Array(ipDiv),IsChi,ChiI2)
*
*     Compute roots and weights. Make sure that the weights ends up in
*     the array where the z component of the 2D integrals will be.
*     Call vRysRW if roots and weights are tabulated in various Taylor
*     expansions. If not tabulated call RtsWgh.
*
*     Pointer to z-component of 2D-integrals where the weights will be
*     put directly. This corresponds to xyz2D(1,1,3,0,0).
      ipWgh = ip2D0 + 2*nT*nRys
      If (nRys.gt.nMxRys .or. NoTab) Then
#ifdef _CHECK_
         If (ip-1.gt.nArray) Then
            Call WarningMessage(2,'Rysg1: ip-1 =/= nArray (pos.2)')
            Write (6,*) ' nArray=',nArray
            Write (6,*) ' ip-1  =',ip-1
            Call Abend()
         End If
#endif
         Call RtsWgh(Array(ipTv),nT,Array(ipU2),Array(ipWgh),nRys)
      Else
#ifdef _CHECK_
         If (ip-1.gt.nArray) Then
            Call WarningMessage(2,'Rysg1: ip-1 =/= nArray (pos.3)')
            Write (6,*) ' nArray=',nArray
            Write (6,*) ' ip-1  =',ip-1
            Call Abend()
         End If
#endif
         Call vRysRW(la+1,lb,lc,ld,Array(ipTv),Array(ipU2),Array(ipWgh),
     &               nT,nRys)
      End If
*-----Drop ipTv
      ip = ip - nT
*
*     Modify the roots.
*
      Call ModU2(Array(ipU2),nT,nRys,Array(ipDiv))
*-----Drop ipDiv
      ip = ip - nT
*
*     Compute coefficients for the recurrence relations of the
*     2D-integrals
*
      Call Cff2D(Max(nabMax-1,0),Max(ncdMax-1,0),nRys,
     &           Array(ipZeta),Array(ipZInv),Array(ipEta),Array(ipEInv),
     &           nT,Coori,CoorAC,Array(ipP),Array(ipQ),
     &           la+lab,lb,lc+lcd,ld,
     &           Array(ipU2),Array(ipPAQP),Array(ipQCPQ),
     &           Array(ipB10),Array(ipB00),labMax,Array(ipB01))
*-----Drop ipU2
      ip = ip - nT*nRys
*     Let go of Zeta, ZInv, Eta, and EInv
      ip = ip - nT*4
*     Let go of P and Q
      ip = ip - 6*nT
*
*     Compute the intermediate 2D-integrals from the roots and weights.
*
      Call vRys2Dm(Array(ip2D0),nT,nRys,nabMax,
     &            ncdMax,Array(ipPAQP),Array(ipQCPQ),
     &            Array(ipB10),Max(nabMax-1,0),
     &            Array(ipB00),labMax,
     &            Array(ipB01),Max(ncdMax-1,0),
     &            la,lb,lc,ld,IfGrad)
*-----Drop ipB01
      ip = ip - nTR*3*lB01
*-----Drop ipB00
      ip = ip - nTR*3*lB00
*-----Drop ipB10
      ip = ip - nTR*3*lB10
*-----Drop ipQCPQ
      ip = ip - nTR*3
*-----Drop ipPAQP
      ip = ip - nTR*3
*
*-----Apply the transfer equation to the intermediate 2D-integrals.
*
      Call HrrCtl(Array(ip2D0),n2D0,Array(ip2D1),n2D1,
     &            la,lb,lc,ld,nabmax,ncdmax,
     &            nTR,Coora(1,1),Coora(1,2),Coora(1,3),Coora(1,4),
     &            IfGrad)
*
*     Compute the gradients of the 2D-integrals. Copy some information
*     which will be modified. This has to be done in order to facilitate
*     partitioning.
*
      ipScr = ip
      ip = ip + nT*nRys
      ipTmp = ip
      ip = ip + nT
      Call ICopy(12,IndGrd,1,JndGrd,1)
      Do 8877 i = 1, 3
         Do 7788 j = 1, 4
            JfGrad(i,j) = IfGrad(i,j)
 7788    Continue
 8877 Continue
      Call Rys2Dg(Array(ip2D0),nT,nRys,la,lb,lc,ld,
     &            Array(ip2D1),JfGrad,
     &            JndGrd,Coora,Alpha,Beta,Gamma,Delta,nZeta,nEta,
     &            Array(ipScr),Array(ipTmp),Index,
     &            Exp_1,Exp_2,nZeta,nEta)
*-----Drop ipScr
      ip = ip - nTR
*-----Drop ipTmp
      ip = ip - nT
*
*     Assemble the gradients of the ERI's
*
      Call Assg1(Temp,PAO,nT,nRys,la,lb,lc,ld,Array(ip2D0),
     &           Array(ip2D1),JfGrad,Index,mVec)
*-----Drop ip2D1
      ip = ip - nTR*3*n2D1
*-----Drop ip2D0
      ip = ip - nTR*3*n2D0
*
*     Distribute the contributions to the molecular gradient
*
      Call Distg1(Temp,mVec,Grad,nGrad,JfGrad,JndGrd,
     &            iuvwx,lOp)
*-----Drop ipAC
*     ip = ip - nT*nPAO * 9
#ifdef _CHECK_
      If (ip.ne.1) Then
         Call WarningMessage(2,'Rysg1: ip=/=1')
         Call Abend()
      End If
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Markus Reiher                                    *
************************************************************************
      subroutine evalstring2(length,term,coeff,nbas,posu,post,poss,vv,
     *                       nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,
     *                       snumber,tnumber,unumber,scrno1,
     *                       scr1,scr2,scr3,scr5,nbasp,nbaso,darray,
     *                       dkhadr,adrmem,dkh_48,adrnext)
c
c************************************************************************
c
c   Evaluate the low-level character string 'term' of length 'length'
c     with coefficient 'coeff'. The result is stored in scr5(,,scrno1).
c
c   Note:  'term' might in general contain Sxxx, Txxx, and Uxxx expressions
c           as well as brackets [,], and V,N,D,Y,F,G,Z,Q,X,I,J,K,L,M  !!
c
c   scrno1 has to be 2 for the purposes here!
c
c   This SR belongs to dkhparser_numeric.
c
c   written by:  Markus Reiher  (ETH Zurich)
c
c   version:  1.0.0
c
c   * the A matrices introduced in previous versions of this
c     routine have been eliminated
c   * this routine requires scr5(nbas,nbas,scrno1) with
c     2 (nbas X nbas)-matrices; however, scrno1=3 since
c     scr5(nbas,nbas,1) is already reserved in calc_operators()
c   * this routine now assumes that the bracket structure
c     of the term is comparatively simple
c     (either no bracket, one bracket only, contiguous brackets,
c      or only(!) nested brackets --- all other
c      cases cannot be treated here and are dealt with
c      at the level of evalstring() )
c
c   first version: 17.01.2007  (Theoretical Chemistry, ETH Zurich)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer length,nbas,posu(maxunumber),post(maxsnumber),nbasp,
     *        poss(maxsnumber),snumber,tnumber,unumber,scrno1,nbaso
      character*(maxlength) term
      REAL*8 coeff
c
      REAL*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp),e(nbas)
      REAL*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),scr5(nbas,nbas,scrno1),
     *                 darray(nbas,nbas)
c
      integer i,idum1,ileft,iright,scrleng,iposA
      character*(maxlength) scrtxt
      REAL*8 alpha,beta
      logical flag
c
      integer dkh_48,adrmem,adrnext
      integer dkhadr(adrmem)
c
      flag=.true.
      alpha=1.0d0
      beta=0.0d0
      iposA=0
c
3150  continue
c
      iright=0
      ileft=0
c
c-----------------------------------------------------------------------
c  The sequence of evaluation of 'term' is determined by the position of
c    the brackets [].
c    --> Find first bracket ']' at iright and --- if available ---
c          corresponding '[' at ileft -> yields the innermost bracket
c------------------------------------------------------------------------
c
      iright=index(term(1:length),']')
*** determine position ileft of corresponding '['
      if (iright.ne.0) then
        ileft=iright-1
1065    continue
        if (term(ileft:ileft).ne.'[') then
          ileft=ileft-1
          goto 1065
        endif
        if (ileft.eq.0 .or. ileft.ge.iright) then
          write (stdout,1010) iright,term(1:maxlength)
1010      format (2X,'Error1 in SR evalstring: unbalanced occurrence ',
     *            'of brackets:',/2X,'] at pos = ',I2,', but no [ left',
     *            ' of it in term = ',A90)
          CALL Abend
        endif
      endif
c
      if (iright.eq.0) then
c
c-----------------------------------------------------------------------
c  a) Easy case: Direct evaluation from left to right of 'term' possible
c                because NO brackets occur at all
c  -------------
*** determine left-hand-side factor if it does not exist yet
        if (flag) then
          call multiply (length,term,coeff,nbas,posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,dkhadr,adrmem,
     *                 dkh_48,adrnext)
        else
*** in this case we have a left-hand factor in A00 already identified
***   and there is no additional bracket left over
*** first multiply with all matrices from the right
*** note: the coefficient has to be alpha=1, not coeff in order to avoid
***       a double multiplication
          call multiply2(length-iposA+1,term(iposA:length),coeff,nbas,
     *                 iposA,posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,dkhadr,adrmem,
     *                 dkh_48,adrnext)
*** check whether there are also matrices to be multiplied from the left
          if (iposA.ne.1) then
            call multiply3(iposA-1,term(1:iposA-1),alpha,nbas,
     *                 posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1),
     *                 scr5(1,1,scrno1-1),nbasp,nbaso,dkhadr,adrmem,
     *                 dkh_48,adrnext)
            call mat_copy(scr5(1,1,scrno1),nbas,nbas,scr5(1,1,scrno1-1))
          end if
        end if
c
      else if (iright.ne.0.and.iposA.ne.0) then
c
c-----------------------------------------------------------------------
c  b) most difficult case: the previously found brackets are not embraced
c                          by the new ones but additional brackets show up
c                          directly after the first bracket on the left
c                          was closed (other cases are not permitted by evalstring() )
c                          like in ...[...]...[...] and the first
c                          brackets were already found
c
*** first check if 'old' A00 must be multiplied by matrices from the left
        if (iposA.ne.1) then
          call multiply3(iposA-1,term(1:iposA-1),alpha,nbas,
     *                 posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,dkhadr,adrmem,
     *                 dkh_48,adrnext)
*** now: scr5(1,1,scrno1) contains the new A00
          call mat_copy(scr5(1,1,scrno1-1),nbas,nbas,scr5(1,1,scrno1))
*** idum1 is the length of the matrices on the left of A00
          idum1=iposA-1
          do 71 i=1,length-idum1
            term(i:i)=term(i+idum1:i+idum1)
  71      continue
*** account for new iposA
          iposA=1
          do 76 i=length-idum1+1,length
            term(i:i)=' '
  76      continue
          length=length-idum1
          ileft=ileft-idum1
          iright=iright-idum1
        end if
*** now check if there are matrices between 1st [...] and 2nd [...]
        if (iposA+3.ne.ileft) then
*** store matrix string befor '[' of length (ileft-1); note that
***   A00 is to be included because it is dealt with in multiply2()
          scrleng=ileft-1
          scrtxt(1:scrleng)=term(1:ileft-1)
*** call routine which gets A00 as input and multiplies the other
***   matrices from the left
          call multiply2(scrleng,scrtxt,alpha,nbas,
     *                 iposA,posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,dkhadr,adrmem,
     *                 dkh_48,adrnext)
*** now: scr5(1,1,scrno1) contains the new A00
          call mat_copy(scr5(1,1,scrno1-1),nbas,nbas,scr5(1,1,scrno1))
*** now: scr5(1,1,scrno1-1) contains the A00 as before
*** set new length since A00 remains as it stands
          scrleng=scrleng-3
          do 72 i=4,length-scrleng
            term(i:i)=term(i+scrleng:i+scrleng)
  72      continue
          do 77 i=length-scrleng+1,length
            term(i:i)=' '
  77      continue
          length=length-scrleng
          ileft=ileft-scrleng
          iright=iright-scrleng
        end if
*** evaluate the directly following new bracket starting right after A00
*** include the energy denominators for the new bracket
*** first: determine string 'scrtxt' between these 2 brackets of 'term'
        scrleng=0
        scrleng=iright-ileft-1
c
c  note: at this stage there are no nested brackets in the second
c        bracket under consideration now as these terms would have been
c        evaluated already through evalstring()
c
*** initialize dummy string scrtxt
        scrtxt(1:scrleng)=term(ileft+1:iright-1)
        call multiply(scrleng,scrtxt,alpha,nbas,posu,post,poss,vv,nn,
     *                dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,
     *                tnumber,unumber,scr1,scr2,scr3,scr5(1,1,scrno1),
     *                darray,nbasp,nbaso,dkhadr,adrmem,dkh_48,adrnext)
        call mat_1_over_h2 (scr5(1,1,scrno1),nbas,e,darray)
*** new right-hand-side A00 is now on scr5(1,1,scrno1)
*** multiply both matrices: old A00 times new A00
        call DGEMM_('N','N',nbas,nbas,nbas,alpha,scr5(1,1,scrno1-1),
     *              nbas,scr5(1,1,scrno1),nbas,beta,darray,nbas)
*** now: scr5(1,1,scrno1-1) contains the new A00
        call mat_copy(scr5(1,1,scrno1-1),nbas,nbas,darray)
c
*** introduce a single A00 for later multiplication purposes, which is stored
*** in scr5(1,1,scrno1-1)
*** Update 'term', and copy rest of term 'idum1' positions to the left
        iposA=1
*** determine length for string in brackets including the two brackets (iright-ileft-1)+2
        idum1=iright-ileft+1
        do 73 i=4,length-idum1
          term(i:i)=term(i+idum1:i+idum1)
  73    continue
        do 78 i=length-idum1+1,length
          term(i:i)=' '
  78    continue
        length=length-idum1
c
*** there might be another bracket term directly following the ones already obtained
        goto 3150
c
      else if (iposA.eq.0.and.iright.ne.0) then
c
c-----------------------------------------------------------------------
c  c) difficult case: Evaluate innermost brackets [..] and substitute
c  -----------------          them by a single A00 expression in 'term'
c
c
*** determine string 'scrtxt' between these 2 brackets of 'term'
        scrleng=iright-ileft-1
c
c  If there was a bracket already present, this was already evaluated and
c    coded as A00 and already stored in scr5(1,1,scrno1-1);
c    adjust its position for scrtxt
c
        if (iposA.ne.0) then
          iposA=iposA-ileft
        end if
c
*** initialize dummy string scrtxt
        scrtxt(1:scrleng)=term(ileft+1:iright-1)
c
*** Evaluate scrtxt --> result is in scr5(,,scrno1) to be transformed
***   to [...] which is then in scr5(,,scrno1-1)
        if (flag) then
          call multiply(scrleng,scrtxt,alpha,nbas,posu,post,poss,vv,nn,
     *                dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,
     *                tnumber,unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                scr5(1,1,scrno1),nbasp,nbaso,dkhadr,adrmem,dkh_48,
     *                adrnext)
*** include the energy denominators
         call mat_1_over_h2 (scr5(1,1,scrno1-1),nbas,e,scr5(1,1,scrno1))
        else
CMR ACTUALLY, THIS CASE CAN NOW NO LONGER OCCUR
*** there was already a bracket present, i.e. we already stored a A00 in scr5
*** first multiply with all matrices from the right
*** note: the coefficient has to be alpha=1, not coeff in order to avoid
***       a double multiplication
          call multiply2(scrleng-iposA+1,scrtxt(iposA:scrleng),coeff,
     *                 nbas,iposA,posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,dkhadr,adrmem,
     *                 dkh_48,adrnext)
*** check whether there are also matrices to be multiplied from the left
          if (iposA.ne.1) then
            call multiply3(iposA-1,scrtxt(1:iposA-1),alpha,nbas,
     *                 posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1),
     *                 scr5(1,1,scrno1-1),nbasp,nbaso,dkhadr,adrmem,
     *                 dkh_48,adrnext)
            call mat_1_over_h2 (scr5(1,1,scrno1-1),nbas,e,
     *                          scr5(1,1,scrno1-1))
          else
*** include the energy denominators
            call mat_1_over_h2 (scr5(1,1,scrno1-1),nbas,e,
     *                          scr5(1,1,scrno1))
          end if
        end if
c
c
*** introduce a single A00 for later multiplication purposes, which is stored
*** in scr5(1,1,scrno1-1); all following multiplications start from A00 as the
*** left hand side factor and consider later eventually missing terms on the left
*** of A00.
*** Update 'term', and copy rest of term 'idum1' positions to the left
        term(ileft:ileft+2)='A00'
        iposA=ileft
        idum1=(iright-ileft+1)-3
        do 70 i=ileft+3,length-idum1
          term(i:i)=term(i+idum1:i+idum1)
  70    continue
        do 75 i=length-idum1+1,length
          term(i:i)=' '
  75    continue
        length=length-idum1
        flag=.false.
c
        goto 3150
c
      else
        write(stdout,*) "MIRACLE in evalstring2() !"
        call Abend
      endif
c
      return
      end
c
c
c
c
      subroutine evalstring2b(length,term,coeff,nbas,posu,post,poss,vv,
     *                       nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,
     *                       snumber,tnumber,unumber,scrno1,
     *                       scr1,scr2,scr3,scr5,nbasp,nbaso,darray,
     *                       ieval,count,dkhadr,adrmem,dkh_48,adrnext)
c
c************************************************************************
c
c   Evaluate the low-level character string 'term' of length 'length'
c     with coefficient 'coeff'. The result is stored in scr5(,,scrno1).
c
c   Note:  'term' might in general contain Sxxx, Txxx, and Uxxx expressions
c           as well as brackets [,], and V,N,D,Y,F,G,Z,Q,X,I,J,K,L,M  !!
c
c   This routine is essentially the same as evalstring2() with the
c     exception that it also tests for the dynamically allocated strings
c     in evalstring() !
c
c   scrno1 has to be 2 for the purposes here!
c
c   This SR belongs to dkhparser_numeric.
c
c   written by:  Markus Reiher  (ETH Zurich)
c
c   version:  1.1.0
c
c   modified: 13.03.07 MR@ETH
c   first version: 18.01.2007  (Theoretical Chemistry, ETH Zurich)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
#include "WrkSpc.fh"
c
      integer length,nbas,posu(maxunumber),post(maxsnumber),nbasp,
     *        poss(maxsnumber),snumber,tnumber,unumber,scrno1,count,
     *        ieval(count),nbaso
      character*(maxlength) term
      REAL*8 coeff
c
      REAL*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 pp(nbas),xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp),e(nbas)
      REAL*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),scr5(nbas,nbas,scrno1),
     *                 darray(nbas,nbas)
c
      integer i,idum1,ileft,iright,scrleng,iposA
      character*(maxlength) scrtxt
      REAL*8 alpha,beta
      logical flag
c
      integer dkh_48,adrmem,adrnext
      integer dkhadr(adrmem)
c
      flag=.true.
      alpha=1.0d0
      beta=0.0d0
      iposA=0
c
3150  continue
c
      iright=0
      ileft=0
c
c-----------------------------------------------------------------------
c  The sequence of evaluation of 'term' is determined by the position of
c    the brackets [].
c    --> Find first bracket ']' at iright and --- if available ---
c          corresponding '[' at ileft -> yields the innermost bracket
c------------------------------------------------------------------------
c
      iright=index(term(1:length),']')
*** determine position ileft of corresponding '['
      if (iright.ne.0) then
        ileft=iright-1
1065    continue
        if (term(ileft:ileft).ne.'[') then
          ileft=ileft-1
          goto 1065
        endif
        if (ileft.eq.0 .or. ileft.ge.iright) then
          write (stdout,1010) iright,term(1:maxlength)
1010      format (2X,'Error1 in SR evalstring: unbalanced occurrence ',
     *            'of brackets:',/2X,'] at pos = ',I2,', but no [ left',
     *            ' of it in term = ',A90)
          CALL Abend
        endif
      endif
c
      if (iright.eq.0) then
c
c-----------------------------------------------------------------------
c  a) Easy case: Direct evaluation from left to right of 'term' possible
c                because NO brackets occur at all
c  -------------
*** determine left-hand-side factor if it does not exist yet
        if (flag) then
          call multiplyb(length,term,coeff,nbas,posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,ieval,count,
     *                 dkhadr,adrmem,dkh_48,adrnext)
        else
*** in this case we have a left-hand factor in A00 already identified
***   and there is no additional bracket left over
*** first multiply with all matrices from the right
*** note: the coefficient has to be alpha=1, not coeff in order to avoid
***       a double multiplication
          call multiply2b(length-iposA+1,term(iposA:length),coeff,nbas,
     *                 iposA,posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,ieval,count,
     *                 dkhadr,adrmem,dkh_48,adrnext)
*** check whether there are also matrices to be multiplied from the left
          if (iposA.ne.1) then
            call multiply3b(iposA-1,term(1:iposA-1),alpha,nbas,
     *                 posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1),
     *                 scr5(1,1,scrno1-1),nbasp,nbaso,ieval,count,
     *                 dkhadr,adrmem,dkh_48,adrnext)
            call mat_copy(scr5(1,1,scrno1),nbas,nbas,scr5(1,1,scrno1-1))
          end if
        end if
c
      else if (iright.ne.0.and.iposA.ne.0) then
c
c-----------------------------------------------------------------------
c  b) most difficult case: the previously found brackets are not embraced
c                          by the new ones but additional brackets show up
c                          directly after the first bracket on the left
c                          was closed (other cases are not permitted by evalstring() )
c                          like in ...[...]...[...] and the first
c                          brackets were already found
c
*** first check if 'old' A00 must be multiplied by matrices from the left
        if (iposA.ne.1) then
          call multiply3b(iposA-1,term(1:iposA-1),alpha,nbas,
     *                 posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,ieval,count,
     *                 dkhadr,adrmem,dkh_48,adrnext)
*** now: scr5(1,1,scrno1) contains the new A00
          call mat_copy(scr5(1,1,scrno1-1),nbas,nbas,scr5(1,1,scrno1))
*** idum1 is the length of the matrices on the left of A00
          idum1=iposA-1
          do 71 i=1,length-idum1
            term(i:i)=term(i+idum1:i+idum1)
  71      continue
*** account for new iposA
          iposA=1
          do 76 i=length-idum1+1,length
            term(i:i)=' '
  76      continue
          length=length-idum1
          ileft=ileft-idum1
          iright=iright-idum1
        end if
*** now check if there are matrices between 1st [...] and 2nd [...]
        if (iposA+3.ne.ileft) then
*** store matrix string befor '[' of length (ileft-1); note that
***   A00 is to be included because it is dealt with in multiply2()
          scrleng=ileft-1
          scrtxt(1:scrleng)=term(iposA+3:ileft-1)
*** call routine which gets A00 as input and multiplies the other
***   matrices from the left
          call multiply2b(scrleng,scrtxt,alpha,nbas,
     *                 iposA,posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,ieval,count,
     *                 dkhadr,adrmem,dkh_48,adrnext)
*** now: scr5(1,1,scrno1) contains the new A00
          call mat_copy(scr5(1,1,scrno1-1),nbas,nbas,scr5(1,1,scrno1))
*** now: scr5(1,1,scrno1-1) contains the A00 as before
*** set new length since A00 remains as it stands
          scrleng=scrleng-3
          do 72 i=4,length-scrleng
            term(i:i)=term(i+scrleng:i+scrleng)
  72      continue
          do 77 i=length-scrleng+1,length
            term(i:i)=' '
  77      continue
          length=length-scrleng
          ileft=ileft-scrleng
          iright=iright-scrleng
        end if
*** evaluate the directly following new bracket starting right after A00
*** include the energy denominators for the new bracket
*** first: determine string 'scrtxt' between these 2 brackets of 'term'
        scrleng=0
        scrleng=iright-ileft-1
c
c  note: at this stage there are no nested brackets in the second
c        bracket under consideration now as these terms would have been
c        evaluated already through evalstring()
c
*** initialize dummy string scrtxt
        scrtxt(1:scrleng)=term(ileft+1:iright-1)
        call multiplyb(scrleng,scrtxt,alpha,nbas,posu,post,poss,vv,nn,
     *                dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,
     *                tnumber,unumber,scr1,scr2,scr3,scr5(1,1,scrno1),
     *                darray,nbasp,nbaso,ieval,count,dkhadr,adrmem,
     *                dkh_48,adrnext)
        call mat_1_over_h2 (scr5(1,1,scrno1),nbas,e,darray)
*** new right-hand-side A00 is now on scr5(1,1,scrno1)
*** multiply both matrices: old A00 times new A00
        call DGEMM_('N','N',nbas,nbas,nbas,alpha,scr5(1,1,scrno1-1),
     *              nbas,scr5(1,1,scrno1),nbas,beta,darray,nbas)
*** now: scr5(1,1,scrno1-1) contains the new A00
        call mat_copy(scr5(1,1,scrno1-1),nbas,nbas,darray)
c
*** introduce a single A00 for later multiplication purposes, which is stored
*** in scr5(1,1,scrno1-1)
*** Update 'term', and copy rest of term 'idum1' positions to the left
        iposA=1
*** determine length for string in brackets including the two brackets (iright-ileft-1)+2
        idum1=iright-ileft+1
        do 73 i=4,length-idum1
          term(i:i)=term(i+idum1:i+idum1)
  73    continue
        do 78 i=length-idum1+1,length
          term(i:i)=' '
  78    continue
        length=length-idum1
c
*** there might be another bracket term directly following the ones already obtained
        goto 3150
c
      else if (iposA.eq.0.and.iright.ne.0) then
c
c-----------------------------------------------------------------------
c  c) difficult case: Evaluate innermost brackets [..] and substitute
c  -----------------          them by a single A00 expression in 'term'
c
c
*** determine string 'scrtxt' between these 2 brackets of 'term'
        scrleng=iright-ileft-1
c
c  If there was a bracket already present, this was already evaluated and
c    coded as A00 and already stored in scr5(1,1,scrno1-1);
c    adjust its position for scrtxt
c
        if (iposA.ne.0) then
          iposA=iposA-ileft
        end if
c
*** initialize dummy string scrtxt
        scrtxt(1:scrleng)=term(ileft+1:iright-1)
c
*** Evaluate scrtxt --> result is in scr5(,,scrno1) to be transformed
***   to [...] which is then in scr5(,,scrno1-1)
        if (flag) then
          call multiplyb(scrleng,scrtxt,alpha,nbas,posu,post,poss,vv,nn,
     *                dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,
     *                tnumber,unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                scr5(1,1,scrno1),nbasp,nbaso,ieval,count,dkhadr,
     *                adrmem,dkh_48,adrnext)
*** include the energy denominators
         call mat_1_over_h2 (scr5(1,1,scrno1-1),nbas,e,scr5(1,1,scrno1))
        else
CMR ACTUALLY, THIS CASE CAN NO LONGER OCCUR
*** there was already a bracket present, i.e. we already stored a A00 in scr5
*** first multiply with all matrices from the right
*** note: the coefficient has to be alpha=1, not coeff in order to avoid
***       a double multiplication
          call multiply2b(scrleng-iposA+1,scrtxt(iposA:scrleng),coeff,
     *                 nbas,iposA,posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1-1),
     *                 scr5(1,1,scrno1),nbasp,nbaso,ieval,count,
     *                 dkhadr,adrmem,dkh_48,adrnext)
*** check whether there are also matrices to be multiplied from the left
          if (iposA.ne.1) then
            call multiply3b(iposA-1,scrtxt(1:iposA-1),alpha,nbas,
     *                 posu,post,poss,vv,nn,dd,
     *                 yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,snumber,tnumber,
     *                 unumber,scr1,scr2,scr3,scr5(1,1,scrno1),
     *                 scr5(1,1,scrno1-1),nbasp,nbaso,ieval,count,
     *                 dkhadr,adrmem,dkh_48,adrnext)
            call mat_1_over_h2 (scr5(1,1,scrno1-1),nbas,e,
     *                          scr5(1,1,scrno1-1))
          else
*** include the energy denominators
            call mat_1_over_h2 (scr5(1,1,scrno1-1),nbas,e,
     *                          scr5(1,1,scrno1))
          end if
        end if
c
c
*** introduce a single A00 for later multiplication purposes, which is stored
*** in scr5(1,1,scrno1-1); all following multiplications start from A00 as the
*** left hand side factor and consider later eventually missing terms on the left
*** of A00.
*** Update 'term', and copy rest of term 'idum1' positions to the left
        term(ileft:ileft+2)='A00'
        iposA=ileft
        idum1=(iright-ileft+1)-3
        do 70 i=ileft+3,length-idum1
          term(i:i)=term(i+idum1:i+idum1)
  70    continue
        do 75 i=length-idum1+1,length
          term(i:i)=' '
  75    continue
        length=length-idum1
        flag=.false.
c
        goto 3150
c
      else
        write(stdout,*) "MIRACLE in evalstring2b() !"
        call Abend
      endif
c
      return
      end
c
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Naoki Nakatani                                   *
!***********************************************************************

subroutine TWO2ONERDM(NA,NE,G2,G1)
! Compute 1-RDM from 2-RDM
! Written by N. Nakatani, Oct. 2014

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NA, NE
real(kind=wp), intent(in) :: G2(NA,NA,NA,NA)
real(kind=wp), intent(out) :: G1(NA,NA)
integer(kind=iwp) :: I, J, K
real(kind=wp) :: G1TMP

do I=1,NA
  do J=1,NA
    G1TMP = Zero
    do K=1,NA
      G1TMP = G1TMP+G2(K,K,J,I)
    end do
    G1(J,I) = G1TMP/real(NE-1,kind=wp)
  end do
end do

end subroutine TWO2ONERDM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
*  Get_nAtoms_Full
*
*> @author I. Fdez. Galv&aacute;n
*>
*> @details
*> Get number of all atoms (not only symmetry unique) from RUNFILE,
*> including MM atoms otherwise invisible to gateway/slapaf.
*>
*> @param[out] nAtoms_Full Number of all atoms in the system
************************************************************************
      Subroutine Get_nAtoms_Full(nAtoms_Full)
      Implicit None
      Integer nAtoms_Full,nAtom,nAtMM
      Logical Found
*
      Call Get_nAtoms_All(nAtom)
      Call Qpg_dArray('MMO Coords',Found,nAtMM)
      nAtoms_Full=nAtom+nAtMM/3
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3sglh311(w,dima,dimb,dimbc,s1,d1,ns)
! this routine adds following contribution to W
! for syma;symb=symc
!
! W(a;bc)  <- + S1 _i(b) . D1 _jk(a,c)
! - S1 _i(c) . D2 _jk(a,b)
!
! w     - W matrix (I/O)
! dima  - dimension of a index (I)
! dimb  - dimension of b (c) index (I)
! dimbc - dimension of bc index (I)
! s1    - S1 matrix (I)
! s2    - S2 matrix (I)
! d1    - D1 matrix (I)
! d2    - D2 matrix (I)
! ns    - signum of the contribution (+-1) (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimbc, ns
real(kind=wp), intent(inout) :: w(dima,dimbc)
real(kind=wp), intent(in) :: s1(dimb), d1(dima,dimb)
integer(kind=iwp) :: b, bc, c

if (ns == 1) then
  ! phase +1

  bc = 0
  do b=2,dimb
    w(:,bc+1:bc+b-1) = w(:,bc+1:bc+b-1)+d1(:,1:b-1)*s1(b)
    bc = bc+b-1
  end do

  bc = 0
  do b=2,dimb
    do c=1,b-1
      bc = bc+1
      w(:,bc) = w(:,bc)-d1(:,b)*s1(c)
    end do
  end do

else
  ! phase - 1

  bc = 0
  do b=2,dimb
    w(:,bc+1:bc+b-1) = w(:,bc+1:bc+b-1)-d1(:,1:b-1)*s1(b)
    bc = bc+b-1
  end do

  bc = 0
  do b=2,dimb
    do c=1,b-1
      bc = bc+1
      w(:,bc) = w(:,bc)+d1(:,b)*s1(c)
    end do
  end do

end if

return

end subroutine t3sglh311

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Diff_Aux1(nEPotPoints,ipEPCo,nB,OneFile)
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"
#include "warnings.fh"

      Character*10 Label,OneFile
      Dimension nInt(1)

*
*-- Open One-electron file.
*
      irc=-1
      Lu_One=49
      Lu_One=IsFreeUnit(Lu_One)
      Call OpnOne(irc,0,OneFile,Lu_One)
      If(irc.ne.0) then
        Write(6,*)
        Write(6,*)'ERROR! Could not open one-electron integral file.'
        Call Quit(_RC_IO_ERROR_READ_)
      Endif

*
*-- Loop over all EF0, terminate when return-code is non-zero.
*
      nEPotPoints=0
      maxCen=99999
      Call GetMem('Temporary','Allo','Real',iTmp,maxCen*3)
      Call GetMem('Idiot','Allo','Real',idiot,nB*(nB+1)/2+4)
      Do i=1,maxCen
        Write(Label,'(A3,I5)')'EF0',i
        irc=-1
        iopt=1
        iSmLbl=0
        Call iRdOne(irc,iopt,label,1,nInt,iSmLbl)
        If(irc.ne.0) Go To 9901
        irc=-1
        iopt=0
        iSmLbl=0
        Call RdOne(irc,iopt,label,1,Work(idiot),iSmLbl)
        Work(iTmp+(i-1)*3+0)=Work(idiot+nInt(1)+0)
        Work(iTmp+(i-1)*3+1)=Work(idiot+nInt(1)+1)
        Work(iTmp+(i-1)*3+2)=Work(idiot+nInt(1)+2)
        nEPotPoints=nEPotPoints+1
      Enddo
9901  Continue

*
*-- Put the coordinates and nuclear part in nice and tight vectors.
*
      Call GetMem('PotPointCoord','Allo','Real',ipEPCo,3*nEPotPoints)
      call dcopy_(3*nEPotPoints,Work(iTmp),1,Work(ipEPCo),1)

*
*-- Deallocate.
*
      Call GetMem('Temporary','Free','Real',iTmp,maxCen*3)
      Call GetMem('Idiot','Free','Real',idiot,nB*(nB+1)/2+4)


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Stefan Knecht                                    *
!***********************************************************************
module qcmaquis_info

 implicit none

 type qcm_names
 character(len=256), allocatable :: states(:)
 end type

 type(qcm_names), public, allocatable :: qcm_group_names(:)

 save

 contains

 subroutine qcmaquis_info_init(igroup,nstates,tag)

   integer, intent(in) :: igroup, nstates, tag

   if(tag == 0)then
     allocate(qcm_group_names(igroup))
   else if(tag == 1)then
     allocate(qcm_group_names(igroup)%states(nstates)); qcm_group_names(igroup)%states = ''
   else if(tag == -1)then
     allocate(qcm_group_names(igroup))
     allocate(qcm_group_names(igroup)%states(nstates)); qcm_group_names(igroup)%states = ''
   else
     write(6,*) 'unknown tag in qcmaquis_info_init'
     call abend()
   end if
 end subroutine qcmaquis_info_init

 subroutine qcmaquis_info_deinit
   integer             :: i
   if(.not.allocated(qcm_group_names)) return
   do i = 1, size(qcm_group_names)
     if(.not.allocated(qcm_group_names)) return
     if(allocated(qcm_group_names(i)%states)) deallocate(qcm_group_names(i)%states)
   end do
   deallocate(qcm_group_names)
 end subroutine qcmaquis_info_deinit

end module qcmaquis_info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CoSet(iCoSet,nCoSet,iChAtom)
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (A-H,O-Z)
      Integer iCoSet(0:7)
      Logical Same
*
*     Find the coset representatives
*
      iCoSet(0) = 0      ! Put in the unit operator
      nCoSet = 1
      Do iIrrep = 1, nIrrep-1
         itest=iAnd(iChAtom,iOper(iIrrep))
         Same = .False.
         Do jCoSet = 0, nCoSet-1
            jTest = iAnd(iChAtom,iCoSet(jCoSet))
            Same = Same .or. jTest.eq.iTest
         End Do
         If (.Not.Same) Then
            nCoSet = nCoSet + 1
            iCoSet(nCoSet-1) = iOper(iIrrep)
         End If
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine FckAcc_NoSymq(iCmp,jCmp,kCmp,lCmp,Shijij,iShell,nijkl,AOInt,FMat,DMat,nDens,iAO,iAOst,iBas,jBas,kBas,lBas,DoCoul, &
                         DoExch,Dij,Dkl,Dik,Dil,Djk,Djl,ExFac)
!***********************************************************************
!                                                                      *
!  Object: to accumulate contributions from the AO integrals directly  *
!          to the symmetry adapted Fock matrix.                        *
!                                                                      *
!          This version uses square density and fock matrices          *
!          Modifications by HJW, 28.12.98                              *
!                                                                      *
!          The indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!          In addition to this complication we have that the order of  *
!          indices in the integrals are not ordered canonically but    *
!          rather in an order such that the contraction step will be   *
!          optimal. Hence, special care has to be taken when tracing   *
!          the density with the integrals so that both entities have   *
!          the same order.                                             *
!                                                                      *
!          The Fock matrix is computed in lower triangular form.       *
!                                                                      *
!          The density matrix is not folded if the shell indices and   *
!          the angular indices are identical.                          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden. February '93                            *
!***********************************************************************

use SOAO_Info, only: iAOtSO
use Basis_Info, only: nBas
use Gateway_Info, only: ThrInt
use Constants, only: Zero, One, Four, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCmp, jCmp, kCmp, lCmp, iShell(4), nijkl, nDens, iAO(4), iAOst(4), iBas, jBas, kBas, lBas
logical(kind=iwp), intent(in) :: Shijij, DoCoul, DoExch
real(kind=wp), intent(in) :: AOInt(nijkl,iCmp,jCmp,kCmp,lCmp), DMat(nDens), Dij, Dkl, Dik, Dil, Djk, Djl, ExFac
real(kind=wp), intent(inout) :: FMat(nDens)
integer(kind=iwp), parameter :: nCBMax = 200
integer(kind=iwp) :: i, i1, i2, i3, i4, ic, icb, ii, ij, ij_, ijkl, ik, il, Indx(3,nCBMax,4), iSO, j, jcb, jj, jk, jl, jSO, k, &
                     kcb, kk, kl, kl_, kSO, l, lcb, ll, lSO, nBasx(4), ncb_Max, nCmpx(4), nij, ntg
real(kind=wp) :: AOijkl, DMax, Fac, Fac_C, Fac_E, Thr
logical(kind=iwp) :: Shij, Shkl
#ifdef _DEBUGPRINT_
real(kind=wp), external :: DDot_
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
if ((.not. DoExch) .and. (.not. DoCoul)) return
#ifdef _DEBUGPRINT_
!write(u6,*) DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1),DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One,0)
write(u6,*) iCmp,jCmp,kCmp,lCmp
write(u6,*) 'iAO=',iAO
write(u6,*) 'iAOst=',iAOst
write(u6,*) 'iShell=',iShell
write(u6,*) DoCoul,DoExch,Shijij
write(u6,*) 'FMAT,DMAT=',DDot_(nDens,FMat,1,[One],0),DDot_(nDens,DMat,1,[One],0)
write(u6,*) ' FckAcc:AOIn',DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1),DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,[One],0)
#endif

DMax = max(Dij,Dkl,Dik,Dil,Djk,Djl)
if (DMax <= Zero) return
thr = ThrInt/DMax

Shij = (iShell(1) == iShell(2))
Shkl = (iShell(3) == iShell(4))
ntg = nbas(0)
Fac = One
if (Shij) Fac = Fac*Half
if (Shkl) Fac = Fac*Half
if (Shijij) Fac = Fac*Half
Fac_C = Four*Fac
Fac_E = -Fac*Exfac
!if (nijkl /= ibas*jbas*kbas*lbas) call SysHalt('fckacc_nosymq')

nCmpx(1) = iCmp
nCmpx(2) = jCmp
nCmpx(3) = kCmp
nCmpx(4) = lCmp
nBasx(1) = iBas
nBasx(2) = jBas
nBasx(3) = kBas
nBasx(4) = lBas
nCB_Max = max(iCmp*iBas,jCmp*jBas,kCmp*kBas,lCmp*lBas)
if (nCB_Max > nCBMax) then
  call WarningMessage(2,'FckAcc_NoSymq: nCB_Max > nCBMax')
  write(u6,*) 'nCB_Max=',nCB_Max
  call Abend()
end if
do ii=1,4
  iCB = 0
  do iC=1,nCmpx(ii)
    iSO = iAOtSO(iAO(ii)+iC,0)+iAOSt(ii)
    do i=1,nBasx(ii)
      iCB = iCB+1
      Indx(1,iCB,ii) = iC
      Indx(2,iCB,ii) = i
      Indx(3,iCB,ii) = iSO
      iSO = iSO+1
    end do
  end do
end do

nij = iBas*jBas

if (.not. DoExch) then
  do lCB=1,lCmp*lBas
    i4 = Indx(1,lCB,4)
    l = Indx(2,lCB,4)
    lSO = Indx(3,lCB,4)
    ll = (lSO-1)*ntg

    do kCB=1,kCmp*kBas
      i3 = Indx(1,kCB,3)
      k = Indx(2,kCB,3)
      kSO = Indx(3,kCB,3)
      kk = (kSO-1)*ntg
      kl = ll+kSO

      kl_ = (l-1)*kBas+k

      do jCB=1,jCmp*jBas
        i2 = Indx(1,jCB,2)
        j = Indx(2,jCB,2)
        jSO = Indx(3,jCB,2)
        jj = (jSO-1)*ntg

        do iCB=1,iCmp*iBas
          i1 = Indx(1,iCB,1)
          i = Indx(2,iCB,1)
          iSO = Indx(3,iCB,1)
          ij = jj+iSO

          ij_ = (j-1)*iBas+i
          ijkl = (kl_-1)*nij+ij_
          AOijkl = Fac_C*AOInt(ijkl,i1,i2,i3,i4)

          if (abs(AOijkl) > Thr) then

            FMat(ij) = FMat(ij)+AOijkl*DMat(kl)
            FMat(kl) = FMat(kl)+AOijkl*DMat(ij)

          end if
        end do
      end do
    end do
  end do
else if (.not. DoCoul) then
  do lCB=1,lCmp*lBas
    i4 = Indx(1,lCB,4)
    l = Indx(2,lCB,4)
    lSO = Indx(3,lCB,4)
    ll = (lSO-1)*ntg

    do kCB=1,kCmp*kBas
      i3 = Indx(1,kCB,3)
      k = Indx(2,kCB,3)
      kSO = Indx(3,kCB,3)
      kk = (kSO-1)*ntg

      kl_ = (l-1)*kBas+k

      do jCB=1,jCmp*jBas
        i2 = Indx(1,jCB,2)
        j = Indx(2,jCB,2)
        jSO = Indx(3,jCB,2)
        jk = kk+jSO
        jl = ll+jSO

        do iCB=1,iCmp*iBas
          i1 = Indx(1,iCB,1)
          i = Indx(2,iCB,1)
          iSO = Indx(3,iCB,1)
          ik = kk+iSO
          il = ll+iSO

          ij_ = (j-1)*iBas+i
          ijkl = (kl_-1)*nij+ij_
          AOijkl = Fac_E*AOInt(ijkl,i1,i2,i3,i4)

          if (abs(AOijkl) > Thr) then

            FMat(ik) = FMat(ik)+AOijkl*DMat(jl)
            FMat(il) = FMat(il)+AOijkl*DMat(jk)
            FMat(jl) = FMat(jl)+AOijkl*DMat(ik)
            FMat(jk) = FMat(jk)+AOijkl*DMat(il)

          end if
        end do
      end do
    end do
  end do
else
  do lCB=1,lCmp*lBas
    i4 = Indx(1,lCB,4)
    l = Indx(2,lCB,4)
    lSO = Indx(3,lCB,4)
    ll = (lSO-1)*ntg

    do kCB=1,kCmp*kBas
      i3 = Indx(1,kCB,3)
      k = Indx(2,kCB,3)
      kSO = Indx(3,kCB,3)
      kk = (kSO-1)*ntg
      kl = ll+kSO

      kl_ = (l-1)*kBas+k

      do jCB=1,jCmp*jBas
        i2 = Indx(1,jCB,2)
        j = Indx(2,jCB,2)
        jSO = Indx(3,jCB,2)
        jj = (jSO-1)*ntg
        jk = kk+jSO
        jl = ll+jSO

        do iCB=1,iCmp*iBas
          i1 = Indx(1,iCB,1)
          i = Indx(2,iCB,1)
          iSO = Indx(3,iCB,1)
          ik = kk+iSO
          il = ll+iSO
          ij = jj+iSO

          ij_ = (j-1)*iBas+i
          ijkl = (kl_-1)*nij+ij_
          AOijkl = AOInt(ijkl,i1,i2,i3,i4)
          if (abs(AOijkl) > Thr) then

            FMat(ij) = FMat(ij)+Fac_C*AOijkl*DMat(kl)
            FMat(kl) = FMat(kl)+Fac_C*AOijkl*DMat(ij)
            FMat(ik) = FMat(ik)+Fac_E*AOijkl*DMat(jl)
            FMat(il) = FMat(il)+Fac_E*AOijkl*DMat(jk)
            FMat(jl) = FMat(jl)+Fac_E*AOijkl*DMat(ik)
            FMat(jk) = FMat(jk)+Fac_E*AOijkl*DMat(il)

          end if
        end do
      end do
    end do
  end do
end if

!write(u6,*) 'FMAT,DMAT=',DDot_(nDens,FMat,1,One,0),DDot_(nDens,DMat,1,One,0)

return

end subroutine FckAcc_NoSymq

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Per Ake Malmqvist                                *
!***********************************************************************
!****************************************************************
!  PROGRAM RASSI        PER-AAKE MALMQVIST
!  SUBROUTINE WRMAT     IBM-3090 RELEASE 89 01 31
!  PRINT OUT A SYMMETRY-BLOCKED MATRIX. THE COMBINED SYMMETRY
!  OF ROWS AND COLUMNS IS ISY12. NDIM1 GIVES THE NUMBER OF
!  OF ROWS WITHIN EACH SYMMETRY TYPE, SIMILAR NDIM2, COLUMNS.
!****************************************************************

subroutine WRMAT(TEXT,ISY12,NDIM1,NDIM2,NMAT,XMAT)

use Symmetry_Info, only: MUL, nIrrep
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: TEXT
integer(kind=iwp), intent(in) :: ISY12, NDIM1(nIrrep), NDIM2(nIrrep), NMAT
real(kind=wp) :: XMAT(NMAT)
integer(kind=iwp) :: ISTA, ISY1, ISY2, NN

ISTA = 1
write(u6,'(/,1X,A,/)') TEXT
do ISY1=1,nIrrep
  ISY2 = MUL(ISY1,ISY12)
  NN = NDIM1(ISY1)*NDIM2(ISY2)
  if (NN /= 0) then
    write(u6,*)
    write(u6,'(A,2I2)') ' SYMMETRY LABELS OF ROWS/COLS:',ISY1,ISY2
    call WRMAT1(NDIM1(ISY1),NDIM2(ISY2),XMAT(ISTA))
  end if
  ISTA = ISTA+NN
end do
write(u6,*)
write(u6,*) repeat('*',80)

end subroutine WRMAT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ICOPY(n,x,incX,y,incY)
!***********************************************************************
!                                                                      *
!     Copy vector X into vector Y                                      *
!                                                                      *
!     calling arguments:                                               *
!     N       : Integer, input.                                        *
!               Number of input elements.                              *
!     X       : Array of Integer, input.                               *
!               Input vector, X.                                       *
!     incX    : Integer, input.                                        *
!               Stride of vector X.                                    *
!     Y       : Array of Integer, output.                              *
!               Output vector, Y.                                      *
!     incY    : Integer, input.                                        *
!               Stride of vector Y.                                    *
!                                                                      *
!***********************************************************************

use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: n, x(*), incx, incy
integer(kind=iwp), intent(_OUT_) :: y(*)
integer(kind=iwp) :: i, ix, iy, m, mp1

! copies integer vector, x, to integer vector, y.
! uses unrolled loops for increments equal to one.
if (n <= 0) return
if ((incx == 1) .and. (incy == 1)) then

  ! code for both increments equal to 1

  ! clean-up loop

  m = mod(n,7)
  if (m /= 0) y(1:m) = x(1:m)
  if ((m == 0) .or. (n >= 7)) then
    mp1 = m+1
    do i=mp1,n,7
      y(i:i+6) = x(i:i+6)
    end do
  end if

else

  ! code for unequal increments or equal increments not equal to 1

  ix = 1
  iy = 1
  if (incx < 0) ix = (-n+1)*incx+1
  if (incy < 0) iy = (-n+1)*incy+1
  do i=1,n
    y(iy) = x(ix)
    ix = ix+incx
    iy = iy+incy
  end do

end if

return

end subroutine ICOPY

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Roland Lindh                                     *
!               1994, Luis Seijo                                       *
!***********************************************************************

subroutine SROInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of MP integrals.          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, and Luis Seijo, Dept. of Applied Phys-  *
!             ical Chemistry, the Free University of Madrid, Spain,    *
!             September '94.                                           *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp, Shells
use Center_Info, only: dc
use Real_Spherical, only: ipSph, RSph
use Symmetry_Info, only: iChTbl, nIrrep
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: ia, iaC, iAng, ib, iC, iCb, iCnt, iCnttp, iComp, iDCRT(0:7), iIC, iIrrep, ip, ipaC, ipC, ipCb, ipF1, ipF2, &
                     ipK1, ipK2, ipP1, ipP2, iPrint, ipTmp, ipZ1, ipZ2, ipZI1, ipZI2, iRout, iShll, l, lDCRT, llOper, LmbdT, mArr, &
                     mdc, nac, ncb, nDCRT, nExpi, nOp
real(kind=wp) :: C(3), Fact, Factor, TC(3), Xg
character(len=80) :: Label
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(Zeta)
unused_var(ZInv)
unused_var(rKappa)
unused_var(iChO)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 191
iPrint = nPrint(iRout)

if (iPrint >= 49) then
  call RecPrt(' In SROInt: A',' ',A,1,3)
  call RecPrt(' In SROInt: RB',' ',RB,1,3)
  call RecPrt(' In SROInt: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In SROInt: P',' ',P,nZeta,3)
  write(u6,*) ' In SROInt: la,lb=',' ',la,lb
end if

rFinal(:,:,:,:) = Zero

llOper = lOper(1)
iComp = 1
mdc = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%ECP .and. (dbsc(iCnttp)%nSRO > 0)) then
    do iCnt=1,dbsc(iCnttp)%nCntr
      C(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

      call DCR(LmbdT,iStabM,nStabM,dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,iDCRT,nDCRT)
      Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

      do lDCRT=0,nDCRT-1
        call OA(iDCRT(lDCRT),C,TC)
        do iAng=0,dbsc(iCnttp)%nSRO-1
          iShll = dbsc(iCnttp)%iSRO+iAng
          nExpi = Shells(iShll)%nExp
          if (nExpi == 0) cycle

          ip = 1
          ipC = ip
          ip = ip+nExpi**2

          if (iPrint >= 49) call RecPrt(' The Akl matrix',' ',Shells(iShll)%Akl(:,:,1),nExpi,nExpi)
          Array(ipC:ipC+nExpi**2-1) = pack(Shells(iShll)%Akl(:,:,1),.true.)
          if (EQ(A,RB) .and. EQ(A,TC) .and. dbsc(iCnttp)%NoPair) then
            if (iPrint >= 49) call RecPrt(' The Adl matrix',' ',Shells(iShll)%Akl(:,:,2),nExpi,nExpi)
            Array(ipC:ipC+nExpi**2-1) = Array(ipC:ipC+nExpi**2-1)+pack(Shells(iShll)%Akl(:,:,2),.true.)
          end if

          ipF1 = ip
          nac = nTri_Elem1(la)*nTri_Elem1(iAng)
          ip = ip+nAlpha*nExpi*nac
          ipP1 = ip
          ip = ip+3*nAlpha*nExpi
          ipZ1 = ip
          ip = ip+nAlpha*nExpi
          ipK1 = ip
          ip = ip+nAlpha*nExpi
          ipZI1 = ip
          ip = ip+nAlpha*nExpi
          if (ip-1 > nArr*nZeta) then
            call WarningMessage(2,'SROInt: ip-1 > nArr*nZeta(1)')
            write(u6,*) ' nArr, nZeta=',nArr,nZeta
            write(u6,*) ' nac, nAlpha=',nac,nAlpha
            write(u6,*) ' nExpi=',nExpi
            call Abend()
          end if
          mArr = (nArr*nZeta-(ip-1))/nZeta

          ! Calculate Effective center and exponent for <A|alm>

          call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,nExpi,Alpha,Shells(iShll)%Exp)
          call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))

          ! Calculate Overlap <A|alm>

          nHer = (la+iAng+2)/2
          call MltPrm(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,Array(ipZ1),Array(ipZI1),Array(ipK1),Array(ipP1),Array(ipF1), &
                      nAlpha*nExpi,iComp,la,iAng,A,TC,nHer,Array(ip),mArr,CCoor,nOrdOp)
          if (iPrint >= 99) call RecPrt('<a|srbs>',' ',Array(ipF1),nAlpha*nExpi,nac)
          ip = ip-6*nAlpha*nExpi

          ipF2 = ip
          ncb = nTri_Elem1(iAng)*nTri_Elem1(lb)
          ip = ip+nExpi*nBeta*ncb
          ipP2 = ip
          ip = ip+3*nExpi*nBeta
          ipZ2 = ip
          ip = ip+nExpi*nBeta
          ipK2 = ip
          ip = ip+nExpi*nBeta
          ipZI2 = ip
          ip = ip+nExpi*nBeta
          if (ip-1 > nArr*nZeta) then
            call WarningMessage(2,'SROInt: ip-1 > nArr*nZeta(2)')
            call Abend()
          end if
          mArr = (nArr*nZeta-(ip-1))/nZeta

          ! Calculate Effective center and exponent for <blm|B>

          call ZXia(Array(ipZ2),Array(ipZI2),nExpi,nBeta,Shells(iShll)%Exp,Beta)
          call SetUp1(Shells(iShll)%Exp,nExpi,Beta,nBeta,TC,RB,Array(ipK2),Array(ipP2),Array(ipZI2))

          ! Calculate Overlap <blm|B>

          nHer = (iAng+lb+2)/2
          call MltPrm(Shells(iShll)%Exp,nExpi,Beta,nBeta,Array(ipZ2),Array(ipZI2),Array(ipK2),Array(ipP2),Array(ipF2),nExpi*nBeta, &
                      iComp,iAng,lb,TC,RB,nHer,Array(ip),mArr,CCoor,nOrdOp)
          if (iPrint >= 99) call RecPrt('<srbs|b>',' ',Array(ipF2),nExpi*nBeta,ncb)
          ip = ip-6*nExpi*nBeta
          ipTmp = ip
          ip = ip+max(nAlpha*nExpi*nac,nExpi*nBeta*ncb)
          if (ip-1 > nArr*nZeta) then
            call WarningMessage(2,'SROInt: ip-1 > nArr*nZeta(3)')
            call Abend()
          end if

          ! Calculate Contraction over the spectral resolvent basis
          ! set of the type <A|alm>A(l;ab)<blm|B> where we now have in
          ! Array(ipF1) the cartesian components of <A|alm>, and
          ! similarily, in Array(ipF2), we have stored the cartesian
          ! components of <alm|B>. Observe that as opposed to the
          ! projection operator that this contraction is done in the
          ! primitive basis.

          ! From the lefthandside overlap, form ikaC from ikac by
          ! 1) ika,c -> c,ika

          call DgeTMo(Array(ipF1),nAlpha*nExpi*nTri_Elem1(la),nAlpha*nExpi*nTri_Elem1(la),nTri_Elem1(iAng),Array(ipTmp), &
                      nTri_Elem1(iAng))

          ! 2) ika,C = c,ika * c,C

          call DGEMM_('T','N',nAlpha*nExpi*nTri_Elem1(la),(2*iAng+1),nTri_Elem1(iAng),One,Array(ipTmp),nTri_Elem1(iAng), &
                      RSph(ipSph(iAng)),nTri_Elem1(iAng),Zero,Array(ipF1),nAlpha*nExpi*nTri_Elem1(la))
          if (iPrint >= 99) call RecPrt('<A|srbs>',' ',Array(ipF1),nAlpha*nExpi,nTri_Elem1(la)*(2*iAng+1))

          ! And (almost) the same thing for the righthand side, form
          ! kjCb from kjcb
          ! 1) kj,cb -> cb,kj

          call DgeTMo(Array(ipF2),nBeta*nExpi,nBeta*nExpi,nTri_Elem1(iAng)*nTri_Elem1(lb),Array(ipTmp), &
                      nTri_Elem1(iAng)*nTri_Elem1(lb))

          ! 2) bkj,C = c,bkj * c,C

          call DGEMM_('T','N',nTri_Elem1(lb)*nExpi*nBeta,(2*iAng+1),nTri_Elem1(iAng),One,Array(ipTmp),nTri_Elem1(iAng), &
                      RSph(ipSph(iAng)),nTri_Elem1(iAng),Zero,Array(ipF2),nTri_Elem1(lb)*nExpi*nBeta)

          ! 3) b,kjC -> kjC,b

          call DgeTMo(Array(ipF2),nTri_Elem1(lb),nTri_Elem1(lb),nExpi*nBeta*(2*iAng+1),Array(ipTmp),nExpi*nBeta*(2*iAng+1))
          l = nExpi*nBeta*(2*iAng+1)*nTri_Elem1(lb)
          Array(ipF2:ipF2+l-1) = Array(ipTmp:ipTmp+l-1)
          if (iPrint >= 99) call RecPrt('<srbs|B>',' ',Array(ipF2),nExpi*nBeta,(2*iAng+1)*nTri_Elem1(lb))

          ! Next Contract (ikaC)*(klC)*(ljCb) over k,l and C,
          ! producing ijab,
          ! by the following procedure:
          ! Loop over a and b
          !   Loop over C
          !     Contract ik(aC)*kl(C), over k producing il(aC),
          !     Contract il(aC)*lj(Cb), over l producing ij(aCb)
          !       accumulate to ij(ab)
          !   End loop C
          ! End Loop b and a

          do ib=1,nTri_Elem1(lb)
            do ia=1,nTri_Elem1(la)
              if (iPrint >= 99) write(u6,*) ' ia,ib=',ia,ib

              do iC=1,(2*iAng+1)
                if (iPrint >= 99) write(u6,*) ' iC,=',iC
                iaC = (iC-1)*nTri_Elem1(la)+ia
                ipaC = (iaC-1)*nAlpha*nExpi+ipF1
                iCb = (ib-1)*(2*iAng+1)+iC
                ipCb = (iCb-1)*nExpi*nBeta+ipF2

                iIC = 0
                if (iPrint >= 99) then
                  call RecPrt('<ia|iC>',' ',Array(ipaC),nAlpha,nExpi)
                  call RecPrt('<iC|ib>',' ',Array(ipCb),nExpi,nBeta)
                end if
                do iIrrep=0,nIrrep-1
                  if (.not. btest(llOper,iIrrep)) cycle
                  if (iPrint >= 99) write(u6,*) ' iIC=',iIC
                  iIC = iIC+1
                  nOp = NrOpr(iDCRT(lDCRT))
                  Xg = real(iChTbl(iIrrep,nOp),kind=wp)
                  Factor = Xg*Fact
                  call DGEMM_('N','N',nAlpha,nExpi,nExpi,One,Array(ipaC),nAlpha,Array(ipC),nExpi,Zero,Array(ipTmp),nAlpha)
                  call DGEMM_('N','N',nAlpha,nBeta,nExpi,Factor,Array(ipTmp),nAlpha,Array(ipCb),nExpi,One,rFinal(1,ia,ib,iIC), &
                              nAlpha)
                end do

              end do
            end do
          end do

        end do
      end do
    end do
  end if
  mdc = mdc+dbsc(iCnttp)%nCntr
end do

if (iPrint >= 99) then
  write(u6,*) ' Result in SROInt'
  do ia=1,(la+1)*(la+2)/2
    do ib=1,(lb+1)*(lb+2)/2
      write(Label,'(A,I2,A,I2,A)') ' rFinal(',ia,',',ib,')'
      call RecPrt(Label,' ',rFinal(:,ia,ib,1),nAlpha,nBeta)
    end do
  end do
end if

return

end subroutine SROInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013-2015, Ignacio Fdez. Galvan                        *
************************************************************************
*  MEP_Dir
*
*> @brief
*>   Compute the new reference structure and initial coordinates for the next MEP point
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Compute the new reference structure (and direction) and initial geometry
*> for the next MEP point optimization (using the Gonz&aacute;lez--Schlegel or
*> M&uacute;ller--Brown method).
*> Calculate some properties of the path (length and curvature) between the previous
*> and current MEP points.
*> All calculations are done in weighted coordinates (mass-weighted by default).
*>
*> @param[in,out] Cx            Cartesian coordinates in all iterations
*> @param[in]     Gx            Cartesian gradient in all iterations
*> @param[in]     nAtom         Number of symmetry-unique atoms
*> @param[in]     iMEP          Number of this MEP point
*> @param[in]     iOff_iter     Iteration of the previous MEP point
*> @param[in]     iPrint        Print level
*> @param[in]     IRCRestart    Flag to mark the start of a backward IRC search
*> @param[out]    ResGrad       Residual gradient
*> @param[out]    BadConstraint Flag to signal constraint problems
************************************************************************
      Subroutine MEP_Dir(Cx,Gx,nAtom,iMEP,iOff_iter,iPrint,IRCRestart,
     &                   ResGrad,BadConstraint)
      use Symmetry_Info, only: nIrrep
      use Slapaf_Info, only: Weights, MF, RefGeo
      use Slapaf_Parameters, only: IRC, nLambda, rMEP, MEP, nMEP,
     &                             MEPNum, dMEPStep, MEP_Type,
     &                             MEP_Algo, iter
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 Cx(3*nAtom,iter+1),Gx(3*nAtom,iter+1)
      Logical IRCRestart,BadConstraint
      Parameter ( RadToDeg=180.0D0/Pi )
      Integer iDum(1)
      Real*8, Allocatable:: PrevDir(:,:), PostDir(:,:), Disp(:,:),
     &                      Grad(:,:), Dir(:,:), Cen(:,:),
     &                      Len(:), Cur(:), drdx(:,:)
*
*                                                                      *
************************************************************************
*                                                                      *
      nCoor=3*nAtom
      iPrev_iter=Max(iOff_iter,1)
      Call mma_allocate(PrevDir,3,nAtom,Label='PrevDir')
      Call mma_allocate(PostDir,3,nAtom,Label='PostDir')
      Call mma_allocate(Disp,3,nAtom,Label='Disp')
      Call mma_allocate(Grad,3,nAtom,Label='Grad')
      Call mma_allocate(Dir,3,nAtom,Label='Dir')
      Call mma_allocate(Cen,3,nAtom,Label='Cen')
*
*     Obtain some useful vectors:
*     PrevDir: difference between ref. structure and previous MEP point
*     PostDir: difference between current MEP point and ref. structure
*     Disp:    difference between current and previous MEP points
*     Grad:    gradient at current MEP point
*
      If (iter.gt.1) Then
        PrevDir(:,:) = RefGeo(:,:)
        Call DaXpY_(nCoor,-One,Cx(:,iPrev_iter),1,PrevDir(:,:),1)
        Call dCopy_(nCoor,Cx(:,iter),1,PostDir(:,:),1)
        PostDir(:,:) = PostDir(:,:) - RefGeo(:,:)
        Call dCopy_(nCoor,Cx(:,iter),1,Disp(:,:),1)
        Call DaXpY_(nCoor,-One,Cx(:,iPrev_iter),1,Disp(:,:),1)
      Else
        PrevDir(:,:)=Zero
        PostDir(:,:)=Zero
        Disp(:,:)   =Zero
      End If
      Call dCopy_(nCoor,Gx(:,iter),1,Grad(:,:),1)
*
*     Normalize the vectors in weighted coordinates
*     and compute some angles that provide information on the path
*     shape and quality.
*     Note that gradient and coordinates transform differently
*
      TWeight=Zero
      dPrevDir=Zero
      dPostDir=Zero
      dDisp=Zero
      dGrad=Zero
      dPostDirGrad=Zero
      dPrevDirGrad=Zero
      dPrevDirDisp=Zero
      dPrevDirPostDir=Zero
      iOff=0
      Do iAtom=1,nAtom
        Fact=Dble(iDeg(Cx(1+iOff,iter)))
        xWeight=Weights(iAtom)
        TWeight=TWeight+Fact*xWeight
        Do ixyz=1,3
          dPrevDir=dPrevDir+Fact*xWeight*PrevDir(ixyz,iAtom)**2
          dPostDir=dPostDir+Fact*xWeight*PostDir(ixyz,iAtom)**2
          dDisp=dDisp+Fact*xWeight*Disp(ixyz,iAtom)**2
          dGrad=dGrad+Fact*Grad(ixyz,iAtom)**2/xWeight
          dPostDirGrad=dPostDirGrad+
     &        Fact*PostDir(ixyz,iAtom)*Grad(ixyz,iAtom)
          dPrevDirGrad=dPrevDirGrad+
     &        Fact*PrevDir(ixyz,iAtom)*Grad(ixyz,iAtom)
          dPrevDirDisp=dPrevDirDisp+
     &        Fact*xWeight*PrevDir(ixyz,iAtom)*Disp(ixyz,iAtom)
          dPrevDirPostDir=dPrevDirPostDir+
     &        Fact*xWeight*PrevDir(ixyz,iAtom)*PostDir(ixyz,iAtom)
          iOff=iOff+1
        End Do
      End Do
      dPrevDir=Sqrt(dPrevDir)
      dPostDir=Sqrt(dPostDir)
      dDisp=Sqrt(dDisp)
      dGrad=Sqrt(dGrad)
      If (dPrevDir.gt.Zero)
     &  Call DScal_(nCoor,One/dPrevDir,PrevDir(:,:),1)
      If (dPostDir.gt.Zero)
     &  Call DScal_(nCoor,One/dPostDir,PostDir(:,:),1)
      If (dDisp.gt.Zero)
     &  Call DScal_(nCoor,One/dDisp,Disp(:,:),1)
      If (dGrad.gt.Zero)
     &  Call DScal_(nCoor,One/dGrad,Grad(:,:),1)
*     Any zero vector is assumed to be parallel to any other
      If (dPostDir*dGrad.gt.Zero) Then
        dPostDirGrad=dPostDirGrad/(dPostDir*dGrad)
      Else
        dPostDirGrad=One
      End If
      If (dPrevDir*dGrad.gt.Zero) Then
        dPrevDirGrad=dPrevDirGrad/(dPrevDir*dGrad)
      Else
        dPrevDirGrad=One
      End If
      If (dPrevDir*dDisp.gt.Zero) Then
        dPrevDirDisp=dPrevDirDisp/(dPrevDir*dDisp)
      Else
        dPrevDirDisp=One
      End If
      If (dPrevDir*dPostDir.gt.Zero) Then
        dPrevDirPostDir=dPrevDirPostDir/(dPrevDir*dPostDir)
      Else
        dPrevDirPostDir=One
      End If
*     A negative curvature means there is no appropriate value
      Curvature=-1.0D-12
      PathLength=dDisp/Sqrt(TWeight)
      If (MEP.and.MEP_Type.eq.'SPHERE    ') Then
*       The curvature is the inverse radius of the circle tangent to
*       both the current and previous MEP points
*       The path length is the arc length between these points
        If (One-dPrevDirPostDir.gt.Zero)
     &    Curvature=(One-dPrevDirPostDir)/Sqrt(One-dPrevDirPostDir**2)/
     &              Sqrt(dPrevDir*dPostDir/TWeight)
        If (Curvature.gt.Zero)
     &    PathLength=aCos(dPrevDirPostDir)/Curvature
      End If
*
*     Store the length and curvature values, and print results
*
      Call mma_allocate(Len,nMEP+1,Label='Len')
      Call mma_allocate(Cur,nMEP+1,Label='Cur')
      If (iMEP.ge.1) Then
        Call Get_dArray('MEP-Lengths   ',Len,nMEP+1)
        Call Get_dArray('MEP-Curvatures',Cur,nMEP+1)
        If (IRC.eq.-1) Then
          Len(1+iMEP)=-PathLength
        Else
          Len(1+iMEP)=PathLength
        End If
        Cur(1+iMEP)=Curvature
        Call Put_dArray('MEP-Lengths   ',Len,nMEP+1)
        Call Put_dArray('MEP-Curvatures',Cur,nMEP+1)
        If ((iMEP.ge.1).and.(iPrint.ge.5)) Then
          If (MEP_Type.eq.'TRANSVERSE') Then
            ConstraintAngle=aCos(dPrevDirGrad)*RadToDeg
          Else
            ConstraintAngle=aCos(dPostDirGrad)*RadToDeg
          End If
          If (MEP) Then
            PathAngle=aCos(dPrevDirPostDir)*RadToDeg
          Else
            PathAngle=aCos(-dPrevDirDisp)*RadToDeg
          End If
          ResGrad=dGrad
          Write(6,*)
          Write(6,'(a)')
     &      ' Last IRC/MEP step'//
     &      ' (in weighted coordinates / sqrt(total weight))'
          Write(6,'(a)')
     &      ' --------------------------------------------------------'
          Write(6,100) 'Residual gradient size:',ResGrad,'hartree/bohr'
          Write(6,100) 'Angle with constraint surface:',
     &                 ConstraintAngle,'degrees'
          Write(6,100) 'Path angle:',PathAngle,'degrees'
          If (Curvature.ge.Zero) Write(6,100)
     &                 'Path curvature:',Curvature,'bohr^(-1)'
          Write(6,100) 'Path length:',PathLength,'bohr'
100       Format(1X,A30,1X,F12.6,1X,A)
        End If
      Else
        Len(:)=Zero
        Cur(:)=Zero
        Call Put_dArray('MEP-Lengths   ',Len,nMEP+1)
        Call Put_dArray('MEP-Curvatures',Cur,nMEP+1)
      End If
      Call mma_deallocate(Len)
      Call mma_deallocate(Cur)
*
*     Do not mess with the geometry or reference if the next iteration
*     will be the start of a reverse IRC search.
*
      If (.Not.IRCRestart) Then
*
*       The new direction for the MEP should be the gradient in weighted
*       coordinates, but this may break additional constraints if they
*       exist, and the gradient may be close to zero.
*       Instead, we will use the direction that, on convergence, should
*       be parallel to the gradient when there are no other constraints.
*       Note that we could be following the gradient uphill
*
        If (MEP_Type.eq.'TRANSVERSE') Then
*         In the TRANSVERSE case, PrevDir is the vector parallel to the
*         gradient, but following this will never change the hyperplane
*         orientation.
*         We will try using a linear combination of PrevDir and Disp
*           dp  = Disp.PrevDir
*           Dir = dp*Disp + a*(PrevDir-dp*Disp)
*               = a*PrevDir + (1-a)*dp*Disp
*         Try different values for Fact (the "a" above).
*         I believe the true MEP direction should be more slanted from
*         the plane normal (PrevDir) than the Disp vector, therefore
*         a negative value is probably better.
          Fact=-0.5D0
          Dir(:,:) = Fact * PrevDir(:,:)
          Call DaXpY_(nCoor,(One-Fact)*dPrevDirDisp,Disp(:,:),1,
     &                                             Dir(:,:),1)
        Else
*         In the SPHERE case, PostDir is the vector to use
          Dir(:,:) = PostDir(:,:)
        End If
*
*       Special cases
*
        If (iMEP.eq.0) Then
          If (IRC.eq.0) Then
*           In the initial iteration of a MEP, use the initial direction
            Call Get_dArray('Transverse',Dir(:,:),nCoor)
          Else
*           In the initial iteration of an IRC branch, use the reaction vector
            Call dCopy_(nCoor,MF,1,Dir(:,:),1)
          End If
        End If
*
*       Project any additional constraints out of the direction vector
*       The constraint vectors are read from the dRdX file
*
        LudRdX=30
        Call DaName(LudRdX,'dRdX')
        iAd=0
        Call iDaFile(LudRdX,2,iDum,1,iAd)
        nLambda_=iDum(1)
        Call iDaFile(LudRdX,2,iDum,1,iAd)
        nCoor_=iDum(1)
        Call mma_allocate(drdx,nCoor_,nLambda_,Label='drdx')
        Call dDaFile(LudRdX,2,drdx,nLambda_*nCoor_,iAd)
        Call DaClos(LudRdX)
        Do iLambda=1,nLambda
          If (iLambda.ne.MEPnum) Then
            dd=dDot_(nCoor,drdx(:,iLambda),1,drdx(:,iLambda),1)
            drd=dDot_(nCoor,drdx(:,iLambda),1,Dir(:,:),1)
            Call DaXpY_(nCoor,-drd/dd,drdx(:,iLambda),1,Dir(:,:),1)
          End If
        End Do
        Call mma_deallocate(drdx)
*
*       Compute the length of the direction vector in weighted coordinates
*
        dDir=Zero
        iOff=0
        Do iAtom=1,nAtom
          Fact=Dble(iDeg(Cx(1+iOff,iter)))
          xWeight=Weights(iAtom)
          Do ixyz=1,3
            dDir=dDir+Fact*xWeight*Dir(ixyz,iAtom)**2
            iOff=iOff+1
          End Do
        End Do
        dDir=Sqrt(dDir)
*
*       According to the Gonzalez-Schlegel method, the reference point
*       is half-step away in the search direction.
*       First set the new reference point (except for rMEP) and then
*       compute the new starting structure at the full step distance
*       For an IRC first step, keep the initial structure as reference
*
        Fact=dMEPStep*Sqrt(TWeight)/dDir
        Call dCopy_(nCoor,Cx(:,iter),1,Cen(:,:),1)
        If (MEP_Algo.eq.'GS') Then
          If ((IRC.eq.0).or.(iMEP.ne.0))
     &      Call Find_Distance(Cx(:,iter),Cen(:,:),Dir(:,:),
     &                Half*Fact,Half*dMEPStep,nAtom,BadConstraint)
          If (.Not.rMEP) Call Put_dArray('Ref_Geom',Cen(:,:),nCoor)
          Call Find_Distance(Cen(:,:),Cx(:,iter+1),Dir(:,:),
     &              Half*Fact,Half*dMEPStep,nAtom,BadConstraint)
        Else If (MEP_Algo.eq.'MB') Then
          If (.Not.rMEP) Call Put_dArray('Ref_Geom',Cx(1,iter),nCoor)
          Call Find_Distance(Cx(:,iter),Cx(:,iter+1),Dir(:,:),
     &              Fact,dMEPStep,nAtom,BadConstraint)
        End If
*
*       Randomly displace the new geometry 1/20th of the MEP distance
*       to try to break symmetry
*
        If (nIrrep.eq.1) Then
          Call Random_Vector(nCoor,Disp(:,:),.True.)
          dDir=Zero
          iOff=0
          Do iAtom=1,nAtom
            xWeight=Weights(iAtom)
            Do ixyz=1,3
              dDir=dDir+xWeight*Disp(ixyz,iAtom)**2
              iOff=iOff+1
            End Do
          End Do
          Fact=dMEPStep*Sqrt(TWeight/dDir)
          Call DaXpY_(nCoor,0.05D0*Fact,Disp(:,:),1,Cx(:,iter+1),1)
        End If
        Call Put_dArray('Transverse',Dir(:,:),nCoor)
        If (iter.eq.1) BadConstraint=.False.
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(PrevDir)
      Call mma_deallocate(PostDir)
      Call mma_deallocate(Disp)
      Call mma_deallocate(Grad)
      Call mma_deallocate(Dir)
      Call mma_deallocate(Cen)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ResidualCD(iAtomPair,ip_CBar,l_CBar,irc)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: Minimize the number of two-center functions in the
C     auxiliary basis for atom pair iAtomPair. This is done by Cholesky
C     decomposition of the residual matrix
C
C     R[uv,kl] = (uv|kl) - (uv_|kl_)
C
C     where uv and kl are two-center products included in the auxiliary
C     basis, and
C
C     (uv_|kl_) = sum[J=1,M1] CBar[uv_,J]*CBar[kl_,J]
C
C     is the current DF approximation to those integrals using
C     one-center auxiliary functions only.
C
C     Two-center info for the atom pair is updated in this routine.
C
C     Return code irc is zero on successful completion.
C
C     Note: the underlying assumption is that few two-center functions
C     are needed so that the integrals can be stored in core.
C
      Implicit None
      Integer iAtomPair
      Integer ip_CBar, l_CBar
      Integer irc
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"

      External Integral_WrOut_LDF_G

#if defined (_DEBUGPRINT_)
      Logical  isSymmetric, hasNonnegativeDiagonal, obeysCauchySchwarz
      External isSymmetric, hasNonnegativeDiagonal, obeysCauchySchwarz
#endif

      Integer  LDF_nBasAux_Pair, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBasAux_Pair, LDF_nShell_Atom, LDF_lShell_Atom

      Integer M, M1
      Integer ijS, ij
      Integer ip_Int, l_Int
      Integer uvS, klS
      Integer ip_SewWrk, l_SewWrk
      Integer iAtom, jAtom
      Integer nShell_iAtom, nShell_jAtom
      Integer iS, jS
      Integer jShell
      Integer ipi, ipj
      Integer nuv
      Integer ip_kOff, l_kOff
      Integer ipk, ip0
      Integer ip_CB, l_CB
      Integer ipCB, ipCBar
      Integer K, K2
      Integer uS, vS
      Integer u, v
      Integer ip_Vec, l_Vec
      Integer ip_ID, l_ID
      Integer nVec

      Real*8 Thr

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_2CFunctions
      Integer IndxG2
      Integer L2C
      Integer kOff
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      IndxG2(i,j)=iWork(ip_IndxG2-1+l_IndxG2_1*(j-1)+i)
      L2C(i,j)=iWork(ip_2CList-1+l_2CList_1*(j-1)+i)
      kOff(i,j)=iWork(ip_kOff-1+nShell_iAtom*(j-1)+i)

      ! Init return code
      irc=0

      If (AP_2CFunctions(1,iAtomPair).gt.0) Then
         ! Set index array for G matrix
         ! (This includes the one-center functions)
         Call LDF_SetIndxG(iAtomPair)
         ! Get number of auxiliary functions
         M=LDF_nBasAux_Pair(iAtomPair)
         ! Get number of one-center functions
         M1=M-AP_2CFunctions(1,iAtomPair)
         ! Reset indices to exclude one-center functions
         Do ijS=1,l_IndxG2_2
            Do ij=1,l_IndxG2_1
               If (IndxG2(ij,ijS).gt.0) Then
                  iWork(ip_IndxG2-1+l_IndxG2_1*(ijS-1)+ij)=
     &            iWork(ip_IndxG2-1+l_IndxG2_1*(ijS-1)+ij)-M1
               End If
            End Do
         End Do
         nRow_G=AP_2CFunctions(1,iAtomPair)
         ! Allocate memory for integrals
         l_Int=nRow_G**2
         Call GetMem('ResidG','Allo','Real',ip_Int,l_Int)
         ! Compute integrals
         Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
         Call xSetMem_Ints(l_SewWrk)
         Call Cho_dZero(Work(ip_Int),l_Int)
         Do klS=1,l_2CList_2
            SHC=L2C(1,klS)
            SHD=L2C(2,klS)
            SPCD=L2C(3,klS)
            Do uvS=klS,l_2CList_2
               SHA=L2C(1,uvS)
               SHB=L2C(2,uvS)
               SPAB=L2C(3,uvS)
               Call Eval_IJKL(SHA,SHB,SHC,SHD,Work(ip_Int),l_Int,
     &                        Integral_WrOut_LDF_G)
            End Do
         End Do
         Call xRlsMem_Ints()
#if defined (_DEBUGPRINT_)
         ! Check integral matrix for symmetry and non-negative diagonals
         ! and Cauchy-Schwarz inequality
         If (.not.isSymmetric(Work(ip_Int),nRow_G,1.0d-15)) Then
            Write(6,'(A)')
     &      'LDF_ResidualCD: Integral matrix is not symmetric!'
            irc=irc+1
         End If
         If (.not.hasNonnegativeDiagonal(Work(ip_Int),nRow_G)) Then
            Write(6,'(A)')
     &      'LDF_ResidualCD: Integral matrix has negative diagonals!'
            irc=irc+1
         End If
         If (.not.obeysCauchySchwarz(Work(ip_Int),nRow_G,1.0d-14)) Then
            Write(6,'(A)')
     &   'LDF_ResidualCD: Integral matrix does not obey C-S inequality!'
            irc=irc+1
         End If
         If (irc.ne.0) Then
            Write(6,'(A)')
     &      'LDF_ResidualCD: => Integral matrix not PSD!!'
            Call LDF_Quit(1)
         End If
#endif
         ! Set up offset array to shell blocks of CBar
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         nShell_iAtom=LDF_nShell_Atom(iAtom)
         nShell_jAtom=LDF_nShell_Atom(jAtom)
         l_kOff=nShell_iAtom*nShell_jAtom
         Call GetMem('kOff','Allo','Inte',ip_kOff,l_kOff)
         ipi=LDF_lShell_Atom(iAtom)-1
         ipj=LDF_lShell_Atom(jAtom)-1
         nuv=0
         Do jS=1,nShell_jAtom
            jShell=iWork(ipj+jS)
            ipk=ip_kOff-1+nShell_iAtom*(jS-1)
            Do iS=1,nShell_iAtom
               iWork(ipk+iS)=nuv
               nuv=nuv+nBasSh(iWork(ipi+iS))*nBasSh(jShell)
            End Do
         End Do
         ! Allocate tmp array for CBar elements corresponding to
         ! two-center auxiliary functions
         l_CB=nRow_G*M1
         Call GetMem('CB','Allo','Real',ip_CB,l_CB)
         ! Copy subblocks of CBar
         Do K=0,M1-1
            ipCB=ip_CB+nRow_G*K
            ipCBar=ip_CBar-1+nuv*K
            Do K2=0,nRow_G-1
               ip0=AP_2CFunctions(2,iAtomPair)+4*K2
               uS=iWork(ip0)
               u=iWork(ip0+1)
               vS=iWork(ip0+2)
               v=iWork(ip0+3)
               Work(ipCB+K2)=
     &            Work(ipCBar+kOff(uS,vS)+nBasSh(iWork(ipi+uS))*(v-1)+u)
            End Do
         End Do
         ! Compute residual matrix
         Call dGeMM_('N','T',nRow_G,nRow_G,M1,
     &               -1.0d0,Work(ip_CB),nRow_G,Work(ip_CB),nRow_G,
     &               1.0d0,Work(ip_Int),nRow_G)
         ! Deallocate tmp CBar array
         Call GetMem('CB','Free','Real',ip_CB,l_CB)
         ! Deallocate offset array
         Call GetMem('kOff','Free','Inte',ip_kOff,l_kOff)
         ! Allocate ID array
         l_ID=nRow_G
         Call GetMem('ID','Allo','Inte',ip_ID,l_ID)
         ! Allocate Cholesky vector array
         l_Vec=nRow_G**2
         Call GetMem('Vec','Allo','Real',ip_Vec,l_Vec)
         ! Incomplete CD of residual matrix
         Thr=Thr_Accuracy
         nVec=0
#if defined (_DEBUGPRINT_)
         ! Check residual matrix for symmetry and non-negative diagonals
         ! and Cauchy-Schwarz inequality
         If (.not.isSymmetric(Work(ip_Int),nRow_G,1.0d-15)) Then
            Write(6,'(A)')
     &      'LDF_ResidualCD: Residual matrix is not symmetric!'
            irc=irc+1
         End If
         If (.not.hasNonnegativeDiagonal(Work(ip_Int),nRow_G)) Then
            Write(6,'(A)')
     &      'LDF_ResidualCD: Residual matrix has negative diagonals!'
            irc=irc+1
         End If
         If (.not.obeysCauchySchwarz(Work(ip_Int),nRow_G,1.0d-14)) Then
            Write(6,'(A)')
     &   'LDF_ResidualCD: Residual matrix does not obey C-S inequality!'
            irc=irc+1
         End If
         If (irc.ne.0) Then
            Write(6,'(A)')
     &      'LDF_ResidualCD: => Residual matrix not PSD!!'
            Call LDF_Quit(1)
         End If
#endif
         Call CD_InCore_P(Work(ip_Int),nRow_G,Work(ip_Vec),nRow_G,
     &                    iWork(ip_ID),nVec,Thr,irc)
         If (irc.ne.0) Then
            Write(6,'(A,I8)')
     &      'LDF_ResidualCD: CD_InCore_P returned code',irc
            Call GetMem('Vec','Free','Real',ip_Vec,l_Vec)
            Call GetMem('ID','Free','Inte',ip_ID,l_ID)
            Call GetMem('ResidG','Free','Real',ip_Int,l_Int)
            Call LDF_UnsetIndxG()
            irc=1
            Return
         End If
         ! Deallocate Cholesky vector array
         Call GetMem('Vec','Free','Real',ip_Vec,l_Vec)
         ! Deallocate integral array
         Call GetMem('ResidG','Free','Real',ip_Int,l_Int)
         ! Reset two-center auxiliary basis info
         Call LDF_Reset2CF(iAtomPair,iWork(ip_ID),nRow_G,nVec)
         ! Deallocate ID array
         Call GetMem('ID','Free','Inte',ip_ID,l_ID)
         ! Unset index arrays for G matrix
         Call LDF_UnsetIndxG()
      End If

c Avoid unused argument warnings
      If (.False.) Call Unused_integer(l_CBar)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SCAVCS(VECO,VECI,IDX,NDIM)
! Scatter vector with sign change
!
! vecO(abs(idx(i))) = veci(i)*sign(idx(i))

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NDIM, IDX(NDIM)
real(kind=wp), intent(_OUT_) :: VECO(*)
real(kind=wp), intent(in) :: VECI(NDIM)
integer(kind=iwp) :: I

do I=1,NDIM
  VECO(abs(IDX(I))) = VECI(I)*real(sign(1,IDX(I)),kind=wp)
end do

return

end subroutine SCAVCS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_X_RdRst(ifail)
!
! T.B. Pedersen, july 2004.
!
! Purpose: read decomposition info and store in common
!          block. If ifail != 0 on exit, some error occurred and,
!          most likely, some of the restart info is not
!          defined/initialized.

use Index_Functions, only: nTri_Elem
use Cholesky, only: Cho_AdrVec, Damp, InfRed, InfRed_Hidden, InfVec, InfVec_Hidden, InfVec_N2, LuRst, MaxRed, MaxVec, nBas, nnShl, &
                    nShell, nSym, NumCho, Span, ThrCom, ThrDiag, ThrNeg, TooNeg, WarNeg, XCho_AdrVec, XnPass, XDamp, XScDiag, &
                    XSpan, XThrCom, XThrDiag, XThrNeg, XTooNeg, XWarNeg
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ifail
integer(kind=iwp), parameter :: lScr = 8
integer(kind=iwp) :: iAdr, iOpt, iSym, j, jScr(lScr), nRd, nSP_UpLim
real(kind=wp) :: dScr(lScr)
character(len=*), parameter :: SecNam = 'Cho_X_RdRst'

! Set return code.
! ----------------

ifail = 0

! Read molecular info.
! --------------------

iAdr = 0

iOpt = 2
nRd = 4
call iDAFile(LuRst,iOpt,jScr,nRd,iAdr)
nShell = jScr(2)
nnShl = jScr(3)
if (jScr(2) < 1) then
  write(u6,'(A,A,I10)') SecNam,': #shells from restart file:',jScr(2)
  ifail = 1
  call Finish_this()
  return
end if
nSP_UpLim = nTri_Elem(nShell)
if ((jScr(3) < 1) .or. (jScr(3) > nSP_UpLim)) then
  write(u6,'(A,A,I10)') SecNam,': #shell pairs from restart file:',jScr(3)
  ifail = 1
  call Finish_this()
  return
end if
if (jScr(1) /= nSym) then
  write(u6,'(A,A,I10)') SecNam,': #irreps from restart file:',jScr(1)
  ifail = 1
  call Finish_this()
  return
else
  iOpt = 2
  call iDAFile(LuRst,iOpt,jScr,nSym,iAdr)
  do iSym=1,nSym
    if (jScr(iSym) /= nBas(iSym)) then
      write(u6,'(A,A,I2,A,I10)') SecNam,': #basis functions in sym.',iSym,' from restart file:',jScr(iSym)
      ifail = 2
      call Finish_this()
      return
    end if
  end do
end if

! Read decomposition configuration info.
! --------------------------------------

iOpt = 2
nRd = 2
call iDAFile(LuRst,iOpt,jScr,nRd,iAdr)
if (jScr(1) == 0) then
  XScDiag = .false.
else if (jScr(1) == 1) then
  XScDiag = .true.
else
  write(u6,'(A,A,I10)') SECNAM,': integer flag for screening not recognized:',jScr(1)
  ifail = 2
  call Finish_this()
  return
end if
if ((jScr(2) > 0) .and. (jScr(2) < 3)) then
  XCho_AdrVec = jScr(2)
else
  write(u6,'(A,A,I10)') SECNAM,': vector file address mode not recognized:',jScr(2)
  ifail = 3
  call Finish_this()
  return
end if
if (XCho_AdrVec /= Cho_AdrVec) then
  write(u6,'(A,A,I10)') SECNAM,': vector file address mode from restart file:',XCho_AdrVec
  write(u6,'(A,A,I10)') SECNAM,': vector file address mode from runfile     :',Cho_AdrVec
  ifail = 3
  call Finish_this()
  return
end if

iOpt = 2
nRd = 8
call dDAFile(LuRst,iOpt,dScr,nRd,iAdr)
XThrCom = dScr(1)
XThrDiag = dScr(2)
XDamp(1) = dScr(3)
XDamp(2) = dScr(4)
XSpan = dScr(5)
XThrNeg = dScr(6)
XWarNeg = dScr(7)
XTooNeg = dScr(8)
ThrCom = XThrCom
ThrDiag = XThrDiag
Damp(1) = XDamp(1)
Damp(2) = XDamp(2)
Span = XSpan
ThrNeg = XThrNeg
WarNeg = XWarNeg
TooNeg = XTooNeg

! Allocate InfVec array.
! ----------------------

call mma_allocate(InfVec_Hidden,MaxVec,InfVec_N2,nSym,Label='InfVec_Hidden')
InfVec => InfVec_Hidden

! Allocate and initialize (read) InfRed array.
! --------------------------------------------

iOpt = 2
nRd = 1
call iDAFile(LuRst,iOpt,jScr,nRd,iAdr)
MaxRed = jScr(1)
XnPass = MaxRed
if (MaxRed < 1) then
  write(u6,'(A,A,I10)') SecNam,': #reduced sets from restart file:',MaxRed
  ifail = 4
  call Finish_this()
  return
else
  call mma_allocate(InfRed_Hidden,MaxRed,Label='InfRed_Hidden')
  InfRed => InfRed_Hidden
  iOpt = 2
  call iDAFile(LuRst,iOpt,InfRed,size(InfRed),iAdr)
  if (InfRed(1) /= 0) then
    write(u6,'(A,A,I10)') SecNam,': disk address of 1st reduced set:',InfRed(1)
    ifail = 5
    call Finish_this()
    return
  end if
end if

! Read InfVec array.
! ------------------

do iSym=1,nSym
  iOpt = 2
  nRd = 1
  call iDAFile(LuRst,iOpt,jScr,nRd,iAdr)
  if (jScr(1) /= NumCho(iSym)) then
    write(u6,'(A,A,I2,A,I10)') SecNam,': #Cholesky vectors (sym.',iSym,'): ',NumCho(iSym)
    write(u6,'(A,A,I10)') SecNam,': ....and from restart file: ',jScr(iSym)
    ifail = 6
    call Finish_this()
    return
  else
    if (NumCho(iSym) < 1) then
      InfVec(:,:,iSym) = 0
    else
      InfVec(:,:,iSym) = 0
      do j=1,size(InfVec,2)
        iOpt = 2
        call iDAFile(LuRst,iOpt,InfVec(:,j,iSym),NumCho(iSym),iAdr)
      end do
    end if
  end if
end do

! Return.
! -------

call Finish_this()

contains

! failures jump to this point
subroutine Finish_this()

  if (ifail /= 0) write(u6,'(A,A)') SecNam,': refusing to read more restart info!'

end subroutine Finish_this

end subroutine Cho_X_RdRst

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_AddChargeConstraintCorrection(AB,l_C,C)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: adadd the correction from the charge constraint,
C
C              C(uv,J) += lambda(uv)*C1(J)
C
C              where uv and J belong to atom pair AB,
C
C              lambda(uv) = eta * [ S(uv) - sum_J C(uv,J)*n(J) ]
C
C              (here C(uv,J) are the coefficients on input)
C
C              eta = 1/[sum_J C1(J)*n(J)]
C
C              n(J) = \int J(r)dr
C
C              and C1(J) is the solution of
C
C              sum_K C1(K)*(K|J) = n(J)
C
C              The n(J) vector must be computed before entering this
C              routine (available through
C              ldf_charge_constraint_info.fh). The overlap matrix S(uv)
C              is computed directly in this routine.
C
C              Overlap and lambda matrices are stored in work at
C              locations defined in ldf_charge_constraint_info.fh
C              and are available on exit from this routine.
C
C     Implementation outline:
C
C     1. Compute G matrix, G(JK)=(J|K)
C     2. Compute overlap matrix for atom pair AB
C     3. Set up rhs of C1 equation, i.e. n(J) without linearly dependent
C        1C functions and including 2C functions (if any)
C     4. Solve equations for C1 using Lapack routine dPoSV
C     5. compute eta
C     6. compute lambda(uv)
C     7. update coefficients C+=lambda*C1
C     8. clean C (i.e. make sure that C(uv,J)=delta(uv,J) for J
C        corresponding to J)
C
      Implicit None
      Integer AB
      Integer l_C
      Real*8  C(l_C)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_charge_constraint_info.fh"

      Character*33 SecNam
      Parameter (SecNam='LDF_AddChargeConstraintCorrection')

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      real*8 ddot_
      external ddot_

      Character*8 Label
      Character*1 UpLo

      Integer A, B
      Integer nA, nB, nAB, M
      Integer ip_G, l_G
      Integer ip_n, l_n
      Integer ip_C1, l_C1
      Integer nRHS
      Integer irc
      Integer ip_S
      Integer ip_lambda, l_lambda

      Real*8  eta

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Check that charge constraint info is set
      If (.not.ChargeConstraintSet) Then
         Call WarningMessage(2,
     &                       SecNam//': charge constraint info not set')
         Call LDF_Quit(1)
      End If

      ! Set dimensions
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      nA=LDF_nBas_Atom(A)
      nB=LDF_nBas_Atom(B)
      nAB=nA*nB
      M=LDF_nBasAux_Pair(AB)
      If (nAB.lt.1 .or. M.lt.1) Then
         l_lambda=0
         ip_lambda=0
         Return
      End If
      If ((nAB*M).gt.l_C) Then
         Call WarningMessage(2,SecNam//': array dimension error')
         Call LDF_Quit(1)
      End If

      ! Allocate and compute G matrix
      l_G=M**2
      Call GetMem('CLDFG','Allo','Real',ip_G,l_G)
      Call LDF_SetIndxG(AB)
      Call LDF_ComputeGMat(AB,M,Work(ip_G))
      Call LDF_UnsetIndxG()

      ! Compute overlap matrix S(uv)
      ip_S=ip_CC_Overlap
      Label='Mltpl  0'
      Call LDF_SetOneEl(Label)
      Call LDF_ComputeOverlapBlock(AB,nAB,Work(ip_S))
      Call LDF_UnsetOneEl(Label)

      ! Allocate and set up n vector
      l_n=M
      Call GetMem('CLDFn','Allo','Real',ip_n,l_n)
      Call LDF_CC_GetRHS(AB,nAB,Work(ip_S),M,Work(ip_n))

      ! RHS vector (n) is overwritten by solution in dPOSV, so
      ! allocate C1 and copy RHS to this location
      l_C1=M
      Call GetMem('CLDFC1','Allo','Real',ip_C1,l_C1)
      Call dCopy_(M,Work(ip_n),1,Work(ip_C1),1)

      ! Solve positive definite linear equations to obtain C1:
      ! sum_K (J|K)*C1(K) = n(J)
      UpLo='L'
      nRHS=1
      irc=0
      call dposv_(UpLo,M,nRHS,Work(ip_G),M,Work(ip_C1),M,irc)
      If (irc.ne.0) Then
         Call WarningMessage(2,
     &                      SecNam//': non-zero return code from dPOSV')
         Write(6,'(A,I10)') 'Return code:',irc
         If (irc.gt.0) Then
            Write(6,'(A)')
     &      '   => G matrix not positive definite'
         Else
            Write(6,'(A,I2,A)')
     &      '   => argument no.',-irc,' has an illegal value'
         End If
         Call LDF_Quit(1)
      End If

      ! Compute eta = 1/sum_J C1(J)*n(J)
      eta=dDot_(M,Work(ip_C1),1,Work(ip_n),1)
      If (abs(eta).lt.1.0d-14) Then
         Call WarningMessage(2,SecNam//': division by zero (eta)')
         Call LDF_Quit(1)
      End If
      eta=1.0d0/eta

      ! Compute lambda(uv)=eta*(S(uv)-sum_K C(uv,K)*n(K))
      ip_lambda=ip_CC_lambda
      Call dCopy_(nAB,Work(ip_S),1,Work(ip_lambda),1)
      Call dGeMV_('N',nAB,M,
     &           -eta,C,nAB,Work(ip_n),1,
     &           eta,Work(ip_lambda),1)

      ! Explicitly zero lambda elements corresponding to 2C functions
      ! Should be zero automatically, but this removes small numerical
      ! inaccuracies.
      Call LDF_CleanLambda(AB,nAB,Work(ip_lambda))

      ! Add charge constraint to C
      ! C(uv,J) = C(uv,J) + lambda(uv)*C1(J)
      Call dGeR(nAB,M,1.0d0,Work(ip_lambda),1,Work(ip_C1),1,C,nAB)

      ! Clean rows corresponding to 2C functions, i.e.
      ! C(uv,J)=delta(uv,J) where J is a 2C function
      Call LDF_CleanC(AB,C,nAB,M)

      ! Deallocation
      Call GetMem('CLDFC1','Free','Real',ip_C1,l_C1)
      Call GetMem('CLDFn','Free','Real',ip_n,l_n)
      Call GetMem('CLDFG','Free','Real',ip_G,l_G)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CleanLambda(AB,nAB,lambda)
      Implicit None
      Integer AB
      Integer nAB
      Real*8  lambda(nAB)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*15 SecNam
      Parameter (SecNam='LDF_CleanLambda')

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Integer A, B
      Integer nRow_Map, nCol_Map
      Integer ip_Map, l_Map
      Integer i2CF

      Integer i, j
      Integer AP_Atoms
      Integer AP_2CFunctions
      Integer Map
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      Map(i,j)=iWork(ip_Map-1+nRow_Map*(j-1)+i)

      If (AP_2CFunctions(1,AB).gt.0) Then
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         If (nAB.lt.LDF_nBas_Atom(A)*LDF_nBas_Atom(B)) Then
            Call WarningMessage(2,
     &                         SecNam//': insufficient array dimension')
            Call LDF_Quit(1)
         End If
         nRow_Map=AP_2CFunctions(1,AB)
         If (A.eq.B) Then
            nCol_Map=2
         Else
            nCol_Map=1
         End If
         l_Map=nRow_Map*nCol_Map
         Call GetMem('CLDFMap','Allo','Inte',ip_Map,l_Map)
         Call LDF_Map2CF(AB,nRow_Map,nCol_Map,iWork(ip_Map))
         Do i2CF=1,AP_2CFunctions(1,AB)
            lambda(Map(i2CF,1))=0.0d0
         End Do
         If (A.eq.B) Then
            Do i2CF=1,AP_2CFunctions(1,AB)
               lambda(Map(i2CF,2))=0.0d0
            End Do
         End If
         Call GetMem('CLDFMap','Free','Inte',ip_Map,l_Map)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CC_GetRHS(AB,l_S,S,M,n)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: get rhs vector for the charge constraint equation,
C                 n(J) = \int J(r)dr
C              excluding linearly dependent functions. For 2C functions,
C              the integral is copied from the overlap matrix S.
C              The linearly independent 1C functions are copied from the
C              blocked aux bas vector stored in
C              ldf_charge_constraint_info.fh (which must be set up
C              before calling this routine).
C
      Implicit None
      Integer AB
      Integer l_S
      Real*8  S(l_S)
      Integer M
      Real*8  n(M)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_charge_constraint_info.fh"

      Character*13 SecNam
      Parameter (SecNam='LDF_CC_GetRHS')

      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom, LDF_nBasAux_Atom
      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom, LDF_nBasAux_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom
      Logical  LDF_isLinDep
      External LDF_isLinDep

#if defined (_DEBUGPRINT_)
      Integer  LDF_nBasAux_Pair
      External LDF_nBasAux_Pair
#endif

      Integer A, B
      Integer ip, ipn
      Integer nSA, nSB
      Integer ipA, ipB
      Integer iS, iShell, ii
      Integer MA, MB
      Integer ip_iOff, l_iOff
      Integer i2C
      Integer iSA, iSB, iA, iB, iShellA

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      Integer List2C
      Integer iOff
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      List2C(i,j)=iWork(AP_2CFunctions(2,AB)-1+4*(j-1)+i)
      iOff(i,j)=iWork(ip_iOff-1+nSA*(j-1)+i)

      ! Check that charge constraint info is set
      If (.not.ChargeConstraintSet) Then
         Call WarningMessage(2,
     &                       SecNam//': charge constraint info not set')
         Call LDF_Quit(1)
      End If

      ! Get atoms
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)

      ! Copy 1C part
      If (AP_1CLinDep(1,AB).lt.1) Then
         ip=iWork(ip_CC_AuxIntVec-1+A)
         ipn=1
         MA=LDF_nBasAux_Atom(A)
         Call dCopy_(MA,Work(ip),1,n(ipn),1)
         ipn=ipn+MA
         If (B.ne.A) Then
            ip=iWork(ip_CC_AuxIntVec-1+B)
            MB=LDF_nBasAux_Atom(B)
            Call dCopy_(MB,Work(ip),1,n(ipn),1)
            ipn=ipn+MB
         End If
      Else
         ip=iWork(ip_CC_AuxIntVec-1+A)
         ipn=1
         nSA=LDF_nAuxShell_Atom(A)
         ipA=LDF_lAuxShell_Atom(A)-1
         Do iS=1,nSA
            iShell=iWork(ipA+iS)
            Do ii=1,nBasSh(iShell)
               If (.not.LDF_isLinDep(ii,iS,A,AB)) Then
                  n(ipn)=Work(ip)
                  ipn=ipn+1
               End If
               ip=ip+1
            End Do
         End Do
         If (B.ne.A) Then
            ip=iWork(ip_CC_AuxIntVec-1+B)
            nSB=LDF_nAuxShell_Atom(B)
            ipB=LDF_lAuxShell_Atom(B)-1
            Do iS=1,nSB
               iShell=iWork(ipB+iS)
               Do ii=1,nBasSh(iShell)
                  If (.not.LDF_isLinDep(ii,iS,B,AB)) Then
                     n(ipn)=Work(ip)
                     ipn=ipn+1
                  End If
                  ip=ip+1
               End Do
            End Do
         End If
      End If

      ! Copy 2C part
      If (AP_2CFunctions(1,AB).gt.0) Then
         nSA=LDF_nShell_Atom(A)
         nSB=LDF_nShell_Atom(B)
         l_iOff=nSA*nSB
         Call GetMem('iOff','Allo','Inte',ip_iOff,l_iOff)
         Call LDF_uvOffset(AB,nSA,nSB,iWork(ip_iOff))
         ipA=LDF_lShell_Atom(A)-1
         Do i2C=1,AP_2CFunctions(1,AB)
            iSA=List2C(1,i2C)
            iA=List2C(2,i2C)
            iSB=List2C(3,i2C)
            iB=List2C(4,i2C)
            iShellA=iWork(ipA+iSA)
            ip=iOff(iSA,iSB)+nBasSh(iShellA)*(iB-1)+iA
            n(ipn)=S(ip)
            ipn=ipn+1
         End Do
         Call GetMem('iOff','Free','Inte',ip_iOff,l_iOff)
      End If

#if defined (_DEBUGPRINT_)
      ! Check dimension
      ipn=ipn-1
      If (ipn.ne.LDF_nBasAux_Pair(AB) .or. ipn.ne.M) Then
         Call WarningMessage(2,SecNam//': dimension error')
         Call LDF_Quit(1)
      End If
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function party_cvb(iperm,n)
! Returns parity of permutation

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: party_cvb
integer(kind=iwp), intent(in) :: n, iperm(n)
integer(kind=iwp) :: i, iswp, j, ntransp
integer(kind=iwp), allocatable :: tmp(:)
logical(kind=iwp) :: done

call mma_allocate(tmp,n,label='tmp')
tmp(:) = iperm(:)

! Following caters for non-contiguous integers:
ntransp = 0
do
  done = .false.
  do i=1,n-1
    if (tmp(i) > tmp(i+1)) then
      ntransp = ntransp+1
      iswp = tmp(i)
      tmp(i) = tmp(i+1)
      tmp(i+1) = iswp
      do j=i-1,1,-1
        if (tmp(j) > tmp(j+1)) then
          ntransp = ntransp+1
          iswp = tmp(j)
          tmp(j) = tmp(j+1)
          tmp(j+1) = iswp
        end if
      end do
      done = .true.
      exit
    end if
  end do
  if (.not. done) exit
end do
if (mod(ntransp-n,2) == 0) then
  party_cvb = One
else
  party_cvb = -One
end if

call mma_deallocate(tmp)

return

end function party_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Per Ake Malmqvist                                *
!***********************************************************************

subroutine MKCRVEC(CMO_0,CRVEC)

use OneDat, only: sNoNuc, sNoOri
use rasscf_global, only: ITCORE
use general_data, only: NBAS, NFRO, NISH, NTOT, NTOT1, NTOT2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CMO_0(NTOT2)
real(kind=wp), intent(out) :: CRVEC(NTOT)
integer(kind=iwp) :: ICOMP, IOPT, IRC, ISYMLBL, NB, NFI
character(len=8) :: LABEL
real(kind=wp), allocatable :: SAO(:,:), STRI(:)
#include "warnings.h"

! Note: Nbas,etc are in included common. So is ITCORE.
! CMO_0 is the starting CMO vectors. Active orbital nr ITCORE in
! symmetry 1 is a specially prepared core orbital, which will be used
! to define a projector on any CI vector. This projector is that part
! of the state vector where the core orbital would be doubly occupied.
! This orbital is computed as a covariant vector CRVEC, to allow the
! projector to be invariant to the orbital basis in each interation.

call mma_allocate(STRI,NTOT1+4,Label='STRI')
IRC = 0
IOPT = ibset(ibset(0,sNoOri),sNoNuc)
LABEL = 'Mltpl  0'
ICOMP = 1
ISYMLBL = 1
call RdOne(IRC,IOPT,LABEL,ICOMP,STRI,ISYMLBL)
if (iRc /= 0) then
  write(u6,*) ' MKCRVEC could not read overlaps from ONEINT.'
  write(u6,*) ' Something is wrong with that file, or possibly'
  write(u6,*) ' with the program. Please check.'
  call Quit(_RC_IO_ERROR_READ_)
end if
NB = NBAS(1)
NFI = NFRO(1)+NISH(1)
call mma_allocate(SAO,NB,NB,Label='SAO')
call Square(STRI,SAO,1,NB,NB)
call mma_deallocate(STRI)
call DGEMV_('N',NB,NB,One,SAO,NB,CMO_0(NB*(NFI+ITCORE-1)+1),1,Zero,CRVEC,1)
call mma_deallocate(SAO)

! Test:
!write(u6,*) 'MKCRVEC test: Overlaps all orbs/core :'
!do it=1,nb
!  write(u6,'(1x,i5,f16.8)') it,ddot_(NB,CMO_0(NB*(IT-1)+1),1,CRVEC,1)
!end do

end subroutine MKCRVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Mickael G. Delcey                                      *
!***********************************************************************

subroutine CHO_Prec_MCLR(CMO,nIsh,nAsh,LuAChoVec,LuChoInt)
!***********************************************************************
!                                                                      *
!  Author : M. G. Delcey                                               *
!                                                                      *
!  Purpose: form 2-electron integrals needed for the preconditioner    *
!           those are (ii|pq) and (ip|iq) with i inactive              *
!           and p, q active+virtual                                    *
!           as well as (tu|pq) and (tp|uq) with t, u active            *
!           and p, q all molecular orbitals                            *
!                                                                      *
!           For small active spaces, this is much less than            *
!           the full list of integrals!                                *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Cholesky, only: InfVec, nBas, nDimRS, nSym, NumCho
use Data_structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, SBA_Type
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: One, Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp), intent(in) :: nIsh(8), nAsh(8), LuAChoVec(8), LuChoInt(2)
#include "warnings.h"
integer(kind=iwp) :: i, iAdr, iAdr2, iAdrtu, iE, ii, iLoc, ioff, ioff2, ioff3, ip1, ip2, ip3, ipiaib, ipInt, ipIntj, ipLtu, ipMO, &
                     ipMO2, ipMOi, ipMOj, iptpuq, irc, IREDC, iS, ISTSQ(8), isum, isum2, iSwap, ISYM, iSyma, isymb, it, itt, itu, &
                     iu, iuu, IVEC2, iVrs, j, jBatch, JNUM, JRED, JRED1, JRED2, jsym, JVEC, k, kMOs, ksym, ksym2, labatch, &
                     Libatch, LREAD, lvec, LWORK, lWorke, maxpq, maxRS, maxtpq, MaxVecPerBatch, memneeded, MUSED, na2, nab, nab2, &
                     naleft, nAshb(8), nAshe(8), nBatch, nileft, nip, nIshb(8), nIshe(8), nMat, nMOs, npq, nRS, ntota, ntotae, &
                     ntoti, ntotie, ntp, ntue, NumCV, NUMV, nVec, nvirt, nvirt2, nVrs
real(kind=wp) :: TCR1, TCR2, TCstart1, TCstart2, tform(2), tform2(2), tforma(2), tforma2(2), tMO(2), TOTCPU, TOTWALL, tread(2), &
                 ttran(2), TWR1, TWR2, TWstart1, TWstart2
real(kind=wp), target :: Dum(1)
logical(kind=iwp) :: add, taskleft, timings
character(len=50) :: CFmt
type(DSBA_Type) :: CMOt, Tmp(1)
type(SBA_Type) :: Lpq(1)
real(kind=wp), allocatable :: iiab(:), Integral(:), Lrs(:,:), tupq(:)
real(kind=wp), allocatable, target :: iirs(:), Lii(:), Lij(:), turs(:)
real(kind=wp), pointer :: piirs(:,:), pLii(:,:), pLij(:,:), pturs(:,:)
logical(kind=iwp), parameter :: DoRead = .false.
integer(kind=iwp), external :: Cho_LK_MaxVecPerBatch

!                                                                      *
!***********************************************************************
!                                                                      *

timings = .false.
call CWTIME(TCstart1,TWstart1)
! 1 --> CPU   2 --> Wall
tread(:) = Zero   !time read vectors
ttran(:) = Zero   !time transform vectors
tform(:) = Zero   !time form integrals
tform2(:) = Zero  !time form integrals
tforma(:) = Zero  !time form integrals
tforma2(:) = Zero !time form integrals
tMO(:) = Zero     !time for final MO transform
MaxVecPerBatch = Cho_LK_MaxVecPerBatch()
iLoc = 3

! dummy association to keep the compiler happy
piirs(0:0,0:0) => Dum(:)
pturs(0:0,0:0) => Dum(:)

ISTSQ(1) = 0
do ISYM=2,NSYM
  ISTSQ(iSYM) = ISTSQ(iSYM-1)+NBAS(ISYM-1)**2
end do

! Start with big loop over symmetries

do jsym=1,nsym
  iAdr = 0

  ! Compute some sizes

  nip = 0
  ntp = 0
  npq = 0
  maxpq = 0
  maxtpq = 0
  ntoti = 0
  ntota = 0
  do isymb=1,nsym
    iSyma = Mul(iSymb,jsym)

    npq = npq+nBas(iSymb)**2
    maxpq = max(npq,nBas(iSymb)**2)
    maxtpq = max(maxtpq,nAsh(iSyma)*nBas(iSymb)**2)

    ! For inactive half-transformed Cho vector + Lii^J
    nip = nip+nIsh(iSyma)*(nBas(isymb)+1)
    ! For active half-transformed Cho vector + Lij^J
    ntp = ntp+nAsh(iSyma)*(nBas(isymb)+nAsh(iSyma))

    ntoti = ntoti+nIsh(isymb)
    ntota = ntota+nAsh(isymb)
  end do

  NumCV = NumCho(jSym)
  call GAIGOP_SCAL(NumCV,'max')
  if (NumCV < 1) cycle

  JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) ! red set of the last vec
  call GAIGOP_SCAL(JRED1,'min')
  call GAIGOP_SCAL(JRED2,'max')
  maxRS = max(0,maxval(nDimRS(JSYM,JRED1:JRED2)))

  ! Check for maxmem to see if integrals would fit in memory
  ! or if batching is required

  call mma_MaxDBLE(LWORK)
  call GAIGOP_SCAL(LWORK,'min')

  nIshb(1:nSym) = 0
  nAshb(1:nSym) = 0

  ! Loop over i and t batches
  ! each batch will increase the i/o, therefore we preferably want to
  ! have the whole iiab and tupq in-core!

  ! First, do we have enough memory at all!

  memneeded = maxRS+max(nip,ntp)                ! for 1 Jbatch
  memneeded = max(memneeded,maxpq)              ! for MO transform
  if (ntota > 0) then
    memneeded = memneeded+maxtpq                ! for 1 (ta|ub)
    ! for 1 (tu|ab) and 1 reduced set
    if (jsym == 1) memneeded = memneeded+ntota*(maxpq+maxRS)
  else if (ntoti > 0) then
    memneeded = memneeded+maxpq                 ! for 1 (ia|ib)
    ! for 1 (ii|ab) and 1 reduced set
    if (jsym == 1) memneeded = memneeded+npq+maxRS
  end if

  if (memneeded > lWork) then
    write(u6,*) 'CHO_PREC_MCLR: Insufficient memory for I/T batch'
    write(u6,*) 'LWORK= ',LWORK
    write(u6,*) 'min. mem. need= ',memneeded
    write(u6,*) 'maxRS+nip/ntp= ',maxRS+max(nip,ntp)
    write(u6,*) 'maxpq        = ',maxpq
    if (ntota > 0) then
      write(u6,*) 'maxtpq       = ',maxtpq
      if (jsym == 1) write(u6,*) 'ntota*(maxpq,maxRS) = ',ntota*maxpq,ntota*maxRS
    else
      if (jsym == 1) write(u6,*) 'npq,maxRS = ',npq,maxRS
    end if
    call Quit(_RC_MEMORY_ERROR_)
  end if
  lWork = lWork-max(maxpq,maxRS+max(nip,ntp))

  ! How many nab + nrs can be stored in memory while stil having place for
  ! at least 1 nRS, 1 maxpq and 1 nIP
  ! (actually nIP will be smaller but that does not matter very much)
  !
  ! nIshe is the number of inactive orbitals dealt in the batch
  ! nIshb is inactive dealt with after the previous batches

  taskleft = .true.
  do while (taskleft)
    lWorke = lWork
    nIshe(1:nSym) = 0
    nAshe(1:nSym) = 0
    taskleft = .false.
    Libatch = 0
    do i=1,nsym
      k = Mul(i,jsym)

      nab = 0
      nRS = 0
      if (jsym == 1) then
        nab = npq
        nRS = maxRS
      end if
      nab2 = nBas(k)**2
      nileft = nIsh(i)-nIshb(i)
      if ((nab+nab2)*nileft > 0) then
        nIshe(i) = min(lWorke/(nrs+nab+nab2),nileft)
        lWorke = lWorke-(nrs+nab+nab2)*nIshe(i)
        libatch = libatch+(nrs+nab+nab2)*nIshe(i)
        if (nIshe(i) /= nileft) then
          taskleft = .true.
          exit
        end if
      end if

    end do

    ! Update nip and compute sum(nIshe)

    nip = 0
    ntotie = 0
    do i=1,nsym
      k = Mul(i,jsym)
      nip = nip+nIshe(i)*nBas(k)
      ntotie = ntotie+nIshe(i) ! For Lii^J
    end do
    nip = nip+ntotie ! for Lii^J

    call mma_allocate(iiab,libatch,Label='iiab')
    nab = 0
    if ((jsym == 1) .and. (ntotie > 0)) then
      nab = npq
      call mma_allocate(iirs,ntotie*maxRS,Label='iirs')
    end if
    ipiaib = 1+nab*ntotie
    iiab(:) = Zero

    if (taskleft) then
      ntotae = 0
      ntue = 0
      ntp = 0      ! do not allocate those
      labatch = 0
      iptpuq = -1
      !write(u6,*) 'Batching loop i'
    else

      ! Batching T loop

      labatch = 0
      do i=1,nsym
        k = Mul(i,jsym)
        nab = 0
        nRS = 0
        if (jsym == 1) then
          nab = ntota*npq
          nRS = ntota*maxRS
        end if
        nab2 = nAsh(i)*nBas(k)**2
        naleft = nAsh(i)-nAshb(i)
        if ((nab+nab2)*naleft > 0) then
          nAshe(i) = min(lWorke/(nrs+nab+nab2),naleft)
          lWorke = lWorke-(nrs+nab+nab2)*nAshe(i)
          labatch = labatch+(nrs+nab+nab2)*nAshe(i)
          if (nAshe(i) /= naleft) then
            taskleft = .true.
            exit
          end if
        end if
      end do

      ntotae = 0
      ntue = 0
      ntp = 0
      do i=1,nsym
        k = Mul(i,jsym)
        ntotae = ntotae+nAshe(i)
        ntue = ntue+nAshe(i)*nAsh(i)
        ntp = ntp+nAsh(i)*(nBas(k)+nAshe(i))
      end do

      if (ntotae > 0) call mma_allocate(tupq,labatch,Label='tupq')
      nab = 0
      if (jsym == 1) then
        nab = npq
        if (ntue > 0) call mma_allocate(turs,ntue*maxRS,Label='turs')
      end if
      iptpuq = 1+nab*ntue
      tupq(:) = Zero
      if (taskleft) write(u6,*) 'Batching loop a'
    end if

    ! Transpose CMO

    call Allocate_DT(CMOt,nIShe,nBas,nSym)

    ioff = 0
    do iSym=1,nsym
      do j=1,nIshe(iSym)
        ioff3 = ioff+nBas(iSym)*(nIshb(iSym)+j-1)
        CMOt%SB(iSym)%A2(j,:) = CMO(ioff3+1:ioff3+nBas(iSym))
      end do
      ioff = ioff+nBas(iSym)**2
    end do

    ! Loop over reduced sets

    do JRED=JRED1,JRED2
      call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

      if (nVrs == 0) cycle  ! no vectors in that (jred,isym)

      if (nVrs < 0) then
        write(u6,*) 'CHO_PREC_MCLR: Cho_X_nVecRS returned nVrs<0. STOP!'
        call Abend()
      end if

      call Cho_X_SetRed(irc,iLoc,JRED)
      ! set index arrays at iLoc
      if (irc /= 0) then
        write(u6,*) 'CHO_PREC_MCLR: cho_X_setred non-zero return code. rc= ',irc
        call Abend()
      end if

      IREDC = JRED

      nRS = nDimRS(JSYM,JRED)

      if (jSym == 1) then
        piirs(1:nRS,1:ntotie) => iirs(1:nRS*ntotie)
        piirs(:,:) = Zero
        pturs(1:nRS,1:ntue) => turs(1:nRS*ntue)
        pturs(:,:) = Zero
      end if

      call mma_MaxDBLE(LWORKe)
      nVec = min(LWORKE/(nRS+max(nip,ntp)),min(nVrs,MaxVecPerBatch))
      if (nVec < 1) then
        write(u6,*) 'CHO_PREC_MCLR: Insufficient memory for J batch'
        write(u6,*) 'That should not happen here'
        write(u6,*) 'Contact the developers'
        call Quit(_RC_MEMORY_ERROR_)
        nBatch = -9999  ! dummy assignment
      end if
      LREAD = nRS*nVec

      call mma_allocate(Lrs,nRS,nVec,Label='Lrs')

      nBatch = (nVrs-1)/nVec+1

      ! Loop over batches of Cholesky vectors

      do jBatch=1,nBatch

        if (jBatch == nBatch) then
          JNUM = nVrs-nVec*(nBatch-1)
        else
          JNUM = nVec
        end if
        JVEC = nVec*(jBatch-1)+iVrs
        IVEC2 = JVEC-1+JNUM

        iSwap = 1 ! Lqi,J are returned
        call Allocate_DT(Lpq(1),nIshe,nBas,JNUM,JSYM,nSym,iSwap)
        call mma_allocate(Lii,ntotie*nVec,Label='Lii')
        !***************************************************************
        !                                                              *
        !          Let's start the real work                           *
        !                                                              *
        !***************************************************************

        ! Read Cholesky vectors

        call CWTIME(TCR1,TWR1)

        call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

        if ((NUMV <= 0) .or. (NUMV /= JNUM)) return

        call CWTIME(TCR2,TWR2)
        tread(1) = tread(1)+(TCR2-TCR1)
        tread(2) = tread(2)+(TWR2-TWR1)

        !***************************************************************
        ! MO Half-transformation
        ! Liq^J= sum_p Lpq^J Xip

        kMOs = 1  !
        nMOs = 1  ! Active MOs (1st set)

        call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,[CMOt],Lpq(1),DoRead)

        if (irc /= 0) return

        call CWTIME(TCR1,TWR1)
        ttran(1) = ttran(1)+(TCR1-TCR2)
        ttran(2) = ttran(2)+(TWR1-TWR2)

        !***************************************************************
        ! Integral formation
        ! (i p | i q) = sum_J Lip^J  Liq^J

        ip1 = ipiaib
        do isym=1,nsym
          ksym = Mul(iSym,jsym)
          do ii=1,nIshe(isym)

            call DGEMM_('N','T',nBas(kSym),nBas(kSym),JNUM,One,Lpq(1)%SB(kSym)%A3(:,ii,1),nBas(kSym)*nIshe(iSym), &
                        Lpq(1)%SB(kSym)%A3(:,ii,1),nBas(kSym)*nIshe(iSym),One,iiab(ip1:),nBas(kSym))
            ip1 = ip1+nBas(kSym)**2
          end do
        end do
        call CWTIME(TCR2,TWR2)
        tform(1) = tform(1)+(TCR2-TCR1)
        tform(2) = tform(2)+(TWR2-TWR1)

        !***************************************************************
        ! Second MO transformation
        ! Lii^J = sum_q Liq^J Xiq

        if (jSym == 1) then
          ipMO = 1

          iE = 0
          do isym=1,nsym
            iS = 1+iE
            iE = iE+JNUM*nIshe(iSym)

            pLii(1:JNUM,1:nIshe(iSym)) => Lii(iS:iE)

            do ii=1,nIshe(iSym)
              ipMO = ipMO+ISTSQ(iSym)
              ipMOi = ipMO+(nIshb(isym)+ii-1)*nBas(iSym)
              call dGeMV_('T',nBas(iSym),JNUM,One,Lpq(1)%SB(iSym)%A3(:,ii,1),nBas(iSym)*nIshe(iSym),CMO(ipMOi),1,Zero,pLii(:,ii),1)
            end do
            nullify(pLii)
          end do

          call CWTIME(TCR1,TWR1)
          ttran(1) = ttran(1)+(TCR1-TCR2)
          ttran(2) = ttran(2)+(TWR1-TWR2)

          !*************************************************************
          ! Integral formation
          ! (i i | p q) = sum_J Lii^J  Lpq^J

          pLii(1:JNUM,1:ntotie) => Lii(1:JNUM*ntotie)
          call DGEMM_('N','N',nRS,ntotie,JNUM,One,Lrs,nRS,pLii,JNUM,One,piirs,nRS)
          nullify(pLii)

          call CWTIME(TCR2,TWR2)
          tform2(1) = tform2(1)+(TCR2-TCR1)
          tform2(2) = tform2(2)+(TWR2-TWR1)

        end if  ! jSym

        call mma_deallocate(Lii)
        call Deallocate_DT(Lpq(1))

        !***************************************************************
        ! Read half-transformed active vectors

        iSwap = 0 ! Lvb,J
        call Allocate_DT(Lpq(1),nAsh,nBas,JNUM,JSYM,nSym,iSwap)

        call mma_allocate(Lij,ntue*nVec,Label='Lij')

        do i=1,nSym
          k = Mul(i,JSYM)
          lvec = nAsh(k)*nBas(i)*JNUM
          iAdr2 = (JVEC-1)*nAsh(k)*nBas(i)
          call DDAFILE(LuAChoVec(Jsym),2,Lpq(1)%SB(i)%A3,lvec,iAdr2)
        end do

        !***************************************************************
        ! Form (tp|uq) integrals

        do j=1,JNUM

          ioff = 0
          do i=1,nsym
            k = Mul(i,JSYM)

            do it=0,nAshe(k)-1
              itt = nAshb(k)+it+1

              do iu=0,nAshb(k)+it
                iuu = iu+1

                itu = nTri_Elem(it)+it*nAshb(k)+iu

                ipInt = iptpuq+ioff+itu*nBas(i)**2

                call DGER_(nBas(i),nBas(i),One,Lpq(1)%SB(i)%A2(itt:,j),nAsh(i),Lpq(1)%SB(i)%A2(iuu:,j),nAsh(i),tupq(ipInt),nBas(i))

              end do
            end do

            ioff = ioff+(nTri_Elem(nAshe(k))+nAshe(k)*nAshb(k))*nBas(i)**2
          end do
        end do
        call CWTIME(TCR1,TWR1)
        tforma(1) = tforma(1)+(TCR1-TCR2)
        tforma(2) = tforma(2)+(TWR1-TWR2)

        !***************************************************************
        ! Second MO transformation

        if (jsym == 1) then
          ipLtu = 1

          ioff = 0
          iE = 0
          do i=1,nsym
            iS = iE+1
            do j=1,JNUM

              ipMO = 1+ioff+nBas(i)*(nIsh(i)+nAshb(i))
              do k=0,nAshe(i)-1
                call dGeMV_('N',nAshb(i)+k+1,nBas(i),One,Lpq(1)%SB(i)%A3(:,1,j),nAsh(i),CMO(ipMO+k*nBas(i)),1,Zero,Lij(ipLtu),1)
                ipLtu = ipLtu+(nAshb(i)+k+1)
              end do
            end do
            ioff = ioff+nBas(i)**2
          end do

          call CWTIME(TCR2,TWR2)

          !*************************************************************
          ! Formation of the (tu|rs) integral

          ipInt = 1
          iE = 0
          do i=1,nsym
            na2 = nAshe(i)*nAshb(i)+nTri_Elem(nAshe(i))
            if (na2 == 0) cycle
            iS = iE+1
            iE = iE+na2*JNUM

            pLij(1:na2,1:JNUM) => Lij(iS:iE)

            call DGEMM_('N','T',nRS,na2,JNUM,One,Lrs,nRS,pLij,na2,One,turs(ipInt),nRS)
            ipInt = ipInt+nRS*na2
            nullify(pLij)
          end do
          call CWTIME(TCR1,TWR1)
          tforma2(1) = tforma2(1)+(TCR1-TCR2)
          tforma2(2) = tforma2(2)+(TWR1-TWR2)
        end if
        !***************************************************************
        !                                                              *
        !          Cholesky loop is over!                              *
        !                                                              *
        !***************************************************************

        call mma_deallocate(Lij)
        call Deallocate_DT(Lpq(1))
      end do ! jbatch

      ! Transform to full storage, use Lrs as temp storage

      if (jsym == 1) then
        add = .true.
        nMat = 1
        do i=1,ntotie
          call Allocate_DT(Tmp(1),nBas,nBas,nSym,aCase='TRI',Ref=iiab(1+nab*(i-1):))
          call swap_rs2full(irc,iLoc,nRS,nMat,JSYM,Tmp,piirs(:,i),add)
          call Deallocate_DT(Tmp(1))
        end do
        do i=1,ntue
          call Allocate_DT(Tmp(1),nBas,nBas,nSym,aCase='TRI',Ref=tupq(1+npq*(i-1):))
          call swap_rs2full(irc,iLoc,nRS,nMat,JSYM,Tmp,pturs(:,i),add)
          call Deallocate_DT(Tmp(1))
        end do
      end if

      call mma_deallocate(Lrs)
    end do ! reduced set JRED

    if (jsym == 1) then
      if (ntotie > 0) call mma_deallocate(iirs)
      if (ntue > 0) call mma_deallocate(turs)
      nullify(piirs,pturs)
    end if

    !MGD  Gather integrals from parallel runs

    call CWTIME(TCR1,TWR1)
    call mma_allocate(Integral,maxpq,Label='Integral')
    ip1 = ipiaib
    ip3 = iptpuq
    isum = 0
    isum2 = 0
    do isym=1,nSym
      ksym = Mul(iSym,jsym)
      nvirt = nBas(kSym)-nIsh(kSym)
      ipMO = 1+ISTSQ(kSym)+nBas(kSym)*nIsh(kSym)

      do ii=1,nIshe(isym)

        ! MO transform (i i | p q)

        if (jsym == 1) then
          isum = isum+1
          ip2 = 1+nab*(isum-1)
          ioff2 = 0
          do ksym2=1,nsym
            ipMO2 = 1+ioff2+nBas(kSym2)*nIsh(kSym2)
            nvirt2 = nBas(kSym2)-nIsh(kSym2)
            do j=1,nvirt2
              ipMOj = ipMO2+(j-1)*nBas(kSym2)
              ipIntj = 1+(j-1)*nBas(kSym2)
              call DSPMV_('U',nBas(kSym2),One,iiab(ip2),CMO(ipMOj),1,Zero,Integral(ipIntj),1)
            end do
            call DGEMM_('T','N',nvirt2,nvirt2,nBas(kSym2),One,Integral,nBas(kSym2),CMO(ipMO2),nBas(kSym2),Zero,iiab(ip2),nvirt2)

            call GADSum(iiab(ip2),nvirt2**2)
            call DDAFILE(LuChoInt(1),1,iiab(ip2),nvirt2**2,iAdr)

            ip2 = ip2+nBas(kSym2)**2
            ioff2 = ioff2+nBas(kSym2)**2
          end do
        else
          iAdr = iAdr+sum((nBas(1:nSym)-nIsh(1:nSym))**2)
        end if

        ! MO transform (i p | i q)

        call DGEMM_('N','N',nBas(kSym),nvirt,nBas(kSym),One,iiab(ip1:),nBas(kSym),CMO(ipMO),nBas(kSym),Zero,Integral,nBas(kSym))
        call DGEMM_('T','N',nvirt,nvirt,nBas(kSym),One,Integral,nBas(kSym),CMO(ipMO),nBas(kSym),Zero,iiab(ip1:),nvirt)

        iAdr = iAdr+sum((nBas(1:kSym-1)-nIsh(1:kSym-1))**2)
        call GADSum(iiab(ip1:),nvirt**2)
        call DDAFILE(LuChoInt(1),1,iiab(ip1:),nvirt**2,iAdr)
        iAdr = iAdr+sum((nBas(kSym+1:nSym)-nIsh(kSym+1:nSym))**2)

        ip1 = ip1+nBas(kSym)**2
      end do

      ! MO transform (t u | p q)

      ! compute address
      iAdrtu = 0
      do i=1,ksym-1
        na2 = nAshe(i)*nAshb(i)+nTri_Elem(nAshe(i))
        do j=1,na2
          iAdrtu = iAdrtu+npq+sum(nBas(1:nSym)**2)
        end do
      end do

      ipMO = 1+ISTSQ(iSym)
      na2 = nAshe(ksym)*nAshb(ksym)+nTri_Elem(nAshe(ksym))
      do itu=1,na2
        if (jsym == 1) then
          isum2 = isum2+1
          ip2 = 1+npq*(isum2-1)
          ioff2 = 0
          do ksym2=1,nsym
            ipMO2 = 1+ioff2
            do j=1,nBas(ksym2)
              ipMOj = ipMO2+(j-1)*nBas(kSym2)
              ipIntj = 1+(j-1)*nBas(kSym2)
              call DSPMV_('U',nBas(kSym2),One,tupq(ip2),CMO(ipMOj),1,Zero,Integral(ipIntj),1)
            end do
            if (nBas(ksym2) > 0) then
              call DGEMM_('T','N',nBas(ksym2),nBas(kSym2),nBas(kSym2),One,Integral,nBas(kSym2),CMO(ipMO2),nBas(kSym2),Zero, &
                          tupq(ip2),nBas(kSym2))
              call GADSum(tupq(ip2),nBas(kSym2)**2)
              call DDAFILE(LuChoInt(2),1,tupq(ip2),nBas(kSym2)**2,iAdrtu)

              ip2 = ip2+nBas(kSym2)**2
              ioff2 = ioff2+nBas(kSym2)**2
            end if
          end do
        else
          iAdrtu = iAdrtu+npq
        end if

        ! MO transform (t p | u q)

        call DGEMM_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One,tupq(ip3),nBas(iSym),CMO(ipMO),nBas(iSym),Zero,Integral,nBas(iSym))
        call DGEMM_('T','N',nBas(iSym),nBas(iSym),nBas(iSym),One,Integral,nBas(iSym),CMO(ipMO),nBas(iSym),Zero,tupq(ip3),nBas(iSym))
        iAdrtu = iAdrtu+sum(nBas(1:iSym-1)**2)

        call GADSum(tupq(ip3),nBas(iSym)**2)
        call DDAFILE(LuChoInt(2),1,tupq(ip3),nBas(iSym)**2,iAdrtu)

        iAdrtu = iAdrtu+sum(nBas(iSym+1:nSym)**2)
        ip3 = ip3+nBas(iSym)**2

      end do

    end do
    call CWTIME(TCR2,TWR2)
    tMO(1) = tMO(1)+(TCR2-TCR1)
    tMO(2) = tMO(2)+(TWR2-TWR1)

    call mma_deallocate(Integral)

    nIshb(1:nSym) = nIshb(1:nSym)+nIshe(1:nSym)  ! now those are done!
    nAshb(1:nSym) = nAshb(1:nSym)+nAshe(1:nSym)  ! now those are done!
    call Deallocate_DT(CMOt)
    call mma_deallocate(iiab)
    if (ntotae > 0) call mma_deallocate(tupq)
  end do  ! loop over i/t batches

end do ! jsym

call CWTIME(TCstart2,TWstart2)
TOTCPU = TCstart2-TCstart1
TOTWALL = TWstart2-TWstart1
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky MCLR timing from CHO_PREC_MCLR'
  write(u6,CFmt) '----------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Integral construction           CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ VECTORS                              ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'TRANSFORMATION                            ',ttran(1),ttran(2)
  write(u6,'(2x,A26,2f10.2)') '(IA|IB) FORMATION                         ',tform(1),tform(2)
  write(u6,'(2x,A26,2f10.2)') '(II|AB) FORMATION                         ',tform2(1),tform2(2)
  write(u6,'(2x,A26,2f10.2)') '(TP|UQ) FORMATION                         ',tforma(1),tforma(2)
  write(u6,'(2x,A26,2f10.2)') '(TU|PQ) FORMATION                         ',tforma2(1),tforma2(2)
  write(u6,'(2x,A26,2f10.2)') 'MO TRANSFORMATION                         ',tMO(1),tMO(2)
  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

end subroutine CHO_Prec_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_SyncDiag(Diag,iLoc)
!
! Purpose: synchronize global diagonal. Diag is the local diagonal
!          and iLoc tells which memory location to use for reduced
!          set index arrays.

use Cholesky, only: Cho_Real_Par, Diag_G, iL2G, IndRed, nnBstRT, nnBstRT_G, TMISC
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*)
integer(kind=iwp), intent(in) :: iLoc
integer(kind=iwp) :: i, j
real(kind=wp) :: c1, c2, w1, w2

! Skip if serial run.
! -------------------

if (.not. Cho_Real_Par) return
call CWTime(c1,w1)

! Zero all entries in global diagonal.
! ------------------------------------

Diag_G(1:nnBstRT_G(1)) = Zero

! Copy elements from local to global diagonal.
! --------------------------------------------

if (iLoc == 1) then
  do i=1,nnBstRT(1)
    Diag_G(iL2G(i)) = Diag(i)
  end do
else
  do j=1,nnBstRT(iLoc)
    i = IndRed(j,iLoc)
    Diag_G(iL2G(i)) = Diag(i)
  end do
end if

! Synchronize global diagonal.
! ----------------------------

call Cho_GADGop(Diag_G,nnBstRT_G(1),'+')

call CWTime(c2,w2)
tMisc(1,4) = tMisc(1,4)+c2-c1
tMisc(2,4) = tMisc(2,4)+w2-w1

end subroutine Cho_P_SyncDiag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine exppqij(wrk,wrksize,typv2,typp,typq,typr,typs,directyes,inverseyes)
! this routine realizes reorganization to
! #2 <p q i j> with given typv2 and typp-typs  <-  #1 <pp,qq|i,j>
! #1 is in shape <pp,qq|i,j> for sympp,symqq,symi>=symj with types
! pp,qq,i,j -5,5,1,1
! #2 <p q i j> may be antisymmetrized or not, two parameters (directyes,
! inverseyes) can be deduced trom typv2 and typp-s, but for simplicity
! these are as input parameters
! this routine does not allow to use typv2=2
!
! typv2     - typ of final #2 (I)
! typp-s    - types of ind. p-s (I)
! directyes - 1 if direct <pqij> integrals are included (I)
! inverseyes- 1 if inverse <qpij> integrals are included (I)
!
! foreign routines used:
! grc0
!
! it also defines new mapd2,mapi2 corresponding to #2

use ccsort_global, only: mapd1, mapd2, mapi1, mapi2, pos20
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, typv2, typp, typq, typr, typs, directyes, inverseyes
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
integer(kind=iwp) :: ii, iiv1d, iiv1i, length, post, posv1d, posv1i, posv2, symi, symj, symp, symq

! get mapd mapi of <p,q r,s> into mapd2,mapi2

call ccsort_grc0(4,typv2,typp,typq,typr,typs,1,pos20,post,mapd2,mapi2)

! realize reorganization psb

do ii=1,mapd2(0,5)

  ! def parameters of #2
  posv2 = mapd2(ii,1)
  length = mapd2(ii,2)
  symp = mapd2(ii,3)
  symq = mapd2(ii,4)
  symi = mapd2(ii,5)
  symj = mapd2(ii,6)

  ! skip this step if length=0
  if (length == 0) cycle

  ! vanish #2
  wrk(posv2:posv2+length-1) = Zero

  if (symi >= symj) then
    ! case symi>=symj - integrals in #1 are in that shape

    if (directyes == 1) then
      ! def position #1 direct (i.e. #1 <symp,symq| symi,symj>)
      ! direct integrals are always used
      iiv1d = mapi1(symp,symq,symi)
      posv1d = mapd1(iiv1d,1)

      ! do #2 <p q i j> <- #1 <p,q|i,j> (i.e. direct)
      ! N.B. Since #1 is  always >= symj
      ! so in this case order of indices in #1 and #2 is the same
      call ireorg(wrk,wrksize,symp,symq,symi,symj,typp,typq,typr,typs,1,2,3,4,5,5,1,1,typv2,posv1d,posv2,One)

    end if

    if (inverseyes == 1) then

      ! def position #1 inverse (i.e. #1 <symq,symp| symi,symj>)
      ! inverse integrals are used only if antisymmetry is required
      iiv1i = mapi1(symq,symp,symi)
      posv1i = mapd1(iiv1i,1)

      ! do #2 <p q i j> <- - #1 <q,p|i,j> (i.e. inverse)
      ! N.B. Since #1 is  always >= symj
      ! so in this case order of indices in #1 and #2 are inversed 1<->2
      call ireorg(wrk,wrksize,symp,symq,symi,symj,typp,typq,typr,typs,2,1,3,4,5,5,1,1,typv2,posv1i,posv2,-One)

    end if

  else
    ! case symi<symj - integrals in #1 are in inverse (symi>=symj) shape

    if (directyes == 1) then

      ! def position #1 direct (i.e. #1 <symq,symp| symj,symi>)
      ! direct integrals are always used
      iiv1d = mapi1(symq,symp,symj)
      posv1d = mapd1(iiv1d,1)

      ! do #2 <p q i j> <- #1 <q,p|j,i> (i.e. direct)
      ! N.B. Since #1 is  always >= symj
      ! so in this case order of indices in #1 and #2 is inversed 1<->2, 3<->4
      call ireorg(wrk,wrksize,symp,symq,symi,symj,typp,typq,typr,typs,2,1,4,3,5,5,1,1,typv2,posv1d,posv2,One)

    end if

    if (inverseyes == 1) then

      ! def position #1 inverse (i.e. #1 <symp,symq| symj,symi>)
      ! inverse integrals are used only if antisymmetry is required
      iiv1i = mapi1(symp,symq,symj)
      posv1i = mapd1(iiv1i,1)

      ! do #2 <p q i j> <- - #1 <p,q|j,i> (i.e. inverse)
      ! N.B. Since #1 is  always >= symj
      ! so in this case order of indices in #1 and #2 are inversed 3<->4
      call ireorg(wrk,wrksize,symp,symq,symi,symj,typp,typq,typr,typs,1,2,4,3,5,5,1,1,typv2,posv1i,posv2,-One)

    end if

  end if

end do

return

end subroutine exppqij

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine Boys_Iter(Functional,CMO,Thrs,ThrRot,ThrGrad,
     &                     ipLbl_AO,ipLbl,
     &                     nBas,nOrb2Loc,nComp,nMxIter,
     &                     Maximisation,Converged,Debug,Silent)
C
C     Author: T.B. Pedersen
C
C     Purpose: Boys localisation of orbitals.
C
      Implicit Real*8 (a-h,o-z)
      Real*8  CMO
      Integer ipLbl_AO(nComp), ipLbl(nComp)
      Integer nBas, nOrb2Loc
      Logical Maximisation, Converged, Debug, Silent
#include "real.fh"
#include "WrkSpc.fh"

C     Print iteration table header.
C     -----------------------------

      If (.not.Silent) Then
         Write(6,'(//,1X,A,A,/,1X,A,A)')
     &   '                                                        CPU ',
     &   '      Wall',
     &   'nIter       Functional P        Delta     Gradient     (sec)',
     &   '     (sec) %Screen'
      End If

C     Initialization (iter 0).
C     ------------------------

      If (.not.Silent) Call CWTime(C1,W1)
      nIter=0
      Converged = .False.
      lRmat = nOrb2Loc**2
      Call GetMem('Rmat','Allo','Real',ipRmat,lRmat)
      Call GenerateB(CMO,nBas,nOrb2Loc,ipLbl_AO,ipLbl,nComp,Debug)
      Call ComputeFuncB2(nOrb2Loc,ipLbl,nComp,Functional,Debug)
      Call GetGrad_Boys(nOrb2Loc,ipLbl,nComp,Work(ipRmat),GradNorm,
     &                  Debug)
      OldFunctional=Functional
      FirstFunctional=Functional
      Delta=Functional
      If (.not. Silent) Then
        Call CWTime(C2,W2)
        TimC = C2 - C1
        TimW = W2 - W1
        Write(6,'(1X,I5,1X,F18.8,2(1X,D12.4),2(1X,F9.1),1X,F7.2)')
     &  nIter,Functional,Delta,GradNorm,TimC,TimW,Zero
      End If

C     Iterations.
C     -----------

      lCol = 2*nOrb2Loc
      Call GetMem('Col','Allo','Real',ipCol,lCol)
      Do While (nIter.lt.nMxIter .and. .not.Converged)
         If (.not.Silent) Call CWTime(C1,W1)
         Call RotateOrbB(CMO,Work(ipCol),ipLbl,nComp,nBas,nOrb2Loc,
     &                   Maximisation,ThrRot,PctSkp,Debug)
         Call ComputeFuncB2(nOrb2Loc,ipLbl,nComp,Functional,Debug)
         Call GetGrad_Boys(nOrb2Loc,ipLbl,nComp,Work(ipRmat),GradNorm,
     &                     Debug)
         nIter=nIter+1
         Delta=Functional-OldFunctional
         OldFunctional=Functional
         If (.not.Silent) Then
            Call CWTime(C2,W2)
            TimC = C2 - C1
            TimW = W2 - W1
            Write(6,'(1X,I5,1X,F18.8,2(1X,D12.4),2(1X,F9.1),1X,F7.2)')
     &      nIter,Functional,Delta,GradNorm,TimC,TimW,PctSkp
         End If
         Converged=GradNorm.le.ThrGrad .and. abs(Delta).le.Thrs
      End Do
      Call GetMem('Col','Free','Real',ipCol,lCol)
      Call GetMem('Rmat','Free','Real',ipRmat,lRmat)

C     Print convergence message.
C     --------------------------

      If (.not.Silent) Then
         If (.not.Converged) Then
            Write(6,'(/,A,I4,A)')
     &      'No convergence after',nIter,' iterations.'
         Else
            Write(6,'(/,A,I4,A)')
     &      'Convergence after',nIter,' iterations.'
            Write(6,*)
            Write(6,'(A,1X,I4)')    'Number of localised orbitals  :',
     &                              nOrb2Loc
            Write(6,'(A,1X,1P,D20.10)')
     &                              'Value of P before localisation:',
     &                              FirstFunctional
            Write(6,'(A,1X,1P,D20.10)')
     &                              'Value of P after localisation :',
     &                              Functional
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ORDER(C,D,N)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(inout) :: C(N,N), D(N)
integer(kind=iwp) :: I, IMIN, J, K
real(kind=wp) :: DMIN, TMP

do I=1,N-1
  IMIN = I
  DMIN = D(I)
  do J=I+1,N
    if (D(J) < DMIN) then
      DMIN = D(J)
      IMIN = J
    end if
  end do
  if (I == IMIN) cycle
  D(IMIN) = D(I)
  D(I) = DMIN
  do K=1,N
    TMP = C(K,I)
    C(K,I) = C(K,IMIN)
    C(K,IMIN) = TMP
  end do
end do

return

end subroutine ORDER

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine genpowers(Lhigh,powexp,coulovlp)

use AMFI_global, only: df, exponents, Lmax, MxprimL, nprimit
use Constants, only: One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lhigh
real(kind=wp), intent(out) :: powexp(MxprimL,MxprimL,0:Lmax,0:Lmax,0:(Lmax+Lmax+5)), &
                              coulovlp(MxprimL,MxprimL,-1:1,-1:1,0:Lmax,0:Lmax)
integer(kind=iwp) :: incl1, incl2, iprim1, iprim2, irun1, irun2, L1, L2, Lrun, n1, n2
real(kind=wp) :: df1, df12, df2, fact, fact1, fact2, factor

!bs set some often used powers of exponents
do L2=0,Lhigh
  do L1=0,L2
    powexp(1:nprimit(L1),1:nprimit(L2),L1,L2,0) = One
  end do
end do
do L2=0,Lhigh
  do L1=0,L2
    do Lrun=1,(L1+L2+5)
      do irun2=1,nprimit(L2)
        do irun1=1,nprimit(L1)
          fact = sqrt(Half*(exponents(irun1,L1)+exponents(irun2,L2)))
          !bs write(u6,*) 'fact',fact,'powexp',powexp(irun1,irun2,L1,L2,Lrun-1)
          powexp(irun1,irun2,L1,L2,Lrun) = powexp(irun1,irun2,L1,L2,Lrun-1)*fact
        end do
      end do
    end do
  end do
end do
!bs generate coulovlp = overlap for normalized functions, but sometimes
!bs with shifted l-values
do l2=0,lhigh
  do incl2=-1,1
    if (l2+incl2 >= 0) then  ! do not lower l for s-functions
      n2 = l2+incl2+1
      df2 = One/sqrt(df(n2+n2-1))
      do l1=0,l2
        do incl1=-1,1
          if (l1+incl1 >= 0) then ! do not lower l for s-functions
            n1 = l1+incl1+1
            df1 = One/sqrt(df(n1+n1-1))
            df12 = df(n1+n2-1)
            do iprim2=1,nprimit(l2)
              fact2 = sqrt(powexp(iprim2,iprim2,l2,l2,n2+n2+1))
              factor = fact2*df1*df2*df12
              do iprim1=1,nprimit(l1)
                fact1 = sqrt(powexp(iprim1,iprim1,l1,l1,n1+n1+1))
                coulovlp(iprim1,iprim2,incl1,incl2,l1,l2) = fact1*factor/powexp(iprim1,iprim2,l1,l2,n1+n2+1)
                !BS write(u6,*) 'fact1',fact1,'factor ',factor,'powexp ',powexp(iprim1,iprim2,l1,l2,n1+n2+1)
              end do
            end do
          end if
        end do
      end do
    end if
  end do
end do

return

end subroutine genpowers

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine MKBNEVF(nAshT,NG3,Hbar,Gact,G2,G3,idxG3)

use Index_Functions, only: iTri, nTri_Elem
use caspt2_global, only: LUSBT
use caspt2_module, only: IASYM, NINDEP, NSYM, NTGEU, NTGEUES, NTGTU, NTGTUES, NTU, NTUES
use EQSOLV, only: IDBMAT
use SUPERINDEX, only: KTGTU, KTU, MTGEU, MTU
use Symmetry_Info, only: Mul
use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: nAshT, NG3
real(kind=wp), intent(in) :: Hbar(nAshT,nAshT), Gact(nAshT,nAshT,nAshT,nAshT), G2(nAshT,nAshT,nAshT,nAshT), G3(NG3)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: IBADR, IBMADR, IBPADR, ID, IDISK, iG3, IST, ISU, ISV, ISX, ISY, ISYM, ISZ, IT, ITABS, ITGEU, ITGEUABS, ITGTU, &
                     ITU, ITUABS, ITUVS, IU, IUABS, IV, IVABS, IVX, IW, IWABS, IX, IXABS, IXGEY, IXGEYABS, IXGTY, IXY, IXYABS, &
                     IXYZS, IY, IYABS, IYX, IYZ, IZ, IZABS, NAS, NASM, NASP, NBF, NBFM, NBFP
real(kind=wp) :: BTUXY, BTUYX, G3VAL, Val
real(kind=wp), allocatable :: BF(:), BFM(:), BFP(:)

do ISYM=1,NSYM
  if (NINDEP(ISYM,8) == 0) cycle
  NAS = NTU(ISYM)
  NBF = nTri_Elem(NAS)
  if (NBF > 0) call mma_Allocate(BF,NBF,LABEL='BF')
  BF(:) = Zero
  call Init_Tsk(ID,NAS)

  ! K(tu,xy) = - h(xv)D(tu,vy) - h(yv)D(tu,xv)
  ! K(tu,xy) = - 0.5*(vw|xz) ( del(vz)D(tu,wy) + del(yv)D(tu,zw) )
  !            - 0.5*(vw|yz) ( del(xv)D(tu,wz) + del(vz)D(tu,xw) )
  !do ITU=1,NAS
  !  if (.not. Rsv_Tsk(ID,ITU)) cycle
  do while (Rsv_Tsk(ID,ITU))
    ITUABS = ITU+NTUES(ISYM)
    ITABS = MTU(1,ITUABS)
    IUABS = MTU(2,ITUABS)
    !iSymT = IASYM(ITABS)
    !iSymU = IASYM(IUABS)
    do IXY=1,ITU
      IXYABS = IXY+NTUES(ISYM)
      IXABS = MTU(1,IXYABS)
      IYABS = MTU(2,IXYABS)
      !iSymX = IASYM(IXABS)
      !iSymY = IASYM(IYABS)
      IBADR = iTri(ITU,IXY)
      !ITX = ITABS+NASHT*(IXABS-1)
      !IUY = IUABS+NASHT*(IYABS-1)
      !IP = iTri(ITX,IUY)
      Val = Zero
      ! Hbar term
      do IV=1,NASHT
        IVABS = IV!+NAES(ISYM)
        Val = Val-Hbar(IXABS,IVABS)*G2(ITABS,IVABS,IUABS,IYABS)
        Val = Val-Hbar(IYABS,IVABS)*G2(ITABS,IXABS,IUABS,IVABS)
      end do
      !do IV=1,nAsh(iSymX)
      !  IVABS = IV+NAES(iSymX)
      !  Val = Val-Hbar(IXABS,IVABS)*G2(ITABS,IVABS,IUABS,IYABS)
      !end do
      !do IV=1,nAsh(iSymY)
      !  IVABS = IV+NAES(iSymY)
      !  Val = Val-Hbar(IYABS,IVABS)*G2(ITABS,IXABS,IUABS,IVABS)
      !end do
      ! RDM3 term
      ! RDM2 term
      do IV=1,NASHT
        IVABS = IV!+NAES(ISYM)
        do IW=1,NASHT
          IWABS = IW!+NAES(ISYM)
          do IZ=1,NASHT
            IZABS = IZ!+NAES(ISYM)
            if (IVABS == IZABS) Val = Val-Half*Gact(IVABS,IWABS,IXABS,IZABS)*G2(ITABS,IWABS,IUABS,IYABS)
            if (IYABS == IVABS) Val = Val-Half*Gact(IVABS,IWABS,IXABS,IZABS)*G2(ITABS,IZABS,IUABS,IWABS)
            if (IXABS == IVABS) Val = Val-Half*Gact(IVABS,IWABS,IYABS,IZABS)*G2(ITABS,IWABS,IUABS,IZABS)
            if (IVABS == IZABS) Val = Val-Half*Gact(IVABS,IWABS,IYABS,IZABS)*G2(ITABS,IXABS,IUABS,IWABS)
          end do
        end do
      end do
      BF(IBADR) = Val
      !write(u6,'(4i3,f20.10)') itabs,iuabs,ixabs,iyabs,Val
    end do
  end do
  call Free_Tsk(ID)

  ! The relation with the "standard" RDM and "MOLCAS" RDM is:
  ! D(MOLCAS)(tuvxyz) = D(standard)(tvy,uxz)
  ! D(standard)(tuvxyz) = D(MOLCAS)(txu,yvz)
  ! K(tu,xy) = - (vw|xz) D(tuv,zyw)
  !            - (vw|yz) D(tuv,xzw)
  ! DK(db,a'b') = RDM3(a'b'c',abc)*G(d,a,c',c)
  ! DK(wy,t u ) = RDM3(tuv,xyz)*G(w,x,v,z)
  !>DK(wv,t x ) = RDM3(txu,yvz)*G(w,y,u,z)

  ! DK(ad,a'b') = RDM3(a'b'c',abc)*G(d,b,c',c)
  ! DK(xw,t u ) = RDM3(tuv,xyz)*G(w,y,v,z)
  !>DK(yw,t x ) = RDM3(txu,yvz)*G(w,v,u,z)
  do IG3=1,NG3
    iT = idxG3(1,iG3)
    iU = idxG3(2,iG3)
    iV = idxG3(3,iG3)
    iX = idxG3(4,iG3)
    iY = idxG3(5,iG3)
    iZ = idxG3(6,iG3)
    iST = IASYM(iT)
    iSU = IASYM(iU)
    iSV = IASYM(iV)
    iSX = IASYM(iX)
    iSY = IASYM(iY)
    iSZ = IASYM(iZ)
    ituvs = MUL(IST,MUL(ISU,ISV))
    ixyzs = MUL(ISX,MUL(ISY,ISZ))
    if (ituvs /= ixyzs) cycle
    iTU = iT+NASHT*(iU-1)
    iVX = iV+NASHT*(iX-1)
    iYZ = iY+NASHT*(iZ-1)

    G3VAL = G3(iG3)

    ! F(tuvxyz) -> BC(vut,xyz)
    if (MUL(iST,iSV) == iSym) call Add_MKBNEVF(iT,iU,iV,iX,iY,iZ)

    if ((iTU /= iVX) .or. (iVX /= iYZ)) then
      if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
        ! F(vxtuyz) -> BC(txv,uyz)
        if (MUL(iSV,iST) == iSym) call Add_MKBNEVF(iV,iX,iT,iU,iY,iZ)
        ! F(yzvxtu) -> BC(vzy,xtu)
        if (MUL(iSY,iSV) == iSym) call Add_MKBNEVF(iY,iZ,iV,iX,iT,iU)
        ! F(tuyzvx) -> BC(yut,zvx)
        if (MUL(iST,iSY) == iSym) call Add_MKBNEVF(iT,iU,iY,iZ,iV,iX)
      end if
      ! F(yztuvx) -> BC(tzy,uvx)
      if (MUL(iSY,iST) == iSym) call Add_MKBNEVF(iY,iZ,iT,iU,iV,iX)
      ! F(vxyztu) -> BC(yxv,ztu)
      if (MUL(iSV,iSY) == iSym) call Add_MKBNEVF(iV,iX,iY,iZ,iT,iU)
    end if

    if ((iT == iU) .and. (iV == iX) .and. (iY == iZ)) cycle
    if ((iT == iU) .and. (iV == iZ) .and. (iX == iY)) cycle
    if ((iX == iV) .and. (iT == iZ) .and. (iU == iY)) cycle
    if ((iZ == iY) .and. (iV == iU) .and. (iX == iT)) cycle

    ! F(utxvzy) -> BC(xtu,vzy)
    if (MUL(iSU,iSX) == iSym) call Add_MKBNEVF(iU,iT,iX,iV,iZ,iY)

    if ((iTU == iVX) .and. (iVX == iYZ)) cycle
    if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
      ! F(xvutzy) -> BC(uvx,tzy)
      if (MUL(iSX,iSU) == iSym) call Add_MKBNEVF(iX,iV,iU,iT,iZ,iY)
      ! F(zyxvut) -> BC(xyz,vut)
      if (MUL(iSZ,iSX) == iSym) call Add_MKBNEVF(iZ,iY,iX,iV,iU,iT)
      ! F(utzyxv) -> BC(ztu,yxv)
      if (MUL(iSU,iSZ) == iSym) call Add_MKBNEVF(iU,iT,iZ,iY,iX,iV)
    end if
    ! F(zyutxv) -> BC(uyz,txv)
    if (MUL(iSZ,iSU) == iSym) call Add_MKBNEVF(iZ,iY,iU,iT,iX,iV)
    ! F(xvzyut) -> BC(zvx,yut)
    if (MUL(iSX,iSZ) == iSym) call Add_MKBNEVF(iX,iV,iZ,iY,iU,iT)
  end do

  BF(:) = Two*BF(:)

  NASP = NTGEU(ISYM)
  NBFP = nTri_Elem(NASP)
  if (NBFP > 0) call mma_allocate(BFP,NBFP,Label='BFP')
  NASM = NTGTU(ISYM)
  NBFM = nTri_Elem(NASM)
  if (NBFM > 0) call mma_allocate(BFM,NBFM,Label='BFM')

  do ITGEU=1,NASP
    ITGEUABS = ITGEU+NTGEUES(ISYM)
    ITABS = MTGEU(1,ITGEUABS)
    IUABS = MTGEU(2,ITGEUABS)
    ITU = KTU(ITABS,IUABS)-NTUES(ISYM)
    do IXGEY=1,ITGEU
      IXGEYABS = IXGEY+NTGEUES(ISYM)
      IXABS = MTGEU(1,IXGEYABS)
      IYABS = MTGEU(2,IXGEYABS)
      IXY = KTU(IXABS,IYABS)-NTUES(ISYM)
      IYX = KTU(IYABS,IXABS)-NTUES(ISYM)
      IBADR = iTri(ITU,IXY)
      BTUXY = BF(IBADR)
      IBADR = iTri(ITU,IYX)
      BTUYX = BF(IBADR)
      IBPADR = iTri(ITGEU,IXGEY)
      BFP(IBPADR) = BTUXY+BTUYX
      if (ITABS == IUABS) cycle
      if (IXABS == IYABS) cycle
      ITGTU = KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
      IXGTY = KTGTU(IXABS,IYABS)-NTGTUES(ISYM)
      IBMADR = iTri(ITGTU,IXGTY)
      BFM(IBMADR) = BTUXY-BTUYX
    end do
  end do

# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    call GADGOP(BFP,NBFP,'+')
    call GADGOP(BFM,NBFM,'+')
  end if
# endif

  if (NBF > 0) call mma_deallocate(BF)

  if ((NBFP > 0) .and. (NINDEP(ISYM,8) > 0)) then
    IDISK = IDBMAT(ISYM,8)
    call DDAFILE(LUSBT,1,BFP,NBFP,IDISK)
    call mma_deallocate(BFP)
  end if
  if (NBFM > 0) then
    if (NINDEP(ISYM,9) > 0) then
      IDISK = IDBMAT(ISYM,9)
      call DDAFILE(LUSBT,1,BFM,NBFM,IDISK)
    end if
    call mma_deallocate(BFM)
  end if
end do

contains

subroutine Add_MKBNEVF(ITABS_,IXABS_,IUABS_,IYABS_,IVABS_,IZABS_)

  integer(kind=iwp), intent(in) :: ITABS_, IXABS_, IUABS_, IYABS_, IVABS_, IZABS_
  integer(kind=iwp) :: IBADR, ITU_, IWABS, IXY_

  iTU_ = KTU(ITABS_,IUABS_)-NTUES(ISYM)
  do IWABS=1,nAshT
    if (MUL(IASYM(IWABS),IASYM(IYABS_)) == iSym) then
      iXY_ = KTU(IWABS,IYABS_)-NTUES(ISYM)
      if (iTU_ >= iXY_) then
        IBADR = iTri(iTU_,iXY_)
        BF(IBADR) = BF(IBADR)-G3VAL*Gact(IWABS,IXABS_,IVABS_,IZABS_)
      end if
    end if
    if (MUL(IASYM(IXABS_),IASYM(IWABS)) == iSym) then
      iXY_ = KTU(IXABS_,IWABS)-NTUES(ISYM)
      if (iTU_ >= iXY_) then
        IBADR = iTri(iTU_,iXY_)
        BF(IBADR) = BF(IBADR)-G3VAL*Gact(IWABS,IYABS_,IVABS_,IZABS_)
      end if
    end if
  end do

end subroutine Add_MKBNEVF

end subroutine MKBNEVF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_ANASIZE(VEC,LVEC,BIN,LBIN,LUPRI)
!
! Purpose: analyse vector (histogram).

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LVEC, LBIN, LUPRI
real(kind=wp), intent(in) :: VEC(LVEC)
real(kind=wp), intent(inout) :: BIN(LBIN)
integer(kind=iwp), parameter :: MBIN = 20
integer(kind=iwp) :: I, IBIN, ICOUNT(MBIN), IJOB, JCOUNT, NBIN, NLOW, NNEG, NZER
real(kind=wp) :: TEST, TOPCT, XNEG
logical(kind=iwp) :: FOUND

! Return if nothing to do.
! ------------------------

if ((LVEC < 1) .or. (LBIN < 1)) return

! Ensure that BIN is in descending order.
! ---------------------------------------

IJOB = -1
call CHO_ORDER(BIN,LBIN,IJOB)

! Test that BIN is positive.
! --------------------------

if (BIN(1) <= Zero) return

! Analysis.
! ---------

NBIN = min(LBIN,MBIN)
ICOUNT(1:NBIN) = 0
NLOW = 0
NZER = 0
NNEG = 0
XNEG = Zero

do I=1,LVEC

  TEST = VEC(I)

  if (TEST < Zero) then
    NNEG = NNEG+1
    XNEG = min(XNEG,TEST)
  else if (TEST == Zero) then
    NZER = NZER+1
  end if

  IBIN = 0
  FOUND = .false.
  do while ((.not. FOUND) .and. (IBIN < NBIN))
    IBIN = IBIN+1
    if (TEST >= BIN(IBIN)) then
      ICOUNT(IBIN) = ICOUNT(IBIN)+1
      FOUND = .true.
    end if
  end do
  if (.not. FOUND) NLOW = NLOW+1

end do

! Print.
! ------

TOPCT = 1.0e2_wp/real(LVEC,kind=wp)

JCOUNT = ICOUNT(1)
write(LUPRI,'(/,1X,A,11X,ES11.4,A,I12,1X,F7.2,A,3X,A,F7.2,A)') 'Larger than ',BIN(1),':',ICOUNT(1),real(ICOUNT(1),kind=wp)*TOPCT, &
                                                               '%','Accumulated: ',real(JCOUNT,kind=wp)*TOPCT,'%'
do IBIN=2,NBIN
  JCOUNT = JCOUNT+ICOUNT(IBIN)
  write(LUPRI,'(1X,A,ES11.4,A,ES11.4,A,I12,1X,F7.2,A,3X,A,F7.2,A)') 'Between ',BIN(IBIN-1),' and ',BIN(IBIN),':',ICOUNT(IBIN), &
                                                                    real(ICOUNT(IBIN),kind=wp)*TOPCT,'%','Accumulated: ', &
                                                                    real(JCOUNT,kind=wp)*TOPCT,'%'
end do
JCOUNT = JCOUNT+NLOW
write(LUPRI,'(1X,A,10X,ES11.4,A,I12,1X,F7.2,A,3X,A,F7.2,A)') 'Smaller than ',BIN(NBIN),':',NLOW,real(NLOW,kind=wp)*TOPCT,'%', &
                                                             'Accumulated: ',real(JCOUNT,kind=wp)*TOPCT,'%'

write(LUPRI,'(/,1X,A,I12,1X,F7.2,A)') 'Number of elements exactly 0.0   :',NZER,real(NZER,kind=wp)*TOPCT,'%'
write(LUPRI,'(1X,A,I12,1X,F7.2,A)') 'Number of negative elements      :',NNEG,real(NNEG,kind=wp)*TOPCT,'%'
if (NNEG > 0) write(LUPRI,'(1X,A,ES12.4)') ' - numerically largest           :',XNEG

end subroutine CHO_ANASIZE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExtractR(iLu,i9,Etot,xyzMy,Hmat,C,nState,xyzQu,lExtr,iExtr_Eig,ExpVal,ExpCento,ENR,ENP)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iLu, i9, nState, iExtr_Eig
real(kind=wp), intent(in) :: Etot, xyzMy(3), Hmat(nTri_Elem(iExtr_Eig)), C(nState,nState), xyzQu(6), ExpVal(4,nState), &
                             ExpCento(4,nState), ENR, ENP
logical(kind=iwp), intent(in) :: lExtr(*)
integer(kind=iwp) :: i, ind, j, nDim

write(iLu,*) '<<<<<<<Configuration ',i9,'>>>>>>>'
if (lExtr(1)) then
  write(iLu,*) 'Total Energy'
  write(iLu,'(F15.8)') Etot
end if
if (lExtr(2)) then
  write(iLu,*) 'QM-Dipole'
  write(iLu,'(3(F12.5))') xyzMy(:)
end if
if (lExtr(3)) then
  write(iLu,*) 'QM-Quadrupole'
  write(iLu,'(6(F12.5))') xyzQu(:)
end if
if (lExtr(4)) then
  write(iLu,*) 'Eigenvalues of RASSI-matrix'
  do i=1,iExtr_Eig
    ind = nTri_Elem(i)
    write(iLu,'(F15.8)') Hmat(ind)
  end do
end if
if (lExtr(5)) then
  write(iLu,*) 'Corresponding eigenvectors'
  do j=1,iExtr_Eig
    write(iLu,'(5(F15.8))') C(:,j)
  end do
end if
if (lExtr(6)) then
  write(iLu,*) 'Expectation values (H_0,V_el,V_pol,V_pp)'
  write(iLu,*) '  Nuc cont:',ENR
  if (lExtr(4)) then
    nDim = iExtr_Eig
  else
    nDim = nState
  end if
  do i=1,nDim
    write(iLu,'(4(F15.8))') ExpVal(:,i)
  end do
end if
if (lExtr(7)) then
  write(iLu,*) 'Expectation values partial V_el, V_pol'
  write(iLu,*) '  Nuc cont:',ENP
  if (lExtr(4)) then
    nDim = iExtr_Eig
  else
    nDim = nState
  end if
  do j=1,nDim
    write(iLu,'(2(F15.8))') ExpCento(:,i)
  end do
end if

return

end subroutine ExtractR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_D2AV(D2AV,nD2AV)
      Implicit Real*8 (A-H,O-Z)
      Character*24 Label
      Logical      Found
      Real*8 D2AV(nD2AV)

      Label='D2av'
      Call qpg_dArray(Label,Found,mD2AV)
      If(.not.Found .or. mD2AV.eq.0) Then
         Call SysAbendMsg('get_d2av','Did not find',Label)
      End If
      If (nD2AV/=mD2AV) Then
         Write (6,*) 'Get_D2AV: nD2AV/=mD2AV'
         Write (6,*) 'nD2AV=',nD2AV
         Write (6,*) 'mD2AV=',mD2AV
         Call Abend()
      End If
      Call get_dArray(Label,D2AV,nD2AV)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
      subroutine quater_sub(nAtoms,G1,G2,ireturn)
      Implicit none
#include "WrkSpc.fh"
#include "debug.fh"
#include "options.fh"
#include "geoms.fh"
      Real*8 U1(3),U2(3),V1(3),V2(3)
      Real*8 V1best(3),V2best(3)
      Real*8 Q(0:3),Vtrans(3)
      Integer ireturn,nAtoms,XYZ(3)
      Real*8  G1(3*nAtoms),G2(3*nAtoms)

      Data XYZ/1,2,3/
#ifdef _DEBUGPRINT_
      debug=.true.
#else
      debug=.false.
#endif
      rotate=.true.
      translate=.true.
      ngeoms=1
      title(1)="ORIGINAL"
      title(2)="GEOHYPER"
      title(3)="bALIGNED"

      call quaterinit()

      nat(1)=nAtoms
      nat(2)=nAtoms
      nat(3)=nAtoms

      Call GetMem("GEO0","Allo","Real",ipgeo(1),3*nAtoms)
      Call GetMem("GEO1","Allo","Real",ipgeo(2),3*nAtoms)
      Call GetMem("GEOF","Allo","Real",ipgeo(3),3*nAtoms)

      call dcopy_(3*nAtoms,G1,1,Work(ipgeo(1)),1)
      call dcopy_(3*nAtoms,G2,1,Work(ipgeo(2)),1)

      Call SetVect(nAtoms,Work(ipgeo(1)),XYZ,V1,V2)
      Call SetVect(nAtoms,Work(ipgeo(2)),XYZ,U1,U2)


      if (debug) then
        Write(6,*) 'Reference axis'
        Call RecPrt("U1",' ',U1,3,1)
        Call RecPrt("U2",' ',U2,3,1)
        Write(6,*) 'New axis'
        Call RecPrt("V1",' ',V1,3,1)
        Call RecPrt("V2",' ',V2,3,1)
      end if

      call QuaterSolve(U1,U2,V1,V2,Q)

      if (debug) then
        Write(6,*) 'Normalized Reference axis'
        Call RecPrt("U1",' ',U1,3,1)
        Call RecPrt("U2",' ',U2,3,1)
        Write(6,*) 'Normalized New axis'
        Call RecPrt("V1",' ',V1,3,1)
        Call RecPrt("V2",' ',V2,3,1)
        call QuaterRotation(Q,U1,V1best)
        call QuaterRotation(Q,U2,V2best)
        Call RecPrt("Best V1",' ',V1best,3,1)
        Call RecPrt("Best V2",' ',V2best,3,1)
      end if

      call dcopy_(3*nAtoms,Work(ipgeo(2)),1,Work(ipgeo(3)),1)

      Call RotateGeoms(Q)
      Call SetVectTrans(nat(1),Work(ipgeo(1)),XYZ,
     &                  nat(3),Work(ipgeo(3)),XYZ,
     &                  Vtrans)
      Call TranslateGeoms(Vtrans)

      if (debug) then
         Call PrintGeom(-1,nat(3),title(3),
     &           Work(ipgeo(3)),geolbl(1,3))
      end if

      call dcopy_(3*nAtoms,Work(ipgeo(3)),1,G2,1)

      Call GetMem("GEO0","Free","Real",ipgeo(1),3*nAtoms)
      Call GetMem("GEO1","Free","Real",ipgeo(2),3*nAtoms)
      Call GetMem("GEOF","Free","Real",ipgeo(3),3*nAtoms)


      ireturn=0

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PrePro(nAtom,Coor)
      use Slapaf_Info, only: Grd, Atom, nSup, mRowH
      use Slapaf_Parameters, only: iRow, iInt, nFix, Redundant, nDimBC,
     &                             lOld, mTROld, lNmHss, lOld_Implicit,
     &                             iter,
     &                             iter
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
      Real*8 Coor(3,nAtom)
      Logical CofM
      Real*8, Allocatable:: TR(:)
*
      CofM = Iter.eq.1 .and. lNmHss
      Call mma_allocate(TR,18*nAtom,Label='TR')
      TR(:)=Zero
      Call TRPGen(nDimBC,nAtom,Coor,mTR,CofM,TR)
      Call mma_deallocate(TR)
      If (lNmHss) Then
         If (Iter.eq.1) mTROld=mTR
         If (iter.le.2*(nDimBC-mTROld)+1.and.iter.ne.1)
     &    mTR=mTROld
      Else
         mTROld=mTR
      End If
*
*-----Operate according to two modes
*     iRow.gt.0 : user supplied internal coordinates
*     iRow.le.0 : Cartesian or Internal Coordinates
*
      nRowH = 0
      If (iRow.gt.0) Then
*
*--------Find the number of active and frozen internal coordinates.
*
         Call Rd_UDIC(iInt,nFix,nRowH)
         nQQ=iInt+nFix
         If (nRowH.GT.0) then
            Call mma_allocate(mRowH,nRowH,Label='mRowH')
            Call Rd_UDIC_RowH(nQQ,nRowH,mRowH)
         EndIf
         If (nQQ.gt.nDimBC-mTR) Redundant=.True.
*
      Else
*
         nFix=0
      End If
*
*-----Initiate the force constant matrix in internal coordinate
*     basis, excluding rotation and translation.
*     Write to runfile only on the first iteration and that there
*     was not an already defined Hessian.
*
      If (iter.eq.1) Call IntFcm(lOld_Implicit)
      If (.Not.lOld.and.lOld_Implicit) lOld=.True.
*
*-----Symmetrize forces
*
      If (Allocated(nSup)) Then
         Call SupSym(Grd,nAtom,Coor,SIZE(nSup),nSup,Atom)
         Call mma_deallocate(Atom)
         Call mma_deallocate(nSup)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine UnixInfo(SuperModuleName,ModuleName)
      Character*(*) ModuleName, SuperModuleName
      External StrnLn
      Integer StrnLn
#include "unixinfo.fh"
      Logical IfTest
      Data IfTest/.False./

#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif

      ProgName=ModuleName
      SuperName=SuperModuleName
      username=' '
      realname=' '
      homedir=' '
      shell=' '
      molcasdir=' '
#ifndef _DEMO_
      Call UnixInfoC(pid, ppid,
     +  sec,mins,hour,mday,mon,year,wday,yday,isdst,
     +  username,realname,homedir,shell,
     +  molcasdir)
#endif

C  Clear ProgName of directory part:
      LenProgName=StrnLn(ProgName)
      Do 100 Ich=LenProgName,1,-1
      If(ProgName(Ich:Ich).Eq.'/')Then
        Islash=Ich
        GoTo 200
      EndIf
100   Continue
      Islash=0
200   Continue
      Do 300 Ich=1,LenProgName
      If(Ich.Le.LenProgName-Islash)Then
        ProgName(Ich:Ich)=ProgName(Ich+Islash:Ich+Islash)
      Else
        ProgName(Ich:Ich)=' '
      EndIf
300   Continue

      mon=mon+1
      year=year+1900
      if(wday.eq.0)wday=7
      yday=yday+1
      WeekDay(1)='Mon'
      WeekDay(2)='Tue'
      WeekDay(3)='Wed'
      WeekDay(4)='Thu'
      WeekDay(5)='Fri'
      WeekDay(6)='Sat'
      WeekDay(7)='Sun'
      Month(1) ='Jan'
      Month(2) ='Feb'
      Month(3) ='Mar'
      Month(4) ='Apr'
      Month(5) ='May'
      Month(6) ='Jun'
      Month(7) ='Jul'
      Month(8) ='Aug'
      Month(9) ='Sep'
      Month(10)='Oct'
      Month(11)='Nov'
      Month(12)='Dec'
      If(IfTest)Call PrtUnixInfo()
      Return
      End
      Subroutine PrtUnixInfo()
#include "unixinfo.fh"
      External StrnLn
      Integer StrnLn
      Character*35 Print

      Print=' '
      Len=StrnLn(ProgName)
      I1=Max(1,35-Len+1)
      Print(I1:35)=ProgName(1:35-I1+1)
      Write(6,'(2A)')' Program name      :',Print
      Write(6,'(A,I35)')' Process ID        :',pid
      Write(6,'(A,I35)')' Parent process ID :',ppid
      Write(6,'(A,I35)')' Seconds           :',sec
      Write(6,'(A,I35)')' Minutes           :',mins
      Write(6,'(A,I35)')' Hours             :',hour
      Write(6,'(A,I35)')' Day of month      :',mday
      Write(6,'(A,I29,3A)')' Month             :',mon,
     +  ' (',Month(mon),')'
      Write(6,'(A,I35)')' Year              :',year
      Write(6,'(A,I29,3A)')' Day of week       :',wday,
     +  ' (',WeekDay(wday),')'
      Write(6,'(A,I35)')' Day of year       :',yday
      Write(6,'(A,I35)')' Daylight saving ? :',isdst
#ifdef _PLEASE_DELETE_ME_
      Print=' '
      Len=StrnLn(UserName)
      I1=Max(1,35-Len+1)
      Print(I1:35)=UserName(1:35-I1+1)
      Write(6,'(2A)')' User name         :',Print
      Print=' '
      Len=StrnLn(RealName)
      Do i=1,Len
         j=iChar(RealName(i:i))
         If ((j.le.8).or.(j.ge.160).or.((j.ge.14).and.(j.le.31)))
     &      RealName(i:i)='?'
      EndDo
      I1=Max(1,35-Len+1)
      Print(I1:35)=RealName(1:35-I1+1)
      Write(6,'(2A)')' Name              :',Print
      Print=' '
      Len=StrnLn(HomeDir)
      I1=Max(1,35-Len+1)
      Print(I1:35)=HomeDir(1:35-I1+1)
      Write(6,'(2A)')' Home directory    :',Print
      Print=' '
      Len=StrnLn(Shell)
      I1=Max(1,35-Len+1)
      Print(I1:35)=Shell(1:35-I1+1)
      Write(6,'(2A)')' Shell             :',Print
      Print=' '
      Len=StrnLn(MolcasDir)
      I1=Max(1,35-Len+1)
      Print(I1:35)=MolcasDir(1:35-I1+1)
      Write(6,'(2A)')' Molcas directory  :',Print
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015,2016, Valera Veryazov                             *
!***********************************************************************

subroutine Append_file_u(iUnit)
! for unformatted files

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iUnit
integer(kind=iwp) :: i, iset, stat

iset = 0
rewind(iUnit)
do
  read(iUnit,iostat=stat)
  if (stat /= 0) exit
  iset = iset+1
end do
rewind(iUnit)
do i=1,iset
  read(iUnit)
end do

return

end subroutine Append_file_u

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine W(R,ilist_p,Weights,list_p,nlist_p,nGrid)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "itmax.fh"
#include "nq_info.fh"
#include "debug.fh"
      Real*8 R(3,nGrid), Weights(nGrid)
      Integer list_p(nlist_p)
*                                                                      *
************************************************************************
*                                                                      *
#include "nq_structure.fh"
      declare_ip_coor
      p(x)=(x*0.5D0)*(3.0D0-x**2)
*                                                                      *
************************************************************************
*                                                                      *
      P_i = Zero ! dummy initialize
*
*     iNQ is the index of the current atomic grid to which these grid
*     points belong.
*
      iNQ=list_p(ilist_p)
C     Write (*,*) 'ilist_p=',ilist_p
C     Write (*,*) 'nlist_p=',nlist_p
C     Write (*,*) 'nGrid=',nGrid
C     Write (*,*) 'iNQ=',iNQ
*                                                                      *
************************************************************************
*                                                                      *
      Do iGrid = 1, nGrid
*        Write (*,*) 'iGrid=',iGrid
*                                                                      *
************************************************************************
*                                                                      *
*----    Becke's partitioning
*
         Sum_P_k=Zero
         Do klist_p = 1, nlist_p
            kNQ=list_p(klist_p)
*           Write (*,*) 'kNQ=',kNQ
            kx=ip_Coor(kNQ)
            ky=kx+1
            kz=ky+1
            r_k=sqrt((R(1,iGrid)-Work(kx))**2
     &               +(R(2,iGrid)-Work(ky))**2
     &               +(R(3,iGrid)-Work(kz))**2)
            P_k=One
            Do llist_p = 1, nlist_p
               lNQ=list_p(llist_p)
*
               If (kNQ.ne.lNQ) Then
                  lx=ip_Coor(lNQ)
                  ly=lx+1
                  lz=ly+1
*
                  r_l=sqrt((R(1,iGrid)-Work(lx))**2
     &                     +(R(2,iGrid)-Work(ly))**2
     &                     +(R(3,iGrid)-Work(lz))**2)
                  R_kl=sqrt((Work(kx)-Work(lx))**2
     &                      +(Work(ky)-Work(ly))**2
     &                      +(Work(kz)-Work(lz))**2)
                  rMU_kl=(r_k-r_l)/R_kl
                  If (rMU_kl.le.0.5D0) Then
                     p1=p(rMU_kl)
                     p2=p(p1)
                     p3=p(p2)
                     s=Half*(One-p3)
                  Else
                     xdiff=rMU_kl-1.0D0
                     xdiff=(-1.5D0-0.5D0*xdiff)*xdiff**2
                     xdiff=(-1.5D0-0.5D0*xdiff)*xdiff**2
                     p3=   ( 1.5D0+0.5D0*xdiff)*xdiff**2
                     s=Half*p3
                  End If
                  P_k=P_k*s
               End If
            End Do
*
            If (kNQ.eq.iNQ) P_i=P_k
            Sum_P_k = Sum_P_k + P_k
         End Do
         Fact=Weights(iGrid)
         Weights(iGrid)=Fact*P_i/Sum_P_k
C        Write (*,*) 'Fact,P_A,Z,Weights=',Fact,P_i,Sum_P_k,
C    &               Weights(iGrid)
*                                                                      *
************************************************************************
*                                                                      *
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Niclas Forsberg                                  *
!***********************************************************************

subroutine PotDist(F,V,Lambda,PED,NumInt,nOsc)
!  Purpose:
!    To give the fractional contributions of the F-matrix to the potential energy.
!
!  Input:
!    F        : Real two dimensional array -  contains the force constants expressed in internal
!    V        : Real two dimensional array  - contains the eigenvectors of F*G as columns.
!    Lambda   : Real array - contains the eigenvalues of F*G.
!
!  Output:
!    PED      : Real three dimensional array - Potential Energy Distribution for each mode. !
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NumInt, nOsc
real(kind=wp), intent(in) :: F(NumInt,NumInt), V(NumInt,NumInt), Lambda(NumInt)
real(kind=wp), intent(out) :: PED(nOsc,nOsc,nOsc)
integer(kind=iwp) :: i, k, l
real(kind=wp) :: Denominator

! Initialize.

! Calculate Potential Energy Distribution for each mode.
PED(:,:,:) = Zero
do i=1,NumInt
  Denominator = max(1.0e-10_wp,Lambda(i))
  do k=1,NumInt
    do l=1,NumInt
      if (k == l) then
        PED(k,k,i) = (V(k,i)**2*F(k,k))/Denominator
      else
        PED(k,l,i) = (2*V(k,i)*V(l,i)*F(k,l))/Denominator
      end if
    end do
  end do
end do

end subroutine PotDist

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine change4_cvb()
      implicit real*8 (a-h,o-z)
      logical changed
      logical ndres_ok
c ... Files/Hamiltonian available ...
      logical, external :: ifcasci_cvb,ifhamil_cvb
c ... Make: up to date? ...
      logical, external :: up2date_cvb
c ... Change of dimensioning variables ...
      logical, external :: chpcmp_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "casinfo_cvb.fh"
#include "rls_cvb.fh"
#include "WrkSpc.fh"
      save ndres_ok

      changed=.false.
c CI vectors
      call icomb_cvb(norb,nalf,nda)
      call icomb_cvb(norb,nbet,ndb)
      ndet = nda*ndb
      ndres=3+ndet

      memplenty=(mavailr_cvb().gt.9*ndet)

      if(chpcmp_cvb(ndres))changed=.true.
      ndres_ok=(.not.changed).and.(up2date_cvb('MEM3'))

      if(changed)call touch_cvb('RDCAS')
      if(chpcmp_cvb(nint(strtcas*1d1)))call touch_cvb('RDCAS')
      call chpcmp2_cvb(icrit,icritold)
      call chpcmp2_cvb(ifinish,ifin_old)
      if(.not.(icritold.eq.1.and.ifin_old.eq.0))call touch_cvb('RDCAS')

      if(ifinish.eq.1.or.ifinish.eq.2)then
c  Logical variables for wavefunction analysis :
c  Always evaluate svb/evb when possible
c    (a) to get exact values (wfn is updated by optim in last iteration)
c    (b) to generate ESYM (variational calculations)
        lcalcsvb=ifcasci_cvb()
        lcalcevb=ifhamil_cvb()
        lcalccivbs=.true.
        lciweights=(npcf.gt.-2.and.((.not.variat).or.endvar)
     >    .and.iciweights.gt.0)
      endif
      if(imethod.eq.11.and.ifinish.eq.0)then
        nv=2
        icase=2
      elseif(imethod.ne.4.and.ifinish.eq.0)then
        if(memplenty)then
          nv=8
          icase=1
        else
          if(icrit.eq.2.and.imethod.ne.6)then
c  No need for CITMP :
            nv=3
            icase=5
          else
            nv=5
            icase=2
          endif
        endif
      elseif(imethod.eq.4.and.ifinish.eq.0)then
        nv=2
        icase=2
      elseif(imethod.eq.12.and.ifinish.eq.0)then
        nv=8
        icase=7
      elseif(ifinish.eq.1.or.ifinish.eq.2)then
        nv=5
        if(.not.lciweights)then
          nv=nv-1
          if((.not.lcalcevb).or.lcalccivbs)nv=nv-1
          if((.not.lcalcsvb).or.lcalccivbs)nv=nv-1
        endif
        icase=3
      else
        nv=3
        icase=4
      endif
      if(chpcmp_cvb(nv))changed=.true.
      if(chpcmp_cvb(icase))changed=.true.
      if(changed)call touch_cvb('MEM4')
      return

      entry chop4_cvb()
      if(release(4))call mfreer_cvb(lc(1)-2)
      release(4)=.true.
      release(5)=.false.


c  CIVECP and CIVBH share memory --> LC(2)
      do iv=1,nv
      lc(iv) = mstackr_cvb(ndres)
      enddo
        do iv=1,nv
        work(lc(iv))=zero
        work(lc(iv)+1)=zero
        enddo
      do iv=1,nv
      lc(iv)=lc(iv)+2
      enddo
c Fix to put in "objects" :
      do iv=1,nv
      call creatci_cvb(iv,work(lc(iv)),lc(iv)+1,nint(work(lc(iv)-2)),
     >  work(lc(iv)-1))
      if(.not.ndres_ok)call setcnt_cvb(work(lc(iv)),0)
      enddo
c-- ins
      if((ifinish.eq.1.or.ifinish.eq.2).and..not.lciweights)then
        if(((.not.lcalcevb).or.lcalccivbs).and.
     >     ((.not.lcalcsvb).or.lcalccivbs))then
          lc(3)=lc(1)
          lc(4)=lc(1)
        elseif((.not.lcalcevb).or.lcalccivbs)then
          lc(4)=lc(3)
        elseif((.not.lcalcsvb).or.lcalccivbs)then
          lc(4)=lc(3)
          lc(3)=lc(1)
        endif
      endif
      if(.not.memplenty)lc(nv+1)=lc(1)
      if(nv.eq.3.or.nv.eq.4.or.nv.eq.5)then
        lc(6)=lc(2)
        lc(7)=lc(3)
        lc(8)=lc(4)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoLSOSMP2_Energy_Fll2(N,w,t,EOcc,EVir,Delete,EMP2,irc)
!
! Thomas Bondo Pedersen, December 2012.
!
! Compute Laplace-SOS-MP2 energy correction from unsorted Cholesky
! vectors (i.e., no batching). This uses the exact same loop
! ordering as the sorted algorithm and thus reads through the
! vector files once for each grid point.

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use Cholesky, only: nSym, NumCho
#if ! defined (_I8_) || defined (_DEBUGPRINT_)
use Cholesky, only: LuPri
#endif
use ChoMP2, only: DecoMP2, iOcc, iT1am, iVir, Laplace_BlockSize, Laplace_nGridPoints, lUNit_F, nMP2Vec, nOcc, nT1am, nVir
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: w(N), t(N), EOcc(*), EVir(*)
logical(kind=iwp), intent(in) :: Delete
real(kind=wp), intent(out) :: EMP2
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: a, blast, bsize, i, iAddr, iBlock, iOpt, ip0, ip1, ipi, ipj, ipX, iSym, iSyma, iSymi, iTyp, iVec, jBlock, &
                     l_Tot, l_X, lenX, Nai, nBlock, nEnrVec(8), nVeci, nVecj, q
real(kind=wp) :: Eq, lX, tq, wq, xb, xbp, xM, xn
#if ! defined (_I8_) || defined (_DEBUGPRINT_)
real(kind=wp) :: Byte
character(len=2) :: Unt
#endif
real(kind=wp), allocatable :: V(:), X(:)
character(len=*), parameter :: SecNam = 'ChoLSOSMP2_Energy_Fll2'
real(kind=wp), external :: dDot_

! init return code
irc = 0

! init energy
EMP2 = Zero

! check input (incl. common block variables)
if (N /= Laplace_nGridPoints) then
  irc = -2
  return
end if
if (Laplace_BlockSize < 1) then
  irc = -3
  return
end if

! set number and type of vectors
if (DecoMP2) then
  iTyp = 2
  nEnrVec(1:nSym) = nMP2Vec(1:nSym)
else
  iTyp = 1
  nEnrVec(1:nSym) = NumCho(1:nSym)
end if

! allocate X
lX = Zero
do iSym=1,nSym
  if ((nT1am(iSym) > 0) .and. (nEnrVec(iSym) > 0)) then
    bsize = min(Laplace_BlockSize,nEnrVec(iSym))
    nBlock = (nEnrVec(iSym)-1)/bsize+1
    blast = nEnrVec(iSym)-bsize*(nBlock-1)
    xM = real(nEnrVec(iSym),kind=wp)
    xn = real(nBlock,kind=wp)
    xb = real(bsize,kind=wp)
    xbp = real(blast,kind=wp)
    lX = max(lX,Half*(xM*(xM+One)+(xn-One)*xb*(xb-One)+xbp*(xbp-One)))
  end if
end do
l_X = int(lX)
#if ! defined (_I8_) || defined (_DEBUGPRINT_)
if (l_X < 0) then
  write(LuPri,'(A,A)') SecNam,': dimension of X matrix is negative!'
  write(LuPri,'(A,I15)') 'l_X=',l_X
  if (lX > Zero) then
    write(LuPri,'(A)') 'This seems to be an integer overflow!'
    call Cho_RWord2Byte(lX,Byte,Unt)
    write(LuPri,'(A,ES15.6,A,ES15.6,1X,A,A)') 'In double precision, lX=',lX,' words (',Byte,Unt,')'
  end if
  irc = 1
  return
end if
#endif
call mma_allocate(X,l_X,Label='X')

! allocate vector array
Nai = nT1am(1)*nEnrVec(1)
do iSym=2,nSym
  Nai = max(Nai,nT1am(iSym)*nEnrVec(iSym))
end do
call mma_allocate(V,Nai,Label='V')

! compute energy correction
do q=1,N
  ! init energy for this q
  Eq = Zero
  ! scale grid point by 1/2
  tq = Half*t(q)
  ! scale weight by 2 (only lower blocks of X computed)
  wq = Two*w(q)
  do iSym=1,nSym
    Nai = nT1am(iSym)
    if ((Nai > 0) .and. (nEnrVec(iSym) > 0)) then
      ! init X for this symmetry
      bsize = min(Laplace_BlockSize,nEnrVec(iSym))
      nBlock = (nEnrVec(iSym)-1)/bsize+1
      blast = nEnrVec(iSym)-bsize*(nBlock-1)
      lenX = nTri_Elem(nEnrVec(iSym))+(nBlock-1)*nTri_Elem(bsize-1)+nTri_Elem(blast-1)
      X(1:lenX) = Zero
      ! open file, read vectors, close file
      ! do not delete file here - it may be needed later
      ! (because of the loop over q)
      call ChoMP2_OpenF(1,iTyp,iSym)
      iOpt = 2
      l_Tot = Nai*nEnrVec(iSym)
      iAddr = 1
      call dDAFile(lUnit_F(iSym,iTyp),iOpt,V,l_Tot,iAddr)
      call ChoMP2_OpenF(2,iTyp,iSym)
      ! scale vectors
      do iVec=1,nEnrVec(iSym)
        ip0 = Nai*(iVec-1)
        do iSymi=1,nSym
          if (nOcc(iSymi) > 0) then
            iSyma = Mul(iSym,iSymi)
            ip1 = ip0+iT1am(iSyma,iSymi)
            do i=1,nOcc(iSymi)
              V(ip1+nVir(iSyma)*(i-1)+1:ip1+nVir(iSyma)*i) = exp(EOcc(iOcc(iSymi)+i)*tq)* &
                                                             V(ip1+nVir(iSyma)*(i-1)+1:ip1+nVir(iSyma)*i)
            end do
            do a=1,nVir(iSyma)
              call dScal_(nOcc(iSymi),exp(-EVir(iVir(iSyma)+a)*tq),V(ip1+a),nVir(iSyma))
            end do
          end if
        end do
      end do
      ! loop over vector blocks to compute
      ! X(J,K) += sum_ai L(ai,J)*L(ai,K)*exp(-(e(a)-e(i))*t(q)/2)
      ipX = 1
      do jBlock=1,nBlock
        ipj = 1+Nai*Laplace_BlockSize*(jBlock-1)
        if (jBlock == nBlock) then
          nVecj = nEnrVec(iSym)-Laplace_BlockSize*(nBlock-1)
        else
          nVecj = Laplace_BlockSize
        end if
        do iBlock=jBlock,nBlock
          ipi = 1+Nai*Laplace_BlockSize*(iBlock-1)
          if (iBlock == nBlock) then
            nVeci = nEnrVec(iSym)-Laplace_BlockSize*(nBlock-1)
          else
            nVeci = Laplace_BlockSize
          end if
          call dGEMM_('T','N',nVeci,nVecj,Nai,One,V(ipi),Nai,V(ipj),Nai,One,X(ipX),nVeci)
          ipX = ipX+nVeci*nVecj
        end do
      end do
#     ifdef _DEBUGPRINT_
      if (lenX /= (ipX-1)) then
        call WarningMessage(2,SecNam//': dimension problem [1]')
        write(u6,'(A,I10,A,I10)') 'lenX=',lenX,' ipX-1=',ipX-1
        call Abend()
      end if
#     endif
      ! compute energy contribution
      ! Eq += sum_JK [X(J,K)]**2
      ipX = 1
      do jBlock=1,nBlock
        if (jBlock == nBlock) then
          nVecj = nEnrVec(iSym)-Laplace_BlockSize*(nBlock-1)
        else
          nVecj = Laplace_BlockSize
        end if
        do iBlock=jBlock,nBlock
          if (iBlock == nBlock) then
            nVeci = nEnrVec(iSym)-Laplace_BlockSize*(nBlock-1)
          else
            nVeci = Laplace_BlockSize
          end if
          if (iBlock == jBlock) then
            Eq = Eq+Half*dDot_(nVeci*nVecj,X(ipX),1,X(ipX),1)
          else
            Eq = Eq+dDot_(nVeci*nVecj,X(ipX),1,X(ipX),1)
          end if
          ipX = ipX+nVeci*nVecj
        end do
      end do
#     ifdef _DEBUGPRINT_
      if (lenX /= (ipX-1)) then
        call WarningMessage(2,SecNam//': dimension problem [2]')
        write(u6,'(A,I10,A,I10)') 'lenX=',lenX,' ipX-1=',ipX-1
        call Abend()
      end if
#     endif
    end if
  end do
  ! scale Eq
  Eq = -wq*Eq
  ! Accumulate in EMP2
  EMP2 = EMP2+Eq
end do

! deallocations
call mma_deallocate(V)
call mma_deallocate(X)

! delete files if requested
if (Delete) then
  do iSym=1,nSym
    call ChoMP2_OpenF(1,iTyp,iSym)
    call ChoMP2_OpenF(3,iTyp,iSym)
  end do
end if

end subroutine ChoLSOSMP2_Energy_Fll2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE CNFSTR(ICONF,ITYP,IASTR,IBSTR,NORB,NAEL,NBEL,
     *                  IDET,IPRODT,ISCR, SIGN,IPREXH)
*
* An orbital configuration ICONF is given,
* Obtain the corresponding alpha strings,IASTR
*        the corresponding beta  strings,IBSTR
*        the corresponding sign array   ,ISIGN
*
* Jeppe Olsen , Summer of '89
*
      IMPLICIT REAL*8 ( A-H,O-Z)
      DIMENSION ICONF(*),ISCR(*),IPRODT(*)
*PAM06 NOTE: NAEL and NBEL can legally be=0.
*PAM06      DIMENSION IASTR(NAEL,*),IBSTR(NBEL,*), SIGN(*)
      DIMENSION IASTR(*),IBSTR(*), SIGN(*)
#include "spinfo.fh"
#include "ciinfo.fh"
*
      NEL = NAEL + NBEL
      IOPEN = ITYP-1+MINOP
      ICLOS = (NAEL + NBEL - IOPEN) / 2
      IOCC  = IOPEN + ICLOS
*
** Spin orbital occupations of determinants of configuration
*
      KLFREE = 1
      KLDETS = KLFREE
      KLFREE = KLDETS + IDET*(NAEL+NBEL)
* Pointer for determinants of prototype ITYP
      IP = 1
      DO 10 JTYP = 1, ITYP - 1
        IP = IP + NDTFTP(JTYP)*(JTYP-1+MINOP)
10    CONTINUE
      CALL CNDET(ICONF,IPRODT(IP),IDET,NAEL+NBEL,NORB,
     &           IOPEN,ICLOS,ISCR(KLDETS),IPREXH)
*
** Separate determinants into strings and determine sign change
*
      DO 100 JDET = 1, IDET
        CALL DETSTR2(ISCR(KLDETS+(JDET-1)*NEL),
*PAM06     &              IASTR(1,JDET),IBSTR(1,JDET),
     &        IASTR(1+NAEL*(JDET-1)),IBSTR(1+NBEL*(JDET-1)),
     &              NEL,NAEL,NBEL,ISIGN,ISCR(KLFREE),IPREXH)
        SIGN(JDET) = DBLE(ISIGN)
100   CONTINUE
*
      NTEST =  0
      IF( NTEST .GE. 1 ) THEN
        WRITE(6,*) ' Output from CNFSTR '
        WRITE(6,*) ' ================== '
        WRITE(6,*) ' Input configuration '
        CALL IWRTMA(ICONF,1,IOCC,1,IOCC)
        WRITE(6,*) ' Corresponding alpha and beta strings'
        CALL IWRTMA(IASTR,NAEL,IDET,NAEL,IDET)
        CALL IWRTMA(IBSTR,NBEL,IDET,NBEL,IDET)
        WRITE(6,*) ' SIGN ARRAY '
        CALL WRTMAT( SIGN,1,IDET,1,IDET)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine PVMem(nRys,MemPV,la,lb,lr,KrnMem)
      External KrnMem
*
      Call KrnMem(nRys,MemNA1,la+1,lb,lr-1)
*
      If (la.ne.0) Then
         Call KrnMem(nRys,MemNA2,la-1,lb,lr-1)
      Else
         MemNA2=0
      End If
*
      MemPV=Max(MemNA1,MemNA2)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

subroutine WfCtl_MSPD(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,iRHSDisp,converged,iPL)
!***********************************************************************
!                                                                      *
!     called from: MCLR                                                *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: Mul
use ipPage, only: ipclose, ipget, ipin, ipnout, ipout, opout, W
use MCLR_Data, only: ipCI, ipDia, IRLXROOT, ISMECIMSPD, ISNAC, LuQDat, LuTemp, NACSTATES, nConf1, nDens, nDensC, OVERRIDE, &
                     ResQaaLag2, XISPSM
use input_mclr, only: Debug, Eps, Fail, iAddressQDat, iBreak, iMethod, kPrint, lSave, nAsh, nCSF, nDisp, nIter, nRoots, nRS2, &
                      State_Sym, StepType, TwoStep
use dmrginfo, only: DoDMRG, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iKapDisp(nDisp), isigDisp(nDisp), iCIDisp(nDisp), iCIsigDisp(nDisp), iRHSDisp(nDisp)
logical(kind=iwp), intent(out) :: converged(8)
integer(kind=iwp), intent(in) :: iPL
#include "warnings.h"
integer(kind=iwp) :: iDis, iDisp, iLen, ipCID, ipCIT, ipPre2, ipS1, ipS2, ipST, iSym, Iter, JRoot, jSpin, Left, lLine, lPaper, &
                     Lu_50, LURot, nConf3, niPre2, nPre2
real(kind=wp) :: Delta, Delta0, DeltaC, DeltaK, R1, R2, rAlpha, rAlphaC, rAlphaK, rBeta, ReCo, Res, rEsci, rEsk
logical(kind=iwp) :: CI, cnvrgd, lPrint
character(len=16) :: VecName
character(len=8) :: Fmt2
integer(kind=iwp), allocatable :: iPre(:)
real(kind=wp), allocatable :: dKappa(:), Fancy(:), Kappa(:), rCHC(:), Sc1(:), Sc2(:), Sigma(:), Temp3(:), Temp4(:)
integer(kind=iwp), external :: IsFreeUnit, niPre, nPre
real(kind=wp), external :: DDot_

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
call StatusLine('MCLR: ','Computing Lagrangian multipliers for MS-PDFT')

lPaper = 132
lLine = 120
left = (lPaper-lLine)/2
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
!----------------------------------------------------------------------*

iDis = 0

fail = .false.
Converged(:) = .true.
!MGD I think this is nice when printed...
lprint = .true.
reco = -One
Lu_50 = 50
if (lSAVE) then
  call DANAME(Lu_50,'RESIDUALS')
  write(u6,*) 'WfCtl_MSPD: SAVE option not implemented'
  call Abend()
end if
if (btest(kprint,1)) lprint = .true.
isym = 1
nconf1 = ncsf(State_Sym)

CI = .false.
if ((iMethod == 2) .and. (nconf1 > 0)) CI = .true.

! Initiate CSF <-> SD
call InCSFSD(Mul(iSym,State_Sym),State_sym)

! Calculate length of the density, Fock and Kappa matrix etc
! notice that this matrices are not necessarily symmetric.
! Store pointers.
!
! Input:
!        iSym: Symmetry of perturbation
!
! Output: Commonblocks (Pointers.fh)

nConf3 = nint(max(xispsm(State_SYM,1),xispsm(State_SYM,1)))

call Setup_MCLR(iSym)

! MSPDFT version ot lines 433-441 in mclr/rdinp_mclr.f
! MSPDFT version of reading NAC command in the mclr/rdinp_mclr.f
call Get_lScalar('isCMSNAC',isNAC)
if (isNAC) call Get_iArray('cmsNACstates',NACstates,2)
if (isNAC) call Get_lScalar('isMECIMSPD',isMECIMSPD)
if (isNAC) override = .true.

! Determine if we should page CI vectors
!                            [2]
! Calculate the diagonal of E    and store in core/disc

call mma_allocate(FANCY,nroots**3,Label='FANCY')
call mma_allocate(rCHC,nRoots,Label='rCHC')
call CIDia_SA(State_Sym,rCHC,Fancy)
call mma_deallocate(rCHC)

call ipOut(ipdia)

! Allocate disk/memory space

! This areas should be addressed through ipIn
! ipOut will page them out to disk and free the memory area
! if page mode is used

! opOut will release the memory area without update the disk

ipS1 = ipGet(nconf3*nroots)
ipS2 = ipGet(nconf3*nroots)
ipST = ipGet(nconf3*nroots)
ipCIT = ipGet(nconf1*nroots)
ipCId = ipGet(nconf1*nroots)

nipre2 = nipre(isym)
npre2 = npre(isym)
ipPre2 = ipGet(npre2)
call ipIn(ipPre2)
call mma_allocate(iPre,nipre2,Label='iPre')
if (TwoStep .and. (StepType == 'RUN2')) then
  ! fetch data from LuQDAT and skip the call to "Prec"
  call ddafile(LuQDAT,2,W(ipPre2)%A,npre2,iaddressQDAT)
  call idafile(LuQDAT,2,iPre,nipre2,iaddressQDAT)
else
  call Prec(W(ipPre2)%A,iPre,isym)
  call ipOut(ippre2)
end if
if (TwoStep .and. (StepType == 'RUN1')) then
  ! save the computed data in "Prec" to LuQDAT and skip the
  ! following part of this function
  call ipIn(ipPre2)
  call ddafile(LuQDAT,1,W(ipPre2)%A,npre2,iaddressQDAT)
  call idafile(LuQDAT,1,iPre,nipre2,iaddressQDAT)
else

  ! OK START WORKING
  !
  !idisp = 1
  jspin = 0

  ! Allocate areas for scratch and state variables

  call mma_allocate(Kappa,nDensC,Label='Kappa')
  call mma_allocate(dKappa,nDensC,Label='dKappa')
  call mma_allocate(Sigma,nDensC,Label='Sigma')
  call mma_allocate(Temp3,nDensC,Label='Temp3')
  call mma_allocate(Temp4,nDens,Label='Temp4')
  call mma_allocate(Sc1,nDens,Label='Sc1')
  call mma_allocate(Sc2,nDensC,Label='Sc2')

  cnvrgd = .true.
  do iDisp=1,nDisp
    Kappa(:) = Zero
    dKappa(:) = Zero
    Sigma(:) = Zero

    !-------------------------------------------------------------------
    !
    ! Calculate RHS for the perturbation
    !
    !-------------------------------------------------------------------

    ! (T1,T2,T3,T4,T5,T6,T7,Kappa1,CI1)

    if (debug) then
      if (isNAC) then
        write(u6,*) 'States: ',NACstates(1),NACstates(2)
      else
        write(u6,*) 'State: ',irlxroot
      end if
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    if (isNAC) then
      LURot = 233
      LURot = IsFreeUnit(LURot)
      call Molcas_Open(LURot,'ROT_VEC')
      do JRoot=1,nRoots
        read(LURot,*) VecName
      end do
      read(LURot,*) VecName
      close(LURot)
      if (VecName == 'CMS-PDFT') then
        call RHS_CMS_NAC(Temp4,W(ipST)%A)
        call DMinvCI_SA(ipST,W(ipS2)%A,Fancy)
      else
        write(u6,'(6X,A)') 'Error: Lagrangian Not Implemented for MS-PDFT'
        write(u6,'(6X,A)') '       Other Than CMS-PDFT'
        call xQuit(_RC_INPUT_ERROR_)
      end if
    else
      LURot = 233
      LURot = IsFreeUnit(LURot)
      call Molcas_Open(LURot,'ROT_VEC')
      do JRoot=1,nRoots
        read(LURot,*) VecName
      end do
      read(LURot,*) VecName
      close(LURot)
      if (VecName == 'CMS-PDFT') then
        call RHS_CMS(Temp4,W(ipST)%A)
        call DMinvCI_SA(ipST,W(ipS2)%A,Fancy)
      else
        write(u6,'(6X,A)') 'Error: Lagrangian Not Implemented for MS-PDFT'
        write(u6,'(6X,A)') '       Other Than CMS-PDFT'
        call xQuit(_RC_INPUT_ERROR_)
      end if
    end if

    call opOut(ipci)

    if (lprint) write(u6,*) '       Iteration       Delta           Res(kappa)       Res(CI)          DeltaK           DeltaC'
    iLen = nDensC
    iRHSDisp(iDisp) = iDis
    call Compress(Temp4,Sigma,iSym)
    r1 = ddot_(nDensc,Sigma,1,Sigma,1)
    if (debug) write(u6,*) 'Hi how about r1',r1
    call dDaFile(LuTemp,1,Sigma,iLen,iDis)

    call ipIn(ipCIT)
    !call ipIn(ipST)
    call ipIn(ipCID)
    W(ipCIT)%A(1:nConf1*nroots) = Zero
    ! already initialized in rhs_mspdft
    !W(ipST)%A(1:nConf1*nroots) = Zero
    !W(ipCID)%A(1:nConf1*nroots) = Zero
    !W(ipCID)%A(1:nConf1*nroots) = W(ipST)%A(1:nConf1*nroots)
    call ipOut(ipCIT)
    Sigma(:) = -Sigma(:)

    call ipIn(ipPre2)
    call DMInvKap(W(ipPre2)%A,iPre,Sigma,Kappa,Temp4,isym,iter)

    call opOut(ippre2)
    r2 = ddot_(nDensC,Kappa,1,Kappa,1)
    if (debug) write(u6,*) 'In that case I think that r2 should be:',r2
    if (r2 > r1) write(u6,*) 'Warning perturbation number ',idisp,' might diverge'

    dKappa(:) = Kappa(:)

    ! In MS-PDFT deltaC is no longer zero initially
    !deltaC = Zero
    ! Use following two lines instead
    call DMinvCI_SA(ipST,W(ipS2)%A,Fancy)
    W(ipCID)%A(1:nConf1*nroots) = W(ipS2)%A(1:nConf1*nroots)
    deltaC = ddot_(nConf1*nroots,W(ipST)%A,1,W(ipS2)%A,1)
    call ipOut(ipcid)
    deltaK = ddot_(nDensC,Kappa,1,Sigma,1)
    Kappa(:) = Zero
    delta = deltac+deltaK
    delta0 = delta
    iter = 1
    !-------------------------------------------------------------------

    do
      if (delta == Zero) exit
      call TimesE2MSPDFT(dKappa,ipCId,1,reco,jspin,ipS2,Temp3,ipS1)

      !-----------------------------------------------------------------
      !
      !            delta
      ! rAlpha=------------
      !        dKappa:dSigma
      !
      !-----------------------------------------------------------------

      rAlphaK = Zero
      rAlphaK = ddot_(nDensC,Temp3,1,dKappa,1)
      rAlphaC = Zero
      call ipIn(ipS1)
      call ipIn(ipCId)
      rAlphaC = ddot_(nConf1*nroots,W(ipS1)%A,1,W(ipCId)%A,1)
      rAlpha = delta/(rAlphaK+rAlphaC)

      !----------------------------------------------------------------*

      ! Kappa=Kappa+rAlpha*dKappa
      Kappa(:) = Kappa(:)+ralpha*dKappa(:)
      ! Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa
      Sigma(:) = Sigma(:)-ralpha*Temp3(:)
      resk = sqrt(ddot_(nDensC,Sigma,1,Sigma,1))
      resci = Zero
      call ipIn(ipCIT)
      W(ipCIT)%A(1:nConf1*nroots) = W(ipCIT)%A(1:nConf1*nroots)+ralpha*W(ipCId)%A(1:nConf1*nroots)
      call ipOut(ipcit)
      ! ipST =ipST -rAlpha*ipS1         ipST=RHS-A*ipCIT
      call ipIn(ipS1)
      call ipIn(ipST)
      W(ipST)%A(1:nConf1*nroots) = W(ipST)%A(1:nConf1*nroots)-ralpha*W(ipS1)%A(1:nConf1*nroots)
      call opOut(ipS1)
      call ipIn(ipST)
      resci = sqrt(ddot_(nconf1*nroots,W(ipST)%A,1,W(ipST)%A,1))

      !----------------------------------------------------------------*

      ! Precondition......
      !    -1
      ! S=M  Sigma

      call opOut(ipcid)

      call ipIn(ipS2)
      call DMinvCI_SA(ipST,W(ipS2)%A,Fancy)
      call opOut(ipci)
      call opOut(ipdia)

      call ipIn(ipPre2)
      call DMInvKap(W(ipPre2)%A,iPre,Sigma,Sc2,Sc1,iSym,iter)
      call opOut(ippre2)

      !----------------------------------------------------------------*
      !      s:Sigma (k+1)     s:Sigma (k+1)
      ! Beta=-------        =  -------------
      !       delta  (k)        s:Sigma (k)
      !
      ! delta=s:sigma
      !
      ! dKappa=s+Beta*dKappa

      deltaC = ddot_(nConf1*nroots,W(ipST)%A,1,W(ipS2)%A,1)
      call ipOut(ipST)

      deltaK = ddot_(nDensC,Sigma,1,Sc2,1)
      if (.not. CI) then
        rBeta = deltaK/delta
        delta = deltaK
        dKappa(:) = rBeta*dKappa(:)+Sc2(:)
      else
        rbeta = (deltac+deltaK)/delta
        delta = deltac+deltaK
        call ipIn(ipCID)
        W(ipCID)%A(1:nConf1*nroots) = rBeta*W(ipCID)%A(1:nConf1*nroots)+W(ipS2)%A(1:nConf1*nroots)
        dKappa(:) = rBeta*dKappa(:)+Sc2(:)
        call opOut(ipS2)
        call ipOut(ipCID)
      end if

      !  ######  #    #  #####        #####    ####    ####
      !  #       ##   #  #    #       #    #  #    #  #    #
      !  #####   # #  #  #    #       #    #  #       #
      !  #       #  # #  #    #       #####   #       #  ###
      !  #       #   ##  #    #       #       #    #  #    #
      !  ######  #    #  #####        #        ####    ####
      !
      !----------------------------------------------------------------*

      res = Zero ! dummy initialize
      if (iBreak == 1) then
        if (abs(delta) < abs(Eps**2*delta0)) exit
      else if (iBreak == 2) then
        res = sqrt(resk**2+resci**2+ResQaaLag2)
        if (doDMRG) res = sqrt(resk**2)
        if (res < abs(Eps)) exit
      else
        if ((abs(delta) < abs(Eps**2*delta0)) .and. (res < abs(Eps))) exit
      end if
      if (iter >= niter) then
        cnvrgd = .false.
        exit
      end if
      if (lprint) write(u6,Fmt2//'I7,4X,ES17.9,ES17.9,ES17.9,ES17.9,ES17.9)') iter,delta/delta0,resk,resci,deltac,deltak
      iter = iter+1

    end do

    !*******************************************************************

    if (.not. cnvrgd) then
      write(u6,Fmt2//'A,I4,A)') 'No convergence for perturbation no: ',idisp,'. Increase Iter.'
      converged(isym) = .false.
      fail = .true.
    else
      if (iPL >= 2) write(u6,Fmt2//'A,I4,A,I4,A)') 'Perturbation no: ',idisp,' converged in ',iter-1,' steps.'
      call ipnout(-1)
    end if

    if (iPL >= 2) write(u6,*)
    iLen = nDensC
    iKapDisp(iDisp) = iDis
    call dDaFile(LuTemp,1,Kappa,iLen,iDis)
    iSigDisp(iDisp) = iDis
    call dDaFile(LuTemp,1,Sigma,iLen,iDis)
    ilen = nconf1*nroots
    iCIDisp(iDisp) = iDis

    call ipin(ipCIT)
    call dDaFile(LuTemp,1,W(ipCIT)%A,iLen,iDis)

    ! MGD This last call seems unused, so I comment it

    !call TimesE2(Kappa,ipCIT,1,reco,jspin,ipS2,Temp3,ipS2)
    iCISigDisp(iDisp) = iDis
    call ipin(ipST)
    call dDaFile(LuTemp,1,W(ipST)%A,iLen,iDis)
  end do ! iDisp

  call mma_deallocate(Temp4)
  call mma_deallocate(Temp3)
  call mma_deallocate(Sigma)
  call mma_deallocate(dKappa)
  call mma_deallocate(Kappa)
  call mma_deallocate(Sc2)
  call mma_deallocate(Sc1)
end if

! Free all memory and remove from disk all data
! related to this symmetry

call mma_deallocate(Fancy)
call mma_deallocate(iPre)

call ipclose(ipdia)
if (.not. CI) call ipclose(ipPre2)

if (debug) then
  write(u6,*) '********************************************************************************'
  write(u6,*)
end if
if (doDMRG) then  ! yma
  nash(:) = RGras2(:)
  nrs2(:) = RGras2(:)
end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine WfCtl_MSPD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine Precabi(ib,is,js,nd,rOut,nba,focki,focka,Sgn,A_J,A_K,Scr,nScr)
!***********************************************************************
!                                          [2]                         *
!     Calculates the diagonal submatrix of E    that couple            *
!                                                                      *
!     kappa           with   kappa                for a                *
!          kactive,virtual        kactive,inactive                     *
!                                                                      *
!     single active index.                                             *
!     Used for preconditioner.                                         *
!                                                                      *
!     See Olsen,Yeager, Joergensen:                                    *
!      "Optimization and characterization of an MCSCF state"           *
!                                                                      *
!     Called by prec                                                   *
!                                                                      *
!     ib,is         :        active index for the submatrix            *
!     js            :        symmetry of inact,virtual                 *
!     rOut          :         Submatrix                                *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: G1t, G2t, nA
use input_mclr, only: nAsh, nBas, nIsh, nOrb, nSym
use Constants, only: Two, Four, Eight
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ib, is, js, nd, nba, nScr
real(kind=wp), intent(inout) :: rOut(*)
real(kind=wp), intent(in) :: Focki(nba,nba), FockA(nba,nba), Sgn
real(kind=wp), intent(out) :: A_J(nScr), A_K(nScr), Scr(nScr)
integer(kind=iwp) :: iAA, ip, itAA, iVJ, jB, jVert, kA, kAA, kkA, kS, lA, lAA, llA, nO, nTri
real(kind=wp) :: Fact, Fact1, Fact2

!                                                                      *
!***********************************************************************
!                                                                      *
nTri = nTri_Elem(nd)

jVert = nOrb(js)-nIsh(js)-nAsh(js)
if (jVert == 0) return

nO = nAsh(js)+nIsh(js)
iAA = nA(is)+ib
itAA = nTri_Elem(iAA)
!                                                                      *
!***********************************************************************
!                                                                      *
do kS=1,nSym
  do kA=1,nAsh(kS)
    kAA = kA+nA(ks)
    kkA = kA+nIsh(ks)
    do lA=1,nAsh(kS)
      lAA = lA+nA(ks)
      llA = lA+nIsh(ks)

      call Coul(jS,jS,kS,kS,kkA,llA,A_J,Scr)
      call Exch(jS,kS,jS,kS,kkA,llA,A_K,Scr)

      do jB=1,nIsh(jS)
        ip = nTri-iTri(nd-jB+1,jVert)

        Fact1 = -Two*G2t(iTri(itAA,iTri(kAA,lAA)))
        Fact2 = -Four*G2t(iTri(iTri(iAA,kAA),iTri(iAA,lAA)))

        if (kaa == iaa) Fact2 = Fact2+Eight*G1t(iTri(iAA,lAA))
        if (laa == iaa) Fact1 = Fact1-Two*G1t(iTri(iAA,kAA))
        if (laa == iaa) Fact2 = Fact2-Two*G1t(iTri(iAA,kAA))

        ivj = (jB-1)*nBas(jS)+no
        rout(ip+1:ip+jVert) = rout(ip+1:ip+jVert)+Sgn*(Fact1*A_J(ivj+1:ivj+jVert)+Fact2*A_K(ivj+1:ivj+jVert))

      end do

    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
do jB=1,nIsh(jS)
  ip = nTri-iTri(nd-jB+1,jVert)
  Fact = (Two-Two*G1t(itAA))
  rOut(ip+1:ip+jVert) = rOut(ip+1:ip+jVert)+Sgn*(Fact*FockI(nO+1:nO+jVert,jB)+Two*FockA(nO+1:nO+jVert,jB))
end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Precabi

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Roland Lindh                                     *
************************************************************************
      SubRoutine EMFInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: to compute the electromagnetic field radiation integrals     *
*         using a complex Gauss-Hermite quadrature.                    *
*                                                                      *
* Called from: OneEl                                                   *
*                                                                      *
* Calling    : RecPrt                                                  *
*              CCrtCmp                                                 *
*              CAssmbl                                                 *
*              CVelInt                                                 *
*              CCmbnVe                                                 *
*                                                                      *
*     Author: Roland Lindh, Dept. of Chemistry - Angstrom,             *
*             University of Uppsala, Sweden. December 2015             *
************************************************************************
      use Her_RW
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables
      Logical ABeq(3)
      Integer iStabO(0:7), iDCRT(0:7)
*
      Call EMFInt_Internal(Array)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_integer(nOrdOp)
         Call Unused_integer_array(lOper)
         Call Unused_integer_array(iChO)
         Call Unused_integer_array(iStabM)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
*
*     This is to allow type punning without an explicit interface
      Contains
      SubRoutine EMFInt_Internal(Array)
      Use Iso_C_Binding
      Real*8, Target :: Array(*)
      Complex*16, Pointer :: zAxyz(:),zBxyz(:),zQxyz(:),zVxyz(:)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 195
      iPrint = nPrint(iRout)
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+1+nOrdOp) * 2
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+1+nOrdOp) * 2
      ipQxyz = nip
      nip = nip + nZeta*3*(la+1+nOrdOp)*(lb+1+nOrdOp) * 2
      If (nOrdOp.eq.1) Then
         ipVxyz = nip
         nip = nip + nZeta*6*(la+1)*(lb+1) * 2
         ipA = nip
         nip = nip + nZeta
         ipB = nip
         nip = nip + nZeta
         ipRes = nip
         nip = nip + nZeta*nElem(la)*nElem(lb)*nComp
      Else
         ipVxyz = nip
         ipA = nip
         ipB = nip
         ipRes = nip
         nip = nip + nZeta*nElem(la)*nElem(lb)*nComp
      End If
      If (nip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'EMFInt: nip-1.gt.nArr*nZeta')
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Write (6,*) ' Abend in EMFInt'
         Call Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In EMFInt: A',' ',A,1,3)
         Call RecPrt(' In EMFInt: RB',' ',RB,1,3)
         Call RecPrt(' In EMFInt: KVector',' ',CCoor,1,3)
         Call RecPrt(' In EMFInt: P',' ',P,nZeta,3)
         Write (6,*) ' In EMFInt: la,lb=',la,lb
      End If
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
*     Compute the cartesian values of the basis functions angular part
*     Note that these arrays are complex.
*
      Call C_F_Pointer(C_Loc(Array(ipAxyz)),zAxyz,
     &                  [nZeta*3*nHer*(la+nOrdOp+1)])
      Call CCrtCmp(Zeta,P,nZeta,A,zAxyz,
     &               la+nOrdOp,HerR(iHerR(nHer)),nHer,ABeq,CCoor)
      Call C_F_Pointer(C_Loc(Array(ipBxyz)),zBxyz,
     &                  [nZeta*3*nHer*(lb+nOrdOp+1)])
      Call CCrtCmp(Zeta,P,nZeta,RB,zBxyz,
     &               lb+nOrdOp,HerR(iHerR(nHer)),nHer,ABeq,CCoor)
      Nullify(zAxyz,zBxyz)
*
*     Compute the cartesian components for the multipole moment
*     integrals. The integrals are factorized into components.
*
      Call C_F_Pointer(C_Loc(Array(ipAxyz)),zAxyz,
     &                  [nZeta*3*nHer*(la+nOrdOp+1)])
      Call C_F_Pointer(C_Loc(Array(ipQxyz)),zQxyz,
     &                  [nZeta*3*(la+nOrdOp+1)*(lb+nOrdOp+1)])
      Call C_F_Pointer(C_Loc(Array(ipBxyz)),zBxyz,
     &                  [nZeta*3*nHer*(lb+nOrdOp+1)])
      Call CAssmbl(zQxyz,
     &             zAxyz,la+nOrdOp,
     &             zBxyz,lb+nOrdOp,
     &             nZeta,HerW(iHerW(nHer)),nHer)
      Nullify(zAxyz,zBxyz,zQxyz)
*
*     Compute the cartesian components for the velocity integrals.
*     The velocity components are linear combinations of overlap
*     components.
*
      If (nOrdOp.eq.1) Then
         ipAOff = ipA
         Do iBeta = 1, nBeta
            call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
            ipAOff = ipAOff + nAlpha
         End Do

         ipBOff = ipB
         Do iAlpha = 1, nAlpha
            call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
            ipBOff = ipBOff + 1
         End Do
*
         Call C_F_Pointer(C_Loc(Array(ipVxyz)),zVxyz,
     &                     [nZeta*3*(la+1)*(lb+1)])
         Call C_F_Pointer(C_Loc(Array(ipQxyz)),zQxyz,
     &                     [nZeta*3*(la+1)*(lb+1)])
         Call CVelInt(zVxyz,zQxyz,la,lb,
     &                Array(ipA),Array(ipB),nZeta)
         Nullify(zVxyz,zQxyz)
*
*     Combine the cartesian components to the full one electron
*     integral.
*
         Call C_F_Pointer(C_Loc(Array(ipQxyz)),zQxyz,
     &                     [nZeta*3*(la+1)*(lb+1)])
         Call C_F_Pointer(C_Loc(Array(ipVxyz)),zVxyz,
     &                     [nZeta*3*(la+1)*(lb+1)*2])
         Call CCmbnVe(zQxyz,nZeta,la,lb,Zeta,rKappa,
     &                Array(ipRes),nComp,zVxyz,CCoor)
         Nullify(zQxyz,zVxyz)
      Else
         Call C_F_Pointer(C_Loc(Array(ipQxyz)),zQxyz,
     &                     [nZeta*3*(la+1)*(lb+1)*(nOrdOp+1)])
         Call CCmbnMP(zQxyz,nZeta,la,lb,nOrdOp,Zeta,
     &                rKappa,Array(ipRes),nComp,CCoor)
         Nullify(zQxyz)
      End If
*
      llOper=lOper(1)
      Do iComp = 2, nComp
         llOper = iOr(llOper,lOper(iComp))
      End Do
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
      Do lDCRT = 0, nDCRT-1
*
*--------Accumulate contributions
*
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array(ipRes),nZeta,la,lb,nComp,Final,nIC,
     &               nOp         ,lOper,iChO,One)
*
      End Do
*
      Return
      End SubRoutine EMFInt_internal
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Strtch(xyz,nCent,Avst,B,lWrite,Label,dB,ldB)

use Constants, only: One, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCent
real(kind=wp), intent(in) :: xyz(3,nCent)
real(kind=wp), intent(out) :: Avst, B(3,nCent)
logical(kind=iwp), intent(in) :: lWrite, ldB
character(len=8), intent(in) :: Label
real(kind=wp), intent(inout) :: dB(3,nCent,3,nCent)
integer(kind=iwp) :: i, j
real(kind=wp) :: aRR, R(3), R2, RR, xRR

R(1) = xyz(1,2)-xyz(1,1)
R(2) = xyz(2,2)-xyz(2,1)
R(3) = xyz(3,2)-xyz(3,1)
R2 = R(1)**2+R(2)**2+R(3)**2
RR = sqrt(R2)
Avst = RR

aRR = RR*Angstrom
if (lWrite) write(u6,'(1X,A,A,2(F10.6,A))') Label,' : Bond Length=',aRR,' / angstrom',RR,' / bohr'
if (aRR < 1.0e-6_wp) then
  call WarningMessage(2,'Abend in Strtch')
  write(u6,*) '***************** ERROR **********************'
  write(u6,*) ' Short (or negative) distance for coordinate: '
  write(u6,'(1X,A,A,2(F10.6,A))') Label,' : Bond Length=',aRR,' / angstrom',RR,' / bohr'
  write(u6,*) '**********************************************'
  write(u6,*)
  call Quit_OnUserError()
end if

! Compute the WDC B-matrix.

B(1,1) = -R(1)/RR
B(2,1) = -R(2)/RR
B(3,1) = -R(3)/RR

! Renormalize

xRR = sqrt(B(1,1)**2+B(2,1)**2+B(3,1)**2)
B(1,1) = B(1,1)/xRR
B(2,1) = B(2,1)/xRR
B(3,1) = B(3,1)/xRR

! Utilize translational invariance.
B(1,2) = -B(1,1)
B(2,2) = -B(2,1)
B(3,2) = -B(3,1)

! Compute the cartesian derivative of the B-matrix.

if (ldB) then

  do i=1,3
    do j=1,i
      if (i == j) then
        dB(i,1,j,1) = (One-B(j,1)*B(i,1))/RR
      else
        dB(i,1,j,1) = (-B(j,1)*B(i,1))/RR
      end if
      dB(j,1,i,1) = dB(i,1,j,1)

      dB(i,2,j,1) = -dB(i,1,j,1)
      dB(j,1,i,2) = dB(i,2,j,1)

      dB(i,1,j,2) = -dB(i,1,j,1)
      dB(j,2,i,1) = dB(i,1,j,2)

      dB(i,2,j,2) = -dB(i,2,j,1)
      dB(j,2,i,2) = dB(i,2,j,2)
    end do
  end do

end if

return

end subroutine Strtch

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Print_Local(rMP,nij,nElem,Coor,nAtoms,C_o_C,Q_Nuc,lMax,
     &                       Lbl_Center,rMPq,EC,Polar,NoField,Temp,
     &                       xrMP,xxRMP,xnrMP,iANr,nOcOb,
     &                       Energy_Without_FFPT,ip_Ene_Occ,
     &                       MpProp_Level,Bond_Threshold,XHole,
     &                       XHoleLoc,D2, ChPol, ChPolBB,LIonize)
      use Real_Spherical
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "status.fh"
      Real*8 rMP(nij,nElem), Coor(3,nAtoms), A(3), C_o_C(3),
     &       Q_Nuc(nAtoms), rMPq(nElem), EC(3,nij), Polar(6,nij),
     &       Polar_M(6), Temp(nij), CX(3), xrMP(nij,nElem),
     &       xxrMP(nij,nElem), xnrMP(nij,nElem), XHoleLoc(nij),
     &       ChPol(6,nij), ChPolBB(6,nij)
      Integer iANr(nAtoms)
      Character*(LENIN) Lbl_Center(nAtoms)
      Character*80 Banner_Line(2)
      Logical NoField, Center_OK, Check_Bond, get_BasisType, XHole
      Logical LIonize
*
      Real*8 Sites
      Real*8 TP
      Real*8 TP_Q
      Real*8 LI, LA
      Real*8 LI_TOT
      Real*8 LI_MIN
*
      Sites = 0.0
      LI_TOT = 0.0
      LI_MIN = 99.0
*                                                                      *
************************************************************************
*                                                                      *
      Center_OK = .True.
      Call Sphere(lMax)
*                                                                      *
************************************************************************
*                                                                      *
*     Make copy of rMP so we keep a copy of the
*     electronic contributions to the multipoles.
*
      iDim = nij*nElem
      Call dCopy_(iDim,rMP,1,xrMP,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Put info to check file.
*
C     Call RecPrt('Print_Local: rMP',' ',rMP,nij,nElem)
      Do iElem = 1, nElem
         Call Add_Info('LoProp MP',rMP(1,iElem),nij,4)
      End Do
      If (.Not.NoField) Then
         Do iPol = 1, 6
            call dcopy_(nij,Polar(iPol,1),6,Temp,1)
            Call Add_Info('LoProp a',Temp,nAtoms*(nAtoms+1)/2,4)
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Binom()
*                                                                      *
************************************************************************
*                                                                      *
*     Set up array for nuclear contributions.
*
      Call dCopy_(nij*nElem,[Zero],0,xnrMP,1)
      ij = 0
      Do iAtom = 1, nAtoms
         Do jAtom = 1, iAtom
            ij = ij + 1
            If (iAtom.eq.jAtom) Then
               xnrMP(ij,1)=Q_nuc(iAtom)
               CX(1)=Coor(1,iAtom)
               CX(2)=Coor(2,iAtom)
               CX(3)=Coor(3,iAtom)
               Call ReExpand(xnrMP,nij,nElem,CX,EC(1,ij),ij,lMax)
            End If
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Loop over all domains
*
*
      Write (6,*)
      Banner_Line(1)='The Localized properties'
      Call Banner (Banner_Line(1),1,80)
      Write(6,*)

      nReal_Centers = 0
      ij = 0
      Do iAtom = 1, nAtoms
         Do jAtom = 1, iAtom
            ij = ij + 1
            If (iAtom.eq.jAtom) Then
*--------------Atomic domain
               Charge_center=Q_nuc(iAtom)
               CX(1)=Coor(1,iAtom)
               CX(2)=Coor(2,iAtom)
               CX(3)=Coor(3,iAtom)
               Center_OK = .True.
            Else
*--------------Bond domain
               Charge_center=Zero
               CX(1)=(Coor(1,iAtom)+Coor(1,jAtom))*Half
               CX(2)=(Coor(2,iAtom)+Coor(2,jAtom))*Half
               CX(3)=(Coor(3,iAtom)+Coor(3,jAtom))*Half
               Center_OK = Check_Bond(Coor(1,iAtom),Coor(1,jAtom),
     &                           iANr(iAtom),iANr(jAtom),Bond_Threshold)
            End If
            call dcopy_(3,EC(1,ij),1,A,1)
*
*---------- Print out values for each domain.
*
            If (Center_OK) Then
            nReal_Centers = nReal_Centers + 1
            Write (6,*)
            Write (6,*)
            If (iAtom.eq.jAtom) Then
               Write (6,*)       '===================='
               Write (6,'(A,A)') ' ATOMIC DOMAIN: ', Lbl_Center(iAtom)
               Write (6,*)       '===================='
            Else
               Write (6,*)       '========================='
               Write (6,'(A,A,A,A)') ' BOND DOMAIN: ',
     &                         Lbl_Center(iAtom), ',', Lbl_Center(jAtom)
               Write (6,*)       '========================='
            End If
            Write (6,'(A,3F12.8,A)') ' Domain center:  :',CX,' / bohr'
            Write (6,'(A,3F12.8,A)') ' Expansion center:', A,' / bohr'
            Write (6,'(A, F12.8  )') ' Total charge    :',
     &                               Charge_center+rMP(ij,1)
**
            If (LIonize) Then
               If (.Not.NoField) Then
                  TP  = (Polar(1,ij)+Polar(3,ij)+Polar(6,ij))/Three
                  TP_Q = Charge_center+rMP(ij,1)
                  Sites = Sites + 1.0
                  If(TP.gt.0.0) Then
                     LI = 0.623*(TP_Q+1.742)*(1/TP)**(1.0/3.0)
                     LA = LI*(TP_Q+0.258)/(TP_Q+1.742)
                     Write (6,*)
                     Write (6,'(A)') 'Local Ionization Energy'
                     Write (6,'(10F12.8)') LI
                     Write (6,*)
                     If (LI.lt.LI_MIN) LI_MIN = LI
                     LI_TOT = LI_TOT + LI
                     Write (6,'(A)') 'Local Electron Affinity'
                     Write (6,'(10F12.8)') LA
                     Write (6,'(A)') 'Local Electronegativity'
                     Write (6,'(10F12.8)') (LI+LA)/2.0
                     Write (6,'(A)') 'Local Chemical Hardness'
                     Write (6,'(10F12.8)') (LI-LA)/2.0

                  Else
                     Write(6,'(A)') 'Negative isotropic polarizability!'
                     Write(6,'(A)') 'The local ionization energy will'
                     Write(6,'(A)') 'not be computed for this site'
                  EndIf
               EndIf
            End If
**
            Write (6,*)
            Write (6,'(A)') ' Electronic multipole moments:'
            iStrt = 1


            Do l = 0, lMax
               iEnd = iStrt + (l+1)*(l+2)/2 - 1
               If (l .eq. 0) Write (6,'(A)') 'Electronic Charge'
               If (l .eq. 1) Write (6,'(A)') 'Electronic Dipole'
               If (l .eq. 2) Write (6,'(A)') 'Electronic Quadrupole'
               If (l .eq. 3) Write (6,'(A)') 'Electronic Octupole'
               If (l .eq. 4) Write (6,'(A)') 'Electronic Hexadecapole'
               If (l .ge. 5) Write (6,'(A,I2)')
     &                  'Electronic multipole moment with l = ',l
               Write (6,'(10F12.8)') (rMP(ij,iElem),iElem=iStrt,iEnd)
c****************************************************
               If (iAtom .eq. jAtom .AND. l .ge. 1) Then
                  Write (6,'(A)') '... with nuclear contribution'
                  Write (6,'(10F12.8)')
     &               (rMP(ij,iElem)+xnrMP(ij,iElem),iElem=iStrt,iEnd)
               End If
c****************************************************
               iStrt = iEnd + 1
               Write (6,*)
            End Do
            If (lMax.ge.1) Then
               Dip_Tot=Sqrt(rMP(ij,2)**2+rMP(ij,3)**2+rMP(ij,4)**2)
               Write (6,*)
               Write (6,'(A,F12.8)')'Dipole magnitude:',Dip_Tot
               Write (6,*)
            End If
            If (.Not.NoField) Then
               Write (6,*)
               Call TriPrt(
     &         'Symmetrized Local Polarizability Tensor',' ',
     &         Polar(1,ij),3)
               Pol_Tot=(Polar(1,ij)+Polar(3,ij)+Polar(6,ij))/Three
               Write (6,*)
               Write (6,'(A,F12.8)')'Isotropic Polarizability:',Pol_Tot
               Write (6,*)
            End If
            If (XHole) then
              x2Dip=XHoleLoc(ij)
              Write(6,'(A,F12.8)')'Exchange hole second-moment:',x2Dip
              Write(6,*)
            Endif
            End If ! Center_OK
*
*debug
C           Call Allocate_Work(ip_EVec,9)
C           Call Allocate_Work(ip_EVal,6)
C           call dcopy_(9,[Zero],0,Work(ip_EVec),1)
C           call dcopy_(3,[One],0,Work(ip_EVec),4)
C           call dcopy_(6,Polar(1,ij),1,Work(ip_EVal),1)
C           Call Jacob(Work(ip_EVal),Work(ip_EVec),3,3)
C           Call TriPrt('EVal',' ',Work(ip_EVal),3)
C           Call RecPrt('EVec',' ',Work(ip_EVec),3,3)
C           Call Free_Work(ip_EVal)
C           Call Free_Work(ip_EVec)
*debug
*           Reexpand all multipole moments to the center of mass
*
            Call ReExpand(rMP,nij,nElem,A,C_o_C,ij,lMax)
C??            Call ReExpand(xrMP,nij,nElem,A,C_o_C,ij,lMax)
            Call ReExpand(xnrMP,nij,nElem,EC(1,ij),C_o_C,ij,lMax)
*
         End Do
      End Do
*     Write the charge capacitances for the bonds
      If (.Not.NoField) Then
         Write(6,*) '=== Charge capacitance for bonds ==='
         ij = 0
         Do jAtom = 1, nAtoms
            Do iAtom = jAtom+1, nAtoms
               ij = iAtom*(iAtom-1)/2 + jAtom
               If (iAtom.eq.jAtom) Then
               Else
                  CX(1)=(Coor(1,iAtom)-Coor(1,jAtom))
                  CX(2)=(Coor(2,iAtom)-Coor(2,jAtom))
                  CX(3)=(Coor(3,iAtom)-Coor(3,jAtom))
                  CRX = ChPolBB(1,ij)*CX(1)
     &                 +ChPolBB(2,ij)*CX(2)
     &                 +ChPolBB(4,ij)*CX(3)

                  CRY = ChPolBB(2,ij)*CX(1)
     &                 +ChPolBB(3,ij)*CX(2)
     &                 +ChPolBB(5,ij)*CX(3)

                  CRZ = ChPolBB(4,ij)*CX(1)
     &                 +ChPolBB(5,ij)*CX(2)
     &                 +ChPolBB(6,ij)*CX(3)

                  CRN = SQRT(CRX*CRX+
     &                 CRY*CRY+
     &                 CRZ*CRZ)

                  DR = SQRT(CX(1)*CX(1)+
     &                 CX(2)*CX(2)+
     &                 CX(3)*CX(3))
                  If ( 0.001.lt.(CRN/(DR*DR*DR))) Then
                     Write(6,' (A, A, F12.8)') Lbl_Center(iAtom),
     &                                        Lbl_Center(jAtom),
     &                                        CRN/(DR*DR*DR)
                  End If
               End If
            End Do
         End Do
         Write(6,*) '=== =========================== ==='
         Write(6,*)
      End If
C      *** Local ionzations are implemented by A. Holt
      If (LIonize) Then
         If (.Not.NoField) Then
            Write (6,'(A)') '===   Local Ionization energy   ==='
            Write (6,'(A)') 'The local ionization energies are'
            Write (6,'(A)') 'computed using the expression for atoms'
            Write (6,'(A)') 'found in; J.Phys.Chem. 1996, 100,4828'
            Write (6,'(A)')
            Write (6,'(A)') 'Average local ionization energy'
            Write (6,'(10F12.8)') LI_TOT/Sites*27.2114
            Write (6,'(A)') 'Lowest local ionization energy (eV)'
            Write (6,'(10F12.8)') LI_MIN*27.2114
            Write (6,'(A)') 'HOMO energy (absolute value, eV)'
            Write (6,'(10F12.8)') ABS(Work(ip_Ene_Occ+nOcOb-1))*27.2114
            Write(6,'(A)') '=== =========================== ==='
            Write (6,'(A)')
         EndIf
      EndIf

*
*     Write out the molecular properties
*
      Write (6,*)
      Write (6,*)
      Write (6,*)
      Banner_Line(1)='The Molecular Multipole Moments'
      Call Banner (Banner_Line(1),1,80)
      Write (6,'(A,3F12.8,A)') ' Expansion center:',C_o_C,' / bohr'
      Write (6,*)
      Write (6,*)
      iElem = 0
      Do l = 0, lMax
         Write (6,*)
         Write (6,'(A,I1)') 'l=',l
         Write (6,*)
         Write (6,'(A)')
     &         'xyz    Nuclear        Electronic     Molecular   '
         Write (6,*)
         Do ix = l, 0, -1
         Do iy = l-ix,0,-1
            iz = l-ix-iy
            iElem = iElem + 1
            rMP_Tot_Electronic=DDot_(nij,[One],0,rMP(1,iElem),1)
            rMP_Tot_Nuclear=rMPq(iElem)
            rMP_Tot = rMP_Tot_Nuclear + rMP_Tot_Electronic
            Write (6,'(3I1,3F16.8)') ix,iy,iz,rMP_Tot_Nuclear,
     &                               rMP_Tot_Electronic,rMP_Tot
         End Do
         End Do
      End Do
      If (.Not.NoField) Then
         Do iPol = 1, 6
            Polar_M(iPol)=DDot_(nij,[One],0,Polar(iPol,1),6)
         End Do
         Call TriPrt(
     &         'Molecular Polarizability Tensor',' ',Polar_M,3)
*debug
C           Call Allocate_Work(ip_EVec,9)
C           Call Allocate_Work(ip_EVal,6)
C           call dcopy_(9,Zero,0,Work(ip_EVec),1)
C           call dcopy_(3,One,0,Work(ip_EVec),4)
C           call dcopy_(6,Polar_M,1,Work(ip_EVal),1)
C           Call Jacob(Work(ip_EVal),Work(ip_EVec),3,3)
C           Call TriPrt('EVal',' ',Work(ip_EVal),3)
C           Call RecPrt('EVec',' ',Work(ip_EVec),3,3)
C           Call Free_Work(ip_EVal)
C           Call Free_Work(ip_EVec)
*debug
      End If
      If(XHole) then
        Write(6,*)
        Write(6,'(A,F12.8)')'Molecular exchange hole second moment:',D2
        Write(6,*)
      Endif
*
*---------- Generate mpprop file
*
      Call Print_MPPROP(rMP,xrMP,xnrMP,nij,nElem,lMax,EC,Polar,
     &                  Lbl_Center,nAtoms,iANr,NoField,C_o_C,Coor,
     &                  nOcOb,Energy_Without_FFPT,ip_Ene_Occ,
     &                  MpProp_Level,Bond_Threshold,nReal_Centers)
*
      Call Allocate_Work(iScratch_New,nij*(2*lMax+1))
      Call Allocate_Work(iScratch_Org,nij*(2*lMax+1))
*
*---------- Compare the molecular multipole moments to the ones arrising from truncation
*           xrMP contains the original multipole moments (electr. + nuclear)
*           xxrMP contains the approximate multipole moments.
*
      Call dCopy_(iDim,rMP,1,xrMP,1)
      call daxpy_(iDim,One,xnrMP,1,xrMP,1)
      Call dCopy_(iDim,xrMP,1,xxrMP,1)

      iPrint = 1
      Do l = lMax-1, 0, -1
         Call CutOff_Error(l,lMax,xrMP,xxrMP,nij,EC,C_o_C,nElem,
     &                     Work(iScratch_New),Work(iScratch_Org),
     &                     nAtoms,iPrint,rms)
      End Do

      Call Free_Work(iScratch_New)
      Call Free_Work(iScratch_Org)
      Call Sphere_Free()
*
*------ Print warning if non-ANO basis sets have been used
*
      If (.NOT. get_BasisType('ANO')) Then
         Write(6,*)
         Write(6,*) 'WARNING: The calculation were performed with at '
         Write(6,*) '         least one non-ANO basis! The results'
         Write(6,*) '         might therefore be erroneous.'
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(ChPol)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Francesco Aquilante                              *
!***********************************************************************

subroutine One_CHARGE(NSYM,NBAS,UBNAME,CMO,OCCN,SMAT,iCase,FullMlk,MxTyp,QQ,nNuc)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6
#ifdef _DEBUGPRINT_
use Definitions, only: r8
#endif

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: NSYM, NBAS(NSYM), iCase, MxTyp, nNuc
character(len=LenIn8), intent(in) :: UBNAME(*)
real(kind=wp), intent(in) :: CMO(*), OCCN(*), SMAT(*)
logical(kind=iwp), intent(in) :: FullMlk
real(kind=wp), intent(out) :: QQ(MxTyp,nNuc)
#include "angtp.fh"
integer(kind=iwp) :: AtomA, AtomB, i, i0, iAB, iAng, IB, iBlo, iEnd, iix, iixx, ik, ikk, iM, IMN, IMO, iNuc, IO, iPair, iPL, IS, &
                     ISING, ISMO, IST, iStart, iSum, iSwap, iSyLbl, ISYM, IT, ix, J, jAng, jEnd, jM, jx, k, l, lqSwap, MY, MYNUC, &
                     MYTYP, NB, nBas2, NBAST, NDIM, NPBonds, nScr, NXTYP, NY, NYNUC, NYTYP, tNUC
real(kind=wp) :: BO, BOThrs, Det, DMN, QSUMI, TERM
logical(kind=iwp) :: DoBond
character(len=100) :: ProgName
character(len=8) TMP
!character(len=4) TLbl(MXATOM)
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: Reduce_Prt
character(len=100), external :: Get_ProgName
character(len=LenIn8), external :: Clean_Bname
integer(kind=iwp), allocatable :: iCenter(:), ICNT(:), ITYP(:), nStab(:)
real(kind=wp), allocatable :: Bonds(:), Charge(:), D(:,:), D_blo(:), D_tmp(:,:), DS(:,:), Fac(:), P(:,:), PInv(:,:), Q2(:), &
                              QSUM(:), QSUM_TOT(:), S(:,:), S_blo(:), S_tmp(:,:), Scr(:)
real(kind=wp), allocatable, save :: DSSwap(:,:), qSwap(:)
character(len=8), allocatable :: tName(:), tSwap(:)
character(len=LenIn), allocatable :: CNAME(:)
character(len=LenIn4), allocatable :: LblCnt4(:)
#ifdef _DEBUGPRINT_
real(kind=r8) :: E
real(kind=r8), external :: DDot_
#endif
character(len=*), parameter :: AufBau(19) = ['01s',                   &
                                             '02s',            '02p', &
                                             '03s',            '03p', &
                                             '04s',      '03d','04p', &
                                             '05s',      '04d','05p', &
                                             '06s','04f','05d','06p', &
                                             '07s','05f','06d','07p']

!                                                                      *
!***********************************************************************
!                                                                      *
iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(tName,MxTyp,label='tName')
do i=1,MxTyp
  tName(i) = '        '
end do

!----------------------------------------------------------------------*
!     Get the name of the calling module.                              *
!     If CPFMCPF no bond analysis is done.                             *
!----------------------------------------------------------------------*

ProgName = Get_ProgName()
call Upcase(ProgName)
ProgName = adjustl(ProgName)
iEnd = max(1,index(ProgName,' '))

DoBond = .false.

!----------------------------------------------------------------------*
!     Set the Mulliken Bond Order threshold for printout               *
!----------------------------------------------------------------------*

BOThrs = Half

!----------------------------------------------------------------------*
!     GET THE TOTAL NUMBER OF BASIS FUNCTIONS AND CHECK LIMITS         *
!----------------------------------------------------------------------*

NBAST = 0
do I=1,NSYM
  NBAST = NBAST+NBAS(I)
end do
if (NBAST > MXBAS) then
  write(u6,'(/6X,A)') 'The number of basis functions exceeds the present limit'
  call Abend()
end if

!----------------------------------------------------------------------*
!     Find the list of unique center labels                            *
!----------------------------------------------------------------------*

call mma_allocate(CNAME,nNuc,label='CNAME')
call mma_allocate(nStab,nNuc,label='nStab')
call mma_allocate(Fac,nNuc,label='Fac')

call Get_cArray('Unique Atom Names',CNAME,LenIn*nNuc)
call Get_iArray('nStab',nStab,nNuc)

Fac(:) = real(nStab(:),kind=wp)/real(nSym,kind=wp)

!----------------------------------------------------------------------*
!     Find the center label for each basis function                    *
!----------------------------------------------------------------------*

call mma_allocate(ICNT,NBAST,label='ICNT')
call mma_allocate(ITYP,NBAST,label='ITYP')
do I=1,NBAST
  ICNT(I) = -1
  do J=1,NNUC
    if (UBNAME(I)(1:LenIn) == CNAME(J)) ICNT(I) = J
  end do
end do

!----------------------------------------------------------------------*
!     Find the type label for each basis function                      *
!----------------------------------------------------------------------*

NXTYP = 0
ITYP(:) = 0
outer1: do I=1,NBAST
  if (ICNT(I) < 0) cycle outer1 ! skip pseudo center
  do J=1,NXTYP
    if (J > MxTyp) then
      write(u6,*) 'Charge: J > MxTyp'
      write(u6,*) 'J=',J
      write(u6,*) 'MxTyp=',MxTyp
      write(u6,*) 'Increase MxType and recompile!'
      call Abend()
    end if
    if (UBNAME(I)(LenIn1:LenIn8) == tName(J)) then
      ITYP(I) = J
      cycle outer1
    end if
  end do
  NXTYP = NXTYP+1
  tName(NXTYP) = UBNAME(I)(LenIn1:LenIn8)

  ITYP(I) = NXTYP
end do outer1

lqSwap = NNUC+NNUC*NXTYP

if (iCase == 0) then
  ! instead of printing charges we dump everything into a memory same with DS matrix

  call mma_allocate(qSwap,lqSwap,label='CHRG_SWP')

  if (DoBond) call mma_allocate(DSSwap,NBAST,NBAST,label='DSSwap')

end if

!----------------------------------------------------------------------*
!     Do some trivial sorting of the type labels                       *
!----------------------------------------------------------------------*

! Sort with respect to radial index

ix = 0
jx = 0
do i=1,NxTyp-1
  ix = ichar(tName(i)(1:1))-ichar('1')+1
  ix = 10*ix+ichar(tName(i)(2:2))-ichar('1')+1
  ! Put polarization and diffuse functions last
  if (tName(i)(1:1) == '*') ix = 100
  do j=i+1,NxTyp
    jx = ichar(tName(j)(1:1))-ichar('1')+1
    jx = 10*jx+ichar(tName(j)(2:2))-ichar('1')+1
    if (tName(j)(1:1) == '*') jx = 100
    if (ix > jx) then
      iSwap = ix
      ix = jx
      jx = iSwap
      TMP = tName(i)
      tName(i) = tName(j)
      tName(j) = TMP
    end if
  end do
end do

! Sort with respect to angular index

iAng = 0
jAng = 0
ix = 1
do
  iix = ichar(tName(ix)(1:1))
  iixx = ichar(tName(ix)(2:2))
  jx = ix
  do i=min(ix+1,NxTyp),NxTyp
    if ((ichar(tName(i)(1:1)) == iix) .and. (ichar(tName(i)(2:2)) == iixx)) jx = i
  end do

  do i=ix,jx-1
    do k=0,iTabMx
      if (AngTp(k) == tName(i)(3:3)) iAng = k
    end do
    do j=i+1,jx
      do l=0,iTabMx
        if (AngTp(l) == tName(j)(3:3)) jAng = l
      end do
      if (iAng > jAng) then
        iSwap = iAng
        iAng = jAng
        jAng = iSwap
        TMP = tName(i)
        tName(i) = tName(j)
        tName(j) = TMP
      end if
    end do
  end do
  !write(u6,*) ' Sorted n subrange'
  !do i=ix,jx
  !  Write(u6,*) tName(i)
  !end do

  ! Now sort with respect to the magnetic index

  iEnd = jx
  iStart = ix
  do
    do k=0,iTabMx
      if (AngTp(k) == tName(iStart)(3:3)) iAng = k
    end do
    jEnd = iStart
    do i=min(iStart+1,iEnd),iEnd
      if (tName(i)(3:3) == AngTp(iAng)) jEnd = i
    end do

    i0 = ichar('1')-1

    iM = 0
    jM = 0
    if (iAng == 1) then
      do i=iStart,jEnd-1
        if (tName(i)(4:4) == 'x') iM = 1
        if (tName(i)(4:4) == 'z') iM = 0
        if (tName(i)(4:4) == 'y') iM = -1
        do j=i+1,jEnd
          if (tName(j)(4:4) == 'x') jM = 1
          if (tName(j)(4:4) == 'z') jM = 0
          if (tName(j)(4:4) == 'y') jM = -1
          if (jM > iM) then
            iSwap = iM
            iM = jM
            jM = iSwap
            TMP = tName(i)
            tName(i) = tName(j)
            tName(j) = TMP
          end if
        end do
      end do
    else if (iAng >= 2) then
      do i=iStart,jEnd-1
        iM = ichar(tName(i)(4:4))-i0
        iM = 10*iM+ichar(tName(i)(5:5))-i0
        if (tName(i)(6:6) == '-') iM = -iM
        do j=i+1,jEnd
          jM = ichar(tName(j)(4:4))-i0
          jM = 10*jM+ichar(tName(j)(5:5))-i0
          if (tName(j)(6:6) == '-') jM = -jM
          if (jM > iM) then
            iSwap = iM
            iM = jM
            jM = iSwap
            TMP = tName(i)
            tName(i) = tName(j)
            tName(j) = TMP
          end if
        end do
      end do
    end if

    if (jEnd == iEnd) exit
    iStart = jEnd+1
  end do

  if (jx == NxTyp) exit
  ix = jx+1
end do

! Sort according to AufBau

call mma_allocate(tSwap,NxTyp,label='tSwap')

iStart = 1
do iAB=1,19
  do i=1,NxTyp
    if (tName(i)(1:3) == AufBau(iAB)) then
      tSwap(iStart) = tName(i)
      tName(i) = '        '
      iStart = iStart+1
    end if
  end do
end do
do i=1,NxTyp
  if (tName(i) /= '        ') then
    tSwap(iStart) = tName(i)
    tName(i) = '        '
    iStart = iStart+1
  end if
end do
do i=1,NxTyp
  tName(i) = tSwap(i)
end do

call mma_deallocate(tSwap)

outer2: do I=1,NBAST
  if (ICNT(I) < 0) cycle outer2 ! skip pseudo center
  do J=1,NXTYP
    if (UBNAME(I)(LenIn1:LenIn8) == tName(J)) then
      ITYP(I) = J
      cycle outer2
    end if
  end do
end do outer2

!----------------------------------------------------------------------*
!     Get the total number of atoms tNUC, regardless of symmetry       *
!----------------------------------------------------------------------*

call Get_iScalar('LP_nCenter',tNUC)

!----------------------------------------------------------------------*
!     Bond analysis initialization                                     *
!----------------------------------------------------------------------*

if (DoBond) then

  !--------------------------------------------------------------------*
  !   In case of symmetry we need the desymmetrization matrix,         *
  !   for the bond order calculation only.                             *
  !--------------------------------------------------------------------*

  if (nSym > 1) then

    call mma_allocate(P,NBAST,NBAST,label='P')
    call mma_allocate(PInv,NBAST,NBAST,label='PInv')
    call Get_dArray('SM',P,NBAST**2)
#   ifdef _DEBUGPRINT_
    call RecPrt('SM',' ',P,NBAST,NBAST)
#   endif
    call MINV(P,PInv,ISING,DET,NBAST)
#   ifdef _DEBUGPRINT_
    call RecPrt('SMInv',' ',PInv,NBAST,NBAST)
#   endif
    call DGeTMi(PInv,NBAST,NBAST)
  end if

  ! Pick up index array of which center a basis function belongs to.
  ! If no symmetry, it is the same as ICNT(I).

  call mma_allocate(iCenter,NBAST,label='iCenter')
  call Get_iArray('Center Index',iCenter,NBAST)

  !*********************************************************************

  !--------------------------------------------------------------------*
  !   Initialize symmetric density D_tmp and overlap S_tmp matrices,   *
  !   block D_blo and S_blo matrices (if symmetry)                     *
  !   plus asymmetric D, S and DS matrices                             *
  !--------------------------------------------------------------------*

  call mma_allocate(D_tmp,NBAST,NBAST,label='D_tmp')
  call mma_allocate(S_tmp,NBAST,NBAST,label='S_tmp')
  call mma_allocate(D,NBAST,NBAST,label='D')
  call mma_allocate(S,NBAST,NBAST,label='S')
  call mma_allocate(DS,NBAST,NBAST,label='DS')
  D_tmp(:,:) = Zero
  S_tmp(:,:) = Zero
  D(:,:) = Zero
  S(:,:) = Zero
  DS(:,:) = Zero

  if (nSym > 1) then
    nBas2 = 0
    do I=1,nsym
      nBas2 = nBas2+nBas(i)*nBas(i)
    end do
    call mma_allocate(D_blo,nBas2,label='D_blo')
    call mma_allocate(S_blo,nBas2,label='S_blo')
    D_blo(:) = Zero
    S_blo(:) = Zero
  end if

  !--------------------------------------------------------------------*
  !   Find the center label for each atom, regardless of symmetry      *
  !--------------------------------------------------------------------*

  ! Just atom label. It's a double of the next one,
  ! but someone could find it usefull in future

  !call Get_LblCnt_All(TLbl)

  ! Atom labels plus symmetry generator

  call mma_allocate(LblCnt4,tNUC,label='LblCnt4')
  call Get_cArray('LP_L',LblCnt4,LenIn4*tNUC)
  !do i=1,tNUC
  !  LblCnt(i)(1:LenIn) = LblCnt4(i)(1:LenIn)
  !end do

  !--------------------------------------------------------------------*
  !   Initialize bond order vector                                     *
  !--------------------------------------------------------------------*

  NPBonds = tNUC*(tNUC-1)/2
  call mma_allocate(Bonds,NPBonds,label='Bonds')
  Bonds(:) = Zero

  !--------------------------------------------------------------------*
  !   End of Bond analysis initialization                              *
  !--------------------------------------------------------------------*

end if

!----------------------------------------------------------------------*
!     Compute Mulliken atomic charges for each center and basis        *
!     function type                                                    *
!----------------------------------------------------------------------*

NDIM = NXTYP*NNUC
call FZero(QQ,nDim)
IB = 0
IS = 0
IMO = 0
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  if (NB /= 0) then
    IMN = 0
    do MY=1,NB
      do NY=1,MY
        IMN = IMN+1
        DMN = Zero
        ISMO = IMO
        do IO=1,NB
          DMN = DMN+OCCN(IO+IB)*CMO(ISMO+MY)*CMO(ISMO+NY)
          ISMO = ISMO+NB
        end do

        if (DoBond) then
          !  Save the Density matrix element (my,ny) and (ny,my) in D_tmp
          !  Save the Overlap matrix element (my,ny) and (ny,my) in S_tmp
          D_tmp(NY+IB,MY+IB) = DMN
          D_tmp(MY+IB,NY+IB) = DMN
          S_tmp(NY+IB,MY+IB) = SMAT(IMN+IS)
          S_tmp(MY+IB,NY+IB) = SMAT(IMN+IS)
        end if

        if (MY /= NY) DMN = Two*DMN
        MYNUC = ICNT(MY+IB)
        NYNUC = ICNT(NY+IB)
        MYTYP = ITYP(MY+IB)
        NYTYP = ITYP(NY+IB)
        if (MY == NY) then
          TERM = SMAT(IMN+IS)*DMN
          if (MYNUC > 0) QQ(MYTYP,MYNUC) = QQ(MYTYP,MYNUC)+TERM
        else
          TERM = Half*SMAT(IMN+IS)*DMN
          if (MYNUC > 0) QQ(MYTYP,MYNUC) = QQ(MYTYP,MYNUC)+TERM
          if (NYNUC > 0) QQ(NYTYP,NYNUC) = QQ(NYTYP,NYNUC)+TERM
        end if
      end do
    end do
    IB = IB+NB
    IS = IS+(NB+NB**2)/2
    IMO = IMO+NB**2
  end if
end do

call mma_deallocate(ITYP)

!----------------------------------------------------------------------*
!     Density and overlap matrix handling for bond order               *
!----------------------------------------------------------------------*
if (DoBond) then

# ifdef _DEBUGPRINT_
  call RecPrt('Density Matrix = ',' ',D_tmp,NBAST,NBAST)
  call RecPrt('Overlap Matrix = ',' ',S_tmp,NBAST,NBAST)
  E = Zero
  do I=1,NBAST
    do J=1,NBAST
      E = E+D_tmp(I,J)*S_tmp(I,J)
    end do
  end do
  write(u6,*)
  write(u6,*) 'Number of electrons as sum of D and S elements = ',E
# endif

  ! In case of symmetry, we desymmetrize D and S through D_blo and S_blo
  if (nSym > 1) then
    iBlo = 0
    iSum = 0
    do i=1,NSYM
      if (nbas(i) /= 0) then
        do j=1,nbas(i)
          do k=1,nbas(i)
            iBlo = iBlo+1
            D_blo(iBlo) = D_tmp(k+iSum,j+iSum)
            S_blo(iBlo) = S_tmp(k+iSum,j+iSum)
          end do
        end do
        iSum = iSum+nbas(i)
      end if
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*) 'D_blo = '
    do i=1,nBas2
      write(u6,*) D_blo(I)
    end do
    write(u6,*) 'S_blo = '
    do i=1,nBas2
      write(u6,*) S_blo(I)
    end do
#   endif

    nScr = MXBAS*NBAST
    iSyLbl = 1
    call mma_allocate(Scr,nScr,label='Scr')
    call Desymmetrize(D_blo,nBas2,Scr,nScr,D,nBas,NBAST,P,nSym,iSyLbl)

    call Desymmetrize(S_blo,nBas2,Scr,nScr,S,nBas,NBAST,PInv,nSym,iSyLbl)
    call mma_deallocate(Scr)

  ! Otherwise we simply copy D and S tmp into D and S

  else
    D(:,:) = D_tmp(:,:)
    S(:,:) = S_tmp(:,:)
  end if

# ifdef _DEBUGPRINT_
  write(u6,*) 'After Desymmetrization'
  !call RecPrt('Density Matrix = ', ' ',D,NBAST,NBAST)
  !call RecPrt('Overlap Matrix = ', ' ',S,NBAST,NBAST)
  write(u6,*) 'Dens=',DDot_(nBast**2,D,1,D,1),DDot_(nBast**2,D,1,[One],0)
  write(u6,*) 'Ovrl=',DDot_(nBast**2,S,1,S,1),DDot_(nBast**2,S,1,[One],0)
  write(u6,*) 'DO  =',DDot_(nBast**2,S,1,D,1)
  E = Zero
  do I=1,NBAST
    do J=1,NBAST
      E = E+D(I,J)*S(I,J)
    end do
  end do
  write(u6,*)
  write(u6,*) 'Number of electrons as sum of D by S elements = ',E
# endif

  ! Finally, we compute the DS matrix as product of D and S

  call DGEMM_('N','N',NBAST,NBAST,NBAST,One,D,NBAST,S,NBAST,Zero,DS,NBAST)

# ifdef _DEBUGPRINT_
  call RecPrt('DS Matrix = ',' ',DS,NBAST,NBAST)
  E = Zero
  do I=1,NBAST
    E = E+DS(I,I)
  end do
  write(u6,*)
  write(u6,*) 'Number of electrons as sum of the DS diagonal = ',E
# endif

  ! in case of first call for UHF we dump everything only

  if (iCase == 0) then
    DSSwap(:,:) = DS(:,:)
  end if

  ! in case of second call for UHF we add what dumped before and release swap memory

  if (iCase == 1) then
    DS(:,:) = DS(:,:)+DSSwap(:,:)
    call mma_deallocate(DSSwap)

#   ifdef _DEBUGPRINT_
    call RecPrt('DS Matrix = ',' ',DS,NBAST,NBAST)
    E = Zero
    do I=1,NBAST
      E = E+DS(I,I)
    end do
    write(u6,*)
    write(u6,*) 'Number of electrons as sum of the DS diagonal = ',E
#   endif

  end if

end if

!----------------------------------------------------------------------*
!     Compute gross atomic charges                                     *
!----------------------------------------------------------------------*

call mma_allocate(QSUM,nNuc,label='QSUM')
call mma_allocate(QSUM_TOT,nNuc,label='QSUM_TOT')

do I=1,NNUC
  QSUMI = Zero
  do J=1,NXTYP
    QSUMI = QSUMI+QQ(J,I)
  end do
  QSUM(I) = QSUMI
end do
! if iCase=0, or 1 we need to put/get QSUM
do i=1,NNUC
  if (iCase == 0) qSwap(i) = QSUM(I)
  if (iCase == 1) QSUM_TOT(I) = QSUM(I)+qSwap(i)
  if (iCase >= 2) QSUM_TOT(I) = QSUM(I)
end do

!----------------------------------------------------------------------*
!     Pick up the nuclear charge                                       *
!----------------------------------------------------------------------*

if (iCase /= 0) then
  call mma_allocate(Charge,nNuc,label='Charge')
  call Get_dArray('Effective nuclear charge',Charge,nNuc)
  do iNuc=1,nNuc
    Charge(iNuc) = Charge(iNuc)*(nSym/nStab(iNuc))
  end do
  call DaXpY_(nNuc,-One,QSUM_TOT,1,Charge,1)
end if

call mma_deallocate(nStab)

!----------------------------------------------------------------------*
!     Compute the 'Mulliken' Bond Order                                *
!----------------------------------------------------------------------*

if (DoBond .and. (tNUC > 1) .and. (iCase >= 1)) then

# ifdef _DEBUGPRINT_
  write(u6,*) 'nPBonds,tNuc=',nPBonds,tNuc
  do MY=1,NBAST
    AtomA = iCenter(MY)
    write(u6,*) 'AtomA,My=',AtomA,My
  end do
# endif
  do MY=1,NBAST
    AtomA = iCenter(MY)
    if (ICNT(MY) <= 0) cycle    ! skip pseudo center
    do NY=1,MY
      AtomB = iCenter(NY)
      if (ICNT(NY) <= 0) cycle  ! skip pseudo center
      if (AtomA == AtomB) cycle ! same atom

      iPair = (max(AtomA,AtomB)-1)*(max(AtomA,AtomB)-2)/2+min(AtomA,AtomB)

      Bonds(iPair) = Bonds(iPair)+DS(MY,NY)*DS(NY,MY)

#     ifdef _DEBUGPRINT_
      write(u6,*) 'Bond Number=',iPair
      write(u6,*) 'Atom numbers = ',AtomA,AtomB
      write(u6,*) 'Bond number = ',iPair,'bond order = ',Bonds(iPair)
      write(u6,*) 'DS(MY,NY) =',DS(MY,NY)
      write(u6,*) 'DS(NY,MY) =',DS(NY,MY)
#     endif
    end do
  end do

  ! distant atoms could have negative bond order, set to zero

  do I=1,NPBonds
    if (Bonds(I) < Zero) Bonds(I) = Zero
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) 'Bond order vector'
  call TriPrt('Bonds','(10F10.5)',Bonds,tNUC-1)
# endif

end if

!----------------------------------------------------------------------*
!     Printout section                                                 *
!----------------------------------------------------------------------*

if (iCase == 0) then
  ! first call for UHF, so just dump numbers to swap
  IEND = 0
  ik = 0
  do IST=1,NNUC,6
    IEND = min(IEND+6,NNUC)
    do IT=1,NXTYP
      do j=IST,IEND
        ik = ik+1
        qSwap(NNUC+ik) = QQ(IT,J)
      end do
    end do
  end do
end if

if ((iCase == 1) .and. (iPL >= 2)) then
  ! second call, make a real print out
  call mma_allocate(Q2,nNuc,label='Q2')
  if (FullMlk) then
    write(u6,'(6X,A)') 'Mulliken charges per centre and basis function type'
    write(u6,'(6X,A)') '---------------------------------------------------'
  else
    write(u6,'(6X,A)') 'Mulliken charges per centre'
    write(u6,'(6X,A)') '---------------------------'
  end if
  IEND = 0
  ik = 0
  ikk = 0
  do IST=1,nNuc,6
    IEND = min(IEND+6,nNuc)
    write(u6,*)
    write(u6,'(14X,6(14X,A,4X))') (CNAME(I),I=IST,IEND)
    write(u6,'(14X,6(A12,A12))') (' alpha','  beta',I=IST,IEND)
    do IT=1,NXTYP
      do J=IST,IEND
        ik = ik+1
        Q2(J) = qSwap(NNUC+ik)
      end do
      if (FullMlk) then
        write(u6,'(5X,A8,12F12.4)') Clean_BName(tName(IT),0),(Fac(j)*Q2(J),Fac(j)*QQ(IT,J),J=IST,IEND)
      end if
    end do

    do J=IST,IEND
      ikk = ikk+1
      Q2(J) = qSwap(ikk)
    end do

    write(u6,'(6X,A,12F12.4)') 'Total  ',(Fac(i)*Q2(I),Fac(i)*QSUM(I),I=IST,IEND)
    write(u6,'(6X,A,6(6X,F12.4,6X))') 'Total  ',(Fac(i)*(Q2(I)+QSUM(I)),I=IST,IEND)
    write(u6,*)
    write(u6,'(6X,A,6(5X,F12.4,7X))') 'Charge ',(Fac(i)*Charge(I),I=IST,IEND)
  end do
  write(u6,*)
  !Write(u6,'(6X,A,F12.6)') 'Total electronic charge=',DDot_(nNuc,[One],0,QSum_TOT,1)
  write(u6,*)
  !Write(u6,'(6X,A,F12.6)') 'Total            charge=',DDot_(nNuc,[One],0,Charge,1)
  call mma_deallocate(Q2)

end if
if (iCase == 1) then
  call mma_deallocate(Charge)
  call mma_deallocate(qSwap)
end if

call mma_deallocate(QSUM_TOT)

if (((iCase == 2) .or. (iCase == 3)) .and. (iPL >= 2)) then
  ! icase=2 for usual mulliken, =2 for spin population.

  if (FullMlk) then
    if (iCase == 2) then
      write(u6,'(6X,A)') 'Mulliken charges per centre and basis function type'
    else
      write(u6,'(6X,A)') 'Mulliken spin population per centre and basis function type'
    end if
    write(u6,'(6X,A)') '---------------------------------------------------'
  else
    if (iCase == 2) then
      write(u6,'(6X,A)') 'Mulliken charges per centre'
    else
      write(u6,'(6X,A)') 'Mulliken spin population per centre'
    end if
    write(u6,'(6X,A)') '---------------------------'
  end if

  IEND = 0
  do IST=1,nNuc,12
    IEND = min(IEND+12,nNuc)
    write(u6,*)
    write(u6,'(14X,12(2X,A))') (CNAME(I),I=IST,IEND)
    if (FullMlk) then
      do IT=1,NXTYP
        write(u6,'(5X,A8,12F8.4)') Clean_BName(tName(IT),0),(Fac(j)*QQ(IT,J),J=IST,IEND)
      end do
    end if
    write(u6,'(6X,A,12F8.4)') 'Total  ',(Fac(i)*QSUM(I),I=IST,IEND)
    if (iCase /= 3) then
      write(u6,*)
      !write(u6,'(6X,A,12F8.4)')'N-E    ',(Fac(i)*Charge(I),I=IST,IEND)
    end if
  end do
  if (iCase == 3) then
    write(u6,*)
    !write(u6,'(6X,A,F12.6)') 'Total electronic spin=',DDot_(nNuc,[One],0,QSum,1)
  else
    write(u6,*)
    !write(u6,'(6X,A,F12.6)') 'Total electronic charge=',DDot_(nNuc,[One],0,QSum,1)
    write(u6,*)
    !TCh = DDot_(nNuc,[One],0,Charge,1)
    !write(u6,'(6X,A,F12.6)') 'Total            charge=',DDot_(nNuc,[One],0,Charge,1)
    !call xml_dDump('FormalCharge','Total charge','a.u',0,TCh,1,1)
  end if
end if
if (iCase >= 2) then
  call mma_deallocate(Charge)
end if

call mma_deallocate(Fac)
call mma_deallocate(CNAME)
call mma_deallocate(QSUM)

!  Mulliken bond order print

if (iPL > 2) then
  if ((iCase >= 1) .and. (iCase <= 2) .and. (tNUC > 1) .and. DoBond) then
    write(u6,*)
    write(u6,'(6X,A)') 'Mulliken Bond Order analysis'
    write(u6,'(6X,A)') '----------------------------'
    write(u6,'(6X,A,F5.3,A)') 'Only bonds with order larger than ',BOThrs,' are printed'
    write(u6,*)
    if (nSym > 1) then
      write(u6,'(8X,A)') 'Atom A:Gen.   Atom B:Gen.   Bond Order'
    else
      write(u6,'(8X,A)') 'Atom A        Atom B        Bond Order'
    end if
    do I=1,tNUC-1
      do J=I+1,tNUC
        iPair = (J-1)*(J-2)/2+I
        BO = Bonds(iPair)
        if (BO >= BOThrs) then
          write(u6,'(8X,2(A,4X),F7.3)') LblCnt4(I),LblCnt4(J),BO
        end if
      end do
    end do
    write(u6,*)
  end if
end if

if (DoBond) then
  if (nSym > 1) then
    call mma_deallocate(P)
    call mma_deallocate(PInv)
    call mma_deallocate(D_blo)
    call mma_deallocate(S_blo)
    call mma_deallocate(LblCnt4)
  end if
  call mma_deallocate(iCenter)
  call mma_deallocate(D_tmp)
  call mma_deallocate(S_tmp)
  call mma_deallocate(D)
  call mma_deallocate(S)
  call mma_deallocate(DS)
  call mma_deallocate(Bonds)
end if

call mma_deallocate(tName)
call mma_deallocate(ICNT)

return

!----------------------------------------------------------------------*
!     Error Exits                                                      *
!----------------------------------------------------------------------*

!write(u6,'(/6X,A)') 'Warning: Total charge is not equal to number of electrons'
!call Abend()

end subroutine One_CHARGE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Stefano Battaglia                                *
!***********************************************************************

! Load the CI vector of state Istate from LUCIEX into memory
subroutine loadCI(CI,Istate)

use caspt2_global, only: IDCIEX, LUCIEX
use caspt2_module, only: nConf
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: CI(Nconf)
integer(kind=iwp), intent(in) :: Istate
integer(kind=iwp) :: ID

! Load the CI array
ID = IDCIEX(ISTATE)
call ddafile(LUCIEX,2,CI,Nconf,ID)

end subroutine loadCI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014-2016, Steven Vancoillie                           *
!               2015,2020, Ignacio Fdez. Galvan                        *
!               2015, Liviu Ungur                                      *
!***********************************************************************
! stdalloc: wraps the standard allocate/deallocate Fortran intrinsics.
!
! When memory is allocated, it is registered to getmem, and when it is
! deallocated it is excluded. On allocation, a check is made that the
! available memory as reported by getmem is sufficient. Thus, all memory
! allocated here counts towards the maximum allowed by getmem.
!
! To add additional data types or dimensions, just include the file
! "mma_allo_template.fh" with appropriate values for the macros:
!   _SUBR_NAME_: The base name for the subroutines
!   _DATA_NAME_: The data type string for getmem: 'REAL' for real(kind=wp),
!                'INTE' for integer(kind=iwp), undefined for anything else
!                ['CHAR' would only be appropriate for character(len=1)]
!   _DEF_LABEL_: The default label
!   _TYPE_: The data type
!   _DIMENSIONS_: The number of dimensions
! See the end of this file.
!
! Once defined, use:
!
! * call mma_allocate(array,n1,...,nk)
!     - array:     An allocatable array of k dimensions, or an allocatable string
!     - n1,...,nk: Size of each dimension (variable number of arguments)
!                  They can be all integers, or all arrays of two integers (lower and upper bound)
!     Optional arguments:
!     - label:     Name with which to identify the array, in case of problems
!     - safe:      If present, nothing will happen if array is already allocated (otherwise it's in error)
!
! * call mma_deallocate(array)
!     Optional arguments:
!     - safe:      If present, nothing will happen if array is already deallocated (otherwise it's in error)
!
! Steven Vancoillie, December 2014
! Ignacio Fdez. Galvan, April 2015 (added label optional arg. and _lim variants)
! Liviu Ungur, May 2015 (added support for COMPLEX*16)
! Ignacio Fdez. Galvan, November 2020 (rewrote with preprocessor templates)

!#define _ENABLE_POINTERS_
module stdalloc

use, intrinsic :: iso_fortran_env, only: int32
use Definitions, only: wp, iwp, byte, u6, ItoB, RtoB

implicit none
private

integer(kind=iwp) :: MxMem

interface mma_allocate
  ! 0D allocate
  module procedure :: cmma_allo_0D
  ! 1D allocate
  module procedure :: bmma_allo_1D, bmma_allo_1D_lim, cmma_allo_1D, cmma_allo_1D_lim, dmma_allo_1D, dmma_allo_1D_lim, &
                      i4mma_allo_1D, i4mma_allo_1D_lim, imma_allo_1D, imma_allo_1D_lim, lmma_allo_1D, lmma_allo_1D_lim, &
                      zmma_allo_1D, zmma_allo_1D_lim
# ifdef _ENABLE_POINTERS_
  module procedure :: dpmma_allo_1D, dpmma_allo_1D_lim, ipmma_allo_1D, ipmma_allo_1D_lim
# endif
  ! 2D allocate
  module procedure :: bmma_allo_2D, bmma_allo_2D_lim, cmma_allo_2D, cmma_allo_2D_lim, dmma_allo_2D, dmma_allo_2D_lim, &
                      imma_allo_2D, imma_allo_2D_lim, lmma_allo_2D, lmma_allo_2D_lim, zmma_allo_2D, zmma_allo_2D_lim
  ! 3D allocate
  module procedure :: dmma_allo_3D, dmma_allo_3D_lim, imma_allo_3D, imma_allo_3D_lim, zmma_allo_3D, zmma_allo_3D_lim
  ! 4D allocate
  module procedure :: dmma_allo_4D, dmma_allo_4D_lim, imma_allo_4D, imma_allo_4D_lim, zmma_allo_4D, zmma_allo_4D_lim
  ! 5D allocate
  module procedure :: dmma_allo_5D, dmma_allo_5D_lim, imma_allo_5D, imma_allo_5D_lim, zmma_allo_5D, zmma_allo_5D_lim
  ! 6D allocate
  module procedure :: dmma_allo_6D, dmma_allo_6D_lim
  ! 7D allocate
  module procedure :: dmma_allo_7D, dmma_allo_7D_lim
end interface

interface mma_deallocate
  ! 0D deallocate
  module procedure :: cmma_free_0D
  ! 1D deallocate
  module procedure :: bmma_free_1D, cmma_free_1D, dmma_free_1D, i4mma_free_1D, imma_free_1D, lmma_free_1D, zmma_free_1D
# ifdef _ENABLE_POINTERS_
  module procedure :: dpmma_free_1D, ipmma_free_1D
# endif
  ! 2D deallocate
  module procedure :: bmma_free_2D, cmma_free_2D, dmma_free_2D, imma_free_2D, lmma_free_2D, zmma_free_2D
  ! 3D deallocate
  module procedure :: dmma_free_3D, imma_free_3D, zmma_free_3D
  ! 4D deallocate
  module procedure :: dmma_free_4D, imma_free_4D, zmma_free_4D
  ! 5D deallocate
  module procedure :: dmma_free_5D, imma_free_5D, zmma_free_5D
  ! 6D deallocate
  module procedure :: dmma_free_6D
  ! 7D deallocate
  module procedure :: dmma_free_7D
end interface

public :: mma_allocate, mma_deallocate, mma_double_allo, mma_double_free, mma_maxBYTES, mma_maxDBLE, mma_maxINT, mma_oom, mxMem

contains

#include "warnings.h"

! out-of-memory handling
subroutine mma_oom(label,bufsize,mma_avail)

  character(len=*), intent(in) :: label
  integer(kind=iwp), intent(in) :: bufsize, mma_avail
  integer(kind=iwp) :: iDum

  iDum = 0
  call getmem('Finish','LIST','REAL',iDum,0)
  write(u6,'(1x,a)') '?mma_allo_?D: error: out-of-memory'
  write(u6,'(1x,a,a)') 'label: ',trim(label)
  write(u6,'(1x,a,1x,i12)') ' available (kB):',nint(mma_avail*1.0e-3_wp)
  write(u6,'(1x,a,1x,i12)') ' required  (kB):',nint(bufsize*1.0e-3_wp)
  call quit(_RC_MEMORY_ERROR_)

end subroutine mma_oom

! double allocation/deallocation handling
subroutine mma_double_allo(label)

  character(len=*), intent(in) :: label

  write(u6,'(1x,a)') '?mma_allo_?D: error: double allocate'
  write(u6,'(1x,a,a)') 'label: ',trim(label)
  call quit(_RC_MEMORY_ERROR_)

end subroutine mma_double_allo

subroutine mma_double_free(label)

  character(len=*), intent(in) :: label

  write(u6,'(1x,a)') '?mma_free_?D: error: double deallocate'
  write(u6,'(1x,a,a)') 'label: ',trim(label)
  call quit(_RC_MEMORY_ERROR_)

end subroutine mma_double_free

subroutine mma_maxDBLE(mma_avail)

  integer(kind=iwp), intent(out) :: mma_avail
  integer(kind=iwp), external :: mma_avmem

  mma_avail = mma_avmem()/RtoB

end subroutine mma_maxDBLE

subroutine mma_maxINT(mma_avail)

  integer(kind=iwp), intent(out) :: mma_avail
  integer(kind=iwp), external :: mma_avmem

  mma_avail = mma_avmem()/ItoB

end subroutine mma_maxINT

subroutine mma_maxBYTES(mma_avail)

  integer(kind=iwp), intent(out) :: mma_avail
  integer(kind=iwp), external :: mma_avmem

  mma_avail = mma_avmem()

end subroutine mma_maxBYTES

#define _IN_STDALLOC_MOD_

! type-specific allocation subroutines
! each #include defines NAME_allo_xD, NAME_allo_xD_lim, and NAME_free_xD

! real(kind=wp) variants

#define _SUBR_NAME_ dmma
#define _TYPE_ real(kind=wp)
#define _DATA_NAME_ 'REAL'

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'dmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'dmma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'dmma_3D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 4
#  define _DEF_LABEL_ 'dmma_4D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 5
#  define _DEF_LABEL_ 'dmma_5D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 6
#  define _DEF_LABEL_ 'dmma_6D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 7
#  define _DEF_LABEL_ 'dmma_7D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_
#undef _DATA_NAME_

! complex(kind=wp) variants
! (note that there is no specific _DATA_NAME_ for these)

#define _SUBR_NAME_ zmma
#define _TYPE_ complex(kind=wp)

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'zmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'zmma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'zmma_3D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 4
#  define _DEF_LABEL_ 'zmma_4D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 5
#  define _DEF_LABEL_ 'zmma_5D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_

! integer(kind=iwp) variants

#define _SUBR_NAME_ imma
#define _TYPE_ integer(kind=iwp)
#define _DATA_NAME_ 'INTE'

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'imma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'imma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'imma_3D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 4
#  define _DEF_LABEL_ 'imma_4D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 5
#  define _DEF_LABEL_ 'imma_5D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_
#undef _DATA_NAME_

#ifdef _I8_
! integer(kind=int32) variants

#define _SUBR_NAME_ i4mma
#define _TYPE_ integer(kind=int32)
#define _DATA_NAME_ 'INTE'

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'i4mma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_
#undef _DATA_NAME_

#endif

! byte variants

#define _SUBR_NAME_ bmma
#define _TYPE_ integer(kind=byte)

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'bmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'bmma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_

! character variants
! (no _DATA_NAME_ defined to make sure size is counted in bytes)

#define _SUBR_NAME_ cmma

#define _TYPE_ character(len=:)

#  define _DIMENSIONS_ 0
#  define _DEF_LABEL_ 'cmma_0D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _TYPE_

#define _TYPE_ character(len=*)

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'cmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'cmma_2D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _TYPE_

#undef _SUBR_NAME_

! logical(kind=iwp) variants
! (note that there is no specific _DATA_NAME_ for these)

#define _SUBR_NAME_ lmma
#define _TYPE_ logical(kind=iwp)

#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'lmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#  define _DIMENSIONS_ 2
#  define _DEF_LABEL_ 'lmma_1D'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_

#undef _SUBR_NAME_
#undef _TYPE_

#ifdef _ENABLE_POINTERS_
! pointer variants

#define _IS_POINTER_

#  define _SUBR_NAME_ ipmma
#  define _TYPE_ integer(kind=iwp)
#  define _DATA_NAME_ 'INTE'

#    define _DIMENSIONS_ 1
#    define _DEF_LABEL_ 'ipmma_1D'
#    include "mma_allo_template.fh"
#    undef _DIMENSIONS_
#    undef _DEF_LABEL_

#  undef _SUBR_NAME_
#  undef _TYPE_
#  undef _DATA_NAME_

#  define _SUBR_NAME_ dpmma
#  define _TYPE_ real(kind=wp)
#  define _DATA_NAME_ 'REAL'

#    define _DIMENSIONS_ 1
#    define _DEF_LABEL_ 'dpmma_1D'
#    include "mma_allo_template.fh"
#    undef _DIMENSIONS_
#    undef _DEF_LABEL_

#  undef _SUBR_NAME_
#  undef _TYPE_
#  undef _DATA_NAME_

#undef _IS_POINTER_
#endif

end module stdalloc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mxdiag_cvb(a,eigval,n)
      implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
      dimension a(n,n),eigval(n)

      itmp = mstackr_cvb(n*3)
      call dsyev_('V','L',n,a,n,eigval,work(itmp),n*3,ierr)
      call mfreer_cvb(itmp)
      if(ierr.ne.0)then
        write(6,*)' Fatal error in mxdiag, ierr :',ierr
        call abend_cvb()
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!***********************************************************************

subroutine ICPCK(ICSPCK,L,ICASE)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: ICSPCK(*)
integer(kind=iwp), intent(in) :: L, ICASE
integer(kind=iwp) :: IPOW, MY

!INTW = ICSPCK((L+14)/15)
!IPOW = 2**(28-2*mod(L-1,15))
!INTW = INTW+ICASE*IPOW
!ICSPCK((L+14)/15) = INTW
MY = (L+14)/15
IPOW = 2**(28-2*mod(L-1,15))
ICSPCK(MY) = ICSPCK(MY)+ICASE*IPOW

return

end subroutine ICPCK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Roland Lindh                                     *
!***********************************************************************

subroutine IniBuf(nDisc,nCore)
!***********************************************************************
!                                                                      *
!  Object: Initiate I/O buffer for semi-direct SCF                     *
!                                                                      *
! Called from:                                                         *
!                                                                      *
! Calling    :                                                         *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chemical Physics,                 *
!             University of Lund, Sweden. October '98                  *
!***********************************************************************

use IOBUF, only: Buffer, DiskMx_Byte, InCore, lBuf, LuTmp, nBuf, OnDisk
use stdalloc, only: mma_allocate, mma_maxDBLE
use Constants, only: Two, Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDisc
integer(kind=iwp), intent(inout) :: nCore
integer(kind=iwp) :: MaxMem, MemMin_Seward, MemReq
integer(kind=iwp), external :: AllocDisk

! Open file for semi-direct implementation
! nDisc in units of MByte
! nCore in units of kByte

! The maximum number of bytes on disk. The file size limit times
! the number of multi files.

DiskMx_Byte = real(AllocDisk(),kind=wp)*Ten*Two**20

nBuf = -99
if ((nDisc == 0) .and. (nCore == 0)) then
  OnDisk = .false.
  Incore = .false.
else if (nDisc*1024 > nCore) then
  OnDisk = .true.
  Incore = .false.
  LuTMp = 32
  call EAFOpen(LuTmp,'SMDINT  ')
  nBuf = 2
else
  OnDisk = .false.
  InCore = .true.
  nBuf = 1
end if

! Adjust buffer size and allocate memory for the buffer.

if (OnDisk .or. InCore) then
  MemMin_Seward = 1024**2 ! Real
  call mma_maxDBLE(MaxMem)
  ! lBuf in units of Real per buffer
  lBuf = (1024*nCore)/(8*nBuf)
  if (InCore) then
    MemReq = MemMin_Seward+lBuf*nBuf
    !write(u6,*) 'MemReq,MaxMem=',MemReq,MaxMem,'  lbuf=',lbuf
    if (MemReq > MaxMem) then
      lBuf = (MaxMem-MemMin_Seward)/nBuf
      if (lBuf < 0) then
        nCore = (((MaxMem*3)/4)*8)/1024
      else
        nCore = (lBuf*8)/1024
      end if
    else
      nCore = (lBuf*8)/1024
    end if
    nCore = ((nCore+7)/8)*8
    lBuf = (1024*nCore)/(8*nBuf)
  end if
  !write(u6,*) 'OnDisk=',OnDisk
  !write(u6,*) 'Incore=',Incore
  !write(u6,*) 'nBuf=',nBuf
  !write(u6,*) 'IniBuf: nDisc=',nDisc,'MByte'
  !write(u6,*) 'nCore=',nCore,'kByte'
  !write(u6,*) 'lBuf=',lBuf

  ! Allocate I/O Buffer
  call mma_allocate(Buffer,lBuf,nBuf,Label='Buffer')
end if

end subroutine IniBuf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1995, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine XRys2D(xyz2D,nArg,lRys,nabMax,ncdMax,PAWP,QCWQ,
     &                 B10,laa,B00,lac,B01,lcc)
************************************************************************
*                                                                      *
* Object: to compute the 2-dimensional integrals of the Rys            *
*         quadrature. The z components are assumed to be pre-          *
*         conditioned with the weights of the roots of the             *
*         Rys polynomial.                                              *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
* Modified loop structure for RISC 1991 R. Lindh Dept. of Theoretical  *
* Chemistry, University of Lund, Sweden.                               *
* Modified for external field version, Feb '95.                        *
* VV: improve loop structure                                           *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 xyz2D(nArg*lRys*3,0:nabMax,0:ncdMax),
     &       PAWP(nArg*lRys*3), QCWQ(nArg*lRys*3),
     &       B10(nArg*lRys*3), B00(nArg*lRys*3), B01(nArg*lRys*3)
#ifdef _DEBUGPRINT_
      Character*30 Label
#endif
*
      iRout = 15
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      If (iPrint.ge.59) Then
         If (nabMax.gt.0) Call RecPrt('PAWP',' ',PAWP,nArg,lRys*3)
         If (ncdMax.gt.0) Call RecPrt('QCWQ',' ',QCWQ,nArg,lRys*3)
         If (laa.ne.0) Call RecPrt(' B10',' ',B10,nArg*lRys,3)
         If (lac.ne.0) Call RecPrt(' B00',' ',B00,nArg*lRys,3)
         If (lcc.ne.0) Call RecPrt(' B01',' ',B01,nArg*lRys,3)
      End If
#endif
*
*     Compute 2D integrals with index (0,0). Observe that the z
*     component already contains the weight factor.
*
      call dcopy_(2*nArg*lRys,[One],0,xyz2D(1,0,0),1)
*
*---- Span first I(i,0)
*
      If (nabMax.ge.1) Then
         Do i = 1, nArg*lRys*3
            xyz2D(i,1,0) = PAWP(i)*xyz2D(i,0,0)
         End Do
      End If
      Do iab = 1, nabMax-1
         Do i = 1, nArg*lRys*3
            xyz2D(i,iab+1,0) = PAWP(i)*xyz2D(i,iab,0)
     &                       + Dble(iab)*B10(i)*xyz2D(i,iab-1,0)
         End Do
      End Do
*
*---- Now do the rest!
*
      If (ncdMax.ge.1) Then
         Do i = 1, nArg*lRys*3
            xyz2D(i,0,1)=QCWQ(i)*xyz2D(i,0,0)
         End Do
         Do iab = 1, nabMax
            Do i = 1, nArg*lRys*3
               xyz2D(i,iab,1)=QCWQ(i)*xyz2D(i,iab,0)
     &                       +Dble(iab)*B00(i)*xyz2D(i,iab-1,0)
            End Do
         End Do
      End If
      Do in = 1, ncdMax-1
         Do i = 1, nArg*lRys*3
            xyz2D(i,0,in+1)=QCWQ(i)*xyz2D(i,0,in)
     &                     -Dble(in)*B01(i)*xyz2D(i,0,in-1)
         End Do
         Do iab = 1, nabMax
            Do i = 1, nArg*lRys*3
               xyz2D(i,iab,in+1)=QCWQ(i)*xyz2D(i,iab,in)
     &                          +Dble(iab)*B00(i)*xyz2D(i,iab-1,in)
     &                          -Dble( in)*B01(i)*xyz2D(i,iab,in-1)
            End Do
         End Do
      End Do
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Write (6,*) ' 2D-integral computed in XRys2D'
         Do 600 iab = 0, nabMax
            Do 610 icd = 0, ncdMax
               Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(x)'
               Call RecPrt(Label,' ',
     &                     xyz2D(1,iab,icd),nArg,lRys)
               Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(y)'
               Call RecPrt(Label,' ',
     &                     xyz2D(1+nArg*lRys,iab,icd),nArg,lRys)
               Write (Label,'(A,I2,A,I2,A)') ' 2D(',iab,',',icd,')(z)'
               Call RecPrt(Label,' ',
     &                     xyz2D(1+2*nArg*lRys,iab,icd),nArg,lRys)
 610        Continue
 600     Continue
      End If
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(laa)
         Call Unused_integer(lac)
         Call Unused_integer(lcc)
      End If
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TransMu(SqMu,nDim,TTot,Temp)
! Transform with TTOT the multipole moment integral matrix

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(inout) :: SqMu(nDim*nDim)
real(kind=wp), intent(in) :: TTot(nDim*nDim)
real(kind=wp), intent(out) :: Temp(nDim*nDim)

!                                                                      *
!***********************************************************************
!                                                                      *
call DGEMM_('N','N',nDim,nDim,nDim,One,SqMu,nDim,TTot,nDim,Zero,Temp,nDim)
call DGEMM_('T','N',nDim,nDim,nDim,One,Ttot,nDim,Temp,nDim,Zero,SqMu,nDim)
!call RecPrt('Overout',' ',SqMu,nDim,nDim)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine TransMu

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine IndSft_RI_2(iCmp,iShell,iBas,jBas,kBas,lBas,
     &                       Shijij, iAO, iAOst, ijkl,SOint,nSOint,
     &                       iSOSym,nSOs,TInt,nTInt,iOff,
     &                       iSO2Ind,iOffA)
************************************************************************
*  object: to sift and index the SO integrals.                         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          april '90                                                   *
*                                                                      *
************************************************************************
      use Basis_Info, only: nBas
      use SOAO_Info, only: iAOtSO
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "srt0.fh"
#include "srt1.fh"
#include "WrkSpc.fh"
*
      Real*8 SOint(ijkl,nSOint), TInt(nTInt)
      Integer iCmp(4), iShell(4), iAO(4), iOffA(4,0:7),
     &        iAOst(4), iSOSym(2,nSOs), iSO2Ind(nSOs)
      Integer iOff(0:7)
      Logical Shijij, qijij
*     local array
      Integer jSym(0:7), lSym(0:7)
#ifdef _DEBUGPRINT_
      Data tr1,tr2/0.0d0,0.0d0/
      Save tr1,tr2
#endif
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      irout = 39
      iprint = nprint(irout)
*                                                                      *
************************************************************************
*                                                                      *
      k12=0
      k34=0
#ifdef _DEBUGPRINT_
      If (iPrint.ge.49) Then
         r1=DDot_(ijkl*nSOInt,SOInt,1,[One],0)
         r2=DDot_(ijkl*nSOInt,SOInt,1,SOInt,1)
         tr1=tr1+r1
         tr2=tr2+r2
         Write (6,*) ' Sum=',r1,tr1
         Write (6,*) ' Dot=',r2,tr2
         Call RecPrt(' in indsft:SOint ',' ',SOint,ijkl,nSOint)
      End If
#endif
      memSO2 = 0
*
*
*     quadruple loop over elements of the basis functions angular
*     description. loops are reduced to just produce unique SO integrals
*     observe that we will walk through the memory in AOint in a
*     sequential way.
*
      i1 = 1
      i3 = 1
      j1 = 0
      j3 = 0
      Do i2 = 1, iCmp(2)
         Do 201 j = 0, nIrrep-1
            ix = 0
            If (iAOtSO(iAO(2)+i2,j)>0) ix = 2**j
            jSym(j) = ix
201      Continue
         If (iShell(2).gt.iShell(1)) then
            i12 = iCmp(2)*(i1-1) + i2
         else
            i12 = iCmp(1)*(i2-1) + i1
         End If
         Do 400 i4 = 1, iCmp(4)
            Do 401 j = 0, nIrrep-1
               ix = 0
               If (iAOtSO(iAO(4)+i4,j)>0) ix = 2**j
               lSym(j) = ix
401         Continue
            If (iShell(4).gt.iShell(3)) then
               i34 = iCmp(4)*(i3-1) + i4
            else
               i34 = iCmp(3)*(i4-1) + i3
            End If
            If (Shijij .and. i34.gt.i12) go to 400
            qijij = Shijij .and. i12.eq.i34
C           Write (6,*) 'i1,i2,i3,i4=',i1,i2,i3,i4
*
*      loop over Irreps which are spanned by the basis function.
*      again, the loop structure is restricted to ensure unique
*      integrals.
*
             Do 210 j2 = 0, nIrrep-1
                If (jSym(j2).eq.0) go to 210
                j12 = ieor(j1,j2)
                If (qijij) then
                   If (iShell(1).gt.iShell(2)) then
                       k12 = nIrrep*j1 + j2+1
                   else
                       k12 = nIrrep*j2 + j1+1
                   End If
                End If
*
                iOffA_= iOffA(1,j2)
                iOffB_= iOffA(3,j2)
                If (j2.ne.0) iOffB_=iOffB_+1
                mm_ = iOffA(4,j2)
                nn  = mm_ - iOffA(2,j2)
                mx  = nn*(nn+1)/2
*
                j4 = ieor(j12,j3)
                If (lSym(j4).eq.0) go to 210
                If (qijij) then
                   If (iShell(3).gt.iShell(4)) then
                      k34 = nIrrep*j3 + j4+1
                   else
                      k34 = nIrrep*j4 + j3+1
                   End If
                   If (k34.gt.k12) go to 210
                End If
*
                memSO2 = memSO2 + 1
                If ( (nSkip(j2+1)+nSkip(j4+1) ).ne.0 ) GoTo 210
*
*               Compute absolute starting SO index
                jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
                lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
*
                nijkl = 0
                Do lSOl = lSO, lSO+lBas-1
                   Do jSOj = jSO, jSO+jBas-1
                      nijkl = nijkl + 1
                      AInt=SOint(nijkl,memSO2)
                      iSO = jSOj-nBas(j2)
                      kSO = lSOl-nBas(j4)
*
                      iSO = iSO2Ind(iSO+iOffB_) + nn
                      ij= iTri(iSO,kSO) - mx + iOffA_
                      TInt(ij)=AInt
*
                   End Do
                End Do
*
210       Continue
*
400      Continue
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iBas)
         Call Unused_integer(kBas)
         Call Unused_integer_array(iSOSym)
         Call Unused_integer_array(iOff)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DetCtl()

use MCLR_Data, only: FnCSF2SD, i12, ICISTR, idc, IDIAG, iST, LuCSF2SD, MS2, NOCSF, NOPART, pINT1, pINT2, PSSIGN
use input_mclr, only: iSpin, nActEl, nElec3, nHole1, nIrrep, nRs1, nRs2, nRs3, nSym, State_Sym
use stdalloc, only: mma_allocate
use Constants, only: Zero, One
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iTmp, MNRS10, MXR4TP, MXRS30, nTRas1, nTRas3

call mma_Allocate(pINT1,nSym,Label='pInt1')
pInt1(:) = 0
call mma_Allocate(pINT2,nSym**3,Label='pInt2')
pInt2(:) = 0

NOCSF = 0
nopart = 0
nIrrep = nSym
mxr4tp = 0
idiag = 1
icistr = 1
ist = 1
i12 = 2
MS2 = iSpin-1
if (ms2 /= 0) then
  idc = 1
  pssign = Zero
else
  itmp = (ispin-1)/2
  pssign = (-One)**itmp
  idc = 2
end if

ntRas1 = sum(nRs1(1:nSym))
ntRas3 = sum(nRs3(1:nSym))
MNRS10 = max(0,2*ntRas1-nHole1)
MXRS30 = max(0,min(2*ntRas3,nElec3))
! From shells to orbitals
call ORBINF_MCLR(nSym,nRs1,nRs2,nRs3,mxr4tp) ! OK
! Number of string types
call STRTYP(ms2,nActEl,MNRS10,MXRS30)  ! looks alright
! Internal string information
call STRINF()  ! looks alright, no!
! Internal subspaces
call ICISPC(MNRS10,MXRS30)  ! looks alright
call ICISPS()  ! looks alright
! CSF information
call DANAME(LUCSF2SD,FNCSF2SD)
call CSFINF(State_sym,iSpin,1,nsym)

end subroutine DetCtl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_mv0v1a3u
     & (rowa,cola,ddx,ddy,
     & nopi,nopj,incx,incy,
     & a,x,y)
C
C     Y(iy) = Y(iy) + A * X(ix)
C
#include "t31.fh"
       integer rowa,cola
       integer ddx, ddy
       integer nopi, nopj, incx, incy
       real*8  a(1:rowa,1:cola)
       real*8  x(1:ddx), y(1:ddy)
C
C      help variables
C
       integer i, j, ix, iy
c
       if (mhkey.eq.1) then
c      ESSL
c@     call  dgemx(nopi,nopj,1.0d0,a,rowa,x,incx,y,incy)
       call dgemv_('N',nopi,nopj,1.0d0,a,rowa,x,incx,1.0d0,y,incy)
C
       else
c      Fortran matrix handling
C
C
       if (incx.eq.1.and.incy.eq.1) then
C
C      Inc's = 1
C
       do 30 j = 1, nopj
       do 20 i = 1, nopi
C
       y(i) = y(i) + a(i,j)*x(j)
 20    continue
 30    continue
C
       else
C
C      Other type inc's
c
       ix = 1
       do 60 j = 1, nopj
       iy = 1
       do 50 i = 1, nopi
       y(iy) = a(i,j)*x(ix) + y(iy)
       iy = iy + incy
 50    continue
       ix = ix + incx
 60    continue
C
       end if
C
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Roland Lindh                                     *
************************************************************************
      SubRoutine CmbnW1(Welp0,Welm0,Wel0p,Wel0m,
     &                  nZeta,la,lb,Zeta,rKappa,Final,Alpha,Beta,
     &                  Grad,nGrad,DAO,IfGrad,IndGrd,iStab,jStab,kOp)
************************************************************************
*                                                                      *
* Object: compute the gradient of the Spherical Well integrals         *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             May '95.                                                 *
************************************************************************
      use Symmetry_Info, only: nIrrep,iChBas
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6),
     &       Zeta(nZeta), rKappa(nZeta), Beta(nZeta),
     &       Welp0(nZeta,(la+2)*(la+3)/2,(lb+1)*(lb+2)/2),
     &       Welm0(nZeta, la   *(la+1)/2,(lb+1)*(lb+2)/2),
     &       Wel0p(nZeta,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2),
     &       Wel0m(nZeta,(la+1)*(la+2)/2, lb   *(lb+1)/2),
     &       Alpha(nZeta), Grad(nGrad),
     &       DAO(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2)
      Logical IfGrad(3,2)
      Integer IndGrd(3,2), kOp(2)
*
*     Statement function for Cartesian index
*
*                     ix*0   added to avoid compiler warning
      Ind(ix,iy,iz) = ix*0 + (iy+iz)*(iy+iz+1)/2 + iz + 1
*
      iRout = 134
      iPrint = nPrint(iRout)
      iQ = 1
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In CmbnW1: Zeta  ',' ',Zeta  ,1,nZeta)
         Call RecPrt(' In CmbnW1: rKappa',' ',rKappa,1,nZeta)
         Call RecPrt(' In CmbnW1: Alpha ',' ',Alpha ,1,nZeta)
         Call RecPrt(' In CmbnW1: Beta  ',' ',Beta  ,1,nZeta)
         np0=(la+2)*(la+3)/2*(lb+1)*(lb+2)/2
         nm0= la   *(la+1)/2*(lb+1)*(lb+2)/2
         n0p=(la+1)*(la+2)/2*(lb+2)*(lb+3)/2
         n0m=(la+1)*(la+2)/2* lb   *(lb+1)/2
         Call RecPrt(' In CmbnW1: Welp0',' ',Welp0,nZeta,np0)
         If (la.ge.1)
     &      Call RecPrt(' In CmbnW1: Welm0',' ',Welm0,nZeta,nm0)
         Call RecPrt(' In CmbnW1: Wel0p',' ',Wel0p,nZeta,n0p)
         If (lb.ge.1)
     &      Call RecPrt(' In CmbnW1: Wel0m',' ',Wel0m,nZeta,n0m)
      End If
*
      tTwo = Two
      nDAO = nZeta * (la+1)*(la+2)/2 * (lb+1)*(lb+2)/2
      Do 10 ixa = 0, la
         iyaMax=la-ixa
      Do 11 ixb = 0, lb
         iybMax=lb-ixb
         Do 20 iya = 0, iyaMax
            iza = la-ixa-iya
            ipa= Ind(ixa,iya,iza)
         Do 21 iyb = 0, iybMax
            izb = lb-ixb-iyb
            ipb= Ind(ixb,iyb,izb)
*
*           Combine Spherical Well integrals
*
            If (IfGrad(1,1)) Then
               ipp0=Ind(ixa+1,iya,iza)
               If (ixa.gt.0) Then
                  xa = -ixa
                  ipm0=Ind(ixa-1,iya,iza)
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,1) =
     &                   (tTwo*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb) +
     &                                   xa*Welm0(iZeta,ipm0,ipb) )
                  End Do
               Else
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,1) =
     &                   (tTwo*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb) )
                  End Do
               End If
            End If
            If (IfGrad(1,2)) Then
               ip0p=Ind(ixb+1,iyb,izb)
               If (ixb.gt.0) Then
                  xb = -ixb
                  ip0m=Ind(ixb-1,iyb,izb)
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,4) =
     &                   (tTwo* Beta(iZeta)*Wel0p(iZeta,ipa,ip0p) +
     &                                   xb*Wel0m(iZeta,ipa,ip0m) )
                  End Do
               Else
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,4) =
     &                   (tTwo* Beta(iZeta)*Wel0p(iZeta,ipa,ip0p) )
                  End Do
               End If
            End If
            If (IfGrad(2,1)) Then
               ipp0=Ind(ixa,iya+1,iza)
               If (iya.gt.0) Then
                  ya = -iya
                  ipm0=Ind(ixa,iya-1,iza)
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,2) =
     &                   (tTwo*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb) +
     &                                   ya*Welm0(iZeta,ipm0,ipb) )
                  End Do
               Else
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,2) =
     &                   (tTwo*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb) )
                  End Do
               End If
            End If
            If (IfGrad(2,2)) Then
               ip0p=Ind(ixb,iyb+1,izb)
               If (iyb.gt.0) Then
                  yb = -iyb
                  ip0m=Ind(ixb,iyb-1,izb)
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,5) =
     &                   (tTwo* Beta(iZeta)*Wel0p(iZeta,ipa,ip0p) +
     &                                   yb*Wel0m(iZeta,ipa,ip0m) )
                  End Do
               Else
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,5) =
     &                   (tTwo* Beta(iZeta)*Wel0p(iZeta,ipa,ip0p) )
                  End Do
               End If
            End If
            If (IfGrad(3,1)) Then
               ipp0=Ind(ixa,iya,iza+1)
               If (iza.gt.0) Then
                  za = -iza
                  ipm0=Ind(ixa,iya,iza-1)
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,3) =
     &                   (tTwo*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb) +
     &                                   za*Welm0(iZeta,ipm0,ipb) )
                  End Do
               Else
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,3) =
     &                   (tTwo*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb) )
                  End Do
               End If
            End If
            If (IfGrad(3,2)) Then
               ip0p=Ind(ixb,iyb,izb+1)
               If (izb.gt.0) Then
                  zb = -izb
                  ip0m=Ind(ixb,iyb,izb-1)
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,6) =
     &                   (tTwo* Beta(iZeta)*Wel0p(iZeta,ipa,ip0p) +
     &                                   zb*Wel0m(iZeta,ipa,ip0m) )
                  End Do
               Else
                  Do iZeta = 1, nZeta
                     Final(iZeta,ipa,ipb,6) =
     &                   (tTwo* Beta(iZeta)*Wel0p(iZeta,ipa,ip0p) )
                  End Do
               End If
            End If
*
 21      Continue
 20      Continue
 11   Continue
 10   Continue
*
*     Trace the gradient integrals
*
      If (iPrint.ge.99) Then
         Call RecPrt(' W(1)',' ',Final,nDAO,6)
         Call RecPrt('   D ',' ',DAO,nDAO,1)
      End If
      Do 100 iCn = 1, 2
         Do 110 iCar = 1, 3
            If (IndGrd(iCar,iCn).ne.0) Then
*              Accumulate contribution to the gradient
               iGrad = Abs(IndGrd(iCar,iCn))
               If (iCn.eq.1) Then
                   i1 = iCar
                   i2 = iCar + 3
                   ps = DBLE( iPrmt( kOp(1), iChBas(1+iCar) ) )
                   Fact = DBLE(iStab)/DBLE(nIrrep)
               Else
                   i1 = iCar + 3
                   i2 = iCar
                   ps = DBLE( iPrmt( kOp(2), iChBas(1+iCar) ) )
                   Fact = ps * DBLE(jStab)/DBLE(nIrrep)
               End if
*              Write (*,*) ' Fact=', Fact, ps
               If (IndGrd(iCar,iCn).lt.0) Then
*                 Gradient via translational invariance.
                  Grad(iGrad) = Grad(iGrad) - Fact*
     &                DDot_(nDAO,DAO,1,Final(1,1,1,i2),1)
               Else
                  Grad(iGrad) = Grad(iGrad) + Fact*
     &                DDot_(nDAO,DAO,1,Final(1,1,1,i1),1)
               End If
            End If
 110     Continue
 100  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_InpMod(Mode)
!
! Thomas Bondo Pedersen, Jan. 2005.
!
! Purpose: modify Cholesky settings for
!          Mode = 'LOW ' : low-accuracy decomposition
!          Mode = 'MEDI' : medium-accuracy decomposition
!          Mode = 'HIGH' : high-accuracy decomposition
!          Mode = '1CCD' : set one-center approximation
!          (All other Mode-values are ignored.)

use Cholesky, only: Cho_1Center, ThrCom
use Definitions, only: wp

implicit none
character(len=4), intent(in) :: Mode
character(len=4) :: Mod2

Mod2 = Mode
call Upcase(Mod2)

if (Mod2(1:3) == 'LOW') then
  ThrCom = 1.0e-4_wp
else if (Mod2(1:4) == 'MEDI') then
  ThrCom = 1.0e-6_wp
else if (Mod2(1:4) == 'HIGH') then
  ThrCom = 1.0e-8_wp
else if (Mod2(1:4) == '1CCD') then
  Cho_1Center = .true.
end if

end subroutine Cho_InpMod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_qlm_utils

use fmm_global_paras, only: INTK, REALK, raw_mm_paras, raw_mm_data, id_list, id_node, One, Two, Half
use fmm_stats, only: stat_pkd_moms_LHS, stat_pkd_moms_rHS, stat_screened_moms_RHS
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_renormalise_qlm, &
          fmm_sort_paras_wrt_centre, &
          fmm_assign_batches, &
          fmm_factor_in_dens, &
          fmm_get_T_sym_qlm, &
          fmm_pack_raw_moments, &
          fmm_pack_raw_parameters

contains

!-------------------------------------------------------------------------------

subroutine fmm_renormalise_qlm(LMAX,qlm)

  implicit none
  integer(INTK), intent(in)  :: LMAX
  real(REALK), intent(inout) :: qlm(:,:)

  integer(INTK) :: i, L, M, p, pp
  real(REALK) :: pref

  ! prefactor to symmetrize T-matrix
  do i=1,size(qlm,2)
    do L=0,LMAX
      pp = L*(L+1)+1
      do M=-L,-1
        pref = -one/(sqrt(two*FACTORIAL(l-m)*FACTORIAL(l+m)))
        p = pp+M
        qlm(p,i) = pref*qlm(p,i)
      end do
      pref = one/FACTORIAL(L)
      p = pp  ! M=0
      qlm(p,i) = pref*qlm(p,i)
      do M=1,L
        pref = ((-1)**m)/sqrt(two*FACTORIAL(l-m)*FACTORIAL(l+m))
        p = pp+M
        qlm(p,i) = pref*qlm(p,i)
      end do
    end do
  end do

contains

real(REALK) function FACTORIAL(n)
  implicit none
  integer(INTK), intent(in) :: n
  integer(INTK) :: i
  FACTORIAL = 1
  do i=n,2,-1
    FACTORIAL = FACTORIAL*i
  end do
end function FACTORIAL

end subroutine fmm_renormalise_qlm

!-------------------------------------------------------------------------------

recursive subroutine fmm_sort_paras_wrt_centre(xyz,paras)

  use fmm_sort_paras, only: fmm_quicksort_wrt_vector

  implicit none
  integer(INTK), intent(in)         :: xyz
  type(raw_mm_paras), intent(inout) :: paras(:)

  integer(INTK) :: i, lo, hi
  real(REALK) :: q1, q2

  if (size(paras) == 1) return

  ! sort only if needed
  q1 = paras(1)%cntr(xyz)
  do i=2,size(paras)
    q2 = paras(i)%cntr(xyz)
    if (q2 < q1) then
      call fmm_quicksort_wrt_vector(paras,xyz)
      exit
    end if
    q1 = q2
  end do

  ! sub-sort next cartesian component
  lo = 1
  do i=2,size(paras)
    q1 = paras(i-1)%cntr(xyz)
    q2 = paras(i)%cntr(xyz)
    if (q2 /= q1) then
      hi = i-1
      if (xyz == 3) then
        return
      else
        call fmm_sort_paras_wrt_centre(xyz+1,paras(lo:hi))
      end if
      lo = i
    end if
  end do

  ! do last batch
  hi = size(paras)
  if (xyz == 3) then
    return
  else
    call fmm_sort_paras_wrt_centre(xyz+1,paras(lo:hi))
  end if

end subroutine fmm_sort_paras_wrt_centre

!-------------------------------------------------------------------------------
! Identify batches of moments with same centre assuming sorted order and
! assign batch index to parameter list

subroutine fmm_assign_batches(paras)

  implicit none
  type(raw_mm_paras), intent(inout) :: paras(:)

  integer(INTK) :: i, batch
  !FIXME
  real(REALK), parameter :: TOLERANCE = 1.0e-20_REALK

  batch = 1
  paras(1)%batch = batch
  do i=2,size(paras)
    if (paras(i)%cntr(3)-paras(i-1)%cntr(3) > TOLERANCE) then
      batch = batch+1
    else if (paras(i)%cntr(2)-paras(i-1)%cntr(2) > TOLERANCE) then
      batch = batch+1
    else if (paras(i)%cntr(1)-paras(i-1)%cntr(1) > TOLERANCE) then
      batch = batch+1
    end if
    paras(i)%batch = batch
  end do

end subroutine fmm_assign_batches

!-------------------------------------------------------------------------------

subroutine fmm_factor_in_dens(dens,qlm)

  implicit none
  real(REALK), intent(in)    :: dens(:)
  real(REALK), intent(inout) :: qlm(:,:)

  integer(INTK) :: i

  do i=1,size(qlm,2)
    qlm(:,i) = qlm(:,i)*dens(i)
  end do

end subroutine fmm_factor_in_dens

!-------------------------------------------------------------------------------
! Prefactorising moments to symmetrize modified T-matrix

subroutine fmm_get_T_sym_qlm(LMAX,qlm_in,qlm_out)

  implicit none
  integer(INTK), intent(in) :: LMAX
  real(REALK), intent(in)   :: qlm_in(:,:)
  real(REALK), intent(out)  :: qlm_out(:,:)

  integer(INTK) :: i, L, u, hi, lo
  real(REALK) :: pref

  do i=1,size(qlm_in,2)
    do L=0,LMAX
      u = L*(L+1)+1     ! m=0
      hi = u+L
      lo = u-L
      pref = two*((-1)**L)
      qlm_out(lo:hi,i) = pref*qlm_in(lo:hi,i)
      qlm_out(u,i) = half*pref*qlm_in(u,i)
    end do
  end do

end subroutine fmm_get_T_sym_qlm

!-------------------------------------------------------------------------------
! Get number of unique batches;
! Also check raw_paras are sorted by batch;
! Do this by checking the batch ID is always increasing

subroutine get_nbatch(paras,nbatch)

  implicit none
  type(raw_mm_paras), intent(in) :: paras(:)
  integer(INTK), intent(out)     :: nbatch
  integer(INTK) :: i, ndim

  ndim = size(paras)
  nbatch = 1
  do i=2,ndim
    if (paras(i)%batch < paras(i-1)%batch) then
      call fmm_quit('batches of packed moments not sorted!')
    end if
    ! some batch numbers are skipped so need to take care of this
    if (paras(i)%batch /= paras(i-1)%batch) then
      nbatch = nbatch+1
    end if
  end do

end subroutine get_nbatch

!-------------------------------------------------------------------------------

subroutine get_pkd_data(add_dens,raw_mms,pkd_paras,pkd_qlm)

  implicit none
  logical, intent(in)             :: add_dens
  type(raw_mm_data), intent(in)   :: raw_mms
  type(raw_mm_paras), intent(out) :: pkd_paras(:)
  real(REALK), intent(out)        :: pkd_qlm(:,:)
  integer(INTK) :: i, j, k, last_batch

  j = 0
  last_batch = -1
  do i=1,size(raw_mms%paras)
    ! Use mapping of raw parameters to raw moments
    k = raw_mms%paras(i)%id
    if (raw_mms%paras(i)%batch == last_batch) then
      ! Element same batch as previous
      if (add_dens) then
        pkd_qlm(:,j) = pkd_qlm(:,j)+raw_mms%qlm(:,k)*raw_mms%dens(k)
      else
        pkd_qlm(:,j) = pkd_qlm(:,j)+raw_mms%qlm(:,k)
      end if
    else
      ! Element in new batch
      j = j+1
      pkd_paras(j) = raw_mms%paras(i)
      if (add_dens) then
        pkd_qlm(:,j) = raw_mms%qlm(:,k)*raw_mms%dens(k)
      else
        pkd_qlm(:,j) = raw_mms%qlm(:,k)
      end if
    end if
    last_batch = raw_mms%paras(i)%batch
  end do

end subroutine get_pkd_data

!-------------------------------------------------------------------------------

subroutine get_screened_nmom(screen_thr,qlm,skip,nskip)

  implicit none
  real(REALK), intent(in)    :: screen_thr
  real(REALK), intent(in)    :: qlm(:,:)
  logical, intent(out)       :: skip(:)
  integer(INTK), intent(out) :: nskip
  integer(INTK) :: i, j

  nskip = 0
  batches: do i=1,size(qlm,2)
    skip(i) = .true.
    nskip = nskip+1
    lm_loop: do j=1,size(qlm,1)
      if (abs(qlm(j,i)) > screen_thr) then
        skip(i) = .false.
        nskip = nskip-1
        exit lm_loop
      end if
    end do lm_loop
  end do batches

end subroutine get_screened_nmom

!-------------------------------------------------------------------------------
! Here we squeeze all the significant batches of moments to be sequential
! at the top of the array, with all the insignificant moments overwritten;
! we use skip(:) as a logical mask to direct the skipping.

subroutine squeeze_significant_batches(skip,paras,qlm)

  implicit none
  logical, intent(in)               :: skip(:)
  type(raw_mm_paras), intent(inout) :: paras(:)
  real(REALK), intent(inout)        :: qlm(:,:)
  integer(INTK) :: i, j

  if (size(paras) /= size(qlm,2)) call fmm_quit('paras and qlm should be same size!')
  if (size(paras) /= size(skip)) call fmm_quit('paras and skip should be same size!')

  j = 0
  do i=1,size(paras)
    if (skip(i)) cycle
    j = j+1
    paras(j) = paras(i)
    qlm(:,j) = qlm(:,i)
  end do

end subroutine squeeze_significant_batches

!-------------------------------------------------------------------------------
! Routine to pack a set of raw moments by batches,
! where members of a batch share a common centre and extent,
! including density factoring and screening if requested.
! Note that no record is kept of the packing for later "unpacking".

subroutine fmm_pack_raw_moments(mm_data,dens,dens_thr)

  implicit none
  type(raw_mm_data), intent(inout) :: mm_data
  logical, intent(in)              :: dens
  real(REALK), intent(in)          :: dens_thr

  type(raw_mm_paras), allocatable :: pkd_paras(:)
  real(REALK), allocatable :: pkd_qlm(:,:)
  logical, allocatable :: skip(:)
  integer(INTK) :: nbatch, nskip, foo, ndim

  ! Get number of unique batches
  call get_nbatch(mm_data%paras,nbatch)

  ! Now build packed data by summing raw data in the same batch
  allocate(pkd_paras(nbatch))
  foo = size(mm_data%qlm,1)
  allocate(pkd_qlm(foo,nbatch))
  call get_pkd_data(dens,mm_data,pkd_paras,pkd_qlm)
  ndim = nbatch

  if (dens) then
    ! Perform density-based screening;
    ! Note we do not reallocate whole array, but push all the
    ! significant terms to the top, and only this array section
    ! of significant moments is then pointed to.
    allocate(skip(nbatch))
    call get_screened_nmom(dens_thr,pkd_qlm,skip,nskip)
    ndim = nbatch-nskip  ! number of significant moments
    call squeeze_significant_batches(skip,pkd_paras,pkd_qlm)
    deallocate(skip)
  end if

  ! This is just for statistics
  stat_pkd_moms_RHS = nbatch
  stat_screened_moms_RHS = ndim

  ! Reallocate the original moments and copy across the packed ones
  deallocate(mm_data%paras,mm_data%qlm)
  nullify(mm_data%paras,mm_data%qlm)
  allocate(mm_data%paras(ndim),mm_data%qlm(foo,ndim))
  mm_data%paras(:) = pkd_paras(:ndim)
  mm_data%qlm(:,:) = pkd_qlm(:,:ndim)

  deallocate(pkd_paras,pkd_qlm)

end subroutine fmm_pack_raw_moments

!-------------------------------------------------------------------------------
! Routine to drive the packing of a set of raw mm parameters by batches,
! where members of a batch share a common centre and extent,
! including the build of a mapping between the packed paras and the
! original raw paras.  This map can be used for later "unpacking".

subroutine fmm_pack_raw_parameters(mm_data)

  implicit none
  type(raw_mm_data), intent(inout) :: mm_data

  type(raw_mm_paras), allocatable :: pkd_paras(:)
  integer(INTK) :: i, j, nbatch, last_batch

  ! Get number of unique batches;
  call get_nbatch(mm_data%paras,nbatch)
  stat_pkd_moms_LHS = nbatch

  ! Initialise packed paras and batch map
  allocate(pkd_paras(nbatch))
  allocate(mm_data%batch_map(nbatch))
  do i=1,nbatch
    mm_data%batch_map(i)%occ = 0
    nullify(mm_data%batch_map(i)%head)
  end do

  ! Now build packed paras by compressing raw paras in same batch
  j = 0
  last_batch = -1
  do i=1,size(mm_data%paras)
    if (mm_data%paras(i)%batch == last_batch) then
      ! Add raw parameter mapping to existing linked-list for this batch
      call add_batch_item(mm_data%batch_map(j),mm_data%paras(i)%id)
    else
      ! Element in new batch
      j = j+1
      pkd_paras(j) = mm_data%paras(i)
      ! Linked-list for this batch is empty, so start one
      mm_data%batch_map(j)%occ = 1
      allocate(mm_data%batch_map(j)%head)
      ! Maintain mapping between parameters and moments
      mm_data%batch_map(j)%head%id = mm_data%paras(i)%id
      nullify(mm_data%batch_map(j)%head%next) ! rest of list is empty
    end if
    last_batch = mm_data%paras(i)%batch
  end do

  ! Reallocate the original parameters and copy across the packed ones
  deallocate(mm_data%paras)
  nullify(mm_data%paras)
  allocate(mm_data%paras(nbatch))
  mm_data%paras(:) = pkd_paras(:)

  deallocate(pkd_paras)

contains

subroutine add_batch_item(batch_list,raw_id)

  implicit none
  type(id_list), intent(inout) :: batch_list
  integer(INTK), intent(in)   :: raw_id
  type(id_node), pointer :: new_node

  batch_list%occ = batch_list%occ+1
  allocate(new_node)
  new_node%id = raw_id
  if (associated(batch_list%head%next)) then
    ! More than one entry in list (including head)
    ! so point new_node to old second entry
    new_node%next => batch_list%head%next
    ! Point head to new_node
    nullify(batch_list%head%next)
    batch_list%head%next => new_node
  else
    ! Only head so far; make new_node our second entry
    batch_list%head%next => new_node
    nullify(new_node%next)   ! end of list
  end if

end subroutine add_batch_item

end subroutine fmm_pack_raw_parameters

!-------------------------------------------------------------------------------

end module fmm_qlm_utils

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Logical Function LDF_isLinDep(i,iShell,iAtom,iAtomPair)
      Implicit None
      Integer i, iShell, iAtom, iAtomPair
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

      Integer iLD, nLD, ip_LD, ip

      Integer j, k
      Integer AP_1CLinDep
      AP_1CLinDep(j,k)=iWork(ip_AP_1ClinDep-1+2*(k-1)+j)

      LDF_isLinDep=.False.
      nLD=AP_1CLinDep(1,iAtomPair)
      If (nLD.lt.1) Return

      ip_LD=AP_1CLinDep(2,iAtomPair)
      iLD=0
      Do While (.not.LDF_isLinDep .and. iLD.lt.nLD)
         ip=ip_LD+3*iLD
         LDF_isLinDep=iWork(ip).eq.iAtom  .and.
     &                iWork(ip+1).eq.iShell .and.
     &                iWork(ip+2).eq.i
         iLD=iLD+1
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mxdiag_cvb(a,eigval,n)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: a(n,n)
real(kind=wp), intent(out) :: eigval(n)
integer(kind=iwp) :: ierr
real(kind=wp), allocatable :: tmp(:)

call mma_allocate(tmp,n*3,label='tmp')
call dsyev_('V','L',n,a,n,eigval,tmp,n*3,ierr)
call mma_deallocate(tmp)
if (ierr /= 0) then
  write(u6,*) ' Fatal error in mxdiag, ierr :',ierr
  call abend_cvb()
end if

return

end subroutine mxdiag_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#ifdef _GROMACS_
      SUBROUTINE Opt_MMO(nAtIn,Coord,nAtOut,CoordMMO,nAtGMX,AT,ipGMS)

      USE, INTRINSIC :: iso_c_binding, only: c_loc, c_ptr
      IMPLICIT NONE

#include "espf.fh"
#include "opt_mmo.fh"
#include "stdalloc.fh"

      INTEGER, INTENT(IN) :: nAtGMX,nAtIn,nAtOut
      TYPE(c_ptr), INTENT(IN) :: ipGMS
      INTEGER, DIMENSION(nAtGMX), INTENT(IN) :: AT
      REAL*8, DIMENSION(3,nAtIn), INTENT(IN) :: Coord
      REAL*8, DIMENSION(3,nAtOut), INTENT(INOUT) :: CoordMMO

      INTEGER :: i,iAtIn,iAtOut,iOk,iPL,j,MMIter
      REAL*8 :: EnergyGMX,MaxF,OldEn,Step
      REAL*8, PARAMETER :: TinyStep = 1.0D-50*AuToNm
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: CoordGMX,FieldGMX,ForceGMX
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: GradMMO,NewCoord,OldCoord
      REAL*8 :: PotGMX(1)
      CHARACTER(LEN=256) :: Message

      INTEGER, EXTERNAL :: iPL_espf
      REAL*8, EXTERNAL :: ddot_

      iPL = iPL_espf()

      IF (nAtOut==0) THEN
         Message = 'Opt_MMO: subroutine called with nAtOut=0'
         CALL WarningMessage(2,Message)
         CALL Abend()
      END IF

! Set up arrays for use with Gromacs
      CALL mma_allocate(CoordGMX,3,nAtGMX)
      CALL mma_allocate(ForceGMX,3,nAtGMX)
      CALL mma_allocate(FieldGMX,3,nAtGMX)
      iAtIn = 1
      iAtOut = 1
      DO i = 1,nAtGMX
         IF (AT(i)==QM.OR.AT(i)==MMI) THEN
            CALL dcopy_(3,Coord(1,iAtIn),1,CoordGMX(1,i),1)
            iAtIn = iAtIn+1
         ELSE
            CALL dcopy_(3,CoordMMO(1,iAtOut),1,CoordGMX(1,i),1)
            iAtOut = iAtOut+1
         END IF
      END DO
      CALL dscal_(3*nAtGMX,AuToNm,CoordGMX,1)

! Set up arrays with MMO coordinates and gradient
      CALL mma_allocate(NewCoord,3,nAtOut)
      CALL mma_allocate(OldCoord,3,nAtOut)
      CALL mma_allocate(GradMMO,3,nAtOut)
      CALL dcopy_(3*nAtOut,CoordMMO,1,NewCoord,1)
      CALL dscal_(3*nAtOut,AuToNm,NewCoord,1)

      IF (iPL>=2) THEN
100      FORMAT(I6,3(F12.6,1X),2X,A)
         CALL CollapseOutput(1,'Gromacs microiterations')
         WRITE(6,*)
         WRITE(6,*) 'Initial coordinates (angstrom)'
         WRITE(6,*) '------------------------------'
         DO i = 1,nAtGMX
            IF (AT(i)==QM) THEN
               WRITE(6,100) i,(CoordGMX(j,i)*NmToAng,j=1,3),'QM'
            ELSE IF (AT(i)==MMI) THEN
               WRITE(6,100) i,(CoordGMX(j,i)*NmToAng,j=1,3),'MMI'
            ELSE
               WRITE(6,100) i,(CoordGMX(j,i)*NmToAng,j=1,3),'MMO'
            END IF
         END DO
         WRITE(6,*)
      END IF

! MMO optimization cycle, performed in Gromacs units
      Step = 0.1D0*AuToNm
      OldEn = HUGE(OldEn)
      MaxF = HUGE(MaxF)
      MMIter = 0
      DO WHILE ((MMIter<MMIterMax).AND.(MaxF>ConvF).AND.(Step>TinyStep))
         MMIter = MMIter+1
         ! Get gradient from Gromacs
         iOk = mmslave_calc_energy_wrapper(ipGMS,CoordGMX,ForceGMX,
     &                                     FieldGMX,PotGMX,EnergyGMX)
         IF (iOk/=1) THEN
            Message = 'Opt_MMO: mmslave_calc_energy is not ok'
            CALL WarningMessage(2,Message)
            CALL Abend()
         END IF
         iAtOut = 1
         DO i = 1,nAtGMX
            IF (AT(i)==MMO) THEN
               GradMMO(1,iAtOut) = -ForceGMX(1,i)
               GradMMO(2,iAtOut) = -ForceGMX(2,i)
               GradMMO(3,iAtOut) = -ForceGMX(3,i)
               iAtOut = iAtOut+1
            END IF
         END DO
#ifdef _DEBUGPRINT_
200      FORMAT(I5,6ES12.4)
         IF (MMIter==1) THEN
            WRITE(6,*)
     &         'Iter       E          |F|         Fmax       Step'
            WRITE(6,*)
     &         '                     (Atomic units)'
            WRITE(6,*)
     &         '-----------------------------------------------------'
         END IF
         IF ((MOD(MMIter,10)==0).OR.(MMIter==1)) THEN
            WRITE(6,200) MMIter,EnergyGMX/AuToKjPerMol,
     &         SQRT(DDot_(3*nAtOut,GradMMO,1,GradMMO,1))/AuToKjPerMolNm,
     &         MaxF/AuToKjPerMolNm,Step/AuToNm
         END IF
#endif
         ! Steepest descent with adaptive step a la Gromacs
         IF ((EnergyGMX<OldEn).OR.(MMIter==1)) THEN
            Step = 1.2D0*Step
            MaxF = Zero
            DO iAtOut = 1,nAtOut
               DO j = 1,3
                  MaxF = MAX(MaxF,ABS(GradMMO(j,iAtOut)))
               END DO
            END DO
            OldEn = EnergyGMX
            CALL dcopy_(3*nAtOut,NewCoord,1,OldCoord,1)
            CALL daxpy_(3*nAtOut,-Step/MaxF,GradMMO,1,NewCoord,1)
         ELSE
            Step = 0.2D0*Step
            CALL dcopy_(3*nAtOut,OldCoord,1,NewCoord,1)
            CALL daxpy_(3*nAtOut,-Step/MaxF,GradMMO,1,NewCoord,1)
         END IF
         ! Update coordinates for Gromacs
         iAtOut = 1
         DO i = 1,nAtGMX
            IF (AT(i)==MMO) THEN
               CoordGMX(1,i) = NewCoord(1,iAtOut)
               CoordGMX(2,i) = NewCoord(2,iAtOut)
               CoordGMX(3,i) = NewCoord(3,iAtOut)
               iAtOut = iAtOut+1
            END IF
         END DO
      END DO

! Issue warning if calculation stopped for other reason than small F
      IF (MaxF>ConvF) THEN
         IF (MMIter==MMIterMax) THEN
            Message = 'Maximum number of microiterations reached'
            CALL WarningMessage(1,Message)
         ELSE IF (Step<=TinyStep) THEN
            Message = 'Microiterations stopped due to zero step size'
            CALL WarningMessage(1,Message)
         END IF
      END IF

! Undo the last move to recover the "converged" coordinates
      IF (MMIter>0) THEN
         CALL dcopy_(3*nAtOut,OldCoord,1,NewCoord,1)
         iAtOut = 1
         DO i = 1,nAtGMX
            IF (AT(i)==MMO) THEN
               CoordGMX(1,i) = NewCoord(1,iAtOut)
               CoordGMX(2,i) = NewCoord(2,iAtOut)
               CoordGMX(3,i) = NewCoord(3,iAtOut)
               iAtOut = iAtOut+1
            END IF
         END DO
      END IF

      IF (iPL>=2) THEN
         WRITE(6,*)
300      FORMAT(' Performed: ',I6,' MM iterations')
         WRITE(6,300) MMIter
400      FORMAT(' Max. force: ',F12.6,' (convergence at: ',F12.6,')')
         WRITE(6,400) MaxF/AuToKjPerMolNm,ConvF/AuToKjPerMolNm
         CALL dscal_(3*nAtGMX,-One/AuToKjPerMolNm,ForceGMX,1)
         EnergyGMX = EnergyGMX/AuToKjPerMol
#ifdef _DEBUGPRINT_
500      FORMAT(3(F12.6,1X))
         WRITE(6,*)
         WRITE(6,*) 'Properties'
         WRITE(6,*) '----------'
         WRITE(6,*) 'Energy: ',EnergyGMX
         DO i = 1,nAtGMX
            IF (AT(i)==MMO) THEN
               WRITE(6,500) (ForceGMX(j,i),j=1,3)
            ELSE
               WRITE(6,500) Zero,Zero,Zero
            END IF
         END DO
#endif
         WRITE(6,*)
      END IF

! Put optimized MMO coordinates on runfile
      CALL dcopy_(3*nAtOut,NewCoord,1,CoordMMO,1)
      CALL dscal_(3*nAtOut,One/AuToNm,CoordMMO,1)
      CALL Put_dArray('MMO Coords',CoordMMO,3*nAtOut)

      IF (iPL>=2) THEN
         IF (MMIter>1) THEN
            WRITE(6,*) 'Final coordinates (angstrom)'
            WRITE(6,*) '----------------------------'
            DO i = 1,nAtGMX
               IF (AT(i)==QM) THEN
                  WRITE(6,100) i,(CoordGMX(j,i)*NmToAng,j=1,3),'QM'
               ELSE IF (AT(i)==MMI) THEN
                  WRITE(6,100) i,(CoordGMX(j,i)*NmToAng,j=1,3),'MMI'
               ELSE
                  WRITE(6,100) i,(CoordGMX(j,i)*NmToAng,j=1,3),'MMO'
               END IF
            END DO
         END IF
         CALL CollapseOutput(0,'Gromacs microiterations')
         WRITE(6,*)
      END IF

! Clean up
      CALL mma_deallocate(CoordGMX)
      CALL mma_deallocate(ForceGMX)
      CALL mma_deallocate(FieldGMX)
      CALL mma_deallocate(NewCoord)
      CALL mma_deallocate(OldCoord)
      CALL mma_deallocate(GradMMO)

      RETURN

      CONTAINS

      FUNCTION mmslave_calc_energy_wrapper(gms,x,f,A,phi,energy)
      INTEGER :: mmslave_calc_energy_wrapper
      TYPE(c_ptr) :: gms
      REAL*8, TARGET :: x(*), f(*), A(*), phi(*)
      REAL*8 :: energy
      INTERFACE
        FUNCTION mmslave_calc_energy(gms,x,f,A,phi,energy)
     &           BIND(C,NAME='mmslave_calc_energy_')
          USE, INTRINSIC :: iso_c_binding, ONLY: c_double, c_int, c_ptr
          INTEGER(kind=c_int) :: mmslave_calc_energy
          TYPE(c_ptr), VALUE :: gms, x, f, A, phi
          REAL(kind=c_double) :: energy
        END FUNCTION mmslave_calc_energy
      END INTERFACE
      mmslave_calc_energy_wrapper = mmslave_calc_energy(gms,c_loc(x(1)),
     &  c_loc(f(1)),c_loc(A(1)),c_loc(phi(1)),energy)
      END FUNCTION mmslave_calc_energy_wrapper

      END
#elif defined (NAGFOR)
! Some compilers do not like empty files
      SUBROUTINE empty_Opt_MMO()
      END
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!               1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine RASSG4(C,S,CB,SB,C2,ICOCOC,ISOCOC,ICSM,ISSM,ICBLTP,ISBLTP,NSSOA,NSSOB,NAEL,IAGRP,NBEL,IBGRP,NOCTPA,NOCTPB,NSM,NTSOB, &
                  IBTSOB,ITSOB,MAXK,MAXI,LC,LS,XINT,CSCR,SSCR,IAEL1,IAEL3,IBEL1,IBEL3,IDC,ISOOSC,NSOOSC,ISOOSE,NSOOSE,ICOOSC, &
                  NCOOSC,ICOOSE,NCOOSE,IASOOS,IACOOS,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,IDOH2,ISTRFL,PS,LUC,LUHC,IST,CJRES,SIRES, &
                  NOPART,TimeDep)
! LOOP OVER SIGMA AND C VECTOR
!
! Jeppe Olsen, Winter of 1991
! small modifications by eaw 96
!
! =====
! Input
! =====
!
! ICOCOC : Allowed type combinations for C
! ISOCOC : Allowed type combinations for S(igma)
! ICS    : Symmetry for C
! ISS    : Symmetry for S
! ICBLTP : Block types for C
! ISBLTP : Block types for S
!
! H     : Active one-body Hamiltonian with core contributions
! C     : CI vector
! CB    : Array able to hold largest STT block of C
! NSSOA : Number of strings per type and symmetry for alpha strings
! NAEL  : Number of active alpha electrons
! NSSOB : Number of strings per type and symmetry for beta strings
! NBEL  : Number of active beta electrons
! NTSOB : Number of orbitals per type and symmetry
! ITSOB : Orbitals of given type and symmetry
! IBTSOB: Offset for ITSOB
!
! MAXK  : Largest number of N-2,N-1 strings treated simultaneously
! MAXI  : Max number of N strings treated simultaneously
!
! LC : Length of scratch array for C
! LS : Length of scratch array for S
! XINT : Scratch array for integrals
! CSCR : Scratch array for C vector (space for res. matr.)
! SSCR : Scratch array for S vector (space for res. matr.)
!
! The C and S vectors are accessed through routines that
! either fetches/disposes symmetry blocks or
! Symmetry-occupation-occupation blocks
!
! IST :  = 1 => Singlet operator
!        = 2 => Triplet operator\
!
! IDOH2 : = 1 => both one and two particle parts
!         = 0 => only one-electron operator
! A triplet one electron operator is defined as E(aa)-E(bb)
! A triplet two-electron operator is defined as (E(aa)+E(bb))(E(aa)-E(bb))

use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: C(*), PS
real(kind=wp), intent(inout) :: S(*)
integer(kind=iwp), intent(in) :: NOCTPA, NOCTPB, ICOCOC(NOCTPA,NOCTPB), ISOCOC(NOCTPA,NOCTPB), ICSM, ISSM, NSM, ICBLTP(NSM), &
                                 ISBLTP(NSM), NSSOA(NOCTPA,NSM), NSSOB(NOCTPB,NSM), NAEL, IAGRP, NBEL, IBGRP, NTSOB(3,NSM), &
                                 IBTSOB(3,NSM), ITSOB(*), MAXK, MAXI, LC, LS, IAEL1(*), IAEL3(*), IBEL1(*), IBEL3(*), IDC, IDOH2, &
                                 ISTRFL(*), LUC, LUHC, IST, NOPART
real(kind=wp), intent(_OUT_) :: CB(*), SB(*), C2(*), XINT(*), CSCR(*), SSCR(*), XI1S(MAXK,*), XI2S(MAXK,*), XI3S(MAXK,*), &
                                XI4S(MAXK,*), CJRES(*), SIRES(*)
integer(kind=iwp), intent(out) :: ISOOSC(NOCTPA,NOCTPB,NSM), NSOOSC(NOCTPA,NOCTPB,NSM), ISOOSE(NOCTPA,NOCTPB,NSM), &
                                  NSOOSE(NOCTPA,NOCTPB,NSM), ICOOSC(NOCTPA,NOCTPB,NSM), NCOOSC(NOCTPA,NOCTPB,NSM), &
                                  ICOOSE(NOCTPA,NOCTPB,NSM), NCOOSE(NOCTPA,NOCTPB,NSM), IASOOS(NOCTPA,NOCTPB,NSM), &
                                  IACOOS(NOCTPA,NOCTPB,NSM)
integer(kind=iwp), intent(_OUT_) :: I1(MAXK,*), I2(MAXK,*), I3(MAXK,*), I4(MAXK,*)
logical(kind=iwp), intent(in) :: TimeDep
integer(kind=iwp) :: DUM(1), I1ASM, I1BSM, I1TA, I1TB, IASM, IATP, IBSM, IBTP, IC1SM, IC1TA, IC1TB, ICBLK, ICBSM, ICENSM, ICENTA, &
                     ICENTB, ICOFF, ICSTSM, ICSTTA, ICSTTB, IFINIC, IFRSTC, IFRSTS, IOFF, IPERM, IS1SM, IS1TA, IS1TB, ISBLK, &
                     ISENSM, ISENTA, ISENTB, ISFINI, ISOFF, ISSTSM, ISSTTA, ISSTTB, JASM, JATP, JBSM, JBTP, LASM(4), LATP(4), &
                     LBLK, LBSM(4), LBTP(4), LCOL, LLASM, LLATP, LLBSM, LLBTP, LROW, LSBLK, LSGN(5), LTRP(5), NCBLK, NCCMBC, &
                     NCCMBE, NIA, NIB, NJA, NJB, NLLA, NLLB, NONEWC, NONEWS, NPERM, NSBLK, NSCMBC, NSCMBE
real(kind=wp) :: PL, XNORM2
real(kind=wp), external :: DDot_

PL = Zero
! ================================
! 1 : Arrays for accessing C and S
! ================================

!***********************************************************************

! Sigma, compact form
call ZOOS(ISSM,ISBLTP,NSM,ISOCOC,NSSOA,NSSOB,NOCTPA,NOCTPB,IDC,ISOOSC,NSOOSC,NSCMBC,0)
! Sigma with expanded diagonal blocks
call ZOOS(ISSM,ISBLTP,NSM,ISOCOC,NSSOA,NSSOB,NOCTPA,NOCTPB,IDC,ISOOSE,NSOOSE,NSCMBE,1)
! C, compact form
call ZOOS(ICSM,ICBLTP,NSM,ISOCOC,NSSOA,NSSOB,NOCTPA,NOCTPB,IDC,ICOOSC,NCOOSC,NCCMBC,0)
! C, Full determinant form
call ZOOS(ICSM,ICBLTP,NSM,ISOCOC,NSSOA,NSSOB,NOCTPA,NOCTPB,1,ICOOSE,NCOOSE,NCCMBE,1)

!************************************************************************

! Initialize loop over batches of sigma blocks
ISENSM = 1
ISENTA = 1
ISENTB = 1
IFRSTS = 1
! Loop over batches over sigma blocks
if (LUHC > 0) rewind(LUHC)

outer: do
  ! Next batch of sigma blocks
  ISSTSM = ISENSM
  ISSTTA = ISENTA
  ISSTTB = ISENTB
  call INCOOS(IDC,ISBLTP,NSOOSE,NOCTPA,NOCTPB,ISSTSM,ISSTTA,ISSTTB,NSM,ISENSM,ISENTA,ISENTB,IASOOS,LS,ISFINI,NSBLK,IFRSTS,ISOCOC)
  if ((NSBLK == 0) .and. (ISFINI /= 0)) exit
  IFRSTS = 0
  ! Initialize sigma blocks
  IS1SM = ISSTSM
  IS1TA = ISSTTA
  IS1TB = ISSTTB
  LSBLK = 0
  do ISBLK=1,NSBLK
    LSBLK = LSBLK+NSOOSE(IS1TA,IS1TB,IS1SM)
    if (ISBLK /= NSBLK) call NXTBLK_MCLR(IS1TA,IS1TB,IS1SM,NOCTPA,NOCTPB,NSM,ISBLTP,IDC,NONEWS,ISOCOC)
  end do
  SB(1:LSBLK) = Zero
  ! Initialize loop over blocks over C vector
  ICENSM = 1
  ICENTA = 1
  ICENTB = 1
  if (LUC > 0) rewind(LUC)
  ! Loop over blocks of C vector
  IFRSTC = 1
  do
    ICSTSM = ICENSM
    ICSTTA = ICENTA
    ICSTTB = ICENTB

    call INCOOS(IDC,ICBLTP,NCOOSE,NOCTPA,NOCTPB,ICSTSM,ICSTTA,ICSTTB,NSM,ICENSM,ICENTA,ICENTB,IACOOS,LC,IFINIC,NCBLK,IFRSTC,ICOCOC)

    ! If no more C blocks go to next batch of sigma blocks
    if ((NCBLK == 0) .and. (IFINIC /= 0)) cycle outer
    IFRSTC = 0
    ! Read C blocks into core
    IC1SM = ICSTSM ! Symmetry alpha
    IC1TA = ICSTTA ! Type alpha string
    IC1TB = ICSTTB ! Type Beta string
    ICOFF = 1
    do ICBLK=1,NCBLK
      ICBSM = Mul(IC1SM,ICSM) ! Symmetry Beta string
      ! C CI vector in
      ! CB Block of CI vector out
      if (ICOCOC(IC1TA,IC1TB) == 1) &
        call GSTTBL_MCLR(C,CB(ICOFF),IC1TA,IC1SM,IC1TB,ICBSM,NOCTPA,NOCTPB,NSSOA,NSSOB,PS,ICOOSC,IDC,PL,LUC,C2)

      ICOFF = ICOFF+NCOOSE(IC1TA,IC1TB,IC1SM)
      if (ICBLK /= NCBLK) call NXTBLK_MCLR(IC1TA,IC1TB,IC1SM,NOCTPA,NOCTPB,NSM,ICBLTP,IDC,NONEWC,ICOCOC)
    end do

    !*******************************************************************

    ! Loop over sigma and C blocks in core and obtain  contribution from
    ! given C block to given S block
    ISOFF = 1
    IASM = ISSTSM
    IATP = ISSTTA
    IBTP = ISSTTB
    do ISBLK=1,NSBLK
      IBSM = Mul(IASM,ISSM)
      NIA = NSSOA(IATP,IASM)
      NIB = NSSOB(IBTP,IBSM)
      if ((NIA /= 0) .and. (NIB /= 0)) then
        JASM = ICSTSM
        JATP = ICSTTA
        JBTP = ICSTTB
        ICOFF = 1
        do ICBLK=1,NCBLK
          JBSM = Mul(JASM,ICSM)
          NJA = NSSOA(JATP,JASM)
          NJB = NSSOB(JBTP,JBSM)
          XNORM2 = DDot_(NJA*NJB,CB(ICOFF),1,CB(ICOFF),1)
          if ((NIA /= 0) .and. (NIB /= 0) .and. (NJA /= 0) .and. (NJB /= 0) .and. (ISOCOC(IATP,IBTP) == 1) .and. &
              (ICOCOC(JATP,JBTP) == 1) .and. (XNORM2 /= Zero)) then
            ! Other symmetry blocks that can be obtained from this block
            !write(u6,*) 'Other symmetry blocks that can be obtained'
            !call xflush(u6)

            call PRMBLK(IDC,ISTRFL,JASM,JBSM,JATP,JBTP,PS,PL,LATP,LBTP,LASM,LBSM,LSGN,LTRP,NPERM)
            do IPERM=1,NPERM
              LLASM = LASM(IPERM)
              LLBSM = LBSM(IPERM)
              LLATP = LATP(IPERM)
              LLBTP = LBTP(IPERM)
              NLLA = NSSOA(LLATP,LLASM)
              NLLB = NSSOB(LLBTP,LLBSM)
              if (LTRP(IPERM) == 1) then
                LROW = NSSOA(LATP(IPERM-1),LASM(IPERM-1))
                LCOL = NSSOB(LBTP(IPERM-1),LBSM(IPERM-1))
                call TRNSPS(LROW,LCOL,CB(ICOFF),C2)
                CB(iCOFF:iCOFF+LROW*LCOL-1) = C2(1:LROW*LCOL)
              end if
              if (LSGN(IPERM) == -1) CB(iCOFF:iCOFF+LROW*LCOL-1) = -CB(iCOFF:iCOFF+LROW*LCOL-1)

              ! Generation of contribution to sigma block
              ! from given CI block

              !write(u6,*) 'TimeDep in rassg4',TimeDep
              !call xflush(u6)
              if (TimeDep) then
                !write(u6,*) 'I call rssbcbn_td'
                call RSSBCBN_td(IASM,IATP,IBSM,IBTP,LLASM,LLATP,LLBSM,LLBTP,IAEL1(IATP),IAEL3(IATP),IBEL1(IBTP),IBEL3(IBTP), &
                                IAEL1(LLATP),IAEL3(LLATP),IBEL1(LLBTP),IBEL3(LLBTP),NAEL,NBEL,IAGRP,IBGRP,SB(ISOFF),CB(ICOFF), &
                                IDOH2,NTSOB,IBTSOB,ITSOB,MAXI,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,C2,NSM,NIA,NIB, &
                                NLLA,NLLB,IST,CJRES,SIRES,NOPART,TimeDep)

                !call RECPRT('SSCR in rassg4',' ',SSCR,5,1) !yma
                !call xflush(u6)
              else
                call RSSBCBN_MCLR(IASM,IATP,IBSM,IBTP,LLASM,LLATP,LLBSM,LLBTP,IAEL1(IATP),IAEL3(IATP),IBEL1(IBTP),IBEL3(IBTP), &
                                  IAEL1(LLATP),IAEL3(LLATP),IBEL1(LLBTP),IBEL3(LLBTP),NAEL,NBEL,IAGRP,IBGRP,SB(ISOFF),CB(ICOFF), &
                                  IDOH2,NTSOB,IBTSOB,ITSOB,MAXI,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,C2,NSM,NIA, &
                                  NIB,NLLA,NLLB,IST,CJRES,SIRES,NOPART,TimeDep)
              end if

            end do
            ! Transpose or scale to restore order ??
            if (LTRP(NPERM+1) == 1) then
              call TRNSPS(NJB,NJA,CB(ICOFF),C2)
              CB(ICOFF:ICOFF+NJA*NJB-1) = C2(1:NJA*NJB)
            end if
            if (LSGN(NPERM+1) == -1) CB(ICOFF:ICOFF+NJA*NJB-1) = -CB(ICOFF:ICOFF+NJA*NJB-1)

          end if
          ICOFF = ICOFF+NCOOSE(JATP,JBTP,JASM)
          ! NeXt C block
          if (ICBLK /= NCBLK) call NXTBLK_MCLR(JATP,JBTP,JASM,NOCTPA,NOCTPB,NSM,ICBLTP,IDC,NONEWC,ICOCOC)
        end do
        ! End of loop over C blocks in Batch
        ! NeXt S block
      end if
      ISOFF = ISOFF+NSOOSE(IATP,IBTP,IASM)
      if (ISBLK /= NSBLK) call NXTBLK_MCLR(IATP,IBTP,IASM,NOCTPA,NOCTPB,NSM,ISBLTP,IDC,NONEWS,ISOCOC)
    end do
    !*******************************************************************
    ! End of loop over S blocks in batch
    ! End of loop over batches of C blocks

    if (IFINIC /= 0) exit
  end do
  ! Transfer S block to permanent storage

  !call RECPRT('SB in rassg4',' ',S,5,1)

  I1ASM = ISSTSM
  I1TA = ISSTTA
  I1TB = ISSTTB
  IOFF = 1
  do ISBLK=1,NSBLK
    I1BSM = Mul(I1ASM,ISSM)
    if (ISOCOC(I1TA,I1TB) == 1) &
      call PSTTBL_MCLR(S,SB(IOFF),I1TA,I1ASM,I1TB,I1BSM,NOCTPA,NOCTPB,NSSOA,NSSOB,PS,ISOOSC,2,IDC,LUHC,C2)
    IOFF = IOFF+NSOOSE(I1TA,I1TB,I1ASM)
    if (ISBLK /= NSBLK) call NXTBLK_MCLR(I1TA,I1TB,I1ASM,NOCTPA,NOCTPB,NSM,ISBLTP,IDC,NONEWS,ISOCOC)
  end do
  if (ISFINI /= 0) exit outer
end do outer
! End of loop over batches of S blocks
!***********************************************************************
if (LUHC > 0) then
  DUM(1) = -1
  call ITODS(DUM,1,LBLK,LUHC)
end if

end subroutine RASSG4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      real*8 function  getCG(
     *j1,     ! integer  2*j1
     *j2,     ! integer  2*j2
     *j3,     ! integer  2*j3
     *m1,     ! integer  2*m1
     *m2,     ! integer  2*m2
     *m3)     ! integer  2*m2
cbs this routine calculates the Clebsch-Gordan-coefficients
cbs by actually calculating the 3j-symbol
cbs  ---                 ---
cbs  |  j1   j2    |   j3   |         j1+m1+j2-m2
cbs  |             |        |  =  (-)                 sqrt (2  j3+1) *
cbs  |  m1   m2    |   m3   |
cbs  ---                 ---
cbs
cbs                             ---             ---
cbs                             |  j1   j2   j3   |
cbs                             |                 |
cbs                             |  m1   m2  -m3   |
cbs                              ---            ---
      implicit real*8(a-h,o-z)
cbs   initialize CG-coefficient
      getCG=0d0
cbs   quick check
      if (m1+m2.ne.m3) return
      if (j1.lt.0.or.j2.lt.0.or.j3.lt.0) return
cbs   check the correct sign    beginning
      idummy=(j1+j2+m1-m2)/2
      if (mod(idummy,2).eq.0) then
      isign=1
      else
      isign=-1
      endif
cbs   check the correct sign    end
      fac1=sqrt(DBLE(j3+1))
      fac2=regge3j(j1,j2,j3,m1,m2,-m3)
      getCG=DBLE(isign)*fac1*fac2
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  Cross
!
!> @brief
!>   Performs the cross product \p A &times; \p B and puts the result in \p C
!> @author Y. Carissan
!>
!> @details
!> Performs the cross product \p A &times; \p B and puts the result in \p C.
!>
!> @param[in]  A First (left) input vector
!> @param[in]  B Second (right) input vector
!> @param[out] C Output vector
!***********************************************************************

subroutine Cross(A,B,C)

use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: A(3), B(3)
real(kind=wp), intent(out) :: C(3)

C(1) = A(2)*B(3)-B(2)*A(3)
C(2) = A(3)*B(1)-B(3)*A(1)
C(3) = A(1)*B(2)-B(1)*A(2)

return

end subroutine Cross

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SODist(SOValue,mAO,nCoor,mBas,nCmp,
     &                  nDeg,MOValue,
     &                  nMOs,iAO,CMOs,nCMO,DoIt)
      use SOAO_Info, only: iAOtSO
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 SOValue(mAO*nCoor,mBas,nCmp*nDeg),
     &       MOValue(mAO*nCoor,nMOs),
     &       CMOs(nCMO)
      Integer DoIt(nMOs)
      Integer   iOff_MO(0:7), iOff_CMO(0:7), iTwoj(0:7)
      Character*80 Label
      Data iTwoj/1,2,4,8,16,32,64,128/
*
      iRout=135
      iPrint=nPrint(iRout)
      If (iPrint.ge.49) Then
         Write (6,*) 'SODist: MO-Coefficients'
         iOff=1
         Do iIrrep = 0, nIrrep-1
            If (nBas(iIrrep).gt.0) Then
               Write (6,*) ' Symmetry Block',iIrrep
               Call RecPrt(' ',' ',CMOs(iOff),nBas(iIrrep),nBas(iIrrep))
            End If
            iOff=iOff+nBas(iIrrep)**2
         End Do
      End If
*
*---- Compute some offsets
*
      itmp1=1
      itmp2=0
      Do iIrrep = 0, nIrrep-1
         iOff_MO(iIrrep)=itmp1
         iOff_CMO(iIrrep)=itmp2
         itmp1=itmp1+nBas(iIrrep)
         itmp2=itmp2+nBas(iIrrep)*nBas(iIrrep)
      End Do
*

      Do i1 = 1, nCmp
         iDeg=0
         Do iIrrep = 0, nIrrep-1
            iSO=iAOtSO(iAO+i1,iIrrep)
            If (iSO<0) Cycle
            iDeg=iDeg+1
            iOff=(i1-1)*nDeg+iDeg

*
*---------- Distribute contribution to all MO's in this irrep
*
            iMO=iOff_MO(iIrrep)
            iCMO=iOff_CMO(iIrrep)+iSO
            Call MyDGeMM(DoIt(iMO),
     &                 mAO*nCoor,nBas(iIrrep),mBas,
     &                 SOValue(1,1,iOff),mAO*nCoor,
     &                 CMOs(iCMO),nBas(iIrrep),
     &                 MOValue(1,iMO),mAO*nCoor)
          End Do
      End Do
*
      If (iPrint.ge.49) Then
         Write (Label,'(A)')'SODist: MOValue(mAO*nCoor,nMOs)'
         Call RecPrt(Label,' ',MOValue(1,1),mAO*nCoor,nMOs)
      End If
*
      Call GetMem('SODist ','CHEC','REAL',iDum,iDum)
      Return
      End

      SUBROUTINE MYDGEMM ( DoIt, M, N, K,
     $                     A, LDA, B, LDB,
     $                     C, LDC )
*     .. Scalar Arguments ..
      INTEGER            M, N, K, LDA, LDB, LDC
      Integer DoIt(*)
*     .. Array Arguments ..
      REAL*8   A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*  Purpose
*  =======
*
*  DGEMM for a spesial case.
*
*
*     .. Local Scalars ..
      INTEGER            I, J, L
      REAL*8   TEMP
*     .. Parameters ..
      REAL*8   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
*     ..
*
*           Form  C := A*B + C.
*
            DO 90, J = 1, N
            if(DoIt(J).eq.1) then
               DO 80, L = 1, K
                  IF( B( L, J ).NE.ZERO )THEN
                     TEMP = B( L, J )
                     DO 70, I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
   70                CONTINUE
                  END IF
   80          CONTINUE
            endif
   90       CONTINUE
*
      RETURN
      END
*
      Subroutine SODist2(SOValue,mAO,nCoor,mBas,nCmp,nDeg,SO,
     &                  nSOs,iAO,TmpCMOs,nCMO,TmpDoIt)
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
*
      Real*8  SOValue(mAO*nCoor,mBas,nCmp*nDeg),
     &        SO(mAO*nCoor,nSOs),
     &        TmpCMOs(nCMO)
      Integer TmpDoIt(nSOs)
*
      Do k=1,nSOs
         TmpDoIt(k) = 1
      End Do
*
      call dcopy_(nCMO,[0.0d0],0,TmpCMOs,1)
*
      iOff=0
      Do i=0,nIrrep-1
         iBas=nBas(i)
         Do j=1,iBas
            ii = iOff+(j-1)*iBas + j
            TmpCMOs(ii) = 1.0d0
         End Do
         iOff=iOff+nBas(i)**2
      End Do
*
      Call SODist(SOValue,mAO,nCoor,mBas,nCmp,nDeg,SO,
     &            nSOs,iAO,TmpCMOs,nCMO,TmpDoIt)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Giovanni Li Manni                                *
!               2020, Oskar Weser                                      *
!***********************************************************************

#include "macros.fh"

module CI_solver_util

use Para_Info, only: MyRank
use linalg_mod, only: verify_
use rasscf_global, only: nAc, nAcPar, nAcpr2, nroots
use general_data, only: JobIPH
#ifdef _MOLCAS_MPP_
use MPI_Wrapper, only: MPI_Bcast, MPI_COMM_WORLD, MPI_LOGICAL, MPI_REAL8
use GA_Wrapper, only: GA_Create
use Para_Info, only: Is_Real_Par
use Definitions, only: MPIInt
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
private

public :: wait_and_read, RDM_to_runfile, rdm_from_runfile, cleanMat, write_RDM

#ifdef _MOLCAS_MPP_
integer(kind=MPIInt) :: error
integer(kind=MPIInt), parameter :: ROOT = 0_MPIInt
#endif

interface
  function isfreeunit(iseed)
    import :: iwp
    integer(kind=iwp) :: isfreeunit
    integer(kind=iwp), intent(in) :: iseed
  end function
end interface

#include "intent.fh"

contains

subroutine wait_and_read(filename,energy)

  character(len=*), intent(in) :: filename
  real(kind=wp), intent(out) :: energy(nroots)
  logical(kind=iwp) :: newcycle_found
  integer(kind=iwp) :: i, LuNewC

  newcycle_found = .false.
  do while (.not. newcycle_found)
    call sleepf(1)
    if (myrank == 0) call f_Inquire(trim(filename),newcycle_found)
#   ifdef _MOLCAS_MPP_
    if (is_real_par()) call MPI_Bcast(newcycle_found,1_MPIInt,MPI_LOGICAL,ROOT,MPI_COMM_WORLD,error)
#   endif
  end do
  if (myrank == 0) then
    write(u6,*) 'NEWCYCLE file found. Proceeding with SuperCI'
    LuNewC = isFreeUnit(12)
    call molcas_open(LuNewC,'NEWCYCLE')
    read(LuNewC,*) (energy(i),i=1,nroots)
    close(LuNewC,status='delete')
    write(u6,*) 'I read the following energies:',energy
  end if
# ifdef _MOLCAS_MPP_
  if (is_real_par()) call MPI_Bcast(energy,1_MPIInt,MPI_REAL8,ROOT,MPI_COMM_WORLD,error)
# endif

end subroutine wait_and_read

!>  @brief
!>  Put RDMs into runfile.
!>
!>  @author Giovanni Li Manni, Oskar Weser
!>
!>  @param[out] DMAT Average 1 body density matrix
!>  @param[out] D1S_MO Average spin 1-dens matrix
!>  @param[out] PSMAT Average symm. 2-dens matrix
!>  @param[out] PAMAT Average antisymm. 2-dens matrix
!>  @param[in,out] jDisk
subroutine RDM_to_runfile(DMAT,D1S_MO,PSMAT,PAMAT,jDisk)

  ! _IN_ is not a semantic IN, since DDAFILE is both a read and
  ! write routine. Redefinition to suppress compiler warning.
  real(kind=wp), intent(_IN_) :: DMAT(nAcpar), D1S_MO(nAcPar), PSMAT(nAcpr2), PAMAT(nAcpr2)
  integer(kind=iwp), intent(inout), optional :: jDisk

  ! Put it on the RUNFILE
  call Put_dArray('D1mo',DMAT,NACPAR)
  call Put_dArray('P2mo',PSMAT,NACPR2)
  ! Save density matrices on disk
  ! DDAFILE calls BDAFile, iOpt option code
  ! 1 = synchronous write
  ! 2 = synchronous read
  ! BUF = array carrying data
  ! lBUF = length of array carrying data
  ! jDisk = memory address (automatically incremented upon
  !         repeated DDAFILE call)
  call DDafile(JOBIPH,1,DMAT,NACPAR,jDisk)
  call DDafile(JOBIPH,1,D1S_MO,NACPAR,jDisk)
  call DDafile(JOBIPH,1,PSMAT,NACPR2,jDisk)
  call DDafile(JOBIPH,1,PAMAT,NACPR2,jDisk)

end subroutine RDM_to_runfile

subroutine rdm_from_runfile(dmat,d1s_mo,psmat,pamat,jdisk)

  real(kind=wp), intent(out) :: dmat(nacpar), d1s_mo(nacpar), psmat(nacpr2), pamat(nacpr2)
  integer(kind=iwp), intent(inout), optional :: jdisk

  call ddafile(jobiph,2,dmat,nacpar,jdisk)
  call ddafile(jobiph,2,d1s_mo,nacpar,jdisk)
  call ddafile(jobiph,2,psmat,nacpr2,jdisk)
  call ddafile(jobiph,2,pamat,nacpr2,jdisk)

end subroutine rdm_from_runfile

subroutine CleanMat(MAT)
  !************ by G. Li Manni Stuttgart April 2016 *************
  !
  ! MAT: One-body density matrix in MO basis as passed by QMC calculation.

  ! It could well be an average matrix in SA calculation.
  !
  ! It has following shape:
  !        11
  !        12 22
  !        ** ** 33
  !        ** ** ** 44
  !        ** ** ** 45 55
  !        ** ** ** 46 56 66
  !        ** ** ** 47 57 67 77
  !        ** ** ** ** ** ** ** 88
  !        ** ** ** ** ** ** ** 89  99
  !        ** ** ** ** ** ** ** 810 910 1010
  !        """""""""""""""""""""""""""""""""""
  ! mimicking a system with (2 0 0 1 4 3 0 0)  active orbitals (blocked by Irreps)

  ! DMAT will be destroyed and replaced with a positive semi-definite one.
  ! N-representability will be preserved.

  use Index_Functions, only: iTri, nTri_Elem
  use Constants, only: Zero, One, Two

  real(kind=wp), intent(inout) :: MAT(NacPar)
  integer(kind=iwp) :: i, j
  real(kind=wp) :: trace
  logical(kind=iwp) :: cleanup_required
  real(kind=wp), allocatable :: EVC(:), MAT_copy(:), Tmp(:), Tmp2(:)

  if (nacpar < 1) then
    write(u6,*) 'matrix size < 1.'
    return
  end if

  call mma_allocate(MAT_copy,NacPar)
  MAT_copy(:) = MAT(:)

  ! Allocate memory for eigenvectors and new DMAT
  call mma_allocate(EVC,NAC**2)
  ! Initialize eigenvectors
  ! set eigenvector array to identity for this version of JACOB
  call unitmat(EVC,NAC)

  ! Step 1: Diagonalize MAT. Eigenvalues are stored in diagonal of MAT
  trace = Zero
  do i=1,nac
    trace = trace+mat(nTri_Elem(i))
  end do
  call JACOB(MAT_copy,EVC,NAC,NAC)

# ifdef _DEBUGPRINT_
  write(u6,*) 'eigenvalues: '
  do i=1,nac
    write(u6,*) MAT_copy(nTri_Elem(I))
  end do
  write(u6,*) 'eigenvectors: '
  do i=1,nac
    write(u6,*) (EVC(i*NAC+j),j=0,NAC)
  end do
# endif
  ! Set to zero negative eigenvalue and to TWO values larger than 2.0.
  cleanup_required = .false.
  do j=1,nac
    if (MAT_copy(nTri_Elem(j)) > Two) then
      MAT_copy(nTri_Elem(j)) = Two
      cleanup_required = .true.
    end if
    if (MAT_copy(nTri_Elem(j)) < 1.0e-12_wp) then
      MAT_copy(nTri_Elem(j)) = Zero
      cleanup_required = .true.
    end if
  end do

  if (cleanup_required) then
    trace = Zero
    do i=1,nac
      trace = trace+MAT_copy(nTri_Elem(I))
    end do
    write(u6,*) 'trace after removing negative eigenvalues =',trace
    ! Combine pieced to form the output MAT
    ! blas routine for square*triangular operation
    call mma_allocate(Tmp,nac**2)
    call mma_allocate(Tmp2,nac**2)
    Tmp(:) = Zero
    Tmp2(:) = Zero
    do i=1,nac
      do j=1,nac
        Tmp(j+(i-1)*nac) = EVC(j+(i-1)*NAC)*MAT_copy(nTri_Elem(I))
      end do
    end do
    call DGEMM_('N','T',nac,nac,nac,One,Tmp,nac,EVC,nac,Zero,Tmp2,nac)
    ! Copy back to MAT
    do i=1,nac
      do j=1,i
        MAT(iTri(i,j)) = Tmp2(j+(i-1)*nac)
      end do
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) 'trace after recombination:'
    trace = Zero
    do i=1,nac
      trace = trace+MAT(nTri_Elem(i))
    end do
#   endif
    call mma_deallocate(tmp)
    call mma_deallocate(tmp2)
  end if
  call mma_deallocate(MAT_copy)
  call mma_deallocate(EVC)
  !***************** Exit ****************

  return

end subroutine cleanMat

subroutine write_RDM(RDM,i_unit)

  use Index_Functions, only: nTri_Elem_Rev

  real(kind=wp), intent(in) :: RDM(:)
  integer(kind=iwp), intent(in) :: i_unit
  integer(kind=iwp) :: curr_line, i, io_err, j, n_lines

  if (myrank == 0) then
    n_lines = nTri_Elem_Rev(size(RDM))

    i = 1
    do curr_line=1,n_lines
      do j=i,i+curr_line-1
        write(i_unit,'(ES25.15)',advance='no',iostat=io_err) RDM(j)
        call verify_(io_err == 0,'Error on writing RDM.')
      end do
      write(i_unit,*)
      i = i+curr_line
    end do
  end if

end subroutine write_RDM

end module CI_solver_util

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE VSMSB(A,LA,S,B,LB,C,LC,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*),B(*),C(*)
      DO 100 I=0,N-1
         C(1+I*LC)=A(1+I*LA)*S-B(1+I*LB)
100   CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Real*8 Function OrbPhase(A,nA)
      Implicit None
      Integer nA, i
      Real*8 A(nA)
*
      OrbPhase=0.0D0
      Do i = 1, nA
         OrbPhase = OrbPhase + A(i)*DBLE(i)
      End Do
      If (OrbPhase.lt.0.0D0) Then
         Call DScal_(nA,-1.0D0,A,1)
         OrbPhase = -OrbPhase
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine HRR(la,lb,A,B,tgt,nPrim,nTrgt,ipIn)
!***********************************************************************
!                                                                      *
! Object: to generate the contracted integrals (one or two-electron)   *
!         from (a+b,0| or (0,a+b| type of integrals. The approach      *
!         implemented here is the same as that one described by Rys,   *
!         Dupuis and King. In this they implemented the method for the *
!         2D-integrals. The method was later implemented to be applied *
!         on the contracted integrals (Head-Gordon & Pople).           *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             February '90                                             *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden.                                         *
!             Modified to not use pointers June '91                    *
!***********************************************************************

use Index_Functions, only: C3_Ind, nTri_Elem1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: la, lb, nPrim, nTrgt
real(kind=wp), intent(in) :: A(3), B(3)
real(kind=wp), intent(inout) :: tgt(nPrim,nTrgt)
integer(kind=iwp), intent(out) :: ipIn
integer(kind=iwp) :: ia, ia1, ia1b, iab, iab1, iaMax, iaMin, ib, ib1, ib1Max, ipRslt
real(kind=wp) :: AB(3), ABSqrt

! Fast exit if HRR will not be applied.
if ((la == 0) .or. (lb == 0)) then
  ipIn = 1
  return
end if

AB(:) = A(:)-B(:)
if (lb > la) AB(:) = -AB(:)
ABSqrt = sqrt(AB(1)**2+AB(2)**2+AB(3)**2)
if (ABSqrt == Zero) then
  call OCHRR(tgt,nPrim,nTrgt,la,lb,ipIn)
else

  ib1Max = min(la,lb)
  iaMin = max(la,lb)
  ipRslt = 0
  do ib1=1,ib1Max
    ib = ib1-1
    iaMax = la+lb-ib1
    do ia=iaMax,iaMin,-1
      ia1 = ia+1
      if (mod(ib1,2) == 0) then
        ! Low loading of target integrals.
        iab1 = nTri_Elem1(ib1)*(C3_Ind(ia,ia,0)-C3_Ind(iaMin,iaMin,0))
        ! High access of source integrals.
        iab = nTrgt-nTri_Elem1(ib)*(C3_Ind(iaMax+1,0,iaMax+1)-C3_Ind(ia,ia,0)+1)
        ia1b = nTrgt-nTri_Elem1(ib)*(C3_Ind(iaMax+1,0,iaMax+1)-C3_Ind(ia1,ia1,0)+1)
      else
        ! High loading of target integrals.
        iab1 = nTrgt-nTri_Elem1(ib1)*(C3_Ind(iaMax,0,iaMax)-C3_Ind(ia,ia,0)+1)
        ! Low access of source integrals.
        iab = nTri_Elem1(ib)*(C3_Ind(ia,ia,0)-C3_Ind(iaMin,iaMin,0))
        ia1b = nTri_Elem1(ib)*(C3_Ind(ia1,ia1,0)-C3_Ind(iaMin,iaMin,0))
      end if
      ipRslt = iab1

      ! Generate this block of integrals with the HRR

      call HRR1(tgt(1,iab1+1),nTri_Elem1(ia)*nTri_Elem1(ib1),tgt(1,ia1b+1),nTri_Elem1(ia1)*nTri_Elem1(ib),AB,tgt(1,iab+1), &
                nTri_Elem1(ia)*nTri_Elem1(ib),ia,ib,ia1,ib1,nPrim,la,lb)

    end do
  end do
  ipIn = nPrim*ipRslt+1
end if

return

end subroutine HRR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  ParaRoot
*
*> @brief
*>   Manage the parallel tempering routine
*> @author A. Ohrn
*>
*> @details
*> If our system is difficult and has small transition elements
*> in the Markov chain, we can use the parallel tempering to
*> boost sampling. This routine is the root for this; it
*> mainly handles the various configurations for the different
*> temperature ensembles; also, manages the ensemble switch.
*>
*> @param[in]     Ract
*> @param[in]     BetaBol
*> @param[in]     Etot
*> @param[in,out] CalledBefore
*> @param[out]    SampleThis
************************************************************************
      Subroutine ParaRoot(Ract,BetaBol,Etot,CalledBefore,SampleThis)
      Implicit Real*8 (a-h,o-z)
      External Ranf
#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "WrkSpc.fh"
#include<constants.fh>

*     Parameter (BoltzK=1.0d-3*CONST_BOLTZMANN_/CONV_AU_TO_KJ_)
      Dimension iPermutation(2,MxParT)
      Dimension CordstTEMP(MxCen*MxPut,3)
      Logical CalledBefore,WeiterBitte,Accept,SampleThis
      Save iTemp

      BoltzK=1.0d-3*CONST_BOLTZMANN_/CONV_AU_TO_KJ_
      Dum1=0.0d0
*
*-- If this is first time to call on this routine.
*
      If(.not.CalledBefore) then
        iTemp=0
        CalledBefore=.true.
      Endif

*
*-- See what to do.
*
999   Continue
      If(iTemp.lt.nTemp) then
        WeiterBitte=.true.
        iTemp=iTemp+1
        Write(6,*)
        Write(6,*)'    Run a new temperature ensemble...',iTemp

*----A logical variable to make parallel tempering sampling correct.
        If(iTemp.eq.1) then
          SampleThis=.true.
        Else
          SampleThis=.false.
        Endif

      Else
        WeiterBitte=.false.
        iTemp=0
        Write(6,*)
        Write(6,*)'    Evaluate temperature ensemble interchanges.'
      Endif

*
*-- If we are to run a new ensemble.
*
      If(WeiterBitte) then
        iLuStIn=8+nStFilT(iTemp)
        iLuStUt=16+nStFilT(iTemp)
        Write(StFilIn(6:6),'(i1.1)')nStFilT(iTemp)
        Write(StFilUt(6:6),'(i1.1)')nStFilT(iTemp)

*---- Collect coordinates from proper startfile.
        Call Get8(Ract,Etot)

*---- Set temperature.
        BetaBol=1.0d0/(ParaTemps(iTemp)*BoltzK)

*
*-- If we are to attempt interchanges.
*
      Else

        Do 10, iPa=1,MxParT
          iPermutation(1,iPa)=iPa
          iPermutation(2,iPa)=iPa
10      Continue

*-- Construct permutations, treat nTemp.eq.2 as special case, the others
*   are obtained with general algorithm.
        If(nTemp.eq.2) then
          iPermutation(2,1)=2
          iPermutation(2,2)=1
          Go To 101
        Endif

        PerType=Ranf(iseed)
        If(PerType.lt.0.5D+0) then

          If(Mod(nTemp,2).eq.1) then
            mTemp=nTemp-1
          Else
            mTemp=nTemp
          Endif

*------ Construct permutation for odd iMac
          Do 12, iPa=1,mTemp,2
            iPermutation(2,iPa)=iPermutation(1,iPa+1)
            iPermutation(2,iPa+1)=iPermutation(1,iPa)
12        Continue

        Else

          mTemp=2*((nTemp-1)/2)
*------ Contruct permutation for even iMac
          Do 13, iPa=2,mTemp,2
            iPermutation(2,iPa)=iPermutation(1,iPa+1)
            iPermutation(2,iPa+1)=iPermutation(1,iPa)
13        Continue
        Endif

101     Continue

*
*-- Now attempt interchange.
*
        iEnsemb=1
2001    Continue
          If(iPermutation(1,iEnsemb).eq.iPermutation(2,iEnsemb)) then
            iEnsemb=iEnsemb+1
            Go To 2001
          Endif

*------ Collect energies for the permutations.
          iLuStIn=8+nStFilT(iPermutation(1,iEnsemb))
          iLuStUt=16+nStFilT(iPermutation(1,iEnsemb))
          Write(StFilIn(6:6),'(i1.1)')nStFilT(iPermutation(1,iEnsemb))
          Write(StFilUt(6:6),'(i1.1)')nStFilT(iPermutation(1,iEnsemb))
          Call Get8(Dum,E1)
          iLuStIn=8+nStFilT(iPermutation(2,iEnsemb))
          iLuStUt=16+nStFilT(iPermutation(2,iEnsemb))
          Write(StFilIn(6:6),'(i1.1)')nStFilT(iPermutation(2,iEnsemb))
          Write(StFilUt(6:6),'(i1.1)')nStFilT(iPermutation(2,iEnsemb))
          Call Get8(Dum,E2)
          T1=ParaTemps(iPermutation(1,iEnsemb))
          T2=ParaTemps(iPermutation(2,iEnsemb))
          B1=1.0d0/(BoltzK*T1)
          B2=1.0d0/(BoltzK*T2)

*------ Make the Metropolis thing.
          BigDelta=(B2-B1)*(E2-E1)
          Expe=exp(BigDelta)
          Accept=.true.
          If(Expe.lt.1.0D+0) then
            Expran=ranf(iseed)
            If(Expe.lt.Expran) Accept=.false.
          Endif

          If(Accept) then
*-----Ct=C2
            iLuStIn=8+nStFilT(iPermutation(2,iEnsemb))
            iLuStUt=16+nStFilT(iPermutation(2,iEnsemb))
            Write(StFilIn(6:6),'(i1.1)')nStFilT(iPermutation(2,iEnsemb))
            Write(StFilUt(6:6),'(i1.1)')nStFilT(iPermutation(2,iEnsemb))
            Call Get8(R2,E2)
            Do 221, i=1,3
              Do 222, j=1,nCent*nPart
                CordstTEMP(j,i)=Cordst(j,i)
222           Continue
221         Continue
*-----C2=C1
            iLuStIn=8+nStFilT(iPermutation(1,iEnsemb))
            iLuStUt=16+nStFilT(iPermutation(1,iEnsemb))
            Write(StFilIn(6:6),'(i1.1)')nStFilT(iPermutation(1,iEnsemb))
            Write(StFilUt(6:6),'(i1.1)')nStFilT(iPermutation(1,iEnsemb))
            Call Get8(R1,E1)
            iLuStIn=8+nStFilT(iPermutation(2,iEnsemb))
            iLuStUt=16+nStFilT(iPermutation(2,iEnsemb))
            Write(StFilIn(6:6),'(i1.1)')nStFilT(iPermutation(2,iEnsemb))
            Write(StFilUt(6:6),'(i1.1)')nStFilT(iPermutation(2,iEnsemb))
            Call Put8(R1,E1,Dum1,Dum1,Dum1)
*-----C1=Ct
            Do 223, i=1,3
              Do 224, j=1,nCent*nPart
                Cordst(j,i)=CordstTEMP(j,i)
224           Continue
223         Continue
            iLuStIn=8+nStFilT(iPermutation(1,iEnsemb))
            iLuStUt=16+nStFilT(iPermutation(1,iEnsemb))
            Write(StFilIn(6:6),'(i1.1)')nStFilT(iPermutation(1,iEnsemb))
            Write(StFilUt(6:6),'(i1.1)')nStFilT(iPermutation(1,iEnsemb))
            Call Put8(R2,E2,Dum1,Dum1,Dum1)
          Endif

          iEnsemb=iEnsemb+2
          If(Accept)Write(6,*)'            accepted!'
          If(.not.Accept)Write(6,*)'            not accepted!'
        If(iEnsemb.lt.nTemp) Go To 2001
        Write(6,*)

*
*-- Do some stuff before exit. The reason we go back up is that this
*   way we will collect the right coordinates from first startfile.
*   Observe that iTemp has been reset hence we are back at the
*   square one again.
*
        Go To 999

      Endif

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DistMemPerm(PosT)
! This routine does:
! define initial positions of Permanent
!
! PosT - initial and last position (I/O)

use Index_Functions, only: nTri_Elem
use chcc_global, only: intkey, no, nv, PosA, PosAex, PosFoo, PosFree, PosFvo, PosFvv, PosGoo, PosGvv, PosHoo, PosHvo, PosHvv, &
                       PosOE, PosT1n, PosT1o, printkey
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: PosT
integer(kind=iwp) :: length, nbas(1)

!1.1 Foo file
length = no*no
PosFoo = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Foo ',PosFoo,length

!1.2 Fvo file
length = no*nv
PosFvo = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Fvo ',PosFvo,length

!1.3 Fvv file
length = nv*nv
PosFvv = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Fvv ',PosFvv,length

!2 OE file

call Get_iArray('nBas',nBas,1)
length = nbas(1)

PosOE = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM OE ',PosOE,length

!3.1 T1o file
length = no*nv
PosT1o = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM T1o ',PosT1o,length

!3.2 T1n file
length = no*nv
PosT1n = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM T1n ',PosT1n,length

!4.1 Hoo file
length = no*no
PosHoo = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Hoo ',PosHoo,length

!4.2 Hvo file
length = no*nv
PosHvo = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Hvo ',PosHvo,length

!4.3 Hvv file
length = nv*nv
PosHvv = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Hvv ',PosHvv,length

!5.1 Goo file
length = no*no
PosGoo = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Goo ',PosGoo,length

!5.2 Hvv file
length = nv*nv
PosGvv = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM Gvv ',PosGvv,length

!6.1 A files @@ A file medzi fixnymi je na zamyslenie (lebo je o4)
length = no*no*nTri_Elem(no)
PosA = PosT
PosT = PosT+length
if (printkey >= 10) write(u6,*) 'DM A   ',PosA,length
if (intkey == 0) then
  PosAex = PosT
  PosT = PosT+length
  if (printkey >= 10) write(u6,*) 'DM Aex ',PosAex,length
else
  PosAex = PosT
end if

!omega PosFree - position of the space, where work arrays started
PosFree = PosT

return

end subroutine DistMemPerm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1999, Roland Lindh                      *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine k2Loop(Coor,iDCRR,nDCRR,k2data,Alpha,nAlpha,Beta,nBeta,Alpha_,Beta_,Coeff1,iBasn,Coeff2,jBasn,Zeta,ZInv,Kappab,P,IndP, &
                  nZeta,IncZZ,Con,Wrk,nWork2,nScree,mScree,ijCmp,DoFock,Scr,nScr,Knew,Lnew,Pnew,Qnew,nNew,DoGrad,HMtrx,nHrrMtrx, &
                  nSD,iSD4)
!***********************************************************************
!                                                                      *
! Object: to compute zeta, kappa, P, and the integrals [nm|nm] for     *
!         prescreening. This is done for all unique pairs of centers   *
!         generated from the symmetry unique centers A and B.          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN.                              *
!             June '91, modified to compute zeta, P, kappa and inte-   *
!             grals for Schwarz inequality in a k2 loop.               *
!             Modified for direct SCF, January '93                     *
!***********************************************************************

use Index_Functions, only: nTri3_Elem1
use Real_Spherical, only: ipSph, rSph
use Basis_Info, only: Shells
use Symmetry_Info, only: iOper, nIrrep
use Disp, only: Dirct, IndDsp
use k2_structure, only: k2_type
use k2_arrays, only: DeDe, DoHess_
use Rys_interfaces, only: cff2d_kernel, modu2_kernel, rys2d_kernel, tval_kernel
use Dens_Stuff, only: ipDij, mDCRij, mDij
use Constants, only: Zero, One, Four
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iDCRR(0:7), nDCRR, nAlpha, nBeta, iBasn, jBasn, nZeta, IncZZ, nWork2, ijCmp, nScr, nNew, &
                                 nHRRMtrx, nSD, iSD4(0:nSD,4)
real(kind=wp), intent(in) :: Coor(3,4), Alpha(nAlpha), Beta(nBeta), Coeff1(nAlpha,iBasn), Coeff2(nBeta,jBasn), Con(nZeta)
type(k2_type), intent(inout) :: k2data(nDCRR)
real(kind=wp), intent(out) :: Alpha_(nZeta), Beta_(nZeta), Zeta(nZeta), ZInv(nZeta), Kappab(nZeta), P(nZeta,3), Scr(nScr,3), &
                              Knew(nNew), Lnew(nNew), Pnew(nNew*3), Qnew(nNew*3), HMtrx(nHrrMtrx,2)
integer(kind=iwp), intent(out) :: IndP(nZeta)
real(kind=wp), intent(inout) :: Wrk(nWork2)
integer(kind=iwp), intent(inout) :: nScree, mScree
logical(kind=iwp), intent(in) :: DoFock, DoGrad
integer(kind=iwp) :: i_Int, iAnga(4), iCmp, iCmpa(4), iCmpa_, iCnt, iComp, iIrrep, iOffZ, iShll(4), iShlla, iSmAng, iw2, iw3, &
                     iZeta, jCmpb_, Jnd, jShllb, la, lb, lDCRR, lZeta, mabcd, mabMax, mabMin, mcdMax, mcdMin, mStb(2), mZeta, &
                     nDisp, ne, nT
real(kind=wp) :: abConMax, abMax, abMaxD, CoorAC(3,2), CoorM(3,4), Delta, Q(3), TA(3), TB(3), TEMP, ZetaM
real(kind=wp), target :: Dummy(1)
real(kind=wp), pointer :: Dij(:,:)
logical(kind=iwp) :: AeqB, NoSpecial
procedure(cff2d_kernel) :: Cff2DS
procedure(modu2_kernel) :: ModU2
procedure(rys2d_kernel) :: Rys2D
procedure(tval_kernel) :: TERIS
real(kind=wp), external :: EstI
logical(kind=iwp), external :: EQ, TF

iShll(:) = iSD4(0,:)
iAnga(:) = iSD4(1,:)
iCmpa(:) = iSD4(2,:)

if (DoFock) then
  Dij(1:mDij,1:mDCRij) => DeDe(ipDij:ipDij+mDij*mDCRij-1)
else
  Dij(1:1,1:1) => Dummy(1:1)
end if

!                                                                      *
!***********************************************************************
!                                                                      *
Q(:) = One
mStb(1:2) = iSD4(10,1:2)
la = iAnga(1)
lb = iAnga(2)
iSmAng = la+lb+la+lb
iCmpa_ = iCmpa(1)
jCmpb_ = iCmpa(2)
iShlla = iShll(1)
jShllb = iShll(2)
!                                                                      *
!***********************************************************************
!                                                                      *
CoorM(:,1) = Coor(:,1)
!                                                                      *
!***********************************************************************
!                                                                      *
do lDCRR=0,nDCRR-1

  call OA(iDCRR(lDCRR),Coor(1:3,2),CoorM(1:3,2))
  AeqB = EQ(CoorM(1,1),CoorM(1,2))
  ! Branch out if integrals are zero by symmetry.
  if (AeqB .and. (mod(iSmAng,2) == 1)) cycle
  CoorM(:,3:4) = CoorM(:,1:2)
# ifdef _DEBUGPRINT_
  call RecPrt(' Actual centers',' ',CoorM,3,4)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute zeta, P and kappa.

  ! No triangulatization applied at this level
  call DoZeta(Alpha,nAlpha,Beta,nBeta,CoorM(1,1),CoorM(1,2),P,Zeta,Kappab,ZInv,Alpha_,Beta_,IndP)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Generate transformation matrix from intermediate integrals
  ! to final angular composition.

  mabMin = nTri3_Elem1(max(la,lb)-1)
  if (EQ(CoorM(1,1),CoorM(1,2))) mabMin = nTri3_Elem1(la+lb-1)
  mabMax = nTri3_Elem1(la+lb)-1
  ne = (mabMax-mabMin+1)
  do iIrrep=0,nIrrep-1
    call OA(iOper(iIrrep),CoorM(1:3,1),TA)
    call OA(iOper(iIrrep),CoorM(1:3,2),TB)
    k2Data(lDCRR+1)%HrrMtrx(:,iIrrep+1) = Zero
    call HrrMtrx(k2Data(lDCRR+1)%HrrMtrx(:,iIrrep+1),ne,la,lb,TA,TB,Shells(iShlla)%Transf,RSph(ipSph(la)),iCmpa_, &
                 Shells(jShllb)%Transf,RSph(ipSph(lb)),jCmpb_)
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute primitive integrals to be used in the prescreening
  ! by the Schwarz inequality.

  ! Compute actual size of [a0|c0] block

  mcdMin = mabMin
  mcdMax = mabMax
  mabcd = (mabMax-mabMin+1)*(mcdMax-mcdMin+1)

  ! Find the proper centers to start of with the angular
  ! momentum on. If la == lb there will exist an
  ! ambiguity to which center that angular momentum should
  ! be accumulated on. In that case we will use A and C of
  ! the order as defined by the basis functions types.

  if (iAnga(1) >= iAnga(2)) then
    CoorAC(:,1) = CoorM(:,1)
  else
    CoorAC(:,1) = CoorM(:,2)
  end if
  CoorAC(:,2) = CoorAC(:,1)

  ! Compute [a0|c0], ijkl,a,c

  Jnd = 0
  nScree = nScree+nZeta
  do iZeta=1,nZeta,IncZZ
    mZeta = min(nZeta-iZeta+1,IncZZ)

    nT = mZeta*1
    NoSpecial = .true.
    call Rys(iAnga,nT,Zeta(iZeta),ZInv(iZeta),mZeta,[One],[One],1,P(iZeta,1),nZeta,Q,1,Kappab(iZeta),[One],CoorM,CoorM,CoorAC, &
             mabMin,mabMax,mcdMin,mcdMax,Wrk,nWork2,TERIS,ModU2,Cff2DS,Rys2D,NoSpecial)
#   ifdef _DEBUGPRINT_
    call RecPrt(' In k2Loop: ijkl,[a0|c0]',' ',Wrk,mZeta,mabcd)
#   endif

    ! Apply a transpose prior to Tnsctl to fake the action of Cntrct.

    iW3 = 1+mZeta*mabcd
    call DGeTMO(Wrk,mZeta,mZeta,mabcd,Wrk(iW3),mabcd)
    Wrk(1:mabcd*mZeta) = Wrk(iW3:iW3+mabcd*mZeta-1)
    call TnsCtl(Wrk,nWork2,mZeta,mabMax,mabMin,mabMax,mabMin,k2data(lDCRR+1)%HrrMtrx(:,1),k2data(lDCRR+1)%HrrMtrx(:,1),la,lb,la, &
                lb,iCmpa_,jCmpb_,iCmpa_,jCmpb_,iShlla,jShllb,iShlla,jShllb,i_Int)
    if (i_Int == 1) then
      iW2 = 1
      iW3 = 1+mZeta*(iCmpa_*jCmpb_)**2
    else
      iW2 = i_Int
      iW3 = 1
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Store data in core

    call Cmpct(Wrk(iW2),iCmpa_,jCmpb_,nZeta,mZeta,Zeta(iZeta),Kappab(iZeta),P(iZeta,1),IndP(iZeta),Con,k2Data(lDCRR+1)%Zeta(:), &
               k2Data(lDCRR+1)%Kappa(:),k2Data(lDCRR+1)%PCoor(:,:),k2Data(lDCRR+1)%IndZ(:),iZeta-1,Jnd,k2Data(lDCRR+1)%ZInv(:), &
               AeqB,k2Data(lDCRR+1)%ab(:),k2Data(lDCRR+1)%abCon(:),Alpha_(iZeta),k2Data(lDCRR+1)%Alpha(:),Beta_(iZeta), &
               k2Data(lDCRR+1)%Beta(:))

  end do ! iZeta
  mScree = mScree+Jnd
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Estimate the largest contracted integral.

  k2Data(lDCRR+1)%EstI = EstI(nAlpha,nBeta,Coeff1,iBasn,Coeff2,jBasn,k2Data(lDCRR+1)%ab(:),Wrk,nWork2,k2Data(lDCRR+1)%IndZ(:))
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Find the largest integral estimate (AO Basis).

  ZetaM = -One
  do iZeta=1,Jnd
    ZetaM = max(k2Data(lDCRR+1)%Zeta(iZeta),ZetaM)
  end do
  k2Data(lDCRR+1)%ZetaM = ZetaM

  iOffZ = mDij-nZeta-1
  abMax = Zero
  abConMax = Zero
  abMaxD = Zero
  do iZeta=0,Jnd-1
    abConMax = max(abConMax,k2Data(lDCRR+1)%abCon(iZeta+1))
    abMax = max(abMax,k2Data(lDCRR+1)%ab(iZeta+1))
    if (DoFock) then
      abMaxD = max(abMaxD,k2Data(lDCRR+1)%ab(iZeta+1)*Dij(iOffZ+iZeta,lDCRR+1))
    else
      abMaxD = Zero
    end if
  end do
  k2Data(lDCRR+1)%abMax = abMax
  k2Data(lDCRR+1)%abConMax = abConMax
  k2Data(lDCRR+1)%abMaxD = abMaxD

  if (DoHess_) then
    abMax = Zero
    do iZeta=1,Jnd
      abMax = max(abMax,k2Data(lDCRR+1)%ab(iZeta))
    end do
    k2data(lDCRR+1)%abMax = abMax
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute data for gradient evaluation

  mZeta = Jnd
  if (DoGrad .and. (mZeta > 0)) then

    ! Compute primitive integrals to be used in the prescreening
    ! by the Cauchy-Schwarz inequality.

    do iZeta=1,mZeta,IncZZ
      lZeta = min(mZeta-iZeta+1,IncZZ)
      call SchInt(CoorM,iAnga,lZeta,k2Data(lDCRR+1)%Zeta(iZeta:),k2Data(lDCRR+1)%ZInv(iZeta:),k2Data(lDCRR+1)%Kappa(iZeta:), &
                  k2Data(lDCRR+1)%PCoor(iZeta:,:),k2Data(lDCRR+1)%Kappa(iZeta:),k2Data(lDCRR+1)%PCoor(iZeta:,:),nZeta,Wrk,nWork2, &
                  HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
      call PckInt(Wrk(i_Int),lZeta,ijCmp,k2Data(lDCRR+1)%abG(iZeta:,1),k2Data(lDCRR+1)%Kappa(iZeta:),.true., &
                  k2Data(lDCRR+1)%Zeta(iZeta:),nZeta,Dummy)
    end do

    ! Second order numerical differentiation. The gradients are
    ! restricted to only those with respect to symmetrical
    ! displacements. The symmetric three point formula is used in
    ! the numerical procedure.

    iIrrep = 0
    Delta = 1.0e-3_wp
    k2Data(lDCRR+1)%abG(:,2) = Zero
    Scr(1:nZeta*ijCmp,:) = Zero

    ! Loop over center A and B.

    do iCnt=1,2

      nDisp = IndDsp(mStb(iCnt),iIrrep)
      do iComp=1,3
        iCmp = 2**(iComp-1)
        if (TF(mStb(iCnt),iIrrep,iCmp) .and. Dirct(nDisp+1)) then
          nDisp = nDisp+1
          temp = CoorM(iComp,iCnt)

          CoorM(iComp,iCnt) = temp+Delta
          CoorM(iComp,iCnt+2) = temp+Delta
          call NewPK(CoorM(1,1),CoorM(1,2),Pnew,mZeta,nZeta,Knew,k2Data(lDCRR+1)%Alpha(:),k2Data(lDCRR+1)%Beta(:))
          do iZeta=1,mZeta,IncZZ
            lZeta = min(mZeta-iZeta+1,IncZZ)
            call SchInt(CoorM,iAnga,lZeta,k2Data(lDCRR+1)%Zeta(iZeta:),k2Data(lDCRR+1)%ZInv(iZeta:),Knew(iZeta),Pnew(iZeta), &
                        Knew(iZeta),Pnew(iZeta),nZeta,Wrk,nWork2,HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
            call PckInt(Wrk(i_Int),lZeta,ijCmp,Scr(iZeta,1),Knew(iZeta),.false.,k2Data(lDCRR+1)%Zeta(iZeta:),nZeta,Knew(iZeta))
          end do

          CoorM(iComp,iCnt) = temp-Delta
          CoorM(iComp,iCnt+2) = temp-Delta
          call NewPK(CoorM(1,1),CoorM(1,2),Qnew,mZeta,nZeta,Lnew,k2Data(lDCRR+1)%Alpha(:),k2Data(lDCRR+1)%Beta(:))
          do iZeta=1,mZeta,IncZZ
            lZeta = min(mZeta-iZeta+1,IncZZ)
            call SchInt(CoorM,iAnga,lZeta,k2Data(lDCRR+1)%Zeta(iZeta:),k2Data(lDCRR+1)%ZInv(iZeta:),Lnew(iZeta),Qnew(iZeta), &
                        Lnew(iZeta),Qnew(iZeta),nZeta,Wrk,nWork2,HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
            call PckInt(Wrk(i_Int),lZeta,ijCmp,Scr(iZeta,2),Lnew(iZeta),.false.,k2Data(lDCRR+1)%Zeta(iZeta:),nZeta,Lnew(iZeta))
          end do

          Scr(1:nZeta*ijCmp,1) = Scr(1:nZeta*ijCmp,1)+Scr(1:nZeta*ijCmp,2)

          CoorM(iComp,iCnt) = temp+Delta
          CoorM(iComp,iCnt+2) = temp-Delta
          do iZeta=1,mZeta,IncZZ
            lZeta = min(mZeta-iZeta+1,IncZZ)
            call SchInt(CoorM,iAnga,lZeta,k2Data(lDCRR+1)%Zeta(iZeta:),k2Data(lDCRR+1)%ZInv(iZeta:),Knew(iZeta),Pnew(iZeta), &
                        Lnew(iZeta),Qnew(iZeta),nZeta,Wrk,nWork2,HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
            call PckInt(Wrk(i_Int),lZeta,ijCmp,Scr(iZeta,3),Knew(iZeta),.false.,k2Data(lDCRR+1)%Zeta(iZeta:),nZeta,Lnew(iZeta))
          end do

          Scr(1:nZeta*ijCmp,1) = Scr(1:nZeta*ijCmp,1)-Scr(1:nZeta*ijCmp,3)

          CoorM(iComp,iCnt) = temp-Delta
          CoorM(iComp,iCnt+2) = temp+Delta
          do iZeta=1,mZeta,IncZZ
            lZeta = min(mZeta-iZeta+1,IncZZ)
            call SchInt(CoorM,iAnga,lZeta,k2Data(lDCRR+1)%Zeta(iZeta:),k2Data(lDCRR+1)%ZInv(iZeta:),Lnew(iZeta),Qnew(iZeta), &
                        Knew(iZeta),Pnew(iZeta),nZeta,Wrk,nWork2,HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
            call PckInt(Wrk(i_Int),lZeta,ijCmp,Scr(iZeta,3),Lnew(iZeta),.false.,k2Data(lDCRR+1)%Zeta(iZeta:),nZeta,Knew(iZeta))
          end do

          Scr(1:nZeta*ijCmp,1) = (Scr(1:nZeta*ijCmp,1)-Scr(1:nZeta*ijCmp,3))/(Four*Delta**2)
          k2data(lDCRR+1)%abG(1:nZeta*ijCmp,2) = k2data(lDCRR+1)%abG(1:nZeta*ijCmp,2)+sqrt(abs(Scr(1:nZeta*ijCmp,1)))

          CoorM(iComp,iCnt) = temp
          CoorM(iComp,iCnt+2) = temp
        end if
      end do

    end do
  end if       ! DoGrad
  !                                                                    *
  !*********************************************************************
  !                                                                    *
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'lDCRR=',lDCRR
  call WrCheck('Zeta ',k2Data(lDCRR+1)%Zeta(:),nZeta)
  call WrCheck('Kappa',k2Data(lDCRR+1)%Kappa(:),nZeta)
  call WrCheck('P    ',K2Data(lDCRR+1)%PCoor(:,:),nZeta*3)
  call WrCheck('xA   ',k2Data(lDCRR+1)%Alpha(:),nZeta)
  call WrCheck('xB   ',k2Data(lDCRR+1)%Beta(:),nZeta)
  call WrCheck('ZInv ',k2Data(lDCRR+1)%ZInv(:),nZeta)
  if (DoGrad) then
    call WrCheck('ab   ',k2data(lDCRR+1)%abG(:,1),nZeta*ijCmp)
    call WrCheck('abG  ',k2data(lDCRR+1)%abG(:,2),nZeta*ijCmp)
  end if
  write(u6,*)
  write(u6,*) ' ERI(Max)=',k2Data(lDCRR+1)%EstI
  write(u6,*) ' abMax   =',k2Data(lDCRR+1)%abMax
  write(u6,*) ' abMaxD  =',k2Data(lDCRR+1)%abMaxD
  call WrCheck(' HrrMtrx',k2Data(lDCRR+1)%HrrMtrx(:,:),ne*iCmpa_*jCmpb_)
# endif
end do ! lDCRR

end subroutine k2Loop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine ReaW (W,aSGrp,beSGrp,bSGrp,gaSGrp,LunInt)
c
c       simuluje citanie VVVV integralov
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 W(1)
        integer aSGrp,beSGrp,bSGrp,gaSGrp,LunInt
c
c       help variables
        integer dim
c
        dim=DimSGrpa(aSGrp)*DimSGrpbe(beSGrp)*
     c      DimSGrpa(bSGrp)*DimSGrpbe(gaSGrp)
c
        call rea1 (LunInt,dim,W(1))
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine PrGrad_pcm(Label,Grad,nGrad,Names,iPrint)
!***********************************************************************
!                                                                      *
! Object: to print set gradient with respect to the symmetrical dis-   *
!         placements.                                                  *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!***********************************************************************

use Symmetry_Info, only: lIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: nGrad, iPrint
character(len=LenIn6), intent(in) :: Names(nGrad)
real(kind=wp), intent(in) :: Grad(nGrad)
integer(kind=iwp) :: iCen, iGrad, mGrad
real(kind=wp) :: Temp, TempX, TempY, TempZ
character(len=LenIn5) :: Namei
real(kind=wp), allocatable :: CGrad(:,:)
character(len=LenIn5), allocatable :: CNames(:)

write(u6,*)
call Banner(Label,1,len(Label)+30)
write(u6,*)
if (iPrint == 4) then
  call mma_allocate(CGrad,3,MxAtom,label='CGrad')
  call mma_allocate(CNames,MxAtom,label='CNames')
  call TrGrd_Alaska_(CGrad,CNames,Grad,nGrad,iCen)
  write(u6,'(1x,A,A)') ' Irreducible representation: ',lIrrep(0)
  write(u6,'(1x,A)') '--------------------------------------------------'
  write(u6,'(1x,A)') '                    X           Y           Z     '
  write(u6,'(1x,A)') '--------------------------------------------------'
  do iGrad=1,iCen
    TempX = CGrad(1,iGrad)
    TempY = CGrad(2,iGrad)
    TempZ = CGrad(3,iGrad)
    Namei = CNames(iGrad)
    write(u6,'(2X,A,3X,3F12.6)') Namei,TempX,TempY,TempZ
  end do
  write(u6,'(1x,A)') '--------------------------------------------------'
  call mma_deallocate(CGrad)
  call mma_deallocate(CNames)
else

  ! Modified by Luca De Vico november 2005 Teokem
  ! I need to print the full gradient vector
  ! to use it for constrained optimizations
  ! with TRANSVERSE option in SLAPAF MODULE

  !mGrad = min(21,nGrad)

  mGrad = nGrad
  write(u6,'(15x,A,A)') ' Irreducible representation: ',lIrrep(0)
  write(u6,*)
  do iGrad=1,mGrad
    Temp = Grad(iGrad)
    if (abs(Temp) < 1.0e-15_wp) Temp = Zero
    write(u6,'(16X,A,15X,E15.7)') Names(iGrad),Temp
  end do

  !if (nGrad > 21) then
  !  write(u6,*)
  !  write(u6,*) '   ... list is truncated ...'
  !  write(u6,*)
  !end if

  ! End of modifications

end if
write(u6,*)

return

end subroutine PrGrad_pcm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      CHARACTER*40 FUNCTION PIKNAM (LINED,KEYW)
C
C...  picks a character item up from a line like
C     ITEM_NAME  value  COMMENTS
C
C     returns ' ' when it fails to pick the item up.
C
C       LINED        input line to be searched
C       KEYW         keyword
C
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*40 KEYW
      CHARACTER*80 LINE,LINED
      LOGICAL FOUND
C
      IK=0
      LL=0
      IL=0
C
      LINE=LINED
      LK=1
      DO 10 I=40,1,-1
        IF (KEYW(I:I).NE.' ') THEN
          LK=I
          GO TO 11
        ENDIF
10    CONTINUE
11    CONTINUE
      DO 12 I=1,40
        IF (KEYW(I:I).NE.' ') THEN
          IK=I
          GO TO 13
        ENDIF
12    CONTINUE
13    CONTINUE
C
      ISTRT=INDEX(LINE,KEYW(IK:LK))
      IF (ISTRT.EQ.0) THEN
C...    the keyword has not been found in the line.
        PIKNAM=' '
        RETURN
      ENDIF
      ISTRT=ISTRT+LK-IK+1
      IF (LINE(ISTRT:ISTRT).NE.' ') THEN
C...    the keyword is not followed by a blank character.
        PIKNAM=' '
        RETURN
      ELSE IF (ISTRT.GE.80) THEN
C...    the line finishes after the keyword.
        PIKNAM=' '
        RETURN
      ELSE
        ISTRT=ISTRT+1
      ENDIF
C
      FOUND=.FALSE.
      DO 20 I=ISTRT,80
        IF (FOUND) THEN
          IF (LINE(I:I).EQ.' ') THEN
            LL=I-1
            GO TO 21
          ENDIF
        ELSE
          IF (LINE(I:I).NE.' ') THEN
            FOUND=.TRUE.
            IL=I
          ENDIF
        ENDIF
20    CONTINUE
21    CONTINUE
C
      IF (FOUND) THEN
        PIKNAM=LINE(IL:LL)
          WRITE (LINE,601) LK,LL-IL+1
C         WRITE (6,LINE) KEYW(:LK),PIKNAM
      ELSE
        PIKNAM=' '
      ENDIF
C
      RETURN
601   FORMAT ('('' PIKNAM:         '',A',I2.2,',1X,A',I2.2,')')
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Sp_Mlt(W_In,ne,W_out,nVec,C,nab)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Parameter(meMax=10)
      Real*8 W_In(ne,nVec), W_Out(nVec,nab), C(ne,nab)
      Integer iAux(meMax+1)
*
      Do iab = 1, nab
         me=0
         Do ie = 1, ne
            If (C(ie,iab).ne.Zero) Then
               me=me+1
               iAux(me)=ie
               If (me.gt.meMax) Go To 98
            End If
         End Do
*
         If (me.eq.1) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
            End Do
         Else If (me.eq.2) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
            End Do
         Else If (me.eq.3) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
     &                        +C(iAux(3),iab)*W_In(iAux(3),iVec)
            End Do
         Else If (me.eq.4) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
     &                        +C(iAux(3),iab)*W_In(iAux(3),iVec)
     &                        +C(iAux(4),iab)*W_In(iAux(4),iVec)
            End Do
         Else If (me.eq.5) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
     &                        +C(iAux(3),iab)*W_In(iAux(3),iVec)
     &                        +C(iAux(4),iab)*W_In(iAux(4),iVec)
     &                        +C(iAux(5),iab)*W_In(iAux(5),iVec)
            End Do
         Else If (me.eq.6) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
     &                        +C(iAux(3),iab)*W_In(iAux(3),iVec)
     &                        +C(iAux(4),iab)*W_In(iAux(4),iVec)
     &                        +C(iAux(5),iab)*W_In(iAux(5),iVec)
     &                        +C(iAux(6),iab)*W_In(iAux(6),iVec)
            End Do
         Else If (me.eq.7) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
     &                        +C(iAux(3),iab)*W_In(iAux(3),iVec)
     &                        +C(iAux(4),iab)*W_In(iAux(4),iVec)
     &                        +C(iAux(5),iab)*W_In(iAux(5),iVec)
     &                        +C(iAux(6),iab)*W_In(iAux(6),iVec)
     &                        +C(iAux(7),iab)*W_In(iAux(7),iVec)
            End Do
         Else If (me.eq.8) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
     &                        +C(iAux(3),iab)*W_In(iAux(3),iVec)
     &                        +C(iAux(4),iab)*W_In(iAux(4),iVec)
     &                        +C(iAux(5),iab)*W_In(iAux(5),iVec)
     &                        +C(iAux(6),iab)*W_In(iAux(6),iVec)
     &                        +C(iAux(7),iab)*W_In(iAux(7),iVec)
     &                        +C(iAux(8),iab)*W_In(iAux(8),iVec)
            End Do
         Else If (me.eq.9) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
     &                        +C(iAux(3),iab)*W_In(iAux(3),iVec)
     &                        +C(iAux(4),iab)*W_In(iAux(4),iVec)
     &                        +C(iAux(5),iab)*W_In(iAux(5),iVec)
     &                        +C(iAux(6),iab)*W_In(iAux(6),iVec)
     &                        +C(iAux(7),iab)*W_In(iAux(7),iVec)
     &                        +C(iAux(8),iab)*W_In(iAux(8),iVec)
     &                        +C(iAux(9),iab)*W_In(iAux(9),iVec)
            End Do
         Else If (me.eq.10) Then
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
     &                        +C(iAux(3),iab)*W_In(iAux(3),iVec)
     &                        +C(iAux(4),iab)*W_In(iAux(4),iVec)
     &                        +C(iAux(5),iab)*W_In(iAux(5),iVec)
     &                        +C(iAux(6),iab)*W_In(iAux(6),iVec)
     &                        +C(iAux(7),iab)*W_In(iAux(7),iVec)
     &                        +C(iAux(8),iab)*W_In(iAux(8),iVec)
     &                        +C(iAux(9),iab)*W_In(iAux(9),iVec)
     &                        +C(iAux(10),iab)*W_In(iAux(10),iVec)
            End Do
         Else If (me.eq.10) Then
            Call RecPrt('C',' ',C,ne,nab)
            Call WarningMessage(2,'Error in Sp_Mlt!')
            Call Abend()
         End If
         Go To 99
*
 98      Continue
            Do iVec = 1, nVec
               W_Out(iVec,iab)=C(iAux(1),iab)*W_In(iAux(1),iVec)
     &                        +C(iAux(2),iab)*W_In(iAux(2),iVec)
     &                        +C(iAux(3),iab)*W_In(iAux(3),iVec)
     &                        +C(iAux(4),iab)*W_In(iAux(4),iVec)
     &                        +C(iAux(5),iab)*W_In(iAux(5),iVec)
     &                        +C(iAux(6),iab)*W_In(iAux(6),iVec)
     &                        +C(iAux(7),iab)*W_In(iAux(7),iVec)
     &                        +C(iAux(8),iab)*W_In(iAux(8),iVec)
     &                        +C(iAux(9),iab)*W_In(iAux(9),iVec)
     &                        +C(iAux(10),iab)*W_In(iAux(10),iVec)
            End Do
            Do ie = iAux(meMax+1), ne
               If (C(ie,iab).ne.Zero)
     &            Call DaXpY_(nVec,C(ie,iab),W_In(ie,1),ne,
     &                                      W_Out(1,iab),1)
            End Do
 99      Continue
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine RdInp_Polar(LuSpool,NoField,Delta,MpProp_Level,
     &                       Bond_Threshold,iPlot,iPrint,Standard,
     &                       Opt_Method,UserDen,PrintDen,SubtractDen,
     &                       SubScale,Restart,TDensity,nStateI,nStateF,
     &                       XHole,Diffuse,dLimmo,Thrs1,Thrs2,nThrs,
     &                       ThrsMul,Alpha,LIonize)
*
      Implicit Real*8 (a-h,o-z)
*
*---- Define local variables
      Character*180 Key, Line, BLIne
      Character*180 Get_Ln
      Character*12  Opt_Method
      External Get_Ln
      Logical lTtl, NoField, Standard, UserDen, PrintDen, SubtractDen
      Logical Restart, Found, TDensity, XHole, Diffuse(3)
      Logical LIonize
      Dimension dLimmo(2)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      BLine=' '
      Delta=0.001D00
      Call Get_iScalar('Highest Mltpl',lMax)
      MpProp_Level = lMax
      Bond_Threshold = 1.5D0
      iPlot = 0
      iPrint = 0
      Standard= .True.
      UserDen=.False.
      PrintDen=.False.
      SubtractDen=.False.
      Restart=.False.
      iRestart = 0
      SubScale=1.0D0
      nStateI=1
      nStateF=2
      Opt_Method = ' '
      TDensity=.False.
      XHole=.False.
      Diffuse(1)=.False.
      Diffuse(2)=.False.
      Diffuse(3)=.False.
      dLimmo(1)=0.65d0
      dLimmo(2)=2.0d0
      Thrs1=1d-5
      Thrs2=1d-4
      nThrs=3
      ThrsMul=1d-2
      Alpha=7.1421297D0
      LIonize=.False.

*     Comment on Alpha:
*     This value of Alpha is for backward-compability.
*     For large systems it may have to be reduced, for
*     example to 2.0.

*
*---- Locate "start of input"
      Rewind(LuSpool)
      Call RdNLst(LuSpool,'LoProp')
*
      lTtl=.False.
  999 Continue
      Key = Get_Ln(LuSpool)
      Line = Key
      Call UpCase(Line)
*
c     If (Line(1:4).eq.'TITL') Go To 8000
      If (Line(1:4).eq.'NOFI') Go To 8001
      If (Line(1:4).eq.'DELT') Go To 8002
      If (Line(1:4).eq.'EXPA') Go To 8003
      If (Line(1:4).eq.'MPPR') Go To 8004
      If (Line(1:4).eq.'BOND') Go To 8005
      If (Line(1:4).eq.'PLOT') Go To 8006
      If (Line(1:4).eq.'PRIN') Go To 8007
      If (Line(1:4).eq.'USER') Go To 8008
      If (Line(1:4).eq.'PRDE') Go To 8009
      If (Line(1:4).eq.'SUBD') Go To 8010
      If (Line(1:4).eq.'REST') Go To 8011
      If (Line(1:4).eq.'TDEN') Go To 8012
      If (Line(1:4).eq.'XHOL') Go To 8013
      If (Line(1:4).eq.'DIFF') Go To 8014
      If (Line(1:4).eq.'ALPH') Go To 8015
      If (Line(1:4).eq.'LION') Go To 8016
      If (Line(1:4).eq.'END ') Go To 9000
      Write (6,*) 'Unidentified key word:', Key
      Call FindErrorLine
      Call Quit_OnUserError()
*
*>>>>>>>>>>>>> TITL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C8000 Continue
      GoTo 999
*
*>>>>>>>>>>>>> NOFI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 8001 Continue
      NoField=.True.
      GoTo 999
*
*>>>>>>>>>>>>> DELT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 8002 Continue
      Key = Get_Ln(LuSpool)
      Call Get_F1(1,Delta)
      GoTo 999
*
*>>>>>>>>>>>>> EXPA <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 8003 Continue
      Key = Get_Ln(LuSpool)
      Line = Key
      Call UpCase(Line)

      If (Line(1:4) .eq. 'MIDP') Then
         Standard=.True.
      Else If (Line(1:4) .eq. 'OPTI') Then
         Standard=.False.
         Opt_Method = 'Optimized'
      Else If (Line(1:4) .eq. 'MULT') Then
         Standard = .False.
         Opt_Method = 'Multipole'
      Else
         Write(6,*) 'Undefined option for ''EXPAnsion center'':',Key
         Call FindErrorLine
         Call Quit_OnUserError()
      End If
      GoTo 999
*
*>>>>>>>>>>>>> MPPR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Read max multipole level for output in the MpProp file
 8004 Continue
      Key = Get_Ln(LuSpool)
      Call Get_I1(1,MpProp_Level)
      GoTo 999
*
*>>>>>>>>>>>>> BOND <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Read max bond length - all bonds longer than this will be ignored
 8005 Continue
      Key = Get_Ln(LuSpool)
      Call Get_F1(1,Bond_Threshold)
      GoTo 999
*
*>>>>>>>>>>>>> PLOT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Provide informations needed for plotting t vs. bond coordinate
* as well as printing a table of t values.
 8006 Continue
      iPlot = 1
      Goto 999
*
*>>>>>>>>>>>>> PRIN   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Read print level
 8007 Continue
      Key = Get_Ln(LuSpool)
      Call Get_I1(1,iPrint)
      GoTo 999
*
*>>>>>>>>>>>>>> USER   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Tell LoProp to read in density matrix(es) supplied by user.
 8008 Continue
      UserDen=.True.
      GoTo 999
*
*
*>>>>>>>>>>>>>> PRDE   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Tell LoProp to output density matrix to file
 8009 Continue
      PrintDen=.True.
      NoField=.True. !Only static properties allowed
      GoTo 999
*
*
*>>>>>>>>>>>>>> SUBD   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Tell LoProp to subtract a user supplied density matrix
* from the current one (which could also be a USER supplied
* density matrix). Also input a scaling factor which the
* difference density is multiplied by.
 8010 Continue
      SubtractDen=.True.
      NoField=.True. !Only static properties allowed
      Key = Get_Ln(LuSpool)
      Call Get_F1(1,SubScale)
      GoTo 999
*
*>>>>>>>>>>>>> NOFI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Restart LoProp with the info stored in a previous LoProp
* calculation.
 8011 Continue
      Restart=.True.
      Call Qpg_iScalar('LoProp Restart',Found)
      If (Found) Then
         Call Get_iScalar('LoProp Restart',iRestart)
      End If
      If (iRestart .eq. 0) Then
         Write(6,*) 'LoProp was not able to restart.'
         Write(6,*) 'Make sure that LoProp was completed on a previous'
     &            //'run.'
         Call Quit_OnUserError()
      End If
      GoTo 999

*
*>>>>>>>>>>>>>> TDEN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Tell LoProp to collect a transition density from a previous
* Rassi-calculation.
 8012 Continue
      TDensity=.true.
      NoField=.true.
      Key=Get_Ln(LuSpool)
      Call Get_I1(1,nStateI)
      Call Get_I1(2,nStateF)
      Go To 999

*
*>>>>>>>>>>>>>>> XHOLe <<<<<<<<<<<<<<<<<<<<<<<<<<<<
* Compute and distribute exchange-hole dipole moments for
* dispersion coefficients.
 8013 Continue
      XHole=.true.
      NoField=.true.
      Go To 999

*
*>>>>>>>>>>>>>>>> DIFFuse <<<<<<<<<<<<<<<<<<<<<<<<<<
* Section for turning the LoProp moments into diffuse
* functions, i.e. obtain an exponent. No moving of bond
* stuff allowed.
 8014 Continue
      NoField=.true.
      Bond_Threshold=1.0d20
      Key = Get_Ln(LuSpool)
      Line = Key
      Call UpCase(Line)
      If(Line(1:4).eq.'NUME') then
        Diffuse(1)=.true.
        Diffuse(2)=.true.
80141   Continue
        Key=Get_Ln(LuSpool)
        Line = Key
        Call UpCase(Line)
        If(Line(1:4).eq.'LIMI') then
          Key = Get_Ln(LuSpool)
          Call Get_F(1,dLimmo,2)
        Elseif(Line(1:4).eq.'THRE') then
          Key=Get_Ln(LuSpool)
          Call Get_F1(1,Thrs1)
          Call Get_F1(2,Thrs2)
          Call Get_I1(3,nThrs)
          Call Get_F1(4,ThrsMul)
        Elseif(Line(1:4).eq.'END ') then
          GoTo 999
        Else
          Write(6,*) 'Undefined option for ''DIFFuse'':',Key
          Call FindErrorLine
          Call Quit_OnUserError()
        Endif
        GoTo 80141
      Elseif(Line(1:4).eq.'REXT') then
        Diffuse(1)=.true.
        Diffuse(3)=.true.
      Else
        Write(6,*) 'Undefined option for ''DIFFuse'':',Key
        Call FindErrorLine
        Call Quit_OnUserError()
      Endif
      Go To 999
*>>>>>>>>>>>>> ALPH <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 8015 Continue
* Change the alpha in the penalty function for the
* fluctuating charge contribution to polarisabilities
      Key = Get_Ln(LuSpool)
      Call Get_F1(1,Alpha)
      GoTo 999

 8016 Continue
      LIonize=.true.
      GoTo 999
*
*>>>>>>>>>>>>> END  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 9000 Continue
*
      Write (6,*)
      If (NoField) Then
         Write (6,*) ' No dynamic properties will be computed.'
         Write (6,*)
      Else
         If (Restart .AND. iRestart .eq. 2) Then
            Write(6,*) ' Previous LoProp calculation was run with the '
     &               //'NOFIeld flag.'
            Write(6,*) ' Thus it is not possible to restart and '
     &               //'calculate dynamic properties.'
            Call Quit_OnUserError()
         End If
         Write (6,*) ' Dynamic properties will be computed.'
         Write (6,*)
         Write (6,'(A,F12.6,A)') '  Applied field +/-', Delta,' au'
         Write (6,*)
      End If
      Write (6,*) ' Expansion centers of the domains are for the'
      If (Standard) Then
         Write (6,*) '  atomic domains: the atom center'
         Write (6,*) '  bond domains  : the center of the bond'
      Else
         Write (6,*) '  atomic domains: the center which set the dipole'
     &               //' moments to zero'
         Write (6,*) '  bond domains  : the center which minimize the '
     &               //'diagonal terms of the quadrupole moment'
         Write (6,*)
         Write (6,*) ' Observe that if the first non-zero term in the '
     &               //'expansion does not dominate the centers are '
     &               //'the original atomic and bond centers!'
      End If
      Write (6,*)
      If(UserDen) then
        Write(6,*)' Read density matrix from user.'
        Write(6,*)
      Endif
      If(TDensity) then
        Write(6,*)' Use transition density matrix from Rassi.'
        Write(6,*)
      Endif
      If(XHole) then
        Write(6,*)' Exchange hole second moment computation and '
     &          //'localization.'
        Write(6,*)
      Endif
      If(Diffuse(1)) then
        Write(6,*)' Computation of exponents to non-zero width '
     &          //'Slater functions.'
        If(Diffuse(2)) then
          Write(6,*)' --- Numerical determination.'
        Elseif(Diffuse(3)) then
          Write(6,*)' --- Analytical determination.'
        Endif
        Write(6,*)
      Endif
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine ZHEEVJ3(H,Q,W)
!=======================================================================
! Subroutine to setup and invert the matrix  H  and return
! eigenvalues W and eigenvector matric  Q

use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), parameter :: N = 3
real(kind=wp), intent(inout) :: H(N,N)
real(kind=wp), intent(out) :: Q(N,N), W(N)
integer(kind=iwp) :: I, R, X, Y
real(kind=wp) :: B, C, G, S, SO, T, THRESH, Z

! Initialize Q to the identity matrix
! --- This loop can be omitted if only the eigenvalues are desired ---
call unitmat(Q,N)
! Initialize W to diag(A)
do X=1,N
  W(X) = H(X,X)
end do
! Main iteration loop
do I=1,50
  ! Test for convergence
  SO = Zero
  do X=1,N
    do Y=X+1,N
      SO = SO+abs(H(X,Y))
    end do
  end do
  if (SO == Zero) return
  if (I < 4) then
    THRESH = 0.2_wp*SO/N**2
  else
    THRESH = Zero
  end if
  ! Do sweep
  do X=1,N
    do Y=X+1,N
      G = 100.0_wp*(abs(H(X,Y)))
      if ((I > 4) .and. (abs(W(X))+G == abs(W(X))) .and. (abs(W(Y))+G == abs(W(Y)))) then
        H(X,Y) = Zero
      else if (abs(H(X,Y)) > THRESH) then
        ! Calculate Jacobi transformation
        B = W(Y)-W(X)
        if ((abs(B)+G) == abs(B)) then
          T = H(X,Y)/B
        else
          if (B <= Zero) then
            T = -Two*H(X,Y)/(sqrt(B**2+Four*H(X,Y)**2)-B)
            !              /(sqrt(B**2+Four*SQRABS(H(X,Y)))-B)
          else if (B == Zero) then
            T = H(X,Y)/abs(H(X,Y))
          else
            T = Two*H(X,Y)/(sqrt(B**2+Four*H(X,Y)**2)+B)
            !             /(sqrt(B**2+Four*SQRABS(H(X,Y)))+B)
          end if
        end if
        !C = One/sqrt(One+SQRABS(T))
        C = One/sqrt(One+T**2)
        S = T*C
        Z = T*H(X,Y)
        ! Apply Jacobi transformation
        H(X,Y) = Zero
        W(X) = W(X)-Z
        W(Y) = W(Y)+Z
        do R=1,X-1
          T = H(R,X)
          H(R,X) = C*T-(S)*H(R,Y)
          H(R,Y) = S*T+C*H(R,Y)
        end do
        do R=X+1,Y-1
          T = H(X,R)
          H(X,R) = C*T-S*(H(R,Y))
          H(R,Y) = S*(T)+C*H(R,Y)
        end do
        do R=Y+1,N
          T = H(X,R)
          H(X,R) = C*T-S*H(Y,R)
          H(Y,R) = (S)*T+C*H(Y,R)
        end do
        ! eigenvectors
        ! This loop can be omitted if only the eigenvalues are desired ---
        do R=1,N
          T = Q(R,X)
          Q(R,X) = C*T-(S)*Q(R,Y)
          Q(R,Y) = S*T+C*Q(R,Y)
        end do
      end if
    end do
  end do
end do
write(u6,*) 'ZHEEVJ3: No convergence.'

end subroutine ZHEEVJ3

!function SQRABS(Z)
!!=====================================================================
!! Calculates the squared absolute value of a complex number Z
!! --------------------------------------------------------------------
!
!use Definitions, only: wp
!
!real(kind=wp) :: SQRABS
!real(kind=wp), intent(in) :: Z
!SQRABS = real(Z)**2
!
!return
!
!end function SQRABS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine XDR_dmatsqrt(a,n)
C
C Compute the inverse square root of a real symmetric matrix : A**(-1/2)
C
      implicit none
#include "WrkSpc.fh"
      Real*8 a(*),dia
      integer n,iCr,iW,iTmp,i,j,k,info
      call getmem('tmp ','ALLOC','REAL',iTmp,8*n)
      call getmem('Cr  ','ALLOC','REAL',iCr ,n*n+4)
      call getmem('Eig ','ALLOC','REAL',iW  ,n+4)
      do i = 0,n*n-1
        Work(iCr+i) = a(i+1)
      end do
      call dsyev_('V','L',n,Work(iCr),n,Work(iW),Work(iTmp),8*n,info)
      do i = 0,n-1
        dia = 1.d0/sqrt(sqrt(Work(iW+i)))
        do j = 0,n-1
          k = i*n + j
          Work(iCr+k) = Work(iCr+k) * dia
        end do
      end do
      call dmxma(n,'N','T',Work(iCr),Work(iCr),a,1.d0)
      call getmem('tmp ','FREE','REAL',iTmp,8*n)
      call getmem('Cr  ','FREE','REAL',iCr ,n*n+4)
      call getmem('Eig ','FREE','REAL',iW  ,n+4)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mktauhelp2 (t2,t1,dimab,dimij,dima,dimi,shift,fact)
c
c     this routine do
c     t2(ab,ij) = t2(ab,ij) + fact* (T1(a,i).t1(b,j)-t1(b,i).t1(a,j))
c     for spin and symmetry of all indices equal
c
c     t2        - T2 matrix (I/O)
c     t1      - t1 matrix (I)
c     dimab   - 1 dimension of T2 (I)
c     dimij   - 3 domension of T2 (I)
c     dima    - number of a in this spin and symm of a (I)
c     dimi    - number of a in this spin and symm of i (I)
c     shift         - number off occ orbitals in spin and symmetry of a (I)
c     fact    - numerical factor (I)
c
c     N.B. Since for T1 i and a are of the same spin, there is no reason
c     to specify spin of dp. It must be automatically the same spin ad i and a.
c
       integer dimab,dimij,dima,dimi,shift
       real*8 fact
       real*8 t2(1:dimab,1:dimij)
       real*8 t1(1:dima,1:dimi)
c
c     help variables
c
       integer i,j,a,b,ij,ab
c
       ij=0
       do 100 i=2,dimi
       do 101 j=1,i-1
       ij=ij+1
c
       ab=0
       do 102 a=2,dima
       do 103 b=1,a-1
       ab=ab+1
       t2(ab,ij)=t2(ab,ij)+fact*(t1(a,i)*t1(b,j)-t1(b,i)*t1(a,j))
c
 103    continue
 102    continue
 101    continue
 100    continue
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(shift)
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FckMat()
!***********************************************************
!                                                          *
!   Driver for calculation of optimized fock matrix.       *
!                                                          *
!***********************************************************

use Index_Functions, only: nTri_Elem
use MCLR_Data, only: F0SQMO, FAMO, FIMO, INT2, nDens, nrec
use input_mclr, only: iMethod, nAsh, nBas, nIsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: nAtri, nm, nmm, nmmm
real(kind=wp), allocatable :: Q(:), T3(:), Tmp2(:,:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Read density matrix

nm = sum(nAsh(1:nSym))
nmm = max(0,maxval(nAsh(1:nSym)+nIsh(1:nSym)))
nmmm = max(0,maxval(nBas(1:nSym)))
nAtri = nTri_Elem(nm)
nAtri = nTri_Elem(nAtri)
nmmm = ((nmmm-1)/nRec+1)*nRec
nmm = nmm*nMMM
nmm = nmm**2
call mma_allocate(F0SQMO,nDens,Label='F0SQMO')
call mma_allocate(FIMO,nDens,Label='FIMO')
if (iMethod == 2) then
  call mma_allocate(Int2,nAtri,Label='Int2')
else
  call mma_allocate(Int2,1,Label='Int2')
end if
Int2(:) = Zero
call mma_allocate(FAMO,nDens,Label='FAMO')
call mma_allocate(Q,nDens,Label='Q')
call mma_allocate(Tmp2,nDens,2,Label='Tmp2')
call mma_allocate(T3,nDens,Label='T3')
!                                                                      *
!***********************************************************************
!                                                                      *
! Calculate two-electron contribution

call Read22_2(Int2,F0SQMO,Q,FIMO,FAMO,Tmp2(:,1),Tmp2(:,2),T3)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(T3)
call mma_deallocate(Tmp2)
call mma_deallocate(Q)
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine FckMat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Steven Vancoillie                                      *
************************************************************************
*SVC: compute RHS elements "on demand". If we have access to all the
* Cholesky vectors, we can just instruct a process to compute it's own
* block of RHS elements, computing the integrals directly. This is much
* more computationally intensive, but should scale much better since we
* go from a badly scaling scatter algorithm to no communication at all.
* This also eliminates the need for the GA library in creating the RHS.
* FIXME: optimizations needed, remove double computation of integrals

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD(IVEC)
      use output_caspt2, only:iPrGlb,verbose
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"


      IF (IPRGLB.GE.VERBOSE) THEN
        WRITE(6,'(1X,A)') ' Using RHS on-demand algorithm'
      END IF

#ifdef _MOLCAS_MPP_
      IF (.NOT.Is_Real_Par()) THEN
        WRITE(6,'(1X,A)') 'RHSOD: error: fake parallel not supported'
        CALL AbEnd()
      END IF
#endif

      CALL RHSOD_A(IVEC)
      CALL RHSOD_B(IVEC)
      CALL RHSOD_C(IVEC)
      CALL RHSOD_D(IVEC)
      CALL RHSOD_E(IVEC)
      CALL RHSOD_F(IVEC)
      CALL RHSOD_G(IVEC)
      CALL RHSOD_H(IVEC)

#ifdef _DEBUGPRINT_
* compute and print RHS fingerprints
      WRITE(6,'(1X,A4,1X,A3,1X,A18)') 'Case','Sym','Fingerprint'
      WRITE(6,'(1X,A4,1X,A3,1X,A18)') '====','===','==========='
      DO ICASE=1,13
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF (NAS*NIS.NE.0) THEN
            CALL RHS_ALLO (NAS,NIS,lg_W)
            CALL RHS_READ (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
            DNRM2 = RHS_DDOT(NAS,NIS,lg_W,lg_W)
            WRITE(6,'(1X,I4,1X,I3,1X,F18.11)') ICASE,ISYM,DNRM2
          END IF
        END DO
      END DO
#endif


      END


************************************************************************
* SUBROUTINES FOR THE SEPARATE CASES
************************************************************************

*|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
      SUBROUTINE RHSOD_A(IVEC)
      USE SUPERINDEX
      USE CHOVEC_IO
      use output_caspt2, only:iPrGlb,debug
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION IOBRA(8,8), IOKET(8,8)
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#else
#define DBL_MB Work
#endif

      IF (iPrGlb.GE.DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case A'
      END IF

************************************************************************
* Case A:
C   RHS(tvx,j)=(tj,vx)+FIMO(t,j)*kron(v,x)/NACTEL
************************************************************************

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(1,NBRA,IOBRA)
      CALL CHOVEC_SIZE(2,NKET,IOKET)

      CALL GETMEM('BRABUF','ALLO','REAL',LBRA,NBRA)
      CALL GETMEM('KETBUF','ALLO','REAL',LKET,NKET)

      CALL CHOVEC_READ(1,LBRA)
      CALL CHOVEC_READ(2,LKET)

      ICASE=1
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      NFIMOES=0
      DO ISYM=1,NSYM

        NAS=NTUV(ISYM) !NASUP(ISYM,ICASE)
        NIS=NISH(ISYM) !NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 1

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IJ=IISTA,IIEND
          ISYJ=ISYM
          DO ITVX=IASTA,IAEND ! these are always all elements
            ITVXTOT=ITVX+NTUVES(ISYM)
            ITABS=MTUV(1,ITVXTOT)
            IVABS=MTUV(2,ITVXTOT)
            IXABS=MTUV(3,ITVXTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
            IX  =MTREL(1,IXABS)
            ISYX=MTREL(2,IXABS)
! compute integrals (tiuv)
            NV=NVTOT_CHOSYM(MUL(ISYT,ISYJ)) ! JSYM=ISYT*ISYI=ISYU*ISYV
            ITJ=IT-1+NASH(ISYT)*(IJ-1)
            IVX=IV-1+NASH(ISYV)*(IX-1)
            IOFFTJ=LBRA+IOBRA(ISYT,ISYJ)+NV*ITJ
            IOFFVX=LKET+IOKET(ISYV,ISYX)+NV*IVX
            TJVX=DDOT_(NV,WORK(IOFFTJ),1,WORK(IOFFVX),1)
! A(tvx,j) = (tjvx) + FIMO(t,j)*delta(v,x)/NACTEL
            IF (ISYT.EQ.ISYJ.AND.IVABS.EQ.IXABS) THEN
              ITTOT=IT+NISH(ISYT)
              FTJ=WORK(LFIMO+NFIMOES+(ITTOT*(ITTOT-1))/2+IJ-1)
              ATVXJ=TJVX+FTJ/DBLE(MAX(1,NACTEL))
            ELSE
              ATVXJ=TJVX
            END IF
! write element A(tvx,j)
            IDX=ITVX+NAS*(IJ-IISTA)
            DBL_MB(MW+IDX-1)=ATVXJ
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 1      CONTINUE

        NFIMOES=NFIMOES+(NORB(ISYM)*(NORB(ISYM)+1))/2

      END DO
************************************************************************

      CALL GETMEM('BRABUF','FREE','REAL',LBRA,NBRA)
      CALL GETMEM('KETBUF','FREE','REAL',LKET,NKET)

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_C(IVEC)
      USE SUPERINDEX
      USE CHOVEC_IO
      use output_caspt2, only:iPrGlb,debug
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION IOBRA(8,8), IOKET(8,8)
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#else
#define DBL_MB Work
#endif

      IF (iPrGlb.GE.DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case C'
      END IF

************************************************************************
* Case C:
C   RHS(tvx,a)=(at,vx)+(FIMO(a,t)-Sum_u(au,ut))*delta(v,x)/NACTEL
************************************************************************

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(3,NBRA,IOBRA)
      CALL CHOVEC_SIZE(2,NKET,IOKET)

      CALL GETMEM('BRABUF','ALLO','REAL',LBRA,NBRA)
      CALL GETMEM('KETBUF','ALLO','REAL',LKET,NKET)

      CALL CHOVEC_READ(3,LBRA)
      CALL CHOVEC_READ(2,LKET)

      ICASE=4
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      NFIMOES=0
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE) !NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE) !NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 4

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IA=IISTA,IIEND
          ISYA=ISYM
          DO ITVX=IASTA,IAEND ! these are always all elements
            ITVXTOT=ITVX+NTUVES(ISYM)
            ITABS=MTUV(1,ITVXTOT)
            IVABS=MTUV(2,ITVXTOT)
            IXABS=MTUV(3,ITVXTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
            IX  =MTREL(1,IXABS)
            ISYX=MTREL(2,IXABS)
! compute integrals (at,vx)
            NV=NVTOT_CHOSYM(MUL(ISYA,ISYT)) ! JSYM=ISYT*ISYI=ISYU*ISYV
            IAT=IA-1+NSSH(ISYA)*(IT-1)
            IVX=IV-1+NASH(ISYV)*(IX-1)
            IOFFAT=LBRA+IOBRA(ISYA,ISYT)+NV*IAT
            IOFFVX=LKET+IOKET(ISYV,ISYX)+NV*IVX
            ATVX=DDOT_(NV,WORK(IOFFAT),1,WORK(IOFFVX),1)

! W(tvx,a) = (at,vx) + (FIMO(a,t)-Sum_u(au,ut))*delta(v,x)/NACTEL
! write element W(tvx,j), only the (at,vx) part
            IDX=ITVX+NAS*(IA-IISTA)
            DBL_MB(MW+IDX-1)=ATVX
          END DO
! now, add in the part with corrections to the integrals
          IATOT=IA+NISH(ISYM)+NASH(ISYM)
          DO IT=1,NASH(ISYM)
            ITTOT=IT+NISH(ISYM)
            FAT=WORK(LFIMO+NFIMOES+(IATOT*(IATOT-1))/2+ITTOT-1)
            SUMU=0.0D0
            ITABS=NAES(ISYM)+IT
            DO IUABS=1,NASHT
              IUUT=KTUV(IUABS,IUABS,ITABS)-NTUVES(ISYM)
              IDX=IUUT+NAS*(IA-IISTA)
              SUMU=SUMU+DBL_MB(MW+IDX-1)
            END DO
            ADDONE=(FAT-SUMU)/DBLE(MAX(1,NACTEL))
            DO IVABS=1,NASHT
              ITVV=KTUV(ITABS,IVABS,IVABS)-NTUVES(ISYM)
              IDX=ITVV+NAS*(IA-IISTA)
              DBL_MB(MW+IDX-1)=DBL_MB(MW+IDX-1)+ADDONE
            END DO
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 4      CONTINUE

        NFIMOES=NFIMOES+(NORB(ISYM)*(NORB(ISYM)+1))/2

      END DO
************************************************************************

      CALL GETMEM('BRABUF','FREE','REAL',LBRA,NBRA)
      CALL GETMEM('KETBUF','FREE','REAL',LKET,NKET)

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_B(IVEC)
      USE SUPERINDEX
      USE CHOVEC_IO
      use output_caspt2, only:iPrGlb,debug
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION IOSYM(8,8)
*      Logical Incore
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#else
#define DBL_MB Work
#endif

      IF (iPrGlb.GE.DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case B'
      END IF

************************************************************************
* Case B (2,3):
C   Let  W(tv,j,l)=(jt,lv):
C   BP(tv,jl)=((tj,vl)+(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
C   BM(tv,jl)=((tj,vl)-(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
************************************************************************

      SQRTH=SQRT(0.5D0)

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(1,NCHOBUF,IOSYM)

      CALL GETMEM('CHOBUF','ALLO','REAL',LCHOBUF,NCHOBUF)

      CALL CHOVEC_READ(1,LCHOBUF)

      iCASE=2
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 2

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IJGEL=IISTA,IIEND
          IJGELTOT=IJGEL+NIGEJES(ISYM)
          IJABS=MIGEJ(1,IJGELTOT)
          ILABS=MIGEJ(2,IJGELTOT)
          IJ  =MIREL(1,IJABS)
          ISYJ=MIREL(2,IJABS)
          IL  =MIREL(1,ILABS)
          ISYL=MIREL(2,ILABS)
          DO ITGEU=IASTA,IAEND ! these are always all elements
            ITGEUTOT=ITGEU+NTGEUES(ISYM)
            ITABS=MTGEU(1,ITGEUTOT)
            IVABS=MTGEU(2,ITGEUTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integrals (ajcl) and (alcj)
            NV=NVTOT_CHOSYM(MUL(ISYT,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
            ITJ=IT-1+NASH(ISYT)*(IJ-1)
            IVL=IV-1+NASH(ISYV)*(IL-1)
            IOFFTJ=LCHOBUF+IOSYM(ISYT,ISYJ)+NV*ITJ
            IOFFVL=LCHOBUF+IOSYM(ISYV,ISYL)+NV*IVL
            TJVL=DDOT_(NV,WORK(IOFFTJ),1,WORK(IOFFVL),1)

            NV=NVTOT_CHOSYM(MUL(ISYT,ISYL))
            ITL=IT-1+NASH(ISYT)*(IL-1)
            IVJ=IV-1+NASH(ISYV)*(IJ-1)
            IOFFTL=LCHOBUF+IOSYM(ISYT,ISYL)+NV*ITL
            IOFFVJ=LCHOBUF+IOSYM(ISYV,ISYJ)+NV*IVJ
            TLVJ=DDOT_(NV,WORK(IOFFTL),1,WORK(IOFFVJ),1)

! BP(tv,jl)=((tj,vl)+(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
            SCL=0.5D0
            IF (ITABS.EQ.IVABS) SCL=SCL*0.5D0
            IF (ILABS.EQ.IJABS) SCL=SCL*SQRTH
            BPTVJL=SCL*(TJVL+TLVJ)
! write element HP(ac,jl)
            IDX=ITGEU+NAS*(IJGEL-IISTA)
            DBL_MB(MW+IDX-1)=BPTVJL
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 2      CONTINUE
      END DO
************************************************************************



      iCASE=3
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 3

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IJGTL=IISTA,IIEND
          IJGTLTOT=IJGTL+NIGTJES(ISYM)
          IJABS=MIGTJ(1,IJGTLTOT)
          ILABS=MIGTJ(2,IJGTLTOT)
          IJ  =MIREL(1,IJABS)
          ISYJ=MIREL(2,IJABS)
          IL  =MIREL(1,ILABS)
          ISYL=MIREL(2,ILABS)
          DO ITGTU=IASTA,IAEND ! these are always all elements
            ITGTUTOT=ITGTU+NTGTUES(ISYM)
            ITABS=MTGTU(1,ITGTUTOT)
            IVABS=MTGTU(2,ITGTUTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integrals (tj,vl) and (tlvj)
            NV=NVTOT_CHOSYM(MUL(ISYT,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
            ITJ=IT-1+NASH(ISYT)*(IJ-1)
            IVL=IV-1+NASH(ISYV)*(IL-1)
            IOFFTJ=LCHOBUF+IOSYM(ISYT,ISYJ)+NV*ITJ
            IOFFVL=LCHOBUF+IOSYM(ISYV,ISYL)+NV*IVL
            TJVL=DDOT_(NV,WORK(IOFFTJ),1,WORK(IOFFVL),1)

            NV=NVTOT_CHOSYM(MUL(ISYT,ISYL))
            ITL=IT-1+NASH(ISYT)*(IL-1)
            IVJ=IV-1+NASH(ISYV)*(IJ-1)
            IOFFTL=LCHOBUF+IOSYM(ISYT,ISYL)+NV*ITL
            IOFFVJ=LCHOBUF+IOSYM(ISYV,ISYJ)+NV*IVJ
            TLVJ=DDOT_(NV,WORK(IOFFTL),1,WORK(IOFFVJ),1)

! BM(tv,jl)=((tj,vl)-(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
            SCL=0.5D0
            !IF (ITABS.EQ.IVABS) SCL=SCL*0.5D0
            !IF (ILABS.EQ.IJABS) SCL=SCL*SQRTH
            BMTVJL=SCL*(TJVL-TLVJ)
! write element BM(tv,jl)
            IDX=ITGTU+NAS*(IJGTL-IISTA)
            DBL_MB(MW+IDX-1)=BMTVJL
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 3      CONTINUE
      END DO
************************************************************************

      CALL GETMEM('CHOBUF','FREE','REAL',LCHOBUF,NCHOBUF)

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_F(IVEC)
      USE SUPERINDEX
      USE CHOVEC_IO
      use output_caspt2, only:iPrGlb,debug
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION IOSYM(8,8)
*      Logical Incore
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#else
#define DBL_MB Work
#endif

      IF (iPrGlb.GE.DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case F'
      END IF

************************************************************************
* Case F (8,9):
C FP(tv,ac)=((at,cv)+(av,ct))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(a,c))
C FM(tv,ac)= -((at,cv)-(av,ct))/(2*SQRT(1+Kron(a,c))
************************************************************************

      SQRTH=SQRT(0.5D0)

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(3,NCHOBUF,IOSYM)

      CALL GETMEM('CHOBUF','ALLO','REAL',LCHOBUF,NCHOBUF)

      CALL CHOVEC_READ(3,LCHOBUF)

      iCASE=8
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 8

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IAGEB=IISTA,IIEND
          IAGEBTOT=IAGEB+NAGEBES(ISYM)
          IAABS=MAGEB(1,IAGEBTOT)
          ICABS=MAGEB(2,IAGEBTOT)
          IA  =MAREL(1,IAABS)
          ISYA=MAREL(2,IAABS)
          IC  =MAREL(1,ICABS)
          ISYC=MAREL(2,ICABS)
          DO ITGEU=IASTA,IAEND ! these are always all elements
            ITGEUTOT=ITGEU+NTGEUES(ISYM)
            ITABS=MTGEU(1,ITGEUTOT)
            IVABS=MTGEU(2,ITGEUTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integrals (ta,vc) and (tc,va)
            NV=NVTOT_CHOSYM(MUL(ISYA,ISYT)) ! JSYM=ISYA*ISYA=ISYC*ISYC
            IAT=IA-1+NSSH(ISYA)*(IT-1)
            ICV=IC-1+NSSH(ISYC)*(IV-1)
            IOFFAT=LCHOBUF+IOSYM(ISYA,ISYT)+NV*IAT
            IOFFCV=LCHOBUF+IOSYM(ISYC,ISYV)+NV*ICV
            ATCV=DDOT_(NV,WORK(IOFFAT),1,WORK(IOFFCV),1)

            NV=NVTOT_CHOSYM(MUL(ISYA,ISYV)) ! JSYM=ISYA*ISYA=ISYC*ISYC
            IAV=IA-1+NSSH(ISYA)*(IV-1)
            ICT=IC-1+NSSH(ISYC)*(IT-1)
            IOFFAV=LCHOBUF+IOSYM(ISYA,ISYV)+NV*IAV
            IOFFCT=LCHOBUF+IOSYM(ISYC,ISYT)+NV*ICT
            AVCT=DDOT_(NV,WORK(IOFFAV),1,WORK(IOFFCT),1)

! FP(tv,ac)=((at,cv)+(av,ct))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(a,c))
            SCL=0.5D0
            IF (ITABS.EQ.IVABS) SCL=SCL*0.5D0
            IF (IAABS.EQ.ICABS) SCL=SCL*SQRTH
            FPTVAC=SCL*(ATCV+AVCT)
! write element FP(tv,ac)
            IDX=ITGEU+NAS*(IAGEB-IISTA)
            DBL_MB(MW+IDX-1)=FPTVAC
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 8      CONTINUE
      END DO
************************************************************************



      iCASE=9
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 9

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IAGTB=IISTA,IIEND
          IAGTBTOT=IAGTB+NAGTBES(ISYM)
          IAABS=MAGTB(1,IAGTBTOT)
          ICABS=MAGTB(2,IAGTBTOT)
          IA  =MAREL(1,IAABS)
          ISYA=MAREL(2,IAABS)
          IC  =MAREL(1,ICABS)
          ISYC=MAREL(2,ICABS)
          DO ITGTU=IASTA,IAEND ! these are always all elements
            ITGTUTOT=ITGTU+NTGTUES(ISYM)
            ITABS=MTGTU(1,ITGTUTOT)
            IVABS=MTGTU(2,ITGTUTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integrals (at,cv) and (av,ct)
            NV=NVTOT_CHOSYM(MUL(ISYA,ISYT)) ! JSYM=ISYA*ISYA=ISYC*ISYC
            IAT=IA-1+NSSH(ISYA)*(IT-1)
            ICV=IC-1+NSSH(ISYC)*(IV-1)
            IOFFAT=LCHOBUF+IOSYM(ISYA,ISYT)+NV*IAT
            IOFFCV=LCHOBUF+IOSYM(ISYC,ISYV)+NV*ICV
            ATCV=DDOT_(NV,WORK(IOFFAT),1,WORK(IOFFCV),1)

            NV=NVTOT_CHOSYM(MUL(ISYA,ISYV)) ! JSYM=ISYA*ISYA=ISYC*ISYC
            IAV=IA-1+NSSH(ISYA)*(IV-1)
            ICT=IC-1+NSSH(ISYC)*(IT-1)
            IOFFAV=LCHOBUF+IOSYM(ISYA,ISYV)+NV*IAV
            IOFFCT=LCHOBUF+IOSYM(ISYC,ISYT)+NV*ICT
            AVCT=DDOT_(NV,WORK(IOFFAV),1,WORK(IOFFCT),1)

! FM(tv,ac)= -((at,cv)-(av,ct))/(2*SQRT(1+Kron(a,c))
            SCL=0.5D0
            !IF (ITABS.EQ.IVABS) SCL=SCL*0.5D0
            !IF (IAABS.EQ.ICABS) SCL=SCL*SQRTH
            FMTVAC=SCL*(AVCT-ATCV)
! write element FM(tv,ac)
            IDX=ITGTU+NAS*(IAGTB-IISTA)
            DBL_MB(MW+IDX-1)=FMTVAC
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 9      CONTINUE
      END DO
************************************************************************

      CALL GETMEM('CHOBUF','FREE','REAL',LCHOBUF,NCHOBUF)

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_H(IVEC)
      USE SUPERINDEX
      USE CHOVEC_IO
      use output_caspt2, only:iPrGlb,debug
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION IOSYM(8,8)
*      Logical Incore
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#else
#define DBL_MB Work
#endif

      IF (iPrGlb.GE.DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case H'
      END IF

************************************************************************
* Case H:
C   WP(jl,ac)=((ajcl)+(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
C   WM(jl,ac)=((ajcl)-(alcj))*SQRT(3.0D0)
************************************************************************

      SQRT3=SQRT(3.0D0)
      SQRTH=SQRT(0.5D0)

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(4,NCHOBUF,IOSYM)

      CALL GETMEM('CHOBUF','ALLO','REAL',LCHOBUF,NCHOBUF)

      CALL CHOVEC_READ(4,LCHOBUF)

      iCASE=12
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NAGEB(ISYM)
        NIS=NIGEJ(ISYM)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 12

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IJGEL=IISTA,IIEND
          IJGELTOT=IJGEL+NIGEJES(ISYM)
          IJABS=MIGEJ(1,IJGELTOT)
          ILABS=MIGEJ(2,IJGELTOT)
          IJ  =MIREL(1,IJABS)
          ISYJ=MIREL(2,IJABS)
          IL  =MIREL(1,ILABS)
          ISYL=MIREL(2,ILABS)
          DO IAGEB=IASTA,IAEND ! these are always all elements
            IAGEBTOT=IAGEB+NAGEBES(ISYM)
            IAABS=MAGEB(1,IAGEBTOT)
            ICABS=MAGEB(2,IAGEBTOT)
            IA  =MAREL(1,IAABS)
            ISYA=MAREL(2,IAABS)
            IC  =MAREL(1,ICABS)
            ISYC=MAREL(2,ICABS)
! compute integrals (ajcl) and (alcj)
            NV=NVTOT_CHOSYM(MUL(ISYA,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
            IAJ=IA-1+NSSH(ISYA)*(IJ-1)
            ICL=IC-1+NSSH(ISYC)*(IL-1)
            IOFFAJ=LCHOBUF+IOSYM(ISYA,ISYJ)+NV*IAJ
            IOFFCL=LCHOBUF+IOSYM(ISYC,ISYL)+NV*ICL
            AJCL=DDOT_(NV,WORK(IOFFAJ),1,WORK(IOFFCL),1)

            NV=NVTOT_CHOSYM(MUL(ISYA,ISYL))
            IAL=IA-1+NSSH(ISYA)*(IL-1)
            ICJ=IC-1+NSSH(ISYC)*(IJ-1)
            IOFFAL=LCHOBUF+IOSYM(ISYA,ISYL)+NV*IAL
            IOFFCJ=LCHOBUF+IOSYM(ISYC,ISYJ)+NV*ICJ
            ALCJ=DDOT_(NV,WORK(IOFFAL),1,WORK(IOFFCJ),1)

! HP(ac,jl)=((ajcl)+(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
            SCL=1.0D0
            IF (IAABS.EQ.ICABS) SCL=SCL*SQRTH
            IF (ILABS.EQ.IJABS) SCL=SCL*SQRTH
            HPACJL=SCL*(AJCL+ALCJ)
! write element HP(ac,jl)
            IDX=IAGEB+NAS*(IJGEL-IISTA)
            DBL_MB(MW+IDX-1)=HPACJL
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 12     CONTINUE
      END DO
************************************************************************



      iCASE=13
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NAGTB(ISYM)
        NIS=NIGTJ(ISYM)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 13

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IJGTL=IISTA,IIEND
          IJGTLTOT=IJGTL+NIGTJES(ISYM)
          IJABS=MIGTJ(1,IJGTLTOT)
          ILABS=MIGTJ(2,IJGTLTOT)
          IJ  =MIREL(1,IJABS)
          ISYJ=MIREL(2,IJABS)
          IL  =MIREL(1,ILABS)
          ISYL=MIREL(2,ILABS)
          DO IAGTB=IASTA,IAEND ! these are always all elements
            IAGTBTOT=IAGTB+NAGTBES(ISYM)
            IAABS=MAGTB(1,IAGTBTOT)
            ICABS=MAGTB(2,IAGTBTOT)
            IA  =MAREL(1,IAABS)
            ISYA=MAREL(2,IAABS)
            IC  =MAREL(1,ICABS)
            ISYC=MAREL(2,ICABS)
! compute integrals (ajcl) and (alcj)
            NV=NVTOT_CHOSYM(MUL(ISYA,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
            IAJ=IA-1+NSSH(ISYA)*(IJ-1)
            ICL=IC-1+NSSH(ISYC)*(IL-1)
            IOFFAJ=LCHOBUF+IOSYM(ISYA,ISYJ)+NV*IAJ
            IOFFCL=LCHOBUF+IOSYM(ISYC,ISYL)+NV*ICL
            AJCL=DDOT_(NV,WORK(IOFFAJ),1,WORK(IOFFCL),1)

            NV=NVTOT_CHOSYM(MUL(ISYA,ISYL))
            IAL=IA-1+NSSH(ISYA)*(IL-1)
            ICJ=IC-1+NSSH(ISYC)*(IJ-1)
            IOFFAL=LCHOBUF+IOSYM(ISYA,ISYL)+NV*IAL
            IOFFCJ=LCHOBUF+IOSYM(ISYC,ISYJ)+NV*ICJ
            ALCJ=DDOT_(NV,WORK(IOFFAL),1,WORK(IOFFCJ),1)

! HP(ac,jl)=((ajcl)-(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
            SCL=SQRT3
            HMACJL=SCL*(AJCL-ALCJ)
! write element HP(ac,jl)
            IDX=IAGTB+NAS*(IJGTL-IISTA)
            DBL_MB(MW+IDX-1)=HMACJL
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 13     CONTINUE
      END DO
************************************************************************

      CALL GETMEM('CHOBUF','FREE','REAL',LCHOBUF,NCHOBUF)

      RETURN
      END


*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_D(IVEC)
      USE SUPERINDEX
      USE CHOVEC_IO
      use output_caspt2, only:iPrGlb,debug
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION IOBRA1(8,8), IOKET1(8,8), IOBRA2(8,8), IOKET2(8,8)
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#else
#define DBL_MB Work
#endif
      DIMENSION NFIMOES(8)

      IF (iPrGlb.GE.DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case D'
      END IF

************************************************************************
* Case D (5,6):
C D1(tv,aj)=(aj,tv) + FIMO(a,j)*Kron(t,v)/NACTEL
C D2(tv,aj)=(tj,av)
************************************************************************

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(4,NBRABUF1,IOBRA1)
      CALL CHOVEC_SIZE(2,NKETBUF1,IOKET1)

      CALL GETMEM('BRABUF1','ALLO','REAL',LBRABUF1,NBRABUF1)
      CALL GETMEM('KETBUF1','ALLO','REAL',LKETBUF1,NKETBUF1)

      CALL CHOVEC_READ(4,LBRABUF1)
      CALL CHOVEC_READ(2,LKETBUF1)

      CALL CHOVEC_SIZE(3,NBRABUF2,IOBRA2)
      CALL CHOVEC_SIZE(1,NKETBUF2,IOKET2)

      CALL GETMEM('BRABUF2','ALLO','REAL',LBRABUF2,NBRABUF2)
      CALL GETMEM('KETBUF2','ALLO','REAL',LKETBUF2,NKETBUF2)

      CALL CHOVEC_READ(3,LBRABUF2)
      CALL CHOVEC_READ(1,LKETBUF2)

      iCASE=5
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      ! set up FIMO access
      ACTINV=1.0D0/DBLE(MAX(1,NACTEL))
      IFIMOES=0
      DO ISYM=1,NSYM
        NFIMOES(ISYM)=IFIMOES
        IFIMOES=IFIMOES+(NORB(ISYM)*(NORB(ISYM)+1))/2
      END DO

      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 8

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

! cases D1, D2 share the RHS along the tu superindex
        NAS1=NAS/2
        IASTA1=IASTA
        IAEND1=IAEND/2
        IASTA2=IAEND1+1
        IAEND2=IAEND

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IAJ=IISTA,IIEND
          IAJTOT=IAJ+NIAES(ISYM)
          IJABS=MIA(1,IAJTOT)
          IAABS=MIA(2,IAJTOT)
          IA  =MAREL(1,IAABS)
          ISYA=MAREL(2,IAABS)
          IJ  =MIREL(1,IJABS)
          ISYJ=MIREL(2,IJABS)
          DO ITV=IASTA1,IAEND1 ! these are always all elements
            ITABS=MTU(1,ITV+NTUES(ISYM))
            IVABS=MTU(2,ITV+NTUES(ISYM))
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integral (aj,tv)
            NV=NVTOT_CHOSYM(MUL(ISYA,ISYJ))
            IOAJ=IA-1+NSSH(ISYA)*(IJ-1)
            IOTV=IT-1+NASH(ISYT)*(IV-1)
            IOFFAJ=LBRABUF1+IOBRA1(ISYA,ISYJ)+NV*IOAJ
            IOFFTV=LKETBUF1+IOKET1(ISYT,ISYV)+NV*IOTV
            AJTV=DDOT_(NV,WORK(IOFFAJ),1,WORK(IOFFTV),1)

! D1(tv,aj)=(aj,tv) + FIMO(a,j)*Kron(t,v)/NACTEL
! integrals only
            IDX=ITV+NAS*(IAJ-IISTA)
            DBL_MB(MW+IDX-1)=AJTV
          END DO
! now, dress with FIMO(a,j), only if T==V, so ISYT==ISYV, so if ISYM==1
          IF (ISYM.EQ.1) THEN
            IATOT=IA+NISH(ISYA)+NASH(ISYA)
            FAJ=WORK(LFIMO+NFIMOES(ISYA)+(IATOT*(IATOT-1))/2+IJ-1)
            ONEADD=FAJ*ACTINV
            DO IUABS=1,NASHT
              IUU=KTU(IUABS,IUABS)
              IDX=IUU+NAS*(IAJ-IISTA)
              DBL_MB(MW+IDX-1)=DBL_MB(MW+IDX-1)+ONEADD
            END DO
          END IF
          DO ITV=IASTA2,IAEND2 ! these are always all elements
            ITABS=MTU(1,ITV-NAS1+NTUES(ISYM))
            IVABS=MTU(2,ITV-NAS1+NTUES(ISYM))
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integral (av,tj)
            NV=NVTOT_CHOSYM(MUL(ISYA,ISYV))
            IOAV=IA-1+NSSH(ISYA)*(IV-1)
            IOTJ=IT-1+NASH(ISYT)*(IJ-1)
            IOFFAV=LBRABUF2+IOBRA2(ISYA,ISYV)+NV*IOAV
            IOFFTJ=LKETBUF2+IOKET2(ISYT,ISYJ)+NV*IOTJ
            AVTJ=DDOT_(NV,WORK(IOFFAV),1,WORK(IOFFTJ),1)

! D2(tv,aj)=(av,tj) + FIMO(a,j)*Kron(t,v)/NACTEL
            IDX=ITV+NAS*(IAJ-IISTA)
            DBL_MB(MW+IDX-1)=AVTJ
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 8      CONTINUE

      END DO
************************************************************************

      CALL GETMEM('BRABUF1','FREE','REAL',LBRABUF1,NBRABUF1)
      CALL GETMEM('KETBUF1','FREE','REAL',LKETBUF1,NKETBUF1)

      CALL GETMEM('BRABUF2','FREE','REAL',LBRABUF2,NBRABUF2)
      CALL GETMEM('KETBUF2','FREE','REAL',LKETBUF2,NKETBUF2)

************************************************************************

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_E(IVEC)
      USE SUPERINDEX
      USE CHOVEC_IO
      use output_caspt2, only:iPrGlb,debug
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION IOBRA(8,8), IOKET(8,8)
*      Logical Incore
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#else
#define DBL_MB Work
#endif

      IF (iPrGlb.GE.DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case E'
      END IF

************************************************************************
* Case E (6,7):
C EP(v,ajl)=((aj,vl)+(al,vj))/SQRT(2+2*Kron(j,l))
C EM(v,ajl)=((aj,vl)-(al,vj))*SQRT(3/2)
************************************************************************

* -SVC- Case E is slightly special, in that the inactive superindices are
* so large, that it is suboptimal to have a direct translation table for
* them. Instead, the code loops over symmetry blocks of A-JL and figures
* out if the indices on the processor fall within a block or not. Within
* a A-JL symmetry block, NA(ISYA) and NIGEJ(ISYJL) are known, so they can
* be determined by integer division. This could be optimized by combining
* it with loop peeling (on the todo list?).

      SQRTH=SQRT(0.5D0)
      SQRTA=SQRT(1.5D0)

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(4,NBRABUF,IOBRA)
      CALL CHOVEC_SIZE(1,NKETBUF,IOKET)

      CALL GETMEM('BRABUF','ALLO','REAL',LBRABUF,NBRABUF)
      CALL GETMEM('KETBUF','ALLO','REAL',LKETBUF,NKETBUF)

      CALL CHOVEC_READ(4,LBRABUF)
      CALL CHOVEC_READ(1,LKETBUF)

      iCASE=6
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 6

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
! find start and end block
        IOFF=0
        DO ISYA=1,NSYM
          ISYJL=MUL(ISYA,ISYM)
          ISYV=ISYM

          NA=NSSH(ISYA)
          NJL=NIGEJ(ISYJL)
          ! what is start/end in this block?
          IAJGELSTA=MAX(IISTA-IOFF,1)
          IAJGELEND=MIN(IIEND-IOFF,NA*NJL)

          DO IAJGEL=IAJGELSTA,IAJGELEND
            IJGEL=(IAJGEL-1)/NA+1
            IA=IAJGEL-NA*(IJGEL-1)
            IJGELTOT=IJGEL+NIGEJES(ISYJL)
            IJABS=MIGEJ(1,IJGELTOT)
            ILABS=MIGEJ(2,IJGELTOT)
            IJ  =MIREL(1,IJABS)
            ISYJ=MIREL(2,IJABS)
            IL  =MIREL(1,ILABS)
            ISYL=MIREL(2,ILABS)
            DO IV=IASTA,IAEND ! these are always all elements
! compute integrals (ajvl) and (alvj)
              NV=NVTOT_CHOSYM(MUL(ISYA,ISYJ))
              IAJ=IA-1+NSSH(ISYA)*(IJ-1)
              IVL=IV-1+NASH(ISYV)*(IL-1)
              IOFFAJ=LBRABUF+IOBRA(ISYA,ISYJ)+NV*IAJ
              IOFFVL=LKETBUF+IOKET(ISYV,ISYL)+NV*IVL
              AJVL=DDOT_(NV,WORK(IOFFAJ),1,WORK(IOFFVL),1)

              NV=NVTOT_CHOSYM(MUL(ISYA,ISYL))
              IAL=IA-1+NSSH(ISYA)*(IL-1)
              IVJ=IV-1+NASH(ISYV)*(IJ-1)
              IOFFAL=LBRABUF+IOBRA(ISYA,ISYL)+NV*IAL
              IOFFVJ=LKETBUF+IOKET(ISYV,ISYJ)+NV*IVJ
              ALVJ=DDOT_(NV,WORK(IOFFAL),1,WORK(IOFFVJ),1)

! EP(v,ajl)=((aj,vl)+(al,vj))/SQRT(2+2*Kron(j,l))
              IF (ILABS.EQ.IJABS) THEN
                SCL=0.5D0
              ELSE
                SCL=SQRTH
              END IF
              EP=SCL*(AJVL+ALVJ)
! write element EP
              IDX=IV+NAS*(IAJGEL+IOFF-IISTA)
              DBL_MB(MW+IDX-1)=EP
            END DO
          END DO

          IOFF=IOFF+NA*NJL
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 6      CONTINUE
      END DO
************************************************************************



      iCASE=7
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 7

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
! find start and end block
        IOFF=0
        DO ISYA=1,NSYM
          ISYJL=MUL(ISYA,ISYM)
          ISYV=ISYM

          NA=NSSH(ISYA)
          NJL=NIGTJ(ISYJL)
          ! what is start/end in this block?
          IAJGTLSTA=MAX(IISTA-IOFF,1)
          IAJGTLEND=MIN(IIEND-IOFF,NA*NJL)

          DO IAJGTL=IAJGTLSTA,IAJGTLEND
            IJGTL=(IAJGTL-1)/NA+1
            IA=IAJGTL-NA*(IJGTL-1)
            IJGTLTOT=IJGTL+NIGTJES(ISYJL)
            IJABS=MIGTJ(1,IJGTLTOT)
            ILABS=MIGTJ(2,IJGTLTOT)
            IJ  =MIREL(1,IJABS)
            ISYJ=MIREL(2,IJABS)
            IL  =MIREL(1,ILABS)
            ISYL=MIREL(2,ILABS)
            DO IV=IASTA,IAEND ! these are always all elements
! compute integrals (ajvl) and (alvj)
              NV=NVTOT_CHOSYM(MUL(ISYA,ISYJ))
              IAJ=IA-1+NSSH(ISYA)*(IJ-1)
              IVL=IV-1+NASH(ISYV)*(IL-1)
              IOFFAJ=LBRABUF+IOBRA(ISYA,ISYJ)+NV*IAJ
              IOFFVL=LKETBUF+IOKET(ISYV,ISYL)+NV*IVL
              AJVL=DDOT_(NV,WORK(IOFFAJ),1,WORK(IOFFVL),1)

              NV=NVTOT_CHOSYM(MUL(ISYA,ISYL))
              IAL=IA-1+NSSH(ISYA)*(IL-1)
              IVJ=IV-1+NASH(ISYV)*(IJ-1)
              IOFFAL=LBRABUF+IOBRA(ISYA,ISYL)+NV*IAL
              IOFFVJ=LKETBUF+IOKET(ISYV,ISYJ)+NV*IVJ
              ALVJ=DDOT_(NV,WORK(IOFFAL),1,WORK(IOFFVJ),1)

! EM(v,ajl)=((aj,vl)-(al,vj))*SQRT(3/2)
              EM=SQRTA*(AJVL-ALVJ)
! write element EM
              IDX=IV+NAS*(IAJGTL+IOFF-IISTA)
              DBL_MB(MW+IDX-1)=EM
            END DO
          END DO

          IOFF=IOFF+NA*NJL
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 7      CONTINUE
      END DO
************************************************************************

      CALL GETMEM('BRABUF','FREE','REAL',LBRABUF,NBRABUF)
      CALL GETMEM('KETBUF','FREE','REAL',LKETBUF,NKETBUF)

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_G(IVEC)
      USE SUPERINDEX
      USE CHOVEC_IO
      use output_caspt2, only:iPrGlb,debug
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION IOBRA(8,8), IOKET(8,8)
*      Logical Incore
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#else
#define DBL_MB Work
#endif

      IF (iPrGlb.GE.DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case G'
      END IF

************************************************************************
* Case G (10,11):
C GP(v,jac)=((av,cj)+(cv,aj))/SQRT(2+2*Kron(a,b))
C GM(v,jac)=((av,cj)-(cv,aj))*SQRT(3/2)
************************************************************************

* -SVC- Case G is slightly special, in that the inactive superindices are
* so large, that it is suboptimal to have a direct translation table for
* them. Instead, the code loops over symmetry blocks of J-AC and figures
* out if the indices on the processor fall within a block or not. Within
* a J-AC symmetry block, NJ(ISYJ) and NAGEB(ISYAC) are known, so they can
* be determined by integer division. This could be optimized by combining
* it with loop peeling (on the todo list?).

      SQRTH=SQRT(0.5D0)
      SQRTA=SQRT(1.5D0)

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(3,NBRABUF,IOBRA)
      CALL CHOVEC_SIZE(4,NKETBUF,IOKET)

      CALL GETMEM('BRABUF','ALLO','REAL',LBRABUF,NBRABUF)
      CALL GETMEM('KETBUF','ALLO','REAL',LKETBUF,NKETBUF)

      CALL CHOVEC_READ(3,LBRABUF)
      CALL CHOVEC_READ(4,LKETBUF)

      iCASE=10
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 10

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
! find start and end block
        IOFF=0
        DO ISYJ=1,NSYM
          ISYAC=MUL(ISYJ,ISYM)
          ISYV=ISYM

          NJ=NISH(ISYJ)
          NAC=NAGEB(ISYAC)
          ! what is start/end in this block?
          IJAGECSTA=MAX(IISTA-IOFF,1)
          IJAGECEND=MIN(IIEND-IOFF,NJ*NAC)

          DO IJAGEC=IJAGECSTA,IJAGECEND
            IAGEC=(IJAGEC-1)/NJ+1
            IJ=IJAGEC-NJ*(IAGEC-1)
            IAGECTOT=IAGEC+NAGEBES(ISYAC)
            IAABS=MAGEB(1,IAGECTOT)
            ICABS=MAGEB(2,IAGECTOT)
            IA  =MAREL(1,IAABS)
            ISYA=MAREL(2,IAABS)
            IC  =MAREL(1,ICABS)
            ISYC=MAREL(2,ICABS)
            DO IV=IASTA,IAEND ! these are always all elements
! compute integrals (ajvl) and (alvj)
              NV=NVTOT_CHOSYM(MUL(ISYA,ISYV))
              IAV=IA-1+NSSH(ISYA)*(IV-1)
              ICJ=IC-1+NSSH(ISYC)*(IJ-1)
              IOFFAV=LBRABUF+IOBRA(ISYA,ISYV)+NV*IAV
              IOFFCJ=LKETBUF+IOKET(ISYC,ISYJ)+NV*ICJ
              AVCJ=DDOT_(NV,WORK(IOFFAV),1,WORK(IOFFCJ),1)

              NV=NVTOT_CHOSYM(MUL(ISYC,ISYV))
              ICV=IC-1+NSSH(ISYC)*(IV-1)
              IAJ=IA-1+NSSH(ISYA)*(IJ-1)
              IOFFCV=LBRABUF+IOBRA(ISYC,ISYV)+NV*ICV
              IOFFAJ=LKETBUF+IOKET(ISYA,ISYJ)+NV*IAJ
              CVAJ=DDOT_(NV,WORK(IOFFCV),1,WORK(IOFFAJ),1)

C GP(v,jac)=((av,cj)+(cv,aj))/SQRT(2+2*Kron(a,b))
              IF (IAABS.EQ.ICABS) THEN
                SCL=0.5D0
              ELSE
                SCL=SQRTH
              END IF
              GP=SCL*(AVCJ+CVAJ)
! write element EP
              IDX=IV+NAS*(IJAGEC+IOFF-IISTA)
              DBL_MB(MW+IDX-1)=GP
            END DO
          END DO

          IOFF=IOFF+NJ*NAC
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 10     CONTINUE
      END DO
************************************************************************



      iCASE=11
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW.EQ.0) GOTO 11

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
! find start and end block
        IOFF=0
        DO ISYJ=1,NSYM
          ISYAC=MUL(ISYJ,ISYM)
          ISYV=ISYM

          NJ=NISH(ISYJ)
          NAC=NAGTB(ISYAC)
          ! what is start/end in this block?
          IJAGTCSTA=MAX(IISTA-IOFF,1)
          IJAGTCEND=MIN(IIEND-IOFF,NJ*NAC)

          DO IJAGTC=IJAGTCSTA,IJAGTCEND
            IAGTC=(IJAGTC-1)/NJ+1
            IJ=IJAGTC-NJ*(IAGTC-1)
            IAGTCTOT=IAGTC+NAGTBES(ISYAC)
            IAABS=MAGTB(1,IAGTCTOT)
            ICABS=MAGTB(2,IAGTCTOT)
            IA  =MAREL(1,IAABS)
            ISYA=MAREL(2,IAABS)
            IC  =MAREL(1,ICABS)
            ISYC=MAREL(2,ICABS)
            DO IV=IASTA,IAEND ! these are always all elements
! compute integrals (ajvl) and (alvj)
              NV=NVTOT_CHOSYM(MUL(ISYA,ISYV))
              IAV=IA-1+NSSH(ISYA)*(IV-1)
              ICJ=IC-1+NSSH(ISYC)*(IJ-1)
              IOFFAV=LBRABUF+IOBRA(ISYA,ISYV)+NV*IAV
              IOFFCJ=LKETBUF+IOKET(ISYC,ISYJ)+NV*ICJ
              AVCJ=DDOT_(NV,WORK(IOFFAV),1,WORK(IOFFCJ),1)

              NV=NVTOT_CHOSYM(MUL(ISYC,ISYV))
              ICV=IC-1+NSSH(ISYC)*(IV-1)
              IAJ=IA-1+NSSH(ISYA)*(IJ-1)
              IOFFCV=LBRABUF+IOBRA(ISYC,ISYV)+NV*ICV
              IOFFAJ=LKETBUF+IOKET(ISYA,ISYJ)+NV*IAJ
              CVAJ=DDOT_(NV,WORK(IOFFCV),1,WORK(IOFFAJ),1)

C GM(v,jac)=((av,cj)-(cv,aj))*SQRT(3/2)
              GM=SQRTA*(AVCJ-CVAJ)
! write element GM
              IDX=IV+NAS*(IJAGTC+IOFF-IISTA)
              DBL_MB(MW+IDX-1)=GM
            END DO
          END DO

          IOFF=IOFF+NJ*NAC
        END DO
************************************************************************

        CALL RHS_Release_Update (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (NAS,NIS,lg_W)
 11     CONTINUE
      END DO
************************************************************************

      CALL GETMEM('BRABUF','FREE','REAL',LBRABUF,NBRABUF)
      CALL GETMEM('KETBUF','FREE','REAL',LKETBUF,NKETBUF)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_map22(a,b,dimp,dimq,dim_1,dim_2,p,nfact)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dim_1, dim_2, p, nfact
real(kind=wp), intent(in) :: a(dimp,dimq)
real(kind=wp), intent(out) :: b(dim_1,dim_2)
integer(kind=iwp) :: pp !, indx(2)

if (nfact == 1) then

  ! nfact = + 1

  !do qq=1,dimq
  !  indx(q) = qq
  !  do pp=1,dimp
  !    indx(p) = pp
  !    b(indx(1),indx(2)) = a(pp,qq)
  !  end do
  !end do

  if (p == 1) then
    !1* (2)
    b(1:dimp,1:dimq) = a
  else
    !2* (1)
    do pp=1,dimp
      b(1:dimq,pp) = a(pp,:)
    end do
  end if

else

  ! nfact = -1

  !do qq=1,dimq
  !  indx(q) = qq
  !  do pp=1,dimp
  !    indx(p) = pp
  !    b(indx(1),indx(2)) = -a(pp,qq)
  !  end do
  !end do

  if (p == 1) then
    !1* (2)
    b(1:dimp,1:dimq) = -a
  else
    !2* (1)
    do pp=1,dimp
      b(1:dimq,pp) = -a(pp,:)
    end do
  end if

end if

return

end subroutine cct3_map22

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1981, Per-Olof Widmark                                 *
************************************************************************
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C  THIS ROUTINE SORTS THE VECTORS X AND Y, WHERE THE VECTOR X IS       C
C  USED AS THE KEYS.                                                   C
C                                                                      C
C  DATE: 81 04 14                                                      C
C                                                                      C
C  AUTHOR: P-O WIDMARK                                                 C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE SORT_POT(X,Y,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(N),Y(N)
      DO 10 I=2,N
         IND=I-1
         SMALL=X(IND)
         DO 20 J=I,N
            IF(X(J).GT.SMALL) GOTO 20
            IND=J
            SMALL=X(IND)
20       CONTINUE
         Z=X(I-1)
         X(I-1)=X(IND)
         X(IND)=Z
         Z=Y(I-1)
         Y(I-1)=Y(IND)
         Y(IND)=Z
10    CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Mk_Indkl(Indkl_OnOff,Indkl,nkl)
      Implicit Real*8 (a-h,o-z)
      Integer Indkl_OnOff(nkl), Indkl(nkl)
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call iVcPrt('Mk_Indkl: Indkl_OnOff',' ',Indkl_OnOff,nkl)
#endif
      ikl = 0
      Do jkl = 1, nkl
         If (Indkl_OnOff(jkl).eq.1) Then
            ikl = ikl + 1
            Indkl(jkl)=ikl
         Else
            Indkl(jkl)=0
         End If
      End Do
#ifdef _DEBUGPRINT_
      Call iVcPrt('Mk_Indkl: Indkl',' ',Indkl,nkl)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function nSize_3C(kS,lS,nShBf,nShell,nIrrep,iOff,nBas_Aux)
!***********************************************************************
!                                                                      *
!     Compute the size of ({nu,mu}|K) and the offsets to the           *
!     different symmetry blocks.                                       *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nSize_3C
integer(kind=iwp), intent(in) :: kS, lS, nShell, nIrrep, nShBf(0:nIrrep-1,nShell), nBas_Aux(0:nIrrep-1)
integer(kind=iwp), intent(out) :: iOff(3,0:nIrrep-1)
integer(kind=iwp) :: kIrrep, klIrrep, lIrrep, nJ, nK, nKL, nL

nSize_3C = 0
iOff(:,:) = 0

if (nIrrep == 1) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (kS /= lS) then
    nK = nShBf(0,kS)
    nL = nShBf(0,lS)
    nKL = nK*nL
  else
    nK = nShBf(0,kS)
    nKL = nTri_Elem(nK)
  end if
  iOff(1,0) = nKL

  nJ = nBas_Aux(0)-1
  iOff(2,0) = nJ
  nSize_3C = nJ*nkl
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do klIrrep=0,nIrrep-1
    iOff(3,klIrrep) = nSize_3C

    nKL = 0
    if (kS /= lS) then
      do kIrrep=0,nIrrep-1
        nK = nShBf(kIrrep,kS)
        lIrrep = Mul(klIrrep+1,kIrrep+1)-1
        nL = nShBf(lIrrep,lS)
        nKL = nKL+nK*nL
      end do
    else
      do kIrrep=0,nIrrep-1
        nK = nShBf(kIrrep,kS)
        lIrrep = Mul(klIrrep+1,kIrrep+1)-1
        nL = nShBf(lIrrep,lS)

        if (kIrrep > lIrrep) then
          nKL = nKL+nK*nL
        else if (kIrrep == lIrrep) then
          nKL = nKL+nTri_ELem(nK)
        end if

      end do
    end if
    iOff(1,klIrrep) = nKL

    nJ = nBas_Aux(klIrrep)
    if (klIrrep == 0) nJ = nJ-1
    iOff(2,klIrrep) = nJ
    nSize_3C = nSize_3C+nJ*nKL

  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end function nSize_3C

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NGETH1(H,ISM,ITP,JSM,JTP)
! One-electron integrals over orbitals belonging to given OS class

use MCLR_Data, only: NTSOB
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: H(*)
integer(kind=iwp), intent(in) :: ISM, ITP, JSM, JTP
integer(kind=iwp) :: I, IJ, J, NI, NJ
real(kind=wp), external :: GTH1ES_MCLR

NI = NTSOB(ITP,ISM)
NJ = NTSOB(JTP,JSM)
IJ = 0
do J=1,NJ
  do I=1,NI
    IJ = IJ+1
    H(IJ) = GTH1ES_MCLR(I,ITP,ISM,J,JTP,JSM)
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' H1 for itp ism jtp jsm ',ITP,ISM,JTP,JSM
call WRTMAT(H,NI,NJ,NI,NJ)
#endif

end subroutine NGETH1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2009, Roland Lindh                                     *
************************************************************************
      Subroutine ReacQ(V_X,nX,V_Q,nQ)
************************************************************************
*                                                                      *
*     Objective: Transform the "reaction vector" from cartesian        *
*                coordinates to Internal.                              *
*                                                                      *
*     Roland Lindh, Dept. of Theor. Chem., Lund University, Sweden     *
*     2009                                                             *
************************************************************************
      use Slapaf_Info, only: BMx, Degen
      Implicit Real*8 (a-h,o-z)
      Real*8 V_Q(nQ), V_X(nX)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Call RecPrt('BMx',' ',BMx,nX,nQ)
      Call RecPrt('V_X',' ',V_X,nX,1)
#endif
*
      M = nX
      N = nQ
      NRHS=1
      Call Eq_Solver('T',M,N,NRHS,BMx,.FALSE.,Degen,V_X,V_Q)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('V_Q',' ',V_Q,nQ,1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RF_Coord(
     &                 nq,nAtoms,iIter,nIter,Cx,jStab,
     &                 nStab,nDim,Smmtrc,Process,Value,
     &                 nB,iANr,qLbl,iRef,fconst,
     &                 rMult,LuIC,Indq,dMass,iCoSet,
     &                 Proc_dB,mB_Tot,mdB_Tot,
     &                 BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,nqB)
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "stdalloc.fh"
#include "real.fh"
#include "sbs.fh"
#include "print.fh"
      Real*8 Cx(3,nAtoms,nIter),
     &       dMass(nAtoms), fconst(nB), Value(nB,nIter), rMult(nB),
     &       Trans(3), RotVec(3), RotMat(3,3),
     &       BM(nB_Tot), dBM(ndB_Tot)
      Integer   nStab(nAtoms), iCoSet(0:7,nAtoms),
     &          jStab(0:7,nAtoms), nqB(nB),
     &          iANr(nAtoms), Indq(3,nB), iBM(nB_Tot), idBM(2,ndB_Tot)
      Logical Smmtrc(3,nAtoms), Process, PSPrint,
     &        TransVar, RotVar, Proc_dB, Invariant
      Character*3 TR_type(6)
      Character*14 Label, qLbl(nB)
#include "ddvdt_RF.fh"
      Real*8, Dimension(:), Allocatable :: xMass
      Real*8, Dimension(:,:), Allocatable :: currXYZ, Ref123, Grad,
     &                                       dRVdxyz, Hess
      Real*8, Dimension(:,:,:), Allocatable :: d2RV
      Integer, Dimension(:), Allocatable :: Ind, iDCR
      Dimension dum(1)
      Data TR_type/'Tx ','Ty ','Tz ','Ryz','Rzx','Rxy'/
*
      iRout=151
      iPrint=nPrint(iRout)
*
      TransVar=iAnd(iSBS,2**7).eq. 2**7
      RotVar=iAnd(iSBS,2**8).eq. 2**8
      If (.Not.RotVar.and..Not.TransVar) Go To 99
*                                                                      *
************************************************************************
*                                                                      *
      nqRF=0
      PSPrint=.False.
      If (iPrint.ge.99) PSPrint=.True.
      If (PSPrint) Write (6,*) ' Enter RF_Coords.'
*
*---- Find nCent and allocate
*
      nCent=0
      Do iAtom = 1, nAtoms
         nCent=nCent+nIrrep/nStab(iAtom)
      End Do
      mB = nCent*3
      Call mma_allocate(currXYZ,3,nCent,label='currXYZ')
      Call mma_allocate(Ref123,3,nCent,label='Ref123')
      Call mma_allocate(Grad,3,nCent,label='Grad')
      Call mma_allocate(dRVdxyz,3,3*nCent,label='dRVdxyz')
      Call mma_allocate(xMass,nCent,label='xMass')
      Call mma_allocate(Ind,nCent,label='Ind')
      Call mma_allocate(iDCR,nCent,label='iDCR')
      Call mma_allocate(Hess,mB,mB,label='Hess')
*
*---- Find index of RF center (origin), etc
*
      iCent=0
      Do iAtom = 1, nAtoms
*
         Do i = 0, nIrrep/nStab(iAtom)-1
            iCent = iCent + 1
            Call OA(iCoSet(i,iAtom),Cx(1:3,iAtom,iIter),
     &              CurrXYZ(1:3,iCent))
            Call OA(iCoSet(i,iAtom),Cx(1:3,iAtom,iRef),
     &              Ref123(1:3,iCent))

*
            Ind(iCent)=iAtom
            iDCR(iCent)=iCoSet(i,iAtom)
         End Do
      End Do
      nCurrXYZ=iCent
*
      Fact=One
      If (.Not.RotVar) Fact=2.0D-2
*
*     Write (6,*) 'nCent,nDim=',nCent,nDim
*     Write (6,*) (Ind(iCent),iCent=1,nCent)
*
      TMass = Zero
      Do iCent = 1, nCent
         iAtom = Ind(iCent)
         xMass(iCent) = dMass(iAtom)
         TMass = TMass + dMass(iAtom)
      End Do
*---- Loop over cartesian components
*
      Do ixyz = 1, 3
*
         Invariant=.False.
         iTest=2**(ixyz-1)
         Do iSym = 0, nIrrep-1
            If (iOper(iSym).eq.iTest) Invariant=.True.
         End Do
         If (Invariant) Go To 199
*
*------- Compute total mass and center of mass of the molecule, the center
*        of the RF cavity is at origin with infinite mass. Hence, the latter
*        is ignored!
*
         COM_xyz = Zero
         Do iCent = 1, nCent
            COM_xyz = COM_xyz + currXYZ(ixyz,iCent)*xMass(iCent)
         End Do
         COM_xyz=COM_xyz/TMass
*
         If (.Not.TransVar) Go To 199
         f_Const=One
*        Write (6,*) ' RF Force Constant:',f_Const
*
         iDeg=1
         Deg=Sqrt(DBLE(iDeg))
*
         nq = nq + 1
         If (.Not.Process) mB_Tot = mB_Tot + mB
         If (.Not.Proc_dB) mdB_Tot = mdB_Tot + mB**2
         nqRF = nqRF + 1
         Write (LuIC,'(A,I2.2,2A)')
     &              'TR',nqRF,' = ',TR_type(ixyz)
         Label=' '
         Write (Label,'(A,I2.2)') 'TR',nqRF
*
         Val = COM_xyz
*
*------- Compute the gradient
*
         call dcopy_(mB,[Zero],0,Grad,1)
         Do iCent = 1, nCent
            iAtom=Ind(iCent)
*           Write (6,*) 'iAtom,iCOM=',iAtom,iCOM
            Grad(ixyz,iCent) = dMass(iAtom)/TMass
         End Do
C        Call RecPrt('Grad (Trans)',' ',Grad,3,nCent)
*
*------- Second derivative is trivially zero!
*
         Call FZero(Hess,mB**2)
         If (Process) Then
*
            Indq(1,nq) = -2**(ixyz)/2
            Indq(2,nq) = 0
            Indq(3,nq) = 0
*
C           fconst(nq)=Sqrt(Fact*Trans_Const)
            fconst(nq)=Sqrt(Trans_Const)
            rMult(nq)=Deg
*
            Value(nq,iIter)=Val
            qLbl(nq)=Label
*
*--------   Project the gradient vector
*
            Call ProjSym(nAtoms,nCent,Ind,nStab,jStab,currXYZ,
     &                   iDCR,Grad,Smmtrc,nDim,PSPrint,
     &                   Hess,mB_Tot,mdB_Tot,
     &                   BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,
     &                   Proc_dB,nqB,nB,nq,rMult(nq))
*
         End If
*
 199     Continue
      End Do
*                                                                      *
************************************************************************
*                                                                      *
C     Write (6,*) 'RotVar=',RotVar
      If (.Not.RotVar) Go To 98
*
*     A la Malmqvist
*
      nOrder=2
      nMass=nCent
      Call FZero(Trans,3)
      Call FZero(RotVec,3)
      Call mma_allocate(d2RV,3,3*nCent,3*nCent,label='d2RV')
C     Call RecPrt('xMass',' ',xMass,1,nMass)
      Call RotDer(nMass,xMass,currXYZ,ref123,trans,RotAng,
     &            RotVec,RotMat,nOrder,dRVdXYZ,d2RV,dum,dum)
C     Call RecPrt('RotVec',' ',RotVec,1,3)
C     Call RecPrt('RotMat',' ',RotMat,3,3)
C     Call RecPrt('dRVdXYZ',' ',dRVdXYZ,3,3*nMass)
*
      Do ixyz = 1, 3
*
         Invariant=.False.
         If (ixyz.eq.1) Then
            iTest=6
         Else If (ixyz.eq.2) Then
            iTest=5
         Else
            iTest=3
         End If
         Do iSym = 0, nIrrep-1
            If (iOper(iSym).eq.iTest) Invariant=.True.
         End Do
         If (Invariant) Go To 299
*
         jxyz = ixyz+1
         If (jxyz.gt.3) jxyz=1
         kxyz = jxyz+1
         If (kxyz.gt.3) kxyz=1
         iDeg=1
         Deg=Sqrt(DBLE(iDeg))
*
         nq = nq + 1
         If (.Not.Process) mB_Tot = mB_Tot + mB
         If (.Not.Proc_dB) mdB_Tot = mdB_Tot + mB**2
         nqRF = nqRF + 1
         Write (LuIC,'(A,I2.2,2A)')
     &              'TR',nqRF,' = ',TR_type(ixyz+3)
         Label=' '
         Write (Label,'(A,I2.2)') 'TR',nqRF
*
         Val = RotVec(ixyz)
*
*------- Compute the gradient
*
         call dcopy_(mB,[Zero],0,Grad,1)
         call dcopy_(mB,dRVdXYZ(ixyz,1),3,Grad,1)
C        Call RecPrt('Grad (Rot)',' ',Grad,3,nCent)
*
*------- Second derivative
*
         Call FZero(Hess,mB**2)
         If (Proc_dB) Call DCopy_(mB**2,d2RV(ixyz,1,1),3,Hess,1)
*
         If (Process) Then
*
            Indq(1,nq) = -( 2**(jxyz)/2  + 2**(kxyz)/2)
            Indq(2,nq) = 0
            Indq(3,nq) = 0
*
            fconst(nq)=Sqrt(Rot_Const)
            rMult(nq)=Deg
*
            Value(nq,iIter)=Val
            qLbl(nq)=Label
*
*--------   Project the gradient vector
*
            Call ProjSym(nAtoms,nCent,Ind,nStab,jStab,currXYZ,
     &                   iDCR,Grad,Smmtrc,nDim,PSPrint,
     &                   Hess,mB_Tot,mdB_Tot,
     &                   BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,
     &                   Proc_dB,nqB,nB,nq,rMult(nq))
*
         End If
*
 299     Continue
      End Do
      Call mma_deallocate(d2RV)
C     Write (6,*) 'nqRF=',nqRF
*                                                                      *
************************************************************************
*                                                                      *
 98   Continue
      Call mma_deallocate(currXYZ)
      Call mma_deallocate(Ref123)
      Call mma_deallocate(Grad)
      Call mma_deallocate(dRVdxyz)
      Call mma_deallocate(xMass)
      Call mma_deallocate(Ind)
      Call mma_deallocate(iDCR)
      Call mma_deallocate(Hess)
 99   Continue
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(iANr)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine CStart_CI_Util(C,h0,TUVX,iSel,ExplE,ExplV,nMaxSel,iFinal)
!***********************************************************************
!                                                                      *
!     Find initial CI-vectors                                          *
!                                                                      *
!     calling arguments:                                               *
!     C       : array of real*8                                        *
!               CI vector                                              *
!     h0      : array of real*8                                        *
!               one-electron integrals                                 *
!     TUVX    : array of real*8                                        *
!               two-electron integrals                                 *
!     iSel    : array of integer                                       *
!               list of configuration included in the explicit Hamilt. *
!     ExplE   : array of real*8                                        *
!               eigenvalues of the explicit Hamiltonian                *
!     ExplV   : array of real*8                                        *
!               eigenvectors of the explicit Hamiltonian               *
!     iFinal  : integer                                                *
!               status of optimization process                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

#ifdef _HDF5_
use mh5, only: mh5_is_hdf5, mh5_open_file_r, mh5_fetch_dset,mh5_close_file
#endif
use csfbas, only: CONF, KCFTP
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: C(*), ExplE(*), ExplV(*)
real(kind=wp), intent(in) :: h0(*), TUVX(*)
integer(kind=iwp), intent(_OUT_) :: iSel(*)
integer(kind=iwp), intent(in) :: nMaxSel, iFinal
integer(kind=iwp) :: i, iDisk, iJOB, IPRLEV, j, k, l
#ifdef _HDF5_
integer(kind=iwp) :: mh5id
#endif
logical(kind=iwp) :: Exists
character(len=80) :: String
integer(kind=iwp), allocatable :: vkcnf(:)
real(kind=wp), allocatable :: Tmp1(:)
#include "rasdim.fh"
#include "general.fh"
#include "rasscf.fh"
#include "WrkSpc.fh"
#include "output_ras.fh"

IPRLEV = IPRLOC(3)

! special case: nConf=1

if ((nConf == 1) .and. (nAc == 0)) then
  iDisk = IADR15(4)
  !ExplE(1) = C(1)  ! Commented out by Jesper
  !ExplV(1) = One   ! Commented out by Jesper
  C(1) = One
  call Save_tmp_CI_vec(1,nConf,C,LuDavid)
  return
end if

! compute the explicit Hamiltonian
! (needs to be out here as we want to redetermine dynamically the selection vector)

call ExplH2(C,h0,TUVX,iSel,ExplE,ExplV)

! special case: nSel=nConf

if (nSel == nMaxSel) then
  if (IPRLEV >= DEBUG) write(u6,*) ' Initial CI-vectors are obtained by diagonalizing the explicit Hamiltonian'
  iDisk = IADR15(4)
  do i=1,lRoots
    C(1:nConf) = Zero
    do j=1,nSel
      k = iSel(j)
      C(k) = ExplV(j+(i-1)*nSel)
    end do
    call Save_tmp_CI_vec(i,nConf,C,LuDavid)
    if (IPRLEV >= INSANE) then
      write(String,'(A,I2)') 'CI vector of root',i
      write(String,'(A,I4,A)') '(max. ',nSel,' elements)'
      l = min(nSel,nConf)
      call dVcPrt(String,' ',ExplV(1+(i-1)*nSel),l)
    end if
  end do
  return
end if

if (Start_Vectors) then
  Start_Vectors = .false.
  if (ICIRST /= 0) then
#   ifdef _HDF5_
    call f_Inquire(StartOrbFile,Exists)
    if (Exists) then
      if (mh5_is_hdf5(StartOrbFile)) then
        if (IPRLEV >= TERSE) then
          write(u6,'(1x,a)') 'reading initial CI vectors from '//StartOrbFile
        end if
        mh5id = mh5_open_file_r(StartOrbFile)

        call mma_allocate(Tmp1,nConf,label='Scr1')
        call mma_allocate(vkcnf,nactel,label='kcnf')
        do i=1,lRoots
          call mh5_fetch_dset(mh5id,'CI_VECTORS',Tmp1,[nconf,1],[0,i-1])
          call Reord2(NAC,NACTEL,STSYM,1,CONF,iWork(KCFTP),Tmp1,C,vkcnf)
          call Save_CI_vec(i,nConf,C,LuDavid)
        end do
        call mma_deallocate(Tmp1)
        call mma_deallocate(vkcnf)

        call mh5_close_file(mh5id)
      else
        Exists = .false.
      end if
    end if
    if (.not. Exists) then
#   endif
      ! get start vectors by reading JOBOLD
      iJOB = 0
      call f_Inquire('JOBOLD',Exists)
      if (Exists) iJOB = 1
      if (iJOB == 1) then
        if (IPRLEV >= TERSE) then
          write(u6,'(1x,a)') 'reading initial CI vectors from JOBOLD'
        end if
        if (JOBOLD <= 0) then
          JOBOLD = 20
          call DaName(JOBOLD,'JOBOLD')
        end if
      else
        if (IPRLEV >= TERSE) then
          write(u6,'(1x,a)') 'reading initial CI vectors from JOBIPH'
        end if
        JOBOLD = JOBIPH
      end if

      iDisk = 0
      call IDafile(JOBOLD,2,iToc,15,iDisk)
      iDisk = iToc(4)
      call mma_allocate(Tmp1,nConf,label='Scr1')
      call mma_allocate(vkcnf,nactel,label='kcnf')
      do i=1,lRoots
        call DDafile(JOBOLD,2,Tmp1,nConf,iDisk)
        call Reord2(NAC,NACTEL,STSYM,1,CONF,iWork(KCFTP),Tmp1,C,vkcnf)
        call Save_CI_vec(i,nConf,C,LuDavid)
        if (IPRLEV >= INSANE) then
          write(String,'(A,I2)') 'Start vector of root',i
          write(String,'(A,I4,A)') '(max. ',nSel,' elements)'
          l = min(nSel,nConf)
          call dVcPrt(String,' ',C,l)
        end if
      end do
      call mma_deallocate(Tmp1)
      call mma_deallocate(vkcnf)
      if (iJOB == 1) then
        if ((JOBOLD > 0) .and. (JOBOLD /= JOBIPH)) then
          call DaClos(JOBOLD)
          JOBOLD = -1
        else if (JOBOLD > 0) then
          JOBOLD = -1
        end if
      end if
#   ifdef _HDF5_
    end if
#   endif

  else
    ! no CI restart, get start vectors by diagonalizing the explicit Hamiltonian
    if (IPRLEV >= DEBUG) write(u6,*) ' Initial CI-vectors are obtained by diagonalizing the explicit Hamiltonian'
    do i=1,lRoots
      C(1:nConf) = Zero
      do j=1,nSel
        k = iSel(j)
        C(k) = ExplV(j+(i-1)*nSel)
      end do
      call Save_CI_vec(i,nConf,C,LuDavid)
      if (IPRLEV >= INSANE) then
        write(String,'(A,I2)') 'Start vector of root',i
        write(String,'(A,I4,A)') '(max. ',nSel,' elements)'
        l = min(nSel,nConf)
        call dVcPrt(String,' ',C,l)
      end if
    end do

  end if

else
  ! no external start vector needed, get start vectors by reading JOBIPH
  if (iFinal == 2) then
    if (IPRLEV >= DEBUG) write(u6,*) ' Initial CI-vectors are identical to the transformed CI-vectors of the previous RASSCF &
                                     &iteration'
  else
    if (IPRLEV >= DEBUG) write(u6,*) ' Initial CI-vectors are identical to the CI-vectors of the previous RASSCF iteration'
  end if
  iDisk = IADR15(4)
  do i=1,lRoots-hRoots
    call DDafile(JOBIPH,2,C,nConf,iDisk)
    call Save_CI_vec(i,nConf,C,LuDavid)
    if (IPRLEV > 10) then
      write(String,'(A,I2)') 'Start vector of root',i
      write(String,'(A,I4,A)') '(max. ',nSel,' elements)'
      l = min(nSel,nConf)
      call dVcPrt(String,' ',C,l)
    end if
  end do
  ! MGD simple guess for missing ones : explV
  ! dangerous if linear dependence with converged states
  do i=lRoots-hRoots+1,lRoots
    C(1:nConf) = Zero
    do j=1,nSel
      k = iSel(j)
      C(k) = ExplV(j+(i-1)*nSel)
    end do
    call Save_CI_vec(i,nConf,C,LuDavid)
  end do

end if

return

end subroutine CStart_CI_Util

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RESTR_MCLR(NVERT0,IDRT0,IDOWN0,IVER,
     &                 LV1RAS,LV3RAS,LM1RAS,LM3RAS,NVERT)
C
C     PURPOSE: PUT THE RAS CONSTRAINT TO THE DRT TABLE BY
C              CREATING A MASK
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION IDRT0(NVERT0,5),IDOWN0(NVERT0,0:3),IVER(NVERT0)
C
      PARAMETER (LTAB=1,NTAB=2)
      DIMENSION IIOR(0:3,0:3)
      DIMENSION IIAND(0:3,0:3)
      DATA IIOR  / 0,1,2,3,1,1,3,3,2,3,2,3,3,3,3,3 /
      DATA IIAND / 0,0,0,0,0,1,0,1,0,0,2,2,0,1,2,3 /
C
C
C     LOOP OVER ALL VERTICES AND CHECK ON RAS CONDITIONS
C     CREATE MASK
C
      DO 10 IV=1,NVERT0
        LEV=IDRT0(IV,LTAB)
        N=IDRT0(IV,NTAB)
        IVER(IV)=0
        IF((LEV.EQ.LV1RAS).AND.(N.GE.LM1RAS)) IVER(IV)=1
        IF((LEV.EQ.LV3RAS).AND.(N.GE.LM3RAS)) IVER(IV)=IVER(IV)+2
10    CONTINUE
C
C     NOW LOOP FORWARDS, MARKING THOSE VERTICES CONNECTED FROM ABOVE.
C     SINCE IVER WAS INITIALIZED TO ZERO, NO CHECKING IS NEEDED.
C
      DO 20 IV=1,NVERT0-1
        IVV=IVER(IV)
        DO 21 IC=0,3
          ID=IDOWN0(IV,IC)
          IF(ID.EQ.0) GOTO 21
          IVER(ID)=IIOR(IVER(ID),IVV)
21      CONTINUE
20    CONTINUE
C
C     THEN LOOP BACKWARDS. SAME RULES, EXCEPT THAT CONNECTIVITY
C     SHOULD BE PROPAGATED ONLY ABOVE THE RESTRICTION LEVELS.
C
      DO 40 IV=NVERT0-1,1,-1
        LEV=IDRT0(IV,LTAB)
        MASK=0
        IF(LEV.GT.LV1RAS) MASK=1
        IF(LEV.GT.LV3RAS) MASK=MASK+2
        IVV=IVER(IV)
        DO 30 IC=0,3
          ID=IDOWN0(IV,IC)
          IF(ID.EQ.0) GOTO 30
          IVD=IVER(ID)
          IVV=IIOR(IVV,IIAND(MASK,IVD))
30      CONTINUE
        IVER(IV)=IVV
40    CONTINUE
C
C     WE ARE NOW INTERESTED ONLY IN VERTICES CONNECTED BOTH TO
C     ALLOWED VERTICES FOR RAS-SPACE 1 AND RAS-SPACE 3.
C     THOSE ARE NUMBERED IN ASCENDING ORDER, THE REST ARE ZEROED.
C
      NVERT=0
      DO 50 IV=1,NVERT0
        IF(IVER(IV).EQ.3) THEN
          NVERT=NVERT+1
          IVER(IV)=NVERT
        ELSE
          IVER(IV)=0
        ENDIF
50    CONTINUE
C
C
C     EXIT
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Roland Lindh                                     *
!***********************************************************************

subroutine Init_UpdMask(nInter)

use Slapaf_Info, only: Coor, Curvilinear, Redundant
use NewH_mod, only: UpdMask
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nInter
integer(kind=iwp) :: iAtom, nAtMM, nsAtom
integer(kind=iwp), allocatable :: IsMM(:)

nsAtom = size(Coor,2)

! If redundant Cartesians and no symmetry, use unit matrix for MM atoms

if (Redundant .and. (.not. Curvilinear) .and. (3*nsAtom == nInter)) then
  call mma_allocate(UpdMask,nInter,label='UpdMask')
  call mma_allocate(IsMM,nsAtom,Label='IsMM')
  call MMCount(nsAtom,nAtMM,IsMM)
  do iAtom=1,nsAtom
    UpdMask((iAtom-1)*3+1:(iAtom-1)*3+3) = merge(1,0,IsMM(iAtom) == 1)
  end do
  call mma_deallocate(IsMM)
end if

return

end subroutine Init_UpdMask

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine wfnsizes
************************************************************************
*
* Compute various orbital sizes
*
************************************************************************
      implicit none
#include "rasdim.fh"
#include "caspt2.fh"
#include "pt2_guga.fh"

      Integer NASHT2
      Integer NI, NR1, NR2, NR3, NS, N123
      Integer I, iSym

* Table sizes
      Integer IIABS, ITABS, IAABS
      Integer II, IA, IS, IO
      Integer ITOT, IINA, IACT, IEXT

      NFROT=0
      NISHT=0
      NASHT=0
      NRAS1T=0
      NRAS2T=0
      NRAS3T=0
      NOSHT=0
      NSSHT=0
      NDELT=0
      NORBT=0
      NBAST=0
      NOSQT=0
      NBSQT=0
      NIMX=0
      NAMX=0
      NSMX=0
      NOMX=0
      NBMX=0
      DO ISYM=1,NSYM
        NIES(ISYM)=NISHT
        NAES(ISYM)=NASHT
        NSES(ISYM)=NSSHT
        NOSH(ISYM)=NISH(ISYM)+NASH(ISYM)
        NSSH(ISYM)=NBAS(ISYM)-NFRO(ISYM)-NOSH(ISYM)-NDEL(ISYM)
        NORB(ISYM)=NOSH(ISYM)+NSSH(ISYM)
        NORBT=NORBT+NORB(ISYM)
        NOSQT=NOSQT+NORB(ISYM)**2
        NBSQT=NBSQT+NBAS(ISYM)**2
        NFROT=NFROT+NFRO(ISYM)
        NISHT=NISHT+NISH(ISYM)
        NASHT=NASHT+NASH(ISYM)
        NOSHT=NOSHT+NOSH(ISYM)
        NRAS1T=NRAS1T+NRAS1(ISYM)
        NRAS2T=NRAS2T+NRAS2(ISYM)
        NRAS3T=NRAS3T+NRAS3(ISYM)
        NSSHT=NSSHT+NSSH(ISYM)
        NDELT=NDELT+NDEL(ISYM)
        NBAST=NBAST+NBAS(ISYM)
        NIMX=MAX(NIMX,NISH(ISYM))
        NAMX=MAX(NAMX,NASH(ISYM))
        NSMX=MAX(NSMX,NSSH(ISYM))
        NOMX=MAX(NOMX,NORB(ISYM))
        NBMX=MAX(NBMX,NBAS(ISYM))
      END DO
C Set RHS Boxes to maximum size
      NINABX=NIMX
      NSECBX=NSMX
      NBTRI=(NBSQT+NBAST)/2
      NOTRI=(NOSQT+NORBT)/2
* Size of orbital transformation arrays:
      NTORB=0
      NTAT=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NR1=NRAS1(ISYM)
        NR2=NRAS2(ISYM)
        NR3=NRAS3(ISYM)
        NS=NSSH(ISYM)
        N123=NR1**2+NR2**2+NR3**2
        NTAT=NTAT+N123
        NTORB=NTORB+NI**2+N123+NS**2
      END DO
C Sizes of DREF and PREF arrays:
      NDREF=1
      NPREF=1
C Sizes of GAMMA1, GAMMA2, and GAMMA3:
      NG1=1
      NG2=1
      NG3TOT=1
      IF(NASHT.GT.0) THEN
        NDREF=(NASHT**2+NASHT)/2
        NASHT2=NASHT**2
        NPREF=(NASHT2**2+NASHT2)/2
        NG1=NASHT**2
        NG2=NG1**2
        NG3TOT=((NG1+2)*(NG1+1)*NG1)/6
      END IF

C  Identify the wave function type
      ISCF=0
      IF((ISPIN.EQ.NACTEL+1).AND.(NACTEL.EQ.NASHT)) ISCF=2
      IF(NASHT.EQ.0) ISCF=1
      IF(NACTEL.EQ.2*NASHT) ISCF=1

************************************************************************
*
* Create orbital name vector
*
************************************************************************
      II=0
      IA=0
      IS=0
      ITOT=0
      IINA=0
      IACT=0
      IEXT=0
      DO ISYM=1,NSYM
        IO=0
        DO I=1,NFRO(ISYM)
          ITOT=ITOT+1
          IO=IO+1
          WRITE(ORBNAM(ITOT),'(A2,I1,A1,I3.3,1X)')
     &      'Fr',ISYM,'.',IO
        END DO
        DO I=1,NISH(ISYM)
          ITOT=ITOT+1
          IINA=IINA+1
          IINAIS(IINA)=ITOT
          IO=IO+1
          WRITE(ORBNAM(ITOT),'(A2,I1,A1,I3.3,1X)')
     &      'In',ISYM,'.',IO
          II=II+1
          IINAM(II)=ORBNAM(ITOT)
        END DO
        DO I=1,NASH(ISYM)
          ITOT=ITOT+1
          IACT=IACT+1
          IACTIS(IACT)=ITOT
          IO=IO+1
          WRITE(ORBNAM(ITOT),'(A2,I1,A1,I3.3,1X)')
     &      'Ac',ISYM,'.',IO
          IA=IA+1
          IANAM(IA)=ORBNAM(ITOT)
        END DO
        DO I=1,NSSH(ISYM)
          ITOT=ITOT+1
          IEXT=IEXT+1
          IEXTIS(IEXT)=ITOT
          IO=IO+1
          WRITE(ORBNAM(ITOT),'(A2,I1,A1,I3.3,1X)')
     &      'Se',ISYM,'.',IO
          IS=IS+1
          ISNAM(IS)=ORBNAM(ITOT)
        END DO
        DO I=1,NDEL(ISYM)
          ITOT=ITOT+1
          IO=IO+1
          WRITE(ORBNAM(ITOT),'(A2,I1,A1,I3.3,1X)')
     &      'De',ISYM,'.',IO
        END DO
      END DO

************************************************************************
*
* Precompute table sizes
*
************************************************************************
      IIABS=0
      ITABS=0
      IAABS=0
      DO ISYM=1,NSYM
        DO I=1,NORB(ISYM)
          IF(I.LE.NISH(ISYM)) THEN
            IIABS=IIABS+1
            IISYM(IIABS)=ISYM
          ELSE IF(I.LE.NISH(ISYM)+NASH(ISYM)) THEN
            ITABS=ITABS+1
            IASYM(ITABS)=ISYM
          ELSE
            IAABS=IAABS+1
            IESYM(IAABS)=ISYM
          END IF
        END DO
      END DO

*---  Check consistency of the orbitals
      If ( NISHT.gt.MXINA ) Then
        Call WarningMessage(2,'Too many inactive orbitals.')
        WRITE(6,'(a,2i8)')' NISHT >  MXINA:',NISHT,MXINA
        Call Quit_OnUserError
      End If
      If ( NASHT.gt.MXACT ) Then
        Call WarningMessage(2,'Too many active orbitals.')
        WRITE(6,'(a,2i8)')' NASHT > MXACT:',NASHT,MXACT
        Call Quit_OnUserError
      End If
      If ( NSSHT.gt.MXEXT ) Then
        Call WarningMessage(2,'Too many secondary orbitals.')
        WRITE(6,'(a,2i8)')' NSSHT > MXEXT:',NSSHT,MXEXT
        Call Quit_OnUserError
      End If
      If ( NBAST.gt.MXORB ) Then
        Call WarningMessage(2,'Too many basis functions.')
        WRITE(6,'(a,2i8)')' NBAST > MXORB:',NBAST,MXORB
        Call Quit_OnUserError
      End If

*
* GG-Nov04  The following informations must be passed to the Cholesky
* transformation section through RunFile. COMMON blocks cannot be
* used due to several conflicts.
      Call Put_iScalar('nSym',nSym)
      Call Put_iArray('nFroPT',nFro,nSym)
      Call Put_iArray('nIsh'  ,nIsh,nSym)
      Call Put_iArray('nAsh'  ,nAsh,nSym)
      Call Put_iArray('nDelPT',nDel,nSym)
      Call Put_iArray('nBas'  ,nBas,nSym)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Convrg(iter,kIter, nInter,iStop,MxItr,
     &                  mIntEff,mTtAtm,GoOn,Step_Trunc,
     &                  Just_Frequencies)
      Use Chkpnt
      Use Slapaf_Info, only: Cx, Gx, Coor, GNrm, Energy, Shift, qInt,
     &                       dqInt, Lbl
      use Slapaf_Parameters, only: HUpMet, FindTS, Analytic_Hessian,
     &                             MaxItr, Numerical, iNeg, GrdMax,
     &                             E_Delta, ThrEne, ThrGrd, nLambda,
     &                             iOptC, ThrCons, ThrMEP, Baker,
     &                             eMEPTest, rMEP, MEP, nMEP, Stop,
     &                             NADC, EDiffZero, ApproxNADC
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "warnings.h"
      Integer:: IRC=0
      Real*8 Maxed, MaxErr
      Character(LEN=5) ConLbl(5)
      Character(LEN=1) Step_Trunc
      Character(LEN=16) StdIn
      Character(LEN=80) Point_Desc
      Character(LEN=16) MEP_Text
      Logical Conv1, GoOn, Found, Terminate, Last_Energy,
     &        Just_Frequencies, Saddle, eTest,
     &        IRCRestart, Conv2, ConvTmp, TSReg, BadConstraint,
     &        TurnBack
      Character(LEN=8) Temp
      Real*8, Allocatable:: Coor1(:,:), Coor2(:,:)
      Real*8, Allocatable:: E_IRC(:), C_IRC(:,:,:), G_IRC(:,:,:)
      Real*8, Allocatable:: E_S(:), C_S(:,:,:), G_S(:,:,:)
      Real*8, Allocatable:: E_R(:), C_R(:,:), G_R(:,:)
      Real*8, Allocatable:: E_P(:), C_P(:,:), G_P(:,:)
      Real*8, Allocatable:: E_MEP(:), G_MEP(:,:,:)
      Real*8, Allocatable, Target:: C_MEP(:,:,:)
      Real*8, Allocatable:: L_MEP(:), Cu_MEP(:)
      Integer, Allocatable:: Information(:)
      Real*8, Allocatable:: Tmp(:)
      Real*8, Allocatable, Target:: Not_Allocated(:,:), OfRef(:,:)
      Real*8 rDum(1,1,1,1)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
      Subroutine SphInt(xyz,nCent,OfRef,RR0,Bf,l_Write,Label,dBf,ldB)
      Integer nCent
      Real*8  xyz(3,nCent)
      Real*8, Allocatable, Target:: OfRef(:,:)
      Real*8  RR0
      Real*8  Bf(3,nCent)
      Logical l_Write
      Character(LEN=8) Label
      Real*8  dBf(3,nCent,3,nCent)
      Logical ldB
      End Subroutine SphInt
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      nAtom=SIZE(Cx,2)
      TSReg = iAnd(iOptC,8192).eq.8192
*                                                                      *
************************************************************************
*                                                                      *
      Lu=6
      nSaddle_Max=100
      iRout=116
      iPrint=nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt('Convrg: Energy',' ',Energy,1,iter)
         Call RecPrt('Convrg: Shift',' ',Shift,nInter,iter)
         Call RecPrt('Convrg: qInt',' ',qInt,nInter,iter+1)
         Call RecPrt('Convrg: dqInt',' ',dqInt,nInter,iter)
         Call RecPrt('Convrg: Cx',' ',Cx,3*nAtom,iter+1)
         Call RecPrt('Convrg: Gx',' ',Gx,3*nAtom,iter+1)
      End If
*
      Call Get_iScalar('Saddle Iter',iter_S)
      If (iter_S.eq.0) Then
         iter_S=1
         Call Put_iScalar('Saddle Iter',iter_S)
         Call f_Inquire('RUNFILE2',Found)
         If (Found) Then
            Call NameRun('RUNFILE2')
            Call Put_iScalar('Saddle Iter',iter_S)
            Call NameRun('RUNFILE')
         End If
      End If
      Temp=' '
      If (Analytic_Hessian) Then
         If (HUPMET.eq.'  No  '.or.HUPMET.eq.' None ') Then
*           Temp='Analytic'
            Temp='Computed'
         Else
            Temp(1:6)= HUPMET(1:6)
         End if
      Else
         Temp(1:6)= HUPMET(1:6)
      End If
*
      Call mma_allocate(Coor1,3,mTtAtm,Label='Coor1')
      Call mma_allocate(Coor2,3,mTtAtm,Label='Coor2')
      Call AtmLst(Cx(:,:,iter  ),nAtom,Coor1,mTtAtm)
      Call AtmLst(Cx(:,:,iter+1),nAtom,Coor2,mTtAtm)
      Call OptRMS_Slapaf(Coor1,Coor2,mTtAtm,RMS,RMSMax)
      Call mma_deallocate(Coor1)
      Call mma_deallocate(Coor2)
*
      If (kIter.ne.iter .and. kIter.eq.1) Then
         Fabs   = GNrm(kiter)
         E = Energy(kiter)
      Else
         Fabs   = GNrm(iter)
         E = Energy(iter)
      End If
      Fabs = Max(Zero,Fabs)
      E0 = E + E_delta
      Energy(iter+1)=E0
      Gx(:,:,iter+1)=Zero
      If (kiter.eq.1) Then
         eChng=Zero
      Else
         If (kIter.ne.iter .and. kIter.eq.2) Then
            eChng=Energy(iter)-Energy(1)
         Else
            eChng=Energy(iter)-Energy(iter-1)
         End If
      End If
*
      eDiffMEP=Zero
      If (MEP.or.rMEP) Then
         Saddle=.False.
         iMEP=0
         Call Qpg_iScalar('nMEP',Found)
         If (Found) Call Get_iScalar('nMEP',iMEP)
         If (iMEP.eq.0) Then
            iOff_Iter=0
            Call Put_iScalar('iOff_Iter',iOff_Iter)
         Else
            Call Get_iScalar('iOff_Iter',iOff_Iter)
         End If
      Else
         iOff_Iter=0
         iSaddle=0
         Call qpg_dArray('Saddle',Saddle,nSaddle)
         Saddle=Saddle.and..NOT.Just_Frequencies
         If (Saddle) Then
            Call Qpg_iScalar('nMEP',Found)
            If (Found) Call Get_iScalar('nMEP',iSaddle)
            Call Get_iScalar('iOff_Iter',iOff_Iter)
         End If
      End If
*
*----- Convergence criteria
*
*      Too many iterations
*
*      or
*
* 1)   a la Baker
*      Abs(GrdMax).lt.ThrGrd
*      and
*      Abs(eChng).lt.ThrEne or RMSMax.lt.ThrGrd
*
* 2)   a la Gaussian
*      Abs(Fabs/Sqrt(mIntEff)).lt.ThrGrd
*      and
*      Abs(GrdMax).lt.ThrGrd*1.5
*      and
*      ((RMS.lt.ThrGrd*4
*        and
*        RMSMax.lt.ThrGrd*6)
*       or
*       Abs(eChng).lt.ThrEne)
*
      If (Baker) Then
         Val1= Abs(eChng)
         Thr1= ThrEne
         If (kIter.le.1) Then
            ConLbl(1)=' --- '
         Else If (Val1.lt.Thr1) Then
            ConLbl(1)=' Yes '
         Else
            ConLbl(1)=' No  '
         End If
         Val2= RMSMax
         Thr2= ThrGrd
         If (Val2.lt.Thr2) Then
            If (Step_Trunc.ne.' ') Then
               ConLbl(2)=' No *'
            Else
               ConLbl(2)=' Yes '
            End If
         Else
            ConLbl(2)=' No  '
         End If
         Val3= Abs(GrdMax)
         Thr3= ThrGrd
         If (Val3.lt.Thr3) Then
            ConLbl(3)=' Yes '
         Else
            ConLbl(3)=' No  '
         End If
         Conv1= Val1.lt.Thr1.and.kIter.gt.1
         Conv1= Conv1.or. (Val2.lt.Thr2 .and. Step_Trunc.eq.' ')
         Conv1= Conv1.and. Val3.lt.Thr3
      Else
         Val2=Abs(Fabs/Sqrt(DBLE(mIntEff)))
         Thr2=ThrGrd
         Conv1=Val2.lt.Thr2
         If (Conv1) Then
            ConLbl(2)=' Yes '
         Else
            ConLbl(2)=' No  '
         End If
         Conv1= Conv1.and.Abs(GrdMax).lt.ThrGrd*1.5D0
         Val4=Abs(GrdMax)
         Thr4=ThrGrd*1.5D0
         ConvTmp=Val4.lt.Thr4
         Conv1=Conv1.and.ConvTmp
         If (ConvTmp) Then
            ConLbl(4)=' Yes '
         Else
            ConLbl(4)=' No  '
         End If
         Conv2= RMS.lt.ThrGrd*4.D0 .and. Step_Trunc.eq.' '
         Val1=RMS
         Thr1=ThrGrd*4.0D0
         ConvTmp=Val1.lt.Thr1
         Conv2=ConvTmp .and. Step_Trunc.eq.' '
         If (ConvTmp) Then
            If (Step_Trunc.ne.' ') Then
               ConLbl(1)=' No *'
            Else
               ConLbl(1)=' Yes '
            End If
         Else
            ConLbl(1)=' No  '
         End If
         Val3=RMSMax
         Thr3=ThrGrd*6.0D0
         ConvTmp=Val3.lt.Thr3
         Conv2=Conv2.and.ConvTmp
         If (ConvTmp) Then
            If (Step_Trunc.ne.' ') Then
               ConLbl(3)=' No *'
            Else
               ConLbl(3)=' Yes '
            End If
         Else
            ConLbl(3)=' No  '
         End If
         Val5=Abs(eChng)
         Thr5=ThrEne
         ConvTmp=Val5.lt.Thr5 .and. kIter.gt.1
         If (ConvTmp) Then
            ConLbl(5)=' Yes '
         Else
            If (kIter.gt.1) Then
               ConLbl(5)=' No  '
            Else
               ConLbl(5)=' --- '
            End If
         End If
         Conv2=Conv2.or.ConvTmp
         Conv1=Conv1.and.Conv2
      End If
*
      Stop = Conv1 .or. (kIter-iOff_Iter).ge.MxItr ! CGG
      iStop=1
      If (kIter-iOff_Iter.ge.MxItr) iStop=16       ! CGG
      If (Conv1.or.Just_Frequencies)  iStop= 0
*
      If (GoOn) Then
         Stop=.False.
         iStop=1
      Else
         If (Just_Frequencies) Stop=.True.
         nPrint(52)=nPrint(52)+1
         nPrint(54)=nPrint(54)+1
         iPrint    =iPrint+1
         nPrint(53)=nPrint(53)+1
      End If
      If (.Not.Just_Frequencies)
     &   Call Status(kIter-iOff_Iter,E,Fabs,E0,MaxItr-1,eChng,Temp,
     &               Step_Trunc,.NOT.Numerical)
*
      If (Baker) Then
         If (iPrint.ge.5) Then
            Write (Lu,'(A)')
     &        '                +----------------------------------+'
            Write (Lu,'(A)')
     &        '                +  Value      Threshold Converged? +'
            Write (Lu,'(A)')
     &        '+---------------+----------------------------------+'
            Write (Lu,4)
     &        '+ Max. gradient +',Val3,' ',Thr3,'    ',ConLbl(3),'  +'
            Write (Lu,'(A)')
     &        '+---------------+----------------------------------+'
            Write (Lu,4)
     &        '+ Max. disp.    +',Val2,' ',Thr2,'    ',ConLbl(2),'  +'
            Write (Lu,'(A)')
     &        '+---------------+----------------------------------+'
            Write (Lu,4)
     &        '+ Energy diff.  +',Val1,' ',Thr1,'    ',ConLbl(1),'  +'
            Write (Lu,'(A)')
     &        '+---------------+----------------------------------+'
 4          Format(A,2(ES11.4,A),A,A)
         End If
      Else
         If (iPrint.ge.5) Then
            Write (Lu,'(A)')
     &        '       +----------------------------------+'
     &      //'----------------------------------+'
            Write (Lu,'(A)')
     &        '       +    Cartesian Displacements       +'
     &      //'    Gradient in internals         +'
            Write (Lu,'(A)')
     &        '       +  Value      Threshold Converged? +'
     &      //'  Value      Threshold Converged? +'
            Write (Lu,'(A)')
     &        ' +-----+----------------------------------+'
     &      //'----------------------------------+'
            Write (Lu,5)
     &        ' + RMS +',Val1,   ' ',Thr1,'    ',ConLbl(1),  '  +',
     &                Val2,   ' ',Thr2,'    ',ConLbl(2),  '  +'
            Write (Lu,'(A)')
     &       ' +-----+----------------------------------+'
     &          //'----------------------------------+'
            Write (Lu,5)
     &        ' + Max +',Val3,   ' ',Thr3,'    ',ConLbl(3),  '  +',
     &                Val4,   ' ',Thr4,'    ',ConLbl(4),  '  +'
            Write (Lu,'(A)')
     &       ' +-----+----------------------------------+'
     &      //'----------------------------------+'
            If (ThrEne.gt.Zero) Then
               Write (Lu,5)
     &           ' + dE  +',Val5,   ' ',Thr5,'    ',ConLbl(5),  '  +'
               Write (Lu,'(A)')
     &          ' +-----+----------------------------------+'
            End If
            Write (Lu,*)
 5          Format(A,2(2(ES11.4,A),A,A))
         End If
      End If
*
      If (Stop.and.Conv1) Then
         Call Qpg_dScalar('Max error',Found)
         If (Found) Call Get_dScalar('Max error',MaxErr)
         If (MaxErr.gt.ThrCons) Then
            iStop=1
            Conv1=.False.
            Stop=.False.
            Write(Lu,'(A,ES11.4)') 'Maximum constraint error: ',MaxErr
            Write(Lu,*)
         End If
      End If
*
      nConst=0
      If (iNeg(1).eq.0) Then
         If (EDiffZero) Then
            If (NADC) Then
               nConst=2
            Else
               nConst=1
            End If
            Point_Desc='Minimum Energy Crossing Point Structure'
         Else
            Point_Desc='Minimum Structure'
         End If
      Else If (iNeg(1).eq.1) Then
         Point_Desc='Transition State Structure'
      Else
         Point_Desc='Higher Order Saddle Point Structure'
      End If
      If (nLambda.gt.nConst) Point_Desc='Constrained '//Trim(Point_Desc)
      If (iPrint.ge.5) Then
         If (Stop) Then
            If (Conv1) Then
               Write (Lu,'(A,I3,A)') ' Geometry is converged in ',
     &            kIter-iOff_iter,' iterations to a '//Trim(Point_Desc)
            Else
               Write (Lu,'(A)') ' No convergence after max iterations'
               If (Lu.ne.6) Write (6,'(/A)')
     &                          ' No convergence after max iterations'
            End If
         Else
            Write (Lu,'(A)') ' Convergence not reached yet!'
         End If
      End If
      If (FindTS.and.Stop.and.Conv1) Then
         If (.Not.TSReg) Then
            If (iPrint.ge.5) Then
               Write (Lu,*)
               Write (Lu,'(A)')
     &' FindTS was requested, but the TS regime was not reached.'
               Write (Lu,'(A)')
     &' The converged structure is probably not the desired TS.'
            End If
            iStop=16
         End If
      End If
c      If (iPrint.eq.7) Then
c         Write (Lu,*)
c         Write (Lu,'(A)') '*********************************'//
c     &      ' Geometry Statistics for Geometry Optimization '//
c     &                    '*********************************'
c         nPrint(118) = 7
c         Call List(' Internal coordinates ',Lbl,qInt,nInter,iter+1)
c         Call List(' Internal forces    ',Lbl,dqInt,nInter,iter)
c      End If
*
*     The energy change should not be too large
      Maxed=1.0d2
      If (Abs(E_Delta).gt.Maxed) Then
         Write (6,*) 'The predicted energy change is too large: ',
     &                E_Delta
         Write (6,'(A)') ' This can''t be right!'
         Write (6,'(A)') ' This job will be terminated.'
         iStop=8
         Stop=.True.
      End If
      If (iPrint.ge.5) Then
         Write (Lu,*)
         Write (Lu,'(A)') '*********************'//
     &      '*******************************************************'
     &      //'*************************************'
         Write (Lu,'(A)') '*********************'//
     &      '*******************************************************'
     &      //'*************************************'
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Terminate=.False.
      IRCRestart=.False.
*                                                                      *
************************************************************************
*                                                                      *
*-----Write summary of conical intersection characterization data
*
      If (Conv1.and.NADC.and.EDiffZero) Then
         If (iPrint.ge.5) Then
            If (.Not.ApproxNADC) Call CI_Summary(Lu)
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Book keeping for Saddle optimization for a TS. Note that this will
*     have to be done on both of the runfiles!
*
      If (Conv1.and.Saddle) Then
*
*        Here if a macro iteration in the Saddle TS optimization is
*        completed.
*
C        ENew=Energy(iter)+E_Delta
         Call mma_allocate(Tmp,nSaddle,Label='Tmp')
*
*        Store the info for later generation of MOLDEN formated files
*
         Call Get_dArray('Saddle',Tmp,nSaddle)
         E_Reac=Tmp(6*nAtom+1)
         E_Prod=Tmp(6*nAtom+2)
*
         Call mma_allocate(E_S,nSaddle_Max,Label='E_S')
         Call mma_allocate(C_S,3,nAtom,nSaddle_Max,Label='C_S')
         Call mma_allocate(G_S,3,nAtom,nSaddle_Max,Label='G_S')
         If (iSaddle.eq.0) Then
*
*           Initiate with data from the starting points
*
            E_S(:)=Zero
            C_S(:,:,:)=Zero
            G_S(:,:,:)=Zero
            iSaddle=1
            If (E_Reac.le.E_Prod) Then
               E_S(iSaddle)=E_Reac
               Call DCopy_(3*nAtom,Tmp(1:3*nAtom),1,C_S(:,:,iSaddle),1)
            Else
               E_S(iSaddle)=E_Prod
               Call DCopy_(3*nAtom,Tmp(3*nAtom+1:6*nAtom),1,
     &                     C_S(:,:,iSaddle),1)
            End If
*
         Else
*
            Call Get_dArray('MEP-Energies',E_S,nSaddle_Max)
            Call Get_dArray('MEP-Coor',C_S,3*nAtom*nSaddle_Max)
            Call Get_dArray('MEP-Grad',G_S,3*nAtom*nSaddle_Max)
*
         End If
*
*        Add the new data
*
         iSaddle=iSaddle+1
         E_S(iSaddle)=Energy(iter)
         C_S(:,:,iSaddle) = Cx(:,:,iter)
         G_S(:,:,iSaddle) = Gx(:,:,iter)
*
*        Put data on RUNFILE
*
         Call Put_dArray('MEP-Energies',E_S,nSaddle_Max)
         Call Put_dArray('MEP-Coor',C_S,3*nAtom*nSaddle_Max)
         Call Put_dArray('MEP-Grad',G_S,3*nAtom*nSaddle_Max)
         Call Put_iScalar('nMEP',iSaddle)
*
         Call mma_deallocate(G_S)
         Call mma_deallocate(C_S)
         Call mma_deallocate(E_S)
*                                                                      *
************************************************************************
*                                                                      *
*        Now update the "Saddle" field on both runfiles.
*
         Do iFile = 1, 2
*
         If (iFile.eq.1) Then
            Call NameRun('RUNREAC')
         Else
            Call NameRun('RUNPROD')
         End If
*
*        Update info on the runfile.
*
         Call Get_dArray('Saddle',Tmp,nSaddle)
         E1=Tmp(6*nAtom+1)
         E2=Tmp(6*nAtom+2)
C        Write (6,*) 'ENew=',ENew
C        Write (6,*) 'E1,E2=',E1,E2
         If (E1.le.E2) Then
C           Write (6,*) 'Update reactant'
            Tmp(6*nAtom+1)=Energy(iter)
            E1=Energy(iter)
            Call DCopy_(3*nAtom,Cx(:,:,iter),1,Tmp(1:3*nAtom),1)
         Else
C           Write (6,*) 'Update product'
            Tmp(6*nAtom+2)=Energy(iter)
            E2=Energy(iter)
            Call DCopy_(3*nAtom,Cx(:,:,iter),1,Tmp(3*nAtom+1:6*nAtom),1)
         End If
*        Set flag that seward should process the info! This should not
*        be done for the final macro iteration.
         If (.Not.FindTS) Tmp(6*nAtom+5)=One
         Call Put_dArray('Saddle',Tmp,nSaddle)
*
         End Do
*
*                                                                      *
************************************************************************
*                                                                      *
*        Converged or not, create the saddle.molden file
*        after each macro iteration
*
         Call NameRun('RUNREAC')
         Call mma_allocate(E_r,nSaddle_Max,Label='E_r')
         Call mma_allocate(C_r,3*nAtom,nSaddle_Max,Label='C_r')
         Call mma_allocate(G_r,3*nAtom,nSaddle_Max,Label='G_r')
         Call Qpg_iScalar('nMEP',Found)
         if(Found) Then
            Call Get_dArray('MEP-Energies',E_r,nSaddle_Max)
            Call Get_dArray('MEP-Coor',C_r,3*nAtom*nSaddle_Max)
            Call Get_dArray('MEP-Grad',G_r,3*nAtom*nSaddle_Max)
            Call Get_iScalar('nMEP',iSaddle_r)
         Else
            E_r(1)=E_Reac
            C_r(:,1) = Tmp(1:3*nAtom)
            G_r(:,:) = Zero
            iSaddle_r=1
         End If
*
         Call NameRun('RUNPROD')
         Call mma_allocate(E_p,nSaddle_Max,Label='E_p')
         Call mma_allocate(C_p,3*nAtom,nSaddle_Max,Label='C_p')
         Call mma_allocate(G_p,3*nAtom,nSaddle_Max,Label='G_p')
         Call Qpg_iScalar('nMEP',Found)
         if(Found) Then
            Call Get_dArray('MEP-Energies',E_p,nSaddle_Max)
            Call Get_dArray('MEP-Coor',C_p,3*nAtom*nSaddle_Max)
            Call Get_dArray('MEP-Grad',G_p,3*nAtom*nSaddle_Max)
            Call Get_iScalar('nMEP',iSaddle_p)
         Else
            E_p(1)=E_Prod
            C_p(:,1) = Tmp(3*nAtom+1:6*nAtom)
            G_p(:,:) = Zero
            iSaddle_p=1
         End If
*
*        Merge the two lists
*
         jSaddle=iSaddle_r
         Do iSaddle=iSaddle_p, 1, -1
            jSaddle=jSaddle+1
            E_r(jSaddle) = E_p(iSaddle)
            C_r(:,jSaddle) = C_p(:,iSaddle)
            G_r(:,jSaddle) = G_p(:,iSaddle)
         End Do
         Call mma_deallocate(G_p)
         Call mma_deallocate(C_p)
         Call mma_deallocate(E_p)
*
*        Align the structures sequentially, only for visualization
*        (gradients are not changed, though)
* TODO   Rotate the gradients too
*
         Do iSaddle=1,iSaddle_r+iSaddle_p-1
            Call Align(C_r(:,iSaddle+1),C_r(:,iSaddle),nAtom)
         End Do
*
         Call Intergeo('MD_SADDLE',E_r,C_r,
     &                 G_r,nAtom,iSaddle_r+iSaddle_p)
*
         Call mma_deallocate(G_r)
         Call mma_deallocate(C_r)
         Call mma_deallocate(E_r)
*
*                                                                      *
************************************************************************
*                                                                      *
*        If the Saddle TS optimization is not yet completed set up
*        data for the next macro iteration.
*
         If (.Not.FindTS) Then
            Call mma_deallocate(Tmp)
C           Write (*,*) 'Reset $SubProject'
*
*           Reset $SubProject for the next macro iteration.
*
            LuInput=11
            LuInput=IsFreeUnit(LuInput)
            Call StdIn_Name(StdIn)
            Call Molcas_Open(LuInput,StdIn)
            If (E1.le.E2) Then
               Write (LuInput,'(A)') '> EXPORT SubProject=.Reac'
C              Write (6,*) 'SubProject=.Reac'
               Call NameRun('RUNREAC')
            Else
               Write (LuInput,'(A)') '> EXPORT SubProject=.Prod'
C              Write (6,*) 'SubProject=.Prod'
               Call NameRun('RUNPROD')
            End If
*
*           Signal whether next iteration will be the first in the branch
*
            Call Qpg_iScalar('nMEP',Found)
            If (.Not.Found) Then
               Write (LuInput,'(A)') '> EXPORT SADDLE_FIRST=1'
            End If
            Write (LuInput,'(A,I3)') '> EXIT ',_RC_CONTINUE_LOOP_
            Close(LuInput)
*
*           Set flags to request yet another macro iteration.
*
            Terminate=.False.
            iStop=6
            Stop=.False.
         Else
            Call NameRun('RUNFILE')
            Call mma_deallocate(Tmp)
            nSaddle=0
            Call Put_dArray('Saddle',[Zero],nSaddle)
            Call Put_iScalar('nMEP',nSaddle)
         End If
*
*        Update the active runfile wrt the total number of micro
*        iterations done in all macro iterations of this branch.
*
         Call NameRun('RUNFILE')
         Call Put_iScalar('iOff_Iter',iter)
      End If
*
*     Disable first iteration signal right after the first iteration
*     (in each branch)
*
      If ((.Not.Conv1).and.Saddle) Then
         If ((iter.Eq.1).and.(iStop.eq.1)) Then
            LuInput=11
            LuInput=IsFreeUnit(LuInput)
            Call StdIn_Name(StdIn)
            Call Molcas_Open(LuInput,StdIn)
            Write (LuInput,'(A)') '> EXPORT SADDLE_FIRST=0'
            Write (LuInput,'(A,I3)') '> EXIT ',_RC_CONTINUE_LOOP_
            Close(LuInput)
            iStop=6
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Book keeping for minimum energy path search
*
      Call Qpg_iScalar('IRC',Found)
      If (Found) Call Get_iScalar('IRC',IRC)
*
      TurnBack=.False.
      If (MEP.or.rMEP) Then
       If (Conv1) Then
*
*        Is this the first iteration or not?
*
         iMEP=iMEP+1
*
*        Save information for the current step
*
         Call mma_allocate(E_MEP,nMEP+1,Label='E_MEP')
         Call mma_allocate(C_MEP,3,nAtom,nMEP+1,Label='C_MEP')
         Call mma_allocate(G_MEP,3,nAtom,nMEP+1,Label='G_MEP')
         If (iMEP.gt.1) Then
            Call Get_dArray('MEP-Energies',E_MEP,nMEP+1)
            Call Get_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
            Call Get_dArray('MEP-Grad',G_MEP,3*nAtom*(nMEP+1))
         Else
            E_MEP(:)=Zero
            C_MEP(:,:,:)=Zero
            G_MEP(:,:,:)=Zero
            E_MEP(iMEP)=Energy(iOff_iter+1)
            C_MEP(:,:,iMEP)= Cx(:,:,iOff_iter+1)
            G_MEP(:,:,iMEP)= Gx(:,:,iOff_iter+1)
         End If
*
         E_MEP(iMEP+1)=Energy(iter)
         C_MEP(:,:,iMEP+1)= Cx(:,:,iter)
         G_MEP(:,:,iMEP+1)= Gx(:,:,iter)
         Call Put_dArray('MEP-Energies',E_MEP,nMEP+1)
         Call Put_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
         Call Put_dArray('MEP-Grad',G_MEP,3*nAtom*(nMEP+1))
         Call Put_iScalar('nMEP',iMEP)
*
*        Save the path so far (energies, coordinates and forces)
*
         Call Intergeo('MD_MEP',E_MEP,C_MEP,G_MEP,nAtom,iMEP+1)
*
*        Compute energy difference and RMS between last two structures
*
         eDiffMEP=E_MEP(iMEP+1)-E_MEP(iMEP)
         Call mma_allocate(Coor1,3,mTtAtm,Label='Coor1')
         Call mma_allocate(Coor2,3,mTtAtm,Label='Coor2')
         Call AtmLst(C_MEP(:,:,iMEP  ),nAtom,Coor1,mTtAtm)
         Call AtmLst(C_MEP(:,:,iMEP+1),nAtom,Coor2,mTtAtm)
         Call OptRMS_Slapaf(Coor1,Coor2,mTtAtm,RMS,RMSMax)
         Call mma_deallocate(Coor1)
         Call mma_deallocate(Coor2)
*
         Call mma_deallocate(G_MEP)
         Call mma_deallocate(C_MEP)
         Call mma_deallocate(E_MEP)
*
       Else
*
*        Test for "turn back", i.e. when the trial structure
*        is getting too close to the previous converged structure,
*        this may be an indication of an ill-behaved constraint
         If (iMEP.ge.1) Then
            Call mma_allocate(C_MEP,3,nAtom,nMEP+1,Label='C_MEP')
            Call mma_allocate(OfRef,3,nAtom,Label='OfRef')
            Call mma_Allocate(Tmp,3*nAtom,Label='Tmp')
            Call Get_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
            OfRef(:,:)=C_MEP(:,:,iMEP+1)

*           Using hypersphere measure, even with "transverse" MEPs,
*           this should not be a problem
            Call SphInt(Cx(:,:,iter),nAtom,Not_Allocated,refDist,Tmp,
     &         .False.,'dummy   ',rDum,.False.)
            Call SphInt(Cx(:,:,iter),nAtom,OfRef,prevDist,
     &                  Tmp,.False.,'dummy   ',rDUm,.False.)
            If (prevDist.lt.Half*refDist) Then
               TurnBack=.True.
               Conv1=.True.
               Stop=.True.
               iStop=0
               Terminate=.True.
            End If
            Call mma_deallocate(Tmp)
            Call mma_deallocate(OfRef)
            Call mma_deallocate(C_MEP)
         End If
*
       End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----List internal coordinates and gradients
*
      kkIter=iter+1
      If (iPrint.ge.8) Then
         Call List(' Internal coordinates ',Lbl,qInt,nInter,kkIter)
         Call List(' Internal forces    ',Lbl,dqInt,nInter,iter)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Put out the new reference structure and the new starting
*     structure to be used for the next MEP point.
*     For rMEP keep the reference structure!
*     Note that this is done in weighted Cartesian coordinates!
*
      If ((Conv1.or.(iter.eq.1)).and.(MEP.or.rMEP)) Then
         If ((iMEP.ge.1).and.(iPrint.ge.5)) Then
            Write (6,*)
            Call CollapseOutput(1,'IRC/Minimum Energy Path Information')
         End If
*
         ResGrad=Huge(ResGrad)
         If (.Not.Terminate) Then
            BadConstraint=.False.
            Call MEP_Dir(Cx,Gx,nAtom,iMEP,iOff_iter,iPrint,IRCRestart,
     &                   ResGrad,BadConstraint)
            Call dCopy_(3*nAtom,Cx(:,:,iter+1),1,Coor,1)
            Call Put_iScalar('iOff_Iter',iter)
         End If
*
         If (MEP) Then
            If (IRC.eq.0) Then
               MEP_Text='MEP'
            Else If (IRC.eq.1) Then
               MEP_Text='IRC(forward)'
            Else
               MEP_Text='IRC(backward)'
            End If
         Else If (rMEP) Then
            MEP_Text='rMEP'
         Else
            MEP_Text=''
         End If
*
*        Should we terminate or not? Not done on the first iteration.
*
         If (iMEP.gt.0) Then
*
*           Test for energy increase (optionally disabled).
            eTest=eMEPTest.and.(eDiffMEP.gt.Zero)
            If ((MEP.and.eTest).and.(.not.Terminate)) Then
               Terminate=.True.
               If (iPrint.ge.5) Then
                  Write (6,*)
                  Write (6,'(A)') ' '//Trim(MEP_Text)//'-search'//
     &               ' terminated due to energy increase!'
                  Write (6,*)
               End If
            End If
*
*           Test for energy decrease (optionally disabled).
            eTest=eMEPTest.and.(eDiffMEP.lt.Zero)
            If ((rMEP.and.eTest).and.(.not.Terminate)) Then
               Terminate=.True.
               If (iPrint.ge.5) Then
                  Write (6,*)
                  Write (6,'(A)') ' '//Trim(MEP_Text)//'-search'//
     &               ' terminated due to energy decrease!'
                  Write (6,*)
               End If
            End If
*
*           Test for small gradient.
            If ((iMEP.gt.1).or.(IRC.eq.0)) Then
              If ((ResGrad.lt.ThrMEP).and.(.not.Terminate)) Then
                 Terminate=.True.
                 If (iPrint.ge.5) Then
                    Write (6,*)
                    Write (6,'(A)') ' '//Trim(MEP_Text)//'-search'//
     &               ' terminated due to small gradient!'
                    Write (6,*)
                 End If
              End If
            End If
*
*           Test for small step.
            If ((RMS.lt.ThrGrd*4.D0).and.(.not.Terminate)) Then
               Terminate=.True.
               If (iPrint.ge.5) Then
                  Write (6,*)
                  Write (6,'(A)') ' '//Trim(MEP_Text)//'-search'//
     &               ' terminated due to small geometry change!'
                  Write (6,*)
               End If
            End If
*
*           Test for max number of points.
            If ((iMEP.ge.nMEP).and.(.not.Terminate)) Then
               Terminate=.True.
               If (iPrint.ge.5) Then
                  Write (6,*)
                  Write (6,'(A)') ' '//Trim(MEP_Text)//'-search'//
     &               ' terminated due to max number of path points!'
                  Write (6,*)
               End If
            End If
*
*           Test for constraint misbehavior.
            If ((BadConstraint.and.(.not.Terminate)).or.TurnBack) Then
               Terminate=.True.
               If (iPrint.ge.5) Then
                  Write (6,*)
                  Write (6,'(A)') ' '//Trim(MEP_Text)//'-search'//
     &               ' terminated due to problematic constraint!'
                  Write (6,*)
               End If
            End If
*
*           If IRC reset for backward IRC search.
*
            If (Terminate) Then
               If (IRC.eq.1) Then
                  IRCRestart=.True.
               End If
            End If
*
         End If
*
         If (Conv1) Then
            Call Chkpnt_update_MEP(.Not.TurnBack,IRCRestart)
         End If
*
         If (Conv1.and.Terminate) Then
            If (IRC.ne.0) Then
               Call mma_allocate(E_MEP,nMEP+1,Label='E_MEP')
               Call mma_allocate(C_MEP,3,nAtom,nMEP+1,Label='C_MEP')
               Call mma_allocate(G_MEP,3,nAtom,nMEP+1,Label='G_MEP')
               Call Get_dArray('MEP-Energies',E_MEP,nMEP+1)
               Call Get_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
               Call Get_dArray('MEP-Grad',G_MEP,3*nAtom*(nMEP+1))
               If (IRC.eq.1) Then
                  IRCRestart=.True.
                  IRC=-1
                  Call Put_iScalar('IRC',IRC)
*
*                 Store away data for IRC molden file. Forward part.
*
                  Call Put_dArray('IRC-Energies',E_MEP,iMEP+1)
                  Call Put_dArray('IRC-Coor',C_MEP,3*nAtom*(iMEP+1))
                  Call Put_dArray('IRC-Grad',G_MEP,3*nAtom*(iMEP+1))
                  Call Put_dArray('Ref_Geom',Cx,3*nAtom)
*
*                 Write a temporary file
*                 (will be overwritten when the backward part is done)
*
                  Call Intergeo('MD_IRC',E_MEP,C_MEP,G_MEP,nAtom,iMEP+1)
*
                  Terminate=.False.
*
               Else If (IRC.eq.-1) Then
*
*                 Assemble molden file for IRC
*
                  nBackward=iMEP+1
                  Call qpg_dArray('IRC-Energies',Found,nForward)
                  nIRC=nForward+nBackward-1
                  Call mma_allocate(E_IRC,nIRC,Label='E_IRC')
                  Call mma_allocate(C_IRC,3,nAtom,nIRC,Label='C_IRC')
                  Call mma_allocate(G_IRC,3,nAtom,nIRC,Label='G_IRC')
*
                  j=0
                  Do i = nBackward, 1, -1
                     j = j+1
                     E_IRC(j)=E_MEP(i)
                     C_IRC(:,:,j) = C_MEP(:,:,i)
                     G_IRC(:,:,j) = G_MEP(:,:,i)
                  End Do
*
                  Call Get_dArray('IRC-Energies',E_IRC(nBackward),
     &                            nForward)
                  Call Get_dArray('IRC-Coor',C_IRC(:,:,nBackward:nIRC),
     &                            nForward*3*nAtom)
                  Call Get_dArray('IRC-Grad',G_IRC(:,:,nBackward:nIRC),
     &                            nForward*3*nAtom)
*
                  Call Intergeo('MD_IRC',E_IRC,C_IRC,G_IRC,nAtom,nIRC)
*
                  Call mma_deallocate(G_IRC)
                  Call mma_deallocate(C_IRC)
                  Call mma_deallocate(E_IRC)
               End If

               Call mma_deallocate(G_MEP)
               Call mma_deallocate(C_MEP)
               Call mma_deallocate(E_MEP)
            End If
         End If
*
         If (.Not.Terminate) Then
           iStop=1
           Stop=.False.
         End If
*
*        Print out the path so far
*
         If ((iMEP.ge.1).and.(iPrint.ge.5)) Then
            Call mma_allocate(E_MEP,nMEP+1,Label='E_MEP')
            Call mma_allocate(C_MEP,3,nAtom,nMEP+1,Label='C_MEP')
            Call mma_allocate(L_MEP,nMEP+1,Label='L_MEP')
            Call mma_allocate(Cu_MEP,nMEP+1,Label='Cu_MEP')
            Call Get_dArray('MEP-Energies',E_MEP,nMEP+1)
            Call Get_dArray('MEP-Coor',C_MEP,3*nAtom*(nMEP+1))
            Call Get_dArray('MEP-Lengths',L_MEP,nMEP+1)
            Call Get_dArray('MEP-Curvatures',Cu_MEP,nMEP+1)
            Write (6,*)
            CumLen=Zero
            If (Cu_MEP(1+iMEP).ge.Zero) Then
               Write(6,*) '         Cumul.'
               Write(6,*) 'Point  Length (bohr)       Energy  Curvature'
               Write(6,*) '--------------------------------------------'
               Do i = 0, iMEP
                  CumLen=CumLen+L_MEP(1+i)
                  Write (6,200) i,CumLen,E_MEP(1+i),Cu_MEP(1+i)
               End Do
            Else
               Write(6,*) '         Cumul.'
               Write(6,*) 'Point  Length (bohr)       Energy'
               Write(6,*) '---------------------------------'
               Do i = 0, iMEP
                  CumLen=CumLen+L_MEP(1+i)
                  Write (6,200) i,CumLen,E_MEP(1+i)
               End Do
            End If
200         Format (1X,I5,1X,F10.6,1X,F16.8,1X,F10.6)
            If (iPrint.gt.6) Then
               Write (6,*)
               Do i = 0, iMEP
                  Call RecPrt(' Coordinates',' ',C_MEP(:,:,i+1),3,nAtom)
               End Do
            End If
            Call CollapseOutput(0,'IRC/Minimum Energy Path Information')
            Write(6,*)
            Call mma_deallocate(E_MEP)
            Call mma_deallocate(C_MEP)
            Call mma_deallocate(L_MEP)
            Call mma_deallocate(Cu_MEP)
         End If
*
      End If
*
      If (IRCRestart) Then
*
*         Prepare the runfile to start from Scratch
*
          iMEP=0
          Call Put_iScalar('nMEP',iMEP)
          Call mma_allocate(Information,7,Label='Information')
          Information(:)=0
          Information(1)=-99     ! Deactivate the record
          Call Put_iArray('Slapaf Info 1',Information,7)
          Call mma_deallocate(Information)
          iOff_Iter=0
          Call Put_iScalar('iOff_Iter',iOff_Iter)
*
*         Restore data
*
          Call Put_dScalar('Last Energy',Energy(1))
          Call Put_Grad(Gx,3*nAtom)
          Call Put_dArray('Unique Coordinates',Cx,3*nAtom)
          Call Put_Coord_New(Cx,nAtom)
          call dcopy_(3*nAtom,Cx,1,Coor,1)
          call dcopy_(3*nAtom,Cx,1,Cx(:,:,iter+1),1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Figure out if the last energy should be computed!
*
      Last_Energy = Stop .and. iStop.ne.16 .and. iStop.ne.8
      Last_Energy = Last_Energy .and. .Not.MEP .and. .Not.rMEP
      Last_Energy = Last_Energy .and.
     &             .Not. (Numerical .and. kIter.eq.1)
      If (Last_Energy) iStop = 2
*                                                                      *
************************************************************************
*                                                                      *
*     Write geometry file for MOLDEN. Note that this file should not be
*     generated if Slapaf is running new geometries for any numerical
*     procedure!
*
      If (
     &     .NOT. Just_Frequencies  .AND.
     &     .NOT. Numerical
     &   ) Then
         Call Write_QMMM(Cx,nAtom,iter)
         Call Intergeo('MD_GEO',Energy,Cx,Gx,nAtom,iter+1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
      Subroutine Averd(ireturn)
      Implicit Real*8 (a-h,o-z)
*
*
*-- Compute average density and corresponding natural orbitals. Two
*   possibilities exists, either construct average from input orbitals,
*   or from density matrices.
*
*   Author: Anders Ohrn.
*
*

*
*-- Include.
*
#include "mxdm.fh"
#include "real.fh"
#include "mxave.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"

*
*-- Allocate.
*
      Dimension Wset(MxSets),nBas(MxSym)
      Logical PrOcc,PrEne,DensityBased
      Character Title*72, Fname*7,OLabel*10,Titorb*40,OrbFile*128
      Character BsLbl*4000,PLab*3
      Dimension Dummy(1),iDummy(7,8)
      Real*8, Allocatable:: DTmp(:)


*
*-- Banner.
*
      ireturn=99

*
*-- Define defaults and initialize.
*
      Call Init_ave(Title,iPrint,Wset,Wsum,PrOcc,PrEne,DensityBased
     &         ,ThrOcc,Dummy(1),iDummy(1,1))

*
*-- Read input.
*
      Call Get_Averd_input(Title,Wset,iPrint,Nset,DensityBased,ThrOcc)

*
*-- Read some information from RUNFILE.
*
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      itBas=0
      Do 31, iSym=1,nSym
        itBas=itBas+nBas(isym)
31    Continue
      Call Get_cArray('Unique Basis Names',BsLbl,(LENIN8)*itBas)

*
*-- Some dimensions.
*
      lsmat=0
      ntot=0
      ntot2=0
      Do 70 i=1,nSym
        lsmat=lsmat+(nBas(i)*(nBas(i)+1))/2
        ntot=ntot+nBas(i)
        ntot2=ntot2+nBas(i)**2
70    Continue

*
*-- Read AO-basis overlap matrix.
*
      Call GetMem('Overlap','Allo','Real',iS,lsmat+4)
      OLabel='Mltpl  0'
      irc=0
      iopt=6
      icomp=1
      isyml=1
      Call RdOne(irc,iopt,OLabel,icomp,Work(iS),isyml)
      If(iprint.ge.99) then
        ind=0
        Do 72, iSym=1,nSym
          Call TriPrt('Overlap Matrix',' ',Work(iS+ind),nBas(iSym))
          ind=ind+nBas(iSym)*(nBas(iSym)+1)/2
72      Continue
      Endif

*
*-- Normalize weights.
*
      Do 80, iset=1,mxsets
        Wsum=Wsum+wset(iset)
80    Continue
      Do 81, iset=1,Nset
        Wset(iset)=Wset(iset)/Wsum
81    Continue

*
*-- Print some Bla Bla...
*
      If(iprint.ge.2) then
        Call Print_Input(Title,nSym,nBas,wSet,nSet)
      Endif

*
*-- Do the dirty work. Different paths for orbital- and density-based
*   averageing.
*

      Call GetMem('Density','Allo','Real',iDao,ntot2)
      call dcopy_(ntot2,[Zero],0,Work(iDao),1)
      If(.not.DensityBased) then
        Luinp=10
        Call GetMem('Orbitals','Allo','Real',iCMO,ntot2)
        Call GetMem('Occ','Allo','Real',iOcc,ntot)
        Do 90, iset=1,Nset
          Fname='NAT001'
          Write(Fname(4:6),'(I3.3)') iset
*------- Read orbital coefficients and occupation numbers.
          Call RdVec(Fname,Luinp,'CO',Nsym,nBas,nBas,Work(iCMO)
     &           ,Work(iOcc),Dummy,iDummy,Titorb,0,iErr)
          iC=0
          iO=0
          iD=0
*------- Up-date average density matrix.
          Do 93, isym=1,nSym
            kaunter=0
            Do 931, i=1,nBas(iSym)
              Do 932, j=1,nBas(iSym)
                Do 933, k=1,nBas(iSym)
                  Work(iDao+iD+kaunter)=Work(iDao+iD+kaunter)
     &  +Wset(iSet)*Work(iOcc+iO+k-1)*Work(iCMO+iC+i+(k-1)*nBas(iSym)-1)
     &                               *Work(iCMO+iC+j+(k-1)*nBas(iSym)-1)
933             Continue
                kaunter=kaunter+1
932           Continue
931         Continue
            iC=iC+nBas(isym)**2
            iD=iD+nBas(isym)**2
            iO=iO+nBas(isym)
93        Continue
*------- Print print print.
          If(iPrint.ge.5) then
            ThrO=1d-5
            Call Primo(Titorb,PrOcc,PrEne,ThrO,Dummy(1),nSym,nBas,nBas
     &                ,BsLbl,Dummy,Work(iOcc),Work(iCMO),-1)
          Endif
90      Continue
        Call GetMem('Orbitals','Free','Real',iCMO,ntot2)
        Call GetMem('Occ','Free','Real',iOcc,ntot)
      Else
        Call GetMem('DensityT','Allo','Real',iDtemp,lsmat)
        call dcopy_(lsmat,[Zero],0,Work(iDtemp),1)
        Do 95, iset=1,Nset
          Fname='RUN001'
          Write(Fname(4:6),'(I3.3)') iset
          Call NameRun(Fname)
*------- Collect density from runfile.
          Call mma_allocate(DTmp,lsmat,Label='DTmp')
          Call Get_D1ao(Dtmp,lsmat)
          Call DaxPy_(lsmat,Wset(iset),Dtmp,1,Work(iDtemp),1)
          Call mma_deallocate(DTmp)
95      Continue
*----- Square the density matrix.
        iDt=0
        iDs=0
        Do 97, iSym=1,nSym
          nB=nBas(iSym)
          Call Dsq(Work(iDtemp+iDt),Work(iDao+iDs),1,nB,nB)
          iDt=iDt+nB*(nB+1)/2
          iDs=iDs+nB**2
97      Continue
        Call GetMem('DensityT','Free','Real',iDtemp,lsmat)
      Endif

*
*-- With the average density in store, lets orthogonalize (canonical),
*   then diagonalize to get natural orbitals.
*
      indT=0
      indS=0
      indB=0
      Call GetMem('NatOrbAcc','Allo','Real',iOrbs,ntot2)
      Call GetMem('NatOccAcc','Allo','Real',iOccs,ntot)
      Do 201, iSym=1,nSym
        nBT=nBas(iSym)*(nBas(iSym)+1)/2
        nBS=nBas(iSym)**2
        Call GetMem('EigV','Allo','Real',iVecs,nBS)
        Call GetMem('St','Allo','Real',iSt,nBT)
        Call GetMem('Si','Allo','Real',iSi,nBT)
        Call GetMem('Ss','Allo','Real',iSs,nBS)
        Call GetMem('Sp','Allo','Real',iSp,nBS)
        Call GetMem('AUX','Allo','Real',iAUX,nBS)
        Call GetMem('TransS','Allo','Real',iTrans,nBS)
        Call GetMem('TransSi','Allo','Real',iTrani,nBS)
        Call GetMem('OrthoDensS','Allo','Real',iOrtoD,nBS)
        Call GetMem('OrthoDensT','Allo','Real',iOrtoDt,nBT)
        Call GetMem('Occs','Allo','Real',iOccNat,nBas(iSym))
        call dcopy_(nBT,[Zero],0,Work(iSt),1)
        call dcopy_(nBT,[Zero],0,Work(iSi),1)
        kaunter=0
        Do 2011, iB1=1,nBas(iSym)
          Do 2012, iB2=1,nBas(iSym)
            Work(iVecs+kaunter)=Zero
            If(iB1.eq.iB2)Work(iVecs+kaunter)=One
            kaunter=kaunter+1
2012      Continue
2011    Continue
        Call Jacob(Work(iS+indT),Work(iVecs),nBas(iSym),nBas(iSym))
        Do 205, i=1,nBas(iSym)
          Sqroot=sqrt(Work(iS+indT+i*(i+1)/2-1))
          Work(iSt+i*(i+1)/2-1)=Sqroot
          Work(iSi+i*(i+1)/2-1)=One/Sqroot
205     Continue
        Call Square(Work(iSt),Work(iSs),1,nBas(iSym),nBas(iSym))
        Call Square(Work(iSi),Work(iSp),1,nBas(iSym),nBas(iSym))
        Call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One
     &            ,Work(iVecs),nBas(iSym),Work(iSs),nBas(iSym),Zero
     &            ,Work(iAUX),nBas(iSym))
        Call Dgemm_('N','T',nBas(iSym),nBas(iSym),nBas(iSym),One
     &            ,Work(iAUX),nBas(iSym),Work(iVecs),nBas(iSym),Zero
     &            ,Work(iTrans),nBas(iSym))
        Call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One
     &            ,Work(iVecs),nBas(iSym),Work(iSp),nBas(iSym),Zero
     &            ,Work(iAUX),nBas(iSym))
        Call Dgemm_('N','T',nBas(iSym),nBas(iSym),nBas(iSym),One
     &            ,Work(iAUX),nBas(iSym),Work(iVecs),nBas(iSym),Zero
     &            ,Work(iTrani),nBas(iSym))
        Call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One
     &            ,Work(iTrans),nBas(iSym),Work(iDao+indS),nBas(iSym)
     &            ,Zero,Work(iAUX),nBas(iSym))
        Call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One
     &            ,Work(iAUX),nBas(iSym),Work(iTrans),nBas(iSym),Zero
     &            ,Work(iOrtoD),nBas(iSym))
        kaunter=0
        Do 2051, iB1=1,nBas(iSym)
          Do 2052, iB2=1,nBas(iSym)
            Work(iVecs+kaunter)=Zero
            If(iB1.eq.iB2)Work(iVecs+kaunter)=One
            kaunter=kaunter+1
2052      Continue
2051    Continue
        kaunter=0
        Do 2053, i=1,nBas(iSym)
          Do 2054, j=1,i
            Work(iOrtoDt+kaunter)=Work(iOrtoD+i+(j-1)*nBas(iSym)-1)
            kaunter=kaunter+1
2054      Continue
2053    Continue
        Call Jacob(Work(iOrtoDt),Work(iVecs),nBas(iSym),nBas(iSym))
        Call Dgemm_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),One
     &            ,Work(iTrani),nBas(iSym),Work(iVecs),nBas(iSym),Zero
     &            ,Work(iAUX),nBas(iSym))
        kaunt=0
        kaunter=0
        Do 208, i=1,nBas(iSym)
          Do 209, j=1,i
            If(i.eq.j) then
              Work(iOccNat+kaunt)=Work(iOrtoDt+kaunter)
              kaunt=kaunt+1
            Endif
            kaunter=kaunter+1
209       Continue
208     Continue
        Call Jacord3(Work(iOccNat),Work(iAUX),nBas(iSym),nBas(iSym))
        Call Add_Info('AVERD_OCC',Work(iOccNat),5,5)
        If(iPrint.ge.5) then
          Write(Titorb,'(A)')'All average orbitals in this irrep.'
          Thr=-1D0
          Call Primo(Titorb,.true.,.false.,Thr,Dum,1,nBas(iSym)
     &              ,nBas(iSym),BsLbl,Dummy,Work(iOccNat),Work(iAUX),-1)
        Endif
        call dcopy_(nBS,Work(iAUX),1,Work(iOrbs+indS),1)
        call dcopy_(nBas(iSym),Work(iOccNat),1,Work(iOccs+indB),1)
        Call GetMem('EigV','Free','Real',iVecs,nBS)
        Call GetMem('St','Free','Real',iSt,nBT)
        Call GetMem('Si','Free','Real',iSi,nBT)
        Call GetMem('Ss','Free','Real',iSs,nBS)
        Call GetMem('Sp','Free','Real',iSp,nBS)
        Call GetMem('AUX','Free','Real',iAUX,nBS)
        Call GetMem('TransS','Free','Real',iTrans,nBS)
        Call GetMem('TransSi','Free','Real',iTrani,nBS)
        Call GetMem('OrthoDensS','Free','Real',iOrtoD,nBS)
        Call GetMem('OrthoDensT','Free','Real',iOrtoDt,nBT)
        Call GetMem('Occs','Free','Real',iOccNat,nBas(iSym))
        indT=indT+nBT
        indS=indS+nBS
        indB=indB+nBas(iSym)
201   Continue
      Write(6,*)
      Write(6,*)
      Write(6,*)
      Write(6,*)'---Average natural orbital generation completed!---'
      Write(6,*)


*
*-- Write average orbitals to a file with the same format as
*   SCF-orbitals. To the outfile are orbital energies added just
*   to make the NEMO happy, the numbers are just bosh!
*
      Write(6,*)
      Write(6,*)
      Write(6,*)'Average orbitals put on AVEORB'
      Write(6,*)
      Write(6,*)'NB: Dummy orbital energies added to AVEORB for '
     &//'compatability reasons.'
      Write(6,*)'    They have no physical meaning.'
      Call GetMem('Zeros','Allo','Real',iZero,ntot)
      call dcopy_(ntot,[Zero],0,Work(iZero),1)
      LuOut=65
      LuOut=IsFreeUnit(LuOut)
      Title='Average Orbitals'
      OrbFile='AVEORB'
      Plab='COE'
      Call WrVec(OrbFile,LuOut,Plab,nSym,nBas,nBas,Work(iOrbs)
     &           ,Work(iOccs),Work(iZero),iDummy,Title)

*
*-- Say something about orbital occupation.
*
      Write(6,*)
      Write(6,*)
      Write(6,'(A)')' |  Average orbital occupation.'
      Write(6,'(A)')' |-----------------------------'
      Write(6,'(A,E18.8)')' |    Threshold: ',ThrOcc
      Write(6,*)
      nOrb=0
      iO=0
      Do 9991, iSym=1,nSym
        Do 9992, iB=1,nBas(iSym)
          If(Work(iOccs+iO+iB-1).lt.ThrOcc) GoTo 9992
          nOrb=nOrb+1
9992    Continue
        Write(6,9999)'      Symmetry:',iSym,'   Number of orbitals '
     &//'below threshold:',nOrb
        iO=iO+nBas(iSym)
9991  Continue
      Write(6,*)
9999  Format(A,I2,A,I4)
      Call GetMem('Zeros','Free','Real',iZero,ntot)
      Call GetMem('NatOrbAcc','Free','Real',iOrbs,ntot2)
      Call GetMem('NatOccAcc','Free','Real',iOccs,ntot)
      Call GetMem('Density','Free','Real',iDao,ntot2)
      Call GetMem('Overlap','Free','Real',iS,lsmat+4)

*
*-- Good Bye.
*
      ireturn=0
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
*               2018, Ignacio Fdez. Galvan                             *
************************************************************************
*  Get_Mass_All
*
*> @brief
*>   Get atomic masses from RUNFILE
*> @author Ignacio Fdez. Galn&aacute;n
*>
*> @details
*> Place atomic masses (in a.u.) into array \p Mass_All(*).
*>
*> @param[out] Mass_All   Array of masses
*> @param[in]  nAtoms_All Number of atoms
************************************************************************
      Subroutine Get_Mass_All(Mass_All,nAtoms_All)
      use Symmetry_Info, only: nIrrep, iOper, Symmetry_Info_Get
      Implicit None
#include "stdalloc.fh"
      Integer nAtoms_All, nAtoms_Allx, nAtoms
      Real*8 Mass_All(nAtoms_All)
      Real*8, Dimension (:), Allocatable :: Mass
      Real*8, Dimension (:,:), Allocatable :: CU
      Integer i,j,nGen,MaxDCR,iChAtom,iCo,nCoSet,nStab
      Integer iGen(3),iCoSet(0:7,0:7),iStab(0:7)
      Integer, External :: iChxyz
      Integer, Save:: Active=0

      If (Active.eq.0) Then
         Call Symmetry_Info_Get()
         Active=1
      End If
*     Obtain symmetry-unique masses
      Call Get_nAtoms_All(nAtoms_Allx)
      If (nAtoms_All.ne.nAtoms_Allx) Then
         Write (6,*) 'Get_Coord_All: nAtoms_All.ne.nAtoms_Allx'
         Write (6,*) 'nAtoms_All=',nAtoms_All
         Write (6,*) 'nAtoms_Allx=',nAtoms_Allx
         Call Abend
      End If
      Call Get_iScalar('Unique atoms',nAtoms)
      Call mma_allocate(Mass,nAtoms)
      Call Get_Mass(Mass,nAtoms)

*     Replicate masses
      Call mma_allocate(CU,3,nAtoms)
      Call Get_dArray('Unique Coordinates',CU,3*nAtoms)
      nGen=0
      If (nIrrep.eq.2) nGen=1
      If (nIrrep.eq.4) nGen=2
      If (nIrrep.eq.8) nGen=3
      If (nGen.ge.1) iGen(1)=iOper(1)
      If (nGen.ge.2) iGen(2)=iOper(2)
      If (nGen.eq.3) iGen(3)=iOper(4)
      MaxDCR=0
      j=0
      Do i=1,nAtoms
        iChAtom=iChxyz(CU(1,i),iGen,nGen)
        Call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
        nCoSet=nIrrep/nStab
        Do iCo=0,nCoSet-1
          j=j+1
          Mass_all(j)=Mass(i)
        End Do
      End Do
      Call mma_deallocate(CU)
      Call mma_deallocate(Mass)

      Return
      End Subroutine Get_Mass_All

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************
!**************************************************************
!** Transformation between VB structures and VB determinants **
!** Also generation of spin-function to determinant transf.  **
!** and of perfect-pairing guess.                            **
!**************************************************************
!***********************************************************************
!*                                                                     *
!*  Transformation between VB structures (VB CSFs) and determinants.   *
!*                                                                     *
!*  The VB structures are ordered according to spatial                 *
!*  configurations, and are normally defined in terms of spin          *
!*  eigenfunctions.                                                    *
!*  VB determinants are ordered with alpha & beta indices in           *
!*  increasing order, with alpha being the slower index.               *
!*                                                                     *
!*  STR2VB[CG] : Structure-to-determinant transformation.              *
!*  VB2STR[CG] : Determinant-to-structure transformation.              *
!*                                                                     *
!*  [C] : Transforms coefficients.                                     *
!*  [G] : Transforms a gradient-type quantity.                         *
!*                                                                     *
!*  The difference between [C] and [G] is mainly important when        *
!*  non-orthogonal spin functions are used (Rumer/Project.)            *
!*                                                                     *
!***********************************************************************

subroutine vb2strg_cvb(cvbdet,cvb)

use casvb_global, only: absym, bikcof, i2s_fr, idetvb, kbasiscvb, nalf_fr, nconfion_fr, ndetvb, ndetvb_fr, nel_fr, nfrag, nMs_fr, &
                        nS_fr, nvb, nvb_fr
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_IN_) :: cvbdet(ndetvb)
real(kind=wp), intent(out) :: cvb(nvb)
integer(kind=iwp) :: idetvb_add, ifrag, ioffs_cvb, ioffs_cvbdet, kbs

kbs = nint(bikcof(0))
if (kbs /= kbasiscvb) then
  call mkbiks_cvb()
  kbs = kbasiscvb
end if
ioffs_cvb = 1
ioffs_cvbdet = 1
idetvb_add = 1
do ifrag=1,nfrag
  call str2vb2_cvb(bikcof(1:),cvb(ioffs_cvb),cvbdet(ioffs_cvbdet),1,idetvb(idetvb_add),i2s_fr(1,ifrag),nS_fr(ifrag), &
                   nalf_fr(1,ifrag),nMs_fr(ifrag),absym(1),ndetvb_fr(ifrag),nvb_fr(ifrag),kbs,nel_fr(ifrag),nconfion_fr(0,ifrag))
  idetvb_add = idetvb_add+ndetvb_fr(ifrag)
  ioffs_cvb = ioffs_cvb+nvb_fr(ifrag)
  ioffs_cvbdet = ioffs_cvbdet+ndetvb_fr(ifrag)
end do

return

end subroutine vb2strg_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dbl_upwalk()

use gugaci_global, only: jpad_upwei, jroute_sys, lsm_inn, mxnode, ng_sm, norb_dbl, norb_dz, norb_frz, ns_sm, nu_ad
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iw, lri, lrj, lsmi, lsmid, lsmij, lsmit, lsmj, no_d, no_t, node

nu_ad(:) = 0
jpad_upwei(:) = 0

if (norb_dbl == 1) then

  ! v(1),d(2-9),s(18-25)           for s=0
  ! v(1),d(2-9),s(18-25),d'(26-33)   for s<>0

  mxnode = 17+ng_sm
  lri = norb_frz+1
  lsmi = lsm_inn(lri)
  lsmid = Mul(lsmi,ns_sm)
  ! for node_v
  nu_ad(1) = 1
  jpad_upwei(1) = 1
  ! for node_d
  nu_ad(1+lsmid) = 1+lsmid
  jpad_upwei(1+lsmid) = 1
  ! for node_s
  nu_ad(17+ns_sm) = 17+ns_sm
  jpad_upwei(17+ns_sm) = 1

  if (jroute_sys == 1) return
  mxnode = 25+ng_sm
  ! for node_d'
  nu_ad(25+lsmid) = 25+lsmid
  jpad_upwei(25+lsmid) = 1

else

  nu_ad(1) = 1
  jpad_upwei(1) = 1
  if (norb_dbl == 0) then
    mxnode = 1
    return
  end if
  do lri=norb_frz+1,norb_dz
    lsmi = lsm_inn(lri)
    lsmid = Mul(lsmi,ns_sm)
    no_d = lsmid+1
    jpad_upwei(no_d) = jpad_upwei(no_d)+1
    do lrj=lri+1,norb_dz
      lsmj = lsm_inn(lrj)
      lsmij = Mul(lsmi,lsmj)
      lsmit = Mul(lsmij,ns_sm)
      no_t = lsmit+9
      jpad_upwei(no_t) = jpad_upwei(no_t)+1
    end do
  end do
  ! v(1),d(2-9),t(10-17),s(18-25),d'(26-33),t'(34-41)
  select case (jroute_sys)
    case default ! (1)
      mxnode = 25                     !v,d,t,s
      jpad_upwei(18:25) = jpad_upwei(10:17)
      jpad_upwei(17+ns_sm) = jpad_upwei(17+ns_sm)+norb_dbl
    case (2)
      mxnode = 25+8
      jpad_upwei(18:25) = jpad_upwei(10:17)+jpad_upwei(10:17)
      jpad_upwei(17+ns_sm) = jpad_upwei(17+ns_sm)+norb_dbl
      jpad_upwei(26:33) = jpad_upwei(2:9)
    case (3)
      mxnode = 25+8+8
      jpad_upwei(18:25) = jpad_upwei(10:17)+jpad_upwei(10:17)
      jpad_upwei(17+ns_sm) = jpad_upwei(17+ns_sm)+norb_dbl
      jpad_upwei(26:33) = jpad_upwei(2:9)
      jpad_upwei(34:41) = jpad_upwei(10:17)
  end select

  do node=2,mxnode
    iw = jpad_upwei(node)
    if (iw == 0) cycle
    nu_ad(node) = node
  end do

end if

return

end subroutine dbl_upwalk

subroutine ext_downwalk()

use gugaci_global, only: iseg_downwei, ng_sm, nlsm_ext, norb_ext, nu_ae
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: im, imi, imij, imj, iwmij(8)

nu_ae(:) = 0
nu_ae(1) = 1
do im=1,ng_sm
  nu_ae(1+im) = 1+im
  nu_ae(9+im) = 9+im
  nu_ae(17+im) = 17+im
end do

iwmij = 0
iseg_downwei(nu_ae(1)) = 1
do imi=1,ng_sm
  iseg_downwei(nu_ae(1+imi)) = nlsm_ext(imi)
  do imj=imi,ng_sm
    imij = Mul(imi,imj)
    if (imij /= 1) then
      iwmij(imij) = iwmij(imij)+nlsm_ext(imi)*nlsm_ext(imj)
      cycle
    end if
    iwmij(1) = iwmij(1)+nlsm_ext(imi)*(nlsm_ext(imi)-1)/2
  end do
end do
do im=1,ng_sm
  iseg_downwei(nu_ae(9+im)) = iwmij(im)
  iseg_downwei(nu_ae(17+im)) = iwmij(im)
end do
iseg_downwei(nu_ae(18)) = iseg_downwei(nu_ae(18))+norb_ext

return

end subroutine ext_downwalk

subroutine readdrt(ludrt)

use gugaci_global, only: ja, jb, jd, jj, jm, js, jt, jv, kk, no, norb_inn
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ludrt
integer(kind=iwp) :: id, idisk, idx(2)

idisk = 0
! number of nodes
call idafile(ludrt,2,idx,2,idisk)
idisk = idx(2)
call idafile(ludrt,2,idx,1,idisk)
id = idx(1)
call idafile(ludrt,2,ja,id,idisk)
call idafile(ludrt,2,jb,id,idisk)
call idafile(ludrt,2,jm,id,idisk)
call idafile(ludrt,2,jj,4*(id+1),idisk)
call idafile(ludrt,2,kk,1+id,idisk)
no(:) = 0
call idafile(ludrt,2,no,norb_inn+2,idisk)
call idafile(ludrt,2,idx,1,idisk)
jv = idx(1)
call idafile(ludrt,2,jd,8,idisk)
call idafile(ludrt,2,jt,8,idisk)
call idafile(ludrt,2,js,8,idisk)

return

end subroutine readdrt

! juv,just(nost,nost),jud(nost)
! |   \  1           |
! | d,dd,s(i=i)      |
! |     \ s,t,tt(i<j)|
! |      \       1 2 |     deal with inner of dbl_space
! |ss(i>j)\          |
! |  2 1   \         |
subroutine dbl_downwalk()

use gugaci_global, only: iseg_downwei, iseg_sta, jud, just, lsm_inn, ng_sm, norb_dbl, norb_dz, norb_frz, ns_sm
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: im, ismi, ismij, ismj, lr0, lri, lrj, nnd, nns, nnt !, lsml(10,10)       !to del

if (norb_dbl == 0) then
  !----------- norb_dbl=0 ----------------------------------------------
  do im=1,ng_sm
    nnd = iseg_sta(1+im)
    nnt = iseg_sta(9+im)
    nns = iseg_sta(17+im)
    do lri=norb_dz,norb_frz+1,-1
      ismi = lsm_inn(lri)
      if (ismi /= im) cycle
      jud(lri) = nnd
      nnd = nnd+iseg_downwei(1+im)
    end do
    do lrj=norb_dz,norb_frz+1,-1
      ismj = lsm_inn(lrj)
      do lri=lrj,1,-1
        ismi = lsm_inn(lri)
        ismij = Mul(ismi,ismj)
        if (ismij /= im) cycle
        just(lri,lrj) = nns
        nns = nns+iseg_downwei(17+im)
        if (lri == lrj) cycle
        just(lrj,lri) = nnt
        nnt = nnt+iseg_downwei(9+im)
      end do
    end do
  end do
end if
!----------- norb_dbl=0 ------------------------------------------------
!----------- norb_dbl<>0 -----------------------------------------------
do im=1,ng_sm
  nnd = 0
  nns = 0
  do lri=norb_frz+1,norb_dz
    ismi = Mul(lsm_inn(lri),ns_sm)
    if (ismi /= im) cycle
    jud(lri) = nnd
    nnd = nnd+1
  end do
  do lri=norb_frz+1,norb_dz-1
    ismi = Mul(lsm_inn(lri),ns_sm)
    do lrj=lri+1,norb_dz      !tmp
      ismj = lsm_inn(lrj)
      ismij = Mul(ismi,ismj)
      if (ismij /= im) cycle
      just(lri,lrj) = nns
      nns = nns+1
    end do
  end do
  if (im == ns_sm) then
    do lr0=norb_frz+1,norb_dz
      just(lr0,lr0) = nns
      nns = nns+1
    end do
  end if
  do lri=norb_frz+1,norb_dz-1
    ismi = Mul(lsm_inn(lri),ns_sm)
    do lrj=lri+1,norb_dz      !tmp
      ismj = lsm_inn(lrj)
      ismij = Mul(ismi,ismj)
      if (ismij /= im) cycle
      just(lrj,lri) = nns
      nns = nns+1
    end do
  end do
end do
!write(u6,*) 'ns_sm',ns_sm
!write(u6,*) just(1:4,1:4)
!do i=norb_frz+1,norb_dz                                     !to del
!  lmi = lsm_inn(i)                                          !to del
!  do j=norb_frz+1,norb_dz                                   !to del
!    lmj = lsm_inn(j)                                        !to del
!    lsml(i,j) = Mul(lmi,lmj)                            !to del
!  end do                                                    !to del
!end do                                                      !to del
!write(nf2,*) '   jud ...'                                   !to del
!write(nf2,'(2x,12i8)') (jud(lr),lr=norb_frz+1,norb_dz)      !to del
!write(nf2,*) '   just ...'                                  !to del
!do i=norb_frz+1,norb_dz                                     !to del
!  write(nf2,'(2x,8i3)') (lsml(i,lr),lr=norb_frz+1,norb_dz)  !to del
!  write(nf2,'(2x,8i3)') (just(i,lr),lr=norb_frz+1,norb_dz)  !to del
!  write(nf2,*)
!end do                                                      !to del
!----------- norb_dbl<>0 -----------------------------------------------

return

end subroutine dbl_downwalk

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PREPSD(WFTP,SGS,CIS,LSYM,
     &                  ICNFTAB,ISPNTAB,ISSTAB,IFSBTAB,
     &                  NCONF,CI,DET,detocc,detcoeff,SPTRA)
      use stdalloc, only: mma_allocate, mma_deallocate
      use gugx, only: SGStruct, CIStruct
      IMPLICIT NONE
      Type (SGStruct) SGS
      Type (CIStruct) CIS
      INTEGER ICNFTAB(*),ISPNTAB(*),ISSTAB(*),IFSBTAB(*)
      INTEGER LSYM,NCONF
      REAL*8 CI(*),DET(*)
      INTEGER IMODE
      CHARACTER(LEN=8) WFTP
      character(len=*), intent(out) :: detocc(NCONF)
      real(8), intent(out) :: detcoeff(NCONF)
      real(8), intent(in) :: SPTRA(*)
      Real*8, Allocatable:: CTMP(:)

C Purpose: Given a RASSCF wave function in Split-GUGA format
C and an orbital transformation matrix for the purpose of
C getting biorthonormal orbitals, prepare a wave function
C in the general SD format, using transformed orbitals.

      IF(WFTP.EQ.'GENERAL ') THEN
C Transform SGUGA to SymmG:
        CALL mma_allocate(CTMP,NCONF,Label='CTMP')
        IMODE=1
        CALL SYG2SGU(IMODE,SGS,CIS,LSYM,ICNFTAB,ISPNTAB,CI,CTMP)
C Transform SymmG to Slater Dets:
        CALL SYGTOSD(ICNFTAB,ISPNTAB,ISSTAB,IFSBTAB,CTMP,DET,
     &               detocc,detcoeff,SPTRA)
        CALL mma_deallocate(CTMP)
      ELSE
        DET(1)=CI(1)
      END IF

      END SUBROUTINE PREPSD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE LOOP12(KM,ISTOP,IT1,IT2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      ISTOP=0
      KM1=KM+1
      J2F=IPO(J2(KM1))
      IDIF=IA(J1(KM1))-IA(J2(KM1))
      IF(IDIF.LT.0.OR.IDIF.GT.1)GO TO 55
      IF(IDIF.EQ.1)GO TO 51
      IWAYKM=IWAY(KM)
      GO TO (39,41,42,55),IWAYKM
39    IWAY(KM)=2
C     GC
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 41
      IF(K0F(J2F).EQ.0)GO TO 41
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM)=COUP(KM1)
      GO TO 40
C     HD
41    IWAY(KM)=3
      IF(K3(IT1+J1(KM1)).EQ.0.OR.K3(IT2+J2(KM1)).EQ.0)GO TO 42
      IF(K2F(J2F).EQ.0)GO TO 42
      J1(KM)=K3(IT1+J1(KM1))
      J2(KM)=K3(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP(KM)=BS4(IB(J2(KM1))+1)*BS2(IB(J2(KM1))+1)*COUP(KM1)
      GO TO 40
C     GA
42    IWAY(KM)=4
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 55
      IF(K0F(J2F).EQ.0)GO TO 55
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM)=COUP(KM1)
      GO TO 40
51    IWAYKM=IWAY(KM)
      GO TO (59,61,62,55),IWAYKM
59    IWAY(KM)=2
C     EC
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 61
      IF(K0F(J2F).EQ.0)GO TO 61
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM)=COUP(KM1)
      GO TO 40
C     EA
61    IWAY(KM)=3
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 62
      IF(K0F(J2F).EQ.0)GO TO 62
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM)=COUP(KM1)
      GO TO 40
C     FB
62    IWAY(KM)=4
      IF(K3(IT1+J1(KM1)).EQ.0.OR.K3(IT2+J2(KM1)).EQ.0)GO TO 55
      IF(K1F(J2F).EQ.0)GO TO 55
      J1(KM)=K3(IT1+J1(KM1))
      J2(KM)=K3(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP(KM)=BS3(IB(J2(KM1))+1)*BS1(IB(J2(KM1))+1)*COUP(KM1)
      GO TO 40
55    ISTOP=1
40      Continue
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function spin(l,i_dim,m1,m2)
! Returns the value of the < m1 | S_l | m2 >

use Constants, only: Zero, One, Half, cZero, cOne, Onei
use Definitions, only: wp, iwp, u6

implicit none
complex(kind=wp) :: spin
integer(kind=iwp), intent(in) :: l, i_dim, m1, m2
integer(kind=iwp) :: ipar
real(kind=wp) :: D, F, MM1, MM2, R, S

spin = cZero
ipar = mod(i_dim,2)
S = real(i_dim-1,kind=wp)*Half
R = Zero

#ifdef _DEBUGPRINT_
write(u6,'(A,4I3)') 'l,i_dim,m1,m2=',l,i_dim,m1,m2
write(u6,'(A,I3,F8.3)') ' ipar,  S  =',ipar,S
#endif

! set up the true values of the MM1 and MM2
! i.e. the projections of the spin momentum S
if (ipar == 0) then
  if (m1 < 0) then
    MM1 = real(m1,kind=wp)+Half
  else
    MM1 = real(m1,kind=wp)-Half
  end if

  if (m2 < 0) then
    MM2 = real(m2,kind=wp)+Half
  else
    MM2 = real(m2,kind=wp)-Half
  end if
else
  MM1 = real(m1,kind=wp)
  MM2 = real(m2,kind=wp)
end if
#ifdef _DEBUGPRINT_
write(u6,'(A,2F8.3)') 'mm1,mm2=',mm1,mm2
call xFlush(u6)
#endif
! compute the value of the matrix element, for each possible cartesian component.
! l=1  => X
! l=2  => Y
! l=3  => Z

if (l == 1) then

  if (MM1-One == MM2) then
    D = S+MM1
    F = S-MM1+One
    R = Half*sqrt(D*F)

    spin = R*cOne

  else if (MM1+One == MM2) then

    D = S-MM1
    F = S+MM1+One
    R = Half*sqrt(D*F)
    spin = R*cOne

  else
    spin = cZero
  end if
# ifdef _DEBUGPRINT_
  write(u6,'(A,2F8.3)') 'X, spin =',spin
  call xFlush(u6)
# endif

else if (l == 2) then

  if (MM1-One == MM2) then

    D = S+MM1
    F = S-MM1+One
    R = -Half*sqrt(D*F)
    spin = R*Onei

  else if (MM1+One == MM2) then

    D = S-MM1
    F = S+MM1+One
    R = Half*sqrt(D*F)
    spin = R*Onei

  else
    spin = cZero
  end if
# ifdef _DEBUGPRINT_
  write(u6,'(A,2F8.3)') 'Y, spin =',spin
  call xFlush(u6)
# endif

else if (l == 3) then

  if (MM1 /= MM2) then
    spin = cZero
  else
    spin = MM1*cOne
  end if
# ifdef _DEBUGPRINT_
  write(u6,'(A,2F8.3)') 'Z, spin =',spin
  call xFlush(u6)
# endif

else
  write(u6,'(A)') 'The spin function gives a wrong number'
  return
end if

#ifdef _DEBUGPRINT_
write(u6,*) 'Upon Return:  spin =',spin
call xFlush(u6)
#endif

return

end function spin

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine fokunpck1 (fok,dp,dimfok)
c
c     this routine do Fok = Fok - dp
c     fok    - Fok matrix (I/O)
c     dp     - Diagonal part vector (I)
c     dimfok - dimension for Fok matrix - norb (I)
c
       integer dimfok
c
       real*8 fok(1:dimfok,1:dimfok)
       real*8 dp(1:dimfok)
c
c     help variables
c
       integer p
c
c1    substract dp from Fok
       do 100 p=1,dimfok
       fok(p,p)=fok(p,p)-dp(p)
 100    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FTwo_Drv(nSym,nBas,nAsh,nSkipX,
     &                    DI,D1A,FA,nTot1,
     &                    ExFac,nTot2,nBMX,CMO)


      Implicit Real*8 (A-H,O-Z)
#include "rasdim.fh"
#include "WrkSpc.fh"
#include "real.fh"

      Integer nBas(8), nAsh(8), nSkipX(8)
      Dimension CMO(*) , D1A(*) , DI(*), FA(*)
      Logical DoCholesky,REORD,DECO
      Integer ALGO
      COMMON /CHORAS/ REORD,DECO,ALGO


      Call DecideOncholesky(DoCholesky)

      IF (DoCholesky.and.ALGO.eq.2)THEN
*
* Building of the Fock matrix directly from Cholesky
* vectors
*
         Call GetMem('LWFSQ','Allo','Real',LWFSQ,nTot2)
         call dcopy_(nTot2,[Zero],0,Work(LWFSQ),1)

         Call Allocate_Work(ipTemp,nTot1)
         Call FZero(Work(ipTemp),nTot1)
*
         CALL CHORAS_DRV(nSym,nBas,nAsh,D1A,DI,Work(ipTemp),
     &                   ExFac,LWFSQ,CMO)

         Call DaXpY_(nTot1,One,Work(ipTemp),1,FA,1)
*
         Call Free_Work(ipTemp)
         Call GetMem('LWFSQ','Free','Real',LWFSQ,nTot2)

      ELSE

*
* Standard building of the Fock matrix from Two-el integrals
*
         Call FockTwo_Drv(nSym,nBas,nAsh,nSkipX,
     &                    DI,D1A,FA,nTot1,
     &                    ExFac,nTot2,nBMX)

      ENDIF


      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_TranslateErrorCode(iErr,MolcasCode)
      Implicit None
      Integer iErr, MolcasCode
#include "warnings.h"

      If (iErr .eq. 3) Then ! special code used in parallel
         MolcasCode = _RC_NOT_AVAILABLE_
      Else If (iErr .eq. 100) Then
         MolcasCode = _RC_CHO_DUM_
      Else If (iErr .eq. 101) Then
         MolcasCode = _RC_CHO_MEM_
      Else If (iErr .eq. 102) Then
         MolcasCode = _RC_CHO_INI_
      Else If (iErr .eq. 103) Then
         MolcasCode = _RC_CHO_LOG_
      Else If (iErr .eq. 104) Then
         MolcasCode = _RC_CHO_RUN_
      Else If (iErr .eq. 105) Then
         MolcasCode = _RC_CHO_INP_
      Else
         MolcasCode = _RC_GENERAL_ERROR_
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_Fock_MoTra(nSym,nBas,nFro,W_DLT,W_DSQ,W_FLT,nFLT,W_FSQ,ExFac)

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nFro(nSym), nFLT
! TODO: fix intent of these arrays after removing "ip_of_Work"
real(kind=wp), intent(inout) :: W_DLT(*), W_DSQ(*), W_FLT(nFLT), W_FSQ(*)
real(kind=wp), intent(in) :: ExFac
integer(kind=iwp) :: i, irc, ja, nDen, NScreen, NumV, nXorb(8)
real(kind=wp) :: ChFracMem, dFKmat, dmpk, Thr, Ymax
type (DSBA_Type) FLT(1), KLT(1), MOs, DLT, DSQ

!****************************************************************
! CALCULATE AND RETURN FMAT DUE TO FROZEN ORBITALS ONLY
!****************************************************************

NScreen = 10
dmpK = 0.1_wp
dFKmat = Zero
nXorb(:)=0

! Initialize Cholesky information

ChFracMem = Zero
call CHO_X_INIT(irc,ChFracMem)
if (irc /= 0) then
  write(u6,*) 'Cho_Fock_Motra: Cho_X_Init returns error code ',irc
  call AbEnd()
end if

Call Allocate_DT(DLT,nBas,nBas,nSym,aCase='TRI',Ref=W_DLT)
Call Allocate_DT(DSQ,nBas,nBas,nSym,aCase='REC',Ref=W_DSQ)
Call Allocate_DT(MOs,nBas,nBas,nSym)

do i=1,nSym
  if (nBas(i) > 0) then
    Ymax = Zero
    do ja=1,nBas(i)
      Ymax = max(Ymax,DSQ%SB(i)%A2(ja,ja))
    end do
    Thr = 1.0e-8_wp*Ymax
    call CD_InCore(DSQ%SB(i)%A2,nBas(i),MOs%SB(i)%A2,nBas(i),NumV,Thr,irc)
    if (irc /= 0) then
      write(u6,*) 'Cho_Fock_Motra: CD_incore returns rc ',irc
      call AbEnd()
    end if

    if (NumV /= nFro(i)) then
      write(u6,'(a,i6,a,i6,a,i6,a,i6,a,i6)') 'Warning! Cho_Fock_Motra: nr of Frozen orbitals from the decomposition of the '// &
                                             'density matrix is ',numV,' in symm. ',i,'; Expected value = ',nFro(i), &
                                             '; Max diagonal of the density in symm. ',i,' is equal to ',Ymax
    end if

  end if

end do

nDen = 1
Call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FLT)
Call Allocate_DT(KLT(1),nBas,nBas,nSym,aCase='TRI',Ref=W_FSQ) ! not needed on exit

call CHO_LK_SCF(irc,nDen,FLT,KLT,nXorb,nFro,[MOs],[DLT],Half*ExFac,NScreen,dmpk,dFKmat)

if (irc /= 0) then
  write(u6,*) 'Cho_Fock_Motra: Cho_LK_scf returns error code ',irc
  call AbEnd()
end if

call Deallocate_DT(KLT(1))
call Deallocate_DT(FLT(1))

call GADSUM(W_FLT,nFLT)

call deallocate_DT(MOs)
call deallocate_DT(DSQ)
call deallocate_DT(DLT)

! Finalize Cholesky information

call CHO_X_FINAL(irc)
if (irc /= 0) then
  write(u6,*) 'Cho_Fock_Motra: Cho_X_Final returns error code ',irc
  write(u6,*) 'Try recovery -- continue.'
end if

return

end subroutine Cho_Fock_MoTra

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine EXTRT_MS_OPEN_OB(IDET_OC,IDET_MS,IDET_OPEN_MS,NEL)
! A determinant IDET_OC, IDET_MS is given. Extract spinprojections
! for open shells
!
! Jeppe Olsen, December 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NEL, IDET_OC(NEL), IDET_MS(NEL)
integer(kind=iwp), intent(_OUT_) :: IDET_OPEN_MS(*)
integer(kind=iwp) :: IEL, IOPEN

IEL = 1
IOPEN = 0
! Loop over electrons
do
  if (IEL < NEL) then
    if (IDET_OC(IEL) /= IDET_OC(IEL+1)) then
      ! Single occupied orbital so
      IOPEN = IOPEN+1
      IDET_OPEN_MS(IOPEN) = IDET_MS(IEL)
      IEL = IEL+1
    else
      IEL = IEL+2
    end if
  else
    ! Last electron was not identical to previous, so
    ! necessarily single occupied.
    IOPEN = IOPEN+1
    IDET_OPEN_MS(IOPEN) = IDET_MS(IEL)
    IEL = IEL+1
  end if
  if (IEL > NEL) exit
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Input det, occ and ms'
call IWRTMA(IDET_OC,1,NEL,1,NEL)
call IWRTMA(IDET_MS,1,NEL,1,NEL)
write(u6,*) ' Number of open orbitals = ',IOPEN
write(u6,*) ' Output det : ms of open orbitals'
call IWRTMA(IDET_OPEN_MS,1,IOPEN,1,IOPEN)
#endif

end subroutine EXTRT_MS_OPEN_OB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine tensor2cart(Jt,Jc)
! Hexch = S1.Jsph.S2

use Constants, only: Half, Onei
use Definitions, only: wp

implicit none
complex(kind=wp), intent(in) :: Jt(-1:1,-1:1)
real(kind=wp), intent(out) :: Jc(3,3)
complex(kind=wp) :: mm, mp, mz, pm, pp, pz, zm, zp, zz

pp = jt(1,1)
pz = jt(1,0)
pm = jt(1,-1)
zp = jt(0,1)
zz = jt(0,0)
zm = jt(0,-1)
mp = jt(-1,1)
mz = jt(-1,0)
mm = jt(-1,-1)

jc(1,1) = Half*real(mm-mp-pm+pp)
jc(2,2) = Half*real(-mm-mp-pm-pp)
jc(1,2) = Half*real(-Onei*mm-Onei*mp+Onei*pm+Onei*pp)
jc(2,1) = Half*real(-Onei*mm+Onei*mp-Onei*pm+Onei*pp)

jc(1,3) = sqrt(Half)*real(mz-pz)
jc(3,1) = sqrt(Half)*real(zm-zp)

jc(2,3) = sqrt(Half)*real(-Onei*mz-Onei*pz)
jc(3,2) = sqrt(Half)*real(-Onei*zm-Onei*zp)

jc(3,3) = real(zz)

return

end subroutine tensor2cart

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PCM_Cavity(iPrint,ICharg,NAtm,ToAng,AtmC,IAtm,IsAtMM,
     &                      LcAtmC,LcIAtm,JSurf)
      use PCM_arrays
      Implicit Real*8 (a-h,o-z)
#include "espf.fh"
*
#include "rctfld.fh"
#include "status.fh"
#include "stdalloc.fh"
      Real*8 AtmC(3,NAtm),LcAtmC(3,NAtm)
      Integer IAtm(NAtm),IsAtMM(NAtm),LcIAtm(NAtm)
      Save Rad_Cor,Surf_Inc
      Data Rad_Cor/2.0d0/,Surf_Inc/0.5d0/
      Real*8, Allocatable:: Xs(:), Ys(:), Zs(:), Rs(:)
      Integer, Allocatable:: pNs(:)
*
*
*     Build the cavity.
*
      Call PCMDef(ISlPar,RSlPar,iPrint)
      RSlPar(3) = 5.0d-1
      RSlPar(7) = 2.0d0
      RSlPar(9) = Rad_Cor + Dble(JSurf)*Surf_Inc
*
*     Possibly print parameter values
*
      If(iPrint.ge.99) Then
         write(6,'(''PCM parameters'')')
         Do 10 I = 1, 100
           write(6,'(''ISlpar('',i3,'') ='',i6)')I, ISlPar(I)
   10    Continue
         Do 20 I = 1, 100
           write(6,'(''RSlpar('',i3,'') ='',F8.3)')I, RSlPar(I)
   20    Continue
      EndIf
*
*---- Recover solvent data
*
      Call DataSol(ISlPar(15))
*
*     It is necessary to avoid spurious "atoms" which can cause errors
*     in UATM: then let's copy only the real atoms on local arrays
*     of coordinates and atomic numbers.
*
      LcI = 0
      Do 30 I = 1, NAtm
         If(IAtm(I).gt.0 .and. IsAtMM(I).eq.0) then
           LcI = LcI + 1
           LcAtmC(1,LcI) = AtmC(1,I)
           LcAtmC(2,LcI) = AtmC(2,I)
           LcAtmC(3,LcI) = AtmC(3,I)
           LcIAtm(LcI)   = IAtm(I)
         EndIf
   30 Continue
      LcNAtm = LcI
      ISlPar(42) = LcNAtm
*
*---- Define atomic/group spheres
*     Allocate space for X, Y, Z, Radius and NOrd for MxSph spheres
*
      Call mma_allocate(Xs,MxSph,Label='Xs')
      Call mma_allocate(Ys,MxSph,Label='Ys')
      Call mma_allocate(Zs,MxSph,Label='Zs')
      Call mma_allocate(Rs,MxSph,Label='Rs')
      Call mma_allocate(pNs,MxSph,Label='pNs')
*
      NSinit = 0
      Call FndSph(LcNAtm,ICharg,ToAng,LcAtmC,LcIAtm,ISlPar(9),
     &            ISlPar(14),RSlPar(9),Xs,Ys,Zs,Rs,pNs,iPrint)
*
*---- Define surface tesserae
*
      Call FndTess(iPrint,ToAng,LcNAtm,Xs,Ys,Zs,Rs,pNs,MxSph)
*
      Call mma_deallocate(pNs)
      Call mma_deallocate(Rs)
      Call mma_deallocate(Zs)
      Call mma_deallocate(Ys)
      Call mma_deallocate(Xs)
*
*---- If needed compute the geometrical derivatives
*
      If(DoDeriv) then
         RSolv = RSlPar(19)
         LcNAtm = ISlPar(42)
         Call mma_allocate(dTes,nTs,LcNAtm,3,Label='dTes')
         Call mma_allocate(dPnt,nTs,LcNAtm,3,3,Label='dPnt')
         Call mma_allocate(dRad,nS ,LcNAtm,3,Label='dRad')
         Call mma_allocate(dCntr,nS ,LcNAtm,3,3,Label='dCntr')
         Call mma_allocate(PCM_SQ,2,nTs,Label='PCM_SQ')
         Call Deriva(0,ToAng,LcNAtm,nTs,nS,nSInit,RSolv,
     $               PCMTess,Vert,Centr,PCMSph,PCMiSph,IntSph,
     $               PCM_N,NVert,NewSph,dTes,dPnt,dRad,dCntr)
         If (nPCM_info.eq.0) Then
            Write(6,'(A)') ' GEPOL failed to compute the grid deriv.'
            Write(6,'(A)') ' Reduce the number of surfaces.'
            Call Quit_OnUserError()
         End If
      EndIf
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Francesco Aquilante                              *
*               2014, Thomas Bondo Pedersen                            *
************************************************************************
*  CHO_FACTOR
*
*> @brief
*>   Evaluation of the Cholesky factor (\f$ Z \f$) of a SPD matrix (\f$ A \f$)
*> @author F. Aquilante (Jan. 2007)
*> @modified_by T.B. Pedersen (2014) Changed criterion for too negative diagonal
*>
*> @details
*> Evaluation of the Cholesky factor (\f$ Z \f$) of a SPD matrix (\f$ A \f$)
*>
*> \code
*>   For k=1,dim(A)
*>     Z(k,k) = sqrt( A(k,k) - sum_j  Z(k,j)^2 )
*>     Z(i,k) = ( A(i,k) - sum_j  Z(i,j)*Z(k,j) ) / Z(k,k)
*> \endcode
*>
*> The result is such that \f$ A \f$ is Cholesky decomposed as
*>
*> \f[  A = Z Z^\text{T} \f]
*>
*> The Cholesky factor is in general *NOT UNIQUE!!*
*> Therefore, and for stability reason, pivoting of the
*> initial matrix \f$ A \f$ would be advisable.
*>
*> @side_effects
*> \p A_k in output contains the \p kCol -th Cholesky vector.
*> In case of detected linear dependence, the \p A_k array
*> is returned as zeros!
*>
*> @note
*> Rectangular storage must be used for the \f$ Z \f$-matrix!
*>
*> @param[in,out] Diag   Updated diagonal elements of \f$ A \f$ (subtraction done by this routine)
*> @param[in,out] A_k    currently treated column of \f$ A \f$. In output contains the \p kCol -th Cholesky vector
*> @param[in]     iD_A   indices of the columns of \f$ A \f$
*> @param[in]     kCol   index of the Cholesky vector
*> @param[in]     nRow   number of rows of \f$ A \f$
*> @param[in]     Zm     in-core matrix whose columns are the Cholesky vectors
*> @param[in]     nMem   max number of columns of \p Zm kept in core
*> @param[in]     lu_Z   file unit where the \f$ Z \f$-matrix is stored
*> @param[in]     Scr    scratch space used for reading out-of-core columns of \p Zm
*> @param[in]     lScr   size of the scratch space (&ge; \p nRow or ``0`` iff in-core)
*> @param[in]     thr    threshold for linear dependence
*> @param[out]    lindep integer indicating detected linear dependence (= ``1`` iff found lin dep, else = ``0``)
************************************************************************
      SUBROUTINE CHO_FACTOR(Diag,A_k,iD_A,kCol,nRow,Zm,nMem,lu_Z,Scr,
     &                      lScr,thr,lindep)

      Implicit Real*8 (a-h,o-z)
      Integer iD_A(*), kCol, nRow, nMem, lu_Z, lScr, lindep
      Real*8  Diag(*), A_k(*), Zm(nRow,*), Scr(*)
#include "warnings.fh"
      Parameter ( one = 1.0d0, zero = 0.0d0 , thr_neg=-1.0d-8)

************************************************************************

      If (thr .lt. zero) Then
         Call WarningMessage(2,'Error in Cho_Factor')
         write(6,*)'thr must be .ge. zero'
         Call Quit(_RC_CHO_LOG_)
      EndIf

      lindep = 0
      Dmax = Diag(iD_A(kCol)) ! pivoting done by the calling routine
      xfac = one/sqrt(Abs(Dmax))

      If (kCol .le. nMem) Then

         If (Dmax.ge.thr) Then
*
*  Compute elements of the k-th Cholesky vector
* -------------------------------------------------------
C     Z(i,k) = A(i,k) - sum_j  Z(k,j)*Z(i,j)
* -------------------------------------------------------
            Do j=1,kCol-1

               fac = -Zm(iD_A(kCol),j)
               Call dAXPY_(nRow,fac,Zm(1,j),1,A_k(1),1)

            End Do

C-tbp: use thr_neg as threshold for too negative diagonal
C      It should not depend on the decomposition threshold!
C        ElseIf (Dmax.gt.zero .or. -Dmax.le.1.0d1*thr) Then
         ElseIf (Dmax.gt.thr_neg) Then

            lindep = 1
            Call Fzero(A_k(1),nRow)
            Return

         Else

            Call WarningMessage(2,'Error in Cho_Factor')
            write(6,*)'CHO_FACTOR: too-negative diagonal.'
            write(6,*)'CHO_FACTOR: current largest Diag = ',Dmax
            Call Quit(_RC_CHO_RUN_)

         EndIf
*                                                                      *
************************************************************************
*                                                                      *
      Else   ! the first nMem columns of Z are in memory
*                                                                      *
************************************************************************
*                                                                      *

         If (lScr .lt. nRow) Then
            Call WarningMessage(2,'Error in Cho_Factor')
            write(6,*)'lScr must be .ge. nRow'
            Call Quit(_RC_CHO_LOG_)
         EndIf

         If (Dmax.ge.thr) Then
*
*  Compute elements of the k-th Cholesky vector (in-core contrib.)
* -----------------------------------------------------------------
C     Z(i,k) = A(i,k) - sum_j  Z(k,j)*Z(i,j)
* -----------------------------------------------------------------
            Do j=1,nMem

               fac = -Zm(iD_A(kCol),j)
               Call dAXPY_(nRow,fac,Zm(1,j),1,A_k(1),1)

            End Do
*
*  Batch for the out-of-core previous vectors
*--------------------------------------------
            kstep = lScr/nRow

            Do kdone=nMem+1,kCol-1,kStep

               lZdone = nRow*(kdone-1)
               lZrem = nRow*(kCol-kdone)
               lZread = Min(LZrem,nRow*kStep)

               Call ddafile(lu_Z,2,Scr(1),lZread,lZdone) ! read
*
*  Compute elements of the k-th Cholesky vector (out-of-core contrib.)
* --------------------------------------------------------------------
C     Z(i,k) = A(i,k) - sum_j  Z(k,j)*Z(i,j)
* --------------------------------------------------------------------
               Do j=1,lZread/nRow
                  kj = nRow*(j-1)
                  fac = -Scr(kj+iD_A(kCol))
                  Call dAXPY_(nRow,fac,Scr(1+kj),1,A_k(1),1)
               End Do

            End Do

C-tbp: use thr_neg as threshold for too negative diagonal
C      It should not depend on the decomposition threshold!
C-tbp    ElseIf (Dmax.gt.zero .or. -Dmax.le.1.0d1*thr) Then
         ElseIf (Dmax.gt.thr_neg) Then

            lindep = 1
            Call Fzero(A_k(1),nRow)
            Return

         Else

            Call WarningMessage(2,'Error in Cho_Factor')
            write(6,*)'CHO_FACTOR: too-negative diagonal.'
            write(6,*)'CHO_FACTOR: current largest Diag = ',Dmax
            Call Quit(_RC_CHO_RUN_)

         EndIf

      EndIf
*
      A_k(iD_A(kCol)) = Dmax
*
* Scaling of the vector elements :  Z(i,k) = Z(i,k)/Z(k,k)
* --------------------------------------------------------
      call dscal_(nRow,xfac,A_k(1),1)
*
*  Explicit zeroing of the previously treated elements
* ----------------------------------------------------
      Do i=1,kCol-1
         A_k(iD_A(i)) = zero
      End Do
*
*  Update diagonal elements of the A matrix
*  ----------------------------------------------------
C     A(i,i) = A(i,i) - Z(i,k)^2    ( i > k )
*  ----------------------------------------------------
      Do i=1,nRow
         Diag(i) = Diag(i) - A_k(i)**2
      End Do
      Diag(iD_A(kCol)) = zero ! explicit zeroing of the treated diagonal

C-tbp: zero negative diagonal elements
C      Stop if too negative!
      Do i = 1,nRow
         If (Diag(i).lt.zero) Then
            If (Diag(i).le.thr_neg) Then
               Call WarningMessage(2,'Error in Cho_Factor')
               write(6,*)'CHO_FACTOR: too negative diagonal.'
               write(6,*)'CHO_FACTOR: i,Diag(i)= ',i,Diag(i)
               Call Quit(_RC_CHO_RUN_)
            Else
               Diag(i)=zero
            End If
         End If
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine TAIL(LL,IJJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)

use guga_global, only: ICOUP, ICOUP1, IWAY, IY, J2, LN
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: LL, IJJ, ITAIL, L0(*), L1(*), L2(*), L3(*), IT1, IT2
integer(kind=iwp), intent(_OUT_) :: ITAI(*)
integer(kind=iwp) :: I, IWAYKM, KM, KM1, L
logical(kind=iwp) :: first

L = LL+1
if (ITAIL == 0) then
  return
end if
do I=1,ITAIL
  ITAI(I) = 0
end do
if (L == LN+1) ITAI(1) = 1
KM = L
J2(KM) = IJJ
ICOUP(L) = 1
ICOUP1(L) = 1
first = .true.
do
  if (first) then
    KM = KM+1
    IWAY(KM) = 0
    first = .false.
  end if
  KM1 = KM-1
  IWAYKM = IWAY(KM)
  if (IWAYKM < 1) then
    if ((L0(IT1+J2(KM1)) == 0) .or. (L0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 1
    else
      J2(KM) = L0(IT2+J2(KM1))
      IWAY(KM) = 1
      ICOUP(KM) = ICOUP(KM1)
      ICOUP1(KM) = ICOUP1(KM1)
    end if
  end if
  if (IWAYKM == 1) then
    if ((L1(IT1+J2(KM1)) == 0) .or. (L1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else
      J2(KM) = L1(IT2+J2(KM1))
      IWAY(KM) = 2
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM),1)
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J2(KM),1)
    end if
  end if
  if (IWAYKM == 2) then
    if ((L2(IT1+J2(KM1)) == 0) .or. (L2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else
      J2(KM) = L2(IT2+J2(KM1))
      IWAY(KM) = 3
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM),2)
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J2(KM),2)
    end if
  end if
  if (IWAYKM == 3) then
    if ((L3(IT1+J2(KM1)) == 0) .or. (L3(IT2+J2(KM1)) == 0)) then
      IWAYKM = 4
    else
      J2(KM) = L3(IT2+J2(KM1))
      IWAY(KM) = 4
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM),3)
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J2(KM),3)
    end if
  end if
  if (IWAYKM > 3) then
    KM = KM-1
    if (KM == L) exit
  else
    if (KM /= LN+1) then
      first = .true.
    else
      ITAI(ICOUP(LN+1)) = ICOUP1(LN+1)
    end if
  end if
end do

return

end subroutine TAIL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MSP(B,Bd,Gamma,Delta,nDim)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 B(nDim,nDim), Bd(nDim),Gamma(nDim),Delta(nDim)
*
*                              T       T            ( T)
*                    |(1-phi)/d g phi/d d|        | (g )
*                    |     T       T    T         | ( T)
*     B = B + (g  d )|phi/d d    -Phi*d g/(d d)**2| (d )
*
*
      iRout=212
      iPrint=nPrint(iRout)
*
*
      gd= DDot_(nDim,Gamma,1,Delta,1)
      dd= DDot_(nDim,Delta,1,Delta,1)
      gg= DDot_(nDim,Gamma,1,Gamma,1)
      phi=(One-((gd**2)/(dd*gg)))
      e_msp=(gd/dd)**2*((Two/(One-Phi*Sqrt(Phi)))-One)
      If (iPrint.ge.99) Then
         Call RecPrt(' MSP: Hessian',' ',B,nDim,nDim)
         Call RecPrt(' MSP: Delta',' ',Delta,nDim,1)
         Call RecPrt(' MSP: Gamma',' ',Gamma,nDim,1)
         Write (6,*) 'MSP: Phi=',Phi
         Write (6,*) 'gd,dd,gg=', gd,dd,gg
         Write (6,*) 'MSP: a=',Sqrt(Phi)
         Write (6,*) 'MSP: E_msp=',E_msp
      End If
      Do i = 1, nDim
         Do j = 1, nDim
            B(i,j) = B(i,j)
     &             + ((One-phi)/gd)*Gamma(i)*Gamma(j)
     &             + phi*( (Gamma(i)*Delta(j)+Delta(i)*Gamma(j))/dd
     &                   - gd*Delta(i)*Delta(j)/dd**2 )
         End Do
      End Do
*
      If (iPrint.ge.99)
     &   Call RecPrt(' MSP: Updated Hessian',' ',B,nDim,nDim)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Bd)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_GetMaxShl(DiaSh,Smax,iShlAB)
!
! Purpose: get max shell pair and update DiaSh.

use Cholesky, only: Cho_Real_Par
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: DiaSh(*)
real(kind=wp), intent(out) :: Smax
integer(kind=iwp), intent(out) :: iShlAB

if (Cho_Real_Par) then
  ! Swap local and global reduced set index arrays and use original
  ! serial routine to get max shell pair.
  call Cho_P_IndxSwp()
  call Cho_GetMaxShl(DiaSh,Smax,iShlAB)
  call Cho_P_IndxSwp()
else
  call Cho_GetMaxShl(DiaSh,Smax,iShlAB)
end if

end subroutine Cho_P_GetMaxShl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_eval_waxy(irc,ipScr,ipChoV1,ipChoV2,ipInt,nAorb,
     &                         JSYM,NUMV,DoTraInt)

      Implicit Real*8 (a-h,o-z)
      Integer ipChoV1(*),ipChoV2(*),ipInt,nAorb(*)
      Integer ipScr(8,8)
      Integer off_PWXY(8,8,8),ISTSQ(8)
      Logical DoTraInt

      parameter (zero = 0.0D0, one = 1.0D0)

#include "Molcas.fh"
#include "WrkSpc.fh"
#include "general.fh"
#include "wadr.fh"

C ************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
C ************************************************


      If (NumV .lt. 1) Return

C --- Computing the integrals
C ---------------------------------------------------------
C --- (wa|xy)  <-  (wa|xy)  +  sum_J  L(wa,#J) * L(xy,#J)
C==========================================================

      Do iSymy=1,nSym

         iSymx=MulD2h(iSymy,JSYM)

         Nxy  = nAorb(iSymx)*nAorb(iSymy)
     &        + Min(0,JSYM-2)*nAorb(iSymx)*(nAorb(iSymy)-1)/2

         If (iSymx.le.iSymy.and.Nxy.gt.0) then

            Do iSyma=1,nSym

               iSymw=MulD2h(iSyma,JSYM)

               Nwa  = nAorb(iSymw)*nBas(iSyma)

               If (Nwa.gt.0) then

                  CALL DGEMM_('N','T',Nwa,Nxy,NumV,
     &                       ONE,Work(ipChoV1(iSymw)),Nwa,
     &                       WORK(ipChoV2(iSymx)),Nxy,ONE,
     &                       Work(ipScr(iSymw,iSymx)),Nwa)


               End If

            End Do

         End If

      End Do


C --- MO-transformation to build the (pw|xy) integrals
C --- is performed (p is a general index).
C --- The storage of the result is the one required by
C --- the RASSCF program : LT-storage in xy, with sym(x)<=sym(y)
C ---
C ---       (pw|xy)  =  sum_a  C(a,p) * (wa|xy)
C ---
C ------------------------------------------------------------
      IF (DoTraInt) THEN

*
*     generate offsets to (pw|xy)
*
*     Important: the way GET_TUVX is written requires
*                a strict loop structure for the definition
*                of the offsets
*
         iStack = 0
         Do iSymp = 1,nSym
            iOrb = nOrb(iSymp)
            Do iSymw = 1,nSym
               jAsh = nAorb(iSymw)
               ijSym=MulD2h(iSymp,iSymw)
               Do iSymy = 1,nSym
                 kAsh = nAorb(iSymy)
                 iSymx=MulD2h(ijSym,iSymy)
                 If (iSymx.le.iSymy) Then
                  lAsh = nAorb(iSymx)
                   kl_Orb_pairs = kAsh*lAsh
     &                          + Min(0,ijSym-2)*kAsh*(lAsh-1)/2
                   off_PWXY(iSymp,iSymw,iSymx)=iStack
                   iStack = iStack + iOrb*jAsh*kl_Orb_pairs
                 End If
               End Do
            End Do
         End Do
         nPWXY=iStack
*
*
*   Offsets to the MOs coefficients
*
         ISTSQ(1)=0
         Do iSym=2,nSym
            ISTSQ(iSym) = ISTSQ(iSym-1) + nBas(iSym-1)**2
         End Do
*
*   Reordering and MO-transformation
*
*
         Do iSymy=1,nSym

            iSymx=MulD2h(iSymy,JSYM)

            If (iSymx.le.iSymy) then

               Nxy  = nAorb(iSymx)*nAorb(iSymy)
     &              + Min(0,JSYM-2)*nAorb(iSymx)*(nAorb(iSymy)-1)/2


               Do iSymw=1,nSym

                  iSyma = MulD2h(iSymw,JSYM) ! =iSymp

                  Nwa = nAorb(iSymw)*nBas(iSyma)
                  Npw = nOrb(iSyma)*nAorb(iSymw)

                  ipMS = ipCM + ISTSQ(iSyma) + nBas(iSyma)*nFro(iSyma)

                  Do ixy = 1,Nxy

                        ipMwa = ipScr(iSymw,iSymx) + Nwa*(ixy-1)

                        ipMpw = ipInt + off_PWXY(iSyma,iSymw,iSymx)
     &                        + Npw*(ixy-1)

C --------------------------------------------------------
C ---       M(p,w)[xy]  =  sum_a  C(a,p) * M(w,a)[xy]
C --------------------------------------------------------
                        nBas_a = max(nBas(iSyma),1)
                        nAob_w = max(nAorb(iSymw),1)
                        nOrb_a = max(nOrb(iSyma),1)

                        CALL DGEMM_('T','T',nOrb(iSyma),nAorb(iSymw),
     &                             nBas(iSyma),ONE,Work(ipMS),
     &                             nBas_a,Work(ipMwa),nAob_w,
     &                             ZERO,Work(ipMpw),nOrb_a)


                  End Do

               End Do

            End If

         End Do


      ENDIF



      irc=0

      Return
      END

**************************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SBLOCK(  NBLOCK,  IBLOCK,   IBOFF,      CB,     HCB,
     &                       LUC,IRESTRICT, LUCBLK,ICBAT_RES,ICBAT_INI,
     &                  ICBAT_END)
*
* Generate a set of sigma blocks,
* The NBLOCK specified in IBLOCK starting from IBOFF,
* be more specific.
*
* The blocks are delivered in HCB
*
* The blocks are scaled and reformed to combination order
* If LUCBLK.GT.0, the blocks of C corresponding to IBLOCK
* are stored on LUCBLK
*
* ICONSPA,ICONSPB  added October 1996
* ICBAT_RES, ICBAT_INI, IBBAT_END added august 1997
*
* If ICBAT_RES .eq.1 then it as assumed that only
* Cbatches ICBAT_INI to ICBAT_END are stored on  LUC
*
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
*
* =====
*.Input
* =====
*
*.Definition of c and sigma spaces
      COMMON/CANDS/ICSM,ISSM,ICSPC,ISSPC
*. Sigma blocks require
      INTEGER IBLOCK(8,*)
*
*./ORBINP/ : NACOB used
#include "orbinp.fh"
#include "cicisp.fh"
#include "strbas.fh"
#include "cstate.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "csm.fh"
#include "WrkSpc.fh"
#include "crun.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "lucinp.fh"
#include "cprnt.fh"
#include "glbbas.fh"
#include "oper.fh"
#include "io_util.fh"
*
      INTEGER ADASX,ASXAD,ADSXA,SXSXDX,SXDXSX
      COMMON/CSMPRD/ADASX(MXPOBS,MXPOBS),ASXAD(MXPOBS,2*MXPOBS),
     &              ADSXA(MXPOBS,2*MXPOBS),
     &              SXSXDX(2*MXPOBS,2*MXPOBS),SXDXSX(2*MXPOBS,4*MXPOBS)
      COMMON/HIDSCR/KLOCSTR(4),KLREO(4),KLZ(4),KLZSCR
#include "cintfo.fh"
      DIMENSION CB(*),HCB(*)
*
      IDUM = 0
*     CALL MEMMAN(IDUM,IDUM,'MARK  ',IDUM,'SBLOCK')
*
C?    WRITE(6,*) ' IPERTOP in SBLOCK = ', IPERTOP
      NTEST = 00
      IF(NTEST.GE.5)
     &WRITE(6,*) ' SBLOCK : ISSPC,ICSPC ', ISSPC,ICSPC
C?    WRITE(6,*) ' LUC in SBLOCK ', LUC
C?    WRITE(6,*) ' I12 in SBLOCK = ', I12
      IF(LUCBLK.GT.0) THEN
        IDISK(LUCBLK)=0
      END IF
*
* Info for this internal space
*. type of alpha and beta strings
      IATP = 1
      IBTP = 2
*. alpha and beta strings with an electron removed
      IATPM1 = 3
      IBTPM1 = 4
*. alpha and beta strings with two electrons removed
      IATPM2 = 5
      IBTPM2 = 6
*
*. Number of supergroups
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*. Offset for supergroups
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
*
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
*
*. connection matrices for supergroups
*
      CALL GETMEM('CONSPA','ALLO','INTE',KCONSPA,NOCTPA**2)
      CALL GETMEM('CONSPB','ALLO','INTE',KCONSPB,NOCTPB**2)
C     SPGRPCON(IOFSPGRP,NSPGRP,NGAS,MXPNGAS,IELFSPGRP,ISPGRPCON,IPRNT)
      CALL SPGRPCON(   IOCTPA,   NOCTPA,     NGAS,  MXPNGAS, NELFSPGP,
     &              iWORK(KCONSPA),IPRCIX)
      CALL SPGRPCON(   IOCTPB,   NOCTPB,     NGAS,  MXPNGAS, NELFSPGP,
     &              iWORK(KCONSPB),IPRCIX)
*
* string sym, string sym => sx sym
* string sym, string sym => dx sym
      CALL GETMEM('KSTSTS','ALLO','INTE',KSTSTS,NSMST ** 2)
      CALL GETMEM('KSTSTD','ALLO','INTE',KSTSTD,NSMST ** 2)
      CALL STSTSM(iWORK(KSTSTS),iWORK(KSTSTD),NSMST)
*. Largest block of strings in zero order space
      MXSTBL0 = MXNSTR
*. Largest number of strings of given symmetry and type
      MAXA = 0
      MAXA0 = IMNMX(iWORK(KNSTSO(IATP)),NSMST*NOCTYP(IATP),2)
      MAXA = MAX(MAXA,MAXA0)
      IF(NAEL.GE.1) THEN
        MAXA1 = IMNMX(iWORK(KNSTSO(IATPM1)),NSMST*NOCTYP(IATPM1),2)
        MAXA = MAX(MAXA,MAXA1)
      END IF
      IF(NAEL.GE.2) THEN
        MAXA1 = IMNMX(iWORK(KNSTSO(IATPM2)),NSMST*NOCTYP(IATPM2),2)
        MAXA = MAX(MAXA,MAXA1)
      END IF
*
      MAXB = 0
      MAXB0 = IMNMX(iWORK(KNSTSO(IBTP)),NSMST*NOCTYP(IBTP),2)
      MAXB = MAX(MAXB,MAXB0)
      IF(NBEL.GE.1) THEN
        MAXB1 = IMNMX(iWORK(KNSTSO(IBTPM1)),NSMST*NOCTYP(IBTPM1),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      IF(NBEL.GE.2) THEN
        MAXB1 = IMNMX(iWORK(KNSTSO(IBTPM2)),NSMST*NOCTYP(IBTPM2),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      MXSTBL = MAX(MAXA,MAXB)
      IF(IPRCIX.GE.3 ) WRITE(6,*)
     &' Largest block of strings with given symmetry and type',MXSTBL
*. Largest number of resolution strings and spectator strings
*  that can be treated simultaneously
      MAXI = MIN( MXINKA,MXSTBL)
      MAXK = MIN( MXINKA,MXSTBL)
*Largest active orbital block belonging to given type and symmetry
      MXTSOB = 0
      DO IOBTP = 1, NGAS
      DO IOBSM = 1, NSMOB
       MXTSOB = MAX(MXTSOB,NOBPTS(IOBTP,IOBSM))
      END DO
      END DO
C?    WRITE(6,*) ' MXTSOB = ', MXTSOB
      MAXIJ = MXTSOB ** 2
*.Local scratch arrays for blocks of C and sigma
c      IF(ISIMSYM.EQ.0) THEN
        LSCR1 = MXSOOB
c      ELSE
c        LSCR1 = MXSOOB_AS
c      END IF
      LSCR1 = MAX(LSCR1,LCSBLK)
      IF(IPRCIX.GE.3)
     &WRITE(6,*) ' ICISTR,LSCR1 ',ICISTR,LSCR1
*.SCRATCH space for integrals
* A 4 index integral block with four indeces belonging OS class
      INTSCR = MAX(MXTSOB ** 4, NTOOB**2)
      IF(IPRCIX.GE.3)
     &WRITE(6,*) ' Integral scratch space ',INTSCR
      CALL GETMEM('INSCR ','ALLO','REAL',KINSCR,INTSCR)
      CALL GETMEM('INSCR2','ALLO','REAL',KINSCR2,INTSCR)
*. Arrays giving allowed type combinations '
      CALL GETMEM('CIOIO ','ALLO','INTE',KCIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('SIOIO ','ALLO','INTE',KSIOIO,NOCTPA*NOCTPB)
*. Offsets for alpha and beta supergroups
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
*. sigma needed for MXRESC
      CALL IAIBCM(ISSPC,iWORK(KSIOIO))
      CALL IAIBCM(ICSPC,iWORK(KCIOIO))
*. Arrays giving block type
      CALL GETMEM('CBLTP ','ALLO','INTE',KCBLTP,NSMST)
*. Arrays for additional symmetry operation
c      IF(IDC.EQ.3.OR.IDC.EQ.4) THEN
c        CALL MEMMAN(KSVST,NSMST,'ADDL  ',2,'SVST  ')
c        CALL SIGVST(WORK(KSVST),NSMST)
c      ELSE
         KSVST = 1
c      END IF
*
*.scratch space for projected matrices and a CI block
*
*. Scratch space for CJKAIB resolution matrices
*. Size of C(Ka,Jb,j),C(Ka,KB,ij)  resolution matrices
      IF( ISSPC.GE.ICSPC) THEN
         KSCIOIO = KSIOIO
      ELSE
         KSCIOIO = KCIOIO
      END IF
      CALL MXRESCPH(iWORK(KSCIOIO),IOCTPA, IOCTPB,  NOCTPA,  NOCTPB,
     &                  NSMST,NSTFSMSPGP,MXPNSMST,   NSMOB, MXPNGAS,
     &                   NGAS,   NOBPTS,   IPRCIX,   MAXK, NELFSPGP,
     &                   MXCJ,   MXCIJA,   MXCIJB,MXCIJAB,   MXSXBL,
     &               MXADKBLK,   IPHGAS, NHLFSPGP,   MNHL,  IADVICE,
     &              MXCJ_ALLSYM,MXADKBLK_AS,MX_NSPII)
      IF(IPRCIX.GE.3) THEN
        WRITE(6,*) 'SBLOCK : MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXCJ_ALLSYM',
     &                       MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXCJ_ALLSYM
         WRITE(6,*) 'SBLOCK : MXADKBLK ', MXADKBLK
         WRITE(6,*) ' MX_NSPII = ', MX_NSPII
      END IF
*. For hardwired routines MXCIJAB is also used
      LSCR2 = MAX(MXCJ,MXCIJA,MXCIJB,MXCIJAB,MX_NSPII)
      IF(IPRCIX.GE.3)
     &WRITE(6,*) ' Space for resolution matrices ',LSCR2
*
      IF(IPRCIX.GE.3)  WRITE(6,*) ' LSCR2 = ', LSCR2
C  I assume memory was allocated for blocks, so
      KC2 = KVEC3
*
      KCJRES = KC2
      KSIRES = KC2 + LSCR2
*
      KSSCR = KSIRES
      KCSCR = KCJRES
*
*.vectors able to hold strings of given sym and type
      MAXIK = MAX(MAXI,MAXK)
*. I1 and Xi1s must also be able to hold largest st block
      LSCR3 = MAX(MXADKBLK,MAXIK*MXTSOB*MXTSOB,MXSTBL0)
      CALL GETMEM('I1    ','ALLO','INTE',KI1  ,LSCR3)
      CALL GETMEM('XI1S  ','ALLO','REAL',KXI1S,LSCR3)
      CALL GETMEM('I2    ','ALLO','INTE',KI2  ,LSCR3)
      CALL GETMEM('XI2S  ','ALLO','REAL',KXI2S,LSCR3)
      CALL GETMEM('I3    ','ALLO','INTE',KI3  ,LSCR3)
      CALL GETMEM('XI3S  ','ALLO','REAL',KXI3S,LSCR3)
      CALL GETMEM('I4    ','ALLO','INTE',KI4  ,LSCR3)
      CALL GETMEM('XI4S  ','ALLO','REAL',KXI4S,LSCR3)
      CALL ZBLTP(ISMOST(1,ICSM),NSMST,IDC,iWORK(KCBLTP),iWORK(KSVST))
*.Some TTS arrays
      NOOS = NOCTPA*NOCTPB*NSMCI
      NTTS = MXNTTS
*
*. for partitioning of vector
      CALL GETMEM('LBTC  ','ALLO','INTE',KLLBT ,NTTS  )
      CALL GETMEM('LECTC ','ALLO','INTE',KLLEBT,NTTS  )
      CALL GETMEM('I1BTC ','ALLO','INTE',KLI1BT,NTTS  )
      CALL GETMEM('IBTC  ','ALLO','INTE',KLIBT ,8*NTTS)
*. For scaling for each TTS block
      CALL GETMEM('SCLFAC','ALLO','REAL',KLSCLFAC ,NTTS)

*. Space for four blocks of string occupations and arrays of
*. reordering arrays
*. Also used to hold an NORB*NORB matrix
      LZSCR = (MAX(NAEL,NBEL)+3)*(NOCOB+1) + 2 * NOCOB + NOCOB*NOCOB
      LZ    = (MAX(NAEL,NBEL)+2) * NOCOB
*. Set up to two blocks for orbital conserving operator
C     DO I1234 = 1, 2
      CALL GETMEM('KLOCS ','ALLO','INTE',KLOCSTR(1),MAX_STR_OC_BLK)
      DO I1234 = 1, 2
        CALL GETMEM('KLREO ','ALLO','INTE',KLREO(I1234),MAX_STR_SPGP)
        CALL GETMEM('KLZ   ','ALLO','INTE',KLZ(I1234),LZ)
      END DO
      CALL GETMEM('KLZSCR','ALLO','INTE',KLZSCR,LZSCR)
* 4 arrays containing all strings of given sym. Dimension can  be
*   reduced to largest number of strings in alpha or beta.
C?    WRITE(6,*) ' SBLOCKS : MAX_STR_SPGP = ', MAX_STR_SPGP
*
      IF(I12.EQ.2) THEN
        IDOH2 = 1
      ELSE
        IDOH2 = 0
      END IF
*. Place perturbation integrals over one body integrals
CINSERT_START
      IF(I12.EQ.2) THEN
        IDOH2 = 1
      ELSE
        IDOH2 = 0
      END IF
*
*. Prepare for perturbation calculation
*
C     IF(IPERTOP.NE.0) THEN
*. Matrix specifying partiotioned spaces
      CALL GETMEM('H0SPC ','ALLO','INTE',KLH0SPC,NOCTPA*NOCTPB)
      CALL H0INTSPC(   IH0SPC,   NPTSPC, IOCPTSPC,   NOCTPA,   NOCTPB,
     &                ISPGPFTP(1,IOCTPA),ISPGPFTP(1,IOCTPB),
     &                   NGAS,MXPNGAS,iWORK(KLH0SPC),NELFGP)
C       IF(IH0SPC.EQ.0) THEN
*. Form of perturbation in subspace has not been defined,
*. Use current IPART
          IH0INSPC(1) = IPART
C       END IF
C     END IF
*
* Jesper: Initializing ksvst
c      KCJPA = 1 ! jwk-cleanup
c      KSIPA = 1 ! jwk-cleanup
      CALL SBLOCKS(NBLOCK,IBLOCK(1,IBOFF),CB,HCB,WORK(KC2),
     &             iWORK(KCIOIO),ISMOST(1,ICSM),iWORK(KCBLTP),
     &             iWORK(KNSTSO(IATP)),iWORK(KNSTSO(IBTP)),
     &             NAEL,IATP,NBEL,IBTP,
     &             IOCTPA,IOCTPB,NOCTPA,NOCTPB,
     &             NSMST,NSMOB,NSMSX,NSMDX,NOBPTS,IOBPTS,MXPNGAS,
     &             ITSOB,MAXK,MAXI,LSCR1,
     &             WORK(KINSCR),WORK(KCSCR),WORK(KSSCR),
     &             iWORK(KSTSTS),iWORK(KSTSTD),SXDXSX,
     &             ADSXA,NGAS,NELFSPGP,IDC,
     &             iWORK(KI1),WORK(KXI1S),iWORK(KI2),WORK(KXI2S),
     &             IDOH2,MXPOBS,iWORK(KSVST),
     &             PSSIGN,IPRDIA,LUC,ICJKAIB,
     &             WORK(KCJRES),WORK(KSIRES),
     &             iWORK(KI3),WORK(KXI3S),iWORK(KI4),WORK(KXI4S),
     &             MXSXST,MXSXBL,MOCAA,
     &             iWORK(KLLBT),iWORK(KLLEBT),
     &             iWORK(KLI1BT),iWORK(KLIBT),
     &             IRESTRICT,
     &             iWORK(KCONSPA),iWORK(KCONSPB),WORK(KLSCLFAC),
     &             IPERTOP,IH0INSPC,iWORK(KLH0SPC),
     &             ICBAT_RES,ICBAT_INI,ICBAT_END,IUSE_PH,IPHGAS,
     &             I_RES_AB,ISIMSYM,WORK(KINSCR2))
*
* CALL SBLOCKS --> 91
*
*
      IF(IDC.EQ.2) THEN
*. reform
        CALL RFTTS(HCB,CB,IBLOCK(1,IBOFF),NBLOCK,1,NSMST,
     &             iWORK(KNSTSO(IATP)),iWORK(KNSTSO(IBTP)),
     &             IDC,PSSIGN,1,NTEST)
*. scale
        CALL SCDTTS(HCB,IBLOCK(1,IBOFF),NBLOCK, NSMST,
     &              iWORK(KNSTSO(IATP)),iWORK(KNSTSO(IBTP)),
     &              IDC,1,NTEST)
      END IF
*
      IF(LUCBLK.GT.0) THEN
        CALL ITODS([-1],1,-1,LUCBLK)
      END IF
*. Eliminate local memory
      IDUM = 0
*     CALL MEMMAN(IDUM ,IDUM,'FLUSM ',2,'SBLOCK')
      CALL GETMEM('CONSPA','FREE','INTE',KCONSPA,NOCTPA**2)
      CALL GETMEM('CONSPB','FREE','INTE',KCONSPB,NOCTPB**2)
      CALL GETMEM('KSTSTS','FREE','INTE',KSTSTS,NSMST ** 2)
      CALL GETMEM('KSTSTD','FREE','INTE',KSTSTD,NSMST ** 2)
      CALL GETMEM('INSCR ','FREE','REAL',KINSCR,INTSCR)
      CALL GETMEM('INSCR2','FREE','REAL',KINSCR2,INTSCR)
      CALL GETMEM('CIOIO ','FREE','INTE',KCIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('SIOIO ','FREE','INTE',KSIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('CBLTP ','FREE','INTE',KCBLTP,NSMST)
      CALL GETMEM('I1    ','FREE','INTE',KI1  ,LSCR3)
      CALL GETMEM('XI1S  ','FREE','REAL',KXI1S,LSCR3)
      CALL GETMEM('I2    ','FREE','INTE',KI2  ,LSCR3)
      CALL GETMEM('XI2S  ','FREE','REAL',KXI2S,LSCR3)
      CALL GETMEM('I3    ','FREE','INTE',KI3  ,LSCR3)
      CALL GETMEM('XI3S  ','FREE','REAL',KXI3S,LSCR3)
      CALL GETMEM('I4    ','FREE','INTE',KI4  ,LSCR3)
      CALL GETMEM('XI4S  ','FREE','REAL',KXI4S,LSCR3)
      CALL GETMEM('SCLFAC','FREE','REAL',KLSCLFAC ,NTTS)
      CALL GETMEM('LBTC  ','FREE','INTE',KLLBT ,NTTS  )
      CALL GETMEM('LECTC ','FREE','INTE',KLLEBT,NTTS  )
      CALL GETMEM('I1BTC ','FREE','INTE',KLI1BT,NTTS  )
      CALL GETMEM('IBTC  ','FREE','INTE',KLIBT ,8*NTTS)
      CALL GETMEM('KLOCS ','FREE','INTE',KLOCSTR(1),MAX_STR_OC_BLK)
      DO I1234 = 1, 2
        CALL GETMEM('KLREO ','FREE','INTE',KLREO(I1234),MAX_STR_SPGP)
        CALL GETMEM('KLZ   ','FREE','INTE',KLZ(I1234),LZ)
      END DO
      CALL GETMEM('KLZSCR','FREE','INTE',KLZSCR,LZSCR)
      CALL GETMEM('H0SPC ','FREE','INTE',KLH0SPC,NOCTPA*NOCTPB)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine OptOneAngle(Angle,SumVee,RotMat,DDg,I1,I2,lRoots)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Three, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: Angle, SumVee
integer(kind=iwp), intent(in) :: I1, I2, lRoots
real(kind=wp), intent(inout) :: RotMat(lRoots,lRoots)
real(kind=wp), intent(in) :: DDg(lRoots,lRoots,lRoots,lRoots)
integer(kind=iwp) :: IA, IMax, Iter, IterMax
real(kind=wp) :: StepSize, SumOld
logical(kind=iwp) :: Converged
real(kind=wp) :: Angles(4), ScanA(31), ScanS(31), Sums(4)
real(kind=wp), allocatable :: RTmp(:,:)
real(kind=wp), parameter :: Threshold = 1.0e-8_wp
real(kind=wp), external :: CalcNSumVee

call mma_allocate(RTmp,lRoots,lRoots)

Converged = .false.
stepsize = Three*deg2rad

!write(u6,'(A,2(I2,2X))') 'scanning rotation angles for ',I1,I2
Angles(2) = Zero
do Iter=1,31
  ScanA(Iter) = (Iter-16)*stepsize*2
  RTmp(:,:) = RotMat(:,:)
  call CMSMatRot(RTmp,ScanA(Iter),I1,I2,lRoots)
  ScanS(Iter) = CalcNSumVee(RTmp,DDg)
  !if (I2 == 1) write(u6,*) Iter,ScanA(Iter),ScanS(Iter)
end do

IMax = sum(maxloc(ScanS(:)))

Iter = 0
IterMax = 100
SumOld = ScanS(IMax)
Angles(2) = ScanA(IMax)
do while (.not. Converged)
  Iter = Iter+1
  Angles(1) = Angles(2)-stepsize
  Angles(3) = Angles(2)+stepsize
  do iA=1,3
    RTmp(:,:) = RotMat(:,:)
    call CMSMatRot(RTmp,Angles(iA),I1,I2,lRoots)
    Sums(iA) = CalcNSumVee(RTmp,DDg)
  end do
  call CMSFitTrigonometric(Angles,Sums)
  RTmp(:,:) = RotMat(:,:)
  call CMSMatRot(RTmp,Angles(4),I1,I2,lRoots)
  Sums(4) = CalcNSumVee(RTmp,DDg)
  if (abs(Sums(4)-SumOld) < Threshold) then
    Converged = .true.
    Angle = Angles(4)
    call CMSMatRot(RotMat,Angle,I1,I2,lRoots)
    SumVee = CalcNSumVee(RotMat,DDg)
    !write(u6,'(A,I3,A)') 'Convergence reached after ',Iter,' micro cycles'
  else
    if (Iter == IterMax) then
      Converged = .true.
      write(u6,'(A,I3,A)') 'No convergence reached after ',Iter,' micro cycles'
    else
      Angles(2) = Angles(4)
      SumOld = Sums(4)
    end if
  end if
end do
call mma_deallocate(RTmp)

end subroutine OptOneAngle

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT_QK42(T2,T1a,T1b,dima,dimb,no,f1,f2)
! this routine does:
! T2(a',b',i,j) <- f1 . T2(a',b',i,j) + f2 . T1a(a,i) . T1b(b,j)
!
! N.B. Kvajt odflaknute

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, no
real(kind=wp), intent(inout) :: T2(dima,dimb,no,no)
real(kind=wp), intent(in) :: T1a(dima,no), T1b(dimb,no), f1, f2
integer(kind=iwp) :: b, j

do j=1,no
  do b=1,dimb
    T2(:,b,:,j) = f1*T2(:,b,:,j)+f2*T1a(:,:)*T1b(j,b)
  end do
end do

return

end subroutine MkT_QK42

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHO_VTRA(irc,scr,lscr,jVref,JVEC1,JNUM,NUMV,JSYM,IREDC,
     &                   iSwap,nDen,kDen,MOs,ChoT)

*********************************************************
*   Author: F. Aquilante
*
*   Purpose:  SCR(lscr) contains JNUM cholesky vectors
*             starting from JVEC1 and stored in reduced
*             sets. The routine performs an MOs half transformation
*             of these elements in a set of target
*             arrays, ChoT, identified the data type SBA_Type.
*             In the target arrays, the vectors are
*             stored in full dimension and as a
*             subset of a a given NUMV number of vectors.
*
*   Input:
*       jVref =  index of the first vector to be transformed
*                computed wrt to the first vector in the
*                target arrays (see calling routine)
*
*       Jvec1 =  first vector to be transformed
*       JNum  =  # of vectors to be transformed
*
*       NumV  =  total # of vectors in the target arrays
*
*       nDen  =  total # of densities to which MOs refer
*       kDen  =  first density to be treated
*
*       iSwap :   = 0   L(k,b,J) is returned
*                 = 1   L(a,k,J) is returned
*                 = 2   L(k,J,b) is returned
*                 = 3   L(a,J,k) is returned
*
*       IREDC :  reduced set in core at the moment of
*                the first call to the routine.
*                Can be set to -1 by the calling routine
*
*********************************************************
      use ChoArr, only: nDimRS, iRS2F
      use ChoSwp, only: InfVec, IndRed
      use Data_Structures, only: DSBA_Type, SBA_Type
      Implicit Real*8 (a-h,o-z)

      Integer irc, nDen,kDen,lScr
      Real*8  Scr(lscr)
      Type (DSBA_Type) MOs(nDen)
      Type (SBA_Type) ChoT(nDen)

      Integer, External:: cho_isao

      Character(Len=8), Parameter:: SECNAM = 'CHO_VTRA'

      Real*8::  Fac(0:1)=[0.5D0,1.0D0]

#include "cholesky.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"

      Integer, Allocatable:: nPorb(:,:)
      Logical Skip3, Skip2, Skip1

*                                                                      *
************************************************************************
*                                                                      *
      Interface
      Subroutine daxpy_(n,da,dx,incx,dy,incy)
      implicit none
      real*8 :: da
      integer :: incx,incy,n
      real*8 :: dx(*),dy(*)
      End Subroutine daxpy_
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
      Skip1(jDen,iSyma)=.NOT.Associated(ChoT(jDen)%SB(iSyma)%A1)
      Skip2(jDen,iSyma)=.NOT.Associated(ChoT(jDen)%SB(iSyma)%A2)
      Skip3(jDen,iSyma)=.NOT.Associated(ChoT(jDen)%SB(iSyma)%A3)
************************************************************************

      Call mma_allocate(nPorb,8,nDen,Label='nPorb')
      Do iDen = 1, nDen
        Do iSym = 1, nSym
          nPorb(iSym,iDen)=SIZE(MOs(iDen)%SB(iSym)%A2,1)
        End Do
      End Do

**********************************************************
C
C    From Reduced sets to half-MOs full storage
C    ------------------------------------------
C
C    iSwap = 0
C
C     L{a,b,J} ---> L(p,b,J)   ! stride-1 transformation
C
C    iSwap = 1
C
C     L{a,b,J} ---> L(a,q,J)
C
C    iSwap = 2
C
C     L{a,b,J} ---> L(p,J,b)   ! stride-1 transformation
C
C    iSwap = 3
C
C     L{a,b,J} ---> L(a,J,q)
**********************************************************

      iLoc = 3 ! use scratch location in reduced index arrays

*                                                                      *
************************************************************************
*                                                                      *
      Select Case (iSwap)
*                                                                      *
************************************************************************
*                                                                      *
      Case (0)
*                                                                      *
************************************************************************
*                                                                      *
         NREAD = 0
         DO JVEC=1,JNUM   ! Relative index in the JNUM batch

            LVEC = JVEC - 1 + JVREF  ! Relative index in the NUMV batch
            kVEC = JVEC - 1 + JVEC1  ! Absolute index
            JRED = InfVec(KVEC,2,jSym)

            IF (JRED .NE. IREDC) THEN ! JRED is not the rs in core
               Call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
               IREDC = JRED
            END IF

            kscr = NREAD
            NREAD= NREAD + nDimRS(jSym,JRED)

            IF (JSYM.eq.1) THEN  ! L(a,b,J)=L(b,a,J); only a.ge.b presnt

               Do jRab=1,nnBstR(jSym,iLoc)

                  kRab = iiBstr(jSym,iLoc) + jRab
                  iRab = IndRed(kRab,iLoc)

                  iag   = iRS2F(1,iRab)  !global address
                  ibg   = iRS2F(2,iRab)

                  iSyma = cho_isao(iag) !symmetry block; S(b)=S(a)=S(p)

                  kscr  = kscr + 1


                  ias   = iag - ibas(iSyma) !address within that sym
                  ibs   = ibg - ibas(iSyma)
                  xfd   = Fac(min(abs(ias-ibs),1)) !fac for diag
C
C     L(p,b,J) = sum_a  xfd* L(a,b,J) * C(p,a)
C     ----------------------------------------
                  DO jDen=kDen,nDen

                     If (skip3(jDen,iSyma)) Cycle

                     ! C(1,b)
                     CALL DAXPY_(nPorb(iSyma,jDen),xfd*Scr(kscr),
     &                           MOs(JDen)%SB(iSyma)%A2(:,ibs),1,
     &                          ChoT(jDen)%SB(iSyma)%A3(:,ias,LVEC),1)

                     ! C(1,a)
                     CALL DAXPY_(nPorb(iSyma,jDen),xfd*Scr(kscr),
     &                           MOs(JDen)%SB(iSyma)%A2(:,ias),1,
     &                          ChoT(jDen)%SB(iSyma)%A3(:,ibs,LVEC),1)

                  END DO  ! loop over densities

               End Do  ! jRab loop

            ELSE  ! jSym.ne.1

               Do jRab=1,nnBstR(jSym,iLoc)

                  kRab = iiBstr(jSym,iLoc) + jRab
                  iRab = IndRed(kRab,iLoc)

                  iag   = iRS2F(1,iRab)  !global address
                  ibg   = iRS2F(2,iRab)

                  iSyma = cho_isao(iag)  !symmetry block
                  iSymb = muld2h(jSym,iSyma)

                  kscr  = kscr + 1

                  ias   = iag - ibas(iSyma)  !address within that sym
                  ibs   = ibg - ibas(iSymb)

C
C     L(p,b,J) = sum_a  L(a,b,J) * C(p,a)
C     -----------------------------------
                  DO jDen=kDen,nDen

                     If (skip3(jDen,iSyma)) Cycle

                     CALL DAXPY_(nPorb(iSyma,jDen),Scr(kscr),
     &                           MOs(jDen)%SB(iSyma)%A2(:,ias),1,
     &                          ChoT(jDen)%SB(iSyma)%A3(:,ibs,LVEC),1)

                  END DO

C
C     L(p,a,J) = sum_b  L(a,b,J) * C(p,b)
C     -----------------------------------
                  DO jDen=kDen,nDen

                     If (skip3(jDen,iSymb)) Cycle

                     CALL DAXPY_(nPorb(iSymb,jDen),Scr(kscr),
     &                           MOs(jDen)%SB(iSymb)%A2(:,ibs),1,
     &                          ChoT(jDen)%SB(iSymb)%A3(:,ias,LVEC),1)

                  END DO

               End Do  ! jRab loop

            ENDIF ! total symmetric vectors check

         END DO
*                                                                      *
************************************************************************
*                                                                      *
      Case (1)
*                                                                      *
************************************************************************
*                                                                      *
      NREAD = 0
      DO JVEC=1,JNUM

         LVEC = JVEC - 1 + JVREF
         kVEC = JVEC - 1 + JVEC1  ! Absolute index
         JRED = InfVec(KVEC,2,jSym)

         IF (JRED .NE. IREDC) THEN ! JRED is not the reduced set in core
            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            IREDC = JRED
         END IF

         kscr = NREAD
         NREAD= NREAD + nDimRS(jSym,JRED)

        IF (JSYM.eq.1) THEN  ! L(a,b,J)=L(b,a,J); only a.ge.b present

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)=Sym(p)

            kscr  = kscr + 1

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            xfd   = Fac(min(abs(ias-ibs),1)) !fac for diagonal elements
C
C     L(a,p,J) = sum_b  xfd* L(a,b,J) * C(p,b)
C     ----------------------------------------
            DO jDen=kDen,nDen

               If (skip2(jDen,iSyma)) Cycle

               iE = SIZE(ChoT(jDen)%SB(iSyma)%A2,1)
               CALL DAXPY_(nPorb(iSyma,jDen),xfd*Scr(kscr),
     &                     MOs(jDen)%SB(iSyma)%A2(:,ibs),1,
     &                ChoT(jDen)%SB(iSyma)%A2(ias:iE,LVEC),nBas(iSyma))

               CALL DAXPY_(nPorb(iSyma,jDen),xfd*Scr(kscr),
     &                     MOs(jDen)%SB(iSyma)%A2(:,ias),1,
     &                ChoT(jDen)%SB(iSyma)%A2(ibs:iE,LVEC),nBas(iSyma))

            END DO  ! loop over densities

         End Do  ! jRab loop

        ELSE  ! jSym.ne.1

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block
            iSymb = muld2h(jSym,iSyma)

            kscr  = kscr + 1

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSymb)
C
C     L(a,q,J) = sum_b  L(a,b,J) * C(q,b)
C     -----------------------------------
             DO jDen=kDen,nDen

               If (skip2(jDen,iSyma)) Cycle

               iE = SIZE(ChoT(jDen)%SB(iSyma)%A2,1)
               CALL DAXPY_(nPorb(iSymb,jDen),Scr(kscr),
     &                     MOs(jDen)%SB(iSymb)%A2(:,ibs),1,
     &                ChoT(jDen)%SB(iSyma)%A2(ias:iE,LVEC),nBas(iSyma))

             END DO
C
C     L(b,q,J) = sum_a  L(a,b,J) * C(q,a)
C     -----------------------------------
             DO jDen=kDen,nDen

               If (skip2(jDen,iSymb)) Cycle

               iE = SIZE(ChoT(jDen)%SB(iSymb)%A2,1)
               CALL DAXPY_(nPorb(iSyma,jDen),Scr(kscr),
     &                     MOs(jDen)%SB(iSyma)%A2(:,ias),1,
     &                ChoT(jDen)%SB(iSymb)%A2(ibs:iE,LVEC),nBas(iSyma))

             END DO

         End Do  ! jRab loop

        ENDIF ! total symmetric vectors check

      END DO
*                                                                      *
************************************************************************
*                                                                      *
      Case (2)
*                                                                      *
************************************************************************
*                                                                      *
             NREAD = 0
             DO JVEC=1,JNUM

                LVEC = JVEC - 1 + JVREF
                kVEC = JVEC - 1 + JVEC1  ! Absolute index
                JRED = InfVec(KVEC,2,jSym)

                IF (JRED .NE. IREDC) THEN
                   Call Cho_X_SetRed(irc,iLoc,JRED)
                   IREDC = JRED
                END IF

             kscr = NREAD
             NREAD= NREAD + nDimRS(jSym,JRED)

             IF (JSYM.eq.1) THEN  ! L(a,b,J)=L(b,a,J); only a.ge.b

                Do jRab=1,nnBstR(jSym,iLoc)

                   kRab = iiBstr(jSym,iLoc) + jRab
                   iRab = IndRed(kRab,iLoc)

                   iag   = iRS2F(1,iRab)  !global address
                   ibg   = iRS2F(2,iRab)

                   iSyma = cho_isao(iag)

                   kscr  = kscr + 1


                   ias   = iag - ibas(iSyma)
                   ibs   = ibg - ibas(iSyma)
                   xfd   = Fac(min(abs(ias-ibs),1))
C
C     L(p,J,b) = sum_a  xfd* L(a,b,J) * C(p,a)
C     ----------------------------------------
                   DO jDen=kDen,nDen

                      If (skip3(jDen,iSyma)) Cycle

                      CALL DAXPY_(nPorb(iSyma,jDen),xfd*Scr(kscr),
     &                            MOs(jDen)%SB(iSyma)%A2(:,ibs),1,
     &                          ChoT(jDen)%SB(iSyma)%A3(:,LVEC,ias),1)

                      CALL DAXPY_(nPorb(iSyma,jDen),xfd*Scr(kscr),
     &                            MOs(jDen)%SB(iSyma)%A2(:,ias),1,
     &                          ChoT(jDen)%SB(iSyma)%A3(:,LVEC,ibs),1)

                   END DO  ! loop over densities

                End Do  ! jRab loop

             ELSE  ! jSym.ne.1

                Do jRab=1,nnBstR(jSym,iLoc)

                   kRab = iiBstr(jSym,iLoc) + jRab
                   iRab = IndRed(kRab,iLoc)

                   iag   = iRS2F(1,iRab)  !global address
                   ibg   = iRS2F(2,iRab)

                   iSyma = cho_isao(iag)  !symmetry block
                   iSymb = muld2h(jSym,iSyma)  !(syma>symb)

                   kscr  = kscr + 1

                   ias   = iag - ibas(iSyma)
                   ibs   = ibg - ibas(iSymb)
C
C     L(p,J,b) = sum_a  L(a,b,J) * C(p,a)
C     -----------------------------------
                   DO jDen=kDen,nDen

                      If (skip3(jDen,iSyma)) Cycle

                      CALL DAXPY_(nPorb(iSyma,jDen),Scr(kscr),
     &                            MOs(jDen)%SB(iSyma)%A2(:,ias),1,
     &                          ChoT(jDen)%SB(iSyma)%A3(:,LVEC,ibs),1)

                   END DO
C
C     L(p,J,a) = sum_b  L(a,b,J) * C(p,b)
C     -----------------------------------
                   DO jDen=kDen,nDen

                      If (skip3(jDen,iSymb)) Cycle

                      CALL DAXPY_(nPorb(iSymb,jDen),Scr(kscr),
     &                            MOs(jDen)%SB(iSymb)%A2(:,ibs),1,
     &                          ChoT(jDen)%SB(iSymb)%A3(:,LVEC,ias),1)

                   END DO

                End Do  ! jRab loop

              ENDIF ! total symmetric vectors check

           END DO
*                                                                      *
************************************************************************
*                                                                      *
      Case (3)
*                                                                      *
************************************************************************
*                                                                      *
      NREAD = 0
      DO JVEC=1,JNUM

         LVEC = JVEC - 1 + JVREF
         KVEC = JVEC - 1 + JVEC1  ! Absolute index
         JRED = InfVec(KVEC,2,jSym)

         IF (JRED .NE. IREDC) THEN ! JRED is not the reduced set in core
            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            IREDC = JRED
         END IF

         kscr = NREAD
         NREAD= NREAD + nDimRS(jSym,JRED)

        IF (JSYM.eq.1) THEN  ! L(a,b,J)=L(b,a,J); only a.ge.b present

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)=Sym(p)

            kscr  = kscr + 1

            ias   = iag - ibas(iSyma)  !address within that sym block
            ibs   = ibg - ibas(iSyma)
            xfd   = Fac(min(abs(ias-ibs),1)) !scale fac for diag
C
C     L(a,J,p) = sum_b  xfd* L(a,b,J) * C(p,b)
C     ----------------------------------------
            DO jDen=kDen,nDen

               If (skip1(jDen,iSyma)) Cycle

               n1 = SIZE(ChoT(jDen)%SB(iSyma)%A3,1)
               ij= ias + n1*(LVEC-1)
               CALL DAXPY_(nPorb(iSyma,jDen),xfd*Scr(kscr),
     &                     MOs(jDen)%SB(iSyma)%A2(:,ibs),1,
     &                     ChoT(jDen)%SB(iSyma)%A1(ij:),
     &                     nBas(iSyma)*NUMV)

               ij= ibs + n1*(LVEC-1)
               CALL DAXPY_(nPorb(iSyma,jDen),xfd*Scr(kscr),
     &                     MOs(jDen)%SB(iSyma)%A2(:,ias),1,
     &                     ChoT(jDen)%SB(iSyma)%A1(ij:),
     &                     nBas(iSyma)*NUMV)

            END DO  ! loop over densities

         End Do  ! jRab loop

        ELSE  ! jSym.ne.1

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block
            iSymb = muld2h(jSym,iSyma)

            kscr  = kscr + 1

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSymb)
C
C     L(a,J,q) = sum_b  L(a,b,J) * C(q,b)
C     -----------------------------------
             DO jDen=kDen,nDen

               If (skip1(jDen,iSyma)) Cycle

               n1 = SIZE(ChoT(jDen)%SB(iSyma)%A3,1)
               ij= ias + n1*(LVEC-1)
               CALL DAXPY_(nPorb(iSymb,jDen),Scr(kscr),
     &                     MOs(jDen)%SB(iSymb)%A2(:,ibs),1,
     &                     ChoT(jDen)%SB(iSyma)%A1(ij:),
     &                     nBas(iSyma)*NUMV)

             END DO
C
C     L(b,J,q) = sum_a  L(a,b,J) * C(q,a)
C     -----------------------------------
             DO jDen=kDen,nDen

               If (skip1(jDen,iSyma)) Cycle

               n1 = SIZE(ChoT(jDen)%SB(iSymb)%A3,1)
               ij= ibs + n1*(LVEC-1)
               CALL DAXPY_(nPorb(iSyma,jDen),Scr(kscr),
     &                     MOs(jDen)%SB(iSyma)%A2(:,ias),1,
     &                     ChoT(jDen)%SB(iSymb)%A1(ij:),
     &                     nBas(iSyma)*NUMV)

             END DO

         End Do  ! jRab loop

        ENDIF ! total symmetric vectors check

      END DO
*                                                                      *
************************************************************************
*                                                                      *
      Case Default
*                                                                      *
************************************************************************
*                                                                      *
         write(6,*)SECNAM//': invalid argument. Iswap= ',Iswap
         irc = 66
         Return

      End Select
*     ENDIF  ! iSwap check

      Call mma_deallocate(nPorb)
      irc=0

      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GS(drdq,nLambda,T,nInter,Swap,RD)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: nLambda
integer(kind=iwp), intent(in) :: nInter
real(kind=wp), intent(inout) :: drdq(nInter,nLambda)
real(kind=wp), intent(out) :: T(nInter,nInter)
logical(kind=iwp), intent(in) :: Swap, RD
integer(kind=iwp) :: i, iInter, iLambda, iStart, j, jLambda
real(kind=wp) :: XX
real(kind=wp), allocatable :: Temp(:,:)
real(kind=wp), parameter :: Thr = 1.0e-12_wp ! Be careful here so that noise is not converted to a basis!
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_

#ifdef _DEBUGPRINT_
call RecPrt('GS: dRdQ',' ',drdq,nInter,nLambda)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Initial check to see if the dRdQ vectors are independent.

call mma_Allocate(Temp,nInter,nLambda,Label='Temp')
Temp(:,:) = drdq(:,:)
call GS_(drdq,nInter,nLambda,Thr)
jLambda = 0
do i=1,nLambda
  XX = sqrt(DDot_(nInter,drdq(:,i),1,drdq(:,i),1))
  !write(u6,*) 'i,XX=',i,XX
  if (XX > Thr) then
    jLambda = jLambda+1
    ! RD = remove degeneracies
    if (RD .and. (jLambda /= i)) drdq(:,jLambda) = drdq(:,i)
  end if
end do
#ifdef _DEBUGPRINT_
call RecPrt('GS: dRdQ(orth)',' ',drdq,nInter,nLambda)
#endif
if ((.not. RD) .and. (jLambda /= nLambda)) then
  write(u6,*) ' Constraints are linear dependent!'
  call Abend()
end if
nLambda = jLambda
!                                                                      *
!***********************************************************************
!                                                                      *
! Project away the space which is spanned by the constraints.

call unitmat(T,nInter)
#ifdef _DEBUGPRINT_
call RecPrt('T(orig)',' ',T,nInter,nInter)
#endif

! Form 1 - P

do iLambda=1,nLambda
  do iInter=1,nInter
    T(:,iInter) = T(:,iInter)-drdq(:,iLambda)*drdq(iInter,iLambda)
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('1-P',' ',T,nInter,nInter)
#endif

! Orthonormalize

call GS_(T,nInter,nInter,Thr)

! Set the trailing vectors to null vectors.
! We might have noise here.

if (nLambda /= 0) then
  iStart = nInter-nLambda+1
  T(:,iStart:) = Zero
end if
#ifdef _DEBUGPRINT_
call RecPrt('1-P(GS)',' ',T,nInter,nInter)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Restore dRdQ

if (.not. RD) drdq(:,:) = Temp
call mma_deallocate(Temp)
!                                                                      *
!***********************************************************************
!                                                                      *
! Reorder, place the null vectors at the start.

j = nInter
do i=nInter,1,-1
  XX = DDot_(nInter,T(:,i),1,T(:,i),1)
  if (XX > Zero) then
    if (i /= j) T(:,j) = T(:,i)
    j = j-1
  end if
end do

! Put drdq at the start

T(:,1:nLambda) = drdq(:,1:nLambda)
#ifdef _DEBUGPRINT_
call RecPrt('T(ReOrdered)',' ',T,nInter,nInter)
#endif

!call GS_(T,nInter,nInter,Thr)
if (Swap) call dswap_(nInter,T(:,1),1,T(:,3),1)

return

end subroutine GS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine dbl_space_loop_g()
#include "drt_h.fh"
      if(norb_dbl.eq.0) return
      call dbl_space_loop_ijkk_sgezero_g()
      call dbl_space_loop_ijkl_sgezero_g()
      return
      end

      subroutine dbl_space_loop_ijkk_sgezero_g()
#include "drt_h.fh"
#include "intsort_h.fh"
      data dzero/0.d0/
c =============================  g1,2,4,6,7,8 ==========================
c       zz=' doub_800_v'
      dzero=0.0d0
      db=jb_sys
      im=ns_sm
      jpds0=im+17
      do lri=norb_frz+1,norb_dz-1
      !  mi=lsm_inn(lri)
        iwdl=just(lri,lri)         !drr(03)-drr(30)
        do lrj=lri+1,norb_dz
c          wl=voint(lrj,lri)          ! vdint(itailorb,iheadorb)
c           wl=1.0d0
c===================================
c  drr-drr
c  wl=2.0d0 but not 1.0d0 is based on that the non-diagonal just uses th
c  non-triangle <ci|h|cj> which designates that i > j. drr-drr
c

            wl=2.0d0
          iwdr=just(lrj,lrj)
          call trans_ijkl_intpos(lrj,lri,lrj,lri,nxo)
          call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
        enddo
      enddo
      if(jb_sys.gt.0) then
!     drl(12)-drl(21)
        vlp_1=-sqrt(db*(db+2))/(db+1)
        do lri=norb_frz+1,norb_dz
          lmi=lsm_inn(lri)
          do lrj=lri+1,norb_dz
            lmj=lsm_inn(lrj)
            lmij=mul_tab(lmi,lmj)
            jpds=17+mul_tab(lmij,ns_sm)
            iwdl=just(lrj,lri)
            iwdr=just(lri,lrj)
c           wl=-vlp_1*voint(lrj,lri)
            wl=-vlp_1*2.0d0
c          write(nf2,*) 'wl=',wl
            call trans_ijkl_intpos(lrj,lri,lrj,lri,nxo)
            call prodab_2(1,0,jpds,iwdl,iwdr,0,wl,0,nxo)
          enddo
        enddo
      endif

      do 200 lri=norb_frz+1,norb_dz-1           !frz
        imi=lsm_inn(lri)
c       n2=ngw2(lri-2)
        do 201 lrj=lri+1,norb_dz
          mij=mul_tab(imi,lsm_inn(lrj))
          if(mij.ne.1) goto 201
          ni=mod(lrj-lri,2)
c=============== down comm for 2 4 =====================================
          vl_0=sqrt((db+2)/(db+1))
         vl_1=sqrt(db/(db+1))
          if(ni.eq.0)     vl_0=-vl_0
          if(ni.eq.0)     vl_1=-vl_1
          vl0_2=1.0d0
          vls0_2=1/(db+1)
          vls10_2=sqrt(db*(db+2))/(db+1)
      !    if(ni.eq.1)vl0_2=-vl0_2
          vls0=-0.5d0
          vls1=(db+3)/(2*db+2)
          vls1_a=(db-1)/(2*db+2)
          vls_c=db/(db+1)
          vlt0=-0.5d0
          vlt1=-0.5d0
          vls10_2b=sqrt(db*(db+2))/(db+1)
          if(ni.eq.1) then
           vl0_2=-vl0_2
            vls0_2=-vls0_2
            vls10_2=-vls10_2
            vls_c=-vls_c
          endif
          if(ni.eq.0) then
           vls0=-vls0
            vls1=-vls1
            vls1_a=-vls1_a
            vls10_2b=-vls10_2b
            vlt0=-vlt0
            vlt1=-vlt1
          endif
!        wl0=dzero
!         wl10=dzero
! for 2,4 the common
! ar(23)-c"(33)-ar(10) ar(13)-c"(33)-ar(20)
! ar(23)-drl(33)-ar(10)  ar(13)-drl(33)-ar(20)    310
c======================
! for 2 the common


c          wltmp=dzero
         do lr=lri+1,lrj-1
c           list =list3(lri,lrj,lr)
c           wltmp=wltmp+2*vint_ci(list+1)-vint_ci(list)
!          wl0 =wl0 +vlt0*(2*vint_ci(list+1)-vint_ci(list))
!          wl10=wl10+vlt1*(2*vint_ci(list+1)-vint_ci(list))
!           wl0=wl0+vl0_1*(2*vint_ci(list+1)-vint_ci(list)) !310:neoc=2,
          iwdl=just(lri,lrj)
          iwdr=just(lrj,lrj)
            wl=vl_0*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_0
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          if(jb_sys.gt.0) then
           iwdl=just(lrj,lri)
            wl=vl_1*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_1
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          endif

          enddo
c         wl0 =vl_0*wltmp
c         wl10=vl_1*wltmp
!     neoc(k)*wg43*(vint(list+2)+coe(k)*vint(list+1))
!    drl(33)-bl(23)-ar(10)
!    drl(33)-bl(13)-ar(20)
c          wltmp=dzero

          do lr=1,lri-1
c           list =list3(lri,lrj,lr)
c            wltmp=wltmp+2*vint_ci(list+1)-vint_ci(list) ! 430 w0=-vl0 w
          iwdl=just(lri,lrj)
          iwdr=just(lrj,lrj)
            wl=vl_0*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_0
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           if(jb_sys.gt.0) then
           iwdl=just(lrj,lri)
            wl=vl_1*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_1
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           endif

          enddo
c        wl0 =wl0+vl_0*wltmp
c        wl10=wl10+vl_1*wltmp
!    ar(23)-bl(10)-drl(33)
!    ar(13)-bl(20)-drl(33)
c          wltmp=dzero

          do lr=lrj+1,norb_dz
c           list =list3(lri,lrj,lr)
c            wltmp=wltmp+2*vint_ci(list+1)-vint_ci(list)  ! 220 w0=-vl0
          iwdl=just(lri,lrj)
          iwdr=just(lrj,lrj)
            wl=vl_0*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_0
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           if(jb_sys.gt.0) then
           iwdl=just(lrj,lri)
            wl=vl_1*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_1
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           endif

          enddo
c======================
! for 4 the common

c          wltmp=dzero
         do lr=lri+1,lrj-1
c           list =list3(lri,lrj,lr)
c           wltmp=wltmp+2*vint_ci(list+1)-vint_ci(list)
!          wl0 =wl0 +vlt0*(2*vint_ci(list+1)-vint_ci(list))
!          wl10=wl10+vlt1*(2*vint_ci(list+1)-vint_ci(list))
!           wl0=wl0+vl0_1*(2*vint_ci(list+1)-vint_ci(list)) !310:neoc=2,
          iwdl=just(lri,lri)
          iwdr=just(lri,lrj)
            wl=vl_0*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_0
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          if(jb_sys.gt.0) then
           iwdr=just(lrj,lri)
            wl=vl_1*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_1
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
          endif

          enddo
c         wl0 =vl_0*wltmp
c         wl10=vl_1*wltmp
!     neoc(k)*wg43*(vint(list+2)+coe(k)*vint(list+1))
!    drl(33)-bl(23)-ar(10)
!    drl(33)-bl(13)-ar(20)
c          wltmp=dzero

          do lr=1,lri-1
c           list =list3(lri,lrj,lr)
c            wltmp=wltmp+2*vint_ci(list+1)-vint_ci(list) ! 430 w0=-vl0 w
          iwdl=just(lri,lri)
          iwdr=just(lri,lrj)
            wl=vl_0*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_0
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           if(jb_sys.gt.0) then
           iwdr=just(lrj,lri)
            wl=vl_1*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_1
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           endif

          enddo
c        wl0 =wl0+vl_0*wltmp
c        wl10=wl10+vl_1*wltmp
!    ar(23)-bl(10)-drl(33)
!    ar(13)-bl(20)-drl(33)
c          wltmp=dzero


          do lr=lrj+1,norb_dz
c           list =list3(lri,lrj,lr)
c            wltmp=wltmp+2*vint_ci(list+1)-vint_ci(list)  ! 220 w0=-vl0
          iwdl=just(lri,lri)
          iwdr=just(lri,lrj)
            wl=vl_0*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_0
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           if(jb_sys.gt.0) then
           iwdr=just(lrj,lri)
            wl=vl_1*2
            call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
            wl=-vl_1
            call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           endif

          enddo


c        wl0 =wl0+vl_0*wltmp
c        wl10=wl10+vl_1*wltmp
c=============== start comm for 2 4 ====================================
          do 300 lrm=norb_frz+1,norb_dz        !ic=1,norb_act   !frz
           imm=lsm_inn(lrm)
            im=mul_tab(imm,imi)
            im=mul_tab(im,ns_sm)
           kij=0
            if(lrm.eq.lrj) kij=2
            if(lrm.eq.lri) kij=4
            if(lrm.lt.lri) kij=7
            if(lrm.gt.lrj) kij=6
            if(lrm.gt.lri.and.lrm.lt.lrj) kij=8
            goto(300,2,300,4,300,6,7,8),kij
!ss(1-c1)  ar(23)-ar(10)-    ar(13)-ar(20)
2           iwdl=just(lri,lrj)
            iwdr=just(lrj,lrj)
c           list =list3(lri,lrj,lri)
c            wl=wl0+vl_0*(voint(lri,lrj)+vint_ci(list))
            wl=vl_0
            call prodab_1(1,0,jpds0,iwdl,iwdr,0,wl,0,lri,lrj)
            call trans_ijkl_intpos(lrj,lri,lri,lri,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)

          if(jb_sys.gt.0) then
c           wl=wl10+vl_1*(voint(lri,lrj)+vint_ci(list))
            iwdl=just(lrj,lri)
            wl=vl_1
            call prodab_1(1,0,jpds0,iwdl,iwdr,0,wl,0,lri,lrj)
            call trans_ijkl_intpos(lrj,lri,lri,lri,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)

          endif
           goto 300
!ss(1-c2)  ar(02)-ar(31)    ar(01)-ar(32)
4           iwdl=just(lri,lri)
            iwdr=just(lri,lrj)
c           list =list3(lri,lrj,lrj)
c            wl=wl0+vl_0*(voint(lri,lrj)+vint_ci(list))
            wl=vl_0
            call prodab_1(1,0,jpds0,iwdl,iwdr,0,wl,0,lri,lrj)
            call trans_ijkl_intpos(lrj,lrj,lri,lrj,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)

          if(jb_sys.gt.0) then
           iwdr=just(lrj,lri)
c            wl=wl10+vl_1*(voint(lri,lrj)+vint_ci(list))
            wl=vl_1
            call prodab_1(1,0,jpds0,iwdl,iwdr,0,wl,0,lri,lrj)
            call trans_ijkl_intpos(lrj,lrj,lri,lrj,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)

          endif
           goto 300
!        ar(23)-br(13)-drr(30)  w0=-sqrt((db+2)/(db+1)) w1=0
!        ar(13)-br(23)-drr(30)  w0=-sqrt(db/(db+1)) w1=0
6            iwdl=just(lri,lrj)
             iwdr=just(lrm,lrm)
c            list =list3(lri,lrj,lrm)
c            wl=-vl_0*vint_ci(list)
             wl=-vl_0
            call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           if(jb_sys.gt.0) then
            iwdl=just(lrj,lri)
c           wl=-vl_1*vint_ci(list)
             wl=-vl_1
            call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           endif
            goto 300
!           drr(03)br(32)br(31)   w0=-sqrt((db+2)/(db+1)) w1=0
!          drr(03)br(31)br(32)   w0=-sqrt(db/(db+1)) w1=0
7            iwdl=just(lrm,lrm)
             iwdr=just(lri,lrj)
c            list =list3(lri,lrj,lrm)
c            wl =-vl_0*vint_ci(list)
             wl =-vl_0
            call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
             call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           if(jb_sys.gt.0) then
            iwdr=just(lrj,lri)
             iwdl=just(lrm,lrm)
c           wl =-vl_1*vint_ci(list)
             wl =-vl_1
            call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
             call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           endif
            goto 300
!  ar(23)-drl(30)-al(13)   w0=sqrt((db+2)/(db+1)) w1=0
!  ar(13)-drl(30)-al(23)   w0=sqrt(db/(db+1)) w1=0
8            iwdl=just(lri,lrj)
             iwdr=just(lrm,lrm)
c            list =list3(lri,lrj,lrm)
c            wl =-vl_0*vint_ci(list)
             wl =-vl_0
            call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
             call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           if(jb_sys.gt.0) then
!  ar(13)-drl(30)-al(23)   w0=sqrt(db/(db+1)) w1=0
            iwdl=just(lrj,lri)
c           wl =-vl_1*vint_ci(list)
             wl =-vl_1
            call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
            call prodab_2(1,0,jpds0,iwdl,iwdr,0,wl,0,nxo)
           endif
c=============== start  d9(ss) d35(tt) =================================
             jpds=17+im
             jpdt=9+im
             jpdt1=jpdt+24
c           iwls=just(lri,lrm)
c             iwrs=just(lrm,lrj)
c            iwlt=iwls
c             iwrt=iwrs
!t    ar(23)-c'(22)-cw(33)-ar(32)   w0=1 w1=0
!t    ar(13)-c'(11)-cw(33)-ar(31)   w0=1 w1=0
!s    ar(23)-c'(12)-cw(33)-ar(31)   w0=-1/(db+1) w1=0
!s    ar(23)-c'(11)-cw(33)-ar(32)   w0=-sqrt(db*(db+2))/(db+1) w1=0
!s    ar(13)-c'(21)-cw(33)-ar(32)   w0=1/(db+1) w1=0
!s    ar(13)-c'(22)-cw(33)-ar(31)   w0=-sqrt(db*(db+2))/(db+1) w1=0
c             wlt0=dzero
c            wls0=dzero
c            wls0_1=dzero                   ! bbs_tmp
c            wls0_2=dzero
c             wltmp=dzero
      do lr=lrm+1,lrj-1
c               list=list3(lri,lrj,lr)
c               wltmp=wltmp+2*vint_ci(list+1)-vint_ci(list)
!         wlt0=wlt0+vl0_2*(2*vint_ci(list+1)-vint_ci(list))
            iwls=just(lri,lrm)
             iwrs=just(lrm,lrj)
             iwlt=iwls
             iwrt=iwrs
               wlt_1=vl0_2*2
               wls_1=-vls0_2*2
               wls1_1=-vls10_2*2
               wls2_1=vls0_2*2
               wlt_2=-vl0_2
               wls_2=vls0_2
               wls1_2=vls10_2
               wls2_2=-vls0_2
             call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
             nxo_1=nxo
             call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
             nxo_2=nxo

             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lri,lrm)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrm,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
             endif
            if(jb_sys.gt.1) then
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
             endif

      enddo
c            wlt0=wlt0+vl0_2*wltmp
c            wls0=wls0-vls0_2*wltmp
c            wls0_1=wls0_1-vls10_2*wltmp
c            wls0_2=wls0_2+vls0_2*wltmp
!       wls2=wls0
!t    ar(23)-cw(33)-c'(22)-ar(32)      w0=1 w1=0
!t    ar(13)-cw(33)-c'(11)-ar(31)      w0=1 w1=0
!s    ar(23)-cw(33)-c'(12)-ar(31)      w0=-1/(db+1) w1=0
!s    ar(23)-cw(33)-c'(11)-ar(32)      w0=-sqrt(db*(db+2))/(db+1) w1=0
!s    ar(13)-cw(33)-c'(21)-ar(32)      w0=1/(db+1) w1=0
!s    ar(13)-cw(33)-c'(22)-ar(31)      w0=-sqrt(db*(db+2))/(db+1) w1=0


c            wltmp=dzero
      do lr=lri+1,lrm-1
c               list=list3(lri,lrj,lr)
            iwls=just(lri,lrm)
             iwrs=just(lrm,lrj)
             iwlt=iwls
             iwrt=iwrs
c               wltmp=wltmp+2*vint_ci(list+1)-vint_ci(list)
!         wlt0=wlt0+vl0_2*(2*vint_ci(list+1)-vint_ci(list))
               wlt_1=vl0_2*2
               wls_1=-vls0_2*2
               wls1_1=-vls10_2*2
               wls2_1=vls0_2*2
               wlt_2=-vl0_2
               wls_2=vls0_2
               wls1_2=vls10_2
               wls2_2=-vls0_2
             call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
             nxo_1=nxo
             call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
             nxo_2=nxo

             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lri,lrm)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrm,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
             endif
            if(jb_sys.gt.1) then
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
             endif

      enddo

c            wlt0=wlt0+vl0_2*wltmp
c            wls0=wls0-vls0_2*wltmp
c            wls0_1=wls0_1-vls10_2*wltmp
c            wls0_2=wls0_2+vls0_2*wltmp
!t    drl(33)-bl(23)-c'(22)-ar(32) w0=-1 w1=0
!t    drl(33)-bl(13)-c'(11)-ar(31) w0=-1 w1=0
!s    drl(33)-bl(23)-c'(12)-ar(31) w0=1/(db+1)  w1=0
!s    drl(33)-bl(23)-c'(11)-ar(32) w0=sqrt(db*(db+2))/(db+1) w1=0
!s    drl(33)-bl(13)-c'(21)-ar(32) w0=-1/(db+1)  w1=0
!s    drl(33)-bl(13)-c'(22)-ar(31) w0=sqrt(db*(db+2))/(db+1)   w1=0


c            wltmp=dzero
      do lr=1,lri-1
c               list=list3(lri,lrj,lr)
c               wltmp=wltmp+(vint_ci(list)-2*vint_ci(list+1))
            iwls=just(lri,lrm)
             iwrs=just(lrm,lrj)
             iwlt=iwls
             iwrt=iwrs
               wlt_1=vl0_2*2
               wls_1=-vls0_2*2
               wls1_1=-vls10_2*2
               wls2_1=vls0_2*2
               wlt_2=-vl0_2
               wls_2=vls0_2
               wls1_2=vls10_2
               wls2_2=-vls0_2
             call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
             nxo_1=nxo
             call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
             nxo_2=nxo

             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lri,lrm)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrm,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
             endif
            if(jb_sys.gt.1) then
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
             endif

      enddo

c            wlt0=wlt0-vl0_2*wltmp                  !bbs_tmp
c            wls0=wls0+vls0_2*wltmp
c            wls0_1=wls0_1+vls10_2*wltmp
c            wls0_2=wls0_2-vls0_2*wltmp
!t    ar(23)-c'(22)-bl(32)-drl(33) w0=-1 w1=0
!t    ar(13)-c'(11)-bl(31)-drl(33) w0=-1 w1=0
!s    ar(23)-c'(12)-br(31)-drl(33) w0=1/(db+1)  w1=0
!s    ar(23)-c'(11)-br(32)-drl(33) w0=sqrt(db*(db+2))/(db+1) w1=0
!s    ar(13)-c'(21)-br(32)-drl(33) w0=-1/(db+1)  w1=0
!s    ar(13)-c'(22)-br(31)-drl(33) w0=sqrt(db*(db+2))/(db+1) w1=0


c            wltmp=dzero
      do lr=lrj+1,norb_dz
c                list=list3(lri,lrj,lr)
c               wltmp=wltmp+(vint_ci(list)-2*vint_ci(list+1))
            iwls=just(lri,lrm)
             iwrs=just(lrm,lrj)
             iwlt=iwls
             iwrt=iwrs
               wlt_1=vl0_2*2
               wls_1=-vls0_2*2
               wls1_1=-vls10_2*2
               wls2_1=vls0_2*2
               wlt_2=-vl0_2
               wls_2=vls0_2
               wls1_2=vls10_2
               wls2_2=-vls0_2
             call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
             nxo_1=nxo
             call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
             nxo_2=nxo

             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lri,lrm)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrm,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
             endif
            if(jb_sys.gt.1) then
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
             endif

      enddo

!            wlt0=wlt0+vl0_2*wltmp
!            wls0=wls0-vls0_2*wltmp
!            wls0_1=wls0_1+vls10_2*wltmp
!            wls0_2=wls0_2+vls0_2*wltmp
c            wlt0=wlt0-vl0_2*wltmp
c            wls0=wls0+vls0_2*wltmp
c            wls0_1=wls0_1+vls10_2*wltmp
c            wls0_2=wls0_2-vls0_2*wltmp
      !       wls0=-wlt0
c=============== up comm for 9 35 ======================================
!t   ar(23)-c'(22)-arw(32) w0=1 w1=0
!t   ar(13)-c'(11)-arw(31) w0=1 w1=0
!s   ar(23)-c'(12)-arw(31) w0=-1/(db+1)  w1=0
!s   ar(23)-c'(11)-arw(31) w0=-sqrt(db*(db+2))/(db+1) w1=0
!s   ar(13)-c'(21)-arw(32) w0=1/(db+1)  w1=0
!s   ar(13)-c'(22)-arw(31) w0=-sqrt(db*(db+2))/(db+1) w1=0
!             list=list3(lri,lrj,lrj)
!             wlt=wlt0+vl0_2*vint_ci(list)
!             wls=wls0-vl0_2*vint_ci(list)
c             list=list3(lri,lrj,lrj)
c             wlt=wlt0+vl0_2*vint_ci(list)
c             wls=wls0-vls0_2*vint_ci(list)
c            wls1=wls0_1-vls10_2*vint_ci(list)
c             wls2=wls0_2+vls0_2*vint_ci(list)
            iwls=just(lri,lrm)
             iwrs=just(lrm,lrj)
             iwlt=iwls
             iwrt=iwrs
               wlt=vl0_2
               wls=-vls0_2
               wls1=-vls10_2
             wls2=vls0_2
             call trans_ijkl_intpos(lrj,lrj,lri,lrj,nxo)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls,0,nxo)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt,0,nxo)
             if(jb_sys.gt.0) then
               iwls=just(lri,lrm)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo)
               iwls=just(lrm,lri)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2,0,nxo)
               iwls=just(lrm,lri)
               iwrs=just(lrm,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo)
             endif
            if(jb_sys.gt.1) then
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt,0,nxo)    !bbs_tm
             endif



!     wl_bbs=-vls0_2*vint_ci(list)
!t   ar(23)-cw(22)-ar(32)
!t   ar(13)-cw(11)-ar(31)
!s   ar(23)-cw(12)-ar(31)    w0=-1/(db+1)    ar(12)-drr(22)-ar(32)
!s   ar(23)-cw(11)-ar(32)    w0=-sqrt(db*(db+1))/(db+1)
!s   ar(13)-cw(21)-ar(32)    w0=1/(db+1)
!s   ar(13)-cw(22)-ar(31)  w0=-sqrt(db*(db+1))/(db+1)
c             list=list3(lri,lrj,lrm)

c             wlt=wlt+vl0_2*vint_ci(list+1)
c             wls=wls-vls0_2*(vint_ci(list+1)-(db+2)*vint_ci(list)) !coe
c            wls1=wls1-vls10_2*(vint_ci(list+1)-vint_ci(list))  !coe=-1
c           wls2=wls2+vls0_2*(vint_ci(list+1)+db*vint_ci(list)) !coe=db
            iwls=just(lri,lrm)
             iwrs=just(lrm,lrj)
             iwlt=iwls
             iwrt=iwrs
               wlt=vl0_2
               wls_1=-vls0_2
               wls1_1=-vls10_2
               wls2_1=vls0_2
             call trans_ijkl_intpos(lrj,lri,lrm,lrm,nxo)
             nxo_1=nxo
               wls_2=vls0_2*(db+2)
               wls1_2=vls10_2
               wls2_2=vls0_2*db
             call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
             nxo_2=nxo

             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt,0,nxo_1)
             if(jb_sys.gt.0) then
               iwls=just(lri,lrm)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrj,lrm)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
               iwls=just(lrm,lri)
               iwrs=just(lrm,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
             endif
c---------------------------------
c lyb
             if(jb_sys.gt.1) then
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt,0,nxo_1)
             endif

!             wls2=wls2+vls0_2*(vint_ci(list+1)-2*vint_ci(list))
!     wl_bbs=wl_bbs-vls0_2*(vint_ci(list+1)-2*vint_ci(list))
!t   arw(23)-c'(22)-ar(32)
!t   arw(13)-c'(11)-ar(31)
!s   arw(23)-c'(12)-ar(31)
!s   arw(23)-c'(11)-ar(32)
!s   arw(13)-c'(21)-ar(32)
!s   arw(13)-c'(22)-ar(31)
!t   ar(23)-c'(22)-ar(32)    w0=1
!t   ar(13)-c'(11)-ar(31)    w0=1
!s   ar(23)-c'(12)-ar(31)   w0=-1/(db+1)  w1=0
!s   ar(23)-c'(11)-ar(32)   w0=-sqrt(db*(db+2))/(db+1) w1=0
!s   ar(13)-c'(21)-ar(32)   w0=1/(db+1)  w1=0
!s   ar(13)-c'(22)-ar(31)   w0=-sqrt(db*(db+2))/(db+1) w1=0
c             list=list3(lri,lrj,lri)
c             wlt=wlt+vl0_2*(voint(lri,lrj)+ vint_ci(list))
c             wls=wls-vls0_2*(voint(lri,lrj)+ vint_ci(list))
c            wls1=wls1-vls10_2*(voint(lri,lrj)+ vint_ci(list))
c             wls2=wls2+vls0_2*(voint(lri,lrj)+ vint_ci(list))
!     wl_bbs=wl_bbs-vls0_2*(voint(lri,lrj)+ vint_ci(list))
            iwls=just(lri,lrm)
             iwrs=just(lrm,lrj)
             iwlt=iwls
             iwrt=iwrs
               wlt=vl0_2
               wls=-vls0_2
               wls1=-vls10_2
               wls2=vls0_2
             call trans_ijkl_intpos(lrj,lri,lri,lri,nxo)

!ar(23)-drr(12)-ar(31)  w0=(db+2)/(db+1)   ???? complete
             call prodab_1(1,0,jpds,iwls,iwrs,0,wls,0,lri,lrj)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls,0,nxo)
             call prodab_1(1,0,jpdt,iwlt,iwrt,0,wlt,0,lri,lrj)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt,0,nxo)
             if(jb_sys.gt.0) then
               iwls=just(lri,lrm)
               iwrs=just(lrj,lrm)
               call prodab_1(1,0,jpds,iwls,iwrs,0,wls1,0,lri,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo)
               iwls=just(lrm,lri)
               iwrs=just(lrj,lrm)
               call prodab_1(1,0,jpds,iwls,iwrs,0,wls2,0,lri,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2,0,nxo)
               iwls=just(lrm,lri)
               iwrs=just(lrm,lrj)
               call prodab_1(1,0,jpds,iwls,iwrs,0,wls1,0,lri,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo)
             endif
            if(jb_sys.gt.1) then
               call prodab_1(1,0,jpdt1,iwlt,iwrt,0,wlt,0,lri,lrj)
               call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt,0,nxo)
             endif

300        continue
c=============== start  d10_ss(dd,ss,tt)  ==============================
!   ar(23)-drr(33)-ar(32)  ar(23)-cw(33)-ar(23)
!   ar(13)-drr(33)-ar(31)  ar(13)-cw(33)-ar(13) w0=1 w1=0
!      if(lri.eq.2.and.lrj.eq.4) then
!       write(6,*) "bbs_tmp err"
!     endif


c          wl0=dzero
c           wltmp=dzero
      do lrm=lri+1,lrj-1
c             list=list3(lri,lrj,lrm)
c             wltmp=wltmp+(2*vint_ci(list+1)-vint_ci(list))
           wl0_1=-vl0_2*2
           wl0_2=vl0_2
           call trans_ijkl_intpos(lrj,lri,lrm,lrm,nxo)
           nxo_1=nxo
           call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
           nxo_2=nxo

           im=mul_tab(lsm_inn(lri),ns_sm)    !!!
           jpdd=1+im
          iwld=jud(lri)
           iwrd=jud(lrj)
           call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
           call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)

           if(jb_sys.gt.0) then
            jpdd=jpdd+24
             call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)
          endif
           do lr=lrj+1,norb_dz
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lri,lr)
             iwrs=just(lrj,lr)
             iwlt=iwls             !
             iwrt=iwrs             !
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lr,lri)
               iwrs=just(lr,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
            endif
             if(jb_sys.gt.1) then
               jpdt=jpdt+24
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
             endif
           enddo


            do lr=norb_frz+1,lri-1
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lr,lri)
             iwrs=just(lr,lrj)
             iwlt=iwls
             iwrt=iwrs
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lri,lr)
               iwrs=just(lrj,lr)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
             endif
             if(jb_sys.gt.1) then
               jpat=jpdt+24
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_2,0,nxo_2)
             endif
           enddo
      enddo
c          wl0 =wl0-vl0_2*wltmp

!   drl(33)-bl(23)-ar(32)
!   drl(33)-bl(13)-ar(31)
c          wltmp=dzero
      do lrm=1,lri-1
c             list=list3(lri,lrj,lrm)
c             wltmp=wltmp+(vint_ci(list)-2*vint_ci(list+1))
           wl0_1=-vl0_2*2
           wl0_2=vl0_2
           call trans_ijkl_intpos(lrj,lri,lrm,lrm,nxo)
           nxo_1=nxo
           call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
           nxo_2=nxo

           im=mul_tab(lsm_inn(lri),ns_sm)    !!!
           jpdd=1+im
          iwld=jud(lri)
           iwrd=jud(lrj)
           call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
           call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)

           if(jb_sys.gt.0) then
            jpdd=jpdd+24
             call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)
          endif
           do lr=lrj+1,norb_dz
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lri,lr)
             iwrs=just(lrj,lr)
             iwlt=iwls             !
             iwrt=iwrs             !
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lr,lri)
               iwrs=just(lr,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
            endif
             if(jb_sys.gt.1) then
               jpdt=jpdt+24
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
             endif
           enddo


            do lr=norb_frz+1,lri-1
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lr,lri)
             iwrs=just(lr,lrj)
             iwlt=iwls
             iwrt=iwrs
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lri,lr)
               iwrs=just(lrj,lr)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
             endif
             if(jb_sys.gt.1) then
               jpat=jpdt+24
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_2,0,nxo_2)
             endif
           enddo
      enddo

c          wl0 =wl0+vl0_2*wltmp

!   ar(23)-bl(32)-drl(33)
!   ar(13)-bl(31)-drl(33)
c          wltmp=dzero
           do lrm=lrj+1,norb_dz
c             list=list3(lri,lrj,lrm)
c             wltmp=wltmp+(vint_ci(list)-2*vint_ci(list+1))
           wl0_1=-vl0_2*2
           wl0_2=vl0_2
           call trans_ijkl_intpos(lrj,lri,lrm,lrm,nxo)
           nxo_1=nxo
           call trans_ijkl_intpos(lrj,lrm,lri,lrm,nxo)
           nxo_2=nxo

           im=mul_tab(lsm_inn(lri),ns_sm)    !!!
           jpdd=1+im
          iwld=jud(lri)
           iwrd=jud(lrj)
           call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
           call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)

           if(jb_sys.gt.0) then
            jpdd=jpdd+24
             call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0_2,0,nxo_2)
          endif
           do lr=lrj+1,norb_dz
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lri,lr)
             iwrs=just(lrj,lr)
             iwlt=iwls             !
             iwrt=iwrs             !
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lr,lri)
               iwrs=just(lr,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
            endif
             if(jb_sys.gt.1) then
               jpdt=jpdt+24
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
             endif
           enddo


            do lr=norb_frz+1,lri-1
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lr,lri)
             iwrs=just(lr,lrj)
             iwlt=iwls
             iwrt=iwrs
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0_2,0,nxo_2)
             if(jb_sys.gt.0) then
               iwls=just(lri,lr)
               iwrs=just(lrj,lr)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0_2,0,nxo_2)
             endif
             if(jb_sys.gt.1) then
               jpat=jpdt+24
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_1,0,nxo_1)
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0_2,0,nxo_2)
             endif
           enddo
      enddo
c           wl0 =wl0+vl0_2*wltmp
c           wl_tmp=vl0_2*wltmp

! ar-arw    arw-al   ar-ar
c           list=list3(lri,lrj,lrj)
c           wl0=wl0-vl0_2*vint_ci(list)
           wl0=-vl0_2
           call trans_ijkl_intpos(lrj,lrj,lri,lrj,nxo)
           im=mul_tab(lsm_inn(lri),ns_sm)    !!!
           jpdd=1+im
          iwld=jud(lri)
           iwrd=jud(lrj)
           call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0,0,nxo)
           if(jb_sys.gt.0) then
            jpdd=jpdd+24
             call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0,0,nxo)
          endif
           do lr=lrj+1,norb_dz
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lri,lr)
             iwrs=just(lrj,lr)
             iwlt=iwls
             iwrt=iwrs
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
             if(jb_sys.gt.0) then
               iwls=just(lr,lri)
               iwrs=just(lr,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
            endif
             if(jb_sys.gt.1) then
               jpdt=jpdt+24
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
             endif
           enddo

            do lr=norb_frz+1,lri-1
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lr,lri)
             iwrs=just(lr,lrj)
             iwlt=iwls
             iwrt=iwrs
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
             if(jb_sys.gt.0) then
               iwls=just(lri,lr)
               iwrs=just(lrj,lr)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
             endif
             if(jb_sys.gt.1) then
               jpat=jpdt+24
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0,0,nxo)
             endif
           enddo

c           list=list3(lri,lrj,lri)
c           wl0=wl0-vl0_2*(voint(lri,lrj)+vint_ci(list))
           wl0=-vl0_2
           call trans_ijkl_intpos(lrj,lri,lri,lri,nxo)

           im=mul_tab(lsm_inn(lri),ns_sm)
           jpdd=1+im
          iwld=jud(lri)
           iwrd=jud(lrj)
           call prodab_1(1,0,jpdd,iwld,iwrd,0,wl0,0,lri,lrj)
           call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0,0,nxo)
           if(jb_sys.gt.0) then
            jpdd=jpdd+24
             call prodab_1(1,0,jpdd,iwld,iwrd,0,wl0,0,lri,lrj)
             call prodab_2(1,0,jpdd,iwld,iwrd,0,wl0,0,nxo)
          endif
           do lr=lrj+1,norb_dz
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lri,lr)
             iwrs=just(lrj,lr)
             iwlt=iwls             !
             iwrt=iwrs             !
             call prodab_1(1,0,jpds,iwls,iwrs,0,wl0,0,lri,lrj)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
             call prodab_1(1,0,jpdt,iwlt,iwrt,0,wl0,0,lri,lrj)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
             if(jb_sys.gt.0) then
               iwls=just(lr,lri)
               iwrs=just(lr,lrj)
               call prodab_1(1,0,jpds,iwls,iwrs,0,wl0,0,lri,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
            endif
             if(jb_sys.gt.1) then
               jpdt=jpdt+24
               call prodab_1(1,0,jpdt,iwlt,iwrt,0,wl0,0,lri,lrj)
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
             endif
           enddo


            do lr=norb_frz+1,lri-1
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lr,lri)
             iwrs=just(lr,lrj)
             iwlt=iwls
             iwrt=iwrs
             call prodab_1(1,0,jpds,iwls,iwrs,0,wl0,0,lri,lrj)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
             call prodab_1(1,0,jpdt,iwlt,iwrt,0,wl0,0,lri,lrj)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wl0,0,nxo)
             if(jb_sys.gt.0) then
               iwls=just(lri,lr)
               iwrs=just(lrj,lr)
               call prodab_1(1,0,jpds,iwls,iwrs,0,wl0,0,lri,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wl0,0,nxo)
             endif
             if(jb_sys.gt.1) then
               jpat=jpdt+24
               call prodab_1(1,0,jpat,iwlt,iwrt,0,wl0,0,lri,lrj)
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wl0,0,nxo)
             endif
           enddo

c===================================================

           do lr=lrj+1,norb_dz
c            list =list3(lri,lrj,lr)
c            wls=wl0+(vls0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))
c     :         -vls1*vint_ci(list)
      !ar(23)-bl(32)-drl(22) ar(13)-bl(31)-drl(11)
c            wlt=wl0+(vlt0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))
c     :         -vlt1*vint_ci(list)
             wls_1=vls0-vl0_2-vls1
             wls_2=-(vls0-vl0_2)*2
             wlt_1=vlt0-vl0_2-vlt1
             wlt_2=-(vlt0-vl0_2)*2
             call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
             nxo_1=nxo
             call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
             nxo_2=nxo
             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lri,lr)
             iwrs=just(lrj,lr)
             iwlt=iwls             !
             iwrt=iwrs             !
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
             if(jb_sys.gt.0) then
c              wls_a=wl0+(vls0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))
c     :           -vls1_a*vint_ci(list)
               wls_b=-vls10_2b
               wls_a_1=vls0-vl0_2-vls1_a
               wls_a_2=-(vls0-vl0_2)*2

               iwls=just(lr,lri)
               iwrs=just(lr,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls_a_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls_a_2,0,nxo_2)
               iwls=just(lri,lr)
               iwrs=just(lr,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls_b,0,nxo_1)
               iwls=just(lr,lri)
               iwrs=just(lrj,lr)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls_b,0,nxo_1)
            endif
             if(jb_sys.gt.1) then
               jpdt=jpdt+24
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
             endif

           enddo
c======= start d5(ss),d40(tt) =================================
           do lr=norb_frz+1,lri-1
c            list =list3(lri,lrj,lr)
      ! drl(22)-bl(13)-ar(31)
c             wls=wl0+(vls0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))
c     :             -vls1*vint_ci(list)
      ! drl(22)-bl(23)-ar(32)  drl(11)-bl(13)-ar(31)
c             wlt=wl0+(vlt0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))
c     :             -vlt1*vint_ci(list)
             wls_1=vls0-vl0_2-vls1
             wls_2=-(vls0-vl0_2)*2
             wlt_1=vlt0-vl0_2-vlt1
             wlt_2=-(vlt0-vl0_2)*2
             call trans_ijkl_intpos(lrj,lr,lri,lr,nxo)
             nxo_1=nxo
             call trans_ijkl_intpos(lrj,lri,lr,lr,nxo)
             nxo_2=nxo

             im=mul_tab(lsm_inn(lri),lsm_inn(lr))
             im=mul_tab(im,ns_sm)
             jpds=17+im
             jpdt=9+im
             iwls=just(lr,lri)
             iwrs=just(lr,lrj)
             iwlt=iwls
             iwrt=iwrs
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
             call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
             if(jb_sys.gt.0) then
!drl(11)-bl(23)-ar(32)
c               wls=wl0+(vls0-vl0_2)*(vint_ci(list)-2*vint_ci(list+1))
c     :             -vls1_a*vint_ci(list)
               wls_1=vls0-vl0_2-vls1_a
               wls_2=-(vls0-vl0_2)*2
               iwls=just(lri,lr)
               iwrs=just(lrj,lr)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
!drl(12)-bl(23)-ar(31) drl(21)-bl(13)-ar(32)
c               wls=-vls10_2b*vint_ci(list)
               wls=-vls10_2b
               iwls=just(lri,lr)
               iwrs=just(lr,lrj)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls,0,nxo_1)
               iwls=just(lr,lri)
               iwrs=just(lrj,lr)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls,0,nxo_1)
             endif
             if(jb_sys.gt.1) then
               jpat=jpdt+24
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wlt_1,0,nxo_1)
               call prodab_2(1,0,jpat,iwlt,iwrt,0,wlt_2,0,nxo_2)
             endif

           enddo
c======= end g5,40 =================================
201      continue
200    continue
      continue
      return
      end

      subroutine dbl_space_loop_ijkl_sgezero_g()
#include "drt_h.fh"
#include "intsort_h.fh"
c =============================  g11,12  == (v-s)=======================
c =============================  g41,42  == (v-t)=======================
      wls1=0.d0
      wls2=0.d0
      wls1_1=0.d0
      wls1_2=0.d0
      wls2_1=0.d0
      wls2_2=0.d0
      db=jb_sys
      do 10 lrl=norb_frz+1,norb_dz-3
         iml=lsm_inn(lrl)
         do 20 lrk=lrl+1,norb_dz-2
           imk=lsm_inn(lrk)
           nkl=lrl+ngw2(lrk)
           do 30 lrj=lrk+1,norb_dz-1
            imj=lsm_inn(lrj)
             do 40 lri=norb_dz,lrj+1,-1
               imi=lsm_inn(lri)

c               list=list4(lrl,lrk,lrj,lri)
               ni =mod(lrk-lrl+lri-lrj,2)
               imik=mul_tab(imi,imk)
        if(imik.eq.mul_tab(imj,iml)) then
               im=mul_tab(imik,ns_sm)
               jpds=17+im
               jpdt=9+im
               jpdt1=jpdt+24
               iwls=just(lrl,lrj)
               iwrs=just(lrk,lri)
               iwlt=iwls             !
               iwrt=iwrs             !
              if(jb_sys.eq.0) then
c                   w0g11=-1/2, w1g11=-3/2                 === g11 ===
c                 wls =vint_ci(list+1)+vint_ci(list+2)
                  wls_1=1.0d0
                  wls_2=1.0d0

c                   w0g42=-1/2, w1g42=1/2                  === g42 ===
c                 wlt =vint_ci(list+1)-vint_ci(list+2)
                  wlt_1=1.0d0
                  wlt_2=-1.0d0
               endif
              if(jb_sys.gt.0) then
!                  wog11=-1/2, w1g11=-(db+3)/(2*db+2)
!      ar(23)bl(32)bl(13)ar(31)
                 w1=-(db+3)/(2*db+2)
c                wls =vint_ci(list+1)+(-0.5d0-w1)*vint_ci(list+2)
                 wls_1=1.0d0
                 wls_2=-0.5d0-w1
!                  wog42=-1/2, w1g42=1/2     ar(23)bl(32)bl(23)ar(32)
c              wlt =vint_ci(list+1)-vint_ci(list+2)
                  wlt_1=1.0d0
                  wlt_2=-1.0d0
!                  w0=0, w1=-sqrt(db*(db+2)/(db+1))
!      ar(13)bl(32)bl(23)ar(31)     ar(23)bl(31)bl(13)ar(32)
                 w1=-sqrt(db*(db+2))/(db+1)
c              wls1=-w1*vint_ci(list+2)
                 wls1=-w1
!      ar(13)bl(31)bl(23)ar(32)      w0=-1/2
                 w1=-(db-1)/(2*db+2)
c              wls2=vint_ci(list+1)+(-0.5d0-w1)*vint_ci(list+2)
                 wls2_1=1.0d0
                 wls2_2=-0.5d0-w1
!      ar(13)bl(31)bl(13)ar(31)
!                 w0=-1/2 w1=1/2
!               wlt1=wlt
              endif
!            if(ni.eq.1)       wls=-wls
               if(ni.eq.1)  then
                 wls_1=-wls_1
                 wls_2=-wls_2
               wlt_1=-wlt_1
               wlt_2=-wlt_2
                 wls1=-wls1
                 wls2_1=-wls2_1
                 wls2_2=-wls2_2
               endif
               call trans_ijkl_intpos(lri,lrj,lrk,lrl,nxo)
               nxo_1=nxo
               call trans_ijkl_intpos(lri,lrl,lrk,lrj,nxo)
               nxo_2=nxo
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
               if(jb_sys.gt.0) then
                 iwrs1=just(lrk,lri)
                 iwls1=just(lrj,lrl)
                 call prodab_2(1,0,jpds,iwls1,iwrs1,0,wls1,0,nxo_2)
                 iwrs1=just(lri,lrk)
                 iwls1=just(lrl,lrj)
                 call prodab_2(1,0,jpds,iwls1,iwrs1,0,wls1,0,nxo_2)
                 iwrs1=just(lri,lrk)
                 iwls1=just(lrj,lrl)
                 call prodab_2(1,0,jpds,iwls1,iwrs1,0,wls2_1,0,nxo_1)
                 call prodab_2(1,0,jpds,iwls1,iwrs1,0,wls2_2,0,nxo_2)
               endif
               if(jb_sys.gt.1) then
                  call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
                  call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
             endif
        endif

            imil=mul_tab(imi,iml)
        if(imil.eq.mul_tab(imj,imk)) then
              im=mul_tab(imil,ns_sm)
              jpds=17+im
              jpdt=9+im
              jpdt1=jpdt+24
              iwls=just(lrl,lri)
            iwrs=just(lrk,lrj)
              iwlt=iwls       !
              iwrt=iwrs       !
              if(jb_sys.eq.0) then
c                   w0g11=-1/2 w1g11=-3/2                  === g11 ===
c                wls =vint_ci(list)+vint_ci(list+1)
                  wls_1=1.0d0
                  wls_2=1.0d0
c                   w0g42=-1/2 w1g42=1/2                   === g42 ===
c                wlt =vint_ci(list+1)-vint_ci(list)
                  wlt_1=1.0d0
                  wlt_2=-1.0d0
              endif
              if(jb_sys.gt.0) then
!                  wog11=-1/2 w1g11=-(db+3)/(2*db+2)
!      ar(23)bl(32)br(31)al(13)
                 w1=-(db+3)/(2*db+2)
c                 wls =(-0.5d0-w1)*vint_ci(list)+vint_ci(list+1)
                 wls_1=1.0d0
                 wls_2=-0.5d0-w1
!                  wog42=-1/2 w1g42=1/2
!      ar(23)bl(32)br(23)al(32)
c              wlt =vint_ci(list+1)-vint_ci(list)
                  wlt_1=1.0d0
                  wlt_2=-1.0d0
!                  w0=0 w1=-sqrt(db*(db+2)/(db+1))
!      ar(23)bl(31)br(32)al(13)
                 w1=-sqrt(db*(db+2))/(db+1)
c               wls1=-w1*vint_ci(list)
                wls1=-w1
!      ar(13)bl(31)br(32)al(23)
!                w0=-1/2 w1=-(db-1)/(2*db+2)
                 w1=-(db-1)/(2*db+2)
c              wls2=(-0.5d0-w1)*vint_ci(list)+vint_ci(list+1)
                 wls2_1=1.0d0
                 wls2_2=-0.5d0-w1
              endif
               if(ni.eq.1) then
                 wls_1=-wls_1
                 wls_2=-wls_2
               wlt_1=-wlt_1
               wlt_2=-wlt_2
                 wls1=-wls1
                 wls2_1=-wls2_1
                 wls2_2=-wls2_2
             endif
               call trans_ijkl_intpos(lri,lrj,lrk,lrl,nxo)
               nxo_1=nxo
               call trans_ijkl_intpos(lri,lrk,lrj,lrl,nxo)
               nxo_2=nxo
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
             call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
               call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
               if(jb_sys.gt.0) then
                 iwls=just(lri,lrl)
                 iwrs=just(lrk,lrj)
                 call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo_2)
                 iwls=just(lrl,lri)
                 iwrs=just(lrj,lrk)
                 call prodab_2(1,0,jpds,iwls,iwrs,0,wls1,0,nxo_2)
               iwls=just(lri,lrl)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
               call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
               endif
               if(jb_sys.gt.1) then
                 call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
                 call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
               endif
        endif

              imij=mul_tab(imi,imj)
        if(imij.eq.mul_tab(imk,iml)) then
                im=mul_tab(imij,ns_sm)
                jpds=17+im
                jpdt=9+im
                jpdt1=24+jpdt
                iwls=just(lrl,lrk)
                iwrs=just(lrj,lri)
                iwlt=iwls             !
                iwrt=iwrs             !
              if(jb_sys.eq.0) then
c           w0g12=1, w1g12=0                                === g12 ===
c                  wls =vint_ci(list)+vint_ci(list+2)
                  wls_1=1.0d0
                  wls_2=1.0d0
c           w0g41=0, w1g41=1                                === g41 ===
c                  wlt =vint_ci(list)-vint_ci(list+2)
                  wlt_1=1.0d0
                  wlt_2=-1.0d0
              endif
                if(jb_sys.gt.0) then
                  w0=(db+2)/(2*db+2)
                  w1=db/(2*db+2)
c                 wls =(w0+w1)*vint_ci(list)+(w0-w1)*vint_ci(list+2)
                  wls_1=w0+w1
                  wls_2=w0-w1
c                 wlt =vint_ci(list)-vint_ci(list+2)
                  wlt_1=1.0d0
                  wlt_2=-1.0d0
               w0=sqrt(db*(db+2))/(2*db+2)
                  w1=-w0
c                 wls1=(w0+w1)*vint_ci(list)+(w0-w1)*vint_ci(list+2)
                  wls1_1=w0+w1
                  wls1_2=w0-w1

                  w0=db/(2*db+2)
                  w1=(db+2)/(2*db+2)
c                 wls2=(w0+w1)*vint_ci(list)+(w0-w1)*vint_ci(list+2)
                  wls2_1=w0+w1
                  wls2_2=w0-w1
              endif
                if(ni.eq.1) then
                 wls_1=-wls_1
                 wls_2=-wls_2
               wlt_1=-wlt_1
               wlt_2=-wlt_2
                 wls1_1=-wls1_1
                 wls1_2=-wls1_2
                 wls2_1=-wls2_1
                 wls2_2=-wls2_2
              endif
                call trans_ijkl_intpos(lri,lrk,lrj,lrl,nxo)
                nxo_1=nxo
                call trans_ijkl_intpos(lri,lrl,lrk,lrj,nxo)
                nxo_2=nxo
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls_1,0,nxo_1)
              call prodab_2(1,0,jpds,iwls,iwrs,0,wls_2,0,nxo_2)
                call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_1,0,nxo_1)
                call prodab_2(1,0,jpdt,iwlt,iwrt,0,wlt_2,0,nxo_2)
                if(jb_sys.gt.0) then
                  iwls=just(lrl,lrk)
                  iwrs=just(lri,lrj)
                  call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
                  call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
                  iwls=just(lrk,lrl)
                  iwrs=just(lrj,lri)
                  call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_1,0,nxo_1)
                  call prodab_2(1,0,jpds,iwls,iwrs,0,wls1_2,0,nxo_2)
               iwrs=just(lri,lrj)
                  call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_1,0,nxo_1)
                  call prodab_2(1,0,jpds,iwls,iwrs,0,wls2_2,0,nxo_2)
                endif
                if(jb_sys.gt.1) then
                  call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_1,0,nxo_1)
                  call prodab_2(1,0,jpdt1,iwlt,iwrt,0,wlt_2,0,nxo_2)
              endif
        endif
40          continue
30        continue
20      continue
10    continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine TimesE2(Kap,ipCId,isym,reco,jspin,ipS2,KapOut,ipCiOut)

use ipPage, only: ipin, opout, W
use MCLR_Data, only: ipCI, n2Dens, nConf1, nDens, nDensC
use input_mclr, only: nAsh, nRoots, nRS2
use PCM_grad, only: do_RF, PCM_grad_TimesE2
use ISRotation, only: InvSCF, ISR, ISR_projection, ISR_TimesE2, unequal_SA
use dmrginfo, only: DoDMRG, LRRAS2, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Kap(nDensC), reco
integer(kind=iwp), intent(in) :: ipCId, isym, jspin, ipS2, ipCiOut
real(kind=wp), intent(out) :: KapOut(nDensC)
real(kind=wp) :: rdum(1)
real(kind=wp), allocatable :: RMOAA(:), Sc1(:), Sc2(:), Sc3(:), Temp3(:), Temp4(:)

call mma_allocate(RMOAA,n2Dens,Label='RMOAA')
call mma_allocate(Sc1,nDens,Label='Sc1')
Sc1(:) = Zero
call mma_allocate(Sc2,nDens,Label='Sc2')
call mma_allocate(Sc3,nDens,Label='Sc3')
call mma_allocate(Temp3,nDens,Label='Temp3')
call mma_allocate(Temp4,nDens,Label='Temp4')
if (.not. InvSCF) ISR%Ap = Zero

if (doDMRG) then ! yma
  nash(:) = RGras2(:)
  nrs2(:) = RGras2(:)
end if
call Uncompress(Kap,Sc1,isym)

! Integral derivative !yma
call RInt_generic(SC1,rmoaa,rdum(1),Sc2,Temp3,Temp4,Sc3,isym,reco,jspin)

call Kap_CI(Temp4,nDens,rmoaa,n2Dens,ipCIOUT)
call Ci_Ci(ipcid,ipS2)
call CI_KAP(ipCid,Sc1,Sc3,isym)

if (do_RF) then
  W(ipCIOUT)%A(1:nConf1*nRoots) = W(ipCIOUT)%A(1:nConf1*nRoots)+W(ipS2)%A(1:nConf1*nRoots)
  ! ipS2 is overwritten
  call Uncompress(Kap,Sc1,isym)
  call PCM_grad_TimesE2(isym,Sc1,Sc3,ipS2)
  !! evaluate the diagonal S-S block if SCF is not invariant
  call ISR_TimesE2(2,W(ipCI)%A,W(ipS2)%A)
  if (unequal_SA) call ISR_TimesE2(1,W(ipCI)%A,W(ipCIOUT)%A)
end if

Sc1(:) = Sc2(:)+Sc3(:)

call Compress(Sc1,KapOut,isym)   ! ds
!call RecPrt('Ex',' ',KapOut,nDensC,1)

call ipin(ipS2)
call ipin(ipCIOUT)
W(ipCIOUT)%A(1:nConf1*nroots) = W(ipCIOUT)%A(1:nConf1*nroots)+W(ipS2)%A(1:nConf1*nroots)
call opOut(ipCId)
! This is also orthogonalization of the solution vector
!do iR=1,nroots
!  do jR=1,nroots
!    ovl = ddot_(nconf1,W(ipciout)%A(iR),1,W(ipci)%A(jR),1)
!    W(ipciout)%A(iR:iR+nconf1-1) = W(ipciout)%A(iR:iR+nconf1-1)-ovl*W(ipci)%A(jR:JR+nconf1-1)
!  end do
!end do

if (unequal_SA .and. (.not. do_RF)) call ISR_TimesE2(1,W(ipCI)%A,W(ipCIOUT)%A)
!! Project out the internal rotation contribution
if ((.not. InvSCF) .or. do_RF) call ISR_projection(W(ipCI)%A,W(ipCIOUT)%A)

call mma_deallocate(Temp4)
call mma_deallocate(Temp3)
call mma_deallocate(Sc3)
call mma_deallocate(Sc2)
call mma_deallocate(Sc1)
call mma_deallocate(rmoaa)

if (doDMRG) nash(:) = LRras2(:)  ! yma

end subroutine TimesE2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

#include "compiler_features.h"

module InputData
  !SVC: this module contains a data structure to keep all input variables.

  use stdalloc, only: mma_allocate, mma_deallocate
  use constants, only: Zero, One
  use definitions, only: wp,iwp,u6

  implicit none
  private

  type States
    Integer(kind=iwp), allocatable :: State(:)
  end type

  type InputTable
    ! TITL      one line with a descriptive name
    Character(len=128) :: Title = ' '
    ! FILE      file to read CAS/RAS reference from
    Character(len=128) :: File = 'JOBIPH'
    ! MULT      the number of states, followed by the ID of each state
    Logical(kind=iwp) :: MULT = .false.
    Integer(kind=iwp) :: nMultState = 0
    type(States)      :: MultGroup
    Logical(kind=iwp) :: AllMult = .false.
    ! XMUL      extended multi-state caspt2
    Logical(kind=iwp) :: XMUL = .false.
    Integer(kind=iwp) :: nXMulState = 0
    type(States)      :: XMulGroup
    Logical(kind=iwp) :: AllXMult = .false.
    ! RMUL      rotated multi-state caspt2
    Logical(kind=iwp) :: RMUL = .false.
    Integer(kind=iwp) :: nRMulState = 0
    type(States)      :: RMulGroup
    Logical(kind=iwp) :: AllRMult = .false.
    ! DWMS      use dynamical weighting to construct Fock
    Logical(kind=iwp) :: DWMS = .false.
    Integer(kind=iwp) :: DWType = -1
    Real(kind=wp)     :: ZETA = One
    ! EFOC      uses rotated E_0 energies with DWMS
    Logical(kind=iwp) :: EFOC = .false.
    ! LROO      compute only a single root, mutually exclusive with both MULT or XMUL
    Logical(kind=iwp) :: LROO = .false.
    Integer(kind=iwp) :: SingleRoot = 0
    ! RLXR      root for which the gradient is computed
    Integer(kind=iwp) :: RlxRoot = -1

    ! IPEA      sets the IP-EA shift
    Logical(kind=iwp) :: IPEA = .false.
    Real(kind=wp)     :: BSHIFT = Zero
    ! IMAG      size of extra 'imaginary' denominator shift
    Real(kind=wp)     :: ShiftI = Zero
    ! SHIF      size of extra denominator shift
    Real(kind=wp)     :: Shift = Zero

    ! several freeze-delete schemes, each of these should active
    ! the general flag below, to indicate additional conversion is
    ! needed on the input orbitals
    Logical(kind=iwp) :: modify_correlating_MOs = .false.
    ! AFRE      freeze orbitals that do not have sufficient density on specified 'active' atoms
    Logical(kind=iwp) :: aFreeze = .false.
    Integer(kind=iwp) :: lnFro = 0
    Real(kind=wp)     :: ThrFr = Zero,ThrDe = Zero
    Character(len=4),allocatable :: NamFro(:)
    ! LOVC      freeze orbitals that are not localized no the active site
    Logical(kind=iwp) :: LovCASPT2 = .false.
    Real(kind=wp)     :: Thr_Atm = Zero
    ! FNOC      delete a fraction of virtual orbitals
    Logical(kind=iwp) :: FnoCASPT2 = .false.
    Real(kind=wp)     :: VFrac = Zero
    ! DOMP
    Logical(kind=iwp) :: doMP2 = .false.
    ! DOEN
    Logical(kind=iwp) :: doEnv = .false.
    ! VIRA
    Logical(kind=iwp) :: VIRA = .false.
    ! GHOS      excludes ghost orbitals from the PT2 treatment
    Logical(kind=iwp) :: GhostDelete = .false.
    Real(kind=wp)     :: ThrGD = Zero

    ! FROZ      number of frozen orbitals in each irrep
    Logical(kind=iwp) :: FROZ = .false.
    Integer(kind=iwp),allocatable :: nFro(:)
    ! DELE      number of deleted orbitals in each irrep
    Logical(kind=iwp) :: DELE = .false.
    Integer(kind=iwp),allocatable :: nDel(:)
    ! DENS      computes full density matrix from the 1st-order wavefunction
    Logical(kind=iwp) :: DENS = .false.
    ! RFPE      make a perturbative reaction field calculation
    Logical(kind=iwp) :: RFPert = .false.
    ! THRE      thresholds for removal of:
    !   ThrsHN    zero-norm components in the first-order perturbed
    !             wave function
    !   ThrsHS    linear dependencies between components of the first-
    !             order perturbed wave function
    Logical(kind=iwp) :: THRE = .false.
    Real(kind=wp)     :: ThrsHN = 1.0e-10_wp,ThrsHS = 1.0e-8_wp
    ! MAXI      maximum number of iterations for solving a system of
    !           linear equations, default 20. A 0 indicates: use of
    !           the diagonal zeroth order hamiltonian
    Integer(kind=iwp) :: maxIter = 20
    ! Conv      convergence criteria for solving a system of linear equations
    Real(kind=wp)     :: ThrConv = 1.0e-6_wp
    ! NOMI      do not create an PM-CAS wavefunction file (JobMix)
    Logical(kind=iwp) :: NoMix = .false.
    ! NOMU      do not perform a multistate interaction
    Logical(kind=iwp) :: noMult = .false.
    ! ONLY      in a MS calculation, compute a single root with couplings to the other roots
    Integer(kind=iwp) :: OnlyRoot = 0
    ! EFFE      read Heff coupling terms from the input and perform only the multistate part
    Logical(kind=iwp) :: JMS = .false.
    Real(kind=wp),allocatable :: Heff(:,:)
    ! NOOR      do not print orbitals
    Logical(kind=iwp) :: PrOrb = .true.
    ! PROP      compute properties
    ! NOPR      do not compute properties
    Logical(kind=iwp) :: Properties = .false.
    ! transformation of reference (input) orbitals
    ! NOTR      do not transform to quasi-canonical orbitals,
    !           regardless of the state of the reference orbitals
    ! TRAN      transform to quasi-canonical orbitals, regardless
    !           of the state of the reference orbitals
    ! the default is to use transformation, unless the PT2 keyword
    ! was used in the rasscf program and the fock matrix is standard
    Character(len=8)  :: OrbIn = 'TRANSFOR'
    ! OFEM      add orbital-free embedding potential to hamiltonian
    Logical(kind=iwp) :: OFEmbedding = .false.
    ! OUTP      control extent of orbital printing
    Character(len=8)  :: OutFormat = 'DEFAULT '
    ! PRWF      print the CI coefficients above this threshold
    Real(kind=wp)     :: PrWF = 0.05_wp
    ! PRSD      print the determinant expansion of CSFs
    Logical(kind=iwp) :: PrSD = .false.
    ! NOOR      do not print any orbitals
    Logical(kind=iwp) :: NoOrb = .false.

    ! UNDOCUMENTED KEYWORDS
    ! CHOL
    Logical(kind=iwp) :: Chol = .false.
    ! CHOI
    Logical(kind=iwp) :: Choi = .false.
    ! WTHR      thresholds for writing large components in the
    !           first-order perturbed wave function, 3 values that
    !           are for denominator, coefficient, and energy
    Real(kind=wp) :: DnmThr = 0.3_wp,CmpThr = 0.025_wp,CntThr = 0.005_wp
    ! FOCK      string representing the type of Fock matrix
    Character(len=8)  :: FockType = 'STANDARD'
    ! HZER      string representing the type of 0-order hamiltonian
    Character(len=8)  :: Hzero = 'STANDARD'
    ! G1SE      include secondary/inactive elements of the exchange
    !           matrix in the g1 modification to the fock matrix
    Logical(kind=iwp) :: G1SecIn = .false.
    ! RHSD      use the RHS-ondemand algorithm for the calculation of the right-hand side
    Logical(kind=iwp) :: RHSD = .false.
    ! CUMU
    Logical(kind=iwp) :: doCumulant = .false.

  end type ! end of type InputTable

  ! Define the Input as an InputTable structure
  type(InputTable),allocatable :: Input

  public :: Input, readin_CASPT2, CleanUp_Input

  save

contains

  subroutine readin_CASPT2(LuIn,nSym)
    !SVC read and store the input as independent as possible. Any sanity
    ! checks not required for reading in the input should be postponed till
    ! the proc_inp call (processing of input). The only variable needed here
    ! is nSym, as some input lines assume knowledge of the number of irreps.

    Use text_file, Only: extend_line, next_non_comment

    Integer(kind=iwp),intent(in) :: LuIn,nSym

    Character(len=:),allocatable :: dLine, Line
    Character(len=4) :: Command,Word

    Integer(kind=iwp) :: i,j,iSym,nStates
    Integer(kind=iwp) :: iSplit,iError

#ifdef _ENABLE_CHEMPS2_DMRG_
    Logical(kind=iwp) :: dochemps2 = .false.
#endif

    rewind (LuIn)
    call RdNLst(LuIn,'CASPT2')

    ! beginning of reading loop
    do

      if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
      Command = Line(1:min(4,len(Line)))
      call Upcase(Command)

      !IFG Note that when multiple values are required, extend_line may
      ! be called (0 or more times) until the READ statement gives no error
      ! this allows the input to be split in lines more or less arbitrarily,
      ! as if the values were read directly from the file.
      select case (Command)

      case ('TITL')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,'(A128)') Input%Title

        ! File with the reference CAS/RAS wavefunction
      case ('FILE')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        ! Not using list-directed input (*), because then the slash means end of input
        read (Line,'(A)',IOStat=iError) Input%file
        if (iError /= 0) call IOError(Line)

        ! Root selection
      case ('MULT')
        Input%MULT = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*) Word
        call Upcase(Word)
        if (Word == 'ALL') then
          nStates = 0
          Input%AllMult = .true.
        else
          read (Line,*,IOStat=iError) nStates
          if (iError /= 0) call IOError(Line)
          if (nStates <= 0) call StatesError(Line)
        end if
        call mma_allocate(Input%MultGroup%State,nStates,label='MultGroup')
        Input%nMultState = nStates
        iSplit = scan(Line,' ')
        call mma_allocate (dLine,len(Line),label='dLine')
        dLine(:) = Line(iSplit:)
        iError = -1
        do while (iError < 0)
          read (dLine,*,IOStat=iError) (Input%MultGroup%State(i),i=1,nStates)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate (dLine)

      case ('XMUL')
        Input%XMUL = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*) Word
        call Upcase(Word)
        if (Word == 'ALL') then
          nStates = 0
          Input%AllXMult = .true.
        else
          read (Line,*,IOStat=iError) nStates
          if (iError /= 0) call IOError(Line)
          if (nStates <= 0) call StatesError(Line)
        end if
        call mma_allocate(Input%XMulGroup%State,nStates,label='XMulGroup')
        Input%nXMulState = nStates
        iSplit = scan(Line,' ')
        call mma_allocate (dLine,len(Line),label='dLine')
        dLine(:) = Line(iSplit:)
        iError = -1
        do while (iError < 0)
          read (dLine,*,IOStat=iError) (Input%XMulGroup%State(i),i=1,nStates)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate (dLine)

      case ('RMUL')
        Input%RMUL = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*) Word
        call Upcase(Word)
        if (Word == 'ALL') then
          nStates = 0
          Input%AllRMult = .true.
        else
          read (Line,*,IOStat=iError) nStates
          if (iError /= 0) call IOError(Line)
          if (nStates <= 0) call StatesError(Line)
        end if
        call mma_allocate(Input%RMulGroup%State,nStates,label='RMulGroup')
        Input%nRMulState = nStates
        iSplit = scan(Line,' ')
        call mma_allocate (dLine,len(Line),label='dLine')
        dLine(:) = Line(iSplit:)
        iError = -1
        do while (iError < 0)
          read (dLine,*,IOStat=iError) (Input%RMulGroup%State(i),i=1,nStates)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate (dLine)

      case ('DWMS')
        Input%DWMS = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%ZETA
        if (iError /= 0) call IOError(Line)

      case ('DWTY')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%DWType
        if (iError /= 0) call IOError(Line)

      case ('EFOC')
        Input%EFOC = .true.

      case ('LROO')
        Input%LROO = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%SingleRoot
        if (iError /= 0) call IOError(Line)

      case ('RLXR')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%RlxRoot
        if (iError /= 0) call IOError(Line)

        ! freeze-deleted control

      case ('FROZ')
        Input%FROZ = .true.
        call mma_allocate(Input%nFro,nSYM,label='nFro')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate (dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read (dLine,*,IOStat=iError) (Input%nFro(iSym),iSym=1,nSym)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate (dLine)

      case ('DELE')
        Input%DELE = .true.
        call mma_allocate(Input%nDel,nSYM,label='nDel')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate (dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read (dLine,*,IOStat=iError) (Input%nDel(iSym),iSym=1,nSym)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate (dLine)

        ! equation solver control

      case ('MAXI')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%maxIter
        if (iError /= 0) call IOError(Line)

      case ('CONV')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%ThrConv
        if (iError /= 0) call IOError(Line)

      case ('THRE')
        Input%THRE = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate (dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read (dLine,*,IOStat=iError) Input%ThrsHN,Input%ThrsHS
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate (dLine)

      case ('SHIF')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%Shift
        if (iError /= 0) call IOError(Line)

      case ('IMAG')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%ShiftI
        if (iError /= 0) call IOError(Line)

        ! environment

      case ('RFPE')
        Input%RFpert = .true.

      case ('OFEM')
        Input%OFEmbedding = .true.

        ! print controls

      case ('PRWF')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%PrWF
        if (iError /= 0) call IOError(Line)

      case ('OUTP')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call StdFmt(Line,Input%OutFormat)

      case ('NOOR')
        Input%PrOrb = .false.

      case ('PRSD')
        Input%PRSD = .true.

      case ('WTHR')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate (dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read (dLine,*,IOStat=iError) Input%DNMTHR,Input%CMPTHR,Input%CNTTHR
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate (dLine)

        ! properties

      case ('DENS')
        Input%DENS = .true.

      case ('PROP')
        Input%Properties = .true.

      case ('NOPR')
        Input%Properties = .false.

        ! fock matrix, 0-order hamiltonian

      case ('TRAN')
        Input%ORBIN = 'TRANSFOR'

      case ('FOCK')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call StdFmt(Line,Input%FockType)

      case ('HZER')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call StdFmt(Line,Input%HZero)

      case ('G1SE')
        Input%G1SECIN = .true.

      case ('IPEA')
        Input%IPEA = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%BSHIFT
        if (iError /= 0) call IOError(Line)

        ! cholesky

      case ('CHOL')
        Input%Chol = .true.
        call Cho_caspt2_rdInp(.true.,LuIn)

      case ('CHOI')
        Input%ChoI = .true.
        call Cho_caspt2_rdInp(.false.,LuIn)

        ! freeze-delete approximation schemes

      case ('AFRE')
        Input%aFreeze = .true.
        Input%modify_correlating_MOs = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call mma_allocate (dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read (dLine,*,IOStat=iError) Input%lnFro,Input%ThrFr,Input%ThrDe
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate (dLine)
        call mma_allocate(Input%NamFro,Input%lnFro,label='NamFro')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        call Upcase(Line)
        call mma_allocate (dLine,len(Line),label='dLine')
        dLine(:) = Line
        iError = -1
        do while (iError < 0)
          read (dLine,*,IOStat=iError) (Input%NamFro(i),i=1,Input%lnFro)
          if (iError > 0) call IOError(Line)
          if (iError < 0) then
            if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
            call Upcase(Line)
            call extend_line(dLine,Line)
          end if
        end do
        call mma_deallocate (dLine)

      case ('LOVC')
        Input%LovCASPT2 = .true.
        Input%modify_correlating_MOs = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%thr_atm
        if (iError /= 0) call IOError(Line)

      case ('FNOC')
        Input%FnoCASPT2 = .true.
        Input%modify_correlating_MOs = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%vFrac
        if (iError /= 0) call IOError(Line)

      case ('DOMP')
        Input%doMP2 = .true.

      case ('DOEN')
        Input%doEnv = .true.

      case ('VIRA')
        Input%VIRA = .true.

      case ('GHOS')
        Input%GhostDelete = .true.
        Input%modify_correlating_MOs = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%ThrGD
        if (iError /= 0) call IOError(Line)

      case ('NOMU')
        Input%NoMult = .true.

      case ('ONLY')
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) Input%OnlyRoot
        if (iError /= 0) call IOError(Line)

      case ('NOMI')
        Input%NoMix = .true.

      case ('RHSD')
        Input%RHSD = .true.

#ifdef _ENABLE_BLOCK_DMRG_
      case ('CUMU')
        Input%doCumulant = .true.
#elif _ENABLE_CHEMPS2_DMRG_
      case ('CHEM')
        !Quan: Using the same variable doCumulant in Block
        Input%doCumulant = .true.
        dochemps2 = .true.
#endif

      case ('EFFE')
        Input%JMS = .true.
        if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
        read (Line,*,IOStat=iError) nStates
        if (iError /= 0) call IOError(Line)
        call mma_allocate(Input%Heff,nStates,nStates,label='Heff')
        Input%Heff = Zero
        do i = 1,nStates
          if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
          call mma_allocate (dLine,len(Line),label='dLine')
          dLine(:) = Line
          iError = -1
          do while (iError < 0)
            read (dLine,*,IOStat=iError) (Input%Heff(i,j),j=1,nStates)
            if (iError > 0) call IOError(Line)
            if (iError < 0) then
              if (.not. next_non_comment(LuIn,Line)) call EOFError(Line)
              call extend_line(dLine,Line)
            end if
          end do
          call mma_deallocate (dLine)
        end do

        ! OBSOLETE KEYWORDS

      case ('GRAD')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError

      case ('NOTR')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError

      case ('JACO')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError

      case ('EXTR')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError

      case ('QLQR')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError

      case ('NATU')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError

      case ('MOLO')
        call WarningMessage(2,'Obsolete keyword: '//Command)
        call Quit_OnUserError

        ! DONE WITH READING INPUT

      case ('END ')
        exit

        ! NO MATCH FOUND, UNKOWN KEYWORD

      case Default
        call WarningMessage(2,'Unrecognized keyword: '//Command)
        call Quit_OnUserError

      end select

    end do ! end of reading loop

#ifdef _ENABLE_CHEMPS2_DMRG_
    ! Check if nState>1
    if ((dochemps2 .EQV. .true.) .and. (nStates > 1)) then
      write (u6,*) 'CHEMPS2> Only State Specific calculation supported'
      call Quit_OnUserError()
    endif
#endif

    call mma_deallocate(Line)

    ! Normal exit
    return

  end subroutine readin_CASPT2

  subroutine CleanUp_Input()
    if (allocated(Input)) then
      if (allocated(Input%MultGroup%State)) call mma_deallocate(Input%MultGroup%State)
      if (allocated(Input%XMulGroup%State)) call mma_deallocate(Input%XMulGroup%State)
      if (allocated(Input%RMulGroup%State)) call mma_deallocate(Input%RMulGroup%State)
      if (allocated(Input%NamFro)) call mma_deallocate(Input%NamFro)
      if (allocated(Input%nFro)) call mma_deallocate(Input%nFro)
      if (allocated(Input%nDel)) call mma_deallocate(Input%nDel)
      if (allocated(Input%Heff)) call mma_deallocate(Input%Heff)
      ! The input structure itself is a scalar, allocated outside mma
      deallocate(Input)
    end if
  end subroutine CleanUp_Input

  subroutine IOError(line)
    Character(len=*),intent(in) :: line

    call WarningMessage(2,'I/O error when reading line.')
    write (u6,*) 'Last line read from input: ',line
    call Quit_OnUserError
  end subroutine IOError

  subroutine EOFError(line)
    Character(len=*),intent(in) :: line

    call WarningMessage(2,'Premature end of input file.')
    write (u6,*) 'Last line read from input: ',line
    call Quit_OnUserError
  end subroutine EOFError

  subroutine StatesError(line)
    Character(len=*),intent(in) :: line

    call WarningMessage(2,'Number of states must be > 0.')
    write (u6,*) 'Last line read from input: ',line
    call Quit_OnUserError
  end subroutine StatesError

end module InputData

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine inverts the matrix a of dimension N,N
subroutine DMINV(N,NMAX,A)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, NMAX
real(kind=wp), intent(inout) :: A(NMAX,NMAX)
integer(kind=iwp) :: I, J, K
real(kind=wp) :: BIGA, HOLD

do K=1,N
  BIGA = A(K,K)
  do I=1,N
    if (I /= K) then
      A(I,K) = -A(I,K)/BIGA
    end if
  end do
  do I=1,N
    HOLD = A(I,K)
    do J=1,N
      if ((I /= K) .and. (J /= K)) then
        A(I,J) = HOLD*A(K,J)+A(I,J)
      end if
    end do
  end do
  do J=1,N
    if (J /= K) then
      A(K,J) = A(K,J)/BIGA
    end if
  end do
  A(K,K) = One/BIGA
end do

return

end subroutine dminv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      !> Cleanup and close files
      subroutine pt2close

      use nevpt2_cfg
      use info_state_energy  ! energies
      use info_orbital_space ! orbital specifications read from JobIph
      use nevpt2wfn
      implicit none

#include "mxdm.fh"
#include "caspt2.fh"

      call nevpt2wfn_close
      call deinit_energies
      call finalize_inforb_molcas

      if(allocated(MultGroup%State))
     &  deallocate(MultGroup%State)
      if(allocated(MultGroup%h5_file_name))
     &  deallocate(MultGroup%h5_file_name)

      !> close file LUONEM
      call DaClos(LUONEM)

      end subroutine pt2close

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine RHS_CMS(Fock,CICSF)

use Index_Functions, only: nTri_Elem
use MCLR_Data, only: nAcPar, nAcPr2, nConf1, nDens, nNA
use input_mclr, only: nRoots, ntAsh, ntBas, ntBtri
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Fock(nDens), CICSF(nconf1*nroots)
integer(kind=iwp) :: NPUVX
integer(kind=iwp), allocatable :: IndPUVX(:,:,:,:), IndTUVX(:,:,:,:)
real(kind=wp), allocatable :: AXkzx(:), AXPzx(:), AXX(:,:), bk(:), bP(:), bX(:), FMO1t(:), FMO2t(:), GDMat(:,:,:), H(:,:), &
                              PUVX(:), R(:,:), W(:,:), zX(:)

!R: rotation matrix from inter states to final states

! MEMORY ALLOCATION
call mma_allocate(AXkzx,nDens)
call mma_allocate(AXPzx,NConf1*nRoots)
call mma_allocate(AXX,nTri_Elem(nRoots-1),nTri_Elem(nRoots-1))
call mma_allocate(R,nRoots,nRoots)
call mma_allocate(H,nRoots,nRoots)
call mma_allocate(bk,nDens)
call mma_allocate(bP,nConf1*nRoots)
call mma_allocate(bX,nTri_Elem(nRoots-1))
call mma_allocate(zX,nTri_Elem(nRoots-1))
call mma_allocate(GDMat,nTri_Elem(nRoots),nnA,nnA)
call mma_allocate(W,nTri_Elem(nRoots),nTri_Elem(nRoots))
call mma_allocate(IndPUVX,ntBas,ntAsh,ntAsh,ntAsh)
call mma_allocate(IndTUVX,ntAsh,ntAsh,ntAsh,ntAsh)
call Get_PUVXLen(NPUVX)
call mma_allocate(PUVX,NPUVX)
call mma_allocate(FMO1t,nRoots*ntBtri)
NACPAR = nTri_Elem(nnA)
NAcPr2 = nTri_Elem(nacpar)
call mma_allocate(FMO2t,nRoots*nacpr2)
! MAIN COURSE
! First, read results printed in MCPDFT module
call CMSRdMat(H,nRoots,nRoots,'ROT_HAM',7)
call Get_DArray('MS_FINAL_ROT',R,nRoots**2)
call Get_DArray('TwoEIntegral',PUVX,NPUVX)
call Get_Two_Ind(IndPUVX,IndTUVX)
call GetPDFTFocks(FMO1t,FMO2t,ntBtri)
! Calculate six additional terms in CMS Lagrangian equaiton
call CMSRHSGDMat(GDMat)
call CalcW(W,GDMAt,PUVX,NPUVX,IndTUVX)

call CalcAXX(AXX,W)

call CalcbXbP(bX,bP,FMO1t,FMO2t,R,H,ntBtri)

call SolveforzX(zX,AXX,bX)

call CalcAXkzx(AXkzx,GDMat,PUVX,NPUVX,IndPUVX,zx)

call CalcAXPzx(AXPzx,GDMat,PUVX,NPUVX,IndTUVX,W,zx)

call Calcbk(bk,R,ntBtri,GDMat,zX)

call SolveforRHS(Fock,CICSF,AXkzx,AXPzx,bk,bP)

! MEMORY DEALLOCATION
call mma_deallocate(AXkzx)
call mma_deallocate(AXPzx)
call mma_deallocate(AXX)
call mma_deallocate(R)
call mma_deallocate(H)
call mma_deallocate(bk)
call mma_deallocate(bP)
call mma_deallocate(bX)
call mma_deallocate(zX)
call mma_deallocate(IndPUVX)
call mma_deallocate(IndTUVX)
call mma_deallocate(GDMat)
call mma_deallocate(W)
call mma_deallocate(FMO1t)
call mma_deallocate(FMO2t)
call mma_deallocate(PUVX)

end subroutine RHS_CMS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1996, Markus P. Fuelscher                         *
*               1993, Per Ake Malmqvist                                *
************************************************************************
      Subroutine SORT1A(nUt,vInt,nSqNum,nSyBlk)
************************************************************************
*                                                                      *
*     Purpose: Phase 1 of the bin sorting algorithm                    *
*             Distribute the integrals into the bins where the indices *
*             and the integral values are stored in different buffers. *
*             When a bin is completed append the buffer containing the *
*             integral values to the file LuTwo and the buffer         *
*             containing the indice to LuTmp. Before draining the      *
*             buffers they are sorted in ascending order using the     *
*             ESSL routine ISORTX.                                     *
*                                                                      *
*     Called from: PLF2,INDSFT2                                        *
*                                                                      *
*     Calls to : PKI4,PKR8,SetVec,ErrTra,ISORTX,I4Len,R8Len            *
*                                                                      *
*     Calling Parameters:                                              *
*     nUt    : number of 2el integrals in the buffers vInt,nSqNum      *
*              and nSyBlk                                              *
*     vInt   : Buffer of 2el integral values                           *
*     nSqNum : sequence number of the integral relative to             *
*              the first adress of the symmetry block                  *
*     nSyBlk : symmetry block number of an integral                    *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDef  : definitions of the record structure                    *
*     TwoDat : definitions of sorting flags and address tables         *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*     Srt1    : common block containing information the number of      *
*               bins and partitioning of symmetry blocks               *
*     Srt2    : common block containing information pertinent to       *
*               the bin sorting algorithm                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.-AA. Malmqvist                             *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*     - modified to use a virtual disk                                 *
*       M. P. Fuelscher, University of Lund, Sweden, 1996              *
*                                                                      *
************************************************************************
*
      use srt2
      Implicit Real*8 (A-H,O-Z)
*
#include "Molcas.fh"
#include "TwoDat.fh"
#include "srt0.fh"
#include "srt1.fh"
#include "stdalloc.fh"
#include "print.fh"
*
      Real*8 vInt(nUt),nSqNum(nUt),nSyBlk(nUt)
*
*----------------------------------------------------------------------*
*     pick up print level                                              *
*----------------------------------------------------------------------*
*
      iRout = 81
      iPrint = nPrint(iRout)
      If ( iPrint.ge.99 ) then
        Write(6,*) ' >>> Enter SORT1A <<<'
        Call dVcPrt('nSqNum',' ',nSqNum,nUt)
        Call dVcPrt('nSyBlk',' ',nSyBlk,nUt)
        Call dVcPrt('vInt',' ',vInt,nUt)
      End If
*
*----------------------------------------------------------------------*
*     Turn timing ON                                                   *
*----------------------------------------------------------------------*
*
      If ( RAMD ) then
        Call SORT1C(nUt,vInt,nSqNum,nSyBlk)
        Return
      End If
*
      iOpt=0 ! Always tight!
*
*----------------------------------------------------------------------*
*     put the 2el integrals into the bins                              *
*----------------------------------------------------------------------*
*
      Do iUt=1,nUt
         iBin=INT(nSyBlk(iUt))
         next=nInt(iBin)+1
         lwVBin(next,iBin)=vInt(iUt)
         lwIBin(next,iBin)=INT(nSqNum(iUt))
         nInt(iBin)=next
         mInt(1,iBin)=mInt(1,iBin)+1
*
*----------------------------------------------------------------------*
*     If a bin is completed pack the buffer and put it to disc         *
*     First, sort the the integrals such that the indices are given in *
*     strictly ascending order.                                        *
*----------------------------------------------------------------------*
*
         If ( next.ge.(lBin-1) ) Then
            Call SaveBin(iBin,iOpt)
         End If
      End Do
*
*----------------------------------------------------------------------*
*     Turn timing OFF and exit                                         *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine meminit_cvb()
      implicit real*8 (a-h,o-z)
#include "memman_cvb.fh"

      memdebug=.false.
      nfield=0
      ioff_r=0
      ioff_i=0
      call setmem('trace=off')
      call setmem('clear=off')
      if(memdebug)then
        write(6,*)' Casvb memory handler initialized.'
        write(6,*)' Memory offsets : integer= ',ioff_i,' real= ',ioff_r
        write(6,*)' No. of fields in use :',nfield
      endif

      return
      end
c
c  -- All memory allocated via real*8 routines ---
c
      integer function mheapr_cvb(nword1)
c  Memory allocator (heap). Returns pointer to NWORD real*8 words.
      implicit real*8 (a-h,o-z)
#include "memman_cvb.fh"

      nword=nword1
      if(memdebug)write(6,*)'     Enter mheapr: nword :',nword
      if(nword.lt.0)then
        write(6,*)' Error: attempting to allocate negative ',
     >    'amount of memory.'
        write(6,*)' nword=',nword
        call abend_cvb()
      endif
      call getmem('casvb','ALLO','REAL',ipoint_g,nword)
      mheapr_cvb=ipoint_g+ioff_r
      if(memdebug)write(6,*)'     mheapr: nword & pointer :',
     >  nword,mheapr_cvb
      return
      end
      integer function mstackr_cvb(nword)
c  Memory allocator (stack). Returns pointer to NWORD real*8 words.
      implicit real*8 (a-h,o-z)
#include "memman_cvb.fh"

      if(memdebug)write(6,*)'     Enter mstackr: nword :',nword
      mstackr_cvb=mheapr_cvb(nword)
      nfield=nfield+1
      if(nfield.gt.mxfield)then
        write(6,*)' Too many field in mstackr :',nfield,mxfield
        call abend_cvb()
      endif
      iaddr(nfield)=mstackr_cvb
      if(memdebug)write(6,*)'     mstackr: nword & pointer :',
     >  nword,mstackr_cvb
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

subroutine Alaska_banner()

use Definitions, only: u6

implicit none

! figlet -f larry3d.flf Alaska
write(u6,100) " ______   ___                     __"
write(u6,100) "/\  _  \ /\_ \                   /\ \"
write(u6,100) "\ \ \L\ \\//\ \      __      ____\ \ \/'\      __"
write(u6,100) " \ \  __ \ \ \ \   /'__`\   /',__\\ \ , <    /'__`\"
write(u6,100) "  \ \ \/\ \ \_\ \_/\ \L\.\_/\__, `\\ \ \\`\ /\ \L\.\_"
write(u6,100) "   \ \_\ \_\/\____\ \__/.\_\/\____/ \ \_\ \_\ \__/.\_\"
write(u6,100) "    \/_/\/_/\/____/\/__/\/_/\/___/   \/_/\/_/\/__/\/_/"
write(u6,100) ""
write(u6,100) ""

100 format(25x,a)

end subroutine Alaska_banner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_multi_T_buffer

use fmm_global_paras, only: INTK, T_pair_batch, T_pair_single, One
use fmm_stats, only: stat_tpack_chunks, stat_tpack_total
use fmm_utils, only: fmm_quit

implicit none
private
! public procedures
public :: fmm_init_multi_T_buffer, &
          fmm_free_multi_T_buffer, &
          fmm_multi_T_buffer_add

integer(INTK), parameter :: BUFFER_SIZE = 1000
! module wide variables
integer(INTK), save :: ndim_max
type(T_pair_batch), save :: T_pair_buffer

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_multi_T_buffer(ndim_max_in)

  implicit none
  integer(INTK), intent(in) :: ndim_max_in

  !ndim_max = ndim_max_in*2  ! we multiply by two for "paired" algorithm
  ndim_max = ndim_max_in
  if (ndim_max < 1) call fmm_quit('invalid multiple T-matrix dimension!')
  nullify(T_pair_buffer%items)
  allocate(T_pair_buffer%items(BUFFER_SIZE))
  T_pair_buffer%ndim = 0

end subroutine fmm_init_multi_T_buffer

!-------------------------------------------------------------------------------

subroutine fmm_free_multi_T_buffer(T_contractor)

  implicit none
  external :: T_contractor

  if (.not. associated(T_pair_buffer%items)) call fmm_quit('T_pair_buffer not alloc.')
  if (T_pair_buffer%ndim /= 0) then
    call expunge_multi_buffer(T_contractor)
    T_pair_buffer%ndim = 0
  end if
  deallocate(T_pair_buffer%items)
  nullify(T_pair_buffer%items)

end subroutine fmm_free_multi_T_buffer

!-------------------------------------------------------------------------------
!
!subroutine fmm_multi_T_buffer_add(T_contractor,T_pair)
!
!  implicit none
!  type(T_pair_single), intent(in) :: T_pair
!  external                        :: T_contractor
!
!  integer(INTK), save :: iRHS_last = 0
!  integer(INTK) :: iRHS
!
!  iRHS = T_pair%paras%RHS_id
!
!  !!!!if (BTEST(T_pair_buffer%ndim+1,0)) then
!    ! number of buffer entries is even; try to expunge
!    if ((T_pair_buffer%ndim == ndim_max) .or. ((iRHS /= iRHS_last) .and. (iRHS_last /= 0)) ) then
!      ! expunge buffer and build all the T-matrices at once
!      call T_contractor(T_pair_buffer)
!      T_pair_buffer%ndim = 0
!    end if
!    iRHS_last = T_pair%paras%RHS_id
!  !!!!end if
!
!  T_pair_buffer%ndim = T_pair_buffer%ndim +1
!  T_pair_buffer%items(T_pair_buffer%ndim) = T_pair
!
!end subroutine fmm_multi_T_buffer_add
!
!-------------------------------------------------------------------------------

subroutine fmm_multi_T_buffer_add(T_contractor,T_pair)

  implicit none
  type(T_pair_single), intent(in) :: T_pair
  external                        :: T_contractor

  if (T_pair_buffer%ndim == BUFFER_SIZE) then
    ! expunge buffer and build all the T-matrices at once
    call expunge_multi_buffer(T_contractor)
  end if

  stat_tpack_total = stat_tpack_total+one
  T_pair_buffer%ndim = T_pair_buffer%ndim+1
  T_pair_buffer%items(T_pair_buffer%ndim) = T_pair

end subroutine fmm_multi_T_buffer_add

!-------------------------------------------------------------------------------

subroutine expunge_multi_buffer(T_contractor)

  use fmm_sort_T_pairs, only: fmm_quicksort_wrt_RHS

  implicit none
  external :: T_contractor

  integer(INTK) :: i, lo
  integer(INTK) :: iRHS, iRHS_next, item_max
  type(T_pair_batch) :: ptr

  lo = 1
  item_max = min((BUFFER_SIZE-1),(T_pair_buffer%ndim-1))

  ! sort only if needed
  iRHS = T_pair_buffer%items(1)%paras%RHS_id
  do i=2,item_max
    iRHS_next = T_pair_buffer%items(i)%paras%RHS_id
    if (iRHS_next < iRHS) then
      call fmm_quicksort_wrt_RHS(T_pair_buffer%items(1:item_max))
      exit
    end if
    iRHS = iRHS_next
  end do

  do i=1,item_max
    iRHS = T_pair_buffer%items(i)%paras%RHS_id
    iRHS_next = T_pair_buffer%items(i+1)%paras%RHS_id
    ptr%ndim = i-lo+1
    if ((iRHS /= iRHS_next) .or. (ptr%ndim == ndim_max)) then
      ptr%items => T_pair_buffer%items(lo:i)
      call T_contractor(ptr)
      lo = i+1
    end if
  end do

  ptr%ndim = (item_max+1)-lo+1
  ptr%items => T_pair_buffer%items(lo:(item_max+1))
  call T_contractor(ptr)

  T_pair_buffer%ndim = 0
  stat_tpack_chunks = stat_tpack_chunks+one

end subroutine expunge_multi_buffer

!-------------------------------------------------------------------------------

end module fmm_multi_T_buffer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine KnEPrm( &
#                 define _CALLING_
#                 include "prm_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: to compute the kinetic energy integrals with the Gauss-      *
!         Hermite quadrature.                                          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!             Modified to multipole moments November '90               *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Her_RW, only: HerR, HerW, iHerR, iHerW
use Definitions, only: wp, iwp, u6

implicit none
#include "prm_interface.fh"
integer(kind=iwp) :: nip, ipAxyz, ipBxyz, ipRxyz, ipQxyz, ipTxyz, ipA, ipB, ipAOff, ipBOff, iBeta
logical(kind=iwp) :: ABeq(3)

#include "macros.fh"
unused_var(ZInv)
unused_var(iCnttp)

ABeq(:) = (A(:) == RB(:))

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+2)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+2)
ipRxyz = nip
nip = nip+nZeta*3*nHer*(nOrdOp-1)
ipQxyz = nip
nip = nip+nZeta*3*(la+2)*(lb+2)*(nOrdOp-1)
ipTxyz = nip
nip = nip+nZeta*3*(la+1)*(lb+1)
ipA = nip
nip = nip+nZeta
ipB = nip
nip = nip+nZeta
!                                                                      *
!***********************************************************************
!                                                                      *
if (nip-1 > nArr*nZeta) then
  call WarningMessage(2,'KnEPrm: nip-1 > nArr*nZeta')
  write(u6,*) 'nip=',nip
  write(u6,*) 'nArr,nZeta=',nArr,nZeta
  call Abend()
end if

#ifdef _DEBUGPRINT_
call RecPrt(' In KnEPrm: A',' ',A,1,3)
call RecPrt(' In KnEPrm: RB',' ',RB,1,3)
call RecPrt(' In KnEPrm: Ccoor',' ',Ccoor,1,3)
call RecPrt(' In KnEPrm: P',' ',P,nZeta,3)
write(u6,*) ' In KnEPrm: la,lb=',la,lb
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the cartesian values of the basis functions angular part

call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),la+1,HerR(iHerR(nHer)),nHer,ABeq)
call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),lb+1,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the contribution from the multipole moment operator

ABeq(1) = .false.
ABeq(2) = .false.
ABeq(3) = .false.
call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),nOrdOp-2,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the cartesian components for the multipole moment
! integrals. The integrals are factorized into components.

call Assmbl(Array(ipQxyz),Array(ipAxyz),la+1,Array(ipRxyz),nOrdOp-2,Array(ipBxyz),lb+1,nZeta,HerW(iHerW(nHer)),nHer)

! Compute the cartesian components for the kinetic energy integrals.
! The kinetic energy components are linear combinations of overlap
! components.

ipAOff = ipA
ipBOff = ipB
do iBeta=1,nBeta
  Array(ipAOff:ipAOff+nAlpha-1) = Alpha(:)
  Array(ipBOff:ipBOff+nAlpha-1) = Beta(iBeta)
  ipAOff = ipAOff+nAlpha
  ipBOff = ipBOff+nAlpha
end do

call Kntc(Array(ipTxyz),Array(ipQxyz),la,lb,Array(ipA),Array(ipB),nZeta)

! Combine the cartesian components to the full one electron
! integral.

call CmbnKE(Array(ipQxyz),nZeta,la,lb,nOrdOp-2,Zeta,rKappa,rFinal,nComp,Array(ipTxyz))

return

end subroutine KnEPrm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine XT_dMoverdH_single( nss, nTempMagn, nT, nM,
     &                                Tmin, Tmax, chit_exp, eso, T,
     &                                zJ, Xfield, EM, dM, sM,
     &                                XT_no_field, tinput, smagn, mem )
c       chi*t ----------- the units are cgsemu: [ cm^3*k/mol ]
      Implicit None
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
!#include "mgrid.fh"
#include "stdalloc.fh"
      Integer, intent(in) :: nss, nTempMagn, nT, NM, mem
      Real(kind=8), intent(in) :: Tmin, Tmax
      Real(kind=8), intent(in) :: zJ
      Real(kind=8), intent(in) :: Xfield
      Real(kind=8), intent(in) :: EM
      Real(kind=8), intent(in) :: eso(nss)
      Real(kind=8), intent(in) :: T(nT+nTempMagn)
      Real(kind=8), intent(in) :: chit_exp(nT)
      Real(kind=8), intent(in) :: XT_no_field( nT+nTempMagn )
      Complex(kind=8), intent(in) :: dM(3,nss,nss)
      Complex(kind=8), intent(in) :: sM(3,nss,nss)
      Logical, intent(in)          :: tinput, smagn
cccc local variables ccc
      Integer       :: iM,iT,jT,i,j,l, nDirX
      Logical       :: m_paranoid
      Real(kind=8) :: THRS
      Real(kind=8), allocatable :: WM1(:), WM2(:), WM3(:), WM4(:),
     &                              WM5(:), WM6(:), WM7(:)
      !WM0(nm), WM1(nm), WM2(nm) ! Zeeman exchange energies
c data for total system:
!total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT1(:)
      Real(kind=8), allocatable :: ST1(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT1(:,:) ! total magnetisation
!total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT2(:)
      Real(kind=8), allocatable :: ST2(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT2(:,:) ! total magnetisation
!total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT3(:)
      Real(kind=8), allocatable :: ST3(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT3(:,:) ! total magnetisation
!total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT4(:)
      Real(kind=8), allocatable :: ST4(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT4(:,:) ! total magnetisation
!total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT5(:)
      Real(kind=8), allocatable :: ST5(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT5(:,:) ! total magnetisation
!total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT6(:)
      Real(kind=8), allocatable :: ST6(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT6(:,:) ! total magnetisation
!total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ZT7(:)
      Real(kind=8), allocatable :: ST7(:,:) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT7(:,:) ! total magnetisation
c standard deviation data:
      Real(kind=8) :: dev
      external dev
      Real(kind=8), allocatable :: XTM_MH(:) !XTM_MH(  nT+nTempMagn)
      Real(kind=8), allocatable :: XTM_dMdH(:) !XTM_dMdH(nT+nTempMagn)
      Real(kind=8), allocatable :: XTtens_MH(:,:,:)
!                                   XTtens_MH(  3,3,nT+nTempMagn)
      Real(kind=8), allocatable :: XTtens_dMdH(:,:,:)
!                                   XTtens_dMdH(3,3,nT+nTempMagn)

      Integer       :: nTempTotal
      Real(kind=8) :: Xfield_1, Xfield_2, Xfield_3, Xfield_4, Xfield_5,
     &                 Xfield_6, Xfield_7
      Real(kind=8) :: hp

      Real(kind=8) :: dHX(3)
      Real(kind=8) :: dHY(3)
      Real(kind=8) :: dHZ(3)
      Real(kind=8) :: dHW(3)

      Integer       :: Info
      Real(kind=8) :: WT(3), ZT(3,3)

      Integer       :: mem_local, RtoB
      Real(kind=8) :: cm3tomB
      logical       :: DBG

      DBG=.false.
      m_paranoid=.true.!.false.
      cm3tomB=0.5584938904_wp   !   in cm3 * mol-1 * T
!     threshold for convergence of average spin, in case (zJ .ne. 0)
      THRS=1.d-13
      RtoB=8
      mem_local=0

cccc-------------------------------------------------------cccc
      If(DBG) Then
         Write(6,'(A, 10I5)') '       nss =',nss
         Write(6,'(A,   I5)') ' nTempMagn =',nTempMagn
         Write(6,'(A,   I5)') '        nT =',nT
         Write(6,'(A,   I5)') '        nM =',nM
         Write(6,'(A,F12.5)') '      Tmin =',Tmin
         Write(6,'(A,F12.5)') '      Tmax =',Tmax
         Write(6,'(A,F12.5)') '        zJ =',zJ
         Write(6,'(A,F12.5)') '    Xfield =',Xfield
         Write(6,'(A,F12.5)') '        EM =',EM
         Write(6,'(A,E12.5)') '      THRS =',THRS
         Write(6,          *) '     smagn =',smagn
         Write(6,          *) '    tinput =',tinput
         If (tinput) Then
            Do iT=1,nTempMagn
               Write(6,'(2(A,i3,A,F12.6,2x))') 'T(',iT,')=',T(iT)
            End Do
            Do iT=1,nT
               jT=iT+nTempMagn
               Write(6,'(2(A,i3,A,F12.6,2x))') 'T(',jT,')=',T(jT),
     &                          ' chiT_exp(',iT,')=',chit_exp(iT)
           End Do

         Else
           Do iT=1,nT+nTempMagn
             Write(6,'(2(A,i3,A,F12.6,2x))') 'T(',iT,')=',T(iT)
           End Do
         End If
         Write(6,'(A)') 'SPIN-ORBIT ENERGY'
         Write(6,'(10F12.5)') (ESO(i),i=1,NSS)
         Call xFlush(6)
      End If !DBG
cccc-------------------------------------------------------cccc
      Write(6,*)
      Write(6,'(100A)') (('%'),J=1,95)
      Write(6,'(16X,A)') 'CALCULATION OF THE FIELD-DEPENDENT '//
     &                   'MAGNETIC SUSCEPTIBILITY'
      Write(6,'(18X,A)') 'within true (dM/dH) and "experimentalists"'//
     &                   ' (M/H) models'
      Write(6,'(100A)') (('%'),J=1,95)
      Write(6,*)
      Write(6,'(2x,A,F10.6,A)') 'Magnetic field strength:',Xfield,
     &                          ' Tesla.'
      Write(6,'(2x,A,F10.6,A)') 'dM/dH is computed numerically '//
     &                          'using 7 point stencil formula, with '//
     &                          'h=0.00001'

      If(tinput) Then
         Write(6,'(2x,a)') 'Temperature dependence of the magnetic '//
     &                     'susceptibility and'
         Write(6,'(2x,a)') 'high-field magnetization will be '//
     &                     'calculated according to '
         Write(6,'(2x,a)') 'experimental values provided by the '//
     &                     'user in file "chitexp.input".'
      Else
         Write(6,'(2x,a,i3,a)') 'Temperature dependence of the '//
     &                          'magnetic susceptibility will be '//
     &                          'calculated in',nT,' points, '
         Write(6,'(2x,a,f4.1,a,f6.1,a)') 'equally distributed in '//
     &                          'temperature range ',tmin,' ---',
     &                           tmax,' K.'
      End If
! allocate memory:
      If ( nM >= 0 ) Then
         Call mma_allocate(WM1,nM,'WM1')
         Call mma_allocate(WM2,nM,'WM2')
         Call mma_allocate(WM3,nM,'WM3')
         Call mma_allocate(WM4,nM,'WM4')
         Call mma_allocate(WM5,nM,'WM5')
         Call mma_allocate(WM6,nM,'WM6')
         Call mma_allocate(WM7,nM,'WM7')
         mem_local=mem_local+7*nM*RtoB
      End If
      If ( (nT+nTempMagn) >= 0 ) Then
         Call mma_allocate(ZT1,(nT+nTempMagn),'ZT1')
         Call mma_allocate(ZT2,(nT+nTempMagn),'ZT2')
         Call mma_allocate(ZT3,(nT+nTempMagn),'ZT3')
         Call mma_allocate(ZT4,(nT+nTempMagn),'ZT4')
         Call mma_allocate(ZT5,(nT+nTempMagn),'ZT5')
         Call mma_allocate(ZT6,(nT+nTempMagn),'ZT6')
         Call mma_allocate(ZT7,(nT+nTempMagn),'ZT7')
         mem_local=mem_local+7*(nT+nTempMagn)*RtoB

         Call mma_allocate(MT1,3,(nT+nTempMagn),'MT0')
         Call mma_allocate(MT2,3,(nT+nTempMagn),'MT1')
         Call mma_allocate(MT3,3,(nT+nTempMagn),'MT3')
         Call mma_allocate(MT4,3,(nT+nTempMagn),'MT4')
         Call mma_allocate(MT5,3,(nT+nTempMagn),'MT5')
         Call mma_allocate(MT6,3,(nT+nTempMagn),'MT6')
         Call mma_allocate(MT7,3,(nT+nTempMagn),'MT7')

         Call mma_allocate(ST1,3,(nT+nTempMagn),'ST1')
         Call mma_allocate(ST2,3,(nT+nTempMagn),'ST2')
         Call mma_allocate(ST3,3,(nT+nTempMagn),'ST3')
         Call mma_allocate(ST4,3,(nT+nTempMagn),'ST4')
         Call mma_allocate(ST5,3,(nT+nTempMagn),'ST5')
         Call mma_allocate(ST6,3,(nT+nTempMagn),'ST6')
         Call mma_allocate(ST7,3,(nT+nTempMagn),'ST7')
         mem_local=mem_local+14*3*(nT+nTempMagn)*RtoB

         Call mma_allocate(XTM_MH  ,(nT+nTempMagn),'XTM_MH')
         Call mma_allocate(XTM_dMdH,(nT+nTempMagn),'XTM_dMdH')
         Call mma_allocate(XTtens_MH  ,3,3,(nT+nTempMagn),'XTtens_MH')
         Call mma_allocate(XTtens_dMdH,3,3,(nT+nTempMagn),'XTtens_dMdH')
         mem_local=mem_local+(2+2*3*3)*(nT+nTempMagn)*RtoB
      End If
      If(dbg) Write(6,*) 'XTMG:  memory allocated (local):'
      If(dbg) Write(6,*) 'mem_local=', mem_local
      If(dbg) Write(6,*) 'XTMG:  memory allocated (total):'
      If(dbg) Write(6,*) 'mem_total=', mem+mem_local





      dHX=0.0_wp
      dHY=0.0_wp
      dHZ=0.0_wp
      dHW=0.0_wp

      nDirX=3

      ! field along X
      dHX(1)=1.0_wp
      dHY(1)=0.0_wp
      dHZ(1)=0.0_wp
      ! field along Y
      dHX(2)=0.0_wp
      dHY(2)=1.0_wp
      dHZ(2)=0.0_wp
      ! field along Z
      dHX(3)=0.0_wp
      dHY(3)=0.0_wp
      dHZ(3)=1.0_wp

      Call dcopy_(3*3*(nT+nTempMagn),[0.0_wp],0,XTtens_MH,1)
      Call dcopy_(3*3*(nT+nTempMagn),[0.0_wp],0,XTtens_dMdH,1)

      hp=0.0001_wp
      Xfield_1=Xfield-3.0_wp*hp
      Xfield_2=Xfield-2.0_wp*hp
      Xfield_3=Xfield-1.0_wp*hp
      Xfield_4=xField
      Xfield_5=Xfield+1.0_wp*hp
      Xfield_6=Xfield+2.0_wp*hp
      Xfield_7=Xfield+3.0_wp*hp
      If(dbg) Write(6,*) 'XTMG:  Xfield: ', Xfield_1, Xfield_2,
     &        Xfield_3, Xfield_4, Xfield_5, Xfield_6, Xfield_7
     &

      nTempTotal=nT+nTempMagn
      m_paranoid = .true.


c ///  opening the loop over different directions of the magnetic field
      Do iM=1,nDirX
         Call dcopy_(nM,[0.0_wp],0,WM1,1)
         Call dcopy_(nM,[0.0_wp],0,WM2,1)
         Call dcopy_(nM,[0.0_wp],0,WM3,1)
         Call dcopy_(nM,[0.0_wp],0,WM4,1)
         Call dcopy_(nM,[0.0_wp],0,WM5,1)
         Call dcopy_(nM,[0.0_wp],0,WM6,1)
         Call dcopy_(nM,[0.0_wp],0,WM7,1)

         Call dcopy_(  (nT+nTempMagn),[0.0_wp],0,ZT1,1)
         Call dcopy_(  (nT+nTempMagn),[0.0_wp],0,ZT2,1)
         Call dcopy_(  (nT+nTempMagn),[0.0_wp],0,ZT3,1)
         Call dcopy_(  (nT+nTempMagn),[0.0_wp],0,ZT4,1)
         Call dcopy_(  (nT+nTempMagn),[0.0_wp],0,ZT5,1)
         Call dcopy_(  (nT+nTempMagn),[0.0_wp],0,ZT6,1)
         Call dcopy_(  (nT+nTempMagn),[0.0_wp],0,ZT7,1)

         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT1,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT2,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT3,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT4,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT5,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT6,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,MT7,1)

         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST1,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST2,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST3,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST4,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST5,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST6,1)
         Call dcopy_(3*(nT+nTempMagn),[0.0_wp],0,ST7,1)

        ! compute magnetization:
        ! seven points numerical field perturbation:
           !  Xfield =XF -3h
         Call MAGN( NSS, NM, dHX(iM), dHY(iM), dHZ(iM), XField_1,
     &              ESO, zJ, THRS,  DM, SM, nTempTotal, T, smagn,
     &              WM1, ZT1, ST1, MT1, m_paranoid, DBG )
           !  Xfield =XF -2h
         Call MAGN( NSS, NM, dHX(iM), dHY(iM), dHZ(iM), XField_2,
     &              ESO, zJ, THRS,  DM, SM, nTempTotal, T, smagn,
     &              WM2, ZT2, ST2, MT2, m_paranoid, DBG )
           !  Xfield =XF -h
         Call MAGN( NSS, NM, dHX(iM), dHY(iM), dHZ(iM), XField_3,
     &              ESO, zJ, THRS,  DM, SM, nTempTotal, T, smagn,
     &              WM3, ZT3, ST3, MT3, m_paranoid, DBG )
           !  Xfield =XF
         Call MAGN( NSS, NM, dHX(iM), dHY(iM), dHZ(iM), XField_4,
     &              ESO, zJ, THRS,  DM, SM, nTempTotal, T, smagn,
     &              WM4, ZT4, ST4, MT4, m_paranoid, DBG )
           !  Xfield =XF +h
         Call MAGN( NSS, NM, dHX(iM), dHY(iM), dHZ(iM), XField_5,
     &              ESO, zJ, THRS,  DM, SM, nTempTotal, T, smagn,
     &              WM5, ZT5, ST5, MT5, m_paranoid, DBG )
           !  Xfield =XF +2h
         Call MAGN( NSS, NM, dHX(iM), dHY(iM), dHZ(iM), XField_6,
     &              ESO, zJ, THRS,  DM, SM, nTempTotal, T, smagn,
     &              WM6, ZT6, ST6, MT6, m_paranoid, DBG )
           !  Xfield =XF +3h
         Call MAGN( NSS, NM, dHX(iM), dHY(iM), dHZ(iM), XField_7,
     &              ESO, zJ, THRS,  DM, SM, nTempTotal, T, smagn,
     &              WM7, ZT7, ST7, MT7, m_paranoid, DBG )

      If(DBG) Then
        Do iT=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex1(',iT,')=',(MT1(l,iT),l=1,3)
        End Do
        Do iT=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex2(',iT,')=',(MT2(l,iT),l=1,3)
        End Do
        Do iT=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex3(',iT,')=',(MT3(l,iT),l=1,3)
        End Do
        Do iT=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex4(',iT,')=',(MT4(l,iT),l=1,3)
        End Do
        Do iT=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex5(',iT,')=',(MT5(l,iT),l=1,3)
        End Do
        Do iT=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex6(',iT,')=',(MT6(l,iT),l=1,3)
        End Do
        Do iT=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex7(',iT,')=',(MT7(l,iT),l=1,3)
        End Do
        Do iT=1,nTempTotal
          Write(6,'(A,i3,A,9E22.14)') 'Mex 7-1 (',iT,')=',
     &                                (MT7(l,iT)-MT1(l,iT),l=1,3)
        End Do
      End If !DBG
!        computing the AVERAGE MOMENTS calculated at different temperatures (T(i))
         Do iT=1,nTempTotal

            ! dM/dH model
            If(iM==1) Then
            XTtens_dMdH(iM,1,iT) = (-1.0_wp*MT1(1,iT)
     &                              +9.0_wp*MT2(1,iT)
     &                             -45.0_wp*MT3(1,iT)
     &                              +0.0_wp*MT4(1,iT)
     &                             +45.0_wp*MT5(1,iT)
     &                              -9.0_wp*MT6(1,iT)
     &                              +1.0_wp*MT7(1,iT) ) *T(iT)* cm3tomB
     &                             / (60.0_wp* hp)

            Else If (iM==2) Then
            XTtens_dMdH(iM,2,iT) = (-1.0_wp*MT1(2,iT)
     &                              +9.0_wp*MT2(2,iT)
     &                             -45.0_wp*MT3(2,iT)
     &                              +0.0_wp*MT4(2,iT)
     &                             +45.0_wp*MT5(2,iT)
     &                              -9.0_wp*MT6(2,iT)
     &                              +1.0_wp*MT7(2,iT) ) *T(iT)* cm3tomB
     &                             / (60.0_wp* hp)
            Else If (iM==3) Then
            XTtens_dMdH(iM,3,iT) = (-1.0_wp*MT1(3,iT)
     &                              +9.0_wp*MT2(3,iT)
     &                             -45.0_wp*MT3(3,iT)
     &                              +0.0_wp*MT4(3,iT)
     &                             +45.0_wp*MT5(3,iT)
     &                              -9.0_wp*MT6(3,iT)
     &                              +1.0_wp*MT7(3,iT) ) *T(iT)* cm3tomB
     &                             / (60.0_wp* hp)
            End If

            ! M/H model
            If(iM==1) Then
            XTtens_MH(iM,1,iT) = MT4(1,iT)*T(iT)*cm3tomB/Xfield
            Else If (iM==2) Then
            XTtens_MH(iM,2,iT) = MT4(2,iT)*T(iT)*cm3tomB/Xfield
            Else If (iM==3) Then
            XTtens_MH(iM,3,iT) = MT4(3,iT)*T(iT)*cm3tomB/Xfield
            End If
         End Do
c ///  closing the loops over field directions
      End Do ! iM (nDirX)



c computing the XT as tensor's average:
      XTM_dMdH=0.0_wp
      XTM_MH  =0.0_wp
      Do iT=1,nTempTotal
         XTM_dMdH(iT) = ( XTtens_dMdH(1,1,iT)
     &                  + XTtens_dMdH(2,2,iT)
     &                  + XTtens_dMdH(3,3,iT) ) / 3.0_wp

         XTM_MH(iT)   = ( XTtens_MH(1,1,iT)
     &                  + XTtens_MH(2,2,iT)
     &                  + XTtens_MH(3,3,iT)   ) / 3.0_wp
      End Do !iT
      Call Add_Info('T_dMdH            ',T       ,nTempTotal,5)
      Call Add_Info('XTM_dMdH          ',XTM_dMdH,nTempTotal,5)
      Call Add_Info('XTM_MH            ',XTM_MH  ,nTempTotal,5)

C -------------------------------------------------------------------
C   WRITING SOME OF THE OUTPUT....
C -------------------------------------------------------------------
      Write(6,*)
      Write(6,'(A)') '----------------------------------------------'//
     &               '----------------------------|'
      Write(6,'(A)') '     |     T      | Statistical |   CHI*T     '//
     &               '|   CHI*T     |   CHI*T     |'
      Write(6,'(A,F6.3,A,F6.3,A)')
     &                '     |            |  Sum (Z)    | H = 0.000 T '//
     &               '| H =',Xfield,' T | H =',XField,' T |'
      Write(6,'(A)') '     |            |             |             '//
     &               '| X = dM/dH   | X = M/H     |'
      Write(6,'(A)') '-----|----------------------------------------'//
     &               '----------------------------|'
      Write(6,'(A)') 'Units|   Kelvin   |    ---      |  cm3*K/mol  '//
     &               '|  cm3*K/mol  |  cm3*K/mol  |'
      Write(6,'(A)') '-----|----------------------------------------'//
     &               '----------------------------|'

      Do iT=1,nT
         jT=iT+nTempMagn
         Write(6,'(A,F11.6,A,E12.5,A,F12.8,A,F12.8,A,F12.7,A)')
     & '     |',T(jT),' |', ZT3(jT),' |',XT_no_field(jT),' |',
     &          XTM_dMdH(jT),' |', XTM_MH(jT), ' |'
      End Do
      Write(6,'(A)') '-----|----------------------------------------'//
     &               '----------------------------|'

c  calcualtion of the standard deviation:
      If (tinput) Then
         Write(6,'(a,5x, f20.14)') 'ST.DEV: X= dM/dH:',
     &          dev(  (nT-nTempMagn),
     &                     XTM_dMdH((1+nTempMagn):(nT+nTempMagn)),
     &                     chit_exp((1+nTempMagn):(nT+nTempMagn))  )
         Write(6,'(a,5x, f20.14)') 'ST.DEV: X= M/H:',
     &          dev(  (nT-nTempMagn),
     &                     XTM_MH((1+nTempMagn):(nT+nTempMagn)),
     &                   chit_exp((1+nTempMagn):(nT+nTempMagn))  )
      Write(6,'(A)') '-----|----------------------------------------'//
     &               '----------------------------|'
      End If !tinput







c print out the main VAN VLECK SUSCEPTIBILITY TENSOR, its main values and main axes:
      Write(6,'(/)')
      Write(6,'(111A)') ('-',i=1,110),'|'
      Write(6,'(25X,A,15x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR '//
     &                         'FOR the  X=dM/dH  model,  '//
     &                         'in cm3*K/mol','|'
      Write(6,'(111A)') ('-',i=1,110),'|'
      Write(6,'(A)') '     T(K)   |   |          Susceptibility '//
     &               'Tensor      |    Main Values  |           '//
     &               '    Main Axes             |'
      Do iT=1,nT
        jT=iT+nTempMagn
        info=0
        wt=0.0_wp
        zt=0.0_wp
        Call DIAG_R2( XTtens_dMdH(:,:,jT) ,3,info,wt,zt)
        Write(6,'(A)') '------------|---|'//
     &                 '------- x --------- y --------- z ---|'//
     &                 '-----------------|'//
     &                 '------ x --------- y --------- z ----|'
        Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                 '            | x |',
     &                  (XTtens_dMdH(1,j,jT),j=1,3),
     &                 ' |  X:',wt(1),'|',(zt(j,1),j=1,3),'|'
        Write(6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),
     &                             '| y |',
     &                  (XTtens_dMdH(2,j,jT),j=1,3),
     &                 ' |  Y:',wt(2),'|',(zt(j,2),j=1,3),'|'
        Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                 '            | z |',
     &                  (XTtens_dMdH(3,j,jT),j=1,3),
     &                 ' |  Z:',wt(3),'|',(zt(j,3),j=1,3),'|'
      End Do
      Write(6,'(111A)') ('-',i=1,110),'|'




      Write(6,'(/)')
      Write(6,'(111A)') ('-',i=1,110),'|'

      Write(6,'(25X,A,15x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR '//
     &                         'FOR the  X = M/H  model,  '//
     &                         'in cm3*K/mol','|'
      Write(6,'(111A)') ('-',i=1,110),'|'
      Write(6,'(A)') '     T(K)   |   |          Susceptibility '//
     &               'Tensor      |    Main Values  |           '//
     &               '    Main Axes             |'
      Do iT=1,nT
        jT=iT+nTempMagn
        info=0
        wt=0.0_wp
        zt=0.0_wp
        Call DIAG_R2( XTtens_MH(:,:,jT) ,3,info,wt,zt)
        Write(6,'(A)') '------------|---|'//
     &                 '------- x --------- y --------- z ---|'//
     &                 '-----------------|'//
     &                 '------ x --------- y --------- z ----|'
        Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                 '            | x |',
     &                  (XTtens_MH(1,j,jT),j=1,3),
     &                 ' |  X:',wt(1),'|',(zt(j,1),j=1,3),'|'
        Write(6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),
     &                             '| y |',
     &                  (XTtens_MH(2,j,jT),j=1,3),
     &                 ' |  Y:',wt(2),'|',(zt(j,2),j=1,3),'|'
        Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                 '            | z |',
     &                  (XTtens_MH(3,j,jT),j=1,3),
     &                 ' |  Z:',wt(3),'|',(zt(j,3),j=1,3),'|'
      End Do
      Write(6,'(111A)') ('-',i=1,110),'|'


      If ( nM >= 0 ) Then
         Call mma_deallocate(WM1)
         Call mma_deallocate(WM2)
         Call mma_deallocate(WM3)
         Call mma_deallocate(WM4)
         Call mma_deallocate(WM5)
         Call mma_deallocate(WM6)
         Call mma_deallocate(WM7)
      End If
      If ( nT+nTempMagn >= 0 ) Then
         Call mma_deallocate(ZT1)
         Call mma_deallocate(ZT2)
         Call mma_deallocate(ZT3)
         Call mma_deallocate(ZT4)
         Call mma_deallocate(ZT5)
         Call mma_deallocate(ZT6)
         Call mma_deallocate(ZT7)

         Call mma_deallocate(MT1)
         Call mma_deallocate(MT2)
         Call mma_deallocate(MT3)
         Call mma_deallocate(MT4)
         Call mma_deallocate(MT5)
         Call mma_deallocate(MT6)
         Call mma_deallocate(MT7)

         Call mma_deallocate(ST1)
         Call mma_deallocate(ST2)
         Call mma_deallocate(ST3)
         Call mma_deallocate(ST4)
         Call mma_deallocate(ST5)
         Call mma_deallocate(ST6)
         Call mma_deallocate(ST7)

         Call mma_deallocate(XTM_MH)
         Call mma_deallocate(XTM_dMdH)
         Call mma_deallocate(XTtens_MH)
         Call mma_deallocate(XTtens_dMdH)
      End If

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grow_w3(w3,AA,nv,d2,dima,dimb,dimc,lasta,lastb,lastc)
! this routine does:
!
! add the block contribution AA(a',b',c') to w3(a>=b,c)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nv, d2, dima, dimb, dimc, lasta, lastb, lastc
real(kind=wp), intent(inout) :: w3(nTri_Elem(nv),d2)
real(kind=wp), intent(in) :: AA(dima,dimb,dimc)
integer(kind=iwp) :: a, a_old, a_point, ab, b, b_old, b_point

if ((dima == 0) .or. (dimb == 0)) then
  write(u6,*) 'dima, dimb = ',dima,dimb
  write(u6,*) 'zle je'
  call abend()
end if

a_point = 0
b_point = 0
ab = 0
!mp write(u6,'(A,3(i5))') 'lasta, lastb, lastc = ',lasta,lastb,lastc
!mp write(u6,'(A,2(i5))') 'dima, dimb          = ',dima,dimb

a_old = 0
b_old = 0

do a=1,nv
  b_point = 0
  do b=1,a
    ab = ab+1
    if ((a >= lasta+1) .and. (a <= lasta+dima)) then

      if (a /= a_old) then
        a_point = a_point+1
        a_old = a
      end if

      if ((b >= max(1,lastb+1)) .and. (b <= min(a,lastb+dimb))) then

        !write(u6,*) 'b, b_old = ',b,b_old
        if ((b /= b_old) .or. (b == max(1,lastb+1))) then
          !write(u6,*) 'wft'
          b_point = b_point+1
          b_old = b
        end if

        !mp if (lastc == 0) write(u6,'(A,5(i5))') 'ab, a, b, a_point, b_point = ',ab,a,b,a_point,b_point
        w3(ab,lastc+1:lastc+dimc) = AA(a_point,b_point,:)

      end if
    end if

  end do
end do

return

end subroutine grow_w3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine schmidtd2_cvb(c1,sxc1,nvec1,c2,nvec2,n)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nvec1, nvec2, n
real(kind=wp), intent(in) :: c1(n,nvec1), sxc1(n,nvec1)
real(kind=wp), intent(inout) :: c2(n,nvec2)
integer(kind=iwp) :: i, j
real(kind=wp), external :: ddot_

do i=1,nvec2
  do j=1,nvec1
    c2(:,i) = c2(:,i)-ddot_(n,c2(:,i),1,sxc1(:,j),1)*c1(:,j)
  end do
end do

return

end subroutine schmidtd2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  trg_series
!
!> @brief  Transform a gradient to a rotated reference, using a series expansion
!> @author Ignacio Fdez. Galvan
!>
!> @details
!> Transforms a gradient computed with respect to the rotation parameters
!> at the "current" orbitals to the rotation parameters at the "reference"
!> orbitals.
!>
!> @see ::trg_svd
!>
!> @param[in]     Nv   Number of virtual orbitals
!> @param[in]     No   Number of occupied orbitals
!> @param[in]     X    Rotation parameters from reference to current
!> @param[in,out] G    Gradient at the current orbitals, will be replaced with the transformed gradient
!***********************************************************************

subroutine trg_series(Nv,No,X,G)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none

integer(kind=iwp), intent(in) :: Nv, No
real(kind=wp), intent(in) :: X(Nv,No)
real(kind=wp), intent(inout) :: G(Nv,No)
integer(kind=iwp) :: i, j, k, term
real(kind=wp) :: aux
real(kind=wp), allocatable :: M(:,:), P(:,:), Q(:,:), tmp(:,:)
integer(kind=iwp), parameter :: maxterm = 30
real(kind=wp), parameter :: thrs = epsilon(thrs)

! This applies the transformation
!
!   G_trans = G + [X,G]/2! + [X,[X,G]]/3! + [X,[X,[X,G]]]/4! + ...
!
! for the special case where G and X are both antisymmetric with a
! single nonzero off-diagonal block. Only the odd terms are relevant.

k = min(No,Nv)
if (k < 1) return

call mma_allocate(P,k,k,label='P')
call mma_allocate(M,k,k,label='M')
call mma_allocate(Q,Nv,No,label='Q')
call mma_allocate(tmp,Nv,No,label='tmp')
if (No <= Nv) then
  ! P = X^T X
  call dgemm_('T','N',No,No,Nv,One,X,Nv,X,Nv,Zero,P,No)
else
  ! P = X X^T
  call dgemm_('N','T',Nv,Nv,No,One,X,Nv,X,Nv,Zero,P,Nv)
end if

Q(:,:) = G(:,:)
do term=1,maxterm
  if (No <= Nv) then
    ! M = Q^T X
    call dgemm_('T','N',No,No,Nv,One,Q,Nv,X,Nv,Zero,M,No)
  else
    ! M = X Q^T
    call dgemm_('N','T',Nv,Nv,No,One,X,Nv,Q,Nv,Zero,M,Nv)
  end if
  ! M = 2M - M^T = M + (M - M^T)
  do j=1,k
    do i=1,j-1
      aux = M(j,i)-M(i,j)
      M(j,i) = M(j,i)+aux
      M(i,j) = M(i,j)-aux
    end do
  end do
  if (No <= Nv) then
    ! Q = X M - Q P
    call dgemm_('N','N',Nv,No,No,One,Q,Nv,P,No,Zero,tmp,Nv)
    call dgemm_('N','N',Nv,No,No,One,X,Nv,M,No,Zero,Q,Nv)
  else
    ! Q = M X - P Q
    call dgemm_('N','N',Nv,No,Nv,One,P,Nv,Q,Nv,Zero,tmp,Nv)
    call dgemm_('N','N',Nv,No,Nv,One,M,Nv,X,Nv,Zero,Q,Nv)
  end if
  ! G = G + Q/(2k+1)!
  Q(:,:) = (Q(:,:)-tmp(:,:))/real(2*term*(2*term+1),kind=wp)
  G(:,:) = G(:,:)+Q(:,:)
  ! Series is converged
  if (maxval(abs(Q)) < thrs) exit
end do
! Not converged
if (term > maxterm) call Abend()

call mma_deallocate(P)
call mma_deallocate(M)
call mma_deallocate(Q)
call mma_deallocate(tmp)

end subroutine trg_series

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CSTART(AREF,EREF,CI,ICI)

use mrci_global, only: ESHIFT, GFAC, IAD25S, ICPF, IDFREE, IDISKC, IDISKD, IDISKS, IREFX, IREST, IROOT, Lu_25, LUEIG, LUREST, &
                       MBUF, MXVEC, NCONF, NNEW, NREF, NRROOT, NSTOT, NVTOT, POTNUC
use guga_util_global, only: nCOP
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: AREF(NREF,NREF), EREF(NREF)
real(kind=wp), intent(out) :: CI(NCONF)
integer(kind=iwp), intent(out) :: ICI(MBUF)
#include "Molcas.fh"
integer(kind=iwp) :: I, I1, I2, IAD25, ID, IR, IREF, ISTA, NN
real(kind=wp) :: GINV
integer(kind=iwp), allocatable :: ISTART(:)
real(kind=wp), allocatable :: Buf(:)

do I=1,MXVEC
  IDISKC(I) = -1
  IDISKS(I) = -1
end do
! FIRST, USE THE CI ARRAY TO STORE THE DIAGONAL ELEMENTS:
call mma_allocate(Buf,nCOP,label='Buf')
IAD25 = IAD25S
do I=1,NCONF,nCOP
  call dDAFILE(Lu_25,2,Buf,nCOP,IAD25)
  NN = min(nCOP,NCONF+1-I)
  CI(I:I+NN-1) = Buf(1:NN)
end do
call mma_deallocate(Buf)
! THESE ARE DIAGONAL ELEMENTS OF THE ELECTRONIC HAMILTONIAN.
! POTNUC SHOULD BE ADDED. IN ADDITION, WE USE AN ENERGY SHIFT.
! NOTE: DISPLACEMENT 1.0e-4 PROTECTS AGAINST DIVIDE ERRORS.
!PAM: Protect all diag elems. Needed in some weird cases.
! ENERGY SHIFT:
ESHIFT = EREF(1)
do I=1,NCONF
  CI(I) = CI(I)+POTNUC-ESHIFT+1.0e-4_wp
end do
call Add_Info('CI_DIAG2',CI(2),1,8)
! REPLACE REFERENCE ENERGIES:
do I=1,NREF
  IR = IREFX(I)
  CI(IR) = EREF(I)-ESHIFT-1.0e-4_wp
end do
if (ICPF == 1) then
  do IREF=1,NREF
    IR = IREFX(IREF)
    CI(IR) = GFAC*CI(IR)
  end do
  GINV = One/GFAC
  CI(:) = GINV*CI
end if
IDFREE = 0
IDISKD = 0
do ISTA=1,NCONF,MBUF
  NN = min(MBUF,(NCONF+1-ISTA))
  call dDAFILE(LUEIG,1,CI(ISTA),NN,IDFREE)
end do
! THEN, SET UP START CI VECTORS IN MCSF BASIS:
CI(:) = Zero
if (IREST == 0) then
  call mma_allocate(ISTART,MXROOT,label='ISTART')
  NNEW = IROOT(NRROOT)
  I1 = 1
  I2 = 1
  do I=1,NNEW
    if (I == IROOT(I1)) then
      ISTART(NNEW-NRROOT+I1) = I
      I1 = I1+1
    else
      ISTART(I2) = I
      I2 = I2+1
    end if
  end do
  if (NNEW > 1) then
    write(u6,*) ' THE FOLLOWING REFERENCE ROOTS ARE USED AS START VECTORS:'
    write(u6,'(12(A,I2))') ' ROOTS NR ',ISTART(1),(',',ISTART(I),I=2,NNEW-1),', AND ',ISTART(NNEW)
    if (NNEW > NRROOT) then
      write(u6,*) ' (THE FIRST EXTRA ROOT(S) WERE INCLUDED IN ORDER TO IMPROVE CONVERGENCE)'
    end if
  else
    write(u6,'(A,I2,A)') ' ROOT NR ',ISTART(1),' IS USED AS START VECTOR.'
  end if
  do I=1,NNEW
    ISTA = ISTART(I)
    IR = IREFX(ISTA)
    CI(IR) = One
    IDISKC(I) = IDFREE
    do ISTA=1,NCONF,MBUF
      NN = min(MBUF,(NCONF+1-ISTA))
      call PKVEC(NN,CI(ISTA),ICI)
      call iDAFILE(LUEIG,1,ICI,NN,IDFREE)
    end do
    CI(IR) = Zero
  end do
  call mma_deallocate(ISTART)
else
  ID = 0
  NNEW = NRROOT
  do I=1,NRROOT
    call dDAFILE(LUREST,2,CI,NCONF,ID)
    call CSFTRA('MCSF',CI,AREF)
    IDISKC(I) = IDFREE
    do ISTA=1,NCONF,MBUF
      NN = min(MBUF,(NCONF+1-ISTA))
      call PKVEC(NN,CI(ISTA),ICI)
      call iDAFILE(LUEIG,1,ICI,NN,IDFREE)
    end do
  end do
end if
NVTOT = NNEW
NSTOT = 0

return

end subroutine CSTART

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2007, Roland Lindh                                *
*               2009, Francesco Aquilante                              *
************************************************************************
      SubRoutine PGet1_CD2(PAO,ijkl,nPAO,iCmp,
     &                 iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,kOp,
     &                 ExFac,CoulFac,PMax,V_k,U_k,mV_k,Z_p_K,nnP1)
************************************************************************
*  Object: to assemble the 2nd order density matrix of a SCF wave      *
*          function from the 1st order density.                        *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*                                                                      *
*             Modified for Cholesky 1-center gradients May 2007 by     *
*             R. Lindh                                                 *
*                                                                      *
*             Modified for RI-HF/CAS, Dec 2009 (F. Aquilante)          *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "WrkSpc.fh"
#include "chomp2g_alaska.fh"
#include "exterm.fh"
      Real*8 PAO(ijkl,nPAO), V_k(mV_k), U_K(mV_K), Z_p_K(nnP1,mV_K),
     &       Fac_ij,Fac_kl
      Integer iAO(4), kOp(4), iAOst(4), iCmp(4)
      Logical Shijij
      External mn2K
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 39
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      Call RecPrt('PGet1_CD2: V_k',' ',V_k,1,mV_k)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Quadruple loop over elements of the basis functions angular
*     description.
*     Observe that we will walk through the memory in PAO in a
*     sequential way.
*
C     Fac = One / Four

      Call CWTime(Cpu1,Wall1)

      Fac = One
      PMax=Zero
      iPAO=0

      iSym = 1
      jSym = 1
      kSym = 1
      lSym = 1
      iSO = 1

      If(ExFac .eq. Zero) Then

         Do i1 = 1, iCmp(1)
            Do i2 = 1, iCmp(2)
               Do i3 = 1, iCmp(3)
                  Do i4 = 1, iCmp(4)
*
*               Unfold the way the eight indicies have been reordered.
                     iSO = iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
                     jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
                     kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
                     lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
                     iPAO = iPAO + 1
                     nijkl = 0
*
                     Do lAOl = 0, lBas-1
                        lSOl = lSO + lAOl
                        Do kAOk = 0, kBas-1
                           kSOk = kSO + kAOk
                           Do jAOj = 0, jBas-1
                              jSOj = jSO + jAOj
                              Do iAOi = 0, iBas-1
                                 iSOi = iSO + iAOi
                                 nijkl = nijkl + 1
*
*---------------------------V_k(ij)*V_k(kl)
*
                                 Indi=Max(iSOi,jSOj)
                                 Indj=iSOi+jSOj-Indi
                                 Indk=Max(kSOk,lSOl)
                                 Indl=kSOk+lSOl-Indk
                                 Indij=(Indi-1)*Indi/2+Indj
                                 Indkl=(Indk-1)*Indk/2+Indl
                                 temp=V_k(Indij)*V_k(Indkl)*CoulFac
*-----Active space contribution (any factor?)
                                 ijVec=mn2K(Indij,1)
                                 klVec=mn2K(Indkl,1)
                                 If (ijVec.eq.0 .or. klVec.eq.0) GoTo 11
                                 Do jp=1,nnP1
                                    temp = temp
     &                                 + Z_p_K(jp,ijVec)*Z_p_K(jp,klVec)
                                 End Do
*
 11                              Continue
                                 PMax=Max(PMax,Abs(temp))
                                 PAO(nijkl,iPAO) = Fac * temp
*
                              End Do
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
      Else If(iMP2prpt .ne. 2) Then
         NumIK = nIJ1(iSym,lSym,iSO)
         If(NumIK.eq.0) Return
         ip_CijK2 = ip_CijK + NumIK

         Do i1 = 1, iCmp(1)
            Do i2 = 1, iCmp(2)
               iSO = iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
               jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)

               Do i3 = 1, iCmp(3)
                  Do i4 = 1, iCmp(4)
                     kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
                     lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

                     iPAO = iPAO + 1
                     nijkl = 0

                     Do lAOl = 0, lBas-1
                        lSOl = lSO + lAOl
                        Do kAOk = 0, kBas-1
                           kSOk = kSO + kAOk
                           Indk=Max(kSOk,lSOl)
                           Indl=kSOk+lSOl-Indk
                           Indkl=(Indk-1)*Indk/2+Indl
                           klVec=mn2K(Indkl,1)
                           If(klvec.ne.0) Then
                              iAdrL = NumIK*(klVec-1)
     &                              + iAdrCVec(jSym,iSym,iSO)
                              Call dDaFile(LuCVector(jSym,iSO),2,
     &                                     Work(ip_CijK),
     &                                     NumIK,iAdrL)
                           End If


                           Do jAOj = 0, jBas-1
                              jSOj = jSO + jAOj
                              Do iAOi = 0, iBas-1
                                 iSOi = iSO + iAOi
                                 nijkl = nijkl + 1
*
                                 Indi=Max(iSOi,jSOj)
                                 Indj=iSOi+jSOj-Indi
                                 Indij=(Indi-1)*Indi/2+Indj
                                 ijVec=mn2K(Indij,1)

                                 If(ijVec.ne.klVec.and.ijvec.ne.0) Then
                                    iAdrJ = NumIK*(ijVec-1) +
     &                                      iAdrCVec(jSym,iSym,iSO)
                                    Call dDaFile(LuCVector(jSym,iSO),2,
     &                                           Work(ip_CijK2),NumIK,
     &                                           iAdrJ)
                                    ip_V2 = ip_CijK2
                                 Else
                                    ip_V2 = ip_CijK
                                 End If

                                 temp=V_k(Indij)*V_k(Indkl)*CoulFac

                                 If (ijVec.eq.0 .or. klVec.eq.0) GoTo 22
                                 If(Indi .eq. Indj) Then
                                    Fac_ij = 1.0d0
                                 Else
                                    Fac_ij = 0.5d0
                                 End If
                                 If(Indk .eq. Indl) Then
                                    Fac_kl = 1.0d0
                                 Else
                                    Fac_kl = 0.5d0
                                 End If

*----- Exchange contribution

                                 temp = temp - ExFac*Fac_ij*Fac_kl*
     &                                  dDot_(NumIK,Work(ip_CijK),1,
     &                                             Work(ip_V2),1)
*-----Active space contribution (any factor?)
                                 Do jp=1,nnP1
                                    temp = temp
     &                                + Z_p_K(jp,ijVec)*Z_p_K(jp,klVec)
                                 End Do
*
 22                              Continue
                                 PMax=Max(PMax,Abs(temp))
                                 PAO(nijkl,iPAO) = Fac * temp
*
                              End Do
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
      Else
         NumIK = nIJ1(iSym,lSym,iSO)
         If(NumIK.eq.0) Return
         ip_CijK2 = ip_CijK + NumIK

         Do i1 = 1, iCmp(1)
            Do i2 = 1, iCmp(2)
               iSO = iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
               jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
               Do i3 = 1, iCmp(3)
                  Do i4 = 1, iCmp(4)
                     kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
                     lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

                     iPAO = iPAO + 1
                     nijkl = 0
*
                     Do lAOl = 0, lBas-1
                        lSOl = lSO + lAOl
                        Do kAOk = 0, kBas-1
                           kSOk = kSO + kAOk
                           Indk=Max(kSOk,lSOl)
                           Indl=kSOk+lSOl-Indk
                           Indkl=(Indk-1)*Indk/2+Indl
                           klVec=mn2K(Indkl,1)
                           If(klvec.ne.0) Then
                              iAdrL = NumIK*(klVec-1)
     &                              + iAdrCVec(jSym,iSym,iSO)
                              Call dDaFile(LuCVector(jSym,iSO),2,
     &                                     Work(ip_CijK),
     &                                     NumIK,iAdrL)
                           End If


                           Do jAOj = 0, jBas-1
                              jSOj = jSO + jAOj
                              Do iAOi = 0, iBas-1
                                 iSOi = iSO + iAOi
                                 nijkl = nijkl + 1
*
                                 Indi=Max(iSOi,jSOj)
                                 Indj=iSOi+jSOj-Indi
                                 Indij=(Indi-1)*Indi/2+Indj
                                 ijVec=mn2K(Indij,1)

                                 If(ijVec.ne.klVec.and.ijvec.ne.0) Then
                                    iAdrJ = NumIK*(ijVec-1) +
     &                                      iAdrCVec(jSym,iSym,iSO)
                                    Call dDaFile(LuCVector(jSym,iSO),2,
     &                                           Work(ip_CijK2),NumIK,
     &                                           iAdrJ)
                                    ip_V2 = ip_CijK2
                                 Else
                                    ip_V2 = ip_CijK
                                 End If

                                 temp= V_k(Indij)*V_k(Indkl)*CoulFac
     &                               + V_K(Indij)*U_K(Indkl)*CoulFac
     &                               + U_K(Indij)*V_K(Indkl)*CoulFac

                                 If (ijVec.eq.0 .or. klVec.eq.0) GoTo 33
                                 If(Indi .eq. Indj) Then
                                    Fac_ij = 1.0d0
                                 Else
                                    Fac_ij = 0.5d0
                                 End If
                                 If(Indk .eq. Indl) Then
                                    Fac_kl = 1.0d0
                                 Else
                                    Fac_kl = 0.5d0
                                 End If

*
*----- MP2 contribution
                                 Call Compute_A_jk_Mp2(1,ijVec,klVec,
     &                                                 tempJ_mp2,
     &                                                 Fac_ij,Fac_kl,
     &                                                 nAuxVe,2)
                                 temp = temp + tempJ_mp2*CoulFac
*
*----- Exchange contribution


                                 tempK = 2.0d0*Fac_ij*Fac_kl*
     &                                   dDot_(NumIK,Work(ip_CijK),1,
     &                                              Work(ip_V2),1)
                                 Call compute_A_jk_Mp2(1,ijVec,klVec,
     &                                tempK_mp2,
     &                                fac_ij,fac_kl,nAuxVe,1)

                                 tempK = tempK + tempK_mp2

                                 temp = temp - ExFac*tempK*Half
*----- Active space contribution (any factor?)
                                 Do jp=1,nnP1
                                    temp = temp
     &                                 + Z_p_K(jp,ijVec)*Z_p_K(jp,klVec)
                                 End Do
*
 33                              Continue
                                 PMax=Max(PMax,Abs(temp))
                                 PAO(nijkl,iPAO) = Fac * temp
*
                              End Do
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End If
*

      If (iPAO.ne.nPAO) Then
         Write (6,*) ' Error in PGet1_CD2!'
         Call Abend
      End If
*
#ifdef _DEBUGPRINT_
      Call RecPrt(' In PGet1_CD2:PAO ',' ',PAO,ijkl,nPAO)
      Call GetMem(' Exit PGet1_CD2','CHECK','REAL',iDum,iDum)
#endif

      Call CWTime(Cpu2,Wall2)
      Cpu = Cpu2 - Cpu1
      Wall = Wall2 - Wall1
      tavec(1) = tavec(1) + Cpu
      tavec(2) = tavec(2) + Wall

      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Shijij)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  PAOLoc
!
!> @brief
!>   Compute projected atomic orbitals (PAOs)
!> @author Thomas Bondo Pedersen
!>
!> @details
!> A set of linearly independent nonorthonormal
!> Projected Atomic Orbitals (PAOs) are computed by projecting
!> the AOs onto the virtual space. Subsequently, the linear
!> dependence may be removed through Cholesky decomposition of a
!> density-type matrix constructed from the linearly dependent
!> PAOs according to \f$ D_{a,b} = \sum_c \mathit{PAO}_{a,c} \mathit{PAO}_{b,c} \f$. Finally,
!> orthonormal linearly independent PAOs may be obtained by
!> multiplying with the inverse square root of the PAO overlap
!> matrix.
!>
!> The Mode input string controls which set is returned in array
!> PAO:
!>
!> - \p Mode = ``'RAW'``: return linearly dependent nonorthonormal PAOs. In this case, array PAO
!>                        should be dimensioned as \p nBas &timens \p nBas (in symmetry blocks).
!> - \p Mode = ``'CHO'``: return linearly independent nonorthonormal PAOs obtained by Cholesky
!>                        decomposition of the density-type matrix. In this case, array PAO should
!>                        be dimensioned as \p nBas &times; \p nVir (in symmetry blocks).
!> - \p Mode = ``'ORT'``: return linearly independent orthonormal PAOs. In this case, array PAO
!>                        should be dimensioned as \p nBas &times; \p nVir (in symmetry blocks).
!>
!> If Mode is anything else, \p Mode = ``'ORT'`` is assumed.
!> Note that if \p nOcc+nVir < \p nBas the remaining \p nBas-nOcc-nVir
!> orbitals are considered part of the orthogonal complement of
!> the virtual space (and are projected out of the AOs when
!> obtaining the raw PAOs). Thus, one may obtain PAOs for any
!> subset of orbitals by specifying \p nOcc and \p nVir arrays
!> appropriately.
!>
!> @note
!> Needs the AO overlap matrix on disk.
!>
!> @param[out] irc  return code
!> @param[in]  CMO  MO coefficients
!> @param[out] PAO  PAOs
!> @param[in]  Thr  Cholesky decomposition threshold
!> @param[in]  nBas Number of basis functions/irrep
!> @param[in]  nOrb Number of orbitals/irrep
!> @param[in]  nOcc Number of occupied orbs/irrep
!> @param[in]  nVir Number of virtual orbs/irrep
!> @param[in]  nSym Number of irreps
!> @param[in]  Mode Mode of calculation
!***********************************************************************

subroutine PAOLoc(irc,CMO,PAO,Thr,nBas,nOrb,nOcc,nVir,nSym,Mode)

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: CMO(*), Thr
real(kind=wp), intent(_OUT_) :: PAO(*)
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym), nOcc(nSym), nVir(nSym)
character(len=*), intent(in) :: Mode
integer(kind=iwp) :: DefLevel, i, iSym, kOff, l_D, Level, lMode, nOrthPs
real(kind=wp) :: ThrLoc, xNrm
logical(kind=iwp) :: Normalize, TestOrth
character(len=3) :: myMode
type(DSBA_Type) :: P, R
real(kind=wp), allocatable :: D(:)
real(kind=wp), parameter :: DefThr = 1.0e-12_wp
character(len=*), parameter :: DefMode = 'ORT', LevMode(3) = ['RAW','CHO','ORT'], SecNam = 'PAOLoc'

#if defined (_DEBUGPRINT_)
TestOrth = .true.
#else
TestOrth = .false.
#endif

! Set return code.
! ----------------

irc = 0

! Set DefLevel from DefMode.
! --------------------------

DefLevel = 0
do i=1,size(LevMode)
  if (DefMode == LevMode(i)) then
    DefLevel = i
    exit
  end if
end do
if (DefLevel == 0) then
  call SysAbendMsg(SecNam,'DefMode not recognized!','Note: this is a programming error...')
  DefLevel = -999999
end if

! Interpret Mode input.
! ---------------------

lMode = len(Mode)
if (lMode < 3) then
  Level = DefLevel
else
  myMode = Mode(1:3)
  call UpCase(myMode)
  Level = DefLevel
  do i=1,size(LevMode)
    if (myMode == LevMode(i)) then
      Level = i
      exit
    end if
  end do
end if

! Compute raw projected AOs.
! --------------------------

call Allocate_DT(R,nBas,nBas,nSym,label='R')

Normalize = .true.
call GetRawPAOs(R%A0,CMO,nBas,nOrb,nOcc,nVir,nSym,Normalize)

if (Level == 1) then
  PAO(1:size(R%A0)) = R%A0
  call FreeMem()
  return
end if

call Allocate_DT(P,nBas,nVir,nSym,label='P',Ref=PAO)

! Use Cholesky decomposition to compute a linearly independent set
! of nonorthonormal PAOs.
! ----------------------------------------------------------------

l_D = nBas(1)**2
do iSym=2,nSym
  l_D = max(l_D,nBas(iSym)**2)
end do
call mma_allocate(D,l_D,label='PAOL_D')

if (Thr <= Zero) then
  ThrLoc = DefThr
else
  ThrLoc = Thr
end if

do iSym=1,nSym
  if (nVir(iSym) > 0) then
    call GetDens_Localisation(D,R%SB(iSym)%A2,nBas(iSym),nBas(iSym))
    call ChoLoc(irc,D,P%SB(iSym)%A2,ThrLoc,xNrm,nBas(iSym),nVir(iSym))
    if (irc /= 0) then
      call FreeMem()
      return
    end if
  end if
end do

if (Level == 2) then
  call FreeMem()
  return
end if

! Orthonormalize the PAOs.
! ------------------------

do iSym=1,nSym
  kOff = nOcc(iSym)+1
  R%SB(iSym)%A2(:,kOff:kOff+nVir(iSym)-1) = P%SB(iSym)%A2(:,1:nVir(iSym))
end do
nOrthPs = 2 ! orthonormalization passes to ensure num. accuracy
call OrthoPAO_Localisation(R%A0,nBas,nOcc,nVir,nSym,nOrthPs,TestOrth)
do iSym=1,nSym
  kOff = nOcc(iSym)+1
  P%SB(iSym)%A2(:,1:nVir(iSym)) = R%SB(iSym)%A2(:,kOff:kOff+nVir(iSym)-1)
end do

call FreeMem()

return

contains

subroutine FreeMem()

  call Deallocate_DT(R)
  call Deallocate_DT(P)
  if (allocated(D)) call mma_deallocate(D)

end subroutine FreeMem

end subroutine PAOLoc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
  Subroutine plot_XT_with_Exp(label, nT, T, XTcalc, XTexp, zJ )

  IMPLICIT NONE

  Integer, parameter    :: wp=kind(0.d0)
  INTEGER, INTENT(in)   :: nT
  REAL (wp), INTENT(in) :: T(nT)
  REAL (wp), INTENT(in) :: XTexp(nT)
  REAL (wp), INTENT(in) :: XTcalc(nT)
  REAL (wp), INTENT(in) :: zJ
  CHARACTER(LEN=50), intent(in) :: label
  ! local variables
  REAL (wp) :: tmin, tmax, XTmin_exp, XTmax_exp, XTmin_calc, XTmax_calc, XTmin, XTmax
  REAL (wp) :: gnuplot_version
  INTEGER               :: file_number, iT, LuPlt, LuData, file_size, StdOut
  LOGICAL               :: file_exist, is_file_open, execute_gnuplot_cmd, dbg
  CHARACTER(LEN=300)    :: line1, line2, cdummy
  CHARACTER(LEN=300)    :: datafile, plotfile, imagefile, epsfile
  INTEGER, EXTERNAL     :: AixRm
  INTEGER               :: Length
  CHARACTER(LEN=1023)   :: realname_plt, realname_dat, realname_png, realname_eps, gnuplot_CMD
  INTEGER               :: iErr
  INTEGER, EXTERNAL     :: IsFreeUnit


  !INTEGER               :: file_number, istat, iT, LuPlt, LuData, file_size, StdOut, iErr
  !LOGICAL               :: file_exist, is_file_open, execute_gnuplot_cmd, dbg
  !CHARACTER(LEN=100)    :: line1, line2, lineOut, cdummy

  StdOut=6
  iErr=0
  dbg=.false.
  tmin=0.0_wp
  tmax=0.0_wp
  XTmin_exp=0.0_wp
  XTmax_exp=0.0_wp
  XTmin_calc=0.0_wp
  XTmax_calc=0.0_wp
  XTmin=0.0_wp
  XTmax=0.0_wp
  tmin=MINVAL(T)-0.05_wp*MAXVAL(T)
  tmax=MAXVAL(T)+0.05_wp*MAXVAL(T)
  XTmin_exp=MINVAL(XTexp)
  XTmax_exp=MAXVAL(XTexp)
  XTmin_calc=MINVAL(XTcalc)
  XTmax_calc=MAXVAL(XTcalc)
  XTmin=MIN(XTmin_exp,XTmin_calc)-0.08_wp*MAX(XTmax_exp,XTmax_calc)
  XTmax=MAX(XTmax_exp,XTmax_calc)+0.08_wp*MAX(XTmax_exp,XTmax_calc)


  IF (dbg) WRITE (StdOut,*) 'nT        = ',nT
  IF (dbg) WRITE (StdOut,*) 'tmin      = ',tmin
  IF (dbg) WRITE (StdOut,*) 'tmax      = ',tmax
  IF (dbg) WRITE (StdOut,*) 'XTmin_exp = ',XTmin_exp
  IF (dbg) WRITE (StdOut,*) 'XTmax_exp = ',XTmax_exp
  IF (dbg) WRITE (StdOut,*) 'XTmin_calc= ',XTmin_calc
  IF (dbg) WRITE (StdOut,*) 'XTmax_calc= ',XTmax_calc
  IF (dbg) WRITE (StdOut,*) 'XTmin     = ',XTmin
  IF (dbg) WRITE (StdOut,*) 'XTmax     = ',XTmax
  IF (dbg) WRITE (StdOut,*) 'zJ        = ',zJ
  IF (dbg) WRITE (StdOut,*) 'label     = ',label
  IF (dbg) THEN
    DO iT=1,nT
      WRITE(StdOut,*) T(iT), XTcalc(iT), XTexp(iT)
    END DO
  END IF

  ! generate the GNUPLOT script in the $WorkDir
  line1=' '
  line2=' '
  gnuplot_CMD=' '
  file_exist=.false.
  is_file_open=.false.
  file_size=0
  execute_gnuplot_cmd =.false.
  gnuplot_version=0.0_wp

  ! check if the file lineOUT exists
  INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open, NUMBER=file_number)

  IF (file_exist) then
     IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" exists in WorkDir'
     IF (is_file_open) then
       IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" is opened'
       ! close the file:
       CLOSE (UNIT=file_number,STATUS='DELETE')
     END IF
     ! delete the file
     IF (dbg) WRITE (StdOut,'(A)') 'deleting the file...'
     iErr=AixRm("lineOUT")
     IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
  ELSE
     IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" does not exist in WorkDir'
  END IF

  ! find the gnuplot
  IF (dbg) WRITE (StdOut,'(A)') 'inquire which GNUPLOT'

!#ifdef __INTEL_COMPILER
  CALL systemf ( "which gnuplot >> lineOUT", iErr )
  IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
!#else
!  CALL execute_command_line ( "which gnuplot >> lineOUT" )
!#endif

  INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number,SIZE=file_size)

  IF (dbg) WRITE (StdOut,*) 'File_number =',file_number
  IF (dbg) WRITE (StdOut,*) 'Is_file_open=',is_file_open
  IF (dbg) WRITE (StdOut,*) 'File_exist  =',file_exist
  IF (dbg) WRITE (StdOut,*) 'File_size   =',file_size

  IF (file_exist) then
    IF(file_size>0) then
      IF (dbg) WRITE (StdOut,'(A)') 'new file  "lineOUT"  exists in WorkDir'

      file_number=IsFreeUnit(43)
      Call molcas_open(file_number,"lineOUT")

      READ (file_number,'(A)') line1

      IF (dbg) WRITE (StdOut,*) 'line1=',line1
      IF (dbg) WRITE (StdOut,*) trim(line1)
      line2=trim(line1)
      IF (dbg) WRITE (StdOut,*) 'line2=',line2

      CLOSE(file_number)
      IF (dbg) WRITE (StdOut,*) 'Closing lineOUT file'
      FLUSH (StdOut)
      execute_gnuplot_cmd =.true.
    ELSE
      ! file_size =0
      WRITE (StdOut,'(A)') 'file  "lineOUT" has a size=0. gnuplot was not found on the system.'
      WRITE (StdOut,'(A)') 'plots will not be created.'
    END IF
  ELSE
     WRITE (StdOut,'(A)') 'file  "lineOUT" does not exist in WorkDir'
  END IF
  ! remove file "lineOUT"
  iErr=AixRm("lineOUT")
  IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr



!--------------------------------------------------------------------------------------------
! check the version of the gnuplot:
  IF ( execute_gnuplot_cmd ) Then
    IF (dbg) WRITE (StdOut,'(A)') 'inquire which version of GNUPLOT is installed'
    ! attempt to execute the script
    WRITE (gnuplot_CMD,'(2A)') trim(line2),' --version > lineOUT'
    IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
!#ifdef __INTEL_COMPILER
    CALL systemf ( gnuplot_CMD, iErr )
    IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
!#else
!    CALL execute_command_line ( gnuplot_CMD )
!#endif
    file_number=IsFreeUnit(42)
    Call molcas_open(file_number,"lineOUT")
    READ (file_number,*) cdummy, gnuplot_version
    IF (dbg) WRITE (StdOut,'(A,F4.1)') 'gnuplot_version = ', gnuplot_version
    IF (abs(gnuplot_version)<0.1_wp) execute_gnuplot_cmd =.false.
    CLOSE (file_number)
    ! remove file "lineOUT"
    iErr=AixRm("lineOUT")
    IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
  END IF



!--------------------------------------------------------------------------------------------
! get the true real names of the files on disk:
  WRITE(datafile ,'(3A)')  'XT_'//trim(label)//'.dat'
  WRITE(imagefile,'(3A)')  'XT_'//trim(label)//'.png'
  WRITE(epsfile  ,'(3A)')  'XT_'//trim(label)//'.eps'
  WRITE(plotfile ,'(3A)')  'XT_'//trim(label)//'.plt'
  Call prgmtranslate(datafile ,realname_dat,Length)
  Call prgmtranslate(imagefile,realname_png,Length)
  Call prgmtranslate(epsfile  ,realname_eps,Length)
  Call prgmtranslate(plotfile ,realname_plt,Length)
  IF (dbg) THEN
    WRITE(StdOut,'(3A)') 'realname_dat=',trim(realname_dat)
    WRITE(StdOut,'(3A)') 'realname_png=',trim(realname_png)
    WRITE(StdOut,'(3A)') 'realname_eps=',trim(realname_eps)
    WRITE(StdOut,'(3A)') 'realname_plt=',trim(realname_plt)
  END IF




!  GENERATE FILES:
!--------------------------------------------------------------------------------------------
! generate the file "XT.dat":
  INQUIRE(FILE=datafile,EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
  IF(file_exist) iErr=AixRm( trim(datafile) )
  IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
  LuData=IsFreeUnit(44)
  Call molcas_open(LuData,datafile)
  IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(datafile)//'" file'
  IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(realname_dat)//'" file'
  DO iT=1,nT
     WRITE (LuData,'(3ES24.14)') T(iT), XTexp(iT), XTcalc(iT)
  END DO
  IF (dbg) WRITE (StdOut,*) 'Writing into the "'//trim(datafile)//'" file'
  IF (dbg) WRITE (StdOut,*) 'Writing into the "'//trim(realname_dat)//'" file'
  CLOSE (LuData)
  IF (dbg) WRITE (StdOut,*) 'Closing the "'//trim(datafile)//'" file'
  IF (dbg) WRITE (StdOut,*) 'Closing the "'//trim(realname_dat)//'" file'
  FLUSH (StdOut)



!--------------------------------------------------------------------------------------------
  ! generate the GNUPLOT script in the $WorkDir
  INQUIRE(FILE=plotfile,EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
  IF(file_exist)  iErr=AixRm( trim(plotfile) )
  IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
  LuPlt=IsFreeUnit(54)
  Call molcas_open(LuPlt,plotfile)
  IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(plotfile)//'" file'
  IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(realname_plt)//'" file'

  IF ( gnuplot_version < 5.0_wp ) Then
  !===  GNUPLOT VERSION 4 and below ==>>  generate EPS
    WRITE (LuPlt,'(A)') 'set terminal postscript eps enhanced color  size 3.0, 2.0 font "arial, 10"'
    WRITE (LuPlt,'(A)') 'set output "'//trim(realname_eps)//'" '
    WRITE (LuPlt,'(A)') 'set grid'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# Axes'
    WRITE (LuPlt,'(A)') '  set xlabel "Temperature / Kelvin" font "Arial,14"'
    WRITE (LuPlt,'(A)') '  set ylabel "{/Symbol c}T / cm^3 K mol^{-1}" font "Arial,14"'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[', tmin,':', tmax,']'
    WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',XTmin,':',XTmax,']'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# Tics for axes'
    WRITE (LuPlt,'(A)') '  set xtics nomirror'
    WRITE (LuPlt,'(A)') '  set ytics nomirror'
    WRITE (LuPlt,'(A)') '  set mxtics'
    WRITE (LuPlt,'(A)') '  set mytics'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# Margins'
    WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
    WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# legend'
    WRITE (LuPlt,'(A)') '  set key right bottom'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# actual plotting'
    WRITE (LuPlt,'(A)') 'plot "'//trim(realname_dat)//'" using 1:2 with points  lt 1  lw  3 lc rgb "black"  title "Experiment", \'
    WRITE (LuPlt,'(A)') '     "'//trim(realname_dat)//'" using 1:3 with lines   lt 1  lw 10 lc rgb "red"    title "Calculation"'
    WRITE (LuPlt,'(A)')

  ELSE IF ( (gnuplot_version >= 5.0_wp) .AND.(gnuplot_version < 6.0_wp) ) Then
  !===  GNUPLOT VERSION 5 and above ==>>  generate PNG
    WRITE (LuPlt,'(A)') 'set terminal pngcairo transparent enhanced font "arial,10" fontscale 4.0 size 1800, 1200'
    WRITE (LuPlt,'(A)') 'set output "'//trim(realname_png)//'" '
    WRITE (LuPlt,'(A)') 'set grid'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# Axes'
    WRITE (LuPlt,'(A)') '  set xlabel "Temperature / Kelvin" font "Arial,14"'
    WRITE (LuPlt,'(A)') '  set ylabel "{/Symbol c}T / cm^3 K mol^{-1}" font "Arial,14"'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[', tmin,':', tmax,']'
    WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',XTmin,':',XTmax,']'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# Tics for axes'
    WRITE (LuPlt,'(A)') '  set xtics nomirror'
    WRITE (LuPlt,'(A)') '  set ytics nomirror'
    WRITE (LuPlt,'(A)') '  set mxtics'
    WRITE (LuPlt,'(A)') '  set mytics'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# Margins'
    WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
    WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# legend'
    WRITE (LuPlt,'(A)') '  set key right bottom'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)') '# actual plotting'
    WRITE (LuPlt,'(A)') 'plot "'//trim(realname_dat)//'" using 1:2 with points  lt 1  lw  3 lc rgb "black"  title "Experiment", \'
    WRITE (LuPlt,'(A)') '     "'//trim(realname_dat)//'" using 1:3 with lines   lt 1  lw 10 lc rgb "red"    title "Calculation"'
    WRITE (LuPlt,'(A)')
    WRITE (LuPlt,'(A)')
  ELSE
    WRITE (StdOut,*) 'GNUPLOT has version: ', gnuplot_version
    WRITE (StdOut,*) 'This version of GNUPLOT is not known and thus, unsupported.'
    execute_gnuplot_cmd=.false.
  END IF
  CLOSE (LuPlt)

  IF (execute_gnuplot_cmd) Then
    ! attempt to execute the script
    IF (dbg) THEN
      file_exist=.false.
      WRITE (StdOut,*) trim(realname_plt)
      INQUIRE(FILE=trim(realname_plt),EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
      IF(file_exist) THEN
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_plt)//'" exists.'
      ELSE
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_plt)//'" does not exist.'
      END IF
      file_exist=.false.
      WRITE (StdOut,*) trim(realname_dat)
      INQUIRE(FILE=trim(realname_dat),EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
      IF(file_exist) THEN
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_dat)//'" exists.'
      ELSE
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_dat)//'" does not exist.'
      END IF
    END IF

    WRITE (gnuplot_CMD,'(5A)') trim(line2),' < ',trim(realname_plt)
    IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',trim(gnuplot_CMD)

!#ifdef __INTEL_COMPILER
    CALL systemf ( gnuplot_CMD, iErr )
    IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
!#else
!    CALL execute_command_line ( gnuplot_CMD )
!#endif
    IF ( gnuplot_version < 5.0_wp ) Then
      file_exist=.false.
      INQUIRE(FILE=trim(realname_eps),EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
      IF(file_exist) THEN
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was created in Working directory.'
      ELSE
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was NOT created in Working directory.'
      END IF
    ELSE
      file_exist=.false.
      INQUIRE(FILE=trim(realname_png),EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
      IF(file_exist) THEN
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_png)//'" was created in Working directory.'
      ELSE
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_png)//'" was NOT created in Working directory.'
      END IF
    END IF
  END IF

  dbg=.false.
  RETURN
#ifdef _WARNING_WORKAROUND_
  IF (.FALSE.) CALL UNUSED_CHARACTER(cdummy)
#endif
  END SUBROUTINE plot_XT_with_Exp







  Subroutine plot_XT_no_Exp( label, nT, T, XTcalc, zJ )

  IMPLICIT NONE

  Integer, parameter    :: wp=kind(0.d0)
  CHARACTER(LEN=50), INTENT(in) :: label
  INTEGER, INTENT(in)   :: nT
  REAL (wp), INTENT(in) :: T(nT)
  REAL (wp), INTENT(in) :: XTcalc(nT)
  REAL (wp), INTENT(in) :: zJ
  ! local variables
  REAL (wp) :: tmin, tmax, XTmin_calc, XTmax_calc, XTmin, XTmax
  REAL (wp) :: gnuplot_version
  INTEGER   :: file_number, iT, LuPlt, LuData, file_size, StdOut
  LOGICAL   :: file_exist, is_file_open, execute_gnuplot_cmd, dbg
  CHARACTER(LEN=300)    :: line1, line2, cdummy
  CHARACTER(LEN=300)    :: datafile, plotfile, imagefile, epsfile
  INTEGER, EXTERNAL     :: AixRm
  INTEGER               :: Length
  CHARACTER(LEN=1023)   :: realname_plt, realname_dat, realname_png, realname_eps, gnuplot_CMD
  INTEGER               :: iErr
  INTEGER, EXTERNAL     :: IsFreeUnit

  dbg=.false.
  iErr=0
  StdOut=6
  tmin=0.0_wp
  tmax=0.0_wp
  XTmin_calc=0.0_wp
  XTmax_calc=0.0_wp
  XTmin=0.0_wp
  XTmax=0.0_wp
  tmin=MINVAL(T)-0.02_wp*MAXVAL(T)
  tmax=MAXVAL(T)+0.02_wp*MAXVAL(T)
  XTmin_calc=MINVAL(XTcalc)
  XTmax_calc=MAXVAL(XTcalc)
  XTmin=XTmin_calc-0.01_wp*XTmax_calc
  XTmax=XTmax_calc+0.01_wp*XTmax_calc

  IF (dbg) WRITE (StdOut,*) 'nT        = ',nT
  IF (dbg) WRITE (StdOut,*) 'tmin      = ',tmin
  IF (dbg) WRITE (StdOut,*) 'tmax      = ',tmax
  IF (dbg) WRITE (StdOut,*) 'XTmin_calc= ',XTmin_calc
  IF (dbg) WRITE (StdOut,*) 'XTmax_calc= ',XTmax_calc
  IF (dbg) WRITE (StdOut,*) 'XTmin     = ',XTmin
  IF (dbg) WRITE (StdOut,*) 'XTmax     = ',XTmax
  IF (dbg) WRITE (StdOut,*) 'zJ        = ',zJ
  IF (dbg) THEN
    DO iT=1,nT
      WRITE(StdOut,*) T(iT), XTcalc(iT)
    END DO
  END IF

  ! generate the GNUPLOT script in the $WorkDir
  line1=' '
  line2=' '
  gnuplot_CMD=' '
  file_exist=.false.
  is_file_open=.false.
  file_size=0
  execute_gnuplot_cmd =.false.
  gnuplot_version=0.0_wp

  ! check if the file lineOUT exists
  INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open, NUMBER=file_number)

  IF (file_exist) then
     IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" exists in WorkDir'
     IF (is_file_open) then
       IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" is opened'
       ! close the file:
       CLOSE (UNIT=file_number,STATUS='DELETE')
     END IF
     ! delete the file
     IF (dbg) WRITE (StdOut,'(A)') 'deleting the file...'
     iErr=AixRm("lineOUT")
     IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
  ELSE
     IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" does not exist in WorkDir'
  END IF


  ! find the gnuplot
  IF (dbg) WRITE (StdOut,'(A)') 'inquire which GNUPLOT'

!#ifdef __INTEL_COMPILER
  CALL systemf ( "which gnuplot >> lineOUT", iErr )
  IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
!#else
!  CALL execute_command_line ( "which gnuplot >> lineOUT" )
!#endif

  INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number,SIZE=file_size)

  IF (dbg) WRITE (StdOut,*) 'File_number =',file_number
  IF (dbg) WRITE (StdOut,*) 'Is_file_open=',is_file_open
  IF (dbg) WRITE (StdOut,*) 'File_exist  =',file_exist
  IF (dbg) WRITE (StdOut,*) 'File_size   =',file_size

  IF (file_exist) then
    IF (file_size>0) then
      IF (dbg) WRITE (StdOut,'(A)') 'new file  "lineOUT"  exists in WorkDir'

      file_number=IsFreeUnit(103)
      Call molcas_open(file_number,"lineOUT")

      READ (file_number,'(A)') line1

      IF (dbg) WRITE (StdOut,*) 'line1=',line1
      IF (dbg) WRITE (StdOut,*) trim(line1)
      line2=trim(line1)
      IF (dbg) WRITE (StdOut,*) 'line2=',line2

      CLOSE(file_number)
      IF (dbg) WRITE (StdOut,*) 'Closing lineOUT file'
      FLUSH (StdOut)
      execute_gnuplot_cmd=.true.
    ELSE
      ! file_size =0
      WRITE (StdOut,'(A)') 'file  "lineOUT" has a size=0. gnuplot was not found on the system.'
      WRITE (StdOut,'(A)') 'plots will not be created.'
    END IF
  ELSE
     WRITE (StdOut,'(A)') 'file  "lineOUT" does not exist in WorkDir'
  END IF
  ! remove file "lineOUT"
  iErr=AixRm("lineOUT")
  IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
!--------------------------------------------------------------------------------------------


! check the version of the gnuplot:
  IF ( execute_gnuplot_cmd ) Then
    IF (dbg) WRITE (StdOut,'(A)') 'inquire which version of GNUPLOT is installed'
    ! attempt to execute the script
    WRITE (gnuplot_CMD,'(2A)') trim(line2),' --version > lineOUT'
    IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
!#ifdef __INTEL_COMPILER
    CALL systemf ( gnuplot_CMD, iErr )
    IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
!#else
!    CALL execute_command_line ( gnuplot_CMD )
!#endif
    file_number=IsFreeUnit(102)
    Call molcas_open(file_number,"lineOUT")
    READ (file_number,*) cdummy, gnuplot_version
    IF (dbg) WRITE (StdOut,'(A,F4.1)') 'gnuplot_version = ', gnuplot_version
    IF (abs(gnuplot_version)<0.1_wp) execute_gnuplot_cmd =.false.
    CLOSE (file_number)
    ! remove file "lineOUT"
    iErr=AixRm("lineOUT")
    IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
  END IF



!--------------------------------------------------------------------------------------------
! get the true real names of the files on disk:
  WRITE(datafile ,'(3A)')  'XT_'//trim(label)//'.dat'
  WRITE(imagefile,'(3A)')  'XT_'//trim(label)//'.png'
  WRITE(epsfile  ,'(3A)')  'XT_'//trim(label)//'.eps'
  WRITE(plotfile ,'(3A)')  'XT_'//trim(label)//'.plt'
  Call prgmtranslate(datafile ,realname_dat,Length)
  Call prgmtranslate(imagefile,realname_png,Length)
  Call prgmtranslate(epsfile  ,realname_eps,Length)
  Call prgmtranslate(plotfile ,realname_plt,Length)
  IF (dbg) THEN
    WRITE(StdOut,'(3A)') 'realname_dat=',trim(realname_dat)
    WRITE(StdOut,'(3A)') 'realname_png=',trim(realname_png)
    WRITE(StdOut,'(3A)') 'realname_eps=',trim(realname_eps)
    WRITE(StdOut,'(3A)') 'realname_plt=',trim(realname_plt)
  END IF




!----------------------------------------------------------------------------------------
! create the file "XT.dat"
  INQUIRE(FILE=datafile,EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
  IF(file_exist)  iErr=AixRm( trim(datafile) )
  IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
  LuData=IsFreeUnit(104)
  Call molcas_open(LuData, datafile )
  IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(datafile)//'" file'
  IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(realname_dat)//'" file'
  DO iT=1,nT
     WRITE (LuData,'(2ES24.14)') T(iT), XTcalc(iT)
  END DO
  IF (dbg) WRITE (StdOut,*) 'Writing into the "'//trim(datafile)//'"file'
  IF (dbg) WRITE (StdOut,*) 'Writing into the "'//trim(realname_dat)//'"file'
  CLOSE (LuData)
  IF (dbg) WRITE (StdOut,*) 'Closing the "'//trim(datafile)//'" file'
  IF (dbg) WRITE (StdOut,*) 'Closing the "'//trim(realname_dat)//'" file'
  FLUSH (StdOut)




!----------------------------------------------------------------------------------------
  ! generate the GNUPLOT script in the $WorkDir
  INQUIRE(FILE=plotfile,EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
  IF(file_exist) iErr=AixRm( trim(plotfile) )
  IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
  LuPlt=IsFreeUnit(105)
  Call molcas_open(LuPlt, plotfile )
  IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(plotfile)//'" file'
  IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(realname_plt)//'" file'



  IF ( gnuplot_version < 5.0_wp ) Then
  !===  GNUPLOT VERSION 4 and below ==>>  generate EPS
     WRITE (LuPlt,'(A)') 'set terminal postscript eps enhanced color  size 3.0, 2.0 font "arial, 10"'
     WRITE (LuPlt,'(A)') 'set output "'//trim(realname_eps)//'" '
     WRITE (LuPlt,'(A)') 'set grid'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Axes'
     WRITE (LuPlt,'(A)') '  set xlabel "Temperature / Kelvin" font "Arial,14"'
     WRITE (LuPlt,'(A)') '  set ylabel "{/Symbol c}T / cm^3 K mol^{-1}" font "Arial,14"'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[', tmin,':', tmax,']'
     WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',XTmin,':',XTmax,']'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Tics for axes'
     WRITE (LuPlt,'(A)') '  set xtics nomirror'
     WRITE (LuPlt,'(A)') '  set ytics nomirror'
     WRITE (LuPlt,'(A)') '  set mxtics'
     WRITE (LuPlt,'(A)') '  set mytics'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Margins'
     WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
     WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# legend'
     WRITE (LuPlt,'(A)') '  set key right bottom'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# actual plotting'
     WRITE (LuPlt,'(A)') 'plot "'//trim(realname_dat)//'" using 1:2 with lines lt 1  lw  8 lc rgb "red" title "Calculation"'


  ELSE IF ( (gnuplot_version >= 5.0_wp) .AND.(gnuplot_version < 6.0_wp) ) Then
  !===  GNUPLOT VERSION 5 and above ==>>  generate PNG
     WRITE (LuPlt,'(A)') 'set terminal pngcairo transparent enhanced font "arial,10" fontscale 4.0 size 1800, 1200'
     WRITE (LuPlt,'(A)') 'set output "'//trim(realname_png)//'" '
     WRITE (LuPlt,'(A)') 'set grid'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Axes'
     WRITE (LuPlt,'(A)') '  set xlabel "Temperature / Kelvin" font "Arial,14"'
     WRITE (LuPlt,'(A)') '  set ylabel "{/Symbol c}T / cm^3 K mol^{-1}" font "Arial,14"'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[', tmin,':', tmax,']'
     WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',XTmin,':',XTmax,']'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Tics for axes'
     WRITE (LuPlt,'(A)') '  set xtics nomirror'
     WRITE (LuPlt,'(A)') '  set ytics nomirror'
     WRITE (LuPlt,'(A)') '  set mxtics'
     WRITE (LuPlt,'(A)') '  set mytics'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Margins'
     WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
     WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# legend'
     WRITE (LuPlt,'(A)') '  set key right bottom'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# actual plotting'
     WRITE (LuPlt,'(A)') 'plot "'//trim(realname_dat)//'" using 1:2 with lines lt 1  lw  8 lc rgb "red" title "Calculation"'
  ELSE
    WRITE (StdOut,*) 'GNUPLOT has version: ', gnuplot_version
    WRITE (StdOut,*) 'This version of GNUPLOT is not known and thus, unsupported.'
    execute_gnuplot_cmd=.false.
  END IF
  WRITE (LuPlt,'(A)')
  CLOSE (LuPlt)



  IF (execute_gnuplot_cmd) Then
    ! attempt to execute the script
    IF (dbg) THEN
      file_exist=.false.
      WRITE (StdOut,*) trim(realname_plt)
      INQUIRE(FILE=trim(realname_plt),EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
      IF(file_exist) THEN
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_plt)//'" exists.'
      ELSE
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_plt)//'" does not exist.'
      END IF
      file_exist=.false.
      WRITE (StdOut,*) trim(realname_dat)
      INQUIRE(FILE=trim(realname_dat),EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
      IF(file_exist) THEN
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_dat)//'" exists.'
      ELSE
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_dat)//'" does not exist.'
      END IF
    END IF

    WRITE (gnuplot_CMD,'(5A)') trim(line2),' < ',trim(realname_plt)
    IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',trim(gnuplot_CMD)

!#ifdef __INTEL_COMPILER
    CALL systemf ( gnuplot_CMD, iErr )
    IF(dbg)  WRITE (StdOut,*) 'iErr = ',iErr
!#else
!    CALL execute_command_line ( gnuplot_CMD )
!#endif

    IF ( gnuplot_version < 5.0_wp ) Then
      file_exist=.false.
      INQUIRE(FILE=trim(realname_eps),EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
      IF(file_exist) THEN
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was created in Working directory.'
      ELSE
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was NOT created in Working directory.'
      END IF
    ELSE
      file_exist=.false.
      INQUIRE(FILE=trim(realname_png),EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
      IF(file_exist) THEN
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_png)//'" was created in Working directory.'
      ELSE
        WRITE (StdOut,'(A,i0,A)') 'File "'//trim(realname_png)//'" was NOT created in Working directory.'
      END IF
    END IF
  END IF


  RETURN
#ifdef _WARNING_WORKAROUND_
  IF (.FALSE.) CALL UNUSED_CHARACTER(cdummy)
#endif
  END SUBROUTINE plot_XT_no_Exp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MV7(C,HC,LUC,LUHC)
*
* Outer routine for sigma vector generation
* GAS version !!!!
*
* Written in terms of RASG3/SBLOCK, May 1997
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
*
* =====
*.Input
* =====
      DIMENSION C(*),HC(*)
*
*.Definition of c and sigma
      COMMON/CANDS/ICSM,ISSM,ICSPC,ISSPC
*
*./ORBINP/ : NACOB used
#include "orbinp.fh"
#include "cicisp.fh"
#include "strbas.fh"
#include "cstate.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "csm.fh"
#include "WrkSpc.fh"
#include "crun.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "lucinp.fh"
#include "cprnt.fh"
#include "glbbas.fh"
#include "oper.fh"
      COMMON/CMXCJ/MXCJ,MAXK1_MX,LSCMAX_MX
      IDUM = 0
*
      IF(ICISTR.EQ.1) THEN
        WRITE(6,*) ' MV7 does not work for ICISTR = 1'
        WRITE(6,*) ' SWITCH to ICISTR = 2,3 or program'
*        STOP ' MV7 does not work for ICISTR = 1'
        CALL SYSABENDMSG('lucia_util/mv7','Internal error',' ')
      END IF
*
      MAXK1_MX = 0
      LSCMAX_MX = 0
      IATP = 1
      IBTP = 2
*
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*. Offset for supergroups
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
*
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
*. Arrays giving allowed type combinations
      CALL GETMEM('SIOIO ','ALLO','INTE',KSIOIO,NOCTPA*NOCTPB)
      CALL IAIBCM(ISSPC,iWORK(KSIOIO))
*. Arrays for additional symmetry operation
      IF(IDC.EQ.3.OR.IDC.EQ.4) THEN
        CALL GETMEM('SVST  ','ALLO','INTE',KSVST,NSMST)
        CALL SIGVST(IWORK(KSVST),NSMST)
      ELSE
         KSVST = 1
      END IF
*. Arrays giving block type
      CALL GETMEM('SBLTP ','ALLO','INTE',KSBLTP,NSMST)
      CALL ZBLTP(ISMOST(1,ISSM),NSMST,IDC,IWORK(KSBLTP),IWORK(KSVST))
      IF(IDC.EQ.3.OR.IDC.EQ.4) THEN
        CALL GETMEM('SVST  ','FREE','INTE',KSVST,NSMST)
      END IF
*. Arrays for partitioning of sigma
      NTTS = MXNTTS
      CALL GETMEM('CLBT  ','ALLO','INTE',KLSLBT ,NTTS  )
      CALL GETMEM('CLEBT ','ALLO','INTE',KLSLEBT ,NTTS  )
      CALL GETMEM('CI1BT ','ALLO','INTE',KLSI1BT,NTTS  )
      CALL GETMEM('CIBT  ','ALLO','INTE',KLSIBT ,8*NTTS)
*. Batches  of C vector
c      IF (ISIMSYM.EQ.0) THEN
        LBLOCK = MXSOOB
c      ELSE
c        LBLOCK = MXSOOB_AS
c      END IF
      LBLOCK = MAX(LBLOCK,LCSBLK)
* JESPER : Should reduce I/O
      IF (ENVIRO(1:6).EQ.'RASSCF') THEN
         LBLOCK = MAX(INT(XISPSM(IREFSM,1)),MXSOOB)
         IF(PSSIGN.NE.0.0D0) LBLOCK = INT(2*XISPSM(IREFSM,1))
      ENDIF
C     WRITE(6,*) ' ISSM and ICSM in MV7 =', ISSM,ICSM
      CALL PART_CIV2(      IDC,
     &               IWORK(KSBLTP),
     &               IWORK(KNSTSO(IATP)),
     &               IWORK(KNSTSO(IBTP)),NOCTPA,NOCTPB, NSMST,LBLOCK,
     &               IWORK(KSIOIO),
*
     &               ISMOST(1,ISSM),
     &                  NBATCH,
     &               IWORK(KLSLBT),
     &               IWORK(KLSLEBT),IWORK(KLSI1BT),IWORK(KLSIBT),
     &               0,ISIMSYM)
      CALL GETMEM('SIOIO ','FREE','INTE',KSIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('SBLTP ','FREE','INTE',KSBLTP,NSMST)
*. Number of BLOCKS
        NBLOCK = IFRMR(iWORK(KLSI1BT),1,NBATCH)
     &         + IFRMR(iWORK(KLSLBT),1,NBATCH) - 1
C?      WRITE(6,*) ' Number of blocks ', NBLOCK

      IF(I12.EQ.2) THEN
        IDOH2 = 1
      ELSE
        IDOH2 = 0
      END IF
*
      IF(ICISTR.EQ.1) THEN
       LLUC = 0
       LLUHC = 0
      ELSE
       LLUC = LUC
       LLUHC = LUHC
      END IF
*
      CALL RASSG3(   C,       HC,   NBATCH,
     &            iWORK(KLSLBT),iWORK(KLSLEBT),
     &            iWORK(KLSI1BT),iWORK(KLSIBT),
     &            LLUC,  LLUHC,I_AM_OUT,N_ELIMINATED_BATCHES)
C?    WRITE(6,*) ' LSCMAX_MX = ', LSCMAX_MX
*. Eliminate local memory
      CALL GETMEM('CLBT  ','FREE','INTE',KLSLBT ,NTTS  )
      CALL GETMEM('CLEBT ','FREE','INTE',KLSLEBT ,NTTS  )
      CALL GETMEM('CI1BT ','FREE','INTE',KLSI1BT,NTTS  )
      CALL GETMEM('CIBT  ','FREE','INTE',KLSIBT ,8*NTTS)
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_STAT()
!
! Purpose: print statistics from decomposition.

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use Para_Info, only: Is_Real_Par, nProcs
use Cholesky, only: CHO_DECALG, CHO_FAKE_PAR, CHO_INTCHK, CHO_REORD, Cho_SScreen, CHO_TSTSCREEN, DID_DECDRV, DSPNm, DSPNM, &
                    INF_INIT, INF_TIMING, InfVec, IntMap, IPRINT, LuPri, NBAS, NBAST, nDGM_call, nDimRS, nDimRS, nnBstR, nnBstRSh, &
                    nnBstRSh, nnBstRT, nnShl, nShell, nSym, nSys_call, NumCho, NumChT, RstCho, RstDia, SSNorm, SSTau, SubScrStat, &
                    TDECDRV, TDECOM, ThrCom, TIMSEC, TINTEG, TMISC, XnPass
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One, Half, Eight
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), parameter :: NTAU = 5
integer(kind=iwp) :: IBATCH, ICAL, IHC, IHW, ILOC, IMC, IMW, IPRSAV, IRC, IRED, IREDC, ISHAB, ISHGD, ISHLAB, ISYM, ITAU, IVEC1, &
                     JNUM, JSYM, JVEC1, JVEC2, KSYM, LRDVEC, LRDVT, LRED, MAXCAL, MUSD, N, NBATCH, NCAL, NCALL, NN, NREP, NTOT, &
                     NUMV, NUMVEC, NVEC
real(kind=wp) :: CFAC, CMISC, CPCT, CTIM, FAC, PCT, SAV1, SAV2, SCC, SCW, SSCRPCT, TAU(NTAU), TCCHA, TCCHD, TCDEC, TCDIA, TCDIS, &
                 TCFIN, TCINI, TCREO, TST, TWCHA, TWCHD, TWDEC, TWDIA, TWDIS, TWFIN, TWINI, TWREO, VCSTOR(8), VCTOT, WFAC, WMISC, &
                 WPCT, WTIM, X, X1DIM, X1RED, X1TOT, X2TOT, XC(NTAU), XCAL, XGB, XREP, XT, XX, XXBST(8), XXSHL, XXTOT, XXX, Y, YY, &
                 YYY
logical(kind=iwp) :: CHO_SSCREEN_SAVE, DOCPCT, DOWPCT, PARALG
character(len=25) :: STRING
character(len=2) :: UNT
real(kind=wp), allocatable :: KRDVEC(:)
real(kind=wp), parameter :: DTAU = 1.0e-1_wp, MNT = 60.0_wp
character(len=*), parameter :: SECNAM = 'CHO_STAT'

PARALG = (CHO_DECALG == 4) .or. (CHO_DECALG == 5) .or. (CHO_DECALG == 6)

! Overall header.
! ---------------

call CHO_HEAD('Cholesky Decomposition Statistics','=',80,LUPRI)
if (RSTDIA) write(LUPRI,'(/,A)') 'Calculation restarted from diagonal on disk'
if (RSTCHO) then
  if (RSTDIA) then
    write(LUPRI,'(A)') 'Calculation restarted from Cholesky vectors on disk'
  else
    write(LUPRI,'(/,A)') 'Calculation restarted from Cholesky vectors on disk'
  end if
end if

! Configuration.
! --------------

call CHO_HEAD('Configuration','-',80,LUPRI)
IPRSAV = IPRINT
IPRINT = INF_INIT+1
call CHO_PRTHEAD(.true.)
IPRINT = IPRSAV

! Vector statistics.
! ------------------

call CHO_HEAD('Vector statistics','-',80,LUPRI)
write(LUPRI,'(/,A,/,A)') 'Sym.        N      Full      Mmax         M    M/Full    M/Mmax       M/N', &
                         '--------------------------------------------------------------------------'
NTOT = 0
do ISYM=1,NSYM
  NTOT = NTOT+NUMCHO(ISYM)
  NN = 0
  XXBST(ISYM) = Zero
  do JSYM=1,NSYM
    KSYM = MUL(JSYM,ISYM)
    if (JSYM > KSYM) then
      NN = NN+NBAS(JSYM)*NBAS(KSYM)
      XXBST(ISYM) = XXBST(ISYM)+real(NBAS(JSYM),kind=wp)*real(NBAS(KSYM),kind=wp)
    else if (JSYM == KSYM) then
      NN = NN+nTri_Elem(NBAS(JSYM))
      XXBST(ISYM) = XXBST(ISYM)+real(NBAS(JSYM),kind=wp)*(real(NBAS(JSYM),kind=wp)+One)*Half
    end if
  end do
  if (NN > 0) then
    YYY = real(NUMCHO(ISYM),kind=wp)/XXBST(ISYM)
  else
    YYY = 9.0e9_wp
  end if
  if (NNBSTR(ISYM,1) > 0) then
    XX = real(NNBSTR(ISYM,1),kind=wp)
    YY = real(NUMCHO(ISYM),kind=wp)/XX
  else
    YY = 9.0e9_wp
  end if
  if (NBAS(ISYM) /= 0) then
    X = real(NBAS(ISYM),kind=wp)
    Y = real(NUMCHO(ISYM),kind=wp)/X
  else
    Y = 9.0e9_wp
  end if
  write(LUPRI,'(I3,4(1X,I9),3(1X,F9.4))') ISYM,NBAS(ISYM),NN,NNBSTR(ISYM,1),NUMCHO(ISYM),YYY,YY,Y
end do
write(LUPRI,'(A)') '--------------------------------------------------------------------------'
NN = nTri_Elem(NBAST)
if (NN > 0) then
  XXX = real(NN,kind=wp)
  YYY = real(NUMCHT,kind=wp)/XXX
else
  YYY = 9.0e9_wp
end if
if (NNBSTRT(1) > 0) then
  XX = real(NNBSTRT(1),kind=wp)
  YY = real(NUMCHT,kind=wp)/XX
else
  YY = 9.0e9_wp
end if
if (NBAST /= 0) then
  X = real(NBAST,kind=wp)
  Y = real(NUMCHT,kind=wp)/X
else
  Y = 9.0e9_wp
end if
write(LUPRI,'(3X,4(1X,I9),3(1X,F9.4))') NBAST,NN,NNBSTRT(1),NUMCHT,YYY,YY,Y
write(LUPRI,'(A)') '--------------------------------------------------------------------------'
if (NTOT /= NUMCHT) write(LUPRI,'(A)') 'WARNING: total number of vectors is wrong!!!'

call CHO_GETSTOR(VCSTOR)

write(LUPRI,'(/,A,/,A,/,A)') '                       %Saving relative to','Sym.     Storage      1st Red. Set     Full', &
                             '---------------------------------------------'
VCTOT = Zero
X1TOT = Zero
X2TOT = Zero
XXTOT = Zero
do ISYM=1,NSYM
  X1DIM = real(NNBSTR(ISYM,1),kind=wp)
  X1RED = X1DIM*real(NUMCHO(ISYM),kind=wp)
  if (X1RED > Zero) then
    SAV1 = 1.0e2_wp*(X1RED-VCSTOR(ISYM))/X1RED
  else
    SAV1 = 9.0e9_wp
  end if
  XX = XXBST(ISYM)*real(NUMCHO(ISYM),kind=wp)
  if (XX > Zero) then
    SAV2 = 1.0e2_wp*(XX-VCSTOR(ISYM))/XX
  else
    SAV2 = 9.0e9_wp
  end if
  XGB = VCSTOR(ISYM)*Eight/1.024e3_wp
  UNT = 'kb'
  if (XGB > 1.0e3_wp) then
    XGB = XGB/1.024e3_wp
    UNT = 'Mb'
    if (XGB > 1.0e3_wp) then
      XGB = XGB/1.024e3_wp
      UNT = 'Gb'
      if (XGB > 1.0e3) then
        XGB = XGB/1.024e3_wp
        UNT = 'Tb'
      end if
    end if
  end if
  write(LUPRI,'(I2,4X,F10.3,1X,A,4X,F9.4,4X,F9.4)') ISYM,XGB,UNT,SAV1,SAV2
  VCTOT = VCTOT+VCSTOR(ISYM)
  X1TOT = X1TOT+X1RED
  X2TOT = X2TOT+X1DIM*(X1DIM+One)*Half
  XXTOT = XXTOT+XX
end do
write(LUPRI,'(A)') '---------------------------------------------'
if (X1TOT > Zero) then
  SAV1 = 1.0e2_wp*(X1TOT-VCTOT)/X1TOT
else
  SAV1 = 9.0e9_wp
end if
if (XXTOT > Zero) then
  SAV2 = 1.0e2_wp*(XXTOT-VCTOT)/XXTOT
else
  SAV2 = 9.0e9_wp
end if
XGB = VCTOT*Eight/1.024e3_wp
UNT = 'kb'
if (XGB > 1.0e3_wp) then
  XGB = XGB/1.024e3_wp
  UNT = 'Mb'
  if (XGB > 1.0e3_wp) then
    XGB = XGB/1.024e3_wp
    UNT = 'Gb'
    if (XGB > 1.0e3_wp) then
      XGB = XGB/1.024e3_wp
      UNT = 'Tb'
    end if
  end if
end if
write(LUPRI,'(A6,F10.3,1X,A,4X,F9.4,4X,F9.4)') 'Total:',XGB,UNT,SAV1,SAV2
write(LUPRI,'(A)') '---------------------------------------------'
PCT = 1.0e2_wp*VCTOT/X2TOT
write(LUPRI,'(A,F11.6,A)') 'Total storage corresponds to',PCT,'% of the 1st reduced set integral matrix.'

call CHO_STAT_PARENTDIAG()

! Integral statistics.
! --------------------

MAXCAL = 0
NCAL = 0
NREP = 0
NCALL = 0
do ISHLAB=1,NNSHL
  if (INTMAP(ISHLAB) > 0) then
    MAXCAL = max(MAXCAL,INTMAP(ISHLAB))
    NCAL = NCAL+1
    NCALL = NCALL+INTMAP(ISHLAB)
    if (INTMAP(ISHLAB) > 1) NREP = NREP+1
  end if
end do

XXSHL = real(NNSHL,kind=wp)
XCAL = real(NCAL,kind=wp)
XREP = real(NREP,kind=wp)

call CHO_HEAD('Integral statistics','-',80,LUPRI)
write(LUPRI,'(/,A,I10)') '#Shells                  :',NSHELL
write(LUPRI,'(A,I10)') '#Shell Pair Distributions:',NNSHL
write(LUPRI,'(A,I10)') '#Integral passes         :',XNPASS
write(LUPRI,'(A,I10)') '#Calls to integral prog. :',NCALL
write(LUPRI,'(A,I10,A,F8.3,A)') '#Shell Pairs Calculated  :',NCAL,' (',XCAL*1.0e2_wp/XXSHL,' % of total)'
write(LUPRI,'(A,I10,A,F8.3,A)') '#Shell Pairs Repeated    :',NREP,' (',XREP*1.0e2_wp/XCAL,' % of calculated)'

write(LUPRI,'(/,A,/,A)') '#Calculations     #Shell Pairs   Percentage','-------------------------------------------'
do ICAL=1,MAXCAL
  N = 0
  do ISHLAB=1,NNSHL
    if (INTMAP(ISHLAB) == ICAL) N = N+1
  end do
  if (N > 0) then
    X = real(N,kind=wp)
    write(LUPRI,'(I12,6X,I12,5X,F8.3)') ICAL,N,X*1.0e2_wp/XXSHL
  end if
end do
write(LUPRI,'(A)') '-------------------------------------------'

! Section timings.
! ----------------

if (IPRINT >= INF_TIMING) then

  TCINI = TIMSEC(2,1)-TIMSEC(1,1)
  TWINI = TIMSEC(4,1)-TIMSEC(3,1)
  TCDIA = TIMSEC(2,2)-TIMSEC(1,2)
  TWDIA = TIMSEC(4,2)-TIMSEC(3,2)
  TCDEC = TIMSEC(2,3)-TIMSEC(1,3)
  TWDEC = TIMSEC(4,3)-TIMSEC(3,3)
  TCCHD = TIMSEC(2,4)-TIMSEC(1,4)
  TWCHD = TIMSEC(4,4)-TIMSEC(3,4)
  TCCHA = TIMSEC(2,5)-TIMSEC(1,5)
  TWCHA = TIMSEC(4,5)-TIMSEC(3,5)
  TCREO = TIMSEC(2,6)-TIMSEC(1,6)
  TWREO = TIMSEC(4,6)-TIMSEC(3,6)
  TCDIS = TIMSEC(2,7)-TIMSEC(1,7)
  TWDIS = TIMSEC(4,7)-TIMSEC(3,7)
  TCFIN = TIMSEC(2,8)-TIMSEC(1,8)
  TWFIN = TIMSEC(4,8)-TIMSEC(3,8)

  call CHO_HEAD('Section timings','-',80,LUPRI)
  write(LUPRI,'(/,A,/,A,/,A)') '                                 CPU time          Wall time', &
                               'Section                      hours min. sec.    hours min. sec.', &
                               '---------------------------------------------------------------'
  STRING = 'Initialization           '
  call CHO_CNVTIM(TCINI,IHC,IMC,SCC)
  call CHO_CNVTIM(TWINI,IHW,IMW,SCW)
  write(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)') STRING,IHC,IMC,SCC,IHW,IMW,SCW
  STRING = 'Diagonal setup           '
  call CHO_CNVTIM(TCDIA,IHC,IMC,SCC)
  call CHO_CNVTIM(TWDIA,IHW,IMW,SCW)
  write(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)') STRING,IHC,IMC,SCC,IHW,IMW,SCW
  STRING = 'Cholesky decomposition   '
  call CHO_CNVTIM(TCDEC,IHC,IMC,SCC)
  call CHO_CNVTIM(TWDEC,IHW,IMW,SCW)
  write(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)') STRING,IHC,IMC,SCC,IHW,IMW,SCW
  STRING = 'Diagonal check           '
  call CHO_CNVTIM(TCCHD,IHC,IMC,SCC)
  call CHO_CNVTIM(TWCHD,IHW,IMW,SCW)
  write(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)') STRING,IHC,IMC,SCC,IHW,IMW,SCW
  if (CHO_INTCHK) then
    STRING = 'Integral check (debug)   '
    call CHO_CNVTIM(TCCHA,IHC,IMC,SCC)
    call CHO_CNVTIM(TWCHA,IHW,IMW,SCW)
    write(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)') STRING,IHC,IMC,SCC,IHW,IMW,SCW
  end if
  if (CHO_REORD) then
    STRING = 'Vector reordering        '
    call CHO_CNVTIM(TCREO,IHC,IMC,SCC)
    call CHO_CNVTIM(TWREO,IHW,IMW,SCW)
    write(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)') STRING,IHC,IMC,SCC,IHW,IMW,SCW
  end if
  if (CHO_FAKE_PAR .and. (NPROCS > 1) .and. Is_Real_Par()) then
    STRING = 'Vector distribution      '
    call CHO_CNVTIM(TCDIS,IHC,IMC,SCC)
    call CHO_CNVTIM(TWDIS,IHW,IMW,SCW)
    write(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)') STRING,IHC,IMC,SCC,IHW,IMW,SCW
  end if
  STRING = 'Finalization             '
  call CHO_CNVTIM(TCFIN,IHC,IMC,SCC)
  call CHO_CNVTIM(TWFIN,IHW,IMW,SCW)
  write(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)') STRING,IHC,IMC,SCC,IHW,IMW,SCW
  write(LUPRI,'(A)') '---------------------------------------------------------------'

end if ! IPRINT > INF_TIMING

! Timing of decomposition driver.
! -------------------------------

if (DID_DECDRV) then

  CMISC = TDECDRV(1)-sum(TINTEG(1,:))-sum(TDECOM(1,:))-sum(TMISC(1,:))
  WMISC = TDECDRV(2)-sum(TINTEG(2,:))-sum(TDECOM(2,:))-sum(TMISC(2,:))
  CPCT = -9.0e9_wp
  CFAC = -9.0e9_wp
  WPCT = -9.0e9_wp
  WFAC = -9.0e9_wp
  if (TDECDRV(1) > Zero) then
    DOCPCT = .true.
    CFAC = 1.0e2_wp/TDECDRV(1)
  else
    DOCPCT = .false.
  end if
  if (TDECDRV(2) > Zero) then
    DOWPCT = .true.
    WFAC = 1.0e2_wp/TDECDRV(2)
  else
    DOWPCT = .false.
  end if

  call CHO_HEAD('Timing of decomposition driver','-',80,LUPRI)
  write(LUPRI,'(/,A,/,A)') 'Task           Component           CPU (min.)     %   Wall (min.)     %', &
                           '-------------------------------------------------------------------------'
  CTIM = TINTEG(1,1)
  WTIM = TINTEG(2,1)
  if (DOCPCT) CPCT = CTIM*CFAC
  if (DOWPCT) WPCT = WTIM*WFAC
  write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') 'Integrals      calculation        ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  CTIM = TINTEG(1,2)
  WTIM = TINTEG(2,2)
  if (DOCPCT) CPCT = CTIM*CFAC
  if (DOWPCT) WPCT = WTIM*WFAC
  write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') '               I/O, qualifieds    ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  CTIM = TDECOM(1,1)
  WTIM = TDECOM(2,1)
  if (DOCPCT) CPCT = CTIM*CFAC
  if (DOWPCT) WPCT = WTIM*WFAC
  write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') 'Decomposition  I/O, qualifieds    ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  CTIM = TDECOM(1,2)
  WTIM = TDECOM(2,2)
  if (DOCPCT) CPCT = CTIM*CFAC
  if (DOWPCT) WPCT = WTIM*WFAC
  write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') '               I/O, vectors       ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  CTIM = TDECOM(1,3)
  WTIM = TDECOM(2,3)
  if (DOCPCT) CPCT = CTIM*CFAC
  if (DOWPCT) WPCT = WTIM*WFAC
  write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') '               vector subtraction ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  if (PARALG) then
    CTIM = TDECOM(1,4)
    WTIM = TDECOM(2,4)
    if (DOCPCT) CPCT = CTIM*CFAC
    if (DOWPCT) WPCT = WTIM*WFAC
    write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') '               qualified CD       ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  end if
  CTIM = TMISC(1,1)
  WTIM = TMISC(2,1)
  if (DOCPCT) CPCT = CTIM*CFAC
  if (DOWPCT) WPCT = WTIM*WFAC
  write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') 'Misc.          qualification      ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  CTIM = TMISC(1,2)
  WTIM = TMISC(2,2)
  if (DOCPCT) CPCT = CTIM*CFAC
  if (DOWPCT) WPCT = WTIM*WFAC
  write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') '               red. set write     ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  CTIM = TMISC(1,3)
  WTIM = TMISC(2,3)
  if (DOCPCT) CPCT = CTIM*CFAC
  if (DOWPCT) WPCT = WTIM*WFAC
  write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') '               info write         ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  if (PARALG) then
    CTIM = TMISC(1,4)
    WTIM = TMISC(2,4)
    if (DOCPCT) CPCT = CTIM*CFAC
    if (DOWPCT) WPCT = WTIM*WFAC
    write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') '               diagonal sync      ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
    CTIM = TMISC(1,5)
    WTIM = TMISC(2,5)
    if (DOCPCT) CPCT = CTIM*CFAC
    if (DOWPCT) WPCT = WTIM*WFAC
    write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') '               vector count sync  ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  end if
  CTIM = CMISC
  WTIM = WMISC
  if (DOCPCT) CPCT = CTIM*CFAC
  if (DOWPCT) WPCT = WTIM*WFAC
  write(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)') '               etc.               ',CTIM/MNT,CPCT,WTIM/MNT,WPCT
  write(LUPRI,'(A)') '-------------------------------------------------------------------------'
  write(LUPRI,'(A,1X,F10.2,10X,F10.2)') 'Total:                            ',TDECDRV(1)/MNT,TDECDRV(2)/MNT
  write(LUPRI,'(A)') '-------------------------------------------------------------------------'
  write(LUPRI,'(A,I12)') 'Total #system calls for vector read  :',NSYS_CALL
  if (.not. CHO_SSCREEN) write(LUPRI,'(A,I12)') 'Total #DGEMM  calls for vector subtr.:',NDGM_CALL

end if

! Screening statistics from vector subtractions.
! ----------------------------------------------

if (CHO_SSCREEN) then
  call CHO_HEAD('Screening Statistics from Vector Subtraction','-',80,LUPRI)
  write(LUPRI,'(/,A,12X,A)') 'Norm used for diagonals      : ',SSNORM
  write(LUPRI,'(A,ES15.4)') 'Screening threshold          : ',SSTAU
  write(LUPRI,'(A,ES15.4)') 'Maximum possible #DGEMV calls: ',SUBSCRSTAT(1)
  write(LUPRI,'(A,ES15.4)') 'Actual #DGEMV calls          : ',SUBSCRSTAT(2)
  if (SUBSCRSTAT(1) > Zero) then
    SSCRPCT = 1.0e2_wp*(SUBSCRSTAT(1)-SUBSCRSTAT(2))/SUBSCRSTAT(1)
    write(LUPRI,'(A,8X,F7.2,A)') 'Screening percent            : ',SSCRPCT,'%'
  end if
end if

! Statistics for shell quadruples spanned by each reduced set.
! (This is for test purposes.)
! ------------------------------------------------------------

if (CHO_TSTSCREEN .and. (.not. (CHO_FAKE_PAR .and. (NPROCS > 1) .and. Is_Real_Par()))) then

  CHO_SSCREEN_SAVE = CHO_SSCREEN
  CHO_SSCREEN = .true. ! to avoid error termination

  if (NTAU < 1) then
    write(LUPRI,*) SECNAM,': screening test requested, but NTAU is non-positive!'
    write(LUPRI,*) SECNAM,': test is skipped!'
  else
    TAU(1) = THRCOM
    do ITAU=2,NTAU
      TAU(ITAU) = TAU(ITAU-1)*DTAU
    end do

    call CHO_HEAD('RS Screening Statistics (TEST)','-',80,LUPRI)
    write(LUPRI,'(/,A,A)') 'Norm used for diagonal shell pairs: ',SSNORM
    call CHO_SUBSCR_INIT()

    ILOC = 3

    do ISYM=1,NSYM
      if (NUMCHO(ISYM) > 0) then

        LRED = INFVEC(NUMCHO(ISYM),2,ISYM)
        do IRED=1,LRED

          IVEC1 = 0
          NVEC = 0
          call CHO_X_NVECRS(IRED,ISYM,IVEC1,NVEC)
          if ((NVEC > 0) .and. (NDIMRS(ISYM,IRED) > 0)) then

            call mma_maxDBLE(LRDVT)
            NUMVEC = min(LRDVT/NDIMRS(ISYM,IRED),NVEC)
            if (NUMVEC < 1) call CHO_QUIT('Insufficient memory for TstScreen in '//SECNAM,104)
            NBATCH = (NVEC-1)/NUMVEC+1

            do IBATCH=1,NBATCH

              if (IBATCH == NBATCH) then
                NUMV = NVEC-NUMVEC*(NBATCH-1)
              else
                NUMV = NUMVEC
              end if
              LRDVEC = NDIMRS(ISYM,IRED)*NUMV
              call mma_allocate(KRDVEC,LRDVEC,Label='KRDVEC')

              JVEC1 = IVEC1+NUMVEC*(IBATCH-1)
              JVEC2 = JVEC1+NUMV-1
              JNUM = 0
              MUSD = 0
              call CHO_VECRD(KRDVEC,LRDVEC,JVEC1,JVEC2,ISYM,JNUM,IREDC,MUSD)
              if (JNUM /= NUMV) call CHO_QUIT('Logical error in '//SECNAM,103)

              if (IREDC /= IRED) then
                call CHO_X_SETRED(IRC,ILOC,IRED)
                if (IRC /= 0) then
                  write(LUPRI,*) SECNAM,': CHO_X_SETRED returned ',IRC
                  call CHO_QUIT('Error in '//SECNAM,104)
                end if
                IREDC = IRED
              end if

              call CHO_SUBSCR_DIA(KRDVEC,NUMV,ISYM,ILOC,SSNORM)
              XT = Zero
              XC(:) = Zero
              do ISHAB=1,NNSHL
                if (NNBSTRSH(ISYM,ISHAB,ILOC) > 0) then
                  do ISHGD=ISHAB,NNSHL
                    if (NNBSTRSH(ISYM,ISHGD,ILOC) > 0) then
                      TST = DSPNM(ISHAB)*DSPNM(ISHGD)
                      TST = sqrt(TST)
                      XT = XT+One
                      do ITAU=1,NTAU
                        if (TST > TAU(ITAU)) XC(ITAU) = XC(ITAU)+One
                      end do
                    end if
                  end do
                end if
              end do

              write(LUPRI,'(/,1X,A,I6,A,I2,A)') '*** Statistics for reduced set',IRED,'    Symmetry',ISYM,' ***'
              write(LUPRI,'(1X,A,I6,A,I6)') '    Batch no.',IBATCH,' of',NBATCH
              write(LUPRI,'(1X,A,9X,I6)') '       No. vectors     : ',NUMV
              write(LUPRI,'(1X,A,9X,I6,9X,I6)') '       Vector range    : ',JVEC1,JVEC2
              write(LUPRI,'(1X,A,ES15.7)') '       Shell quadruples: ',XT
              if (XT < One) call CHO_QUIT('XT non-positive in '//SECNAM,103)
              FAC = 1.0e2_wp/XT
              do ITAU=1,NTAU
                PCT = FAC*(XT-XC(ITAU))
                write(LUPRI,'(1X,A,ES15.7,A,ES15.7,A)') '       Threshold: ',TAU(ITAU),'  Screening percent: ',PCT,'%'
              end do
              call XFLUSH(LUPRI)

              call mma_deallocate(KRDVEC)

            end do

          end if

        end do

      end if
    end do

    call CHO_SUBSCR_FINAL()
  end if ! skip point

  CHO_SSCREEN = CHO_SSCREEN_SAVE

end if

end subroutine CHO_STAT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fx

! This module contains just an abstract interface, to avoid explicit interfaces

use Definitions, only: wp

implicit none
private

interface
  function f_interface(x)
    import :: wp
    real(kind=wp) :: f_interface
    real(kind=wp), intent(in) :: x
  end function f_interface
end interface

public :: f_interface

end module fx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine unpckhelp8 (a,b,dimp,dimef,eadd,noe,bb,dimb)
c
c     this routine do:
c     b(ef,_Bb) = a(pe,qf)-a(qf,pe) for symp=symq
c
       integer dimp,dimef,eadd,noe,bb,dimb
       real*8 a(1:dimp,1:dimp)
       real*8 b(1:dimef,1:dimb)
c
c     help variables
       integer pe,qf,ef
c
       ef=0
       do 100 pe=eadd+2,eadd+noe
       do 101 qf=eadd+1,pe-1
       ef=ef+1
       b(ef,bb)=a(pe,qf)-a(qf,pe)
 101    continue
 100    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        SubRoutine CtlDns(iDCRR,iDCRS,iDCRT,jOp)

      Integer jop(6)

*              Djl. Some care has to be taken here. Assume that there
*              are two operators, T and S which generates the center
*              pairs A,T(B) and A,S(B). If these pairs are symmetry
*              related we will only
*
*--------------Dij
               iR = iDCRR
               jOp(1) = NrOpr(iR) + 1
*--------------Dkl
               iS = iDCRS
               jOp(2) = NrOpr(iS) + 1
*--------------Dik
               iT  = iDCRT
               jOp(3) = NrOpr(iT) + 1
*--------------Dil
               iTS = iEor(iT,iS)
               jOp(4) = NrOpr(iTS) + 1
*--------------Djk
               iRT = iEor(iR,iT)
               jOp(5) = NrOpr(iRT) + 1
*--------------Djl
               iRTS= iEor(iRT,iS)
               jOp(6) = NrOpr(iRTS) + 1
*
      Return
      End
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Bingbing Suo                                     *
!***********************************************************************
! 11 feb 2007 -bsuo- added by suo bing
!                    this file contains subroutines which depend on plat

subroutine version_info()

use Definitions, only: u6

implicit none

write(u6,'(10x,a42)') '*****************************************'
write(u6,'(10x,a42)') '*      Xian-ci mrci program             *'
write(u6,'(10x,a42)') '*     Institute of Modern Physics       *'
write(u6,'(10x,a42)') '*        Northwest University           *'
write(u6,'(10x,a42)') '*        xian, shaanxi, china           *'
write(u6,'(10x,a42)') '*                                       *'
write(u6,'(10x,a42)') '*        report bugs and errors         *'
write(u6,'(10x,a42)') '*           wzy@nwu.edu.cn              *'
write(u6,'(10x,a42)') '*        yubin_wang@hotmail.com         *'
write(u6,'(10x,a42)') '*       bingbing_suo@hotmail.com        *'
write(u6,'(10x,a42)') '*                                       *'
write(u6,'(10x,a42)') '*****************************************'
write(u6,*)
write(u6,*)

return

end subroutine version_info

subroutine allocate_int_memory()

use gugaci_global, only: maxintseg, vint_ci
use stdalloc, only: mma_allocate
use Constants, only: Zero

implicit none

! this subroutine is used to allocate the dynamic memory for integrals
! vint_ci(:) pointer to the base address of the memory of integrals
! maxintseg  maximum length of the integral segment

call mma_allocate(vint_ci,[0,maxintseg+1],label='vint_ci')
vint_ci(:) = Zero

return

end subroutine allocate_int_memory

subroutine deallocate_int_memory()

use gugaci_global, only: vint_ci
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(vint_ci)

return

end subroutine deallocate_int_memory

subroutine read_ml(nf,bv,n,m)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nf, n, m
real(kind=wp), intent(out) :: bv(n)
integer(kind=iwp) :: idisk, irec(64)

idisk = 0
call idafile(nf,2,irec,64,idisk)
idisk = irec(m)
call ddafile(nf,2,bv,n,idisk)

!select case (nf)
!  case (34)
!    call ddafile(nf,2,bv,n,idisk)
!  case (35)
!    call ddafile(nf,2,bv,n,idisk)
!  case default
!end select

return

end subroutine read_ml

subroutine write_ml(nf,bv,n,m)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nf, n, m
real(kind=wp), intent(_IN_) :: bv(n)
integer(kind=iwp) :: idisk, irec(64)

idisk = 0
if (m == 1) then
  irec = 0
  call idafile(nf,1,irec,64,idisk)
  irec(1) = idisk
else
  call idafile(nf,2,irec,64,idisk)
end if

idisk = irec(m)
call ddafile(nf,1,bv,n,idisk)

!select case (nf)
!  case (34)
!    call ddafile(nf,1,bv,n,idisk)
!  case (35)
!    call ddafile(nf,1,bv,n,idisk)
!  case default
!end select
irec(m+1) = idisk
idisk = 0
call idafile(nf,1,irec,64,idisk)
!write(u6,*) 'idisk',m,idisk

return

end subroutine write_ml

subroutine readint(ntyp,vintrd)
! subroutine used to read divided integrals into main memory
! on entry:
! -----------------
! ntyp   - integral type need to be readed
!   1 internal space integrals
!   2 integrals which have one or three indices in external space
!   3 integrals which have two indices in external space
!   4 external space integrals
! on out:
! -------------------
! vintrd(*) - integrals used in hamiltonian matrix calculation

use gugaci_global, only: LuCiInt

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ntyp
real(kind=wp), intent(_OUT_) :: vintrd(*)
integer(kind=iwp) :: idisk, idum(1), idx(4), lenint

idx = 0
idisk = 0
call idafile(luciint,2,idx,4,idisk)
select case (ntyp)
  case (1)
    idisk = idx(1)
    call idafile(luciint,2,idum,1,idisk)
    lenint = idum(1)
    call ddafile(luciint,2,vintrd(2),lenint,idisk)
  case (2)
    ! internal external space 1 and 3 index integrals
    idisk = idx(2)
    call idafile(luciint,2,idum,1,idisk)
    lenint = idum(1)
    call ddafile(luciint,2,vintrd(2),lenint,idisk)
    !write(u6,*) vintrd(1:lenint)
  case (3)
    ! internal external space 2 index integrals
    idisk = idx(3)
    call idafile(luciint,2,idum,1,idisk)
    lenint = idum(1)
    call ddafile(luciint,2,vintrd(2),lenint,idisk)
  case (4)
    ! external space integrals
    idisk = idx(4)
    call idafile(luciint,2,idum,1,idisk)
    lenint = idum(1)
    call ddafile(luciint,2,vintrd(2),lenint,idisk)
end select

!do i=1,lenint+1
!  write(12,'(i8,1x,f15.8)') i,vintrd(i)
!end do

return

end subroutine readint

subroutine gugaciinit()

use gugaci_global, only: FnOneMO, FnTwoMO, LuCiDen, LuCiDia, LuCiInt, LuCiMO, LuCiTv1, LuCiTv2, LuCiVec, LuDrt, LuLoop, LuOneMO, &
                         LuTwoMO
#ifdef MOLPRO
use file_qininit, only:
use molegeom, only:
use groupinfo, only:
use orbinfo, only:
use Definitions, only: iwp
#endif

implicit none
character(len=8) :: fnciden, fncidia, fnciint, fncimo, fncitv1, fncitv2, fncivec, fndrt, fnloop

#ifndef MOLPRO
fnonemo = 'traone'
#endif
fntwomo = 'traint'
fndrt = 'cidrt'
fnciint = 'ciint'
fnloop = 'ciloop'
fncidia = 'cidia'
fncivec = 'civec'
fncitv1 = 'citv1'
fncitv2 = 'citv2'
fnciden = 'ciden'
fncimo = 'cimo'

luonemo = 30
lutwomo = 50
ludrt = 31
luciint = 32
luloop = 33
lucidia = 34
lucivec = 35
lucitv1 = 36
lucitv2 = 37
luciden = 38
lucimo = 39
#ifndef MOLPRO
call daname(ludrt,fndrt)
call daname(luciint,fnciint)
call daname(luloop,fnloop)
call daname(lucidia,fncidia)
call daname(lucivec,fncivec)
call daname(lucitv1,fncitv1)
call daname(lucitv2,fncitv2)
call daname(luciden,fnciden)
call daname(lucimo,fncimo)
#endif
#ifdef _XIANEST_
! open chkfile and drt file
call fileopen(nfchk,anchk,11)
call chkfil_taskctrl(2)  ! read task information

nreps = 0
! read infomation from checkfile and moint file
call chkfil_ciorbinf(2)
nlsm_bas(1:8) = nsbas(1:8)
nlsm_all(1:8) = nsorb(1:8)
ng_sm = nreps

call fileopen(ludrt,fndrt,12)
call fileopen(luciint,fnciint,12)
call fileopen(luloop,fnloop,12)
call fileopen(lucidia,fncidia,12)
call fileopen(lucivec,fncivec,12)
call fileopen(lucitv1,fncitv1,12)
call fileopen(lucitv2,fncitv2,12)
call fileopen(luciden,fnciden,12)
call fileopen(lucimo,fncimo,12)
call fileopen(lutwomo,fntwomo,12)
#endif

return

end subroutine gugaciinit

subroutine gugafinalize()

use gugaci_global, only: LuCiDen, LuCiDia, LuCiInt, LuCiMO, LuCiTv1, LuCiTv2, LuCiVec, LuDrt, LuLoop

implicit none

#ifdef MOLPRO
call fileclos(ludrt,12)
call fileclos(luciint,12)
call fileclos(luloop,12)
call fileclos(lucidia,12)
call fileclos(lucivec,12)
call fileclos(lucitv1,12)
call fileclos(lucitv2,12)
call fileclos(luciden,12)
call fileclos(lucimo,12)
call fileclos(lutwomo,12)
#else
call daclos(ludrt)
call daclos(luciint)
call daclos(luloop)
call daclos(lucidia)
call daclos(lucivec)
call daclos(lucitv1)
call daclos(lucitv2)
call daclos(luciden)
call daclos(lucimo)
#endif

return

end subroutine gugafinalize

subroutine memdengrad_alloc()

use gugaci_global, only: denm1, denm2, norb_all
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nc, ndim

ndim = norb_all*(norb_all+1)/2
call mma_allocate(denm1,ndim,label='denm1')
nc = ndim*(ndim+1)/2
call mma_allocate(denm2,nc,label='denm2')

end subroutine memdengrad_alloc

subroutine memdengrad_free()

use gugaci_global, only: denm1, denm2
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(denm1)
call mma_deallocate(denm2)

end subroutine memdengrad_free

subroutine memcidiag_alloc()

use gugaci_global, only: jeh, jph, jwh, maxpl, th, thh
use stdalloc, only: mma_allocate
use Constants, only: Zero

implicit none

call mma_allocate(jph,maxpl,label='jph')
call mma_allocate(jeh,maxpl,label='jeh')
call mma_allocate(jwh,maxpl,label='jwh')
call mma_allocate(th,maxpl,label='th')
call mma_allocate(thh,maxpl,label='thh')
jph(:) = 0
jeh(:) = 0
jwh(:) = 0
th(:) = Zero
thh(:) = Zero

return

end subroutine memcidiag_alloc

subroutine memcidiag_dealloc()

use gugaci_global, only: jeh, jph, jwh, th, thh
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(jph)
call mma_deallocate(jeh)
call mma_deallocate(jwh)
call mma_deallocate(th)
call mma_deallocate(thh)

return

end subroutine memcidiag_dealloc

subroutine mem_intinnindex_alloc()

use gugaci_global, only: intind_abkk, intind_iabc, intind_iaqq, intind_ijab, intind_ijcc, intind_ijka, intspace_abkk, &
                         intspace_ijab, intspace_ijcc, loij, loij_all, loijk, &
                         loijk_all, nabc, ngw2, ngw3, norb_all, norb_inn, vdint, voint
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lent

call mma_allocate(loij,50000,label='loij')
call mma_allocate(loijk,1384150,label='loijk')
call mma_allocate(loij_all,50000,label='loij_all')
call mma_allocate(loijk_all,1384150,label='loijk_all')
loij(1:50000) = 0
loijk(1:1384150) = 0
loijk_all(1:50000) = 0
loijk_all(1:1384150) = 0

call mma_allocate(intind_iaqq,50000,label='intind_iaqq')
call mma_allocate(intind_abkk,50000,label='intind_abkk')
lent = norb_inn*nabc+norb_all+ngw2(norb_all)+ngw3(norb_all) !2*norb_ext*norb_ext*norb_ext
call mma_allocate(intind_iabc,lent,label='intind_iabc')
call mma_allocate(intind_ijka,50000,label='intind_ijka')
call mma_allocate(intind_ijcc,50000,label='intind_ijcc')
call mma_allocate(intind_ijab,50000,label='intind_ijab')
intind_iaqq(1:50000) = 0
intind_abkk(1:50000) = 0
intind_iabc(1:lent) = 0
intind_ijka(1:50000) = 0
intind_ijcc(1:50000) = 0
intind_ijab(1:50000) = 0

call mma_allocate(intspace_abkk,50000,label='inspace_abkk')
call mma_allocate(intspace_ijcc,50000,label='inspace_ijcc')
call mma_allocate(intspace_ijab,50000,label='inspace_ijab')
intspace_abkk(1:50000) = 0
intspace_ijcc(1:50000) = 0
intspace_ijab(1:50000) = 0

voint = Zero
vdint = Zero

return

end subroutine mem_intinnindex_alloc

subroutine mem_intinnindex_dealloc()

use gugaci_global, only: intind_abkk, intind_iabc, intind_iaqq, intind_ijab, intind_ijcc, intind_ijka, intspace_abkk, &
                         intspace_ijab, intspace_ijcc, loij, loij_all, loijk, loijk_all
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(loij)
call mma_deallocate(loijk)
call mma_deallocate(loij_all)
call mma_deallocate(loijk_all)

call mma_deallocate(intind_iaqq)
call mma_deallocate(intind_abkk)
call mma_deallocate(intind_iabc)
call mma_deallocate(intind_ijka)
call mma_deallocate(intind_ijcc)
call mma_deallocate(intind_ijab)

call mma_deallocate(intspace_abkk)
call mma_deallocate(intspace_ijcc)
call mma_deallocate(intspace_ijab)

return

end subroutine mem_intinnindex_dealloc

subroutine allocate_casrst()

use gugaci_global, only: ja, jb, jj, jm, kk, max_node
use stdalloc, only: mma_allocate

implicit none

call mma_allocate(ja,max_node,label='ja')
call mma_allocate(jb,max_node,label='jb')
call mma_allocate(jm,[0,max_node],label='jm')
call mma_allocate(jj,[1,4],[0,max_node],label='jj')
call mma_allocate(kk,[0,max_node],label='kk')
ja(:) = 0
jb(:) = 0
jm(:) = 0
jj(:,:) = 0
kk(:) = 0

return

end subroutine allocate_casrst

subroutine deallocate_casrst()

use gugaci_global, only: ja, jb, jj, jm, kk
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(ja)
call mma_deallocate(jb)
call mma_deallocate(jm)
call mma_deallocate(jj)
call mma_deallocate(kk)

return

end subroutine deallocate_casrst

subroutine allocate_subdrt(icase,lent)

use gugaci_global, only: ihy, iy, jj_sub, jphy, max_node, max_wei
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: icase, lent

call mma_allocate(ihy,max_wei,label='ihy')
call mma_allocate(jj_sub,[1,4],[0,max_node],label='jj_sub')
call mma_allocate(iy,[1,4],[0,max_node],label='iy')
if (icase == 1) then
  call mma_allocate(jphy,max_node,label='jphy')
else
  call mma_allocate(jphy,lent,label='jphy')
end if

end subroutine allocate_subdrt

subroutine allocate_subdrtl(icase,lent)

use gugaci_global, only: ihyl, iyl, jjl_sub, jphyl, max_node, max_wei
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: icase, lent

call mma_allocate(ihyl,max_wei,label='ihyl')
call mma_allocate(jjl_sub,[1,4],[0,max_node],label='jjl_sub')
call mma_allocate(iyl,[1,4],[0,max_node],label='iyl')
if (icase == 1) then
  call mma_allocate(jphyl,max_node,label='jphyl')
else
  call mma_allocate(jphyl,lent,label='jphyl')
end if

end subroutine allocate_subdrtl

subroutine deallocate_subdrt()

use gugaci_global, only: ihy, iy, jj_sub, jphy
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(ihy)
call mma_deallocate(jj_sub)
call mma_deallocate(iy)
call mma_deallocate(jphy)

end subroutine deallocate_subdrt

subroutine deallocate_subdrtl()

use gugaci_global, only: ihyl, iyl, jjl_sub, jphyl
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(ihyl)
call mma_deallocate(jjl_sub)
call mma_deallocate(iyl)
call mma_deallocate(jphyl)

end subroutine deallocate_subdrtl

#ifndef MOLPRO

function c_time()

use Definitions, only: wp

implicit none
real(kind=wp) :: c_time
real(kind=wp), external :: seconds

c_time = seconds()

end function c_time

function ipair(i,j)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ipair
integer(kind=iwp), intent(in) :: i, j

if (i >= j) then
  ipair = i*(i-1)/2+j
else
  ipair = j*(j-1)/2+i
end if

end function ipair

!subroutine trimstr(string)
!! delete space character in the head and tail of the string
!
!use Definitions, only: iwp
!
!implicit none
!character(len=*), intent(inout) :: string
!integer(kind=iwp) :: i, j, k
!character(len=128) :: line
!
!k = len_trim(string)
!line(1:k) = string(1:k)
!do i=1,k
!  if (string(i:i) /= ' ') exit
!end do
!string = ' '
!j = k-i+1
!string(1:j) = line(i:k)
!
!return
!
!end subroutine trimstr

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Reset_ThrGrd(nIter,mTtAtm,ThrGrd)

use Slapaf_Info, only: Cx, nDimBC
use Slapaf_procedures, only: Box, Hidden
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nIter, mTtAtm
real(kind=wp), intent(inout) :: ThrGrd
integer(kind=iwp) :: i, iIter, mTR, nBonds, nHidden, nMax, nSaddle, nsAtom
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: AN(:), TabA(:,:,:), TabAI(:), TabB(:,:)
real(kind=wp), allocatable :: Coor(:,:), Tmp(:), TR(:), Vec(:)

!                                                                      *
!***********************************************************************
!                                                                      *
nsAtom = size(Cx,2)
!                                                                      *
!***********************************************************************
!                                                                      *
call qpg_dArray('Saddle',Found,nSaddle)
if (.not. Found) return
iIter = nIter           ! Normal Computation
!                                                                      *
!***********************************************************************
!                                                                      *
! Find the translational and rotational eigenvectors for the
! current structure.

call mma_allocate(TR,18*nsAtom,Label='TR')
TR(:) = Zero

call TRPGen(nDimBC,nsAtom,Cx(1,1,iIter),mTR,.false.,TR)

!call RecPrt('TR',' ',TR,nDimBC,mTR)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_Allocate(TabAI,2*mTtAtm,Label='TabAI')
call mma_Allocate(Vec,3*mTtAtm*nDimBC,Label='Vec')
call mma_Allocate(AN,mTtAtm,Label='AN')
call mma_Allocate(Coor,3,mTtAtm,Label='Coor')

! Generate Grand atoms list

call GenCoo(Cx(1,1,iIter),nsAtom,Coor,mTtAtm,Vec,nDimBC,AN,TabAI)

! Are there some hidden frozen atoms ?

call Hidden(Coor,AN,nHidden)

! Generate bond list

call Box(Coor,mTtAtm+nHidden,AN,TabB,TabA,nBonds,nMax)
!                                                                      *
!***********************************************************************
!                                                                      *
! If there are some bond types 2, and we are in saddle
! far from the TS, let us get a reduced threshold to avoid
! wasting our time

call mma_allocate(Tmp,nSaddle,Label='Tmp')
call Get_dArray('Saddle',Tmp,nSaddle)
Found = .false.
if (Tmp(nSaddle-1) > Half) then
  do i=1,nBonds
    if (TabB(3,i) == 2) then
      Found = .true.
      exit
    end if
  end do
  if (Found) then
    !ThrGrd = 0.03_wp
    ThrGrd = Ten*ThrGrd
    call WarningMessage(1,'Molecule composed of many fragments Convergence threshold reduced')
  end if
end if
call mma_deallocate(Tmp)

call mma_deallocate(TabA)
call mma_deallocate(TabB)
call mma_deallocate(Coor)
call mma_deallocate(AN)
call mma_deallocate(Vec)
call mma_deallocate(TabAI)
call mma_deallocate(TR)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Reset_ThrGrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cipro()
#include "drt_h.fh"
#include "grad_h.fh"
#include "files_gugaci.fh"
#include "stdalloc.fh"
      parameter (maxmolcasorb=5000,maxpro=50)
      dimension idx_idisk0(64),idx_idisk1(max_root+1)
      dimension occ(max_orb)
      allocatable cmo(:),cno(:)
!     *          denao(max_orb,max_orb)
      dimension ipcom(maxpro)
      REAL*8, pointer :: omat(:),denao(:),vprop(:,:,:)
      character bsbl(2*4*maxmolcasorb)*1
      character*8 label
      character*8 pname(maxpro),ptyp(maxpro)
      dimension pnuc(maxpro)
      dimension pgauge(3,maxpro)
      dimension idummy(1)

! mrci nature orbital
      idisk=0
      call idafile(lucimo,2,idx_idisk0,64,idisk)
!      print*, "read head"
      idisk=idx_idisk0(2)
      nc=2*4*maxmolcasorb
      call cdafile(lucimo,2,bsbl,nc,idisk)

!      open(100,file="dat1")
      nc0=0
      nc1=0
      nc2=0
      nmo=0
      do im=1,ng_sm
        nc0=nc0+nlsm_bas(im)**2
        nc1=nc1+nlsm_all(im)*(nlsm_all(im)+1)/2
        nc2=nc2+nlsm_bas(im)*(nlsm_bas(im)+1)/2
        nmo=nmo+nlsm_bas(im)
      enddo
! read property labels
      iopt=8
      npro=0
      do i=1,100
        label="undef"
        call irdone(irec,iopt+1,label,ipc,idummy,isymlb)
        if(irec.ne.0) exit
        iopt=16
        if(mod(isymlb,2).eq.0) cycle
        npro=npro+1
        pname(npro)=label
        ipcom(npro)=ipc
        ptyp(npro)="HERM"
        if(label.eq."VELOCITY") ptyp(npro)="ANTI"
        if(label.eq."ANGMOM  ") ptyp(npro)="ANTI"
        if(label(1:5).eq."MLTPV") ptyp(npro)="ANTI"
        if(npro.ge.maxpro) exit
      enddo

!      print"(10(1X,a8))", pname(1:npro)
!      print*, ipcom(1:npro)
!      print*, ptyp(1:npro)

      allocate(omat(nc2))
      allocate(denao(nc0))
      allocate(vprop(mroot,mroot,npro))
!      allocate(denao(nmo,nmo))
      call mma_allocate(cmo,max_orb**2,label='cmo')
      call mma_allocate(cno,max_orb**2,label='cno')
      idisk=idx_idisk0(3)
      call ddafile(lucimo,2,cmo,nc0,idisk)
! read overlap matirx
      call rdone(irec,6,"MLTPL  0",1,omat,idummy(1))
      idisk=0
      call idafile(luciden,2,idx_idisk1,max_root+1,idisk)

      icall=0
      do iroot=1,mroot
! read density matrix
        idisk=idx_idisk1(iroot)
        call ddafile(luciden,2,denm1,nc1,idisk)
        call natureorb(nlsm_bas,nlsm_all,nlsm_del,ng_sm,denm1,
     *                 nc1,cmo,nc0,bsbl,nc,cno,occ,nmo,pror)

! mulliken population
        call xflush(6)
        write(6,'(a,i2)')' mulliken charges for state nr ',iroot
!        call charge(nsym,nbas,name,cno,occ,smat,2,.true.,.true.)
        call charge(ng_sm,nlsm_bas,bsbl,cno,occ,omat,2,.true.,.false.)
        write(6,*)' ',('*',i=1,70)
        call xflush(6)
! transform mo density matrix to ao basis
!        print"(10i8)", nc0,nmo,nlsm_bas
        call transden(ng_sm,nlsm_bas,denao,cno,nc0,occ,nmo)

! calculated properties
        call calprop(ng_sm,nlsm_bas,mroot,iroot,iroot,nc2,npro,
     *               pname,ipcom,ptyp,
     *               denao,nc0,vprop,pgauge,pnuc,icall)
! print property
      enddo
      call mma_deallocate(cmo)
      call mma_deallocate(cno)
!      close(100)


! this code copy from molcas
      if(npro.gt.0) then
c write expectation values:
        write(6,*)
        write(6,*)' expectation values of various operators:'
        write(6,*)
     *  '(note: electronic multipoles include a negative sign.)'
        do 110 iprop=1,npro
          if(ptyp(iprop).eq.'ANTI') goto 110
          do 105 ista=1,mroot,4
            iend=min(ista+3,mroot)
            write(6,*)
            write(6,'(1x,a,a8,a,i4)')
     *    '   property: ',pname(iprop),
     *    '   component:',ipcom(iprop)
            write(6,'(1x,a,3f16.8)')
     *    '    gauge origin:',(pgauge(i,iprop),i=1,3)
            write(6,'(1x,a,i8,3i16)')
     *    '            root:',(i,i=ista,iend)
            write(6,'(1x,a,4f16.8)')
     *    '      electronic:',(vprop(i,i,iprop),i=ista,iend)
            write(6,'(1x,a,4f16.8)')
     *    '         nuclear:',(pnuc(iprop),i=ista,iend)
            write(6,'(1x,a,4f16.8)')
     *    '           total:',(pnuc(iprop)+vprop(i,i,iprop),i=ista,iend)
105       continue
110     continue
        write(6,*)
      end if


      iopt=8
      npro=0
      do i=1,100
        label="undef"
        call irdone(irec,iopt+1,label,ipc,idummy,isymlb)
        if(irec.ne.0) exit
        iopt=16
!       if(mod(isymlb,2).eq.0) cycle
        npro=npro+1
        pname(npro)=label
        ipcom(npro)=ipc
        ptyp(npro)="HERM"
        if(label.eq."VELOCITY") ptyp(npro)="ANTI"
        if(label.eq."ANGMOM  ") ptyp(npro)="ANTI"
        if(label(1:5).eq."MLTPV") ptyp(npro)="ANTI"
        if(npro.ge.maxpro) exit
      enddo

!      print"(10(1x,a8))", pname(1:npro)
!      print"(10i4)", ipcom(1:npro)
!      print"(10(1x,a8))", ptyp(1:npro)

      nsiz=0
      Call Molcas_BinaryOpen_Vanilla(110,"soint.dat")
      do i=1,npro
        if(pname(i)(1:4).ne."AMFI") cycle
        omat=0.d0
        call irdone(irtc,1,pname(i),ipcom(i),idummy,isymlb)
        if (irtc.eq.0) nsiz=idummy(1)
        call rdone(irtc,0,pname(i),ipcom(i),omat,isymlb)
        if(nsiz.gt.nc2) then
          write(6,*) "in subroutine cipro, read so int error"
          call abend
c          stop 1999
        endif
        write(6,"(a8,1x,2i4)") "nsiz=",i,nsiz
        write(6,"(5(1x,f12.8))") omat(1:nsiz)
        write(110) nsiz
        write(110) omat(1:nsiz)
      enddo
      close(110)
      deallocate(omat)
      deallocate(denao)
      deallocate(vprop)
      return
      end

      subroutine calprop(ngsm,nsbas,mroot,istate,jstate,nsi,npro,pname,
     *                   ipcom,ptyp,aden,lmo,
     *                   vprop,pgauge,pnuc,icall)
      implicit none
!-----------------------------------------------------
      integer ngsm,mroot,istate,jstate,nsi,npro,lmo,icall
      character*8 pname(npro),ptyp(npro)
      integer :: ipcom(npro),nsbas(ngsm)
      real*8 :: smat(nsi),amat(nsi),aden(lmo)
      real*8 :: vprop(mroot,mroot,npro)
      real*8 :: pgauge(3,npro),pnuc(npro)
!-----------------------------------------------------
      integer nsiz
      integer i,j,im,nc,nc0,nc1,irtc,isymlb
      real*8 pint(nsi+4)
      real*8 val,sgn,ddot_
      integer idummy(1)

! we have two kind of densitry matrix, symm or anti-symm
! compress density matrix
      nc0=0
      nc1=1
      nc=0
      do im=1,ngsm
        if(nsbas(im).eq.0) cycle
        do i=1,nsbas(im)
          do j=1,i-1
            smat(nc1)=aden(nc0+(j-1)*nsbas(im)+i)
     *               +aden(nc0+(i-1)*nsbas(im)+j)
            amat(nc1)=aden(nc0+(j-1)*nsbas(im)+i)
     *               -aden(nc0+(i-1)*nsbas(im)+j)
!            smat(nc1)=aden(nc+i,nc+j)+aden(nc+j,nc+i)
!            amat(nc1)=aden(nc+i,nc+j)-aden(nc+j,nc+i)
            nc1=nc1+1
          enddo
          smat(nc1)=aden(nc0+(i-1)*nsbas(im)+i)
!          smat(nc1)=aden(nc+i,nc+i)
          amat(nc1)=0.d0
          nc1=nc1+1
        enddo
        nc=nc+nsbas(im)
        nc0=nc0+nsbas(im)**2
      enddo

!      open(100,file="dat1")
!      do i=1,1293
!        write(100,"(i8,1x,f14.8)") i,smat(i)
!      enddo
!      close(100)

      nsiz=nsi
! read property int and calculated property
      do i=1,npro
        call irdone(irtc,1,pname(i),ipcom(i),idummy,isymlb)
        if (irtc.eq.0) nsiz=idummy(1)
        call rdone(irtc,0,pname(i),ipcom(i),pint,isymlb)
C        print*, "nsiz",nsiz
        if(icall.eq.0) then
          pgauge(1,i)=pint(nsiz+1)
          pgauge(2,i)=pint(nsiz+2)
          pgauge(3,i)=pint(nsiz+3)
          pnuc(i)=pint(nsiz+4)
        endif
        if(isymlb.ne.1) then
          write(6,*) "error calcualte property,need debug"
          call abend
!          stop 888
        endif
!        print*, "pop int"
!        print"(10(1x,f8.5))",pint(1:100)
!        print*, "sden "
!        print"(10(1x,f8.5))",smat(1:100)

! calculate and save property
        sgn=1.d0
        if(pname(i)(1:5).eq."MLTPL") sgn=-1.d0
        if(ptyp(i)(1:4).eq."HERM") then
          val=sgn*ddot_(nsiz,smat,1,pint,1)
          vprop(istate,jstate,i)=val
          vprop(jstate,istate,i)=val
        else
          val=sgn*ddot_(nsiz,amat,1,pint,1)
          vprop(istate,jstate,i)=val
          vprop(jstate,istate,i)=-val
        endif
!        write(6,*) nsiz,"val=",val
      enddo

      icall=1

      return
      end

      subroutine transden(ngsm,nsbas,denao,cno,lmo,occ,loc)
! calculate density matrix in ao basis
      implicit none
      integer ngsm,lmo,loc
      integer :: nsbas(ngsm)
      real*8  :: denao(lmo),cno(lmo),occ(loc)
!      real*8  :: denao(loc,loc),cno(lmo),occ(loc)
!-----------------------------------------------
      integer i,im,ni,nc,nc0,nc1
      real*8 val

      denao=0.d0
!      print*, "occ",nsbas(1:ngsm)
!      print"(10(1x,f8.5))",occ
      nc=1
      nc0=0
      nc1=1
      do im=1,ngsm
        ni=nsbas(im)
        if(ni.eq.0) cycle
!        print*, nc,ni
        do i=1,ni
          val=occ(i+nc0)
          call dger(ni,ni,val,cno(nc1),1,cno(nc1),1,
     *              denao(nc),ni)
          nc1=nc1+ni
        enddo
        nc0=nc0+ni
        nc=nc+ni**2
      enddo

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRWF(SGS,CIS,ISYCI,CI,CITHR)
      use definitions, only: iwp, wp
      use gugx, only: SGStruct, CIStruct
      use stdalloc, only: mma_allocate, mma_deallocate
      IMPLICIT NONE
      Type (SGStruct), intent(in):: SGS
      Type (CIStruct), intent(in):: CIS
      integer(kind=iwp) ISYCI
      real(kind=wp), intent(in):: CI(*), CITHR

      Integer(kind=iwp), Allocatable:: ICS(:)
      Integer(kind=iwp) NLEV,NMIDV

      NLEV  =SGS%nLev
      NMIDV =CIS%nMidV

      CALL mma_allocate(ICS,NLEV,Label='ICS')
      CALL PRWF1(SGS,CIS,NLEV,NMIDV,SGS%ISM,ICS,CIS%NOCSF,
     &           CIS%IOCSF,CIS%NOW,CIS%IOW,ISYCI,CI,CITHR)
      CALL mma_deallocate(ICS)

      END SUBROUTINE PRWF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Ttotal(T1,T2,T3,T4,Ttot,Ttot_Inv,nDim)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(in) :: T1(nDim,nDim), T2(nDim,nDim), T3(nDim,nDim), T4(nDim,nDim)
real(kind=wp), intent(out) :: Ttot(nDim,nDim), Ttot_Inv(nDim,nDim)
integer(kind=iwp) :: ISING
real(kind=wp) :: DET
real(kind=wp), allocatable :: Temp(:,:), Temp2(:,:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Ttot=T1*T2*T3*T4

!lg write(u6,*) 'Ttotal ', nDim
call mma_allocate(Temp,nDim,nDim,label='Temp')
call mma_allocate(Temp2,nDim,nDim,label='Temp2')
call DGEMM_('N','N',nDim,nDim,nDim,One,T1,nDim,T2,nDim,Zero,Temp,nDim)
call DGEMM_('N','N',nDim,nDim,nDim,One,Temp,nDim,T3,nDim,Zero,Temp2,nDim)
call DGEMM_('N','N',nDim,nDim,nDim,One,Temp2,nDim,T4,nDim,Zero,Ttot,nDim)
call mma_deallocate(Temp)
call mma_deallocate(Temp2)
!lg call RecPrt('T_TOT',' ',Ttot,nDim,nDim)
call MINV(Ttot,Ttot_Inv,ISING,DET,nDim)

return

end subroutine Ttotal

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Free_RctFld()

use PCM_arrays, only: Centr, dCntr, dPnt, dRad, dTes, IntSph, NewSph, nVert, PCM_N, PCM_SQ, PCMDm, PCMiSph, PCMSph, PCMTess, SSph, &
                      Vert
use Langevin_arrays, only: Cavxyz, Davxyz, dField, Dip, DipEF, Field, Grid, PolEF, Ravxyz
use rctfld_module, only: DoDeriv, lLangevin, MM, PCM
use External_Centers, only: iXPolType
use stdalloc, only: mma_deallocate

implicit none

if (allocated(MM)) then

  call mma_deallocate(MM)

  if (lLangevin .or. (iXPolType > 0)) then
    call mma_deallocate(Field)
    call mma_deallocate(dField)
    call mma_deallocate(Dip)
    call mma_deallocate(PolEf)
    call mma_deallocate(DipEf)
    call mma_deallocate(Grid)
    call mma_deallocate(davxyz)
    call mma_deallocate(cavxyz)
    call mma_deallocate(ravxyz)
  end if

  if (PCM) then
    call mma_deallocate(NewSph)
    call mma_deallocate(IntSph)
    call mma_deallocate(NVert)
    call mma_deallocate(PCMiSph)
    call mma_deallocate(PCM_N)
    call mma_deallocate(PCMDM)
    call mma_deallocate(SSph)
    call mma_deallocate(Centr)
    call mma_deallocate(Vert)
    call mma_deallocate(PCMTess)
    call mma_deallocate(PCMSph)

    ! Free the space for geometric derivatives

    if (DoDeriv) then
      call mma_deallocate(dTes)
      call mma_deallocate(dPnt)
      call mma_deallocate(dRad)
      call mma_deallocate(dCntr)
      call mma_deallocate(PCM_SQ)
    end if

  end if

end if

return

end subroutine Free_RctFld

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Giovanni Li Manni                                *
************************************************************************

      Subroutine ChkSplit()
************************************************************************
*     SplitCAS Check for obvious errors or violation  of limits        *
*----------------------------------------------------------------------*
*     written by:                                                      *
*     Giovanni Li Manni (GLMJ)                                         *
*     University of Geneva, Switzerland, 2010                          *
*----------------------------------------------------------------------*
*     history: none                                                    *
************************************************************************

      Implicit Real*8 (A-H,O-Z)
#include "rasdim.fh"

#include "output_ras.fh"
#include "general.fh"
#include "splitcas.fh"
#include "warnings.fh"
      Parameter ( ROUTINE='ChkSplit' )

*      IF(DoSplitCAS) THEN
        IERR=0
        If (lRootSplit.gt.nConf) IERR=1
        If (IERR.eq.1) then
          Write(LF,*)
          Write(LF,*)'******************** ERROR *********************'
          Write(LF,'(1X,A)')'Input Error: '
          write(LF,*)' Root you are looking for is not reachable within'
          write(LF,*)' the selected active space.'
          Write(LF,*)' Try to select a bigger active space!'
          write(LF,*)' Root selected by user = ', lRootSplit
          write(LF,*)' Root reachable = ', nConf
          Write(LF,*)'************************************************'
          Call Quit(_RC_INPUT_ERROR_)
        End If

*       If ( NumSplit ) then
        IERR=0
        If ( iDimBlockA.lt.lRootSplit) IERR=1
        If (IERR.eq.1) then
          Write(LF,*)
          Write(LF,*)'******************** ERROR **********************'
          Write(LF,*)'Input Error: AA-Block selected is too small!'
          Write(LF,'(1X,A,I5)')' Root to be optimized :',lRootSplit
          Write(LF,'(1X,A,I5)')' AA-Block dimension   :',iDimBlockA
        write(LF,*)'AA-Block must be always equal or greater than root.'
          write(LF,*) 'In a NUSP calculation increase iDimBlockA'
          write(LF,*) 'In a ENSP calculation increase the energy-gap'
          write(LF,*) 'In a PESP calculation increase the percentage'
          Write(LF,*)'*************************************************'
          Call Quit(_RC_INPUT_ERROR_)
*          iDimBlockA=lRootSplit
*          ircWar = 1
*          Write(LF,'(1X,A,I8)')
*     &    'iDimBlockA has been reset to =',iDimBlockA
        End If

        IERR=0
        If (iDimBlockA.gt.mxDimBlockA) IERR=1
        If (IERR.eq.1) then
          Write(LF,*)
          Write(LF,*) '***************** ERROR *****************'
          Write(LF,'(1X,A,I6)')'Input Error: Max dim. BlockA exceeded',
     &                        mxDimBlockA
          write(LF,*) 'iDimBlockA selected by user = ', iDimBlockA
          write(LF,*) 'If you are running a NUSP calculation, ',
     &    'please, decrease the value of iDimBlockA!'
          write(LF,*) 'If you are running a ENSP calculation, ',
     &    'please, decrease the energy-gap!'
          write(LF,*) 'If you are running a PESP calculation, ',
     &    'please, decrease the percentage!'
          Write(LF,*)'************************************************'
          Call Quit(_RC_INPUT_ERROR_)
        End If
*       End If
*       ^ End chk over NumSplit

      IERR=0
      If (ThrSplit.lt.min_ThrSplit) IERR = 1
      If (IERR.eq.1) then
        Write(LF,*)
        Write(LF,*) '***************** ERROR *****************'
        Write(LF,'(1X,A,I6)')'Input Error: ThrSplit too small'
        Write(LF,'(1X,A,I6)')'minimum value ThrSplit = ', min_ThrSplit
        write(LF,*) 'ThrSplit selected by user = ', ThrSplit
        Write(LF,*)'************************************************'
        Call Quit(_RC_INPUT_ERROR_)
      End If

*      END IF

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gugadrt_mole_inf()

use gugadrt_global, only: iprint, iref_occ, logic_mr, logic_mrelcas, lsm_inn, ludrt, max_ref, n_electron, n_ref, ng_sm, nlsm_all, &
                          nlsm_bas, nlsm_ext, nlsmddel, nlsmedel, norb_act, norb_all, norb_dbl, norb_dz, norb_ext, norb_frz, &
                          norb_inn, ns_sm, nstart_act, spin
use Symmetry_Info, only: Mul
use Constants, only: Zero, Two
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: err, i, icmd, idisk, idum(1), im, iorb, ispin, itmpstr(72), j, jcmd, ln1, lsm, lsmtmp(8), ms_ref, mult, &
                     nact_sm, nactel, nde, ndisk, ne_act, neact, ngsm, nlsm_act(8), nlsm_dbl(8), nlsm_frz(8), nlsm_inn(8), &
                     noidx(8), norb1, norb2, norb_all_tmp, ntit
logical(kind=iwp) :: log_debug, skip
character(len=4) :: command
character(len=72) :: line
character(len=132) :: modline
! copy from molcas, bsuo, jun. 30, 2009
integer(kind=iwp), parameter :: ncmd = 18, mxtit = 10
character(len=*), parameter :: cmd(ncmd) = ['TITL','ELEC','SPIN','SYMM','ACTI','PRIN','REFE','FIRS','INAC','CIAL', &
                                            'VALE','INTE','NOCO','ONEO','EXTR','NONI','NACT','END ']

n_electron = 0
nactel = 0
spin = Zero
ns_sm = 1
call rdnlst(5,'GUGADRT')
ntit = 0
skip = .false.
jcmd = 0
do
  if (.not. skip) then
    read(5,'(a)',iostat=err) line
    if (err < 0) call error(1)
    command = line(1:8)
    call upcase(command)
    if (command(1:1) == '*') cycle
    if (command == ' ') cycle
    jcmd = 0
    do icmd=1,ncmd
      if (command == cmd(icmd)) jcmd = icmd
    end do
  end if
  skip = .false.
  select case (jcmd)
    case (1)
      !---  process title    command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        command = line(1:8)
        call upcase(command)
        if (command(1:1) == '*') cycle
        jcmd = 0
        do icmd=1,ncmd
          if (command == cmd(icmd)) jcmd = icmd
        end do
        if (jcmd /= 0) then
          skip = .true.
          exit
        end if
        ntit = ntit+1
      end do

    case (2)
      !---  process electron command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=err) n_electron
      if (err > 0) call error(2)

    case (3)
      !---  process spin     command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=err) ispin
      if (err > 0) call error(2)
      spin = (ispin-1)/Two

    case (4)
      !---  process symmetry command ----------------------------------------*
      !write (u6,*)'input_guga: keyword symmetry is obsolete and ignored!
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=err) ns_sm
      if (err > 0) call error(2)

    case (5)
      !---  process active   command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      modline = line//' 0 0 0 0 0 0 0 0'
      read(modline,*,iostat=err) (nlsm_act(i),i=1,8)
      if (err > 0) call error(2)

    case (6)
      !---  process print    command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=err) iprint
      if (err > 0) call error(2)

    case (7)
      !---  process referenc command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=err) n_ref,ln1
      if (err > 0) call error(2)
      if (n_ref > max_ref) then
        write(u6,*) ' Warnning! Program could not deal with so many reference states!'
        write(u6,*) ' Maximum number of reference states is',max_ref
        write(u6,*) ' Set number of reference states into ',max_ref
        n_ref = max_ref
      end if
      if (ln1 == 0) then
        logic_mr = .true.
      else
        do i=1,n_ref
          read(5,'(80i1)',iostat=err) iref_occ(1:ln1,i)
          if (err < 0) call error(1)
          if (err > 0) call error(2)
        end do
        logic_mr = .true.
      end if

    case (8)
      !---  process first    command ----------------------------------------*

    case (9)
      !---  process inactive command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      modline = line//' 0 0 0 0 0 0 0 0'
      read(modline,*,iostat=err) (nlsm_dbl(i),i=1,8)
      if (err > 0) call error(2)

    case (10)
      !---  process ciall    command ----------------------------------------*
      !do
      !  read(5,'(a)',iostat=err) line
      !  if (err < 0) call error(1)
      !  if (line(1:1) /= '*') exit
      !end do
      !read(line,*,iostat=err) ns_sm
      !if (err > 0) call error(2)
      logic_mrelcas = .true.

    case (11)
      !---  process valence  command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      modline = line//' 0 0 0 0 0 0 0 0'
      read(modline,*,iostat=err) (nlsm_ext(i),i=1,8)
      if (err > 0) call error(2)

    case (12)
      !---  process interact command ----------------------------------------*

    case (13)
      !---  process nocorr   command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      modline = line//' 0 0 0 0 0 0 0 0'
      read(modline,*,iostat=err)  !(ncor(i),i=1,8)
      if (err > 0) call error(2)
      !bsuo, jun. 30, 2009 - neglect them

    case (14)
      !---  process oneocc   command ----------------------------------------*
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      modline = line//' 0 0 0 0 0 0 0 0'
      read(modline,*,iostat=err) ! (ione(i),i=1,8)
      if (err > 0) call error(2)
      !bsuo, jun. 30, 2009 - neglect them

    case (15)
      !---  process extract  command ----------------------------------------*
      write(u6,*) 'input: extract option is redundant and is ignored!'

    case (16)
      !---  process non-interact command -------------------------------------
      write(u6,*) 'input: non-interact option is redundant and is ignored!'

    case (17)
      !---  process nactel       command -------------------------------------
      do
        read(5,'(a)',iostat=err) line
        if (err < 0) call error(1)
        if (line(1:1) /= '*') exit
      end do
      read(line,*,iostat=err) nactel
      if (err > 0) call error(2)

    case (18)
      !---  the end of the input is reached, print the title ----------------*
      exit

    case default
      write(u6,*) 'input: illegal keyword'
      write(u6,'(a,a)') 'command=',command
      call abend()

  end select

end do

! frozen orbital(dbl, ext) have been delete in mo trans step, so we negl here.
nlsm_frz(1:ng_sm) = 0

norb_frz = 0
norb_act = 0
norb_dz = 0
norb_all = 0
do i=1,ng_sm
  norb_frz = norb_frz+nlsm_frz(i)
  norb_dbl = norb_dbl+nlsm_dbl(i)
  norb_act = norb_act+nlsm_act(i)
  nlsm_inn(i) = nlsm_frz(i)+nlsm_dbl(i)+nlsm_act(i)
  nlsm_ext(i) = nlsm_all(i)-nlsm_inn(i)
  norb_all = norb_all+nlsm_all(i)
end do
norb_inn = norb_frz+norb_dbl+norb_act
norb_ext = norb_all-norb_inn
norb_dz = norb_dbl+norb_frz

nstart_act = norb_dz+1

iorb = 0
do i=1,ng_sm
  do j=1,nlsm_frz(i)
    iorb = iorb+1
    lsm_inn(iorb) = i
  end do
end do
do i=1,ng_sm
  do j=1,nlsm_dbl(i)
    iorb = iorb+1
    lsm_inn(iorb) = i
  end do
end do
do i=1,ng_sm
  do j=1,nlsm_act(i)
    iorb = iorb+1
    lsm_inn(iorb) = i
  end do
end do

nact_sm = 1
do im=1,norb_inn
  if (lsm_inn(im) > nact_sm) nact_sm = lsm_inn(im)
end do

norb_all_tmp = 0
do ngsm=1,ng_sm
  norb_all_tmp = norb_all_tmp+nlsm_all(ngsm)
end do
if (norb_all_tmp /= norb_all) then
  write(u6,*) '  input num.of orbital err! check again!'
  call abend()
end if

lsm = 0
do im=ng_sm,1,-1
  if (nlsm_ext(im) > 0) then
    lsm = im
    exit
  end if
end do
lsm_inn(norb_inn+1) = lsm

lsmtmp(1:8) = 0
if (logic_mr) then
  do i=1,n_ref
    itmpstr(1:norb_act) = iref_occ(1:norb_act,i)
    do j=1,norb_dz
      iref_occ(j,i) = 2
    end do
    iref_occ(norb_dz+1:norb_dz+norb_act,i) = itmpstr(1:norb_act)
  end do
end if

do i=1,ng_sm !norb_inn
  lsmtmp(i) = 0
end do
do i=1,norb_inn
  lsmtmp(lsm_inn(i)) = lsmtmp(lsm_inn(i))+1
end do

!============ chck input data block ====================
if (norb_frz > norb_dz) then
  write(u6,*) ' check input data: norb_frz  error'
  call abend()
end if
! check number of electrons
if (nactel /= 0) then
  if (n_electron /= 0) then
    ne_act = n_electron-2*norb_dz
    if (nactel /= ne_act) then
      write(u6,*) 'Input error, Error in checking ELECtron and NACTel!'
      call abend()
    end if
  else
    ne_act = nactel
    n_electron = 2*norb_dz+nactel
  end if
else
  if (n_electron /= 0) then
    ne_act = n_electron-2*norb_dz
    nactel = ne_act
  else
    ne_act = 0
    write(u6,*) 'Input error, you must input ELECtron or NACTel!'
    call abend()
  end if
end if
nde = 2*norb_dz
if (nde > n_electron) then
  write(u6,'(1x,42a)') 'check input date: number of electrons error'
  write(u6,'(1x,a20,1x,i4)') 'number of electrons ',n_electron
  write(u6,'(1x,a36,1x,i4)') 'number of doubly occupied electrons ',nde
  call abend()
end if

norb1 = norb_inn+norb_ext
norb2 = 0
do i=1,ng_sm
  norb2 = norb2+nlsm_all(i)
end do
if (norb1 /= norb2) then
  write(u6,*) ' check input data: orb_number error'
  write(u6,*) norb1,norb2
  call abend()
end if

if (logic_mr) then
  write(u6,*) ' Refrence states'
  !ne_act = n_electron-2*norb_dz
  do i=1,n_ref
    write(u6,'(80i1)') iref_occ(1:norb_inn,i)
    ms_ref = 1
    neact = 0
    do j=norb_dz+1,norb_inn
      if (iref_occ(j,i) == 1) ms_ref = Mul(ms_ref,lsm_inn(j))
      if (iref_occ(j,i) == 1) neact = neact+1
      if (iref_occ(j,i) == 2) neact = neact+2
    end do
    if (ms_ref /= ns_sm .or. neact /= ne_act) then
      write(u6,*) '  input ref_conf  err! check again! ',i
      call abend()
    end if
  end do
end if
!============ block end =============================
!****************************************************
log_debug = .false.
if (log_debug) then
  write(u6,1001)
  write(u6,1002) norb_all,norb_frz,norb_dz,norb_inn,norb_ext
  write(u6,1002) nlsm_all(1:ng_sm)
  write(u6,1002) nlsm_frz(1:ng_sm)
  write(u6,1002) nlsm_dbl(1:ng_sm)
  write(u6,1002) nlsm_inn(1:ng_sm)
  write(u6,*) 'lsm inn'
  write(u6,1002) lsm_inn(1:norb_inn)
end if
!*****************************************************

! merge into molcas
! write date into cidrt for ci calculation
noidx = 0
idisk = 0
call idafile(ludrt,1,noidx,2,idisk)
! group symmetry
idum(1) = ng_sm
call idafile(ludrt,1,idum,1,idisk)
! state symmetry
idum(1) = ns_sm
call idafile(ludrt,1,idum,1,idisk)
! number of roots to be cal
idum(1) = 1
call idafile(ludrt,1,idum,1,idisk)
! number of corelation electrons
idum(1) = n_electron
call idafile(ludrt,1,idum,1,idisk)
! number of active electrons
idum(1) = nactel
call idafile(ludrt,1,idum,1,idisk)
! spin symmetry of the state, 2s+1
idum(1) = ispin
call idafile(ludrt,1,idum,1,idisk)
! dbl orb
call idafile(ludrt,1,nlsm_dbl,8,idisk)
! act orb
call idafile(ludrt,1,nlsm_act,8,idisk)
! all correlated orb
call idafile(ludrt,1,nlsm_all,8,idisk)
! num. basis
call idafile(ludrt,1,nlsm_bas,8,idisk)
! method to choose ref. state, 4 for cas, 2 for rst
if (logic_mr) then
  idum(1) = 2
  call idafile(ludrt,1,idum,1,idisk)
  idum(1) = n_ref
  call idafile(ludrt,1,idum,1,idisk)
  ! reference states
  !iref_occ(norb_dz+1:norb_dz+norb_act,i)=itmpstr(1:norb_act)
  do i=1,n_ref
    call idafile(ludrt,1,iref_occ(1,i),norb_inn,idisk)
  end do
end if
if (logic_mrelcas) then
  idum(1) = 4
  call idafile(ludrt,1,idum,1,idisk)
end if
! number of ref. states, if logic_mr = .true.
noidx(2) = idisk
idisk = 0
call idafile(ludrt,1,noidx,2,idisk)
noidx = 0
do i=1,ng_sm
  noidx(i) = i
end do
mult = nint(2*spin)+1
write(u6,*) '-----------------------------------------------'
write(u6,*) '    ci orbitals information'
ndisk = 0
do i=1,8
  ndisk = ndisk+nlsm_bas(i)
end do
write(u6,*) '    num. of basis:          ',ndisk
write(u6,*) '    num. of orbitals:       ',norb_all
write(u6,*) '    num. of active-orbitals:',norb_act
write(u6,*) '    num. of electrons:      ',n_electron
write(u6,*) '    multiplicity:           ',mult
write(u6,*) '    symmetry:               ',ns_sm
write(u6,*)
write(u6,*) '    oribtials per-symmtry'
write(u6,1003) noidx(1:ng_sm)
write(u6,1004) nlsmddel(1:ng_sm)
write(u6,1005) nlsm_dbl(1:ng_sm)
write(u6,1006) nlsm_act(1:ng_sm)
write(u6,1007) nlsm_ext(1:ng_sm)
write(u6,1008) nlsmedel(1:ng_sm)
write(u6,*) '-----------------------------------------------'

! following information will be drts
! notice we do not close file ludrt here, it will be closed after drt
! information is written into this file
!---------------------------------------------------------------------

return

1001 format(1x,'norb all group sm')
1002 format(8(1x,i3))
1003 format(16x,8(i4))
1004 format(8x,'frozen  ',8(i4))
1005 format(8x,'double  ',8(i4))
1006 format(8x,'active  ',8(i4))
1007 format(8x,'virtual ',8(i4))
1008 format(8x,'frz ext ',8(i4))

contains

subroutine error(code)
  integer(kind=iwp), intent(in) :: code
  select case (code)
    case (1)
      write(u6,*) 'input: end of input file encountered'
    case (2)
      write(u6,*) 'input: error while reading input!'
  end select
  write(u6,'(a,a)') 'last command: ',command
  call abend()
end subroutine error

end subroutine gugadrt_mole_inf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine asonc12e_cvb( &
#                       define _CALLING_
#                       include "ddasonc_interface.fh"
                       )
! Applies S and H on c vector(s).

use casvb_global, only: civb2, civb3, civb4, cpu0, cvb, cvbdet, ipp12e, iter12e, npr, nprorb, nvb, orbs, strucopt
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "ddasonc_interface.fh"
integer(kind=iwp) :: ic1, ivec
real(kind=wp), allocatable :: vec_all(:)
real(kind=wp), external :: ddot_, tim_cvb

iter12e = iter12e+1
if (ipp12e >= 2) then
  write(u6,'(/,a,i5,a,f10.3,a)') ' Davidson iteration',iter12e,' at',tim_cvb(cpu0),' CPU seconds'
  write(u6,'(a)') ' -----------------------------------------------'
end if

! If no optimization of structure coefficients we are doing "Augmented" calc:
if (strucopt) then
  ic1 = 1
else
  ic1 = 2
end if

call mma_allocate(vec_all,npr,label='vec_all')
do ivec=1,nvec
  call free2all_cvb(c(ic1,ivec),vec_all,1)
  if (.not. strucopt) vec_all(nprorb+1:nprorb+nvb) = vec_all(nprorb+1:nprorb+nvb)+c(1,ivec)*cvb(1:nvb)
  ! (CIVB set in O12EA :)
  call cizero_cvb(civb2)
  call oneexc_cvb(civb3,civb2,vec_all,.false.,0)
  call str2vbc_cvb(vec_all(nprorb+1),cvbdet)
  call vb2ciaf_cvb(cvbdet,civb2)
  call cicopy_cvb(civb2,civb4)
  call makecivbhs_cvb(civb4,civb2,orbs)

  call ci2vbg_cvb(civb4,cvbdet)
  call vb2strg_cvb(cvbdet,vec_all(nprorb+1))
  vec_all(1:nprorb) = Zero
  call onedens_cvb(civb3,civb4,vec_all,.false.,0)
  call all2free_cvb(vec_all,axc(ic1,ivec),1)
  if (.not. strucopt) axc(1,ivec) = ddot_(nvb,cvb,1,vec_all(nprorb+1:nprorb+nvb),1)

  call ci2vbg_cvb(civb2,cvbdet)
  call vb2strg_cvb(cvbdet,vec_all(nprorb+1))
  vec_all(1:nprorb) = Zero
  call onedens_cvb(civb3,civb2,vec_all,.false.,0)
  call all2free_cvb(vec_all,sxc(ic1,ivec),1)
  if (.not. strucopt) sxc(1,ivec) = ddot_(nvb,cvb,1,vec_all(nprorb+1:nprorb+nvb),1)
end do
call mma_deallocate(vec_all)

return

end subroutine asonc12e_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MRCI(IRETURN)
************************************************************************
*  MULTI REFERENCE SDCI AND AVERAGE CPF PROGRAM.                       *
************************************************************************
C UNITS USED IN THE PROGRAM
C UNIT  5, INPUT
C UNIT  6, OUTPUT
C UNIT  2=LUPROP, (DA,ONEINT) FOR PROPERTY CALCULATIONS
C UNIT 10=LUSYMB, (DA,CIGUGA) SYMBOLIC FORMULAS
C UNIT 50=LUTRA, (DA,TRAINT) TRANSFORMED MO 2-EL INTEGRALS
C UNIT 60, (DA) SORTED AIBJ, ABIJ AND AIJK INTEGRALS
C UNIT 70, (DA) SORTED IJKL AND ABCI INTEGRALS
C UNIT 80, (DA) SORTED ABCD INTEGRALS
C UNIT 17=LUONE, (DA,TRAONE) ONE ELECTRON INTEGRALS
C UNIT 18=LUVEC, (Formatted, sequential!) MRCI ORBITALS OUT
C UNIT 23=LUEIG, (DA) WORKSPACE FOR MALMQUIST DIAGONALIZATION.
C UNIT 25, (DA) FOCK MATRIX AND DIAGONAL CSF MATRIX ELEMENTS
C UNIT 27, (DA) SCRATCH IN IIJJ. ALSO, REFERENCE CI VECTOR.
C UNIT 28=LUREST, (DA,MRCIVECT) CI VECTOR
************************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "WrkSpc.fh"

#include "SysDef.fh"

#include "mrci.fh"
*
*     Prologue, print program header
*
*      CALL SETTIM
      CALL XUFLOW
*
*     ( Workspace allocated in Start() )
*
*      Call IniMem
*PAM04      Call GetMem('WrkSpc','Max ','Real',MemOff,MaxMem)
*PAM04* PAM July 2004:
*PAM04* Actually allocate only half the memory, minus some spare overhead.
*PAM04* This is a temporary measure. I will systematically change the
*PAM04* present static allocation in order to use GETMEM instead.
*PAM04* Changed statement:
*PAM04*     MaxMem=MaxMem-3*1000
*PAM04      MaxMem=(MaxMem-3*1000)/2
*PAM04      Call GetMem('WrkSpc','Allo','Real',MemOff,MaxMem)
*PAM04      write(6,*)' Allocated ''WrkSpc''. memoff, maxmem=',memoff,maxmem

*PAM04 Now try completely without ''WrkSpc'' array:
      Call GetMem('HowMuch','Max ','Real',LDummy,MemTot)
*
*     Open files
*
      LUVEC=18
*
      LUSYMB=10
      CALL DANAME(LUSYMB,'CIGUGA')
      LUTRA=50
      CALL DANAME_MF(LUTRA,'TRAINT')
      LUONE=17
      CALL DANAME(LUONE,'TRAONE')
      LUREST=28
      CALL DANAME(LUREST,'MRCIVECT')
C Temporaries:
      Lu_60=60
      CALL DANAME_MF(Lu_60 ,'TIABIJ')
      Lu_70=70
      CALL DANAME_MF(Lu_70 ,'TIABCI')
      Lu_80=80
      CALL DANAME_MF(Lu_80 ,'TIABCD')
      LUEIG=23
      CALL DANAME(LUEIG,'FT23F001')
      Lu_25=25
      CALL DANAME(Lu_25 ,'FT25F001')
      Lu_27=27
      CALL DANAME(Lu_27 ,'FT27F001')
*
*     main body
*
*PAM04      iMemOff=ip_of_iWork(Work(MemOff))
*PAM04      CALL SDCI(Work(MemOff),iWork(iMemOff))
      CALL SDCI_MRCI()
*
*     Epilogue, end
*
*                                                                      *
************************************************************************
*                                                                      *
*     Close open dafiles.
*
      CALL DACLOS(LUSYMB)
      CALL DACLOS(LUTRA )
      CALL DACLOS(LUONE )
      CALL DACLOS(LUREST)
      CALL DACLOS(Lu_60 )
      CALL DACLOS(Lu_70 )
      CALL DACLOS(Lu_80 )
      CALL DACLOS(LUEIG )
      CALL DACLOS(Lu_25 )
      CALL DACLOS(Lu_27 )
*                                                                      *
************************************************************************
*                                                                      *
      Call FastIO('STATUS')
      IRETURN=0
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  quatersolve
!
!> @brief
!>   Computes the quaternion which corresponds to the best rotation that transforms \p U1 in \p U2 and \p V1 in \p V2
!> @author Y. Carissan
!>
!> @details
!> Input vectors will be normalized and \p V2 changed.
!> Computes the quaternion which corresponds to the
!> rotation that transforms \p U1 in \p U2 and \p V1 in \p V2.
!> If such a rotation does not exists, i.e. if
!> \f[ U_1 \cdot V_1 \ne U_2 \cdot V_2 \f]
!> the quaternion contains the rotation
!> which transforms \p U1 into \p U2 and \p V1 into \p V2' such that
!> \f[ U_1 \cdot V_1 = U_2 \cdot V_2' \f]
!> and
!> \f[ U_1 \times V_1 = b (U_2 \times V_2') \f] with \f$ b \f$ real.
!>
!> @param[in,out] U1 vector \f$ U_1 \f$
!> @param[in,out] U2 vector \f$ U_2 \f$
!> @param[in,out] V1 vector \f$ V_1 \f$
!> @param[in,out] V2 vector \f$ V_2 \f$
!> @param[out]    Q  quaternion \f$ Q \f$
!***********************************************************************

subroutine quatersolve(U1,U2,V1,V2,Q)

use Quater_globals, only: debug
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, r8

implicit none
real(kind=wp), intent(inout) :: U1(3), U2(3), V1(3), V2(3)
real(kind=wp), intent(out) :: Q(0:3)
real(kind=wp) :: U3(3), V3(3), Uref(3), Vref(3), K(3), Vtmp(3), c
logical(kind=iwp) :: skip
real(kind=wp), parameter :: thrs = 1.0e-3_wp
real(kind=r8), external :: ddot_

if (debug) then
  call RecPrt('IN SOLVE U1',' ',U1,3,1)
  call RecPrt('IN SOLVE V1',' ',V1,3,1)
  call RecPrt('IN SOLVE U2',' ',U2,3,1)
  call RecPrt('IN SOLVE V2',' ',V2,3,1)
end if
call quatersetup(U1,U2,V1,V2)
if (debug) call RecPrt('new V2',' ',V2,3,1)

Uref(:) = U1(:)
Vref(:) = V1(:)

call GetKandC(U1,U2,V1,V2,K,C)

skip = .false.
if (C < thrs) then
  call cross(U1,U2,U3)
  call cross(V1,V2,V3)
  call getKandC(U1,V1,U3,V3,K,C)
  if (C < thrs) then
    call getKandC(U2,V2,U3,V3,K,C)
    if (C < thrs) then
      skip = .true.
    else
      Uref(:) = U2(:)
      Vref(:) = V2(:)
    end if
  end if
end if

if (skip) then
  Q(:) = [One,Zero,Zero,Zero]
else
  Q(1:3) = Half*K(:)/sqrt(C)

  call Cross(Uref,Q(1:3),Vtmp) ! Vtmp = Uref x Q

  Q(0) = Half*ddot_(3,Vref,1,Vtmp,1)/ddot_(3,Vtmp,1,Vtmp,1) ! Q(0)=0.5 * Vref.(UrefxQ)/(UrefxQ)^2
end if

call CheckQuater(Q)
call setMatrix(Q)
if (debug) call RecPrt('Quaternion',' ',Q,4,1)

return

end subroutine quatersolve

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_Distrib_Vec(Jin,Jfi,iDV,nV)
C
C     Unless you know exactly what you are doing,
C     do NOT call this routine directly; use Cho_P_Distrib_Vec instead!
C
      Use Para_Info, Only: MyRank, nProcs
      Implicit None
      Integer  Jin, Jfi, nV
      Integer  iDV(*)

      Integer i, iNode

      nV=0
      Do i=Jin,Jfi
         iNode=MOD(i-1,nProcs)
         If (myRank .eq. iNode) Then
            nV = nV + 1
            iDV(nV) = i
         End If
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               1996, Hans-Joachim Werner                              *
************************************************************************
      SubRoutine Assg1(Temp,PAO,nT,nRys,la,lb,lc,ld,xyz2D0,xyz2D1,
     &                 IfGrad,Index,mVec)
************************************************************************
*                                                                      *
* Object: to assemble the gradients of the ERI's.                      *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91; modified by H.-J. Werner, Mai 1996          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "itmax.fh"
#include "iavec.fh"
      Real*8 PAO(nT,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,
     &              (lc+1)*(lc+2)/2,(ld+1)*(ld+2)/2),
     &       xyz2D0(nRys,nT,0:la+1,0:lb+1,0:lc+1,0:ld+1,3),
     &       xyz2D1(nRys,nT,0:la  ,0:lb  ,0:lc  ,0:ld  ,9),
     &      Temp(9)
      Logical IfGrad(3,4)
      Integer Ind1(3,3), Ind2(3,3), Index(3,4), nVec(3)
*
*     Statement functions
*
      nElem(i) = (i+1)*(i+2)/2
*
      iRout = 248
      iPrint = nPrint(iRout)
*
      call dcopy_(9,[Zero],0,Temp,1)
*
      ii = la*(la+1)*(la+2)/6
      jj = lb*(lb+1)*(lb+2)/6
      kk = lc*(lc+1)*(lc+2)/6
      ll = ld*(ld+1)*(ld+2)/6
*
      mVec = 0
      Do i = 1, 3             ! Cartesian directions
         nVec(i) = 0
         Do iCent = 1, 4      ! Centers of integral
            If (IfGrad(i,iCent)) Then
               mVec = mVec + 1
               nVec(i) = nVec(i) + 1
               Ind1(nVec(i),i) = 3*(Index(i,iCent)-1) + i
               Ind2(nVec(i),i) = mVec
            End If
         End Do
      End Do
*
      Do 100 ipd = 1, nElem(ld)
         ixd = ixyz(1,ll+ipd)
         iyd = ixyz(2,ll+ipd)
         izd = ixyz(3,ll+ipd)
*
      Do 200 ipc = 1, nElem(lc)
         ixc = ixyz(1,kk+ipc)
         iyc = ixyz(2,kk+ipc)
         izc = ixyz(3,kk+ipc)
*
         ixcd = ixc + ixd
         iycd = iyc + iyd
         izcd = izc + izd
*
      Do 300 ipb = 1, nElem(lb)
         ixb = ixyz(1,jj+ipb)
         iyb = ixyz(2,jj+ipb)
         izb = ixyz(3,jj+ipb)
*
         ixbcd = ixcd + ixb
         iybcd = iycd + iyb
         izbcd = izcd + izb
*
      Do 400 ipa = 1, nElem(la)
         ixa = ixyz(1,ii+ipa)
         iya = ixyz(2,ii+ipa)
         iza = ixyz(3,ii+ipa)
*
         ixabcd = ixbcd + ixa
         iyabcd = iybcd + iya
         izabcd = izbcd + iza
*
*
*        Compute all desired gradients with respect to an x-component.
*
         If (iyabcd.ne.0) Then
*
         If (nVec(1).eq.3) Then
           call ass3(xyz2D0(1,1,iya,iyb,iyc,iyd,2),
     &               xyz2D0(1,1,iza,izb,izc,izd,3),
     &               xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)),
     &               xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(2,1)),
     &               xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(3,1)),
     &               PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,1)),
     &               Temp(Ind2(2,1)),Temp(Ind2(3,1)),nT,nRys)
         Else If (nVec(1).eq.2) Then
           call ass2(xyz2D0(1,1,iya,iyb,iyc,iyd,2),
     &               xyz2D0(1,1,iza,izb,izc,izd,3),
     &               xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)),
     &               xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(2,1)),
     &               PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,1)),
     &               Temp(Ind2(2,1)),nT,nRys)
         Else If (nVec(1).eq.1) Then
           call ass1(xyz2D0(1,1,iya,iyb,iyc,iyd,2),
     &               xyz2D0(1,1,iza,izb,izc,izd,3),
     &               xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)),
     &               PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,1)),
     &               nT,nRys)
         End If
*
         Else
*
         If (nVec(1).eq.3) Then
           call ass3a(xyz2D0(1,1,iza,izb,izc,izd,3),
     &                xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)),
     &                xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(2,1)),
     &                xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(3,1)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,1)),
     &                Temp(Ind2(2,1)),Temp(Ind2(3,1)),nT,nRys)
         Else If (nVec(1).eq.2) Then
           call ass2a(xyz2D0(1,1,iza,izb,izc,izd,3),
     &                xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)),
     &                xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(2,1)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,1)),
     &                Temp(Ind2(2,1)),nT,nRys)
         Else If (nVec(1).eq.1) Then
           call ass1a(xyz2D0(1,1,iza,izb,izc,izd,3),
     &                xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,1)),
     &                nT,nRys)
         End If
*
         End If
*
*        Compute all desired gradients with respect to an y-component.
*
         If (ixabcd.ne.0) Then
*
         If (nVec(2).eq.3) Then
            call ass3(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),
     &                xyz2D0(1,1,iza,izb,izc,izd,3),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(2,2)),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(3,2)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,2)),
     &                Temp(Ind2(2,2)),Temp(Ind2(3,2)),nT,nRys)
         Else If (nVec(2).eq.2) Then
            call ass2(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),
     &                xyz2D0(1,1,iza,izb,izc,izd,3),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(2,2)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,2)),
     &                Temp(Ind2(2,2)),nT,nRys)
         Else If (nVec(2).eq.1) Then
            call ass1(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),
     &                xyz2D0(1,1,iza,izb,izc,izd,3),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,2)),
     &                nT,nRys)
         End If
*
         Else
*
         If (nVec(2).eq.3) Then
           call ass3a(xyz2D0(1,1,iza,izb,izc,izd,3),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(2,2)),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(3,2)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,2)),
     &                Temp(Ind2(2,2)),Temp(Ind2(3,2)),nT,nRys)
         Else If (nVec(2).eq.2) Then
           call ass2a(xyz2D0(1,1,iza,izb,izc,izd,3),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(2,2)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,2)),
     &                Temp(Ind2(2,2)),nT,nRys)
         Else If (nVec(2).eq.1) Then
           call ass1a(xyz2D0(1,1,iza,izb,izc,izd,3),
     &                xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,2)),
     &                nT,nRys)
         End If
*
         End If
*
*        Compute all desired gradients with respect to an z-component.
*
         If (ixabcd*iyabcd.ne.0) Then
*
         If (nVec(3).eq.3) Then
            call ass3(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),
     &                xyz2D0(1,1,iya,iyb,iyc,iyd,2),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(3,3)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                Temp(Ind2(2,3)),Temp(Ind2(3,3)),nT,nRys)
         Else If (nVec(3).eq.2) Then
            call ass2(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),
     &                xyz2D0(1,1,iya,iyb,iyc,iyd,2),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                Temp(Ind2(2,3)),nT,nRys)
         Else If (nVec(3).eq.1) Then
            call ass1(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),
     &                xyz2D0(1,1,iya,iyb,iyc,iyd,2),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                nT,nRys)
         End If
*
         Else If (ixabcd.eq.0.and.iyabcd.ne.0) Then
*
         If (nVec(3).eq.3) Then
           call ass3a(xyz2D0(1,1,iya,iyb,iyc,iyd,2),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(3,3)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                Temp(Ind2(2,3)),Temp(Ind2(3,3)),nT,nRys)
         Else If (nVec(3).eq.2) Then
           call ass2a(xyz2D0(1,1,iya,iyb,iyc,iyd,2),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                Temp(Ind2(2,3)),nT,nRys)
         Else If (nVec(3).eq.1) Then
           call ass1a(xyz2D0(1,1,iya,iyb,iyc,iyd,2),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                nT,nRys)
         End If
*
         Else If (iyabcd.eq.0.and.ixabcd.ne.0) Then
*
         If (nVec(3).eq.3) Then
           call ass3a(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(3,3)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                Temp(Ind2(2,3)),Temp(Ind2(3,3)),nT,nRys)
         Else If (nVec(3).eq.2) Then
           call ass2a(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                Temp(Ind2(2,3)),nT,nRys)
         Else If (nVec(3).eq.1) Then
           call ass1a(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),
     &                xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                nT,nRys)
         End If
*
         Else
*
         If (nVec(3).eq.3) Then
            call ass3b(xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                 xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),
     &                 xyz2D1(1,1,iza,izb,izc,izd,Ind1(3,3)),
     &                 PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                 Temp(Ind2(2,3)),Temp(Ind2(3,3)),nT,nRys)
         Else If (nVec(3).eq.2) Then
            call ass2b(xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                 xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),
     &                 PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                 Temp(Ind2(2,3)),nT,nRys)
         Else If (nVec(3).eq.1) Then
            call ass1b(xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),
     &                 PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),
     &                 nT,nRys)
         End If
*
         End If
*
 400  Continue
*
 300  Continue
*
 200  Continue
*
 100  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_CASPT2_OpenF(iOpt,iTyp,iSym,nBatch)
! Purpose: open (iOpt=1), close and keep (iOpt=2), or close and
!          delete (iOpt=3) Cholesky vector files for CASPT2 program
!          (full vectors).
!          For iOpt=0, the units are initialized (to -1).
!          iTyp=1: transformed Cholesky vectors (Inactive).
!          iTyp=2: transformed Cholesky vectors (Active).
!          iTyp=3: vectors from (pi|qj) decomposition (Not
!                  implemented yet!)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iOpt, iTyp, iSym, nBatch
#include "WrkSpc.fh"
#include "chocaspt2.fh"
integer(kind=iwp) :: iaddr, iB, LuV, nSym, NCALLS = 0, NUMCHO(8)
character(len=3) :: BaseNm
character(len=7) :: FullNm
character(len=*), parameter :: SecNam = 'Cho_CASPT2_OpenF'

!******************************************************************
if (nBatch > 999) then
  call Cho_x_Quit(SecNam,' nBatch limited to 999 !!!',' ')
end if
call Get_iScalar('nSym',nSym)
call Get_iArray('NumCho',NumCho,nSym)

if (NCALLS == 0) then
  do iB=1,nBatch
    iaddr = ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1
    iWork(iaddr) = -1
  end do
end if

! Initialize units and return for iOpt=0.
! ---------------------------------------

if (iOpt == 0) then
  do iB=1,nBatch
    iaddr = ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1
    iWork(iaddr) = -1
  end do
  return
end if

! Open or close files.
! --------------------
if ((iTyp < 1) .or. (iTyp > 2)) then
  call Cho_x_Quit(SecNam,'iTyp error',' ')
end if

if (iOpt == 1) then
  if (NumCho(iSym) > 0) then
    do iB=1,nBatch
      iaddr = ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1
      if (iWork(iaddr) < 1) then
        call Cho_caspt2_GetBaseNm(BaseNm,iTyp)
        write(FullNm,'(A3,I1,I3)') BaseNm,iSym,iB
        LuV = 7 ! initial guess
        call daName_MF_WA(LuV,FullNm) ! handle inquire/free unit
        iWork(iaddr) = LuV
        write(u6,*) ' Opened file "',FullNm,'" as unit nr LuV=',LuV
        write(u6,*) ' Unit number LuV is stored at address ',iaddr
      end if
    end do
  else
    do iB=1,nBatch
      iaddr = ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1
      iWork(iaddr) = -1
    end do
  end if
else if (iOpt == 2) then
  do iB=1,nBatch
    iaddr = ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1
    if (iWork(iaddr) > 0) then
      write(u6,*) ' Closing lUnit_F=',iWork(iaddr)
      call daClos(iWork(iaddr))
      iWork(iaddr) = -1
    end if
  end do
else if (iOpt == 3) then
  do iB=1,nBatch
    iaddr = ipUnit_F(iSym)+(iTyp-1)*nIsplit(iSym)+iB-1
    if (iWork(iaddr) > 0) then
      write(u6,*) ' Erasing lUnit_F=',iWork(iaddr)
      call daEras(iWork(iaddr))
      iWork(iaddr) = -1
    end if
  end do
else
  call Cho_x_Quit(SecNam,'iOpt out of bounds',' ')
end if

end subroutine Cho_CASPT2_OpenF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
        subroutine o3v3t2 (wrk,wrksize,NvGrp,maxdim,LunAux)
c
c       This routine do:
c
c       --- Part III, generation of X, Y intermediates
c
c        T2(be,ga,u,v) <-
c        T21  +             [ (be,u|ga,v)                 ]
c        T22  + sum(i,j)    [ Ta(be,ga,ij) . A(i,j,u,v)   ]
c          T21 implemented as X0:
c          T22 implemented as X4:
c
c       X(be,u,ga,v) <<-
c          X0 (T21)     1/2 (be,u|ga,v)
c         X1         + Q(be,u,i,a) . E(ga,a,i,v)
c          X2 (T24)   + Gvv(a,be)   . t2(ga,a,v,u)
c          X3 (T25)   - Goo(i,u)    . t2(ga,be,v,i)
c          X4 (T22)   + sum(i>=j)   [ Ta(be,ga,ij) . A(ij,u,v)  ]
c                    - 1/2 sum(i)  [ Ta(be,ga,ii) . A(ii,u,v)  ]
c          Xe (T2ex)  - sum(i,j)    [ Aex(i,j,u,v) . T1(be,i) .T1(ga,j) ]
c                       Xe - o4v2 term is factorized to o4v + o3v2 terms
c
c       Y(be,u,ga,v) = K(be,u,i,a) . t2(i,a,ga,v)
c
c       where E(ga,a,i,v) = 2 t2(ga,a,v,i) - t2(ga,a,i,v)
c
c       T1(be,u) << -
c       T11  +            [  F(be,u)                   ]
c       T12  - sum(a,i)   [ 2F(a,i) . t(be,i) . t(a,u) ]
c       T13  + sum(a)     [  Hvv(a,be) . t(a,u)        ]
c       T14  - sum(i)     [  Hoo(i,u)  . t(be,i)       ]
c       T15  + sum(a,i)   [  Hoo(a,i)  .
c           (2t2(be,a,u,i) - t2(be,a,i,u) + t(a,u).t(be,i)) ]
c
c       Extra cost - multiple reading:
c                    1) N_be . T;
c                    2) N_ga . Q
c                    3) N_ga . K
c
c
c1      intermediates Q and K will be temporarry stored in files
c       QFil, KFil as follows
c       do beGrp
c       do aGrp
c         Q(K) (be',u,i,a')
c       end do
c       end do
c
c2      Structure of files, where selected group of (pq|rs) are
c       stored (V'O|OO) - I1 ; (V'O|V'O) - I2 ; (V'V'|OO) - I3
c
c       (A'I|JK)  I1inxx xx - Group of A'
c
c       (A'I|B'J) I2xxyy xx - Group of A'
c                        yy - Group of B'
c
c       (A'B'|IJ) I3xxyy xx - Group of A'
c                        yy - Group of B'
c
c
c3      Structure of Cholesky vector files
c
c       L1(m,I ,A')  L1vcxx xx - Group of A'
c
c       L2(m,A',B')  L2xxyy xx - Group of A'
c                           yy - Group of B'
c
c4      Structure of Amplitude file
c       t2(A',B',IJ)  T2xxyy xx - Group of A'
c                            yy - Group of B'
c
c
        implicit none
#include "chcc1.fh"
#include "chcc_parcc.fh"
#include "para_info.fh"
#include "o3v3.fh"
#include "chcc_files.fh"
#include "wrk.fh"
#include "chcc_casy.fh"
c
        integer NvGrp,LunAux

c       help variables
        integer dim1,dim2,dima,dimbe,dimga
        integer aGrp,beGrp,gaGrp,adda,addbe,addga
        integer PossV1,PossV2,PossV3,PossV4
        integer PossH1,PossH2,PossH3,PossH4
        integer PossK,PossQ,PossX,PossY
c
        integer PossT,maxdim

c
        character*6 LunName
c
c       --- introduction part ---
c
cx      Distribute memory
c       @@ yet distribution is the same for all three o3v3 drivers,
c       v buducnosti nosnost usposobit vsetky 3 vlastne
c
        PossT=PossFree
        call DistMemo3v3t2 (NvGrp,maxdim,
     c       PossV1,PossV2,PossV3,PossV4,
     c       PossH1,PossH2,PossH3,PossH4,
     c       PossK,PossQ,
     c       PossT)
c
        if (printkey.ge.10) then
        write (6,*) ' Last Value :',PossT,wrksize
        end if
        if (PossT.gt.wrksize) then
cmp!           write (6,*) ' Nieje dobre, Dr. Ch.  Kokotopuloss',
        write (6,*) ' Not Enough memory in o3v3t2 step!',
     & 'Increase large and/or small segmentation ',
     c                  (1.0d0*PossT)/(1.0d0*wrksize)
           call abend()
        end if
c
c
c##G     Vanish XYyes
c
        do dim1=1,NvGrp
        do dim2=1,NvGrp
          XYyes(dim1,dim2)=0
          if (printkey.ge.10) then
          write (6,*) 'Xyes',dim1,dim2,Xyes(dim1,dim2)
          end if
        end do
        end do
c
c
c
        PossX=PossQ
        PossY=PossK
c
        addbe=0
        do beGrp=1,NvGrp
        dimbe=DimGrpv(beGrp)
c
c##     test, if this beGrp is planed to be run on this node
        dim1=0
        do dim2=1,NvGrp
          dim1=dim1+BeAID(myRank,beGrp,dim2)
        end do
        dim1=dim1+BetaID(myRank,beGrp)
        if (dim1.eq.0) goto 11
        if (printkey.gt.1) then ! nie som si isty ....
        write (6,*) ' o3v3 T2 - ID, beGrp',myRank,beGrp
        end if
cmp
        Call CWTime(TCpu,TWall)
        if (printkey.gt.1) then
        write (6,*)
        write (6,'(A,f18.1)') ' Cpu last call [s] = ',
     & TCpu-TCpu_l
        write (6,'(A,f18.1)') 'Wall last call [s] = ',
     & TWall-TWall_l
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if
        TCpu_l=TCpu
        TWall_l=TWall
cmp
c
cT1G          vanish H4(be',u)
          dim1=dimbe*no
          call mv0zero (dim1,dim1,wrk(PossH4))
c
cG             Extract H1(be',I) <- T1(be,I)
          call ExtT1 (wrk(PossH1),wrk(PossT1o),dimbe,addbe)
c
          addga=0
          do gaGrp=1,NvGrp
          dimga=DimGrpv(gaGrp)
c
c           initialize X(be',u,ga',v) as X0, calc in step II
c           vanish Y(be',u,ga',v)
            LunName=Tmp2Name(beGrp,gaGrp)
            dim1=no*no*DimGrpv(beGrp)*DimGrpv(gaGrp)
            if (Xyes(beGrp,gaGrp).eq.1) then
              call GetX (wrk(PossX),dim1,LunAux,LunName,1,1)
              Xyes(beGrp,gaGrp)=2
            else
              call mv0zero (dim1,dim1,wrk(PossX))
            end if
            call mv0zero (dim1,dim1,wrk(PossY))
c
cG               Extract H2(ga',I) <- T1(ga,I)
            call ExtT1 (wrk(PossH2),wrk(PossT1o),dimga,addga)
c
c
            adda=0
            do aGrp=1,NvGrp
            dima=DimGrpv(aGrp)
c
c           Test, if this Be' A' combination is to be run on this node
            if (BeAID(myRank,beGrp,aGrp).eq.0) goto 12
            if (printkey.ge.10) then
            write (6,*) ' o3v3 T2 - ID,be,a,ga',myRank,beGrp,aGrp,gaGrp
            end if
c
c
cXY1.1.1      read V1(ga',a',p,q) <- t2(ga',a',p,q)
              LunName=T2Name(gaGrp,aGrp)
              if (aGrp.eq.gaGrp) then
                dim1=dimga*(dimga+1)*no*no/2
                call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
cXY1.1.2        Expand V1(be',b',p,q) <- V2(be'b',p,q)
                dim1=dima*(dima+1)/2
                call ExpT2 (wrk(possV2),wrk(PossV1),dimga,dim1,no)
              else
                dim1=dimga*dima*no*no
                call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
              end if
c
              if (gaGrp.eq.beGrp) then
c@x              tento if nebol prevereny dostatocne
c              term T15 only for ga'=be'
c              use     : V1(be',a',I,J) = T2(be',a',I,J)
c                        H1(be',I) = T1(be,I) also H2
c              destroy : V2,V3 (also V4 is free)
c
cT15.1                Extract V2(a',I) <- T1(a,i)
                call ExtT1 (wrk(PossV2),wrk(PossT1o),dima,adda)
c
cT15.2                Make V3(be',u,a',i) <- 2t2(be,a,u,i)-t2(be,a,i,u)+t(a,u).t(be,i)
                call MkT_T15 (wrk(PossV3),wrk(PossV1),wrk(PossH1),
     c                        wrk(possV2),dimbe,dima,no)
c
cT15.3                Extract V2(a',i) <- Hvo(a',i) rutina identicka s ExtT1
                  call ExtT1 (wrk(PossV2),wrk(PossHvo),dima,adda)
c
cT15.4f         Calc H4(be',u) <<- V3(be',u,a',i) . V2(a',i)
                call mv0v1a3u (dimbe*no,dima*no,dima*no,dimbe*no,
     c                         dimbe*no,dima*no,1,1,
     c                         wrk(PossV3),wrk(PossV2),wrk(PossH4))
c
              end if
c
cX2.1              Map V3(a',u,ga',v) <- V1(ga',a',v,u)
               call Map4_3142 (wrk(PossV1),wrk(PossV3),dimga,dima,no,no)
c
cX2.2              Extract H3(a',be') <- Gvv(be,a)
              call ExH_X2 (wrk(PossGvv),wrk(PossH3),
     c                     dima,dimbe,nv,adda,addbe)
c
cX2.3              Calc V4(be',u,ga',v) <- H3(T)(a',be') . V3(a',u,ga',v)
              dim1=dimbe*dimga*no*no
                 call mv0zero (dim1,dim1,wrk(PossV4))
              dim1=dimga*no*no
              call mc0c1at3b (dima,dimbe,dima,dim1,dimbe,dim1,
     c                        dimbe,dima,dim1,
     c                        wrk(PossH3),wrk(PossV3),wrk(PossV4))
c
cX2.4f              Add X(be',u,ga',v) <<- +V4(be',u,ga',v)
cc            pozor na faktor, cele X je s vahou 0.5, sem teda asi 2
              dim1=dimbe*dimga*no*no
                 call mv0v1u (dim1,wrk(PossV4),1,wrk(PossX),1,2.0d0)
c
               if (aGrp.eq.beGrp) then
c                now a=be, i.e in V1 there is t2(ga',be',I,J)
c
cX3.1                Calc V2(ga',be',v,u) <- V1(ga',be',v,i) . Goo(i,u)
                dim1=dimga*dimbe*no*no
                call mv0zero (dim1,dim1,wrk(PossV2))
                dim1=dimga*dimbe*no
                call mc0c1a3b (dim1,no,no,no,dim1,no,
     c                         dim1,no,no,
     c                         wrk(PossV1),wrk(PossGoo),wrk(PossV2))
c
cX3.2                map V3((be',u,ga',v) <- V2(ga',be',v,u)
                call Map4_3142 (wrk(possV2),wrk(PossV3),
     c                          dimga,dimbe,no,no)
c
cX3.3f                Add X(be',u,ga',v) <<- -V3(be',u,ga',v)
cc              pozor na faktor, cele X je s vahou 0.5, sem teda asi -2
                dim1=dimbe*dimga*no*no
                call mv0v1u (dim1,wrk(PossV3),1,wrk(PossX),1,-2.0d0)
c
c
cX4.1                Map V2(be',ga',J,I) <- V1(ga',be',I,J)
                 Call Map4_2143 (wrk(PossV1),wrk(PossV2),
     c                          dimga,dimbe,no,no)
c
cX4.2                Make Tau in V2(be',ga',I,J)
                call MkTau_chcc (wrk(PossV2),wrk(PossH1),wrk(PossH2),
     c                           dimbe,dimga,no,1.0d0,1.0d0)
c
cX4.3                Extract V3(be',ga',ij) <- V2(be',ga',I,J)
                call ExV_X41 (wrk(PossV3),wrk(PossV2),dimbe*dimga,no)
c
cX4.5                V4(be',ga',u,v) <- V3(be',ga',ij) . A(ij,u,v)
                dim1=dimga*dimbe*no*no
                call mv0zero (dim1,dim1,wrk(PossV4))
                dim1=dimbe*dimga
                dim2=no*(no+1)/2
                 call mc0c1a3b (dim1,dim2,dim2,no*no,dim1,no*no,
     c                         dim1,dim2,no*no,
     c                       wrk(PossV3),wrk(PossA),wrk(PossV4))
c
cX4.6                Map V3(ij,V,U) <- A(ij,U,V)
                dim1=no*(no+1)/2
                call Map3_132 (wrk(PossA),wrk(PossV3),dim1,no,no)
c
cX4.7                Set A(ij,V,U) <- V3(ij,V,U)
                dim1=no*no*no*(no+1)/2
                call mv0u (dim1,wrk(PossV3),1,wrk(PossA),1)
c
cX4.8           Make V3(be',ga',ij) <- V2(be',ga',J,I) for i>=j
                call ExV_X43 (wrk(PossV3),wrk(PossV2),dimbe*dimga,no)
c
cX4.9                V4(be',ga',u,v) << - V3(be',ga',ij) . A(ij,u,v)
                dim1=dimbe*dimga
                dim2=no*(no+1)/2
                 call mc0c1a3b (dim1,dim2,dim2,no*no,dim1,no*no,
     c                         dim1,dim2,no*no,
     c                       wrk(PossV3),wrk(PossA),wrk(PossV4))
c
cX4.10          Map V3(ij,U,V) <- A(ij,V,U)
                dim1=no*(no+1)/2
                call Map3_132 (wrk(PossA),wrk(PossV3),dim1,no,no)
c
cX4.11          Set A(ij,U,V) <- V3(ij,U,V)
                dim1=no*no*no*(no+1)/2
                call mv0u (dim1,wrk(PossV3),1,wrk(PossA),1)
c
cX4.12          Extract H3(i,u,v) <- A(ii,u,v)
                call ExA_X4 (wrk(PossA),wrk(PossH3),no)
c
c
cX4.13          Extract V3(be',ga',i) <- V2(be',ga',I,J)
                call ExV_X42 (wrk(PossV3),wrk(PossV2),dimbe*dimga,no)
c
cX4.14          V4(be',ga',u,v) <<- - V3(be',ga',i) . H3(i,u,v)
                dim1=dimbe*dimga
                 call mc0c2a3b (dim1,no,no,no*no,dim1,no*no,
     c                         dim1,no,no*no,
     c                         wrk(PossV3),wrk(PossH3),wrk(PossV4))
c
cX4.15          Map V3(be',u,ga',v) <- V4(be',ga',u,v)
                 call Map4_1324 (wrk(PossV4),wrk(PossV3),
     c                          dimbe,dimga,no,no)
c
cX4.16f         Add X(be',u,ga',v) <<- V3(be',u,ga',v)
cc              pozor na faktor, cele X je s vahou 0.5, sem teda asi 1
                dim1=dimbe*dimga*no*no
                   call mv0v1u (dim1,wrk(PossV3),1,wrk(PossX),1,1.0d0)
c
cXe                Term Xe (V2,V3 and V4 can be used)
c                only in cholesky based approach
c
                if (intkey.eq.0) then
cXe.1                Ext V2(i,u,v,j) <- Aex(ij,uv)
                Call Ext_Aex (wrk(PossAex),wrk(PossV2),no)
c
cXe.2           V3(be',u,v,j) <- H1(=T1)(be',i) . V2(i,u,v,j)
                dim1=dimbe*no*no*no
                call mv0zero (dim1,dim1,wrk(PossV3))
                dim1=no*no*no
                call mc0c1a3b (dimbe,no,no,dim1,dimbe,dim1,
     c                         dimbe,no,dim1,
     c                         wrk(PossH1),wrk(PossV2),wrk(PossV3))
c
cXe.3                Map V4(j,ga') <- H2(ga',j)
                call Map2_21 (wrk(PossH2),wrk(PossV4),dimga,no)
c
cXe.4           V2(be',u,v,ga') <- V3(be',u,v,j) . V4(j,ga')
                dim1=dimbe*dimga*no*no
                call mv0zero (dim1,dim1,wrk(PossV2))
                dim1=dimbe*no*no
                call mc0c1a3b (dim1,no,no,dimga,dim1,dimga,
     c                         dim1,no,dimga,
     c                         wrk(PossV3),wrk(PossV4),wrk(PossV2))
c
cXe.5           Map V3(be',u,ga',v) <- V2(be,u,v,ga')
                call Map3_132(wrk(PossV2),wrk(PossV3),dimbe*no,no,dimga)
c
cXe.6f          Add X(be',u,ga',v) <<- - V3(be',u,ga',v)
cc              pozor na faktor, cele X je s vahou 0.5, sem teda asi -1
                dim1=dimbe*dimga*no*no
                   call mv0v1u (dim1,wrk(PossV3),1,wrk(PossX),1,-1.0d0)
                end if
c
               end if
c
c
cX1.2         map V2(a',i,ga',v) <- V1(ga',a',i,v)
              call Map4_3124 (wrk(PossV1),wrk(PossV2),dimga,dima,no,no)
c
cX1.3         read V1(be',u,i,a') <- Q(be',u,i,a')
              LunName=Tmp1Name(beGrp,aGrp)
              dim1=dimbe*dima*no*no
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,0)
cX1.4              Map V3(be',u,a',i) <- V1(be',u,i,a')
              dim1=dimbe*no
              call Map3_132 (wrk(PossV1),wrk(PossV3),dim1,no,dima)
c
cY1.2         read V1(be',u,i,a') <- K(be',u,i,a')
              dim1=dimbe*dima*no*no
              call GetX (wrk(PossV1),dim1,LunAux,LunName,0,1)
cY1.3              Map V4(be',u,a',i) <- V1(be',u,i,a')
              dim1=dimbe*no
              call Map3_132 (wrk(PossV1),wrk(PossV4),dim1,no,dima)
c
cY1.4f        Y(be',u,ga',v) <<- V4(be',u,a',i) . V2(a',i,ga',v)
              call mc0c1a3b (dimbe*no,dima*no,dima*no,dimga*no,
     c                       dimbe*no,dimga*no,
     c                       dimbe*no,dima*no,dimga*no,
     c                       wrk(PossV4),wrk(PossV2),wrk(PossY))
c
cX1.5         Make E: V1(a',i,ga',v) = 2 V2(a',v,ga',i) - V2(a',i,ga',v)
              call MkE_Y3 (wrk(PossV1),wrk(PossV2),dima,dimga,no)
c
cX1.6f        X(be',u,ga',v) <<- V3(be',u,a',i) . V1(a',i,ga',v)
              call mc0c1a3b (dimbe*no,dima*no,dima*no,dimga*no,
     c                       dimbe*no,dimga*no,
     c                       dimbe*no,dima*no,dimga*no,
     c                       wrk(PossV3),wrk(PossV1),wrk(PossX))
c
12             adda=adda+dima
            end do
c
cX0.1          read V1(be',u,ga',j) <- (be',u|ga',v)
c##          this contribution need to be taken only once for given be'ga'
c         thus will be executed on that node, where be',a'=1 is
c          calculated
          if (BeAID(myRank,beGrp,1).eq.1) then
            LunName=I2Name(beGrp,gaGrp)
            dim1=dimbe*dimga*no*no
            call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
          else
            dim1=dimbe*dimga*no*no
            call mv0zero (dim1,dim1,wrk(PossV1))
          end if
c
cX0.2f          Add X(be',u,ga',v) <<- 1/2 V1(be',u,ga',v)
cc            pozor na faktor, cele X je s vahou 0.5, sem teda asi 1
          dim1=dimbe*dimga*no*no
          call mv0v1u (dim1,wrk(PossV1),1,wrk(PossX),1,1.0d0)
c
c         save X,Y
          LunName=Tmp2Name(beGrp,gaGrp)
          dim1=dimbe*dimga*no*no
          XYyes(beGrp,gaGrp)=1
          call SaveX (wrk(PossX),dim1,LunAux,LunName,1,0)
          call SaveX (wrk(PossY),dim1,LunAux,LunName,0,1)
c
c@@
c        call Chck_Y (wrk(PossY),dimbe,addbe,dimga,addga)
c        call Chck_X (wrk(PossX),dimbe,addbe,dimga,addga)
c@@
          addga=addga+dimga
          end do
c
c
c##       These contributions must be taken only once per Beta'
          if (BetaID(myRank,beGrp).eq.1) then
c
cT12.1      calc V1(i,u) <<- Fvo(T)(a,i) . T1o(a,u)
            dim1=no*no
            call mv0zero (dim1,dim1,wrk(PossV1))
            call mc0c1at3b (nv,no,nv,no,no,no,
     c                   no,nv,no,
     c                   wrk(PossFvo),wrk(PossT1o),wrk(PossV1))
c
cT12.2      calc V2(be',u) <<- T1o(be',i) . V1(i,u)
            dim1=no*dimbe
            call mv0zero (dim1,dim1,wrk(PossV2))
            call mc0c1a3b (dimbe,no,no,no,dimbe,no,
     c                   dimbe,no,no,
     c                   wrk(PossT1o),wrk(PossV1),wrk(PossV2))
c
cT12.3f     Add H4(be',u) <<- -2.0 V2(be',u)
            call mv0v1u (dim1,wrk(PossV2),1,wrk(PossH4),1,-2.0d0)
c
c
cT13.1            Extract V1(a,be') <- Hvv(a,be)
              call ExH_T13 (wrk(PossV1),wrk(PossHvv),dimbe,addbe,nv)
c
cT13.2f     Add H4(be',u) <<- V1(T)(a,be') . T1(a,i)
            call mc0c1at3b (nv,dimbe,nv,no,dimbe,no,
     c                     dimbe,nv,no,
     c                     wrk(PossV1),wrk(PossT1o),wrk(PossH4))
c
c
cT14.1      calc V1(be',u) <- H1(be',i) . Hoo(i,u)
            dim1=no*dimbe
            call mv0zero (dim1,dim1,wrk(PossV1))
            call mc0c1a3b (dimbe,no,no,no,dimbe,no,
     c                     dimbe,no,no,
     c                     wrk(PossH1),wrk(PossHoo),wrk(PossV1))
c
cT14.2f     Add H4(be',u) <<- - V1(be',u)
            dim1=no*dimbe
            call mv0v1u (dim1,wrk(PossV1),1,wrk(PossH4),1,-1.0d0)
c
          end if
c
c
cT1G          Add T1n(be,u) <<- H4(be',u)
              call AdT_T17 (wrk(PossT1n),wrk(PossH4),
     c                  nv,dimbe,no,addbe,1.0d0)
c
c
11        addbe=addbe+dimbe
        end do
c
c
c##        correct Xyes (those, modified to 2 reset to 1)
        do dim1=1,NvGrp
        do dim2=1,NvGrp
          if (Xyes(dim1,dim2).eq.2) then
            Xyes(dim1,dim2)=1
          end if
        end do
        end do
c
c
#ifdef _MOLCAS_MPP_
c##        Synchronizacny bod:
c1        Allreduce T1n
c2        Allreduce X,Y (yet not needed)
        dim1=nv*no
        call gadgop (wrk(PossT1n),dim1,'+')
#endif
c
c
cT11.1        Add T1n(be,u) <<- Fvo(be,u)
        dim1=nv*no
           call mv0v1u (dim1,wrk(PossFvo),1,wrk(PossT1n),1,1.0d0)
c
c@@
c        call Chck_T1 (wrk(PossT1n),0)
c@@
c
c
        return
        end
c
c        ------------------------------
c
        subroutine Chck_T1 (T1,key)
c
c        check T1
c
        implicit none
#include "chcc1.fh"
        real*8 T1(1:nv,1:no)
c
c        help var
        integer be,u,i,j,a,b,bad
        integer key
        real*8 s
c
        bad=0
c
        do u=1,no
        do be=1,nv
c
          s=0.0d0
c
          do a=1,nv
          s=s+Hvvc(be,a)*T1c(a,u)
          end do
c
          do i=1,no
          s=s-Hooc(i,u)*T1c(be,i)
          end do
c
          do i=1,no
          do a=1,nv
             s=s+Hvoc(a,i)*
     c      (2.0d0*T2c(a,be,i,u)-T2c(a,be,u,i)+T1c(a,u)*T1c(be,i))
          end do
          end do
c
          do i=1,no
          do a=1,nv
           s=s+(2.0d0*Q21(a,i,be,u)-Q22(a,be,i,u))*T1c(a,i)
          end do
          end do
c
          do i=1,no
          do b=1,nv
          do a=1,nv
             s=s+(2.0d0*Q3(b,be,a,i)-Q3(a,be,b,i))*
     c          (T2c(a,b,i,u)+T1c(a,i)*T1c(b,u))
          end do
          end do
          end do
c
          do i=1,no
          do j=1,no
          do a=1,nv
             s=s-(2.0d0*Q1(a,i,u,j)-Q1(a,j,u,i))*
     c          (T2c(a,be,i,j)+T1c(a,i)*T1c(be,j))
          end do
          end do
          end do
c
c            s=s/(Oeo(u)-Oev(be))
c
          if (abs(T1(be,u)-s).gt.1.0d-10) then
            bad=bad+1
            if (key.eq.1) then
              T1(be,u)=s
            end if
          end if
c
        end do
        end do
c
         write (6,*) ' T1 test :',bad
c
        return
        end
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine PGet3(PAO,ijkl,nPAO,iCmp,
     &                 iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,kOp,
     &                 DAO,nDAO,
     &                 PAOPam,n1,n2,n3,n4,iPam,MapPam,mDim,
     &                 Cred,nCred,Scr1,nScr1,Scr2,nScr2,PMax)
************************************************************************
*                                                                      *
*  Object: to assemble the index list of the batch of the 2nd order    *
*          density matrix.                                             *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*             Modified from PGet1, June '92                            *
************************************************************************
      use SOAO_Info, only: iAOtSO, iOffSO
      use pso_stuff
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 PAO(ijkl,nPAO), PAOPam(n1,n2,n3,n4), DAO(nDAO),
     &       Cred(nCred), Scr1(nScr1,2), Scr2(nScr2)
      Integer iAO(4), kOp(4), iAOst(4), nPam(4), iiBas(4), iCmp(4)
      Real*8 iPam(n1+n2+n3+n4), MapPam(4,mDim)
      Logical Shijij
*
      iRout = 39
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Write (6,*) ' nBases..=',iBas,jBas,kBas,lBas
      End If
*
*-----Prepare some data for Pam
*
      iiBas(1) = iBas
      iiBas(2) = jBas
      iiBas(3) = kBas
      iiBas(4) = lBas
      nPSOPam=n1*n2*n3*n4
*
*-----Set up table with SO indices in iPam and a table
*     with the number of basis functions in nPam.
*
      Call ICopy(4,[0],0,nPam,1)
      in1 = 0
      Do 9 jPam = 1, 4
         in2 = 0
         Do 11 i1 = 1, iCmp(jPam)
            iSO = iAOtSO(iAO(jPam)+i1,0)
     &          + iAOst(jPam)
            nPam(jPam) = nPam(jPam) + iiBas(jPam)
            Do 12 iAOi = 0, iiBas(jPam)-1
               iSOi = iSO + iAOi
               in2 = in2 + 1
               iPam(in1+in2) = DBLE(iSOi)
               MapPam(jPam,iSOi) = DBLE(in2)
 12         Continue
 11      Continue
         in1 = in1 + in2
 9    Continue
*
*     Get the scrambled 2nd order density matrix
*
      If (LSA) Then
      Call PTrans_sa(CMO(1,1),nPam,iPam,n1+n2+n3+n4,
     &            DAO,PAOPam,nPSOPam,G1,nG1,G2,nG2,
     &            Cred,nCred/2,Scr1(1,1),nScr1,Scr2,nScr2,Scr1(1,2),
     &            nScr1)
      Else
       Call PTrans(CMO(1,1),nPam,iPam,n1+n2+n3+n4,
     &            DAO,PAOPam,nPSOPam,G1,nG1,G2,nG2,
     &            Cred,nCred,Scr1,nScr1,Scr2,nScr2)
      End If
*
*     Quadruple loop over elements of the basis functions angular
*     description.
*     Observe that we will walk through the memory in PAO in a
*     sequential way.
*
      PMax=Zero
      iPAO=0
      Do 100 i1 = 1, iCmp(1)
         Do 200 i2 = 1, iCmp(2)
            Do 300 i3 = 1, iCmp(3)
               Do 400 i4 = 1, iCmp(4)
*
*               Unfold the way the eight indices have been reordered.
                iSO = iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)+iOffSO(kOp(1))
                jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)+iOffSO(kOp(2))
                kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)+iOffSO(kOp(3))
                lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)+iOffSO(kOp(4))
*
                iPAO = iPAO + 1
                nijkl = 0
                Do 120 lAOl = 0, lBas-1
                   lSOl = lSO + lAOl
                   k4 = INT(MapPam(4,lSOl))
                   Do 220 kAOk = 0, kBas-1
                      kSOk = kSO + kAOk
                      k3 = INT(MapPam(3,kSOk))
                      Do 320 jAOj = 0, jBas-1
                         jSOj = jSO + jAOj
                         k2 = INT(MapPam(2,jSOj))
                         Do 420 iAOi = 0, iBas-1
                            iSOi = iSO + iAOi
                            k1 = INT(MapPam(1,iSOi))
                            nijkl = nijkl + 1
*
                            PMax=Max(PMax,Abs(PAOPam(k1,k2,k3,k4)))
                            PAO(nijkl,iPAO) = PAOPam(k1,k2,k3,k4)
*
 420                     Continue
 320                  Continue
 220               Continue
 120            Continue
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
      If (iPAO.ne.nPAO) Then
        Call WarningMessage(2,' Error in PGet3!')
        Call Abend()
      End If
*
*     Call GetMem(' Exit PGet3','CHECK','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Shijij)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CoreToPoint(nAt,MP,TP)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(inout) :: MP(nAt*(nAt+1)/2)
real(kind=wp), intent(out) :: TP(nAt)
integer(kind=iwp) :: i, iAt, kAt
real(kind=wp) :: ByggMeraHus, dScaleOff, dScaleOffSave, dToPoint
logical(kind=iwp) :: GoHere
real(kind=wp), allocatable :: NucCh(:)
real(kind=wp), parameter :: ByggareBas(6) = [2.0_wp,8.0_wp,8.0_wp,18.0_wp,18.0_wp,32.0_wp]

! A crude but to the point algorithm to put core electrons and
! nuclei together, and separating the presumably more diffuse
! part of the charge distribution in a separate chunk.

call mma_allocate(NucCh,nAt,label='NucC')
call Get_dArray('Nuclear charge',NucCh,nAt)
kAt = 0
dToPoint = Zero
do iAt=1,nAt
  ByggMeraHus = Zero
  GoHere = .true.
  dScaleOffSave = NucCh(iAt)
  do i=1,6
    dScaleOff = dScaleOffSave-ByggareBas(i)
    if ((dScaleOff <= Zero) .and. GoHere) then
      dToPoint = ByggMeraHus
      GoHere = .false.
    end if
    dScaleOffSave = dScaleOff
    ByggMeraHus = ByggMeraHus+ByggareBas(i)
  end do
  kAt = kAt+iAt
  MP(kAt) = MP(kAt)+dToPoint
  TP(iAt) = NucCh(iAt)-dToPoint
end do
call mma_deallocate(NucCh)

return

end subroutine CoreToPoint

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine get_polar(nPrim,nBas,nAtoms,nCenters,NOCOB,
!EB     &OENE,ONUM,nOrb,OCOF,RCHC,LNearestAtom)
     &OENE,nOrb,OCOF,RCHC,LNearestAtom,LFirstRun)
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"
#include "MpParam.fh"
#include "Address.fh"
#include "MolProp.fh"

      Dimension OENE(nOrb) ! EB, ONUM(nOrb)
      Dimension oCof(nBas,nPrim)
      Dimension Pol(6,nAtoms,nAtoms), Pd(3,nAtoms)
      Dimension RCHC(3,nBas)
      Logical   LNearestAtom
      Logical   LFirstRun

      iStdOut = 6
      iA = 0 ! Added by EB

      NORBI = nBas
      WRITE(iStdOut,*) '  '
      WRITE(iStdOut,*) ' CALCULATE THE POLARIZATION TENSOR '
      WRITE(iStdOut,*) '  '
C
C CONSTRUCT THE POLARIZATION CONTRIBUTION FROM EACH PAIR OF ATOMS
C
C NBOND assigns the array value where bondvaluearray starts
      Do nA=1,nAtoms
         Do nB=1,nAtoms
            Do i=1,6
               POL(i,nA,nB)=0.0D0
            EndDo
         EndDo
      EndDo
      Write(iStdOut,*)
      Write(iStdOut,*)'No occupied orbitals',NOCOB
      Write(iStdOut,*)'No orbitals',nBas
      Write(iStdOut,*)

      Do i = 1 , NOCOB
         Do j = NOCOB+1,nBas
C
C ORBITAL ENERGIES
C
            FOE  = 4.0d0/(OENE(J)-OENE(I))
C
C CALCULATE EXPANSION CENTER FOR THE TWO ORBITALS
C
            RIJX = 0.5d0*(RCHC(1,I)+RCHC(1,J))
            RIJY = 0.5d0*(RCHC(2,I)+RCHC(2,J))
            RIJZ = 0.5d0*(RCHC(3,I)+RCHC(3,J))
            Do nA = 1,nAtoms
               PAX = 0.0d0
               PAY = 0.0d0
               PAZ = 0.0d0
               Do iPBas = 1,nAtomPBas(NA)
                  K = iAtPrTab(iPBas,NA)
                  Do L =  1 , nPrim
                     If(L.gt.K)Then
                     KK = L
                     LL = K
                     Else
                     KK = K
                     LL = L
                     EndIf
                     PAX = PAX+OCOF(I,K)*OCOF(J,L)
     &               *(work(iwork(iMltPlAd(1))+kk*(kk-1)/2+ll-1)
     &               +work(iwork(iMltPlAd(0))+kk*(kk-1)/2+ll-1)
     &               *(CordMltPl(1,1)-RIJX))

                     PAY = PAY+OCOF(I,K)*OCOF(J,L)
     &               *(work(iwork(iMltPlAd(1)+1)+kk*(kk-1)/2+ll-1)
     &               +work(iwork(iMltPlAd(0))+kk*(kk-1)/2+ll-1)
     &               *(CordMltPl(2,1)-RIJY))

                     PAZ = PAZ + OCOF(I,K)*OCOF(J,L)
     &               *(work(iwork(iMltPlAd(1)+2)+kk*(kk-1)/2+ll-1)
     &               +work(iwork(iMltPlAd(0))+kk*(kk-1)/2+ll-1)
     &               *(CordMltPl(3,1)-RIJZ))
                  EndDo
               EndDo
               PD(1,nA)=PAX
               PD(2,nA)=PAY
               PD(3,nA)=PAZ
            EndDo
            Do nA=1,nAtoms
               Do nB=1,nAtoms
                  POL(1,nA,nB)=POL(1,nA,nB)+PD(1,nA)*PD(1,nB)*FOE
                  POL(2,nA,nB)=POL(2,nA,nB)+PD(1,nA)*PD(2,nB)*FOE
                  POL(3,nA,nB)=POL(3,nA,nB)+PD(1,nA)*PD(3,nB)*FOE
                  POL(4,nA,nB)=POL(4,nA,nB)+PD(2,nA)*PD(2,nB)*FOE
                  POL(5,nA,nB)=POL(5,nA,nB)+PD(2,nA)*PD(3,nB)*FOE
                  POL(6,nA,nB)=POL(6,nA,nB)+PD(3,nA)*PD(3,nB)*FOE
               EndDo
            EndDo
         EndDo
      EndDo
      Do nA = 1,nAtoms
         Do i=1,6
           Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA+1)/2-1)=POL(i,nA,nA)
           Work(iAtPolAd+nAtoms*(i-1)+nA-1)=POL(i,nA,nA)
         EndDo
         Do nB = 1,nA-1
            Do i=1,6
               Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA-1)/2+nB-1) =
     &         POL(i,nA,nB)+POL(i,nB,nA)
            EndDo
         EndDo
      EndDo
      Do nA = 1,nAtoms
         Do nB = 1,nA-1
            FracA = Frac(nA,nB)
            FracB = 1.0 - FracA
C Find the closest atom
            If(LNearestAtom.and.(.not.BondMat(nA,nB))) Then
               Smallest=1.0D200
               Do i=1,nAtoms
                  R=sqrt((Cor(1,nA,nB)-Cor(1,i,i))**2+
     &                    (Cor(2,nA,nB)-Cor(2,i,i))**2+
     &                    (Cor(3,nA,nB)-Cor(3,i,i))**2)
                  If(R.lt.Smallest) Then
                     Smallest=R
                     iA=i
                  EndIf
               EndDo
               RA=sqrt((Cor(1,nA,nB)-Cor(1,nA,nA))**2+
     &                  (Cor(2,nA,nB)-Cor(2,nA,nA))**2+
     &                  (Cor(3,nA,nB)-Cor(3,nA,nA))**2)
               RB=sqrt((Cor(1,nA,nB)-Cor(1,nB,nB))**2+
     &                  (Cor(2,nA,nB)-Cor(2,nB,nB))**2+
     &                  (Cor(3,nA,nB)-Cor(3,nB,nB))**2)
               If( ((iA.ne.nA) .and. (iA.ne.nB) ) .and.
     &             ( (Smallest.lt.RA) .and.  (Smallest.lt.RB) ) ) Then
                  iA=iA
                  iB=0
                  FracA=1.0D0
                  FracB=0.0D0
!                  Write(iStdOut,*)
!                  Write(iStdOut,*)
!     &            ' Moving polaizability between the atoms', nA, nB
!                  Write(iStdOut,*)' to the atom                  ', iA
!                  Write(iStdOut,*)
               Else
                  iA=nA
                  iB=nB
               EndIf
            Else
               iA=nA
               iB=nB
            EndIf
            IF(BondMat(nA,nB)) THEN
               Do i=1,6
                  Work(iAtPolAd+nAtoms*(i-1)+iA-1)=
     &            Work(iAtPolAd+nAtoms*(i-1)+iA-1)+
     &            Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA-1)/2+nB-1)*FracA
                  Work(iAtPolAd+nAtoms*(i-1)+nB-1)=
     &            Work(iAtPolAd+nAtoms*(i-1)+nB-1)+
     &            Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA-1)/2+nB-1)*FracB
               EndDo
            ELSE
               Do i=1,6
                  Work(iAtPolAd+nAtoms*(i-1)+iA-1)=
     &            Work(iAtPolAd+nAtoms*(i-1)+iA-1)+
     &            Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA-1)/2+nB-1)*FracA
                  Work(iAtPolAd+nAtoms*(i-1)+nB-1)=
     &            Work(iAtPolAd+nAtoms*(i-1)+nB-1)+
     &            Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA-1)/2+nB-1)*FracB
                  Work(iAtBoPolAd+nCenters*(i-1)+iA*(iA+1)/2-1)=
     &            Work(iAtBoPolAd+nCenters*(i-1)+iA*(iA+1)/2-1)+
     &            Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA-1)/2+nB-1)*FracA
                  Work(iAtBoPolAd+nCenters*(i-1)+nB*(nB+1)/2-1)=
     &            Work(iAtBoPolAd+nCenters*(i-1)+nB*(nB+1)/2-1)+
     &            Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA-1)/2+nB-1)*FracB
               EndDo
            ENDIF
         EndDo
      EndDo
! If a UHF system is used, correct for the dubble counting of alpha and beta electrons
      If(LFirstRun.eqv..False.) Then
         FracA = 0.5d0
         Do nA = 1,nAtoms
            Do i=1,6
               Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA+1)/2-1)=
     &         Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA+1)/2-1)*FracA
               Work(iAtPolAd+nAtoms*(i-1)+nA-1)=
     &         Work(iAtPolAd+nAtoms*(i-1)+nA-1)*FracA
            EndDo
            Do nB = 1,nA-1
              If(BondMat(nA,nB).eqv..True.) THEN
                  Do i=1,6
                     Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA-1)/2+nB-1) =
     &               Work(iAtBoPolAd+nCenters*(i-1)+nA*(nA-1)/2+nB-1)*
     &               FracA
                  EndDo
               EndIf
            EndDo
         EndDo
      EndIf

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Do_Lebedev(L_Eff,mPt,R,Sym)
!***********************************************************************
!                                                                      *
!     Computes data useful for the angular quadrature.                 *
!                                                                      *
!***********************************************************************

use nq_Grid, only: Pax
use Lebedev_quadrature, only: available_table, ld_by_rule, order_table
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Four, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: L_Eff, Sym
integer(kind=iwp), intent(out) :: mPt
real(kind=wp), allocatable, intent(out) :: R(:,:)
integer(kind=iwp) :: iSet
real(kind=wp), allocatable :: TempR(:,:), TempW(:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Generate angular grid a la Lebedev

iSet = (L_Eff-1)/2
if (available_table(iSet) /= 1) then
  write(u6,'(A,I3)') 'Failed to find a Lebedev grid of order',L_EFF
  call Abend()
end if
if ((Sym < 0) .or. (Sym > 4)) then
  write(u6,'(A,I3)') 'Symmetry of a Lebedev grid must be 0, 1, 2, 3 or 4'
  call Abend()
end if

mPt = order_table(Sym,iSet)
call mma_allocate(R,4,mPt,Label='R')
call mma_allocate(TempR,mPt,3,Label='TempR')
call mma_allocate(TempW,mPt,Label='TempW')

call ld_by_rule(Sym,iSet,TempR(:,1),TempR(:,2),TempR(:,3),TempW)
call DGEMM_('N','T',3,mPt,3,One,Pax,3,TempR,mPt,Zero,R,4)
R(4,:) = Four*Pi*TempW

call mma_deallocate(TempW)
call mma_deallocate(TempR)
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Do_Lebedev

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_VecBuf_Retrieve(Vec,lVec,jVec1,iVec2,iSym,
     &                               jNum,iRedC,mUsed)
C
C     Thomas Bondo Pedersen, June 2006.
C
C     Purpose: copy as many vectors as possible from buffer to array
C              Vec, starting at vector jVec1 and copying at most until
C              vector iVec2. On exit, jNum is the number of vectors
C              copied. On entry as well as on exit, iRedC identifies the
C              reduced set stored at location 3 (use "-1" if none or
C              unknown). On exit, mUsed is the actual amount of memory
C              used (in array Vec).
C
C     NOTE: if no vectors can be copied, jNum=0 and mUsed=0 are returned
C           but execution is NOT stopped here!!!
C
C     NOTE: it is assumed that the vectors are stored in their
C           respective reduced sets (thus, should only be used with
C           RUN_MODE = RUN_EXTERNAL).
C
      use ChoArr, only: nDimRS
      use ChoSwp, only: InfVec
      use ChoVecBuf, only: CHVBUF, ip_CHVBUF_SYM, l_CHVBUF_SYM,
     &                     l_CHVBFI_SYM, nVec_in_Buf
      Implicit Real*8 (a-h,o-z)
      Real*8 Vec(lVec)
#include "cholesky.fh"

      external ddot_

      Character*19 SecNam
      Parameter (SecNam = 'Cho_VecBuf_Retrieve')

      Logical Full
      Logical LocDbg
#ifdef _DEBUGPRINT_
      Parameter (LocDbg = .true.)
#else
      Parameter (LocDbg = .false.)
#endif

C     Initialize.
C     -----------

      jNum = 0
      mUsed = 0

C     Check that a buffer has been allocated and contains vectors in the
C     requested range.
C     ------------------------------------------------------------------

      If (l_ChvBuf_Sym(iSym) .lt. 1) Then
         If (LocDbg) Then
            Write(Lupri,*) SecNam,': returning immediately. ',
     &                     'No buffer allocated.'
         End If
         Return
      End If
      If (l_ChvBfI_Sym(iSym).gt.0) Then
         Call Cho_VecBuf_Check()
      End If
      If (jVec1 .gt. nVec_in_Buf(iSym)) Then
         If (LocDbg) Then
            Write(Lupri,*) SecNam,': returning immediately. ',
     &                     'jVec1 = ',jVec1,'  >  nVec_in_Buf = ',
     &                     nVec_in_Buf(iSym),' (sym. ',iSym,')'
         End If
         Return
      End If

C     Count how many vectors can be copied.
C     -------------------------------------

      lTot = 0
      Full = lTot .ge. lVec
      jVec = jVec1 - 1
      iV2  = min(nVec_in_Buf(iSym),iVec2)
      If (.NOT.Allocated(nDimRS)) Then
         iLoc = 3
         Do While (jVec.lt.iV2 .and. .not.Full)
            jVec = jVec + 1
            jRed = InfVec(jVec,2,iSym)
            If (jRed .ne. iRedC) Then
               irc = 0
               Call Cho_X_SetRed(irc,iLoc,jRed)
               If (irc .ne. 0) Then
                  Write(Lupri,*) SecNam,': Cho_X_SetRed returned ',irc
                  Call Cho_Quit('Error in '//SecNam,104)
               End If
               iRedC = jRed
            End If
            lTot = lTot + nnBstR(iSym,iLoc)
            If (lTot .gt. lVec) Then
               jVec = jVec - 1
               lTot = lTot - nnBstR(iSym,iLoc)
               Full = .true.
            Else
               jNum = jNum + 1
            End If
         End Do
      Else
         Do While (jVec.lt.iV2 .and. .not.Full)
            jVec = jVec + 1
            jRed = InfVec(jVec,2,iSym)
            lTot = lTot + nDimRS(iSym,jRed)
            If (lTot .gt. lVec) Then
               jVec = jVec - 1
               lTot = lTot - nDimRS(iSym,jRed)
               Full = .true.
            Else
               jNum = jNum + 1
            End If
         End Do
      End If

C     Copy vectors (if any).
C     ----------------------

      If (lTot .gt. 0) Then
         kB = ip_ChVBuf_Sym(iSym)
         If (jVec1 .gt. 1) Then
            If (.NOT.Allocated(nDimRS)) Then
               iLoc = 3
               Do jVec = 1,jVec1-1
                  jRed = InfVec(jVec,2,iSym)
                  If (iRedC .ne. jRed) Then
                     irc = 0
                     Call Cho_X_SetRed(irc,iLoc,jRed)
                     If (irc .ne. 0) Then
                        Write(Lupri,*) SecNam,
     &                                 ': Cho_X_SetRed returned ',irc
                        Call Cho_Quit('Error [2] in '//SecNam,104)
                     End If
                     iRedC = jRed
                  End If
                  kB = kB + nnBstR(iSym,iLoc)
               End Do
            Else
               Do jVec = 1,jVec1-1
                  jRed = InfVec(jVec,2,iSym)
                  kB = kB + nDimRS(iSym,jRed)
               End Do
            End If
         End If
         Call dCopy_(lTot,CHVBUF(kB),1,Vec,1)
         ! Check copy operation (may fail if molcas is compiled for
         ! 64 bit but linked to a 32 bit blas library)
         ! Note: check is not done unless it is enabled when the buffer
         ! is initialized.
         ! This only happens if _DEBUGPRINT_ is defined, so
         ! the following section is normally not executed.
         ! For debugging without turning on _DEBUGPRINT_ compilation:
         !   Call Cho_VecBuf_EnableIntegrityCheck(irc)
         ! somewhere in the code and for every subsequent call to this
         ! routine, the integrity is checked.
         If (l_ChVBfI_Sym(iSym).gt.0) Then
            nErr=0
            kB=1
            Do iVec=1,jNum
               jVec=jVec1+iVec-1
               jRed=InfVec(jVec,2,iSym)
               Call Cho_VecBuf_CompareNormAndSum(nDimRS(iSym,jRed),1,
     &                                           Vec(kB),jVec,iSym,irc)
               If (irc.ne.0) Then
                  nErr=nErr+1
                  Write(LuPri,'(A,I9,A,I2,A)')
     &            'Buffer copy failed for vector',jVec,' (sym.',iSym,')'
               End If
               kB=kB+nDimRS(iSym,jRed)
            End Do
            If (nErr.gt.0) Then
               Call Cho_Flush(LuPri)
               Write(LuPri,'(A,I9,A)')
     &         'Cho_VecBuf_Retrieve: buffer copy failed for',nErr,
     &         ' vectors. Going to check buffer integrity...'
               Call Cho_Flush(LuPri)
               Call Cho_VecBuf_Check()
               Write(LuPri,'(A,A)')
     &         'Buffer integrity checked: OK',
     &         ' --- error occurs in the copy operation.'
#if defined (_I8_)
               Write(LuPri,'(A,A)')
     &         'This appears to be a 64-bit version of MOLCAS.',
     &         ' Did you link to a 32-bit version of the BLAS library?'
#endif
               Call Cho_Quit(
     &         'Cho_VecBuf_Retrieve: buffer copy failed',104)
            End If
         End If
      End If

C     Set memory used.
C     ----------------

      mUsed = lTot

C     Debug: print.
C     -------------

      If (LocDbg) Then
         Write(Lupri,*)
         Write(Lupri,*) SecNam,':'
         If (jNum .lt. 1) Then
            Write(Lupri,*) 'No vectors copied!'
         Else
            Write(Lupri,*) 'Vectors ',jVec1,' to ',jVec1+jNum-1,
     &                     ' of symmetry ',iSym,' copied from buffer.'
            If (Allocated(nDimRS)) Then
               kOffV = 1
               Do iVec = 1,jNum
                  jVec = jVec1 + iVec - 1
                  jRed = InfVec(jVec,2,iSym)
                  jAdr = InfVec(jVec,3,iSym)
                  xNrm = sqrt(dDot_(nDimRS(iSym,jRed),Vec(kOffV),1,
     &                                               Vec(kOffV),1))
                  Write(Lupri,*) 'Vector:',jVec,' disk address: ',jAdr,
     &                           ' norm: ',xNrm
                  kOffV = kOffV + nDimRS(iSym,jRed)
               End Do
               nTst = kOffV - 1
               If (nTst .NE. mUsed) Then
                 Call Cho_Quit('Vector dimension error in '//SecNam,104)
               End If
            End If
         End If
         Call Cho_Flush(Lupri)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003-2005, Valera Veryazov                             *
!               2017, Roland Lindh                                     *
!***********************************************************************

subroutine Reduce_Thresholds(EThr_,SIntTh)

use Gateway_Info, only: ThrInt
use InfSCF, only: DltNTh, DltNTh_old, DThr, DThr_old, EThr, EThr_old, FThr, FThr_old, ThrInt_old
use Constants, only: Zero, One, Ten
use Definitions, only: wp, u6

implicit none
real(kind=wp), intent(in) :: EThr_
real(kind=wp), intent(inout) :: SIntTh
real(kind=wp) :: Relax

write(u6,*)
write(u6,*) 'Temporary increase of thresholds...'
write(u6,*)
EThr_old = EThr
DThr_old = DThr
DltNTh_old = DltNTh
FThr_old = FThr

! Get threshold used in connection of products of integrals and densities

ThrInt_old = ThrInt

EThr = EThr_
if (EThr_old == Zero) then
  Relax = One
else
  Relax = EThr/EThr_old
end if
SIntTh = SIntTh*Relax
DThr = DThr*Relax
DltNTh = Ten**2*EThr
FThr = FThr*Relax
ThrInt = ThrInt*Relax

return

end subroutine Reduce_Thresholds

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE INVMAT(A,B,MATDIM,NDIM,ISING)
C FIND INVERSE OF MATRIX A
C INPUT :
C        A : MATRIX TO BE INVERTED
C        B : SCRATCH ARRAY
C        MATDIM : PHYSICAL DIMENSION OF MATRICES
C        NDIM :   DIMENSION OF SUBMATRIX TO BE INVERTED
C
C OUTPUT : A : INVERSE MATRIX ( ORIGINAL MATRIX THUS DESTROYED )
C WARNINGS ARE ISSUED IN CASE OF CONVERGENCE PROBLEMS )
*
* ISING = 0 => No convergence problems
*       = 1  => Convergence problems
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(MATDIM,MATDIM),B(MATDIM,MATDIM)
C
      ITEST=0
      IF(NDIM.EQ.1)THEN
        IF(A(1,1) .NE. 0.0D0 ) THEN
           A(1,1) = 1.0D0/A(1,1)
        ELSE
           ITEST = 1
        END IF
      ELSE
        DETERM=0.0D0
        EPSIL=0.0D0
        CALL BNDINV(        A,        B,     NDIM,   DETERM,    EPSIL,
     &                  ITEST,   MATDIM)
      END IF
C
      IF( ITEST .NE. 0 ) THEN
        WRITE (6,'(A,I3)') ' INVERSION PROBLEM NUMBER..',ITEST
      END IF
*
      IF(ITEST.NE.0) THEN
        ISING = 1
      ELSE
        ISING = 0
      END IF
*
      NTEST = 0
      IF ( NTEST .NE. 0 ) THEN
        WRITE(6,*) ' INVERTED MATRIX '
        CALL WRTMAT(A,NDIM,NDIM,MATDIM,MATDIM)
      END IF
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine ddrhs_cvb(vec,ndim,ioffs)
      implicit real*8(a-h,o-z)
#include "WrkSpc.fh"
#include "direct_cvb.fh"
      dimension vec(ndim)

      nvrhs=nvrhs+1
      if(nvrhs.gt.mxrhs)then
        write(6,*)' Too many RHS vectors in Davidson!',nvrhs,mxrhs
        call abend_cvb()
      endif
      if(ndim+ioffs.gt.nparm)then
        write(6,*)' Illegal call to DDRHS :',ndim,ioffs,nparm
        call abend_cvb()
      endif
      call fzero(work(idd(ivrhs)+(nvrhs-1)*nparm),ioffs)
      call fmove_cvb(vec,work(ioffs+idd(ivrhs)+(nvrhs-1)*nparm),ndim)
      call fzero(work(ndim+ioffs+idd(ivrhs)+(nvrhs-1)*nparm),
     >  nparm-ioffs-ndim)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SDCMRF(CSD,CCM,IATP,IBTP,IASM,IBSM,NA,NB,IDC,PS,PL,ISGVST,LDET,LCOMB,ISCALE,SCLFAC)
! Change a block of coefficients bwtween combination format and
! Slater determinant format
!
! Combinations => SD
!
! Input
! =====
! CSD : Block in determinant form
! CCM : Block in combination form
! IATP,IBTP : type of alpha- and beta- string
! NA,NB : Number of alpha- and beta- strings
! IDC  : Combination type
! PS   : Spin combination sign
! PL   : Ml   combination sign
! ISGVST : Ml reflection of strings
!
! If ISCALE == 0, no overall scaling is performed,
!                 the overall scale factor is returned as SCLFAC

use Index_Functions, only: nTri_Elem
use Constants, only: One, Two, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: CSD(*)
real(kind=wp), intent(in) :: CCM(*), PS, PL
integer(kind=iwp), intent(in) :: IATP, IBTP, IASM, IBSM, NA, NB, IDC, ISGVST(IBSM), ISCALE
integer(kind=iwp), intent(out) :: LDET, LCOMB
real(kind=wp), intent(out) :: SCLFAC
integer(kind=iwp) :: IPACK
real(kind=wp) :: FACTOR, SGN
logical(kind=iwp) :: Test1, Test2
real(kind=wp), parameter :: SQRT2 = sqrt(Two), SQRT2I = sqrt(Half)

! Is combination array packed ?

SCLFAC = One
IPACK = 0
FACTOR = One

Test1 = (IDC == 2) .or. (IDC == 4)
if (.not. Test1) then
  Test2 = IDC == 4
  if (Test2) Test2 = Test2 .and. (IASM == ISGVST(IBSM))
else
  Test2 = .false.
end if

if (Test1) then
  SGN = PS
  FACTOR = SQRT2
  if ((IASM == IBSM) .and. (IATP == IBTP)) IPACK = 1
else if (Test2) then
  if (IATP == IBTP) IPACK = 1
  SGN = PS*PL
  FACTOR = Two
end if

LDET = NA*NB
#ifdef _DEBUGPRINT_
write(u6,*) ' SDCMRF : NA, NB =',NA,NB
#endif
if (IPACK == 0) then
  LCOMB = LDET
else
  LCOMB = nTri_Elem(NA)
end if
if ((IDC == 4) .and. (IPACK == 0)) FACTOR = SQRT2
FACTOR = One/FACTOR

! Combination => SD transformation

if (IPACK == 1) then
  ! Unpack from triangular form
  call TRIPK32(CSD,CCM,NA,NA,SGN)
else
  CSD(1:NA*NB) = CCM(1:NA*NB)
end if
! Scale
if (FACTOR /= One) then
  if (ISCALE == 1) then
    SCLFAC = One
    CSD(1:LDET) = FACTOR*CSD(1:LDET)
  else
    SCLFAC = FACTOR
  end if
  if (IPACK == 1) call SCLDIA(CSD,SQRT2,NA,0)
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Information from SDCMRF'

write(u6,'(A,6I4)') ' IATP IBTP IASM IBSM IDC ',IATP,IBTP,IASM,IBSM,IDC
write(u6,'(A,I4,3X,2ES15.8)') ' IPACK FACTOR SIGN',IPACK,FACTOR,SGN
write(u6,*) ' Slater determinant block'
call WRTMAT(CSD,NA,NB,NA,NB)
write(u6,*)
write(u6,*) ' Combination block'
if (IPACK == 1) then
  call PRSM2(CCM,NA)
else
  call WRTMAT(CCM,NA,NB,NA,NB)
end if
#endif

end subroutine SDCMRF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NEWORB_RASSCF(CMOO,CMON,FP,FTR,VEC,WO,SQ,CMOX,D,OCCN)
C
C     RASSCF program, version IBM-3090: SX section
C
C     Purpose: To diagonalize the inactive,
C              and external parts of the Fock matrix FP=(FI+FA)
C              and order the eigenvalues and eigenvectors after energy.
C              The active orbitals are obtained by diagonalising the
C              corresponding RAS subspaces.
C              The new MO's are written onto JOBIPH
C              in address IADR15(2), and are used to produce the final
C              wave function. These are the orbitals printed in the
C              output section.
C     Called from SXCTL if IFINAL=1 (after last MC iteration)
C
C          ********** IBM-3090 MOLCAS Release: 90 02 22 **********
C
C     Calling arguments:
*     D       : array of real, input
*               one body density matrix in MO-space
*     FP      : array of real, input
*               MCSCF-Fock matrix
*     FTR     : array of real
*               scratch array (local copy of FP, one sym. block only)
*     SQ      : array of real
*               scratch array (keep in sym block of Fock)
*     WO      : array of real
*               scratch array (keep in sym block of Fock)
*     VEC     : array of real
*               scratch array (eigenvectors of FTR)
*     CMOX    : array of real, input
*               scratch array (local copy of CMOO)
*     CMOO    : array of real, input
*               old MO-coefficients
*     CMON    : array of real, output
*               new MO-coefficients
*     OCNN    : array of real, input/output
*               MO occupation numbers

#ifdef _DMRG_
      use qcmaquis_interface_cfg
#endif
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='NEWORB  ')
#include "SysDef.fh"
#include "raswfn.fh"
#include "rctfld.fh"

      DIMENSION CMOO(*),CMON(*),FP(*),FTR(*),VEC(*),
     *          WO(*),SQ(*),D(*),OCCN(*),CMOX(*)

C Local print level (if any)
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
C
C     IORD = 1 Ordering of inactive and secondary orbitals
C
      IF(ISUPSM.eq.1.AND.IORDEM.eq.0) IFORDE=0
      IORD=IFORDE

      IB=0
      ISTMO1=1
      ISTFCK=0
      ISTD=0

* A long loop over symmetry:
      DO ISYM=1,NSYM
       NBF=NBAS(ISYM)
       NFO=NFRO(ISYM)
       NIO=NISH(ISYM)
       NAO=NASH(ISYM)
       NEO=NSSH(ISYM)
       NOO=NFO+NIO+NAO
       NOT=NIO+NAO+NEO
       ISTMO=ISTMO1+NFO*NBF
C*********************************************************************
C      Frozen orbitals (move MO's to CMON, and set zero to FDIAG)
C*********************************************************************
       IF(NFO.NE.0) THEN
        NFNB=NBF*NFO
        CALL DCOPY_(NFNB,CMOO(ISTMO1),1,CMON(ISTMO1),1)
        DO  NF=1,NFO
         FDIAG(IB+NF)=0.0D0
         OCCN(IB+NF)=2.0D0
        END DO
       ENDIF
C*********************************************************************
C      Inactive part of the Fock matrix
C*********************************************************************
       IF(NIO.NE.0) THEN
C       MOVE FP TO TRIANGULAR FORM
        NIJ=0
        DO NI=1,NIO
         DO NJ=1,NI
          NIJ=NIJ+1
          FTR(NIJ)=FP(NIJ+ISTFCK)
          IF(IXSYM(IB+NFO+NI).NE.IXSYM(IB+NFO+NJ)) FTR(NIJ)=0.0D0
         END DO
        END DO
C       DIAGONALIZE
        NIO2=NIO**2
        CALL FZERO(VEC,NIO2)
        II=1
        DO NI=1,NIO
         VEC(II)=1.0D0
         II=II+NIO+1
        END DO
        CALL JACOB(FTR,VEC,NIO,NIO)
C
C       Transform molecular orbitals
C
        CALL DGEMM_('N','N',
     &              NBF,NIO,NIO,
     &              1.0d0,CMOO(ISTMO),NBF,
     &              VEC,NIO,
     &              0.0d0,CMON(ISTMO),NBF)
C
C       Sort eigenvalues and orbitals after energy
C
C       Move eigenvalues to FDIAG and set occupation numbers to 2.
C
        II=0
        NO1=IB+NFO
        DO NI=1,NIO
         II=II+NI
         FDIAG(NO1+NI)=FTR(II)
         OCCN(NO1+NI)=2.0D0
        END DO
        IF(NIO.GT.1.AND.IORD.NE.0) THEN
         NIO1=NIO-1
         DO NI=1,NIO1
          NI1=NI+1
          MIN=NI
          DO NJ=NI1,NIO
           IF(FDIAG(NO1+NJ).LT.FDIAG(NO1+MIN)) MIN=NJ
          END DO
          IF(MIN.EQ.NI) GO TO 20
          FMIN=FDIAG(NO1+MIN)
          FDIAG(NO1+MIN)=FDIAG(NO1+NI)
          FDIAG(NO1+NI)=FMIN
* (SVC) added: extra nodig voor verandering ordening met supsym
          IXSYMT=IXSYM(NO1+MIN)
          IXSYM(NO1+MIN)=IXSYM(NO1+NI)
          IXSYM(NO1+NI)=IXSYMT

          ISTI=ISTMO+NBF*(NI-1)
          ISTM=ISTMO+NBF*(MIN-1)
          CALL DSWAP_(NBF,CMON(ISTI),1,CMON(ISTM),1)
20       CONTINUE
         END DO
        ENDIF
       ENDIF
C*********************************************************************
C      Active orbitals. Diagonalize corresponding diagonal block of D
C*********************************************************************
C.. dongxia make a loop for all active spaces
C
      ioff=0
      Do igas=1,ngas
       if(igas.gt.1)ioff=ioff+ngssh(igas-1,isym)
       IF(ngssh(igas,isym).NE.0) THEN
C       MOVE D TO TRIANGULAR FORM
        NTU=0
        ntud=istd+itri(ioff+1)
        DO NT=1,ngssh(igas,isym)
         ntud=ntud+ioff
C YM: change ntt --> nttr for the confict if include rctfld.fh
         nttr=nt+nio+ioff
         DO NU=1,NT
          nut=nu+nio+ioff
          NTU=NTU+1
          ntud=ntud+1
          FTR(NTU)=D(ntud)
          IF(IXSYM(IB+NFO+nttr).NE.IXSYM(IB+NFO+nut)) ftr(ntu)=0.0d0
         END DO
        END DO

#ifdef _DMRG_
C YM:   If lRF, use Canonical instead of Natural, otherwise the energy expression will be
c       mismatch due to the FI matrix still in Canonical form.
cc YM:   The lRF flag can be removed if "TRACI" utility has MPS version
cc        If(.not.lRF.OR.iOrbTyp.EQ.2) Then
c YM:   Just use the same way as Block did, the NOs will be added later
        If(.not.doDMRG.OR.iOrbTyp.EQ.2) Then
#else
C NN.14 Skip making new orbitals for DMRG-CASSCF except for the case OutOrb = Canonical
C       because the DMRG is orbital variant.
        If(.NOT.DoBlockDMRG.OR.iOrbTyp.EQ.2) Then
#endif

C
C       DIAGONALIZE
        NAO2=ngssh(igas,isym)**2
        CALL FZERO(VEC,NAO2)
        II=1
        DO NT=1,ngssh(igas,isym)
         VEC(II)=1.0D0
         II=II+ngssh(igas,isym)+1
        END DO
        CALL JACOB(FTR,VEC,ngssh(igas,isym),ngssh(igas,isym))
CPAM01 Reorder to max-overlap agreement with input orbitals.
CPAM01 This prevents numerical difficulty with the subsequent transformation
CPAM01 of the CI vector, see TRAMAT routine.
CPAM01 Similar later, with RAS2, RAS3.
        DO I=1,ngssh(igas,isym)-1
         JSEL=I
         AVMX=ABS(VEC(I+ngssh(igas,isym)*(I-1)))
         DO J=I+1,ngssh(igas,isym)
          AVIJ=ABS(VEC(I+ngssh(igas,isym)*(J-1)))
          IF(AVIJ.GT.AVMX) THEN
            JSEL=J
            AVMX=AVIJ
          END IF
         END DO
CPAM01 Swap if necessary. Note phase control!!
         IF(JSEL.GT.I) THEN
           VIJ=VEC(I+ngssh(igas,isym)*(JSEL-1))
           IF(VIJ.GT.0.0D0) THEN
             DO K=1,ngssh(igas,isym)
               SWAP=VEC(K+ngssh(igas,isym)*(JSEL-1))
               VEC(K+ngssh(igas,isym)*(JSEL-1))=
     &          -VEC(K+ngssh(igas,isym)*(I-1))
               VEC(K+ngssh(igas,isym)*(I-1))=SWAP
             END DO
           ELSE
             DO K=1,ngssh(igas,isym)
               SWAP=VEC(K+ngssh(igas,isym)*(JSEL-1))
               VEC(K+ngssh(igas,isym)*(JSEL-1))=
     &          +VEC(K+ngssh(igas,isym)*(I-1))
               VEC(K+ngssh(igas,isym)*(I-1))=-SWAP
             END DO
           END IF
C Also swap eigenvalues:
           SWAP=FTR((JSEL*(JSEL+1))/2)
           FTR((JSEL*(JSEL+1))/2)=FTR((I*(I+1))/2)
           FTR((I*(I+1))/2)=SWAP
         ELSE
CPAM01 If swap is not needed, still apply phase control!!
           IF(VEC(I+ngssh(igas,isym)*(I-1)).LT.0.0D0) THEN
             DO K=1,ngssh(igas,isym)
              VEC(K+ngssh(igas,isym)*(I-1))=
     &         -VEC(K+ngssh(igas,isym)*(I-1))
              VEC(K+ngssh(igas,isym)*I  )=
     &         -VEC(K+ngssh(igas,isym)*I  )
             END DO
           END IF
         END IF
        END DO
CPAM01 We now have a MINIMAL pure rotation. This means that all
CPAM01 upper-left subdeterminants are >0 and as big as possible.
CPAM01 This eliminates numerical trouble in TRAMAT.

C
C       Transform molecular orbitals
C
        ISTMOA=ISTMO+NBF*(NIO+ioff)
        CALL DGEMM_('N','N',
     &              NBF,ngssh(igas,isym),ngssh(igas,isym),
     &              1.0d0,CMOO(ISTMOA),NBF,
     &              VEC,ngssh(igas,isym),
     &              0.0d0,CMON(ISTMOA),NBF)
C NN.14 Just copy CMO(Old) to CMO(new)
        Else ! If(.NOT.DoDMRG.OR.iOrbTyp.EQ.2)
          ISTMOA=ISTMO+NBF*(NIO+ioff)
         CALL DCOPY_(NBF*ngssh(igas,isym),CMOO(ISTMOA),1,CMON(ISTMOA),1)
        End If
C
C       Move eigenvalues to OCCN and set energies to zero (not defined).
C
        II=0
        NO1=IB+NFO+NIO+ioff
        DO NT=1,ngssh(igas,isym)
         II=II+NT
         OCCN(NO1+NT)=FTR(II)
         FDIAG(NO1+NT)=0.0D0
        END DO

       ENDIF  ! end of if(NGAS(1).ne.0)
      END DO ! end loop over GAS spaces
C
C*********************************************************************
C      external part of the Fock matrix
C*********************************************************************
C
       IF(NEO.NE.0) THEN
C       Move fp to triangular form
        NAB=0
        DO NA=1,NEO
         DO NB=1,NA
          NAB=NAB+1
          NAT=NA+NIO+NAO
          NBT=NB+NIO+NAO
          NABT=ISTFCK+(NAT**2-NAT)/2+NBT
          FTR(NAB)=FP(NABT)
          IF(IXSYM(IB+NFO+NAT).NE.IXSYM(IB+NFO+NBT)) FTR(NAB)=0.0D0
         END DO
        END DO
C       DIAGONALIZE
        NEO2=NEO**2
        CALL FZERO(VEC,NEO2)
        II=1
        DO NA=1,NEO
         VEC(II)=1.0D0
         II=II+NEO+1
        END DO
        CALL JACOB(FTR,VEC,NEO,NEO)
C
C       Move eigenvalues to FDIAG and set occupation numbers to zero.
C
        II=0
        NO1=IB+NFO+NIO+NAO
        DO NA=1,NEO
         II=II+NA
         FDIAG(NO1+NA)=FTR(II)
         OCCN(NO1+NA)=0.0D0
        END DO
C
C       Transform molecular orbitals
C
        ISTMOA=ISTMO+NBF*(NIO+NAO)
        CALL DGEMM_('N','N',
     &              NBF,NEO,NEO,
     &              1.0d0,CMOO(ISTMOA),NBF,
     &              VEC,NEO,
     &              0.0d0,CMON(ISTMOA),NBF)
C
C       Sort eigenvalues and orbitals after energy
C
        IF(NEO.GT.1.AND.IORD.NE.0) THEN
         NEO1=NEO-1
         DO NA=1,NEO1
          NA1=NA+1
          MIN=NA
          DO NB=NA1,NEO
           IF(FDIAG(NO1+NB).LT.FDIAG(NO1+MIN)) MIN=NB
          END DO
          IF(MIN.EQ.NA) GO TO 99
          FMIN=FDIAG(NO1+MIN)
          FDIAG(NO1+MIN)=FDIAG(NO1+NA)
          FDIAG(NO1+NA)=FMIN
* (SVC) added: extra nodig voor verandering ordening met supsym
          IXSYMT=IXSYM(NO1+MIN)
          IXSYM(NO1+MIN)=IXSYM(NO1+NA)
          IXSYM(NO1+NA)=IXSYMT

          ISTI=ISTMOA+NBF*(NA-1)
          ISTM=ISTMOA+NBF*(MIN-1)
          CALL DSWAP_(NBF,CMON(ISTI),1,CMON(ISTM),1)
99       CONTINUE
         END DO
        ENDIF
       ENDIF
C
C*********************************************************************
C      Deleted orbitals (move MO's and set zero to FDIAG and OCCN)
C*********************************************************************
       NDO=NDEL(ISYM)
       IF(NDO.NE.0) THEN
        NDNB=NDO*NBF
        IST=ISTMO1+NBF*(NOO+NEO)
        CALL DCOPY_(NDNB,CMOO(IST),1,CMON(IST),1)
        DO ND=1,NDO
         FDIAG(IB+NBF-NDO+ND)=0.0D0
         OCCN(IB+NBF-NDO+ND)=0.0D0
        END DO
       ENDIF
C
       IB=IB+NBF
       ISTFCK=ISTFCK+(NOT**2+NOT)/2
       ISTMO1=ISTMO1+NBF**2
       ISTD=ISTD+(NAO**2+NAO)/2
* End of a long loop over symmetry.
      END DO
C
      IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,*)' Diagonal elements of the FOCK matrix in NEWORB:'
        Write(LF,'(1X,10F11.6)') (FDIAG(I),I=1,NTOT)
      END IF
C
C*********************************************************************
C     Orthogonalise new orbitals
C*********************************************************************
      CALL ORTHO_rASSCF(WO,CMOX,CMON,SQ)
        If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' CMO in NEWORB_RASSCF after diag and orthog'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         ioff=0
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          if(iBas.ne.0) then
            write(6,*) 'Sym =', iSym
            do i= 1,iBas
              write(6,*) (CMON(ioff+iBas*(i-1)+j),j=1,iBas)
            end do
            iOff = iOff + (iBas*iBas)
          end if
         End Do
        End If
C
C     Save new CMOs on the JOBIPH
C
      IAD15=IADR15(2)
      CALL dDAFILE(JOBIPH,1,CMON,NTOT2,IAD15)
      CALL dDAFILE(JOBIPH,1,OCCN,NTOT,IAD15)

#ifdef _HDF5_
      call mh5_put_dset(wfn_mocoef,CMON)
      call mh5_put_dset(wfn_occnum,OCCN)
      call mh5_put_dset(wfn_orbene,FDIAG)
#endif

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DrvUpH(nWndw,nIter,H,nInter,dq,g,iOptH,IterHess)

use Slapaf_Info, only: mRowH
use NewH_mod, only: DiagMM, UpdMask
use Constants, only: Zero
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nWndw, nIter, nInter, iOptH
real(kind=wp), intent(inout) :: H(nInter,nInter)
real(kind=wp), intent(in) :: dq(nInter,nIter), g(nInter,nIter+1)
integer(kind=iwp), intent(inout) :: IterHess
integer(kind=iwp) :: i, iSt, lIter
logical(kind=iwp) :: DoMask, Found

!                                                                      *
!***********************************************************************
!                                                                      *
iSt = max(2,nIter-(nWndw-1))
call Qpg_iScalar('HessIter',Found)
if (Found) then
  call Get_iScalar('HessIter',IterHess)
  iSt = max(iSt,IterHess+1)
else
  IterHess = 0
end if
if (allocated(mRowH)) iSt = max(iSt,size(mRowH)+2)
#ifdef _DEBUGPRINT_
write(u6,*) 'DrvUpH: iSt,kIter=',iSt,nIter
call RecPrt('DrvUpH: Initial Hessian',' ',H,nInter,nInter)
!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. btest(iOptH,3)) then
  write(u6,*)
  if (nIter < iSt) then
    write(u6,*) 'No update of Hessian on the first iteration'
  else
    write(u6,'(A,30I3)') 'Hessian update from points:',(lIter,lIter=iSt-1,nIter)
  end if
  write(u6,*)
end if
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
DoMask = .false.
if (allocated(UpdMask)) then
  if (size(UpdMask) == nInter) DoMask = .true.
end if
if (DoMask) then
  do i=1,nInter
    if (UpdMask(i) /= 0) then
      H(i,:) = Zero
      H(:,i) = Zero
      H(i,i) = DiagMM
    end if
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Update the Hessian over the window

#ifdef _DEBUGPRINT_
call RecPrt('DrvUpH: Initial Hessian',' ',H,nInter,nInter)
#endif
do lIter=iSt,nIter
# ifdef _DEBUGPRINT_
  write(u6,*) 'DrvUpH: Call NewH, lIter=',lIter
# endif
  call NewH(nInter,lIter,dq,g,H,iOptH,nIter)
end do
#ifdef _DEBUGPRINT_
call RecPrt('DrvUpH: Updated Hessian',' ',H,nInter,nInter)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine DrvUpH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ZOOS(ISMOST,IBLTP,MAXSYM,IOCOC,NSSOA,NSSOB,
     &                NOCTPA,NOCTPB,IDC,IOOS,NOOS,NCOMB,IXPND)
*
* Generate offsets for CI vector for RAS CI expansion of given symmetry
* Combination type is defined by IDC
* Total number of combinations NCOMB is also obtained
*
* Symmetry is defined through ISMOST
*
* ICBLTP gives typo of symmetry block :
* = 0 : symmetry block is not included
* = 1 : symmetry block is included , all OO types
* = 2 : symmetry block is included , lower OO types
*
* If IXPND .ne. 0 , the diagonal blocks are always choosen expanded
*
* ========
*  Output
* ========
*
* IOOS(IOCA,IOCB,ISYM) : Start of block with alpha strings of
*                        symmetry ISYM and type IOCA, and
*                        betastrings of type IOCB
* NOOS(IOCA,IOCB,ISYM) : Number of combinations
* The ordering used for the CI vector is
*
*    SYMMETRY  FOR ALPHA STRINGS..(GIVES SYMMETRY OF BETA STRING )
*         OCCUPATION TYPE  FOR ALPHA STRING
*            OCCUPATION TYPE FOR    BETA STRING
*                BETA STRING ( COLUMN INDEX)
*                ALPHA STRINGS ( ROW INDEX )
*    END OF LOOPS
*
*
*. Input
      DIMENSION IOCOC(NOCTPA,NOCTPB),ISMOST(*)
      DIMENSION NSSOA(MAXSYM,NOCTPA),NSSOB(MAXSYM,NOCTPB)
      DIMENSION IBLTP(*)
*. output
      DIMENSION IOOS(NOCTPA,NOCTPB,MAXSYM)
      DIMENSION NOOS(NOCTPA,NOCTPB,MAXSYM)
*
      CALL ISETVC(IOOS,0,NOCTPA*NOCTPB*MAXSYM)
      CALL ISETVC(NOOS,0,NOCTPA*NOCTPB*MAXSYM)
C?    CALL ISETVC(ICBLTP,0,MAXSYM)
      NCOMB = 0
      DO 100 IASYM = 1, MAXSYM
*
        IBSYM = ISMOST(IASYM)
        IF(IBSYM .EQ. 0 ) GOTO 100
*. Allowed combination symmetry block ?
        IF(IDC.NE.1.AND.IBLTP(IASYM).EQ.0) GOTO 100
*. Allowed occupation combinations
        DO  95 IAOCC = 1,NOCTPA
          IF(IBLTP(IASYM).EQ.1) THEN
            MXBOCC = NOCTPB
            IREST1 = 0
          ELSE
            MXBOCC = IAOCC
            IREST1 = 1
          END IF
          DO 90 IBOCC = 1, MXBOCC
*.Is this block allowed
            IF(IOCOC(IAOCC,IBOCC).EQ.1) THEN
              IOOS(IAOCC,IBOCC,IASYM) = NCOMB+1
              IF(IXPND.EQ.0 .AND. IREST1.EQ.1 .AND. IAOCC.EQ.IBOCC)THEN
                NCOMB = NCOMB
     &      +   (NSSOA(IASYM,IAOCC)+1)*NSSOB(IBSYM,IBOCC)/2
                NOOS(IAOCC,IBOCC,IASYM) =
     &          (NSSOA(IASYM,IAOCC)+1)*NSSOB(IBSYM,IBOCC)/2
              ELSE
                NCOMB = NCOMB
     &      +   NSSOA(IASYM,IAOCC)*NSSOB(IBSYM,IBOCC)
                NOOS(IAOCC,IBOCC,IASYM) =
     &          NSSOA(IASYM,IAOCC)*NSSOB(IBSYM,IBOCC)
              END IF
            END IF
!            write(6,*) ' NOOS(IA,IB,ISM) ',NOOS(IAOCC,IBOCC,IASYM)
   90     CONTINUE
   95   CONTINUE
  100 CONTINUE
*


      NTEST = 0
      IF ( NTEST .NE. 0 ) THEN
         WRITE(6,*)
         WRITE(6,*) ' ==============='
         WRITE(6,*) ' ZOOS reporting '
         WRITE(6,*) ' ==============='
         WRITE(6,*)
         WRITE(6,*) ' NSSOA, NSSOB ( input ) '
         CALL IWRTMA(NSSOA,MAXSYM,NOCTPA,MAXSYM,NOCTPA)
         CALL IWRTMA(NSSOB,MAXSYM,NOCTPB,MAXSYM,NOCTPB)
         WRITE(6,*)
         WRITE(6,*) ' Number of combinations obtained ',NCOMB
         WRITE(6,*) ' Offsets for combination OOS blocks '
         DO 111 IASYM = 1,MAXSYM
           WRITE(6,'(A,I2)') '  Symmetry ',IASYM
           CALL IWRTMA(IOOS(1,1,IASYM),NOCTPA,NOCTPB,NOCTPA,NOCTPB)
  111    CONTINUE
         WRITE(6,*) ' Number of  combinations per OOS blocks '
         DO 112 IASYM = 1,MAXSYM
           WRITE(6,'(A,I2)') '  Symmetry ',IASYM
           CALL IWRTMA(NOOS(1,1,IASYM),NOCTPA,NOCTPB,NOCTPA,NOCTPB)
  112    CONTINUE
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRPROP(PROP,USOR,USOI,ENSOR,NSS,OVLP,ENERGY,JBNUM,EigVec)

use rassi_aux, only: ipglob
use rassi_global_arrays, only: SODYSAMPS
use kVectors, only: k_Vector, nk_Vector
use Cntrl, only: Atens_Req, BAngRes, BIncre, BStart, DIPR, Do_SK, Do_TMom, DoCD, DYSO, EPrThr, HypF_rms_Req, iComp, IfGCAL, &
                 IfGTCALSA, IfGTSHSA, IfMCal, IFSO, IfvanVleck, IfXCal, IPUSED, ISOCMP, LoopDivide, LoopMax, LPRPR, MLTPLT, &
                 MULTIP, NBSTep, NPROP, NSOPR, NSTATE, NTS, nTStep, OSThr_DIPR, OSthr_QIPR, PNAME, pNMR_req, PNUC, PORIG, &
                 PRDIPCOM, PRMEE, PRMES, PRXVE, PTYPE, QIALL, QIPR, ReduceLoop, RSPR, RSThr, SOPRNM, SOPRTP, TIncre, TMaxs, TMins, &
                 Tolerance, TStart
use hfcop, only: Hyperfine_Oper
#ifdef _HDF5_
use mh5, only: mh5_put_dset
use RASSIWfn, only: wfn_sfs_amfi, wfn_sfs_angmom, wfn_sfs_edipmom, wfn_sos_angmomi, wfn_sos_angmomr, wfn_sos_dys, &
                    wfn_sos_edipmomi, wfn_sos_edipmomr, wfn_sos_spini, wfn_sos_spinr
use Cntrl, only: RhoDyn
#endif
use wigner_util, only: w3j
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Six, Nine, Ten, Half, Quart, OneHalf, Pi, cZero, auTocm, auToeV, auTofs, auTokJ, &
                     auToT, c_in_au, Debye, deg2rad, gElectron, kBoltzmann, mBohr, rNAVO
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: PROP(NSTATE,NSTATE,NPROP)
integer(kind=iwp), intent(in) :: NSS, JBNUM(NSTATE)
real(kind=wp), intent(in) :: USOR(NSS,NSS), USOI(NSS,NSS), ENSOR(NSS), OVLP(NSTATE,NSTATE), ENERGY(NSTATE), EigVec(NSTATE,NSTATE)
integer(kind=iwp) :: I, I2Tot, I_Have_DL, I_Have_DV, i_print, I_Print_Header, iAMFIx, iAMFIy, iAMFIz, iAMx, iAMy, iAMz, IBStep, &
                     IC, ICMP, IEND, iERR, IfAnyD, IfAnyM, IfAnyO, IfAnyQ, IfAnyS, iFinal, IFUNCT, iMLTPL, IPAM(3), IPAMFI(3), &
                     iPhi, iPhiStep, iPrDXY, iPrDXZ, iPrDYZ, iProp, ISO, iSOPr, ISS, ISTA, iStart, iState, IT, ITHE, ITStep, iVec, &
                     iXYZ, J, JC, JEND, JSS, JSTART, jState, jXYZ, K, KDGN, LMStep, MPLET, MPLET1, MPLET2, nCol, nMiss, NORIENT, &
                     nPhiStep, nTheStep, nVec, SECORD(4)
real(kind=wp) :: A, AFactor, AX, AY, AZ, B, BFinal, bPhiRes, Bx, By, Bz, c_1(3,3), c_2(3,3), Chi(3), COMPARE, CONTRIB, curit(3,3), &
                 D_MXI, D_MXR, D_MYI, D_MYR, D_MZI, D_MZR, D_XI, D_XR, D_YI, D_YR, D_ZI, D_ZR, DELTA, DLT_E, DLTT, DTENS(3,3), &
                 DTIJ, DX2, DXX2, DXXDYY, DXXDZZ, DXXXDX, DXXYDY, DXXZDZ, DXY2, DXYDZ, DXZ2, DXZDY, DY2, DysThr, DYXDZ, DYY2, &
                 DYYDZZ, DYYXDX, DYYYDY, DYYZDZ, DYZ2, DYZDX, DZ2, DZXDY, DZYDX, DZZ2, DZZXDX, DZZYDY, DZZZDZ, EDiff, EDIFF2, &
                 EDIFF3, EEX, EEY, EEZ, EVI(3), EVR(3), F, Fact, FACT0, FACTM, Factor, FACTP, FX, FXX, FXXFYY, FXXFZZ, FXXX, FXXY, &
                 FXXZ, FXY, FXZ, FY, FYX, FYY, FYYFZZ, FYYX, FYYY, FYYZ, FYZ, FZ, FZX, FZY, FZZ, FZZX, FZZY, FZZZ, G, GSEnergy, &
                 GSTENS(3,3), GTENS(3,3), GTij, GTOTAL(3,3), OSthr, OSThr2, p_Boltz, paramt(3,3), Phi, PLIMIT, PMAX, Q_XXI, Q_XXR, &
                 Q_XYI, Q_XYR, Q_XZI, Q_XZR, Q_YYI, Q_YYR, Q_YZI, Q_YZR, Q_ZZI, Q_ZZR, R, RKT, RMAGM(3), rMagMO, RPart, &
                 Rtensor(6), RXX, RXXY, RXXZ, RXY, RXYX, RXYY, RXYZ, RXZ, RXZX, RXZY, RXZZ, RYX, RYY, RYYX, RYYZ, RYZ, RYZX, RYZY, &
                 RYZZ, RZX, RZY, RZZ, RZZX, RZZY, S, S1, S2, SOSTERM(3,3), T, TFinal, THE, TMPm(NTS), TMPMAT(3,3), &
                 TMPVEC(3,3), Zstat
complex(kind=wp) :: T0(3), TM1
logical(kind=iwp) :: IFAMFI, IFANGM, IFDIP1
integer(kind=iwp), allocatable :: PMAP(:)
real(kind=wp), allocatable :: AMFIINT(:,:,:), ANGMOME(:,:,:), chicuriT_tens(:,:,:), chiparamT_tens(:,:,:), chiT_tens(:,:,:), &
                              DL(:,:), DV(:,:), DXI(:,:), DXR(:,:), DXXXI(:,:), DXXXR(:,:), DXXYI(:,:), DXXYR(:,:), DXXZI(:,:), &
                              DXXZR(:,:), DYI(:,:), DYR(:,:), DYYXI(:,:), DYYXR(:,:), DYYYI(:,:), DYYYR(:,:), DYYZI(:,:), &
                              DYYZR(:,:), DZI(:,:), DZR(:,:), DZZXI(:,:), DZZXR(:,:), DZZYI(:,:), DZZYR(:,:), DZZZI(:,:), &
                              DZZZR(:,:), EDIP1MOM(:,:,:), ESO(:), LXI(:,:), LYI(:,:), LZI(:,:), MAGM(:), MDXI(:,:), MDXR(:,:), &
                              MDYI(:,:), MDYR(:,:), MDZI(:,:), MDZR(:,:), MQXYI(:,:), MQXYR(:,:), MQXZI(:,:), MQXZR(:,:), &
                              MQYXI(:,:), MQYXR(:,:), MQYZI(:,:), MQYZR(:,:), MQZXI(:,:), MQZXR(:,:), MQZYI(:,:), MQZYR(:,:), &
                              MXYZI(:,:,:), MXYZR(:,:,:), QXXI(:,:), QXXR(:,:), QXYI(:,:), QXYR(:,:), QXZI(:,:), QXZR(:,:), &
                              QYYI(:,:), QYYR(:,:), QYZI(:,:), QYZR(:,:), QZZI(:,:), QZZR(:,:), SOPRI(:,:), SOPRR(:,:), SXI(:,:), &
                              SXR(:,:), SXYI(:,:), SXYR(:,:), SXZI(:,:), SXZR(:,:), SYI(:,:), SYR(:,:), SYXI(:,:), SYXR(:,:), &
                              SYZI(:,:), SYZR(:,:), SZI(:,:), SZR(:,:), SZXI(:,:), SZXR(:,:), SZYI(:,:), SZYR(:,:), TOT2K(:,:), &
                              UZR(:,:), UZI(:,:), ZI(:,:), ZR(:,:), ZXYZI(:,:,:), ZXYZR(:,:,:)
#ifdef _HDF5_
real(kind=wp), allocatable :: TMP(:,:,:)
#endif
complex(kind=wp), allocatable :: DIPSOm(:,:,:), DIPSOn(:,:,:), GCONT(:,:,:), SPNSFS(:,:,:), Z(:,:), ZEKL(:,:,:,:)
logical(kind=iwp), allocatable :: ISGS(:)
character, parameter :: xyzchr(3) = ['x','y','z']
real(kind=wp), parameter :: AU2J = auTokJ*1.0e3_wp, AU2JTM = (AU2J/auToT)*rNAVO, AU2REDR = 200.0_wp*Debye, &
                            BOLTZ = kBoltzmann/AU2J, BOLTZ_K = kBoltzmann*auTocm/AU2J, &
                            coeff_chi = 0.1_wp*rNAVO/kBoltzmann*mBohr**2, DLT = 1.0e-18_wp, FEGVAL = -gElectron, &
                            J2CM = auTocm/AU2J, ONEOVER10C = One/(Ten*c_in_au**2), ONEOVER30C = ONEOVER10C/Three, &
                            ONEOVER6C2 = One/(Six*c_in_au**2), ONEOVER9C2 = One/(Nine*c_in_au**2), Rmu0 = 4.0e-7_wp*Pi, &
                            THRSH = 1.0e-10_wp, Two3rds = Two/Three, TWOOVERM45C = -Two/(45.0_wp*c_in_au**2)

! D[XYZ][RI]           Dipole
! MD[XYZ][RI]          Magnetic-Dipole
! Q[XYZ][XYZ][RI]      Electric-Quadrupole
! MQ[XYZ][XYZ][RI]     Magnetic-Quadrupole
! D[XYZ][XYZ][XYZ][RI] Octupole
! S[XYZ][RI]           Spin-Magnetic-Dipole
! S[XYZ][XYZ][RI]      Spin-Magnetic-Quadrupole

if (IPGLOB > 0) then

  !*****************************************************
  ! printout of properties over the spin-free states
  !*****************************************************
  if (PRXVE .or. PRMEE) then
    write(u6,*)
    write(u6,*)
    write(u6,'(6X,A)') repeat('*',100)
    write(u6,'(6X,A,98X,A)') '*','*'
    write(u6,'(6X,A,34X,A,34X,A)') '*',' Spin-free properties section ','*'
    write(u6,'(6X,A,98X,A)') '*','*'
    write(u6,'(6X,A)') repeat('*',100)
    write(u6,*)
    write(u6,*)
  end if

  ! Did the user want printed expectation values?
  if (PRXVE) then
    call CollapseOutput(1,'Expectation values')
    write(u6,*)
    write(u6,*) ' ============================================'
    write(u6,*) '  EXPECTATION VALUES OF 1-ELECTRON OPERATORS'
    write(u6,*) '  FOR THE SPIN-FREE EIGENSTATES:'
    write(u6,*) ' ============================================'
    write(u6,*) ' (note: negative sign used for electronic multipoles)'
    write(u6,*)
    NCOL = 4
    do IPROP=1,NPROP
      if (IPUSED(IPROP) == 0) cycle

      ! Skip printing if all the diagonal values are very small
      !  (presumed zero for reasons of selection rules)
      PLIMIT = 1.0e-10_wp
      PMAX = ZERO

      do I=1,NSTATE
        PMAX = max(PMAX,abs(PROP(I,I,IPROP)+PNUC(IPROP)*OVLP(I,I)))
      end do
      if (PMAX < PLIMIT) cycle

      do ISTA=1,NSTATE,NCOL
        IEND = min(NSTATE,ISTA+NCOL-1)
        write(u6,*)
        write(u6,'(1X,A,A8,A,I4)') 'PROPERTY: ',PNAME(IPROP),'   COMPONENT:',ICOMP(IPROP)
        write(u6,'(1X,A,3(1X,ES16.9))') 'ORIGIN    :',(PORIG(I,IPROP),I=1,3)
        write(u6,'(1X,A,I8,4I17)') 'STATE     :',(I,I=ISTA,IEND)
        write(u6,*)
        write(u6,'(1X,A,4(1X,ES16.9))') 'ELECTRONIC:',(PROP(I,I,IPROP),I=ISTA,IEND)
        write(u6,'(1X,A,4(1X,ES16.9))') 'NUCLEAR   :',(PNUC(IPROP),I=ISTA,IEND)
        write(u6,'(1X,A,4(1X,ES16.9))') 'TOTAL     :',(PROP(I,I,IPROP)+PNUC(IPROP),I=ISTA,IEND)
        write(u6,*)
      end do
    end do
    call CollapseOutput(0,'Expectation values')
    write(u6,*)
  end if

  ! include nuclear contribution
  do IPROP=1,NPROP
    do I=1,NSTATE
      PROP(I,I,IPROP) = PROP(I,I,IPROP)+PNUC(IPROP)
    end do
  end do

  ! Did the user want printed matrix elements?
  if (PRMEE) then
    call CollapseOutput(1,'Matrix elements')
    write(u6,*)
    write(u6,*) ' ========================================='
    write(u6,*) '  MATRIX ELEMENTS OF 1-ELECTRON OPERATORS'
    write(u6,*) '  FOR THE SPIN-FREE EIGENSTATES:'
    write(u6,*) ' ========================================='
    write(u6,*) ' (including nuclear contrib.)'
    write(u6,*)
    write(u6,*) ' SELECTED PROPERTIES:'
    do I=1,NPROP,5
      write(u6,'(1X,5(A8,1X,I2,4X))') (PNAME(IPROP),ICOMP(IPROP),IPROP=I,min(NPROP,I+4))
    end do

    NCOL = 4
    do IPROP=1,NPROP
      if (IPUSED(IPROP) == 0) cycle
      write(u6,*)
      write(u6,'(1X,A,A8,A,I4)') 'PROPERTY: ',PNAME(IPROP),'   COMPONENT:',ICOMP(IPROP)
      write(u6,'(1X,A,3(1X,ES16.9))') 'ORIGIN: ',(PORIG(I,IPROP),I=1,3)
      do ISTA=1,NSTATE,NCOL
        IEND = min(NSTATE,ISTA+NCOL-1)
        write(u6,*)
        write(u6,'(1X,A,I8,3I17)') ' STATE   ',(I,I=ISTA,IEND)
        write(u6,*)
        do J=1,NSTATE
          write(u6,'(1X,I4,6X,4(1X,ES16.9))') J,(PROP(J,I,IPROP),I=ISTA,IEND)
        end do
      end do
    end do

    call CollapseOutput(0,'Matrix elements')
    write(u6,*)
  end if
  ! Added by Ungur Liviu on 04.11.2009.
  ! Addition of ANGMOM to Runfile.

  call mma_allocate(ANGMOME,3,NSTATE,NSTATE,Label='ANGMOME')
  call mma_allocate(EDIP1MOM,3,NSTATE,NSTATE,Label='EDIP1MOM')
  call mma_allocate(AMFIINT,3,NSTATE,NSTATE,Label='AMFIINT')

  IFANGM = .false.
  IFDIP1 = .false.
  IFAMFI = .false.
  ANGMOME(:,:,:) = Zero
  EDIP1MOM(:,:,:) = Zero
  AMFIINT(:,:,:) = Zero
  do IPROP=1,NPROP
    if (PNAME(IPROP)(1:6) == 'ANGMOM') then
      IFANGM = .true.
      ANGMOME(ICOMP(IPROP),:,:) = PROP(:,:,IPROP)
    end if
    ! add dipole moment integrals:
    if ((PNAME(IPROP) == 'MLTPL  1') .and. (PTYPE(IPROP) == 'HERMSING')) then
      IFDIP1 = .true.
      EDIP1MOM(ICOMP(IPROP),:,:) = PROP(:,:,IPROP)
    end if
    ! add spin-orbit AMFI integrals:
    if (PNAME(IPROP)(1:8) == 'AMFI    ') then
      IFAMFI = .true.
      AMFIINT(ICOMP(IPROP),:,:) = PROP(:,:,IPROP)
    end if
  end do
  if (IFANGM) call Put_dArray('ANGM_SINGLE',ANGMOME,3*NSTATE*NSTATE)
  if (IFDIP1) call Put_dArray('DIP1_SINGLE',EDIP1MOM,3*NSTATE*NSTATE)
  if (IFAMFI) call Put_dArray('AMFI_SINGLE',AMFIINT,3*NSTATE*NSTATE)
# ifdef _HDF5_
  call mma_allocate(TMP,NSTATE,NSTATE,3,Label='TMP')
  if (IFANGM) then
    do i=1,3
      TMP(:,:,i) = ANGMOME(i,:,:)
    end do
    call mh5_put_dset(wfn_sfs_angmom,TMP,[NSTATE,NSTATE,3],[0,0,0])
  end if
  if (IFDIP1) then
    do i=1,3
      TMP(:,:,i) = EDIP1MOM(i,:,:)
    end do
    call mh5_put_dset(wfn_sfs_edipmom,TMP,[NSTATE,NSTATE,3],[0,0,0])
  end if
  if (IFAMFI) then
    do i=1,3
      TMP(:,:,i) = AMFIINT(i,:,:)
    end do
    call mh5_put_dset(wfn_sfs_amfi,TMP,[NSTATE,NSTATE,3],[0,0,0])
  end if
  call mma_deallocate(TMP)
# endif
  call mma_deallocate(ANGMOME)
  call mma_deallocate(EDIP1MOM)
  call mma_deallocate(AMFIINT)
  !******************************************************
  ! printout of properties over the spin-orbit states
  !******************************************************
  ! If PRPR requested, print the spin matrices
# ifdef _HDF5_
  if (LPRPR .or. PRMES) then
# else
  if (LPRPR) then
# endif
    call mma_Allocate(SOPRR,NSS,NSS,Label='SOPRR')
    call mma_Allocate(SOPRI,NSS,NSS,Label='SOPRI')
    do ICMP=1,3
      SOPRR(:,:) = Zero
      SOPRI(:,:) = Zero
      if (ICMP == 2) then
        call SMMAT(PROP,SOPRI,NSS,0,ICMP)
      else
        call SMMAT(PROP,SOPRR,NSS,0,ICMP)
      end if
      call ZTRNSF(NSS,USOR,USOI,SOPRR,SOPRI)
#     ifdef _HDF5_
      call mh5_put_dset(wfn_sos_spinr,SOPRR,[NSS,NSS,1],[0,0,ICMP-1])
      call mh5_put_dset(wfn_sos_spini,SOPRI,[NSS,NSS,1],[0,0,ICMP-1])
#     endif
      if (LPRPR) call PRCMAT3(NSS,SOPRR,SOPRI,ICMP)
    end do
    call mma_deallocate(SOPRR)
    call mma_deallocate(SOPRI)
  end if

  if (IFSO .and. (NSOPR /= 0)) then

    if (PRMES) then
      ! match the SO property list to the SF property list
      call mma_allocate(PMAP,NSOPR,Label='PMap')
      NMISS = 0
      loop1: do ISOPR=1,NSOPR
        PMAP(ISOPR) = 0
        do IPROP=1,NPROP
          if ((PNAME(IPROP) == SOPRNM(ISOPR)) .and. (ICOMP(IPROP) == ISOCMP(ISOPR))) then
            PMAP(ISOPR) = IPROP
            cycle loop1
          end if
        end do
        NMISS = NMISS+1
      end do loop1

      ! check for inconsistencies
      if (NMISS > 0) then
        call WarningMessage(1,'Missing data integrals.')
        write(u6,*) 'WARNING: You have requested matrix elements'
        write(u6,*) 'over spin states of some operators. The present'
        write(u6,*) 'code uses matrix elements computed over spin-free'
        write(u6,*) 'states to compute those over spin states.'
        write(u6,*) 'Matrix elements of the following operator(s)'
        write(u6,*) 'were never computed and must be skipped.'
        write(u6,*) '   (If you need these properties, change the'
        write(u6,*) '    input to SEWARD and recompute.)'
        do ISOPR=1,NSOPR
          if (PMAP(ISOPR) == 0) write(u6,*) 'Property:',SOPRNM(ISOPR),'      Component:',ISOCMP(ISOPR)
        end do
        write(u6,*)
      end if
      write(u6,*)
      write(u6,*)
      write(u6,'(6X,A)') repeat('*',100)
      write(u6,'(6X,A,98X,A)') '*','*'
      write(u6,'(6X,A,34X,A,34X,A)') '*','Spin-orbit properties section ','*'
      write(u6,'(6X,A,98X,A)') '*','*'
      write(u6,'(6X,A)') repeat('*',100)
      write(u6,*)
      write(u6,*)

      call CollapseOutput(1,'Matrix elements over SO states')
      write(u6,*)
      write(u6,*) ' ========================================='
      write(u6,*) '  MATRIX ELEMENTS OF 1-ELECTRON OPERATORS'
      write(u6,*) '  FOR THE SPIN-ORBIT EIGENSTATES:'
      write(u6,*) ' ========================================='
      write(u6,*)
      write(u6,*) ' SELECTED PROPERTIES:'
      do I=1,NPROP,5
        write(u6,'(1X,5(A8,1X,I2,4X))') (SOPRNM(ISOPR),ISOCMP(ISOPR),ISOPR=I,min(NSOPR,I+4))
      end do

      ! Remove zeroes to make SOPRNM and ISOCMP lists contiguous. New NSOPR.
      ISOPR = 0
      do I=1,NSOPR
        IPROP = PMAP(I)
        if (IPROP > 0) then
          ISOPR = ISOPR+1
          SOPRNM(ISOPR) = SOPRNM(I)
          ISOCMP(ISOPR) = ISOCMP(I)
        end if
      end do
      call mma_deallocate(PMAP)
      NSOPR = ISOPR

      call mma_Allocate(SOPRR,NSS,NSS,Label='SOPRR')
      call mma_Allocate(SOPRI,NSS,NSS,Label='SOPRI')
      ! Print out the matrix elements:
      NCOL = 4
      do ISOPR=1,NSOPR
        write(u6,*)
        write(u6,'(1X,A,A8,A,I4)') 'PROPERTY: ',SOPRNM(ISOPR),'   COMPONENT:',ISOCMP(ISOPR)
        !IFG  should print the origin, but where is it stored (for SO properties)?
        SOPRR(:,:) = Zero
        SOPRI(:,:) = Zero

        call SMMAT(PROP,SOPRR,NSS,ISOPR,0)
        call ZTRNSF(NSS,USOR,USOI,SOPRR,SOPRI)
        call PRCMAT(NSS,SOPRR,SOPRI)
        ! prpr keyword: Print selected spin-orbit properties to ext. data files
        if (LPRPR .and. (SOPRNM(ISOPR)(1:5) == 'MLTPL')) then
          if (SOPRTP(ISOPR) == 'HERMSING') call PRCMAT2(ISOPR,NSS,SOPRR,SOPRI)
        else if (LPRPR .and. (SOPRNM(ISOPR)(1:6) == 'ANGMOM')) then
          if (SOPRTP(ISOPR) == 'ANTISING') call PRCMAT2(ISOPR,NSS,SOPRR,SOPRI)
        else if (LPRPR .and. (SOPRNM(ISOPR)(1:8) == 'VELOCITY')) then
          if (SOPRTP(ISOPR) == 'ANTISING') call PRCMAT2(ISOPR,NSS,SOPRR,SOPRI)
        else if (LPRPR .and. (SOPRNM(ISOPR)(1:5) == 'MLTPV')) then
          if (SOPRTP(ISOPR) == 'ANTISING') call PRCMAT2(ISOPR,NSS,SOPRR,SOPRI)
        end if
        ! prpr end

#       ifdef _HDF5_
        if (SOPRNM(ISOPR)(1:6) == 'ANGMOM') then
          call mh5_put_dset(wfn_sos_angmomr,SOPRR,[NSS,NSS,1],[0,0,ISOCMP(ISOPR)-1])
          call mh5_put_dset(wfn_sos_angmomi,SOPRI,[NSS,NSS,1],[0,0,ISOCMP(ISOPR)-1])
        end if

        if ((SOPRNM(ISOPR)(1:8) == 'MLTPL  1') .and. (SOPRTP(ISOPR) == 'HERMSING')) then
          call mh5_put_dset(wfn_sos_edipmomr,SOPRR,[NSS,NSS,1],[0,0,ISOCMP(ISOPR)-1])
          call mh5_put_dset(wfn_sos_edipmomi,SOPRI,[NSS,NSS,1],[0,0,ISOCMP(ISOPR)-1])
        end if
#       endif

      end do
      call mma_deallocate(SOPRR)
      call mma_deallocate(SOPRI)
      call CollapseOutput(0,'Matrix elements over SO states')
      write(u6,*)

    end if

  end if

end if

!*****************************************************
! printout of special properties
!*****************************************************

! AFACTOR = 2*pi*e^2*E_h^2 / eps_0*m_e*c^3*h^2
! numerically: 2/c^3 (in a.u. of time ^ -1)
AFACTOR = Two/c_in_au**3/(auTofs*1.0e-15_wp)

if (IPGLOB >= 2) then
  write(u6,*)
  write(u6,*)
  write(u6,'(6X,A)') repeat('*',100)
  write(u6,'(6X,A,98X,A)') '*','*'
  write(u6,'(6X,A,34X,A,34X,A)') '*','  Special properties section  ','*'
  write(u6,'(6X,A,98X,A)') '*','*'
  write(u6,'(6X,A)') repeat('*',100)
  write(u6,*)
  write(u6,*)
end if

if (IFSO) then
  ! Compute transition strengths for spin-orbit states:

  ! Initial setup for both dipole, quadrupole etc. and exact operator

  ! printing threshold
  !if (IPGLOB <= 2) then
  !  OSTHR = 1.0e-8_wp ! first order
  !  OSTHR2 = 1.0e-12_wp ! second order (weaker)
  !else
  !  OSTHR = Zero
  !  OSTHR2 = Zero
  !end if
  OSTHR = 1.0e-5_wp
  OSTHR2 = 1.0e-5_wp
  if (DIPR) OSTHR = OSTHR_DIPR
  if (DIPR) write(u6,30) 'Dipole printing threshold changed to ',OSTHR
  ! Again to avoid total negative transition strengths
  if (QIPR) then
    OSTHR = OSTHR_QIPR
    write(u6,49) 'Printing threshold changed to ',OSTHR,'since quadrupole threshold is given'
    OSTHR2 = OSTHR_QIPR
    write(u6,30) 'Quadrupole printing threshold changed to ',OSTHR2
  end if
  if (QIALL) write(u6,*) ' Will write all quadrupole contributions'

  ! Rotatory strength threshold
  if (RSPR) then
    write(u6,30) 'Rotatory strength printing threshold changed to ',RSTHR
  else
    RSTHR = 1.0e-7_wp !Default
  end if

  ! Reducing the loop over states - good for X-rays
  ! At the moment memory is not reduced

  JEND = NSS
  if (REDUCELOOP) then
    IEND = LOOPDIVIDE
    JSTART = LOOPDIVIDE+1
    if (LOOPMAX > 0) JEND = min(NSS,LOOPDIVIDE+LOOPMAX)
  else
    IEND = NSS
    JSTART = 1
  end if

  if (IPGLOB >= 1) then

    ! Initialize arrays for indentifying problematic transitions
    ! These stores all dipole oscillator strengths in
    ! length and velocity gauge for a later comparison.

    call mma_allocate(DL,NSS,NSS,Label='DL')
    call mma_allocate(DV,NSS,NSS,Label='DV')
    DL(:,:) = Zero
    DV(:,:) = Zero
    I_HAVE_DL = 0
    I_HAVE_DV = 0

    ! Electric-Dipole Electric-Dipole transitions

    if (Do_SK) then
      nVec = nk_Vector
    else
      nVec = 1
    end if

    call Allocate_and_Load_electric_dipoles(IFANYD)

    if (IFANYD /= 0) then

      do iVec=1,nVec

        i_Print = 0

        do ISS=1,IEND
          do JSS=JSTART,JEND
            EDIFF = ENSOR(JSS)-ENSOR(ISS)
            if (abs(EDIFF) <= 1.0e-8_wp) cycle
            if (EDIFF > Zero) then
              T0(1) = cmplx(DXR(JSS,ISS),DXI(JSS,ISS),kind=wp)
              T0(2) = cmplx(DYR(JSS,ISS),DYI(JSS,ISS),kind=wp)
              T0(3) = cmplx(DZR(JSS,ISS),DZI(JSS,ISS),kind=wp)
              if (Do_SK) then
                TM1 = k_vector(1,iVec)*T0(1)+k_vector(2,iVec)*T0(2)+k_vector(3,iVec)*T0(3)
                T0(1) = T0(1)-TM1*k_vector(1,iVec)
                T0(2) = T0(2)-TM1*k_vector(2,iVec)
                T0(3) = T0(3)-TM1*k_vector(3,iVec)
              end if
              DX2 = abs(conjg(T0(1))*T0(1))
              DY2 = abs(conjg(T0(2))*T0(2))
              DZ2 = abs(conjg(T0(3))*T0(3))
              FX = Two3rds*EDIFF*(DX2)
              FY = Two3rds*EDIFF*(DY2)
              FZ = Two3rds*EDIFF*(DZ2)
              F = FX+FY+FZ
              AX = (AFACTOR*EDIFF**2)*FX
              AY = (AFACTOR*EDIFF**2)*FY
              AZ = (AFACTOR*EDIFF**2)*FZ
              A = (AFACTOR*EDIFF**2)*F
              ! Store dipole oscillator strength
              DL(JSS,ISS) = F
              if (abs(F) >= OSTHR) then
                if (i_Print == 0) then
                  i_Print = 1

                  ! Print full COMPLEX transition dipole moment vectors?
                  ! J. Norell 7/5 2020
                  if (PRDIPCOM) then

                    call CollapseOutput(1,'Complex transition dipole vectors (SO states):')
                    write(u6,'(3X,A)') '----------------------------------------'
                    if (OSTHR > Zero) then
                      write(u6,30) '   for osc. strength at least ',OSTHR
                      write(u6,*)
                    end if
                    write(u6,*) '     From   To','       Re(Dx)       Im(Dx)','       Re(Dy)       Im(Dy)', &
                                '       Re(Dz)       Im(Dz)'
                    write(u6,32)
                  else
                    call CollapseOutput(1,'Dipole transition strengths (SO states):')
                    write(u6,'(3X,A)') '----------------------------------------'
                    if (OSTHR > Zero) then
                      write(u6,30) '   for osc. strength at least ',OSTHR
                      write(u6,*)
                    end if
                    if (Do_SK) then
                      write(u6,*)
                      write(u6,'(4x,a,3F10.6,a)') 'Direction of the k-vector: ',(k_vector(k,iVec),k=1,3),' (a.u.)'
                      write(u6,'(4x,a)') 'The light is assumed to be unpolarized.'
                      write(u6,*)
                    end if
                    write(u6,31) 'From','To','Osc. strength','Einstein coefficients Ax, Ay, Az (sec-1)   ','Total A (sec-1)'
                    write(u6,32)
                  end if
                  ! END print COMPLEX vectors
                end if

                ! Print full COMPLEX transition dipole moment vectors?
                if (PRDIPCOM) then
                  write(u6,'(5X,I5,I5,A,A,ES12.3,A,ES12.3,A,ES12.3,A,ES12.3,A,ES12.3,A,ES12.3)') ISS,JSS,'   ',' ',real(T0(1)), &
                                                                                                 ' ',aimag(T0(1)),' ', &
                                                                                                 real(T0(2)),' ',aimag(T0(2)),' ', &
                                                                                                 real(T0(3)),' ',aimag(T0(3))
                else
                  write(u6,33) ISS,JSS,F,AX,AY,AZ,A ! "Regular" print instead
                end if
                ! END print COMPLEX vectors

              end if
              call Add_Info('TMS(SO,Len)',[F],1,6)
              if (PRDIPCOM) call Add_Info('TVC(SO,Len)',[DX2+DY2+DZ2],1,6)

            end if
          end do
        end do

        if (i_Print == 1) then
          write(u6,32)
          call CollapseOutput(0,'Dipole transition strengths (SO states):')
          write(u6,*)
        end if

      end do ! iVec

      I_HAVE_DL = 1
    end if

    call Deallocate_electric_dipoles()

    ! Now the same in velocity representation

    if (Do_SK) then
      nVec = nk_Vector
    else
      nVec = 1
    end if

    call Allocate_and_Load_velocities(IFANYD)

    if (IFANYD /= 0) then

      do iVec=1,nVec

        i_Print = 0

        do ISS=1,IEND
          do JSS=JSTART,JEND
            EDIFF = ENSOR(JSS)-ENSOR(ISS)
            if (abs(EDIFF) <= 1.0e-8_wp) cycle
            if (EDIFF > Zero) then
              T0(1) = cmplx(DXR(JSS,ISS),DXI(JSS,ISS),kind=wp)
              T0(2) = cmplx(DYR(JSS,ISS),DYI(JSS,ISS),kind=wp)
              T0(3) = cmplx(DZR(JSS,ISS),DZI(JSS,ISS),kind=wp)
              if (Do_SK) then
                TM1 = k_vector(1,iVec)*T0(1)+k_vector(2,iVec)*T0(2)+k_vector(3,iVec)*T0(3)
                T0(1) = T0(1)-TM1*k_vector(1,iVec)
                T0(2) = T0(2)-TM1*k_vector(2,iVec)
                T0(3) = T0(3)-TM1*k_vector(3,iVec)
              end if
              DX2 = abs(conjg(T0(1))*T0(1))
              DY2 = abs(conjg(T0(2))*T0(2))
              DZ2 = abs(conjg(T0(3))*T0(3))
              FX = Two3rds*(DX2)/EDIFF
              FY = Two3rds*(DY2)/EDIFF
              FZ = Two3rds*(DZ2)/EDIFF
              F = FX+FY+FZ
              AX = (AFACTOR*EDIFF**2)*FX
              AY = (AFACTOR*EDIFF**2)*FY
              AZ = (AFACTOR*EDIFF**2)*FZ
              A = (AFACTOR*EDIFF**2)*F
              ! Store dipole oscillator strength
              DV(JSS,ISS) = F
              if (abs(F) >= OSTHR) then
                if (i_Print == 0) then
                  i_Print = 1
                  call CollapseOutput(1,'Velocity transition strengths (SO states):')
                  write(u6,'(3X,A)') '------------------------------------------'
                  if (OSTHR > Zero) then
                    write(u6,30) '   for osc. strength at least ',OSTHR
                    write(u6,*)
                  end if
                  if (Do_SK) then
                    write(u6,*)
                    write(u6,'(4x,a,3F10.6,a)') 'Direction of the k-vector: ',(k_vector(k,iVec),k=1,3),' (a.u.)'
                    write(u6,'(4x,a)') 'The light is assumed to be unpolarized.'
                    write(u6,*)
                  end if
                  write(u6,31) 'From','To','Osc. strength','Einstein coefficients Ax, Ay, Az (sec-1)   ','Total A (sec-1)'
                  write(u6,32)
                end if
                write(u6,33) ISS,JSS,F,AX,AY,AZ,A
              end if
              call Add_Info('TMS(SO,Vel)',[F],1,6)
            end if
          end do
        end do

        if (i_Print == 1) then
          write(u6,32)
          call CollapseOutput(0,'Velocity transition strengths (SO states):')
          write(u6,*)
        end if

      end do ! iVec

      I_HAVE_DV = 1
    end if

    call Deallocate_electric_dipoles()

    ! Compare oscillator strengths in length and velocity gauge
    ! All differences in oscillator strengths above the tolerance
    ! of 0.1 (10 percent) will be printed.

    if ((I_HAVE_DL == 1) .and. (I_HAVE_DV == 1)) then
      call CollapseOutput(1,'Length and velocity gauge comparison (SO states):')

      ! I guess that I have to explain it when I print a warning

      write(u6,*)
      write(u6,*) '--------------------------------------------------'
      write(u6,*) 'A comparison between the dipole oscillator strengths in'
      write(u6,*) 'length and velocity gauge will be performed'
      write(u6,*)
      write(u6,49) 'All dipole oscillator differences above the tolerance of ',TOLERANCE,' will be printed'
      write(u6,*)
      write(u6,*) 'Due to basis set deficiency these oscillator may be problematic'
      write(u6,*)
      write(u6,*) 'The tolerance is defined as ABS(1-O_l/O_v)'
      write(u6,*) 'O_l : dipole oscillator strength in length gauge'
      write(u6,*) 'O_p : dipole oscillator strength in velocity gauge'
      write(u6,*) '--------------------------------------------------'

      I_PRINT_HEADER = 0
      do I=1,IEND
        do J=JSTART,JEND
          EDIFF = ENSOR(J)-ENSOR(I)
          if (EDIFF < Zero) cycle
          COMPARE = Zero
          if ((DL(J,I) >= OSTHR+dlt) .and. (DV(J,I) >= OSTHR+dlt)) then
            COMPARE = abs(1-DL(J,I)/DV(J,I))
          else if ((DL(J,I) >= OSTHR+dlt) .and. (DL(J,I) > Zero)) then
            COMPARE = -OneHalf
          else if ((DV(J,I) >= OSTHR+dlt) .and. (DV(J,I) > Zero)) then
            COMPARE = -2.5_wp
          end if
          if (abs(COMPARE) >= TOLERANCE) then
            I_PRINT_HEADER = I_PRINT_HEADER+1
            if (I_PRINT_HEADER == 1) then
              write(u6,*)
              write(u6,*) ' Problematic transitions have been found'
              write(u6,*)
              write(u6,39) 'From','To','Difference (%)','Osc. st. (len.)','Osc. st. (vel.)'
              write(u6,40)
            end if
            if (COMPARE >= Zero) then
              write(u6,38) I,J,COMPARE*100.0_wp,DL(J,I),DV(J,I)
            else if (COMPARE >= -Two) then
              write(u6,36) I,J,DL(J,I),'below threshold'
            else
              write(u6,37) I,J,'below threshold',DV(J,I)
            end if
          end if
        end do
      end do
      if (I_PRINT_HEADER == 0) then
        write(u6,*)
        write(u6,*) 'No problematic oscillator strengths above the tolerance ',TOLERANCE,' have been found'
        write(u6,*)
      else
        write(u6,40)
        write(u6,*)
        write(u6,*) 'Number of problematic transitions = ',I_PRINT_HEADER
        write(u6,*)
      end if
      call CollapseOutput(0,'Length and velocity gauge comparison (SO states):')
      write(u6,*)
    end if

    ! Free the memory

    call mma_deallocate(DL)
    call mma_deallocate(DV)

    ! We will first allocate a matrix for the total of the second order wave vector

    call mma_allocate(TOT2K,NSS,NSS,Label='TOT2K')
    TOT2K(:,:) = Zero

    ! Checking if all are in
    SECORD = 0

    ! Magnetic-Dipole - Magnetic-Dipole transitions and
    ! Spin-Magnetic-Dipole - Spin-Magnetic-Dipole transitions

    ! I will not separate these for SO states since there would then be
    ! M^2 + Ms^2 + 2*MMs (three terms to be programmed)
    ! M^2 and Ms^2 can be calculated separately but the cross term not directly

    ! Magnetic-Dipole
    call Allocate_and_Load_Magnetic_Dipoles(IFANYM)
    ! Spin-Magnetic-Dipole ---- notice the S
    call Allocate_and_Load_Spin_Magnetic_dipoles(IFANYS)

    if ((IFANYM /= 0) .or. (IFANYS /= 0)) then

      ! Only print the part calculated

      if (QIALL) then
        if ((IFANYM /= 0) .and. (IFANYS /= 0)) then
          call CollapseOutput(1,'Magnetic-dipole - magnetic-dipole and spin-magnetic-dipole - spin-magnetic-dipole transition '// &
                              'strengths (SO states):')
          write(u6,'(3X,A)') '---------------------------------------------------------------------------------------------'// &
                             '----------------------'
        else if ((IFANYM /= 0) .and. (IFANYS == 0)) then
          call CollapseOutput(1,'Magnetic-dipole - magnetic-dipole transition strengths (SO states):')
          write(u6,'(3X,A)') '-------------------------------------------------------------------'
        else if ((IFANYM == 0) .and. (IFANYS /= 0)) then
          call CollapseOutput(1,'Spin-magnetic-dipole - spin-magnetic-dipole transition strengths (SO states):')
          write(u6,'(3X,A)') '-----------------------------------------------------------------------------'
        end if
        if (OSTHR2 > Zero) then
          write(u6,30) '   for osc. strength at least ',OSTHR2
          write(u6,*)
        end if
        write(u6,31) 'From','To','Osc. strength'
        write(u6,35)
      end if

      ! Magnetic-Dipole

      ! Spin-Magnetic-Dipole

      g = FEGVAL
      do ISS=1,IEND
        do JSS=JSTART,NSS
          EDIFF = ENSOR(JSS)-ENSOR(ISS)
          if (abs(EDIFF) < 1.0e-8_wp) cycle
          if (EDIFF > Zero) then

            DX2 = (MDXI(JSS,ISS)+g*SXR(JSS,ISS))**2+(MDXR(JSS,ISS)-g*SXI(JSS,ISS))**2
            DY2 = (MDYI(JSS,ISS)+g*SYR(JSS,ISS))**2+(MDYR(JSS,ISS)-g*SYI(JSS,ISS))**2
            DZ2 = (MDZI(JSS,ISS)+g*SZR(JSS,ISS))**2+(MDZR(JSS,ISS)-g*SZI(JSS,ISS))**2

            F = (DX2+DY2+DZ2)*EDIFF*ONEOVER6C2
            ! Add it to the total
            TOT2K(JSS,ISS) = TOT2K(JSS,ISS)+F
            if (abs(F) >= OSTHR2) then
              if (QIALL) write(u6,33) ISS,JSS,F
            end if
          end if
        end do
      end do

      if (QIALL) then
        write(u6,35)
        if ((IFANYM /= 0) .and. (IFANYS /= 0)) then
          call CollapseOutput(0,'Magnetic-dipole - magnetic-dipole and spin-magnetic-dipole - spin-magnetic-dipole transition '// &
                              'strengths (SO states):')
          write(u6,*)
        else if ((IFANYM /= 0) .and. (IFANYS == 0)) then
          call CollapseOutput(0,'Magnetic-dipole - magnetic-dipole transition strengths (SO states):')
          write(u6,*)
        else if ((IFANYM == 0) .and. (IFANYS /= 0)) then
          call CollapseOutput(0,'Spin-magnetic-dipole - Spin-magnetic-dipole transition strengths (SO states):')
          write(u6,*)
        end if
      end if
      SECORD(1) = 1
    end if

    ! Magnetic-Dipole
    call Deallocate_Magnetic_dipoles()

    ! Spin-Magnetic-Dipole
    call Deallocate_Spin_Magnetic_dipoles()

    ! Electric-Quadrupole Electric-Quadrupole transitions

    call Allocate_and_Load_Electric_Quadrupoles(IFANYQ)

    if (IFANYQ /= 0) then
      if (QIALL) then
        call CollapseOutput(1,'Quadrupole transition strengths (SO states):')
        write(u6,'(3X,A)') '--------------------------------------------'
        if (OSTHR2 > Zero) then
          write(u6,30) '   for osc. strength at least ',OSTHR2
          write(u6,*)
        end if
        write(u6,31) 'From','To','Osc. strength'
        write(u6,35)
      end if

      do ISS=1,IEND
        do JSS=JSTART,NSS
          EDIFF = ENSOR(JSS)-ENSOR(ISS)
          if (abs(EDIFF) < 1.0e-8_wp) cycle
          if (EDIFF > Zero) then

            ! D should be purely real since D is a real symmetric matrix

            EDIFF3 = EDIFF**3

            DXX2 = QXXR(JSS,ISS)**2+QXXI(JSS,ISS)**2
            DYY2 = QYYR(JSS,ISS)**2+QYYI(JSS,ISS)**2
            DZZ2 = QZZR(JSS,ISS)**2+QZZI(JSS,ISS)**2
            FXX = ONEOVER30C*EDIFF3*(DXX2)
            FYY = ONEOVER30C*EDIFF3*(DYY2)
            FZZ = ONEOVER30C*EDIFF3*(DZZ2)

            DXY2 = QXYR(JSS,ISS)**2+QXYI(JSS,ISS)**2
            DXZ2 = QXZR(JSS,ISS)**2+QXZI(JSS,ISS)**2
            DYZ2 = QYZR(JSS,ISS)**2+QYZI(JSS,ISS)**2
            FXY = ONEOVER10C*EDIFF3*(DXY2)
            FXZ = ONEOVER10C*EDIFF3*(DXZ2)
            FYZ = ONEOVER10C*EDIFF3*(DYZ2)

            DXXDYY = QXXR(JSS,ISS)*QYYR(JSS,ISS)+QXXI(JSS,ISS)*QYYI(JSS,ISS)
            DXXDZZ = QXXR(JSS,ISS)*QZZR(JSS,ISS)+QXXI(JSS,ISS)*QZZI(JSS,ISS)
            DYYDZZ = QYYR(JSS,ISS)*QZZR(JSS,ISS)+QYYI(JSS,ISS)*QZZI(JSS,ISS)
            FXXFYY = -ONEOVER30C*EDIFF3*(DXXDYY)
            FXXFZZ = -ONEOVER30C*EDIFF3*(DXXDZZ)
            FYYFZZ = -ONEOVER30C*EDIFF3*(DYYDZZ)

            F = FXX+FXY+FXZ+FYY+FYZ+FZZ+FXXFYY+FXXFZZ+FYYFZZ
            ! Add it to the total
            TOT2K(JSS,ISS) = TOT2K(JSS,ISS)+F

            if (abs(F) >= OSTHR2) then
              if (QIALL) write(u6,33) ISS,JSS,F
            end if
          end if
        end do
      end do

      if (QIALL) then
        write(u6,35)
        call CollapseOutput(0,'Quadrupole transition strengths (SO states):')
        write(u6,*)
      end if
      SECORD(2) = 1
    end if

    call Deallocate_Electric_Quadrupoles()

    ! Electric-Dipole Electric-Octupole transitions

    ! Octupole
    call Allocate_and_Load_Octupoles(IFANYO)
    ! Dipole
    call Allocate_and_Load_electric_dipoles(IFANYD)

    if ((IFANYD /= 0) .and. (IFANYO /= 0)) then
      if (QIALL) then
        call CollapseOutput(1,'Electric-dipole - electric-octupole transition strengths (SO states):')
        write(u6,'(3X,A)') '---------------------------------------------------------------------'
        if (OSTHR2 > Zero) then
          write(u6,30) '   for osc. strength at least ',OSTHR2
          write(u6,*)
        end if
        write(u6,31) 'From','To','Osc. strength'
        write(u6,35)
      end if

      do ISS=1,IEND
        do JSS=JSTART,NSS
          EDIFF = ENSOR(JSS)-ENSOR(ISS)
          if (abs(EDIFF) < 1.0e-8_wp) cycle
          if (EDIFF > Zero) then

            EDIFF3 = EDIFF**3

            DXXXDX = DXXXR(JSS,ISS)*DXR(JSS,ISS)+DXXXI(JSS,ISS)*DXI(JSS,ISS)
            DYYXDX = DYYXR(JSS,ISS)*DXR(JSS,ISS)+DYYXI(JSS,ISS)*DXI(JSS,ISS)
            DZZXDX = DZZXR(JSS,ISS)*DXR(JSS,ISS)+DZZXI(JSS,ISS)*DXI(JSS,ISS)
            FXXX = TWOOVERM45C*EDIFF3*(DXXXDX)
            FYYX = TWOOVERM45C*EDIFF3*(DYYXDX)
            FZZX = TWOOVERM45C*EDIFF3*(DZZXDX)

            DXXYDY = DXXYR(JSS,ISS)*DYR(JSS,ISS)+DXXYI(JSS,ISS)*DYI(JSS,ISS)
            DYYYDY = DYYYR(JSS,ISS)*DYR(JSS,ISS)+DYYYI(JSS,ISS)*DYI(JSS,ISS)
            DZZYDY = DZZYR(JSS,ISS)*DYR(JSS,ISS)+DZZYI(JSS,ISS)*DYI(JSS,ISS)
            FXXY = TWOOVERM45C*EDIFF3*(DXXYDY)
            FYYY = TWOOVERM45C*EDIFF3*(DYYYDY)
            FZZY = TWOOVERM45C*EDIFF3*(DZZYDY)

            DXXZDZ = DXXZR(JSS,ISS)*DZR(JSS,ISS)+DXXZI(JSS,ISS)*DZI(JSS,ISS)
            DYYZDZ = DYYZR(JSS,ISS)*DZR(JSS,ISS)+DYYZI(JSS,ISS)*DZI(JSS,ISS)
            DZZZDZ = DZZZR(JSS,ISS)*DZR(JSS,ISS)+DZZZI(JSS,ISS)*DZI(JSS,ISS)
            FXXZ = TWOOVERM45C*EDIFF3*(DXXZDZ)
            FYYZ = TWOOVERM45C*EDIFF3*(DYYZDZ)
            FZZZ = TWOOVERM45C*EDIFF3*(DZZZDZ)

            F = FXXX+FYYX+FZZX+FXXY+FYYY+FZZY+FXXZ+FYYZ+FZZZ
            ! Add it to the total
            TOT2K(JSS,ISS) = TOT2K(JSS,ISS)+F

            if (abs(F) >= OSTHR2) then
              if (QIALL) write(u6,33) ISS,JSS,F
            end if
          end if
        end do
      end do

      if (QIALL) then
        write(u6,35)
        call CollapseOutput(0,'Electric-dipole - electric-octupole transition strengths (SO states):')
        write(u6,*)
      end if
      SECORD(3) = 1
    end if

    call Deallocate_Octupoles()

    call Deallocate_electric_dipoles()

    ! Electric-Dipole - Magnetic-Quadrupole transitions and
    ! Electric-Dipole - Spin-Magnetic-Quadrupole transitions

    ! Again I will just include the spin-term so both terms are calculated
    ! (Can also be done separately)
    ! DM + DMs

    ! Magnetic-Quadrupole
    ! Spin-Magnetic-Quadrupole
    ! Spin-Magnetic-Quadrupole = M^s_ab = r_b * s_a

    ! Electric-Dipole
    call Allocate_and_Load_electric_dipoles(IFANYD)
    if (IFANYD /= 0) then
      ! Magnetic-Quadrupole
      call Allocate_and_Load_Magnetic_Quadrupoles(IFANYD)
      ! Spin-Magnetic-Quadrupole
      call Allocate_and_Load_Spin_Magnetic_Quadrupoles(IFANYS)

      if ((IFANYD /= 0) .or. (IFANYS /= 0)) then
        if (QIALL) then
          if ((IFANYD /= 0) .and. (IFANYS /= 0)) then
            call CollapseOutput(1,'Electric-dipole - magnetic-quadrupole and electric-dipole - spin-magnetic-quadrupole '// &
                                'transition strengths (SO states):')
            write(u6,'(3X,A)') '-------------------------------------------------------------------------------------'// &
                               '---------------------------------'
          else if ((IFANYD /= 0) .and. (IFANYS == 0)) then
            call CollapseOutput(1,'Electric-dipole - magnetic-quadrupole transition strengths (SO states):')
            write(u6,'(3X,A)') '-----------------------------------------------------------------------'
          else if ((IFANYD == 0) .and. (IFANYS /= 0)) then
            call CollapseOutput(1,'Electric-dipole - spin-magnetic-quadrupole transition strengths (SO states):')
            write(u6,'(3X,A)') '----------------------------------------------------------------------------'
          end if

          if (OSTHR2 > Zero) then
            write(u6,30) '   for osc. strength at least ',OSTHR2
            write(u6,*)
          end if
          write(u6,31) 'From','To','Osc. strength'
          write(u6,35)
        end if

        g = FEGVAL*Three/Two ! To remove the 2/3 factor in ONEOVER9C2
        g = g*Two ! Seem to be needed to agree with the exact term,
        ! needs to be looked further into!
        do ISS=1,IEND
          do JSS=JSTART,NSS
            EDIFF = ENSOR(JSS)-ENSOR(ISS)
            if (abs(EDIFF) < 1.0e-8_wp) cycle
            if (EDIFF > Zero) then

              EDIFF2 = EDIFF**2

              ! Since the Spin-Magnetic-Quadrupole is made from the multiplication of two complex integrals we have
              ! M^s = (a+ib)(c+id) = ac-bd + i(ad+bc) hence the long expressions below
              ! Also, since the magnetic quadrupole terms are real and the electric dipole are imaginary
              ! we multiply the real components of MQ with the imaginary of the dipole term, and vice versa.
              ! However, the spin y component is imaginary

              ! Magnetic-Quadrupole   Spin-Magnetic-Quadrupole
              ! Electric-Dipole
              DXYDZ = -((MQXYI(JSS,ISS)+g*SXYI(JSS,ISS))*DZI(JSS,ISS))+((MQXYR(JSS,ISS)+g*SXYR(JSS,ISS))*DZR(JSS,ISS))
              DYXDZ = -((MQYXI(JSS,ISS)+g*SYXR(JSS,ISS))*DZI(JSS,ISS))+((MQYXR(JSS,ISS)+g*SYXI(JSS,ISS))*DZR(JSS,ISS))
              FXY = ONEOVER9C2*EDIFF2*(DXYDZ)
              FYX = -ONEOVER9C2*EDIFF2*(DYXDZ)

              DZXDY = -((MQZXI(JSS,ISS)+g*SZXR(JSS,ISS))*DYI(JSS,ISS))+((MQZXR(JSS,ISS)+g*SZXI(JSS,ISS))*DYR(JSS,ISS))
              DXZDY = -((MQXZI(JSS,ISS)+g*SXZR(JSS,ISS))*DYI(JSS,ISS))+((MQXZR(JSS,ISS)+g*SXZI(JSS,ISS))*DYR(JSS,ISS))
              FZX = ONEOVER9C2*EDIFF2*(DZXDY)
              FXZ = -ONEOVER9C2*EDIFF2*(DXZDY)

              DYZDX = -((MQYZI(JSS,ISS)+g*SYZR(JSS,ISS))*DXI(JSS,ISS))+((MQYZR(JSS,ISS)+g*SYZI(JSS,ISS))*DXR(JSS,ISS))
              DZYDX = -((MQZYI(JSS,ISS)+g*SZYI(JSS,ISS))*DXI(JSS,ISS))+((MQZYR(JSS,ISS)+g*SZYR(JSS,ISS))*DXR(JSS,ISS))
              FYZ = ONEOVER9C2*EDIFF2*(DYZDX)
              FZY = -ONEOVER9C2*EDIFF2*(DZYDX)

              F = FYX+FXY+FZX+FXZ+FYZ+FZY
              ! Add it to the total
              TOT2K(JSS,ISS) = TOT2K(JSS,ISS)+F

              if (abs(F) >= OSTHR2) then
                if (QIALL) write(u6,33) ISS,JSS,F
              end if
            end if
          end do
        end do

        if (QIALL) then
          write(u6,35)
          if ((IFANYD /= 0) .and. (IFANYS /= 0)) then
            call CollapseOutput(0,'Electric-dipole - magnetic-quadrupole and electric-dipole - spin-magnetic-quadrupole '// &
                                'transition strengths (SO states):')
            write(u6,*)
          else if ((IFANYD /= 0) .and. (IFANYS == 0)) then
            call CollapseOutput(0,'Electric-dipole - magnetic-quadrupole transition strengths (SO states):')
            write(u6,*)
          else if ((IFANYD == 0) .and. (IFANYS /= 0)) then
            call CollapseOutput(0,'Electric-dipole - spin-magnetic-quadrupole transition strengths (SO states):')
            write(u6,*)
          end if
        end if
        SECORD(4) = 1
      end if

      ! Magnetic-Quadrupole
      call Deallocate_Magnetic_Quadrupoles()
      ! Spin-Magnetic-Quadrupole
      call Deallocate_Spin_Magnetic_Quadrupoles()
    end if
    ! Electric-Dipole
    call Deallocate_electric_dipoles()

    ! Now write out the total

    ! Add it to the total

    I2TOT = 0
    do I=1,4
      if (SECORD(I) == 1) I2TOT = I2TOT+1
    end do
    if (I2TOT >= 1) then
      if (SECORD(1) == 0) write(u6,*) 'Magnetic-dipole - magnetic-dipole not included'
      if (SECORD(2) == 0) write(u6,*) 'Electric-quadrupole - electric-quadrupole not included'
      if (SECORD(3) == 0) write(u6,*) 'Electric-dipole - electric-octupole not included'
      if (SECORD(4) == 0) write(u6,*) 'Electric-dipole - magnetic-quadrupole not included'
      i_Print = 0
      do ISS=1,IEND
        do JSS=JSTART,JEND
          EDIFF = ENSOR(JSS)-ENSOR(ISS)
          if (abs(EDIFF) < 1.0e-8_wp) cycle
          if (EDIFF > Zero) then

            F = TOT2K(JSS,ISS)
            if (abs(F) >= OSTHR2) then
              if (i_Print == 0) then
                i_Print = 1
                call CollapseOutput(1,'Second-order contribution to the transition strengths (SO states):')
                write(u6,'(3X,A)') '------------------------------------------------------------------'

                if (OSTHR2 > Zero) then
                  write(u6,30) '   for osc. strength at least ',OSTHR2
                  write(u6,*)
                end if
                write(u6,31) 'From','To','Osc. strength'
                write(u6,35)
              end if
              write(u6,33) ISS,JSS,F
              call Add_Info('TMS(SO,2nd)',[F],1,6)
            end if
          end if
        end do
      end do
      if (i_Print == 1) then
        write(u6,35)
        call CollapseOutput(0,'Second-order contribution to the transition strengths (SO states):')
        write(u6,*)
      end if
    end if
    ! release the memory again
    call mma_deallocate(TOT2K)

  end if

  if (DOCD) then
    ! Lasse 2019
    ! New CD here with electric dipole and magnetic-dipole - velocity gauge

    ! Electric dipole (linear momentum, p)
    call Allocate_and_Load_velocities(IFANYD)

    ! Magnetic-Dipole (angular momentum, l = r x p)
    call Allocate_and_Load_Magnetic_Dipoles(IFANYM)

    if ((IFANYD /= 0) .and. (IFANYM /= 0)) then

      ! Spin-Magnetic-Dipole
      call Allocate_and_Load_Spin_Magnetic_Dipoles(IFANYS)

      ! Electric quadrupole (r:p+p:r)

      call Allocate_and_Load_Electric_Quadrupoles(IFANYQ)

      ! Only print the part calculated

      write(u6,*)
      call CollapseOutput(1,'Circular Dichroism - velocity gauge Electric-Dipole - Magnetic-Dipole rotatory strengths (SO states):')
      write(u6,'(3X,A)') '-----------------------------------------------------------------------------------------------------'
      if (DO_SK) then
        write(u6,30) 'For red. rot. strength at least',RSTHR
      else
        write(u6,30) 'For isotropic red. rot. strength at least',RSTHR
      end if
      write(u6,*)

      if (Do_SK .and. (IFANYQ /= 0)) then
        nVec = nk_Vector
      else
        nVec = 1
      end if

      do iVec=1,nVec

        if (Do_SK .and. (IFANYQ /= 0)) then
          write(u6,*)
          write(u6,'(4x,a,3F10.6)') 'Direction of the k-vector: ',(k_vector(k,iVec),k=1,3)
          write(u6,*)
          write(u6,31) 'From','To','Red. rot. str.'
        else
          write(u6,31) 'From','To','Red. rot. str.'
          if (IFANYQ /= 0) write(u6,44) 'Rxx','Rxy','Rxz','Ryy','Ryz','Rzz'
        end if
        write(u6,35)

        g = FEGVAL
        do ISS=1,IEND
          do JSS=JSTART,JEND
            EDIFF = ENSOR(JSS)-ENSOR(ISS)
            if (abs(EDIFF) < 1.0e-8_wp) cycle
            if (EDIFF > Zero) then

              ! These are all complex quantities, and their products are complex too,
              ! but eventually every piece will be:
              !   <I|a|J> <J|b|I> + <I|b|J> <J|b|I>
              ! for a and b Hermitian operators, so it will be reduced to:
              !   2*(Re(A_ij)*Re(B_ij)+Im(A_ij)*Im(B_ij))
              ! and the imaginary parts of the products can be ignored.

              ! Note p = -i*hbar*nabla
              D_XR = DXI(JSS,ISS)
              D_YR = DYI(JSS,ISS)
              D_ZR = DZI(JSS,ISS)
              D_XI = -DXR(JSS,ISS)
              D_YI = -DYR(JSS,ISS)
              D_ZI = -DZR(JSS,ISS)
              ! Note r x p = -i*hbar * (r x nabla)
              D_MXR = MDXI(JSS,ISS)+g*SXR(JSS,ISS)
              D_MYR = MDYI(JSS,ISS)+g*SYR(JSS,ISS)
              D_MZR = MDZI(JSS,ISS)+g*SZR(JSS,ISS)
              D_MXI = -MDXR(JSS,ISS)+g*SXI(JSS,ISS)
              D_MYI = -MDYR(JSS,ISS)+g*SYI(JSS,ISS)
              D_MZI = -MDZR(JSS,ISS)+g*SZI(JSS,ISS)

              ! R = 1/3 tr(Rtensor)
              RXX = D_XR*D_MXR+D_XI*D_MXI
              RYY = D_YR*D_MYR+D_YI*D_MYI
              RZZ = D_ZR*D_MZR+D_ZI*D_MZI
              if (abs(EDIFF) > 1.0e-8_wp) then
                R = Half/EDIFF*AU2REDR*(RXX+RYY+RZZ)
              else
                R = ZERO
              end if
              write(u6,43) '1/3 Tr(RTensor): ',R

              ! Compute full rotatory strength tensor
              ! (see Hansen and Bak, 10.1021/jp001899+)

              if (IFANYQ /= 0) then
                ! Note r:p+p:r = -i*hbar * (r:nabla+nabla:r)
                Q_XXR = QXXI(JSS,ISS)
                Q_XYR = QXYI(JSS,ISS)
                Q_XZR = QXZI(JSS,ISS)
                Q_YYR = QYYI(JSS,ISS)
                Q_YZR = QYZI(JSS,ISS)
                Q_ZZR = QZZI(JSS,ISS)
                Q_XXI = -QXXR(JSS,ISS)
                Q_XYI = -QXYR(JSS,ISS)
                Q_XZI = -QXZR(JSS,ISS)
                Q_YYI = -QYYR(JSS,ISS)
                Q_YZI = -QYZR(JSS,ISS)
                Q_ZZI = -QZZR(JSS,ISS)
                RXY = D_XR*D_MYR+D_XI*D_MYI
                RXZ = D_XR*D_MZR+D_XI*D_MZI
                RYX = D_YR*D_MXR+D_YI*D_MXI
                RYZ = D_YR*D_MZR+D_YI*D_MZI
                RZX = D_ZR*D_MXR+D_ZI*D_MXI
                RZY = D_ZR*D_MYR+D_ZI*D_MYI
                RXXY = Q_XXR*D_YR+Q_XXI*D_YI
                RXXZ = Q_XXR*D_ZR+Q_XXI*D_ZI
                RXYX = Q_XYR*D_XR+Q_XYI*D_XI
                RXYZ = Q_XYR*D_ZR+Q_XYI*D_ZI
                RXZX = Q_XZR*D_XR+Q_XZI*D_XI
                RXZY = Q_XZR*D_YR+Q_XZI*D_YI
                RXYY = Q_XYR*D_YR+Q_XYI*D_YI
                RYYX = Q_YYR*D_XR+Q_YYI*D_XI
                RYYZ = Q_YYR*D_ZR+Q_YYI*D_ZI
                RYZX = Q_YZR*D_XR+Q_YZI*D_XI
                RYZY = Q_YZR*D_YR+Q_YZI*D_YI
                RXZZ = Q_XZR*D_ZR+Q_XZI*D_ZI
                RYZZ = Q_YZR*D_ZR+Q_YZI*D_ZI
                RZZX = Q_ZZR*D_XR+Q_ZZI*D_XI
                RZZY = Q_ZZR*D_YR+Q_ZZI*D_YI
                ! xx, xy, xz, yy, yz, zz
                Rtensor(1) = 0.75_wp*(RYY+RZZ+(RXYZ-RXZY))
                Rtensor(2) = -0.375_wp*(RXY+RYX+(RXXZ+RYZY-RXZX-RYYZ))
                Rtensor(3) = -0.375_wp*(RXZ+RZX+(RXYX+RZZY-RXXY-RYZZ))
                Rtensor(4) = 0.75_wp*(RXX+RZZ+(RYZX-RXYZ))
                Rtensor(5) = -0.375_wp*(RYZ+RZY+(RYYX+RXZZ-RXYY-RZZX))
                Rtensor(6) = 0.75_wp*(RXX+RYY+(RXZY-RYZX))
                if (abs(EDIFF) > 1.0e-8_wp) then
                  Rtensor(:) = AU2REDR/EDIFF*Rtensor(:)
                else
                  Rtensor(:) = Zero
                end if
                if (Do_SK) then
                  ! k^T R k
                  R = k_vector(1,iVec)**2*Rtensor(1)+k_vector(2,iVec)**2*Rtensor(4)+k_vector(3,iVec)**2*Rtensor(6)+ &
                      Two*k_vector(1,iVec)*k_vector(2,iVec)*Rtensor(2)+Two*k_vector(1,iVec)*k_vector(3,iVec)*Rtensor(3)+ &
                      Two*k_vector(2,iVec)*k_vector(3,iVec)*Rtensor(5)
                else
                  write(u6,43) 'tensor: ',Rtensor(:)
                end if
              end if

              if (abs(R) > RSTHR) write(u6,33) ISS,JSS,R

              call Add_Info('CD_V(SO)',[R],1,6)
            end if
          end do
        end do

        write(u6,35)
      end do

      call Deallocate_Spin_Magnetic_Dipoles()

      call Deallocate_Electric_Quadrupoles()

      call CollapseOutput(0,'Circular Dichroism - velocity gauge Electric-Dipole - Magnetic-Dipole rotatory strengths (SO states):')
    end if

    call Deallocate_electric_dipoles()

    call Deallocate_magnetic_dipoles()

    ! Lasse 2019
    ! New CD here with electric dipole and magnetic-dipole - mixed gauge

    ! Electric dipole (r)
    call Allocate_and_Load_electric_dipoles(IFANYD)
    ! Magnetic-Dipole (angular momentum, l = r x p)
    call Allocate_and_Load_Magnetic_dipoles(IFANYM)

    if ((IFANYD /= 0) .and. (IFANYM /= 0)) then

      ! Spin-Magnetic-Dipole
      call Allocate_and_Load_Spin_Magnetic_Dipoles(IFANYS)

      ! Electric quadrupole (r:r)
      call Allocate_and_Load_Electric_Quadrupoles(IFANYQ)

      ! Only print the part calculated

      write(u6,*)
      call CollapseOutput(1,'Circular Dichroism - mixed gauge Electric-Dipole - Magnetic-Dipole rotatory strengths (SO states):')
      write(u6,'(3X,A)') '--------------------------------------------------------------------------------------------------'
      write(u6,*)
      write(u6,*) ' WARNING WARNING WARNING !!!'
      write(u6,*)
      write(u6,*) ' Circular Dichroism in the mixed gauge'
      write(u6,*) ' is NOT origin independent - check your results'
      if (DO_SK) then
        write(u6,30) 'For red. rot. strength at least',RSTHR
      else
        write(u6,30) 'For isotropic red. rot. strength at least',RSTHR
      end if
      write(u6,*)

      if (Do_SK .and. (IFANYQ /= 0)) then
        nVec = nk_Vector
      else
        nVec = 1
      end if

      do iVec=1,nVec

        if (Do_SK .and. (IFANYQ /= 0)) then
          write(u6,*)
          write(u6,'(4x,a,3F10.6)') 'Direction of the k-vector: ',(k_vector(k,iVec),k=1,3)
          write(u6,*)
          write(u6,31) 'From','To','Red. rot. str.'
        else
          write(u6,31) 'From','To','Red. rot. str.'
          if (IFANYQ /= 0) write(u6,44) 'Rxx','Rxy','Rxz','Ryy','Ryz','Rzz'
        end if
        write(u6,35)

        g = FEGVAL
        do ISS=1,IEND
          do JSS=JSTART,JEND
            EDIFF = ENSOR(JSS)-ENSOR(ISS)
            if (abs(EDIFF) < 1.0e-8_wp) cycle
            if (EDIFF > Zero) then

              ! These are all complex quantities, and their products are complex too,
              ! but eventually every piece will be:
              !   <I|a|J> <J|b|I> + <I|b|J> <J|b|I>
              ! for a and b Hermitian operators, so it will be reduced to:
              !   2*(Re(A_ij)*Re(B_ij)+Im(A_ij)*Im(B_ij))
              ! and the imaginary parts of the products can be ignored.

              D_XR = DXR(JSS,ISS)
              D_YR = DYR(JSS,ISS)
              D_ZR = DZR(JSS,ISS)
              D_XI = DXI(JSS,ISS)
              D_YI = DYI(JSS,ISS)
              D_ZI = DZI(JSS,ISS)
              ! Note r x p = -i*hbar * (r x nabla),
              ! but we will need i * (r x p) = hbar * r x nabla
              D_MXI = MDXI(JSS,ISS)+g*SXR(JSS,ISS)
              D_MYI = MDYI(JSS,ISS)+g*SYR(JSS,ISS)
              D_MZI = MDZI(JSS,ISS)+g*SZR(JSS,ISS)
              D_MXR = MDXR(JSS,ISS)+g*SXI(JSS,ISS)
              D_MYR = MDYR(JSS,ISS)+g*SYI(JSS,ISS)
              D_MZR = MDZR(JSS,ISS)+g*SZI(JSS,ISS)

              ! R = 1/3 tr(Rtensor)
              RXX = D_XR*D_MXR+D_XI*D_MXI
              RYY = D_YR*D_MYR+D_YI*D_MYI
              RZZ = D_ZR*D_MZR+D_ZI*D_MZI
              R = Half*AU2REDR*(RXX+RYY+RZZ)

              ! Compute full rotatory strength tensor
              ! (see Hansen and Bak, 10.1021/jp001899+)

              if (IFANYQ /= 0) then
                Q_XXR = QXXR(JSS,ISS)
                Q_XYR = QXYR(JSS,ISS)
                Q_XZR = QXZR(JSS,ISS)
                Q_YYR = QYYR(JSS,ISS)
                Q_YZR = QYZR(JSS,ISS)
                Q_ZZR = QZZR(JSS,ISS)
                Q_XXI = QXXI(JSS,ISS)
                Q_XYI = QXYI(JSS,ISS)
                Q_XZI = QXZI(JSS,ISS)
                Q_YYI = QYYI(JSS,ISS)
                Q_YZI = QYZI(JSS,ISS)
                Q_ZZI = QZZI(JSS,ISS)
                RXY = D_XR*D_MYR+D_XI*D_MYI
                RXZ = D_XR*D_MZR+D_XI*D_MZI
                RYX = D_YR*D_MXR+D_YI*D_MXI
                RYZ = D_YR*D_MZR+D_YI*D_MZI
                RZX = D_ZR*D_MXR+D_ZI*D_MXI
                RZY = D_ZR*D_MYR+D_ZI*D_MYI
                RXXY = Q_XXR*D_YR+Q_XXI*D_YI
                RXXZ = Q_XXR*D_ZR+Q_XXI*D_ZI
                RXYX = Q_XYR*D_XR+Q_XYI*D_XI
                RXYZ = Q_XYR*D_ZR+Q_XYI*D_ZI
                RXZX = Q_XZR*D_XR+Q_XZI*D_XI
                RXZY = Q_XZR*D_YR+Q_XZI*D_YI
                RXYY = Q_XYR*D_YR+Q_XYI*D_YI
                RYYX = Q_YYR*D_XR+Q_YYI*D_XI
                RYYZ = Q_YYR*D_ZR+Q_YYI*D_ZI
                RYZX = Q_YZR*D_XR+Q_YZI*D_XI
                RYZY = Q_YZR*D_YR+Q_YZI*D_YI
                RXZZ = Q_XZR*D_ZR+Q_XZI*D_ZI
                RYZZ = Q_YZR*D_ZR+Q_YZI*D_ZI
                RZZX = Q_ZZR*D_XR+Q_ZZI*D_XI
                RZZY = Q_ZZR*D_YR+Q_ZZI*D_YI
                ! xx, xy, xz, yy, yz, zz
                Rtensor(1) = 0.75_wp*(RYY+RZZ+EDIFF*(RXYZ-RXZY))
                Rtensor(2) = -0.375_wp*(RXY+RYX+EDIFF*(RXXZ+RYZY-RXZX-RYYZ))
                Rtensor(3) = -0.375_wp*(RXZ+RZX+EDIFF*(RXYX+RZZY-RXXY-RYZZ))
                Rtensor(4) = 0.75_wp*(RXX+RZZ+EDIFF*(RYZX-RXYZ))
                Rtensor(5) = -0.375_wp*(RYZ+RZY+EDIFF*(RYYX+RXZZ-RXYY-RZZX))
                Rtensor(6) = 0.75_wp*(RXX+RYY+EDIFF*(RXZY-RYZX))
                Rtensor(:) = AU2REDR*Rtensor(:)
                if (Do_SK) then
                  ! k^T R k
                  R = k_vector(1,iVec)**2*Rtensor(1)+k_vector(2,iVec)**2*Rtensor(4)+k_vector(3,iVec)**2*Rtensor(6)+ &
                      Two*k_vector(1,iVec)*k_vector(2,iVec)*Rtensor(2)+Two*k_vector(1,iVec)*k_vector(3,iVec)*Rtensor(3)+ &
                      Two*k_vector(2,iVec)*k_vector(3,iVec)*Rtensor(5)
                else
                  write(u6,43) 'tensor: ',Rtensor(:)
                end if
              end if

              if (abs(R) > RSTHR) write(u6,33) ISS,JSS,R

              call Add_Info('CD_M(SO)',[R],1,6)
            end if
          end do
        end do
        write(u6,35)
      end do

      call Deallocate_Spin_Magnetic_Dipoles()

      call Deallocate_Electric_Quadrupoles()

      call CollapseOutput(0,'Circular Dichroism - mixed gauge Electric-Dipole - Magnetic-Dipole rotatory strengths (SO states):')
    end if

    call Deallocate_electric_dipoles()
    call Deallocate_Magnetic_Dipoles()
  end if
  ! CD end

  ! +++ J. Norell 19/7 - 2018
  ! Dyson amplitudes for (1-electron) ionization transitions
  if (DYSO) then
    call Add_Info('SODYSAMPS',SODYSAMPS,NSS**2,4)
    DYSTHR = 1.0e-5_wp
    write(u6,*)
    call CollapseOutput(1,'Dyson amplitudes (SO states):')
    write(u6,'(3X,A)') '-----------------------------------------------'
    if (DYSTHR > Zero) then
      write(u6,*) 'for Dyson intensities at least',DYSTHR
      write(u6,*)
    end if
    write(u6,*) '       From      To        BE (eV)       Dyson intensity'
    write(u6,'(3X,A)') '-----------------------------------------------------------------------------------------'
    do I=1,NSS
      do J=1,NSS
        F = SODYSAMPS(I,J)*SODYSAMPS(I,J)
        EDIFF = auToeV*(ENSOR(J)-ENSOR(I))
        if (abs(EDIFF) < 1.0e-8_wp) cycle
        if (F > 1.0e-5_wp) then
          if (EDIFF > Zero) write(u6,'(A,I8,I8,F15.3,ES22.5)') '    ',I,J,EDIFF,F
        end if
      end do ! J
    end do ! I
    write(u6,*)
    write(u6,*)
    call CollapseOutput(0,'Dyson amplitudes (SO states):')
    write(u6,*)
    ! VKochetov 2021 put SO Dyson amplitudes to hdf5
#   ifdef _HDF5_
    if (rhodyn) call mh5_put_dset(wfn_sos_dys,SODYSAMPS)
#   endif
  end if
  ! +++ J. Norell

  !***********************************************************************
  !                                                                      *
  !     Start of section for transition moments using the exact operator *
  !     for the vector potential.                                        *
  !                                                                      *
  !***********************************************************************

  if (Do_TMOM) call PRPROP_TM_Exact(PROP,USOR,USOI,ENSOR,NSS,JBNUM,EigVec)

end if

! CALCULATION OF THE D-TENSOR (experimental)
! IFDCAL to implement keyword that will activate computation
! of d-tensor
!if (IFDCAL) then
if (.false.) then

  write(u6,*)
  write(u6,*) '  D-Matrix'
  write(u6,*) '  ========================================='
  write(u6,*) '  calculated using 2nd order perturbation'
  write(u6,*) '  > any spin degeneracy, no spatial degeneracy'
  write(u6,*) '  > weak spin-orbit coupling'
  write(u6,*)

  ! SVC 2006: Compute D-tensor through second order perturbation theory.
  ! no orbitally-degenerate groundstates!
  IAMFIX = 0
  IAMFIY = 0
  IAMFIZ = 0
  do IPROP=1,NPROP
    if (PNAME(IPROP)(1:4) == 'AMFI') then
      if (ICOMP(IPROP) == 1) IAMFIX = IPROP
      if (ICOMP(IPROP) == 2) IAMFIY = IPROP
      if (ICOMP(IPROP) == 3) IAMFIZ = IPROP
    end if
  end do
  IPAMFI(1) = IAMFIX
  IPAMFI(2) = IAMFIY
  IPAMFI(3) = IAMFIZ
  ! initialisations
  DTENS(:,:) = Zero

  ! loop over all excited states, different factors will arise depending
  ! on the difference in spin between ground and excited states.
  ISTATE = 1
  MPLET1 = MLTPLT(JBNUM(ISTATE))
  S1 = Half*real(MPLET1-1,kind=wp)
  FACT0 = w3j(S1,One,S1,S1,Zero,-S1)*w3j(S1,One,S1,S1,Zero,-S1)/(S1*S1)
  FACTP = w3j(S1+One,One,S1,S1+One,-One,-S1)*w3j(S1,One,S1+One,S1,One,-(S1+One))/((S1+One)*(Two*S1+One))
  FACTM = w3j(S1-One,One,S1,S1-One,One,-S1)*w3j(S1,One,S1-One,S1,-One,-(S1-One))/(S1*(Two*S1-One))
  !write(u6,*)
  !write(u6,*) 'S1 ', S1
  !write(u6,*) 'FACT0 ', FACT0
  !write(u6,*) 'FACTP ', FACTP
  !write(u6,*) 'FACTM ', FACTM
  !write(u6,*)
  loop3: do IXYZ=1,3
    do JXYZ=1,3
      DTIJ = Zero
      do JSTATE=2,NSTATE
        MPLET2 = MLTPLT(JBNUM(JSTATE))
        S2 = Half*real(MPLET2-1,kind=wp)
        DELTA = ENERGY(JSTATE)-ENERGY(ISTATE)
        if (DELTA < 1.0e-5_wp) exit loop3
        CONTRIB = Zero
        CONTRIB = PROP(ISTATE,JSTATE,IPAMFI(IXYZ))*PROP(JSTATE,ISTATE,IPAMFI(JXYZ))/DELTA
        !write(u6,*) 'ISTATE, JSTATE, IXYZ, JXYZ, DELTA ',ISTATE,JSTATE,IXYZ,JXYZ,DELTA
        !write(u6,*) 'CONTRIB ', CONTRIB
        !write(u6,*) 'PROP(ISTATE,JSTATE,IXYZ) ',PROP(ISTATE,JSTATE,IPAMFI(IXYZ))
        !write(u6,*) 'PROP(JSTATE,ISTATE,JXYZ) ',PROP(JSTATE,ISTATE,IPAMFI(JXYZ))
        if (S2 == S1) then
          DTIJ = DTIJ+FACT0*CONTRIB
        else if (S2 == S1+One) then
          DTIJ = DTIJ+FACTP*CONTRIB
        else if (S2 == S1-One) then
          DTIJ = DTIJ+FACTM*CONTRIB
        end if
      end do
      DTENS(IXYZ,JXYZ) = DTIJ
    end do
  end do loop3

  if (IXYZ > 3) then
    ! diagonalisation of the D-tensor matrix
    EVR(:) = Zero
    EVI(:) = Zero
    TMPMAT(:,:) = DTENS(:,:)
    call unitmat(TMPVEC,3)
    call XEIGEN(1,3,3,TMPMAT,EVR,EVI,TMPVEC,IERR)

    ! D-factor printout
    ! D = D_zz - 1/2 * (D_xx + D_yy)
    ! E = 1/2 * (D_xx - D_yy)
    write(u6,*)
    write(u6,*) 'The D matrix and eigenvalues:'
    write(u6,*)
    write(u6,'(2x,2x,2x,3(5x,a2,5x),4x,4x,2x,10x,2x,2x,2x,3(4x,a2,i1,3x))') (xyzchr(IXYZ),IXYZ=1,3),('D_',IXYZ,IXYZ=1,3)
    write(u6,*)
    do IXYZ=1,3
      write(u6,'(2x,a2,2x,3(1x,f10.8,1x),4x,a2,i1,a1,2x,f10.8,2x,a2,2x,3(1x,f8.4,1x),3x,a2,i1,a1,2x,f8.3,2x,a5)') &
        xyzchr(IXYZ),(DTENS(IXYZ,JXYZ),JXYZ=1,3),'D_',IXYZ,':',EVR(IXYZ),xyzchr(IXYZ),TMPVEC(IXYZ,:),'D_',IXYZ,':', &
        EVR(IXYZ)*auTocm,'cm^-1'
    end do
  end if

end if

! CALCULATION OF THE G-TENSOR
! IFGCAL is set by keyword EPRG
if (IFGCAL .and. (.not. IFSO)) then
  write(u6,*) 'keyword SPIN needed together with EPRG'
  write(u6,*)
else if (IFGCAL) then
  ! PAM 2005 Experimental: Compute g-tensor through 2-nd order
  ! perturbation approach, mixed ang mom / spin orbit terms
  ! Declarations for gtensor(3,3) and some other odds and ends
  ! for nice output have been added to declaration head above.

  write(u6,*)
  write(u6,*) '  g-Matrix Approach I'
  write(u6,*) '  ========================================='
  write(u6,*) '  calculated using 2nd order perturbation'
  write(u6,*) '  > any spin degeneracy, no spatial degeneracy'
  write(u6,*) '  > weak spin-orbit coupling'
  write(u6,*)

  IAMFIX = 0
  IAMFIY = 0
  IAMFIZ = 0
  IAMX = 0
  IAMY = 0
  IAMZ = 0
  do IPROP=1,NPROP
    if (PNAME(IPROP)(1:4) == 'AMFI') then
      if (ICOMP(IPROP) == 1) IAMFIX = IPROP
      if (ICOMP(IPROP) == 2) IAMFIY = IPROP
      if (ICOMP(IPROP) == 3) IAMFIZ = IPROP
    else if (PNAME(IPROP)(1:6) == 'ANGMOM') then
      if (ICOMP(IPROP) == 1) IAMX = IPROP
      if (ICOMP(IPROP) == 2) IAMY = IPROP
      if (ICOMP(IPROP) == 3) IAMZ = IPROP
    end if
  end do
  IPAMFI(1) = IAMFIX
  IPAMFI(2) = IAMFIY
  IPAMFI(3) = IAMFIZ
  IPAM(1) = IAMX
  IPAM(2) = IAMY
  IPAM(3) = IAMZ

  ! start loop over the states ISTATE:
  ISTATE = 1
  do while (((ENERGY(min(ISTATE,NSTATE))-ENERGY(1)) <= EPRTHR) .and. (ISTATE <= NSTATE))

    GTENS(:,:) = Zero

    MPLET = MLTPLT(JBNUM(ISTATE))
    S = Half*real(MPLET-1,kind=wp)

    write(u6,*)
    write(u6,'(3x,A6,I4,3x,A4,F4.1,3x,A4,F18.8)') 'STATE ',ISTATE,'S = ',S,'E = ',ENERGY(ISTATE)
    write(u6,'(3x,A46)') '----------------------------------------------'

    if (MPLET /= 1) then
      FACTOR = One/sqrt(S*(S+One)*(Two*S+One))

      ! print separate contributions if verbose
      if (IPGLOB >= 3) then
        write(u6,*)
        write(u6,*) 'contributions from the SOS expansion to delta(g_pq) in *ppt* (p,q=x,y,z)'
        write(u6,*)
        write(u6,'(2x,a8,2x,9(4x,a2,3x))') ' states ','xx','xy','xz','yx','yy','yz','zx','zy','zz'
        write(u6,*)
        do JSTATE=1,NSTATE
          if (JSTATE /= ISTATE) then
            DELTA = ENERGY(JSTATE)-ENERGY(ISTATE)
            if (abs(DELTA) < 1.0e-4_wp) then
              write(u6,'(1x,i3,2x,i3,3x,A20,1x,A20,F18.8)') ISTATE,JSTATE,'possible degeneracy,','energy difference = ',DELTA
              cycle
            end if
            do IXYZ=1,3
              do JXYZ=1,3
                SOSTERM(JXYZ,IXYZ) = -Two*FACTOR*PROP(ISTATE,JSTATE,IPAMFI(IXYZ))*PROP(ISTATE,JSTATE,IPAM(JXYZ))/DELTA
              end do
            end do
            write(u6,'(1x,i3,2x,i3,3x,9(f8.3,1x))') ISTATE,JSTATE,SOSTERM(:,:)*1.0e3_wp
          end if
        end do
      end if

      ! calculate sum-over-states for each g_pq (p,q = x,y,z)
      loop2: do IXYZ=1,3
        do JXYZ=1,3
          GTIJ = Zero
          DELTA = Zero
          CONTRIB = Zero
          do JSTATE=1,NSTATE
            if (JSTATE /= ISTATE) then
              DELTA = ENERGY(JSTATE)-ENERGY(ISTATE)
              ! SVC 2008: no good criterium for spatial degeneracy, use rasscf energies ?
              if (abs(DELTA) < 1.0e-4_wp) then
                write(u6,*)
                write(u6,*) 'SPATIALLY DEGENERATE STATE: sum-over-states not applicable'
                !write(u6,*) '> lower the degeneracy treshold if this is not a spatially degenerate state'
                write(u6,*)
                exit loop2
              end if
              GTIJ = GTIJ+PROP(ISTATE,JSTATE,IPAMFI(IXYZ))*PROP(ISTATE,JSTATE,IPAM(JXYZ))/DELTA
            end if
          end do
          GTENS(IXYZ,JXYZ) = -Two*FACTOR*GTIJ
        end do
      end do loop2

      if (IXYZ > 3) then
        ! put g_e on the diagonal
        do IXYZ=1,3
          do JXYZ=IXYZ,3
            if (IXYZ == JXYZ) GTENS(IXYZ,JXYZ) = GTENS(IXYZ,JXYZ)+FEGVAL
          end do
        end do

        ! determine symmetric G = gg+ tensor, this is what can be measured
        ! experimentally, and store as GSTENS
        do IXYZ=1,3
          do JXYZ=1,3
            GSTENS(IXYZ,JXYZ) = sum(GTENS(IXYZ,:)*GTENS(JXYZ,:))
          end do
        end do

        ! determine the eigenvalues of the g matrix
        EVR(:) = Zero
        EVI(:) = Zero
        ! XEIGEN alters the input matrix! copy GTENS to TMPMAT
        TMPMAT(:,:) = GTENS(:,:)
        call unitmat(TMPVEC,3)

        IERR = 0
        call XEIGEN(1,3,3,TMPMAT,EVR,EVI,TMPVEC,IERR)
        if (IERR /= 0) then
          write(u6,*) 'Error: xEigen returned IERR = ',IERR
          return
        end if

        write(u6,*)
        write(u6,*) 'The g matrix and eigenvalues:'
        write(u6,*)
        write(u6,'(6x,3(5x,a2,5x))') (xyzchr(IXYZ),IXYZ=1,3)
        write(u6,*)
        do IXYZ=1,3
          write(u6,'(2x,a2,2x,3(1x,f10.8,1x),4x,a2,i1,a1,2x,f8.4,3x,a8,i1,a2,2x,f10.3,2x,a3)') xyzchr(IXYZ),GTENS(IXYZ,:),'g_', &
                                                                                               IXYZ,':',EVR(IXYZ),'delta(g_', &
                                                                                               IXYZ,'):', &
                                                                                               (EVR(IXYZ)-FEGVAL)*1.0e3_wp,'ppt'
        end do

        !write(u6,'(6x,3(5x,i1,4x))') (IXYZ,IXYZ=1,3)

        ! determine the eigenvalues of the G = gg* matrix
        EVR(:) = Zero
        EVI(:) = Zero
        TMPMAT(:,:) = GSTENS(:,:)
        call unitmat(TMPVEC,3)

        IERR = 0
        call XEIGEN(1,3,3,TMPMAT,EVR,EVI,TMPVEC,IERR)
        if (IERR /= 0) then
          write(u6,*) 'Error: xEigen returned IERR = ',IERR
          return
        end if

        ! reconstruct g_s from the square root of the eigenvalues
        ! and the eigenvectors of G = gg+ by back transformation
        do IXYZ=1,3
          do JXYZ=1,3
            GSTENS(IXYZ,JXYZ) = sum(TMPVEC(IXYZ,:)*sqrt(EVR(:))*TMPVEC(JXYZ,:))
          end do
        end do

        write(u6,*)
        write(u6,*) 'The symmetric g matrix is the actual experimentally determined g matrix.'
        write(u6,*) 'The sign of the eigenvalues is undetermined (assumed positive).'
        write(u6,*)
        write(u6,'(2x,2x,2x,3(5x,a2,5x),4x,4x,2x,10x,2x,2x,2x,3(4x,a2,i1,3x))') (xyzchr(IXYZ),IXYZ=1,3),('g_',IXYZ,IXYZ=1,3)
        write(u6,*)
        do IXYZ=1,3
          write(u6,'(2x,a2,2x,3(1x,f10.8,1x),4x,a2,i1,a1,2x,f10.6,2x,a2,2x,3(1x,f8.4,1x),3x,a8,i1,a2,2x,f8.3,2x,a3)') &
            xyzchr(IXYZ),(GSTENS(IXYZ,JXYZ),JXYZ=1,3),'g_',IXYZ,':',sqrt(EVR(IXYZ)),xyzchr(IXYZ),TMPVEC(IXYZ,:),'delta(g_',IXYZ, &
            '):',(sqrt(EVR(IXYZ))-FEGVAL)*1.0e3_wp,'ppt'
        end do
        EVR(:) = sqrt(EVR(:))-FEGVAL
        call Add_Info('EPRGVAL',EVR,3,6)
      end if

    end if

    ISTATE = ISTATE+1

    ! end long loop over states ISTATE
  end do

  ! SVC alternative approach for the g-tensor:
  ! using first order degenerate perturbation theory

  if (IFVANVLECK) then
    write(u6,*)
    write(u6,*) '  VAN VLECK Tensor and g-Matrix Approach II'
    write(u6,*) '  ========================================='
    write(u6,*) '  1st order degenerate perturbation theory'
    write(u6,*) '  within isolated kramers doublets.'
    write(u6,*) '  > spatial degeneracy'
    write(u6,*) '  > strong spin-orbit coupling'
    write(u6,*)
  else
    write(u6,*)
    write(u6,*) '  g-Matrix Approach II'
    write(u6,*) '  ========================================='
    write(u6,*) '  1st order degenerate perturbation theory'
    write(u6,*) '  within isolated kramers doublets.'
    write(u6,*) '  > spatial degeneracy'
    write(u6,*) '  > strong spin-orbit coupling'
    write(u6,*)
  end if

  IAMX = 0
  IAMY = 0
  IAMZ = 0
  do IPROP=1,NPROP
    if (PNAME(IPROP)(1:6) == 'ANGMOM') then
      !write(u6,*) '3****ANGMOM rassi/prprop'
      if (ICOMP(IPROP) == 1) IAMX = IPROP
      if (ICOMP(IPROP) == 2) IAMY = IPROP
      if (ICOMP(IPROP) == 3) IAMZ = IPROP
    end if
  end do

  call mma_allocate(LXI,NSS,NSS,Label='LXI')
  LXI(:,:) = Zero
  call mma_allocate(LYI,NSS,NSS,Label='LYI')
  LYI(:,:) = Zero
  call mma_allocate(LZI,NSS,NSS,Label='LZI')
  LZI(:,:) = Zero

  if (IAMX > 0) call SMMAT(PROP,LXI,NSS,IAMX,0)
  if (IAMY > 0) call SMMAT(PROP,LYI,NSS,IAMY,0)
  if (IAMZ > 0) call SMMAT(PROP,LZI,NSS,IAMZ,0)

  call mma_allocate(ZXYZR,NSS,NSS,3,Label='ZXYZR')
  call mma_allocate(ZXYZI,NSS,NSS,3,Label='ZXYZI')
  ZXYZR(:,:,:) = Zero
  ZXYZI(:,:,:) = Zero

  call SMMAT(PROP,ZXYZR(:,:,1),NSS,0,1)
  call SMMAT(PROP,ZXYZI(:,:,2),NSS,0,2)
  call SMMAT(PROP,ZXYZR(:,:,3),NSS,0,3)

  ZXYZR(:,:,1) = FEGVAL*ZXYZR(:,:,1)
  ZXYZI(:,:,2) = FEGVAL*ZXYZI(:,:,2)
  ZXYZR(:,:,3) = FEGVAL*ZXYZR(:,:,3)

  ZXYZI(:,:,1) = ZXYZI(:,:,1)+LXI(:,:)
  ZXYZI(:,:,2) = ZXYZI(:,:,2)+LYI(:,:)
  ZXYZI(:,:,3) = ZXYZI(:,:,3)+LZI(:,:)

  call mma_deallocate(LXI)
  call mma_deallocate(LYI)
  call mma_deallocate(LZI)

  ! SVC 20090926 Experimental
  ! Add analysis of different contributions

  ! Establish which spin components of SFS belong to the ground state
  call mma_allocate(ISGS,NSS,Label='ISGS')

  GSENERGY = ENERGY(1)
  do ISTATE=2,NSTATE
    if (ENERGY(ISTATE) < GSENERGY) GSENERGY = ENERGY(ISTATE)
  end do

  IMLTPL = 0
  do ISTATE=1,NSTATE
    ISGS(IMLTPL+1:IMLTPL+MLTPLT(JBNUM(ISTATE))) = abs(ENERGY(ISTATE)-GSENERGY) < 1.0e-6_wp
    IMLTPL = IMLTPL+MLTPLT(JBNUM(ISTATE))
  end do

  ! Analyze the different contributions to the GS Kramers doublet
  ! Zeeman matrix elements.  There are 4 different ME's: <1|Ze|1>,
  ! <1|Ze|2>, <2|Ze|1>, and <2|Ze|2>, stored in ZEKL.  Contributions
  ! of SFS i,j to SOS k,l (k,l=1,2): <k|Ze|l> = Sum(i,j) U(i,k)*
  ! <i|Ze|j> U(j,l).  This sum is decomposed into parts belonging to
  ! each SFS state i as follows:
  ! -> GS's contain only MEs with themselves and other GS's
  ! -> ES's contain MEs with themselves, the GS's (2x) and other ES's
  !    The ME's with the GS's are counted twice as they do not belong to
  !    any GS's (they contain only ME's within their own GS group)
  !    The contributions with other ES's are split between the ES's,
  !    counting them double (<i|Ze|j> and <j|Ze|i>) and divide by two later.

  call mma_allocate(ZEKL,2,2,3,NSTATE,Label='ZEKL')

  IMLTPL = 0
  ZEKL(:,:,:,:) = cZero

  do ISTATE=1,NSTATE

    ISTART = IMLTPL+1
    IFINAL = IMLTPL+MLTPLT(JBNUM(ISTATE))

    if (abs(ENERGY(ISTATE)-GSENERGY) < 1.0e-6_wp) then

      ! Contribution of the GS spin components
      do IXYZ=1,3
        do ISS=ISTART,IFINAL
          do JSS=1,NSS
            if (ISGS(JSS)) then
              call ZECON(NSTATE,NSS,USOR,USOI,ZXYZR(:,:,IXYZ),ZXYZI(:,:,IXYZ),ZEKL,IXYZ,ISTATE,ISS,JSS)
              call ZECON(NSTATE,NSS,USOR,USOI,ZXYZR(:,:,IXYZ),ZXYZI(:,:,IXYZ),ZEKL,IXYZ,ISTATE,JSS,ISS)
              !write(u6,710) 'ZEKL',ISTATE,IXYZ,ISS,JSS,ZEKL(:,:,IXYZ,ISTATE)
            end if
          end do
        end do
      end do

    else

      ! Contributions of the ES spin components
      do IXYZ=1,3
        do ISS=ISTART,IFINAL
          do JSS=1,NSS
            call ZECON(NSTATE,NSS,USOR,USOI,ZXYZR(:,:,IXYZ),ZXYZI(:,:,IXYZ),ZEKL,IXYZ,ISTATE,ISS,JSS)
            call ZECON(NSTATE,NSS,USOR,USOI,ZXYZR(:,:,IXYZ),ZXYZI(:,:,IXYZ),ZEKL,IXYZ,ISTATE,JSS,ISS)
            if (ISGS(JSS)) then
              call ZECON(NSTATE,NSS,USOR,USOI,ZXYZR(:,:,IXYZ),ZXYZI(:,:,IXYZ),ZEKL,IXYZ,ISTATE,ISS,JSS)
              call ZECON(NSTATE,NSS,USOR,USOI,ZXYZR(:,:,IXYZ),ZXYZI(:,:,IXYZ),ZEKL,IXYZ,ISTATE,JSS,ISS)
            end if
            !write(u6,710) 'ZEKL',ISTATE,IXYZ,ISS,JSS,ZEKL(:,:,IXYZ,ISTATE)
          end do
        end do
      end do

    end if

    !do IXYZ=1,3
    !  write(u6,720) 'ZEKL',IXYZ,ISTATE,ZEKL(:,:,IXYZ,ISTATE)
    !end do

    IMLTPL = IMLTPL+MLTPLT(JBNUM(ISTATE))
  end do

  call mma_deallocate(ISGS)

  ! We now have decomposed the <k|Ze|l> into terms belonging to either
  ! a GS or an ES for each k,l=1,2 and p=x,y,z stored in ZEKL(k,l,p,SFS)
  ! Now, these new decomposed terms of the ZEKL ME's are combined to
  ! form the G tensor.  Consider e.g. that <k|Ze|l> is decomposed into
  ! <k|GS|l> + <k|ES1|l> + <k|ES2|l>, then the contributions to G are given as:
  ! -> G_pq/2 = <k|Ze_p|l> <l|Ze_q|k>
  !         = (<k|GS_p|l> + <k|ES1_p|l> + <k|ES2_p|l>)
  !         * (<l|GS_q|k> + <l|ES1_q|k> + <l|ES2_q|k>)

  ! from GS: (<k|GS_p|l>/2 * <l|GS_q|k>/2)/2 + (<k|GS_p|l>/2 * <l|GS_q|k>/2)/2
  ! from ES1: 2*((<k|ES1_p|l>/2 * <l|GS_q|k>/2)/2 + (<k|GS_q|l>/2 * <l|ES1_p|k>/2)/2)
  !           + (<k|ES1_p|l>/2 * <l|ES1_q|k>/2)/2 + (<k|ES1_q|l>/2 * <l|ES2_p|k>/2)/2
  !           + (<k|ES1_p|l>/2 * <l|ES2_q|k>/2)/2 + (<k|ES2_q|l>/2 * <l|ES1_p|k>/2)/2
  ! In the end, the outer division by 2 cancels on both sides, and the
  ! inner divisions by two combine to a division by 4.

  call mma_allocate(GCONT,3,3,NSTATE,Label='GCONT')

  GCONT(:,:,:) = cZero
  GTOTAL(:,:) = Zero

  do ISTATE=1,NSTATE
    do IXYZ=1,3
      do JXYZ=1,3

        if (abs(ENERGY(ISTATE)-GSENERGY) < 1.0e-6_wp) then

          ! Contributions for the GS's
          do JSTATE=1,NSTATE
            if (abs(ENERGY(JSTATE)-GSENERGY) < 1.0e-6_wp) then
              do I=1,2
                do J=1,2
                  GCONT(JXYZ,IXYZ,ISTATE) = GCONT(JXYZ,IXYZ,ISTATE)+(ZEKL(I,J,IXYZ,ISTATE)*ZEKL(J,I,JXYZ,JSTATE)+ &
                                                                     ZEKL(I,J,IXYZ,JSTATE)*ZEKL(J,I,JXYZ,ISTATE))*Quart
                end do
              end do
            end if
          end do

        else

          ! Contributions for the ES's
          do JSTATE=1,NSTATE
            do I=1,2
              do J=1,2
                GCONT(JXYZ,IXYZ,ISTATE) = GCONT(JXYZ,IXYZ,ISTATE)+(ZEKL(I,J,IXYZ,ISTATE)*ZEKL(J,I,JXYZ,JSTATE)+ &
                                                                   ZEKL(I,J,IXYZ,JSTATE)*ZEKL(J,I,JXYZ,ISTATE))*Quart
                if (abs(ENERGY(JSTATE)-GSENERGY) < 1.0e-6_wp) &
                  GCONT(JXYZ,IXYZ,ISTATE) = GCONT(JXYZ,IXYZ,ISTATE)+(ZEKL(I,J,IXYZ,ISTATE)*ZEKL(J,I,JXYZ,JSTATE)+ &
                                                                     ZEKL(I,J,IXYZ,JSTATE)*ZEKL(J,I,JXYZ,ISTATE))*Quart
              end do
            end do
          end do

        end if

      end do
    end do

    GTOTAL(:,:) = GTOTAL(:,:)+real(GCONT(:,:,ISTATE))
  end do

  call mma_deallocate(ZEKL)

  call mma_allocate(DIPSOm,3,NSS,NSS,Label='DIPSOm')
  call mma_allocate(DIPSOn,3,NSS,NSS,Label='DIPSOn')
  call mma_allocate(ESO,NSS,Label='ESO')
  call mma_allocate(Z,NSS,NSS,Label='Z')

  DIPSOm(:,:,:) = cZero
  DIPSOn(:,:,:) = cZero

  ! Continue original calculation of G tensor (=gg^*)
  call get_dArray('ESO_SINGLE',ESO,NSS)
  call ZTRNSF(NSS,USOR,USOI,ZXYZR(:,:,1),ZXYZI(:,:,1))
  call MULMAT(NSS,ZXYZR(:,:,1),ZXYZI(:,:,1),eex,Z)
  DIPSOm(1,:,:) = Half*Z(:,:)
  DIPSOn(1,:,:) = -Z(:,:)
  call ZTRNSF(NSS,USOR,USOI,ZXYZR(:,:,2),ZXYZI(:,:,2))
  call MULMAT(NSS,ZXYZR(:,:,2),ZXYZI(:,:,2),eey,Z)
  DIPSOm(2,:,:) = Half*Z(:,:)
  DIPSOn(2,:,:) = -Z(:,:)
  call ZTRNSF(NSS,USOR,USOI,ZXYZR(:,:,3),ZXYZI(:,:,3))
  call MULMAT(NSS,ZXYZR(:,:,3),ZXYZI,eez,Z)
  DIPSOm(3,:,:) = Half*Z(:,:)
  DIPSOn(3,:,:) = -Z(:,:)
  write(u6,*)

  call mma_deallocate(Z)

  if (IFVANVLECK) then

    call mma_allocate(chiT_tens,NTS,3,3,Label='chiT_tens')
    call mma_allocate(chicuriT_tens,NTS,3,3,Label='chicuriT_tens')
    call mma_allocate(chiparamT_tens,NTS,3,3,Label='chiparamT_tens')

    iT = 0
    chiT_tens(:,:,:) = Zero
    chicuriT_tens(:,:,:) = Zero
    chiparamT_tens(:,:,:) = Zero
    iT = 0
    do iT=1,NTS
      if (iT == 1) then
        TMPm(iT) = TMINS+1.0e-4_wp
      else
        DLTT = (TMAXS-TMINS)/real(NTS-1,kind=wp)
        TMPm(iT) = TMINS+DLTT*real(iT-1,kind=wp)
      end if
      Zstat = Zero
      do Iss=1,Nss
        p_Boltz = exp(-ESO(Iss)/Boltz_k/TMPm(iT))
        Zstat = Zstat+p_Boltz
        c_2(:,:) = Zero
        curit(:,:) = Zero
        paramt(:,:) = Zero
        do Jss=1,Nss
          dlt_E = Eso(Iss)-Eso(Jss)
          do jc=1,3
            c_1(:,jc) = real(DIPSOn(:,Iss,Jss)*conjg(DIPSOn(jc,Iss,Jss)))
          end do
          if (abs(dlt_E) < 10.97_wp) then ! what is this number?
            c_2(:,:) = c_2(:,:)+c_1(:,:)
            curit(:,:) = curit(:,:)+c_1(:,:)
            !paramt(:,:) = paramt(:,:)+Zero*c_1(:,:)
          else
            c_2(:,:) = c_2(:,:)-Two*Boltz_k*TMPm(iT)*c_1(:,:)/dlt_E
            !curit(:,:) = curit(:,:)-Zero*(Two*Boltz_k*TMPm(iT)*c_1(:,:)/dlt_E)
            paramt(:,:) = paramt(:,:)-Two*Boltz_k*TMPm(iT)*c_1(:,:)/dlt_E
          end if
        end do !Jss
        chiT_tens(iT,:,:) = chiT_tens(iT,:,:)+p_Boltz*c_2(:,:)
        chicuriT_tens(iT,:,:) = chicuriT_tens(iT,:,:)+p_Boltz*curit(:,:)
        chiparamT_tens(iT,:,:) = chiparamT_tens(iT,:,:)+p_Boltz*paramt(:,:)
      end do !Iss
      !Zstat1m(iT) = Zstat
      chiT_tens(iT,:,:) = coeff_chi*(chiT_tens(iT,:,:)/Zstat)
      chicuriT_tens(iT,:,:) = coeff_chi*(chicuriT_tens(iT,:,:)/Zstat)
      chiparamT_tens(iT,:,:) = coeff_chi*(chiparamT_tens(iT,:,:)/Zstat)
    end do ! iT

    write(u6,'(/)')
    write(u6,'(A)') repeat('-',120)
    write(u6,'(30X,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR  (cm3*K/mol)'
    write(u6,'(A)') repeat('-',120)
    write(u6,*)
    !write(u6,'(8X,A,9(7X,A))') 'T','(1,1)','(1,2)','(1,3)','(2,1)','(2,2)','(2,3)','(3,1)','(3,2)','(3,3)'
    write(u6,'(6X,A,8X,9(A,9X))') 'T(K)','xx','xy','xz','yx','yy','yz','zx','zy','zz'
    write(u6,*)
    do iT=1,NTS
      write(u6,'(4X,F6.1,3X,11(F9.4,2X),F8.4)') TMPm(iT),((chiT_tens(iT,ic,jc),jc=1,3),ic=1,3)
    end do

    write(u6,'(/)')
    write(u6,'(A)') repeat('-',120)
    write(u6,'(30X,A)') 'Curie contrib. to VAN VLECK TENSOR  (cm3*K/mol)'
    write(u6,'(A)') repeat('-',120)
    write(u6,*)
    !write(u6,'(8X,A,9(7X,A))') 'T','(1,1)','(1,2)','(1,3)','(2,1)','(2,2)','(2,3)','(3,1)','(3,2)','(3,3)'
    write(u6,'(6X,A,8X,9(A,9X))') 'T(K)','xx','xy','xz','yx','yy','yz','zx','zy','zz'
    write(u6,*)
    do iT=1,NTS
      write(u6,'(4X,F6.1,3X,11(F9.4,2X),F8.4)') TMPm(iT),((chicuriT_tens(iT,ic,jc),jc=1,3),ic=1,3)
    end do
    write(u6,'(/)')
    write(u6,'(A)') repeat('-',120)
    write(u6,'(30X,A)') 'Parama. contrib. to VAN VLECK TENSOR  (cm3*K/mol)'
    write(u6,'(A)') repeat('-',120)
    write(u6,*)
    !write(u6,'(8X,A,9(7X,A))') 'T','(1,1)','(1,2)','(1,3)','(2,1)','(2,2)','(2,3)','(3,1)','(3,2)','(3,3)'
    write(u6,'(6X,A,8X,9(A,9X))') 'T(K)','xx','xy','xz','yx','yy','yz','zx','zy','zz'
    write(u6,*)
    do iT=1,NTS
      write(u6,'(4X,F6.1,3X,11(F9.4,2X),F8.4)') TMPm(iT),((chiparamT_tens(iT,ic,jc),jc=1,3),ic=1,3)
    end do
    write(u6,*)
    write(u6,*)
    write(u6,*) '  g-Matrix'
    write(u6,*) '  =========='

    !do I=1,3
    !  do J=1,3
    !    do iT=1,NT
    !      chiT_tens(iT,I,J) = Zero
    !    end do
    !  end do
    !end do
    call mma_deallocate(chiT_tens)
    call mma_deallocate(chicuriT_tens)
    call mma_deallocate(chiparamT_tens)
  end if ! IFVANVLECK

  call mma_allocate(SPNSFS,3,NSS,NSS,Label='SPNSFS')

  ISS = 1
  do while ((ISS <= NSS) .and. (ENSOR(min(ISS,NSS))-ENSOR(1) <= EPRTHR))

    GTENS(:,:) = Zero

    KDGN = 1
    do JSS=ISS+1,NSS
      EDIFF = ENSOR(JSS)-ENSOR(ISS)
      if (IFGTCALSA .and. IFGTSHSA) then
        KDGN = MULTIP
        !write(u6,*) 'KDGN=',KDGN
      else if (abs(EDIFF) < 1.0e-6_wp) then
        KDGN = KDGN+1
      end if
    end do

    write(u6,*)
    do I=1,KDGN
      write(u6,'(3x,A9,I4,3x,A4,F18.8)') 'SO-STATE ',ISS-1+I,'E = ',ENSOR(ISS-1+I)
    end do
    write(u6,'(3x,A46)') '----------------------------------------------'

    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if (IFGTCALSA) then
      if (ISS == 1) IFUNCT = 0
      call SINANI(KDGN,IFUNCT,NSS,DIPSOn,SPNSFS)
      IFUNCT = IFUNCT+KDGN
    end if
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    if (KDGN /= 2) then
      write(u6,*) 'no twofold degeneracy'
    else

      if ((ISS == 1) .and. (KDGN == 2) .and. (IPGLOB >= 3)) then
        write(u6,*) 'Experimental: SFS contributions to G=gg+'
        write(u6,*)
        write(u6,'(a6,9(5x,a2,5x))') 'state ','xx','xy','xz','yx','yy','yz','zx','zy','zz'
        write(u6,*)
        do ISTATE=1,NSTATE
          write(u6,'(2x,I2,2x,9(F12.6))') ISTATE,real(GCONT(:,:,ISTATE))
        end do

        write(u6,*)
        write(u6,'(A6,9(F12.6))') 'total ',GTOTAL(:,:)
      end if

      JSS = ISS+1

      do IXYZ=1,3
        do JXYZ=1,3
          GTIJ = Zero
          do ISO=ISS,JSS
            GTIJ = GTIJ+sum(ZXYZR(ISO,ISS:JSS,IXYZ)*ZXYZR(ISS:JSS,ISO,JXYZ)-ZXYZI(ISO,ISS:JSS,IXYZ)*ZXYZI(ISS:JSS,ISO,JXYZ))
          end do
          GTENS(IXYZ,JXYZ) = Two*GTIJ
        end do
      end do

      if (IPGLOB > 3) then
        write(u6,*) 'G tensor = gg+'
        write(u6,*)
        write(u6,'(6x,3(6x,a2,4x))') (xyzchr(IXYZ),IXYZ=1,3)
        do IXYZ=1,3
          write(u6,'(2x,a2,2x,3(1x,f18.8,1x))') xyzchr(IXYZ),GTENS(IXYZ,:)
        end do
      end if

      EVR(:) = Zero
      EVI(:) = Zero
      TMPMAT(:,:) = GTENS(:,:)
      call unitmat(TMPVEC,3)

      call XEIGEN(1,3,3,TMPMAT,EVR,EVI,TMPVEC,IERR)

      ! construct g_s matrix from G by back-transormation of the
      ! square root of the G eigenvalues
      do IXYZ=1,3
        do JXYZ=1,3
          GTENS(IXYZ,JXYZ) = sum(TMPVEC(IXYZ,:)*sqrt(EVR(:))*TMPVEC(JXYZ,:))
        end do
      end do

      write(u6,'(6x,3(5x,a2,5x),4x,4x,2x,8x,2x,2x,2x,3(4x,a2,i1,3x))') (xyzchr(IXYZ),IXYZ=1,3),('g_',IXYZ,IXYZ=1,3)
      write(u6,*)
      do IXYZ=1,3
        write(u6,'(2x,a2,2x,3(1x,f10.6,1x),4x,a2,i1,a1,2x,f8.4,2x,a2,2x,3(1x,f8.4,1x))') xyzchr(IXYZ),GTENS(IXYZ,:),'g_',IXYZ, &
                                                                                         ':',sqrt(EVR(IXYZ)),xyzchr(IXYZ), &
                                                                                         TMPVEC(IXYZ,:)
      end do

    end if

    ISS = ISS+KDGN

  end do

  call mma_deallocate(ZXYZR)
  call mma_deallocate(ZXYZI)
  call mma_deallocate(DIPSOn)
  call mma_deallocate(GCONT)
  call mma_deallocate(SPNSFS)

end if

!*****************************************************
!* Experimental hyperfine tensor stuff starts here
!*****************************************************

! Skip if not a hyperfine calculation
if (HypF_rms_Req .or. allocated(Atens_Req) .or. allocated(pNMR_req)) call Hyperfine_Oper(PROP,USOR,USOI,JBNUM)

!*****************************************************
!* Experimental hyperfine tensor stuff ends here
!*****************************************************

call mma_deallocate(DIPSOm,safe='*')
call mma_deallocate(ESO,safe='*')

! SVC20080312 calculation of magnetization

if (IFXCAL .and. (.not. IFSO)) then
  write(u6,*) 'keyword SPIN needed with MAGN'
  write(u6,*)
else if (IFXCAL) then

  write(u6,*)
  write(u6,*) '  ========================================='
  write(u6,*) '  Magnetization and Magnetic Susceptibility'
  write(u6,*) '  ========================================='
  write(u6,*)

  ! initialization same as G-tensor, construct L+gS matrix elements
  IAMX = 0
  IAMY = 0
  IAMZ = 0
  do IPROP=1,NPROP
    if (PNAME(IPROP)(1:6) == 'ANGMOM') then
      !write(u6,*) '4****ANGMOM rassi/prprop'
      if (ICOMP(IPROP) == 1) IAMX = IPROP
      if (ICOMP(IPROP) == 2) IAMY = IPROP
      if (ICOMP(IPROP) == 3) IAMZ = IPROP
    end if
  end do

  call mma_allocate(LXI,NSS,NSS,Label='LXI')
  LXI(:,:) = Zero
  call mma_allocate(LYI,NSS,NSS,Label='LYI')
  LYI(:,:) = Zero
  call mma_allocate(LZI,NSS,NSS,Label='LZI')
  LZI(:,:) = Zero

  if (IAMX > 0) call SMMAT(PROP,LXI,NSS,IAMX,0)
  if (IAMY > 0) call SMMAT(PROP,LYI,NSS,IAMY,0)
  if (IAMZ > 0) call SMMAT(PROP,LZI,NSS,IAMZ,0)

  call mma_allocate(MXYZR,NSS,NSS,3,Label='MXYZR')
  call mma_allocate(MXYZI,NSS,NSS,3,Label='MXYZI')
  MXYZR(:,:,:) = Zero
  MXYZI(:,:,:) = Zero

  call SMMAT(PROP,MXYZR(:,:,1),NSS,0,1)
  call SMMAT(PROP,MXYZI(:,:,2),NSS,0,2)
  call SMMAT(PROP,MXYZR(:,:,3),NSS,0,3)

  MXYZR(:,:,1) = FEGVAL*MXYZR(:,:,1)
  MXYZI(:,:,2) = FEGVAL*MXYZI(:,:,2)
  MXYZR(:,:,3) = FEGVAL*MXYZR(:,:,3)

  MXYZI(:,:,1) = MXYZI(:,:,1)+LXI(:,:)
  MXYZI(:,:,2) = MXYZI(:,:,2)+LYI(:,:)
  MXYZI(:,:,3) = MXYZI(:,:,3)+LZI(:,:)

  call mma_deallocate(LXI)
  call mma_deallocate(LYI)
  call mma_deallocate(LZI)

  call ZTRNSF(NSS,USOR,USOI,MXYZR(:,:,1),MXYZI(:,:,1))
  call ZTRNSF(NSS,USOR,USOI,MXYZR(:,:,2),MXYZI(:,:,2))
  call ZTRNSF(NSS,USOR,USOI,MXYZR(:,:,3),MXYZI(:,:,3))

  call mma_allocate(ZXYZR,NSS,NSS,3,Label='ZXYZR')
  call mma_allocate(ZXYZI,NSS,NSS,3,Label='ZXYZI')
  ZXYZR(:,:,:) = Zero
  ZXYZR(:,:,:) = Zero

  call mma_allocate(ZR,NSS,NSS,Label='ZR')
  call mma_allocate(ZI,NSS,NSS,Label='ZI')
  call mma_allocate(UZR,NSS,NSS,Label='UZR')
  call mma_allocate(UZI,NSS,NSS,Label='UZI')

  BFINAL = BSTART+(NBSTEP-1)*BINCRE
  TFINAL = TSTART+(NTSTEP-1)*TINCRE

  write(u6,*) 'Magnetic flux density range (T):'
  write(u6,'(2x,f6.2,a3,f6.2,a4,i4,a6)') BSTART,' - ',BFINAL,' in ',NBSTEP,' steps'
  write(u6,*)
  write(u6,*) 'Temperature range (K):'
  write(u6,'(2x,f6.2,a3,f6.2,a4,i4,a6)') TSTART,' - ',TFINAL,' in ',NTSTEP,' steps'

  call mma_allocate(MAGM,9*NBSTEP*NTSTEP,Label='MAGM')

  LMSTEP = 0

  do IXYZ=1,3

    write(u6,*)
    write(u6,'(3x,a1,3x,8(1x,a12,1x))') 'T','    B'//xyzchr(IXYZ)//' (T)  ','   M (J/T)  ','  Mx (J/T)  ','  My (J/T)  ', &
                                        '  Mz (J/T)  ','Xx'//xyzchr(IXYZ)//' (m3/mol)','Xy'//xyzchr(IXYZ)//' (m3/mol)', &
                                        'Xz'//xyzchr(IXYZ)//' (m3/mol)'
    write(u6,*)

    do IBSTEP=1,NBSTEP
      B = BSTART+BINCRE*(IBSTEP-1)
      ZR(:,:) = Half*B/auToT*MXYZR(:,:,IXYZ)
      ZI(:,:) = Half*B/auToT*MXYZI(:,:,IXYZ)
      do ISS=1,NSS
        ZR(ISS,ISS) = ZR(ISS,ISS)+ENSOR(ISS)
      end do
      call unitmat(UZR,NSS)
      UZI(:,:) = Zero
      call ZJAC(NSS,ZR,ZI,NSS,UZR,UZI)
      do JXYZ=1,3
        ZXYZR(:,:,JXYZ) = -Half*MXYZR(:,:,JXYZ)
        ZXYZI(:,:,JXYZ) = -Half*MXYZI(:,:,JXYZ)
        call ZTRNSF(NSS,UZR,UZI,ZXYZR(:,:,JXYZ),ZXYZI(:,:,JXYZ))
      end do
      do ITSTEP=1,NTSTEP
        T = TSTART+TINCRE*(ITSTEP-1)
        RkT = T*BOLTZ
        RMAGM(:) = Zero
        RPART = Zero
        if (IPGLOB > 2) then
          write(u6,*)
          write(u6,'(2x,a14,3(4x,a4,4x),2x,a6)') 'Energy (cm^-1)','mu_x','mu_y','mu_z','weight'
          write(u6,*)
        end if
        do ISS=1,NSS
          DELTA = ZR(ISS,ISS)-ZR(1,1)
          FACT = exp(-DELTA/RkT)
          RMAGM(:) = RMAGM(:)+ZXYZR(ISS,ISS,:)*FACT
          RPART = RPART+FACT
          if (IPGLOB > 2) &
            write(u6,'(2x,f14.3,3(1x,f10.6,1x),2x,f6.3)') (ZR(ISS,ISS)-ZR(1,1))*auTocm,ZXYZR(ISS,ISS,1),ZXYZR(ISS,ISS,2), &
                                                          ZXYZR(ISS,ISS,3),FACT
        end do
        if (IPGLOB > 2) write(u6,*)
        RMAGM(:) = (RMAGM(:)/RPART)*AU2JTM
        RMAGMO = sqrt(sum(RMAGM(:)**2))
        do JXYZ=1,3
          LMSTEP = LMSTEP+1
          MAGM(LMSTEP) = RMAGM(JXYZ)
          if (IBSTEP > 1) then
            Chi(JXYZ) = RMAGM(JXYZ)-MAGM(LMSTEP-3*NTSTEP)
            Chi(JXYZ) = Chi(JXYZ)*Rmu0/BINCRE
          end if
        end do
        if (IBSTEP == 1) then
          write(u6,'(1x,f6.2,5(1x,es12.5,1x))') T,B,RMAGMO,RMAGM(1),RMAGM(2),RMAGM(3)
        else
          write(u6,'(1x,f6.2,8(1x,es12.5,1x))') T,B,RMAGMO,RMAGM(1),RMAGM(2),RMAGM(3),Chi(1),Chi(2),Chi(3)
        end if
      end do
    end do
  end do

  call mma_deallocate(MAGM)

  write(u6,*)

  ! powder magnetization, useful in nonlinear cases

  if (IFMCAL) then

    write(u6,*)
    write(u6,*) 'Powder Magnetization'
    write(u6,*)
    write(u6,'(3x,a1,3x,5(1x,a12,1x))') 'T','    B  (T)  ','   M (J/T)  ','  Mx (J/T)  ','  My (J/T)  ','  Mz (J/T)  '

    call mma_allocate(MAGM,3*NBSTEP*NTSTEP,Label='MAGM')
    MAGM(:) = Zero

    NPHISTEP = int(360.0_wp/BANGRES)
    NTHESTEP = int(180.0_wp/BANGRES)

    ! scale number of points on phi via sin(theta)
    NORIENT = 0
    do ITHE=1,NTHESTEP+1
      THE = BANGRES*(ITHE-1)*deg2rad
      IPHISTEP = int((NPHISTEP-1)*sin(THE)+1)
      BPHIRES = 360/IPHISTEP
      do IPHI=1,IPHISTEP
        PHI = BPHIRES*(IPHI-1)*deg2rad

        NORIENT = NORIENT+1

        LMSTEP = 0
        !write(u6,*)
        !write(u6,'(1x,2(A6,I4))') ' ITHE ',ITHE,' IPHI',IPHI
        !write(u6,'(6(5x,A4,5x))') ' B  ','THE ','PHI ',' Mx ',' My ',' Mz '
        do IBSTEP=1,NBSTEP
          B = BSTART+BINCRE*(IBSTEP-1)
          BX = B*sin(THE)*cos(PHI)
          BY = B*sin(THE)*sin(PHI)
          BZ = B*cos(THE)
          ZR(:,:) = Half/auToT*(BX*MXYZR(:,:,1)+BY*MXYZR(:,:,2)+BZ*MXYZR(:,:,3))
          ZI(:,:) = Half/auToT*(BX*MXYZI(:,:,1)+BY*MXYZI(:,:,2)+BZ*MXYZI(:,:,3))
          do ISS=1,NSS
            ZR(ISS,ISS) = ZR(ISS,ISS)+ENSOR(ISS)
          end do
          call unitmat(UZR,NSS)
          UZI(:,:) = Zero
          call ZJAC(NSS,ZR,ZI,NSS,UZR,UZI)
          do IXYZ=1,3
            ZXYZR(:,:,IXYZ) = -Half*MXYZR(:,:,IXYZ)
            ZXYZI(:,:,IXYZ) = -Half*MXYZI(:,:,IXYZ)
            call ZTRNSF(NSS,UZR,UZI,ZXYZR(:,:,IXYZ),ZXYZI(:,:,IXYZ))
          end do
          do ITSTEP=1,NTSTEP
            T = TSTART+TINCRE*(ITSTEP-1)
            RkT = T*BOLTZ
            RMAGM(:) = Zero
            RPART = Zero
            do ISS=1,NSS
              DELTA = ZR(ISS,ISS)-ZR(1,1)
              FACT = exp(-DELTA/RkT)
              RMAGM(:) = RMAGM(:)+ZXYZR(ISS,ISS,:)*FACT
              RPART = RPART+FACT
            end do
            RMAGM(:) = (RMAGM(:)/RPART)*AU2JTM
            !write(u6,'(6(1x,es12.5,1x))') B,THE,PHI,RMAGM(1),RMAGM(2),RMAGM(3)
            ! backtransformation in two steps, -phi and -theta
            A = RMAGM(1)
            B = RMAGM(2)
            RMAGM(1) = A*cos(PHI)+B*sin(PHI)
            RMAGM(2) = B*cos(PHI)-A*sin(PHI)
            A = RMAGM(1)
            B = RMAGM(3)
            RMAGM(1) = A*cos(THE)-B*sin(THE)
            RMAGM(3) = B*cos(THE)+A*sin(THE)
            do IXYZ=1,3
              LMSTEP = LMSTEP+1
              MAGM(LMSTEP) = MAGM(LMSTEP)+RMAGM(IXYZ)
            end do
          end do
        end do

      end do
    end do

    write(u6,*)
    LMSTEP = 0
    do IBSTEP=1,NBSTEP
      B = BSTART+BINCRE*(IBSTEP-1)
      do ITSTEP=1,NTSTEP
        T = TSTART+TINCRE*(ITSTEP-1)
        RMAGM(:) = MAGM(LMSTEP+1:LMSTEP+3)/NORIENT
        LMSTEP = LMSTEP+3
        RMAGMO = sqrt(sum(RMAGM(:)**2))
        write(u6,'(1x,f6.2,5(1x,es12.5,1x))') T,B,RMAGMO,RMAGM(1),RMAGM(2),RMAGM(3)
      end do
    end do

    call mma_deallocate(MAGM)

  end if

  write(u6,*)

  call mma_deallocate(ZR)
  call mma_deallocate(ZI)
  call mma_deallocate(UZR)
  call mma_deallocate(UZI)

  call mma_deallocate(MXYZR)
  call mma_deallocate(MXYZI)
  call mma_deallocate(ZXYZR)
  call mma_deallocate(ZXYZI)

end if

30 format(5X,A,1X,ES15.8)
31 format(5X,2(1X,A4),6X,A15,1X,A47,1X,A15)
32 format(5X,95('-'))
33 format(5X,2(1X,I4),5X,5(1X,ES15.8))
35 format(5X,31('-'))
36 format(5X,2(1X,I4),6X,15('-'),1X,ES15.8,1X,A15)
37 format(5X,2(1X,I4),6X,15('-'),1X,A15,1X,ES15.8)
38 format(5X,2(1X,I4),6X,F15.6,4(1X,ES15.8))
39 format(5X,2(1X,A4),6X,A15,1X,A15,1X,A15)
40 format(5X,63('-'))
43 format(12X,A8,6(1X,ES15.6))
44 format(20X,6(1X,A15))
49 format(5X,A,1X,ES15.8,1X,A)
!710 format(A4,4I4,4(2X,'('F12.8','F12.8')'))
!720 format(A4,2I4,4(2X,'('F12.8','F12.8')'))

contains

subroutine Allocate_and_Load_electric_dipoles(IFANY)

  integer(kind=iwp), intent(out) :: IFANY
  integer(kind=iwp) :: IPRDX, IPRDY, IPRDZ, ISOPR

  IPRDX = 0
  IPRDY = 0
  IPRDZ = 0
  IFANY = 0
  do ISOPR=1,NSOPR
    if ((SOPRNM(ISOPR) == 'MLTPL  1') .and. (SOPRTP(ISOPR) == 'HERMSING')) then
      IFANY = 1
      if (ISOCMP(ISOPR) == 1) IPRDX = ISOPR
      if (ISOCMP(ISOPR) == 2) IPRDY = ISOPR
      if (ISOCMP(ISOPR) == 3) IPRDZ = ISOPR
    end if
  end do
  call mma_allocate(DXR,NSS,NSS,Label='DXR')
  call mma_allocate(DXI,NSS,NSS,Label='DXI')
  call mma_allocate(DYR,NSS,NSS,Label='DYR')
  call mma_allocate(DYI,NSS,NSS,Label='DYI')
  call mma_allocate(DZR,NSS,NSS,Label='DZR')
  call mma_allocate(DZI,NSS,NSS,Label='DZI')
  DXR(:,:) = Zero
  DXI(:,:) = Zero
  DYR(:,:) = Zero
  DYI(:,:) = Zero
  DZR(:,:) = Zero
  DZI(:,:) = Zero
  if (IPRDX > 0) then
    call SMMAT(PROP,DXR,NSS,IPRDX,0)
    call ZTRNSF(NSS,USOR,USOI,DXR,DXI)
  end if
  if (IPRDY > 0) then
    call SMMAT(PROP,DYR,NSS,IPRDY,0)
    call ZTRNSF(NSS,USOR,USOI,DYR,DYI)
  end if
  if (IPRDZ > 0) then
    call SMMAT(PROP,DZR,NSS,IPRDZ,0)
    call ZTRNSF(NSS,USOR,USOI,DZR,DZI)
  end if

end subroutine Allocate_and_Load_electric_dipoles

subroutine Allocate_and_Load_velocities(IFANY)

  integer(kind=iwp), intent(out) :: IFANY
  integer(kind=iwp) :: IPRDX, IPRDY, IPRDZ, ISOPR

  IPRDX = 0
  IPRDY = 0
  IPRDZ = 0
  IFANY = 0
  do ISOPR=1,NSOPR
    if (SOPRNM(ISOPR) == 'VELOCITY') then
      IFANY = 1
      if (ISOCMP(ISOPR) == 1) IPRDX = ISOPR
      if (ISOCMP(ISOPR) == 2) IPRDY = ISOPR
      if (ISOCMP(ISOPR) == 3) IPRDZ = ISOPR
    end if
  end do
  call mma_allocate(DXR,NSS,NSS,Label='DXR')
  call mma_allocate(DXI,NSS,NSS,Label='DXI')
  call mma_allocate(DYR,NSS,NSS,Label='DYR')
  call mma_allocate(DYI,NSS,NSS,Label='DYI')
  call mma_allocate(DZR,NSS,NSS,Label='DZR')
  call mma_allocate(DZI,NSS,NSS,Label='DZI')
  DXR(:,:) = Zero
  DXI(:,:) = Zero
  DYR(:,:) = Zero
  DYI(:,:) = Zero
  DZR(:,:) = Zero
  DZI(:,:) = Zero
  if (IPRDX > 0) then
    call SMMAT(PROP,DXR,NSS,IPRDX,0)
    call ZTRNSF(NSS,USOR,USOI,DXR,DXI)
  end if
  if (IPRDY > 0) then
    call SMMAT(PROP,DYR,NSS,IPRDY,0)
    call ZTRNSF(NSS,USOR,USOI,DYR,DYI)
  end if
  if (IPRDZ > 0) then
    call SMMAT(PROP,DZR,NSS,IPRDZ,0)
    call ZTRNSF(NSS,USOR,USOI,DZR,DZI)
  end if

end subroutine Allocate_and_Load_velocities

subroutine Deallocate_electric_dipoles()

  call mma_deallocate(DXR)
  call mma_deallocate(DXI)
  call mma_deallocate(DYR)
  call mma_deallocate(DYI)
  call mma_deallocate(DZR)
  call mma_deallocate(DZI)

end subroutine Deallocate_electric_dipoles

subroutine Allocate_and_Load_magnetic_dipoles(IFANY)

  integer(kind=iwp), intent(out) :: IFANY
  integer(kind=iwp) :: IPRMDX, IPRMDY, IPRMDZ, ISOPR

  IPRMDX = 0
  IPRMDY = 0
  IPRMDZ = 0

  IFANY = 0
  do ISOPR=1,NSOPR
    if (SOPRNM(ISOPR) == 'ANGMOM') then
      IFANY = 1
      if (ISOCMP(ISOPR) == 1) IPRMDX = ISOPR
      if (ISOCMP(ISOPR) == 2) IPRMDY = ISOPR
      if (ISOCMP(ISOPR) == 3) IPRMDZ = ISOPR
    end if
  end do
  call mma_allocate(MDXR,NSS,NSS,Label='MDXR')
  call mma_allocate(MDXI,NSS,NSS,Label='MDXI')
  call mma_allocate(MDYR,NSS,NSS,Label='MDYR')
  call mma_allocate(MDYI,NSS,NSS,Label='MDYI')
  call mma_allocate(MDZR,NSS,NSS,Label='MDZR')
  call mma_allocate(MDZI,NSS,NSS,Label='MDZI')
  MDXR(:,:) = Zero
  MDXI(:,:) = Zero
  MDYR(:,:) = Zero
  MDYI(:,:) = Zero
  MDZR(:,:) = Zero
  MDZI(:,:) = Zero
  if (IPRMDX > 0) then
    call SMMAT(PROP,MDXR,NSS,IPRMDX,0)
    call ZTRNSF(NSS,USOR,USOI,MDXR,MDXI)
  end if
  if (IPRMDY > 0) then
    call SMMAT(PROP,MDYR,NSS,IPRMDY,0)
    call ZTRNSF(NSS,USOR,USOI,MDYR,MDYI)
  end if
  if (IPRMDZ > 0) then
    call SMMAT(PROP,MDZR,NSS,IPRMDZ,0)
    call ZTRNSF(NSS,USOR,USOI,MDZR,MDZI)
  end if

end subroutine Allocate_and_Load_magnetic_dipoles

subroutine Deallocate_magnetic_dipoles()

  call mma_deallocate(MDXR)
  call mma_deallocate(MDXI)
  call mma_deallocate(MDYR)
  call mma_deallocate(MDYI)
  call mma_deallocate(MDZR)
  call mma_deallocate(MDZI)

end subroutine Deallocate_magnetic_dipoles

subroutine Allocate_and_Load_Spin_Magnetic_dipoles(IFANY)

  integer(kind=iwp), intent(out) :: IFANY
  integer(kind=iwp) :: IPRSX, IPRSY, IPRSZ, ISOPR

  IPRSX = 0
  IPRSY = 0
  IPRSZ = 0

  IFANY = 0
  do ISOPR=1,NSOPR
    if ((SOPRNM(ISOPR) == 'MLTPL  0') .and. (SOPRTP(ISOPR) == 'ANTITRIP')) then
      IFANY = 1
      if (ISOCMP(ISOPR) == 1) IPRSX = ISOPR
      if (ISOCMP(ISOPR) == 1) IPRSY = ISOPR
      if (ISOCMP(ISOPR) == 1) IPRSZ = ISOPR
    end if
  end do
  call mma_allocate(SXR,NSS,NSS,Label='SXR')
  call mma_allocate(SXI,NSS,NSS,Label='SXI')
  call mma_allocate(SYR,NSS,NSS,Label='SYR')
  call mma_allocate(SYI,NSS,NSS,Label='SYI')
  call mma_allocate(SZR,NSS,NSS,Label='SZR')
  call mma_allocate(SZI,NSS,NSS,Label='SZI')
  SXR(:,:) = Zero
  SXI(:,:) = Zero
  SYR(:,:) = Zero
  SYI(:,:) = Zero
  SZR(:,:) = Zero
  SZI(:,:) = Zero
  if (IPRSX > 0) then
    call SMMAT(PROP,SXR,NSS,IPRSX,1)
    call ZTRNSF(NSS,USOR,USOI,SXR,SXI)
  end if
  if (IPRSY > 0) then
    call SMMAT(PROP,SYR,NSS,IPRSY,2)
    call ZTRNSF(NSS,USOR,USOI,SYR,SYI)
  end if
  if (IPRSZ > 0) then
    call SMMAT(PROP,SZR,NSS,IPRSZ,3)
    call ZTRNSF(NSS,USOR,USOI,SZR,SZI)
  end if

end subroutine Allocate_and_Load_Spin_Magnetic_dipoles

subroutine Deallocate_Spin_Magnetic_dipoles()

  call mma_deallocate(SXR)
  call mma_deallocate(SXI)
  call mma_deallocate(SYR)
  call mma_deallocate(SYI)
  call mma_deallocate(SZR)
  call mma_deallocate(SZI)

end subroutine Deallocate_Spin_Magnetic_dipoles

subroutine Allocate_and_Load_Spin_Magnetic_Quadrupoles(IFANY)

  integer(kind=iwp), intent(out) :: IFANY
  integer(kind=iwp) :: IPRSXY, IPRSXZ, IPRSYX, IPRSYZ, IPRSZX, IPRSZY, ISOPR

  IPRSXY = 0
  IPRSXZ = 0

  IPRSYX = 0
  IPRSYZ = 0

  IPRSZX = 0
  IPRSZY = 0
  IFANY = 0
  do ISOPR=1,NSOPR
    if ((SOPRNM(ISOPR) == 'MLTPL  1') .and. (SOPRTP(ISOPR) == 'ANTITRIP')) then
      IFANY = 1
      if (ISOCMP(ISOPR) == 1) IPRSXY = ISOPR
      if (ISOCMP(ISOPR) == 1) IPRSXZ = ISOPR

      if (ISOCMP(ISOPR) == 2) IPRSYX = ISOPR
      if (ISOCMP(ISOPR) == 2) IPRSYZ = ISOPR

      if (ISOCMP(ISOPR) == 3) IPRSZX = ISOPR
      if (ISOCMP(ISOPR) == 3) IPRSZY = ISOPR
    end if
  end do
  call mma_allocate(SZXR,NSS,NSS,Label='SZXR')
  call mma_allocate(SZXI,NSS,NSS,Label='SZXI')
  SZXR(:,:) = Zero
  SZXI(:,:) = Zero
  call mma_allocate(SXZR,NSS,NSS,Label='SXZR')
  call mma_allocate(SXZI,NSS,NSS,Label='SXZI')
  SXZR(:,:) = Zero
  SXZI(:,:) = Zero

  call mma_allocate(SXYR,NSS,NSS,Label='SXYR')
  call mma_allocate(SXYI,NSS,NSS,Label='SXYI')
  SXYR(:,:) = Zero
  SXYI(:,:) = Zero
  call mma_allocate(SYXR,NSS,NSS,Label='SYXR')
  call mma_allocate(SYXI,NSS,NSS,Label='SYXI')
  SYXR(:,:) = Zero
  SYXI(:,:) = Zero

  call mma_allocate(SYZR,NSS,NSS,Label='SYZR')
  call mma_allocate(SYZI,NSS,NSS,Label='SYZI')
  SYZR(:,:) = Zero
  SYZI(:,:) = Zero
  call mma_allocate(SZYR,NSS,NSS,Label='SZYR')
  call mma_allocate(SZYI,NSS,NSS,Label='SZYI')
  SZYR(:,:) = Zero
  SZYI(:,:) = Zero
  if (IPRSXY > 0) then
    call SMMAT(PROP,SXYR,NSS,IPRSXY,2)
    call ZTRNSF(NSS,USOR,USOI,SXYR,SXYI)
  end if
  if (IPRSYX > 0) then
    call SMMAT(PROP,SYXR,NSS,IPRSYX,1)
    call ZTRNSF(NSS,USOR,USOI,SYXR,SYXI)
  end if

  if (IPRSXZ > 0) then
    call SMMAT(PROP,SXZR,NSS,IPRSXZ,3)
    call ZTRNSF(NSS,USOR,USOI,SXZR,SXZI)
  end if
  if (IPRSZX > 0) then
    call SMMAT(PROP,SZXR,NSS,IPRSZX,1)
    call ZTRNSF(NSS,USOR,USOI,SZXR,SZXI)
  end if

  if (IPRSYZ > 0) then
    call SMMAT(PROP,SYZR,NSS,IPRSYZ,3)
    call ZTRNSF(NSS,USOR,USOI,SYZR,SYZI)
  end if
  if (IPRSZY > 0) then
    call SMMAT(PROP,SZYR,NSS,IPRSZY,2)
    call ZTRNSF(NSS,USOR,USOI,SZYR,SZYI)
  end if

end subroutine Allocate_and_Load_Spin_Magnetic_Quadrupoles

subroutine Deallocate_Spin_Magnetic_Quadrupoles()

  call mma_deallocate(SXYR)
  call mma_deallocate(SXYI)
  call mma_deallocate(SYXR)
  call mma_deallocate(SYXI)

  call mma_deallocate(SYZR)
  call mma_deallocate(SYZI)
  call mma_deallocate(SZYR)
  call mma_deallocate(SZYI)

  call mma_deallocate(SZXR)
  call mma_deallocate(SZXI)
  call mma_deallocate(SXZR)
  call mma_deallocate(SXZI)

end subroutine Deallocate_Spin_Magnetic_Quadrupoles

subroutine Allocate_and_Load_Electric_Quadrupoles(IFANY)

  integer(kind=iwp), intent(out) :: IFANY
  integer(kind=iwp) :: IPRDXX, IPRDXY, IPRDXZ, IPRDYY, IPRDYZ, IPRDZZ, ISOPR

  IPRDXX = 0
  IPRDXY = 0
  IPRDXZ = 0
  IPRDYY = 0
  IPRDYZ = 0
  IPRDZZ = 0

  IFANY = 0
  do ISOPR=1,NSOPR
    if (SOPRNM(ISOPR) == 'MLTPL  2') then
      IFANY = 1
      if (ISOCMP(ISOPR) == 1) IPRDXX = ISOPR
      if (ISOCMP(ISOPR) == 2) IPRDXY = ISOPR
      if (ISOCMP(ISOPR) == 3) IPRDXZ = ISOPR
      if (ISOCMP(ISOPR) == 4) IPRDYY = ISOPR
      if (ISOCMP(ISOPR) == 5) IPRDYZ = ISOPR
      if (ISOCMP(ISOPR) == 6) IPRDZZ = ISOPR
    end if
  end do
  call mma_allocate(QXXR,NSS,NSS,Label='QXXR')
  call mma_allocate(QXXI,NSS,NSS,Label='DXXI')
  call mma_allocate(QXYR,NSS,NSS,Label='DXYR')
  call mma_allocate(QXYI,NSS,NSS,Label='DXYI')
  call mma_allocate(QXZR,NSS,NSS,Label='DXZR')
  call mma_allocate(QXZI,NSS,NSS,Label='DXZI')
  call mma_allocate(QYYR,NSS,NSS,Label='DYYR')
  call mma_allocate(QYYI,NSS,NSS,Label='DYYI')
  call mma_allocate(QYZR,NSS,NSS,Label='DYZR')
  call mma_allocate(QYZI,NSS,NSS,Label='DYZI')
  call mma_allocate(QZZR,NSS,NSS,Label='DZZR')
  call mma_allocate(QZZI,NSS,NSS,Label='DZZI')
  QXXR(:,:) = Zero
  QXXI(:,:) = Zero
  QXYR(:,:) = Zero
  QXYI(:,:) = Zero
  QXZR(:,:) = Zero
  QXZI(:,:) = Zero
  QYYR(:,:) = Zero
  QYYI(:,:) = Zero
  QYZR(:,:) = Zero
  QYZI(:,:) = Zero
  QZZR(:,:) = Zero
  QZZI(:,:) = Zero
  if (IPRDXX > 0) then
    call SMMAT(PROP,QXXR,NSS,IPRDXX,0)
    call ZTRNSF(NSS,USOR,USOI,QXXR,QXXI)
  end if
  if (IPRDXY > 0) then
    call SMMAT(PROP,QXYR,NSS,IPRDXY,0)
    call ZTRNSF(NSS,USOR,USOI,QXYR,QXYI)
  end if
  if (IPRDXZ > 0) then
    call SMMAT(PROP,QXZR,NSS,IPRDXZ,0)
    call ZTRNSF(NSS,USOR,USOI,QXZR,QXZI)
  end if
  if (IPRDYY > 0) then
    call SMMAT(PROP,QYYR,NSS,IPRDYY,0)
    call ZTRNSF(NSS,USOR,USOI,QYYR,QYYI)
  end if
  if (IPRDYZ > 0) then
    call SMMAT(PROP,QYZR,NSS,IPRDYZ,0)
    call ZTRNSF(NSS,USOR,USOI,QYZR,QYZI)
  end if
  if (IPRDZZ > 0) then
    call SMMAT(PROP,QZZR,NSS,IPRDZZ,0)
    call ZTRNSF(NSS,USOR,USOI,QZZR,QZZI)
  end if

end subroutine Allocate_and_Load_Electric_Quadrupoles

subroutine Deallocate_Electric_Quadrupoles()

  call mma_deallocate(QXXR)
  call mma_deallocate(QXXI)
  call mma_deallocate(QXYR)
  call mma_deallocate(QXYI)
  call mma_deallocate(QXZR)
  call mma_deallocate(QXZI)
  call mma_deallocate(QYYR)
  call mma_deallocate(QYYI)
  call mma_deallocate(QYZR)
  call mma_deallocate(QYZI)
  call mma_deallocate(QZZR)
  call mma_deallocate(QZZI)

end subroutine Deallocate_Electric_Quadrupoles

subroutine Allocate_and_Load_Magnetic_Quadrupoles(IFANY)

  integer(kind=iwp), intent(out) :: IFANY
  integer(kind=iwp) :: IPRDYX, IPRDZX, IPRDZY, ISOPR

  IPRDXY = 0
  IPRDXZ = 0
  IPRDYX = 0
  IPRDYZ = 0
  IPRDZX = 0
  IPRDZY = 0

  IFANY = 0
  do ISOPR=1,NSOPR
    if (SOPRNM(ISOPR) == 'OMQ') then
      IFANY = 1
      if (ISOCMP(ISOPR) == 2) IPRDXY = ISOPR
      if (ISOCMP(ISOPR) == 3) IPRDXZ = ISOPR

      if (ISOCMP(ISOPR) == 4) IPRDYX = ISOPR
      if (ISOCMP(ISOPR) == 6) IPRDYZ = ISOPR

      if (ISOCMP(ISOPR) == 7) IPRDZX = ISOPR
      if (ISOCMP(ISOPR) == 8) IPRDZY = ISOPR
    end if
  end do

  call mma_allocate(MQXYR,NSS,NSS,Label='MQXYR')
  call mma_allocate(MQXYI,NSS,NSS,Label='MQXYI')
  call mma_allocate(MQYXR,NSS,NSS,Label='MQYXR')
  call mma_allocate(MQYXI,NSS,NSS,Label='MQYXI')
  call mma_allocate(MQXZR,NSS,NSS,Label='MQXZR')
  call mma_allocate(MQXZI,NSS,NSS,Label='MQXZI')
  call mma_allocate(MQZXR,NSS,NSS,Label='MQZXR')
  call mma_allocate(MQZXI,NSS,NSS,Label='MQZXI')
  call mma_allocate(MQYZR,NSS,NSS,Label='MQYZR')
  call mma_allocate(MQYZI,NSS,NSS,Label='MQYZI')
  call mma_allocate(MQZYR,NSS,NSS,Label='MQZYR')
  call mma_allocate(MQZYI,NSS,NSS,Label='MQZYI')
  MQXYR(:,:) = Zero
  MQXYI(:,:) = Zero
  MQYXR(:,:) = Zero
  MQYXI(:,:) = Zero
  MQXZR(:,:) = Zero
  MQXZI(:,:) = Zero
  MQZXR(:,:) = Zero
  MQZXI(:,:) = Zero
  MQYZR(:,:) = Zero
  MQYZI(:,:) = Zero
  MQZYR(:,:) = Zero
  MQZYI(:,:) = Zero
  if (IPRDXY > 0) then
    call SMMAT(PROP,MQXYR,NSS,IPRDXY,0)
    call ZTRNSF(NSS,USOR,USOI,MQXYR,MQXYI)
  end if
  if (IPRDYX > 0) then
    call SMMAT(PROP,MQYXR,NSS,IPRDYX,0)
    call ZTRNSF(NSS,USOR,USOI,MQYXR,MQYXI)
  end if

  if (IPRDXZ > 0) then
    call SMMAT(PROP,MQXZR,NSS,IPRDXZ,0)
    call ZTRNSF(NSS,USOR,USOI,MQXZR,MQXZI)
  end if
  if (IPRDZX > 0) then
    call SMMAT(PROP,MQZXR,NSS,IPRDZX,0)
    call ZTRNSF(NSS,USOR,USOI,MQZXR,MQZXI)
  end if

  if (IPRDYZ > 0) then
    call SMMAT(PROP,MQYZR,NSS,IPRDYZ,0)
    call ZTRNSF(NSS,USOR,USOI,MQYZR,MQYZI)
  end if
  if (IPRDZY > 0) then
    call SMMAT(PROP,MQZYR,NSS,IPRDZY,0)
    call ZTRNSF(NSS,USOR,USOI,MQZYR,MQZYI)
  end if

end subroutine Allocate_and_Load_Magnetic_Quadrupoles

subroutine Deallocate_Magnetic_Quadrupoles()

  call mma_deallocate(MQXYR)
  call mma_deallocate(MQXYI)
  call mma_deallocate(MQYXR)
  call mma_deallocate(MQYXI)
  call mma_deallocate(MQXZR)
  call mma_deallocate(MQXZI)
  call mma_deallocate(MQZXR)
  call mma_deallocate(MQZXI)
  call mma_deallocate(MQYZR)
  call mma_deallocate(MQYZI)
  call mma_deallocate(MQZYR)
  call mma_deallocate(MQZYI)

end subroutine Deallocate_Magnetic_Quadrupoles

subroutine Allocate_and_Load_Octupoles(IFANY)

  integer(kind=iwp), intent(out) :: IFANY
  integer(kind=iwp) :: IPRDXXX, IPRDXXY, IPRDXXZ, IPRDYYX, IPRDYYY, IPRDYYZ, IPRDZZX, IPRDZZY, IPRDZZZ, ISOPR

  ! This is a real symmetric rank 3 tensor so only 10 and not 27 is needed
  ! The order which comes in
  IPRDXXX = 0 !
  IPRDXXY = 0 !
  IPRDXXZ = 0 !

  !IPRDXYX = 0
  !IPRDXYY = 0 ! YYX These are the same due to symmetry
  !IPRDXYZ = 0 ! Not present

  !IPRDXZX = 0
  !IPRDXZY = 0
  !IPRDXZZ = 0 ! ZZX

  !IPRDYXX = 0
  !IPRDYXY = 0
  !IPRDYXZ = 0

  IPRDYYX = 0 ! Taking the XYY order
  IPRDYYY = 0 !
  IPRDYYZ = 0 !

  !IPRDYZX = 0
  !IPRDYZY = 0
  !IPRDYZZ = 0 ! ZZY

  !IPRDZXX = 0
  !IPRDZXY = 0
  !IPRDZXZ = 0

  !IPRDZYX = 0
  !IPRDZYY = 0
  !IPRDZYZ = 0

  IPRDZZX = 0 ! Taking order from XZZ
  IPRDZZY = 0 ! Taking order from YZZ
  IPRDZZZ = 0 !

  IFANY = 0
  do ISOPR=1,NSOPR
    if (SOPRNM(ISOPR) == 'MLTPL  3') then
      IFANY = 1
      if (ISOCMP(ISOPR) == 1) IPRDXXX = ISOPR
      if (ISOCMP(ISOPR) == 2) IPRDXXY = ISOPR
      if (ISOCMP(ISOPR) == 3) IPRDXXZ = ISOPR
      if (ISOCMP(ISOPR) == 4) IPRDYYX = ISOPR ! Changed from XYY
      !if (ISOCMP(ISOPR) == 5) IPRDXYZ = ISOPR
      if (ISOCMP(ISOPR) == 6) IPRDZZX = ISOPR ! Changed from XZZ
      if (ISOCMP(ISOPR) == 7) IPRDYYY = ISOPR
      if (ISOCMP(ISOPR) == 8) IPRDYYZ = ISOPR
      if (ISOCMP(ISOPR) == 9) IPRDZZY = ISOPR ! Changed from YZZ
      if (ISOCMP(ISOPR) == 10) IPRDZZZ = ISOPR
    end if
  end do
  call mma_allocate(DXXXR,NSS,NSS,Label='DXXXR')
  call mma_allocate(DXXXI,NSS,NSS,Label='DXXXI')
  call mma_allocate(DXXYR,NSS,NSS,Label='DXXYR')
  call mma_allocate(DXXYI,NSS,NSS,Label='DXXYI')
  call mma_allocate(DXXZR,NSS,NSS,Label='DXXZR')
  call mma_allocate(DXXZI,NSS,NSS,Label='DXXZI')
  DXXXR(:,:) = Zero
  DXXXI(:,:) = Zero
  DXXYR(:,:) = Zero
  DXXYI(:,:) = Zero
  DXXZR(:,:) = Zero
  DXXZI(:,:) = Zero
  call mma_allocate(DYYXR,NSS,NSS,Label='DYYXR')
  call mma_allocate(DYYXI,NSS,NSS,Label='DYYXI')
  call mma_allocate(DYYYR,NSS,NSS,Label='DYYYR')
  call mma_allocate(DYYYI,NSS,NSS,Label='DYYYI')
  call mma_allocate(DYYZR,NSS,NSS,Label='DYYZR')
  call mma_allocate(DYYZI,NSS,NSS,Label='DYYZI')
  DYYXR(:,:) = Zero
  DYYXI(:,:) = Zero
  DYYYR(:,:) = Zero
  DYYYI(:,:) = Zero
  DYYZR(:,:) = Zero
  DYYZI(:,:) = Zero
  call mma_allocate(DZZXR,NSS,NSS,Label='DZZXR')
  call mma_allocate(DZZXI,NSS,NSS,Label='DZZXI')
  call mma_allocate(DZZYR,NSS,NSS,Label='DZZYR')
  call mma_allocate(DZZYI,NSS,NSS,Label='DZZYI')
  call mma_allocate(DZZZR,NSS,NSS,Label='DZZZR')
  call mma_allocate(DZZZI,NSS,NSS,Label='DZZZI')
  DZZXR(:,:) = Zero
  DZZXI(:,:) = Zero
  DZZYR(:,:) = Zero
  DZZYI(:,:) = Zero
  DZZZR(:,:) = Zero
  DZZZI(:,:) = Zero
  if (IPRDXXX > 0) then
    call SMMAT(PROP,DXXXR,NSS,IPRDXXX,0)
    call ZTRNSF(NSS,USOR,USOI,DXXXR,DXXXI)
  end if
  if (IPRDXXY > 0) then
    call SMMAT(PROP,DXXYR,NSS,IPRDXXY,0)
    call ZTRNSF(NSS,USOR,USOI,DXXYR,DXXYI)
  end if
  if (IPRDXXZ > 0) then
    call SMMAT(PROP,DXXZR,NSS,IPRDXXZ,0)
    call ZTRNSF(NSS,USOR,USOI,DXXZR,DXXZI)
  end if

  if (IPRDYYX > 0) then
    call SMMAT(PROP,DYYXR,NSS,IPRDYYX,0)
    call ZTRNSF(NSS,USOR,USOI,DYYXR,DYYXI)
  end if
  if (IPRDYYY > 0) then
    call SMMAT(PROP,DYYYR,NSS,IPRDYYY,0)
    call ZTRNSF(NSS,USOR,USOI,DYYYR,DYYYI)
  end if
  if (IPRDYYZ > 0) then
    call SMMAT(PROP,DYYZR,NSS,IPRDYYZ,0)
    call ZTRNSF(NSS,USOR,USOI,DYYZR,DYYZI)
  end if

  if (IPRDZZX > 0) then
    call SMMAT(PROP,DZZXR,NSS,IPRDZZX,0)
    call ZTRNSF(NSS,USOR,USOI,DZZXR,DZZXI)
  end if
  if (IPRDZZY > 0) then
    call SMMAT(PROP,DZZYR,NSS,IPRDZZY,0)
    call ZTRNSF(NSS,USOR,USOI,DZZYR,DZZYI)
  end if
  if (IPRDZZZ > 0) then
    call SMMAT(PROP,DZZZR,NSS,IPRDZZZ,0)
    call ZTRNSF(NSS,USOR,USOI,DZZZR,DZZZI)
  end if

end subroutine Allocate_and_Load_Octupoles

subroutine deallocate_Octupoles()

  call mma_deallocate(DXXXR)
  call mma_deallocate(DXXXI)
  call mma_deallocate(DXXYR)
  call mma_deallocate(DXXYI)
  call mma_deallocate(DXXZR)
  call mma_deallocate(DXXZI)
  call mma_deallocate(DYYXR)
  call mma_deallocate(DYYXI)
  call mma_deallocate(DYYYR)
  call mma_deallocate(DYYYI)
  call mma_deallocate(DYYZR)
  call mma_deallocate(DYYZI)
  call mma_deallocate(DZZXR)
  call mma_deallocate(DZZXI)
  call mma_deallocate(DZZYR)
  call mma_deallocate(DZZYI)
  call mma_deallocate(DZZZR)
  call mma_deallocate(DZZZI)

end subroutine deallocate_Octupoles

end subroutine PRPROP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine optalf_cvb(heigval,gradp,nparm,hh,alfa,
     >  nnegeig,alfastart,alftol)
      implicit real*8 (a-h,o-z)
      dimension heigval(nparm),gradp(nparm)
      save zero,half,one
      data zero/0.d0/,half/0.5d0/,one/1.d0/

      alfa=alfastart

c  << Optimize alpha >>                             -1
c  Norm of dX should be HH in:  dX = - (H - alpha I)   * G
      olf=alfa
      alfmin=alfa
      alfmax=1.d2+alfmin

      relfac=one
700   alfmin=olf
      alfmx1=alfmax
      cnrmin=zero
      cnrmax=zero
      do 800 i=1,nnegeig
      cnrmin=cnrmin+(gradp(i)/(heigval(i)-alfmin))**2
      cnrmax=cnrmax+(gradp(i)/(heigval(i)-alfmax))**2
800   continue
      do 801 i=nnegeig+1,nparm
      cnrmin=cnrmin+(gradp(i)/(heigval(i)+alfmin))**2
      cnrmax=cnrmax+(gradp(i)/(heigval(i)+alfmax))**2
801   continue
      cnrmin=sqrt(cnrmin)
      cnrmax=sqrt(cnrmax)
900   alfa=half*(alfmax+alfmin)
      cnrm=zero
      do 1000 i=1,nnegeig
      cnrm=cnrm+(gradp(i)/(heigval(i)-alfa))**2
1000  continue
      do 1001 i=nnegeig+1,nparm
      cnrm=cnrm+(gradp(i)/(heigval(i)+alfa))**2
1001  continue
      cnrm=sqrt(cnrm)
      if(cnrm.lt.hh)then
        alfmax=alfa
        cnrmax=cnrm
      else
        alfmin=alfa
        cnrmin=cnrm
      endif
      if(abs(relfac*(alfmax-alfmin)).gt.alftol)goto 900
      if(alfmax.eq.alfmx1)then
        if(alfmax.gt.1d20)then
          write(6,*)' Optimization of trust region size failed!'
          write(6,*)' Trust region size required :',hh
          write(6,*)' Min/max alpha values :',alfmin,alfmax
          write(6,*)' Min/max step sizes :',cnrmin,cnrmax
          call abend_cvb()
        endif
        alfmax=1.d1*alfmax
        relfac=one/alfmax
        goto 700
      endif
c  Found the optimal alpha value, construct corresponding update :
      alfa=half*(alfmax+alfmin)

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine SIGDER(IVEC,JVEC,SCAL)

use Index_Functions, only: nTri_Elem
use Fockof, only: FAI, FAI_Full, FAT, FAT_Full, FIA, FIA_Full, FIT, FIT_Full, FTA, FTA_Full, FTI, FTI_Full, IOFFIA, IOFFIT, IOFFTA
use EQSOLV, only: IFCOUP
#if defined(_MOLCAS_MPP_) && defined(_GA_)
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: GA_Destroy
#endif
use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array, GA_Arrays
use caspt2_global, only: FIFA, idSDMat, LISTS, LUSTD
use caspt2_module, only: CPUSGM, FockType, G1SecIn, nActEl, nAsh, nASup, nCases, nInDep, nIsh, nISup, nOrb, nSsh, nSym, TIOSGM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iVec, jVec
real(kind=wp), intent(in) :: Scal
integer(kind=iwp) :: iCase, iCase1, idSDer, IfC, IFIFA, iLoop, IMLTOP, ISYM, ISYM1, ISYM2, lCX, lg_CX, lg_D2, lg_Sgm2, Lg_SgmX, &
                     lg_V1, lSgmX, lSgmX_Sta, Max_MESG_SIZE, NA, NAS, NAS1, NAS2, nCX, nD1, NFIA, NFIT, NFTA, NI, NIN1, NIN2, &
                     NIS1, NIS2, nLoop, NO, NS, nSgm1, nSgm2, lSgm2_Sta, nD2, iCase2, nSgm2_Blk, nSgmX, nSgmX_Blk, MaxLen
real(kind=wp) :: CPU, CPU0, CPU1, FACT, TIO, TIO0, TIO1
real(kind=wp), allocatable :: D1(:), D2(:), SDER1(:), SDER2(:), SGM1(:), SGM2(:), WRK(:)
#if defined(_MOLCAS_MPP_) && defined(_GA_)
logical(kind=iwp) :: bStat
#endif

! Work in the MO basis
! We need both explicit and implicit overlap derivatives. The latter
! comes from the derivative of the transformation matrix.

! p,q: inactive or secondary
! y,z: active (t,u)
! a,b: internally contracted
! T1_{px} * S1_{xy} f_{yz} * T2_{pz}
! = T1pa*C1xa * S1xy * fyz * T2pb*C2zb
! Derivative of S1:
! = (T1Ct1)px * (T2Ct2*f)py * dS1xy/da
! Derivative of C1 (or, Lagrangian multiplier in MO basis):
! = T1pa*dC1xa/da * S1xy * fyz * T2pb*C2zb
!   ...
! = -1/2 (T1Ct1)pu * dS1tu/da * (T2Ct2*f*S1C1*Ct1)pt
! Derivative of C2 (or, Lagrangian multiplier in MO basis):
! = T1pa*C1xa * S1xy * fyz * T2pb*dC2zb/da
!   ...
! = -1/2 (T1Ct1St1*f*C2*Ct2)pt * (T2Ct2)pu * dS2tu/da

! About IMLTOP for the SGM subroutine
! With IMLTOP=0: the vector for the second argument has to be
! contravariant form (T*C),
! With IMLTOP=1: the vector for the first  argument has to be
! covariant form (T*SC),

! Allocate some matrices for storing overlap and transformation
! derivatives. Here constructs these derivatives in the MO basis,
! but not in the internally contracted basis.

MaxLen = maxval(nASUP(1:nSym,1:11)**2)

call mma_allocate(WRK,MaxLen,Label='WRK')
WRK(:) = Zero

do iCase=1,11
  do iSym=1,nSym
    nAS = nASUP(iSym,iCase)
    idSDer = idSDMat(iSym,iCase)
    call DDAFILE(LuSTD,1,WRK,nAS*nAS,idSDer)
  end do
end do
call mma_deallocate(WRK)

! If the G1 correction to the Fock matrix is used, then the
! inactive/virtual coupling elements (which are non-zero for the
! case of average CASSCF) cannot be used in the CASPT2 equations.
if ((FOCKTYPE == 'G1') .and. (.not. G1SECIN)) then
  IFCOUP(12,5) = 0
  IFCOUP(13,5) = 0
end if

! Transform to standard representation:
call PTRTOC(0,IVEC,IVEC) !! T*C (internally contracted -> MO)
if (IVEC /= JVEC) call PTRTOC(0,JVEC,JVEC)

! Set up non-diagonal blocks of Fock matrix:
! SVC: add transposed fock matrix blocks
NFIT = 0
NFIA = 0
NFTA = 0
do ISYM=1,NSYM
  NI = NISH(ISYM)
  NA = NASH(ISYM)
  NS = NSSH(ISYM)
  IOFFIT(ISYM) = NFIT
  IOFFIA(ISYM) = NFIA
  IOFFTA(ISYM) = NFTA
  NFIT = NFIT+NA*NI
  NFIA = NFIA+NS*NI
  NFTA = NFTA+NS*NA
end do
NFIT = NFIT+1
NFIA = NFIA+1
NFTA = NFTA+1

call mma_allocate(FIT_Full,NFIT,Label='FIT_Full')
call mma_allocate(FTI_Full,NFIT,Label='FTI_Full')

call mma_allocate(FIA_Full,NFIA,Label='FIA_Full')
call mma_allocate(FAI_Full,NFIA,Label='FAI_Full')

call mma_allocate(FTA_Full,NFTA,Label='FTA_Full')
call mma_allocate(FAT_Full,NFTA,Label='FAT_Full')

IFIFA = 1
do ISYM=1,NSYM
  NI = NISH(ISYM)
  NA = NASH(ISYM)
  NS = NSSH(ISYM)
  NO = NORB(ISYM)

  FIT(ISYM)%A(1:NA*NI) => FIT_Full(IOFFIT(ISYM)+1:IOFFIT(ISYM)+NA*NI)
  FTI(ISYM)%A(1:NA*NI) => FTI_Full(IOFFIT(ISYM)+1:IOFFIT(ISYM)+NA*NI)

  FIA(ISYM)%A(1:NS*NI) => FIA_Full(IOFFIA(ISYM)+1:IOFFIA(ISYM)+NS*NI)
  FAI(ISYM)%A(1:NS*NI) => FAI_Full(IOFFIA(ISYM)+1:IOFFIA(ISYM)+NS*NI)

  FTA(ISYM)%A(1:NS*NA) => FTA_Full(IOFFTA(ISYM)+1:IOFFTA(ISYM)+NS*NA)
  FAT(ISYM)%A(1:NS*NA) => FAT_Full(IOFFTA(ISYM)+1:IOFFTA(ISYM)+NS*NA)

  call FBLOCK(FIFA(IFIFA),NO,NI,NA,NS,FIT(ISYM)%A(:),FTI(ISYM)%A(:),FIA(ISYM)%A(:),FAI(ISYM)%A(:),FTA(ISYM)%A(:),FAT(ISYM)%A(:))

  IFIFA = IFIFA+nTri_Elem(NO)

end do

call TIMING(CPU0,CPU,TIO0,TIO)

! Is it possible to reduce to one loop? We have to compute bra and
! ket overlap and bra and ket wavefunctions are not identical, so
! it seems impossible to reduce?

NLOOP = 2
do ILOOP=1,NLOOP
  !! ILOOP1 : <T+lambda|H|T       >
  !! ILOOP2 : <T       |H|T+lambda>

  ! Loop over types and symmetry block of sigma vector:
  do ICASE1=1,11
    !do ICASE1=1,NCASES
    do ISYM1=1,NSYM
      if (NINDEP(ISYM1,ICASE1) == 0) cycle
      NIS1 = NISUP(ISYM1,ICASE1)
      NAS1 = NASUP(ISYM1,ICASE1)
      NIN1 = NINDEP(ISYM1,ICASE1)
      NSGM2 = NIS1*NAS1
      if (NSGM2 == 0) cycle

      call mma_allocate(SGM2,NSGM2,Label='SGM2')
      SGM2(:) = Zero

      NSGM1 = 0
      !LSGM1 = 1
      if (ICASE1 == 1) then
        NSGM1 = NASH(ISYM1)*NISH(ISYM1)
      else if (ICASE1 == 4) then
        NSGM1 = NASH(ISYM1)*NSSH(ISYM1)
      else if ((ICASE1 == 5) .and. (ISYM1 == 1)) then
        NSGM1 = NIS1
      end if
      call mma_allocate(SGM1,max(1,NSGM1),Label='SGM1')
      SGM1(:) = Zero

      IMLTOP = 0
      do ICASE2=ICASE1+1,NCASES
        IFC = IFCOUP(ICASE2,ICASE1)
        if (IFC == 0) cycle
        do ISYM2=1,NSYM
          if (NINDEP(ISYM2,ICASE2) == 0) cycle
          NIS2 = NISUP(ISYM2,ICASE2)
          NAS2 = NASUP(ISYM2,ICASE2)
          NCX = NIS2*NAS2
          if (NCX == 0) cycle

          call RHS_ALLO(NAS2,NIS2,lg_CX)
          call RHS_READ(NAS2,NIS2,lg_CX,ICASE2,ISYM2,IVEC)
          if ((IVEC /= JVEC) .and. (ILOOP == 2)) then
            !! T = T + \lambda
            if (SCAL /= One) call RHS_SCAL(NAS2,NIS2,lg_CX,SCAL)
            call RHS_ALLO(NAS2,NIS2,lg_V1)
            call RHS_READ(NAS2,NIS2,lg_V1,ICASE2,ISYM2,JVEC)
            call RHS_DAXPY(NAS2,NIS2,One,lg_V1,lg_CX)
            call RHS_FREE(lg_V1)
          end if
          ! SVC: for case H (12,13) we can now pass the distributed array ID to
          ! the SGM subroutines
          if ((ICASE2 == 12) .or. (ICASE2 == 13)) then
            LCX = lg_CX
            !XTST = RHS_DDOT(NAS2,NIS2,lg_CX,lg_CX)
          else
            LCX = Allocate_GA_Array(NCX,'CX')
            call RHS_GET(NAS2,NIS2,lg_CX,GA_Arrays(LCX)%A)
            call RHS_FREE(lg_CX)
            !XTST = DDOT_(NCX,GA_Arrays(LCX)%A,1,GA_Arrays(LCX)%A,1)
          end if

#         ifdef _DEBUGPRINT_
          write(u6,*) ' ISYM1,ICASE1:',ISYM1,ICASE1
          write(u6,*) ' ISYM2,ICASE2:',ISYM2,ICASE2
          write(u6,*) ' SIGMA calling SGM with IMLTOP=',IMLTOP
#         endif
          ! Compute contribution SGM2 <- CX, and SGM1 <- CX  if any
          call SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,SGM1,size(SGM1),SGM2,size(SGM2),LCX,LISTS,size(LISTS))

          if ((ICASE2 == 12) .or. (ICASE2 == 13)) then
            call RHS_FREE(lg_CX)
          else
            call Deallocate_GA_Array(LCX)
          end if
        end do
      end do

      !-SVC: sum the replicate arrays:
      MAX_MESG_SIZE = 2**27
      do LSGM2_STA=1,NSGM2,MAX_MESG_SIZE
        NSGM2_BLK = min(MAX_MESG_SIZE,NSGM2-LSGM2_STA+1)
        call GADGOP(SGM2(LSGM2_STA),NSGM2_BLK,'+')
      end do

      if (NSGM1 > 0) call GADGOP(SGM1,NSGM1,'+')

      ! If there are 1-electron contributions, add them into the 2-el
      ! part (This requires a non-empty active space.)
      if (NSGM1 > 0) then
        FACT = One/real(max(1,NACTEL),kind=wp)
        if (ICASE1 == 1) then
          call SPEC1A(IMLTOP,FACT,ISYM1,SGM2,size(SGM2),SGM1,size(SGM1))
        else if (ICASE1 == 4) then
          call SPEC1C(IMLTOP,FACT,ISYM1,SGM2,size(SGM2),SGM1,size(SGM1))
        else if ((ICASE1 == 5) .and. (ISYM1 == 1)) then
          call SPEC1D(IMLTOP,FACT,SGM2,size(SGM2),SGM1,size(SGM1))
        end if
      end if
      call mma_deallocate(SGM1)

      !-SVC: no need for the replicate arrays any more, fall back to one array
      call RHS_ALLO(NAS1,NIS1,lg_SGM2)
      call RHS_PUT(NAS1,NIS1,lg_SGM2,SGM2)
      call mma_deallocate(SGM2)

      ! Add to sigma array. Multiply by S to  lower index.
      !call RHS_ALLO(NAS1,NIS1,lg_SGMX)
      !call RHS_READ(NAS1,NIS1,lg_SGMX,ICASE1,ISYM1,JVEC)
      if (ICASE1 <= 11) then
        call RHS_ALLO(NAS1,NIS1,lg_CX)
        call RHS_READ(NAS1,NIS1,lg_CX,ICASE1,ISYM1,IVEC)
        if ((IVEC /= JVEC) .and. (ILOOP == 1)) then
          !! T = T + \lambda
          if (SCAL /= One) call RHS_SCAL(NAS1,NIS1,lg_CX,SCAL)
          call RHS_ALLO(NAS1,NIS1,lg_V1)
          call RHS_READ(NAS1,NIS1,lg_V1,ICASE1,ISYM1,JVEC)
          call RHS_DAXPY(NAS1,NIS1,One,lg_V1,lg_CX)
          call RHS_FREE(lg_V1)
        end if

        call mma_allocate(SDER1,NAS1*NAS1,Label='SDER1')
        idSDer = idSDMat(iSym1,iCase1)
        call DDAFILE(LuSTD,2,SDER1,nAS1*nAS1,idSDer)

        call C1S1DER(SDER1,NAS1*NAS1)

        idSDer = idSDMat(iSym1,iCase1)
        call DDAFILE(LuSTD,1,SDER1,nAS1*nAS1,idSDer)
        call mma_deallocate(SDER1)

        call RHS_FREE(lg_CX)
      end if

      !if ((ICASE1 /= 12) .and. (ICASE1 /= 13)) then
      !  call RHS_STRANS(NAS1,NIS1,ALPHA,lg_SGM2,lg_SGMX,ICASE1,ISYM1)
      !else
      !  call RHS_DAXPY(NAS1,NIS1,ALPHA,lg_SGM2,lg_SGMX)
      !end if
      call RHS_FREE(lg_SGM2)

      ! Write SGMX to disk.
      !call RHS_SAVE(NAS1,NIS1,lg_SGMX,ICASE1,ISYM1,JVEC)
      !call RHS_FREE(lg_SGMX)
    end do
  end do

  IMLTOP = 1
  ! Loop over types and symmetry block of CX vector:
  do ICASE1=1,11
    !do ICASE1=1,NCASES
    do ISYM1=1,NSYM
      if (NINDEP(ISYM1,ICASE1) == 0) cycle
      NIS1 = NISUP(ISYM1,ICASE1)
      NAS1 = NASUP(ISYM1,ICASE1)
      ND2 = NIS1*NAS1
      if (ND2 == 0) cycle

      call RHS_ALLO(NAS1,NIS1,lg_D2)
      call RHS_SCAL(NAS1,NIS1,lg_D2,Zero)
      ! Contract S*CX to form D2. Also form D1 from D2, if needed.

      NCX = ND2
      call RHS_ALLO(NAS1,NIS1,lg_CX)
      call RHS_READ(NAS1,NIS1,lg_CX,ICASE1,ISYM1,IVEC)

      if ((IVEC /= JVEC) .and. (ILOOP == 1)) then
        !! T = T + \lambda
        if (SCAL /= One) call RHS_SCAL(NAS1,NIS1,lg_CX,SCAL)
        call RHS_ALLO(NAS1,NIS1,lg_V1)
        call RHS_READ(NAS1,NIS1,lg_V1,ICASE1,ISYM1,JVEC)
        call RHS_DAXPY(NAS1,NIS1,One,lg_V1,lg_CX)
        call RHS_FREE(lg_V1)
      end if

      if ((ICASE1 /= 12) .and. (ICASE1 /= 13)) then
        call RHS_STRANS(NAS1,NIS1,One,lg_CX,lg_D2,ICASE1,ISYM1)
      else
        call RHS_DAXPY(NAS1,NIS1,One,lg_CX,lg_D2)
      end if
      call RHS_FREE(lg_CX)

      call mma_allocate(D2,ND2,Label='D2')
      call RHS_GET(NAS1,NIS1,lg_D2,D2)
      call RHS_FREE(lg_D2)

      ND1 = 0
      !LD1 = 1
      IMLTOP = 1
      FACT = One/real(max(1,NACTEL),kind=wp)
      if (ICASE1 == 1) then
        ND1 = NASH(ISYM1)*NISH(ISYM1)
        if (ND1 > 0) then
          call mma_allocate(D1,ND1,Label='D1')
          D1(:) = Zero
          call SPEC1A(IMLTOP,FACT,ISYM1,D2,size(D2),D1,size(D1))
        end if
      else if (ICASE1 == 4) then
        ND1 = NASH(ISYM1)*NSSH(ISYM1)
        if (ND1 > 0) then
          call mma_allocate(D1,ND1,Label='D1')
          D1(:) = Zero
          call SPEC1C(IMLTOP,FACT,ISYM1,D2,size(D2),D1,size(D1))
        end if
      else if ((ICASE1 == 5) .and. (ISYM1 == 1)) then
        ND1 = NIS1
        if (ND1 > 0) then
          call mma_allocate(D1,ND1,Label='D1')
          D1(:) = Zero
          call SPEC1D(IMLTOP,FACT,D2,size(D2),D1,size(D1))
        end if
      end if
      if (.not. allocated(D1)) call mma_allocate(D1,1,Label='D1')

      !! No need to compute for ICASE2 = 12 and 13
      do ICASE2=ICASE1+1,11 !! NCASES
        if (IFCOUP(ICASE2,ICASE1) == 0) cycle
        do ISYM2=1,NSYM
          if (NINDEP(ISYM2,ICASE2) == 0) cycle
          NIS2 = NISUP(ISYM2,ICASE2)
          NAS2 = NASUP(ISYM2,ICASE2)
          NIN2 = NINDEP(ISYM2,ICASE2)
          NSGMX = NIS2*NAS2
          if (NSGMX == 0) cycle

          if ((ICASE2 == 12) .or. (ICASE2 == 13)) then
            call RHS_ALLO(NAS2,NIS2,lg_SGMX)
            call RHS_READ(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
            LSGMX = lg_SGMX
          else
            LSGMX = Allocate_GA_Array(NSGMX,'SGMX')
          end if

#         ifdef _DEBUGPRINT_
          write(u6,*) ' ISYM1,ICASE1:',ISYM1,ICASE1
          write(u6,*) ' ISYM2,ICASE2:',ISYM2,ICASE2
          write(u6,*) ' SIGMA calling SGM with IMLTOP=',IMLTOP
#         endif
          ! Compute contribution SGMX <- D2, and SGMX <- D1  if any
          call SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,D1,size(D1),D2,size(D2),LSGMX,LISTS,size(LISTS))
          !if (iCase2 <= 11) then
          !end if

          if ((ICASE2 /= 12) .and. (ICASE2 /= 13)) then
            MAX_MESG_SIZE = 2**27
            do LSGMX_STA=1,NSGMX,MAX_MESG_SIZE
              NSGMX_BLK = min(MAX_MESG_SIZE,NSGMX-LSGMX_STA+1)
              call GADGOP(GA_Arrays(LSGMX)%A(LSGMX_STA),NSGMX_BLK,'+')
            end do
            !call RHS_ALLO(NAS2,NIS2,lg_SGMX)
            !call RHS_READ(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
            !call RHS_ADD(NAS2,NIS2,lg_SGMX,GA_Array(LSGMX)%A)
            !! do C2DER
            call mma_allocate(SDER2,NAS2*NAS2,Label='SDER2')
            idSDer = idSDMat(iSym2,iCase2)
            call DDAFILE(LuSTD,2,SDER2,nAS2*nAS2,idSDer)

            call C2DER(SDER2,NAS2*NAS2)

            idSDer = idSDMat(iSym2,iCase2)
            call DDAFILE(LuSTD,1,SDER2,nAS2*nAS2,idSDer)
            call mma_deallocate(SDER2)

            !call Deallocate_GA_Array(LSGMX)
          end if

          !-SVC: no need for the replicate arrays any more, fall back to one array
          !call RHS_SAVE(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
          if ((ICASE2 == 12) .or. (ICASE2 == 13)) then
            call RHS_FREE(lg_SGMX)
          else
            call Deallocate_GA_Array(LSGMX)
          end if
        end do
      end do
      call mma_deallocate(D2)
      call mma_deallocate(D1)
    end do
  end do

end do

call TIMING(CPU1,CPU,TIO1,TIO)
CPUSGM = CPUSGM+(CPU1-CPU0)
TIOSGM = TIOSGM+(TIO1-TIO0)

call mma_deallocate(FIT_Full)
call mma_deallocate(FTI_Full)
call mma_deallocate(FIA_Full)
call mma_deallocate(FAI_Full)
call mma_deallocate(FTA_Full)
call mma_deallocate(FAT_Full)
do iSym=1,nSym
  nullify(FIT(iSym)%A,FTI(iSym)%A,FIA(iSym)%A,FAI(iSym)%A,FTA(iSym)%A,FAT(iSym)%A)
end do

! Transform contrav C  to ei%Agenbasis of H0(diag):
call PTRTOSR(1,IVEC,IVEC)
if (IVEC /= JVEC) call PTRTOSR(1,JVEC,JVEC)

contains

subroutine C1S1DER(SDER,nSDER)

  integer(kind=iwp), intent(in) :: nSDER
  real(kind=wp), intent(inout) :: SDER(nSDER)
  integer(kind=iwp) :: iType
# if defined(_MOLCAS_MPP_) && defined(_GA_)
  integer(kind=iwp) :: lg_SDER
# endif

  ! (T2Ct2*f)py * (T1Ct1)pz * dS1yz/da
  ! -1/2 (T2Ct2*f*S1*C1*Ct1)pt * (T1Ct1)pu * dS1tu/da

  !! Finalize the derivative of S1
  !! 2S. (T2Ct2*f) * T1Ct1
# if defined(_MOLCAS_MPP_) && defined(_GA_)
  if (is_real_par()) then
    call GA_CREATE_STRIPED('H',NAS1,NAS1,'SDER',lg_SDER)
    call GA_PUT(lg_SDER,1,NAS1,1,NAS1,SDER,NAS1)
    call GA_DGEMM('N','T',NAS1,NAS1,NIS1,Two,lg_CX,lg_SGM2,One,lg_SDER)
  else
# endif
    call DGEMM_('N','T',NAS1,NAS1,NIS1,Two,GA_Arrays(lg_CX)%A,NAS1,GA_Arrays(lg_SGM2)%A,NAS1,One,SDER,NAS1)
# if defined(_MOLCAS_MPP_) && defined(_GA_)
  end if
# endif
  !do i=1,nas1*nis1
  !  write(u6,'(i4,2f20.10)') ,i,GA_Arrays(lg_cx)%A(i),GA_Arrays(lg_sgm2)%A(i)
  !end do

  !! Next, the derivative of C1
  !! 2C. (T2Ct2*f) * S1*C1 (MO -> IC)
  !!     lg_T * lg_V2 -> lg_V1
  call RHS_ALLO(NIN1,NIS1,lg_V1)
  ITYPE = 1
  !! SGM2 is local quantity, so put this in GA?
  call RHS_SR2C(ITYPE,1,NAS1,NIS1,NIN1,lg_V1,lg_SGM2,ICASE1,ISYM1)
  !! 3C. (T2Ct2*f) * S1*C1 * Ct1 (IC -> MO)
  !!     lg_T * lg_V1 -> lg_V2
  ITYPE = 0
  call RHS_SR2C(ITYPE,0,NAS1,NIS1,NIN1,lg_V1,lg_SGM2,ICASE1,ISYM1)
  call RHS_FREE(lg_V1)

  !! 4C. (T1Ct1*f) * (T2Ct2St2*f*C1*Ct1)
# if defined(_MOLCAS_MPP_) && defined(_GA_)
  if (is_real_par()) then
    call GA_DGEMM('N','T',NAS1,NAS1,NIS1,-One,lg_CX,lg_SGM2,One,lg_SDER)
    call GA_GET(lg_SDER,1,NAS1,1,NAS1,SDER,NAS1)
    bStat = GA_destroy(lg_SDER)
  else
# endif
    call DGEMM_('N','T',NAS1,NAS1,NIS1,-One,GA_Arrays(lg_CX)%A,NAS1,GA_Arrays(lg_SGM2)%A,NAS1,One,SDER,NAS1)
# if defined(_MOLCAS_MPP_) && defined(_GA_)
  end if
# endif

end subroutine C1S1DER

subroutine C2DER(SDER,nSDER)

  integer(kind=iwp), intent(in) :: nSDER
  real(kind=wp), intent(inout) :: SDER(nSDER)
  integer(kind=iwp) :: iType, lg_Sgm, lg_v2
# if defined(_MOLCAS_MPP_) && defined(_GA_)
  integer(kind=iwp) :: lg_SDER
# endif

  ! -1/2 (T2Ct2)pu * dS2tu/da * (T1Ct1St1*f*C2*Ct2)pt

# if defined(_MOLCAS_MPP_) && defined(_GA_)
  if (is_real_par()) then
    call GA_CREATE_STRIPED('V',NAS2,NIS2,'SDER',lg_SGMX)
    call GA_PUT(lg_SGMX,1,NAS2,1,NIS2,GA_Arrays(LSGMX)%A,NAS2)
  else
# endif
    lg_SGMX = LSGMX
# if defined(_MOLCAS_MPP_) && defined(_GA_)
  end if
# endif

  !! For icase = 12 or 13, there is no need to transform,
  !! so LTMP is always replicated, but T for A and C are
  !! distributed?, so...
  call RHS_ALLO(NIN2,NIS2,lg_V2)
  !! 2. (T1Ct1St1*f) * C2 (MO -> IC; LTMP -> LTMP2)
  ITYPE = 0
  call RHS_SR2C(ITYPE,1,NAS2,NIS2,NIN2,lg_V2,lg_SGMX,ICASE2,ISYM2)
  !! 3. (T1Ct1St1*f) * C2 * Ct2 (IC -> MO; LTMP2 -> LTMP)
  call RHS_SR2C(ITYPE,0,NAS2,NIS2,NIN2,lg_V2,lg_SGMX,ICASE2,ISYM2)
  call RHS_FREE(lg_V2)

  !! 4. (T2Ct2*f) * (T1Ct1St1*f*C2*Ct2)
  call RHS_ALLO(NAS2,NIS2,lg_SGM)
  call RHS_READ(NAS2,NIS2,lg_SGM,ICASE2,ISYM2,IVEC)
  if ((IVEC /= JVEC) .and. (ILOOP == 2)) then
    !! T = T + \lambda
    if (SCAL /= One) call RHS_SCAL(NAS2,NIS2,lg_SGM,SCAL)
    call RHS_ALLO(NAS2,NIS2,lg_V1)
    call RHS_READ(NAS2,NIS2,lg_V1,ICASE2,ISYM2,JVEC)
    call RHS_DAXPY(NAS2,NIS2,One,lg_V1,lg_SGM)
    call RHS_FREE(lg_V1)
  end if
# if defined(_MOLCAS_MPP_) && defined(_GA_)
  if (is_real_par()) then
    call GA_CREATE_STRIPED('H',NAS2,NAS2,'SDER',lg_SDER)
    call GA_PUT(lg_SDER,1,NAS2,1,NAS2,SDER,NAS2)
    call GA_DGEMM('N','T',NAS2,NAS2,NIS2,-One,lg_SGM,lg_SGMX,One,lg_SDER)
    call GA_GET(lg_SDER,1,NAS2,1,NAS2,SDER,NAS2)
    bStat = GA_destroy(lg_SGMX)
    bStat = GA_destroy(lg_SDER)
  else
# endif
    call DGEMM_('N','T',NAS2,NAS2,NIS2,-One,GA_Arrays(lg_SGM)%A,NAS2,GA_Arrays(LSGMX)%A,NAS2,One,SDER,NAS2)
# if defined(_MOLCAS_MPP_) && defined(_GA_)
  end if
# endif
  call RHS_FREE(lg_SGM)

end subroutine C2DER

end subroutine sigder

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CalcDT(nMult,nGrdPt,natom,nAtQM,ipIsMM,iGrdTyp,Coord,
     &                  Grid,DGrid,T,TT,DT,DTT,DTTTT,DTTT)
      Implicit Real*8 (A-H,O-Z)
*
*     The dependancy of T with respect to grid points is taken
*     into account if the GEPOL grid is used (iGrdTyp == 2)
*
*     1) dT    = dT/dx + Sum_k dT/dq_k * dq_k/dx
*     2) dTT   = (dTt.T+Tt.dT)
*     3) dTTTT = (dTt.T+Tt.dT)((TtT)**-1)
*     4) dTT   = d((TtT)**-1) = -((TtT)**-1)(dTt.T+Tt.dT)((TtT)**-1)
*     5) dTTT = d((TtT)**-1)*Tt + ((TtT)**-1)*dTt
*
*
#include "espf.fh"
*
      Dimension Coord(3,natom),Grid(3,nGrdPt),DGrid(nGrdPt,nAtQM,3,3),
     &          T(nMult,nGrdPt),TT(nMult,nMult),
     &          DT(nMult,nGrdPt,3,nAtQM),DTT(nMult,nMult,3,nAtQM),
     &          DTTTT(nMult,nMult,3,nAtQM),DTTT(nMult,nGrdPt,3,nAtQM)
*
*     Very local array
*
      Dimension DG(3,3)
*
      iPL = iPL_espf()
*
      nOrd = nMult/nAtQM
*
*     Step 1
*
      iQM = 0
      Do iPnt = 1, nGrdPt
         iQM = 0
         Do iAt = 1, natom
            If (iWork(ipIsMM+iAt-1).eq.1) Goto 1
            iQM = iQM + 1
            X = Grid(1,iPnt) - Coord(1,iAt)
            Y = Grid(2,iPnt) - Coord(2,iAt)
            Z = Grid(3,iPnt) - Coord(3,iAt)
            R = sqrt(X*X+Y*Y+Z*Z)
            R2 = R * R
            R3 = R2 * R
            R5 = R2 * R3
            Do jQM = 1, nAtQM
               Do I = 1, 3
                  Do J = 1, 3
                     DG(I,J) = Zero
*
* This is commented since the derivative of the GEPOL grid points look ugly
*
c                     If (iGrdTyp.eq.2) DG(I,J) = DGrid(iPnt,jQM,I,J)
                  End Do
               End Do
               dIJ = Zero
               If (iQM .eq. jQM) dIJ = One
               If (nOrd .eq. 1) Then
                  DT(iQM   ,iPnt,1,jQM) = X/R3*(dIJ-DG(1,1))
     &                                  + Y/R3*(   -DG(2,1))
     &                                  + Z/R3*(   -DG(3,1))
                  DT(iQM   ,iPnt,2,jQM) = X/R3*(   -DG(1,2))
     &                                  + Y/R3*(dIJ-DG(2,2))
     &                                  + Z/R3*(   -DG(3,2))
                  DT(iQM   ,iPnt,3,jQM) = X/R3*(   -DG(1,3))
     &                                  + Y/R3*(   -DG(2,3))
     &                                  + Z/R3*(dIJ-DG(3,3))
               Else
                 DT(4*iQM-3,iPnt,1,jQM)= X/R3*(dIJ-DG(1,1))
     &                                 + Y/R3*(   -DG(2,1))
     &                                 + Z/R3*(   -DG(3,1))
                 DT(4*iQM-3,iPnt,2,jQM)= X/R3*(   -DG(1,2))
     &                                 + Y/R3*(dIJ-DG(2,2))
     &                                 + Z/R3*(   -DG(3,2))
                 DT(4*iQM-3,iPnt,3,jQM)= X/R3*(   -DG(1,3))
     &                                 + Y/R3*(   -DG(2,3))
     &                                 + Z/R3*(dIJ-DG(3,3))
                 DT(4*iQM-2,iPnt,1,jQM)= (three*X*X-R2)/R5*(dIJ-DG(1,1))
     &                                 + (three*X*Y   )/R5*(   -DG(2,1))
     &                                 + (three*X*Z   )/R5*(   -DG(3,1))
                 DT(4*iQM-2,iPnt,2,jQM)= (three*X*X-R2)/R5*(   -DG(1,2))
     &                                 + (three*X*Y   )/R5*(dIJ-DG(2,2))
     &                                 + (three*X*Z   )/R5*(   -DG(3,2))
                 DT(4*iQM-2,iPnt,3,jQM)= (three*X*X-R2)/R5*(   -DG(1,3))
     &                                 + (three*X*Y   )/R5*(   -DG(2,3))
     &                                 + (three*X*Z   )/R5*(dIJ-DG(3,3))
                 DT(4*iQM-1,iPnt,1,jQM)= (three*Y*X   )/R5*(dIJ-DG(1,1))
     &                                 + (three*Y*Y-R2)/R5*(   -DG(2,1))
     &                                 + (three*Y*Z   )/R5*(   -DG(3,1))
                 DT(4*iQM-1,iPnt,2,jQM)= (three*Y*X   )/R5*(   -DG(1,2))
     &                                 + (three*Y*Y-R2)/R5*(dIJ-DG(2,2))
     &                                 + (three*Y*Z   )/R5*(   -DG(3,2))
                 DT(4*iQM-1,iPnt,3,jQM)= (three*Y*X   )/R5*(   -DG(1,3))
     &                                 + (three*Y*Y-R2)/R5*(   -DG(2,3))
     &                                 + (three*Y*Z   )/R5*(dIJ-DG(3,3))
                 DT(4*iQM  ,iPnt,1,jQM)= (three*Z*X   )/R5*(dIJ-DG(1,1))
     &                                 + (three*Z*Y   )/R5*(   -DG(2,1))
     &                                 + (three*Z*Z-R2)/R5*(   -DG(3,1))
                 DT(4*iQM  ,iPnt,2,jQM)= (three*Z*X   )/R5*(   -DG(1,2))
     &                                 + (three*Z*Y   )/R5*(dIJ-DG(2,2))
     &                                 + (three*Z*Z-R2)/R5*(   -DG(3,2))
                 DT(4*iQM  ,iPnt,3,jQM)= (three*Z*X   )/R5*(   -DG(1,3))
     &                                 + (three*Z*Y   )/R5*(   -DG(2,3))
     &                                 + (three*Z*Z-R2)/R5*(dIJ-DG(3,3))
               EndIf
            End Do
1           Continue
         End Do
      End Do
      If (iQM.ne.nAtQM) Then
         Write(6,'(A)') ' Error in espf/initdb: iQM != nAtQM !!!'
         Call Abend()
      End If
      If (iPL.ge.4) Then
         Do iMlt = 1, nMult
            Do jPnt = 1, nGrdPt
               Write(6,'(A,i4,i4)') ' DT for iMlt and jPnt: ',iMlt,jPnt
               Do iQM = 1, nAtQM
                  Write(6,'(i4,3F20.7)') iQM,(DT(iMlt,jPnt,I,iQM),I=1,3)
               End Do
            End Do
         End Do
      End If
*
*     Step 2
*
      Do iMlt = 1, nMult
         Do jMlt = 1, nMult
            Do iQM = 1, nAtQM
               DTT(iMlt,jMlt,1,iQM)= Zero
               DTT(iMlt,jMlt,2,iQM)= Zero
               DTT(iMlt,jMlt,3,iQM)= Zero
               Do iPnt = 1, nGrdPt
                  DTT(iMlt,jMlt,1,iQM)= DTT(iMlt,jMlt,1,iQM)
     &                                + T(iMlt,iPnt)*DT(jMlt,iPnt,1,iQM)
     &                                + DT(iMlt,iPnt,1,iQM)*T(jMlt,iPnt)
                  DTT(iMlt,jMlt,2,iQM)= DTT(iMlt,jMlt,2,iQM)
     &                                + T(iMlt,iPnt)*DT(jMlt,iPnt,2,iQM)
     &                                + DT(iMlt,iPnt,2,iQM)*T(jMlt,iPnt)
                  DTT(iMlt,jMlt,3,iQM)= DTT(iMlt,jMlt,3,iQM)
     &                                + T(iMlt,iPnt)*DT(jMlt,iPnt,3,iQM)
     &                                + DT(iMlt,iPnt,3,iQM)*T(jMlt,iPnt)
               End Do
            End Do
            If (iPL.ge.4) Then
               Write(6,'(A,i4,i4)') 'DTT1 for iMlt and jMlt: ',iMlt,jMlt
               Do iQM = 1, nAtQM
                 Write(6,'(i4,3F20.7)') iQM,(DTT(iMlt,jMlt,I,iQM),I=1,3)
               End Do
            End If
         End Do
      End Do
*
*     Step 3
*
      Do iMlt = 1, nMult
         Do jMlt = 1, nMult
            Do iQM = 1, nAtQM
               DTTTT(iMlt,jMlt,1,iQM) = Zero
               DTTTT(iMlt,jMlt,2,iQM) = Zero
               DTTTT(iMlt,jMlt,3,iQM) = Zero
               Do kMlt = 1, nMult
                  DTTTT(iMlt,jMlt,1,iQM)= DTTTT(iMlt,jMlt,1,iQM)
     &                              + DTT(iMlt,kMlt,1,iQM)*TT(kMlt,jMlt)
                  DTTTT(iMlt,jMlt,2,iQM)= DTTTT(iMlt,jMlt,2,iQM)
     &                              + DTT(iMlt,kMlt,2,iQM)*TT(kMlt,jMlt)
                  DTTTT(iMlt,jMlt,3,iQM)= DTTTT(iMlt,jMlt,3,iQM)
     &                              + DTT(iMlt,kMlt,3,iQM)*TT(kMlt,jMlt)
               End Do
            End Do
            If (iPL.ge.4) Then
              Write(6,'(A,i4,i4)') 'DTTTT for iMlt and jMlt: ',iMlt,jMlt
              Do iQM = 1, nAtQM
               Write(6,'(i4,3F20.7)') iQM,(DTTTT(iMlt,jMlt,I,iQM),I=1,3)
              End Do
           End If
         End Do
      End Do
*
*     Step 4
*
      Do iMlt = 1, nMult
         Do jMlt = 1, nMult
            Do iQM = 1, nAtQM
               DTT(iMlt,jMlt,1,iQM) = Zero
               DTT(iMlt,jMlt,2,iQM) = Zero
               DTT(iMlt,jMlt,3,iQM) = Zero
               Do kMlt = 1, nMult
                  DTT(iMlt,jMlt,1,iQM)= DTT(iMlt,jMlt,1,iQM)
     &                            - TT(iMlt,kMlt)*DTTTT(kMlt,jMlt,1,iQM)
                  DTT(iMlt,jMlt,2,iQM)= DTT(iMlt,jMlt,2,iQM)
     &                            - TT(iMlt,kMlt)*DTTTT(kMlt,jMlt,2,iQM)
                  DTT(iMlt,jMlt,3,iQM)= DTT(iMlt,jMlt,3,iQM)
     &                            - TT(iMlt,kMlt)*DTTTT(kMlt,jMlt,3,iQM)
               End Do
            End Do
            If (iPL.ge.4) Then
               Write(6,'(A,i4,i4)') 'DTT for iMlt and jMlt: ',iMlt,jMlt
               Do iQM = 1, nAtQM
                 Write(6,'(i4,3F20.7)') iQM,(DTT(iMlt,jMlt,I,iQM),I=1,3)
               End Do
            End If
         End Do
      End Do
*
*     Step 5
*
      Do iMlt = 1, nMult
         Do iPnt = 1, nGrdPt
            Do iQM = 1, nAtQM
               DTTT(iMlt,iPnt,1,iQM) = Zero
               DTTT(iMlt,iPnt,2,iQM) = Zero
               DTTT(iMlt,iPnt,3,iQM) = Zero
               Do jMlt = 1, nMult
                  DTTT(iMlt,iPnt,1,iQM)= DTTT(iMlt,iPnt,1,iQM)
     &                               + TT(iMlt,jMlt)*DT(jMlt,iPnt,1,iQM)
     &                               + DTT(iMlt,jMlt,1,iQM)*T(jMlt,iPnt)
                  DTTT(iMlt,iPnt,2,iQM)= DTTT(iMlt,iPnt,2,iQM)
     &                               + TT(iMlt,jMlt)*DT(jMlt,iPnt,2,iQM)
     &                               + DTT(iMlt,jMlt,2,iQM)*T(jMlt,iPnt)
                  DTTT(iMlt,iPnt,3,iQM)= DTTT(iMlt,iPnt,3,iQM)
     &                               + TT(iMlt,jMlt)*DT(jMlt,iPnt,3,iQM)
     &                               + DTT(iMlt,jMlt,3,iQM)*T(jMlt,iPnt)
               End Do
            End Do
            If (iPL.ge.4) Then
               Write(6,'(A,i4,i4)') 'DTTT for iMlt and iPnt: ',iMlt,iPnt
               Do iQM = 1, nAtQM
                Write(6,'(i4,3F20.7)') iQM,(DTTT(iMlt,iPnt,I,iQM),I=1,3)
               End Do
            End If
         End Do
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(iGrdTyp)
        Call Unused_real_array(DGrid)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NEWGASTAB(NSYM,NGAS,NGASORB,NGASLIM,ICASE)
      use stdalloc, only: mma_allocate
      use rassi_global_arrays, only: REST1, REST2, REST
      IMPLICIT NONE
      INTEGER NSYM,NGAS,NGASORB(NSYM,NGAS),NGASLIM(2,NGAS), ICASE

      INTEGER NSIZE,ITYPE
      INTEGER IGAS,ISUM,ISYM,KORB,KREST,LPOS

C Executable statements
      NSIZE=4+(NGAS+1)*(NSYM+1)+2*NGAS
      ITYPE=91
      SELECT CASE (ICASE)
      CASE (1)
         CALL mma_allocate(REST1,NSIZE,Label='REST1')
         REST=>REST1(:)
      CASE (2)
         CALL mma_allocate(REST2,NSIZE,Label='REST2')
         REST=>REST2(:)
      CASE DEFAULT
         Write(6,*) 'NEWGASTAB: Illegal ICASE value'
         Write(6,*) 'ICASE=',ICASE
      END SELECT
      REST(1)=NSIZE
      REST(2)=ITYPE
      REST(3)=NGAS
      REST(4)=NSYM
      KORB=5
CTEST      write(*,*)' In NEWGASTAB. NGASORB array is:'
CTEST      do igas=1,ngas
CTEST        write(*,'(1x,8i5)')(ngasorb(isym,igas),isym=1,nsym)
CTEST      end do
CTEST      write(*,*)' In NEWGASTAB. NGASLIM array is:'
CTEST      write(*,'(1x,20i3)')(ngaslim(1,igas),igas=1,ngas)
CTEST      write(*,'(1x,20i3)')(ngaslim(2,igas),igas=1,ngas)

      DO IGAS=1,NGAS
       ISUM=0
       DO ISYM=1,NSYM
        LPOS=KORB+ISYM+(NSYM+1)*IGAS
        REST(LPOS)=2*NGASORB(ISYM,IGAS)
        ISUM=ISUM+2*NGASORB(ISYM,IGAS)
       END DO
       LPOS=KORB+0+(NSYM+1)*IGAS
       REST(LPOS)=ISUM
      END DO
      DO ISYM=0,NSYM
       ISUM=0
       DO IGAS=1,NGAS
        LPOS=KORB+ISYM+(NSYM+1)*IGAS
        ISUM=ISUM+REST(LPOS)
       END DO
       LPOS=KORB+ISYM
       REST(LPOS)=ISUM
      END DO
      KREST=KORB+(NGAS+1)*(NSYM+1)
      LPOS=KREST
      DO IGAS=1,NGAS
       REST(LPOS  )=NGASLIM(1,IGAS)
       REST(LPOS+1)=NGASLIM(2,IGAS)
       LPOS=LPOS+2
      END DO

      nullify(REST)
      END SUBROUTINE NEWGASTAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine Start3(CMO,TrM,mBB,nD,OneHam,Ovrlp,mBT)
************************************************************************
*                                                                      *
*     purpose: Get starting orbitals from density matrix read as input.*
*                                                                      *
*     called from: SOrb                                                *
*                                                                      *
*     calls to: TrGen                                                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "file.fh"
#include "mxdm.fh"
#include "infscf.fh"
      Real*8 CMO(mBB,nD), TrM(mBB,nD), OneHam(mBT), Ovrlp(mBT),
     &       Dens(mBT,nD)
*
*---- Define local variables
      Integer nBasX(8)
      Character*8 Location


#include "SysDef.fh"

*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Location='Start3'
*
*---- Compute transformation matrix
      Do iD = 1, nD
         Call TrGen(TrM(1,iD),nBB,Ovrlp,OneHam,nBT)
         Call DCopy_(nBO,TrM(1,iD),1,CMO(1,iD),1)
      End Do
*
*...  read old system definitions
*...  check for compatibility of the calculations
*
*     Call get_iScalar('nSym',nSymX)
      Call Peek_iScalar('nSym',nSymX)
      If (nSymX.ne.nSym) Then
         Call SysWarnMsg(Location,
     &         'Error inconsistent number of Irreps',' ')
         Call SysCondMsg('nSymX=nSym',nSymX,'<>',nSym)
      End If
      Call Get_iArray('nBas',nBasX,nSymX)
      Do iSym=1,nSym
         If (nBasX(iSym).ne.nBas(iSym)) Then
            Call SysWarnMsg(Location,
     &            'Error inconsistent nBas',' ')
            Call SysCondMsg('nBasX(iSym)=nBas (iSym)',
     &         nBasX(iSym),'<>',nBas(iSym))
         End If
      End Do
*
*...  read old density matrix
      Call Get_D1AO(Dens(1,1),nBT)
      if (iUHF.eq.1) then
         Call Get_D1sAO(Dens(1,2),nBT)
c now we need to fix interface - actually we read a+b,a-b
         Do i=1,nBT
            ra=Half*(Dens(i,1)+Dens(i,2))
            rb=Half*(Dens(i,1)-Dens(i,2))
            Dens(i,1)=ra
            Dens(i,2)=rb
         End Do

      endif
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Real*8 Function VExch (ZP,NP,ZQ,NQ,LA,nProj,iCoShll)
************************************************************************
*                                                                      *
*     VExch calculates the atomic integral                             *
*     <zp,np,la | Sum(core) Kc |zq,nq,la>                              *
*                                                                      *
************************************************************************
      Use Basis_Info
      Implicit Real*8 (A-H,O-Z)
C...  auxiliar constant pool:       ready only up to g-valence/g-core
      PARAMETER (lp1=5,lp12=lp1*lp1,lp13=(lp1*lp1+lp1)/2)
      COMMON/CONST/RCA(lp1,lp13),DFAC(lp12),KOSUU(lp13),NYU(lp1,lp13)
*
*     Define statement function
      VF(N,X)=DFAC(N)/sqrt(X)**(N+1)
*
      If (nProj.gt.4) Then
        Write (6,*) 'VExch: nProj',nProj
        Write (6,*) 'Abend: Implementation ready only up to g-core.'
        Write (6,*) '       Update common block /CONST/.'
        Call Abend
      Endif
      If (NP.gt.5.or.NQ.gt.5) Then
        Write (6,*) 'VExch: NP,NQ',NP,NQ
        Write (6,*) 'Abend: Implementation ready only up to g-valence.'
        Write (6,*) '       Update common block /CONST/.'
        Call Abend
      Endif
*
      PI=2.D0*ACOS(0.D0)
      PIPPI=(0.5D0/PI)**0.75D0
      L1=LA
      VPQ=VF(2*NP,ZP)*VF(2*NQ,ZQ)
      PSMT=0.D0
*ls start adding
      Vexch=0.D0
*ls end adding
*     loop over angular momentum
      DO 55 ISIM=1,nProj+1
        iCoSh=iCoShll+ISIM-1
        EDUM=0.5D0*DBLE(ISIM)+0.25D0
        NR=ISIM
        NS=ISIM
        L2=ISIM
        DL2=DBLE(2*(L2-1)+1)
        LMT=((L1-1)*L1)/2+L2
        IF(L1.LT.L2) LMT=((L2-1)*L2)/2+L1
        KOMAX=KOSUU(LMT)
*       loop over core orbitals of a given angular momentum
        iOff = Shells(iCoSh)%nBasis*Shells(iCoSh)%nExp
        DO 54 ICORB=1,Shells(iCoSh)%nBasis
          OrbPS=0d0
          DO 50 INU=1,KOMAX
            NUT=NYU(INU,LMT)
            NU=NUT
            RCAT=RCA(INU,LMT)*DL2
C                BEGIN KSM.
C           COMPUTATION OF K SUPER MATRIX OVER CGTO
C           NU IS UPPER INDEX NYU IN ROOTHAAN'S NOTATION
C
            IT1=NP+NR-NU-1
            IT2=NQ+NS+NU
            IT3=NQ+NS-NU-1
            IT4=NP+NR+NU
            SUMA=0.D0
            nExpon=Shells(iCoSh)%nExp
            DO K=1,nExpon
              ZR=Shells(iCoSh)%Exp(K)
              CR=Shells(iCoSh)%Cff_c(K,ICORB,2)
CLS           coeff of unnormalized non-diagonal cartesian GTF
* to be used in ecpaimp       CR=CR/(PIPPI*(4.D0*ZR)**EDUM)
              VR=VF(2*NR,ZR)
              RTT1=0.5D0*(ZP+ZR)
              DO L=1,nExpon
                ZS=Shells(iCoSh)%Exp(L)
                CS=Shells(iCoSh)%Cff_c(L,ICORB,2)
* to be used in ecpaimp          CS=CS/(PIPPI*(4.D0*ZS)**EDUM)
                VS=VF(2*NS,ZS)
                RTT2=0.5D0*(ZQ+ZS)
                RTT3=RTT1/RTT2
                RTT4=1.D0/RTT3
                CALL AUXC((IT1+1)/2,IT2,RTT3,RTT5)
                CALL AUXC((IT3+1)/2,IT4,RTT4,RTT6)
                RTT7=VF(IT1,RTT1)*VF(IT2,RTT2)*RTT5
     .              +VF(IT3,RTT2)*VF(IT4,RTT1)*RTT6
                SUMA=SUMA+RTT7*CR*CS/sqrt(VPQ*VR*VS)
              END DO
            END DO
C                END KSM.
*ls c       PSMT=PSMT+RCAT*0.797884561D0*SUMA
*ls start adding
            OrbPS=OrbPS+RCAT*0.797884561D0*SUMA
*ls end adding
  50      CONTINUE
*ls start adding
          FOcc=Shells(iCoSh)%Occ(iCOrb)
          Vexch=Vexch+2d0*OrbPS * FOcc
*ls start adding
 54     CONTINUE
*       end of loop over core orbitals of a given angular momentum
55    CONTINUE
*     end of loop over angular momentum
*ls c VEXCH= 2.D0*PSMT
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

#include "compiler_features.h"
#ifdef _MOLCAS_MPP_

subroutine V_SCALE(EIG,SCA,V,nRows,NAS,LDV,NIN,COND)

use caspt2_module, only: ThrShS
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nRows, NAS, LDV, NIN
real(kind=wp), intent(in) :: EIG(NAS), SCA(NAS)
real(kind=wp), intent(inout) :: V(LDV,*)
real(kind=wp), intent(out) :: COND(NIN)
integer(kind=iwp) :: I, J, jVEC

jVEC = 0
do J=1,NAS
  if (EIG(J) >= THRSHS) then
    jVEC = jVEC+1
    V(:,jVEC) = V(:,J)/sqrt(EIG(J))
  end if
end do
if (jVEC /= NIN) then
  write(u6,*) 'V_SCALE: inconsitency in linear dependence removal, ABORT'
  call AbEnd()
end if
! Addition, for the scaled symmetric ON.
do I=1,NIN
  V(1:nRows,I) = SCA(1:nRows)*V(1:nRows,I)
end do
! The condition number, after scaling, disregarding linear dep.
if (NIN >= 2) then
  do jVEC=1,NIN
    COND(jVEC) = sum(V(1:nRows,jVec)**2)
  end do
end if
end subroutine V_SCALE

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(V_SCALE)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995,2002, Roland Lindh                           *
!***********************************************************************

subroutine NAInt_GIAO( &
#                     define _CALLING_
#                     include "int_interface.fh"
                     )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of electric field         *
!         integrals.                                                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, January '91                             *
!                                                                      *
! Modified for explicit code, R. Lindh, February '95.                  *
!                                                                      *
! Modified for GIAOs, R. Lindh, June 2002, Tokyo, Japan.               *
!***********************************************************************

use Basis_Info, only: dbsc, Gaussian_Type, nCnttp, Nuclear_Model, Point_Charge
use Center_Info, only: dc
use Index_Functions, only: nTri3_Elem1, nTri_Elem1
use Constants, only: Zero, One, OneHalf, Pi, TwoP54
use Definitions, only: wp, iwp

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: iAnga_EF(4), iAnga_NA(4), iComp, iDCRT(0:7), ip3, ipEFInt, ipHRR, ipIn, ipNAInt, iPrint, ipRys, iRout, kab, &
                     kCnt, kCnttp, kdc, lab, labcd_EF, labcd_NA, lcd_EF, lcd_NA, lDCRT, llOper, LmbdT, mabMax, mabMin, mArr, &
                     mcdMax_EF, mcdMax_NA, mcdMin_EF, mcdMin_NA, nDCRT, nFLOP, nHRR, nMem, nOp, nT
real(kind=wp) :: C(3), CoorAC(3,2), Coori(3,4), EInv, Eta, Fact, rKappcd, TC(3)
logical(kind=iwp) :: NoSpecial
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: EQ
external :: Fake, MODU2, TERI, TNAI, vCff2D, vRys2D, XCff2D, XRys2D

#include "macros.fh"
unused_var(Alpha)
unused_var(Beta)
unused_var(nHer)
unused_var(Ccoor)
unused_var(PtChrg)
unused_var(iAddPot)
!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 200
iPrint = nPrint(iRout)

rFinal(:,:,:,:) = Zero

Coori(:,1) = A
Coori(:,2) = RB

iAnga_EF(1) = la
iAnga_EF(2) = lb
iAnga_NA(1) = la
iAnga_NA(2) = lb
mabMin = nTri3_Elem1(max(la,lb)-1)
if (EQ(A,RB)) mabMin = nTri3_Elem1(la+lb-1)
mabMax = nTri3_Elem1(la+lb)-1
lab = (mabMax-mabMin+1)
kab = nTri_Elem1(la)*nTri_Elem1(lb)

iAnga_EF(3) = nOrdOp
iAnga_EF(4) = 0
mcdMin_EF = nTri3_Elem1(nOrdOp-1)
mcdMax_EF = nTri3_Elem1(nOrdop)-1
lcd_EF = (mcdMax_EF-mcdMin_EF+1)
labcd_EF = lab*lcd_EF

iAnga_NA(3) = nOrdOp-1
iAnga_NA(4) = 0
mcdMin_NA = nTri3_Elem1(nOrdOp-2)
mcdMax_NA = nTri3_Elem1(nOrdop-1)-1
lcd_NA = (mcdMax_NA-mcdMin_NA+1)
labcd_NA = lab*lcd_NA

! Compute Flop's and size of work array which HRR will Use.

call mHRR(la,lb,nFLOP,nMem)
nHRR = max(labcd_EF,labcd_NA,lcd_EF*nMem,lcd_NA*nMem)

! Distribute the work array

mArr = nArr-labcd_EF-nHRR
ipEFInt = 1
ipRys = ipEFInt+nZeta*labcd_EF
ipHRR = ipRys+nZeta*mArr

! Find center to accumulate angular momentum on. (HRR)

if (la >= lb) then
  CoorAC(:,1) = A
else
  CoorAC(:,1) = RB
end if

llOper = lOper(1)
do iComp=2,nComp
  llOper = ior(llOper,lOper(iComp))
end do

! Modify Zeta if the two-electron code will be used!

if (Nuclear_Model == Gaussian_Type) then
  rKappa = rKappa*(TwoP54/Zeta)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over nuclear centers

kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (dbsc(kCnttp)%Charge == Zero) cycle
  do kCnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)
    if (iPrint >= 99) call RecPrt('C',' ',C,1,3)

    ! Find the DCR for M and S

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    Fact = real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    do lDCRT=0,nDCRT-1
      call OA(iDCRT(lDCRT),C,TC)
      CoorAC(:,2) = TC
      Coori(:,3) = TC
      Coori(:,4) = TC
      !                                                                *
      !*****************************************************************
      !                                                                *
      !------- Compute integrals with the Rys-Gauss quadrature.        *
      !                                                                *
      !*****************************************************************
      ! 1)                                                             *
      ! Do the EF integrals

      nT = nZeta
      if (Nuclear_Model == Gaussian_Type) then
        NoSpecial = .false.
        Eta = dbsc(kCnttp)%ExpNuc
        EInv = One/Eta
        rKappcd = TwoP54/Eta
        ! Tag on the normalization
        rKappcd = rKappcd*(Eta/Pi)**OneHalf
        call Rys(iAnga_EF,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,TC,1,rKappa,[rKappcd],Coori,Coori,CoorAC,mabMin,mabMax, &
                 mcdMin_EF,mcdMax_EF,Array(ipRys),mArr*nZeta,TERI,MODU2,vCff2D,vRys2D,NoSpecial)
      else if (Nuclear_Model == Point_Charge) then
        NoSpecial = .true.
        call Rys(iAnga_EF,nT,Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,rKappa,[One],Coori,Coori,CoorAC,mabMin,mabMax,mcdMin_EF, &
                 mcdMax_EF,Array(ipRys),mArr*nZeta,TNAI,Fake,XCff2D,XRys2D,NoSpecial)
      else
        ! ...more to come...
      end if
      !
      ! The integrals are now ordered as ijkl,e,f
      !
      !  a) Change the order to f,ijkl,e
      !  b) Unfold e to ab, f,ijkl,ab
      !  c) Change the order back to ijkl,ab,f
      !
      ! a)

      call DGetMO(Array(ipRys),nZeta*lab,nZeta*lab,lcd_EF,Array(ipHRR),lcd_EF)

      ! b) Use the HRR to unfold e to ab

      call HRR(la,lb,A,RB,Array(ipHRR),lcd_EF*nZeta,nMem,ipIn)
      ip3 = ipHRR-1+ipIn

      ! c)

      call DGetMO(Array(ip3),lcd_EF,lcd_EF,nZeta*kab,Array(ipEFInt),nZeta*kab)

      ! Stored as nZeta,iElem,jElem,iComp
      !                                                                *
      !*****************************************************************
      ! 2)                                                             *
      ! Do the NA integrals

      if (Nuclear_Model == Gaussian_Type) then
        NoSpecial = .false.
        Eta = dbsc(kCnttp)%ExpNuc
        EInv = One/Eta
        rKappcd = TwoP54/Eta
        ! Tag on the normalization
        rKappcd = rKappcd*(Eta/Pi)**OneHalf
        call Rys(iAnga_NA,nT,Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,TC,1,rKappa,[rKappcd],Coori,Coori,CoorAC,mabMin,mabMax,0,0, &
                 Array(ipRys),mArr*nZeta,TERI,MODU2,vCff2D,vRys2D,NoSpecial)
      else if (Nuclear_Model == Point_Charge) then
        NoSpecial = .true.
        call Rys(iAnga_NA,nT,Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,rKappa,[One],Coori,Coori,CoorAC,mabMin,mabMax,0,0, &
                 Array(ipRys),mArr*nZeta,TNAI,Fake,XCff2D,XRys2D,NoSpecial)
      else
        ! ...more to come...
      end if

      ! Use the HRR to compute the required primitive integrals

      call HRR(la,lb,A,RB,Array(ipRys),nZeta,nMem,ipNAInt)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Assemble dV/dB

      call Assemble_dVdB(Array(ipNAInt),Array(ipEFInt),nZeta,la,lb,A,RB,TC)

      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Accumulate contributions

      nOp = NrOpr(iDCRT(lDCRT))
      call SymAdO(Array(ipEFInt),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,-Fact*dbsc(kCnttp)%Charge)

    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (Nuclear_Model == Gaussian_Type) then
  rKappa = rKappa*(TwoP54/Zeta)
end if
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine NAInt_GIAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_Test
*
*> @brief
*>   Check Cholesky decomposition of matrix \p X
*> @author Thomas Bondo Pedersen
*>
*> @details
*> The difference between the matrix \p X and its Cholesky
*> representation is calculated and returned in array \p Y. If the
*> RMS error is less than \p Thr, \p irc = ``0`` is returned, else a positive
*> value is returned (a negative value signals an input error).
*> The input matrix \p X may be stored as a lower triangle
*> (\p Square = ``.false.``) or as a full square matrix (\p Square = ``.true.``).
*> The dimension of \p Y will be the same as that of \p X
*> (i.e. ``n(n+1)/2`` for lower triangular storage or ``n*n`` for full
*> square storage).
*>
*> @param[in]  X      The \p n &times; \p n matrix to be tested
*> @param[in]  n      Dimension of matrix \p X
*> @param[in]  Square Flag for packing of \p X
*> @param[in]  Vec    Cholesky vectors representing \p X
*> @param[in]  nVec   Number of Cholesky vectors
*> @param[in]  xf     Factor for the scaling of the vectors
*> @param[out] Y      ``Y = X - xf*Vec*VecT``
*> @param[in]  lY     Dimension of array \p Y
*> @param[in]  Thr    Threshold allowed for RMS error
*> @param[out] irc    Return code
************************************************************************
      SubRoutine Cho_X_Test(X,n,Square,Vec,nVec,xf,Y,lY,Thr,irc)
      Implicit Real*8 (a-h,o-z)
      Dimension X(*), Vec(n,nVec), Y(lY)
      Logical   Square

      external ddot_

C     Check input.
C     ------------

      If (n .lt. 1) Then ! nothing to do
         irc = 0
         Return
      Else If (nVec.lt.0 .or. Thr.lt.0.0d0) Then ! input error
         irc = -1
         Return
      End If
      If (Square) Then
         lX = n*n
      Else
         lX = n*(n+1)/2
      End If
      If (lY .lt. lX) Then ! insufficient memory
         irc = -2
         Return
      End If

C     Compute Y(ij) = X(ij) - xf * sum_J L(iJ) * L(jJ).
C     -------------------------------------------------

      Call dCopy_(lX,X,1,Y,1)
      If (Square) Then
         Call DGEMM_('N','T',n,n,nVec,
     &              -xf,Vec,n,Vec,n,1.0d0,Y,n)
      Else
         Call dGeMM_Tri('N','T',n,n,nVec,
     &                  -xf,Vec,n,Vec,n,1.0d0,Y,n)
      End If

C     Check RMS error.
C     ----------------

      RMS = sqrt(dDot_(lX,Y,1,Y,1)/dble(lX))
      If (RMS .gt. Thr) Then
         irc = 1
      Else
         irc = 0
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Gunnar Karlstrom                                 *
!               2000, Roland Lindh                                     *
!***********************************************************************

subroutine ener(h1,TwoHam,D,RepNuc,nh1,First,Dff,D_Tot,Grid,nGrid_,DipMom,EField,DipEff,PolEff,Cord,MaxAto,Z_Nuc,nPolComp, &
                nAnisopol,pField,tmpF)
!***********************************************************************
!                                                                      *
!     Object: to compute the needed terms from the interaction between *
!             the charge of the QM system, the dipole moments on the   *
!             grid, and the counter charge on the boundary of the      *
!             cavity. The latter can be divided into three terms,      *
!             nuclear, electronic and Langevin dipole moment terms.    *
!                                                                      *
!     Authors: G. Karlstroem                                           *
!              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
!                                                                      *
!              and                                                     *
!                                                                      *
!              R. Lindh                                                *
!              Dept. of Chem. Phys., Univ. of Lund, Sweden.            *
!                                                                      *
!              March 2000                                              *
!***********************************************************************

use Symmetry_Info, only: iChBas, nIrrep
use Basis_Info, only: nBas
use Gateway_global, only: PrPrt
use Integral_Interfaces, only: int_kernel, int_mem, OneEl_Integrals
use rctfld_module, only: lRFCav, TK
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nh1, nGrid_, MaxAto, nPolComp, nAnisopol
real(kind=wp), intent(inout) :: h1(nh1), TwoHam(nh1), RepNuc
real(kind=wp), intent(in) :: D(nh1), D_tot(nh1), Grid(3,nGrid_), DipMom(3,nGrid_), EField(4,nGrid_), DipEff(nGrid_), &
                             PolEff(nPolComp,nGrid_), Cord(3,MaxAto), Z_Nuc(MaxAto), pField(4,nGrid_), tmpF(4,nGrid_)
logical(kind=iwp), intent(in) :: First, Dff
integer(kind=iwp) :: iComp, iGrid, ip, iSmLbl, iSym, iSymC, iSymX, iSymXY, iSymXZ, iSymY, iSymYZ, iSymZ, iSyXYZ, ix, ixyz, iy, iz, &
                     MltLbl, n_Int, nComp, nOrdOp
real(kind=wp) :: ag, AGSum, Alfa, CCoor(3), dX, dY, dZ, EDip2, EElDip, EF_Grid(3), EInt, Emx, ENucDip, ESelf, ESimple, Ex, FDD, &
                 FTot, FTot2, fX, fY, fZ, PFx, PFy, PFz, RepHlp, RHrmt, Sig, x
logical(kind=iwp) :: NonEq, Save_tmp
character(len=8) :: Label
#ifdef _DEBUGPRINT_
real(kind=wp) :: tmp_RepNuc
#endif
integer(kind=iwp), allocatable :: ips(:), kOper(:), lOper(:)
real(kind=wp), allocatable :: C_Coor(:,:), Integrals(:)
procedure(int_kernel) :: EFInt
procedure(int_mem) :: EFMem
integer(kind=iwp), external :: IrrFnc, n2Tri
real(kind=wp), external :: DDOt_

!                                                                      *
!***********************************************************************
!                                                                      *
! First compute contributions due to the interaction of the QM
! charge distributions with the corresponding counter charges on
! the surface of the cavity.

! Here we have three terms
! 1) nuclear-nuclear, constant: added to RepNuc once
! 2) nuclear-electronic, constant: added to h1 once
! 3) electronic-electronic, linearly dependent of the density: TwoHam

#ifdef _DEBUGPRINT_
tmp_RepNuc = RepNuc
#endif
NonEq = .false.
if (lRFCav) call RctFld(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq)
!                                                                      *
!***********************************************************************
!                                                                      *
!1) Compute interaction between the dipole moment on the grid and
!   the EF on the grid (Edip2). Eself is the self interaction term
!   of the dipole moments on the grid.
!   Both terms depend on D_tot and the modifies RepNuc each iteration.

!2) Compute interaction term between the EF of the nuclear charges
!   and the dipole moments on the grid (EnucDip). This scalar terms
!   depends also on D_tot and modifies RepNuc at each iteration.

Edip2 = Zero
Eint = Zero
Eself = Zero
Enucdip = Zero
Esimple = Zero
agsum = Zero

do iGrid=1,nGrid_
  ! Langevin dipole moment
  dx = DipMom(1,iGrid)
  dy = DipMom(2,iGrid)
  dz = DipMom(3,iGrid)
  ! Total Electric Field
  fx = EField(1,iGrid)
  fy = EField(2,iGrid)
  fz = EField(3,iGrid)
  ! Electric Field from permanent multipoles
  pfx = pField(1,iGrid)
  pfy = pField(2,iGrid)
  pfz = pField(3,iGrid)

  ! Twice the energy of Langevin dipole moments in EF

  Edip2 = Edip2-fx*dx-fy*dy-fz*dz

  fDd = fx*dx+fy*dy+fz*dz   ! f dot d

  ! Do NOT halve the contribution from permanent multipoles
  Eint = Eint-Half*(fDd+pfx*dx+pfy*dy+pfz*dz)

  Esimple = Esimple-Half*(tmpF(1,iGrid)*dx+tmpF(2,iGrid)*dy+tmpF(3,iGrid)*dz)

  ! Compute self energies of dipole moments

  ftot2 = fx*fx+fy*fy+fz*fz
  ftot = sqrt(ftot2)
  x = ftot*DipEff(iGrid)*tk
  if (x <= 1.0e-7_wp) then
    ag = Zero
    !alang = Zero
  else
    ex = exp(x)
    emx = One/ex
    !alang = (ex+emx)/(ex-emx)-One/x
    ag = -log((ex-emx)/(Two*x))/tk
  end if

  if (iGrid > nAnisopol) then  ! isotropic
    !uind = DipEff(iGrid)*alang+ftot*PolEff(1,iGrid)
    !Eself = Eself+ftot*uind+ag-Half*ftot**2*PolEff(1,iGrid)
    Eself = Eself+fDd-Half*ftot2*PolEff(1,iGrid)
    agsum = agsum+ag
  else ! anisotropic
    Eself = Eself+Half*(fx*dx+fy*dy+fz*dz)
  end if

  ! Compute the EF at the grid point due to the nucleus

  nOrdOp = 1
  call EFNuc(Grid(1,iGrid),Z_Nuc,Cord,MaxAto,EF_Grid,nOrdOp)

  Enucdip = Enucdip-EF_Grid(1)*dx-EF_Grid(2)*dy-EF_Grid(3)*dz

end do  ! iGrid

#ifdef _DEBUGPRINT_
write(u6,*) 'Esimple             =',Esimple
write(u6,*) 'EnucRctfld          =',RepNuc-tmp_RepNuc
write(u6,*) 'Eself               =',Eself
write(u6,*) 'Ag term             =',agsum
write(u6,*) 'Electrostatic energy=',Eint
write(u6,*) 'EnucDip (half)      =',Half*Enucdip
#endif

RepNuc = RepNuc+Eself+agsum+Eint+Half*Enucdip

! Note:Before PS made this code compatible with XFIE, the following
! quantity was reported as Electrostatic energy: Half*Edip2
! and: RepNuc = RepNuc + Eself + Half*Edip2 + Half*Enucdip

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute interaction term between the field of the electronic
! charge and the dipole moments. This term is modified on each
! iteration.

! Retrieve the statatic h1

Label = 'h1_raw  '
call Get_Temp(Label,h1,nh1)

! Compute the modification to h1

! Evaluate electronic EF integrals at each point and add to h1

rHrmt = One
nOrdOp = 1
nComp = 3
Sig = -One
iSymX = IrrFnc(1)
iSymY = IrrFnc(2)
iSymZ = IrrFnc(4)
iSymXY = IrrFnc(3)
iSymXZ = IrrFnc(5)
iSymYZ = IrrFnc(6)
iSyXYZ = IrrFnc(7)

call mma_allocate(ips,nComp,Label='ips')
call mma_allocate(lOper,nComp,Label='lOper')
call mma_allocate(kOper,nComp,Label='kOper')
call mma_allocate(C_Coor,3,nComp,Label='CCoor')

Save_tmp = PrPrt
PrPrt = .true.

RepHlp = Zero
do iGrid=1,nGrid_
  write(Label,'(A,I5)') 'EF ',iGrid
  CCoor(:) = Grid(:,iGrid)
  iSymC = 1
  if (Ccoor(1) /= Zero) iSymC = ibset(iSymC,iSymX)
  if (Ccoor(2) /= Zero) iSymC = ibset(iSymC,iSymY)
  if (Ccoor(3) /= Zero) iSymC = ibset(iSymC,iSymZ)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero)) iSymC = ibset(iSymC,iSymXY)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ibset(iSymC,iSymXZ)
  if ((Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ibset(iSymC,iSymYZ)
  if ((Ccoor(1) /= Zero) .and. (Ccoor(2) /= Zero) .and. (Ccoor(3) /= Zero)) iSymC = ibset(iSymC,iSyXYZ)

  iComp = 0
  do ix=nOrdOp,0,-1
    do iy=nOrdOp-ix,0,-1
      iComp = iComp+1
      iz = nOrdOp-ix-iy
      ixyz = 0
      if (mod(ix,2) /= 0) ixyz = ibset(ixyz,0)
      if (mod(iy,2) /= 0) ixyz = ibset(ixyz,1)
      if (mod(iz,2) /= 0) ixyz = ibset(ixyz,2)
      iSym = 2**IrrFnc(ixyz)
      if (Ccoor(iComp) /= Zero) iSym = ibset(iSym,0)
      lOper(iComp) = MltLbl(iSymC,iSym)
      kOper(iComp) = iChBas(iComp+1)
      C_Coor(:,iComp) = Ccoor(:)
    end do
  end do

  call OneEl_Integrals(EFInt,EFMem,Label,ips,lOper,nComp,C_Coor,nOrdOp,rHrmt,kOper,Integrals)

  Eeldip = Zero
  do iComp=1,nComp
    ip = ips(iComp)
    iSmLbl = lOper(iComp)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Compute properties directly from integrals

    n_Int = n2Tri(iSmLbl)
    if ((n_Int /= 0) .and. (abs(DipMom(iComp,iGrid)) > 1.0e-20_wp)) then
      call CmpInt(Integrals(ip),n_Int,nBas,nIrrep,iSmLbl)
      if (n_Int /= nh1) then
        call WarningMessage(2,'Ener: n_Int /= nh1')
        write(u6,*) 'n_Int=',n_Int
        write(u6,*) 'nh1=',nh1
        call Abend()
      end if

      ! Accumulate contribution to h1

      alfa = Sig*DipMom(iComp,iGrid)
      h1(1:n_Int) = h1(1:n_Int)+alfa*Integrals(ip:ip+n_Int-1)
      EelDip = EelDip-alfa*DDot_(nh1,D_tot,1,Integrals(ip),1)

    end if

    !                                                                  *
    !*******************************************************************
    !                                                                  *

  end do ! iComp

  ! Deallocate memory for integral

  call mma_deallocate(Integrals)

  RepHlp = RepHlp+EelDip*half
  !write(u6,*) 'Eeldip=',Eeldip,RepHlp

end do    ! iGrid
RepNuc = RepNuc+RepHlp
#ifdef _DEBUGPRINT_
write(u6,*) 'RepHlp              =',RepHlp
#endif

PrPrt = Save_tmp

call mma_deallocate(C_Coor)
call mma_deallocate(kOper)
call mma_deallocate(lOper)
call mma_deallocate(ips)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine ener

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine geth0()
#include "drt_h.fh"
#include "pl_structure_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
c     character*256 filename
      dimension vad0(max_h0)
      real*8, allocatable :: vb1(:), vb2(:)
      dimension iselcsf_occ(max_innorb,max_ref)
      data dcrita/0.5d-5/

      allocate(vb1(max_h0*max_kspace),vb2(max_h0*max_kspace))
      if(.not.logic_mr) then
        call minevalue(iselcsf_occ)
      endif
!========================================================
! calculate ndim_h0
      if(norb_act.eq.0) then
        ndim_h0=1
        vector2(1)=vector1(1)
        irfno(1)=1
        goto 100
!        return
      endif
      ni=mod(norb_act,2)
      ipae=1
      jpae=nu_ae(ipae)
      if(jpae.eq.0) return
      jpadl=1
      if(nu_ad(jpadl).eq.0) return
      jpad=jpadl
      call seg_drt()
      if(ndim .eq. 0) return
      ndim_h0=ndim

      if(mroot.gt.ndim_h0) then
        write(6,*) '    mroot> ndim_h0, mroot,ndim_h0=',mroot,ndim_h0
        mroot=min(ndim_h0,mroot)
        write(6,*) "   ",mroot,"roots are calculated"
      endif

      call copy_to_drtl()

      if ( logic_mr ) then
        call irfrst(iselcsf_occ)
        if(mroot.gt.ndim_h0) then
          write(6,*) '    mroot> ndim_h0, mroot,ndim_h0=',mroot,ndim_h0
          mroot=min(ndim_h0,mroot)
          write(6,*) "   ",mroot,"roots are calculated"
        endif
        call  minevalue(iselcsf_occ)
      endif

!=====================================================================
100   continue
c     if(logic_mr) ndim_h0=irf
      if(.not.logic_mr) then
        ndim0=ndim_h0
      else
        ndim0=irf
      endif
      write(6,*)'     ================================'
      write(6,*)'         step 1: diagnalization h0   '
      write(6,*)'            ndim_h0=', ndim0
      write(6,*)'     ================================'

      if(ndim_h0.eq.1) then
        ecih0(1)=escf(1)
        vcm(1)=1.d0
        goto 400
      endif

      call formh0()   ! for log_mr, ndim_h0 changed to irf in this subro
!=====================================================================
      if (associated(vcm)) deallocate(vcm)
      allocate(vcm(ndim_h0*mroot))

      if(ndim_h0.le.30) then
        call hotred(max_kspace,ndim_h0,vector2,vd,ve,vu)
        call qlcm(max_kspace,ndim_h0,vd,ve,vu)
        ijm=0
        do m=1,mroot
          ecih0(m)=vd(m)
          do l=1,ndim_h0
            vcm(ijm+l)=vu(m,l)
          enddo
          ijm=ijm+ndim_h0
        enddo
        goto 400
      else
        mmspace=mroot*3+10
        do i=1,mmspace
          indx(i)=(i-1)*ndim_h0
        enddo

        do i=1,ndim_h0
          mn=i*(i+1)/2
          vad0(i)=vector2(mn)
        enddo

        nxh=ndim_h0*(ndim_h0+1)/2
        nxb=ndim_h0*max_kspace

        call basis_2(ndim_h0,vb1,nxb,vad0,vector2,nxh)

        do m=1,mroot
          ecih0(m)=escf(m)
        enddo

        kval=mroot*2
        call hymat_2(max_root,max_kspace,ndim_h0,kval,mroot,dcrita,
     *               ecih0,vcm,indx,vector2,nxh,vb1,vb2,nxb,vad0)
c        vcm(1:mroot*ndim_h0)=vb1(1:mroot*ndim_h0)
c save ci vector in h0 into vb2
        numh0=nci_h0 !iw_sta(2,1)
        vb2(1:numh0*mroot)=0.d0
        if(logic_mr) then
          idx1=0
          idx2=0
          do i=1,mroot
            do j=1,ndim_h0
              m=irfno(j)
              vb2(idx1+m)=vb1(idx2+j)
            enddo
            idx1=idx1+numh0
            idx2=idx2+ndim_h0
          enddo
        else
          vb2(1:numh0*mroot)=vb1(1:numh0*mroot)
        endif
      endif
      deallocate(vcm)

400   continue
      write(6,*)
      do m=1,mroot
        ijcm=indx(m)
        write(6,'(5x,a7,i5,f18.8)')   ' root,',m,ecih0(m)
      enddo
      write(6,*)

c      filename=tmpdir(1:len_str)//"/fort7"
c      len=len_str+6
c      open(nf7,file=filename(1:len),form="unformatted")
c      write(nf7) vb2(1:numh0*mroot)
c      close(nf7)

c      open(100,file="tmp.dat")
c      do i=1,ndim_h0
c        write(100,"(1x,f18.9,2i8)") vb1(i),i,irfno(i)
c      enddo
c      write(100,*) "ndim_h0=",ndim_h0,"v0=",numh0
c      idx1=0
c      idx2=0
c      do i=1,mroot
c        write(100,*) "mroot=",mroot
c        do j=1,numh0
c          write(100,"(1x,i2,1x,i5,2x,f18.9)") 1,j,vb2(j)
c          m=ifrno(j)
c          write(100,"(2(1x,i8,1x,f18.9))") j,vb2(j+idx1),m,vb1(m+idx2)
c        enddo
c        idx1=idx1+numh0
c        idx2=idx2+ndim_h0
c      enddo
c      close(100)
c      stop 888
      return
      end

      subroutine formh0()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      real*8, allocatable :: buff(:)

      num=ndim_h0*(ndim_h0+1)/2
      if(num.gt.max_vector) then
        write(6,*) " no enough space to store h0 matrix",num
#ifdef MOLPRO
#else
      call abend()
#endif
#ifdef _XIANEST_
#endif
!       call abend
!        stop 888
      endif

      vector2(1:lenvec)=0.d0
      log_prod=2
      call readint(1,vint_ci)
! act complete loop
      call cloop_in_act()
! dbl- act loop
      call ploop_in_act()

c save the h0 matrix into sracth file 23 to use later
      if ( logic_mr ) then ! rst
        allocate(buff(ndim_h0))
        buff(1:ndim_h0)=vector1(1:ndim_h0)
        vector1(1:lenvec)=0.d0
        mnh0=ndim_h0*(ndim_h0+1)/2
        vector1(1:mnh0)=vector2(1:mnh0)
        mnrh0=irf*(irf+1)/2
        vector2(1:mnrh0)=0.d0
        do ir1=1,irf
          iconf1=irfno(ir1)
          ii=ir1*(ir1+1)/2
          vector2(ii)=buff(iconf1)
          do ir2=1,ir1-1
            iconf2=irfno(ir2)
            ii=ir1*(ir1-1)/2+ir2
            iconfmax=max(iconf1,iconf2)
            iconfmin=min(iconf1,iconf2)
            iicc=iconfmax*(iconfmax-1)/2+iconfmin
            vector2(ii)=vector1(iicc)
          enddo
        enddo
        ndim_h0=irf
        deallocate(buff)
      else
        do i=1,ndim_h0   ! rcas
          ii=i*(i-1)/2+i
          vector2(ii)=vector2(ii)+vector1(i)
        enddo
      endif

      !do i=1,ndim_h0
      !  write(6,"(i4,1x,f12.6)") i,vector1(i)
      !enddo
      !stop 888
      write(6,"(a24,i5)") " dimension of h0 space= ",ndim_h0
      log_prod=1

c      open(100,file="h0_new")
c      do i=1,num
c        write(100,*) i,vector2(i)
c      enddo
c      close(100)
c      stop 777
      return
      end

c mroot=2 min_space=4
c    b1=(0,0,1.0,0,0,0...) b2=(0,0,0,0,1.0,0...)
      subroutine basis_2(ndim,vb1,nxb,vad,th,nxh)
#include "drt_h.fh"
      data dzero/0.d0/dcrita/1.0d-6/epc/5.0d-3/
      dimension vb1(max_kspace*ndim),vad(ndim)
      dimension th(nxh),ijb1(mroot),vb2(max_kspace*ndim)
      vb1=0.d0

      do j=1,mroot
        ij=indx(j)
        mief=mjn(j)
        if(logic_mr)then
          mjnj=mjn(j)
          mief=ifrno(mjnj)
        endif
        do 60 l=1,ndim
        vb1(ij+l)=dzero
60      continue
        vb1(ij+mief)=1.0d0
      enddo

c=================================================================
      j=mroot
      do m=1,mroot
        ijb2=indx(m)
        i=mjn(m)
        if(logic_mr)then
          mjnj=mjn(m)
          i=ifrno(mjnj)
        endif
        vadi=vad(i)
        vb2(ijb2+i)=vadi
        ijh=i*(i-1)/2
        j=j+1
        ijb1(m)=indx(j)
        do l=1,i-1
          fenmu=vadi-vad(l)
          if(abs(fenmu).lt.epc) fenmu=epc
          vb1(ijb1(m)+l)=th(ijh+l)/fenmu
          vb2(ijb2+l)=th(ijh+l)
        enddo
        do l=i+1,ndim
          fenmu=vadi-vad(l)
          if(abs(fenmu).lt.epc) fenmu=epc
          ijh=l*(l-1)/2
          vb1(ijb1(m)+l)=th(ijh+i)/fenmu
          vb2(ijb2+l)=th(ijh+i)
        enddo
      enddo

c--------------------------------------------------------------------
c write out basis
c--------------------------------------------------------------------
c500    write(nf2,*)' l    vb5       vb6      vb7       vb8     '
c
c       do l=1,ndim
c        write(nf2,'(2x,i5,4f10.4)')l,vb1(indx(5)+l),vb1(indx(6)+l)
c     :                             ,vb1(indx(7)+l),vb1(indx(8)+l)
c     enddo
c      stop 777   !wyb_tmp
c--------------------------------------------------------------------
      do m0=1,mroot
        ib=m0+mroot
        call orthnor(ndim,ib,dcrita,vb1,nxb)
      enddo

      return
      end


      subroutine minevalue(iselcsf_occ)
#include "drt_h.fh"
#include "files_gugaci.fh"
      common/config/ndr,nwalk(0:max_orb)
      dimension iselcsf_occ(max_innorb,max_ref)
      dimension iwalktmp(0:max_orb)
      data dzero/0.d0/dcrita/1.0d-6/epc/5.0d-3/

      call read_ml(lucidia,1,vector1,nci_dim,1)

      vector2(1:nci_dim)=vector1(1:nci_dim)
      ndimh0=nci_h0 !iw_sta(2,1)

      if(.not.logic_mr) then
        do i=1,mroot
          l=1
          am=vector2(l)
          do j=1,ndimh0
            if(vector2(j).ne.dzero.and.vector2(j).lt.am) then
              l=j
              am=vector2(j)
            endif
          enddo
          mjn(i)=l
          vector2(l)=dzero
        enddo
      else
        do i=1,mroot
          l=1
          am=vector2(l)
          do j=1,irf
            jm=irfno(j)
            if(vector2(jm).ne.dzero.and.vector2(jm).lt.am) then
              l=jm
              am=vector2(jm)
            endif
          enddo
          mjn(i)=l
          vector2(l)=dzero
        enddo
      endif

      do m=1,mroot
        escf(m)=vector1(mjn(m))
      enddo

      write(6,*) '   mjn(k) :',mroot
      do m=1,mroot
        call found_a_config(mjn(m),escf(m),1)
        do i=1,norb_all
          iwalktmp(i)=nwalk(norb_all-i+1)
        enddo
        ij=norb_dz
        if(m.le.2*mroot) then
          do io=1,norb_act
            ij=ij+1
            if(iwalktmp(ij).eq.3) iselcsf_occ(io,m)=3
            if(iwalktmp(ij).eq.2) iselcsf_occ(io,m)=2
            if(iwalktmp(ij).eq.1) iselcsf_occ(io,m)=1
            if(iwalktmp(ij).eq.0) iselcsf_occ(io,m)=0
          enddo
c          write(6,"(16(i1))") iwalktmp(norb_dz+1:norb_dz+norb_act)
        endif
!        write(6 ,'(2x,2i8,f18.8)') m,mjn(m),escf(m)
!       write(nf2,'(2x,2i8,f18.8)') m,mjn(m),escf(m)
      enddo
      write(6,*)
      end

      subroutine orthnor_ab(n,av,bv,id)  !bv:basis, av:vector for orth a
      real*8 av(n),bv(n),s,ddot_,dcrita
      dcrita=1.0e-10
      smax2=1.d10
      smax1=0.0d0
      if(id.ne.0) goto 150
c     orthogonization av,bv
      s=ddot_(n,av,1,bv,1)
      do i=1,n
        av(i)=av(i)-s*bv(i)
      enddo
c     normalization of av_eigenvector.
150   s=0.0d0
      s=ddot_(n,av,1,av,1)
      s=sqrt(s)
      s=max(s,dcrita)
      do i=1,n
        av(i)=av(i)/s
      enddo

      return
      end

      real*8 function ddot_bak(n,dx,dy)
      real*8 dx(n),dy(n),s
      s=0.0d0
      do l=1,n
        s=s+dx(l)*dy(l)
      enddo
      ddot_bak=s
      return
      end

      subroutine matrmk_1(k)
#include "drt_h.fh"
#include "files_gugaci.fh"
      do ibas=1,k
        call read_bv(lucitv1,ibas,vector1,nci_dim)
        ij=ibas*(ibas-1)/2
        do jbas=1,ibas
          call read_bv(lucitv2,jbas,vector2,nci_dim)
          vsumtmp=0.d0
          do l=1,nci_dim
            vsumtmp=vsumtmp+vector1(l)*vector2(l)
          enddo
          vp(ij+jbas)=vsumtmp
        enddo
      enddo
      write(6,*)
      il=0
      do l=1,k
        write(6,1112) (vp(i),i=il+1,il+l)
        il=il+l
      enddo
      write(6,*)
1112  format(2x,20f14.8)
      return
      end

      subroutine matrix_vector_mul_h0()


      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Preciba(iB,iS,jS,nd,rOut,nba,
     &                   focki,focka,fock,sign,
     &                   A_J,A_K,Scr,nScr)
************************************************************************
*                                          [2]                         *
*     Calculates the diagonal submatrix of E    that couple            *
*                                                                      *
*     kappa           with   kappa                for a                *
*          kinactive,virtual        kinactive,active                   *
*                                                                      *
*     single inactive index.                                           *
*     Used for preconditioner.                                         *
*                                                                      *
*     See Olsen,Yeager, Joergensen:                                    *
*      "Optimization and characterization of an MCSCF state"           *
*                                                                      *
*     Called by prec                                                   *
*                                                                      *
*     ib,is       :       inactive index for the submatrix             *
*     js          :       symmetry of virtual,active                   *
*     rOut        :       Submatrix                                    *
*                                                                      *
************************************************************************
      use Arrays, only: G1t
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
      Real*8  Fock(nba,nba),Focki(nba,nba),FockA(nba,nba)
      Real*8 rOut(*), A_J(nScr), A_K(nScr), Scr(nScr)
*                                                                      *
************************************************************************
*                                                                      *
       iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
       iTri1(i,j)=nTri-itri(nd-Min(i,j)+1,nd-Min(i,j)+1)
     &           +Max(i,j)-Min(i,j)+1
*                                                                      *
************************************************************************
*                                                                      *
      nTri=itri(nd,nd)
      jVert=nOrb(jS)-nAsh(jS)-nIsh(jS)
      nO=nAsh(jS)+nIsh(jS)
*                                                                      *
************************************************************************
*                                                                      *
*     Get block J^(iB,iB)
      Call Coul(jS,jS,iS,iS,iB,iB,A_J,Scr)
*     Get block K^(iB,iB)
      Call Exch(jS,iS,jS,iS,iB,iB,A_K,Scr)
*
      Do jA=1,nAsh(jS)
         ip=itri1(ja,nd-jVert+1)
         Do jB=1,nAsh(jS)
            jBB=jB+nIsh(jS)
*           Get D_(ja,jb)
            rDens=-sign*G1t((iTri(jA+nA(jS),jB+nA(jS))))
            If (jA.eq.jB) rDens=rdens+sign*2.0d0
*
            ivB=(jBB-1)*nBas(jS) + nO + 1
            Call DaXpY_(jVert,6.0d0*rDens,
     &                 A_K(ivB),1,
     &                 rOut(ip),1) ! ????
            Call DaXpY_(jVert,-2.0d0*rDens,
     &                 A_J(ivB),1,
     &                 rOut(ip),1)
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Do jA=1,nAsh(js)
         ip=iTri1(ja,nAsh(js)+1)
         Call DaXpY_(jVert,sign*4.0d0,Focki(nO+1,ja+nIsh(js)),1,
     &               rout(ip),1)
         Call DaXpY_(jVert,sign*4.0d0,FockA(nO+1,ja+nIsh(js)),1,
     &               rout(ip),1)
         Call DaXpY_(jVert,-sign,     Fock (nO+1,ja+nIsh(js)),1,
     &               rout(ip),1)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Francesco Aquilante                              *
!***********************************************************************

function Fexp(rho,drho)
!***********************************************************************
!***********************************************************************
!**                                                                  ***
!** Switching function of the NDSD potential:                        ***
!**     J.-M. Garcia Lastra, J. W. Kaminski, T. A. Wesolowski,       ***
!**                               J. Chem. Phys.  129 (2008) 074107. ***
!**                                                                  ***
!** Author: F. Aquilante, Geneva July 2010                           ***
!**                                                                  ***
!***********************************************************************
!***********************************************************************

use Constants, only: One, Three, Two, Pi
use Definitions, only: wp

implicit none
real(kind=wp) :: Fexp
real(kind=wp), intent(in) :: rho, drho(3)
real(kind=wp) :: eir_rBmin, eis_sBmax, eis_sBmin, er_rBmin, es_sBmax, es_sBmin, fact, factinv, rhoinv, rhoinv13, sB, xnorm, xnorm_
real(kind=wp), parameter :: lambda = 5.0e2_wp, One3 = One/Three, rBmin = 0.7_wp, sBmin = 0.3_wp, sBmax = 0.9_wp

rhoinv = One/rho
rhoinv13 = rhoinv**One3
fact = Two*(Three*Pi**2)**One3
factinv = One/fact
xnorm = drho(1)**2+drho(2)**2+drho(3)**2
xnorm_ = sqrt(xnorm)
sB = factinv*rhoinv*rhoinv13*xnorm_

es_sBmin = exp(lambda*(sBmin-sB))
es_sBmax = exp(lambda*(sBmax-sB))
er_rBmin = exp(lambda*(rBmin-rho))

eis_sBmin = One/(es_sBmin+One)
eis_sBmax = One/(es_sBmax+One)
eir_rBmin = One/(er_rBmin+One)

Fexp = eis_sBmin*(One-eis_sBmax)*eir_rBmin

end function Fexp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ZMatReader(iZMUnit,LuWr,nAtoms,nXAtoms,nBasis,
     & nAskAtoms,iErr)
      Implicit Integer (i-n)
      Implicit Real*8 (a-h,o-z)
#include "g_zmatconv.fh"
      Character*80 Line, Blank
      Character*3  Command
      Character*24 Words(7)
* nAtoms : Total number of real atoms. Include X dummy atoms: NAT(i)= 0
* nXAtoms: Total number of ghost (Z) atoms:                   NAT(i)=-1
* nBasis : Nummer of atom types requiring Basis Set
C  ***  nAskAtoms.EQ.-1  =>  Seward ZMAT input  => Use "End of"
C  ***  nAskAtoms.NE.-1  =>  GateWay ZMAT input => Use nAskAtoms
      iErr = 0
      Blank = ' '
      nAtoms  = 0
      nXAtoms = 0
      nBasis  = 0
      Do i = 1, 100 ! MaxNat
        BasReq(i) = .False.
      EndDo
      Do i = 1, MaxAtoms
        Symbols(i) = '     '
        NAT(i) = 0
        iZmat(i,1) = 0
        iZmat(i,2) = 0
        iZmat(i,3) = 0
        Zmat(i,1) = 0.0d0
        Zmat(i,2) = 0.0d0
        Zmat(i,3) = 0.0d0
      EndDo

* Read Line (or COMMAND)
10    If ((nAtoms + nXAtoms).EQ.nAskAtoms) GoTo 100
      Read(iZMUnit,'(A)',Err=9906,End=9999) Line
      If ( Line(1:1).EQ.'*' ) GoTo 10
      If ( Line.EQ.Blank ) GoTo 100
      Command = Line(1:3)
      Call UpCase(Command)
      If (Command.EQ.'END') GoTo 100
      iErr = 0
      NA = 0
      NB = 0
      NT = 0
      Dist  = 0.0d0
      Beta  = 0.0d0
      Theta = 0.0d0

* Read Symbol           [ Symb ]
      Call Pick_Words(Line,7,Nwords,Words)
      If (Nwords.LT.1) GoTo 9993
      Call FoundAtomicNumber(LuWr,Words(1),NAtom,iErr)
      If (iErr.NE.0) GoTo 9998
      If (NAtom.GE. 0) nAtoms  = nAtoms  + 1
      If (NAtom.EQ.-1) nXAtoms = nXAtoms + 1
      NAT(nAtoms + nXAtoms) = NAtom
      Symbols(nAtoms + nXAtoms) = Trim(Words(1))
      If (NAtom.GT. 0) BasReq(NAtom)=.True.
      If ((nAtoms + nXAtoms).EQ.1) GoTo 10 ! Raed Only the First Atom

* Read Distance         [ Symb   NA Dist ]
      Call Pick_Words(Line,7,Nwords,Words)
      If (Nwords.LT.3) GoTo 9993
      Call Get_iNumber(Words(2),NA,iErr)
      If (iErr.NE.0) GoTo 9998
      If (NA.GE.(nAtoms + nXAtoms)) GoTo 9997
      Call Get_dNumber(Words(3),Dist,iErr)
      If (iErr.NE.0) GoTo 9998
      If (Dist.LE.0.0d0) GoTo 9996
      iZmat(nAtoms + nXAtoms, 1) = NA
      Zmat(nAtoms + nXAtoms, 1) = Dist
      If ((nAtoms + nXAtoms).EQ.2) GoTo 10 ! Raed Only the Second Atom

* Read Planar angle     [ Symb   NA Dist   NB Beta ]
      Call Pick_Words(Line,7,Nwords,Words)
      If (Nwords.LT.5) GoTo 9993
      Call Get_iNumber(Words(4),NB,iErr)
      If (iErr.NE.0) GoTo 9998
      If (NB.GE.(nAtoms + nXAtoms)) GoTo 9997
      Call Get_dNumber(Words(5),Beta,iErr)
      If (iErr.NE.0) GoTo 9998
      If (Beta.LE.0.0d0 .OR. Beta.GE.180.0d0) GoTo 9995
      iZmat(nAtoms + nXAtoms, 2) = NB
      Zmat(nAtoms + nXAtoms, 2) = Beta
      If (NA.EQ.NB) GoTo 9994
      If ((nAtoms + nXAtoms).EQ.3) GoTo 10 ! Raed Only the Second Atom

* Read Dihedral angle   [ Symb   NA Dist   NB Beta   NT Theta]
      Call Pick_Words(Line,7,Nwords,Words)
      If (Nwords.LT.7) GoTo 9993
      Call Get_iNumber(Words(6),NT,iErr)
      If (iErr.NE.0) GoTo 9998
      If (NT.GE.(nAtoms + nXAtoms)) GoTo 9997
      Call Get_dNumber(Words(7),Theta,iErr)
      If (iErr.NE.0) GoTo 9998
      iZmat(nAtoms + nXAtoms, 3) = NT
      Zmat(nAtoms + nXAtoms, 3) = Theta
      If (NA.EQ.NB .OR. NB.EQ.NT .OR. NA.EQ.NT) GoTo 9994
      GoTo 10

* Pre-check Basis Set consistency  BasReq: Atom requiring Basis Set
100   nBasis = 0
      Do i = 1, 100
        If (BasReq(i)) nBasis = nBasis + 1
      EndDo

      GoTo 9999

9906  iErr = 1
      Write(LuWr,*) ' [ZMatReader]: Unable to read z-matrix file !'
      GoTo 9999

9997  iErr = 1
      Write(LuWr,*) ' [ZMatReader]: Wrong index in line'
      Write(LuWr,*) '               ',Line
      GoTo 9999

9996  iErr = 1
      Write(LuWr,*) ' [ZMatReader]: Wrong distance in line'
      Write(LuWr,*) '               ',Line
      GoTo 9999

9995  iErr = 1
      Write(LuWr,*) ' [ZMatReader]: Wrong planar angle in line'
      Write(LuWr,*) '               ',Line
      GoTo 9999

9994  iErr = 1
      Write(LuWr,*) ' [ZMatReader]: Multiple index in line'
      Write(LuWr,*) '               ',Line
      GoTo 9999

9993  iErr = 1
      Write(LuWr,*) ' [ZMatReader]: Z-Matrix incomplete in line'
      Write(LuWr,*) '               ',Line
      GoTo 9999

9998  iErr = 1
      Write(LuWr,*) ' [ZMatReader]: Error in line'
      Write(LuWr,*) '               ',Line
      GoTo 9999

9999  Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine UnCompress(ArrayIn,ArrayOut,idsym)
*
*      Uncompresses the PCG vector to a orbital rotation matrix
*
*      The redundant rotations are set to zero
*
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
      Integer dsym
      Real*8  ArrayIn(nDensC),ArrayOut(nDens2)
      Integer Bas(8)
      indexC=0
      Fact=1.0d0
      If (idsym.lt.0) Fact=-Fact
      dsym=abs(idsym)
      call dcopy_(nDens2,[0.0d0],0,ArrayOut,1)
      If (TimeDep) Then
         Do i=1,nSym
            Bas(i)=nBas(i)
         End Do
      Else
         Do i=1,nSym
            Bas(i)=nB(i)
         End Do
      End If
      Do iSym=1,nSym
       Do jSym=1,nSym
        If (iEOr(iSym-1,jSym-1)+1.eq.dSym) Then
          Do jBas=1,Bas(jSym)
          If (jBas.le.nIsh(jsym)) Then
             jT=0
          Else If (jBas.le.nIsh(jsym)+nRs1(jsym)) Then
             jT=1
          Else If (jBas.le.nIsh(jsym)+nRs2(jsym)) Then
             jT=2
          Else If (jBas.le.nIsh(jsym)+nRs3(jsym)) Then
             jT=3
          Else
             jT=4
          End If
          Do iBas=1,nOrb(iSym)
           If (iBas.le.nIsh(isym)) Then
             iT=0
           Else If (iBas.le.nIsh(isym)+nRs1(isym)) Then
             iT=1
           Else If (iBas.le.nIsh(isym)+nRs2(isym)) Then
             iT=2
           Else If (iBas.le.nIsh(isym)+nRs3(isym)) Then
             iT=3
           Else
             iT=4
           End If
           If (Timedep) Then
            If (iT.ne.jT) Then
             indexC=indexc+1
             Index1=ipMat(iSym,jSym)+(jBas-1)*nOrb(iSym)+iBas-1
             ArrayOut(Index1)=Fact*ArrayIn(indexC)
            End If
           Else
            If (iT.gt.jT) Then
             indexC=indexc+1
             Index1=ipMat(iSym,jSym)+(jBas-1)*nOrb(iSym)+iBas-1
             Index2=ipMat(jSym,iSym)+(iBas-1)*nOrb(jSym)+jBas-1
             ArrayOut(Index1)=Fact*ArrayIn(indexC)
             ArrayOut(Index2)=-Fact*ArrayIn(indexC)
            End If
           End If
          End Do
         End Do
        End If
       End Do
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine hamdens()
! Purpose : Transform initial Hamiltonian to required basis as well as
! the initial density matrix, which are currently present
! in CSF basis

use rhodyn_data, only: alpha, basis, CSF2SO, d, density0, dipole, dipole_basis, DM0, dysamp_bas, flag_dyson, flag_pulse, flag_so, &
                       flag_test, hamiltonian, HTOT_CSF, initialtime, ipglob, Nstate, SO_CI, tmp, U_CI, U_CI_compl
use rhodyn_utils, only: transform, mult, dashes
use Constants, only: Zero, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, j, k, ii

if (ipglob > 2) then
  call dashes()
  write(u6,*) 'Begin get_hamiltonian'
  call dashes()
end if

if (.not. flag_test) then
  U_CI_compl(:,:) = cmplx(U_CI,kind=wp)
end if
hamiltonian(:,:) = cZero
density0(:,:) = cZero

! construct the initial hamiltonian and density matrix

write(u6,*) 'Basis: ',basis
if (initialtime == Zero) then
  if (basis == 'CSF') then
    hamiltonian(:,:) = HTOT_CSF
    density0(:,:) = DM0
  else if (basis == 'SF') then
    ! Hamiltonian CSF->SF
    call transform(HTOT_CSF,U_CI_compl,hamiltonian)
    ! density CSF->SF
    call transform(DM0,U_CI_compl,density0)
  else if (basis == 'SO') then
    ! Hamiltonian CSF->SO
    call transform(HTOT_CSF,CSF2SO,hamiltonian)
    ! density CSF->SO
    call transform(DM0,CSF2SO,density0)
  end if
else if (initialtime /= Zero) then
  ! if initialtime /= 0, then the initial density matrix in basis
  ! of "Basis", not in CSF basis, in this case, the density matrix
  ! readin was printout directly from the propagate part, so we can
  ! directly use it in propagate section, let density0 equal to the read
  ! in density matrix.
  if (basis == 'CSF') then
    ! Hamiltonian CSF
    hamiltonian(:,:) = HTOT_CSF
    ! density SF->CSF
    call transform(DM0,U_CI_compl,density0,.false.)
  else if (basis == 'SF') then
    ! Hamiltonian CSF->SF
    call transform(HTOT_CSF,U_CI_compl,hamiltonian)
    ! density SF
    density0(:,:) = DM0
  else if (basis == 'SO') then
    ! Hamiltonian CSF->SO
    call transform(HTOT_CSF,CSF2SO,hamiltonian)
    ! density SO
    density0(:,:) = DM0
  end if
end if

if (ipglob > 2) then
  call dashes()
  write(u6,*) 'End get_hamiltonian'
  call dashes()
end if

if (.not. flag_test) then

  if (ipglob > 2) then
    call dashes()
    write(u6,*) 'Begin get_dipole'
    call dashes()
  end if

  ! construct the dipole matrix in required basis (with dyson matrix)
  ! here dipole presumably in SO basis (if SO is on)
  !                     or in SF basis (is SO is off)

  if (flag_so) then
    if (basis == 'CSF') then
      do i=1,3
        call transform(dipole(:,:,i),CSF2SO,dipole_basis(:,:,i),.false.)
      end do
    else if (basis == 'SF') then
      do i=1,3
        call transform(dipole(:,:,i),SO_CI,dipole_basis(:,:,i),.false.)
      end do
    else if (basis == 'SO') then
      dipole_basis(:,:,:) = dipole
      if (flag_dyson) then
        call mult(SO_CI,dysamp_bas,tmp,.true.,.false.)
        call mult(tmp,SO_CI,dysamp_bas)
      end if
    end if
  else ! flag_so is off
    if (basis == 'CSF') then
      do i=1,3
        call transform(dipole(:,:,i),U_CI_compl,dipole_basis(:,:,i),.false.)
      end do
    else if (basis == 'SF') then
      dipole_basis(:,:,:) = dipole
    end if
  end if

  if (flag_dyson) then
    do i=1,3
      dipole_basis(:,:,i) = dipole_basis(:,:,i)+alpha*dysamp_bas
    end do
  end if

  !!!!!!!!!!!!!!!!!!!
  if (ipglob > 3) then
    ii = 10
    if (Nstate < 10) ii = Nstate
    write(u6,*) 'hamiltonian'
    do i=1,ii
      write(u6,*) (hamiltonian(i,j),j=1,ii)
    end do
    write(u6,*) 'density0'
    do i=1,ii
      write(u6,*) (density0(i,j),j=1,ii)
    end do
    write(u6,*) 'End get_dipole'
    call dashes()
  end if
  if (ipglob > 4) then
    do i=1,3
      call dashes()
      write(u6,*) 'Dipole Matrix in',basis,'basis'
      if (i == 1) write(u6,*) 'Printout the components dipole matrix dx'
      if (i == 2) write(u6,*) 'Printout the components dipole matrix dy'
      if (i == 3) write(u6,*) 'Printout the components dipole matrix dz'
      call dashes()
      do k=1,d
        write(u6,*) (dipole_basis(k,j,i),j=1,d)
      end do
      write(u6,*)
      call dashes()
    end do
  end if

end if

if (flag_test .and. flag_pulse) then
  dipole_basis(:,:,:) = dipole
  if (ipglob > 4) then
    do i=1,3
      call dashes()
      write(u6,*) 'Dipole Matrix in',basis,'basis'
      if (i == 1) write(u6,*) 'Printout the components dipole matrix dx'
      if (i == 2) write(u6,*) 'Printout the components dipole matrix dy'
      if (i == 3) write(u6,*) 'Printout the components dipole matrix dz'
      call dashes()
      do k=1,d
        write(u6,*) (dipole_basis(k,j,i),j=1,d)
      end do
      write(u6,*)
      call dashes()
    end do
  end if
end if

end subroutine hamdens

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Print_Basis2()
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only:S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "angtp.fh"
#include "print.fh"
      Logical output
      Logical lAux, lPam2, lECP, lPP, lFAIEMP
*                                                                      *
************************************************************************
*                                                                      *
      iRout=2
      iPrint=nPrint(iRout)
*
      LuWr=6
      lAux =.False.
      lPam2=.False.
      lECP =.False.
      lPP  =.False.
      lFAIEMP  =.False.
      Do i = 1, nCnttp
         lAux  = lAux  .or. dbsc(i)%Aux
         lPAM2 = lPAM2 .or. dbsc(i)%lPAM2
         lECP  = lECP  .or. dbsc(i)%ECP
         lPP   = lPP   .or. dbsc(i)%nPP.ne.0
         lFAIEMP = lFAIEMP .or. dbsc(i)%Frag
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.6) Then
         Write (LuWr,*)
         Call CollapseOutput(1,'   Primitive basis info:')
         Write (LuWr,'(3X,A)') '   ---------------------'
         Write (LuWr,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Generate list of primitive basis functions
*
      If (iPrint.ge.6) Then
         Write (LuWr,*)
         Write (LuWr,'(19X,A)')
     &         ' *****************************************************'
         Write (LuWr,'(19X,A)')
     &         ' ******** Primitive Basis Functions (Valence) ********'
         Write (LuWr,'(19X,A)')
     &         ' *****************************************************'
      End If
*     Loop over distinct shell types
      jExp  =0
      iPrim = 0
      iPrim_Aux = -1
      iPrim_Frag = 0
      iBas  = 0
      iBas_Aux  = -1
      iBas_Frag = 0
      iShell=0
*     Loop over basis sets
      Do iCnttp = 1, nCnttp
         mdc = dbsc(iCnttp)%mdci
         output=iPrint.ge.6
         If (dbsc(iCnttp)%Aux.or.dbsc(iCnttp)%Frag)
     &     output = output .and. iPrint.ge.10
     &                     .and. iCnttp.ne.iCnttp_Dummy
         If(output) then
            Write (LuWr,*)
            Write (LuWr,*)
            Write (LuWr,'(A,A)') ' Basis set:',dbsc(iCnttp)%Bsl
         End If
         iShSrt = dbsc(iCnttp)%iVal
*        Loop over distinct centers
         Do icnt = 1, dbsc(iCnttp)%nCntr
            mdc = mdc + 1
            if (mdc.gt.MxAtom) then
               Call WarningMessage(2,'MxAtom too small')
               write(LuWr,*) 'MxAtom=',MxAtom
               write(LuWr,*) 'Increase MxAtom in info.fh and',
     &                       ' recompile the code!'
               Call Abend()
            end if
*           Loop over shells associated with this center
*           Start with s type shells
            jSh = iShSrt
            Do iAng = 0, dbsc(iCnttp)%nVal-1
               iShell = iShell + 1
               nExpj=Shells(jSh)%nExp
               nBasisj=Shells(jSh)%nBasis
               If (S%MaxPrm(iAng).gt.0 .and. nExpj.gt.0 .and.
     &             nBasisj.gt.0 .and. output .and.
     &             iCnt.eq.1) Then
                  Write (LuWr,*)
                  Write (LuWr,*) '                 Type         '
                  Write (LuWr,'(19X,A)')
     &                                         AngTp(iAng)
                  Write (LuWr,*) '          No.      Exponent   ',
     &                        ' Contraction Coefficients'
               End If
*
               If (nBasisj.gt.0 .and. output) Then
                  Do kExp = 1, nExpj
                     jExp  = jExp  + 1
                     If (iCnt.eq.1)
     &               Write (LuWr,'( 9X,I4,1X,D16.9,10(1X,F10.6),'//
     &                        '1X,3(/,30X,10(1X,F10.6)))')
     &                     jExp , Shells(jSh)%Exp(kExp),
     &                     ( Shells(jSh)%Cff_c(kExp,ib,2),
     &                     ib=1,nBasisj)
                  End Do
               End If
               If (iShell.gt.MxShll) Then
                  Call WarningMessage(2,'iShell.gt.MxShll')
                  Write (LuWr,*) ' Change MxShll in info.fh and re'
     &                      //'compile the code!'
                  Call Abend()
               End If
               kCmp=(iAng+1)*(iAng+2)/2
               If (Shells(jSh)%Prjct) kCmp=2*iAng+1
               If (nBasisj.ne.0 ) Then
                  If (Shells(jSh)%Aux) Then
                     iPrim_Aux = iPrim_Aux + nExpj   * kCmp
     &                         * nIrrep/dc(mdc)%nStab
                     iBas_Aux  = iBas_Aux  + nBasisj * kCmp
     &                         * nIrrep/dc(mdc)%nStab
                  Else If (Shells(jSh)%Frag) Then
                     iPrim_Frag = iPrim_Frag + nExpj   * kCmp
     &                          * nIrrep/dc(mdc)%nStab
                     iBas_Frag = iBas_Frag  + nBasisj * kCmp
     &                         * nIrrep/dc(mdc)%nStab
                  Else
                     iPrim = iPrim + nExpj   * kCmp
     &                      * nIrrep/dc(mdc)%nStab
                     iBas  = iBas  + nBasisj * kCmp
     &                     * nIrrep/dc(mdc)%nStab
                  End If
               End If
               jSh = jSh + 1
            End Do
         End Do
*
      End Do
      If (iBas.ge.2*MaxBfn) Then
         Call WarningMessage(2,'MaxBfn too small')
         Write (LuWr,*) 'Input: Increase 2*MaxBfn to ', iBas
         Call Abend()
      End If
      If (iPrint.ge.6) Then
         Write(LuWr,*)
         Write(LuWr,*) ' Number of primitives                ', iPrim
         Write(LuWr,*) ' Number of basis functions           ', iBas
         If (lAux .and. iPrint.ge.10) Then
             Write(LuWr,*) ' Number of primitive aux. functions  ',
     &                      iPrim_Aux
             Write(LuWr,*) ' Number of auxiliary basis functions ',
     &                       iBas_Aux
         End If
         If (lFAIEMP .and. iPrint.ge.10) Then
             Write(LuWr,*) ' Number of primitive frag. functions ',
     &                      iPrim_Frag
             Write(LuWr,*) ' Number of fragment basis functions  ',
     &                       iBas_Frag
         End If
         Write (LuWr,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (lPAM2) Then
         Write (LuWr,*)
         Write (LuWr,'(19X,A)')
     &         ' *************************************************'
         Write (LuWr,'(19X,A)')
     &         ' ******** Primitive Basis Functions (PAM) ********'
         Write (LuWr,'(19X,A)')
     &         ' *************************************************'
         Do iCnttp=1,nCnttp
         If (dbsc(iCnttp)%lPAM2) Then
*            If (iPrint.ge.10) Then
            Write (LuWr,*)
            Write (LuWr,*)
            Write (LuWr,'(A,A)') ' Basis set:',dbsc(iCnttp)%Bsl
            If (dbsc(iCnttp)%nPAM2.ne.-1) Then
               Write (LuWr,*)
               Write (LuWr,*) 'Angular momentum of PAM operator: ',
     &                         AngTp(dbsc(iCnttp)%nPAM2)
               iAddr=1
*
               Do iAngl=0,dbsc(iCnttp)%nPAM2
                  iPrimm = INT(dbsc(iCnttp)%PAM2(iAddr)  )
                  iBass =  INT(dbsc(iCnttp)%PAM2(iAddr+1))
                  Write(LuWr,'(14H Ang. moment: ,3x,a1)') AngTp(iAngl)
                  Write(LuWr,'(22H Number of  primitive:,i4,'
     &                      //'22H Number of contracted:,i4)')
     &                         iPrimm,iBass
                  Write (LuWr,*)
                  Write(LuWr,'(21H  N.        Exponents,'
     &                      //'23H            Coefficent:)')
*
                  Do ir=0,iPrimm - 1
                     Write (LuWr,'(i4,1x,f18.12,1x,12(1x,f12.8))')
     &               ir+1,dbsc(iCnttp)%PAM2(iAddr+2+ir),
     &                   (dbsc(iCnttp)%PAM2(iAddr+2+iPrimm+ic),
     &               ic=ir,(iPrimm)*iBass-1,iPrimm)
                  End Do
*
               iAddr = iAddr + 2 + iPrimm + iPrimm*iBass
               End Do
            End If
*            End If
         End If
         End Do
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.10 .and. (lECP.or.lPP)) Then
         Write (LuWr,*)
         Write (LuWr,'(19X,A)')
     &         ' *************************************************'
         Write (LuWr,'(19X,A)')
     &         ' ******** Primitive Basis Functions (ECP) ********'
         Write (LuWr,'(19X,A)')
     &         ' *************************************************'
C     Else
Cstart Molcas
C        If (iPrint.lt.6) Write (LuWr,*)
C    &                  'To display basis set information use the key',
C    &                  ' "BSSHOW" in the input.'
C        If ((lECP.or.lPP).and.iPrint.lt.10) Write (LuWr,*)
C    &                  'To display ECP information use the key',
C    &                  ' "ECPSHOW" in the input.'
C        If (lAUX .and. iPrint.lt.10 ) Write (LuWr,*)
C    &      'To display auxiliary basis information use the key',
C    &      ' "AUXSHOW" in the input.'
Cend
      End If
*
      Do iCnttp = 1, nCnttp
*
*------- Pseudo potential type ECP
*
         If (dbsc(iCnttp)%nPP.ne.0 .and. iPrint.ge.10) Then
            Write (LuWr,*)
            Write (LuWr,*)
            Write (LuWr,'(A,A)') ' Basis set:',dbsc(iCnttp)%Bsl
            Write (LuWr,*)
            Write (LuWr,'(A)') ' Pseudo Potential'
            Write (LuWr,*)
            kShStr=dbsc(iCnttp)%iPP
            kShEnd = kShStr + dbsc(iCnttp)%nPP-1
            lSh= 0
            Do kSh = kShStr, kShEnd
               nExpk=Shells(kSh)%nExp
               If (nExpk.ne.0.and.iCnttp.le.21) Then
                  If (lSh.eq.0) Then
                     Write (LuWr,'(4X,A)') '  H Potential'
                  Else
                     Write (LuWr,'(4X,A)') AngTp(lSh-1)//
     &                      '-H Potential'
                  End If
               End If
               lSh = lSh + 1
               Write (LuWr,'(A)') '  n     Exponent      Coefficient'
               iOff = 1
               Do iExp = 1, nExpk
                  ncr=Int(Shells(kSh)%Exp(iOff  ))
                  zcr=    Shells(kSh)%Exp(iOff+1)
                  ccr=    Shells(kSh)%Exp(iOff+2)
                  Write (LuWr,'(2x,I1,3X,2F15.10)') ncr,zcr,ccr
                  iOff = iOff + 3
               End Do
               Write (LuWr,*)
*
            End Do
         End If
*
*------- Huzinaga type ECP
*
         If (dbsc(iCnttp)%ECP) Then
            If (iPrint.ge.10) Then
               Write (LuWr,*)
               Write (LuWr,*)
               Write (LuWr,'(A,A)') ' Basis set:',dbsc(iCnttp)%Bsl
*
               If (dbsc(iCnttp)%nM1.ne.0) Then
                  Write (LuWr,*)
                  Write (LuWr,*) ' M1 operator       Exponent   ',
     &                           ' Contraction Coefficients'
                  Do irow = 1, dbsc(iCnttp)%nM1
                     Write (LuWr,'(14X,D16.9,1X,D19.9)')
     &                  dbsc(iCnttp)%M1xp(irow),
     &                  dbsc(iCnttp)%M1cf(irow)
                  End Do
               End If ! If (dbsc(iCnttp)%nM1.ne.0) Then
*
               If (dbsc(iCnttp)%nM2.ne.0) Then
                  Write (LuWr,*)
                  Write (LuWr,*) ' M2 operator       Exponent   ',
     &                           ' Contraction Coefficients'
                  Do irow = 1, dbsc(iCnttp)%nM2
                     Write (LuWr,'(14X,D16.9,1X,D19.9)')
     &                  dbsc(iCnttp)%M2xp(irow),
     &                  dbsc(iCnttp)%M2cf(irow)
                  End Do
               End If ! If (dbsc(iCnttp)%nM2.ne.0) Then
            End If ! If (iPrint.ge.10) Then
*
*--------------Projection Basis Set
*
            iSh = dbsc(iCnttp)%iPrj
            nSumB = 0
            jSh = iSh
            Do iAng = 0, dbsc(iCnttp)%nPrj-1
               nSumB = nSumB + Shells(jSh)%nBasis
               jSh = jSh + 1
            End Do
            If (nSumB.ne.0.and.iPrint.ge.10) Then
               Write (LuWr,*)
               Write (LuWr,*)
               Write (LuWr,*) ' Proj. Operator'
            End If
            Do iAng = 0, dbsc(iCnttp)%nPrj-1
               If (Shells(iSh)%nBk.ne.0) Then
                  If (iPrint.ge.10) Then
                     Write (LuWr,*)
                     Write (LuWr,'(19X,A,A)')
     &                     '        Angular Type: ', AngTp(iAng)
                     Write (LuWr,*) '                   Exponent   ',
     &                              ' Contraction Coefficients'
                     Write (LuWr,*)
                     Write (LuWr,
     &                  '(A,18X,8(G12.5),/,5(32X,8(G12.5),/))')
     &                  '     Bk-values',
     &                  (Shells(iSh)%Bk(i),i=1,Shells(iSh)%nBk)
                     Write (LuWr,
     &                  '(A,18X,8(G12.5),/,5(32X,8(G12.5),/))')
     &                  '     Frac.Occ.',
     &                  (Shells(iSh)%Occ(i),i=1,Shells(iSh)%nBk)
                  End If
*
                  Do i=1,Shells(iSh)%nBk
                     Shells(iSh)%Bk(i)=Shells(iSh)%Bk(i)
     &                                *Shells(iSh)%Occ(i)
                  End Do
*
                  If (iPrint.ge.10) Then
                     Do kExp = 1, Shells(iSh)%nExp
                        jExp  = jExp  + 1
                        Write (LuWr,'(14X,D16.9,8(G12.5),'//
     &                        '3(/,30X,8(G12.5)))')
     &                          Shells(ish)%Exp(kExp),
     &                        ( Shells(ish)%Cff_c(kExp,ib,2),
     &                     ib=1,Shells(iSh)%nBk)
                     End Do
                  End If ! If (iPrint.ge.10) Then
               End If ! If (Shells(iSh)%nBk.ne.0) Then
               iSh = iSh + 1
            End Do    ! iAng

*
*--------------Auxilliary core basis
*
            If (iPrint.ge.10) Then
               iSh = dbsc(iCnttp)%iSOC
               nSumB = 0
               jSh = iSh
               Do iAng = 0, dbsc(iCnttp)%nSOC-1
                  nSumB = nSumB + Shells(jSh)%nBasis
                  jSh = jSh + 1
               End Do
               If (nSumB.ne.0.and.iPrint.ge.10) Then
                  Write (LuWr,*)
                  Write (LuWr,*)
                  Write (LuWr,*) ' SOC Basis'
               End If
               Do iAng = 0, dbsc(iCnttp)%nSOC-1
                  If (Shells(iSh)%nBasis.ne.0) Then
                     Write (LuWr,*)
                     Write (LuWr,'(19X,A,A)')
     &                     '        Angular Type: ', AngTp(iAng)
                     Write (LuWr,*) '                   Exponent   ',
     &                              ' Contraction Coefficients'
                     Write (LuWr,*)
                     Do kExp = 1, Shells(iSh)%nExp
                        jExp  = jExp  + 1
                        Write (LuWr,'(14X,D16.9,10(1X,F10.6),'//
     &                           '3(/,30X,10(1X,F10.6)))')
     &                        Shells(iSh)%Exp(kExp),
     &                      ( Shells(iSh)%Cff_c(kExp,ib,1),
     &                        ib=1,Shells(iSh)%nBasis)
                     End Do
                  End If
                  iSh = iSh + 1
               End Do
            End If ! If (iPrint.ge.10) Then
*
*-----------Spectral Resolution Basis Set
*
            If (iPrint.ge.10) Then
               iSh = dbsc(iCnttp)%iSRO
               nSumA = 0
               jSh = iSh
               Do iAng = 0, dbsc(iCnttp)%nSRO-1
                  nSumA = nSumA + Shells(jSh)%nExp
                  jSh = jSh + 1
               End Do
               If (nSumA.ne.0) Then
                  Write (LuWr,*)
                  Write (LuWr,*)
                  Write (LuWr,*) ' Spectral Resolution Basis Set'
               End If
               Do iAng = 0, dbsc(iCnttp)%nSRO-1
                  nExpi=Shells(iSh)%nExp
                  If (nExpi.ne.0) Then
                     Write (LuWr,*)
                     Write (LuWr,'(19X,A,A)')
     &                     '        Angular Type: ', AngTp(iAng)
                     Call RecPrt(' Exponents',' ',
     &                           Shells(iSh)%Exp,nExpi,1)
                     If (iPrint.ge.11) Then
                        Call RecPrt(' The Akl matrix','(5D20.13)',
     &                              Shells(iSh)%Akl(1,1,1),nExpi,
     &                                                     nExpi)
                        Call RecPrt(' The Adl matrix','(5D20.13)',
     &                              Shells(iSh)%Akl(1,1,2),nExpi,
     &                                                     nExpi)
                     End If
                  End If
                  iSh = iSh + 1
               End Do ! iAng
            End If  ! If (iPrint.ge.10) Then
         End If ! If (dbsc(iCnttp)%ECP) Then
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.6) Then
         Call CollapseOutput(0,'   Primitive basis info:')
         Write (LuWr,*)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DistMemo2v4(NaGrp,NbeGrp,NaSGrp,NbeSgrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,PosTau,PosT2n1,PosT2n2,PosT2w,PosL11,PosL12, &
                       PosL21,PosL22,PosL23,PosL24,PosL2W,PosH1,PosH2,PosM1,PosM2,PosW1,PosW2,PosWw,PosWx,PosT,NL2)
! This routine does:
! define initial positions of T,L,M and W arrays,
! described in o2v4ctl routine
!
! I/O parameter description:
! NaGrp    - # of groups in a set (I)
! NbeGrp   - # of groups in be set (I)
! NaSGrp   - # of subgroups in each (a)' group (I)
! NbeSGrp  - # of subgroups in each (be)' group (I)
! mdGrpa   - # maximal dimension od (a)' group (I)
! mdGrpbe  - # maximal dimension od (be)' group (I)
! mdSGrpa  - # maximal dimension od (a)" subgroup (I)
! mdSGrpbe - # maximal dimension od (be)" subgroup (I)
! PosX     - initial positions of arrays (O-all)
! PosT     - next free position (O)
! NL2      - # of L2 vectors (O)

use Index_Functions, only: nTri_Elem
use chcc_global, only: intkey, nc, no, nv, printkey
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NaGrp, NbeGrp, NaSGrp, NbeSgrp, mdGrpa, mdGrpbe, mdSGrpa, mdSGrpbe
integer(kind=iwp), intent(out) :: PosTau, PosT2n1, PosT2n2, PosT2w, PosL11, PosL12, PosL21, PosL22, PosL23, PosL24, PosL2W, PosH1, &
                                  PosH2, PosM1, PosM2, PosW1, PosW2, PosWw, PosWx, NL2
integer(kind=iwp), intent(inout) :: PosT
integer(kind=iwp) :: lenab, lenbega, length

!1 Tau

PosTau = PosT
if (NaGrp == 1) then
  length = no*no*nTri_Elem(nv)
else
  length = no*no*mdGrpa*mdGrpa
end if
PosT = PosT+length
if (printkey >= 10) write(u6,99) 'DM Tau',PosTau

!2 T2n files

posT2n1 = PosT
if ((NbeGrp == 1) .and. (NbeSGrp == 1)) then
  length = nTri_Elem(no)*nTri_Elem(nv)
else
  length = nTri_Elem(no)*mdSGrpbe*mdSGrpbe
end if
PosT = PosT+length

PosT2n2 = PosT
if ((NbeGrp == 1) .and. (NbeSGrp == 1)) then
  length = nTri_Elem(no-1)*nTri_Elem(nv-1)
else
  length = nTri_Elem(no-1)*mdSGrpbe*mdSGrpbe
end if
PosT = PosT+length

PosT2w = PosT
if ((NbeGrp == 1) .and. (NbeSGrp == 1)) then
  length = nTri_Elem(no)*nTri_Elem(nv)
else
  length = nTri_Elem(no)*mdSGrpbe*mdSGrpbe
end if
PosT = PosT+length
if (printkey >= 10) write(u6,99) 'DM T2 ',PosT2n1,PosT2n2,PosT2w

! L1 files

if (intkey == 1) then
  ! integral based
  length = 0
else
  ! cholesky based
  length = nc*mdGrpa*no
end if

if (NaGrp == 1) then
  PosL11 = PosT
  PosL12 = PosT
  PosT = PosT+length
else
  PosL11 = PosT
  PosT = PosT+length
  PosL12 = PosT
  PosT = PosT+length
end if
if (printkey >= 10) write(u6,99) 'DM L1 ',PosL11,PosL12

! L2 files

if (intkey == 1) then
  ! integral based
  length = 0
else
  ! cholesky based
  length = nc*mdGrpa*mdGrpbe
end if

if (NaGrp == 1) then
  if (NbeGrp == 1) then
    ! All L2 are identical
    PosL21 = PosT
    PosL22 = PosT
    PosL23 = PosT
    PosL24 = PosT
    PosT = PosT+length
    NL2 = 1
  else
    ! L21=L23 and L22=L24
    PosL21 = PosT
    PosL23 = PosT
    PosT = PosT+length
    PosL22 = PosT
    PosL24 = PosT
    PosT = PosT+length
    NL2 = 2
  end if
else
  if (NbeGrp == 1) then
    ! L21=L22 and L23=L24
    PosL21 = PosT
    PosL22 = PosT
    PosT = PosT+length
    PosL23 = PosT
    PosL24 = PosT
    PosT = PosT+length
    NL2 = 2
  else
    ! all L2 files are different
    PosL21 = PosT
    PosT = PosT+length
    PosL22 = PosT
    PosT = PosT+length
    PosL23 = PosT
    PosT = PosT+length
    PosL24 = PosT
    PosT = PosT+length
    NL2 = 4
  end if
end if

PosL2W = PosT
if (intkey == 1) then
  ! integral based
  length = 0
else
  ! cholesky based
  if ((NaGrp == 1) .and. (NbeGrp == 1)) then
    length = nc*nTri_Elem(nv)
  else
    length = nc*mdGrpa*mdGrpbe
  end if
  if ((no*mdGrpbe) > length) then
    length = no*mdGrpbe
  end if
  if (nc*no*mdGrpa > length) length = nc*no*mdGrpa
end if

PosT = PosT+length

if (printkey >= 10) write(u6,99) 'DM L2 ',PosL21,PosL22,PosL23,PosL24,PosL2W

! H files

length = no*mdSGrpbe
if (intkey == 1) then
  PosH1 = PosT
  PosT = PosT+length
  PosH2 = PosT
  PosT = PosT+length
else
  PosH1 = PosT
  PosH2 = PosT
end if
if (printkey >= 10) write(u6,99) 'DM H  ',PosH1,PosH2

! M files

length = nc*mdSGrpa*mdSGrpbe

if ((NaGrp == 1) .and. (NaSGrp == 1) .and. (NbeGrp == 1) .and. (NbeSGrp == 1)) then
  ! M1=M2
  PosM1 = PosT
  PosM2 = PosT
  PosT = PosT+length
else
  ! M files are different
  PosM1 = PosT
  PosT = PosT+length
  PosM2 = PosT
  PosT = PosT+length
end if
if (printkey >= 10) write(u6,99) 'DM M  ',PosM1,PosM2

! W1,W2 files

if (NaGrp*NaSGrp == 1) then
  ! W1 and W2 are identical
  length = mdSGrpa*mdSGrpbe*mdSGrpa*mdSGrpbe
  if ((no > mdSGrpbe) .and. (intkey == 1)) length = mdSGrpa*mdSGrpbe*mdSGrpa*no
  PosW1 = PosT
  PosW2 = PosT
  PosT = PosT+length
else
  ! W1 and W2 are different
  length = mdSGrpa*mdSGrpbe*mdSGrpa*mdSGrpbe
  if ((no > mdSGrpbe) .and. (intkey == 1)) length = mdSGrpa*mdSGrpbe*mdSGrpa*no
  PosW1 = PosT
  PosT = PosT+length
  PosW2 = PosT
  PosT = PosT+length
end if

! Ww file

PosWw = PosT

if ((NaGrp == 1) .and. (NaSGrp == 1)) then
  lenab = nTri_Elem(nv)
else
  lenab = mdSGrpa*mdSGrpa
end if
if ((NbeGrp == 1) .and. (NbeSGrp == 1)) then
  lenbega = nTri_Elem(nv)
else
  lenbega = mdSGrpbe*mdSGrpbe
end if

length = lenab*lenbega
if (intkey == 1) then
  length = mdSGrpa*mdSGrpbe*mdSGrpa*mdSGrpbe
  if (no > mdSGrpbe) length = mdSGrpa*mdSGrpbe*mdSGrpa*no
end if
PosT = PosT+length

! Wx file

PosWx = PosT
length = mdSGrpa*mdSGrpbe*mdSGrpa*no
if (intkey == 0) length = 0
PosT = PosT+length

if (printkey >= 10) then
  write(u6,99) 'DM W  ',PosW1,PosW2,PosWw,PosWx

  write(u6,99) 'PosT ',PosT
end if

return

99 format(a7,10(i10,1x))

end subroutine DistMemo2v4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
*               2019, Stefano Battaglia                                *
************************************************************************
      SUBROUTINE CASPT2(IRETURN)
      USE SUPERINDEX
      USE INPUTDATA, ONLY: INPUT
      USE PT2WFN
      use output_caspt2, only:iPrGlb,terse,usual,verbose
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King, Set_Do_Parallel
#endif
      IMPLICIT NONE
      INTEGER IRETURN
*----------------------------------------------------------------------*
*     1998  PER-AAKE MALMQUIST                                         *
*     DEPARTMENT OF THEORETICAL CHEMISTRY                              *
*     UNIVERSITY OF LUND, SWEDEN                                       *
*----------------------------------------------------------------------*

C     SECOND ORDER PERTURBATION CALCULATIONS WITH A CASSCF
C     REFERENCE FUNCTION.

C     ORIGINAL CASPT2 PROGRAM WRITTEN 890526 BY:
C     KERSTIN ANDERSSON (ALL CASPT2 CODE WITH FOLLOWING EXCEPTIONS)
C     PER-AKE MALMQVIST (THE GUGA PART)
C     BJORN O ROOS      (THE INTEGRAL TRANSFORMATION)

C     MODIFIED 1991-02-23 BY PER-AAKE MALMQUIST, FOR USE WITH THE
C     MOLCAS RASSCF PROGRAM.

C     ALL PROGRAM REWRITTEN (MALMQVIST 1993) FOR MOLCAS VERSION 3,
C     EXCEPT TRACTL AND TRA2 KEPT BUT SLIGHTLY MODIFIED, AND ALSO:
C     INTERFACING WITH MOLCAS-3 BY MARCUS FUELSCHER

C     REWRITTEN FOR 1) EXACT ACTIVE DENSITY MATRIX
C     2) QUANTITIES NEEDED FOR GRADIENTS
C     3) MULTI-STATE CASPT2
C     BY MALMQVIST 1998.
C
C     SINCE THEN, THE FOLLOWING MODIFICATIONS HAVE BEEN MADE:
C     IPEA HAMILTONIAN BY G. GHIGO & P. MALMQVIST
C       Chem. Phys. Lett. 396, pp 142 (2004)
C       http://dx.doi.org/10.1016/j.cplett.2004.08.032
C     LOVCASPT2/FNOCASPT2/AFREEZE BY B. ROOS & F. AQUILANTE
C       J. Chem. Phys. 131, 034113 (2009)
C       http://dx.doi.org/10.1063/1.3157463
C     CHOLESKY SUPPORT BY P. MALMQVIST AND F. AQUILANTE
C       J. Chem. Theory Comput. 4 (5), pp 694-702 (2008)
C       http://dx/doi.org/10.1021/ct700263h
C     RASPT2 BY P. MALMQVIST
C       J. Chem. Phys. 128, 204109 (2008)
C       http://dx.doi.org/10.1063/1.2920188
C     PARALLELIZATION BY S. VANCOILLIE
C       J. Comp. Chem. 34, pp 1937-1948 (2013)
C       http://dx.doi.org/10.1002/jcc.23342
C     MAJOR REFACTORING OF INITIALIZATION PHASE AND ADDITION OF
C     HDF5 SUPPORT BY S. VANCOILLIE (2016)
C
************************************************************************
#include "rasdim.fh"
#include "warnings.h"
#include "constants.fh"
#include "caspt2.fh"
#include "pt2_guga.fh"
#include "intgrl.fh"
#include "eqsolv.fh"
#include "chocaspt2.fh"
#include "stdalloc.fh"
      CHARACTER(LEN=60) STLNE2
* Timers
      REAL*8  CPTF0, CPTF10, CPTF11, CPTF12, CPTF13, CPTF14,
     &       TIOTF0,TIOTF10,TIOTF11,TIOTF12,TIOTF13,TIOTF14,
     &          CPE,CPUTOT,TIOE,TIOTOT
* Indices
      INTEGER I
      INTEGER ISTATE
      INTEGER IGROUP,JSTATE_OFF
* Convergence check
      INTEGER ICONV
* Relative energies
      REAL*8  RELAU,RELEV,RELCM,RELKJ

* Effective Hamiltonian
      REAL*8, ALLOCATABLE :: Heff(:,:), Ueff(:,:)

* Zeroth-order Hamiltonian
      REAL*8, ALLOCATABLE :: H0(:,:), U0(:,:)

      Call StatusLine('CASPT2:','Just starting')

      IRETURN = 0

      CALL SETTIM
      ! CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)

* Probe the environment to globally set the IPRGLB value
      Call Set_Print_Level

*======================================================================*
*
      Call StatusLine('CASPT2:','Initializing')
      CALL PT2INI
* Initialize effective Hamiltonian and eigenvectors
      CALL MMA_ALLOCATE(Heff,Nstate,Nstate,Label='Heff')
      CALL MMA_ALLOCATE(Ueff,Nstate,Nstate,Label='Ueff')
      Heff=0.0D0
      Ueff=0.0D0
* Initialize zeroth-order Hamiltonian and eigenvectors
      CALL MMA_ALLOCATE(H0,Nstate,Nstate,Label='H0')
      CALL MMA_ALLOCATE(U0,Nstate,Nstate,Label='U0')
      H0(:,:)=0.0D0
* U0 is initialized as the identity matrix, in the case of a
* standard MS-CASPT2 calculation it will not be touched anymore
      U0(:,:)=0.0D0
      call dcopy_(Nstate,[1.0d0],0,U0,Nstate+1)
*
*======================================================================*
* Put the CASSCF energies on the diagonal of Heff, i.e. form the
* first-order corrected effective Hamiltonian:
*     Heff[1] = PHP
* and later on we will add the second-order correction
* Heff(2) = PH \Omega_1 P to Heff[1]
      DO I=1,NSTATE
        HEFF(I,I) = REFENE(I)
      END DO
      IF (IPRGLB.GE.VERBOSE) THEN
        write(6,*)' Heff[1] in the original model space basis:'
        call prettyprint(Heff,Nstate,Nstate)
      END IF
* If the EFFE keyword has been used, we already have the multi state
* coupling Hamiltonian effective matrix, just copy the energies and
* proceed to the MS coupling section.
      IF (INPUT%JMS) THEN
        ! in case of XMS, XDW, RMS, we need to rotate the states
        if (IFXMS .or. IFRMS) then
          call xdwinit(Heff,H0,U0)
        end if
        DO I=1,NSTATE
          ENERGY(I)=INPUT%HEFF(I,I)
        END DO
        HEFF(:,:)=INPUT%HEFF(:,:)
        GOTO 1000
      END IF

* In case of a XDW-CASPT2 calculation we first rotate the CASSCF
* states according to the XMS prescription in xdwinit
      if ((IFXMS .and. IFDW) .or. (IFRMS)) then
        call xdwinit(Heff,H0,U0)
        if (IFEFOCK) then
          call wgtinit(H0)
        else
          call wgtinit(Heff)
        end if
      else
        call wgtinit(Heff)
      end if

* Before entering the long loop over groups and states, precompute
* the 1-RDMs for all states and mix them according to the type of
* calculation: MS, XMS, DW or XDW.
      call rdminit

* For (X)Multi-State, a long loop over root states.
* The states are ordered by group, with each group containing a number
* of group states for which GRPINI is called.
      JSTATE_OFF=0
      STATELOOP: DO IGROUP=1,NGROUP

       IF ((NLYGROUP.NE.0).AND.(IGROUP.NE.NLYGROUP)) THEN
         JSTATE_OFF = JSTATE_OFF + NGROUPSTATE(IGROUP)
         CYCLE
       END IF

       IF (IPRGLB.GE.USUAL) THEN
         WRITE(STLNE2,'(A,1X,I3)') 'CASPT2 computation for group',IGROUP
         CALL CollapseOutput(1,TRIM(STLNE2))
         WRITE(6,*)
       END IF

       CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
       CALL GRPINI(IGROUP,NGROUPSTATE(IGROUP),JSTATE_OFF,HEFF,H0,U0)
       CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
       CPUGIN=CPTF10-CPTF0
       TIOGIN=TIOTF10-TIOTF0
CProducing XMS Rotated States

       DO ISTATE=1,NGROUPSTATE(IGROUP)
         JSTATE = JSTATE_OFF + ISTATE


* Skip this state if we only need 1 state and it isn't this "one".
         IF ((NLYROOT.NE.0).AND.(JSTATE.NE.NLYROOT)) CYCLE

         CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
         CALL STINI
         CALL TIMING(CPTF11,CPE,TIOTF11,TIOE)
         CPUSIN=CPTF11-CPTF0
         TIOSIN=TIOTF11-TIOTF0

* Solve CASPT2 equation system and compute corr energies.
         IF (IPRGLB.GE.USUAL) THEN
            WRITE(6,'(20A4)')('****',I=1,20)
            WRITE(6,*)' CASPT2 EQUATION SOLUTION'
            WRITE(6,'(20A4)')('----',I=1,20)
         END IF

         Write(STLNE2,'(A27,I3)')'Solve CASPT2 eqs for state ',
     &                               MSTATE(JSTATE)
         Call StatusLine('CASPT2:',TRIM(STLNE2))
         CALL EQCTL2(ICONV)

* Save the final caspt2 energy in the global array ENERGY():
         ENERGY(JSTATE)=E2TOT

         CALL TIMING(CPTF12,CPE,TIOTF12,TIOE)
         CPUPT2=CPTF12-CPTF11
         TIOPT2=TIOTF12-TIOTF11

         IF (ICONV .NE. 0) THEN
C     No convergence. Skip the rest of the calculation.
            IRETURN = _RC_NOT_CONVERGED_
            EXIT STATELOOP
         END IF

C     Orbitals, properties:

         ! if the dens keyword is used, need accurate density and
         ! for that the serial LUSOLV file is needed, in that case copy
         ! the distributed LURHS() to LUSOLV here.
         IF(IFDENS) THEN
           CALL PCOLLVEC(IRHS,0)
           CALL PCOLLVEC(IVECX,0)
           CALL PCOLLVEC(IVECR,0)
           CALL PCOLLVEC(IVECC,1)
           CALL PCOLLVEC(IVECC2,1)
           CALL PCOLLVEC(IVECW,1)
         END IF

         IF (IFPROP) THEN
           IF (IPRGLB.GE.USUAL) THEN
             WRITE(6,*)
             WRITE(6,'(20A4)')('****',I=1,20)
             WRITE(6,*)' CASPT2 PROPERTY SECTION'
           END IF
           CALL PRPCTL
         ELSE
           IF (IPRGLB.GE.USUAL) THEN
             WRITE(6,*)
             WRITE(6,*)'  (Skipping property calculation,'
             WRITE(6,*)'   use PROP keyword to activate)'
           END IF
         END IF

         CALL TIMING(CPTF13,CPE,TIOTF13,TIOE)
         CPUPRP=CPTF13-CPTF12
         TIOPRP=TIOTF13-TIOTF12

C     Gradients.
C     Note: Quantities computed in gradients section can also
C     be used efficiently for computing Multi-State HEFF.
C     NOTE: atm the MS-CASPT2 couplings computed here are wrong!
         IF(IFDENS) THEN
           IF (IPRGLB.GE.VERBOSE) THEN
              WRITE(6,*)
              WRITE(6,'(20A4)')('****',I=1,20)
              IF(NSTATE.GT.1) THEN
              WRITE(6,*)' CASPT2 GRADIENT/MULTI-STATE COUPLINGS SECTION'
              ELSE
                 WRITE(6,*)' CASPT2 GRADIENT SECTION'
              END IF
           END IF
           Call StatusLine('CASPT2:','Multi-State couplings')
C-SVC: for now, this part is only performed on the master node
#ifdef _MOLCAS_MPP_
           IF (Is_Real_Par()) THEN
             Call Set_Do_Parallel(.False.)
             IF (KING()) CALL GRDCTL(HEFF)
             Call Set_Do_Parallel(.True.)
             CALL GASync
           ELSE
             CALL GRDCTL(HEFF)
           END IF
#else
           CALL GRDCTL(HEFF)
#endif
         END IF

         IF((.NOT.IFDENS) .AND. IFMSCOUP) THEN
C     If this was NOT a gradient, calculation, then the multi-state
C     couplings are more efficiently computed via three-body
C     transition density matrices.
           IF (IPRGLB.GE.VERBOSE) THEN
              WRITE(6,*)
              WRITE(6,'(20A4)')('****',I=1,20)
              WRITE(6,*)' CASPT2 MULTI-STATE COUPLINGS SECTION'
           END IF
           Call StatusLine('CASPT2:','Multi-State couplings')
           CALL MCCTL(HEFF)
         END IF


         CALL TIMING(CPTF14,CPE,TIOTF14,TIOE)
         CPUGRD=CPTF14-CPTF13
         TIOGRD=TIOTF14-TIOTF13

         CPUTOT=CPTF14-CPTF0
         TIOTOT=TIOTF14-TIOTF0

         IF (ISTATE.EQ.1) THEN
           CPUTOT=CPUTOT+CPUGIN
           TIOTOT=TIOTOT+TIOGIN
         ELSE
           CPUGIN=0.0D0
           TIOGIN=0.0D0
           CPUFMB=0.0D0
           TIOFMB=0.0D0
           CPUINT=0.0D0
           TIOINT=0.0D0
         END IF

        IF (IPRGLB.GE.VERBOSE) THEN
          WRITE(6,*)
          WRITE(6,'(A,I6)')    '  CASPT2 TIMING INFO FOR STATE ',
     &                         MSTATE(JSTATE)
          WRITE(6,*)
          WRITE(6,'(A)')       '                        '//
     &                         ' cpu time  (s) '//
     &                         ' wall time (s) '
          WRITE(6,'(A)')       '                        '//
     &                         ' ------------- '//
     &                         ' ------------- '
          WRITE(6,*)
          WRITE(6,'(A,2F14.2)')'  Group initialization  ',CPUGIN,TIOGIN
          WRITE(6,'(A,2F14.2)')'  - Fock matrix build   ',CPUFMB,TIOFMB
          WRITE(6,'(A,2F14.2)')'  - integral transforms ',CPUINT,TIOINT
          WRITE(6,'(A,2F14.2)')'  State initialization  ',CPUSIN,TIOSIN
          WRITE(6,'(A,2F14.2)')'  - density matrices    ',CPUFG3,TIOFG3
          WRITE(6,'(A,2F14.2)')'  CASPT2 equations      ',CPUPT2,TIOPT2
          WRITE(6,'(A,2F14.2)')'  - H0 S/B matrices     ',CPUSBM,TIOSBM
          WRITE(6,'(A,2F14.2)')'  - H0 S/B diag         ',CPUEIG,TIOEIG
          WRITE(6,'(A,2F14.2)')'  - H0 NA diag          ',CPUNAD,TIONAD
          WRITE(6,'(A,2F14.2)')'  - RHS construction    ',CPURHS,TIORHS
          WRITE(6,'(A,2F14.2)')'  - PCG solver          ',CPUPCG,TIOPCG
          WRITE(6,'(A,2F14.2)')'    - scaling           ',CPUSCA,TIOSCA
          WRITE(6,'(A,2F14.2)')'    - lin. comb.        ',CPULCS,TIOLCS
          WRITE(6,'(A,2F14.2)')'    - inner products    ',CPUOVL,TIOOVL
          WRITE(6,'(A,2F14.2)')'    - basis transforms  ',CPUVEC,TIOVEC
          WRITE(6,'(A,2F14.2)')'    - sigma routines    ',CPUSGM,TIOSGM
          WRITE(6,'(A,2F14.2)')'  - array collection    ',CPUSER,TIOSER
          WRITE(6,'(A,2F14.2)')'  Properties            ',CPUPRP,TIOPRP
          WRITE(6,'(A,2F14.2)')'  Gradient/MS coupling  ',CPUGRD,TIOGRD
          WRITE(6,'(A,2F14.2)')' Total time             ',CPUTOT,TIOTOT
          WRITE(6,*)
        END IF

C End of long loop over states in the group
       END DO
       IF (IPRGLB.GE.USUAL) THEN
         CALL CollapseOutput(0,'CASPT2 computation for group ')
         WRITE(6,*)
       END IF
C End of long loop over groups
        JSTATE_OFF = JSTATE_OFF + NGROUPSTATE(IGROUP)
      END DO STATELOOP

1000  CONTINUE

      IF (IRETURN.NE.0) GOTO 9000
      IF(IPRGLB.GE.TERSE) THEN
       WRITE(6,*)' Total CASPT2 energies:'
       IF (IFXMS.or.IFRMS) THEN
        WRITE(6,*)
        WRITE(6,*)' State-specific CASPT2 energies obtained using'
        WRITE(6,*)' rotated states do not have a well-defined physical'
        WRITE(6,*)' meaning, however they can be extracted from the'
        WRITE(6,*)' diagonal of the effective Hamiltonian.'
       ELSE
        DO I=1,NSTATE
         IF ((NLYROOT.NE.0).AND.(I.NE.NLYROOT)) CYCLE
         CALL PrintResult(6,'(6x,A,I3,5X,A,F16.8)',
     &    'CASPT2 Root',MSTATE(I),'Total energy:',ENERGY(I),1)
        END DO
        IF(IPRGLB.GE.VERBOSE.AND.(NLYROOT.EQ.0)) THEN
         WRITE(6,*)
         WRITE(6,*)' Relative CASPT2 energies:'
         WRITE(6,'(1X,A4,4X,A12,1X,A10,1X,A10,1X,A10)')
     &     'Root', '(a.u.)', '(eV)', '(cm^-1)', '(kJ/mol)'
         ISTATE=1
         DO I=2,NSTATE
           IF (ENERGY(I).LT.ENERGY(ISTATE)) ISTATE=I
         END DO
         DO I=1,NSTATE
          RELAU = ENERGY(I)-ENERGY(ISTATE)
          RELEV = RELAU * CONV_AU_TO_EV_
          RELCM = RELAU * CONV_AU_TO_CM1_
          RELKJ = RELAU * CONV_AU_TO_KJ_PER_MOLE_
          WRITE(6,'(1X,I4,4X,F12.8,1X,F10.2,1X,F10.1,1X,F10.2)')
     &     MSTATE(I), RELAU, RELEV, RELCM, RELKJ
         END DO
        END IF
       END IF
       WRITE(6,*)
      END IF

      IF(NLYROOT.NE.0) IFMSCOUP=.FALSE.
      IF(IFMSCOUP) THEN
        Call StatusLine('CASPT2:','Effective Hamiltonian')
        CALL MLTCTL(HEFF,UEFF,U0)

        IF(IPRGLB.GE.VERBOSE.AND.(NLYROOT.EQ.0)) THEN
         WRITE(6,*)' Relative (X)MS-CASPT2 energies:'
         WRITE(6,'(1X,A4,4X,A12,1X,A10,1X,A10,1X,A10)')
     &     'Root', '(a.u.)', '(eV)', '(cm^-1)', '(kJ/mol)'
         DO I=1,NSTATE
          RELAU = ENERGY(I)-ENERGY(1)
          RELEV = RELAU * CONV_AU_TO_EV_
          RELCM = RELAU * CONV_AU_TO_CM1_
          RELKJ = RELAU * CONV_AU_TO_KJ_PER_MOLE_
          WRITE(6,'(1X,I4,4X,F12.8,1X,F10.2,1X,F10.1,1X,F10.2)')
     &     I, RELAU, RELEV, RELCM, RELKJ
         END DO
         WRITE(6,*)
        END IF
      END IF

* Back-transform the effective Hamiltonian and the transformation matrix
* to the basis of original CASSCF states
      CALL Backtransform(Heff,Ueff,U0)

* create a JobMix file
* (note that when using HDF5 for the PT2 wavefunction, IFMIX is false)
      CALL CREIPH_CASPT2(Heff,Ueff,U0)

* Store the PT2 energy and effective Hamiltonian on the wavefunction file
      CALL PT2WFN_ESTORE(HEFF)

* Store rotated states if XMUL + NOMUL
      IF (IFXMS.AND.(.NOT.IFMSCOUP)) CALL PT2WFN_DATA

* store information on runfile for geometry optimizations
      Call Put_iScalar('NumGradRoot',iRlxRoot)
      Call Store_Energies(NSTATE,ENERGY,iRlxRoot)

9000  CONTINUE

C Free resources, close files
      CALL PT2CLS()

      CALL MMA_DEALLOCATE(UEFF)
      CALL MMA_DEALLOCATE(U0)
      CALL MMA_DEALLOCATE(HEFF)
      CALL MMA_DEALLOCATE(H0)

C     PRINT I/O AND SUBROUTINE CALL STATISTICS
      IF ( IPRGLB.GE.USUAL ) THEN
        CALL FASTIO('STATUS')
      END IF

      Call StatusLine('CASPT2:','Finished.')
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_ANASIZE(VEC,LVEC,BIN,LBIN,LUPRI)
C
C     Purpose: analyse vector (histogram).
C
#include "implicit.fh"
      DIMENSION VEC(LVEC), BIN(LBIN)

      PARAMETER (ZERO = 0.0D0)

      PARAMETER (MBIN = 20)
      INTEGER   ICOUNT(MBIN)
      LOGICAL   FOUND

C     Return if nothing to do.
C     ------------------------

      IF ((LVEC.LT.1) .OR. (LBIN.LT.1)) RETURN

C     Ensure that BIN is in descending order.
C     ---------------------------------------

      IJOB = -1
      CALL CHO_ORDER(BIN,LBIN,IJOB)

C     Test that BIN is positive.
C     --------------------------

      IF (BIN(1) .LE. ZERO) RETURN

C     Analysis.
C     ---------

      NBIN = MIN(LBIN,MBIN)
      CALL IZERO(ICOUNT,NBIN)
      NLOW = 0
      NZER = 0
      NNEG = 0
      XNEG = ZERO

      DO I = 1,LVEC

         TEST = VEC(I)

         IF (TEST .LT. ZERO) THEN
            NNEG = NNEG + 1
            XNEG = MIN(XNEG,TEST)
         ELSE IF (TEST .EQ. ZERO) THEN
            NZER = NZER + 1
         END IF

         IBIN  = 0
         FOUND = .FALSE.
         DO WHILE ((.NOT.FOUND) .AND. (IBIN.LT.NBIN))
            IBIN = IBIN + 1
            IF (TEST .GE. BIN(IBIN)) THEN
               ICOUNT(IBIN) = ICOUNT(IBIN) + 1
               FOUND = .TRUE.
            END IF
         END DO
         IF (.NOT.FOUND) NLOW = NLOW + 1

      END DO

C     Print.
C     ------

      TOPCT = 1.0D2/DBLE(LVEC)

      JCOUNT = ICOUNT(1)
      WRITE(LUPRI,'(/,1X,A,11X,D11.4,A,I12,1X,F7.2,A,3X,A,F7.2,A)')
     & 'Larger than ',BIN(1),':',ICOUNT(1),
     & DBLE(ICOUNT(1))*TOPCT,'%','Accumulated: ',DBLE(JCOUNT)*TOPCT,'%'
      DO IBIN = 2,NBIN
         JCOUNT = JCOUNT + ICOUNT(IBIN)
         WRITE(LUPRI,'(1X,A,D11.4,A,D11.4,A,I12,1X,F7.2,A,3X,A,F7.2,A)')
     &   'Between ',BIN(IBIN-1),' and ',BIN(IBIN),':',ICOUNT(IBIN),
     &   DBLE(ICOUNT(IBIN))*TOPCT,'%',
     &   'Accumulated: ',DBLE(JCOUNT)*TOPCT,'%'
      END DO
      JCOUNT = JCOUNT + NLOW
      WRITE(LUPRI,'(1X,A,10X,D11.4,A,I12,1X,F7.2,A,3X,A,F7.2,A)')
     & 'Smaller than ',BIN(NBIN),':',NLOW,
     & DBLE(NLOW)*TOPCT,'%','Accumulated: ',DBLE(JCOUNT)*TOPCT,'%'

      WRITE(LUPRI,'(/,1X,A,I12,1X,F7.2,A)')
     & 'Number of elements exactly 0.0D0 :',NZER,
     & DBLE(NZER)*TOPCT,'%'
      WRITE(LUPRI,'(1X,A,I12,1X,F7.2,A)')
     & 'Number of negative elements      :',NNEG,
     & DBLE(NNEG)*TOPCT,'%'
      IF (NNEG .GT. 0) THEN
         WRITE(LUPRI,'(1X,A,D12.4)')
     & ' - numerically largest           :',XNEG
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Allocate_Work
*
*> @brief
*>   Allocate real memory of length \p n and return the corresponding pointer \p ip
*> @author R. Lindh
*>
*> @details
*> Short parameter list wrapper to ::GETMEM for allocation of
*> memory of type ``REAL*8``. Label defaulted to '``AW``'.
*>
*> @param[out] ip pointer to \c Work
*> @param[in]  n  length
************************************************************************
      Subroutine Allocate_Work(ip,n)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
*
      Call GetMem('AW','Allo','Real',ip,n)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Per Ake Malmqvist                                *
************************************************************************
      SUBROUTINE CREIPH_CASPT2(Heff,Ueff,U0)
      use definitions, only: iwp, wp, u6
      use constants, only: Zero
      use fciqmc_interface, only: DoFCIQMC
      use caspt2_global, only:iPrGlb, Weight
      use PrintLevel, only: USUAL
      use Molcas, only: LenIn
      USE REFWFN, ONLY: REFWFN_FILENAME, IADR15
      use gugx, only: L2ACT, LEVEL
      use caspt2_global, only: CMO, CMO_Internal, NCMO
      use stdalloc, only: mma_allocate, mma_deallocate
      use Molcas, only: LenIn, MxAct, MxOrb, MxRoot
      use RASDim, only: MxIter, MxTit
      use caspt2_module, only: Nstate,DOCUMULANT,HEADER,IFMIX,IFMSCOUP,
     &                         IFQCAN,IFRMS,IFXMS,IROOT,ISCF,ISPIN,
     &                         LROOTS,
     &                         NACTEL,BNAME,NASH,NBAS,NBSQT,NCONF,
     &                         NDEL,NELE3,NFRO,NHOLE1,NISH,NRAS1,NRAS2,
     &                         NRAS3,NROOTS,NSYM,POTNUC,STSYM,TITLE,
     &                         MSTATE,ENERGY,MSTATE
      use pt2_guga, only: CITHR,MXCI
      IMPLICIT None
C Normal operation: A new file, 'JOBMIX', will be created, with the
C CMO's and CI arrays of the JOBIPH, except that the CI arrays have
C been modified. They are now linear combinations of the original ones,
C using coefficients taken from the eigenvectors of the effective
C Hamiltonian.
C Also, replace the original CASSCF energies with CASPT2 or MS-CASPT2
C energies.
      real(kind=wp), intent(in):: Heff(Nstate,Nstate),
     &                            Ueff(Nstate,Nstate),
     &                            U0(Nstate,Nstate)

      integer(kind=iwp) JOBIPH, JOBMIX
      real(kind=wp) Weight_(MxRoot)
      real(kind=wp), allocatable:: CI1(:), CI2(:), OLDE(:), EFFCP(:)
      integer(kind=iwp), allocatable:: JROOT(:), IDIST(:)
      integer(kind=iwp) I,IAD15,IDISK,IDR,IDW,IISTATE,ISNUM,ISTATE,J,
     &                  JSNUM,MROOTS,NIDIST,NOLDE,ID
      real(kind=wp) X


C Not called, if .NOT.IFMIX, then only the new CI coefficients are
C printed, no JOBMIX file is created.
      IF (IFMSCOUP.AND.(ISCF.EQ.0)) THEN
        IF (.NOT.IFMIX) THEN
          IF (IPRGLB.GE.USUAL) CALL PRINT_CI_MIX(Ueff)
          RETURN
        END IF
      END IF
      IF (DOCUMULANT .OR. (.NOT.IFMIX)) RETURN

      if (DoFCIQMC) return

      IF(IFMSCOUP) THEN
        IF(IPRGLB.GE.USUAL) THEN
          WRITE(u6,*)' THE ORIGINAL CI ARRAYS ARE NOW MIXED AS LINEAR'
          WRITE(u6,*)' COMBINATIONS, GIVEN BY THE EIGENVECTORS.'
        END IF
      END IF

      IF(IPRGLB.GE.USUAL) THEN
        WRITE(u6,*)' A NEW JOBIPH FILE NAMED ''JOBMIX'' IS PREPARED.'
        WRITE(u6,'(20A4)')('****',I=1,20)
      END IF

* Note that JOBIPH file will contain all the RASSCF CI vectors
* plus a CASPT2 effective Hamiltonian for the selected states.
* The effective Hamiltonian for the states not included in the
* CASPT2 treatment will be diagonal with RASSCF energies!

* The JOBMIX will contain the (possibly mixed) CI vectors,
* with CASPT2 energies for the selected states and zero energy
* for states not included in the CASPT2 treatment
* If NoMulti was specified, the original state indexing is
* maintained, otherwise the new states are just 1, 2, 3...

      CALL mma_allocate(CI1,MXCI,Label='CI1')
      CALL mma_allocate(CI2,MXCI,Label='CI2')
      JOBIPH=15
      CALL DANAME(JOBIPH,refwfn_filename)
      JOBMIX=11
      CALL DANAME(JOBMIX,'JOBMIX')
C IADR15 is already known (it is the table of contents of the
C JOBIPH file). When copying/modifying selected data from JOBIPH
C to JOBMIX, we use the same TOC array, IADR15.
      IAD15=0
      CALL IDAFILE(JOBIPH,2,IADR15,30,IAD15)
      IAD15=0
      CALL IDAFILE(JOBMIX,1,IADR15,30,IAD15)
      IAD15=IADR15(1)
* Modify root index in case of MS
      CALL mma_allocate(JROOT,MXROOT,LABEL='JROOT')
      IF (IFMSCOUP) THEN
        CALL ICOPY(MXROOT,[0],0,JROOT,1)
        DO ISTATE=1,NSTATE
          JROOT(ISTATE)=ISTATE
        END DO
        MROOTS=NSTATE
      ELSE
        CALL ICOPY(MXROOT,IROOT,1,JROOT,1)
        MROOTS=NROOTS
      END IF
* Initialize WEIGHT_() (which is unused) just so detection
* of uninitialized memory does not get its knickers twisted
      CALL DCOPY_(MXROOT,[Zero],0,WEIGHT_,1)
      WEIGHT_(1:NROOTS) = WEIGHT(1:NROOTS)
      CALL WR_RASSCF_INFO(JOBMIX,1,iAd15,
     &                    NACTEL,ISPIN,NSYM,STSYM,
     &                    NFRO,NISH,NASH,NDEL,NBAS,8,
     &                    BNAME,(LenIn+8)*MXORB,NCONF,HEADER,144,
     &                    TITLE,4*18*MXTIT,POTNUC,
     &                    LROOTS,MROOTS,JROOT,MXROOT,NRAS1,
     &                    NRAS2,NRAS3,NHOLE1,NELE3,IFQCAN,
     &                    Weight_)
      CALL mma_deallocate(JROOT)
* Copy MO coefficients from JOBIPH to JOBMIX
      NCMO=NBSQT
      CALL mma_allocate(CMO_Internal,NCMO,Label='CMO_Internal')
      CMO=>CMO_Internal
      IAD15=IADR15(9)
      CALL DDAFILE(JOBIPH,2,CMO,NCMO,IAD15)
      IAD15=IADR15(9)
      CALL DDAFILE(JOBMIX,1,CMO,NCMO,IAD15)
* If IFQCAN.EQ.0, there is also an additional CMO set:
      IF(IFQCAN.EQ.0) THEN
        IAD15=IADR15(2)
        CALL DDAFILE(JOBIPH,2,CMO,NCMO,IAD15)
        IAD15=IADR15(2)
        CALL DDAFILE(JOBMIX,1,CMO,NCMO,IAD15)
      END IF
      CALL mma_deallocate(CMO_Internal)
      nullify(CMO)
* Copy all CI coefficients
      IDR=IADR15(4)
      IDW=IADR15(4)
      DO I=1,LROOTS
      CALL DDAFILE(JOBIPH,2,CI1,NCONF,IDR)
      CALL DDAFILE(JOBMIX,1,CI1,NCONF,IDW)
      END DO
* Replace old energy array with (MS-)CASPT2 energy values:
      NOLDE=MXROOT*MXITER
      CALL mma_allocate(OLDE,NOLDE,LABEL='OLDE')
      OLDE(:)=Zero
      IF (IFMSCOUP) THEN
        CALL DCOPY_(NSTATE,ENERGY,1,OLDE,1)
      ELSE
        DO ISTATE=1,NSTATE
          ISNUM=MSTATE(ISTATE)
          OLDE(ISNUM)=ENERGY(ISTATE)
        END DO
      END IF
      IAD15=IADR15(6)
      CALL DDAFILE(JOBMIX,1,OLDE,NOLDE,IAD15)
      CALL mma_deallocate(OLDE)
      IAD15=IADR15(18)
CSVC: translates levels to orbital index
      CALL IDAFILE(JOBMIX,1,L2ACT,mxAct,IAD15)
CSVC: translates orbital index to levels
      CALL IDAFILE(JOBMIX,1,LEVEL,mxAct,IAD15)

* PAM07: Eliminate unsafe IPOSFILE calls, use instead dummy i/o operations
* to find disk addresses to CI arrays:
      NIDIST=0
      DO ISTATE=1,NSTATE
        JSNUM=MSTATE(ISTATE)
        NIDIST=MAX(NIDIST,JSNUM)
      END DO
      CALL mma_allocate(IDIST,NIDIST,Label='IDIST')
      ID=IADR15(4)
      DO JSNUM=1,NIDIST
        IDIST(JSNUM)=ID
* This dummy operation does nothing, merely updates file pointer ID
        CALL DDAFILE(JOBIPH,0,CI1,NCONF,ID)
      END DO
* PAM07: Now IDIST() is used, instead of IPOSFILE, below!

C PAM05: Now CREIPH is called also in the NOMULT=1 case, to allow making
C a JOBMIX file also when NOMULT was ordered. Then the energies
C will be state-specific, of course. But no mixing of CI vectors.
      IF (IFMSCOUP) THEN
C Also write effective Hamiltonian on Jobiph file:
        CALL mma_allocate(EFFCP,LROOTS**2,Label='EFFCP')
C Read the effective Hamiltonian on JobIph file:
        IAD15=IADR15(17)
        CALL DDAFILE(JOBIPH,2,EFFCP,LROOTS**2,IAD15)
C Replace the relevant elements:
        DO I=1,NSTATE
          ISNUM=MSTATE(I)
          DO J=1,NSTATE
            JSNUM=MSTATE(J)
            EFFCP(ISNUM+LROOTS*(JSNUM-1))=HEFF(I,J)
          END DO
        END DO
C Write the present effective Hamiltonian:
        IAD15=IADR15(17)
        CALL DDAFILE(JOBIPH,1,EFFCP,LROOTS**2,IAD15)
C Write a diagonal Hamiltonian in the JOBMIX:
        IAD15=IADR15(17)
        CALL DCOPY_(LROOTS**2,[Zero],0,EFFCP,1)
        DO ISTATE=1,NSTATE
          EFFCP((ISTATE-1)*LROOTS+ISTATE)=ENERGY(ISTATE)
        END DO
        CALL DDAFILE(JOBMIX,1,EFFCP,LROOTS**2,IAD15)
        CALL mma_deallocate(EFFCP)
* Now 'mix' those states that were treated in the multi-state CASPT2
        IF (IPRGLB.GE.USUAL) THEN
          WRITE(u6,*)
          CALL CollapseOutput(1,'Mixed CI coefficients:')
        END IF
        DO ISTATE=1,NSTATE
          CALL DCOPY_(MXCI,[Zero],0,CI2,1)
          DO IISTATE=1,NSTATE
            JSNUM=MSTATE(IISTATE)
            IDISK=IDIST(JSNUM)
            CALL DDAFILE(JOBIPH,2,CI1,NCONF,IDISK)
            X=Ueff(IISTATE,ISTATE)
            CALL DAXPY_(NCONF,X,CI1,1,CI2,1)
          END DO
          IF(ISCF.EQ.0) THEN
            IF(IPRGLB.GE.USUAL) THEN
              WRITE(u6,'(1x,a,i3)')
     &        ' The CI coefficients for the MIXED state nr. ',ISTATE
              CALL PRWF_CP2(STSYM,NCONF,CI2,CITHR)
            END IF
          END IF
          IDISK=IDIST(ISTATE)
          CALL DDAFILE(JOBMIX,1,CI2,NCONF,IDISK)
        END DO
        IF(IPRGLB.GE.USUAL) THEN
          CALL CollapseOutput(0,'Mixed CI coefficients:')
          WRITE(u6,*)
        END IF
C In case of XMS/XDW/RMS and NOMUL, the CI vectors are replaced by the
C rotated zeroth-order states (they should have been printed earlier,
C in grpini)
      ELSE IF (IFXMS.or.IFRMS) THEN
        DO ISTATE=1,NSTATE
          ISNUM=MSTATE(ISTATE)
          CALL DCOPY_(MXCI,[Zero],0,CI2,1)
          DO IISTATE=1,NSTATE
            JSNUM=MSTATE(IISTATE)
            IDISK=IDIST(JSNUM)
            CALL DDAFILE(JOBIPH,2,CI1,NCONF,IDISK)
            X=U0(IISTATE,ISTATE)
            CALL DAXPY_(NCONF,X,CI1,1,CI2,1)
          END DO
          IDISK=IDIST(ISNUM)
          CALL DDAFILE(JOBMIX,1,CI2,NCONF,IDISK)
        END DO
      END IF

      CALL mma_deallocate(IDIST)
      CALL mma_deallocate(CI1)
      CALL mma_deallocate(CI2)

      CALL DACLOS(JOBIPH)
      CALL DACLOS(JOBMIX)

      END SUBROUTINE CREIPH_CASPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_AuxBasVectorNorm(ip_V,ip_Norm)
C
C     Thomas Bondo Pedersen, December 2010.
C
C     Purpose: compute Frobenius norm of aux bas vector.
C
      Implicit None
      Integer ip_V
      Integer ip_Norm
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nAtom, LDF_nBasAux_Atom
      External LDF_nAtom, LDF_nBasAux_Atom

      real*8 ddot_
      external ddot_

      Integer iAtom, nAtom, iAtomPair
      Integer ip0, ipN, ip, l

      Integer i, j
      Integer AP_2CFunctions
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      nAtom=LDF_nAtom()
      ip0=ip_V-1
      ipN=ip_Norm-1
      Do iAtom=1,nAtom
         l=LDF_nBasAux_Atom(iAtom)
         ip=iWork(ip0+iAtom)
         Work(ipN+iAtom)=sqrt(dDot_(l,Work(ip),1,Work(ip),1))
      End Do
      ip0=ip0+nAtom
      ipN=ipN+nAtom
      Do iAtomPair=1,NumberOfAtomPairs
         l=AP_2CFunctions(1,iAtomPair)
         ip=iWork(ip0+iAtomPair)
         Work(ipN+iAtomPair)=sqrt(dDot_(l,Work(ip),1,Work(ip),1))
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine chop2_cvb()

use casvb_global, only: cvb, kbasis, kbasiscvb, mxnvb, norb, orbs, release
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nvb_alloc
integer(kind=iwp), external :: nvb_cvb

if (release(2)) then
  call mma_deallocate(orbs)
  call mma_deallocate(cvb)
end if
release(2) = .true.
release(3) = .false.

! Note zeroing of ORBS and CVB:
call mma_allocate(orbs,norb,norb,label='orbs')
orbs(:,:) = Zero
! (MXNVB should be upper bound on KBASIS & KBASISCVB):
nvb_alloc = max(nvb_cvb(kbasiscvb),nvb_cvb(kbasis),mxnvb)
call mma_allocate(cvb,nvb_alloc,label='cvb')
cvb(:) = Zero

return

end subroutine chop2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CD_AInv(A,n,AInV,Thr_CD)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Real*8 A(n,n), AInv(n,n)
*
      Call GetMem('ADiag','Allo','Real',ipADiag,n)
      Call GetMem('iADiag','Allo','Inte',ipiADiag,n)
*
      iSeed=77
      Lu_A=IsFreeUnit(iSeed)
      Call DaName_MF_WA(Lu_A,'AMat09')
*
      iDisk=0
      Call dDaFile(Lu_A,1,A,n**2,iDisk)
*
C     Call RecPrt('A',' ',A,n,n)
*
      iSeed=iSeed+1
      Lu_Q=IsFreeUnit(iSeed)
      Call DaName_MF_WA(Lu_Q,'QMat09')
*
      call dcopy_(n,A,n+1,Work(ipADiag),1)
C     Call RecPrt('ADiag',' ',Work(ipADiag),1,n)
*
      Call CD_AInv_(n,m,Work(ipADiag),iWork(ipiADiag),Lu_A,Lu_Q,Thr_CD)
*
      Call GetMem('iADiag','Free','Inte',ipiADiag,n)
      Call GetMem('ADiag','Free','Real',ipADiag,n)
*
      Call GetMem('QVec','Allo','Real',ipQVec,n*m)
*
      iDisk=0
      Call dDaFile(Lu_Q,2,Work(ipQVec),n*m,iDisk)
*
C     Call RecPrt('QVec','(6G20.10)',Work(ipQVec),n,m)
      Call DGEMM_('N','T',n,n,m,
     &            1.0D0,Work(ipQVec),n,
     &                  Work(ipQVec),n,
     &            0.0D0,AInv,n)
C     Call RecPrt('AInv',' ',AInv,n,n)
      Call DaEras(Lu_Q)
      Call GetMem('QVec','Free','Real',ipQVec,n*n)
*                                                                      *
************************************************************************
*                                                                      *
*     Check the accuracy I-AA^1
*
#ifdef _ACCURACY_
      Call Allocate_Work(ipTmp,n*n)
*---
      Call FZero(Work(ipTmp),n*n)
*     I
      call dcopy_(n,1.0D0,0,Work(ipTmp),n+1)
*     I-AA^-1
      Call DGEMM_('N','N',n,n,n,
     &           -1.0D0,A,n,
     &                  AInv,n,
     &            1.0D0,Work(ipTmp),n)
      Call RecPrt('I-AA^-1','(6G20.12)',Work(ipTmp),n,n)
*
      Call DGEMM_('N','N',n,n,n,
     &            1.0D0,A,n,
     &                  AInv,n,
     &            0.0D0,Work(ipTmp),n)
      Call Allocate_Work(ipTmp2,n*n)
      Call FZero(Work(ipTmp2),n*n)
      call dcopy_(n,1.0D0,0,Work(ipTmp2),n+1)
      Call DGEMM_('N','N',n,n,n,
     &           -1.0D0,Work(ipTmp),n,
     &                  Work(ipTmp),n,
     &            1.0D0,Work(ipTmp2),n)
      Call RecPrt('I-AA^-1AA^-1','(6G20.12)',Work(ipTmp2),n,n)
*---
      Call Free_Work(ipTmp2)
      Call Free_Work(ipTmp)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      Subroutine CD_AInv_(n,m,ADiag,iADiag,Lu_A,Lu_Q,Thr_CD)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "real.fh"
      Real*8 ADiag(n)
      Integer iADiag(n)
      Logical Out_of_Core
*
      nScr=3*n
      Call GetMem('AMax','Max','Real',iDummy,MaxMem)
      lScr=Min(MaxMem,nScr)
      Call GetMem('AScr','Allo','Real',ipScr,lScr)
*
      nDim=n
      nIrrep=1
*
      Thr=Thr_CD*1.0D-1
      Lu_Z=7
      Call DaName_MF_WA(Lu_Z,'ZMAT09')
      Call Get_Pivot_idx(ADiag,nDim,nVec,Lu_A,Lu_Z,iADiag,Work(ipScr),
     &                   lScr,Thr)
      m=nVec
      If (nDim.ne.nVec) Then
         Write (6,*)
         Write (6,*) 'Detected lin. dep. in the auxiliary basis'
         Write (6,'(A,I6)')' # of aux. bfns before lin. dep. removal: ',
     &                     nDim
         Write (6,'(A,I6)')' # of aux. bfns after  lin. dep. removal: ',
     &                     nVec
      End If
*
      Call Pivot_Mat(nDim,nVec,Lu_A,Lu_Z,iADiag,Work(ipScr),lScr)
*
      Call GetMem('AScr','Free','Real',ipScr,lScr)
*
************************************************************************
*     A-vectors are now on disk. Go ahead and compute the Q-vectors!
************************************************************************
*
      ThrQ=Thr_CD*1.0D-1 ! Threshold for Inv_Cho_Factor
*
      nB=nVec
      If (nB.eq.0) Go To 777
      nQm=nB*(nB+1)/2
*
      nXZ=nB
      nQm_full= nB*(nB+1)/2
*
      Out_of_Core=2*nQm_full+5*nXZ.gt.MaxMem
*
      If (Out_Of_Core) Then
         mQm=(nQm*MaxMem-5*nXZ)/(2*nQm_full)
         a=One
         b=-Two*DBLE(mQm)
         mB=INT(-a/Two + Sqrt( (a/Two)**2 - b ))
         kQm=mB*(mB+1)/2
         If (kQm.gt.mQm) Then
            Call WarningMessage(2,'Error in CD_AInv')
            Write (6,*) 'kQm.gt.mQm!'
            Write (6,*) 'MaxMem=',MaxMem
            Write (6,*) 'nQm,mQm,kQm=',nQm,mQm,kQm
            Write (6,*) 'nB,mB=',nB,mB
            Call Abend()
         End If
      Else
         mB = nB
         kQm = nQm
      End If
*
      lQm=kQm
      lAm=lQm
*
      If (lQm.lt.1) Then
         Call WarningMessage(2,'Error in CD_AInv')
         Write (6,*) 'lQm.lt.1'
         Call Abend()
      End If
*
*     Some of memory for scratch arrays for Inv_Cho_Factor
*     Allocate memory for the A- and Q-vectors and initialize.
*
      Call GetMem('ICF','Allo','Real',ip_ICF,lAm+lQm+5*nXZ)
      ipZ    = ip_ICF
      ipX    = ip_ICF + 1*nXZ
      ip_Q_k = ip_ICF + 2*nXZ
      ip_A_k = ip_ICF + 3*nXZ
      ip_Scr = ip_ICF + 4*nXZ
      lScr=nXZ
      ip_Am  = ip_ICF + 5*nXZ
      ip_Qm  = ip_ICF + 5*nXZ + lAm
*
      Call FZero(Work(ip_Am),lAm)
      Call FZero(Work(ip_Qm),lQm)
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Process the A_ks to generate Q_ks.
*
      iAddr=0
      nMem=mB
      Do kCol = 1, nB
*
         iAddr_=iAddr
         If (kCol.le.nMem) Then
*           Point to A_k in Am
            iOff = (kCol-1)*kCol/2
            ip_A_l=ip_Am+iOff
            If (kCol.eq.1) Then
               nAm=nMem*(nMem+1)/2
               Call dDaFile(Lu_Z,2,Work(ip_Am),nAm,iAddr_)
            End If
*           Point to Q_k in Qm
            iOff = (kCol-1)*kCol/2
            ip_Q_l=ip_Qm+iOff
         Else If (kCol.gt.nMem) Then
*           Use special scratch for A_k
            ip_A_l=ip_A_k
            Call dDaFile(Lu_Z,2,Work(ip_A_l),kCol,iAddr_)
*           Use special scratch for Q_k
            ip_Q_l=ip_Q_k
         End If
*
         LinDep=2
         Call Inv_Cho_Factor(Work(ip_A_l),kCol,
     &                       Work(ip_Am),Work(ip_Qm),nMem,
     &                       Lu_Z,Lu_Q,
     &                       Work(ip_Scr),lScr,
     &                       Work(ipZ),Work(ipX),ThrQ,
     &                       Work(ip_Q_l),LinDep)
*
         If (LinDep.ne.0) Then
            Call WarningMessage(2,'Error in CD_AInv')
            Write(6,*) 'Inv_Cho_Factor found linear dependence!'
            Call Abend()
         End If
*
*        Write the new A/Q-vector to file
*
         iAddr_=iAddr
         If (kCol.eq.nMem) Then
            nQm=kCol*(kCol+1)/2
            Call dDaFile(Lu_Q,1,Work(ip_Qm),nQm,iAddr )
            Call dDaFile(Lu_Z,1,Work(ip_Am),nQm,iAddr_)
         Else If (kCol.gt.nMem) Then
            Call dDaFile(Lu_Q,1,Work(ip_Q_k),kCol,iAddr )
            Call dDaFile(Lu_Z,1,Work(ip_A_l),kCol,iAddr_)
         End If
*
      End Do
*
      Call GetMem('ICF','Free','Real',ip_ICF,lAm+lQm+5*nXZ)
 777  Continue
      Call DaEras(Lu_Z)
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Sort the Q-matrix back to the original order.
*
      Call GetMem('MemMax','Max','Real',iDummy,MaxMem2)
*
      nBfnTot=n
      nBfn2=n**2
      lScr=Min(MaxMem2,Max(nBfn2,2*nBfnTot))
      Call GetMem('Scr','Allo','Real',ip_Scr,lScr)
*
      Call Restore_Mat(nDim,nVec,Lu_Q,Lu_A,iADiag,Work(ip_Scr),lScr,
     &                 .true.)
      Call DaEras(Lu_Q)
      Lu_Q=Lu_A
*
*     Note: after the 'Restore' call to Sort_mat, the Q-matrix is
*           no longer stored as upper-triangular but as squared
*           (zeros have been added because the corresponding argument
*            is set to .true.). The column index is still pivoted.
*
      Call GetMem('Scr','Free','Real',ip_Scr,lScr)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine TAB2F(IVER,LV)

use guga_global, only: IAF, IBF, IFIRST, IJF, IPRINT, IVF0, K0F, K1F, K2F, K3F, LN, MXVERT, N, S
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVER, LV
integer(kind=iwp) :: I, IA1, IAT, IB1, IBT, IEL, II, IIM, IJD, IJR, IJRL, IJS, IJS1, IN_, ISTOP, IUT, IUT1, J, J11, J3, J4, JJ, &
                     JJ1, JJ2, K, NIJ, NIJ1, nijj
integer(kind=iwp), allocatable :: IORB(:)

nijj = 0
IEL = 2
if (IFIRST /= 0) IEL = 1
IEL = IEL+1
IUT = 0
IBF(1) = int(2*S)
IAF(1) = int(N-2*S)/2
IJF(LN+1) = 0
IJF(LN) = 1
NIJ = 1
IJR = 1
IJS = 2
IJRL = IJR
call mma_allocate(IORB,MXVERT,label='IORB')
IORB(1) = 0
do II=1,LN
  IIM = LN-II+1-LV
  do
    ! S=0
    NIJ = NIJ+1
    !if (NIJ > IVER)
    nijj = max(nij,nijj)
    IAF(NIJ) = IAF(IJR)
    IBF(NIJ) = IBF(IJR)
    IORB(NIJ) = IORB(IJR)+2
    if (IIM > 0) then
      call CHEL(IAF(NIJ),IBF(NIJ),IIM,IEL,ISTOP)
      if (ISTOP == 1) NIJ = NIJ-1
    end if
    if (IBF(IJR) /= 0) then
      ! S=1
      NIJ = NIJ+1
      !if (NIJ > IVER)
      nijj = max(nij,nijj)
      IAF(NIJ) = IAF(IJR)
      IBF(NIJ) = IBF(IJR)-1
      IORB(NIJ) = IORB(IJR)+1
      if (IIM > 0) then
        call CHEL(IAF(NIJ),IBF(NIJ),IIM,IEL,ISTOP)
        if (ISTOP == 1) NIJ = NIJ-1
      end if
    end if
    if (IAF(IJR) /= 0) then
      ! S=2
      NIJ = NIJ+1
      !if (NIJ > IVER)
      nijj = max(nij,nijj)
      IAF(NIJ) = IAF(IJR)-1
      IBF(NIJ) = IBF(IJR)+1
      IORB(NIJ) = IORB(IJR)+1
      if (IIM > 0) then
        call CHEL(IAF(NIJ),IBF(NIJ),IIM,IEL,ISTOP)
        if (ISTOP == 1) NIJ = NIJ-1
      end if
    end if
    if (IAF(IJR) /= 0) then
      ! S=3
      NIJ = NIJ+1
      !if (NIJ > IVER)
      nijj = max(nij,nijj)
      IAF(NIJ) = IAF(IJR)-1
      IBF(NIJ) = IBF(IJR)
      IORB(NIJ) = IORB(IJR)
      if (IIM > 0) then
        call CHEL(IAF(NIJ),IBF(NIJ),IIM,IEL,ISTOP)
        if (ISTOP == 1) NIJ = NIJ-1
      end if
    end if
    if (IJR == IJRL) exit
    IJR = IJR+1
  end do
  ! DELETE VERTICES
  NIJ1 = NIJ-1
  IN_ = IJS
  IUT = IJS
  do IJD=IJS,NIJ1
    JJ1 = NIJ-IJD+IJS-1
    J = JJ1+1
    do K=IJS,JJ1
      if ((IAF(J) == IAF(K)) .and. (IBF(J) == IBF(K))) then
        IAF(J) = -1
        IBF(J) = -1
        exit
      end if
    end do
  end do
  ! PACK VERTICES
  IJS1 = IJS+1
  do J=IJS1,NIJ
    if ((IAF(J) == -1) .and. (IBF(J) == -1)) then
      IN_ = IN_+1
    else
      IN_ = IN_+1
      IUT = IUT+1
      IAF(IUT) = IAF(IN_)
      IBF(IUT) = IBF(IN_)
      IORB(IUT) = IORB(IN_)
    end if
  end do
  ! ORDER VERTICES
  IUT1 = IUT-1
  do J=IJS,IUT1
    J11 = J+1
    do K=J11,IUT
      if (IAF(J)-IAF(K) <= 0) then
        if ((IAF(J)-IAF(K) < 0) .or. (IBF(J) <= IBF(K))) then
          IAT = IAF(J)
          IBT = IBF(J)
          IAF(J) = IAF(K)
          IBF(J) = IBF(K)
          IAF(K) = IAT
          IBF(K) = IBT
        end if
      end if
    end do
  end do
  if (II /= LN) IJF(LN-II) = IUT
  IJR = IJS
  IJS = IUT+1
  IJRL = IUT
  NIJ = IUT
end do
call mma_deallocate(IORB)
JJ2 = 0
do II=1,LN
  I = LN-II+1
  JJ1 = IJF(I+1)+1
  JJ2 = IJF(I)
  J3 = JJ2+1
  if (I /= 1) J4 = IJF(I-1)
  if (I == 1) J4 = IUT
  ! DETERMINE CASE DOWN
  do J=JJ1,JJ2
    IA1 = IAF(J)
    IB1 = IBF(J)
    K0F(J) = 0
    K1F(J) = 0
    K2F(J) = 0
    K3F(J) = 0
    do JJ=J3,J4
      if (IA1 /= IAF(JJ)) then
        if ((IA1-IAF(JJ)) == 1) then
          if (IB1 /= IBF(JJ)) then
            if ((IBF(JJ)-IB1) == 1) K2F(J) = JJ
          else
            K3F(J) = JJ
          end if
        end if
      else if (IB1 /= IBF(JJ)) then
        if ((IB1-IBF(JJ)) == 1) K1F(J) = JJ
      else
        K0F(J) = JJ
      end if
    end do
  end do
end do
IVF0 = IUT
K0F(IUT) = 0
K1F(IUT) = 0
K2F(IUT) = 0
K3F(IUT) = 0
K0F(IUT+1) = 0
K1F(IUT+1) = 0
K2F(IUT+1) = 0
K3F(IUT+1) = 0
if (IPRINT >= 5) write(u6,101)
if (IPRINT >= 5) write(u6,100) (J,IAF(J),IBF(J),K0F(J),K1F(J),K2F(J),K3F(J),J=1,IUT)
write(u6,*) ' Number of vertices',nijj,iut
if (nijj > iver) then
  write(u6,310) IVER
  call Abend()
end if

return

100 format(6X,I3,5X,2I4,5X,4I4)
101 format(///,6X,'TAB2F',//,8X,'J',7X,'AF',2X,'BF',6X,'K0F',1X,'K1F',1X,'K2F',1X,'K3F',/)
310 format(/,6X,'NUMBER OF VERTICES EXCEEDS',I7)

end subroutine TAB2F

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NGETH1(H,ISM,ITP,JSM,JTP)
*
* One-electron integrals over orbitals belonging to
* given OS class
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "detdim.fh"
#include "WrkSpc.fh"

*. Active pointers
#include "lbbas1.fh"

#include "Input.fh"
#include "orbinp_mclr.fh"
*.Output
      DIMENSION H(*)
*
      NI = NTSOB(ITP,ISM)
      NJ = NTSOB(JTP,JSM)
      IJ = 0
      DO 100 J = 1, NJ
        DO 50 I = 1, NI
          IJ = IJ+1
          H(IJ) = GTH1EN(I,ITP,ISM,J,JTP,JSM)
   50   CONTINUE
  100 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' H1 for itp ism jtp jsm ',ITP,ISM,JTP,JSM
        CALL WRTMAT(H,NI,NJ,NI,NJ)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ProjSym2(nAtoms,nCent,Ind,A,iDCRs,B,BqR,dB,dBqR)
      use Slapaf_Info, only: jStab,nStab
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "warnings.h"
*
#include "real.fh"
      Real*8 Tx(3,MxAtom), A(3,nCent), B(3,nCent), BqR(3,nAtoms),
     &       dB(3,nCent,3,nCent), dBqR(3,nAtoms,3,nAtoms), ATemp(3)
      Integer   Ind(nCent), iDCRs(nCent)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('B',' ',B,3,nCent)
      Call RecPrt('dB',' ',dB,3*nCent,3*nCent)
      Write (6,*) iDCRs
#endif
*
*---- Set up the T-matrix
*
*---- Project away nonsymmetric displacements
*
      call dcopy_(3*nCent,[One],0,Tx,1)
      Do i = 1, nCent
         Call NonSym(nStab(Ind(i)),jStab(0,Ind(i)),A(1,i),Tx(1,i))
*
*------- Rotate vector back to the unique center
*
         Call OA(iDCRs(i),Tx(1:3,i),ATemp)
         Tx(:,i)=ATemp(:)
      End Do
*
*---- The T-matrix is now computed. Now create BqR and dBqR.
*
*---- Create BqR
*
      Call FZero(BqR,3*nAtoms)
      Do i = 1, nCent
         Do ixyz = 1, 3
            BqR(ixyz,Ind(i)) = BqR(ixyz,Ind(i))
     &                       + Tx(ixyz,i)*B(ixyz,i)
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('BqR',' ',BqR,1,3*nAtoms)
#endif
*
*---- Create dBqR
*
      Call FZero(dBqR,(3*nAtoms)**2)
      Do i = 1, nCent
         Do ixyz = 1, 3
*
            Do j = 1, nCent
               Do jxyz = 1, 3
*
                  dBqR(ixyz,Ind(i),jxyz,Ind(j)) =
     &               dBqR(ixyz,Ind(i),jxyz,Ind(j))
     &             + Tx(ixyz,i)*dB(ixyz,i,jxyz,j)*Tx(jxyz,j)
*
               End Do
            End Do

         End Do
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('dBqR',' ',dBqR,3*nAtoms,3*nAtoms)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine CD_Tester_Vec( &
#                        define _CALLING_
#                        include "cdvec_interface.fh"
                        )

use CD_Tester_mod, only: Vec
use Definitions, only: wp, iwp, u6

implicit none
#include "cdvec_interface.fh"
integer(kind=iwp) :: kOff, lTot
character(len=*), parameter :: SecNam = 'CD_Tester_Vec'

if (iOpt == 1) then
  kOff = nDim*(iVec1-1)
  lTot = nDim*nVec
  Vec(kOff+1:kOff+lTot) = Buf(1:lTot)
else if (iOpt == 2) then
  kOff = nDim*(iVec1-1)
  lTot = nDim*nVec
  Buf(1:lTot) = Vec(kOff+1:kOff+lTot)
else
  write(u6,*)
  write(u6,*) 'WARNING! WARNING! WARNING! WARNING!'
  write(u6,*) SecNam,': illegal option: iOpt = ',iOpt
  write(u6,*) 'WARNING! WARNING! WARNING! WARNING!'
  write(u6,*)
  call xFlush(u6)
end if

end subroutine CD_Tester_Vec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1995, Jeppe Olsen                                 *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GASDN2_MCLR(I12,RHO1,RHO2,R,L,CB,SB,C2,ICOCOC,ISOCOC,ICSM,ISSM,ICBLTP,ISBLTP,NACOB,NSSOA,NSSOB,NAEL,IAGRP,NBEL,IBGRP, &
                       IOCTPA,IOCTPB,NOCTPA,NOCTPB,NSM,MXPNGAS,NOBPTS,IOBPTS,MAXK,MAXI,LC,LS,CSCR,SSCR,NGAS,NELFSPGPA,NELFSPGPB, &
                       IDC,ISOOSC,NSOOSC,ISOOSE,NSOOSE,ICOOSC,NCOOSC,ICOOSE,NCOOSE,IASOOS,IACOOS,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S, &
                       X,RHO1S,LUL,LUR,PSL,PSR,ieaw,n1,n2)
! Jeppe Olsen, Winter of 1991
! GAS modifications, August 1995
!
! =====
! Input
! =====
!
! I12    : = 1 => calculate one-electron density matrix
!          = 2 => calculate one-and two-electron density matrix
! RHO1   : Initial one-electron density matrix
! RHO2   : Initial two-electron density matrix
!
! ICOCOC : Allowed type combinations for C
! ISOCOC : Allowed type combinations for S(igma)
! ICS    : Symmetry for C
! ISS    : Symmetry for S
! ICBLTP : Block types for C
! ISBLTP : Block types for S
!
! NACOB : Number of active orbitals
! NSSOA : Number of strings per type and symmetry for alpha strings
! NAEL  : Number of active alpha electrons
! NSSOB : Number of strings per type and symmetry for beta strings
! NBEL  : Number of active beta electrons
!
! MAXIJ : Largest allowed number of orbital pairs treated simultaneously
! MAXK  : Largest number of N-2,N-1 strings treated simultaneously
! MAXI  : Max number of N strings treated simultaneously
!
! LC : Length of scratch array for C
! LS : Length of scratch array for S
! RHO1S: Scratch array for one body
! CSCR : Scratch array for C vector
! SSCR : Scratch array for S vector
!
! The L and R vectors are accessed through routines that
! either fetches/disposes symmetry blocks or
! Symmetry-occupation-occupation blocks

use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: I12, NOCTPA, NOCTPB, ICOCOC(NOCTPA,NOCTPB), ISOCOC(NOCTPA,NOCTPB), ICSM, ISSM, ICBLTP(*), &
                                 ISBLTP(*), NACOB, NSM, NSSOA(NSM,NOCTPA), NSSOB(NSM,NOCTPB), NAEL, IAGRP, NBEL, IBGRP, IOCTPA, &
                                 IOCTPB, MXPNGAS, NOBPTS(*), IOBPTS(*), MAXK, MAXI, LC, LS, NELFSPGPA(3,*), NELFSPGPB(3,*), IDC, &
                                 LUL, LUR, ieaw, n1, n2
real(kind=wp), intent(inout) :: RHO1(*), RHO2(*)
real(kind=wp), intent(in) :: R(*), L(*), PSL, PSR
real(kind=wp), intent(out) :: CB(*), SB(*), C2(*), CSCR(*), SSCR(*), XI1S(*), XI2S(*), XI3S(*), XI4S(*), X(*), RHO1S(*)
integer(kind=iwp), intent(inout) :: NGAS
integer(kind=iwp), intent(out) :: ISOOSC(NOCTPA,NOCTPB,NSM), NSOOSC(NOCTPA,NOCTPB,NSM), ISOOSE(NOCTPA,NOCTPB,NSM), &
                                  NSOOSE(NOCTPA,NOCTPB,NSM), ICOOSC(NOCTPA,NOCTPB,NSM), NCOOSC(NOCTPA,NOCTPB,NSM), &
                                  ICOOSE(NOCTPA,NOCTPB,NSM), NCOOSE(NOCTPA,NOCTPB,NSM), IASOOS(NOCTPA,NOCTPB,NSM), &
                                  IACOOS(NOCTPA,NOCTPB,NSM)
integer(kind=iwp), intent(_OUT_) :: I1(*), I2(*), I3(*), I4(*)
integer(kind=iwp) :: IASM, IATP, IBSM, IBTP, IC1SM, IC1TA, IC1TB, ICBLK, ICBSM, ICENSM, ICENTA, ICENTB, ICOFF, ICSTSM, ICSTTA, &
                     ICSTTB, IFINIC, IFRSTC, IFRSTS, IIASM, IIATP, IIBSM, IIBTP, ILPERM, IRPERM, IS1SM, IS1TA, IS1TB, ISBLK, &
                     ISBSM, ISENSM, ISENTA, ISENTB, ISFINI, ISOFF, ISSTSM, ISSTTA, ISSTTB, ISTRFL(1), JASM, JATP, JBSM, JBTP, &
                     JJASM, JJATP, JJBSM, JJBTP, LASM(4), LATP(4), LBSM(4), LBTP(4), LCOL, LROW, LSGN(5), LTRP(5), NCBLK, NCCMBC, &
                     NCCMBE, NIA, NIB, NIIA, NIIB, NJA, NJB, NJJA, NJJB, NLPERM, NONEWC, NONEWS, NRPERM, NSBLK, NSCMBC, NSCMBE, &
                     RASM(4), RATP(4), RBSM(4), RBTP(4), RSGN(5), RTRP(5)
real(kind=wp) :: PLL, PLR, XNORM2
real(kind=wp), external :: dDot_

PLL = Zero
PLR = Zero

! ================================
! 1 : Arrays for accessing L and R
! ================================
! L Compact form
call ZOOS(ISSM,ISBLTP,NSM,ISOCOC,NSSOA,NSSOB,NOCTPA,NOCTPB,IDC,ISOOSC,NSOOSC,NSCMBC,0)
! L Full determinant form
call ZOOS(ISSM,ISBLTP,NSM,ISOCOC,NSSOA,NSSOB,NOCTPA,NOCTPB,1,ISOOSE,NSOOSE,NSCMBE,1)
! R compact form
call ZOOS(ICSM,ICBLTP,NSM,ICOCOC,NSSOA,NSSOB,NOCTPA,NOCTPB,IDC,ICOOSC,NCOOSC,NCCMBC,0)
! R Full determinant form
call ZOOS(ICSM,ICBLTP,NSM,ICOCOC,NSSOA,NSSOB,NOCTPA,NOCTPB,1,ICOOSE,NCOOSE,NCCMBE,1)
! Initialize loop over batches of L blocks
ISENSM = 1
ISENTA = 1
ISENTB = 1
IFRSTS = 1
! Loop over batches over L blocks
outer: do
  ! Next batch of L blocks
  ISSTSM = ISENSM
  ISSTTA = ISENTA
  ISSTTB = ISENTB
  call INCOOS(IDC,ISBLTP,NSOOSE,NOCTPA,NOCTPB,ISSTSM,ISSTTA,ISSTTB,NSM,ISENSM,ISENTA,ISENTB,IASOOS,LS,ISFINI,NSBLK,IFRSTS,ISOCOC)
  if ((NSBLK == 0) .and. (ISFINI /= 0)) exit outer
  IFRSTS = 0
  ! Obtain L blocks
  IS1SM = ISSTSM
  IS1TA = ISSTTA
  IS1TB = ISSTTB
  ISOFF = 1
  do ISBLK=1,NSBLK
    ISBSM = Mul(IS1SM,ISSM)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' ISBLK ISOFF ',ISBLK,ISOFF
#   endif
    if (ISOCOC(IS1TA,IS1TB) == 1) &
      call GSTTBL_MCLR(L,SB(ISOFF),IS1TA,IS1SM,IS1TB,ISBSM,NOCTPA,NOCTPB,NSSOA,NSSOB,PSL,ISOOSC,IDC,PLL,LUL,C2)
    ISOFF = ISOFF+NSOOSE(IS1TA,IS1TB,IS1SM)
    if (ISBLK /= NSBLK) call NXTBLK_MCLR(IS1TA,IS1TB,IS1SM,NOCTPA,NOCTPB,NSM,ISBLTP,IDC,NONEWS,ISOCOC)
  end do
  ! Initialize loop over blocks over L vector
  ICENSM = 1
  ICENTA = 1
  ICENTB = 1
  ! Loop over blocks of R vector
  IFRSTC = 1
  do
#   ifdef _DEBUGPRINT_
    write(u6,*) ' >>> next batch of R blocks'
#   endif
    ICSTSM = ICENSM
    ICSTTA = ICENTA
    ICSTTB = ICENTB

    call INCOOS(IDC,ICBLTP,NCOOSE,NOCTPA,NOCTPB,ICSTSM,ICSTTA,ICSTTB,NSM,ICENSM,ICENTA,ICENTB,IACOOS,LC,IFINIC,NCBLK,IFRSTC,ICOCOC)
    ! If no more R blocks go to next batch of L blocks
    if ((NCBLK == 0) .and. (IFINIC /= 0)) cycle outer
    IFRSTC = 0
    ! Read L blocks into core
    IC1SM = ICSTSM
    IC1TA = ICSTTA
    IC1TB = ICSTTB
    ICOFF = 1
    do ICBLK=1,NCBLK
      ICBSM = Mul(IC1SM,ICSM)
      if (ICOCOC(IC1TA,IC1TB) == 1) &
        call GSTTBL_MCLR(R,CB(ICOFF),IC1TA,IC1SM,IC1TB,ICBSM,NOCTPA,NOCTPB,NSSOA,NSSOB,PSR,ICOOSC,IDC,PLR,LUR,C2)
      ICOFF = ICOFF+NCOOSE(IC1TA,IC1TB,IC1SM)
      if (ICBLK /= NCBLK) call NXTBLK_MCLR(IC1TA,IC1TB,IC1SM,NOCTPA,NOCTPB,NSM,ICBLTP,IDC,NONEWC,ICOCOC)
    end do
    ! Loop over L and R blocks in core and obtain  contribution from
    ! given L and R blocks
    ISOFF = 1
    IASM = ISSTSM
    IATP = ISSTTA
    IBTP = ISSTTB
    do ISBLK=1,NSBLK
      IBSM = Mul(IASM,ISSM)
      NIA = NSSOA(IASM,IATP)
      NIB = NSSOB(IBSM,IBTP)
      ! Possible permutations of L blocks
      call PRMBLK(IDC,ISTRFL,IASM,IBSM,IATP,IBTP,PSL,PLR,LATP,LBTP,LASM,LBSM,LSGN,LTRP,NLPERM)
      do ILPERM=1,NLPERM
        IIASM = LASM(ILPERM)
        IIBSM = LBSM(ILPERM)
        IIATP = LATP(ILPERM)
        IIBTP = LBTP(ILPERM)
        NIIA = NSSOA(IIASM,IIATP)
        NIIB = NSSOB(IIBSM,IIBTP)

        if (LTRP(ILPERM) == 1) then
          LROW = NSSOA(LASM(ILPERM-1),LATP(ILPERM-1))
          LCOL = NSSOB(LBSM(ILPERM-1),LBTP(ILPERM-1))
          call TRPMT3(SB(ISOFF),LROW,LCOL,C2)
          SB(ISOFF:ISOFF+LROW*LCOL-1) = C2(1:LROW*LCOL)
        end if
        if (LSGN(ILPERM) == -1) SB(ISOFF:ISOFF+NIA*NIB-1) = -SB(ISOFF:ISOFF+NIA*NIB-1)

        JASM = ICSTSM
        JATP = ICSTTA
        JBTP = ICSTTB
        ICOFF = 1
        do ICBLK=1,NCBLK
          JBSM = Mul(JASM,ICSM)
          NJA = NSSOA(JASM,JATP)
          NJB = NSSOB(JBSM,JBTP)
          XNORM2 = dDot_(NJA*NJB,CB(ICOFF),1,CB(ICOFF),1)
          if ((NIA*NIB*NJA*NJB /= 0) .and. (ISOCOC(IATP,IBTP) == 1) .and. (ICOCOC(JATP,JBTP) == 1) .and. (XNORM2 /= Zero)) then
            ! Possible permutations of this block
            call PRMBLK(IDC,ISTRFL,JASM,JBSM,JATP,JBTP,PSR,PLR,RATP,RBTP,RASM,RBSM,RSGN,RTRP,NRPERM)
            do IRPERM=1,NRPERM
              if (RTRP(IRPERM) == 1) then
                LROW = NSSOA(RASM(IRPERM-1),RATP(IRPERM-1))
                LCOL = NSSOB(RBSM(IRPERM-1),RBTP(IRPERM-1))
                call TRPMT3(CB(ICOFF),LROW,LCOL,C2)
                CB(ICOFF:ICOFF+LROW*LCOL-1) = C2(1:LROW*LCOL)
              end if
              if (RSGN(IRPERM) == -1) CB(ICOFF:ICOFF+NJA*NJB-1) = -CB(ICOFF:ICOFF+NJA*NJB-1)
              JJASM = RASM(IRPERM)
              JJBSM = RBSM(IRPERM)
              JJATP = RATP(IRPERM)
              JJBTP = RBTP(IRPERM)
              NJJA = NSSOA(JJASM,JJATP)
              NJJB = NSSOB(JJBSM,JJBTP)
              call GSDNBB2_MCLR(I12,RHO1,RHO2,IIASM,IIATP,IIBSM,IIBTP,JJASM,JJATP,JJBSM,JJBTP,NGAS,NELFSPGPA(:,IOCTPA-1+IIATP), &
                                NELFSPGPB(:,IOCTPB-1+IIBTP),NELFSPGPA(:,IOCTPA-1+JJATP),NELFSPGPB(:,IOCTPB-1+JJBTP),NAEL,NBEL, &
                                IAGRP,IBGRP,SB(ISOFF),CB(ICOFF),C2,MXPNGAS,NOBPTS,IOBPTS,MAXI,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,I3, &
                                XI3S,I4,XI4S,X,NSM,NIIA,NIIB,NJJA,NJJB,NACOB,RHO1S,ieaw,n1,n2)
            end do
            ! Transpose or scale R block to restore order ??
            if (RTRP(NRPERM+1) == 1) then
              call TRPMT3(CB(ICOFF),NJB,NJA,C2)
              CB(ICOFF:ICOFF+NJA*NJB-1) = C2(1:NJA*NJB)
            end if
            if (RSGN(NRPERM+1) == -1) CB(ICOFF:ICOFF+NJA*NJB-1) = -CB(ICOFF:ICOFF+NJA*NJB-1)

          end if
          ICOFF = ICOFF+NCOOSE(JATP,JBTP,JASM)
          ! Next C block
          if (ICBLK /= NCBLK) call NXTBLK_MCLR(JATP,JBTP,JASM,NOCTPA,NOCTPB,NSM,ICBLTP,IDC,NONEWC,ICOCOC)
        end do
        ! End of loop over R blocks in Batch
      end do
      ! Transpose or scale L block to restore order ??
      if (LTRP(NLPERM+1) == 1) then
        call TRPMT3(SB(ISOFF),NIB,NIA,C2)
        SB(ISOFF:ISOFF+NIA*NIB-1) = C2(1:NIA*NIB)
      end if
      if (LSGN(NLPERM+1) == -1) SB(ISOFF:ISOFF+NIA*NIB-1) = -SB(ISOFF:ISOFF+NIA*NIB-1)
      ! Next L block
      ISOFF = ISOFF+NSOOSE(IATP,IBTP,IASM)
      if (ISBLK /= NSBLK) call NXTBLK_MCLR(IATP,IBTP,IASM,NOCTPA,NOCTPB,NSM,ISBLTP,IDC,NONEWS,ISOCOC)
    end do
    ! End of loop over L blocks in batch
    ! End of loop over batches of R blocks
    if (IFINIC /= 0) exit
  end do
  if (ISFINI /= 0) exit outer
end do outer
! End of loop over batches of L blocks

end subroutine GASDN2_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
*  Cho_Dec_Qual
*
*> @author F. Aquilante
*>
*> @details
*> The symmetric positive (semi-)definite matrix
*>
*> \f[ Q_{ab,cd} = Q_{ab,cd} - \sum_J L_{ab,J} L_{cd,J} \f]
*>
*> is evaluated and the diagonal elements are returned in \p QDiag.
*> Subsequently, \p Q is Cholesky decomposed to yield \p NumV vectors
*> \f$ K_{ab,I} \f$ as
*>
*> \f[ Q_{ab,cd} = \sum_I K_{ab,I} K_{cd,I} \f]
*>
*> @note
*> \p Q is destroyed and can not be used after this routine.
*>
*> @param[in]     Diag  Array of diagonal integrals stored as in the first reduced set
*> @param[in]     Lab   Array of Cholesky vectors (symmetry blocked) for the qualified shell pairs
*> @param[in,out] Q     Array (symmetry blocked) containing the matrix of the qualified integrals
*> @param[out]    Kab   Array symmetry blocked of Cholesky vectors resulting from the decomposition
*>                      of the qualified integral matrix
*> @param[out]    iD    Index array. On exit \p iD(k,jSym) contains the index of the qualified diagonals
*>                      from which the \p k -th vector of \p jSym was generated
*> @param[out]    NumV  Array of the number of vectors in each symmetry from the decomposition of the
*>                      qualified integral matrix
*> @param[out]    QDiag Array (symmetry blocked) containing the updated qualified diagonals
************************************************************************
      SUBROUTINE Cho_Dec_Qual(Diag,Lab,Q,Kab,iD,NumV,QDiag)
      Implicit Real*8 (a-h,o-z)

      Real*8   Diag(*),Lab(*),Q(*), QDiag(*)
      Real*8   Kab(*)
      Integer  iD(*),NumV(*)
#include "cholesky.fh"

      Real*8  Dmax(8)
      Integer nVecG(8)
      Logical Sync
      Character*12 SecNam
      Parameter (SecNam = 'Cho_Dec_Qual')
      Parameter (xone = -1.0d0, one = 1.0d0)

      irc=0

C --- Determine the max diagonal (qualified excluded)
C     For 1-center decomposition, this is done later.
      If (Cho_1Center) Then
         Call fZero(Dmax,nSym)
      Else
         Sync = .False.
         Call Cho_P_MaxDX(Diag,Sync,Dmax)
      End If

C --- Set the number of previous Cholesky vectors (global)
      Call Cho_P_GetGV(nVecG,nSym)

      ipD = 1
      ipQ = 1
      ipSQL = 1
      ipSQK = 1
      ipQD = 0
      Do jSym=1,nSym

         mQ = Max(nQual(jSym),1)

C ---  Do the subtraction  Q({ab}|{cd}) -= sum_J  L({ab},J) * L({cd},J)
C ---------------------------------------------------------------------
         Call DGEMM_('N','T',nQual(jSym),nQual(jSym),nVecG(jSym),
     &                      xone,Lab(ipSQL),mQ,
     &                           Lab(ipSQL),mQ,
     &                       one,Q(ipQ),mQ)

C --- Extract diagonal of updated Q({ab}|{cd})
C --------------------------------------------
         Do iQ = 1,nQual(jSym)
            QDiag(ipQD+iQ) = Q(ipQ-1+nQual(jSym)*(iQ-1)+iQ)
         End Do

C --- For 1-Center decomposition, find max. diagonal among qualified
C ------------------------------------------------------------------
         If (Cho_1Center) Then
            Do iQ = 1,nQual(jSym)
               Dmax(jSym) = max(Dmax(jSym),QDiag(ipQD+iQ))
            End Do
         End If

C --- Cholesky decompose Q({ab}|{cd})
C     Note: Q is destroyed in CD_InCore_p
C ---------------------------------------
         Thr = max(ThrCom,Dmax(jSym)*Span)
         Call CD_InCore_p(Q(ipQ),nQual(jSym),Kab(ipSQK),
     &                    nQual(jSym),iD(ipD),NumV(jSym),Thr,irc)

         If (irc.ne.0) Then
            write(6,*) SecNam,' non-zero rc on exit from CD_InCore_p: ',
     &                 irc
            Call Cho_Quit('Decomposition error in '//SecNam,104)
         EndIf

         ipSQL = ipSQL + nQual(jSym)*nVecG(jSym)
         ipSQK = ipSQK + nQual(jSym)**2
         ipQ = ipQ + nQual(jSym)**2
         ipD = ipD + nQual(jSym)
         ipQD = ipQD + nQual(jSym)

      End Do

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_AllocateBlockMatrix(Label,ip_Blocks)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Allocate atom pair blocks of a quadratic matrix (e.g.
C              density matrix, Fock matrix). On exit, ip_Blocks points
C              to pointers in iWork such that
C
C              ip=iWork(ip_Blocks-1+iAtomPair)
C
C              is the pointer (in array Work) to the matrix block for
C              atom pair iAtomPair.
C
C              Deallocation is done by calling subroutine
C              LDF_DeallocateBlockMatrix(Label,ip_Blocks).
C
C              Label is used to label the allocation in GetMem.
C              (For example, Label could be 'Den' or 'Fck', but
C              any three-character string is accepted).
C
      Implicit None
      Character*3 Label
      Integer ip_Blocks
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Integer l
      Integer ip0
      Integer iAtomPair
      Integer iAtom, jAtom
      Integer ip

      Character*8 myLabel

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Allocate pointer array
      Write(myLabel,'(A3,A5)') Label,'Blk_P'
      l=NumberOfAtomPairs
      Call GetMem(myLabel,'Allo','Inte',ip_Blocks,l)
      ip0=ip_Blocks-1

      ! Set pointers relative to 0 (i.e. offsets)
      l=0
      Do iAtomPair=1,NumberOfAtomPairs
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         iWork(ip0+iAtomPair)=l
         l=l+LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
      End Do

      ! Allocate matrix blocks
      Write(myLabel,'(A3,A5)') Label,'Block'
      Call GetMem(myLabel,'Allo','Real',ip,l)

      ! Shift pointers so that they become relative to allocated memory
      Do iAtomPair=1,NumberOfAtomPairs
         iWork(ip0+iAtomPair)=iWork(ip0+iAtomPair)+ip
      End Do

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_DeallocateBlockMatrix(Label,ip_Blocks)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: Deallocate block matrix (see LDF_AllocateBlockMatrix).
C
      Implicit None
      Character*3 Label
      Integer ip_Blocks
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Integer l
      Integer iAtomPair
      Integer iAtom, jAtom
      Integer ip

      Character*8 myLabel

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Get total length of block matrix
      l=0
      Do iAtomPair=1,NumberOfAtomPairs
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         l=l+LDF_nBas_Atom(iAtom)*LDF_nBas_Atom(jAtom)
      End Do

      ! Deallocate matrix blocks
      Write(myLabel,'(A3,A5)') Label,'Block'
      ip=iWork(ip_Blocks)
      Call GetMem(myLabel,'Free','Real',ip,l)

      ! Deallocate pointer array
      Write(myLabel,'(A3,A5)') Label,'Blk_P'
      l=NumberOfAtomPairs
      Call GetMem(myLabel,'Free','Inte',ip_Blocks,l)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

subroutine RHSOD_H_NOSYM(IVEC)

use SUPERINDEX, only: MAGEB, MAGTB, MIGEJ, MIGTJ
use CHOVEC_IO, only: ChoVec_Read, ChoVec_Size, NVTOT_CHOSYM
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB
#else
use fake_GA, only: GA_Arrays
#endif
use caspt2_global, only: iPrGlb
use caspt2_module, only: NAGEB, NAGTB, NIGEJ, NIGTJ, NSSHT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: IA, IAEND, IAGEB, IAGTB, IASTA, IC, iCASE, IDX, IIEND, IISTA, IJ, IJGEL, IJGTL, IL, IOSYM(8,8), lg_W, LIJOFF, &
                     LILOFF, MW, NAS, NBLOCK, NCHOBUF, NIS, NV, NW
real(kind=wp) :: AJCL, ALCJ, HMACJL, HPACJL, SCL
real(kind=wp), allocatable :: AIBJ(:,:), CHOBUF(:)
integer(kind=iwp), parameter :: NOSYM = 1
real(kind=wp), parameter :: SQRT3 = sqrt(Three), SQRTH = sqrt(Half)

if (iPrGlb >= DEBUG) write(u6,*) 'RHS on demand: case H'

!***********************************************************************
! Case H:
!   WP(jl,ac)=((ajcl)+(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
!   WM(jl,ac)=((ajcl)-(alcj))*SQRT(Three)
!***********************************************************************

NV = NVTOT_CHOSYM(NOSYM)
call mma_ALLOCATE(AIBJ,NSSHT,NSSHT,Label='AIBJ')
NBLOCK = NV*NSSHT

!***********************************************************************
!SVC: read in all the cholesky vectors (need all symmetries)
!***********************************************************************
call CHOVEC_SIZE(4,NCHOBUF,IOSYM)

call mma_allocate(CHOBUF,NCHOBUF,Label='CHOBUF')

call CHOVEC_READ(4,CHOBUF,NCHOBUF)

iCASE = 12

NAS = NAGEB(NOSYM)
NIS = NIGEJ(NOSYM)
NW = NAS*NIS

if (NW /= 0) then

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  do IJGEL=IISTA,IIEND
    IJ = MIGEJ(1,IJGEL)
    IL = MIGEJ(2,IJGEL)
    LIJOFF = 1+NBLOCK*(IJ-1)
    LILOFF = 1+NBLOCK*(IL-1)
    ! precompute integral blocks
    call DGEMM_('T','N',NSSHT,NSSHT,NV,One,CHOBUF(LIJOFF),NV,CHOBUF(LILOFF),NV,Zero,AIBJ,NSSHT)
    do IAGEB=IASTA,IAEND ! these are always all elements
      IA = MAGEB(1,IAGEB)
      IC = MAGEB(2,IAGEB)
      AJCL = AIBJ(IA,IC)
      ALCJ = AIBJ(IC,IA)
      ! HP(ac,jl)=((ajcl)+(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
      SCL = One
      if (IA == IC) SCL = SCL*SQRTH
      if (IL == IJ) SCL = SCL*SQRTH
      HPACJL = SCL*(AJCL+ALCJ)
      ! write element HP(ac,jl)
      IDX = IAGEB+NAS*(IJGEL-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = HPACJL
#     else
      GA_Arrays(lg_w)%A(IDX) = HPACJL
#     endif
    end do
  end do
  !*********************************************************************
  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,NOSYM,iVEC)
  call RHS_FREE(lg_W)
  !*********************************************************************
end if

iCASE = 13

NAS = NAGTB(NOSYM)
NIS = NIGTJ(NOSYM)
NW = NAS*NIS

if (NW /= 0) then

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  do IJGTL=IISTA,IIEND
    IJ = MIGTJ(1,IJGTL)
    IL = MIGTJ(2,IJGTL)
    LIJOFF = 1+NBLOCK*(IJ-1)
    LILOFF = 1+NBLOCK*(IL-1)
    ! precompute integral blocks
    call DGEMM_('T','N',NSSHT,NSSHT,NV,One,CHOBUF(LIJOFF),NV,CHOBUF(LILOFF),NV,Zero,AIBJ,NSSHT)
    do IAGTB=IASTA,IAEND ! these are always all elements
      IA = MAGTB(1,IAGTB)
      IC = MAGTB(2,IAGTB)
      AJCL = AIBJ(IA,IC)
      ALCJ = AIBJ(IC,IA)
      ! HM(ac,jl)=((ajcl)-(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
      SCL = SQRT3
      HMACJL = SCL*(AJCL-ALCJ)
      ! write element HM(ac,jl)
      IDX = IAGTB+NAS*(IJGTL-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = HMACJL
#     else
      GA_Arrays(lg_W)%A(IDX) = HMACJL
#     endif
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,NOSYM,iVEC)
  call RHS_FREE(lg_W)
end if
!***********************************************************************

call mma_deallocate(CHOBUF)

call mma_DEALLOCATE(AIBJ)

end subroutine RHSOD_H_NOSYM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_INIT1()
!
! Purpose: initialize counter arrays.

use Cholesky, only: Cho_Real_Par, InfRed, InfVec, myNumCho, nSym, NumCho, NumChT, RstCho, XnPass

implicit none

if (RSTCHO) then

  ! Read restart information.
  ! -------------------------

  call CHO_GETRSTC()
  NUMCHT = sum(NUMCHO(1:NSYM))

else

  ! Initialize vector info and counters.
  ! ------------------------------------

  INFVEC(:,:,:) = 0
  NUMCHO(1:NSYM) = 0
  NUMCHT = 0

  ! Initialize reduced set info.
  ! ----------------------------

  INFRED(:) = 0

  ! Initialize global integral pass counter.
  ! ----------------------------------------

  XNPASS = 0

end if

! Parallel init.
! --------------

if (Cho_Real_Par) MYNUMCHO(1:NSYM) = 0

end subroutine CHO_INIT1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine Cho_X_Dealloc(irc)

      use ChoArr, only: iSOShl, iBasSh, nBasSh, nBstSh, iSP2F, iAtomShl,
     &                  iShlSO, iRS2F, IntMap, iScr, nDimRS, iL2G,
     &                  iShP2RS, iShP2Q, iQL2G, LQ_Tot, iSimRI

      use ChoSwp, only: iQuAB, iQuAB_L, iQuAB_Hidden, iQuAB_L_Hidden,
     &                  nnBstRSh_Hidden, nnBstRSh,
     &                  nnBstRSh_L_Hidden, nnBstRSh_G,
     &                  iiBstRSh_Hidden, iiBstRSh,
     &                  iiBstRSh_L_Hidden, iiBstRSh_G,
     &                    IndRSh_Hidden,   IndRSh,
     &                    IndRSh_G_Hidden,   IndRSh_G,
     &                    InfRed_Hidden,   InfRed,
     &                    InfRed_G_Hidden,   InfRed_G,
     &                    InfVec_Hidden,   InfVec,
     &                    InfVec_G_Hidden,   InfVec_G,
     &                    IndRed_Hidden,   IndRed,
     &                    IndRed_G_Hidden,   IndRed_G,
     &                    InfVec_Bak
C
C     T.B. Pedersen, July 2004.
C
C     Purpose: deallocate ALL index arrays for the Cholesky utility.
C              On exit, irc=0 signals sucessful completion.
C
      Implicit None
      Integer irc
#include "chpari.fh"
#include "stdalloc.fh"

      Character*13 SecNam
      Parameter (SecNam = 'Cho_X_Dealloc')

      irc=0

C     Deallocate.
C     -----------

      If (Allocated(InfRed_Hidden))
     &    Call mma_deallocate(InfRed_Hidden)
      If (Associated(InfRed)) InfRed=>Null()

      If (Allocated(InfVec_Hidden))
     &    Call mma_deallocate(InfVec_Hidden)
      If (Associated(InfVec)) InfVec=>Null()

      If (Allocated(IndRed_Hidden))
     &    Call mma_deallocate(IndRed_Hidden)
      If (Associated(IndRed)) IndRed=>Null()

      If (Allocated(IndRSh_Hidden))
     &    Call mma_deallocate(IndRSh_Hidden)
      If (Associated(IndRSh)) IndRSh=>Null()

      If (Allocated(iScr)) Call mma_deallocate(iScr)

      If (Allocated(iiBstRSh_Hidden))
     &    Call mma_deallocate(iiBstRSh_Hidden)
      If (Associated(iiBstRSh)) iiBstRSh=>Null()

      If (Allocated(nnBstRSh_Hidden))
     &    Call mma_deallocate(nnBstRSh_Hidden)
      If (Associated(nnBstRSh)) nnBstRSh=>Null()

      If (Allocated(IntMap)) Call mma_deallocate(IntMap)

      If (Allocated(nDimRS)) Call mma_deallocate(nDimRS)

      If (Allocated(iRS2F)) Call mma_deallocate(iRS2F)

      If (Allocated(iSOShl)) Call mma_deallocate(iSOShl)

      If (Allocated(iShlSO)) Call mma_deallocate(iShlSO)

      If (Allocated(iQuAB_Hidden)) Call mma_deallocate(iQuAB_Hidden)
      If (Associated(iQuAB)) iQuAB => Null()

      If (Allocated(iBasSh)) Call mma_deallocate(iBasSh)

      If (Allocated(nBasSh)) Call mma_deallocate(nBasSh)

      If (Allocated(nBstSh)) Call mma_deallocate(nBstSh)

      If (Allocated(iAtomShl)) Call mma_deallocate(iAtomShl)

      If (Allocated(iSP2F)) Call mma_deallocate(iSP2F)

      If (Allocated(iShP2RS)) Call mma_deallocate(iShP2RS)

      If (Allocated(iShP2Q )) Call mma_deallocate(iShP2Q )

      If (Allocated(iQuAB_L_Hidden)) Call mma_deallocate(iQuAB_L_Hidden)
      If (Associated(iQuAB_L)) iQuAB_L => Null()

      If (Allocated(iQL2G )) Call mma_deallocate(iQL2G )

      If (Allocated(LQ_Tot)) Call mma_deallocate(LQ_Tot)

      If (Allocated(InfVec_Bak)) Call mma_deallocate(InfVec_Bak)

      If (Allocated(iSimRI)) Call mma_deallocate(iSimRI)

      If (Allocated(InfVec_G_Hidden))
     &    Call mma_deallocate(InfVec_G_Hidden)
      If (Associated(InfVec_G)) InfVec_G=>Null()

      If (Allocated(IndRed_G_Hidden))
     &    Call mma_deallocate(IndRed_G_Hidden)
      If (Associated(IndRed_G)) IndRed_G=>Null()

      If (Allocated(InfRed_G_Hidden))
     &    Call mma_deallocate(InfRed_G_Hidden)
      If (Associated(InfRed_G)) InfRed_G=>Null()

      If (Allocated(IndRSh_G_Hidden))
     &    Call mma_deallocate(IndRSh_G_Hidden)
      If (Associated(IndRSh_G)) IndRSh_G=>Null()

      If (Allocated(iiBstRSh_L_Hidden))
     &    Call mma_deallocate(iiBstRSh_L_Hidden)
      If (Associated(iiBstRSh_G)) iiBstRSh_G=>Null()

      If (Allocated(nnBstRSh_L_Hidden))
     &    Call mma_deallocate(nnBstRSh_L_Hidden)
      If (Associated(nnBstRSh_G)) nnBstRSh_G=>Null()

      If (Allocated(iL2G)) Call mma_deallocate(iL2G)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MP2gDens_setup()

use MBPT2_Global, only: Density, DiaA, mAdDel, mAdFro, mAdOcc, mAdVir, Mp2Lagr, WDensity
use Data_Structures, only: Allocate_DT
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iSym, nExtT, nOccT
#include "corbinf.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
call Allocate_DT(Density,nOrb+nDel,nOrb+nDel,nSym,label='MP2Density')
call Allocate_DT(WDensity,nOrb+nDel,nOrb+nDel,nSym,label='MP2WDensity')
call Allocate_DT(Mp2Lagr,nFro+nOcc,nExt+nDel,nSym,label='MP2Lagr')
call Allocate_DT(DiaA,nFro+nOcc,nExt+nDel,nSym,Label='MP2DiaA')

Density%A0(:) = Zero
WDensity%A0(:) = Zero
Mp2Lagr%A0(:) = Zero
DiaA%A0(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
mAdOcc(1) = 1
nOccT = nOcc(1)
do iSym=2,nSym
  mAdOcc(iSym) = mAdOcc(iSym-1)+nOcc(iSym-1)
  nOccT = nOccT+nOcc(iSym)
end do

mAdVir(1) = 1
nExtT = nExt(1)
do iSym=2,nSym
  mAdVir(iSym) = mAdVir(iSym-1)+nExt(iSym-1)
  nExtT = nExtT+nExt(iSym)
end do

mAdFro(1) = nOccT+1
do iSym=2,nSym
  mAdFro(iSym) = mAdFro(iSym-1)+nFro(iSym-1)
end do

mAdDel(1) = nExtT+1
do iSym=2,nSym
  mAdDel(iSym) = mAdDel(iSym-1)+nDel(iSym-1)
end do

return

end subroutine MP2gDens_setup

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function nSize_Rv(kS,lS,nShBf,nShell,nIrrep,iOff,
     &                          nVec)
************************************************************************
*                                                                      *
*     Compute the size of Rv(nu,mu,K) and the offsets to the           *
*     different symmetry blocks.                                       *
*                                                                      *
************************************************************************
      Integer nShBf(0:nIrrep-1,nShell), iOff(0:nIrrep-1),
     &        nVec(0:nIrrep-1)
*
      nSize_Rv=0
*
      If (nIrrep.eq.1) Then
*                                                                      *
************************************************************************
*                                                                      *
         iOff(0)=0
         If (kS.ne.lS) Then
            nK = nShBf(0,kS)
            nL = nShBf(0,lS)
            nKL = nK*nL
         Else
            nK = nShBf(0,kS)
            nKL = nK*(nK+1)/2
         End If
*
         nJ = nVec(0)
         nSize_Rv = nJ*nkl
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
         Call IZero(iOff,nIrrep)
         Do klIrrep = 0, nIrrep-1
            iOff(klIrrep) = nSize_Rv
*
            nKL = 0
            If (kS.ne.lS) Then
               Do kIrrep = 0, nIrrep-1
                  nK = nShBf(kIrrep,kS)
                  lIrrep = iEor(klIrrep,kIrrep)
                  nL = nShBf(lIrrep,lS)
                  nKL = nKL + nK*nL
               End Do
            Else
               Do kIrrep = 0, nIrrep-1
                  nK = nShBf(kIrrep,kS)
                  lIrrep = iEor(klIrrep,kIrrep)
                  nL = nShBf(lIrrep,lS)
*
                  If (kIrrep.gt.lIrrep) Then
                     nKL = nKL + nK*nL
                  Else If (kIrrep.eq.lIrrep) Then
                     nKL = nKL + nK*(nK+1)/2
                  Else
                     nKL = nKL + 0
                  End If
*
               End Do
            End If
*
            nJ = nVec(klIrrep)
            nSize_Rv = nSize_Rv + nJ*nKL
*
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine contandmult(Lhigh,AIMP,oneonly,numballcart,LUPROP,ifinite,onecart,onecontr,oneoverR3,iCenter)

use AMFI_global, only: charge, contrarray, icore, ikeeplist, ikeeporb, incrLM, ipowxyz, iredLM, iredoffunctnew, itotalperIR, &
                       Lmax, Loffunction, Moffunction, MxcontL, MxprimL, ncontrac, ncontrac_keep, nprimit, nrtofiperIR, numbofsym, &
                       shiftIRED, shiftIRIR
use index_functions, only: iTri
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lhigh, numballcart, LUPROP, ifinite, iCenter
logical(kind=iwp), intent(in) :: AIMP, oneonly
real(kind=wp), intent(inout) :: onecart(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax,3)
real(kind=wp), intent(out) :: onecontr(MxcontL,MxcontL,-Lmax:Lmax,3,Lmax)
real(kind=wp), intent(in) :: oneoverR3(MxprimL*(MxprimL+1)/2,Lmax)
integer(kind=iwp) :: I, icartfirst, icartsec, ind1, ind2, ipntnew, ipntold, ipowx, ipowy, ipowz, ired1, ired2, iredfirst, &
                     iredired, iredsec, irun, irun1, irun2, L, length3, Lrun, Mfirst, mrun, Msec, norb1, norb2, norbsh1, norbsh2
character(len=8) :: xa(4), ya(4), za(4)
real(kind=wp), allocatable :: Dummy(:), OCA(:,:), OCA2(:,:), OCA3(:,:)

!bs get back the real number of functions for the finite nucleus
if (ifinite == 2) ncontrac(0) = ncontrac_keep
!#######################################################################
!bs subroutine to contract radial one-electron integrals
!bs and multiply them with angular factors
!#######################################################################
xa(:) = ['********','        ','ANTISYMM','X1SPNORB']
ya(:) = ['********','        ','ANTISYMM','Y1SPNORB']
za(:) = ['********','        ','ANTISYMM','Z1SPNORB']

!bs clean the arrays for cartesian integrals

length3 = numbalLcart*(numbalLcart+1)/2
call mma_allocate(OCA,Length3,3,Label='OCA')
call mma_allocate(OCA2,Length3,3,Label='OCA2')
call mma_allocate(Dummy,MxContL**2,Label='Dummy')
Dummy(:) = Zero
OCA(:,:) = Zero
OCA2(:,:) = Zero

!bs one-electron-integrals:
!bs 1. index: number of first contracted function
!bs 2. index: number of second contracted function
!bs 3. index: pointer(m1,m2)    m1< m2 otherwise change sign of integral
!bs 4. index: L-value
!bs onecart(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax,1),
!bs onecart(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax,2),
!bs onecart(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax,3)

!bs generate one-electron integrals for all L greater/equal 1
if (ifinite == 2) charge = Zero ! nuclear integrals are modelled for finite nucleus somewhere else
do L=1,Lhigh
  call contone(L,oneoverr3(:,L),onecontr(:,:,-Lmax,1,L),Lmax,contrarray(:,3,L),nprimit(L),ncontrac(L),MxcontL,Dummy, &
               onecart(:,:,:,L,1),onecart(:,:,:,L,2),onecart(:,:,:,L,3),charge,oneonly)
end do

!bs ********************************************************************
!bs now move all integrals to one big arrays for X,Y,Z
!bs ********************************************************************
do Lrun=1,Lhigh  !loop over L-values (integrals are diagonal in L)
  mrun = 0
  do Msec=-Lrun,Lrun    ! cartesian M-values  (Mfirst,Msec) with
    do Mfirst=-Lrun,Msec  ! Mfirst <= Msec (actually '=' does never appear as there is no L-component  in Ag

      !bs determine  if L_X L_Y or L_Z
      ipowx = ipowxyz(1,mfirst,Lrun)+ipowxyz(1,msec,Lrun)
      ipowy = ipowxyz(2,mfirst,Lrun)+ipowxyz(2,msec,Lrun)
      ipowz = ipowxyz(3,mfirst,Lrun)+ipowxyz(3,msec,Lrun)

      mrun = mrun+1
      !bs now determine the irreducible representations
      iredfirst = iredLM(Mfirst,Lrun)
      iredsec = iredLM(Msec,Lrun)
      !bs check out which IR is the lower one.
      if (iredfirst <= iredsec) then

        !bs calculate shift to get to the beginning of the block
        iredired = shiftIRIR((iredsec*iredsec-iredsec)/2+iredfirst)+incrlm(Mfirst,Lrun)*itotalperIR(iredsec)+incrLM(Msec,Lrun)
        if ((mod(ipowx,2) == 0) .and. (mod(ipowy,2) == 1) .and. (mod(ipowz,2) == 1)) then
          do icartfirst=1,ncontrac(Lrun) ! loop first index
            do icartsec=1,ncontrac(Lrun) ! loop second index
              oca(iredired+icartsec,1) = oca(iredired+icartsec,1)+onecart(icartfirst,icartsec,mrun,Lrun,1)
            end do
            !bs  shift pointer by number of functions in IR
            iredired = iredired+itotalperIR(iredsec)
          end do
        end if
        if ((mod(ipowx,2) == 1) .and. (mod(ipowy,2) == 0) .and. (mod(ipowz,2) == 1)) then
          do icartfirst=1,ncontrac(Lrun) ! loop first index
            do icartsec=1,ncontrac(Lrun) ! loop second index
              oca(iredired+icartsec,2) = oca(iredired+icartsec,2)+onecart(icartfirst,icartsec,mrun,Lrun,2)
            end do
            !bs shift pointer by number of functions in IR
            iredired = iredired+itotalperIR(iredsec)
          end do
        end if
        if ((mod(ipowx,2) == 1) .and. (mod(ipowy,2) == 1) .and. (mod(ipowz,2) == 0)) then
          do icartfirst=1,ncontrac(Lrun) ! loop first index
            do icartsec=1,ncontrac(Lrun) ! loop second index
              oca(iredired+icartsec,3) = oca(iredired+icartsec,3)+onecart(icartfirst,icartsec,mrun,Lrun,3)
            end do
            !bs shift pointer by number of functions in IR
            iredired = iredired+itotalperIR(iredsec)
          end do
        end if
      else if (iredfirst > iredsec) then
        !bs In this case, indices are exchanged with respect to former
        !bs symmetry of blocks. Therefore, there will be a minus sign

        !bs calculate shift to get to the beginning of the block
        iredired = shiftIRIR((iredfirst*iredfirst-iredfirst)/2+iredsec)+incrLM(Msec,Lrun)*itotalperIR(iredfirst)+incrLM(Mfirst,Lrun)
        if ((mod(ipowx,2) == 0) .and. (mod(ipowy,2) == 1) .and. (mod(ipowz,2) == 1)) then
          do icartsec=1,ncontrac(Lrun)     !loop second index
            do icartfirst=1,ncontrac(Lrun) !loop first index
              oca(iredired+icartfirst,1) = oca(iredired+icartfirst,1)-onecart(icartsec,icartfirst,mrun,Lrun,1)
            end do
            !bs shift pointer by number of functions in IR
            iredired = iredired+itotalperIR(iredfirst)
          end do
        end if
        if ((mod(ipowx,2) == 1) .and. (mod(ipowy,2) == 0) .and. (mod(ipowz,2) == 1)) then
          do icartsec=1,ncontrac(Lrun)     !loop second index
            do icartfirst=1,ncontrac(Lrun) !loop first index
              oca(iredired+icartfirst,2) = oca(iredired+icartfirst,2)-onecart(icartsec,icartfirst,mrun,Lrun,2)
            end do
            !bs shift pointer by number of functions in IR
            iredired = iredired+itotalperIR(iredfirst)
          end do
        end if
        if ((mod(ipowx,2) == 1) .and. (mod(ipowy,2) == 1) .and. (mod(ipowz,2) == 0)) then
          do icartsec=1,ncontrac(Lrun)     !loop  second index
            do icartfirst=1,ncontrac(Lrun) !loop first index
              oca(iredired+icartfirst,3) = oca(iredired+icartfirst,3)-onecart(icartsec,icartfirst,mrun,Lrun,3)
            end do
            !bs shift pointer by number of functions in IR
            iredired = iredired+itotalperIR(iredfirst)
          end do
        end if
      end if
    end do
  end do
end do

!bs copy integrals on arrays with no symmetry blocking at all
!bs which means huge triangular matrices
irun = 0
do norb2=1,numballcart
  ired2 = iredoffunctnew(norb2)
  norbsh2 = norb2-shiftIRED(ired2)
  do norb1=1,norb2
    ired1 = iredoffunctnew(norb1)
    norbsh1 = noRb1-shiftIRED(ired1)
    irun = irun+1
    iredired = shiftIRIR((ired2*ired2-ired2)/2+ired1)
    if (ired1 /= ired2) then
      oca2(irun,:) = oca(iredired+norbsh2+(norbsH1-1)*itotalperIR(IREd2),:)
    else
      oca2(irun,:) = oca(iredired+norbsh2*(norbsH2-1)/2+norbsh1,:)
    end if
  end do
end do
if (.not. AIMP) then
  ! write a hermit-like file   b.s. 4.10.96
  !BS write(u6,*) 'number of orbitals ',numbalLcart
  !BS write(u6,*) 'length of triangular matrix ', length3
  !BS This was removed and will be done in SEWARD
  !BS open(LUPROP,status='UNKNOWN',form='UNFORMATTED',file='AOPROPER_MF')
  !BS rewind(LUPROP)
  write(LUPROP) iCenter
  write(LUPROP) xa,numbofsym,(nrtofiperIR(I),i=1,numbofsym),numballcart,(Loffunction(I),I=1,numballcart), &
                (Moffunction(I),I=1,numballcart),Lhigh,(ncontrac(I),I=0,Lhigh)
  write(LUPROP) (oca2(irun,1),irun=1,length3)
  write(LUPROP) Ya
  write(LUPROP) (oca2(irun,2),irun=1,length3)
  write(LUPROP) Za
  write(LUPROP) (oca2(irun,3),irun=1,length3)
  !BS close(LUPROP)
else
  !bs reorder for AIMP
  !bs write(u6,*) 'reorder integrals for AIMP'
  length3 = ikeeporb*(ikeeporb+1)/2
  call mma_allocate(OCA3,length3,3,Label='OCA3')
  OCA3(:,:) = Zero
  !bs write(u6,*) 'number of orbitals ',ikeeporb
  !bs write(u6,*) 'length of triangular matrix ', length3
  do irun2=1,ikeeporb
    do irun1=1,irun2
      ind2 = ikeeplist(irun2)
      ind1 = ikeeplist(irun1)
      ipntold = iTri(ind1,ind2)
      ipntnew = iTri(irun1,irun2)

      oca3(ipntnew,:) = oca2(ipntold,:)
    end do
  end do
  !BS write(u6,*) 'transfered to new blocks'
  !BS LUPROP = 19
  !BS open(LUPROP,status='UNKNOWN',form='UNFORMATTED',file='AOPROPER_MF')
  !BS rewind(LUPROP)

  write(LUPROP) iCenter
  write(LUPROP) xa,numbofsym,(nrtofiperIR(I),i=1,numbofsym),ikeeporb,(Loffunction(ikeeplist(i)),i=1,ikeeporb), &
                (Moffunction(ikeeplist(i)),I=1,ikeeporb),Lhigh,((ncontrac(I)-icore(I)),I=0,Lhigh)
  write(LUPROP) (oca3(irun,1),irun=1,length3)
  write(LUPROP) ya
  write(LUPROP) (oca3(irun,2),irun=1,length3)
  write(LUPROP) za
  write(LUPROP) (oca3(irun,3),irun=1,length3)

  call mma_deallocate(OCA3)
  !BS close(LUPROP)
end if

!bs that is it!!

call mma_deallocate(OCA2)
call mma_deallocate(OCA)
call mma_deallocate(Dummy)

return

end subroutine contandmult

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ALLOC_LUCIA()
! Dimensions and
! Allocation of static memory
!
! =====
! Input
! =====
!
! KFREE : Pointer to first element of free space
! Information in /LUCINP/,/ORBINP/,/CSYM/
!
! ======
! Output
! ======
! KFREE : First array of free space after allocation of static memory
! /GLBBAS/,/CDIM/
!
! =======
! Version
! =======
!
! Modified Jan 1997
!           Fall 97 (PGINT1 added)
!           Spring 99

use lucia_data, only: INT1, INT1O, KINH1, KINH1_NOCCSYM, LSM1, LSM2, NBINT1, NBINT2, NSMOB, NTOOB, PGINT1, PGINT1A, PINT1, PINT2, &
                      RHO1, SRHO1
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ISM

! 1 : One electron integrals (Complete matrix allocated)
call mma_allocate(INT1,NTOOB**2,Label='INT1')
! A copy of the original UNMODIFIED 1-elecs ints
call mma_allocate(INT1O,NTOOB**2,Label='Int1O')
! Zero to avoid problems with elements that will not
! be initialized
INT1(:) = Zero
INT1O(:) = Zero
! 2 : Two electron integrals
! Pointers to symmetry block of integrals
call mma_allocate(PINT1,NBINT1,Label='PINT1')
call mma_allocate(PINT2,NBINT2,Label='PINT2')
! Pointers to nonsymmetric one-electron integrals
do ISM=1,NSMOB
  ! triangular packed
  call mma_allocate(PGINT1(ISM)%A,NSMOB,Label='PGINT1(ISM)%I')
  ! no packing
  call mma_allocate(PGINT1A(ISM)%A,NSMOB,Label='PGINT1A(ISM)%I')
end do
! Symmetry of last index as a function of initial index
call mma_allocate(LSM1,NBINT1,Label='LSM1')
call mma_allocate(LSM2,NBINT2,Label='LSM2')
! 3 One-body density
call mma_allocate(RHO1,NTOOB**2,Label='RHO1')
! 3.1 : One-body spin density
call mma_allocate(SRHO1,NTOOB**2,Label='SRHO1')
! indices for pair of orbitals symmetry ordered
! Lower half packed
call mma_allocate(KINH1,NTOOB*NTOOB,Label='KINTH1')
! Complete form
call mma_allocate(KINH1_NOCCSYM,NTOOB*NTOOB,Label='KINTH1_NOCCSYM')

end subroutine ALLOC_LUCIA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_TrcIdl_Report()
C
C     Thomas Bondo Pedersen, May 2010.
C
C     Report idle status for all processors
C
      Implicit None
#include "cholesky.fh"
#include "choptr2.fh"
#include "cho_para_info.fh"
#include "WrkSpc.fh"

      Integer i
      Integer nIdle
      Integer ip, l

#if defined (_DEBUGPRINT_)
      If (l_Idle.lt.1 .or. .not.Trace_Idle) Then
         Write(LuPri,'(A)')
     &   'Cho_TrcIdl_Report should not be called in this run!'
         Write(LuPri,*) 'Trace_Idle=',Trace_Idle
         Write(LuPri,'(A,2I10)')
     &   'ip_Idle,l_Idle=',ip_Idle,l_Idle
         Call Cho_Quit('Illegal call to Cho_TrcIdl_Report',103)
      End If
#endif

      If (Cho_Real_Par) Then
#if defined (_DEBUGPRINT_)
         If (l_Idle.lt.nProcs) Then
            Write(LuPri,'(A)')
     &      'Error detected in Cho_TrcIdl_Report: l_Idle < nProcs'
            Write(LuPri,*) 'Trace_Idle=',Trace_Idle
            Write(LuPri,'(A,2I10)')
     &      'ip_Idle,l_Idle=',ip_Idle,l_Idle
            Call Cho_Quit(
     &               'Cho_TrcIdle_Report: l_Idle not properly set!',103)
         End If
#endif
         l=nProcs
         Call GetMem('TIloc','Allo','Inte',ip,l)
         Call iCopy(nProcs,iWork(ip_Idle),1,iWork(ip),1)
         Call Cho_GAIGOp(iWork(ip),nProcs,'+')
         nIdle=0
         Do i=0,nProcs-1
            nIdle=nIdle+min(iWork(ip+i),1)
         End Do
         If (nIdle.eq.0) Then
            Write(LuPri,'(A)')
     &      'No idle procs to report'
         Else
            Write(LuPri,'(I4,A,I4,A,F7.2,A)')
     &      nIdle,' of',nProcs,' procs have been idle (',
     &      1.0d2*dble(nIdle)/dble(nProcs),' %)'
            Write(LuPri,'(A)')
     &      'List of idle procs:'
            Do i=0,nProcs-1
               If (iWork(ip+i).gt.0) Then
                  Write(LuPri,'(I4,A,I8,A)')
     &            i,' (Idle counter:',iWork(ip+i),')'
               End If
            End Do
         End If
         Call GetMem('TIloc','Free','Inte',ip,l)
      Else
         If (iWork(ip_Idle).eq.0) Then
            Write(LuPri,'(A)')
     &      'No idle procs to report!'
         Else
            Write(LuPri,'(A,I8,A)')
     &      'Proc 0 has been idle',iWork(ip_Idle),' times'
         End If
      End If
      Call Cho_Flush(LuPri)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

subroutine Seward_Banner()

use Definitions, only: u6

implicit none

! figlet -f larry3d.flf Seward
write(u6,100) " ____                                           __"
write(u6,100) "/\  _`\                                        /\ \"
write(u6,100) "\ \,\L\_\     __   __  __  __     __     _ __  \_\ \"
write(u6,100) " \/_\__ \   /'__`\/\ \/\ \/\ \  /'__`\  /\`'__\/'_` \"
write(u6,100) "   /\ \L\ \/\  __/\ \ \_/ \_/ \/\ \L\.\_\ \ \//\ \L\ \"
write(u6,100) "   \ `\____\ \____\\ \___x___/'\ \__/.\_\\ \_\\ \___,_\"
write(u6,100) "    \/_____/\/____/ \/__//__/   \/__/\/_/ \/_/ \/__,_ /"
write(u6,100) ""
write(u6,100) ""

100 format(21x,a)

end subroutine Seward_Banner

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Ben Swerts                                             *
!***********************************************************************

subroutine ReIndexFrag(Array,nDens,nDens_Valence,nBas,nBas_Valence,nIrrep)
!***********************************************************************
!                                                                      *
! Input: Array(nDens) filled up to Array(nDens_Valence)                *
! Output: Reindexed Array so fragment densities can be put at the      *
!         proper places.                                               *
! Only needed in case of symmetry.                                     *
!                                                                      *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDens, nDens_Valence, nBas(0:7), nBas_Valence(0:7), nIrrep
real(kind=wp), intent(inout) :: Array(nDens)
integer(kind=iwp) :: indexLarge, indexSmall, iIrrep

if (nIrrep == 1) return

indexLarge = nDens+1
indexSmall = nDens_Valence+1
do iIrrep=nIrrep-1,0,-1
  ! calculate the position in the hypothetical Array(nDens_Valence)
  ! and in the needed Array(nDens)
  indexLarge = indexLarge-nBas(iIrrep)
  indexSmall = indexSmall-nBas_Valence(iIrrep)
  ! move the data
  call dcopy_(nBas_Valence(iIrrep),Array(indexSmall),1,Array(indexLarge),1)
  call dcopy_(nBas_Valence(iIrrep),[Zero],0,Array(indexSmall),1)
end do

return

end subroutine ReIndexFrag

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DRT_RASSI(NVERT0,IDRT0,IDOWN0,NWVER,NVERT,IDRT,IDOWN)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IDRT0(NVERT0,5),IDOWN0(NVERT0,0:3)
      DIMENSION NWVER(NVERT0)
      DIMENSION IDRT(NVERT,5),IDOWN(NVERT,0:3)
C PURPOSE: IDRT0 AND IDOWN0 ARE PALDUS DRT TABLES FOR THE FULL
C    GRAPH. NWVER IS A REINDICING TABLE, WHERE NWVER(IV)=0 IF VERTEX
C    IV SHOULD BE EXCLUDED, AND ELSE IS THE NEW INDEX FOR THAT VERTEX.
C    OUTPUT IS IDRT AND IDOWN, THE TABLES FOR THE RESTRICTED GRAPH.
      DO IV=1,NVERT0
        IVNEW=NWVER(IV)
        IF(IVNEW.EQ.0) GOTO 30
        DO ITAB=1,5
          IDRT(IVNEW,ITAB)=IDRT0(IV,ITAB)
        END DO
        DO IC=0,3
          ID=IDOWN0(IV,IC)
          IDNEW=0
          IF(ID.NE.0) IDNEW=NWVER(ID)
          IDOWN(IVNEW,IC)=IDNEW
        END DO
30    CONTINUE
      END DO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_SubScr_Init()
!
! Purpose: initialize screening in vector subtraction.

use Cholesky, only: DSPNm, DSubScr, nnBstR, nnShl, nSym
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iSym, l_DSubScr

l_DSubScr = nnBstR(1,1)
do iSym=2,nSym
  l_DSubScr = max(l_DSubScr,nnBstR(iSym,1))
end do
call mma_allocate(DSubScr,l_DSubScr,Label='DSubScr')

call mma_allocate(DSPNm,nnShl,Label='DSPNm')

end subroutine Cho_SubScr_Init

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Matthew R. Hennefarth                            *
!***********************************************************************
!  get_coulomb
!
!> @brief get coulomb integrals in AO basis
!>
!> @details
!>   Coulomb integrals generated from \p dm1_core and \p dm1_cas. Currently implementation uses the Fock matrices with ExFac set to
!>   zero. As such, it just wraps the TRACTL2 call.
!>
!> @author Matthew R. Hennefarth
!>
!> @param[in]  cmo      MO coefficients
!> @param[in]  dm1_core core density in AO basis
!> @param[in]  dm1_cas  active space density in AO basis
!> @param[out] coul     coulomb integrals in AO basis
!***********************************************************************

subroutine get_coulomb(cmo,dm1_core,dm1_cas,coul)

use PrintLevel, only: DEBUG, INSANE
use rasscf_global, only: lsquare, NACPR2, nfint
use general_data, only: ntot1, ntot2
use mcpdft_output, only: iprglb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: cmo(ntot2), dm1_core(ntot2), dm1_cas(ntot2)
real(kind=wp), intent(out) :: coul(ntot1)
integer(kind=iwp) :: print_level
real(kind=wp), allocatable :: focka(:), focki(:), puvx(:), tuvx(:)
real(kind=wp), parameter :: exfac = Zero

select case (iPrGlb)
  case (DEBUG)
    print_level = 5
  case (INSANE)
    print_level = 10
  case default
    print_level = 0
end select

call mma_allocate(puvx,nfint,label='puvx')
call mma_allocate(tuvx,nacpr2,label='tuvx')
call mma_allocate(focki,ntot1,label='focki')
call mma_allocate(focka,ntot1,label='focka')

! Quite honestly, this is overkill. It generates the inactive fock, active fock, and transformed integrals puvx/tuvx etc.
! This is completely not necessary for what we need.
call tractl2(cmo,puvx,tuvx,dm1_core,focki,dm1_cas,focka,print_level,lsquare,exfac)

coul(:ntot1) = focki(:)+focka(:)

call mma_deallocate(puvx)
call mma_deallocate(tuvx)
call mma_deallocate(focki)
call mma_deallocate(focka)

end subroutine get_coulomb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

#include "compiler_features.h"
#if defined(_MOLCAS_MPP_) && defined(_GA_)

subroutine LinDepLag_MPP(lg_BDER,lg_SDER,nAS,nIN,iSym,iCase)
! Parallel LinDepLag
! We always use the canonical orthonormalization.

use GA_Wrapper, only: DBL_MB, GA_Destroy, GA_NodeId
#ifdef _SCALAPACK_
use scalapack_mod, only: GA_PDSYEVX_
#endif
use caspt2_global, only: idBoriMat, LUSTD
use caspt2_module, only: THRSHS
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: lg_BDER, lg_SDER, nAS, nIN, iSym, iCase
integer(kind=iwp) :: I, IDB, iHi, iLo, J, jHi, jLo, LDB, LDV, lg_B, lg_Lag, lg_S, lg_Vec, mB, mV, myRank
logical(kind=iwp) :: bStat
real(kind=wp), allocatable :: EIG(:)
#if ! defined (_SCALAPACK_)
real(kind=wp) :: WGRONK(2)
integer(kind=iwp) :: info, NSCRATCH
real(kind=wp), allocatable :: SCRATCH(:), VEC(:)
#endif

!! Obtain the X matrix
!! First, read S
call PSBMAT_GETMEM('S',lg_S,NAS)
call PSBMAT_READ('S',iCase,iSym,lg_S,NAS)

call mma_allocate(EIG,NAS,Label='EIG')
EIG(:) = Zero

myRank = GA_NodeID()
#ifdef _SCALAPACK_
call PSBMAT_GETMEM('VMAT',lg_Vec,NAS)
call GA_PDSYEVX_(lg_S,lg_Vec,EIG,0)
bSTAT = GA_Destroy(lg_S)
#else
! here for the non-ScaLAPACK version: copy matrix to master process,
! diagonalize using the serial DSYEV routine, and copy the resulting
! eigenvectors back to a global array.  Then distribute the eigenvalues.
if (myRank == 0) then
  call mma_allocate(VEC,NAS*NAS,Label='VEC')
  call GA_Get(lg_S,1,NAS,1,NAS,VEC,NAS)
end if
bSTAT = GA_Destroy(lg_S)
if (myRank == 0) then
  call DSYEV_('V','L',NAS,VEC,NAS,EIG,WGRONK,-1,INFO)
  NSCRATCH = int(WGRONK(1))
  call mma_allocate(SCRATCH,NSCRATCH,Label='SCRATCH')
  call DSYEV_('V','L',NAS,VEC,NAS,EIG,SCRATCH,NSCRATCH,INFO)
  call mma_deallocate(SCRATCH)
end if
call PSBMAT_GETMEM('VMAT',lg_Vec,NAS)
if (myRank == 0) then
  call GA_Put(lg_Vec,1,NAS,1,NAS,VEC,NAS)
  call mma_deallocate(VEC)
end if
call GADGOP(EIG,NAS,'+')
#endif

!! Scale only the independent vectors to avoid
!! any numerically unstable computation
! Form orthonormal transformation vectors by scaling the eigenvectors.
call GA_Sync()
call GA_Distribution(lg_Vec,myRank,iLo,iHi,jLo,jHi)
if (iLo /= 0) then
  call GA_Access(lg_Vec,iLo,iHi,jLo,jHi,mV,LDV)
  if ((jHi-jLo+1) /= NAS) then
    write(u6,*) 'SBDIAG_MPP: error in striping of lg_Vec, ABORT'
    call ABEND()
  end if
  do I=1,jHi-jLo+1 ! NAS
    ! can't use array statement because DBL_MB is out of bounds!
    !if (EIG(I) >= THRSHS) DBL_MB(mV+LDV*(I-1):mV+LDV*(I-1)+jHi-jLo) = DBL_MB(mV+LDV*(I-1):mV+LDV*(I-1)+jHi-jLo)/sqrt(EIG(I))
    if (EIG(I) >= THRSHS) call DScal_(iHi-iLo+1,One/sqrt(EIG(I)),DBL_MB(mV+LDV*(I-1)),1)
  end do
  call GA_Release_Update(lg_Vec,iLo,iHi,jLo,jHi)
end if
call GA_Sync()

call mma_deallocate(EIG)

! matrix has been prepared

call GA_CREATE_STRIPED('H',NAS,NAS,'Lag',lg_Lag)
call PSBMAT_GETMEM('B',lg_B,NAS)

call GA_Distribution(lg_B,myRank,iLo,iHi,jLo,jHi)
call GA_Access(lg_B,iLo,iHi,jLo,jHi,mB,LDB)
IDB = IDBoriMat(ISYM,ICASE)
call DDAFILE(LUSTD,2,DBL_MB(mB),(iHi-iLo+1)*(jHi-jLo+1),IDB)
call GA_Release_Update(lg_B,iLo,iHi,jLo,jHi)

!! Compute the partial derivative
!! Work(LF)  : B --> lg_B
!! BDER      : D --> lg_BDER
!! Work(LVEC): X^0 and X --> lg_Vec
call GA_DGEMM('N','T',NAS,NAS,NAS,Two,lg_B,lg_BDER,Zero,lg_Lag)
call GA_DGEMM('N','N',NAS,NAS,NAS,One,lg_Lag,lg_VEC,Zero,lg_B)
call GADupl(lg_B,lg_Lag)

call GA_DGEMM('T','N',NAS,NAS,NAS,One,lg_Vec,lg_Lag,Zero,lg_B)
!! At this point,
!! Work(LF) = 2 \mathcal{X}^0 * B * D * \mathcal{X}

!! remove dependent part
!! (linearly indep-indep and dep-dep)
call GA_Distribution(lg_B,myRank,iLo,iHi,jLo,jHi)
if (iLo /= 0) then
  call GA_Access(lg_B,iLo,iHi,jLo,jHi,mV,LDV)
  !if (ilo <= nas-nin) then
  do J=1,nAS-nIN
    do I=1,min(iHi-iLo+1,nAS-nIN-iLo+1)
      DBL_MB(mV+i-1+LDV*(j-1)) = Zero
    end do
  end do
  !end if
  !if (ilo >= nas-nin+1) then
  do J=nAS-nIN+1,nAS
    do I=max(1,nAS-nIN+1-iLo+1),LDV
      DBL_MB(mV+i-1+LDV*(j-1)) = Zero
    end do
  end do
  !end if
  call GA_Release_Update(lg_B,iLo,iHi,jLo,jHi)
end if

!! orthogonal -> non-orthogonal
!! Finalize Eq. (62)
call GA_DGEMM('N','N',NAS,NAS,NAS,One,lg_Vec,lg_B,Zero,lg_Lag)
call GA_DGEMM('N','T',NAS,NAS,NAS,One,lg_Lag,lg_Vec,One,lg_SDER)

call PSBMAT_FREEMEM(lg_Vec)
bSTAT = GA_Destroy(lg_Lag)
#include "macros.fh"
unused_var(bStat)
call PSBMAT_FREEMEM(lg_B)

end subroutine LinDepLag_MPP

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(LinDepLag_MPP)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_IniLQ(MaxQual,nSym)
      use ChoSwp, only: iQuAB_L, iQuAB_L_Hidden
      use ChoArr, only: iQL2G, nQual_L
      Implicit None
      Integer MaxQual, nSym
#include "cho_para_info.fh"
#include "stdalloc.fh"

      If (Cho_Real_Par) Then
         Call mma_allocate(iQuAB_L_Hidden,MaxQual,nSym,
     &                     Label='iQuAB_L_Hidden')
         iQuAB_L => iQuAB_L_Hidden
         Call mma_allocate(iQL2G,MaxQual,nSym,Label='iQL2G')
      End If

      nQual_L(:)=0

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014,2015, Ignacio Fdez. Galvan                        *
************************************************************************
*  Preprocess_UDC
*
*> @brief
*>   Quickly read the constraints to take some decisions
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Process the constraints in the \p Lu file, but just to find out whether
*> some constraints are present and their values.
*> This is used for:
*>   - Detecting if the "EDIFF" constraint is present and with a zero value,
*>     in which case a conical intersection algorithm could be activated
*>     (depending on the symmetry and spin in the runfile).
*>   - Detecting if any constraint is explicitly declared as "soft",
*>     this is recommended for some TS searches with numerical differentiation.
*>   - Detecting whether an explicit MEP/IRC constraint has been included,
*>     this will probably give problems.
*>
*> @param[in]  Lu     Unit number of the file with the constraints
*> @param[in]  iPrint Print level
************************************************************************
      SUBROUTINE Preprocess_UDC(Lu,iPrint)
      IMPLICIT NONE
      INTEGER :: Lu,iPrint,iPos,Error,nLines,i,j
      CHARACTER(LEN=180) :: Line1,Line2,EDiffName,Get_Ln
      REAL*8 :: EDiffValue
#include "info_slapaf.fh"
#include "real.fh"
#include "nadc.fh"

      EDiffName = ''
      EDiffZero = .FALSE.
      iState(1) = 0
      iState(2) = 0
*
*     An arbitrary initial value given to EDiffValue, this value is
*     irrelevant since the only thing that matters is whether it is 0.0
*
      EDiffValue = One
*
*     Ugly hack to be able to restore the file to its original position
*     (since Get_Ln may read more than one line)
*     Count the lines until the end of the file and backspace
*
      nLines = 0
      DO
        READ(Lu,'(A)',IOSTAT=Error) Line1
        nLines = nLines+1
        IF (Error.ne.0) EXIT
      END DO
      DO i=1,nLines
        BACKSPACE(Lu)
      END DO
*
*     Read the primitive constraints
*
*     First read until the "VALUES" line
*     Each line is split at the "=" sign by auto,
*     so read two lines if there is no "=" sign
*
      DO
        Line1 = Get_Ln(Lu)
        CALL UpCase(Line1)
        CALL LeftAd(Line1)
        IF (Line1(1:4).eq.'VALU') EXIT
        iPos = INDEX(Line1,'=')
        IF (iPos.gt.0) THEN
          Line2 = Line1(iPos+1:)
          Line1 = Line1(:iPos-1)
        ELSE
          Line2 = Get_Ln(Lu)
          CALL UpCase(Line2)
        END IF
        CALL LeftAd(Line2)
*       If a primitive is defined as "EDIFF", save its name
        IF (Line2(1:4).eq.'EDIF') THEN
          EDiffName = Line1
          iPos = INDEX(Line2,' ')
          Line2 = Line2(iPos+1:)
          CALL LeftAd(Line2)
          READ(Line2,*,IOSTAT=Error) i
          IF (Error.ne.0) i=0
          iPos = INDEX(Line2,' ')
          Line2 = Line2(iPos+1:)
          CALL LeftAd(Line2)
          READ(Line2,*,IOSTAT=Error) j
          IF (Error.ne.0) j=0
          iState(1)=MAX(i,j)
          iState(2)=MIN(i,j)
        END IF
*       If a primitive of the same type as that used by MEP/IRC
*       is defined, signal it.
        IF (Line2(1:4).eq.MEP_Type(1:4)) THEN
          MEPCons=.TRUE.
        END IF
      END DO
*
*     Now read the constraint values
*
*     Read until the "END" line
*     Each line is split at the "=" sign by auto,
*     so read two lines if there is no "=" sign
*
      DO
        Line1 = Get_Ln(Lu)
        CALL UpCase(Line1)
        CALL LeftAd(Line1)
*       Read continuation lines
        DO WHILE (INDEX(Line1,'&').ne.0)
          Line1 = Get_Ln(Lu)
          CALL UpCase(Line1)
          CALL LeftAd(Line1)
        END DO
        IF (Line1(1:4).eq.'END ') EXIT
        iPos = INDEX(Line1,'=')
        IF (iPos.gt.0) THEN
          Line2 = Line1(iPos+1:)
          Line1 = Line1(:iPos-1)
        ELSE
          Line2 = Get_Ln(Lu)
          CALL UpCase(Line2)
        END IF
*       If the name matches the "EDIFF" primitive, read the value
        IF (Line1.eq.EDiffName) THEN
          READ(Line2,*,IOSTAT=Error) EDiffValue
          IF (Error.ne.0) EDiffValue = One
        END IF
*       If the constraint is explicitly "soft"
        IF (INDEX(Line2,'SOFT').ne.0) lSoft = .TRUE.
      END DO
*
*     Return the file to its original position
*     (cannot use REWIND because this may be the full input for slapaf)
*     First advance to the end of file and then backspace
*
      DO
        READ(Lu,'(A)',IOSTAT=Error) Line1
        IF (Error.ne.0) EXIT
      END DO
      DO i=1,nLines
        BACKSPACE(Lu)
      END DO
*
*     If an "EDIFF" constraint is being used with a value exactly 0.0,
*     this may be a conical intersection search.
*     If there is no "EDIFF" at all, there's no use computing NACs
*
      IF (EDiffValue.eq.Zero) THEN
        EDiffZero = .TRUE.
        IF (iPrint.ge.6) THEN
          WRITE(6,*) 'Energy difference constraint with zero value.'
          WRITE(6,*) 'This may be a conical intersection search.'
        END IF
      ELSE IF (EDiffName(1:4).ne.'    ') THEN
        IF (iPrint.ge.6) THEN
          WRITE(6,*) 'Energy difference constraint with non-zero value.'
          WRITE(6,*) 'This will not be a conical intersection search.'
        END IF
      ELSE
        NADC=.FALSE.
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine schmidtn_cvb(c,nvec,sao,n,metr)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nvec, n, metr
real(kind=wp), intent(inout) :: c(n,nvec)
real(kind=wp), intent(in) :: sao(*)
real(kind=wp), allocatable :: tmp(:,:)

if (metr == 0) then
  call schmidtn2_cvb(c,c,nvec,sao,n,metr)
else
  call mma_allocate(tmp,n,nvec,label='tmp')
  call schmidtn2_cvb(c,tmp,nvec,sao,n,metr)
  call mma_deallocate(tmp)
end if

return

end subroutine schmidtn_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetChVHlp1(cGrp,deGrp,yes,NL2,L2Status)
! this routine does:
! check, if Cholesky vector block cGrp,deGrp is actually situated
! in the memory as one of L2x
!
! descrition of parameters:
! cGrp, deGrp - required Group of c, delta in L2(m,c',de') (I)
! yes    -  0 - not loaded  (O)
!           x - loaded, value of L2x (x=1-4)
! NL2         - Number of L2 arrays really reserved in memory (I)
! L2Status    - L2 status matrix (I)
!               L2Status(i,1) - cGrp
!               L2Status(i,2) - deGrp
!               L2Status(i,3) - Pos

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: cGrp, deGrp, NL2, L2Status(4,3)
integer(kind=iwp), intent(out) :: yes
integer(kind=iwp) :: i

yes = 0
do i=1,NL2
  if ((cGrp == L2Status(i,1)) .and. (deGrp == L2Status(i,2))) yes = i
end do

return

end subroutine GetChVHlp1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_STAT()
C
C     Purpose: print statistics from decomposition.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "cho_para_info.fh"
#include "choprint.fh"
#include "choorb.fh"
#include "choptr.fh"
#include "chosubscr.fh"
#include "WrkSpc.fh"

      CHARACTER*8 SECNAM
      PARAMETER (SECNAM = 'CHO_STAT')

      CHARACTER*25 STRING
      CHARACTER*2  UNT

      PARAMETER (NTAU = 5, DTAU = 1.0D-1)
      REAL*8 TAU(NTAU), XC(NTAU)

      REAL*8 XXBST(8), VCSTOR(8)

      LOGICAL DOCPCT, DOWPCT, CHO_SSCREEN_SAVE, PARALG

      PARAMETER (N2 = INFVEC_N2)

      MULD2H(I,J)=IEOR(I-1,J-1)+1
      INTMAP(I)=IWORK(ip_INTMAP-1+I)
      INFVEC(I,J,K)=IWORK(ip_INFVEC-1+MAXVEC*N2*(K-1)+MAXVEC*(J-1)+I)
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NDIMRS(I,J)=IWORK(ip_NDIMRS-1+NSYM*(J-1)+I)
      DSPNM(I)=WORK(ip_DSPNM-1+I)


      PARALG=CHO_DECALG.EQ.4 .OR. CHO_DECALG.EQ.5 .OR. CHO_DECALG.EQ.6

C     Overall header.
C     ---------------

      CALL CHO_HEAD('Cholesky Decomposition Statistics','=',80,LUPRI)
      IF (RSTDIA) THEN
         WRITE(LUPRI,'(/,A)')
     &   'Calculation restarted from diagonal on disk'
      END IF
      IF (RSTCHO) THEN
         IF (RSTDIA) THEN
            WRITE(LUPRI,'(A)')
     &      'Calculation restarted from Cholesky vectors on disk'
         ELSE
            WRITE(LUPRI,'(/,A)')
     &      'Calculation restarted from Cholesky vectors on disk'
         END IF
      END IF

C     Configuration.
C     --------------

      CALL CHO_HEAD('Configuration','-',80,LUPRI)
      IPRSAV = IPRINT
      IPRINT = INF_INIT + 1
      CALL CHO_PRTHEAD(.TRUE.)
      IPRINT = IPRSAV

C     Vector statistics.
C     ------------------

      CALL CHO_HEAD('Vector statistics','-',80,LUPRI)
      WRITE(LUPRI,'(/,A,A,/,A,A)')
     & 'Sym.        N      Full      Mmax         M    M/Full',
     & '    M/Mmax       M/N',
     & '-----------------------------------------------------',
     & '---------------------'
      NTOT = 0
      DO ISYM = 1,NSYM
         NTOT = NTOT + NUMCHO(ISYM)
         NN = 0
         XXBST(ISYM) = 0.0D0
         DO JSYM = 1,NSYM
            KSYM = MULD2H(JSYM,ISYM)
            IF (JSYM .GT. KSYM) THEN
               NN = NN + NBAS(JSYM)*NBAS(KSYM)
               XXBST(ISYM) = XXBST(ISYM)
     &         + DBLE(NBAS(JSYM))*DBLE(NBAS(KSYM))
            ELSE IF (JSYM .EQ. KSYM) THEN
               NN = NN + NBAS(JSYM)*(NBAS(JSYM) + 1)/2
               XXBST(ISYM) = XXBST(ISYM)
     &         + DBLE(NBAS(JSYM))*(DBLE(NBAS(JSYM)) + 1.0D0)/2.0D0
            END IF
         END DO
         IF (NN .GT. 0) THEN
            YYY = DBLE(NUMCHO(ISYM))/XXBST(ISYM)
         ELSE
            YYY = 9.0D9
         END IF
         IF (NNBSTR(ISYM,1) .GT. 0) THEN
            XX = DBLE(NNBSTR(ISYM,1))
            YY = DBLE(NUMCHO(ISYM))/XX
         ELSE
            YY = 9.0D9
         END IF
         IF (NBAS(ISYM) .NE. 0) THEN
            X = DBLE(NBAS(ISYM))
            Y = DBLE(NUMCHO(ISYM))/X
         ELSE
            Y = 9.0D9
         END IF
         WRITE(LUPRI,'(I3,4(1X,I9),3(1X,F9.4))')
     &   ISYM,NBAS(ISYM),NN,NNBSTR(ISYM,1),NUMCHO(ISYM),YYY,YY,Y
      END DO
      WRITE(LUPRI,'(A,A)')
     & '-----------------------------------------------------',
     & '---------------------'
      NN = NBAST*(NBAST + 1)/2
      IF (NN .GT. 0) THEN
         XXX = DBLE(NN)
         YYY = DBLE(NUMCHT)/XXX
      ELSE
         YYY = 9.0D9
      END IF
      IF (NNBSTRT(1) .GT. 0) THEN
         XX = DBLE(NNBSTRT(1))
         YY = DBLE(NUMCHT)/XX
      ELSE
         YY = 9.0D9
      END IF
      IF (NBAST .NE. 0) THEN
         X = DBLE(NBAST)
         Y = DBLE(NUMCHT)/X
      ELSE
         Y = 9.0D9
      END IF
      WRITE(LUPRI,'(3X,4(1X,I9),3(1X,F9.4))')
     & NBAST,NN,NNBSTRT(1),NUMCHT,YYY,YY,Y
      WRITE(LUPRI,'(A,A)')
     & '-----------------------------------------------------',
     & '---------------------'
      IF (NTOT .NE. NUMCHT) THEN
         WRITE(LUPRI,'(A)')
     &   'WARNING: total number of vectors is wrong!!!'
      END IF

      CALL CHO_GETSTOR(VCSTOR)

      WRITE(LUPRI,'(/,A,/,A,/,A)')
     & '                       %Saving relative to',
     & 'Sym.     Storage      1st Red. Set     Full',
     & '---------------------------------------------'
      VCTOT = 0.0D0
      X1TOT = 0.0D0
      X2TOT = 0.0D0
      XXTOT = 0.0D0
      DO ISYM = 1,NSYM
         X1DIM = DBLE(NNBSTR(ISYM,1))
         X1RED = X1DIM*DBLE(NUMCHO(ISYM))
         IF (X1RED .GT. 0.0D0) THEN
            SAV1  = 1.0D2*(X1RED - VCSTOR(ISYM))/X1RED
         ELSE
            SAV1 = 9.0D9
         END IF
         XX = XXBST(ISYM)*DBLE(NUMCHO(ISYM))
         IF (XX .GT. 0.0D0) THEN
            SAV2  = 1.0D2*(XX - VCSTOR(ISYM))/XX
         ELSE
            SAV2 = 9.0D9
         END IF
         XGB = VCSTOR(ISYM)*8.0D0/1.024D3
         UNT = 'kb'
         IF (XGB .GT. 1.0D3) THEN
            XGB = XGB/1.024D3
            UNT = 'Mb'
            IF (XGB .GT. 1.0D3) THEN
               XGB = XGB/1.024D3
               UNT = 'Gb'
               IF (XGB .GT. 1.0D3) THEN
                  XGB = XGB/1.024D3
                  UNT = 'Tb'
               END IF
            END IF
         END IF
         WRITE(LUPRI,'(I2,4X,F10.3,1X,A,4X,F9.4,4X,F9.4)')
     &   ISYM,XGB,UNT,SAV1,SAV2
         VCTOT = VCTOT + VCSTOR(ISYM)
         X1TOT = X1TOT + X1RED
         X2TOT = X2TOT + X1DIM*(X1DIM + 1.0D0)/2.0D0
         XXTOT = XXTOT + XX
      END DO
      WRITE(LUPRI,'(A)')
     & '---------------------------------------------'
      IF (X1TOT .GT. 0.0D0) THEN
         SAV1  = 1.0D2*(X1TOT - VCTOT)/X1TOT
      ELSE
         SAV1 = 9.0D9
      END IF
      IF (XXTOT .GT. 0.0D0) THEN
         SAV2  = 1.0D2*(XXTOT - VCTOT)/XXTOT
      ELSE
         SAV2 = 9.0D9
      END IF
      XGB = VCTOT*8.0D0/1.024D3
      UNT = 'kb'
      IF (XGB .GT. 1.0D3) THEN
         XGB = XGB/1.024D3
         UNT = 'Mb'
         IF (XGB .GT. 1.0D3) THEN
            XGB = XGB/1.024D3
            UNT = 'Gb'
            IF (XGB .GT. 1.0D3) THEN
               XGB = XGB/1.024D3
               UNT = 'Tb'
            END IF
         END IF
      END IF
      WRITE(LUPRI,'(A6,F10.3,1X,A,4X,F9.4,4X,F9.4)')
     & 'Total:',XGB,UNT,SAV1,SAV2
      WRITE(LUPRI,'(A)')
     & '---------------------------------------------'
      PCT = 1.0D2*VCTOT/X2TOT
      WRITE(LUPRI,'(A,F11.6,A)')
     & 'Total storage corresponds to',PCT,
     & '% of the 1st reduced set integral matrix.'

      CALL CHO_STAT_PARENTDIAG()

C     Integral statistics.
C     --------------------

      MAXCAL = 0
      NCAL   = 0
      NREP   = 0
      NCALL  = 0
      DO ISHLAB = 1,NNSHL
         IF (INTMAP(ISHLAB) .GT. 0) THEN
            MAXCAL = MAX(MAXCAL,INTMAP(ISHLAB))
            NCAL   = NCAL  + 1
            NCALL  = NCALL + INTMAP(ISHLAB)
            IF (INTMAP(ISHLAB) .GT. 1) NREP = NREP + 1
         END IF
      END DO

      XXSHL = DBLE(NNSHL)
      XCAL  = DBLE(NCAL)
      XREP  = DBLE(NREP)

      CALL CHO_HEAD('Integral statistics','-',80,LUPRI)
      WRITE(LUPRI,'(/,A,I10)')
     & '#Shells                  :',NSHELL
      WRITE(LUPRI,'(A,I10)')
     & '#Shell Pair Distributions:',NNSHL
      WRITE(LUPRI,'(A,I10)')
     & '#Integral passes         :',XNPASS
      WRITE(LUPRI,'(A,I10)')
     & '#Calls to integral prog. :',NCALL
      WRITE(LUPRI,'(A,I10,A,F8.3,A,A)')
     & '#Shell Pairs Calculated  :',NCAL,' (',XCAL*1.0D2/XXSHL,' %',
     & ' of total)'
      WRITE(LUPRI,'(A,I10,A,F8.3,A,A)')
     & '#Shell Pairs Repeated    :',NREP,' (',XREP*1.0D2/XCAL,' %',
     & ' of calculated)'

      WRITE(LUPRI,'(/,A,/,A)')
     & '#Calculations     #Shell Pairs   Percentage',
     & '-------------------------------------------'
      DO ICAL = 1,MAXCAL
         N = 0
         DO ISHLAB = 1,NNSHL
            IF (INTMAP(ISHLAB) .EQ. ICAL) N = N + 1
         END DO
         IF (N .GT. 0) THEN
            X = DBLE(N)
            WRITE(LUPRI,'(I12,6X,I12,5X,F8.3)') ICAL,N,X*1.0D2/XXSHL
         END IF
      END DO
      WRITE(LUPRI,'(A)')
     & '-------------------------------------------'

C     Section timings.
C     ----------------

      IF (IPRINT .GE. INF_TIMING) THEN

      TCINI = TIMSEC(2,1) - TIMSEC(1,1)
      TWINI = TIMSEC(4,1) - TIMSEC(3,1)
      TCDIA = TIMSEC(2,2) - TIMSEC(1,2)
      TWDIA = TIMSEC(4,2) - TIMSEC(3,2)
      TCDEC = TIMSEC(2,3) - TIMSEC(1,3)
      TWDEC = TIMSEC(4,3) - TIMSEC(3,3)
      TCCHD = TIMSEC(2,4) - TIMSEC(1,4)
      TWCHD = TIMSEC(4,4) - TIMSEC(3,4)
      TCCHA = TIMSEC(2,5) - TIMSEC(1,5)
      TWCHA = TIMSEC(4,5) - TIMSEC(3,5)
      TCREO = TIMSEC(2,6) - TIMSEC(1,6)
      TWREO = TIMSEC(4,6) - TIMSEC(3,6)
      TCDIS = TIMSEC(2,7) - TIMSEC(1,7)
      TWDIS = TIMSEC(4,7) - TIMSEC(3,7)
      TCFIN = TIMSEC(2,8) - TIMSEC(1,8)
      TWFIN = TIMSEC(4,8) - TIMSEC(3,8)

      CALL CHO_HEAD('Section timings','-',80,LUPRI)
      WRITE(LUPRI,'(/,A,/,A,/,A)')
     &'                                 CPU time          Wall time',
     &'Section                      hours min. sec.    hours min. sec.',
     &'---------------------------------------------------------------'
      STRING = 'Initialization           '
      CALL CHO_CNVTIM(TCINI,IHC,IMC,SCC)
      CALL CHO_CNVTIM(TWINI,IHW,IMW,SCW)
      WRITE(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)')
     & STRING,IHC,IMC,SCC,IHW,IMW,SCW
      STRING = 'Diagonal setup           '
      CALL CHO_CNVTIM(TCDIA,IHC,IMC,SCC)
      CALL CHO_CNVTIM(TWDIA,IHW,IMW,SCW)
      WRITE(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)')
     & STRING,IHC,IMC,SCC,IHW,IMW,SCW
      STRING = 'Cholesky decomposition   '
      CALL CHO_CNVTIM(TCDEC,IHC,IMC,SCC)
      CALL CHO_CNVTIM(TWDEC,IHW,IMW,SCW)
      WRITE(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)')
     & STRING,IHC,IMC,SCC,IHW,IMW,SCW
      STRING = 'Diagonal check           '
      CALL CHO_CNVTIM(TCCHD,IHC,IMC,SCC)
      CALL CHO_CNVTIM(TWCHD,IHW,IMW,SCW)
      WRITE(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)')
     & STRING,IHC,IMC,SCC,IHW,IMW,SCW
      IF (CHO_INTCHK) THEN
         STRING = 'Integral check (debug)   '
         CALL CHO_CNVTIM(TCCHA,IHC,IMC,SCC)
         CALL CHO_CNVTIM(TWCHA,IHW,IMW,SCW)
         WRITE(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)')
     &   STRING,IHC,IMC,SCC,IHW,IMW,SCW
      END IF
      IF (CHO_REORD) THEN
         STRING = 'Vector reordering        '
         CALL CHO_CNVTIM(TCREO,IHC,IMC,SCC)
         CALL CHO_CNVTIM(TWREO,IHW,IMW,SCW)
         WRITE(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)')
     &    STRING,IHC,IMC,SCC,IHW,IMW,SCW
      END IF
      IF (CHO_FAKE_PAR .AND. NPROCS.GT.1 .AND. Is_Real_Par()) THEN
         STRING = 'Vector distribution      '
         CALL CHO_CNVTIM(TCDIS,IHC,IMC,SCC)
         CALL CHO_CNVTIM(TWDIS,IHW,IMW,SCW)
         WRITE(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)')
     &    STRING,IHC,IMC,SCC,IHW,IMW,SCW
      END IF
      STRING = 'Finalization             '
      CALL CHO_CNVTIM(TCFIN,IHC,IMC,SCC)
      CALL CHO_CNVTIM(TWFIN,IHW,IMW,SCW)
      WRITE(LUPRI,'(A,1X,I8,2X,I2,1X,F5.1,1X,I8,2X,I2,1X,F5.1)')
     & STRING,IHC,IMC,SCC,IHW,IMW,SCW
      WRITE(LUPRI,'(A)')
     &'---------------------------------------------------------------'

      END IF ! IPRINT .GT. INF_TIMING

C     Timing of decomposition driver.
C     -------------------------------

      IF (DID_DECDRV) THEN

         CMISC = TDECDRV(1)
         WMISC = TDECDRV(2)
         DO J = 1,NINTEG
            CMISC = CMISC - TINTEG(1,J)
            WMISC = WMISC - TINTEG(2,J)
         END DO
         DO J = 1,NDECOM
            CMISC = CMISC - TDECOM(1,J)
            WMISC = WMISC - TDECOM(2,J)
         END DO
         DO J = 1,NMISC
            CMISC = CMISC - TMISC(1,J)
            WMISC = WMISC - TMISC(2,J)
         END DO
         CPCT = -9.0D9
         CFAC = -9.0D9
         WPCT = -9.0D9
         WFAC = -9.0D9
         IF (TDECDRV(1) .GT. 0.0D0) THEN
            DOCPCT = .TRUE.
            CFAC   = 1.0D2/TDECDRV(1)
         ELSE
            DOCPCT = .FALSE.
         END IF
         IF (TDECDRV(2) .GT. 0.0D0) THEN
            DOWPCT = .TRUE.
            WFAC   = 1.0D2/TDECDRV(2)
         ELSE
            DOWPCT = .FALSE.
         END IF

         CALL CHO_HEAD('Timing of decomposition driver','-',80,LUPRI)
         WRITE(LUPRI,'(/,A,A,/,A,A)')
     &    'Task           Component           CPU (min.)     %',
     &    '   Wall (min.)     %',
     &    '---------------------------------------------------',
     &    '----------------------'
         CTIM = TINTEG(1,1)
         WTIM = TINTEG(2,1)
         IF (DOCPCT) CPCT = CTIM*CFAC
         IF (DOWPCT) WPCT = WTIM*WFAC
         WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &   'Integrals      calculation        ',
     &   CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         CTIM = TINTEG(1,2)
         WTIM = TINTEG(2,2)
         IF (DOCPCT) CPCT = CTIM*CFAC
         IF (DOWPCT) WPCT = WTIM*WFAC
         WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &   '               I/O, qualifieds    ',
     &   CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         CTIM = TDECOM(1,1)
         WTIM = TDECOM(2,1)
         IF (DOCPCT) CPCT = CTIM*CFAC
         IF (DOWPCT) WPCT = WTIM*WFAC
         WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &   'Decomposition  I/O, qualifieds    ',
     &   CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         CTIM = TDECOM(1,2)
         WTIM = TDECOM(2,2)
         IF (DOCPCT) CPCT = CTIM*CFAC
         IF (DOWPCT) WPCT = WTIM*WFAC
         WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &   '               I/O, vectors       ',
     &   CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         CTIM = TDECOM(1,3)
         WTIM = TDECOM(2,3)
         IF (DOCPCT) CPCT = CTIM*CFAC
         IF (DOWPCT) WPCT = WTIM*WFAC
         WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &   '               vector subtraction ',
     &   CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         IF (PARALG) THEN
            CTIM = TDECOM(1,4)
            WTIM = TDECOM(2,4)
            IF (DOCPCT) CPCT = CTIM*CFAC
            IF (DOWPCT) WPCT = WTIM*WFAC
            WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &      '               qualified CD       ',
     &      CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         END IF
         CTIM = TMISC(1,1)
         WTIM = TMISC(2,1)
         IF (DOCPCT) CPCT = CTIM*CFAC
         IF (DOWPCT) WPCT = WTIM*WFAC
         WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &   'Misc.          qualification      ',
     &   CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         CTIM = TMISC(1,2)
         WTIM = TMISC(2,2)
         IF (DOCPCT) CPCT = CTIM*CFAC
         IF (DOWPCT) WPCT = WTIM*WFAC
         WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &   '               red. set write     ',
     &   CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         CTIM = TMISC(1,3)
         WTIM = TMISC(2,3)
         IF (DOCPCT) CPCT = CTIM*CFAC
         IF (DOWPCT) WPCT = WTIM*WFAC
         WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &   '               info write         ',
     &   CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         IF (PARALG) THEN
            CTIM = TMISC(1,4)
            WTIM = TMISC(2,4)
            IF (DOCPCT) CPCT = CTIM*CFAC
            IF (DOWPCT) WPCT = WTIM*WFAC
            WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &      '               diagonal sync      ',
     &      CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
            CTIM = TMISC(1,5)
            WTIM = TMISC(2,5)
            IF (DOCPCT) CPCT = CTIM*CFAC
            IF (DOWPCT) WPCT = WTIM*WFAC
            WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &      '               vector count sync  ',
     &      CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         END IF
         CTIM = CMISC
         WTIM = WMISC
         IF (DOCPCT) CPCT = CTIM*CFAC
         IF (DOWPCT) WPCT = WTIM*WFAC
         WRITE(LUPRI,'(A,1X,F10.2,1X,F7.2,2X,F10.2,1X,F7.2)')
     &   '               etc.               ',
     &   CTIM/6.0D1,CPCT,WTIM/6.0D1,WPCT
         WRITE(LUPRI,'(A,A)')
     &   '---------------------------------------------------',
     &   '----------------------'
         WRITE(LUPRI,'(A,1X,F10.2,10X,F10.2)')
     &   'Total:                            ',
     &   TDECDRV(1)/6.0D1,TDECDRV(2)/6.0D1
         WRITE(LUPRI,'(A,A)')
     &   '---------------------------------------------------',
     &   '----------------------'
         WRITE(LUPRI,'(A,I12)')
     &   'Total #system calls for vector read  :',NSYS_CALL
         IF (.NOT. CHO_SSCREEN) THEN
            WRITE(LUPRI,'(A,I12)')
     &      'Total #DGEMM  calls for vector subtr.:',NDGM_CALL
         END IF

      END IF

C     Screening statistics from vector subtractions.
C     ----------------------------------------------

      IF (CHO_SSCREEN) THEN
         CALL CHO_HEAD('Screening Statistics from Vector Subtraction',
     &                 '-',80,LUPRI)
         WRITE(LUPRI,'(/,A,12X,A)')
     &   'Norm used for diagonals      : ',SSNORM
         WRITE(LUPRI,'(A,1P,D15.4)')
     &   'Screening threshold          : ',SSTAU
         WRITE(LUPRI,'(A,1P,D15.4)')
     &   'Maximum possible #DGEMV calls: ',SUBSCRSTAT(1)
         WRITE(LUPRI,'(A,1P,D15.4)')
     &   'Actual #DGEMV calls          : ',SUBSCRSTAT(2)
         IF (SUBSCRSTAT(1) .GT. 0.0D0) THEN
            SSCRPCT = 1.0D2*(SUBSCRSTAT(1)-SUBSCRSTAT(2))/SUBSCRSTAT(1)
            WRITE(LUPRI,'(A,8X,F7.2,A)')
     &      'Screening percent            : ',SSCRPCT,'%'
         END IF
      END IF

C     Statistics for shell quadruples spanned by each reduced set.
C     (This is for test purposes.)
C     ------------------------------------------------------------

      IF (CHO_TSTSCREEN .AND.
     &    .NOT.(CHO_FAKE_PAR.AND.NPROCS.GT.1.AND.Is_Real_Par())) THEN

         CHO_SSCREEN_SAVE = CHO_SSCREEN
         CHO_SSCREEN = .TRUE. ! to avoid error termination

         IF (NTAU .LT. 1) THEN
            WRITE(LUPRI,*) SECNAM,': screening test requested, but ',
     &                     'NTAU is non-positive!'
            WRITE(LUPRI,*) SECNAM,': test is skipped!'
            GO TO 199 ! skip
         END IF
         TAU(1) = THRCOM
         DO ITAU = 2,NTAU
            TAU(ITAU) = TAU(ITAU-1)*DTAU
         END DO

         CALL CHO_HEAD('RS Screening Statistics (TEST)','-',80,LUPRI)
         WRITE(LUPRI,'(/,A,A)')
     &   'Norm used for diagonal shell pairs: ',SSNORM
         CALL CHO_SUBSCR_INIT()

         ILOC = 3

         DO ISYM = 1,NSYM
            IF (NUMCHO(ISYM) .GT. 0) THEN

               LRED = INFVEC(NUMCHO(ISYM),2,ISYM)
               DO IRED = 1,LRED

                  IVEC1 = 0
                  NVEC  = 0
                  CALL CHO_X_NVECRS(IRED,ISYM,IVEC1,NVEC)
                  IF (NVEC.GT.0 .AND. NDIMRS(ISYM,IRED).GT.0) THEN

                     CALL CHO_MEM('TstS Max','GETM','REAL',KRDVT,LRDVT)
                     NUMVEC = MIN(LRDVT/NDIMRS(ISYM,IRED),NVEC)
                     IF (NUMVEC .LT. 1) THEN
                        CALL CHO_QUIT(
     &                  'Insufficient memory for TstScreen in '//SECNAM,
     &                  104)
                     END IF
                     NBATCH = (NVEC - 1)/NUMVEC + 1

                     DO IBATCH = 1,NBATCH

                        IF (IBATCH .EQ. NBATCH) THEN
                           NUMV = NVEC - NUMVEC*(NBATCH-1)
                        ELSE
                           NUMV = NUMVEC
                        END IF
                        LRDVEC = NDIMRS(ISYM,IRED)*NUMV
                        CALL CHO_MEM('TstScreen','ALLO','REAL',
     &                               KRDVEC,LRDVEC)

                        JVEC1 = IVEC1 + NUMVEC*(IBATCH-1)
                        JVEC2 = JVEC1 + NUMV - 1
                        JNUM  = 0
                        MUSD  = 0
                        CALL CHO_VECRD(WORK(KRDVEC),LRDVEC,JVEC1,JVEC2,
     &                                 ISYM,JNUM,IREDC,MUSD)
                        IF (JNUM .NE. NUMV) THEN
                           CALL CHO_QUIT('Logical error in '//SECNAM,
     &                                   103)
                        END IF

                        IF (IREDC .NE. IRED) THEN
                           CALL CHO_X_SETRED(IRC,ILOC,IRED)
                           IF (IRC .NE. 0) THEN
                              WRITE(LUPRI,*) SECNAM,
     &                        ': CHO_X_SETRED returned ',IRC
                              CALL CHO_QUIT('Error in '//SECNAM,104)
                           END IF
                           IREDC = IRED
                        END IF

                        CALL CHO_SUBSCR_DIA(WORK(KRDVEC),NUMV,ISYM,ILOC,
     &                                      SSNORM)
                        XT = 0.0D0
                        CALL CHO_DZERO(XC,NTAU)
                        DO ISHAB = 1,NNSHL
                           IF (NNBSTRSH(ISYM,ISHAB,ILOC) .GT. 0) THEN
                              DO ISHGD = ISHAB,NNSHL
                                 IF (NNBSTRSH(ISYM,ISHGD,ILOC) .GT. 0)
     &                           THEN
                                    TST = DSPNM(ISHAB)*DSPNM(ISHGD)
                                    TST = SQRT(TST)
                                    XT  = XT + 1.0D0
                                    DO ITAU = 1,NTAU
                                       IF (TST .GT. TAU(ITAU)) THEN
                                          XC(ITAU) = XC(ITAU) + 1.0D0
                                       END IF
                                    END DO
                                 END IF
                              END DO
                           END IF
                        END DO

                        WRITE(LUPRI,'(/,1X,A,I6,A,I2,A)')
     &                  '*** Statistics for reduced set',IRED,
     &                  '    Symmetry',ISYM,' ***'
                        WRITE(LUPRI,'(1X,A,I6,A,I6)')
     &                  '    Batch no.',IBATCH,' of',NBATCH
                        WRITE(LUPRI,'(1X,A,9X,I6)')
     &                  '       No. vectors     : ',NUMV
                        WRITE(LUPRI,'(1X,A,9X,I6,9X,I6)')
     &                  '       Vector range    : ',JVEC1,JVEC2
                        WRITE(LUPRI,'(1X,A,1P,D15.7)')
     &                  '       Shell quadruples: ',XT
                        IF (XT .LT. 1.0D0) THEN
                           CALL CHO_QUIT('XT non-positive in '//SECNAM,
     &                                   103)
                        END IF
                        FAC = 1.0D2/XT
                        DO ITAU = 1,NTAU
                           PCT = FAC*(XT-XC(ITAU))
                           WRITE(LUPRI,'(1X,A,1P,D15.7,A,D15.7,A)')
     &                     '       Threshold: ',TAU(ITAU),
     &                     '  Screening percent: ',PCT,'%'
                        END DO
                        CALL CHO_FLUSH(LUPRI)

                        CALL CHO_MEM('TstScreen','FREE','REAL',
     &                               KRDVEC,LRDVEC)

                     END DO

                  END IF

               END DO

            END IF
         END DO

         CALL CHO_SUBSCR_FINAL()

  199    CONTINUE ! skip point

         CHO_SSCREEN = CHO_SSCREEN_SAVE

      END IF


      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine prints the trailer part to the postscript figure of     *
! occupation numbers.                                                  *
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine FigCls(lu)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lu

write(lu,'(a)') '%---'
write(lu,'(a)') 'grestore'
write(lu,'(a)') 'showpage'
write(lu,'(a)') '%.AutoFeed'

return

end subroutine FigCls

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine initopt_cvb(icrit,lfxvb,nfxvb,iorts,nort,norb)

use casvb_global, only: ioptcode, ioptim
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: icrit, lfxvb, nfxvb, iorts(2,*), nort
integer(kind=iwp), intent(in) :: norb
integer(kind=iwp) :: iorb, jorb

! IOPTCODE bit 0 = REPORT
!              1 = OPTIM
!              2 = Svb
!              3 = freeze structure coefficients
!              4 = strong-orthogonality constraints

if (ioptim == 0) return

if (btest(ioptcode(ioptim),1)) then
  call setifinish_cvb(1)
else if (btest(ioptcode(ioptim),0)) then
  call setifinish_cvb(3)
end if
if (btest(ioptcode(ioptim),2)) icrit = 1
if (btest(ioptcode(ioptim),3)) then
  lfxvb = 1
  nfxvb = 0
end if
if (btest(ioptcode(ioptim),4)) then
  nort = 0
  do iorb=1,norb
    do jorb=iorb+1,norb
      if (.not. ((jorb == iorb+1) .and. (mod(iorb,2) == 1))) then
        nort = nort+1
        iorts(1,nort) = iorb
        iorts(2,nort) = jorb
      end if
    end do
  end do
end if

return

end subroutine initopt_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine COUNT_CPF(NINTGR,NSYM,NORB,MUL)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: NINTGR
integer(kind=iwp), intent(in) :: NSYM, NORB(*), MUL(8,8)
integer(kind=iwp) :: NOP, NOQ, NOR, NORBP, NOS, NSP, NSPQ, NSPQR, NSQ, NSR, NSS, NSSM, NT, NTM, NU, NUMAX, NUMIN, NV, NX, NXM

! COUNT TWO-ELECTRON INTEGRALS
NINTGR = 0
do NSP=1,NSYM
  NOP = NORB(NSP)
  do NSQ=1,NSP
    NSPQ = MUL(NSP,NSQ)
    NOQ = NORB(NSQ)
    do NSR=1,NSP
      NSPQR = MUL(NSPQ,NSR)
      NOR = NORB(NSR)
      NSSM = NSR
      if (NSR == NSP) NSSM = NSQ
      do NSS=1,NSSM
        if (NSS /= NSPQR) cycle
        NOS = NORB(NSS)
        NORBP = NOP*NOQ*NOR*NOS
        if (NORBP == 0) cycle
        do NV=1,NOR
          NXM = NOS
          if (NSR == NSS) NXM = NV
          do NX=1,NXM
            NTM = 1
            if (NSP == NSR) NTM = NV
            do NT=NTM,NOP
              NUMIN = 1
              if ((NSP == NSR) .and. (NT == NV)) NUMIN = NX
              NUMAX = NOQ
              if (NSP == NSQ) NUMAX = NT
              do NU=NUMIN,NUMAX
                NINTGR = NINTGR+1
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end do

return

end subroutine COUNT_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      Subroutine CSF2SD(CSF,SD,is)
      use ipPage, only: Diskbased
      Use Str_Info, only: DTOC, CNSM
*
*  Transforms a CSF vector to slater determinants
*
      implicit Real*8(a-h,o-z)
#include "detdim.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "cicisp_mclr.fh"
#include "Input.fh"
#include "spinfo_mclr.fh"
*
      Real*8 CSF(*),SD(*)
      Real*8, Allocatable:: CTM(:)
*

      iiCOPY=0
      iprdia=0
      nConf=Max(ncsf(is),ndtasm(iS))
      isym=iEor(is-1,State_Sym-1)+1
      i=2
      If (isym.eq.1) i=1

      If (diskbased) Then
         CALL CSDTVC_MCLR(CSF,SD,1,DTOC,CNSM(i)%ICTS,IS,iiCOPY,IPRDIA)
      Else
         Call mma_allocate(CTM,nConf,Label='CTM')
         CTM(:)=Zero
         CTM(1:ncsf(is))=CSF(1:ncsf(is))

         CALL CSDTVC_MCLR(CTM,SD,1,DTOC,CNSM(i)%ICTS,IS,iiCOPY,IPRDIA)

         Call mma_deallocate(CTM)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Francesco Aquilante                              *
*               2014, Thomas Bondo Pedersen                            *
************************************************************************
*  INV_CHO_FACTOR
*
*> @brief
*>   Evaluation of the inverse Cholesky factor (\f$ Q \f$) of a SPD matrix (\f$ A \f$)
*>   by using a modified Gram--Schmidt orthonormalization of a set
*>   of unit vectors
*> @author F. Aquilante (Nov. 2006)
*> @modified_by T.B. Pedersen (2014) Change criterion for too negative norm
*>
*> @details
*> Evaluation of the inverse Cholesky factor (\f$ Q \f$) of a SPD matrix (\f$ A \f$)
*> by using a modified Gram--Schmidt orthonormalization of a set of unit vectors \f$ V: V(i,k)=\delta_{ik} \f$):
*>
*> \code
*>   For k=1,dim(A)
*>     Qu_k = V_k - sum_j=1^k-1 (Q_j^T * A * V_k) * Q_j
*>          = V_k - sum_j=1^k-1 (Q_j^T * A_k) * Q_j
*>     Q_k = Qu_k / sqrt(Qu_k^T * A_k * Qu_k)
*> \endcode
*>
*> The result is such that the inverse of A is Cholesky decomposed as
*>
*> \f[ A^{-1} = Q Q^\text{T} \f]
*> (\f$ Q \f$ is a full-rank upper triangular matrix)
*>
*> or in general (also for rank deficient \f$ A \f$) such that
*>
*> \f[ Q^\text{T} A Q = I \f]
*>
*> The inverse Cholesky factor is in general *NOT UNIQUE!!*
*> Therefore, and for stability reason, a full pivoting of the
*> initial matrix \f$ A \f$ would be advisable.
*>
*> Worth of mention is the fact that the lower triangular
*> matrix L such that
*>
*> \f[ A = L L^\text{T} \f]
*> (Cholesky decomposition of \f$ A \f$)
*>
*> can be computed as: \f$ L = A Q \f$
*>
*> @side_effects
*> In output \p A_k is returned in a PACKED form (i.e. off-diagonal elements are
*> scaled by two); the latter is the form in which it should be stored as column of \p Am.
*> In case of detected linear dependence, the \p Q_k array is returned as zeros!
*>
*> @note
*> Triangular storage must be used for the \f$ Q \f$-matrix!
*>
*> @param[in,out] A_k    \p kCol -th column of \f$ A \f$ (min. size \p kCol)
*> @param[in]     kCol   index of the column/vector
*> @param[in]     Am     in-core part of the matrix \f$ A \f$ (triangular storage)
*> @param[in]     Qm     in-core matrix whose columns are the orthonormal vectors (triangular storage)
*> @param[in]     nMem   max number of columns of \p Qm (and also of \p Am) kept in core
*> @param[in]     lu_A   file unit where the \f$ A \f$-matrix is stored
*> @param[in]     lu_Q   file unit where the \f$ Q \f$-matrix is stored
*> @param[in]     Scr    scratch space used for reading out-of-core columns of \p Qm and \p Am
*> @param[in]     lScr   size of the scratch space (&ge; \p kCol-1 or ``0`` iff in-core)
*> @param[in]     Z      auxiliary array of min. size \p kCol (always needed)
*> @param[in]     X      auxiliary array of min. size \p kCol-1 (needed only for the out-of-core case)
*> @param[in]     thr    threshold for linear dependence
*> @param[out]    Q_k    the \p kCol -th column of \p Qm (min. size \p kCol)
*> @param[out]    lindep integer indicating detected linear dependence (= ``1`` iff found lin dep, else = ``0``)
************************************************************************
      SUBROUTINE INV_CHO_FACTOR(A_k,kCol,Am,Qm,nMem,lu_A,lu_Q,Scr,lScr,
     &                          Z,X,thr,Q_k,lindep)

      Implicit Real*8 (a-h,o-z)
      Integer kCol, nMem, lu_A, lu_Q, lScr, lindep
      Integer  incr,shft
      Real*8  A_k(*), Am(*), Qm(*), Scr(*), Z(*), X(*), Q_k(*)
      Real*8  thr
#include "para_info.fh"
#include "warnings.fh"
      Parameter ( two = 2.0d0, one = 1.0d0, zero = 0.0d0 )
      Parameter ( thr_neg = -1.0d-8 )
**********************************************************************
      incr=1
      shft=0

      If (thr .lt. zero) Then
         Call WarningMessage(2,'Error in Inv_Cho_Factor')
         write(6,*)'thr must be .ge. zero'
         Call Quit(_RC_CHO_LOG_)
      EndIf

      lindep = 0

      If (kCol .le. nMem) Then
*
*  Compute scalar product of A_k with previous vectors
*  ---------------------------------------------------
         jp=1
         Do j=1,kCol-1
            Z(j)=ddot_(j,A_k(1),1,Qm(jp),1)
            jp = jp + j
         End Do
C        Call RecPrt('A_k*Qm',' ',Z,1,kCol)
*
*  Compute unnormalized k-th vector
* ---------------------------------
C SVC: this piece of code was computing Q_k = - Qm * Z, where Q_k and Z
C are vectors of length kCol-1, and Qm is a matrix in triangular storage
C with column-wise layout:
C   |Q_k(1)     |      |Qm(1,1) Qm(1,2) ... Qm(1,kCol-1)     |   |Z(1)     |
C   |Q_k(2)     |      |        Qm(2,2) ... Qm(2,kCol-1)     |   |Z(2)     |
C   | ...       |  = - |                ...     ...          | * |...      |
C   | ...       |      |                                     |   |...      |
C   |Q_k(kCol-1)|      |                    Qm(kCol-1,kCol-1)|   |Z(kCol-1)|
C In order to improve performance, I've used the DTPMV routine from
C BLAS. For parallel processes, we will block up the triangular matrix
C and divide the blocks over the processes, using either DTPMV or DGEMV
C on the blocks (depending if it is a diagonal or off-diagonal block).

         Call FZero(Q_k,kCol-1)
#ifdef _MOLCAS_MPP_
         if (is_real_par().and.kCol.ge.500) then
C SVC: the best way would probably be to chop up the triangular matrix
C into blocks, and then call DTPMV/DGEMV on those blocks. To keep things
C simple, I've just used a series of DAXPY's on each column of the
C triangular matrix, this should be sufficient (for now).
           DO J=1+MYRANK,KCOL-1,NPROCS
             IJ=(J*(J-1))/2+1
             CALL DAXPY_(J,-Z(J),Qm(IJ),1,Q_k,1)
           END DO
           Call GAdGOp(Q_k,kCol-1,'+')
         else
           CALL DAXPY_(kCol-1,-1.0D0,Z,1,Q_k,1)
           CALL DTPMV('U','N','N',kCol-1,Qm,Q_k,1)
         end if
#else
         CALL DAXPY_(kCol-1,-1.0D0,Z,1,Q_k,1)
         CALL DTPMV('U','N','N',kCol-1,Qm,Q_k,1)
#endif
         Q_k(kCol) = one
*
*
*  Normalize k-th vector :   ||Q_k|| = Q_k^T * A * Q_k
* ----------------------------------------------------

         call dscal_(kCol-1,two,A_k(1),1) ! packing of A_k

         Z(kCol)=ddot_(kCol,A_k(1),1,Q_k(1),1) !contrib fr k-th col of A

         jp=1
         Do j=1,kCol-1 ! contrib. from previous columns of A
            Z(j)=ddot_(j,Q_k(1),1,Am(jp),1)
            jp = jp + j
         End Do

         xnorm=ddot_(kCol,Z(1),1,Q_k(1),1)

         If (xnorm.ge.thr) Then

           xnorm=one/sqrt(xnorm)
           call dscal_(kCol,xnorm,Q_k(1),1)

C-tbp: use fixed criterion for too negative diagonal
C-tbp    ElseIf (xnorm.gt.zero .or. -xnorm.le.1.0d1*thr) Then
         ElseIf (xnorm.gt.thr_neg) Then

           lindep = 1
           Call Fzero(Q_k(1),kCol)

         Else

           Call WarningMessage(2,'Error in Inv_Cho_Factor')
           write(6,*)'INV_CHO_FACTOR: too-negative value for norm(Q_k).'
           write(6,*)'INV_CHO_FACTOR: xnorm = ',xnorm
           Call Quit(_RC_CHO_RUN_)

         EndIf


*                                                                      *
************************************************************************
*                                                                      *
      Else   ! the first nMem columns of Q are in memory
*                                                                      *
************************************************************************
*                                                                      *

         If (lScr .lt. kCol-1) Then
            Call WarningMessage(2,'Error in Inv_Cho_Factor')
            write(6,*)'lScr must be .ge. kCol-1'
            Call Quit(_RC_CHO_LOG_)
         EndIf

         Call FZero(X(1),kCol-1)
*
*  Compute scalar product of A_k with in-core previous vectors
*  -----------------------------------------------------------
         jp=1
         Do j=1,nMem
            Z(j)=ddot_(j,A_k(1),1,Qm(jp),1)
            jp = jp + j
         End Do
*
*  Batch for the out-of-core previous vectors
*--------------------------------------------
         kdone = nMem
         lQcol = (kCol-1)*kCol/2 ! length up to kCol-1
         Do while ( kdone .lt. kCol-1 )

            lQdone = kdone*(kdone+1)/2
            lQdone_=lQdone
            lQread = lQcol - lQdone

            kread = kCol-1
            Do while ( lQread .gt. lScr )
              lQread = lQread - kread
              kread = kread - 1
            End Do

            Call ddafile(lu_Q,2,Scr(1),lQread,lQdone_) ! read

            jp=1
            Do j=kdone+1,kread
               Z(j)=ddot_(j,A_k(1),1,Scr(jp),1)
               jp = jp + j
            End Do
*
*  Store an out-of-core intermediate for the Q-vectors
*-----------------------------------------------------
            Do i=1,kread
              sprev=zero
              kstart = Max(i,kdone+1) ! (j.ge.i .and. j_out_of_core)
              Do j=kstart,kread
                 ij = j*(j-1)/2 + i - lQdone
                 sprev = sprev + Z(j)*Scr(ij)
              End Do
              X(i) = X(i) + sprev
            End Do

            kdone = kread

         End Do
C        Call RecPrt('A_k*Qm',' ',Z,1,kCol)
*
*  Compute unnormalized k-th vector
* ---------------------------------
         Do i=1,kCol-1
            sprev = X(i) ! out-of-core contrib.
            Do j=i,nMem
               ij = j*(j-1)/2 + i
               sprev = sprev + Z(j)*Qm(ij)
            End Do
            Q_k(i) = - sprev
         End Do
         Q_k(kCol) = one
*
*
*  Normalize k-th vector :   ||Q_k|| = Q_k^T * A * Q_k
* ----------------------------------------------------

         call dscal_(kCol-1,two,A_k(1),1) ! packing of A_k

         Z(kCol)=ddot_(kCol,A_k(1),1,Q_k(1),1) !contrib fr k-th col of A
*
*  Batch for the out-of-core previous vectors
*--------------------------------------------
         kdone = nMem
         lQcol = (kCol-1)*kCol/2 ! length up to kCol-1
         Do while ( kdone .lt. kCol-1 )

            lQdone = kdone*(kdone+1)/2
            lQread = lQcol - lQdone

            kread = kCol-1
            Do while ( lQread .gt. lScr )
              lQread = lQread - kread
              kread = kread - 1
            End Do
*
*  Out-of-core intermediate to be used for the normalization factor
*------------------------------------------------------------------
            Call ddafile(lu_A,2,Scr(1),lQread,lQdone) ! read

            jp=1
            Do j=kdone+1,kread
               Z(j)=ddot_(j,Q_k(1),1,Scr(jp),1)
               jp = jp + j
            End Do

            kdone = kread

         End Do

         jp=1
         Do j=1,nMem ! contrib. from in-core previous columns of A
            Z(j)=ddot_(j,Q_k(1),1,Am(jp),1)
            jp = jp + j
         End Do

         xnorm=ddot_(kCol,Z(1),1,Q_k(1),1)

         If (xnorm.ge.thr) Then

           xnorm=one/sqrt(xnorm)
           call dscal_(kCol,xnorm,Q_k(1),1)

C-tbp: use fixed criterion for too negative diagonal
C-tbp    ElseIf (xnorm.gt.zero .or. -xnorm.le.1.0d1*thr) Then
         ElseIf (xnorm.gt.thr_neg) Then

           lindep = 1
           Call Fzero(Q_k(1),kCol)

         Else

           Call WarningMessage(2,'Error in Inv_Cho_Factor')
           write(6,*)'INV_CHO_FACTOR: too-negative value for norm(Q_k).'
           write(6,*)'INV_CHO_FACTOR: xnorm = ',xnorm
           Call Quit(_RC_CHO_RUN_)

         EndIf


      EndIf

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine ChoMP2_fno_Org(irc,Delete,P_ab,P_ii,EOcc,EVir,Wrk,lWrk)
!
!  F. Aquilante, Geneva May 2008  (snick to Pedersen's code)

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri
use Cholesky, only: nSym, NumCho
use ChoMP2, only: ChoAlg, DecoMP2, DeMP2, iFirstS, iMatab, iOcc, iT1am, iVir, LiMatij, LnOcc, LnT1am, lUnit_F, MP2_small, nBatch, &
                  nMatab, nMP2Vec, nOcc, nT1am, nVir, shf
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
logical(kind=iwp), intent(in) :: Delete
real(kind=wp), intent(inout) :: P_ab(*), P_ii(*)
real(kind=wp), intent(in) :: EOcc(*), EVir(*)
integer(kind=iwp), intent(in) :: lWrk
real(kind=wp), intent(out) :: Wrk(lWrk)
integer(kind=iwp) :: i, i0, iAdr, iBat, iBatch, ij, iOpt, iS, iSym, iSyma, iSymb, iSymi, iSymj, iTyp, iVaJi(8), iVec, iVec0, &
                     iVec1, j, ja, jb, jBatch, kEnd0, kEnd1, kEnd2, kMabij, kOff1, kOff2, kOffi, kOffj, kOffM, kOffMM, kP(8), &
                     kVec, kVecai, kXaibj, LiT2am(8), LnT2am, lP(8), lTot, lWrk0, lWrk1, lWrk2, Nai, nBat, nEnrVec(8), NumVec, &
                     nVaJi, nVec
real(kind=wp) :: Dnom, xsDnom
character(len=*), parameter :: SecNam = 'ChoMP2_fno_Org'
real(kind=wp), external :: ddot_

irc = 0

kP(1) = 1
lP(1) = 0
do iS=2,nSym
  kP(iS) = kP(iS-1)+nVir(iS-1)**2
  lP(iS) = lP(iS-1)+nOcc(iS-1)
end do

DeMP2 = Zero

! Set number and type of vectors.
! -------------------------------

if (DecoMP2) then
  iTyp = 2
  nEnrVec(1:nSym) = nMP2Vec(1:nSym)
else
  iTyp = 1
  nEnrVec(1:nSym) = NumCho(1:nSym)
end if

if (MP2_small) then

  ! Loop over occupied orbital batches.
  ! -----------------------------------

  do iBatch=1,nBatch

    jBatch = iBatch

    call ChoMP2_Energy_GetInd(LnT2am,LiT2am,iBatch,jBatch)

    kXaibj = 1
    kEnd0 = kXaibj+LnT2am
    lWrk0 = lWrk-kEnd0+1
    if (lWrk0 < 1) call SysAbendMsg(SecNam,'insufficient memory','[0]')

    if (ChoAlg == 2) then

      kMabij = kXaibj  ! rename pointer
      Wrk(kMabij:kMabij+LnT2am-1) = Zero ! initialize

      ! Loop over Cholesky vector symmetries.
      ! -------------------------------------

      do iSym=1,nSym

        Nai = LnT1am(iSym,iBatch)
        if ((Nai > 0) .and. (nEnrVec(iSym) > 0)) then

          ! Reserve memory for reading a single vector.
          ! -------------------------------------------

          kVecai = kEnd0
          kEnd1 = kVecai+nT1am(iSym)
          lWrk1 = lWrk-kEnd1+1

          if (lWrk1 < Nai) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.1]')

          ! Set up batch over Cholesky vectors.
          ! -----------------------------------

          nVec = min(lWrk1/Nai,nEnrVec(iSym))
          if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.2]') ! should not happen
          nBat = (nEnrVec(iSym)-1)/nVec+1

          ! Open Cholesky vector files.
          ! ---------------------------

          call ChoMP2_OpenF(1,iTyp,iSym)

          ! Start vector batch loop.
          ! ------------------------

          do iBat=1,nBat

            if (iBat == nBat) then
              NumVec = nEnrVec(iSym)-nVec*(nBat-1)
            else
              NumVec = nVec
            end if
            iVec1 = nVec*(iBat-1)+1

            ! Set up index arrays for reordered vectors.
            ! ------------------------------------------

            nVaJi = 0
            do iSymi=1,nSym
              iSyma = Mul(iSymi,iSym)
              iVaJi(iSymi) = nVaJi
              nVaJi = nVaJi+nVir(iSyma)*NumVec*LnOcc(iSymi,iBatch)
            end do

            ! Pointer to reordered vectors: kVec.
            ! -----------------------------------

            kVec = kEnd1
            kEnd2 = kVec+nVaJi
            lWrk2 = lWrk-kEnd2+1
            if (lWrk2 < 0) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.3]') ! should not happen

            ! Read one vector at a time and reorder.
            ! --------------------------------------

            iVec0 = iVec1-1
            do iVec=1,NumVec

              iOpt = 2
              lTot = nT1am(iSym)
              iAdr = nT1am(iSym)*(iVec0+iVec-1)+1
              call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVecai),lTot,iAdr)

              do iSymi=1,nSym
                iSyma = Mul(iSymi,iSym)
                i0 = iFirstS(iSymi,iBatch)-1
                do i=1,LnOcc(iSymi,iBatch)
                  kOff1 = kVecai+iT1am(iSyma,iSymi)+nVir(iSyma)*(i0+i-1)
                  kOff2 = kVec+iVaJi(iSymi)+nVir(iSyma)*NumVec*(i-1)+nVir(iSyma)*(iVec-1)
                  Wrk(kOff2:kOff2+nVir(iSyma)-1) = Wrk(kOff1:kOff1+nVir(iSyma)-1)
                end do
              end do

            end do

            ! Compute M(ab,ii) .
            ! ------------------

            do iSymj=1,nSym

              iSymb = Mul(iSymj,iSym)

              if (nVir(iSymb) > 0) then

                do j=1,LnOcc(iSymj,iBatch)

                  i = j

                  ij = LiMatij(iSymj,iSymj,iBatch)+iTri(i,j)

                  kOffi = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(i-1)
                  kOffj = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(j-1)
                  kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

                  call dGeMM_('N','T',nVir(iSymb),nVir(iSymb),NumVec,One,Wrk(kOffi),nVir(iSymb),Wrk(kOffj),nVir(iSymb),One, &
                              Wrk(kOffM),nVir(iSymb))

                end do

              end if

            end do

          end do

          call Cho_GAdGOp(Wrk(kMabij),LnT2am,'+')

          ! Close Cholesky vector files.
          ! ----------------------------

          call ChoMP2_OpenF(2,iTyp,iSym)

          ! Compute energy contribution
          ! ---------------------------------------

          do iSymj=1,nSym

            iSymb = Mul(iSymj,iSym)

            if (nVir(iSymb) > 0) then

              do j=1,LnOcc(iSymj,iBatch)

                i = j

                ij = LiMatij(iSymj,iSymj,iBatch)+iTri(i,j)

                kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

                ! Compute Energy contribution
                ! -------------------------------------
                do jb=1,nVir(iSymb)
                  do ja=1,nVir(iSymb)
                    Dnom = EVir(iVir(iSymb)+ja)+EVir(iVir(iSymb)+jb)-Two*EOcc(iOcc(iSymj)+j)
                    xsDnom = Dnom/(Dnom**2+shf**2)
                    kOffMM = kOffM+nVir(iSymb)*(jb-1)+ja-1
                    !DeMP2 = DeMP2+Wrk(kOffMM)**2/Dnom
                    DeMP2 = DeMP2+Wrk(kOffMM)**2*xsDnom
                  end do
                end do

              end do

            end if

          end do

        end if

      end do ! iSym

    end if

  end do ! iBatch

  ! If requested, delete vector files.
  ! ----------------------------------

  if (Delete) then
    do iSym=1,nSym
      call ChoMP2_OpenF(1,iTyp,iSym)
      call ChoMP2_OpenF(3,iTyp,iSym)
    end do
  end if

  return

end if   !  MP2_small run

! Loop over occupied orbital batches.
! -----------------------------------

do iBatch=1,nBatch

  jBatch = iBatch

  call ChoMP2_Energy_GetInd(LnT2am,LiT2am,iBatch,jBatch)

  kXaibj = 1
  kEnd0 = kXaibj+LnT2am
  lWrk0 = lWrk-kEnd0+1
  if (lWrk0 < 1) call SysAbendMsg(SecNam,'insufficient memory','[0]')

  if (ChoAlg == 2) then

    kMabij = kXaibj  ! rename pointer
    Wrk(kMabij:kMabij+LnT2am-1) = Zero ! initialize

    ! Loop over Cholesky vector symmetries.
    ! -------------------------------------

    do iSym=1,nSym

      Nai = LnT1am(iSym,iBatch)
      if ((Nai > 0) .and. (nEnrVec(iSym) > 0)) then

        ! Reserve memory for reading a single vector.
        ! -------------------------------------------

        kVecai = kEnd0
        kEnd1 = kVecai+nT1am(iSym)
        lWrk1 = lWrk-kEnd1+1

        if (lWrk1 < Nai) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.1]')

        ! Set up batch over Cholesky vectors.
        ! -----------------------------------

        nVec = min(lWrk1/Nai,nEnrVec(iSym))
        if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.2]') ! should not happen
        nBat = (nEnrVec(iSym)-1)/nVec+1

        ! Open Cholesky vector files.
        ! ---------------------------

        call ChoMP2_OpenF(1,iTyp,iSym)

        ! Start vector batch loop.
        ! ------------------------

        do iBat=1,nBat

          if (iBat == nBat) then
            NumVec = nEnrVec(iSym)-nVec*(nBat-1)
          else
            NumVec = nVec
          end if
          iVec1 = nVec*(iBat-1)+1

          ! Set up index arrays for reordered vectors.
          ! ------------------------------------------

          nVaJi = 0
          do iSymi=1,nSym
            iSyma = Mul(iSymi,iSym)
            iVaJi(iSymi) = nVaJi
            nVaJi = nVaJi+nVir(iSyma)*NumVec*LnOcc(iSymi,iBatch)
          end do

          ! Pointer to reordered vectors: kVec.
          ! -----------------------------------

          kVec = kEnd1
          kEnd2 = kVec+nVaJi
          lWrk2 = lWrk-kEnd2+1
          if (lWrk2 < 0) call SysAbendMsg(SecNam,'Insufficient memory','[ChoAlg.2.3]') ! should not happen

          ! Read one vector at a time and reorder.
          ! --------------------------------------

          iVec0 = iVec1-1
          do iVec=1,NumVec

            iOpt = 2
            lTot = nT1am(iSym)
            iAdr = nT1am(iSym)*(iVec0+iVec-1)+1
            call ddaFile(lUnit_F(iSym,iTyp),iOpt,Wrk(kVecai),lTot,iAdr)

            do iSymi=1,nSym
              iSyma = Mul(iSymi,iSym)
              i0 = iFirstS(iSymi,iBatch)-1
              do i=1,LnOcc(iSymi,iBatch)
                kOff1 = kVecai+iT1am(iSyma,iSymi)+nVir(iSyma)*(i0+i-1)
                kOff2 = kVec+iVaJi(iSymi)+nVir(iSyma)*NumVec*(i-1)+nVir(iSyma)*(iVec-1)
                Wrk(kOff2:kOff2+nVir(iSyma)-1) = Wrk(kOff1:kOff1+nVir(iSyma)-1)
              end do
            end do

          end do

          ! Compute M(ab,ii) .
          ! ------------------

          do iSymj=1,nSym

            iSymb = Mul(iSymj,iSym)

            if (nVir(iSymb) > 0) then

              do j=1,LnOcc(iSymj,iBatch)

                i = j

                ij = LiMatij(iSymj,iSymj,iBatch)+iTri(i,j)

                kOffi = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(i-1)
                kOffj = kVec+iVaJi(iSymj)+nVir(iSymb)*NumVec*(j-1)
                kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

                call dGeMM_('N','T',nVir(iSymb),nVir(iSymb),NumVec,One,Wrk(kOffi),nVir(iSymb),Wrk(kOffj),nVir(iSymb),One, &
                            Wrk(kOffM),nVir(iSymb))

              end do

            end if

          end do

        end do

        call Cho_GAdGOp(Wrk(kMabij),LnT2am,'+')

        ! Close Cholesky vector files.
        ! ----------------------------

        call ChoMP2_OpenF(2,iTyp,iSym)

        do iSymj=1,nSym

          iSymb = Mul(iSymj,iSym)

          if (nVir(iSymb) > 0) then

            do j=1,LnOcc(iSymj,iBatch)

              i = j

              ij = LiMatij(iSymj,iSymj,iBatch)+iTri(i,j)

              kOffM = kMabij+LiT2am(1)+nMatab(1)*(ij-1)+iMatab(iSymb,iSymb)

              ! Compute T(a,b)[i] and energy contrib.
              ! -------------------------------------
              do jb=1,nVir(iSymb)
                do ja=1,nVir(iSymb)
                  Dnom = EVir(iVir(iSymb)+ja)+EVir(iVir(iSymb)+jb)-Two*EOcc(iOcc(iSymj)+j)
                  xsDnom = Dnom/(Dnom**2+shf**2)
                  kOffMM = kOffM+nVir(iSymb)*(jb-1)+ja-1
                  !DeMP2 = DeMP2+Wrk(kOffMM)**2/Dnom
                  DeMP2 = DeMP2+Wrk(kOffMM)**2*xsDnom
                  !Wrk(kOffMM) = Wrk(kOffMM)/Dnom
                  Wrk(kOffMM) = Wrk(kOffMM)*xsDnom
                end do
              end do

              P_ii(lP(iSymj)+i) = P_ii(lP(iSymj)+i)+ddot_(nVir(iSymb)**2,Wrk(kOffM),1,Wrk(kOffM),1)

              ! Compute P(a,b) += sum_c T(a,c)*T(c,b)
              ! -------------------------------------
              call dGeMM_('N','N',nVir(iSymb),nVir(iSymb),nVir(iSymb),One,Wrk(kOffM),nVir(iSymb),Wrk(kOffM),nVir(iSymb),One, &
                          P_ab(kP(iSymb)),nVir(iSymb))

            end do

          end if

        end do

      end if

    end do ! iSym

  end if

end do ! iBatch

! If requested, delete vector files.
! ----------------------------------

if (Delete) then
  do iSym=1,nSym
    call ChoMP2_OpenF(1,iTyp,iSym)
    call ChoMP2_OpenF(3,iTyp,iSym)
  end do
end if

end subroutine ChoMP2_fno_Org

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Routine to generate the transformation for the second moments.
subroutine M2Trans(Rotte,TD)

use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: Rotte(3,3)
real(kind=wp), intent(out) :: TD(6,6)

! The transformation of x2.

TD(1,1) = Rotte(1,1)*Rotte(1,1)
TD(2,1) = Rotte(1,1)*Rotte(2,1)
TD(3,1) = Rotte(1,1)*Rotte(3,1)
TD(4,1) = Rotte(2,1)*Rotte(2,1)
TD(5,1) = Rotte(2,1)*Rotte(3,1)
TD(6,1) = Rotte(3,1)*Rotte(3,1)

! The transformation of xy.

TD(1,2) = Rotte(1,1)*Rotte(1,2)+Rotte(1,2)*Rotte(1,1)
TD(2,2) = Rotte(1,1)*Rotte(2,2)+Rotte(1,2)*Rotte(2,1)
TD(3,2) = Rotte(1,1)*Rotte(3,2)+Rotte(1,2)*Rotte(3,1)
TD(4,2) = Rotte(2,1)*Rotte(2,2)+Rotte(2,2)*Rotte(2,1)
TD(5,2) = Rotte(2,1)*Rotte(3,2)+Rotte(2,2)*Rotte(3,1)
TD(6,2) = Rotte(3,1)*Rotte(3,2)+Rotte(3,2)*Rotte(3,1)

! The transformation of xz.

TD(1,3) = Rotte(1,1)*Rotte(1,3)+Rotte(1,3)*Rotte(1,1)
TD(2,3) = Rotte(1,1)*Rotte(2,3)+Rotte(1,3)*Rotte(2,1)
TD(3,3) = Rotte(1,1)*Rotte(3,3)+Rotte(1,3)*Rotte(3,1)
TD(4,3) = Rotte(2,1)*Rotte(2,3)+Rotte(2,3)*Rotte(2,1)
TD(5,3) = Rotte(2,1)*Rotte(3,3)+Rotte(2,3)*Rotte(3,1)
TD(6,3) = Rotte(3,1)*Rotte(3,3)+Rotte(3,3)*Rotte(3,1)

! The transformation of y2.

TD(1,4) = Rotte(1,2)*Rotte(1,2)
TD(2,4) = Rotte(1,2)*Rotte(2,2)
TD(3,4) = Rotte(1,2)*Rotte(3,2)
TD(4,4) = Rotte(2,2)*Rotte(2,2)
TD(5,4) = Rotte(2,2)*Rotte(3,2)
TD(6,4) = Rotte(3,2)*Rotte(3,2)

! The transformation of yz.

TD(1,5) = Rotte(1,2)*Rotte(1,3)+Rotte(1,3)*Rotte(1,2)
TD(2,5) = Rotte(1,2)*Rotte(2,3)+Rotte(1,3)*Rotte(2,2)
TD(3,5) = Rotte(1,2)*Rotte(3,3)+Rotte(1,3)*Rotte(3,2)
TD(4,5) = Rotte(2,2)*Rotte(2,3)+Rotte(2,3)*Rotte(2,2)
TD(5,5) = Rotte(2,2)*Rotte(3,3)+Rotte(2,3)*Rotte(3,2)
TD(6,5) = Rotte(3,2)*Rotte(3,3)+Rotte(3,3)*Rotte(3,2)

! The transformation of z2.

TD(1,6) = Rotte(1,3)*Rotte(1,3)
TD(2,6) = Rotte(1,3)*Rotte(2,3)
TD(3,6) = Rotte(1,3)*Rotte(3,3)
TD(4,6) = Rotte(2,3)*Rotte(2,3)
TD(5,6) = Rotte(2,3)*Rotte(3,3)
TD(6,6) = Rotte(3,3)*Rotte(3,3)

return

end subroutine M2Trans

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!               1993, Per Boussard                                     *
!***********************************************************************

subroutine M1Grd( &
#                define _CALLING_
#                include "grd_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of the M1 integrals used  *
!         ECP calculations. The operator is the nuclear attraction     *
!         operator times a s-type gaussian function.                   *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
!             Physics, University of Stockholm, Sweden, October '93.   *
!                                                                      *
!             Modified to gradients, December '93 (RL).                *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Index_Functions, only: nTri_Elem1
use Constants, only: One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: i, iAlpha, ianga(4), iBeta, iCar, iCmp, iDAO, iDCRT(0:7), iIrrep, iM1xp, ip, ipA, ipAOff, ipB, ipBOff, ipDAO, &
                     ipDAOt, ipK, ipPx, ipPy, ipPz, iPrint, ipZ, ipZI, iRout, iuvwx(4), iZeta, j, JndGrd(3,4), kCnt, kCnttp, kdc, &
                     lDCRT, LmbdT, lOp(4), mGrad, nArray, nDAO, nDCRT, nDisp, nRys
real(kind=wp) :: C(3), Coora(3,4), CoorAC(3,2), Coori(3,4), Fac, Fact, Gmma, PTC2, TC(3), Tmp0, Tmp1
logical(kind=iwp) :: EQ, JfGrad(3,4)
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: TF
external :: TNAI1, Fake, Cff2D
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"

#include "macros.fh"
unused_var(ZInv)
unused_var(rFinal)
unused_var(Ccoor(1))
unused_var(nOrdOp)
unused_var(nComp)

iRout = 193
iPrint = nPrint(iRout)

nRys = nHer

if (iPrint >= 49) then
  call RecPrt(' In M1Grd: A',' ',A,1,3)
  call RecPrt(' In M1Grd: RB',' ',RB,1,3)
  call RecPrt(' In M1Grd: P',' ',P,nZeta,3)
  write(u6,*) ' In M1Grd: la,lb=',' ',la,lb
end if

! Allocate Scratch for primitives and work area for HRR

ip = 1
ipA = ip
ip = ip+nZeta
ipB = ip
ip = ip+nZeta
ipDAO = ip
ip = ip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)
ipK = ip
ip = ip+nZeta
ipZ = ip
ip = ip+nZeta
ipZI = ip
ip = ip+nZeta
ipPx = ip
ip = ip+nZeta
ipPy = ip
ip = ip+nZeta
ipPz = ip
ip = ip+nZeta
if (ip-1 > nArr*nZeta) then
  write(u6,*) ' ip-1 > nArr*nZeta (M1 section)'
  write(u6,*) ' nArr,nZeta=',nArr,nZeta
  call Abend()
end if
nArray = nArr*nZeta-ip+1

iIrrep = 0
iAnga(1) = la
iAnga(2) = lb
iAnga(3) = 0
iAnga(4) = 0
Coora(:,1) = A(:)
Coora(:,2) = RB(:)
if (la >= lb) then
  CoorAC(:,1) = A(:)
else
  CoorAC(:,1) = RB(:)
end if
iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
lOp(1) = kOp(1)
lOp(2) = kOp(2)

ipAOff = ipA
do iBeta=1,nBeta
  call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB
do iAlpha=1,nAlpha
  call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
  ipBOff = ipBOff+1
end do

! Loop over nuclear centers.

kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (.not. dbsc(kCnttp)%ECP) cycle
  if (dbsc(kCnttp)%nM1 == 0) cycle
  do kCnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    iuvwx(3) = dc(kdc+kCnt)%nStab
    iuvwx(4) = dc(kdc+kCnt)%nStab

    do lDCRT=0,nDCRT-1
      lOp(3) = NrOpr(iDCRT(lDCRT))
      lOp(4) = lOp(3)
      call OA(iDCRT(lDCRT),C,TC)
      ! Branch out if one-center integral
      if (EQ(A,RB) .and. EQ(A,TC)) cycle
      if (iPrint >= 99) call RecPrt(' In M1Grd: TC',' ',TC,1,3)
      Coora(:,1) = A(:)
      Coora(:,2) = RB(:)
      Coori(:,1:2) = Coora(:,1:2)
      if ((.not. EQ(A,RB)) .or. (.not. EQ(A,TC))) then
        Coori(1,1) = Coori(1,1)+One
        !Coora(1,1) = Coora(1,1)+One
      end if
      CoorAC(:,2) = TC(:)
      Coori(:,3) = TC(:)
      Coori(:,4) = TC(:)
      Coora(:,3:4) = Coori(:,3:4)

      do iM1xp=1,dbsc(kCnttp)%nM1
        Gmma = dbsc(kCnttp)%M1xp(iM1xp)

        JndGrd(:,1:2) = IndGrd(:,:)
        do i=1,3
          do j=1,2
            JfGrad(i,j) = IfGrad(i,j)
          end do
        end do

        ! Derivatives with respect to the operator is computed
        ! via the translational invariance.
        ! Some extra care is needed here due to that Rys2Dg will
        ! try to avoid some of the work.

        nDisp = IndDsp(kdc+kCnt,iIrrep)
        do iCar=0,2
          ! No direct assembly of contribution from the operat.
          JfGrad(iCar+1,3) = .false.
          JndGrd(iCar+1,3) = 0
          iCmp = 2**iCar
          if (TF(kdc+kCnt,iIrrep,iCmp) .and. (.not. dbsc(kCnttp)%pChrg)) then
            ! Displacement is symmetric
            nDisp = nDisp+1
            if (Direct(nDisp)) then
              ! Reset flags for the basis set centers so that
              ! we will explicitly compute the derivatives
              ! with respect to those centers. Activate flag
              ! for the third center so that its derivative
              ! will be computed by the translational
              ! invariance.
              JfGrad(iCar+1,1) = .true.
              JfGrad(iCar+1,2) = .true.
              if ((A(iCar+1) /= TC(iCar+1)) .and. (RB(iCar+1) /= TC(iCar+1))) then
                ! Three center case
                JndGrd(iCar+1,1) = abs(JndGrd(iCar+1,1))
                JndGrd(iCar+1,2) = abs(JndGrd(iCar+1,2))
                JndGrd(iCar+1,3) = -nDisp
                JfGrad(iCar+1,1) = .true.
                JfGrad(iCar+1,2) = .true.
              else if ((A(iCar+1) == TC(iCar+1)) .and. (RB(iCar+1) /= TC(iCar+1))) then
                ! Two center case
                JndGrd(iCar+1,1) = -abs(JndGrd(iCar+1,1))
                JndGrd(iCar+1,2) = abs(JndGrd(iCar+1,2))
                JfGrad(iCar+1,1) = .false.
                JfGrad(iCar+1,2) = .true.
              else if ((A(iCar+1) /= TC(iCar+1)) .and. (RB(iCar+1) == TC(iCar+1))) then
                ! Two center case
                JndGrd(iCar+1,1) = abs(JndGrd(iCar+1,1))
                JndGrd(iCar+1,2) = -abs(JndGrd(iCar+1,2))
                JfGrad(iCar+1,1) = .true.
                JfGrad(iCar+1,2) = .false.
              else
                ! One center case
                JndGrd(iCar+1,1) = 0
                JndGrd(iCar+1,2) = 0
                JfGrad(iCar+1,1) = .false.
                JfGrad(iCar+1,2) = .false.
              end if
            end if
          end if
        end do
        ! No derivatives with respect to the fourth center.
        JndGrd(:,4) = 0
        JfGrad(1,4) = .false.
        JfGrad(2,4) = .false.
        JfGrad(3,4) = .false.
        mGrad = 0
        do iCar=1,3
          do i=1,2
            if (JfGrad(iCar,i)) mGrad = mGrad+1
          end do
        end do
        if (iPrint >= 99) write(u6,*) ' mGrad=',mGrad
        if (mGrad == 0) cycle

        ! Modify the original basis. Observe that
        ! simplification due to A=B are not valid for the
        ! exponent index, eq. P-A=/=0.

        do iZeta=1,nZeta
          PTC2 = (P(iZeta,1)-TC(1))**2+(P(iZeta,2)-TC(2))**2+(P(iZeta,3)-TC(3))**2
          Tmp0 = Zeta(iZeta)+Gmma
          Tmp1 = exp(-Zeta(iZeta)*Gmma*PTC2/Tmp0)
          Array(ipK+iZeta-1) = rKappa(iZeta)*Tmp1
          Array(ipZ+iZeta-1) = Tmp0
          Array(ipZI+iZeta-1) = One/Tmp0
          Array(ipPx+iZeta-1) = (Zeta(iZeta)*P(iZeta,1)+Gmma*TC(1))/Tmp0
          Array(ipPy+iZeta-1) = (Zeta(iZeta)*P(iZeta,2)+Gmma*TC(2))/Tmp0
          Array(ipPz+iZeta-1) = (Zeta(iZeta)*P(iZeta,3)+Gmma*TC(3))/Tmp0
        end do

        ! Modify the density matrix with the prefactor

        Fact = -dbsc(kCnttp)%Charge*dbsc(kCnttp)%M1cf(iM1xp)*(real(nStabM,kind=wp)/real(LmbdT,kind=wp))*Two*Pi
        nDAO = nTri_Elem1(la)*nTri_Elem1(lb)
        do iDAO=1,nDAO
          do iZeta=1,nZeta
            Fac = Fact*Array(ipK+iZeta-1)*Array(ipZI+iZeta-1)
            ipDAOt = nZeta*(iDAO-1)+iZeta-1+ipDAO
            Array(ipDAOt) = Fac*DAO(iZeta,iDAO)
          end do
        end do
        if (iPrint >= 99) then
          write(u6,*) ' Charge=',dbsc(kCnttp)%Charge
          write(u6,*) ' Fact=',Fact
          write(u6,*) ' IndGrd=',IndGrd
          write(u6,*) ' JndGrd=',JndGrd
          call RecPrt('DAO*Fact',' ',Array(ipDAO),nZeta,nDAO)
        end if

        ! Compute integrals with the Rys quadrature.

        call Rysg1(iAnga,nRys,nZeta,Array(ipA),Array(ipB),[One],[One],Array(ipZ),Array(ipZI),nZeta,[One],[One],1,Array(ipPx), &
                   nZeta,TC,1,Coori,Coora,CoorAC,Array(ip),nArray,TNAI1,Fake,Cff2D,Array(ipDAO),nDAO,Grad,nGrad,JfGrad,JndGrd, &
                   lOp,iuvwx)

      end do
    end do
  end do
end do

return

end subroutine M1Grd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CRYSTALFIELD( ESOJ, DIPSO, S_SO, nDIMcf,
     &                         iDIM, nlanth, zmagn2, iopt, GRAD, iprint)

      Implicit None
#include "stdalloc.fh"
      Integer, Parameter            :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)           :: iprint, iDIM
      Integer, intent(in)           :: nDIMcf, iopt, nlanth
      Real(kind=8), intent(in)     :: ESOJ(nDIMcf)
      Real(kind=8), intent(in)     :: ZMAGN2(3,3)
      Complex(kind=8), intent(in)  :: DIPSO(3,nDIMcf,nDIMcf)
      Complex(kind=8), intent(in)  ::  S_SO(3,nDIMcf,nDIMcf)
      Logical, intent(in)           :: GRAD
      ! local variables
      Integer :: info
      Real(kind=8), allocatable :: wtmp(:)
      Complex(kind=8), allocatable ::  DIPJ(:,:,:)
      Complex(kind=8), allocatable ::    SJ(:,:,:), ztmp(:,:)
      Integer                       :: i,j
      Real(kind=8), allocatable    :: gtens(:), zmagn(:,:)


      Write(6,'(/)')
      Write(6,'(100A)') ('%',i=1,95)
      If(MOD(nDIMcf,2).eq.1) Then
        Write(6,'(5x,A,I2,A)') 'CALCULATION OF CRYSTAL-FIELD '//
     &                         'PARAMETERS OF THE GROUND ATOMIC '//
     &                         'MULTIPLET J = ', (nDIMcf-1)/2, '.'
      Else
        Write(6,'(5x,A,I2,A)') 'CALCULATION OF CRYSTAL-FIELD '//
     &                         'PARAMETERS OF THE GROUND ATOMIC '//
     &                         'MULTIPLET J = ', (nDIMcf-1),'/2.'
      End If
      Write(6,'(100A)') ('%',i=1,95)
      Write(6,*)


      Call mma_allocate(gtens,3,'gtens')
      Call mma_allocate(zmagn,3,3,'zmagn')
      Call dcopy_(  3,[0.0_wp],0,gtens,1)
      Call dcopy_(3*3,[0.0_wp],0,zmagn,1)
      If(iopt.eq.1) Then
c  coordinate system for decomposition of the CF matrix identic to the coordinate system
c  of the main magnetic axes of the ground multiplet (NDIM(1))
        CALL atens(DIPSO(1:3,1:idim,1:idim), idim, GTENS, ZMAGN, 1)
        Write(6,'(a)') 'The parameters of the Crystal Field matrix '//
     &                 'are written in the coordinate system:'
        If(MOD(iDIM,2).eq.0) Then
          Write(6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic '//
     &                        'axes of the ground pseuDospin S = |',
     &                        iDIM-1,'/2> multiplet.'
        Else
          Write(6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic '//
     &                        'axes of the ground pseuDospin S = |',
     &                       (iDIM-1)/2,'> multiplet.'
        End If

      Else If(iopt.eq.2) Then
c  coordinate system for decomposition of the CF matrix identic to the coordinate system
c  of the main magnetic axes of the ground multiplet (NDIM(1))
        CALL atens(DIPSO, nDIMCF, GTENS, ZMAGN, 1)
        Write(6,'(a)') 'The parameters of the Crystal Field matrix '//
     &                 'are written in the coordinate system:'
        If(MOD(nDIMCF,2).eq.0) Then
          Write(6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic '//
     &                        'axes of the ground atomic J = |',
     &                         nDIMCF-1,'/2> multiplet'
        Else
          Write(6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic '//
     &                        'axes of the ground atomic J = |',
     &                        (nDIMCF-1)/2,'> multiplet'
        End If

      Else If(iopt.eq.3) Then
        Write(6,'(a)') 'The parameters of the Crystal Field matrix '//
     &                 'are written in the coordinate system:'
        Write(6,'(a)') '(Xm, Ym, Zm) -- defined in the input file.'
        Call dcopy_(3*3,zmagn2,1,zmagn,1)
      Else
        Write(6,'(a)') 'The parameters of the Crystal Field matrix '//
     &                 'are written in the initial coordinate system.'
        Do i=1,3
          ZMAGN(i,i)=1.0_wp
        End Do
      End If !axisoption


      ! rotate the momentum:
      Call mma_allocate(DIPJ,3,nDIMcf,nDIMcf,'DIPJ')
      Call mma_allocate(SJ,3,nDIMcf,nDIMcf,'SJ')
      Call zcopy_(3*nDIMcf*nDIMcf,[(0.0_wp,0.0_wp)],0,DIPJ,1)
      Call zcopy_(3*nDIMcf*nDIMcf,[(0.0_wp,0.0_wp)],0,  SJ,1)
      CALL rotmom2( DIPSO, nDIMCF, ZMAGN, DIPJ )
      CALL rotmom2(  S_SO, nDIMCF, ZMAGN,   SJ )

      Write(6,'(a)') 'Rotation matrix from the initial coordinate '//
     &               'system to the employed coordinate system is:'

      If((iopt.eq.1).OR.(iopt.eq.2)) Then
        Write(6,'(70a)') ('-',i=1,67),'|'
        Write(6,'(A,31x,A)') 'x , y , z  -- initial Cartesian axes','|'
        Write(6,'(A,35x,A)') 'Xm, Ym, Zm -- main magnetic axes','|'
        Write(6,'(4x,3(17x,a),9x,a)') 'x','y','z','|'
        Write(6,'(6x,A,3F18.14,1x,A)') '| Xm |',(ZMAGN(j,1),j=1,3),'|'
        Write(6,'( A,A,3F18.14,1x,A)') ' R =  ','| Ym |',
     &                                 (ZMAGN(j,2),j=1,3),'|'
        Write(6,'(6x,A,3F18.14,1x,A)') '| Zm |',(ZMAGN(j,3),j=1,3),'|'
        Write(6,'(83a)') ('-',i=1,67),'|'
        Write(6,'(A,I3)') 'Quantization axis is Zm.'

      Else If(iopt.eq.3) Then

        Write(6,'(70a)') ('-',i=1,67),'|'
        Write(6,'(A,31x,A)') 'x , y , z  -- initial Cartesian axes','|'
        Write(6,'(A,11x,A)') 'Xm, Ym, Zm -- the coordinate system '//
     &                       'defined in the input','|'
        Write(6,'(4x,3(17x,a),9x,a)') 'x','y','z','|'
        Write(6,'(6x,A,3F18.14,1x,A)') '| Xm |',(ZMAGN(j,1),j=1,3),'|'
        Write(6,'( A,A,3F18.14,1x,A)') ' R =  ','| Ym |',
     &   (ZMAGN(j,2),j=1,3),'|'
        Write(6,'(6x,A,3F18.14,1x,A)') '| Zm |',(ZMAGN(j,3),j=1,3),'|'
        Write(6,'(83a)') ('-',i=1,67),'|'
        Write(6,'(A,I3)') 'Quantization axis is Zm.'

      Else

        Write(6,'(A)') 'IDENTITY matrix.'
        Write(6,'(A,I3)') 'Quantization axis is the initial z axis.'
      End If

      If(IPRINT.gt.2) Then
        CALL prMom('CRYSTALFIELD::   DIPJ(l,i,j)',DIPJ,nDIMcf)
        CALL prMom('CRYSTALFIELD::     SJ(l,i,j)',  SJ,nDIMcf)
      End If

      Call mma_allocate(ztmp,nDIMcf,nDIMcf,'z')
      Call mma_allocate(wtmp,nDIMcf,'w')
      wtmp(:)=0.0_wp
      ztmp(:,:)=(0.0_wp,0.0_wp)
      info=0
      Call diag_c2(DIPJ,nDIMcf,info,wtmp,ztmp)
      Do i=1,nDIMcf
        Write(6,'(A,i2,A,4F20.15)') 'energy: ',i,' : ',
     &             wtmp(i), wtmp(i)+wtmp(nDIMcf-i+1)
      End Do
      Call mma_deallocate(ztmp)
      Call mma_deallocate(wtmp)

      CALL CRYSTALFIELD_1(nDIMcf,nlanth,DIPJ,ESOJ,GRAD,iprint)


      Call mma_deallocate(DIPJ)
      Call mma_deallocate(SJ)
      Call mma_deallocate(gtens)
      Call mma_deallocate(zmagn)
      Return
      End



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      Subroutine CRYSTALFIELD_1(nDIMcf,nlanth,MM,ESOJ,GRAD,iprint)

C This soubrutine calculates the crystal field parameters on the basis
C of the given fron RASSI - J multiplet.
c In a second step, the first largest 27 parameters will be used to
c recalculate the S-O energies, eigenfunctions, g- and D- tensors.

c  Employed parameters:


C  IPRINT = the print level of the calculation


C  IReturn = the error value.
c        0 = no error, happy landing

C================== Variable declarations =============================

      Implicit None
#include "stdalloc.fh"
      Integer, Parameter            :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)           :: nDIMcf, nlanth, iprint
      Logical, intent(in)           :: GRAD
      Real(kind=8), intent(in)     :: ESOJ(nDIMcf)
      Complex(kind=8), intent(in)  :: MM(3,nDIMcf,nDIMcf)
      ! local variables:
      Integer                       :: info, i, j, k, q
      Integer                       :: LuCF, IsFreeUnit
      Real(kind=8)                 :: dznrm2
      Real(kind=8), allocatable    :: Winit(:), Eloc(:), a(:)
      Real(kind=8)                 :: BNC(nDIMcf,0:nDIMcf)
      Real(kind=8)                 :: BNS(nDIMcf,0:nDIMcf)
      Real(kind=8)                 :: Bstev(nDIMcf,-nDIMcf:nDIMcf)
      Complex(kind=8)              :: trace
      Complex(kind=8)              ::
     &                   Akq((nDIMcf-1),-(nDIMcf-1):(nDIMcf-1))
      Complex(kind=8), allocatable :: Zinit(:,:), Z(:,:),
     &                                  HCF(:,:)
      External           :: trace, dznrm2, IsFreeUnit

C============== End of variable declarations ==========================
      Call mma_allocate(Winit,nDIMcf,'Winit')
      Call mma_allocate(Eloc,nDIMcf,'Eloc')
      Call mma_allocate(a,6,'anm')
      Call mma_allocate(Zinit,nDIMcf,nDIMcf,'Zinit')
      Call mma_allocate(Z,nDIMcf,nDIMcf,'Z')
      Call mma_allocate(HCF,nDIMcf,nDIMcf,'HCF')

      info=0
      Call dcopy_(nDIMcf,[0.0_wp],0,Winit,1)
      Call dcopy_(nDIMcf,[0.0_wp],0,Eloc,1)
      Call dcopy_(6,[0.0_wp],0,A,1)
      Call zcopy_(nDIMcf*nDIMcf,[(0.0_wp,0.0_wp)],0,Zinit,1)
      Call zcopy_(nDIMcf*nDIMcf,[(0.0_wp,0.0_wp)],0,Z,1)
      Call zcopy_(nDIMcf*nDIMcf,[(0.0_wp,0.0_wp)],0,HCF,1)

      ! find the J-pseudospin:
      !iDir=3
      CALL pseudospin(MM,nDIMcf,Z,3,1,iprint)
      CALL rtrace(nDIMcf,ESOJ,ELOC)
      ! re-write the CF matrix in J-pseudospin basis:
      ! energy units =  cm-1
      Do i=1,nDIMcf
        Do j=1,nDIMcf
          Do k=1,nDIMcf
            HCF(i,j)=HCF(i,j) + ELOC(k)*CONJG(Z(k,i))*Z(k,j)
          End Do
        End Do
      End Do
      ! diagonalize the initial CF matrix:
      CALL DIAG_C2( HCF,nDIMcf,INFO,Winit,Zinit)
      Call print_ZFS('Ab Initio Calculated Crystal-Field Splitting '//
     &               'Matrix written in the basis of Pseudospin '//
     &               'Eigenfunctions',HCF,nDIMCF)

      If(IPRINT.gt.2) Then
        Write(6,*)
        Write(6,'(5X,A)') 'MAIN VALUES OF THE INITIAL CRYSTAL'//
     &                    '-FIELD HAMILTONIAN:'
        Write(6,*)
        If(MOD(nDIMcf,2).eq.1) Then
          Do I=1,nDIMcf
            Write(6,'(3X,A,I3,A,F25.16)') '|',
     &                     (nDIMcf-1)/2+(1-I),'> = ',Winit(I)-Winit(1)
          End Do
        Else
          Do I=1,nDIMcf
            Write(6,'(3X,A,I3,A,F25.16)') '|',
     &                  (nDIMcf-1)-2*(I-1),'/2 > = ',Winit(i)-Winit(1)
          End Do
        End If
        Write(6,*)

        Write(6,'(5X,A)') 'EIGENVECTORS OF THE INITIAL CRYSTAL'//
     &                    '-FIELD HAMILTONIAN:'
        Write(6,*)
        Call print_ZFS_naoya('J',Zinit,nDIMcf)
!     End  the checking of the main values of the initial crystal-field
      End If

C  calculating the coeficients of the crystal filed operators Bnm
C    Akq=(2k+1)/(2J+1) * 1/|< J || O || J >|^2 * Trace{HCF*O(k,-q)}
      Call NEWCF(HCF,nDIMcf,Akq,BNC,BNS,Bstev)
      !If(dbg) Call recover_CF(nDIMCF,HCF,Akq,BNC,BNS,Bstev)

      Call print_CFP_alpha(nlanth,nDIMCF,BNC,BNS)
      If(iprint>=4) Then
         Call print_CFP_LCLU(nDIMCF,BNC,BNS,.true.)
         Call print_CFP_stev(nDIMCF,Bstev,.true.)
         Call print_CFP_naoya(nDIMcf,Akq,.true.)
      Else
         Call print_CFP_LCLU(nDIMCF,BNC,BNS,.false.)
         Call print_CFP_stev(nDIMCF,Bstev,.false.)
         Call print_CFP_naoya(nDIMcf,Akq,.false.)
      End If

c-----------------------------------------------------------------------
      Write(6,'(/)')
      If(MOD(nDIMcf,2)==1) Then
         Write(6,'(A,I0)') 'DECOMPOSITION OF THE RASSI WAVE '//
     &                     'FUNCTIONS CORRESPONDING TO THE '//
     &                     'LOWEST ATOMIC MULTIPLET J =',(nDIMcf-1)/2
         Write(6,'(A,I0)') 'IN WAVE FUNCTIONS WITH DEFINITE '//
     &                     'PROJECTION OF THE TOTAL MOMENT '//
     &                     'ON THE QUANTIZATION AXIS'
      Else ! MOD(nDIMcf,2)==0
         Write(6,'(A,I0,A)') 'DECOMPOSITION OF THE RASSI WAVE '//
     &                       'FUNCTIONS CORRESPONDING TO THE '//
     &                       'LOWEST ATOMIC MULTIPLET J = ',
     &                         (nDIMcf-1),'/2'
         Write(6,'(A,I0)') 'IN WAVE FUNCTIONS WITH DEFINITE '//
     &                     'PROJECTION OF THE TOTAL MOMENT '//
     &                     'ON THE QUANTIZATION AXIS'
      End If

      Call print_ZFS_naoya('J',Zinit,nDIMcf)
      Call individual_ranks(nDIMCF,BNC,BNS,HCF,'J',iprint)
c-----------------------------------------------------------------------
C  saving some information for tests:
      CALL Add_Info('CRYS_BNMC_20',[DBLE(BNC(2,0))],1,4)
      CALL Add_Info('CRYS_BNMC_40',[DBLE(BNC(4,0))],1,4)
      CALL Add_Info('CRYS_BNMC_60',[DBLE(BNC(6,0))],1,4)
c-----------------------------------------------------------------------
      ! for the interface related to CF gradient calculation:
      If (GRAD) Then
         LuCF=IsFreeUnit(81)
         Call molcas_open(LuCF,'CFMAT')
         Do k=2,nDIMcf-1,2
           Do q=0,k
               Write(LuCF,'(I3,I3,1x,2ES25.15)') k,q,BNC(k,q),BNS(k,q)
           End Do
         End Do
         Close(LuCF)
      End If
c-----------------------------------------------------------------------
      Call mma_deallocate(Winit)
      Call mma_deallocate(Eloc)
      Call mma_deallocate(a)
      Call mma_deallocate(Zinit)
      Call mma_deallocate(Z)
      Call mma_deallocate(HCF)

      Return
      End









      Subroutine newCF(H,n,A, B,C,Bstev)
      Implicit none
      Integer, Parameter          :: wp=selected_real_kind(p=15,r=307)
#include "stdalloc.fh"
      Integer, intent(in)           :: n
      Complex(kind=8),intent(in)   :: H(n,n)
      Complex(kind=8), intent(out) :: A( (n-1), -(n-1):(n-1) )
      Real(kind=8), intent(out)    :: B(n,0:n), C(n,0:n)
      Real(kind=8), intent(out)    :: Bstev(n,-n:n)
      ! local variables:
      Integer                       :: ik,iq
      Real(kind=8)                 :: rfact,cr,mfact,C0
      Complex(kind=8)              :: trace, cfact
      Complex(kind=8), allocatable :: Cp(:,:), Cm(:,:)
      Complex(kind=8)              :: mf
      Real(kind=8)                 :: knm(12,0:12)
      External                      :: trace
      Logical                       :: dbg

!-------------------------------------------
      If(n<1) Return
!-------------------------------------------
      dbg=.false.
      Call mma_allocate(Cp,n,n,'operator O')
      Call mma_allocate(Cm,n,n,'operator W')
!-------------------------------------------
!     n=2*J+1;  or   n=2*S+1
      Bstev(1:n,-n:n)=0.0_wp
      B(1:n,0:n)=0.0_wp
      C(1:n,0:n)=0.0_wp
      A(1:(n-1),-(n-1):(n-1))=(0.0_wp,0.0_wp)
      Call set_knm( knm )

      Do ik=1,n-1
         Do iq=0,ik
            cr=0.0_wp
            mfact=0.0_wp
            rfact=0.0_wp
            cfact=(0.0_wp,0.0_wp)
            C0=0.0_wp
            ! generate the operator matrix K=ik, Q=iq, dimension = n
            Call ITO(n,ik,iq,C0,Cp,Cm)
            Call coeff_redus_sub(n,ik,cr)

            mfact=dble((-1)**iq)
            rfact=C0*C0*dble(2*ik+1)/dble(n)
            cfact=cmplx(mfact*rfact,0.0_wp,wp)


            !-------------------------------------------
            ! Naoya's C/C0 operators:
            a(ik,-iq)=cfact*trace(n,H,Cp)
            a(ik, iq)=cfact*trace(n,H,Cm)


            !-------------------------------------------
            ! make real combinations of CF parameters:
            ! Liviu's ITO operators:
            If(iq==0) Then
               !b(ik, iq)=dble( (0.5_wp,0.0_wp)*(A(ik,iq)+A(ik,-iq)) )
               b(ik, iq)=dble(A(ik,iq))
            Else
               mf=cmplx((-1)**iq,0.0_wp,wp)
               b(ik, iq)=dble( A(ik,-iq)+mf*A(ik,iq))
               c(ik, iq)=dble((A(ik,-iq)-mf*A(ik,iq))*(0.0_wp,-1.0_wp))
            End If
            ! scale with the correct ratio:
            b(ik,iq)=b(ik,iq)/(cr*C0)
            c(ik,iq)=c(ik,iq)/(cr*C0)


            !-------------------------------------------
            ! parameters to be used in connection with ESO as in MATLAB
            ! EasySpin program
            ! The ESO operaors are not implemented for k>12 in EasySpin
            ! therefore we do not provide these parameters as well.
            If((ik<=12).and.(iq<=12)) Then
               ! scale with the correct ratio:
               If(iq==0) Then
                  bstev(ik, iq)=b(ik,iq)*knm(ik,iq)
               Else
                  bstev(ik, iq)=b(ik,iq)*knm(ik,iq)
                  bstev(ik,-iq)=c(ik,iq)*knm(ik,iq)
               End If
            End If

            If(dbg) Then
               Write(6,'(A,2I3,5(ES20.13,1x))') 'k,q, b(k,q), c(k,q)',
     &                                      ik,iq, b(ik,iq), c(ik,iq)
            End If
         End Do
      End Do

      Call mma_deallocate(Cp)
      Call mma_deallocate(Cm)

      Return
      End subroutine newCF







      Subroutine recover_CF(N,HAM,Akq,B,C,Bstev)
      Implicit none
      Integer, Parameter           :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in)          :: n
      Complex(kind=8), intent(in) :: HAM(n,n)
      Complex(kind=8), intent(in) :: Akq((n-1), -(n-1):(n-1))
      Real(kind=8), intent(in)    :: B(n,0:n), C(n,0:n), Bstev(n,-n:n)

      Integer          :: k,q,i,j,info
      Real(kind=8)    :: tdiff
      Complex(kind=8) :: Cp(n,n), Cm(n,n), redME
      Complex(kind=8) :: O(n,n), W(n,n),zfact
      Complex(kind=8) :: HCF(n,n), Z(n,n)
      Real(kind=8)    :: w1(n), w2(n),c0,dznrm2_
      External         :: dznrm2_

      Do k=2,n-1
        Do q=-k,k
          Write(6,'(A,i2,A,i3,A,2ES20.10)') 'Akq(',k,',',q,') = ',
     &                                       Akq(k,q)
        End Do
      End Do
!==================================================================
      Write(6,'(A,ES20.10)') 'recover from Akq parameters'
      tdiff=0.0_wp
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,HCF,1)
      Do k=1,n-1
        Do q=0,k
          ! generate the operator matrix K=ik, Q=iq, dimension=na
          Call ITO(n,k,q,C0,Cp,Cm)
          If(q==0) Then
            Call zaxpy_(n*n, Akq(k, q), Cp, 1, HCF,1)
          Else
            Call zaxpy_(n*n, Akq(k, q), Cp, 1, HCF,1)
            Call zaxpy_(n*n, Akq(k,-q), Cm, 1, HCF,1)
          End If
        End Do !q
      End Do !k
      tdiff=dznrm2_(n*n,HAM-HCF,1)
      Write(6,'(A,ES20.10)') 'total difference between HAM-HCF=',tdiff
      Do i=1,n
        Do j=1,n
          Write(6, '(2(A,i2,A,i2,A,2ES20.10,A),2(2ES20.10,5x))')
     &                'HAM(',i,',',j,')=',HAM(i,j),'      ',
     &                'HCF(',i,',',j,')=',HCF(i,j),' diff=',
     &                 HAM(i,j)-HCF(i,j)
        End Do
      End Do
      w1(:)=0.0_wp
      Z(:,:)=(0.0_wp,0.0_wp)
      Call diag_c2(HAM,n,info,w1,Z)
      w2(:)=0.0_wp
      Z(:,:)=(0.0_wp,0.0_wp)
      Call diag_c2(HCF,n,info,w2,Z)
      Do i=1,n
         Write(6,'(2(A,i2,A,ES20.10,A),2(2ES20.10,5x))')
     &                'W1(',i,')=',w1(i)-w1(1),'      ',
     &                'W2(',i,')=',w2(i)-w2(1),' diff=',
     &                 w1(i)-w2(i)
      End Do

!==================================================================
      Write(6,'(A,ES20.10)') 'recover from B and C parameters'
      tdiff=0.0_wp
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,HCF,1)
      Do k=1,n-1
        Do q=0,k
          Call Liviu_ESO(n,k,q,O,W,redME)
          If(q==0) Then
            zfact=cmplx(B(k,0),0.0_wp,wp)
            Call zaxpy_(n*n, zfact, O, 1,  HCF,1)
          Else
            zfact=cmplx(B(k,q),0.0_wp,wp)
            Call zaxpy_(n*n,zfact,O,1,HCF,1)
            zfact=cmplx(C(k,q),0.0_wp,wp)
            Call zaxpy_(n*n,zfact,W,1,HCF,1)
          End If
        End Do
      End Do
      tdiff=dznrm2_(n*n,(HAM(1:n,1:n)-HCF(1:n,1:n)),1)
      Write(6,'(A,ES20.10)') 'total difference between HAM-HCF=',tdiff
      Do i=1,n
        Do j=1,n
          Write(6, '(2(A,i2,A,i2,A,2ES20.10,A),2(2ES20.10,5x))')
     &                'HAM(',i,',',j,')=',HAM(i,j),'      ',
     &                'HCF(',i,',',j,')=',HCF(i,j),' diff=',
     &                 HAM(i,j)-HCF(i,j)
        End Do
      End Do
      w1(:)=0.0_wp
      Z(:,:)=(0.0_wp,0.0_wp)
      Call diag_c2(HAM,n,info,w1,Z)
      w2(:)=0.0_wp
      Z(:,:)=(0.0_wp,0.0_wp)
      Call diag_c2(HCF,n,info,w2,Z)
      Do i=1,n
         Write(6,'(2(A,i2,A,ES20.10,A),2(2ES20.10,5x))')
     &                'W1(',i,')=',w1(i)-w1(1),'      ',
     &                'W2(',i,')=',w2(i)-w2(1),' diff=',
     &                 w1(i)-w2(i)
      End Do

!==================================================================
      Write(6,'(A,ES20.10)') 'recover from Bstev'
      tdiff=0.0_wp
      Call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,HCF,1)
      Do k=1,n-1
        Do q=0,k
          Call ESO(n,k,q,O,W,redME)
          If(q==0) Then
            zfact=cmplx(Bstev(k,0),0.0_wp,wp)
            Call zaxpy_(n*n, zfact, O, 1,  HCF,1)
          Else
            zfact=cmplx(Bstev(k, q),0.0_wp,wp)
            Call zaxpy_(n*n,zfact,O,1,HCF,1)
            zfact=cmplx(Bstev(k,-q),0.0_wp,wp)
            Call zaxpy_(n*n,zfact,W,1,HCF,1)
          End If
        End Do
      End Do
      tdiff=dznrm2_(n*n,(HAM(1:n,1:n)-HCF(1:n,1:n)),1)
      Write(6,'(A,ES20.10)') 'total difference between HAM-HCF=',tdiff
      Do i=1,n
        Do j=1,n
          Write(6, '(2(A,i2,A,i2,A,2ES20.10,A),2(2ES20.10,5x))')
     &                'HAM(',i,',',j,')=',HAM(i,j),'      ',
     &                'HCF(',i,',',j,')=',HCF(i,j),' diff=',
     &                 HAM(i,j)-HCF(i,j)
        End Do
      End Do
      w1(:)=0.0_wp
      Z(:,:)=(0.0_wp,0.0_wp)
      Call diag_c2(HAM,n,info,w1,Z)
      w2(:)=0.0_wp
      Z(:,:)=(0.0_wp,0.0_wp)
      Call diag_c2(HCF,n,info,w2,Z)
      Do i=1,n
         Write(6,'(2(A,i2,A,ES20.10,A),2(2ES20.10,5x))')
     &                'W1(',i,')=',w1(i)-w1(1),'      ',
     &                'W2(',i,')=',w2(i)-w2(1),' diff=',
     &                 w1(i)-w2(i)
      End Do
!==================================================================

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

subroutine NwShft()
!***********************************************************************
!                                                                      *
! Object: to numerically evaluate the molecular Hessian.               *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             May '92                                                  *
!***********************************************************************

use Slapaf_Info, only: Delta, iter, qInt, Shift
use Constants, only: Zero, Two
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nInter
integer(kind=iwp) :: iCount, jCount, jInter, kCount, kInter, lInter

nInter = size(Shift,1)

# ifdef _DEBUGPRINT_
call RecPrt('NwShft  qInt',' ',qInt,nInter,iter)
call RecPrt('NwShft Shift',' ',Shift,nInter,iter-1)
# endif

! Compute the new shift

!write(u6,*) ' iter=',iter
if (iter < 2*nInter+1) then

  ! Shifts for the numerical Hessian

  jInter = (iter+1)/2
  Shift(:,iter) = Zero
  if (mod(iter,2) == 0) then
    Shift(jInter,iter) = -Two*Delta
  else
    ! Undo previous displacement
    if (jInter > 1) Shift(jInter-1,iter) = Delta
    Shift(jInter,iter) = Delta
  end if

else

  ! Shifts for the numerical cubic force constants

  iCount = (iter-2*nInter+3)/4
  !write(u6,*) ' iCount=',iCount
  jCount = 0
  lInter = 0
  outer: do kInter=1,nInter
    do lInter=1,kInter-1
      jCount = jCount+1
      if (jCount == iCount) exit outer
    end do
  end do outer
  if (lInter == 0) then
    call WarningMessage(2,'lInter == 0')
    call Abend()
  end if
  !write(u6,*) 'kInter, lInter=',kInter,lInter
  kCount = iter-2*nInter
  Shift(:,iter) = Zero
  ! Undo last change for numerical Hessian
  if (iCount == 1) Shift(nInter,iter) = Delta
  if (mod(kCount,4) == 1) then
    ! Undo change due to previous pair
    if (lInter /= 1) then
      Shift(kInter,iter) = Delta
      Shift(lInter-1,iter) = Delta
    else if ((lInter == 1) .and. (kInter /= 2)) then
      Shift(kInter-1,iter) = Delta
      Shift(kInter-2,iter) = Delta
    end if
    ! +d,+d
    !write(u6,*) ' +d,+d'
    Shift(kInter,iter) = Shift(kInter,iter)+Delta
    Shift(lInter,iter) = Shift(lInter,iter)+Delta
  else if (mod(kCount,4) == 2) then
    ! -d,+d
    !write(u6,*) ' -d,+d'
    Shift(kInter,iter) = -Two*Delta
    Shift(lInter,iter) = Zero
  else if (mod(kCount,4) == 3) then
    ! +d,-d
    !write(u6,*) ' +d,-d'
    Shift(kInter,iter) = Two*Delta
    Shift(lInter,iter) = -Two*Delta
  else if (mod(kCount,4) == 0) then
    ! -d,-d
    !write(u6,*) ' -d,-d'
    Shift(kInter,iter) = -Two*Delta
    Shift(lInter,iter) = Zero
  end if
end if

! Compute the new parameter set.
qInt(:,iter+1) = qInt(:,iter)+Shift(:,iter)

# ifdef _DEBUGPRINT_
call RecPrt('  qInt',' ',qInt,nInter,iter+1)
call RecPrt(' Shift',' ',Shift,nInter,iter)
# endif

end subroutine NwShft

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Init2()
      use Slapaf_Info, only: Cx, Gx, Gx0, NAC, Coor, Grd,
     &                       Energy, Energy0, DipM, qInt, dqInt,
     &                       RefGeo, Get_Slapaf
      use Slapaf_Parameters, only: MaxItr, mTROld, lOld_Implicit,
     &                             TwoRunFiles, iter
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
      Logical Is_Roots_Set
      Real*8, Allocatable:: MMGrd(:,:), Tmp(:), DMs(:,:)
#include "SysDef.fh"
* Beijing Test
      Logical Exist_2,lMMGrd, Found
      Real*8 Columbus_Energy(2)
************ columbus interface ****************************************
      Integer Columbus
*
*                                                                      *
************************************************************************
*                                                                      *
*     Dummy-add the TS and saddle constraints, so that the arrays have
*     a large enough size, these constraints will be actually added or
*     not later on.
*
      Call Merge_Constraints('UDC','TSC','purge.Udc',mLambda,iDummy)
      Call Merge_Constraints('purge.Udc','UDC.Saddle','purge.Udc',
     &                       mLambda,iDummy)
*                                                                      *
************************************************************************
*                                                                      *
*
*     Get some basic information from the runfile.
*
      Call Get_Slapaf(iter, MaxItr, mTROld, lOld_Implicit,SIZE(Coor,2),
     &                mLambda)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*---  Pick up information from previous iterations
*
*                                                                      *
************************************************************************
*                                                                      *
      If (iter/=1) Then
*                                                                      *
************************************************************************
*                                                                      *
         Call qpg_dArray('qInt',Found,nqInt)
         If (Found) Then
            nQQ=nqInt/MaxItr
            Call mma_allocate( qInt,nQQ,MaxItr,Label= 'qInt')
            Call mma_allocate(dqInt,nQQ,MaxItr,Label='dqInt')
            Call Get_dArray( 'qInt', qInt,nQQ*MaxItr)
            Call Get_dArray('dqInt',dqInt,nQQ*MaxItr)
         End If
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Save coordinates and gradients from this iteration onto the list.
*
      Cx(:,:,iter)=Coor(:,:)
      Gx(:,:,iter)=Grd(:,:)

      If (iter.gt.1) Then
        Temp=Zero
        Do i = 1, SIZE(Coor,2)
           Do j = 1, 3
              Temp=Max(Temp,Abs(Cx(j,i,iter)-Cx(j,i,iter-1)))
           End Do
           If (Temp.gt.Zero) Exit
        End Do
        If (Temp.eq.Zero) Then
          Call WarningMessage(2,'Error in Init2')
          Write (6,*)
          Write (6,*) '****************** ERROR *********************'
          Write (6,*) 'Coordinates did not change!'
          Write (6,*) 'Maybe SEWARD is not inside the loop?'
          Write (6,*) '**********************************************'
          Call Quit_OnUserError()
        End If
      End If

* In case of a QM/MM geometry optimization, all the old MM gradients are
* replaced by the new one (both gradients are stored on the Runfile).
*
      Call Qpg_dArray('MM Grad',lMMGrd,6*SIZE(Coor,2))
      lMMGrd = .False.
      If (lMMGrd) Then
         Call mma_allocate(MMGrd,3*SIZE(Coor,2),2,Label='MMGrd')
         Call Get_dArray('MM Grad',MMGrd,3*SIZE(Coor,2)*2)
         Do iN = 1, iter-1
            Write(6,*) 'Grad at iteration :',iN
            Call RecPrt('Old:',' ',Gx(:,:,iN),3,SIZE(Coor,2))
            Call DaXpY_(3*SIZE(Coor,2),-One,MMGrd(:,1),1,Gx(:,:,iN),  1)
            Call DaXpY_(3*SIZE(Coor,2), One,MMGrd(:,2),1,Gx(:,:,iN),  1)
            Call RecPrt('New:',' ',Gx(1,1,iN),3,SIZE(Coor,2))
         End Do
         Call mma_deallocate(MMGrd)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Pick up the reference structure from input or the run file.
*
      If (Iter.eq.1) Then
*
*        Check if reference structure is defined by Gateway/Seward
*        for the Saddle approach to find a TS.

         Call qpg_dArray('Ref_Geom',Found,nData)
         If (Found) Then
            If (.Not.Allocated(RefGeo)) Then
               Call mma_allocate(RefGeo,3,SIZE(Coor,2),Label='RefGeo')
            End If
            Call Get_dArray('Ref_Geom',RefGeo,3*SIZE(Coor,2))
         Else
*
*           Not defined: default reference structure to the starting
*           structure.
*
            If (.Not.Allocated(RefGeo)) Then
               Call mma_allocate(RefGeo,3,SIZE(Coor,2),Label='RefGeo')
            End If
            RefGeo(:,:)=Cx(:,:,1)
            Call Put_dArray('Ref_Geom',RefGeo,3*SIZE(Coor,2))
         End If
      Else
*
*        Pick up the reference structure.
*
         If (.Not.Allocated(RefGeo)) Then
            Call mma_allocate(RefGeo,3,SIZE(Coor,2),Label='RefGeo')
         End If
         Call Get_dArray('Ref_Geom',RefGeo,3*SIZE(Coor,2))
      End If
*
*     Align the reference structure to the current one, otherwise
*     measuring distances does not make much sense
*
*     (disabled for the moment, moving the reference affects the
*      computation of some vectors for MEP)
C     If (iter.gt.1) Call Align(RefGeo,Coor,SIZE(Coor,2))
C     Call RecPrt('Ref_Geom',' ',RefGeo,3,SIZE(Coor,2))
*                                                                      *
************************************************************************
*                                                                      *
*...  Get the energy of the last iteration
*
*     Check if we are running in C&M mode.
*
      Call Get_iScalar('Columbus',columbus)
*
      If (Columbus.eq.1) Then
         Call Get_dArray('MR-CISD energy',Columbus_Energy,2)
         Energy(iter)=Columbus_Energy(1)
      Else
         Is_Roots_Set = .False.
         Call Qpg_iScalar('Number of roots',Is_Roots_Set)
         nRoots = 1
         If (Is_Roots_Set) Then
            Call Get_iScalar('Number of roots',nRoots)
         End If
*        Write (6,*) 'Runfile'
*        Write (6,*) 'nRoots=',nRoots
         If (nRoots.ne.1) Then
            Call Get_iScalar('NumGradRoot',iRoot)
*           Write (6,*) 'iRoot=',iRoot
            Call mma_allocate(Tmp,nRoots,Label='Tmp')
            Call Get_dArray('Last energies',Tmp,nRoots)
*           Call RecPrt('Last Energies',' ',Tmp,1,nRoots)
            Energy(iter)=Tmp(iRoot)
            Call mma_deallocate(Tmp)
         Else
            Call Get_dScalar('Last energy',Energy(iter))
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************ columbus interface ****************************************
*                                                                      *
*     The dipole moment is required for numerical differentiation.
*     Currently it is not written to the RUNFILE if we are in C&M mode.
*
      If (columbus.eq.1) Then
      Else
         Is_Roots_Set = .False.
         Call Qpg_iScalar('Number of roots',Is_Roots_Set)
         nRoots = 1
         If (Is_Roots_Set) Then
            Call Get_iScalar('Number of roots',nRoots)
         End If
         If (nRoots.ne.1) Then
            Call Get_iScalar('NumGradRoot',iRoot)
*           Write (6,*) 'iRoot=',iRoot
            Call mma_allocate(DMs,3,nRoots,Label='DMs')
            DMs(:,:)=Zero
            Call Qpg_dArray('Last Dipole Moments',Found,nDip)
            If (Found.and.(nDip.eq.3*nRoots)) Then
               Call Get_dArray('Last Dipole Moments',DMs,3*nRoots)
            End If
            Call dCopy_(3,DMs(:,iRoot),1,DipM(:,iter),1)
            Call mma_deallocate(DMs)
         Else
            Call Qpg_dArray('Dipole moment',Found,nDip)
            If (Found.and.(nDip.eq.3)) Then
               Call Get_dArray('Dipole moment',DipM(:,iter),3)
            Else
               DipM(:,iter)=Zero
            End If
         End If
*        Call RecPrt('Dipole Moment',' ',DipM(:,iter),1,3)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Test if this is a case of an intersection calculation. Depending
*     on if we are running the calculation in M or C&M mode this is
*     done in a bit different way.
*
      If (Columbus.eq.1) Then
*
*        C&M mode
*
         Call Get_iScalar('ColGradMode',iMode)
         If (iMode.eq.2.or.iMode.eq.3) Then
*
            E0=Columbus_Energy(2)
            Energy0(iter)=E0
*
            Call qpg_dArray('Grad State2',Found,Length)
            If (.not.Found .or. Length.eq.0) Then
               Call SysAbendmsg('Get_Molecule','Did not find:',
     &                          'Grad State2')
            End If
            Call Get_dArray('Grad State2',Gx0(1,1,iter),Length)
            Gx0(:,:,iter) = -Gx0(:,:,iter)
*
         End If
         If (iMode.eq.3) Then
            Call mma_allocate(NAC,3,Length/3,Label='NAC')
            Call Get_dArray('NADC',NAC,Length)
         End If
*
      Else
*
*     M mode
*
         Call f_Inquire('RUNFILE2',Exist_2)
         If (Exist_2) Then
            Call NameRun('RUNFILE2')
*
            Is_Roots_Set = .False.
            Call Qpg_iScalar('Number of roots',Is_Roots_Set)
            nRoots = 1
            If (Is_Roots_Set) Then
               Call Get_iScalar('Number of roots',nRoots)
            End If

*           Write (6,*) 'Runfile2'
*           Write (6,*) 'nRoots=',nRoots
            If (nRoots.ne.1) Then
               Call Get_iScalar('NumGradRoot',iRoot)
C              Write (6,*) 'iRoot=',iRoot
               Call mma_allocate(Tmp,nRoots,Label='Tmp')
               Call Get_dArray('Last energies',Tmp,nRoots)
*              Call RecPrt('Last Energies',' ',Tmp,1,nRoots)
               E0=Tmp(iRoot)
               Call mma_deallocate(Tmp)
            Else
               Call Get_dScalar('Last energy',E0)
            End If
            Energy0(iter)=E0
*
            nGrad=3*SIZE(Coor,2)
            Call Get_Grad(Gx0(1,1,iter),nGrad)
            Gx0(:,:,iter) = -Gx0(:,:,iter)
*
            Call NameRun('RUNFILE')
            TwoRunFiles = .True.
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Value_l=20.0D0
      Call Qpg_dScalar('Value_l',Found)
      If (.Not.Found) Call Put_dScalar('Value_l',Value_l)

*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine NAPrm(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &                 Final,nZeta,nComp,la,lb,A,RB,nRys,
     &                 Array,nArr,CCoor,nOrdOp)
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of nuclear attraction     *
*         integrals.                                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, January 1991                            *
************************************************************************
      use Basis_Info
      Implicit Real*8 (A-H,O-Z)
*     Used for normal nuclear attraction integrals
      External TNAI, Fake, XCff2D, XRys2D
*     Used for finite nuclei
      External TERI, ModU2, vCff2D, vRys2D
#include "real.fh"
#include "oneswi.fh"
#include "print.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp),
     &       Zeta(nZeta), ZInv(nZeta), Alpha(nAlpha), Beta(nBeta),
     &       rKappa(nZeta), P(nZeta,3), A(3), RB(3), CCoor(3,2),
     &       Array(nZeta*nArr)
*-----Local arrys
      Real*8 C(3), Coora(3,4), Coori(3,4), CoorAC(3,2)
      Logical EQ, NoSpecial
      Integer iAnga(4)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      iRout = 151
      iPrint = nPrint(iRout)
*
      Call FZero(Final,nZeta*nElem(la)*nElem(lb)*nComp)
*
      lc=0
      ld=0
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = lc
      iAnga(4) = ld
      call dcopy_(3,A,1,Coora(1,1),1)
      call dcopy_(3,RB,1,Coora(1,2),1)
      call dcopy_(2*3,Coora,1,Coori,1)
      mabMin = nabSz(Max(la,lb)-1)+1
      mabMax = nabSz(la+lb)
      If (EQ(A,RB)) mabMin=nabSz(la+lb-1)+1
*
*     Compute FLOPs and size of work array which Hrr will use.
*
      Call mHrr(la,lb,nFLOP,nMem)
*
*     Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
       call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
       call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
*     Modify Zeta if the two-electron code will be used!
*
      If (Nuclear_Model.eq.Gaussian_Type .or.
     &    Nuclear_Model.eq.mGaussian_Type) Then
         Do iZeta = 1, nZeta
            rKappa(iZeta)=rKappa(iZeta)*(TwoP54/Zeta(iZeta))
         End Do
      End If
*
      iCnttp = INT(CCoor(1,2))
      Q_Nuc=dbsc(iCnttp)%Charge

      If (Q_Nuc.eq.Zero) Go To 111
      call dcopy_(3,CCoor,1,C,1)
      If (iPrint.ge.99) Call RecPrt('C',' ',C,1,3)
*
      Call DCopy_(3,C,1,CoorAC(1,2),1)
      Call DCopy_(3,C,1,Coori(1,3),1)
      Call DCopy_(3,C,1,Coori(1,4),1)
      Call DCopy_(3,C,1,Coora(1,3),1)
      Call DCopy_(3,C,1,Coora(1,4),1)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute integrals with the Rys quadrature.
*                                                                      *
************************************************************************
*                                                                      *
      nT = nZeta
*                                                                      *
************************************************************************
*                                                                      *
      If (Nuclear_Model.eq.Gaussian_Type) Then
*
*        Gaussian nuclear charge distribution
*
         NoSpecial=.False.
         Eta=dbsc(iCnttp)%ExpNuc
         EInv=One/Eta
         rKappcd=TwoP54/Eta
*        Tag on the normalization
         rKappcd=rKappcd*(Eta/Pi)**(Three/Two)
*        s-type function
         mcdMin=0
         mcdMax=0
         Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &            [Eta],[EInv],1,P,nZeta,
     &            C,1,rKappa,[rKappcd],Coori,Coora,CoorAC,
     &            mabmin,mabmax,mcdMin,mcdMax,
     &            Array,nArr*nZeta,
     &            TERI,ModU2,vCff2D,vRys2D,NoSpecial)
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Nuclear_Model.eq.mGaussian_Type) Then
*
*        Modified Gaussian nuclear charge distribution
*
         NoSpecial=.False.
         Eta=dbsc(iCnttp)%ExpNuc
         EInv=One/Eta
         rKappcd=TwoP54/Eta
*        Tag on the normalization
         rKappcd=rKappcd*(Eta/Pi)**(Three/Two)
     &          /(One+Three*dbsc(iCnttp)%w_mGauss/(Two*Eta))
*        s type function
         mcdMin=0
         mcdMax=0
         Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &            [Eta],[EInv],1,P,nZeta,
     &            C,1,rKappa,[rKappcd],Coori,Coora,CoorAC,
     &            mabmin,mabmax,mcdMin,mcdMax,
     &            Array,nArr*nZeta,
     &            TERI,ModU2,vCff2D,vRys2D,NoSpecial)
*
*        d type function w*(x**2+y**2+z**2)
         If (dbsc(iCnttp)%w_mGauss.gt.0.0D0) Then
            rKappcd = rKappcd*dbsc(iCnttp)%w_mGauss
            iAnga(3)=2
            mcdMin=nabSz(2+ld-1)+1
            mcdMax = nabSz(2+ld)
*           tweak the pointers
            ipOff = 1 + nZeta * (la+1)*(la+2)/2
     &            * (lb+1)*(lb+2)/2
            mArr = nArr - (la+1)*(la+2)/2*(lb+1)*(lb+2)/2
            Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &               [Eta],[EInv],1,P,nZeta,
     &               C,1,rKappa,[rKappcd],Coori,Coora,CoorAC,
     &               mabMin,mabMax,mcdMin,mcdMax,
     &               Array(ipOff),mArr*nZeta,
     &               TERI,ModU2,vCff2D,vRys2D,NoSpecial)
            iAnga(3)=0
*
*           Add the s and d contributions together!
*
            Call Assemble_mGauss(Array,Array(ipOff),
     &                           nZeta*(mabMax-mabMin+1))
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Nuclear_Model.eq.Point_Charge) Then
*
*        Point-like nuclear charge distribution
*
         NoSpecial=.True.
         Eta=One
         EInv=One
         rKappcd=One
         mcdMin=0
         mcdMax=0
         Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &            [Eta],[EInv],1,P,nZeta,
     &            C,1,rKappa,[rKappcd],Coori,Coora,CoorAC,
     &            mabMin,mabMax,mcdMin,mcdMax,
     &            Array,nArr*nZeta,
     &            TNAI,Fake,XCff2D,XRys2D,NoSpecial)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Use the HRR to compute the required primitive integrals.
*
      Call HRR(la,lb,A,RB,Array,nZeta,nMem,ipIn)
*
      Call DCopy_(nZeta*nElem(la)*nElem(lb)*nComp,Array(ipIn),1,Final,1)
      Call DScal_(nZeta*nElem(la)*nElem(lb)*nComp,-Q_Nuc,Final,1)
*
 111  Continue
*
      If (Nuclear_Model.eq.Gaussian_Type .or.
     &    Nuclear_Model.eq.mGaussian_Type) Then
         Do iZeta = 1, nZeta
            rKappa(iZeta)=rKappa(iZeta)/(TwoP54/Zeta(iZeta))
         End Do
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_integer(nRys)
         Call Unused_integer(nOrdOp)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Tra2c(i,iSym,iBas,iAsh,
     &                 j,jSym,jBas,jAsh,
     &                 kl_Bas_pairs,ij_Orb_pairs,
     &                 CMO_i,CMO_j,IJKL,C,TUKL)
      Real*8 CMO_i(iBas,iAsh), CMO_j(jBas,jAsh),
     &       C(ij_Orb_pairs), IJKL(kl_Bas_pairs),
     &       TUKL(kl_Bas_pairs,ij_Orb_pairs)
*
*     Call RecPrt('IJKL',' ',IJKL,1,kl_Bas_Pairs)
*
      If (iSym.eq.jSym.and.i.ne.j) Then
         ijA = 0
         Do iA = 1, iAsh
            Do jA = 1, iA
               ijA = ijA + 1
               C(ijA)=CMO_i(i,iA)*CMO_i(j,jA)
     &               +CMO_i(j,iA)*CMO_i(i,jA)
            End Do
         End Do
*        Call TriPrt('C',' ',C,iAsh)
      ElseIf (iSym.eq.jSym) Then
         ijA = 0
         Do iA = 1, iAsh
            Do jA = 1, iA
               ijA = ijA + 1
               C(ijA)=CMO_i(i,iA)*CMO_i(i,jA)
            End Do
         End Do
*        Call TriPrt('C',' ',C,iAsh)
      Else
         ijA = 0
         Do iA = 1, iAsh
            Do jA = 1, jAsh
               ijA = ijA + 1
               C(ijA)=CMO_i(i,iA)*CMO_j(j,jA)
            End Do
         End Do
*        Call RecPrt('C',' ',C,jAsh,iAsh)
      End If
*     Write(6,*) ' ij_Orb_Pairs=',ij_Orb_Pairs
*
      Call DNaXpY(ij_Orb_pairs,kl_Bas_pairs,
     &            C,1,
     &            IJKL,1,0,
     &            TUKL,1,kl_Bas_pairs)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

function Gamma2(m,T)
!***********************************************************************
!                                                                      *
! Object: to compute the auxiliary function in the high argument       *
!         approximation.                                               *
!                                                                      *
!***********************************************************************

use Constants, only: Two, Half, Pi
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: Gamma2
integer(kind=iwp), intent(in) :: m
real(kind=wp) :: T
integer(kind=iwp) :: i

Gamma2 = Half*sqrt(Pi/T)
do i=1,m
  Gamma2 = (real(2*i-1,kind=wp)/(Two*T))*Gamma2
end do

return

end function Gamma2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine LovMP2_putInf(mSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,X,Y,isFNO)
! Purpose: put info in MP2 common blocks.

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mSym, lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
real(kind=wp), intent(in) :: X(*), Y(*)
logical(kind=iwp), intent(in) :: isFNO
integer(kind=iwp) :: iSym
integer(kind=iwp), external :: ip_of_Work
#include "corbinf.fh"
#include "chomp2_cfg.fh"

nSym = mSym

do iSym=1,nSym
  nOrb(iSym) = lnOrb(iSym)
  nOcc(iSym) = lnOcc(iSym)
  nFro(iSym) = lnFro(iSym)
  nDel(iSym) = lnDel(iSym)
  nExt(iSym) = lnVir(iSym)
end do

ChoAlg = 2
DecoMP2 = Decom_Def
ThrMP2 = -huge(ThrMP2)
SpanMP2 = Span_Def
MxQualMP2 = MxQual_Def
ChkDecoMP2 = .false.
ForceBatch = .false.
Verbose = .false.
SOS_mp2 = .false.
set_cd_thr = .true.
OED_Thr = 1.0e-8_wp
C_os = 1.3_wp
EOSMP2 = Zero

DoFNO = isFNO
ip_Dab = ip_of_Work(X(1))
ip_Dii = ip_of_Work(Y(1))
l_Dab = nExt(1)
l_Dii = nOcc(1)
do iSym=2,nSym
  l_Dab = l_Dab+nExt(iSym)**2
  l_Dii = l_Dii+nOcc(iSym)
end do

return

end subroutine LovMP2_putInf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine DmpOne()
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Print the TOC of the one electron integral file                  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher                                                  *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use OneDat, only: AuxOne, pALbl, pAtom, pBas, pChrge, pCoC, pCoM, pCoord, pEnd, pFID, pIndex, pNext, pOp, pOption, pPot, pSym, &
                  pSymOp, pTitle, pType, pVersN, TocOne
use Definitions, only: u6

implicit none

!----------------------------------------------------------------------*
! Start                                                                *
!----------------------------------------------------------------------*
write(u6,*)
write(u6,*) ' Auxiliary info on the ONEINT file'
write(u6,*) ' ---------------------------------'
write(u6,*)
write(u6,*) ' AuxOne%Lu =',AuxOne%Lu
write(u6,*) ' AuxOne%Opn=',AuxOne%Opn
write(u6,*)
write(u6,*) ' TOC of the ONEINT file'
write(u6,*) ' ----------------------'
write(u6,*)
write(u6,*) ' pFID   =',pFID,' TocOne(pFID)   =',TocOne(pFID)
write(u6,*) ' pVersN =',pVersN,' TocOne(pVersN) =',TocOne(pVersN)
write(u6,*) ' pTitle =',pTitle,' TocOne(pTitle) =',TocOne(pTitle)
write(u6,*) ' pOp    =',pOp,' TocOne(pOp)    =',TocOne(pOp)
write(u6,*) ' pSym   =',pSym,' TocOne(pSym)   =',TocOne(pSym)
write(u6,*) ' pSymOp =',pSymOp,' TocOne(pSymOp) =',TocOne(pSymOp)
write(u6,*) ' pBas   =',pBas,' TocOne(pBas)   =',TocOne(pBas)
write(u6,*) ' pAtom  =',pAtom,' TocOne(pAtom)  =',TocOne(pAtom)
write(u6,*) ' pCoord =',pCoord,' TocOne(pCoord) =',TocOne(pCoord)
write(u6,*) ' pPot   =',pPot,' TocOne(pPot)   =',TocOne(pPot)
write(u6,*) ' pCoM   =',pCoM,' TocOne(pCoM)   =',TocOne(pCoM)
write(u6,*) ' pCoC   =',pCoC,' TocOne(pCoC)   =',TocOne(pCoC)
write(u6,*) ' pALbl  =',pALbl,' TocOne(pALbl)  =',TocOne(pALbl)
write(u6,*) ' pType  =',pType,' TocOne(pType)  =',TocOne(pType)
write(u6,*) ' pChrge =',pChrge,' TocOne(pChrge) =',TocOne(pChrge)
write(u6,*) ' pIndex =',pIndex,' TocOne(pIndex) =',TocOne(pIndex)
write(u6,*) ' pNext  =',pNext,' TocOne(pNext)  =',TocOne(pNext)
write(u6,*) ' pOption=',pOption,' TocOne(pOption)=',TocOne(pOption)
write(u6,*) ' pEnd   =',pEnd,' TocOne(pEnd)   =',TocOne(pEnd)
write(u6,*)

!----------------------------------------------------------------------*
! Terminate                                                            *
!----------------------------------------------------------------------*
return

end subroutine DmpOne

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE HEFVAL(IST,JST,DVALUE)
      IMPLICIT NONE
C Apart from input call parameters, we need two vectors stored on
C LUSOLV. Vector nr IVECC (presently=2) contains the contravariant
C elements of the solution to the CASPT2 equations.
C IVECW is the number (presently=6) of the vector on LUSOLV
C where a contravariant representation of the CASPT2 Right-Hand Side
C vector is stored. This depends on the MOs used, but is actually
C the same for all the root states.

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "SysDef.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
#include "pt2_guga.fh"

      INTEGER IST,JST
      REAL*8 DVALUE

      INTEGER I
      INTEGER NTG1,NTG2,NTG3,LTG1,LTG2,LTG3
      INTEGER IDCI,LCI1,LCI2
      REAL*8 OVL,DUMMY(1)

C We evaluate the effective Hamiltonian matrix element in two steps.

      NTG1=NASHT**2
      NTG2=NASHT**4
      NTG3=(NTG1*(NTG1+1)*(NTG1+2))/6
C Note: Need proper allocation even if unused, sinced allocated
C arrays are in subroutine parameter lists of MKTG3, HCOUP.
      NTG1=MAX(1,NTG1)
      NTG2=MAX(1,NTG2)
      NTG3=MAX(1,NTG3)
      CALL GETMEM('TG1','ALLO','REAL',LTG1,NTG1)
      CALL GETMEM('TG2','ALLO','REAL',LTG2,NTG2)
      CALL GETMEM('TG3','ALLO','REAL',LTG3,NTG3)
      WORK(LTG1)=0.0D0
      WORK(LTG2)=0.0D0
      WORK(LTG3)=0.0D0

      CALL GETMEM('MCCI1','ALLO','REAL',LCI1,MXCI)
      CALL GETMEM('MCCI2','ALLO','REAL',LCI2,MXCI)
      IF(ISCF.EQ.0) THEN
C Read root vectors nr. IST and JST from LUCI.
        IDCI=IDTCEX
        DO I=1,NSTATE
          IF(I.EQ.IST) THEN
            CALL DDAFILE(LUCIEX,2,WORK(LCI1),NCONF,IDCI)
            IF(I.EQ.JST) THEN
              CALL DCOPY_(NCONF,WORK(LCI1),1,WORK(LCI2),1)
            END IF
          ELSE IF(I.EQ.JST) THEN
            CALL DDAFILE(LUCIEX,2,WORK(LCI2),NCONF,IDCI)
          ELSE
            CALL DDAFILE(LUCIEX,0,DUMMY,NCONF,IDCI)
          END IF
        END DO
      END IF

      CALL MKTG3(LSYM,LSYM,WORK(LCI1),WORK(LCI2),OVL,
     &           WORK(LTG1),WORK(LTG2),NTG3,WORK(LTG3))
      CALL GETMEM('MCCI1','FREE','REAL',LCI1,MXCI)
      CALL GETMEM('MCCI2','FREE','REAL',LCI2,MXCI)

      CALL HCOUP(IVECW,IVECC,OVL,WORK(LTG1),WORK(LTG2),
     &           WORK(LTG3),DVALUE)

      CALL GETMEM('TG1','FREE','REAL',LTG1,NTG1)
      CALL GETMEM('TG2','FREE','REAL',LTG2,NTG2)
      CALL GETMEM('TG3','FREE','REAL',LTG3,NTG3)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*  MemMan
*
*> @brief
*>   Handle calls for memory from LUCIA, by passing the either to ::GETMEM or to the MEMMAN_LUCIA routine
*>
*> @param[out]    ipOut Position
*> @param[in]     Ln_   Length
*> @param[in]     Oper  ``MARK`` / ``ADDL`` / ``ADDS`` / ``FLUSM`` / ``FREE``
*> @param[in]     ir    ``1`` / ``2``
*> @param[in,out] Label Arbitrary
************************************************************************
      Subroutine MemMan(ipOut,Ln_,Oper,ir,Label)
      Implicit Real*8 (a-h,o-z)
      Character*(*) Oper
      Character*5 OP2
      Character*6 Label
      CHARACTER*4 IRL
      Integer ip(40)
      Logical Mark
      Common /Memilimem/ num,ip,Mark
      INTRINSIC LEN
#include "memman.fh"
*
      L=MIN(LEN(OPER),5)
      OP2=' '
      OP2(1:L)=Oper(1:L)

      Ln = Ln_
      If (ln.eq.0) ln=1
      If (ir.eq.1) IRL='REAL'
      If (ir.eq.2) IRL='REAL'
      If (OP2(1:4).eq.'MARK') Then
         Num_Marks = Num_Marks + 1
         If (Num_Marks .gt. MxpMarks) Then
            Write(6,*) 'MemMan: There is too many active marks.'
            Write(6,*) 'Please either increase MxpMarks or remove'
            Write(6,*) 'some of the existring marks.'
            Write(6,*)
            Write(6,*) 'MxpMarks, Num_Marks = ',MxpMarks, Num_Marks
            Write(6,*)
            write(6,*) 'Num       Label      iPos'
            Write(6,*) '=============================='
            Do i = 1, Num_Marks
               Write(6,'(1X,I3,5X,A8,5X,I9)')
     &               i,label_marks(i),ipos_marks(i)
            End Do
            Call Abend()
         End If
         Call GetMem(Label,'Allo','Real',iPos,1)
         Label_Marks(Num_Marks) = Label(1:6)
         iPos_Marks(Num_Marks)  = iPos
      End If
      If (OP2(1:4).eq.'ADDL' .or. OP2(1:4).eq.'ADDS') Then
         Call GetMem(label,'ALLO',IRL,ipout,Ln)
      End If
      If (OP2(1:5).eq.'FLUSM') Then
         iPos  = 0
         i_Save = 0
         Do i = Num_Marks, 1, -1
            If (iPos .eq. 0 .AND. Label_Marks(i) .eq. Label) Then
               iPos   = iPos_Marks(i)
               i_Save = i
            End If
         End Do
         If (iPos .eq. 0) Then
            Write(6,*) 'MemMan: You have specified a non-existing'
            Write(6,*) 'label. I can''t work with that.'
            Write(6,*)
            Write(6,*) 'Label = ',Label
            Call Abend()
         End If
         Do i = i_Save+1, Num_Marks
            iPos_Marks(i-1)  = iPos_Marks(i)
            Label_Marks(i-1) = Label_Marks(i)
         End Do
         Call GetMem(Label,'Flush','Real',iPos,1)
         Call GetMem(Label,'Free','Real',iPos,1)
         Num_Marks = Num_Marks - 1
      End If
      If (OP2(1:4).eq.'FREE') Then
         Write(6,*) 'Memman: Operation FREE not implemented yet.'
         call abend()
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Last_Energy(iReturn)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iReturn
!#include "timtra.fh"
integer(kind=iwp) :: lengthlast
character(len=8) :: Method
logical(kind=iwp) :: Do_ESPF, StandAlone, FoundLastEn
!                                                                      *
!***********************************************************************
!                                                                      *
iReturn = 99

! Get information regarding the last method used

call qpg_cArray('LastEnergyMethod',FoundLastEn,lengthlast)
if (FoundLastEn) then
  call Get_cArray('LastEnergyMethod',Method,8)
else
  call Get_cArray('Relax Method',Method,8)
end if

call DecideOnESPF(Do_ESPF)

if (Method(5:7) /= 'SCF'     .and. &
    Method(1:6) /= 'KS-DFT'  .and. &
    Method(1:6) /= 'CASSCF'  .and. &
    Method(1:6) /= 'RASSCF'  .and. &
    Method(1:6) /= 'CASPT2'  .and. &
    Method(1:5) /= 'MBPT2'   .and. &
    Method(1:5) /= 'CCSDT'   .and. &
    Method(1:4) /= 'CHCC'    .and. &
    Method(1:6) /= 'MCPDFT'  .and. &
    Method(1:6) /= 'MSPDFT'  .and. &
#   ifdef _DMRG_
    Method(1:7) /= 'DMRGSCF' .and. &
#   endif
    Method(1:4) /= 'CHT3'    .and. &
    Method(1:8) /= 'EXTERNAL') then
  write(u6,'(A,A,A)') 'Last Energy for ',Method,' is not implemented yet.'
  call Abend()
end if

if (Method(1:6) == 'MCPDFT') Do_ESPF = .false.
if (Method(1:6) == 'MSPDFT') Do_ESPF = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute integrals

call StartLight('seward')
call Disable_Spool()
call Seward(iReturn)
if (iReturn /= 0) then
  write(u6,*) 'Last_Energy failed ...'
  write(u6,*) 'SEWARD returned with return code, rc = ',iReturn
  call Abend()
end if

! Compute ESPF

if (Do_ESPF) then
  call StartLight('espf')
  call Disable_Spool()
  StandAlone = .true.
  call ESPF(iReturn,StandAlone)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'ESPF returned with return code, rc = ',iReturn
    call Abend()
  end if
end if

! Compute the wave function

if ((Method(5:7) == 'SCF' .and. Method(1:4) /= 'DMRG') .or. &
    Method(1:6) == 'KS-DFT' .or. &
    Method(1:5) == 'MBPT2'  .or. &
    Method(1:4) == 'CHCC'   .or. &
    Method(1:4) == 'CHT3') then
  call StartLight('scf')
  call Disable_Spool()
  call xml_open('module',' ',' ',0,'scf')
  call SCF(iReturn)
  call xml_close('module')
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'SCF returned with return code, rc = ',iReturn
    call Abend()
  end if
else if (Method(1:6) == 'RASSCF' .or. &
         Method(1:6) == 'CASSCF' .or. &
         Method(1:6) == 'CASPT2' .or. &
         Method(1:6) == 'MCPDFT' .or. &
         Method(1:6) == 'MSPDFT' .or. &
         Method(1:5) == 'CCSDT') then
  call StartLight('rasscf')
  call Disable_Spool()
  call RASSCF(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'RASSCF returned with return code, rc = ',iReturn
    call Abend()
  end if
#ifdef _DMRG_
else if (Method(1:7) == 'DMRGSCF') then
  call StartLight('dmrgscf')
  call Disable_Spool()
  call DMRGSCF(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'DMRGSCF returned with return code, rc = ',iReturn
    call Abend()
  end if
#endif
else if (Method(1:8) == 'EXTERNAL') then
  call StartLight('false')
  call Disable_Spool()
  call False_program(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'FALSE returned with return code, rc = ',iReturn
    call Abend()
  end if
end if

if (Method(1:5) == 'MBPT2') then
  call StartLight('mbpt2')
  call Disable_Spool()
  call MP2_Driver(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'MBPT2 returned with return code, rc = ',iReturn
    call Abend()
  end if
end if

if (Method(1:5) == 'CCSDT') then
  call StartLight('motra')
  call Disable_Spool()
  call MOTra(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'MOTra returned with return code, rc = ',iReturn
    call Abend()
  end if

  call StartLight('ccsdt')
  call Disable_Spool()
  call CCSDT(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'CCSDT returned with return code, rc = ',iReturn
    call Abend()
  end if
end if

if (Method(1:4) == 'CHCC' .or. &
    Method(1:4) == 'CHT3') then
  call StartLight('chcc')
  call Disable_Spool()
  call CHCC(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'CHCC returned with return code, rc = ',iReturn
    call Abend()
  end if
end if

if (Method(1:4) == 'CHT3') then
  call StartLight('cht3')
  call Disable_Spool()
  call CHT3(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'CHT3 returned with return code, rc = ',iReturn
    call Abend()
  end if
end if

if (Method(1:6) == 'CASPT2') then
  call StartLight('caspt2')
  call Disable_Spool()
  call CASPT2(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'CASPT2 returned with return code, rc = ',iReturn
    call Abend()
  end if
end if

if (Method(1:6) == 'MCPDFT') then
  call StartLight('mcpdft')
  call Disable_Spool()
  call MCPDFT(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'MCPDFT returned with return code, rc = ',iReturn
    call Abend()
  end if
end if

if (Method(1:6) == 'MSPDFT') then
  call StartLight('mcpdft')
  call Disable_Spool()
  call MCPDFT(iReturn)
  if (iReturn /= 0) then
    write(u6,*) 'Last_Energy failed ...'
    write(u6,*) 'MCPDFT returned with return code, rc = ',iReturn
    call Abend()
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Since Last_Energy itself cleans up after the modules, it's necessary
! to force nfld_tim and nfld_stat to zero, or finish will scream.
!nfld_tim = 0
!nfld_stat = 0
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Last_Energy

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine output2b (unit,dkhscfflg,ucounter,uopsleng,uoporder,
     *                     eouops,duops,uops)
c
c*******************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 15.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      logical dkhscfflg
      integer unit,ucounter,uopsleng(maxuops),uoporder(maxuops),
     *        eouops(maxuops)
      REAL*8 duops(maxuops)
      character*(maxlength) uops(maxuops)
      integer j
c
      if (dkhscfflg) then
        write (unit,1012)
1012    format (/6X,'#',2X,'length',92X,'order',2X,'symm.',2X,'coeff.',
     *          /107X,'(tot)',/)
      else
        write (unit,1013)
1013    format (/6X,'#',2X,'length',92X,'order',2X,'symm.',2X,'coeff.',
     *          /108X,'(V)',/)
      endif
      do 10 j=1,ucounter
        write (unit,1015) j,uopsleng(j),uops(j)(1:uopsleng(j)),
     *                       uoporder(j),eouops(j),duops(j)
1015    format (I7,2X,I3,2X,A90,4X,I2,5X,I2,3X,F17.14)
  10  continue
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine VanishT1 (wrk,wrksize)
c
c        this routine do:
c        Vanish T1o
c
        implicit none
#include "chcc1.fh"
#include "wrk.fh"
c
c        help variables
        integer len
c
        len=no*nv
        call mv0zero (len,len,wrk(PossT1o))
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Jeppe Olsen                                      *
!***********************************************************************

subroutine GETCNF_MCLR(KCNF,KTYP,K,ICONF,IREFSM,NEL)
! Obtain configuration number K.
! Occupation in KCNF
! Type in KTYP
!
! Jeppe Olsen, summer of 89

use MCLR_Data, only: MINOP, NCNATS, NTYP
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: KCNF(*)
integer(kind=iwp), intent(out) :: KTYP
integer(kind=iwp), intent(in) :: K, ICONF(*), IREFSM, NEL
integer(kind=iwp) :: ICNFB1, ICNFB2, JCL, JOCC, JOP, JTYP, KADD, KREL, NJCNF

ICNFB1 = 1
ICNFB2 = 1
KTYP = 0
do JTYP=1,NTYP
  JOP = JTYP-1+MINOP
  JCL = (NEL-JOP)/2
  JOCC = JOP+JCL

  NJCNF = NCNATS(JTYP,IREFSM)
  if ((K >= ICNFB1) .and. (K <= ICNFB1+NJCNF-1)) then
    KREL = K-ICNFB1+1
    KADD = (KREL-1)*JOCC
    KTYP = JTYP
    KCNF(1:JOCC) = ICONF(ICNFB2+KADD:ICNFB2+KADD+JOCC-1)
  end if

  ICNFB1 = ICNFB1+NJCNF
  ICNFB2 = ICNFB2+NJCNF*JOCC
end do

end subroutine GETCNF_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      PROGRAM ASC2JOB
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER FMTIPH

#include "rasdim.fh"
#include "rasscf.fh"
#include "WrkSpc.fh"
#include "general.fh"

      CALL INIT_LINALG
      CALL PrgmInit('Asc2Job')

      JOBIPH=15
      JOBIPH=isFreeUnit(JOBIPH)
      CALL DANAME(JOBIPH,'JOBIPH')

      FMTIPH=JOBIPH+1
      FMTIPH=isFreeUnit(FMTIPH)
      CALL MOLCAS_OPEN(FMTIPH,'FMTIPH')

      READ(FMTIPH,*)
      READ(FMTIPH,'(15I10)') (IADR15(I), I=1,30)
      IAD15=0
      CALL IDAFILE(JOBIPH,1,IADR15,30,IAD15)

      nName=LENIN8*mxOrb
      nHeader=144
      nTitle=4*18*mxTit

 100  FORMAT(I10)
 200  FORMAT(2X,10I10)
 300  FORMAT(A)
 400  FORMAT(E20.12)
 500  FORMAT(2X,5E20.12)
 510  FORMAT(2X,6E20.12)
      READ(FMTIPH,*)
      READ(FMTIPH,100) nActEl
      READ(FMTIPH,*)
      READ(FMTIPH,100) iSpin
      READ(FMTIPH,*)
      READ(FMTIPH,100) nSym
      READ(FMTIPH,*)
      READ(FMTIPH,100) lSym
      READ(FMTIPH,*)
      READ(FMTIPH,200) (nFro(I), I=1,MxSym)
      READ(FMTIPH,*)
      READ(FMTIPH,200) (nISh(I), I=1,MxSym)
      READ(FMTIPH,*)
      READ(FMTIPH,200) (nASh(I), I=1,MxSym)
      READ(FMTIPH,*)
      READ(FMTIPH,200) (nDel(I), I=1,MxSym)
      READ(FMTIPH,*)
      READ(FMTIPH,200) (nBas(I), I=1,MxSym)
      READ(FMTIPH,*)
      READ(FMTIPH,100) nConf
      READ(FMTIPH,*)
      READ(FMTIPH,'(36A)') (Header(I), I=1,72)
      READ(FMTIPH,*)
      READ(FMTIPH,'(80A)') (Title(I), I=1,9)
      READ(FMTIPH,*)
      READ(FMTIPH,400) PotNuc
      READ(FMTIPH,*)
      READ(FMTIPH,100) lRoots
      READ(FMTIPH,*)
      READ(FMTIPH,100) nRoots
      READ(FMTIPH,*)
      READ(FMTIPH,200) (iRoot(I), I=1,MxRoot)
      READ(FMTIPH,*)
      READ(FMTIPH,200) (nRS1(I), I=1,MxSym)
      READ(FMTIPH,*)
      READ(FMTIPH,200) (nRS2(I), I=1,MxSym)
      READ(FMTIPH,*)
      READ(FMTIPH,200) (nRS3(I), I=1,MxSym)
      READ(FMTIPH,*)
      READ(FMTIPH,100) nHole1
      READ(FMTIPH,*)
      READ(FMTIPH,100) nElec3
      READ(FMTIPH,*)
      READ(FMTIPH,100) iPT2
      READ(FMTIPH,*)
      READ(FMTIPH,500) (Weight(I), I=1,MxRoot)

      NTOT=0
      NTOT2=0
      NASHT=0
      NTOT3=0
      NFOCK=0
      DO ISYM=1,NSYM
         NTOT=NTOT+nBas(ISYM)
         NTOT2=NTOT2+nBas(ISYM)**2
         NASHT=NASHT+nASh(ISYM)
         nOrb(iSym)=nBas(iSym)-nFro(iSym)-nDel(iSym)
         NTOT3=NTOT3+nOrb(iSym)*(nOrb(iSym)+1)/2
         NFOCK=NFOCK+(nISh(ISYM)+nASh(ISYM))**2
      END DO
      NACPAR=NASHT*(NASHT+1)/2
      NACPR2=NACPAR*(NACPAR+1)/2

      READ(FMTIPH,*)
      READ(FMTIPH,300) (Name(I), I=1,NTOT)

      IAD15=IADR15(1)
      CALL WR_RASSCF_Info(JOBIPH,1,IAD15,NACTEL,ISPIN,NSYM,LSYM,
     &            NFRO,NISH,NASH,NDEL,NBAS,MxSym,
     &            NAME,nName,NCONF,HEADER,nHeader,
     &            TITLE,nTitle,POTNUC,LROOTS,NROOTS,
     &            IROOT,MxRoot,NRS1,NRS2,NRS3,
     &            NHOLE1,NELEC3,IPT2,WEIGHT)

      IAD15=IADR15(2)
      CALL GETMEM('ADR1','ALLO','REAL',LADR1,NTOT2)
      CALL GETMEM('ADR2','ALLO','REAL',LADR2,NTOT)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,500) (WORK(LADR1+I-1), I=1,NTOT2)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,500) (WORK(LADR2+I-1), I=1,NTOT)
      CALL DDAFILE(JOBIPH,1,WORK(LADR1),NTOT2,IAD15)
      CALL DDAFILE(JOBIPH,1,WORK(LADR2),NTOT,IAD15)
      CALL GETMEM('ADR1','FREE','REAL',LADR1,NTOT2)
      CALL GETMEM('ADR2','FREE','REAL',LADR2,NTOT)

      IAD15=IADR15(3)
      CALL GETMEM('ADR1','ALLO','REAL',LADR1,NACPAR)
      CALL GETMEM('ADR2','ALLO','REAL',LADR2,NACPR2)
      READ(FMTIPH,*)
      Do I = 1,LROOTS
      READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,500) (WORK(LADR1+J-1), J=1,NACPAR)
        Call DDafIle(JOBIPH,1,WORK(LADR1),NACPAR,IAD15)
        READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,500) (WORK(LADR1+J-1), J=1,NACPAR)
        Call DDafIle(JOBIPH,1,WORK(LADR1),NACPAR,IAD15)
        READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,500) (WORK(LADR2+J-1), J=1,NACPR2)
        Call DDafIle(JOBIPH,1,WORK(LADR2),NACPR2,IAD15)
        READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,500) (WORK(LADR2+J-1), J=1,NACPR2)
        Call DDafIle(JOBIPH,1,WORK(LADR2),NACPR2,IAD15)
      ENDDO
      CALL GETMEM('ADR1','FREE','REAL',LADR1,NACPAR)
      CALL GETMEM('ADR2','FREE','REAL',LADR2,NACPR2)

      IAD15=IADR15(4)
      CALL GETMEM('ADR','ALLO','REAL',LADR,NCONF)
      READ(FMTIPH,*)
      Do I = 1,LROOTS
      READ(FMTIPH,*)
      READ(FMTIPH,*)
        READ(FMTIPH,500) (WORK(LADR+J-1), J=1,NCONF)
        Call DDafIle(JOBIPH,1,WORK(LADR),NCONF,IAD15)
      ENDDO
      CALL GETMEM('ADR','FREE','REAL',LADR,NCONF)

      IAD15=IADR15(5)
      CALL GETMEM('ADR','ALLO','REAL',LADR,NFOCK)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,500) (WORK(LADR+I-1), I=1,NFOCK)
      CALL DDAFILE(JOBIPH,1,WORK(LADR),NFOCK,IAD15)
      CALL GETMEM('ADR','FREE','REAL',LADR,NFOCK)

      IAD15=IADR15(6)
      CALL GETMEM('ADR','ALLO','REAL',LADR,mxRoot*mxIter)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,500) (WORK(LADR+I-1), I=1,mxRoot*mxIter)
      CALL DDAFILE(JOBIPH,1,WORK(LADR),mxRoot*mxIter,IAD15)
      CALL GETMEM('ADR','FREE','REAL',LADR,mxRoot*mxIter)

      IAD15=IADR15(7)
      CALL GETMEM('ADR','ALLO','REAL',LADR,6*mxIter)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,510) (WORK(LADR+I-1), I=1,6*mxIter)
      CALL DDAFILE(JOBIPH,1,WORK(LADR),6*mxIter,IAD15)
      CALL GETMEM('ADR','FREE','REAL',LADR,6*mxIter)

      IAD15=IADR15(9)
      CALL GETMEM('ADR','ALLO','REAL',LADR,NTOT2)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,500) (WORK(LADR+I-1), I=1,NTOT2)
      CALL DDAFILE(JOBIPH,1,WORK(LADR),NTOT2,IAD15)
      CALL GETMEM('ADR','FREE','REAL',LADR,NTOT2)

      IAD15=IADR15(10)
      CALL GETMEM('ADR','ALLO','REAL',LADR,NTOT3)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,500) (WORK(LADR+I-1), I=1,NTOT3)
      CALL DDAFILE(JOBIPH,1,WORK(LADR),NTOT3,IAD15)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,500) (WORK(LADR+I-1), I=1,NTOT3)
      CALL DDAFILE(JOBIPH,1,WORK(LADR),NTOT3,IAD15)
      CALL GETMEM('ADR','FREE','REAL',LADR,NTOT3)

      IAD15=IADR15(11)
      CALL GETMEM('ADR','ALLO','REAL',LADR,NORBT)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,500) (WORK(LADR+I-1), I=1,NORBT)
      CALL DDAFILE(JOBIPH,1,WORK(LADR),NORBT,IAD15)
      CALL GETMEM('ADR','FREE','REAL',LADR,NORBT)

      IAD15=IADR15(12)
      CALL GETMEM('ADR1','ALLO','REAL',LADR1,NTOT2)
      CALL GETMEM('ADR2','ALLO','REAL',LADR2,NTOT)
      READ(FMTIPH,*)
      DO I = 1,LROOTS
      READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,500) (WORK(LADR1+J-1), J=1,NTOT2)
        CALL DDAFILE(JOBIPH,1,WORK(LADR1),NTOT2,IAD15)
        READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,500) (WORK(LADR2+J-1), J=1,NTOT)
        CALL DDAFILE(JOBIPH,1,WORK(LADR2),NTOT,IAD15)
      ENDDO
      CALL GETMEM('ADR1','FREE','REAL',LADR1,NTOT2)
      CALL GETMEM('ADR2','FREE','REAL',LADR2,NTOT)

      IAD15=IADR15(14)
      CALL GETMEM('ADR1','ALLO','REAL',LADR1,NTOT2)
      CALL GETMEM('ADR2','ALLO','REAL',LADR2,NTOT)
      READ(FMTIPH,*)
      Do I=1,LROOTS
      READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,500) (WORK(LADR1+J-1), J=1,NTOT2)
        CALL DDAFILE(JOBIPH,1,WORK(LADR1),NTOT2,IAD15)
        READ(FMTIPH,*)
        READ(FMTIPH,*)
        READ(FMTIPH,500) (WORK(LADR2+J-1), J=1,NTOT)
        CALL DDAFILE(JOBIPH,1,WORK(LADR2),NTOT,IAD15)
      End Do
      CALL GETMEM('ADR1','FREE','REAL',LADR1,NTOT2)
      CALL GETMEM('ADR2','FREE','REAL',LADR2,NTOT)

      IAD15=IADR15(17)
      CALL GETMEM('ADR','ALLO','REAL',LADR,LROOTS**2)
      READ(FMTIPH,*)
      READ(FMTIPH,*)
      READ(FMTIPH,500) (WORK(LADR+J-1), J=1,LROOTS**2)
      CALL DDAFILE(JOBIPH,1,WORK(LADR),LROOTS**2,IAD15)
      CALL GETMEM('ADR','FREE','REAL',LADR,LROOTS**2)

      CALL DACLOS(JOBIPH)
      CLOSE(FMTIPH)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SYGTOSD(ICNFTAB,ISPNTAB,ISSTAB,IFSBTAB,CISYG,CISD,detocc,detcoeff,SPTRA)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICNFTAB(*), ISPNTAB(*), ISSTAB(*), IFSBTAB(*)
real(kind=wp), intent(in) :: CISYG(*), SPTRA(*)
real(kind=wp), intent(_OUT_) :: CISD(*), detcoeff(*)
character(len=*), intent(_OUT_) :: detocc(*)
integer(kind=iwp) :: I, IBLK, ICNF, idet, IEL, IEL1, IEL2, IERR, IFORM, IFSB, IMORS, IOCC, IOEND, IORB, IOSTA, IPART, IPOS, IREST, &
                     ISBSTR, ISORB, ISPART, ISPD, ISPEND, ISPN, ISPSTA, ISST, ISUM, ISYGEND, ISYGSTA, IWORD, IWRD, JSST, KCNF, &
                     KCNFINF, KFSB, KGSLIM, KGSORB, KHSHMAP, KMRSSBS, KSPN, KSPNINF, KSSTARR, KSSTTB, LSPTRA, LSYM, MAXOP, MINOP, &
                     MORSBITS, MXBLK, NACTEL, NAPART, NASPRT, NBLK, NCLSD, NCNF, NCPL, NFSB, NHEAD, NHSHMAP, NO, NOCC, NOP, NOPEN, &
                     NORB, NSP, NSPD, NSSTP, NSYM, NWRD
integer(kind=iwp), allocatable :: ndim(:), OccArr(:), OrbArr(:), SBSET(:), SSArr(:), STArr(:)
real(kind=wp), allocatable :: BLK(:)
character, allocatable :: occ(:)
integer(kind=iwp), external :: OCC2MRS

! Unbutton the configuration table:
NACTEL = ICNFTAB(3)
NORB = ICNFTAB(4)
MINOP = ICNFTAB(5)
MAXOP = ICNFTAB(6)
NSYM = ICNFTAB(7)
LSYM = ICNFTAB(8)
NAPART = ICNFTAB(9)
IFORM = ICNFTAB(10)
NHEAD = 10
KGSORB = NHEAD+1
KGSLIM = KGSORB+(NSYM+1)*(NAPART+1)
KCNFINF = KGSLIM+2*NAPART
!TEST write(u6,*) ' Table at KGSORB:'
!TEST do ipart=0,napart
!TEST   write(u6,'(1x,10i5)') (icnftab(kgsorb+isym+(nsym+1)*ipart),isym=0,nsym)
!TEST end do
!TEST write(u6,*) ' Table at KGSLIM:'
!TEST write(u6,'(1x,10i5)') (icnftab(kgslim+2*(ipart-1)),ipart=1,napart)
!TEST write(u6,'(1x,10i5)') (icnftab(kgslim+1+2*(ipart-1)),ipart=1,napart)
! Unbutton the spin coupling table:
KSPNINF = 9
! Unbutton the Substring Table:
NASPRT = ISSTAB(5)
MORSBITS = ISSTAB(6)
NSSTP = ISSTAB(7)
KSSTTB = 15
!TEST KSBSMRS = ISSTAB(11)
KMRSSBS = ISSTAB(12)
! Unbutton the Fock Sector Block table:
NHEAD = 7
KSSTARR = NHEAD+1
NFSB = IFSBTAB(2)
NHSHMAP = IFSBTAB(6)
KHSHMAP = IFSBTAB(7)

! MXBLK=Largest individual SYG block of determinants:
MXBLK = 0
idet = 0
do NOPEN=MINOP,MAXOP
  NCNF = ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP)))
  NCPL = ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+2)
  MXBLK = max(NCNF*NCPL,MXBLK)
end do
! A variety of small temporary arrays used:
call mma_allocate(BLK,MXBLK,Label='BLK')
call mma_allocate(ORBARR,NACTEL,Label='OrbArr')
call mma_allocate(OCCARR,2*NORB,Label='OccArr')
call mma_allocate(STARR,NASPRT,Label='STArr')
call mma_allocate(NDIM,NASPRT,Label='nDim')
call mma_allocate(SSARR,NASPRT,Label='SSArr')
call mma_allocate(SBSET,NSSTP,Label='SBSet')
call mma_allocate(occ,norb,label='occ')
! We will need later the accumulated number of substrings of
! earlier substring types:
ISUM = 0
do ISST=1,NSSTP
  SBSET(ISST) = ISUM
  ISUM = ISUM+ISSTAB(KSSTTB+5*(ISST-1))
end do
! Loop over nr of open shells.
ISYGEND = 0
do NOPEN=MINOP,MAXOP
  NCLSD = (NACTEL-NOPEN)/2
  if (NCLSD < 0) cycle
  if (2*NCLSD+NOPEN /= NACTEL) cycle
  NOCC = NCLSD+NOPEN
  if (NOCC > NORB) cycle
  NCNF = ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP)))
  if (NCNF == 0) cycle
  KCNF = ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP))+1)
  NWRD = ICNFTAB(KCNFINF+3*(LSYM-1+NSYM*(NOPEN-MINOP))+2)
  NCPL = ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+1)
  NSPD = ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+2)
  KSPN = ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+4)
  if (NSPD == 0) cycle
  if (NCPL == 0) cycle
  ! ISYGSTA=1st element of each block
  NBLK = NCPL*NCNF
  ISYGSTA = ISYGEND+1
  ISYGEND = ISYGEND+NBLK
  ! Location of spin coupling coefficients:
  LSPTRA = ISPNTAB(KSPNINF+6*(NOPEN-MINOP)+5)
  ! Matrix multiplication into temporary array:
  call DGEMM_('N','N',NSPD,NCNF,NCPL,One,SPTRA(LSPTRA),NSPD,CISYG(ISYGSTA),NCPL,Zero,BLK,NSPD)

  ! There is no phase factor in the reorder of orbitals from SYG
  ! to SD. But there is a fairly lengthy procedure for finding the
  ! correct position of each CI coefficient.
  IBLK = 0
  ! Loop over configurations
  IWORD = 0 ! dummy initialize
  do ICNF=1,NCNF
    if (IFORM == 1) then
      ORBARR(1:NOCC) = ICNFTAB(KCNF+NWRD*(ICNF-1):KCNF+NWRD*(ICNF-1)+NOCC-1)
    else if (IFORM == 2) then
      IEL2 = 0
      IEL1 = NCLSD
      do IORB=1,NORB
        IOCC = ICNFTAB(KCNF-1+IORB+NWRD*(ICNF-1))
        if (IOCC == 1) then
          IEL1 = IEL1+1
          ORBARR(IEL1) = IORB
        else
          IEL2 = IEL2+1
          ORBARR(IEL2) = IORB
        end if
      end do
    else if (IFORM == 3) then
      do IEL=1,NOCC
        IWRD = (3+IEL)/4
        IREST = (3+IEL)-4*IWRD
        if (IREST == 0) IWORD = ICNFTAB(KCNF-1+IWRD+NWRD*(ICNF-1))
        IORB = mod(IWORD,256)
        IWORD = IWORD/256
        ORBARR(IEL) = IORB
      end do
    else if (IFORM == 4) then
      IEL2 = 0
      IEL1 = NCLSD
      do IORB=1,NORB
        IWRD = (IORB+14)/15
        IREST = IORB+14-15*IWRD
        if (IREST == 0) IWORD = ICNFTAB(KCNF-1+IWRD+NWRD*(ICNF-1))
        IOCC = mod(IWORD,4)
        IWORD = IWORD/4
        if (IOCC == 1) then
          IEL1 = IEL1+1
          ORBARR(IEL1) = IORB
        else
          IEL2 = IEL2+1
          ORBARR(IEL2) = IORB
        end if
      end do
    end if

    !TEST write(u6,'(1x,a,10i5)') 'Configuration:',(ORBARR(iel),iel=1,nocc)
    !TEST write(u6,*) ' Loop over spin determinants.'
    ! Loop over spin determinants
    do ISPD=1,NSPD
      !TEST write(u6,'(1x,a,20i3)') 'Spin determinant:',(ISPNTAB(KSPN-1+I+NOPEN*(ISPD-1)),I=1,nopen)
      IBLK = IBLK+1
      ! count the determinants
      idet = idet+1
      ! Construct occupation number array:
      OCCARR(:) = 0
      do IEL=1,NCLSD
        IORB = ORBARR(IEL)
        OCCARR(2*IORB-1) = 1
        OCCARR(2*IORB) = 1
      end do
      do I=1,NOPEN
        ! Spin of each electron is coded as 1 for alpha, 0 for beta.
        ISPN = ISPNTAB(KSPN-1+I+NOPEN*(ISPD-1))
        IEL = NCLSD+I
        ISORB = 2*ORBARR(IEL)-ISPN
        OCCARR(ISORB) = 1
      end do
      ! Identify substrings:
      ! Loop over active partitions. Subdivide as needed into subpartitions.
      !TEST write(u6,*) ' Identify substrings.'
      !TEST write(u6,'(1x,a,10i5)') 'Occupation array:',(OCCARR(isorb),isorb=1,2*norb)
      ! construct occupation array in 0,u,d,2 format
      do IORB=1,2*norb-1,2
        if ((OCCARR(IORB) == 1) .and. (OCCARR(1+IORB) == 1)) then
          occ((IORB+1)/2) = '2'
        else if ((OCCARR(IORB) == 1) .and. (OCCARR(1+IORB) == 0)) then
          occ((IORB+1)/2) = 'u'
        else if ((OCCARR(IORB) == 0) .and. (OCCARR(1+IORB) == 1)) then
          occ((IORB+1)/2) = 'd'
        else if ((OCCARR(IORB) == 0) .and. (OCCARR(1+IORB) == 0)) then
          occ((IORB+1)/2) = '0'
        end if
      end do

      IOEND = 0
      ISPEND = 0
      !TEST write(u6,'(1x,a,10i5)') 'NAPART:',NAPART
      do IPART=1,NAPART
        !TEST write(u6,'(1x,a,10i5)') ' In loop, IPART:',IPART
        NOP = 2*ICNFTAB(KGSORB+(NSYM+1)*IPART)
        !TEST write(u6,'(1x,a,10i5)') '            NOP:',NOP
        !TEST if (NOP == 0) write(u6,*) ' (Skip it.)'
        if (NOP == 0) cycle
        NSP = (NOP+MORSBITS-1)/MORSBITS
        !TEST write(u6,'(1x,a,10i5)') '            NSP:',NSP
        ISPSTA = ISPEND+1
        ISPEND = ISPEND+NSP
        do ISPART=ISPSTA,ISPEND
          !TEST write(u6,'(1x,a,10i5)') 'Loop lims ISPSTA,ISPEND:',ISPSTA,ISPEND
          NO = min(NOP,MORSBITS)
          NOP = NOP-NO
          IOSTA = IOEND+1
          IOEND = IOEND+NO
          !TEST write(u6,'(1x,a,10i5)') 'IOSTA,IOEND:',IOSTA,IOEND
          !TEST write(u6,'(1x,a,10i5)') 'Occ array:',(OCCARR(ISORB),ISORB=IOSTA,IOEND)
          IMORS = OCC2MRS(NO,OCCARR(IOSTA))
          !TEST write(u6,'(1x,a,10i5)') 'IMORS=',IMORS
          ! Position in Morsel-to-Substring table:
          IPOS = KMRSSBS+2*(IMORS+(2**MORSBITS)*(ISPART-1))
          ! Substring ID number
          ISBSTR = ISSTAB(IPOS)
          ! Test:
          !TEST JMORS = ISSTAB(KSBSMRS+2*(ISBSTR-1))
          !TEST if (IMORS /= JMORS) then
          !TEST   write(u6,*) ' Mistranslated morsel!!'
          !TEST   write(u6,'(1x,a,4i12)') 'IMORS->ISBSTR:',IMORS,ISBSTR
          !TEST   write(u6,'(1x,a,4i12)') 'but ISBSTR->IMORS:',ISBSTR,JMORS
          !TEST   write(u6,'(1x,a,4i12)') 'KMRSSBS:',KMRSSBS
          !TEST   write(u6,'(1x,a,4i12)') 'KSBSMRS:',KSBSMRS
          !TEST   call ABEND()
          !TEST end if
          !TEST write(u6,'(1x,a,10i5)') 'ISBSTR:',ISBSTR
          ! Substring type ISST, nr of such substrings is NDIM
          ISST = ISSTAB(IPOS+1)
          !TEST write(u6,'(1x,a,10i5)') 'ISST  :',ISST
          STARR(ISPART) = ISST
          ndim(ISPART) = ISSTAB(KSSTTB+5*(ISST-1))
          SSARR(ISPART) = ISBSTR-SBSET(ISST)
        end do
      end do
      !TEST write(u6,*) ' Finally, substring types and substrings:'
      !TEST write(u6,'(1x,a,10i5)') 'Substr types:',(STARR(ISPART),ISPART=1,NASPRT)
      !TEST write(u6,'(1x,a,10i5)') 'Substrings  :',(SSARR(ISPART),ISPART=1,NASPRT)
      !TEST write(u6,'(1x,a,10i5)') 'Dimensions  :',(NDIM(ISPART),ISPART=1,NASPRT)
      ! Position within FS block:
      IPOS = (SSARR(NASPRT)-1)
      do ISPART=NASPRT-1,1,-1
        IPOS = ndim(ISPART)*IPOS+(SSARR(ISPART)-1)
      end do
      IPOS = IPOS+1
      ! Identify Fock Sector Block:
      !TEST write(u6,*) ' Arguments in HSHGET call:'
      !TEST write(u6,'(1x,a,10i5)') 'Key:',(STARR(ISPART),ISPART=1,NASPRT)
      !TEST write(u6,'(1x,a,10i5)') 'Size of key:',NASPRT
      !TEST write(u6,'(1x,a,10i5)') 'Size of items stored:',NASPRT+2
      !TEST write(u6,'(1x,a,10i5)') 'Items stored at KSSTARR=',KSSTARR
      !TEST write(u6,'(1x,a,10i5)') '      Map size  NHSHMAP=',NHSHMAP
      !TEST write(u6,'(1x,a,10i5)') '  Map stored at KHSHMAP=',KHSHMAP
      call HSHGET(STARR,NASPRT,NASPRT+2,IFSBTAB(KSSTARR),NHSHMAP,IFSBTAB(KHSHMAP),IFSB)
      !TEST write(u6,'(1x,a,10i5)') ' Map returns index IFSB=',IFSB
      !TEST write(u6,'(1x,a,10i5)') ' Item stored there is  =',(IFSBTAB(KSSTARR-1+ISPART+(NASPRT+2)*(IFSB-1)),ISPART=1,NASPRT+2)
      ! Position of this FS block in SD wave function:
      KFSB = IFSBTAB(KSSTARR+(NASPRT+2)*IFSB-1)
      ! Temporary check, may be removed later. See that we have picked up
      ! the correct FS block.
      IERR = 0
      do ISPART=1,NASPRT
        JSST = IFSBTAB(KSSTARR-1+ISPART+(NASPRT+2)*(IFSB-1))
        ISST = STARR(ISPART)
        if (ISST /= JSST) IERR = 1
      end do
      if (IERR /= 0) then
        write(u6,*) ' SYGTOSD Error: Hash map returned the wrong FS block!'
        write(u6,'(1x,a,8I8)') 'NOPEN,ICNF,ISPN:',NOPEN,ICNF,ISPN
        write(u6,'(1x,a,20I3)') 'Configuration:',(ORBARR(IEL),IEL=1,NACTEL)
        write(u6,'(1x,a,20I3)') 'Determinant:',(OCCARR(ISORB),ISORB=1,2*NORB)
        write(u6,'(1x,a,10I5)') 'Substring type combination:',(STARR(ISPART),ISPART=1,NASPRT)
        write(u6,'(1x,a,10I5)') 'Substring combination:',(SSARR(ISPART),ISPART=1,NASPRT)
        write(u6,'(1x,a,8I8)') 'Hash table says IFSB=',IFSB
        if ((IFSB > 0) .and. (IFSB <= NFSB)) then
          write(u6,'(1x,a,8I8)') 'but that FS block would contain',(IFSBTAB(KSSTARR-1+ISPART+(NASPRT+2)*(IFSB-1)),ISPART=1,NASPRT)
        else
          write(u6,*) 'but there is no such FS block!'
          write(u6,*) ' The FS block table follows:'
          call PRFSBTAB(IFSBTAB)
        end if
        call ABEND()
      end if
      ! Finally:
      CISD(KFSB-1+IPOS) = BLK(IBLK)
      detcoeff(idet) = BLK(IBLK)
      write(detocc(idet),*) occ
      ! End of spin-determinant loop
    end do
    ! End of loop over configurations
  end do
  ! End of loop over nr of open shells
end do
call mma_deallocate(BLK)
call mma_deallocate(ORBARR)
call mma_deallocate(OCCARR)
call mma_deallocate(STARR)
call mma_deallocate(NDIM)
call mma_deallocate(SSARR)
call mma_deallocate(SBSET)
call mma_deallocate(occ)

return

end subroutine SYGTOSD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WrCheck(Label,Arr,n)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Arr(n)
      Character*(*) Label
      Write (6,*) Label, DDot_(n,Arr,1,Arr,1),
     &                   DDot_(n,Arr,1,[One],0),n
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               Anders Ohrn                                            *
************************************************************************
      SUBROUTINE JACORD(HH,EIGVEC,NVEC,NDIM)
*
      IMPLICIT REAL*8 (A-H,O-Z)
*
      DIMENSION HH(*), EIGVEC(NDIM,NVEC)

      ThrZ=1.0D-14
      DO 100 I=1,NVEC-1
        II=(I*(I+1))/2
        EI=HH(II)
        EMIN=EI
        IMIN=I
        DO 10 J=I+1,NVEC
          JJ=(J*(J+1))/2
          EJ=HH(JJ)
          IF(EJ.GE.EMIN.or.ABS(EJ-EMIN).lt.ThrZ) GOTO 10
          EMIN=EJ
          IMIN=J
  10    CONTINUE
        IF(IMIN.EQ.I) GOTO 100
        HH(II)=EMIN
        JJ=(IMIN*(IMIN+1))/2
        HH(JJ)=EI
        DO 20 K=1,NDIM
          SWAP=EIGVEC(K,I)
          EIGVEC(K,I)=EIGVEC(K,IMIN)
          EIGVEC(K,IMIN)=SWAP
  20    CONTINUE
 100  CONTINUE
      RETURN
      END
      SUBROUTINE JACORD2(EVal,EVec,n,nB)
C      SubRoutine Sort(EVal,EVec,n,nB)
************************************************************************
*                                                                      *
*     purpose: Sort the set of eigenvalues and eigenvectors            *
*                                                                      *
*                                                                      *
*     input:                                                           *
*       EVal    : the set of eigenvalues in random order               *
*       EVec    : the set of eigenvectors in random order              *
*       n,nB    : dimensions                                           *
*                                                                      *
*     output:                                                          *
*       EVal    : sorted set of eigenvalues                            *
*       EVec    : sorted set of eigenvectors                           *
*                                                                      *
*     called from: DCore, NewOrb, IvoGen                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
      Dimension EVal(n),EVec(nB,n)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*
      Do 100 i = 1,n - 1
         k = i
         Do 110 j = i + 1, n
            If (EVal(j).lt.EVal(k)) k = j
110      Continue
         If (k.ne.i) Then
            Swap    = EVal(k)
            EVal(k) = EVal(i)
            EVal(i) = Swap
            Do 120 l = 1, nB
               Swap      =   EVec(l,k)
               EVec(L,K) =   EVec(l,i)
               EVec(L,I) =   Swap
120         Continue
         End If
100   Continue

      End


      SUBROUTINE JACORD3(EVal,EVec,n,nB)
C      SubRoutine Sort(EVal,EVec,n,nB)
************************************************************************
*                                                                      *
*     purpose: Sort the set of eigenvalues and eigenvectors, in        *
*              falling sequence.                                       *
*                                                                      *
*                                                                      *
*     input:                                                           *
*       EVal    : the set of eigenvalues in random order               *
*       EVec    : the set of eigenvectors in random order              *
*       n,nB    : dimensions                                           *
*                                                                      *
*     output:                                                          *
*       EVal    : sorted set of eigenvalues                            *
*       EVec    : sorted set of eigenvectors                           *
*                                                                      *
*     called from: DCore, NewOrb, IvoGen                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: A. Ohrn copied JACORD2 and made minimal modification.   *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
      Dimension EVal(n),EVec(nB,n)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*
      Do 100 i = 1,n - 1
         k = i
         Do 110 j = i + 1, n
            If (EVal(j).gt.EVal(k)) k = j
110      Continue
         If (k.ne.i) Then
            Swap    = EVal(k)
            EVal(k) = EVal(i)
            EVal(i) = Swap
            Do 120 l = 1, nB
               Swap      =   EVec(l,k)
               EVec(L,K) =   EVec(l,i)
               EVec(L,I) =   Swap
120         Continue
         End If
100   Continue
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GETINCN_RASSCFS(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                  IXCHNG,IKSM,JLSM,INTLST,NSMOB,ICOUL)
*
* Obtain integrals
*
*     ICOUL = 0 :
*                  XINT(IK,JL) = (IJ!KL)         for IXCHNG = 0
*                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
*
*     ICOUL = 1 :
*                  XINT(IJ,KL) = (IJ!KL)         for IXCHNG = 0
*                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
*
*     ICOUL = 2 :  XINT(IL,JK) = (IJ!KL)         for IXCHNG = 0
*                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
*
* Storing for ICOUL = 1 not working if IKSM or JLSM .ne. 0
*
*
* Version for integrals stored in INTLST
*
* If type equals zero, all integrals of given type are fetched
* ( added aug8, 98)
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "mxpdim.fh"
#include "orbinp.fh"
*. Integral list
      Real * 8 Intlst(*)
*.Output
      DIMENSION XINT(*)
*. Local scratch
C-jwk-cleanup      DIMENSION IJARR(MXPORB)
*
      IF(ITP.GE.1) THEN
        iOrb=NOBPTS(ITP,ISM)
      ELSE
        IORB = NTOOBS(ISM)
      END IF
*
      IF(JTP.GE.1) THEN
        jOrb=NOBPTS(JTP,JSM)
      ELSE
        JORB = NTOOBS(JSM)
      END IF
*
      IF(KTP.GE.1) THEN
        kOrb=NOBPTS(KTP,KSM)
      ELSE
        KORB = NTOOBS(KSM)
      END IF
*
      IF(LTP.GE.1) THEN
        lOrb=NOBPTS(LTP,LSM)
      ELSE
        LORB = NTOOBS(LSM)
      END IF
*. Offsets relative to start of all orbitals, symmetry ordered
      IOFF = IBSO(ISM)
      DO IITP = 1, ITP -1
        IOFF = IOFF + NOBPTS(IITP,ISM)
      END DO
*
      JOFF = IBSO(JSM)
      DO JJTP = 1, JTP -1
        JOFF = JOFF + NOBPTS(JJTP,JSM)
      END DO
*
      KOFF = IBSO(KSM)
      DO KKTP = 1, KTP -1
        KOFF = KOFF + NOBPTS(KKTP,KSM)
      END DO
*
      LOFF = IBSO(LSM)
      DO LLTP = 1, LTP -1
        LOFF = LOFF + NOBPTS(LLTP,LSM)
      END DO

*
*     Collect Coulomb terms
*
*
      iInt=0
      Do l=lOff,lOff+lOrb-1
        jMin=jOff
        If ( JLSM.ne.0 ) jMin=l
        Do j=jMin,jOff+jOrb-1
          Do k=kOff,kOff+kOrb-1
            iMin = iOff
            If(IKSM.ne.0) iMin = k
            IF(ICOUL.EQ.1)  THEN
*. Address before integral (1,j!k,l)
                IINT = (L-LOFF)*Jorb*Korb*Iorb
     &               + (K-KOFF)*Jorb*Iorb
     &               + (J-JOFF)*Iorb
            ELSE IF (ICOUL.EQ.2) THEN
*  Address before (1L,JK)
                IINT = (K-KOFF)*JORB*LORB*IORB
     &               + (J-JOFF)     *LORB*IORB
     &               + (L-LOFF)          *IORB
            END IF
*
              Do i=iMin,iOff+iOrb-1
                  IJ = MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
                  KL = MAX(K,L)*(MAX(K,L)-1)/2+MIN(K,L)
                  IJKL = MAX(IJ,KL)*(MAX(IJ,KL)-1)/2+MIN(IJ,KL)
* Next line inserted by Jesper: "I don't think iInt should be the same
* for all i"
                  iInt=iInt + 1
                  Xint(iInt) = Intlst(ijkl)
              End Do
          End Do
        End Do
      End Do
*
*     Collect Exchange terms
*
      If ( IXCHNG.ne.0 ) Then
*
        iInt=0
        Do l=lOff,lOff+lOrb-1
          jMin=jOff
          If ( JLSM.ne.0 ) jMin=l
          Do j=jMin,jOff+jOrb-1
            Do k=kOff,kOff+kOrb-1
              iMin = iOff
              If(IKSM.ne.0) iMin = k
              IF(ICOUL.EQ.1)  THEN
*. Address before integral (1,j!k,l)
                  IINT = (L-LOFF)*Jorb*Korb*Iorb
     &                  + (K-KOFF)*Jorb*Iorb
     &                  + (J-JOFF)*Iorb
              ELSE IF (ICOUL.EQ.2) THEN
*  Address before (1L,JK)
                IINT = (K-KOFF)*JORB*LORB*IORB
     &               + (J-JOFF)     *LORB*IORB
     &               + (L-LOFF)          *IORB
              END IF
*
                Do i=iMin,iOff+iOrb-1
                  IL = MAX(I,L)*(MAX(I,L)-1)/2+MIN(I,L)
                  KJ = MAX(K,J)*(MAX(K,J)-1)/2+MIN(K,J)
                  ILKJ = MAX(IL,KJ)*(MAX(IL,KJ)-1)/2+MIN(IL,KJ)
                  iInt=iInt+1
                  XInt(iInt)=XInt(iInt)-Intlst(ilkj)
                End Do
            End Do
          End Do
        End Do
      End If
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NSMOB)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CSFDET(NOPEN,IDET,NDET,ICSF,NCSF,CDC,SCR,nSCR,PSSIGN)
! Expand csf's in terms of combinations with
! the use of the Grabenstetter method (I.J.Q.C. 10, P142 (1976))
!
! Input :
!         NOPEN : NUMBER OF OPEN ORBITALS
!         IDET  : OCCUPATION OF combinations
!         NDET  : NUMBER OF combinations
!         ICSF  : INTERMEDIATE SPIN COUPLINGS OF
!                 CSF'S IN BRANCHING DIAGRAM
! Output :
!         CDC :  NDET X NCSF MATRIX
!                GIVING EXPANSION FROM COMB'S TO CSF,S
!                CSF BASIS = Comb basis *CDC
! Scratch :
!          SCR, SHOULD AT LEAST BE ???
!
! If combinations are use (signaled by PSSIGN /= 0)
! the factors are multiplies with sqrt(2), corresponding to
! a combination being 1/sqrt(2) times the sum or difference of two
! determinants

use lucia_data, only: IPRCIX
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nOpen, nDet, IDET(NOPEN,NDET), nCSF, ICSF(NOPEN,NCSF), nSCR
real(kind=wp), intent(out) :: CDC(NDET,NCSF), SCR(nSCR)
real(kind=wp), intent(in) :: PSSIGN
integer(kind=iwp) :: IOPEN, JCSF, JDADD, JDET, KLFREE, KLMDET, KLSCSF
real(kind=wp) :: CMBFAC, COEF, SGN

if (PSSIGN == Zero) then
  CMBFAC = One
else
  CMBFAC = sqrt(Two)
end if

KLFREE = 1
KLMDET = KLFREE
KLFREE = KLMDET+NDET*NOPEN
KLSCSF = KLFREE
KLFREE = KLSCSF+NOPEN

! OBTAIN INTERMEDIATE VALUES OF MS FOR ALL DETERMINANTS
do JDET=1,NDET
  call MSSTRN(IDET(:,JDET),SCR(KLMDET+(JDET-1)*NOPEN),NOPEN)
end do

do JCSF=1,NCSF
# ifdef _DEBUGPRINT
  write(u6,*) ' ....Output for CSF ',JCSF
# endif

  ! OBTAIN INTERMEDIATE COUPLINGS FOR CSF
  call MSSTRN(ICSF(:,JCSF),SCR(KLSCSF),NOPEN)

  do JDET=1,NDET
    ! EXPANSION COEFFICIENT OF DETERMINANT JDET FOR CSF JCSF
    COEF = One
    SGN = One
    JDADD = (JDET-1)*NOPEN
    do IOPEN=1,NOPEN

      if ((ICSF(IOPEN,JCSF) == 1) .and. (IDET(IOPEN,JDET) == 1)) then
        ! + + CASE
        COEF = COEF*(SCR(KLSCSF-1+IOPEN)+SCR(KLMDET-1+JDADD+IOPEN))/(Two*SCR(KLSCSF-1+IOPEN))
      else if ((ICSF(IOPEN,JCSF) == 1) .and. (IDET(IOPEN,JDET) == 0)) then
        ! + - CASE
        COEF = COEF*(SCR(KLSCSF-1+IOPEN)-SCR(KLMDET-1+JDADD+IOPEN))/(Two*SCR(KLSCSF-1+IOPEN))
      else if ((ICSF(IOPEN,JCSF) == 0) .and. (IDET(IOPEN,JDET) == 1)) then
        ! - + CASE
        COEF = COEF*(SCR(KLSCSF-1+IOPEN)-SCR(KLMDET-1+JDADD+IOPEN)+One)/(Two*SCR(KLSCSF-1+IOPEN)+Two)
        SGN = -SGN
      else if ((ICSF(IOPEN,JCSF) == 0) .and. (IDET(IOPEN,JDET) == 0)) then
        ! - - CASE
        COEF = COEF*(SCR(KLSCSF-1+IOPEN)+SCR(KLMDET-1+JDADD+IOPEN)+One)/(Two*SCR(KLSCSF-1+IOPEN)+Two)
      end if
    end do
    CDC(JDET,JCSF) = SGN*CMBFAC*sqrt(COEF)
  end do
end do

if (IPRCIX >= 5) then
  write(u6,*)
  write(u6,'(A,2I2)') '  The CDC array for  NOPEN ',NOPEN
  write(u6,*) ' NDET, NCSF = ',NDET,NCSF
  write(u6,*)
  call WRTMAT(CDC,NDET,NCSF,NDET,NCSF)
end if

end subroutine CSFDET

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION IDMIN (N, X, INCX)
C
C     FINDS THE INDEX OF ELEMENT HAVING MIN. VALUE.
C
      INTEGER    N, INCX
      REAL*8     X(*)
      INTEGER    I, IXX
      REAL*8     MIN
C
      IDMIN = 0
      IF (N .GE. 1) THEN
         IDMIN = 1
         IF (N .NE. 1) THEN
            IF (INCX .NE. 1) THEN
C                                  CODE FOR INCREMENT NOT EQUAL TO 1
               IXX = 1
               MIN = X(1)
               IXX = IXX + INCX
               DO 10  I=2, N
                  IF (X(IXX) .LT. MIN) THEN
                     IDMIN = I
                     MIN = X(IXX)
                  END IF
                  IXX = IXX + INCX
   10          CONTINUE
            ELSE
C                                  CODE FOR INCREMENT EQUAL TO 1
               MIN = X(1)
               DO 20  I=2, N
                  IF (X(I) .LT. MIN) THEN
                     IDMIN = I
                     MIN = X(I)
                  END IF
   20          CONTINUE
            END IF
         END IF
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FindErrorLine()

use getline_mod, only: iGetLine, MyUnit
use Definitions, only: iwp, u6

implicit none
character(len=180) :: line
integer(kind=iwp) :: isave, istatus, lunit

lunit = myunit
isave = igetline
rewind(lunit)
do
  read(lunit,'(a)',iostat=istatus) Line
  if (istatus > 0) exit
  call UpCase(Line)
  Line = adjustl(Line)
  if (Line(1:1) == '&') then
    line = line(2:)
    exit
  end if
end do
if (istatus <= 0) then
  igetline = 0
  write(u6,'(a,a,a)') ' >>>>> Input file for module ',line(1:index(line,' ')),' <<<<<'
  do
    read(lunit,'(A)',iostat=istatus) line
    if (istatus /= 0) exit
    igetline = igetline+1
    if (igetline == isave) then
      write(u6,*) '******   Error  *******'
      write(u6,'(a)') line
      write(u6,'(a)')
      call WarningMessage(2,'Error in FindErrorLine')
      call Quit_OnUserError()
    end if
    if (isave-igetline <= 50) write(u6,'(a)') line
  end do
  !  write(u6,'(a)') ' >>>>> Input error <<<<<'
  !  rewind(lunit)
  !  igetline = 0
  !end do
end if
call WarningMessage(1,'FindErrorLine: Error in input was not located;  Please, check it manually!')

return

end subroutine FindErrorLine

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine RInt_Generic(rkappa,rmos,rmoa,Fock,Q,Focki,Focka,
     &                        idsym,reco,jspin)
      use Arrays, only: W_CMO_Inv=>CMO_Inv, W_CMO=>CMO, G1t, G2t, FAMO,
     &                  FIMO
*
*                              ~
*     Constructs  F  = <0|[E  ,H]|0> ( + <0|[[E  , Kappa],H]|0> )
*                  pq       pq                 pq
*
      use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
      Implicit Real*8(a-h,o-z)

#include "real.fh"
#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
#include "standard_iounits.fh"
      Real*8 Fock(nDens2),focka(nDens2),rkappa(nDens2),
     &       Focki(ndens2),Q(ndens2),rMOs(*),rmoa(*)
      Logical Fake_CMO2,DoAct
      Real*8, Allocatable:: MT1(:), MT2(:), MT3(:), QTemp(:),
     &                      Dens2(:),  G2x(:)
      Type (DSBA_Type) CVa(2), DLT, DI, DA, Kappa, JI(1), KI, JA, KA,
     &                 FkI, FkA, QVec, CMO, CMO_Inv
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (LuWr,*) 'Focki=',DDot_(nDens2,Focki,1,Focki,1)
      Write (LuWr,*) 'Focka=',DDot_(nDens2,Focka,1,Focka,1)
#endif
*
      Fact=-One
      call dcopy_(ndens2,[0.0d0],0,Fock,1)
*                                                                      *
************************************************************************
*                                                                      *
      Select Case (NewCho)
*                                                                      *
************************************************************************
*                                                                      *
      Case (.FALSE.)   ! Cho-MO
*                                                                      *
************************************************************************
*                                                                      *
        Call mma_allocate(MT1,nmba,Label='MT1')
        Call mma_allocate(MT2,nmba,Label='MT2')
        MT1(:)=Zero
        MT2(:)=Zero

        Call R2ElInt(rkappa,MT1,MT2,focki,focka,
     &               nDens2,idSym,ReCo,Fact,jspin)
#ifdef _DEBUGPRINT_
        Write (LuWr,*) 'MT1=',DDot_(nmba,MT1,1,MT1,1)
        Write (LuWr,*) 'MT2=',DDot_(nmba,MT2,1,MT2,1)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*
*
*     Q  = sum(jkl)=(pj|kl)d(ijkl)
*      pi
*
        If (iMethod.eq.2) Then
           Call mma_allocate(QTemp,ndens2,Label='QTemp')
           Call CreQ(Q,MT1,G2t,idsym)
           Call CreQ(QTemp,MT2,G2t,idsym)
#ifdef _DEBUGPRINT_
           Write (LuWr,*) 'Q=',DDot_(nDens2,Q,1,Q,1)
           Write (LuWr,*) 'QTemp=',DDot_(nDens2,QTemp,1,QTemp,1)
#endif
           call daxpy_(ndens2,One,QTemp,1,Q,1)
           Call mma_deallocate(QTemp)
        End If
*                                                                      *
************************************************************************
*                                                                      *
      Case (.TRUE.)   ! Cho-Fock
*                                                                      *
************************************************************************
        Fake_CMO2=.false.
        DoAct=.true.
*
**      Form inactive density
*
        Call Allocate_DT(DI,nOrb,nOrb,nSym)
        DI%A0(:)=Zero

        Do iS=1,nsym
         Do iB=1,nIsh(iS)
          DI%SB(iS)%A2(ib,ib)=Two
         End Do
        End Do
*
**      Form AO 1-index transform inactive density
*
        Call mma_allocate(Dens2,nDens2,Label='Dens2')
        Dens2(:)=Zero
        Call Allocate_DT(DLT,nOrb,nOrb,nSym) ! Note SQ format
        DLT%A0(:)=Zero

        If (idSym/=1) Then
           Write (6,*) 'idSym/=1, idSym=',idsym
           Call Abend()
        End If

        Do iS=1,nSym
          If (nOrb(iS).ne.0) Then
            Do jS=1,nSym
              If (iEOr(iS-1,jS-1)+1.eq.idsym.and.nOrb(jS).ne.0) Then
                   Call DGEMM_('N','N',
     &                         nOrb(iS),nOrb(jS),nOrb(jS),
     &                         One,rkappa(ipMat(is,js)),nOrb(iS),
     &                             DI%SB(js)%A2,nOrb(jS),
     &                         Zero,Dens2(ipMat(iS,jS)),nOrb(iS))
                   Call DGEMM_('T','T',nOrb(jS),nOrb(iS),nOrb(iS),
     &                         One,Dens2(ipMat(iS,jS)),nOrb(iS),
     &                             W_CMO(ipCM(is)),nOrb(iS),
     &                         Zero,DLT%SB(iS)%A2,nOrb(jS))
                   Call DGEMM_('T','T',nOrb(jS),nOrb(jS),nOrb(iS),
     &                         One,DLT%SB(iS)%A2,nOrb(iS),
     &                             W_CMO(ipCM(js)),nOrb(jS),
     &                         Zero,Dens2(ipMat(iS,jS)),nOrb(jS))

                   Call DGEMM_('T','T',nOrb(jS),nOrb(iS),nOrb(iS),
     &                         One,DI%SB(js)%A2,nOrb(iS),
     &                             W_CMO(ipCM(is)),nOrb(iS),
     &                         Zero,DLT%SB(iS)%A2,nOrb(jS))
                   Call DGEMM_('T','T',nOrb(jS),nOrb(jS),nOrb(iS),
     &                         One, DLT%SB(iS)%A2,nOrb(iS),
     &                              W_CMO(ipCM(js)),nOrb(jS),
     &                         Zero,DI%SB(js)%A2,nOrb(jS))
              EndIf
            End Do
          EndIf
        End Do
        ! Release and allocate again in LT format
        Call Deallocate_DT(DLT)
        Call Allocate_DT(DLT,nOrb,nOrb,nSym,aCase='TRI')

        call Fold_Mat(nSym,nOrb,Dens2,DLT%A0)
        DLT%A0(:) = ReCo * DLT%A0(:)
*
**      Form active density and MO coefficients
*
        If (iMethod.eq.2) Then
          na2=0
          nAct=0
          nG2=0
          Do iSym=1,nSym
            na2 = na2+nAsh(iSym)**2
            nact=nact+nAsh(iSym)
            nAG2=0
            Do jSym=1,nSym
              kSym=iEOr(jsym-1,isym-1)+1
              nAG2=nAg2+nAsh(jSym)*nAsh(kSym)
            End Do
            nG2=nG2+nAG2**2
          End Do
          nAtri=nact*(nact+1)/2
          nAtri=nAtri*(nAtri+1)/2

          Call Allocate_DT(CVa(1),nAsh,nOrb,nSym)
          Call Allocate_DT(CVa(2),nAsh,nOrb,nSym)
          Call Allocate_DT(DA,nAsh,nAsh,nSym)
*
          ioff=0
          ioff4=1
          Do iS=1,nSym
            ioff2 = ioff + nOrb(iS)*nIsh(iS)
            ioff5 = ioff4+ nOrb(iS)*nIsh(iS)
            Do iB=1,nAsh(iS)
              ioff3=ioff2+nOrb(iS)*(iB-1)
              CVa(1)%SB(iS)%A2(iB,:) =
     &           W_CMO(ioff3+1:ioff3+nOrb(iS))
             Do jB=1,nAsh(iS)
              ip2=itri(nA(is)+ib,nA(is)+jb)
              DA%SB(iS)%A2(iB,jB)=G1t(ip2)
             End Do
            End Do
*MGD to check
            Call DGEMM_('T','T',nAsh(iS),nOrb(iS),nOrb(iS),
     &                  1.0d0,rkappa(ioff5),nOrb(iS),
     &                        W_CMO(1+ioff),nOrb(iS),
     &                  0.0d0,CVa(2)%SB(iS)%A2,nAsh(iS))
            ioff=ioff+(nIsh(iS)+nAsh(iS))*nOrb(iS)
            ioff4=ioff4+nOrb(iS)**2
          End Do
*
**      Expand 2-body density matrix
*
          Call mma_allocate(G2x,nG2,Label='G2x')
          ipGx=0
          Do ijS=1,nSym
            Do iS=1,nSym
              jS=iEOR(is-1,ijS-1)+1
              Do kS=1,nSym
                lS=iEOR(kS-1,ijS-1)+1
                Do kAsh=1,nAsh(ks)
                  Do lAsh=1,nAsh(ls)
                    ikl=itri(lAsh+nA(lS),kAsh+nA(kS))
                    Do iAsh=1,nAsh(is)
                      Do jAsh=1,nAsh(js)
                        iij =itri(iAsh+nA(is),jAsh+nA(jS))
                        ipGx=ipGx+1
                        G2x(ipGx)=G2t(itri(iij,ikl))
                      End Do
                    End Do
                  End Do
                End Do
              End Do
            End Do
          End Do
        End If
*
**      Allocate temp arrays and zero Fock matrices
*
        call dcopy_(nATri,[0.0d0],0,rMOs,1)
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
        Call RecPrt('DLT',' ',DLT%A0,1,SIZE(DLT%A0))
        Call RecPrt('DI ',' ',DI%A0 ,1,SIZE(DI%A0 ))
        Call RecPrt('DA ',' ',DA%A0 ,1,SIZE(DA%A0 ))
        Call RecPrt('G2x',' ',G2x,1,SIZE(G2x))
        Call RecPrt('rKappa ',' ',rKappa ,1,SIZE(rKappa))
#endif
*
**      Compute the whole thing
*
        Call Allocate_DT(Kappa,nBas,nBas,nSym,Ref=rKappa)
        Call Allocate_DT(JI(1),nBas,nBas,nSym,aCase='TRI')
        JI(1)%A0(:)=Zero
        Call Allocate_DT(KI,nBas,nBas,nSym)
        KI%A0(:)=Zero
        Call Allocate_DT(JA,nBas,nBas,nSym)
        JA%A0(:)=Zero
        Call Allocate_DT(KA,nBas,nBas,nSym)
        KA%A0(:)=Zero
        Call Allocate_DT(FkI,nBas,nBas,nSym,Ref=FockI)
        FkI%A0(:)=Zero
        Call Allocate_DT(FkA,nBas,nBas,nSym,Ref=FockA)
        FkA%A0(:)=Zero
        Call Allocate_DT(QVec,nBas,nAsh,nSym,Ref=Q)
        Call Allocate_DT(CMO,nBas,nAsh,nSym,Ref=W_CMO)
        Call Allocate_DT(CMO_Inv,nBas,nAsh,nSym,Ref=W_CMO_Inv)
        iread=2 ! Asks to read the half-transformed Cho vectors

        Call CHO_LK_MCLR(DLT,DI,DA,G2x,Kappa,JI,KI,JA,KA,FkI,FkA,
     &                   rMOs,QVec,CVa,CMO,CMO_inv,
     &                   nIsh, nAsh,DoAct,Fake_CMO2,
     &                   LuAChoVec,LuIChoVec,iread)

        Call Deallocate_DT(CMO_Inv)
        Call Deallocate_DT(CMO)
        Call Deallocate_DT(QVec)
        Call Deallocate_DT(FkA)
        Call Deallocate_DT(FkI)
        Call Deallocate_DT(KA)
        Call Deallocate_DT(JA)
        Call Deallocate_DT(KI)
        Call Deallocate_DT(JI(1))
        Call Deallocate_DT(Kappa)
        Call GADSum(FockI,nDens2)
        Call GADSum(FockA,nDens2)
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      nas=0
      Do iSym = 1, nSym
        Write (6,*) 'iSym=',iSym
*       Call RecPrt('FIMO ',' ', FIMO(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
*       Call RecPrt('FAMO ',' ', FAMO(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
        Call RecPrt('FockI',' ',FockI(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
        Call RecPrt('FockA',' ',FockA(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
*       Call RecPrt('Q',' ',Q(ipMatba(iSym,iSym)),nOrb(iSym),nAsh(iSym))
        nas = nas + nAsh(iSym)
      End Do
      nAtri=nas*(nas+1)/2
      nAtri=nAtri*(nAtri+1)/2
*     Call RecPrt('MO1',' ',rMOs,1,nAtri)
#endif
*
**      Calculate contribution from uncontracted indexes
*
        Do iS=1,nSym
          jS=iEOr(iS-1,iDSym-1)+1
          If (nOrb(iS)*nOrb(jS).ne.0) Then
            Call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(iS),Reco*Fact,
     &                  FIMO(ipCM(iS)),nOrb(is),
     &                  rkappa(ipMat(iS,jS)),nOrb(iS),
     &                  One,FockI(ipMat(iS,jS)),nOrb(iS))
            Call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(jS),Fact,
     &                  rkappa(ipMat(iS,jS)),nOrb(is),
     &                  FIMO(ipCM(jS)),nOrb(jS),
     &                  One,FockI(ipMat(iS,jS)),nOrb(is))
            If (iMethod.eq.2) Then
               Call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(iS),
     &                     Reco*Fact,
     &                     FAMO(ipCM(iS)),nOrb(is),
     &                     rkappa(ipMat(iS,jS)),nOrb(iS),
     &                     One,FockA(ipMat(iS,jS)),nOrb(iS))
               Call DGEMM_('N','N',nOrb(iS),nOrb(jS),nOrb(jS),Fact,
     &                     rkappa(ipMat(iS,jS)),nOrb(is),
     &                     FAMO(ipCM(jS)),nOrb(jS),
     &                     One,FockA(ipMat(iS,jS)),nOrb(is))
            End If
          End If
        End Do
*
**      Deallocate
*
        Call mma_deallocate(Dens2)

        If (iMethod.eq.2) Then
          Call mma_deallocate(G2x)
          Call Deallocate_DT(CVa(2))
          Call Deallocate_DT(CVa(1))
          Call deallocate_DT(DA)
        EndIf

        Call deallocate_DT(DLT)
        Call deallocate_DT(DI)

        Call GADSum(    Q,nDens2)
        Call GADSum( rMOs,nAtri)
*                                                                      *
************************************************************************
*                                                                      *
      End Select
*                                                                      *
************************************************************************
*                                                                      *
*
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      If (NewCho) Then
      nas=0
      Do iSym = 1, nSym
        Write (6,*) 'iSym=',iSym
        Call RecPrt('FockI',' ',FockI(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
        Call RecPrt('FockA',' ',FockA(ipCM(iSym)),nOrb(iSym),nIsh(iSym))
        Call RecPrt('Q',' ',Q(ipMatba(iSym,iSym)),nOrb(iSym),nAsh(iSym))
        nas = nas + nAsh(iSym)
      End Do
      nAtri=nas*(nas+1)/2
      nAtri=nAtri*(nAtri+1)/2
      Call RecPrt('MO1',' ',rMOs,1,nAtri)
      Call abend()
      End If
#endif

      Do iS=1,nSym
         jS=iEOr(iS-1,idsym-1)+1
*
*                I    A
*        F  =2( F  + F  )
*         pi     pi   pi
*
         If (nIsh(iS)*nOrb(jS).gt.0) Then
            Call DaXpY_(nIsh(iS)*nOrb(jS),2.0d0,
     &                 Focki(ipMat(js,is)),1,
     &                 Fock(ipMat(js,is)),1)
            If (iMethod.eq.2)  Call DaXpY_(nIsh(iS)*nOrb(jS),2.0d0,
     &                                    Focka(ipMat(js,is)),1,
     &                                    Fock(ipMat(js,is)),1)
         End If
*
         If (nOrb(iS).gt.0) Then
            Do iAsh=1,nAsh(jS)
               Do jAsh=1,nAsh(js)
                  ipF=ipMat(js,is)+nIsh(js)+jAsh-1
                  ipFI=ipMat(is,js)+(nIsh(js)+iAsh-1)*nOrb(is)
                  Dij=G1t(itri(iash+nA(js),jAsh+nA(js)))

*                I
*        F  = F - F  D
*         ap   ap  ap ba
*
                  ipF= ipMat(is,js)+(Nish(js)+iAsh-1)*nOrb(is)
                  ipFI=ipMat(is,js)+(Nish(js)+jAsh-1)*nOrb(is)
*
*                I
*        F  = F + F  D
*         pa   pa  pb ab
*
                  Call DaXpY_(nOrb(is),Dij,
     &                       Focki(ipFI),1,
     &                       Fock(ipF),1)
               End Do
            End Do
         End If
*
*
*      F  = F  + Q
*       pa   pa   pa
*
         If (nAsh(iS)*nOrb(jS).gt.0)
     &      Call DaXpY_(nAsh(is)*nOrb(js),1.0d0,
     &                 Q(ipMatba(js,is)),1,
     &                 Fock(ipMat(js,is)+nOrb(js)*nIsh(is)),1)
*
*
*      F  = F  - Q
*       ap   ap   ap
*
      End Do
#ifdef _DEBUGPRINT_
      Write (LuWr,*) 'Fock=',DDot_(nDens2,Fock,1,Fock,1)
#endif
*
      Call DYAX(ndens2,2.0d0,Fock,1,Focka,1)
      Do iS=1,nSym
        js=iEOR(is-1,idsym-1)+1
        If (nOrb(is)*nOrb(js).ne.0)
     &  Call DGESUB(Focka(ipMat(is,js)),nOrb(is),'N',
     &              Focka(ipMat(js,is)),nOrb(js),'T',
     %              Fock(ipMat(is,js)),nOrb(is),
     &              nOrb(is),nOrb(js))
      End Do
#ifdef _DEBUGPRINT_
      Write (LuWr,*) 'Fock=',DDot_(nDens2,Fock,1,Fock,1)
#endif
*
      Call AddGrad(rKappa,Fock,idsym,2.0d0*fact)
      If (.not.newCho) Then
        Call mma_allocate(MT3,nmba,Label='MT3')
        Call DZAXPY(nmba,1.0d0,MT1,1,
     &             MT2,1,MT3,1)
        Call PickMO_MCLR(MT3,rmos,idsym)
*
        If (ispop.ne.0) Then
           Call DZAXPY(nmba,-1.0d0,MT1,1,MT2,1,MT3,1)
           Call PickMO_MCLR(MT3,rmoa,idsym)
        End If
        Call mma_deallocate(MT3)
        Call mma_deallocate(MT2)
        Call mma_deallocate(MT1)
      EndIf
#ifdef _DEBUGPRINT_
      Write (LuWr,*) 'Exit RInt_Generic'
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Solvent_Data
! Database of optical and physical data for various solvents.

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

logical(kind=iwp) :: Initialized = .false.
integer(kind=iwp), parameter :: MxT = 4 ! Maximum number of atom types per solvent

type AtSolv
  integer(kind=iwp) :: NTT = 0
  real(kind=wp) :: RDiff = Zero, KT = Zero, RWT = Zero
end type AtSolv

type Solvent
  character(len=32) :: SName
  real(kind=wp) :: Eps, EpsInf, DerEps, RSolv, VMol, TCE !, STen, DSTen, CMF, Rho, Tabs
  type(AtSolv) :: Atoms(MxT)
end type Solvent

!Caillet-Claverie's atomic parameters for dispersion and repulsion.
!    H       He
!   Li       Be        B        C        N       O         F       Ne
!   Na       Mg       Al       Si        P       S        Cl       Ar
!    K       Ca
!            Sc       Ti        V       Cr       Mn       Fe       Co       Ni       Cu       Zn
!                     Ga       Ge       As       Se       Br       Kr
!   Rb       Sr
!             Y       Zr       Nb       Mo       Tc       Ru       Rh       Pd       Ag       Cd
!                     In       Sn       Sb       Te        I       Xe
! All zero (no data) after Xe
real(kind=wp), parameter :: DK(54) = [ &
  1.000_wp,0.594_wp, &
    Zero  ,  Zero  ,  Zero  ,1.000_wp,1.180_wp,1.360_wp,1.500_wp,1.209_wp, &
  1.400_wp,  Zero  ,  Zero  ,  Zero  ,2.100_wp,2.400_wp,2.100_wp,2.127_wp, &
  2.900_wp,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  , &
                      Zero  ,  Zero  ,  Zero  ,  Zero  ,2.400_wp,2.566_wp, &
    Zero  ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  , &
                      Zero  ,  Zero  ,  Zero  ,  Zero  ,3.200_wp,  Zero &
]
real(kind=wp), parameter :: R(54) = [ &
  1.20_wp ,1.28_wp , &
    Zero  ,  Zero  ,  Zero  ,1.70_wp ,1.60_wp ,1.50_wp ,1.45_wp ,1.38_wp , &
  1.20_wp ,  Zero  ,  Zero  ,  Zero  ,1.85_wp ,1.80_wp ,1.76_wp ,1.66_wp , &
  1.46_wp ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  , &
                      Zero  ,  Zero  ,  Zero  ,  Zero  ,1.85_wp ,1.76_wp , &
    Zero  ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  , &
                      Zero  ,  Zero  ,  Zero  ,  Zero  ,1.96_wp ,1.85_wp &
]

! Other atomic radii
!    H        He
!   Li        Be         B         C         N         O         F        Ne
!   Na        Mg        Al        Si         P         S        Cl        Ar
!    K        Ca
!             Sc        Ti         V        Cr        Mn        Fe        Co        Ni        Cu        Zn
!                       Ga        Ge        As        Se        Br        Kr
!   Rb        Sr (+2)
!             Y  (+3)   Zr (+4)   Nb (+5)   Mo (+6)   Tc (+5)   Ru (+2)   Rh (+3)   Pd (+2)   Ag (+1)   Cd (+2)
!                       In        Sn        Sb        Te         I        Xe
!   Cs        Ba (+2)
!             La (+3)   Ce (+3)   Pr (+3)   Nd (+3)   Pm (+3)   Sm (+3)   Eu (+3)
!             Gd (+3)   Tb (+3)   Dy (+3)   Ho (+3)   Er (+3)   Tm (+3)   Yb (+3)
!             Lu (+3)   Hf (+4)   Ta (+5)    W(+4,+6) Re(+5,+7) Os (+6)   Ir (+3)   Pt        Au        Hg
!                       Tl        Pb        Bi (+3)   Po (+2)   At        Rn (+4)
!   Fr        Ra (+2)
!             Ac (+3)   Th (+4)   Pa (+4)    U (+4)   Np (+4)   Pu (+4)   Am (+4)
!             Cm (+3)   Bk (+3)   Cf (+3)   Es (+3)   Fm (+3)   Md (+3)   No (+3)
!             Lw (+3)   Ru

! Pauling radii
real(kind=wp), parameter :: PRad(104) = [ &
  1.20_wp ,1.20_wp , &
  1.37_wp ,1.45_wp ,1.45_wp ,1.50_wp ,1.50_wp ,1.40_wp ,1.35_wp ,1.30_wp , &
  1.57_wp ,1.36_wp ,1.24_wp ,1.17_wp ,1.90_wp ,1.85_wp ,1.80_wp ,1.88_wp , &
  2.75_wp ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,1.63_wp ,1.40_wp ,1.39_wp , &
                    1.87_wp ,1.86_wp ,2.00_wp ,2.00_wp ,1.95_wp ,2.02_wp , &
    Zero  ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,1.63_wp ,1.72_wp ,1.58_wp , &
                    1.93_wp ,2.17_wp ,2.20_wp ,2.20_wp ,2.15_wp ,2.16_wp , &
    Zero  ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,1.72_wp ,1.66_wp ,1.55_wp , &
                    1.96_wp ,1.02_wp ,  Zero  ,  Zero  ,  Zero  ,  Zero  , &
    Zero  ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,1.86_wp ,  Zero  ,  Zero  ,  Zero  , &
             Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  ,  Zero  , &
             Zero  ,  Zero &
]
! Warning: the following are atomic diameters.
real(kind=wp), parameter :: UFFRad(0:104) = [ &
    Zero  , &
  2.886_wp,2.362_wp, &
  2.451_wp,2.745_wp,4.083_wp,3.851_wp,3.660_wp,3.500_wp,3.364_wp,3.243_wp, &
  2.983_wp,3.021_wp,4.499_wp,4.295_wp,4.147_wp,4.035_wp,3.947_wp,3.868_wp, &
  3.812_wp,3.399_wp, &
           3.295_wp,3.175_wp,3.144_wp,3.023_wp,2.961_wp,2.912_wp,2.872_wp,2.834_wp,3.495_wp,2.763_wp, &
                    4.383_wp,4.280_wp,4.230_wp,4.205_wp,4.189_wp,4.141_wp, &
  4.114_wp,3.641_wp, &
           3.345_wp,3.124_wp,3.165_wp,3.052_wp,2.998_wp,2.963_wp,2.929_wp,2.899_wp,3.148_wp,2.848_wp, &
                    4.463_wp,4.392_wp,4.420_wp,4.470_wp,4.50_wp,4.404_wp, &
  4.517_wp,3.703_wp, &
           3.522_wp,3.556_wp,3.606_wp,3.575_wp,3.547_wp,3.520_wp,3.493_wp, &
           3.368_wp,3.451_wp,3.428_wp,3.409_wp,3.391_wp,3.374_wp,3.355_wp, &
           3.640_wp,3.141_wp,3.170_wp,3.069_wp,2.954_wp,3.120_wp,2.840_wp,2.754_wp,3.293_wp,2.705_wp, &
                    4.347_wp,4.297_wp,4.370_wp,4.709_wp,4.750_wp,4.765_wp, &
  4.900_wp,3.677_wp, &
           3.478_wp,3.396_wp,3.424_wp,3.395_wp,3.424_wp,3.424_wp,3.381_wp, &
           3.326_wp,3.339_wp,3.313_wp,3.299_wp,3.286_wp,3.274_wp,3.248_wp, &
           3.236_wp,3.500_wp &
]
! Covalent radii
! Parameters for atoms heavier than At are
! taken from the UFF force field (A.K.Rappe',C.J.Casewit,K.S.Colwell,
! W.A.Goddard III and W.M.Skiff, J.Am.Chem.Soc. 114,10024 (1992)).
real(kind=wp), parameter :: CRad(0:104) = [ &
    Zero  , &
  0.354_wp,0.849_wp, &
  1.336_wp,1.010_wp,0.838_wp,0.757_wp,0.700_wp,0.658_wp,0.668_wp,0.920_wp, &
  1.539_wp,1.421_wp,1.244_wp,1.117_wp,1.101_wp,1.064_wp,1.044_wp,1.032_wp, &
  1.953_wp,1.761_wp, &
           1.513_wp,1.412_wp,1.402_wp,1.345_wp,1.382_wp,1.270_wp,1.241_wp,1.164_wp,1.302_wp,1.193_wp, &
                    1.260_wp,1.197_wp,1.211_wp,1.190_wp,1.192_wp,1.147_wp, &
  2.260_wp,2.052_wp, &
           1.698_wp,1.564_wp,1.473_wp,1.467_wp,1.322_wp,1.478_wp,1.332_wp,1.338_wp,1.386_wp,1.403_wp, &
                    1.459_wp,1.398_wp,1.407_wp,1.386_wp,1.382_wp,1.267_wp, &
  2.570_wp,2.277_wp, &
           1.943_wp,1.841_wp,1.823_wp,1.816_wp,1.801_wp,1.780_wp,1.771_wp, &
           1.735_wp,1.732_wp,1.710_wp,1.696_wp,1.673_wp,1.660_wp,1.637_wp, &
           1.671_wp,1.611_wp,1.511_wp,1.392_wp,1.372_wp,1.372_wp,1.371_wp,1.364_wp,1.262_wp,1.340_wp, &
                    1.518_wp,1.459_wp,1.512_wp,1.500_wp,1.545_wp,1.420_wp, &
  2.880_wp,2.512_wp, &
           1.983_wp,1.721_wp,1.711_wp,1.684_wp,1.666_wp,1.657_wp,1.660_wp, &
           1.801_wp,1.761_wp,1.750_wp,1.724_wp,1.712_wp,1.689_wp,1.679_wp, &
           1.698_wp,1.850_wp &
]

type(Solvent), protected :: SolvData(24)

public :: Init_Solvent_Data, Pauling, RCov97, SolvData

contains

subroutine Init_Solvent_Data()
  ! Skip if already initialized
  if (Initialized) return

  ! For each solvent, the following data is given:
  !     SName
  !     Eps
  !     EpsInf
  !     DerEps
  !     RSolv
  !     VMol
  !     TCE
  !     (commented out: STen, DSTen, CMF, Rho, and Tabs for some)
  ! and then, for each atom type in the solvent:
  !     NTT
  !     RDiff
  !     KT
  !     RWT
  ! (using default initialization for derived types does not play nice with all compilers)

  ! Water
  !                     Eps,     EpsInf,  DerEps,    RSolv,   VMol,    TCE,             STen,    DSTen,   CMF,     Rho
  SolvData(1) = Solvent('WATER', &
                        78.39_wp,1.776_wp,-0.3562_wp,1.385_wp,18.07_wp,2.57e-4_wp, & ! ,71.81_wp,0.650_wp,1.277_wp,3.348e-2_wp)
                        ! Atomic parameters for dispersion and repulsion
                        [AtSolv(1,1.5_wp,DK(8),R(8)), & ! Atom O
                         AtSolv(2,1.2_wp,DK(1),R(1)), & ! Atom H
                         AtSolv(0,Zero,Zero,Zero), &
                         AtSolv(0,Zero,Zero,Zero) &
                        ])

  ! Acetonitrile (Warning: RSolv and VMol for this solvent need to be checked)
  !                     Eps,     EpsInf,  DerEps,RSolv,   VMol,    TCE,              STen,    DSTen,   CMF,     Rho
  SolvData(2) = Solvent('ACETONITRILE', &
                        36.64_wp,1.806_wp, Zero ,2.155_wp,53.68_wp,1.192e-3_wp, & ! ,36.47_wp,1.373_wp,0.808_wp,1.153e-2_wp
                        ! Atomic parameters for dispersion and repulsion
                        [AtSolv(2,1.76_wp,DK(6),R(6)), & ! Atom C
                         AtSolv(3,1.2_wp,DK(1),R(1)), & ! Atom H
                         AtSolv(1,1.6_wp,DK(7),R(7)), & ! Atom N
                         AtSolv(0,Zero,Zero,Zero) &
                        ])

  ! Methanol
  !                     Eps,     EpsInf,  DerEps,    RSolv,   VMol,   TCE,              STen,    DSTen,   CMF,     Rho
  SolvData(3) = Solvent('METHANOL', &
                        32.63_wp,1.758_wp,-0.1984_wp,1.855_wp,40.7_wp,1.182e-3_wp, & ! ,22.12_wp,1.154_wp,1.776_wp,1.495e-2_wp
                        ! Atomic parameters for dispersion and repulsion
                        [AtSolv(1,1.76_wp,DK(6),R(6)), & ! Atom C
                         AtSolv(4,1.2_wp,DK(1),R(1)), & ! Atom H
                         AtSolv(1,1.5_wp,DK(8),R(8)), & ! Atom O
                         AtSolv(0,Zero,Zero,Zero) &
                        ])

  ! Ethanol
  !                     Eps,     EpsInf,  DerEps,    RSolv,   VMol,   TCE,              STen,    DSTen,   CMF,     Rho
  SolvData(4) = Solvent('ETHANOL', &
                        24.55_wp,1.847_wp,-0.1510_wp,2.180_wp,58.7_wp,1.103e-3_wp, & ! ,21.89_wp,1.146_wp,1.543_wp,1.032e-2_wp
                        ! Atomic parameters for dispersion and repulsion
                        [AtSolv(2,1.76_wp,DK(6),R(6)), & ! Atom C
                         AtSolv(6,1.2_wp,DK(1),R(1)), & ! Atom H
                         AtSolv(1,1.5_wp,DK(8),R(8)), & ! Atom O
                         AtSolv(0,Zero,Zero,Zero) &
                        ])

  ! IsoQuinoline
  !                     Eps,     EpsInf,  DerEps,RSolv,  VMol,     TCE,              STen,    DSTen, CMF,   Rho
  SolvData(5) = Solvent('ISOQUINOLINE', &
                        10.43_wp,1.010_wp, Zero ,3.50_wp,117.27_wp,1.255e-3_wp, & ! ,26.53_wp, Zero , Zero ,5.135e-3_wp
                        ! Atomic parameters for dispersion and repulsion
                        [AtSolv(9,1.5_wp,DK(6),R(6)), & ! Atom C
                         AtSolv(7,1.2_wp,DK(1),R(1)), & ! Atom H
                         AtSolv(1,1.6_wp,DK(7),R(7)), & ! Atom N
                         AtSolv(0,Zero,Zero,Zero) &
                        ])

  ! Quinoline
  !                     Eps,    EpsInf,  DerEps,RSolv,  VMol,     TCE,              STen,    DSTen, CMF,   Rho
  SolvData(6) = Solvent('QUINOLINE', &
                        9.03_wp,1.010_wp, Zero ,3.50_wp,117.27_wp,1.255e-3_wp, & ! ,26.53_wp, Zero , Zero ,5.135e-3_wp
                        ! Atomic parameters for dispersion and repulsion
                        [AtSolv(9,1.5_wp,DK(6),R(6)), & ! Atom C
                         AtSolv(7,1.2_wp,DK(1),R(1)), & ! Atom H
                         AtSolv(1,1.6_wp,DK(7),R(7)), & ! Atom N
                         AtSolv(0,Zero,Zero,Zero) &
                        ])

  ! Chloroform
  !                     Eps,    EpsInf,  DerEps,RSolv,  VMol,   TCE,              STen,    DSTen, CMF,   Rho
  SolvData(7) = Solvent('CHLOROFORM', &
                        4.90_wp,2.085_wp, Zero ,2.48_wp,80.7_wp,1.255e-3_wp, & ! ,26.53_wp, Zero , Zero ,7.482e-3_wp
                        ! Atomic parameters for dispersion and repulsion
                        [AtSolv(1,2.82_wp,DK(6),R(6)), & ! Atom C
                         AtSolv(1,1.2_wp,DK(1),R(1)), & ! Atom H
                         AtSolv(3,1.79_wp,DK(17),R(17)), & ! Atom Cl
                         AtSolv(0,Zero,Zero,Zero) &
                        ])

  ! EthylEther
  !                     Eps,     EpsInf,DerEps,RSolv,   VMol,      TCE,             STen,  DSTen, CMF,   Rho
  SolvData(8) = Solvent('ETHYLETHER', &
                        4.335_wp, Zero , Zero ,2.785_wp,103.84_wp,1.617e-3_wp, & ! , Zero , Zero , Zero ,5.799e-3_wp
                        ! Atomic parameters for dispersion and repulsion
                        [AtSolv(4,1.76_wp,DK(6),R(6)), & ! Atom C
                         AtSolv(10,1.2_wp,DK(1),R(1)), & ! Atom H
                         AtSolv(1,1.50_wp,DK(8),R(8)), & ! Atom O
                         AtSolv(0,Zero,Zero,Zero) &
                        ])

  ! MethyleneChloride
  !                     Eps,    EpsInf,  DerEps,RSolv,  VMol,   TCE,              STen,    DSTen, CMF,   Rho
  SolvData(9) = Solvent('METHYLENECHLORIDE', &
                        8.93_wp,2.020_wp, Zero ,2.27_wp,64.5_wp,1.367e-3_wp, & ! ,27.33_wp, Zero , Zero ,9.74e-3_wp
                        ! Atomic parameters for dispersion and repulsion
                        [AtSolv(1,1.76_wp,DK(6),R(6)), & ! Atom C
                         AtSolv(2,1.2_wp,DK(1),R(1)), & ! Atom H
                         AtSolv(2,1.79_wp,DK(17),R(17)), & ! Atom Cl
                         AtSolv(0,Zero,Zero,Zero) &
                        ])

  ! DiChloroEthane
  !                      Eps,     EpsInf,  DerEps,RSolv,   VMol,   TCE,              STen,    DSTen, CMF,   Rho
  SolvData(10) = Solvent('DICHLOROETHANE', &
                         10.36_wp,2.085_wp, Zero ,2.505_wp,79.4_wp,1.156e-3_wp, & ! ,31.54_wp, Zero , Zero ,7.576e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(2,1.76_wp,DK(6),R(6)), &  ! Atom C
                          AtSolv(4,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(2,1.79_wp,DK(17),R(17)), & ! Atom Cl
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! CarbonTetraChloride
  !                      Eps,     EpsInf,  DerEps,RSolv,   VMol,   TCE,              STen,    DSTen,   CMF,     Rho
  SolvData(11) = Solvent('CARBONTETRACHLORIDE', &
                         2.228_wp,2.129_wp, Zero ,2.685_wp,96.5_wp,1.270e-3_wp, & ! ,26.15_wp,1.436_wp,0.629_wp,6.241e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(1,2.82_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(4,1.79_wp,DK(17),R(17)), & ! Atom Cl
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! Benzene
  !                      Eps,     EpsInf,  DerEps,RSolv,  VMol,    TCE,              STen,    DSTen,   CMF,     Rho
  SolvData(12) = Solvent('BENZENE', &
                         2.247_wp,2.244_wp, Zero ,2.63_wp,88.91_wp,1.380e-3_wp, & ! ,28.18_wp,1.469_wp,0.629_wp,6.773e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(6,1.5_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(6,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! Toluene
  !                      Eps,     EpsInf,  DerEps,RSolv,  VMol,    TCE,             STen,    DSTen,   CMF,     Rho
  SolvData(13) = Solvent('TOLUENE', &
                         2.379_wp,2.232_wp, Zero ,2.82_wp,106.3_wp,1.08e-3_wp, & ! ,27.92_wp,1.391_wp,0.679_wp,5.665e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(7,1.5_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(8,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! Chlorobenzene
  !                      Eps,     EpsInf,  DerEps,RSolv,   VMol,     TCE,              STen,    DSTen, CMF,   Rho
  SolvData(14) = Solvent('CHLOROBENZENE', &
                         5.621_wp,2.320_wp, Zero ,2.805_wp,101.79_wp,0.981e-3_wp, & ! ,32.69_wp, Zero , Zero ,5.916e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(6,1.5_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(5,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(1,1.79_wp,DK(17),R(17)), & ! Atom Cl
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! NitroMethane
  !                      Eps,     EpsInf,  DerEps,RSolv,   VMol,    TCE,              STen,    DSTen,   CMF,     Rho
  SolvData(15) = Solvent('NITROMETHANE', &
                         38.20_wp,1.904_wp, Zero ,2.155_wp,53.68_wp,1.192e-3_wp, & ! ,36.47_wp,1.373_wp,0.808_wp,1.122e-2_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(1,1.76_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(3,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(1,1.6_wp,DK(7),R(7)), & ! Atom N
                          AtSolv(2,1.5_wp,DK(8),R(8)) & ! Atom O
                         ])

  ! Heptane
  !                      Eps,    EpsInf,  DerEps,RSolv,   VMol,     TCE,             STen,    DSTen,   CMF,     Rho
  SolvData(16) = Solvent('HEPTANE', &
                         1.92_wp,1.918_wp, Zero ,3.125_wp,146.56_wp,1.25e-3_wp, & ! ,19.80_wp,1.505_wp,0.687_wp,4.109e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(7,1.76_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(16,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! Cyclohexane
  !                      Eps,     EpsInf,  DerEps,RSolv,   VMol,     TCE,             STen,    DSTen,   CMF,     Rho
  SolvData(17) = Solvent('CYCLOHEXANE', &
                         2.023_wp,2.028_wp, Zero ,2.815_wp,108.10_wp,1.20e-3_wp, & ! ,24.38_wp,1.467_wp,0.621_wp,5.571e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(6,1.76_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(12,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! Aniline
  !                      Eps,    EpsInf,  DerEps,RSolv,  VMol,    TCE,             STen,    DSTen,   CMF,     Rho
  SolvData(18) = Solvent('ANILINE', &
                         6.89_wp,2.506_wp, Zero ,2.80_wp,91.15_wp,0.85e-3_wp, & ! ,42.79_wp,0.731_wp,0.972_wp,6.607e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(6,1.5_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(7,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(1,1.6_wp,DK(7),R(7)), & ! Atom N
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! Acetone
  !                      Eps,    EpsInf,  DerEps,     RSolv,  VMol,    TCE,             STen,    DSTen, CMF,   Rho
  SolvData(19) = Solvent('ACETONE', &
                         20.7_wp,1.841_wp,-9.77e-2_wp,2.38_wp,73.52_wp,1.42e-3_wp, & ! ,22.67_wp, Zero , Zero ,8.190e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(3,1.76_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(6,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(1,1.5_wp,DK(8),R(8)), & ! Atom O
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! TetraHydroFuran
  !                      Eps,    EpsInf,  DerEps,RSolv,  VMol,    TCE,              STen,    DSTen, CMF,   Rho
  SolvData(20) = Solvent('TETRAHYDROFURAN', &
                         7.58_wp,1.971_wp, Zero ,2.56_wp,81.11_wp,1.142e-3_wp, & ! ,26.40_wp, Zero , Zero ,7.425e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(4,1.76_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(8,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(1,1.5_wp,DK(8),R(8)), & ! Atom O
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! DiMethylSulfoxide
  !                      Eps,    EpsInf,  DerEps,    RSolv,   VMol,    TCE,             STen,    DSTen, CMF,   Rho
  SolvData(21) = Solvent('DIMETHYLSULFOXIDE', &
                         46.7_wp,2.179_wp,-0.1902_wp,2.455_wp,70.94_wp,9.82e-2_wp, & ! ,42.86_wp, Zero , Zero ,8.49e-3_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(2,1.76_wp,DK(6),R(6)), & ! Atom C
                          AtSolv(6,1.2_wp,DK(1),R(1)), & ! Atom H
                          AtSolv(1,1.80_wp,DK(16),R(16)), & ! Atom S
                          AtSolv(1,1.5_wp,DK(8),R(8)) & ! Atom O
                         ])

  ! Argon
  ! Warning: the following data are referred to the absolute
  !          temperature of 118 K (the highest available). Change
  !          the parameter Tabs to this value in actual calculations.
  !          To use other temperatures, one has to provide also the
  !          corresponding density (in g cm-3) to compute RHO (i.e.
  !          the numeral density) and VMol (i.e. the molar volume)
  !          properly. Of course, the proper dielectric constant
  !          must be provided too.
  !                      Eps,     EpsInf,  DerEps,RSolv,   VMol,    TCE,             STen,    DSTen, CMF,   Rho,        Tabs
  SolvData(22) = Solvent('ARGON', &
                         1.430_wp,1.430_wp, Zero ,1.875_wp,34.29_wp,9.82e-2_wp, & ! ,42.86_wp, Zero , Zero ,1.756e-2_wp,118.0_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(1,1.875_wp,DK(18),R(18)), & ! Atom Ar
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! Krypton
  ! Warning: the following data are referred to the absolute
  !          temperature of 168 K (the highest available). Change
  !          the parameter Tabs to this value in actual calculations.
  !          To use other temperatures, one has to provide also the
  !          corresponding density (in g cm-3) to compute RHO (i.e.
  !          the numeral density) and VMol (i.e. the molar volume)
  !          properly. Of course, the proper dielectric constant
  !          must be provided too.
  !                      Eps,     EpsInf,  DerEps,RSolv,  VMol,    TCE,             STen,    DSTen, CMF,   Rho,        Tabs
  SolvData(23) = Solvent('KRYPTON', &
                         1.519_wp,1.519_wp, Zero ,2.07_wp,42.71_wp,9.82e-2_wp, & ! ,42.86_wp, Zero , Zero ,1.410e-2_wp,168.0_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(1,2.07_wp,DK(36),R(36)), & ! Atom Kr
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  ! Xenon
  ! Warning: the following data are referred to the absolute
  !          temperature of 210 K (the highest available). Change
  !          the parameter Tabs to this value in actual calculations.
  !          To use other temperatures, one has to provide also the
  !          corresponding density (in g cm-3) to compute RHO (i.e.
  !          the numeral density) and VMol (i.e. the molar volume)
  !          properly. Of course, the proper dielectric constant
  !          must be provided too.
  !                      Eps,     EpsInf,  DerEps,RSolv,  VMol,    TCE,             STen,    DSTen, CMF,   Rho,        Tabs
  SolvData(24) = Solvent('XENON', &
                         1.706_wp,1.706_wp, Zero ,2.20_wp,50.38_wp,9.82e-2_wp, & ! ,42.86_wp, Zero , Zero ,1.195e-2_wp,210.0_wp
                         ! Atomic parameters for dispersion and repulsion
                         [AtSolv(1,2.20_wp,DK(53),R(53)), & ! Atom Xe
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero), &
                          AtSolv(0,Zero,Zero,Zero) &
                         ])

  Initialized = .true.

end subroutine Init_Solvent_Data

function Pauling(Z)
! Pauling radius for atomic number Z (UFF when not defined)
  real(kind=wp) :: Pauling
  integer(kind=iwp), intent(in) :: Z
  Pauling = PRad(Z)
  if (Pauling == Zero) Pauling = UFFRad(Z)
end function Pauling

function RCov97(Za,Zb)
! This function returns an estimated covalent bond distance (in Ang)
! between atoms of atomic numbers Za and Zb. Setting Zb to 0 returns
! the covalent radius of Za.
  real(kind=wp) :: RCov97
  integer(kind=iwp), intent(in) :: Za, Zb
  integer(kind=iwp) :: i, j
  i = min(max(Za,lbound(CRad,1)),ubound(CRad,1))
  j = min(max(Zb,lbound(CRad,1)),ubound(CRad,1))
  RCov97 = CRad(i)+CRad(j)
end function RCov97

end module Solvent_Data

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000-2016, Valera Veryazov                             *
************************************************************************
******************************************************************************
*                                                                            *
* Author:   Valera Veryazov 2000-2016                                        *
*           Theoretical Chemistry                                            *
*           Lund University                                                  *
*           Sweden                                                           *
*                                                                            *
******************************************************************************
*
*
*   Use this routine wisely!
*
*
*   in case if you would like to block some dev. code
*   from usage, or apply some conditions for this:
*
*   add a call
*     Call OnlyIMayUseIt("name")
*
*


      subroutine OnlyIMayUseIt(Name)
      Character*(*) Name
      character*256 value
      character*1024 message
      isdev=0
      value=' '
      call getenvf('MOLCAS_ISDEV',value)
      if(value.eq.'PRODUCTION') then
      isdev=1
      return
      endif
      if(value.eq.' '.or.value.ne.Name) then
      message='This code is for testing purpose only;'//
     * 'if you want to use it by other means, ;'//
     * 'e.g. to publish the results -- you must contact;'//
     * Name//' to find the conditions applied;;'//
     * 'Alternatively you may either use the production version;'
      isdev=1
      Call WarningMessage(2,message)
      return
      endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE NRCOUP_CP2(IDRT,ISGMNT,NOW,IOW,NOCP,IOCP,
     &                  NOCSF,IOCSF,NRL,MVL,MVR)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "pt2_guga.fh"
      COMMON /SEGTAB/ IC1(26),IC2(26),ITVPT(26),IBVPT(26),ISVC(26),
     &                NIVR,LIVR,NSGMNT,LSGMNT
C INPUT PARAMETERS:
      DIMENSION MVL(NMIDV,2),MVR(NMIDV,2)
      DIMENSION IDRT(NVERT,5),ISGMNT(NVERT,26)
      PARAMETER (LTAB=1)
C OUTPUT PARAMETERS:
      DIMENSION NOW(2,NSYM,NMIDV),NOCP(MXEO,NSYM,NMIDV)
      DIMENSION IOW(2,NSYM,NMIDV),IOCP(MXEO,NSYM,NMIDV)
      DIMENSION NOCSF(NSYM,NMIDV,NSYM),IOCSF(NSYM,NMIDV,NSYM)
C SCRATCH PARAMETERS:
      DIMENSION NRL(NSYM,NVERT,0:MXEO)

      DO 10 INDEO=0,MXEO
        DO 11 IV=1,MIDV2
          DO 12 LFTSYM=1,NSYM
            NRL(LFTSYM,IV,INDEO)=0
  12      CONTINUE
  11    CONTINUE
  10  CONTINUE
      NRL(1,1,0)=1

      DO 101 IVLT=1,MIDV1-1
        LEV=IDRT(IVLT,LTAB)
        DO 102 ISGT=1,26
          IVLB=ISGMNT(IVLT,ISGT)
          IF(IVLB.EQ.0) GOTO 102
          ICL=IC1(ISGT)
          ISYM=1
          IF((ICL.EQ.1).OR.(ICL.EQ.2)) ISYM=ISM(LEV)
          DO 100 ITSYM=1,NSYM
            IBSYM=MUL(ITSYM,ISYM)

      IF(ISGT.LE.4) THEN
C THIS IS AN UPPER WALK.
        NRL(IBSYM,IVLB,0)=NRL(IBSYM,IVLB,0)+NRL(ITSYM,IVLT,0)
        GOTO 100
      END IF
      IF(ISGT.LE.8) THEN
C THIS IS AN TOP SEGMENT.
        INDEO=LEV+(IBVPT(ISGT)-1)*NLEV
        NRL(IBSYM,IVLB,INDEO)=NRL(IBSYM,IVLB,INDEO)+NRL(ITSYM,IVLT,0)
        GOTO 100
      END IF
      IF(ISGT.LE.18) THEN
C THIS IS A MID-SEGMENT.
        DO 110 IP=LEV+1,NLEV
          INDEOT=IP+(ITVPT(ISGT)-1)*NLEV
          INDEOB=IP+(IBVPT(ISGT)-1)*NLEV
          NRL(IBSYM,IVLB,INDEOB)=NRL(IBSYM,IVLB,INDEOB)+
     &            NRL(ITSYM,IVLT,INDEOT)
 110    CONTINUE
        GOTO 100
      END IF
      IF(ISGT.LE.22) THEN
C THIS IS A BOTTOM SEGMENT.
        DO 120 IP=LEV+1,NLEV
          INDEOT=IP+(ITVPT(ISGT)-1)*NLEV
          IPQ=(IP*(IP-1))/2 + LEV
          INDEOB=IPQ+2*NLEV
          NRL(IBSYM,IVLB,INDEOB)=NRL(IBSYM,IVLB,INDEOB) +
     &          NRL(ITSYM,IVLT,INDEOT)
 120    CONTINUE
        GOTO 100
      END IF
C THIS IS A LOWER WALK.
      DO 130 INDEO=2*NLEV+1,MXEO
        NRL(IBSYM,IVLB,INDEO)=NRL(IBSYM,IVLB,INDEO)+
     &         NRL(ITSYM,IVLT,INDEO)
 130  CONTINUE

 100  CONTINUE
 102    CONTINUE
 101  CONTINUE

      MXUP=0
      DO 140 MV=1,NMIDV
        IVLT=MV+MIDV1-1
        DO 141 LFTSYM=1,NSYM
          NOW(1,LFTSYM,MV)=NRL(LFTSYM,IVLT,0)
          MXUP=MAX(MXUP,NOW(1,LFTSYM,MV))
          DO 142 INDEO=1,MXEO
            NOCP(INDEO,LFTSYM,MV)=NRL(LFTSYM,IVLT,INDEO)
 142      CONTINUE
 141    CONTINUE
 140  CONTINUE

      DO 150 INDEO=0,MXEO
        DO 151 IV=MIDV1,NVERT
          DO 152 LFTSYM=1,NSYM
            NRL(LFTSYM,IV,INDEO)=0
  152     CONTINUE
  151   CONTINUE
  150 CONTINUE
      NRL(1,NVERT,0)=1

      DO 201 IVLT=NVERT-1,MIDV1,-1
        LEV=IDRT(IVLT,LTAB)
        DO 202 ISGT=1,26
          IVLB=ISGMNT(IVLT,ISGT)
          IF(IVLB.EQ.0) GOTO 202
          ICL=IC1(ISGT)
          ISYM=1
          IF((ICL.EQ.1).OR.(ICL.EQ.2)) ISYM=ISM(LEV)
          DO 200 ITSYM=1,NSYM
            IBSYM=MUL(ITSYM,ISYM)
      IF(ISGT.GE.23) THEN
C THIS IS A LOWER WALK.
        NRL(ITSYM,IVLT,0)=NRL(ITSYM,IVLT,0)+NRL(IBSYM,IVLB,0)
        GOTO 200
      END IF
      IF(ISGT.GE.19) THEN
C THIS IS AN BOTTOM SEGMENT.
        INDEO=LEV+(ITVPT(ISGT)-1)*NLEV
        NRL(ITSYM,IVLT,INDEO)=NRL(ITSYM,IVLT,INDEO)+NRL(IBSYM,IVLB,0)
        GOTO 200
      END IF
      IF(ISGT.GE.9) THEN
C THIS IS A MID-SEGMENT.
        DO 210 IQ=1,LEV-1
          INDEOT=IQ+(ITVPT(ISGT)-1)*NLEV
          INDEOB=IQ+(IBVPT(ISGT)-1)*NLEV
          NRL(ITSYM,IVLT,INDEOT)=NRL(ITSYM,IVLT,INDEOT)+
     &            NRL(IBSYM,IVLB,INDEOB)
 210    CONTINUE
        GOTO 200
      END IF
      IF(ISGT.GE.5) THEN
C THIS IS AN TOP SEGMENT.
        DO 220 IQ=1,LEV-1
          INDEOB=IQ+(IBVPT(ISGT)-1)*NLEV
          IPQ=(LEV*(LEV-1))/2+IQ
          INDEOT=IPQ+2*NLEV
          NRL(ITSYM,IVLT,INDEOT)=NRL(ITSYM,IVLT,INDEOT) +
     &          NRL(IBSYM,IVLB,INDEOB)
 220    CONTINUE
        GOTO 200
      END IF
C THIS IS AN UPPER WALK.
      DO 230 IPQ=1,(LEV*(LEV-1))/2
        INDEO=2*NLEV+IPQ
        NRL(ITSYM,IVLT,INDEO)=NRL(ITSYM,IVLT,INDEO)+
     &         NRL(IBSYM,IVLB,INDEO)
 230  CONTINUE

 200  CONTINUE
 202    CONTINUE
 201  CONTINUE

      MXDWN=0
      DO 240 MV=1,NMIDV
        IVLT=MV+MIDV1-1
        DO 241 LFTSYM=1,NSYM
          NOW(2,LFTSYM,MV)=NRL(LFTSYM,IVLT,0)
          MXDWN=MAX(MXDWN,NOW(2,LFTSYM,MV))
          DO 242 INDEO=1,MXEO
            N=NRL(LFTSYM,IVLT,INDEO)
            IF(N.NE.0) NOCP(INDEO,LFTSYM,MV)=N
 242      CONTINUE
 241    CONTINUE
 240  CONTINUE

      NUW=0
      DO 251 MV=1,NMIDV
        DO 252 ISYM=1,NSYM
          IOW(1,ISYM,MV)=NUW*NIPWLK
          NUW=NUW+NOW(1,ISYM,MV)
 252    CONTINUE
 251  CONTINUE
      NWALK=NUW
      DO 253 MV=1,NMIDV
        DO 254 ISYM=1,NSYM
          IOW(2,ISYM,MV)=NWALK*NIPWLK
          NWALK=NWALK+NOW(2,ISYM,MV)
 254    CONTINUE
 253  CONTINUE
      NLW=NWALK-NUW

      NICOUP=0
      DO 260 INDEO=1,MXEO
        DO 261 MV=1,NMIDV
          DO 262 LFTSYM=1,NSYM
            IOCP(INDEO,LFTSYM,MV)=NICOUP
            NICOUP=NICOUP+NOCP(INDEO,LFTSYM,MV)
 262      CONTINUE
 261    CONTINUE
 260  CONTINUE

      DO 270 ISYTOT=1,NSYM
        NCSF(ISYTOT)=0
        DO 271 MV=1,NMIDV
          DO 272 ISYUP=1,NSYM
            ISYDWN=MUL(ISYTOT,ISYUP)
            N=NOW(1,ISYUP,MV)*NOW(2,ISYDWN,MV)
            NOCSF(ISYUP,MV,ISYTOT)=N
            IOCSF(ISYUP,MV,ISYTOT)=NCSF(ISYTOT)
            NCSF(ISYTOT)=NCSF(ISYTOT)+N
 272      CONTINUE
 271    CONTINUE
 270  CONTINUE
C
      NSGMX=1
      NSGTMP=MAX(MXUP,MXDWN)
      DO 550 MV3=1,NMIDV
        MV1=MVL(MV3,2)
        MV2=MVL(MV3,1)
        MV4=MVR(MV3,1)
        MV5=MVR(MV3,2)
      DO 551 ISYUS1=1,NSYM
        NUPS1=NOW(1,ISYUS1,MV3)
      DO 552 ISYDS1=1,NSYM
        NSGMX=MAX(NSGMX,NOCSF(ISYUS1,MV3,ISYDS1))
        IF (MV1.NE.0)THEN
          NT4TMP=NUPS1*NOW(2,ISYDS1,MV1)
          NSGTMP=MAX(NSGTMP,NT4TMP)
        ENDIF
        IF (MV2.NE.0)THEN
          NT3TMP=NUPS1*NOW(2,ISYDS1,MV2)
          NSGTMP=MAX(NSGTMP,NT3TMP)
        ENDIF
        IF (MV4.NE.0)THEN
          NT1TMP=NUPS1*NOW(2,ISYDS1,MV4)
          NSGTMP=MAX(NSGTMP,NT1TMP)
        ENDIF
        IF (MV5.NE.0)THEN
          NT2TMP=NUPS1*NOW(2,ISYDS1,MV5)
          NSGTMP=MAX(NSGTMP,NT2TMP)
        ENDIF
  552 CONTINUE
  551 CONTINUE
  550 CONTINUE
      CALL GETMEM('LSGTMP','ALLO','REAL',LSGTMP,NSGTMP)
C
#ifdef _DEBUGPRINT_
      WRITE(6,600)MXUP,MXDWN,
     &            NSGMX,NSGMX,NSGTMP
  600 FORMAT(/,' MAXIMUM NUMBER OF WALKS',
     &       /,' UPPER ',I6,' LOWER ',I6,
     &       /,' LENGTH OF LARGEST WORK ARRAYS IN SUBROUTINE SIGMA',
     &       /,' TEMPORARY SGM1 ',I7,
     &       /,' TEMPORARY SGM2 ',I7,
     &       /,' NSGTMP         ',I7)
C
CAR   END OF INSERT
        WRITE(6,*)
        WRITE(6,*)' TOTAL NR OF WALKS: UPPER ',NUW
        WRITE(6,*)'                    LOWER ',NLW
        WRITE(6,*)'                     SUM  ',NWALK
        WRITE(6,*)' TOTAL NR OF COUPL COEFFS ',NICOUP
        INDEO=2*NLEV+1
        WRITE(6,*)'         OF TYPE 1&2 ONLY:',IOCP(INDEO,1,1)
        WRITE(6,*)
        WRITE(6,*)' NR OF CONFIGURATIONS/SYMM:'
        WRITE(6,'(8(1X,I8))')(NCSF(IS),IS=1,NSYM)
        WRITE(6,*)

        WRITE(6,*)
        WRITE(6,*)' NR OF WALKS AND CONFIGURATIONS IN NRCOUP'
        WRITE(6,*)' BY MIDVERTEX AND SYMMETRY.'
        DO 310 MV=1,NMIDV
          WRITE(6,*)
          WRITE(6,1234) MV,(NOW(1,IS,MV),IS=1,NSYM)
          WRITE(6,1235)    (NOW(2,IS,MV),IS=1,NSYM)
          DO 305 IST=1,NSYM
            WRITE(6,1236)IST,(NOCSF(IS,MV,IST),IS=1,NSYM)
 305      CONTINUE
 1234 FORMAT('  MV=',I2,'    UPPER WALKS:',8I6)
 1235 FORMAT('           LOWER WALKS:',8I6)
 1236 FORMAT(' IST=',I2,'  CONFIGURATIONS:',8I6)
 310    CONTINUE
        WRITE(6,*)
        WRITE(6,*)' NR OF COUPLING COEFFICIENTS:'
        WRITE(6,*)' 1. OPEN LOOPS TYPE 1:'
        DO 320 IP=1,NLEV
          DO 321 MV=1,NMIDV
            DO 322 IS=1,NSYM
              NCP=NOCP(IP,IS,MV)
              IF(NCP.EQ.0) GOTO 322
              WRITE(6,2345) IP,MV,IS,NCP
 2345 FORMAT(' P=',I2,'  MV=',I2,' SYMM ',I1,' NOCP=',I4)
 322        CONTINUE
 321      CONTINUE
 320    CONTINUE
        WRITE(6,*)
        WRITE(6,*)' 2. OPEN LOOPS TYPE 2:'
        DO 330 IP=1,NLEV
          DO 331 MV=1,NMIDV
            DO 332 IS=1,NSYM
              NCP=NOCP(NLEV+IP,IS,MV)
              IF(NCP.EQ.0) GOTO 332
              WRITE(6,2345) IP,MV,IS,NCP
 332       CONTINUE
 331     CONTINUE
 330    CONTINUE
        WRITE(6,*)
        WRITE(6,*)' 3. CLOSED LOOPS:'
        DO 340 IP=2,NLEV
          DO 341 IQ=1,IP-1
            INDEO=2*NLEV+(IP*(IP-1))/2+IQ
            DO 342 MV=1,NMIDV
              DO 343 IS=1,NSYM
                NCP=NOCP(INDEO,IS,MV)
                IF(NCP.EQ.0) GOTO 343
                WRITE(6,2346) IP,IQ,MV,IS,NCP
 2346 FORMAT(' P=',I2,'  Q=',I2,'  MV=',I2,' SYMM ',I1,' NOCP=',I4)
 343          CONTINUE
 342        CONTINUE
 341      CONTINUE
 340    CONTINUE
#endif

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DMInvKap(rMFact,iMFact,rIn,rOut,rtemp,isym,iter)
!***********************************************************************
!                                                                      *
!     _____     -1                                                     *
!     Kappa  = M  Kappa                                                *
!          ip   pq     iq                                              *
!                                                                      *
!                                                                      *
!     In: rMFact        Factorized preconditioner (diagonal part       *
!                       of the electronic hessian that couple          *
!                       rotations with one common index)               *
!     Out: rOut         Orbital rotaotion                              *
!                                                                      *
!     iSym              Symmetry of rotation                           *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: Mul
use Spool, only: LuWr
use MCLR_Data, only: ipMat, nDens, nDensC, SA
use input_mclr, only: nAsh, nIsh, nOrb, nRs1, nRs2, nRs3, nSym, PT2
use dmrginfo, only: DoDMRG, LRRAS2, RGRAS2
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: rMFact(*), rIn(nDensC)
integer(kind=iwp), intent(in) :: iMFact(*), iter
real(kind=wp), intent(out) :: rOut(nDensC), rtemp(nDens)
integer(kind=iwp), intent(inout) :: iSym
integer(kind=iwp) :: ii, ip1, ip2, ipi, iRC, iS, jS, nd
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
ip1 = 1
ipi = 1

if (doDMRG) then  ! yma
  nash(:) = RGras2(:)
  nrs2(:) = RGras2(:)
end if

call Uncompress2(rIn,rtemp,isym)
!                                                                      *
!***********************************************************************
!                                                                      *
do jS=1,nSym
  iS = Mul(js,iSym)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !    kappa
  !         ip
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do iI=1,nIsh(js)
    nD = nOrb(is)-nIsh(is)
    if (nd /= 0) then
      ip2 = ipMat(is,js)+nOrb(is)*(iI-1)
      irc = 0
      call dgetrs_('N',ND,1,rMFact(ip1),nd,iMFact(ipi),rtemp(ip2),nd,irc)
      if (irc /= 0) then
        write(u6,*) 'Error in DGETRS called from dminvkap'
        call Abend()
      end if
      ip1 = ip1+nD**2
      ipi = ipi+nD
    end if
  end do

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !    kappa
  !         ap
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  do iI=1,nAsh(js)
    nD = nOrb(is)-nAsh(is)
    if (SA .or. PT2) then
      if (iI <= nRs1(jS)) then
        nD = nOrb(is)-nRs1(js)
      else if (iI <= nRs1(jS)+nRs2(jS)) then
        nD = nOrb(is)-nRs2(js)
      else if (iI <= nRs1(jS)+nRs2(jS)+nRs3(jS)) then
        nD = nOrb(is)-nRs3(js)
      end if
    end if
    if (nd /= 0) then
      ip2 = ipMat(is,js)+nOrb(is)*(iI-1+nIsh(js))
      irc = 0
      call dgetrs_('N',ND,1,rMFact(ip1),nd,iMFact(ipi),rtemp(ip2),nd,irc)
      if (irc /= 0) then
        write(u6,*) 'Error in DGETRS called from dminvkap'
        call Abend()
      end if
      ip1 = ip1+nD**2
      ipi = ipi+nD
    end if
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call Compress2(rtemp,rOut,isym)

if (doDMRG) nash(:) = LRras2(:)
!                                                                      *
!***********************************************************************
!                                                                      *
! Warn if the trial vector becomes large

if ((ddot_(nDensC,rOut,1,rOut,1) > 100.0_wp) .and. (iter == 1)) then
  write(LuWr,*) '****************************************'
  write(LuWr,*) '*                                      *'
  write(LuWr,*) '*           WARNING!!                  *'
  write(LuWr,*) '* Elements in the E^[2] matrix small!! *'
  write(LuWr,*) '* The calculation might diverge.       *'
  write(LuWr,*) '*                                      *'
  write(LuWr,*) '* Check your active space!!!!          *'
  write(LuWr,*) '*                                      *'
  write(LuWr,*) '* Make sure degenerate orbitals do not *'
  write(LuWr,*) '* belong to different spaces.          *'
  write(LuWr,*) '* Note that no LR code can handle      *'
  write(LuWr,*) '* 2.0 occupancy in active orbitals!!   *'
  write(LuWr,*) '****************************************'
end if
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine DMInvKap

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!               2015, Lasse Kragh Soerensen                            *
!***********************************************************************

subroutine GASDIAS(NAEL,IASTR,NBEL,IBSTR,NORB,DIAG,NSMST,H,XB,RJ,RK,NSSOA,NSSOB,LUDIA,ECORE,PSSIGN,NTOOB,ICISTR,RJKAA,I12,IBLTP, &
                   NBLOCK,IBLKFO,I_AM_OUT,N_ELIMINATED_BATCHES)
! Calculate determinant diagonal
! Turbo-ras version
!
! Driven by IBLKFO, May 97
!
! ========================
! General symmetry version
! ========================
!
! Jeppe Olsen, July 1995, GAS version
!
! I12 = 1 => only one-body part
!     = 2 =>      one+two-body part
!
! Added the possibility to zero out unwanted diagonal part
! which is needed for highly excited states. Lasse 2015

use lucia_data, only: IDISK
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NAEL, NBEL, NORB, NSMST, NSSOA(NSMST,*), NSSOB(NSMST,*), LUDIA, NTOOB, ICISTR, I12, IBLTP(*), &
                                 NBLOCK, IBLKFO(8,NBLOCK), I_AM_OUT(*), N_ELIMINATED_BATCHES
integer(kind=iwp), intent(inout) :: IASTR(NAEL,*), IBSTR(NBEL,*)
real(kind=wp), intent(_OUT_) :: DIAG(*), RJKAA(*)
real(kind=wp), intent(in) :: H(NORB), RJ(NTOOB,NTOOB), ECORE, PSSIGN
real(kind=wp), intent(out) :: XB(NORB)
real(kind=wp), intent(inout) :: RK(NTOOB,NTOOB)
integer(kind=iwp) :: I, I_AM_NOT_WANTED, IA, IAEL, IASM, IASTOP, IASTRT, IATP, IB, IBEL, IBLK, IBSM, IBSTOP, IBSTRT, IBTP, IDET, &
                     IDUM_ARR(1), IEL, IOFF, IREST1, ITDET, JEL, NASTR1, NBSTR1
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IBLOCK, II
#endif
real(kind=wp) :: EAA, EB, HB, RJBB, X, XADD

if (PSSIGN == -One) then
  XADD = 1.0e6_wp
else
  XADD = Zero
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Diagonal one electron integrals'
call WRTMAT(H,1,NORB,1,NORB)
write(u6,*) ' Core energy ',ECORE
if (I12 == 2) then
  write(u6,*) ' Coulomb and exchange integrals'
  call WRTMAT(RJ,NORB,NORB,NTOOB,NTOOB)
  write(u6,*)
  call WRTMAT(RK,NORB,NORB,NTOOB,NTOOB)
end if

write(u6,*) ' TTSS for Blocks'
do IBLOCK=1,NBLOCK
  write(u6,'(10X,4I3,2I8)') (IBLKFO(II,IBLOCK),II=1,4)
end do

write(u6,*) ' I12 = ',I12
#endif

! Diagonal elements according to Handys formulae
! (corrected for error)
!
! DIAG(IDET) = HII*(NIA+NIB)
!            + 0.5 * ( J(I,J)-K(I,J) ) * NIA*NJA
!            + 0.5 * ( J(I,J)-K(I,J) ) * NIB*NJB
!            +         J(I,J) * NIA*NJB
!
! K goes to J - K
if (I12 == 2) RK(:,:) = RJ(:,:)-RK(:,:)
IDET = 0
ITDET = 0
if (LUDIA /= 0) IDISK(LUDIA) = 0

do IBLK=1,NBLOCK
  ! Lasse addition
  I_AM_NOT_WANTED = 0
  do I=1,N_ELIMINATED_BATCHES
    if (I_AM_OUT(I) == IBLK) then
      I_AM_NOT_WANTED = 1
      exit
    end if
  end do
  ! Lasse addition end

  IATP = IBLKFO(1,IBLK)
  IBTP = IBLKFO(2,IBLK)
  IASM = IBLKFO(3,IBLK)
  IBSM = IBLKFO(4,IBLK)

  if (IBLTP(IASM) == 2) then
    IREST1 = 1
  else
    IREST1 = 0
  end if

  ! Construct array RJKAA(*) =   SUM(I) H(I)*N(I) +
  !                          0.5*SUM(I,J) (J(I,J) - K(I,J))*N(I)*N(J)

  ! Obtain alpha strings of sym IASM and type IATP
  IDUM_ARR = 0
  call GETSTR_TOTSM_SPGP(1,IATP,IASM,NAEL,NASTR1,IASTR,NORB,0,IDUM_ARR,IDUM_ARR)
  IOFF = 1
  do IA=1,NSSOA(IASM,IATP)
    EAA = Zero
    do IEL=1,NAEL
      IAEL = IASTR(IEL,IA)
      EAA = EAA+H(IAEL)
      if (I12 == 2) then
        do JEL=1,NAEL
          EAA = EAA+Half*RK(IASTR(JEL,IA),IAEL)
        end do
      end if
    end do
    RJKAA(IA-IOFF+1) = EAA
  end do
  ! Obtain beta strings of sym IBSM and type IBTP
  call GETSTR_TOTSM_SPGP(2,IBTP,IBSM,NBEL,NBSTR1,IBSTR,NORB,0,IDUM_ARR,IDUM_ARR)
  IBSTRT = 1
  IBSTOP = NSSOB(IBSM,IBTP)
  do IB=IBSTRT,IBSTOP

    ! Terms depending only on IB

    HB = Zero
    RJBB = Zero
    XB(:) = Zero

    do IEL=1,NBEL
      IBEL = IBSTR(IEL,IB)
      HB = HB+H(IBEL)

      if (I12 == 2) then
        do JEL=1,NBEL
          RJBB = RJBB+RK(IBSTR(JEL,IB),IBEL)
        end do

        XB(:) = XB(:)+RJ(1:NORB,IBEL)
      end if
    end do
    EB = HB+Half*RJBB+ECORE

    if ((IREST1 == 1) .and. (IATP == IBTP)) then
      IASTRT = IB
    else
      IASTRT = 1
    end if
    IASTOP = NSSOA(IASM,IATP)

    do IA=IASTRT,IASTOP
      IDET = IDET+1
      ITDET = ITDET+1
      X = EB+RJKAA(IA-IOFF+1)
      do IEL=1,NAEL
        X = X+XB(IASTR(IEL,IA))
      end do
      ! Lasse addition
      if (I_AM_NOT_WANTED == 0) then
        if (IB == IA) then
          DIAG(IDET) = X+XADD
        else
          DIAG(IDET) = X
        end if
      else
        DIAG(IDET) = Zero
      end if
      ! Lasse addition end
    end do
    ! End of loop over alpha strings|
  end do
  ! End of loop over betastrings
  ! Yet a RAS block of the diagonal has been constructed
  if (ICISTR >= 2) then
#   ifdef _DEBUGPRINT_
    write(u6,*) ' number of diagonal elements to disc ',IDET
    call WRTMAT(DIAG,1,IDET,1,IDET)
#   endif
    IDUM_ARR(1) = IDET
    call ITODS(IDUM_ARR,1,-1,LUDIA)
    call TODSC(DIAG,IDET,-1,LUDIA)
    IDET = 0
  end if
end do
! End of loop over blocks

#ifdef _DEBUGPRINT_
write(u6,*) ' Number of diagonal elements generated (1)',ITDET
#endif

#ifdef _DEBUGPRINT_
if (ICISTR <= 1) then
  write(u6,*) ' CIDIAGONAL'
  call WRTMAT(DIAG,1,IDET,1,IDET)
end if
#endif

if (ICISTR >= 2) then
  IDUM_ARR(1) = -1
  call ITODS(IDUM_ARR,1,-1,LUDIA)
end if

end subroutine GASDIAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dkh_wgene(n,ord,nst,ndk,ifodd,cdk,wr,rw,t1,t2,e,rer,or,ro,info,s1,s2,t3,t4)
! Calculate U(Word)O/E_{nst}U^{\dag}(Word)

#include "intent.fh"

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, ord, ndk, nst
logical(kind=iwp), intent(inout) :: ifodd
integer(kind=iwp), intent(inout) :: info
real(kind=wp), intent(in) :: cdk(ndk), wr(n,n), rw(n,n)
real(kind=wp), intent(inout) :: t1(n,n), t2(n,n), e(n,n,ndk), rer(n,n,ndk), or(n,n,ndk), ro(n,n,ndk)
real(kind=wp), intent(_OUT_) :: s1(n,n,*), s2(n,n,*)
real(kind=wp), intent(out) :: t3(n,n), t4(n,n)
integer(kind=iwp) :: m, i, j, k
real(kind=wp) :: c

m = (ndk-nst)/ord+1
if (m <= 1) return
s1(:,:,1) = t1(:,:)
s2(:,:,1) = t2(:,:)
do i=1,m-1
  t1(:,:) = Zero
  t2(:,:) = Zero
  k = nst+ord*i
  call dkh_woprig(n,ifodd,wr,rw,s1(:,:,i),s2(:,:,i),s1(:,:,i+1),s2(:,:,i+1),t3,t4)
  info = info+2
  c = cdk(i)*(-1)**(i)
  t1(:,:) = t1(:,:)+s1(:,:,i+1)*c
  t2(:,:) = t2(:,:)+s2(:,:,i+1)*c
  do j=1,i
    call dkh_woplft(n,ifodd,wr,rw,s1(:,:,j),s2(:,:,j),s1(:,:,j),s2(:,:,j),t3,t4)
    info = info+2
    if (j == 1) then
      c = cdk(i)
    else
      c = cdk(i-j+1)*cdk(j-1)*(-1)**(j-1)
    end if
    t1(:,:) = t1(:,:)+s1(:,:,j)*c
    t2(:,:) = t2(:,:)+s2(:,:,j)*c
  end do
  ifodd = .not. ifodd
  if (ifodd) then
    or(:,:,k) = or(:,:,k)+t1(:,:)
    ro(:,:,k) = ro(:,:,k)+t2(:,:)
  else
    e(:,:,k) = e(:,:,k)+t1(:,:)
    rer(:,:,k) = rer(:,:,k)+t2(:,:)
  end if
end do

end subroutine dkh_wgene

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Nrmlx(Exp,nPrim,Coeff,nCntrc,
     &                 Scrt1,nScrt1,Scrt2,nScrt2,iAng)
************************************************************************
*                                                                      *
* Object: normalize the contraction coefficients with respect to the   *
*         radial overlap.                                              *
*                                                                      *
* Called from: Input                                                   *
*                                                                      *
* Calling    : RecPrt                                                  *
*              DGEMM_  (ESSL)                                          *
*              DnDot   (ESSL)                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 Exp(nPrim), Coeff(nPrim,nCntrc), Scrt1(nScrt1),
     &       Scrt2(nScrt2)
#include "real.fh"
*
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*) ' In Nrmlz: iAng=',iAng
      Call RecPrt(' In Nrmlz: Coefficients',' ',Coeff,nPrim,nCntrc)
      Call RecPrt(' In Nrmlz: Exponents',' ',Exp,nPrim,1)
#endif
*
*     Normalize the coefficients (only radial normalization)
*
*     Compute overlap for all primitives of this shell.
*     This formula includes the normalization constant for each
*     primitive as well as the overlap factor of between the primitives.
*     Hence, the overlap matrix elements correspond to those of the
*     normalized primitive gaussian functions.
*
      Do 200 iExp = 1, nPrim
         Do 210 jExp = 1, iExp-1
               Temp =  ( Two*Sqrt(Exp(iExp)*Exp(jExp)) /
     &                   (Exp(iExp)+Exp(jExp)))**(Dble(iAng)+Three/Two)
               Scrt1(nPrim*(iExp-1)+jExp)=Temp
               Scrt1(nPrim*(jExp-1)+iExp)=Temp
 210        Continue
            Scrt1(nPrim*(iExp-1)+iExp)=One
 200     Continue
*     Contract right side
      Call DGEMM_('N','N',
     &            nPrim,nCntrc,nPrim,
     &            1.0d0,Scrt1,nPrim,
     &            Coeff,nPrim,
     &            0.0d0,Scrt2,nPrim)
#ifdef _DEBUGPRINT_
      Call RecPrt(' Overlap primitives',' ',Scrt1,nPrim,nPrim)
      Call RecPrt(' Overlap PrimCon',' ',Scrt2,nPrim,nCntrc)
#endif
*     Compute the overlap for each contracted basis function, <i|i>
      Call DnDot(nCntrc,nPrim,Scrt1,1,1,Scrt2,1,nPrim,Coeff,1,nPrim)
*     Normalize coefficients, i.e. combine the normalization factor
*     of the primitive and the overlap of the unnormalized contracted
*     basis function.
      Do i = 1, nCntrc
         Tmp = 1/Sqrt(Scrt1(i))
         Call DScal_(nPrim,Tmp,Coeff(1,i),1)
      End Do
#ifdef _DEBUGPRINT_
      Call Recprt(' In Nrmlz: Normalized coefficients',' ',
     &            Coeff,nPrim,nCntrc)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Primo_RasScf(VecTit,Ene,Occ,CMO)
!***********************************************************************
! purpose:
! Print MO-coefficients
!
!***********************************************************************

use rasscf_global, only: BName, iPT2, OutFmt2, PreThr, ProThr
use general_data, only: NASH, NBAS, NDEL, NFRO, NISH, NSYM
use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: VecTit
real(kind=wp), intent(in) :: Ene(*), Occ(*), CMO(*)
integer(kind=iwp) :: I, ib, iBas, iBOff, iCOff, iCol, IO, IORB, IS, ISEND, ISOFF, ISStart, IST, ISYM, left, lLine, lPaper, NB, &
                     NBTOT, nCols, ND, NFIA, NO, NS, NSKIP, NSLCT(8), NSLCTT, NVSH(8)
real(kind=wp) :: CC
logical(kind=iwp) :: PrEne, PrOcc
character(len=132) :: Line
character(len=8) :: Fmt1, Fmt2
character(len=3) :: lIrrep(8)
integer(kind=iwp), allocatable :: MrkIt(:), Slct(:)
character(len=LenIn+8), external :: Clean_BName

call Get_cArray('Irreps',lIrrep,24)

! set print format
nCols = 10
lLine = 120
lPaper = 132
left = (lPaper-lLine)/2
write(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
! PAM Krapperup Nov 05: For the moment, selection of orbitals to be
! printed is ultimately determined here on the basis of PRETHR (and
! PROTHR) thresholds. These have either been set by the user, or
! determined in the CHKINP subroutine, possibly then on basis of
! user specification of OutFmt1 flags.
! Exception: OutFmt2='NOCORE  ' will inhibit printing of non-valece orbs.

! PAM Nov 09: Output marked as collapsible.
! print header
write(u6,*)
call CollapseOutput(1,'   Molecular orbitals:')
write(u6,'(6X,A)') '-------------------'
write(u6,*)
write(u6,Fmt2//'A)') trim(VecTit)
write(u6,*)

! Flag ipt2 in common in module rasscf_global.F90.
!   ipt2=0 means usual MO's, quasicanonical for
! inactives and virtuals, natural for active.
!   ipt2=1 means quasicanonical for actives also.
! PAM Apr 05: The rules for selecting orbitals for print
! appear a bit confused. I just follow the rules for now:
if (iPT2 == 0) then
  PrOcc = .true.
  PrEne = .true.
else
  PrOcc = .false.
  PrEne = .true.
end if

! Select orbitals to be printed.
! By default at least all occupied are printed.
! If iPT2==0 all orbitals with energy less than PrEThr
! and occupation bigger then PrOThr are also printed.
! If iPT2==1 all orbitals with occupations greater than
! PrOThr are also printed.

! Nr of orbitals=nr of basis functions
NBTOT = sum(NBAS(1:NSYM))

! Put rasscf orbital energies on the runfile
call Put_darray('RASSCF OrbE',ENE,NBTOT)

! Initialize MARKIT.
call mma_allocate(MRKIT,NBTOT,Label='MrkIt')
MrkIt(:) = 0
if (OutFmt2 /= 'NOCORE  ') then
  ! Mark MARKIT as selected for occupied orbitals.
  IORB = 0
  do ISYM=1,NSYM
    NFIA = NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
    do I=1,NFIA
      IORB = IORB+1
      MRKIT(IORB) = 1
    end do
    IORB = IORB+NBAS(ISYM)-NFIA
  end do
else
  ! Mark MARKIT as selected for valence or active orbitals.
  IORB = 0
  call Get_iArray('Non valence orbitals',NVSH,nSym)
  do ISYM=1,NSYM
    NFIA = NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
    NSKIP = min(NFRO(ISYM)+NISH(ISYM),NVSH(ISYM))
    IORB = IORB+NSKIP
    do I=NSKIP+1,NFIA
      IORB = IORB+1
      MRKIT(IORB) = 1
    end do
    IORB = IORB+NBAS(ISYM)-NFIA
  end do
end if
! If PROCC, then only those orbitals that have occ no larger
! than or equal to PrOThr:
if (PROCC .and. (PrOThr >= Zero)) then
  IORB = 0
  do ISYM=1,NSYM
    NFIA = NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
    do I=1,NFIA
      IORB = IORB+1
      if (OCC(IORB) < PROTHR) MRKIT(IORB) = 0
    end do
    IORB = IORB+NBAS(ISYM)-NFIA
  end do
end if
! But if PRENE, then also those orbitals that have energy less
! than or equal to PrEThr, skipping deleted orbitals of course.
if (PRENE) then
  IORB = 0
  do ISYM=1,NSYM
    NFIA = NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
    IORB = IORB+NFIA
    ND = NDEL(ISYM)
    do I=NFIA+1,NBAS(ISYM)-ND
      IORB = IORB+1
      if (ENE(IORB) <= PRETHR) MRKIT(IORB) = 1
    end do
    IORB = IORB+ND
  end do
end if
! Let ISELECT enumerate the orbitals to be printed, rather than
! just marking them:
NSLCTT = 0
NO = 0
do ISYM=1,NSYM
  NS = 0
  NB = NBAS(ISYM)
  do IO=NO+1,NO+NB
    if (MRKIT(IO) == 1) NS = NS+1
  end do
  NO = NO+NB
  NSLCT(ISYM) = NS
  NSLCTT = NSLCTT+NS
end do
call mma_allocate(SLCT,NSLCTT,Label='SLCT')
IS = 0
NO = 0
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  do IO=NO+1,NO+NB
    if (MRKIT(IO) == 1) then
      IS = IS+1
      SLCT(IS) = IO
    end if
  end do
  NO = NO+NB
end do
! Get rid of MARKIT.
call mma_deallocate(MRKIT)

! finally, print, the MOs
if (OutFmt2 == 'FULL    ') then

  ! print orbitals, using default format.
  ISOFF = 0
  IBOFF = 0
  ICOFF = 0
  do ISYM=1,NSYM
    NB = NBAS(ISYM)
    NS = NSLCT(ISYM)
    if (NS > 0) then
      write(u6,*)
      write(u6,*)
      write(u6,*)
      write(u6,Fmt2//'A,I2,A,A)') 'Molecular orbitals for symmetry species',iSym,': ',lIrrep(iSym)
      do ISSTART=1,NS,NCOLS
        ISEND = min(ISSTART+NCOLS-1,NS)
        write(u6,*)
        write(u6,*)
        write(u6,Fmt2//'A,7X,10I10)') 'Orbital ',(SLCT(ISOFF+I)-IBOFF,I=ISSTART,ISEND)
        if (PRENE) write(u6,Fmt2//'A,7X,10F10.4)') 'Energy  ',(ENE(SLCT(ISOFF+I)),I=ISSTART,ISEND)
        if (PROCC) write(u6,Fmt2//'A,7X,10F10.4)') 'Occ. No.',(OCC(SLCT(ISOFF+I)),I=ISSTART,ISEND)
        write(u6,*)
        do IB=1,NB
          write(u6,'(2X,I4,1X,A,10F10.4)') IB,Clean_BName(BName(IBOFF+IB),LenIn), &
                                           (CMO(ICOFF+(SLCT(ISOFF+I)-1-IBOFF)*NB+IB),I=ISSTART,ISEND)
        end do
      end do
    end if
    ISOFF = ISOFF+NS
    IBOFF = IBOFF+NB
    ICOFF = ICOFF+NB**2
  end do

else if (OutFmt2 == 'COMPACT ') then

  ! print orbitals, using compact format.

  ISOFF = 0
  IBOFF = 0
  ICOFF = 0
  do ISYM=1,NSYM
    NB = NBAS(ISYM)
    if (NSLCT(ISYM) /= 0) then
      write(u6,*)
      write(u6,FMT2//'A,I2,A,A)') 'MOLECULAR ORBITALS FOR SYMMETRY SPECIES',ISYM,': ',LIRREP(ISYM)
      write(u6,*)
      if (PROCC .and. PRENE) then
        write(u6,FMT2//'A)') 'INDEX  ENERGY  OCCUPATION COEFFICIENTS ...'
      else if (PROCC) then
        write(u6,FMT2//'A)') 'INDEX  ENERGY  COEFFICIENTS ...'
      else if (PRENE) then
        write(u6,FMT2//'A)') 'INDEX  OCCUPATION  COEFFICIENTS ...'
      else
        write(u6,FMT2//'A)') 'INDEX  COEFFICIENTS ...'
      end if
      do IS=1,NSLCT(ISYM)
        IORB = SLCT(ISOFF+IS)
        ICOL = IORB-IBOFF
        LINE = ''
        IST = 1
        write(LINE(IST:132),'(I5)') ICOL
        IST = IST+5
        if (PRENE) then
          write(LINE(IST:132),'(F10.4)') ENE(IORB)
          IST = IST+10
        end if
        if (PROCC) then
          write(LINE(IST:132),'(F10.4)') OCC(IORB)
          IST = IST+10
        end if
        write(u6,FMT2//'A)') LINE
        LINE = ''
        IST = 9
        do IBAS=1,NB
          CC = CMO(ICOFF+(ICOL-1)*NB+IBAS)
          if (abs(CC) >= 0.1_wp) then
            write(LINE(IST:132),'(I4,1X,A,A,F7.4,A)') IBAS,Clean_BName(BName(IBOFF+IBAS),LenIn),'(',CC,')'
            IST = IST+28
            if (IST > (132-LEFT-28)) then
              write(u6,FMT2//'A)') trim(LINE)
              LINE = ''
              IST = 9
            end if
          end if
        end do
        write(u6,FMT2//'A)') trim(LINE)
        LINE = ''
        IST = 9
      end do
    end if
    ISOFF = ISOFF+NSLCT(ISYM)
    IBOFF = IBOFF+NB
    ICOFF = ICOFF+NB**2
  end do

end if

call mma_deallocate(SLCT)
! PAM 09: Reset to non-collapsible output before return.
call CollapseOutput(0,'   Molecular orbitals:')
write(u6,*)

end subroutine Primo_RasScf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CXSVAL(ICIS,IXS,NMIDV,NIPWLK,LNOW,LIOW,LNCSF,
     &                 LNOCSF,LIOCSF,NWALK,LICASE,
     &                 MXEO,LNOCP,LIOCP,NICOUP,LICOUP,NVTAB,
     &           LVTAB,LMVL,LMVR,NT1MX,NT2MX,NT3MX,NT4MX,NT5MX)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='CXSVAL')
#include "Struct.fh"
      Dimension ICIS(nCISize)
      Dimension IXS(nXSize)

C Purpose: Dereference the CI structure and the excitation
C structure arrays and return values and pointers.


C CI structure, sizes, addresses...
      nMidV =ICIS(1)
      nIpWlk =ICIS(2)
      lNOW =ICIS(3)
      lIOW =ICIS(4)
      lNCSF =ICIS(5)
      lNOCSF =ICIS(6)
      lIOCSF =ICIS(7)
      nWalk =ICIS(8)
      lICase =ICIS(9)
C Excitation operators, coupling coefficients,...
      MxEO =IXS(1)
      lNOCP =IXS(2)
      lIOCP =IXS(3)
      nICoup =IXS(4)
      lICoup =IXS(5)
      nVTab =IXS(6)
      lVTab =IXS(7)
      lMVL =IXS(8)
      lMVR =IXS(9)
      NT1MX =IXS(10)
      NT2MX =IXS(11)
      NT3MX =IXS(12)
      NT4MX =IXS(13)
      NT5MX =IXS(14)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GenRadQuad_PAM(iNQ,nR_Eff,mr,Alpha,Process,QuadR,
     &                          nQuadR)
      Implicit Real*8 (a-h,o-z)
#include "itmax.fh"
#include "WrkSpc.fh"
#include "real.fh"
#include "nq_info.fh"
#include "debug.fh"
      Real*8 Alpha(2), QuadR(2,nQuadR)
      Real*8 mr(2), ln_rn
      Logical Process
*
*---- Last point at infinity is eliminated
*
      If (Debug) Write (6,*) 'New Algorithm (Malmqvist)'
*
*-----Reading of the datas
      Alpha_Min=Alpha(1)
      Alpha_Max=Alpha(2)
      l_Max=2*Int(mr(1))
      If (Debug) Write (6,*) 'l_Max=',l_Max
      Relative_Max_Error=mr(2)
      If (Debug) Write (6,*) 'Relative_Max_Error=',Relative_Max_Error
*
*     Compute an approximative R_D_0
*
      Dr=Zero
      h=Zero
       Do k = 0, l_Max, l_Max-1
      R_D_0=Relative_Max_Error/(10.0D0**k)
      Dr=-Log10(R_D_0)
*
*     Starting value of h
*
      h=One/(0.47D0*Dr+0.93D0)
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute a correct h for the approximative R_D_0
*
      C1=Four*Sqrt(Two)*Pi
      C2=Pi**2/Two
 99   Continue
      h_=C2/( -Log( Ten**(-Dr)*h / C1 ) )
      If (Abs(h_-h).gt.1.0D-4) Then
         h=h_
         Go To 99
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Now find h from the correct R_D, i.e. from the highest
*     angular momentum available.
*
      Dr=-Log10(Relative_Max_Error)
 98   Continue
      h_=C2/(
     &        -Log(
     &             Ten**(-Dr)*(h/C1)*(h/Pi)**(DBLE(k)/Two)
     &             *(G((DBLE(k)+Three)/Two)/G(Three/Two))
     &            )
     &       )

      If (Debug) Write (6,*) 'h h_ ',h, h_
      If (Abs(h_-h).gt.1.0D-5) Then
         h=h_
         Go To 98
      End If
*
      If (k.eq.0) h0=h
       End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute table of R_Max as a function of l
*
      Do i = l_Max, 0, -2
         D_m=-4.0D0
         If (l_Max.eq. 4) D_m=-2.3D0
         If (l_Max.eq. 2) D_m=-1.0D0
         If (l_Max.eq. 0) D_m= 1.9D0
         If (l_Max.eq.-2) D_m= 9.1D0
*
         ggg=(Two/(DBLE(i)+Three))*(D_m-Log(One/Ten**(-Dr)))
         R_Max(i)=Sqrt(Exp(ggg)/Alpha_Max)
         If (Debug) Then
            write(6,*) 'i        =',i
            write(6,*) 'l_Max    =',l_Max
            write(6,*) 'ggg      =',ggg
            write(6,*) 'R_Max(i) =',R_Max(i)
         End If
      End Do
      If (Debug) Write (6,*) 'h0,h=',h0,h
*
*     For hybrid grid use R_Max for l=0 and h for l=l_max
*     r1=R_Max(l_Max)
      r1=R_Max(0)
      ln_rn=1.7D0-log(Alpha_Min)/Two
      rn=Exp(ln_rn)
      gamma=r1/(Exp(h)-One)
      n_High=Int(Log(rn/gamma+One)/h+One)
      If (Debug) Then
        Write (6,*)
        Write (6,*) 'r1,Alpha_Min    =',r1,Alpha_Min
        Write (6,*) 'rn,Alpha_Max    =',rn,Alpha_MAx
        Write (6,*) 'h,Dr,n_High     =',h,Dr,n_High
      End If
*
*-----Store the radius and the associated weights
*
      If (Debug) Write(6,*) 'n_High',n_High
      iR = 0
      Do k = 0, n_High
         a = DBLE(k)*h
         rk = Gamma*(Exp(a)-One)
*----Note that the point at r=0 is eliminated
         If (rk.ne.Zero) Then
           iR = iR + 1
           If (Process) Then
              QuadR(1,ir)=rk
              Correction=One
*
*             Gregorious correction for points close to the nuclei
*
              If (k.eq.0) Correction= 46.D0/120.D0
              If (k.eq.1) Correction=137.D0/120.D0
              If (k.eq.2) Correction=118.D0/120.D0
              If (k.eq.3) Correction=119.D0/120.D0
*
              QuadR(2,ir) = h * ( rk + gamma ) * Correction
              QuadR(2,ir) = QuadR(1,ir)**2 * QuadR(2,ir)
           End If
         End If
*
      End Do
*-----Store the value of the maximum radius to which we should integrate
*       for the partitionning and the number of effective radii.
      nR_Eff = iR
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iNQ)
      End
      Function G(Arg)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 G
      g=-1000.0D0
*
      Arg_=DBLE(Int(Arg))
      If (Abs(Arg-Arg_).lt.Half/Two) Then
*        Integer argument
         G=One
         rG=One
      Else
*        fractional argument
         G=Sqrt(Pi)
         rG=Half
      End If
*
 99   Continue
         If (Abs(rG-Arg).lt.Half/Two) goto 666
         G=rG*G
         rG=rG+One
      Go To 99
666   continue
      return
*
      End
      Function RD(m,h)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 RD, h
*
      RD=(Four*Sqrt(Two)*Pi/h)*Exp(-Pi**2/(Two*h))
      If (m.eq.0) Return
      RD=(G(Three/Two)/G((DBLE(m)+Three)/Two))
     &  *(Pi/h)**(DBLE(m)/Two) * RD
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRSM2(A,NDIM)
C
C PRINT LOWER TRIANGULAR MATRIX PACKED IN COLUMN WISE FASHION
C
      IMPLICIT REAL*8           ( A-H,O-Z)
      DIMENSION A(*)
C
      DO 100 I=1,NDIM
        WRITE(6,1010) I,
     &  (A((J-1)*NDIM-J*(J-1)/2+I),J=1,I)
  100 CONTINUE
      RETURN
 1010 FORMAT(1H0,2X,I3,5(E14.7),/,(1H ,5X,5(E14.7)))
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3dhlp1 (w,v,dimp,dimq,dimr,denijk,ec,
     & diagp,diagq,diagr,
     & dimdiagp,dimdiagq,dimdiagr,addp,addq,addr)
c
c     this routine realize following procedure
c     for symp.ne.symq.ne.symr
c
c     ec = sum(p,q,r) [ W(p,q,r) . V(p,q,r) / Dijkpqr ]
c
c     w      - W  matrix (I)
c     v      - V  matrix (I)
c     dimp   - dimension of p index (I)
c     dimq   - dimension of q index (I)
c     dimr   - dimension of r index (I)
c     denijk - sum of i,j,k diagonal (other) F parts (I)
c     ec     - energy contribution
c     diagp  - vector of diagonal parts of symmetry p (I)
c     diagq  - vector of diagonal parts of symmetry q (I)
c     diagr  - vector of diagonal parts of symmetry r (I)
c     dimdiagp - dimension of diagonal parts in symetry p (I)
c     dimdiagq - dimension of diagonal parts in symetry q (I)
c     dimdiagr - dimension of diagonal parts in symetry r (I)
c     addp   - additional constant to p (Nocc) (I)
c     addq   - additional constant to q (Nocc) (I)
c     addr   - additional constant to r (Nocc) (I)
c
       integer dimp,dimq,dimr
       integer dimdiagp,dimdiagq,dimdiagr,addp,addq,addr
       real*8 ec,denijk
       real*8 w(1:dimp,1:dimq,1:dimr)
       real*8 v(1:dimp,1:dimq,1:dimr)
       real*8 diagp(1:dimdiagp)
       real*8 diagq(1:dimdiagq)
       real*8 diagr(1:dimdiagr+dimr)
c
c     help variables
c
       integer p,q,r
       real*8 denijkr,denijkqr,denijkpqr
c
       ec=0.0d0
c
       do 100 r=1,dimr
       denijkr=denijk-diagr(addr+r)
       do 101 q=1,dimq
       denijkqr=denijkr-diagq(q+addq)
       do 102 p=1,dimp
       denijkpqr=denijkqr-diagp(p+addp)
       ec=ec+w(p,q,r)*v(p,q,r)/denijkpqr
 102    continue
 101    continue
 100    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Rulin Feng                                       *
************************************************************************
*       ****************************************************
*                           Do SO-NTO
*       ****************************************************
*        This routine is made to prepare the transition density
*        This routine is modified from do_sonatorb.f.
*        matrices, transition spin density matrices.
*        In the future, this may include antisymmetric, transition
*        densities. Namely the keyword antisin or antitrip
*
*                                                      -RF 8/18,2021
      SUBROUTINE DO_SONTO(NSS, USOR, USOI)
      use rassi_global_arrays, only: JBNUM, EIGVEC
      use stdalloc, only: mma_allocate, mma_deallocate
      use cntrl, only: SONTOSTATES, SONTO
      use Cntrl, only: NSTATE, NOSO, MLTPLT
      use rassi_data, only: NBST
      IMPLICIT None
      Integer NSS
      Real*8 USOR(NSS,NSS), USOI(NSS,NSS)
      Real*8 IDENTMAT(3,3)
      Real*8, Allocatable:: UMATR(:), UMATI(:), VMAT(:,:)
      Real*8, Allocatable:: TDMAO(:), TSDMAO(:)
      Real*8, Allocatable:: ANTSIN(:)
      Integer I, ISS, ISTATE, JOB1, MPLET1, MSPROJ1,
     &           JSS, JSTATE, JOB2, MPLET2, MSPROJ2,
     &        INTOSTATE, JNTOSTATE, IOPT

c Calculates natural orbitals, including spinorbit effects
      WRITE(6,*)
      WRITE(6,*)
      WRITE(6,*) '*****************************************'
      WRITE(6,*) '* RUNNING SONTO CODE ********************'
      WRITE(6,*) '*****************************************'
      WRITE(6,*)

      IDENTMAT(:,:)=0.0D0
      FOR ALL (I=1:3) IDENTMAT(I,I)=1.0D0

      CALL mma_allocate(UMATR,NSS**2,Label='UMATR')
      CALL mma_allocate(UMATI,NSS**2,Label='UMATI')
      CALL mma_allocate(VMAT,NSS,NSS,Label='VMAT')

      VMAT(:,:)=0.0D0

c transform V matrix in SF basis to spin basis
c This was taken from smmat.f and modified slightly
      ISS=0
      DO ISTATE=1,NSTATE
       JOB1=JBNUM(ISTATE)
       MPLET1=MLTPLT(JOB1)
c       S1=0.5D0*DBLE(MPLET1-1)

       DO MSPROJ1=-MPLET1+1,MPLET1-1,2
c        SM1=0.5D0*DBLE(MSPROJ1)
        ISS=ISS+1
        JSS=0

        DO JSTATE=1,NSTATE
         JOB2=JBNUM(JSTATE)
         MPLET2=MLTPLT(JOB2)
c         S2=0.5D0*DBLE(MPLET2-1)

         DO MSPROJ2=-MPLET2+1,MPLET2-1,2
c          SM2=0.5D0*DBLE(MSPROJ2)
          JSS=JSS+1

          IF (MPLET1.EQ.MPLET2 .AND. MSPROJ1.EQ.MSPROJ2) THEN
           VMAT(ISS,JSS)=EIGVEC(JSTATE,ISTATE)
          END IF ! IF (MPLET1.EQ.MPLET2 .AND. MSPROJ1.EQ.MSPROJ2)
         END DO ! DO MSPROJ2=-MPLET2+1,MPLET2-1,2
        END DO ! end DO JSTATE=1,NSTATE
       END DO ! DO MSPROJ1=-MPLET1+1,MPLET1-1,2
      END DO ! DO ISTATE=1,NSTATE

c combine this matrix with the SO eigenvector matrices
      IF(.not.NOSO) THEN
        CALL DGEMM_('N','N',NSS,NSS,NSS,
     &      1.0d0,VMAT,NSS,USOR,NSS,0.0d0,
     &      UMATR,NSS)
        CALL DGEMM_('N','N',NSS,NSS,NSS,
     &      1.0d0,VMAT,NSS,USOI,NSS,0.0d0,
     &      UMATI,NSS)
      ELSE
c Spinorbit contributions to this are disabled
        CALL DCOPY_(NSS,VMAT,1,UMATR,1)
        CALL DCOPY_(NSS,[0.0d0],0,UMATI,1)
      END IF

c SONTONSTATE = number of state pairs to calculate.
c These states are stored as pairs beginning in SONTO
      DO I=1,SONTOSTATES
        INTOSTATE=SONTO(1,I)
        JNTOSTATE=SONTO(2,I)
        WRITE(6,*)
        WRITE(6,*) "CALCULATING SO-NTOs BETWEEN SO STATES: ",
     &              INTOSTATE,JNTOSTATE
        IF((INTOSTATE.GT.NSS.OR.INTOSTATE.LE.0)
     & .or.(JNTOSTATE.GT.NSS.OR.JNTOSTATE.LE.0)) THEN
          WRITE(6,*) "...WHICH DOES NOT EXIST!"
          CALL ABEND()
        END IF
        WRITE(6,*)
        iOpt=0
c Currently only HERMISING TDMs are dealt with here
        call mma_allocate(TDMAO,6*NBST**2,Label='TDMAO')
        call mma_allocate(TSDMAO,6*NBST**2,Label='TSDMAO')
        call mma_allocate(ANTSIN,6*NBST**2,Label='ANTSIN')
c Initialization is important
        TDMAO(:)=0.0D0
        TSDMAO(:)=0.0D0
        ANTSIN(:)=0.0D0
c
        Call MAKETDMAO('HERMSING',UMATR,UMATI,
     &                        INTOSTATE,JNTOSTATE,NSS,iOpt,IDENTMAT,
     &                        TDMAO)
c Following codes are left for other types of SO-TDMs
c        Call print_matrixt('TDM after MAKETDMAO 1',nbst,nbst**2,1,
c     &                    TDMAO)
c        CALL MAKETDMAO('HERMTRIP',UMATR,UMATI,
c     &                        INTOSTATE,JNTOSTATE,NSS,iOpt,IDENTMAT,
c     &                        TSDMAO,NBST)
c        Call print_matrixt('TSDM after MAKETDMAO 1',nbst,nbst**2,1,
c     &                    TSDMAO)
c        CALL MAKETDMAO('ANTISING',UMATR,UMATI,
c     &                        INTOSTATE,JNTOSTATE,NSS,iOpt,IDENTMAT,
c     &                        ANTSIN,NBST)
c        Call print_matrixt('ANTITDM after MAKETDMAO 1',nbst,nbst**2,1,
c     &                    ANTSIN)
        Call DO_AOTDMNTO(TDMAO,TSDMAO,ANTSIN,
     &                     INTOSTATE,JNTOSTATE,NBST,NBST**2)
        Call mma_deallocate(TDMAO)
        Call mma_deallocate(TSDMAO)
        Call mma_deallocate(ANTSIN)
      END DO
      Call mma_deallocate(UMATR)
      Call mma_deallocate(UMATI)
      Call mma_deallocate(VMAT)
      Call mma_deallocate(SONTO)

      END SUBROUTINE DO_SONTO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine rdi_cvb(ivec,n,file_id,ioffset)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Definitions, only: wp, iwp, RtoI

implicit none
integer(kind=iwp), intent(in) :: n, ioffset
integer(kind=iwp), intent(out) :: ivec(n)
real(kind=wp), intent(in) :: file_id
integer(kind=iwp) :: ibuf(8), nreals, nrem

nreals = n/RtoI
nrem = n-nreals*RtoI
call rdi_cvb_internal(ivec,ibuf)

return

! This is to allow type punning without an explicit interface
contains

#include "intent.fh"

subroutine rdi_cvb_internal(ivec,ibuf)
  integer(kind=iwp), target, intent(_OUT_) :: ivec(*), ibuf(*)
  integer(kind=iwp) :: ioff
  real(kind=wp), pointer :: buf(:), vec(:)
  call c_f_pointer(c_loc(ivec(1)),vec,[nreals])
  call rdlow_cvb(vec,nreals,file_id,ioffset)
  nullify(vec)
  if (nrem > 0) then
    call c_f_pointer(c_loc(ibuf(1)),buf,[1])
    call rdlow_cvb(buf,1,file_id,nreals+ioffset)
    nullify(buf)
    ioff = nreals*RtoI
    ivec(ioff+1:ioff+nrem) = ibuf(1:nrem)
  end if
end subroutine rdi_cvb_internal

end subroutine rdi_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_car_to_sph

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! public procedures
   PUBLIC :: fmm_init_car_to_sph,      &
             fmm_free_car_to_sph,      &
             fmm_transform_car_to_sph

   REAL(REALK), ALLOCATABLE, SAVE :: SphCoef(:,:,:)

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_car_to_sph(LMAX)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: LMAX

      IF ( ALLOCATED(SphCoef) ) THEN
         CALL fmm_quit('mm_car_to_sph not freed correctly!')
      END IF

      ALLOCATE( SphCoef(0:LMax*2+1, (LMax+1)*(LMax+2)/2, 0:LMax) )
      CALL fmm_build_sphcoef(LMAX)

   END SUBROUTINE fmm_init_car_to_sph

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_free_car_to_sph

      DEALLOCATE( SphCoef )

   END SUBROUTINE fmm_free_car_to_sph

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_build_sphcoef(LMAX)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: LMAX

      INTEGER(INTK) :: L, LL, I, M
      INTEGER(INTK) :: IX, IY, IZ
      INTEGER(INTK) :: IPX1, IPY1, IPZ1, IPY2, IPZ2, IPX2
      REAL(REALK)   :: Denom, PreFac, Arg
!
!     --- Initialization ---
!
      SphCoef(:,:,:) = Zero
!
!     --- s coefficients ---
!
      SphCoef(1,1,0) = One
      IF (LMax == 0) RETURN
!
!     --- p coefficients ---
!
      SphCoef(1,2,1) = One
      SphCoef(2,3,1) = One
      SphCoef(3,1,1) = One
      IF (LMax == 1) GO TO 100
!
!      SphCoef(1,2,2) =  Sqrt3
!      SphCoef(2,5,2) =  Sqrt3
!      SphCoef(3,1,2) = -Half
!      SphCoef(3,4,2) = -Half
!      SphCoef(3,6,2) =  One
!      SphCoef(4,3,2) =  Sqrt3
!      SphCoef(5,1,2) =  Half * Sqrt3
!      SphCoef(5,4,2) = -Half * Sqrt3
!
!     --- Higher than d ---
!
      DO LL = 2, LMax
         L = LL - 1
         Arg = DBLE(L+L+1) / DBLE(L+L+2)
         PreFac = SQRT(Arg)
!
         I = 0
         DO IX = L, 0, -1
            DO IY = L - IX, 0, -1
               IZ = L - IX - IY
               I = I + 1
               IPX1 = I
               IPY1 = I + (L - IX + 1)                                                    ! Increase 1 Y
               IPZ1 = I + (L - IX + 2)                                                    ! Increase 1 Z
!
!     --- Diagonal recurrence ---
!
               SphCoef(LL+LL+1,IPX1,LL) = SphCoef(LL+LL+1,IPX1,LL) +    &
                                          PreFac * SphCoef(L+L+1,I,L)
               SphCoef(LL+LL+1,IPY1,LL) = SphCoef(LL+LL+1,IPY1,LL) -    &
                                          PreFac * SphCoef(1,I,L)
!
               SphCoef(1,IPY1,LL) = SphCoef(1,IPY1,LL) +    &
                                    PreFac * SphCoef(L+L+1,I,L)
               SphCoef(1,IPX1,LL) = SphCoef(1,IPX1,LL) +    &
                                    PreFac * SphCoef(1,I,L)
!
!     --- Vertical recurrence (1) ---
!
               DO M = -LL + 1, LL - 1
                  Denom = SQRT(DBLE((L+M+1)*(L-M+1)))
                  SphCoef(LL+M+1,IPZ1,LL) = SphCoef(LL+M+1,IPZ1,LL) +   &
                          (DBLE(L+L+1)/Denom) * SphCoef(L+M+1,I,L)
               END DO
!
            END DO   ! IY
         END DO   ! IX
!
!     --- Vertical recurrence (2) ---
!
         I = 0
         DO IX = L - 1, 0, -1
            DO IY = L - 1 - IX, 0, -1
               IZ = L - 1 - IX - IY
               I = I + 1
               IPX2 = I
               IPY2 = I + (L - 1 - IX + 1) + (L - 1 - IX + 2)   ! Increase 2 Y
               IPZ2 = I + (L - 1 - IX + 2) + (L - 1 - IX + 3)   ! Increase 2 Z
!
               DO M = -LL + 1, LL - 1
                  Arg = DBLE((L+M)*(L-M)) / DBLE((L+M+1)*(L-M+1))
                  PreFac = SQRT(Arg)
                  SphCoef(LL+M+1,IPX2,LL) = SphCoef(LL+M+1,IPX2,LL) -   &
                                            PreFac * SphCoef(L+M,I,L-1)
                  SphCoef(LL+M+1,IPY2,LL) = SphCoef(LL+M+1,IPY2,LL) -   &
                                            PreFac * SphCoef(L+M,I,L-1)
                  SphCoef(LL+M+1,IPZ2,LL) = SphCoef(LL+M+1,IPZ2,LL) -   &
                                            PreFac * SphCoef(L+M,I,L-1)
               END DO   ! M
!
            END DO   ! IY
         END DO   ! IX
!
      END DO   ! LL
!
!     o p-1, p0, p+1 -> px, py, pz
!
  100 CONTINUE
      SphCoef(:,:,1) = Zero
      SphCoef(1,1,1) = One
      SphCoef(2,2,1) = One
      SphCoef(3,3,1) = One
!
   END SUBROUTINE fmm_build_sphcoef

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_transform_car_to_sph(CarMpole,SphMpole,ndim,LMAX)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN)  :: ndim, LMAX
      REAL(REALK),   INTENT(IN)  :: CarMpole(ndim,(LMAX+1)*(LMAX+2)/2,0:LMAX )
      REAL(REALK),   INTENT(OUT) :: SphMpole(ndim,2*LMAX+1,0:LMAX )

      INTEGER(INTK) :: MType, IS, IC, IJAO
      REAL(REALK)  :: Tmp, TempSphCoef, SphCoef_yzx(3,3)

      SphMpole(:,:,:) = Zero
      SphCoef_yzx(:,:) = Zero
      SphCoef_yzx(1,2) = One
      SphCoef_yzx(2,3) = One
      SphCoef_yzx(3,1) = One

      DO MType = 0, LMAX
         DO IS = 1, (MType + MType + 1)
            DO IC = 1, (MType + 1) * (MType + 2) / 2

               IF (MType /= 1) THEN
                  TempSphCoef = SphCoef(IS,IC,MType)
               ELSE
                  TempSphCoef = SphCoef_yzx(IS,IC)
               END IF

               DO IJAO = 1, ndim
                  Tmp =  TempSphCoef * CarMpole(IJAO,IC,MType)
                  SphMpole(IJAO,IS,MType) = SphMpole(IJAO,IS,MType) +Tmp
               END DO

            END DO
         END DO
      END DO

   END SUBROUTINE fmm_transform_car_to_sph

!-------------------------------------------------------------------------------

END MODULE fmm_car_to_sph

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE SORTA_CPF(BUFOUT,INDOUT,ICAD,IBUFL,TIBUF,ISAB,BUFBI,
     *INDBI,BIAC,BICA,NINTGR)
      IMPLICIT REAL*8 (A-H,O-Z)
      EXTERNAL COUNT_CPF
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION BUFOUT(*),INDOUT(*)
      DIMENSION ICAD(*),IBUFL(*),TIBUF(NTIBUF),ISAB(*)
      DIMENSION BUFBI(*),INDBI(*),BIAC(*),BICA(*)
C     SORTS INTEGRALS (AB/CI)
C     FOR FIXED B,I ALL A,C
C     FIRST CHAIN FOR IJKL
      DIMENSION NORB0(9)
*
      CALL COUNT_CPF(NINTGR,NSYM,NORB,MUL)
      IF (IPRINT.GE.2) THEN
        WRITE(6,*)' NUMBER OF TWO-ELECTRON INTEGRALS:',NINTGR
      END IF
      IAD50=0
      CALL iDAFILE(Lu_TraInt,2,iTraToc,nTraToc,IAD50)
      KKBUF0=(RTOI*(KBUFF1+2)-2)/(RTOI+1)
      KKBUF1=RTOI*KKBUF0+KKBUF0+1
      KKBUF2=KKBUF1+1
      NOV=LN*NVIRT+1
      IF(IFIRST.NE.0)NOV=1
      IDISK=0
      KBUF0=RTOI*KBUF
      KBUF1=KBUF0+KBUF+1
      KBUF2=KBUF1+1
      IDIV=RTOI
      ID=0
      DO 5 IREC=1,NOV
        IBUFL(IREC)=0
        ICAD(IREC)=ID
        INDOUT(ID+KBUF2)=-1
        ID=ID+KBUF2
5     CONTINUE
      NORB0(1)=0
      DO 4 I=1,NSYM
        NORB0(I+1)=NORB0(I)+NORB(I)
4     CONTINUE
C
C     TWO-ELECTRON INTEGRALS
C
      DO 313 NSP=1,NSYM
        NOP=NORB(NSP)
        DO 312 NSQ=1,NSP
          NSPQ=MUL(NSP,NSQ)
          NOQ=NORB(NSQ)
          DO 311 NSR=1,NSP
            NSPQR=MUL(NSPQ,NSR)
            NOR=NORB(NSR)
            NSSM=NSR
            IF(NSR.EQ.NSP)NSSM=NSQ
            DO 310 NSS=1,NSSM
              IF(NSS.NE.NSPQR)GO TO 310
              NOS=NORB(NSS)
              NORBP=NOP*NOQ*NOR*NOS
              IF(NORBP.EQ.0)GO TO 310
              CALL dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
              IOUT=0
              DO 309 NV=1,NOR
                NXM=NOS
                IF(NSR.EQ.NSS)NXM=NV
                DO 308 NX=1,NXM
                  NTM=1
                  IF(NSP.EQ.NSR)NTM=NV
                  DO 307 NT=NTM,NOP
                    NUMIN=1
                    IF(NSP.EQ.NSR.AND.NT.EQ.NV)NUMIN=NX
                    NUMAX=NOQ
                    IF(NSP.EQ.NSQ)NUMAX=NT
                    DO 306 NU=NUMIN,NUMAX
                      IOUT=IOUT+1
                      IF(IOUT.GT.NTIBUF) THEN
                        CALL dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
                        IOUT=1
                      END IF
                      M1=ICH(NORB0(NSP)+NT)
                      M2=ICH(NORB0(NSQ)+NU)
                      M3=ICH(NORB0(NSR)+NV)
                      M4=ICH(NORB0(NSS)+NX)
                      IF(M1.LE.0.OR.M2.LE.0)GO TO 306
                      IF(M3.LE.0.OR.M4.LE.0)GO TO 306
C                     ORDER THESE INDICES CANONICALLY
                      N1=M1
                      N2=M2
                      IF(M1.GT.M2)GO TO 11
                      N1=M2
                      N2=M1
11                    N3=M3
                      N4=M4
                      IF(M3.GT.M4)GO TO 12
                      N3=M4
                      N4=M3
12                    NI=N1
                      NJ=N2
                      NK=N3
                      NL=N4
                      IF(NI.GT.NK)GO TO 502
                      IF(NI.EQ.NK)GO TO 14
                      NI=N3
                      NJ=N4
                      NK=N1
                      NL=N2
                      GO TO 502
14                    IF(NJ.GT.NL)GO TO 502
                      NL=N2
                      NJ=N4
502                   FINI=TIBUF(IOUT)
                      IF(ABS(FINI).LT.1.D-09)GO TO 306
                      IF(NI.LE.LN)GO TO 109
                      IF(NK.LE.LN)GO TO 306
                      IF(NJ.LE.LN)GO TO 42
                      IF(NL.GT.LN)GO TO 306
                      IF(IFIRST.NE.0)GO TO 306
C
C                     ABCI
C
                      NA=NI-LN
                      NB=NJ-LN
                      NC=NK-LN
                      NI=NL
108                   ITURN=0
107                   NIB=(NI-1)*NVIRT+NB+1
                      IBUFL(NIB)=IBUFL(NIB)+1
                      ICQ=ICAD(NIB)
                      ICP=ICQ/IDIV+IBUFL(NIB)
                      BUFOUT(ICP)=FINI
                      ICPP=ICQ+KBUF0+IBUFL(NIB)
                      INDOUT(ICPP)=(NA-1)*NVIRT+NC
                      IF(IBUFL(NIB).LT.KBUF)GO TO 106
                      INDOUT(ICQ+KBUF1)=KBUF
                      JDISK=IDISK
                      CALL iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),KBUF2,
     &                             IDISK)
                      INDOUT(ICQ+KBUF2)=JDISK
                      IBUFL(NIB)=0
106                   IF(ITURN.EQ.1.OR.NA.EQ.NB)GO TO 306
                      ITURN=1
                      NAT=NA
                      NA=NB
                      NB=NAT
                      GO TO 107
42                    IF(NJ.LE.0.OR.NL.LE.LN)GO TO 306
C
C                     CIAB
C
                      IF(IFIRST.NE.0)GO TO 306
                      NA=NK-LN
                      NB=NL-LN
                      NC=NI-LN
                      NI=NJ
                      GO TO 108
C
C                     IJKL
C
109                   IIJ=IROW(NI)+NJ
                      KL=IROW(NK)+NL
                      IJKL=IIJ*(IIJ-1)/2+KL
                      IJ=1
                      IBUFL(IJ)=IBUFL(IJ)+1
                      ICQ=ICAD(IJ)
                      ICP=ICQ/IDIV+IBUFL(IJ)
                      BUFOUT(ICP)=FINI
                      ICPP=ICQ+KBUF0+IBUFL(IJ)
                      INDOUT(ICPP)=IJKL
                      IF(IBUFL(IJ).LT.KBUF)GO TO 306
                      INDOUT(ICQ+KBUF1)=KBUF
                      JDISK=IDISK
                      CALL iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),KBUF2,
     &                             IDISK)
                      INDOUT(ICQ+KBUF2)=JDISK
                      IBUFL(IJ)=0
306                 CONTINUE
307               CONTINUE
308             CONTINUE
309           CONTINUE
310         CONTINUE
311       CONTINUE
312     CONTINUE
313   CONTINUE
C     EMPTY LAST BUFFERS
CFUE Start of insertion
      If ( NOV.gt.mAdr ) then
        WRITE(6,*)'SORTA_CPF Error: NOV > MADR (See code).'
        CALL Abend
      End If
CFUE End of insertion
      DO 150 I=1,NOV
        ICQ=ICAD(I)
        INDOUT(ICQ+KBUF1)=IBUFL(I)
        JDISK=IDISK
        CALL iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),KBUF2,IDISK)
        LASTAD(I)=JDISK
150   CONTINUE
C
C     IJKL
C
      IDISK=0
      IBUFIJ=0
      INDBI(KKBUF2)=-1
      IADR=LASTAD(1)
201   CALL iDAFILE(Lu_TiABIJ,2,INDOUT,KBUF2,IADR)
      LENGTH=INDOUT(KBUF1)
      IADR=INDOUT(KBUF2)
      IF(LENGTH.EQ.0)GO TO 209
      DO 202 I=1,LENGTH
        IBUFIJ=IBUFIJ+1
        BUFBI(IBUFIJ)=BUFOUT(I)
        INDBI(RTOI*KKBUF0+IBUFIJ)=INDOUT(KBUF0+I)
        IF(IBUFIJ.LT.KKBUF0)GO TO 202
        INDBI(KKBUF1)=KKBUF0
        JDISK=IDISK
        CALL iDAFILE(Lu_TiABCI,1,INDBI,KKBUF2,IDISK)
        INDBI(KKBUF2)=JDISK
        IBUFIJ=0
202   CONTINUE
209   IF(IADR.NE.-1) GO TO 201
C     EMPTY LAST BUFFER
      INDBI(KKBUF1)=IBUFIJ
      JDISK=IDISK
      CALL iDAFILE(Lu_TiABCI,1,INDBI,KKBUF2,IDISK)
      LASTAD(1)=JDISK
C
C     ABCI
C
      ICHK=0
      IAD15=IDISK
      IADABCI=IAD15
      INSOUT=0
      NOVST=1
      IADD10=IAD10(4)
      CALL dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
      CALL iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IN=2
      NSAVE=ICOP1(IN)
100   NI=NSAVE
      IOUT=0
110   IN=IN+1
      IF(IN.LE.LEN)GO TO 15
      CALL dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
      CALL iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.LE.0)GO TO 6
      IN=1
15    IF(ICHK.NE.0)GO TO 460
      IF(ICOP1(IN).EQ.0)GO TO 10
      IOUT=IOUT+1
      GO TO 110
10    ICHK=1
      GO TO 110
460   ICHK=0
      NSAVE=ICOP1(IN)
6     CONTINUE
      NIB=(NI-1)*NVIRT+NOVST
      DO 20 NB=1,NVIRT
        NSIB=MUL(NSM(LN+NB),NSM(NI))
        INS=NNS(NSIB)
        IF(INS.EQ.0)GO TO 18
        DO 21 I=1,INS
          BIAC(I)=0.0D0
          BICA(I)=0.0D0
21      CONTINUE
18      NIB=NIB+1
        IADR=LASTAD(NIB)
203     CALL iDAFILE(Lu_TiABIJ,2,INDOUT,KBUF2,IADR)
        LENGTH=INDOUT(KBUF1)
        IADR=INDOUT(KBUF2)
        IF(LENGTH.EQ.0)GO TO 210
        DO 204 KK=1,LENGTH
          INND=INDOUT(KBUF0+KK)
          NA=(INND-1)/NVIRT+1
          NC=INND-(NA-1)*NVIRT
          NAC=(NA-1)*NVIRT+NC
          IACS=ISAB(NAC)
          BIAC(IACS)=BIAC(IACS)+BUFOUT(KK)
          IF(NA.GT.NC)BICA(IACS)=BICA(IACS)-BUFOUT(KK)
          IF(NA.LT.NC)BICA(IACS)=BICA(IACS)+BUFOUT(KK)
204     CONTINUE
210     IF(IADR.NE.-1) GO TO 203
        ILOOP=0
72      DO 75 I=1,INS
          INSOUT=INSOUT+1
          IF(ILOOP.EQ.0)BUFBI(INSOUT)=BIAC(I)
          IF(ILOOP.EQ.1)BUFBI(INSOUT)=BICA(I)
          IF(INSOUT.LT.KBUFF1)GO TO 75
          CALL dDAFILE(Lu_TiABCI,1,BUFBI,KBUFF1,IAD15)
          INSOUT=0
75      CONTINUE
        ILOOP=ILOOP+1
        IF(ILOOP.EQ.1)GO TO 72
20    CONTINUE
      IF(LEN.GE.0)GO TO 100
C     EMPTY LAST BUFFER
      IF ( INSOUT.EQ.0 ) THEN
        RETURN
      END IF
      CALL dDAFILE(Lu_TiABCI,1,BUFBI,KBUFF1,IAD15)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetRest_t3(t1,t1_tmp,E2old)
! this file read 1) T1o
!                2) E1old,E2old,niter
! from RstFil file

use ChT3_global, only: LunAux, no, nv, printkey
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: t1(nv*no,2), t1_tmp(nv*no), E2old
integer(kind=iwp) :: dum
real(kind=wp) :: E1old

!open(unit=LunAux,File='RstFil',form='unformatted')
call MOLCAS_BinaryOpen_Vanilla(LunAux,'RstFil')
!mp write(u6,*) 'no, nv, length = ',no,nv,length
read(LunAux) t1(:,1)

call Map2_21_t3(t1,t1_tmp,nv,no)

t1(:,1) = t1_tmp
t1(:,2) = t1_tmp

read(LunAux) E1old,E2old,dum
#include "macros.fh"
unused_var(dum)

if (printkey > 1) write(u6,'(A,2(f15.12,1x))') 'Results from CCSD : E1, E2 ',E1old,E2old

close(LunAux)

return

end subroutine GetRest_t3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine CalcDdiff(Ddiff,GDMat,M,K,nnA,nRoots)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: M, K, nnA, nRoots
real(kind=wp), intent(out) :: Ddiff(nnA,nnA)
real(kind=wp), intent(in) :: GDMat(nTri_Elem(nRoots),nnA,nnA)
integer(kind=iwp) :: iKK, iMM, it

iMM = nTri_Elem(M)
iKK = nTri_Elem(K)

do it=1,nnA
  Ddiff(:,it) = GDMat(iMM,it,:)-GDMat(iKK,it,:)
end do

end subroutine CalcDdiff

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SubScr_Init()
C
C     Purpose: initialize screening in vector subtraction.
C
      use ChoSubScr, only: DSubScr, DSPNm
#include "implicit.fh"
#include "cholesky.fh"
#include "stdalloc.fh"
      Integer l_DSubScr

      l_DSubScr = nnBstR(1,1)
      Do iSym = 2,nSym
         l_DSubScr = max(l_DSubScr,nnBstR(iSym,1))
      End Do
      Call mma_allocate(DSubScr,l_DSubScr,Label='DSubScr')

      Call mma_allocate(DSPNm,nnShl,Label='DSPNm')

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine QUNE(NCALLS,ENOW,BK,XSX,VL,VM,XQN,XOLD,V1,V2,NDIM,LUQUNE,TMIN,QNSTEP,QNUPDT,KSDFT)
! RASSCF PROGRAM VERSION IBM-3090: SX SECTION
!
! PURPOSE: THIS SUBROUTINE MAKES A QUASI NEWTON UPDATE
!          OF THE ROTATION MATRIX X, OR A LINE SEARCH.

use RASDim, only: MxIter
use Constants, only: Zero, One, Two, Three, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(inout) :: NCALLS
real(kind=wp), intent(in) :: ENOW
integer(kind=iwp), intent(in) :: NDIM, LUQUNE
real(kind=wp), intent(_IN_) :: BK(NDIM)
real(kind=wp), intent(inout) :: XSX(NDIM)
real(kind=wp), intent(out) :: VL(NDIM), VM(NDIM), XQN(NDIM), XOLD(NDIM), V1(NDIM), V2(NDIM), TMIn
character(len=2), intent(out) :: QNSTEP
character(len=3), intent(out) :: QNUPDT
character(len=80), intent(in) :: KSDFT
integer(kind=iwp) :: IAD, IVEC, NLM
real(kind=wp) :: C0, C1, C2, C3, E0, E1, ELM, EMIN, EPRED_LS, EPRED_QN, EPRED_SX, FP, P, P1, P2, Q, SCLFCT, T0, T1, TLM, X, &
                 XSXNRM, Y
integer(kind=iwp), save :: NLS, NVEC
real(kind=wp), save :: ALPHA(mxiter+2), BETA(mxiter+2), ELAST, FPLAST
real(kind=wp), external :: DDot_, DNrm2_

NCALLS = NCALLS+1

if (NCALLS == 1) then
  NVEC = 0
  ! NLS: Nr of consecutive line searches.
  NLS = 0
  ALPHA(:) = Zero
  BETA(:) = Zero
  IAD = 0
  call DDAFILE(LUQUNE,1,BK,NDIM,IAD)
  call DDAFILE(LUQUNE,1,XSX,NDIM,IAD)
  call DDAFILE(LUQUNE,1,XSX,NDIM,IAD)
  ELAST = ENOW
  FPLAST = Two*DDOT_(NDIM,BK,1,XSX,1)
  TMIN = Zero
  QNSTEP = 'SX'
  QNUPDT = ' NO'
  return
end if
! -- 1. CALC L AND M ARRAYS
! Read from the beginning of LUQUNE. There is the BLB gradient, the proposed optimal
! (QN) step at the previous iteration, and the actual step taken in that iteration.
! VM should be computed as the difference in QN steps, where the new one is computed
! without the new update vectors (which are still unknown).
IAD = 0
call DDAFILE(LUQUNE,2,V1,NDIM,IAD)
VL(:) = BK(:)-V1(:)
! VL is the difference between the old and the new BLB gradient array:
! Read old QN step into VM:
call DDAFILE(LUQUNE,2,VM,NDIM,IAD)
call DDAFILE(LUQUNE,2,XOLD,NDIM,IAD)
! -- FP WILL BE USED IN LINE SEARCH ANALYSIS LATER.
FP = Two*DDOT_(NDIM,BK,1,XOLD,1)
! -- QN VECTOR UPDATED WITHOUT NEWEST UPDATE VECTORS: XQN=-HINV*BK
XQN(:) = XSX(:)
do IVEC=1,NVEC
  call DDAFILE(LUQUNE,2,V1,NDIM,IAD)
  call DDAFILE(LUQUNE,2,V2,NDIM,IAD)
  X = -DDOT_(NDIM,V1,1,BK,1)
  Y = -DDOT_(NDIM,V2,1,BK,1)
  P1 = ALPHA(IVEC)*X+BETA(IVEC)*Y
  P2 = BETA(IVEC)*X
  XQN(:) = XQN(:)+P1*V1(:)+P2*V2(:)
end do
! Subtract. VM will now contain the difference in QN steps, where the new one
! is computed without the update (which we still do not know).
VM(:) = VM(:)-XQN(:)
! -- NOTE: M ARRAY = HK(INV)*LK
! -- 2. DECIDE ON WHICH ROTATION TO USE.
! -- A LINE SEARCH ANALYSIS.
C0 = ELAST
C1 = FPLAST
C2 = Three*(ENOW-ELAST)-Two*FPLAST-FP
C3 = -Two*(ENOW-ELAST)+FPLAST+FP
!write(u6,*) repeat('*',60)
!write(u6,*) ' SEARCH FOR MINIMUM:'
!write(u6,*) ' POLYNOMIAL COEFFICIENTS:'
!write(u6,'(A,4F16.8)') ' ENOW,ELAST,FP,FPLAST',ENOW,ELAST,FP,FPLAST
!write(u6,'(A,4F16.8)') ' C0,C1,C2,C3',C0,C1,C2,C3
P = Three*C1*C3
Q = C2**2
! -- NLM=NR OF LOCAL MINIMA
NLM = 0
TLM = Zero
if (abs(P) > 0.001_wp*Q) then
  if (Q > P) then
    !write(u6,*) ' THIS IS A 3RD DEGREE POLY WITH 2 STAT. POINTS.'
    NLM = 1
    TLM = (sqrt(Q-P)-C2)/(Three*C3)
    !write(u6,*) ' THERE IS A LOCAL MINIMUM AT'
    !write(u6,*) ' TLM=',TLM
  else
    !write(u6,*) ' THIS IS A MONOTONOUS 3RD DEGREE POLY.'
  end if
else if (abs(C2) > 0.001_wp*C1) then
  if (C2 > Zero) then
    !write(u6,*) ' THIS IS A 2ND DEGREE POLY WITH A MINIMUM.'
    NLM = 1
    TLM = -C1/(Two*C2)
    !write(u6,*) ' THERE IS A LOCAL MINIMUM AT'
    !write(u6,*) ' TLM=',TLM
  else
    !write(u6,*) ' THIS IS A 2ND DEGREE POLY WITH A MAXIMUM.'
  end if
end if
!if (NLM == 0) write(u6,*) ' NO LOCAL MINIMUM.'
T0 = -Half
T1 = +2.5_wp
if (NLM == 1) then
  ELM = C0+TLM*(C1+TLM*(C2+TLM*C3))
  !write(u6,*) ' LOCAL MINIMUM AT TLM=',TLM
  !write(u6,*) '     ENERGY AT TLM IS=',ELM
  ! --  DISREGARD LOCAL MINIMUM IF TOO FAR AWAY:
  if (TLM > T1) NLM = 0
  if (TLM < T0) NLM = 0
  !if (NLM == 0) write(u6,*) ' TOO FAR AWAY -- REJECTED.'
end if
! -- RULES: 1. IF THERE IS A LOCAL MINIMUM IN THE TRUST REGION
!              -0.4<TLM<1.4, THIS IS USED.
! --        2. ELSE, SELECT THE LOWEST MINIMUM IN -0.5..+2.5.
if ((NLM == 1) .and. (abs(TLM-Half) < 0.9_wp)) then
  TMIN = TLM
  EMIN = ELM
  !write(u6,*) ' THE LOCAL MINIMUM IS USED.'
else
  E0 = C0+T0*(C1+T0*(C2+T0*C3))
  E1 = C0+T1*(C1+T1*(C2+T1*C3))
  !write(u6,*) ' EXTRAP. ENERGIES IN T=-0.5 AND 2.5 ARE'
  !write(u6,*) E0,E1
  if (E0 < E1) then
    TMIN = T0
    EMIN = E0
  else
    TMIN = T1
    EMIN = E1
  end if
  if (NLM == 1) then
    ELM = C0+TLM*(C1+TLM*(C2+TLM*C3))
    if (ELM < EMIN) then
      TMIN = TLM
      EMIN = ELM
    else
      NLM = 0
    end if
  end if
end if
!write(u6,*) '  SELECTED TMIN:',TMIN
!write(u6,*) ' PREDICTED EMIN:',EMIN
!write(u6,*) repeat('*',60)

! Predicted energy lowering, depending on step taken.
! EPRED_LS should be quite exact, if step length is not too long.
! But EPRED_SX and EPRED_QN are much more uncertain.
EPRED_LS = EMIN-ENOW
EPRED_SX = Half*DDOT_(NDIM,BK,1,XSX,1)
EPRED_QN = Half*DDOT_(NDIM,BK,1,XQN,1)
!write(u6,*) ' Predicted QN energy change:',EPRED_QN
!write(u6,*) ' Predicted SX energy change:',EPRED_SX
!write(u6,*) ' Predicted LS energy change:',EPRED_LS

! Here follows decision whether to update inverse Hessian, or not:
if (NLM == 1) then
  X = C3*(One-TMIN)/sqrt(Q-P)
  if ((abs(X) < 0.2_wp) .and. (TMIN > Half)) then
    !PAM THEN THE ERROR ARISING FROM NONLINEARITY OF GRADIENT ALONG THE
    !PAM SEARCH DIRECTION IS SMALLER THAN ABOUT 25 PERCENT, SO IT IS
    !PAM MEANINGFUL INFORMATION ABOUT GRADIENT HESSIAN. ALSO, THE
    !PAM INFORMATION GIVEN BY THE LAST GRADIENT IS BETTER THAN THE ONE
    !PAM FROM THE NEXT-TO-LAST. THEREFORE, UPDATE INVERSE HESSIAN.
    ! -- WE ARE PROBABLY IN A QUADRATIC MINIMUM REGION, SO UPDATE
    !write(u6,*) ' QUAD MINIMUM REGION -- UPDATE INVERSE HESSIAN.'
    QNUPDT = 'YES'
  else
    ! -- WE ARE OUTSIDE QUADRATIC MINIMUM.
    !write(u6,*) ' NOT IN QUADRATIC MIN. INV HESSIAN NOT UPDATED.'
    QNUPDT = ' NO'
  end if
else
  ! -- DEFINITELY NON-QUADRATIC REGION.
  !write(u6,*) ' VERY NON-QUADRATIC REGION.'
  !write(u6,*) ' SHOULD WE SCRAP ALL THE UPDATE VECTORS??'
  !write(u6,*) ' NO, BUT DO NOT UPDATE.'
  QNUPDT = ' NO'
  !if (KSDFT(1:3) /= 'SCF') NVEC = 0
end if

! I strongly mistrust the above analysis. For the moment, decide to update
! always. The analysis should instead be based on if whether a large rotation
! remains (do not update) or has been done (scrap the vectors).
!if (QNUPDT /= 'YES') write(u6,*) ' DECIDE TO UPDATE ANYWAY! (PAM Dec 2006)'
QNUPDT = 'YES'

if (QNUPDT == 'YES') then
  ! Determine new pair of update vectors, and also use it to correct XQN:
  ! Recall: VL is the difference between the old and the new BLB gradient array:
  ! VM is the difference between the old, and the new provisional, XQN arrays.
  NVEC = NVEC+1
  ! METHOD: BFGS
  V1(:) = XOLD(:)
  V2(:) = VM(:)
  X = DDOT_(NDIM,V1,1,VL,1)
  Y = DDOT_(NDIM,V2,1,VL,1)
  if (X == Zero) then
    ALPHA(NVEC) = 1.0e99_wp
    BETA(NVEC) = -1.0e49_wp
  else
    ALPHA(NVEC) = (One+Y/X)/X
    BETA(NVEC) = -One/X
  end if
  ! METHOD: SYMMETRIZED POWELL 1-RANK:
  !V1(:) = VL(:)
  !V2(:) = XOLD(:)-VM(:)
  !X = DDOT_(NDIM,V1,1,V1,1)
  !Y = DDOT_(NDIM,V2,1,V1,1)
  !ALPHA(NVEC) = -Y/(X**2)
  !BETA(NVEC) = One/X
  ! --  ADD THE NEWEST UPDATE CONTRIBUTION INTO XQN:
  X = -DDOT_(NDIM,V1,1,BK,1)
  Y = -DDOT_(NDIM,V2,1,BK,1)
  P1 = ALPHA(NVEC)*X+BETA(NVEC)*Y
  P2 = BETA(NVEC)*X
  XQN(:) = XQN(:)+P1*V1(:)+P2*V2(:)
  call DDAFILE(LUQUNE,1,V1,NDIM,IAD)
  call DDAFILE(LUQUNE,1,V2,NDIM,IAD)
  ! We have added to XQN the two-rank update,
  !  (alpha*|V1><V1| + beta*|v1><V2| + beta |V2><V1|)|BK>
end if

EPRED_QN = Half*DDOT_(NDIM,BK,1,XQN,1)
!write(u6,*) ' Predicted QN energy change (revised):', EPRED_QN

! -- IF LINE SEARCH IS NEARLY CONVERGED, USE THE QN OR SX STEP
! -- TO GET NEW DIRECTION, ELSE CONTINUE LINE SEARCH:
X = TMIN-One
if ((abs(X) < 0.4_wp) .or. (abs(EPRED_LS) < 1.0e-8_wp) .or. (KSDFT(1:3) /= 'SCF')) then
  !write(u6,*) ' THE LINE SEARCH MINIMUM IS PREDICTED TO BE'
  !write(u6,*) ' RATHER CLOSE TO THE CURRENT POINT.'
  !write(u6,*) ' THEREFORE, DO NOT CONTINUE BY LS.'
  if (NVEC == 0) QNSTEP = 'SX'
  if (NVEC > 0) QNSTEP = 'QN'
else if (NLS >= 2) then
  !write(u6,*) ' WE HAVE ALREADY USED LINE SEARCHES CONSECUTIVELY'
  !write(u6,*) '    FOR SEVERAL ITERATIONS. WE MUST TRY TO BREAK'
  !write(u6,*) '    OUT FROM THIS LINE SEARCH: DISABLE IT.'
  if (NVEC == 0) QNSTEP = 'SX'
  if (NVEC > 0) QNSTEP = 'QN'
else
  ! Else we should use a line search. But maybe check predicted effect:
  ! If predicted LS-energy minimum is not an improvement
  ! then do not use line search.
  !write(u6,*) ' THE LINE-SEARCH ANALYSIS PREDICTS A MINIMUM'
  !write(u6,*) '    PRETTY FAR FROM WHERE WE GOT WITH THE LAST'
  !write(u6,*) '    STEP. THEREFORE; WE MAY CONSIDER CONTINUING'
  !write(u6,*) '    BY LS, ALONG THE SAME DIRECTION AS LAST STEP.'
  !write(u6,*) ' BUT WILL WE GAIN FROM THAT? LETS SEE!'
  if (EPRED_LS > EPRED_QN) then
    !write(u6,*) ' LS REJECTED -- GIVES TOO LITTLE.'
    if (NVEC == 0) QNSTEP = 'SX'
    if (NVEC > 0) QNSTEP = 'QN'
  else if (EPRED_LS > EPRED_SX) then
    !write(u6,*) ' USE SX.'
    QNSTEP = 'SX'
  else
    QNSTEP = 'LS'
  end if
end if
if (QNSTEP == 'LS') then
  !write(u6,*) ' USE LINE SEARCH.'
  XSX(:) = (TMIN-One)*XOLD(:)
end if
if (QNSTEP == 'QN') then
  !write(u6,*) ' USE QN STEP.'
  XSX(:) = XQN(:)
end if
!if (QNSTEP == 'SX') write(u6,*) ' USE SX STEP.'

! Often, use of qune results in getting caught in a cyclic or caotic
! attractor towards the end. As an attempt to break such a pattern,
! apply a scaling whenever energy goes up:
if (ENOW > ELAST) XSX(:) = 0.7_wp*XSX(:)

! Before committing the finally suggested step (which is now in XSX),
! also apply a step size limitation. The squared 2-norm of the vector XSX
! sum of squares of rotation angles, so the 2-norm is a strict limit on
! largest rotation angle, which we (arbitrarily) limit to 0.5 (say):
XSXNRM = DNRM2_(NDIM,XSX,1)
SCLFCT = One/(One+Two*XSXNRM)
XSX(:) = SCLFCT*XSX(:)

ELAST = ENOW
FPLAST = Two*DDOT_(NDIM,BK,1,XSX,1)
IAD = 0
call DDAFILE(LUQUNE,1,BK,NDIM,IAD)
call DDAFILE(LUQUNE,1,XQN,NDIM,IAD)
call DDAFILE(LUQUNE,1,XSX,NDIM,IAD)
NLS = NLS+1
if (QNSTEP /= 'LS') NLS = 0

end subroutine QUNE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine calcmagn2(N,NM,W,T,H,M,dX,dY,dZ,L, MT,Z)
!  this subroutine sums the contribution to molar magnetization from
!  different states:
!    -- from the states obtained in exact Zeeman diagonalization (NM) and
!    -- from the states higher in energy via second order perturbation
!----------------------------------------------------------------------
!  Input data:
!     N  -  total number of states
!    NM  -  number of states enterring the exact Zeeman diagonalization
!          (NM <= N)
!   W(N) -  energy of the input states
!
!
      Implicit None
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)          :: N, NM, L
      Real(kind=8), intent(in)    :: W(N), T, dX, dY, dZ, H
      Real(kind=8), intent(out)   :: MT, Z
      Complex(kind=8), intent(in) :: M(3,N,N)

      Integer                    :: i, j
      Real(kind=8)              :: pB, dltw, S2, S1, mB, kB
c /// constants
      mB=0.4668643740_wp                  ! * in cm-1*T-1
      kB=0.69503560_wp                    !   in cm^-1*K-1
      pB=0.0_wp
      Z =0.0_wp
      MT=0.0_wp
      DLTW=0.0_wp

      Do I=1,N
        pB=EXP(-(W(I)-W(1))/kB/T)
        Z=Z+pB
        If(I.LE.NM) Then
c  case when I <= NM
          S2=0.0_wp
          S2=DBLE(M(L,I,I))
          Do J = NM+1, N
            DLTW=W(I)-W(J)
            S1=0.0_wp
            S1=DBLE( M(L,I,J)*CONJG(M(1,I,J)) )*dX
     &        +DBLE( M(L,I,J)*CONJG(M(2,I,J)) )*dY
     &        +DBLE( M(L,I,J)*CONJG(M(3,I,J)) )*dZ
            S2=S2 - 2.0_wp * mB * H * S1 / DLTW
          End Do ! J
        Else  !  I
c  case when I > NM
          Do J=1,N
            DLTW=W(I)-W(J)
            S1=0.0_wp
            S2=0.0_wp
            S1=DBLE( M(L,I,J)*CONJG(M(1,I,J)) )*dX
     &        +DBLE( M(L,I,J)*CONJG(M(2,I,J)) )*dY
     &        +DBLE( M(L,I,J)*CONJG(M(3,I,J)) )*dZ

            If(abs(DLTW).lt.1.D-3) Then
              S2=S2 + 1.0_wp * mB * H * S1 / kB / T
            Else
              S2=S2 - 2.0_wp * mB * H * S1 / DLTW
            End If
          End Do ! J
        End If  !  I
        MT=MT+pB*S2
      End Do !I

      MT=MT/Z

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1992, Roland Lindh                                *
!               1990, IBM                                              *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine PSOAO2(nSO,MemPrm,MemM,iAnga,iCmpa,iAO,iFnc,iBas,iBsInc,jBas,jBsInc,kBas,kBsInc,lBas,lBsInc,iPrim,iPrInc,jPrim,jPrInc, &
                  kPrim,kPrInc,lPrim,lPrInc,nAco,Mem1,Mem2,Mem3,Mem4,MemX,MemPSO,MemFck,nFT,nCMO,MemFin,MemBuffer,iMemB)
!***********************************************************************
!                                                                      *
!  Object: to partion the SO and AO block. It will go to some length   *
!          before it will start and break up the SO block. This will   *
!          reduce the total flop count. However, as we are breaking up *
!          the AO block this will affect the vectorization. Hence, at  *
!          some point it will actually be better to recompute the      *
!          primitives.                                                 *
!          Current stratergy:                                          *
!          1. Reduce the size of the density matrix and buffer so that *
!             it fits into memory.                                     *
!                                                                      *
!          2. Start reducing the length of the primitives in the order *
!             lPrim,jPrim.                                             *
!                                                                      *
!          3. Reduce the size of the SO block by reducing the number of*
!             basis functions in the order lBas, jBas.                 *
!                                                                      *
!          4. Reduce the size of the Buffer.                           *
!                                                                      *
!          5. Reduce kBas,iBas                                         *
!                                                                      *
!          6. Terminate run telling job max and min of additional      *
!             memory needed to perform the calculation.                *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!             Modified to first order derivatives. January '92         *
!             Anders Bernhardsson Theoretical chemistry, Lund 1995     *
!***********************************************************************

! Memory map for mckinley
!
!---------------------------------------------------------------------------
!|      |               |       |               |               |          |
!|REAL  |  P TRANSF     | RYSG2 |   Transf      | FCK GENERAT   |MO Transf |
!|      |               |       |               |               |          |
!---------------------------------------------------------------------------
!|      |               |       |               |               |Scratch   |
!|  MX  |               |       | 9*abcd*ijkl   |    SS         |space     |
!|      |               |       |               |               |          |
!---------------------------------------------------------------------------
!|      |               |       |               |               |          |
!|  M3  |Scratch space  |Memrys |Scratch space  |    SS         | Scratch  |
!|      |               |       |               |               | space    |
!---------------------------------------------------------------------------
!|      |MEM4 (half tr) |*******|***************|               |          |
!|  M2  |               |       |               |               |  SS      |
!|      |PSO transf     |       |               |Scratch space  |          |
!---------------------------------------------------------------------------
!|      |               |       |               |               |          |
!|  M1  |      P        |   *   |      *        |     *         |    *     |
!|      |               |       |               |               |          |
!---------------------------------------------------------------------------
!|      |      ?        |       |               |               |          |
!|Buffer|***************|*******|Transformed    |***************|**********|
!|      |               |       |integrals      |               |          |
!---------------------------------------------------------------------------

use McKinley_global, only: nMethod, RASSCF
use Index_Functions, only: nTri_Elem1
use Gateway_global, only: force_part_p !, force_part_c
use SOAO_Info, only: iAOtSO
use pso_stuff, only: lPSO
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSO, MemPrm, MemM, iAnga(4), iCmpa(4), iAO(4), iBas, jBas, kBas, lBas, iPrim, jPrim, kPrim, &
                                 lPrim, nAco, iMemB
integer(kind=iwp), intent(out) :: iFnc(4), iBsInc, jBsInc, kBsInc, lBsInc, iPrInc, jPrInc, kPrInc, lPrInc, Mem1, Mem2, Mem3, Mem4, &
                                  MemX, MemPSO, MemFck, nFT, nCMO, MemFin, MemBuffer
#include "pstat.fh"
integer(kind=iwp) :: i1, iiBas(4), iCmp, iFac, iTmp1, j, jCmp, jPam, kCmp, kSOInt, la, lb, lc, lCmp, ld, mabcd, Mem0, MemAux, &
                     MemCntrct, MemDep, MemF, MemMax, MemMO, MemRys, MemScr, MemSph, MemTrn, nabcd, nFac, nijkl, nMax, nMaxC, &
                     nPam(4,0:7), nTmp1, nTmp2
logical(kind=iwp) :: Fail, QiBas, QjBas, QjPrim, QkBas, QlBas, QlPrim
integer(kind=iwp), external :: MemTra

!iRout = 10
!iPrint = nPrint(iRout)
la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)
iCmp = iCmpa(1)
jCmp = iCmpa(2)
kCmp = iCmpa(3)
lCmp = iCmpa(4)
iTotal = iTotal+1
mabcd = nTri_Elem1(la)*nTri_Elem1(lb)*nTri_Elem1(lc)*nTri_Elem1(ld)
nabcd = iCmp*jCmp*kCmp*lCmp

!if (force_part_c) then
!  iBsInc = (iBas+1)/2
!  jBsInc = (jBas+1)/2
!  kBsInc = (kBas+1)/2
!  lBsInc = (lBas+1)/2
!else
iBsInc = iBas
jBsInc = jBas
kBsInc = kBas
lBsInc = lBas
!end if
if (force_part_p) then
  jPrInc = (jPrim+1)/2
  !lPrInc = (lPrim+1)/2
else
  jPrInc = jPrim
  !lPrInc = lPrim
end if
iPrInc = iPrim
kPrInc = kPrim
lPrInc = lPrim
MemBuffer = iMemB
MemMax = MemM-MemBuffer

do
  nijkl = iBsInc*jBsInc*kBsInc*lBsInc
  QjPrim = .false.
  QlPrim = .true.
  QiBas = .false.
  QjBas = .false.
  QkBas = .false.
  QlBas = .false.
  Mem0 = MemMax

  ! Picked MO coeff

  if (nMethod == RASSCF) then
    nCMO = nACO*kCmp*kBas+nACO*lCmp*lBas
  else
    nCMO = 0
  end if

  ! Area for integral storage before transforming them to FM/MO
  ! and place for the CMOs

  MemFin = 9*nijkl*nabcd
  if (MemFin+ncmo+1 > Mem0) then
    MaxReq = max(MaxReq,nCMO+MemFin+1-Mem0)
    QlPrim = .false.
    call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                MaxReq,Fail)
    if (Fail) then
      write(u6,*) 'PSOAO2: memory partitioning failed!'
      write(u6,*) '        Restart with more memory!'
      call Abend()
    end if
    cycle
  end if
  ! Subtract one additional word for getmem's internal error check
  Mem0 = Mem0-MemFin-nCMO-1

  !---------------------------------------------------------------------

  ! *** Work1 ***

  ! Memory for 2nd order density matrix in SO basis.

  kSOInt = nSO*iBsInc*jBsInc*kBsInc*lBsInc
  Mem1 = kSOInt

  ! Allocate memory for MO to SO/AO transformation
  ! of the 2nd order density matrix for this shell quadruplet.
  ! and area for AO/SO transformation of Fock matrix.

  if (lPSO) then
    iiBas(1) = iBsInc
    iiBas(2) = jBsInc
    iiBas(3) = kBsInc
    iiBas(4) = lBsInc
    nPam(:,:) = 0
    MemPSO = 1
    nTmp2 = 0
    !call IecPrt('iiBas',iiBas,1,4)

    do jPam=1,4
      iTmp1 = 0
      nTmp1 = 0
      do j=0,nIrrep-1
        do i1=1,iCmpa(jPam)
          if (iAOtSO(iAO(jPam)+i1,j) > 0) then
            nPam(jPam,j) = nPam(jPam,j)+iiBas(jPam)
            nTmp1 = nTmp1+iiBas(jPam)
            iTmp1 = iTmp1+1
          end if
        end do
      end do
      MemPSO = MemPSO*nTmp1
      nTmp2 = nTmp2+nTmp1
      iFnc(jPam) = iTmp1
    end do
    MemScr = MemTra(nPam)
    nFac = 4
    nTmp2 = nTmp2+4
  else
    MemScr = 0
    MemPSO = 0
    nFac = 0
    nTmp2 = 0
  end if
  MemAux = MemPSO+MemScr+nFac*S%nDim+nTmp2+4
  if (Mem1+1+MemAux > Mem0) then
    MaxReq = max(MaxReq,Mem1+1+MemAux-Mem0)
    QjPrim = .false.
    QlPrim = .false.
    QiBas = .false.
    QjBas = .false.
    QkBas = .false.
    QlBas = .true.
    call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                MaxReq,Fail)
    if (Fail) then
      write(u6,*) 'PSOAO2: memory partitioning failed!'
      write(u6,*) '        Restart with more memory!'
      call Abend()
    end if
    cycle
  end if
  Mem0 = Mem0-Mem1-1
  !---------------------------------------------------------------------
  !
  ! MemFck: Target for generating the symmetrized Fock Matrix.
  !          Distributed localy.
  ! MemMo : Target for generating the  MO integrals
  !          Distributed localy.
  ! Whole work area is used, if work area is big enough work3 is increased
  !
  !----------------------------------------------------------------------

  MemDep = nijkl*nabcd
  ! Temp+S1+S2
  MemFck = 2*MemDep+max(MemDep,nijkl+max(iBsInc*lBsInc,jBsInc*lBsInc,iBsInc*kBsInc,jBsInc*kBsInc))
  nFT = iBsInc*jBsInc*iCmp*jCmp+kBsInc*lBsInc*kCmp*lCmp+iBsInc*kBsInc*iCmp*kCmp+jBsInc*lBsInc*jCmp*lCmp+iBsInc*lBsInc*iCmp*lCmp+ &
        jBsInc*kBsInc*jCmp*kCmp
  MemFck = MemFck+nFT
  if (nmethod == RASSCF) then

    !3 scratch spaces, sorted integrals and translation

    nMaxC = nACO
    MemFck = MemFck+2*nMaxC
    nMax = max(iCmp*iBsInc,jCmp*jBsInc,kCmp*kBsInc,lcmp*lBsInc)
    nMax = max(nMax,nMaxC)
    MemMO = 3*nMax**4+10*nabcd*nijkl
  else
    MemMo = 0
  end if

  !---------------------------------------------------------------------

  ! *** Work2 and Work4 ***

  ! Memory for 2nd order density matrix in contracted basis
  !   (both cartesian and spherical harmonic) and in primitive basis.
  ! MemDeP: Target for desymmetrization
  ! MemTrn: Scratch and target for decontraction
  ! MemAux: Contracted 2nd order density matrix (if partial decon.)
  ! MemSph: transformation spherical harmonics to cartesian, source and target.

  MemDeP = nabcd*nijkl
  MemTrn = mabcd*max(iBsInc*jBsInc*kBsInc*lBsInc,iPrInc*jPrInc*kBsInc*lBsInc,iPrInc*jPrInc*kPrInc*lPrInc)
  MemTrn = MemTrn+1

  ! If partial decontraction we need to keep the contracted 2nd
  ! order density matrix. (Work4)
  if ((jPrInc /= jPrim) .or. (lPrInc /= lPrim)) then
    MemAux = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
  else
    MemAux = 0
  end if
  MemSph = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
  Mem2 = max(MemTrn+MemAux,MemDeP,MemSph)
  MemFck = MemFck-Mem2
  MemMO = MemMo-Mem2
  if (Mem2+1 > Mem0) then
    MaxReq = max(MaxReq,Mem2+1-Mem0)
    call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                MaxReq,Fail)
    if (Fail) then
      write(u6,*) 'PSOAO2: memory partitioning failed!'
      write(u6,*) '        Restart with more memory!'
      call Abend()
    end if
    cycle
  end if
  ! Subtract one additional word for getmem's internal error check
  Mem0 = Mem0-Mem2-1
  MemX = 9*mabcd*iBsInc*jBsInc*kBsInc*lBsInc
  MemFck = MemFck-MemX
  MemMO = MemMo-MemX
  if (MemX+1 > Mem0) then
    MaxReq = max(MaxReq,MemX+1-Mem0)
    call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                MaxReq,Fail)
    if (Fail) then
      write(u6,*) 'PSOAO2: memory partitioning failed!'
      write(u6,*) '        Restart with more memory!'
      call Abend()
    end if
    cycle
  end if
  Mem0 = Mem0-MemX

  ! *** Work3 and Work5 ***

  ! Scratch for decontraction and transformation to spherical gaussian.
  ! Working array for Rysg2.
  ! Scratch area for resolving degeneracies due to the double coset
  ! treatement of the symmetry.
  ! MemTrn: Scratch for decontraction
  ! MemRys: Scratch for calualation of primitive integral gradients.

  iFac = 1
  if (mabcd /= 1) iFac = 2
  MemF = 9*nabcd*nijkl
  MemTrn = mabcd*max(iPrInc*jBsInc*kBsInc*lBsInc,iPrInc*jPrInc*kPrInc*lBsInc,iPrInc*jPrInc*kPrInc*lPrInc*iFac)
  MemRys = MemPrm*iPrInc*jPrInc*kPrInc*lPrInc+80

  ! Scratch space for contraction of the integrals

  MemCntrct = 9*mabcd*(max(iBsInc*jBsInc*kBsInc*lPrInc,iBsInc*jPrInc*kPrInc*lPrInc)+iBsInc*jBsInc*kPrInc*lPrInc)

  MemFck = max(0,MemFck)
  MemMo = max(0,MemMo)
  Mem3 = max(MemMO,MemFck,MemTrn,MemRys,2*MemF,MemF+MemCntrct)
  if (Mem3+1 <= Mem0) exit
  MaxReq = max(MaxReq,Mem3+1-Mem0)
  call Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
              MaxReq,Fail)
  if (Fail) then
    write(u6,*) 'PSOAO2: memory partitioning failed!'
    write(u6,*) '        Restart with more memory!'
    call Abend()
  end if
end do
! Subtract one additional word for getmem's internal error check
Mem0 = Mem0-Mem3-1

! Work4, if used, is placed at the end of Work2
if ((jPrInc /= jPrim) .or. (lPrInc /= lPrim)) then
  Mem4 = MemAux
else
  Mem4 = Mem2
end if

return

end subroutine PSOAO2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_multipole_ints

use fmm_global_paras, only: INTK, REALK, LUINTM, fmm_basis, fmm_sh_pairs, fmm_prim_batch, Zero, Pi
implicit none
private
! Public procedures
public :: fmm_init_multipole_ints, &
          fmm_free_multipole_ints, &
          fmm_build_multipoles

real(REALK), allocatable :: ECoefX(:,:,:,:)
real(REALK), allocatable :: ECoefY(:,:,:,:)
real(REALK), allocatable :: ECoefZ(:,:,:,:)

real(REALK), allocatable :: MIntX(:,:,:)
real(REALK), allocatable :: MIntY(:,:,:)
real(REALK), allocatable :: MIntZ(:,:,:)

real(REALK), allocatable :: MpoleX(:,:,:,:)
real(REALK), allocatable :: MpoleY(:,:,:,:)
real(REALK), allocatable :: MpoleZ(:,:,:,:)

real(REALK), allocatable :: CarMpole(:,:,:)
real(REALK), allocatable :: SphMpole(:,:,:)

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_multipole_ints(basis,MaxMul)

  implicit none
  type(fmm_basis), intent(in) :: basis
  integer(INTK), intent(in)   :: MaxMul

  integer(INTK) :: MaxAngl, MaxSgm2
  MaxAngl = basis%maxangl
  MaxSgm2 = basis%maxsgm2

  allocate(ECoefX(0:MaxAngl,0:MaxAngl,0:MaxAngl*2,MaxSgm2))
  allocate(ECoefY(0:MaxAngl,0:MaxAngl,0:MaxAngl*2,MaxSgm2))
  allocate(ECoefZ(0:MaxAngl,0:MaxAngl,0:MaxAngl*2,MaxSgm2))

  allocate(MIntX(-1:MaxMul+1,-1:MaxMul+1,MaxSgm2))
  allocate(MIntY(-1:MaxMul+1,-1:MaxMul+1,MaxSgm2))
  allocate(MIntZ(-1:MaxMul+1,-1:MaxMul+1,MaxSgm2))

  allocate(MpoleX(0:MaxAngl,0:MaxAngl,0:MaxMul,MaxSgm2))
  allocate(MpoleY(0:MaxAngl,0:MaxAngl,0:MaxMul,MaxSgm2))
  allocate(MpoleZ(0:MaxAngl,0:MaxAngl,0:MaxMul,MaxSgm2))

end subroutine fmm_init_multipole_ints

!-------------------------------------------------------------------------------

subroutine fmm_free_multipole_ints()

  implicit none
  deallocate(ECoefX)
  deallocate(ECoefY)
  deallocate(ECoefZ)

  deallocate(MIntX)
  deallocate(MIntY)
  deallocate(MIntZ)

  deallocate(MpoleX)
  deallocate(MpoleY)
  deallocate(MpoleZ)

  if (allocated(CarMpole)) deallocate(CarMpole)
  if (allocated(SphMpole)) deallocate(SphMpole)

end subroutine fmm_free_multipole_ints

!-------------------------------------------------------------------------------

subroutine fmm_build_multipoles(basis,MaxMul,sh_pairs)

  use fmm_car_to_sph, only: fmm_init_car_to_sph, &
                            fmm_free_car_to_sph
  use fmm_integral_utils, only: fmm_get_prim_batch, &
                                fmm_build_Ecoef1, &
                                fmm_build_Ecoef2

  implicit none
  type(fmm_basis), intent(in)    :: basis
  integer(INTK), intent(in)      :: MaxMul
  type(fmm_sh_pairs), intent(in) :: sh_pairs(:)

  !fixme
  character(len=*), parameter :: FName = 'multipoles'

  type(fmm_prim_batch) :: batch(basis%MaxSgm2)
  character(len=255) :: FBuf
  integer(INTK) :: Ish, Jsh, NPrim, IAnglA, IAnglB
  integer(INTK) :: i, ij, nmoms
  integer(INTK), external :: IsFreeUnit

  call fmm_init_car_to_sph(MaxMul)

  FBuf = trim(FName)//'.fmm1'
  LUINTM = IsFreeUnit(LUINTM)
  open(unit=LUINTM,file=trim(FBuf),status='REPLACE',access='SEQUENTIAL',form='UNFORMATTED')
  rewind(LUINTM)

  nmoms = 0
  do ij=1,size(sh_pairs)
    !print *, SIZE(sh_pairs), ij

    Ish = sh_pairs(ij)%I
    Jsh = sh_pairs(ij)%J

    ! Prepare batch of primitives
    call fmm_get_prim_batch(basis,Ish,Jsh,batch,NPrim)
    ! Build Hermite expansion E-coefficients
    IAnglA = basis%KType(Ish)
    IAnglB = basis%KType(Jsh)
    if (IAnglA >= IAnglB) then
      call fmm_build_Ecoef1(batch,NPrim,IAnglA,IAnglB,ECoefX,ECoefY,ECoefZ)
    else
      call fmm_build_Ecoef2(batch,NPrim,IAnglA,IAnglB,ECoefX,ECoefY,ECoefZ)
    end if

    ! Set multipole origin
    do i=1,NPrim
      batch(i)%PC(:) = batch(i)%P(:)-sh_pairs(ij)%centre(:)
    end do
    ! Build Hermite multipole moment integrals
    call fmm_build_Mints(batch,NPrim,MaxMul)

    ! Build spherical multipole integrals for Cartesian GTOs
    ! assuming final Fock matrix in spherical GTOs
    ! (only difference is we use spherical AO contraction coefs)
    ! When using these multipoles need Cartesian form of
    ! density and J_matrices
    call fmm_build_Mpole_ints(IAnglA,IAnglB,NPrim,MaxMul)
    call fmm_build_SphMpole(basis,batch,Ish,Jsh,NPrim,MaxMul)
    call fmm_store_SphMpole(basis,batch,Ish,Jsh,NPrim,MaxMul,sh_pairs(ij)%centre,nmoms)
  end do

  ! Mark end of file with negative L-index
  write(LUINTM) 0,-1,0,0,0,zero,zero,zero,zero
  close(unit=LUINTM,status='KEEP')

  FBuf = trim(FName)//'.fmm1header'
  LUINTM = IsFreeUnit(LUINTM)
  open(unit=LUINTM,file=trim(FBuf),status='REPLACE',access='SEQUENTIAL',form='UNFORMATTED')
  write(LUINTM) MaxMul,basis%nbas,nmoms
  close(unit=LUINTM,status='KEEP')

  call fmm_free_car_to_sph()

end subroutine fmm_build_multipoles

!-------------------------------------------------------------------------------

subroutine fmm_build_Mints(batch,NPrim,MaxMul)

  ! o Evaluate 1D multipole-moment integrals

  implicit none

  type(fmm_prim_batch), intent(in) :: batch(:)
  integer(INTK), intent(in)        :: NPrim, MaxMul

  integer(INTK) :: Ie, It, IJ

  real(REALK) :: PXCX(NPrim), PYCY(NPrim), PZCZ(NPrim)
  real(REALK) :: ExpPHalf(NPrim), ExpntP(NPrim)

  PXCX(:) = batch(1:Nprim)%PC(1)
  PYCY(:) = batch(1:Nprim)%PC(2)
  PZCZ(:) = batch(1:Nprim)%PC(3)
  ExpPHalf(:) = batch(1:Nprim)%ExpPHalf
  ExpntP(:) = batch(1:Nprim)%ExpntP

  ! o Recurrence relation
  !   M(t,e,NPrim)

  MIntX(:,:,:) = Zero
  MIntY(:,:,:) = Zero
  MIntZ(:,:,:) = Zero

  MIntX(0,0,1:NPrim) = sqrt(Pi/ExpntP(:))
  MIntY(0,0,1:NPrim) = sqrt(Pi/ExpntP(:))
  MIntZ(0,0,1:NPrim) = sqrt(Pi/ExpntP(:))

  do Ie=1,MaxMul
    do It=0,Ie
      do IJ=1,NPrim
        MIntX(It,Ie,IJ) = real(It,kind=REALK)*MIntX(It-1,Ie-1,IJ)
        MIntY(It,Ie,IJ) = real(It,kind=REALK)*MIntY(It-1,Ie-1,IJ)
        MIntZ(It,Ie,IJ) = real(It,kind=REALK)*MIntZ(It-1,Ie-1,IJ)
      end do
      do IJ=1,NPrim
        MIntX(It,Ie,IJ) = MIntX(It,Ie,IJ)+PXCX(IJ)*MIntX(It,Ie-1,IJ)
        MIntY(It,Ie,IJ) = MIntY(It,Ie,IJ)+PYCY(IJ)*MIntY(It,Ie-1,IJ)
        MIntZ(It,Ie,IJ) = MIntZ(It,Ie,IJ)+PZCZ(IJ)*MIntZ(It,Ie-1,IJ)
      end do
      do IJ=1,NPrim
        MIntX(It,Ie,IJ) = MIntX(It,Ie,IJ)+ExpPHalf(IJ)*MIntX(It+1,Ie-1,IJ)
        MIntY(It,Ie,IJ) = MIntY(It,Ie,IJ)+ExpPHalf(IJ)*MIntY(It+1,Ie-1,IJ)
        MIntZ(It,Ie,IJ) = MIntZ(It,Ie,IJ)+ExpPHalf(IJ)*MIntZ(It+1,Ie-1,IJ)
      end do
    end do
  end do

end subroutine fmm_build_Mints

!-------------------------------------------------------------------------------

subroutine fmm_build_Mpole_ints(IAnglA,IAnglB,NPrim,MaxMul)

  implicit none

  integer(INTK), intent(in) :: IAnglA, IAnglB, NPrim, MaxMul

  integer(INTK) :: It1, It2, Ie, It, IJ
  integer(INTK) :: ItMax

  MpoleX(:,:,:,:) = zero
  MpoleY(:,:,:,:) = zero
  MpoleZ(:,:,:,:) = zero

  do It1=0,IAnglA
    do It2=0,IAnglB
      do Ie=0,MaxMul
        ItMax = min((It1+It2),Ie)
        do It=0,ItMax
          do IJ=1,NPrim
            MpoleX(It1,It2,Ie,IJ) = MpoleX(It1,It2,Ie,IJ)+ECoefX(It1,It2,It,IJ)*MIntX(It,Ie,IJ)
            MpoleY(It1,It2,Ie,IJ) = MpoleY(It1,It2,Ie,IJ)+ECoefY(It1,It2,It,IJ)*MIntY(It,Ie,IJ)
            MpoleZ(It1,It2,Ie,IJ) = MpoleZ(It1,It2,Ie,IJ)+ECoefZ(It1,It2,It,IJ)*MIntZ(It,Ie,IJ)
          end do
        end do
      end do
    end do
  end do

end subroutine fmm_build_Mpole_ints

!-------------------------------------------------------------------------------

subroutine fmm_build_SphMpole(basis,batch,Ish,Jsh,NPrim,MaxMul)

  use fmm_car_to_sph, only: fmm_transform_car_to_sph

  implicit none
  type(fmm_basis), intent(in)      :: basis
  type(fmm_prim_batch), intent(in) :: batch(:)
  integer(INTK), intent(in)        :: Ish, Jsh, NPrim, MaxMul

  !fixme
  real(REALK), parameter :: ThrInt = 1.0e-12_REALK

  logical :: IEqJ
  integer(INTK) :: IAnglA, IAnglB
  integer(INTK) :: IL1, IL2, IL3
  integer(INTK) :: IeX, IeY, IeZ, MType, MCar
  integer(INTK) :: It1, Iu1, Iv1
  integer(INTK) :: It2, Iu2, Iv2
  integer(INTK) :: IJ, IBatch
  !integer(INTK) :: IIBatch
  integer(INTK) :: IL2Temp
  integer(INTK) :: Labelp, Labelq, ndim
  real(REALK) :: Temp1, Temp2

  IAnglA = basis%KType(Ish)
  IAnglB = basis%KType(Jsh)

  ndim = (basis%LtuvMax_Car(IAnglA)-basis%LtuvMin_Car(IAnglA)+1)*(basis%LtuvMax_Car(IAnglB)-basis%LtuvMin_Car(IAnglB)+1)
  ndim = ndim*NPrim

  allocate(CarMpole(ndim,(MaxMul+1)*(MaxMul+2)/2,0:MaxMul))
  if (.not. allocated(SphMpole)) then
    allocate(SphMpole(ndim,(2*MaxMul+1),0:MaxMul))
  end if

  CarMpole(:,:,:) = zero

  IEqJ = (ISh == JSh)
  IBatch = 0
  !IIBatch = 0
  Labelp = basis%KLoc_Car(ISh)
  do IL1=basis%LtuvMin_Car(IAnglA),basis%LtuvMax_Car(IAnglA)
    Labelp = Labelp+1
    It1 = basis%Lt(IL1)
    Iu1 = basis%Lu(IL1)
    Iv1 = basis%Lv(IL1)

    Labelq = basis%KLoc_Car(JSh)
    IL2Temp = basis%LtuvMax_Car(IAnglB)
    if (IEqJ) IL2Temp = IL1
    do IL2=basis%LtuvMin_Car(IAnglB),IL2Temp
      IBatch = IBatch+1
      Labelq = Labelq+1
      It2 = basis%Lt(IL2)
      Iu2 = basis%Lu(IL2)
      Iv2 = basis%Lv(IL2)

      !contracted functions
      do MType=0,MaxMul
        do MCar=1,(MType+1)*(MType+2)/2
          IL3 = MCar+basis%LtuvMin_Car(MType)-1
          IeX = basis%Lt(IL3)
          IeY = basis%Lu(IL3)
          IeZ = basis%Lv(IL3)

          Temp1 = Zero
          do IJ=1,NPrim
            Temp2 = MpoleX(It1,It2,IeX,IJ)*MpoleY(Iu1,Iu2,IeY,IJ)*MpoleZ(Iv1,Iv2,IeZ,IJ)*batch(IJ)%CCoefAB
            Temp1 = Temp1+Temp2
          end do

          if (abs(Temp1) >= ThrInt) CarMpole(IBatch,MCar,MType) = Temp1

        end do
      end do

      !primitive functions
      !do IJ=1, NPrim
      !  IIbatch = IIbatch +1
      !  do MType=0,MaxMul
      !    do MCar=1,(MType+1)*(MType+2)/2
      !
      !      IL3 = MCar+basis%LtuvMin_Car(MType)-1
      !      IeX = basis%Lt(IL3)
      !      IeY = basis%Lu(IL3)
      !      IeZ = basis%Lv(IL3)
      !      Temp1 = MpoleX(It1,It2,IeX,IJ)*MpoleY(Iu1,Iu2,IeY,IJ)*MpoleZ(Iv1,Iv2,IeZ,IJ)*batch(IJ)%CCoefAB
      !      if (abs(Temp1) >= ThrInt) CarMpole(IIBatch,MCar,MType) = Temp1
      !
      !    end do
      !  end do
      !end do
      !------------

    end do
  end do

  !print *, 'carmpole:'
  !do iex=1,size(carmpole,1)
  !  do MType=0,MaxMul
  !    do MCar=1,(MType+1)*(MType+2)/2
  !      print *, mtype,mcar,carmpole(iex,mcar,mtype)
  !    end do
  !  end do
  !end do

  ! Transform batch of cartesian integrals to spherical moments
  !ndim = MAX(Ibatch,IIbatch)
  ndim = size(CarMpole,1)
  call fmm_transform_car_to_sph(CarMpole,SphMpole,ndim,MaxMul)

  deallocate(CarMpole)

end subroutine fmm_build_SphMpole

!-------------------------------------------------------------------------------

subroutine fmm_store_SphMpole(basis,batch,Ish,Jsh,NPrim,MaxMul,mcntr,nmoms)

#include "macros.fh"

  implicit none
  type(fmm_basis), intent(in)      :: basis
  type(fmm_prim_batch), intent(in) :: batch(:)
  integer(INTK), intent(in)        :: ISh, JSh, MaxMul, NPrim
  real(REALK), intent(in)          :: mcntr(3)
  integer(INTK), intent(inout)     :: nmoms

  real(REALK), parameter :: MomScrn = 1.0e-15_REALK
  logical :: IEqJ, flag
  integer(INTK) :: IAnglA, IAnglB
  integer(INTK) :: IL1, IL2 !, IJ
  integer(INTK) :: MType, MSph
  integer(INTK) :: IBatch
  !integer(INTK) :: IIBatch
  integer(INTK) :: IL2Temp
  integer(INTK) :: Labelp, Labelq

  IEqJ = (ISh == JSh)
  IAnglA = basis%KType(Ish)
  IAnglB = basis%KType(Jsh)

  IBatch = 0
  !IIBatch = 0
  Labelp = basis%KLoc_Car(ISh)
  do IL1=basis%LtuvMin_Car(IAnglA),basis%LtuvMax_Car(IAnglA)
    Labelp = Labelp+1
    Labelq = basis%KLoc_Car(JSh)
    IL2Temp = basis%LtuvMax_Car(IAnglB)
    if (IEqJ) IL2Temp = IL1
    do IL2=basis%LtuvMin_Car(IAnglB),IL2Temp
      IBatch = IBatch+1
      Labelq = Labelq+1

      !contracted functions
      flag = .false.
      do MType=0,MaxMul
        do MSph=1,(MType+MType+1)
          ! Weak screening
          if (abs(SphMpole(IBatch,MSph,MType)) < MomScrn) cycle
          flag = .true.
          write(LUINTM) nmoms+1,MType,(MSph-MType-1),Labelp,Labelq,mcntr(1:3),SphMpole(IBatch,MSph,MType)
        end do
      end do
      if (flag) nmoms = nmoms+1

      unused_var(batch)
      unused_var(NPrim)

      !primitive functions
      !do IJ=1,NPrim
      !  IIBatch = IIBatch + 1
      !  flag = .false.
      !  do MType=0,MaxMul
      !    do MSph=1,(MType+MType+1)
      !      ! Weak screening
      !      if (ABS(SphMpole(IIBatch,MSph,MType)) < MomScrn) cycle
      !      flag = .true.
      !      write(LUINTM) nmoms,MType,(MSph-MType-1),Labelp,Labelq,batch(IJ)%P(1:3),SphMpole(IIBatch,MSph,MType)
      !    end do
      !  end do
      !  if (flag) nmoms = nmoms + 1
      !end do
      !------------

    end do
  end do

  if (allocated(SphMpole)) deallocate(SphMpole)

end subroutine fmm_store_SphMpole

!-------------------------------------------------------------------------------

end module fmm_multipole_ints

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
       SubRoutine OutPut_Mclr(iKapDisp,isigdisp,iCiDisp,
     &                        iCiSigDisp,iRHSDisp,iRHSCIDisp,
     &                        converged)
********************************************************************
*                                                                  *
* Contracts the response coefficient to the hessian                *
*                                                                  *
* Input                                                            *
*       iKapDisp : Disk locations of solutions to respons equation *
*       iSigDisp : Disk locations of RHS                           *
*       iCIDisp  : Disk locations of CI Soulutions to response     *
*       iCISigDisp : Disk locations of RHS                         *
*       nHess    : Length of hessian                               *
*                                                                  *
* Output to disk                                                   *
*                                                                  *
*       RespHess : Hessian etc                                     *
*       Hess     : Hessian etc                                     *
*                                                                  *
* Author: Anders Bernhardsson, 1996                                *
*         Theoretical Chemistry, University of Lund                *
********************************************************************
       Implicit Real*8 (a-h,o-z)
#include "detdim.fh"

#include "Input.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "disp_mclr.fh"
#include "cicisp_mclr.fh"
#include "WrkSpc.fh"
       Character*8 Label
#ifdef _DEBUGPRINT_
       Character*20 Label2
#endif
       Integer Pstate_sym,ldisp2(8),ielec(3)
       Integer iKapDisp(nDisp),isigdisp(nDisp),
     &         iCiDisp(nDisp),iCiSigDisp(nDisp),
     &         iRHSDisp(nDisp),iRHSCiDisp(nDisp)
       Logical elec,converged(8),CI
       Real*8 Pola(6)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*
#ifdef _DEBUGPRINT_
       debug=.True.
#else
       debug=.false.
#endif
       nHss=0
       Do iS=1,nSym
        nHss=nHss+lDisp(is)*(lDisp(is)+1)/2
       End Do
       nhess=nDIsp*(nDisp+1)/2
       Call GetMem('RESPH','ALLO','REAL',ipRHss,nHss)
       call dcopy_(nHss,[0.0d0],0,Work(ipRHss),1)
*
*-------------------------------------------------------------------*
*
* Ok construct hessian
*
*-------------------------------------------------------------------*
*
       mSym=0
       kSym=0
       idum=1
       idisp=0
       Do 100 iSym=1,nSym
*
*         Calculate length of the density, Fock and Kappa matrix etc
*         notice that this matrixes not necessary are symmetric.
*         Store pointers.
*
*         Input:
*         iSym : Symmetry of perturbation
*
*         Output: Commonblocks (Pointers.fh)
*
          Call Setup_MCLR(iSym)
          PState_SYM=iEor(State_Sym-1,iSym-1)+1
          nconfM=Max(ncsf(PState_Sym),nint(xispsm(Pstate_Sym,1)))
          nconf1=ncsf(PState_Sym)
          CI=.false.
          If (iMethod.eq.2.and.nconf1.gt.0) CI=.true.
          If (CI.and.nconf1.eq.1.and.isym.eq.1) CI=.false.
*
*         Allocate areas for scratch and state variables
*
          Call GetMem('kappa1','Allo','Real',ipKap1,nDensC)
          Call GetMem('kappa2','Allo','Real',ipKap2,nDensC)
          Call GetMem('skappa','Allo','Real',ipsKap,nDensC)
          Call Getmem('rkappa1','ALLO','Real',iprkap1,nDensC)
          Call Getmem('rkappa2','ALLO','Real',iprkap2,nDensC)
*
*
          If (CI) Then
             ipcip1=ipget(nconfM)
             ipcip2=ipget(nconfM)
             ipsp=ipget(nconfM)
             iprp2=ipget(nconfM)
             iprp1=ipget(nconfM)
          End If
*
*                                    [2]
*         Calculate the diagonal of E    and store in core/disc
*
*
*
        Do 110 jDisp=1,lDisp(iSym)
          iDisp=iDisp+1
          jspin=0
          If (iAnd(nTPert(idisp),1).eq.1) jSpin=1
          If (jspin.eq.0) Then
             nconf1=ncsf(Pstate_sym)
          Else
             nconf1=nint(xispsm(Pstate_Sym,1))
          End If
*
*---------------------------------------------------------------*
*                                                               *
*    Read response from disk                                    *
*                                                               *
*---------------------------------------------------------------*
*
          iDisk=iKapDisp(iDisp)
*
*-------- If disk address =/= -1 arrays on file.
*
          If (iDisk.ne.-1) Then
              Len=nDensC
              Call dDaFile(LuTemp,2,Work(ipKap1),Len,iDisk)
              iDisk=iSigDisp(iDisp)
              Call dDaFile(LuTemp,2,Work(ipSKap),Len,iDisk)
              iDisk=iRHSDisp(iDisp)
              Call dDaFile(LuTemp,2,Work(iprKap1),Len,iDisk)
              Do i=0,ndensC-1
                 Work(ipSKap+i)=-Work(ipSKap+i)-Work(iprKap1+i)
              End Do
C
*             Call Recprt('ORB-RHS',' ',Work(iprKap1),nDensC,1)
*             Write(*,*)'ddot orb-resp',
*     &            ddot_(ndensC,Work(ipKap1),1,Work(ipKap1),1)
*             Write(*,*)'ddot orb-sigma',
*     &            ddot_(ndensC,Work(ipSKap),1,Work(ipSKap),1)
*             Write(*,*)'ddot orb-rhs',
*     &            ddot_(ndensC,Work(iprKap1),1,Work(iprKap1),1)
C
*
             Call GADSum(Work(ipKap1),Len)
             Call GADSum(Work(ipSKap),Len)
             Call GADSum(Work(iprKap1),Len)

             If (CI) Then
                ilen=nconf1
                idis=iCIDisp(iDisp)
                Call dDaFile(LuTemp,2,Work(ipin(ipCIp1)),iLen,iDis)
                idis=iCISigDisp(idisp)
                Call dDaFile(LuTemp,2,Work(ipin(ipSp)),iLen,iDis)
                idis=iRHSCIDisp(idisp)
                Call dDaFile(LuTemp,2,Work(ipin(iprp1)),iLen,iDis)
                ii=ipin(ipSp)
                jj=ipin(iprp1)
                Do i=0,nConf1-1
                   Work(ii+i)= -Work(ii+i)-Work(jj+i)
                End Do
C
*               Write(*,*)'ddot ci-resp',
*     &               ddot_(nConf1,Work(ipin(ipcip1)),1,
*     &                      Work(ipin(ipcip1)),1)
*               Write(*,*)'ddot ci-sigma',
*     &               ddot_(nConf1,Work(ipin(ipSp)),1,
*     &                      Work(ipin(ipSp)),1)
*               Write(*,*)'ddot ci-rhs',
*     &               ddot_(nConf1,Work(ipin(iprp1)),1,
*     &                      Work(ipin(iprp1)),1)
C
                Call GADSum(Work(ipin(ipCIp1)),iLen)
                Call GADSum(Work(ipin(ipSp  )),iLen)
                Call GADSum(Work(ipin(ipRp1 )),iLen)
             End If
*
          Else
*
                            Len = nDensC
             Call FZero(Work(ipKap1),Len)
             Call GADSum(Work(ipKap1),Len)
             Call FZero(Work(ipSKap),Len)
             Call GADSum(Work(ipSKap),Len)
             Call FZero(Work(iprKap1),Len)
             Call GADSum(Work(iprKap1),Len)
*
             If (CI) Then
*
                ilen=nconf1
                Call FZero(Work(ipin(ipCIp1)),iLen)
                Call GADSum(Work(ipin(ipCIp1)),iLen)
                Call FZero(Work(ipin(ipSp  )),iLen)
                Call GADSum(Work(ipin(ipSp  )),iLen)
                Call FZero(Work(ipin(ipRp1 )),iLen)
                Call GADSum(Work(ipin(ipRp1 )),iLen)
*
             End If
*
          End If
*
************************************************************************
*
           Do 120 kDisp=1, jdisp
*
*                    (x) (2) (y)   (x) (y)    (y) (x)
*            E    = k   E   k   + F   k   +  F   k
*             Resp
*
               kspin=0
               If (iAnd(nTPert(kdisp+ksym),1).eq.1) kSpin=1
               If (kspin.eq.0) Then
                 nconf1=ncsf(PState_Sym)
               Else
                 nConf1=nint(xispsm(Pstate_Sym,1))
               End If
               If (.not.lCalc(kDisp+ksym)) Goto 120
*
C
*                  Write(*,*)'kDisp+kSym',kDisp+kSym
*                  Write(*,*)'iKapDisp(kdisp+ksym)',iKapDisp(kdisp+ksym)
C
               iDisk=iKapDisp(kDisp+kSym)
               If (iDisk.ne.-1) Then
                  Len=nDensC
                  Call dDaFile(LuTemp,2,Work(ipKap2),Len,iDisk)
                  iDisk=iRHSDisp(kDisp+kSym)
                  Call dDaFile(LuTemp,2,Work(iprKap2),Len,iDisk)

                  Call GASync()
                  Call GADSum(Work(ipKap2 ),Len)
                  Call GADSum(Work(iprKap2),Len)

                  If (CI) Then
                     ilen=nconf1
                     idis=iCIDisp(kDisp+ksym)
                     Call dDaFile(LuTemp,2,Work(ipin(ipCIp2)),iLen,iDis)
                     idis=iRHSCIDisp(kdisp+ksym)
                     Call dDaFile(LuTemp,2,Work(ipin(iprp2)),iLen,iDis)
                     rTempc1=DDot_(nConf1,Work(ipin(ipCIp2)),1,
     &                                   Work(ipin(ipsp)),1)

                          Call GASync()
                     Call GADSum(Work(ipin(ipCIp2)),iLen)
                     Call GADSum(Work(ipin(iprp2 )),iLen)

                  Else
                     rtempc1=0.0d0
                  End If
*
               Else
*
                  Call GASync()
                  Len=nDensC
                  Call FZero(Work(ipKap2 ),Len)
                  Call GADSum(Work(ipKap2 ),Len)
                  Call FZero(Work(iprKap2),Len)
                  Call GADSum(Work(iprKap2),Len)
                  If (CI) Then
                     ilen=nconf1
                          Call GASync()
                     Call FZero(Work(ipin(ipCIp2)),iLen)
                     Call GADSum(Work(ipin(ipCIp2)),iLen)
                     Call FZero(Work(ipin(iprp2 )),iLen)
                     Call GADSum(Work(ipin(iprp2 )),iLen)
                     rTempc1=DDot_(nConf1,Work(ipin(ipCIp2)),1,
     &                                   Work(ipin(ipsp)),1)
                  Else
                     rtempc1=0.0d0
                  End If
*
               End If
*
               rTempk1=DDot_(nDensC,Work(ipKap2),1,Work(ipSKap),1)
*
               Fact=1.0d0
               If (kdisp.eq.jdisp) Fact=2.0d0
               rTempk2=Fact*
     &                DDot_(nDensC,Work(ipKap1),1,Work(iprKap2),1)
               If (kdisp.ne.jdisp) Then
               rtempk3=1.0d0*DDot_(nDensC,Work(iprKap1),1,
     &                  Work(ipKap2),1)
               Else
                rTempk3=0.0d0
               End if
               If (CI) Then
                 Fact=1.0d0
                 If (kdisp.eq.jdisp) Fact=2.0d0
                  rTempc2=Fact*
     &                DDot_(nConf1,Work(ipin(ipCip1)),1,
     &                            Work(ipin(iprp2)),1)
                 If (kdisp.ne.jdisp) Then
                  rtempc3=1.0d0*
     &                DDot_(nConf1,Work(ipin(iprp1)),1,
     &                            Work(ipin(ipCIp2)),1)
                 Else
                  rTempc3=0.0d0
                 End if
                Else
                  rtempc2=0.0d0
                  rtempc3=0.0d0
               End if
C
*              Write(*,*) kdisp,jdisp
*              Write(*,*) rTempk1,rtempk2,rtempk3
*              Write(*,*) rtempc1,rtempc2,rtempc3
C
               Maxi=Max(kDisp,jDisp)
               Mini=Min(kDisp,jDisp)
               index=mSym+Maxi*(Maxi-1)/2+Mini
*
               Work(ipRhss-1+Index)=Work(ipRhss-1+Index)+
     &             rTempk1+rtempk2+rtempk3+
     &             rtempc1+rtempc2+rtempc3
*
 120       Continue

**********************************************************************
*
 110     Continue
       kSym=kSym+lDisp(iSym)
       mSym=mSym+lDisp(iSym)*(lDisp(iSym)+1)/2
*
*    Free areas for scratch and state variables
*
          Call Getmem('rkappa2','FREE','Real',iprkap2,nDensC)
          Call Getmem('rkappa1','FREE','Real',iprkap1,nDensC)
          Call GetMem('skappa','FREE','Real',ipsKap,nDensC)
          Call GetMem('kappa2','FREE','Real',ipKap2,nDensC)
          Call GetMem('kappa1','FREE','Real',ipKap1,nDensC)
          If (CI)  irc=ipclose(ipcip1)
 100  Continue
      Call GetMem('HESS','ALLO','REAL',ipHess,nHss)
      Call GetMem('HESS','ALLO','REAL',ipHess2,nHss)
      Call GetMem('Temp','ALLO','REAL',ipTemp,nHss)
      Call FZero(Work(ipTemp),nHss)
      Call GetMem('Temp','ALLO','REAL',ipELEC,3*ndisp)
C     Call GetMem('Temp','ALLO','REAL',ipELEC2,3*ndisp)
      Call GetMem('Temp','ALLO','REAL',ipEG  ,3*ndisp)
      Call GetMem('Temp','ALLO','REAL',ipELOUT,3*ndisp)
      irc=ipclose(-1)
*
*-------------------------------------------------------------------*
*
*     OK now when we have out Hessian, what should  we do with it!
*
*-------------------------------------------------------------------*
*
*
*     If a basis set is dependent on perturbation add terms
*     constructed in mckinley.
*
      call dcopy_(6,[0.0d0],0,pola,1)
      idum=1
      iopt=128
      irc=3*ndisp
      Label='DOTELGR'
      Call drdMCk(irc,iopt,LaBeL,idum,Work(ipEG),idum)
      elec=.true.
      if (irc.ne.0) elec=.false.
                Call GADsum(Work(iphss), nhss)
      call dcopy_(nhss,Work(iphss),1,Work(iphess2),1)
#ifdef _DEBUGPRINT_
      If (debug) Then
         ip=ipHess2
         Do iSym=1,nSym
           Write(label2,'(A,I2)') 'CHessian symmetry',iSym
            If (lDisp(iSym).ne.0)
     &         Call TriPrt(label2,' ',Work(ip),lDisp(iSym))
            ip=ip+ldisp(isym)*(1+ldisp(isym))/2
         End Do
      End If
*
      If (debug) Then
       Call MMSORT2(Work(ipHESS2),Work(ipELEC),pola,ielec)
       Call Recprt('CONN',' ',Work(ipElec),3*nDisp,1)
      End If
*
C
c       Write(*,*)'I am here 1'
       Call Recprt('ipRhss','(5G20.10) ',Work(ipRHss),nhss,1)
       Call Recprt('iphss','(5G20.10) ',Work(ipHss),nhss,1)
#endif
C
      Call DaXpY_(mSym,1.0d0,Work(ipRHss),1,Work(ipHess2),1)
*
#ifdef _DEBUGPRINT_
      If (debug) Then
       Call MMSORT2(Work(ipRHSS),Work(ipELEC),pola,ielec)
       Call Recprt('RESP',' ',Work(ipElec),3*nDisp,1)
      End If
#endif
*
      Call MMSORT2(Work(ipHESS2),Work(ipELEC),pola,ielec)
*
#ifdef _DEBUGPRINT_
      If (debug) Then
       Call Recprt('R+C',' ',Work(ipElec),3*nDisp,1)
       ip=ipHess2
       Do iSym=1,nSym
        Write(label2,'(A,I2)') 'Hessian symmetry',iSym
        If (lDisp(iSym).ne.0)
     &   Call TriPrt(label2,' ',Work(ip),lDisp(iSym))
        ip=ip+ldisp(isym)*(1+ldisp(isym))/2
       End Do
      End If
#endif
*
      Call mmSort(Work(ipHess2),Work(ipHess),ldisp2)
*
#ifdef _DEBUGPRINT_
C
cvv       Write(*,*)'I am here'
c       Call Recprt('iphess2',' ',Work(ipHess2),nhss,1)
c       Call HssPrt_MCLR(iwork(ipdegdisp),Work(ipHess2),ldisp2)
#endif
      If (McKinley) Then
*
         iRC=-1
         iOpt=0
         Label='StatHess'
         Call dRdMck(iRC,iOpt,Label,idum,Work(ipTemp),idum)
         If (iRC.ne.0) Then
            Write (6,*) 'OutPut: Error reading MCKINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend()
         End If
*
#ifdef _DEBUGPRINT_
         If (debug) Then
            ip=ipTemp
            Do iSym=1,nSym
               Write(label2,'(a,i2)') 'SHessian symmetry',iSym
               If (lDisp2(iSym).ne.0)
     &            Call TriPrt(label2,' ',Work(ip),lDisp2(iSym))
               ip=ip+ldisp2(isym)*(1+ldisp2(isym))/2
            End Do
         End If
#endif
         Call DaXpY_(mSym,1.0d0,Work(ipTemp),1,Work(ipHess),1)
      End If
#ifdef _DEBUGPRINT_
      If (debug) Then
        ip=ipHess
        Do iSym=1,nSym
          Write(label2,'(a,i2)') 'Hessian symmetry',iSym
          If (lDisp2(iSym).ne.0)
     &    Call TriPrt(label2,' ',Work(ip),lDisp2(iSym))
          ip=ip+ldisp2(isym)*(1+ldisp2(isym))/2
        End Do
      End If
#endif
*
*
      If (McKinley) Then
         iRC=-1
         iOpt=0
         Label='Hess    '
         Call dWrMck(iRC,iOpt,Label,iDum,Work(ipHess),iDum)
         If (iRC.ne.0) Then
            Write (6,*) 'OutPut: Error writing to MCKINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend()
         End If
         Call Put_iScalar('No of Internal coordinates',ldisp2(1))
         Call Put_AnalHess(Work(ipHess),ldisp2(1)*(ldisp2(1)+1)/2)
      End If
*
      If (.true.) Then
       iRC=-1
       iOpt=0
       Call GetMem('NRDISP','ALLO','INTE',ipnrdisp,ndisp)
       Call RdMck(irc,iopt,'NRCTDISP',idum,iWork(ipnrDisp),idum)
       iRC=-1
       iOpt=0
       Call GetMem('DEGDISP','ALLO','INTE',ipdegdisp,ndisp)
       Label='DEGDISP'
       Call RdMck(irc,iopt,Label,idum,iWork(ipDegDisp),idum)
       If (iRC.ne.0) Then
          Write (6,*) 'OutPut: Error reading RELAX'
          Write (6,'(A,A)') 'Label=',Label
          Call Abend()
       End If
C
*       If (debug)
*        Call HssPrt_MCLR(iwork(ipdegdisp),Work(ipHess),ldisp2)
*       Call Recprt('iphess',' ',Work(ipHess),nhss,1)
C
       call daxpy_(3*ndisp,-1.0d0,Work(ipEG),1,Work(ipELEC),1)
#ifdef _DEBUGPRINT_
       If (debug.and.elec)
     &  Call Recprt('ELEC-ST',' ',Work(ipEG),3*nDisp,1)
       If (debug.and.elec)
     &  Call Recprt('ELEC-TOT',' ',Work(ipElec),3*nDisp,1)
#endif
*
       Lu_10=10
       Lu_10=IsFreeUnit(Lu_10)
       call molcas_open(lu_10,'UNSYM')
c       Open(unit=Lu_10, file='UNSYM')
*
       If (Mckinley) Then
           Call FreqAnal(iwork(ipdegdisp),iWork(ipnrdisp),work(ipHess),
     &               converged,Work(ipELEC),ielec,Work(ipelout),
     &               ldisp2,Lu_10)
           Call Niclas(work(ipHess),coor,Lu_10)
       End If
       Write(6,*)
       Write(6,*)
       Write(6,*)'************************************'
       Write(6,*)'*                                  *'
       Write(6,*)'*       Polarizabilities           *'
       Write(6,*)'*                                  *'
       Write(6,*)'************************************'
       Write(6,*)
       Write(6,*)
       Call Add_Info('POLARIZABILITIES',Pola,6,2)
*
*      Go from energy derivative to polarizability, there is a difference
*      in the sign in the definition.
*
       Call DScal_(6,-1.0D0,Pola,1)
*
       Call TriPrt(' ',' ',Pola,3)
       close(Lu_10)
       Call GetMem('NRDISP','FREE','INTE',ipnrdisp,ndisp)
       Call GetMem('DEGDISP','FREE','INTE',ipdegdisp,ndisp)
      End If
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*

      Call GetMem('Temp','FREE','REAL',ipTemp,nHss)
      Call GetMem('HESS','FREE','REAL',ipHess,nHss)
      Call GetMem('HESS','FREE','REAL',ipHess2,nHss)
      Call GetMem('RESPH','FREE','REAL',ipRHss,nHss)
      Call GetMem('Temp','FREE','REAL',ipELEC,3*ndisp)
      Call GetMem('Temp','Free','REAL',ipEG  ,3*ndisp)
      Call GetMem('Temp','FREE','REAL',ipELOUT,3*ndisp)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
!** Subroutine to calculates quasibound level tunneling lifetime/width
!** For relevant theory see Le Roy & Liu [J.Chem.Phys.69,3622-31(1978)]
!  and Connor & Smith [Mol.Phys. 43, 397 (1981)] and Huang & Le Roy
!  [J.Chem.Phys. 119, 7398 (2003); Erratum, ibid, 127, xxxx (2007)]
!** Final level width calculation from Eq.(4.5) of Connor & Smith.
!------------------ Corrected: 12 March 2007 --------------------------
subroutine WIDTHas(KV,JROT,E,EO,DSOC,V,S,SDRDY,VMX,RMIN,H,BFCT,IWR,ITP1,ITP2,ITP3,INNER,NPP,GAMA)
!++ "WIDTH" calls subroutine "LEVQAD" ++++++++++++++++++++++++++++++++++
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

use Constants, only: Zero, One, Two, Four, Ten, Half, Pi, cLight
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: KV, JROT, IWR, ITP2, ITP3, INNER, NPP
real(kind=wp), intent(in) :: E, EO, DSOC, V(NPP), S(NPP), SDRDY(NPP), RMIN, H, BFCT
real(kind=wp), intent(inout) :: VMX
integer(kind=iwp), intent(out) :: ITP1
real(kind=wp), intent(out) :: GAMA
integer(kind=iwp) :: I, IMM, IRM, ITP1P, ITP1P1, ITP2M, ITP2M2, ITP2P1, ITP2P2, KVI, KVO, M, M2, NN, NST
real(kind=wp) :: ANS1, ANS2, ARG, COR, D1, D2, D3, DFI, DSGB, DSGN, DWEB, EMSC, EMV, G1, G2, G3, GAMALG, H2, HBW, HBWB, OMEGJC, &
                 PMX, RMINN, RMX, RT, SM, TAU, TAULG, TI, TUN0, U1, U2, VMAX, XJ, XX
logical(kind=iwp) :: Found
! PSI0 = polygamma(1/2) = -gamma-ln(4) [gamma = Euler-Mascheroni constant]
real(kind=wp), parameter :: FACT = 0.5e-2_wp/(Pi*cLight), PSI0 = -1.96351002602142347944_wp
character(len=*), parameter :: LWELL(2) = ['INNER','OUTER']

IMM = 0
PMX = 0
RMINN = RMIN-H
H2 = H*H
! First - locate innermost turning point ...
Found = .false.
do I=1,ITP2
  ITP1 = I
  if (V(I) < E) then
    Found = .true.
    exit
  end if
end do
if (.not. Found) then
  GAMA = Zero
  return
end if
! ITP1 is first mesh point to right of innermost turning point.
loop_1: do
  ITP1P = ITP1+1
  ITP1P1 = ITP1P+1
  IRM = ITP1-1
  ! Calculate JWKB tunneling probability from quadrature over barrier
  ! (ITP2 is first point inside barrier - as determined in QBOUND)
  ITP2P1 = ITP2+1
  ITP2P2 = ITP2+2
  ! ITP2M is the last mesh point before the 2-nd turning point.
  ITP2M = ITP2-1
  ITP2M2 = ITP2-2
  G1 = V(ITP2M)-E
  G2 = V(ITP2)-E
  G3 = V(ITP2P1)-E
  ! Quadrature over barrier starts here.
  call LEVQAD(G1,G2,G3,H,RT,ANS1,ANS2)
  SM = ANS2*SDRDY(ITP2)**2/H
  !SM = ANS2/H
  if (G3 >= Zero) then
    SM = SM+Half*sqrt(G3)*SDRDY(ITP2)**2
    PMX = VMX
    M2 = ITP2P2
    loop_2: do
      Found = .false.
      do I=M2,ITP3
        M = I
        G3 = V(I)-E
        if (V(I) > PMX) PMX = V(I)
        if (G3 < Zero) then
          Found = .true.
          exit
        end if
        SM = SM+sqrt(G3)*SDRDY(I)**2
      end do
      if (.not. Found) then
        if (V(M) > V(M-1)) then
          if (IWR /= 0) write(u6,602) KV,JROT
          return
        end if
        RMX = RMINN+M*H
        U1 = sqrt(G3/(V(M)-DSOC))
        U2 = sqrt((E-DSOC)/(V(M)-DSOC))
        SM = SM-Half*sqrt(G3)+(log((One+U1)/U2)-U1)*RMX*sqrt(V(M)-DSOC)/H
        XJ = (sqrt(One+Four*(V(M)-DSOC)*(RMX/H)**2)-One)*Half
        if (IWR /= 0) write(u6,603) JROT,EO,XJ,RMX
        exit loop_1
      else if (M < ITP3) then
        ! If encounter a double-humped barrier, take care here.
        if (IWR /= 0) write(u6,609) KV,JROT,EO,M
        KVO = 0
        DSGN = sign(One,S(M-1))
        ! Find the effective quantum number for the outer well
        do I=M,ITP3
          DSGB = DSGN
          DSGN = sign(One,S(I))
          if ((DSGN*DSGB) < Zero) KVO = KVO+1
        end do
        KVI = KV-KVO
        if (INNER == 0) then
          ! For levels of outer well, get correct width by changing ITP1
          ITP1 = M
          if (IWR > 0) write(u6,610) KVO,LWELL(2)
        else
          if (IWR > 0) write(u6,610) KVI,LWELL(1)
          ! For "inner-well" levels, locate outer barrier
          do I=M,ITP3
            M2 = I
            G3 = V(I)-E
            if (G3 >= Zero) cycle loop_2
          end do
          exit loop_1
        end if
      else
        G1 = V(M)-E
        G2 = V(M-1)-E
        G3 = V(M-2)-E
        call LEVQAD(G1,G2,G3,H,RT,ANS1,ANS2)
        SM = SM-Half*sqrt(G3)*SDRDY(M-2)**2-sqrt(G2)*SDRDY(M-1)+ANS2*SDRDY(M)**2/H+ANS2/H
        exit loop_1
      end if
    end do loop_2
  end if
end do loop_1
EMSC = -SM/Pi
if (INNER > 0) VMX = PMX
VMAX = VMX/BFCT
! Tunneling factors calculated here ** TUN0 is simple WKB result
! as in Child's eqs.(57c) & (59).
! .....  EPSRJ= -2.* Pi* EMSC
TUN0 = Half*exp(Two*Pi*EMSC)
! ... for permeability calculate Connor-Smith's Eq.(3.7) \omega=OMEGJC
OMEGJC = sqrt(One+Two*TUN0)-One
! ... alternate calculation to give better precision for small TUN0
if (TUN0 < 1.0e-5_wp) OMEGJC = TUN0*(ONe-Half*TUN0*(One-TUN0))
OMEGJC = Four*OMEGJC/(OMEGJC+Two)
! Quadrature for JWKB calculation of vibrational spacing in well HBW
D1 = E-V(IRM)
D2 = E-V(ITP1)
D3 = E-V(ITP1P)
call LEVQAD(D1,D2,D3,H,RT,ANS1,ANS2)
SM = ANS1*SDRDY(ITP1)**2/H
!SM = ANS1/H
if (D3 >= Zero) then
  SM = SM+Half/sqrt(D3)
  Found = .false.
  do I=ITP1P1,ITP2M2
    IMM = I
    EMV = E-V(I)
    if (EMV < Zero) then
      Found = .true.
      exit
    end if
    SM = SM+SDRDY(I)**2/sqrt(EMV)
  end do
  if (Found) then
    ! If encounter a double-minimum well, take care here.
    D1 = EMV
    D2 = E-V(IMM-1)
    D3 = E-V(IMM-2)
    if (IWR /= 0) write(u6,605) KV,JROT,EO
  else
    D1 = E-V(ITP2)
    D2 = E-V(ITP2M)
    D3 = E-V(ITP2M2)
  end if
  !call LEVQAD(D1,D2,D3,R1,R2,R3,H,RT,ANS1,ANS2)
  call LEVQAD(D1,D2,D3,H,RT,ANS1,ANS2)
  SM = SM-Half*SDRDY(IMM-2)/sqrt(D3)+ANS1*SDRDY(IMM-1)**2/H
end if
!SM = SM-Half*SDRDY(IMM-2)/sqrt(D3)+ANS1/H
! Get HBW in same energy units (1/cm) associated with BFCT
HBW = Two*Pi/(BFCT*SM)
! HBW fix up suggested by Child uses his eqs.(48)&(62) for HBW
! Derivative of complex gamma function argument calculated as
! per eq.(6.1.27) in Abramowitz and Stegun.
NST = int(abs(EMSC)*1.0e2_wp)
NST = max(NST,4)
ARG = PSI0
do I=0,NST
  NN = I
  XX = I+Half
  TI = One/(XX*((XX/EMSC)**2+One))
  ARG = ARG+TI
  if (abs(TI) < 1.0e-10_wp) exit
end do
! ... and use continuum approximation for tail of summation (???)
COR = Half*(EMSC/(NN+One))**2
ARG = ARG+COR-COR**2
! Now use WKL's Weber fx. approx for (?) derivative of barrier integral ..
DWEB = (EO-VMAX)*BFCT/(H2*EMSC)
DFI = (log(abs(EMSC))-ARG)*BFCT/(H2*DWEB)
HBWB = One/(One/HBW+DFI/(Two*Pi))
! Width from formula (4.5) of  Connor & Smith, Mol.Phys.43,397(1981)
! [neglect time delay integral past barrier in their Eq.(4.16)].
if (EMSC > -25.0_wp) then
  GAMA = (HBWB/(Two*Pi))*OMEGJC
  TAU = Zero
  if (GAMA > 1.0e-60_wp) TAU = FACT/GAMA
  ! GAM0 = TUN0*HBW/Pi  is the simple WKB width GAMMA(0) discussed by
  ! Le Roy & Liu in J.C.P.69,3622(1978).
  if (IWR > 0) write(u6,601) TAU,GAMA,HBWB,VMAX
else
  GAMALG = log10(HBWB/(Two*Pi))+Two*Pi*EMSC/log(Ten)
  TAULG = log10(FACT)-GAMALG
  if (IWR > 0) write(u6,611) TAULG,GAMALG,HBWB,VMAX
end if

return

601 format('    Lifetime=',ES10.3,'(s)   Width=',ES10.3,'   dG/dv=',F7.2,'   V(max)=',F9.2)
602 format(' *** WARNING ***  For   v =',I3,'   J =',I3,'   cannot calculate width since barrier maximum beyond range')
603 format(' *** For  J=',I3,'  E=',F9.2,'  R(3-rd) beyond range so approx. tunneling calc. uses'/8X, &
           'pure centrifugal potential with  J(app)=',F7.2,'  for  R > R(max)=',F7.2)
605 format(' **** CAUTION *** Width estimate only qualitative, as have a double-minimum well for   E(v=',I3,', J=',I3,')=',F15.7/ &
           15X,'a more stable result may be obtained by searching for the quasibound levels using option: INNER > 0 .')
609 format(' *** CAUTION - Permeability estimate not exact as have a double-humped barrier:  E(v=',I3,', J=',I3,') =',G15.8,I6)
610 format(16X,'(NOTE: this has the node count of a   v=',I3,2X,A5,'-well level')
611 format(12X,'Log10(lifetime/sec)=',F10.5,' ;   Log10(width/cm-1)=',F10.5,'   Spacing=',G12.5,'   V(max)=',G14.7,'(cm-1)')

end subroutine WIDTHas

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine moments(N,MS,MM,iprint)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero, gElectron
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, iprint
complex(kind=wp), intent(in) :: MS(3,N,N), MM(3,N,N)
integer(kind=iwp) :: I, i1, i2, iDir, J, L
complex(kind=wp) :: Mf(3,3), Sf(3,3), Lf(3,3)
complex(kind=wp), allocatable :: AML(:,:,:), AMM(:,:,:), AMS(:,:,:), Z(:,:)
real(kind=wp), parameter :: g_e = -gElectron
!-----------------------------------------------------------------------

if (N < 1) return
call mma_allocate(Z,N,N,'Z')
call mma_allocate(AMS,3,N,N,'AMS')
call mma_allocate(AML,3,N,N,'AML')
call mma_allocate(AMM,3,N,N,'AMM')
!-----------------------------------------------------------------------
do iDir=1,3
  Z(:,:) = cZero
  AMM(:,:,:) = cZero
  AML(:,:,:) = cZero
  AMS(:,:,:) = cZero

  call pseudospin(MM,N,Z,iDir,1,1)

  do l=1,3
    do i=1,N
      do j=1,N
        do i1=1,N
          do i2=1,N
            AMM(l,i,j) = AMM(l,i,j)+MM(l,i1,i2)*conjg(Z(i1,i))*Z(i2,j)
            AMS(l,i,j) = AMS(l,i,j)+MS(l,i1,i2)*conjg(Z(i1,i))*Z(i2,j)
          end do
        end do
        AML(l,i,j) = -AMM(l,i,j)-g_e*AMS(l,i,j)
      end do
    end do
  end do
  Mf(iDir,:) = AMM(:,1,1)
  Sf(iDir,:) = AMS(:,1,1)
  Lf(iDir,:) = AML(:,1,1)

  if (iprint > 3) then
    write(u6,*)
    write(u6,'(2x,a)') 'MOMENTS:  AMM(l,:,:)'
    do l=1,3
      write(u6,*)
      write(u6,'(a,i3)') 'PROJECTION2 =',l
      do i=1,N
        write(u6,'(20(2F12.8,2x))') (AMM(l,i,j),j=1,N)
      end do
    end do
    write(u6,*)
    write(u6,'(2x,a)') 'MOMENTS:  AMS(l,:,:)'
    do l=1,3
      write(u6,*)
      write(u6,'(a,i3)') 'PROJECTION2 =',l
      do i=1,N
        write(u6,'(20(2F12.8,2x))') (AMS(l,i,j),j=1,N)
      end do
    end do
    write(u6,*)
    write(u6,'(2x,a)') 'MOMENTS:  AML(l,:,:)'
    do l=1,3
      write(u6,*)
      write(u6,'(a,i3)') 'PROJECTION2 =',l
      do i=1,N
        write(u6,'(20(2F12.8,2x))') (AML(l,i,j),j=1,N)
      end do
    end do
  end if
end do !iDir

write(u6,'(A)') '--------------|--- H || Xm --|--- H || Ym --|--- H || Zm --|'
write(u6,'(8A)') repeat('-',14),'|',(repeat('-',14),'|',j=1,3)
write(u6,'(A,3(F13.9,1x,A))') ' <1| mu_X |1> |',(real(Mf(iDir,1)),'|',iDir=1,3)
write(u6,'(A,3(F13.9,1x,A))') ' <1| mu_Y |1> |',(real(Mf(iDir,2)),'|',iDir=1,3)
write(u6,'(A,3(F13.9,1x,A))') ' <1| mu_Z |1> |',(real(Mf(iDir,3)),'|',iDir=1,3)
write(u6,'(8a)') repeat('-',14),'|',(repeat('-',14),'|',j=1,3)
write(u6,'(A,3(F13.9,1x,A))') '  <1| L_X |1> |',(real(Lf(iDir,1)),'|',iDir=1,3)
write(u6,'(A,3(F13.9,1x,A))') '  <1| L_Y |1> |',(real(Lf(iDir,2)),'|',iDir=1,3)
write(u6,'(A,3(F13.9,1x,A))') '  <1| L_Z |1> |',(real(Lf(iDir,3)),'|',iDir=1,3)
write(u6,'(8a)') repeat('-',14),'|',(repeat('-',14),'|',j=1,3)
write(u6,'(A,3(F13.9,1x,A))') '  <1| S_X |1> |',(real(Sf(iDir,1)),'|',iDir=1,3)
write(u6,'(A,3(F13.9,1x,A))') '  <1| S_Y |1> |',(real(Sf(iDir,2)),'|',iDir=1,3)
write(u6,'(A,3(F13.9,1x,A))') '  <1| S_Z |1> |',(real(Sf(iDir,3)),'|',iDir=1,3)
write(u6,'(2a)') repeat('-',59),'|'

!-----------------------------------------------------------------------
call mma_deallocate(Z)
call mma_deallocate(AMS)
call mma_deallocate(AML)
call mma_deallocate(AMM)

return

end subroutine moments

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine svbd2_cvb(orbs,cvb,fx,ioptc,iter,
     >  civec,civbs,gjorb,gjorb2,gjorb3,cvbdet,
     >  c,sxc,res,rhs,rhsp,solp,solp_res)
      implicit real*8 (a-h,o-z)
      external asonc1_cvb,ddsolsvb_cvb,ddressvb_cvb,
     >  ddres2upd10_cvb
      external ddrestart_cvb
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "davtune_cvb.fh"
#include "opt2_cvb.fh"
      dimension orbs(norb,norb),cvb(nvb)
      dimension civec(ndet),civbs(ndet)
      dimension gjorb(*),gjorb2(*),gjorb3(*)
      dimension cvbdet(ndetvb)
      dimension c(nvb,maxdav),sxc(nvb,maxdav),res(nvb),rhs(nvb)
      dimension rhsp(maxdav),solp(maxdav),solp_res(maxdav)
      dimension dum(max(nvb,maxdav),maxdav)

      call makegjorbs_cvb(orbs,gjorb,gjorb2,gjorb3)

      if(memplenty)then
        call cicopy_cvb(civec,civbs)
      else
        call cird_cvb(civbs,61001.2d0)
      endif
      call applyt_cvb(civbs,gjorb2)
      call ci2vbg_cvb(civbs,cvbdet)
      call vb2strg_cvb(cvbdet,rhs)

      ioptc=1
      nvguess=1
      nvrestart=0
      call fmove_cvb(cvb,c,nvb)
      if(.not.follow)then
        ifollow=1
      else
        ifollow=4
      endif

      call ddinitsvb_cvb(ifollow,isaddle,ip(3))
      call ddres2updinit_cvb(0)
      call dirdiag_cvb(
     >  asonc1_cvb,ddsolsvb_cvb,ddressvb_cvb,ddres2upd10_cvb,
     >  ddrestart_cvb,
     >  c,dum,sxc,.false.,cvb,res,rhs,
     >  dum,rhsp,solp,solp_res,
     >  .false.,.false.,.true.,maxdav,nvb,nvb,
     >  nvguess,nvrestart,isaddle,ifollow,mxiter,
     >  resthr,orththr,nortiter,zero,
     >  ioptc,iter,fx,ip(3))
      have_solved_it=.true.

      ovraa=one
      svb=fx
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkT_QK42 (T2,T1a,T1b,dima,dimb,no,f1,f2)
c
c       this routine do:
c       T2(a',b',i,j) <- f1 . T2(a',b',i,j) + f2 . T1a(a,i) . T1b(b,j)
c
c       N.B. Kvajt odflaknute
c
        implicit none
        integer dima,dimb,no
        real*8 f1,f2
        real*8 T2(1:dima,1:dimb,1:no,1:no)
        real*8 T1a(1:dima,1:no)
        real*8 T1b(1:dimb,1:no)
c
c       help variables
        integer a,b,i,j
        real*8 c
c

        do j=1,no
          do b=1,dimb
          c=f2*T1b(j,b)
            do i=1,no
              do a=1,dima
                T2(a,b,i,j)=f1*T2(a,b,i,j)+T1a(a,i)*c
              end do
            end do
          end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
* PAM2009 Who wrote this? What purpose?
      Subroutine Check_InVec_m(InVec)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: nProcs, Is_Real_Par
      If (.Not.Is_Real_Par()) Return
      InVec_Tot = InVec
      Call GAIGOP_SCAL(InVec_Tot,'+')
      If (InVec_Tot.ne.0) Then
         If (InVec.eq.0) Then
            mProcs=-1
         Else
            mProcs = InVec_Tot/InVec
         End If
         If (mProcs.ne.nProcs) Then
            Write (6,*) 'Check_InVec: different orbital options on '
     &                //'different nodes'
            Write (6,*) 'Sets InVec to 0'
            InVec=0
         End If
      End If
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(InVec)
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Mickael G. Delcey                                *
*               2017, Ignacio Fdez. Galvan                             *
************************************************************************
      subroutine processRP(KeepGroup,SymThr)
      use External_Centers
      Use Iso_C_Binding
#ifndef _HAVE_EXTRA_
      Use XYZ
#endif
      Implicit Real*8 (a-h,o-z)
      Character KeepGroup*180,KWord*180,KG*180
#ifdef _HAVE_EXTRA_
      Character*180 minGroup,Key
      Character*180, External :: Get_Ln
#else
      Real*8, Dimension(:,:,:), Allocatable :: DumRot
      Real*8, Dimension(:,:), Allocatable :: DumTrans
      Real*8, pointer:: p1Dim(:)
#endif
************************************************************************
*                                                                      *
*    A silly routine to try to handle symmetry in RP-Coord section     *
*    verify that R, P and the standard structures have one common      *
*    symmetry. The user should preferably use a defined symmetry if    *
*    the TS symmetry is lower than R and P                             *
*                                                                      *
*    M.G. Delcey     June 2010                                         *
*    Lund University                                                   *
*                                                                      *
*    Adaptation to OpenMolcas                                          *
*    I. Fdez. Galvan   July 2017                                       *
*                                                                      *
************************************************************************
*
**   If C1, all is already done
*
      KG=KeepGroup
      Call UpCase(KG)
      if (KG(1:1).eq.'E'.or.KG(1:2).eq.'C1') then
           KG='NOSYM'
      endif
      If (KG(1:5).eq.'NOSYM') Go To 30
*
#ifdef _HAVE_EXTRA_
      LuRP=IsFreeUnit(10)
      Call molcas_open(LuRP,'findsym.out')
      KWord = Get_Ln(LuRP)
      minGroup = Get_Ln(LuRP)
      close(LuRP)
      If (index(KWord,'C1').ne.0) Go To 30
*
**    Else findsym will find the group
*
      Call findsymf('findsym.RP1',KG,SymThr,ierr)
      If (ierr.ne.0) Go To 20
      Call molcas_open(LuRP,'findsym.out')
      Key = Get_Ln(LuRP)
      If (index(Key,'C1').ne.0) Then
        Close(LuRP)
        Go To 30
      End If
      Key = Get_Ln(LuRP)
      KWord = Get_Ln(LuRP)
      Call Get_I(1,nRP,1)
*  Only read the second structure in findsym.out
      Do i=1,nRP+3
        Read(LuRP,*)
      End Do
      Do i=1,nRP
         Read(LuRP,*) KWord,j,(RP_Centers(j,i,2),j=1,3)
      EndDo
      nRP=nRP*3
      close(LuRP)
*
**    Compare with the one of the current structure
**    no need if user defined
*
      Write(6,*) Key,minGroup
      If (KG(1:4).eq.'FULL') Then
        If (Key.ne.minGroup) Go To 21
      EndIf
*
**
*
      Call findsymf('findsym.RP2',KG,SymThr,ierr)
      If (ierr.ne.0) Go To 20
      Call molcas_open(LuRP,'findsym.out')
      Read(LuRP,*)
      KWord = Get_Ln(LuRP)
*
      If (KG(1:4).eq.'FULL') Then
        If (KWord.ne.minGroup) Then
          Close(LuRP)
          Go To 21
        End If
      EndIf
*
      KWord = Get_Ln(LuRP)
      Call Get_I(1,i,1)
      If (3*i.ne.nRP) Go To 20
      Do i=1,nRP/3+3
        Read(LuRP,*)
      End Do
      Do i=1,nRP/3
         Read(LuRP,*) KWord,j,(RP_Centers(j,i,2),j=1,3)
      EndDo
#else
      ! If manual symmetry, trust it
      ! Only check if automatic symmetry requested
      If (KG(1:4) .ne. 'FULL') Go To 30
      ! The detected symmetry for the two structures must match
      LuRP = 10
      LuRP = IsFreeUnit(LuRP)
      Call Molcas_Open(LuRP,'findsym.RP1')
      Call Read_XYZ(LuRP,DumRot,DumTrans)
      Close(LuRP)
      Call Parse_Group(KeepGroup,SymThr)
      Call C_F_Pointer(C_Loc(RP_Centers(1,1,1)),p1Dim,[nRP])
      nRP = Out_Raw(p1Dim)
      Nullify(p1Dim)
      Call Clear_XYZ()
      !
      KG = Trim(Symmetry)
      LuRP = IsFreeUnit(LuRP)
      Call Molcas_Open(LuRP,'findsym.RP2')
      Call Read_XYZ(LuRP,DumRot,DumTrans)
      Close(LuRP)
      Call Parse_Group(KeepGroup,SymThr)
      Call C_F_Pointer(C_Loc(RP_Centers(1,1,2)),p1Dim,[nRP])
      i   = Out_Raw(p1Dim)
      Nullify(p1Dim)
      If (i .ne. nRP) Go To 20
      Call Clear_XYZ()
      If (Symmetry .ne. KG) Go To 21
#endif
 30   Continue
      return
************************************************************************
 20   Continue
      Call WarningMessage(2,
     &       'Error in RP-Coord section, check symmetry')
      Call Quit_OnUserError()
 21   Continue
      KWord='Error in RP-Coord section, structures do not have the '//
     &      'same symmetry. Please define manually the symmetry group.'
      Call WarningMessage(2,KWord)
      Call Quit_OnUserError()
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 07, 2022, created this file.               *
!*****************************************************************

subroutine CMSHeader(CMSSFile)

use CMS, only: CMSGuessFile, iCMSOpt
use rasscf_global, only: CMSThreshold, iCMSIterMax, iCMSIterMin, lRoots
use Definitions, only: wp, u6

implicit none
character(len=*), intent(in) :: CMSSFile

write(u6,*)
write(u6,*)
write(u6,'(4X,A35)') 'CMS INTERMEDIATE-STATE OPTIMIZATION'
if (CMSSFile == 'XMS') then
  write(u6,'(5X,A12,8X,A25)') 'START MATRIX','XMS INTERMEDIATE STATES'
else
  write(u6,'(5X,A12,8X,A25)') 'START MATRIX',CMSGuessFile
end if
if (iCMSOpt == 1) then
  write(u6,'(5X,A8,12X,A25)') 'OPT ALGO','NEWTON'
else if (iCMSOpt == 2) then
  write(u6,'(5X,A8,12X,A25)') 'OPT ALGO','JACOBI'
end if
write(u6,'(5X,A15,5X,16X,ES9.2E2)') 'Q_a-a THRESHOLD',CMSThreshold
if (iCMSOpt == 1) write(u6,'(5X,A15,5X,16X,ES9.2E2)') 'GRAD  THRESHOLD',CMSThreshold*1.0e-2_wp
write(u6,'(5X,A10,10X,I25)') 'MAX CYCLES',ICMSIterMax
write(u6,'(5X,A10,10X,I25)') 'MIN CYCLES',ICMSIterMin
write(u6,*) repeat('=',71)
if (iCMSOpt == 2) then
  if (lRoots > 2) then
    write(u6,'(4X,A8,2X,2(A16,11X))') 'Cycle','Q_a-a','Difference'
  else
    write(u6,'(4X,A8,2X,A18,6X,A8,12X,A12)') 'Cycle','Rot. Angle (deg.)','Q_a-a','Q_a-a Diff.'
  end if
else
  write(u6,'(6X,A5,7X,A5,8X,A10,2X,A6,5X,A7,4X,A4)') 'Cycle','Q_a-a','Difference','# Pos.','Largest','Step'
  write(u6,'(43X,A7,4X,A8,3X,A6)') 'Hessian','Gradient','Scaled'
end if
write(u6,*) repeat('-',71)

return

end subroutine CMSHeader

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine writegs2_cvb(orbs,cvb,
     >  cvbdet,iapr,ixapr,iabind)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension orbs(norb,norb),cvb(nvb)
      dimension cvbdet(ndetvb),iapr(ndetvb),ixapr(nda+1),iabind(ndetvb)

      call str2vbc_cvb(cvb,cvbdet)
      ioffs=0
      call wris_cvb([ndetvb],1,recn_tmp04,ioffs)
      call wris_cvb([norb],1,recn_tmp04,ioffs)
      call wris_cvb([nalf],1,recn_tmp04,ioffs)
      call wris_cvb([nbet],1,recn_tmp04,ioffs)
      call wrrs_cvb(orbs,norb*norb,recn_tmp04,ioffs)
      idetvb=0
      do 100 ia=1,nda
      do 101 ixa=ixapr(ia),ixapr(ia+1)-1
      idetvb=idetvb+1
      ib=iapr(ixa)
      iabind(idetvb)=ia+(ib-1)*nda
101   continue
100   continue
      call wris_cvb(iabind,ndetvb,recn_tmp04,ioffs)
      call wrrs_cvb(cvbdet,ndetvb,recn_tmp04,ioffs)
      call make_cvb('WRITEGS')
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine optize_cvb(fx,ioptc,iter,
     >  imetinp,isadinp,mxiter,maxinp,corenrg,ipinp,ipdd1,ipdd2,
     >  strucopt)
c  *********************************************************************
c  *                                                                   *
c  *  Routine for second-order optimization.                           *
c  *                                                                   *
c  *  Uses the following functions:                                    *
c  *                                                                   *
c  *   GETFREE:   Determine # free parameters                          *
c  *    UPDATE:   Add dx to vector of free variables, x                *
c  *        FX:   Calculate f(x)                                       *
c  *      GRAD:   Calculate gradient of f                              *
c  *      HESS:   Calculate the action of the hessian on trial vector  *
c  *   GETHESS:   Calculate full hessian                               *
c  *                                                                   *
c  *  IOPTC is optimization control :                                  *
c  *                                                                   *
c  *  IOPTC=-3    Opt. terminated close to convergence (at request)    *
c  *  IOPTC=-2    Optimization failed -- too small step size           *
c  *  IOPTC=-1    Maximum number of iterations used                    *
c  *  IOPTC= 0    Converged                                            *
c  *  IOPTC= 1    Not complete                                         *
c  *                                                                   *
c  *********************************************************************
      implicit real*8 (a-h,o-z)
      logical maxinp,iter_is_1,strucopt
#include "malloc_cvb.fh"
#include "opt_cvb.fh"

#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

#include "opt2_cvb.fh"
      external dum_a_cvb,o123a_cvb,o123b_cvb,o5b_cvb,o7a_cvb,o7b_cvb
      external o8b_cvb,o10a_cvb,o10b_cvb
      external o12sa_cvb,o12sb_cvb,o12ea_cvb,o12eb_cvb
      save zero
      data zero/0.d0/

      if(mxiter.eq.0)then
        ioptc=-1
        return
      endif

c  Initialize for new optimization - input parameters:
      imethod=imetinp
      isaddle=isadinp
      maxize=maxinp
      ip=ipinp

c  Parameters initialized:
      exp=zero
      hh=hhstart
      hhkeep=hh
      ioptc=1

      if(maxize)then
        ifollow=1
      else
        ifollow=2
      endif

      call fx_cvb(fx,.false.)
      fxbest=fx
      do 1000 iter=1,mxiter
      iter_is_1=(iter.eq.1)
      call getfree_cvb(nparm,n_div,nfrdim,iter,fx)
      if(nfrdim.le.0)then
        if(ip.ge.0)write(6,'(a)')' No free parameters!'
        if(ip.ge.0)write(6,'(a)')' Calculation converged.'
        ioptc=0
        return
      endif
      if(fx.lt.zero.and.maxize)then
        call chgsgn_cvb(fx)
        call getfree_cvb(nparm,n_div,nfrdim,iter,fx)
      endif

      if(imethod.eq.1.or.imethod.eq.2.or.imethod.eq.3)then
        ix(1) = mstackr_cvb(nparm)
        ix(2) = mstackr_cvb(nparm)
        ix(3) = mstackr_cvb(nparm*nparm)
        ix(4) = mstackr_cvb(nparm)
        ix(5) = mstackr_cvb(nparm)
        ix(6) = mstackr_cvb(nparm)
        ix(7) = mstackr_cvb(nparm)
        call optize2_cvb(fx,nparm,ioptc,
     >    w(ix(1)),w(ix(2)),iter_is_1,
     >    o123a_cvb,o123b_cvb)
        call mfreer_cvb(ix(1))
      elseif(imethod.eq.5)then
        ix(1) = mstackr_cvb(nparm)
        ix(2) = mstackr_cvb(nparm)
        call optize2_cvb(fx,nparm,ioptc,
     >    w(ix(1)),w(ix(2)),iter_is_1,
     >    dum_a_cvb,o5b_cvb)
        call mfreer_cvb(ix(1))
      elseif(imethod.eq.7)then
        ix(1) = mstackr_cvb(nparm+1)
        ix(2) = mstackr_cvb(nparm+1)
        maxd=min(nparm+1,200)
        mxit=500
        call ddinit_cvb('AxEx',nparm+1,nfrdim+1,maxd,mxit,
     >    ifollow,isaddle,ipdd1,zero,n_div)
        call asonC7init_cvb(ix(2),ipdd2)
        call optize2_cvb(fx,nparm,ioptc,
     >    w(ix(1)),w(ix(2)),iter_is_1,
     >    o7a_cvb,o7b_cvb)
        call mfreer_cvb(ix(1))
      elseif(imethod.eq.8)then
        ix(1) = mstackr_cvb(nparm)
        ix(2) = mstackr_cvb(nparm)
        ix(3) = mstackr_cvb((nparm+1)*(nparm+1))
        ix(4) = mstackr_cvb(nparm+1)
        call optize2_cvb(fx,nparm,ioptc,
     >    w(ix(1)),w(ix(2)),iter_is_1,
     >    dum_a_cvb,o8b_cvb)
        call mfreer_cvb(ix(1))
      elseif(imethod.eq.9)then
        i1 = mstackr_cvb(nparm)
        i2 = mstackr_cvb(nparm)
        i3 = mstackr_cvb(nparm)
        call optize9_cvb(fx,nparm,ioptc,
     >    w(i1),w(i2),w(i3))
      call mfreer_cvb(i1)
      elseif(imethod.eq.10)then
        ix(1)  = mstackr_cvb(nparm)
        ix(2)  = mstackr_cvb(nparm)
        maxd=min(nparm,200)
        mxit=500
        call ddinit_cvb('AxExb',nparm,nfrdim,maxd,mxit,
     >    ifollow,isaddle,ipdd1,zero,n_div)
        call asonc10init_cvb(ipdd2)
        call optize2_cvb(fx,nparm,ioptc,
     >    w(ix(1)),w(ix(2)),iter_is_1,
     >    o10a_cvb,o10b_cvb)
        call mfreer_cvb(ix(1))
      elseif(imethod.eq.12.and.maxize)then
        if(strucopt)then
          nparm_dav=nparm
          nfrdim_dav=nfrdim
        else
          nparm_dav=nparm+1
          nfrdim_dav=nfrdim+1
        endif
        ix(1)  = mstackr_cvb(nparm_dav)
        ix(2)  = mstackr_cvb(nparm_dav)
        maxd=min(nparm_dav,200)
        mxit=500
        call ddinit_cvb('Axb',nparm_dav,nfrdim_dav,maxd,mxit,
     >    ifollow,isaddle,ipdd1,zero,0)
        call asonc12sinit_cvb(ipdd2)
        call optize2_cvb(fx,nparm_dav,ioptc,
     >    w(ix(1)),w(ix(2)),iter_is_1,
     >    o12sa_cvb,o12sb_cvb)
        call mfreer_cvb(ix(1))
      elseif(imethod.eq.12.and..not.maxize)then
        if(strucopt)then
          nparm_dav=nparm
          nfrdim_dav=nfrdim
        else
          nparm_dav=nparm+1
          nfrdim_dav=nfrdim+1
        endif
        ix(1) = mstackr_cvb(nparm_dav)
        ix(2) = mstackr_cvb(nparm_dav)
        maxd=min(nparm_dav,200)
        mxit=500
        call ddinit_cvb('AxESx',nparm_dav,nfrdim_dav,maxd,mxit,
     >    ifollow,isaddle,ipdd1,corenrg,n_div)
        call asonc12einit_cvb(ipdd2)
        call optize2_cvb(fx,nparm_dav,ioptc,
     >    w(ix(1)),w(ix(2)),iter_is_1,
     >    o12ea_cvb,o12eb_cvb)
        call mfreer_cvb(ix(1))
      else
        write(6,*)' Unrecognized optimization algorithm!',imethod
        call abend_cvb()
      endif
      if(ioptc.le.0)goto 1100
1000  continue
      iter=iter-1
1100  if(ioptc.ge.0)call getfree_cvb(nparm,n_div,nfrdim,-1,fx)
      if(iter.eq.mxiter.and.ioptc.gt.0)ioptc=-1
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_Dump(irc,Lunit)
!
! T.B. Pedersen, March 2005.
!
! Purpose: print some entries in the module Cholesky
!
! On input, Lunit is the logical unit to print to...

use Cholesky, only: BlockSize, ChkOnly, Cho_1Center, Cho_AdrVec, Cho_DecAlg, Cho_DecAlg_Def, Cho_DiaChk, Cho_Fake_Par, Cho_IntChk, &
                    Cho_IOVec, Cho_MinChk, Cho_No2Center, Cho_PreScreen, Cho_Reord, Cho_SimP, Cho_SScreen, Cho_TrcNeg, &
                    Cho_TstScreen, Cho_UseAbs, Damp, DiaMax, DiaMin, DiaMnZ, Did_DecDrv, DSPNm, DSubScr, Frac_ChVBuf, HaltIt, &
                    iABMnZ, iAlQua, iAtomShl, iBas, iBasSh, iChkQ, IFCSew, iiBstR, iiBstRSh, IndRed, IndRSh, InfRed, InfVec, &
                    IntMap, iOff_Col, iOffQ, iQuAB, iRS2F, iScr, iShlSO, iSOShl, iSP2F, lBuf, LuCho, LuMap, LuPri, LuRed, LuRst, &
                    LuScr, LuSel, LuTmp, MaxQual, MaxRed, MaxVec, MinQual, mmBstRT, Mode_Screen, ModRst, Mx2Sh, MxORSh, MxShPr, &
                    N1_Qual, N1_VecRd, N2_Qual, N2_VecRd, N_Subtr, nBas, nBasSh, nBasT, nBstSh, nChkQ, nCol_Chk, nColAB, nDecom, &
                    nDGM_call, nDimRS, nInteg, nnBstR, nnBstRSh, nnBstRT, nnShl, nnShl_Tot, nnZTot, nQual, nSection, nShell, nSym, &
                    nSys_call, NumCho, NumChT, nVecRS1, RstCho, RstDia, Run_Mode, ScDiag, ShA, ShAB, ShB, ShC, ShCD, ShD, Span, &
                    SSTau, SubScrStat, tDecDrv, tDecom, Thr_PreScreen, ThrCom, ThrDef, ThrDiag, ThrNeg, TimSec, tInteg, &
                    Tol_DiaChk, TooNeg, Trace_Idle, WarNeg, XCho_AdrVec, XDamp, XlDiag, XnBas, XnnShl, XnPass, XnShell, XnSym, &
                    XScDiag, XSpan, XThrCom, XThrDiag, XThrNeg, XTooNeg, XWarNeg
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: Lunit
integer(kind=iwp) :: i, j
character(len=*), parameter :: SecNam = 'Cho_Dump'

irc = 0

write(Lunit,*)
write(Lunit,*)
write(Lunit,*) '>>> Output from ',SecNam,':'
write(Lunit,*)
call XFlush(Lunit)

write(Lunit,*) '*** Contents of Choleksy:'
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'iBas : ',(iBas(i),i=1,8)
write(Lunit,*) 'nBas : ',(nBas(i),i=1,8)
write(Lunit,*) 'XnBas: ',(XnBas(i),i=1,8)
write(Lunit,*) 'nBasT: ',nBasT
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'ThrDef        : ',ThrDef
write(Lunit,*) 'ThrCom        : ',ThrCom
write(Lunit,*) 'ThrDiag       : ',ThrDiag
write(Lunit,*) 'Tol_DiaChk    : ',Tol_DiaChk
write(Lunit,*) 'ThrNeg        : ',ThrNeg
write(Lunit,*) 'WarNeg        : ',WarNeg
write(Lunit,*) 'TooNeg        : ',TooNeg
write(Lunit,*) 'nSym          : ',nSym
write(Lunit,*) 'lBuf          : ',lBuf
write(Lunit,*) 'MinQual       : ',MinQual
write(Lunit,*) 'MaxQual       : ',MaxQual
write(Lunit,*) 'IFCSew        : ',IFCSew
write(Lunit,*) 'Mode_Screen   : ',Mode_Screen
write(Lunit,*) 'Cho_DecAlg    : ',Cho_DecAlg
write(Lunit,*) 'Cho_DecAlg_Def: ',Cho_DecAlg_Def
write(Lunit,*) 'iAlQua        : ',iAlQua
write(Lunit,*) 'MxShPr        : ',MxShPr
write(Lunit,*) 'ModRst        : ',ModRst
write(Lunit,*) 'Run_Mode      : ',Run_Mode
write(Lunit,*) 'ScDiag        : ',ScDiag
write(Lunit,*) 'ChkOnly       : ',ChkOnly
write(Lunit,*) 'Cho_IntChk    : ',Cho_IntChk
write(Lunit,*) 'Cho_MinChk    : ',Cho_MinChk
write(Lunit,*) 'Cho_UseAbs    : ',Cho_UseAbs
write(Lunit,*) 'Cho_TrcNeg    : ',Cho_TrcNeg
write(Lunit,*) 'Cho_ReOrd     : ',Cho_ReOrd
write(Lunit,*) 'Cho_DiaChk    : ',Cho_DiaChk
write(Lunit,*) 'Cho_TstScreen : ',Cho_TstScreen
write(Lunit,*) 'Cho_1Center   : ',Cho_1Center
write(Lunit,*) 'Cho_No2Center : ',Cho_No2Center
write(Lunit,*) 'Cho_PreScreen : ',Cho_PreScreen
write(Lunit,*) 'Cho_SimP      : ',Cho_SimP
write(Lunit,*) 'Cho_Fake_Par  : ',Cho_Fake_Par
write(Lunit,*) 'RstDia        : ',RstDia
write(Lunit,*) 'RstCho        : ',RstCho
write(Lunit,*) 'Did_DecDrv    : ',Did_DecDrv
write(Lunit,*) 'HaltIt        : ',HaltIt
write(Lunit,*) 'Trace_Idle    : ',Trace_Idle
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'LuCho: ',(LuCho(i),i=1,8)
write(Lunit,*) 'LuSel: ',(LuSel(i),i=1,8)
write(Lunit,*) 'LuTmp: ',(LuTmp(i),i=1,8)
write(Lunit,*) 'LuPri: ',LuPri
write(Lunit,*) 'LuScr: ',LuScr
write(Lunit,*) 'LuRed: ',LuRed
write(Lunit,*) 'LuRst: ',LuRst
write(Lunit,*) 'LuMap: ',LuMap
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'nShell   : ',nShell
write(Lunit,*) 'nnShl_Tot: ',nnShl_Tot
write(Lunit,*) 'nnShl    : ',nnShl
write(Lunit,*) 'MxORSh   : ',MxORSh
write(Lunit,*) 'Mx2Sh    : ',Mx2Sh
do j=1,3
  write(Lunit,*) 'iiBstR : ',(iiBstR(i,j),i=1,8)
end do
do j=1,3
  write(Lunit,*) 'nnBstR : ',(nnBstR(i,j),i=1,8)
end do
write(Lunit,*) 'nnBstRT: ',(nnBstRT(i),i=1,3)
write(Lunit,*) 'mmBstRT: ',mmBstRT
write(Lunit,*) 'nQual  : ',(nQual(i),i=1,8)
write(Lunit,*) 'iOffQ  : ',(iOffQ(i),i=1,8)
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'DiaMax: ',(DiaMax(i),i=1,8)
write(Lunit,*) 'DiaMin: ',(DiaMin(i),i=1,8)
write(Lunit,*) 'Damp  : ',(Damp(i),i=1,2)
write(Lunit,*) 'Span  : ',Span
write(Lunit,*) 'XlDiag: ',XlDiag
write(Lunit,*) 'DiaMnZ: ',DiaMnZ
write(Lunit,*) 'Thr_PreScreen: ',Thr_PreScreen
write(Lunit,*) 'iABMnZ: ',iABMnZ
write(Lunit,*) 'nnZTot: ',nnZTot
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'NumCho   : ',(NumCho(i),i=1,8)
write(Lunit,*) 'NumChT   : ',NumChT
write(Lunit,*) 'MaxVec   : ',MaxVec
write(Lunit,*) 'MaxRed   : ',MaxRed
write(Lunit,*) 'BlockSize: ',BlockSize
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'ShA     : ',ShA
write(Lunit,*) 'ShB     : ',ShB
write(Lunit,*) 'ShAB    : ',ShAB
write(Lunit,*) 'ShC     : ',ShC
write(Lunit,*) 'ShD     : ',ShD
write(Lunit,*) 'ShCD    : ',ShCD
write(Lunit,*) 'nColAB  : ',nColAB
write(Lunit,*) 'iOff_Col: ',(iOff_Col(i),i=1,8)
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'XThrCom    : ',XThrCom
write(Lunit,*) 'XThrDiag   : ',XThrDiag
write(Lunit,*) 'XDamp      : ',(XDamp(i),i=1,2)
write(Lunit,*) 'XSpan      : ',XSpan
write(Lunit,*) 'XThrNeg    : ',XThrNeg
write(Lunit,*) 'XWarNeg    : ',XWarNeg
write(Lunit,*) 'XTooNeg    : ',XTooNeg
write(Lunit,*) 'XnSym      : ',XnSym
write(Lunit,*) 'XnShell    : ',XnShell
write(Lunit,*) 'XnnShl     : ',XnnShl
write(Lunit,*) 'XnPass     : ',XnPass
write(Lunit,*) 'XCho_AdrVec: ',XCho_AdrVec
write(Lunit,*) 'XScDiag    : ',XScDiag
write(Lunit,*)
call XFlush(Lunit)
do j=1,nChkQ+1
  write(Lunit,*) 'iChkQ   : ',(iChkQ(i,j),i=1,4)
end do
write(Lunit,*) 'nCol_Chk: ',nCol_Chk
do j=1,nSection
  write(Lunit,*) 'TimSec  : ',(TimSec(i,j),i=1,4)
end do
do j=1,nInteg
  write(Lunit,*) 'tInteg  : ',(tInteg(i,j),i=1,2)
end do
do j=1,nDecom
  write(Lunit,*) 'tDecom  : ',(tDecom(i,j),i=1,2)
end do
write(Lunit,*) 'tDecDrv : ',(tDecDrv(i),i=1,2)
write(Lunit,*)
write(Lunit,*) 'nVecRS1: ',(nVecRS1(i),i=1,8)
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'Cho_AdrVec: ',Cho_AdrVec
write(Lunit,*) 'Cho_IOVec : ',Cho_IOVec
write(Lunit,*) 'nSys_Call : ',nSys_Call
write(Lunit,*) 'nDGM_Call : ',nDGM_Call
write(Lunit,*) 'N1_VecRd  : ',N1_VecRd
write(Lunit,*) 'N2_VecRd  : ',N2_VecRd
write(Lunit,*) 'N_Subtr   : ',N_Subtr
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'N1_Qual: ',N1_Qual
write(Lunit,*) 'N2_Qual: ',N2_Qual
write(Lunit,*)
write(Lunit,*) 'Frac_ChVBuf: ',Frac_ChVBuf
call XFlush(Lunit)
write(Lunit,*)
write(Lunit,*) '    (dimension)'
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*) 'InfRed  : ',size(InfRed)
write(Lunit,*) 'InfVec  : ',size(InfVec)
write(Lunit,*) 'IndRed  : ',size(IndRed)
write(Lunit,*) 'IndRSh  : ',size(IndRsh)
write(Lunit,*) 'iScr    : ',size(iScr)
write(Lunit,*) 'iiBstRSh: ',size(iiBstRSh)
write(Lunit,*) 'nnBstRSh: ',size(nnBstRSh)
write(Lunit,*) 'IntMap  : ',size(IntMap)
write(Lunit,*) 'nDimRS  : ',size(nDimRS)
write(Lunit,*) 'iRS2F   : ',size(iRS2F)
write(Lunit,*) 'iSOShl  : ',size(iSOShl)
write(Lunit,*) 'iShlSO  : ',size(iShlSO)
write(Lunit,*) 'iQuab   : ',size(iQuab)
write(Lunit,*) 'iBasSh  : ',size(iBasSh)
write(Lunit,*) 'nBasSh  : ',size(nBasSh)
write(Lunit,*) 'nBstSh  : ',size(nBstSh)
write(Lunit,*) 'iAtomShl: ',size(iAtomShl)
write(Lunit,*) 'iSP2F   : ',size(iSP2F)
write(Lunit,*)
call XFlush(Lunit)
write(Lunit,*)
write(Lunit,*) 'Cho_SScreen: ',Cho_SScreen
write(Lunit,*) 'SSTau      : ',SSTau
write(Lunit,*) 'SubScrStat : ',(SubScrStat(i),i=1,2)
write(Lunit,*) 'DSubScr    : ',size(DSubScr)
write(Lunit,*) 'DSPNm      : ',size(DSPNm)

end subroutine Cho_Dump

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine WRMAT1(ND1,ND2,XMAT)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ND1, ND2
real(kind=wp), intent(in) :: XMAT(ND1,ND2)
integer(kind=iwp) :: I, IBL, J, JEND, JSTA, NBL
integer(kind=iwp), parameter :: NCOL = 5

! NCOL=NR OF PRINTING COLUMNS.
NBL = (ND2+NCOL-1)/NCOL
do IBL=1,NBL
  JSTA = 1+NCOL*(IBL-1)
  JEND = min(NCOL*IBL,ND2)
  write(u6,'(//,5(8X,I8),/)') (J,J=JSTA,JEND)
  do I=1,ND1
    write(u6,'(1X,I3,5(1X,G16.9))') I,(XMAT(I,J),J=JSTA,JEND)
  end do
end do

end subroutine WRMAT1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************

subroutine Add_Info(Label,Array,nArray,iTol)
!***********************************************************************
!                                                                      *
!     written by:                                                      *
!     V.Veryazov                                                       *
!                                                                      *
!    parameters:                                                       *
!       Label - text label                                             *
!       Array(nArray) - values to check                                *
!       iTol - tolerance:                                              *
!               if positive: 10**(-iTol)                               *
!               else: -iTol                                            *
!                                                                      *
!***********************************************************************

use Para_Info, only: MyRank
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, King
#endif
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: nArray
real(kind=wp), intent(in) :: Array(nArray)
integer(kind=iwp), intent(in) :: iTol
integer(kind=iwp) :: i, ia, iArray, icomma, iDum(1), iGeoData, iGeoInfo(2), ik, isfound, iuGeoData, j, k, l, length, LuDispEn, n0, &
                     nIntCoord, nlabel, Num
real(kind=wp) :: Aux(1)
logical(kind=iwp) :: Found
character(len=256) :: Collect, STMP, STRING, STRING2
character(len=120) :: Line
character(len=30) :: Junk
character(len=15) :: Energy_File
character(len=8) :: Tol
character(len=*), parameter :: GeoDataF = 'GEODATA'
integer(kind=iwp), external :: isFreeUnit
!integer(kind=iwp) :: irecl
!character(len=32) :: File_Name
!logical(kind=iwp) :: Exist, is_error
interface
  subroutine add_molcas_info(str,n) bind(C,name='add_molcas_info_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT
    character(kind=c_char) :: str(*)
    integer(kind=MOLCAS_C_INT) :: n
  end subroutine add_molcas_info
end interface

!------------------------------------------------
! If this is a fake parallel run (e.g. inside the parallel loop of CASPT2_gradient,
! then do not add info - just return immidiately
#ifdef _MOLCAS_MPP_
if ((.not. King()) .and. (.not. Is_Real_Par())) return
#endif
! Num - is a number of exported variables from an array.
Num = 20
!File_Name = 'molcas_info'

!Lu_Info = 99

!---------------------------------------------------------------------*
! Check the file status                                               *
!---------------------------------------------------------------------*
call open_molcas_info()
!call f_Inquire(File_name, Exist)
!----------------------------------------------------------------------*
! Open existing file and position the record pointer to the end        *
!----------------------------------------------------------------------*
!if (Exist) then
!  call molcas_open_Ext2(Lu_info,file_name,'sequential','formatted',ios,.false.,irecl,'unknown',is_error)
!  if (ios /= 0) then
!    write(u6,*) 'Add_Info: can not create info file'
!    write(u6,*) 'Check file permissions!'
!    call Abend()
!  end if
!  nLines = 0
!  do
!    read(Lu_Info,'(A)',iostat=ios) Line
!    if (ios < 0) exit
!    nLines = nLines+1
!  end do
!  rewind(Lu_Info)
!  do iLine=1,nLines
!    read(Lu_Info,'(A)') Line
!  end do
!# ifdef NAGFOR
!  ! FIXME: ugly hack to make NAG compiler happy
!  close(Lu_Info)
!  open(Lu_Info,file=file_name,position='append')
!# endif
!----------------------------------------------------------------------*
! Open new file                                                        *
!----------------------------------------------------------------------*
!else
!  call molcas_open_Ext2(Lu_info,file_name,'sequential','formatted',ios,.false.,irecl,'unknown',is_error)
!  if (ios /= 0) then
!    write(u6,*) 'Add_Info: can not create a new file'
!    write(u6,*) 'Check file permissions!'
!    call Abend()
!  end if
!  do i=1,Len(Line)
!    Line(i:i)='#'
!  end do
!  write(Lu_Info,'(A)') Line
!  write(Lu_Info,'(A)') '# MOLCAS-Info_File Vers.No. 1.1'
!  write(Lu_Info,'(A)') Line
!end if
!----------------------------------------------------------------------*
! Append new information                                               *
!----------------------------------------------------------------------*
write(Tol,'(i8)') merge(8,iTol,iTol == 0)
nlabel = len(label)
Line = label
n0 = nlabel
do i=1,nlabel
  if (label(i:i) == ' ') Line(i:i) = '_'
end do
call upcase(Line)
!------------------ Some code for Geo-Environment //Jonas 2011
!----------------------------------------------------------------------*
! Check if we are in the GEO-Environment and append if energy          *
!----------------------------------------------------------------------*
call qpg_iArray('GeoInfo',Found,length)
if (Found) then
  call get_iArray('GeoInfo',iGeoInfo,2)
  if ((nArray == 1) .and. (iGeoInfo(1) == 1) .and. (Label(1:2) == 'E_')) then
    write(Energy_File,'(A,I4.4)') 'disp.energy',iGeoInfo(2)
    LuDispEn = 1
    LuDispEn = isfreeunit(LuDispEn)
    call Molcas_Open(LuDispEn,Energy_File)
    write(LuDispEn,'(F16.8)') Array(1)
    close(LuDispEn)
    iGeoData = 0
    iuGeoData = 10
    iuGeoData = isFreeUnit(iuGeoData)
    call DaName_WA(iuGeoData,GeoDataF)
    call iDaFile(iuGeoData,2,iDum,1,iGeoData)
    nIntCoord = iDum(1)
    iGeoData = iGeoInfo(2)*(nIntCoord+1)+1
    Aux(1) = Array(1) ! because the argument is inout in dDaFile
    call dDaFile(iuGeoData,1,Aux,1,iGeoData)
    call DaClos(iuGeoData)
  end if
end if
isfound = 1
if (MyRank == 0) then
  !---------------------------------------------------------------------

  ! If this label should not be checked, then just return immediately:
  STRING = ' '
  call GETENVF('MOLCAS_NOCHECK',STRING)
  call upcase(STRING)
  STMP = STRING
  isfound = 0
  do
    icomma = index(STMP,',')
    if (icomma /= 0) then
      STRING = ' '
      STRING = STMP(1:icomma-1)
      if (icomma < len(STMP)) then
        STMP = STMP(icomma+1:)
      else
        STMP = ''
      end if
    else
      STRING = STMP
      STMP = ' '
    end if
    k = 0
    l = len(STRING)
    do i=1,l
      if (STRING(i:i) == ' ') then
        if (k > 0) then
          if (STRING2(1:k) == Line(1:k)) then
            isfound = 1
            exit
          end if
        end if
        k = 0
      else
        k = k+1
        STRING2(k:k) = STRING(i:i)
      end if
    end do
    if (STMP == ' ') exit
  end do
end if

if (isfound /= 1) then
  do iArray=1,nArray
    nlabel = n0
    if (nArray /= 1) then
      write(Junk,'(a,i3,a)') '[',iArray-1,']'
      do j=1,5
        if (Junk(j:j) /= ' ') then
          nlabel = nlabel+1
          Line(nlabel:nlabel) = Junk(j:j)
        end if
      end do
    end if
    nlabel = nlabel+1
    Line(nlabel:nlabel) = '='
    nlabel = nlabel+1
    Line(nlabel:nlabel) = '"'
    ia = int(Array(iArray)+0.3_wp)
    if ((abs(Array(iArray)-ia) < 1.0e-7_wp) .and. (ia /= 0)) then
      write(Junk,'(I30)') ia
    else
      if (abs(Array(iArray)) > 1.0e-14_wp) then
        write(Junk,'(F30.12)') Array(iArray)
      else
        Junk = '0.0'
      end if
    end if
    do j=1,30
      if (Junk(j:j) /= ' ') then
        nlabel = nlabel+1
        Line(nlabel:nlabel) = Junk(j:j)
      end if
    end do
    nlabel = nlabel+1
    Line(nlabel:nlabel) = '"'
    if (iArray < Num) then
      !----------------------------------------------------------------*
      ! Export only head of Array                                      *
      !----------------------------------------------------------------*
      !write(Lu_Info,*)
      collect = ''
      collect(1:nlabel) = Line(1:nlabel)
      call add_molcas_info(collect,nlabel)
      !write(Lu_Info,'(a)') Line(1:nlabel)
      if (iArray == nArray) then
        collect = 'export '//Line(1:n0)
        call add_molcas_info(collect,n0+7)
        !write(Lu_Info,'(a,a)') 'export ',Line(1:n0)
      end if
    end if
    ik = 0
    do i=1,8
      if (Tol(i:i) /= ' ') then
        ik = ik+1
        Junk(ik:ik) = Tol(i:i)
      end if
    end do
    collect = '#> '//Line(1:nlabel)//'/'//Junk(1:ik)
    call add_molcas_info(collect,nlabel+ik+4)
    !write(Lu_Info,'(a,a,a,a)') '#> ',Line(1:nlabel),'/',Junk(1:ik)
  end do
end if
!----------------------------------------------------------------------*
! Close file                                                           *
!----------------------------------------------------------------------*
call close_molcas_info()
!----------------------------------------------------------------------*
! exit                                                                 *
!----------------------------------------------------------------------*
return

end subroutine Add_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine o12eb_cvb( &
#                    define _CALLING_
#                    include "optb_interface.fh"
                    )

use casvb_global, only: cvb, expct, fxbest, have_solved_it, hh, ip, nfrorb, nvb, odx, orbs, scalesmall, strucopt
use casvb_interfaces, only: ddasonc_sub, ddres2upd_sub
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
#include "optb_interface.fh"
integer(kind=iwp) :: ioptc2, ipu, iter2
real(kind=wp) :: cnrm2, fac, fx_exp, resthr_old = -One, resthr_use
logical(kind=iwp) :: skip
real(kind=wp), external :: ddot_, dnrm2_
procedure(ddasonc_sub) :: asonc12e_cvb
procedure(ddres2upd_sub) :: ddres2upd10_cvb

if (.not. close2conv) then
  resthr_use = 1.0e-5_wp
else
  resthr_use = 0.05_wp*grdnrm
  resthr_use = max(0.5e-5_wp*0.6_wp,resthr_use)
  resthr_use = min(1.0e-5_wp,resthr_use)
end if
skip = ((resthr_use == resthr_old) .and. have_solved_it)
resthr_old = resthr_use

if (.not. skip) then
  call makegjorbs_cvb(orbs)

  call axesx_cvb(asonc12e_cvb,ddres2upd10_cvb,odx,resthr_use,ioptc2,iter2,fx_exp)
  expct = fx_exp-fxbest
  have_solved_it = .true.

  if (ip >= 2) write(u6,'(a,i4)') ' Number of iterations for direct diagonalization :',iter2

  if (strucopt) then
    cnrm2 = ddot_(nvb,cvb,1,odx(nfrorb+1:),1)
    ! "Orthogonalize" on CVB to get smallest possible update norm:
    odx(nfrorb+1:nfrorb+nvb) = odx(nfrorb+1:nfrorb+nvb)-cnrm2*cvb(1:nvb)
    ! Scale variables according to overlap with CVB:
    odx(1:nparm) = odx(1:nparm)/cnrm2
  else
    ! We are doing "Augmented" calc:
    fac = One/odx(1)
    ! Scale variables according to overlap with CVB:
    odx(1:nparm-1) = fac*odx(2:nparm)
  end if
end if

dxnrm = dnrm2_(nparm,odx,1)
if (.not. close2conv) then
  ipu = 1
else
  ipu = 2
end if
if ((dxnrm > hh) .or. scalesmall(ipu)) then
  odx(:) = hh/dxnrm*odx(:)
  dxnrm = hh
end if

return

end subroutine o12eb_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mkorbfree2_cvb(orbs,north,corth,
     >  irels,relorb,ifxorb,iorts,irots,
     >  trprm,owrk,owrk2,orbinv,idel)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension orbs(norb,norb)
      dimension north(norb),corth(norb,niorth)
      dimension irels(2,nijrel),relorb(norb,norb,nijrel)
      dimension ifxorb(norb),iorts(2,nort),irots(2,ndrot)
      dimension trprm(nprorb,nprorb)
      dimension owrk(norb,norb),owrk2(norb,norb)
      dimension orbinv(norb,norb),idel(nprorb)
      dimension dum(1)
      save thresh
      data thresh/1.d-7/

      if(orbfr_is_unit)then
        nfrorb=nprorb
        goto 1000
      endif
      call fzero(trprm,nprorb*nprorb)
      call izero(idel,nprorb)
      call fmove_cvb(orbs,orbinv,norb*norb)
      call mxinv_cvb(orbinv,norb)

      nc=0
      ioffs=0
      do 100 iorb=1,norb
      if(north(iorb).gt.0.and.ifxorb(iorb).ne.1)then
c  Transform simple constraints to basis of VB orbitals :
        call mxattb_cvb(orbs,corth(1,1+ioffs),norb,norb,north(iorb),
     >    owrk)
        call span_cvb(owrk,north(iorb),ncon,dum,norb,0)
        ishift=(iorb-1)*(norb-1)
        do 300 icon=1,ncon
        nc=nc+1
        i2=0
        do 301 i=1,norb
        if(i.ne.iorb)then
          i2=i2+1
          trprm(i2+ishift,nc)=owrk(i,icon)
        endif
301     continue
300     continue
      elseif(ifxorb(iorb).eq.1)then
        ishift=(iorb-1)*(norb-1)
        do 350 icon=1,norb-1
        nc=nc+1
        trprm(icon+ishift,nc)=one
350     continue
      endif
      ioffs=ioffs+north(iorb)
100   continue

      call mxattb_cvb(orbs,orbs,norb,norb,norb,owrk)
      call ortelim_cvb(trprm,iorts,irots,owrk,
     >  nc,nprorb,norb*(norb-1),nrem)
      call izero(idel,nprorb)
      do 500 i=1,nrem
      idel(i)=1
500   continue

      do 600 irel=1,nijrel
      iorb=irels(1,irel)
      jorb=irels(2,irel)
      call mxatb_cvb(relorb(1,1,irel),orbs,norb,norb,norb,owrk)
      call mxatb_cvb(orbinv,owrk,norb,norb,norb,owrk2)
      if(abs(abs(owrk2(iorb,jorb))-one).gt.thresh)then
        write(6,*)' Transformation matrix cannot be correct !'
        call mxprint_cvb(owrk2,norb,norb,0)
        call abend_cvb()
      endif
      ishift=(jorb-1)*(norb-1)
      ishift2=(iorb-1)*(norb-1)
      i2=0
      do 700 i=1,norb
      if(i.eq.iorb)goto 700
      i2=i2+1
      j2=0
      do 720 j=1,norb
      if(j.eq.jorb)goto 720
      j2=j2+1
      do 740 iprm=1,nprorb
      trprm(i2+ishift2,iprm)=trprm(i2+ishift2,iprm)
     >  +owrk2(i,j)*trprm(j2+ishift,iprm)
740   continue
720   continue
700   continue
      ioff=1+(iorb-1)*(norb-1)
      ioff2=1+iorb*(norb-1)
      nl1=(iorb-1)*(norb-1)
      nl2=(norb-iorb)*(norb-1)
      do 800 i=nrem+1,nprorb
      sum1=ddot_(norb-1,trprm(ioff,i),1,trprm(ioff,i),1)
      sum2=ddot_(nl1,trprm(1,i),1,trprm(1,i),1)
      if(nl2.gt.0) sum2=sum2
     >    +ddot_(nl2,trprm(ioff2,i),1,trprm(ioff2,i),1)
      if(sum1.gt.thresh.and.sum2.lt.thresh)idel(i)=1
800   continue
600   continue
      nfrorb=0
      do 900 i=1,norb*(norb-1)
      if(idel(i).ne.1)then
        nfrorb=nfrorb+1
        call fmove_cvb(trprm(1,i),trprm(1,nfrorb),nprorb)
      endif
900   continue
      call fzero(trprm(1,nfrorb+1),(nprorb-nfrorb)*nprorb)
      call nize_cvb(trprm,nfrorb,dum,nprorb,0,0)

1000  nfr=nfrorb+nfrvb
      orbopt=(nfrorb.ne.0)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SubScr_Final()
C
C     Purpose: finalize (de-allocate memory) screening in vector
C              subtraction.
C
      use ChoSubScr, only: DSubScr, DSPNm
      Implicit None
#include "stdalloc.fh"

      If (Allocated(DSPNm)) Call mma_deallocate(DSPNm)

      If (Allocated(DSubScr)) Call mma_deallocate(DSubScr)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine addinta(wrk,wrksize,syma,ammap)
! this routine does for all a in syma
! 1- reconstruct #2 <_a,m,p,q> from TEMPDA2 file
! 2- prepare corresponding <_am p q> (like <amef>aaaa) to #3
! and write it to open INTA1-4
! N.B.  this routine uses following foreign routines:
! wrtmap
! wri

use ccsort_global, only: luna1, luna2, luna3, luna4, mapd3, mapi3, mbas, nva, nvb, pos30
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, syma, ammap(mbas,8,8)
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
integer(kind=iwp) :: a, lenefaaaa, lenefabab, lenefbaab, lenefbbbb, lenejaaaa, lenejabab, lenejabba, lenejbaab, lenejbaba, &
                     lenejbbbb, post, rc

! mapd2 and mapi2 of #2 <_a,m|p,q> are prepared

! make required mapd3 and mapi3 and write them to INTA1-4
! define lengths of this mediates

!1   to INTA1 <m,_a||ef>aaaa, <m,_a||ef>baab
call ccsort_grc0(3,2,1,3,3,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenefaaaa)
call dawrtmap(luna1,mapd3,mapi3,rc)
call ccsort_grc0(3,0,2,3,4,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenefbaab)
call dawrtmap(luna1,mapd3,mapi3,rc)

!2   to INTA2 <m,_a||ef>bbbb, <m,_a||ef>abab
call ccsort_grc0(3,2,2,4,4,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenefbbbb)
call dawrtmap(luna2,mapd3,mapi3,rc)
call ccsort_grc0(3,0,1,3,4,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenefabab)
call dawrtmap(luna2,mapd3,mapi3,rc)

!3   to INTA3 <m,_a||ej>aaaa, <m,_a||ej>baab, <m,_a||ej>baba
call ccsort_grc0(3,0,1,3,1,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenejaaaa)
call dawrtmap(luna3,mapd3,mapi3,rc)
call ccsort_grc0(3,0,2,3,2,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenejbaab)
call dawrtmap(luna3,mapd3,mapi3,rc)
call ccsort_grc0(3,0,2,4,1,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenejbaba)
call dawrtmap(luna3,mapd3,mapi3,rc)

!4   to INTA4 <m,_a||ej>bbbb, <m,_a||ej>abba, <m,_a||ej>abab
call ccsort_grc0(3,0,2,4,2,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenejbbbb)
call dawrtmap(luna4,mapd3,mapi3,rc)
call ccsort_grc0(3,0,1,4,1,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenejabba)
call dawrtmap(luna4,mapd3,mapi3,rc)
call ccsort_grc0(3,0,1,3,2,0,syma,pos30,post,mapd3,mapi3)
call deflength(mapd3,lenejabab)
call dawrtmap(luna4,mapd3,mapi3,rc)

! cycle over a

do a=1,nvb(syma)

  ! reconstruct #2 <_a,m,p,q> for given _a
  call mkampq(wrk,wrksize,a,ammap)

  ! get contributions to INTA2 <m,_a||ef>bbbb, <m,_a||ef>abab
  ! and write it there

  if (lenefbbbb > 0) then
    call expmpq(wrk,wrksize,syma,2,2,4,4,1,1)
    call dawri(luna2,lenefbbbb,wrk(mapd3(1,1)))
  end if

  if (lenefabab > 0) then
    call expmpq(wrk,wrksize,syma,0,1,3,4,1,0)
    call dawri(luna2,lenefabab,wrk(mapd3(1,1)))
  end if

  ! get contributions to INTA4 <m,_a||ej>bbbb, <m,_a||ej>abba, <m,_a||ej>abab
  ! and write it there

  if (lenejbbbb > 0) then
    call expmpq(wrk,wrksize,syma,0,2,4,2,1,1)
    call dawri(luna4,lenejbbbb,wrk(mapd3(1,1)))
  end if

  if (lenejabba > 0) then
    call expmpq(wrk,wrksize,syma,0,1,4,1,0,1)
    call dawri(luna4,lenejabba,wrk(mapd3(1,1)))
  end if

  if (lenejabab > 0) then
    call expmpq(wrk,wrksize,syma,0,1,3,2,1,0)
    call dawri(luna4,lenejabab,wrk(mapd3(1,1)))
  end if

  if (a > (nvb(syma)-nva(syma))) then
    ! contributions to INTA1 and INTA3 only for a-alfa

    ! get contributions to INTA1 <m,_a||ef>aaaa, <m,_a||ef>baab if any
    ! and write it there

    if (lenefaaaa > 0) then
      call expmpq(wrk,wrksize,syma,2,1,3,3,1,1)
      call dawri(luna1,lenefaaaa,wrk(mapd3(1,1)))
    end if

    if (lenefbaab > 0) then
      call expmpq(wrk,wrksize,syma,0,2,3,4,0,1)
      call dawri(luna1,lenefbaab,wrk(mapd3(1,1)))
    end if

    ! get contributions to INTA3 <m,_a||ej>aaaa, <m,_a||ej>baab, <m,_a||ej>baba
    ! and write it there

    if (lenejaaaa > 0) then
      call expmpq(wrk,wrksize,syma,0,1,3,1,1,1)
      call dawri(luna3,lenejaaaa,wrk(mapd3(1,1)))
    end if

    if (lenejbaab > 0) then
      call expmpq(wrk,wrksize,syma,0,2,3,2,0,1)
      call dawri(luna3,lenejbaab,wrk(mapd3(1,1)))
    end if

    if (lenejbaba > 0) then
      call expmpq(wrk,wrksize,syma,0,2,4,1,1,0)
      call dawri(luna3,lenejbaba,wrk(mapd3(1,1)))
    end if

  end if

end do

return

end subroutine addinta

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_QUALIFY(DIAG,ISHLAB,ISYMAX,MEM,FULL)
!
! Purpose: qualify diagonal elements for decomposition in
!          current reduced set. ISYMAX is the symmetry block
!          to which the largest diagonal belongs.
!          MEM is the (total!) max. allowed
!          memory for storing the qualified columns.
!          If no more columns can be qualified on exit,
!          FULL=.true. is returned.

use Cholesky, only: IALQUA, iOffq, MaxQual, nnBstR, nQual, nSym
#ifdef _DEBUGPRINT_
use Cholesky, only: DiaMin, iiBstR, iiBstRSh, IndRed, iQuAB, iSP2F, LuPri, nnBstRSh
#endif
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*)
integer(kind=iwp), intent(in) :: ISHLAB, ISYMAX, MEM
logical(kind=iwp), intent(out) :: FULL
integer(kind=iwp) :: ISYM, LEFT, MEM0, MINM, NEED
character(len=*), parameter :: SECNAM = 'CHO_QUALIFY'
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I, I1, I2, ISHLA, ISHLB, K, K1, K2, NUM
#endif

! Copy counter to offset array.
! -----------------------------

IOFFQ(1:NSYM) = NQUAL(1:NSYM)

! Check memory.
! -------------

MEM0 = sum(NQUAL(1:NSYM)*NNBSTR(1:NSYM,2))
LEFT = MEM-MEM0
if (IALQUA == 0) then
  MINM = NNBSTR(1,2)
  do ISYM=1,NSYM
    MINM = max(MINM,NNBSTR(ISYM,2))
  end do
else
  MINM = NNBSTR(ISYMAX,2)
end if
FULL = LEFT < MINM
if (FULL) return

! Qualify.
! --------

if (IALQUA == 0) then  ! qualify until full (dalton style)
  do ISYM=1,NSYM
    call CHO_QUALIFY_1(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
  end do
else if (IALQUA == 1) then  ! qualify until full
  call CHO_QUALIFY_1(DIAG,ISYMAX,ISHLAB,MEM,MEM0,LEFT)
  do ISYM=1,ISYMAX-1
    call CHO_QUALIFY_1(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
  end do
  do ISYM=ISYMAX+1,NSYM
    call CHO_QUALIFY_1(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
  end do
else ! qualify until full, then largest
  call CHO_QUALIFY_2(DIAG,ISYMAX,ISHLAB,MEM,MEM0,LEFT)
  do ISYM=1,ISYMAX-1
    call CHO_QUALIFY_2(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
  end do
  do ISYM=ISYMAX+1,NSYM
    call CHO_QUALIFY_2(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
  end do
end if

! Set FULL flag:
! FULL=.true. if a) not enough memory to qualify another column of
! any symmetry, or b) MAXQUAL reached in any symmetry.
! ----------------------------------------------------------------

NEED = sum(NQUAL(1:NSYM)*NNBSTR(1:NSYM,2))
if ((NEED < 1) .or. (NEED > MEM)) then
  call CHO_QUIT('Logical error (2) in '//SECNAM,104)
else
  LEFT = MEM-NEED
  FULL = .false.
  ISYM = 0
  do while ((ISYM < NSYM) .and. (.not. FULL))
    ISYM = ISYM+1
    if ((NQUAL(ISYM) < IOFFQ(ISYM)) .or. (NQUAL(ISYM) < 0) .or. (NQUAL(ISYM) > MAXQUAL)) then
      call CHO_QUIT('Logical error (3) in '//SECNAM,104)
    else
      FULL = NQUAL(ISYM) == MAXQUAL
    end if
    if (NNBSTR(ISYM,2) > 0) FULL = FULL .or. (LEFT < NNBSTR(ISYM,2))
  end do
end if

#ifdef _DEBUGPRINT_
! Debug: print.
! -------------

call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)
write(LUPRI,*)
write(LUPRI,*)
write(LUPRI,*) SECNAM,': qualified diagonals from shell-pair ',ISHLA,ISHLB,':'
write(LUPRI,*) 'Qualification algorithm: ',IALQUA
write(LUPRI,*) 'Total memory for qualification: ',MEM,'  Memory left: ',LEFT
do ISYM=1,NSYM
  NUM = NQUAL(ISYM)-IOFFQ(ISYM)
  write(LUPRI,*)
  write(LUPRI,*) 'Sym.,dimension,#qualified,threshold: ',ISYM,NNBSTRSH(ISYM,ISHLAB,2),NUM,DIAMIN(ISYM)
  if (NNBSTRSH(ISYM,ISHLAB,2) > 0) then
    I1 = IIBSTR(ISYM,2)+IIBSTRSH(ISYM,ISHLAB,2)+1
    I2 = I1+NNBSTRSH(ISYM,ISHLAB,2)-1
    write(LUPRI,*) 'Diagonal (current reduced set):'
    write(LUPRI,'(5F15.8)') (DIAG(INDRED(I,2)),I=I1,I2)
    K1 = IOFFQ(ISYM)+1
    K2 = NQUAL(ISYM)
    write(LUPRI,*) 'Qualified diagonals:'
    write(LUPRI,'(5F15.8)') (DIAG(INDRED(IQUAB(K,ISYM),2)),K=K1,K2)
  end if
end do
write(LUPRI,*)
write(LUPRI,*)
#endif

end subroutine CHO_QUALIFY

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DYAX(N,ALPHA,X,INCX,Y,INCY)
C
C     MULTIPLY A VECTOR, X, BY A SCALAR AND STORE THE RESULT IN
C     THE VECTOR Y.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(1+(N-1)*INCX), Y(1+(N-1)*INCY)
      DO 10 I = 1, N
         Y(1+(I-1)*INCY) = ALPHA * X(1+(I-1)*INCX)
   10 CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_TrcIdl_Init()
!
! Thomas Bondo Pedersen, May 2010.
!
! Allocate and init array for tracing idle processors

use Para_Info, only: nProcs
use Cholesky, only: Cho_Real_Par, Idle
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: l_Idle

if (Cho_Real_Par) then
  l_Idle = nProcs
else
  l_Idle = 1
end if
call mma_allocate(Idle,l_Idle,Label='Idle')

Idle(:) = 0

end subroutine Cho_TrcIdl_Init

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE MAI(JSY,INDEX,C,S,FC,BUFIN,IBUFIN,A,B,FK,DBK,W,THET,
     *ENP,EPP,NII,KTYP)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
      DIMENSION JSY(*),INDEX(*),C(*),S(*),FC(*),BUFIN(*),IBUFIN(*),
     &          A(*),B(*),FK(*),DBK(*),W(*),THET(NII,NII),ENP(*),EPP(*)
C     KTYP=0  ,  (A/I)   INTEGRALS
C     KTYP=1  ,  (AI/JK) INTEGRALS
      DIMENSION IPOB(9)
      PARAMETER (IPOW6=2**6,IPOW13=2**13,IPOW19=2**19)
      PARAMETER (IPOW10=2**10,IPOW20=2**20)
*
      JSYM(L)=JSUNP_CPF(JSY,L)
*
C      IF(IDENS.EQ.1)WRITE(6,876)(FC(I),I=1,NOB2)
C  876 FORMAT(1X,'AI',5F12.6)
      NK  = 0 ! dummy initialize
      NSK = 0 ! dummy initialize
      INUM=IRC(4)-IRC(3)
      CALL MPSQ2(C,S,W,MUL,INDEX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)
      NVT=IROW(NVIRT+1)
      ICHK=0
      IJOLD=0
      NOB2=IROW(NORBT+1)
      NOT2=IROW(LN+1)
      NOTT=2*NOT2
      NOVST=LN*NVIRT+1+NVT
      LBUF0=RTOI*LBUF
      LBUF1=LBUF0+LBUF+1
      LBUF2=LBUF1+1
      IF(KTYP.EQ.0)IADD10=IAD10(9)
      IF(KTYP.EQ.1)IADD10=IAD10(7)
100   CALL dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
      CALL iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 100
      IF(LEN.LT.0)GO TO 200
      DO 10 II=1,LEN
      IND=ICOP1(II)
      IF(ICHK.NE.0)GO TO 460
      IF(IND.NE.0)GO TO 11
      ICHK=1
      GO TO 10
460   ICHK=0
      ITURN=0
      IF(IDENS.EQ.1.AND.IJOLD.NE.0)GO TO 20
21    ITURN=1
      IF(KTYP.EQ.1)GO TO 9
      NK=IND
      IJOLD=NK
      NSK=NSM(NK)
      GO TO 20
9     INDI=IND
*      NI=MOD(INDI,IPOW10)
*      NJ=MOD(INDI/IPOW10,IPOW10)
*      NK=MOD(INDI/IPOW20,IPOW10)
      NI=IBITS(INDI,0,10)
      NJ=IBITS(INDI,10,10)
      NK=IBITS(INDI,20,10)
      NSIJ=MUL(NSM(NI),NSM(NJ))
      NSK=MUL(NSIJ,NSM(NK))
      IJ=IROW(NI)+NJ
      IF(IJ.EQ.IJOLD)GO TO 20
      IJOLD=IJ
      IADR=LASTAD(NOVST+NOTT+IJ)
      DO 105 INN=1,NOB2
      FC(INN)=D0
105   CONTINUE
90    CALL iDAFILE(Lu_TiABIJ,2,IBUFIN,LBUF2,IADR)
      LENGTH=IBUFIN(LBUF1)
      IADR=IBUFIN(LBUF2)
      IF(LENGTH.EQ.0)GO TO 91
      CALL SCATTER(LENGTH,FC,IBUFIN(LBUF0+1),BUFIN)
91    IF(IADR.NE.-1) GO TO 90
C     FORM VECTOR FK
20    NA1=NSYS(NSK)+1
      NA2=NSYS(NSK+1)
      INK=0
      IF(NA2.LT.NA1)GO TO 10
      DO 13 NA=NA1,NA2
      INK=INK+1
      NAK=IROW(LN+NA)+NK
      IF(ITURN.EQ.0)FC(NAK)=FK(INK)
      IF(ITURN.EQ.1)FK(INK)=FC(NAK)
13    CONTINUE
      IF(ITURN.EQ.0)GO TO 21
      GO TO 10
11    IF(INK.EQ.0)GO TO 10
CPAM97      ITYP=IAND(IND,63)
CPAM97      ICP2=IAND(ISHFT(IND,-6),8191)
CPAM97      ICP1=IAND(ISHFT(IND,-19),8191)
*      ITYP=MOD(IND,IPOW6)
*      ICP2=MOD(IND/IPOW6,IPOW13)
*      ICP1=MOD(IND/IPOW19,IPOW13)
      ITYP=IBITS(IND, 0,6)
      ICP2=IBITS(IND,6,13)
      ICP1=IBITS(IND,19,13)
      IF(ITYP.GT.1)GO TO 12
      INDA=ICP1
      INDB=IRC(1)+ICP2
      INNY=INDEX(INDB)+1
      IF(IDENS.EQ.1)GO TO 41
      IF(INDA.NE.IREF0)GO TO 42
      COPI=COP(II)/SQRT(ENP(INDB))
      CALL DAXPY_(INK,COPI,FK,1,S(INNY),1)
      IF(ITER.EQ.1)GO TO 10
      TERM=DDOT_(INK,FK,1,C(INNY),1)
      EPP(INDB)=EPP(INDB)+COPI*TERM
      GO TO 10
42    ENPQ=(D1-THET(INDA,INDB)/D2)*(ENP(INDA)+ENP(INDB)-D1)+
     *THET(INDA,INDB)/D2
      FACS=SQRT(ENP(INDA))*SQRT(ENP(INDB))/ENPQ
      FACW=FACS*(D2-THET(INDA,INDB))/ENPQ
      FACWA=FACW*ENP(INDA)-FACS
      FACWB=FACW*ENP(INDB)-FACS
      COPI=COP(II)*C(INDA)
      CALL DAXPY_(INK,COPI*FACS,FK,1,S(INNY),1)
      CALL DAXPY_(INK,COPI*FACWB,FK,1,W(INNY),1)
      TERM=DDOT_(INK,FK,1,C(INNY),1)
      S(INDA)=S(INDA)+COP(II)*FACS*TERM
      W(INDA)=W(INDA)+COP(II)*FACWA*TERM
      GO TO 10
41    IF(INDA.EQ.IREF0)COPI=C(INDA)*COP(II)/ENP(INDB)
      ENPQ=(D1-THET(INDA,INDB)/D2)*(ENP(INDA)+ENP(INDB)-D1)+
     *THET(INDA,INDB)/D2
      IF(INDA.NE.IREF0)COPI=C(INDA)*COP(II)/ENPQ
      CALL DAXPY_(INK,COPI,C(INNY),1,FK,1)
C      WRITE(6,654)NK,NSK,INDB
C  654 FORMAT(1X,'TYP1,NK,NSK,INDB',3I7)
C      WRITE(6,653)(FK(I),I=1,INK)
C  653 FORMAT(1X,'FK',5F12.6)
      GO TO 10
12    IF(ITER.EQ.1)GO TO 10
      INDA=IRC(1)+ICP1
      INDB=IRC(ITYP)+ICP2
      INMY=INDEX(INDA)+1
      INNY=INDEX(INDB)+1
      MYSYM=JSYM(INDA)
      NYSYM=MUL(MYSYM,NSK)
      MYL=MUL(MYSYM,LSYM)
      NYL=MUL(NYSYM,LSYM)
      IFT=0
      IF(ITYP.EQ.2)IFT=1
      CALL IPO_CPF(IPOB,NVIR,MUL,NSYM,NYL,IFT)
      NVM=NVIR(MYL)
      IF(IDENS.EQ.1)GO TO 210
      ENPQ=(D1-THET(INDA,INDB)/D2)*(ENP(INDA)+ENP(INDB)-D1)+
     *THET(INDA,INDB)/D2
      FACS=SQRT(ENP(INDA))*SQRT(ENP(INDB))/ENPQ
      FACW=FACS*(D2-THET(INDA,INDB))/ENPQ
      FACWA=FACW*ENP(INDA)-FACS
      FACWB=FACW*ENP(INDB)-FACS
      CALL SETZ(DBK,INK)
      CALL DAXPY_(INK,COP(II),FK,1,DBK,1)
      IF(NYL.NE.1)GO TO 25
      IF(IFT.EQ.0)CALL SQUAR_CPF(C(INNY+IPOB(MYL)),A,NVM)
      IF(IFT.EQ.1)CALL SQUARM_CPF(C(INNY+IPOB(MYL)),A,NVM)
      CALL SETZ(B,NVM)
      CALL FMMM(DBK,A,B,1,NVM,INK)
      CALL DAXPY_(NVM,FACS,B,1,S(INMY),1)
      CALL DAXPY_(NVM,FACWA,B,1,W(INMY),1)
      SIGN=D1
      IF(IFT.EQ.1)SIGN=-D1
      IOUT=INNY+IPOB(MYL)-1
      DO 125 I=1,NVM
      DO 130 J=1,I
      IOUT=IOUT+1
      TERM=DBK(I)*C(INMY+J-1)+SIGN*DBK(J)*C(INMY+I-1)
      S(IOUT)=S(IOUT)+FACS*TERM
      W(IOUT)=W(IOUT)+FACWB*TERM
130   CONTINUE
      IF(IFT.EQ.1)GO TO 125
      TERM=DBK(I)*C(INMY+I-1)
      S(IOUT)=S(IOUT)-FACS*TERM
      W(IOUT)=W(IOUT)-FACWB*TERM
125   CONTINUE
      GO TO 10
25    NKM=INK*NVM
      CALL SETZ(B,NVM)
      IF(NSK.GT.MYL)GO TO 26
      IF(IFT.EQ.1)CALL VNEG_CPF(DBK,1,DBK,1,INK)
      CALL FMMM(DBK,C(INNY+IPOB(MYL)),B,1,NVM,INK)
      CALL DAXPY_(NVM,FACS,B,1,S(INMY),1)
      CALL DAXPY_(NVM,FACWA,B,1,W(INMY),1)
      CALL SETZ(B,NKM)
      CALL FMMM(DBK,C(INMY),B,INK,NVM,1)
      CALL DAXPY_(NKM,FACS,B,1,S(INNY+IPOB(MYL)),1)
      CALL DAXPY_(NKM,FACWB,B,1,W(INNY+IPOB(MYL)),1)
      GO TO 10
26    CALL FMMM(C(INNY+IPOB(NSK)),DBK,B,NVM,1,INK)
      CALL DAXPY_(NVM,FACS,B,1,S(INMY),1)
      CALL DAXPY_(NVM,FACWA,B,1,W(INMY),1)
      CALL SETZ(B,NKM)
      CALL FMMM(C(INMY),DBK,B,NVM,INK,1)
      CALL DAXPY_(NKM,FACS,B,1,S(INNY+IPOB(NSK)),1)
      CALL DAXPY_(NKM,FACWB,B,1,W(INNY+IPOB(NSK)),1)
      GO TO 10
210   CALL SETZ(B,INK)
      ENPQ=(D1-THET(INDA,INDB)/D2)*(ENP(INDA)+ENP(INDB)-D1)+
     *THET(INDA,INDB)/D2
      COPI=COP(II)/ENPQ
C      WRITE(6,652)IFT,NYL,NSK,MYL,INDA,INDB
C  652 FORMAT(1X,'TYP2',6I7)
      IF(NYL.NE.1)GO TO 225
      IF(IFT.EQ.0)CALL SQUAR_CPF(C(INNY+IPOB(MYL)),A,NVM)
      IF(IFT.EQ.1)CALL SQUARN_CPF(C(INNY+IPOB(MYL)),A,NVM)
      CALL FMMM(C(INMY),A,B,1,INK,NVM)
227   CALL VSMA(B,1,COPI,FK,1,FK,1,INK)
C      WRITE(6,651)(FK(I),I=1,INK)
C  651 FORMAT(1X,'FK',5F12.6)
      GO TO 10
225   IF(NSK.GT.MYL)GO TO 226
      CALL FMMM(C(INNY+IPOB(MYL)),C(INMY),B,INK,1,NVM)
      IF(IFT.EQ.1)COPI=-COPI
      GO TO 227
226   CALL FMMM(C(INMY),C(INNY+IPOB(NSK)),B,1,INK,NVM)
      GO TO 227
10    CONTINUE
      GO TO 100
200   IF(IDENS.EQ.0)GO TO 201
      NA1=NSYS(NSK)+1
      NA2=NSYS(NSK+1)
      INK=0
      IF(NA2.LT.NA1)GO TO 201
      DO 213 NA=NA1,NA2
      INK=INK+1
      NAK=IROW(LN+NA)+NK
      FC(NAK)=FK(INK)
213   CONTINUE
201   CALL MDSQ2(C,S,W,MUL,INDEX,JSY,NDIAG,INUM,IRC(3),
     *LSYM,NVIRT,SQ2)
C      IF(IDENS.EQ.1)WRITE(6,876)(FC(I),I=1,NOB2)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1998, Roland Lindh                                *
************************************************************************
      Subroutine PLF_Fck1(AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iShell,
     &                     MapOrg,iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,
     &                     kOp,D,F,ind,nind,ExFac,NoClmb,NoExch)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
*
      Real*8 AOint(ijkl,iCmp,jCmp,kCmp,lCmp),
     &       D(*), F(*)
      Integer iShell(4), iAO(4), kOp(4), iAOst(4), iSOs(4), MapOrg(4),
     &        ind(nind,*)
      Logical Shijij, usShij, usShkl, NoExch, NoClmb
*
      usShij = iShell(1).eq.iShell(2)
      usShkl = iShell(3).eq.iShell(4)
      fac_c=One
      if(usShij) fac_c=fac_c*Half
      if(usShkl) fac_c=fac_c*Half
      if(Shijij) fac_c=fac_c*Half
      fac_e=fac_c*Exfac
      If (NoExch) fac_e=Zero
      If (NoClmb) fac_c=Zero
*
      iAOsti=iAOst(1)
      iAOstj=iAOst(2)
      iAOstk=iAOst(3)
      iAOstl=iAOst(4)
      iAOi=iAO(1)
      iAOj=iAO(2)
      iAOk=iAO(3)
      iAOl=iAO(4)
*
      Do i4 = 1, lCmp
         iSOs(4)=iAOtSO(iAOl+i4,kOp(4))+iAOstl
         Do i3 = 1, kCmp
            iSOs(3)=iAOtSO(iAOk+i3,kOp(3))+iAOstk
            Do i2 = 1, jCmp
               iSOs(2)=iAOtSO(iAOj+i2,kOp(2))+iAOstj
               Do i1 = 1, iCmp
                  iSOs(1)=iAOtSO(iAOi+i1,kOp(1))+iAOsti
*
                  iSO =iSOs(1)
                  jSO =iSOs(2)
                  kSO =iSOs(3)
                  lSO =iSOs(4)
*
                  nijkl = 0
                  Do lSOl = lSO, lSO+lBas-1
                     Do kSOk = kSO, kSO+kBas-1
                        kl=ind(kSOk,lSOl)
                        dkl=D(kl)*Four
                        fkl=Zero
                        Do jSOj = jSO, jSO+jBas-1
                           jk=ind(jSOj,kSOk)
                           jl=ind(jSOj,lSOl)
                           Do iSOi = iSO, iSO+iBas-1
                              nijkl = nijkl + 1
                              val=AOint(nijkl,i1,i2,i3,i4)
                              val_c=val*fac_c
                              val_e=val*fac_e
                              ij=ind(iSOi,jSOj)
                              fkl=fkl+val_c*D(ij)
                              F(ij)=F(ij)+val_c*dkl
                              ik=ind(iSOi,kSOk)
                              il=ind(iSOi,lSOl)
                              F(ik)=F(ik)-val_e*D(jl)
                              F(jl)=F(jl)-val_e*D(ik)
                              F(il)=F(il)-val_e*D(jk)
                              F(jk)=F(jk)-val_e*D(il)
                           End Do
                        End Do
                        F(kl)=F(kl)+fkl*Four
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(MapOrg)
      End
      Subroutine PLF_Fck2(AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iShell,
     &                     MapOrg,iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,
     &                     kOp,D,F,ldens,ndens,ind,nind,ExFac,
     &                     NoClmb,NoExch)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
*
      Real*8 AOint(ijkl,iCmp,jCmp,kCmp,lCmp),
     &       D(ldens,ndens), F(ldens,ndens),exfac(ndens)
      Integer iShell(4), iAO(4), kOp(4),
     &        iAOst(4), iSOs(4), MapOrg(4), ind(nind,*)
      Logical Shijij, usShij, usShkl, NoExch(ndens), NoClmb(ndens)
*
      usShij = iShell(1).eq.iShell(2)
      usShkl = iShell(3).eq.iShell(4)
      fac_c=One
      if(usShij) fac_c=fac_c*Half
      if(usShkl) fac_c=fac_c*Half
      if(Shijij) fac_c=fac_c*Half
      fac_e1=fac_c*Exfac(1)
      fac_e2=fac_c*Exfac(2)
      If (NoExch(1)) fac_e1=Zero
      If (NoExch(2)) fac_e2=Zero
      If (NoClmb(1)) fac_c=Zero
*
      iAOsti=iAOst(1)
      iAOstj=iAOst(2)
      iAOstk=iAOst(3)
      iAOstl=iAOst(4)
      iAOi=iAO(1)
      iAOj=iAO(2)
      iAOk=iAO(3)
      iAOl=iAO(4)
*
      Do i4 = 1, lCmp
         iSOs(4)=iAOtSO(iAOl+i4,kOp(4))+iAOstl
         Do i3 = 1, kCmp
            iSOs(3)=iAOtSO(iAOk+i3,kOp(3))+iAOstk
            Do i2 = 1, jCmp
               iSOs(2)=iAOtSO(iAOj+i2,kOp(2))+iAOstj
               Do i1 = 1, iCmp
                  iSOs(1)=iAOtSO(iAOi+i1,kOp(1))+iAOsti
*
                  iSO =iSOs(1)
                  jSO =iSOs(2)
                  kSO =iSOs(3)
                  lSO =iSOs(4)
*
                  nijkl = 0
                  Do lSOl = lSO, lSO+lBas-1
                     Do kSOk = kSO, kSO+kBas-1
                        kl=ind(kSOk,lSOl)
                        dkl=D(kl,1)*Four
                        fkl=Zero
                        Do jSOj = jSO, jSO+jBas-1
                           jk=ind(jSOj,kSOk)
                           jl=ind(jSOj,lSOl)
                           Do iSOi = iSO, iSO+iBas-1
                              nijkl = nijkl + 1
                              val=AOint(nijkl,i1,i2,i3,i4)
                              val_c=val*fac_c
                              val_e1=val*fac_e1
                              val_e2=val*fac_e2
                              ij=ind(iSOi,jSOj)
                              ik=ind(iSOi,kSOk)
                              il=ind(iSOi,lSOl)
                              fkl=fkl+val_c*D(ij,1)
                              F(ij,1)=F(ij,1)+val_c*dkl
                              F(ik,1)=F(ik,1)-val_e1*D(jl,1)
                              F(jl,1)=F(jl,1)-val_e1*D(ik,1)
                              F(il,1)=F(il,1)-val_e1*D(jk,1)
                              F(jk,1)=F(jk,1)-val_e1*D(il,1)
                              F(ik,2)=F(ik,2)-val_e2*D(jl,2)
                              F(jl,2)=F(jl,2)-val_e2*D(ik,2)
                              F(il,2)=F(il,2)-val_e2*D(jk,2)
                              F(jk,2)=F(jk,2)-val_e2*D(il,2)
                           End Do
                        End Do
                        F(kl,1)=F(kl,1)+fkl*Four
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(MapOrg)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FockGen_td(d_0,rDens1,rdens2,fock,idsym)
!***********************************************************************
!                                                                      *
!   Constructs active fockmatrix and Q matrix                          *
!                                                                      *
!   Input: rkappa : Rotation matrix                                    *
!          idsym  : symmetry of perturbation                           *
!                                                                      *
!                                                                      *
!   Output:MO     :MO integrals                                        *
!          Fock   :Fock matrix (one index transformed integrals)       *
!          MOtilde:MO (one index transformed integrals)                *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: Mul
use MCLR_Data, only: FIMO, ipCM, ipMat, nA, nDens, nNA
use input_mclr, only: nAsh, nBas, nIsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: d_0, rDens1(nna,nna), rdens2(*)
real(kind=wp), intent(out) :: Fock(nDens)
integer(kind=iwp), intent(in) :: idSym
integer(kind=iwp) :: iA, iAA, ip1, ip2, ip3, ipF, ipM, ipS, iS, jA, jAA, jS, kA, kS, n1, n2
real(kind=wp) :: rd, rd1, rd2
real(kind=wp), allocatable :: MO(:), Scr(:), TQ(:)

!                                                                      *
!***********************************************************************
!                                                                      *
Fock(:) = Zero

n1 = max(0,maxval(nBas(1:nSym)))
n2 = n1**2
call mma_allocate(MO,n2,Label='MO')
call mma_allocate(Scr,n2,Label='Scr')

do ipS=1,nSym
  do kS=1,nSym
    do iS=1,nSym
      jS = Mul(Mul(ipS,kS),iS)
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Coulomb term: F  = 2(pk|ji)d
      !                kp           ij
      !                                                                *
      !*****************************************************************
      !                                                                *
      if ((Mul(ipS,kS) == iDsym) .and. (nBas(ipS)*nIsh(kS) > 0)) then
        do iA=1,nAsh(iS)
          iAA = iA+nIsh(iS)
          do jA=1,nAsh(jS)
            jAA = jA+nIsh(jS)

            call Coul(ipS,kS,iS,jS,iAA,jAA,MO,Scr)

            rD = rDens1(iA+nA(iS),jA+nA(jS))*Two
            Fock(ipMat(ipS,Ks):ipMat(ipS,Ks)+nBas(ipS)*nIsh(kS)-1) = Fock(ipMat(ipS,Ks):ipMat(ipS,Ks)+nBas(ipS)*nIsh(kS)-1)+ &
                                                                     rd*MO(1:nBas(ipS)*nIsh(kS))

          end do
        end do
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Exchange term   F = -(pk|ji)d     (i>j)  OBS KAN VARA FEL
      !                  pl          kj

      if ((Mul(ips,iS) == iDsym) .and. (nBas(ipS) > 0)) then
        do iA=1,nIsh(iS)
          ipF = ipMat(ipS,iS)+nBas(ipS)*(iA-1)
          do jA=1,nAsh(jS)
            jAA = jA+nIsh(js)

            call Coul(ipS,kS,iS,jS,iA,jAA,MO,Scr)

            ipM = 1+nIsh(kS)*nBas(ipS)
            do kA=1,nAsh(ks)

              ! Two different densities for the exchange term.

              rd1 = rDens1(jA+nA(jS),kA+nA(ks))*Two
              rd2 = rDens1(kA+nA(kS),jA+nA(js))*Two
              Fock(ipF:ipF+nBas(ipS)-1) = Fock(ipF:ipF+nBas(ipS)-1)-rd1*Half*MO(ipM:ipM+nBas(ipS)-1)
              Fock(ipMat(is,ips)+iA-1:ipMat(is,ips)+iA-1+nBas(ipS)*nBas(iS)-1:nBas(iS)) = &
                Fock(ipMat(is,ips)+iA-1:ipMat(is,ips)+iA-1+nBas(ipS)*nBas(iS)-1:nBas(iS))+rd2*Half*MO(ipM:ipM+nBas(ipS)-1)
              ipM = ipM+nBas(ipS)
            end do
          end do
        end do
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! KAN GAA FEL
!
! $F_{pb}=F_{pa}^ID_{ba}$

do iS=1,nSym
  if (nBas(iS) > 0) then
    jS = Mul(is,iDSym)
    do iA=1,nAsh(is)
      do jA=1,nAsh(js)
        rd2 = rDens1(iA+nA(iS),jA+nA(js))
        rd1 = rDens1(jA+nA(jS),iA+nA(is))
        ip1 = nBas(iS)*(nIsh(is)+iA-1)+ipCM(is)
        ip2 = nBas(iS)*(nIsh(js)+jA-1)+ipmat(is,js)
        ip3 = nIsh(js)+jA-1+ipmat(js,is)
        Fock(ip2:ip2+nBas(iS)-1) = Fock(ip2:ip2+nBas(iS)-1)+Rd1*FIMO(ip1:ip1+nBas(iS)-1)
        Fock(ip3:ip3+nBas(iS)*nBas(jS)-1:nBas(jS)) = Fock(ip3:ip3+nBas(iS)*nBas(jS)-1:nBas(jS))-Rd2*FIMO(ip1:ip1+nBas(iS)-1)
      end do
    end do
  end if
end do
! QB is calc here

call CreQADD(Fock,rdens2,idsym,MO,Scr,n2)

call mma_allocate(TQ,nDens,Label='TQ')
TQ(:) = Zero

! QA here
call CreQADD2(TQ,rdens2,idsym,MO,Scr,n2)

call mma_deallocate(Scr)
call mma_deallocate(MO)

call mma_allocate(Scr,nDens,Label='Scr')
Scr(:) = Fock(:)

do iS=1,nsym
  jS = Mul(is,idsym)
  if (nBas(iS)*nBas(jS) > 0) &
    call DGeSub(Fock(ipMat(is,js)),nbas(is),'N',TQ(ipMat(js,is)),nbas(js),'T',Scr(ipmat(is,js)),nbas(is),nbas(is),nbas(js))
end do

if (idSym == 1) call AddGrad2(Scr,d_0)

Fock(:) = Two*Scr(:)

call mma_deallocate(TQ)
call mma_deallocate(Scr)
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine FockGen_td

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PtRela(H0,Ovlp,RR,nSize,Temp,nTemp)
*
************************************************************************
*                                                                      *
*     Objective: Add the relativitic perturbation operator to          *
*                the one-electron Hamiltonian                          *
*                                                                      *
************************************************************************
*
      Implicit Real*8 ( A-H,O-Z )
*

#include "input.fh"
*
      Real*8 H0(nSize), Ovlp(nSize), RR(nSize), Temp(nTemp)
      Character*8 Label
      Character*20 PriLbl
      Logical Debug
      Data    Debug/.false./
      Dimension idum(1)
*
*----------------------------------------------------------------------*
*                                                                      *
*     Start procedure                                                  *
*     Load mass-velocity and one-electron Darwin contact term.         *
*     Add them to the one-electron Hamiltonian.                        *
*                                                                      *
*----------------------------------------------------------------------*
*
*
      If ( .not.ComStk(2,5,0,1) ) then
         Return
      End If
*
      Label='MassVel '
      iRc=-1
      iOpt1=1
      iOpt2=2
      iSyLbl=0
      iComp=1
      Alpha=ComVal(2,5,0,1)
      Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
      nInts=idum(1)
      If ( iRc.ne.0 ) Goto 991
      Call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
      If ( iRc.ne.0 ) Goto 991
      call daxpy_(nInts,Alpha,Temp,1,H0,1)
      H0(nInts+4)=H0(nInts+4)-Alpha*Temp(nInts+4)
      If ( Debug ) Then
        Write (6,'(6X,A,F8.6)') 'weight =',Alpha
        PriLbl='Mass-Velocity term  '
        Write(PriLbl(19:20),'(I2)') iComp
        Call PrDiOp(PriLbl,nSym,nBas,Temp)
      End If
      Label='Darwin  '
      iRc=-1
      iOpt1=1
      iOpt2=2
      iSyLbl=0
      iComp=1
      Call iRdOne(iRc,iOpt1,Label,iComp,idum,iSyLbl)
      nInts=idum(1)
      If ( iRc.ne.0 ) Goto 991
      Call RdOne(iRc,iOpt2,Label,iComp,Temp,iSyLbl)
      If ( iRc.ne.0 ) Goto 991
      call daxpy_(nInts,Alpha,Temp,1,H0,1)
      H0(nInts+4)=H0(nInts+4)-Alpha*Temp(nInts+4)
      If ( Debug ) Then
        Write (6,'(6X,A,F8.6)') 'weight =',Alpha
        PriLbl='1el. Darwin term    '
        Write(PriLbl(19:20),'(I2)') iComp
        Call PrDiOp(PriLbl,nSym,nBas,Temp)
      End If
*
*----------------------------------------------------------------------*
*     Normal Exit                                                      *
*----------------------------------------------------------------------*
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_real_array(Ovlp)
        Call Unused_real_array(RR)
      End If
*
*----------------------------------------------------------------------*
*     Error Exit                                                       *
*----------------------------------------------------------------------*
*
991   Write (6,*) 'PtRela: Error reading ONEINT'
      Write (6,'(A,A)') 'Label=',Label
      Call Abend()
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mkqhelp2 (vector,dimv,length,factor)
c
c     this routine do vector = vector*factot
c     vector - multilyied vector (I/O)
c     dimv   - dimension of vecrot
c     length - length of vector to be multiplyied
c     factor - scaling factor
c
c     $N.B. this routine should be substitued by mv0s3v
c
       integer dimv,length
       real*8 vector(1:dimv)
       real*8 factor
c
c     help variable
c
       integer n
c
       if (length.gt.0) then
       do 10 n=1,length
       vector(n)=vector(n)*factor
 10     continue
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_L1(L1,dima,adda)
! this routine tests L1

use chcc_global, only: L1k, nc, no
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dima, adda
real(kind=wp), intent(inout) :: L1(nc,dima,no)
integer(kind=iwp) :: a, bad, i, m, ntot
real(kind=wp) :: s

bad = 0
ntot = 0

do i=1,no
  do a=adda+1,adda+dima
    do m=1,nc

      s = L1k(m,i,a)

      if (abs(L1(m,a-adda,i)-s) > 1.0e-10_wp) then
        bad = bad+1
        L1(m,a-adda,i) = s
      end if
      ntot = ntot+1

    end do
  end do
end do

write(u6,*) ' L1   ',bad,ntot

return

end subroutine Chck_L1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine Dihedr(Lbls,xyz,mCentr,rtrnc,Max_Center)
!***********************************************************************
!                                                                      *
! Object: to compute dihedral angles from a list of coordinates.       *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Molcas, only: LenIn
use Constants, only: Zero, One, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mCentr, Max_Center
character(len=LenIn), intent(in) :: Lbls(mCentr)
real(kind=wp), intent(in) :: xyz(3,mCentr), rtrnc
integer(kind=iwp) :: ic, jc, kc, lc
real(kind=wp) :: arg, Bt(3,4), Coor(3,4), Dummy(1), Phi1, Phi12, Phi2, r1, r12, r2, r23, r3, Tau, x1, x12, x2, x23, x3, x4, y1, &
                 y12, y2, y23, y3, y4, z1, z12, z2, z23, z3, z4
character(len=8) :: Label
logical(kind=iwp) :: Typ
real(kind=wp), parameter :: Thr = 1.0e-12_wp, Thr_bond = 1.0e-6_wp

Label = ' '
if (mCentr > Max_Center) return

Typ = .false.
do ic=1,mCentr
  x2 = xyz(1,ic)
  y2 = xyz(2,ic)
  z2 = xyz(3,ic)
  Coor(:,2) = xyz(:,ic)
  do jc=1,mCentr
    if (jc == ic) cycle
    x3 = xyz(1,jc)
    y3 = xyz(2,jc)
    z3 = xyz(3,jc)
    r2 = sqrt((x3-x2)**2+(y3-y2)**2+(z3-z2)**2)
    if ((r2 > rtrnc) .or. (r2 < Thr_bond)) cycle
    !write(u6,*)
    Coor(:,3) = xyz(:,jc)
    do kc=1,mCentr
      if (kc == ic) cycle
      if (kc == jc) cycle
      x1 = xyz(1,kc)
      y1 = xyz(2,kc)
      z1 = xyz(3,kc)
      r1 = sqrt((x2-x1)**2+(y2-y1)**2+(z2-z1)**2)
      if ((r1 > rtrnc) .or. (r1 < Thr_bond)) cycle
      arg = ((x1-x2)*(x3-x2)+(y1-y2)*(y3-y2)+(z1-z2)*(z3-z2))/(r1*r2)
      if (abs(arg) > One) arg = sign(One,arg)
      if (One-abs(arg) < Thr) cycle
      Phi1 = acos(arg)/deg2rad
      x12 = (y2-y1)*(z3-z2)-(y3-y2)*(z2-z1)
      y12 = (z2-z1)*(x3-x2)-(z3-z2)*(x2-x1)
      z12 = (x2-x1)*(y3-y2)-(x3-x2)*(y2-y1)
      r12 = sqrt(x12**2+y12**2+z12**2)
      if (r12 == Zero) cycle
      Coor(:,1) = xyz(:,kc)
      do lc=kc+1,mCentr
        if (lc == ic) cycle
        if (lc == jc) cycle
        if (lc == kc) cycle
        x4 = xyz(1,lc)
        y4 = xyz(2,lc)
        z4 = xyz(3,lc)
        r3 = sqrt((x4-x3)**2+(y4-y3)**2+(z4-z3)**2)
        if ((r3 > rtrnc) .or. (r3 < Thr_bond)) cycle
        arg = ((x2-x3)*(x4-x3)+(y2-y3)*(y4-y3)+(z2-z3)*(z4-z3))/(r2*r3)
        if (abs(arg) > One) arg = sign(One,arg)
        if (One-abs(arg) < Thr) cycle
        Phi2 = acos(arg)/deg2rad
        x23 = (y3-y2)*(z4-z3)-(y4-y3)*(z3-z2)
        y23 = (z3-z2)*(x4-x3)-(z4-z3)*(x3-x2)
        z23 = (x3-x2)*(y4-y3)-(x4-x3)*(y3-y2)
        r23 = sqrt(x23**2+y23**2+z23**2)
        if (r23 == Zero) cycle
        Coor(:,4) = xyz(:,lc)
        !arg = (x12*x23+y12*y23+z12*z23)/(r12*r23)
        !if (abs(arg) > One) arg = sign(One,arg)
        !Phi12 = acos(arg)/deg2rad
        call Trsn(Coor,4,Tau,Bt,.false.,.false.,Label,Dummy,.false.)
        Phi12 = Tau/deg2rad
        if (.not. Typ) then
          Typ = .true.
          write(u6,*)
          write(u6,'(10X,A)') ' ***************************************************************'
          write(u6,'(10X,A)') ' *              Valence Dihedral Angles / degree               *'
          write(u6,'(10X,A)') ' ***************************************************************'
          write(u6,'(7X,A)') '             Atom centers                       Phi1     Phi2     Theta '
        end if
        write(u6,'(10X,4(I2,1X,A,2X),1X,3(F7.2,2X))') kc,Lbls(kc),ic,Lbls(ic),jc,Lbls(jc),lc,Lbls(lc),Phi1,Phi2,Phi12
      end do
    end do
  end do
end do

return

end subroutine Dihedr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ORTHOX_MOTRA(S,C,NORB,NBAS)
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(NBAS,NORB),S(NORB,NORB)
*
*
      DO IORB=1,NORB
         F=1.0/SQRT(S(IORB,IORB))
         DO IBAS=1,NBAS
            C(IBAS,IORB)=F*C(IBAS,IORB)
         END DO
         DO JORB=1,NORB
            S(IORB,JORB)=F*S(IORB,JORB)
            S(JORB,IORB)=F*S(JORB,IORB)
         END DO
         DO JORB=IORB+1,NORB
            A=S(IORB,JORB)
            DO IBAS=1,NBAS
               C(IBAS,JORB)=C(IBAS,JORB)-A*C(IBAS,IORB)
            END DO
            DO KORB=1,NORB
               S(JORB,KORB)=S(JORB,KORB)-A*S(IORB,KORB)
            END DO
            DO KORB=1,NORB
               S(KORB,JORB)=S(KORB,JORB)-A*S(KORB,IORB)
            END DO
         END DO
      END DO
*
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine gaussj2_cvb(a,lrow,lcol,ibook,irows,ijs,oijs,n)
      implicit real*8 (a-h,o-z)
      dimension a(n,n)
      dimension lrow(n),lcol(n),ibook(n)
      dimension irows(n),ijs(2,n*n),oijs(n*n)
      save zero,one,thresh
      data zero/0.d0/,one/1.d0/,thresh/1.d-10/

c  initialize imx & jmx to suppress compiler warnings ...
      imx=0
      jmx=0

      nij=n*n
      do 100 i=1,n
      irows(i)=i
      ibook(i)=0
100   continue
      do 1000 imain=1,n
      amx=zero
      do 1100 i=1,n
      if(ibook(i).ne.1)then
        do 1200 j=1,n
        if(ibook(j).eq.0)then
          if(abs(a(i,j)).ge.amx)then
            amx=abs(a(i,j))
            imx=i
            jmx=j
          endif
        elseif(ibook(j).gt.1)then
          write(6,*)' Singular matrix in GAUSSJ !'
          call abend_cvb()
        endif
1200    continue
      endif
1100  continue
      ibook(jmx)=ibook(jmx)+1
      if(imx.ne.jmx)then
        do 1300 ii=1,n
        dum=a(imx,ii)
        a(imx,ii)=a(jmx,ii)
        a(jmx,ii)=dum
1300    continue
        idum=irows(imx)
        irows(imx)=irows(jmx)
        irows(jmx)=idum
      endif
      lrow(imain)=imx
      lcol(imain)=jmx
      if(abs(a(jmx,jmx)).lt.thresh)then
        ihad=imain-1
        goto 3000
      endif
      ijs(1,nij)=irows(jmx)
      ijs(2,nij)=irows(jmx)
      oijs(nij)=a(jmx,jmx)
      nij=nij-1
      oneovamx=one/a(jmx,jmx)
      a(jmx,jmx)=one
      do 1500 ii=1,n
      a(jmx,ii)=oneovamx*a(jmx,ii)
1500  continue
      do 1700 ii2=1,n
      if(ii2.ne.jmx)then
        dum=a(ii2,jmx)
        a(ii2,jmx)=zero
        do 1800 ii=1,n
        a(ii2,ii)=a(ii2,ii)-dum*a(jmx,ii)
1800    continue
        ijs(1,nij)=irows(ii2)
        ijs(2,nij)=irows(jmx)
        oijs(nij)=dum
        nij=nij-1
      endif
1700  continue
1000  continue
      do 2000 ii=n,1,-1
      if(lrow(ii).ne.lcol(ii))then
        do 2100 ii2=1,n
        dum=a(ii2,lrow(ii))
        a(ii2,lrow(ii))=a(ii2,lcol(ii))
        a(ii2,lcol(ii))=dum
2100    continue
      endif
2000  continue
      return
3000  continue
      do 3100 i=1,n
      do 3200 j=1,ihad
      if(lcol(j).eq.i)goto 3100
3200  continue
      ijs(1,nij)=irows(i)
      ijs(2,nij)=irows(i)
      oijs(nij)=zero
      nij=nij-1
      do 3300 j=1,n
      if(j.ne.i)then
        ijs(1,nij)=irows(j)
        ijs(2,nij)=irows(i)
        oijs(nij)=a(j,i)
        nij=nij-1
      endif
3300  continue
3100  continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3wresult(symi,symj,i,j,eaaa,eaab,eabb,ebbb)
! this routine writes:
!   0) value of SymiMin,Imin,SymJmin,Jmin from which accumulation started
!   1) value of SymI,SymJ,I,J
!   2) present stage of energies
! into T3tEne file and overwrites previous values

use CCT3_global, only: imin, jmin, symimin, symjmin
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: symi, symj, i, j
real(kind=wp), intent(in) :: eaaa, eaab, eabb, ebbb
integer(kind=iwp) :: lun

lun = 1
call Molcas_Open(lun,'T3tEne')
!open(unit=lun,file='T3tEne')

write(lun,97) symimin,imin,symjmin,jmin
write(lun,98) symi,symj
write(lun,98) i,j
write(lun,99) eaaa
write(lun,99) eaab
write(lun,99) eabb
write(lun,99) ebbb

close(lun)

return

97 format(2x,4(i4,2x))
98 format(2x,2(i4,2x))
99 format(2x,f22.16)

end subroutine t3wresult

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine XDR_Prop(nbas,isize,jsize,imethod,paratyp,dkhorder,
     &                    xorder,inS,inK,inV,inpVp,inX,inpXp,
     &                    inUL,inUS,clight)
C
C Driver for relativistic transformation of property integrals
C
C   also called the "picture change correction" since the physical operator
C   X is defined in four-component picture, one need to transform them
C   to two/one- component picture as well as the Hamiltonian in the two/one-
C   component relativistic calculations
C
      implicit none
#include "WrkSpc.fh"
C Input variables
      integer nbas,isize,jsize,imethod,paratyp,dkhorder,xorder
      Real*8 clight
      Real*8 inS(isize),inK(isize),inpVp(isize),inpXp(isize)
      Real*8 inV(isize),inUL(jsize),inUS(jsize)
C Input/Output variables
      Real*8 inX(isize)
C Local variables
      integer nn,i,j,k
      integer jS,jK,jV,jpVp,jX,jpXp,itmp
C
C Convert to square matrices
C
      nn = nbas*nbas+4
      call getmem('skin ','ALLOC','REAL',jK   ,nn)
      call getmem('sSS  ','ALLOC','REAL',jS   ,nn)
      call getmem('sV   ','ALLOC','REAL',jV   ,nn)
      call getmem('spVp ','ALLOC','REAL',jpVp ,nn)
      call getmem('sX   ','ALLOC','REAL',jX   ,nn)
      call getmem('spXp ','ALLOC','REAL',jpXp ,nn)
#ifdef MOLPRO
      call square(inK  ,Work(jK),nbas,nbas)
      call square(inS  ,Work(jS),nbas,nbas)
      call square(inV  ,Work(jV),nbas,nbas)
      call square(inpVp,Work(jpVp),nbas,nbas)
      call square(inX  ,Work(jX),nbas,nbas)
      call square(inpXp,Work(jpXp),nbas,nbas)
#else
      call square(inK  ,Work(jK),nbas,1,nbas)
      call square(inS  ,Work(jS),nbas,1,nbas)
      call square(inV  ,Work(jV),nbas,1,nbas)
      call square(inpVp,Work(jpVp),nbas,1,nbas)
      call square(inX  ,Work(jX),nbas,1,nbas)
      call square(inpXp,Work(jpXp),nbas,1,nbas)
#endif
C
C Calculate the relativistic transformed property integrals
C
      if(imethod.eq.2.or.imethod.eq.3.or.
     &   (imethod.eq.1.and.xorder.ge.15) )then
C
C X2C/BSS transformation
C
C   because the transformation matrix in non-orthogonal basis picture has
C   obtained via the Hamiltonian drivers, here we just need to simply apply
C   it to property integrals ( X, pXp in four-component picture )
C
C   high order DKH can also employ this formulation, only negligible
C   contribution from higher orders is included
C
        call getmem('TMP ','ALLOC','REAL',itmp ,nn)
C        ! eval U_L^{\dag} X U_L
        call dmxma(nbas,'C','N',inUL,Work(jX),Work(itmp),1.d0)
        call dmxma(nbas,'N','N',Work(itmp),inUL,Work(jX),1.d0)
C        ! eval U_S^{\dag}pXp U_S
        call dmxma(nbas,'C','N',inUS,Work(jpXp),Work(itmp),1.d0)
        call dmxma(nbas,'N','N',Work(itmp),inUS,Work(jpXp),1.d0)
C        ! sum
        do k=0,nbas*nbas-1
          Work(jX+k) = Work(jX+k) + Work(jpXp+k)
        end do
        call getmem('TMP ','FREE','REAL',itmp ,nn)
C
      else if(imethod.eq.1)then
C
C Arbitrary order DKH transformation
C
        call dkh_prop(nbas,Work(jS),Work(jK),Work(jV),Work(jpVp),
     &              Work(jX),Work(jpXp),clight,dkhorder,xorder,paratyp)
      endif
C
C Copy transformed property integral back to inX
C
      k=0
      do i=1,nbas
        do j=1,i
          k=k+1
          inX(k)=Work(jX+j-1+(i-1)*nbas)
        enddo
      enddo
C
C Free temp memories
C
      call getmem('skin ','FREE','REAL',jK   ,nn)
      call getmem('sSS  ','FREE','REAL',jS   ,nn)
      call getmem('sV   ','FREE','REAL',jV   ,nn)
      call getmem('spVp ','FREE','REAL',jpVp ,nn)
      call getmem('sX   ','FREE','REAL',jX   ,nn)
      call getmem('spXp ','FREE','REAL',jpXp ,nn)
C
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Cntrl

use Molcas, only: LenIn, MxAtom, MxOrb, MxRoot
use RASDim, only: mxTit
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

! BP - SO Natural orbital information
! RF - SO Natural transition orbital information
! IFARGU           Do phase factor for SO-NTOs
! IFCURD           Do current density stuff
! Do_TMOM          Do (exact) Transition MOMents
! L_Eff            The order of the Lebedev solid angle integration
! Do_SK            Do k-vector directions of the exact
!                     Hamiltonian with a vector field.
! nQuad            Number of vectors in the isotropic quadrature
! Do_Pol           Specify a polarization vector direction
! DOCD             Regular circular dichroism - velocity and mixed gauge
! SaveDens         Save input-state transition densities in temp. file

! CITHR  - THRESHOLD FOR PRINTING CI COEFFICIENTS.
! NSTAT  - NR OF STATES TO BE PICKED UP FROM EACH JOBIPH.
! IRREP  - SYMMETRY OF THE WAVE FUNCTIONS ON EACH JOBIPH.
! NCONF  - SIZE OF CI ARRAYS ON EACH JOBIPH.
! NJOB   - NR OF JOBIPH FILES TO BE USED.
! NSTATE - TOTAL NUMBER OF STATES.
! NPROP  - NR OF PROPERTIES TO COMPUTE MATRIX ELEMENTS FOR.
! NRNATO - NR OF EIGENSTATE TO COMPUTE NATURAL ORBITALS FOR.
! LSYM1  - SYMMETRY OF CURRENTLY PROCESSED BRA STATE.
! LSYM2  - SYMMETRY OF CURRENTLY PROCESSED KET STATE.
! NCONF1, SIMILAR.
! THE REST ARE POINTERS TO DYNAMICALLY ALLOCATED ARRAYS:
! ALPHZ - Value for alpha in DQV diabatization.
! BETAE - Value for beta in DQV diabatization.

! JBNAME - LOGICAL NAME OF EACH JOBIPH FILE.
! PNAME  - NAME OF EACH PROPERTY FOR WHICH MATRIX ELEMENTS ARE COMPUTED
! PTYPE  - TYPE NAME, ex. 'AntiSing' for an antihermitian, spin-singlet op.
! SOPRNM - LIST OF PROPERTY NAMES, LIKE PNAME, FOR MATRIX ELEMENTS OVER
!          SPIN-ORBIT STATES.
! SOPRTP - TYPE NAME, similar to PTYPE

! BP - Hyperfine tensor Flags
! IFACAL        TRUE to calculate hyperfine tensors
! IFACALFC      TRUE to calculate ONLY FC terms
! IFACALSD      TRUE to calculate ONLY SD terms
! K.Sharkas beg
! IFACALPSO     TRUE to calculate PSO terms individually
! IFACALFCON    TRUE to calculate FC  terms individually
! IFACALSDON    TRUE to calculate SD  terms individually
! IFACALFCSDON  TRUE to calculate FC +SD terms
! IFGTCALSA     TRUE to calculate single_aniso g-tensor in RASSI
! K.Sharkas end

! tjd- BMII: LPRPR set to .T. for easier parsable matrix output
! tjd- Yoni: LHAMI

! BP - Testing flags
! NOSO      Disable SO contributions in the SONATORB and SODIAG code

! PRSXY  - PRINT MO OVERLAP MATRICES FOR INPUT JOBIPHS.
! PRORB  - PRINT INPUT ORBITALS.
! PRTRA  - PRINT TRANSFORMATION COEFFICIENTS.
! PRCI   - PRINT CI COEFFICIENTS OF INPUT STATES.
! CIH5   - Put CI coeffs and MO to HDF5
! IFHEXT - Spin-free Hamiltonian is taken from input.
! IFSHFT - Energy shifts of input states will be applied.
! IFHDIA - Diagonal H-matrix elements are taken from input.
! IFSO   - DO SPIN-ORBIT INTERACTION CALCULATION.

! Rassi input...
! RFpert - This flag is used to signal a
!          reaction field calculation (perturbation approach).
! ToFile - Denotes if H-matrix and various one-electron matrices
!          are to be put on a file for subsequent programs.
! PRXVR, etc: Print expectation values for RasScf input states,
!          for (spin-free) eigenstates, and for SO states.
! PRMER, etc: Print matrix elements    for RasScf input states,
!          for (spin-free) eigenstates, and for SO states.
! IfDCpl - Flag for approximate derivative couplings
!IgorS 06-05-2009
! HOP    - Switch for Trajectory Surface Hopping Algorithm
! stknecht
! QDPT2SC - use SC effective Hamiltonian (rather than the PC one) from QD-NEVPT2
! QDPT2EV - use eigenvectors of effective Hamiltonian from QD-NEVPT2 to mix TDMs (in MPS-SI we do not use 'mixed MPS'
!           instead we mix the TDMs)

! NTO Calculation Section /// Jie Bao
! SONTO            Array of SO state pairs
! SONTOSTATES      Number of state pairs to calculate
! SONAT            Array of SO state to compute
! SONATNSTATE      Number of states to calculate
! SODIAGNSTATE     Number of states to diagonalize

! TEMPORARY DATA FROM JOBIPHS
! POTNU1, NACTE1, MPLET1, NSYM1, NFRO1, NISH1, NASH1, NDEL1, NBAS1, NRS11, NRS21, NRS31, LROT1, NROOT1, IROOT1, NHOL11, NELE31,
! bNAME, HEAD1, TITLE1

! Cholesky/RI stuff
! ALGO, Nscreen, dmpk

! ISTATE1 - Number of the current relaxed state
! ISTATE2 - Number of the state that interacts with the current state
! NCI1    - Configuration's number of state 1
! ChkHop  - If .true. switches on the TSH algorithm

!----- Variables for HFCOP.F90
! NATens_Calc        - Number of A_tensor calc. (EPR)
! NPNMR_Calc         - Number of pNMR tensor calc.
! NCOUP              - Number of coupling states
! ASD_idx(atom,comp) - list[NAtoms] ASD properties
! PSO_idx(atom,comp) - list[NAtoms] PSO properties
! Atens_Req          - list[NAtoms] of logical values whether A_tensor is requested for iAtom
! pNMR_req           - list[NAtoms] of logical values whether pNMR_tensor is requested for iAtom
! LCSTATES           - list of coupling states
! NucMass            - list[NATens_Calc] of nuclear mass (integer A=Z+N)
! NucSpin            - list[NATens_Calc] of spin quantum numbers of nuclei
! NucGFac            - list[NATens_Calc] of nuclear g-factor
! HISO_set           - Hypothetical isotope [to request to ignore whether an isotope exists or not]
! HypoIso            - list[NAtoms] of logical values whether g-factor/spin of this atom is hypothetical

!----------------------------------------------------------------------*
!     Define files ( file names and unit numbers )                     *
!----------------------------------------------------------------------*

! LUIPH  - UNIT NUMBER OF JOBIPHS
! LUMCK  - UNIT NUMBER OF MCKINT FILES
! LUONE  - D:O, ONE-ELECTRON INTEGRAL FILE
! LUORD  - D:O, ORDERED TWO-ELECTRON INTEGRAL FILE
! IDCMO  - Addresses to the CMO arrays on each JOBIPH

integer(kind=iwp), parameter :: MORSBITS = 8, MXDISP = 500, MXJOB = 100, MXPROP = 30000

integer(kind=iwp) :: ALGO, DCHO, DYSEXPSF, DYSEXPSO, IBINA(2,MxRoot), ICOMP(MXPROP), IDCMO(MXJOB), IFJ2, IFJZ, IPUSED(MXPROP), &
                     IROOT1(mxRoot), IRREP(MXJOB), ISOCMP(MXPROP), ISTAT(MXJOB), ISTATE1, ISTATE2, ITOC15(30), L_Eff, LOOPDIVIDE, &
                     LOOPMAX, LROT1, LSYM1, LSYM2, LUEIG, LUEXC, LUIPH, LUMCK, LUONE, LUORD, LUTDM, LUTOM, MLTPLT(MXJOB), MPLET1, &
                     MULTIP, NACTE(MXJOB), NACTE1, NASH1(8), NATens_Calc, NATOMS, NBAS1(8), NBINA, NBSTEP, NCI1, NCI2, &
                     NCONF(MXJOB), NCONF1, NCOUP, NDEL1(8), NDET(MXJOB), NELE3(MXJOB), NELE31, NFRO1(8), NHOL11, NHOLE1(MXJOB), &
                     NISH1(8), NJOB, NPNMR_Calc, NPROP, nQuad, NRNATO, NROOT1, NROOTS(MXJOB), NRS11(8), NRS21(8), NRS31(8), &
                     Nscreen, NSOPR, NSOTHR_PRT, NSTAT(MXJOB), NSTATE, NSYM1, NTP, NTS, NTSTEP, OCAN, SODIAGNSTATE = 0, &
                     SONATNSTATE = 0, SONTOSTATES = 0
real(kind=wp) :: ALPHZ, BANGRES, BETAE, BINCRE, BSTART, CITHR, COOR(3,MXATOM), DEGEN_ETHR, dmpk, EMIN, EPRTHR, ERFNUC, OSTHR_DIPR, &
                 OSTHR_QIPR, PNUC(MXPROP) = Zero, PORIG(3,MXPROP) = Zero, RSTHR, SOTHR_PRT, TDIPMIN, TINCRE, TMAXP, TMAXS, &
                 TMGr_thrs, TMINP, TMINS, TOLERANCE, TSTART
logical(kind=iwp) :: AutoSelect_GFac, BINA, ChkHop, CIH5, DCHS, DIPR, Do_Pol, Do_SK, Do_TMOM, DOCD, DoGSOR, DQVD, DYSEXPORT, DYSO, &
                     Force_NON_AO_TDM, GNuc_set, HAVE_DIAG, HAVE_HEFF, HOP, HypF_rms_Req, IFARGU, IFCURD, IfDCpl, IFEJOB, IFGCAL, &
                     IFGTCALSA, IFGTSHSA, IFHAM, IFHCOM, IFHDIA, IFHEFF, IFHEXT, IFMCAL, IfNTO, IFSHFT, IFSO, IFTDM, IFTRD1, &
                     IFTRD2, IFVANVLECK, IFXCAL, LHAMI, LPRPR, NATO, NMass_set, NOHAM, NOSO, NSpin_set, ONLY_OVERLAPS, PRCI, &
                     PRDIPCOM, PRDIPVEC, PRMEE, PRMER, PRMES, PRORB, PRRAW, PRSXY, PRTRA, PRWEIGHT, PRXVE, PRXVR, PRXVS, QDPT2EV, &
                     QDPT2SC, QIALL, QIPR, REDUCELOOP, RFpert, RHODyn, RSPR, SaveDens, SECOND_TIME, TDYS, ToFile, TRACK
character(len=LenIn+8) :: bNAME(mxOrb)
character(len=128) :: JBNAME(MXJOB), MINAME(MXJOB)
character(len=16) :: OCAA(20)
character(len=8) :: FnEig, FnToM, PNAME(MXPROP), PTYPE(MXPROP), RASTYP(MXJOB), SOPRNM(MXPROP), &
                    SOPRTP(MXPROP)
character(len=4) :: TITLE1(18,mxTit)
character(len=2) :: HEAD1(72)
integer(kind=iwp), allocatable :: AngMom_idx(:), ASD_idx(:,:), LCSTATES(:), NucMass(:), PSO_idx(:,:), SODIAG(:), SONAT(:), &
                                  SONTO(:,:)
real(kind=wp), allocatable :: GNuc(:), HEff(:,:), NucSpin(:), RefEne(:)
logical(kind=iwp), allocatable :: Atens_Req(:), HypoIso(:), pNMR_req(:)

public :: ALGO, AlphZ, AngMom_idx, ASD_idx, Atens_Req, AutoSelect_GFac, BAngRes, BetaE, BINA, BIncre, bNAME, BStart, ChkHop, CIH5, &
          CITHR, Coor, DCHO, DCHS, DEGEN_ETHR, DIPR, dmpk, Do_Pol, Do_SK, DO_TMOM, DoCD, DOGSOR, DQVD, DYSEXPORT, DYSEXPSF, &
          DYSEXPSO, DYSO, EMin, EPRThr, ERFNuc, FnEig, FnTOM, FORCE_NON_AO_TDM, GNuc, GNuc_set, HAVE_DIAG, HAVE_HEFF, HEAD1, HEff, &
          HOP, HypF_rms_Req, HypoIso, IBINA, ICOMP, IDCMO, IfArgu, IfCurd, IFDCPL, IFEJOB, IFGCAL, IFGTCALSA, IFGTSHSA, IFHAM, &
          IFHCOM, IFHDIA, IFHEFF, IFHEXT, IfJ2, IfJz, IFMCAL, IFNTO, IFSHFT, IFSO, IfTDM, IfTrD1, IFTRD2, IfvanVleck, IFXCAL, &
          IPUSED, IROOT1, IRREP, ISOCMP, ISTAT, ISTATE1, ISTATE2, iToc15, JBNAME, L_Eff, LCSTATES, LHAMI, LOOPDIVIDE, LOOPMAX, &
          LPRPR, LROT1, lSym1, lSym2, LuEig, LuExc, LuIph, LuMck, LuOne, LuOrd, LuTDM, LUTOM, MINAME, MLTPLT, MORSBITS, MPLET1, &
          MULTIP, MXJOB, MXPROP, NACTE, NACTE1, NASH1, NATens_Calc, NATO, nAtoms, NBAS1, NBINA, NBSTep, nCI1, nCI2, NCONF, NCONF1, &
          NCOUP, NDEL1, NDET, NELE3, NELE31, NFRO1, NHOL11, NHOLE1, NISH1, NJOB, NMass_set, NOHAM, NOSO, NPNMR_Calc, NPROP, NQUAD, &
          NrNATO, NROOT1, NROOTS, NRS11, NRS21, NRS31, Nscreen, NSOPR, NSOThr_Prt, NSpin_set, NSTAT, NSTATE, NSYM1, NTP, NTS, &
          nTStep, NucMass, NucSpin, OCAA, OCAN, ONLY_OVERLAPS, OSThr_DiPr, OSThr_QIPR, PNAME, pNMR_req, PNUC, PORIG, PRCI, &
          PRDIPCOM, PrDipVec, PRMEE, PRMER, PRMES, PRORB, PrRaw, PRSXY, PRTRA, PrWeight, PRXVE, PRXVR, PRXVS, PSO_idx, PTYPE, &
          QDPT2EV, QDPT2SC, QIAll, QIPR, RASTYP, REDUCELOOP, RefEne, RFPert, RhoDyn, RSPR, RSThr, SAVEDENS, SECOND_TIME, SODIAG, &
          SODIAGNSTATE, SONAT, SONATNSTATE, SONTO, SONTOSTATES, SOPRNM, SOPRTP, SOThr_Prt, TDipMin, TDYS, TIncre, TITLE1, TMAXP, &
          TMaxs, TMGR_Thrs, TMINP, TMins, ToFile, Tolerance, TRACK, TStart

end module Cntrl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dgeSub(A,LDA,FORMA,B,LDB,FORMB,C,LDC,M,N)
! MATRIX subtraction FOR GENERAL MATRICES

#include "intent.fh"

use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: A(*), B(*)
character, intent(in) :: FORMA, FORMB
integer(kind=iwp), intent(in) :: LDA, LDB, LDC, M, N
real(kind=wp), intent(_OUT_) :: C(*)
integer(kind=iwp) :: iCol, iRow

if ((FORMA == 'N') .and. (FORMB == 'N')) then
  do iRow=0,m-1
    do iCol=0,n-1
      c(iRow+iCol*ldc+1) = a(iRow+iCol*lda+1)-b(iRow+iCol*ldb+1)
    end do
  end do
else if ((FORMA == 'T') .and. (FORMB == 'N')) then
  do iRow=0,m-1
    do iCol=0,n-1
      c(iRow+iCol*ldc+1) = a(iCol+iRow*lda+1)-b(iRow+iCol*ldb+1)
    end do
  end do
else if ((FORMA == 'N') .and. (FORMB == 'T')) then
  do iRow=0,m-1
    do iCol=0,n-1
      c(iRow+iCol*ldc+1) = a(iRow+iCol*lda+1)-b(iCol+iRow*ldb+1)
    end do
  end do
else if ((FORMA == 'T') .and. (FORMB == 'T')) then
  do iRow=0,m-1
    do iCol=0,n-1
      c(iRow+iCol*ldc+1) = a(iCol+iRow*lda+1)-b(iCol+iRow*ldb+1)
    end do
  end do
else
  write(u6,*) 'Error when calling DGESUB, forma=',FORMA,'   formb=',FORMB
  call Abend()
end if

return

end subroutine dgeSub

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine GetUmat_Localisation(U,C,S,X,Scr,lScr,nBas,nOrb)
C
C     Author: T.B. Pedersen
C
C     Purpose: compute transformation matrix U=C^TSX.
C
      Implicit None
      Real*8  U(*), C(*), S(*), X(*)
      Integer lScr
      Real*8  Scr(lScr)
      Integer nBas, nOrb

      Character*80 Txt
      Character*20 SecNam
      Parameter (SecNam = 'GetUmat_Localisation')

      Real*8 d0, d1
      Parameter (d0 = 0.0d0, d1 = 1.0d0)

      Integer Need

      If (nOrb.lt.1 .or. nBas.lt.1) Return

      Need = nBas*nOrb
      If (lScr .lt. Need) Then
         Write(Txt,'(A,I9,A,I9)')
     &   'lScr =',lScr,'     Need =',Need
         Call SysAbendMsg(SecNam,
     &                   'Insufficient dimension of scratch array!',Txt)
      End If

      Call DGEMM_('N','N',nBas,nOrb,nBas,d1,S,nBas,X,nBas,d0,Scr,nBas)
      Call DGEMM_('T','N',nOrb,nOrb,nBas,d1,C,nBas,Scr,nBas,d0,U,nOrb)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Index_Functions

use Definitions, only: iwp

implicit none
private

public :: C3_Ind, C3_Ind3, C_Ind, C_Ind3, C_Ind3_Rev, iTri, iTri_Rev, nTri3_Elem, nTri3_Elem1, nTri_Elem, nTri_Elem1

#include "macros.fh"

contains

! Index for a total order of l=lx+ly+lz, sorted with priority lx > ly > lz
! e.g., for l=2 this gives:
!
!   lx ly lz  C_Ind
!   ---------------
!    2  0  0    1
!    1  1  0    2
!    1  0  1    3
!    0  2  0    4
!    0  1  1    5
!    0  0  2    6
pure function C_Ind(l,lx,lz)
  integer(kind=iwp) :: C_Ind
  integer(kind=iwp), intent(in) :: l, lx, lz
  C_Ind = (l-lx)*(l-lx+1)/2+lz+1
end function C_Ind

! Same as C_Ind, but from lx, ly, lz directly
pure function C_Ind3(lx,ly,lz)
  integer(kind=iwp) :: C_Ind3
  integer(kind=iwp), intent(in) :: lx, ly, lz
  unused_var(lx)
  C_Ind3 = (ly+lz)*(ly+lz+1)/2+lz+1
end function C_Ind3

! Cumulative C_Ind, including all previous l values
pure function C3_Ind(l,lx,lz)
  integer(kind=iwp) :: C3_Ind
  integer(kind=iwp), intent(in) :: l, lx, lz
  C3_Ind = l*(l+1)*(l+2)/6+(l-lx)*(l-lx+1)/2+lz+1
end function C3_Ind

! Same as C3_Ind, but from lx, ly, lz directly
pure function C3_Ind3(lx,ly,lz)
  integer(kind=iwp) :: C3_Ind3
  integer(kind=iwp), intent(in) :: lx, ly, lz
  C3_Ind3 = (lx+ly+lz)*(lx+ly+lz+1)*(lx+ly+lz+2)/6+(ly+lz)*(ly+lz+1)/2+lz+1
end function C3_Ind3

! Inverse of C_Ind3: from the index and l, return lx, ly, lz
pure function C_Ind3_Rev(lxyz,l)
  use Constants, only: Seven, Eight
  integer(kind=iwp) :: C_Ind3_Rev(3)
  integer(kind=iwp), intent(in) :: lxyz, l
  integer(kind=iwp) :: lx, ly, lyz, lz
  lyz = (int(sqrt(Eight*lxyz-Seven))-1)/2
  lz = lxyz-lyz*(lyz+1)/2-1
  ly = lyz-lz
  lx = l-lyz
  C_Ind3_Rev(:) = [lx,ly,lz]
end function C_Ind3_Rev

! Number of elements in a triangular matrix of side n
!
!   n  nTri_Elem
!   ------------
!   0     0
!   1     1
!   2     3
!   3     6
!   4    10
pure function nTri_Elem(n)
  integer(kind=iwp) :: nTri_Elem
  integer(kind=iwp), intent(in) :: n
  nTri_Elem = n*(n+1)/2
end function nTri_Elem

! Same as nTri_Elem, but with n=l+1
pure function nTri_Elem1(l)
  integer(kind=iwp) :: nTri_Elem1
  integer(kind=iwp), intent(in) :: l
  nTri_Elem1 = (l+1)*(l+2)/2
end function nTri_Elem1

! Like nTri_Elem, but for 3-dimensional arrays
!
!   n  nTri3_Elem
!   -------------
!   0     0
!   1     1
!   2     4
!   3    10
!   4    20
pure function nTri3_Elem(n)
  integer(kind=iwp) :: nTri3_Elem
  integer(kind=iwp), intent(in) :: n
  nTri3_Elem = n*(n+1)*(n+2)/6
end function nTri3_Elem

! Same as nTri3_Elem, but with n=l+1
pure function nTri3_Elem1(l)
  integer(kind=iwp) :: nTri3_Elem1
  integer(kind=iwp), intent(in) :: l
  nTri3_Elem1 = (l+1)*(l+2)*(l+3)/6
end function nTri3_Elem1

! Index of element i,j in a triangularly stored matrix
pure function iTri(i,j)
  integer(kind=iwp) :: iTri
  integer(kind=iwp), intent(in) :: i, j
  if (j > i) then
    iTri = j*(j-1)/2+i
  else
    iTri = i*(i-1)/2+j
  end if
end function iTri

! Inverse of iTri: from the index, return i and j
pure function iTri_Rev(ij)
  use Constants, only: Seven, Eight
  integer(kind=iwp) :: iTri_Rev(2)
  integer(kind=iwp), intent(in) :: ij
  integer(kind=iwp) :: i, j
  i = (int(sqrt(Eight*ij-Seven))+1)/2
  j = ij-i*(i-1)/2
  iTri_Rev(:) = [i,j]
end function iTri_Rev

end module

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_UnsetSh(irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: Unset data in localdf_bas.fh
C
      Implicit None
      Integer irc
#include "localdf_bas.fh"

      ! set return code
      irc=0

      ! Deallocate iShlSO
      Call GetMem('LDF_iShlSO','Free','Inte',ip_iShlSO,l_iShlSO)

      ! Deallocate nBasSh
      Call GetMem('LDF_nBasSh','Free','Inte',ip_nBasSh,l_nBasSh)

      ! Deallocate iSOShl
      Call GetMem('LDF_iSOShl','Free','Inte',ip_iSOShl,l_iSOShl)

      ! Zero variables
      nBas_Auxiliary=0
      nBas_Valence=0
      nShell_Auxiliary=0
      nShell_Valence=0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine seg_drt()

use gugaci_global, only: ihy, ipae, iy, jj, jj_sub, jpad, jpae, jphy, max_wei, ndim, no, nohy, norb_act, norb_dz, norb_inn
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i, ihypos, ij1, in_, iw, j(4), j1, j2, j3, j4, jde, jp, jp0, jpe, jpend, jpmax, jps, jpsta, lr
integer(kind=iwp), allocatable :: jpihy(:)

jpmax = no(norb_inn+1)
iy(:,:) = 0
ihy(:) = 0
jj_sub(:,:) = 0
jphy(:) = 0

iy(1,jpad) = 1
ndim = 0
if (norb_act == 0) then
  if (jpad /= ipae) return
  ndim = 1
  jj_sub(1,jpad) = jpae
  return
end if
do i=1,4
  j(i) = jj(i,jpad)
  if (j(i) /= 0) then
    iy(1,j(i)) = 1
    jj_sub(i,jpad) = j(i)
  end if
end do

jps = 1
jpe = no(norb_inn+1)
do jp=jps,jpe
  jj_sub(1:4,jp) = 0
  if (iy(1,jp) == 0) cycle
  do i=1,4
    j(i) = jj(i,jp)
    if (j(i) == 0) cycle
    iy(1,j(i)) = 1
    jj_sub(i,jp) = j(i)
  end do
end do

if (iy(1,jpae) == 0) then
  ndim = 0
  nohy = 0
  return
end if

iy(1,1:jpmax) = 0
iy(1,jpae) = 1

do jp0=no(norb_inn-1)+1,no(norb_inn)
  if (jj_sub(1,jp0) /= jpae) jj_sub(1,jp0) = 0
  if (jj_sub(2,jp0) /= jpae) jj_sub(2,jp0) = 0
  if (jj_sub(3,jp0) /= jpae) jj_sub(3,jp0) = 0
  if (jj_sub(4,jp0) /= jpae) jj_sub(4,jp0) = 0
end do
do lr=norb_inn-1,norb_dz+1,-1
  jps = no(lr)+1
  jpe = no(lr+1)
  do jde=jps,jpe
    j1 = jj_sub(1,jde)
    j2 = jj_sub(2,jde)
    j3 = jj_sub(3,jde)
    j4 = jj_sub(4,jde)
    iy(1,jde) = iy(1,j1)+iy(1,j2)+iy(1,j3)+iy(1,j4)
    if (iy(1,jde) /= 0) then
      if ((j2 /= 0) .and. (iy(1,j2) /= 0)) iy(2,jde) = iy(1,j1)
      if ((j3 /= 0) .and. (iy(1,j3) /= 0)) iy(3,jde) = iy(1,j1)+iy(1,j2)
      if ((j4 /= 0) .and. (iy(1,j4) /= 0)) iy(4,jde) = iy(1,jde)-iy(1,j4)
      !if (jde == 1) continue
    else
      do jp0=no(lr-1)+1,no(lr)
        if (jj_sub(1,jp0) == jde) jj_sub(1,jp0) = 0
        if (jj_sub(2,jp0) == jde) jj_sub(2,jp0) = 0
        if (jj_sub(3,jp0) == jde) jj_sub(3,jp0) = 0
        if (jj_sub(4,jp0) == jde) jj_sub(4,jp0) = 0
      end do
    end if
  end do
end do
lr = norb_dz+1
jde = jpad
j1 = jj_sub(1,jde)
j2 = jj_sub(2,jde)
j3 = jj_sub(3,jde)
j4 = jj_sub(4,jde)
iy(1,jde) = iy(1,j1)+iy(1,j2)+iy(1,j3)+iy(1,j4)
if (iy(1,jde) /= 0) then
  if ((j2 /= 0) .and. (iy(1,j2) /= 0)) iy(2,jde) = iy(1,j1)
  if ((j3 /= 0) .and. (iy(1,j3) /= 0)) iy(3,jde) = iy(1,j1)+iy(1,j2)
  if ((j4 /= 0) .and. (iy(1,j4) /= 0)) iy(4,jde) = iy(1,jde)-iy(1,j4)
  !if (jde == 1) continue
else
  do jp0=no(lr)+1,no(lr+1)
    if (jj_sub(1,jp0) == jde) jj_sub(1,jp0) = 0
    if (jj_sub(2,jp0) == jde) jj_sub(2,jp0) = 0
    if (jj_sub(3,jp0) == jde) jj_sub(3,jp0) = 0
    if (jj_sub(4,jp0) == jde) jj_sub(4,jp0) = 0
  end do
end if

ndim = iy(1,jpad)
!=======================================================================
jphy(jpad) = 1
ihy(1) = 1
ihy(2) = 0

ihypos = 3
do i=1,4
  j(i) = jj_sub(i,jpad)
  if (j(i) == 0) cycle
  iw = 0
  if (i /= 1) iw = iy(i,jpad)
  jphy(j(i)) = 1
  ihy(ihypos) = 1
  ihy(ihypos+1) = iw
  ihypos = ihypos+2
end do

call mma_allocate(jpihy,max_wei,label='jpihy')
lr = norb_dz+1
jpsta = no(lr)+1
jpend = jpae
do jp=jpsta,jpend
  if (iy(1,jp) == 0) cycle
  call ajphy(jp,in_,jpihy)
  jphy(jp) = ihypos
  ihy(ihypos) = in_
  do ij1=1,in_
    ihypos = ihypos+1
    ihy(ihypos) = jpihy(ij1)
  end do
  ihypos = ihypos+1
end do
nohy = ihypos-1
!write(u6,'(3x,4i10)') jpad,jpae,ndim,nohy
call mma_deallocate(jpihy)

return

end subroutine seg_drt

function iwalk_ad(jdbl,jext,iwa,iwd)

use gugaci_global, only: iseg_downwei, iw_sta, jpad_upwei, log_prod
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iwalk_ad
integer(kind=iwp), intent(in) :: jdbl, jext, iwa, iwd
integer(kind=iwp) :: ioff, isegdown, iwup

if (log_prod == 3) then
  ! mrpt2
  ioff = 0
  if (jext == 1) ioff = iw_sta(jdbl,jext)
  iwup = jpad_upwei(jdbl)
  isegdown = iseg_downwei(jext)
  iwalk_ad = (iwa*iwup+iwd)*isegdown+ioff
else
  ! mrci
  iwup = jpad_upwei(jdbl)
  isegdown = iseg_downwei(jext)
  iwalk_ad = (iwa*iwup+iwd)*isegdown+iw_sta(jdbl,jext)
end if

return

end function iwalk_ad

!function iwalk_ad_mrso(jdbl,jext,iwa,iwd)
!
!use gugaci_global, only: iseg_downwei, jpad_upwei
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp) :: iwalk_ad_mrso
!integer(kind=iwp), intent(in) :: jdbl, jext, iwa, iwd
!integer(kind=iwp) :: isegdown, iwup
!
!iwup = jpad_upwei(jdbl)
!isegdown = iseg_downwei(jext)
!iwalk_ad_mrso = (iwa*iwup+iwd)*isegdown+isub_sta(jdbl,jext)
!
!return
!
!end function iwalk_ad_mrso

subroutine ajphy(jp,in_,jpihy)

use gugaci_global, only: iy, jj, jj_sub, jpad, kk, max_node, max_wei, no, norb_dz
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: jp
integer(kind=iwp), intent(inout) :: in_, jpihy(max_wei)
integer(kind=iwp) :: i, idr, j, jpe, jpn, jy, l, lr, nn
integer(kind=iwp), allocatable :: iin(:)

if (jp == jpad) then
  in_ = 1
  jpihy(1) = 0
  return
end if
call mma_allocate(iin,[0,max_node],label='iin')
iin(0) = 0
lr = kk(jp)
!write(u6,*) '  ajphy,jp,start,end',jp,no(nst-lr)+1,no(nst-lr+1)
jpe = no(lr+1)
iin(jpad:jpe) = 0
iin(jp) = 1
do jpn=no(lr-1),jpad,-1
  iin(jpn) = iin(jj_sub(1,jpn))+iin(jj_sub(2,jpn))+iin(jj_sub(3,jpn))+iin(jj_sub(4,jpn))
end do
in_ = iin(jpad)
idr = 0
do l=1,in_
  jpihy(l) = 0
  jy = l
  nn = jpad
  do i=norb_dz+1,lr-1
    do j=1,4
      if (jj(j,nn) == 0) cycle
      if (jy <= iin(jj_sub(j,nn))) then
        idr = j
        exit
      end if
      jy = jy-iin(jj_sub(j,nn))
    end do
    if (idr /= 1) jpihy(l) = jpihy(l)+iy(idr,nn)
    nn = jj_sub(idr,nn)
  end do
end do
call mma_deallocate(iin)

return

end subroutine ajphy

function K_COE(JBL,JBR,IDDL,IDDR)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: k_coe
integer(kind=iwp), intent(in) :: jbl, jbr, iddl, iddr
integer(kind=iwp) :: idl, idr

K_COE = 0
IDL = IDDL-1
IDR = IDDR-1
if ((IDL == 3) .and. (IDR == 3)) K_COE = 200
if ((IDL == 1) .and. (IDR == 1) .and. (JBR-JBL == -1)) K_COE = -1
if ((IDL == 1) .and. (IDR == 1) .and. (JBR-JBL == 1)) K_COE = 100
if ((IDL == 2) .and. (IDR == 2) .and. (JBR-JBL == 1)) K_COE = -1
if ((IDL == 2) .and. (IDR == 2) .and. (JBR-JBL == -1)) K_COE = 100
if ((IDL == 2) .and. (IDR == 1)) K_COE = JBR
if ((IDL == 1) .and. (IDR == 2)) K_COE = -JBR-2

return

end function K_COE

subroutine copy_to_drtl()

use gugaci_global, only: ihy, ihyl, ipae, ipael, iy, iyl, jj_sub, jjl_sub, jpad, jpadl, jpae, jpael, jphy, jphyl, no, nohy, norb_inn

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: knode, nod

jpadl = jpad
jpael = jpae
ipael = ipae
ihyl(1:nohy) = ihy(1:nohy)

knode = no(norb_inn+1)
do nod=1,knode
  jjl_sub(1:4,0:knode) = jj_sub(1:4,0:knode)
  iyl(1:4,nod) = iy(1:4,nod)
  jphyl(nod) = jphy(nod)
end do

return

end subroutine copy_to_drtl

!subroutine get_jpadty(jp,ity,jp_ms)
!
!use gugaci_global, only: ns_sm
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: jp
!integer(kind=iwp), intent(out) :: ity, jp_ms
!integer(kind=iwp) :: jpp
!
!if (jp == 1) then
!  ity = 1
!  jp_ms = ns_sm
!  return
!end if
!jpp = jp+15
!if (mod(jpp,8) == 0) then
!  ity = jpp/8-1
!  jp_ms = 8
!else
!  ity = jpp/8
!  jp_ms = mod(jpp,8)
!end if
!
!return
!
!end subroutine get_jpadty

subroutine get_jpty(jpadlr,jptyl,jptyr)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: jpadlr
integer(kind=iwp), intent(out) :: jptyl, jptyr

select case (jpadlr)
  case default ! (1)
    jptyl = 4
    jptyr = 4
  case (2)
    jptyl = 4
    jptyr = 3
  case (3)
    jptyl = 3
    jptyr = 4
  case (4)
    jptyl = 4
    jptyr = 6
  case (5)
    jptyl = 6
    jptyr = 4
  case (6)
    jptyl = 4
    jptyr = 2
  case (7)
    jptyl = 2
    jptyr = 4
  case (8)
    jptyl = 4
    jptyr = 5
  case (9)
    jptyl = 5
    jptyr = 4
  case (10)
    jptyl = 4
    jptyr = 1
  case (11)
    jptyl = 3
    jptyr = 3
  case (12)
    jptyl = 6
    jptyr = 6
  case (13)
    jptyl = 3
    jptyr = 2
  case (14)
    jptyl = 2
    jptyr = 3
  case (15)
    jptyl = 6
    jptyr = 5
  case (16)
    jptyl = 5
    jptyr = 6
  case (17)
    jptyl = 3
    jptyr = 1
  case (18)
    jptyl = 6
    jptyr = 1
  case (19)
    jptyl = 2
    jptyr = 2
  case (20)
    jptyl = 5
    jptyr = 5
  case (21)
    jptyl = 2
    jptyr = 5
  case (22)
    jptyl = 5
    jptyr = 2
  case (23)
    jptyl = 2
    jptyr = 1
  case (24)
    jptyl = 5
    jptyr = 1
  case (25)
    jptyl = 1
    jptyr = 1
end select

return

end subroutine get_jpty

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine priwel(k,alfa,beta,r0,a,gri,nz,isum,grin)

use welcom, only: iPot3, kMax
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: k, nz, iSum
real(kind=wp), intent(in) :: alfa(nz), Beta, r0, a(nz)
real(kind=wp), intent(inout) :: gri(nz,isum)
real(kind=wp), intent(out) :: grin(nz,0:k,k/2+1,k/4+1)
integer(kind=iwp) :: i, iDiv, indst, iPot3i, iv(kmax), ix, ix2, ixS, ixyS, ixyz, iy, iy2, iyS, iz, j, jj, l

call binte(k,alfa,beta,r0,a,grin,nz)
!call RecPrt(' In PriWel: Grin',' ',Grin,nz,(k+1)*(k/2+1)*(k/4+1))

! distribute the integrals into gri

indst = 1
gri(:,1) = grin(:,0,1,1)
do i=1,k
  ipot3i = ipot3(i)
  gri(:,indst+1:indst+iPot3i) = Zero
  do j=1,ipot3i
    jj = j
    do l=i,1,-1
      idiv = ipot3(l-1)
      ixyz = (jj-1)/idiv+1
      iv(l) = ixyz
      jj = jj-(ixyz-1)*idiv
    end do

    ! the potency vector for this integral is now ready
    ! ... now analyze it

    ix = 0
    iy = 0
    iz = 0
    do l=1,i
      if (iv(l) == 1) ix = ix+1
      if (iv(l) == 2) iy = iy+1
      if (iv(l) == 3) iz = iz+1
    end do
    ix2 = (ix/2)*2
    if (ix2 /= ix) cycle
    iy2 = (iy/2)*2
    if (iy2 /= iy) cycle
    ixs = max(ix,iy)
    iys = min(ix,iy)
    ixys = (ixs+iys)/2+1
    iys = iys/2+1
    gri(:,j+indst) = grin(:,i,ixys,iys)
  end do
  indst = indst+ipot3i
end do
!call RecPrt(' In PriWel:gri',' ',gri,nz,isum)

return

end subroutine priwel

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TR1CTL(Ovlp,HOne,Kine,CMO)
*
*     Objective: Control section for transformation of one-electron
*                integrals (effective one electron Hamiltonian and
*                kinetic energy )
*
      !> module dependencies
#ifdef _HDF5_QCM_
      use hdf5_utils
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "motra_global.fh"
#include "trafo_motra.fh"
#include "files_motra.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#ifdef _HDF5_QCM_
      real*8,  allocatable :: writebuf(:,:)
#endif
*
      Real*8 Ovlp(*), HOne(*), Kine(*), CMO(*)
*
*
*     Initialize LUONEMO
*
      CALL DANAME(LUONEMO,FNONEMO)
      IDISK=0
* Provisionally initialize ECOR to prevent false alarms from
* automatic detection of uninitialized variables.
      ECOR=0.0D0
      CALL WR_MOTRA_Info(LUONEMO,1,iDisk,
     &                   TCONEMO,64,ECOR,NSYM,
     &                   NBAS,NORB,NFRO,NDEL,8,BSLBL,LENIN8*mxOrb)
*
*     Write Mo coefficients to disc
*
      TCONEMO(1)=IDISK
      CALL dDAFILE(LUONEMO,1,CMO,NTOT2,IDISK)
*
*     Generate Fock-matrix for inactive orbitals
*     and compute the total core energy
*
      CALL GETMEM('FLT','ALLO','REAL',LWFLT,NTOT1)
      CALL GETMEM('DLT','ALLO','REAL',LWDLT,NTOT1)
      CALL GETMEM('FSQ','ALLO','REAL',LWFSQ,NTOT2)
      CALL GETMEM('DSQ','ALLO','REAL',LWDSQ,NTOT2)
      CALL DCOPY_(NTOT1,HONE,1,WORK(LWFLT),1)
      CALL DCOPY_(NTOT2,[0.0D0],0,WORK(LWFSQ),1)
      CALL DCOPY_(NTOT1,[0.0D0],0,WORK(LWDLT),1)
      CALL DCOPY_(NTOT2,[0.0D0],0,WORK(LWDSQ),1)
      ECOR=0.0D0
      CALL FCIN(WORK(LWFLT),NTOT1,WORK(LWDLT),
     &          WORK(LWFSQ),WORK(LWDSQ),ECOR,CMO)
      CALL GETMEM('DSQ','FREE','REAL',LWDSQ,NTOT2)
      CALL GETMEM('FSQ','FREE','REAL',LWFSQ,NTOT2)
      CALL GETMEM('DLT','FREE','REAL',LWDLT,NTOT1)
*
      ECOR=POTNUC+ECOR
      IF ( IPRINT.GE.5 .OR. DEBUG.NE.0 ) THEN
         WRITE(6,'(6X,A,E20.10)') 'TOTAL CORE ENERGY:',ECOR
      ENDIF
*
*     Transform one-electron Fock matrix
*
      CALL GETMEM('FMO','ALLO','REAL',LWFMO,NORBTT)
      CALL GETMEM('TMP','ALLO','REAL',LWTMP,2*N2MAX)
      CALL DCOPY_(NORBTT,[0.0D0],0,WORK(LWFMO),1)
      CALL DCOPY_(2*N2MAX,[0.0D0],0,WORK(LWTMP),1)
      CALL TRAONE_MOTRA(WORK(LWFLT),WORK(LWFMO),WORK(LWTMP),CMO)
      IF ( IPRINT.GE.5 .OR. DEBUG.NE.0 ) THEN
        WRITE(6,'(6X,A)') 'Fock matrix in MO basis'
        ISTLT=0
        DO ISYM=1,NSYM
          IF ( NORB(ISYM).GT.0 ) THEN
            WRITE(6,'(6X,A,I2)')' symmetry species:',ISYM
            CALL TRIPRT(' ',' ',WORK(LWFMO+ISTLT),NORB(ISYM))
            ISTLT=ISTLT+NORB(ISYM)*(NORB(ISYM)+1)/2
          END IF
        END DO
      END IF

#ifdef _HDF5_QCM_
      if(ihdf5 == 1)then
        msym = nsym
        !> put data to file
        datadim(1)    = 1; datadim_bound = 1
        call hdf5_put_data(file_id(1),"ecore ",datadim,ecor)
        call hdf5_put_data(file_id(1),"norbtt",datadim,norbtt)
        call hdf5_put_data(file_id(1),"nsym  ",datadim,msym)
        datadim(1)   = nsym
        allocate(writebuf(nsym,3)); writebuf = -1
        do i = 1, nsym
          writebuf(i,1) = norb(i)
          writebuf(i,2) = nfro(i)
          writebuf(i,3) = ndel(i)
        end do
        call hdf5_put_data(file_id(1),"norb  ",datadim,writebuf(1,1))
        call hdf5_put_data(file_id(1),"nfro  ",datadim,writebuf(1,2))
        call hdf5_put_data(file_id(1),"ndel  ",datadim,writebuf(1,3))
        deallocate(writebuf)
        datadim(1)   = norbtt
        call hdf5_put_data(file_id(1),"FockMO",datadim,
     &                     work(lwfmo:lwfmo+norbtt-1))
      end if
#endif

      TCONEMO(2)=IDISK
      CALL dDAFILE(LUONEMO,1,WORK(LWFMO),NORBTT,IDISK)
      CALL GETMEM('TMP','FREE','REAL',LWTMP,2*N2MAX)
      CALL GETMEM('FMO','FREE','REAL',LWFMO,NORBTT)
      CALL GETMEM('FLT','FREE','REAL',LWFLT,NTOT1)
*
*     Transform kinetic energy matrix
*
      IRC=0
      CALL GETMEM('KAO','ALLO','REAL',LWKAO,NTOT1)
      CALL GETMEM('KMO','ALLO','REAL',LWKMO,NORBTT)
      CALL GETMEM('TMP','ALLO','REAL',LWTMP,2*N2MAX)
      CALL DCOPY_(NORBTT,[0.0D0],0,WORK(LWKMO),1)
      CALL DCOPY_(2*N2MAX,[0.0D0],0,WORK(LWTMP),1)
      CALL DCOPY_(NTOT1,KINE,1,WORK(LWKAO),1)
      CALL TRAONE_MOTRA(WORK(LWKAO),WORK(LWKMO),WORK(LWTMP),CMO)
      IF ( IPRINT.GE.5 .OR. DEBUG.NE.0 ) THEN
        WRITE(6,'(6X,A)') 'Kinetic integrals in MO basis'
        ISTLT=0
        DO ISYM=1,NSYM
          IF ( NORB(ISYM).GT.0 ) THEN
            WRITE(6,'(6X,A,I2)')' symmetry species:',ISYM
            CALL TRIPRT(' ',' ',WORK(LWKMO+ISTLT),NORB(ISYM))
            ISTLT=ISTLT+NORB(ISYM)*(NORB(ISYM)+1)/2
          END IF
        END DO
      END IF
      TCONEMO(3)=IDISK
      CALL dDAFILE(LUONEMO,1,WORK(LWKMO),NORBTT,IDISK)
      CALL GETMEM('TMP','FREE','REAL',LWTMP,2*N2MAX)
      CALL GETMEM('KMO','FREE','REAL',LWKMO,NORBTT)
      CALL GETMEM('KAO','FREE','REAL',LWKAO,NTOT1)
*
*     Copy overlap matrix to luonem
*
      CALL GETMEM('OVP','ALLO','REAL',LWOVP,NTOT1)
      CALL DCOPY_(NTOT1,OVLP,1,WORK(LWOVP),1)
      TCONEMO(4)=IDISK
      CALL dDAFILE(LUONEMO,1,WORK(LWOVP),NORBTT,IDISK)
      CALL GETMEM('OVP','FREE','REAL',LWOVP,NTOT1)
*
*     Create CIDATA and molecular orbital sections on LUONEM
*
      TCONEMO(5)=IDISK
      IDISK=0
      CALL WR_MOTRA_Info(LUONEMO,1,iDisk,
     &                   TCONEMO,64,ECOR,NSYM,
     &                   NBAS,NORB,NFRO,NDEL,8,BSLBL,LENIN8*mxOrb)
      CALL DACLOS(LUONEMO)
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_PRTRED(IOPT)
C
C     Purpose: print information about reduced set.
C
      use ChoSwp, only: nnBstRSh
#include "implicit.fh"
#include "choorb.fh"
#include "cholesky.fh"

      DIMENSION XBAS(8), XXBAS(8)

      INTEGER NSHP(2)
      LOGICAL CONTRIB(2)

      MULD2H(I,J)=IEOR(I-1,J-1)+1

      DO ISYM = 1,NSYM
         XBAS(ISYM) = DBLE(NBAS(ISYM))
      END DO

      XXBAST = 0.0D0
      DO ISYM = 1,NSYM
         XXBAS(ISYM) = 0.0D0
         DO ISYMB = 1,NSYM
            ISYMA = MULD2H(ISYMB,ISYM)
            IF (ISYMA .EQ. ISYMB) THEN
               XXBAS(ISYM) = XXBAS(ISYM)
     &                     + XBAS(ISYMA)*(XBAS(ISYMA) + 1.0D0)/2.0D0
            ELSE IF (ISYMA .GT. ISYMB) THEN
               XXBAS(ISYM) = XXBAS(ISYM) + XBAS(ISYMA)*XBAS(ISYMB)
            END IF
         END DO
         XXBAST = XXBAST + XXBAS(ISYM)
      END DO

      IF (IOPT .EQ. 1) THEN
         NRED = 1
      ELSE
         NRED = 2
      END IF

      DO IRED = 1,NRED
         NSHP(IRED) = 0
         DO ISHLAB = 1,NNSHL
            CONTRIB(IRED) = .FALSE.
            ISYM = 0
            DO WHILE ((.NOT.CONTRIB(IRED)) .AND. ISYM.LT.NSYM)
               ISYM = ISYM + 1
               IF (NNBSTRSH(ISYM,ISHLAB,IRED) .GT. 0) THEN
                  CONTRIB(IRED) = .TRUE.
               END IF
            END DO
            IF (CONTRIB(IRED)) THEN
               NSHP(IRED) = NSHP(IRED) + 1
            END IF
         END DO
      END DO

      CALL CHO_HEAD('Reduced Set Information','=',80,LUPRI)

      IF (NNSHL_TOT .EQ. 0) THEN
         PCT1 = 9.9D9
      ELSE
         PCT1 = 1.0D2*DBLE(NSHP(1))/DBLE(NNSHL_TOT)
      END IF
      IF (IOPT .EQ. 1) THEN
         WRITE(LUPRI,'(/,A,/,A)')
     &   'Sym.          Full   First Red. Set',
     &   '-----------------------------------'
         DO ISYM = 1,NSYM
            WRITE(LUPRI,'(I3,3X,F12.1,7X,I10)')
     &      ISYM,XXBAS(ISYM),NNBSTR(ISYM,1)
         END DO
         WRITE(LUPRI,'(A)')
     &   '-----------------------------------'
         WRITE(LUPRI,'(A,F12.1,7X,I10)')
     &   'Total:',XXBAST,NNBSTRT(1)
         WRITE(LUPRI,'(A)')
     &   '-----------------------------------'
         WRITE(LUPRI,'(/,A,I10,A,I10,A,F7.2,A)')
     &   'First Reduced Set:',NSHP(1),' of',NNSHL_TOT,
     &   ' shell pairs contribute (',PCT1,'%)'
      ELSE
         IF (NNSHL_TOT .EQ. 0) THEN
            PCT2 = 9.9D9
         ELSE
            PCT2 = 1.0D2*DBLE(NSHP(2))/DBLE(NNSHL_TOT)
         END IF
         WRITE(LUPRI,'(/,A,/,A,/,A)')
     &   '                          Reduced Set',
     &   'Sym.          Full      First    Current',
     &   '----------------------------------------'
         DO ISYM = 1,NSYM
            WRITE(LUPRI,'(I3,3X,F12.1,1X,I10,1X,I10)')
     &      ISYM,XXBAS(ISYM),NNBSTR(ISYM,1),NNBSTR(ISYM,2)
         END DO
         WRITE(LUPRI,'(A)')
     &   '----------------------------------------'
         WRITE(LUPRI,'(A,F12.1,1X,I10,1X,I10)')
     &   'Total:',XXBAST,NNBSTRT(1),NNBSTRT(2)
         WRITE(LUPRI,'(A)')
     &   '----------------------------------------'
         WRITE(LUPRI,'(/,A,I10,A,I10,A,F7.2,A)')
     &   'First Reduced Set:',NSHP(1),' of',NNSHL_TOT,
     &   ' shell pairs contribute (',PCT1,'%)'
         WRITE(LUPRI,'(A,I10,A,I10,A,F7.2,A)')
     &   'Curr. Reduced Set:',NSHP(2),' of',NNSHL_TOT,
     &   ' shell pairs contribute (',PCT2,'%)'
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine UpG_T2d (T2,dima,adda)
c
c        upgrade T2 (diagonal)
c
        implicit none
#include "chcc1.fh"
        integer dima,adda
        real*8 T2(1:dima*(dima+1)/2,1:no,1:no)
c
c        help var
        integer i,j,a,b,ab
c
        do j=1,no
        do i=1,no
          ab=0
          do a=1,dima
          do b=1,a
          ab=ab+1
            T2c(a+adda,b+adda,i,j)=T2(ab,i,j)
            T2c(b+adda,a+adda,j,i)=T2(ab,i,j)
          end do
          end do
        end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine INTX(FockI,Temp1,Temp2,Temp3,Temp4,Fock,rMo,loper,idisp)

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use MCLR_Data, only: CMO, DspVec, G1t, ipCM, ipMat, ipMatLT, nA, nB, nDens, SWLbl
use input_mclr, only: iMethod, nAsh, nBas, nIsh, nOrb, nSym, nTPert
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(out) :: FockI(nDens), Temp1(nDens), Temp2(nDens), Temp3(nDens), Temp4(nDens), Fock(nDens)
real(kind=wp), intent(_OUT_) :: rMO(*)
integer(kind=iwp), intent(in) :: lOper, iDisp
integer(kind=iwp) :: i, iOff, iOp, iOpt, iRC, iS, j, jDisp, jOff, jS, nSize, kDisp
real(kind=wp) :: rde, Origin(3)
character(len=8) :: Label

!***********************************************************************
if (nDens == 0) return
jDisp = DspVec(idisp)

!       x
! Read P
!
! Remember two-electron contributions are saved in MO base
! but one electron contributions is saved in AO base.

if (btest(ntpert(idisp),2)) then   ! 2 el contribution
  if (btest(ntpert(idisp),4)) then  ! from mckinley
    if (iMethod == 2) then

      !----------------------------------------------------------------*
      !
      ! RASSCF
      !
      !----------------------------------------------------------------*

      Label = 'TOTAL'
      iop = ibset(0,loper)
      irc = -1
      iopt = 0
      call dRdMck(iRC,iOpt,Label,jDisp,Fock,iop)
      if (iRc /= 0) then
        write(u6,*) 'IntX: Error reading MCKINT'
        write(u6,'(A,A)') 'Label=',Label
        call Abend()
      end if
      call ReLoad(Fock,loper+1,nbas,norb)

      Label = 'INACTIVE'
      iop = ibset(0,loper)
      irc = -1
      iopt = 0
      call dRdMck(iRC,iOpt,Label,jDisp,Focki,iop)
      if (iRc /= 0) then
        write(u6,*) 'IntX: Error reading MCKINT'
        write(u6,'(A,A)') 'Label=',Label
        call Abend()
      end if
      call ReLoad(Focki,loper+1,nbas,norb)

      Label = 'MOPERT'
      iop = ibset(0,loper)
      irc = -1
      iopt = 0
      call dRdMck(iRC,iOpt,Label,jDisp,rMO,iop)
      if (iRc /= 0) then
        write(u6,*) 'IntX: Error reading MCKINT'
        write(u6,'(A,A)') 'Label=',Label
        call Abend()
      end if
    else

      !----------------------------------------------------------------*
      !
      ! SCF
      !
      !----------------------------------------------------------------*

      Label = 'TOTAL'
      iop = ibset(0,loper)
      irc = -1
      iopt = 0
      call dRdMck(iRC,iOpt,Label,jDisp,Focki,iop)
      if (iRc /= 0) then
        write(u6,*) 'IntX: Error reading MCKINT'
        write(u6,'(A,A)') 'Label=',Label
        call Abend()
      end if
      Fock(:) = Zero
      do iS=1,nSym
        js = Mul(is,loper+1)
        Fock(ipMat(is,js):ipMat(is,js)+nOrb(is)*nIsh(js)-1) = Two*Focki(ipMat(is,js):ipMat(is,js)+nOrb(is)*nIsh(js)-1)
      end do
    end if
  end if
end if

!----------------------------------------------------------------------*
!
! Two electron fock matrix done!
! Lets fix  the one electron matrixes
!
!----------------------------------------------------------------------*

if (btest(nTPert(iDisp),1)) then ! 1 el contribution
  iop = ibset(0,loper)
  if (btest(ntpert(idisp),4)) then  ! from mckinley
    Label = 'ONEGRD'
    irc = -1
    iopt = 0
    call dRdMck(iRC,iOpt,Label,jDisp,Temp1,iop)
    if (iRc /= 0) then
      write(u6,*) 'IntX: Error reading MCKINT'
      write(u6,'(A,A)') 'Label=',Label
      call Abend()
    end if
  else                                         ! or seward
    Label = SwLbl(idisp)
    iopt = 0
    irc = -1
    Temp1(:)=Zero
    call RdOne(irc,iopt,Label,jDisp,Temp1,iop)
    if (iRc /= 0) then
      write(u6,*) 'IntX: Error reading MCKINT'
      write(u6,'(A,A)') 'Label=',Label
      call Abend()
    end if
    If (Label=="MLTPL  1" .and. iOp==1) Then
       ! check if we have to correct the dipole moment integrals. They should be expanded around the origin, (0,0,0).
       nSize=0
       do iS=1,nSym
          do jS=1,iS
             If (nBas(is)*nBas(js) /= 0) Then
                If (Mul(iS,jS) == loper+1) Then
                   If (iS==jS) Then
                      nSize=nSize+nBas(iS)*(nBas(iS)+1)/2
                   Else
                      nSize=nSize+nBas(iS)*nBas(jS)
                   End If
                End If
             End If
          End Do
       End Do
       Origin(1:3)=Temp1(nSize+1: nSize+3)
       If (Origin(jDisp)/=Zero) Then
          ! We need to correct the matrix
          Label = 'MLTPL  0'
          iopt = 0
          irc = -1
          Temp2(:)=Zero
          kDisp=1
          call RdOne(irc,iopt,Label,kDisp,Temp2,iop)
          nSize=0
          do iS=1,nSym
             do jS=1,iS
                If (nBas(is)*nBas(js) /= 0) Then
                   If (Mul(iS,jS) == loper+1) Then
                      If (iS==jS) Then
                         Temp1(nSize+1:nSize+nBas(iS)*(nBas(iS)+1)/2)=Temp1(nSize+1:nSize+nBas(iS)*(nBas(iS)+1)/2) &
                                                                    + Origin(jDisp)*Temp2(nSize+1:nSize+nBas(iS)*(nBas(iS)+1)/2)
                         nSize=nSize+nBas(iS)*(nBas(iS)+1)/2
                      Else
                         Write (6,*) 'Ugh!'
                         Call abend()
                         nSize=nSize+nBas(iS)*nBas(jS)
                      End If
                   End If
                End If
             End Do
          End Do
       End If
    End If
  end if
end if

Temp2(:) = Zero

do iS=1,nSym
  do jS=1,is
    if (nBas(is)*nBas(js) /= 0) then
      if (Mul(iS,jS) == loper+1) then
        if (is == js) then
          call Square(Temp1(ipMatLt(iS,jS)),Temp4,1,nBas(is),nBas(is))
        else
          Temp4(1:nBas(iS)*nBas(jS)) = Temp1(ipMatLT(iS,Js):ipMatLT(iS,Js)+nBas(iS)*nBas(jS)-1)
        end if
        call DGEMM_('T','N',nOrb(iS),nBas(jS),nBAs(iS),One,CMO(ipCM(iS)),nBas(is),Temp4,nBas(iS),Zero,Temp3,nOrb(iS))
        call DGEMM_('N','N',nOrb(is),nB(jS),nBas(jS),One,Temp3,nOrb(iS),CMO(ipCM(jS)),nBas(jS),Zero,Temp2(ipMat(iS,jS)),nOrb(iS))
        if (is /= js) then
          call DGEMM_('T','T',nOrb(jS),nOrb(iS),nBAs(jS),One,CMO(ipCM(jS)),nBas(js),Temp4,nBas(iS),Zero,Temp3,nOrb(jS))
          call DGEMM_('N','N',nOrb(js),nB(iS),nBas(iS),One,Temp3,nOrb(jS),CMO(ipCM(iS)),nBas(iS),Zero,Temp2(ipMat(jS,iS)),nOrb(jS))
        end if

      end if
    end if
  end do
end do

Temp3(:) = Zero
do iS=1,nSym
  js = Mul(is,loper+1)
  if (nOrb(js) < 1) cycle
  do j=1,nAsh(is)+nish(is)
    do i=1,nAsh(is)+nIsh(is)
      if ((i == j) .and. (i <= nish(is)) .and. (j <= nish(is))) then
        rde = Two
      else if ((i > nish(is)) .and. (j > nish(is))) then
        rde = G1t(iTri(i-nIsh(is)+nA(is),j-nIsh(is)+nA(is)))
      else
        cycle
      end if
      iOff = ipMat(js,is)+(i-1)*nOrb(js)
      jOff = ipMat(js,is)+(j-1)*nOrb(js)
      Temp3(iOff:iOff+nOrb(js)-1) = Temp3(iOff:iOff+nOrb(js)-1)+rDe*Temp2(jOff:jOff+nOrb(js)-1)
    end do
  end do
end do
!***********************************************************************

!----------------------------------------------------------------------*
!
! One electron fock matrix done!
!
!----------------------------------------------------------------------*

if (btest(ntpert(idisp),2)) then
  Focki(:) = Focki(:)+Temp2(:)
  Fock(:) = Fock(:)+Temp3(:)
else
  FockI(:) = Temp2(:)
  Fock(:) = Temp3(:)
end if

end subroutine INTX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GET_IREOTS(IARRAY,NACTOB)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "mxpdim.fh"
#include "orbinp.fh"
      DIMENSION IARRAY(NACTOB)
*
* Make the IREOTS reorder array available in ARRAY.
* Added in order to let MOLCAS use IREOTS.
*
      CALL ICOPY(NACTOB,IREOTS,1,IARRAY,1)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine all2free_cvb(vecfrom,vecto,nvec)

use casvb_global, only: nfr, nfrorb, npr, nprorb, nprvb, orbfr_is_unit, trprm
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nvec
real(kind=wp), intent(in) :: vecfrom(npr,nvec)
real(kind=wp), intent(out) :: vecto(nfr,nvec)
integer(kind=iwp) :: ivec

do ivec=1,nvec
  if (.not. orbfr_is_unit) then
    call mxattb_cvb(trprm,vecfrom(:,ivec),nfrorb,nprorb,1,vecto(:,ivec))
  else
    if (nprorb > 0) vecto(1:nprorb,ivec) = vecfrom(1:nprorb,ivec)
  end if
  if (nprvb > 0) vecto(nfrorb+1:nfrorb+nprvb,ivec) = vecfrom(nprorb+1:nprorb+nprvb,ivec)
end do

return

end subroutine all2free_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine BoostRep(AddRep,SmatPure,Vecs,nSize,InCutOff)

use qmstat_global, only: exrep10, exrep4, exrep6, iOcc1, nEqState, QmType
use Index_Functions, only: iTri, nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: AddRep
integer(kind=iwp), intent(in) :: nSize
real(kind=wp), intent(in) :: SmatPure(*), Vecs(nSize,nSize)
logical(kind=iwp), intent(in) :: InCutOff
integer(kind=iwp) :: i, iO1, iO2, j, kaunter
real(kind=wp) :: Scalar

! Enter.

! Common section.

Scalar = Zero

! Take different route for different QM-method.

if (QmType(1:3) == 'SCF') then

  ! Repulsion term added to the Energy
  ! Calculated as S_i*S_i*CPsi_m* CPis_n
  ! S_i is the overlap integral (with the solvent molecule)
  ! for the occupied orbitals of the quantum system
  ! CPsi_m and CPsi_n are the transformation coefficients
  ! obtained from the diagonalization procedure of the Fock matrix
  ! to go from the original wavefunction to the final wavefunction
  ! after the SCF procedure. These coeficientes run over all basis set

  do iO1=1,nSize
    do iO2=1,nSize
      do i=1,iOcc1
        kaunter = nTri_Elem(i)
        Scalar = Scalar+(Vecs(i,iO1)*Vecs(i,iO2)*SmatPure(kaunter))
      end do
    end do
  end do
  Scalar = abs(Scalar)
  AddRep = exrep4*Scalar**2+exrep6*Scalar**3+exrep10*Scalar**5
else if (QmType(1:4) == 'RASS') then
  do i=1,nSize
    do j=1,nSize
      kaunter = iTri(i,j)
      Scalar = Scalar+Vecs(i,nEqState)*Vecs(j,nEqState)*SmatPure(kaunter)
    end do
  end do
  Scalar = abs(Scalar)
  AddRep = exrep4*Scalar**2+exrep6*Scalar**3+exrep10*Scalar**5
end if

! Crazy energy added if inner cut-off has been passed. Ensure reject.

if (InCutOff) AddRep = huge(AddRep)

return

end subroutine BoostRep

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Mk_tVt(TInt,nTheta_All,tVt,nTheta,List2,mData,
     &                  iPrm,nPrm,iAng,jAng,nk,nl,Indkl,nkl,
     &                  iAL,nA,nB)
      Implicit Real*8 (a-h,o-z)
      Real*8 TInt(nTheta_All,nTheta_All), tVt(nTheta,nTheta)
      Integer List2(mData,nTheta_All), iPrm(nPrm), Indkl(nkl),
     &        iAL(nA,nB)
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('Mk_tVt: TInt',' ',TInt,nTheta_All,nTheta_All)
      Call iVcPrt('iPrm',' ',iPrm,nPrm)
      Call iVcPrt('Indkl',' ',Indkl,nkl)
      Call iVcPrt('iAL',' ',iAL,nA*nB)
#endif
      Call FZero(tVt,nTheta**2)
      iA=iAng+1
      jA=jAng+1
      Do iTheta_All = 1, nTheta_All
         kComp=List2(3,iTheta_All)
         lComp=List2(4,iTheta_All)
         ik=   List2(5,iTheta_All)
         il=   List2(6,iTheta_All)
         If (iAng.eq.jAng) Then
            iTheta_Full = ik*(ik-1)/2+il
         Else
            iTheta_Full = (il-1)*nk + ik
         End If
         If (
C    &       iAL(kComp,lComp).eq.1 .and.
     &       kComp.eq.iA .and. lComp.eq.jA .and.
     &       iPrm(iTheta_Full).eq.1) Then
            iTheta=Indkl(iTheta_Full)
*
            Do jTheta_All = 1, nTheta_All
               mComp=List2(3,jTheta_All)
               nComp=List2(4,jTheta_All)
               im   =List2(5,jTheta_All)
               in   =List2(6,jTheta_All)
               If (iAng.eq.jAng) Then
                  jTheta_Full = im*(im-1)/2+in
               Else
                  jTheta_Full = (in-1)*nk + im
               End If
               If (
C    &             iAL(mComp,nComp).eq.1 .and.
     &             mComp.eq.iA .and. nComp.eq.jA .and.
     &             iPrm(jTheta_Full).eq.1) Then
                  jTheta=Indkl(jTheta_Full)
*
                  tVt(iTheta,jTheta) = tVt(iTheta,jTheta)
     &                               +     TInt(iTheta_All,jTheta_All)
C    &                               + Abs(TInt(iTheta_All,jTheta_All))
*
               End If
            End Do
*
         End If
      End Do
*
#ifdef _DEBUGPRINT_
      Call RecPrt('tVt',' ',tVt,nTheta,nTheta)
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(iAL)
#endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nl)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine touchord_cvb(itouch,iorder,n)
      implicit real*8(a-h,o-z)
      dimension iorder(n)
      logical debug
      data debug/.false./

      if(debug)then
        write(6,*)' itouch :',itouch
        write(6,*)' iorder on entry :',iorder
      endif
      itchord=iorder(itouch)
      do 100 i=1,n
      if(iorder(i).lt.itchord.and.iorder(i).ne.0)iorder(i)=iorder(i)+1
100   continue
      iorder(itouch)=1
      if(debug)write(6,*)' iorder on exit  :',iorder
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_dArray_chk(Label,rData,nData)

use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: Label
integer(kind=iwp), intent(in) :: nData
real(kind=wp), intent(out) :: rData(nData)
integer(kind=iwp) :: mData
logical(kind=iwp) :: Found

call qpg_dArray(Label,Found,mData)
if ((.not. Found) .or. (mData == 0)) then
  call SysAbendMsg('Get_dArray_chk','Did not find:',Label)
else if (nData /= mData) then
  write(u6,*) 'Get_dArray_chk: nData /= mData'
  write(u6,*) 'nData=',nData
  write(u6,*) 'mData=',mData
  call Abend()
end if
call Get_dArray(Label,rData,nData)

return

end subroutine Get_dArray_chk

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine CVelInt(Vxyz,Sxyz,na,nb,Alpha,Beta,nZeta)
************************************************************************
*                                                                      *
* Object: to assemble the cartesian components of the velocity inte-   *
*         grals from the cartesian components of the overlap integals. *
*                                                                      *
* Called from: PrpInt                                                  *
*                                                                      *
* Calling    : CRecPrt                                                 *
*               RecPrt                                                 *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Complex*16 Vxyz(nZeta,3,0:na,0:nb,2), Sxyz(nZeta,3,0:na+1,0:nb+1)
      Real*8 Alpha(nZeta), Beta(nZeta)
      Character*80 Label
      iRout=160
      iPrint = nPrint(iRout)

      If (iPrint.ge.99) Then
         Call RecPrt(' In CVelInt: Beta ',' ',Beta ,nZeta,1)
      End If
      Do 10 ia = 0, na
         Do 20 ib = 0, nb
            If (ia.ne.0 .and. ib.ne.0) Then
               Do iCar = 1, 3
                  Do iZeta = 1, nZeta
                     Vxyz(iZeta,iCar,ia,ib,1) =
     &                    Dble(ia) * Sxyz(iZeta,iCar,ia-1,ib)
     &                 - Alpha(iZeta) * Two * Sxyz(iZeta,iCar,ia+1,ib)
                     Vxyz(iZeta,iCar,ia,ib,2) =
     &                    Dble(ib) * Sxyz(iZeta,iCar,ia,ib-1)
     &                 - Beta(iZeta) * Two * Sxyz(iZeta,iCar,ia,ib+1)
                  End Do
               End Do
            Else If (ia.eq.0 .and. ib.ne.0) Then
               Do iCar = 1, 3
                  Do iZeta = 1, nZeta
                     Vxyz(iZeta,iCar,ia,ib,1) =
     &                 - Alpha(iZeta) * Two * Sxyz(iZeta,iCar,ia+1,ib)
                     Vxyz(iZeta,iCar,ia,ib,2) =
     &                    Dble(ib) * Sxyz(iZeta,iCar,ia,ib-1)
     &                 - Beta(iZeta) * Two * Sxyz(iZeta,iCar,ia,ib+1)
                  End Do
               End Do
            Else If (ia.ne.0 .and. ib.eq.0) Then
               Do iCar = 1, 3
                  Do iZeta = 1, nZeta
                     Vxyz(iZeta,iCar,ia,ib,1) =
     &                    Dble(ia) * Sxyz(iZeta,iCar,ia-1,ib)
     &                 - Alpha(iZeta) * Two * Sxyz(iZeta,iCar,ia+1,ib)
                     Vxyz(iZeta,iCar,ia,ib,2) =
     &                 - Beta(iZeta) * Two * Sxyz(iZeta,iCar,ia,ib+1)
                  End Do
               End Do
            Else
               Do iCar = 1, 3
                  Do iZeta = 1, nZeta
                     Vxyz(iZeta,iCar,ia,ib,1) =
     &                 - Alpha(iZeta) * Two * Sxyz(iZeta,iCar,ia+1,ib)
                     Vxyz(iZeta,iCar,ia,ib,2) =
     &                 - Beta(iZeta) * Two * Sxyz(iZeta,iCar,ia,ib+1)
                  End Do
               End Do
            End If
*
            If (iPrint.ge.99) Then
               Write (Label,'(A,I2,A,I2,A)') ' In CVelInt: Vxyz(',
     &                ia,',',ib,',1)'
               Call CRecPrt(Label,' ',Vxyz(1,1,ia,ib,1),nZeta,3,'R')
               Call CRecPrt(Label,' ',Vxyz(1,1,ia,ib,1),nZeta,3,'I')
               Write (Label,'(A,I2,A,I2,A)') ' In CVelInt: Vxyz(',
     &                ia,',',ib,',2)'
               Call CRecPrt(Label,' ',Vxyz(1,1,ia,ib,2),nZeta,3,'R')
               Call CRecPrt(Label,' ',Vxyz(1,1,ia,ib,2),nZeta,3,'I')
            End If
 20      Continue
 10   Continue

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pseudospin(M,d,z,iDir,iOpt,iprint)
! d - dimension (input)
! moment(l,d,d) (input)
! z - pseudospin eigenfunctions (output)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: d, iDir, iOpt, iprint
complex(kind=wp), intent(in) :: M(3,d,d)
complex(kind=wp), intent(out) :: z(d,d)
integer(kind=iwp) :: i, info
real(kind=wp), allocatable :: w(:)
complex(kind=wp), allocatable :: M_tmp(:,:), z1(:,:)
real(kind=wp), external :: dznrm2_
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

call mma_allocate(W,d,'W')
call mma_allocate(Z1,d,d,'Z1')
call mma_allocate(M_tmp,d,d,'M_tmp')
info = 0
M_tmp(:,:) = M(iDir,:,:)
call diag_c2(M_tmp,d,info,w,z1)
if (iprint >= 3) then
  do i=1,d
    write(u6,'(A,i3,A,F24.14)') 'i=',i,' eigenvalue=',w(i)
  end do
end if
if (info /= 0) then
  write(u6,'(5x,a)') 'PSEUDO::  diagonalization of the zeeman hamiltonian failed.'
else
  if (iprint >= 3) then
    write(u6,*) 'PSEUDO:  norm of  M is:',dznrm2_(3*d*d,M,1)
    write(u6,*) 'PSEUDO:  norm of Z1 is:',dznrm2_(d*d,Z1,1)
  end if
  if (iDir == 3) then
    if (iOpt == 1) then
      call spin_phase(M,d,z1,z)
    else
      z(:,:) = z1(:,:)
      write(u6,*) 'PSEUDOSPIN:  iOpt = ',iOpt
      call WarningMessage(2,'PSEUDOSPIN: iOpt is not understood.')
    end if
  else
    z(:,:) = z1(:,:)
  end if
end if

call mma_deallocate(W)
call mma_deallocate(Z1)
call mma_deallocate(M_tmp)

return

end subroutine pseudospin

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!               2019, Stefano Battaglia                                *
!***********************************************************************

subroutine CASPT2(IRETURN)
!----------------------------------------------------------------------*
!     1998  PER-AAKE MALMQUIST                                         *
!     DEPARTMENT OF THEORETICAL CHEMISTRY                              *
!     UNIVERSITY OF LUND, SWEDEN                                       *
!----------------------------------------------------------------------*

! SECOND ORDER PERTURBATION CALCULATIONS WITH A CASSCF
! REFERENCE FUNCTION.

! ORIGINAL CASPT2 PROGRAM WRITTEN 890526 BY:
! KERSTIN ANDERSSON (ALL CASPT2 CODE WITH FOLLOWING EXCEPTIONS)
! PER-AKE MALMQVIST (THE GUGA PART)
! BJORN O ROOS      (THE INTEGRAL TRANSFORMATION)

! MODIFIED 1991-02-23 BY PER-AAKE MALMQUIST, FOR USE WITH THE
! MOLCAS RASSCF PROGRAM.

! ALL PROGRAM REWRITTEN (MALMQVIST 1993) FOR MOLCAS VERSION 3,
! EXCEPT TRACTL AND TRA2 KEPT BUT SLIGHTLY MODIFIED, AND ALSO:
! INTERFACING WITH MOLCAS-3 BY MARCUS FUELSCHER

! REWRITTEN FOR 1) EXACT ACTIVE DENSITY MATRIX
! 2) QUANTITIES NEEDED FOR GRADIENTS
! 3) MULTI-STATE CASPT2
! BY MALMQVIST 1998.

! SINCE THEN, THE FOLLOWING MODIFICATIONS HAVE BEEN MADE:
! IPEA HAMILTONIAN BY G. GHIGO & P. MALMQVIST
!   Chem. Phys. Lett. 396, pp 142 (2004)
!   http://dx.doi.org/10.1016/j.cplett.2004.08.032
! LOVCASPT2/FNOCASPT2/AFREEZE BY B. ROOS & F. AQUILANTE
!   J. Chem. Phys. 131, 034113 (2009)
!   http://dx.doi.org/10.1063/1.3157463
! CHOLESKY SUPPORT BY P. MALMQVIST AND F. AQUILANTE
!   J. Chem. Theory Comput. 4 (5), pp 694-702 (2008)
!   http://dx/doi.org/10.1021/ct700263h
! RASPT2 BY P. MALMQVIST
!   J. Chem. Phys. 128, 204109 (2008)
!   http://dx.doi.org/10.1063/1.2920188
! PARALLELIZATION BY S. VANCOILLIE
!   J. Comp. Chem. 34, pp 1937-1948 (2013)
!   http://dx.doi.org/10.1002/jcc.23342
! MAJOR REFACTORING OF INITIALIZATION PHASE AND ADDITION OF
! HDF5 SUPPORT BY S. VANCOILLIE (2016)

!***********************************************************************

use INPUTDATA, only: INPUT
use PT2WFN, only: PT2WFN_DATA, PT2WFN_ESTORE
use fciqmc_interface, only: DoFCIQMC
use caspt2_global, only: do_grad, IDSAVGRD, iPrGlb, iStpGrd, nStpGrd
use caspt2_module, only: CPT2Method, CPUEIG, CPUFG3, CPUFMB, CPUGIN, CPUGRD, CPUINT, CPULCS, CPUNAD, CPUOVL, CPUPCG, CPUPRP, &
                         CPUPT2, CPURHS, CPUSBM, CPUSCA, CPUSER, CPUSGM, CPUSIN, CPUVEC, E2ToT, Energy, HZERO, IfChol, IfDens, &
                         IfDW, IfMSCoup, IfProp, IfRMS, IfXMS, iRlxRoot, jState, mState, nGroup, nGroupState, nLyGroup, nLyRoot, &
                         nState, PT2Method, RefEne, TIOEIG, TIOFG3, TIOFMB, TIOGIN, TIOGRD, TIOINT, TIOLCS, TIONAD, TIOOVL, &
                         TIOPCG, TIOPRP, TIOPT2, TIORHS, TIOSBM, TIOSCA, TIOSER, TIOSGM, TIOSIN, TIOVEC
use SC_NEVPT2, only: Do_FIC, Do_SC, ENERGY_SC, HEFF_SC, SC_prop, SC_NEVPT2_initial, SC_NEVPT2_final
use PrintLevel, only: TERSE, USUAL, VERBOSE
use EQSOLV, only: iRHS, iVecC, iVecC2, iVecR, iVecW, iVecX
#ifdef _DMRG_
use, intrinsic :: iso_c_binding, only: c_bool, c_int
use qcmaquis_interface, only: qcmaquis_interface_compute_and_store_123rdm_full, &
                              qcmaquis_interface_compute_and_store_trans_123rdm_full
use caspt2_module, only: DMRG
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, auTocm, auToeV, auTokJmol
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: IRETURN
integer(kind=iwp) :: ICONV, IGROUP, ISTATE, JSTATE_OFF
#ifdef _DMRG_
integer(kind=iwp) :: I, J
#endif
real(kind=wp) :: CPE, CPTF0, CPTF11, CPTF12, CPTF13, CPTF14, CPUTOT, RELAU, RELCM, RELEV, RELKJ, TIOE, TIOTF0, TIOTF11, TIOTF12, &
                 TIOTF13, TIOTF14, TIOTOT
logical(kind=iwp) :: IFGRDT0
character(len=60) :: STLNE2
real(kind=wp), allocatable :: ESav(:), H0(:,:), H0Sav(:,:), Heff(:,:), U0(:,:), U0Sav(:,:), Ueff(:,:), UeffSav(:,:)
#include "warnings.h"

call StatusLine('CASPT2: ','Just starting')

IRETURN = 0
IFGRDT0 = .false.

!=======================================================================
!
! Miscellaneous setup, reading of the input and start of writing
! input parameters in the log file.
call PT2INI()

! Set up effective Hessian for multi-state calculations. Note that
! single state calculations are treated as an one-dimensional case.
call HEFF_INI()

! If the EFFE keyword has been used proceed to the MS coupling section.
if (INPUT%JMS) then
  call Print_Truff()
  call Post_Process()
  call CASPT2_TERM()
  return
end if

! Before entering the long loop over groups and states, precompute
! the 1-RDMs for all states and mix them according to the type of
! calculation: MS, XMS, DW or XDW. This is done in the natural
! orbital basis.

call rdminit()

!! loop for multistate CASPT2 gradient
!! In the first step, the effective Hamiltonian and the
!! rotation vector are computed. In the second step,
!! quantities needed for gradient are computed
nStpGrd = 1
IFGRDT0 = do_grad
! Why do we need to do this here?
if (do_grad .and. IfChol) call CNSTFIFAFIMO(0)
if (do_grad .and. IFMSCOUP) then
  nStpGrd = 2
  !! avoid doing a lot of calculations in dens in the first loop
  do_grad = .false.
  call MMA_ALLOCATE(ESav,Nstate)
  call MMA_ALLOCATE(H0Sav,Nstate,Nstate)
  ! at this stage, H0 is just a zero matrix
  if ((IFXMS .and. IFDW) .or. IFRMS) H0Sav(:,:) = H0(:,:)
end if

!! iStpGrd = 0 means PT2GRD is found and program requests gradient
!! for the second root or NAC vectors. Skip the energy calculation
!! and directly goes to the gradient part
if (iStpGrd == 0) then
  call SavGradParams2(2,UEFF,U0,H0,Nstate)
  Esav(:) = ENERGY(1:Nstate)
  UEFFSav(:,:) = UEFF(:,:)
  U0Sav(:,:) = U0(:,:)
  if ((IFXMS .and. IFDW) .or. IFRMS) H0Sav(:,:) = H0(:,:)
  iStpGrd = 2
  call Post_Process()
  call CASPT2_TERM()
  return
end if

! FIRST GRAD LOOP ITER
#ifdef _DMRG_
if (DMRG) then
  do I=1,NSTATE
    call qcmaquis_interface_compute_and_store_123rdm_full(int(I-1,c_int),logical(.true.,c_bool))
    do J=1,NSTATE
      if (I /= J) call qcmaquis_interface_compute_and_store_trans_123rdm_full(int(I-1,c_int),int(J-1,c_int),logical(.true.,c_bool))
    end do
  end do
end if
#endif

!***********************************************************************
!                                                                      *
!                                                                      *
!***********************************************************************
! For (X)Multi-State, a long loop over root states.
! The states are ordered by group, with each group containing a number
! of group states for which GRPINI is called.
JSTATE_OFF = 0
STATELOOP: do IGROUP=1,NGROUP

  call TIMING(CPTF0,CPE,TIOTF0,TIOE)

  if ((NLYGROUP /= 0) .and. (IGROUP /= NLYGROUP)) then
    JSTATE_OFF = JSTATE_OFF+NGROUPSTATE(IGROUP)
    cycle
  end if

  if (IPRGLB >= USUAL) then
    write(STLNE2,'(A,1X,I3)') trim(PT2Method)//' computation for group',IGROUP
    call CollapseOutput(1,trim(STLNE2))
    write(u6,*)
  end if

  ! GRPINI (group init?) does a number of things as follows (note this
  ! list is not complete).

  ! 1. Reads the natural orbitals (NO) MOs from LUONEM. Stored in
  !    CMO.
  ! 2. transforms HONE from AO to NO basis (traone).
  ! 3. transforms the two-electron integrals to the NO basis
  ! 4. Form the 1-particle density matrix (DREF) from DMIX as
  !    generated RDMINIT above. In the NO basis. This is needed
  !    to form the Fock matrix in the NO basis.
  ! 5. Forms the Fock matrix in NO basis by a call to MkOrb.
  !    For conventional integrals for it directly in the NO basis,
  !    while for the Cholesky decomposition approach the Fock matrix
  !    is first formed in the AO basis and then transformed to NO
  !    basis. This routine also reads the CI coefficients in the
  !    NO basis from the file LUCIEX. Transforms the to PCO basis and
  !    writes them back to LUCIEX on another place.
  ! 6. Forms the pseudo canonical orbitals (PCO), in OrbCtl.
  !    6a. For the PCO basis and the transformation matrix between
  !        the NO and the PCO basis, the TOrb matrix.
  !    6b. Transform the FIMO matrix to the PCO basis
  !    6c. Transform the FIFA matrix to the PCO basis
  ! 7. Transforms the Cholesky vectors or the two-electron integrals
  !    to the PCO basis.
  ! 8. Drops the NO CMO orbitals as stored in CMO.

  call GRPINI(IGROUP,NGROUPSTATE(IGROUP),JSTATE_OFF,HEFF,H0,U0,nState)

  if (do_grad) call CNSTFIFAFIMO(1)

  do ISTATE=1,NGROUPSTATE(IGROUP)
    JSTATE = JSTATE_OFF+ISTATE

    ! Skip this state if we only need 1 state and it isn't this "one".
    if ((NLYROOT /= 0) .and. (JSTATE /= NLYROOT)) cycle

    ! STINI (state init?) does the following

    ! 1. It calls POLY3 to form the 1-, 2-, and 3-particle density
    !    matrix in the PCO basis. This is based on the CI vector
    !    expressed in the PCO basis. Using pt2_put the result is
    !    stored on LUDMAT.
    ! 2. Using GETDPREF it pulls the one- and two-particle density
    !    matrices (gamma 1 and gamma 2), using pt2_get, of the
    !    LUDMAT file and sticks them in to DREF and PREF.
    ! 3. Sets the EREF value
    ! 4. Recomputes EASUM.

    call STINI(JSTATE)

    ! Solve CASPT2 equation system and compute corr energies.
    if (IPRGLB >= USUAL) then
      write(u6,'(A)') repeat('*',80)
      write(u6,'(2X,A)') trim(PT2Method)//' EQUATION SOLUTION'
      write(u6,'(A)') repeat('-',80)
    end if

    write(STLNE2,'(A,I0)') 'Solve '//trim(PT2Method)//' eqs. for state ',MSTATE(JSTATE)

    call TIMING(CPTF11,CPE,TIOTF11,TIOE)

    call StatusLine('CASPT2: ',STLNE2)

    call EQCTL2(ICONV)

    ! Save the final caspt2 energy in the global array ENERGY():
    ENERGY(JSTATE) = E2TOT

    call TIMING(CPTF12,CPE,TIOTF12,TIOE)
    CPUPT2 = CPTF12-CPTF11
    TIOPT2 = TIOTF12-TIOTF11

    if (ICONV /= 0) then
      ! No convergence. Skip the rest of the calculation.
      IRETURN = _RC_NOT_CONVERGED_
      exit STATELOOP
    end if

    ! Orbitals, properties:

    ! if the dens keyword is used, need accurate density and
    ! for that the serial LUSOLV file is needed, in that case copy
    ! the distributed LURHS() to LUSOLV here.
    if (IFDENS .or. (do_grad .and. (iRlxRoot == MSTATE(JSTATE)))) then
      if (do_FIC) then
        call PCOLLVEC(IRHS,0)
        call PCOLLVEC(IVECX,0)
        call PCOLLVEC(IVECR,0)
        call PCOLLVEC(IVECC,1)
        call PCOLLVEC(IVECC2,1)
        call PCOLLVEC(IVECW,1)
      end if
    end if

    if (IFPROP .or. (do_grad .and. (iRlxRoot == MSTATE(JSTATE)))) then

      call PRPCTL(0,UEFF,U0,nState)

    else
      if (IPRGLB >= USUAL) then
        write(u6,*)
        write(u6,*) '  (Skipping property calculation,'
        write(u6,*) '   use PROP keyword to activate)'
      end if
    end if
    !! Save many quantities needed for gradient calculations
    if (nStpGrd == 2) call SavGradParams(1,IDSAVGRD)

    call TIMING(CPTF13,CPE,TIOTF13,TIOE)
    CPUPRP = CPTF13-CPTF12
    TIOPRP = TIOTF13-TIOTF12

    if (.not. DoFCIQMC) then

      if (IFMSCOUP) then
        ! If this was NOT a gradient, calculation, then the multi-state
        ! couplings are more efficiently computed via three-body
        ! transition density matrices.
        if (IPRGLB >= VERBOSE) then
          write(u6,*)
          write(u6,'(A)') repeat('*',80)
          write(u6,'(2X,A)') trim(PT2Method)//' MULTI-STATE COUPLINGS SECTION'
        end if
        call StatusLine('CASPT2: ','Multi-State couplings')
        call MCCTL(HEFF,NSTATE,JSTATE)
      end if

    end if

    call Iter_Timing()

    ! End of long loop over states in the group
  end do

  if (IPRGLB >= USUAL) then
    call CollapseOutput(0,trim(STLNE2))
    write(u6,*)
  end if

  ! End of long loop over groups
  JSTATE_OFF = JSTATE_OFF+NGROUPSTATE(IGROUP)
end do STATELOOP

!***********************************************************************
!                                                                      *
!                                                                      *
!***********************************************************************

call Print_Truff()
call Post_Process()
call CASPT2_TERM()

contains

subroutine Print_Truff()

  integer(kind=iwp) :: I

  if (IRETURN /= 0) then
    call CASPT2_TERM()
    return
  end if

  if (IPRGLB >= TERSE) then
    if ((HZERO == 'DYALL') .and. SC_prop) ENERGY(1:NSTATE) = ENERGY_SC(1:NSTATE)
    write(u6,*) ' Total '//trim(CPT2Method)//' energies:'
    if (IFXMS .or. IFRMS .and. (HZERO /= 'DYALL')) then
      write(u6,*)
      write(u6,*) ' State-specific CASPT2 energies obtained using'
      write(u6,*) ' rotated states do not have a well-defined physical'
      write(u6,*) ' meaning, however they can be extracted from the'
      write(u6,*) ' diagonal of the effective Hamiltonian.'
    else
      do I=1,NSTATE
        if ((NLYROOT /= 0) .and. (I /= NLYROOT)) cycle
        call PrintResult(u6,'(6x,A,I3,5X,A,F16.8)',trim(CPT2Method)//' Root',MSTATE(I),'Total energy:',ENERGY(I),1)
      end do
      if ((IPRGLB >= VERBOSE) .and. (NLYROOT == 0)) then
        write(u6,*)
        write(u6,*) ' Relative '//trim(PT2Method)//' energies:'
        write(u6,'(1X,A4,4X,A12,1X,A10,1X,A10,1X,A10)') 'Root','(a.u.)','(eV)','(cm^-1)','(kJ/mol)'
        ISTATE = minloc(ENERGY(1:NSTATE),dim=1)
        do I=1,NSTATE
          RELAU = ENERGY(I)-ENERGY(ISTATE)
          RELEV = RELAU*auToeV
          RELCM = RELAU*auTocm
          RELKJ = RELAU*auTokJmol
          write(u6,'(1X,I4,4X,F12.8,1X,F10.2,1X,F10.1,1X,F10.2)') MSTATE(I),RELAU,RELEV,RELCM,RELKJ
        end do
      end if
    end if
    write(u6,*)
  end if

end subroutine Print_Truff

subroutine Post_Process()

  integer(kind=iwp) :: I

  if (.not. doFCIQMC) then
    if (iStpGrd /= 2) then
      if (NLYROOT /= 0) IFMSCOUP = .false.
      if (IFMSCOUP) then
        call StatusLine('CASPT2: ','Effective Hamiltonian')
        call MLTCTL(HEFF,UEFF,U0)

        if ((IPRGLB >= VERBOSE) .and. (NLYROOT == 0)) then
          if (HZERO == 'DYALL') then
            if (SC_prop) then
              write(u6,*) ' Relative QD-SC-NEVPT2 energies:'
            else
              write(u6,*) ' Relative QD-PC-NEVPT2 energies:'
            end if
          else
            write(u6,*) ' Relative (X)MS-CASPT2 energies:'
          end if
          write(u6,'(1X,A4,4X,A12,1X,A10,1X,A10,1X,A10)') 'Root','(a.u.)','(eV)','(cm^-1)','(kJ/mol)'
          do I=1,NSTATE
            RELAU = ENERGY(I)-ENERGY(1)
            RELEV = RELAU*auToeV
            RELCM = RELAU*auTocm
            RELKJ = RELAU*auTokJmol
            write(u6,'(1X,I4,4X,F12.8,1X,F10.2,1X,F10.1,1X,F10.2)') I,RELAU,RELEV,RELCM,RELKJ
          end do
          write(u6,*)
        end if
      end if
    end if

    ! Beginning of second step, in case gradient of (X)MS

    if (nStpGrd == 2) then
      if (IPRGLB >= TERSE) then
        write(u6,'(A)') repeat('*',80)
        write(u6,'(A)') ' SECOND RUN to compute analytical gradients/NAC quantities'
        write(u6,'(A)') repeat('-',80)
        write(u6,*)
        call XFlush(u6)
      end if
      do_grad = .true.
      Esav(:) = ENERGY(1:nState)
      UeffSav(:,:) = Ueff(:,:)
      if (IFXMS .or. IFRMS .or. IFMSCOUP) U0Sav(:,:) = U0(:,:)

      !! Somehow H0 is wrong for XDW-CASPT2
      !! Maybe, H0(1,1) is computed with rotated basis with
      !! DW-density, while the true value is computed with SA-density
      if (do_grad .and. IFMSCOUP) then
        if ((IFXMS .and. IFDW) .or. IFRMS) H0(:,:) = H0Sav(:,:)
      end if
      call SavGradParams2(1,UEFF,U0,H0,nState)

      call GradLoop(Heff,Ueff,H0,U0,H0Sav,nState)
    end if

    ! Back-transform the effective Hamiltonian and the transformation matrix
    ! to the basis of original CASSCF states
    if (nStpGrd == 2) then
      call Backtransform(Heff,UeffSav,U0sav,nState)
      Ueff(:,:) = UeffSav(:,:)
      ENERGY(1:nState) = ESav(:)
    else
      call Backtransform(Heff,Ueff,U0,nState)
    end if

    ! create a JobMix file
    ! (note that when using HDF5 for the PT2 wavefunction, IFMIX is false)
    call CREIPH_CASPT2(Heff,Ueff,U0,nState)

    ! Store the PT2 energy and effective Hamiltonian on the wavefunction file
    call PT2WFN_ESTORE(HEFF,nState)

    ! Store rotated states if XMUL + NOMUL
    if ((IFXMS .or. IFRMS) .and. (.not. IFMSCOUP)) call PT2WFN_DATA()

    ! store information on runfile for geometry optimizations
    call Put_iScalar('NumGradRoot',iRlxRoot)
    call Store_Energies(NSTATE,ENERGY,iRlxRoot)
  end if

end subroutine Post_Process

subroutine CASPT2_TERM()

  !! Finishing for gradient calculation
  if (IFGRDT0) then
    call GrdCls(IRETURN,nState,UEFFSav,U0Sav,H0)
    call MMA_DEALLOCATE(UeffSav)
    call MMA_DEALLOCATE(U0Sav)
    if (IFMSCOUP) then
      call MMA_DEALLOCATE(ESav)
      call MMA_DEALLOCATE(H0Sav)
    end if
  end if

  ! Free resources, close files
  call PT2CLS()

  call MMA_DEALLOCATE(UEFF)
  call MMA_DEALLOCATE(U0)
  call MMA_DEALLOCATE(HEFF)
  call MMA_DEALLOCATE(H0)
  if ((HZERO == 'DYALL') .and. Do_SC) call SC_NEVPT2_final()

  ! PRINT I/O AND SUBROUTINE CALL STATISTICS
  if (IPRGLB >= USUAL) call FASTIO('STATUS')

  call StatusLine('CASPT2: ','Finished.')

end subroutine CASPT2_TERM

subroutine HEFF_INI()

  integer(kind=iwp) :: I

  ! Initialize effective Hamiltonian and eigenvectors
  call MMA_ALLOCATE(Heff,Nstate,Nstate,Label='Heff')
  call MMA_ALLOCATE(Ueff,Nstate,Nstate,Label='Ueff')
  Heff(:,:) = Zero
  Ueff(:,:) = Zero
  ! Initialize zeroth-order Hamiltonian and eigenvectors
  call MMA_ALLOCATE(H0,Nstate,Nstate,Label='H0')
  call MMA_ALLOCATE(U0,Nstate,Nstate,Label='U0')
  H0(:,:) = Zero
  ! U0 is initialized as the identity matrix, in the case of a
  ! standard MS-CASPT2 calculation it will not be touched anymore
  call unitmat(U0,Nstate)

  ! Some preparations for gradient calculation
  if (do_grad) then
    call MMA_ALLOCATE(UeffSav,Nstate,Nstate)
    call MMA_ALLOCATE(U0Sav,Nstate,Nstate)
    IDSAVGRD = 0
  end if
  !=====================================================================
  ! Put the CASSCF energies on the diagonal of Heff, i.e. form the
  ! first-order corrected effective Hamiltonian:
  !     Heff[1] = PHP
  ! and later on we will add the second-order correction
  ! Heff(2) = PH \Omega_1 P to Heff[1]
  if ((HZERO == 'DYALL') .and. Do_SC) call SC_NEVPT2_initial()
  do I=1,NSTATE
    HEFF(I,I) = REFENE(I)
    if ((HZERO == 'DYALL') .and. Do_SC) HEFF_SC(I,I) = REFENE(I)
  end do
  if (IPRGLB >= VERBOSE) then
    write(u6,*) ' Heff[1] in the original model space basis:'
    call prettyprint(Heff,Nstate,Nstate)
  end if
  ! If the EFFE keyword has been used, we already have the multi state
  ! coupling Hamiltonian effective matrix, just copy the energies.
  if (INPUT%JMS) then
    ! in case of XMS, XDW, RMS, we need to rotate the states
    if (IFXMS .or. IFRMS .and. (HZERO /= 'DYALL')) call xdwinit(Heff,H0,U0,nState)
    do I=1,NSTATE
      ENERGY(I) = INPUT%HEFF(I,I)
    end do
    HEFF(:,:) = INPUT%HEFF(:,:)
    if ((HZERO == 'DYALL') .and. Do_SC) HEFF_SC(:,:) = INPUT%HEFF(:,:)
  else

    ! In case of a XDW-CASPT2 calculation we first rotate the CASSCF
    ! states according to the XMS prescription in xdwinit
    if (((IFXMS .and. IFDW) .or. IFRMS) .and. (HZERO /= 'DYALL')) call xdwinit(Heff,H0,U0,nState)
    call wgtinit(Heff,nState)
  end if

end subroutine HEFF_INI

subroutine Iter_Timing()

  if (.not. DoFCIQMC) then
    call TIMING(CPTF14,CPE,TIOTF14,TIOE)
    CPUGRD = CPTF14-CPTF13
    TIOGRD = TIOTF14-TIOTF13
    CPUTOT = CPTF14-CPTF0
    TIOTOT = TIOTF14-TIOTF0

    if (ISTATE == 1) then
      CPUTOT = CPUTOT+CPUGIN
      TIOTOT = TIOTOT+TIOGIN
    else
      CPUGIN = Zero
      TIOGIN = Zero
      CPUFMB = Zero
      TIOFMB = Zero
      CPUINT = Zero
      TIOINT = Zero
    end if
  end if

  if (IPRGLB >= VERBOSE) then
    write(u6,*)
    write(u6,'(A,I6)') '  CASPT2 TIMING INFO FOR STATE ',MSTATE(JSTATE)
    write(u6,*)
    write(u6,'(A)') '                         cpu time  (s)  wall time (s)'
    write(u6,'(A)') '                         -------------  -------------'
    write(u6,*)
    write(u6,'(A,2F14.2)') '  Group initialization  ',CPUGIN,TIOGIN
    write(u6,'(A,2F14.2)') '  - Fock matrix build   ',CPUFMB,TIOFMB
    write(u6,'(A,2F14.2)') '  - integral transforms ',CPUINT,TIOINT
    write(u6,'(A,2F14.2)') '  State initialization  ',CPUSIN,TIOSIN
    write(u6,'(A,2F14.2)') '  - density matrices    ',CPUFG3,TIOFG3
    write(u6,'(A,2F14.2)') '  CASPT2 equations      ',CPUPT2,TIOPT2
    write(u6,'(A,2F14.2)') '  - H0 S/B matrices     ',CPUSBM,TIOSBM
    write(u6,'(A,2F14.2)') '  - H0 S/B diag         ',CPUEIG,TIOEIG
    write(u6,'(A,2F14.2)') '  - H0 NA diag          ',CPUNAD,TIONAD
    write(u6,'(A,2F14.2)') '  - RHS construction    ',CPURHS,TIORHS
    write(u6,'(A,2F14.2)') '  - PCG solver          ',CPUPCG,TIOPCG
    write(u6,'(A,2F14.2)') '    - scaling           ',CPUSCA,TIOSCA
    write(u6,'(A,2F14.2)') '    - lin. comb.        ',CPULCS,TIOLCS
    write(u6,'(A,2F14.2)') '    - inner products    ',CPUOVL,TIOOVL
    write(u6,'(A,2F14.2)') '    - basis transforms  ',CPUVEC,TIOVEC
    write(u6,'(A,2F14.2)') '    - sigma routines    ',CPUSGM,TIOSGM
    write(u6,'(A,2F14.2)') '  - array collection    ',CPUSER,TIOSER
    write(u6,'(A,2F14.2)') '  Properties            ',CPUPRP,TIOPRP
    if (.not. DoFCIQMC) then ! MS-CASPT2 currently not possible
      write(u6,'(A,2F14.2)') '  MS coupling           ',CPUGRD,TIOGRD
    end if
    write(u6,'(A,2F14.2)') ' Total time             ',CPUTOT,TIOTOT
    write(u6,*)
  end if

end subroutine Iter_Timing

end subroutine CASPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine ddsol72_cvb(hp,eigval,eigvec,dum,itdav,maxdav,nfrdim1,
     >  solp,solp_res,eig,eig_res)
c  Solve linear equation in Davidson subspace.
      implicit real*8 (a-h,o-z)
#include "direct_cvb.fh"
      dimension hp(maxdav,maxdav),eigval(itdav),eigvec(itdav,itdav)
      dimension solp(maxdav),solp_res(maxdav)

      if(ip.ge.3)then
        write(6,*)' HP matrix (b) :'
        call mxprint2_cvb(hp,itdav,maxdav,itdav,0)
      endif

      do it=1,itdav
      call fmove_cvb(hp(1,it),eigvec(1,it),itdav)
      enddo
      call mxdiag_cvb(eigvec,eigval,itdav)

      if(ifollow.le.2)then
        iroot=nroot
        jroot=mod(itdav,nroot)
        if(jroot.eq.0)jroot=nroot
        if(itdav.eq.maxdav.or.itdav.eq.nfrdim)jroot=nroot
        iroot=min(itdav,iroot)
        jroot=min(itdav,jroot)
        if(ifollow.eq.1)then
          iroot=itdav-iroot+1
          jroot=itdav-jroot+1
        endif
      elseif(ifollow.eq.3)then
        write(6,*)' Overlap-based root following not yet implemented!'
        call abend_cvb()
      elseif(ifollow.eq.4)then
c  Eigenvalue-based root following -- determine closest root :
        iroot=1
        delmin=abs(eigval(1)-eig)
        do 100 i=1,min(itdav,nroot)
        del=abs(eigval(i)-eig)
        if(del.lt.delmin)then
          delmin=del
          iroot=i
        endif
100     continue
        jroot=iroot
      endif
      eig=eigval(iroot)
      call fmove_cvb(eigvec(1,iroot),solp,itdav)
      eig_res=eigval(jroot)
      call fmove_cvb(eigvec(1,jroot),solp_res,itdav)
      if(ip.ge.2)then
        write(6,'(a)')' Eigenvalues :'
        call vecprint_cvb(eigval,itdav)
        write(6,'(a,i3,a)')' Eigenvector number',iroot,' :'
        call vecprint_cvb(solp,itdav)
        if(jroot.ne.iroot)then
          write(6,'(a,i3,a)')' Eigenvector number',jroot,' :'
        call vecprint_cvb(solp_res,itdav)
        endif
      endif
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real(dum)
        call Unused_integer(nfrdim1)
      end if
      end
      subroutine ddinit7_cvb(ifollow1,isaddle1,ip1)
      implicit real*8 (a-h,o-z)
#include "direct_cvb.fh"

      ifollow=ifollow1
      isaddle=isaddle1
      nroot=max(1,isaddle+1)
      ip=ip1
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FGenerator(nMat,F,iCre,iAnn,trgrd,m_Ord,mx_Ord,nOsc)

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: m_Ord, nOsc, nMat(0:m_Ord,nOsc), iCre(0:m_Ord,nOsc), iAnn(0:m_Ord,nOsc), mx_Ord
real(kind=wp), intent(out) :: F(0:m_Ord,0:mx_Ord,3)
real(kind=wp), intent(in) :: trgrd(3,nOsc)
integer(kind=iwp) :: i, iCar, iOrd, iOsc, jOrd
real(kind=wp) :: sqr(0:50)

F(:,:,:) = Zero
do i=0,50
  sqr(i) = sqrt(real(i,kind=wp)*Half)
end do
do iCar=1,3
  do iOsc=1,nOsc
    do iOrd=1,m_Ord
      jOrd = iAnn(iOrd,iOsc)
      if (jOrd >= 0) then
        F(iOrd,jOrd,iCar) = F(iOrd,jOrd,iCar)+sqr(nMat(iOrd,iOsc))*trgrd(iCar,iOsc)
      end if
    end do
  end do
  do iOsc=1,nOsc
    do iOrd=0,m_Ord
      jOrd = iCre(iord,iosc)
      if (jOrd >= 0) then
        F(iOrd,jOrd,iCar) = F(iOrd,jOrd,iCar)+sqr(nMat(jOrd,iOsc))*trgrd(iCar,iOsc)
      end if
    end do
  end do
end do

end subroutine FGenerator

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_DIAGINT(ISHLA,ISHLB,SCR,LSCR)
!
! Purpose: call Seward to calculate diagonal shell (AB|AB).

use Integral_interfaces, only: Int_PostProcess, int_wrout
#ifdef _DEBUGPRINT_
use Cholesky, only: LuPri
use Gateway_Info, only: CutInt, ThrInt
#endif
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ISHLA, ISHLB, LSCR
real(kind=wp), intent(out) :: SCR(LSCR)
procedure(int_wrout) :: Integral_Wrout_Cho_Diag
#ifdef _DEBUGPRINT_
real(kind=wp) :: CUTINT1, CUTINT2, THRINT1, THRINT2
character(len=*), parameter :: SECNAM = 'CHO_MCA_DIAGINT'
#endif

Int_PostProcess => Integral_Wrout_Cho_Diag

#ifdef _DEBUGPRINT_
CUTINT1 = CutInt
THRINT1 = ThrInt
#endif

call EVAL_IJKL(ISHLA,ISHLB,ISHLA,ISHLB,SCR,LSCR)

nullify(Int_PostProcess)
#ifdef _DEBUGPRINT_
CUTINT2 = CutInt
THRINT2 = ThrInt
if ((CUTINT2 /= CUTINT1) .or. (THRINT2 /= THRINT1)) then
  write(LUPRI,*) SECNAM,': CutInt before Eval_Ints_: ',CUTINT1
  write(LUPRI,*) SECNAM,': CutInt after  Eval_Ints_: ',CUTINT2
  write(LUPRI,*) SECNAM,': ThrInt before Eval_Ints_: ',THRINT1
  write(LUPRI,*) SECNAM,': ThrInt after  Eval_Ints_: ',THRINT2
  call CHO_QUIT('Integral prescreening error detected in '//SECNAM,102)
end if
#endif

end subroutine CHO_MCA_DIAGINT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dSd(IOpt,ICOORD,NESFJ,DERS,DERP,Tessera,Vert,Centr,Sphere,ISphe,IntSph,NVert)

use PCM_Arrays, only: MxVert
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IOpt, ICOORD, NESFJ, ISphe, IntSph(MxVert), NVert
real(kind=wp), intent(out) :: DERS, DERP(3)
real(kind=wp), intent(in) :: Tessera(4), Vert(3,MxVert), Centr(3,MxVert), Sphere(4,*)
integer(kind=iwp) :: JJ, L, L0, L1, L2, L3, NSI, NV
real(kind=wp) :: DA, DERTS, DP(MxVert,3), PROD, PT(3), RSUM, SUMDER(3), SUMVERT(3)

! Trova le derivate dell'area e del punto rappresentativo della
! tessera ITS rispetto
!
!   IOpt = 0 : alla coordinata ICOORD(1=X, 2=Y, 3=Z) dell'atomo NSJ.
!              (ex dsdx)
!   IOpt = 1 : al raggio della sfera NSJ. (ex dsdr)
!
! NESFJ e' la sfera attorno all'atomo NSJ.
! ITS appartiene alla sfera NSI (diversa da NESFJ, e intersecata
! da NESFJ).

DERTS = ZERO
NSI = ISPHE
NV = NVERT
do L=1,NV
  DP(L,1) = ZERO
  DP(L,2) = ZERO
  DP(L,3) = ZERO
end do
do L=1,NV
  if (INTSPH(L) /= NESFJ) cycle
  ! L1 e' il lato di ITS che sta sulla sfera NESFJ
  L1 = L
  L0 = L-1
  if (L1 == 1) L0 = NV
  L2 = L1+1
  if (L1 == NV) L2 = 1
  L3 = L2+1
  if (L2 == NV) L3 = 1
  ! Trova la derivata del vertice L1: DP(L1)
  call DVer(IOpt,ICOORD,L0,L1,L2,DP(L1,1),DP(L1,2),DP(L1,3),Vert,Centr,Sphere,IntSph)
  ! Trova la derivata del vertice L2: DP(L2)
  call DVer(IOpt,ICOORD,L1,-L2,L3,DP(L2,1),DP(L2,2),DP(L2,3),Vert,Centr,Sphere,IntSph)

  ! 1) Derivata dell'area della tessera.

  ! Calcola i contributi dovuti ai lati L0-L1, L1-L2, L2-L3
  if (INTSPH(L0) /= NSI) then
    call DerPhi(IOpt,ICOORD,NESFJ,L0,L1,DP,DA,Vert,Centr,Sphere,IntSph,ISphe)
    DERTS = DERTS+DA
  end if
  call DerPhi(IOpt,ICOORD,NESFJ,L1,L2,DP,DA,Vert,Centr,Sphere,IntSph,ISphe)
  DERTS = DERTS+DA
  if (INTSPH(L2) /= ISPHE) then
    call DerPhi(IOpt,ICOORD,NESFJ,L2,L3,DP,DA,Vert,Centr,Sphere,IntSph,ISphe)
    DERTS = DERTS+DA
  end if

  ! Calcola i contributi dovuti ai vertici L1 e L2
  call DerBet(IOpt,ICOORD,NESFJ,L0,L1,L2,DP,DA,Vert,Centr,Sphere,IntSph,ISphe)
  DERTS = DERTS-DA
  call DerBet(IOpt,ICOORD,NESFJ,L1,L2,L3,DP,DA,Vert,Centr,Sphere,IntSph,ISphe)
  DERTS = DERTS-DA
end do
DERS = DERTS

! 2) Derivata del punto rappresentativo.

! Trova il punto rappresentativo riferito al centro della sfera
PT(1) = Tessera(1)-Sphere(1,NSI)
PT(2) = Tessera(2)-Sphere(2,NSI)
PT(3) = Tessera(3)-Sphere(3,NSI)
! Trova il modulo della somma dei vertici della tessera
SUMVERT(:) = ZERO
do L=1,NV
  SUMVERT(:) = SUMVERT(:)+(VERT(:,L)-Sphere(1:3,NSI))
end do
RSUM = ZERO
do JJ=1,3
  RSUM = RSUM+SUMVERT(JJ)*SUMVERT(JJ)
end do
RSUM = sqrt(RSUM)
! Trova la somma delle derivate dei vertici
SUMDER(:) = DP(L1,:)+DP(L2,:)

PROD = ZERO
do JJ=1,3
  PROD = PROD+PT(JJ)*SUMDER(JJ)
end do
DERP(:) = (SUMDER(:)*Sphere(4,NSI)/RSUM)-(PT(:)*PROD/(Sphere(4,NSI)*RSUM))

return

end subroutine dSd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_VecBuf_EnableIntegrityCheck(irc)
!
! Thomas Bondo Pedersen, September 2012.
!
! Enable integrity check of buffer: allocate and store norm and sum
! of each vector in the buffer.

use Cholesky, only: CHVBFI, CHVBUF, InfVec, ip_CHVBFI_SYM, ip_CHVBUF_SYM, IPRINT, l_CHVBFI_SYM, LuPri, nDimRS, nSym, nVec_in_Buf, &
                    RUN_EXTERNAL, RUN_MODE
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), external :: dDot_
integer(kind=iwp) :: ip, ipV, iSym, jRed, jVec, l_ChVBfI

! Set return code
irc = 0

! Not implemented in internal run mode (since the buffered vectors
! may change length and hence norm and sum, causing too much book
! keeping activity for a debug feature).
if (RUN_MODE /= RUN_EXTERNAL) return

! Return if no buffer is allocated
if (.not. allocated(CHVBUF)) return

! Return if already enabled
if (allocated(CHVBFI)) return

! Check that nDimRS is allocated
if (.not. allocated(nDimRS)) then
  irc = 1
  return
end if

! Allocate and store norm and sum of each vector in the buffer
l_ChVBfI_Sym(1:nSym) = nVec_in_Buf(1:nSym)
l_ChVBfI = sum(l_ChVBfI_Sym(1:nSym))
if (l_ChVBfI > 0) then
  call mma_allocate(CHVBFI,2,l_ChVBfI,Label='CHVBFI')
  ip = 1
  do iSym=1,nSym
    ip_ChVBfI_Sym(iSym) = ip
    ip = ip+l_ChVBfI_Sym(iSym)
  end do
  do iSym=1,nSym
    ipV = ip_ChVBuf_Sym(iSym)
    ip = ip_ChvBfI_Sym(iSym)
    do jVec=1,nVec_in_Buf(iSym)
      jRed = InfVec(jVec,2,iSym)
      CHVBFI(1,ip) = sqrt(dDot_(nDimRS(iSym,jRed),CHVBUF(ipV),1,CHVBUF(ipV),1))
      CHVBFI(2,ip) = sum(CHVBUF(ipV:ipV+nDimRS(iSym,jRed)-1))
      ipV = ipV+nDimRS(iSym,jRed)
      ip = ip+1
    end do
  end do
  if (iPrint > 2) call Cho_VecBuf_PrtRef('@NABLE')
  write(LuPri,'(A)') 'Cholesky vector buffer integrity checks enabled'
else
  l_ChVBfI_Sym(1:nSym) = 0
  ip_ChVBfI_Sym(1:nSym) = 0
end if

end subroutine Cho_VecBuf_EnableIntegrityCheck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE READCI(ISTATE,ISGS,ICIS,NCI,CI)
      use rassi_global_arrays, only: JBNUM, LROOT
#ifdef _HDF5_
      USE mh5, ONLY: mh5_is_hdf5, mh5_open_file_r, mh5_exists_attr,
     &               mh5_fetch_attr, mh5_fetch_dset, mh5_close_file
#endif
      IMPLICIT NONE
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='READCI')
#include "rasdim.fh"
#include "cntrl.fh"
#include "Files.fh"
#include "WrkSpc.fh"
#include "rassi.fh"
#include "jobin.fh"
#include "Struct.fh"
#include "SysDef.fh"
#ifdef _HDF5_
      integer :: refwfn_id
      integer :: root2state(mxroot), IDXCI
#endif

      INTEGER ISTATE
      INTEGER ISGS(NSGSIZE), ICIS(NCISIZE)
      INTEGER NCI
      REAL*8 CI(NCI)

      INTEGER I, IAD, IDISK, JOB, LROOT1, LSYM


      IF(ISTATE.LT.1 .OR. ISTATE.GT.NSTATE) THEN
        WRITE(6,*)'RASSI/READCI: Invalid ISTATE parameter.'
        WRITE(6,*)' ISTATE, NSTATE:',ISTATE,NSTATE
        CALL ABEND()
      END IF
      JOB=JBNUM(ISTATE)
      LROOT1=LROOT(ISTATE)

#ifdef _HDF5_
************************************************************************
*
* For HDF5 formatted job files
*
************************************************************************
      If (mh5_is_hdf5(jbname(job))) Then
        refwfn_id = mh5_open_file_r(jbname(job))
        if (mh5_exists_attr(refwfn_id, 'ROOT2STATE')) then
          call mh5_fetch_attr(refwfn_id,'ROOT2STATE',root2state)
          IDXCI = root2state(lroot1)
        else
          IDXCI = lroot1
        end if
        IF (IDXCI.LE.0.OR.IDXCI.GT.NROOTS(JOB)) THEN
          call WarningMessage(2,'Invalid CI array index, abort!')
          call AbEnd
        END IF
        call mh5_fetch_dset(refwfn_id,
     &         'CI_VECTORS',CI,[NCI,1],[0,IDXCI-1])
        call mh5_close_file(refwfn_id)
      Else
#endif
************************************************************************
*
* For JOBIPH/JOBMIX formatted job files
*
************************************************************************
        CALL DANAME(LUIPH,JBNAME(JOB))
        IAD=0
        CALL IDAFILE(LUIPH,2,ITOC15,30,IAD)
        IDISK=ITOC15(4)
        DO I=1,LROOT1-1
          CALL DDAFILE(LUIPH,0,CI,NCI,IDISK)
        END DO
        CALL DDAFILE(LUIPH,2,CI,NCI,IDISK)
        CALL DACLOS(LUIPH)
************************************************************************
#ifdef _HDF5_
      End If
#endif

      IF(IPGLOB.gt.SILENT .and. PRCI) THEN
        WRITE(6,*)' READCI called for state ',ISTATE
        WRITE(6,*)' This is on JobIph nr.',JOB
        WRITE(6,*)' JobIph file name:',JBNAME(JOB)
        WRITE(6,*)' It is root nr.',LROOT(ISTATE)
        WRITE(6,*)' Its length NCI=',NCI
        WRITE(6,*)' Its symmetry  =',IRREP(JOB)
        WRITE(6,*)' Spin multiplic=',MLTPLT(JOB)
        LSYM=IRREP(JOB)
        CALL PRWF(ISGS,ICIS,LSYM,CI,CITHR)
      END IF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Box(Coor,mTtAtm,iANr,TabB,TabA,nBonds,nMax)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two, Eight
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mTtAtm, iANr(mTtAtm)
real(kind=wp), intent(in) :: Coor(3,mTtAtm)
integer(kind=iwp), intent(out) :: nBonds, nMax
integer(kind=iwp), allocatable, intent(out) :: TabB(:,:), TabA(:,:,:)
integer(kind=iwp) :: iAtom, nBondMax, nx, ny, nz
real(kind=wp) :: adjust, Box_Size, ThrB, xmax, xmin, ymax, ymin, zmax, zmin
integer(kind=iwp), allocatable :: iBox(:,:), Tab(:,:,:,:)

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
if (mTtAtm < 2) then
  write(u6,*) 'Too few atoms to relax: mTtAtm=',mTtAtm
  call WarningMessage(2,'mTtAtm < 2')
  call Abend()
end if

ThrB = 0.4_wp
#ifdef _DEBUGPRINT_
call RecPrt('Box: Coor',' ',Coor,3,mTtAtm)
write(u6,*) 'Box: ThrB=',ThrB
#endif

xmin = 1.0e10_wp
ymin = 1.0e10_wp
zmin = 1.0e10_wp
xmax = -1.0e10_wp
ymax = -1.0e10_wp
zmax = -1.0e10_wp

! Establish boundaries

do iAtom=1,mTtAtm
  xmin = min(xmin,Coor(1,iAtom))
  xmax = max(xmax,Coor(1,iAtom))
  ymin = min(ymin,Coor(2,iAtom))
  ymax = max(ymax,Coor(2,iAtom))
  zmin = min(zmin,Coor(3,iAtom))
  zmax = max(zmax,Coor(3,iAtom))
end do
xmin = xmin-1.0e-2_wp
xmax = xmax+1.0e-2_wp
ymin = ymin-1.0e-2_wp
ymax = ymax+1.0e-2_wp
zmin = zmin-1.0e-2_wp
zmax = zmax+1.0e-2_wp

Box_Size = Eight  ! a.u.
nx = max(1,int((xmax-xmin)/Box_Size)+1)
adjust = (nx*Box_size-(xmax-xmin))/Two
xmin = xmin-adjust
xmax = xmax+adjust
ny = max(1,int((ymax-ymin)/Box_Size)+1)
adjust = (ny*Box_size-(ymax-ymin))/Two
ymin = ymin-adjust
ymax = ymax+adjust
nz = max(1,int((zmax-zmin)/Box_Size)+1)
adjust = (nz*Box_size-(zmax-zmin))/Two
zmin = zmin-adjust
zmax = zmax+adjust
#ifdef _DEBUGPRINT_
write(u6,*) 'nx,ny,nz=',nx,ny,nz
#endif

nMax = 100
!nf nMax = 40
! AOM Fixed this size to account for double VdW counting
nBondMax = mTtAtm*(mTtAtm+1)
! AOM
call mma_allocate(TabB,3,nBondMax,Label='TabB')
call mma_allocate(TabA,[1,2],[0,nMax],[1,mTtAtm],Label='TabA')
call mma_allocate(Tab,[0,nMax],[1,nx],[1,ny],[1,nz],Label='Tab')
call mma_allocate(iBox,3,mTtAtm,Label='iBox')

call Sort_to_Box(Coor,mTtAtm,Tab,nMax,nx,ny,nz,iBox,iANr,xmin,ymin,zmin,Box_Size)

call Find_Bonds(Coor,mTtAtm,Tab,nMax,nx,ny,nz,iBox,iANr,TabB,nBonds,nBondMax,TabA,ThrB)

call mma_deallocate(iBox)
call mma_deallocate(Tab)

return

#undef _DEBUGPRINT_
end subroutine Box

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Put_Chunk(MuNu_s,MuNu_e,j_s,j_e,Rv,nMuNu,LenVec)

use RI_glob, only: Chunk
#ifdef _MOLCAS_MPP_
use RI_glob, only: ip_Chunk
use Para_Info, only: Is_Real_Par
#endif
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: MuNu_s, MuNu_e, j_s, j_e, nMuNu, LenVec
real(kind=wp), intent(inout) :: Rv(nMuNu,j_e-j_s+1)
integer(kind=iwp) :: jp_ChoVec, jVec, mMuNu, NumVec_

#ifndef _MOLCAS_MPP_
#include "macros.fh"
unused_var(MuNu_e)
#endif

!                                                                      *
!***********************************************************************
!                                                                      *

NumVec_ = j_e-j_s+1

#ifdef _MOLCAS_MPP_
if (NumVec_ > 0) then
  if (Is_Real_Par()) then
    call GA_Put(ip_Chunk,MuNu_s,MuNu_e,j_s,j_e,Rv,nMuNu)
  else
#endif
    mMuNu = MuNu_s-1
    jp_ChoVec = 1+mMuNu
    do jVec=1,NumVec_
      Chunk(jp_ChoVec:jp_ChoVec+nMuNu-1) = Rv(:,jVec)
      jp_ChoVec = jp_ChoVec+LenVec
    end do
#ifdef _MOLCAS_MPP_
  end if
end if
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Put_Chunk

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Markus P. Fuelscher                              *
!***********************************************************************
!  readvc_m
!
!> @brief get start MO coeffients
!>
!> @author M. P. Fuelscher
!> @author Matthew R. Hennefarth
!>
!> @param[out] cmo mo coefficients
!***********************************************************************

subroutine ReadVC_m(CMO)

use PrintLevel, only: DEBUG, TERSE, VERBOSE
use mcpdft_output, only: iPrGlb, iPrLoc
use mcpdft_input, only: mcpdft_options
use general_data, only: invec, jobiph, jobold, ntot2
#ifdef _HDF5_
use mh5, only: mh5_close_file, mh5_fetch_dset, mh5_open_file_r
#endif
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: CMO(ntot2)
integer(kind=iwp) :: iad19, IADR19(30), ijob, iprlev
#ifdef _HDF5_
integer(kind=iwp) ::mh5id
#endif
logical(kind=iwp) :: Found

IPRLEV = IPRLOC(1)
if (IPRLEV >= DEBUG) write(u6,*) ' Entering READVC'

! invec can either be 3 or 4 based off of proc_inpx
! can also be 5 (if FileOrb points to a non hdf5 reference file)

! read from unit formatted ascii file with starting orbitals

! Note: Inside RDVEC, the file wfn_file is opened, but uses blindly
! the unit number provided here. So that should better be a usable
! number, or else!
! read from unit JOBOLD (binary file)
if (InVec == 3) then
  IAD19 = 0
  iJOB = 0
  call f_Inquire('JOBOLD',Found)
  if (Found) iJOB = 1
  if (iJOB == 1) then
    if (JOBOLD <= 0) then
      JOBOLD = 20
      call DaName(JOBOLD,'JOBOLD')
    end if
  else
    if (IPRLEV >= TERSE) write(u6,*) '  File JOBOLD not found -- use JOBIPH.'
    if (JOBIPH > 0) then
      JOBOLD = JOBIPH
    else
      call DaName(JOBOLD,mcpdft_options%wfn_file)
    end if
  end if
  call IDaFile(JOBOLD,2,IADR19,15,IAD19)
  if (IADR19(15) == -1) then
    IAD19 = 0
    call IDAFILE(JOBOLD,2,IADR19,30,IAD19)
  else
    IADR19(16:30) = 0
    if (IPRGLB >= VERBOSE) call WarningMessage(1,'Old JOBIP file layout.')
  end if
  if (IPRLEV >= TERSE) then
    if (iJOB == 1) then
      write(u6,'(6X,A)') 'The MO-coefficients are taken from the file:'
      write(u6,'(6X,A)') 'JOBOLD'
    else
      write(u6,'(6X,A)') 'The MO-coefficients are taken from the file:'
      write(u6,'(6X,A)') trim(mcpdft_options%wfn_file)
    end if
  end if

  iAd19 = iAdr19(2)
  call DDaFile(JobOld,2,CMO,NTOT2,iAd19)

  if ((JOBOLD > 0) .and. (JOBOLD /= JOBIPH)) then
    call DaClos(JOBOLD)
    JOBOLD = -1
  else if (JOBOLD > 0) then
    JOBOLD = -1
  end if

else if (InVec == 4) then
  ! read from a HDF5 wavefunction file
# ifdef _HDF5_
  if (IPRLEV >= TERSE) then
    write(u6,'(6X,A)') 'The MO-coefficients are taken from the file:'
    write(u6,'(6X,A)') trim(mcpdft_options%wfn_file)
  end if

  mh5id = mh5_open_file_r(mcpdft_options%wfn_file)
  call mh5_fetch_dset(mh5id,'MO_VECTORS',CMO)
  call mh5_close_file(mh5id)
# else
  write(u6,*) 'Orbitals requested from HDF5, but this'
  write(u6,*) 'installation does not support that, abort!'
  call abend()
# endif
else if (invec == 5) then
  write(u6,*) 'FileOrb specified, but does not point to hdf5 file'
  write(u6,*) 'This has not been implemented, aborting'
  call abend()
end if

end subroutine ReadVC_m

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetSh_Localisation(X,nBas,m,XSh,nShell,iSO2Sh,iOpt,Norm)

use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nBas, m, nShell, iSO2Sh(*), iOpt
real(kind=wp), intent(in) :: X(nBas,m)
real(kind=wp), intent(_OUT_) :: XSh(nShell,*)
character(len=3), intent(in) :: Norm  ! 'MAX' or 'FRO'
integer(kind=iwp) :: i, iShell, j, jShell
character(len=3) :: myNorm

if ((nBas < 1) .or. (nShell < 1)) return

myNorm = Norm
call UpCase(myNorm)

if (iOpt == 1) then
  XSh(:,1:m) = Zero
  if (myNorm == 'MAX') then
    do j=1,m
      do i=1,nBas
        iShell = iSO2Sh(i)
        XSh(iShell,j) = max(abs(X(i,j)),XSh(iShell,j))
      end do
    end do
  else if (myNorm == 'FRO') then
    do j=1,m
      do i=1,nBas
        iShell = iSO2Sh(i)
        XSh(iShell,j) = XSh(iShell,j)+X(i,j)**2
      end do
      do iShell=1,nShell
        XSh(iShell,j) = sqrt(XSh(iShell,j))
      end do
    end do
  end if
else
  if (m /= nBas) call SysAbendMsg('GetSh_Localisation','Fatal error','m != nBas')
  XSh(:,1:nShell) = Zero
  if (myNorm == 'MAX') then
    do j=1,nBas
      jShell = iSO2Sh(j)
      do i=1,nBas
        iShell = iSO2Sh(i)
        XSh(iShell,jShell) = max(abs(X(i,j)),XSh(iShell,jShell))
      end do
    end do
  else if (myNorm == 'FRO') then
    do j=1,nBas
      jShell = iSO2Sh(j)
      do i=1,nBas
        iShell = iSO2Sh(i)
        XSh(iShell,jShell) = XSh(iShell,jShell)+X(i,j)**2
      end do
      Xsh(:,jShell) = sqrt(Xsh(:,jShell))
    end do
  end if
end if

end subroutine GetSh_Localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_Word2Byte
*
*> @brief
*>   Convert integer number of \p n -byte words to byte with a reasonable prefix (``-``, ``k``, ``M``, ``G``, or ``T``)
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Convert integer number of \p n -byte words to byte, kilobyte,
*> megabyte, gigabyte, or terabyte.
*>
*> @param[in]  iWord Number of \p n -byte words
*> @param[in]  n     Number of byte per word
*> @param[out] Byte  \p iWord in bytes/kb/Mb/Gb/Tb
*> @param[out] Unt   Unit of Byte ['``b ``', '``kb``', '``Mb``', '``Gb``', or '``Tb``']
************************************************************************
      SubRoutine Cho_Word2Byte(iWord,n,Byte,Unt)
      Implicit None
      Integer     iWord, n
      Real*8      Byte
      Character*2 Unt

      Byte = DBLE(iWord)*DBLE(n)
      Unt  = 'b '
      If (ABS(Byte) .gt. 1.0d3) Then
         Byte = Byte/1.024d3
         Unt  = 'kb'
         If (ABS(Byte) .gt. 1.0d3) Then
            Byte = Byte/1.024d3
            Unt  = 'Mb'
            If (ABS(Byte) .gt. 1.0d3) Then
               Byte = Byte/1.024d3
               Unt  = 'Gb'
               If (ABS(Byte) .gt. 1.0d3) Then
                  Byte = Byte/1.024d3
                  Unt  = 'Tb'
               End If
            End If
         End If
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Prim_Atom_Tab(nAtoms,nPrim,
     &Work,CENTX,CENTY,CENTZ)
      Implicit Real*8 (a-h,o-z)

#include "MolProp.fh"
      Dimension Work(3*nAtoms)
! Begin EB
! EB     Dimension CENTX(nPrim),CENTY(nPrim),CENTZ(nPrim)
      Dimension CENTX(nPrim*(nPrim+1)/2),
     &          CENTY(nPrim*(nPrim+1)/2),
     &          CENTZ(nPrim*(nPrim+1)/2)
! End EB
*
*---- Get the primitiv basis that belongs to a specific atom
*
      Do i=1,nAtoms
         nAtomPBas(i) = 0
         Do j=1,nPrim
            If((ABS(Work((i-1)*3+1)-CENTX(j*(j-1)/2+j)).le.1E-10).and.
     &         (ABS(Work((i-1)*3+2)-CENTY(j*(j-1)/2+j)).le.1E-10).and.
     &         (ABS(Work((i-1)*3+3)-CENTZ(j*(j-1)/2+j)).le.1E-10))Then
               nAtomPBas(i) = nAtomPBas(i) + 1
               iAtPrTab(nAtomPBas(i),i) = j
!               Write(*,*)'Atom tab',i,j,CENTX(j*(j-1)/2+j),
!     &         CENTY(j*(j-1)/2+j),CENTZ(j*(j-1)/2+j),nAtomPBas(i)
            EndIf
         EndDo
      EndDo

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GF(nX,nDoF,nInter,EVec,EVal,RedM,iNeg,dDipM,mTR,nAtom,
     &              DipM)
      use Slapaf_Info, only: Smmtrc
      use Slapaf_parameters, only: nDimBC
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 dDipM(3,nInter+mTR), DipM(3),
     &       EVec(2*nDoF,nDoF), EVal(2*nDoF), RedM(nDoF)
      Real*8, Allocatable:: G(:), GInv(:), F(:), Tmp1(:), Tmp2(:)
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('GF: dDipM',' ',dDipM,3,nInter)
      Call RecPrt('GF: DipM',' ',DipM,3,1)
#endif
      Call mma_allocate(Tmp1,nX**2,Label='Tmp1')
      Call mma_allocate(Tmp2,nX**2,Label='Tmp2')
*                                                                      *
************************************************************************
*                                                                      *
*     Note that all calculations will be done in the Cartesian basis!  *
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute harmonic frequencies
*                                                                      *
************************************************************************
*                                                                      *
*     Generate the G matrix (mass tensor in cartesians)
*
      Call mma_allocate(G,nDimBC**2,Label='G')
      Call mma_allocate(GInv,nDimBC**2,Label='GInv')
      Call Mk_G(G,GInv,nDimBC)
*
*
*     Get the force constant matrix in cartesians
*
      Call mma_allocate(F,nX**2,Label='F')
      Call Get_H(F,nX)
*                                                                      *
************************************************************************
*                                                                      *
*     Form the GF-matrix (actually G^(1/2)FG^(1/2))
*
      Call GF_Mult(G,F,Tmp2,nDoF)  ! Result in Tmp2
      Call mma_deallocate(F)
*
*     Compute the frequencies and harmonic eigenfunctions in
*     Cartesians.
*
      Call GF_Harmonic_Frequencies(G,GInv,Tmp1,Tmp2,EVec,EVal,RedM,
     &                             iNeg,nX,nDoF)
*
      Call mma_deallocate(G)
      Call mma_deallocate(GInv)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Compute the dipole moment derivative in Cartesians.
*
      Call Get_dDipM(dDipM,DipM,nDoF,nInter)
*                                                                      *
************************************************************************
*                                                                      *
*    Transform from cartesian to normal coordinates
*
      Do iNC = 1, nDoF
         call dcopy_(nDoF,EVec(1,iNC),2,Tmp2,1)
         ix = (iNC-1)*3 + 1
         iy = (iNC-1)*3 + 2
         iz = (iNC-1)*3 + 3
         Tmp1(ix) = Zero
         Tmp1(iy) = Zero
         Tmp1(iz) = Zero
         i = 0
         Do iAtom = 1, nAtom
            Do ixyz = 1, 3
               If (Smmtrc(ixyz,iAtom)) Then
                  i = i + 1
                  Tmp1(ix) = Tmp1(ix) + dDipM(1,i)*Tmp2(i)
                  Tmp1(iy) = Tmp1(iy) + dDipM(2,i)*Tmp2(i)
                  Tmp1(iz) = Tmp1(iz) + dDipM(3,i)*Tmp2(i)
               End If
            End Do
         End Do
      End Do
      call dcopy_(3*nDoF,Tmp1,1,dDipM,1)
#ifdef _DEBUGPRINT_
      Call RecPrt('dDipM(normal coord.)',' ',dDipM,3,nDoF)
#endif
      Call mma_deallocate(Tmp2)
      Call mma_deallocate(Tmp1)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine IndSft_Cho(TInt,lInt,iCmp,iShell,iBas,jBas,kBas,lBas,Shijij,iAO,iAOst,ijkl,SOint,nSOint)
!***********************************************************************
!  object: to sift and index the SO integrals.                         *
!                                                                      *
!          the indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          april '90                                                   *
!                                                                      *
!***********************************************************************

use Symmetry_Info, only: nIrrep
use Index_Functions, only: iTri, nTri_Elem
use SOAO_Info, only: iAOtSO, iOffSO
use Cholesky, only: iShlSO, iSOShl, LuPri, nBstSh, ShA, ShB, ShC, ShD
use sort_data, only: nSkip
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Constants, only: Zero, One
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: lInt, iCmp(4), iShell(4), iBas, jBas, kBas, lBas, iAO(4), iAOst(4), ijkl, nSOint
real(kind=wp), intent(inout) :: TInt(lInt)
logical(kind=iwp), intent(in) :: Shijij
real(kind=wp), intent(in) :: SOint(ijkl,nSOint)
integer(kind=iwp) :: A, B, C, D, AB, CD, CDAB, ABCD, i1, i12, i2, i3, i34, i4, ISHLAB, ISHLCD, ISHLI, ISHLJ, ISHLK, ISHLL, iSO, &
                     iSOi, iSym(0:7), ix, j, j1, j12, j2, j2max, j3, j4, jCmpMx, jSO, jSOj, jSym(0:7), k12, k34, kSO, kSOk, &
                     kSym(0:7), lCmpMx, lSO, lSOl, lSym(0:7), memSO2, NCDAB, nijkl, NTELM, NUMA, NUMAB, NUMB, NUMC, NUMCD, NUMD
logical(kind=iwp) :: Shij, Shkl, qijij, qij, qkl
#ifdef _DEBUGPRINT_
real(kind=wp) :: r1, r2, tr1 = Zero, tr2 = Zero
real(kind=wp), external :: ddot_

r1 = DDot_(ijkl*nSOInt,SOInt,1,[One],0)
r2 = DDot_(ijkl*nSOInt,SOInt,1,SOInt,1)
tr1 = tr1+r1
tr2 = tr2+r2
write(u6,*) ' Sum=',r1,tr1
write(u6,*) ' Dot=',r2,tr2
call RecPrt(' in indsft:SOint ',' ',SOint,ijkl,nSOint)
#endif

k12 = 0
k34 = 0
memSO2 = 0

NUMC = NBSTSH(SHC)
NUMD = NBSTSH(SHD)
NUMA = NBSTSH(SHA)
NUMB = NBSTSH(SHB)

if (SHC == SHD) then
  NUMCD = nTri_Elem(NUMC)
else
  NUMCD = NUMC*NUMD
end if
if (SHA == SHB) then
  NUMAB = nTri_Elem(NUMA)
else
  NUMAB = NUMA*NUMB
end if
NCDAB = NUMCD*NUMAB
if (NCDAB /= LINT) then
  write(LUPRI,*) 'IndSft_Cho: dimension of integral array: ',NCDAB
  write(LUPRI,*) 'IndSft_Cho: expected                   : ',LINT
  write(LUPRI,*) 'IndSft_Cho: YOU HAVE A DIMENSION PROBLEM!'
end if

ISHLCD = ITRI(SHC,SHD)
ISHLAB = ITRI(SHA,SHB)

! to avoid stupid compiler warnings:

C = 0
D = 0
A = 0
B = 0

NTELM = 0

! allocate space to store integrals to gether with their
! Symmetry batch and sequence number
! To avoid conflicts in using memory this is done in the
! subroutine PSOAO

! quadruple loop over elements of the basis functions angular
! description. loops are reduced to just produce unique SO integrals
! observe that we will walk through the memory in AOint in a
! sequential way.

Shij = iShell(1) == iShell(2)
Shkl = iShell(3) == iShell(4)
do i1=1,iCmp(1)
  do j=0,nIrrep-1
    ix = 0
    if (iAOtSO(iAO(1)+i1,j) > 0) ix = 2**j
    iSym(j) = ix
  end do
  jCmpMx = iCmp(2)
  if (Shij) jCmpMx = i1
  do i2=1,jCmpMx
    do j=0,nIrrep-1
      ix = 0
      if (iAOtSO(iAO(2)+i2,j) > 0) ix = 2**j
      jSym(j) = ix
    end do
    qij = i1 == i2
    if (iShell(2) > iShell(1)) then
      i12 = iCmp(2)*(i1-1)+i2
    else
      i12 = iCmp(1)*(i2-1)+i1
    end if
    do i3=1,iCmp(3)
      do j=0,nIrrep-1
        ix = 0
        if (iAOtSO(iAO(3)+i3,j) > 0) ix = 2**j
        kSym(j) = ix
      end do
      lCmpMx = iCmp(4)
      if (Shkl) lCmpMx = i3
      do i4=1,lCmpMx
        do j=0,nIrrep-1
          ix = 0
          if (iAOtSO(iAO(4)+i4,j) > 0) ix = 2**j
          lSym(j) = ix
        end do
        qkl = i3 == i4
        if (iShell(4) > iShell(3)) then
          i34 = iCmp(4)*(i3-1)+i4
        else
          i34 = iCmp(3)*(i4-1)+i3
        end if
        if (Shijij .and. (i34 > i12)) cycle
        qijij = Shijij .and. (i12 == i34)

        ! loop over Irreps which are spanned by the basis function.
        ! again, the loop structure is restricted to ensure unique
        ! integrals.

        do j1=0,nIrrep-1
          if (iSym(j1) == 0) cycle
          j2max = nIrrep-1
          if (Shij .and. qij) j2max = j1
          do j2=0,j2max
            if (jSym(j2) == 0) cycle
            j12 = ieor(j1,j2)
            if (qijij) then
              if (Shij .and. qij) then
                k12 = nTri_Elem(j1)+j2+1
              else if (Shij) then
                k12 = nIrrep*j1+j2+1
              else if (iShell(1) > iShell(2)) then
                k12 = nIrrep*j1+j2+1
              else
                k12 = nIrrep*j2+j1+1
              end if
            end if

            do j3=0,nIrrep-1
              if (kSym(j3) == 0) cycle
              j4 = ieor(j12,j3)
              if (lSym(j4) == 0) cycle
              if (Shkl .and. qkl .and. (j4 > j3)) cycle
              if (qijij) then
                if (Shkl .and. qkl) then
                  k34 = nTri_Elem(j3)+j4+1
                else if (Shkl) then
                  k34 = nIrrep*j3+j4+1
                else if (iShell(3) > iShell(4)) then
                  k34 = nIrrep*j3+j4+1
                else
                  k34 = nIrrep*j4+j3+1
                end if
                if (k34 > k12) cycle
              end if

              memSO2 = memSO2+1
              if ((nSkip(j1+1)+nSkip(j2+1)+nSkip(j3+1)+nSkip(j4+1)) /= 0) cycle

              ! Compute absolute starting SO index
              iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)+iOffSO(j1)
              jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)+iOffSO(j2)
              kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+iOffSO(j3)
              lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+iOffSO(j4)

              nijkl = 0
              do lSOl=lSO,lSO+lBas-1
                do kSOk=kSO,kSO+kBas-1
                  do jSOj=jSO,jSO+jBas-1
                    do iSOi=iSO,iSO+iBas-1
                      nijkl = nijkl+1

                      NTELM = NTELM+1

                      ISHLI = ISOSHL(ISOI)
                      ISHLJ = ISOSHL(JSOJ)
                      ISHLK = ISOSHL(KSOK)
                      ISHLL = ISOSHL(LSOL)

                      if ((ISHLI == SHC) .and. (ISHLJ == SHD) .and. (ISHLK == SHA) .and. (ISHLL == SHB)) then
                        C = ISHLSO(ISOI)
                        D = ISHLSO(JSOJ)
                        A = ISHLSO(KSOK)
                        B = ISHLSO(LSOL)
                      else if ((ISHLJ == SHC) .and. (ISHLI == SHD) .and. (ISHLK == SHA) .and. (ISHLL == SHB)) then
                        C = ISHLSO(JSOJ)
                        D = ISHLSO(ISOI)
                        A = ISHLSO(KSOK)
                        B = ISHLSO(LSOL)
                      else if ((ISHLI == SHC) .and. (ISHLJ == SHD) .and. (ISHLL == SHA) .and. (ISHLK == SHB)) then
                        C = ISHLSO(ISOI)
                        D = ISHLSO(JSOJ)
                        A = ISHLSO(LSOL)
                        B = ISHLSO(KSOK)
                      else if ((ISHLJ == SHC) .and. (ISHLI == SHD) .and. (ISHLL == SHA) .and. (ISHLK == SHB)) then
                        C = ISHLSO(JSOJ)
                        D = ISHLSO(ISOI)
                        A = ISHLSO(LSOL)
                        B = ISHLSO(KSOK)
                      else if ((ISHLK == SHC) .and. (ISHLL == SHD) .and. (ISHLI == SHA) .and. (ISHLJ == SHB)) then
                        C = ISHLSO(KSOK)
                        D = ISHLSO(LSOL)
                        A = ISHLSO(ISOI)
                        B = ISHLSO(JSOJ)
                      else if ((ISHLL == SHC) .and. (ISHLK == SHD) .and. (ISHLI == SHA) .and. (ISHLJ == SHB)) then
                        C = ISHLSO(LSOL)
                        D = ISHLSO(KSOK)
                        A = ISHLSO(ISOI)
                        B = ISHLSO(JSOJ)
                      else if ((ISHLK == SHC) .and. (ISHLL == SHD) .and. (ISHLJ == SHA) .and. (ISHLI == SHB)) then
                        C = ISHLSO(KSOK)
                        D = ISHLSO(LSOL)
                        A = ISHLSO(JSOJ)
                        B = ISHLSO(ISOI)
                      else if ((ISHLL == SHC) .and. (ISHLK == SHD) .and. (ISHLJ == SHA) .and. (ISHLI == SHB)) then
                        C = ISHLSO(LSOL)
                        D = ISHLSO(KSOK)
                        A = ISHLSO(JSOJ)
                        B = ISHLSO(ISOI)
                      else
                        write(LUPRI,*) 'Shell quadruple requested: ',SHC,SHD,SHA,SHB
                        write(LUPRI,*) 'Shell quadruple of element ',NTELM,':',ISHLI,ISHLJ,ISHLK,ISHLL
                        call CHO_QUIT('Logical error in IndSft_Cho',103)
                      end if

                      if (SHA == SHB) then
                        AB = ITRI(A,B)
                      else
                        AB = NUMA*(B-1)+A
                      end if
                      if (SHC == SHD) then
                        CD = ITRI(C,D)
                      else
                        CD = NUMC*(D-1)+C
                      end if

                      CDAB = NUMCD*(AB-1)+CD
#                     ifdef _DEBUGPRINT_
                      if ((CDAB > LINT) .or. (CDAB < 1)) then
                        write(LUPRI,*) 'CDAB: ',CDAB
                        write(LUPRI,*) 'Dimension: ',LINT
                        call CHO_QUIT('IndSft_Cho: Error!',104)
                      end if
#                     endif
                      TINT(CDAB) = SOint(nijkl,memSO2)
                      if (ISHLCD == ISHLAB) then
                        if ((SHC == SHD) .or. (SHC == SHA)) then
                          ABCD = NUMAB*(CD-1)+AB
                          TINT(ABCD) = SOint(nijkl,memSO2)
                        else if (SHC == SHB) then
                          CD = NUMD*(C-1)+D
                          AB = NUMB*(A-1)+B
                          ABCD = NUMAB*(CD-1)+AB
                          TINT(ABCD) = SOint(nijkl,memSO2)
                        end if
                      end if

                    end do
                  end do
                end do
              end do

            end do
          end do
        end do

      end do
    end do
  end do
end do

return

end subroutine IndSft_Cho

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
function ISYMST(STRING,NEL)
! Symmmetry of string, D2H version

use Symmetry_Info, only: Mul
use lucia_data, only: ISMFTO
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: ISYMST
integer(kind=iwp), intent(in) :: NEL, STRING(NEL)
integer(kind=iwp) :: IEL

ISYMST = 1
do IEL=1,NEL
  ISYMST = Mul(ISYMST,ISMFTO(STRING(IEL)))
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' ISYMST, String and symmetry'
call IWRTMA(STRING,1,NEL,1,NEL)
write(u6,*) ISYMST
#endif

end function ISYMST

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SigmaVec(C,HC,kic)
      Use Str_Info
*
* Outer routine for sigma vector generation
* RAS space
* This is a driver routine change in some rows just so it s
* should work in my mclr program. Of course I have to change
* the name on it but if you look in Jeppes mv7old(relaci) you
* will find a subroutine that looks very much like this
* This routine is just a setup routine for memory etc
*
      IMPLICIT REAL*8(A-H,O-Z)
*
* =====
*.Input
* =====
*
#include "cands.fh"
#include "detdim.fh"
#include "orbinp_mclr.fh"
#include "cicisp_mclr.fh"
#include "cstate_mclr.fh"
#include "csm.fh"
#include "stdalloc.fh"
#include "crun_mclr.fh"

#include "Input.fh"
#include "cprnt_mclr.fh"
#include "genop.fh"
#include "csmprd.fh"
      Dimension C(*),HC(*),kic(2)
      Integer sxstsm(1)
      Dimension idummy(1)
      Integer, Allocatable:: STSTS(:), STSTD(:), SVST(:),
     &                       SIOIO(:), CIOIO(:),
     &                       SBLTP(:), CBLTP(:),
     &                       I1(:), I2(:), I3(:), I4(:),
     &                       OOS(:,:)
      Real*8, Allocatable:: SB(:), CB(:), INSCR(:),
     &                      XI1S(:), XI2S(:), XI3S(:), XI4S(:)
      Real*8, Target, Allocatable:: C2(:), CJRES(:), SIRES(:)
      Real*8, Pointer:: pC2(:), pCJRES(:), pSIRES(:)

      LUC=0
      LUHC=0
      ZERO = 0.0D0
      IDUMMY(1) = 0
      NSDET = NINT(XISPSM(ISSM,ISSPC))
*
*. The story of MV7 : I started out from nothing, absolutely zero,
*
      call dcopy_(NSDET,[Zero],0,HC,1)
*
* Info for this internal space
*
      IATP = IASTFI(ISSPC)
      IBTP = IBSTFI(ISSPC)
      JATP = IASTFI(ICSPC)
      JBTP = IBSTFI(ICSPC)
      IF(IATP.NE.JATP.OR.IBTP.NE.JBTP) THEN
        WRITE(6,*) ' My world is falling apart'
        WRITE(6,*) ' C and sigma belongs to different types of strings'
        WRITE(6,*) ' IATP IBTP JATP JBTP ',IATP,IBTP,JATP,JBTP
        Call Abend
      END IF
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
* string sym, string sym => sx sym
* string sym, string sym => dx sym
      Call mma_allocate(STSTS,NSMST**2,Label='STSTS')
      Call mma_allocate(STSTD,NSMST**2,Label='STSTD')

      CALL STSTSM_MCLR(STSTS,STSTD,NSMST)

*. Largest block of strings in zero order space
      MAXA0 = IMNMX(Str(IATP)%NSTSO,NSMST*NOCTYP(IATP),2)
      MAXB0 = IMNMX(Str(IBTP)%NSTSO,NSMST*NOCTYP(IBTP),2)
      MXSTBL0 = MAX(MAXA0,MAXB0)
*. Largest number of strings of given symmetry and type
      MAXA = 0
      IF(NAEL.GE.1) THEN
        MAXA1 = IMNMX(Str(IATP+1)%NSTSO,NSMST*NOCTYP(IATP+1),2)
        MAXA = MAX(MAXA,MAXA1)
      END IF
      IF(NAEL.GE.2) THEN
        MAXA1 = IMNMX(Str(IATP+2)%NSTSO,NSMST*NOCTYP(IATP+2),2)
        MAXA = MAX(MAXA,MAXA1)
      END IF
      MAXB = 0
      IF(NBEL.GE.1) THEN
        MAXB1 = IMNMX(Str(IBTP+1)%NSTSO,NSMST*NOCTYP(IBTP+1),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      IF(NBEL.GE.2) THEN
        MAXB1 = IMNMX(Str(IBTP+2)%NSTSO,NSMST*NOCTYP(IBTP+2),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      MXSTBL = MAX(MAXA,MAXB)
      IF(IPRCIX.GE.2 ) WRITE(6,*)
     &' Largest block of strings with given symmetry and type',MXSTBL
      MAXI = MIN( MXINKA,MXSTBL)
      MAXK = MIN( MXINKA,MXSTBL)
*Largest active orbital block belonging to given type and symmetry
      MXTSOB = IMNMX(NTSOB,3*NSMOB,2)
      MAXIJ = MXTSOB ** 2
*.Local scratch arrays for blocks of C and sigma
      LSCR1 = 0
      IF(ICISTR.LE.2) THEN
        LSCR1 = MXSB
      ELSE IF(ICISTR.EQ.3) THEN
        LSCR1 = MXSOOB
      END IF
      IF(ICISTR.EQ.1) THEN
        Call mma_allocate(CB,LSCR1,Label='CB')
        Call mma_allocate(SB,LSCR1,Label='SB')
      END IF
*.SCRATCH space for integrals
* A 4 index integral block with four indices belonging OS class
      INTSCR = MXTSOB ** 4

      Call mma_allocate(INSCR,INTSCR,Label='INSCR')
*. Arrays giving allowed type combinations

      Call mma_allocate(SIOIO,NOCTPA*NOCTPB,Label='SIOIO')
      Call mma_allocate(CIOIO,NOCTPA*NOCTPB,Label='CIOIO')
*
*      SIOIO,CIOIO [NOCTPA x NOCTPB]
*      Allowed combinations of alpha and beta strings
*      Sigma and CI vector respectively
*
*      (RAS1 & RAS3 constrains)
*
      CALL IAIBCM_MCLR(MNR1IC(ISSPC),MXR3IC(ISSPC),NOCTPA,NOCTPB,
     &            Str(IATP)%EL1,Str(IATP)%EL3,
     &            Str(IBTP)%EL1,Str(IBTP)%EL3,
     &            SIOIO,IPRCIX)
*
      CALL IAIBCM_MCLR(MNR1IC(ICSPC),MXR3IC(ICSPC),NOCTPA,NOCTPB,
     &            Str(IATP)%EL1,Str(IATP)%EL3,
     &            Str(IBTP)%EL1,Str(IBTP)%EL3,
     &            CIOIO,IPRCIX)
*
*
*. Arrays giving block type
      Call mma_allocate(SBLTP,NSMST,Label='SBLTP')
      Call mma_allocate(CBLTP,NSMST,Label='CBLTP')
*. Arrays for additional symmetry operation
*
      Call mma_allocate(SVST,NSMST,Label='SVST')
*
*.scratch space for projected matrices and a CI block
*
*. Scratch space for CJKAIB resolution matrices
*. Size of C(Ka,Jb,j),C(Ka,KB,ij)  resolution matrices
      IF(NOPART.EQ.0) THEN
         MAXPK = MAXK
       ELSE
         MAXPK = 0
      END IF
*
* Get memory requirements
*
*     MXCJ:MXCIJA:MXCIJB:MXCIJAB:MXSXBL:MXIJST:MXIJSTF
*
      IATP1=MIN(IATP+1,ITYP_DUMMY)
      IBTP1=MIN(IbTP+1,ITYP_DUMMY)
      IATP2=MIN(IATP+2,ITYP_DUMMY)
      IBTP2=MIN(IbTP+2,ITYP_DUMMY)
      CALL MXRESC(CIOIO,IATP,IBTP,NOCTPA,NOCTPB,NSMST,
     &            Str(IATP)%NSTSO,Str(IBTP)%NSTSO,
     &            IATP+1,Str(IATP1)%NSTSO,NOCTYP(IATP1),
     &            Str(IBTP1)%NSTSO,NOCTYP(IBTP1),
     &            NSMOB,3,3,NTSOB,IPRCIX,MAXpK,
     &            Str(IATP2)%NSTSO,NOCTYP(IATP2),
     &            Str(IBTP2)%NSTSO,NOCTYP(IBTP2),
     &            Str(IATP)%EL123,Str(IBTP)%EL123,
     &            MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL,MXIJST,
     &            MXIJSTF)
*
*
*.vectors able to hold strings of given sym and type
      MAXIK = MAX(MAXI,MAXK)
*. I1 and Xi1s must also be able to hold largest st block
* and (i,j,kstring) array

      LSCR3 = MAX(MXIJST,MAXIK*MXTSOB,MXSTBL0)

      Call mma_allocate(I1,LSCR3,Label='I1')
      Call mma_allocate(I2,LSCR3,Label='I2')
      Call mma_allocate(I3,MAXIK*MXTSOB,Label='I3')
      Call mma_allocate(I4,MAXIK*MXTSOB,Label='I4')
      Call mma_allocate(XI1S,LSCR3,Label='XI1S')
      Call mma_allocate(XI2S,LSCR3,Label='XI2S')
      Call mma_allocate(XI3S,MAXIK*MXTSOB,Label='XI3S')
      Call mma_allocate(XI4S,MAXIK*MXTSOB,Label='XI4S')
      LSCR2 = MAX(MXCJ,MXCIJA,MXCIJB,MXCIJAB)
*
*. Merethe Interface
      MOCAA = 0
      IF(MOCAA.NE.0) THEN
*. These blocks will also be used for single excitations so,
*. To be removed   Largest block of SX excitations
        MAXE = MAX(NAEL,NBEL)
        MAXEl3 = MIN(MAXE,MXTSOB)
        MXSXST = (MXTSOB+1)*MAXEL3
        MXSXBL = MXSXST*MXSTBL0
        IF(IPRCIX.GE.2)
     &  WRITE(6,*) ' MXSXST,MXSXBL = ', MXSXST,MXSXBL
        LSCR2 = MAX(4*MXSXBL,LSCR2)
      END IF
*
      LSCR12 = MAX(LSCR1,2*LSCR2)
*
      IF(IDIAG .EQ. 2 ) THEN
*. PICO diagonalizer uses block KVEC3, use this as scratch block
        Write (6,*) 'Unchartered territory!'
        Call Abend()
*       pC2 => VEC3 ! this is not clear yet.
        IF ( 2 * LSCR2 .GT. LSCR1 ) THEN
           Call mma_allocate(CJRES,LSCR2,Label='CJRES')
           pCJRES => CJRES
           Call mma_allocate(SIRES,LSCR2,Label='SIRES')
           pSIRES => SIRES
        ELSE
*          pCJRES => VEC3                ! dito
*          pSIRES => VEC3(1+LSCR2:)     ! dito
        END IF
      ELSE
        Call mma_allocate(C2,LSCR12,Label='C2')
        pC2 => C2
        pCJRES => C2
        pSIRES => C2(1+LSCR2:)
      END IF
*
*     Symmetry handling symmetry allowed/forbidden
*
*     Out KSBLTP [NSMST]
*
      CALL ZBLTP(ISMOST(1,ISSM),NSMST,IDC,SBLTP,SVST)
      CALL ZBLTP(ISMOST(1,ICSM),NSMST,IDC,CBLTP,SVST)
*.10 OOS arrays
      nOOS = NOCTPA*NOCTPB*NSMST
      Call mma_allocate(OOS,nOOS,10,Label='OOS')
*
      iiCOPY=1
      IF(NOCSF.EQ.0) THEN
* Transform C vector from CSF to SD basis
        CALL CSDTVC_MCLR(C,HC,1,DTOC,CNSM(kic(1))%ICTS,
     &                   icsm,iiCOPY,IPRDIA)
      END IF
*
      IF(IDC.NE.1.AND.ICISTR.EQ.1) THEN

*. Transform from combination scaling to determinant scaling
        CALL SCDTC2_MCLR(C,ISMOST(1,ICSM),CBLTP,NSMST,
     &                   NOCTPA,NOCTPB,Str(IATP)%NSTSO,
     &                   Str(IBTP)%NSTSO,CIOIO,IDC,
     &                   2,IDUMMY,IPRDIA)
      END IF

*
*     Goto 987
      IF(I12.EQ.2) THEN
        IDOH2 = 1
      ELSE
        IDOH2 = 0
      END IF
*
      IF(ICISTR.EQ.1) THEN
       LLUC = 0
       LLUHC = 0
      ELSE
       LLUC = LUC
       LLUHC = LUHC
      END IF
      call dcopy_(NSDET,[ZERO],0,HC,1)
*
      IF(ICISTR.EQ.1) THEN
      CALL RASSG4(C,HC,CB,SB,pC2,
     &            CIOIO,SIOIO,ISMOST(1,ICSM),
     &            ISMOST(1,ISSM),CBLTP,SBLTP,
     &            NORB1,NORB2,NORB3,NACOB,
     &            Str(IATP)%NSTSO,Str(IATP)%ISTSO,
     &            Str(IBTP)%NSTSO,Str(IBTP)%ISTSO,
     &            NAEL,IATP,NBEL,IBTP,NOCTPA,NOCTPB,
     &            NSMST,NSMOB,NSMSX,NSMDX,NTSOB,IBTSOB,ITSOB,
     &            MAXIJ,MAXK,MAXI,ICISTR,IINSTR,INTSCR,LSCR1,
     &            LSCR1,
     &            INSCR,pCJRES,pSIRES,
     &            SXSTSM,STSTS,STSTD,SXDXSX,
     &            ADSXA,ASXAD,
     &            Str(IATP)%EL1,Str(IATP)%EL3,
     &            Str(IBTP)%EL1,Str(IBTP)%EL3,IDC,
     &            OOS(:,1), OOS(:,2), OOS(:,3), OOS(:,4),
     &            OOS(:,5), OOS(:,6), OOS(:,7), OOS(:,8),
     &            OOS(:,9), OOS(:,10),
     &            I1,XI1S,I2,XI2S,
     &            I3,XI3S,I4,XI4S,
     &            IDOH2,
     &            SVST,PSSIGN,IPRDIA,LLUC,LLUHC,IST,
     &            pCJRES,pSIRES,NOPARt,TimeDep)

      Else
       Call SysHalt('sigmavec')
*
*      IF WE USE DISK REPLACE THE FIRST VARIABLES LIKE THIS
*      CALL RASSG4(C,HC,C,HC!,
*
      End If
*
      IF(IDC.NE.1.AND.ICISTR.EQ.1) THEN
*. Transform from combination scaling to determinant scaling

        CALL SCDTC2_MCLR(HC,ISMOST(1,ISSM),SBLTP,NSMST,
     &              NOCTPA,NOCTPB,Str(IATP)%NSTSO,
     &              Str(IBTP)%NSTSO,CIOIO,IDC,
     &              1,IDUMMY,IPRDIA)
      END IF

*
      IF(NOCSF.EQ.0) THEN
* Transform HC vector from SD to CSF basis
        CALL CSDTVC_MCLR(C,HC,2,DTOC,CNSM(kic(2))%ICTS,ISSM,1,IPRDIA)
      END IF

*. Eliminate local memory

      Call mma_deallocate(STSTS)
      Call mma_deallocate(STSTD)
      Call mma_deallocate(INSCR)
      Call mma_deallocate(SIOIO)
      Call mma_deallocate(CIOIO)
      Call mma_deallocate(SBLTP)
      Call mma_deallocate(CBLTP)

      Call mma_deallocate(I4)
      Call mma_deallocate(I3)
      Call mma_deallocate(I2)
      Call mma_deallocate(I1)
      Call mma_deallocate(XI4S)
      Call mma_deallocate(XI3S)
      Call mma_deallocate(XI2S)
      Call mma_deallocate(XI1S)
      Call mma_deallocate(OOS)
      IF (ICISTR.EQ.1) THEN
        Call mma_deallocate(CB)
        Call mma_deallocate(SB)
      End If
      Call mma_deallocate(SVST)
      If (Associated(pC2)) pC2=>Null()
      If (Associated(pCJRES)) pCJRES=>Null()
      If (Associated(pSIRES)) pSIRES=>Null()
      IF (Allocated(C2)) Call mma_deallocate(C2)
      If (Allocated(CJRES)) Call mma_deallocate(CJRES)
      If (Allocated(SIRES)) Call mma_deallocate(SIRES)
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE STRINF(IPRNT)
      Use Str_Info
*
* Strings for internal space.
* Information is stored in
* Largest allowed length is MSTINF
*
*.Input
* /LUCINP/,/ORBINP/,/CSM/
*.Output
* /STRINP/,/STINF/,/STRBAS/ and string information in STIN
*
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
*     (and /LUCINP/ not occuring here )
#include "detdim.fh"
#include "orbinp_mclr.fh"
#include "stdalloc.fh"
*
* ======
* Output
* ======
*
#include "csm.fh"
*
      Integer ISGSTI(1),ISGSTO(1)
      Integer, Allocatable:: KFREEL(:)
      NTEST = 0
      NTEST = MAX(NTEST,IPRNT)
*
*
**.2 : Number of classes per string type and mappings between
**.    string types (/STINF/)
*
      CALL ZSTINF_MCLR(IPRNT)
*
*
**.3 : Static memory for string information
*
      CALL MEMSTR()
*
**.4 :Reverse lexical adresing schemes for each type of string
*
*.First free address
      Call mma_MaxINT(imax)
      CALL mma_allocate(KFREEL,imax,Label='KFREEL')
      DO 20 ITYP = 1, NSTTYP
        IF(IUNIQTP(ITYP).EQ.ITYP) THEN
        CALL WEIGHT_mclr(Str(ITYP)%Z,NELEC(ITYP),NORB1,NORB2,NORB3,
     &                   MNRS1(ITYP),MXRS1(ITYP),MNRS3(ITYP),
     &                   MXRS3(ITYP),KFREEL )
        END IF
   20 CONTINUE
*
**.5 : Number of electrons in RAS1 and RAS3 per string sub type
*
      DO 25 ITYP = 1, NSTTYP
        IF(IUNIQTP(ITYP).EQ.ITYP) THEN
        CALL IEL13(MNRS1(ITYP),MXRS1(ITYP),MNRS3(ITYP),MXRS3(ITYP),
     &             NELEC(ITYP),NOCTYP(ITYP),Str(ITYP)%EL1,
     &             Str(ITYP)%EL3,Str(ITYP)%EL123,
     &             Str(ITYP)%ACTP)
        END IF
   25 CONTINUE
*
**.6 : Number of strings per type and symmetry for a given string type
*
      DO 30 ITYP = 1, NSTTYP
        IF(IUNIQTP(ITYP).EQ.ITYP) THEN
        CALL NSTRSO_MCLR(NELEC(ITYP),NORB1,NORB2,NORB3,
     &                   MNRS1(ITYP),MXRS1(ITYP),MNRS3(ITYP),
     &                   MXRS3(ITYP),KFREEL,NACOB,Str(ITYP)%NSTSO,
     &                   NOCTYP(ITYP),NSMST,ITYP,IPRNT)
*. Corresponding offset array
        CALL ZBASE(Str(ITYP)%NSTSO,Str(ITYP)%ISTSO,
     &             NSMST*NOCTYP(ITYP) )
*. Symmetry and class index for each string
         CALL ZSMCL(NSMST,NOCTYP(ITYP),Str(ITYP)%NSTSO,
     &              Str(ITYP)%STSM,Str(ITYP)%STCL )
        END IF
   30 CONTINUE
*
**.7 Construct strings, ordered according to symmetry and class
*
      DO 40 ITYP = 1, NSTTYP
        IF(IUNIQTP(ITYP).EQ.ITYP) THEN
        CALL GENSTR_MCLR(NELEC(ITYP),MNRS1(ITYP),MXRS1(ITYP),
     &                   MNRS3(ITYP),MXRS3(ITYP),Str(ITYP)%ISTSO,
     &                   NOCTYP(ITYP),NSMST,Str(ITYP)%Z,KFREEL,
     &                   Str(ITYP)%STREO,Str(ITYP)%OCSTR,
     &                   KFREEL(1+NOCTYP(ITYP)*NSMST),ITYP,IPRNT)
        END IF
   40 CONTINUE
*
*
**.8 Internal annihilation arrays between types of strings
*
      DO 50 ITYP = 1, NSTTYP
        IF(IUNIQMP(ITYP).EQ.ITYP) THEN
        IF(ISTAC(ITYP,1).NE.0) THEN
          JTYP = ISTAC(ITYP,1)
          IF(IPRNT.GE.2) THEN
          WRITE(6,*) ' Annihilator arrays between types ',ITYP,JTYP
          WRITE(6,*) ' ==========================================='
          END IF
          IF(ISTAC(ITYP,2).EQ.0) THEN
            LROW = NELEC(ITYP)
          ELSE
            LROW = NACOB
          END IF
          Str(ITYP)%STSTM(1:NSTFTP(ITYP)*LROW,1)=0
          Str(ITYP)%STSTM(1:NSTFTP(ITYP)*LROW,2)=0
          CALL ANNSTR(Str(ITYP)%OCSTR,NSTFTP(ITYP),NSTFTP(JTYP),
     &                NELEC(ITYP),NACOB,Str(JTYP)%Z,
     &                Str(JTYP)%STREO,LROW,0,ISGSTI,ISGSTO,
     &                Str(ITYP)%STSTM(:,1),Str(ITYP)%STSTM(:,2),
     &                JTYP,IPRNT)
        END IF
        END IF
   50 CONTINUE
*
** 6 : Creation arrays
*
      DO 60 ITYP = 1, NSTTYP
        IF(IUNIQMP(ITYP).EQ.ITYP) THEN
        IF(ISTAC(ITYP,2).NE.0) THEN
*. Type of creation map
          IF (ISTAC(ITYP,1).EQ.0) THEN
*. Only creation map, compact scheme with offsets
            LROW = -1
          ELSE IF (ISTAC(ITYP,1).NE.0) THEN
*. Both annihilation and creation, use full form
            LROW = NACOB
          END IF
          JTYP = ISTAC(ITYP,2)
          IF(IPRNT.GE.2) THEN
          WRITE(6,*) ' Creator  arrays between types ',ITYP,JTYP
          WRITE(6,*) ' ==========================================='
          END IF
          CALL CRESTR(Str(ITYP)%OCSTR,NSTFTP(ITYP),NSTFTP(JTYP),
     &                NELEC(ITYP),NACOB,Str(JTYP)%Z,
     &                Str(JTYP)%STREO,0,ISGSTI,ISGSTO,
     &                Str(ITYP)%STSTM(:,1),Str(ITYP)%STSTM(:,2),
     &                Str(ITYP)%STSTMN,Str(ITYP)%STSTMI,
     &                LROW,JTYP,IPRNT)
        END IF
        END IF
   60 CONTINUE
      CALL mma_deallocate(KFREEL)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
*               1993, Per Boussard                                     *
************************************************************************
      SubRoutine M1Grd(
#define _CALLING_
#include "grd_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of the M1 integrals used  *
*         ECP calculations. The operator is the nuclear attraction     *
*         operator times a s-type gaussian function.                   *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by ECPMem                 *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
*             Physics, University of Stockholm, Sweden, October '93.   *
*                                                                      *
*             Modified to gradients, December '93 (RL).                *
************************************************************************
      use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
      External TNAI1, Fake, Cff2D
#include "Molcas.fh"
#include "real.fh"
#include "print.fh"
#include "disp.fh"

#include "grd_interface.fh"

*     Local variables
      Real*8 C(3), TC(3), CoorAC(3,2), Coori(3,4), Coora(3,4)
      Integer iDCRT(0:7), iAnga(4), iuvwx(4), lOp(4), JndGrd(3,4)
      Logical EQ, JfGrad(3,4), TstFnc, TF
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*
      iRout = 193
      iPrint = nPrint(iRout)
*
      nRys = nHer
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In M1Grd: A',' ',A,1,3)
         Call RecPrt(' In M1Grd: RB',' ',RB,1,3)
         Call RecPrt(' In M1Grd: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In M1Grd: P',' ',P,nZeta,3)
         Write (6,*) ' In M1Grd: la,lb=',' ',la,lb
      End If
*
*-----Allocate Scratch for primitives and work area for HRR
*
      ip = 1
      ipA = ip
      ip = ip + nZeta
      ipB = ip
      ip = ip + nZeta
      ipDAO = ip
      ip = ip + nZeta*nElem(la)*nElem(lb)
      ipK = ip
      ip = ip + nZeta
      ipZ = ip
      ip = ip + nZeta
      ipZI = ip
      ip = ip + nZeta
      ipPx = ip
      ip = ip + nZeta
      ipPy = ip
      ip = ip + nZeta
      ipPz = ip
      ip = ip + nZeta
      If (ip-1.gt.nArr*nZeta) Then
         Write (6,*) ' ip-1.gt.nArr*nZeta (M1 section)'
         Write (6,*) ' nArr,nZeta=',nArr,nZeta
         Call Abend()
      End If
      nArray = nArr*nZeta - ip + 1
*
      iIrrep = 0
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = 0
      iAnga(4) = 0
      call dcopy_(3, A,1,Coora(1,1),1)
      call dcopy_(3,RB,1,Coora(1,2),1)
      call dcopy_(3, A,1,Coora(1,1),1)
      call dcopy_(3,RB,1,Coora(1,2),1)
      If (la.ge.lb) Then
         call dcopy_(3, A,1,CoorAC(1,1),1)
      Else
         call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      lOp(1) = kOp(1)
      lOp(2) = kOp(2)
*
      ipAOff = ipA
      Do 200 iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
 200  Continue
*
      ipBOff = ipB
      Do 210 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
 210  Continue
*
*-----Loop over nuclear centers.
*
      kdc = 0
      Do 100 kCnttp = 1, nCnttp
         If (.Not.dbsc(kCnttp)%ECP) Go To 111
         If (dbsc(kCnttp)%nM1.eq.0) Go To 111
         Do 101 kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3)=dbsc(kCnttp)%Coor(1:3,kCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            iuvwx(3) = dc(kdc+kCnt)%nStab
            iuvwx(4) = dc(kdc+kCnt)%nStab
*
            Do 102 lDCRT = 0, nDCRT-1
               lOp(3) = NrOpr(iDCRT(lDCRT))
               lOp(4) = lOp(3)
               Call OA(iDCRT(lDCRT),C,TC)
*--------------Branch out if one-center integral
               If (EQ(A,RB).and.EQ(A,TC)) Go To 102
               If (iPrint.ge.99) Call RecPrt(' In M1Grd: TC',' ',TC,1,3)
               call dcopy_(3,A,1,Coora(1,1),1)
               call dcopy_(3,RB,1,Coora(1,2),1)
               call dcopy_(6,Coora(1,1),1,Coori(1,1),1)
               If (.Not.EQ(A,RB) .or. .Not.EQ(A,TC)) Then
                  Coori(1,1) = Coori(1,1)+One
*                 Coora(1,1) = Coora(1,1)+One
               End If
               call dcopy_(3,TC,1,CoorAC(1,2),1)
               call dcopy_(3,TC,1,Coori(1,3),1)
               call dcopy_(3,TC,1,Coori(1,4),1)
               call dcopy_(3,TC,1,Coora(1,3),1)
               call dcopy_(3,TC,1,Coora(1,4),1)
*
               Do 1011 iM1xp=1, dbsc(kCnttp)%nM1
                  Gamma = dbsc(kCnttp)%M1xp(iM1xp)
*
                  Call ICopy(6,IndGrd,1,JndGrd,1)
                  Do 10 i = 1, 3
                     Do 11 j = 1, 2
                        JfGrad(i,j) = IfGrad(i,j)
 11                  Continue
 10               Continue
*
*-----------------Derivatives with respect to the operator is computed
*                 via the translational invariance.
*                 Some extra care is needed here due to that Rys2Dg will
*                 try to avoid some of the work.
*
                  nDisp = IndDsp(kdc+kCnt,iIrrep)
                  Do 220 iCar = 0, 2
*--------------------No direct assembly of contribution from the operat.
                     JfGrad(iCar+1,3) = .False.
                     JndGrd(iCar+1,3) = 0
                     iCmp = 2**iCar
                     If ( TF(kdc+kCnt,iIrrep,iCmp) .and.
     &                    .Not.dbsc(kCnttp)%pChrg ) Then
*-----------------------Displacement is symmetric
                        nDisp = nDisp + 1
                        If (Direct(nDisp)) Then
*--------------------------Reset flags for the basis set centers so that
*                          we will explicitly compute the derivatives
*                          with respect to those centers. Activate flag
*                          for the third center so that its derivative
*                          will be computed by the translational
*                          invariance.
                           JfGrad(iCar+1,1) = .True.
                           JfGrad(iCar+1,2) = .True.
                           If ( A(iCar+1).ne.TC(iCar+1) .and.
     &                         RB(iCar+1).ne.TC(iCar+1)) Then
*-----------------------------Three center case
                              JndGrd(iCar+1,1) = Abs(JndGrd(iCar+1,1))
                              JndGrd(iCar+1,2) = Abs(JndGrd(iCar+1,2))
                              JndGrd(iCar+1,3) = -nDisp
                              JfGrad(iCar+1,1) = .True.
                              JfGrad(iCar+1,2) = .True.
                            Else If ( A(iCar+1).eq.TC(iCar+1) .and.
     &                               RB(iCar+1).ne.TC(iCar+1)) Then
*-----------------------------Two center case
                              JndGrd(iCar+1,1) = -Abs(JndGrd(iCar+1,1))
                              JndGrd(iCar+1,2) = Abs(JndGrd(iCar+1,2))
                              JfGrad(iCar+1,1) = .False.
                              JfGrad(iCar+1,2) = .True.
                            Else If ( A(iCar+1).ne.TC(iCar+1) .and.
     &                               RB(iCar+1).eq.TC(iCar+1)) Then
*-----------------------------Two center case
                              JndGrd(iCar+1,1) = Abs(JndGrd(iCar+1,1))
                              JndGrd(iCar+1,2) = -Abs(JndGrd(iCar+1,2))
                              JfGrad(iCar+1,1) = .True.
                              JfGrad(iCar+1,2) = .False.
                            Else
*-----------------------------One center case
                              JndGrd(iCar+1,1) = 0
                              JndGrd(iCar+1,2) = 0
                              JfGrad(iCar+1,1) = .False.
                              JfGrad(iCar+1,2) = .False.
                            End If
                        End If
                     End If
 220              Continue
*-----------------No derivatives with respect to the fourth center.
                  Call ICopy(3,[0],0,JndGrd(1,4),1)
                  JfGrad(1,4) = .False.
                  JfGrad(2,4) = .False.
                  JfGrad(3,4) = .False.
                  mGrad = 0
                  Do 231 iCar = 1, 3
                     Do 232 i = 1, 2
                        If (JfGrad(iCar,i)) mGrad = mGrad + 1
 232                 Continue
 231              Continue
                  If (iPrint.ge.99) Write (6,*) ' mGrad=',mGrad
                  If (mGrad.eq.0) Go To 1011
*
*-----------------Modify the original basis. Observe that
*                 simplification due to A=B are not valid for the
*                 exponent index, eq. P-A=/=0.
*
                  Do 1012 iZeta = 1, nZeta
                     PTC2 = (P(iZeta,1)-TC(1))**2
     &                    + (P(iZeta,2)-TC(2))**2
     &                    + (P(iZeta,3)-TC(3))**2
                     Tmp0 = Zeta(iZeta)+Gamma
                     Tmp1 = Exp(-Zeta(iZeta)*Gamma*PTC2/Tmp0)
                     Array(ipK +iZeta-1) = rKappa(iZeta) * Tmp1
                     Array(ipZ +iZeta-1) = Tmp0
                     Array(ipZI+iZeta-1) = One/Tmp0
                     Array(ipPx+iZeta-1) =
     &                  (Zeta(iZeta)*P(iZeta,1)+Gamma*TC(1))/Tmp0
                     Array(ipPy+iZeta-1) =
     &                  (Zeta(iZeta)*P(iZeta,2)+Gamma*TC(2))/Tmp0
                     Array(ipPz+iZeta-1) =
     &                  (Zeta(iZeta)*P(iZeta,3)+Gamma*TC(3))/Tmp0
 1012             Continue
*
*-----------------Modify the density matrix with the prefactor
*
                  Fact = -dbsc(kCnttp)%Charge*dbsc(kCnttp)%M1cf(iM1xp)*
     &                   (DBLE(nStabM) / DBLE(LmbdT)) * Two * Pi
                  nDAO = nElem(la)*nElem(lb)
                  Do 300 iDAO = 1, nDAO
                     Do 310 iZeta = 1, nZeta
                        Fac = Fact * Array(ipK+iZeta-1) *
     &                        Array(ipZI+iZeta-1)
                        ipDAOt = nZeta*(iDAO-1) + iZeta-1 + ipDAO
                        Array(ipDAOt)= Fac * DAO(iZeta,iDAO)
 310                 Continue
 300              Continue
                  If (iPrint.ge.99) Then
                     Write (6,*) ' Charge=',dbsc(kCnttp)%Charge
                     Write (6,*) ' Fact=',Fact
                     Write (6,*) ' IndGrd=',IndGrd
                     Write (6,*) ' JndGrd=',JndGrd
                     Call RecPrt('DAO*Fact',' ',Array(ipDAO),nZeta,nDAO)
                  End If
*
*-----------------Compute integrals with the Rys quadrature.
*
                  Call Rysg1(iAnga,nRys,nZeta,
     &                       Array(ipA),Array(ipB),[One],[One],
     &                       Array(ipZ),Array(ipZI),nZeta,[One],[One],1,
     &                       Array(ipPx),nZeta,TC,1,Coori,Coora,
     &                       CoorAC,Array(ip),nArray,
     &                       TNAI1,Fake,Cff2D,
     &                       Array(ipDAO),nDAO,Grad,nGrad,JfGrad,JndGrd,
     &                       lOp,iuvwx)
*
 1011          Continue
 102        Continue
 101     Continue
 111     kdc = kdc + dbsc(kCnttp)%nCntr
 100  Continue
*
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_real_array(Final)
         Call Unused_integer(nOrdOp)
         Call Unused_integer_array(lOper)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Lasse Kragh Soerensen                            *
************************************************************************
      SUBROUTINE I_AM_SO_EXCITED(NBATCH,IBATCH,LBATCH,I1BATCH)
*
* Subroutine by Lasse from October 2015
*
* Updated March 2018 for doubly excited states
*
* Will give single excited states in from the desired GAS (or GAS's)
* And now also doubly excited states
*
* The difference between the HEXS and DEXS is controlled by
* I_ELIMINATE_GAS
* Notice that for the doubly excited states (DEXS) all
* singly excited states (HEXS) are in effect.
*
      IMPLICIT REAL*8(A-H,O-Z) ! I am so against this
*
#include "mxpdim.fh"
#include "gasstr.fh"
#include "cgas.fh"
*
* Input
      INTEGER IBATCH(8,*),LBATCH(*),I1BATCH(*)
* Scratch
      INTEGER IMAX_OCC(2,NGAS,2)
      INTEGER MAX_E_GAS_ALPHA(2,MXPSTT),MAX_E_GAS_BETA(2,MXPSTT)
      INTEGER MAXM1_E_GAS_ALPHA(2,MXPSTT),MAXM1_E_GAS_BETA(2,MXPSTT)
*
      NTEST = 00
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Oh I am so excited '
        WRITE(6,*)
        WRITE(6,*) ' Number of GAS without maximum occupation = ',
     &               N_ELIMINATED_GAS
        WRITE(6,*)
        IF(I_ELIMINATE_GAS.EQ.1) THEN
          WRITE(6,*) ' GAS without maximum occupation (HEXS)'
          WRITE(6,*)
        ELSE
          WRITE(6,*) ' GAS without maximum-1 occupation (DEXS)'
          WRITE(6,*)
        END IF
        DO I = 1, N_ELIMINATED_GAS
          WRITE(6,*) IELIMINATED_IN_GAS(I)
        END DO
      END IF
*
* First we need to find the GAS spaces for which we will eliminate
* the maximum occupation.
*
      IZERO = 0
      IMAX_OCC = IZERO
*
      DO JBATCH = 1,2 ! only alpha and beta
        DO IBLOCK = I1BATCH(JBATCH),I1BATCH(JBATCH)+ LBATCH(JBATCH)-1
          DO ISPGP = 1, NSPGPFTP(JBATCH)
            IOFF = IBSPGPFTP(JBATCH)
            DO IGAS = 1, NGAS
              IITYPE = ISPGPFTP(IGAS,IOFF-1+ISPGP)
              IEL = NELFGP(IITYPE)
              IF(IEL.GT.IMAX_OCC(JBATCH,IGAS,1))THEN
                IMAX_OCC(JBATCH,IGAS,1) = IEL
                IMAX_OCC(JBATCH,IGAS,2) = IITYPE
              END IF
            END DO
          END DO
        END DO
      END DO
*
      IF(NTEST.GE.100) THEN
        DO JBATCH = 1,2
          IF(JBATCH.EQ.1) THEN
            WRITE(6,*) ' Maximum number of alpha electrons in each GAS'
          ELSE
            WRITE(6,*) ' Maximum number of beta electrons in each GAS'
          END IF
          WRITE(6,*)
          WRITE(6,*) ' GAS, Electrons, Group '
          DO IGAS = 1,NGAS
            WRITE(6,*) IGAS,IMAX_OCC(JBATCH,IGAS,1),
     &                      IMAX_OCC(JBATCH,IGAS,2)
          END DO
          WRITE(6,*)
        END DO
      END IF
*
* Find which types contains the groups with a maximum number
* of alpha or beta electrons in a GAS
*
      NALPHA = 0
      NBETA = 0
      NALPHAM1 = 0
      NBETAM1 = 0
      DO JBATCH = 1,2 ! only alpha and beta
        DO IBLOCK = I1BATCH(JBATCH),I1BATCH(JBATCH)+ LBATCH(JBATCH)-1
          DO ISPGP = 1, NSPGPFTP(JBATCH)
            IOFF = IBSPGPFTP(JBATCH)
            DO IGAS = 1, NGAS
              IITYPE = ISPGPFTP(IGAS,IOFF-1+ISPGP)
              IEL = NELFGP(IITYPE)
              IF(IEL.EQ.IMAX_OCC(JBATCH,IGAS,1))THEN
                IF(JBATCH.EQ.1) THEN
                  NALPHA = NALPHA + 1
                  MAX_E_GAS_ALPHA(1,NALPHA) = IGAS
                  MAX_E_GAS_ALPHA(2,NALPHA) = ISPGP
                ELSE
                  NBETA = NBETA + 1
                  MAX_E_GAS_BETA(1,NBETA) = IGAS
                  MAX_E_GAS_BETA(2,NBETA) = ISPGP
                END IF
              END IF
              IF(I_ELIMINATE_GAS.EQ.2) THEN ! DEXS
                IF(IEL.EQ.IMAX_OCC(JBATCH,IGAS,1)-1)THEN
                  IF(JBATCH.EQ.1) THEN
                    NALPHAM1 = NALPHAM1 + 1
                    MAXM1_E_GAS_ALPHA(1,NALPHAM1) = IGAS
                    MAXM1_E_GAS_ALPHA(2,NALPHAM1) = ISPGP
                  ELSE
                    NBETAM1 = NBETAM1 + 1
                    MAXM1_E_GAS_BETA(1,NBETAM1) = IGAS
                    MAXM1_E_GAS_BETA(2,NBETAM1) = ISPGP
                  END IF
                END IF
              END IF
            END DO
          END DO
        END DO
      END DO
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) 'Maximum number of alpha supergroups '//
     &             'that can be eliminated',NALPHA + NALPHAM1
        WRITE(6,*)
        WRITE(6,*) ' GAS Supergroup for HEXS'
        WRITE(6,*)
        DO IGAS = 1, NGAS
          DO I = 1, NALPHA
            IF(MAX_E_GAS_ALPHA(1,I).EQ.IGAS) THEN
              WRITE(6,*) MAX_E_GAS_ALPHA(1,I),MAX_E_GAS_ALPHA(2,I)
            END IF
          END DO
        END DO
        IF(I_ELIMINATE_GAS.EQ.2) THEN ! DEXS
          WRITE(6,*)
          WRITE(6,*) ' GAS Supergroup for DEXS'
          WRITE(6,*)
          DO IGAS = 1, NGAS
            DO I = 1, NALPHAM1
              IF(MAXM1_E_GAS_ALPHA(1,I).EQ.IGAS) THEN
                WRITE(6,*) MAXM1_E_GAS_ALPHA(1,I),MAXM1_E_GAS_ALPHA(2,I)
              END IF
            END DO
          END DO
        END IF
        WRITE(6,*)
        WRITE(6,*) 'Maximum number of beta supergroups '//
     &             'that can be eliminated',NBETA + NBETAM1
        WRITE(6,*)
        WRITE(6,*) ' GAS Supergroup for HEXS'
        WRITE(6,*)
        DO IGAS = 1, NGAS
          DO I = 1, NBETA
            IF(MAX_E_GAS_BETA(1,I).EQ.IGAS) THEN
              WRITE(6,*) MAX_E_GAS_BETA(1,I),MAX_E_GAS_BETA(2,I)
            END IF
          END DO
        END DO
        IF(I_ELIMINATE_GAS.EQ.2) THEN ! DEXS
          WRITE(6,*)
          WRITE(6,*) ' GAS Supergroup for DEXS'
          WRITE(6,*)
          DO IGAS = 1, NGAS
            DO I = 1, NBETAM1
              IF(MAXM1_E_GAS_BETA(1,I).EQ.IGAS) THEN
                WRITE(6,*) MAXM1_E_GAS_BETA(1,I),MAXM1_E_GAS_BETA(2,I)
              END IF
            END DO
          END DO
        END IF
        WRITE(6,*)
      END IF
*
* Now find the batches to possibly eliminate
*
      N_ELIMINATED_BATCHES = 0
*
      DO I = 1, N_ELIMINATED_GAS
        IGAS_ELIM = IELIMINATED_IN_GAS(I)
        DO JBATCH = 1, NBATCH
          DO IBLOCK = I1BATCH(JBATCH),I1BATCH(JBATCH)+ LBATCH(JBATCH)-1
            ITYPE_A = IBATCH(1,IBLOCK)
            ITYPE_B = IBATCH(2,IBLOCK)
* Will first check if it matches a beta type
            IMATCH_BETA = 0
            DO J = 1, NBETA
              IF(ITYPE_B.EQ.MAX_E_GAS_BETA(2,J).AND.
     &          IGAS_ELIM.EQ.MAX_E_GAS_BETA(1,J)) THEN
                IMATCH_BETA = 1
                EXIT
              ELSE
                CYCLE
              END IF
            END DO
* Will first check if it matches a beta type (DEXS)
            IMATCH_BETAM1 = 0
            IF(I_ELIMINATE_GAS.EQ.2) THEN ! DEXS
              DO J = 1, NBETAM1
                IF(ITYPE_B.EQ.MAXM1_E_GAS_BETA(2,J).AND.
     &            IGAS_ELIM.EQ.MAXM1_E_GAS_BETA(1,J)) THEN
                  IMATCH_BETAM1 = 1
                  EXIT
                ELSE
                  CYCLE
                END IF
              END DO
            END IF
* Now check it also matches an alpha type
            IMATCH_ALPHA = 0
            DO J = 1, NALPHA
              IF(ITYPE_A.EQ.MAX_E_GAS_ALPHA(2,J).AND.
     &          IGAS_ELIM.EQ.MAX_E_GAS_ALPHA(1,J)) THEN
                IMATCH_ALPHA = 1
                EXIT
              ELSE
                CYCLE
              END IF
            END DO
* Now check it also matches an alpha type (DEXS)
            IMATCH_ALPHAM1 = 0
            IF(I_ELIMINATE_GAS.EQ.2) THEN ! DEXS
              DO J = 1, NALPHAM1
                IF(ITYPE_A.EQ.MAXM1_E_GAS_ALPHA(2,J).AND.
     &            IGAS_ELIM.EQ.MAXM1_E_GAS_ALPHA(1,J)) THEN
                  IMATCH_ALPHAM1 = 1
                  EXIT
                ELSE
                  CYCLE
                END IF
              END DO
            END IF
            IF((IMATCH_BETA.EQ.1.AND.IMATCH_ALPHA.EQ.1).OR.
     &         (IMATCH_BETAM1.EQ.1.AND.IMATCH_ALPHA.EQ.1).OR.
     &         (IMATCH_BETA.EQ.1.AND.IMATCH_ALPHAM1.EQ.1)) THEN
              N_ELIMINATED_BATCHES = N_ELIMINATED_BATCHES + 1
*              I_AM_OUT(N_ELIMINATED_BATCHES) = JBATCH
*MGD actually, we will eliminate blocks and not batches
              I_AM_OUT(N_ELIMINATED_BATCHES) = iblock
            END IF
          END DO
        END DO
      END DO
*
      IF(N_ELIMINATED_BATCHES.GT.MXPSTT) THEN
        WRITE(6,*) ' Increase MXPSTT to ',N_ELIMINATED_BATCHES
        CALL SYSABENDMSG('lucia_util/i_am_so_excited',
     &                   'Dimension of I_AM_OUT is too small',
     &                   'Increase MXPSTT')
      END IF
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Number of eliminated blocks ',N_ELIMINATED_BATCHES
        WRITE(6,*)
        WRITE(6,*) ' The blocks eliminated '
        WRITE(6,*)
        DO I = 1, N_ELIMINATED_BATCHES
          WRITE(6,*) I_AM_OUT(I)
        END DO
        WRITE(6,*)
      END IF
*
      END SUBROUTINE I_AM_SO_EXCITED

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Jesper Norell                                    *
!***********************************************************************

!****************************************************************
!  SUBROUTINE MKDYSZZ
!  PURPOSE: CALCULATE DYSON ORBITAL COEFFICIENTS FOR CI EXPANSIONS IN
!  BASIS FUNCTION BASE BASE Z,
!  IN ANALOGUE TO MKTDZZ FOR TRANSITION DENSITY MATRIX.
!****************************************************************
!  MODIFIED BY BRUNO TENORIO TO ADDRESS SYMMETRY
!  SEPTEMBER 2020
!****************************************************************

subroutine MKDYSZZ(CMOA,DYSAB,DYSZZ)

use Symmetry_Info, only: nIrrep
use rassi_data, only: NASH, NBASF, NCMO, NOSH
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CMOA(NCMO), DYSAB(*)
real(kind=wp), intent(inout) :: DYSZZ(*)
integer(kind=iwp) :: BIOOFF, IBIO, IBIOFF, ISY1, IZZ, IZZOFF, NA1, NB1, NO1, SYMOFF
real(kind=wp) :: COEFF

! Re-express the DO coefficients in biorth basis DYSAB
! into atomic basis DYSZZ with help of CMOA that contains
! biorth orbitals in ZZ basis

SYMOFF = 0
IBIOFF = 0
IZZOFF = 0
do ISY1=1,nIrrep
  NO1 = NOSH(ISY1)
  NA1 = NASH(ISY1)
  NB1 = NBASF(ISY1)
  if (NA1 > 0) then
    do IBIO=1,NO1
      do IZZ=1,NB1
        BIOOFF = (IBIO-1)*NB1
        COEFF = DYSAB(IBIO+IBIOFF)*CMOA(SYMOFF+BIOOFF+IZZ)
        DYSZZ(IZZ+IZZOFF) = DYSZZ(IZZ+IZZOFF)+COEFF
      end do
    end do
  end if
  IZZOFF = NB1+IZZOFF
  IBIOFF = NO1+IBIOFF
  SYMOFF = (NO1*NB1)+SYMOFF
end do

end subroutine MKDYSZZ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine GenBMp_Loc(X,nRow,nCol,FilNam,Color)
      Implicit None
      Integer nRow, nCol
      Real*8  X(nRow,nCol)
      Character*(*) FilNam
      Character*1   Color

      Character*10 SecNam
      Parameter (SecNam = 'GenBMp_Loc')

      Integer  isFreeUnit
      External isFreeUnit

      Character*80 Txt
      Integer Lunit, irc, nStp
      Real*8  StpSiz

      Lunit = isFreeUnit(11)
      Call Molcas_Open(Lunit,FilNam)
      irc = 0
      nStp = -1
      StpSiz = -1.0d0
      Call GenBMp(irc,X,nRow,nCol,Lunit,nStp,StpSiz,Color)
      If (irc .ne. 0) Then
         Write(Txt,'(A,I4)') 'GenBMp returned',irc
         Call SysAbendMsg(SecNam,'GenBMp failed!',Txt)
      End If
      Close(Lunit,Status='Keep')

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Update_H(nWndw,H,nInter,nIter,
     &                    iOptC,dq,g,iOptH,
     &                    jPrint,GNrm,
     &                    nsAtom,Store,
     &                    AllowFindTS)
      use Slapaf_Info, only: MF
      use Slapaf_Parameters, only: IRC, Mode
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
#include "real.fh"
      Real*8 H(nInter,nInter), dq(nInter,nIter), g(nInter,nIter)
      Logical Old_MF, Store, AllowFindTS
      Real*8, Allocatable:: Tmp(:,:)
*                                                                      *
************************************************************************
*                                                                      *
*---- Update the Hessian. The procedure here loops over gradients
*     of the nWndw last iteration. The reason for this is that the
*     initial Hessian is reset to new values at each iteration.
*     The anharmonic constants used here is the most recently
*     updated version.
*
      Call DrvUpH(nWndw,nIter,H,nInter,dq,g,iOptH,jPrint,IterHess)

      Call Chk4NAN(nInter*nInter,H,ierr)

      If (ierr.ne.0) Call SysAbendMsg('Update_H','NaNs in Hessian','')
      If (Store) Call Put_dArray('Hss_upd',H,nInter**2)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Check if we have an old reaction mode
*
      Old_MF=DDot_(3*nsAtom,MF,1,MF,1).ne.Zero
      Old_MF = Old_MF .and. Mode.ne.0 .and. IRC.eq.0
      Call mma_allocate(Tmp,3,nsAtom,Label='Tmp')
      If (Old_MF) Then
         If (jPrint.ge.6)
     &      Write (6,*) ' Reading old reaction mode from disk'
         Tmp(:,:) = MF(:,:)
         Mode=1  ! any number between 1 and nInter
         iOptC=iOr(iOptC,8192)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Massage the new Hessian
*
      Call FixHess(H,nInter,iOptC,Tmp,GNrm,nsAtom,(IterHess.eq.nIter),
     &             AllowFindTS)
*                                                                      *
************************************************************************
*                                                                      *
*     Store the new reaction mode if any!
*
      If (Mode.gt.0 .and. Mode.le.nInter) Then
         If (jPrint.ge.6) Write (6,*)
     %      ' Storing new reaction mode on disk'
         MF(:,:)=Tmp(:,:)
      End If
      Call mma_deallocate(Tmp)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      If (jPrint.ge.99) Then
         Call RecPrt('Update_H: Updated Hessian',' ',H,nInter,nInter)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Christophe Chipot                                      *
!               Janos G. Angyan                                        *
!***********************************************************************

subroutine PNT(IOut,nAtoms,CO,IRMax,DeltaR,IAn,nPts,Grid,IsMM,Process)
! THIS SUBROUTINE CREATES A GRID OF POINTS AROUND A MOLECULE.
!
! THE POINTS ARE INITIALLY SELECTED IN A CUBE, THEN RE-SCALED TO THE
! SIZE OF THE MOLECULE.
!
! THE POINTS LYING WITHIN THE VAN DER WAALS ENVELOPE OF THE
! MOLECULE ARE EXCLUDED, BECAUSE OF THE PENETRATION EFFECTS.
! THIS PROCEDURE IS BASED ON THE SCALED VDW RADII.
! THE SCALING FACTOR : VDWFact
!
! THE POINTS LYING OUTSIDE THE EXCLUSION RADIUS ARE EXCLUDED TOO.
! THE EXCLUSION RADIUS  :  r_max
! THE GRID STEP         :  delta_r
!
! This subroutine comes from the Grid_3.1.2 program (C.CHIPOT, J.G.ANGYAN,
! Universite' Henri Poincare' - Nancy 1, France)

use Constants, only: Zero, One, Two, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IOut, nAtoms, IRMax, IAn(nAtoms), IsMM(nAtoms)
real(kind=wp), intent(in) :: CO(3,nAtoms), DeltaR
integer(kind=iwp), intent(out) :: nPts
real(kind=wp), intent(inout) :: Grid(3,*)
logical(kind=iwp), intent(in) :: Process
real(kind=wp) :: Distance, pointa, pointb, pointc, RMax, rSpher, RVDWMX, RZ, VDWEnv, VDWFact, xmax, xmin, xrange, ymax, ymin, &
                 yrange, zmax, zmin, zrange
integer(kind=iwp) :: iAtom, iPL, Ipx, Ipy, Ipz, maxpt, nbptx, nbpty, nbptz
logical(kind=iwp) :: Retain1, Retain2
real(kind=wp), parameter :: rHuge = 1.0e8_wp, &
                            ! These are mostly Bondi radii (in angstrom), but there are some differences
                            RVDW(0:54) = [2.00_wp, &                                                                    ! X
                                          1.20_wp,1.40_wp, &                                                            ! H-He
                                          1.82_wp,Zero,Zero,1.70_wp,1.55_wp,1.50_wp,1.47_wp,1.54_wp, &                  ! Li-Ne
                                          2.27_wp,1.73_wp,2.30_wp,2.10_wp,1.80_wp,1.80_wp,1.75_wp,1.88_wp, &            ! Na-Ar
                                          2.75_wp,Zero,Zero,Zero,1.22_wp,Zero,Zero,Zero,Zero,1.63_wp,1.40_wp,1.39_wp, & ! K-Zn
                                            1.87_wp,Zero,1.85_wp,1.90_wp,1.85_wp,2.02_wp, &                             ! Ga-Kr
                                          Zero,Zero,Zero,Zero,Zero,Zero,Zero,Zero,Zero,1.63_wp,1.72_wp,1.58_wp, &       ! Rb-Cd
                                            1.93_wp,2.17_wp,Zero,2.06_wp,1.98_wp,2.16_wp]                               ! In-Xe
integer(kind=iwp), external :: iPL_espf

! Criteria ?

iPL = iPL_espf()-1
RMax = real(IRMax,kind=wp)
if (Process .and. (iPL >= 3)) then
  write(IOut,'(A,I2,A)') ' Max : ',IRMax,' van der Waals radii'
  write(IOut,'(A,F4.2,A)') ' ... with ',DeltaR*Angstrom,' angstroms between grid points.'
end if

! The VDW scaling factor is currently hard-coded. Too be changed.

VDWFact = One

! SEARCH FOR THE EXTREMA OF THE MOLECULAR GEOMETRY WITHIN A CUBE.

xmax = -rHuge
xmin = rHuge
ymax = -rHuge
ymin = rHuge
zmax = -rHuge
zmin = rHuge

RVDWMX = Zero
do iAtom=1,nAtoms
  if (IsMM(iAtom) /= 0) then
    if (Process .and. (iPL >= 3)) then
      write(u6,11) iAtom
    end if
    cycle
  end if
  xmax = max(xmax,CO(1,iAtom))
  xmin = min(xmin,CO(1,iAtom))
  ymax = max(ymax,CO(2,iAtom))
  ymin = min(ymin,CO(2,iAtom))
  zmax = max(zmax,CO(3,iAtom))
  zmin = min(zmin,CO(3,iAtom))
  RVDWMX = max(RVDWMX,RVDW(IAn(iAtom)))
end do
rSpher = RMax*RVDWMX/Angstrom

! DETERMINE THE MINIMUM PARALLELEPIPED DIMENSIONS REQUIRED TO
! CONTAIN THE MOLECULE, INCLUDING A MAXIMUM SELECTION RADIUS
! ON BOTH SIDES.

xrange = xmax-xmin+Two*rSpher
yrange = ymax-ymin+Two*rSpher
zrange = zmax-zmin+Two*rSpher

nbptx = int(xrange/DeltaR)
nbpty = int(yrange/DeltaR)
nbptz = int(zrange/DeltaR)

! DETERMINE THE MAXIMUM NUMBER OF POINTS FOR THE FITTING PROCEDURE.

maxpt = nbptx*nbpty*nbptz

! PRINT OUT INTERMEDIATE RESULTS, IF SO REQUESTED

if (iPL > 2) then
  write(IOut,'(" EXTREMA OF THE MOLECULAR GEOMETRY : ")')
  write(IOut,'(a)')
  write(IOut,'(" X_min = ",f8.4,4x,"X_max = ",f8.4)') xmin*Angstrom,xmax*Angstrom
  write(IOut,'(" Y_min = ",f8.4,4x,"Y_max = ",f8.4)') ymin*Angstrom,ymax*Angstrom
  write(IOut,'(" Z_min = ",f8.4,4x,"Z_max = ",f8.4)') zmin*Angstrom,zmax*Angstrom
  write(IOut,'(a)')
  write(IOut,'(" RE-SCALED PARALLELEPIPED SIZE : ")')
  write(IOut,'(a)')
  write(IOut,'(" X = ",f8.4)') xrange*Angstrom
  write(IOut,'(" Y = ",f8.4)') yrange*Angstrom
  write(IOut,'(" Z = ",f8.4)') zrange*Angstrom
  write(IOut,'(a)')
  write(IOut,'(" NUMBER OF POINTS PER DIRECTION : ")')
  write(IOut,'(a)')
  write(IOut,'(" Nb_x = ",i5)') nbptx
  write(IOut,'(" Nb_y = ",i5)') nbpty
  write(IOut,'(" Nb_z = ",i5)') nbptz
  write(IOut,'(a)')
  write(IOut,'(" MAXIMUM POSSIBLE NUMBER OF POINTS : ")')
  write(IOut,'(a)')
  write(IOut,'(" Nb_max = ",i10)') maxpt
  write(IOut,'(a)')
end if

! LOOP OVER ALL POSSIBLE POINTS IN THE PARALLELEPIPED.

nPts = 0

do Ipx=0,nbptx
  pointa = xmin-rSpher+real(Ipx,kind=wp)*DeltaR

  do Ipy=0,nbpty
    pointb = ymin-rSpher+real(Ipy,kind=wp)*DeltaR

    do Ipz=0,nbptz
      pointc = zmin-rSpher+real(Ipz,kind=wp)*DeltaR

      ! IS THIS POINT WITHIN THE VAN DER WAALS ENVELOPE ?
      !      Retain1 => false
      ! IS THIS POINT BEYOND THE EXCLUSION RADIUS FROM ALL ATOMS ?
      !      Retain2 => false

      Retain1 = .true.
      Retain2 = .false.

      iAtom = 0
      do while (Retain1)
        iAtom = iAtom+1
        if (iAtom > nAtoms) exit
        if (IsMM(iAtom) /= 0) cycle
        RZ = RVDW(IAn(iAtom))/Angstrom
        VDWEnv = RZ*VDWFact
        Distance = (pointa-CO(1,iAtom))**2+(pointb-CO(2,iAtom))**2+(pointc-CO(3,iAtom))**2
        Distance = sqrt(Distance)
        if (Retain1) Retain1 = Distance > VDWEnv
        Retain2 = Retain2 .or. (Distance <= rmax*RZ)
      end do

      ! STORE THE POINTS REQUIRED FOR THE FITTING PROCEDURE.

      if (Retain1 .and. Retain2) then
        nPts = nPts+1
        if (Process) then
          Grid(1,nPts) = pointa
          Grid(2,nPts) = pointb
          Grid(3,nPts) = pointc
        end if
      end if
    end do
  end do
end do

return

11 format(' MM atom',I3,' is ignored in the grid construction')

end subroutine PNT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Roland Lindh                                     *
************************************************************************
      Subroutine SetUp_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
************************************************************************
*                                                                      *
*     Object: to set up data and allocate memory for integral calcula- *
*             tions. The whole data structure is hidden to the user.   *
*                                                                      *
*     nSkal(output): returns the number of shells                      *
*     Indexation(input): logical flag to initiate index tables         *
*     ThrAO(input): if ThrAO.ne.Zero CutInt is reset to ThrAO          *
*                                                                      *
*     Author: Roland Lindh, Chemical Physics, University of Lund,      *
*             Sweden. January '98.                                     *
************************************************************************
      use Her_RW
      use vRys_RW
      use iSD_data
      use k2_arrays
      use LundIO
      use Basis_Info, only: nBas, nBas_Aux
      use Real_Info, only: CutInt
      use Logical_info, only: lSchw
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
      External CmpctR, CmpctS
#include "Basis_Mode_Parameters.fh"
#include "Basis_Mode.fh"
#include "stdalloc.fh"
#include "setup.fh"
#include "real.fh"
#include "status.fh"
#include "ndarray.fh"
*
      Logical DoFock, DoGrad, Indexation
*
      If (ERI_Status.eq.Active) Then
        Call Nr_Shells(nSkal)
        Return
      End If
      ERI_Status=Active
*                                                                      *
************************************************************************
*                                                                      *
      if(thrao.ne.Zero) CutInt=ThrAO
*
*.....Compute the total number of symmetry adapted basis functions
*
      nSOs = 0
      Do iIrrep = 0, nIrrep-1
         If (Basis_Mode.eq.Valence_Mode) Then
            nSOs = nSOs + nBas(iIrrep)
         Else If (Basis_Mode.eq.Auxiliary_Mode) Then
            nSOs = nSOs + nBas_Aux(iIrrep)
         Else If (Basis_Mode.eq.With_Auxiliary_Mode) Then
            nSOs = nSOs + nBas(iIrrep) + nBas_Aux(iIrrep)
         End If
      End Do
*
*.....Generate a two-dimensional array of the length of nSOs.
*     The first entry gives the irrep of a SO and the second entry
*     gives the relative index of a SO in its irrep.
*
      Call mma_allocate(iSOSym,2,nSOs,Label='iSOSym')
      iSOs = 1
      nBas_iIrrep=0
      Do iIrrep = 0, nIrrep-1
         If (Basis_Mode.eq.Valence_Mode) Then
            nBas_iIrrep=nBas(iIrrep)
         Else If (Basis_Mode.eq.Auxiliary_Mode) Then
            nBas_iIrrep=nBas_Aux(iIrrep)
         Else If (Basis_Mode.eq.With_Auxiliary_Mode) Then
            nBas_iIrrep=nBas(iIrrep)+nBas_Aux(iIrrep)
         End If
         Do i = 1, nBas_iIrrep
            iSOSym(1,iSOs)=iIrrep          ! Irreducible reps.
            iSOSym(2,iSOs)=i               ! Relative index in irrep.
            iSOs = iSOs + 1
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*.....Compute the number of shells and set up the shell information
*     tables(iSD).
*
      Call Nr_Shells(nSkal)
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     allocate Integer memory for resulting SO info...
*     memory basepointers are declared in inftra common block
*
      If (Indexation) Then
         Indexation_Status=Active
         Call SOFSh1(nSkal,nIrrep,nSOs)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate auxiliary array for symmetry transformation
*
      nAux = nIrrep**3
      If (nIrrep.eq.1) nAux = 1
      Call mma_allocate(Aux,nAux,Label='Aux')
*                                                                      *
************************************************************************
*                                                                      *
*     Preallocate memory for k2 entities
*
      nZeta = MxPrm * MxPrm
      nEta  = MxPrm * MxPrm
      MemR=(nDArray-1)*nZeta + (nDArray-1)*nEta
      Call mma_allocate(Mem_DBLE,MemR,Label='Mem_DBLE')
      ipZeta=1
      MemI=nZeta+nEta+2
      Call mma_allocate(Mem_INT,MemI,Label='Mem_INT')
      ipiZet=1
*                                                                      *
************************************************************************
*                                                                      *
      If (DoFock) Then
         nFT=MxFT
      Else
         nFT=1
      End If
      Call mma_allocate(FT,MxFT,Label='FT')
*                                                                      *
************************************************************************
*                                                                      *
*     Precompute k2 entities
*
      If (lSchw) Then
         Call Drvk2(CmpctS,DoFock,DoGrad)
      Else
         Call Drvk2(CmpctR,DoFock,DoGrad)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call StatP(0)
      Buf%nUt=0
      iDisk=0
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Function iPD(iSO_,jSO_,iSOSym,nSOs)
      use Basis_Info, only: nBas
      Integer iPD
      Integer iSOSym(2,nSOs)
*
      iPD = -999999
*
      iSO=Max(iSO_,jSO_)
      jSO=Min(iSO_,jSO_)
      iSym=iSOSym(1,iSO)
      iSOr=iSOSym(2,iSO)
      jSym=iSOSym(1,jSO)
      jSOr=iSOSym(2,jSO)
      If (iSym.eq.jSym) Then
          ij = iSOr*(iSOr-1)/2 + jSOr
      Else
          ij = (iSOr-1)*nBas(jSym) + jSOr
      End If
*
      iPD=ij
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Rulin Feng                                       *
!***********************************************************************

subroutine XDR_Prop(nbas,isize,jsize,imethod,paratyp,xorder,inS,inK,inV,inpVp,inX,inpXp,inUL,inUS,clight,Label,iComp,iSizec)
! Driver for relativistic transformation of property integrals
!
! also called the "picture change correction" since the physical operator
! X is defined in four-component picture, one need to transform them
! to two-/one-component picture as well as the Hamiltonian in the two-/one-
! component relativistic calculations

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nbas, isize, jsize, imethod, paratyp, xorder, iComp
real(kind=wp), intent(in) :: inS(isize), inK(isize), inV(isize), inpVp(isize), inpXp(isize), clight
real(kind=wp), intent(inout) :: inX(isize), inUL(jsize), inUS(jsize)
integer(kind=iwp) :: i, j, k, iSizec, idbg, nSym, iOpt, iRC, Lu_One, lOper, n_Int, jComp, iPSOComp, IDUM(1)
character(len=8) :: Label, magLabel, PSOLabel
real(kind=wp), allocatable :: sK(:,:), sS(:,:), sV(:,:), spVp(:,:), sX(:,:), spXp(:,:), tmp(:,:), magaPX(:), magaPXs(:,:), &
                              magaXP(:), magaXPs(:,:), magbPX(:), magbPXs(:,:), magbXP(:), magbXPs(:,:), PSO(:,:), PSOt(:), Ppso(:)

! Convert to square matrices

call mma_allocate(sK,nbas,nbas,label='skin')
call mma_allocate(sS,nbas,nbas,label='sSS')
call mma_allocate(sV,nbas,nbas,label='sV')
call mma_allocate(spVp,nbas,nbas,label='spVp')
call mma_allocate(sX,nbas,nbas,label='sX')
call mma_allocate(spXp,nbas,nbas,label='spXp')
#ifdef MOLPRO
call square(inK,sK,nbas,nbas)
call square(inS,sS,nbas,nbas)
call square(inV,sV,nbas,nbas)
call square(inpVp,spVp,nbas,nbas)
call square(inX,sX,nbas,nbas)
call square(inpXp,spXp,nbas,nbas)
#else
call square(inK,sK,nbas,1,nbas)
call square(inS,sS,nbas,1,nbas)
call square(inV,sV,nbas,1,nbas)
call square(inpVp,spVp,nbas,1,nbas)
call square(inX,sX,nbas,1,nbas)
call square(inpXp,spXp,nbas,1,nbas)
#endif

! Calculate the relativistic transformed property integrals

if ((imethod == 2) .or. (imethod == 3) .or. ((imethod == 1) .and. (xorder >= 15))) then

  ! Handle magnetic integrals if provided by Gen1Int
  !
  !********************************************************************
  !
  ! PSO integrals with i, pre-existing PSO integrals in ONEREL
  ! required. The h_UL{\dag} should have a minus sign, for
  ! which a tranpose is not enough, thus add this manually.
  ! * MAG:
  ! *  1: x_k*d/dx  4: x_k*d/dy  7: x_k*d/dz
  ! *  2: y_k*d/dx  5: y_k*d/dy  8: y_k*d/dz
  ! *  3: z_k*d/dx  6: z_k*d/dy  9: z_k*d/dz
  ! * PSO1: operator (y_k*d/dz - z_k*d/dy)/r_k^3
  ! *  = MAG 8 - MAG 6
  ! * PSO2: operator (z_k*d/dx - x_k*d/dz)/r_k^3
  ! *  = MAG 3 - MAG 7
  ! * PSO3: operator (x_k*d/dy - y_k*d/dx)/r_k^3
  ! *  = MAG 4 - MAG 2
  ! * PSO n = MAG a - MAG b

  if ((Label(1:3) == 'MAG') .and. ((iComp == 3) .or. (iComp == 4) .or. (iComp == 8))) then
    nSym = 1 ! always C1 symmetry
    inUS(:) = inUS(:)*clight
    iOpt = 0
    iRC = -1
    Lu_One = 2
    call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
    if (iRC /= 0) call Error()
    ! switch basis to primitive functions
    call OneBas('PRIM')
    ! do MAG a
    write(magLabel,'(A,A3)') 'MAGXP',Label(6:8)
    iOpt = 1
    iRC = -1
    lOper = -1
    call iRdOne(iRC,iOpt,magLabel,iComp,idum,lOper)
    n_Int = IDUM(1)
    if (iRC /= 0) call Error()
    call mma_allocate(magaXP,n_Int+4,label='MAGaXP')
    iOpt = 0
    iRC = -1
    call RdOne(iRC,iOpt,magLabel,iComp,magaXP,lOper)
    if (iRC /= 0) call Error()
    !call CmpInt(magaXP,n_Int,nbas,nSym,lOper)
    call mma_allocate(magaPX,n_Int+4,label='MAGaPX')
    magLabel(1:5) = 'MAGPX'
    call RdOne(iRC,iOpt,magLabel,iComp,magaPX,lOper)
    !if (iRC /= 0) call Error()
    call mma_allocate(magaXPs,nbas,nbas,label='MAGaXPs')
    call mma_allocate(magaPXs,nbas,nbas,label='MAGaPXs')
    call square(magaXP,magaXPs,nbas,1,nbas)
    call square(magaPX,magaPXs,nbas,1,nbas)
    call mma_deallocate(magaXP)
    call mma_deallocate(magaPX)
    call merge_mag_ints(nbas,jsize,magaXPs,magaPXs,.true.)
    ! put magaPXs into -magaPXs
    ! or put magaXPs into -magaXPs
    ! test which
    magaPXs(:,:) = -magaPXs(:,:)
    call mma_allocate(tmp,nbas,nbas,label='TMP')
    ! rulin- disable or reenable dmxma for mag integral X2C
    ! transformations
    call dmxma(nbas,'N','N',magaPXs,inUS,tmp,One)
    call dmxma(nbas,'T','N',inUL,tmp,magaPXs,One)
    call dmxma(nbas,'N','N',magaXPs,inUL,tmp,One)
    call dmxma(nbas,'T','N',inUS,tmp,magaXPs,One)
    magaXPs(:,:) = magaXPs(:,:)+magaPXs(:,:)
    call mma_deallocate(magaPXs)
    ! define MAG b
    if (iComp == 3) then
      jComp = 7
      iPSOComp = 2
    else if (iComp == 4) then
      jComp = 2
      iPSOComp = 3
    else if (iComp == 8) then
      jComp = 6
      iPSOComp = 1
    end if
    ! do MAG b
    write(magLabel,'(A,A3)') 'MAGXP',Label(6:8)
    iOpt = 1
    iRC = -1
    lOper = -1
    call iRdOne(iRC,iOpt,magLabel,jComp,idum,lOper)
    n_Int = IDUM(1)
    if (iRC /= 0) call Error()
    call mma_allocate(magbXP,n_Int+4,label='MAGbXP')
    iOpt = 0
    iRC = -1
    call RdOne(iRC,iOpt,magLabel,jComp,magbXP,lOper)
    call mma_allocate(magbPX,n_Int+4,label='MAGbPX')
    magLabel(1:5) = 'MAGPX'
    call RdOne(iRC,iOpt,magLabel,jComp,magbPX,lOper)
    call ClsOne(iRC,iOpt)
    call mma_allocate(magbXPs,nbas,nbas,label='MAGbXPs')
    call mma_allocate(magbPXs,nbas,nbas,label='MAGbPXs')
    call square(magbXP,magbXPs,nbas,1,nbas)
    call square(magbPX,magbPXs,nbas,1,nbas)
    call mma_deallocate(magbXP)
    call mma_deallocate(magbPX)
    call merge_mag_ints(nbas,jsize,magbXPs,magbPXs,.true.)
    ! put magbPXs into -magbPXs
    ! or put magbXP into -magbXP
    ! test which
    magbPXs(:,:) = -magbPXs(:,:)
    call dmxma(nbas,'N','N',magbPXs,inUS,tmp,One)
    call dmxma(nbas,'T','N',inUL,tmp,magbPXs,One)
    call dmxma(nbas,'N','N',magbXPs,inUL,tmp,One)
    call dmxma(nbas,'T','N',inUS,tmp,magbXPs,One)
    magbXPs(:,:) = magbXPs(:,:)+magbPXs(:,:)
    call mma_deallocate(magbPXs)
    call mma_deallocate(tmp)
    ! do PSO combinations
    call mma_allocate(PSO,nbas,nbas,label='PSO')
    PSO(:,:) = magaXPs(:,:)-magbXPs(:,:)
    call mma_deallocate(magaXPs)
    call mma_deallocate(magbXPs)
    write(PSOLabel,'(A,A3)') 'PSOI ',Label(6:8)
    ! test for off-diagonal elements
    IDUM(1) = nbas
    call CmpInt(PSO,n_Int,idum(1),nSym,lOper)
    ! store PSO integrals to ONEINT
    call mma_allocate(PSOt,n_Int+4,label='PSOt')
    k = 1
    do i=1,nbas
      do j=1,i
        PSOt(k) = PSO(j,i)
        k = k+1
      end do
    end do
    call mma_deallocate(PSO)
    call mma_allocate(Ppso,iSizec+4,label='PPSO')
    idbg = -1
    call repmat(idbg,PSOt,Ppso,.false.)
    call mma_deallocate(PSOt)
    iOpt = 0
    iRC = -1
    Lu_one = 2
    call OpnOne(iRC,iOpt,'ONEINT',Lu_one)
    if (iRC /= 0) call Error()
    iRC = -1
    lOper = 255
    call WrOne(iRC,iOpt,PSOLabel,iPSOComp,Ppso,lOper)
    if (iRC /= 0) call Error()
    iOpt = 0
    call ClsOne(iRC,iOpt)
    call mma_deallocate(Ppso)
    inUS(:) = inUS(:)/clight
  end if

  if (Label(1:3) == 'MAG') then
    inUS(:) = inUS(:)*clight
    ! Put together lower and upper triangular matrices
    call merge_mag_ints(nbas,jsize,sX,spXp,.true.)
    call mma_allocate(tmp,nbas,nbas,label='TMP')
    ! Eval U_L^{\dag} X U_S
    ! Eval U_S^{\dag} X U_L
    call dmxma(nbas,'N','N',spXp,inUS,tmp,One)
    call dmxma(nbas,'T','N',inUL,tmp,spXp,One)
    call dmxma(nbas,'N','N',sX,inUL,tmp,One)
    call dmxma(nbas,'T','N',inUS,tmp,sX,One)
    ! Sum
    sX(:,:) = sX(:,:)+spXp(:,:)
    ! copy spXp back so its not a half computed matrix
    spXp(:,:) = sX(:,:)
    call mma_deallocate(tmp)
    inUS(:) = inUS(:)/clight
  else

    ! X2C/BSS transformation
    !
    ! because the transformation matrix in non-orthogonal basis picture has
    ! obtained via the Hamiltonian drivers, here we just need to simply apply
    ! it to property integrals ( X, pXp in four-component picture )
    !
    ! high order DKH can also employ this formulation, only negligible
    ! contribution from higher orders is included

    call mma_allocate(tmp,nbas,nbas,label='TMP')
    ! eval U_L^{\dag} X U_L
    call dmxma(nbas,'C','N',inUL,sX,tmp,One)
    call dmxma(nbas,'N','N',tmp,inUL,sX,One)
    ! eval U_S^{\dag}pXp U_S
    call dmxma(nbas,'C','N',inUS,spXp,tmp,One)
    call dmxma(nbas,'N','N',tmp,inUS,spXp,One)
    ! sum
    sX(:,:) = sX(:,:)+spXp(:,:)
    call mma_deallocate(tmp)
  end if !MAG

else if (imethod == 1) then

  ! Arbitrary order DKH transformation

  call dkh_prop(nbas,sS,sK,sV,spVp,sX,spXp,clight,xorder,paratyp)
end if

! Copy transformed property integral back to inX

k = 1
do i=1,nbas
  do j=1,i
    inX(k) = sX(j,i)
    k = k+1
  end do
end do

! Free temp memories

call mma_deallocate(sK)
call mma_deallocate(sS)
call mma_deallocate(sV)
call mma_deallocate(spVp)
call mma_deallocate(sX)
call mma_deallocate(spXp)

return

contains

subroutine Error()
  use Definitions, only: u6
  write(u6,*) ' *** Error in subroutine XDR_Prop ***'
  write(u6,*) '     Abend in subroutine OpnOne'
  call Abend()
end subroutine Error

end subroutine XDR_Prop

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_T2n(T2,dimbe,addbe,dimga,addga,key)
! chek T2n bez menovatelov, nediagonalne

use chcc_global, only: Ac, Bc, Gooc, Gvvc, Jc, Kc, no, nv, OEo, OEv, Q1, Q21, Q22, Q3, T1c, T2c
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dimbe, addbe, dimga, addga, key
real(kind=wp), intent(in) :: T2(dimbe,dimga,no,no)
integer(kind=iwp) :: a, b, bad, be, bstart, bup, ga, i, j, ntot, u, v
real(kind=wp) :: s, s1

bad = 0
ntot = 0

do v=1,no
  do u=1,no
    do ga=addga+1,addga+dimga
      if (key == 1) then
        bstart = ga
        bup = addbe+dimbe
      else
        bstart = addbe+1
        bup = addbe+dimbe
      end if
      do be=bstart,bup

        ntot = ntot+1
        s = Zero

        !1
        s1 = Q21(be,u,ga,v)
        s = s+s1

        !2
        s1 = Zero
        do j=1,no
          do i=1,no
            s1 = s1+Ac(i,j,u,v)*(T2c(be,ga,i,j)+T1c(be,i)*T1c(ga,j))
          end do
        end do
        s = s+s1

        !3
        s1 = Zero
        do b=1,nv
          do a=1,nv
            s1 = s1+Bc(a,b,be,ga)*(T2c(a,b,u,v)+T1c(a,u)*T1c(b,v))
          end do
        end do
        s = s+s1

        !4
        s1 = Zero
        do a=1,nv
          s1 = s1+Gvvc(be,a)*T2c(a,ga,u,v)
          s1 = s1+Gvvc(ga,a)*T2c(a,be,v,u)
        end do
        s = s+s1

        !5
        s1 = Zero
        do i=1,no
          s1 = s1+Gooc(i,u)*T2c(be,ga,i,v)
          s1 = s1+Gooc(i,v)*T2c(ga,be,i,u)
        end do
        s = s-s1

        !6
        s1 = Zero
        do a=1,nv
          s1 = s1+Q3(ga,a,be,u)*T1c(a,v)
          s1 = s1+Q3(be,a,ga,v)*T1c(a,u)
        end do
        do i=1,no
          do a=1,nv
            s1 = s1-(Q22(ga,a,i,u)*T1c(be,i))*T1c(a,v)
            s1 = s1-(Q22(be,a,i,v)*T1c(ga,i))*T1c(a,u)
          end do
        end do
        s = s+s1

        !7
        s1 = Zero
        do i=1,no
          s1 = s1+Q1(be,u,i,v)*T1c(ga,i)
          s1 = s1+Q1(ga,v,i,u)*T1c(be,i)
        end do
        do i=1,no
          do a=1,nv
            s1 = s1+(Q21(be,u,a,i)*T1c(a,v))*T1c(ga,i)
            s1 = s1+(Q21(ga,v,a,i)*T1c(a,u))*T1c(be,i)
          end do
        end do
        s = s-s1

        !8
        s1 = Zero
        do i=1,no
          do a=1,nv
            s1 = s1+(Two*Jc(be,i,u,a)-Kc(i,be,u,a))*(Two*T2c(a,ga,i,v)-T2c(ga,a,i,v))
            s1 = s1+(Two*Jc(ga,i,v,a)-Kc(i,ga,v,a))*(Two*T2c(a,be,i,u)-T2c(be,a,i,u))
          end do
        end do
        s = s+Half*s1

        !9
        s1 = Zero
        do i=1,no
          do a=1,nv
            s1 = s1+Kc(i,be,u,a)*T2c(ga,a,i,v)
            s1 = s1+Kc(i,ga,v,a)*T2c(be,a,i,u)
          end do
        end do
        s = s-Half*s1

        !10
        s1 = Zero
        do i=1,no
          do a=1,nv
            s1 = s1+Kc(i,ga,u,a)*T2c(be,a,i,v)
            s1 = s1+Kc(i,be,v,a)*T2c(ga,a,i,u)
          end do
        end do
        s = s-s1

        s = s/(Oeo(u)+Oeo(v)-Oev(be)-Oev(ga))

        if (abs(T2(be-addbe,ga-addga,u,v)-s) > 1.0e-10_wp) then
          bad = bad+1
          !write(u6,*) 'Bad',abs(T2(be-addbe,ga-addga,u,v)
        end if

      end do
    end do
  end do
end do

if (key == 1) then
  write(u6,*) ' Final test T2 dia',bad,ntot
else
  write(u6,*) ' Final test T2 off',bad,ntot
end if

return

end subroutine Chck_T2n

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ZSMCL(NSMST,NOCTP,NSSO,ISTSM,ISTCL)
*
* set symmetry and class arrays for strings
*
      INTEGER ISTSM(*),ISTCL(*),NSSO(NOCTP,NSMST)
*
      IOFF = 1
      DO 100 ISM = 1, NSMST
      DO 101 ICL = 1, NOCTP
        CALL  ISETVC(ISTSM(IOFF),ISM,NSSO(ICL,ISM))
        CALL  ISETVC(ISTCL(IOFF),ICL,NSSO(ICL,ISM))
        IOFF = IOFF + NSSO(ICL,ISM)
  101 CONTINUE
  100 CONTINUE
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************
!*************************************************************
! Initializes info needed by the Cholesky integral generator
!
! F. Aquilante
!*************************************************************

subroutine INIT_GETINT(RC)

use Index_Functions, only: nTri_Elem
use GetInt_mod, only: LuCVec, mNeed, nBas, nPQ, nRS, NumCho, nVec, pq1, Vec2
use RICD_Info, only: Do_DCCD
use TwoDat, only: rcTwo
use stdalloc, only: mma_allocate, mma_maxDBLE
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: RC
integer(kind=iwp) :: LWork, nSym

rc = 0
call get_iscalar('nSym',nSym)
call get_iarray('nBas',nBas,nSym)
call INIT_NumCV(NumCho,nSym)

if (Do_DCCD) then
  if (NumCho(1) < 1) then
    write(u6,*) 'Init_GetInt: NumCho(1) < 1'
    call Abend()
  end if

  nPQ = nTri_Elem(nBas(1))
  nRS = nPQ
  ! Memory management
  mNeed = 2*nPQ

  if (mNeed <= 0) then
    ! ***QUIT*** bad initialization
    write(u6,*) 'Gen_Int: bad initialization'
    rc = rcTwo%RD11
    call Abend()
  end if

  ! Set up the batch procedure
  ! --------------------------
  call mma_maxDBLE(LWORK)
  LWORK = LWORK-LWORK/10

  nVec = min(LWORK/mNeed,NumCho(1))

  if (nVec <= 0) then
    ! ***QUIT*** insufficient memory
    write(u6,*) 'Gen_Int: Insufficient memory for batch'
    write(u6,*) 'LWORK= ',LWORK
    write(u6,*) 'mNeed= ',mNeed
    write(u6,*) 'NumCho= ',NumCho(1)
    rc = rcTwo%RD05
    call Abend()
  end if

  ! Allocate memory for reading the vectors and do the transposition
  call mma_allocate(Vec2,Npq,nVec,label='MemC2')

end if

LuCVec(1) = -1
LuCVec(2) = -1

pq1 = 0

return

end subroutine INIT_GETINT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkstrtgs_cvb(orbsao,irdorbs,cvb,recn)

use casvb_global, only: ifmos, kbasiscvb, nbas_mo, nmcscf, norb, nvb, variat
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: orbsao(nbas_mo,norb), cvb(nvb)
integer(kind=iwp), intent(out) :: irdorbs(norb)
real(kind=wp), intent(in) :: recn
integer(kind=iwp) :: ierr, ioffs_cvb, ioffs_orbs, ioffs_orbsao, ioffs_orbslao, iorb, nbas_mo1, norb1, nvb1
logical(kind=iwp) :: use_ao

call rdheader_cvb(recn,norb1,nbas_mo1,nvb1,kbasiscvb,ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)
use_ao = ifmos .and. ((.not. variat) .or. (variat .and. (nmcscf == 1))) .and. (nbas_mo == nbas_mo1) .and. (ioffs_orbsao > 0)
do iorb=1,norb
  if (.not. use_ao) then
    irdorbs(iorb) = 1
    call rdgspr_cvb(recn,orbsao(:,iorb),iorb,norb,1,ierr)
  else
    irdorbs(iorb) = 2
    call rdgspr_cvb(recn,orbsao(:,iorb),iorb,nbas_mo,3,ierr)
  end if
  if (ierr /= 0) then
    call prtfid_cvb(' Error in orbital read from ',recn)
    write(u6,'(a)') ' Orbital no :',iorb
    if (use_ao) then
      write(u6,'(a)') ' AO basis ? : Yes'
    else
      write(u6,'(a)') ' AO basis ? : No'
    end if
    call abend_cvb()
  end if
end do
call rdgspr_cvb(recn,cvb,1,nvb,2,ierr)

return

end subroutine mkstrtgs_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Mk_Hss_Q()
      use Slapaf_Info, only: Cx, Coor, DipM, qInt, dqInt, BMx, mRowH
      use Slapaf_Parameters, only: BSet, HSet, Delta, lNmHss, nDimBC,
     &                             mTROld, NmIter, iter
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
*
*     Compute the Hessian in internal coordinates.
*
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('Mk_Hss_Q: DipM',' ',DipM,SIZE(DipM,1),SIZE(DipM,2))
#endif
      If ((lNmHss.or.Allocated(mRowH)).and.iter.eq.NmIter) Then
         mInt = nDimBC - mTROld
         nsAtom=SIZE(Coor,2)
         Call Put_dArray('Unique Coordinates',Cx,3*nsAtom)
         Call Put_Coord_New(Cx,nsAtom)
         If (Allocated(mRowH)) Then
            If (BSet.and.HSet) Call Hss_Q()
            Call RowHessian(NmIter,mInt,Delta/2.5d0)
         Else
            Call FormNumHess(iter,mInt,Delta,nsAtom,iNeg,DipM)
         End If
*
         Coor(:,:) = Cx(:,:,1)
         Call Get_dArray('BMxOld',BMx,SIZE(Coor)*SIZE(qInt,1))
         qInt(:,Iter) = qInt(:,1)
         dqInt(:,Iter) = dqInt(:,1)
      Else
         If (BSet.and.HSet) Call Hss_Q()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 FUNCTION OVERLAP_RASSI(IFSBTAB1,IFSBTAB2,PSI1,PSI2)
      IMPLICIT NONE
      REAL*8 PSI1(*),PSI2(*)
      INTEGER IFSBTAB1(*),IFSBTAB2(*)
      INTEGER ISSTARR(50)
      INTEGER NFSB1,NASPRT1,NDETS1,KSTARR1
      INTEGER NFSB2,NASPRT2,NDETS2,NHSH2,KHSH2,KSTARR2
      INTEGER IFSB1,KPOS1,ISPART
      INTEGER IFSB2,KPOS2
      INTEGER IBLKPOS1,NBLKSIZ1
      INTEGER IBLKPOS2,NBLKSIZ2
      real*8 ddot_
      external ddot_

C Purpose: Compute the overlap of two wave functions
C The FS blocks of the two wave functions:
      NFSB1  =IFSBTAB1(3)
      NASPRT1=IFSBTAB1(4)
      NDETS1 =IFSBTAB1(5)
      KSTARR1=8
      NFSB2  =IFSBTAB2(3)
      NASPRT2=IFSBTAB2(4)
      NDETS2 =IFSBTAB2(5)
      NHSH2  =IFSBTAB2(6)
      KHSH2  =IFSBTAB2(7)
      KSTARR2=8
      OVERLAP_RASSI=0.0D0
      IF (NFSB1.EQ.0) RETURN
      IF (NFSB2.EQ.0) RETURN
      IF (NASPRT1.NE.NASPRT2) GOTO 901
      IF (NDETS1.EQ.0) RETURN
      IF (NDETS2.EQ.0) RETURN

C Loop over FS blocks of the PSI1 wave function
      DO IFSB1=1,NFSB1
        KPOS1=KSTARR1+(NASPRT1+2)*(IFSB1-1)
        DO ISPART=1,NASPRT1
          ISSTARR(ISPART)=IFSBTAB1(KPOS1-1+ISPART)
        END DO
        NBLKSIZ1 =IFSBTAB1(KPOS1+NASPRT1  )
        IBLKPOS1 =IFSBTAB1(KPOS1+NASPRT1+1)
C Find this block in the PSI2 structure.
        CALL HSHGET(ISSTARR,NASPRT2,NASPRT2+2,IFSBTAB2(KSTARR2),
     &                NHSH2,IFSBTAB2(KHSH2),IFSB2)
        IF(IFSB2.EQ.0) GOTO 100
        KPOS2=KSTARR2+(NASPRT2+2)*(IFSB2-1)
        NBLKSIZ2 =IFSBTAB2(KPOS2+NASPRT2  )
        IF(NBLKSIZ1.NE.NBLKSIZ2) THEN
          WRITE(6,*)' OVERLAP Error: The same FS block has not'
          WRITE(6,*)' the same size in PSI1 and PSI2.'
          CALL ABEND()
        END IF
        IBLKPOS2 =IFSBTAB2(KPOS2+NASPRT2+1)
        OVERLAP_RASSI=OVERLAP_RASSI+
     &         DDOT_(NBLKSIZ1,PSI1(IBLKPOS1),1,PSI2(IBLKPOS2),1)
 100    CONTINUE
      END DO
      RETURN
 901  CONTINUE
      WRITE(6,*)' OVERLAP Error: The two wave function structures'
      WRITE(6,*)' have different nr of subpartitions!'
      CALL ABEND()
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Do_Pi2Grad(mAO,mGrid,P2_ontop,nP2_ontop,nGrad_Eff,list_s,nlist_s,list_bas,D1mo,nd1mo,TabMO,P2_ontop_d,RhoI,RhoA,mRho, &
                      nMOs,CMO,nCMO,TabSO,ft,P2MOCube,P2MOCubex,P2MOCubey,P2MOCubez,nPMO3p,MOs,MOx,MOy,MOz)
!***********************************************************************
!                                                                      *
! Object: Calculation P2 ontop density and its derivatives             *
!                                                                      *
! Called from: Do_batch                                                *
!                                                                      *
!    INPUT:                                                            *
!   D1mo     = one-body density matrix in MO basis                     *
!   nd1mo    = size of D1mo                                            *
!   TabMO    = MO values computed on grid                              *
!   nMOs     = number of MO basis                                      *
!   mAO      = number of derivatives of AO...                          *
!   mGrid    = number of grid points                                   *
!                                                                      *
!***********************************************************************

use Basis_Info, only: nBas
use nq_pdft, only: lft, lGGA
use nq_Grid, only: List_G
use nq_Info, only: Functional_type, GGA_type, iOff_Ash, iOff_Bas, iOff_BasAct, mBas, mIrrep, nAsh, NASHT, nFro, nIsh, OffBas, &
                   OffBas2
use Index_Functions, only: iTri
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four, Eight
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: mAO, mGrid, nP2_ontop, nGrad_Eff, nlist_s, list_s(2,nlist_s), list_bas(2,nlist_s), nd1mo, mRho, &
                                 nMOs, nCMO, nPMO3p
real(kind=wp), intent(out) :: P2_ontop(nP2_ontop,mGrid), P2_ontop_d(np2_ontop,nGrad_Eff,mGrid), TabSO(mAO,mGrid,nMOs)
real(kind=wp), intent(in) :: D1mo(nd1mo), TabMO(mAO,mGrid,nMOs), CMO(nCMO), P2MOCube(NASHT,mGrid), P2MOCubex(NASHT,nPMO3p), &
                             P2MOCubey(NASHT,nPMO3p), P2MOCubez(NASHT,nPMO3p), MOs(NASHT,mGrid), MOx(NASHT,mGrid), &
                             MOy(NASHT,mGrid), MOz(NASHT,mGrid)
real(kind=wp), intent(inout) :: RhoA(mRho,mGrid), RhoI(mRho,mGrid)
logical(kind=iwp), intent(in) :: ft
integer(kind=iwp) :: g_eff, i, i_, iCoord, iCoord1, iCoord2, iCoord3, iGrid, iIrrep, ilist_s, IOff1, iOff2, iOffF, jOffA_, jOffB_, &
                     k, k_, kIrrep, kl, l, l_, lIrrepx, nBasf, nOccO, NumAsh, NumIsh
real(kind=wp), allocatable :: dMOs(:,:), dMOx(:,:), dMOy(:,:), dMOz(:,:), dRhoA(:,:,:), dRhoI(:,:,:), dTabMO(:,:,:,:), dTabMO2(:), &
                              TabSO2(:,:,:)
real(kind=r8), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
if (nP2_ontop == 4) then
  if ((mAO /= 10) .or. (mRho /= 4)) then
    call WarningMessage(2,' Something is wrong in dim. in p2cs')
    call Abend()
  end if
else if (nP2_ontop == 6) then
  if ((mAO /= 10) .or. (mRho /= 6)) then
    call WarningMessage(2,' Something is wrong in dim. in p2cs')
    call Abend()
  end if
end if

P2_ontop(:,:) = Zero
P2_ontop_d(:,:,:) = Zero
call mma_allocate(dRhoI,mRho,mGrid,nGrad_Eff,Label='dRhoI')
call mma_allocate(dRhoA,mRho,mGrid,nGrad_Eff,Label='dRhoA')
dRhoI(:,:,:) = Zero
dRhoA(:,:,:) = Zero
jOffA_ = 0
jOffB_ = 0
do iIrrep=0,mIrrep-1
  iOff_Ash(iIrrep) = jOffA_
  iOff_Bas(iIrrep) = jOffB_
  iOff_BasAct(iIrrep) = jOffB_+nIsh(iIrrep)+nFro(iIrrep)
  jOffA_ = jOffA_+nAsh(iIrrep)
  jOffB_ = jOffB_+mBas(iIrrep)
end do
!***********************************************************************
!   P(1,...) - P_2                                                     *
!   P(2,...), P(3,...), P(4,...) - grad P_2                            *
!***********************************************************************

call mma_allocate(dTabMO,nP2_ontop,nMOs,nGrad_eff,mGrid,Label='dTabMO')
dTabMO(:,:,:,:) = Zero

call mma_allocate(TabSO2,nMOs,mAO,mGrid,Label='TabSO2')
call mma_allocate(dTabMO2,nMOs,Label='dTabMO2')

do ilist_s=1,nlist_s

  TabSO(:,:,:) = Zero

  call mk_SOs(TabSO,mAO,mGrid,nMOs,List_s,List_Bas,nList_s,iList_s)

  call ConvertTabSO(TabSO2,TabSO,mAO,mGrid,nMOs)

  do iGrid=1,mGrid

    do iCoord=1,3
      g_eff = list_g(iCoord,ilist_s)

      iCoord1 = 0
      iCoord2 = 0
      iCoord3 = 0
      if (lft .and. lGGA) then
        select case (iCoord)
          case (1)
            iCoord1 = 4
            iCoord2 = 5
            iCoord3 = 6
          case (2)
            iCoord1 = 5
            iCoord2 = 7
            iCoord3 = 8
          case (3)
            iCoord1 = 6
            iCoord2 = 8
            iCoord3 = 9
        end select
      end if

      do iIrrep=0,mIrrep-1
        nOccO = nIsh(iIrrep)+nAsh(iIrrep)
        if (nOccO == 0) cycle
        nBasF = nBas(iIrrep)

        iOffF = OffBas(iIrrep)+nFro(iIrrep)

        call DGEMM_('T','N',nOccO,1,nBasF,One,CMO(OffBas2(iIrrep):),nBasF,TabSO2(OffBas(iIrrep):,iCoord,iGrid),nBasF,Zero,dTabMO2, &
                    nOccO)
        dTabMO(1,iOffF:iOffF+nOccO-1,g_eff,iGrid) = dTabMO(1,iOffF:iOffF+nOccO-1,g_eff,iGrid)+dTabMO2(1:nOccO)

        if (lft .and. lGGA) then
          call DGEMM_('T','N',nOccO,1,nBasF,One,CMO(OffBas2(iIrrep):),nBasF,TabSO2(OffBas(iIrrep):,iCoord1,iGrid),nBasF,Zero, &
                      dTabMO2,nOccO)
          dTabMO(2,iOffF:iOffF+nOccO-1,g_eff,iGrid) = dTabMO(2,iOffF:iOffF+nOccO-1,g_eff,iGrid)+dTabMO2(1:nOccO)

          call DGEMM_('T','N',nOccO,1,nBasF,One,CMO(OffBas2(iIrrep):),nBasF,TabSO2(OffBas(iIrrep):,iCoord2,iGrid),nBasF,Zero, &
                      dTabMO2,nOccO)
          dTabMO(3,iOffF:iOffF+nOccO-1,g_eff,iGrid) = dTabMO(3,iOffF:iOffF+nOccO-1,g_eff,iGrid)+dTabMO2(1:nOccO)

          call DGEMM_('T','N',nOccO,1,nBasF,One,CMO(OffBas2(iIrrep):),nBasF,TabSO2(OffBas(iIrrep):,iCoord3,iGrid),nBasF,Zero, &
                      dTabMO2,nOccO)
          dTabMO(4,iOffF:iOffF+nOccO-1,g_eff,iGrid) = dTabMO(4,iOffF:iOffF+nOccO-1,g_eff,iGrid)+dTabMO2(1:nOccO)
        end if
      end do ! iIrrep
    end do   ! iCoord
  end do     ! iGrid
end do       ! iList_s
call mma_deallocate(TabSO2)
call mma_deallocate(dTabMO2)
!***********************************************************************
! Inactive part:                                                       *
!***********************************************************************
NumIsh = 0
NumAsh = 0
do iIrrep=0,mIrrep-1
  NumIsh = NumIsh+nISh(iIrrep)
  NumAsh = NumAsh+nAsh(iIrrep)
end do

do iGrid=1,mGrid
  do iIrrep=0,mIrrep-1
    do i_=1,nISh(iIrrep)+nFro(iIrrep)
      i = iOff_Bas(iIrrep)+i_
      RhoI(1,iGrid) = RhoI(1,iGrid)+TabMO(1,iGrid,i)*TabMO(1,iGrid,i)
      if ((Functional_type == GGA_type) .and. ft) then
        RhoI(2,iGrid) = RhoI(2,iGrid)+TabMO(1,iGrid,i)*TabMO(2,iGrid,i)
        RhoI(3,iGrid) = RhoI(3,iGrid)+TabMO(1,iGrid,i)*TabMO(3,iGrid,i)
        RhoI(4,iGrid) = RhoI(4,iGrid)+TabMO(1,iGrid,i)*TabMO(4,iGrid,i)
      end if

      ! Build dRhoI
      do g_eff=1,nGrad_eff
        dRhoI(1,iGrid,g_eff) = dRhoI(1,iGrid,g_eff)+dTabMO(1,i,g_eff,iGrid)*TabMO(1,iGrid,i) !times 2 or not?

        if ((Functional_type == GGA_type) .and. ft) then
          dRhoI(2,iGrid,g_eff) = dRhoI(2,iGrid,g_eff)+dTabMO(1,i,g_eff,iGrid)*TabMO(2,iGrid,i)+ &
                                 TabMO(1,iGrid,i)*dTabMO(2,i,g_eff,iGrid)

          dRhoI(3,iGrid,g_eff) = dRhoI(3,iGrid,g_eff)+dTabMO(1,i,g_eff,iGrid)*TabMO(3,iGrid,i)+ &
                                 TabMO(1,iGrid,i)*dTabMO(3,i,g_eff,iGrid)

          dRhoI(4,iGrid,g_eff) = dRhoI(4,iGrid,g_eff)+dTabMO(1,i,g_eff,iGrid)*TabMO(4,iGrid,i)+ &
                                 TabMO(1,iGrid,i)*dTabMO(4,i,g_eff,iGrid)

        end if ! GGA
      end do   ! g_eff

    end do     ! i_
  end do       ! iIrrep
end do         ! iGrid

if (NumIsh /= 0) then
  do iGrid=1,mGrid
    P2_ontop(1,iGrid) = RhoI(1,iGrid)*RhoI(1,iGrid)

    if ((Functional_type == GGA_type) .and. ft) then
      P2_ontop(2,iGrid) = Four*RhoI(1,iGrid)*RhoI(2,iGrid)
      P2_ontop(3,iGrid) = Four*RhoI(1,iGrid)*RhoI(3,iGrid)
      P2_ontop(4,iGrid) = Four*RhoI(1,iGrid)*RhoI(4,iGrid)
    end if
    do g_eff=1,nGrad_eff
      P2_ontop_d(1,g_eff,iGrid) = P2_ontop_d(1,g_eff,iGrid)+Four*dRhoI(1,iGrid,g_eff)*RhoI(1,iGrid)

      if ((Functional_type == GGA_type) .and. ft) then
        !******************ADD STUFF FOR FT: HERE***************
        P2_ontop_d(2,g_eff,iGrid) = P2_ontop_d(2,g_eff,iGrid)+Four*dRhoI(2,iGrid,g_eff)*RhoI(1,iGrid)+ &
                                    Eight*dRhoI(1,iGrid,g_eff)*RhoI(2,iGrid)

        P2_ontop_d(3,g_eff,iGrid) = P2_ontop_d(3,g_eff,iGrid)+Four*dRhoI(3,iGrid,g_eff)*RhoI(1,iGrid)+ &
                                    Eight*dRhoI(1,iGrid,g_eff)*RhoI(3,iGrid)

        P2_ontop_d(4,g_eff,iGrid) = P2_ontop_d(4,g_eff,iGrid)+Four*dRhoI(4,iGrid,g_eff)*RhoI(1,iGrid)+ &
                                    Eight*dRhoI(1,iGrid,g_eff)*RhoI(4,iGrid)

      end if ! GGA
    end do   ! ngrad

  end do
end if

!***********************************************************************
! Active-Inactive part:                                                *
!***********************************************************************
if ((NumIsh /= 0) .and. (NumAsh /= 0)) then
  do kIrrep=0,mIrrep-1
    do k_=1,nASh(kIrrep)
      k = k_+iOff_BasAct(kIrrep)
      do lIrrepx=0,mIrrep-1
        do l_=1,nAsh(lIrrepx)
          l = l_+iOff_BasAct(lIrrepx)
          kl = iTri(k_+iOff_Ash(kIrrep),l_+iOff_Ash(lIrrepx))
          do iGrid=1,mGrid
            RhoA(1,iGrid) = RhoA(1,iGrid)+D1mo(kl)*TabMO(1,iGrid,k)*TabMO(1,iGrid,l)
            if ((Functional_type == GGA_type) .and. ft) then
              RhoA(2,iGrid) = RhoA(2,iGrid)+D1mo(kl)*TabMO(1,iGrid,k)*TabMO(2,iGrid,l)
              RhoA(3,iGrid) = RhoA(3,iGrid)+D1mo(kl)*TabMO(1,iGrid,k)*TabMO(3,iGrid,l)
              RhoA(4,iGrid) = RhoA(4,iGrid)+D1mo(kl)*TabMO(1,iGrid,k)*TabMO(4,iGrid,l)
            end if

            do g_eff=1,nGrad_eff
              dRhoA(1,iGrid,g_eff) = dRhoA(1,iGrid,g_eff)+D1mo(kl)*dTabMO(1,k,g_eff,iGrid)*TabMO(1,iGrid,l)

              !******************ADD STUFF FOR FT: HERE***************

              if ((Functional_type == GGA_type) .and. ft) then
                dRhoA(2,iGrid,g_eff) = dRhoA(2,iGrid,g_eff)+D1mo(kl)*dTabMO(1,k,g_eff,iGrid)*TabMO(2,iGrid,l)+ &
                                       D1mo(kl)*TabMO(1,iGrid,k)*dTabMO(2,l,g_eff,iGrid)

                dRhoA(3,iGrid,g_eff) = dRhoA(3,iGrid,g_eff)+D1mo(kl)*dTabMO(1,k,g_eff,iGrid)*TabMO(3,iGrid,l)+ &
                                       D1mo(kl)*TabMO(1,iGrid,k)*dTabMO(3,l,g_eff,iGrid)

                dRhoA(4,iGrid,g_eff) = dRhoA(4,iGrid,g_eff)+D1mo(kl)*dTabMO(1,k,g_eff,iGrid)*TabMO(4,iGrid,l)+ &
                                       D1mo(kl)*TabMO(1,iGrid,k)*dTabMO(4,l,g_eff,iGrid)
              end if ! GGA

            end do
          end do     ! iGrid
        end do       ! l_
      end do         ! lIrrepx
    end do           ! k_
  end do             ! kIrrep

  do iGrid=1,mGrid
    P2_ontop(1,iGrid) = P2_ontop(1,iGrid)+RhoI(1,iGrid)*RhoA(1,iGrid)
    if ((Functional_type == GGA_type) .and. ft) then
      P2_ontop(2,iGrid) = P2_ontop(2,iGrid)+Two*RhoI(2,iGrid)*RhoA(1,iGrid)+Two*RhoI(1,iGrid)*RhoA(2,iGrid)
      P2_ontop(3,iGrid) = P2_ontop(3,iGrid)+Two*RhoI(3,iGrid)*RhoA(1,iGrid)+Two*RhoI(1,iGrid)*RhoA(3,iGrid)
      P2_ontop(4,iGrid) = P2_ontop(4,iGrid)+Two*RhoI(4,iGrid)*RhoA(1,iGrid)+Two*RhoI(1,iGrid)*RhoA(4,iGrid)
    end if ! GGA
    do g_eff=1,nGrad_Eff
      P2_ontop_d(1,g_eff,iGrid) = P2_ontop_d(1,g_eff,iGrid)+Two*RhoI(1,iGrid)*dRhoA(1,iGrid,g_eff)+ &
                                  Two*dRhoI(1,iGrid,g_eff)*RhoA(1,iGrid)
      if ((Functional_type == GGA_type) .and. ft) then

        P2_ontop_d(2,g_eff,iGrid) = P2_ontop_d(2,g_eff,iGrid)+Two*dRhoI(2,iGrid,g_eff)*RhoA(1,iGrid)+ &
                                    Four*RhoI(2,iGrid)*dRhoA(1,iGrid,g_eff)+Four*dRhoI(1,iGrid,g_eff)*RhoA(2,iGrid)+ &
                                    Two*RhoI(1,iGrid)*dRhoA(2,iGrid,g_eff)

        P2_ontop_d(3,g_eff,iGrid) = P2_ontop_d(3,g_eff,iGrid)+Two*dRhoI(3,iGrid,g_eff)*RhoA(1,iGrid)+ &
                                    Four*RhoI(3,iGrid)*dRhoA(1,iGrid,g_eff)+Four*dRhoI(1,iGrid,g_eff)*RhoA(3,iGrid)+ &
                                    Two*RhoI(1,iGrid)*dRhoA(3,iGrid,g_eff)

        P2_ontop_d(4,g_eff,iGrid) = P2_ontop_d(4,g_eff,iGrid)+Two*dRhoI(4,iGrid,g_eff)*RhoA(1,iGrid)+ &
                                    Four*RhoI(4,iGrid)*dRhoA(1,iGrid,g_eff)+Four*dRhoI(1,iGrid,g_eff)*RhoA(4,iGrid)+ &
                                    Two*RhoI(1,iGrid)*dRhoA(4,iGrid,g_eff)
      end if ! GGA
    end do   ! g_eff

  end do ! loop over grid points
end if   ! if Inactive

call mma_deallocate(dRhoI)
call mma_deallocate(dRhoA)

!***********************************************************************
! Active-Active part:                                                  *
!***********************************************************************
if (NumAsh /= 0) then

  call mma_allocate(dMOs,NASHT,mGrid,Label='dMOs')
  if (lft .and. lGGA) then
    call mma_allocate(dMOx,NASHT,mGrid,Label='dMOx')
    call mma_allocate(dMOy,NASHT,mGrid,Label='dMOy')
    call mma_allocate(dMOz,NASHT,mGrid,Label='dMOz')
  end if

  do g_eff=1,nGrad_eff
    do iGrid=1,mGrid
      do iIrrep=0,mIrrep-1
        IOff1 = IOff_Ash(iIrrep)
        IOff2 = IOff_BasAct(iIrrep)
        dMOs(IOff1+1:IOff1+nAsh(iIrrep),iGrid) = dTabMO(1,IOff2+1:IOff2+nAsh(iIrrep),g_eff,iGrid)
        if (lft .and. lGGA) then
          dMOx(IOff1+1:IOff1+nAsh(iIrrep),iGrid) = dTabMO(2,IOff2+1:IOff2+nAsh(iIrrep),g_eff,iGrid)
          dMOy(IOff1+1:IOff1+nAsh(iIrrep),iGrid) = dTabMO(3,IOff2+1:IOff2+nAsh(iIrrep),g_eff,iGrid)
          dMOz(IOff1+1:IOff1+nAsh(iIrrep),iGrid) = dTabMO(4,IOff2+1:IOff2+nAsh(iIrrep),g_eff,iGrid)
        end if
      end do
    end do

    do iGrid=1,mGrid
      do IIrrep=0,mIrrep-1
        IOff1 = iOff_Ash(IIrrep)+1
        P2_ontop_d(1,g_eff,iGrid) = P2_ontop_d(1,g_eff,iGrid)+Four*ddot_(nAsh(IIrrep),dMOs(IOff1:,iGrid),1,P2MOCube(IOff1:,iGrid),1)
        if (lft .and. lGGA) then
          P2_ontop_d(2,g_eff,iGrid) = P2_ontop_d(2,g_eff,iGrid)+ &
                                      Four*ddot_(nAsh(IIrrep),dMOx(IOff1:,iGrid),1,P2MOCube(IOff1:,iGrid),1)+ &
                                      Four*ddot_(nAsh(IIrrep),dMOs(IOff1:,iGrid),1,P2MOCubex(IOff1:,iGrid),1)
          P2_ontop_d(3,g_eff,iGrid) = P2_ontop_d(3,g_eff,iGrid)+ &
                                      Four*ddot_(nAsh(IIrrep),dMOy(IOff1:,iGrid),1,P2MOCube(IOff1:,iGrid),1)+ &
                                      Four*ddot_(nAsh(IIrrep),dMOs(IOff1:,iGrid),1,P2MOCubey(IOff1:,iGrid),1)
          P2_ontop_d(4,g_eff,iGrid) = P2_ontop_d(4,g_eff,iGrid)+ &
                                      Four*ddot_(nAsh(IIrrep),dMOz(IOff1:,iGrid),1,P2MOCube(IOff1:,iGrid),1)+ &
                                      Four*ddot_(nAsh(IIrrep),dMOs(IOff1:,iGrid),1,P2MOCubez(IOff1:,iGrid),1)
        end if
      end do
    end do
  end do

  do iGrid=1,mGrid
    do IIrrep=0,mIrrep-1
      IOff1 = iOff_Ash(IIrrep)+1
      P2_ontop(1,iGrid) = P2_ontop(1,iGrid)+ddot_(nAsh(IIrrep),MOs(IOff1:,iGrid),1,P2MOCube(IOff1:,iGrid),1)
    end do
  end do

  if (lGGA .and. lft) then
    do iGrid=1,mGrid
      do IIrrep=0,mIrrep-1
        IOff1 = iOff_Ash(IIrrep)+1
        P2_ontop(2,iGrid) = P2_ontop(2,iGrid)+Four*ddot_(nAsh(IIrrep),MOx(IOff1:,iGrid),1,P2MOCube(IOff1:,iGrid),1)
        P2_ontop(3,iGrid) = P2_ontop(3,iGrid)+Four*ddot_(nAsh(IIrrep),MOy(IOff1:,iGrid),1,P2MOCube(IOff1:,iGrid),1)
        P2_ontop(4,iGrid) = P2_ontop(4,iGrid)+Four*ddot_(nAsh(IIrrep),MOz(IOff1:,iGrid),1,P2MOCube(IOff1:,iGrid),1)
        !write(u6,*) 'MOz used for dPiz'
        !write(u6,*) iGrid,iOff1
        !call RecPrt(' ',' ',MOz(iOff1:,iGrid),1,nAsh(iIrrep))
      end do
    end do
  end if

  call mma_deallocate(dMOs)
  if (lft .and. lGGA) then
    call mma_deallocate(dMOx)
    call mma_deallocate(dMOy)
    call mma_deallocate(dMOz)
  end if

end if
call mma_deallocate(dTabMO)

return

end subroutine Do_Pi2Grad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine diag_master()
! To do in this subroutine:
!
! - Make sure all calling parameters are accounted for
! - Make sure mxntts is set in previous subroutine
! - Make sure nsmst is set in previous subroutine
!
! Set up the diagonal for the CI calculation

use lucia_data, only: INT1, INT1O
use CandS, only: ISSM

implicit none

INT1(:) = INT1O(:)
call GASCI(ISSM,1)

end subroutine diag_master

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
c  ************************************
c  ** Memory allocation and the like **
c  ************************************
      subroutine setidbl_cvb()
      implicit real*8(a-h,o-z)
#include "idbl_cvb.fh"
#include "SysDef.fh"

      idbl=RtoI
      return
      end
      integer function idbl_cvb(nreals)
      implicit real*8(a-h,o-z)
#include "idbl_cvb.fh"

      idbl_cvb=nreals*idbl
      return
      end
      integer function ihlf_cvb(nints)
      implicit real*8(a-h,o-z)
#include "idbl_cvb.fh"

      ihlf_cvb=(nints+idbl-1)/idbl
      return
      end
c
c  -- Initialization of casvb memory manager ---
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!               1995,1996, Pavel Neogrady                              *
!***********************************************************************

subroutine mod2(nsym,nish,nash,norb,fi,eps)
! this routine defines fi(p,q) = delta(p,q).eps(p)
! and redefines nish=nish+nash, nash=0
!
! this is suitable for closed shell case

use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nsym, norb(8)
integer(kind=iwp), intent(inout) :: nish(8)
integer(kind=iwp), intent(out) :: nash(8)
real(kind=wp), intent(_OUT_) :: fi(*)
real(kind=wp), intent(in) :: eps(*)
integer(kind=iwp) :: isym, p, padd, pq, q

!1 redefine foki

pq = 0
padd = 0
do isym=1,nsym

  do p=1,norb(isym)
    do q=1,p
      pq = pq+1
      if (p == q) then
        fi(pq) = eps(padd+p)
      else
        fi(pq) = Zero
      end if
    end do
  end do

  padd = padd+norb(isym)
end do

!2 redefine n's

nish(1:nsym) = nish(1:nsym)+nash(1:nsym)
nash(1:nsym) = 0

return

end subroutine mod2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
*               Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_CalcChoDiag
*
*> @brief
*>   Calculate integral diagonal from Cholesky vectors
*> @author Francesco Aquilante
*> @modified_by Thomas Bondo Pedersen
*>
*> @details
*> This routine calculates the integral diagonal from Cholesky
*> vectors,
*>
*> \f[ (ab|ab) = \sum_J L_{ab,J}^2 \quad (a,b: \text{AO-indices}) \f]
*>
*> The diagonal calculation is parallelized.
*> The diagonal is returned in first reduced set storage and must
*> be allocated before calling this routine.
*> Return code is ``0`` if successful execution.
*>
*> @param[out] rc   Return code
*> @param[out] Diag Array containing diagonal on exit
************************************************************************
      SUBROUTINE Cho_X_CalcChoDiag(rc,Diag)
      Implicit Real*8 (a-h,o-z)

      Integer   rc
      Real*8    Diag(*)
      Character*17 SECNAM
      Parameter (SECNAM = 'Cho_X_CalcChoDiag')

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )

************************************************************************
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
************************************************************************

      Call fZero(Diag,nnBstRT(1))


      IREDC= -1  ! unknwn reduced set

      iLoc = 3 ! use scratch location in reduced index arrays

C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
      DO jSym=1,nSym

         If (NumCho(jSym) .lt. 1) GOTO 1000

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec
         Do JRED=JRED1,JRED2

            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               rc = 77
               Return
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.',
     &                         '  rc= ',irc
              rc = irc
              Return
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec  = Min(LWORK/Max(nRS,1),nVrs)

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) ' LWORK= ',LWORK
               WRITE(6,*) ' jsym= ',jsym
               WRITE(6,*) ' min. mem. need for reading= ',nRS
               rc = 33
               Return
               nBatch = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)

C --- BATCH over the vectors ----------------------------

            nBatch = (nVrs-1)/nVec + 1

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM ) then
                  Call GetMem('rsL','Free','Real',ipLrs,LREAD)
                  rc=77
                  Return
               End If


C ---------------------------------------------------------------------
C --- Compute the diagonals :   D(ab) = D(ab) + sum_J (Lab,J)^2
C
C --- Stored in the 1st reduced set

               Do krs=1,nRS

                  mrs = iiBstR(JSYM,iLoc) + krs
                  jrs = IndRed(mrs,iLoc) ! address in 1st red set

                  Do jvc=1,JNUM

                     ipL = ipLrs + nRS*(jvc-1)
                     Diag(jrs) = Diag(jrs)
     &                         + Work(ipL+krs-1)**2
                  End Do

               End Do

C --------------------------------------------------------------------
C --------------------------------------------------------------------

            END DO  ! end batch loop

C --- free memory
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

999         Continue


         END DO   ! loop over red sets

1000     CONTINUE

      END DO   !loop over JSYM


      Call Cho_GAdGOp(Diag(1),NNBSTRT(1),'+')

      rc  = 0

      END

**************************************************************
**************************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_CNVTIM(TIM,IHR,IMN,SEC)
C
C     Purpose: convert TIM to hours/minutes/seconds
C
      IMPLICIT NONE
      REAL*8  TIM
      INTEGER IHR, IMN
      REAL*8  XHR, XMN, SEC

      XHR = TIM/3.6D3
      IHR = INT(XHR)

      XMN = (TIM - 3.6D3*DBLE(IHR))/6.0D1
      IMN = INT(XMN)

      SEC = TIM - 3.6D3*DBLE(IHR) - 6.0D1*DBLE(IMN)

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
************************************************************************
      Subroutine LDKH(s,h,v,pvp,x,pxp,dkhorder,xorder,paramtype,
     &       dkhscfflg,N,isize,clight,vv,nn,dd,yy,ff,gg,xx,ii,jj,kk,mm,
     &       revt,eig,sinv,aa,rr,tt,pp,e,ew,snumber,tnumber,unumber,
     &       scrno1,scrno2,scr1,scr2,scr3,scr5,scr8,no_hamil,no_prop,
     &       nbasp,nbaso,indx2,Nsm,nblock,nAtom,scrsq,scrt,ssm,hsm,
     &       ewsm,eigsm)
************************************************************************
*                                                                      *
*     The local DKH procedure                                          *
*                                                                      *
*                                                                      *
*     Called from: dkh_driver                                          *
*                                                                      *
*     Calling    : sog                                                 *
*                  diag_dkh                                            *
*                                                                      *
*                                                                      *
*     Input      : h,s,v,pvp                                           *
*                                                                      *
*     Output     : h,x,pxp                                             *
*                                                                      *
************************************************************************
*      Implicit None
#include "dkhparameters.fh"
*
      Logical dkhscfflg,no_hamil,no_prop
      Integer  dkhorder,xorder,isize,snumber,tnumber,nbasp,nbaso,
     *        unumber,scrno1,scrno2,indx2(nAtom,4),Nsm,nblock,
     *        nAtom,N
      Real*8 clight,s(isize),h(isize),v(isize),pvp(isize),
     *                 x(isize),pxp(isize),ssm(Nsm,Nsm),
     *                 hsm(Nsm*(Nsm+1)/2)
      Real*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp)
      Real*8 revt(Nsm,Nsm),eig(Nsm,N),sinv(Nsm,Nsm),
     *                 aa(Nsm),rr(Nsm),tt(Nsm),pp(N),e(Nsm),
     *                 ew(N),ewsm(Nsm),eigsm(Nsm,Nsm)
      Real*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),
     *                 scr5(Nsm,N,2),scr8(isize,3),
     *                 scrsq(Nsm,Nsm,scrno1),
     *                 scrt(Nsm*(Nsm+1)/2,scrno2)
*
      Character*(3) paramtype
*
      Integer poss(maxsnumber),post(maxsnumber),posu(maxunumber)
*
      Integer i,j,k,l,m,counter,firstc,lastc,icen,jcen,itrian
*
      Real*8 det
      Integer adrmem,isfreeunit,dkh_48,adrnext
      Parameter (adrmem=4000)
      Integer dkhadr(adrmem)
#ifdef MOLPRO
      Character*32 filnam
#endif
      dkh_48=0

************************************************************************
*
      If (Out_Of_Core) then
        dkh_48=48
#ifdef _MOLCAS_
        dkh_48=isfreeunit(dkh_48)
        call daname_mf(dkh_48,'DKHMX')
#else
        filnam='DKHMX'
        call tmp_filename(filnam)
        call daname_nolib(dkh_48,filnam)
#endif
      End If
*
      If (dkhorder.gt.maxorder) then
        write(stdout,1010) dkhorder,maxorder,maxorder
1010    format (/,'Warning: dkhorder = ',I2,', but maxorder = ',I2,'.',
     *          /'--> dkhorder will be reduced to maxorder = ',I2,'.'/)
        dkhorder=maxorder
      End If
*
CMR150107      call initialize2 (N,isize,vv,nn,dd,yy,ff,gg,xx,ii,jj,kk,
CMR150107     *                  ll,mm,revt,tran,sinv,aa,rr,tt,pp,e,ew,snumber,
CMR150107     *                  tnumber,unumber,scrno1,scrno2,nbasp,
CMR150107     *                  scr1,scr2,scr3,scr5,scr8,dkhorder,xorder)
CMR260207 "nbaso" has not yet been included in initialize2
      Do i=1,maxsnumber
        poss(i)=0
        post(i)=0
      End Do
      Do i=1,maxunumber
        posu(i)=0
      End Do
*
************************************************************************
*
      Do i=1,isize
         scr8(i,1)=s(i)
      End Do
      Do i=1,isize
         s(i)=0.0d0
      End Do
      Do i=1,N
        Do j=1,N
          eig(i,j)=0.0d0
        End Do
      End Do
      icen=0
*                                                                      *
************************************************************************
*                 Create the small variable                            *
*                                                                      *
      Do i=1,nblock
        firstc=indx2(i,4)
        if (i.ne.nblock) Then
           lastc=indx2(i+1,4)-1
        Else
           lastc=nAtom
        End If
        counter=0
        itrian=1
        Do jcen=firstc,lastc
          counter=counter+indx2(jcen,2)-indx2(jcen,1)+1
          Do k=indx2(jcen,1),indx2(jcen,2)
             Do icen=firstc,jcen-1
                Do j=indx2(icen,1),indx2(icen,2)
                  ssm(itrian,1)=scr8(k*(k-1)/2+j,1)
                  hsm(itrian)=h(k*(k-1)/2+j)
                  itrian=itrian+1
                End Do
             End Do
             Do j=indx2(jcen,1),k
               ssm(itrian,1)=scr8(k*(k-1)/2+j,1)
               hsm(itrian)=h(k*(k-1)/2+j)
               itrian=itrian+1
             End Do
          End Do
        End Do
*
**    Verify that the overlap matrix is not singular
*
        call mat_sq_from_t (scrsq(1,1,1),counter,ssm)
        j=-1
        call mat_copy (scrsq(1,1,2),counter,counter,scrsq(1,1,1))
        call dcopiv (scrsq(1,1,2),scrsq(1,1,2),counter,1,counter,
     &               dkhzero,det,k,j,scrt(1,3))
        if (j.ne.0) then
          write (stdout,1020) dkhzero
1020      format('  D K H |****** '/,
     &  '        |****** WARNING - OVERLAP MATRIX SINGULAR '/,
     &  '        |****** PIVOTAL ELEMENT LESS THAN ',D20.4,' FOUND'/,
     &  '        |******'//)
          call errex_rel(' D K H | singular overlap matrix')
        endif
*
**      Run the calculation with the small variables
*
        Call sog(counter,ssm,sinv,scrt(1,1),scrt(1,2),ewsm)
        Call diag_dkh(hsm,counter,eigsm,ewsm,sinv,scrsq(1,1,2),1)
*
*      Reconstruct EIG and EW for the perturbation
*
        l=0
        Do icen=firstc,lastc
           Do k=indx2(icen,1),indx2(icen,2)
              ew(k)=ewsm(l+1)
              Do j=1,counter
                eig(j,k)=eigsm(l*counter+j,1)
                scr5(j,k,1)=sinv(l*counter+j,1)
                scr5(j,k,2)=scrsq(l*counter+j,1,1)
              End Do
              l=l+1
           End Do
        End Do
      End Do
*                                                                      *
************************************************************************
*                   Evaluation of the hamiltonian                      *
*
**      Reconstruct the small variables
*
      Do i=1,isize
         scr8(i,2)=v(i)
         scr8(i,3)=pvp(i)
         scr8(i,1)=x(i)
         s(i)=pxp(i)
         h(i)=h(i)+v(i)
      End Do
*
      Do i=1,nblock
        firstc=indx2(i,4)
        if (i.ne.nblock) Then
           lastc=indx2(i+1,4)-1
        Else
           lastc=nAtom
        End If
        counter=0
        l=0
        itrian=1
        Do icen=firstc,lastc
          counter=counter+indx2(icen,2)-indx2(icen,1)+1
        End Do
        Do icen=firstc,lastc
           Do k=indx2(icen,1),indx2(icen,2)
*
*             Faute ici aussi
*
              Do jcen=firstc,icen-1
                 Do j=indx2(jcen,1),indx2(jcen,2)
                   v(itrian)=scr8(k*(k-1)/2+j,2)
                   pvp(itrian)=scr8(k*(k-1)/2+j,3)
                   x(itrian)=scr8(k*(k-1)/2+j,1)
                   pxp(itrian)=s(k*(k-1)/2+j)
                   itrian=itrian+1
                 End Do
              End Do
              Do j=indx2(icen,1),k
                v(itrian)=scr8(k*(k-1)/2+j,2)
                pvp(itrian)=scr8(k*(k-1)/2+j,3)
                x(itrian)=scr8(k*(k-1)/2+j,1)
                pxp(itrian)=s(k*(k-1)/2+j)
                itrian=itrian+1
              End Do
              ewsm(l+1)=ew(k)
              Do j=1,counter
                eigsm(l*counter+j,1)=eig(j,k)
                sinv(l*counter+j,1)=scr5(j,k,1)
                ssm(l*counter+j,1)=scr5(j,k,2)
              End Do
              l=l+1
           End Do
        End Do
        isize=counter*(counter+1)/2
        if (.not.Out_Of_Core) nbaso=counter
*
**    Evaluation of the hamiltonian
*
        Call calc_prefactors (counter,isize,clight,aa,rr,tt,pp,e,ewsm)
        Call calc_revt (counter,revt,eigsm,sinv,ssm,scrsq(1,1,2))
        Call calc_E0 (counter,isize,hsm,revt,ewsm)
        Call calc_E1 (counter,isize,xorder,dkhscfflg,hsm,v,pvp,x,pxp,
     &                vv,dd,xx,jj,revt,eigsm,sinv,aa,rr,tt,scrno1,
     &                scrno2,scrsq,scrt,no_prop,nbasp,nbaso,dkhadr,
     &                adrmem,dkh_48,adrnext)
*       nn,yy,ii and kk are respectively vv,dd,xx and jj
       Call setup_matrices (counter,isize,vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,
     &                     kk,ll,mm,aa,rr,e,scrno2,scrt,no_prop,
     &                     nbasp,nbaso,dkhadr,adrmem,dkh_48,adrnext)
       Call calc_Uxxx (counter,dkhorder,xorder,dkhscfflg,posu,post,poss,
     &                vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,snumber,
     &                tnumber,unumber,scrno1,scr1,scr2,scr3,scrsq,nbasp,
     &                nbaso,dkhadr,adrmem,dkh_48,adrnext)
c
       Call calc_Txxx (counter,dkhorder,xorder,dkhscfflg,posu,post,poss,
     &                vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,snumber,
     &                tnumber,unumber,scrno1,scr1,scr2,scr3,scrsq,nbasp,
     &                nbaso,dkhadr,adrmem,dkh_48,adrnext)
c
       Call calc_Sxxx (counter,dkhorder,xorder,dkhscfflg,posu,post,poss,
     &                vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,snumber,
     &                tnumber,unumber,scrno1,scr1,scr2,scr3,scrsq,nbasp,
     &                nbaso,dkhadr,adrmem,dkh_48,adrnext)

        If (.not.no_hamil)
     & Call calc_operators(counter,isize,dkhorder,xorder,dkhscfflg,posu,
     &                      post,poss,vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,
     &                      kk,ll,mm,e,snumber,tnumber,unumber,
     &                      scrno1,scrno2,scr1,scr2,scr3,scrsq,scrt,
     &                      revt,hsm,nbasp,nbaso,dkhadr,adrmem,dkh_48,
     &                      adrnext)
        If (.not.dkhscfflg.and..not.no_prop)
     &  Call calc_xoperators(counter,isize,dkhorder,xorder,
     &                       dkhscfflg,posu,post,poss,vv,nn,dd,yy,
     &                       ff,gg,pp,xx,ii,jj,kk,ll,mm,e,snumber,
     &                       tnumber,unumber,scrno1,scrno2,scr1,
     &                       scr2,scr3,scrsq,scrt,revt,x,nbasp,nbaso,
     &                       dkhadr,adrmem,dkh_48,adrnext)
*
**     Reconstruct the full variables
*
        itrian=1
        m=1
        l=1
        Do icen=firstc,lastc
           Do k=indx2(icen,1),indx2(icen,2)
              Do jcen=firstc,icen-1
                Do j=indx2(jcen,1),indx2(jcen,2)
                  h(k*(k-1)/2+j)=hsm(itrian)
                  itrian=itrian+1
                End Do
              End Do
              Do j=indx2(icen,1),k
                h(k*(k-1)/2+j)=hsm(itrian)
                itrian=itrian+1
              End Do
           End Do
        End Do
      End Do
*
      isize=N*(N+1)/2
      if (Out_Of_Core) then
#ifdef _MOLCAS_
        call DaEras(dkh_48)
#else
        call daclos(dkh_48)
#endif
      endif
*
c Avoid unused argument warnings
      If (.False.) Call Unused_character(paramtype)
      End
************************************************************************
************************************************************************
************************************************************************
      subroutine calc_indx(indx2,indx,Coord,N,nAtom,Nsm,nblock)
************************************************************************
*                                                                      *
*     Create the auxiliary index                                       *
*                                                                      *
*     Called from : dkrelint                                           *
*                                                                      *
*     Calling     : none                                               *
*                                                                      *
*                                                                      *
*     indx2( ,3) is the number of the block. It is equal to the number *
*     of the atom, or to the number of the center define by the user   *
*     when the atom is inside the radius                               *
*     indx2( ,1) and indx2( ,2) are respectively the number of the     *
*     first and the last primitive basis                               *
*     indx( ,4) is a kind of new array of the size nblock, which       *
*     contains the number of atoms in each block                       *
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
      use DKH_Info
      Integer indx2(nAtom,4),indx(N),N,Nsm,nblock,itmp1,itmp2
      Real*8 Coord(3*nAtom),distce
*
      call get_iarray('Ctr Index Prim',indx,N)
      indx2(1,1)=1
      indx2(1,3)=1
      Do j=1,N
         indx2(indx(j),2)=j
      End Do
      Do j=2,nAtom
         indx2(j,3)=j
         indx2(j,1)=indx2(j-1,2)+1
      End Do
*
**    Make one block with all atoms within the radius
*
      If ((radiLD.gt.0.0d0).and.(nCtrLD.gt.0))  Then
#ifdef _MOLCAS_
         Call get_coord_all(Coord,nAtom)
#else
         call abend
#endif
         Do i=1,nCtrLD
           icen=iCtrLD(i)
           itmp1=3*icen-2
           Do j=1,nAtom
              If (j.ne.icen) Then
                 itmp2=3*j-2
                 distce=sqrt((Coord(itmp1)-Coord(itmp2))**2
     & +(Coord(itmp1+1)-Coord(itmp2+1))**2+(Coord(itmp1+2)-
     & Coord(itmp2+2))**2)
                 If (distce.le.radiLD) Then
                    indx2(j,3)=indx2(icen,3)
                 End If
              End If
           End Do
         End Do
*
**     Reorganize indx2
*
         Do i=1,nAtom-1
            Do j=i,nAtom
              If (indx2(i,3).gt.indx2(j,3)) Then
                Do k=1,3
                  itmp1=indx2(i,k)
                  indx2(i,k)=indx2(j,k)
                  indx2(j,k)=itmp1
                End Do
              End If
           End Do
         End Do
      End If
*
**    Compute the number of blocks and the maximum size
*
      Nsm=indx2(1,2)-indx2(1,1)+1
      nblock=1
      itmp1=Nsm
      indx2(1,4)=1
      Do j=2,nAtom
        If (indx2(j,3).ne.indx2(j-1,3)) Then
           nblock=nblock+1
           indx2(nblock,4)=j
           If (itmp1.gt.Nsm) Nsm=itmp1
           itmp1=0
        End If
        itmp1=itmp1+indx2(j,2)-indx2(j,1)+1
      End Do
      If (itmp1.gt.Nsm) Nsm=itmp1
      End
************************************************************************
************************************************************************
************************************************************************
      subroutine diag_ldkh(nAtom,nblock,N,isize,Nsm,indx2,ssm,hsm,s,h,
     *                     sinv,ewsm,eigsm,ew,eig,v,scr8,scrsq,scrt)
************************************************************************
*                                                                      *
*      Block-diagonalize the hamiltonian                               *
*                                                                      *
*                                                                      *
************************************************************************
      Implicit none
      Integer i,j,k,l,nblock,firstc,lastc,nAtom,indx2(nAtom,4),counter,
     *        jcen,icen,N,isize,Nsm,itrian
      Real*8 h(isize),s(isize),v(isize),ew(N),eig(N,N),
     *                 scr8(isize)
      Real*8 ssm(Nsm,Nsm),hsm(Nsm*(Nsm+1)/2),sinv(Nsm,Nsm),
     *                 scrt(Nsm*(Nsm+1)/2),ewsm(Nsm),eigsm(Nsm,Nsm),
     *                 scrsq(Nsm,Nsm)
*                                                                      *
************************************************************************
*                                                                      *
      Do i=1,isize
         scr8(i)=s(i)
      End Do
      Do i=1,N
        Do j=1,N
          eig(i,j)=0.0d0
        End Do
      End Do
*
      Do i=1,nblock
        firstc=indx2(i,4)
        if (i.ne.nblock) Then
           lastc=indx2(i+1,4)-1
        Else
           lastc=nAtom
        End If
        counter=0
        itrian=1
        Do jcen=firstc,lastc
          counter=counter+indx2(jcen,2)-indx2(jcen,1)+1
          Do k=indx2(jcen,1),indx2(jcen,2)
             Do icen=firstc,jcen-1
                Do j=indx2(icen,1),indx2(icen,2)
                  ssm(itrian,1)=scr8(k*(k-1)/2+j)
                  hsm(itrian)=h(k*(k-1)/2+j)
                  itrian=itrian+1
                End Do
             End Do
             Do j=indx2(jcen,1),k
               ssm(itrian,1)=scr8(k*(k-1)/2+j)
               hsm(itrian)=h(k*(k-1)/2+j)
               itrian=itrian+1
             End Do
          End Do
        End Do
*
**      Run the calculation with the small variables
*
        Call sog(counter,ssm,sinv,scrt,scrsq,ewsm)
        Call diag_dkh(hsm,counter,eigsm,ewsm,sinv,scrsq,1)
*
*      Reconstruct EIG and EW for the perturbation
*
        l=0
        itrian=1
        Do icen=firstc,lastc
           Do k=indx2(icen,1),indx2(icen,2)
              ew(k)=ewsm(l+1)
              Do j=indx2(icen,1),indx2(icen,2)
                eig(j,k)=eigsm(itrian,1)
                itrian=itrian+1
              End Do
              l=l+1
           End Do
        End Do
      End Do
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(v)
      End
************************************************************************
************************************************************************
************************************************************************
      subroutine ldkhpert(N,isize,h,s,sinv,scrsq,scrt,nblock,indx2,eig,
     *                    ew,nAtom,sprov)
************************************************************************
*                                                                      *
*     Compute the 2nd order perturbation for the Local DKH procedure   *
*     for eigenvectors and eigenvalues                                 *
*                                                                      *
*                                                                      *
************************************************************************
      use DKH_Info
      Implicit real*8(a-h,o-z)
      Integer N,isize,i,j,k,l,m,icen,nAtom,
     *        nblock,indx2(nAtom,4)
      Real*8 h(isize),s(isize),sinv(N,N),eig(N,N),ew(N)
      Real*8 scrsq(N,N,3),scrt(isize,2),norm
      Real*8 sprov(N,N)
*                                                                      *
************************************************************************
*                                                                      *
      Call mat_sq_from_t (scrsq(1,1,2),N,h)
      Call sog(N,s,sinv,scrt(1,1),scrt(1,2),scrsq(1,1,1))
      Call Mat_sq_from_t (sprov,N,s)
*
      Do i=1,N
         Do j=1,N
            scrsq(i,j,1)=0.0d0
            scrsq(i,j,3)=0.0d0
         End Do
         scrt(i,1)=ew(i)
      End Do
*
*          H*C
*
      Do i=1,nCtrLD
         icen=iCtrLD(i)
         Do j=1,nblock
         If (icen.ne.j) Then
            Do k=indx2(j,1),indx2(j,2)
               Do l=indx2(icen,1),indx2(icen,2)
                  scrsq(k,l,3)=0.0d0
                  scrsq(k,l,1)=0.0d0
                  Do m=indx2(icen,1),indx2(icen,2)
                     scrsq(k,l,3)=scrsq(k,l,3)+scrsq(k,m,2)*eig(m,l)
                     scrsq(k,l,1)=scrsq(k,l,1)+sprov(k,m)  *eig(m,l)
                  End Do
               End Do
            End Do
         End If
         End Do
      End Do
*
*          C*H
*
      Do i=1,nCtrLD
         icen=iCtrLD(i)
         Do j=1,nblock
         If (icen.ne.j) Then
            Do k=indx2(j,1),indx2(j,2)
               Do l=indx2(icen,1),indx2(icen,2)
                  scrsq(k,l,2)=0.0d0
                  sprov(k,l)  =0.0d0
                  Do m=indx2(j,1),indx2(j,2)
                     scrsq(k,l,2)=scrsq(k,l,2)+eig(m,k)*scrsq(m,l,3)
                     sprov(k,l)  =sprov(k,l)  +eig(m,k)*scrsq(m,l,1)
                  End Do
               End Do
            End Do
         End If
         End Do
      End Do
*
**    Perturbation
*
      Do i=1,nCtrLD
         icen=iCtrLD(i)
         Do j=1,nblock
         If (icen.ne.j) Then
            Do k=indx2(j,1),indx2(j,2)
               Do l=indx2(icen,1),indx2(icen,2)
                 denom=1d0/(ew(l)-ew(k))
                 norm=scrsq(k,l,2)-ew(l)*sprov(k,l)
                 scrt(l,1)=scrt(l,1)+(norm**2)*denom
                 eig(k,l)=norm*denom
               End Do
            End Do
         End If
         End Do
      End Do
*
**   Orthonormalization
*
      Do i=1,N
         ew(i)=scrt(i,1)
         Do j=i,N
            norm=0.0d0
            Do k=1,N
               norm=norm+eig(k,i)*eig(k,j)
            End Do
            if (i.eq.j) Then
              Do k=1,N
                 eig(k,i)=eig(k,i)/Sqrt(norm)
              End Do
            Else
              Do k=1,N
                 eig(k,j)=eig(k,j)-norm*eig(k,i)
              End Do
            End If
         End Do
      End Do
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_add22 (a,b,q,dimp,dimq,fact)
c
c     this routine do:
c     B(p,q) <-- fact * A(p) for given q
c
       integer dimp,dimq,q
       real*8 fact
       real*8 b(1:dimp,1:dimq)
       real*8 a(1:dimp)
c
c     help variable
c
       integer p
c
       do 100 p=1,dimp
       b(p,q)=b(p,q)+fact*a(p)
 100    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
* WRAPPERS FOR PARALLEL S AND B MATRIX ROUTINES
*
      SUBROUTINE PSBMAT_GETMEM(cNAME,lg_M,nSize)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      use fake_ga, only: GA_arrays, Allocate_GA_Array
      IMPLICIT None
CSVC2010: create square global array S/B for symmetry iSYM
C with integer handle lg_M or if replicate or serial, create
C tridiagonal local array at Work(lg_M)
      Integer lg_M, nSize
      CHARACTER(len=*) cNAME

      Integer nTri

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        CALL GA_CREATE_STRIPED ('H',nSize,nSize,cNAME,LG_M)
        CALL GA_ZERO (LG_M)
      ELSE
#endif
        nTri=(nSize*(nSize+1))/2
        lg_M=Allocate_GA_Array(nTri,cName)
        GA_Arrays(lg_M)%A(:)=0.0D0
#ifdef _MOLCAS_MPP_
      END IF
#endif

      END SUBROUTINE PSBMAT_GETMEM

      SUBROUTINE PSBMAT_FREEMEM(lg_M)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      use fake_ga, only: Deallocate_GA_Array
      IMPLICIT NONE
CSVC2010: destroy square global array S/B for symmetry iSYM
C with integer handle lg_M or if replicate or serial, free the
C tridiagonal local array at Work(lg_M)
      Integer lg_M

#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
      LOGICAL bStat
#endif


#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        bStat = GA_Destroy(lg_M)
      ELSE
#endif
        Call Deallocate_GA_Array(lg_M)
#ifdef _MOLCAS_MPP_
      END IF
#endif
      END SUBROUTINE PSBMAT_FREEMEM

      SUBROUTINE PSBMAT_WRITE(cNAME,iCase,iSym,lg_M,nSize)
CSVC20100902: write the global array lg_M to disk using DRA interface,
C or if replicate or serial, write WORK(lg_M) to LUSBT
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
      use caspt2_global, only: LUH0T
#endif
      use caspt2_global, only: LUSBT
      use EQSOLV, only: IDSMAT, IDBMAT, IDTMAT, IDSTMAT
      use fake_ga, only: GA_arrays
      implicit none
      Integer iCase, iSym, lg_M, nSize
      CHARACTER(LEN=*) cNAME


#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
      Integer LU, myRank, ISTA,IEND,JSTA,JEND, mpt_M, LDM
#endif
      Integer IDISK, nBlock


      IF (CNAME.EQ.'S') THEN
#ifdef _MOLCAS_MPP_
        LU=LUH0T(1)
#endif
        IDISK=IDSMAT(iSym,iCase)
        nBlock=(nSize*(nSize+1))/2
      ELSE IF (CNAME.EQ.'B') THEN
#ifdef _MOLCAS_MPP_
        LU=LUH0T(2)
#endif
        IDISK=IDBMAT(iSym,iCase)
        nBlock=(nSize*(nSize+1))/2
      ELSE IF (CNAME.EQ.'T') THEN
#ifdef _MOLCAS_MPP_
        LU=LUH0T(3)
#endif
        IDISK=IDTMAT(iSym,iCase)
        nBlock=nSize
      ELSE IF (CNAME.EQ.'M') THEN
#ifdef _MOLCAS_MPP_
        LU=LUH0T(4)
#endif
        IDISK=IDSTMAT(iSym,iCase)
        nBlock=nSize
      END IF

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        CALL GA_Sync()
        myRank = GA_NodeID()
        CALL GA_Distribution (lg_M,myRank,ISTA,IEND,JSTA,JEND)
        IF (ISTA.GT.0 .AND. JSTA.GT.0) THEN
          CALL GA_Access (lg_M,ISTA,IEND,JSTA,JEND,mpt_M,LDM)
          NBLOCK=LDM*(JEND-JSTA+1)
          CALL DDAFILE(LU,1,DBL_MB(mpt_M),NBLOCK,IDISK)
          CALL GA_Release (lg_M,ISTA,IEND,JSTA,JEND)
        END IF
        CALL GA_Sync()
      ELSE
#endif
        CALL DDAFILE(LUSBT,1,GA_Arrays(lg_M)%A(:),nBlock,IDISK)
#ifdef _MOLCAS_MPP_
      END IF
#endif

      END SUBROUTINE PSBMAT_WRITE

      SUBROUTINE PSBMAT_READ(cNAME,iCase,iSym,lg_M,nSize)
CSVC20100902: read the disk array stored as cName+iSym using DRA
C interface into global array lg_M, or if replicate or serial, read from
C LUSBT into WORK(lg_M)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
      use caspt2_global, only: LUH0T
#endif
      use caspt2_global, only: LUSBT
      use EQSOLV, only: IDSMAT, IDBMAT, IDTMAT, IDSTMAT
      use fake_ga, only: GA_arrays
      IMPLICIT None
      INTEGER iCASE,iSym,lg_M,nSize
      CHARACTER(LEN=*) cNAME

#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
      INTEGER LU, myRank, iSTA, IEND, JSTA, JEND, mpt_M, LDM
#endif
      INTEGER IDISK, nBlock


      IF (CNAME.EQ.'S') THEN
#ifdef _MOLCAS_MPP_
        LU=LUH0T(1)
#endif
        IDISK=IDSMAT(iSym,iCase)
        nBlock=(nSize*(nSize+1))/2
      ELSE IF (CNAME.EQ.'B') THEN
#ifdef _MOLCAS_MPP_
        LU=LUH0T(2)
#endif
        IDISK=IDBMAT(iSym,iCase)
        nBlock=(nSize*(nSize+1))/2
      ELSE IF (CNAME.EQ.'T') THEN
#ifdef _MOLCAS_MPP_
        LU=LUH0T(3)
#endif
        IDISK=IDTMAT(iSym,iCase)
        nBlock=nSize
      ELSE IF (CNAME.EQ.'M') THEN
#ifdef _MOLCAS_MPP_
        LU=LUH0T(4)
#endif
        IDISK=IDSTMAT(iSym,iCase)
        nBlock=nSize
      END IF

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        CALL GA_Sync()
        myRank = GA_NodeID()
        CALL GA_Distribution (lg_M,myRank,ISTA,IEND,JSTA,JEND)
        IF (ISTA.GT.0 .AND. JSTA.GT.0) THEN
          CALL GA_Access (lg_M,ISTA,IEND,JSTA,JEND,mpt_M,LDM)
          NBLOCK=LDM*(JEND-JSTA+1)
          CALL DDAFILE(LU,2,DBL_MB(mpt_M),NBLOCK,IDISK)
          CALL GA_Release_Update (lg_M,ISTA,IEND,JSTA,JEND)
        END IF
        CALL GA_Sync()
      ELSE
#endif
        CALL DDAFILE(LUSBT,2,GA_Arrays(lg_M)%A(:),nBlock,IDISK)
#ifdef _MOLCAS_MPP_
      END IF
#endif

      END SUBROUTINE PSBMAT_READ

      REAL*8 FUNCTION PSBMAT_FPRINT(lg_M,NM)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      use fake_ga, only: GA_arrays
      IMPLICIT NONE
      INTEGER lg_M, NM

      INTEGER nTri
      REAL*8, External::DNRM2_
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        PSBMAT_FPRINT=SQRT(GA_DDOT(lg_M,lg_M))
      ELSE
#endif
        nTri=(NM*(NM+1))/2
        PSBMAT_FPRINT=DNRM2_(nTri,GA_Arrays(lg_M)%A(:),1)
#ifdef _MOLCAS_MPP_
      END IF
#endif
      END FUNCTION PSBMAT_FPRINT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine simplify2 (i,uniorder,dkhorder,ordercounter,opcounter,
     *               operleng,oporder,evenodd,doperators,operators,
     *               wordercounter,wopsleng,woporder,eowops,dwops,wops,
     *               oddcounter,oddleng,oddorder,eoodd,dodd,odd)
c
c***************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 30.06.2005
c
c   first version: 23.05.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer i,uniorder,dkhorder,ordercounter(0:maxorder),opcounter,
     *        operleng(maxoperators),oporder(maxoperators,3),
     *        evenodd(maxoperators),
     *        wordercounter(maxorder),wopsleng(maxuops),
     *        woporder(maxuops,3),eowops(maxuops),oddcounter,
     *        oddleng(maxuops),oddorder(maxuops,3),eoodd(maxuops)
      REAL*8 doperators(maxoperators),dwops(maxuops),
     *                 dodd(maxuops)
      character*(maxlength) wops(maxuops),odd(maxuops)
#if defined(_MOLCAS_) || defined(MOLPRO)
      character*(maxlength) opstring
      character operators(*)
#else
      character*(maxlength) operators(maxoperators)
#endif
c
      integer scrleng1,scrleng2,reslengl1,reslengr1,reslengl2,reslengr2
      character*(maxlength) scrchar1,scrchar2,rescharl1,rescharr1,
     *                      rescharl2,rescharr2
c
      integer j,k,l,ilow,hit1,hit2
      character*(3) scrchar0, dkh_int2char
      logical match,equalstring
c
      if(i.ge.1.and.i.le.99) then
          scrchar0=dkh_int2char(i)
          scrchar0(1:1)='W'
      endif
cvv      do 10 k=1,99
cvv        if (i.eq.k) then
cvv          scrchar0=dkh_int2char(k)
cvv          scrchar0(1:1)='W'
cvv        endif
cvv 10   continue
      if (uniorder.gt.99) then
        write (stdout,1002)
1002    format (/2X,'Note: So far only 99 unitary transformations U_i',
     *          ' are possible in SR "simplify2."')
        Call Abend
      endif
      do 15 k=1,maxlength
        scrchar1(k:k)=' '
        scrchar2(k:k)=' '
  15  continue
      scrleng1=6
      scrleng2=6
      scrchar1(1:scrleng1)=scrchar0(1:3)//'E00'
      scrchar2(1:scrleng2)='E00'//scrchar0(1:3)
 412  continue
      match=.false.
      ilow=1
      do 100 j=0,dkhorder
        do 200 k=ilow,ilow+ordercounter(j)-1
#if defined(_MOLCAS_) || defined(MOLPRO)
          call get_dkoperators(k,opstring,operators)
          hit1=index(opstring(1:operleng(k)),scrchar1(1:6))
#else
          hit1=index(operators(k)(1:operleng(k)),scrchar1(1:6))
#endif
          if (hit1.ne.0) then
#if defined(_MOLCAS_) || defined(MOLPRO)
            call store_reschar (operleng(k),opstring,hit1,scrleng1,
     *                          reslengl1,reslengr1,rescharl1,rescharr1)
#else
            call store_reschar (operleng(k),operators(k),hit1,scrleng1,
     *                          reslengl1,reslengr1,rescharl1,rescharr1)
#endif
            do 300 l=ilow,ilow+ordercounter(j)-1
#if defined(_MOLCAS_) || defined(MOLPRO)
              call get_dkoperators(l,opstring,operators)
              hit2=index(opstring(1:operleng(l)),scrchar2(1:6))
#else
              hit2=index(operators(l)(1:operleng(l)),scrchar2(1:6))
#endif
              if (hit2.ne.0) then
#if defined(_MOLCAS_) || defined(MOLPRO)
                call store_reschar (operleng(l),opstring,hit2,
     *                              scrleng2,reslengl2,
     *                              reslengr2,rescharl2,rescharr2)
#else
                call store_reschar (operleng(l),operators(l),hit2,
     *                              scrleng2,reslengl2,
     *                              reslengr2,rescharl2,rescharr2)
#endif
                match=equalstring(reslengl1,reslengr1,rescharl1,
     *                            rescharr1,reslengl2,reslengr2,
     *                            rescharl2,rescharr2)
              endif
              if (match) then
                call replace1 (i,j,k,l,ordercounter,opcounter,operleng,
     *                         oporder,evenodd,doperators,operators,
     *                         reslengl1,reslengr1,rescharl1,rescharr1,
     *                         oddcounter,oddleng,oddorder,eoodd,dodd,
     *                         odd)
                goto 412
              endif
 300        continue
            do 400 l=opcounter,ilow+ordercounter(j),-1
              operleng(l+2)=operleng(l)
              oporder(l+2,1)=oporder(l,1)
              oporder(l+2,2)=oporder(l,2)
              oporder(l+2,3)=oporder(l,3)
              evenodd(l+2)=evenodd(l)
              doperators(l+2)=doperators(l)
#if defined(_MOLCAS_) || defined(MOLPRO)
              call copy_dkoperators(l,operators,l+2,operators)
#else
              operators(l+2)=operators(l)
#endif
 400        continue
c                                              and ilow+ordercounter(j)+1
            operleng(ilow+ordercounter(j))=operleng(k)
            oporder(ilow+ordercounter(j),1)=oporder(k,1)
            oporder(ilow+ordercounter(j),2)=oporder(k,2)
            oporder(ilow+ordercounter(j),3)=oporder(k,3)
            evenodd(ilow+ordercounter(j))=evenodd(k)
            doperators(ilow+ordercounter(j))=-1.d0*doperators(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
            opstring=rescharl1(1:reslengl1)//
     *               scrchar2(1:scrleng2)//rescharr1(1:reslengr1)
            call put_dkoperators(ilow+ordercounter(j),opstring,
     *               operators)
#else
            operators(ilow+ordercounter(j))=rescharl1(1:reslengl1)//
     *                    scrchar2(1:scrleng2)//rescharr1(1:reslengr1)
#endif
c
            operleng(ilow+ordercounter(j)+1)=operleng(k)
            oporder(ilow+ordercounter(j)+1,1)=oporder(k,1)
            oporder(ilow+ordercounter(j)+1,2)=oporder(k,2)
            oporder(ilow+ordercounter(j)+1,3)=oporder(k,3)
            evenodd(ilow+ordercounter(j)+1)=evenodd(k)
            doperators(ilow+ordercounter(j)+1)=doperators(k)
#if defined(_MOLCAS_) || defined(MOLPRO)
            opstring=rescharl1(1:reslengl1)//
     *               scrchar2(1:scrleng2)//rescharr1(1:reslengr1)
            call put_dkoperators(ilow+ordercounter(j)+1,opstring,
     *               operators)
#else
            operators(ilow+ordercounter(j)+1)=rescharl1(1:reslengl1)//
     *                    scrchar2(1:scrleng2)//rescharr1(1:reslengr1)
#endif
            ordercounter(j)=ordercounter(j)+2
            opcounter=opcounter+2
            goto 412
          endif
 200    continue
        ilow=ilow+ordercounter(j)
 100  continue
c
      if (dbgflg.ge.1 .and. i.le.9) write (dbgunit,4026) i,i
4026  format (/2X,'Commutator symmetry [W',I1,',E0] = -O',I1,' has ',
     *        'been exploited for operators.  (SR "simplify2")')
      if (dbgflg.ge.1 .and. i.ge.10) write (dbgunit,4027) i,i
4027  format (/2X,'Commutator symmetry [W',I2,',E0] = -O',I2,' has ',
     *        'been exploited for operators.  (SR "simplify2")')
      if (dbgflg.ge.3) then
        write (dbgunit,1026) i+1,i,i
1026    format (/2X,'Terms of Hamiltonian H',I1,' = [U',I1,' * ',
     *            '(operators) * U',I1,'^t]:',/2X,52('-'))
        call output3 (dbgunit,opcounter,operleng,oporder,evenodd,
     *                doperators,operators)
      endif
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer_array(wordercounter)
        call Unused_integer_array(wopsleng)
        call Unused_integer_array(woporder)
        call Unused_integer_array(eowops)
        call Unused_real_array(dwops)
        call Unused_character(wops)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module nq_Info

use Definitions, only: wp, iwp

implicit none
private

!     R_Max : Maximum radius associated with the i'th center for the
!             radial loop.
! Integer
!
!     L_Quad  : Value of the angular momentum for which the grid is
!               generated unless the quadrature is pruned.
!     nR      : Initial number of radial points for which the grid is
!               generated.
!     nAtoms  : Number of atoms in the system.
!     nTotGP  : Total number of grid points generated during the program.

integer(kind=iwp), parameter :: LMax_NQ = 62, &
                                Other_Type = 0, LDA_Type = 1, GGA_Type = 2, meta_GGA_Type1 = 3, meta_GGA_Type2 = 4, &
                                Fixed_Grid = 0, Moving_Grid = 1, &
                                On = 1, Off = 0
integer(kind=iwp) :: Angular_Pruning, Functional_Type, Grid_Type, IOff_Ash(0:7), IOff_Bas(0:7), IOff_BasAct(0:7), iOpt_Angular, &
                     L_Quad, L_Quad_save, mBas(0:7), mIrrep, mOrb(0:7), mRad, nAngularGrids, nAsh(0:7), NASHT, nAtoms, ndc, &
                     nFro(0:7), nISh(0:7), nOrbt, nPot1, nPot2, NQ_Direct, nR, nR_Save, nTotGP, number_of_subblocks, &
                     nUVX(0:7,0:7,0:7), nUVXt, nVX(0:7,0:7), nVXt, nx, ny, nz, OffBas(0:7), OffBas2(0:7), OffBasFro(0:7), &
                     OffOrb(0:7), OffOrb2(0:7), OffOrbTri(0:7), OffPUVX(0:7), OffUVX(0:7,0:7,0:7), OffVX(0:7,0:7), Packing, &
                     Rotational_Invariance
real(kind=wp) :: Block_Size, Crowding, Dens_a1, Dens_a2, Dens_b1, Dens_b2, Dens_I, Dens_t1, Dens_t2, Energy_integrated, Fade, &
                 Grad_I, R_Max(0:LMax_NQ), T_Y, Tau_I, ThrC, Threshold, Threshold_save, x_min, y_min, z_min
character(len=10) :: Quadrature
character(len=8) :: MBC

public :: Angular_Pruning, Block_Size, Crowding, Dens_a1, Dens_a2, Dens_b1, Dens_b2, Dens_I, Dens_t1, Dens_t2, Energy_integrated, &
          Fade, Fixed_Grid, Functional_Type, GGA_Type, Grad_I, Grid_Type, IOff_Ash, IOff_Bas, IOff_BasAct, iOpt_Angular, L_Quad, &
          L_Quad_save, LDA_Type, LMax_NQ, mBas, MBC, meta_GGA_Type1, meta_GGA_Type2, mIrrep, mOrb, Moving_Grid, mRad, &
          nAngularGrids, nAsh, NASHT, nAtoms, ndc, nFro, nISh, nOrbt, nPot1, nPot2, NQ_Direct, NQ_Info_Dmp, NQ_Info_Get, nR, &
          nR_Save, nTotGP, number_of_subblocks, nUVX, nUVXt, nVX, nVXt, nx, ny, nz, Off, OffBas, OffBas2, OffBasFro, OffOrb, &
          OffOrb2, OffOrbTri, OffPUVX, OffUVX, OffVX, On, Other_Type, Packing, Quadrature, R_Max, Rotational_Invariance, T_Y, &
          Tau_I, ThrC, Threshold, Threshold_save, x_min, y_min, z_min

contains

subroutine NQ_Info_Dmp()

  use fortran_strings, only: char_array, str
  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp) :: i, lcDmp
  integer(kind=iwp), allocatable :: iDmp(:)
  real(kind=wp), allocatable :: rDmp(:)
  character, allocatable :: cDmp(:)
  integer(kind=iwp), parameter :: liDmp = 25+5*8, lrDmp = 20+(LMax_NQ+1)

  ! Real Stuff

  call mma_allocate(rDmp,lrDmp,Label='rDmp')
  i = 1
  rDmp(i) = Threshold_save
  i = i+1
  rDmp(i) = Crowding
  i = i+1
  rDmp(i) = Threshold
  i = i+1
  rDmp(i:i+LMax_NQ) = R_Max
  i = i+LMax_NQ+1
  rDmp(i) = Energy_integrated
  i = i+1
  rDmp(i) = Dens_I
  i = i+1
  rDmp(i) = Grad_I
  i = i+1
  rDmp(i) = Tau_I
  i = i+1
  rDmp(i) = Dens_a1
  i = i+1
  rDmp(i) = Dens_b1
  i = i+1
  rDmp(i) = Dens_a2
  i = i+1
  rDmp(i) = Dens_b2
  i = i+1
  rDmp(i) = Dens_t1
  i = i+1
  rDmp(i) = Dens_t2
  i = i+1
  rDmp(i) = Block_Size
  i = i+1
  rDmp(i) = x_min
  i = i+1
  rDmp(i) = y_min
  i = i+1
  rDmp(i) = z_min
  i = i+1
  rDmp(i) = Fade
  i = i+1
  rDmp(i) = ThrC
  i = i+1
  rDmp(i) = T_Y
  i = i+1
  call Put_dArray('Quad_r',rDmp,lrDmp)
  call mma_deallocate(rDmp)

  ! Integer Stuff

  call mma_allocate(iDmp,liDmp,Label='iDmp')
  i = 1
  iDmp(i) = NASHT
  i = i+1
  iDmp(i) = nPot1
  i = i+1
  iDmp(i) = nOrbt
  i = i+1
  iDmp(i) = nPot2
  i = i+1
  iDmp(i) = ndc
  i = i+1
  iDmp(i) = nAngularGrids
  i = i+1
  iDmp(i) = L_Quad_save
  i = i+1
  iDmp(i) = nR_Save
  i = i+1
  iDmp(i) = Angular_Pruning
  i = i+1
  iDmp(i) = nx
  i = i+1
  iDmp(i) = ny
  i = i+1
  iDmp(i) = nz
  i = i+1
  iDmp(i) = number_of_subblocks
  i = i+1
  iDmp(i) = L_Quad
  i = i+1
  iDmp(i) = nR
  i = i+1
  iDmp(i) = nAtoms
  i = i+1
  iDmp(i) = nTotGP
  i = i+1
  iDmp(i) = iOpt_Angular
  i = i+1
  iDmp(i) = mIrrep
  i = i+1
  iDmp(i:i+7) = nISh
  i = i+8
  iDmp(i:i+7) = nAsh
  i = i+8
  iDmp(i:i+7) = mBas
  i = i+8
  iDmp(i) = Functional_type
  i = i+1
  iDmp(i:i+7) = mOrb
  i = i+8
  iDmp(i) = Grid_Type
  i = i+1
  iDmp(i) = Rotational_Invariance
  i = i+1
  iDmp(i) = mRad
  i = i+1
  iDmp(i) = NQ_Direct
  i = i+1
  iDmp(i) = Packing
  i = i+1
  iDmp(i:i+7) = OffPUVX
  i = i+8
  call Put_iArray('Quad_i',iDmp,liDmp)
  call mma_deallocate(iDmp)

  ! Character Stuff

  lcDmp = len(Quadrature)+len(MBC)
  call mma_allocate(cDmp,lcDmp,Label='cDmp')
  i = 0
  cDmp(i+1:i+len(Quadrature)) = char_array(Quadrature)
  i = i+len(Quadrature)
  cDmp(i+1:i+len(MBC)) = char_array(MBC)
  i = i+len(MBC)
  call Put_cArray('Quad_c',str(cDmp),lcDmp)
  call mma_deallocate(cDmp)

end subroutine

subroutine NQ_Info_Get()

  use fortran_strings, only: str
  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp) :: i, lcDmp
  integer(kind=iwp), allocatable :: iDmp(:)
  real(kind=wp), allocatable :: rDmp(:)
  character, allocatable :: cDmp(:)
  integer(kind=iwp), parameter :: liDmp = 25+5*8, lrDmp = 20+(LMax_NQ+1)

  ! Real Stuff

  call mma_allocate(rDmp,lrDmp,Label='rDmp')
  call Get_dArray('Quad_r',rDmp,lrDmp)
  i = 1
  Threshold_save = rDmp(i)
  i = i+1
  Crowding = rDmp(i)
  i = i+1
  Threshold = rDmp(i)
  i = i+1
  R_Max = rDmp(i:i+LMax_NQ)
  i = i+LMax_NQ+1
  Energy_integrated = rDmp(i)
  i = i+1
  Dens_I = rDmp(i)
  i = i+1
  Grad_I = rDmp(i)
  i = i+1
  Tau_I = rDmp(i)
  i = i+1
  Dens_a1 = rDmp(i)
  i = i+1
  Dens_b1 = rDmp(i)
  i = i+1
  Dens_a2 = rDmp(i)
  i = i+1
  Dens_b2 = rDmp(i)
  i = i+1
  Dens_t1 = rDmp(i)
  i = i+1
  Dens_t2 = rDmp(i)
  i = i+1
  Block_Size = rDmp(i)
  i = i+1
  x_min = rDmp(i)
  i = i+1
  y_min = rDmp(i)
  i = i+1
  z_min = rDmp(i)
  i = i+1
  Fade = rDmp(i)
  i = i+1
  ThrC = rDmp(i)
  i = i+1
  T_Y = rDmp(i)
  i = i+1
  call mma_deallocate(rDmp)

  ! Integer Stuff

  call mma_allocate(iDmp,liDmp,Label='iDmp')
  call Get_iArray('Quad_i',iDmp,liDmp)
  i = 1
  NASHT = iDmp(i)
  i = i+1
  NPot1 = iDmp(i)
  i = i+1
  nOrbt = iDmp(i)
  i = i+1
  nPot2 = iDmp(i)
  i = i+1
  ndc = iDmp(i)
  i = i+1
  nAngularGrids = iDmp(i)
  i = i+1
  L_Quad_save = iDmp(i)
  i = i+1
  nR_Save = iDmp(i)
  i = i+1
  Angular_Pruning = iDmp(i)
  i = i+1
  nx = iDmp(i)
  i = i+1
  ny = iDmp(i)
  i = i+1
  nz = iDmp(i)
  i = i+1
  number_of_subblocks = iDmp(i)
  i = i+1
  L_Quad = iDmp(i)
  i = i+1
  nR = iDmp(i)
  i = i+1
  nAtoms = iDmp(i)
  i = i+1
  nTotGP = iDmp(i)
  i = i+1
  iOpt_Angular = iDmp(i)
  i = i+1
  mIrrep = iDmp(i)
  i = i+1
  nISh = iDmp(i:i+7)
  i = i+8
  nAsh = iDmp(i:i+7)
  i = i+8
  mBas = iDmp(i:i+7)
  i = i+8
  Functional_type = iDmp(i)
  i = i+1
  mOrb = iDmp(i:i+7)
  i = i+8
  Grid_Type = iDmp(i)
  i = i+1
  Rotational_Invariance = iDmp(i)
  i = i+1
  mRad = iDmp(i)
  i = i+1
  NQ_Direct = iDmp(i)
  i = i+1
  Packing = iDmp(i)
  i = i+1
  OffPUVX = iDmp(i:i+7)
  i = i+8
  call mma_deallocate(iDmp)

  ! Character Stuff

  lcDmp = len(Quadrature)+len(MBC)
  call mma_allocate(cDmp,lcDmp,Label='cDmp')
  call Get_cArray('Quad_c',cDmp,lcDmp)
  i = 0
  Quadrature = str(cDmp(i+1:i+len(Quadrature)))
  i = i+len(Quadrature)
  MBC = str(cDmp(i+1:i+len(MBC)))
  i = i+len(MBC)
  call mma_deallocate(cDmp)

end subroutine NQ_Info_Get

end module nq_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Inter(iSet1,nSet1,iSet2,nSet2,iInter,nInter)
************************************************************************
*                                                                      *
* Object : to form the intersection of two sets.                       *
*                                                                      *
* Called from: NucAtt                                                  *
*              TwoEl                                                   *
*                                                                      *
* Calling    : None                                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             February '90                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Integer iSet1(0:nSet1-1),iSet2(0:nSet2-1), iInter(0:7)
*
      nInter = 0
      Do 10 i1 = 0, nSet1-1
         Do 20 i2 = 0, nSet2-1
            If (iSet1(i1).eq.iSet2(i2)) Then
               nInter = nInter + 1
               iInter(nInter-1) = iSet1(i1)
               Go To 10
            End If
 20      Continue
 10   Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Ext_L0(V1,V2,no,dimij,dimc,nbs)
! this routine does:
! V2(i,j,m') <- V1(p,q,m')

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: no, dimij, dimc, nbs
real(kind=wp), intent(in) :: V1(nbs,nbs,dimc)
real(kind=wp), intent(out) :: V2(dimij,dimc)
integer(kind=iwp) :: i, ij

ij = 0
do i=1,no
  V2(ij+1:ij+i,:) = V1(i,1:i,:)
  ij = ij+i
end do

return

end subroutine Ext_L0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Inter(iSet1,nSet1,iSet2,nSet2,iInter,nInter)
!***********************************************************************
!                                                                      *
! Object : to form the intersection of two sets.                       *
!                                                                      *
! Called from: NucAtt                                                  *
!              TwoEl                                                   *
!                                                                      *
! Calling    : None                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             February '90                                             *
!***********************************************************************

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nSet1, iSet1(0:nSet1-1), nSet2, iSet2(0:nSet2-1)
integer(kind=iwp), intent(inout) :: iInter(0:7)
integer(kind=iwp), intent(out) :: nInter
integer(kind=iwp) :: i1, i2

nInter = 0
do i1=0,nSet1-1
  do i2=0,nSet2-1
    if (iSet1(i1) == iSet2(i2)) then
      iInter(nInter) = iSet1(i1)
      nInter = nInter+1
      exit
    end if
  end do
end do

return

end subroutine Inter

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AODKHEXP(NBasis,M,MX,M0,Ep,E0,EL,ES,OL,W,TA,TB,A1,A2,O2,E2,F2,WS)
! Do the Douglas-Kroll-Hess Arbitrary order term
!
! Storage requirements:
! Ep,E0 - NBasis
! EL,ES,OL - NBasis*NBasis
! W,TA,TB,A1,A2 - NBasis*NBasis
! O2,E2,F2 - Nbasis*Nbasis*M (M=order of DKH)

use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NBasis, M, MX, M0
real(kind=wp), intent(in) :: Ep(NBasis), E0(NBasis), ES(NBasis,NBasis), OL(NBasis,NBasis)
real(kind=wp), intent(inout) :: EL(NBasis,NBasis), TA(NBasis,NBasis), TB(NBasis,NBasis), A1(NBasis,NBasis), A2(NBasis,NBasis), &
                                O2(NBasis,NBasis,M), E2(NBasis,NBasis,M), F2(NBasis,NBasis,M), WS(NBasis,NBasis,M)
real(kind=wp), intent(out) :: W(NBasis,NBasis)
integer(kind=iwp) :: I, Ioe, Iut, J, K, KK, Ks
real(kind=wp) :: Cof
logical(kind=iwp) :: Ifodd

! Copy 1st order DKH effective potential
! E2(upper-left) O2(upper-right) F2(lower-right)

E2(:,:,1) = EL(:,:)
F2(:,:,1) = ES(:,:)
O2(:,:,1) = OL(:,:)

! Apply [M/2] times Douglas-Kroll-Hess Unitary transformations

do Iut=1,M/2
  do I=1,NBasis
    do J=1,NBasis
      W(J,I) = O2(J,I,Iut)/(Ep(I)+Ep(J))
      if (Iut <= MX) WS(J,I,Iut*2-1) = W(J,I)
    end do
  end do
  ! Apply W_{Iut} to O/E_{Ks}
  do Ks=M-Iut,1,-1
    ! W_{1} only apply to O/E_{1}
    if ((Iut == 1) .and. (Ks >= 2)) cycle
    do Ioe=1,2
      ! O_{k,k<Iut} was eliminated
      if ((Ioe == 1) .and. (Ks < Iut)) cycle
      Ifodd = Ioe == 1
      ! Copy O/E_{Ks} terms to temp arrays
      if (Ifodd) then
        TA(:,:) = O2(:,:,Ks)
      else
        TA(:,:) = E2(:,:,Ks)
        TB(:,:) = F2(:,:,Ks)
      end if
      do K=Ks,M,Iut
        ! skip terms do not contribute to final DKH Hamiltonian (even,upper-left)
        if ((K+Iut+Iut > M) .and. ((K+Iut > M) .or. (.not. Ifodd))) cycle
        KK = (K-Ks)/Iut+1
        if ((Ioe == 1) .and. (Ks == Iut)) then
          ! see Eq.(74) of JCP130(2009)044102
          if (KK == 1) then
            Cof = Half
          else
            Cof = real(KK,kind=wp)/(KK*KK-One)
          end if
        else
          ! see Eq.(71) of JCP130(2009)044102
          Cof = One/KK
        end if
        if (Ifodd) then
          ! skip terms do not contribute to final DKH Hamiltonian (even,upper-left)
          if (K+Iut+Iut+Iut <= M) then
            call DGEMM_('T','N',NBasis,NBasis,NBasis,Cof,W,NBasis,TA,NBasis,Zero,A2,NBasis)
          end if
          call DGEMM_('N','T',NBasis,NBasis,NBasis,Cof,W,NBasis,TA,NBasis,Zero,A1,NBasis)
          ! ( 0  W)(0  O)   (0  O)( 0  W)   ( WO'+(WO')'     0       )
          ! (-W' 0)(O' 0) - (O' 0)(-W' 0) = (    0       -W'O-(W'O)' )
          !  where W'=W^{\dag} O'=O^{\dag}
          do I=1,NBasis
            do J=1,NBasis
              if (K+Iut+Iut+Iut <= M) then
                TB(J,I) = -A2(J,I)-A2(I,J)
              end if
              TA(J,I) = A1(J,I)+A1(I,J)
            end do
          end do
          if (K+Iut+Iut+Iut <= M) then
            F2(:,:,K+Iut) = F2(:,:,K+Iut)+TB(:,:)
          end if
          E2(:,:,K+Iut) = E2(:,:,K+Iut)+TA(:,:)
        else
          call DGEMM_('N','N',NBasis,NBasis,NBasis,Cof,W,NBasis,TB,NBasis,Zero,A1,NBasis)
          call DGEMM_('N','N',NBasis,NBasis,NBasis,Cof,TA,NBasis,W,NBasis,Zero,A2,NBasis)
          ! ( 0  W)(E 0)   (E 0)( 0  W)   (    0     WF-EW )
          ! (-W' 0)(0 F) - (0 F)(-W' 0) = ( (WF-EW)'   0   )
          !  where W'=W^{\dag}
          do I=1,NBasis
            do J=1,NBasis
              TA(J,I) = A1(J,I)-A2(J,I)
            end do
          end do
          O2(:,:,K+Iut) = O2(:,:,K+Iut)+TA(:,:)
        end if
        Ifodd = .not. Ifodd
      end do
    end do
  end do
end do

! Sum all even terms to Douglas-Kroll-Hess Hamiltonian

do I=1,NBasis
  EL(I,I) = EL(I,I)+E0(I)
end do
do I=2,M0
  EL(:,:) = EL(:,:)+E2(:,:,I)
end do

return

end subroutine AODKHEXP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MP2gDens_setup()
*                                                                      *
************************************************************************
*                                                                      *
      Implicit Real*8 (a-h,o-z)
*
#include "WrkSpc.fh"
#include "mp2grad.fh"
#include "corbinf.fh"
*                                                                      *
************************************************************************
*                                                                      *
      l_Density = 0
      l_Mp2Lagr = 0
      l_DiaA    = 0
      Do iSym = 1, nSym
         l_Density = l_Density + (nOrb(iSym)+nDel(iSym))
     &                         * (nOrb(iSym)+nDel(iSym))
         l_Mp2Lagr = l_Mp2Lagr + (nFro(iSym) + nOcc(iSym))
     &                         * (nExt(iSym) + nDel(iSym))
         l_DiaA    = l_DiaA    + (nFro(iSym) + nOcc(iSym))
     &                         * (nExt(iSym) + nDel(iSym))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('MP2Density','Allo','Real',ip_First_Density,
     &            l_Density)
      Call GetMem('MP2WDensity','Allo','Real',ip_First_WDensity,
     &            l_Density)
      Call GetMem('MP2Lagr','Allo','Real',
     &            ip_First_Mp2Lagr, l_Mp2Lagr)
      Call GetMem('MP2DiaA','Allo','Real',
     &            ip_First_DiaA, l_DiaA)
*
      Call FZero(Work(ip_First_Density),    l_Density)
      Call FZero(Work(ip_First_WDensity),   l_Density)
      Call FZero(Work(ip_First_Mp2Lagr),    l_Mp2Lagr)
      Call FZero(Work(ip_First_DiaA),       l_DiaA)
*                                                                      *
************************************************************************
*                                                                      *
      ip_Density(1)    = ip_First_Density
      ip_WDensity(1)   = ip_First_WDensity
      ip_Mp2Lagr(1)    = ip_First_Mp2Lagr
      ip_DiaA(1)       = ip_First_DiaA
      Do i = 1, nSym-1
         ip_Density(i+1)    = ip_Density(i)    + (nOrb(i)+nDel(i))
     &                                         * (nOrb(i)+nDel(i))
         ip_WDensity(i+1)   = ip_WDensity(i)   + (nOrb(i)+nDel(i))
     &                                         * (nOrb(i)+nDel(i))
         ip_Mp2Lagr(i+1)    = ip_Mp2Lagr(i)    + (nFro(i)+nOcc(i))
     &                                         * (nExt(i)+nDel(i))
         ip_DiaA(i+1)       = ip_DiaA(i)       + (nFro(i)+nOcc(i))
     &                                         * (nExt(i)+nDel(i))
      End Do
*
      mAdOcc(1) = ipEOcc
      nOccT = nOcc(1)
      Do iSym = 2, nSym
         mAdOcc(iSym) = mAdOcc(iSym-1) + nOcc(iSym-1)
         nOccT = nOccT + nOcc(iSym)
      End Do

      mAdVir(1) = ipEVir
      nExtT = nExt(1)
      Do iSym=2, nSym
         mAdVir(iSym) = mAdVir(iSym-1) + nExt(iSym-1)
         nExtT = nExtT + nExt(iSym)
      End Do
*
      mAdFro(1) = ipEOcc+nOccT
      Do iSym = 2, nSym
         mAdFro(iSym) = mAdFro(iSym-1) + nFro(iSym-1)
      End Do
*
      mAdDel(1) = ipEVir+nExtT
      Do iSym = 2, nSym
         mAdDel(iSym) = mAdDel(iSym-1) + nDel(iSym-1)
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!               2012,2014, Victor P. Vysotskiy                         *
!***********************************************************************

subroutine Cho_XCV_DV_S(irc,SP_BatchDim,nSP_Batch,id_mySP,n_mySP)

use Cholesky, only: iiBstRSh, INF_PROGRESS, IPRINT, LuCho, LuPri, LuTmp, nnBstR, nnBstRSh, nSym, NumCho
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nSP_Batch, SP_BatchDim(nSP_Batch), n_mySP, id_mySP(n_mySP)
integer(kind=iwp) :: iAdr, iAdr0, iBatch, ip_Mem, ip_T, ip_V, iSP, iSP1, iSP2, iSP_Batch, iSym, j, J1, kOffT, kOffV, kT, kV, &
                     l_Mem, lTot, max_block_dim, max_vector_dim, nBatch, nDim, nSP_this_batch, nVec_per_batch, nVec_this_batch
real(kind=wp) :: X0, X1, Y0, Y1
real(kind=wp), allocatable :: DVSVEC(:)
character(len=*), parameter :: SecNam = 'Cho_XCV_DV_S'

! Init return code
irc = 0

! Find max vector dimension
max_vector_dim = nnBstR(1,2)
do iSym=2,nSym
  max_vector_dim = max(max_vector_dim,nnBstR(iSym,2))
end do
if (max_vector_dim < 1) then
  irc = -2
  return
end if

! Find max block dimension
max_block_dim = 0
iSP1 = 1
do iSP_Batch=1,nSP_Batch
  nSP_this_batch = SP_BatchDim(iSP_Batch)
  iSP2 = iSP1+nSP_this_batch-1
  do iSym=1,nSym
    nDim = 0
    do iSP=iSP1,iSP2
      nDim = nDim+nnBstRSh(iSym,id_mySP(iSP),2)
    end do
    max_block_dim = max(max_block_dim,nDim)
  end do
  iSP1 = iSP1+nSP_this_batch
end do
#ifdef _DEBUGPRINT_
if ((iSP1-1) /= n_mySP) call Cho_Quit(SecNam//': SP batch dimension error',103)
#endif

! Get largest memory block
call mma_maxDBLE(l_Mem)
lTot = max_vector_dim+max_block_dim
if (l_Mem < lTot) then
  irc = -1
  return
end if
call mma_allocate(DVSVEC,l_Mem,Label='DVSVEC')
ip_Mem = 1

! read, reorder, and write vectors, one symmetry at a time
do iSym=1,nSym
  if (iPrint >= Inf_Progress) then
    write(LuPri,'(/,A,I2,/,A)') 'Writing vectors, symmetry',iSym,'---------------------------'
    write(LuPri,'(3X,A,I8)') 'Total number of vectors:',NumCho(iSym)
    write(LuPri,'(3X,A,I8)') 'Vector dimension       :',nnBstR(iSym,2)
    write(LuPri,'(3X,A,I8)') 'Shell pair batches     :',nSP_Batch
    call XFlush(LuPri)
  end if
  if ((NumCho(iSym) > 0) .and. (nnBstR(iSym,2) > 0)) then
    ! Set up batching
    lTot = max_block_dim+nnBstR(iSym,2)
    nVec_per_batch = min(l_Mem/lTot,NumCho(iSym))
    if (nVec_per_batch < 1) call Cho_Quit('Insufficient memory for batching in '//SecNam,101)
    nBatch = (NumCho(iSym)-1)/nVec_per_batch+1
    if (iPrint >= Inf_Progress) then
      write(LuPri,'(3X,A,I8)') 'Vector batches         :',nBatch
      call XFlush(LuPri)
    end if
    ! Read and write vectors in batches
    do iBatch=1,nBatch
      ! Determine number of vectors in this batch
      if (iBatch == nBatch) then
        nVec_this_batch = NumCho(iSym)-nVec_per_batch*(nBatch-1)
      else
        nVec_this_batch = nVec_per_batch
      end if
      ! First vector in this batch
      J1 = nVec_per_batch*(iBatch-1)+1
      if (iPrint >= Inf_Progress) then
        write(LuPri,'(3X,A,I8,/,3X,A)') 'Vector batch number:',iBatch,'++++++++++++++++++++++++++++'
        write(LuPri,'(6X,A,I8)') 'Number of vectors in this batch:',nVec_this_batch
        write(LuPri,'(6X,A,I8,1X,I8)') 'First and last vector          :',J1,J1+nVec_this_batch-1
        call XFlush(LuPri)
        call CWTime(X0,Y0)
      end if
      ! Set memory pointers
      ip_T = ip_Mem
      ip_V = ip_T+max_block_dim*nVec_this_batch
      ! Read blocked vectors and copy into full vector array
      iAdr0 = 0
      iSP1 = 1
      do iSP_Batch=1,nSP_Batch
        nSP_this_batch = SP_BatchDim(iSP_Batch)
        iSP2 = iSP1+nSP_this_batch-1
        nDim = 0
        do iSP=iSP1,iSP2
          nDim = nDim+nnBstRSh(iSym,id_mySP(iSP),2)
        end do
        if (nDim > 0) then
          lToT = nDim*nVec_this_batch
          iAdr = iAdr0+nDim*(J1-1)
          call DDAFile(LuTmp(iSym),2,DVSVEC(ip_T),lTot,iAdr)
          kT = ip_T-1
          kV = ip_V-1
          do J=1,nVec_this_batch
            kOffT = kT+nDim*(J-1)
            kOffV = kV+nnBstR(iSym,2)*(J-1)+iiBstRSh(iSym,id_mySP(iSP1),2)
            DVSVEC(kOffV+1:kOffV+nDim) = DVSVEC(kOffT+1:kOffT+nDim)
          end do
          iAdr0 = iAdr0+nDim*NumCho(iSym)
        end if
        iSP1 = iSP1+nSP_this_batch
      end do
      if (iPrint >= Inf_Progress) then
        call CWTime(X1,Y1)
        write(LuPri,'(6X,A,F12.2,1X,F12.2)') 'Time for read/reorder (sec)    :',(X1-X0),(Y1-Y0)
        call XFlush(LuPri)
      end if
      ! Write full vectors to disk
      lTot = nnBstR(iSym,2)*nVec_this_batch
      iAdr = nnBstR(iSym,2)*(J1-1)
      call DDAFile(LuCho(iSym),1,DVSVEC(ip_V),lTot,iAdr)
      if (iPrint >= Inf_Progress) then
        call CWTime(X0,Y0)
        write(LuPri,'(6X,A,F12.2,1X,F12.2)') 'Time for write (sec)           :',(X0-X1),(Y0-Y1)
        call XFlush(LuPri)
      end if
    end do
  end if
end do

! Deallocation
call mma_deallocate(DVSVEC)

end subroutine Cho_XCV_DV_S

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! The RASSI-density matrix subroutine.
subroutine DensiSt(Dens,StVec,iS,nSt,iDm)
! iS    - Which state that is occupied.
! Dens  - The density
! StVec - The coefficients for how the new states are expressed with the old.

use Index_Functions, only: nTri_Elem
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iS, nSt, iDm
real(kind=wp), intent(out) :: Dens(nTri_Elem(nSt))
real(kind=wp), intent(in) :: StVec(iDm,*)
integer(kind=iwp) :: i, j, kaunt

kaunt = 0
do i=1,nSt
  do j=1,i-1
    kaunt = kaunt+1
    Dens(kaunt) = Two*StVec(i,iS)*StVec(j,iS)
  end do
  kaunt = kaunt+1
  Dens(kaunt) = StVec(i,iS)*StVec(i,iS)
end do

return

end subroutine DensiSt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine LoadGtuvx(TUVX,Gtuvx)
! ****************************************************************
! Purpose:                                                       *
! Loading TUVX array to a 4-D tensor.                            *
! Copyied from src/molcas_ci_util/david5.f                       *
! ****************************************************************

use rasscf_global, only: NAC, NACPR2
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: TUVX(NACPR2)
real(kind=wp), intent(out) :: Gtuvx(NAC,NAC,NAC,NAC)
integer(kind=iwp) :: it, ituvx, iu, iv, ix, ixmax

ituvx = 0
do it=1,NAC
  do iu=1,it
    do iv=1,it
      ixmax = iv
      if (it == iv) ixmax = iu
      do ix=1,ixmax
        ituvx = ituvx+1
        Gtuvx(it,iu,iv,ix) = TUVX(ituvx)
        Gtuvx(iu,it,iv,ix) = TUVX(ituvx)
        Gtuvx(it,iu,ix,iv) = TUVX(ituvx)
        Gtuvx(iu,it,ix,iv) = TUVX(ituvx)
        Gtuvx(iv,ix,it,iu) = TUVX(ituvx)
        Gtuvx(ix,iv,it,iu) = TUVX(ituvx)
        Gtuvx(iv,ix,iu,it) = TUVX(ituvx)
        Gtuvx(ix,iv,iu,it) = TUVX(ituvx)
      end do
    end do
  end do
end do

return

end subroutine LoadGtuvx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine dset_cvb(iorbrel,ifxorb,ifxstr,
     >  idelstr,iorts,irots,izeta)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "inpmod_cvb.fh"
#include "malloc_cvb.fh"
      dimension iorbrel(ndimrel),ifxorb(mxorb),
     >  iorts(*),irots(*),izeta(*)

c  Check if any molecular interaction constraints :
      if(ploc)call plcconst_plc()
      sym=(norbrel.gt.0.or.nort.gt.0.or.plc_const)
      call rdioff_cvb(9,recinp,ioffs)
      call wris_cvb(iorbrel,ndimrel,recinp,ioffs)
      call wrioff_cvb(10,recinp,ioffs)
      call wrioff_cvb(11,recinp,ioffs)
      call wris_cvb(ifxorb,norb,recinp,ioffs)
      call wrioff_cvb(12,recinp,ioffs)
      call wris_cvb(iw(ifxstr),nfxvb,recinp,ioffs)
      call wrioff_cvb(13,recinp,ioffs)
      call wris_cvb(iw(idelstr),nzrvb,recinp,ioffs)
      call wrioff_cvb(14,recinp,ioffs)
      call wris_cvb(iorts,2*nort,recinp,ioffs)
      call wrioff_cvb(15,recinp,ioffs)
      call wris_cvb(irots,2*ndrot,recinp,ioffs)
      call wrioff_cvb(16,recinp,ioffs)
      call wris_cvb(izeta,nsyme,recinp,ioffs)
      call wrioff_cvb(17,recinp,ioffs)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine OpnFls_RASSCF(DSCF,DoCholesky)
!***********************************************************************
!                                                                      *
!     Open files.                                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use general_data, only: ITERFILE, JOBIPH, JOBOLD, LUDAVID, LUINTA, LUINTM, LUONEL, LUQUNE
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp), intent(out) :: DSCF, DoCholesky
integer(kind=iwp) :: iOpt, iRC
logical(kind=iwp) :: test
integer(kind=iwp), external :: IsFreeUnit

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*
!---  define logical unit numbers -------------------------------------*
! Molecular orbital input file  this variable is not used
! File is opened and closed i.e. around calls to rdvec.
!LUStartOrb = 19
! Job interface unit (-1 shows it has not been opened!)
JOBIPH = -1
! Old RASSCF job interface for input MO's and CI vector
JOBOLD = -1
! AO one-electron integrals
LUONEL = 16
! AO two-electron integrals
LUINTA = 40
! MO two-electron integrals
LUINTM = 13
! Temporary unit used for QUNE update
LUQUNE = 27
! Temporary unit for diagonalization
LUDAVID = 37
! Opening the JOBIPH file is delayed till after input processing at end
! of READIN_RASSCF. Only then is file name known.

!---  open the ORDINT file --------------------------------------------*
call f_Inquire('ORDINT',test)
call DecideOnDirect(.true.,test,DSCF,DoCholesky)
if ((.not. DSCF) .and. (.not. DoCholesky)) then
  iRc = -1
  iOpt = 0
  call OpnOrd(iRc,iOpt,'ORDINT',LUINTA)
  if (iRc /= 0) then
    write(u6,*) 'RASSCF tried to open a file (ORDINT) containing'
    write(u6,*) 'two-electron integrals, but failed. Something'
    write(u6,*) 'is wrong with the file. Most probably it is'
    write(u6,*) 'simply missing: Please check. It should have'
    write(u6,*) 'been created by SEWARD. Perhaps it is in the'
    write(u6,*) 'wrong directory?'
    call Abend()
  end if
else
  call f_Inquire('RUNFILE',test)
  if (.not. test) then
    write(u6,*) 'RASSCF tried to open a file (RUNFILE) containing'
    write(u6,*) 'data from previous program steps. Something'
    write(u6,*) 'is wrong with the file. Most probably it is'
    write(u6,*) 'simply missing: Please check. It should have'
    write(u6,*) 'been created by SEWARD.'
    call Abend()
  end if
end if
!---  open the file carrying the transfromed two-electron integrals ---*
call DaName(LUINTM,'TRAINT')
!---  open the DAVID file carrying temporary CI and sigma vectors -----*
!     Note the unit number is defined in the module general_data
call DaName(LuDavid,'TEMP01')
!---  open the file carrying the hessian update vectors ---------------*
call DaName(LuQune,'TEMP02')
!
! Open file for storage of information on CI-iterations
!
IterFile = IsFreeUnit(10)
call molcas_open(IterFile,'CIITER')
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine OpnFls_RASSCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CRYSTALFIELD(ESOJ,DIPSO,S_SO,nDIMcf,d,nlanth,zmagn2,iopt,GRAD,iprint)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDIMcf, d, nlanth, iopt, iprint
real(kind=wp), intent(in) :: ESOJ(nDIMcf), ZMAGN2(3,3)
complex(kind=wp), intent(in) :: DIPSO(3,nDIMcf,nDIMcf), S_SO(3,nDIMcf,nDIMcf)
logical(kind=iwp), intent(in) :: GRAD
integer(kind=iwp) :: i, info, j
real(kind=wp) :: gtens(3), zmagn(3,3)
real(kind=wp), allocatable :: wtmp(:)
complex(kind=wp), allocatable :: DIPJ(:,:,:), SJ(:,:,:), TMP(:,:,:), ztmp(:,:)

write(u6,'(/)')
write(u6,'(A)') repeat('%',95)
if (mod(nDIMcf,2) == 1) then
  write(u6,'(5x,A,I2,A)') 'CALCULATION OF CRYSTAL-FIELD PARAMETERS OF THE GROUND ATOMIC MULTIPLET J = ',(nDIMcf-1)/2,'.'
else
  write(u6,'(5x,A,I2,A)') 'CALCULATION OF CRYSTAL-FIELD PARAMETERS OF THE GROUND ATOMIC MULTIPLET J = ',(nDIMcf-1),'/2.'
end if
write(u6,'(A)') repeat('%',95)
write(u6,*)

if (iopt == 1) then
  ! coordinate system for decomposition of the CF matrix identic to the coordinate system
  ! of the main magnetic axes of the ground multiplet (NDIM(1))
  call mma_allocate(TMP,3,d,d,label='TMP')
  TMP(:,:,:) = DIPSO(:,1:d,1:d)
  call atens(TMP,d,GTENS,ZMAGN,1)
  call mma_deallocate(TMP)
  write(u6,'(a)') 'The parameters of the Crystal Field matrix are written in the coordinate system:'
  if (mod(d,2) == 0) then
    write(u6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic axes of the ground pseudospin S = |',d-1,'/2> multiplet.'
  else
    write(u6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic axes of the ground pseudospin S = |',(d-1)/2,'> multiplet.'
  end if

else if (iopt == 2) then
  ! coordinate system for decomposition of the CF matrix identic to the coordinate system
  ! of the main magnetic axes of the ground multiplet (NDIM(1))
  call atens(DIPSO,nDIMCF,GTENS,ZMAGN,1)
  write(u6,'(a)') 'The parameters of the Crystal Field matrix are written in the coordinate system:'
  if (mod(nDIMCF,2) == 0) then
    write(u6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic axes of the ground atomic J = |',nDIMCF-1,'/2> multiplet'
  else
    write(u6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic axes of the ground atomic J = |',(nDIMCF-1)/2,'> multiplet'
  end if

else if (iopt == 3) then
  write(u6,'(a)') 'The parameters of the Crystal Field matrix are written in the coordinate system:'
  write(u6,'(a)') '(Xm, Ym, Zm) -- defined in the input file.'
  zmagn(:,:) = zmagn2(:,:)
else
  write(u6,'(a)') 'The parameters of the Crystal Field matrix are written in the initial coordinate system.'
  call unitmat(zmagn,3)
end if ! axisoption

! rotate the momentum:
call mma_allocate(DIPJ,3,nDIMcf,nDIMcf,'DIPJ')
call mma_allocate(SJ,3,nDIMcf,nDIMcf,'SJ')
call rotmom2(DIPSO,nDIMCF,ZMAGN,DIPJ)
call rotmom2(S_SO,nDIMCF,ZMAGN,SJ)

write(u6,'(a)') 'Rotation matrix from the initial coordinate system to the employed coordinate system is:'

if ((iopt == 1) .or. (iopt == 2)) then
  write(u6,'(2a)') repeat('-',67),'|'
  write(u6,'(A,31x,A)') 'x , y , z  -- initial Cartesian axes','|'
  write(u6,'(A,35x,A)') 'Xm, Ym, Zm -- main magnetic axes','|'
  write(u6,'(4x,3(17x,a),9x,a)') 'x','y','z','|'
  write(u6,'(6x,A,3F18.14,1x,A)') '| Xm |',(ZMAGN(j,1),j=1,3),'|'
  write(u6,'( A,A,3F18.14,1x,A)') ' R =  ','| Ym |',(ZMAGN(j,2),j=1,3),'|'
  write(u6,'(6x,A,3F18.14,1x,A)') '| Zm |',(ZMAGN(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',67),'|'
  write(u6,'(A,I3)') 'Quantization axis is Zm.'

else if (iopt == 3) then

  write(u6,'(2a)') repeat('-',67),'|'
  write(u6,'(A,31x,A)') 'x , y , z  -- initial Cartesian axes','|'
  write(u6,'(A,11x,A)') 'Xm, Ym, Zm -- the coordinate system defined in the input','|'
  write(u6,'(4x,3(17x,a),9x,a)') 'x','y','z','|'
  write(u6,'(6x,A,3F18.14,1x,A)') '| Xm |',(ZMAGN(j,1),j=1,3),'|'
  write(u6,'( A,A,3F18.14,1x,A)') ' R =  ','| Ym |',(ZMAGN(j,2),j=1,3),'|'
  write(u6,'(6x,A,3F18.14,1x,A)') '| Zm |',(ZMAGN(j,3),j=1,3),'|'
  write(u6,'(2a)') repeat('-',67),'|'
  write(u6,'(A,I3)') 'Quantization axis is Zm.'

else

  write(u6,'(A)') 'IDENTITY matrix.'
  write(u6,'(A,I3)') 'Quantization axis is the initial z axis.'
end if

if (IPRINT > 2) then
  call prMom('CRYSTALFIELD::   DIPJ(l,i,j)',DIPJ,nDIMcf)
  call prMom('CRYSTALFIELD::     SJ(l,i,j)',SJ,nDIMcf)
end if

call mma_allocate(ztmp,nDIMcf,nDIMcf,'z')
call mma_allocate(wtmp,nDIMcf,'w')
call diag_c2(DIPJ,nDIMcf,info,wtmp,ztmp)
do i=1,nDIMcf
  write(u6,'(A,i2,A,4F20.15)') 'energy: ',i,' : ',wtmp(i),wtmp(i)+wtmp(nDIMcf-i+1)
end do
call mma_deallocate(ztmp)
call mma_deallocate(wtmp)

call CRYSTALFIELD_1(nDIMcf,nlanth,DIPJ,ESOJ,GRAD,iprint)

call mma_deallocate(DIPJ)
call mma_deallocate(SJ)

return

end subroutine CRYSTALFIELD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************

!----------------------------------------------------------------------*
! A subroutine that computes those darn f-factors. They are defined    *
! in equation (2.4) in doi:10.1143/JPSJ.21.2313. As can be seen from   *
! that equation, the computation of the f-factors is actually a matter *
! of using the binomial theorem. This is what we do below and to make  *
! the computation efficient the expression (2.4) is written as a       *
! succint double sum.                                                  *
!----------------------------------------------------------------------*
subroutine fFactor(loneX,ltwoX,lsumX,loneY,ltwoY,lsumY,loneZ,ltwoZ,lsumZ,PAxyz,PBxyz,FactorX,FactorY,FactorZ)

use qmstat_global, only: MxAngqNr
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: loneX, ltwoX, lsumX, loneY, ltwoY, lsumY, loneZ, ltwoZ, lsumZ
real(kind=wp), intent(in) :: PAxyz(3), PBxyz(3)
real(kind=wp), intent(out) :: FactorX(2*MxAngqNr+1), FactorY(2*MxAngqNr+1), FactorZ(2*MxAngqNr+1)
integer(kind=iwp) :: i, ia, iLowB, iUpB
real(kind=wp) :: fff1, fff2, PAraise, PBraise
integer(kind=iwp), external :: NoverP_Q

do ia=0,lsumX !We use unrolled loops with regard to x,y and z therefore, here we start with the x-factors.
  fff2 = 0
  ! These lower and upper bounds have to do
  ! with the allowed numbers in the binomial coefficients.
  iLowB = max(0,ia-ltwoX)
  iUpB = min(ia,loneX)
  do i=iLowB,iUpB
    fff1 = NoverP_Q(loneX,i)*NoverP_Q(ltwoX,ia-i)
    if (i /= 0) then  !This is needed for some compilers (NAG_64)
      PAraise = PAxyz(1)**i
    else
      PAraise = One
    end if
    if (ia-i /= 0) then
      PBraise = PBxyz(1)**(ia-i)
    else
      PBraise = One
    end if
    fff2 = fff2+fff1*PAraise*PBraise
  end do
  FactorX(lsumX-ia+1) = fff2
end do
do ia=0,lsumY !y-factors.
  fff2 = 0
  iLowB = max(0,ia-ltwoY)
  iUpB = min(ia,loneY)
  do i=iLowB,iUpB
    fff1 = NoverP_Q(loneY,i)*NoverP_Q(ltwoY,ia-i)
    if (i /= 0) then !This is needed for some compilers (NAG_64)
      PAraise = PAxyz(2)**i
    else
      PAraise = One
    end if
    if (ia-i /= 0) then
      PBraise = PBxyz(2)**(ia-i)
    else
      PBraise = One
    end if
    fff2 = fff2+fff1*PAraise*PBraise
  end do
  FactorY(lsumY-ia+1) = fff2
end do
do ia=0,lsumZ !z-factorz.
  fff2 = 0
  iLowB = max(0,ia-ltwoZ)
  iUpB = min(ia,loneZ)
  do i=iLowB,iUpB
    fff1 = NoverP_Q(loneZ,i)*NoverP_Q(ltwoZ,ia-i)
    if (i /= 0) then !This is needed for some compilers (NAG_64)
      PAraise = PAxyz(3)**i
    else
      PAraise = One
    end if
    if (ia-i /= 0) then
      PBraise = PBxyz(3)**(ia-i)
    else
      PBraise = One
    end if
    fff2 = fff2+fff1*PAraise*PBraise
  end do
  Factorz(lsumZ-ia+1) = fff2
end do

return

end subroutine fFactor

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Domain_Histogram(iDomain,nAtom,nOcc,Title)
C
C     Thomas Bondo Pedersen, January 2006.
C
C     Purpose: print histogram of domain sizes.
C
      Implicit Real*8 (a-h,o-z)
      Integer iDomain(0:nAtom,nOcc)
      Character*(*) Title
#include "WrkSpc.fh"

      If (nAtom.lt.1 .or. nOcc.lt.1) Return

      i_min = iDomain(0,1)
      i_max = iDomain(0,1)
      x_ave = dble(iDomain(0,1))
      Do i = 2,nOcc
         i_min = min(i_min,iDomain(0,i))
         i_max = max(i_max,iDomain(0,i))
         x_ave = x_ave + dble(iDomain(0,i))
      End Do
      x_ave = x_ave/dble(nOcc)

      l_iCount = i_max - i_min + 1
      Call GetMem('Dm_Histo','Allo','Inte',ip_iCount,l_iCount)

      Call Cho_Head(Title,"=",80,6)
      Write(6,'(/,A,3X,I10,/,A,3X,I10,/,A,F13.2)')
     & 'Minimum size:',i_min,
     & 'Maximum size:',i_max,
     & 'Average size:',x_ave
      Call Domain_Histo1(iDomain,nAtom,nOcc,iWork(ip_iCount),i_min,
     &                   i_max)
      Fac = 1.0d2/dble(nOcc)
      Pct = Fac*dble(iWork(ip_iCount))
      i = i_min
      Write(6,'(/,A,I10,A,I10,3X,F7.2,A)')
     & 'Number with size',i,':',iWork(ip_iCount),Pct,'%'
      Do iC = 2,l_iCount
         Pct = Fac*dble(iWork(ip_iCount-1+iC))
         i = i + 1
         Write(6,'(A,I10,A,I10,3X,F7.2,A)')
     &   'Number with size',i,':',iWork(ip_iCount-1+iC),Pct,'%'
      End Do

      Call GetMem('Dm_Histo','Free','Inte',ip_iCount,l_iCount)

      End
      SubRoutine Domain_Histo1(iDomain,nAtom,nOcc,iCount,i_min,i_max)
      Implicit Real*8 (a-h,o-z)
      Integer iDomain(0:nAtom,nOcc), iCount(*)

      nC = i_max - i_min + 1
      Call iCopy(nC,[0],0,iCount,1)

      Do i = 1,nOcc
         iC = iDomain(0,i) - i_min + 1
         iCount(iC) = iCount(iC) + 1
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SlapAf(ireturn)

use Slapaf_Info, only: CallLast, isFalcon
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: Columbus, iStop
integer(kind=iwp), external :: isStructure

#include "warnings.h"

!                                                                      *
!***********************************************************************
!                                                                      *
! Let us go to work !

iStop = -1
call RlxCtl(iStop)
! in case it is dmrg calculation
!      call read_dmrg_parameter_for_mclr()
!                                                                      *
!***********************************************************************
!                                                                      *
! Epilogue
!                                                                      *
!***********************************************************************
!                                                                      *
! Put out the proper return code.

if (iStop == 2) then
  !*********** columbus interface **************************************
  ! prevent slapaf to startup alaska
  ! The last MRCI or MRAQCC energy is written to the RUNFILE by the
  ! Columbus modules, so no need to recompute it internally

  call Get_iScalar('Columbus',Columbus)
  if (Columbus == 1) then
    iReturn = _RC_ALL_IS_WELL_
  else

    ! Compute the last energy (module Last_Energy)

    if (CallLast) then
      call Start_Last_Energy()

      iReturn = _RC_INVOKED_OTHER_MODULE_
    else
      iReturn = _RC_ALL_IS_WELL_
    end if
  end if

else if (iStop == 3) then

  ! Invoke Alaska

  call Start_Alaska()

  iReturn = _RC_INVOKED_OTHER_MODULE_

else if (iStop == 6) then

  ! Saddle TS optimization

  iReturn = _RC_INVOKED_OTHER_MODULE_

else if (iStop == 8) then

  ! Predicted energy change too large

  iReturn = _RC_NOT_CONVERGED_

else if (iStop == 16) then

  ! Optimization didn't converge!

  iReturn = _RC_NOT_CONVERGED_

else if (iStop == 1) then

  ! Continue looping!

  if (isStructure() == 1) then
    iReturn = _RC_CONTINUE_LOOP_
  else
    iReturn = _RC_ALL_IS_WELL_
  end if
  if (isFalcon) iReturn = _RC_ALL_IS_WELL_

else if (iStop == 0) then

  ! ???

  iReturn = _RC_ALL_IS_WELL_

else

  ! Bad bad boy!

  iReturn = _RC_INTERNAL_ERROR_
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine SlapAf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2011, Francesco Aquilante                              *
************************************************************************
      SubRoutine DOne_SCF(nSym,nBas,nOrb,nFro,CMO,nCMO,Occ,Dlt,
     &                    alpha_density)
************************************************************************
*                                                                      *
*     purpose: Compute density matrix in AO basis                      *
*                                                                      *
*     input:                                                           *
*       nSym    : number of symmetries                                 *
*       nBas(i) : number of basis functions (i = 1, nSym)              *
*       nOrb(i) : number of orbitals (i = 1, nSym)                     *
*       nFro(i) : number of frozen orbitals (i = 1, nSym)              *
*       CMO     : molecular orbitals                                   *
*       Occ     : occupation numbers                                   *
*                                                                      *
*       alpha_density: .true. iff alpha MOs were sent in               *
*                                                                      *
*     output:                                                          *
*       Dlt     : density matrix in triangular storrage                *
*                                                                      *
*     called from: DMat, final                                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: modified by F. Aquilante, Apr 2011                      *
*                                                                      *
************************************************************************
*
#include "compiler_features.h"
#ifndef POINTER_REMAP
      Use, Intrinsic :: ISO_C_BINDING
#endif
      use SpinAV
      Implicit Real*8 (a-h,o-z)
*
      Real*8, Target:: CMO(nCMO), Occ(*), Dlt(*)
      Real*8, Pointer:: pCMO(:,:), pOcc(:), pDlt(:)
      Integer nBas(nSym),nOrb(nSym),nFro(nSym)
      Logical alpha_density
*
#include "real.fh"

*
*---- Statement function for triangular storage
      Ind(i,j) = i*(i - 1)/2 + j
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call NrmClc(CMO,nCMO,'DOne_SCF','CMO')
      nOcc=0
      Do iSym = 1, nSym
         nOcc = nOcc + nOrb(iSym)
      End Do
      Call NrmClc(Occ,nOcc,'DOne_SCF','Occ')
#endif
*
      ipCMO  = 1
      ipDlt  = 1
      ipOcc  = 1
      Do iSym = 1, nSym
*
         nBs = nBas(iSym)
         nOr = nOrb(iSym)
         nFr = nFro(iSym)
*
         lth = nBs*(nBs + 1)/2
         Call FZero(Dlt(ipDlt),lth)
         If (nOr.eq.0) Go To 100
*
#ifdef POINTER_REMAP
         pCMO(1:nBs,1:nBs) => CMO(ipCMO:ipCMO+nBs**2-1)
#else
         Call C_F_POINTER(C_LOC(CMO(ipCMO)), pCMO, [nBs,nBs])
#endif
         pOcc => Occ(ipOcc:ipOcc+nOr-1)
         pDlt => Dlt(ipDlt:ipDlt+lth-1)
*
         Do iRow = 1, nBs
            Sum = Zero
            Do i = nFr + 1, nOr
               Sum = Sum + pOcc(i)*pCMO(iRow,i)**2
*              Sum = Sum + pOcc(i)*pCMO(iRow,i)*pCMO(iRow,i)
            End Do
            pDlt(Ind(iRow,iRow)) = Sum
*
            Do iCol = 1, iRow - 1
               Sum = Zero
               Do i = nFr + 1, nOr
                  Sum = Sum + pOcc(i)*pCMO(iRow,i)*pCMO(iCol,i)
               End Do
               pDlt(Ind(iRow,iCol)) = 2.0D0*Sum
            End Do
         End Do
#ifdef _DEBUGPRINT_
         Call NrmClc(pDlt,nBs*(nBs+1)/2,'DOne_SCF','Dlt')
*        Call RecPrt('CMO',' ',pCMO,nBs,nBs)
*        Call RecPrt('Occ',' ',pOcc,1,nOr)
*        Call TriPrt('Dlt',' ',pDlt,nBs)
#endif
*
 100     Continue
*
         Nullify(pCMO,pOcc,pDlt)
         ipCMO = ipCMO + nBs**2
         ipDlt = ipDlt + lth
         ipOcc = ipOcc + nOr
      End Do
*
      xsign=1.0d0
      If (Do_SpinAV) Then
*
         If (alpha_density) xsign=-1.0d0
         iOffD=1
         lOff=0
         Do iSym = 1, nSym
            lth=nBas(iSym)*(nBas(iSym)+1)/2
*
            pDlt => Dlt(iOffD:iOffD+lth-1)
*
            ipDScc=1+lOff
            Do j=1,nBas(iSym)
               Do i=1,j-1
                  ji=j*(j-1)/2+i
                  iDSc=ipDScc-1+nBas(iSym)*(j-1)+i
                  pDlt(ji)=pDlt(ji)+xsign*2.0d0*DSc(iDSc)
               End Do
               jj=j*(j+1)/2
               iDSc=ipDScc-1+nBas(iSym)*(j-1)+j
               pDlt(jj)=pDlt(jj)+xsign*DSc(iDSc)
            End Do
            iOff=iOff+lth
            lOff=lOff+nBas(iSym)**2
         End Do
*
      EndIf
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE EMPTY(BUF,IBUF,LASTAD,SO,KBUF,NTPB)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"
#include "real_guga.fh"
#include "integ.fh"
#include "files_guga.fh"
      DIMENSION BUF(kBuf),IBUF(kBuf+2),LASTAD(*),SO(*)
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
      COMMON/D/JNDX(500 000)
*
      JO(L)=ICUNP(ICASE,L)
*
*
      ISUM=JRC(ILIM)
      IOUT=0
      NMAT=0
      ICLR=NTPB
      IN=ICLR+1
      NBX=0
      IOFF=0
      DO 10 II=1,ISUM
      IF(II.GT.JRC(1))GO TO 11
      IVL=IV0
      KK=II
      GO TO 15
11    IF(II.GT.JRC(2))GO TO 12
      IVL=IV1
      KK=II-JRC(1)
      GO TO 15
12    IF(II.GT.JRC(3))GO TO 13
      IVL=IV2
      KK=II-JRC(2)
      GO TO 15
13    IVL=IV3
      KK=II-JRC(3)
15    IOUT=IOUT+1
      ICOP1(IOUT)=0
      IF(IOUT.LT.NBUF)GO TO 460
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
460   IVL0=IV0-IVL
*      IND=KK+2**16*IVL0
      IND=IOR(KK,ISHFT(IVL0,16))
      IOUT=IOUT+1
      ICOP1(IOUT)=IND
      IF(IOUT.LT.NBUF)GO TO 16
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
16    IJJ=0
      JJ=(II-1)*LN
      DO 20 I=1,LN
      JJ1=JO(JJ+I)
      DO 25 J=1,I
      IJJ=IJJ+1
      IN=IN+1
      IF(IN.LE.ICLR)GO TO 100
      IN=1
      DO 105 IIQQ=1,ICLR
      SO(IIQQ)=D0
105   CONTINUE
      NBX=NBX+1
      IADR=LASTAD(NBX)
110   CONTINUE
      IF(IADR.EQ.-1)GO TO 120
C     FPS
      CALL dDAFILE(Lu_11,2, BUF,KBUF,  IADR)
      CALL iDAFILE(Lu_11,2,IBUF,KBUF+2,IADR)
      LENGTH=IBUF(KBUF+1)
      IADR  =IBUF(KBUF+2)
      IF(LENGTH.EQ.0)GO TO 110
      DO 130 IIQQ=1,LENGTH
      IQ=IBUF(IIQQ)-IOFF
      SO(IQ)=BUF(IIQQ)
130   CONTINUE
      GO TO 110
120   IOFF=IOFF+ICLR
100   IF(JJ1.EQ.0)GO TO 25
      JJ2=JO(JJ+J)
      IF(JJ2.EQ.0)GO TO 25
      ITYP=0
      IF(I.EQ.J)ITYP=1
      IKK=IJJ
      IF(ITYP.EQ.1)IKK=I
      IF(SO(IN).EQ.D0)GO TO 25
      IOUT=IOUT+1
CPAM96      ICOP1(IOUT)=IOR(ITYP,ISHFT(IKK,1))
*      ICOP1(IOUT)=ITYP+2*IKK
      ICOP1(IOUT)=IOR(ITYP,ISHFT(IKK,1))
      COP(IOUT)=SO(IN)
      IF(IOUT.LT.NBUF)GO TO 25
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
25    CONTINUE
20    CONTINUE
10    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine IJIJ_CPF(JSY,HDIAG,FJI)

use cpf_global, only: IAD25S, IRC, IREF0, IROW, IV0, IV1, LN, LSYM, Lu_25, Lu_27, Lu_CIGuga, NNS, NSM, NSYS, NVIR, NVIRT, POTNUC
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JSY(*)
real(kind=wp), intent(_OUT_) :: HDIAG(*)
real(kind=wp), intent(in) :: FJI(*)
integer(kind=iwp) :: IAD27, IADD10, IADD25, ICHK, ICOUP, ICOUPS, IFS, II, IIJ, IIJ1, IIJ2, IJJ, INB, IND, INDI, INS, IOUT, ITYP, &
                     IVL, IVSAVE, J, JJ, KK, LENGTH, NA, NA1, NA2, NB, NB1, NB2, NSA, NSS
real(kind=wp) :: HCOUT(nCOP), TERM
integer(kind=iwp), external :: JSUNP

ICOUP = 0 ! dummy initialize
IVL = 0 ! dummy initialize
NSS = 0 ! dummy initialize

IADD25 = IAD25S
IAD27 = 0
if (IREF0 > nCOP) then
  write(u6,*) 'IJIJ_CPF Error: IREF0>nCOP (See code.)'
end if
call dDAFILE(Lu_27,2,HDIAG,IRC(1),IAD27)

IFS = 0
TERM = Zero
IVSAVE = 0
ICOUPS = 0
IOUT = 0
ICHK = 0
IADD10 = IAD10(3)

do
  ! Read a new COP buffer:
  call dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
  call iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
  LENGTH = ICOP1(nCOP+1)
  if (LENGTH == 0) cycle
  if (LENGTH < 0) exit
  ! A long loop over the COP buffer:
  do II=1,LENGTH
    IND = ICOP1(II)
    if (ICHK == 0) then
      if (IND /= 0) then
        ITYP = ibits(IND,0,1)
        IJJ = ibits(IND,1,11)
        if (ITYP == 0) TERM = COP(II)*FJI(IJJ)
        if (IVL == IV0) then

          ! IVL == IV0, Valence:
          INB = ICOUP
          HDIAG(INB) = HDIAG(INB)+TERM

        else if (IVL == IV1) then

          ! IVL == IV1, Singles:
          INB = 0
          NA1 = NSYS(NSS)+1
          NA2 = NSYS(NSS+1)
          do NA=NA1,NA2
            INB = INB+1
            if (ITYP /= 0) then
              IIJ = IROW(LN+NA)+IJJ
              TERM = COP(II)*FJI(IIJ)
            end if
            HDIAG(INB) = HDIAG(INB)+TERM
          end do

        else

          INB = 0
          ! Doubles:
          do NA=1,NVIRT
            NSA = MUL(NSS,NSM(LN+NA))
            NB1 = NSYS(NSA)+1
            NB2 = NSYS(NSA+1)
            if (NB2 > NA) NB2 = NA
            if (NB2 >= NB1) then
              IIJ1 = IROW(LN+NA)+IJJ
              do NB=NB1,NB2
                INB = INB+1
                if (ITYP /= 0) then
                  IIJ2 = IROW(LN+NB)+IJJ
                  TERM = COP(II)*(FJI(IIJ1)+FJI(IIJ2))
                end if
                HDIAG(INB) = HDIAG(INB)+TERM
              end do
            end if
          end do

        end if
      else
        ICHK = 1
      end if

    else

      ICHK = 0
      INDI = IND
      ICOUP = ibits(INDI,0,16)
      IVL = ibits(INDI,16,8)
      ICHK = 0
      INS = 1
      if (IVSAVE == IV0) then
        INS = ICOUPS
        INB = ICOUPS
      end if

      if (INB > 0) then
        ! Transfer HDIAG via buffer HCOUT, write it to unit 25:
        do J=INS,INB
          IOUT = IOUT+1
          HCOUT(IOUT) = HDIAG(J)
          if (IOUT >= nCOP) then
            ! Write out the filled HCOUT buffer:
            if (IFS /= 1) then
              POTNUC = HCOUT(IREF0)
              IFS = 1
            end if
            do KK=1,nCOP
              HCOUT(KK) = HCOUT(KK)-POTNUC
            end do
            call dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
            IOUT = 0
          end if
        end do
      end if

      if (IVL /= IV0) then
        JJ = IRC(IVL)+ICOUP
        NSS = MUL(JSUNP(JSY,JJ),LSYM)
        if (IVL == 1) INB = NVIR(NSS)
        if (IVL > 1) INB = NNS(NSS)
        if (INB > 0) call dDAFILE(Lu_27,2,HDIAG,INB,IAD27)
      end if
      IVSAVE = IVL
      ICOUPS = ICOUP

    end if
  end do
end do

! Transfer remaining HDIAG elements to 25 via buffer HCOUT:
if (INB /= 0) then

  do J=1,INB
    IOUT = IOUT+1
    HCOUT(IOUT) = HDIAG(J)
    if (IOUT >= nCOP) then
      ! Write out the filled HCOUT buffer:
      if (IFS /= 1) then
        POTNUC = HCOUT(IREF0)
        IFS = 1
      end if
      do KK=1,nCOP
        HCOUT(KK) = HCOUT(KK)-POTNUC
      end do
      call dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
      IOUT = 0
    end if
  end do

end if

! One last write of the HCOUT buffer:
if (IFS /= 1) then
  POTNUC = HCOUT(IREF0)
  IFS = 1
end if
do KK=1,IOUT
  HCOUT(KK) = HCOUT(KK)-POTNUC
end do
call dDAFILE(Lu_25,1,HCOUT,nCOP,IADD25)
write(u6,50) POTNUC

return

50 format(/,6X,'REFERENCE ENERGY',F18.8)

end subroutine IJIJ_CPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RdTraOne()
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     read the header of the transformed one-electron integral file    *
!                                                                      *
!***********************************************************************

use ccsort_global, only: nBasX, nDelX, nFroX, nSymX
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
#include "Molcas.fh"
integer(kind=iwp) :: iDisk, LuTraOne, nOrbX(8), TocTraOne(64)
real(kind=wp) :: EcorX
character(len=LenIn8), allocatable :: BsLbl(:)

LuTraOne = 3

call DaName(LuTraOne,'TRAONE')

!ulf
iDisk = 0

call mma_allocate(BsLbl,MxOrb,label='BsLbl')
call WR_MOTRA_Info(LuTraOne,2,iDisk,TocTraOne,64,EcorX,nSymX,nBasX,nOrbX,nFroX,nDelX,8,BsLbl,LenIn8*MxOrb)
call mma_deallocate(BsLbl)

call Daclos(LuTraOne)

return

end subroutine RdTraOne

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReadBas(Lhigh,makemean,bonn,breit,symmetry,sameorb,AIMP,oneonly,ncont4,numballcart,LUIN,ifinite)
! Supposed to read the maximum of l-values, the number of primitive and
! contracted functions, the exponents and contraction coefficients

use AMFI_global, only: charge, cntscrtch, Exp_finite, exponents, icore, ikeeplist, ikeeporb, incrLM, ipow2ired, ipowxyz, iredLM, &
                       iredoffunctnew, itotalperIR, Lmax, Loffunction, Moffunction, MxcontL, MxprimL, ncontrac, nprimit, &
                       nrtofiperIR, numbofsym, shiftIRED, shiftIRIR
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: Lhigh, ncont4, numballcart, ifinite
logical(kind=iwp), intent(out) :: MakeMean, Bonn, Breit, SameOrb, AIMP, OneOnly
character(len=4), intent(out) :: Symmetry
integer(kind=iwp), intent(in) :: LUIN
integer(kind=iwp) :: I, iBeginIRed(8), icart, iDelperSym(8), ILINE, inired, iorbrun, ired, ired1, ired2, iredrun, Irun, ishifter, &
                     isum, itype, JRUN, lDel, Lrun, Lval, mRun, nfunctperIRED(8), nmax, nsymrun, numbofcart, numbprev, numbr
character(len=54) :: Stars
character(len=4) :: Word
integer(kind=iwp), allocatable :: IREDoffunction(:), nfunctions(:,:), nmbMperIRL(:,:), nOff(:,:)
#ifdef _DEBUGPRINT_
character(len=21) :: chCharge
#define _TEST_ .true.
#else
#define _TEST_ .false.
#endif
logical(kind=iwp), parameter :: IfTest = _TEST_

#ifdef _DEBUGPRINT_
chCharge = '  Charge of nucleus: '
#endif
Stars = '******************************************************'
Bonn = .false.
Breit = .false.
SameOrb = .false.
AIMP = .false.
OneOnly = .false.
MakeMean = .true.
ifinite = 0

if (IfTest) then
  write(u6,'(/,/,/,24X,A)') Stars
  write(u6,'(24X,2A)') '******** Starting Atomic Spin-Orbit MF code ********'
  write(u6,'(24X,A,/,/)') Stars
end if

iCore(:) = 0
call RdNLst(LUIN,'AMFI')
do
  read(LUIN,'(A4)') Word
  if (IfTest) write(u6,'(A4)') Word
  call UpCase(Word)
  select case (WORD)
    case ('BONN')
      Bonn = .true.
    case ('BREI')
      Breit = .true.
    case ('FINI')
      iFinite = 1
      read(LUIN,*) Exp_finite
    case ('SAME')
      SameOrb = .true.
    case ('AIMP')
      AIMP = .true.
      read(LUIN,*) lDel,(iCore(I),I=0,ldel)
      if (IfTest) then
        write(u6,*)
        write(u6,*) 'CORE to be deleted '
        write(u6,*) '   L   #orbs.  '
        write(u6,*)
        do I=0,lDel
          write(u6,'(2I5)') I,iCore(I)
        end do
      end if
      exit
    case ('ONEO')
      OneOnly = .true.
      write(u6,*) ' Only one-electron integrals!!'
      write(u6,*) ' Probably useful for test-purposes only'
    case default
      exit
  end select
end do

if (IfTest) then
  write(u6,*) ' AMFI: '
  if (BONN) then
    write(u6,*) ' Bonn-approach for spin-other-orbit part'
  end if
  if (BREIT) then
    write(u6,*) ' Breit-Pauli type of the SO operator'
  else
    write(u6,*) ' Douglas-Kroll type of the SO operator'
  end if
  if (iFinite == 0) then
    write(u6,*) ' Point nucleus '
  else
    write(u6,*) ' Finite nucleus'
  end if
end if

Symmetry = 'D2H'
NumbofSym = 8
if (IfTest) then
  write(u6,*) ' Symmetry is D2H'
  if (SameOrb) then
    write(u6,*) ' Same-Orbit only'
  else
    write(u6,*) ' Other-Orbit included'
  end if
end if
read(LUIN,*) Charge,Lhigh
if (Lhigh > Lmax) then
  write(u6,*) ' Sorry, so far this code deals only with maximum l-values of ',Lmax
  call Abend()
end if
#ifdef _DEBUGPRINT_
write(u6,'(A21,F5.2)') chCharge,Charge
#endif
call InitiRed(Symmetry)
call mma_allocate(nfunctions,[1,numbofsym],[0,Lhigh],label='nfunctions')
call mma_allocate(nmbMperIRL,[1,numbofsym],[0,Lhigh],label='nmbMperIRL')
nmbMperIRL(:,:) = 0
if (IfTest) write(u6,'(/,A)') '  Used SOC basis set: '
do Lrun=0,Lhigh
  read(LUIN,*) nprimit(Lrun),ncontrac(Lrun)
  if (IfTest) then
    write(u6,'(/,A,I2,A,I2)') '  nExp: ',nprimit(Lrun),' lAng: ',lRun
    write(u6,'(I3,I3)') nprimit(Lrun),ncontrac(Lrun)
  end if
  if (nprimit(Lrun) > MxprimL) then
    write(u6,*) 'Too many primitives for L=',Lrun, &
                ' increase MxprimL in amfi_global or reduce the number of primitives to at least ',MxprimL
    call Abend()
  end if
  if (ncontrac(Lrun) > MxcontL) then
    write(u6,*) ' Too many contracted functions for L=',Lrun, &
                ' increase MxcontL in amfi_global or reduce the number of contracted functions to at most ',MxcontL
    call Abend()
  end if
  if (ncontrac(Lrun) > nprimit(Lrun)) then
    write(u6,*) ' You have more contracted than uncontracted functions, I do not believe that. Sorry! '
    call Abend()
  end if

  ! Read input in MOLCAS-style

  read(LUIN,*) (exponents(ILINE,Lrun),ILINE=1,nprimit(Lrun))
  do ILINE=1,nprimit(Lrun)
    read(LUIN,*) (cntscrtch(ILINE,JRUN,Lrun),Jrun=1,ncontrac(Lrun))
  end do

  ! End of reading for the current L-value

  if (IfTest) then
    write(u6,'(5E18.8)') (exponents(ILINE,Lrun),ILINE=1,nprimit(Lrun))
    do Irun=1,ncontrac(Lrun)
      write(u6,*) ' orbital : ',irun
      write(u6,'(6(1X,F12.7))') (cntscrtch(I,Irun,Lrun),I=1,nprimit(Lrun))
    end do
  end if

  ! Setting the numbers of cartesians per IR

  do iRedRun=1,NumbofSym
    nFunctions(iRedRun,Lrun) = 0
  end do
  do mRun=-Lrun,Lrun
    nfunctions(ipow2ired(ipowxyz(1,mrun,Lrun),ipowxyz(2,mrun,Lrun),ipowxyz(3,mrun,Lrun)),Lrun) = &
      nfunctions(ipow2ired(ipowxyz(1,mrun,Lrun),ipowxyz(2,mrun,Lrun),ipowxyz(3,mrun,Lrun)),Lrun)+ncontrac(Lrun)
  end do
  do mRun=-Lrun,Lrun
    nmbMperIRL(ipow2ired(ipowxyz(1,mrun,Lrun),ipowxyz(2,mrun,Lrun),ipowxyz(3,mrun,Lrun)),Lrun) = &
      nmbMperIRL(ipOw2ired(ipowxyz(1,mrun,Lrun),ipowxyz(2,mrun,Lrun),ipowxYz(3,mrun,Lrun)),Lrun)+1
  end do
  if (IfTest) write(u6,'(A,8I4)') ' Number of functions per IR: ',(nfunctions(iredrun,Lrun),iredrun=1,numbofsym)
end do   ! End Do for loop over L-values

if (IfTest) then
  write(u6,*) ' Distribution of M-values'
  do Lrun=0,Lhigh
    write(u6,*) nmbMperIRL(:,Lrun)
  end do
end if

numbofcart = 0
do lrun=0,Lhigh
  numbofcart = numbofcart+(Lrun+Lrun+1)*ncontrac(Lrun)
end do

call mma_allocate(nOff,numbofcart,2,Label='nOff')

nfunctperIRED(1:numbofsym) = 0
do Lrun=0,Lhigh
  nfunctperIRED(1:numbofsym) = nfunctperIRED(1:numbofsym)+nfunctions(1:numbofsym,Lrun)
end do
call mma_deallocate(nfunctions)
call mma_deallocate(nmbMperIRL)
if (IfTest) write(u6,'(A,8I3)') ' Total number of atomic functions per IRED ',(nfunctperIRED(iredrun),iredrun=1,numbofsym)
itotalperIR(1:numbofsym) = nfunctperIRED(1:numbofsym)
isum = 0
do iredrun=1,numbofsym
  isum = isum+itotalperIR(iredrun)
end do
numballcart = isum
iorbrun = 0
do iredrun=1,numbofsym
  do inired=1,itotalperIR(iredrun)
    iorbrun = iorbrun+1
    IREDoffunctnew(iorbrun) = iredrun
  end do
end do
if (IfTest) then
  write(u6,'(A,8I3)') 'including additional functions per IRED ',(itotalperIR(iredrun),iredrun=1,numbofsym)
end if
ibeginIRED(1:numbofsym) = 0
do lrun=0,Lhigh
  do mrun=-lrun,lrun
    iredLM(mrun,lrun) = ipow2ired(ipowxyz(1,mrun,Lrun),ipowxyz(2,mrun,Lrun),ipowxyz(3,mrun,Lrun))
    incrLM(mrun,lrun) = ibeginIRED(iredLM(mrun,lrun))
    ibeginIRED(iredLM(mrun,lrUn)) = ibeginIRED(iredLM(mrun,lrun))+ncontrac(lrun)
  end do
end do
if (IfTest) then
  do lrun=0,Lhigh
    write(u6,'(A,I4,A,21I3)') 'L= ',lrun,' shifts inside the IRED',(incrLM(mrun,lrun),mrun=-lrun,lrun)
  end do
end if
shiftIRED(1) = 0
do iredrun=1,numbofsym-1
  shiftIRED(iredrun+1) = shiftIRED(iredrun)+itotalperIR(iredrun)
end do
if (IfTest) then
  write(u6,'(A,8I4)') 'shifts for the IREDs ',(shiftIRED(iredrun),iredrun=1,numbofsym)
  do lrun=0,Lhigh
    do mrun=-Lrun,Lrun
      do irun=1,ncontrac(lrun)
        write(u6,*) 'L,M,contr funct, absolute number ',lrun,mrun,irun,shiftired(iredLM(mrun,lrun))+incrLM(mrun,Lrun)+irun
      end do
    end do
  end do
end if
shiftIRIR(1) = 0
irun = 1
do ired1=2,numbofsym
  do ired2=1,ired1
    irun = irun+1
    if (ired2 == 1) then
      shiftIRIR(irun) = shiftIRIR(irun-1)+(itotalperIR(ired1-1)*itotalperIR(ired1-1)+itotalperIR(ired1-1))/2
    else
      shiftIRIR(irun) = shiftIRIR(irun-1)+itotalperIR(ired1)*itotalperIR(ired2-1)
    end if
  end do
end do
call mma_allocate(IREDoffunction,numbofcart,label='IREDoffunction')
do lrun=0,Lhigh
  do Mrun=-Lrun,Lrun
    ired = iredLM(Mrun,Lrun)
    ishifter = shiftIRED(ired)+incrLM(mrun,lrun)
    do icart=1,ncontrac(Lrun)
      Moffunction(ishifter+icart) = Mrun
      Loffunction(ishifter+icart) = Lrun
      IREDoffunction(ishifter+Icart) = ired
      nOff(ishifter+Icart,2) = icart
    end do
  end do
end do
do irun=1,numbofcart
  nOff(irun,1) = irun
end do
idelpersym(1:numbofsym) = 0
nrtofiperIR(1:numbofsym) = itotalperIR(1:numbofsym)
if (AIMP) then

  ! Generate list of orbitals to be removed

  if (IfTest) write(u6,'(/,A)') '  Core removed for use with AIMP'
  ikeeporb = 0
  numbprev = 0
  do irun=1,numbofcart
    do
      if ((irun == 1) .or. ((irun >= 2) .and. (noff(irun,1) == numbprev+1))) then
        Lval = Loffunction(irun)
        numbr = nOff(irun,1)
        itype = nOff(irun,2)
        if (itype <= iCore(lval)) then
          write(u6,777) numbr,itype,lval
          idelpersym(IREDoffunction(irun)) = idelpersym(IREDoffunction(irun))+1
          numbprev = numbr
        else
          ikeeporb = ikeeporb+1
          ikeeplist(ikeeporb) = numbr
          numbprev = numbr
        end if
        exit
      end if
      ikeeporb = ikeeporb+1
      ikeeplist(ikeeporb) = numbprev+1
      numbprev = numbprev+1
    end do
  end do
  ikeeporb = 0
  nrtofiperIR(1:numbofsym) = itotalperIR(1:numbofsym)-idelpersym(1:numbofsym)
  do nsymrun=1,numbofsym
    ikeeporb = ikeeporb+nrtofiperIR(nsymrun)
  end do
  if (IfTest) then
    write(u6,'(A,8I3)') '  Number of funct. per IRED after removing core: ',(nrtofiperIR(iredrun),iredrun=1,numbofsym)
    write(u6,'(I4,A)') ikeeporb,' orbitals left after deleting core'
  end if
end if
call mma_deallocate(IREDoffunction)
nmax = max(6,ncontrac(0))
do lrun=1,Lhigh
  nmax = max(nmax,ncontrac(lrun))
end do
ncont4 = nmax*nmax*nmax*nmax

call mma_deallocate(nOff)

return

777 format('  Orbital number ',I4,' is the ',I3,'th of L-value ',I3,' it will be removed !!!')

end subroutine ReadBas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE mk_IOFF(IOFF,mSYM,NBASF,ISY12)
#include "symmul.fh"
      INTEGER IOFF(mSYM), NBASF(mSym)

C FIRST SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS OF TDMSCR
      IOF=0
      Call IZERO(IOFF,8)
      DO ISY1=1,mSYM
        ISY2=MUL(ISY1,ISY12)
        IF(ISY1.LT.ISY2) GOTO 10
        IOFF(ISY1)=IOF
        IOFF(ISY2)=IOF
        NB1=NBASF(ISY1)
        NB2=NBASF(ISY2)
        NB12=NB1*NB2
        IF(ISY1.EQ.ISY2) NB12=(NB12+NB1)/2
        IOF=IOF+NB12
  10    CONTINUE
      END DO
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ddV_(Cart,mTtAtm,Hess,iANr,iTabBonds,iTabAtoms,nBonds,nMax,nHidden)

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: nIrrep, iOper, VarR, VarT
use Slapaf_Info, only: ddV_Schlegel, iOptC, Magic_Bond
use ddvdt, only: A_Bend, A_Str, A_StrH, A_Trsn, aAV, alpha_vdW, B_Str, f_Const_Min, r_ref_vdW, rAV, rko, rkf, rkr, rkr_vdW, rkt, &
                 Rot_Const, Trans_Const
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Ten, Half, Angstrom, deg2rad
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: mTtAtm, iANr(mTtAtm), nBonds, iTabBonds(3,nBonds), nMax, iTabAtoms(2,0:nMax,mTtAtm), nHidden
real(kind=wp), intent(in) :: Cart(3,mTtAtm)
real(kind=wp), intent(out) :: Hess(nTri_Elem(3*mTtAtm))
integer(kind=iwp) :: i, iAtom, iBond, iBondType, icoor, ij, iNb0, iNb1, iNb2, iNeighbor, ir, iSym, iTest, ixyz, jAtom, jBond, &
                     jBondType, jCoor, jNeighbor, jr, kAtom, kBond, kBondType, kNeighbor, kr, lAtom, lBond, lBondType, lr, mAtom, &
                     mr, nCoBond_j, nNeighbor, nNeighbor_i, nNeighbor_j, nNeighbor_k, nOrder
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iNeg, n3, nqB, nqO, nqR, nqT
#endif
real(kind=wp) :: A35, aij, aik, ail, ajk, akl, alpha, ami, amj, beta, C(3,4), CosFi2, CosFi3, CosFi4, CosFi_Max, CosPhi, &
                 cosThetax, cosThetay, cosThetaz, Diff, dO1_dx1, dO1_dx2, dO1_dy1, dO1_dy2, dO1_dz1, dO1_dz2, dO2_dx1, dO2_dx2, &
                 dO2_dy1, dO2_dy2, dO2_dz1, dO2_dz2, dO3_dx1, dO3_dx2, dO3_dy1, dO3_dy2, dO3_dz1, dO3_dz2, Dum(1), f1, &
                 f2, f_const, f_const_min_, Fact, g_ij, g_jk, g_kl, g_vdW, g_vdW_ij, g_vdW_im, g_vdW_jk, g_vdW_jm, g_vdW_kl, gij, &
                 gim, gjm, gmm, Hxx, Hxy, Hxz, Hyy, Hyz, Hzz, r0, r0_vdW, r0_vdW_ij, r0_vdW_im, r0_vdW_jk, r0_vdW_jm, r0_vdW_kl, &
                 r0mi, r0mj, r1, Rab, RabCov, Rbc, RbcCov, rij(3), rij0, rij2, rik(3), rik0, rik2, ril(3), ril0, ril2, rjk(3), &
                 rjk0, rjk2, rkl(3), rkl0, rkl2, rL, rL2, rmi, rmi2, rmidotrmj, rmj, rmj2, RotAng, RotMat(3,3), RotVec(3), rrij, &
                 rZero, si(3), SinPhi, sj(3), sk(3), sl(3), sm(3), Tau, Test_zero, Thr_Line, ThrFi1, ThrFi2, tij, TMass, Trans(3), &
                 x(2), xij, xkl, xmi, xmj, xyz(3,4), y(2), yij, ykl, ymi, ymj, z(2), zij, zkl, zmi, zmj
logical(kind=iwp) :: Help, Invariant(3), MinBas
real(kind=wp), allocatable :: CurrXYZ(:,:), Grad(:,:,:), xMass(:)
integer(kind=iwp), external :: iTabRow, LHR, nCoBond
real(kind=wp), external :: CovRad, CovRadT, rMass
logical(kind=iwp), external :: Torsion_Check

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'ddV: nBonds=',nBonds
nqR = 0
nqB = 0
nqT = 0
nqO = 0
do iAtom=1,mTtAtm
  nNeighbor_i = iTabAtoms(1,0,iAtom)
  write(u6,*) 'iAtom,nNeighbor=',iAtom,nNeighbor_i
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
f_const_min_ = f_const_min*0.1_wp
f_const = Zero

MinBas = .false.
if (MinBas) then
  Fact = 1.3_wp
else
  Fact = One
end if
rZero = 1.0e-10_wp

Hess(:) = Zero
#ifdef _DEBUGPRINT_
n3 = 3*mTtAtm
call TriPrt(' In LNM: Hessian at start','(12f8.3)',Hess,n3)
call DiagMtrx_T(Hess,n3,iNeg)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(xMass,mTtAtm,Label='xMass')
call Get_Mass_All(xMass,mTtAtm-nHidden)
do iAtom=mTtAtm-nHidden+1,mTtAtm
  xMass(iAtom) = rMass(iANr(iAtom))
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Hessian for translational coordinates in case of a RF calculation.

if (VarT) then

  do ixyz=1,3
    Invariant(ixyz) = .false.
    iTest = 2**(ixyz-1)
    do iSym=0,nIrrep-1
      if (iOper(iSym) == iTest) Invariant(ixyz) = .true.
    end do
  end do
  if (.not. all(Invariant)) then

    Fact = One
    if (.not. VarR) Fact = 2.0e-2_wp

    TMass = sum(xMass)
    do iAtom=1,mTtAtm
      f1 = xMass(iAtom)/TMass
      do jAtom=1,iAtom-1
        f2 = xMass(jAtom)/TMass

        f_const = max(Trans_Const,f_const_Min_)
        gmm = Fact*f_const*f1*f2

        if (.not. Invariant(1)) Hess(LHR(1,iAtom,1,jAtom)) = Hess(LHR(1,iAtom,1,jAtom))+gmm
        if (.not. Invariant(2)) Hess(LHR(2,iAtom,2,jAtom)) = Hess(LHR(2,iAtom,2,jAtom))+gmm
        if (.not. Invariant(3)) Hess(LHR(3,iAtom,3,jAtom)) = Hess(LHR(3,iAtom,3,jAtom))+gmm

      end do

      f_const = max(Trans_Const,f_const_Min_)
      gmm = Fact*f_const*f1*f1

      if (.not. Invariant(1)) Hess(LHR(1,iAtom,1,iAtom)) = Hess(LHR(1,iAtom,1,iAtom))+gmm
      if (.not. Invariant(1)) Hess(LHR(2,iAtom,2,iAtom)) = Hess(LHR(2,iAtom,2,iAtom))+gmm
      if (.not. Invariant(1)) Hess(LHR(3,iAtom,3,iAtom)) = Hess(LHR(3,iAtom,3,iAtom))+gmm

    end do
#   ifdef _DEBUGPRINT_
    call TriPrt(' In LNM: Hessian after Translation','(6f12.7)',Hess,n3)
    call DiagMtrx_T(Hess,n3,iNeg)
#   endif
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Hessian for rotational coordinates

if (VarR) then

  do ixyz=1,3
    Invariant(ixyz) = .false.
    if (ixyz == 1) then
      iTest = 6
    else if (ixyz == 2) then
      iTest = 5
    else
      iTest = 3
    end if
    do iSym=0,nIrrep-1
      if (iOper(iSym) == iTest) Invariant(ixyz) = .true.
    end do
  end do
  if (.not. all(Invariant)) then

    !if (mTtAtm <= 2) then
    !  call WarningMessage(2,'Error in ddV')
    !  write(u6,*)
    !  write(u6,*) ' Warning!'
    !  write(u6,*) ' Rotational internal coordinates not implemented for fewer than 3 atoms!'
    !  write(u6,*) ' Add dummy atoms to your input and try again!'
    !  write(u6,*)
    !  call Quit(_RC_GENERAL_ERROR_)
    !end if
    call mma_allocate(Grad,3,3,mTtAtm,Label='Grad')
    call mma_allocate(CurrXYZ,3,mTtAtm,Label='CurrXYZ')
    do iAtom=1,mTtAtm
      if (iANr(iAtom) <= 0) xMass(iAtom) = 1.0e-10_wp
    end do
    nOrder = 1
    Trans(:) = Zero
    RotVec(:) = Zero
    CurrXYZ(:,:) = Cart(:,:)
    call RotDer(mTtAtm,xMass,CurrXYZ,Cart,Trans,RotAng,RotVec,RotMat,nOrder,Grad,dum)
    call mma_deallocate(CurrXYZ)

    do iAtom=1,mTtAtm
      dO1_dx1 = Grad(1,1,iAtom)
      dO2_dx1 = Grad(2,1,iAtom)
      dO3_dx1 = Grad(3,1,iAtom)
      dO1_dy1 = Grad(1,2,iAtom)
      dO2_dy1 = Grad(2,2,iAtom)
      dO3_dy1 = Grad(3,2,iAtom)
      dO1_dz1 = Grad(1,3,iAtom)
      dO2_dz1 = Grad(2,3,iAtom)
      dO3_dz1 = Grad(3,3,iAtom)
      if (Invariant(1)) then
        dO1_dx1 = Zero
        dO1_dy1 = Zero
        dO1_dz1 = Zero
      end if
      if (Invariant(2)) then
        dO2_dx1 = Zero
        dO2_dy1 = Zero
        dO2_dz1 = Zero
      end if
      if (Invariant(3)) then
        dO3_dx1 = Zero
        dO3_dy1 = Zero
        dO3_dz1 = Zero
      end if
      do jAtom=1,iAtom-1
        dO1_dx2 = Grad(1,1,jAtom)
        dO2_dx2 = Grad(2,1,jAtom)
        dO3_dx2 = Grad(3,1,jAtom)
        dO1_dy2 = Grad(1,2,jAtom)
        dO2_dy2 = Grad(2,2,jAtom)
        dO3_dy2 = Grad(3,2,jAtom)
        dO1_dz2 = Grad(1,3,jAtom)
        dO2_dz2 = Grad(2,3,jAtom)
        dO3_dz2 = Grad(3,3,jAtom)
        if (Invariant(1)) then
          dO1_dx2 = Zero
          dO1_dy2 = Zero
          dO1_dz2 = Zero
        end if
        if (Invariant(2)) then
          dO2_dx2 = Zero
          dO2_dy2 = Zero
          dO2_dz2 = Zero
        end if
        if (Invariant(3)) then
          dO3_dx2 = Zero
          dO3_dy2 = Zero
          dO3_dz2 = Zero
        end if

        f_const = max(Rot_Const,f_const_Min_)
        Hess(LHR(1,iAtom,1,jAtom)) = Hess(LHR(1,iAtom,1,jAtom))+f_const*(dO1_dx1*dO1_dx2+dO2_dx1*dO2_dx2+dO3_dx1*dO3_dx2)
        Hess(LHR(1,iAtom,2,jAtom)) = Hess(LHR(1,iAtom,2,jAtom))+f_const*(dO1_dx1*dO1_dy2+dO2_dx1*dO2_dy2+dO3_dx1*dO3_dy2)
        Hess(LHR(1,iAtom,3,jAtom)) = Hess(LHR(1,iAtom,3,jAtom))+f_const*(dO1_dx1*dO1_dz2+dO2_dx1*dO2_dz2+dO3_dx1*dO3_dz2)
        Hess(LHR(2,iAtom,1,jAtom)) = Hess(LHR(2,iAtom,1,jAtom))+f_const*(dO1_dy1*dO1_dx2+dO2_dy1*dO2_dx2+dO3_dy1*dO3_dx2)
        Hess(LHR(2,iAtom,2,jAtom)) = Hess(LHR(2,iAtom,2,jAtom))+f_const*(dO1_dy1*dO1_dy2+dO2_dy1*dO2_dy2+dO3_dy1*dO3_dy2)
        Hess(LHR(2,iAtom,3,jAtom)) = Hess(LHR(2,iAtom,3,jAtom))+f_const*(dO1_dy1*dO1_dz2+dO2_dy1*dO2_dz2+dO3_dy1*dO3_dz2)
        Hess(LHR(3,iAtom,1,jAtom)) = Hess(LHR(3,iAtom,1,jAtom))+f_const*(dO1_dz1*dO1_dx2+dO2_dz1*dO2_dx2+dO3_dz1*dO3_dx2)
        Hess(LHR(3,iAtom,2,jAtom)) = Hess(LHR(3,iAtom,2,jAtom))+f_const*(dO1_dz1*dO1_dy2+dO2_dz1*dO2_dy2+dO3_dz1*dO3_dy2)
        Hess(LHR(3,iAtom,3,jAtom)) = Hess(LHR(3,iAtom,3,jAtom))+f_const*(dO1_dz1*dO1_dz2+dO2_dz1*dO2_dz2+dO3_dz1*dO3_dz2)

      end do

      Hess(LHR(1,iAtom,1,iAtom)) = Hess(LHR(1,iAtom,1,iAtom))+f_const*(dO1_dx1*dO1_dx1+dO2_dx1*dO2_dx1+dO3_dx1*dO3_dx1)
      Hess(LHR(2,iAtom,1,iAtom)) = Hess(LHR(2,iAtom,1,iAtom))+f_const*(dO1_dy1*dO1_dx1+dO2_dy1*dO2_dx1+dO3_dy1*dO3_dx1)
      Hess(LHR(2,iAtom,2,iAtom)) = Hess(LHR(2,iAtom,2,iAtom))+f_const*(dO1_dy1*dO1_dy1+dO2_dy1*dO2_dy1+dO3_dy1*dO3_dy1)
      Hess(LHR(3,iAtom,1,iAtom)) = Hess(LHR(3,iAtom,1,iAtom))+f_const*(dO1_dz1*dO1_dx1+dO2_dz1*dO2_dx1+dO3_dz1*dO3_dx1)
      Hess(LHR(3,iAtom,2,iAtom)) = Hess(LHR(3,iAtom,2,iAtom))+f_const*(dO1_dz1*dO1_dy1+dO2_dz1*dO2_dy1+dO3_dz1*dO3_dy1)
      Hess(LHR(3,iAtom,3,iAtom)) = Hess(LHR(3,iAtom,3,iAtom))+f_const*(dO1_dz1*dO1_dz1+dO2_dz1*dO2_dz1+dO3_dz1*dO3_dz1)

    end do
    call mma_deallocate(Grad)
#   ifdef _DEBUGPRINT_
    call TriPrt(' In LNM: Hessian after Rotation','(12f12.7)',Hess,n3)
    call DiagMtrx_T(Hess,n3,iNeg)
#   endif
  end if
end if
call mma_deallocate(xMass)
!                                                                      *
!***********************************************************************
!                                                                      *
! Hessian for tension

do iBond=1,nBonds
  kAtom = iTabBonds(1,iBond)
  lAtom = iTabBonds(2,iBond)
  iBondType = iTabBonds(3,iBond)
  !if (iBondType > Magic_Bond) cycle
  kr = iTabRow(iANr(kAtom))
  lr = iTabRow(iANr(lAtom))
  Help = (kr > 3) .or. (lr > 3)
  xkl = Cart(1,kAtom)-Cart(1,lAtom)
  ykl = Cart(2,kAtom)-Cart(2,lAtom)
  zkl = Cart(3,kAtom)-Cart(3,lAtom)
  rkl2 = xkl**2+ykl**2+zkl**2

  if (ddV_Schlegel .or. Help) then
    Rab = sqrt(rkl2)
    RabCov = CovRad(iANr(kAtom))+CovRad(iANr(lAtom))
    if (((kr == 1) .and. (lr == 1)) .or. Help) then
      gmm = Fact*A_StrH(1)*exp(-A_StrH(2)*(Rab-RabCov))
    else
      ij = iTri(kr,lr)
      gmm = Fact*A_Str/(Rab-B_Str(ij))**3
    end if
  else
    r0 = rAv(kr,lr)
    alpha = aAv(kr,lr)
    gmm = rkr*exp(alpha*(r0**2-rkl2))
    if (btest(iOptC,10)) then
      r0_vdW = r_ref_vdW(kr,lr)
      g_vdW = rkr_vdW*exp(-alpha_vdW*(r0_vdW-sqrt(rkl2))**2)
    else
      g_vdW = Zero
    end if
    gmm = gmm+g_vdW
  end if

  f_const = max(gmm,f_const_Min_)
# ifdef _DEBUGPRINT_
  nqR = nqR+1
  write(u6,*) 'ddV: bonds: kAtom,lAtom=',kAtom,LAtom
  write(u6,*) '          : Bondtype=',iBondType
  !write(u6,*) gmm/rkr, f_const, g_vdW
  write(u6,*) f_const
# endif
  Hxx = f_const*xkl*xkl/rkl2
  Hxy = f_const*xkl*ykl/rkl2
  Hxz = f_const*xkl*zkl/rkl2
  Hyy = f_const*ykl*ykl/rkl2
  Hyz = f_const*ykl*zkl/rkl2
  Hzz = f_const*zkl*zkl/rkl2

  Hess(LHR(1,kAtom,1,kAtom)) = Hess(LHR(1,kAtom,1,kAtom))+Hxx
  Hess(LHR(2,kAtom,1,kAtom)) = Hess(LHR(2,kAtom,1,kAtom))+Hxy
  Hess(LHR(2,kAtom,2,kAtom)) = Hess(LHR(2,kAtom,2,kAtom))+Hyy
  Hess(LHR(3,kAtom,1,kAtom)) = Hess(LHR(3,kAtom,1,kAtom))+Hxz
  Hess(LHR(3,kAtom,2,kAtom)) = Hess(LHR(3,kAtom,2,kAtom))+Hyz
  Hess(LHR(3,kAtom,3,kAtom)) = Hess(LHR(3,kAtom,3,kAtom))+Hzz

  Hess(LHR(1,kAtom,1,lAtom)) = Hess(LHR(1,kAtom,1,lAtom))-Hxx
  Hess(LHR(1,kAtom,2,lAtom)) = Hess(LHR(1,kAtom,2,lAtom))-Hxy
  Hess(LHR(1,kAtom,3,lAtom)) = Hess(LHR(1,kAtom,3,lAtom))-Hxz
  Hess(LHR(2,kAtom,1,lAtom)) = Hess(LHR(2,kAtom,1,lAtom))-Hxy
  Hess(LHR(2,kAtom,2,lAtom)) = Hess(LHR(2,kAtom,2,lAtom))-Hyy
  Hess(LHR(2,kAtom,3,lAtom)) = Hess(LHR(2,kAtom,3,lAtom))-Hyz
  Hess(LHR(3,kAtom,1,lAtom)) = Hess(LHR(3,kAtom,1,lAtom))-Hxz
  Hess(LHR(3,kAtom,2,lAtom)) = Hess(LHR(3,kAtom,2,lAtom))-Hyz
  Hess(LHR(3,kAtom,3,lAtom)) = Hess(LHR(3,kAtom,3,lAtom))-Hzz

  Hess(LHR(1,lAtom,1,lAtom)) = Hess(LHR(1,lAtom,1,lAtom))+Hxx
  Hess(LHR(2,lAtom,1,lAtom)) = Hess(LHR(2,lAtom,1,lAtom))+Hxy
  Hess(LHR(2,lAtom,2,lAtom)) = Hess(LHR(2,lAtom,2,lAtom))+Hyy
  Hess(LHR(3,lAtom,1,lAtom)) = Hess(LHR(3,lAtom,1,lAtom))+Hxz
  Hess(LHR(3,lAtom,2,lAtom)) = Hess(LHR(3,lAtom,2,lAtom))+Hyz
  Hess(LHR(3,lAtom,3,lAtom)) = Hess(LHR(3,lAtom,3,lAtom))+Hzz

end do
#ifdef _DEBUGPRINT_
call TriPrt(' In LNM: Hessian after tension','(12f12.7)',Hess,n3)
call DiagMtrx_T(Hess,n3,iNeg)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Hessian for bending

if (nBonds >= 2) then
  do mAtom=1,mTtAtm
    mr = iTabRow(iANr(mAtom))

    nNeighbor = iTabAtoms(1,0,mAtom)
    if (nNeighbor < 2) cycle
    do iNeighbor=1,nNeighbor
      iAtom = iTabAtoms(1,iNeighbor,mAtom)
      iBond = iTabAtoms(2,iNeighbor,mAtom)
      iBondType = iTabBonds(3,iBond)
      if (iBondType > Magic_Bond) cycle
      ir = iTabRow(iANr(iAtom))

      xmi = Cart(1,iAtom)-Cart(1,mAtom)
      ymi = Cart(2,iAtom)-Cart(2,mAtom)
      zmi = Cart(3,iAtom)-Cart(3,mAtom)
      rmi2 = xmi**2+ymi**2+zmi**2
      rmi = sqrt(rmi2)

      do jNeighbor=1,iNeighbor-1
        jAtom = iTabAtoms(1,jNeighbor,mAtom)
        jBond = iTabAtoms(2,jNeighbor,mAtom)
        jBondType = iTabBonds(3,jBond)
        if (jBondType > Magic_Bond) cycle
        jr = iTabRow(iANr(jAtom))
        Help = (mr > 3) .or. (ir > 3) .or. (jr > 3)

        xmj = Cart(1,jAtom)-Cart(1,mAtom)
        ymj = Cart(2,jAtom)-Cart(2,mAtom)
        zmj = Cart(3,jAtom)-Cart(3,mAtom)
        rmj2 = xmj**2+ymj**2+zmj**2
        rmj = sqrt(rmj2)

        ! Test if zero angle

        Test_zero = xmi*xmj+ymi*ymj+zmi*zmj
        Test_zero = Test_zero/(rmi*rmj)
        if (abs(Test_zero-One) < 1.0e-12_wp) cycle

        xij = Cart(1,jAtom)-Cart(1,iAtom)
        yij = Cart(2,jAtom)-Cart(2,iAtom)
        zij = Cart(3,jAtom)-Cart(3,iAtom)
        rij2 = xij**2+yij**2+zij**2
        rrij = sqrt(rij2)

        if (ddV_Schlegel .or. Help) then
          Rab = rmi
          RabCov = CovRad(iANr(iAtom))+CovRad(iANr(mAtom))
          Rbc = rmj
          RbcCov = CovRad(iANr(jAtom))+CovRad(iANr(mAtom))
          if ((ir == 1) .or. (jr == 1)) then
            gij = Fact*A_Bend(1)
          else
            gij = Fact*A_Bend(2)
          end if
        else
          r0mi = rAv(mr,ir)
          ami = aAv(mr,ir)
          r0mj = rAv(mr,jr)
          amj = aAv(mr,jr)
          gim = exp(ami*(r0mi**2-rmi2))
          gjm = exp(amj*(r0mj**2-rmj2))
          if (btest(iOptC,10)) then
            r0_vdW_im = r_ref_vdW(ir,mr)
            g_vdW_im = exp(-alpha_vdW*(r0_vdW_im-sqrt(rmi2))**2)
            r0_vdW_jm = r_ref_vdW(jr,mr)
            g_vdW_jm = exp(-alpha_vdW*(r0_vdW_jm-sqrt(rmj2))**2)
          else
            g_vdW_im = Zero
            g_vdW_jm = Zero
          end if
          g_vdW_im = g_vdW_im*rkr_vdW/rkr
          g_vdW_jm = g_vdW_jm*rkr_vdW/rkr
          gim = gim+Half*g_vdW_im
          gjm = gjm+Half*g_vdW_jm
          gij = rkf*gim*gjm
        end if
        rL2 = (ymi*zmj-zmi*ymj)**2+(zmi*xmj-xmi*zmj)**2+(xmi*ymj-ymi*xmj)**2
        !hjw modified
        if (rL2 < 1.0e-14_wp) then
          rL = Zero
        else
          rL = sqrt(rL2)
        end if
        gij = max(gij,f_const_Min_)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'iAtom,mAtom,jAtom=',iAtom,mAtom,jAtom
        write(u6,*) 'gij=',gij
        write(u6,*) 'rmj=',rmj
        write(u6,*) 'rmi=',rmi
        write(u6,*) 'rrij=',rrij
#       endif

        if ((rmj > rZero) .and. (rmi > rZero) .and. (rrij > rZero)) then
#         ifdef _DEBUGPRINT_
          nqB = nqB+1
#         endif
          SinPhi = rL/(rmj*rmi)
          rmidotrmj = xmi*xmj+ymi*ymj+zmi*zmj
          CosPhi = rmidotrmj/(rmj*rmi)

          ! Non-linear case

          Thr_Line = sin(25.0_wp*deg2rad)
          if (mTtAtm == 3) Thr_Line = rZero
          if (SinPhi > Thr_Line) then
            si(1) = (xmi/rmi*cosphi-xmj/rmj)/(rmi*sinphi)
            si(2) = (ymi/rmi*cosphi-ymj/rmj)/(rmi*sinphi)
            si(3) = (zmi/rmi*cosphi-zmj/rmj)/(rmi*sinphi)
            sj(1) = (cosphi*xmj/rmj-xmi/rmi)/(rmj*sinphi)
            sj(2) = (cosphi*ymj/rmj-ymi/rmi)/(rmj*sinphi)
            sj(3) = (cosphi*zmj/rmj-zmi/rmi)/(rmj*sinphi)
            sm(1) = -si(1)-sj(1)
            sm(2) = -si(2)-sj(2)
            sm(3) = -si(3)-sj(3)
            do icoor=1,3
              do jCoor=1,3
                if (mAtom > iAtom) then
                  Hess(LHR(icoor,mAtom,jcoor,iAtom)) = Hess(LHR(icoor,mAtom,jcoor,iAtom))+gij*sm(icoor)*si(jcoor)
                else
                  Hess(LHR(icoor,iAtom,jcoor,mAtom)) = Hess(LHR(icoor,iAtom,jcoor,mAtom))+gij*si(icoor)*sm(jcoor)
                end if
                if (mAtom > jAtom) then
                  Hess(LHR(icoor,mAtom,jcoor,jAtom)) = Hess(LHR(icoor,mAtom,jcoor,jAtom))+gij*sm(icoor)*sj(jcoor)
                else
                  Hess(LHR(icoor,jAtom,jcoor,mAtom)) = Hess(LHR(icoor,jAtom,jcoor,mAtom))+gij*sj(icoor)*sm(jcoor)
                end if
                if (iAtom > jAtom) then
                  Hess(LHR(icoor,iAtom,jcoor,jAtom)) = Hess(LHR(icoor,iAtom,jcoor,jAtom))+gij*si(icoor)*sj(jcoor)
                else
                  Hess(LHR(icoor,jAtom,jcoor,iAtom)) = Hess(LHR(icoor,jAtom,jcoor,iAtom))+gij*sj(icoor)*si(jcoor)
                end if
              end do
            end do
            do icoor=1,3
              do jCoor=1,icoor
                Hess(LHR(icoor,iAtom,jcoor,iAtom)) = Hess(LHR(icoor,iAtom,jcoor,iAtom))+gij*si(icoor)*si(jcoor)
                Hess(LHR(icoor,mAtom,jcoor,mAtom)) = Hess(LHR(icoor,mAtom,jcoor,mAtom))+gij*sm(icoor)*sm(jcoor)
                Hess(LHR(icoor,jAtom,jcoor,jAtom)) = Hess(LHR(icoor,jAtom,jcoor,jAtom))+gij*sj(icoor)*sj(jcoor)

              end do
            end do
          else

            ! Linear case

            if ((abs(ymi) > rZero) .or. (abs(xmi) > rZero)) then
              x(1) = -ymi
              y(1) = xmi
              z(1) = Zero
              x(2) = -xmi*zmi
              y(2) = -ymi*zmi
              z(2) = xmi*xmi+ymi*ymi
            else
              x(1) = One
              y(1) = Zero
              z(1) = Zero
              x(2) = Zero
              y(2) = One
              z(2) = Zero
            end if
#           ifdef _DEBUGPRINT_
            nqB = nqB+2
#           endif
            do i=1,2
              r1 = sqrt(x(i)**2+y(i)**2+z(i)**2)
              cosThetax = x(i)/r1
              cosThetay = y(i)/r1
              cosThetaz = z(i)/r1
              si(1) = -cosThetax/rmi
              si(2) = -cosThetay/rmi
              si(3) = -cosThetaz/rmi
              sj(1) = -cosThetax/rmj
              sj(2) = -cosThetay/rmj
              sj(3) = -cosThetaz/rmj
              sm(1) = -(si(1)+sj(1))
              sm(2) = -(si(2)+sj(2))
              sm(3) = -(si(3)+sj(3))

              do icoor=1,3
                do jCoor=1,3
                  if (mAtom > iAtom) then
                    Hess(LHR(icoor,mAtom,jcoor,iAtom)) = Hess(LHR(icoor,mAtom,jcoor,iAtom))+gij*sm(icoor)*si(jcoor)
                  else
                    Hess(LHR(icoor,iAtom,jcoor,mAtom)) = Hess(LHR(icoor,iAtom,jcoor,mAtom))+gij*si(icoor)*sm(jcoor)
                  end if
                  if (mAtom > jAtom) then
                    Hess(LHR(icoor,mAtom,jcoor,jAtom)) = Hess(LHR(icoor,mAtom,jcoor,jAtom))+gij*sm(icoor)*sj(jcoor)
                  else
                    Hess(LHR(icoor,jAtom,jcoor,mAtom)) = Hess(LHR(icoor,jAtom,jcoor,mAtom))+gij*sj(icoor)*sm(jcoor)
                  end if
                  if (iAtom > jAtom) then
                    Hess(LHR(icoor,iAtom,jcoor,jAtom)) = Hess(LHR(icoor,iAtom,jcoor,jAtom))+gij*si(icoor)*sj(jcoor)
                  else
                    Hess(LHR(icoor,jAtom,jcoor,iAtom)) = Hess(LHR(icoor,jAtom,jcoor,iAtom))+gij*sj(icoor)*si(jcoor)
                  end if
                end do
              end do
              do icoor=1,3
                do jCoor=1,icoor
                  Hess(LHR(icoor,iAtom,jcoor,iAtom)) = Hess(LHR(icoor,iAtom,jcoor,iAtom))+gij*si(icoor)*si(jcoor)
                  Hess(LHR(icoor,mAtom,jcoor,mAtom)) = Hess(LHR(icoor,mAtom,jcoor,mAtom))+gij*sm(icoor)*sm(jcoor)
                  Hess(LHR(icoor,jAtom,jcoor,jAtom)) = Hess(LHR(icoor,jAtom,jcoor,jAtom))+gij*sj(icoor)*sj(jcoor)
                end do
              end do
            end do
          end if
        end if

      end do
    end do
  end do
# ifdef _DEBUGPRINT_
  call TriPrt(' In LNM: Hessian after bending','(12f12.7)',Hess,n3)
  call DiagMtrx_T(Hess,n3,iNeg)
# endif
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Hessian for torsion

if (nBonds >= 3) then
  do iBond=1,nBonds
    jAtom = iTabBonds(1,iBond)
    kAtom = iTabBonds(2,iBond)
    iBondType = iTabBonds(3,iBond)
    Fact = One
    if (iBondType > Magic_Bond) Fact = Two
#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) '*',jAtom,kAtom,' *'
    write(u6,*)
    write(u6,*) 'BondType=',iBondType
#   endif

    ! Allow center bond to be a "magic" bond

    !if (iBondType == vdW_Bond) cycle

    jr = iTabRow(iANr(jAtom))
    kr = iTabRow(iANr(kAtom))

    xyz(:,2) = Cart(:,jAtom)
    xyz(:,3) = Cart(:,kAtom)

    nNeighbor_j = iTabAtoms(1,0,jAtom)
    if (nNeighbor_j < 2) cycle
    nNeighbor_k = iTabAtoms(1,0,kAtom)
    if (nNeighbor_k < 2) cycle

    do jNeighbor=1,nNeighbor_j
      iAtom = iTabAtoms(1,jNeighbor,jAtom)
#     ifdef _DEBUGPRINT_
      !write(u6,*)
      !write(u6,*) iAtom,jAtom,kAtom,' *'
      !write(u6,*)
#     endif
      jBond = iTabAtoms(2,jNeighbor,jAtom)
      if (iBond == jBond) cycle
      jBondType = iTabBonds(3,jBond)
      !if (jBondType == vdW_Bond) cycle
      if (jBondType > Magic_Bond) cycle
      ir = iTabRow(iANr(iAtom))

      xyz(:,1) = Cart(:,iAtom)

      do kNeighbor=1,nNeighbor_k
        lAtom = iTabAtoms(1,kNeighbor,kAtom)
        kBond = iTabAtoms(2,kNeighbor,kAtom)
        if (iBond == kBond) cycle
        if (lAtom == iAtom) cycle
        kBondType = iTabBonds(3,kBond)
        !if (kBondType == vdW_Bond) cycle
        if (kBondType > Magic_Bond) cycle
        lr = iTabRow(iANr(lAtom))
        Help = (kr > 3) .or. (ir > 3) .or. (jr > 3) .or. (lr > 3)

        xyz(:,4) = Cart(:,lAtom)

        rij(1) = Cart(1,iAtom)-Cart(1,jAtom)
        rij(2) = Cart(2,iAtom)-Cart(2,jAtom)
        rij(3) = Cart(3,iAtom)-Cart(3,jAtom)
        rij2 = rij(1)**2+rij(2)**2+rij(3)**2

        rjk(1) = Cart(1,jAtom)-Cart(1,kAtom)
        rjk(2) = Cart(2,jAtom)-Cart(2,kAtom)
        rjk(3) = Cart(3,jAtom)-Cart(3,kAtom)
        rjk2 = rjk(1)**2+rjk(2)**2+rjk(3)**2

        rkl(1) = Cart(1,kAtom)-Cart(1,lAtom)
        rkl(2) = Cart(2,kAtom)-Cart(2,lAtom)
        rkl(3) = Cart(3,kAtom)-Cart(3,lAtom)
        rkl2 = rkl(1)**2+rkl(2)**2+rkl(3)**2

        ! Allow only angles in the range of 35-145
        A35 = 35.0_wp*deg2rad
        CosFi_Max = cos(A35)
        CosFi2 = (rij(1)*rjk(1)+rij(2)*rjk(2)+rij(3)*rjk(3))/sqrt(rij2*rjk2)
        if (abs(CosFi2) > CosFi_Max) cycle
        CosFi3 = (rkl(1)*rjk(1)+rkl(2)*rjk(2)+rkl(3)*rjk(3))/sqrt(rkl2*rjk2)
        if (abs(CosFi3) > CosFi_Max) cycle
#       ifdef _DEBUGPRINT_
        write(u6,*) 'CosFi2,CosFi3=',CosFi2,CosFi3
        write(u6,*) 'rij=',rij,rij2
        write(u6,*) 'rjk=',rjk,rjk2
        write(u6,*) 'rkl=',rkl,rkl2
#       endif

        if (ddV_Schlegel .or. Help) then
          Rab = sqrt(rij2)
          RabCov = (CovRadT(iANr(iAtom))+CovRadT(iANr(jAtom)))/Angstrom
          Rbc = sqrt(rjk2)/Fact
          RbcCov = (CovRadT(iANr(jAtom))+CovRadT(iANr(kAtom)))/Angstrom
          Diff = RbcCov-Rbc
          if (Diff < Zero) Diff = Zero
          tij = Fact*A_Trsn(1)+A_Trsn(2)*Diff
        else
          rij0 = rAv(ir,jr)**2
          aij = aAv(ir,jr)
          rjk0 = rAv(jr,kr)**2
          ajk = aAv(jr,kr)
          rkl0 = rAv(kr,lr)**2
          akl = aAv(kr,lr)
          ! Magic bond fix
          rjk2 = rjk2/Fact**2

          g_ij = exp(aij*(rij0-rij2))
          g_jk = exp(ajk*(rjk0-rjk2))
          g_kl = exp(akl*(rkl0-rkl2))
          if (btest(iOptC,10)) then
            r0_vdW_ij = r_ref_vdW(ir,jr)
            g_vdW_ij = exp(-alpha_vdW*(r0_vdW_ij-sqrt(rij2))**2)
            r0_vdW_jk = r_ref_vdW(jr,kr)
            g_vdW_jk = exp(-alpha_vdW*(r0_vdW_jk-sqrt(rjk2))**2)
            r0_vdW_kl = r_ref_vdW(kr,lr)
            g_vdW_kl = exp(-alpha_vdW*(r0_vdW_kl-sqrt(rkl2))**2)
          else
            g_vdW_ij = Zero
            g_vdW_jk = Zero
            g_vdW_kl = Zero
          end if
          g_vdW_ij = g_vdW_ij*rkr_vdW/rkr
          g_vdW_jk = g_vdW_jk*rkr_vdW/rkr
          g_vdW_kl = g_vdW_kl*rkr_vdW/rkr
          g_ij = g_ij+Half*g_vdW_ij
          g_jk = g_jk+Half*g_vdW_jk
          g_kl = g_kl+Half*g_vdW_kl
          tij = rkt*g_ij*g_jk*g_kl
        end if
        tij = max(tij,f_const_Min_)
        if (Torsion_Check(iAtom,jAtom,kAtom,lAtom,xyz,iTabAtoms,nMax,mTtAtm)) tij = max(tij,Ten*f_const_Min_)
#       ifdef _DEBUGPRINT_
        nqT = nqT+1
        write(u6,*)
        write(u6,*) iAtom,jAtom,kAtom,lAtom
        write(u6,*) tij
#       endif

        call Trsn(xyz,4,Tau,C,.false.,.false.,'        ',Dum,.false.)
        si(:) = C(:,1)
        sj(:) = C(:,2)
        sk(:) = C(:,3)
        sl(:) = C(:,4)
#       ifdef _DEBUGPRINT_
        !call RecPrt('C',' ',C,3,4)
#       endif

        ! Off diagonal block

        do icoor=1,3
          do jCoor=1,3
            Hess(LHR(icoor,iAtom,jcoor,jAtom)) = Hess(LHR(icoor,iAtom,jcoor,jAtom))+tij*si(icoor)*sj(jcoor)
            Hess(LHR(icoor,iAtom,jcoor,kAtom)) = Hess(LHR(icoor,iAtom,jcoor,kAtom))+tij*si(icoor)*sk(jcoor)
            Hess(LHR(icoor,iAtom,jcoor,lAtom)) = Hess(LHR(icoor,iAtom,jcoor,lAtom))+tij*si(icoor)*sl(jcoor)
            Hess(LHR(icoor,jAtom,jcoor,kAtom)) = Hess(LHR(icoor,jAtom,jcoor,kAtom))+tij*sj(icoor)*sk(jcoor)
            Hess(LHR(icoor,jAtom,jcoor,lAtom)) = Hess(LHR(icoor,jAtom,jcoor,lAtom))+tij*sj(icoor)*sl(jcoor)
            Hess(LHR(icoor,kAtom,jcoor,lAtom)) = Hess(LHR(icoor,kAtom,jcoor,lAtom))+tij*sk(icoor)*sl(jcoor)

          end do
        end do

        ! Diagonal block

        do icoor=1,3
          do jCoor=1,icoor
            Hess(LHR(icoor,iAtom,jcoor,iAtom)) = Hess(LHR(icoor,iAtom,jcoor,iAtom))+tij*si(icoor)*si(jcoor)
            Hess(LHR(icoor,jAtom,jcoor,jAtom)) = Hess(LHR(icoor,jAtom,jcoor,jAtom))+tij*sj(icoor)*sj(jcoor)
            Hess(LHR(icoor,kAtom,jcoor,kAtom)) = Hess(LHR(icoor,kAtom,jcoor,kAtom))+tij*sk(icoor)*sk(jcoor)
            Hess(LHR(icoor,lAtom,jcoor,lAtom)) = Hess(LHR(icoor,lAtom,jcoor,lAtom))+tij*sl(icoor)*sl(jcoor)

          end do
        end do

      end do          ! iNeigbor_k
    end do            ! iNeighbor_j
  end do              ! iBonds
# ifdef _DEBUGPRINT_
  call TriPrt(' In LNM: Hessian after torsion','(12f12.7)',Hess,n3)
  call DiagMtrx_T(Hess,n3,iNeg)
# endif
end if
!                                                                      *
!***********************************************************************
!                                                                      *
!                                  k
!                                 /
! Hessian for out-of-plane   j - i
!                                 \
!                                  l

!if (.false.) then
if (nBonds >= 3) then

  do iAtom=1,mTtAtm

    nNeighbor_i = iTabAtoms(1,0,iAtom)
    !write(u6,*) 'iAtom,nNeighbor_i=',iAtom,nNeighbor_i
    if (nNeighbor_i < 3) cycle
    ir = iTabRow(iANr(iAtom))
    xyz(:,4) = Cart(:,iAtom)

    do iNb0=1,nNeighbor_i
      jAtom = iTabAtoms(1,iNb0,iAtom)
      !write(u6,*) 'jAtom=',jAtom
      jr = iTabRow(iANr(jAtom))
      iBond = iTabAtoms(2,iNb0,iAtom)
      iBondType = iTabBonds(3,iBond)
      !write(u6,*) 'iBondType=',iBondType
      nCoBond_j = nCoBond(jAtom,mTtAtm,nMax,iTabBonds,nBonds,iTabAtoms)
      if (nCoBond_j > 1) cycle
      !if (iBondType == vdW_Bond) cycle
      if (iBondType > Magic_Bond) cycle
      xyz(:,1) = Cart(:,jAtom)

      do iNb1=1,nNeighbor_i
        kAtom = iTabAtoms(1,iNb1,iAtom)
        !write(u6,*) 'kAtom=',kAtom
        kBond = iTabAtoms(2,iNb1,iAtom)
        if (kAtom == jAtom) cycle
        kBondType = iTabBonds(3,kBond)
        !write(u6,*) 'kBondType=',kBondType
        !if (kBondType == vdW_Bond) cycle
        if (kBondType > Magic_Bond) cycle
        kr = iTabRow(iANr(kAtom))

        xyz(:,2) = Cart(:,kAtom)

        do iNb2=1,nNeighbor_i
          lAtom = iTabAtoms(1,iNb2,iAtom)
          !write(u6,*) 'lAtom=',lAtom
          lBond = iTabAtoms(2,iNb2,iAtom)

          if (lAtom == jAtom) cycle
          if (lAtom <= kAtom) cycle
          lBondType = iTabBonds(3,lBond)
          !write(u6,*) 'lBondType=',lBondType
          !if (lBondType == vdW_Bond) cycle
          if (lBondType > Magic_Bond) cycle
          lr = iTabRow(iANr(lAtom))
          Help = (kr > 3) .or. (ir > 3) .or. (jr > 3) .or. (lr > 3)

          !Write(u6,*) 'i,j,k,l=',iAtom,jAtom,kAtom,lAtom
          !Write(u6,*) 'Help=',Help

          xyz(:,3) = Cart(:,lAtom)

          rij(:) = Cart(:,iAtom)-Cart(:,jAtom)

          rik(:) = Cart(:,iAtom)-Cart(:,kAtom)

          ril(:) = Cart(:,iAtom)-Cart(:,lAtom)

          rij2 = rij(1)**2+rij(2)**2+rij(3)**2
          rik2 = rik(1)**2+rik(2)**2+rik(3)**2
          ril2 = ril(1)**2+ril(2)**2+ril(3)**2

          ThrFi1 = cos(90.0_wp*deg2rad)
          ThrFi2 = cos(150.0_wp*deg2rad)
          CosFi2 = (rij(1)*rik(1)+rij(2)*rik(2)+rij(3)*rik(3))/sqrt(rij2*rik2)
          if ((CosFi2 > ThrFi1) .or. (CosFi2 < ThrFi2)) cycle

          CosFi3 = (rij(1)*ril(1)+rij(2)*ril(2)+rij(3)*ril(3))/sqrt(rij2*ril2)
          if ((CosFi3 > ThrFi1) .or. (CosFi3 < ThrFi2)) cycle

          CosFi4 = (rik(1)*ril(1)+rik(2)*ril(2)+rik(3)*ril(3))/sqrt(rik2*ril2)
          if ((CosFi4 > ThrFi1) .or. (CosFi4 < ThrFi2)) cycle
#         ifdef _DEBUGPRINT_
          write(u6,*) 'CosFi2,CosFi3,CosFi4=',CosFi2,CosFi3,CosFi4
#         endif

          if (ddV_Schlegel .or. Help) then

            ! I do not have a clue to how this will really work!

            tij = f_const_Min_
          else
            rij0 = rAv(ir,jr)**2
            aij = aAv(ir,jr)
            rik0 = rAv(ir,kr)**2
            aik = aAv(ir,kr)
            ril0 = rAv(ir,lr)**2
            ail = aAv(ir,lr)
            beta = rko*exp((aij*rij0+aik*rik0+ail*ril0))
            tij = beta*exp(-(aij*rij2+aik*rik2+ail*ril2))
          end if
          !tij = max(tij,f_const_Min_)

          call OutofP(xyz,4,Tau,C,.false.,.false.,'        ',Dum,.false.)
          if (abs(Tau) > 25.0_wp*deg2rad) cycle
#         ifdef _DEBUGPRINT_
          nqO = nqO+1
#         endif

          si(:) = C(:,4)
          sj(:) = C(:,1)
          sk(:) = C(:,2)
          sl(:) = C(:,3)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'iAtoms=',iAtom,jAtom,kAtom,lAtom
          write(u6,*) 'tij,Tau=',tij,Tau
          !call RecPrt('si',' ',si,1,3)
          !call RecPrt('sj',' ',sj,1,3)
          !call RecPrt('sk',' ',sk,1,3)
          !call RecPrt('sl',' ',sl,1,3)
#         endif

          ! Off diagonal block

          do icoor=1,3
            do jCoor=1,3
              Hess(LHR(icoor,iAtom,jcoor,jAtom)) = Hess(LHR(icoor,iAtom,jcoor,jAtom))+tij*si(icoor)*sj(jcoor)
              Hess(LHR(icoor,iAtom,jcoor,kAtom)) = Hess(LHR(icoor,iAtom,jcoor,kAtom))+tij*si(icoor)*sk(jcoor)
              Hess(LHR(icoor,iAtom,jcoor,lAtom)) = Hess(LHR(icoor,iAtom,jcoor,lAtom))+tij*si(icoor)*sl(jcoor)
              Hess(LHR(icoor,jAtom,jcoor,kAtom)) = Hess(LHR(icoor,jAtom,jcoor,kAtom))+tij*sj(icoor)*sk(jcoor)
              Hess(LHR(icoor,jAtom,jcoor,lAtom)) = Hess(LHR(icoor,jAtom,jcoor,lAtom))+tij*sj(icoor)*sl(jcoor)
              Hess(LHR(icoor,kAtom,jcoor,lAtom)) = Hess(LHR(icoor,kAtom,jcoor,lAtom))+tij*sk(icoor)*sl(jcoor)

            end do
          end do

          ! Diagonal block

          do icoor=1,3
            do jCoor=1,icoor
              Hess(LHR(icoor,iAtom,jcoor,iAtom)) = Hess(LHR(icoor,iAtom,jcoor,iAtom))+tij*si(icoor)*si(jcoor)
              Hess(LHR(icoor,jAtom,jcoor,jAtom)) = Hess(LHR(icoor,jAtom,jcoor,jAtom))+tij*sj(icoor)*sj(jcoor)
              Hess(LHR(icoor,kAtom,jcoor,kAtom)) = Hess(LHR(icoor,kAtom,jcoor,kAtom))+tij*sk(icoor)*sk(jcoor)
              Hess(LHR(icoor,lAtom,jcoor,lAtom)) = Hess(LHR(icoor,lAtom,jcoor,lAtom))+tij*sl(icoor)*sl(jcoor)

            end do
          end do

        end do        ! iNb2
      end do          ! iNb1
    end do            ! iCase
  end do              ! iBond
# ifdef _DEBUGPRINT_
  call TriPrt(' In LNM: Hessian after out-of-plane','(12f12.7)',Hess,n3)
  call DiagMtrx_T(Hess,n3,iNeg)
# endif
end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'ddV: nqR, nqB, nqT, nqO=',nqR,nqB,nqT,nqO
#endif

return

end subroutine ddV_

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine IniTim()
      Use Para_Info, Only: nProcs
      Implicit None
#include "WrkSpc.fh"
#include "timtra.fh"
*
      if(nfld_tim.eq.0) return
      if(nfld_tim.gt.nfldmax) then
        Call WarningMessage(2,'Too many fields in IniTim')
        Write(6,*) 'nfld_tim:',nfld_tim
        call Abend()
      end if
      Call GetMem('iGATim','Allo','Real',iGATim,nProcs*nfld_tim*2)
      call Fzero(Work(iGATim),nProcs*nfld_tim*2)
      Return
      End
      SubRoutine IniStat()
      Use Para_Info, Only: nProcs
      Implicit None
#include "WrkSpc.fh"
#include "timtra.fh"
*
      if(nfld_stat.eq.0) return
      if(nfld_stat.gt.nfldmax) then
        Call WarningMessage(2,'Too many fields in IniStat')
        Write(6,*) 'nfld_stat:',nfld_stat
        call Abend()
      end if
      Call GetMem('iGAStat','Allo','Real',iGAStat,nProcs*nfld_stat)
      call Fzero(Work(iGAStat),nProcs*nfld_stat)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine expand4_12(AA,BB,d1,d2,d3)
! this routine does:
!
! A(ab,i,j) -> A(a,b,i,j)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: d1, d2, d3
real(kind=wp), intent(in) :: AA(nTri_Elem(d1),d2,d3)
real(kind=wp), intent(out) :: BB(d1,d1,d2,d3)
integer(kind=iwp) :: a, ab, b, i

ab = 0
do a=1,d1
  do b=1,a-1
    ab = ab+1
    BB(a,b,:,:) = AA(ab,:,:)
    do i=1,d2
      BB(b,a,:,i) = AA(ab,i,:)
    end do
  end do
  ab = ab+1
  BB(a,a,:,:) = AA(ab,:,:)
end do

return

end subroutine expand4_12

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Naoki Nakatani                                   *
************************************************************************
      Subroutine BlockCtl(LW1,TUVX,IFINAL,IRST)
************************************************************************
*                                                                      *
*     Description                                                      *
*                                                                      *
*     This is an alternative of DavCtl for DMRG-CASSCF in DMRGCtl      *
*                                                                      *
************************************************************************
*                                                                      *
*     DMRG control section                                             *
*                                                                      *
*     calling arguments:                                               *
*     LW1     : Memory pointer to active Fock matrix                   *
*               array of real*8                                        *
*     TUVX    : array of real*8                                        *
*               two-electron integrals (tu!vx)                         *
*     IFINAL  : integer                                                *
*               termination flag                                       *
*     IRST    : integer                                                *
*               restart flag of DMRG                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     N. Nakatani, Hokkaido University, Japan, 2014                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension LW1(*), TUVX(*)

      Integer iChMolpro(8)
      Character*3 Label

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='BLOCKCTL')

* Load symmetry info from RunFile
      Call Get_iScalar('NSYM',nIrrep)
      Call Get_iArray('Symmetry operations',iOper,nIrrep)
      Call Get_iScalar('Rotational Symmetry Number',iSigma)

* Get character table to convert MOLPRO symmetry format
      Call MOLPRO_ChTab(nSym,Label,iChMolpro)

* Convert orbital symmetry into MOLPOR format
      Call Getmem('OrbSym','Allo','Inte',lOrbSym,NAC)
      iOrb=1
      Do iSym=1,nSym
        Do jOrb=1,NASH(iSym)
          iWork(lOrbSym+iOrb-1)=iChMolpro(iSym)
          iOrb=iOrb+1
        End Do
      End Do
      lSymMolpro=iChMolpro(lSym)

      NRDM_ORDER=2
      If (NACTEL.EQ.1) NRDM_ORDER=1

* Default setting for the first iteraction
      JRST=IRST
      ThDMRG=THRE*1.0d1
      ThNoise=1.0d-4

      If (JRST.NE.0) Then
        If (IFINAL.EQ.0) Then
          If (ABS(ROTMAX).GE.1.0d-1) Then
* No restart
            JRST=0
            ThDMRG=THRE*1.0d1
            ThNoise=1.0d-4
          Else If (ABS(ROTMAX).GE.0.5d-1) Then
* Full-restart with noise
            JRST=2
            ThDMRG=THRE*5.0d0
            ThNoise=1.0d-5
          Else If (ABS(ROTMAX).GE.0.1d-1) Then
* Full-restart with smaller noise
            JRST=2
            ThDMRG=THRE
            ThNoise=1.0d-6
          Else
* Restart without noise
            JRST=1
            ThDMRG=THRE
            ThNoise=0.0d0
          End If
        Else If (IFINAL.EQ.1) Then
* Full-restart for CI-only
          JRST=2
          ThDMRG=THRE
          ThNoise=1.0d-6
        Else
* Full-restart for the final wavefunction
          If (iOrbTyp.EQ.2) Then
* with OutOrb = Canonical, this will be problematic for LMO-DMRG calc.
            JRST=2
            ThDMRG=THRE
            ThNoise=1.0d-6
          Else
* by default, just restarting
            JRST=1
            ThDMRG=THRE
            ThNoise=0.0d0
          End If
        End If
      End If

* In the following calls the extra array HFOCC has been passed
* from Molcas to Block to have a user customized reference det.
* This change must be done accordingly into the block code.
* In particular, in file molcas/block_calldmrg.C:
* line~23:  const char* hf_occ)
* line~24:  block_calldmrg(*Restart, *N_roots, *N_act, *N_elec, *M_s, Sym, *iSym, OrbSym, *E_core, h0, tuvx, *M_state, *N_pdm, *T_sweep, *T_noise, E_sweep, hf_occ);
* line~63:  const char* hf_occ)
* line~186: fcon << "hf_occ " << hf_occ << endl;
*
* In molcas/block_calldmrg.h:
* line~25:  const char* hf_occ);
* line~46:  const char* hf_occ);


* Compute DMRG
      Call block_calldmrg(JRST,lRoots,NAC,NACTEL,ISPIN-1,
     &                    Label,lSymMolpro,iWork(lOrbSym),
     &                    0.0d0,LW1,TUVX,MxDMRG,NRDM_ORDER,
     &                    ThDMRG,ThNoise,ENER(1,ITER),HFOCC,NRS2T)

      If (IFINAL.EQ.2 .AND. Do3RDM .AND. NACTEL.GT.2) Then
* Compute 3RDM for DMRG-cu4-CASPT2
        Call block_calldmrg(1,lRoots,NAC,NACTEL,ISPIN-1,
     &                      Label,lSymMolpro,iWork(lOrbSym),
     &                      0.0d0,LW1,TUVX,MxDMRG,3,
     &                      THRE,0.0d0,ENER(1,ITER),HFOCC,NRS2T)
      End If

      Call Getmem('OrbSym','Free','Inte',lOrbSym,NAC)


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Hess_Tra(Hss_X,nDim,Degen,BMx,nInter,Hss_Q)
      Implicit Real*8 (a-h,o-z)
      Real*8 Hss_X(nDim*nDim), Degen(nDim), BMx(nDim,nInter),
     &       Hss_Q(nInter*nInter)
#include "real.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: X(:), XT(:)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the Hessian matrix in Internal Cartesian Coordinates
*     by solving:
*
*     d^2E/dx^2 = dQ/dx d^2E/dQ^2 dQ/dx
*
      Do j = 1, nDim
         Do i = 1, nDim
            ij = (j-1)*nDim + i
            Hss_X(ij) = Hss_X(ij) / Sqrt(Degen(i)*Degen(j))
         End Do
      End Do
*
#ifdef _DEBUGPRINT_
      Call RecPrt('BMx',' ',BMx,nDim,nInter)
      Call RecPrt('Hss_X',' ',Hss_X,nDim,nDim)
#endif
      Call mma_allocate(X,nDim*nInter,Label='X')
      M=nDim
      N=nInter
      NRHS=nDim
      Call Eq_Solver('N',M,N,NRHS,BMx,.FALSE.,Degen,Hss_X,X)
*
      Call mma_allocate(XT,nDim*nInter,Label='XT')
      Call TRNSPS(nInter,nDim,X,XT)
#ifdef _DEBUGPRINT_
      Call RecPrt('X',' ',X,nInter,nDim)
      Call RecPrt('XT',' ',XT,nDim,nInter)
#endif
*
      M=nDim
      N=nInter
      NRHS=nInter
      Call Eq_Solver('N',M,N,NRHS,BMx,.False.,Degen,XT,Hss_Q)
*
      Call mma_deallocate(XT)
      Call mma_deallocate(X)
#ifdef _DEBUGPRINT_
      Call RecPrt('Hss_Q',' ',Hss_Q,nInter,nInter)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Sort_Localisation(CMO,nBas,nOcc,nFro,nSym)
C
C     Thomas Bondo Pedersen, November 2005.
C
C     Purpose: sort CMOs according to Cholesky orbital ordering.
C
      Implicit Real*8 (a-h,o-z)
      Real*8 CMO(*)
      Integer nBas(nSym), nOcc(nSym), nFro(nSym)
#include "WrkSpc.fh"

      Character*17 SecNam
      Parameter (SecNam = 'Sort_Localisation')

      Character*8  Label
      Character*80 Txt

C     Static setting of decomposition threshold.
C     ------------------------------------------

      ThrCho = 1.0d-12

C     Get a copy of the occupied orbitals: X=CMO.
C     -------------------------------------------

      lX = nBas(1)*nOcc(1)
      Do iSym = 2,nSym
         lX = lX + nBas(iSym)*nOcc(iSym)
      End Do
      Call GetMem('XCho','Allo','Real',ipX,lX)
      k1 = 1
      kX = ipX
      Do iSym = 1,nSym
         kC = k1 + nBas(iSym)*nFro(iSym)
         Call dCopy_(nBas(1)*nOcc(1),CMO(kC),1,Work(kX),1)
         k1 = k1 + nBas(iSym)**2
         kX = kX + nBas(iSym)*nOcc(iSym)
      End Do

C     Get the overlap matrix.
C     -----------------------

      lOAux = nBas(1)*(nBas(1)+1)/2
      lOvlp = nBas(1)*nBas(1)
      Do iSym = 1,nSym
         lOaux = lOaux + nBas(iSym)*(nBas(iSym)+1)/2
         lOvlp = lOvlp + nBas(iSym)*nBas(iSym)
      End Do
      lOaux = lOaux + 4
      Call GetMem('Ovlp','Allo','Real',ipOvlp,lOvlp)
      Call GetMem('AuxOvlp','Allo','Real',ipOaux,lOaux)

      irc    = -1
      iOpt   = 2
      iComp  = 1
      iSyLbl = 1
      Label  = 'Mltpl  0'
      Call RdOne(irc,iOpt,Label,iComp,Work(ipOaux),iSyLbl)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': RdOne returned ',irc
         Write(6,*) 'Label = ',Label,'  iSyLbl = ',iSyLbl
         Call SysAbendMsg(SecNam,'I/O error in RdOne',' ')
      End If

      kTri = ipOaux
      kSqr = ipOvlp
      Do iSym = 1,nSym
         Call Tri2Rec(Work(kTri),Work(kSqr),nBas(iSym),.False.)
         kTri = kTri + nBas(iSym)*(nBas(iSym)+1)/2
         kSqr = kSqr + nBas(iSym)*nBas(iSym)
      End Do
      Call GetMem('AuxOvlp','Free','Real',ipOaux,lOaux)

C     Sort each symmetry block.
C     -------------------------

      kX = ipX
      kC = 1
      kS = ipOvlp
      Do iSym = 1,nSym

C        Cycle loop for empty symmetry blocks.
C        -------------------------------------

         If (nBas(iSym).lt.1 .or. nOcc(iSym).lt.1) Go To 100

C        Allocations.
C        ------------

         lDen = nBas(iSym)*nBas(iSym)
         lU = nOcc(iSym)*nOcc(iSym)
         lScr = nBas(iSym)*nOcc(iSym)
         Call GetMem('SrtDen','Allo','Real',ipDen,lDen)
         Call GetMem('SrtU','Allo','Real',ipU,lU)
         Call GetMem('SrtScr','Allo','Real',ipScr,lScr)

C        Cholesky decompose D=C^TC and thus define the ordering.
C        At this stage, X contains the original MOs (CMO).
C        After the decomposition, X contains the Cholesky MOs.
C        -------------------------------------------------------

         Call GetDens_Localisation(Work(ipDen),Work(kX),nBas(iSym),
     &                             nOcc(iSym))
         irc = -1
         Call ChoLoc(irc,Work(ipDen),Work(kX),ThrCho,xNrm,nBas(iSym),
     &               nOcc(iSym))
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoLoc returned ',irc
            Write(6,*) 'Symmetry block: ',iSym
            Write(6,*) 'Unable to continue...'
            Write(Txt,'(A,I6)') 'ChoLoc return code:',irc
            Call SysAbendMsg(SecNam,
     &                       'Density Cholesky decomposition failed!',
     &                       Txt)
         End If

C        Compute address in CMO, skipping frozen orbitals.
C        -------------------------------------------------

         k1 = kC + nBas(iSym)*nFro(iSym)

C        Compute U = X^TSC.
C        ------------------

         Call GetUmat_Localisation(Work(ipU),Work(kX),Work(kS),CMO(k1),
     &                             Work(ipScr),lScr,nBas(iSym),
     &                             nOcc(iSym))

C        Sort.
C        -----

         Call Sort_Localisation_1(CMO(k1),Work(ipU),nBas(iSym),
     &                            nOcc(iSym))

C        Update counters.
C        ----------------

         kX = kX + nBas(iSym)*nOcc(iSym)
         kC = kC + nBas(iSym)**2
         kS = kS + nBas(iSym)**2

C        De-allocations.
C        ---------------

         Call GetMem('SrtScr','Free','Real',ipScr,lScr)
         Call GetMem('SrtU','Free','Real',ipU,lU)
         Call GetMem('SrtDen','Free','Real',ipDen,lDen)

C        Loop cycling (empty symmetries jump here).
C        ------------------------------------------

  100    Continue

      End Do

C     De-allocations.
C     ---------------

      Call GetMem('XCho','Free','Real',ipX,lX)
      Call GetMem('Ovlp','Free','Real',ipOvlp,lOvlp)

      End
      SubRoutine Sort_Localisation_1(CMO,U,nBas,nOcc)
C
C     Thomas Bondo Pedersen, November 2005.
C
C     Purpose: sort CMO columns according to U.
C
      Implicit Real*8 (a-h,o-z)
      Real*8 CMO(nBas,nOcc), U(nOcc,nOcc)
#include "WrkSpc.fh"

      I1(i)=iWork(ipI1-1+i)
      I2(i)=iWork(ipI2-1+i)

C     Allocations.
C     ------------

      lI1 = nOcc
      lI2 = nOcc
      lC  = nBas*nOcc
      Call GetMem('Sr1I1','Allo','Inte',ipI1,lI1)
      Call GetMem('Sr1I2','Allo','Inte',ipI2,lI2)
      Call GetMem('Sr1C','Allo','Real',ipC,lC)

C     Find max U element in each row.
C     -------------------------------

      ip1 = ipI1 - 1
      Do i = 1,nOcc
         iWork(ip1+i) = i
      End Do

      ip2 = ipI2 - 1
      Do i = 1,nOcc
         jmax = 0
         Umax = -1.0d15
         Do j = 1,nOcc
            If (I1(j) .eq. j) Then
               Utst = abs(U(i,j))
               If (Utst .gt. Umax) Then
                  jmax = j
                  Umax = Utst
               End If
            End If
         End Do
         If (jmax .eq. 0) Then
            Call SysAbendMsg('Sort_Localisation_1','Error:','jmax=0')
         Else
            iWork(ip1+jmax) = 0
            iWork(ip2+i) = jmax
         End If
      End Do

C     Swap MOs according to I2.
C     -------------------------

      Call dCopy_(nBas*nOcc,CMO,1,Work(ipC),1)
      Do i = 1,nOcc
         kOff = ipC + nBas*(I2(i)-1)
         Call dCopy_(nBas,Work(kOff),1,CMO(1,i),1)
      End Do

C     De-allocate.
C     ------------

      Call GetMem('Sr1C','Free','Real',ipC,lC)
      Call GetMem('Sr1I2','Free','Inte',ipI2,lI2)
      Call GetMem('Sr1I1','Free','Inte',ipI1,lI1)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
!***************************************************
!                   Calculating NTO
!****************************************************
! Reference: J. Chem. Phys., 2014, 141, 024106
! Notation used in the following of the code follows those in the
! reference mentioned above, especially between equation 53 and
! 54 on page 024106-8.
! NASHT is the number of active orbitals, originated from this
! program.
! Umat is the U matrix, which is the eigenvector  matrix
! calculated by transition density matrix (TDM)
! multiplied by its transpose. Vmat is the V matrix, the eigen-
! vector matrix of a matrix calculated by the transpose
! multiplied by the TDM.
! Ueig is the eigenvalen matrix for the U matrix, Veig is
! that
! for the V matrix.
! ONTO is the hole NTO, calculated by multiplying MO matrix with
! the eigenvector matrix for U matrix. Note that the eigenvector
! matrix is still named as U. Similar condition is for the
! particle matirx.
!
! However, the sets of particle and hole orbitals are switched
! when I examined the results. So I put the data stored in LONTO
! as the particle NTO. (Because JOB1 is for the second JobIph
! file in the input and JOB2 is for the first.)
!
!                                  -------Jie Bao
!           in Depart. of Chemistry, University of Minnesota, USA
!                                      2018/08/09

subroutine NTOCalc(JOB1,JOB2,ISTATE,JSTATE,TRAD,TRASD,ISpin)

use fortran_strings, only: str
use Symmetry_Info, only: nIrrep
use rassi_data, only: NASH, NASHT, NBASF, NBST, NCMO, NISH, NISHT, NOSH
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: JOB1, JOB2, IState, jState, ISpin
real(kind=wp) :: TRAD(NASHT**2), TRASD(NASHT**2)
integer(kind=iwp) :: I, I_NTO, icactorb, INFO, IOrb, Iprint, isym, IUseSym, J, Jprint, LU, N_NTO, NAISHT, NDge, NScrq, NSupBas, &
                     NSUPCMO, NUseBF(nIrrep), NUsedBF(nIrrep), NUseSym, RealtoUse(nIrrep), UsetoReal(nIrrep)
real(kind=wp) :: SumEigVal, WGRONK(2)
logical(kind=iwp) :: DOTEST
character(len=128) :: FILENAME
character(len=9) :: STATENAME
character(len=8) :: NTOType
character(len=3) :: lIrrep(8)
character :: Spin(2)
integer(kind=iwp), allocatable :: Indfr(:), Indto(:), OrbAct(:), OrbBas(:), OrbSym(:), OrbUsedSym(:), Symfr(:), Symto(:)
real(kind=wp), allocatable :: CMO1(:), CMO2(:), ONTO(:), Scrq(:), SUPCMO1(:), SUPCMO2(:), TDM(:), TDMT(:), UEig(:), UMAT(:), &
                              UNTO(:), VEig(:), VMAT(:)
real(kind=wp), parameter :: PrintThres = 1.0e-5_wp
integer(kind=iwp), external :: ISFREEUNIT

! Nr. of basis functions used prior to this symmetry (NUsedBF)
! and used in this symmetry (NUseBF) nIrrep >= NusedSym
!IOrb is the index  of orbitals.
!OrbBas() is the number of basis function for IOrb
!OrbSym() is the index of symmetry/irrep  for IOrb

statename = ''
DoTest = .false.
call mma_allocate(CMO1,NCMO,Label='CMO1')
call mma_allocate(CMO2,NCMO,Label='CMO2')
call RDCMO_RASSI(JOB1,CMO1)
call RDCMO_RASSI(JOB2,CMO2)

if (dotest) then
  write(u6,*) 'CMO1'
  do I=0,NCMO,5
    write(u6,'(2X,5F10.6)') (CMO1(I+IPrint),IPrint=1,min(5,NCMO-I))
  end do
  write(u6,*) 'CMO2'
  do I=0,NCMO,5
    write(u6,'(2X,5F10.6)') (CMO2(I+IPrint),IPrint=1,min(5,NCMO-I))
  end do
end if

call mma_allocate(OrbUsedSym,NBST,Label='OrbUsedSym')
call mma_allocate(OrbAct,NISHT+NASHT,Label='OrbAct')
call mma_allocate(OrbBas,NISHT+NASHT,Label='OrbBas')
call mma_allocate(OrbSym,NISHT+NASHT,Label='OrbSym')

! Analyzing the symmetry of the wave function
IUseSym = 0
NSupBas = 0
IOrb = 0
do ISym=1,nIrrep
  if (NASH(ISym) > 0) then
    IUseSym = IUseSym+1
    RealtoUse(ISym) = IUseSym
    UsetoReal(IUseSym) = ISym
    NSupBas = NSupBas+NBASF(ISym)
    if (IUseSym > 1) then
      NUsedBF(IUseSym) = NBASF(UsetoReal(IUseSym-1))+NUsedBF(IUseSym-1)
    else
      NUsedBF(IUseSym) = 0
    end if
    NUseBF(IUseSym) = NBASF(ISym)
    do I=1,NOSH(ISym)
      IOrb = IOrb+1
      if (I > NISH(ISym)) then
        OrbAct(IOrb) = 1
      else
        OrbAct(IOrb) = 0
      end if
      OrbBas(IOrb) = NBASF(ISym)
      OrbSym(IOrb) = ISym
      OrbUsedSym(IOrb) = IUseSym
    end do
  else
    RealtoUse(ISym) = 0
  end if
end do
NSUPCMO = NASHT*NSupBas
NUseSym = IUseSym
NAISHT = NASHT+NISHT
if (DoTest) then
  write(u6,*) 'Reprinting MO information'
  write(u6,*) 'Size of Super-CMO matrix',NSupCMO
  write(u6,'(6X,A20,4X,16I4)') 'MO Index',(IOrb,IOrb=1,NAISHT)
  write(u6,'(6X,A20,4X,16I4)') 'Irrep Belong to',(OrbSym(IOrb),IOrb=1,NAISHT)
  write(u6,'(6X,A20,4X,16I4)') 'Nr. of Basis F',(OrbBas(IOrb),IOrb=1,NAISHT)
  write(u6,'(6X,A20,4X,16I4)') 'Act Orbital?',(OrbAct(IOrb),IOrb=1,NAISHT)
  write(u6,'(6X,A20,4X,16I4)') 'used basis f',(NUsedBF(OrbUsedSym(IOrb)),IOrb=1,NAISHT)
end if
! End of analyzing wave function

! building up a super-CMO matrix (to be C1-like)
call mma_allocate(SUPCMO1,NSUPCMO,Label='SUPCMO1')
call mma_allocate(SUPCMO2,NSUPCMO,Label='SUPCMO1')
SUPCMO1(:) = Zero
SUPCMO2(:) = Zero
call mma_allocate(ONTO,NSUPCMO,Label='ONTO')
call mma_allocate(UNTO,NSUPCMO,Label='UNTO')
icactorb = 0
I = 0
do IOrb=1,NAISHT
  if (OrbAct(IOrb) == 1) then
    icactorb = icactorb+1
    do IPrint=1,(OrbBas(IOrb))
      JPrint = IPrint+NUsedBF(OrbUsedSym(IOrb))
      J = I+IPrint-1
      SUPCMO1(icactorb+(JPRINT-1)*NASHT) = CMO1(1+J)
      SUPCMO2(icactorb+(JPRINT-1)*NASHT) = CMO2(1+J)
    end do
  end if
  I = I+OrbBas(IOrb)
end do
if (DoTest) then
  write(u6,*) 'printing CMO1 in a C1-like format'
  do I=1,NASHT
    do J=1,NSupBas,10
      write(u6,'(4X,10F10.6)') (SUPCMO1(I+(JPrint-1)*NASHT),JPrint=J,min(J+9,NSupBas))
    end do
  end do

  write(u6,*) 'printing CMO2 in a C1-like format'
  do I=1,NASHT
    do J=1,NSupBas,10
      write(u6,'(4X,10F10.6)') (SUPCMO2(I+(JPrint-1)*NASHT),JPrint=J,min(J+9,NSupBas))
    end do
  end do
end if
call mma_deallocate(OrbUsedSym)
call mma_deallocate(OrbAct)
call mma_deallocate(OrbBas)
call mma_deallocate(OrbSym)
! end of building up the super-CMO matrix
!     Start and initialize spaces
statename = str(JSTATE)//'_'//str(ISTATE)
NDge = NASHT**2
call mma_allocate(Umat,NDge,Label='UMat')
call mma_allocate(Vmat,NDge,Label='VMat')
call mma_allocate(Ueig,NDge,Label='Ueig')
call mma_allocate(Veig,NDge,Label='Veig')
call mma_allocate(TDM,NDge,Label='TDM')
call mma_allocate(TDMT,NDge,Label='TDMT')
write(u6,*)
write(u6,'(6X,A)') repeat('*',100)
write(u6,'(6X,A,98X,A)') '*','*'
write(u6,'(6X,A,34X,A31,33X,A)') '*','NATURAL TRANSITION ORBITALS','*'
write(u6,'(6X,A,98X,A)') '*','*'
write(u6,'(6X,A,38X,A14,I2,A12,I2 ,30X,A )') '*','BETWEEN STATE ',JSTATE,' AND STATE ',ISTATE,'*'
write(u6,'(6X,A,98X,A)') '*','*'
write(u6,'(6X,A)') repeat('*',100)
write(u6,*)
write(u6,*)
if (ISpin == 1) then
  N_NTO = 1
  Spin(1) = 'a'
  write(u6,'(10X,a)') 'NTO CALCULATION ONLY DONE FOR ALPHA SPIN BECAUSE THE WAVE FUNCTION IS A SINGLET,'
  write(u6,'(10X,a)') 'SO ALPHA NTOS ARE EQUAL TO BETA ONES'
else
  N_NTO = 2
  Spin(1) = 'a'
  Spin(2) = 'b'
end if
do I_NTO=1,N_NTO
  Ueig(:) = Zero
  Veig(:) = Zero
  ONTO(:) = Zero
  UNTO(:) = Zero
  if (Spin(I_NTO) == 'a') then
    TDM(1:Ndge) = Half*(TRAD(1:Ndge)+TRASD(1:Ndge))
  else
    TDM(1:Ndge) = Half*(TRAD(1:Ndge)-TRASD(1:Ndge))
  end if
  do I=1,NASHT
    do J=1,NASHT
      TDMT(I+NASHT*(J-1)) = TDM(J+NASHT*(I-1))
    end do
  end do
  ! Print out transition density matrix
  if (Spin(I_NTO) == 'a') then
    write(FILENAME,'(a,a)') 'TDM',trim(adjustl(STATENAME))
    LU = ISFREEUNIT(233)
    call Molcas_Open(LU,FILENAME)
    do I=1,NASHT
      write(LU,'(5(1X,ES11.4E2))') (TRAD(NASHT*(I-1)+J),J=1,NASHT)
    end do
    write(LU,*)
    write(LU,*)
    write(LU,*)
    do I=1,NASHT
      write(LU,'(5(1X,ES11.4E2))') (TRASD(NASHT*(I-1)+J),J=1,NASHT)
    end do
    close(LU)
  end if
  ! Generalizing transpose of TDM, TDM_T

  ! Calculating T_trans*T
  call DGEMM_('n','n',NASHT,NASHT,NASHT,One,TDMT,NASHT,TDM,NASHT,Zero,Vmat,NASHT)
  ! Writing Particle Matrix
  write(FILENAME,'(a,a,a)') 'Dhole.',trim(adjustl(STATENAME)),Spin(I_NTO)
  LU = ISFREEUNIT(LU)
  call Molcas_Open(LU,FILENAME)
  do I=1,NASHT
    write(LU,'(10(1X,ES11.4E2))') (Vmat(NASHT*(I-1)+J),J=1,NASHT)
  end do
  close(LU)
  ! Calculating T*T_transpose
  call DGEMM_('n','n',NASHT,NASHT,NASHT,One,TDM,NASHT,TDMT,NASHT,Zero,Umat,NASHT)
  write(FILENAME,'(a,a,a)') 'Dpart.',trim(adjustl(STATENAME)),Spin(I_NTO)
  LU = ISFREEUNIT(LU)
  call Molcas_Open(LU,FILENAME)
  do I=1,NASHT
    write(LU,'(10(1X,ES11.4E2))') (Umat(NASHT*(I-1)+J),J=1,NASHT)
  end do
  close(LU)
  call DSYEV_('V','U',NASHT,Vmat,NASHT,Veig,WGRONK,-1,INFO)
  NScrq = int(WGRONK(1))
  if (Nscrq == 0) then
    Nscrq = max(NDge,100)
    if (DoTest) write(u6,*) 'Size of scratch space is increased to max(NDge,100)'
  end if
  call mma_allocate(Scrq,NScrq,Label='Scrq')
  !   Diagonalizing matrices
  call DSYEV_('V','U',NASHT,Umat,NASHT,Ueig,Scrq,NScrq,INFO)
  call DSYEV_('V','U',NASHT,Vmat,NASHT,Veig,Scrq,NScrq,INFO)
  call mma_deallocate(Scrq)
  ! Printing some matrices
  if (DoTest) then
    write(FILENAME,'(a,a,a)') 'EigVecHole.',trim(adjustl(STATENAME)),Spin(I_NTO)
    LU = ISFREEUNIT(LU)
    call Molcas_Open(LU,FILENAME)
    do I=1,NASHT
      write(LU,'(5(1X,ES11.4E2))') (Vmat(NASHT*(I-1)+J),J=1,NASHT)
    end do
    close(LU)
    write(FILENAME,'(a,a,a)') 'EigVecPart.',trim(adjustl(STATENAME)),Spin(I_NTO)
    LU = ISFREEUNIT(LU)
    call Molcas_Open(LU,FILENAME)
    do I=1,NASHT
      write(LU,'(5(1X,ES11.4E2))') (Umat(NASHT*(I-1)+J),J=1,NASHT)
    end do
    close(LU)
  end if
  ! End of Diagonalizing the matrices

  ! Constructing hole and particle orbitals

  call DGEMM_('t','n',NASHT,NSupBas,NASHT,One,Umat,NASHT,SupCMO1,NASHT,Zero,ONTO,NASHT)
  call DGEMM_('t','n',NASHT,NSupBas,NASHT,One,Vmat,NASHT,SupCMO2,NASHT,Zero,UNTO,NASHT)

  if (DoTest) then
    write(u6,*) 'printing Particle NTO in a C1-like format'
    do I=1,NASHT
      do J=1,NSupBas,10
        write(u6,'(4X,10F10.6)') (ONTO(I+(JPrint-1)*NASHT),JPrint=J,min(J+9,NSupBas))
      end do
    end do

    write(u6,*) 'printing Hole     NTO in a C1-like format'
    do I=1,NASHT
      do J=1,NSupBas,10
        write(u6,'(4X,10F10.6)') (UNTO(I+(JPrint-1)*NASHT),JPrint=J,min(J+9,NSupBas))
      end do
    end do
  end if

  ! Printing NTOs
  call mma_allocate(Symto,NASHT,Label='Symto')
  call mma_allocate(Indto,NASHT,Label='Indto')
  call mma_allocate(Symfr,NASHT,Label='Symfr')
  call mma_allocate(Indfr,NASHT,Label='Indfr')
  NTOType = 'PART'
  call NTOSymAnalysis(NUseSym,NUseBF,NUsedBF,ONTO,NTOType,STATENAME,Ueig,UsetoReal,RealtoUse,Spin(I_NTO),Symto,Indto,SumEigVal)
  NTOType = 'HOLE'
  call NTOSymAnalysis(NUseSym,NUseBF,NUsedBF,UNTO,NTOType,STATENAME,Veig,UsetoReal,RealtoUse,Spin(I_NTO),Symfr,Indfr,SumEigVal)
  ! End of Printing NTOs

  call Get_cArray('Irreps',lIrrep,24)
  lIrrep(1:nIrrep) = adjustr(lIrrep(1:nIrrep))

  ! Putting particle-hole pairs in the output
  write(u6,*)
  if (I_NTO == 1) then
    write(u6,'(10X,a)') 'NATURAL TRANSITION ORBTIAL INFORMATION FOR ALPHA SPIN'
  else
    write(u6,'(10X,a)') 'NATURAL TRANSITION ORBTIAL INFORMATION FOR BETA  SPIN'
  end if
  write(u6,'(6X,A)') repeat('=',100)
  write(u6,'(10X,5A18)') 'EXCITATION','EIGENVALUE','EXCITATION','HOLE NTO','PARTICLE NTO'
  write(u6,'(10X,A18,18X,3A18)') 'AMPLITUDE','CONTRIBUTION(%)','SYMMETRY INDEX','SYMMETRY INDEX'
  write(u6,'(6X,A)') repeat('-',100)
  do IOrb=NASHT,1,-1
    if (Ueig(IOrb) < PrintThres) exit
    write(u6,'(10X,2(10X,F8.5),10X,F8.2,2(A9,I9))') sqrt(Ueig(IOrb)),Ueig(IOrb),Ueig(IOrb)/SumEigVal*100.0_wp,lIrrep(Symfr(IOrb)), &
                                                    Indfr(IOrb),lIrrep(Symto(IOrb)),Indto(IOrb)
  end do

  write(u6,'(6X,A)') repeat('-',100)
  write(u6,'(6X,A,F8.5)') 'SUM OF EIGENVALUES',SumEigVal
  write(u6,'(6X,A)') repeat('=',100)

  call mma_deallocate(Symto)
  call mma_deallocate(Indto)
  call mma_deallocate(Symfr)
  call mma_deallocate(Indfr)
end do
! End of loop over N_NTO (I_NTO=1 for alpha and 2 for beta)

write(u6,*)
write(u6,'(6X,A)') repeat('*',100)
write(u6,'(6X,A,33X,A34,31X,A)') '*','END OF NATURAL TRANSITION ORBITALS','*'
write(u6,'(6X,A,33X,A14,I2,A12,I2 ,35X,A )') '*','BETWEEN STATE ',JSTATE,' AND STATE ',ISTATE,'*'
write(u6,'(6X,A)') repeat('*',100)

call mma_deallocate(VMat)
call mma_deallocate(UMat)
call mma_deallocate(VEig)
call mma_deallocate(UEig)
call mma_deallocate(TDMT)
call mma_deallocate(TDM)
call mma_deallocate(CMO1)
call mma_deallocate(CMO2)

call mma_deallocate(SUPCMO2)
call mma_deallocate(SUPCMO1)
call mma_deallocate(UNTO)
call mma_deallocate(ONTO)

end subroutine NTOCalc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SPINORB(D,CMO,OCC,kroot)
C
C     Purpose: diagonalize the spin density matrix (D) to
C     obtain the eigenvectors (EVEC) and the eigenvalues (EVAL).
C     Then the natural spinorbitals (CMONSO) are computed
C     (only active).
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
#include "WrkSpc.fh"
      Parameter (ROUTINE='SPINORB ')
      DIMENSION D(*),CMO(*),OCC(*)
C
C
C Local print level (if any)
      IPRLEV=IPRLOC(6)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF

      IPDEN=1
      IPCMO=1
      IPOCC=1
      DO ISYM=1,NSYM
        NB=NBAS(ISYM)
        NF=NFRO(ISYM)
        NI=NISH(ISYM)
        IF ( NB.NE.0 ) THEN
          NA=NASH(ISYM)
          IF ( NA.NE.0 ) THEN
            CALL GETMEM('SPORB1','ALLO','REAL',LW1,NA*NA)
            CALL GETMEM('SPORB2','ALLO','REAL',LW2,NA*NB)
            CALL DCOPY_(NA*NA,[0.0D0],0,WORK(LW1),1)
            CALL DCOPY_(NA,[1.0D0],0,WORK(LW1),NA+1)
            CALL Jacob(D(IPDEN),WORK(LW1),NA,NA)
            IDIAG=0
            DO I=1,NA
              IDIAG=IDIAG+I
              OCC(IPOCC+NF+NI+I-1)=D(IPDEN+IDIAG-1)
            END DO
            CALL DGEMM_('N','N',
     &                  NB,NA,NA,
     &                  1.0d0,CMO(IPCMO+(NF+NI)*NB),NB,
     &                  WORK(LW1),NA,
     &                  0.0d0,WORK(LW2),NB)
            CALL DCOPY_(NA*NB,WORK(LW2),1,CMO(IPCMO+(NF+NI)*NB),1)
            CALL GETMEM('SPORB2','FREE','REAL',LW2,NA*NB)
            CALL GETMEM('SPORB1','FREE','REAL',LW1,NA*NA)
            IPDEN=IPDEN+NA*(NA+1)/2
          END IF
          IPCMO=IPCMO+NB*NB
          IPOCC=IPOCC+NB
        END IF
      END DO
C
C
      RETURN
c Avoid unused argument warnings
#ifdef _WARNING_WORKAROUND_
      IF (.FALSE.) CALL Unused_integer(kroot)
#endif
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Dresselhaus                                     *
!***********************************************************************

subroutine embPotOutput(nAtoms,dens)
!***********************************************************************
!                                                                      *
! Object: Calculates and writes out the electrostatic potential on a   *
!         grid.                                                        *
!                                                                      *
! Called from: OneEl                                                   *
!              RASSCF (version below)                                  *
!                                                                      *
! Calling    : IniSewM                                                 *
!              Drv1_Pot                                                *
!              molcas_open                                             *
!              embpot routines                                         *
!                                                                      *
!     Author: Thomas Dresselhaus                                       *
!                                                                      *
!***********************************************************************

use Embedding_Global, only: embOutEspPath, embWriteEsp, nEmbGridPoints, embGridCoord
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms
real(kind=wp), intent(in) :: dens(*)

integer(kind=iwp) :: i, iUnitEmb, j, nOrdOp
real(kind=wp) :: distGpAtom
real(kind=wp), allocatable :: coordsEmb(:,:), chargesEmb(:), espGrid(:)
integer(kind=iwp), external :: isFreeUnit

call EmbPotInit(.true.)
! I dunno whether the coordinates/charges are still stored
! somewhere, but I'll just read them in again here.
call mma_allocate(coordsEmb,3,nAtoms,label='Coor')
call Get_dArray('Unique Coordinates',coordsEmb,3*nAtoms)
call mma_allocate(chargesEmb,nAtoms,label='Charge')
call Get_dArray('Nuclear charge',chargesEmb,nAtoms)
!write(u6,*) 'dens(1:3)=',dens(1:3)
!write(u6,*) 'Coords of gridpt 1:',embGridCoord(:,1)
!write(u6,*) 'Coords of gridpt 3:',embGridCoord(:,3)
! Get the electrostatic potential on the grid
!write(u6,*) 'nEmbGridPoints=', nEmbGridPoints
if (embWriteEsp) then
  call mma_allocate(espGrid,nEmbGridPoints,label='ESP')
  !write(u6,*) 'espGrid(1:3)=',espGrid(1:3)
  call inisewm('mltpl',0)
  !write(u6,*) 'inisewm done!'
  nordop = 0
  call Drv1_Pot(dens,embGridCoord,espGrid,nEmbGridPoints,1,nordop)
  !write(u6,*) 'Coords:'
  !write(u6,*) coordsEmb(:,1)
  !write(u6,*) coordsEmb(:,2)
  !write(u6,*) coordsEmb(:,3)
  !write(u6,*) '----------------------------------------------------'
  !write(u6,*) 'Charges:'
  !write(u6,*) chargesEmb(1:3)
  iUnitEmb = isFreeUnit(1)
  call molcas_open(iUnitEmb,embOutEspPath)
end if
do i=1,nEmbGridPoints
  do j=1,nAtoms
    distGpAtom = sqrt((coordsEmb(1,j)-embGridCoord(1,i))**2+ &
                      (coordsEmb(2,j)-embGridCoord(2,i))**2+ &
                      (coordsEmb(3,j)-embGridCoord(3,i))**2)
    if (embWriteEsp) espGrid(i) = espGrid(i)+chargesEmb(j)/distGpAtom
  end do
  if (embWriteEsp) then
    !write(u6,*) 'ESP on grid point ',i,': ',espGrid(i)
    ! Write to file
    write(iUnitEmb,'(es18.10)') -espGrid(i)
    !write(iUnitEmb,'(es18.10)') espGrid(i)
  end if
end do
if (embWriteEsp) then
  close(iUnitEmb)
  call mma_deallocate(espGrid)
end if
call mma_deallocate(coordsEmb)
call mma_deallocate(chargesEmb)
call embpotfreemem()

end subroutine embPotOutput

! Actually the incoming densities are in an AO basis and treated
! as such...
subroutine embPotOutputMODensities(nAtoms,nSym,densInact,densAct,nBasPerSym,nBasTotSquare)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nSym, nBasPerSym(nSym), nBasTotSquare
real(kind=wp), intent(in) :: densInact(nBasTotSquare), densAct(nBasTotSquare)
integer(kind=iwp) :: i, iCnt, iCnt2, iCol, iDensDimPck, iRow
real(kind=wp), allocatable :: totDens(:), totDensP(:)

iDensDimPck = 0
do i=1,nSym
  iDensDimPck = iDensDimPck+((nBasPerSym(i)*(nBasPerSym(i)+1))/2)
end do

call mma_allocate(totDens,nBasTotSquare,label='TotD')
call mma_allocate(totDensP,iDensDimPck,label='TotDp')

call dcopy_(nBasTotSquare,densInact,1,totDens,1)
call daxpy_(nBasTotSquare,One,densAct,1,totDens,1)
!Pack density
iCnt = 0
iCnt2 = 0
do i=1,nSym
  do iRow=1,nBasPerSym(i)
    do iCol=1,iRow
      iCnt = iCnt+1
      if (iRow == iCol) then
        totDensP(iCnt) = totDens((iRow-1)*nBasPerSym(i)+iCol+iCnt2)
      else
        totDensP(iCnt) = Two*totDens((iRow-1)*nBasPerSym(i)+iCol+iCnt2)
      end if
    end do
  end do
  iCnt2 = iCnt2+nBasPerSym(i)*nBasPerSym(i)
end do

call embPotOutput(nAtoms,totDensP)

call mma_deallocate(totDens)
call mma_deallocate(totDensP)

end subroutine embPotOutputMODensities

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine setfn_cvb(fileid,fn)

use casvb_global, only: fileids, filename, ifilio, max_rec, nrec
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: fileid
character(len=*), intent(in) :: fn
real(kind=wp) :: fileid_try
integer(kind=iwp) :: i, itry, lenfn
logical(kind=iwp), parameter :: debug = .false.

lenfn = len_trim(fn)
do i=1,nrec
  if (fn(1:lenfn) == filename(i)) then
    fileid = fileids(i)
    return
  end if
end do
itry = 0
do
  itry = itry+1
  fileid_try = real(itry,kind=wp)
  do i=1,nrec
    if (fileid_try == fileids(i)) exit
  end do
  if (i > nrec) exit
end do
nrec = nrec+1
if (nrec > max_rec) then
  write(u6,*) ' nrec > max_rec in setfn :',nrec,max_rec
  call abend_cvb()
end if
! set file name
filename(nrec) = fn
fileids(nrec) = fileid_try
ifilio(nrec) = 0
if (debug) then
  write(u6,*) ' IO information for identifier :',fileids(nrec)
  write(u6,*) ' IBF is :',nrec
  write(u6,*) ' File name is :',filename(nrec)
end if
fileid = fileids(nrec)

return

end subroutine setfn_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine PXMem(nRys,MemPV,la,lb,lr)
      External NAMem, MltMem, EFMem, CntMem
#include "property_label.fh"
*
      If (PLabel.eq.'NAInt ') Then
         Call PVMem(nRys,MemPV,la,lb,lr,NAMem)
      Else If (PLabel.eq.'MltInt') Then
         Call PVMem(nRys,MemPV,la,lb,lr,MltMem)
      Else If (PLabel.eq.'EFInt ') Then
         Call PVMem(nRys,MemPV,la,lb,lr,EFMem)
      Else If (PLabel.eq.'CntInt') Then
         Call PVMem(nRys,MemPV,la,lb,lr,CntMem)
      Else
         Call WarningMessage(2,'PXMem: Illegal type!')
         Write(6,*) '       PLabel=',PLabel
         Call Abend()
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FOPAB(FIFA,NFIFA,IBRA,IKET,FOPEL)

use Index_Functions, only: iTri, nTri_Elem
use sguga, only: CIS, EXS, L2ACT, SGS
use caspt2_global, only: IDCIEX, LUCIEX
use caspt2_module, only: ISCF, NAES, NASH, NCONF, NISH, NORB, NSYM, STSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NFIFA, IBRA, IKET
real(kind=wp), intent(in) :: FIFA(NFIFA)
real(kind=wp), intent(out) :: FOPEL
integer(kind=iwp) :: I, ID, IFTEST, II, IJ, IOFF(8), ISCR, IST, ISU, ISYM, IT, ITABS, ITTOT, ITUTOT, IU, IUABS, IUTOT, J, LEVT, &
                     LEVU, NI, nLev
real(kind=wp) :: EINACT, ESUM, FTU, OCC, TRC
real(kind=wp), allocatable :: BRA(:), KET(:), SGM(:)
real(kind=wp), external :: DDot_

nLev = SGS%nLev

! Procedure for computing one matrix element of the Fock matrix in the
! basis of the CASSCF states: <BRA|FOP|KET>
! In: The (possibly average) Fock matrix, active indices only, over the
! original CASSCF orbitals and the indices of the two states

! Offset table for accessing FIFA array:
IOFF(1) = 0
do ISYM=1,NSYM-1
  IOFF(ISYM+1) = IOFF(ISYM)+nTri_Elem(NORB(ISYM))
end do

IFTEST = 0
if (IFTEST > 0) then
  write(u6,*) ' The FIFA array:'
  do ISYM=1,NSYM
    IJ = IOFF(ISYM)+1
    do I=1,NORB(ISYM)
      write(u6,'(1x,5F16.8)') (FIFA(IJ+J),J=0,I-1)
      IJ = IJ+I
    end do
  end do
end if

! Specialized code for Closed-shell or Hi-spin HF:
! Sum up diagonal elements of FIFA times occ. number
! FIXME: This only works for diagonal elements, thus
! in the case of XMS this will not work...
if ((ISCF == 1) .or. (ISCF == 2)) then
  ESUM = Zero
  if (IBRA == IKET) then
    do ISYM=1,NSYM
      OCC = Two
      do I=1,NISH(ISYM)
        ESUM = ESUM+OCC*FIFA(IOFF(ISYM)+nTri_Elem(I))
      end do
      if (ISCF == 2) OCC = One
      do J=1,NASH(ISYM)
        I = NISH(ISYM)+J
        ESUM = ESUM+OCC*FIFA(IOFF(ISYM)+nTri_Elem(I))
      end do
    end do
  else
    write(u6,*) ' Warning: neglecting the off-diagonal entries'
    write(u6,*) ' of H0, XMS will be equal to MS!'
  end if
  FOPEL = ESUM
  return
end if

! General CASSCF or RASSCF case:
! Sum up trace of FIFA over inactive orbitals only:
TRC = Zero
do ISYM=1,NSYM
  do I=1,NISH(ISYM)
    II = IOFF(ISYM)+nTri_Elem(I)
    TRC = TRC+FIFA(II)
  end do
end do
! Contribution from inactive orbitals:
EINACT = Two*TRC

if (IFTEST > 0) write(u6,*) ' Energy contrib from inactive orbitals:',EINACT

! Allocate arrays for ket and bra wave functions
call mma_allocate(BRA,NCONF,Label='BRA')
call mma_allocate(KET,NCONF,Label='KET')
! Allocate array for sigma = Fock operator acting on ket:
call mma_allocate(SGM,NCONF,LABEL='SGM')

! Load ket wave function
ID = IDCIEX(IKET)
call DDAFILE(LUCIEX,2,KET,NCONF,ID)

if (IFTEST > 0) then
  write(u6,*) ' IKET:',IKET
  write(u6,*) ' Ket CI array:'
  ISCR = min(NCONF,20)
  write(u6,'(1x,5F16.8)') (KET(I),I=1,ISCR)
end if

! Compute (lowering part of) FIFA operator acting on
! the ket wave function.
SGM(:) = Zero
do LEVU=1,NLEV
  IUABS = L2ACT(LEVU)
  ISU = SGS%ISM(LEVU)
  IU = IUABS-NAES(ISU)
  NI = NISH(ISU)
  IUTOT = NI+IU
  do LEVT=1,LEVU
    if (SGS%ISM(LEVT) /= ISU) cycle
    ITABS = L2ACT(LEVT)
    IST = ISU
    IT = ITABS-NAES(IST)
    ITTOT = NI+IT
    ITUTOT = iTri(IUTOT,ITTOT)
    FTU = FIFA(IOFF(ISU)+ITUTOT)
    if (abs(FTU) < 1.0e-16_wp) cycle
    call SG_Epq_Psi(SGS,CIS,EXS,LEVT,LEVU,FTU,STSYM,KET,SGM)
  end do
end do
! Add contribution from inactive part:
SGM(:) = SGM(:)+EINACT*KET(:)

if (IFTEST > 0) then
  write(u6,*) ' SGM array from (lowering F)|KET>:'
  write(u6,'(1x,5F16.8)') (SGM(I),I=1,NCONF)
end if

! Load bra wave function
ID = IDCIEX(IBRA)
call DDAFILE(LUCIEX,2,BRA,NCONF,ID)

! Put matrix element into FOPEL:
FOPEL = DDOT_(NCONF,BRA,1,SGM,1)

if (IFTEST > 0) then
  write(u6,*) ' FOPEL is now:'
  write(u6,'(1x,5f16.8)') FOPEL
end if

! Compute (strictly lowering part of) FIFA operator acting on |BRA>.
! We are computing contributions <KET|Etu|BRA> with t<u, then
! using them as <BRA|Eut|KET>
! Note that I already have BRA in memory
SGM(:) = Zero
do LEVU=2,NLEV
  IUABS = L2ACT(LEVU)
  ISU = SGS%ISM(LEVU)
  IU = IUABS-NAES(ISU)
  NI = NISH(ISU)
  IUTOT = NI+IU
  do LEVT=1,LEVU-1
    if (SGS%ISM(LEVT) /= ISU) cycle
    ITABS = L2ACT(LEVT)
    IST = ISU
    IT = ITABS-NAES(IST)
    ITTOT = NI+IT
    ITUTOT = iTri(IUTOT,ITTOT)
    FTU = FIFA(IOFF(ISU)+ITUTOT)
    if (abs(FTU) < 1.0e-16_wp) cycle
    call SG_Epq_Psi(SGS,CIS,EXS,LEVT,LEVU,FTU,STSYM,BRA,SGM)
  end do
end do

if (IFTEST > 0) then
  write(u6,*) ' SGM array from (strictly lowering F)|BRA>:'
  write(u6,'(1x,5F16.8)') (SGM(I),I=1,NCONF)
end if

! Load ket wave function
ID = IDCIEX(IKET)
call DDAFILE(LUCIEX,2,KET,NCONF,ID)

! Add contribution to matrix element FOPEL
FOPEL = FOPEL+DDOT_(NCONF,KET,1,SGM,1)

if (IFTEST > 0) then
  write(u6,*) ' FOPEL is now:'
  write(u6,'(1x,5f16.8)') FOPEL
end if

call mma_deallocate(SGM)
call mma_deallocate(BRA)
call mma_deallocate(KET)

end subroutine FOPAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE T_TO_NK_VEC(      T,   KORB,    ISM,   ISPC,  LUCIN,
     &                        LUCOUT,      C)
*
* Evaluate T**(NK_operator) times vector on file LUIN
* to yield vector on file LUOUT
* (NK_operator is number operator for orbital K )
*
* Note LUCIN and LUCOUT are both rewinded before read/write
* Input
* =====
*  T : Input constant
*  KORB : Orbital in symmetry order
*
*  ISM,ISPC : Symmetry and space of state on LUIN
*  C : Scratch block
*
*
* Jeppe Olsen, Feb. 98
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "strinp.fh"
#include "orbinp.fh"
#include "cicisp.fh"
#include "strbas.fh"
#include "gasstr.fh"
#include "crun.fh"
#include "csm.fh"

*. Scratch block, must hold a batch of blocks
      DIMENSION C(*)
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' T_TO_NK_VEC speaking '
        WRITE(6,*) ' ISM, ISPC = ', ISM,ISPC
      END IF
      IDUM = 0
*. Set up block and batch structure of vector
      IATP = 1
      IBTP = 2
*
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
*
      CALL Z_BLKFO(     ISPC,      ISM,     IATP,     IBTP,   KLCLBT,
     &               KLCLEBT,  KLCI1BT,   KLCIBT,  KLCBLTP,   NBATCH,
     &                NBLOCK)
C           Z_BLKFO(ISPC,ISM,IATP,IBTP,KPCLBT,KPCLEBT,
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
*
      CALL GETMEM('KLASTR','ALLO','INTE',KLASTR,MXNSTR*NAEL)
      CALL GETMEM('KLBSTR','ALLO','INTE',KLBSTR,MXNSTR*NBEL)
      CALL GETMEM('KLKAOC','ALLO','INTE',KLKAOC,MXNSTR)
      CALL GETMEM('KLKBOC','ALLO','INTE',KLKBOC,MXNSTR)
*. Orbital K in type ordering
      KKORB = IREOST(KORB)
      CALL T_TO_NK_VECS   (       T,   KKORB,       C,   LUCIN,  LUCOUT,
     &                     IWORK(KNSTSO(IATP)),
     &                     IWORK(KNSTSO(IBTP)),
     &                     NBLOCK,IWORK(KLCIBT),NAEL,NBEL,IWORK(KLASTR),
     &                     IWORK(KLBSTR),IWORK(KLCBLTP),
     &                   NSMST,ICISTR,NTOOB,IWORK(KLKAOC),IWORK(KLKBOC))

      CALL GETMEM('KLASTR','FREE','INTE',KLASTR,MXNSTR*NAEL)
      CALL GETMEM('KLBSTR','FREE','INTE',KLBSTR,MXNSTR*NBEL)
      CALL GETMEM('KLKAOC','FREE','INTE',KLKAOC,MXNSTR)
      CALL GETMEM('KLKBOC','FREE','INTE',KLKBOC,MXNSTR)

      CALL GETMEM('CLBT  ','FREE','INTE',KLCLBT ,MXNTTS)
      CALL GETMEM('CLEBT ','FREE','INTE',KLCLEBT,MXNTTS)
      CALL GETMEM('CI1BT ','FREE','INTE',KLCI1BT,MXNTTS)
      CALL GETMEM('CIBT  ','FREE','INTE',KLCIBT ,8*MXNTTS)
      CALL GETMEM('CBLTP ','FREE','INTE',KLCBLTP,NSMST)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------
! 1998  PER-AAKE MALMQUIST
! DEPARTMENT OF THEORETICAL CHEMISTRY
! UNIVERSITY OF LUND
! SWEDEN
!--------------------------------------------

subroutine MKRHSC(IVEC,FIMO,NFIMO,ERI,nERI,SCR,nSCR)
! Set up RHS vector of PT2 Linear Equation System, in vector
! number IVEC of LUSOLV for case 4 (ATVX).

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use SUPERINDEX, only: KTUV
use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array, GA_Arrays
use caspt2_module, only: NACTEL, NAES, NASH, NASHT, NINDEP, NISH, NORB, NSSH, NSSH, NSYM, NTUV, NTUVES
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, NFIMO, nERI, nSCR
real(kind=wp), intent(inout) :: FIMO(NFIMO), ERI(nERI), SCR(nSCR)

integer(kind=iwp) :: IA, IATOT, IBUF, ICASE, IFIMO, ISYM, ISYMT, ISYMU, ISYMUV, ISYMV, IT, ITABS, ITTOT, IU, IUABS, IUTOT, IV, &
                     IVABS, IVTOT, IW, IW1, IW2, IYABS, IYYW, IYYWA, LW, NAS, NFIMOES, NFNXT, NIS, NV
real(kind=wp) :: ONEADD, rSUM

NFNXT = 0
do ISYM=1,NSYM
  NFIMOES = NFNXT
  NFNXT = NFNXT+nTri_Elem(NORB(ISYM))
  if (NINDEP(ISYM,4) == 0) cycle
  NAS = NTUV(ISYM)
  NIS = NSSH(ISYM)
  NV = NAS*NIS
  if (NV == 0) cycle

  !   Allocate W. Put in W(tuv,a)=(at,uv) +
  !             (FIMO(a,t)-sum(y)(ay,yt))*delta(u,v)/NACTEL.
  ! First, just the two-electron integrals. Later, add correction.

  LW = Allocate_GA_Array(NV,'WC')
  do ISYMT=1,NSYM
    ISYMUV = Mul(ISYMT,ISYM)
    do ISYMU=1,NSYM
      ISYMV = Mul(ISYMU,ISYMUV)
      do IU=1,NASH(ISYMU)
        IUTOT = IU+NISH(ISYMU)
        IUABS = IU+NAES(ISYMU)
        do IV=1,NASH(ISYMV)
          IVTOT = IV+NISH(ISYMV)
          IVABS = IV+NAES(ISYMV)
          call COUL(ISYM,ISYMT,ISYMU,ISYMV,IUTOT,IVTOT,ERI,SCR)
          do IA=1,NSSH(ISYM)
            IATOT = IA+NISH(ISYM)+NASH(ISYM)
            do IT=1,NASH(ISYMT)
              ITTOT = IT+NISH(ISYMT)
              ITABS = IT+NAES(ISYMT)
              IW1 = KTUV(ITABS,IUABS,IVABS)-NTUVES(ISYM)
              IW2 = IA
              IW = IW1+NAS*(IW2-1)
              IBUF = IATOT+NORB(ISYM)*(ITTOT-1)
              GA_Arrays(LW)%A(IW) = ERI(IBUF)
            end do
          end do
        end do
      end do
    end do
  end do

  do IT=1,NASH(ISYM)
    ITTOT = IT+NISH(ISYM)
    ITABS = IT+NAES(ISYM)
    do IA=1,NSSH(ISYM)
      IATOT = IA+NISH(ISYM)+NASH(ISYM)
      IFIMO = NFIMOES+iTri(IATOT,ITTOT)
      rSUM = FIMO(IFIMO)
      do IYABS=1,NASHT
        IYYW = KTUV(IYABS,IYABS,ITABS)-NTUVES(ISYM)
        IYYWA = IYYW+NAS*(IA-1)
        rSUM = rSUM-GA_Arrays(LW)%A(IYYWA)
      end do
      ONEADD = rSUM/real(max(1,NACTEL),kind=wp)
      do ISYMU=1,NSYM
        do IU=1,NASH(ISYMU)
          IUABS = IU+NAES(ISYMU)
          IW1 = KTUV(ITABS,IUABS,IUABS)-NTUVES(ISYM)
          IW2 = IA
          IW = IW1+NAS*(IW2-1)
          GA_Arrays(LW)%A(IW) = GA_Arrays(LW)%A(IW)+ONEADD
        end do
      end do
    end do
  end do

  ! Put W on disk
  ICASE = 4
  call MKRHS_SAVE(ICASE,ISYM,IVEC,LW)

  call Deallocate_GA_Array(LW)
end do

end subroutine MKRHSC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine QMPosition(EHam,Cordst,Coord,Forcek
     &                     ,dLJrep,Ract,iQ_Atoms)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"

      Dimension Cordst(MxCen*MxPut,3),Coord(MxAt*3)

*
*-- First the harmonic potential that keeps QM close to centre.
*
      dDepart=(Cordst(1,1)-Coord(1))**2
     &       +(Cordst(1,2)-Coord(2))**2
     &       +(Cordst(1,3)-Coord(3))**2
      EHam=Forcek*0.5d0*dDepart

*
*-- Second the repulsion with boundary that keeps QM away from
*   boundary.
*
      RMax=0.0d0
      Do 901, iAt=1,iQ_Atoms
        R=Cordst(iAt,1)**2+Cordst(iAt,2)**2+Cordst(iAt,3)**2
        R=sqrt(R)
        Diff=Ract-R
        EHam=EHam+(dLJRep/Diff)**12
901   Continue

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Roland Lindh                                     *
************************************************************************
      Subroutine RotGrd(RA,ZA,O,dOdx,d2Odx2,nAtoms,Do_Grad,Do_Hess)
************************************************************************
*                                                                      *
*     Object: Compute the principle axis system and to optionally      *
*             evaluate the gradient of the principle axis system.      *
*                                                                      *
*             See: B. G. Johnson et al., CPL, 220, 377 (1994).         *
*                                                                      *
*     Author: R. Lindh, Dept. of Chem. Phys., Univ. of Lund, Sweden.   *
*                                                                      *
*             Created on board M/S Polarlys on voyage from Tromso to   *
*             Trondheim, Sept. 2003.                                   *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 RA(3,nAtoms), ZA(nAtoms),
     &       O(3,3), dOdx(3,3,nAtoms,3), d2Odx2(3,3,nAtoms,3,nAtoms,3),
     &               dMdx(3,3), dMdy(3,3),
     &       EVal(3), T(3),
     &       Px(3,3), Py(3,3)
      Logical Do_Grad, Rot_Corr, Do_Hess
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('RotGrd: RA',' ',RA,3,nAtoms)
      Call RecPrt('RotGrd: ZA',' ',ZA,1,nAtoms)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the total charge
*
      Z_Tot=DDot_(nAtoms,[One],0,ZA,1)
*
*---- Form the center of nuclear charge
*
      Call Compute_T(Z_Tot,T,ZA,RA,nAtoms)
*
*---- Form O
*
      Call Compute_O(ZA,RA,nAtoms,Z_Tot,T,O,EVal)
*                                                                      *
************************************************************************
*                                                                      *
      If (.Not.Do_Grad) Return
*                                                                      *
************************************************************************
*                                                                      *
*     Turn off rotational correction to the gradient if the eigen
*     vectors are close to degeneracy!
*
      Rot_Corr=.True.
      If (Abs(Eval(1)-Eval(2))/(EVal(1)+EVal(2)).lt.0.001D0) Then
         Write (6,*) 'Rotational correction to the DFT gradient is '
     &             //'turned off due to close-to-degeneracy problems!'
         Rot_Corr=.False.
      End If
      If (Abs(Eval(1)-Eval(3))/(EVal(1)+EVal(3)).lt.0.001D0) Then
         Write (6,*) 'Rotational correction to the DFT gradient is '
     &             //'turned off due to close-to-degeneracy problems!'
         Rot_Corr=.False.
      End If
      If (Abs(Eval(2)-Eval(3))/(EVal(2)+EVal(3)).lt.0.001D0) Then
         Write (6,*) 'Rotational correction to the DFT gradient is '
     &             //'turned off due to close-to-degeneracy problems!'
         Rot_Corr=.False.
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the gradient
*
      Do iAtom = 1, nAtoms
         dTdRAi=ZA(iAtom)/Z_Tot
         Do iCar = 1, 3
*
*---------- Form dO/dx
*
            Call Compute_dOdx(ZA,RA,nAtoms,T,O,EVal,Rot_Corr,
     &                        iAtom,iCar,dTdRAi,dMdx,
     &                        dOdx(1,1,iAtom,iCar),Px)
*
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (.Not.Do_Hess) Return
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the Hessian
*
      Do iAtom = 1, nAtoms
         dTdRAi=ZA(iAtom)/Z_Tot
         Do iCar = 1, 3
            Call Compute_dOdx(ZA,RA,nAtoms,T,O,EVal,Rot_Corr,
     &                        iAtom,iCar,dTdRAi,dMdx,
     &                        dOdx(1,1,iAtom,iCar),Px)
*
            Do jAtom = 1, iAtom
               dTdRAj=ZA(jAtom)/Z_Tot
               jCar_Max = 3
               If (iAtom.eq.jAtom) jCar_Max = iCar
               Do jCar = 1, jCar_Max
                  Call Compute_dOdx(ZA,RA,nAtoms,T,O,EVal,Rot_Corr,
     &                              jAtom,jCar,dTdRAj,dMdy,
     &                              dOdx(1,1,jAtom,jCar),Py)
*
*---------------- Form d2O/dx2
*
                  Call Compute_d2Odx2(ZA,RA,nAtoms,T,O,EVal,Rot_Corr,
     &                                iAtom,iCar,dTdRAi,dMdx,
     &                                dOdx(1,1,iAtom,iCar),Px,
     &                                jAtom,jCar,dTdRAj,dMdy,
     &                                dOdx(1,1,jAtom,jCar),Py,
     &                                d2Odx2(1,1,iAtom,iCar,jAtom,jCar))
*
                  If (iAtom.ne.jAtom .or.
     &                (iAtom.eq.jAtom.and.iCar.ne.jCar)) Then
                      call dcopy_(9,d2Odx2(1,1,iAtom,iCar,jAtom,jCar),1,
     &                             d2Odx2(1,1,jAtom,jCar,iAtom,iCar),1)
                  End If
*
               End Do  ! jCar
            End Do     ! iCar
*
         End Do        ! jAtom
      End Do           ! iAtom
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
*               1993, Per-Olof Widmark                                 *
************************************************************************
      Subroutine OrdIn1(iOpt,Buf0,lBuf0,iBatch)
************************************************************************
*                                                                      *
*     Purpose: Read a buffer of ordered two electron integrals         *
*                                                                      *
*     Note:    This subroutine has internal buffers.                   *
*                                                                      *
*    Calling parameters:                                               *
*    Buf0   : contains on output the integrals                         *
*    lBuf0  : number of integrals to be transfered                     *
*    iOpt   : option code (iOpt=1:start reading at first integral)     *
*                         (iOpt=2:continue reading)                    *
*    rc     : return code                                              *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    TwoDat : table of contents and auxiliary information              *
*    TowRc  : Table of return code                                     *
*    TwoDef : definitions of record structure                          *
*    TwoBuf : save area for buffering of two electron integrals        *
*                                                                      *
*    Local data declarations: none                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.O. Widmark                                 *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
      External C2R8
      Real*8 C2R8
*
#include "Molcas.fh"
#include "TwoDat.fh"
#include "TwoDef.fh"
*---------------------------------------------------------------------*
*                                                                     *
*     This is a buffer exculsively used for I/O buffering             *
*     of the ordered 2-el. integrals file                             *
*                                                                     *
*     !!!     The current version uses one buffer only     !!!        *
*     !!! Double buffering and asynchronous I/O is preseen !!!        *
*                                                                     *
*---------------------------------------------------------------------*
      Character*1 Buf1(8*lStRec)
      Save Buf1

#include "SysDef.fh"
*
      Real*8 Buf0(*)
      Save kOpt
*---------------------------------------------------------------------*
*     Fetch the unit number, disk start adress and pointers           *
*---------------------------------------------------------------------*
      LuTwo=AuxTwo(isUnit)
      iDisk1=AuxTwo(isDaDa)
      isBuf1=AuxTwo(isUpk8)
      lBuf1=AuxTwo(islBf1)
*---------------------------------------------------------------------*
*     If this is the first block of a symmetry batch                  *
*     get the disk disk start adress and load the buffer              *
*---------------------------------------------------------------------*
      If ( iOpt.eq.1 ) then
        iDisk1=TocTwo(isDAdr+iBatch-1)
        jOpt=2
        Call cdDAFILE(LuTwo,jOpt,Buf1,lStRec,iDisk1)
*---------------------------------------------------------------------*
*                                                                     *
*       Note:                                                         *
*       If the records are organized in sequential order              *
*       (SORT3 in SEWARD is activated)                                *
*       deactivate the update of the disk adress                      *
*                                                                     *
*       iDisk1=NINT(C2R8(Buf1(1)))                                    *
*---------------------------------------------------------------------*
        lBuf1=nint(C2R8(Buf1(17)))
        kOpt=nint(C2R8(Buf1(25)))
        isBuf1=lTop*RtoB+1
      End If
*---------------------------------------------------------------------*
*     If the number of requested integrals is smaller than            *
*     the current buffer transfer data                                *
*---------------------------------------------------------------------*
      If ( lBuf0.le.lBuf1 ) then
        Call cUPKR8(kOpt,lBuf0,nByte,Buf1(isBuf1),Buf0)
        isBuf1=isBuf1+nByte
        lBuf1=lBuf1-lBuf0
*---------------------------------------------------------------------*
*     If the number of requested integrals is larger than             *
*     the current buffer first drain the current buffer and           *
*     read as many subsequent buffers as needed                       *
*---------------------------------------------------------------------*
      Else
        Call cUPKR8(kOpt,lBuf1,nByte,Buf1(isBuf1),Buf0)
        isBuf0=lBuf1+1
        nleft=lBuf0-lBuf1
        Do while ( nleft.gt.0 )
          jOpt=2
          Call cdDAFILE(LuTwo,jOpt,Buf1,lStRec,iDisk1)
*---------------------------------------------------------------------*
*                                                                     *
*         Note:                                                       *
*         If the records are organized in sequential order            *
*         (SORT3 in SEWARD is activated)                              *
*         deactivate the update of the disk adress                    *
*                                                                     *
*         iDisk1=NINT(C2R8(Buf1(1)))                                  *
*---------------------------------------------------------------------*
          lBuf1=nint(C2R8(Buf1(17)))
          ncopy=min(nleft,lBuf1)
          kOpt=nint(C2R8(Buf1(25)))
          isBuf1=lTop*RtoB+1
          Call cUPKR8(kOpt,ncopy,nByte,Buf1(isBuf1),Buf0(isBuf0))
          isBuf0=isBuf0+ncopy
          isBuf1=lTop*RtoB+1+nByte
          lBuf1=lBuf1-ncopy
          nleft=nleft-ncopy
        End Do
      End If
*---------------------------------------------------------------------*
*     Update pointer to next disk adress and integral to unpack       *
*---------------------------------------------------------------------*
      AuxTwo(isDaDa)=iDisk1
      AuxTwo(isUpk8)=isBuf1
      AuxTwo(islBf1)=lBuf1
*---------------------------------------------------------------------*
*     exit                                                            *
*---------------------------------------------------------------------*
      Return
*
*     This is to allow type punning without an explicit interface
      Contains
      SubRoutine cdDAFILE(Lu,iOpt,Buf,lBuf_,iDisk_)
      Use Iso_C_Binding
      Integer Lu, iOpt, lBuf_, iDisk_
      Character, Target :: Buf(*)
      Real*8, Pointer :: pBuf(:)
      Call C_F_Pointer(C_Loc(Buf(1)),pBuf,[lBuf_])
      Call dDAFILE(Lu,iOpt,pBuf,lBuf_,iDisk_)
      Nullify(pBuf)
      End SubRoutine cdDAFILE
      Subroutine cUPKR8(iOpt,nData,nByte,InBuf,OutBuf)
      Use Iso_C_Binding
      Integer :: iOpt,nData,nByte
      Character, Target :: InBuf(*)
      Real*8 :: OutBuf(*)
      Real*8, Pointer :: dBuf(:)
      Call C_F_Pointer(C_Loc(InBuf(1)),dBuf,[nData])
      Call UPKR8(iOpt,nData,nByte,dBuf,OutBuf)
      Nullify(dBuf)
      End Subroutine cUPKR8
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_getint (wrk,wrksize,
     & i,symi,possr0,mapdr,mapir,rc)
c
c     this routine read integrals R_i(a,bc) for given i in given symi
c
c     i      - number of orbital (I)
c     symi   - irrep of i (I)
c     possr0 - initial possition of R (I)
c     mapdr  - direct map of R (I)
c     mapir  - inverse map of R (I)
c     rc     - return (error) code (O)
c
       implicit none
#include "t31.fh"
#include "wrk.fh"
c
       integer i,symi,possr0,rc
c
       integer mapdr(0:512,1:6)
       integer mapir(1:8,1:8,1:8)
c
c     help variables
c
       integer iadd,lun,isym,num
c      integer rc1
       integer poss,length,im
c
c1    some tests
c
       if (i.gt.noa(symi)) then
c     RC=1 : i is higher than occipied in this irrep (Stup)
       rc=1
       return
       end if
c
       if (i.lt.1) then
c     RC=2 : i is less than 1 (Stup)
       rc=2
       return
       end if
c
c2    calc number for this orbital
c
       iadd=0
       if (symi.gt.1) then
       do 10 isym=1,symi-1
       iadd=iadd+noa(isym)
 10     continue
       end if
c
       num=iadd+i
c
c
c3    get R
c
       lun=1
       daddr(lun)=T3IntPos(num)
c
       call daname (lun,t3nam)
c
       call idafile (lun,2,mapdr,513*6,daddr(lun))
       call idafile (lun,2,mapir,8*8*8,daddr(lun))
c
       poss=possr0
       length=0
       do im=1,mapdr(0,5)
         mapdr(im,1)=poss
         poss=poss+mapdr(im,2)
         length=length+mapdr(im,2)
c        write (*,99) ' MAP',(mapdr(im,k),k=1,6)
c99       format (a3,i8,2x,i8,4(2x,i2))
       end do
c
       if (length.gt.0) then
         call ddafile (lun,2,wrk(possr0),length,daddr(lun))
       end if
c      call cct3_getmediate (wrk,wrksize,
c    & lun,possr0,mapdr,mapir,rc1)

       call daclos (lun)
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE TAB2(NREF,IOCR,nIOCR,L0,L1,L2,L3,INTNUM,LV,LSYM,
     *ICIALL,IFCORE,ICOR,NONE,JONE)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IOCR(nIOCR),L0(*),L1(*),L2(*),L3(*),ICOR(*),
     *JONE(*)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      DIMENSION IORB(MXVERT)
      DIMENSION K00(MXVERT),K11(MXVERT),K22(MXVERT),K33(MXVERT)
      DIMENSION L00(MXVERT),L11(MXVERT),L22(MXVERT),L33(MXVERT)
*
      IEL=2
      IF(IFIRST.NE.0)IEL=1
*
C     NUMBER OF ACTIVE ELECTRONS
      NAC=N-2*NIORB
*
C     UPPER LIMIT FOR NUMBER OF ELECTRONS IN ACTIVE SPACE
      NACU=NAC+IEL
*
      IUT=0
      IB(1)=INT(2*S)
      IA(1)=INT(N-2*S)/2
      IJ(LN+1)=0
      IJ(LN)=1
      NIJ=1
      IJR=1
      IJS=2
      IJRL=IJR
      IORB(1)=0
      DO 10 II=1,LN
         IIM=LN-II+1-LV
         IAC=IIM-NIORB-1
         IIM2=(IIM-1)*2
*
C        S=0
*
16       INUM=N-2*IA(IJR)-IB(IJR)
         IF(INTNUM.EQ.0.OR.IIM.LE.0)GO TO 109
         IF(IAC.GE.0)GO TO 409
         IF(IB(IJR).EQ.0)GO TO 109
         IF(INUM+IIM2.EQ.N-2)GO TO 11
         GO TO 109
409      IF(IB(IJR).GT.IAC+3)GO TO 11
109      NIJ=NIJ+1
         IA(NIJ)=IA(IJR)
         IB(NIJ)=IB(IJR)
         IORB(NIJ)=IORB(IJR)+2
         IF(IIM.LE.0)GO TO 11
         CALL CHEL(IA(NIJ),IB(NIJ),IIM,IEL,ISTOP)
         IF(ISTOP.EQ.1)NIJ=NIJ-1
*
C        S=1
*
11       IF(IB(IJR).EQ.0)GO TO 12
         IF(INTNUM.EQ.0.OR.IIM.LE.0)GO TO 112
         IF(IAC.LT.0)GO TO 112
         IF(INUM+1.GT.NACU)GO TO 12
         IF(INUM+1.NE.NACU)GO TO 112
         IBS=IB(IJR)-1
         IF(IBS.NE.0.AND.IBS.NE.2)GO TO 12
112      NIJ=NIJ+1
         IA(NIJ)=IA(IJR)
         IB(NIJ)=IB(IJR)-1
         IORB(NIJ)=IORB(IJR)+1
         IF(IIM.LE.0)GO TO 12
         CALL CHEL(IA(NIJ),IB(NIJ),IIM,IEL,ISTOP)
         IF(ISTOP.EQ.1)NIJ=NIJ-1
*
C        S=2
*
12       IF(IA(IJR).EQ.0)GO TO 13
         IF(INTNUM.EQ.0.OR.IIM.LE.0)GO TO 113
         IF(IAC.LT.0)GO TO 413
         IF(IB(IJR)+1.GT.IAC+3)GO TO 13
         IF(INUM+1.GT.NACU)GO TO 13
         IF(INUM+1.NE.NACU)GO TO 113
         IBS=IB(IJR)+1
         IF(IBS.NE.0.AND.IBS.NE.2)GO TO 13
         GO TO 113
413      IF(IB(IJR).GE.2)GO TO 13
113      NIJ=NIJ+1
         IA(NIJ)=IA(IJR)-1
         IB(NIJ)=IB(IJR)+1
         IORB(NIJ)=IORB(IJR)+1
         IF(IIM.LE.0)GO TO 13
         CALL CHEL(IA(NIJ),IB(NIJ),IIM,IEL,ISTOP)
         IF(ISTOP.EQ.1)NIJ=NIJ-1
*
C        S=3
*
13       IF(IA(IJR).EQ.0)GO TO 14
         IF(INTNUM.EQ.0)GO TO 114
         IF(IAC.LT.0)GO TO 114
         IF(IB(IJR).GT.IAC+3)GO TO 14
         IF(INUM+2.GT.NACU)GO TO 14
         IF(INUM+2.NE.NACU)GO TO 114
         IBS=IB(IJR)
         IF(IBS.NE.0.AND.IBS.NE.2)GO TO 14
114      NIJ=NIJ+1
         IA(NIJ)=IA(IJR)-1
         IB(NIJ)=IB(IJR)
         IORB(NIJ)=IORB(IJR)
         IF(IIM.LE.0)GO TO 14
         CALL CHEL(IA(NIJ),IB(NIJ),IIM,IEL,ISTOP)
         IF(ISTOP.EQ.1)NIJ=NIJ-1
*
14       IF(IJR.EQ.IJRL)GO TO 15
         IJR=IJR+1
         GO TO 16
C        DELETE VERTICES
15       NIJ1=NIJ-1
         IN=IJS
         IUT=IJS
         IF(NIJ1.LT.IJS)GO TO 21
         DO 20 IJD=IJS,NIJ1
            JJ1=NIJ-IJD+IJS-1
            J=JJ1+1
            DO 25 K=IJS,JJ1
               IF(IA(J).NE.IA(K))GO TO 25
               IF(IB(J).NE.IB(K))GO TO 25
               GO TO 26
25          CONTINUE
            GO TO 20
26          IA(J)=-1
            IB(J)=-1
20       CONTINUE
C        PACK VERTICES
         IJS1=IJS+1
         DO 30 J=IJS1,NIJ
            IF(IA(J).NE.-1)GO TO 31
            IF(IB(J).NE.-1)GO TO 31
            IN=IN+1
            GO TO 30
31          IN=IN+1
            IUT=IUT+1
            IA(IUT)=IA(IN)
            IB(IUT)=IB(IN)
            IORB(IUT)=IORB(IN)
30       CONTINUE
C        ORDER VERTICES
         IUT1=IUT-1
         IF(IUT1.LT.IJS)GO TO 21
         DO 41 J=IJS,IUT1
            J11=J+1
            DO 42 K=J11,IUT
               IF (IA(J)-IA(K).LT.0) THEN
                  GO TO 43
               ELSE IF (IA(J)-IA(K).EQ.0) THEN
                  GO TO 44
               ELSE
                  GO TO 42
               END IF
44             IF(IB(J).GT.IB(K))GO TO 42
43             IAT=IA(J)
               IBT=IB(J)
               IA(J)=IA(K)
               IB(J)=IB(K)
               IA(K)=IAT
               IB(K)=IBT
42          CONTINUE
41       CONTINUE
21       IF(II.NE.LN)IJ(LN-II)=IUT
         IJR=IJS
         IJS=IUT+1
         IJRL=IUT
         NIJ=IUT
10    CONTINUE
      IF(N.NE.2)GO TO 35
      IUT=IUT+1
      IA(IUT)=0
      IB(IUT)=0
      IA(IUT-1)=0
      IB(IUT-1)=1
      IA(IUT-2)=0
      IB(IUT-2)=2
35    JJ2=0
      DO 40 II=1,LN
         I=LN-II+1-LV
         IIM2=(I-1)*2
         I0=I+LV
         JJ1=IJ(I0+1)+1
         JJ2=IJ(I0)
         J3=JJ2+1
         IF(I0.NE.1)J4=IJ(I0-1)
         IF(I0.EQ.1)J4=IUT
C        DETERMINE CASE DOWN
         DO 50 J=JJ1,JJ2
            IA1=IA(J)
            IB1=IB(J)
            INUM=2*IA1+IB1
            K00(J)=0
            K11(J)=0
            K22(J)=0
            K33(J)=0
            DO 60 JJ=J3,J4
               IF(IA1.EQ.IA(JJ))GO TO 61
               IF((IA1-IA(JJ)).NE.1)GO TO 60
               IF(IB1.EQ.IB(JJ))GO TO 62
               IF((IB(JJ)-IB1).NE.1)GO TO 60
               IF(I.GT.NIORB.OR.INTNUM.EQ.0)GO TO 59
               IF(I.LE.0)GO TO 59
               IF(IB1.GE.2)GO TO 60
59             K22(J)=JJ
               GO TO 60
62             K33(J)=JJ
               GO TO 60
61             IF(IB1.EQ.IB(JJ))GO TO 63
               IF((IB1-IB(JJ)).NE.1)GO TO 60
               K11(J)=JJ
               GO TO 60
63             IF(I.GT.NIORB.OR.INTNUM.EQ.0)GO TO 64
               IF(I.LE.0)GO TO 64
               IF(IB1.EQ.0)GO TO 64
               IF(INUM-IIM2.EQ.2)GO TO 60
               IF(IA1.LT.I-1)GO TO 60
64             K00(J)=JJ
60          CONTINUE
50       CONTINUE
C        DETERMINE CASE UP
         DO 70 J=J3,J4
            IA1=IA(J)
            IB1=IB(J)
            INUM=2*IA1+IB1
            L00(J)=0
            L11(J)=0
            L22(J)=0
            L33(J)=0
            DO 80 JJ=JJ1,JJ2
               IF(IA(JJ).EQ.IA1)GO TO 81
               IF((IA(JJ)-IA1).NE.1)GO TO 80
               IF(IB(JJ).EQ.IB1)GO TO 82
               IF((IB1-IB(JJ)).NE.1)GO TO 80
               IF(I.GT.NIORB.OR.INTNUM.EQ.0)GO TO 79
               IF(I.LE.0)GO TO 79
               IF(IB1.GE.3)GO TO 80
79             L22(J)=JJ
               GO TO 80
82             L33(J)=JJ
               GO TO 80
81             IF(IB(JJ).EQ.IB1)GO TO 83
               IF((IB(JJ)-IB1).NE.1)GO TO 80
               L11(J)=JJ
               GO TO 80
83             IF(I.GT.NIORB.OR.INTNUM.EQ.0)GO TO 84
               IF(I.LE.0)GO TO 84
               IF(IB1.EQ.0)GO TO 84
               IF(INUM-IIM2.EQ.2)GO TO 80
               IF(IA1.LT.I-1)GO TO 80
84             L00(J)=JJ
80          CONTINUE
70       CONTINUE
40    CONTINUE
      IV0=IUT
      IV1=IUT-1
      IV2=IUT-2
      IV3=IUT-3
      K00(IUT)=0
      K11(IUT)=0
      K22(IUT)=0
      K33(IUT)=0
      K00(IUT+1)=0
      K11(IUT+1)=0
      K22(IUT+1)=0
      K33(IUT+1)=0
      IF(ICIALL.NE.0)CALL CIALL(LSYM,NREF,IOCR,nIOCR,L00,L11,L22,L33,LV)
      CALL DELTAB(NREF,IOCR,L0,L1,L2,L3,INTNUM,LV,IFCORE,ICOR,
     *NONE,JONE,K00,K11,K22,K33,L00,L11,L22,L33)
      DO 103 I=1,ILIM
         ISTA=(I-1)*MXVERT
         IF(IPRINT.GE.5)WRITE(IW,101)
101      FORMAT(///,6X,'TAB2',//,8X,'J',8X,'A',3X,'B',7X,
     *   'K0',2X,'K1',2X,'K2',2X,'K3',2X,'L0',2X,'L1',2X,'L2',2X,'L3',/)
         IF(IPRINT.GE.5)WRITE(IW,100)(J,IA(J),IB(J),K0(ISTA+J),
     *   K1(ISTA+J),K2(ISTA+J),K3(ISTA+J),L0(ISTA+J),L1(ISTA+J),
     *   L2(ISTA+J),L3(ISTA+J),J=1,IUT)
100   FORMAT(6X,I3,5X,2I4,5X,8I4)
103   CONTINUE
      IBMAX=0
      DO 450 J=1,IUT
         IF(IB(J).GT.IBMAX)IBMAX=IB(J)
450   CONTINUE
      IUT1=IUT-1
      DO 511 IL=1,ILIM
         ISTA=(IL-1)*MXVERT
         IX(ISTA+1)=1
         DO 410 II=1,LN
            IF(II.EQ.LN)GO TO 420
            I=LN-II
            IJL=IJ(I)
            IJS=IJ(I+1)+1
            GO TO 430
420         IJL=IUT
            IJS=IUT-3
            IF(IFIRST.NE.0)IJS=IUT-1
430         DO 440 J=IJS,IJL
            ISUM=0
            IF(L0(ISTA+J).EQ.0)GO TO 441
            ISUM=ISUM+IX(ISTA+L0(ISTA+J))
441         IF(L1(ISTA+J).EQ.0)GO TO 442
            IY(ISTA+L1(ISTA+J),1)=ISUM
            ISUM=ISUM+IX(ISTA+L1(ISTA+J))
442         IF(L2(ISTA+J).EQ.0)GO TO 443
            IY(ISTA+L2(ISTA+J),2)=ISUM
            ISUM=ISUM+IX(ISTA+L2(ISTA+J))
443         IF(L3(ISTA+J).EQ.0)GO TO 444
            IY(ISTA+L3(ISTA+J),3)=ISUM
            ISUM=ISUM+IX(ISTA+L3(ISTA+J))
444         IX(ISTA+J)=ISUM
440         CONTINUE
410      CONTINUE
511   CONTINUE
      DO 104 I=1,ILIM
         ISTA=(I-1)*MXVERT
         IF(IPRINT.GE.5)WRITE(IW,102)
102      FORMAT(///,6X,'INDEX TABLE',//,8X,'J',8X,'Y1',3X,'Y2',
     *   3X,'Y3',9X,'X',/)
         IF(IPRINT.GE.5)WRITE(IW,200)(J,IY(ISTA+J,1),IY(ISTA+J,2),
     *   IY(ISTA+J,3),IX(ISTA+J),J=1,IUT)
200      FORMAT(6X,I3,5X,3I5,5X,I5)
104   CONTINUE
      IF(IPRINT.GE.2)WRITE(IW,210)IUT
210   FORMAT(/,6X,'NUMBER OF VERTICES',I10)
      WRITE(IW,214)
214   FORMAT(///,6X,'INTERNAL CONFIGURATIONS (FORMAL)')

      IF (IFIRST.EQ.0) THEN
* This is a normal calculation, both singles and doubles included.
      WRITE(IW,215)(IX(IUT+1-ITTT+MXVERT*(ITTT-1)),ITTT=1,4)
215   FORMAT(/,6X,'NUMBER OF VALENCE STATES',I16,
     */,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7,
     */,6X,'NUMBER OF TRIPLET COUPLED DOUBLES',I7,
     */,6X,'NUMBER OF SINGLET COUPLED DOUBLES',I7)
      ELSE
* ''FIRST'' keyword has been given. Then this is just a so-called
* first-order CI, i.e., singles only.
      WRITE(IW,215)(IX(IUT+1-ITTT+MXVERT*(ITTT-1)),ITTT=1,2)
c216   FORMAT(/,6X,'NUMBER OF VALENCE STATES',I16,
c     */,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7)
      END IF

      IRC(1)=IX(IUT)
      DO 8 I=2,ILIM
         ISTA=(I-1)*MXVERT
         IRC(I)=IX(ISTA+IUT+1-I)+IRC(I-1)
8     CONTINUE
      ISUM=IRC(ILIM)
      If (ISUM.GT.LIX) Then
         Write(6,*) 'Tab2: ISUM.GT.LIX'
         Write(6,*) 'ISUM,LIX=',ISUM,LIX
         Call Abend
      End If
      DO 5 I=1,10
         FBB=I-1
         FB=FBB/(FBB+1)
         BS1(I)=SQRT(FB)
         FB=(FBB+2)/(FBB+1)
         BS2(I)=SQRT(FB)
         IF(I.GT.1)BS3(I)=D1/BS1(I)
         BS4(I)=D1/BS2(I)
         FB=FBB*FBB-1
         IF(I.GT.1)BL1(I)=SQRT(FB)/FBB
         FB=(FBB+2)**2-1
         BL2(I)=SQRT(FB)/(FBB+2)
5     CONTINUE
C     PUT ZEROS IN VECTORS
      DO 6 I=1,LN
         COUP(I)=D0
         COUP1(I)=D0
6     CONTINUE
      IN=0
      DO 305 I=1,LN
         II=LN-I+1
         IJS=IJ(II+1)+1
         IJL=IJ(II)
         IJFS=IJF(II+1)+1
         IJFL=IJF(II)
         DO 320 IIJ=IJS,IJL
            DO 330 IIJF=IJFS,IJFL
               IF(IA(IIJ).NE.IAF(IIJF))GO TO 330
               IF(IB(IIJ).NE.IBF(IIJF))GO TO 330
               IPO(IIJ)=IIJF
               GO TO 320
330         CONTINUE
320      CONTINUE
305   CONTINUE
      IPO(IUT)=IJF(1)+1
      IF(IPRINT.GE.10)WRITE(IW,350)(IPO(J),J=1,IUT)
350   FORMAT(/,6X,5I5)
      JMAX=0
      LN1=LN+1
      DO 400 I=2,LN1
         I1=I-1
         JL=IJ(I1)-IJ(I)
         IF(JL.LT.JMAX)GO TO 400
         JMAX=JL
400   CONTINUE
*
      IF (IPRINT.GE.2) THEN
         WRITE(IW,411)JMAX
         WRITE(IW,412)IBMAX, MAXB
411      FORMAT(/,6X,'NUMBER OF VERTICES IN ONE ROW',I6,
     &     6X,'(PRESENT LIMIT 31)')
         IF(JMAX.GT.31) Call Abend
412      FORMAT(6X,'MAXIMUM B VALUE',I20,6X,'(PRESENT LIMIT ',I5,')')
      END IF
      IF(IBMAX.GT.MAXB) Call Abend
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Steven Vancoillie                                *
!               2017, Stefan Knecht                                    *
!***********************************************************************
! author: S. Knecht (modified version of pt2wfn.f in CASPT2 written by
!                    S. Vancoillie)
!***********************************************************************

module nevpt2wfn

use Definitions, only: iwp

implicit none
private

logical(kind=iwp) :: pt2wfn_is_h5 = .false.
integer(kind=iwp) :: pt2wfn_id, pt2wfn_refene, pt2wfn_energy_sc, pt2wfn_energy_pc, pt2wfn_mocoef, pt2wfn_heff_sc, pt2wfn_heff_pc, &
                     pt2wfn_ref_checkpoint

public :: nevpt2wfn_close, nevpt2wfn_data, nevpt2wfn_estore, nevpt2wfn_init

contains

! Create a wavefunction file and replace any existing .wfn file
subroutine nevpt2wfn_init(create_h5)

  use refwfn, only: refwfn_active
# ifdef _HDF5_
  use nevpt2_cfg, only: MultGroup, no_pc, nr_active_electrons, nr_states, nSpin
  use stdalloc, only: mma_allocate, mma_deallocate
  use mh5, only: mh5_create_file, mh5_init_attr, mh5_create_dset_str, mh5_create_dset_real, mh5_put_dset, mh5_close_dset
# endif

  logical(kind=iwp), intent(in) :: create_h5
# ifndef _HDF5_
# include "macros.fh"
  unused_var(create_h5)
# else
# include "rasdim.fh"
# include "caspt2.fh"
# include "pt2_guga.fh"
  integer(kind=iwp) :: dsetid, i
  character, allocatable :: typestring(:)
# endif

  if (refwfn_active) then
    call WarningMessage(2,'Active reference wavefunction file, cannot create new PT2 wavefunction file, aborting!')
    call AbEnd()
  end if

# ifdef _HDF5_
  if (create_h5) then
    pt2wfn_is_h5 = .true.

    !> create a new wavefunction file!
    pt2wfn_id = mh5_create_file('NEVPT2WFN')

    !> set module type
    call mh5_init_attr(pt2wfn_id,'MOLCAS_MODULE','NEVPT2')

    !> copy basic molecular information to the HDF5 file
    call run2h5_molinfo(pt2wfn_id)
    call one2h5_ovlmat(pt2wfn_id,nsym,nbas)
    call one2h5_fckint(pt2wfn_id,nsym,nbas)
    call one2h5_crtmom(pt2wfn_id,nsym,nbas)

    !> set wavefunction type
    call mh5_init_attr(pt2wfn_id,'CI_TYPE','CAS')

    !> general wavefunction attributes
    call mh5_init_attr(pt2wfn_id,'SPINMULT',nSpin)
    call mh5_init_attr(pt2wfn_id,'LSYM',stSym)
    call mh5_init_attr(pt2wfn_id,'NACTEL',nr_active_electrons)
    call mh5_init_attr(pt2wfn_id,'NHOLE1',0)
    call mh5_init_attr(pt2wfn_id,'NELEC3',0)
    call mh5_init_attr(pt2wfn_id,'NCONF',1)
    call mh5_init_attr(pt2wfn_id,'NSTATES',nr_states)

    !> keep it for compatibility
    call mh5_init_attr(pt2wfn_id,'L2ACT',1,[MXLEV],L2ACT)
    call mh5_init_attr(pt2wfn_id,'A2LEV',1,[MXLEV],LEVEL)

    !> molecular orbital type index
    call mma_allocate(typestring,nbast)
    call orb2tpstr(NSYM,NBAS,NFRO,NISH,NRAS1,NRAS2,NRAS3,NSSH,NDEL,typestring)
    dsetid = mh5_create_dset_str(pt2wfn_id,'MO_TYPEINDICES',1,[NBAST],1)
    call mh5_init_attr(dsetid,'DESCRIPTION', &
                       'Type index of the molecular orbitals arranged as blocks of size [NBAS(i)], i=1,#irreps')
    call mh5_put_dset(dsetid,typestring)
    call mma_deallocate(typestring)
    call mh5_close_dset(dsetid)

    !> roots
    !call mh5_init_attr (pt2wfn_id,'STATE_ROOTID',1,[nr_states],MultGroup%state)

    !> setup dummy root to state translation
    root2state = 0
    do i=1,nr_states
      root2state(i) = i
    end do

    call mh5_init_attr(pt2wfn_id,'STATE_ROOTID',1,[nr_states],root2state)

    !> setup dummy root to state translation - part 2 -
    root2state = 0
    do i=1,nr_states
      root2state(i) = MultGroup%state(i)
    end do

    call mh5_init_attr(pt2wfn_id,'ROOT2STATE',1,[nr_states],ROOT2STATE)

    !> reference energy (for each state)
    pt2wfn_refene = mh5_create_dset_real(pt2wfn_id,'STATE_REFWF_ENERGIES',1,[nr_states])
    call mh5_init_attr(pt2wfn_refene,'DESCRIPTION','Reference energy for each state, arranged as array of [nr_states]')

    !> PT2 energy (SC for each state)
    pt2wfn_energy_sc = mh5_create_dset_real(pt2wfn_id,'STATE_PT2_ENERGIES_SC',1,[nr_states])
    call mh5_init_attr(pt2wfn_energy_sc,'DESCRIPTION','PT2 energy (SC) for each state, arranged as array of [nr_states]')
    !> effective Hamiltonian (SC)
    pt2wfn_heff_sc = mh5_create_dset_real(pt2wfn_id,'H_EFF_SC',2,[nr_states,nr_states])
    call mh5_init_attr(pt2wfn_heff_sc,'DESCRIPTION', &
                       'Effective QD-NEVPT2 hamiltonian (SC), arranged as matrix of size [nr_states,nr_states]')

    !> molecular orbital coefficients
    pt2wfn_mocoef = mh5_create_dset_real(pt2wfn_id,'MO_VECTORS',1,[NBSQT])
    call mh5_init_attr(pt2wfn_mocoef,'DESCRIPTION', &
                       'Coefficients of the average orbitals, arranged as blocks of size [NBAS(i)**2], i=1,#irreps')

    if (.not. no_pc) then
      !> PT2 energy (PC for each state) - default
      pt2wfn_energy_pc = mh5_create_dset_real(pt2wfn_id,'STATE_PT2_ENERGIES',1,[nr_states])
      call mh5_init_attr(pt2wfn_energy_pc,'DESCRIPTION','PT2 energy (PC) for each state, arranged as array of [nr_states]')
      !> effective Hamiltonian (PC) - default
      pt2wfn_heff_pc = mh5_create_dset_real(pt2wfn_id,'H_EFF',2,[nr_states,nr_states])
      call mh5_init_attr(pt2wfn_heff_pc,'DESCRIPTION', &
                         'Effective QD-NEVPT2 hamiltonian (PC), arranged as matrix of size [nr_states,nr_states]')

    end if

#   ifdef _DMRG_
    !> maximum allowed filename length is equal to MH5_MAX_LBL_LEN=256
    pt2wfn_ref_checkpoint = mh5_create_dset_str(pt2wfn_id,'QCMAQUIS_CHECKPOINT',1,[nr_states],256)
    call mh5_init_attr(pt2wfn_ref_checkpoint,'DESCRIPTION','QCMaquis checkpoint directory names for each root in [nr_states].')
#   endif
  else
# endif
    pt2wfn_is_h5 = .false.
# ifdef _HDF5_
  end if
# endif

end subroutine nevpt2wfn_init

subroutine nevpt2wfn_data()

# ifdef _HDF5_
# ifdef _DMRG_
  use qcmaquis_info, only: qcm_group_names
# endif
  use nevpt2_cfg, only: MultGroup
  use mh5, only: mh5_put_dset
  use stdalloc, only: mma_allocate, mma_deallocate
  use Definitions, only: wp

# include "rasdim.fh"
# include "caspt2.fh"
  real(kind=wp), allocatable :: BUF(:)
  integer(kind=iwp) :: IDISK
# ifdef _DMRG_
  integer(kind=iwp) :: i
# endif

  if (pt2wfn_is_h5) then
    call mma_allocate(BUF,NCMO)
    IDISK = 0
    call DDAFILE(LUONEM,2,BUF,NCMO,IDISK)
    call mh5_put_dset(pt2wfn_mocoef,BUF)
    call mma_deallocate(BUF)
#   ifdef _DMRG_
    if (allocated(qcm_group_names)) then
      do i=1,size(MultGroup%State)
        call mh5_put_dset(pt2wfn_ref_checkpoint,qcm_group_names(1)%states(MultGroup%State(i):MultGroup%State(i)),[1],[i-1])
      end do
    end if
#   endif

  end if
# endif

end subroutine nevpt2wfn_data

subroutine nevpt2wfn_estore()

# ifdef _HDF5_
  use nevpt2_cfg, only: no_pc
  use info_state_energy, only: e, e2en, e2mp, psien, psimp ! energies + effective Hamiltonian
  use mh5, only: mh5_put_dset

  if (pt2wfn_is_h5) then
    !> reference energies aka DMRG-SCF energies
    call mh5_put_dset(pt2wfn_refene,e)
    call mh5_put_dset(pt2wfn_energy_sc,psimp)
    !> effective Hamiltonian
    call mh5_put_dset(pt2wfn_heff_sc,e2mp)
    if (.not. no_pc) then
      !> single-state PC energies
      call mh5_put_dset(pt2wfn_energy_pc,psien)
      !> effective PC Hamiltonian
      call mh5_put_dset(pt2wfn_heff_pc,e2en)
    end if
  end if
# endif

end subroutine nevpt2wfn_estore

subroutine nevpt2wfn_close()

# ifdef _HDF5_
# ifdef _DMRG_
  use qcmaquis_info, only: qcmaquis_info_deinit
# endif
  use mh5, only: mh5_close_file

  if (pt2wfn_is_h5) then
    call mh5_close_file(pt2wfn_id)
    pt2wfn_is_h5 = .false.
    pt2wfn_id = -1
#   ifdef _DMRG_
    call qcmaquis_info_deinit()
#   endif

  end if
# endif

end subroutine nevpt2wfn_close

end module nevpt2wfn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  ScfHandM
*
*> @brief
*>   (i) construct the multicenter multipole expansion for the MO-Hamiltonian,
*>   (ii) read in the one-electron part of the Hamiltonian and
*>   (iii) construct the super-matrix. The last two are MO-transformed
*> @author A. Ohrn
*>
*> @details
*> First call on the MME-routine. It returns things in AO-basis
*> which we need to put into MO-form. Observe that the quadrupoles
*> in Qmstat are ordered differently compared to Molcas. Qmstat:
*> \f$ xx \f$ \f$ xy \f$ \f$ yy \f$ \f$ xz \f$ \f$ yz \f$ \f$ zz \f$; Molcas:
*> \f$ xx \f$ \f$ xy \f$ \f$ xz \f$ \f$ yy \f$ \f$ yz \f$ \f$ zz \f$. Then we
*> read in parts of the unperturbed Hamiltonian and construct the
*> super-matrix.
*>
*> @param[in] Cmo   Orbital coeff.
*> @param[in] nBas  Number of contracted basis functions
*> @param[in] nOcc  Number of contracted basis functions of a certain atom-type
*> @param[in] natyp Number of atoms of a certain atom-type (for water, hydrogen is 2)
*> @param[in] nntyp Number of atom-types in molecule
*> @param[in] Occu  Orbital occupation numbers
************************************************************************
      Subroutine ScfHandM(Cmo,nBas,iQ_Atoms,nOcc,natyp,nntyp,Occu)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "qm1.fh"
#include "WrkSpc.fh"
#include "tratoc.fh"

      Dimension Cmo(MxBas**2),Occu(MxBas),nOcc(MxBas),natyp(MxAt)
      Dimension nBas(MxSym),iCent(MxBas*MxBas)
      Dimension iMME(MxMltp*(MxMltp+1)*(MxMltp+2)/6)
      Character MMElab*20,ChCo*2

*----------------------------------------------------------------------*
* Zeros.                                                               *
*----------------------------------------------------------------------*
      iCi=iQ_Atoms*(iQ_Atoms+1)/2
      Do 51, i=1,iOrb(1)*(iOrb(1)+1)/2
        Do 52, j=1,iCi
          Cha(i,j)=0
          DipMy(i,1,j)=0
          DipMy(i,2,j)=0
          DipMy(i,3,j)=0
          Quad(i,1,j)=0
          Quad(i,2,j)=0
          Quad(i,3,j)=0
          Quad(i,4,j)=0
          Quad(i,5,j)=0
          Quad(i,6,j)=0
52      Continue
51    Continue

*
*-- MulticenterMultipoleExpansion
*
*
*--- First get the expansion in AO-format.
*
      Call GetMem('Dummy','Allo','Inte',iDum,nBas(1)**2)
      Call MultiNew(iQ_Atoms,nBas(1),nOcc,natyp,nntyp,iMME
     &             ,iWork(iDum),iCent,nMlt,outxyz
     &             ,SlExpQ,lSlater)
      Call GetMem('Dummy','Free','Inte',iDum,nBas(1)**2)

*
*-- If MP2 density correction is requested, go here. This option is
*   not working nicely, alas, hence do not use!
*
      If(Mp2DensCorr) then
        Call Mbpt2Corr(nBas(1),Cmo)
      Endif

*
*--- Then transform this to MO-format since that is the basis we use
*    here!
*
      nTyp=0
      Do 100, i=1,nMlt
        nTyp=nTyp+i*(i+1)/2
100   Continue
      Call GetMem('OnTheWay','Allo','Real',ipO,nTyp)
      kaunter=0
      Do 101, iO1=1,iOrb(1)
        Do 102, iO2=1,iO1
          kaunter=kaunter+1
          kaunta=0
          Do 103, iB1=1,nBas(1)
            Do 104, iB2=1,nBas(1)
              kaunta=kaunta+1
              iX1=max(iB1,iB2)
              iX2=min(iB1,iB2)
              indMME=iX2+iX1*(iX1-1)/2
              cProd=Cmo(iB1+(iO1-1)*nBas(1))*Cmo(iB2+(iO2-1)*nBas(1))
              Do 105, iTyp=1,nTyp
                Work(ipO+iTyp-1)=cProd*Work(iMME(iTyp)+indMME-1)
105           Continue
              Cha(kaunter,iCent(kaunta))=Cha(kaunter,iCent(kaunta))
     &                   +Work(ipO)
           DipMy(kaunter,1,iCent(kaunta))=DipMy(kaunter,1,iCent(kaunta))
     &                   +Work(ipO+1)
           DipMy(kaunter,2,iCent(kaunta))=DipMy(kaunter,2,iCent(kaunta))
     &                   +Work(ipO+2)
           DipMy(kaunter,3,iCent(kaunta))=DipMy(kaunter,3,iCent(kaunta))
     &                   +Work(ipO+3)
             Quad(kaunter,1,iCent(kaunta))=Quad(kaunter,1,iCent(kaunta))
     &                   +Work(ipO+4)
             Quad(kaunter,2,iCent(kaunta))=Quad(kaunter,2,iCent(kaunta))
     &                   +Work(ipO+5)
             Quad(kaunter,3,iCent(kaunta))=Quad(kaunter,3,iCent(kaunta))
     &                   +Work(ipO+7) !Why seven? See <Description>
             Quad(kaunter,4,iCent(kaunta))=Quad(kaunter,4,iCent(kaunta))
     &                   +Work(ipO+6)
             Quad(kaunter,5,iCent(kaunta))=Quad(kaunter,5,iCent(kaunta))
     &                   +Work(ipO+8)
             Quad(kaunter,6,iCent(kaunta))=Quad(kaunter,6,iCent(kaunta))
     &                   +Work(ipO+9)
104         Continue
103       Continue
102     Continue
101   Continue
      Call GetMem('OnTheWay','Free','Real',ipO,nTyp)

*
*-- Deallocate the AO-multipoles.
*
      Do 106,i=1,nTyp
        Write(ChCo,'(I2.2)')i
        Write(MMElab,*)'MME'//ChCo
        Call GetMem(MMElab,'Free','Real',iMME(i),nBas(1)*(nBas(1)+1)/2)
106   Continue

*
*-- Put quadrupoles in Buckinghamform.
*
      kaunter=0
      Do 191, i1=1,iOrb(1)
        Do 192, i2=1,i1
          kaunter=kaunter+1
          Do 193, k=1,ici
            Do 194, j=1,6
              Quad(kaunter,j,k)=Quad(kaunter,j,k)*1.5
194         Continue
            Tra=Quad(kaunter,1,k)+Quad(kaunter,3,k)
     &         +Quad(kaunter,6,k)
            Tra=Tra/3
            Quad(kaunter,1,k)=Quad(kaunter,1,k)-Tra
            Quad(kaunter,3,k)=Quad(kaunter,3,k)-Tra
            Quad(kaunter,6,k)=Quad(kaunter,6,k)-Tra
193       Continue
192     Continue
191   Continue
*----------------------------------------------------------------------*
* To conclude, we sum up. This serves two purposes: (1) to make a check*
* if thing have proceeded nicely, (2) to deduce if the QM-molecule is  *
* charged.                                                             *
*----------------------------------------------------------------------*
      qEl=0
      dipx=0
      dipy=0
      dipz=0
      dipx0=0
      dipy0=0
      dipz0=0
      qtot=0
      dTox=0
      dToy=0
      dToz=0
      Call GetMem('TotMME','Allo','Real',iMtot
     &           ,10*iQ_Atoms*(iQ_Atoms+1)/2)
      Call dCopy_(10*iQ_Atoms*(iQ_Atoms+1)/2,[0.0D0],0,Work(iMtot),1)
      Do 110, ii=1,iOrb(1)
        i=ii*(ii+1)/2
        Do 111, j=1,iQ_Atoms*(iQ_Atoms+1)/2
          qEl=qEl+Cha(i,j)*Occu(ii)
          Work(iMtot+10*(j-1))=Work(iMtot+10*(j-1))+Cha(i,j)*Occu(ii)
          dipx=dipx+DipMy(i,1,j)*Occu(ii)
          dipy=dipy+DipMy(i,2,j)*Occu(ii)
          dipz=dipz+DipMy(i,3,j)*Occu(ii)
          Work(iMtot+10*(j-1)+1)=Work(iMtot+10*(j-1)+1)
     &                          +DipMy(i,1,j)*Occu(ii)
          Work(iMtot+10*(j-1)+2)=Work(iMtot+10*(j-1)+2)
     &                          +DipMy(i,2,j)*Occu(ii)
          Work(iMtot+10*(j-1)+3)=Work(iMtot+10*(j-1)+3)
     &                          +DipMy(i,3,j)*Occu(ii)
          dipx0=dipx0+Cha(i,j)*outxyz(j,1)*Occu(ii)
          dipy0=dipy0+Cha(i,j)*outxyz(j,2)*Occu(ii)
          dipz0=dipz0+Cha(i,j)*outxyz(j,3)*Occu(ii)
          Work(iMtot+10*(j-1)+4)=Work(iMtot+10*(j-1)+4)
     &                          +Quad(i,1,j)*Occu(ii)
          Work(iMtot+10*(j-1)+5)=Work(iMtot+10*(j-1)+5)
     &                          +Quad(i,2,j)*Occu(ii)
          Work(iMtot+10*(j-1)+6)=Work(iMtot+10*(j-1)+6)
     &                          +Quad(i,3,j)*Occu(ii)
          Work(iMtot+10*(j-1)+7)=Work(iMtot+10*(j-1)+7)
     &                          +Quad(i,4,j)*Occu(ii)
          Work(iMtot+10*(j-1)+8)=Work(iMtot+10*(j-1)+8)
     &                          +Quad(i,5,j)*Occu(ii)
          Work(iMtot+10*(j-1)+9)=Work(iMtot+10*(j-1)+9)
     &                          +Quad(i,6,j)*Occu(ii)
111     Continue
110   Continue
      If(iPrint.ge.10) then
        Write(6,*)
        Write(6,*)'    Distributed multipole in each centre'
        Write(6,*)'    (Compare with output from MpProp.)'
        Do 1111, j=1,iQ_Atoms*(iQ_Atoms+1)/2
          If(j.le.iQ_Atoms) then
            Work(iMtot+10*(j-1))=Work(iMtot+10*(j-1))-Chanuc(j)
          Endif
          Write(6,*)'      Center: ',j
          Write(6,*)'      Charge: ',-Work(iMtot+10*(j-1))
          Write(6,*)'      Dipole: ',(-Work(iMtot+10*(j-1)+kk),kk=1,3)
          Write(6,*)
1111    Continue
      Endif
      Call GetMem('TotMME','Free','Real',iMtot
     &           ,4*iQ_Atoms*(iQ_Atoms+1)/2)
      Do 112, i=1,iQ_Atoms
        qtot=qtot+ChaNuc(i)
        dTox=dTox+ChaNuc(i)*outxyz(i,1)
        dToy=dToy+ChaNuc(i)*outxyz(i,2)
        dToz=dToz+ChaNuc(i)*outxyz(i,3)
112   Continue
      qtot=qtot-qEl
      dTox=dTox-dipx-dipx0
      dToy=dToy-dipy-dipy0
      dToz=dToz-dipz-dipz0
      If(iPrint.ge.5) then
        Write(6,*)
        Write(6,*)'    Summed multipoles for unperturbed w.f.'
        Write(6,*)'      Charge: ',qtot
        Write(6,*)'      Dipole: ',dTox,',',dToy,',',dToz
      Endif
      If(.not.abs(qtot).le.0.0001) ChargedQM=.true.

*
*-- Make a check of the one-electron matrix: is it pure?
*
      Call Chk_OneHam(nBas)

*
*-- So read integrals and construct super-matrix.
*
      Call ScfH0(nBas)

*
*-- The End...
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1998, Roland Lindh                                *
************************************************************************
#define _USE_OLD_CODE_
#ifdef _USE_OLD_CODE_
      Subroutine FckAcc_mck(iAng, iCmp,jCmp,kCmp,lCmp,Shijij,
     &                  iShll, iShell, kOp, nijkl,
     &                  AOInt,TwoHam,nDens,Scrt,nScrt,
     &                  iAO,iAOst,iBas,jBas,kBas,lBas,
     &                  Dij,ij1,ij2,ij3,ij4,
     &                  Dkl,kl1,kl2,kl3,kl4,
     &                  Dik,ik1,ik2,ik3,ik4,
     &                  Dil,il1,il2,il3,il4,
     &                  Djk,jk1,jk2,jk3,jk4,
     &                  Djl,jl1,jl2,jl3,jl4,
     &                  FT,nFT,
     &                  tfact,iCar,iCent,pert,indgrd,ipdisp)
************************************************************************
*                                                                      *
*  Object: to accumulate contibutions from the AO integrals directly   *
*          to the symmatry adapted Fock matrix.                        *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*          In addition to this complication we have that the order of  *
*          indicies in the integrals are not ordered canonically but   *
*          rather in an order such that the contraction step will be   *
*          optimal. Hence, special care has to be taken when tracing   *
*          the density with the integrals so that both entities have   *
*          the same order.                                             *
*                                                                      *
*          The Fock matrix is computed in lower triangular form.       *
*                                                                      *
*          The density matrix is not folded if the shell indices and   *
*          the angular indices are identical.                          *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden. February '93                            *
************************************************************************
      use Basis_Info
      use Symmetry_Info, only: nIrrep, iChTbl, iOper, iChBas
      use SOAO_Info, only: iAOtSO
      use Real_Spherical, only: iSphCr
      use Real_Info, only: CutInt
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "disp2.fh"
      Real*8 AOInt(nijkl,iCmp,jCmp,kCmp,lCmp), TwoHam(nDens),
     &       Scrt(nScrt), FT(nFT),
     &       Dij(ij1*ij2+1,ij3,ij4),
     &       Dkl(kl1*kl2+1,kl3,kl4),
     &       Dik(ik1*ik2+1,ik3,ik4),
     &       Dil(il1*il2+1,il3,il4),
     &       Djk(jk1*jk2+1,jk3,jk4),
     &       Djl(jl1*jl2+1,jl3,jl4)
c     Logical Qij, Qkl
      Logical Shij, Shkl, Shijij, Qijij,
     &        iShij, iShkl, iQij, iQkl,
     &        iQik, iShik, iQil, iShil, iQjk, iShjk, iQjl, iShjl,
     &        lFij, lFkl, lFik, lFjl, lFil, lFjk
      Integer iAng(4), iShell(4), iShll(4), kOp(4), kOp2(4),
     &        iAO(4), iAOst(4), iCmpa(4)
      Logical Pert(0:nIrrep-1)
      integer indgrd(3,4,0:nirrep-1),ipdisp(*)

*     Local Arrays
      Integer iSym(4,0:7), iTwoj(0:7)
      Real*8 Prmt(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
      Data Prmt/1.d0,-1.d0,-1.d0,1.d0,-1.d0,1.d0,1.d0,-1.d0/
*
*     Statement Function
*
      iOff(ixyz)  = ixyz*(ixyz+1)*(ixyz+2)/6
      xPrmt(i,j) = Prmt(iAnd(i,j))
*
      iprint=0
*
*     Write (*,*) DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1),
*    &            DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One  ,0)
*     If (DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1).gt.Zero
*    &    .or.
*    &    DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One,0).gt.Zero) Then
*     If (iPrint.ge.49) Then
*     Call RecPrt('Dik','(5G20.10)',Dik,ik1*ik2+1,ik3*ik4)
*        Write (*,'(A,2G20.10)')
*    &                  ' FckAcc:AOIn',DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
*    &               AOInt,1,AOInt,1), DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
*    &               AOInt,1,One,0)
*     End If
*     End If
*     If (iPrint.ge.99) Then
*        Call RecPrt('FckAcc:AOInt','(5G20.10)',
*    &                       AOInt,nijkl,iCmp*jCmp*kCmp*lCmp)
*        Write (*,'(A,G20.10)')'Dij=',XDot(Dij,ij1,ij2,ij3,ij4)
*        Write (*,'(A,G20.10)')'Dkl=',XDot(Dkl,kl1,kl2,kl3,kl4)
*        Write (*,'(A,G20.10)')'Dik=',XDot(Dik,ik1,ik2,ik3,ik4)
*        Write (*,'(A,G20.10)')'Dil=',XDot(Dil,il1,il2,il3,il4)
*        Write (*,'(A,G20.10)')'Djk=',XDot(Djk,jk1,jk2,jk3,jk4)
*        Write (*,'(A,G20.10)')'Djl=',XDot(Djl,jl1,jl2,jl3,jl4)
*     End If
*
*     Write (*,'(A,8L1)') 'Pert=',Pert
      If (iBas*jBas*kBas*lBas.gt.nScrt) Then
         Write (6,*) 'FckAcc_McK: iBas*jBas*kBas*lBas.gt.nScrt'
         Write (6,*) 'iBas,jBas,kBas,lBas,nScrt=',
     &         iBas,jBas,kBas,lBas,nScrt
         Call Abend()
      End If
      ii = iOff(iAng(1))
      jj = iOff(iAng(2))
      kk = iOff(iAng(3))
      ll = iOff(iAng(4))
      kOp2(1) = iOper(kOp(1))
      kOp2(2) = iOper(kOp(2))
      kOp2(3) = iOper(kOp(3))
      kOp2(4) = iOper(kOp(4))
      iCmpa(1) = iCmp
      iCmpa(2) = jCmp
      iCmpa(3) = kCmp
      iCmpa(4) = lCmp
      lFij = .False.
      lFkl = .False.
      lFik = .False.
      lFjl = .False.
      lFil = .False.
      lFjk = .False.
*
      ipFij = 1
      nFij  = iBas*jBas*iCmpa(1)*iCmpa(2)
*
      ipFkl = ipFij + nFij
      nFkl  = kBas*lBas*iCmpa(3)*iCmpa(4)
*
      ipFik = ipFkl + nFkl
      nFik  = iBas*kBas*iCmpa(1)*iCmpa(3)
*
      ipFjl = ipFik + nFik
      nFjl  = jBas*lBas*iCmpa(2)*iCmpa(4)
*
      ipFil = ipFjl + nFjl
      nFil  = iBas*lBas*iCmpa(1)*iCmpa(4)
*
      ipFjk = ipFil + nFil
      nFjk  = jBas*kBas*iCmpa(2)*iCmpa(3)
*
      call dcopy_(nFij+nFkl+nFik+nFjl+nFil+nFjk,[Zero],0,FT(ipFij),1)
*
*     Quadruple loop over elements of the basis functions angular
*     description. Loops are reduced to just produce unique SO integrals
*     Observe that we will walk through the memory in AOInt in a
*     sequential way.
*
      Shij = iShell(1).eq.iShell(2)
      Shkl = iShell(3).eq.iShell(4)
      iShij = iShell(1).eq.iShell(2)
      iShkl = iShell(3).eq.iShell(4)
      iShik = iShell(1).eq.iShell(3)
      iShil = iShell(1).eq.iShell(4)
      iShjk = iShell(2).eq.iShell(3)
      iShjl = iShell(2).eq.iShell(4)
      Do 100 i1 = 1, iCmp
         Do 101 j = 0, nIrrep-1
            iSym(1,j) = 0
            If (iAOtSO(iAO(1)+i1,j)>0) iSym(1,j) = iTwoj(j)
101      Continue
         jCmpMx = jCmp
         If (Shij) jCmpMx = i1
         iChBs = iChBas(ii+i1)
         If (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+i1))
         pEa = xPrmt(iOper(kOp(1)),iChBs)
         Do 200 i2 = 1, jCmpMx
            Do 201 j = 0, nIrrep-1
               iSym(2,j) = 0
               If (iAOtSO(iAO(2)+i2,j)>0) iSym(2,j) = iTwoj(j)
201         Continue
            jChBs = iChBas(jj+i2)
            If (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+i2))
            pRb = xPrmt(iOper(kOp(2)),jChBs)
*           Qij = i1.eq.i2
            If (iShell(2).gt.iShell(1)) Then
               i12 = jCmp*(i1-1) + i2
            Else
               i12 = iCmp*(i2-1) + i1
            End If
            Do 300 i3 = 1, kCmp
               Do 301 j = 0, nIrrep-1
                  iSym(3,j) = 0
                  If (iAOtSO(iAO(3)+i3,j)>0) iSym(3,j) = iTwoj(j)
301            Continue
               lCmpMx = lCmp
               If (Shkl) lCmpMx = i3
               kChBs = iChBas(kk+i3)
               If (Shells(iShll(3))%Transf)
     &            kChBs = iChBas(iSphCr(kk+i3))
               pTc = xPrmt(iOper(kOp(3)),kChBs)
               Do 400 i4 = 1, lCmpMx
                  Do 401 j = 0, nIrrep-1
                     iSym(4,j) = 0
                     If (iAOtSO(iAO(4)+i4,j)>0) iSym(4,j) = iTwoj(j)
401               Continue
*                 Qkl = i3.eq.i4
                  lChBs = iChBas(ll+i4)
                  If (Shells(iShll(4))%Transf)
     &               lChBs = iChBas(iSphCr(ll+i4))
                  pTSd= xPrmt(iOper(kOp(4)),lChBs)
                  If (iShell(4).gt.iShell(3)) Then
                     i34 = lCmp*(i3-1) + i4
                  Else
                     i34 = kCmp*(i4-1) + i3
                  End If
                  If (Shijij .and. i34.gt.i12) Go To 400
                  Qijij = Shijij .and. i12.eq.i34
                  iQij = iShij.and.i1.eq.i2
                  iQkl = iShkl.and.i3.eq.i4
                  iQik = iShik.and.i1.eq.i3
                  iQil = iShil.and.i1.eq.i4
                  iQjk = iShjk.and.i2.eq.i3
                  iQjl = iShjl.and.i2.eq.i4
                  pFctr=pEa*pRb*pTc*pTSd
*
                  mFij = 0
                  mFkl = 0
                  mFik = 0
                  mFjl = 0
                  mFil = 0
                  mFjk = 0
                  Do 1000 iIrrep = 0, nIrrep-1
                     If (iSym(1,iIrrep).ne.0 .and.
     &                   iSym(2,iIrrep).ne.0) mFkl=mFkl+1
                     If (iSym(3,iIrrep).ne.0 .and.
     &                   iSym(4,iIrrep).ne.0) mFij=mFij+1
                     If (iSym(1,iIrrep).ne.0 .and.
     &                   iSym(3,iIrrep).ne.0) mFjl=mFjl+1
                     If (iSym(2,iIrrep).ne.0 .and.
     &                   iSym(4,iIrrep).ne.0) mFik=mFik+1
                     If (iSym(1,iIrrep).ne.0 .and.
     &                   iSym(4,iIrrep).ne.0) mFjk=mFjk+1
                     If (iSym(2,iIrrep).ne.0 .and.
     &                   iSym(3,iIrrep).ne.0) mFil=mFil+1
 1000             Continue
                  If (mFij+mFkl+mFik+mFjl+mFil+mFjk.eq.0) Go To 400
*
                  vijkl = DNrm2_(iBas*jBas*kBas*lBas,
     &                          AOInt(1,i1,i2,i3,i4),1)
                  If (vijkl.lt.CutInt) Go To 400
************************************************************************
*                                                                      *
*-----------------Fij = hij + Sum(kl) Dkl {(ij|kl)-1/2(ik|jl)}         *
*                                                                      *
*-----------------or                                                   *
*                                                                      *
*-----------------Fij = hij + Sum(k=>l) Dkl {(2-d(kl)} P(ij|kl)        *
*                                                                      *
*-----------------where P(ij|kl)=(ij|kl)-1/4(ik|jl)-1/4(il|jk)         *
*                                                                      *
*-----------------or in the case of no sum restriction                 *
*                                                                      *
*-----------------P(ij|kl) = (ij|kl) - 1/2(ik|jl)                      *
*                                                                      *
*-----------------C o l o u m b  C o n t r i b u t i o n s             *
*                                                                      *
*---------------- Fij = Dkl * (ij|kl)                                  *
*                                                                      *
*-----------------Order density matrix in accordance with the integrals*
*                                                                      *
************************************************************************
                  If (mFij.eq.0) Go To 3203
                  If (iShell(3).lt.iShell(4)) Then
                     vkl = Dkl(kBas*lBas+1,i4,i3)
                  Else
                     vkl = Dkl(kBas*lBas+1,i3,i4)
                  End If
*
*-----------------Pickup the right column of the density matrix and
*                 change order if not canonical.
*
                  qFctr = One
                  ipFij1 = ((i2-1)*iCmpa(1)+i1-1)*iBas*jBas+ipFij
                  Fac = One
                  If (iQij) Fac = Half
                  D_kl=Two
                  If (iQkl) D_kl=One
                  Fac=Fac*D_kl
                  If (vkl*vijkl*Abs(Fac*qFctr*pFctr).lt.CutInt)
     &               Go To 3203
                  If (iShell(3).lt.iShell(4)) Then
                     Call DGetMO(Dkl(1,i4,i3),kl1,kl1,
     &                           kl2,Scrt,kl2)
                     Call dGeMV_('N',iBas*jBas,kBas*lBas,
     &                 Fac * qFctr*pFctr,AOInt(1,i1,i2,i3,i4),iBas*jBas,
     &                          Scrt,1,
     &                          One,FT(ipFij1),1)
                  Else
                     Call dGeMV_('N',iBas*jBas,kBas*lBas,
     &                 Fac * qFctr*pFctr,AOInt(1,i1,i2,i3,i4),iBas*jBas,
     &                          Dkl(1,i3,i4),1,
     &                          One,FT(ipFij1),1)
                  End If
C                 Call RecPrt('Fij',' ',FT(ipFij1),iBas,jBas)
                  lFij = .True.
 3203             Continue
                  If (Qijij) Go To 1200
*---------------- Fkl = Dij * (ij|kl)
                  If (mFkl.eq.0) Go To 1200
                  If (iShell(1).lt.iShell(2)) Then
                     vij = Dij(iBas*jBas+1,i2,i1)
                  Else
                     vij = Dij(iBas*jBas+1,i1,i2)
                  End  If
                  qFctr = One
                  ipFkl1 = ((i4-1)*iCmpa(3)+i3-1)*kBas*lBas+ipFkl
                  Fac = One
                  If (iQkl) Fac = Half
                  D_ij=Two
                  If (iQij) D_ij=One
                  Fac=Fac*D_ij
                  If (vij*vijkl*Abs(Fac*qFctr*pFctr).lt.CutInt)
     &               Go To 1200
                  If (iShell(1).lt.iShell(2)) Then
                     Call DGeTMO(Dij(1,i2,i1),ij1,ij1,
     &                           ij2,Scrt,ij2)
                     Call dGeMV_('T',iBas*jBas,kBas*lBas,
     &                  Fac* qFctr*pFctr,AOInt(1,i1,i2,i3,i4),iBas*jBas,
     &                          Scrt,1,
     &                          One,FT(ipFkl1),1)
                  Else
                     Call dGeMV_('T',iBas*jBas,kBas*lBas,
     &                  Fac* qFctr*pFctr,AOInt(1,i1,i2,i3,i4),iBas*jBas,
     &                          Dij(1,i1,i2),1,
     &                          One,FT(ipFkl1),1)
                  End If
C                 Call RecPrt('Fkl',' ',FT(ipFkl1),kBas,lBas)
                  lFkl = .True.
 1200             Continue
*
*-----------------E x c h a n g e   c o n t r i b u t i o n s
*
*-----------------Change the order ijkl to ikjl. Make sure also that
*                 the index pairs are canonical.
*
                  ipD = 1 + iBas*jBas*kBas*lBas
                  np = ipD-1 + Max(iBas*lBas,jBas*lBas,
     &                             iBas*kBas,jBas*kBas)
                  If (np.gt.nScrt) Then
                     Write (6,*) 'FckAcc_McK: np.gt.nScrt'
                     Write (6,*) 'np,nScrt=',np,nScrt
                     Call Abend()
                  End If
                  If (mFik+mFjl.eq.0) Go To 1210
                  If (mFik.ne.0.and.iShell(2).lt.iShell(4)) Then
                     vjl=Djl(jBas*lBas+1,i4,i2)
                  Else If (mFik.ne.0) Then
                     vjl=Djl(jBas*lBas+1,i2,i4)
                  Else
                     vjl=Zero
                  End If
                  If (mFjl.ne.0.and.iShell(1).lt.iShell(3)) Then
                     vik=Dik(iBas*kBas+1,i3,i1)
                  Else If (mFjl.ne.0) Then
                     vik=Dik(iBas*kBas+1,i1,i3)
                  Else
                    vik=Zero
                  End If
                  If (vik*vijkl/Four .lt. CutInt .and.
     &                vjl*vijkl/Four .lt. CutInt) Go To 1210
                  Do 600 j = 1, jBas
                     nij = (j-1)*iBas + 1
                     Do 601 k = 1, kBas
                        nik = (k-1)*iBas + 1
                        Do 602 l = 1, lBas
                           nkl = (l-1)*kBas + k
                           njl = (l-1)*jBas + j
                           iOut = (nkl-1)*iBas*jBas + nij
                           iIn  = (njl-1)*iBas*kBas + nik
                           call dcopy_(iBas,AOInt(iOut,i1,i2,i3,i4),1,
     &                                Scrt(iIn),1)
 602                    Continue
 601                 Continue
 600              Continue
************************************************************************
*                                                                      *
*-----------------Fik = - 1/4 * Djl * P(jl|ik)                         *
*                                                                      *
*                 P(jl|ik) = (jl|ik) - 1/4(ji|lk) - 1/4(jk|il)         *
*                                                                      *
*                 P(jl|ik) = (jl|ik) - 1/2(ji|lk)                      *
*                                                                      *
*-----------------Change factor if                                     *
*                 a) asymmetrical P matrix is implied                  *
*                 b) if the two exchange integrals in the symmetrical  *
*                    P matrix are identical.                           *
*                                                                      *
************************************************************************
                  If (mFik.eq.0) Go To 2213
                  qFctr = One
                  ipFik1 = ((i3-1)*iCmpa(1)+i1-1)*iBas*kBas+ipFik
                  Fac = -Quart
                  If (iQjl.and. .Not.iQik) Fac = -Half
                  D_jl=Two
                  If (iQjl) D_jl=One
                  Fac=Fac*D_jl
                  If (vjl*vijkl*Abs(Fac*qFctr*pFctr).lt.CutInt)
     &               Go To 2213
                  If (iShell(2).lt.iShell(4)) Then
                     Call DGeTMO(Djl(1,i4,i2),jl1,jl1,
     &                           jl2,Scrt(ipD),jl2)
                     Call dGeMV_('N',iBas*kBas,jBas*lBas,
     &                          Fac*qFctr*pFctr,Scrt,iBas*kBas,
     &                          Scrt(ipD),1,
     &                          One,FT(ipFik1),1)
                  Else
                     Call dGeMV_('N',iBas*kBas,jBas*lBas,
     &                          Fac*qFctr*pFctr,Scrt,iBas*kBas,
     &                          Djl(1,i2,i4),1,
     &                          One,FT(ipFik1),1)
                  End If
C                 Call RecPrt('Fik',' ',FT(ipFik1),iBas,kBas)
                  lFik = .True.
 2213             Continue
                  If (iQij.and.iQkl) Go To 2220
************************************************************************
*                                                                      *
*-----------------Fjl = - 1/4 * Dik * P(jl|ik)                         *
*                                                                      *
*                 P(jl|ik) = (jl|ik) - 1/4(ji|lk) - 1/4(jk|il)         *
*                                                                      *
*                 P(jl|ik) = (jl|ik) - 1/2(ji|lk)                      *
*                                                                      *
************************************************************************
                  If (mFjl.eq.0) Go To 1210
                  qFctr = One
                  ipFjl1 = ((i4-1)*iCmpa(2)+i2-1)*jBas*lBas+ipFjl
                  Fac = -Quart
                  If (iQik.and. .Not.iQjl) Fac = -Half
                  D_ik=Two
                  If (iQik) D_ik=One
                  Fac=Fac*D_ik
                  If (vik*vijkl*Abs(Fac*qFctr*pFctr).lt.CutInt)
     &               Go To 1210
                  If (iShell(1).lt.iShell(3)) Then
                     Call DGeTMO(Dik(1,i3,i1),ik1,ik1,
     &                           ik2,Scrt(ipD),ik2)
                     Call dGeMV_('T',iBas*kBas,jBas*lBas,
     &                          Fac*qFctr*pFctr,Scrt,iBas*kBas,
     &                          Scrt(ipD),1,
     &                          One,FT(ipFjl1),1)
                  Else
                     Call dGeMV_('T',iBas*kBas,jBas*lBas,
     &                          Fac*qFctr*pFctr,Scrt,iBas*kBas,
     &                          Dik(1,i1,i3),1,
     &                          One,FT(ipFjl1),1)
                  End If
C                 Call RecPrt('Fjl',' ',FT(ipFjl1),jBas,lBas)
                  lFjl = .True.
 1210             Continue
*
*-----------------Change order ijkl to iljk
*
                  If (iQij.or.iQkl) Go To 2220
                  If (mFil+mFjk.eq.0) Go To 2220
                  If (mFil.ne.0.and.iShell(2).lt.iShell(3)) Then
                     vjk = Djk(jBas*kBas+1,i3,i2)
                  Else If (mFil.ne.0) Then
                     vjk = Djk(jBas*kBas+1,i2,i3)
                  Else
                     vjk=Zero
                  End If
                  If (mFjk.ne.0.and.iShell(1).lt.iShell(4)) Then
                     vil = Dil(iBas*lBas+1,i4,i1)
                  Else If (mFjk.ne.0) Then
                     vil = Dil(iBas*lBas+1,i1,i4)
                  Else
                     vil=Zero
                  End If
                  If (vil*vijkl/Four .lt. CutInt .and.
     &                vjk*vijkl/Four .lt. CutInt) Go To 2220
                  i = 1
                  Do 610 j = 1, jBas
                     nij = (j-1)*iBas + i
                     Do 611 k = 1, kBas
                        njk = (k-1)*jBas + j
                         Do 612 l = 1, lBas
                            nkl = (l-1)*kBas + k
                            nil = (l-1)*iBas + i
                            ijkl = (nkl-1)*iBas*jBas + nij
                            iljk = (njk-1)*iBas*lBas + nil
                            call dcopy_(iBas,AOInt(ijkl,i1,i2,i3,i4),1,
     &                                 Scrt(iljk),1)
 612                     Continue
 611                  Continue
 610               Continue
*-----------------Fil = - 1/4 * Djk * (ij|kl)
                  If (mFil.eq.0) Go To 1220
                  qFctr = One
                  ipFil1 = ((i4-1)*iCmpa(1)+i1-1)*iBas*lBas+ipFil
                  Fac = -Quart
                  If (iQjk.and. .Not.iQil) Fac = -Half
                  D_jk=Two
                  If (iQjk) D_jk=One
                  Fac=Fac*D_jk
                  If (vjk*vijkl*Abs(Fac*qFctr*pFctr).lt.CutInt)
     &               Go To 1220
                  If (iShell(2).lt.iShell(3)) Then
                     Call DGeTMO(Djk(1,i3,i2),jk1,jk1,
     &                           jk2,Scrt(ipD),jk2)
                     Call dGeMV_('N',iBas*lBas,jBas*kBas,
     &                          Fac*qFctr*pFctr,Scrt,iBas*lBas,
     &                          Scrt(ipD),1,
     &                          One,FT(ipFil1),1)
                  Else
                     Call dGeMV_('N',iBas*lBas,jBas*kBas,
     &                          Fac*qFctr*pFctr,Scrt,iBas*lBas,
     &                          Djk(1,i2,i3),1,
     &                          One,FT(ipFil1),1)
                  End If
C                 Call RecPrt('Fil',' ',FT(ipFil1),iBas,lBas)
                  lFil = .True.
 1220             Continue
                  If (Qijij) Go To 2220
*-----------------Fjk = - 1/4 * Dil * (ij|kl)
                  If (mFjk.eq.0) Go To 2220
                  qFctr = One
                  ipFjk1 = ((i3-1)*iCmpa(2)+i2-1)*jBas*kBas+ipFjk
                  Fac = -Quart
                  If (iQil.and. .Not.iQjk) Fac = -Half
                  D_il=Two
                  If (iQil) D_il=One
                  Fac=Fac*D_il
                  If (vil*vijkl*Abs(Fac*qFctr*pFctr).lt.CutInt)
     &               Go To 2220
                  If (iShell(1).lt.iShell(4)) Then
                     Call DGeTMO(Dil(1,i4,i1),il1,il1,
     &                           il2,Scrt(ipD),il2)
                     Call dGeMV_('T',iBas*lBas,jBas*kBas,
     &                          Fac*qFctr*pFctr,Scrt,iBas*lBas,
     &                          Scrt(ipD),1,
     &                          One,FT(ipFjk1),1)
                  Else
                     Call dGeMV_('T',iBas*lBas,jBas*kBas,
     &                          Fac*qFctr*pFctr,Scrt,iBas*lBas,
     &                          Dil(1,i1,i4),1,
     &                          One,FT(ipFjk1),1)
                  End If
C                 Call RecPrt('Fjk',' ',FT(ipFjk1),jBas,kBas)
                  lFjk = .True.
 2220             Continue
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
*
*     Write (*,*) ' Fij'
      nnIrrep=nIrrep
      If (sIrrep) nnIrrep=1
      Do iIrrep=0,nnIrrep-1
*        Write (*,'(I2,L1)') iIrrep, pert(iIrrep)
         If (pert(iIrrep)) Then
            ip=ipDisp(abs(indgrd(iCar,iCent,iIrrep)))
            rCh=xPrmt(iOper(kOp(iCent)),iChBas(1+iCar))*
     &                DBLE(iChTbl(iIrrep,kOp(iCent)))
            Fact=tfact*rCh
*           Write (*,*) 'Level ij'
            If (lFij) Call FckDst(TwoHam(ip),ndens,FT(ipFij),
     &                             iBas,jBas,iCmpa(1),iCmpa(2),
     &                             kOp2(1),kOp2(2),
     &                             iIrrep,
     &                             iShij,
     &                             iAO(1),iAO(2),iAOst(1),iAOst(2),
     &                             fact)
*           Write (*,*) 'Level kl'
            If (lFkl) Call FckDst(TwoHam(ip),ndens,FT(ipFkl),
     &                             kBas,lBas,iCmpa(3),iCmpa(4),
     &                             kOp2(3),kOp2(4),
     &                             iIrrep,
     &                             iShkl,
     &                             iAO(3),iAO(4),iAOst(3),iAOst(4),
     &                             fact)
*           Write (*,*) 'Level ik'
            If (lFik) Call FckDst(TwoHam(ip),ndens,FT(ipFik),
     &                             iBas,kBas,iCmpa(1),iCmpa(3),
     &                             kOp2(1),kOp2(3),
     &                             iIrrep,
     &                             iShik,
     &                             iAO(1),iAO(3),iAOst(1),iAOst(3),
     &                             fact)
*           Write (*,*) 'Level jl'
            If (lFjl) Call FckDst(TwoHam(ip),ndens,FT(ipFjl),
     &                             jBas,lBas,iCmpa(2),iCmpa(4),
     &                             kOp2(2),kOp2(4),
     &                             iIrrep,
     &                             iShjl,
     &                             iAO(2),iAO(4),iAOst(2),iAOst(4),
     &                             fact)
*           Write (*,*) 'Level il'
            If (lFil) Call FckDst(TwoHam(ip),ndens,FT(ipFil),
     &                             iBas,lBas,iCmpa(1),iCmpa(4),
     &                             kOp2(1),kOp2(4),
     &                             iIrrep,
     &                             iShil,
     &                             iAO(1),iAO(4),iAOst(1),iAOst(4),
     &                             fact)
*           Write (*,*) 'Level jk'
            If (lFjk) Call FckDst(TwoHam(ip),ndens,FT(ipFjk),
     &                             jBas,kBas,iCmpa(2),iCmpa(3),
     &                             kOp2(2),kOp2(3),
     &                             iIrrep,
     &                             iShjk,
     &                             iAO(2),iAO(3),iAOst(2),iAOst(3),
     &                             fact)
*           If (DDot_(3468,TwoHam,1,TwoHam,1).gt.Zero) Then
*           If (Abs(DDot_(3468,TwoHam,1,One,0)).gt.1.0D-16) Then
*           Write (*,'(A,G20.6,G20.7)') 'TwoHam=',
*    &             DDot_(3468,TwoHam,1,TwoHam,1),
*    &             DDot_(3468,TwoHam,1,One,0)
*           Else
*           Write (*,'(A,G20.6)') 'TwoHam=',
*    &             DDot_(3468,TwoHam,1,TwoHam,1)
*           End If
*           Call FZero(TwoHam,3468)
*           End If
         End If
      End Do
      Return
      End
#else
      Subroutine FckAcc_Mck(iAng, iCmp, jCmp, kCmp, lCmp, Shijij,
     &                  iShll, iShell, kOp, nijkl,
     &                  AOInt,TwoHam,nDens,Scrt,nScrt,
     &                  iAO,iAOst,iBas,jBas,kBas,lBas,
     &                  Dij,ij1,ij2,ij3,ij4,
     &                  Dkl,kl1,kl2,kl3,kl4,
     &                  Dik,ik1,ik2,ik3,ik4,
     &                  Dil,il1,il2,il3,il4,
     &                  Djk,jk1,jk2,jk3,jk4,
     &                  Djl,jl1,jl2,jl3,jl4,
     &                  FT,nFT,
     &                  tfact,iCar,iCent,pert,indgrd,ipdisp)
************************************************************************
*                                                                      *
*  Object: to accumulate contibutions from the AO integrals directly   *
*          to the symmatry adapted Fock matrix.                        *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*          In addition to this complication we have that the order of  *
*          indicies in the integrals are not ordered canonically but   *
*          rather in an order such that the contraction step will be   *
*          optimal. Hence, special care has to be taken when tracing   *
*          the density with the integrals so that both entities have   *
*          the same order.                                             *
*                                                                      *
*          The Fock matrix is computed in lower triangular form.       *
*                                                                      *
*          The density matrix is not folded if the shell indices and   *
*          the angular indices are identical.                          *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden. February '93                            *
*                                                                      *
*     Modified July '98 in Tokyo by R. Lindh                           *
************************************************************************
      use Basis_Info
      use Symmetry_Info, only: nIrrep, iChTbl, iChBas
      use SOAO_Info, only: iAOtSO
      use Real_Spherical, only: iSphCr
      use Real_Info, only: ThrInt, CutInt
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "disp2.fh"
#include "print.fh"
      Real*8 AOInt(nijkl,iCmp,jCmp,kCmp,lCmp), TwoHam(nDens),
     &       Scrt(nScrt), FT(nFT),
     &       Dij(ij1*ij2+1,ij3,ij4),
     &       Dkl(kl1*kl2+1,kl3,kl4),
     &       Dik(ik1*ik2+1,ik3,ik4),
     &       Dil(il1*il2+1,il3,il4),
     &       Djk(jk1*jk2+1,jk3,jk4),
     &       Djl(jl1*jl2+1,jl3,jl4)
      Logical Shijij, Qijij,
     &        iShij, iShkl, iQij, iQkl,
     &        iQik, iShik, iQil, iShil, iQjk, iShjk, iQjl, iShjl,
     &        lFij, lFkl, lFik, lFjl, lFil, lFjk
      Integer iAng(4), iShell(4), iShll(4), kOp(4), kOp2(4),
     &        iAO(4), iAOst(4), iCmpa(4)
      Logical Pert(0:nIrrep-1)
      integer indgrd(3,4,0:nirrep-1),ipdisp(*)
*     Local Arrays
      Integer iSym(4)
      Real*8 Prmt(0:7)
c     Character*72 Label
      Data Prmt/1.d0,-1.d0,-1.d0,1.d0,-1.d0,1.d0,1.d0,-1.d0/
*
*     Statement Function
*
      iOff(ixyz)  = ixyz*(ixyz+1)*(ixyz+2)/6
      xPrmt(i,j) = Prmt(iAnd(i,j))
c     iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*
      iRout = 38
      iPrint = nPrint(iRout)
*
*     If (iPrint.ge.49) Then
*        Write (*,*) ' FckAcc:AOIn',DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
*    &               AOInt,1,AOInt,1), DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
*    &               AOInt,1,One,0)
*     End If
*     If (iPrint.ge.99) Then
*        Call RecPrt('FckAcc:AOInt',' ',AOInt,nijkl,iCmp*jCmp*kCmp*lCmp)
*        Write (*,*)'Dij=',XDot(Dij,ij1,ij2,ij3,ij4)
*        Write (*,*)'Dkl=',XDot(Dkl,kl1,kl2,kl3,kl4)
*        Write (*,*)'Dik=',XDot(Dik,ik1,ik2,ik3,ik4)
*        Write (*,*)'Dil=',XDot(Dil,il1,il2,il3,il4)
*        Write (*,*)'Djk=',XDot(Djk,jk1,jk2,jk3,jk4)
*        Write (*,*)'Djl=',XDot(Djl,jl1,jl2,jl3,jl4)
*     End If
*
      ExFac=One
      ThrInt=0.0D0
      If (iBas*jBas*kBas*lBas.gt.nScrt) Then
         Write (6,*) 'FckAcc: nScrt too small!'
         Call Abend
      End If
      ii = iOff(iAng(1))
      jj = iOff(iAng(2))
      kk = iOff(iAng(3))
      ll = iOff(iAng(4))

      kOp2(1) = iOper(kOp(1))
      kOp2(2) = iOper(kOp(2))
      kOp2(3) = iOper(kOp(3))
      kOp2(4) = iOper(kOp(4))
      iCmpa(1) = iCmp
      iCmpa(2) = jCmp
      iCmpa(3) = kCmp
      iCmpa(4) = lCmp
      lFij = .False.
      lFkl = .False.
      lFik = .False.
      lFjl = .False.
      lFil = .False.
      lFjk = .False.
*
      ipFij = 1
      nFij  = iBas*jBas*iCmpa(1)*iCmpa(2)
*
      ipFkl = ipFij + nFij
      nFkl  = kBas*lBas*iCmpa(3)*iCmpa(4)
*
      ipFik = ipFkl + nFkl
      nFik  = iBas*kBas*iCmpa(1)*iCmpa(3)
*
      ipFjl = ipFik + nFik
      nFjl  = jBas*lBas*iCmpa(2)*iCmpa(4)
*
      ipFil = ipFjl + nFjl
      nFil  = iBas*lBas*iCmpa(1)*iCmpa(4)
*
      ipFjk = ipFil + nFil
      nFjk  = jBas*kBas*iCmpa(2)*iCmpa(3)
*
      call dcopy_(nFij+nFkl+nFik+nFjl+nFil+nFjk,Zero,0,FT(ipFij),1)
*
      ipDij = 1
      ipDkl = 1
      ipDik = 1
      ipDil = 1
      ipDjk = 1
      ipDjl = 1
      ipFij1= 1
      ipFkl1= 1
      ipFik1= 1
      ipFil1= 1
      ipFjk1= 1
      ipFjl1= 1
*
*     Quadruple loop over elements of the basis functions angular
*     description. Loops are reduced to just produce unique SO integrals
*     Observe that we will walk through the memory in AOInt in a
*     sequential way.
*
      iShij = iShell(1).eq.iShell(2)
      iShkl = iShell(3).eq.iShell(4)
      iShik = iShell(1).eq.iShell(3)
      iShil = iShell(1).eq.iShell(4)
      iShjk = iShell(2).eq.iShell(3)
      iShjl = iShell(2).eq.iShell(4)
      mijkl=iBas*jBas*kBas*lBas
      Do 100 i1 = 1, iCmp
         ix = 0
         Do j = 0, nIrrep-1
            If (iAOtSO(iAO(1)+i1,j)>0) ix = iOr(ix,2**j)
         End Do
         iSym(1)=ix
         jCmpMx = jCmp
         If (iShij) jCmpMx = i1
         iChBs = iChBas(ii+i1)
         If (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+i1))
         pEa = xPrmt(iOper(kOp(1)),iChBs)
         Do 200 i2 = 1, jCmpMx
            ix = 0
            Do j = 0, nIrrep-1
               If (iAOtSO(iAO(2)+i2,j)>0) ix = iOr(ix,2**j)
            End Do
            iSym(2)=ix
            jChBs = iChBas(jj+i2)
            If (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+i2))
            pRb = xPrmt(iOper(kOp(2)),jChBs)
            If (iShell(2).gt.iShell(1)) Then
               i12 = jCmp*(i1-1) + i2
            Else
               i12 = iCmp*(i2-1) + i1
            End If
            Do 300 i3 = 1, kCmp
               ix = 0
               Do j = 0, nIrrep-1
                  If (iAOtSO(iAO(3)+i3,j)>0) ix = iOr(ix,2**j)
               End Do
               iSym(3)=ix
               lCmpMx = lCmp
               If (iShkl) lCmpMx = i3
               kChBs = iChBas(kk+i3)
               If (Shells(iShll(3))%Transf)
     &            kChBs = iChBas(iSphCr(kk+i3))
               pTc = xPrmt(iOper(kOp(3)),kChBs)
               Do 400 i4 = 1, lCmpMx
                  ix = 0
                  Do j = 0, nIrrep-1
                     If (iAOtSO(iAO(4)+i4,j)>0) ix = iOr(ix,2**j)
                  End Do
                  iSym(4)=ix
                  lChBs = iChBas(ll+i4)
                  If (Shells(iShll(4))%Transf)
     &               lChBs = iChBas(iSphCr(ll+i4))
                  pTSd= xPrmt(iOper(kOp(4)),lChBs)
                  If (iShell(4).gt.iShell(3)) Then
                     i34 = lCmp*(i3-1) + i4
                  Else
                     i34 = kCmp*(i4-1) + i3
                  End If
                  If (Shijij .and. i34.gt.i12) Go To 400
                  vijkl=0
                  do ijkl=1,mijkl
                    vijkl=max(vijkl,abs(AOInt(ijkl,i1,i2,i3,i4)))
                  end do
c                 vijkl = DNrm2_(iBas*jBas*kBas*lBas,
c    &                          AOInt(1,i1,i2,i3,i4),1)
C                 If (vijkl.lt.CutInt) Go To 400
*
                  Qijij = Shijij .and. i12.eq.i34
                  iQij = iShij.and.i1.eq.i2
                  iQkl = iShkl.and.i3.eq.i4
                  iQik = iShik.and.i1.eq.i3
                  iQil = iShil.and.i1.eq.i4
                  iQjk = iShjk.and.i2.eq.i3
                  iQjl = iShjl.and.i2.eq.i4
                  pFctr=pEa*pRb*pTc*pTSd
************************************************************************
*
                  Fac_ij = pFctr
                  Fac_kl = pFctr
                  Fac_ik =-Quart * pFctr
                  Fac_jl =-Quart * pFctr
                  Fac_il =-Quart * pFctr
                  Fac_jk =-Quart * pFctr
                  If (iQij) Fac_ij = Fac_ij * Half
                  If (iQkl) Fac_kl = Fac_kl * Half
                  If (iQjl.and. .Not.iQik) Fac_ik = Fac_ik * Two
                  If (iQik.and. .Not.iQjl) Fac_jl = Fac_jl * Two
                  If (iQjk.and. .Not.iQil) Fac_il = Fac_il * Two
                  If (iQil.and. .Not.iQjk) Fac_jk = Fac_jk * Two
*
                  D_ij=Two
                  If (iQij) D_ij=One
                  D_kl=Two
                  If (iQkl) D_kl=One
                  D_ik=Two
                  If (iQik) D_ik=One
                  D_jl=Two
                  If (iQjl) D_jl=One
                  D_il=Two
                  If (iQil) D_il=One
                  D_jk=Two
                  If (iQjk) D_jk=One
*
                  Fac_ij=Fac_ij*D_kl
                  Fac_kl=Fac_kl*D_ij
                  Fac_jl=Fac_jl*D_ik
                  Fac_ik=Fac_ik*D_jl
                  Fac_jk=Fac_jk*D_il
                  Fac_il=Fac_il*D_jk
*
C                 Write (*,*)
C                 Write (*,*) 'iShell(1),iShell(2),i1,i2=',
C    &                         iShell(1),iShell(2),i1,i2
C                 Write (*,*) 'Dij=',Dij(1,i1,i2)
C                 Write (*,*) 'Fac_ij,iQij=',Fac_ij,iQij
C                 Write (*,*)
C                 Write (*,*) 'iShell(3),iShell(4),i3,i4=',
C    &                         iShell(3),iShell(4),i3,i4
C                 Write (*,*) 'Dkl=',Dkl(1,i3,i4)
C                 Write (*,*) 'Fac_kl,iQkl=',Fac_kl,iQkl
C                 Write (*,*)
                  If (Qijij) Then
                     Fac_kl = Zero
                     Fac_jk = Zero
                  End If
                  If (iQij.and.iQkl) Then
                     Fac_jl = Zero
                     Fac_il = Zero
                     Fac_jk = Zero
                  End If
                  If (iQij.or.iQkl) Then
                     Fac_il = Zero
                     Fac_jk = Zero
                  End If
************************************************************************
*
                  iOpt=0
                  ip = 1
                  If (iAnd(iSym(1),iSym(2)).ne.0 .or.
     &                iAnd(iSym(3),iSym(4)).ne.0) Then
                     iOpt = iOpt + 1
*
                     If (iShell(3).lt.iShell(4)) Then
                        vkl = Dkl(kBas*lBas+1,i4,i3)
                        ipDkl=ip
                        ip = ip + kBas*lBas
                        Call DGetMO(Dkl(1,i4,i3),kl1,kl1,
     &                              kl2,Scrt(ipDkl),kl2)
                     Else
                        vkl = Dkl(kBas*lBas+1,i3,i4)
                        loc1=(idLoc(Dkl(1,i3,i4))-idLoc(Scrt))
                        loc2=(idLoc(Scrt(2))-idLoc(Scrt(1)))
                        ipDkl = 1 + loc1/loc2
                     End If
                     ipFij1 = ((i2-1)*iCmpa(1)+i1-1)*iBas*jBas
     &                      + ipFij
                     If (iShell(1).lt.iShell(2)) Then
                        vij = Dij(iBas*jBas+1,i2,i1)
                        ipDij=ip
                        ip = ip + iBas*jBas
                        Call DGeTMO(Dij(1,i2,i1),ij1,ij1,
     &                              ij2,Scrt(ipDij),ij2)
                     Else
                        vij = Dij(iBas*jBas+1,i1,i2)
                        loc1=(idLoc(Dij(1,i1,i2))-idLoc(Scrt))
                        loc2=(idLoc(Scrt(2))-idLoc(Scrt(1)))
                        ipDij = 1 + loc1/loc2
                     End  If
                     ipFkl1 = ((i4-1)*iCmpa(3)+i3-1)*kBas*lBas
     &                      + ipFkl
                     If (vkl*vijkl*Abs(Fac_ij).lt.ThrInt .and.
     &                   vij*vijkl*Abs(Fac_kl).lt.ThrInt) Then
                        iOpt = iOpt -1
                     Else
                        lFij=.True.
                        lFkl=.True.
                     End If
                  End If
*
                  If (iAnd(iSym(1),iSym(3)).ne.0 .or.
     &                iAnd(iSym(2),iSym(4)).ne.0) Then
                     iOpt = iOpt + 2
*
                     If (iShell(2).lt.iShell(4)) Then
                        vjl=Djl(jBas*lBas+1,i4,i2)
                        ipDjl=ip
                        ip = ip + jBas*lBas
                        Call DGeTMO(Djl(1,i4,i2),jl1,jl1,
     &                              jl2,Scrt(ipDjl),jl2)
                     Else
                        vjl=Djl(jBas*lBas+1,i2,i4)
                        loc1= (idLoc(Djl(1,i2,i4))-idLoc(Scrt))
                        loc2=(idLoc(Scrt(2))-idLoc(Scrt(1)))
                        ipDjl = 1 + loc1/loc2
                     End If
                     ipFik1 = ((i3-1)*iCmpa(1)+i1-1)*iBas*kBas
     &                      + ipFik
                     If (iShell(1).lt.iShell(3)) Then
                        vik=Dik(iBas*kBas+1,i3,i1)
                        ipDik = ip
                        ip = ip + iBas*kBas
                        Call DGeTMO(Dik(1,i3,i1),ik1,ik1,
     &                              ik2,Scrt(ipDik),ik2)
                     Else
                        vik=Dik(iBas*kBas+1,i1,i3)
                        loc1=(idLoc(Dik(1,i1,i3))-idLoc(Scrt))
                        loc2=(idLoc(Scrt(2))-idLoc(Scrt(1)))
                        ipDik = 1 + loc1/loc2
                     End If
                     ipFjl1 = ((i4-1)*iCmpa(2)+i2-1)*jBas*lBas
     &                      + ipFjl
                     If (vik*vijkl*Abs(Fac_jl) .lt. ThrInt .and.
     &                   vjl*vijkl*Abs(Fac_ik) .lt. ThrInt) Then
                        iOpt = iOpt - 2
                     Else
                        lFik = .True.
                        lFjl = .True.
                     End If
                  End If
*
                  If (iAnd(iSym(1),iSym(4)).ne.0 .or.
     &                iAnd(iSym(2),iSym(3)).ne.0) Then
                     iOpt = iOpt + 4
*
                     If (iShell(2).lt.iShell(3)) Then
                        vjk = Djk(jBas*kBas+1,i3,i2)
                        ipDjk = ip
                        ip = ip + jBas*kBas
                        Call DGeTMO(Djk(1,i3,i2),jk1,jk1,
     &                              jk2,Scrt(ipDjk),jk2)
                     Else
                        vjk = Djk(jBas*kBas+1,i2,i3)
                        loc1=(idLoc(Djk(1,i2,i3))-idLoc(Scrt))
                        loc2= (idLoc(Scrt(2))-idLoc(Scrt(1)))
                        ipDjk = 1 + loc1/loc2
                     End If
                     ipFil1 = ((i4-1)*iCmpa(1)+i1-1)*iBas*lBas
     &                      + ipFil
                     If (iShell(1).lt.iShell(4)) Then
                        vil = Dil(iBas*lBas+1,i4,i1)
                        ipDil = ip
                        ip = ip + iBas*lBas
                        Call DGeTMO(Dil(1,i4,i1),il1,il1,
     &                              il2,Scrt(ipDil),il2)
                     Else
                        vil = Dil(iBas*lBas+1,i1,i4)
                        loc1= (idLoc(Dil(1,i1,i4))-idLoc(Scrt))
                        loc2= (idLoc(Scrt(2))-idLoc(Scrt(1)))
                        ipDil = 1 + loc1/loc2
                     End If
                     ipFjk1 = ((i3-1)*iCmpa(2)+i2-1)*jBas*kBas
     &                     + ipFjk
                     If (vil*vijkl*Abs(Fac_jk) .lt. ThrInt .and.
     &                   vjk*vijkl*Abs(Fac_il) .lt. ThrInt) Then
                        iOpt = iOpt -4
                     Else
                        lFil = .True.
                        lFjk = .True.
                     End If
                  End If
                  If (ip-1.gt.nScrt) Then
                     Write (6,*) 'FckAcc: nScrt too small!'
                     Call Abend
                  End If
                  Go To ( 1, 2, 3, 4, 5, 6, 7) iOpt
                  Go To 400
*                                                                      *
************************************************************************
*                                                                      *
 1                Continue
                  Call Fck1(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDij),FT(ipFij1),Fac_ij,
     &                      Scrt(ipDkl),FT(ipFkl1),Fac_kl,ExFac)
                  Go To 400
 2                Continue
                  Call Fck2(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDik),FT(ipFik1),Fac_ik,
     &                      Scrt(ipDjl),FT(ipFjl1),Fac_jl,ExFac)
                  Go To 400
 3                Continue
                  Call Fck3(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDij),FT(ipFij1),Fac_ij,
     &                      Scrt(ipDkl),FT(ipFkl1),Fac_kl,
     &                      Scrt(ipDik),FT(ipFik1),Fac_ik,
     &                      Scrt(ipDjl),FT(ipFjl1),Fac_jl,ExFac)
                  Go To 400
 4                Continue
                  Call Fck4(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDil),FT(ipFil1),Fac_il,
     &                      Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
                  Go To 400
 5                Continue
                  Call Fck5(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDij),FT(ipFij1),Fac_ij,
     &                      Scrt(ipDkl),FT(ipFkl1),Fac_kl,
     &                      Scrt(ipDil),FT(ipFil1),Fac_il,
     &                      Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
                  Go To 400
 6                Continue
                  Call Fck6(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDik),FT(ipFik1),Fac_ik,
     &                      Scrt(ipDjl),FT(ipFjl1),Fac_jl,
     &                      Scrt(ipDil),FT(ipFil1),Fac_il,
     &                      Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
                  Go To 400
 7                Continue
                  Call Fck7(AOInt(1,i1,i2,i3,i4),iBas,jBas,kBas,lBas,
     &                      Scrt(ipDij),FT(ipFij1),Fac_ij,
     &                      Scrt(ipDkl),FT(ipFkl1),Fac_kl,
     &                      Scrt(ipDik),FT(ipFik1),Fac_ik,
     &                      Scrt(ipDjl),FT(ipFjl1),Fac_jl,
     &                      Scrt(ipDil),FT(ipFil1),Fac_il,
     &                      Scrt(ipDjk),FT(ipFjk1),Fac_jk,ExFac)
                  Go To 400
************************************************************************
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
*
      nnIrrep=nIrrep
      If (sIrrep) nnIrrep=1
      Do iIrrep=0,nnIrrep-1
*
         If (pert(iIrrep)) Then
            ip=ipDisp(abs(indgrd(iCar,iCent,iIrrep)))
            rCh=xPrmt(iOper(kOp(iCent)),iChBas(1+iCar))*
     &                DBLE(iChTbl(iIrrep,kOp(iCent)))
            Fact=tfact*rCh
*           Write (*,*) 'Level ij'
            If (lFij) Call FckDst(TwoHam(ip),ndens,FT(ipFij),
     &                             iBas,jBas,iCmpa(1),iCmpa(2),
     &                             kOp2(1),kOp2(2),
     &                             iIrrep,
     &                             iShij,
     &                             iAO(1),iAO(2),iAOst(1),iAOst(2),
     &                             fact)
*           Write (*,*) 'Level kl'
            If (lFkl) Call FckDst(TwoHam(ip),ndens,FT(ipFkl),
     &                             kBas,lBas,iCmpa(3),iCmpa(4),
     &                             kOp2(3),kOp2(4),
     &                             iIrrep,
     &                             iShkl,
     &                             iAO(3),iAO(4),iAOst(3),iAOst(4),
     &                             fact)
*           Write (*,*) 'Level ik'
            If (lFik) Call FckDst(TwoHam(ip),ndens,FT(ipFik),
     &                             iBas,kBas,iCmpa(1),iCmpa(3),
     &                             kOp2(1),kOp2(3),
     &                             iIrrep,
     &                             iShik,
     &                             iAO(1),iAO(3),iAOst(1),iAOst(3),
     &                             fact)
*           Write (*,*) 'Level jl'
            If (lFjl) Call FckDst(TwoHam(ip),ndens,FT(ipFjl),
     &                             jBas,lBas,iCmpa(2),iCmpa(4),
     &                             kOp2(2),kOp2(4),
     &                             iIrrep,
     &                             iShjl,
     &                             iAO(2),iAO(4),iAOst(2),iAOst(4),
     &                             fact)
*           Write (*,*) 'Level il'
            If (lFil) Call FckDst(TwoHam(ip),ndens,FT(ipFil),
     &                             iBas,lBas,iCmpa(1),iCmpa(4),
     &                             kOp2(1),kOp2(4),
     &                             iIrrep,
     &                             iShil,
     &                             iAO(1),iAO(4),iAOst(1),iAOst(4),
     &                             fact)
*           Write (*,*) 'Level jk'
            If (lFjk) Call FckDst(TwoHam(ip),ndens,FT(ipFjk),
     &                             jBas,kBas,iCmpa(2),iCmpa(3),
     &                             kOp2(2),kOp2(3),
     &                             iIrrep,
     &                             iShjk,
     &                             iAO(2),iAO(3),iAOst(2),iAOst(3),
     &                             fact)
         End If
      End Do
*
      Return
      End
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------
! 1998  PER-AAKE MALMQUIST
! DEPARTMENT OF THEORETICAL CHEMISTRY
! UNIVERSITY OF LUND
! SWEDEN
!--------------------------------------------

subroutine MKRHSB(IVEC,ERI,nERI,SCR,nSCR)
! Set up RHS vector of PT2 Linear Equation System, in vector
! number IVEC of LUSOLV for cases 2 and 3 (VJTI).

use Symmetry_Info, only: Mul
use SUPERINDEX, only: KIGEJ, KIGTJ, KTGEU, KTGTU
use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array, GA_Arrays
use caspt2_module, only: NAES, NASH, NIES, NIGEJ, NIGEJES, NIGTJ, NIGTJES, NINDEP, NISH, NORB, NSYM, NTGEU, NTGEUES, NTGTU, NTGTUES
use Constants, only: Two, Half, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, nERI, nSCR
real(kind=wp), intent(inout) :: ERI(nERI), SCR(nSCR)
integer(kind=iwp) :: IBUF, ICASE, II, IIABS, IIJM, IIJP, IJ, IJABS, ISYM, ISYMI, ISYMJ, ISYMT, ISYMU, IT, ITABS, ITTOT, ITUM, &
                     ITUP, IU, IUABS, IUTOT, IWM, JWP, LWM, LWP, NASM, NASP, NINM, NINP, NISM, NISP, NVM, NVP
real(kind=wp) :: Val
real(kind=wp), parameter :: SQ2 = sqrt(Two)

! VJTI CASE:
do ISYM=1,NSYM
  NINP = NINDEP(ISYM,2)
  NINM = NINDEP(ISYM,3)
  if (NINP+NINM == 0) cycle
  NASP = NTGEU(ISYM)
  NISP = NIGEJ(ISYM)
  NVP = NASP*NISP
  if (NVP == 0) cycle
  NASM = NTGTU(ISYM)
  NISM = NIGTJ(ISYM)
  NVM = NASM*NISM
  ! Allocate WP,WM
  LWP = Allocate_GA_Array(NVP,'WBP')
  LWM = Allocate_GA_Array(NVM,'WBM')
  ! Let  W(tu,i,j)=(it,ju):
  !   WP(tu,ij)=(W(tu,i,j)+W(tu,j,i))*(1-Kron(t,u)/2) /2
  ! With new normalisation, replace /2 with /(2*SQRT(1+Kron(ij))
  !   WM(tu,ij)=(W(tu,i,j)-W(tu,j,i))*(1-Kron(t,u)/2) /2
  do ISYMT=1,NSYM
    ISYMU = Mul(ISYMT,ISYM)
    if (ISYMT < ISYMU) cycle
    if (NASH(ISYMT)*NASH(ISYMU) == 0) cycle
    do ISYMI=1,NSYM
      ISYMJ = Mul(ISYMI,ISYM)
      if (NISH(ISYMI)*NISH(ISYMJ) == 0) cycle
      do IT=1,NASH(ISYMT)
        ITABS = IT+NAES(ISYMT)
        ITTOT = IT+NISH(ISYMT)
        do IU=1,NASH(ISYMU)
          IUABS = IU+NAES(ISYMU)
          IUTOT = IU+NISH(ISYMU)
          if (ITABS < IUABS) exit
          ITUP = KTGEU(ITABS,IUABS)-NTGEUES(ISYM)
          ITUM = KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
          call EXCH(ISYMI,ISYMT,ISYMJ,ISYMU,ITTOT,IUTOT,ERI,SCR)
          if (ITABS /= IUABS) then
            do II=1,NISH(ISYMI)
              IIABS = II+NIES(ISYMI)
              do IJ=1,NISH(ISYMJ)
                IJABS = IJ+NIES(ISYMJ)
                IBUF = II+NORB(ISYMI)*(IJ-1)
                Val = Half*ERI(IBUF)
                if (IIABS >= IJABS) then
                  IIJP = KIGEJ(IIABS,IJABS)-NIGEJES(ISYM)
                  JWP = ITUP+NASP*(IIJP-1)
                  if (IIABS > IJABS) then
                    GA_Arrays(LWP)%A(JWP) = GA_Arrays(LWP)%A(JWP)+Val
                    IIJM = KIGTJ(IIABS,IJABS)-NIGTJES(ISYM)
                    IWM = ITUM+NASM*(IIJM-1)
                    GA_Arrays(LWM)%A(IWM) = GA_Arrays(LWM)%A(IWM)+Val
                  else
                    GA_Arrays(LWP)%A(JWP) = GA_Arrays(LWP)%A(JWP)+SQ2*Val
                  end if
                else
                  IIJP = KIGEJ(IJABS,IIABS)-NIGEJES(ISYM)
                  JWP = ITUP+NASP*(IIJP-1)
                  GA_Arrays(LWP)%A(JWP) = GA_Arrays(LWP)%A(JWP)+Val
                  IIJM = KIGTJ(IJABS,IIABS)-NIGTJES(ISYM)
                  IWM = ITUM+NASM*(IIJM-1)
                  GA_Arrays(LWM)%A(IWM) = GA_Arrays(LWM)%A(IWM)-Val
                end if
              end do
            end do
          else
            do II=1,NISH(ISYMI)
              IIABS = II+NIES(ISYMI)
              do IJ=1,NISH(ISYMJ)
                IJABS = IJ+NIES(ISYMJ)
                IBUF = II+NORB(ISYMI)*(IJ-1)
                Val = Quart*ERI(IBUF)
                if (IIABS >= IJABS) then
                  IIJP = KIGEJ(IIABS,IJABS)-NIGEJES(ISYM)
                  JWP = ITUP+NASP*(IIJP-1)
                  if (IIABS > IJABS) then
                    GA_Arrays(LWP)%A(JWP) = GA_Arrays(LWP)%A(JWP)+Val
                  else
                    GA_Arrays(LWP)%A(JWP) = GA_Arrays(LWP)%A(JWP)+SQ2*Val
                  end if
                else
                  IIJP = KIGEJ(IJABS,IIABS)-NIGEJES(ISYM)
                  JWP = ITUP+NASP*(IIJP-1)
                  GA_Arrays(LWP)%A(JWP) = GA_Arrays(LWP)%A(JWP)+Val
                end if
              end do
            end do
          end if
        end do
      end do
    end do
  end do
  !  Put WP on disk
  ICASE = 2
  call MKRHS_SAVE(ICASE,ISYM,IVEC,LWP)
  ! Put WM on disk
  if (NINM > 0) then
    ICASE = 3
    call MKRHS_SAVE(ICASE,ISYM,IVEC,LWM)
  end if
  call Deallocate_GA_Array(LWM)
  call Deallocate_GA_Array(LWP)
end do

end subroutine MKRHSB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

subroutine Clr2(XrIn,rOut,nACO,nSD,iSDi,iSDj,nDisp,nTemp,Temp)

! nACO: number of active orbitals

use McKinley_global, only: ipDisp3, ipMO
use Index_Functions, only: iTri, nTri_Elem
use pso_stuff, only: G2
use SOAO_Info, only: iAOtSO
use Symmetry_Info, only: iOper, nIrrep
use Basis_Info, only: nBas
use Disp, only: lDisp
use Etwas, only: nASh
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: XrIn(*)
real(kind=wp), intent(inout) :: rOut(*)
integer(kind=iwp), intent(in) :: nACO, nSD, iSDi(0:nSD), iSDj(0:nSD), nDisp, nTemp
real(kind=wp), intent(inout) :: Temp(nTemp)

call Clr2_inner(XrIn,Temp)

! This is to avoid an explicit interface
contains

subroutine Clr2_inner(XrIn,Temp)

  real(kind=wp), intent(in), target :: XrIn(*)
  real(kind=wp), intent(inout), target :: Temp(nTemp)
  integer(kind=iwp) :: i, ia, iaoi, iaoj, iAsh, iB, ibas, iC, iCmp, id, iDisp, iE, ih, iiii, iij, iIrr, ij1, ij12, ij2, ipF, &
                       ipFKL, ipi, ipj, ipM, ipm2, ipp(0:7), iS, iShell(2), iSO, j, ja, jAsh, jB, jbas, jC, jCmp, jh, jIrr, jis, &
                       js, k, kAsh, kIrr, kl, kls, klt, l, lAsh, lIrr, lMax, lsl, lSO, mIrr, na(0:7), ni, nj, nnA, nX, nXrIn
  real(kind=wp) :: fact, rd
  logical(kind=iwp) :: Process
  real(kind=wp), pointer :: rIn(:,:,:,:,:), Temp1(:,:,:), Temp2(:), Temp3(:,:,:), Temp4(:,:,:), Temp5(:,:,:), Temp6(:)
  integer(kind=iwp), external :: NrOpr

  ibas = iSDi(3)
  jbas = iSDj(3)
  iCmp = iSDi(2)
  jCmp = iSDj(2)
  iAOi = iSDi(7)
  iAOj = iSDj(7)

  nXrIn = iBas*iCmp*jBas*jCmp*nIrrep*nTri_Elem(nACO)*nDisp

  ni = iBas*iCmp
  nj = jBas*jCmp

  rIn(1:ni,1:nj,0:nIrrep-1,1:nTri_Elem(nACO),1:nDisp) => XrIn(1:nXrIn)

  iS = 1
  iE = iBas*iCmp*nACO
  Temp1(1:iBas,1:iCmp,1:nACO) => Temp(iS:iE)

  iS = iE+1
  iE = iE+nACO**2
  Temp2(1:nACO**2) => Temp(iS:iE)
  Temp2(:) = Zero

  iS = iE+1
  iE = iE+jBas*jCmp*nACO
  Temp3(1:jBas,1:jCmp,1:nACO) => Temp(iS:iE)
  iS = iE+1
  iE = iE+iBas*iCmp*nACO
  Temp4(1:iBas,1:iCmp,1:nACO) => Temp(iS:iE)
  Temp4(:,:,:) = Zero
  iS = iE+1
  iE = iE+jBas*jCmp*nACO
  Temp5(1:jBas,1:jCmp,1:nACO) => Temp(iS:iE)
  Temp5(:,:,:) = Zero
  iS = iE+1

  nX = 1
  iE = iE+nX
  Temp6(1:nX) => Temp(iS:iE) ! dummy set

  Process = .false.
  call PckMo2(temp6,icmp,iBas,jcmp,jBas,iaoi,iaoj,Process,nX)
  iE = iE-1+nX
  Temp6(1:nX) => Temp(iS:iE)

  iShell(1) = iSDi(11)
  iShell(2) = iSDj(11)

  nnA = 0
  do iS=0,nIrrep-1
    nA(iS) = nNA
    nnA = nnA+nAsh(is)
  end do

  ipi = 1

  ipj = ipi+nACO*ibas*icmp

  Process = .true.
  call PckMo2(temp6,icmp,iBas,jcmp,jBas,iaoi,iaoj,Process,nX)

  id = 0
  do mIrr=0,nIrrep-1
    iiii = 0
    do iS=0,nIrrep-1
      js = nrOpr(ieor(ioper(is),iOper(mIrr)))
      ipp(is) = iiii
      iiii = nbas(is)*nash(js)+iiii
    end do
    do iDisp=1,lDisp(mIrr)
      iD = id+1
      ia = 1
      do iIrr=0,nIrrep-1
        kl = 0
        k = 0
        do kIrr=0,nIrrep-1
          do kAsh=1,nAsh(kIrr)
            k = k+1
            l = 0
            do lIrr=0,kIrr
              kls = ieor(iOper(kIrr),iOper(lIrr))
              jIrr = nropr(ieor(ieor(iOper(iIrr),iOper(mIrr)),kls))
              ja = 1
              do j=0,jIrr-1
                ja = ja+nAsh(j)
              end do

              ! Symmetry of Q matrix

              jis = nropr(ieor(iOper(iIrr),ioper(mIrr)))

              lMax = nAsh(lIrr)
              if (lIrr == kirr) lmax = kash
              do lAsh=1,lMax
                l = lash+nA(lIrr)
                kl = itri(k,l)

                ! id,iirr,jirr,kA,lA

                if (nash(jirr) /= 0) &
                  call DGEMM_('N','N',ni,nAsh(jIrr),nj, &
                              One,rIn(:,:,iIrr,kl,id),ni, &
                                  Temp6(ipj+(ja-1)*jcmp*jBas:nX),nj, &
                              Zero,Temp1,ni)
                if (nash(iirr) /= 0) &
                  call DGEMM_('T','N',nash(iIrr),nAsh(jIrr),ni, &
                              One,Temp6(ipi+(ia-1)*icmp*ibas:nX),ni, &
                                  Temp1,ni, &
                              Zero,Temp2,nash(iirr))

                do iC=1,iCmp
                  do iB=1,iBas
                    do i=1,nAsh(jis)
                      ih = i+na(jis)
                      Temp4(iB,ic,i) = Zero
                      do iAsh=1,nAsh(jirr)
                        jh = iash+na(jirr)
                        fact = One
                        iij = itri(ih,jh)
                        if ((iij >= kl) .and. (k == l)) fact = Two
                        if ((iij < kl) .and. (ih == jh)) fact = Two
                        if (k /= l) FacT = fact*Two
                        rd = G2(itri(iij,kl),1)*fact
                        Temp4(iB,ic,i) = Temp4(ib,ic,i)+Temp1(ib,ic,iash)*rd
                      end do
                    end do
                  end do
                end do

                ipF = ipDisp3(id)-1+ipp(iirr)
                do jAsh=1,nAsh(jis)
                  do iC=1,iCmp
                    lSO = iAOtSO(iAOi+iC,iIrr)
                    if (lso > 0) then
                      do iB=1,iBas
                        lsl = lSO+ib-1
                        ipFKL = ipF+(jAsh-1)*nBas(iIrr)+lsl
                        rOut(ipFKL) = rOut(ipFKL)+Temp4(ib,ic,jash)
                      end do
                    end if
                  end do
                end do

                if (iShell(1) /= iShell(2)) then
                  if (nash(jirr) /= 0) &
                    call DGEMM_('T','N',nj,nAsh(jIrr),ni, &
                                One,rIn(:,:,jIrr,kl,id),ni, &
                                    Temp6(ipi+(ja-1)*icmp*ibas:nX),ni, &
                                Zero,Temp3,nj)
                  if (nash(iirr) /= 0) &
                    call DGEMM_('T','N',nAsh(iirr),nAsh(jirr),nj, &
                                One,Temp6(ipj+(ia-1)*jcmp*jBas:nX),nj, &
                                    Temp3,nj, &
                                One,Temp2,nAsh(iirr))

                  do jC=1,jCmp
                    do jB=1,jBas
                      do i=1,nAsh(jis)
                        ih = i+na(jis)
                        Temp5(jB,jc,i) = Zero
                        do iAsh=1,nAsh(jirr)
                          jh = iash+na(jirr)
                          fact = One
                          iij = itri(ih,jh)
                          if ((iij >= kl) .and. (k == l)) fact = Two
                          if ((iij < kl) .and. (ih == jh)) fact = Two
                          if (k /= l) FacT = fact*Two
                          rd = G2(itri(iij,kl),1)*fact
                          Temp5(jB,jc,i) = Temp5(jb,jc,i)+Temp3(jb,jc,iash)*rd
                        end do
                      end do
                    end do
                  end do

                  ipf = ipDisp3(id)-1+ipp(iirr)
                  do iAsh=1,nAsh(jis)
                    do jC=1,jCmp
                      iSO = iAOtSO(iAOj+jC,iIrr)
                      if (iso > 0) then
                        do jB=1,jBas
                          i = iSO+jb-1
                          ipFKL = ipF+(iAsh-1)*nBas(iIrr)+i
                          rOut(ipFKL) = rOut(ipFKL)+Temp5(jb,jc,iash)
                        end do
                      end if
                    end do
                  end do
                end if

                ! Distribute integrals

                if (iirr >= jirr) then
                  klt = itri(k,l)
                  do iAsh=1,nash(iirr)
                    ij1 = iAsh+na(iirr)
                    do jAsh=1,nash(jirr)
                      ij2 = jAsh+na(jirr)
                      if (ij1 >= ij2) then
                        ij12 = itri(ij1,ij2)
                        if (ij12 <= klt) then
                          ipM = ipMO(iD)+iTri(ij12,klt)-1
                          ipm2 = iash+(jash-1)*nash(iirr)
                          rOut(ipm) = rOut(ipm)+Temp2(ipm2)
                        end if
                      end if
                    end do
                  end do
                end if
              end do ! lash
            end do ! lirr
          end do ! kash
        end do ! kirr
        ia = ia+nAsh(iIrr)
      end do ! iirr
    end do ! ndisp
  end do ! msym

end subroutine Clr2_inner

end subroutine Clr2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Gunnar Karlstrom                                 *
*               2000, Roland Lindh                                     *
************************************************************************
      Real*8 Function Anal_Gitt(cordsi,latato)
************************************************************************
*                                                                      *
*     Object:                                                          *
*                                                                      *
*     Authors: G. Karlstroem                                           *
*              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
*                                                                      *
*              and                                                     *
*                                                                      *
*              R. Lindh                                                *
*              Dept. of Chem. Phys., Univ. of Lund, Sweden.            *
*                                                                      *
*              March 2000                                              *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 cordsi(3,latato)
*
      Anal_Gitt=Zero
*
*.....analyze the lattice
*
      gatom=Zero
      Do i=1,latato
         faktor=One
         x1=cordsi(1,i)+One
         y1=cordsi(2,i)
         z1=cordsi(3,i)
         Do j=1,latato
            r2 = (x1-cordsi(1,j))**2
     &         + (y1-cordsi(2,j))**2
     &         + (z1-cordsi(3,j))**2
            If (r2.lt.0.01D0) faktor=faktor+One
         End Do

         x1=cordsi(1,i)-One
         y1=cordsi(2,i)
         z1=cordsi(3,i)
         Do j=1,latato
            r2 = (x1-cordsi(1,j))**2
     &         + (y1-cordsi(2,j))**2
     &         + (z1-cordsi(3,j))**2
            If (r2.lt.0.01D0) faktor=faktor+One
         End Do

         x1=cordsi(1,i)
         y1=cordsi(2,i)+One
         z1=cordsi(3,i)
         Do j=1,latato
            r2 = (x1-cordsi(1,j))**2
     &         + (y1-cordsi(2,j))**2
     &         + (z1-cordsi(3,j))**2
            If (r2.lt.0.01D0) faktor=faktor+One
         End Do

         x1=cordsi(1,i)
         y1=cordsi(2,i)-One
         z1=cordsi(3,i)
         Do j=1,latato
            r2 = (x1-cordsi(1,j))**2
     &         + (y1-cordsi(2,j))**2
     &         + (z1-cordsi(3,j))**2
            If (r2.lt.0.01D0) faktor=faktor+One
         End Do

         x1=cordsi(1,i)
         y1=cordsi(2,i)
         z1=cordsi(3,i)+One
         Do j=1,latato
            r2 = (x1-cordsi(1,j))**2
     &         + (y1-cordsi(2,j))**2
     &         + (z1-cordsi(3,j))**2
            If (r2.lt.0.01D0) faktor=faktor+One
         End Do

         x1=cordsi(1,i)
         y1=cordsi(2,i)
         z1=cordsi(3,i)-One
         Do j=1,latato
            r2 = (x1-cordsi(1,j))**2
     &         + (y1-cordsi(2,j))**2
     &         + (z1-cordsi(3,j))**2
            If (r2.lt.0.01D0) faktor=faktor+One
         End Do
         gatom=gatom+One/faktor
      End Do
      Anal_Gitt=gatom
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MatPCM(NTs,Eps,Conductor,ISphe,Coor_Sph,Tessera,DMat,SMat,SDMat,TMat,RMat)
! Compute PCM matrix with the formalism in
! M. Cossi, N. Rega, G. Scalmani, V. Barone JCP in press;
! D.M. Chipman JCP 112, 5558 (2000).
! Solvation charges are defined through
! Tq = RV
! where V is the solute electrostatic potential. Here T^-1*R is computed
! and finally returned in DMat.

use PCM_Arrays, only: DiagScale
use Constants, only: Zero, One, Two, Four, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NTs, ISPhe(NTs)
real(kind=wp), intent(in) :: Eps, Coor_Sph(4,*), Tessera(4,NTs)
real(kind=wp), intent(out) :: DMat(NTs,NTs), SMat(NTs,NTs), SDMat(NTs,NTs), TMat(NTs,NTs), RMat(NTs,NTs)
logical(kind=iwp), intent(in) :: Conductor
integer(kind=iwp) :: ITs, JTs, KTs, LI
real(kind=wp) :: EpsFac, Fac, Prod, RIJ, XI, XJ, XNI, YI, YJ, YNI, ZI, ZJ, ZNI
real(kind=wp), parameter :: FPI = Four*Pi, TPI = Two*Pi

if (Conductor) then

  ! Conductor model

  ! S matrix
  EpsFac = Eps/(Eps-One)
  SMat(:,:) = Zero
  do ITs=1,NTs
    XI = Tessera(1,iTs)
    YI = Tessera(2,iTs)
    ZI = Tessera(3,iTs)
    SMat(ITs,ITs) = -DiagScale*EpsFac*sqrt(FPI/Tessera(4,ITs))
    do JTs=1,ITs-1
      XJ = Tessera(1,jTs)
      YJ = Tessera(2,jTs)
      ZJ = Tessera(3,jTs)
      RIJ = sqrt((XI-XJ)**2+(YI-YJ)**2+(ZI-ZJ)**2)
      SMat(ITs,JTs) = -EpsFac*One/RIJ
      SMat(JTs,ITs) = SMat(ITs,JTs)
    end do
  end do

  ! Invert S matrix and store it in D

  if (Eps > One) then
    call MatInvert(SMat,nTs)
    DMat(:,:) = SMat(:,:)
  else
    DMat(:,:) = Zero
  end if

else

  ! Dielectric model:

  ! S and D* matrices
  DMat(:,:) = Zero
  do ITs=1,NTs
    XI = Tessera(1,iTs)
    YI = Tessera(2,iTs)
    ZI = Tessera(3,iTs)
    LI = ISphe(ITs)
    XNI = (XI-Coor_Sph(1,LI))/Coor_Sph(4,LI)
    YNI = (YI-Coor_Sph(2,LI))/Coor_Sph(4,LI)
    ZNI = (ZI-Coor_Sph(3,LI))/Coor_Sph(4,LI)
    SMat(ITs,ITs) = DiagScale*sqrt(FPI/Tessera(4,ITs))
    DMat(ITs,ITs) = DMat(ITs,ITs)-TPI/Tessera(4,ITs)
    do JTs=1,NTs
      if (JTs == ITs) cycle
      XJ = Tessera(1,jTs)
      YJ = Tessera(2,jTs)
      ZJ = Tessera(3,jTs)
      RIJ = sqrt((XI-XJ)**2+(YI-YJ)**2+(ZI-ZJ)**2)
      SMat(ITs,JTs) = One/RIJ
      Prod = (XI-XJ)*XNI+(YI-YJ)*YNI+(ZI-ZJ)*ZNI
      DMat(ITs,JTs) = -Prod/RIJ**3
      DMat(JTs,JTs) = DMat(JTs,JTs)-DMat(ITs,JTs)*Tessera(4,ITs)/Tessera(4,JTs)
    end do
  end do

  ! S*A*D matrix
  SDMat(:,:) = Zero
  do ITs=1,NTs
    do JTs=1,NTs
      do KTs=1,NTs
        SDMat(ITs,JTs) = SDMat(ITs,JTs)+SMat(ITs,KTs)*Tessera(4,KTs)*DMat(KTs,JTs)
      end do
    end do
  end do

  ! The charges are defined as
  ! q = T-1 R V,         T = f(e)*S - SAD / 2p

  ! T and R matrices
  Fac = (Eps+One)/(Eps-One)
  TMat(:,:) = Fac*SMat(:,:)-SDMat(:,:)/TPI
  do ITs=1,NTs
    do JTs=1,NTs
      RMat(ITs,JTs) = DMat(JTs,ITs)*Tessera(4,JTs)/TPI
    end do
    RMat(ITs,ITs) = RMat(ITs,ITs)-One
  end do

  ! Invert T matrix

  if (Eps > One) then
    call MatInvert(TMat,nTs)
  else
    TMat(:,:) = Zero
  end if

  ! Form T^-1 * R and store it in D

  call DGEMM_('N','N',nTs,nTs,nTs,One,TMat,nTs,RMat,nTs,Zero,DMat,nTs)

end if

return

end subroutine MatPCM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Chen Zhou                                        *
!***********************************************************************
! 2023, Matthew R. Hennefarth - modified to modern fortran             *
!***********************************************************************

module write_pdft_job

use Molcas, only: MxRoot
use RASDim, only: MxIter
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
private

public :: writejob

contains

!> @brief Write energy and rotation matrix to JobIph or h5
!>
!> @author Matthew R. Hennefarth
!>
!> @param[in] e_states final PDFT energy for each state
!> @param[in] nstates number of states
!> @param[in] si_pdft Optional orthonormal eigenvectors to diagonalize effective Hamiltonian
subroutine writejob(e_states,nstates,si_pdft)

  integer(kind=iwp), intent(in) :: nstates
  real(kind=wp), intent(in) :: e_states(nstates)
  real(kind=wp), optional, intent(in) :: si_pdft(nstates,nstates)
  real(kind=wp) :: energy(mxroot*mxiter)
  integer(kind=iwp) :: i, j

  ! get energies
  energy = Zero
  do i=1,mxIter
    do j=1,nstates
      energy(mxRoot*(i-1)+j) = e_states(j)
    end do
  end do

  call save_energies(energy)

  if (present(si_pdft)) call save_ci(si_pdft,nstates)

end subroutine writejob

!> @brief Save energies to wavefunction file
!>
!> @author Matthew R. Hennefarth
!>
!> @param[in] e_states state energies
subroutine save_energies(e_states)

  use general_data, only: jobiph
  use mcpdft_input, only: mcpdft_options
# ifdef _HDF5_
  use mh5, only: mh5_close_file, mh5_open_attr, mh5_open_dset, mh5_open_file_rw, mh5_put_attr, mh5_put_dset
# endif

# include "intent.fh"

  real(kind=wp), intent(_IN_) :: e_states(:)
  integer(kind=iwp) :: adr19(15), disk
# ifdef _HDF5_
  integer(kind=iwp) :: module_name, refwfn_id, wfn_energy
# endif

  if (.not. mcpdft_options%is_hdf5_wfn) then
    adr19(:) = 0
    disk = 0
    call iDaFile(JOBIPH,2,adr19,15,disk)
    disk = adr19(6)
    call DDaFile(jobiph,1,e_states,size(e_states),disk)
# ifdef _HDF5_
  else
    refwfn_id = mh5_open_file_rw(mcpdft_options%wfn_file)
    module_name = mh5_open_attr(refwfn_id,'MOLCAS_MODULE')
    call mh5_put_attr(module_name,'MCPDFT')
    wfn_energy = mh5_open_dset(refwfn_id,'ROOT_ENERGIES')
    call mh5_put_dset(wfn_energy,e_states)
    call mh5_close_file(refwfn_id)
# endif
  end if

end subroutine save_energies

!> @brief Save MSPDFT final eigenvectors to wavefunction file
!>
!> @author Matthew R. Hennefarth
!>
!> @param[in] si_pdft Rotation matrix to final eigenstate basis
!> @param[in] nstates number of states
subroutine save_ci(si_pdft,nstates)

  use general_data, only: jobiph
  use mcpdft_input, only: mcpdft_options
# ifdef _HDF5_
  use mh5, only: mh5_close_file, mh5_fetch_attr, mh5_fetch_dset, mh5_open_dset, mh5_open_file_rw, mh5_put_dset
# endif
  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp), intent(in) :: nstates
  real(kind=wp), intent(in) :: si_pdft(nstates,nstates)
  integer(kind=iwp) :: ad19, adr19(15), disk, dum(1), ncon, state
# ifdef _HDF5_
  integer(kind=iwp) :: refwfn_id, wfn_cicoef
# endif
  real(kind=wp), allocatable :: ci_rot(:,:), tCI(:,:)

  ncon = 0

  if (.not. mcpdft_options%is_hdf5_wfn) then
    disk = 284 ! where does this number come from?
    call iDafile(jobiph,2,dum,1,disk)
    ncon = dum(1)

# ifdef _HDF5_
  else
    refwfn_id = mh5_open_file_rw(mcpdft_options%wfn_file)
    call mh5_fetch_attr(refwfn_id,'NCONF',ncon)
# endif
  end if

  call mma_allocate(tCI,ncon,nstates,label='tCI')
  call mma_allocate(ci_rot,nstates,ncon,label='CI Rot')

  if (.not. mcpdft_options%is_hdf5_wfn) then
    adr19(:) = 0
    ad19 = 0
    call iDaFile(JOBIPH,2,adr19,15,ad19)
    disk = adr19(4)
  end if

  do state=1,nstates
    if (.not. mcpdft_options%is_hdf5_wfn) then
      call DDafile(jobiph,2,tCI(:,state),ncon,disk)
#   ifdef _HDF5_
    else
      call mh5_fetch_dset(refwfn_id,'CI_VECTORS',tCI(:,state),[ncon,1],[0,state-1])
#   endif
    end if
  end do

  call dgemm_('n','n',nstates,ncon,nstates,One,si_pdft,nstates,tCI,ncon,Zero,ci_rot,nstates)

  if (.not. mcpdft_options%is_hdf5_wfn) then
    disk = adr19(4)
    do state=1,nstates
      call DDafile(jobiph,1,ci_rot(:,state),ncon,disk)
    end do
# ifdef _HDF5_
  else
    wfn_cicoef = mh5_open_dset(refwfn_id,'CI_VECTORS')
    do state=1,nstates
      call mh5_put_dset(wfn_cicoef,ci_rot(:,state),[ncon,1],[0,state-1])
    end do
    call mh5_close_file(refwfn_id)
# endif
  end if

  call mma_deallocate(ci_rot)
  call mma_deallocate(tCI)

end subroutine save_ci

end module write_pdft_job

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FIJTD(INTSYM,INDX,C1,C2,TDMO)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION INTSYM(*),INDX(*),
     *          C1(*),C2(*),TDMO(NBAST,NBAST)
*
      JSYM(L)=JSUNP(INTSYM,L)
*------
* POW: Unnecessary but warning stopping initializations
      ni=-1234567
      nk=-1234567
*------
      ICHK=0
      IADD10=IAD10(8)
100   CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 100
      IF(LEN.LT.0) RETURN
      DO 10 IN=1,LEN
      IND=ICOP1(IN)
      IF(ICHK.NE.0) THEN
        ICHK=0
        INDI=IND
*        NI=MOD(INDI,2**10)
*        NK=MOD(INDI/2**10,2**10)
        NI=IBITS(INDI, 0,10)
        NK=IBITS(INDI,10,10)
        GO TO 10
      END IF
      IF(IND.EQ.0) THEN
        ICHK=1
        GO TO 10
      END IF
*      IVL=MOD(IND,2**6)
*      IC2=MOD(IND/2**6,2**13)
*      IC1=MOD(IND/2**19,2**13)
      IVL=IBITS(IND, 0, 6)
      IC2=IBITS(IND, 6,13)
      IC1=IBITS(IND,19,13)
      IF(IVL.NE.IVVER)GO TO 13
      TDMO(NI,NK)=TDMO(NI,NK)+COP(IN)*C1(IC1)*C2(IC2)
      IF(NI.NE.NK) TDMO(NK,NI)=TDMO(NK,NI)+COP(IN)*C2(IC1)*C1(IC2)
      GO TO 10
13    INDA=IRC(IVL)+IC1
      INDB=IRC(IVL)+IC2
      NA=INDX(INDA)
      NB=INDX(INDB)
      NS1=JSYM(INDA)
      NS1L=MUL(NS1,LSYM)
      INUM=NVIR(NS1L)
      IF(IVL.GE.2)INUM=NVPAIR(NS1L)
      TERM=DDOT_(INUM,C1(NA+1),1,C2(NB+1),1)
      TDMO(NI,NK)=TDMO(NI,NK)+COP(IN)*TERM
      IF(NI.EQ.NK) GOTO 10
      TERM=DDOT_(INUM,C2(NA+1),1,C1(NB+1),1)
      TDMO(NK,NI)=TDMO(NK,NI)+COP(IN)*TERM
10    CONTINUE
      GO TO 100
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dkh_woplft(n,ifodd,wr,rw,p1,p2,q1,q2,t1,t2)
! Product of W(nw)P(np)=Q(np+nw)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
logical(kind=iwp), intent(in) :: ifodd
real(kind=wp), intent(in) :: wr(n,n), rw(n,n), p1(n,n), p2(n,n)
real(kind=wp), intent(inout) :: q1(n,n), q2(n,n)
real(kind=wp), intent(out) :: t1(n,n), t2(n,n)

#include "macros.fh"
unused_var(ifodd)
unused_var(p1)
unused_var(p2)

call dmxma(n,'N','N',wr,q2,t1,One)
call dmxma(n,'N','N',rw,q1,t2,One)
q1(:,:) = t1(:,:)
q2(:,:) = t2(:,:)

return

end subroutine dkh_woplft

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SIGMADET_CVB(C,HC,IREFSM,NCI)

use Lucia_Interface, only: Lucia_Util
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IREFSM, NCI
real(kind=wp), intent(_IN_) :: C(NCI)
real(kind=wp), intent(out) :: HC(NCI)

! Export arguments to be used in sigma_master_cvb

! Call the sigma routine
call LUCIA_UTIL('SIGMA_CVB', &
                CI_Vector=C, &
                SIGMA_Vector=HC, &
                iSym=iREFSM)

end subroutine SIGMADET_CVB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PckInt_mck(abab,nZeta,nab,ab)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, nab
real(kind=wp), intent(in) :: abab(nZeta,nab,nab)
real(kind=wp), intent(out) :: ab(nZeta)
integer(kind=iwp) :: iab, iZeta
real(kind=wp) :: xMax, xTest

! Integrals

do iZeta=1,nZeta
  xMax = Zero
  do iab=1,nab
    xTest = abs(abab(iZeta,iab,iab))
    if (xTest > xMax) xMax = xTest
  end do
  ab(iZeta) = sqrt(xMax)
end do

return

end subroutine PckInt_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GSBBD2B(RHO2,IASM,IATP,IBSM,IBTP,NIA,NIB,
     &                        JASM,JATP,JBSM,JBTP,NJA,NJB,
     &                  IAGRP,IBGRP,NGAS,IAOC,IBOC,JAOC,JBOC,
     &                  SB,CB,ADSXA,STSTSX,MXPNGAS,
     &                  NOBPTS,IOBPTS,MAXK,
     &                  I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,X,
     &                  NSMOB,NSMST,NSMSX,NSMDX,MXPOBS,IUSEAB,
     &                  CJRES,SIRES,NORB,NTESTG,ieaw)
*
* alpha-beta contribution to two-particle density matrix
* from given c-block and s-block.
*
* =====
* Input
* =====
*
* IASM,IATP : Symmetry and type of alpha  strings in sigma
* IBSM,IBTP : Symmetry and type of beta   strings in sigma
* JASM,JATP : Symmetry and type of alpha  strings in C
* JBSM,JBTP : Symmetry and type of beta   strings in C
* NIA,NIB : Number of alpha-(beta-) strings in sigma
* NJA,NJB : Number of alpha-(beta-) strings in C
* IAGRP : String group of alpha strings
* IBGRP : String group of beta strings
* IAEL1(3) : Number of electrons in RAS1(3) for alpha strings in sigma
* IBEL1(3) : Number of electrons in RAS1(3) for beta  strings in sigma
* JAEL1(3) : Number of electrons in RAS1(3) for alpha strings in C
* JBEL1(3) : Number of electrons in RAS1(3) for beta  strings in C
* CB   : Input C block
* ADSXA : sym of a+, a+a => sym of a
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
* NTSOB  : Number of orbitals per type and symmetry
* IBTSOB : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* NSMOB,NSMST,NSMSX : Number of symmetries of orbitals,strings,
*       single excitations
* MAXK   : Largest number of inner resolution strings treated at simult.
*
*
* ======
* Output
* ======
* SB : updated sigma block
*
* =======
* Scratch
* =======
*
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* I2, XI2S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* X : Space for block of two-electron integrals
*
* Jeppe Olsen, Fall of 1996
*
*
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
      INTEGER ADSXA(MXPOBS,MXPOBS),STSTSX(NSMST,NSMST)
      INTEGER NOBPTS(3,*),IOBPTS(3,*)
*.Input
      DIMENSION CB(*),SB(*)
*. Output
      DIMENSION RHO2(*)
*.Scratch
      DIMENSION I1(*),XI1S(*),I2(*),XI2S(*)
      DIMENSION I3(*),XI3S(*),I4(*),XI4S(*)
      DIMENSION X(*)
      DIMENSION CJRES(*),SIRES(*)
      DIMENSION IAOC(*),IBOC(*),JAOC(*),JBOC(*)
*.Local arrays
      DIMENSION ITP(3 ),JTP(3 ),KTP(3 ),LTP(3 )
*
      NGAS = 3
      ZERO = 0.0D0
      IROUTE = 3
*
*. Symmetry of allowed excitations
      IJSM = STSTSX(IASM,JASM)
      KLSM = STSTSX(IBSM,JBSM)
      itype=2
      If (ieaw.eq.1) itype=3
      IF(IJSM.EQ.0.OR.KLSM.EQ.0) GOTO 9999
*.Types of SX that connects the two strings
      CALL SXTYP_GAS(NKLTYP,KTP,LTP,NGAS,IBOC,JBOC)
      CALL SXTYP_GAS(NIJTYP,ITP,JTP,NGAS,IAOC,JAOC)
      IF(NIJTYP.EQ.0.OR.NKLTYP.EQ.0) GOTO 9999
      DO 2001 IJTYP = 1, NIJTYP
        ITYP = ITP(IJTYP)
        JTYP = JTP(IJTYP)
        DO 1940 ISM = 1, NSMOB
          JSM = ADSXA(ISM,IJSM)
          IF(JSM.EQ.0) GOTO 1940
          IOFF = IOBPTS(ITYP,ISM)
          JOFF = IOBPTS(JTYP,JSM)
          NI = NOBPTS(ITYP,ISM)
          NJ = NOBPTS(JTYP,JSM)
          IF(NI.EQ.0.OR.NJ.EQ.0) GOTO 1940
*EAW
*. Find Ka strings that connect with Ja strings for given group of Jorbs
           KABOT = 1
*. Obtain all strings
           KATOP = -1
           CALL ADST(JOFF,NJ,JATP,JASM,IAGRP,KABOT,KATOP,
     &              I1,XI1S,MAXK,NKASTR,KAEND)
           CALL ADST(IOFF,NI,IATP,IASM,IAGRP,KABOT,KATOP,
     &               I3,XI3S,MAXK,NKASTR,KAEND)
          IDOCOMP = 1
          IF(IDOCOMP.EQ.1) THEN
              CALL COMPRS2LST(I1,XI1S,NJ,I3,XI3S,NI,NKASTR,NKAEFF)
          ELSE
              NKAEFF = NKASTR
          END IF

*. Loop over batches of KA strings
          NKABTC = NKAEFF/MAXK
          IF(NKABTC*MAXK.LT.NKAEFF) NKABTC = NKABTC + 1
          DO 1801 IKABTC = 1, NKABTC
            KABOT = (IKABTC-1)*MAXK + 1
            KATOP = MIN(KABOT+MAXK-1,NKAEFF)
            LKABTC = KATOP-KABOT+1
*. Obtain C(ka,J,JB) for Ka in batch
            DO JJ = 1, NJ
              CALL GET_CKAJJB(CB,NJ,NJA,CJRES,LKABTC,NJB,
     &             JJ,I1(KABOT+(JJ-1)*NKASTR),
     &             XI1S(KABOT+(JJ-1)*NKASTR))
            END DO
*. Obtain S(ka,i,Ib) for Ka in batch
            DO II = 1, NI
              CALL GET_CKAJJB(SB,NI,NIA,SIRES,LKABTC,NIB,
     &             II,I3(KABOT+(II-1)*NKASTR),
     &             XI3S(KABOT+(II-1)*NKASTR))
            END DO
*
            DO 2000 KLTYP = 1, NKLTYP
              KTYP = KTP(KLTYP)
              LTYP = LTP(KLTYP)
*
              DO 1930 KSM = 1, NSMOB
                LSM = ADSXA(KSM,KLSM)
                IF(LSM.EQ.0) GOTO 1930
                KOFF = IOBPTS(KTYP,KSM)
                LOFF = IOBPTS(LTYP,LSM)
                NK = NOBPTS(KTYP,KSM)
                NL = NOBPTS(LTYP,LSM)
*. If IUSEAB is used, only terms with i.ge.k will be generated so
                IKORD = 0
                IF(IUSEAB.EQ.1.AND.ISM.GT.KSM) GOTO 1930
                IF(IUSEAB.EQ.1.AND.ISM.EQ.KSM.AND.ITYP.LT.KTYP)
     &          GOTO 1930
                IF(IUSEAB.EQ.1.AND.ISM.EQ.KSM.AND.ITYP.EQ.KTYP) IKORD=1
*
                IF(NK.EQ.0.OR.NL.EQ.0) GOTO 1930
*EAW
*. Obtain all connections a+l!Kb> = +/-/0!Jb>
*. NKBSTR must be given as input
*. obtain cb(KA,KB,jl) =  sum(JA,JB)<KA!a la!JA><KB!a jb !JB>C(JA,JB)
*
               KBBOT = 1
*. Obtain all strings
               KBTOP = -1
               CALL ADST(LOFF,NL,JBTP,JBSM,IBGRP,KBBOT,KBTOP,
     &                      I2,XI2S,MAXK,NKBSTR,KBEND)
               CALL ADST(KOFF,NK,IBTP,IBSM,IBGRP,KBBOT,KBTOP,
     &                   I4,XI4S,MAXK,NKBSTR,KBEND)

*               IF(NKBSTR.EQ.0) GOTO 1930
                CALL SETVEC(X,ZERO,NI*NJ*NK*NL)
*
                CALL ABTOR2(SIRES,CJRES,LKABTC,NIB,NJB,
     &               NKBSTR,X,NI,NJ,NK,NL,NKBSTR,
     &               I4,XI4S,I2,XI2S,IKORD)
*. contributions to Rho2(ij,kl) has been obtained, scatter out
                CALL ADTOR2_MCLR(RHO2,X,itype,
     &                NI,IOFF,NJ,JOFF,NK,KOFF,NL,LOFF,NORB)

 1930         CONTINUE
 2000       CONTINUE
 1801     CONTINUE
*. End of loop over partitioning of alpha strings
 1940   CONTINUE
 2001 CONTINUE
*
 9999 CONTINUE
*
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(MXPNGAS)
        CALL Unused_integer(NSMSX)
        CALL Unused_integer(NSMDX)
        CALL Unused_integer(NTESTG)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Roland Lindh                                     *
!               2010, Mickael G. Delcey                                *
!               2020, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine calc_LSTvec(mynRP,Reac,Prod,TanVec,Invar)

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: mynRP
real(kind=wp), intent(in) :: Reac(mynRP), Prod(mynRP)
real(kind=wp), intent(out) :: TanVec(mynRP)
logical(kind=iwp), intent(in) :: Invar
integer(kind=iwp) :: i, iAt, iCnt, iProdA, iReacA, j, jTmp, mAt, nAt, nData, nsc
real(kind=wp) :: norm, RMax, RMSD
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: iStab(:)
real(kind=wp), allocatable :: W(:), XYZ(:,:)
real(kind=r8), external :: DDot_

!***********************************************************************
!                                                                      *
!      Object : compute the LST vector, that is Reac-Prod              *
!      Of course it is not that simple, because of metric problems     *
!                                                                      *
!      M.G. Delcey     June 2010                                       *
!      Lund University                                                 *
!                                                                      *
!***********************************************************************
!
! Get the symmetry stabilizers for each center

nAt = mynRP/3
call mma_Allocate(iStab,nAt,label='iStab')
iAt = 1
nsc = 0
do i=1,nCnttp
  do iCnt=1,dbsc(i)%nCntr
    nsc = nsc+1
    if (.not. (dbsc(i)%pChrg .or. dbsc(i)%Frag .or. dbsc(i)%Aux)) then
      jTmp = 0
      do j=1,dc(nsc)%nStab-1
        jTmp = ior(jTmp,dc(nsc)%iStab(j))
      end do
      iStab(iAt) = jTmp
      iAt = iAt+1
    end if
  end do
end do

! Align the structures and compute the vector (un-weighted)

call mma_allocate(XYZ,3*nAt*8,2)
iReacA = 1
iProdA = 2
call Expand_Coor(Reac,nAt,XYZ(1,iReacA),mAt)
call Expand_Coor(Prod,nAt,XYZ(1,iProdA),mAt)
call Qpg_dArray('Weights',Found,nData)
if (Found .and. (nData >= mAt)) then
  call mma_allocate(W,nData,label='W')
  call Get_dArray('Weights',W,nData)
else
  call SysAbendMsg('calc_LSTvec','No or wrong weights were found in the RUNFILE.','')
end if
if (Invar) then
  call Superpose_w(XYZ(1,iReacA),XYZ(1,iProdA),W,mAt,RMSD,RMax)
  call Fix_Symmetry(XYZ(1,iReacA),nAt,iStab)
end if
TanVec(:) = XYZ(1:mynRP,iReacA)-XYZ(1:mynRP,iProdA)
call mma_deallocate(XYZ)
call mma_deallocate(iStab)
call mma_deallocate(W)

! And normalize it

norm = DDot_(mynRP,TanVec,1,TanVec,1)
TanVec(:) = TanVec/sqrt(norm)
!call RecPrt('TanVec',' ',TanVec,3,nAt)

end subroutine calc_LSTvec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine occupy_cvb(nk,nel,locc,lunocc)

use Definitions, only: iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nel, nk(0:nel)
integer(kind=iwp), intent(_OUT_) :: locc(*), lunocc(*)
integer(kind=iwp) :: iel, iocc, iunocc

iocc = 0
iunocc = 0
do iel=1,nel
  if (nk(iel)-nk(iel-1) == 1) then
    iocc = iocc+1
    locc(iocc) = iel
  else if (nk(iel)-nk(iel-1) == 0) then
    iunocc = iunocc+1
    lunocc(iunocc) = iel
  else
    write(u6,*) ' Error in graphical indexing routine!'
    call abend_cvb()
  end if
end do

return

end subroutine occupy_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine getvb2mo2_cvb(orbs,norbcheck,nelcheck)
      implicit real*8 (a-h,o-z)
#include "files_cvb.fh"
#include "casvb.fh"
      dimension orbs(*)

      call cvbinit_cvb()
      call rdheader_cvb(recn_vbwfn,norb1,nbas_mo1,nvb1,kbasiscvb1,
     >  ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)
      if(norbcheck.ne.norb1)then
        call prtfid_cvb(' Error - present number of orbitals'//
     >    ' not consistent with number on ',recn_vbwfn)
        write(6,*)' Numbers :',norbcheck,norb1
        call abend_cvb()
      endif
      ioff=1
      do 100 iorb=1,norb1
      call  rdgspr_cvb(recn_vbwfn,orbs(ioff),iorb,norb1,1,ierr)
      if(ierr.ne.0)then
        write(6,*)' Error in VB orbital read :',ierr
        call abend()
      endif
      ioff=ioff+norb1
100   continue
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(nelcheck)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SXTYP(NSXTP,ITP,JTP,LEL1,LEL3,REL1,REL3)
*
* Types of creation and annihilation  operators so
* <L!a+ a!R> is nonvanishing
*
* L is defined by LEL1,LEL3
* R is defined by REL1,REL3
*
      INTEGER REL1,REL3
      INTEGER ITP(3),JTP(3)
      NSXTP = 0
*
*. To get rid of annoying and incorrect compiler warnings
      I1 = 0
      I3 = 0
      IJ1 = 0
      IJ3 = 0
*
      DO 100 I123 = 1, 3
        IF(I123.EQ.1) THEN
          I1 = 1
          I3 = 0
        ELSE IF(I123.EQ.2) THEN
          I1 = 0
          I3 = 0
        ELSE IF(I123.EQ.3) THEN
          I1 = 0
          I3 = 1
        END IF
        IF(LEL1-I1.LT.0) GOTO 100
        IF(LEL3-I3.LT.0) GOTO 100
        DO 50 J123 = 1, 3
          IF(J123.EQ.1) THEN
            IJ1 = I1 - 1
            IJ3 = I3
          ELSE IF(J123.EQ.2) THEN
            IJ1 = I1
            IJ3 = I3
          ELSE IF(J123.EQ.3) THEN
            IJ1 = I1
            IJ3 = I3-1
          END IF
          IF(REL1+IJ1.EQ.LEL1.AND.REL3+IJ3.EQ.LEL3) THEN
            NSXTP = NSXTP + 1
            ITP(NSXTP) = I123
            JTP(NSXTP) = J123
          END IF
   50   CONTINUE
  100 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,'(A,4I4)')
     &  ' SX  connecting LEL1,LEL3,REL1,REL3 ',LEL1,LEL3,REL1,REL3
        WRITE(6,*) ' Number of connections obtained ', NSXTP
        WRITE(6,*) ' ITYPE JTYPE '
        WRITE(6,*) ' =========== '
        DO 200 I = 1, NSXTP
         WRITE(6,'(2I5)') ITP(I),JTP(I)
  200   CONTINUE
*
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine Chk_Input(irc)
C
C     Author: T.B. Pedersen
C     Purpose: Check input.
C
C     Return codes:
C       irc = 0: all OK
C       irc < 0: all OK, but nothing to do
C       irc > 0: input error
C
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "inflocal.fh"

      Character*9 SecNam
      Parameter (SecNam = 'Chk_Input')

      Logical DoCholesky

      irc = 0
      doCholesky = .False.

      nOrb2LocT = 0
      Do iSym = 1,nSym
         n = nFro(iSym) + nOrb2Loc(iSym)
         If (n.lt.0 .or. n.gt.nOrb(iSym)) Then
            irc = irc + 1
            Write(6,*) SecNam,': nFro + nOrb2Loc out of bounds:'
            Write(6,*) '    iSym     = ',iSym
            Write(6,*) '    nFro     = ',nFro(iSym)
            Write(6,*) '    nOrb2Loc = ',nOrb2Loc(iSym)
            Write(6,*) '    nOrb     = ',nOrb(iSym)
         End If
         If (n .gt. nBas(iSym)) Then
            irc = irc + 1
            Write(6,*) SecNam,': nFro + nOrb2Loc > nBas:'
            Write(6,*) '    iSym     = ',iSym
            Write(6,*) '    nFro     = ',nFro(iSym)
            Write(6,*) '    nOrb2Loc = ',nOrb2Loc(iSym)
            Write(6,*) '    nBas     = ',nBas(iSym)
         End If
         nOrb2LocT = nOrb2LocT + nOrb2Loc(iSym)
      End Do
      If (nOrb2LocT .eq. 0) Then
         irc = -1
         Return
      End If

      If (LocModel.lt.0 .or. LocModel.gt.nLocModel) Then
         Write(6,*) SecNam,': LocModel must satisfy 0 <= LocModel <= ',
     &              nLocModel
         Write(6,*) '    LocModel = ',LocModel
         irc = irc + 1
      End If

      If (LocModel .eq. 4) Then
         Call DecideOnCholesky(doCholesky)
         If (.not.doCholesky) Then
            Call SysAbendMsg(SecNam,
     &           'Edmiston-Ruedenberg localisation not possible:',
     &           'Cholesky integrals required!')
         End If
      End If

      If (EvalER) Then
         Call DecideOnCholesky(doCholesky)
         If (.not.doCholesky) Then
            Write(6,*) SecNam,': evaluation of ER functional requires',
     &                 ' Cholesky decomposition of ERIs!'
            Write(6,*) 'Evaluation of ER functional is cancelled...'
            EvalER = .False.
         End If
      End If

      If (Analysis .and. .not.Test_Localisation) Then
         Test_Localisation = .True.
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Jeppe Olsen                                      *
!***********************************************************************
! Note pt. CC calculations can be restarted from CI
! calculations in the same space by specifying CI=>CC.
! This requires that the input CI vector and the CC
! vector is in the same space. It would be
! better to do the reformatting after the CI.
!
! One can then do f.ex a partial CISDTQ to initialize the
! CCSD.
!
! It would be
!
! Lucia.f : GAS implementing no pair relativistic Theory
!
! Version of March 2000, Jeppe Olsen

subroutine ZERORC(IFIL,IAMPACKED)
! A record was known to be identical zero
!
! Write corresponding info to file IFIL
!
! IAMPACKED added Oct. 98 / Jeppe Olsen

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IFIL, IAMPACKED
integer(kind=iwp) :: ISCR(2)

! Zero record
ISCR(1) = 1
! Packed form
ISCR(2) = IAMPACKED

call ITODS(ISCR,2,2,IFIL)

end subroutine ZERORC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine JoinLvec (wrk,wrksize,
     c             PossV1,PossV2,NaGrpR,LunAux)
c
c       This routine do:
c        Join L0-L2 files (Global, dimensioned as nc)
c        from local L0-L2 files (dimensioned as ncLoc)
c        N.B. This file have sense only for parallel run
c
c
c       Structure of Cholesky vector files
c
c       L0(m,IJ)    L0vctr  I>=J
c
c       L1(m,I ,A') L1vcxx xx - Group of A'
c@@        kokot som, ze som to takto urobil, prerobit na L(m,a,i) to treba
c
c       L2(m,A'B')  L2xxyy xx - Group of A', A'>=B'
c                          yy - Group of B'
c
c       Memory requirements:
c        real:
c       V1   - max {ov'm; v'v'm;  oom}
c       V2   - max {v'v'm, ov'm; oom}
c        actual:
c       reord routine requirements are used (DistMemReord)
c
#ifdef _MOLCAS_MPP_
        use Para_Info, only: MyRank
#endif
        implicit none
        integer PossV1,PossV2,NaGrpR,LunAux
#include "chcc1.fh"
#include "chcc_reord.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
#include "wrk.fh"
#ifdef _MOLCAS_MPP_
#include "parcc.fh"
c
c       help variables
        character*6 LunName
        integer aGrp,bGrp
        integer dim1,dima,dimb,dimab
        integer i,ncLoc,ncOff
c
c
c7.0        calculate ncOffset for given node
        ncLoc=NChLoc(myRank)
        ncOff=0
        if (myRank.gt.0) then
          do i=0,myRank-1
          ncOff=ncOff+NChLoc(i)
          end do
        end if
c
c
c
c7.1        Make global L0
        LunName=L0Name
c
c7.1.1  Read Local L0 = V2(ml,ij) on proper place in V2
        dim1=ncLoc*no*(no+1)/2
        call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
c7.1.2        Vanish V1(m,ij)
        dim1=nc*no*(no+1)/2
        call mv0zero (dim1,dim1,wrk(PossV1))
c
c7.1.3        Insert V2(ml,ij) -> V1(m,ij)
        dim1=no*(no+1)/2
        call InsL (wrk(PossV2),wrk(PossV1),ncLoc,nc,ncOff,dim1)
c
c##        Synchronizacny bod
c7.1.4        Allreduce V1
        dim1=nc*no*(no+1)/2
        call gadgop (wrk(PossV1),dim1,'+')
c
c7.1.5        Save L0 (Global)
        dim1=nc*no*(no+1)/2
        call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c
c
c7.2    make global L1 files
c
        do aGrp=1,NaGrpR
        dima=DimGrpaR(aGrp)
        LunName=L1Name(aGrp)
c
c7.2.1  read L1 = V2(ml,i,a') back into file
        dim1=no*dima*ncLoc
        call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
c7.2.2        Vanish V1(m,i,a')
        dim1=nc*no*dima
        call mv0zero (dim1,dim1,wrk(PossV1))
c
c7.2.3        Insert V2(ml,i,a') -> V1(m,i,a')
        dim1=no*dima
        call InsL (wrk(PossV2),wrk(PossV1),ncLoc,nc,ncOff,dim1)
c
c##        Synchronizacny bod
c7.2.4        Allreduce V1
        dim1=nc*no*dima
        call gadgop (wrk(PossV1),dim1,'+')
c
c7.2.5        Save V1(m,i,a') (Global)
        dim1=nc*no*dima
        call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
        end do
c
c
c
c2.3    Make glogal L2(m,a'b') files
c
        do aGrp=1,NaGrpR
        dima=DimGrpaR(aGrp)
        do bGrp=1,aGrp
        dimb=DimGrpaR(bGrp)
        if(aGrp.eq.bGrp) then
          dimab=dima*(dima+1)/2
        else
          dimab=dima*dimb
        end if
        LunName=L2Name(aGrp,bGrp)
c
c
c7.3.1  read L2 = V2(ml,a'b') back into file
        dim1=dimab*ncLoc
        call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
c7.3.2        Vanish V1(m,a'b')
        dim1=nc*dimab
        call mv0zero (dim1,dim1,wrk(PossV1))
c
c7.3.3        Insert V2(ml,a',b') -> V1(m,a',b')
        dim1=dimab
        call InsL (wrk(PossV2),wrk(PossV1),ncLoc,nc,ncOff,dim1)
c
c##        Synchronizacny bod
c7.3.4        Allreduce V1
        dim1=nc*dimab
        call gadgop (wrk(PossV1),dim1,'+')
c
c7.3.5        Save V1(ml,a',b') (Global)
        dim1=nc*dimab
        call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
        end do
        end do
c
#else
c Avoid unused argument warnings
        if (.false.) then
          call Unused_real_array(wrk)
          call Unused_integer(PossV1)
          call Unused_integer(PossV2)
          call Unused_integer(NaGrpR)
          call Unused_integer(LunAux)
        end if
#endif
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE EXCH(ISYP,ISYI,ISYQ,ISYJ,II,IJ,ERI,SCR)

      IMPLICIT REAL*8 (A-H,O-Z)

      DIMENSION ERI(*), SCR(*)
      LOGICAL TRANSP
#include "intgrl.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "blksize.fh"

      NDIM2M=(NSYMZ*(NSYMZ+1))/2
      IF(ISYP.GE.ISYQ) THEN
        ISY1=ISYP
        ISY2=ISYQ
        ISY3=ISYI
        ISY4=ISYJ
        I3=II
        I4=IJ
        TRANSP=.TRUE.
      ELSE
        ISY1=ISYQ
        ISY2=ISYP
        ISY3=ISYJ
        ISY4=ISYI
        I3=IJ
        I4=II
        TRANSP=.FALSE.
      END IF

C We are going for an EXCH1 or EXCH2 integral of symmetry
C block ISY1,ISY3,ISY2,ISY4.
C Disk address to symmetry block, and record nr:

      IS12=(ISY1*(ISY1-1))/2+ISY2
      IF(ISY3.GT.ISY4) THEN
        IS34=(ISY3*(ISY3-1))/2+ISY4
        IDISK=IAD2M(2,IS12+NDIM2M*(IS34-1))
        IREC=I4+NOSHZ(ISY4)*(I3-1)
      ELSE IF(ISY3.EQ.ISY4) THEN
        IS34=(ISY3*(ISY3-1))/2+ISY4
        IF(I3.GE.I4) THEN
          IDISK=IAD2M(2,IS12+NDIM2M*(IS34-1))
          IREC=(I3*(I3-1))/2 + I4
        ELSE
          IDISK=IAD2M(2,IS12+NDIM2M*(IS34-1))
          IREC=(I4*(I4-1))/2 + I3
          TRANSP= .NOT. TRANSP
        END IF
      ELSE
        IS34=(ISY4*(ISY4-1))/2+ISY3
        IDISK=IAD2M(3,IS12+NDIM2M*(IS34-1))
        IREC=I3+NOSHZ(ISY3)*(I4-1)
      END IF

C Buffer size:
      NO1=NORBZ(ISY1)
      NO2=NORBZ(ISY2)
      NBUF=NO1*NO2
      IF(NBUF.EQ.0) RETURN

C Address update for earlier records, then read:
* PAM07 * Eliminate unsafe IPOSFILE call
*      IDISK=IDISK+iPosFile(NBUF)*(IREC-1)
* Replace with dummy i/o operations: Is this efficience issue??
      DO I=1,IREC-1
        CALL dDAFILE(LUINTMZ,0,SCR,NBUF,IDISK)
      END DO

      IF(TRANSP) THEN
        CALL dDAFILE(LUINTMZ,2,SCR,NBUF,IDISK)
        CALL TRNSPS(NO2,NO1,SCR,ERI)
      ELSE
        CALL dDAFILE(LUINTMZ,2,ERI,NBUF,IDISK)
      END IF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

! Module replacing the code in prgminit.c in molcas-extra

#include "compiler_features.h"
#include "macros.fh"
! from getenvc.c
#define MAXSTR 256

module prgm

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
private

type FileEntry
  character(len=MAXSTR) :: Filename, Shortname
  character(len=16) :: Attr
end type FileEntry
type(FileEntry), allocatable :: FileTable(:)
character(len=MAXSTR) :: WorkDir = '', FastDir = '', Project = 'Noname', StatusFile = ''
character(len=16) :: SlaveDir = '', SubDir = ''

public :: PrgmInitC, PrgmFree, PrgmTranslate_Mod, SetSubDir
#ifndef _GA_
public :: IsInMem
#endif

! Private extensions to mma interfaces

interface cptr2loff
  module procedure :: fe_cptr2loff
end interface
interface mma_allocate
  module procedure :: fe_mma_allo_1D, fe_mma_allo_1D_lim
end interface
interface mma_deallocate
  module procedure :: fe_mma_free_1D
end interface

contains

subroutine PrgmInitC(ModName,l)
  character(len=*), intent(in) :: ModName
  integer(kind=iwp), intent(in) :: l
  integer(kind=iwp) :: n
  unused_var(l)
  call PrgmCache()
  call ReadPrgmFile(ModName)
  call ReadPrgmFile('global')
  ! Save location of the "status" file, since it will be needed after deallocation
  call PrgmTranslate_Mod('status',5,StatusFile,n,0)
  return
end subroutine PrgmInitC

subroutine PrgmFree()
  if (allocated(FileTable)) call mma_deallocate(FileTable)
  return
end subroutine PrgmFree

subroutine PrgmTranslate_Mod(InStr,l1,OutStr,l2,Par)
  character(len=*), intent(in) :: InStr
  integer(kind=iwp), intent(in) :: l1, Par
  character(len=*), intent(out) :: OutStr
  integer(kind=iwp), intent(out) :: l2
  integer(kind=iwp) :: Num, Loc
  logical(kind=iwp) :: Found, Lustre
  character(len=len(InStr)) :: Input
  character(len=MAXSTR) :: WD, Ext
  character(len=16) :: Attr
  unused_var(l1)
  Lustre = .false.
  Input = InStr
  Loc = index(Input,char(0))
  if (Loc > 0) Input(Loc:) = ''
# ifdef _DEBUGPRINT_
  write(u6,*) 'Translating ',trim(Input)
# endif
  inquire(file=Input,exist=Found)
  if (Found) then
#   ifdef _DEBUGPRINT_
    write(u6,*) 'File ',trim(Input),' exists'
#   endif
    OutStr = Input
  else
    WD = WorkDir
    if (trim(WD) == '') WD = '.'
    if (allocated(FileTable)) then
      Num = FindFile(Input,FileTable)
    else
      Num = -1
    end if
    if (Num > 0) then
#     ifdef _DEBUGPRINT_
      write(u6,*) 'File ',trim(Input),' found in table: ',trim(FileTable(Num)%Filename)
#     endif
      ! the value of $WorkDir will depend on some attributes,
      ! pass it to the ExpandVars function
      Attr = FileTable(Num)%Attr
      if (index(Attr,'f') > 0) WD = FastDir
#     ifdef MOLCAS_LUSTRE
      Lustre = (index(Attr,'l') > 0)
#     endif
      if ((Par == 1) .and. (.not. Lustre)) WD = trim(WD)//SlaveDir
      OutStr = FileTable(Num)%Filename
      OutStr = ExpandVars(OutStr,trim(WD)//SubDir)
      ! add "extension" to multi files
      if (index(Attr,'*') > 0) then
        Ext = Input(len_trim(FileTable(Num)%Shortname)+1:)
        OutStr = trim(OutStr)//Ext
      else if (index(Attr,'.') > 0) then
        Ext = Input(len_trim(FileTable(Num)%Shortname)+1:)
        Loc = index(OutStr,'.',back=.true.)
        OutStr = ReplaceSubstr(OutStr,Loc,Loc,trim(Ext)//'.')
      end if
    else if ((Num < 0) .and. (Input == 'status')) then
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Using cached "status" entry'
#     endif
      OutStr = trim(StatusFile)
    else
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Assuming $WorkDir/'//trim(Input)
#     endif
      if ((Par == 1)) WD = trim(WD)//SlaveDir
      OutStr = ExpandVars('$WorkDir/'//Input,trim(WD)//SubDir)
    end if
  end if
  l2 = len_trim(OutStr)
# ifdef _DEBUGPRINT_
  write(u6,*) 'Output: ',trim(OutStr)
# endif
  return
end subroutine PrgmTranslate_Mod

subroutine SetSubDir(Dir)
  character(len=*), intent(in) :: Dir
  SubDir = trim(Dir)
  return
end subroutine SetSubDir

#ifndef _GA_
function IsInMem(Filename)
  integer(kind=iwp) :: IsInMem
  character(len=*), intent(in) :: Filename
  unused_var(len(Filename)) ! GCC 4.8 doesn't like just "unused_var(Filename)" here
  ! since FiM is not in OpenMolcas, always return 0
  IsInMem = 0
  return
end function IsInMem
#endif

! Private procedures follow

! Subroutine to read the contents of a .prgm file and append them to FileTable
subroutine ReadPrgmFile(ModName)
  character(len=*), intent(in) :: ModName
  character(len=MAXSTR) :: Dir, Line
  character(len=2*MAXSTR) :: FileName
  logical(kind=iwp) :: Found
  integer(kind=iwp) :: Lu, Error, Num, i, j, k
  integer(kind=iwp), external :: isFreeUnit
  type(FileEntry), allocatable :: TempTable(:), NewTable(:)

# include "macros.fh"
  unused_proc(mma_allocate(FileTable,[0,0]))
  if (.not. allocated(FileTable)) call mma_allocate(FileTable,0,label='FileTable')

# ifdef _DEBUGPRINT_
  write(u6,*) 'ModName: '//trim(ModName)
# endif

  ! If other locations are enabled, pymolcas should be changed too
  ! Or this should be revamped so that pymolcas writes a pre-parsed file
  call GetEnvF('MOLCAS',Dir)
  Dir = trim(Dir)//'/data'
  FileName = trim(Dir)//'/'//trim(ModName)//'.prgm'
  inquire(file=FileName,exist=Found)
  if (Found) then
#   ifdef _DEBUGPRINT_
    write(u6,*) 'FileName: '//trim(FileName)
#   endif
    Lu = isFreeUnit(30)
    call molcas_open(Lu,trim(FileName))
    Num = 0
    do
      read(Lu,*,iostat=Error)
      if (Error /= 0) exit
      Num = Num+1
    end do
    call mma_allocate(TempTable,Num,label='TempTable')
    rewind(Lu)
    Num = 0
    do
      read(Lu,'(A)',iostat=Error) Line
      if (Error /= 0) exit
      Line = adjustl(Line)
      if (Line(1:1) == '#') cycle
      if (index(Line,'(prgm)') /= 0) cycle
      if (index(Line,'(file)') == 0) cycle
      Num = Num+1
      ! Strip quotes and tabs
      Line = Strip(Line,'"'//char(9))
      Line = adjustl(Line(index(Line,' '):))
      TempTable(Num)%Shortname = Line(:index(Line,' '))
      Line = adjustl(Line(index(Line,' '):))
      TempTable(Num)%Filename = Line(:index(Line,' '))
      Line = adjustl(Line(index(Line,' '):))
      TempTable(Num)%Attr = Line(:index(Line,' '))
    end do
    ! Make sure leftover entries are blanked
    do i=Num+1,size(TempTable)
      TempTable(i)%Shortname = ''
    end do
    ! Count new unique entries
    j = 0
    do i=1,Num
      if (FindFile(TempTable(i)%Shortname,FileTable,Exact=.true.) > 0) cycle
      if (FindFile(TempTable(i)%Shortname,TempTable(1:i-1),Exact=.true.) > 0) cycle
      j = j+1
    end do
    Num = j
    ! Merge and update FileTable
    call mma_allocate(NewTable,size(FileTable)+Num,label='FileTable')
    NewTable(1:size(FileTable)) = FileTable
    k = size(FileTable)
    do i=1,size(TempTable)
      if (TempTable(i)%Shortname == '') exit
      Num = k+1
      j = FindFile(TempTable(i)%Shortname,NewTable(1:k),Exact=.true.)
      if (j > 0) Num = j
      NewTable(Num) = TempTable(i)
      k = max(k,Num)
    end do
    call mma_deallocate(FileTable)
    call move_alloc(NewTable,FileTable)
    call mma_deallocate(TempTable)
    close(Lu)
  end if
# ifdef _DEBUGPRINT_
  call ReportPrgm()
# else
  unused_proc(ReportPrgm())
# endif
  return
end subroutine ReadPrgmFile

! Subroutine to print the contents of FileTable
subroutine ReportPrgm()
  character(len=MAXSTR) :: FmtStr
  integer(kind=iwp) :: MaxLen(2)
  integer(kind=iwp) :: i
  MaxLen = 0
  do i=1,size(FileTable)
    MaxLen(1) = max(MaxLen(1),len_trim(FileTable(i)%Shortname))
    MaxLen(2) = max(MaxLen(2),len_trim(FileTable(i)%Filename))
  end do
  write(FmtStr,*) '(A',MaxLen(1),',1X,A',MaxLen(2),',1X,"<",A,">")'
  write(u6,*) '===================================='
  write(u6,*) 'Number of entries: ',size(FileTable)
  do i=1,size(FileTable)
    write(u6,FmtStr) FileTable(i)%Shortname,FileTable(i)%Filename,trim(FileTable(i)%Attr)
  end do
  write(u6,*) '===================================='
  return
end subroutine ReportPrgm

! Function to strip all the characters in Chars from String (in any position)
function Strip(String,Chars)
# ifdef ALLOC_ASSIGN
  character(len=:), allocatable :: Strip
# else
  character(len=len(String)) :: Strip
# endif
  character(len=*), intent(in) :: String, Chars
  character(len=len(String)) :: Tmp
  integer(kind=iwp) :: i, j
  j = 0
  do i=1,len_trim(String)
    if (index(Chars,String(i:i)) /= 0) cycle
    j = j+1
    Tmp(j:j) = String(i:i)
  end do
  Strip = trim(Tmp(1:j))
  return
end function Strip

! Function to find a file, given its Shortname, in a file table
! Returns the index in the table (or 0 if not found)
function FindFile(Short,Table,Exact)
  integer(kind=iwp) :: FindFile
  character(len=*), intent(in) :: Short
  type(FileEntry), intent(in) :: Table(:)
  logical(kind=iwp), intent(in), optional :: Exact
  logical(kind=iwp) :: FindExact
  integer(kind=iwp) :: i
  FindFile = 0
  if (present(Exact)) then
    FindExact = Exact
  else
    FindExact = .false.
  end if
  do i=1,size(Table)
    ! an entry matches not only if it's equal, also if
    ! the beginning matches and it is a "multi" file
    if (FindExact) then
      if (trim(Short) == trim(Table(i)%Shortname)) then
        FindFile = i
        exit
      end if
    else
      if (index(Short,trim(Table(i)%Shortname)) == 1) then
        if ((trim(Short) == trim(Table(i)%Shortname)) .or. (index(Table(i)%Attr,'*') > 0) .or. &
            (index(Table(i)%Attr,'.') > 0)) then
          FindFile = i
          exit
        end if
      end if
    end if
  end do
  return
end function

! Function to replace environment variables in a string
! A variable starts with '$' and ends with [ $/.] or the end of the string
function ExpandVars(String,WD)
# ifdef ALLOC_ASSIGN
  character(len=:), allocatable :: ExpandVars
# define LEV Len(ExpandVars)
# else
  character(len=MAXSTR) :: ExpandVars
# define LEV Len_Trim(ExpandVars)
# endif
  character(len=*), intent(in) :: String, WD
  character(len=MAXSTR) :: Var, Val
  integer(kind=iwp) :: i, j, Ini, Fin
  ! start with a copy of the string, this copy will be modified on the fly
  ExpandVars = String
  Ini = 0
  i = 0
  ! scan the string, not using a fixed loop because the length and index
  ! will change as replacements are done
  do
    i = i+1
    if (i > LEV) exit
    ! the $ marks the start of the variable, find the end
    ! (by default the end of the string)
    if (ExpandVars(i:i) == '$') then
      Ini = i
      Fin = LEV
      do j=i+1,LEV
        if (index(' $/.',ExpandVars(j:j)) /= 0) then
          Fin = j-1
          exit
        end if
      end do
      ! get the value of the variable and replace it in the string
      Var = ExpandVars(Ini+1:Fin)
      select case (Var)
        case ('Project')
          Val = Project
        case ('WorkDir')
          Val = WD
        case Default
          call GetEnvF(Var,Val)
          if (trim(Val) == '') then
            if (Var /= 'SubProject') Val = 'UNK_VAR'
          end if
      end select
      ExpandVars = ReplaceSubstr(ExpandVars,Ini,Fin,trim(Val))
      ! update the index to continue
      i = Ini+len_trim(Val)-1
    end if
  end do
  return
end function ExpandVars

! Function to replace a substring (between the Ini and Fin positions) with Repl
function ReplaceSubstr(String,Ini,Fin,Repl)
# ifdef ALLOC_ASSIGN
  character(len=:), allocatable :: ReplaceSubstr
# else
  character(len=MAXSTR) :: ReplaceSubstr
# endif
  character(len=*), intent(in) :: String, Repl
  integer(kind=iwp), intent(in) :: Ini, Fin
  integer(kind=iwp) :: i, j
  ! make sure the indices are within limits
  i = min(max(1,Ini),len(String))
  j = min(max(1,Fin),len(String))
  j = max(i,j)
  ReplaceSubstr = trim(String(:i-1)//Repl//String(j+1:))
  return
end function ReplaceSubstr

! Save some often used variables as module variables, for faster access
subroutine PrgmCache()
  use Para_Info, only: mpp_id
  call GetEnvF('WorkDir',WorkDir)
  call GetEnvF('FastDir',FastDir)
  call GetEnvF('Project',Project)
  if (trim(Project) == '') Project = 'Noname'
  if (mpp_id() > 0) write(SlaveDir,'(A,I0)') '/tmp_',mpp_id()
  return
end subroutine PrgmCache

! Private extensions to mma_interfaces, using preprocessor templates
! (see src/mma_util/stdalloc.f)

! Define fe_cptr2loff, fe_mma_allo_1D, fe_mma_allo_1D_lim, fe_mma_free_1D
#define _TYPE_ type(FileEntry)
#  define _FUNC_NAME_ fe_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ fe_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'fe_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

end module prgm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ddrhs_cvb(vec,ndim,ioffs)

use casvb_global, only: mxrhs, nparm, nvrhs, rhs
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndim, ioffs
real(kind=wp), intent(in) :: vec(ndim)

nvrhs = nvrhs+1
if (nvrhs > mxrhs) then
  write(u6,*) ' Too many RHS vectors in Davidson!',nvrhs,mxrhs
  call abend_cvb()
end if
if (ndim+ioffs > nparm) then
  write(u6,*) ' Illegal call to DDRHS :',ndim,ioffs,nparm
  call abend_cvb()
end if
rhs(1:ioffs,nvrhs) = Zero
rhs(ioffs+1:ioffs+ndim,nvrhs) = vec(:)
rhs(ioffs+ndim+1:,nvrhs) = Zero

return

end subroutine ddrhs_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_RI_SwapVecUnit(iSym)

#ifdef _MOLCAS_MPP_
use Para_Info, only: nProcs, Is_Real_Par
#endif
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iSym
#include "cholesky.fh"
#include "choglob.fh"
integer(kind=iwp) :: iTmp
logical(kind=iwp) :: doSwap

#ifdef _MOLCAS_MPP_
doSwap = (nProcs > 1) .and. Is_Real_Par()
#else
doSwap = .false.
#endif

if (doSwap) then
  iTmp = LuCho(iSym)
  LuCho(iSym) = LuCho_G(iSym)
  LuCho_G(iSym) = iTmp
end if

return

end subroutine Cho_RI_SwapVecUnit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OutCoor(TEXT,Chr,nDim,FI,N1,N2,lAngstroms)
!***********************************************************************
!                                                                      *
!     Object: To generate a cartesian output with atomic labels        *
!             N1 and N2 are the real limits of dummy FI                *
!                                                                      *
!***********************************************************************

use Constants, only: Angstrom
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDim, N1, N2
character(len=*), intent(in) :: TEXT, Chr(nDim)
real(kind=wp), intent(in) :: FI(N1,N2)
logical(kind=iwp), intent(in) :: lAngstroms
integer(kind=iwp) :: I

write(u6,*)
write(u6,*) '*********************************************************'
write(u6,*) Text
write(u6,*) '*********************************************************'
write(u6,*) ' ATOM              X               Y               Z     '
do I=1,NDIM
  if (lAngstroms) then
    write(u6,300) Chr(I),FI(1:3,I)*Angstrom
  else
    write(u6,300) Chr(I),FI(1:3,I)
  end if
end do

write(u6,*)

return

300 format(2X,A,3X,3F16.6)

end subroutine OutCoor

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Bernd Artur Hess                                 *
************************************************************************
      SubRoutine Ass_pX(Alpha,nZeta,Final,la,lb,Slaplb,Slamlb,nComp)
************************************************************************
*                                                                      *
* Object: to assemble the pV integrals from                            *
*         derivative integrals of the electric potential.              *
*                                                                      *
*     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
*             Chemie, University of Bonn, Germany, August 1994         *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8  Final (nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,3,nComp),
     *        Slaplb(nZeta,(la+2)*(la+3)/2,(lb+1)*(lb+2)/2,nComp),
     *        Slamlb(nZeta, la   *(la+1)/2,(lb+1)*(lb+2)/2,nComp),
     *        Alpha(nZeta)
      Character*80 Label
*
*     Statement function for cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
      nElem(ix) = (ix+1)*(ix+2)/2
*
      iRout = 203
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
          Write (6,*)
          Write (6,*) ' In Ass_pX la,lb,nComp=',la,lb,nComp
          Write (6,*)
          Call RecPrt('Alpha','(10G15.8)',Alpha,nZeta,1)
          Do iComp = 1, nComp
             Write (6,*)
             Write (6,*) 'iComp=',iComp
             Write (6,*)
             Write (Label,'(A,I2,A)')
     &             'Ass_pX:  Slaplb(iComp=',iComp,')'
             Call RecPrt(Label,'(10f15.8)',Slaplb(1,1,1,iComp),
     &                   nZeta,nElem(la+1)*nElem(lb))
             If (la.gt.0) Then
                Write (Label,'(A,I2,A)')
     &                'Ass_pX: Slamlb(iComp=,',iComp,')'
                Call RecPrt(Label,'(10G15.8)',Slamlb(1,1,1,iComp),
     &                      nZeta,nElem(la-1)*nElem(lb))
             End If
          End Do
      End If
*
      Do iComp = 1, nComp
*
      Do 10 ixa = la, 0, -1
         Do 11 iya = la-ixa, 0, -1
            iza = la-ixa-iya
            ipa = Ind(la,ixa,iza)
*
      Do 20 ixb = lb, 0, -1
         Do 21 iyb = lb-ixb, 0, -1
            izb = lb-ixb-iyb
            ipb = Ind(lb,ixb,izb)
*                                                                      *
************************************************************************
*                                                                      *
            If (ixa.EQ.0) Then
               ixp=Ind(la+1,ixa+1,iza)
               Do iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,1,iComp) =
     &               Two*Alpha(iZeta)*Slaplb(iZeta,ixp,ipb,iComp)
               End Do
            Else
               ixp=Ind(la+1,ixa+1,iza)
               ixm=Ind(la-1,ixa-1,iza)
               Do iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,1,iComp) =
     &               Two*Alpha(iZeta)*Slaplb(iZeta,ixp,ipb,iComp)
     &              -Dble(ixa)*       Slamlb(iZeta,ixm,ipb,iComp)
               End Do
            End If
*
            If (iya.EQ.0) Then
               iyp=Ind(la+1,ixa,iza)
               Do iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,2,iComp) =
     &               Two*Alpha(iZeta)*Slaplb(iZeta,iyp,ipb,iComp)
               End Do
            Else
               iyp=Ind(la+1,ixa,iza)
               iym=Ind(la-1,ixa,iza)
               Do iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,2,iComp) =
     &               Two*Alpha(iZeta)*Slaplb(iZeta,iyp,ipb,iComp)
     &              -Dble(iya)*       Slamlb(iZeta,iym,ipb,iComp)
               End Do
            End If
*
            If (iza.EQ.0) Then
               izp=Ind(la+1,ixa,iza+1)
               Do iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,3,iComp) =
     &               Two*Alpha(iZeta)*Slaplb(iZeta,izp,ipb,iComp)
               End Do
            Else
               izp=Ind(la+1,ixa,iza+1)
               izm=Ind(la-1,ixa,iza-1)
               Do iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,3,iComp) =
     &               Two*Alpha(iZeta)*Slaplb(iZeta,izp,ipb,iComp)
     &              -Dble(iza)*       Slamlb(iZeta,izm,ipb,iComp)
               End Do
            End If
*                                                                      *
************************************************************************
*                                                                      *
21       Continue
20    Continue
*
11       Continue
10    Continue
*
      End Do
*
      If (iPrint.ge.49) Then
          Write (6,*) ' In Ass_pX la,lb,nComp=',la,lb,nComp
          Do iComp = 1, nComp
             Write (6,*)
             Write (6,*) 'iComp=',iComp
             Write (6,*)
*
             Write (Label,'(A,I2,A)')
     &          ' Ass_pX: pX( 1,iComp=',iComp,')'
             Call RecPrt(Label,'(10G15.8)',
     &                   Final(1,1,1,1,iComp),nZeta,
     &                   nElem(la)*nElem(lb))
*
             Write (Label,'(A,I2,A)')
     &          ' Ass_pX: pX( 2,iComp=',iComp,')'
             Call RecPrt(Label,'(10G15.8)',
     &                   Final(1,1,1,2,iComp),nZeta,
     &                   nElem(la)*nElem(lb))
*
             Write (Label,'(A,I2,A)')
     &          ' Ass_pX: pX( 3,iComp=',iComp,')'
             Call RecPrt(Label,'(10G15.8)',
     &                   Final(1,1,1,3,iComp),nZeta,
     &                   nElem(la)*nElem(lb))
         End Do
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GTSTTPS(IEL1,IEL3,NEL1,NEL3,NTYP,ITYP,IWAY)
*
* ITYP : type of strings with IEL1,IEL3 electrons
*
* IWAY = 1 : IEL1, IEL3 known, find ITYP
* IWAY = 2 : ITYP known, find IEL1, IEL3
*
      IMPLICIT REAL*8 (A-H,O-Z)
*
      DIMENSION NEL1(*),NEL3(*)
*
      IF(IWAY.EQ.1) THEN
        ITYP = -1
        DO 10 IITYP = 1, NTYP
          IF(IEL1.EQ.NEL1(IITYP).AND.IEL3.EQ.NEL3(IITYP))
     &    ITYP = IITYP
   10   CONTINUE
*
C       IF(ITYP .EQ. -1 ) THEN
C         WRITE(6,*) ' Error in GSTTPS '
C         WRITE(6,*) ' Error : Type could not be identified'
C         WRITE(6,*) ' Error : IEL1 IEL3 : , IEL1,IEL3 '
C         WRITE(6,*) ' I am going to STOP '
C         STOP'GSTTPS'
C       END IF
      ELSE IF (IWAY .EQ. 2 ) THEN
        IEL1 = NEL1(ITYP)
        IEL3 = NEL3(ITYP)
      END IF
*
      NTEST = 0
      IF(NTEST.GE.100) THEN
        WRITE(6,'(A,5I4)') ' GSTTPS : IWAY IEL1 IEL3 ITYP ',
     &  IWAY,IEL1,IEL3,ITYP
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Joseph Golab                                           *
!               1987, Jeppe Olsen                                      *
!               1989, Markus P. Fuelscher                              *
!***********************************************************************

subroutine ORDSTR(IINST,IOUTST,NELMNT,ISGN,IPRINT)
! AUTHOR:        J. OLSEN, UNIV. OF LUND, SWEDEN, APRIL 1987
! MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
!                M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
!
! PURPOSE:
!
! ORDER A STRING OF INTEGERS TO ASCENDING ORDER
! IINST : INPUT STRING IS IINST
! IOUTST : OUTPUT STRING IS IOUTST
! NELMNT : NUMBER OF INTEGERS IN STRING
! ISGN : SIGN OF PERMUTATION : +1 : EVEN PERMUTATION
!                              -1 : ODD  PERMUTATION
!
! THIS CODE CONTAINS THE OLD ORDER CODE OF JOE GOLAB
! (HE IS HEREBY AKNOWLEDGED, AND I AM EXCUSED)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NELMNT, IINST(NELMNT), IPRINT
integer(kind=iwp), intent(out) :: IOUTST(NELMNT), ISGN
integer(kind=iwp) :: I, JOE, SWAP

if (NELMNT == 0) return

IOUTST(:) = IINST(:)
ISGN = 1

! BEGIN TO ORDER

JOE = 1
outer: do
  I = JOE
  do
    if (I == NELMNT) exit outer
    if (IOUTST(I) > IOUTST(I+1)) exit
    I = I+1
  end do
  JOE = I+1
  do
    SWAP = IOUTST(I)
    ISGN = -ISGN
    IOUTST(I) = IOUTST(I+1)
    IOUTST(I+1) = SWAP
    if (I == 1) cycle outer
    I = I-1
    if (IOUTST(I) <= IOUTST(I+1)) exit
  end do
end do outer

! END ORDER

if (IPRINT > 30) then
  write(6,*) ' INPUT STRING ORDERED STRING ISGN'
  call IWRTMA(IINST,1,NELMNT,1,NELMNT)
  call IWRTMA(IOUTST,1,NELMNT,1,NELMNT)
  write(6,*) ' ISGN : ',ISGN
end if

return

end subroutine ORDSTR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c     Compute F3 using cumulant reconstruction except for G3-dependent terms
      Function CU4F3H (NAC,E,ES,G1,G2,F1,F2,iP,iQ,jP,jQ,kP,kQ)
      Implicit Real*8 (A-H,O-Z)
      Dimension E(NAC)
      Dimension G1(NAC,NAC), G2(NAC,NAC,NAC,NAC)
      Dimension F1(NAC,NAC), F2(NAC,NAC,NAC,NAC)
c
      CU4F3H=0.0D0
c
c Compute these 3PDM contributions in other place
c
c     // G(I,i)G(JKL,jkl)[4]
c     CU4F3H=CU4F3H
c    & + G1(lT,lT)*G3(iP,iQ,jP,jQ,kP,kQ)
c     // G(I,j)G(JKL,ikl)[12]
c     CU4F3H=CU4F3H
c    & - 0.5D0*G1(iP,lT)*G3(lT,iQ,jP,jQ,kP,kQ)
c    & - 0.5D0*G1(jP,lT)*G3(lT,jQ,iP,iQ,kP,kQ)
c    & - 0.5D0*G1(kP,lT)*G3(lT,kQ,iP,iQ,jP,jQ)
c    & - 0.5D0*G1(lT,iQ)*G3(iP,lT,jP,jQ,kP,kQ)
c    & - 0.5D0*G1(lT,jQ)*G3(jP,lT,iP,iQ,kP,kQ)
c    & - 0.5D0*G1(lT,kQ)*G3(kP,lT,iP,iQ,jP,jQ)
c

c     // G(I,i)G(JKL,jkl)[4]
      CU4F3H=CU4F3H
     & + G1(iP,iQ)*F2(jP,jQ,kP,kQ)
     & + G1(jP,jQ)*F2(iP,iQ,kP,kQ)
     & + G1(kP,kQ)*F2(iP,iQ,jP,jQ)
c     // G(I,j)G(JKL,ikl)[12]
      CU4F3H=CU4F3H
     & - 0.5D0*G1(iP,jQ)*F2(jP,iQ,kP,kQ)
     & - 0.5D0*G1(iP,kQ)*F2(kP,iQ,jP,jQ)
     & - 0.5D0*G1(jP,iQ)*F2(iP,jQ,kP,kQ)
     & - 0.5D0*G1(jP,kQ)*F2(kP,jQ,iP,iQ)
     & - 0.5D0*G1(kP,iQ)*F2(iP,kQ,jP,jQ)
     & - 0.5D0*G1(kP,jQ)*F2(jP,kQ,iP,iQ)
c     // G(IJ,ij)G(KL,kl)[3]
      CU4F3H=CU4F3H
     & + G2(iP,iQ,jP,jQ)*F1(kP,kQ)
     & + G2(iP,iQ,kP,kQ)*F1(jP,jQ)
     & + F1(iP,iQ)*G2(jP,jQ,kP,kQ)
c     // G(IJ,ik)G(KL,jl)[12]
      CU4F3H=CU4F3H
     & - 0.5D0*G2(iP,iQ,jP,kQ)*F1(kP,jQ)
     & - 0.5D0*G2(jP,jQ,iP,kQ)*F1(kP,iQ)
     & - 0.5D0*G2(kP,kQ,iP,jQ)*F1(jP,iQ)
     & - 0.5D0*F1(iP,jQ)*G2(jP,iQ,kP,kQ)
     & - 0.5D0*F1(iP,kQ)*G2(kP,iQ,jP,jQ)
     & - 0.5D0*F1(jP,kQ)*G2(kP,jQ,iP,iQ)
c     // G(I,i)G(J,j)G(KL,kl)[6]
      CU4F3H=CU4F3H
     & - 2.0D0*G1(iP,iQ)*G1(jP,jQ)*F1(kP,kQ)
     & - 2.0D0*G1(iP,iQ)*G1(kP,kQ)*F1(jP,jQ)
     & - 2.0D0*G1(jP,jQ)*G1(kP,kQ)*F1(iP,iQ)
     & - 2.0D0*G1(iP,iQ)*ES*G2(jP,jQ,kP,kQ)
     & - 2.0D0*G1(jP,jQ)*ES*G2(iP,iQ,kP,kQ)
     & - 2.0D0*G1(kP,kQ)*ES*G2(iP,iQ,jP,jQ)
c     // G(I,j)G(J,i)G(KL,kl)[6]
      CU4F3H=CU4F3H
     & + G1(iP,jQ)*G1(jP,iQ)*F1(kP,kQ)
     & + G1(iP,kQ)*G1(kP,iQ)*F1(jP,jQ)
     & + G1(jP,kQ)*G1(kP,jQ)*F1(iP,iQ)
c     // G(I,i)G(J,k)G(KL,jl)[24]
      CU4F3H=CU4F3H
     & + G1(iP,iQ)*G1(jP,kQ)*F1(kP,jQ)
     & + G1(iP,iQ)*G1(kP,jQ)*F1(jP,kQ)
     & + G1(jP,jQ)*G1(iP,kQ)*F1(kP,iQ)
     & + G1(jP,jQ)*G1(kP,iQ)*F1(iP,kQ)
     & + G1(kP,kQ)*G1(iP,jQ)*F1(jP,iQ)
     & + G1(kP,kQ)*G1(jP,iQ)*F1(iP,jQ)
     & + ES*G1(iP,jQ)*G2(jP,iQ,kP,kQ)
     & + ES*G1(jP,iQ)*G2(iP,jQ,kP,kQ)
     & + ES*G1(iP,kQ)*G2(kP,iQ,jP,jQ)
     & + ES*G1(kP,iQ)*G2(iP,kQ,jP,jQ)
     & + ES*G1(jP,kQ)*G2(kP,jQ,iP,iQ)
     & + ES*G1(kP,jQ)*G2(jP,kQ,iP,iQ)
c     // G(I,j)G(J,k)G(KL,il)[24]
      CU4F3H=CU4F3H
     & - 0.5D0*G1(iP,jQ)*G1(jP,kQ)*F1(kP,iQ)
     & - 0.5D0*G1(iP,kQ)*G1(kP,jQ)*F1(jP,iQ)
     & - 0.5D0*G1(jP,iQ)*G1(iP,kQ)*F1(kP,jQ)
     & - 0.5D0*G1(jP,kQ)*G1(kP,iQ)*F1(iP,jQ)
     & - 0.5D0*G1(kP,iQ)*G1(iP,jQ)*F1(jP,kQ)
     & - 0.5D0*G1(kP,jQ)*G1(jP,iQ)*F1(iP,kQ)
c     // G(I,i)G(J,j)G(K,k)G(L,l)[1]
      CU4F3H=CU4F3H
     & + 6.0D0*G1(iP,iQ)*G1(jP,jQ)*G1(kP,kQ)*ES
c     // G(I,j)G(J,i)G(K,k)G(L,l)[6]
      CU4F3H=CU4F3H
     & - 3.0D0*G1(iP,jQ)*G1(jP,iQ)*G1(kP,kQ)*ES
     & - 3.0D0*G1(iP,kQ)*G1(kP,iQ)*G1(jP,jQ)*ES
     & - 3.0D0*G1(jP,kQ)*G1(kP,jQ)*G1(iP,iQ)*ES
c     // G(I,j)G(J,k)G(K,i)G(L,l)[8]
      CU4F3H=CU4F3H
     & + 1.5D0*G1(iP,jQ)*G1(jP,kQ)*G1(kP,iQ)*ES
     & + 1.5D0*G1(iP,kQ)*G1(kP,jQ)*G1(jP,iQ)*ES

c Loop over lT
      DO 900 lT=1,NAC
c     // G(IJ,ik)G(KL,jl)[12]
      CU4F3H=CU4F3H
     & - 0.5D0*G2(iP,iQ,jP,lT)*G2(lT,jQ,kP,kQ)*E(lT)
     & - 0.5D0*G2(iP,iQ,kP,lT)*G2(lT,kQ,jP,jQ)*E(lT)
     & - 0.5D0*G2(jP,jQ,iP,lT)*G2(lT,iQ,kP,kQ)*E(lT)
     & - 0.5D0*G2(jP,jQ,kP,lT)*G2(lT,kQ,iP,iQ)*E(lT)
     & - 0.5D0*G2(kP,kQ,iP,lT)*G2(lT,iQ,jP,jQ)*E(lT)
     & - 0.5D0*G2(kP,kQ,jP,lT)*G2(lT,jQ,iP,iQ)*E(lT)
c     // G(IJ,kl)G(KL,ij)[3], G(IJ,lk)G(KL,ji)[3]
c     // G(IJ,kl)G(KL,ji)[3], G(IJ,lk)G(KL,ij)[3]
      CU4F3H=CU4F3H
     & + (
     &   + 2.0D0*G2(iP,kQ,jP,lT)*G2(kP,iQ,lT,jQ)*E(lT)
     &   + 2.0D0*G2(iP,jQ,kP,lT)*G2(jP,iQ,lT,kQ)*E(lT)
     &   + 2.0D0*G2(iP,jQ,lT,kQ)*G2(jP,iQ,kP,lT)*E(lT)
     &   + 2.0D0*G2(iP,lT,jP,kQ)*G2(kP,jQ,lT,iQ)*E(lT)
     &   + 2.0D0*G2(iP,lT,kP,jQ)*G2(jP,kQ,lT,iQ)*E(lT)
     &   + 2.0D0*G2(iP,kQ,lT,jQ)*G2(jP,lT,kP,iQ)*E(lT)
     &   + G2(iP,kQ,jP,lT)*G2(kP,jQ,lT,iQ)*E(lT)
     &   + G2(iP,jQ,kP,lT)*G2(jP,kQ,lT,iQ)*E(lT)
     &   + G2(iP,jQ,lT,kQ)*G2(jP,lT,kP,iQ)*E(lT)
     &   + G2(iP,lT,jP,kQ)*G2(kP,iQ,lT,jQ)*E(lT)
     &   + G2(iP,lT,kP,jQ)*G2(jP,iQ,lT,kQ)*E(lT)
     &   + G2(iP,kQ,lT,jQ)*G2(jP,iQ,kP,lT)*E(lT)
     & )/6.0D0
c     // G(I,j)G(J,i)G(KL,kl)[6]
      CU4F3H=CU4F3H
     & + G1(iP,lT)*G1(lT,iQ)*G2(jP,jQ,kP,kQ)*E(lT)
     & + G1(jP,lT)*G1(lT,jQ)*G2(iP,iQ,kP,kQ)*E(lT)
     & + G1(kP,lT)*G1(lT,kQ)*G2(iP,iQ,jP,jQ)*E(lT)
c     // G(I,i)G(J,k)G(KL,jl)[24]
      CU4F3H=CU4F3H
     & + G1(iP,iQ)*G1(jP,lT)*G2(lT,jQ,kP,kQ)*E(lT)
     & + G1(iP,iQ)*G1(kP,lT)*G2(lT,kQ,jP,jQ)*E(lT)
     & + G1(jP,jQ)*G1(iP,lT)*G2(lT,iQ,kP,kQ)*E(lT)
     & + G1(jP,jQ)*G1(kP,lT)*G2(lT,kQ,iP,iQ)*E(lT)
     & + G1(kP,kQ)*G1(iP,lT)*G2(lT,iQ,jP,jQ)*E(lT)
     & + G1(kP,kQ)*G1(jP,lT)*G2(lT,jQ,iP,iQ)*E(lT)
     & + G1(iP,iQ)*G1(lT,jQ)*G2(jP,lT,kP,kQ)*E(lT)
     & + G1(iP,iQ)*G1(lT,kQ)*G2(kP,lT,jP,jQ)*E(lT)
     & + G1(jP,jQ)*G1(lT,iQ)*G2(iP,lT,kP,kQ)*E(lT)
     & + G1(jP,jQ)*G1(lT,kQ)*G2(kP,lT,iP,iQ)*E(lT)
     & + G1(kP,kQ)*G1(lT,iQ)*G2(iP,lT,jP,jQ)*E(lT)
     & + G1(kP,kQ)*G1(lT,jQ)*G2(jP,lT,iP,iQ)*E(lT)
c     // G(I,j)G(J,k)G(KL,il)[24]
      CU4F3H=CU4F3H
     & - 0.5D0*G1(iP,jQ)*G1(jP,lT)*G2(lT,iQ,kP,kQ)*E(lT)
     & - 0.5D0*G1(iP,kQ)*G1(kP,lT)*G2(lT,iQ,jP,jQ)*E(lT)
     & - 0.5D0*G1(jP,iQ)*G1(iP,lT)*G2(lT,jQ,kP,kQ)*E(lT)
     & - 0.5D0*G1(jP,kQ)*G1(kP,lT)*G2(lT,jQ,iP,iQ)*E(lT)
     & - 0.5D0*G1(kP,iQ)*G1(iP,lT)*G2(lT,kQ,jP,jQ)*E(lT)
     & - 0.5D0*G1(kP,jQ)*G1(jP,lT)*G2(lT,kQ,iP,iQ)*E(lT)
     & - 0.5D0*G1(iP,lT)*G1(lT,jQ)*G2(jP,iQ,kP,kQ)*E(lT)
     & - 0.5D0*G1(iP,lT)*G1(lT,kQ)*G2(kP,iQ,jP,jQ)*E(lT)
     & - 0.5D0*G1(jP,lT)*G1(lT,iQ)*G2(iP,jQ,kP,kQ)*E(lT)
     & - 0.5D0*G1(jP,lT)*G1(lT,kQ)*G2(kP,jQ,iP,iQ)*E(lT)
     & - 0.5D0*G1(kP,lT)*G1(lT,iQ)*G2(iP,kQ,jP,jQ)*E(lT)
     & - 0.5D0*G1(kP,lT)*G1(lT,jQ)*G2(jP,kQ,iP,iQ)*E(lT)
     & - 0.5D0*G1(lT,iQ)*G1(iP,jQ)*G2(jP,lT,kP,kQ)*E(lT)
     & - 0.5D0*G1(lT,iQ)*G1(iP,kQ)*G2(kP,lT,jP,jQ)*E(lT)
     & - 0.5D0*G1(lT,jQ)*G1(jP,iQ)*G2(iP,lT,kP,kQ)*E(lT)
     & - 0.5D0*G1(lT,jQ)*G1(jP,kQ)*G2(kP,lT,iP,iQ)*E(lT)
     & - 0.5D0*G1(lT,kQ)*G1(kP,iQ)*G2(iP,lT,jP,jQ)*E(lT)
     & - 0.5D0*G1(lT,kQ)*G1(kP,jQ)*G2(jP,lT,iP,iQ)*E(lT)
c     // G(I,k)G(J,l)G(KL,ij)[12]
      CU4F3H=CU4F3H
     & - 0.5D0*G1(iP,kQ)*G1(jP,lT)*G2(kP,iQ,lT,jQ)*E(lT)
     & - 0.5D0*G1(iP,jQ)*G1(kP,lT)*G2(jP,iQ,lT,kQ)*E(lT)
     & - 0.5D0*G1(jP,iQ)*G1(kP,lT)*G2(iP,jQ,lT,kQ)*E(lT)
     & - 0.5D0*G1(iP,lT)*G1(jP,kQ)*G2(lT,iQ,kP,jQ)*E(lT)
     & - 0.5D0*G1(iP,lT)*G1(kP,jQ)*G2(lT,iQ,jP,kQ)*E(lT)
     & - 0.5D0*G1(jP,lT)*G1(kP,iQ)*G2(lT,jQ,iP,kQ)*E(lT)
     & - 0.5D0*G1(iP,jQ)*G1(lT,kQ)*G2(jP,iQ,kP,lT)*E(lT)
     & - 0.5D0*G1(iP,kQ)*G1(lT,jQ)*G2(kP,iQ,jP,lT)*E(lT)
     & - 0.5D0*G1(jP,iQ)*G1(lT,kQ)*G2(iP,jQ,kP,lT)*E(lT)
     & - 0.5D0*G1(jP,kQ)*G1(lT,iQ)*G2(kP,jQ,iP,lT)*E(lT)
     & - 0.5D0*G1(kP,iQ)*G1(lT,jQ)*G2(iP,kQ,jP,lT)*E(lT)
     & - 0.5D0*G1(kP,jQ)*G1(lT,iQ)*G2(jP,kQ,iP,lT)*E(lT)
c     // G(I,j)G(J,i)G(K,k)G(L,l)[6]
      CU4F3H=CU4F3H
     & - 3.0D0*G1(iP,lT)*G1(lT,iQ)*G1(jP,jQ)*G1(kP,kQ)*E(lT)
     & - 3.0D0*G1(jP,lT)*G1(lT,jQ)*G1(iP,iQ)*G1(kP,kQ)*E(lT)
     & - 3.0D0*G1(kP,lT)*G1(lT,kQ)*G1(iP,iQ)*G1(jP,jQ)*E(lT)
c     // G(I,j)G(J,k)G(K,i)G(L,l)[8]
      CU4F3H=CU4F3H
     & + 1.5D0*G1(iP,jQ)*G1(jP,lT)*G1(lT,iQ)*G1(kP,kQ)*E(lT)
     & + 1.5D0*G1(iP,kQ)*G1(kP,lT)*G1(lT,iQ)*G1(jP,jQ)*E(lT)
     & + 1.5D0*G1(jP,kQ)*G1(kP,lT)*G1(lT,jQ)*G1(iP,iQ)*E(lT)
     & + 1.5D0*G1(iP,lT)*G1(lT,jQ)*G1(jP,iQ)*G1(kP,kQ)*E(lT)
     & + 1.5D0*G1(iP,lT)*G1(lT,kQ)*G1(kP,iQ)*G1(jP,jQ)*E(lT)
     & + 1.5D0*G1(jP,lT)*G1(lT,kQ)*G1(kP,jQ)*G1(iP,iQ)*E(lT)
c     // G(I,k)G(J,l)G(K,i)G(L,j)[3]
      CU4F3H=CU4F3H
     & + 1.5D0*G1(iP,kQ)*G1(jP,lT)*G1(kP,iQ)*G1(lT,jQ)*E(lT)
     & + 1.5D0*G1(iP,jQ)*G1(kP,lT)*G1(jP,iQ)*G1(lT,kQ)*E(lT)
     & + 1.5D0*G1(iP,lT)*G1(jP,kQ)*G1(lT,iQ)*G1(kP,jQ)*E(lT)
c     // G(I,j)G(J,k)G(K,l)G(L,i)[6]
      CU4F3H=CU4F3H
     & - 0.75D0*G1(iP,jQ)*G1(jP,kQ)*G1(kP,lT)*G1(lT,iQ)*E(lT)
     & - 0.75D0*G1(iP,kQ)*G1(kP,jQ)*G1(jP,lT)*G1(lT,iQ)*E(lT)
     & - 0.75D0*G1(iP,jQ)*G1(jP,lT)*G1(lT,kQ)*G1(kP,iQ)*E(lT)
     & - 0.75D0*G1(iP,kQ)*G1(kP,lT)*G1(lT,jQ)*G1(jP,iQ)*E(lT)
     & - 0.75D0*G1(iP,lT)*G1(lT,jQ)*G1(jP,kQ)*G1(kP,iQ)*E(lT)
     & - 0.75D0*G1(iP,lT)*G1(lT,kQ)*G1(kP,jQ)*G1(jP,iQ)*E(lT)
  900 CONTINUE
      Return
      End Function

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine loop_cvb(nel,nk,nkmin,nkmax,rc)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nel, nkmin(0:nel), nkmax(0:nel)
integer(kind=iwp), intent(inout) :: nk(0:nel)
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: iel, ik

rc = 0
do iel=1,nel-1
  ik = nk(iel)
  ! Tests: (1) IK+1 OCCUPIED; (2) IK NOT OCCUPIED; (3) IK MINIMAL
  if (.not. ((nk(iel+1)-ik == 1) .or. (ik == nk(iel-1)) .or. (ik == nkmin(iel)))) then
    ! SITUATION IS :  IEL       \     <= NOT MINIMAL
    !                 IEL+1     |
    nk(1:iel-1) = min(nkmax(1:iel-1),ik-1)
    nk(iel) = ik-1
    rc = 1
    return
  end if
end do
! Maximize the loop on exit
nk(0:nel-1) = nkmax(0:nel-1)

return

end subroutine loop_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NRCNF2(NORB,ISM,NCNF2)
! Returns the array NCNF2, which contains the number of
! (sub-)configurations with NCLS closed-shell and NOPN open-shell
! orbitals and having symmetry label LSYM, stored as
!          NCNF2(LSYM,IPOS)
! with IPOS=nTri_Elem(NOCC)+NOPN+1, NOCC=NCLS+NOPN,
! provided that 0<=NCLS, 0<=NOPN, and NOCC<=NORB.
! Prerequisite: The orbital symmetry labels stored in ISM.
! Method: Induction

use Index_Functions, only: nTri_Elem, nTri_Elem1
use Symmetry_Info, only: MUL, nIrrep
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NORB, ISM(NORB)
integer(kind=iwp), intent(out) :: NCNF2(nIrrep,nTri_Elem1(NORB))
integer(kind=iwp) :: IPOS1, IPOS2, IPOS3, ISYM, JSYM, L, NCLS, NEW, NOCC, NOPN

NCNF2(:,:) = 0
NCNF2(1,1) = 1
do L=1,NORB
  do NOCC=L,1,-1
    do NOPN=0,NOCC
      NCLS = NOCC-NOPN
      IPOS1 = nTri_Elem(NOCC)+NOPN+1
      IPOS2 = IPOS1-NOCC
      IPOS3 = IPOS2-1
      do ISYM=1,nIrrep
        NEW = NCNF2(ISYM,IPOS1)
        if (NCLS > 0) NEW = NEW+NCNF2(ISYM,IPOS2)
        JSYM = MUL(ISM(L),ISYM)
        if (NOPN > 0) NEW = NEW+NCNF2(JSYM,IPOS3)
        NCNF2(ISYM,IPOS1) = NEW
      end do
    end do
  end do
end do

end subroutine NRCNF2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Roland Lindh                                     *
************************************************************************
      Subroutine Mk_aCD_acCD_Shells(iCnttp,W2L)
************************************************************************
*                                                                      *
*    Objective: To generate aCD auxiliary basis sets on-the-fly.       *
*                                                                      *
* Called from: Mk_RICD_Shells                                          *
*                                                                      *
*     Author: Roland Lindh, Dept. of Chemistry - Angstrom              *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO, nSOInf, SOAO_Info_Init,
     &                                     SOAO_Info_Free
      Use Basis_Info
      Use Sizes_of_Seward, only: S
      use RICD_Info, only: Do_acCD_Basis, Skip_High_AC, Thrshld_CD
      Implicit Real*8 (A-H,O-Z)
      External Integral_RICD
#include "itmax.fh"
#include "Molcas.fh"
#include "SysDef.fh"
#include "real.fh"
#include "print.fh"
#include "status.fh"
#include "stdalloc.fh"
      Integer, Allocatable :: iList2_c(:,:), iList2_p(:,:), iD_c(:),
     &                        Con(:), ConR(:,:), Prm(:), Indkl_p(:),
     &                        AL(:), LTP(:,:), iD_p(:), Indkl(:)
      Real*8, Allocatable :: Wg(:), Vec(:), Scr(:), TP(:), tVt(:),
     &                       Q(:), A(:), Z(:), tVp(:), tVtF(:), C(:),
     &                       Temp(:), QTmp(:), Tmp(:)
      Real*8, Allocatable :: TInt_c(:), TInt_p(:), ADiag(:)
      Real*8 :: Dummy(1)=[0.0D0]
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Real*8, Allocatable :: H(:), U(:), tVtInv(:)
#endif
      Logical Hit, Found, Diagonal, Keep_Basis, In_Core, W2L
      Character*80 BSLbl, Label
      Character*80 atom,type,author,basis,CGTO, Aux
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Interface
         Subroutine  Drv2El_Atomic_NoSym(Integral_RICD,ThrAO,
     &                                   iCnttp,jCnttp,
     &                                   TInt,nTInt,
     &                                   In_Core,ADiag,Lu_A,ijS_req,
     &                                   Keep_Shell)
         External Integral_RICD
         Real*8 ThrAO
         Integer iCnttp, jCnttp, nTInc, Lu_A, ijS_req, Keep_Shell
         Logical In_Core
         Real*8, Allocatable :: TInt(:), ADiag(:)
         End Subroutine
         Subroutine Fix_Exponents(nP,mP,nC,Exp,CoeffC,CoeffP)
         Integer nP, mP, nC
         Real*8, Allocatable:: Exp(:), CoeffC(:,:,:), CoeffP(:,:,:)
         End Subroutine Fix_Exponents
      End Interface
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*---- Statement Function
*
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      ThrAO=Zero
      mData=4
      nCnttp_Start = nCnttp
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Loop now over all unique valence basis sets and generate the
*     corresponding aCD auxiliary basis sets. Note that there are two
*     different types of aCD auxiliary basis sets, aCD and acCD.
*
      nSO_p=0
      nTheta_All=0
*                                                                      *
************************************************************************
*                                                                      *
*
*     Pick up the threshold for the CD procedure. Note that basis
*     sets might have individual accuracy!
*
      mdc = dbsc(iCnttp)%mdci
      Thr_aCD=dbsc(iCnttp)%aCD_Thr*Thrshld_CD
*
      nTest= dbsc(iCnttp)%nVal-1
*                                                                      *
************************************************************************
*                                                                      *
      If (Skip_High_AC) Then
*
*        Pick up the angular index of the highest valence shell
*
         If (dbsc(iCnttp)%AtmNr.le.2) Then
            iVal=0
         Else If (dbsc(iCnttp)%AtmNr.le.10) Then
            iVal=1
         Else If (dbsc(iCnttp)%AtmNr.le.18) Then
            iVal=1
         Else If (dbsc(iCnttp)%AtmNr.le.36) Then
            iVal=2
         Else If (dbsc(iCnttp)%AtmNr.le.54) Then
            iVal=2
         Else If (dbsc(iCnttp)%AtmNr.le.86) Then
            iVal=3
         Else
            iVal=3
         End If
         Keep_All = 2*nTest
*        Find the number of polarization shells
         iZ=Max(0,nTest-iVal)
*        Reduce the product basis from excessive shells
         Keep_Shell=Keep_All-iZ
      Else
         Keep_Shell=iTabmx
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Define some parameters to facilitate the atomic calculation
*
      iShell = dbsc(iCnttp)%nVal
      S%nShlls=iShell
*                                                                      *
************************************************************************
*                                                                      *
*     Use the name of the old valence basis
*
      Label=dbsc(iCnttp)%Bsl_old
*
      Hit=.True.
      Call Decode(Label,atom,1,Hit)
      Hit=.True.
      Call Decode(Label,type,2,Hit)
      Hit=.True.
      Call Decode(Label,author,3,Hit)
      Hit=.True.
      Call Decode(Label,basis,4,Hit)
      Hit=.True.
      Call Decode(Label,CGTO,5,Hit)
      Hit=.False.
      Call Decode(Label,Aux,6,Hit)
      If (.Not.Hit) Aux = ' '
*
      n=Index(Atom,' ')-1
      Label=' '
      Label(1:n+1)=atom(1:n)//'.'
      nn = n + 1
*
      n=Index(Type,' ')-1
      If (Do_acCD_Basis) Then
         Label(nn+1:nn+n+23)=Type(1:n)//'....acCD-aux-basis.'
      Else
         Label(nn+1:nn+n+22)=Type(1:n)//'....aCD-aux-basis.'
      End If
*
      Indx=Index(Label,' ')
      BSLbl=' '
      BSLbl(1:Indx-1)=Label(1:Indx-1)
*
*     Make a temporary setup of the SOAO_Info arrays for the
*     atomic auxiliary basis set.
*     Note that the auxiliary basis set will carry an angular value
*     which at most is twice that of valence basis set.
*
      mSOInf = 0

      Do iAng = 0, 2*nTest
         nCmp = (iAng+1)*(iAng+2)/2
         mSOInf = mSOInf + nCmp
      End Do
      Call SOAO_Info_Init(mSOInf,1)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     C O N T R A C T E D    S E C T I O N
*
*     Run in contracted mode to generate the auxiliary basis for the
*     aCD primitive product basis.
*
      Call Flip_Flop(.False.)
*                                                                      *
************************************************************************
*                                                                      *
*     Define AOtSO
*
      iAO = 0
      iSO = 0
      nSO=0
      Do iAng = 0, nTest
         iShll_ = dbsc(iCnttp)%iVal + iAng
         nCmp = (iAng+1)*(iAng+2)/2
         If (Shells(iShll_)%Prjct ) nCmp = 2*iAng+1
         iSO = 0
         If (Shells(iShll_)%nBasis_C*Shells(iShll_)%nExp==0) Cycle
         Do iCmp = 1, nCmp
            iAO = iAO + 1
            If (iAO>nSOInf) Then
               Write (6,*) 'mk_acd_accd_shells: iAO>nSOInf (1)'
               Write (6,*) 'iAO=',iAO
               Write (6,*) 'nSOInf=',nSOInf
               Call Abend()
            End If
            iAOtSO(iAO,0) = iSO + 1
            iSO = iSO + Shells(iShll_)%nBasis
         End Do
         nSO=nSO+iSO
      End Do
*
*     Generate list
*
      nPhi_All=nSO*(nSO+1)/2
      Call mma_allocate(iList2_c,mData*2,nPhi_All,label='iList2_c')
      Call Mk_List2(iList2_c,nPhi_All,mData,nSO,iCnttp,nTest,0)
*                                                                      *
************************************************************************
*                                                                      *
*     If the full product basis is used no need for decomposition!
*
      If (Thr_aCD.eq.0.0D0) Then
         nTInt_c=nPhi_All
         Call mma_allocate(iD_c,nTInt_c,label='iD_c')
         Do i = 1, nTInt_c
            iD_c(i) = i
         End Do
         NumCho_c=nTInt_c
         Go To 1881
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Generate atomic two-electron integrals to decompose.
*
      ijS_req=0
      Call Drv2El_Atomic_NoSym(Integral_RICD,ThrAO,iCnttp,iCnttp,
     &                         TInt_c,nTInt_c,
     &                         In_Core,ADiag,Lu_A,ijS_req,Keep_Shell)
*                                                                      *
************************************************************************
*                                                                      *
*     Let us now decompose and retrieve the most important
*     contracted products, indicies stored in iD_c
*
      Call mma_allocate(iD_c,nTInt_c,label='iD_c')
*
*     Temporary code for weights to be used in a MS-aCD/acCD
*     scheme. Currently set to unit giving the convential
*     all purpose aCD/acCD auxiliary basis sets.
*
      Call mma_allocate(Wg,nTInt_c,label='Wg')
      call dcopy_(nTInt_c,[1.0D0],0,Wg,1)
*
      If (In_Core) Then
#ifdef _DEBUGPRINT_
         Call RecPrt('TInt_c',' ',TInt_c,nTInt_c,nTInt_c)
#endif
         Call mma_allocate(Vec,nTInt_c**2,label='Vec')
*
         Call CD_InCore_p_w(TInt_c,nTInt_c,
     &                      Wg,Vec,nTInt_c,iD_c,NumCho_c,
     &                      Thr_aCD,iRC)
*
         If (iRC.ne.0) Then
            Call WarningMessage(2,'Error in Mk_RICD_Shells')
            Write (6,*) 'Mk_aCD_Shells: CD_InCore_p(c) failed!'
            Call Abend()
         End If
#ifdef _DEBUGPRINT_
         Call RecPrt('Vec',' ',Vec,nTInt_c,NumCho_c)
#endif
         Call mma_deallocate(TInt_c)
         Call mma_deallocate(Vec)
*
      Else    ! out-of-core part
*
         Call GetMem('Scr','Max','Real',iDum,lScr)
         lScr=Min(lScr-2*nTInt_c,nTInt_c**2+3*nTInt_c)
         Call mma_Allocate(Scr,lScr,label='Scr')
*
         iSeed=Lu_A+1
         Lu_B=IsFreeUnit(iSeed)
         Call DaName_MF_WA(Lu_B,'AVEC1')
*
         Call Get_Pivot_idx_w(ADiag,Wg,nTInt_c,
     &                        NumCho_c,Lu_A,Lu_B,iD_c,
     &                        Scr,lScr,Thr_aCD)
*
         Call mma_deallocate(Scr)
         Call mma_deallocate(ADiag)
         Call DaEras(Lu_B)
         Call DaEras(Lu_A)
*
      End If
*
      Call mma_deallocate(Wg)
*
 1881 Continue
*
      If (NumCho_c.lt.1) Then
         Call WarningMessage(2,'Error in Mk_RICD_Shells')
         Write (6,*) 'Mk_aCD_Shells: NumCho_c.lt.1 is illegal!'
         Call Abend()
      End If
*
#ifdef _DEBUGPRINT_
      Write (6,*) ' Thr_aCD:',Thr_aCD
      Write (6,*) 'NumCho_c:',NumCho_c
      Call iVcPrt('iD_c',' ',iD_c,NumCho_c)
#endif
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Define AOtSO for primitive integral calculations.
*
      If (Do_acCD_Basis) Then
         iAO = 0
         iSO = 0
         nSO_p=0
         Do iAng = 0, nTest
            iShll_ = dbsc(iCnttp)%iVal + iAng
            nCmp = (iAng+1)*(iAng+2)/2
            If (Shells(iShll_)%Prjct) nCmp = 2*iAng+1
            iSO = 0
            Do iCmp = 1, nCmp
               iAO = iAO + 1
               If (iAO>nSOInf) Then
                  Write (6,*) 'mk_acd_accd_shells: iAO>nSOInf (2)'
                  Call Abend()
               End If
               iAOtSO(iAO,0) = iSO + 1
               iSO = iSO + Shells(iShll_)%nExp
            End Do
            nSO_p=nSO_p+iSO
         End Do
      End If
*                                                                      *
************************************************************************
************************************************************************
************************************************************************
*                                                                      *
*        Loop through angular products. Note that all the products
*        of an atom require multiple basis sets since Seward is not
*        structured to handle more than one shell of a specific
*        angular at the time, i.e. a basis set contains only, for
*        example, one d-shell. For an atomic basis spd we will have
*        the p*p and d*s resulting in two independent shells with
*        the same total angular momentum, d.
*
         iShll=S%Mx_Shll - 1
*
*        Start now looping over the products and analys the result
*        of the CD. Note the very peculiar loop structure over
*        iBS, iAng, and jAng. This to reduce the number of
*        created basis sets.
*
         nBS = (nTest+2)/2
         Do iBS = 0, nBS-1
            iAngMin=iBS
            iAngMax=nTest - iBS
*
            nCnttp=nCnttp+1
            Keep_Basis = .False.
*
            If (nCnttp.gt.Mxdbsc) Then
               Call WarningMessage(2,'Error in Mk_RICD_Shells')
               Write (6,*) 'Mk_RICD_Shells: Increase Mxdbsc'
               Call Abend()
            End If
*
*           Some generic setting of information
*
            dbsc(nCnttp)%Bsl=Label
            dbsc(nCnttp)%Bsl_old=dbsc(nCnttp)%Bsl
            dbsc(nCnttp)%pChrg=dbsc(iCnttp)%pChrg
            dbsc(nCnttp)%Fixed=dbsc(iCnttp)%Fixed
            dbsc(nCnttp)%Parent_iCnttp=iCnttp
            dbsc(nCnttp)%iVal = iShll+1
            dbsc(nCnttp)%Aux =.True.
            dbsc(nCnttp)%aCD_Thr=dbsc(iCnttp)%aCD_Thr
            dbsc(nCnttp)%fMass=dbsc(iCnttp)%fMass
*                                                                      *
************************************************************************
*                                                                      *
*           Loop over shell pairs
*
            jShll=iShll
            Do iAng = 0, iAngMax
               jAngMax=Min(iAng,iAngMin)
               iShll_=dbsc(iCnttp)%iVal+iAng
               If (iAng.eq.iAngMax) jAngMax=iAngMax
               If (iAng.lt.iAngMin) jAngMax=0
               jAngMin=iAngMin
               If (iAng.le.iAngMin) jAngMin=0
               Do jAng = jAngMin, jAngMax
                  jShll_=dbsc(iCnttp)%iVal+jAng
*
                  iShll = iShll + 1
#ifdef _DEBUGPRINT_
                  Write (6,*)
                  Write (6,*) 'iAng,jAng=',iAng,jAng
                  Write (6,*) 'iAngMax=',iAngMax
#endif
                  If (iShll.gt.MxShll) Then
                     Call WarningMessage(2,'Error in Mk_RICD_Shells')
                     Write (6,*) 'Mk_RICD_Shells: iShll.gt.MxShll'
                     Write (6,*) 'iShll,MxShll=',iShll,MxShll
                     Call Abend()
                  End If
                  Diagonal=iAng.eq.jAng
*
*                 Examine if any contracted products of these two shells
*                 survived the CD procedure, or that it is an empty shell.
*
                  Found=.False.
                  kShll=-1
                  lShll=-1
                  Do iCho_c = 1, NumCho_c
                     ijSO = iD_c(iCho_c)
                     kAng=iList2_c(1,ijSO)
                     lAng=iList2_c(2,ijSO)
                     If ( iAng.eq.kAng .and. jAng.eq.lAng ) Then
                        kShll=iList2_c(7,ijSO)
                        lShll=iList2_c(8,ijSO)
                        Found=.True.
                        Exit
                     End If
                  End Do
*
*                 Fake Found=.FALSE. for shells which should explicitly be
*                 empty.
*
                  Found = Found .and. jAng.ge.iAngMin
     &                          .and. iAng.ge.iAngMin
     &                          .and. iAng+jAng.le.Keep_Shell
                  Keep_Basis = Found .or. Keep_Basis
#ifdef _DEBUGPRINT_
                  Write (6,*) 'Found,kShll,lShll=',Found,kShll,lShll
#endif
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*                    P R I M I T I V E   S E C T I O N
*
*                    Run in uncontracted mode to produce a SLIM
*                    primitive product  basis.
*
                  If (Do_acCD_Basis.and.Found) Then
*
                     Call Flip_Flop(.True.)
*
*                    Generate list
*
                     npi=Shells(iShll_)%nExp
                     nCmpi=(iAng+1)*(iAng+2)/2
                     If (Shells(iShll_)%Prjct ) nCmpi=2*iAng+1
                     npj=Shells(jShll_)%nExp
                     nCmpj=(jAng+1)*(jAng+2)/2
                     If (Shells(jShll_)%Prjct ) nCmpj=2*jAng+1
                     If (iAng.eq.jAng) Then
                        nTheta_All=npi*nCmpi*(npi*nCmpi+1)/2
                     Else
                        nTheta_All=npi*nCmpi*npj*nCmpj
                     End If
*
                     Call mma_allocate(iList2_p,2*mData,nTheta_all,
     &                                 label='iList2_p')
*
                     ijS_Req=(iAng+1)*iAng/2 + jAng + 1
*
                     Call Mk_List2(iList2_p,nTheta_All,mData,nSO_p,
     &                             iCnttp, nTest,ijS_Req)
*                                                                      *
************************************************************************
*                                                                      *
*                    Generate atomic two-electron integrals
*
                     Call Drv2El_Atomic_NoSym(Integral_RICD,
     &                                        ThrAO,iCnttp,iCnttp,
     &                                        TInt_p,nTInt_p,
     &                                        In_Core,ADiag,Lu_A,
     &                                        ijS_Req,Keep_Shell)
*
                     If (.NOT.In_Core) Then
                        Call WarningMessage(2,'Error in Mk_RICD_Shells')
                        Write (6,*) 'Out-of-core acCD not implemented!'
                        Call Abend()
                     End If
#ifdef _DEBUGPRINT_
                     Call RecPrt('TInt_p','(5G20.11)',
     &                           TInt_p,nTInt_p,nTInt_p)
#endif
                     Call Flip_Flop(.False.)
*
                  End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*                 Now mimic the procedure of GetBS!
*                                                                      *
************************************************************************
*                                                                      *
*                 Working on the CONTRACTED functions.
*
*                 This section is identical for acCD and aCD auxiliary
*                 basis sets!
*                                                                      *
************************************************************************
*                                                                      *
                  If (Found) Then
*
                     lAng = iAng + jAng
*
*                    Now figure out how many and which!
*
                     nk=Shells(kShll)%nBasis_C
                     nl=Shells(lShll)%nBasis_C
                     If (Diagonal) Then
                        nCntrc_Max=nk*(nk+1)/2
                     Else
                        nCntrc_Max=nk*nl
                     End If
#ifdef _DEBUGPRINT_
                     Write (6,*) 'nCntrc_Max=',
     &                                              nCntrc_Max
#endif
                     Call mma_allocate(Con,nCntrc_Max,label='Con')
                     Call mma_allocate(ConR,2,nCntrc_Max,label='ConR')
                     Call IZero(Con,nCntrc_Max)
                     Call IZero(ConR,2*nCntrc_Max)
                     nCntrc=0
                     Do iCho_c = 1, NumCho_c
                        ijSO = iD_c(iCho_c)
                        kAng=iList2_c(1,ijSO)
                        lAng=iList2_c(2,ijSO)
                        If (kAng.eq.iAng.and.lAng.eq.jAng) Then
*
*                          Pick up the radial index!
*
                           ik=iList2_c(5,ijSO)
                           il=iList2_c(6,ijSO)
*
                           If (Diagonal) Then
                              ikl=iTri(ik,il)
                           Else
                              ikl=(il-1)*nk + ik
                           End If
*
*                          Note that this migh be done several time
*                          since several angular pairs might have the same
*                          radial function!
*
                           If (Con(ikl).eq.0) Then
                               nCntrc=nCntrc+1
                               Con(ikl)=1
                               ConR(1,nCntrc)=ik
#ifdef _DEBUGPRINT_
                               Write (6,*) 'iCho_c,  ijSO=',
     &                                      iCho_c+1,ijSO
#endif
                               ConR(2,nCntrc)=il
                           End If
                        End If
                     End Do    !  iCho_c
#ifdef _DEBUGPRINT_
                     Write (6,*) 'nCntrc=',nCntrc
                     Call iVcPrt('Con',' ',Con,nCntrc_Max)
                     Call iVcPrt('ConR',' ',ConR,2*nCntrc)
                     Write (6,*)
                     Write (6,*) 'ConR'
                     Write (6,'(30I3)')
     &                     (ConR(1,i),i=1,nCntrc)
                     Write (6,'(30I3)')
     &                     (ConR(2,i),i=1,nCntrc)
#endif
*
                  Else
*
*                    Let us put in an empty shell!
*
                     nk=0
                     nl=0
                     nCntrc=0
                  End If
*                                                                      *
************************************************************************
*                                                                      *
*                 Work on the PRIMITIVE products!
*
*                 Here the work is trivial in case of the aCD basis
*                                                                      *
************************************************************************
*                                                                      *
                  If (Found) Then
*                                                                      *
************************************************************************
*                                                                      *
*                    Produce the SLIM primitive products
*                                                                      *
************************************************************************
*                                                                      *
                     If (Do_acCD_Basis) Then
*
*                       Now figure out how many and which!
*
                        npk=Shells(kShll)%nExp
                        npl=Shells(lShll)%nExp
                        If (Diagonal) Then
                           nPrim_Max=npk*(npk+1)/2
                        Else
                           nPrim_Max=npk*npl
                        End If
#ifdef _DEBUGPRINT_
                           Write (6,*) 'nPrim_Max:',nPrim_Max
#endif
                        Call mma_allocate(Prm,nPrim_Max,label='Prm')
                        Call IZero(Prm,nPrim_Max)
*
*                       Pick up the diagonal elements from TInt_p
*                       corresponding to this shell pair. We sum over
*                       the angular parts identical to those of the
*                       contracted.
*
                        nCompA=(iAng+1)*(iAng+2)/2
                        nCompB=(jAng+1)*(jAng+2)/2
                        nAB=nCompA*nCompB
                        Call mma_allocate(AL,nAB,label='AL')
*
*                       First make a list from the contracted which
*                       angular products to include.
*
                        Call Mk_AngList(AL,nCompA,nCompB,
     &                                  iD_c,NumCho_c,
     &                                  iList2_c,nPhi_All,
     &                                  2*mData,iAng,jAng)
*
                        Call mma_allocate(TP,nPrim_Max**2,label='TP')
                        Call mma_allocate(LTP,2,nPrim_Max,label='LTP')
                        Call Mk_TInt_P(TInt_p,nTheta_All,
     &                                 TP,nPrim_Max,
     &                                 AL,nCompA,nCompB,
     &                                 iList2_p,nTheta_All,
     &                                 2*mData,iAng,jAng,npk,npl,LTP)
*
#ifdef _DEBUGPRINT_
                        Call RecPrt('TIntP','(5G20.10)',
     &                              TP,nPrim_Max,nPrim_Max)
                        Call iVcPrt('List_TP',' ',LTP,2*nPrim_Max)
#endif
*                       Let us now decompose and retrieve the most
*                       important primitive products, indicies stored in
*                       iD_p
*
                        Call mma_allocate(iD_p,nPrim_Max,label='iD_p')
                        Call mma_allocate(Vec,nPrim_Max**2,label='Vec')
*
                        Thrshld_CD_p = Thr_aCD*2.0D-1
 3377                   Continue
                        Call CD_InCore_p(TP,nPrim_Max,Vec,nPrim_Max,
     &                                   iD_p,NumCho_p,Thrshld_CD_p,iRC)
                        If (NumCho_p.lt.1) Then
                           Call WarningMessage(2,
     &                           'Error in Mk_RICD_Shells')
                           Write (6,*) 'Mk_aCD_Shells: '
     &                               //'NumCho_p.lt.1 is illegal!'
                           Write (6,*) 'iAng,jAng=',iAng,jAng
                           Write (6,*) 'nPrim_Max=',nPrim_Max
                           Write (6,*) 'NumCho_p=',NumCho_p
                           Write (6,*) 'iRC=',iRC
                           Call Abend()
                        End If
*
#ifdef _DEBUGPRINT_
                        Write (6,*) 'Thrshld_CD_p:',Thrshld_CD_p
                        Write (6,*) 'NumCho_p    :',NumCho_p
                        Call iVcPrt('iD_p',' ',iD_p,NumCho_p)
                        Call RecPrt('Vec',' ',Vec,nPrim_Max,NumCho_p)
#endif
                        If (NumCho_p.lt.nCntrc) Then
                           Write (6,*) 'W a r n i n g!'
                           Write (6,*) 'Fewer primitive functions than'
     &                               //' contracted functions!'
                           Write (6,*) 'NumCho_p=',NumCho_p
                           Write (6,*) '  nCntrc=',nCntrc
                           Thrshld_CD_p=Thrshld_CD_p*0.5
                           If (Thrshld_CD_p.le.1.0D-14) Then
                              Call WarningMessage(2,
     &                           'Error in Mk_RICD_Shells')
                              Write (6,*) 'Thrshld_CD_p is too low!'
                              Write (6,*) 'iAng, jAng:',iAng,jAng
                              Call Abend()
                           End If
                           Call Mk_TInt_P(TInt_p,nTheta_All,
     &                                    TP,nPrim_Max,
     &                                    AL,nCompA,nCompB,
     &                                    iList2_p,nTheta_All,
     &                                    2*mData,iAng,jAng,npk,npl,LTP)
                           Go To 3377
                        End If
                        Call mma_deallocate(TP)
                        Call mma_deallocate(Vec)
*
                        Do iCho_p = 1, NumCho_p
                           ijSO = iD_p(iCho_p)
                           Prm(ijSO)=1
                        End Do
                        nPrim=NumCho_p
                        Call mma_allocate(Shells(iShll)%Exp,nPrim,
     &                                    Label='ExpacCD')
                        Shells(iShll)%nExp=nPrim
*
#ifdef _DEBUGPRINT_
                        Write (6,*) 'nPrim=',nPrim
                        Call iVcPrt('Prm',' ',Prm,nPrim_Max)
#endif
                        Call mma_allocate(Indkl_p,nPrim_Max,
     &                                    label='Indkl_p')
                        Call Mk_Indkl(Prm,Indkl_p,nPrim_Max)
*
*                       Observe that the exponents are ordered according
*                       to their importance as given by the CD.
*
                        Do iCho_p = 1, NumCho_p
                           iTheta = iD_p(iCho_p)
                           ik=LTP(1,iTheta)
                           il=LTP(2,iTheta)
                           Exp_i=Shells(kShll)%Exp(ik)
                           Exp_j=Shells(lShll)%Exp(il)
                           Shells(iShll)%Exp(iCho_p)=Exp_i+Exp_j
                        End Do
#ifdef _DEBUGPRINT_
                        Call RecPrt('SLIM Exponents',' ',
     &                             Shells(iShll)%Exp,1,nPrim)
#endif
*                                                                      *
************************************************************************
*                                                                      *
                     Else ! Do_aCD_Basis
*                                                                      *
************************************************************************
*                                                                      *
*                       Put in the aCD set of exponents, i.e. all unique
*                       sums.
*
                        nExpk=Shells(kShll)%nExp
                        nExpl=Shells(lShll)%nExp
                        If (Diagonal) Then
                           nPrim=nExpk*(nExpk+1)/2
                        Else
                           nPrim=nExpk*nExpl
                        End If
                        Call mma_allocate(Shells(iShll)%Exp,nPrim,
     &                                    Label='ExpaCD')
                        Shells(iShll)%nExp=nPrim
*
                        iOff = 0
                        Do ip_Exp = 1, nExpk
                           jp_Exp_Max = nExpl
                           If (Diagonal) jp_Exp_Max = ip_Exp
                           Do jp_Exp = 1, jp_Exp_Max
                              iOff = iOff + 1
                              Shells(iShll)%Exp(iOff)=
     &                                   Shells(kShll)%Exp(ip_Exp)
     &                                  +Shells(lShll)%Exp(jp_Exp)
                           End Do
                        End Do
*
                        If (iOff.ne.nPrim) Then
                           Call WarningMessage(2,
     &                           'Error in Mk_RICD_Shells')
                           Write (6,*) 'Mk_aCD_Shell: iOff.ne.iEnd'
                           Call Abend()
                        End If
*
#ifdef _DEBUGPRINT_
                        If (Diagonal) Then
                           Call TriPrt('aCD Exponents',' ',
     &                                 Shells(iShll)%Exp,nExpk)
                        Else
                           Call RecPrt('aCD Exponents',' ',
     &                                 Shells(iShll)%Exp,nExpk,nExpl)
                        End If
#endif
                     End If
*
                  Else
*                                                                      *
************************************************************************
*                                                                      *
*                    An empty shell
*
                     nPrim=0
                     Shells(iShll)%nExp=nPrim
*                                                                      *
************************************************************************
*                                                                      *
                  End If ! Found
*                                                                      *
************************************************************************
*                                                                      *
                  lAng=iAng+jAng
                  S%iAngMx=Max(S%iAngMx,lAng)
                  S%MaxPrm(lAng)=Max(S%MaxPrm(lAng),nPrim)
*
#ifdef _DEBUGPRINT_
                  Write (6,*)
                  Write (6,*) 'iShll=',iShll
                  Write (6,*) 'nPrim,nCntrc=',nPrim,nCntrc
                  Write (6,*) 'lAng=',lAng
                  Write (6,*) 'S%MaxPrm(lAng)=',S%MaxPrm(lAng)
#endif
*
                  Shells(iShll)%nBasis_c=nCntrc
*                                                                      *
************************************************************************
*                                                                      *
                  Call mma_allocate(Shells(iShll)%Cff_c,
     &                              nPrim,nCntrc,2,Label='Cff_c')
                  Call mma_allocate(Shells(iShll)%pCff,
     &                              nPrim,nCntrc,Label='pCff')
                  Shells(iShll)%nBasis = nCntrc
                  Call mma_allocate(Shells(iShll)%Cff_p,
     &                              nPrim,nPrim ,2,Label='Cff_p')
*                                                                      *
************************************************************************
*                                                                      *
*                 C O N T R A C T I O N    C O E F F I C I E N T S
*
                  If (Found) Then
*                                                                      *
************************************************************************
*                                                                      *
*                    For SLIM basis sets
*                                                                      *
************************************************************************
*                                                                      *
                     If (Do_acCD_Basis) Then
*
*                       Alright this is a bit more elaborate than for
*                       the aCD basis set. Surprise!
*
*                       Some care has to be taken here. There might be
*                       different angular products, for example, px*px
*                       and px*py, which carry the same radial part but
*                       have different angular part! To overcome this
*                       possible source of redundancy we use the sum of
*                       such terms in the fitting procedure!
*
                        nTheta=nPrim
                        nExpk=Shells(kShll)%nExp
                        nExpl=Shells(lShll)%nExp
                        If (iAng.eq.jAng) Then
                           nTheta_Full=nExpk*(nExpk+1)/2
                        Else
                           nTheta_Full=nExpk*nExpl
                        End If
                        nPhi=nCntrc
*
*                       Generate the (theta'|V|theta') matrix in the
*                       SLIM primitive product basis.
*
                        Call mma_allocate(tVt,nTheta**2,label='tVt')
                        Call Mk_tVt(TInt_p,nTInt_p,
     &                              tVt,nTheta,iList2_p,2*mData,
     &                              Prm,nPrim_Max,
     &                              iAng,jAng,nExpk,nExpl,
     &                              Indkl_p,nPrim_Max,
     &                              AL,nCompA,nCompB)
*
#ifdef _DEBUGPRINT_
                        Write (6,*)
                        Write (6,*) 'tVt(Diag)'
                        Write (6,*) (tVt(i),i=1,nTheta**2,nTheta+1)
                        Call RecPrt('tVt',' ',tVt,nTheta,nTheta)
                        Call iVcPrt('iD_p',' ',iD_p,NumCho_p)
#endif
*
*                       Generate (theta'|V|theta')^{-1}
*
*                       Let's do a Cholesky decomposition with pivoting
*                       according to the previous CD.
*
                        nTri=nTheta*(nTheta+1)/2
                        Call mma_allocate(Q,nTri,label='Q')
                        Call mma_allocate(A,nTri,label='A')
                        Call mma_allocate(Z,nTheta,label='Z')
                        Do iCho_p = 1, NumCho_p
                           iTheta_full=iD_p(iCho_p)
                           iTheta     =Indkl_p(iTheta_full)
                           Do jCho_p = 1, iCho_p
                              jTheta_full=iD_p(jCho_p)
                              jTheta     =Indkl_p(jTheta_full)
                              ijT= iCho_p*(iCho_p-1)/2 + jCho_p
                              ijS= (jTheta-1)*nTheta + iTheta
                              A(ijT)=tVt(ijS)
                           End Do
                        End Do
#ifdef _DEBUGPRINT_
                        Call TriPrt('A',' ',A,nTheta)
*
                        Call mma_allocate(H,nTri,label='H')
                        Call mma_allocate(U,nTri,label='U')
                        call dcopy_(nTri,A,1,H,1)
                        Call FZero(U,nTheta**2)
                        call dcopy_(nTheta,[One],0,U,nTheta+1)
                        Call Jacob(H,U,nTheta,nTheta)
                        Call TriPrt('H','(10G20.10)',H,nTheta)
                        Call RecPrt('U',' ',U,nTheta,nTheta)
                        Call mma_deallocate(H)
                        Call mma_deallocate(U)
#endif
*
#ifdef _DEBUGPRINT_
                        Call mma_allocate(tVtInv,nTheta**2,
     &                                    label='tVtInv')
                        iSing=0
                        Det=0.0D0
                        Call MInv(tVt,tVtInv,iSing,Det,nTheta)
                        Write (6,*) 'iSing,Det=',iSing,Det
#endif
                        Call mma_deallocate(tVt)
*
                        Do iTheta = 1, nTheta
                           iOff_Ak=(iTheta-1)*iTheta/2 + 1
                           iOff_Qk=(iTheta-1)*iTheta/2 + 1
                           Thrs= Thrshld_CD_p
C                          Thrs= 1.0D-12
                           Call Inv_Cho_Factor(A(iOff_Ak),iTheta,A,Q,
     &                                         iTheta,iDum,iDum,
     &                                         Dummy,0,Z,
     &                                         Dummy,Thrs,
     &                                         Q(iOff_Qk),LinDep)
                           If (LinDep.eq.1) Then
                              Call WarningMessage(2,
     &                           'Error in Mk_RICD_Shells')
                              Write (6,*) 'Mk_aCD_Shells: linear '
     &                                  //'dependence'
     &                                  //' found in tVt!'
                              Write (6,*) 'Found for vector:',iTheta
                              Call Abend()
                           End If
                        End Do
                        Call mma_deallocate(Z)
                        Call mma_deallocate(A)
#ifdef _DEBUGPRINT_
                        Call TriPrt('Q','(9G10.3)',Q,nTheta)
#endif
*
*                       Generate the (theta'|V|theta) matrix in the
*                       mixed product basis.
*
                        Call mma_allocate(tVp,nTheta*nPhi,label='tVp')
                        Call mma_allocate(tVtF,nTheta*nTheta_Full,
     &                                    label='tVtF')
                        Call Mk_tVtF(TInt_p,nTInt_p,
     &                               tVtF,nTheta,
     &                               iList2_p,2*mData,
     &                               Prm,nPrim_Max,
     &                               iAng,jAng,nExpk,nExpl,
     &                               Indkl_p,nPrim_Max,
     &                               nTheta_Full,
     &                               AL,nCompA,nCompB)
                        Call mma_deallocate(AL)
#ifdef _DEBUGPRINT_
                        Call RecPrt('tVtF',' ',tVtF,nTheta,nTheta_Full)
#endif
*
*                       Pick up the contraction coefficients of the aCD
*                       basis set. Be careful what this means in the
*                       case that the shells are identical!
*
                        Call mma_allocate(Indkl,nCntrc_Max,
     &                                    label='Indkl')
                        Call Mk_Indkl(Con,Indkl,nCntrc_Max)
                        Call mma_allocate(C,nTheta_Full*nPhi,label='C')
                        Call Mk_Coeffs(Shells(kShll)%Cff_c(1,1,1),
     &                                 nExpk,Shells(kShll)%nBasis_C,
     &                                 Shells(lShll)%Cff_c(1,1,1),
     &                                 nExpl,Shells(lShll)%nBasis_C,
     &                                 C,nTheta_Full,nPhi,
     &                                 iD_c,NumCho_c,
     &                                 iList2_c,2*mData,
     &                                 nPhi_All,
     &                                 Indkl,nCntrc_Max,
     &                                 Shells(kShll)%nBasis_C,
     &                                 Shells(lShll)%nBasis_C,
     &                                 iAng,jAng,
     &                                 Shells(kShll)%Cff_p(1,1,1),
     &                                 Shells(lShll)%Cff_p(1,1,1))
                        Call mma_deallocate(Indkl)
#ifdef _DEBUGPRINT_
                        Call RecPrt('C',' ',C,nTheta_Full,nPhi)
#endif
*
*                       Generate the (theta'|V|phi') matrix.
*
                        Call DGEMM_('N','N',
     &                              nTheta,nPhi,nTheta_Full,
     &                              1.0d0,tVtF,nTheta,
     &                              C,nTheta_Full,
     &                              0.0d0,tVp,nTheta)
                        Call mma_deallocate(tVtF)
#ifdef _DEBUGPRINT_
                        Call RecPrt('tVp',' ',tVp,nTheta,nPhi)
#endif
                        Call mma_deallocate(C)
*
*                       Generate the contraction coefficients of the
*                       SLIM contracted product basis in terms of the
*                       SLIM primitive product basis as
*                       Sum(nu') (mu'|V|nu')^-1  (nu'|V|i')=C_{mu',i'}
*
*                       To simplify life I will put the Q matrix into
*                       square storage.
*
                        Call mma_Allocate(Temp,nTheta**2,label='Temp')
                        Call FZero(Temp,nTheta**2)
                        Do iTheta = 1, nTheta
                           Do jTheta = 1, iTheta
                              ijT = iTheta*(iTheta-1)/2 + jTheta
                              ijS = (iTheta-1)*nTheta + jTheta
                              Temp(ijS)=Q(ijT)
                           End Do
                        End Do
                        call mma_deallocate(Q)
#ifdef _DEBUGPRINT_
                        Call RecPrt('Q',' ',Temp,nTheta,nTheta)
#endif
*
*                       Resort the external index back to original
*                       order. The column index is external.
*
                        Call mma_allocate(QTmp,nTheta**2,label='QTmp')
                        Do iCho_p = 1, NumCho_p
                           iTheta_Full = iD_p(iCho_p)
                           iTheta      = Indkl_p(iTheta_Full)
                           call dcopy_(nTheta,Temp(iCho_p),nTheta,
     &                                       QTmp(iTheta),nTheta)
                        End Do
                        Call mma_deallocate(Temp)
#ifdef _DEBUGPRINT_
                        Call RecPrt('Q',' ',QTmp,nTheta,nTheta)
                        Call RecPrt('tVp',' ',tVp,nTheta,nPhi)
#endif
*                       Q(T) tVp
                        Call mma_allocate(Scr,nTheta*nPhi,label='Scr')
                        Scr(:)=0.0D0
                        Call DGEMM_('T','N',
     &                              nTheta,nPhi,nTheta,
     &                              1.0d0,QTmp,nTheta,
     &                              tVp,nTheta,
     &                              0.0d0,Scr,nTheta)
*                       QQ(T) tVp
                        Call DGEMM_('N','N',
     &                              nTheta,nPhi,nTheta,
     &                              1.0d0,QTmp,nTheta,
     &                              Scr,nTheta,
     &                              0.0d0,
     &                              Shells(iShll)%Cff_c(1,1,1),nTheta)
#ifdef _DEBUGPRINT_
                        Call RecPrt('SLIM coeffcients',' ',
     &                               Shells(iShll)%Cff_c(1,1,1),
     &                               nTheta,nPhi)
                        Scr(:)=0.0D0
                        Call DGEMM_('N','N',
     &                              nTheta,nPhi,nTheta,
     &                              1.0d0,tVtInv,nTheta,
     &                              tVp,nTheta,
     &                              0.0d0,Scr,nTheta)
                        Call RecPrt('SLIM coeffcients2',' ',Scr,
     &                               nTheta,nPhi)
                        Call mma_deallocate(tVtInv)
#endif
                        Call mma_deallocate(tVp)
*
*                       Now reorder the coefficients to the CD order of
*                       the exponents.
*
                        Call mma_allocate(Tmp,nTheta*nPhi,label='Tmp')
                        call dcopy_(nTheta*nPhi,
     &                              Shells(iShll)%Cff_c(1,1,1),1,Tmp,1)
                        Do iCho_p = 1, NumCho_p
                           iTheta_full = iD_p(iCho_p)
                           iTheta      = Indkl_p(iTheta_full)
                           call dcopy_(nPhi,
     &                                 Tmp(iTheta),nTheta,
     &                                 Shells(iShll)%Cff_c(iCho_p,1,1),
     &                                             nTheta)
                        End Do
                        Call mma_deallocate(Tmp)
*
*                       Modify from coefficients for normalized
*                       Gaussians to unnormalized Gaussians.
*
                        Do iCho_p = 1, NumCho_p
                           iTheta = iD_p(iCho_p)
                           ik=LTP(1,iTheta)
                           il=LTP(2,iTheta)
                           Fact = Shells(kShll)%Cff_p(ik,ik,1)
     &                          * Shells(lShll)%Cff_p(il,il,1)
                           Call DScal_(nPhi,Fact,
     &                            Shells(iShll)%Cff_c(iCho_p,1,1),
     &                                 nTheta)
                        End Do
                        Call mma_deallocate(LTP)
*
                        Call mma_deallocate(iD_p)
                        Call mma_deallocate(Indkl_p)
                        Call mma_deallocate(Scr)
                        Call mma_deallocate(QTmp)
#ifdef _DEBUGPRINT_
                        Call RecPrt('SLIM coeffcients',' ',
     &                              Shells(iShll)%Cff_c(1,1,1),
     &                              nTheta,nPhi)
#endif
*                                                                      *
************************************************************************
*                                                                      *
                     Else ! Do_aCD_Basis
*                                                                      *
************************************************************************
*                                                                      *
*                       Put in the selected set of coeffients. Note
*                       again that the order should be that according
*                       to the CD in order to prepivot, since the CD
*                       itself is implemented without pivoting.
*
                        Do iCntrc = 1, nCntrc
                           kC = ConR(1,iCntrc)
                           lC = ConR(2,iCntrc)
#ifdef _DEBUGPRINT_
                           Write (6,*) 'kC,lC=',kC,lC
#endif
*                                                                      *
************************************************************************
*                                                                      *
*                          Form the unnormalized coefficients!
*
                           jkl = 0
                           If (Diagonal) Then
                              Do iExp_k = 1, Shells(kShll)%nExp
*
                               Coeff_kk=Shells(kShll)%Cff_c(iExp_k,kC,1)
                               Coeff_lk=Shells(lShll)%Cff_c(iExp_k,lC,1)

                                 Do iExp_l = 1 , iExp_k

                               Coeff_ll=Shells(lShll)%Cff_c(iExp_l,lC,1)
                               Coeff_kl=Shells(kShll)%Cff_c(iExp_l,kC,1)
                                    Coeff_  =Coeff_ll*Coeff_kk
     &                                      +Coeff_kl*Coeff_lk
                                    If (iExp_k.eq.iExp_l) Then
                                       Coeff_  =Coeff_  *Half
                                    End If
                                    jkl = jkl + 1

                               Shells(iShll)%Cff_c(jkl,iCntrc,1)=Coeff_

                                 End Do
                              End Do
                           Else
                              Do iExp_k = 1, Shells(kShll)%nExp

                               Coeff_k =Shells(kShll)%Cff_c(iExp_k,kC,1)

                                 Do iExp_l = 1 , Shells(lShll)%nExp

                               Coeff_l =Shells(lShll)%Cff_c(iExp_l,lC,1)

                                    Coeff_kl=Coeff_l*Coeff_k

                                    jkl = jkl + 1
                              Shells(iShll)%Cff_c(jkl,iCntrc,1)=Coeff_kl
                                 End Do
                              End Do
                           End If
*
                        End Do ! iCntrc
#ifdef _DEBUGPRINT_
                        Call RecPrt('aCD Coefficients','(6G20.12)',
     &                              Shells(iShll)%Cff_c(1,1,1),
     &                              nPrim,nCntrc)
#endif
*                                                                      *
************************************************************************
*                                                                      *
                     End If
*                                                                      *
************************************************************************
*                                                                      *
                     Shells(iShll)%Cff_c(:,:,2)=
     &                       Shells(iShll)%Cff_c(:,:,1)
*
                     Call mma_deallocate(Con)
                     Call mma_deallocate(ConR)
                     If (Do_acCD_Basis) Call mma_deallocate(Prm)
*
*                    Put in unit matrix of uncontracted set
*
                     Shells(iShll)%Cff_p(:,:,1)=Zero
                     Do i=1,nPrim
                        Shells(iShll)%Cff_p(i,i,1)=One
                     End Do
*
                     Shells(iShll)%Cff_p(:,:,2)=
     &                       Shells(iShll)%Cff_p(:,:,1)
                     Call Nrmlz(Shells(iShll)%Exp,nPrim,
     &                          Shells(iShll)%Cff_p(1,1,1),
     &                          nPrim ,lAng)
#ifdef _DEBUGPRINT_
                     Call RecPrt('uncon1',' ',
     &                            Shells(iShll)%Cff_p(:,:,1),
     &                            nPrim,nPrim)
                     Call RecPrt('uncon2',' ',
     &                            Shells(iShll)%Cff_p(:,:,2),
     &                            nPrim,nPrim)
#endif
*
*                    OK let's do the correction now!
*
#ifdef _DEBUGPRINT_
                     Call RecPrt('Coefficients 10',' ',
     &                           Shells(iShll)%Cff_c(:,:,1),
     &                           nPrim,nCntrc)
                     iOff = nPrim*nCntrc
                     Call RecPrt('Coefficients 20',' ',
     &                           Shells(iShll)%Cff_c(:,:,2),
     &                           nPrim,nCntrc)
#endif
                     iOff = nPrim*nCntrc
                     Call Fix_Coeff(nPrim,nCntrc,
     &                              Shells(iShll)%Cff_c(:,:,2),
     &                              Shells(iShll)%Cff_p(:,:,1),'F')
#ifdef _DEBUGPRINT_
                     Call RecPrt('Coefficients 1',' ',
     &                            Shells(iShll)%Cff_c(:,:,1),
     &                            nPrim,nCntrc)
                     iOff = nPrim*nCntrc
                     Call RecPrt('Coefficients 2','(6G20.13)',
     &                            Shells(iShll)%Cff_c(:,:,2),
     &                            nPrim,nCntrc)
#endif
*
*                    Now remove any primitives with all zero
*                    coefficents!
*
                     Call Fix_Exponents(nPrim,mPrim,nCntrc,
     &                                  Shells(iShll)%Exp,
     &                                  Shells(iShll)%Cff_c,
     &                                  Shells(iShll)%Cff_p)
                     nPrim=mPrim
                     Shells(iShll)%nExp=nPrim
#ifdef _DEBUGPRINT_
                     Call RecPrt('Coefficients 1',' ',
     &                           Shells(iShll)%Cff_c(:,:,1),
     &                           nPrim,nCntrc)
                     iOff = nPrim*nCntrc
                     Call RecPrt('Coefficients 2',' ',
     &                           Shells(iShll)%Cff_c(:,:,2),
     &                           nPrim,nCntrc)
#endif
                  End If
*
*
                  Shells(iShll)%nBasis=Shells(iShll)%nBasis_c
                  If (jAng.eq.0.and.Found) Then
                     Shells(iShll)%Transf=Shells(kShll)%Transf
                     Shells(iShll)%Prjct =Shells(kShll)%Prjct
                  Else
                     Shells(iShll)%Transf=.True.
                     Shells(iShll)%Prjct =.False.
                  End If
                  Shells(iShll)%Aux=.True.
*
                  If (Do_acCD_Basis.and.Found) Then
                     Call mma_deallocate(iList2_p)
                     Call mma_deallocate(TInt_p)
                  End If
                  Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
*
               End Do ! jAng
            End Do ! iAng
*
            dbsc(nCnttp)%nVal = iShll-jShll
            dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal
*                                                                      *
************************************************************************
************************************************************************
************************************************************************
*                                                                      *
            If (Keep_Basis) Then
               If (Show.and.nPrint(2).ge.6) Then
                  Write (6,*)
                  Write (6,*)
                  Write(6,'(1X,A,I5,A,A)')
     &                  'Basis Set ',nCnttp,' Label: ', BSLbl(1:Indx-1)
                  Write(6,'(1X,A)') 'On-the-fly basis set generation'
               End if
*
*
*              Transfer the coordinate information
*
               nCnt = dbsc(iCnttp)%nCntr
               dbsc(nCnttp)%nCntr=nCnt
               dbsc(nCnttp)%mdci =mdc
*              Create a pointer to the actual coordinates
               dbsc(nCnttp)%Coor => dbsc(iCnttp)%Coor(1:3,1:nCnt)
*
*              Compute the number of elements stored in the dynamic
*              memory so far.
               S%Mx_Shll=iShll+1
               Max_Shells=S%Mx_Shll
               S%Mx_mdc=mdc
*
            Else
*
*              If all the shells are empty, skip the whole basis set!
*
               nCnttp=nCnttp-1
            End If
*
         End Do   ! iBS
*
*        Done for this valence basis set.
*
         S%Mx_Shll = iShll + 1
         Max_Shells=S%Mx_Shll
*                                                                      *
************************************************************************
*                                                                      *
*        Deallocate
*
         Call mma_deallocate(iD_c)
         Call mma_deallocate(iList2_c)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*        Let us now Gram-Schmidt orthonormalize the auxiliary basis for
*        better numerics and balance.
*
         Do jCnttp = nCnttp_start + 1, nCnttp
            Call Renorm2(jCnttp)
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*        Optionally add auxiliary basis set to the end of the
*        temporary auxiliary basis set library.
*
      If (W2L) Then
         Lu_lib=17
         Lu_lib=IsFreeUnit(Lu_lib)
         call molcas_open(Lu_lib,'RICDLIB')
         ReWind(Lu_lib)
         Do ! For ever
            Read (Lu_lib,*,END=777)
         End Do
 777     Continue
         BACKSPACE(Lu_lib)
*
         Do jCnttp = nCnttp_start + 1, nCnttp
            If (jCnttp.eq.nCnttp_start+1) Then
               Write (Lu_lib,'(A)') '/'//Label
            Else
               Write (Lu_lib,'(A)') Label
            End If
            If (jCnttp.eq.nCnttp_start+1) Then
               Write (Lu_lib,'(F6.2,2I10)') dbsc(jCnttp)%Charge,
     &               dbsc(jCnttp)%nVal-1,nCnttp-nCnttp_start
            Else
               Write (Lu_lib,'(F6.2, I10)') dbsc(jCnttp)%Charge,
     &               dbsc(jCnttp)%nVal-1
            End If
            Write (Lu_lib,*) ' Dummy reference line.'
            Write (Lu_lib,*) ' Dummy reference line.'
            Do iAng = 0, dbsc(jCnttp)%nVal-1
               iShll_ = dbsc(jCnttp)%iVal + iAng
               nExpi=Shells(iShll_)%nExp
               iSph=0
               If (Shells(iShll_)%Prjct )  iSph=1
               If (Shells(iShll_)%Transf) iSph=iSph+2
               Write (Lu_lib,'(3I10)') nExpi, Shells(iShll_)%nBasis,iSph
*
*              Skip if the shell is empty.
*
               If (nExpi.eq.0) Cycle
*
*              Write out the exponents
*
               Write (Lu_lib,'( 5(1X,D20.13))')
     &               (Shells(iShll_)%Exp(i),i=1,nExpi)
*
*              Write out the contraction coefficients
*
               Do i = 1, nExpi
                  Write (Lu_lib,'( 5(1X,D20.13))')
     &                  (Shells(iShll_)%Cff_c(i,j,1),
     &                        j=1,Shells(iShll_)%nBasis)
               End Do
*
            End Do
         End Do
         Close(Lu_lib)
      End If
*
      Call SOAO_Info_Free()
*                                                                      *
************************************************************************
*                                                                      *
      Return
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ICOPVE2(IIN,IOFF,NDIM,IOUT)
*
* IOUT(I) = IIN(IOFF-1+I),I = 1, NDIM
*
      IMPLICIT REAL*8(A,H,O-Z)
*. Input
      DIMENSION IIN(*)
*. Output
      DIMENSION IOUT(*)
*
      DO I = 1, NDIM
        IOUT(I) = IIN(IOFF-1+I)
      END DO
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Daoling Peng                                     *
************************************************************************
      Subroutine DKRelint_DP
      Use Basis_Info
      use DKH_Info
      use Symmetry_Info, only: nIrrep
*
*     modified by D. Peng, ETH Zurich, October 2011
*
*     Interface/Driver routine for scalar relativistic
*           arbitrary-order DKH method,
*           exact decoupling X2C method &
*           exact decoupling BSS method.
*
      Implicit real*8(a-h,o-z)
#include "Molcas.fh"
#include "warnings.fh"
#include "rinfo.fh"
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "wldata.fh"
#include "oneswi.fh"
#include "RelLight.fh"
#include "relae.fh"
      integer ipaddr(3)
      Character*8 Label, pXpLbl
      Integer nBas_prim(8), nBas_cont(8)
      Logical Debug
      Data Debug/.False./
      character*(3) paramtype
      integer relmethod,dkhorder,xorder,dkhparam
      logical delflag,DoFullLT
      integer stdout
      Dimension idum(1)

      If(IRFLAG1.eq.1)then
        Call DKRelint
        Return
      End IF
*                                                                      *
************************************************************************
*                                                                      *
      iRout=77
      iPrint=nPrint(iRout)
*
      If(Debug)Then
        idbg=6
      Else
        idbg=-1
      Endif
*
      stdout=6
*                                                                      *
************************************************************************
*                                                                      *
*     Save basis set info from contracted run
*
      if(iprint.ge.10) write(stdout,*) ' In DKRelInt', ncnttp
      kCof=0
      kAng=0
      kExp=0
      kC=0
*
*     Normalize coefficients
*
      do iCnttp=1,nCnttp
*
*       The none valence type shells comes at the end. When this block
*       is encountered stop the procedure.
*
        If(dbsc(iCnttp)%Aux .or.
     &     dbsc(iCnttp)%Frag .or.
     &     dbsc(iCnttp)%nFragType.gt.0 ) Go To 999

*
        Do icnt = 1, dbsc(iCnttp)%nCntr
        kC=kC+1
           Do iAngr=0,nAngr(kC)
               rI=DBLE(iAngr)+One+Half
              kAng=kAng+1
              Do iBas=1,nBasisr(kAng)
                 Sum=Zero
                 kExpi=kExp
                 kCofi=kCof
                 Do iExp=1,nPrimr(kAng)
                    kExpi=kExpi+1
                    kCofi=kCofi+1
                    rExpi=rExp(kExpi)
c                   write(stdout,'(a11,f20.8)') ' Exponents',rExpi
                    rCofi=rCof(kCofi)
                    kExpj=kExp
                    kCofj=kCof
                    Do jExp=1,nPrimr(kAng)
                       kExpj=kExpj+1
                       kCofj=kCofj+1
                       rExpj=rExp(kExpj)
                       rCofj=rCof(kCofj)
                       Sum=Sum+rCofi*rCofj*
     &                 (Two*sqrt(rExpi*rExpj)/(rExpi+rExpj))**rI
                    Enddo
                 Enddo
                 rNorm=One/sqrt(Sum)
                 if(iprint.ge.10) write(stdout,*) ' rNorm', kAng,rNorm
                   Do iExp=1,nPrimr(kAng)
                      rCof(kCof+iExp)=rCof(kCof+iExp)*rNorm
                     if(iprint.ge.10) then
                         write(stdout,'(a24,f20.6)')
     &                   ' normalized coefficients',
     &                   rCof(kCof+iExp)
                     endif
                   Enddo
                 kCof=kCof+nPrimr(kAng)
              Enddo
              kExp=kExp+nPrimr(kAng)
           Enddo
        Enddo
      Enddo
 999  Continue
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.10) Then
      i=0
      Do L=1,nrSym
         write(stdout,*) ' Irreducible representation', L
         Do ibas=1,nrBas(L)
            i=i+1
            Write (stdout,'(20i4)') i, icent(i),lnang(i),lmag(i)
         End Do
      End Do
      End If
*
      Call iCopy(8,nBas,1,nBas_Cont,1)
      nSym=nIrrep
*                                                                      *
************************************************************************
*                                                                      *
*     Close ONEINT
*
      iOpt=0
      Call ClsOne(iRC,iOpt)
*                                                                      *
************************************************************************
*                                                                      *
*     Open ONEREL
*
      iOpt = 0
      iRC = -1
      Lu_One=2
      Call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
      If (iRC.ne.0) Go To 9999
*
      Call OneBas('PRIM')
*                                                                      *
************************************************************************
*                                                                      *
      Call Get_iArray('nBas_Prim',nBas,nSym)
      Call iCopy(8,nBas,1,nBas_prim,1)
      If(iPrint.ge.10) then
         write(stdout,'(a,8i5)') ' Symmetries          ', nSym
         write(stdout,'(a,8i5)') ' Primitive basis fcns',
     &                          (nBas(i),i=0,nSym-1)
      Endif
*
*     Allocate memory for relativistic part
*
      VELIT=CLightAU
      iSizep=0
      iSizes=0
      iSizec=0
      iibas =0
      Do L=0,nSym-1
         iSizep=iSizep + nBas(L)*(nBas(L)+1)/2
         iSizes=iSizes + nBas(L)*nBas(L)
         iSizec=iSizec+nrBas(L+1)*(nrBas(L+1)+1)/2
         iibas =iibas + nbas(L)
      End Do
      If(iPrint.ge.10) write(stdout,*) ' iSizep', iSizep
*
      CALL GetMem('Kin     ','ALLO','REAL',iK,iSizep+4)
      CALL GetMem('SS      ','ALLO','REAL',iSS,iSizep+4)
      CALL GetMem('V       ','ALLO','REAL',iV,iSizep+4)
      CALL GetMem('pVp     ','ALLO','REAL',ipVp,iSizep+4)
*
      If (iprint.ge.20) write(stdout,*)
     &   '  indices', iss,ik,iv,ipvp
      Label='Mltpl  0'
      iComp=1
      iOpt=0
      iRC = -1
      Call RdOne(iRC,iOpt,Label,1,Work(iSS),lOper)
      If (iRC.ne.0) then
         Write (stdout,*) 'DKRelInt: Error reading from ONEINT'
         Write (stdout,'(A,A)') 'Label=',Label
         Call Abend
      End If
      nComp=1
      ipaddr(1)=iSS
      If (iPrint.ge.20) Call PrMtrx(Label,[lOper],nComp,ipaddr,Work)
      Label='Attract '
      iRC = -1
      Call RdOne(iRC,iOpt,Label,1,Work(iV),lOper)
      If (iRC.ne.0) then
         Write (stdout,*) 'DKRelInt: Error reading from ONEINT'
         Write (stdout,'(A,A)') 'Label=',Label
         Call Abend
      End If
      ipaddr(1)=iV
      If (iPrint.ge.20) Call PrMtrx(Label,[lOper],nComp,ipaddr,Work)
      Label='Kinetic '
      iRC = -1
      Call RdOne(iRC,iOpt,Label,1,Work(iK),lOper)
      If (iRC.ne.0) then
         Write (stdout,*) 'DKRelInt: Error reading from ONEINT'
         Write (stdout,'(A,A)') 'Label=',Label
         Call Abend
      End If
      ipaddr(1)=iK
      If (iPrint.ge.20)  Call PrMtrx(Label,[lOper],nComp,ipaddr,Work)
      Label='pVp     '
      iRC = -1
      Call RdOne(iRC,iOpt,Label,1,Work(ipVp),lOper)
      If (iRC.ne.0) then
         Write (stdout,*) 'DKRelInt: Error reading from ONEINT'
         Write (stdout,'(A,A)') 'Label=',Label
         Call Abend
      End If
      ipaddr(1)=ipVp
      If (iPrint.ge.20) Call PrMtrx(Label,[lOper],nComp,ipaddr,Work)
*
      iOpt=0
      Call ClsOne(iRC,iOpt)
*                                                                      *
************************************************************************
*                                                                      *
      If (IRELAE.ge.100) Then
         If (IRELAE.ge.1000) Then
*
*        IRELAE codes the method (DKH=1), the order (01 to 99), and the
*        parametrization (1 to 5), i.e. 3rd order DKH with sqrt
*        parametrization: 1-03-3, i.e. IRELAE=1033
*
            relmethod = 1
*
*           relmethod = 1  arbitrary order DKH
*                     = 2  exact decoupling X2C
*                     = 3  exact decoupling BSS
*
            xOrder = iRELAE/10000
            iTemp=iRELAE-1000 - xOrder*10000
            dkhorder = iTemp/10
            iTemp = iTemp - dkhorder*10
            dkhparam = iTemp
            If (xorder.gt.dkhorder) then
              Write(stdout,"(a,i3,a,i3)") " xorder was reduced from ",
     &                                     xorder," to ",dkhorder
              xorder=dkhorder
            End If
            If (iTemp.eq.1) Then
               paramtype='OPT'
            Else If (iTemp.eq.2) Then
               paramtype='EXP'
            Else If (iTemp.eq.3) Then
               paramtype='SQR'
            Else If (iTemp.eq.4) Then
               paramtype='MCW'
            Else If (iTemp.eq.5) Then
               paramtype='CAY'
            Else
               Write(stdout,*) 'dkrelint: Illegal parametrization!'
               Call Abend
            End If
c            write(stdout,"(A,A)") " Computing the",
c     &                             " arbitrary order DKH Hamiltonian"
         Else If (IRELAE.eq.101) Then
            relmethod = 2
            xorder = 1
c            write(stdout,"(A,A)") " Computing the",
c     &                            " exact decoupling X2C Hamiltonian"
         Else If (IRELAE.eq.102) Then
            relmethod = 3
            xorder = 1
c            write(stdout,"(A,A)") " Computing the",
c     &                            " exact decoupling BSS Hamiltonian"
         Else
            Write(stdout,*) 'dkrelint: Unknown method !'
            Call Abend
         End If
*                                                                      *
************************************************************************
*                                                                      *
         Call Allocate_Work(iK_Save,iSizep+4)
         Call Allocate_Work(iK_Done,iSizep+4)
         call dcopy_(iSizep+4,Work(iK),1,Work(iK_Save),1)
*
         Call Allocate_Work(iU_L,iSizes+4)
         Call Allocate_Work(iU_S,iSizes+4)
*
*        Read block information if do local transformation
*
         If (LDKroll) Then
           Call GetMem('Index  ','ALLO','INTE',indx,iibas+4)
           Call xdr_indx(iibas,iWork(indx))
           DoFullLT=.true.
           if(radiLD.eq.0.d0) DoFullLT=.false.
           if(DoFullLT)then
             if (relmethod.eq.1.and.xorder.eq.0) then
               xorder = dkhorder
             end if
             Write(6,"(A)") "   DLU Local Transformation"
           else
             Write(6,"(A)") "   DLH Local Transformation"
           end if
         End If
*
*        Do the Hamiltonian seperately
*
         k=0
         ks=0
         kz=0
*
         Do L = 0, nSym-1
            If (L.eq.nSym-1) delflag=.TRUE.
            n=nBas(L)
            iSize=n*(n+1)/2
            If (iSize.eq.0) Go To 911
*                                                                      *
************************************************************************
*                                                                      *
            If (LDKroll) Then
              Call GetMem('InfoLoc','ALLO','INTE',iLoc,n+4)
              Call GetMem('MapLoc ','ALLO','INTE',iMap,n+4)
              call xdr_info_local(n,iWork(indx+kz),nbl,iWork(iLoc),
     &                            iWork(iMap) )
CDP              write(6,"(a,i1,i5,a,99i4)") '   Sym: ',L+1,n,
CDP     &                    '  = Local ',(iWork(iLoc+i),i=0,nbl-1)
              Call XDR_Local_Ham(n,isize,n*n,relmethod,dkhparam,
     &                     dkhorder,xorder,Work(iSS+k),Work(iK+k),
     &                     Work(iV+k),Work(ipVp+k),Work(iU_L+ks),
     &                     Work(iU_S+ks),iWork(indx+kz),nbl,
     &                     iWork(iLoc),iWork(iMap),DoFullLT,clightau)
              Call GetMem('InfoLoc','FREE','INTE',iLoc,n+4)
              Call GetMem('MapLoc ','FREE','INTE',iMap,n+4)
            Else
              Call XDR_Ham(n,isize,n*n,relmethod,dkhparam,dkhorder,
     &                     xorder,Work(iSS+k),Work(iK+k),Work(iV+k),
     &                     Work(ipVp+k),Work(iU_L+ks),Work(iU_S+ks),
     &                     clightau)
            End If
*                                                                      *
************************************************************************
*                                                                      *
            ks=ks+n*n
            kz=kz+n
 911        k=k+isize
         End Do
*                                                                      *
************************************************************************
*                                                                      *
         call dcopy_(iSizep+4,Work(iK),1,Work(iK_Done),1)
*                                                                      *
************************************************************************
*                                                                      *
         If (xOrder.le.0) Go To 912
*                                                                      *
************************************************************************
*                                                                      *
*        Pick up the number of property integrals to process.
*
#ifdef MOLPRO
#else
         numb_props=nProp_Int(.False.,iWork(ip_iDummy),0)
         Call Allocate_iWork(ipInd,4*numb_props)
         numb_props=nProp_Int(.True.,iWork(ipInd),numb_props)
         Do iProps=1,numb_props
            ipOp   =ipInd + (iProps-1)*4
            ip_MEF =ipInd + (iProps-1)*4 + 1
            ipiComp=ipInd + (iProps-1)*4 + 2
            ipjCent=ipInd + (iProps-1)*4 + 3
*
            call dcopy_(iSizep+4,Work(iK_Save),1,Work(iK),1)
*                                                                      *
************************************************************************
*                                                                      *
*           Read the property integrals
*
*           Open ONEREL
*
            iOpt = 0
            iRC = -1
            Lu_One=2
            Call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
            If (iRC.ne.0) Go To 9999
*
            Call OneBas('PRIM')
*
            iMEF = iWork(ip_MEF)
            If (iWork(ipOp).eq.1) Then
               Write (Label,'(a,i2)') 'MLTPL ',iMEF
            Else If (iWork(ipOp).eq.2) Then
               jCent = iWork(ipjCent)
               Write (Label,'(a,i1,i5)') 'EF',iMEF,jCent
            Else If (iWork(ipOp).eq.3) Then
               jCent = iWork(ipjCent)
               Write (Label,'(a,i5)') 'Cnt',jCent
            Else
               Write (6,*) 'DKRelInt: illegal property!'
               Call Abend
            End If
            iComp = iWork(ipiComp)
C           Write (6,*)
C           Write (6,*) 'Label=',Label
C           Write (6,*) 'iComp=',iComp
C           Write (6,*)
*
            iOpt=1
            iRC = -1
            lOper=-1
            Call iRdOne(iRC,iOpt,Label,iComp,idum,lOper)
            If (iRC.eq.0) nInt=idum(1)
C           Write (6,*) 'lOper=',lOper
            CALL GetMem('X       ','ALLO','REAL',iX,nInt+4)
            iRC = -1
            iOpt=0
            Call RdOne(iRC,iOpt,Label,iComp,Work(iX),lOper)
            If (iRC.ne.0) then
               Write (stdout,*) 'DKRelInt: Error reading from ONEREL'
               Write (stdout,'(A,A)') 'Label=',Label
               Write (stdout,'(A,A)') 'iRC=',iRC
               Call Abend
            End If
            Call CmpInt(Work(iX),nInt,nBas_Prim,nSym,lOper)
            If (nInt.eq.0) Then
               iOpt=0
               Call ClsOne(iRC,iOpt)
               Go To 666
            End If
*
            If (iWork(ipOp).eq.1) Then
               Write (pXpLbl,'(A,I2)') 'pMp   ', iMEF
            Else If (iWork(ipOp).eq.2) Then
               Write (pXpLbl,'(A,I1,I5)') 'PP',iMEF,jCent
            Else If (iWork(ipOp).eq.3) Then
               Write (pXpLbl,'(A,I2)') 'pCp   ',jCent
            End If
            iOpt=1
            iRC = -1
            Call iRdOne(iRC,iOpt,pXpLbl,iComp,idum,lOper)
            If (iRC.eq.0) nInt=idum(1)
            CALL GetMem('pXp     ','ALLO','REAL',ipXp,nInt+4)
            iOpt=0
            iRC = -1
            Call RdOne(iRC,iOpt,pXpLbl,iComp,Work(ipXp),lOper)
            If (iRC.ne.0) then
               Write (stdout,*) 'DKRelInt: Error reading from ONEREL'
               Write (stdout,'(A,A)') 'pXpLbl=',pXpLbl
               Write (stdout,'(A,A)') 'iRC=',iRC
               Call Abend
            End If
            Call CmpInt(Work(ipXp),nInt,nBas_Prim,nSym,lOper)
*
            iOpt=0
            Call ClsOne(iRC,iOpt)
*
            Call GetMem('Core','Max','Real',iDum(1),Mem_Available)
C           Write (6,*) 'Mem_Available=',Mem_Available
            delflag=.FALSE.
            k=0
            ks=0
            kz=0
            Do L = 0, nSym-1
               If (L.eq.nSym-1 .and.
     &             iProps.eq.numb_props) delflag=.TRUE.
               n=nBas(L)
               iSize=n*(n+1)/2
               If (iSize.eq.0) Go To 91
*
*              Skip if the propetry operator does not have a total
*              symmetric component!
*
               If(iAnd(1,lOper).eq.0) Go To 91
*                                                                      *
************************************************************************
*                                                                      *
               Call XDR_Prop(n,isize,n*n,relmethod,dkhparam,dkhorder,
     &                       xorder,Work(iSS+k),Work(iK+k),Work(iV+k),
     &                       Work(ipVp+k),Work(iX+k),Work(ipXp+k),
     &                       Work(iU_L+ks),Work(iU_S+ks),clightau)
               ks=ks+n*n
               kz=kz+n
 91            k=k+isize
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*           Put the picture change corrected integral back to the
*           ONEINT file. Primitives in Work(iX).
*
*           First contract the result, store in Work(ip_Prop)
*
            Call Allocate_Work(ip_Prop,iSizec+4)
            Call repmat(idbg,Work(iX),Work(ip_Prop))
*
*                                                                      *
************************************************************************
*                                                                      *
*           Read the contracted property integrals from OneInt
*
            iOpt = 0
            iRC = -1
            Lu_One=2
            Call OpnOne(iRC,iOpt,'ONEINT',Lu_One)
            If (iRC.ne.0) Go To 9999
*
            iOpt=1
            iRC = -1
            lOper=-1
            Call iRdOne(iRC,iOpt,Label,iComp,idum,lOper)
            If (iRC.eq.0) nInt=idum(1)
            CALL GetMem('Y       ','ALLO','REAL',iY,nInt+4)
            iRC = -1
            iOpt=0
            Call RdOne(iRC,iOpt,Label,iComp,Work(iY),lOper)
C           Write (6,*) 'Y1=',DDot_(nInt,Work(iY),1,
C    &                                  1.0D0,0)
            If (iRC.ne.0) then
               Write (stdout,*) 'DKRelInt: Error reading from ONEINT'
               Write (stdout,'(A,A)') 'Label=',Label
               Call Abend
            End If
*
*           Put the picture change corrected blocks in. Note that this
*           is just the diagonal symmetry blocks.
*
            Call Cp_Prop_Int(Work(iY),nInt,Work(ip_Prop),iSizec,
     &                       nrBas,nIrrep,lOper)
*
*           Now write it back to disc
*
            iOpt=0
            Call WrOne(iRC,iOpt,Label,iComp,Work(iY),lOper)
*
            iOpt=0
            Call ClsOne(iRC,iOpt)
*
            Call Free_Work(iY)
            Call Free_Work(ip_Prop)
*
            Call GetMem('pXp     ','FREE','REAL',ipXp,iSizep+4)
 666        Continue
            Call GetMem('X       ','FREE','REAL',iX,iSizep+4)
*                                                                      *
************************************************************************
*                                                                      *
         End Do ! iProps
*
         Call Free_iWork(ipInd)
#endif
 912     Continue
*                                                                      *
************************************************************************
*                                                                      *
         call dcopy_(iSizep+4,Work(iK_Done),1,Work(iK),1)
         Call Free_Work(iK_Done)
         Call Free_Work(iK_Save)
         Call Free_Work(iU_L)
         Call Free_Work(iU_S)
         If (LDKroll) Then
           Call GetMem('Index  ','FREE','INTE',indx,iibas+4)
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*        The Old code, no option for property integrals.
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*        Loop over the symmetry blocks
*
         epsilon=1.d-10
         delflag=.FALSE.
         k=0
         Do L = 0, nSym-1
            If (L.eq.nSym-1) delflag=.TRUE.
            n=nBas(L)
            iSize=n*(n+1)/2
            If (iSize.eq.0) goto 9
*           Allocate
*
            CALL GetMem('P       ','ALLO','REAL',iP,isize+4)
            CALL GetMem('G       ','ALLO','REAL',iG,isize+4)
            CALL GetMem('Ev2     ','ALLO','REAL',iEv2,n*n+4)
            CALL GetMem('Eig     ','ALLO','REAL',iEig,n*n+4)
            CALL GetMem('Sinv    ','ALLO','REAL',iSinv,n*n+4)
            CALL GetMem('Ew      ','ALLO','REAL',iEw,n+4)
            CALL GetMem('E       ','ALLO','REAL',iE,n+4)
            CALL GetMem('Aa      ','ALLO','REAL',iAa,n+4)
            CALL GetMem('Rr      ','ALLO','REAL',iRr,n+4)
            CALL GetMem('Tt      ','ALLO','REAL',iTt,n+4)
            CALL GetMem('Re1r    ','ALLO','REAL',iRe1r,n*n+4)
            CALL GetMem('Auxi    ','ALLO','REAL',iAuxi,n*n+4)
            CALL GetMem('Twrk4   ','ALLO','REAL',iTwrk4,n*200+4)
            Length    = N*N+4
            Length2   = iSize+4
            iDim      = N
            If (IRELAE .EQ. 0) Then
               Length    = 1
               Length2   = 1
               iDim      = 1
            End If
            CALL GetMem('Even1   ','ALLO','REAL',iEven1,Length)
            CALL GetMem('Pvpt    ','ALLO','REAL',iPvpt,Length2)
            CALL GetMem('Bu      ','ALLO','REAL',iBu,Length2)
*
*           call to package relsew
*
            CALL SCFCLI(idbg,epsilon,Work(iSS+k),Work(iK+k),Work(iV+k),
     &                  Work(ipVp+k),n,iSize,VELIT,Work(iBu),Work(iP),
     &                  Work(iG),Work(iEv2),Work(iEig),Work(iSinv),
     &                  Work(iEw),
     &                  Work(iE),Work(iAa),Work(iRr),Work(iTt),
     &                  Work(iPvpt),Work(iEven1),
     &                  Work(iRe1r),Work(iAuxi),
     &                  Work(iTwrk4),iDim)


            CALL GetMem('Bu      ','FREE','REAL',iBu,Length2)
            CALL GetMem('P       ','FREE','REAL',iP,isize+4)
            CALL GetMem('G       ','FREE','REAL',iG,isize+4)
            CALL GetMem('Ev2     ','FREE','REAL',iEv2,n*n+4)
            CALL GetMem('Eig     ','FREE','REAL',iEig,n*n+4)
            CALL GetMem('Sinv    ','FREE','REAL',iSinv,n*n+4)
            CALL GetMem('Ew      ','FREE','REAL',iEw,n+4)
            CALL GetMem('E       ','FREE','REAL',iE,n+4)
            CALL GetMem('Aa      ','FREE','REAL',iAa,n+4)
            CALL GetMem('Rr      ','FREE','REAL',iRr,n+4)
            CALL GetMem('Tt      ','FREE','REAL',iTt,n+4)
            CALL GetMem('Pvpt    ','FREE','REAL',iPvpt,Length2)
            CALL GetMem('Even1   ','FREE','REAL',iEven1,Length)
            CALL GetMem('Re1r    ','FREE','REAL',iRe1r,n*n+4)
            CALL GetMem('Auxi    ','FREE','REAL',iAuxi,n*n+4)
            CALL GetMem('Twrk4   ','FREE','REAL',iTwrk4,n*200+4)
 9          k=k+isize
         End Do
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate arrays in contracted basis
*
*
      Call GetMem('H       ','ALLO','REAL',iH,iSizec+4)
      Call FZero(Work(iH),iSizec+4)
      Call GetMem('H_o     ','ALLO','REAL',iH_nr,iSizec+4)
      Call FZero(Work(iH_nr),iSizec+4)
      Call GetMem('H_temp  ','ALLO','REAL',iH_temp,iSizec+4)
      Call FZero(Work(iH_temp),iSizec+4)
c
#ifdef MOLPRO
c... store relativistic H
      Call repmat(idbg,Work(ik),Work(iH_temp))
      call fperm(Work(iH_temp),Work(ih))
      Call writem(Work(iH),isizec+2,1,1200,0,'H0')
      Call writem(Work(iH),isizec+2,1,1210,0,'H01')
c... store V=H-T
      Call lesw(Work(iss),iSizec,1,1400,0)
      Call daxpy_(iSizec,-one,Work(iss),1,Work(iH),1)
      Call writem(Work(iH),isizec+2,1,1410,0,'POT')
c... reset contracted basis size
      Call iCopy(8,nBas_Cont,1,nBas,1)
      CALL GetMem('V       ','FREE','REAL',iV,iSizep+4)
      CALL GetMem('SS      ','FREE','REAL',iSS,iSizep+4)
      CALL GetMem('Kin     ','FREE','REAL',iK,iSizep+4)
#else
*
*     Note: in combination with ECPs V is only based on the effective
*           charges of the atoms. In the primitive basis, however, we
*           have temporarily introduced the actual atomic charges. We
*           have to fix this now. Hence the somewhat strange way in
*           which the DKH corrected Hamiltonian is computed.
*
*     Compute stripped non-relativistic H (iH_Temp)
*                                                                      *
************************************************************************
*                                                                      *
*     Open ONEREL
*
      iOpt = 0
      iRC = -1
      Lu_One=2
      Call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
      If (iRC.ne.0) Go To 9999
*
      Call OneBas('PRIM')
*
      Label='Kinetic '
      Call RdOne(iRC,iOpt,Label,1,Work(iSS),lOper)
      If (iRC.ne.0) then
         Write (stdout,*) 'DKRelInt: Error reading from ONEINT'
         Write (stdout,'(A,A)') 'Label=',Label
         Call Abend
      End If
      Label='Attract '
      Call RdOne(iRC,iOpt,Label,1,Work(iV),lOper)
      If (iRC.ne.0) then
         Write (stdout,*) 'DKRelInt: Error reading from ONEINT'
         Write (stdout,'(A,A)') 'Label=',Label
         Call Abend
      End If
*     Add Kinetic and Attraction term
      Call DaXpY_(iSizep+4,One,Work(iSS),1,Work(iV),1)
      If (iPrint.ge.20) Then
         Call iSwap(8,nBas,1,nBas_Prim,1)
         Call PrMtrx('Attract+Kinetic (prim)',[lOper],nComp,[iV],Work)
         Call PrMtrx('Kinetic (prim)',[lOper],nComp,[iSS],Work)
         Call iSwap(8,nBas,1,nBas_Prim,1)
      End If
      call dcopy_(4,[Zero],0,Work(iH_Temp+iSizec),1)
*     Contract and store in iH_temp
      Call repmat(idbg,Work(iV),Work(iH_temp))
*
      CALL GetMem('V       ','FREE','REAL',iV,iSizep+4)
      CALL GetMem('SS      ','FREE','REAL',iSS,iSizep+4)
*
*     Close ONEREL and re-open ONEINT
*
      iOpt = 0
      iRC = -1
      Call ClsOne(iRC,iOpt)
      If (iRC.ne.0) Go To 9999
      iOpt = 0
      iRC = -1
      Lu_One=2
      Call OpnOne(iRC,iOpt,'ONEINT',Lu_One)
      If (iRC.ne.0) Go To 9999
*
      If (iPrint.ge.20) Then
         Call iSwap(8,nBas,1,nBas_Cont,1)
         Call PrMtrx('iH_temp (cont)',[lOper],nComp,[iH_temp],Work)
         Call iSwap(8,nBas,1,nBas_Cont,1)
      End If
*
*     Transform DKH Hamiltonian to contracted basis (iH)
*
      If (iPrint.ge.20) Then
         Call iSwap(8,nBas,1,nBas_Prim,1)
         Call PrMtrx('iK (prim)',[lOper],nComp,[iK],Work)
         Call iSwap(8,nBas,1,nBas_Prim,1)
      End If
      Call repmat(idbg,Work(iK),Work(iH))
      If (iPrint.ge.20) Then
         Call iSwap(8,nBas,1,nBas_Cont,1)
         Call PrMtrx('iH (cont)',[lOper],nComp,[iH],Work)
         Call iSwap(8,nBas,1,nBas_Cont,1)
      End If
*
      CALL GetMem('Kin     ','FREE','REAL',iK,iSizep+4)
*
      iOpt = 0
      iRC = -1
      Label='OneHam 0'
      Call RdOne(iRC,iOpt,Label,1,Work(iH_nr),lOper)
      If (iRC.ne.0) then
         Write (stdout,*) 'DKRelInt: Error reading from ONEINT'
         Write (stdout,'(A,A)') 'Label=',Label
         Call Abend
      End If
      iOpt = 0
      iRC = -1
*
*     final Hamiltonian computed as H(nrel) + ( Hrel(s) - Hnrel(s))
*     where (s) is stripped and with full charge
*
      Call DaXpY_(iSizec+4,-One,Work(iH_temp),1,Work(iH),1)
      Call DaXpY_(iSizec+4,One,Work(iH_nr),1,Work(iH),1)
*
      Call Get_iArray('nBas',nBas,nSym)
      If(iPrint.ge.10) then
         write(stdout,'(a11,10i5)') ' Symmetries', nSym
         write(stdout,'(a11,10i5)') ' Contracted',(nBas(i),i=0,nSym-1)
      Endif
      Label='OneHam 0'
      lOper=1
      nComp=1
      ipaddr(1)=iH
      If (iPrint.ge.20) Call PrMtrx(Label,[lOper],nComp,ipaddr,Work)
*
*     Replace 1-el Hamiltonian on ONEINT
*
      iRC = -1
      Call WrOne(iRC,iOpt,Label,1,Work(iH),lOper)
      Label='OneHam  '
      Call WrOne(iRC,iOpt,Label,1,Work(iH),lOper)
      If (iRC.ne.0) then
         Write (stdout,*) 'DKRelInt: Error reading from ONEINT'
         Write (stdout,'(A,A)') 'Label=',Label
         Call Abend
      End If
*
      If (IRELAE .eq. 23) Then   ! IORA
*
*     Replace overlap on ONEINT
*
         Call repmat(idbg,Work(ipVp),Work(iH))
         iRC = -1
         Label='Mltpl  0'
         Call WrOne(iRC,iOpt,Label,1,Work(iH),lOper)
         If (iRC.ne.0) then
            Write (stdout,*) 'DKInt: Error reading from ONEINT'
            Write (stdout,'(A,A)') 'Label=',Label
            Call Abend
         End If
      End If
#endif
*
      CALL GetMem('OneHam  ','FREE','REAL',iH,iSizec+4)
      CALL GetMem('H_o     ','FREE','REAL',iH_nr,iSizec+4)
      CALL GetMem('H_temp  ','FREE','REAL',iH_temp,iSizec+4)
      CALL GetMem('pVp     ','FREE','REAL',ipVp,iSizep+4)
*
      Return
*
 9999 Continue
      Write (stdout,*) ' *** Error in subroutine DKRelInt ***'
      Write (stdout,*) '     Abend in subroutine OpnOne'
      Call Abend
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine MemRg2(iAnga,nRys,MemPrm,ider)
!***********************************************************************
! This routine will compute the memory requirement of Rysg2            *
! Memory requirement is per primitive!                                 *
!                                                                      *
! Modified to gradients 1991 R. Lindh, Dept. of Theoretical Chemistry, *
! University of Lund.                                                  *
! Modified to hessians 1995 Anders Bernhardsson Dept. of Theoretical   *
! Chemistry, University of Lund.                                       *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iAnga(4), ider
integer(kind=iwp), intent(out) :: nRys, MemPrm
integer(kind=iwp) :: la, lb, lB00, lB01, lB10, lc, ld, MemPrm2, MemPrm3, n2D0, n2D1, n2D2, nabcd, nabMax, ncdMax, nPAO

!iRout = 13
!iPrint = nPrint(iRout)
la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)
nRys = (la+lb+lc+ld+2+ider)/2

MemPrm = 0
nPAO = nTri_Elem1(la)*nTri_Elem1(lb)*nTri_Elem1(lc)*nTri_Elem1(ld)
! 1st order gradient of [ab|cd]
MemPrm = MemPrm+nPAO*9

nabMax = la+lb+2
ncdMax = lc+ld+2
nabcd = (nabMax+1)*(ncdMax+1)
!lB10 = max(min(nabMax-1,1),0)
!lB01 = max(min(ncdMax-1,1),0)
!lB00 = max(min(Min(nabMax,ncdMax),1),0)
lB10 = 1
lB01 = 1
lB00 = 1

! 2D-Integrals

n2D0 = max(nabcd,(la+3)*(lb+3)*(ncdMax+1),(la+3)*(lb+3)*(lc+3)*(ld+3))
MemPrm = MemPrm+3*nRys*n2D0

! 1st order gradient of the 2D-integrals

n2D1 = max(nabcd,(la+3)*(lb+3)*(ncdMax+1),(la+1)*(lb+1)*(lc+1)*(ld+1)*3)
n2D2 = (la+1)*(lb+1)*(lc+1)*(ld+1)*6
MemPrm = MemPrm+3*nRys*n2D1
MemPrm3 = 3*nRys*n2D2+3*nRys

! Coefficients for recurrence relations

MemPrm2 = 3*nRys+3*nRys+3*nRys*(lB10+lB01+lB00)
! Roots
MemPrm2 = MemPrm2+nRys
! The inverse of the arguments
MemPrm2 = MemPrm2+1
! Arguments
MemPrm2 = MemPrm2+1
! Expanded versions of Zeta, ZetInv, Eta, EtaInv, P and Q
MemPrm = MemPrm+10
!if (iPrint >=99) then
!  write(u6,*) ' [ab|cd] 1st grad.   :',nPAO*9
!  write(u6,*) ' 2D-integrals        :',n2D0*3*nRys
!  write(u6,*) ' 2D-integrals (1st)  :',n2D1*3*nRys
!  write(u6,*) ' 2D-integrals (2nd)  :',n2D2*3*nRys
!  write(u6,*) ' PAQP vector         :',3*nRys
!  write(u6,*) ' QCPQ vector         :',3*nRys
!  write(u6,*) ' B10 coefficients    :',nRys*3*lB10
!  write(u6,*) ' B00 coefficients    :',nRys*3*lB00
!  write(u6,*) ' B01 coefficients    :',nRys*3*lB01
!  write(u6,*) ' Roots               :',nRys
!  write(u6,*) ' Inverse arguments   :',1
!  write(u6,*) ' Arguments           :',1
!end if
MemPrm = MemPrm+max(MemPrm2,MemPrm3)

return

end subroutine MemRg2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_RSCopy
*
*> @brief
*>   Copy reduced set index arrays
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Copy index arrays from location \p iRS (``1``,``2``,``3``) to location
*> \p jRS (``1``,``2``,``3``). Special handling of the case \p iRS = ``1``:
*> ``IndRed(i,jRS) = i`` rather than ``IndRed(i,jRS)=IndRed(i,iRS)``.
*> If \p iRS and/or \p jRS are out of bounds, \p irc = ``1`` on exit and nothing
*> has been done!
*>
*> @note
*> cholesky.fh must have been initialized.
*>
*> @param[out] irc return code
*> @param[in]  iRS location of reference reduced set
*> @param[in]  jRS location of target reduced set
************************************************************************
      Subroutine Cho_X_RSCopy(irc,iRS,jRS)
      Implicit None
      Integer irc,iRS,jRS

      If (iRS.lt.1 .or. iRS.gt.3 .or. jRS.lt.1 .or. jRS.gt.3) Then
         irc = 1
      Else
         Call Cho_RSCopy(iRS,jRS)
         irc = 0
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2_Energy_GetPQInd(LnPQRSprod,LiPQRSprod,iBatch,jBatch)
!
! Jonas Bostrom, june 2008
!
! Purpose: setup (pq|rs) index arrays for calculating mp2_densities.

use Index_Functions, only: nTri_Elem
use Cholesky, only: nSym
use ChoMP2, only: ChoAlg, LnPQprod
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: LnPQRSprod, LiPQRSprod(8)
integer(kind=iwp), intent(in) :: iBatch, jBatch
integer(kind=iwp) :: iSym
character(len=14) :: String
character(len=*), parameter :: SecNam = 'ChoMP2_Energy_GetPQInd'

if (iBatch == jBatch) then
  LnPQRSprod = 0
  if (ChoAlg == 1) then
    do iSym=1,nSym
      LiPQRSprod(iSym) = LnPQRSprod
      LnPQRSprod = LnPQRSprod+nTri_Elem(LnPQprod(iSym,iBatch))
    end do
  else
    write(String,'(A8,I6)') 'ChoAlg =',ChoAlg
    call SysAbendMsg(SecNam,'ChoAlg out-of-bounds error!',String)
  end if
else
  LnPQRSprod = 0
  do iSym=1,nSym
    LiPQRSprod(iSym) = LnPQRSprod
    LnPQRSprod = LnPQRSprod+LnPQprod(iSym,iBatch)*LnPQprod(iSym,jBatch)
  end do
end if

end subroutine ChoMP2_Energy_GetPQInd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PKWLK(N,IPWLK,NWALK,IWALK,ICASE)
! PURPOSE: PACK THE GUGA STEP NUMBERS INTO THE ARRAY IWALK.
! EACH OF THE NWALK WALKS HAS N STEP NUMBERS, 2 BITS EACH,
! AT MOST 15 TO AN INTEGER ELEMENT OF IWALK, EACH NEW WALK
! IS ALIGNED ON INTEGERS.
! NOTE: Can be used for upper, lower, or total walks, so the
! number of integers used for each walk (IPWLK) is given as
! call parameter.

use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: N, IPWLK, NWALK, ICASE(N,NWALK)
integer(kind=iwp), intent(_OUT_) :: IWALK(*)
integer(kind=iwp) :: I, IPOS, IWORD, J, L, LEND, LSTA

IPOS = 0
do I=1,NWALK
  LEND = 0
  do J=1,IPWLK
    LSTA = LEND+1
    LEND = min(LSTA+14,N)
    IPOS = IPOS+1
    IWORD = 0
    do L=LEND,LSTA,-1
      IWORD = 4*IWORD+ICASE(L,I)
    end do
    IWALK(IPOS) = IWORD
  end do
end do

end subroutine PKWLK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MoReduce(nBas,MOsToKeep)

use qmstat_global, only: AvRed, BigT, iPrint, MxSymQ, nState, ThrsRedOcc
use Index_Functions, only: iTri, nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nBas(MxSymQ)
integer(kind=iwp), intent(out) :: MOsToKeep
#include "Molcas.fh"
integer(kind=iwp) :: i, iB, iB1, iB2, icomp, iDiskUt, iM1, iM2, ind, ind1, ind2, indx, iopt, irc, iS1, iS2, Ising, iSmLbl, kaunt, &
                     Lu_One, Lu_Scratch, nMtK, nSize
real(kind=wp) :: ChargeNonReduced, ChargeReduced, Det, DiffMax, DiffMegaMax, Dum, Dummy(1), Sqroot, ThrOcc, TraceFull, TraceRed, &
                 weight
logical(kind=iwp) :: First = .true.
character(len=50) :: Header
integer(kind=iwp), allocatable :: iTocBig(:)
real(kind=wp), allocatable :: AUX(:,:), Dav(:), DavS(:,:), Din(:), DsqM(:,:), Inv(:,:), NewOcc(:), Occ(:), OtD(:,:), OtDt(:), &
                              S(:), Ss(:,:), Ssq(:), Sst(:,:), St(:), Strans(:,:), Stri(:), Sx(:), TEMP(:,:), TmoD(:,:), &
                              Trans(:,:), TransB(:,:), TreD(:,:), TreT(:), Vecs(:,:)
logical(kind=iwp), allocatable :: LindMOs(:)
character(len=LenIn8), allocatable :: BsLbl(:)
real(kind=wp), parameter :: ReduceWarning = Half
integer(kind=iwp), external :: IsFreeUnit
real(kind=r8), external :: Ddot_

! A word of welcome.

write(u6,*) '     ----- Transform to average natural MO-reduced basis.'

! First we accumulate the different density matrices.

nSize = nTri_Elem(nBas(1))
weight = One/real(nState,kind=wp)
call mma_allocate(Din,nSize,label='DenM')
call mma_allocate(Dav,nSize,label='DenA')
Dav(:) = Zero
do iS1=1,nState
  do iS2=1,iS1
    indx = iTri(iS1,iS2)
    Din(:) = BigT(:,indx)
    if (iS1 /= iS2) cycle
    kaunt = 0
    do iB1=1,nBas(1)
      do iB2=1,iB1-1
        kaunt = kaunt+1
        Dav(kaunt) = Dav(kaunt)+Din(kaunt)*Half*weight
      end do
      kaunt = kaunt+1
      Dav(kaunt) = Dav(kaunt)+Din(kaunt)*weight
    end do
  end do
end do

! Then since we are working in the non-orthogonal AO-basis,
! it is necessary to orthogonalize before we diagonalize
! accumulated density.

call mma_allocate(LindMOs,nBas(1),label='LindMOs')
call mma_allocate(Vecs,nBas(1),nBas(1),label='Vecs')
call mma_allocate(AUX,nBas(1),nBas(1),label='AuxS')
call mma_allocate(Ss,nBas(1),nBas(1),label='OvlSs')
call mma_allocate(Sx,nSize,label='OvlSs')
call mma_allocate(Sst,nBas(1),nBas(1),label='OvlSi')
call mma_allocate(St,nSize,label='OvlSi')
call mma_allocate(DavS,nBas(1),nBas(1),label='DavSq')
call mma_allocate(Trans,nBas(1),nBas(1),label='Trans')
call mma_allocate(TransB,nBas(1),nBas(1),label='Trans')
call mma_allocate(OtD,nBas(1),nBas(1),label='OrtoAvDen')
call mma_allocate(OtDt,nSize,label='OrtoAcDeT')
call mma_allocate(S,nSize,label='OvlS')
call mma_allocate(Occ,nBas(1),label='Occs')
Vecs(:,:) = Zero
call dCopy_(nBas(1),[One],0,Vecs,nBas(1)+1)
! Symmetric orthogonalization, hence get overlap matrix, S.
Lu_One = 92
call OpnOne(irc,0,'ONEINT',Lu_One)
irc = -1
iopt = 6
iSmLbl = 0
icomp = 1
call RdOne(irc,iopt,'Mltpl  0',icomp,S,iSmLbl)
call Jacob(S,Vecs,nBas(1),nBas(1))
Sx(:) = Zero
St(:) = Zero
do i=1,nBas(1)
  Sqroot = sqrt(S(nTri_Elem(i)))
  Sx(nTri_Elem(i)) = One/Sqroot
  St(nTri_Elem(i)) = Sqroot
end do
call Square(Sx,Ss,1,nBas(1),nBas(1))
call Square(St,Sst,1,nBas(1),nBas(1))
! S^(-1/2)
call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),One,Vecs,nBas(1),Ss,nBas(1),Zero,AUX,nBas(1))
call Dgemm_('N','T',nBas(1),nBas(1),nBas(1),One,AUX,nBas(1),Vecs,nBas(1),Zero,Trans,nBas(1))
! S^(1/2)
call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),One,Vecs,nBas(1),Sst,nBas(1),Zero,AUX,nBas(1))
call Dgemm_('N','T',nBas(1),nBas(1),nBas(1),One,AUX,nBas(1),Vecs,nBas(1),Zero,TransB,nBas(1))
! The density matrix transforms 'inversely' from the matrix-elements,
! thus let S^(1/2) transform it, not S^(-1/2) which applies to the
! matrix elements.
call Square(Dav,DavS,1,nBas(1),nBas(1))
call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),One,TransB,nBas(1),DavS,nBas(1),Zero,AUX,nBas(1))
call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),One,AUX,nBas(1),TransB,nBas(1),Zero,OtD,nBas(1))
Vecs(:,:) = Zero
call dCopy_(nBas(1),[One],0,Vecs,nBas(1)+1)
call SqToTri_Q(OtD,OtDt,nBas(1))
call Jacob(OtDt,Vecs,nBas(1),nBas(1))
! With diagonalized density matrix, collect occupation numbers and
! natural orbital coefficients.
call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),One,Trans,nBas(1),Vecs,nBas(1),Zero,AUX,nBas(1))
do i=1,nBas(1)
  Occ(i) = OtDt(nTri_Elem(i))
end do
TraceFull = Zero
do i=1,nBas(1)
  TraceFull = TraceFull+Occ(i)
end do
if (iPrint >= 5) then
  call mma_allocate(BsLbl,nBas(1),label='BsLbl')
  call Get_cArray('Unique Basis Names',BsLbl,LenIn8*nBas(1))
end if
if (iPrint >= 10) then
  write(Header,'(A)') 'All average transition density orbitals'
  ThrOcc = -One
  call Primo(Header,.true.,.false.,ThrOcc,Dum,1,nBas(1),nBas(1),BsLbl,Dummy,Occ,AUX,-1)
  write(u6,*)
  write(u6,*) '  Trace = ',TraceFull
end if
! Deallocations.
call mma_deallocate(Din)
call mma_deallocate(Dav)
call mma_deallocate(Vecs)
call mma_deallocate(Ss)
call mma_deallocate(Sx)
call mma_deallocate(Sst)
call mma_deallocate(St)
call mma_deallocate(DavS)
call mma_deallocate(Trans)
call mma_deallocate(TransB)
call mma_deallocate(OtD)
call mma_deallocate(OtDt)
call mma_deallocate(S)

! Jetzt far wir mal wieder. Reduce MO-basis according to input criterion.

MOsToKeep = 0
do iB=1,nBas(1)
  if (Occ(iB) >= ThrsRedOcc) then
    LindMOs(iB) = .true.
    MOsToKeep = MOsToKeep+1
  else
    LindMOs(iB) = .false.
  end if
end do
call mma_allocate(AvRed,nBas(1),MOsToKeep,label='UncleMoe')
call mma_allocate(NewOcc,MOsToKeep,label='NewOccs')
ind1 = 0
! Loop to suck-out the nice MOs.
do iB=1,nBas(1)
  if (LindMOs(iB)) then
    ind1 = ind1+1
    AvRed(:,ind1) = AUX(:,iB)
    NewOcc(ind1) = Occ(iB)
  end if
end do
TraceRed = Zero
do i=1,MOsToKeep
  TraceRed = TraceRed+NewOcc(i)
end do
! Make a trace check.
if ((TraceFull-TraceRed) >= ReduceWarning) then
  write(u6,*)
  write(u6,*) 'WARNING!  With your occupation threshold, the density matrix trace'
  write(u6,*) 'differs by ',TraceFull-TraceRed,'.'
  write(u6,*) 'You should consider lowering the threshold!'
end if
if (iPrint >= 5) then
  write(Header,'(A)') 'Reduced average orbitals'
  ThrOcc = -One
  call Primo(Header,.true.,.false.,ThrOcc,Dum,1,nBas(1),[MOsToKeep],BsLbl,Dummy,NewOcc,AvRed,-1)
  write(u6,*)
  write(u6,*) '  Trace = ',TraceRed,MOsToKeep
  call mma_deallocate(BsLbl)
end if

! Time to reduce all individual density matrices in the big TDM to
! the reduced MO-basis. Once more, observe that the density
! transforms contravariantly. But sadly, we need to invert the
! full square MO-matrix before we make reductions.

call mma_allocate(Inv,nBas(1),nBas(1),label='InverseC')
call MInv(AUX,Inv,Ising,Det,nBas(1))

! Now all those transformations and density reductions. To check for
! density losses, the overlaps are read. These partially transformed
! transition density matrix is stored in a scratch file.

DiffMegaMax = Zero
nSize = nTri_Elem(nBas(1))
nMtK = nTri_Elem(MOsToKeep)
call mma_allocate(TEMP,nBas(1),nBas(1),label='Temporary')
call mma_allocate(TmoD,nBas(1),nBas(1),label='MOtrDen')
call mma_allocate(TreD,MOsToKeep,MOsToKeep,label='MOreDen')
call mma_allocate(TreT,nMtK,label='MOreDen')
call mma_allocate(Din,nSize,label='DenM')
call mma_allocate(DsqM,nBas(1),nBas(1),label='DenMsq')
call mma_allocate(S,nSize,label='OvlS')
call mma_allocate(Ssq,nBas(1)**2,label='Ssquare')
call mma_allocate(Strans,nBas(1),nBas(1),label='Strans')
call mma_allocate(Stri,nMtK,label='Stri')
Lu_Scratch = IsFreeUnit(57)
call DaName(Lu_Scratch,'TDMSCR')
irc = -1
iopt = 6
iSmLbl = 0
icomp = 1
call RdOne(irc,iopt,'Mltpl  0',icomp,S,iSmLbl)
call ClsOne(irc,iopt)
iDiskUt = 0
call mma_allocate(iTocBig,nTri_Elem(nState),label='iTocBig')
call iDaFile(Lu_Scratch,1,iTocBig,nTri_Elem(nState),iDiskUt)
do iS1=1,nState
  do iS2=1,iS1
    ! Collect this particular density matrix.
    indx = iTri(iS1,iS2)
    Din(:) = BigT(:,indx)
    ! Square it and correct the non-diagonal (recall convention)
    call Dsq(Din,DsqM,1,nBas(1),nBas(1))
    ! Contravariant transformation of density matrix.
    call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),One,Inv,nBas(1),DsqM,nBas(1),Zero,TEMP,nBas(1))
    call Dgemm_('N','T',nBas(1),nBas(1),nBas(1),One,TEMP,nBas(1),Inv,nBas(1),Zero,TmoD,nBas(1))
    ! Covariant transformation of overlap matrix.
    call Square(S,Ssq,1,nBas(1),nBas(1))
    call Dgemm_('T','N',nBas(1),nBas(1),nBas(1),One,AUX,nBas(1),Ssq,nBas(1),Zero,TEMP,nBas(1))
    call Dgemm_('N','N',nBas(1),nBas(1),nBas(1),One,TEMP,nBas(1),AUX,nBas(1),Zero,Strans,nBas(1))
    ! How much charge ('overlap') is there in this density element?
    ChargeNonReduced = Ddot_(nBas(1)**2,TmoD,1,Strans,1)
    ! Reduction of density matrix and overlap matrix.
    ind1 = 0
    do iM1=1,nBas(1)
      if (.not. LindMOs(iM1)) cycle
      ind1 = ind1+1
      ind2 = 0
      do iM2=1,nBas(1)
        if (.not. LindMOs(iM2)) cycle
        ind2 = ind2+1
        TreD(ind2,ind1) = TmoD(iM2,iM1)
        Ssq(ind2+(ind1-1)*MOsToKeep) = Strans(iM2,iM1)
      end do
    end do
    ! Triangularize, jetzt!
    do iM1=1,MOsToKeep
      do iM2=1,MOsToKeep
        if (iM1 /= iM2) TreD(iM2,iM1) = Two*TreD(iM2,iM1)
      end do
    end do
    call SqToTri_Q(TreD,TreT,MOsToKeep)
    call SqToTri_Q(Ssq,Stri,MOsToKeep)
    ! Compute total electronic charge of this reduced density.
    ChargeReduced = Ddot_(nMtK,TreT,1,Stri,1)
    ! Renormalize to get right charge ('overlap'); to safeguard
    ! against zero overlaps, make check.
    if ((abs(ChargeNonReduced) > 1.0e-7_wp) .and. (abs(ChargeReduced) > 1.0e-7_wp)) then
      TreT(:) = TreT*ChargeNonReduced/ChargeReduced
    end if
    ! If sufficient printlevel, show moment modifications.
    if (iPrint >= 10) then
      call MomentMod(TreT,TmoD,AUX,MOsToKeep,nBas(1),LindMOs,iS1,iS2,First,DiffMax)
      if (DiffMax > DiffMegaMax) DiffMegaMax = DiffMax
    end if
    ! Add previous disk address to T-o-C.
    ind = iTri(iS1,iS2)
    iTocBig(ind) = iDiskUt
    ! 'Because I will take a giant dump on you!'
    call dDaFile(Lu_Scratch,1,TreT,nMtk,iDiskUt)
  end do
end do
! The real table-of-content
iDiskUt = 0
call iDaFile(Lu_Scratch,1,iTocBig,nTri_Elem(nState),iDiskUt)
! Deallocations and closing.
call mma_deallocate(iTocBig)
call mma_deallocate(LindMOs)
call mma_deallocate(AUX)
call mma_deallocate(NewOcc)
call mma_deallocate(Inv)
call mma_deallocate(TEMP)
call mma_deallocate(TmoD)
call mma_deallocate(TreD)
call mma_deallocate(TreT)
call mma_deallocate(Din)
call mma_deallocate(DsqM)
call mma_deallocate(S)
call mma_deallocate(Ssq)
call mma_deallocate(Strans)
call mma_deallocate(Stri)
call mma_deallocate(Occ)
call DaClos(Lu_Scratch)

! Report on the reduction.

write(u6,*)
write(u6,90) 'AO-basis ---> MO-basis reduction complete.'
write(u6,91) 'From ',nBas(1),' functions to ',MosToKeep,'.'
write(u6,90) 'Reduced basis renormalized to have same overlap as non-reduced.'
if (iPrint >= 10) write(u6,92) 'Largest dipole difference is ',DiffMegaMax

return

90 format('        ',A)
91 format('        ',A,I3,A,I3,A)
92 format('        ',A,F10.7)

end subroutine MoReduce

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ReadAtomPairInfo(irc)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Read atom pair info from disk.
C
      Implicit None
      Integer irc
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Character*8 Label

      Integer Lu
      Integer iAddr
      Integer iBuf(1)
      Integer ip, l
      Integer iAtomPair

      Integer i, j
      Integer AP_1CLinDep, AP_2CFunctions
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Init return code
      irc=0

      ! Open file
      Lu=7
      Call DAName_MF(Lu,'LDFAP')

      ! Init disk address
      iAddr=0

      ! Read info
      l=1
      Call iDAFile(Lu,2,iBuf,l,iAddr)
      NumberOfAtomPairs=iBuf(1)
      l_AP_Atoms=2*NumberOfAtomPairs
      Call GetMem('LDFAPA','Allo','Inte',ip_AP_Atoms,l_AP_Atoms)
      Call iDAFile(Lu,2,iWork(ip_AP_Atoms),l_AP_Atoms,iAddr)
      l_AP_Unique=NumberOfAtomPairs
      Call GetMem('AP_Unique','Allo','Inte',ip_AP_Unique,l_AP_Unique)
      Call iDAFile(Lu,2,iWork(ip_AP_Unique),l_AP_Unique,iAddr)
      l_AP_DiskC=NumberOfAtomPairs
      Call GetMem('AP_DiskC','Allo','Inte',ip_AP_DiskC,l_AP_DiskC)
      Call iDAFile(Lu,2,iWork(ip_AP_DiskC),l_AP_DiskC,iAddr)
      l_AP_1CLinDep=2*NumberOfAtomPairs
      Call GetMem('AP1CLD','Allo','Inte',ip_AP_1CLinDep,l_AP_1CLinDep)
      Do iAtomPair=1,NumberOfAtomPairs
         l=1
         Call iDAFile(Lu,2,iBuf,l,iAddr)
         iWork(ip_AP_1CLinDep+2*(iAtomPair-1))=iBuf(1)
         l=3*AP_1CLinDep(1,iAtomPair)
         If (l.lt.1) Then
            iWork(ip_AP_1CLinDep+2*(iAtomPair-1)+1)=0
         Else
            Write(Label,'(A,I5.5)') '1CL',iAtomPair-1
            Call GetMem(Label,'Allo','Inte',ip,l)
            iWork(ip_AP_1CLinDep+2*(iAtomPair-1)+1)=ip
            Call iDAFile(Lu,2,iWork(ip),l,iAddr)
         End If
      End Do
      l_AP_2CFunctions=2*NumberOfAtomPairs
      Call GetMem('AP2CFN','Allo','Inte',ip_AP_2CFunctions,
     &                                    l_AP_2CFunctions)
      Do iAtomPair=1,NumberOfAtomPairs
         l=1
         Call iDAFile(Lu,2,iBuf,l,iAddr)
         iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=iBuf(1)
         l=4*AP_2CFunctions(1,iAtomPair)
         If (l.lt.1) Then
            iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=0
         Else
            Write(Label,'(A,I5.5)') '2CF',iAtomPair-1
            Call GetMem(Label,'Allo','Inte',ip,l)
            iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=ip
            Call iDAFile(Lu,2,iWork(ip),l,iAddr)
         End If
      End Do
      Call LDF_AllocateBlockMatrix('APD',ip_AP_Diag)
      l_AP_Diag=NumberOfAtomPairs
      Call LDF_AllocateBlockMatrix('APB',ip_AP_DiagBak)
      l_AP_DiagBak=NumberOfAtomPairs
      Do iAtomPair=1,NumberOfAtomPairs
         l=1
         Call iDAFile(Lu,2,iBuf,l,iAddr)
         l=iBuf(1)
         If (l.lt.1) Then
            Call WarningMessage(1,
     &                 'LDF_ReadAtomPairInfo: zero diagonal dimension?')
            Write(6,'(A,I10)') 'Atom pair:',iAtomPair
            Call xFlush(6)
         Else
            ip=iWork(ip_AP_Diag-1+iAtomPair)
            Call dDAFile(Lu,2,Work(ip),l,iAddr)
            ip=iWork(ip_AP_DiagBak-1+iAtomPair)
            Call dDAFile(Lu,2,Work(ip),l,iAddr)
         End If
      End Do

      ! Close file
      Call DAClos(Lu)

      ! Mark atom pair info set
      LDF_AtomPairInfo_Status=LDF_AtomPairInfo_Set

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ORTHO_MOTRA(nSym,nBas,nDel,Ovlp,CMO)
*
*     Objective: Orthonormalize input vectors
*               (Gram-Schmidt orthogonaliztion)
*
      IMPLICIT REAL*8 (A-H,O-Z)
#include "trafo_motra.fh"
#include "WrkSpc.fh"
*
      Real*8 Ovlp(*), CMO(*)
      Integer nBas(nSym), nDel(nSym)
*
*
*     Allocate work space
*
      CALL GETMEM('SCR1','ALLO','REAL',LW1,N2MAX)
      CALL GETMEM('SCR2','ALLO','REAL',LW2,N2MAX)
      CALL GETMEM('SCR3','ALLO','REAL',LW3,N2MAX)
*
*     Loop over symmetries and orthogonalize
*
      IJ=1
      IM=1
      DO ISYM=1,NSYM
         NORBI=NBAS(ISYM)-NDEL(ISYM)
         IF(NORBI.GT.0) THEN
           CALL SQUARE(OVLP(IJ),WORK(LW3),1,NBAS(ISYM),NBAS(ISYM))
C           CALL MXMA(WORK(LW3),1,NBAS(ISYM),
C     *               CMO(IM),1,NBAS(ISYM),
C     *               WORK(LW2),1,NBAS(ISYM),
C     *               NBAS(ISYM),NBAS(ISYM),NORBI)
           CALL DGEMM_('N','N',NBAS(ISYM),NORBI,NBAS(ISYM),
     *                  1.0d0,WORK(LW3),NBAS(ISYM),CMO(IM),
     *                  NBAS(ISYM),0.0d0,WORK(LW2),NBAS(ISYM))
C           CALL MXMA(CMO(IM),NBAS(ISYM),1,
C     *               WORK(LW2),1,NBAS(ISYM),
C     *               WORK(LW1),1,NORBI,
C     *               NORBI,NBAS(ISYM),NORBI)
           CALL DGEMM_('T','N',NORBI,NORBI,NBAS(ISYM),
     *                  1.0d0,CMO(IM),NBAS(ISYM),WORK(LW2),
     *                  NBAS(ISYM),0.0d0,WORK(LW1),NORBI)
           CALL ORTHOX_MOTRA(WORK(LW1),CMO(IM),NORBI,NBAS(ISYM))
        END IF
           IJ=IJ+NBAS(ISYM)*(NBAS(ISYM)+1)/2
           IM=IM+NBAS(ISYM)*NBAS(ISYM)
      END DO
*
*     Deallocate work space and exit
*
      CALL GETMEM('SCR3','FREE','REAL',LW3,N2MAX)
      CALL GETMEM('SCR2','FREE','REAL',LW2,N2MAX)
      CALL GETMEM('SCR1','FREE','REAL',LW1,N2MAX)
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Dynamix(iReturn)

#ifdef _HDF5_
use mh5, only: mh5_put_dset, mh5_close_file
use Dynamix_Globals, only: dyn_etot, dyn_etot0, dyn_fileid, dyn_nh, dyn_vel, File_H5Res, lH5Restart
#endif
use Dynamix_Globals, only: DT, PIN, POUT, THERMO, TEMP, RESTART, VELO, nh, iQ1, iQ2, iX1, iX2, iVx1, iVx2, VelVer, VV_First, &
                           VV_Second, Gromacs
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: auTokJ, auTofs, kBoltzmann, Zero, One, Three, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: iReturn
integer(kind=iwp), parameter :: nTasks = 3
integer(kind=iwp) :: i, irc, iRlxRoot, iseed, iTask, Itr, j, LuInput, mTasks, MxItr, natom, nFlag, nRoots, Task(nTasks)
real(kind=wp) :: arg, buffer, Ekin, Epot, Etot0, Freq, mean, NHC(nh), Q1, Q2, Sigma, time, val
logical(kind=iwp) :: Found, lHop
character(len=16) :: StdIn
character(len=15) :: caption
character(len=8) :: ENV
real(kind=wp), parameter :: kb = kBoltzmann/(auTokJ*1.0e3_wp)
character(len=2), allocatable :: atom(:)
real(kind=wp), allocatable :: Mass(:), vel(:), pcoo(:,:)
integer(kind=iwp), external :: AixRm, IsFreeUnit, IsStructure
#include "warnings.h"

iReturn = 99

! Initialize Dynamix and set default values

#ifdef _DEBUGPRINT_
write(u6,*) ' Dynamix calls Init_Dynamix.'
#endif
call Init_Dynamix()
#ifdef _DEBUGPRINT_
write(u6,*) ' Dynamix back from Init_Dynamix.'
#endif

! Read the input

#ifdef _HDF5_
call cre_dyn()
#endif
#ifdef _DEBUGPRINT_
write(u6,*) ' Dynamix calls Readin_Dynamix.'
#endif
call Readin_Dynamix(Task,nTasks,mTasks)
#ifdef _DEBUGPRINT_
write(u6,*) ' Dynamix back from Readin_Dynamix.'
#endif

! Check if this is an initial run of Dynamix

call Qpg_dScalar('MD_Time',Found)

#ifdef _HDF5_
if (.not. found .and. lH5Restart) then
  call restart_dynamix(file_h5res)
  found = .true.
end if
#endif

! Generate or read velocities if this is an initial run

if (.not. Found) then
  ! Check if the RESTART keyword was used.
  if (RESTART == Zero) then
    time = Zero
  else
    time = RESTART
    write(u6,'(5X,A,T55,F9.2,A)') 'MD restart time = ',RESTART,' a.u.'
  end if

  call Put_dScalar('MD_Time',time)
  call Get_nAtoms_Full(natom)

  call mma_allocate(atom,natom)
  call mma_allocate(Mass,natom)
  call mma_allocate(vel,natom*3)

  call Get_Name_Full(atom)
  call GetMassDx(Mass,natom)

  ! Initialize Thermostat Variables

  if (THERMO == 2) then
    Freq = One/(22.0_wp/auTofs)
    Q1 = Three*natom*TEMP*Kb/(Freq*Freq)
    Q2 = TEMP*Kb/(Freq*Freq)

    NHC(iQ1) = Q1
    NHC(iQ2) = Q2
    NHC(iX1) = Zero
    NHC(iX2) = Zero
    NHC(iVx1) = Zero
    NHC(iVx2) = Zero

    call Put_NHC(NHC,nh)
#   ifdef _HDF5_
    call mh5_put_dset(dyn_nh,NHC)
#   endif

  end if

  ! Check if nuclear coordinates to project out from the dynamics
  if ((POUT == 0) .and. (PIN == natom*3)) then
    write(u6,'(5X,A,T55)') 'Dynamics in full dimensionality.'
  else
    write(u6,'(5X,A,T55)') 'Dynamics in reduced dimensionality.'
    if (POUT /= 0) then
      call mma_allocate(pcoo,POUT,natom*3)
      call DxRdOut(pcoo,POUT,natom)
      ! Save on RUNFILE
      call Put_dArray('Proj_Coord',pcoo,POUT*natom*3)
    else if (PIN /= natom*3) then
      call mma_allocate(pcoo,PIN,natom*3)
      call DxRdIn(pcoo,PIN,natom)
      ! Save on RUNFILE
      call Put_dArray('Keep_Coord',pcoo,PIN*natom*3)
    end if
  end if

  if (VELO == 1) then
    call DxRdVel(vel,natom)
    write(u6,'(5X,A,T55)') 'The initial velocities (bohr/au) are read in.'
  else if (VELO == 2) then
    call DxRdVel(vel,natom)
    do i=1,natom
      do j=1,3
        vel(3*(i-1)+j) = vel(3*(i-1)+j)/sqrt(Mass(i))
      end do
    end do
    write(u6,'(5X,A,T55)') 'The initial mass weighted velocities (bohr/au) are read in.'

    ! Maxwell-Boltzmann distribution
  else if (VELO == 3) then
    nFlag = 0
    val = Zero
    buffer = Zero

    write(u6,'(5X,A,T55)') 'The initial velocities (bohr/au) are taken '
    write(u6,'(5X,A,f9.2,A)') 'from a Boltzmann distribution at',TEMP,' kelvin'

    call getSeed(iseed)

    do i=1,natom
      arg = TEMP*Kb/Mass(i)
      Sigma = sqrt(arg)
      mean = Zero
      do j=1,3
        call RandomGauss(mean,Sigma,iseed,nflag,buffer,Val)
        vel(3*(i-1)+j) = Val

        !write(u6,'(5x,a,t55,d16.8)') 'Vel = ',Val

      end do
    end do
  else
    do i=1,3*natom
      vel(i) = Zero
    end do
    write(u6,'(5X,A,T55)') 'The initial velocities are set to zero.'
  end if
  caption = 'Velocities'
  call DxPtTableWithoutMassForce(caption,time,natom,atom,vel)

  ! Check if reduced dimensionality
  if (POUT /= 0) then
    call project_out_vel(vel,natom)
  else if (PIN /= natom*3) then
    call project_in_vel(vel,natom)
    caption = 'Vel (red dim)'
    call DxPtTableWithoutMassForce(caption,time,natom,atom,vel)
  end if

  ! Calculate the kinetic energy
  if (VELO > 0) then
    Ekin = Zero
    do i=1,natom
      do j=1,3
        Ekin = Ekin+Half*Mass(i)*(vel(3*(i-1)+j)**2)
      end do
    end do
  else
    Ekin = Zero
  end if
  write(u6,'(5x,a,6x,d19.12,1x,a)') 'Kinetic energy',Ekin,'a.u.'
  ! Save the velocities on RUNFILE
  call Put_Velocity(vel,3*natom)
  ! Save the total energy on RUNFILE if the total energy should be conserved.
  call Get_dScalar('Last Energy',Epot)
  Etot0 = Epot+Ekin
  call Put_dScalar('MD_Etot0',Etot0)
  call Put_dScalar('MD_Etot',Etot0)
# ifdef _HDF5_
  call mh5_put_dset(dyn_vel,vel)
  call mh5_put_dset(dyn_etot0,Etot0)
  call mh5_put_dset(dyn_etot,Etot0)
# endif
  call DxEnergies(time,Epot,Ekin,Etot0)
  write(u6,'(5x,a,8x,d19.12,1x,a)') 'Total Energy',Etot0,'a.u.'
  call mma_deallocate(atom)
  call mma_deallocate(Mass)
  call mma_deallocate(vel)
  if ((POUT /= 0) .or. (PIN /= natom*3)) then
    call mma_deallocate(pcoo)
  end if
end if

! Execute the tasks

do iTask=1,mTasks

  if (Task(iTask) == VelVer) then

    if (Found) then

#     ifdef _DEBUGPRINT_
      write(u6,*) ' Dynamix calls VelVer_Second.'
#     endif
      call VelVer_Second(irc)
#     ifdef _DEBUGPRINT_
      write(u6,*) ' Dynamix back from VelVer_Second.'
#     endif

      ! Check for Hopping?

      lHop = .false.
      call qpg_iScalar('MaxHops',lHop)
      if (lHop) then

        ! Read the roots

        call Get_iScalar('Number of roots',nRoots)
        call Get_iScalar('Relax CASSCF root',iRlxRoot)

        ! Run RASSI

        LuInput = 11
        LuInput = IsFreeUnit(LuInput)
        call StdIn_Name(StdIn)
        call Molcas_Open(LuInput,StdIn)
        write(LuInput,'(A)') '>export DYN_OLD_TRAP=$MOLCAS_TRAP'
        write(LuInput,'(A)') '>export MOLCAS_TRAP=ON'
        write(LuInput,'(A)') ' &RASSI &End'
        write(LuInput,'(A)') ' NR OF JOBIPHS'
        write(LuInput,*) ' 1 ',nRoots
        write(LuInput,*) (i,i=1,nRoots)
        !write(LuInput,'(X,I1,1X,I1)') inxtState,iRlxRoot
        write(LuInput,'(A)') ' HOP'
        write(LuInput,'(A)') 'End of Input'
        write(LuInput,'(A)') ' &Dynamix &End'
        write(LuInput,'(A)') ' VV_First'
        write(LuInput,'(A)') ' DT'
        write(LuInput,*) DT
        write(LuInput,'(A)') 'THERMO'
        write(LuInput,*) THERMO
        write(LuInput,'(A)') 'VELO'
        write(LuInput,*) VELO
        write(LuInput,'(A)') 'OUT'
        write(LuInput,*) POUT
        write(LuInput,'(A)') 'IN'
        write(LuInput,*) PIN
        write(LuInput,'(A)') 'End of Input'
        write(LuInput,'(A)') '>export MOLCAS_TRAP=$DYN_OLD_TRAP'
        close(LuInput)
        call Finish(_RC_INVOKED_OTHER_MODULE_)
      else
#       ifdef _DEBUGPRINT_
        write(u6,*) ' Dynamix calls VelVer_First.'
#       endif
        call VelVer_First(irc)
      end if

#     ifdef _DEBUGPRINT_
      write(u6,*) ' Dynamix back from VelVer_First.'
#     endif
    else
#     ifdef _DEBUGPRINT_
      write(u6,*) ' Dynamix calls VelVer_First.'
#     endif

      call VelVer_First(irc)
#     ifdef _DEBUGPRINT_
      write(u6,*) ' Dynamix back from VelVer_First.'
#     endif
    end if
  else if (Task(iTask) == VV_First) then
    call VelVer_First(irc)

  else if (Task(iTask) == VV_Second) then
    call VelVer_Second(irc)

  else if (Task(iTask) == Gromacs) then
    call GROM(irc)

  else
    write(u6,*) 'Illegal task'
    call Abend()
  end if
end do

! Remove the GRADS file

call f_Inquire('GRADS',Found)
if (Found) then
  if (AixRm('GRADS') /= 0) call Abend()
end if

#ifdef _HDF5_
call mh5_close_file(dyn_fileid)
#endif

! If running in a DoWhile loop, we turn a successful
! return code into "continue loop", except on the
! last iteration

if ((IsStructure() == 1) .and. (irc == 0)) then
  MxItr = 0
  call GetEnvf('MOLCAS_MAXITER',ENV)
  if (ENV /= ' ') then
    read(ENV,*) MxItr
  end if
  Itr = 1
  call GetEnvf('MOLCAS_ITER',ENV)
  if (ENV /= ' ') then
    read(ENV,*) Itr
  end if
  if (Itr < MxItr) then
    iReturn = _RC_CONTINUE_LOOP_
  else
    iReturn = irc
  end if
else
  iReturn = irc
end if

return

end subroutine Dynamix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine init(wrk,wrksize,lunabij1,lunabij2,lunabij3)
! this routine does FI1,FII1,FIII1,T11,T21
! 1) def F1(a,e) = fok(a,e)
! 2) def F2(m,i) = fok(m,i)
! 3) def F3(e,m) = fok(e,m)
! 4) def T1n(a,i) = fok(a,i)
! 5) def T2m(abij)= <ab||ij>
!
! lunabij1 - lun of file, where <ab||ij>aaaa is stored (I)
! lunabij2 - lun of file, where <ab||ij>bbbb is stored (I)
! lunabij3 - lun of file, where <ab||ij>abab is stored (I)
!
! N.B. this routine uses and destroys help files : none

use ccsd_global, only: f11, f12, f21, f22, f31, f32, fk1, fk2, fk3, fk4, fk5, fk6, t13, t14, t21, t22, t23
use Para_Info, only: MyRank
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp), intent(_IN_) :: lunabij1, lunabij2, lunabij3
integer(kind=iwp) :: post, rc

!1.1 map fok(a,b)aa to f1(a,e)aa
call map(wrk,wrksize,2,1,2,0,0,fk1,1,f11,post,rc)

!1.2 map fok(a,b)bb to f1(a,e)bb
call map(wrk,wrksize,2,1,2,0,0,fk2,1,f12,post,rc)

!2.1 map fok(i,j)aa to f2(i,j)aa
call map(wrk,wrksize,2,1,2,0,0,fk5,1,f21,post,rc)

!2.2 map fok(i,j)bb to f2(i,j)bb
call map(wrk,wrksize,2,1,2,0,0,fk6,1,f22,post,rc)

!3.1 map fok(a,i)aa to f3(a,i)aa
call map(wrk,wrksize,2,1,2,0,0,fk3,1,f31,post,rc)

!3.2 map fok(a,i)bb to f3(a,i)bb
call map(wrk,wrksize,2,1,2,0,0,fk4,1,f32,post,rc)

if (myRank == 0) then

  !4.1 map fok(a,i)aa to t1n(a,i)aa
  call map(wrk,wrksize,2,1,2,0,0,fk3,1,t13,post,rc)

  !4.2 map fok(a,i)bb to t1n(a,i)bb
  call map(wrk,wrksize,2,1,2,0,0,fk4,1,t14,post,rc)

else

  !4.3 set t1naa (t13) =0
  call set0(wrk,wrksize,t13)

  !4.4 set t1nbb (t14) =0
  call set0(wrk,wrksize,t14)

end if

if (myRank == 0) then

  !5.1 load <ab||ij>aaaa from lunabij1 to t2n(ab,ij)aaaa
  call filemanager(2,lunabij1,rc)
  call getmediate(wrk,wrksize,lunabij1,t21,rc)

  !5.2 load <ab||ij>bbbb from lunabij2 to t2n(ab,ij)bbbb
  call filemanager(2,lunabij2,rc)
  call getmediate(wrk,wrksize,lunabij2,t22,rc)

  !5.3 load <ab||ij>abab from lunabij3 to t2n(ab,ij)abab
  call filemanager(2,lunabij3,rc)
  call getmediate(wrk,wrksize,lunabij3,t23,rc)

else

  !5.4 set t2naaaa (t21) =0
  call set0(wrk,wrksize,t21)

  !5.5 set t2nbbbb (t22) =0
  call set0(wrk,wrksize,t22)

  !5.6 set t2nabab (t23) =0
  call set0(wrk,wrksize,t23)

end if

return

end subroutine init

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RNFill(length,A,c)
! fill an array with random numbers in interval (-c,c)
! (not true)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: length
real(kind=wp), intent(out) :: A(length)
real(kind=wp), intent(in) :: c
integer(kind=iwp) :: i

#include "macros.fh"
unused_var(c)

do i=1,length
  !A(i) = c*(srand()-Half)
  A(i) = 1.0e-7_wp*i
end do

return

end subroutine RNFill

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine SpinDens
     &          (LS,RS,iL,iR,rP1,rp2,rp3,rp4,rp5,rDe1,rde2,
     &           itype)
*
      Implicit Real*8(a-h,o-z)
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "WrkSpc.fh"
#include "crun_mclr.fh"

#include "Input.fh"
#include "Pointers.fh"
#include "spinfo_mclr.fh"
#include "cands.fh"
#include "cstate_mclr.fh"
      Real*8 LS(*),RS(*),rP1(nna,nna,nna,nna),
     &       rP2(nna,nna,nna,nna),rP3(nna,nna,nna,nna),
     &       rP4(nna,nna,nna,nna),rP5(nna,nna,nna,nna),
     &       rDe1(nna,nna),rde2(nna,nna)
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*
*     Input:
*
*     LS : CI Coeff for left state
*     RS : CI Coeff for right state
*     iL : Symmetry of left state
*     iR : Symmetry of right state
*
*
*     Output:
*
*      rP1 : Two Electron -- Density
*      rP2 : Two Electron ++ Density
*      rP3 : Two Electron spin Density
*      rD1 : One Electron Spin adapted Density
*      rD1 : One Electron spin density Density
*
*
*     itype=1
*     Densities for:
*              0
*     <L|[{Q:S} ,H]|R>
*              0
*     itype 2
*     Densities for
*               0       0
*     <L||[{Q:S} ,[{Q:S} ,H]]|R>
*               0       0
*
C     Call GetMem('AAA','CHECK','REAL',i,i)

      Two=2.0d0
      rOne=1.0d0
      Zero=0.0d0
      n1=2*n1dens
      n2=2*n2dens+nnA**4
      Call GetMem('1Dens2','ALLO','Real',ipDe,n1)
      Call GetMem('2Dens2','ALLO','Real',ipP,n2)
      call dcopy_(n1,[Zero],0,Work(ipDe),1)
      call dcopy_(n2,[Zero],0,Work(ipP),1)
      nConfL=Max(ncsf(il),nint(xispsm(il,1)))
      nConfR=Max(ncsf(iR),nint(xispsm(iR,1)))

      Call GetMem('CIL','ALLO','REAL',ipL,nConfL)
      Call GetMem('CIR','ALLO','REAL',ipR,nConfR)
      Call CSF2SD(LS,Work(ipL),iL)
      Call CSF2SD(RS,Work(ipR),iR)
      icsm=iR
      issm=iL
      Call Densi2(2,Work(ipDe),Work(ipP),
     &               Work(ipL),Work(ipR),0,0,1,n1dens,n2dens)
*
      If (itype.eq.1) Then
*
*             0
*        <0|[Q  ,H]|0>
*             0pq
*
         Do iA=1,nna
          Do jA=1,nnA
           rde1(ia,ja)=Work(ipDe+nna*(ia-1)+ja-1)-
     &                Work(ipDe+n1dens+nna*(ia-1)+ja-1)+
     &                Work(ipDe+nna*(ja-1)+ia-1)-
     &                Work(ipDe+n1dens+nna*(ja-1)+ia-1)
          End Do
         End Do
         Do iA=1,NnA
          Do jA=1,nnA
           Do kA=1,nnA
            Do lA=1,nnA
             ijklab=(ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
             jilkab=(ja-1)*nna**3+(ia-1)*nna**2+(la-1)*nna+ka
             ijklba=(ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
             jilkba=(la-1)*nna**3+(ka-1)*nna**2+(ja-1)*nna+ia
             ijkl=itri((ia-1)*nna+ja,(ka-1)*nna+la)
             jilk=itri((ja-1)*nna+ia,(la-1)*nna+ka)
             rP1(ia,ja,ka,la)=Work(ipP+ijkl-1)-Work(ipP+ijkl-1+n2dens)+
     R        Work(ipP+n2dens*2+ijklab-1)-Work(ipP+ijklba-1+2*n2dens)+
     L        Work(ipP+jilk-1)-Work(ipP+jilk-1+n2dens)-
     L        Work(ipP+n2dens*2+jilkab-1)+Work(ipP+jilkba-1+2*n2dens)
            End Do
           End Do
          End Do
         End Do
*
*
      Else If (itype.eq.2) Then
* OK CONSTRUCT

*   --
*   ++
*   -+
*   spindensity
*   spin adadpted density

         Call DZAXPY(n1dens,-1.0d0,Work(ipDe),1,
     &           Work(ipDe+n1dens),1,rde1,1)
         Call DZAXPY(n1dens,1.0d0,Work(ipDe+n1dens),1,
     &           Work(ipDe),1,rde2,1)

         Do iA=1,nnA
          Do jA=1,nnA
           Do kA=1,nnA
            Do lA=1,nnA
             ijklab=(ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
             ilkjab=(ia-1)*nna**3+(la-1)*nna**2+(ka-1)*nna+ja
             ilkjba=(ka-1)*nna**3+(ja-1)*nna**2+(ia-1)*nna+la
             ijklba=(ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
             ijkl=itri((ia-1)*nna+ja,(ka-1)*nna+la)
             rP1(ia,ja, ka,la)=
     &                 Work(ipP+ijkl-1)+Work(ipP+n2dens+ijkl-1)-
     &                 Work(ipp+ijklab+2*n2dens-1)-
     &                 Work(ipp+ijklba+2*n2dens-1)
            End Do
           End Do
         End Do
         End Do
         Do iA=1,nnA
          Do jA=1,nnA
           Do kA=1,nnA
            Do lA=1,nnA
             ijklab=(ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
             ilkjab=(ia-1)*nna**3+(la-1)*nna**2+(ka-1)*nna+ja
             ilkjba=(ka-1)*nna**3+(ja-1)*nna**2+(ia-1)*nna+la
             ijklba=(ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
             ijkl=itri((ia-1)*nna+ja,(ka-1)*nna+la)
             rP2(ia,ja, ka,la)=
     &                 Work(ipP+ijkl-1)-Work(ipP+n2dens+ijkl-1)-
     &                 Work(ipp+ijklab+2*n2dens-1)+
     &                 Work(ipp+ijklba+2*n2dens-1)
            End Do
           End Do
         End Do
         End Do


         Do iA=1,NnA
          Do jA=1,nnA
           Do kA=1,nnA
            Do lA=1,nnA
             ijklab=(ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
             ijklba=(ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
             ijkl=itri((ia-1)*nna+ja,(ka-1)*nna+la)
             rP3(ia,ja,ka,la)=Work(ipP+ijkl-1)+Work(ipP+ijkl-1+n2dens)+
     &        Work(ipP+n2dens*2+ijklab-1)+Work(ipP+ijklba-1+2*n2dens)
            End Do
           End Do
          End Do
         End Do
         Do iA=1,NnA
          Do jA=1,nnA
           Do kA=1,nnA
            Do lA=1,nnA
             ijklab=(ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
             ijklba=(ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
             ijkl=itri((ia-1)*nna+ja,(ka-1)*nna+la)
             rP4(ia,ja,ka,la)=
     &        -Work(ipP+n2dens*2+ijklab-1)+Work(ipP+ijklba-1+2*n2dens)
            End Do
           End Do
          End Do
         End Do
         Do iA=1,NnA
          Do jA=1,nnA
           Do kA=1,nnA
            Do lA=1,nnA
             ijklab=(ia-1)*nna**3+(ja-1)*nna**2+(ka-1)*nna+la
             ijklba=(ka-1)*nna**3+(la-1)*nna**2+(ia-1)*nna+ja
             ijkl=itri((ia-1)*nna+ja,(ka-1)*nna+la)
             rP5(ia,ja,ka,la)=
     &        Work(ipP+n2dens*2+ijklab-1)+Work(ipP+ijklba-1+2*n2dens)
            End Do
           End Do
          End Do
         End Do
        End If
        Call GetMem('1Dens2','Free','Real',ipDe,n1)
        Call GetMem('2Dens2','Free','Real',ipP,n2)
        Call GetMem('CIL','Free','Real',ipL,nConfL)
        Call GetMem('CIR','Free','Real',ipR,nConfR)
      Return
      End
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine rhs_sa(Fock)
       use Arrays, only: Int1
       Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
#include "SysDef.fh"
#include "Files_mclr.fh"
#include "real.fh"
#include "sa.fh"
#include "dmrginfo_mclr.fh"
       Real*8 Fock(*)
       Dimension rdum(1)
       Real*8, Allocatable:: T(:), F(:), G1q(:), G2q(:), G1r(:), G2r(:)
*                                                                      *
************************************************************************
*                                                                      *
       itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*
       if(doDMRG)then ! yma
         call dmrg_dim_change_mclr(RGras2(1:8),ntash,0)
       end if

       ng1=itri(ntash,ntash)
       ng2=itri(ng1,ng1)
*
       Call mma_allocate(T,ndens2,Label='T')
       Call mma_allocate(F,ndens2,Label='F')
       Call mma_allocate(G1q,ng1,Label='G1q')
       Call mma_allocate(G2q,ng2,Label='G2q')
       Call mma_allocate(G1r,ntash**2,Label='G1r')
       Call mma_allocate(G2r,itri(ntash**2,ntash**2),Label='G2r')
*
**     Pick up densities from JobIph file
*
       iR=iroot(istate)
       jdisk=itoc(3)
       Do i=1,iR-1
         Call dDaFile(LUJOB ,0,rdum,ng1,jDisk)
         Call dDaFile(LUJOB ,0,rdum,ng1,jDisk)
         Call dDaFile(LUJOB ,0,rdum,Ng2,jDisk)
         Call dDaFile(LUJOB ,0,rdum,Ng2,jDisk)
       End Do
       Call dDaFile(LUJOB ,2,G1q,ng1,jDisk)
       Call dDaFile(LUJOB ,0,rdum,ng1,jDisk)
       Call dDaFile(LUJOB ,2,G2q,Ng2,jDisk)
       Call dDaFile(LUJOB ,0,rdum,Ng2,jDisk)
*
       Call Put_P2MO(G2q,ng2)
       Call Put_D1MO(G1q,ng1)
*
       Do iB=1,ntash
        Do jB=1,ntash
        G1r(ib+(jb-1)*ntash) = G1q(itri(ib,jb))
        End Do
       End Do

       Do iB=1,ntash
        Do jB=1,ntash
         iDij=iTri(ib,jB)
         iRij=jb+(ib-1)*ntash
         Do kB=1,ntash
          Do lB=1,ntash
           iDkl=iTri(kB,lB)
           iRkl=lb+(kb-1)*ntash
           fact=One
           if(iDij.ge.iDkl .and. kB.eq.lB) fact=Two
           if(iDij.lt.iDkl .and. iB.eq.jB) fact=Two
           iijkl=itri(iDij,iDkl)
           iRijkl=itri(iRij,iRkl)
           G2r(iRijkl)=Fact*G2q(iijkl)
          End Do
         End Do
        End Do
       End Do
*
       if(doDMRG)then ! yma
         call dmrg_dim_change_mclr(RGras2(1:8),nna,0)
       end if

       Call FockGen(One,G1r,G2r,T,Fock,1)
*       Do iS=1,nsym
*        Call RecPrt(' ',' ',fock(ipMat(is,is)),nbas(is),nbas(is))
*       End Do

      If (.not.debug) Then !yma debug ??
       renergy=Zero
       Do i=1,nsym
        Do j=1,nbas(i)
         renergy = renergy + T(ipmat(i,i)+j-1+nbas(i)*(j-1))
        End DO
       End DO

      rcorei=Zero
      rcorea=Zero
      Do iS=1,nSym
       Do iB=1,nIsh(is)
       rcorei=rcorei+Two*Int1(ipCM(is)+nOrb(iS)*(ib-1)+ib-1)
       End Do

       Do iB=1,nAsh(iS)
        Do jB=1,nAsh(iS)
         iiB=nA(iS)+ib
         ijB=nA(iS)+jb
         iij=iTri(iib,ijb)
         iiB=nIsh(iS)+ib
         ijB=nIsh(iS)+jb
         rcorea=rcorea+G1q(iij)*Int1(ipCM(is)+nOrb(is)*(iib-1)+ijB-1)
        End Do
       End Do
      End Do
!      rcore=rCorei+rcoreA
!      write(*,*) 'In rhs_sa'
!      Write(*,*) 'Checking energy',0.5d0*renergy+potnuc+half*rcore !yma
!      Write(*,*) 'Checking energy',0.5d0*renergy,potnuc,rcore      !yma
!      write(*,*)
      End if
!      Do iS=1,nsym
!       Call RecPrt(' ',' ',fock(ipMat(is,is)),nbas(is),nbas(is))
!      End Do
*
       Call mma_deallocate(G1q)
       Call mma_deallocate(G2q)
*
       Call TCMO(T,1,-2)
       ijb=0
       Do is=1,nsym
        Do ib=1,nbas(is)
         Do jb=1,ib-1
          ijb=ijb+1
          F(ijb)=T(ipmat(is,is)+nbas(is)*(JB-1)+IB-1)
     &          +T(ipmat(is,is)+nbas(is)*(IB-1)+JB-1)
         End Do
         ijb=ijb+1
         F(ijb)=T(ipmat(is,is)+nbas(is)*(iB-1)+IB-1)
        End Do
       End Do
       Call Put_Fock_Occ(F,nDens2)

!       call recprt('RHS',' ',fock,ndens2,1)
*
       Call mma_deallocate(G1r)
       Call mma_deallocate(G2r)
       Call mma_deallocate(T)
       Call mma_deallocate(F)

*
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_TraVec(VecAO,VecMO,COrb1,COrb2,Scr,lScr,iSyCho,iSyCO,iSyCV,iLoc,iMoType1,iMoType2)
!
! Jonas Bostrom, Feb 2010
!
! Purpose: compute pq-vector from reduced set AO vector.

use Symmetry_Info, only: Mul
use Cholesky, only: iBas, iiBstR, IndRed, iRS2F, nBas, nnBstR, nSym
use ChoMP2, only: iAoMo, iMoAo, iMoMo, nMo, nMoAo, nMoType
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: VecAO(*), COrb1(*), COrb2(*)
real(kind=wp), intent(_OUT_) :: VecMO(*)
integer(kind=iwp), intent(in) :: lScr, iSyCho, iSyCO, iSyCV, iLoc, iMoType1, iMoType2
real(kind=wp), intent(out) :: Scr(lScr)
integer(kind=iwp) :: iAlBe, iAlpha, iBeta, iSym, iSymAl, iSymBe, iSymP, iSymq, iSyScr, iVecType, jAlBe, jAlpha, jBeta, kOff1, &
                     kOff2, kOff3, kOffAl, kOffBe, nTotAl, nTotp, nTotq
real(kind=wp) :: AOVal
real(kind=wp), parameter :: Fac(0:1) = [Half,One]
character(len=*), parameter :: SecNam = 'ChoMP2_TraVec'

! Check what type of Cholesky vector to make (fro-occ, occ-occ.....)
iVecType = iMoType2+(iMoType1-1)*nMoType

if ((iLoc < 2) .or. (iLoc > 3)) then
  write(u6,*) SecNam,': illegal iLoc = ',iLoc
  call SysAbendMsg(SecNam,'iLoc out of bounds!',' ')
end if
iSyScr = Mul(iSyCho,iSyCO)
if (lScr < nMoAo(iSyScr,iMoType1)) then
  write(u6,*) SecNam,': insufficient scratch space lScr = ',lScr
  write(u6,*) SecNam,': needed                          = ',nMoAo(iSyScr,iMoType1)
  call SysAbendMsg(SecNam,'Insufficient scratch space',' ')
else
  Scr(1:nMoAo(iSyScr,iMoType1)) = Zero
end if

! First half-transformation step:
! Scr(i,alpha) = sum_beta VecAO(alpha,beta)*COrb1(i,beta)
! ------------------------------------------------------

if (iSyCho == 1) then

  do iAlBe=1,nnBstR(iSyCho,iLoc)

    jAlBe = IndRed(iiBstR(iSyCho,iLoc)+iAlBe,iLoc)
    iAlpha = iRS2F(1,jAlBe)
    iBeta = iRS2F(2,jAlBe)

    iSymAl = 1
    do iSym=nSym,2,-1
      if (iAlpha > iBas(iSym)) then
        iSymAl = iSym
        exit
      end if
    end do
    iSymBe = iSymAl
    iSymP = Mul(iSymBe,iSyCO)

    jAlpha = iAlpha-iBas(iSymAl)
    jBeta = iBeta-iBas(iSymBe)

    AOVal = Fac(min(abs(iAlpha-iBeta),1))*VecAO(iAlBe)
    kOffAl = iMoAo(iSymP,iSymAl,iMoType1)+nMo(iSymP,iMoType1)*(jAlpha-1)
    kOffBe = iMoAo(iSymP,iSymBe,iMoType1)+nMo(iSymP,iMoType1)*(jBeta-1)
    Scr(kOffAl+1:kOffAl+nMo(iSymP,iMoType1)) = Scr(kOffAl+1:kOffAl+nMo(iSymP,iMoType1))+ &
                                               AOVal*COrb1(kOffBe+1:kOffBe+nMo(iSymP,iMoType1))
    Scr(kOffBe+1:kOffBe+nMo(iSymP,iMoType1)) = Scr(kOffBe+1:kOffBe+nMo(iSymP,iMoType1))+ &
                                               AOVal*COrb1(kOffAl+1:kOffAl+nMo(iSymP,iMoType1))

  end do

else

  do iAlBe=1,nnBstR(iSyCho,iLoc)

    jAlBe = IndRed(iiBstR(iSyCho,iLoc)+iAlBe,iLoc)
    iAlpha = iRS2F(1,jAlBe)
    iBeta = iRS2F(2,jAlBe)

    iSymAl = 1
    do iSym=nSym,2,-1
      if (iAlpha > iBas(iSym)) then
        iSymAl = iSym
        exit
      end if
    end do
    iSymBe = Mul(iSymAl,iSyCho)

    jAlpha = iAlpha-iBas(iSymAl)
    jBeta = iBeta-iBas(iSymBe)

    AOVal = VecAO(iAlBe)

    iSymP = Mul(iSymBe,iSyCO)
    kOffAl = iMoAo(iSymP,iSymAl,iMoType1)+nMo(iSymP,iMoType1)*(jAlpha-1)
    kOffBe = iMoAo(iSymP,iSymBe,iMoType1)+nMo(iSymP,iMoType1)*(jBeta-1)
    Scr(kOffAl+1:kOffAl+nMo(iSymP,iMoType1)) = Scr(kOffAl+1:kOffAl+nMo(iSymP,iMoType1))+ &
                                               AOVal*COrb1(kOffBe+1:kOffBe+nMo(iSymP,iMoType1))

    iSymP = Mul(iSymAl,iSyCO)
    kOffAl = iMoAo(iSymP,iSymAl,iMoType1)+nMo(iSymP,iMoType1)*(jAlpha-1)
    kOffBe = iMoAo(iSymP,iSymBe,iMoType1)+nMo(iSymP,iMoType1)*(jBeta-1)
    Scr(kOffBe+1:kOffBe+nMo(iSymP,iMoType1)) = Scr(kOffBe+1:kOffBe+nMo(iSymP,iMoType1))+ &
                                               AOVal*COrb1(kOffAl+1:kOffAl+nMo(iSymP,iMoType1))

  end do

end if

! Second half-transformation step:
! VecMO(q,p) = sum_alpha COrb2(alpha,q)*Scr(p,alpha)
! -------------------------------------------------

do iSymp=1,nSym

  iSymq = Mul(iSymp,iSyCho)
  iSymAl = Mul(iSymq,iSyCV)

  nTotAl = nBas(iSymAl)
  nTotq = nMo(iSymq,iMoType2)
  nTotp = nMo(iSymp,iMoType1)

  if ((nTotp > 0) .and. (nTotq > 0) .and. (nTotAl > 0)) then
    kOff1 = iAoMo(iSymAl,iSymq,iMoType2)+1
    kOff2 = iMoAo(iSymp,iSymAl,iMoType1)+1
    kOff3 = iMoMo(iSymq,iSymp,iVecType)+1
    call DGEMM_('T','T',nMo(iSymq,iMoType2),nMo(iSymp,iMoType1),nBas(iSymAl),One,COrb2(kOff1),nTotAl,Scr(kOff2),nTotp,Zero, &
                VecMO(kOff3),nTotq)
  end if

end do

end subroutine ChoMP2g_TraVec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETH1(nBTri,H1,RFpert,ERFNuc)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBTri
real(kind=wp), intent(out) :: H1(nBTri), ERFNuc
logical(kind=iwp), intent(in) :: RFpert
integer(kind=iwp) :: iCmp, iOpt, iRc, iSyLab
character(len=8) :: OneLbl
real(kind=wp), allocatable :: Tmp(:)

iRc = -1
iOpt = 6
iCmp = 1
iSyLab = 1
OneLbl = 'OneHam  '

call RdOne(iRc,iOpt,OneLbl,iCmp,H1,iSyLab)

if (IRC /= 0) then
  write(u6,*)
  write(u6,*) '    *** ERROR IN SUBROUTINE  CHO_GETH1 ***'
  write(u6,*) '   BARE NUCLEI HAMILTONIAN IS NOT AVAILABLE'
  write(u6,*)
  call Abend()
end if

ERFNuc = Zero
if (RFpert) then
  call mma_allocate(Tmp,nBTri,Label='Tmp')
  call Get_dScalar('RF Self Energy',ERFNuc)
  call Get_dArray('Reaction field',Tmp,nBtri)

  H1(:) = H1(:)+Tmp(:)

  call mma_deallocate(Tmp)
end if

return

end subroutine CHO_GETH1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Expectus(QMMethod,HmatOld,Vmat,VpolMat,Smat,MxDim
     &                   ,iVEC,nDim,lEig,iEig,ip_ExpVal)
      Implicit Real*8 (a-h,o-z)

#include "numbers.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension HmatOld(MxDim),Vmat(MxDim),VpolMat(MxDim),Smat(MxDim)
      Character QMMethod*5
      Logical lEig

*
*-- Take different path for different QM-method.
*
      If(QMMethod(1:5).eq.'RASSI') then
*
*---- For how many roots are the eigenvalues to be computed.
*
        If(lEig) then
          nRoots=iEig
        Else
          nRoots=nDim
        Endif
*
*---- Loop over roots and compute expectation values according to
*     well-known formulas.
*
        nDTri=nDim*(nDim+1)/2
        Call GetMem('DenTemp','Allo','Real',iDTmp,nDTri)
        Call GetMem('ExpVals','Allo','Real',ip_ExpVal,4*nRoots)
        Do 801, iRoot=1,nRoots
          kaunter=0
*
*------ Generate density matrix for relevant root.
*
          Call DensiSt(Work(iDTmp),Work(iVEC),iRoot,nDim,nDim)
*
*------ Expectation values.
*
          Work(ip_ExpVal+4*(iRoot-1)+0)=Ddot_(nDTri,Work(iDTmp),iOne
     &                                      ,HmatOld,iOne)
          Work(ip_ExpVal+4*(iRoot-1)+1)=Ddot_(nDTri,Work(iDTmp),iOne
     &                                      ,Vmat,iOne)
          Work(ip_ExpVal+4*(iRoot-1)+2)=Ddot_(nDTri,Work(iDTmp),iOne
     &                                      ,Vpolmat,iOne)
          Work(ip_ExpVal+4*(iRoot-1)+3)=Ddot_(nDTri,Work(iDTmp),iOne
     &                                      ,Smat,iOne)
801     Continue
        Call GetMem('DenTemp','Free','Real',iDTmp,nDTri)

*
*-- If its SCF we are running.
*
      Elseif(QMMethod(1:5).eq.'SCF  ') then
        nDTri=nDim*(nDim+1)/2
        Call GetMem('DenTemp','Allo','Real',iDTmp,nDTri)
        Call GetMem('ExpVals','Allo','Real',ip_ExpVal,4)
        Call Densi_MO(Work(iDTmp),Work(iVEC),1,iEig,nDim,nDim)
*
*------ Expectation values.
*
        Work(ip_ExpVal+0)=Ddot_(nDTri,Work(iDTmp),iOne,HmatOld,iOne)
        Work(ip_ExpVal+1)=Ddot_(nDTri,Work(iDTmp),iOne,Vmat,iOne)
        Work(ip_ExpVal+2)=Ddot_(nDTri,Work(iDTmp),iOne,Vpolmat,iOne)
        Work(ip_ExpVal+3)=Ddot_(nDTri,Work(iDTmp),iOne,Smat,iOne)
        Call GetMem('DenTemp','Free','Real',iDTmp,nDTri)

*
*-- Shit happens.
*
      Else
        Write(6,*)
        Write(6,*)' Now how did this happen, says Expectus!'
        Call Quit(_RC_INTERNAL_ERROR_ )
      Endif

*
*-- What's you major malfunction, numb nuts!
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine VVVOX2(KEEP,iSym,iSymI,iSymJ,iSymK,iSymL,nBasT,vLag,CMO,WRK,DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,FIFA,FIMO)

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use ChoVec_io, only: NVLOC_CHOBATCH
use Cholesky, only: InfVec
use caspt2_global, only: LuGAMMA
use ChoCASPT2, only: MXNVC, NCHSPC, numcho_pt2
use caspt2_module, only: IFMSCOUP, iRlxRoot, JSTATE, NASH, NBAS, NBTCHES, NFROT, NISH, NSSH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: KEEP(8), iSym, iSymI, iSymJ, iSymK, iSymL, nBasT
real(kind=wp), intent(inout) :: vLag(nBasT,nBasT), WRK(nBasT,nBasT), FPT2AO(nBasT**2), FPT2CAO(nBasT**2), FIFA(nBasT**2), &
                                FIMO(nBasT**2)
real(kind=wp), intent(in) :: CMO(nBasT,nBasT), DPT2AO(nBasT**2), DPT2CAO(nBasT**2)
integer(kind=iwp) :: i, IBATCH, IBATCH_TOT, ILOC, ipWRK(8), IRC, iSkip(8), iSMax, ISTLT(8), ISTSQ(8), iSymIJ, iSymL_, iVec, j, &
                     JNUM, JRED, JRED1, JRED2, JREDC, JSTART, jSym, JV1, JV2, KEEPI, KEEPJ, KEEPK, KEEPL, MUSED, nAshI, nB, nB2, &
                     nB3, nBasI, nBasIJ, nBasJ, nBasK, nBasKL, nBasL, NBATCH, nIshI, nOrbI, nSshI, NUMV, NVECS_RED
real(kind=wp) :: tmp
real(kind=wp), allocatable :: CHSPC(:), HTSPC(:), HTVec(:)
#include "warnings.h"

iSkip(1:nSym) = 1
ipWRK(1:nSym) = 1

ISTSQ(1) = 0
ISTLT(1) = 0
do jSym=2,nSym
  nB = nBas(jSym-1)
  nB2 = nB**2
  nB3 = nTri_Elem(nB2)
  ISTSQ(jSym) = ISTSQ(jSym-1)+nB2
  ISTLT(jSym) = ISTLT(jSym-1)+nB3
end do

nBasI = nBas(iSymI)
KEEPI = KEEP(iSymI)
!nAuxI = nAux(iSymI)
nBasJ = nBas(iSymJ)
KEEPJ = KEEP(iSymJ)
!nAuxJ = nAux(iSymJ)
iSymIJ = Mul(iSymI,iSymJ)
nBasIJ = nBasI*nBasJ
if (iSymI == iSymJ) nBasIJ = nTri_Elem(nBasI)
if (nBasIJ == 0) return

nBasK = nBas(iSymK)
KEEPK = KEEP(iSymK)
!nAuxK = nAux(iSymK)
iSMax = iSymK
if (iSymK == iSymI) iSMax = iSymJ
iSymL_ = Mul(iSymIJ,iSymK)
if (iSymL_ > iSMax) return !! should not
nBasL = nBas(iSymL_)
KEEPL = KEEP(iSymL_)
!nAuxL = nAux(iSymL_)
nBasKL = nBasK*nBasL
if (iSymK == iSymL) nBasKL = nTri_Elem(nBasK)
if (nBasKL == 0) return

! INTEGRAL BLOCK EXCLUDED BY SETTING KEEP PARAMETERS?
if (KEEPI+KEEPJ+KEEPK+KEEPL /= 0) return
!! This will not work when the number of the inactive orbital is 0
!if (nAuxI+nAuxJ+nAuxK+nAuxL == 0) return ! frozen orbitals

jSym = iSymJ
!kSym = iSymK
!lSym = iSymL
nIshI = nIsh(iSym)
!nIshJ = nIsh(jSym)
!nIshK = nIsh(kSym)
!nIshL = nIsh(lSym)
nAshI = nAsh(iSym)
!nAshJ = nAsh(jSym)
!nAshK = nAsh(kSym)
!nAshL = nAsh(lSym)
nSshI = nSsh(iSym)
!nSshJ = nSsh(jSym)
!nSshK = nSsh(kSym)
!nSshL = nSsh(lSym)
nOrbI = nIshI+nAshI+nSshI

call mma_allocate(CHSPC,NCHSPC,Label='CHSPC')
call mma_allocate(HTSPC,NCHSPC,Label='HISPC')
call mma_allocate(HTVec,nBasT**2,Label='HTVEC')

IBATCH_TOT = NBTCHES(iSym)

if (NUMCHO_PT2(iSym) == 0) return

JRED1 = InfVec(1,2,jSym)
JRED2 = InfVec(NumCho_PT2(jSym),2,jSym)

! Loop over JRED
do JRED=JRED1,JRED2

  call Cho_X_nVecRS(JRED,iSym,JSTART,NVECS_RED)
  if (NVECS_RED == 0) cycle

  ILOC = 3
  call CHO_X_SETRED(IRC,ILOC,JRED)
  ! For a reduced set, the structure is known, including
  ! the mapping between reduced index and basis set pairs.
  ! The reduced set is divided into suitable batches.
  ! First vector is JSTART. Nr of vectors in r.s. is NVECS_RED.
  !JEND = JSTART+NVECS_RED-1

  ! Determine batch length for this reduced set.
  ! Make sure to use the same formula as in the creation of disk
  ! address tables, etc, above:
  NBATCH = 1+(NVECS_RED-1)/MXNVC

  ! Loop over IBATCH
  JV1 = JSTART
  do IBATCH=1,NBATCH
    !write(u6,*) 'ibatch,nbatch = ',ibatch,nbatch
    IBATCH_TOT = IBATCH_TOT+1

    JNUM = NVLOC_CHOBATCH(IBATCH_TOT)
    JV2 = JV1+JNUM-1

    ! ----- Construct orbital Lagrangian -----

    !! CHSPC       :: (mu nu|P)
    !! HTSPC       :: ( q nu|P)
    !! Bra and Ket :: (ia|P) = T_{ij}^{ab}*(jb|P)
    !! In 1), HT_{i mu,P} = C_{mu a}*(ia|P)
    !!        (ia|P) read from disk
    !! In 3), L_{i mu} = HT_{i nu,P} * (mu nu|P)
    !! Then, L_{pi} = C_{mu p} * L_{i mu}^T
    !! Transpose is done in VVVO_Drv2,
    !! and C_{mu p} is in OLagVVVO

    !! 1) Half back-transformation of Bra and Ket density
    !! Read the 3c-2e pseudo-density (in MO), and half transform
    call VVVOTRA_RI(CMO,CHSPC,size(CHSPC),HTSPC,JNUM,IBATCH_TOT,IBATCH_TOT,nOrbI)

    !! 2) read AO Cholesky vectors,
    !!    then, (strange) reduced form -> squared AO (mu nu|iVec)
    JREDC = JRED
    ! Read a batch of reduced vectors
    call CHO_VECRD(CHSPC,NCHSPC,JV1,JV2,iSym,NUMV,JREDC,MUSED)
    if (NUMV /= JNUM) then
      write(u6,*) ' Rats! CHO_VECRD was called, assuming it to'
      write(u6,*) ' read JNUM vectors. Instead it returned NUMV'
      write(u6,*) ' vectors: JNUM, NUMV=',JNUM,NUMV
      write(u6,*) ' Back to the drawing board?'
      call QUIT(_RC_INTERNAL_ERROR_)
    end if
    if (JREDC /= JRED) then
      write(u6,*) ' Rats! It was assumed that the Cholesky vectors'
      write(u6,*) ' in HALFTRNSF all belonged to a given reduced'
      write(u6,*) ' set, but they don''t!'
      write(u6,*) ' JRED, JREDC:',JRED,JREDC
      write(u6,*) ' Back to the drawing board?'
      write(u6,*) ' Let the program continue and see what happens.'
    end if

    !! (strange) reduced form -> squared AO (mu nu|iVec)
    !! is it possible to avoid this transformation?
    ! choptr.fh
    call R2FIP(CHSPC,size(CHSPC),WRK,ipWRK,NUMV,nBasT,iSym,iSkip,irc,JREDC)

    ! ----- Fock-like transformations (if needed) -----

    if (nFroT == 0) then
      do iVec=1,NUMV
        call FDGTRF(CHSPC(1+nBasT**2*(iVec-1)),DPT2AO,FPT2AO)
        call FDGTRF(CHSPC(1+nBasT**2*(iVec-1)),DPT2CAO,FPT2CAO)
      end do
    end if

    !! 3) Contract with Cholesky vectors
    call DGemm_('N','T',nOrbI,nBasI,nBasI*JNUM,Two,HTSPC,nOrbI,CHSPC,nBasI,One,vLag,nBasI)

    !! 4) Construct the 3c-2e pseudo-density in AO
    !! D_{p nu} -> D_{mu nu}
    !! i.e., construct B_PT2, used in ALASKA
    call DGemm_('N','N',nBasI,nBasI*JNUM,nOrbI,One,CMO(1,1),nBasI,HTSPC,nOrbI,Zero,CHSPC,nBasI)

    !! 5) Save the 3c-2e pseudo-density in the disk
    !! it may be replaced with ddafile
    do iVec=1,NUMV
      if (IFMSCOUP .and. (jState /= 1)) then
        read(LuGamma,rec=iVec+JV1-1) HTVec(1:nBasI**2)
        HTVec(1:nBasI**2) = HTVec(1:nBasI**2)+CHSPC(nBasI**2*(iVec-1)+1:nBasI**2*iVec)
        write(LuGamma,rec=iVec+JV1-1) HTVec(1:nBasI**2)
      else if ((jState == iRlxRoot) .or. IFMSCOUP) then
        write(LuGamma,rec=iVec+JV1-1) CHSPC(1+nBasI**2*(iVec-1):nBasI**2*iVec)
      end if
    end do

    JV1 = JV1+JNUM
  end do
end do

call mma_deallocate(CHSPC)
call mma_deallocate(HTSPC)
call mma_deallocate(HTVec)

!! Have to (?) symmetrize Fock-transformed matrices
if (nFroT == 0) then
  do i=1,nBasI
    do j=1,i-1
      tmp = (FPT2AO(i+nBasI*(j-1))+FPT2AO(j+nBasI*(i-1)))*Half
      FPT2AO(i+nBasI*(j-1)) = Tmp
      FPT2AO(j+nBasI*(i-1)) = Tmp
      tmp = (FPT2CAO(i+nBasI*(j-1))+FPT2CAO(j+nBasI*(i-1)))*Half
      FPT2CAO(i+nBasI*(j-1)) = Tmp
      FPT2CAO(j+nBasI*(i-1)) = Tmp
      if (nFroT /= 0) then
        tmp = (FIFA(i+nBasI*(j-1))+FIFA(j+nBasI*(i-1)))*Half
        FIFA(i+nBasI*(j-1)) = Tmp
        FIFA(j+nBasI*(i-1)) = Tmp
        tmp = (FIMO(i+nBasI*(j-1))+FIMO(j+nBasI*(i-1)))*Half
        FIMO(i+nBasI*(j-1)) = Tmp
        FIMO(j+nBasI*(i-1)) = Tmp
      end if
    end do
  end do
end if

return

contains

subroutine FDGTRF(ChoVec,DD,FF)

  real(kind=wp), intent(in) :: ChoVec(nBasI**2), DD(nBasI**2)
  real(kind=wp), intent(inout) :: FF(nBasI**2)
  real(kind=wp), external :: ddot_

  !! Coulomb
  FF(:) = FF(:)+DDot_(nBasI**2,DD,1,ChoVec,1)*ChoVec(:)

  !! Exchange
  call DGEMM_('T','N',nBasI,nBasI,nBasI,One,ChoVec,nBasI,DD,nBasI,Zero,WRK,nBasI)
  call DGEMM_('T','T',nBasI,nBasI,nBasI,-Half,ChoVec,nBasI,WRK,nBasI,One,FF,nBasI)

end subroutine FDGTRF

subroutine VVVOTRA_RI(CMO,CHSPC_,NCHSPC,HTSPC_,NVEC,IBSTA,IBEND,nOrbI)
  !! CHSPC is used as a temporary array

  integer(kind=iwp), intent(in) :: NCHSPC, NVEC, IBSTA, IBEND, nOrbI
  real(kind=wp), intent(in) :: CMO(nBasI,nOrbI)
  real(kind=wp), intent(inout) :: CHSPC_(NCHSPC), HTSPC_(nOrbI,nBasT,NVEC)
  integer(kind=iwp) :: IPQ, jVec, nBra
  integer(kind=iwp), parameter :: Inactive = 1, Active = 2, Virtual = 3

  !! BraAI
  call Cholesky_Vectors(2,Inactive,Active,JSYM,CHSPC_,NCHSPC,nBra,IBSTA,IBEND)
  IPQ = nAshI*nIshI
  do jVec=1,NVEC
    ! a. AI -> mu I
    call DGemm_('T','T',nIshI,nBasI,nAshI,One,CHSPC_(1+IPQ*(jVec-1)),nAshI,CMO(1,1+nIshI),nBasI,Zero,HTSPC_(1,1,jVec),nOrbI)
    ! a. AI -> A mu
    call DGemm_('N','T',nAshI,nBasI,nIshI,One,CHSPC_(1+IPQ*(jVec-1)),nAshI,CMO(1,1),nBasI,Zero,HTSPC_(1+nIshI,1,jVec),nOrbI)
  end do

  !! BraSI
  call Cholesky_Vectors(2,Inactive,Virtual,JSYM,CHSPC_,NCHSPC,nBra,IBSTA,IBEND)
  IPQ = nIshI*nSshI
  do jVec=1,NVEC
    ! b. SI -> mu I
    call DGemm_('T','T',nIshI,nBasI,nSshI,One,CHSPC_(1+IPQ*(jVec-1)),nSshI,CMO(1,1+nIshI+nAshI),nBasI,One,HTSPC_(1,1,jVec),nOrbI)
    ! a. SI -> S mu
    call DGemm_('N','T',nSshI,nBasI,nIshI,One,CHSPC_(1+IPQ*(jVec-1)),nSshI,CMO(1,1),nBasI,Zero,HTSPC_(1+nIshI+nAshI,1,jVec),nOrbI)
  end do

  !! BraSA
  call Cholesky_Vectors(2,Active,Virtual,JSYM,CHSPC_,NCHSPC,nBra,IBSTA,IBEND)
  IPQ = nAshI*nSshI
  do jVec=1,NVEC
    ! d. SA -> mu A
    call DGemm_('T','T',nAshI,nBasI,nSshI,One,CHSPC_(1+IPQ*(jVec-1)),nSshI,CMO(1,1+nIshI+nAshI),nBasI,One,HTSPC_(1+nIshI,1,jVec), &
                nOrbI)
    ! b. SA -> S mu
    call DGemm_('N','T',nSshI,nBasI,nAshI,One,CHSPC_(1+IPQ*(jVec-1)),nSshI,CMO(1,1+nIshI),nBasI,One,HTSPC_(1+nIshI+nAshI,1,jVec), &
                nOrbI)
  end do

  !! BraAA
  call Cholesky_Vectors(2,Active,Active,JSYM,CHSPC_,NCHSPC,nBra,IBSTA,IBEND)
  IPQ = nAshI*nAshI
  do jVec=1,NVEC
    ! b. AA -> mu A
    call DGemm_('T','T',nAshI,nBasI,nAshI,One,CHSPC_(1+IPQ*(jVec-1)),nAshI,CMO(1,1+nIshI),nBasI,One,HTSPC_(1+nIshI,1,jVec),nOrbI)
    ! c. AA -> A mu
    call DGemm_('N','T',nAshI,nBasI,nAshI,One,CHSPC_(1+IPQ*(jVec-1)),nAshI,CMO(1,1+nIshI),nBasI,One,HTSPC_(1+nIshI,1,jVec),nOrbI)
  end do

end subroutine VVVOTRA_RI

end subroutine VVVOX2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2018, Ignacio Fdez. Galvan                             *
!***********************************************************************

module Chkpnt

#ifdef _HDF5_
use mh5, only: mh5_close_attr, mh5_close_dset, mh5_close_file, mh5_create_attr_int, mh5_create_dset_int, mh5_create_dset_real, &
               mh5_create_dset_str, mh5_create_file, mh5_fetch_attr, mh5_get_attr, mh5_init_attr, mh5_is_hdf5, mh5_open_attr, &
               mh5_open_dset, mh5_open_file_rw, mh5_put_attr, mh5_put_dset, mh5_resize_dset
use Definitions, only: wp
#endif
use Molcas, only: LenIn
use Definitions, only: iwp

implicit none
private

# ifdef _HDF5_
character(len=*), parameter :: basename = 'SLAPAFCHK'

integer(kind=iwp) :: chkpnt_coor, chkpnt_ener, chkpnt_force, chkpnt_hess, chkpnt_id, chkpnt_iter, chkpnt_new, Iter_all
character(len=12) :: filename
#endif

public :: Chkpnt_close, Chkpnt_open, Chkpnt_update, Chkpnt_update_MEP

contains

subroutine Chkpnt_open()
# ifdef _HDF5_
  use Symmetry_Info, only: nIrrep
  use Slapaf_Info, only: Coor, IRC, iter
  integer(kind=iwp) :: tmp
  logical(kind=iwp) :: create
  character(len=3) :: level

  Iter_all = Iter
  create = .true.
  call GetEnvF('EMIL_InLoop',level)
  if ((level == '0') .or. (level == '1')) level = ''
  filename = basename//trim(level)

  if (((Iter > 1) .or. (IRC == -1)) .and. mh5_is_hdf5(filename)) then
    create = .false.
    chkpnt_id = mh5_open_file_rw(filename)
    chkpnt_iter = mh5_open_attr(chkpnt_id,'ITERATIONS')
    chkpnt_ener = mh5_open_dset(chkpnt_id,'ENERGIES')
    chkpnt_coor = mh5_open_dset(chkpnt_id,'COORDINATES')
    chkpnt_new = mh5_open_dset(chkpnt_id,'CENTER_COORDINATES')
    chkpnt_force = mh5_open_dset(chkpnt_id,'FORCES')
    chkpnt_hess = mh5_open_dset(chkpnt_id,'HESSIAN')
    call mh5_fetch_attr(chkpnt_id,'NSYM',tmp)
    if (tmp /= nIrrep) create = .true.
    call mh5_fetch_attr(chkpnt_id,'NATOMS_UNIQUE',tmp)
    if (tmp /= size(Coor,2)) create = .true.
    call mh5_fetch_attr(chkpnt_id,'ITERATIONS',tmp)
    if (IRC == -1) then
      if (Iter >= tmp) create = .true.
      Iter_all = tmp+1
    else
      if (tmp >= Iter) create = .true.
    end if
  end if
  if (create) then
    if ((Iter > 1) .or. (IRC == -1)) then
      call WarningMessage(2,'The HDF5 file does not exist or is inconsistent')
      call AbEnd()
    else
      call Chkpnt_init()
    end if
  end if
# endif
end subroutine Chkpnt_open

#ifdef _HDF5_
subroutine Chkpnt_init()
  use Phase_Info, only: iPhase
  use Symmetry_Info, only: nIrrep
  use Index_Functions, only: nTri_Elem
  use Slapaf_Info, only: AtomLbl, Coor, dMass, dMEPStep, iCoSet, MEP, nDimBC, nStab, rMEP, Smmtrc
  use stdalloc, only: mma_allocate, mma_deallocate
  character :: lIrrep(24)
  integer(kind=iwp) :: dsetid, i, j, k, mAtom
  integer(kind=iwp), allocatable :: desym(:,:), symdof(:,:)
  real(kind=wp), allocatable :: charges(:)

  chkpnt_id = mh5_create_file(filename)

  call mh5_init_attr(chkpnt_id,'MOLCAS_MODULE','SLAPAF')

  ! symmetry information
  call mh5_init_attr(chkpnt_id,'NSYM',nIrrep)
  call Get_cArray('Irreps',lIrrep,24)
  call mh5_init_attr(chkpnt_id,'IRREP_LABELS',1,[nIrrep],lIrrep,3)

  call mh5_init_attr(chkpnt_id,'NATOMS_UNIQUE',size(Coor,2))

  call mh5_init_attr(chkpnt_id,'DOF',nDimBC)

  ! atom labels
  dsetid = mh5_create_dset_str(chkpnt_id,'CENTER_LABELS',1,[size(Coor,2)],LenIn)
  call mh5_init_attr(dsetid,'DESCRIPTION','Unique center labels arranged as one [NATOMS_UNIQUE] block')
  call mh5_put_dset(dsetid,AtomLbl)
  call mh5_close_dset(dsetid)

  ! atom masses
  dsetid = mh5_create_dset_real(chkpnt_id,'CENTER_MASSES',1,[size(Coor,2)])
  call mh5_init_attr(dsetid,'DESCRIPTION','Nuclear masses, stored as array of size [NATOMS_UNIQUE]')
  call mh5_put_dset(dsetid,dMass)
  call mh5_close_dset(dsetid)

  ! atom charges
  dsetid = mh5_create_dset_real(chkpnt_id,'CENTER_CHARGES',1,[size(Coor,2)])
  call mh5_init_attr(dsetid,'DESCRIPTION','Nuclear charges, stored as array of size [NATOMS_UNIQUE]')
  call mma_allocate(charges,size(Coor,2))
  call Get_dArray('Nuclear Charge',charges,size(Coor,2))
  call mh5_put_dset(dsetid,charges)
  call mma_deallocate(charges)
  call mh5_close_dset(dsetid)

  ! number of iterations
  chkpnt_iter = mh5_create_attr_int(chkpnt_id,'ITERATIONS')

  ! atom coordinates (new iteration)
  !   use the same dataset name as in run2hdf5
  chkpnt_new = mh5_create_dset_real(chkpnt_id,'CENTER_COORDINATES',2,[3,size(Coor,2)])
  call mh5_init_attr(chkpnt_new,'DESCRIPTION','Atom coordinates for new iteration, matrix of size [NATOMS_UNIQUE,3], stored '// &
                     'with atom index varying slowest')

  if (nIrrep > 1) then

    mAtom = 0
    do i=1,size(Coor,2)
      mAtom = mAtom+nIrrep/nStab(i)
    end do
    call mma_allocate(desym,4,mAtom)
    call mma_allocate(symdof,2,nDimBC)
    mAtom = 0
    k = 0
    do i=1,size(Coor,2)
      do j=0,nIrrep/nStab(i)-1
        mAtom = mAtom+1
        desym(1,mAtom) = i
        desym(2,mAtom) = iPhase(1,iCoSet(j,i))
        desym(3,mAtom) = iPhase(2,iCoSet(j,i))
        desym(4,mAtom) = iPhase(3,iCoSet(j,i))
      end do
      do j=1,3
        if (.not. Smmtrc(j,i)) cycle
        k = k+1
        symdof(1,k) = i
        symdof(2,k) = j
      end do
    end do

    ! total number of atoms
    call mh5_init_attr(chkpnt_id,'NATOMS_ALL',mAtom)

    ! desymmetrization factors
    dsetid = mh5_create_dset_int(chkpnt_id,'DESYM_FACTORS',2,[4,mAtom])
    call mh5_init_attr(dsetid,'DESCRIPTION','Factors for obtaining all coordinates, matrix of size [NATOMS_ALL,4], each row '// &
                       'contains the unique atom index and the factors with which to multiply the x,y,z coordinates')
    call mh5_put_dset(dsetid,desym)
    call mh5_close_dset(dsetid)
    call mma_deallocate(desym)

    ! symmetry-unique degrees of freedom (Cartesian indices)
    dsetid = mh5_create_dset_int(chkpnt_id,'DOF_INDICES',2,[2,nDimBC])
    call mh5_init_attr(dsetid,'DESCRIPTION','Indices of the Cartesian degrees of freedom, matrix of size [DOF, 2], each row '// &
                       'contains the atom index and the Cartesian index (1=x, 2=y, 3=z)')
    call mh5_put_dset(dsetid,symdof)
    call mh5_close_dset(dsetid)
    call mma_deallocate(symdof)
  end if

  ! iteration data:

  ! energies
  chkpnt_ener = mh5_create_dset_real(chkpnt_id,'ENERGIES',1,[0],dyn=.true.)
  call mh5_init_attr(chkpnt_ener,'DESCRIPTION','Energies for all iterations as a matrix of size [ITERATIONS]')

  ! atom coordinates
  chkpnt_coor = mh5_create_dset_real(chkpnt_id,'COORDINATES',3,[3,size(Coor,2),0],dyn=.true.)
  call mh5_init_attr(chkpnt_coor,'DESCRIPTION','Atom coordinates, matrix of size [ITERATIONS,NATOMS_UNIQUE,3], stored with '// &
                     'iteration varying slowest, then atom index')

  ! Cartesian forces (F = -g)
  chkpnt_force = mh5_create_dset_real(chkpnt_id,'FORCES',3,[3,size(Coor,2),0],dyn=.true.)
  call mh5_init_attr(chkpnt_force,'DESCRIPTION','Cartesian forces, matrix of size [ITERATIONS,NATOMS_UNIQUE,3], stored with '// &
                     'iteration varying slowest, then atom index')

  ! Cartesian Hessian
  chkpnt_hess = mh5_create_dset_real(chkpnt_id,'HESSIAN',1,[nTri_Elem(nDimBC)])
  call mh5_init_attr(chkpnt_hess,'DESCRIPTION','Cartesian Hessian in triangular form, as a vector of size [DOF*(DOF+1)/2]')

  ! MEP/IRC information
  if (MEP .or. rMEP) then
    call mh5_init_attr(chkpnt_id,'MEP_STEP',dMEPStep)
    call mh5_init_attr(chkpnt_id,'MEP_ITERATIONS',0)

    dsetid = mh5_create_dset_int(chkpnt_id,'MEP_INDICES',1,[0],dyn=.true.)
    call mh5_init_attr(dsetid,'DESCRIPTION','Iteration number for each converged MEP step, as a vector of size [MEP_ITERATIONS]')
  end if
end subroutine Chkpnt_init
#endif

subroutine Chkpnt_update()
# ifdef _HDF5_
  use Slapaf_Info, only: Cx, Energy, Gx, iter, nDimBC
  use stdalloc, only: mma_allocate, mma_deallocate
  integer(kind=iwp) :: i, ij, j
  logical(kind=iwp) :: Found
  real(kind=wp), allocatable :: Hss_X(:)

  call Qpg_dArray('Hss_X',Found,i)
  if (Found) then
    if (i /= nDimBC**2) then
      call WarningMessage(2,'Hessian with wrong dimension')
      call AbEnd()
    end if
    call mma_allocate(Hss_X,i)
    call Get_dArray('Hss_X',Hss_X,i)
    ij = 0
    do i=1,nDimBC
      do j=1,i
        ij = ij+1
        Hss_X(ij) = Hss_X(nDimBC*(i-1)+j)
      end do
    end do
  end if

  ! iterations
  call mh5_put_attr(chkpnt_iter,Iter_all)
  ! energies
  call mh5_resize_dset(chkpnt_ener,[Iter_all])
  call mh5_put_dset(chkpnt_ener,Energy(Iter:Iter),[1],[Iter_all-1])
  ! coordinates
  call mh5_resize_dset(chkpnt_coor,[3,size(Cx,2),Iter_all])
  call mh5_put_dset(chkpnt_coor,Cx(:,:,Iter),[3,size(Cx,2),1],[0,0,Iter_all-1])
  ! new coordinates
  call mh5_put_dset(chkpnt_new,Cx(1,1,Iter+1))
  ! forces
  call mh5_resize_dset(chkpnt_force,[3,size(Cx,2),Iter_all])
  call mh5_put_dset(chkpnt_force,Gx(:,:,Iter),[3,size(Cx,2),1],[0,0,Iter_all-1])
  ! Hessian
  if (Found) then
    call mh5_put_dset(chkpnt_hess,Hss_X(1))
    call mma_deallocate(Hss_X)
  end if
# endif
end subroutine Chkpnt_update

subroutine Chkpnt_update_MEP(SaveMEP,IRCRestart)
  logical(kind=iwp), intent(in) :: SaveMEP, IRCRestart
# ifdef _HDF5_
  integer(kind=iwp) :: attrid, dsetid, iMEP

  if (IRCRestart) call mh5_init_attr(chkpnt_id,'IRC_RESTART',Iter_all+1)
  if (SaveMEP) then
    attrid = mh5_open_attr(chkpnt_id,'MEP_ITERATIONS')
    call mh5_get_attr(attrid,iMEP)
    iMEP = iMEP+1
    call mh5_put_attr(attrid,iMEP)
    call mh5_close_attr(attrid)
    dsetid = mh5_open_dset(chkpnt_id,'MEP_INDICES')
    call mh5_resize_dset(dsetid,[iMEP])
    call mh5_put_dset(dsetid,[Iter_all],[1],[iMEP-1])
    call mh5_close_dset(dsetid)
  end if
# else
# include "macros.fh"
  unused_var(SaveMEP)
  unused_var(IRCRestart)
# endif
end subroutine Chkpnt_update_MEP

subroutine Chkpnt_close()
# ifdef _HDF5_
  call mh5_close_file(chkpnt_id)
# endif
end subroutine Chkpnt_close

end module Chkpnt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine vbgenabdet_cvb(idetavb,idetbvb,
     >  iconfs,nconf,nconfion,
     >  ndetvb,nel,noe,
     >  nalf,nbet,norb)
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension idetavb(ndetvb),idetbvb(ndetvb)
      dimension iconfs(noe,nconf),nconfion(0:nel)

      i1 = mstacki_cvb((norb+1)*(nalf+1))
      i2 = mstacki_cvb((norb+1)*(nbet+1))
      i3 = mstacki_cvb(norb+1)
      i4 = mstacki_cvb(norb+1)
      i5 = mstacki_cvb(norb)
      i6 = mstacki_cvb(norb)
      call vbgenabdet2_cvb(idetavb,idetbvb,
     >  iconfs,nconf,nconfion,
     >  ndetvb,nel,noe,
     >  nalf,nbet,norb,
     >  iw(i1),iw(i2),iw(i3),iw(i4),
     >  iw(i5),iw(i6))
      call mfreei_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine MASSES(IAN,IMN,ANAME,MASS)
!***********************************************************************
!** For isotope with (input) atomic number IAN and mass number IMN,
!  return (output):  (i) as the right-adjusted 2-character variable ANAME
!  the alphabetic symbol for that element, and (ii) the atomic mass MASS
!  [amu].
!** If the input value of IMN does not equal one of the tabulated values
!  for atomic species IAN, return the abundance-averaged standard atomic
!  weight of that atom
!***********************************************************************

use Isotopes, only: ElementList, Initialize_Isotopes, MaxAtomNum
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ian
integer(kind=iwp), intent(inout) :: imn
character(len=2), intent(out) :: ANAME
real(kind=wp), intent(out) :: mass
integer(kind=iwp) :: i, n

call Initialize_Isotopes()

if ((IAN <= 0) .or. (IAN > MaxAtomNum)) then
  MASS = Zero
  ANAME = 'XX'
  IMN = 0
  write(u6,601) IAN
  return
else
  ANAME = adjustr(ElementList(IAN)%Symbol)
end if
if ((IAN == 1)) then
  ! Special case: insert common name for deuterium or tritium
  if (IMN == 2) ANAME = ' D'
  if (IMN == 3) ANAME = ' T'
end if
MASS = -One
do I=1,size(ElementList(IAN)%Isotopes)
  if (IMN == ElementList(IAN)%Isotopes(I)%A) then
    MASS = ElementList(IAN)%Isotopes(I)%m
    exit
  end if
end do
if (MASS < Zero) then
  n = ElementList(IAN)%Natural
  if (n < 1) then
    MASS = ElementList(IAN)%Isotopes(1)%m
  else
    MASS = sum(ElementList(IAN)%Isotopes(1:n)%m*ElementList(IAN)%Isotopes(1:n)%x)
  end if
  if (IMN /= 0) then
    write(u6,602) ANAME,IMN
    IMN = 0
  end if
end if

return

601 format(' *** Isotopes database does not include Atomic Number=',i4)
602 format(' *** Isotopes database does not include ',A2,'(',i3,'), so use average atomic mass.')

end subroutine MASSES

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_ComputeU(AP_QD,nD,ip_DBlocks,U)
! Thomas Bondo Pedersen, January 2011.
!
! Purpose: compute
!
!      U = sum_uv sqrt[(Delta(uv)|Delta(uv))]*|D(uv)|
!
! Note: diagonal integrals for A=B must be stored quadratically.

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: AP_QD(*), nD, ip_DBlocks(nD)
real(kind=wp), intent(out) :: U(nD)
integer(kind=iwp) :: iD, AB, A, B, nA, nB, uv, ipDel, ipDB
integer(kind=iwp), external :: LDF_nBas_Atom
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

do iD=1,nD
  U(iD) = Zero
  do AB=1,NumberOfAtomPairs
    A = iWork(ip_AP_Atoms-1+2*(AB-1)+1)
    B = iWork(ip_AP_Atoms-1+2*(AB-1)+2)
    nA = LDF_nBas_Atom(A)
    nB = LDF_nBas_Atom(B)
    ipDel = AP_QD(AB)-1
    ipDB = iWork(ip_DBlocks(iD)-1+AB)-1
    do uv=1,nA*nB
      U(iD) = U(iD)+sqrt(Work(ipDel+uv))*abs(Work(ipDB+uv))
    end do
  end do
end do

end subroutine LDF_ComputeU

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Cho_Amatrix(XMAT,nXMAT,CMO,NCMO,DDTR,NATR)
! Calculation of the "exchange" matrix for the G1,G2,G3 Fock operators
! from Cholesky vectors

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use CHOVEC_IO, only: NVLOC_CHOBATCH
use caspt2_module, only: nAsh, nBtch, nBtches, nIsh, nOrb, nOSqT, nSsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nXMAT, nCMO, NATR
real(kind=wp), intent(inout) :: XMAT(nXMAT)
real(kind=wp), intent(in) :: CMO(nCMO), DDTR(NATR)
integer(kind=iwp) :: I, IB1, IB2, IBGRP, ISYM, J, JSYM, MXBGRP, MXCHOBUF, MXINT, MXPIQK, NADDBUFF, NBUF, NCHOBUF, NINTS, NLB, NLK, &
                     NV
type(DSBA_Type) :: HDSQ
integer(kind=iwp), allocatable :: BGRP(:,:,:), ICA(:), ICI(:), ICV(:), IXMAT(:), NBGRP(:), NVEC(:,:)
real(kind=wp), allocatable :: BRABUF(:), KETBUF(:)
real(kind=wp), allocatable, target :: INTBUF(:)
integer(kind=iwp), parameter :: Inac = 1, Acti = 2, Virt = 3

! Transform Cholesky vectors, this will have to be redone after
! the modified Fock matrix is diagonalized
call TRACHO3(CMO,NCMO)

! Square (Dd) to simplify multiplication
call Allocate_DT(HDSQ,NASH,NASH,NSYM,Label='HDSQ')
I = 1
do ISYM=1,NSYM
  call Square(DDTR(I),HDSQ%Sb(ISYM)%A1,1,NASH(ISYM),NASH(ISYM))
  I = I+nTri_Elem(NASH(ISYM))
end do
! To include a 1/2 factor in the final matrix, just scale (Dd)
HDSQ%A0(:) = Half*HDSQ%A0(:)

! Get offsets and sizes
call mma_allocate(IXMAT,NSYM,Label='IXMAT')
call mma_allocate(NBGRP,NSYM,Label='NBGRP')
MXINT = 0
MXBGRP = 0
do ISYM=1,NSYM
  ! Offsets of symmetry blocks in XMAT
  if (ISYM == 1) then
    IXMAT(ISYM) = 1
  else
    IXMAT(ISYM) = IXMAT(ISYM-1)+NORB(ISYM-1)**2
  end if
  ! Max size for integral matrix
  do JSYM=1,NSYM
    I = Mul(ISYM,JSYM)
    NINTS = max(NISH(I),NASH(I),NSSH(I))
    MXINT = max(MXINT,(NINTS*NASH(JSYM))**2)
  end do
  MXBGRP = max(MXBGRP,NBTCH(ISYM))
end do
call mma_allocate(INTBUF,MXINT,Label='INTBUF')
call mma_allocate(BGRP,2,MXBGRP,NSYM,Label='BGRP')
MXBGRP = 0
MXCHOBUF = 0
do ISYM=1,NSYM
  ! Batch groups per symmetry
  NBGRP(ISYM) = NBTCH(ISYM)
  do I=1,NBGRP(ISYM)
    BGRP(:,I,ISYM) = NBTCHES(ISYM)+I
  end do
  ! Max size for Cholesky vectors
  call MEMORY_ESTIMATE(ISYM,BGRP(:,:,ISYM),NBGRP(ISYM),NCHOBUF,MXPIQK,NADDBUFF)
  MXBGRP = max(MXBGRP,NBGRP(ISYM))
  MXCHOBUF = max(MXCHOBUF,NCHOBUF)
end do
! Number of Cholesky vectors per group and symmetry
call mma_allocate(NVEC,MXBGRP,NSYM,Label='NVEC')
do ISYM=1,NSYM
  do IBGRP=1,NBGRP(ISYM)
    NVEC(IBGRP,ISYM) = sum(NVLOC_CHOBATCH(BGRP(1,IBGRP,ISYM):BGRP(2,IBGRP,ISYM)))
  end do
end do

call mma_allocate(BRABUF,MXCHOBUF,Label='BRABUF')
call mma_allocate(KETBUF,MXCHOBUF,Label='KETBUF')

! Now fetch Cholesky vectors and accumulate the A_pq matrix
call mma_allocate(ICI,NSYM,Label='ICI')
call mma_allocate(ICA,NSYM,Label='ICA')
call mma_allocate(ICV,NSYM,Label='ICV')
do ISYM=1,NSYM
  ! Index of symmetry blocks in Cholesky vectors,
  ! according to the active orbital symmetry
  J = 0
  ICI(Mul(ISYM,1)) = J
  ICA(1) = 0
  ICV(1) = 0
  do JSYM=1,NSYM-1
    I = Mul(ISYM,JSYM)
    J = J+NISH(JSYM)*NASH(I)
    ICI(Mul(ISYM,JSYM+1)) = J
    ICA(JSYM+1) = ICA(JSYM)+NASH(JSYM)*NASH(I)
    ICV(JSYM+1) = ICV(JSYM)+NASH(JSYM)*NSSH(I)
  end do
  do IBGRP=1,NBGRP(ISYM)
    IB1 = BGRP(1,IBGRP,ISYM)
    IB2 = BGRP(2,IBGRP,ISYM)
    NV = NVEC(IBGRP,ISYM)
    if (NV == 0) exit
    ! Inactive-Inactive
    call Get_Cholesky_Vectors(Inac,Acti,ISYM,BRABUF,size(BRABUF),NBUF,IB1,IB2)
    call Accum(Inac,Inac,BRABUF,size(BRABUF),BRABUF,size(BRABUF),ICI,ICI)
    ! Inactive-Active
    call Get_Cholesky_Vectors(Acti,Acti,ISYM,KETBUF,size(KETBUF),NBUF,IB1,IB2)
    call Accum(Inac,Acti,BRABUF,size(BRABUF),KETBUF,size(KETBUF),ICI,ICA)
    ! Active-Active
    call Accum(Acti,Acti,KETBUF,size(KETBUF),KETBUF,size(KETBUF),ICA,ICA)
    ! Inactive-Virtual
    call Get_Cholesky_Vectors(Virt,Acti,ISYM,KETBUF,size(KETBUF),NBUF,IB1,IB2)
    call Accum(Inac,Virt,BRABUF,size(BRABUF),KETBUF,size(KETBUF),ICI,ICV)
    ! Virtual-Virtual
    call Accum(Virt,Virt,KETBUF,size(KETBUF),KETBUF,size(KETBUF),ICV,ICV)
    ! Active-Virtual
    ! We could have saved these Cholesky vectors,
    ! but there's joy in repetition
    call Get_Cholesky_Vectors(Acti,Acti,ISYM,BRABUF,size(BRABUF),NBUF,IB1,IB2)
    call Accum(Acti,Virt,BRABUF,size(BRABUF),KETBUF,size(KETBUF),ICA,ICV)
  end do
end do

call GADGOp(XMAT,NOSQT,'+')

call Deallocate_DT(HDSQ)
call mma_deallocate(IXMAT)
call mma_deallocate(NBGRP)
call mma_deallocate(BGRP)
call mma_deallocate(NVEC)
call mma_deallocate(BRABUF)
call mma_deallocate(KETBUF)
call mma_deallocate(INTBUF)
call mma_deallocate(ICI)
call mma_deallocate(ICA)
call mma_deallocate(ICV)

contains

subroutine Accum(bBlock,kBlock,bBuf,nbBuf,kBuf,nkBuf,IB,IK)

  integer(kind=iwp), intent(in) :: bBlock, kBlock, IB(NSYM), IK(NSYM)
  integer(kind=iwp), intent(in) :: nbBuf, nkBuf
  real(kind=wp), intent(in) :: bBuf(nbBuf), kBuf(nkBuf)
  integer(kind=iwp) :: B1, bOff(NSYM), BS, BSWCH, I, II, IJ, IJT, J, JA, JJ, K1, kOff(NSYM), KS, KSWCH, NA, NB(NSYM), NK(NSYM), &
                       PQSYM, TUSYM
  logical(kind=iwp) :: diag
  real(kind=wp), pointer, contiguous :: INT2(:,:)
  real(kind=wp), external :: dDot_

  ! NB,NK = number of orbitals in bra/ket (not including NA factor)
  ! bOff,kOff = offset or starting orbital in bra/ket
  ! QB,QK = index function for bra/ket
  ! BSWCH,KSWCH = aux switch for generalizing integral access
  !               (1 if inactive, which come before active)

  BSWCH = 0
  select case (bBlock)
    case (Inac)
      NB(:) = NISH(1:NSYM)
      bOff(:) = 0
      BSWCH = 1
    case (Acti)
      NB(:) = NASH(1:NSYM)
      bOff(:) = NISH(1:NSYM)
    case (Virt)
      NB(:) = NSSH(1:NSYM)
      bOff(:) = NISH(1:NSYM)+NASH(1:NSYM)
    case default ! Nothing compares 2 U
      ! (just to keep compilers happy)
      NB(:) = 0
      bOff(:) = 0
      call Abend()
  end select
  KSWCH = 0
  select case (kBlock)
    case (Inac)
      NK(:) = NISH(1:NSYM)
      kOff(:) = 0
      KSWCH = 1
    case (Acti)
      NK(:) = NASH(1:NSYM)
      kOff(:) = NISH(1:NSYM)
    case (Virt)
      NK(:) = NSSH(1:NSYM)
      kOff(:) = NISH(1:NSYM)+NASH(1:NSYM)
    case default
      NK(:) = 0
      kOff(:) = 0
      call Abend()
  end select
  ! Is this a diagonal block?
  diag = bBlock == kBlock

  ! We want (pt|qu) integrals of symmetry ISYM, with:
  !   t,u of symmetry TUSYM
  !   p,q of symmetry PQSYM
  do TUSYM=1,NSYM
    PQSYM = Mul(ISYM,TUSYM)
    NA = NASH(TUSYM)
    ! Reconstruct the (bBlock,Active|kBlock,Active) integrals
    NLB = NB(PQSYM)*NA
    NLK = NK(PQSYM)*NA
    call dgemm_('N','T',NLB,NLK,NV,One,bBUF(IB(TUSYM)*NV+1),NLB,kBUF(IK(TUSYM)*NV+1),NLK,Zero,INTBUF,NLB)
    if (NLB*NLK == 0) cycle
    INT2(1:NLB,1:NLK) => INTBUF(1:NLB*NLK)

    ! Accumulate A_pq = sum_tu (pt|qu)*(Dd)_tu
    ! BS,KS = step sizes for traversing active orbitals in INT2
    !         (= 1 if inactive, = NB,NK otherwise)
    BS = (NB(PQSYM)-1)*(1-BSWCH)+1
    KS = (NK(PQSYM)-1)*(1-KSWCH)+1
    ! B1,K1 = for getting the index of the 1st active orbital
    !         (= NA if inactive, = 1 otherwise)
    B1 = (NA-1)*BSWCH+1
    K1 = (NA-1)*KSWCH+1
    do J=1,NK(PQSYM)
      do I=1,NB(PQSYM)
        ! Index of this element in XMAT
        IJ = IXMAT(PQSYM)+(kOff(PQSYM)+J-1)*NORB(PQSYM)+bOff(PQSYM)+I-1
        ! Index of (p1|**) and (**|q1)
        II = (I-1)*B1+1
        JJ = (J-1)*K1+1
        do JA=1,NA
          XMAT(IJ) = XMAT(IJ)+dDot_(NA,INT2(II:,JJ),BS,HDSQ%SB(TUSYM)%A2(:,JA),1)
          JJ = JJ+KS
        end do
        ! Symmetric element
        if (diag .and. (I == J)) exit
        IJT = IXMAT(PQSYM)+(bOff(PQSYM)+I-1)*NORB(PQSYM)+kOff(PQSYM)+J-1
        XMAT(IJT) = XMAT(IJ)
      end do
    end do
    nullify(INT2)
  end do

end subroutine Accum

end subroutine Cho_Amatrix

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Bjorn O. Roos                                    *
*               2008, Valera Veryazov                                  *
************************************************************************
      subroutine expbas(ireturn)
************************************************************************
*                                                                      *
*     Objective: Expand MOs to larger basis set                        *
*                                                                      *
*     B. O. Roos, University of Lund, April 2008.                      *
*                                                                      *
************************************************************************
      Implicit real*8 (a-h,o-z)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "info_expbas.fh"
      Dimension nBas1(mxsym),nBas2(mxsym),Occ1(maxbfn),Eorb1(maxbfn),
     &          Occ2(maxbfn),Eorb2(maxbfn)
      Integer indt1(maxbfn),indt2(maxbfn),Indtype(56)
      Character*(LENIN8) Bas1(maxbfn),Bas2(maxbfn)
      Character*80 VecTit
      Character*512 FName
      Logical Exist_1,Exist_2,okay
*----------------------------------------------------------------------*
*     Start program and say Hello                                      *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*     Read information from Runfile 1                                  *
*----------------------------------------------------------------------*
      FName='RUNFIL1'
      iLen=mylen(FName)
      Call f_Inquire(FName(:iLen),Exist_1)
      If(.not.Exist_1) then
       Write (6,*) 'Error finding file '//FName(:iLen)
        Call Abend()
      Endif
      Call namerun(FName(:iLen))
      Call get_iScalar('nSym',nSym1)
      Call Get_iArray('nBas',nBas1,nSym1)
      nDim1=0
      nTot1=0
      Do iSym=1,nSym1
         nDim1=nDim1+nBas1(iSym)
         nTot1=nTot1+nBas1(iSym)**2
      End Do
      Call Get_cArray('Unique Basis Names',Bas1,(LENIN8)*nDim1)
*----------------------------------------------------------------------*
*     Read information from Runfile 2                                  *
*----------------------------------------------------------------------*
      FName='RUNFIL2'
      iLen=mylen(FName)
      Call f_Inquire(FName(:iLen),Exist_2)
      If(.not.Exist_2) then
       Write (6,*) 'Error finding file '//FName(:iLen)
        Call Abend()
      Endif
      Call namerun(FName(:iLen))
      Call get_iScalar('nSym',nSym2)
      Call Get_iArray('nBas',nBas2,nSym2)
      nDim2=0
      ntot2=0
      Do iSym=1,nSym2
         nDim2=nDim2+nBas2(iSym)
         ntot2=ntot2+nBas2(iSym)**2
      End Do
      Call Get_cArray('Unique Basis Names',Bas2,(LENIN8)*nDim2)
*----------------------------------------------------------------------*
*     Read MO coefficients from a formatted vector file                *
*----------------------------------------------------------------------*
      Call GetMem('CMO1','Allo','Real',ipCMO1,nTot1)
      Call GetMem('CMO2','Allo','Real',ipCMO2,nTot2)
      FName=EB_FileOrb
      If (mylen(FName).eq.0) FName='INPORB'
      iLen=mylen(FName)
      call f_Inquire (FName(:iLen),okay)
      If ( okay ) Then
        lOcc=0
        LuInpOrb=50
        Call RdVec(FName(:iLen),LuInpOrb,'COEI',
     &  nSym1,nBas1,nBas1,Work(ipCMO1),Occ1,Eorb1,indt1,VecTit,1,iErr)
      Else
        Write (6,*) 'RdCMO: Error finding MO file'
        Call Abend()
      End If

*----------------------------------------------------------------------*
*     Print and check input information                                *
*----------------------------------------------------------------------*
*      Write(6,910) 'Start of option expand.'
  910 Format(/1x,A)
      Write(6,1000) Vectit(:mylen(Vectit))
 1000 Format(/1x,'Header on input orbitals file:'/A)
      Write(6,910) 'Information from input runfile'
      Write(6,920) 'Number of symmetries',nSym1
  920 Format(1x,A30,8i5)
      Write(6,920) 'Number of basis functions',(nBas1(i),i=1,nSym1)
C
      Write(6,910) 'Information from expanded basis set runfile'
      Write(6,920) 'Number of symmetries',nSym2
      Write(6,920) 'Number of basis functions',(nBas2(i),i=1,nSym2)
C     Check for inconsistensies:
      If(nSym1.ne.nSym2) then
       write(6,*) 'Symmetries are not equal. Stop here',nSym1, nSym2
       Call Abend()
      Endif
      Do isym=1,nSym1
       if(nBas1(isym).gt.nBas2(isym)) then
        write(6,*) 'Second basis set must be larger than first'
        write(6,*) 'not fulfilled in sym',isym,'basis functions are',
     &  nBas1(isym),nBas2(isym)
        Call Abend()
       Endif
      Enddo
*----------------------------------------------------------------------*
*     Build the new orbitals                                           *
*----------------------------------------------------------------------*
      ist1=0
      ist2=0
      ib1=1
      ib2=1
      Do isym=1,nsym1
       nb1=nBas1(isym)
       nb2=nBas2(isym)
       If(nb2.gt.0) then
        call expandbas(Bas1(ib1),nb1,Bas2(ib2),nb2,
     & Work(ist1+ipCMO1),Work(ist2+ipCMO2),occ1(ib1),eorb1(ib1),
     & indt1(ib1),occ2(ib2),eorb2(ib2),indt2(ib2))
        ist1=ist1+nb1**2
        ist2=ist2+nb2**2
        ib1=ib1+nb1
        ib2=ib2+nb2
       Endif
      Enddo
*----------------------------------------------------------------------*
*     Write the new orbitals in to the file EXPORB                     *
*----------------------------------------------------------------------*
C     First resort indt to standard
C
      Do i=1,56
       Indtype(i)=0
      Enddo
      ind=0
      ishift=0
      Do isym=1,nSym2
       nb2=nBas2(isym)
       if(nb2.ne.0) then
        Do ib2=1,nb2
         ind=ind+1
         Indtype(ishift+indt2(ind))=Indtype(ishift+indt2(ind))+1
        Enddo
       Endif
       ishift=ishift+7
      Enddo
C
      VecTit='Basis set expanded orbital file EXPORB'
      Lu_=60
      Call WRVEC('EXPORB',LU_,'COEI',nSym2,nBas2,nBas2,Work(ipCMO2),
     & occ2,eorb2,Indtype,VecTit)
      Write(6,*)'New orbitals have been built in file EXPORB'
*----------------------------------------------------------------------*
*     Normal termination                                               *
*----------------------------------------------------------------------*
      Call GetMem('CMO1','Free','Real',ipCMO1,nTot2)
      Call GetMem('CMO2','Free','Real',ipCMO2,nTot2)
*
      ireturn=0
      return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine OrbFiles_m(JOBIPH,IPRLEV)
      Implicit Real*8 (a-h,o-z)
#include "rasdim.fh"
#include "output_ras.fh"
#include "rasscf.fh"
#include "gas.fh"
#include "WrkSpc.fh"
c***********************************************************************
      Real*8 Energy
      Integer ipEne,ipOcc
      Character*80 VecTyp
      Character*128 Filename
      Dimension IndType(56)
      Integer nBas(mxSym),nFro(mxSym),nDel(mxSym),nAsh(mxSym)
      Integer nIsh(mxSym),nRs1(mxSym),nRs2(mxSym),nRs3(mxSym)

* This routine is used at normal end of a RASSCF optimization, or
* when using the OrbOnly keyword to create orbital files.
*-------------------------------------------------------------------
* NOTE:
* PAM 2008: Before this subroutine replaced RASREAD, the orbital energies
* were sent as subroutine argument when rasread was called from rasscf.
* But the real argument, in rasscf, was FDIAG, which turns out to be a
* fixed array FDIAG(mxorb) in rasscf.fh.
* Rather than checking why that array is there, and how the values are
* put there, I simply use the array FDIAG in rasscf.fh, when needing
* orbital energies to WrVec calls. This may need checking later...
*----------------------------------------------------------------------*
*     Read the JobIph file to get the required information             *
*----------------------------------------------------------------------*
* PAM Jan 2014 -- do not take POTNUC from JOBIPH; take it directly
* from runfile, where it was stored by seward.
      iDisk=0
      Call iDaFile(JobIph,2,iToc,15,iDisk)
      iDisk=iToc(1)
      Call WR_RASSCF_Info(JobIph,2,iDisk,
     &                    nActEl,iSpin,nSym,lSym,
     &                    nFro,nIsh,nAsh,nDel,
     &                    nBas,mxSym,Name,LENIN8*mxOrb,nConf,
     &                    Header,144,Title,4*18*mxTit,PotNucDummy,
     &                    lRoots,nRoots,iRoot,mxRoot,
     &                    nRs1,nRs2,nRs3,
     &                    nHole1,nElec3,iPt2,Weight)
      ntot=0
      ntot2=0
      Do iSym=1,nSym
         ntot=ntot+nBas(iSym)
         ntot2=ntot2+nBas(iSym)*nBas(iSym)
      End Do
*----------------------------------------------------------------------*
*     Allocate CMO array                                               *
*----------------------------------------------------------------------*
      call getmem('CMO','allo','real',LCMO,ntot2)
      call getmem('Occ','allo','real',ipOcc,ntot)
*----------------------------------------------------------------------*
*     Make typeindex information                                       *
*----------------------------------------------------------------------*
      iShift=0
      DO ISYM=1,NSYM
        IndT=0
        IndType(1+iShift)= NFRO(ISYM)
        IndT=IndT+NFRO(ISYM)
        IndType(2+iShift)= NISH(ISYM)
        IndT=IndT+NISH(ISYM)
        If (.not. iDoGas) Then
         IndType(3+iShift)= NRS1(ISYM)
         IndT=IndT+NRS1(ISYM)
         IndType(4+iShift)= NRS2(ISYM)
         IndT=IndT+NRS2(ISYM)
         IndType(5+iShift)= NRS3(ISYM)
         IndT=IndT+NRS3(ISYM)
        Else
         IndType(3+iShift)=0
         NGAST=SUM(NGSSH(1:NGAS,ISYM))
         IndType(4+iShift)=ngast
         IndT=IndT+ngast
         IndType(5+iShift)=0
        End If
        IndType(7+iShift)= NDEL(ISYM)
        IndT=IndT+NDEL(ISYM)
        IndType(6+iShift)= NBAS(ISYM)-IndT
        iShift=iShift+7
      EndDo
*----------------------------------------------------------------------*
*     First, write MCSCF orbitals to RasOrb.                           *
*----------------------------------------------------------------------*
* IORBTYP=1 for 'Average' orbitals, Default.
* IORBTYP=2 for 'Canonical' orbitals.
* IORBTYP=3 or 4 goes unchecked, treated as default case.
      iDisk=iToc(2)
      filename='RASORB'
      Call dDaFile(JobIph,2,Work(lCMO),ntot2,iDisk)
      If ( iOrbTyp.ne.2 ) then
         IF(IPRLEV.GE.USUAL)Write(LF,'(6X,3A)')
     &   'Average orbitals are written to the ',
     &   trim(filename),' file'
         Write(VecTyp,'(A)')
     &   '* RASSCF average (pseudo-natural) orbitals'
         Call dDaFile(JobIph,2,Work(ipOcc),ntot,iDisk)
      Else
         IF(IPRLEV.GE.USUAL)Write(LF,'(6X,3A)')
     &   'Canonical orbitals are written to the ',
     &   trim(filename),' file'
         Write(VecTyp,'(A)')
     &   '* RASSCF canonical orbitals for CASPT2'
         call dcopy_(ntot,[1.0D0],0,Work(ipOcc),1)
      End If
*----------------------------------------------------------------------*
*     Write  orbitals                                                  *
*----------------------------------------------------------------------*
      LuvvVec=50
      LuvvVec=isfreeunit(LuvvVec)
c      Call WrVec(filename,LuvvVec,'COE',nSym,nBas,nBas,
c     &  Work(lCMO), Work(ipOcc), FDIAG, iDummy,VecTyp)
      Call WrVec_(filename,LuvvVec,'COET',0,nSym,nBas,nBas,
     &            Work(lCMO),Work(lCMO),
     &            Work(ipOcc),Work(ipOcc),
     &            FDIAG,[E2act],
     &            indType,VecTyp,0)
c      Call WrVec(filename,LuvvVec,'AI',NSYM,NBAS,NBAS,
c     & Work(lCMO), Work(ipOcc), FDIAG, IndType,VecTyp)
      Call WrVec_(filename,LuvvVec,'AIT',0,nSym,nBas,nBas,
     &            Work(lCMO),Work(lCMO),
     &            Work(ipOcc),Work(ipOcc),
     &            FDIAG,[E2act],
     &            indType,VecTyp,0)
*----------------------------------------------------------------------*
*     Second, write natural orbitals
*----------------------------------------------------------------------*
      iDisk=iToc(6)
      Call GetMem('Ene','Allo','Real',ipEne,mxRoot*mxIter)
      Call dDaFile(JobIph,2,Work(ipEne),mxRoot*mxIter,iDisk)

      iDisk=iToc(12)
      DO IRT=1,MIN(MAXORBOUT,LROOTS,999)
* Clumsy but simple way of getting the state energies:
        Do i=1,mxIter
          If (Work(ipEne+(i-1)*mxRoot+IRT-1).eq.0.0D0) Go To 11
          Energy = Work(ipEne+(i-1)*mxRoot+IRT-1)
        End Do
  11    Continue
        IF(IRT.LE.9) THEN
          Write(filename,'(A7,I1)') 'RASORB.',IRT
        ELSE IF(IRT.LE.99) THEN
          Write(filename,'(A7,I2)') 'RASORB.',IRT
        ELSE IF(IRT.LE.999) THEN
          Write(filename,'(A7,I3)') 'RASORB.',IRT
        ELSE
          filename = 'RASORB.x'
        END IF
        Call dDaFile(JobIph,2,Work(lCMO),ntot2,iDisk)
        Call dDaFile(JobIph,2,Work(ipOcc),ntot,iDisk)
        IF(IPRLEV.GE.USUAL)Write(LF,'(6X,A,I3,3A)')
     &   'Natural orbitals for root ',IRT,
     &   ' are written to the ',trim(filename),' file'
         Write(VecTyp,'(A41,I3,A3,f22.12)')
     &   '* RASSCF natural orbitals for root number',IRT,
     &   ' E=',Energy
*----------------------------------------------------------------------*
*     Write  orbitals                                                  *
*----------------------------------------------------------------------*
        LuvvVec=50
        LuvvVec=isfreeunit(LuvvVec)
        Call WrVec(filename,LuvvVec,'COE',nSym,nBas,nBas,
     &    Work(lCMO), Work(ipOcc), FDIAG, IndType,VecTyp)
        Call WrVec(filename,LuvvVec,'AI',NSYM,NBAS,NBAS,
     &   Work(lCMO), Work(ipOcc), FDIAG, IndType,VecTyp)
      END DO
      Call GetMem('Ene','Free','Real',ipEne,mxRoot*mxIter)
*----------------------------------------------------------------------*
*     Third, write spin density orbitals
*----------------------------------------------------------------------*
      iDisk=iToc(14)
      Call GetMem('EDummy','Allo','Real',LEDum,NTot)
      call dcopy_(NTot,[0.0D0],0,Work(LEDum),1)
      DO IRT=1,MIN(MAXORBOUT,LROOTS,999)
        IF(IRT.LE.9) THEN
          Write(filename,'(A7,I1)') 'SPDORB.',IRT
        ELSE IF(IRT.LE.99) THEN
          Write(filename,'(A7,I2)') 'SPDORB.',IRT
        ELSE IF(IRT.LE.999) THEN
          Write(filename,'(A7,I3)') 'SPDORB.',IRT
        ELSE
          filename = 'SPDORB.x'
        END IF
        Call dDaFile(JobIph,2,Work(lCMO),ntot2,iDisk)
        Call dDaFile(JobIph,2,Work(ipOcc),ntot,iDisk)
        IF(IPRLEV.GE.USUAL)Write(LF,'(6X,A,I3,3A)')
     &   'Spin density orbitals for root ',IRT,
     &   ' are written to the ',trim(filename),' file'
        Write(VecTyp,'(A,I3)')
     &   '* RASSCF spin density orbitals for root number',IRT
*----------------------------------------------------------------------*
*     Write  orbitals                                                  *
*----------------------------------------------------------------------*
        LuvvVec=50
        LuvvVec=isfreeunit(LuvvVec)
        Call WrVec(filename,LuvvVec,'CEO',nSym,nBas,nBas,
     &    Work(lCMO), Work(ipOcc), Work(LEDum), IndType,VecTyp)
        Call WrVec(filename,LuvvVec,'AI',NSYM,NBAS,NBAS,
     &   Work(lCMO), Work(ipOcc), Work(LEDum), IndType,VecTyp)
      END DO
      Call GetMem('EDummy','Free','Real',LEDUM,NTOT)
*----------------------------------------------------------------------*
*     Normal Exit                                                      *
*----------------------------------------------------------------------*
      call getmem('CMO','free','real',LCMO,ntot2)
      call getmem('Occ','free','real',ipOcc,ntot)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine Angles(Lbls,xyz,mCentr,rtrnc,Max_Center)
!***********************************************************************
!                                                                      *
! Object: to compute angles from a list of coordinates.                *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use Molcas, only: LenIn
use Constants, only: Zero, One, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: mCentr, Max_Center
character(len=LenIn) Lbls(mCentr)
real(kind=wp) :: xyz(3,mCentr), rtrnc
integer(kind=iwp) :: ic, jc, kc
logical(kind=iwp) :: tp
real(kind=wp) :: Arg, Phi, r1, r2, x1, x2, x3, y1, y2, y3, z1, z2, z3

if (mCentr > Max_Center) return

tp = .false.
! The center atom
do ic=1,mCentr
  x1 = xyz(1,ic)
  y1 = xyz(2,ic)
  z1 = xyz(3,ic)
  do jc=1,mCentr
    if (jc == ic) cycle
    x2 = xyz(1,jc)
    y2 = xyz(2,jc)
    z2 = xyz(3,jc)
    r1 = sqrt((x2-x1)**2+(y2-y1)**2+(z2-z1)**2)
    if (r1 > rtrnc .or. r1 == Zero) cycle
    do kc=jc+1,mCentr
      if (kc == ic) cycle
      x3 = xyz(1,kc)
      y3 = xyz(2,kc)
      z3 = xyz(3,kc)
      r2 = sqrt((x3-x1)**2+(y3-y1)**2+(z3-z1)**2)
      if (r2 > rtrnc .or. r2 == Zero) cycle
      arg = ((x2-x1)*(x3-x1)+(y2-y1)*(y3-y1)+(z2-z1)*(z3-z1))/(r1*r2)
      if (abs(arg) > One) arg = sign(One,arg)
      Phi = acos(arg)/deg2rad
      if (.not. tp) then
        tp = .true.
        write(u6,*)
        write(u6,'(19X,A)') ' ************************************** '
        write(u6,'(19X,A)') ' *    Valence Bond Angles / degree    * '
        write(u6,'(19X,A)') ' ************************************** '
        write(u6,'(19X,A)') '       Atom centers                 Phi'
      end if
      write(u6,'(21X,3(I2,1X,A,2X),1X,F6.2)') jc,Lbls(jc),ic,Lbls(ic),kc,Lbls(kc),Phi
    end do
  end do
end do

return

end subroutine Angles

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine TRDNS1(IVEC,DPT1,NDPT1)
! Add to the transition density matrix DPT1,
!    DPT1(p,q) = Add <IVEC| E(p,q) |0>.
! where IVEC stands for the 1st-order perturbed CASPT2
! wave function stored as vector nr IVEC on LUSOLV.
! DPT1 is stored as symmetry-blocked array of square matrices.
! Each square matrix is actually lower block triangle, but is
! stored in full, including zero elements.

! Only cases A, C and D(Symm 1) contributes.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, King
#endif
use fake_GA, only: GA_Arrays
use caspt2_module, only: nActel, nAsh, nAsh, nASup, nInDep, nIsh, nISup, nOrb, nSsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, NDPT1
real(kind=wp), intent(inout) :: DPT1(NDPT1)
integer(kind=iwp) :: IA, ICASE, ID, IDOFF, II, IMLTOP, ISYM, IT, ITTOT, IW, IWAI, IWAT, IWOFF, IWTI, lVec, NA, NAS, NI, NIS, NO, &
                     NS, NVEC, NWAI, NWAT, NWTI
real(kind=wp) :: FACT
real(kind=wp), allocatable :: WAI(:), WAT(:), WTI(:)
#ifdef _MOLCAS_MPP_
real(kind=wp), allocatable :: TMP(:)
#endif

! Transform to standard representation, covariant form.
call PTRTOC(1,IVEC,IVEC)

NWTI = sum(NASH(1:NSYM)*NISH(1:NSYM))
NWAI = sum(NSSH(1:NSYM)*NISH(1:NSYM))
NWAT = sum(NSSH(1:NSYM)*NASH(1:NSYM))

IMLTOP = 1
if (NWTI /= 0) then
  call mma_allocate(WTI,NWTI,LABEL='WTI')
  WTI(:) = Zero
  ICASE = 1
  IWOFF = 1
  do ISYM=1,NSYM
    if (NINDEP(ISYM,ICASE) == 0) cycle
    NIS = NISUP(ISYM,ICASE)
    NAS = NASUP(ISYM,ICASE)
    NVEC = NIS*NAS
    if (NVEC == 0) cycle
    call RHS_ALLO(NAS,NIS,LVEC)
    call RHS_READ(NAS,NIS,LVEC,ICASE,ISYM,IVEC)
    FACT = One/real(max(1,NACTEL),kind=wp)
#   ifdef _MOLCAS_MPP_
    if (IS_REAL_PAR()) then
      if (KING()) then
        call mma_allocate(TMP,NVEC,Label='TMP')
        call RHS_GET(NAS,NIS,LVEC,TMP)
        call SPEC1A(IMLTOP,FACT,ISYM,TMP,size(TMP),WTI(IWOFF),size(WTI(IWOFF:)))
        call mma_deallocate(TMP)
      end if
    else
#   endif
      call SPEC1A(IMLTOP,FACT,ISYM,GA_Arrays(LVEC)%A,size(GA_Arrays(LVEC)%A),WTI(IWOFF),size(WTI(IWOFF:)))
#   ifdef _MOLCAS_MPP_
    end if
#   endif
    call RHS_FREE(LVEC)
    IWOFF = IWOFF+NASH(ISYM)*NISH(ISYM)
  end do
end if

if (NWAT /= 0) then
  call mma_allocate(WAT,NWAT,Label='WAT')
  WAT(:) = Zero
  ICASE = 4
  IWOFF = 1
  do ISYM=1,NSYM
    if (NINDEP(ISYM,ICASE) == 0) cycle
    NIS = NISUP(ISYM,ICASE)
    NAS = NASUP(ISYM,ICASE)
    NVEC = NIS*NAS
    if (NVEC == 0) cycle
    if (NSSH(ISYM)*NASH(ISYM) == 0) cycle
    call RHS_ALLO(NAS,NIS,LVEC)
    call RHS_READ(NAS,NIS,LVEC,ICASE,ISYM,IVEC)
    FACT = One/real(max(1,NACTEL),kind=wp)
#   ifdef _MOLCAS_MPP_
    if (IS_REAL_PAR()) then
      if (KING()) then
        call mma_allocate(TMP,NVEC,LABEL='TMP')
        call RHS_GET(NAS,NIS,LVEC,TMP)
        call SPEC1C(IMLTOP,FACT,ISYM,TMP,size(TMP),WAT(IWOFF),size(WAT(IWOFF:)))
        call mma_deallocate(TMP)
      end if
    else
#   endif
      call SPEC1C(IMLTOP,FACT,ISYM,GA_Arrays(LVEC)%A,size(GA_Arrays(LVEC)%A),WAT(IWOFF),size(WAT(IWOFF:)))
#   ifdef _MOLCAS_MPP_
    end if
#   endif
    call RHS_FREE(LVEC)
    IWOFF = IWOFF+NSSH(ISYM)*NASH(ISYM)
  end do
end if

if (NWAI /= 0) then
  call mma_allocate(WAI,NWAI,Label='WAI')
  WAI(:) = Zero
  ICASE = 5
  do ISYM=1,1
    if (NINDEP(ISYM,ICASE) == 0) cycle
    NIS = NISUP(ISYM,ICASE)
    NAS = NASUP(ISYM,ICASE)
    NVEC = NIS*NAS
    if (NVEC == 0) cycle
    call RHS_ALLO(NAS,NIS,LVEC)
    call RHS_READ(NAS,NIS,LVEC,ICASE,ISYM,IVEC)
    FACT = One/real(max(1,NACTEL),kind=wp)
#   ifdef _MOLCAS_MPP_
    if (IS_REAL_PAR()) then
      if (KING()) then
        call mma_allocate(TMP,NVEC,LABEL='TMP')
        call RHS_GET(NAS,NIS,LVEC,TMP)
        call SPEC1D(IMLTOP,FACT,TMP,NVEC,WAI,NWAI)
        call mma_deallocate(TMP)
      end if
    else
#   endif
      call SPEC1D(IMLTOP,FACT,GA_Arrays(LVEC)%A,size(GA_Arrays(LVEC)%A),WAI,nWAI)
#   ifdef _MOLCAS_MPP_
    end if
#   endif
    call RHS_FREE(LVEC)
  end do
end if

! Transform vectors back to eigenbasis of H0(diag).
call PTRTOSR(0,IVEC,IVEC)

if (NWTI > 0) call GADGOP(WTI,NWTI,'+')
if (NWAI > 0) call GADGOP(WAI,NWAI,'+')
if (NWAT > 0) call GADGOP(WAT,NWAT,'+')
! Put transition density elements in temporaries W into
! proper positions, as subdiagonal matrices in DPT1:
IDOFF = 0
IWTI = 0
IWAI = 0
IWAT = 0
do ISYM=1,NSYM
  NI = NISH(ISYM)
  NA = NASH(ISYM)
  NS = NSSH(ISYM)
  NO = NORB(ISYM)
  do IT=1,NA
    ITTOT = IT+NI
    do II=1,NI
      ID = IDOFF+ITTOT+NO*(II-1)
      IW = IWTI+IT+NA*(II-1)
      DPT1(ID) = DPT1(ID)+WTI(IW)
    end do
  end do
  do IT=1,NA
    ITTOT = IT+NI
    ID = IDOFF+NI+NA+NO*(ITTOT-1)
    IW = IWAT+IT-NA
    do IA=1,NS
      ID = ID+1
      IW = IW+NA
      DPT1(ID) = DPT1(ID)+WAT(IW)
    end do
  end do
  do II=1,NI
    ID = IDOFF+NI+NA+NO*(II-1)
    IW = IWAI+II-NI
    do IA=1,NS
      ID = ID+1
      IW = IW+NI
      DPT1(ID) = DPT1(ID)+WAI(IW)
    end do
  end do
  IWTI = IWTI+NA*NI
  IWAI = IWAI+NS*NI
  IWAT = IWAT+NS*NA
  IDOFF = IDOFF+NO**2
end do

if (NWTI > 0) call mma_deallocate(WTI)
if (NWAI > 0) call mma_deallocate(WAI)
if (NWAT > 0) call mma_deallocate(WAT)

end subroutine TRDNS1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RmLDep(AMat,lDm,lth)
!***********************************************************************
!                                                                      *
!     purpose: Remove linear dependencies                              *
!                                                                      *
!     input:                                                           *
!       AMat    : matrix with linear dependencies (lDm,lDm)            *
!                                                                      *
!     output:                                                          *
!       AMat    : inverted matrix without linear dependencies (lDm,lDm)*
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: lDm, lth
real(kind=wp), intent(inout) :: AMat(lDm,lDm)
real(kind=wp) :: Dummy
integer(kind=iwp) :: i, iDum, iErr, ij, lthS, lthT, nFound
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: j
#endif
real(kind=wp), allocatable :: ATri(:), EVal(:), EVec(:), Scr(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

lthT = nTri_Elem(lth)
lthS = lth**2
call mma_allocate(ATri,lthT,Label='ATri')
call mma_allocate(EVec,lthS,Label='EVec')
call mma_allocate(EVal,lth,Label='EVal')

! Put a unit matrix into the eigenvectors work space
call unitmat(EVec,lth)

! Copy triangular part of AMat to work space
ij = 1
do i=1,lth
  ATri(ij:ij+i-1) = AMat(i,1:i)
  ij = ij+i
end do
#ifdef _DEBUGPRINT_
write(u6,*) ' Squared A-matrix in RmLDep:'
do i=1,lth
  write(u6,'(5(1x,es13.6))') (AMat(i,j),j=1,lth)
end do
write(u6,*) ' Triangular A-matrix:'
write(u6,'(5(1x,es13.6))') (ATri(i),i=1,lthT)
#endif

! Diagonalize
call mma_allocate(Scr,lth**2,Label='Scr')
Dummy = Zero
iDum = 0
call Diag_Driver('V','A','L',lth,ATri,Scr,lth,Dummy,Dummy,iDum,iDum,EVal,EVec,lth,1,0,'J',nFound,iErr)
call mma_deallocate(Scr)
#ifdef _DEBUGPRINT_
write(u6,*) ' Eigenvalues of A-matrix in RLnDep:'
write(u6,'(5(1x,es13.6))') (EVal(i),i=1,lth)
#endif

! Form the inverse
AMat(:,1:lth) = Zero
do i=1,lth
  if (EVal(i) > 1.0e-12_wp) then
    AMat(i,i) = One/EVal(i)
  else
    !write(u6,*) ' Eigenvalue',i,' smaller then 1.0e-12'
    AMat(i,i) = Zero
  end if
end do
call mma_allocate(Scr,lthS,Label='Scr')
call DGEMM_('N','T',lth,lth,lth, &
            One,AMat,lDm, &
            EVec,lth, &
            Zero,Scr,lth)
call DGEMM_('N','N',lth,lth,lth, &
            One,EVec,lth, &
            Scr,lth, &
            Zero,AMat,lDm)
call mma_deallocate(Scr)

call mma_deallocate(EVal)
call mma_deallocate(EVec)
call mma_deallocate(ATri)

end subroutine RmLDep

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994-1996, Martin Schuetz                              *
************************************************************************
************************************************************************
* This Module comprises 8 subroutines and 5 functions, which are all   *
* used to store, recall and administrate vectors from e.g. subsequent  *
* iterations, which can be assigned to an ordered keylist, e.g. to a   *
* list of iteration numbers.                                           *
* The internal data structure used to control the vectors is a linked  *
* list of nodes, each containing a pointer to the memory or disk       *
* location of the vector, together with some other information.        *
* The head of the list is a special node called CNOD which contains    *
* the following info:                                                  *
*     CNOD:    addr(CNOD)   -> error code, if 0: op performed OK       *
*              addr(CNOD)+1 -> ptr to first NODE in list (iroot)       *
*              addr(CNOD)+2 -> actual length of list (lislen)          *
*              addr(CNOD)+3 -> # of vectors wished to keep in memory   *
*                              (incore)                                *
*              addr(CNOD)+4 -> unused yet                              *
*              addr(CNOD)+5 -> unused yet                              *
* One NODE of the linked list itself contains six integers and is      *
* organized as follows:                                                *
*     NODE:    addr(NODE)   -> ptr to next node                        *
*              addr(NODE)+1 -> ptr to stored vector                    *
*              addr(NODE)+2 -> next free position, if on disk          *
*                              unused otherwise                        *
*              addr(NODE)+3 -> length of vector                        *
*              addr(NODE)+4 -> iteration number                        *
*              addr(NODE)+5 -> 1, if in core; 0, if on disk            *
* The 11 subroutines and functions operating on the linked lists have  *
* the following purposes:                                              *
* IniLst(LList,incore)                                                 *
*  -> initialize list                                                  *
* PutVec(vec,lvec,LUnit,iterat,NoAllo,opcode,LList)                    *
*  -> store vector on list, ev. move the tailnode vector on disk       *
* GetVec(LUnit,iterat,LList,inode,vec,lvec)                            *
*  -> fetch vector from list, which corresponds to iterat              *
* GetNod(iterat,LList,inode)                                           *
*  -> does not read out vector, just returns address of node in inode  *
* InfNod(inode,iterat,ipnext,ipvec,lvec)                               *
*  -> returns info of node indicated by inode                          *
* Logical InCore(inode)                                                *
*  -> returns true, if corresponding vector is incore, false otherwise *
* Integer iVPtr(LUnit,ivptr1,inode)                                    *
*  -> uses InfNod or GetVec to read out vector of inode, depending     *
*     if InCore or not. If the result is ivptr1, the vector was read   *
*     from disk. ivptr1 has to be allocated before (same vector length *
*     as stored in inode).                                             *
* Integer LstPtr(LUnit,iterat,LList)                                   *
*  -> uses GetNod and InfNod to get the pointer to the vector, which   *
*     corresponds to iterat. The pointer is the return value of the    *
*     function. If the vector is not InCore, the function terminates   *
*     with an Error message. This function is used only in cases,      *
*     where the vector for sure is stored in core (e.g. last entries   *
*     in LList).                                                       *
* Logical LLErr(LList)                                                 *
*  -> checks, if ErrCode was set in previous LL Operation              *
* Integer LLLen(LList)                                                 *
*  -> returns the actual length of the LL                              *
* KilLst(LList)                                                        *
*  -> kill list and free all memory                                    *
* DmpLst(LList,LUnit,lDskPt)                                           *
*  -> flush list and dump it on corresponding DA listfile              *
*     lDskPt: DA pointer where listnodes begin (on output)             *
* RclLst(LList,LUnit,lDskPt,NoAllo)                                    *
*  -> recall and restore list from corresponding DA listfile           *
*     lDskPt: DA pointer where listnodes begin  (on input)             *
*     NoAllo: amount of memory not to allocate...                      *
*----------------------------------------------------------------------*
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1994/96                              *
************************************************************************


      SubRoutine IniLst(iLList,incore)
      Implicit Real*8 (a-h,o-z)
      Integer iLList,incore
#include "real.fh"

#include "mxdm.fh"
#include "lnklst.fh"
*
      Debug_LnkLst=.False.
*
*     allocate list header CNOD
      lLList=lLList+1
      iLList=lLList
      nLList(iLList,0)=0
      nLList(iLList,1)=0
      nLList(iLList,2)=0
      nLList(iLList,3)=incore

*
      If (Debug_LnkLst) Then
         Write (6,*) 'IniLst'
         Call StlLst(iLList)
      End If
*
      Return
      End
*----------------------------------------------------------------------*


      SubRoutine PutVec(vec,lvec,LUnit,iterat,NoAllo,opcode,iLList)
*     NoAllo is the amount of memory (in DWords) one wants to keep
*     for other purposes.
*     opcode is a 4 character string:
*     'APND' -append nevertheless to list, if same iterat is found
*             on head node
*     'NOOP' -no operation, if same iterat is found on head node
*     'OVWR' -overwrite vector, if same iterat is found on head node
*             if lvec is different from lvec stored on node, old
*             vector is not overwritten and iWork(LList) is set to
*             ErrCode 1
*
      Implicit Real*8 (a-h,o-z)
*
*     declaration subroutine parameters
      Integer lvec,LUnit,iterat,iLList,NoAllo,iroot,lislen,incore
      Real*8 vec(lvec)
      Character opcode*4
*
*     declaration local variables
      Integer iPtr1,iPtr2,MaxMem
C     Integer iDskPt,len
*
#include "real.fh"
#include "WrkSpc.fh"
#include "mxdm.fh"
#include "lnklst.fh"

#include "SysDef.fh"
*
      If (Debug_LnkLst) Then
         Write (6,*) 'PutVec'
         Call StlLst(iLList)
      End If
*
*     clear ErrCode
      nLList(iLList,0)=0
*     read listhead
      iroot=nLList(iLList,1)
      lislen=nLList(iLList,2)
      incore=nLList(iLList,3)

      If ((iroot.gt.0).AND.(nLList(iroot,4).eq.iterat)) Then
        If (opcode.eq.'NOOP') Then
*         that's all, folks
          Return
        Else If (opcode.eq.'OVWR') Then
          If (nLList(iroot,3).ne.lvec) Then
* Set error code: inconsistency in vector lengths
            nLList(iLList,0)=1
          Else
            call dcopy_(lvec,vec,1,Work(nLList(iroot,1)),1)
          End If
          Return
        Else If (opcode.ne.'APND') Then
*         opcode unknown
          Write (6,*) 'PutVec: opcode unknown'
          Write (6,'(A,A)') 'opcode=',opcode
          Call Abend()
        End If
      End If
*     check if there is still enough memory to store vec
      Call GetMem('LVec ','Max','Real',iPtr1,MaxMem)
cvv Enough memory
*       let's allocate some memory
        Call GetMem('LVec ','Allo','Real',iPtr1,lvec)
*      End If
*     allocate new node
      lLList=lLList+1
      iPtr2=lLList
      nLList(iPtr2,0)=iroot
      nLList(iPtr2,1)=iPtr1
      nLList(iPtr2,2)=0
      nLList(iPtr2,3)=lvec
      nLList(iPtr2,4)=iterat
      nLList(iPtr2,5)=1


      call dcopy_(lvec,vec,1,Work(iPtr1),1)
      iroot=iPtr2
      lislen=lislen+1
      nLList(iLList,1)=iroot
      nLList(iLList,2)=lislen

*
      Return

#ifdef _WARNING_WORKAROUND_
      If (.False.) Then
         Call Unused_integer(LUnit)
         Call Unused_integer(NoAllo)
      End If
#endif
      End
*----------------------------------------------------------------------*


      SubRoutine GetVec(LUnit,iterat,iLList,inode,vec,lvec)
*     searches linked list for node corresponding to iterat, starting
*     from iroot=iWork(LList+1).
*     inode points to the node found after searching.
*     the vector stored at inode then is copied to vec, but only
*     if lvec is equal to the vector length stored in inode. Otherwise
*     the entry is considered as inconsistent.
*     inode is set to zero, if no entry was found, or to its negative
*     address, if an inconsistent entry was found.
*     if LList<0, then -LList is interpreted as a direct node address,
*     and not the address of the listhead (faster access).
      Implicit Real*8 (a-h,o-z)
*
*     declaration subroutine parameters
      Integer lvec,LUnit,iterat,iLList,inode
      Real*8 vec(lvec)
*
*     declaration local variables
c      Integer iDskPt
*
#include "real.fh"
#include "WrkSpc.fh"
#include "mxdm.fh"
#include "lnklst.fh"

#include "SysDef.fh"
*
*
        inode=nLList(iLList,1)

 100  If ((nLList(inode,4).ne.iterat).and.(nLList(inode,0).ne.0)) Then
        inode=nLList(inode,0)

        GoTo 100
      End If
      If (nLList(inode,4).eq.iterat) Then
*       we've found matching entry, so check if consistent
        If (nLList(inode,3).eq.lvec) Then
*         everything's allright, we made it, let's copy to vec
            call dcopy_(lvec,Work(nLList(inode,1)),1,vec,1)
        Else
* inconsistency
          write(6,*)' Found inconsistency.'
*          inode=-inode
          inode=0
        End If
      Else
        inode=0
      End If
*
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(LUnit)
#endif
      End
*----------------------------------------------------------------------*


      SubRoutine GetNod(iterat,iLList,inode)
*     searches linked list for node corresponding to iterat, starting
*     from iroot. inode points to the node found after searching.
*     inode is set to zero and iWork(LList)=0 is set to ErrCode 1,
*     if no correspondance was found.
      Implicit Real*8 (a-h,o-z)
*
*     declaration subroutine parameters
      Integer iterat,iLList,inode
*
#include "real.fh"
#include "mxdm.fh"
#include "lnklst.fh"

*
*
      If (Debug_LnkLst) Then
         Write (6,*) 'GetNod'
         Call StlLst(iLList)
      End If
*
*     clear ErrCode
      nLList(iLList,0)=0
*     set inode to iroot
      inode=nLList(iLList,1)

 100  If ((nLList(inode,4).ne.iterat).and.(nLList(inode,0).ne.0)) Then
        inode=nLList(inode,0)
        GoTo 100
      End If
      If (nLList(inode,4).eq.iterat) Then
*       we've found matching entry
      Else
        Write (6,*) 'GetNod: Warning!'
        inode=0
        nLList(iLList,0)=1
      End If
*
      End
*----------------------------------------------------------------------*


      SubRoutine InfNod(inode,iterat,ipnext,ipvec,lvec)
*     returns info of node indicated by inode. iterat,ipnext,ipvec,lvec
*     are overwritten with the corresponding info on the node
      Implicit Real*8 (a-h,o-z)
*
*     declaration of procedure parameters
      Integer inode,iterat,ipnext,ipvec,lvec
*

#include "mxdm.fh"
#include "lnklst.fh"
*
      iterat=nLList(inode,4)
      ipnext=nLList(inode,0)
      ipvec= nLList(inode,1)
      lvec=  nLList(inode,3)
*
      Return
      End
*----------------------------------------------------------------------*


      Logical Function InCore(inode)
*     returns true, if corresponding vector is incore, false otherwise
      Implicit Real*8 (a-h,o-z)
      Integer inode
*

#include "mxdm.fh"
#include "lnklst.fh"
*
      If (nLList(inode,5).eq.1) Then
        InCore=.TRUE.
      Else
        InCore=.FALSE.
      End If
      Return
      End
*----------------------------------------------------------------------*


      Logical Function LLErr(iLList)
*     checks, if ErrCode was set in previous LL Operation
      Implicit Real*8 (a-h,o-z)
      Integer iLList
*

#include "mxdm.fh"
#include "lnklst.fh"
*

      If (nLList(iLList,0).eq.0) Then
        LLErr=.FALSE.
      Else
        LLErr=.TRUE.
      End If
      Return
      End
*----------------------------------------------------------------------*


      Integer Function LLLen(iLList)
*     returns the actual length of the LL
      Implicit Real*8 (a-h,o-z)
      Integer iLList
*

#include "mxdm.fh"
#include "lnklst.fh"
*
      LLLen=nLList(iLList,2)
      Return
      End
*----------------------------------------------------------------------*


      Subroutine iVPtr(LUnit,vptr1,nvptr1,inode)
*     uses InfNod or GetVec to read out vector of inode, depending
*     if InCore or not. If the result is ivptr1, the vector was read
*     from disk. ivptr1 has to be allocated before (same vector length
*     as stored in inode). The return value points to the memory
*     location of the read vector. If the function fails (in GetVec),
*     the inode value of GetVec is returned.
*
*     2017-03-15:Converted to return the array in vptr1.
      Implicit Real*8 (a-h,o-z)
      Integer LUnit,nvptr1,ivptr2,inode,idum
      Logical InCore
      Real*8  vptr1(nvptr1)
*
#include "real.fh"
#include "WrkSpc.fh"
#include "mxdm.fh"
#include "lnklst.fh"
*
      If (InCore(inode)) Then
        Call InfNod(inode,idum,idum,ivptr2,idum)
        Call DCopy_(nvptr1,Work(ivptr2),1,vptr1,1)
      Else
        Call GetVec(LUnit,nLList(inode,4),inode,inode,
     &              vptr1,nLList(inode,3))
      End If
*
      Return
      End
*----------------------------------------------------------------------*


      Integer Function LstPtr(LUnit,iterat,iLList)
*     uses GetNod and InfNod to obtain the pointer to the vector, which
*     corresponds to iterat. The pointer is the return value of the
*     function. If the vector is not InCore, the function terminates
*     with an Error message. This function is used only in cases,
*     where the vector for sure is stored in core (e.g. last entries
*     in LList).
      Implicit Real*8 (a-h,o-z)
*
*     declaration subroutine parameters
      Integer LUnit,iterat,iLList
*
*     declaration local variables
      Integer inode,idum,ivptr
*     and functions
      Logical InCore
*
      LstPtr=-999999
      Call GetNod(iterat,iLList,inode)
      If (inode.eq.0) Then
* Hmmm, no entry found in LList, that's strange
        Write (6,*) 'LstPtr: inode.le.0'
        Write (6,*) 'inode=',inode
        Call Abend()
      Else If (InCore(inode)) Then
        Call InfNod(inode,idum,idum,ivptr,idum)
        LstPtr=ivptr
      Else
* Hmmm, no incore hit for this entry, that's strange
        Write (6,*) 'LstPtr: no incore hit for this entry'
        Write (6,*) 'inode=',inode
        Call Abend()
      End If

#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(LUnit)
#endif
      End
*----------------------------------------------------------------------*


      SubRoutine KilLst(iLList)
      Implicit Real*8 (a-h,o-z)
*     Free all memory of linked list LList
#include "real.fh"
#include "WrkSpc.fh"
#include "mxdm.fh"
#include "lnklst.fh"
*     local vars
      Integer iLList,iroot,iPtr1
*
*
      If (Debug_LnkLst) Then
         Write (6,*) 'KilLst'
         Call StlLst(iLList)
      End If
*
      iroot=nLList(iLList,1)
 100  Continue
      If (iroot.ne.0) Then
        iPtr1=nLList(iroot,1)
        iFlag=nLList(iroot,5)

        If (iFlag.eq.1) Then
          Call GetMem('LVec ','Free','Real',iPtr1,nLList(iroot,3))
        End If
        iPtr1=iroot
        iroot=nLList(iroot,0)
        GoTo 100
      End If
*
      End
*----------------------------------------------------------------------*


      SubRoutine DmpLst(iLList,LUnit,lDskPt)
      Implicit Real*8 (a-h,o-z)
      Integer iLList,LUnit,lDskPt
*
#include "WrkSpc.fh"
#include "mxdm.fh"
#include "lnklst.fh"

#include "SysDef.fh"
*
*     clear ErrCode
      nLList(iLList,0)=0
*     read listhead
      iroot=nLList(iLList,1)
      lislen=nLList(iLList,2)
      incore=nLList(iLList,3)

      If (iroot.le.0) Then
* linked list has zero length, that's strange
* save in any case listhead...
        lDskPt=0
        iDskPt=lDskPt
        Call iDaFile(LUnit,1,nLList(iLList,0),NodSiz,iDskPt)
*       Call GetMem('CNOD ','Free','Inte',LList,NodSiz)
        Return
      End If
 10   Continue
      If (nLList(iroot,5).eq.1) Then
        iPtr1=iroot
        iPtr2=iPtr1
* go either to last element or list or to last element in core
* and flush vector
 100    If ((nLList(iPtr1,0).ne.0).and.(nLList(iPtr1,5).eq.1)) Then
          iPtr2=iPtr1
          iPtr1=nLList(iPtr1,0)
          GoTo 100
        End If
        If (nLList(iPtr1,5).eq.1) Then
* nothing written on disk yet
          iDskPt=0
          iPtr2=iPtr1
          iPtr1=nLList(iPtr1,1)
        Else
          iDskPt=nLList(iPtr1,2)
          iPtr1=nLList(iPtr2,1)
        End If
* now set up node again and write vec to disk
        nLList(iPtr2,1)=iDskPt
        nLList(iPtr2,5)=0
        len=nLList(iPtr2,3)

        Call dDaFile(LUnit,1,Work(iPtr1),len,iDskPt)
        Call GetMem('LVec ','Free','Real',iPtr1,len)
        Go To 10
      End If
      lDskPt=iDskPt
*     now all vectors are flushed... so dump linked list...
      Call iDaFile(LUnit,1,nLList(iLList,0),NodSiz,iDskPt)
*
 200  If (iroot.ne.0) Then
        iPtr1=iroot
        iroot=nLList(iroot,0)
        Call iDaFile(LUnit,1,nLList(iPtr1,0),NodSiz,iDskPt)
*       Call GetMem('LNode','Free','Inte',iPtr1,NodSiz)
        GoTo 200
      End If
*     Call GetMem('CNOD ','Free','Inte',LList,NodSiz)
*
      End
*----------------------------------------------------------------------*


      SubRoutine RclLst(iLList,LUnit,lDskPt,NoAllo)
      Implicit Real*8 (a-h,o-z)
      Integer iLList,LUnit,lDskPt,NoAllo
*
#include "WrkSpc.fh"
#include "mxdm.fh"
#include "lnklst.fh"

#include "SysDef.fh"
*
* load listhead...
      lLList=lLList+1
      iLList=lLList

      Call iDaFile(LUnit,2,nLList(iLList,0),NodSiz,lDskPt)
      iroot=nLList(iLList,1)

      If (iroot.le.0) Then
        Write (6,*) 'RclLst: linked list has zero length,'
     &            //' that''s strange!'
* linked list has zero length, that's strange
*       Call Quit(20)
        Return
      End If
*
* restore linked list...
      lislen=1
      lLList=lLList+1
      iPtr1=lLList

      nLList(iLList,1)=iPtr1
      Call iDaFile(LUnit,2,nLList(iPtr1,0),NodSiz,lDskPt)

      iroot=iPtr1
      iPtr2=iroot
 100  If (nLList(iPtr2,0).ne.0) Then
        lislen=lislen+1
         lLList=lLList+1
         iPtr1=lLList
        nLList(iPtr2,0)=iPtr1

        Call iDaFile(LUnit,2,nLList(iPtr1,0),NodSiz,lDskPt)
        iPtr2=iPtr1
        Go To 100
      End If
      If (nLList(iLList,2).ne.lislen) Then
        Write(6,*) 'RclLst:LList length mismatch:',
     &              nLList(iLList,2),lislen
        Call Abend
      End If
      Write (6,*) 'Let''s restore...'
* now we have restored the list, let's fetch some vectors
      incore=nLList(iLList,3)
      Call GetMem('LVec ','Max','Real',iPtr1,MaxMem)
      lvec=nLList(iroot,3)
      iPtr2=iroot
 200  If ((incore.gt.0).AND.(MaxMem-NoAllo.ge.lvec).AND.(iPtr2.gt.0))
     &  Then
        lDskPt=nLList(iPtr2,1)
        Call GetMem('LVec ','Allo','Real',iPtr1,lvec)
        Call dDaFile(LUnit,2,Work(iPtr1),lvec,lDskPt)
        nLList(iPtr2,1)=iPtr1
        nLList(iPtr2,2)=0
        nLList(iPtr2,5)=1
        iPtr2=nLList(iPtr2,0)
        incore=incore-1

        Call GetMem('LVec ','Max','Real',iPtr1,MaxMem)
        Go To 200
      End If
      If (iPtr2.gt.0) nLList(iLList,3)=nLList(iLList,3)-incore
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MAXABSDIAG(DIAG,IRED,DGMAX)
C
C     Purpose: set max. abs. DIAG (reduced set IRED) in each symmetry, and
C              return the global max. abs. in DGMAX.
C
      use ChoSwp, only: IndRed
#include "implicit.fh"
      DIMENSION DIAG(*)
#include "cholesky.fh"

      CHARACTER*14 SECNAM
      PARAMETER (SECNAM = 'CHO_MAXABSDIAG')

      INTEGER AB, AB1, AB2

      LOGICAL LOCDBG
#if defined (_DEBUGPRINT_)
      PARAMETER (LOCDBG = .TRUE.)
#else
      PARAMETER (LOCDBG = .FALSE.)
#endif

      IF (CHO_1CENTER) THEN ! specialization for 1-center approximation
         CALL CHO_MAXABSDIAG_1C(DIAG,IRED,DGMAX)
         RETURN
      END IF

      IF (IRED .EQ. 1) THEN
         DO ISYM = 1,NSYM
            IF (NNBSTR(ISYM,IRED) .LT. 1) THEN
               DIAMAX(ISYM) = 0.0D0
            ELSE
               DIAMAX(ISYM) = ABS(DIAG(IIBSTR(ISYM,IRED)+1))
               AB1 = IIBSTR(ISYM,IRED) + 2
               AB2 = IIBSTR(ISYM,IRED) + NNBSTR(ISYM,IRED)
               DO AB = AB1,AB2
                  DIAMAX(ISYM) = MAX(DIAMAX(ISYM),ABS(DIAG(AB)))
               END DO
            END IF
            DIAMAXT(ISYM)=DIAMAX(ISYM)
         END DO
      ELSE IF ((IRED.EQ.2) .OR. (IRED.EQ.3)) THEN
         DO ISYM = 1,NSYM
            IF (NNBSTR(ISYM,IRED) .LT. 1) THEN
               DIAMAX(ISYM) = 0.0D0
            ELSE
               AB = INDRED(IIBSTR(ISYM,IRED)+1,IRED)
               DIAMAX(ISYM) = ABS(DIAG(AB))
               AB1 = IIBSTR(ISYM,IRED) + 2
               AB2 = IIBSTR(ISYM,IRED) + NNBSTR(ISYM,IRED)
               DO IAB = AB1,AB2
                  AB = INDRED(IAB,IRED)
                  DIAMAX(ISYM) = MAX(DIAMAX(ISYM),ABS(DIAG(AB)))
               END DO
            END IF
            IF (NNBSTR(ISYM,1) .LT. 1) THEN
               DIAMAXT(ISYM) = 0.0D0
            ELSE
               DIAMAXT(ISYM) = ABS(DIAG(IIBSTR(ISYM,1)+1))
               AB1 = IIBSTR(ISYM,1) + 2
               AB2 = IIBSTR(ISYM,1) + NNBSTR(ISYM,1)
               DO AB = AB1,AB2
                  DIAMAXT(ISYM) = MAX(DIAMAXT(ISYM),ABS(DIAG(AB)))
               END DO
            END IF
         END DO
      ELSE
         WRITE(LUPRI,*) SECNAM,': unknown reduced set, IRED = ',IRED
         CALL CHO_QUIT('Unknown reduced set in '//SECNAM,104)
      END IF

      DGMAX = DIAMAX(1)
      DO ISYM = 2,NSYM
         DGMAX = MAX(DGMAX,DIAMAX(ISYM))
      END DO

      IF (LOCDBG) THEN
         WRITE(LUPRI,*) SECNAM,': in reduced set ',IRED,':'
         WRITE(LUPRI,*) 'DIAMAX  = ',(DIAMAX(ISYM),ISYM=1,NSYM)
         WRITE(LUPRI,*) 'DIAMAXT = ',(DIAMAXT(ISYM),ISYM=1,NSYM)
         WRITE(LUPRI,*) 'DGMAX   = ',DGMAX
      END IF

      END
      SubRoutine Cho_MaxAbsDiag_1C(Diag,iLoc,DGMax)
C
C     Specialization for 1-Center approximation: only find max for
C     1-center diagonals.
C
      use ChoArr, only: iSP2F, iAtomShl
      use ChoSwp, only: nnBstRSh, iiBstRSh, IndRed
#include "implicit.fh"
      Real*8 Diag(*)
#include "cholesky.fh"

      Character*17 SecNam
      Parameter (SecNam = 'Cho_MaxAbsDiag_1C')

      Logical LocDbg
#if defined (_DEBUGPRINT_)
      Parameter (LocDbg = .true.)
#else
      Parameter (LocDbg = .false.)
#endif

      If (iLoc .eq. 1) Then
         Do iSym = 1,nSym
            DiaMax(iSym) = 0.0d0
            Do iShlAB = 1,nnShl
               Call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.true.)
               If (iAtomShl(iShlA) .eq. iAtomShl(iShlB)) Then
                  i1 = iiBstR(iSym,1) + iiBstRSh(iSym,iShlAB,1) + 1
                  i2 = i1 + nnBstRSh(iSym,iShlAB,1) - 1
                  Do i = i1,i2
                     DiaMax(iSym)=max(DiaMax(iSym),Diag(i))
                  End Do
               End If
            End Do
            DiaMaxT(iSym)=DiaMax(iSym)
         End Do
      Else If (iLoc.eq.2 .or. iLoc.eq.3) Then
         Do iSym = 1,nSym
            DiaMax(iSym) = 0.0d0
            Do iShlAB = 1,nnShl
               Call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.true.)
               If (iAtomShl(iShlA) .eq. iAtomShl(iShlB)) Then
                  i1 = iiBstR(iSym,iLoc) + iiBstRSh(iSym,iShlAB,iLoc)
     &               + 1
                  i2 = i1 + nnBstRSh(iSym,iShlAB,iLoc) - 1
                  Do i = i1,i2
                     DiaMax(iSym)=max(DiaMax(iSym),Diag(IndRed(i,iLoc)))
                  End Do
               End If
            End Do
            DiaMaxT(iSym) = 0.0d0
            Do iShlAB = 1,nnShl
               Call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.true.)
               If (iAtomShl(iShlA) .eq. iAtomShl(iShlB)) Then
                  i1 = iiBstR(iSym,1) + iiBstRSh(iSym,iShlAB,1) + 1
                  i2 = i1 + nnBstRSh(iSym,iShlAB,1) - 1
                  Do i = i1,i2
                     DiaMaxT(iSym)=max(DiaMaxT(iSym),Diag(i))
                  End Do
               End If
            End Do
         End Do
      Else
         Write(LuPri,*) SecNam,': unknown reduced set, iLoc = ',iLoc
         Call Cho_Quit('Unknown reduced set in '//SecNam,104)
      End If

      DGMax = DiaMax(1)
      Do iSym = 2,nSym
         DGMax = max(DGMax,DiaMax(iSym))
      End Do

      If (LocDbg) Then
         Write(LuPri,*) SecNam,': in reduced set ',iLoc,':'
         Write(LuPri,*) 'DiaMax  = ',(DiaMax(iSym),iSym=1,nSym)
         Write(LuPri,*) 'DiaMaxT = ',(DiaMaxT(iSym),iSym=1,nSym)
         Write(LuPri,*) 'DGMax   = ',DGMax
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine saoon_cvb(c1,c2,n2,s,n,metr)
! Put matrix product S*C1 in C2:

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n2, n, metr
real(kind=wp), intent(in) :: c1(n,n2), s(*)
real(kind=wp), intent(out) :: c2(n,n2)
integer(kind=iwp) :: ik, j, k

if (metr == 0) then
  c2(:,:) = c1(:,:)
else if (metr == 1) then
  call mxatb_cvb(s,c1,n,n,n2,c2)
else if (metr == 2) then
  c2(:,:) = Zero
  do j=1,n2
    ik = 0
    do k=1,n
      c2(1:k-1,j) = c2(1:k-1,j)+s(ik+1:ik+k-1)*c1(k,j)
      c2(k,j) = c2(k,j)+sum(s(ik+1:ik+k)*c1(1:k,j))
      ik = ik+k
    end do
  end do
end if

return

end subroutine saoon_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Set_CHO_ADRVEC(ii)

use Definitions, only: iwp, u6

implicit none
#include "cholesky.fh"
integer(kind=iwp) :: Set_CHO_ADRVEC
integer(kind=iwp), intent(in) :: ii

Set_CHO_ADRVEC = 0
if (ii < 0) then
  Set_CHO_ADRVEC = CHO_ADRVEC
else if ((ii == 1) .or. (ii == 2)) then
  CHO_ADRVEC = ii
  Set_CHO_ADRVEC = CHO_ADRVEC
else
  call WarningMessage(2,'Set_CHO_ADRVEC: Illegal option')
  write(u6,*) 'ii=',ii
  call Abend()
end if

return

end function Set_CHO_ADRVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RSSBCB2(IASM,IATP,IBSM,IBTP,JASM,JATP,JBSM,JBTP,NGAS,IAOC,IBOC,JAOC,JBOC,NAEL,NBEL,IJAGRP,IJBGRP,SB,CB,JDOH2,NOBPTS, &
                   MAXI,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,XINT,C2,NSMOB,NSMST,NIA,NIB,NJA,NJB,IDC,CJRES,SIRES,I3,XI3S,I4,XI4S,MOCAA, &
                   SCLFAC,IPHGAS,I_RES_AB)
! SUBROUTINE RSSBCB2 --> 82
!
! Contributions to sigma block (iasm iatp, ibsm ibtp) from
! C block (jasm jatp, jbsm, jbtp)
!
! =====
! Input
! =====
!
! IASM,IATP : Symmetry and type of alpha strings in sigma
! IBSM,IBTP : Symmetry and type of beta  strings in sigma
! JASM,JATP : Symmetry and type of alpha strings in C
! JBSM,JBTP : Symmetry and type of beta  strings in C
! NGAS      : Number of active spaces in calculation
! IAOC,IBOC : Number of electrons in each AS for sigma supergroups
! JAOC,JBOC : Number of electrons in each AS for C     supergroups
! NAEL : Number of alpha electrons
! NBEL : Number of  beta electrons
! IJAGRP    : IA and JA belongs to this group of strings
! IJBGRP    : IB and JB belongs to this group of strings
! CB : Input c block
! IDOH2 : = 0 => no two electron operator
! IDOH2 : = 1 =>    two electron operator
! NTSOB  : Number of orbitals per type and symmetry
! IBTSOB : base for orbitals of given type and symmetry
! IBORB  : Orbitals of given type and symmetry
! MAXI   : Largest Number of "spectator strings" treated simultaneously
! MAXK   : Largest number of inner resolution strings treated at simult.
!
! IHAPR : /= 0 implies thatt the exact Hamiltonian shoulf not be uses
! In the case IPTSPC and JPTSPC defined the perturbation spaces
! a nonvanishing perturbation is allowed inside each subspace.
! The actual type of approximate Hamiltonian in each subspace is defined by
! IHFORM
! NNSEL2E : Only selected 2e terms will be included
! ISEL2E : orbital spaces in which 2e terms are included
!          (Currently : all indices identical)
!
! ======
! Output
! ======
! SB : fresh sigma block
!
! =======
! Scratch
! =======
! SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
!              largest number of orbital pairs of given symmetries and
!              types.
! I1, XI1S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! I1, XI1S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! C2 : Must hold largest STT block of sigma or C
!
! XINT : Scratch space for integrals.
!
! Jeppe Olsen, Winter of 1991

use lucia_data, only: TSIGMA
use Constants, only: Zero, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IASM, IATP, IBSM, IBTP, JASM, JATP, JBSM, JBTP, NGAS, IAOC(NGAS), IBOC(NGAS), JAOC(NGAS), &
                                 JBOC(NGAS), NAEL, NBEL, IJAGRP, IJBGRP, JDOH2, NOBPTS(*), MAXI, MAXK, NSMOB, NSMST, NIA, NIB, &
                                 NJA, NJB, IDC, MOCAA, IPHGAS(*), I_RES_AB
real(kind=wp), intent(inout) :: SB(NIA*NIB), CB(NJA*NJB), XI1S(*), XI2S(*), XI3S(*), XI4S(*)
real(kind=wp), intent(_OUT_) :: SSCR(*), CSCR(*), C2(*), XINT(*), CJRES(*), SIRES(*)
integer(kind=iwp), intent(inout) :: I1(*), I2(*), I3(*), I4(*)
real(kind=wp), intent(in) :: SCLFAC
integer(kind=iwp) :: I12, IBLOCK(8), IDIAG, IDOH2, IIDC, IIITRNS, ITASK, IUSEAB, JJJTRNS, LADVICE
real(kind=wp) :: CPU, CPU0, CPU1, FACTOR, WALL, WALL0, WALL1

! For H(apr)

#ifdef _DEBUGPRINT_
write(u6,*) ' ==============================='
write(u6,*) ' RSSBCB2 :  C block (transposed)'
write(u6,*) ' ================================'
call WRTMAT(CB,NJB,NJA,NJB,NJA)
write(u6,*) ' ======================================'
write(u6,*) ' RSSBCB2 : Initial  S block(transposed)'
write(u6,*) ' ======================================'
call WRTMAT(SB,NIA,NIB,NIA,NIB)
write(u6,*) ' Overall scalefactor ',SCLFAC
write(u6,*) ' JDOH2 = ',JDOH2
write(u6,*) ' I_RES_AB = ',I_RES_AB

write(u6,*) ' IAOC and IBOC'
call IWRTMA(IAOC,1,NGAS,1,NGAS)
call IWRTMA(IBOC,1,NGAS,1,NGAS)
write(u6,*) ' JAOC and JBOC  :'
call IWRTMA(JAOC,1,NGAS,1,NGAS)
call IWRTMA(JBOC,1,NGAS,1,NGAS)
write(u6,*) ' IASM IATP JASM JATP ',IASM,IATP,JASM,JATP
write(u6,*) ' IBSM IBTP JBSM JBTP ',IBSM,IBTP,JBSM,JBTP
write(u6,*) ' NAEL NBEL ',NAEL,NBEL
#endif
! Should the corresponding Hamiltonian matrix block be
! calculated exactly or approximately
!if (IHAPR /= 0) then
!  call HMATAPR(IASM,IATP,IBSM,IBTP,JASM,JATP,JBSM,JBTP,IPTSPC,JPTSPC,IJOP,IJOP,IIF,JDOH2,IDOH2,IMZERO,IDIAG)
!# ifdef _DEBUGPRINT_
!  write(u6,*) ' RSSBCBN : ',NNSEL2E,ISEL2E(1)
!# endif
!  NSEL2E = NNSEL2E
!  if (IMZERO /= 0) goto 9999
!else
! Operator specified by input
IDOH2 = JDOH2
IDIAG = 0
!end if
#ifdef _DEBUGPRINT_
write(u6,*) ' IDIAG IDOH2 ',IDIAG,IDOH2
#endif

if ((IDC == 2) .and. (IATP == IBTP) .and. (IASM == IBSM) .and. (I_RES_AB == 0) .and. (JASM == JBSM) .and. (JATP == JBTP)) then
  ! Diagonal sigma block, use alpha-beta symmetry to reduce computations.
  IUSEAB = 1
else
  IUSEAB = 0
end if

if (IDIAG == 0) then

  ! Calculate block exactly

  if ((I_RES_AB /= 1) .and. (IUSEAB == 0) .and. (IATP == JATP) .and. (JASM == IASM)) then

    ! =============================
    ! Sigma beta beta contribution
    ! =============================

    ! Sigma aa(IA,IB) = sum(i > k,j > l)<IB!Eb(ij)Eb(kl)!JB>
    !                 * ((ij!kl)-(il!kj)) C(IA,JB)
    !                 + sum(ij) <IB!Eb(ij)!JB> H(ij) C(IA,JB)
    ! One electron part
    call TRPMT3(SB,NIB,NIA,C2)
    SB(1:NIA*NIB) = C2(1:NIA*NIB)
    call TRPMT3(CB,NJB,NJA,C2)
    CB(1:NJA*NJB) = C2(1:NJA*NJB)

    if (NBEL >= 0) then
#     ifdef _DEBUGPRINT_
      write(u6,*) ' SB before RSBB1E'
      call wrtmat(sb,nia,nib,nia,nib)
      write(u6,*) ' I am going to call RSBB1E'
#     endif
      call TIMING(CPU0,CPU,WALL0,WALL)
      call RSBB1E(IBSM,IBTP,JBSM,JBTP,IJBGRP,NIA,NGAS,IBOC,JBOC,SB,CB,NOBPTS,MAXI,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,XINT,NSMOB,MOCAA, &
                  SCLFAC,IPHGAS)
      call TIMING(CPU1,CPU,WALL1,WALL)
      TSIGMA(1) = TSIGMA(1)+(WALL1-WALL0)

      ! CALL RSBB1E --> 33

#     ifdef _DEBUGPRINT_
      write(u6,*) ' SB after RSBB1E'
      call wrtmat(sb,nib,nia,nib,nia)
      write(u6,*) ' first element of SB after RSBB1E',SB(1)
#     endif

    end if
    if ((IDOH2 /= 0) .and. (NBEL >= 0)) then
      ! Two electron part
#     ifdef _DEBUGPRINT_
      write(u6,*) ' I am going to call RSBB2A'
#     endif
      call TIMING(CPU0,CPU,WALL0,WALL)
      call RSBB2A(IBSM,IBTP,JBSM,JBTP,IJBGRP,NIA,NGAS,IBOC,JBOC,SB,CB,NOBPTS,MAXI,MAXK,SSCR,CSCR,I1,XI1S,XINT,NSMOB,NSMST,SCLFAC, &
                  IPHGAS)
      call TIMING(CPU1,CPU,WALL1,WALL)
      TSIGMA(2) = TSIGMA(2)+(WALL1-WALL0)

      ! CALL RSBB2A --> 46

#     ifdef _DEBUGPRINT_
      write(u6,*) ' SB after RSBB2a'
      call wrtmat(sb,nib,nia,nib,nia)
      write(u6,*) ' first element of SB after RSBB1E',SB(1)
#     endif
    end if
    call TRPMT3(SB,NIA,NIB,C2)
    SB(1:NIA*NIB) = C2(1:NIA*NIB)
    call TRPMT3(CB,NJA,NJB,C2)
    CB(1:NJA*NJB) = C2(1:NJA*NJB)
  end if

  ! =============================
  ! Sigma alpha beta contribution
  ! =============================

  if ((IDOH2 /= 0) .and. (NAEL >= 0) .and. (NBEL >= 0)) then
#   ifdef _DEBUGPRINT_
    write(u6,*) ' I am going to call RSBB2B'
#   endif
    IIITRNS = 1
    if (IIITRNS == 1) then
      ! Call advice routine
      !    ADVICE_SIGMA(IAOCC,IBOCC,JAOCC,JBOCC,ITERM,LADVICE)
      call ADVICE_SIGMA(IAOC,IBOC,JAOC,JBOC,LADVICE)
      ! LADVICE = 2 => implies transpose
      if (LADVICE == 2) then
        JJJTRNS = 1
      else
        JJJTRNS = 0
      end if
    end if

    !write(u6,*) ' IUSE_PA = ',IUSE_PA

    if (JJJTRNS == 0) then
      !if (IUSE_PA == 0) then
      call TIMING(CPU0,CPU,WALL0,WALL)
      call RSBB2BN(IASM,IATP,IBSM,IBTP,NIA,NIB,JASM,JATP,JBSM,JBTP,NJA,NJB,IJAGRP,IJBGRP,NGAS,IAOC,IBOC,JAOC,JBOC,SB,CB,NOBPTS, &
                   MAXK,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,NSMOB,IUSEAB,CJRES,SIRES,SCLFAC,IPHGAS)
      call TIMING(CPU1,CPU,WALL1,WALL)
      TSIGMA(3) = TSIGMA(3)+(WALL1-WALL0)

      ! CALL RSBB2BN --> 52

      !else if (IUSE_PA == 1) then
      !  !write(u6,*) ' RSBB2BVN will be called'
      !  call RSBB2BVN(IASM,IATP,IBSM,IBTP,NIA,NIB,JASM,JATP,JBSM,JBTP,NJA,NJB,IJAGRP,IJBGRP,NGAS,IAOC,IBOC,JAOC,JBOC,SB,CB, &
      !                MXPNGAS,NOBPTS,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,NSMOB,IUSEAB,CJRES,SIRES,SCLFAC,0,0,0, &
      !                IUSE_PH,IPHGAS,CJPA,SIPA)
      !end if

    else if (JJJTRNS == 1) then
      ! well lets give the transpose routine some more practice : Transpose back
      call TRPMT3(SB,NIB,NIA,C2)
      SB(1:NIA*NIB) = C2(1:NIA*NIB)
      call TRPMT3(CB,NJB,NJA,C2)
      CB(1:NJA*NJB) = C2(1:NJA*NJB)
      !write(u6,*) ' RSSBCB2 : Transpose path choosen'

      !if (IUSE_PA == 0) then
      ! No division into active/passive
      call TIMING(CPU0,CPU,WALL0,WALL)
      call RSBB2BN(IBSM,IBTP,IASM,IATP,NIB,NIA,JBSM,JBTP,JASM,JATP,NJB,NJA,IJBGRP,IJAGRP,NGAS,IBOC,IAOC,JBOC,JAOC,SB,CB,NOBPTS, &
                   MAXK,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,NSMOB,IUSEAB,CJRES,SIRES,SCLFAC,IPHGAS)
      call TIMING(CPU1,CPU,WALL1,WALL)
      TSIGMA(3) = TSIGMA(3)+(WALL1-WALL0)

      ! CALL RSBB2BN --> 52

      !else
      !  ! Divide into active/passive
      !  call RSBB2BVN(IBSM,IBTP,IASM,IATP,NIB,NIA,JBSM,JBTP,JASM,JATP,NJB,NJA,IJBGRP,IJAGRP,NGAS,IBOC,IAOC,JBOC,JAOC,SB,CB, &
      !                MXPNGAS,NOBPTS,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,NSMOB,IUSEAB,CJRES,SIRES,SCLFAC,0,0,0, &
      !                IUSE_PH,IPHGAS,CJPA,SIPA)
      !end if

      ! Transpose (To compensate later transposition)
      call TRPMT3(SB,NIA,NIB,C2)
      SB(1:NIA*NIB) = C2(1:NIA*NIB)
      call TRPMT3(CB,NJA,NJB,C2)
      CB(1:NJA*NJB) = C2(1:NJA*NJB)
    end if
#   ifdef _DEBUGPRINT_
    write(u6,*) ' SB after RSBB2B, first element'
    call wrtmat(sb,1,1,nia,nib)
    write(u6,*) ' SB after RSBB2b'
    call wrtmat(sb,nia,nib,nia,nib)
#   endif
  end if

  ! =============================
  ! Sigma alpha alpha contribution
  ! =============================

  if ((I_RES_AB /= -1) .and. (NAEL >= 0) .and. (IBTP == JBTP) .and. (IBSM == JBSM)) then

    ! alpha single excitation

#   ifdef _DEBUGPRINT_
    write(u6,*) ' I am going to call RSBB1E (last time)'
#   endif
    call TIMING(CPU0,CPU,WALL0,WALL)
    call RSBB1E(IASM,IATP,JASM,JATP,IJAGRP,NIB,NGAS,IAOC,JAOC,SB,CB,NOBPTS,MAXI,MAXK,SSCR,CSCR,I1,XI1S,I2,XI2S,XINT,NSMOB,MOCAA, &
                SCLFAC,IPHGAS)
    call TIMING(CPU1,CPU,WALL1,WALL)
    TSIGMA(1) = TSIGMA(1)+(WALL1-WALL0)

    ! CALL RSBB1E --> 33

#   ifdef _DEBUGPRINT_
    write(u6,*) ' SB transposed after RSBB1, first element'
    call wrtmat(sb,1,1,nia,nib)
    write(u6,*) ' SB transposed  after RSBB1E'
    call wrtmat(SB,nib,nia,nib,nia)
#   endif

    ! alpha double excitation

    if ((IDOH2 /= 0) .and. (NAEL >= 0)) then
#     ifdef _DEBUGPRINT_
      write(u6,*) ' I am going to call RSBB2A (last time)'
#     endif
      call TIMING(CPU0,CPU,WALL0,WALL)
      call RSBB2A(IASM,IATP,JASM,JATP,IJAGRP,NIB,NGAS,IAOC,JAOC,SB,CB,NOBPTS,MAXI,MAXK,SSCR,CSCR,I1,XI1S,XINT,NSMOB,NSMST,SCLFAC, &
                  IPHGAS)
      call TIMING(CPU1,CPU,WALL1,WALL)
      TSIGMA(2) = TSIGMA(2)+(WALL1-WALL0)

      ! CALL RSBB2A --> 46

    end if

#   ifdef _DEBUGPRINT_
    write(u6,*) ' SB transposed after RSBB2A, first element'
    call wrtmat(sb,1,1,nia,nib)
    write(u6,*) ' SB after RSBB2A'
    call wrtmat(sb,nia,nib,nia,nib)
#   endif
  end if

else if (IDIAG == 1) then

  ! Diagonal approxiation (IDIAG = 1)
  ! or complete orbital conserving part of Ham (IH_OCC_CONS = 1)

  IBLOCK(1) = IATP
  IBLOCK(2) = IBTP
  IBLOCK(3) = IASM
  IBLOCK(4) = IBSM
  IBLOCK(5) = 1
  IBLOCK(6) = 1
  if (IDOH2 == 0) then
    I12 = 1
  else
    I12 = 2
  end if
  !write(u6,*) ' IDOH2, I12 ', IDOH2,I12
  ITASK = 2
  FACTOR = Zero
  ! Well, we are not using transposed matrices here so
  call TRPMT3(CB,NJB,NJA,C2)
  CB(1:NJA*NJB) = C2(1:NJA*NJB)

  if ((IATP == JATP) .and. (IBTP == JBTP) .and. (IASM == JASM) .and. (IBSM == JBSM)) then
    !write(u6,*) ' DIATERM2_GAS will be called'
    C2(1:NJA*NJB) = CB(1:NJA*NJB)
    ! Input is in det basis
    IIDC = 1
    call DIATERM2_GAS(FACTOR,ITASK,C2,1,IBLOCK,1,I12,IIDC)
  else
    C2(1:NIA*NIB) = Zero
  end if
  ! Remaining occupation conserving operator
  !if (IH_OCC_CONS == 1) &
  !  call HCONFDIA_BBM(NAEL,NBEL,IJAGRP,IJBGRP,IASM,IATP,IAOC,NIA,IBSM,IBTP,IBOC,NIB,JASM,JATP,JAOC,NJA,JBSM,JBTP,JBOC,NJB,XINT, &
  !                    CB,C2)

  if (IUSEAB == 0) then
    FACTOR = SCLFAC
  else
    FACTOR = Half*SCLFAC
  end if
  !    MAT_P_MATT(A,B,NR,NC,COEF)
  call MAT_P_MATT(SB,C2,NIB,NIA,FACTOR)
  call TRPMT3(CB,NJA,NJB,C2)
  CB(1:NJA*NJB) = C2(1:NJA*NJB)
end if

!9999 continue
! Clean up
!if (IHAPR /= 0) call HMATAPR(IASM,IATP,IBSM,IBTP,JASM,JATP,JBSM,JBTP,IPTSPC,JPTSPC,IJOP,IJOP,IIF,JDOH2,IDOH2,IMZERO,IDIAG)

#ifdef _DEBUGPRINT_
write(u6,*) ' ==================================='
write(u6,*) ' RSSBCB : Final S block (transposed)'
write(u6,*) ' ==================================='
call WRTMAT(SB,NIB,NIA,NIB,NIA)
#endif

end subroutine RSSBCB2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine transcon(contold,idim1,idim2,ovlp,contnew,nprim,ncont)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idim1, idim2, nprim, ncont
real(kind=wp), intent(in) :: contold(idim1,idim2), ovlp(idim1,idim1)
real(kind=wp), intent(out) :: contnew(nprim,ncont)
integer(kind=iwp) :: ICONT, Irun, Jrun
real(kind=wp) :: xnorm

!write(u6,*) 'begin transcon nprim,ncont ',nprim,ncont
!bs copy old contraction coefficients in dense form
contnew(:,:) = contold(1:nprim,1:ncont)
!bs ensure normalization
do ICONT=1,ncont
  xnorm = Zero
  do Jrun=1,nprim
    do Irun=1,nprim
      xnorm = xnorm+contnew(Irun,ICONT)*contnew(Jrun,ICONT)*ovlp(Irun,Jrun)
      !write(u6,*) 'Icont,jrun,irun,xnorm ',icont,jrun,irun,xnorm
    end do
  end do
  !write(u6,*) 'ICONT ',ICONT,xnorm
  xnorm = One/sqrt(xnorm)
  !bs scale with normalization factor
  contnew(:,ICONT) = xnorm*contnew(:,ICONT)
end do
!write(u6,*) 'end transcon nprim,ncont ',nprim,ncont

return

end subroutine transcon

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Jobiph_J

use Molcas, only: MxRoot, MxSym
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: iadr15_j(15), iroot_j(mxroot), ispin_j, lroots_j, lsym_j, nactel_j, nash_j(mxsym), nbas_j(mxsym), nconf_j, &
                     ndel_j(mxsym), nelec3_j, nfro_j(mxsym), nhole1_j, nish_j(mxsym), nroots_j, nrs1_j(mxsym), nrs2_j(mxsym), &
                     nrs3_j(mxsym), nsym_j
real(kind=wp) :: weight_j(mxroot)
character(len=72) :: title_j(18)

public :: iadr15_j, iroot_j, ispin_j, lroots_j, lsym_j, nactel_j, nash_j, nbas_j, nconf_j, ndel_j, nelec3_j, nfro_j, nhole1_j, &
          nish_j, nroots_j, nrs1_j, nrs2_j, nrs3_j, nsym_j, title_j, weight_j

end module Jobiph_J

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007,2008, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine ChoMP2_VectorMO2AO(iTyp,Delete,BaseName_AO,CMO,DoDiag,
     &                              Diag,lDiag,lU_AO,irc)
C
C     Thomas Bondo Pedersen, Dec. 2007 - Jan. 2008.
C
C     Purpose: backtransform vectors from MO to AO basis.
C
C     Input:
C        iTyp......... specifies type of vectors (iTyp is used to open
C                      MO vector files through ChoMP2_OpenF()).
C        Delete....... Flag specifiyng whether MO vector files are to
C                      be deleted before exiting this routine.
C        BaseName_AO.. Base name (3 characters) for the files containing
C                      AO vectors. Symmetry index will be appended!
C        CMO.......... MO coefficient array
C        DoDiag....... if .True., calculate AO diagonal elements as
C                      D(ab) = sum_J L(J,ab)*L(J,ab)
C     Output:
C        Diag......... Contains the diagonal if requested (flag DoDiag).
C        lDiag........ Dimension of Diag
C        lU_AO........ Array containing units of open AO vector files.
C        irc.......... return code.
C                      = 0 if successful, non-zero otherwise
C                      (must be checked by caller).
C
C***********************************************************************
C!!!!!!!!!!!!!!!!!!!!!!!!! IMPORTANT !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C***********************************************************************
C*** CHOLESKY INFORMATION MUST BE INITIALIZED WHEN CALLING THIS ROUTINE.
C    --> I.e. Cho_X_Init() must have been called.
C    --> It is actually sufficient that choorb.fh + nSym in
C        cholesky.fh are available (which they are when Cho_X_Init()
C        has been called).
C*** CHOLESKY MP2 INFORMATION MUST BE INITIALIZED WHEN CALLING THIS
C    ROUTINE.
C    --> I.e. ChoMP2_Setup() must have been called.
C*** AO VECTORS ARE STORED IN LOWER TRIANGULAR [M(I,J), I.GE.J] FORMAT.
C    --> I.e. vectors are stored as L(J,ab) where a>=b
C*** DIAGONAL IS STORED IN LOWER TRIANGULAR FORMAT.
C    --> I.e. diagonal is stored as D(ab) where a>=b (same as vectors).
C***********************************************************************
C!!!!!!!!!!!!!!!!!!!!!!!!! IMPORTANT !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C***********************************************************************
C
      Implicit None
      Integer     iTyp
      Logical     Delete
      Character*3 BaseName_AO
      Real*8      CMO(*)
      Logical     DoDiag
      Integer     lDiag
      Real*8      Diag(lDiag)
      Integer     lU_AO(*)
      Integer     irc
#include "cholesky.fh"
#include "choorb.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"

      Character*18 SecNam
      Character*11 ThisNm
      Parameter (SecNam = 'ChoMP2_VectorMO2AO')
      Parameter (ThisNm = 'VectorMO2AO')

      Character*4 FullName_AO

      Integer iSym, iSyma, iSymb, iCount, iOpen, iClose
      Integer ip_COcc, ip_CVir
      Integer l_COcc,  l_CVir

      Logical Debug
#if defined (_DEBUGPRINT_)
      Parameter (Debug = .True.)
#else
      Parameter (Debug = .False.)
#endif

      Integer MulD2h, k, l
      MulD2h(k,l)=iEOr(k-1,l-1)+1

C     Initializations.
C     ----------------

      irc = 0
      Do iSym = 1,nSym
         lU_AO(iSym) = -999999
      End Do
      If (DoDiag) Then
         iCount = 0
         Do iSym = 1,nSym
            Do iSymb = 1,nSym
               iSyma = MulD2h(iSymb,iSym)
               iCount = iCount + nBas(iSyma)*nBas(iSymb)
            End Do
         End Do
         If (iCount .ne. lDiag) Then
            Write(6,*) SecNam,': WARNING: ',
     &                 'inconsistent diagonal allocation!'
            If (iCount .gt. lDiag) Then
               Write(6,*) '   - insufficient memory, will return now...'
               irc = 1
               Return
            Else
               Write(6,*) '   - sufficient memory, going to continue...'
            End If
         End If
      End If

C     Reorder CMO. This also removes frozen orbitals.
C     -----------------------------------------------

      l_COcc = nT1AOT(1)
      l_CVir = nAOVir(1)
      Call GetMem('COcc','Allo','Real',ip_COcc,l_COcc)
      Call GetMem('CVir','Allo','Real',ip_CVir,l_CVir)
      Call ChoMP2_MOReOrd(CMO,Work(ip_COcc),Work(ip_CVir))

C     Backtransform.
C     --------------

      Call ChoMP2_BackTra(iTyp,Work(ip_COcc),Work(ip_CVir),
     &                    BaseName_AO,DoDiag,Diag)

C     Open AO vector files (i.e. get units to return).
C     ------------------------------------------------

      Do iSym = 1,nSym
         Write(FullName_AO,'(A3,I1)') BaseName_AO,iSym
         lU_AO(iSym) = 7
         Call daName_MF_WA(lU_AO(iSym),FullName_AO)
      End Do

C     Debug: check backtransformation.
C     --------------------------------

      If (Debug) Then
         Call ChoMP2_CheckBackTra(iTyp,Work(ip_COcc),Work(ip_CVir),
     &                            lU_AO)
      End If

C     Delete MO files if requested.
C     -----------------------------

      If (Delete) Then
         iOpen = 1
         iClose = 3
         Do iSym = 1,nSym
            Call ChoMP2_OpenF(iOpen,iTyp,iSym)
            Call ChoMP2_OpenF(iClose,iTyp,iSym)
         End Do
      End If

C     Deallocate and exit.
C     --------------------

      Call GetMem('CVir','Free','Real',ip_CVir,l_CVir)
      Call GetMem('COcc','Free','Real',ip_COcc,l_COcc)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Martin Schuetz                                   *
!               1998, Roland Lindh                                     *
!               2000-2015, Steven Vancoillie                           *
!***********************************************************************

! duplicate & copy a global array...
! iGA1,iGA2:       GA handles...
subroutine GADupl(iGA1,iGA2)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: GA_Duplicate
use Definitions, only: u6
#endif
use Definitions, only: iwp

implicit none
#ifdef _MOLCAS_MPP_
integer(kind=iwp), intent(in) :: iGA1
integer(kind=iwp), intent(out) :: iGA2
logical(kind=iwp) :: ok
character(len=6) :: gaLbl2
character(len=5) :: gaLbl

if (.not. Is_Real_Par()) return
if (iGA1 >= 0) return
call ga_inquire_name(iGA1,gaLbl)
write(gaLbl2,'(A,I1)') gaLbl,2

ok = ga_duplicate(iGA1,iGA2,gaLbl2)
if (.not. ok) then
  write(u6,*) 'GADupl: ga_duplicate not OK!'
  call ga_error('GADupl',42)
  call Abend()
end if

call ga_copy(iGA1,iGA2)
#else
integer(kind=iwp), intent(in) :: iGA1, iGA2
#include "macros.fh"
unused_var(iGA1)
unused_var(iGA2)
#endif

end subroutine GADupl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine o8b2_cvb(nparm,
     >  dx,grad,eigvec,eigval,
     >  dxnrm,close2conv)
      implicit real*8 (a-h,o-z)
      logical close2conv
#include "opt_cvb.fh"
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

      dimension dx(nparm),grad(nparm)
      dimension eigvec(nparm+1,nparm+1),eigval(nparm+1)
      save one
      data one/1d0/

      call fzero(eigvec,(nparm+1)*(nparm+1))
      do 100 iprm=1,nparm
      eigvec(iprm+1,1)=grad(iprm)
      eigvec(1,iprm+1)=grad(iprm)
      eigvec(iprm+1,iprm+1)=one
      call hess_cvb(eigvec(2,iprm+1))
100   continue
      write(6,*)' Augmented Hessian matrix :'
      call mxprint_cvb(eigvec,nparm+1,nparm+1,0)
      call mxdiag_cvb(eigvec,eigval,nparm+1)
      iroot=nparm+1
      if(ip.ge.2)then
        write(6,'(a)')' Eigenvalues of augmented Hessian :'
        call vecprint_cvb(eigval,nparm+1)
        write(6,'(a)')' Eigenvector to be followed :'
        call vecprint_cvb(eigvec(1,iroot),nparm+1)
      endif
      write(6,*)' Following root no :',iroot
      call fmove_cvb(eigvec(2,iroot),dx,nparm)
      if(abs(eigvec(1,iroot)).gt.1d-8)then
        fac1=one/eigvec(1,iroot)
      else
        fac1=sign(one,eigvec(1,iroot))
      endif
      call dscal_(nparm,fac1,dx,1)
      dxnrm=dnrm2_(nparm,dx,1)
      if(.not.close2conv)then
        ipu=1
      else
        ipu=2
      endif
      if(dxnrm.gt.hh.or.scalesmall(ipu))then
        call dscal_(nparm,hh/dxnrm,dx,1)
        dxnrm=hh
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine KE_exchange(N1,N2,lant,t,u,OPT,HEXC)
! this function computes the exchange+covalent contributions to Hamiltonian of a given Lanthanide

use jcoeff, only: dE, init_Jx, Jx
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cOne, auTocm, auToeV
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N1, N2, lant, OPT
real(kind=wp), intent(in) :: t, u
complex(kind=wp), intent(out) :: HEXC(N1,N1,N2,N2)
integer(kind=iwp) :: i1, i2, iJ, iK, ika, iLS, iP, iph, j1, j2, JLn, ms1, ms2, ns1, ns2, SR
real(kind=wp) :: Jfinal(0:7,-5:5,0:1,-1:1)
real(kind=wp), allocatable :: HEXC1(:,:,:,:)
real(kind=wp), parameter :: conv = 1.0e3_wp*auToeV/auTocm ! cm-1 to meV?
real(kind=wp), external :: WCG ! Clebsch-Gordan Coefficients

call init_Jx()
call mma_allocate(HEXC1,N1,N1,N2,N2,label='HEXC1')
HEXC1(:,:,:,:) = Zero
JLn = N1-1  !nexch(iLn)-1
SR = N2-1  !nexch(iRad)-1
do i1=1,N1
  ms1 = -(N1-1)+2*(i1-1)
  do j1=1,N1
    ns1 = -(N1-1)+2*(j1-1)
    do i2=1,N2
      ms2 = -(N2-1)+2*(i2-1)
      do j2=1,N2
        ns2 = -(N2-1)+2*(j2-1)

        if (OPT == 1) then ! FULL calculation

          do iLS=1,4
            do iJ=1,17
              do iK=0,7
                do ika=-5,5
                  do iP=0,1
                    do iph=-1,1
                      if (WCG(JLn,JLn,2*iK,0,JLn,JLn)*WCG(SR,SR,2*iP,0,SR,SR) == Zero) cycle
                      if (WCG(JLn,ns1,2*iK,2*ika,JLn,ms1)*WCG(SR,ns2,2*iP,2*iph,SR,ms2) == Zero) cycle

                      HEXC1(i1,j1,i2,j2) = HEXC1(i1,j1,i2,j2)+t*t/(u+dE(lant,iLS,iJ))*Jx(lant,iLS,iJ,iK,ika,iP,iph)* &
                                           WCG(JLn,ns1,2*iK,2*ika,JLn,ms1)*WCG(SR,ns2,2*iP,2*iph,SR,ms2)/ &
                                           WCG(JLn,JLn,2*iK,0,JLn,JLn)/WCG(SR,SR,2*iP,0,SR,SR)
                    end do
                  end do
                end do
              end do
            end do
          end do

          if ((i1 == 1) .and. (j1 == 1) .and. (i2 == 1) .and. (j2 == 1)) then
            Jfinal = Zero
            write(u6,'(A)') 'Jfinal(iK,ika,iP,iph):'
            do iK=0,7
              do ika=-5,5
                do iP=0,1
                  do iph=-1,1

                    do iLS=1,4
                      do iJ=1,17

                        Jfinal(iK,ika,iP,iph) = Jfinal(iK,ika,iP,iph)+t*t/(u+dE(lant,iLS,iJ))*Jx(lant,iLS,iJ,iK,ika,iP,iph)

                      end do
                    end do
                    if (abs(Jfinal(iK,ika,iP,iph)) > 1.0e-13_wp) &
                      write(u6,'(4i4,4x,2ES24.14)') iK,ika,iP,iph,Jfinal(iK,ika,iP,iph),Jfinal(iK,ika,iP,iph)*conv
                  end do
                end do
              end do
            end do
          end if

        else if (OPT == 2) then ! 1/U approximation

          do iLS=1,4
            do iJ=1,17
              do iK=0,7
                do ika=-5,5
                  do iP=0,1
                    do iph=-1,1
                      if (WCG(JLn,JLn,2*iK,0,JLn,JLn)*WCG(SR,SR,2*iP,0,SR,SR) == Zero) cycle
                      if (WCG(JLn,ns1,2*iK,2*ika,JLn,ms1)*WCG(SR,ns2,2*iP,2*iph,SR,ms2) == Zero) cycle

                      HEXC1(i1,j1,i2,j2) = HEXC1(i1,j1,i2,j2)+t*t/u*Jx(lant,iLS,iJ,iK,ika,iP,iph)*WCG(JLn,ns1,2*iK,2*ika,JLn,ms1)* &
                                           WCG(SR,ns2,2*iP,2*iph,SR,ms2)/WCG(JLn,JLn,2*iK,0,JLn,JLn)/WCG(SR,SR,2*iP,0,SR,SR)
                    end do
                  end do
                end do
              end do
            end do
          end do

        end if !( OPT )

        HEXC(i1,j1,i2,j2) = HEXC1(i1,j1,i2,j2)*cOne

      end do !j2
    end do !i2
  end do !j1
end do !i1

call mma_deallocate(HEXC1)

return

end subroutine KE_exchange

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_Stat_ParentDiag()
!
! Thomas Bondo Pedersen, February 2006.
!
! Purpose: print statistics about the diagonals from which the
!          Cholesky vectors are computed. I.e., whether they are
!          one-center or two-center diagonals. Does not work with
!          symmetry!

use Cholesky, only: InfVec, LuPri, nBasT, nnBstRT, nSym, NumCho, NumChT
use Molcas, only: LenIn, MxBas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), parameter :: numAt = 6
integer(kind=iwp) :: i, i1, i2, iA, iAt, iAt0, iAt1, iAt2, iAtA, iAtB, iAtom, iB, iBatch, iClass(4), iRS1, iVec, nAt, nAtom, &
                     nBatch, nChk, nPseudo, nTot1, nTot2
real(kind=wp) :: R, Ratio(numAt), Rave, RClass(3), Rmax, Rmin
logical(kind=iwp) :: Debug
character(len=LenIn+8) :: AtomLabel(MxBas)
integer(kind=iwp), allocatable :: iBF2Atom(:), mapRS2F(:,:), nBas_per_Atom(:), nBas_Start(:), nPC1(:)
real(kind=wp), allocatable :: Coord(:,:), RC2(:)
character(len=*), parameter :: SecNam = 'Cho_Stat_ParentDiag'

! Set debug flag.
! ---------------

#ifdef _DEBUGPRINT_
Debug = .true.
#else
Debug = .false.
#endif

! Symmetry not allowed.
! ---------------------

if (nSym /= 1) return

! Check if anything to do.
! ------------------------

if (NumCho(1) /= NumChT) call SysAbendMsg(SecNam,'NumChT /= NumCho(1)',' ')
if (NumChT < 1) return

! Get number of atoms.
! --------------------

!call Get_nAtoms_All(nAtom)
call Get_iScalar('Bfn Atoms',nAtom)
call Get_iScalar('Pseudo atoms',nPseudo)

! Get atomic labels and basis function labels.
! --------------------------------------------

call Get_cArray('Unique Basis Names',AtomLabel,(LenIn+8)*nBasT)

! Allocate and get index arrays for indexation of basis functions on
! each atom.
! ------------------------------------------------------------------

call mma_allocate(nBas_per_Atom,nAtom,Label='nBas_per_Atom')
call mma_allocate(nBas_Start,nAtom,Label='nBas_Start')
call BasFun_Atom(nBas_per_Atom,nBas_Start,AtomLabel,nBasT,nAtom,Debug)

! Allocate and get nuclear coordinates.
! -------------------------------------

call mma_allocate(Coord,3,nAtom,Label='Coord')
!call Get_dArray('Unique Coordinates',Coord,3*nAtom)
call Get_dArray('Bfn Coordinates',Coord,3*nAtom)

! Allocate and set mapping from basis function to atom.
! -----------------------------------------------------

call mma_Allocate(iBF2Atom,nBasT,Label='iBF2Atom')
do iAtom=1,nAtom
  i1 = nBas_Start(iAtom)
  i2 = i1+nBas_per_Atom(iAtom)-1
  do i=i1,i2
    iBF2Atom(i) = iAtom
  end do
end do

if (Debug) then
  write(Lupri,*)
  write(Lupri,*) SecNam,': mapping from basis function to atom:'
  do i=1,nBasT
    write(Lupri,*) 'Basis function ',i,' is centered on atom ',iBF2Atom(i),' labeled ',AtomLabel(i)(1:LenIn)
  end do
end if

! Allocate and set mapping from 1st reduced set to full storage.
! --------------------------------------------------------------

call mma_allocate(mapRS2F,2,nnBstRT(1),Label='mapRS2F')
call Cho_RStoF(mapRS2F,2,nnBstRT(1),1)

! Allocate counters.
! ------------------

call mma_allocate(nPC1,nAtom,Label='nPC1')
call mma_allocate(RC2,NumChT,Label='RC2')

! Compute statistics.
! -------------------

Rmin = 1.0e15_wp
Rmax = -1.0e15_wp
Rave = Zero
nPC1(:) = 0
RC2(:) = Zero
do iVec=1,NumChT
  iRS1 = InfVec(iVec,1,1)
  iA = mapRS2F(1,iRS1)
  iB = mapRS2F(2,IRS1)
  iAtA = iBF2Atom(iA)
  iAtB = iBF2Atom(iB)
  if (iAtA == iAtB) then
    nPC1(iAtA) = nPC1(iAtA)+1
  else
    R = sqrt((Coord(1,iAtA)-Coord(1,iAtB))**2+(Coord(2,iAtA)-Coord(2,iAtB))**2+(Coord(3,iAtA)-Coord(3,iAtB))**2)
    RC2(iVec) = R
    Rmin = min(Rmin,R)
    Rmax = max(Rmax,R)
    Rave = Rave+R
  end if
end do
nTot1 = sum(nPC1(:))
nTot2 = NumChT-nTot1
if (nTot2 > 0) then
  Rave = Rave/real(nTot2,kind=wp)
else if (nTot2 < 0) then
  call SysAbendMsg(SecNam,'Setup error!','nTot2 < 0')
end if

! Print overall statisctics.
! --------------------------

write(Lupri,'(//,2X,A,/,2X,A)') 'Parent Diagonals','----------------'
write(Lupri,'(/,A,I9,A,F7.2,A)') 'Number of vectors from 1-center diagonals:',nTot1,' (', &
                                 1.0e2_wp*real(nTot1,kind=wp)/real(NumChT,kind=wp),'%)'
write(Lupri,'(A,I9,A,F7.2,A)') 'Number of vectors from 2-center diagonals:',nTot2,' (', &
                               1.0e2_wp*real(nTot2,kind=wp)/real(NumChT,kind=wp),'%)'

! Print statistics for 1-center vectors.
! --------------------------------------

write(Lupri,'(/,1X,A)') 'Vectors from 1-center diagonals:'
nBatch = (nAtom-nPseudo-1)/numAt+1 ! exclude pseudo-atoms
do iBatch=1,nBatch
  if (iBatch == nBatch) then
    ! exclude pseudo-atoms
    nAt = nAtom-nPseudo-numAt*(nBatch-1)
  else
    nAt = numAt
  end if
  iAt0 = numAt*(iBatch-1)
  iAt1 = iAt0+1
  iAt2 = iAt0+nAt
  do i=1,nAt
    iAt = iAt0+i
    if (nBas_per_Atom(iAt) < 1) then
      if (nPC1(iAt) > 0) call SysAbendMsg(SecNam,'No basis functions, but >0 vectors !?!?',' ')
      Ratio(i) = Zero
    else
      Ratio(i) = real(nPC1(iAt),kind=wp)/real(nBas_per_Atom(iAt),kind=wp)
    end if
  end do
  write(Lupri,'(/,A,6(6X,A))') 'Label              ',(AtomLabel(nBas_Start(i))(1:LenIn),i=iAt1,iAt2)
  write(Lupri,'(A,6(1X,I9))') 'Center no.         ',(i,i=iAt1,iAt2)
  write(Lupri,'(A,6(1X,I9))') 'Vectors (M)        ',(nPC1(i),i=iAt1,iAt2)
  write(Lupri,'(A,6(1X,I9))') 'Basis functions (N)',(nBas_per_Atom(i),i=iAt1,iAt2)
  write(Lupri,'(A,6(1X,F9.2))') 'Ratio (M/N)        ',(Ratio(i),i=1,nAt)
  if (iBatch /= nBatch) write(Lupri,*)
end do

! Print statistics for 2-center vectors.
! --------------------------------------

if (nTot2 > 0) then
  write(Lupri,'(/,1X,A)') 'Vectors from 2-center diagonals:'
  RClass(1) = Rave-(Rave-Rmin)*Half
  RClass(2) = Rave
  RClass(3) = Rave+(Rmax-Rave)*Half
  iClass(:) = 0
  nChk = 0
  do iVec=1,NumChT
    if (RC2(iVec) > Zero) then
      nChk = nChk+1
      if (RC2(iVec) <= RClass(1)) then
        iClass(1) = iClass(1)+1
      else if (RC2(iVec) <= RClass(2)) then
        iClass(2) = iClass(2)+1
      else if (RC2(iVec) <= RClass(3)) then
        iClass(3) = iClass(3)+1
      else
        iClass(4) = iClass(4)+1
      end if
    end if
  end do
  if (nChk /= nTot2) then
    ! FAQ
    ! --- Replace the call to SysAbendMsg with just a warning.
    !
    !call SysAbendMsg(SecNam,'nChk /= nTot2',' ')
    !
    ! --- TODO/FIX  figure out if with ghost atoms is just a mistmatch
    !               or there is really a bug

    write(u6,*) SecNam//': Warning! (nChk /= nTot2); could be due to the presence of ghost atoms.'
  end if
  write(Lupri,'(/,A,3ES15.5)') 'Min, average, and max center distance: ',Rmin,Rave,Rmax
  write(Lupri,'(A,ES12.2,A,I9)') '#vectors with center distance                R <= ',RClass(1),': ',iClass(1)
  write(Lupri,'(A,ES12.2,A,ES12.2,A,I9)') '#vectors with center distance ',RClass(1),' < R <= ',RClass(2),': ',iClass(2)
  write(Lupri,'(A,ES12.2,A,ES12.2,A,I9)') '#vectors with center distance ',RClass(2),' < R <= ',RClass(3),': ',iClass(3)
  write(Lupri,'(A,ES12.2,A,12X,A,I9)') '#vectors with center distance ',RClass(3),' < R    ',': ',iClass(4)
end if

! Deallocations.
! --------------

call mma_deallocate(RC2)
call mma_deallocate(nPC1)
call mma_deallocate(mapRS2F)
call mma_deallocate(iBF2Atom)
call mma_deallocate(Coord)
call mma_deallocate(nBas_Start)
call mma_deallocate(nBas_per_Atom)

end subroutine Cho_Stat_ParentDiag

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_TraDrv(irc,CMO,Diag,DoDiag)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: AO-to-MO (ai) transformation of Cholesky vectors
C              performed directly in reduced sets. This assumes
C              that the MP2 program has been appropriately initialized.
C
      Implicit None
      Integer irc
      Real*8  CMO(*), Diag(*)
      Logical DoDiag
#include "cholesky.fh"
#include "chomp2.fh"
#include "stdalloc.fh"

      Character(LEN=6), Parameter:: ThisNm = 'TraDrv'
      Character(LEN=13), Parameter:: SecNam = 'ChoMP2_TraDrv'

      Real*8, Allocatable:: COcc(:), CVir(:)

      irc = 0

C     Reorder MO coefficients.
C     ------------------------

      Call mma_allocate(COcc,nT1AOT(1),Label='COcc')
      Call mma_allocate(CVir,nAOVir(1),Label='CVir')
      Call ChoMP2_MOReOrd(CMO,COcc,CVir)

C     Transform vectors.
C     ------------------

      Call ChoMP2_Tra(COcc,CVir,Diag,DoDiag)

C     Deallocate reordered MO coefficients.
C     -------------------------------------

      Call mma_deallocate(CVir)
      Call mma_deallocate(COcc)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
       subroutine ccsd(ireturn,run_triples)
c
c     program for CCSD
c
       Logical run_triples
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "filemgr.fh"
#include "paralell.fh"

#include "SysDef.fh"
c
c     work file declaration
       integer wrksize
#include "WrkSpc.fh"
c
c     variables
c
       integer rc,posst,niter,idum(1)
       integer lunabij1,lunabij2,lunabij3
       integer lunt2o1,lunt2o2,lunt2o3
       integer lunw3aaaa,lunw3baab,lunw3bbaa,lunw3bbbb,lunw3abba,
     & lunw3aabb
       integer keyext,keyexc,lunrst
       real*8 scalar,energy,energyold,diff,dum(1)
       integer diispointt(1:4)
       integer diispointr(1:4)
       integer lenv,lenn,possabstack,nabstack,nfree,inv4,infree

       real*8 E1aa,E1bb,E2aaaa,E2bbbb,E2abab
       real*8 pz1aa,pz1bb,pz2abab
CLD    real*8 pz1aa,pz1bb,pz2aaaa,pz2bbbb,pz2abab
c
c      parameters for par
       real*8 timtotcpu,timtotcpun,timdifcpu,timtotwc,timtotwcn,timdifwc
       real*8 timtotit
       integer i
c
       call CWTime (timtotcpu,timtotwc)
       timtotit=timtotwc
c
       energy = 9999999
       energyold=99999
       fullprint=0
       If (iPrintLevel(-1).LE.0) fullprint=-1

c
cI    **************  start   section **************
c
cI.1.1read input data form INPDAT (reorg) and input file
c
       call reainput
c
cI.1.2write head to output file
c
       if (fullprint.ge.0) then
         call wrhead
         if (noccsd.eq.1) then
           write(6,'(6X,A)') 'NOSD key is turned on'
           write(6,'(6X,A)') 'CCSD step is skipped'
           goto 999
         end if
       write (6,*) ' nProcs, myRank',nProcs,myRank
       end if
c
cI.1.3check if there is something to do in CCSD
       call ccsd_exc (keyexc)
       if (keyexc.eq.0) then
         write(6,*) ' No determinants in CCSD expansion '
         write(6,*) ' Zero correlation energy           '
         write(6,*) ' CCSD step excluded                '
         if (run_triples) then
           write(6,*) ' Triples step excluded'
           run_triples=.false.
         end if
         goto 999
       else if (keyexc.eq.1) then
         write(6,*) ' Only monoexcitations in CC expansion '
         write(6,*) ' CCSD step excluded                '
         if (run_triples) then
           write(6,*) ' Triples step excluded'
           run_triples=.false.
         end if
         goto 999
       end if
c
cI.1.4def parametrs for filemgr
c
       call mkfilemgrcom
c
cI.2.1 calc. work space requirements to fix and help mediates
c
       call initfiles (wrksize,lenv,lenn)
       if (fullprint.ge.0)
     &     write(6,*) ' Basic Work space requirements    :',wrksize
c
cI.2.3 allocate work space
c
cI.2.3.1  check free space
       Call GetMem('CCSD','Max','Real',maxspace,maxspace)
       maxspace=maxspace-8
       if (fullprint.ge.0)
     &     write (6,*) ' Max Size',maxspace
c
       if (maxspace.lt.wrksize) then
         write(6,*) ' Allocation of work space failed'
         write(6,*) ' Increase the value of the variable MOLCAS_MEM'
         Call Abend()
       end if
c
cI.2.3.2  fix, where AB stack will be located
       nfree=maxspace-wrksize
       inv4=int(lenv/lenn)
       infree=int(nfree/lenn)
       if (infree.gt.int(inv4/2)) then
c      there is enough free room for AB_stack
         possabstack=wrksize+1
         if (inv4.ge.infree) then
         nabstack=infree
         else
         nabstack=inv4
         end if
         wrksize=wrksize+nabstack*lenn
       else
c      there is not enough free room for AB_stack, will be build in
c      2.nd half of V4
         nabstack=int(inv4/2)
         possabstack=possv40+nabstack*lenn
       end if
c
       if (fullprint.ge.2) then
       write(6,*) ' Dimension of AB stack            :',nabstack
       end if
       if (fullprint.ge.0)
     &     write(6,*) ' Final Work space requirements    :',wrksize
c
cI.2.3.3  check free space
       Call GetMem('CCSD','Allo','Real',iOff,wrksize)
c
cI.2.4 set wrk = 0
       call mv0zero (wrksize,wrksize,Work(iOff))
       if (fullprint.ge.0)
     &     write(6,*) ' Allocation of work space   : Done'
c
cI.2.5read static integrals from INTSTA (reorg) file
c
       call reaintsta (Work(iOff),wrksize)
c
cI.2.6divide fok to faa,fai,fii and dp
c
       call divfok (Work(iOff),wrksize,
     & mapdn,mapin,possn0,mapdp,mapip,possp0,
     & mapdfk1,mapifk1,possfk10,mapdfk2,mapifk2,possfk20,
     & mapdfk3,mapifk3,possfk30,mapdfk4,mapifk4,possfk40,
     & mapdfk5,mapifk5,possfk50,mapdfk6,mapifk6,possfk60,
     & mapddp1,mapidp1,possdp10,mapddp2,mapidp2,possdp20,rc)
c
cI.2.7open 3 files for <ab|ij>aaaa,<ab|ij>bbbb,<ab|ij>abab
       call filemanager (1,lunabij1,rc)
       call filemanager (1,lunabij2,rc)
       call filemanager (1,lunabij3,rc)
c
cI.2.8open 3 files for T2oaaaa,T2obbbb,T2oabab
       call filemanager (1,lunt2o1,rc)
       call filemanager (1,lunt2o2,rc)
       call filemanager (1,lunt2o3,rc)
c
       if (keyrst.ne.0) then
cI.2.91        open fil for restart informations - filerst
       lunrst=16
       call filemanager (4,lunrst,rc)
       end if
c
       if (keyrst.eq.2) then
cI.2.92        read informations from restart file
c
c     get T1aa
       call getmediate (Work(iOff),wrksize,
     & lunrst,posst110,mapdt11,mapit11,rc)
c     get T1bb
       call getmediate (Work(iOff),wrksize,
     & lunrst,posst120,mapdt12,mapit12,rc)
c
c     get and write T2aaaa
       call getmediate (Work(iOff),wrksize,
     & lunrst,possv40,mapdv4,mapiv4,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunt2o1,mapdv4,mapiv4,rc)
c     get and write T2bbbb
       call getmediate (Work(iOff),wrksize,
     & lunrst,possv40,mapdv4,mapiv4,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunt2o2,mapdv4,mapiv4,rc)
c     get and write T2abab
       call getmediate (Work(iOff),wrksize,
     & lunrst,possv40,mapdv4,mapiv4,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunt2o3,mapdv4,mapiv4,rc)
c
       if (iokey.eq.1) then
c      Fortran IO
       read (lunrst,end=97) energyold,niter
c
       else
c      MOLCAS IO
       call ddafile (lunrst,2,dum,1,daddr(lunrst))
       energyold=dum(1)
       call idafile (lunrst,2,idum,1,daddr(lunrst))
       niter=idum(1)
       end if
       goto 98
c
c     case when energy and niter is not in save file
CFUE 97     energyold=0.0d0
 97     energyold=Escf
       niter=0
       write(6,*) ' ENERGY AND NIT WAS NOT IN SAVE FILE, CHANGED TO 0'
c
 98     niter=niter+1
c
       else
cI.2.93 T2naaaa,T2nbbbb and T2nabab are 0, we can write them as T2old
       call wrtmediate (Work(iOff),wrksize,
     & lunt2o1,mapdt21,mapit21,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunt2o2,mapdt22,mapit22,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunt2o3,mapdt23,mapit23,rc)
       end if
c
c
cI.2.10        write V1 (<ab||ij>aaaa) to lunabij1
c     V2 (<ab||ij>bbbb) to lunabij2
c     V3 (<ab||ij>abab) to lunabij3
c
       call wrtmediate (Work(iOff),wrksize,
     & lunabij1,mapdv1,mapiv1,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunabij2,mapdv2,mapiv2,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunabij3,mapdv3,mapiv3,rc)
c
cI.2.11        open lunext files if extrapolation is used
c
       if (yesext.eq.1) then
c     keyext=firstext
c
c*    open files for T and R
       call diisof (diispointt,cycext)
       call diisof (diispointr,cycext)
c
c*    open file for E (extrapolate amplitudes)
       call filemanager (1,lune,rc)
c
c*    write T21,T22,T23,T11,T12 to E (they are zero or restart ones)
c     T2aaaa
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt21,mapit21,rc)
c     T2bbbb
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt22,mapit22,rc)
c     T2abab
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt23,mapit23,rc)
c     T1aa
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt11,mapit11,rc)
c     T1bb
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt12,mapit12,rc)
c
c*
       keyext=0
       end if
c
c*     write head for short + medium printing
       if (fullprint.ge.0 .and. fullprint.lt.2) then
         write(6,*)
         write(6,'(6X,A)')
     &   'Iteration       Total enegy      Corr. energy      Difference'
       end if
c
c
cII   **************  Iteration cycle   **************
c
       if (keyrst.ne.2) then
         niter=1
       end if
c
       call distnodes
c
c
 1     if ((fullprint.ge.1).and.(myRank.eq.0).and.(nProcs.gt.1)) then
         write (6,*) 'Npocab:',nprocab
         do i=1,nprocab
           write (6,*) 'Proc  :',i,idab(i),ideffab(i)
         end do
       write (6,*) 'IDaaaa:',idaaaa
       write (6,*) 'IDaabb:',idaabb
       write (6,*) 'IDabba:',idabba
       write (6,*) 'IDbbbb:',idbbbb
       write (6,*) 'IDbbaa:',idbbaa
       write (6,*) 'IDbaab:',idbaab
       write (6,*) 'IDfin :',idfin
       end if
cpar
c    set ididle,idtmab =0
       do i=1,nProcs
        ididle(i)=0.0d0
        idtmab(i)=0.0d0
       end do
cend par
c
       call init (Work(iOff),wrksize,
     & lunabij1,lunabij2,lunabij3)
       call CWTime (timtotcpun,timtotwcn)
       timdifcpu=timtotcpun-timtotcpu
       timdifwc=timtotwcn-timtotwc
       timtotcpu=timtotcpun
       timtotwc=timtotwcn
       if (fullprint.ge.1) then
         write(6,*) ' Initial section done',myRank,timdifwc,
     &                                     timtotwcn-timtotit
       timtotit=timtotwcn
       end if
c
       call sumoverab (Work(iOff),wrksize,
     & lunt2o1,lunt2o2,lunt2o3,nabstack,possabstack,niter)
       call CWTime (timtotcpun,timtotwcn)
       timdifcpu=timtotcpun-timtotcpu
       timdifwc=timtotwcn-timtotwc
       timtotcpu=timtotcpun
       timtotwc=timtotwcn
       if (fullprint.ge.1) then
         write(6,*) ' Sumation over ab done',myRank,timdifwc
       end if
c
cpar   store time spend in sumoverab process for this node
       idtmab(myRank+1)=timdifwc
c
       call sumovera (Work(iOff),wrksize,
     & lunt2o1,lunt2o2,lunt2o3,
     & lunw3aaaa,lunw3baab,lunw3bbaa,lunw3bbbb,lunw3abba,lunw3aabb)
       call CWTime (timtotcpun,timtotwcn)
       timdifcpu=timtotcpun-timtotcpu
       timdifwc=timtotwcn-timtotwc
       timtotcpu=timtotcpun
       timtotwc=timtotwcn
       if (fullprint.ge.1) then
         write(6,*) ' Sumation over a done',myRank,timdifwc
       end if
c
       call intermezzo (Work(iOff),wrksize,
     & lunw3aaaa,lunw3bbbb,lunw3abba,
     & lunw3baab,lunw3aabb,lunw3bbaa,lunt2o1,lunt2o2,lunt2o3,
     & lunabij1,lunabij2,lunabij3)
       call CWTime (timtotcpun,timtotwcn)
       timdifcpu=timtotcpun-timtotcpu
       timdifwc=timtotwcn-timtotwc
       timtotcpu=timtotcpun
       timtotwc=timtotwcn
       if (fullprint.ge.1) then
         write(6,*) ' Internal section done',myRank,timdifwc
       end if
c
       call finale (Work(iOff),wrksize,
     & lunabij1,lunabij2,lunabij3,
     & lunt2o1,lunt2o2,lunt2o3)
       call CWTime (timtotcpun,timtotwcn)
       timdifcpu=timtotcpun-timtotcpu
       timdifwc=timtotwcn-timtotwc
       timtotcpu=timtotcpun
       timtotwc=timtotwcn
       if (fullprint.ge.1) then
         write(6,*) ' Final section done',myRank,timdifwc
       end if
c
#ifdef _MOLCAS_MPP_
cpar
       call joinamplitudes (Work(iOff),wrksize)
       call CWTime (timtotcpun,timtotwcn)
       timdifcpu=timtotcpun-timtotcpu
       timdifwc=timtotwcn-timtotwc
       timtotcpu=timtotcpun
       timtotwc=timtotwcn
       if (fullprint.ge.1) then
         write(6,*) ' Amplitudes allreduced',myRank,timdifwc
       end if
c
c      store differntial wc time at this point to calculate idle time
c      and redefine ideffab for next step
       ididle(myRank+1)=timdifwc
       if (niter.gt.0) then
         call redef
         if ((myRank.eq.0).and.(fullprint.ge.1)) then
         write (6,997) ' ABTim',(idtmab(i),i=1,nProcs)
           write (6,997) ' IDtim',(ididle(i),i=1,nProcs)
           write (6,997) ' EFF  ',(ideffab(i),i=1,nprocab)
997        format (a6,2x,16(f7.2,1x))
       end if
       end if
cendpar
#endif
c
cIII  *********** division, SA, extrapolation, energy, tests *************
c
c
c3.1  division by denominators (divided amplitudes are stored in the same files
c     like T1n and T2n
c
c3.1.1div. T1n
       call divt (Work(iOff),wrksize,
     & 2,mapdt13,mapit13,mapddp1,mapidp1,mapddp2,mapidp2,rc)
       call divt (Work(iOff),wrksize,
     & 2,mapdt14,mapit14,mapddp1,mapidp1,mapddp2,mapidp2,rc)
c
c3.1.2div. T2n
       call divt (Work(iOff),wrksize,
     & 4,mapdt21,mapit21,mapddp1,mapidp1,mapddp2,mapidp2,rc)
       call divt (Work(iOff),wrksize,
     & 4,mapdt22,mapit22,mapddp1,mapidp1,mapddp2,mapidp2,rc)
       call divt (Work(iOff),wrksize,
     & 4,mapdt23,mapit23,mapddp1,mapidp1,mapddp2,mapidp2,rc)
c
c
c3.2  Spin adaptation
c
       if (keysa.gt.0) then
       call saamp (Work(iOff),wrksize,
     & keysa)
       end if
c
c
c3.3  extrapolation
       if (yesext.eq.1) then
c
c*    write new Tn (T21,T22,T23,T13,T14) to T stack
       call diiswa1 (Work(iOff),wrksize,
     & diispointt)
c
c*    calc Tn = Tn - E
       call calcr (Work(iOff),wrksize,
     & lune)
c
c*    write Tn=Tn-E to R stack
       call diiswa1 (Work(iOff),wrksize,
     & diispointr)
c
c*    do diis Tn = DIIS (Tprev) if necc.
       call diis (Work(iOff),wrksize,
     & diispointt,diispointr,keyext)
c
c*    write Tn = T(DIIS) to E
c     rewind lune
       call filemanager (2,lune,rc)
c     T2aaaa
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt21,mapit21,rc)
c     T2bbbb
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt22,mapit22,rc)
c     T2abab
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt23,mapit23,rc)
c     T1aa
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt13,mapit13,rc)
c     T1bb
       call wrtmediate (Work(iOff),wrksize,
     & lune,mapdt14,mapit14,rc)
c
c
       end if
c
c
c3.4  save restart informations - amplitudes
       if (keyrst.ne.0) then
       call saverest1 (Work(iOff),wrksize,
     & lunrst)
       end if
c
c
c3.5  write Tn into place of to
c
c3.5.1put t1naa -> t1oaa
       call map (Work(iOff),wrksize,
     & 2,1,2,0,0,mapdt13,mapit13,1,mapdt11,mapit11,posst110,
     &           posst,rc)
c
c3.5.2put t1nbb -> t1obb
       call map (Work(iOff),wrksize,
     & 2,1,2,0,0,mapdt14,mapit14,1,mapdt12,mapit12,posst120,
     &           posst,rc)
c
c3.5.3rewind lunt2o1 and write t2naaaa there
       call filemanager (2,lunt2o1,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunt2o1,mapdt21,mapit21,rc)
c
c3.5.4rewind lunt2o2 and write t2nbbbb there
       call filemanager (2,lunt2o2,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunt2o2,mapdt22,mapit22,rc)
c
c3.5.5rewind lunt2o3 and write t2nabab there
       call filemanager (2,lunt2o3,rc)
       call wrtmediate (Work(iOff),wrksize,
     & lunt2o3,mapdt23,mapit23,rc)
c
c     test zero
       call percentzero (Work(iOff),wrksize,
     & mapdt13,pz1aa)
       call percentzero (Work(iOff),wrksize,
     & mapdt14,pz1bb)
c      call percentzero (Work(iOff),wrksize,
c    & mapdt21,pz2aaaa)
c      call percentzero (Work(iOff),wrksize,
c    & mapdt22,pz2bbbb)
       call percentzero (Work(iOff),wrksize,
     & mapdt23,pz2abab)
c
c
c3.6  calc energy
CFUE   energy=0.0d0
       energy=Escf
       scalar=0.0d0
c
c3.6.1calc fai(a,i)aa . t1(a,i)aa
       call multdot (Work(iOff),wrksize,
     & 2,mapdfk3,mapifk3,1,mapdt13,mapit13,1,scalar,rc)
       energy=energy+scalar
       E1aa = scalar
CFUE   write(6,22) scalar
c
c3.6.2calc fai(a,i)bb . t1(a,i)bb
       call multdot (Work(iOff),wrksize,
     & 2,mapdfk4,mapifk4,1,mapdt14,mapit14,1,scalar,rc)
       energy=energy+scalar
       E1bb = scalar
CFUE   write(6,22) scalar
c
c3.6.3get <ab||ij>aaaa into V1 and calc V1(abij) . Tau(abij)aaaa
       call filemanager (2,lunabij1,rc)
       call getmediate (Work(iOff),wrksize,
     & lunabij1,possv10,mapdv1,mapiv1,rc)
       call mktau (Work(iOff),wrksize,
     & mapdt21,mapit21,mapdt13,mapit13,mapdt13,mapit13,
     &             1.0d0,rc)
       call multdot (Work(iOff),wrksize,
     & 4,mapdv1,mapiv1,1,mapdt21,mapit21,1,scalar,rc)
       energy=energy+scalar
       E2aaaa = scalar
CFUE   write(6,22) scalar
c
c3.6.4get <ab||ij>bbbb into V1 and calc V1(abij) . Tau(abij)bbbb
       call filemanager (2,lunabij2,rc)
       call getmediate (Work(iOff),wrksize,
     & lunabij2,possv10,mapdv1,mapiv1,rc)
       call mktau (Work(iOff),wrksize,
     & mapdt22,mapit22,mapdt14,mapit14,mapdt14,mapit14,
     &             1.0d0,rc)
       call multdot (Work(iOff),wrksize,
     & 4,mapdv1,mapiv1,1,mapdt22,mapit22,1,scalar,rc)
       energy=energy+scalar
       E2bbbb = scalar
CFUE   write(6,22) scalar
c
c3.6.5get <ab||ij>abab into V1 and calc V1(abij) . Tau(abij)abab
       call filemanager (2,lunabij3,rc)
       call getmediate (Work(iOff),wrksize,
     & lunabij3,possv10,mapdv1,mapiv1,rc)
       call mktau (Work(iOff),wrksize,
     & mapdt23,mapit23,mapdt13,mapit13,mapdt14,mapit14,
     &             1.0d0,rc)
       call multdot (Work(iOff),wrksize,
     & 4,mapdv1,mapiv1,1,mapdt23,mapit23,1,scalar,rc)
       energy=energy+scalar
       E2abab = scalar
CFUE   write(6,22) scalar
CFUE   write(6,22) energy
C22    format (2x,f20.15)
c
c
c3.7  save restart informations - energy, iteration cycle
       if (keyrst.ne.0) then
       call saverest2 (lunrst,energy,niter,iokey,daddr(lunrst))
       end if
c
ctmp   call timing (timtotcpu,timdifcpu,timtotwc,timdifwc)
       call CWTime (timtotcpun,timtotwcn)
       timdifcpu=timtotcpun-timtotcpu
       timdifwc=timtotwcn-timtotwc
       timtotcpu=timtotcpun
       timtotwc=timtotwcn
       if (fullprint.ge.1) then
         write(6,*) ' Adapt., Extrap. and Energy evaluation done ',
     c               myRank,timdifwc,timtotwc
       end if
c
c
c3.8  test of convergence or termination
c
       diff=energy-energyold
       If (niter.eq.1) diff=E1aa+E1bb+E2aaaa+E2bbbb+E2abab
       energyold=energy
c
       if (fullprint.ge.0 .and. fullprint.le.1) then
c      reduced printing
         write(6,'(6X,I5,5X,F17.8,2X,2(F15.8,2X))')
     &   niter,energy,E1aa+E1bb+E2aaaa+E2bbbb+E2abab,diff
c
       else if (fullprint.ge.2) then
c      full printing
         write(6,*)
         write(6,'(6X,A,I4)') 'Iteration No        :',niter
         write(6,'(6X,A,2F24.13)') 'Total energy (diff) :',energy,diff
         write(6,'(6X,A,F24.13)') 'Correlation energy  :',
     &                         E1aa+E1bb+E2aaaa+E2bbbb+E2abab
         write(6,'(6X,A,F24.13)') 'Reference energy    :',Escf
         write(6,'(6X,A,F17.8)')  'E1aa   contribution :',E1aa
         write(6,'(6X,A,F17.8)')  'E1bb   contribution :',E1bb
         write(6,'(6X,A,F17.8)')  'E2aaaa contribution :',E2aaaa
         write(6,'(6X,A,F17.8)')  'E2bbbb contribution :',E2bbbb
         write(6,'(6X,A,F17.8)')  'E2abab contribution :',E2abab
         write(6,'(6X,A)')
     &   '% of small amplitudes in  T1aa   T1bb   T2aaaa T2bbbb T2abab'
         write(6,'(31X,5(F5.1,2X))')
     &        pz1aa,pz1bb,pz2abab
c
       end if
       Call Add_Info('E_CCSD',[Energy],1,8)
c
       niter=niter+1
c
*--- the original code depends on print level!!!!!!!
*      if (abs(diff).le.ccconv .and. fullprint.ge.0) then
*        write(6,*) '     Convergence after ',niter,
*    &   ' Iterations'
*      else if (niter.gt.maxiter .and. fullprint.ge.0) then
*        write(6,*) '     Convergence not reached'
*      else if (niter.le.maxiter)then
*        goto 1
*      end if
       if (abs(diff).le.ccconv) then
         write(6,*) '     Convergence after ',niter,
     &   ' Iterations'
       else if (niter.gt.maxiter) then
         write(6,*) '     Convergence not reached'
       else if (niter.le.maxiter)then
         goto 1
       end if
       IF (fullprint.ge.0) THEN
         write(6,*)
         write(6,*)
c
c
c**   **************     Finitto      **************
c
         write(6,'(6X,A,2F17.8)') 'Total energy (diff) :',energy,diff
         write(6,'(6X,A,F24.13)') 'Correlation energy  :',
     &                         E1aa+E1bb+E2aaaa+E2bbbb+E2abab
         write(6,'(6X,A,F24.13)') 'Reference energy    :',Escf
         write(6,'(6X,A,F17.8)')  'E1aa   contribution :',E1aa
         write(6,'(6X,A,F17.8)')  'E1bb   contribution :',E1bb
         write(6,'(6X,A,F17.8)')  'E2aaaa contribution :',E2aaaa
         write(6,'(6X,A,F17.8)')  'E2bbbb contribution :',E2bbbb
         write(6,'(6X,A,F17.8)')  'E2abab contribution :',E2abab
         write(6,*)
         write(6,*)
       ENDIF
c Export a method and energy to the MOLCAS runfile
       Call Put_cArray('Relax Method','CCSDT   ',8)
       Call Store_Energies(1,[Energy],1)
c
c4.0  type 5 maximal elements + euclidian norms in each type of amplitudes
c
c4.0.1T1aa
       call max5 (Work(iOff),wrksize,
     & 2,mapdt13,mapit13,'T1aa    ')
c
c4.0.2T1bb
       call max5 (Work(iOff),wrksize,
     & 2,mapdt14,mapit14,'T1bb    ')
c
c4.0.3T2aaaa
       call max5 (Work(iOff),wrksize,
     & 4,mapdt21,mapit21,'T2aaaa  ')
c
c4.0.4T2bbbb
       call max5 (Work(iOff),wrksize,
     & 4,mapdt22,mapit22,'T2bbbb  ')
c
c4.0.5T2abab
       call max5 (Work(iOff),wrksize,
     & 4,mapdt23,mapit23,'T2abab  ')
c
c4.1  close lunabij1,2,3
       call filemanager (3,lunabij1,rc)
       call filemanager (3,lunabij2,rc)
       call filemanager (3,lunabij3,rc)
c
c4.2  close lunt2o1,2,3
       call filemanager (3,lunt2o1,rc)
       call filemanager (3,lunt2o2,rc)
       call filemanager (3,lunt2o3,rc)
c
c4.3  close lunext files if extrapolation is used
       if (yesext.eq.1) then
       call diiscf (diispointt,cycext)
       call diiscf (diispointr,cycext)
       call filemanager (3,lune,rc)
       end if
c
c4.4  close lunrst file if restart informations was stored
       if (keyrst.ne.0) then
       call filemanager (3,lunrst,rc)
       end if
c global ccsd synchronization point for parallel runs
       Call GASync()

c      Releasing the memory
       Call GetMem('CCSD','Free','Real',iOff,wrksize)
c
999    If (fullprint.ge.0) then
         write(6,*)
         write(6,'(6X,A)') 'Happy Landing!'
         write(6,*)
       EndIf
c
       ireturn=0
       return
       end
c
c     ---------------
c
       subroutine percentzero (wrk,wrksize,
     & mapd,pz)
c
c     this routine test % of small elements in meditate, decribed by mpd
c
c     mapd - direct map of required mediate (I)
c
#include "wrk.fh"
       integer mapd(0:512,1:6)
       real*8  pz
c
c     help variables
c
       integer poss,lenght
       integer nhelp,nzero
       real*8 zerolim
c
c     def lenght, poss, zerolim
c
       poss=mapd(1,1)
       nhelp=mapd(0,5)
       lenght=mapd(nhelp,1)+mapd(nhelp,2)-mapd(1,1)
       zerolim=1.0d-6
c
       if (lenght.gt.0) then
       nzero=0
       do 100 nhelp=poss,poss+lenght-1
       if (abs(wrk(nhelp)).lt.zerolim) then
       nzero=nzero+1
       end if
 100    continue
       pz = dble(100*nzero)/dble(lenght)
       else
       pz=1.0d0
       end if
c
       return
       end
c
c     ---------------
c
        subroutine ccsd_exc (key)
c
c       check, if there is atleast one determinant in CCSD expansion
c       key=0 - no determinant in expansion
c           1 - only monoexcitations in expansion
c           2 - both mono and biexcitations in expansion
c
        implicit none
#include "ccsd1.fh"
        integer key
c
c       help variables
        integer isym,jsym,ijsym,asym,bsym,nij,nab
        integer naa,nbb,naaaa,nbbbb,nabab
c
c
c1.1    calc # of monoexcitations
c       taking into account also symmetry

        naa=0
        nbb=0
        do isym=1,nsym
          asym=isym
          naa=naa+noa(isym)*nva(asym)
          nbb=nbb+nob(isym)*nvb(asym)
        end do
c
c1.2    calc # of biexcitation
c       taking into account also symmetry
c
        naaaa=0
        do isym=1,nsym
        do jsym=1,isym
        ijsym=mmul(isym,jsym)
        if (isym.eq.jsym) then
          nij=noa(isym)*(noa(isym)-1)/2
        else
          nij=noa(isym)*noa(jsym)
        end if
          do asym=1,nsym
          bsym=mmul(ijsym,asym)
          if (bsym.lt.asym) then
            nab=nva(asym)*nva(bsym)
          else if (bsym.eq.asym) then
            nab=nva(asym)*(nva(asym)-1)/2
          else
            nab=0
          end if
          naaaa=naaaa+nij*nab
          end do
        end do
        end do
c
        nbbbb=0
        do isym=1,nsym
        do jsym=1,isym
        ijsym=mmul(isym,jsym)
        if (isym.eq.jsym) then
          nij=nob(isym)*(nob(isym)-1)/2
        else
          nij=nob(isym)*nob(jsym)
        end if
          do asym=1,nsym
          bsym=mmul(ijsym,asym)
          if (bsym.lt.asym) then
            nab=nvb(asym)*nvb(bsym)
          else if (bsym.eq.asym) then
            nab=nvb(asym)*(nvb(asym)-1)/2
          else
            nab=0
          end if
          nbbbb=nbbbb+nij*nab
          end do
        end do
        end do
c
        nabab=0
        do isym=1,nsym
        do jsym=1,isym
        ijsym=mmul(isym,jsym)
        nij=noa(isym)*nob(jsym)
          do asym=1,nsym
          bsym=mmul(ijsym,asym)
          nab=nva(asym)*nvb(bsym)
          nabab=nabab+nij*nab
          end do
        end do
        end do
c
c
c2      set key
c
        if ((naaaa+nbbbb+nabab).eq.0) then
          if ((naa+nbb).eq.0) then
            key=0
          else
            key=1
          end if
        else
          key=2
        end if
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine fstring_cvb(strings,nstring,istring,ncmp,ifc)

use casvb_global, only: inputmode
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nstring, ncmp, ifc
character(len=*), intent(in) :: strings(nstring)
integer(kind=iwp), intent(inout) :: istring
integer(kind=iwp) :: ierr
logical(kind=iwp) :: done
character(len=8) :: string
logical(kind=iwp), parameter :: debug = .false.

if (inputmode == 2) then
  call gethfs_cvb(istring)
  if (debug) then
    write(u6,*) ' fstring :',istring
    if (istring /= 0) write(u6,*) ' fstring :',strings(istring)
  end if
  return
end if
call popfield_cvb(ifc)
call rdstring_cvb(string,ierr)
done = .false.
do istring=1,nstring
  if (string(1:ncmp) == strings(istring)(1:ncmp)) then
    ! For keywords starting by END we check more letters. This
    ! implementation is a bit ungainly, but simpler to code:
    if (string(1:3) == 'END') then
      if (string(4:ncmp+3) /= strings(istring)(4:ncmp+3)) cycle
    end if
    done = .true.
    exit
  end if
end do
if (.not. done) then
  istring = 0
  call pushfield_cvb()
end if
if (inputmode == 1) call seth_cvb([istring],1)
if (debug) then
  write(u6,*) ' fstring :',istring
  if (istring /= 0) write(u6,*) ' fstring :',strings(istring)
end if

return

end subroutine fstring_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetIndx_JK_2P(AB,CD)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Set index arrays for evaluating (J_AB | K_CD) integrals.
C     To unset: Call LDF_UnsetIndx_JK_2P().
C
C     Makes use of LDF_SetIndxG for each of the atom pairs; hence,
C     values set by LDF_SetIndxG should be properly unset before calling
C     this routine!
C
C
      Implicit None
      Integer AB, CD
#include "localdf_int.fh"

      Call LDF_SetIndxG(AB)
      Call LDF_Transfer1('AB',ip_IndxG,l_IndxG_1,l_IndxG_2,
     &                        ip_IndxG2,l_IndxG2_1,l_IndxG2_2,
     &                        ip_2CList,l_2CList_1,l_2CList_2)
      ip_IndxG=0
      l_IndxG_1=0
      l_IndxG_2=0
      ip_IndxG2=0
      l_IndxG2_1=0
      l_IndxG2_2=0
      ip_2CList=0
      l_2CList_1=0
      l_2CList_2=0
      Call LDF_SetIndxG(CD)
      Call LDF_Transfer1('CD',ip_IndxG,l_IndxG_1,l_IndxG_2,
     &                        ip_IndxG2,l_IndxG2_1,l_IndxG2_2,
     &                        ip_2CList,l_2CList_1,l_2CList_2)
      ip_IndxG=0
      l_IndxG_1=0
      l_IndxG_2=0
      ip_IndxG2=0
      l_IndxG2_1=0
      l_IndxG2_2=0
      ip_2CList=0
      l_2CList_1=0
      l_2CList_2=0
      Call LDF_SetDim_JK_2P(AB,CD)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_SetDim_JK_2P(AB,CD)
      Implicit None
      Integer AB, CD
#include "localdf_int2.fh"

      Integer  LDF_nBasAux_Pair
      External LDF_nBasAux_Pair

      nAB=LDF_nBasAux_Pair(AB)
      nCD=LDF_nBasAux_Pair(CD)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Transfer1(Label,
     &                         ip_IndxG,l_IndxG_1,l_IndxG_2,
     &                         ip_IndxG2,l_IndxG2_1,l_IndxG2_2,
     &                         ip_2CList,l_2CList_1,l_2CList_2)
      Implicit None
      Character*2 Label
      Integer ip_IndxG,  l_IndxG_1,  l_IndxG_2
      Integer ip_IndxG2, l_IndxG2_1, l_IndxG2_2
      Integer ip_2CList, l_2CList_1, l_2CList_2
#include "localdf_int2.fh"

      If (Label.eq.'AB') Then
         ip_AB_IndxG=ip_IndxG
         l_AB_IndxG_1=l_IndxG_1
         l_AB_IndxG_2=l_IndxG_2
         ip_AB_IndxG2=ip_IndxG2
         l_AB_IndxG2_1=l_IndxG2_1
         l_AB_IndxG2_2=l_IndxG2_2
         ip_AB_2CList=ip_2CList
         l_AB_2CList_1=l_2CList_1
         l_AB_2CList_2=l_2CList_2
      Else If (Label.eq.'CD') Then
         ip_CD_IndxG=ip_IndxG
         l_CD_IndxG_1=l_IndxG_1
         l_CD_IndxG_2=l_IndxG_2
         ip_CD_IndxG2=ip_IndxG2
         l_CD_IndxG2_1=l_IndxG2_1
         l_CD_IndxG2_2=l_IndxG2_2
         ip_CD_2CList=ip_2CList
         l_CD_2CList_1=l_2CList_1
         l_CD_2CList_2=l_2CList_2
      Else
         Call WarningMessage(2,'LDF_Transfer1: unknown Label')
         Call LDF_Quit(1)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_Transfer2(ip_IndxG_,l_IndxG_1_,l_IndxG_2_,
     &                         ip_IndxG2_,l_IndxG2_1_,l_IndxG2_2_,
     &                         ip_2CList_,l_2CList_1_,l_2CList_2_)
      Implicit None
      Integer ip_IndxG_,  l_IndxG_1_,  l_IndxG_2_
      Integer ip_IndxG2_, l_IndxG2_1_, l_IndxG2_2_
      Integer ip_2CList_, l_2CList_1_, l_2CList_2_
#include "localdf_int.fh"

      ip_IndxG=ip_IndxG_
      l_IndxG_1=l_IndxG_1_
      l_IndxG_2=l_IndxG_2_
      ip_IndxG2=ip_IndxG2_
      l_IndxG2_1=l_IndxG2_1_
      l_IndxG2_2=l_IndxG2_2_
      ip_2CList=ip_2CList_
      l_2CList_1=l_2CList_1_
      l_2CList_2=l_2CList_2_

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_UnsetIndx_JK_2P()
      Implicit None
#include "localdf_int2.fh"

      Call LDF_Transfer2(ip_AB_IndxG,l_AB_IndxG_1,l_AB_IndxG_2,
     &                   ip_AB_IndxG2,l_AB_IndxG2_1,l_AB_IndxG2_2,
     &                   ip_AB_2CList,l_AB_2CList_1,l_AB_2CList_2)
      Call LDF_UnsetIndxG()
      Call LDF_Transfer2(ip_CD_IndxG,l_CD_IndxG_1,l_CD_IndxG_2,
     &                   ip_CD_IndxG2,l_CD_IndxG2_1,l_CD_IndxG2_2,
     &                   ip_CD_2CList,l_CD_2CList_1,l_CD_2CList_2)
      Call LDF_UnsetIndxG()

      ip_AB_IndxG=0
      l_AB_IndxG_1=0
      l_AB_IndxG_2=0
      ip_AB_IndxG2=0
      l_AB_IndxG2_1=0
      l_AB_IndxG2_2=0
      ip_AB_2CList=0
      l_AB_2CList_1=0
      l_AB_2CList_2=0

      ip_CD_IndxG=0
      l_CD_IndxG_1=0
      l_CD_IndxG_2=0
      ip_CD_IndxG2=0
      l_CD_IndxG2_1=0
      l_CD_IndxG2_2=0
      ip_CD_2CList=0
      l_CD_2CList_1=0
      l_CD_2CList_2=0

      nAB=0
      nCD=0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GT1DIA_MCLR(H1DIA)

use MCLR_Data, only: FIMO, ipCM
use input_mclr, only: nAsh, nIsh, nOrb, nSym
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: H1DIA(*)
integer(kind=iwp) :: i, iAsh, ii, iS

i = 1
do iS=1,nSym
  ii = ipCM(iS)+nOrb(iS)*(nIsh(iS)-1)+nIsh(iS)-1
  do iAsh=1,nAsh(iS)
    ii = ii+nOrb(iS)+1
    H1DIA(i) = FIMO(ii)
    i = i+1
  end do
end do

end subroutine GT1DIA_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#ifdef _GROMACS_
      SUBROUTINE RunGromacs(nAtIn,Coord,ipMltp,MltOrd,Forces,
     &                      ipGrad,Energy)

      USE, INTRINSIC :: iso_c_binding, only: c_int, c_loc, c_ptr
      IMPLICIT NONE

#include "espf.fh"
#include "opt_mmo.fh"
#include "stdalloc.fh"

      INTEGER, INTENT(IN) :: ipMltp,MltOrd,nAtIn
      INTEGER, INTENT(OUT) :: ipGrad
      REAL*8, DIMENSION(3,nAtIn), INTENT(IN) :: Coord
      REAL*8, INTENT(OUT) :: Energy
      LOGICAL, INTENT(IN) :: Forces

      TYPE(c_ptr) :: ipCR,ipGMS
      INTEGER :: iAtGMX,iAtIn,iAtOut,ic,iLast,iOk
      INTEGER :: j,LuExtPot,LuWr,nAtGMX,nAtOut
      INTEGER, DIMENSION(:), ALLOCATABLE :: AT
      REAL*8 :: EnergyGMX,Energy2GMX,q
      REAL*8, DIMENSION(:), ALLOCATABLE :: PotGMX,Pot2GMX
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: CoordGMX,CoordMMO
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: FieldGMX,Field2GMX
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: ForceGMX,Force2GMX
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: GradMMO
      CHARACTER(LEN=12) :: ExtPotFormat
      CHARACTER(LEN=100) :: ProgName
      CHARACTER(LEN=256) :: LogFileName,Message,TPRFileName
      LOGICAL :: Found,isNotLast

      INTEGER, EXTERNAL :: isFreeUnit
      CHARACTER(LEN=100), EXTERNAL :: Get_SuperName
      INTERFACE
        SUBROUTINE mmslave_done(gms) BIND(C,NAME='mmslave_done_')
          USE, INTRINSIC :: iso_c_binding, ONLY: c_ptr
          TYPE(c_ptr), VALUE :: gms
        END SUBROUTINE mmslave_done
        FUNCTION mmslave_init(cr,log_) BIND(C,NAME='mmslave_init_')
          USE, INTRINSIC :: iso_c_binding, ONLY: c_char, c_ptr
          TYPE(c_ptr) :: mmslave_init
          TYPE(c_ptr), VALUE :: cr
          CHARACTER(kind=c_char) :: log_(*)
        END FUNCTION mmslave_init
        FUNCTION mmslave_read_tpr(tpr,gms)
     &           BIND(C,NAME='mmslave_read_tpr_')
          USE, INTRINSIC :: iso_c_binding, ONLY: c_char, c_int, c_ptr
          INTEGER(kind=c_int) :: mmslave_read_tpr
          CHARACTER(kind=c_char) :: tpr(*)
          TYPE(c_ptr), VALUE :: gms
        END FUNCTION mmslave_read_tpr
        FUNCTION mmslave_set_q(gms,id,q) BIND(C,NAME='mmslave_set_q_')
          USE, INTRINSIC :: iso_c_binding, ONLY: c_double, c_int, c_ptr
          INTEGER(kind=c_int) :: mmslave_set_q
          TYPE(c_ptr), VALUE :: gms
          INTEGER(kind=c_int), VALUE :: id
          REAL(kind=c_double), VALUE :: q
        END FUNCTION mmslave_set_q
        FUNCTION init_commrec() BIND(C,NAME='init_commrec_')
          USE, INTRINSIC :: iso_c_binding, ONLY: c_ptr
          TYPE(c_ptr) :: init_commrec
        END FUNCTION init_commrec
      END INTERFACE


      LuExtPot = 1
      LuWr = 6
      Energy = Zero
      ProgName = Get_SuperName()

      WRITE(ExtPotFormat,'(a4,i2,a6)') '(I4,',MxExtPotComp,'F13.8)'

! Get MMO coordinates and atom types from runfile
      CALL Qpg_dArray('MMO Coords',Found,nAtOut)
      nAtOut = nAtOut/3
      CALL mma_allocate(CoordMMO,3,nAtOut)
      IF (Found) THEN
         CALL Get_dArray('MMO Coords',CoordMMO,3*nAtOut)
      ELSE
         Message = 'RunGromacs: MMO coordinates not found on runfile'
         CALL WarningMessage(2,Message)
         CALL Abend()
      END IF

      CALL Qpg_iArray('Atom Types',Found,nAtGMX)
      CALL mma_allocate(AT,nAtGMX)
      IF (Found) THEN
         CALL Get_iArray('Atom Types',AT,nAtGMX)
      ELSE
         Message = 'RunGromacs: Atom types not found on runfile'
         CALL WarningMessage(2,Message)
         CALL Abend()
      END IF

! Since this is the first time we use information from runfile, do a
! consistency check
      IF (nAtGMX.NE.nAtIn+nAtOut) THEN
         Message = 'RunGromacs: nAtGMX and nAtIn+nAtOut not equal'
         CALL WarningMessage(2,Message)
         CALL Abend()
      END IF

! Initialize Gromacs mmslave
      ipCR = init_commrec()
      CALL prgmtranslate('GMX.LOG',LogFileName,iLast)
      LogFileName(iLast+1:iLast+1) = CHAR(0)
      ipGMS = mmslave_init(ipCR,LogFileName)

! Let Gromacs read tpr file
      TPRFileName = TPRDefName
      iLast = LEN_TRIM(TPRFileName)
      TPRFileName(iLast+1:iLast+1) = CHAR(0)
      iOk = mmslave_read_tpr(TPRFileName,ipGMS)
      IF (iOk.ne.1) THEN
         Message = 'RunGromacs: mmslave_read_tpr is not ok'
         CALL WarningMessage(2,Message)
         CALL Abend()
      END IF

! Perform microiterations, though only if (1) it is requested, (2) there
! are MMO atoms to optimize, (3) not last energy, (4) multipoles are
! available, and (5) no gradient calculation
      IF (MMIterMax>0.AND.nAtOut>0) THEN
         isNotLast = ProgName(1:11).NE.'last_energy'
         IF ((ipMltp.NE.ip_Dummy).AND.(.NOT.Forces).AND.isNotLast) THEN
            CALL Opt_MMO(nAtIn,Coord,nAtOut,CoordMMO,nAtGMX,AT,ipGMS)
         END IF
      END IF

! Trick: Set QM charges in Gromacs to zero (or, currently, to a very
! small number). This is needed to exclude their contribution to the
! external potential.
      DO iAtGMX = 1,nAtGMX
         IF (AT(iAtGMX)==QM) THEN
            iOk = mmslave_set_q(ipGMS,INT(iAtGMX-1,kind=c_int),
     &                          SmallNumber)
            IF (iOk.NE.1) THEN
               Message = 'RunGromacs: mmslave_set_q is not ok'
               CALL WarningMessage(2,Message)
               CALL Abend()
            END IF
         END IF
      END DO

! Get energy, forces and external potential from Gromacs
      CALL mma_allocate(CoordGMX,3,nAtGMX)
      CALL mma_allocate(FieldGMX,3,nAtGMX)
      CALL mma_allocate(ForceGMX,3,nAtGMX)
      CALL mma_allocate(PotGMX,nAtGMX)
      iAtIn = 1
      iAtOut = 1
      DO iAtGMX = 1,nAtGMX
         IF (AT(iAtGMX)==QM.OR.AT(iAtGMX)==MMI) THEN
            CALL dcopy_(3,Coord(1,iAtIn),1,CoordGMX(1,iAtGMX),1)
            iAtIn = iAtIn+1
         ELSE
            CALL dcopy_(3,CoordMMO(1,iAtOut),1,CoordGMX(1,iAtGMX),1)
            iAtOut = iAtOut+1
         END IF
      END DO
      CALL dscal_(3*nAtGMX,AuToNm,CoordGMX,1)
      CALL dcopy_(3*nAtGMX,Zero,0,FieldGMX,1)
      CALL dcopy_(3*nAtGMX,Zero,0,ForceGMX,1)
      CALL dcopy_(nAtGMX,Zero,0,PotGMX,1)
      iOk = mmslave_calc_energy_wrapper(ipGMS,CoordGMX,ForceGMX,
     &                                  FieldGMX,PotGMX,EnergyGMX)
      IF (iOk.NE.1) THEN
         Message='RunGromacs: mmslave_calc_energy is not ok'
         CALL WarningMessage(2,Message)
         CALL Abend()
      END IF

! Special case: forces on MM atoms
      IF (Forces) THEN
         ic = 0
         CALL mma_allocate(Field2GMX,3,nAtGMX)
         CALL mma_allocate(Force2GMX,3,nAtGMX)
         CALL mma_allocate(Pot2GMX,nAtGMX)
         CALL dcopy_(3*nAtGMX,Zero,0,Field2GMX,1)
         CALL dcopy_(3*nAtGMX,Zero,0,Force2GMX,1)
         CALL dcopy_(nAtGMX,Zero,0,Pot2GMX,1)
         DO iAtGMX = 1,nAtGMX
            IF (AT(iAtGMX)==QM) THEN
               q = Work(ipMltp+ic)
               iOk = mmslave_set_q(ipGMS,INT(iAtGMX-1,kind=c_int),q)
               IF (iOk.ne.1) THEN
                  Message = 'RunGromacs: mmslave_set_q is not ok'
                  CALL WarningMessage(2,Message)
                  CALL Abend()
               END IF
               ic = ic+MltOrd
            END IF
         END DO
         iOk = mmslave_calc_energy_wrapper(ipGMS,CoordGMX,Force2GMX,
     &                                     Field2GMX,Pot2GMX,Energy2GMX)
         IF (iOk.NE.1) THEN
            Message = 'RunGromacs: mmslave_calc_energy is not ok'
            CALL WarningMessage(2,Message)
            CALL Abend()
         END IF
      END IF

! Store classical contributions to energy and gradient
      Energy = EnergyGMX/AuToKjPerMol
      IF (Forces) THEN
         CALL GetMem('GradCl','ALLO','REAL',ipGrad,3*nAtIn)
         CALL mma_allocate(GradMMO,3,nAtOut)
         iAtIn = 1
         iAtOut = 1
         DO iAtGMX = 1,nAtGMX
            IF (AT(iAtGMX)==QM) THEN
               CALL dcopy_(3,ForceGMX(1,iAtGMX),1,
     &                     Work(ipGrad+3*(iAtIn-1)),1)
               iAtIn = iAtIn+1
            ELSE IF (AT(iAtGMX)==MMI) THEN
               CALL dcopy_(3,Force2GMX(1,iAtGMX),1,
     &                     Work(ipGrad+3*(iAtIn-1)),1)
               iAtIn = iAtIn+1
            ELSE
               CALL dcopy_(3,Force2GMX(1,iAtGMX),1,
     &                     GradMMO(1,iAtOut),1)
               iAtOut = iAtOut+1
            END IF
         END DO
         CALL dscal_(3*nAtIn,-One/AuToKjPerMolNm,Work(ipGrad),1)
         CALL dscal_(3*nAtOut,-One/AuToKjPerMolNm,GradMMO,1)
         CALL Put_dArray('MMO Grad',GradMMO,3*nAtOut)
      END IF

! Write external potential to ESPF.EXTPOT file
      LuExtPot = isFreeUnit(LuExtPot)
      CALL molcas_open(LuExtPot,'ESPF.EXTPOT')
      WRITE(LuExtPot,'(I1)') 0
      iAtIn = 1
      DO iAtGMX = 1,nAtGMX
         IF (AT(iAtGMX)==QM.OR.AT(iAtGMX)==MMI) THEN
            WRITE(LuExtPot,ExtPotFormat) iAtIn,
     &                     PotGMX(iAtGMX)/AuToKjPerMol,
     &                    -FieldGMX(1,iAtGMX)/AuToKjPerMolNm,
     &                    -FieldGMX(2,iAtGMX)/AuToKjPerMolNm,
     &                    -FieldGMX(3,iAtGMX)/AuToKjPerMolNm,
     &                     (Zero,j=5,MxExtPotComp)
            iAtIn = iAtIn+1
         END IF
      END DO
      CLOSE(LuExtPot)

! Clean up
      CALL mma_deallocate(CoordMMO)
      CALL mma_deallocate(AT)
      CALL mma_deallocate(CoordGMX)
      CALL mma_deallocate(FieldGMX)
      CALL mma_deallocate(ForceGMX)
      CALL mma_deallocate(PotGMX)
      IF (Forces) THEN
         CALL mma_deallocate(Field2GMX)
         CALL mma_deallocate(Force2GMX)
         CALL mma_deallocate(Pot2GMX)
         CALL mma_deallocate(GradMMO)
      END IF
      CALL mmslave_done(ipGMS)

      RETURN

      CONTAINS

      FUNCTION mmslave_calc_energy_wrapper(gms,x,f,A,phi,energy)
      INTEGER :: mmslave_calc_energy_wrapper
      TYPE(c_ptr) :: gms
      REAL*8, TARGET :: x(*), f(*), A(*), phi(*)
      REAL*8 :: energy
      INTERFACE
        FUNCTION mmslave_calc_energy(gms,x,f,A,phi,energy)
     &           BIND(C,NAME='mmslave_calc_energy_')
          USE, INTRINSIC :: iso_c_binding, ONLY: c_double, c_int, c_ptr
          INTEGER(kind=c_int) :: mmslave_calc_energy
          TYPE(c_ptr), VALUE :: gms, x, f, A, phi
          REAL(kind=c_double) :: energy
        END FUNCTION mmslave_calc_energy
      END INTERFACE
      mmslave_calc_energy_wrapper = mmslave_calc_energy(gms,c_loc(x(1)),
     &  c_loc(f(1)),c_loc(A(1)),c_loc(phi(1)),energy)
      END FUNCTION mmslave_calc_energy_wrapper

      END
#elif defined (NAGFOR)
! Some compilers do not like empty files
      SUBROUTINE empty_RunGromacs()
      END
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine CD_Tester_Diff(X,n,Err)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: X(n*n)
real(kind=wp), intent(out) :: Err(3)
integer(kind=iwp) :: i
real(kind=wp) :: xn2
real(kind=wp), parameter :: dum = 9.876543210e15_wp

if (n < 1) then
  Err(1) = dum
  Err(2) = -dum
  Err(3) = dum
else
  Err(1) = x(1)
  Err(2) = x(1)
  Err(3) = x(1)*x(1)
  do i=2,n**2
    Err(1) = min(Err(1),x(i))
    Err(2) = max(Err(2),x(i))
    Err(3) = Err(3)+x(i)*x(i)
  end do
  xn2 = real(n,kind=wp)*real(n,kind=wp)
  Err(3) = Err(3)/xn2
end if

end subroutine CD_Tester_Diff

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE LOOP3(KM,ISTOP,IT1,IT2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      ISTOP=0
C     STOP THE LOOP
      KM1=KM+1
      IDIF=IA(J1(KM1))-IA(J2(KM1))
      IF(IDIF.LT.0.OR.IDIF.GT.1)GO TO 52
      IF(IDIF.EQ.0)GO TO 60
      IWAYKM=IWAY(KM)
      GO TO (49,51,52),IWAYKM
49    IWAY(KM)=2
C     CASE E-F
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K0(IT2+J2(KM1)).EQ.0)GO TO 51
      COUP(KM)=COUP(KM1)
      J2(KM)=K2(IT1+J1(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)
      GO TO 40
51    IWAY(KM)=3
      IF(K3(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 52
      COUP(KM)=COUP(KM1)*BS3(IB(J2(KM1))+1)
      J2(KM)=K3(IT1+J1(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      GO TO 40
C     CASE G-H
60    IWAYKM=IWAY(KM)
      GO TO (64,65,52),IWAYKM
64    IWAY(KM)=2
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K0(IT2+J2(KM1)).EQ.0)GO TO 65
      COUP(KM)=COUP(KM1)
      J2(KM)=K1(IT1+J1(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)
      GO TO 40
65    IWAY(KM)=3
      IF(K3(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 52
      COUP(KM)=COUP(KM1)*BS4(IB(J2(KM1))+1)
      J2(KM)=K3(IT1+J1(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      GO TO 40
52    ISTOP=1
40      Continue
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ABTD(ICSPCK,INTSYM,INDX,C1,C2,TDMO,A1,A2,F)

use mrci_global, only: IFIRST, IRC, LN, LSYM, NBAST, NSYM, NVIR, NVIRP, SQ2, SQ2INV
use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICSPCK(*), INTSYM(*), INDX(*)
real(kind=wp), intent(inout) :: C1(*), C2(*), TDMO(NBAST,NBAST)
real(kind=wp), intent(_OUT_) :: A1(*), A2(*), F(*)
integer(kind=iwp) :: I, IA, IAB, IASYM, IC, ICSYM, IFT, II1, INDA, INMY, INN, IOC(55), IPF, IPOA(9), IPOF(9), ITAIL, LNA, LNC, &
                     MYL, MYSYM, NA, NA1, NA2, NAC, NB, NCLIM, NVIRA, NVIRC
real(kind=wp) :: TERM, TSUM
integer(kind=iwp), external :: ICUNP, JSUNP
real(kind=r8), external :: DDOT_

! CALCULATE A) TRANSITION DENSITY ELEMENTS OF TYPE TDMO(A,B)
!           B) DIAGONAL ELEMENTS TDMO(I,I) AND TDMO(A,A)
! SCRATCH SPACES: A1(),A2(), SIZE NEEDED IS NVMAX**2
!                  ALSO F(), SIZE NEEDED IS NVSQ
call CSCALE(INDX,INTSYM,C1,SQ2)
call CSCALE(INDX,INTSYM,C2,SQ2)
NCLIM = 4
if (IFIRST /= 0) NCLIM = 2
! MOVE TRANSITION DENSITY MATRIX TO F IN SYMMETRY BLOCKS
call IPO(IPOF,NVIR,MUL,NSYM,1,-1)
do IASYM=1,NSYM
  IAB = IPOF(IASYM)
  NA1 = NVIRP(IASYM)+1
  NA2 = NVIRP(IASYM)+NVIR(IASYM)
  do NA=NA1,NA2
    do NB=NA1,NA2
      IAB = IAB+1
      F(IAB) = TDMO(LN+NA,LN+NB)
    end do
  end do
end do
II1 = 0
ITAIL = IRC(NCLIM)
do INDA=1,ITAIL
  do I=1,LN
    II1 = II1+1
    IOC(I) = (1+ICUNP(ICSPCK,II1))/2
  end do
  if (INDA <= IRC(1)) then
    TSUM = C1(INDA)*C2(INDA)
  else
    MYSYM = JSUNP(INTSYM,INDA)
    MYL = MUL(MYSYM,LSYM)
    INMY = INDX(INDA)+1
    if (INDA <= IRC(2)) then
      ! DOUBLET-DOUBLET INTERACTIONS
      if (NVIR(MYL) == 0) cycle
      IPF = IPOF(MYL)+1
      NVIRA = NVIR(MYL)
      call DGER(NVIRA,NVIRA,One,C1(INMY),1,C2(INMY),1,F(IPF),NVIRA)
      LNA = LN+NVIRP(MYL)
      TSUM = Zero
      do I=1,NVIRA
        TERM = C1(INMY-1+I)*C2(INMY-1+I)
        IA = LNA+I
        TDMO(IA,IA) = TDMO(IA,IA)+TERM
        TSUM = TSUM+TERM
      end do
    else
      ! TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
      IFT = 1
      if (INDA > IRC(3)) IFT = 0
      call IPO(IPOA,NVIR,MUL,NSYM,MYL,IFT)
      TSUM = Zero
      do IASYM=1,NSYM
        IAB = IPOF(IASYM+1)-IPOF(IASYM)
        if (IAB == 0) cycle
        ICSYM = MUL(MYL,IASYM)
        NVIRA = NVIR(IASYM)
        NVIRC = NVIR(ICSYM)
        if (NVIRC == 0) cycle
        if (MYL /= 1) then
          if (IASYM > ICSYM) then
            call MTRANS(C1(INMY+IPOA(IASYM)),A1,NVIRA,NVIRC)
            call MTRANS(C2(INMY+IPOA(IASYM)),A2,NVIRA,NVIRC)
          else
            NAC = NVIRA*NVIRC
            if (IFT == 0) then
              call DCOPY_(NAC,C1(INMY+IPOA(ICSYM)),1,A1,1)
              call DCOPY_(NAC,C2(INMY+IPOA(ICSYM)),1,A2,1)
            else
              call VNEG(NAC,C1(INMY+IPOA(ICSYM)),1,A1,1)
              call VNEG(NAC,C2(INMY+IPOA(ICSYM)),1,A2,1)
            end if
          end if
        else
          if (IFT == 0) then
            call SQUAR(C1(INMY+IPOA(IASYM)),A1,NVIRA)
            call SQUAR(C2(INMY+IPOA(IASYM)),A2,NVIRA)
          else
            call SQUARM(C1(INMY+IPOA(IASYM)),A1,NVIRA)
            call SQUARM(C2(INMY+IPOA(IASYM)),A2,NVIRA)
          end if
        end if
        IPF = IPOF(IASYM)+1
        call DGEMM_('N','T',NVIRA,NVIRA,NVIRC,One,A1,NVIRA,A2,NVIRA,One,F(IPF),NVIRA)
        INN = 1
        LNC = LN+NVIRP(ICSYM)
        do I=1,NVIRC
          TERM = DDOT_(NVIRA,A1(INN),1,A2(INN),1)
          TSUM = TSUM+TERM
          IC = LNC+I
          TDMO(IC,IC) = TDMO(IC,IC)+TERM
          INN = INN+NVIRA
        end do
      end do
      TSUM = TSUM/2
    end if
  end if
  do I=1,LN
    TDMO(I,I) = TDMO(I,I)+IOC(I)*TSUM
  end do
end do
do IASYM=1,NSYM
  IAB = IPOF(IASYM)
  NA1 = NVIRP(IASYM)+1
  NA2 = NVIRP(IASYM)+NVIR(IASYM)
  do NA=NA1,NA2
    do NB=NA1,NA2
      IAB = IAB+1
      if (NA /= NB) TDMO(LN+NA,LN+NB) = F(IAB)
    end do
  end do
end do
call CSCALE(INDX,INTSYM,C1,SQ2INV)
call CSCALE(INDX,INTSYM,C2,SQ2INV)

return

end subroutine ABTD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_T2p(T21,aSGrp,bSGrp)
! test T2+

use Index_Functions, only: nTri_Elem
use chcc_global, only: no, nv, T2c
use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: T21(nTri_Elem(nv/2-1),nTri_Elem(no))
integer(kind=iwp), intent(in) :: aSGrp, bSGrp
integer(kind=iwp) :: a, ab, ap, b, bad, bp, u, uv, v
real(kind=wp) :: s

if (aSGrp == 2) then
  ap = nv/2
else
  ap = 0
end if

if (bSGrp == 2) then
  bp = nv/2
else
  bp = 0
end if

bad = 0

uv = 0
do u=1,no
  do v=1,u
    uv = uv+1

    ab = 0
    do a=2,nv/2
      do b=1,a-1
        ab = ab+1

        s = (T2c(bp+b,ap+a,v,u)+T2c(bp+b,ap+a,u,v))*Half

        if (abs(T21(ab,uv)-s) > 1.0e-10_wp) bad = bad+1
        T21(ab,uv) = s

      end do
    end do

  end do
end do

if (bad == 0) then
  write(u6,*) ' Chck T2+ OK ',bad
else
  write(u6,*) ' Chck T2+ Bug !!!!!!! ',bad
end if

return

end subroutine Chck_T2p

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dqk21(f,a,b,reslt,abserr,resabs,resasc)
!***begin prologue  dqk21
!***date written   800101   (yymmdd)
!***revision date  830518   (yymmdd)
!***category no.  h2a1a2
!***keywords  21-point gauss-kronrod rules
!***author  piessens,robert,appl. math. & progr. div. - k.u.leuven
!           de doncker,elise,appl. math. & progr. div. - k.u.leuven
!***purpose  to compute i = integral of f over (a,b), with error
!                           estimate
!                       j = integral of abs(f) over (a,b)
!***description
!
!           integration rules
!           standard fortran subroutine
!           real*8 version
!
!           parameters
!            on entry
!              f      - real*8
!                       function subprogram defining the integrand
!                       function f(x). the actual name for f needs to be
!                       declared e x t e r n a l in the calling program.
!
!              a      - real*8
!                       lower limit of integration
!
!              b      - real*8
!                       upper limit of integration
!
!            on return
!              reslt  - real*8
!                       approximation to the integral i
!                       result is computed by applying the 21-point
!                       kronrod rule (resk) obtained by optimal addition
!                       of abscissae to the 10-point gauss rule (resg).
!
!              abserr - real*8
!                       estimate of the modulus of the absolute error,
!                       which should not exceed abs(i-reslt)
!
!              resabs - real*8
!                       approximation to the integral j
!
!              resasc - real*8
!                       approximation to the integral of abs(f-i/(b-a))
!                       over (a,b)
!
!***references  (none)
!***routines called  d1mach
!***end prologue  dqk21

use Constants, only: Zero, One, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
interface
  function f(x)
    import :: wp
    real(kind=wp) :: f
    real(kind=wp), intent(in) :: x
  end function f
end interface
real(kind=wp), intent(in) :: a, b
real(kind=wp), intent(out) :: reslt, abserr, resabs, resasc
real(kind=wp) :: absc, centr, dhlgth, epmach, fc, fsum, fval1, fval2, fv1(10), fv2(10), hlgth, resg, resk, reskh, uflow
integer(kind=iwp) :: j, jtw, jtwm1
real(kind=wp), external :: d1mach

! the abscissae and weights are given for the interval (-1,1).
! because of symmetry only the positive abscissae and their
! corresponding weights are given.
!
! xgk    - abscissae of the 21-point kronrod rule
!          xgk(2), xgk(4), ...  abscissae of the 10-point
!          gauss rule
!          xgk(1), xgk(3), ...  abscissae which are optimally
!          added to the 10-point gauss rule
!
! wgk    - weights of the 21-point kronrod rule
!
! wg     - weights of the 10-point gauss rule
!
!
! gauss quadrature weights and kronron quadrature abscissae and weights
! as evaluated with 80 decimal digit arithmetic by l. w. fullerton,
! bell labs, nov. 1981.

real(kind=wp), parameter :: wg(5) = [0.066671344308688137593568809893332_wp, &
                                     0.149451349150580593145776339657697_wp, &
                                     0.219086362515982043995534934228163_wp, &
                                     0.269266719309996355091226921569469_wp, &
                                     0.295524224714752870173892994651338_wp]
real(kind=wp), parameter :: xgk(11) = [0.995657163025808080735527280689003_wp, &
                                       0.973906528517171720077964012084452_wp, &
                                       0.930157491355708226001207180059508_wp, &
                                       0.865063366688984510732096688423493_wp, &
                                       0.780817726586416897063717578345042_wp, &
                                       0.679409568299024406234327365114874_wp, &
                                       0.562757134668604683339000099272694_wp, &
                                       0.433395394129247190799265943165784_wp, &
                                       0.294392862701460198131126603103866_wp, &
                                       0.148874338981631210884826001129720_wp, &
                                       0.000000000000000000000000000000000_wp]
real(kind=wp), parameter :: wgk(11) = [0.011694638867371874278064396062192_wp, &
                                       0.032558162307964727478818972459390_wp, &
                                       0.054755896574351996031381300244580_wp, &
                                       0.075039674810919952767043140916190_wp, &
                                       0.093125454583697605535065465083366_wp, &
                                       0.109387158802297641899210590325805_wp, &
                                       0.123491976262065851077958109831074_wp, &
                                       0.134709217311473325928054001771707_wp, &
                                       0.142775938577060080797094273138717_wp, &
                                       0.147739104901338491374841515972068_wp, &
                                       0.149445554002916905664936468389821_wp]

! list of major variables
! -----------------------
!
! centr  - mid point of the interval
! hlgth  - half-length of the interval
! absc   - abscissa
! fval*  - function value
! resg   - result of the 10-point gauss formula
! resk   - result of the 21-point kronrod formula
! reskh  - approximation to the mean value of f over (a,b),
!          i.e. to i/(b-a)
!
! machine dependent constants
! ---------------------------
!
! epmach is the largest relative spacing.
! uflow is the smallest positive magnitude.
!
!***first executable statement  dqk21

epmach = d1mach(4)
uflow = d1mach(1)

centr = Half*(a+b)
hlgth = Half*(b-a)
dhlgth = abs(hlgth)

! compute the 21-point kronrod approximation to
! the integral, and estimate the absolute error.

fc = f(centr)
resg = Zero
resk = fc*wgk(11)
resabs = abs(resk)
do j=1,5
  jtw = j*2
  absc = hlgth*xgk(jtw)
  fval1 = f(centr-absc)
  fval2 = f(centr+absc)
  fv1(jtw) = fval1
  fv2(jtw) = fval2
  fsum = fval1+fval2
  resg = resg+wg(j)*fsum
  resk = resk+wgk(jtw)*fsum
  resabs = resabs+wgk(jtw)*(abs(fval1)+abs(fval2))
end do
do j=1,5
  jtwm1 = j*2-1
  absc = hlgth*xgk(jtwm1)
  fval1 = f(centr-absc)
  fval2 = f(centr+absc)
  fv1(jtwm1) = fval1
  fv2(jtwm1) = fval2
  fsum = fval1+fval2
  resk = resk+wgk(jtwm1)*fsum
  resabs = resabs+wgk(jtwm1)*(abs(fval1)+abs(fval2))
end do
reskh = resk*Half
resasc = wgk(11)*abs(fc-reskh)
do j=1,10
  resasc = resasc+wgk(j)*(abs(fv1(j)-reskh)+abs(fv2(j)-reskh))
end do
reslt = resk*hlgth
resabs = resabs*dhlgth
resasc = resasc*dhlgth
abserr = abs((resk-resg)*hlgth)
if ((resasc /= Zero) .and. (abserr /= Zero)) abserr = resasc*min(One,(200.0_wp*abserr/resasc)**OneHalf)
if (resabs > uflow/(50.0_wp*epmach)) abserr = max((epmach*50.0_wp)*resabs,abserr)

return

end subroutine dqk21

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2009, Giovanni Li Manni                                *
*               2009, Francesco Aquilante                              *
************************************************************************
* symmetry-----> C1 INPORB
      Subroutine desym(iUHF)
************************************************************************
*                                                                      *
* Purpose: Convert INPORB file with symmetry to DeSymOrb               *
*          file with C1 symmetry.                                      *
*                                                                      *
*          G. Li Manni, F. Aquilante, University of Geneva, June 2009. *
*                                                                      *
* Example of input:                                                    *
*                                                                      *
*   &SEWARD                                                            *
*    coord                                                             *
*     file.xyz                                                         *
*    basis                                                             *
*     ano-rcc-mb                                                       *
*    oneonly                                                           *
*    nodk                                                              *
*                                                                      *
*   >>COPY $CurrDir/scf_sym.ScfOrb INPORB                              *
*                                                                      *
*   &EXPBAS                                                            *
*    NoEx                                                              *
*    Desy                                                              *
*   END                                                                *
*                                                                      *
************************************************************************
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, lIrrep
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "info_expbas.fh"
#include "stdalloc.fh"
      Parameter (EorbThr = 50.D0 )
      Real*8 Coor(3,MxAtom),Znuc(MxAtom)
      Character*(LENIN) AtomLabel(MxAtom)
      Character*512 FilesOrb
      Character*(LENIN8), Allocatable :: label(:)
      Character*8 MO_Label(maxbfn)
      Parameter (nNumber=61)
      Character Number(nNumber)
      Integer ibas_lab(MxAtom), nOrb(8),iA(7), iOrdEor(0:maxbfn-1)
      Character*(LENIN8+1) gtolabel(maxbfn)
*      Character*8 Filename
      Character*50 VTitle
      character*128 SymOrbName
      Logical Exist,y_cart,Found, Reduce_Prt
      External Reduce_Prt

      data number /'1','2','3','4','5','6','7','8','9','0',
     &             'a','b','c','d','e','f','g','h','i','j',
     &             'k','l','m','n','o','p','q','r','s','t',
     &             'u','v','w','x','y','z','A','B','C','D',
     &             'E','F','G','H','I','J','K','L','M','N',
     &             'O','P','Q','R','S','T','V','W','X','Y',
     &             'Z'/
      data iRc/0/
      save iRc
*                                                                      *
************************************************************************
*                                                                      *
      Check_CMO=Zero
      Check_Energy=Zero
      Check_Occupation=Zero
      y_cart=.false.

*                                                                      *
************************************************************************
*                                                                      *
*      write(6,*) 'Start option DeSymmetrization'

      Call f_Inquire('RUNFILE',Exist)
      If (.Not.Exist) then
       Write (6,*) 'Error finding RUNFILE'
       Call Abend()
      Endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Read the characteristics of all different basis sets,
*     provide each atom with a nuclear charge and establish
*     a link between an atom and its basis set ---
*
*     NOTICE!!!
*     This call will also fill info.fh and the dynamic storage in
*     Work(ipInf)
*
      Call Inter1       (AtomLabel,iBas_Lab,Coor,Znuc,nAtom)
      Call Qpg_iArray('nOrb',Found,nData)
      If (Found) Then
         Call Get_iArray('nOrb',nOrb,nData)
      Else
         Call iCopy(nIrrep,nBas,1,nOrb,1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      iAngMx_Valence=0
      Do iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%Aux .and.
     &       .Not.dbsc(iCnttp)%Frag ) Then
            nTest=dbsc(iCnttp)%nVal-1
            iAngMx_Valence=Max(iAngMx_Valence,nTest)
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Compute memory requirements and allocate memory
*
      nB=0
      Do iS=0,nirrep-1
       nB=nB+nBas(is)
      End Do
*      write(6,*) 'nB=',nB
      Call GetMem('ICENT','ALLO','INTE',ipCent,8*nB)
      Call GetMem('IPHASE','ALLO','INTE',ipPhase,8*nB)
      Call GetMem('nCENT','ALLO','INTE',ipCent2,nB)
      Call GetMem('ICENTER','ALLO','INTE',ipCent3,nB)
      Call GetMem('CMO2','ALLO','REAL',ipC2,nB**2)
      Call GetMem('VECTOR','ALLO','REAL',ipV,nB**2)
      call dcopy_(nB**2,[Zero],0,Work(ipV),1)
        Call FZero(Work(ipC2),nB**2)
      If (iUHF.eq.1) Then
         Call GetMem('CMO2','ALLO','REAL',ipC2_ab,nB**2)
         Call GetMem('VECTOR','ALLO','REAL',ipV_ab,nB**2)
         call dcopy_(nB**2,[Zero],0,Work(ipV_ab),1)
         Call FZero(Work(ipC2_ab),nB**2)
      Else
         ipC2_ab=ip_Dummy
         ipV_ab =ip_Dummy
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Read exponents and contraction coefficients of each unique basis.
*     Write the present basis set (iCnttp) to the molden.input file for
*     the appropriate atoms.
*     Moreover, a list is constructed which contains a label for each
*     GTO (gtolabel). This list follows the MOLDEN order of GTOs.
*     Later this list will be used in the transformation of sabf (the
*     symmetry adapted basis functions).
*
      iatom=0
      mdc=0
      kk=0
*
*            write(6,*)'nCnttp', nCnttp
      Do iCnttp=1,nCnttp             ! loop over unique basis sets
         If (dbsc(iCnttp)%Aux.or.dbsc(iCnttp)%Frag) Go To 996
*
*         write(6,*)'dbsc(iCntt)%nCntr',dbsc(iCnttp)%nCntr
        Do iCntr=1,dbsc(iCnttp)%nCntr! loop over symmetry unique centers
          mdc=mdc+1
          nDeg=nIrrep/dc(mdc)%nStab
*            write(6,*)'nDeg', nDeg
          Do iDeg=1,nDeg             ! loop over centers
            iAtom=iAtom+1
*
            If (dbsc(iCnttp)%nVal.gt.6) Then
               Write (6,*) 'Desym: too high angular momentum!'
               write (6,*) 'iCnttp and dbsc(iCnttp)%nVal= '
     &                 ,iCnttp, dbsc(iCnttp)%nVal
               Call Abend()
            End If
*
            Do l=0,dbsc(iCnttp)%nVal-1
              ishell=dbsc(iCnttp)%iVal+l
              nBasisi=Shells(iShell)%nBasis
*              write(6,*) 'nBasisi', Shells(iShell)%nBasis
              If (nBasisi.gt.nNumber) Then
                 Write (6,*) 'Desym: too many contracted functions!'
                 Write (6,*) 'nBasisi=',Shells(iShell)%nBasis
                 Call Abend()
              End If
*
*             Iterate over each contracted GTO
*
CC              Do icontr=1,nBasisi
*
*
*
                If (l.eq.0) Then
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'01s     '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
*                   write(6,*)'kk, gtolabel(kk), iAtom',
*     &                kk,gtolabel(kk),iAtom
                  End do
                End If
                If (l.eq.1) Then
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'02px    '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
*                   write(6,*)'kk, gtolabel(kk), iAtom',
*     &                kk,gtolabel(kk),iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'02py    '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
*                   write(6,*)'kk, gtolabel(kk), iAtom',
*     &                kk,gtolabel(kk),iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'02pz    '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
*                   write(6,*)'kk, gtolabel(kk), iAtom',
*     &                kk,gtolabel(kk),iAtom
                  End do
                End If
                If ((l.eq.2).and.(.not.y_cart)) Then
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'03d02-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'03d01-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'03d00   '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'03d01+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'03d02+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                End If
                If ((l.eq.3).and.(.not.y_cart)) Then
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'04f03-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'04f02-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'04f01-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'04f00   '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'04f01+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'04f02+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'04f03+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                End If
                If ((l.eq.4).and.(.not.y_cart)) Then
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'05g04-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'05g03-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'05g02-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'05g01-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'05g00   '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'05g01+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'05g02+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'05g03+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'05g04+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                EndIf
                If ((l.eq.5).and.(.not.y_cart)) Then
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h05+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h04-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h03-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h02-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h01-  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h00   '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h01+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h02+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h03+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h04+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                  Do icontr=1,nBasisi
                   kk=kk+1
                   gtolabel(kk)=AtomLabel(iAtom)//'06h05+  '//
     &                          number(icontr)
                   iWork(ipCent3+kk-1)=iAtom
                  End do
                End If
            End Do
          End Do
        End Do
 996    Continue
      End Do
      kk_Max=kk
      If (nB.gt.kk_max) Then
         Write (6,*) 'nB.gt.kk_max'
         Write (6,*) 'nB,kk_Max=',nB,kk_Max
         Go To 999
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
      nTot=0
      nTot2=0
      Do iS=0,nIrrep-1
         nTot=nTot+nBas(iS)
         nTot2=nTot2+nBas(iS)**2
      End Do
      Call GetMem('Aux','ALLO','REAL',ipAux,nTot)
      Call GetMem('INDT','Allo','Inte',mAdIndt,ntot)
      Call GetMem('IndType','Allo','Inte',mInd,56)
      Call GetMem('Occ','Allo','Real',mAdOcc,nTot )
      Call GetMem('Eor','Allo','Real',mAdEor,nTot )
      Call GetMem('CMO','Allo','Real',mAdCMO,nTot2)
      Call FZero(Work(ipAux),nTot)
      Call IZero(iWork(mAdIndt),nTot)
      Call IZero(iWork(mInd),56)
      Call FZero(Work(mAdOcc),nTot)
      Call FZero(Work(mAdEor),nTot)
      Call FZero(Work(mAdCMO),nTot2)
      If (iUHF.eq.1) Then
         Call GetMem('Aux','ALLO','REAL',ipAux_ab,nTot)
         Call GetMem('INDT','Allo','Inte',mAdIndt_ab,ntot)
         Call GetMem('IndType','Allo','Inte',mInd_ab,56)
         Call GetMem('Occ','Allo','Real',mAdOcc_ab,nTot )
         Call GetMem('Eor','Allo','Real',mAdEor_ab,nTot )
         Call GetMem('CMO','Allo','Real',mAdCMO_ab,nTot2)
         Call FZero(Work(ipAux_ab),nTot)
         Call IZero(iWork(mAdIndt_ab),nTot)
         Call IZero(iWork(mInd_ab),56)
         Call FZero(Work(mAdOcc_ab),nTot)
         Call FZero(Work(mAdEor_ab),nTot)
         Call FZero(Work(mAdCMO_ab),nTot2)
      Else
         ipAux_ab=ip_Dummy
         mAdIndt_ab=ip_Dummy
         mInd_ab=ip_Dummy
         mAdOcc_ab=ip_Dummy
         mAdEor_ab=ip_Dummy
         mAdCMO_ab=ip_Dummy
      End If
*
*
*---- Read HF CMOs from file
*
      Lu_=75
      FilesOrb=EB_FileOrb
      If (mylen(FilesOrb).eq.0) FilesOrb='INPORB'
      if(DoExpbas) FilesOrb='EXPORB'
      iLen=mylen(FilesOrb)
        Call RdVec_(FilesOrb(:iLen),Lu_,'COEI',iUHF,nIrrep,nBas,nBas,
     &            Work(mAdCMO),Work(mAdCMO_ab),
     &            Work(mAdOcc),Work(mAdOcc_ab),
     &            Work(mAdEor),Work(mAdEor_ab),
     &            iWork(mAdIndt),VTitle,1,iErr,iWfType)
       if(iUHF.eq.1) then
         write(6,*) 'DESY keyword not implemented for DODS wf!'
         Call Abend()
       end if
        if(iErr.ne.0) then
          iRc=1
          return
        end if

*                                                                      *
************************************************************************
*                                                                      *
*     Get the coeff. of sym adapted basis functions (ipC2)
*
      Call Dens_IF_SCF(Work(ipC2),Work(mAdCMO),'F')
      Call GetMem('CMO','Free','Real',mAdCMO,nTot2)
      If (iUHF.eq.1) Then
         Call Dens_IF_SCF(Work(ipC2_ab),Work(mAdCMO_ab),'F')
         Call GetMem('CMO','Free','Real',mAdCMO_ab,nTot2)
      End If
*        write(6,*)'write work(ipC2) in .out'
*        write(6,*) (Work(k), k=ipC2,ipC2+nTot2-1)

*                                                                      *
************************************************************************
*                                                                      *
*      Back 'transformation' of the symmetry adapted basis functions.
*      Probably somewhat clumsy, but it seems to work.If someone
*      knows a more elegant way to do it, please improve this part!
*
*      PART 1: Obtain symmetry information (soout), construct a label
*              for each sabf, which will be used in part 2 to find the
*              corresponding GTO in the MOLDEN list by comparing with
*              gtolabel
*
*      nB       --- Total number of contracted basis functions
*      ipcent2  --- degeneracy of a basis function
*      ipCent   --- centres over which the basis function is
*                   delocalized
*      ipPhase  --- phase of the AO in the linear combination
*
      Call mma_allocate(Label,MaxBfn+MaxBfn_Aux,label='Label')
      Call icopy(8*nB,[0],0,iWork(ipPhase),1)
      Call icopy(8*nB,[0],0,iWork(ipCent),1)
      Call SOout(label,iWork(ipCent),iWork(ipPhase))
      ipc=0
      Do iContr=1,nB
        iWork(ipCent2+iContr-1)=0
        Do k=1,8
          If (iWork(ipCent+ipc).ne.0)
     &       iWork(ipcent2+iContr-1)=iWork(ipCent2+iContr-1)+1
          ipc=ipc+1
        End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*
* Part 2: -Take a MOLCAS symmetry functions (loop i)
*         -Find the corresponding label in the MOLDEN list (loop j)
*         -Copy the coeff of the sabf in the MOLDEN MO (vector), multiply
*          by the appropriate factor (ipPhase),and divide by the number of
*          centres over which the sabf is delocalized (ipCent3).
*         -The vectors are copied by rows!
*
*     loop over MOLCAS symmetry functions
      i=0
      ik=0
      Do iIrrep=0,nIrrep-1
*
        Do iB=1,nBas(iIrrep)
          i=i+1
*
          If (iB.eq.1) Then
            ik=1
          else
            If (label(i-1).eq.label(i)) Then
              ik=ik+1
            else
              ik=1
            End If
          End If
*                                                                      *
************************************************************************
*                                                                      *
          Write (MO_Label(i),'(I5,A3)') iB,lirrep(iIrrep)
*
          Do j=1,nB
*
*
CC          write(6,*)'j, gtolabel(j), i, label(i)//number(ik), ik',
CC     &        j,'   ', gtolabel(j),i, label(i)//number(ik), ik
            If (gtolabel(j).eq.label(i)//number(ik)) Then
              Do k=1,8
                ipc=(i-1)*8+k-1
                ipp=ipc
                If (iWork(ipCent+ipc).eq.iWork(ipcent3+j-1)) Then
                  Do ii=1,nB
                    ic=(ii-1)*nB+(i-1)
                    iv=(ii-1)*nB+(j-1)
                    If (MolWgh.eq.0) Then
                       Work(ipV+iv) = Work(ipV+iv)
     &                              + Work(ipC2+ic)
     &                              * DBLE(iWork(ipPhase+ipp))
     &                              / DBLE(iWork(ipcent2+i-1))
                       If (iUHF.eq.1) Work(ipV_ab+iv) = Work(ipV_ab+iv)
     &                              + Work(ipC2_ab+ic)
     &                              * DBLE(iWork(ipPhase+ipp))
     &                              / DBLE(iWork(ipcent2+i-1))
                    Else
                       Work(ipV+iv) = Work(ipV+iv)
     &                              + Work(ipC2+ic)
     &                              * DBLE(iWork(ipPhase+ipp))
     &                              / Sqrt(DBLE(iWork(ipcent2+i-1)))
                       If (iUHF.eq.1) Work(ipV_ab+iv) = Work(ipV_ab+iv)
     &                              + Work(ipC2_ab+ic)
     &                              * DBLE(iWork(ipPhase+ipp))
     &                              / Sqrt(DBLE(iWork(ipcent2+i-1)))
                    End If
                  End Do
                End If
              End Do
            End If
          End Do
        End Do
      End Do
      Call mma_deallocate(Label)
*                                                                      *
************************************************************************
*                                                                      *
*      Dump vector in the molden.input file
*
      ii=0
      Do i=0,nB-1
        If (Work(mAdEOr+i).le.EorbThr) Then
C          Write (MF,*) 'Sym= ',MO_Label(i+1)
C          Write (MF,103) Work(mAdEOr+i)
C          Write (MF,*) 'Spin= Alpha'
C          Write (MF,104) Work(mAdOcc+i)
          If (Work(mAdEOr+i).lt.0.0D0) Then
          Check_Energy     = Check_Energy
     &                     + Work(mAdEOr+i)*DBLE(i)
          End If
          Check_Occupation = Check_Occupation
     &                     +Work(mAdOcc+i)*DBLE(i)
          Do j=1,nB
C            Write (MF,100) j,Work(ipV+ii+j-1)
            Check_CMO = Check_CMO
     &                + Work(ipV+ii+j-1)**2
          End Do
        End If
*
        If (iUHF.eq.1) Then
           If (Work(mAdEOr_ab+i).le.EorbThr) Then
C             Write (MF,*) 'Sym= ',MO_Label(i+1)
C             Write (MF,103) Work(mAdEOr_ab+i)
C             Write (MF,*) 'Spin= Beta'
C             Write (MF,104) Work(mAdOcc_ab+i)
          Check_Energy     = Check_Energy
     &                     + Work(mAdEOr_ab+i)*DBLE(i)
          Check_Occupation = Check_Occupation
     &                     +Work(mAdOcc_ab+i)*DBLE(i)
              Do j=1,nB
C                Write (MF,100) j,Work(ipV_ab+ii+j-1)
                 Check_CMO = Check_CMO
     &                     + Work(ipV_ab+ii+j-1)**2
              End Do
           End If
        End If
*
        ii=ii+nB
      End Do
***************************** START SORTING ****************************
***************************** START SORTING ****************************
***************************** START SORTING ****************************

*********************  energy sorting + sort memory ********************
        call dcopy_(nTot,Work(mAdEor),1,Work(ipAux),1)
        do i=0, nTot-1
          iOrdEor(i)=i
        end do

        do i=0,nTot-2
            do k=i+1,nTot-1
              if(work(ipAux+k).lt.Work(ipAux+i)) then
                temporary=work(ipAux+i)
                work(ipAux+i)=Work(ipAux+k)
                work(ipAux+k)=temporary
                iTempOrd=iOrdEor(i)
                iOrdEor(i)=iOrdEor(k)
                iOrdEor(k)= iTempOrd
              end if
            end do
        end do
***************************** MOs sorting ******************************
        Call GetMem('OrdC1','ALLO','REAL',ipOrdC1,nTot**2)
        Call FZero(Work(ipOrdC1),nTot**2)
        do i=0,nTot-1
            do k=0,nTot-1
              work(ipOrdC1+nTot*i+k)=work(ipV+nTot*iOrdEor(i)+k)
            end do
        end do
************************* Occupation sorting ***************************
        Call GetMem('OccC1','ALLO','REAL',ipOccC1,nTot)
        Call FZero(Work(ipOccC1),nTot)
        do i=0,nTot-1
          Work(ipOccC1+i) = Work(mAdOcc+iOrdEor(i))
        end do
*************************   index sorting   ****************************
        mpunt=mAdIndt
        do iIrrep=0,nIrrep-1
          mpunt=mpunt+nBas(iIrrep)
        end do

        do i=1,7
          iA(i)=0
        end do
        kindt=mInd
        mpunt=mAdIndt
        do iIrrep=0,nIrrep-1
           Do i=1,7
                do j=0,nBas(iIrrep)-1
                  if(iWork(mpunt+j).eq.i) iA(i)=iA(i)+1
                end do
           End Do
           mpunt=mpunt+nBas(iIrrep)
        end do
        call icopy(7,iA,1,iWork(kindt),1)
****************************************************************************

*    Energy after first sorting work(ipAux)
*    MO after sorting           Work(ipOrdC1)
*    Occupation after sorting   Work(ipOccC1)

******* Natural Active Orbitals (energy = Zero) are sorted by Occ Numb ***********

        do i=0, nTot-1
          iOrdEor(i)=i
        end do

        do i=0,nTot-2
            do k=i+1,nTot-1
              if(Work(ipOccC1+k).gt.Work(ipOccC1+i)) then
                temporary=work(ipOccC1+i)
                work(ipOccC1+i)=Work(ipOccC1+k)
                work(ipOccC1+k)=temporary
                iTempOrd=iOrdEor(i)
                iOrdEor(i)=iOrdEor(k)
                iOrdEor(k)= iTempOrd
              end if
            end do
        end do
***************************** MOs sorting ******************************
        Call GetMem('OrdC2','ALLO','REAL',ipOrdC2,nTot**2)
        Call FZero(Work(ipOrdC2),nTot**2)
        do i=0,nTot-1
            do k=0,nTot-1
              work(ipOrdC2+nTot*i+k)=work(ipOrdC1+nTot*iOrdEor(i)+k)
            end do
        end do
************************* Orbital Energy sorting ***************************
* Energy sorting here it is not needed as the sorting is taking place only at
* Active orbital level for which energy are zeroes (not defined).
*        Call GetMem('EorC2','ALLO','REAL',ipEorC2,nTot)
*        Call FZero(Work(ipEorC2),nTot)
*        do i=0,nTot-1
*          Work(ipEorC2+i) = Work(ipAux+iOrdEor(i))
*        end do
******************************  print output **************************
       notSymm=1
       iWF=9
       SymOrbName='DESORB'
       VTitle = 'Basis set desymmetrized orbital file DESORB'
       Call WrVec_(SymOrbName,iWF,'COEI',iUHF,notSymm,[nTot],[nTot],
     &            Work(ipOrdC2),Work(ipV_ab),
     &            Work(iPOccC1),Work(mAdOcc_ab),
     &            Work(ipAux),Work(ipAux_ab),
     &            iWork(mInd),VTitle,iWFtype)
       call Add_Info('desym CMO',Work(ipOrdC2),999,8)
*                                                                      *
************************************************************************
*                                                                      *
*     If (iUHF.lt.2)
*    & Call Add_Info('MOLDEN_CMO',       Check_CMO,       1,2)
*     Call Add_Info('MOLDEN_Occupation',Check_Occupation,1,2)
*     Call Add_Info('MOLDEN_Energy    ',Check_Energy    ,1,2)
*                                                                      *
************************************************************************
*                                                                      *
      iPL=iPrintLevel(-1)
      jPL=iPL
      If (Reduce_Prt().and.iPL.lt.3) jPL=0
      If (jPL.ge.3) Then
         Write (6,*)
         Write (6,*) ' INPORB_C1 file was generated!'
         Write (6,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('OccC1','FREE','REAL',ipOccC1,nTot)
      Call GetMem('OrdC1','FREE','REAL',ipOrdC1,nTot**2)
      Call GetMem('OrdC2','FREE','REAL',ipOrdC2,nTot**2)
      Call GetMem('Eor','Free','Real',mAdEor,nTot)
      Call GetMem('Occ','Free','Real',mAdOcc,nTot)
      Call GetMem('Aux','FREE','REAL',ipAux,nTot)
      Call GetMem('INDT','Free','Inte',mAdIndt,nTot)
      Call GetMem('IndType','Free','Inte',mInd,56)
      If (iUHF.eq.1) Then
         Call GetMem('Eor','Free','Real',mAdEor_ab,nTot)
         Call GetMem('Occ','Free','Real',mAdOcc_ab,nTot)
         Call GetMem('Aux','FREE','REAL',ipAux_ab,nTot)
         Call GetMem('INDT','Free','Inte',mAdIndt,nTot)
         Call GetMem('IndType','Free','Inte',mInd_ab,56)
      End If
      Call GetMem('ICENT','FREE','INTE',ipCent,8*nB)
      Call GetMem('IPHASE','FREE','INTE',ipPhase,8*nB)
      Call GetMem('nCENT','FREE','INTE',ipCent2,nB)
      Call GetMem('ICENTER','FREE','INTE',ipCent3,nB)
      If (iUHF.eq.1) Then
         Call GetMem('CMO2','FREE','REAL',ipC2_ab,nB**2)
         Call GetMem('VECTOR','FREE','REAL',ipV_ab,nB**2)
      End If
      Call GetMem('CMO2','FREE','REAL',ipC2,nB**2)
      Call GetMem('VECTOR','FREE','REAL',ipV,nB**2)
C 998  Close (MF)
 999  Call ClsSew
*
C -------------FORMATS-------------
c100  format(I4,3x,F16.8)
c103  format('Ene= ',F10.4)
c104  format('Occup= ',F10.5)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c  ********************************************************
c  ** Public-domain library routines used by casvb only. **
c  ********************************************************
c  **********************
c  ** EISPACK ROUTINES **
c  **********************
      subroutine hqr(nm,n,low,igh,h,wr,wi,ierr)
C  RESTORED CORRECT INDICES OF LOOPS (200,210,230,240). (9/29/89 BSG)
c
      integer i,j,k,l,m,n,en,ll,mm,na,nm,igh,itn,its,low,mp2,enm2,ierr
      real*8 h(nm,n),wr(n),wi(n)
      real*8 p,q,r,s,t,w,x,y,zz,norm,tst1,tst2
      logical notlas
c
c     this subroutine is a translation of the algol procedure hqr,
c     num. math. 14, 219-231(1970) by martin, peters, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 359-371(1971).
c
c     this subroutine finds the eigenvalues of a real
c     upper hessenberg matrix by the qr method.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        h contains the upper hessenberg matrix.  information about
c          the transformations used in the reduction to hessenberg
c          form by  elmhes  or  orthes, if performed, is stored
c          in the remaining triangle under the hessenberg matrix.
c
c     on output
c
c        h has been destroyed.  therefore, it must be saved
c          before calling  hqr  if subsequent calculation and
c          back transformation of eigenvectors is to be performed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  the eigenvalues
c          are unordered except that complex conjugate pairs
c          of values appear consecutively with the eigenvalue
c          having the positive imaginary part first.  if an
c          error exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated september 1989.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      norm = 0.0d0
      k = 1
      l = 0     ! dummy initialize
      m = 0     ! dummy initialize
      p = 0.0D0 ! dummy initialize
      q = 0.0D0 ! dummy initialize
      r = 0.0D0 ! dummy initialize
c     .......... store roots isolated by balanc
c                and compute matrix norm ..........
      do 50 i = 1, n
c
         do 40 j = k, n
         norm = norm + abs(h(i,j))
   40    continue
c
         k = i
         if (i .ge. low .and. i .le. igh) go to 50
         wr(i) = h(i,i)
         wi(i) = 0.0d0
   50 continue
c
      en = igh
      t = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalues ..........
   60 if (en .lt. low) go to 1001
      its = 0
      na = en - 1
      enm2 = na - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low do -- ..........
   70 do 80 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 100
         s = abs(h(l-1,l-1)) + abs(h(l,l))
         if (s .eq. 0.0d0) s = norm
         tst1 = s
         tst2 = tst1 + abs(h(l,l-1))
         if (tst2 .eq. tst1) go to 100
   80 continue
c     .......... form shift ..........
  100 x = h(en,en)
      if (l .eq. en) go to 270
      y = h(na,na)
      w = h(en,na) * h(na,en)
      if (l .eq. na) go to 280
      if (itn .eq. 0) go to 1000
      if (its .ne. 10 .and. its .ne. 20) go to 130
c     .......... form exceptional shift ..........
      t = t + x
c
      do 120 i = low, en
      h(i,i) = h(i,i) - x
  120 continue
c
      s = abs(h(en,na)) + abs(h(na,enm2))
      x = 0.75d0 * s
      y = x
      w = -0.4375d0 * s * s
  130 its = its + 1
      itn = itn - 1
c     .......... look for two consecutive small
c                sub-diagonal elements.
c                for m=en-2 step -1 until l do -- ..........
      do 140 mm = l, enm2
         m = enm2 + l - mm
         zz = h(m,m)
         r = x - zz
         s = y - zz
         p = (r * s - w) / h(m+1,m) + h(m,m+1)
         q = h(m+1,m+1) - zz - r - s
         r = h(m+2,m+1)
         s = abs(p) + abs(q) + abs(r)
         p = p / s
         q = q / s
         r = r / s
         if (m .eq. l) go to 150
         tst1 = abs(p)*(abs(h(m-1,m-1)) + abs(zz) + abs(h(m+1,m+1)))
         tst2 = tst1 + abs(h(m,m-1))*(abs(q) + abs(r))
         if (tst2 .eq. tst1) go to 150
  140 continue
c
  150 mp2 = m + 2
c
      do 160 i = mp2, en
         h(i,i-2) = 0.0d0
         if (i .eq. mp2) go to 160
         h(i,i-3) = 0.0d0
  160 continue
c     .......... double qr step involving rows l to en and
c                columns m to en ..........
      do 260 k = m, na
         notlas = k .ne. na
         if (k .eq. m) go to 170
         p = h(k,k-1)
         q = h(k+1,k-1)
         r = 0.0d0
         if (notlas) r = h(k+2,k-1)
         x = abs(p) + abs(q) + abs(r)
         if (x .eq. 0.0d0) go to 260
         p = p / x
         q = q / x
         r = r / x
  170    s = sign(sqrt(p*p+q*q+r*r),p)
         if (k .eq. m) go to 180
         h(k,k-1) = -s * x
         go to 190
  180    if (l .ne. m) h(k,k-1) = -h(k,k-1)
  190    p = p + s
         x = p / s
         y = q / s
         zz = r / s
         q = q / p
         r = r / p
         if (notlas) go to 225
c     .......... row modification ..........
         do 200 j = k, EN
            p = h(k,j) + q * h(k+1,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
  200    continue
c
         j = min(en,k+3)
c     .......... column modification ..........
         do 210 i = L, j
            p = x * h(i,k) + y * h(i,k+1)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
  210    continue
         go to 255
  225    continue
c     .......... row modification ..........
         do 230 j = k, EN
            p = h(k,j) + q * h(k+1,j) + r * h(k+2,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
            h(k+2,j) = h(k+2,j) - p * zz
  230    continue
c
         j = min(en,k+3)
c     .......... column modification ..........
         do 240 i = L, j
            p = x * h(i,k) + y * h(i,k+1) + zz * h(i,k+2)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
            h(i,k+2) = h(i,k+2) - p * r
  240    continue
  255    continue
c
  260 continue
c
      go to 70
c     .......... one root found ..........
  270 wr(en) = x + t
      wi(en) = 0.0d0
      en = na
      go to 60
c     .......... two roots found ..........
  280 p = (y - x) / 2.0d0
      q = p * p + w
      zz = sqrt(abs(q))
      x = x + t
      if (q .lt. 0.0d0) go to 320
c     .......... real pair ..........
      zz = p + sign(zz,p)
      wr(na) = x + zz
      wr(en) = wr(na)
      if (zz .ne. 0.0d0) wr(en) = x - w / zz
      wi(na) = 0.0d0
      wi(en) = 0.0d0
      go to 330
c     .......... complex pair ..........
  320 wr(na) = x + p
      wr(en) = x + p
      wi(na) = zz
      wi(en) = -zz
  330 en = enm2
      go to 60
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Per Ake Malmqvist                                *
*               1989, Bjorn O. Roos                                    *
*               1991,1993, Markus P. Fuelscher                         *
*               1991,1993, Jeppe Olsen                                 *
*               1998, Roland Lindh                                     *
*               2016, Andrew M. Sand                                   *
************************************************************************
      SUBROUTINE MCPDFT(IRETURN)
************************************************************************
*                                                                      *
*           ######     #     #####   #####   #####  #######            *
*           #     #   # #   #     # #     # #     # #                  *
*           #     #  #   #  #       #       #       #                  *
*           ######  #     #  #####   #####  #       #####              *
*           #   #   #######       #       # #       #                  *
*           #    #  #     # #     # #     # #     # #                  *
*           #     # #     #  #####   #####   #####  #                  *
*                                                                      *
*                                                                      *
*                 A program for MC-PDFT calculations                   *
*                 Called after RASSCF is called.                       *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and J. Olsen, P.Aa. Malmqvist and B.O. Roos       *
*     University of Lund, Sweden                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     MOLCAS version 1 by P.Aa. Malmqvist and B.O. Roos, 1989          *
*     MOLCAS version 2 by M.P. Fuelscher and J. Olsen  , 1991          *
*     MOLCAS version 3 by M.P. Fuelscher and J. Olsen  , 1993          *
*                                                                      *
*     Modified to process only unique symmetry blocks, R. Lindh,       *
*     March '98.                                                       *
*                                                                      *
*     Modified AMS Feb 2016 - separate MCPDFT from RASSCF              *
************************************************************************

      use csfbas, only: CONF, KCFTP
      use hybridpdft, only: do_hybrid
      use stdalloc, only : mma_allocate, mma_deallocate
      use Fock_util_global, only: ALGO, DoActive, DoCholesky
      use OFembed, only: Do_OFemb, FMaux
      Implicit Real*8 (A-H,O-Z)

#include "WrkSpc.fh"
#include "wadr.fh"
#include "rasdim.fh"
#include "warnings.h"
#include "input_ras_mcpdft.fh"
#include "rasscf.fh"
#include "rasrc.fh"
#include "general.fh"
#include "gas.fh"
#include "splitcas.fh"
#include "bk_approx.fh"
#include "output_ras.fh"
#include "rctfld.fh"
#include "timers.fh"
#include "casvb.fh"
#include "rasscf_lucia.fh"
#include "lucia_ini.fh"
#include "gugx.fh"
#include "pamint.fh"
#include "qnctl_mcpdft.fh"
#include "orthonormalize_mcpdft.fh"
#include "ciinfo.fh"
*JB XMC-PDFT stuff
#include "mspdft.fh"
*Chen write JOBIPH
#include "wjob.fh"
      Integer LRState,NRState         ! storing info in Do_Rotate.txt
      Integer LHrot,NHrot             ! storing info in H0_Rotate.txt
      Real*8  MSPDFTShift
      Logical lshiftdiag
      CHARACTER(Len=18)::MatInfo
      Integer LXScratch,NXScratch
      INTEGER LUMS,IsFreeUnit
      Dimension WGRONK(2)
      External IsFreeUnit

      Logical DSCF
      Logical lOPTO
      Character*80 Line
      Logical IfOpened
      Logical Found
      Character(len=9),DIMENSION(:),Allocatable::VecStat
      CHARACTER(Len=9)::StatVec
      CHARACTER(Len=30)::mspdftfmt
      Logical RefBas
      Logical Gradient

* --------- Cholesky stuff:
#include "chopar.fh"
#include "chotime.fh"
#include "qmat_m.fh"
* --------- End Cholesky stuff
      Character*8 EMILOOP

#include "sxci_mcpdft.fh"

      External Get_ProgName
!      External Get_SuperName
      Character*100 ProgName, Get_ProgName!, Get_SuperName
      External RasScf_Init_m
      External Scan_Inp_m
!      External Proc_Inp
!      real*8 Elec_Ener
      integer iRef_E,IAD19
      integer IADR19(1:15)
      integer NMAYBE,KROOT
      real*8 EAV
!
      real*8, allocatable :: PLWO(:)
      integer ivkcnf
      Dimension Dummy(1)
* Set status line for monitor:
      Call StatusLine('MCPDFT:',' Just started.')
* Set the return code(s)
      !CASDFT_E = 0d0
      ITERM  = 0
      IRETURN=_RC_ALL_IS_WELL_

* Local print level in this routine:
      IPRLEV=IPRLOC(1)

* Set some Cholesky stuff
      DoActive=.true.
      DoQmat=.false.
      lOPTO=.False.
!      PLWO=0

!        ProgName=Get_SuperName()
!        write(*,*) 'supername',ProgName
* Set variable IfVB to check if this is a VB job.
      ProgName=Get_ProgName()
      IfVB=0
      If (ProgName(1:5).eq.'casvb') IfVB=2
* Default option switches and values, and initial data.
      EAV = 0.0d0
      Call RasScf_Init_m()
      Call Seward_Init()
* Open the one-olectron integral file:
       LuOne=77
       LuOne=isFreeUnit(LuOne)
       iRC=-1
       iOpt=0
       Call OpnOne(iRC,iOpt,'ONEINT',LuOne)
       If (iRC.ne.0) Then
        Write (6,*) 'Error when trying to open the one-electron'
        Write (6,*) 'integral file.'
        Call Quit(_RC_INTERNAL_ERROR_)
       End If
      If (IfVB.eq.2) go to 10

!      write(*,*) 'KSDFT: ',KSDFT
*
!      write(*,*) LUINPUT, IRC
* Make a copy, upper-cased, left-adjusted, of the input between and including
* the '&MCPDFT' and the 'End of input' markers, skipping all lines beginning
* with '*' or '!' or ' '  when left-adjusted, and replacing any rightmost
* substring beginning with '!' with blanks.
* That copy will be in file 'CleanInput', and its unit number is returned
* as LUInput in common (included file input_ras_mcpdft.fh) by the following call:
      Call cpinp_(LUInput,iRc)
!      write(*,*) LUINPUT, IRC
* If something wrong with input file:
      If (iRc.ne._RC_ALL_IS_WELL_) Then
       Call WarningMessage(2,'Input file is unusable.')
       Write(6,*)' MCPDFT Error: Could not make a clean copy of'
       Write(6,*)' the input file. This is an unexpected bug.'
       IRETURN=_RC_INTERNAL_ERROR_
       GOTO 9990
      End If


* Scan the input file for keywords:
      Call Scan_Inp_m(iRc)
* If something wrong with input file:
      If (iRc.ne._RC_ALL_IS_WELL_) Then
       If (IPRLOC(1).GE.TERSE) Then
        Call WarningMessage(2,'Scanning input file failed.')
* Calling again, now with iRc indicating an error, will echo the keywords:
        Call Scan_Inp_m(iRc)
       End If
       IRETURN=_RC_INPUT_ERROR_
       GOTO 9990
      End If

* Local print level in this routine:
      IPRLEV=IPRLOC(1)
*
10    CONTINUE
* Open files
      Call OpnFls_RASSCF_m(DSCF,DoCholesky)

* Some preliminary input data:
      Call Rd1Int_m
      If ( .not.DSCF ) Call Rd2Int_MCPDFT

* Printed program header:
!      If (IfVB.ne.2) Call Mem_Info('MCPDFT')


* Process the input:
      Call Proc_InpX(DSCF,iRc)
* If something goes wrong in proc_inp:
      If (iRc.ne._RC_ALL_IS_WELL_) Then
       If (IPRLEV.ge.TERSE) Then
        Call WarningMessage(2,'Input processing failed.')
        Write(6,*)' RASSCF Error: Proc_Inp failed unexpectedly.'
        Write(6,*)' Here is a printing of the input file that'
        Write(6,*)' was processed:'
        Rewind(LUInput)
  15    Continue
        Read(LuInput,'(A80)',End=16,Err=16) Line
        Write(6,*) Line
        Go To 15
  16    Continue
       End If
       IRETURN=iRc
       GOTO 9990
      End If


* Local print level may have changed:
      IPRLEV=IPRLOC(1)


      Call InpPri_m(lOpto)

!          INQUIRE(UNIT=JOBOLD,OPENED=IfOpened)
*
* If this is not CASDFT make sure the DFT flag is unset
*
      If (KSDFT(1:3).eq.'SCF') Then
        Call Get_iScalar('System BitSwitch',iFlags)
        iFlags=iAnd(iFlags,Not(2**6))
        Call Put_iScalar('System BitSwitch',iFlags)
      End If

* If the ORBONLY option was chosen, then Proc_Inp just generated
*  orbitals from the JOBIPH file. Nothing more to do:
      IF(KeyORBO) GOTO 9990

*--------------------------------------------------------
*
* Allocate various matrices
*
      Call GetMem('FI','Allo','Real',LFI,NTOT1)
      Call GetMem('FA','Allo','Real',LFA,NTOT1)
      Call GetMem('D1I','Allo','Real',LD1I,NTOT2)
      Call GetMem('D1A','Allo','Real',LD1A,NTOT2)
      Call GetMem('D1tot','Allo','Real',LD1tot,NTOT1)
      Call GetMem('OCCN','Allo','Real',LOCCN,NTOT)
      Call GetMem('LCMO','Allo','Real',LCMO,NTOT2)
      allocate(PLWO(1:NACPAR))
      PLWO(:) = 0
!
*
      LTUVX=1
      LDMAT=1
      LDSPN=1
      LPMAT=1
      LPA  =1
      If ( NAC.GT.0 ) then

         Call GetMem('TUVX','Allo','Real',LTUVX,NACPR2)
         Call FZero(Work(LTUVX),NACPR2)

         ltuvx_cvb=ltuvx

         Call GetMem('DMAT','Allo','Real',LDMAT,NACPAR)
         Call GetMem('DSPN','Allo','Real',LDSPN,NACPAR)
         Call GetMem('PMAT','Allo','Real',LPMAT,NACPR2)
         Call GetMem('P2AS','Allo','Real',LPA,NACPR2)
         call dcopy_(NACPAR,[0.0d0],0,Work(LDMAT),1)
         call dcopy_(NACPAR,[0.0d0],0,Work(LDSPN),1)
      Else
         LTUVX = ip_Dummy
         ltuvx_cvb=ltuvx
         LDMAT = ip_Dummy
         LDSPN = ip_Dummy
         LPMAT = ip_Dummy
         LPA   = ip_Dummy
      End If
*
* Get start orbitals

* Initialize OCCN array, to prevent false alarms later from
* automated detection of using uninitialized variables:
      call dcopy_(NTot,[0.0D0],0,Work(lOCCN),1)

* PAM03: Note that removal of linear dependence may change the nr
* of secondary/deleted orbitals, affecting some of the global
* variables: NSSH(),NDEL(),NORB(),NTOT3, etc etc
      Call ReadVc_m(Work(LCMO),Work(lOCCN),
     &             WORK(LDMAT),WORK(LDSPN),WORK(LPMAT),WORK(LPA))
* Only now are such variables finally known.
       If (IPRLOC(1).GE.DEBUG) Then
        CALL TRIPRT('Averaged one-body density matrix, D, in RASSCF',
     &              ' ',Work(LDMAT),NAC)
        CALL TRIPRT('Averaged one-body spin density matrix DS, RASSCF',
     &              ' ',Work(LDSPN),NAC)
        CALL TRIPRT('Averaged two-body density matrix, P',
     &              ' ',WORK(LPMAT),NACPAR)
        CALL TRIPRT('Averaged antisym 2-body density matrix PA RASSCF',
     &              ' ',WORK(LPA),NACPAR)
       END IF
*
* Allocate core space for dynamic storage of data
*
      CALL ALLOC_m
*
      if(ifvb.eq.1)call casinfo2_cvb()

      Call Timing(Swatch,Swatch,Ebel_1,Swatch)

CGG03 Aug 03
      If(NAlter.gt.0) Call Alter_MO_m(Work(LCMO))

*
*                                                                      *
************************************************************************
*                                                                      *
*     Start iterations
*                                                                      *
************************************************************************
*                                                                      *
      Rc_CI  = 0
      Rc_SX  = 0
      ECAS   = 0.0d0
      ROTMAX = 0.0d0
      ITER   = 0
      Call GetMem('FOcc','ALLO','REAL',ipFocc,nTot1)
*                                                                      *
************************************************************************
*                                                                      *
*     Entry point for second and successive iterations
*                                                                      *
************************************************************************
*                                                                      *

!      goto 413 !Jump 1
      if (KSDFT(1:5).eq.'T:'.or. KSDFT(1:3).eq.'FT:') Then
         KSDFT_TEMP=KSDFT
        KSDFT='SCF'
        ExFac=1.0D0
      else
         KSDFT_TEMP=KSDFT
      end if

      ITER=ITER+1
      If ( ITER.EQ.1 ) THEN
        Start_Vectors=.True.

!        Call Get_D1I_RASSCF(Work(LCMO),Work(lD1I))

        If (iCIRST.eq.1) Then
           Call GetMem('TmpDMAT','Allo','Real',ipTmpDMAT,NACPAR)
           call dcopy_(NACPAR,Work(LDMAT),1,Work(ipTmpDMAT),1)
           If (NASH(1).ne.NAC) Call DBLOCK_m(Work(ipTmpDMAT))
           Call Get_D1A_RASSCF_m(Work(LCMO),Work(ipTmpDMAT),WORK(LD1A))
           Call GetMem('TmpDMAT','Free','Real',ipTmpDMAT,NACPAR)
           DoActive = .true.
        Else
           lRf = .false.
           IF(KSDFT_TEMP(1:2).ne.'T:') Then
            KSDFT='SCF'
            ExFac=1.0D0
           end IF
           Call dcopy_(NTOT2,[0.0D0],0,WORK(LD1A),1)
           DoActive = .false.
        End If
        DoQmat=.false.
      end if
************************************************************************
*         ^ End First iteration
************************************************************************
*
* Print header to file containing informations on CI iterations.
*
! 413 Continue

!AMS start-
! - Read in the CASSCF Energy from JOBIPH file.  These values are not
! used in calculations, but are merely reprinted as the reference energy
! for each calculated MC-PDFT energy.
!

        iJOB=0
      Call GetMem('REF_E','ALLO','REAL',iRef_E,lroots)
      Call Fzero(Work(iRef_E),lroots)
        Call f_Inquire('JOBOLD',Found)
        if (.not.found) then
          Call f_Inquire('JOBIPH',Found)
          if(Found) JOBOLD=JOBIPH
        end if
        If (Found) iJOB=1
        If (iJOB.eq.1) Then
           if(JOBOLD.le.0) Then
             JOBOLD=20
             Call DaName(JOBOLD,'JOBOLD')
           end if
        end if
       IADR19(:)=0
       IAD19=0
      Call IDaFile(JOBOLD,2,IADR19,15,IAD19)
      jdisk = IADR19(6)
!I must read from the 'old' JOBIPH file.
      Call GetMem('ELIST','ALLO','REAL',iEList,MXROOT*MXITER)
      Call DDaFile(JOBOLD,2,Work(iEList),MXROOT*MXITER,jdisk)
      NMAYBE=0
      DO IT=1,MXITER
        AEMAX=0.0D0
        DO I=1,MXROOT
          E=WORK(iEList+MXROOT*(IT-1)+(I-1))
          AEMAX=MAX(AEMAX,ABS(E))
        END DO
        IF(ABS(AEMAX).LE.1.0D-12) GOTO 11
        NMAYBE=IT
      END DO
  11  CONTINUE
      Do_Rotate=.false.
      IF(iMSPDFT==1) Then
       call f_inquire('ROT_HAM',Do_Rotate)
       If(.not.Do_Rotate) Then
        write(6,'(6X,A,A)')'keyword "MSPD" is used but ',
     &  'the file of rotated Hamiltonian is not found.'
        write(6,'(6X,2a)')'Performing regular (state-',
     &   'specific) MC-PDFT calculation'
       End If
      End IF
      IF(Do_Rotate) Then
        write(6,'(6X,80A)') ('=',i=1,80)
        write(6,*)
        write(6,'(6X,A,A)')'keyword "MSPD" is used and ',
     &  'file recording rotated hamiltonian is found. '
        write(6,*)
        write(6,'(6X,A,A)')
     &  'Switching calculation to Multi-State Pair-Density ',
     &  'Functional Theory (MS-PDFT) '
        write(6,'(6X,A)')'calculation.'
        write(6,*)
        NHRot=lroots**2
        CALL GETMEM('HRot','ALLO','REAL',LHRot,NHRot)
        LUMS=12
        LUMS=IsFreeUnit(LUMS)
        CALL Molcas_Open(LUMS,'ROT_HAM')
        Do Jroot=1,lroots
          read(LUMS,*) (Work(LHRot+Jroot-1+(Kroot-1)*lroots)
     &                 ,kroot=1,lroots)
        End Do
        Read(LUMS,'(A18)') MatInfo
        MSPDFTMethod=' MS-PDFT'
        IF(trim(adjustl(MatInfo)).eq.'an unknown method') THEN
         write(6,'(6X,A,A)')'The MS-PDFT calculation is ',
     & 'based on a user-supplied rotation matrix.'
        ELSE
         write(6,'(6X,A,A,A)')'The MS-PDFT method is ',
     &   trim(adjustl(MatInfo)),'.'
        If(trim(adjustl(MatInfo)).eq.'XMS-PDFT') MSPDFTMethod='XMS-PDFT'
        If(trim(adjustl(MatInfo)).eq.'CMS-PDFT') MSPDFTMethod='CMS-PDFT'
        If(trim(adjustl(MatInfo)).eq.'VMS-PDFT') MSPDFTMethod='VMS-PDFT'
        If(trim(adjustl(MatInfo)).eq.'FMS-PDFT') MSPDFTMethod='FMS-PDFT'
        ENDIF
        write(6,*)
        write(6,'(6X,80A)') ('=',i=1,80)
        write(6,*)
        Close(LUMS)
        do KROOT=1,lROOTS
          ENER(IROOT(KROOT),1)=Work((LHRot+(Kroot-1)*lroots+
     &                                     (KROOT-1)))
           EAV = EAV + ENER(IROOT(KROOT),ITER) * WEIGHT(KROOT)
           Work(iRef_E + KROOT-1) = ENER(IROOT(KROOT),1)
        end do
      Else
        do KROOT=1,lROOTS
          ENER(IROOT(KROOT),1)=Work(iEList+MXROOT*(NMAYBE-1) +
     &                                     (KROOT-1))
           EAV = EAV + ENER(IROOT(KROOT),ITER) * WEIGHT(KROOT)
           Work(iRef_E + KROOT-1) = ENER(IROOT(KROOT),1)
        end do
      End IF!End IF for Do_Rotate=.true.

      Call GetMem('ELIST','FREE','REAL',iEList,MXROOT*MXITER)
      If(JOBOLD.gt.0.and.JOBOLD.ne.JOBIPH) Then
        Call DaClos(JOBOLD)
        JOBOLD=-1
      End if

!AMS end
!        Call Get_D1I_RASSCF(Work(LCMO),Work(lD1I))
!           Call Get_D1A_RASSCF(Work(LCMO),Work(LDMAT),WORK(LD1A))
!      KSDFT_TEMP=KSDFT


      Write(IterFile,*)
      Write(IterFile,'(20A4)') ('****',i=1,20)
      IF (Iter .Eq. 1) Then
         Write(IterFile,'(15X,A)') 'RASSCF iteration: 1B'
      Else
         Write(IterFile,'(15X,A,I3)') 'RASSCF iteration: ',Iter
      End If
*
        IF (KSDFT_TEMP(1:2).eq.'T:'.or.KSDFT_TEMP(1:3).eq.'FT:') Then
           KSDFT=KSDFT_TEMP
           ExFac=0.0d0
        end IF
*
* Transform two-electron integrals and compute at the same time
* the Fock matrices FI and FA
*
      Call Timing(Swatch,Swatch,Fortis_1,Swatch)
      If (.not.DoCholesky .or. ALGO.eq.1) Then
         Call GetMem('PUVX','Allo','Real',LPUVX,NFINT)
         Call FZero(Work(LPUVX),NFINT)
      Else
         LPUVX=ip_Dummy
      EndIf
      Call Get_D1I_RASSCF_m(Work(LCMO),Work(lD1I))

      DoActive = .true.
!AMS - comment out?
!      If (DoCholesky.and.ALGO.eq.2) Then
!         DoQmat=.true. ! to be used in the subsequent SX-section
!         NTav=0
!         do iSym=1,nSym
!            NTav = NTav + nBas(iSym)*nAsh(iSym)
!         end do
!         Call GetMem('Q-mat','Allo','Real',ipQmat,NTav)
!         Call Fzero(Work(ipQmat),NTav)
!      EndIf

c      call triprt('P-mat 1',' ',WORK(LPMAT),nAc*(nAc+1)/2)

       IPR=0
       IF(IPRLOC(2).EQ.4) IPR=5
       IF(IPRLOC(2).EQ.5) IPR=10

       CALL TRACTL2(WORK(LCMO),WORK(LPUVX),WORK(LTUVX),WORK(LD1I),
     &              WORK(LFI),WORK(LD1A),WORK(LFA),IPR,lSquare,ExFac)
*       If ( IPRLEV.ge.DEBUG ) then
*        write(6,*) 'FA_old'
*        call wrtmat(Work(lfa),1,ntot1,1,ntot1)
*        write(6,*) 'FI_old'
*        call wrtmat(Work(lfi),1,ntot1,1,ntot1)
*        End if

       Call Put_CMO(Work(LCMO),ntot2)

       !write(6,*) 'doGSOR is ... ',doGSOR
       if (doGSOR) then
        Call f_Inquire('JOBOLD',Found)
        if (.not.found) then
          Call f_Inquire('JOBIPH',Found)
          if(Found) JOBOLD=JOBIPH
        end if
        If (Found) iJOB=1
        If (iJOB.eq.1) Then
           if(JOBOLD.le.0) Then
             JOBOLD=20
             Call DaName(JOBOLD,'JOBOLD')
           end if
        end if
       IADR19(:)=0
       IAD19=0
       LUCT=87
       LUCT=IsFreeUnit(LUCT)
       CALL Molcas_Open(LUCT,'CI_THETA')

      Call IDaFile(JOBOLD,2,IADR19,15,IAD19)
          CALL GETMEM('CIVEC','ALLO','REAL',LW4,NCONF)
          CALL GETMEM('Dtmp ','ALLO','REAL',LW6,NACPAR)
          CALL GETMEM('DStmp','ALLO','REAL',LW7,NACPAR)
          CALL GETMEM('Ptmp ','ALLO','REAL',LW8,NACPR2)
          CALL GETMEM('PAtmp','ALLO','REAL',LW9,NACPR2)
          CALL GETMEM('Pscr','ALLO','REAL',LW10,NACPR2)

          call dcopy_(NACPAR,[0.0D0],0,WORK(LW6),1)
          call dcopy_(NACPAR,[0.0D0],0,WORK(LW7),1)
          call dcopy_(NACPR2,[0.0D0],0,WORK(LW8),1)
          call dcopy_(NCONF,[0.0D0],0,WORK(LW4),1)
          iDisk = IADR19(4)
          jDisk = IADR19(3)

       Call GetMem('CIVtmp','Allo','Real',LW11,nConf)
          DO jRoot=1,lroots
           do i=1,nconf
             read(LUCT,*) Work(LW4-1+i)
           end do
           Call DDafile(JOBOLD,1,Work(LW4),nConf,iDisk)
          call getmem('kcnf','allo','inte',ivkcnf,nactel)
          Call Reord2(NAC,NACTEL,STSYM,1,
     &                CONF,iWork(KCFTP),
     &                Work(LW4),Work(LW11),iWork(ivkcnf))
          Call dcopy_(nconf,Work(LW11),1,Work(LW4),1)
          call getmem('kcnf','free','inte',ivkcnf,nactel)
         C_Pointer = Lw4
         CALL GetMem('Lucia','Allo','Real',Lucia_Base, 1)
!Andrew - changed here
         CALL Lucia_Util('Densi',ip_Dummy,iDummy,Dummy)
                 If (IFCAS.GT.2 .OR. iDoGAS) Then
                   Call CISX_m(IDXSX,Work(LW6),Work(LW7),Work(LW8),
     &                     Work(LW9),Work(LW10))
                 End If
         CALL GetMem('Lucia','Free','Real',Lucia_Base, 1)

!         write(6,*) 'jDisk',jDisk
         Call DDafile(JOBOLD,1,Work(LW6),NACPAR,jDisk)
         Call DDafile(JOBOLD,1,Work(LW7),NACPAR,jDisk)
         Call DDafile(JOBOLD,1,Work(LW8),NACPR2,jDisk)
         Call DDafile(JOBOLD,1,Work(LW9),NACPR2,jDisk)
       end do
       Close(LUCT)

       Call fCopy('JOBIPH','JOBGS',ierr)

       end if!DoGSOR


!      write(*,*) "two ints",Work(LPUVX:LPUVX+NACPR2-1)
!      write(*,*) "LCMO",Work(LCMO:LCMO+NTOT2-1)
      If (.not.DoCholesky .or. ALGO.eq.1) Then
         if(dogradmspd) then
           CALL Put_dArray('TwoEIntegral    ',Work(LPUVX),nFINT)
         end if
         Call GetMem('PUVX','Free','Real',LPUVX,NFINT)
      EndIf

      Call Timing(Swatch,Swatch,Fortis_2,Swatch)
      Fortis_2 = Fortis_2 - Fortis_1
      Fortis_3 = Fortis_3 + Fortis_2

!      write(*,*) 'pre MSCTL CMOs'
!      do i=1,ntot2
!      write(*,*) Work(LCMO-1+i)
!      end do


      IF(KSDFT_TEMP(1:2).eq.'T:'.or. KSDFT_TEMP(1:3).eq.'FT:') Then
       IF(DoGradMSPD) THEN
        Call GetMem('F1MS' ,'Allo','Real',iF1MS ,nTot1*nRoots)
        Call GetMem('FocMS','Allo','Real',iFocMS,nTot1*nRoots)
        Call GetMem('FxyMS','Allo','Real',iFxyMS,nTot4*nRoots)
        Call GetMem('F2MS' ,'Allo','Real',iF2MS ,nACPR2*nRoots)
        Call GetMem('P2MO' ,'Allo','Real',iP2MOt,nACPR2*nRoots)
        Call GetMem('DIDA' ,'Allo','Real',iDIDA ,nTot1*(nRoots+1))
        Call GetMem('D1AOMS' ,'Allo','Real',D1AOMS,nTot1*nRoots)
           if (ispin.ne.1)
     &  Call GetMem('D1SAOMS' ,'Allo','Real',D1SAOMS,nTot1*nRoots)
        Call FZero(Work(iP2MOt),lRoots*NACPR2)
       END IF
        CALL GETMEM('CASDFT_Fock','ALLO','REAL',LFOCK,NACPAR)

        !write(6,*) 'call msctl ...'

        Call MSCtl(Work(LCMO),Work(LFOCK),Work(LFI),Work(LFA),
     &       Work(iRef_E))

        If(IWJOB==1.and.(.not.Do_Rotate)) Call writejob(iadr19)

        If (Do_Rotate) Then
         NHRot=lroots**2
         Do Jroot=1,lroots
          Work(LHRot+Jroot-1+(Jroot-1)*lroots)=Work(iRef_E-1+Jroot)
         End DO
         Write(6,'(6X,80a)') ('*',i=1,80)
         Write(6,*)
         Write(6,'(34X,2A)')MSPDFTMethod,' FINAL RESULTS'
         Write(6,*)
         Write(6,'(6X,80a)') ('*',i=1,80)
         Write(6,*)

         lshiftdiag=.false.
         CALL shiftdiag(WORK(LHRot),MSPDFTShift,lshiftdiag,lRoots,10)
         if(.not.do_hybrid) then
          write(6,'(6X,2A)')
     &    MSPDFTMethod,' Effective Hamiltonian'
         else
          write(6,'(6X,3A)')
     &    'Hybrid ',MSPDFTMethod,' Effective Hamiltonian'
         end if
         if(lshiftdiag) then
          write(6,'(6X,A,F9.2,A)')
     &    '(diagonal values increased by',-MSPDFTShift,' hartree)'
          Do JRoot=1,lRoots
           Work(LHRot+Jroot-1+(Jroot-1)*lroots)=
     &     Work(LHRot+Jroot-1+(Jroot-1)*lroots)-MSPDFTShift
          End Do
         end if
         Call RecPrt(' ','(7X,10(F9.6,1X))',Work(LHRot),lroots,lroots)
         write (6,*)
*MS-PDFT    To diagonalize the final MS-PDFT effective H matrix.
*MS-PDFT    Eigenvectors will be stored in LRState. This notation for the
*MS-PDFT    address here is the same for the rotated space in XMS-CASPT2.
         NRState=NHRot
         CALL GETMEM('RotStat','ALLO','REAL',LRState,NRState)
         Call FZero(Work(LRState),NRState)
         Call Dsyev_('V','U',lroots,Work(LHRot),lroots,Work(LRState),
     &               WGRONK,-1,INFO)
         NXScratch=Int(WGRONK(1))
         Call GetMem('XScratch','Allo','Real',LXScratch,NXScratch)
         Call Dsyev_('V','U',lroots,Work(LHRot),lroots,Work(LRState),
     &               Work(LXScratch),NXScratch,INFO)

         if(lshiftdiag) then
          Do Jroot=1,lRoots
           Work(LRState+Jroot-1)=Work(LRState+Jroot-1)+MSPDFTShift
          End Do
         end if

         if(.not.do_hybrid) then
          write(6,'(6X,2A)')MSPDFTMethod,' Energies:'
          Do Jroot=1,lroots
            write(6,'(6X,3A,1X,I4,3X,A13,F18.8)')
     & '::    ',MSPDFTMethod,' Root',
     &      Jroot,'Total energy:',Work(LRState+Jroot-1)
          End Do
         else
          write(6,'(6X,3A)')'Hybrid ',MSPDFTMethod,' Energies:'
          Do Jroot=1,lroots
            write(6,'(6X,4A,1X,I4,3X,A13,F18.8)')
     & '::    ','Hybrid ',MSPDFTMethod,' Root',
     &      Jroot,'Total energy:',Work(LRState+Jroot-1)
          End Do
         end if
      Call Put_iScalar('Number of roots',nroots)
      Call Put_dArray('Last energies',WORK(LRState),nroots)
      Call Put_dScalar('Last energy',WORK(LRState+iRlxRoot-1))
         Write(6,*)
         CALL mma_allocate(VecStat,lRoots)
         Do Jroot=1,lRoots
          write(StatVec,'(A5,I4)')'Root ',JRoot
          VecStat(JRoot)=StatVec
         End Do
         if(.not.do_hybrid) then
          write(6,'(6X,2A)')MSPDFTMethod,' Eigenvectors:'
         else
          write(6,'(6X,3A)')'Hybrid ',MSPDFTMethod,' Eigenvectors:'
         end if
         write(6,'(7X,A)')'Intermediate-state Basis'
          write(mspdftfmt,'(A4,I5,A9)')
     &     '(6X,',lRoots,'(A10,5X))'
          write(6,mspdftfmt)((VecStat(JRoot)),JRoot=1,lroots)
*Added by Chen to write energies and states of MS-PDFT into JOBIPH
         If(IWJOB==1) Call writejobms(iadr19,LRState,LHRot)
         Call RecPrt(' ','(7X,10(F9.6,6X))',
     &               Work(LHRot),lroots,lroots)
         if(DoGradMSPD) then
           Call MSPDFTGrad_Misc(LHRot)
           Call GetMem('F1MS' ,'Free','Real',iF1MS , nTot1*nRoots)
           Call GetMem('F2MS' ,'Free','Real',iF2MS ,nACPR2*nRoots)
           Call GetMem('FxyMS','Free','Real',iFxyMS, nTot4*nRoots)
           Call GetMem('P2MO' ,'Free','Real',iP2MOt,nACPR2*nRoots)
           Call GetMem('FocMS','Free','Real',iFocMS, nTot1*nRoots)
           Call GetMem('DIDA' ,'Free','Real',iDIDA ,nTot1*(nRoots+1))
           Call GetMem('D1AOMS' ,'Free','Real',D1AOMS,nTot1*nRoots)
           if (ispin.ne.1)
     &     Call GetMem('D1SAOMS' ,'Free','Real',D1SAOMS,nTot1*nRoots)
          end if
*         Write(6,*)
         refbas=.false.
         call f_inquire('ROT_VEC',RefBas)
         Call GetMem('XScratch','FREE','Real',LXScratch,NXScratch)
*print MS-PDFT final states in basis of reference states
*re-use RotStat, XScratch and LRState
         if(RefBas) then
          NXScratch=NHRot
          Call GetMem('XScratch','ALLO','Real',LXScratch,NXScratch)
          Call FZero(Work(LXScratch),NXScratch)
          Call FZero(Work(LRState)  ,NXScratch)
          CALL ReadMat2('ROT_VEC',MatInfo,WORK(LRState),
     &                     lRoots,lRoots,7,18,'T')
          CALL DGEMM_('n','n',lRoots,lRoots,lRoots,1.0d0,Work(LRState),
     &         lRoots,Work(LHRot),lRoots,0.0d0,Work(LXScratch),lRoots)
          write(6,'(7X,A)')'Reference-state Basis'
          write(6,mspdftfmt)((VecStat(JRoot)),JRoot=1,lroots)
          Call RecPrt(' ','(7X,10(F9.6,6X))',
     &                Work(LXScratch),lroots,lroots)
          CALL PrintMat2('FIN_VEC',MatInfo,WORK(LXScratch),
     &                      lRoots,lRoots,7,18,'T')
          Call GetMem('XScratch','FREE','Real',LXScratch,NXScratch)
         end if
*        Gradient part
         if(DoGradMSPD) then
          Call Put_iScalar('Number of roots',nroots)
          Call Put_cArray('Relax Method','MSPDFT  ',8)
          Call Put_cArray('MCLR Root','****************',16)
          Call Put_iScalar('Relax CASSCF root',irlxroot)
         end if
         Write(6,'(6X,80a)') ('*',i=1,80)
         CALL GETMEM('HRot','FREE','REAL',LHRot,NHRot)
         CALL GETMEM('RotStat','FREE','REAL',LRState,NRState)
         CALL mma_deallocate(VecStat)
        End If
        CALL GETMEM('CASDFT_Fock','FREE','REAL',LFOCK,NACPAR)
      END IF


!      Call rasscf_mcontrol(Iter)
!      Call Timing(Swatch,Swatch,Gucci_1,Swatch)

!AMS - comment out here, too!
!      If (DoCholesky.and.ALGO.eq.2) Then
!         Call GetMem('Q-mat','Free','Real',ipQmat,NTav)
!      EndIf

       !write(6,*) 'done mcpdft...'

*                                                                      *
************************************************************************
*                                                                      *
*     Compute Final CI vectors
*                                                                      *
************************************************************************
*                                                                      *
      ICICH=0
*****************************************************************************************
***************************           Closing up MC-PDFT      ***************************
*****************************************************************************************

************************************************************************
*  write essential information for subsequent gradient calculations.
      Gradient=.False.
      If(Gradient) then

        If (.not.DoCholesky .or. ALGO.eq.1) Then
          Call GetMem('PUVX','Allo','Real',LPUVX,NFINT)
          Call FZero(Work(LPUVX),NFINT)
        EndIf

        CALL TRACTL2(WORK(LCMO),WORK(LPUVX),WORK(LTUVX),WORK(LD1I),
     &             WORK(LFI),WORK(LD1A),WORK(LFA),IPR,lSquare,ExFac)

        Call Get_D1I_RASSCF_m(Work(LCMO),Work(lD1I))
        Call GetMem('Fcore','Allo','Real',iTmp1,nTot1)
        iComp  =  1
        iSyLbl =  1
        iRc    = -1
        iOpt   =  6
        Call RdOne(iRc,iOpt,'OneHam',iComp,Work(iTmp1),iSyLbl)

!        Call GetMem('Dens','ALLO','REAL',ipDens,nTot1)


        !if(CASDFT_E.eq.0) then
        !  CASDFT_E = ECAS
        !end if

!        Elec_Ener = CASDFT_E-PotNuc
        write(6,*) "PLWO"
        write(6,*) PLWO(:)
!        Call Calc_E(Work(LDMAT),Work(LDSPN),WORK(LPMAT),
!     &            Work(ipDens),Work(LCMO),Work(LTUVX),
!     &            Work(iTmp1),Elec_Ener,PLWO)
        Call GetMem('Dens','FREE','REAL',ipDens,nTot1)
        Call GetMem('Fcore','FREE','Real',iTmp1,nTot1)
        Call GetMem('PUVX','FREE','Real',LPUVX,NFINT)
        deallocate(PLWO)
!       Necessary for analgrad in Alaska.
        Call Put_iScalar('PDFT ready',0)


      End If

*^follow closing up MC-PDFT
*
* release SEWARD
*
      Call ClsSew
* ClsSew is needed for releasing memory used by integral_util, rys... which is allocated when MC-PDFT run is performed.

*---  Finalize Cholesky information if initialized
      if (DoCholesky)then
         Call Cho_X_Final(irc)
         if (irc.ne.0) then
            Write(LF,*)'RASSCF: Cho_X_Final fails with return code ',irc
            Write(LF,*)' Try to recover. Calculation continues.'
         endif
         If (Do_OFemb) Then
            Call mma_deallocate(FMaux)
            Call OFE_print(EAV)
         EndIf
      endif

*  Release  some memory allocations
      Call GetMem('FOCC','FREE','REAL',ipFocc,NTOT1)
      Call GetMem('FI','Free','Real',LFI,NTOT1)
      Call GetMem('FA','Free','Real',LFA,NTOT1)
      Call GetMem('D1I','Free','Real',LD1I,NTOT2)
      Call GetMem('D1A','Free','Real',LD1A,NTOT2)
      Call GetMem('D1tot','Free','Real',lD1tot,NTOT1)
      Call GetMem('LCMO','Free','Real',LCMO,NTOT2)
      Call GetMem('REF_E','Free','REAL',iRef_E,lroots)
      Call GetMem('OCCN','Free','Real',LOCCN,NTOT)

      If ( NAC.GT.0 ) then
        Call GetMem('DMAT','free','Real',LDMAT,NACPAR)
        Call GetMem('DSPN','free','Real',LDSPN,NACPAR)
        Call GetMem('PMAT','free','Real',LPMAT,NACPR2)
        Call GetMem('P2AS','free','Real',LPA,NACPR2)
        Call GetMem('TUVX','free','Real',LTUVX,NACPR2)
      End if

      If (iClean.eq.1) Call Free_iWork(ipCleanMask)
*
* Create output orbital files:
!      Call OrbFiles(JOBIPH,IPRLEV)
*
       if (doGSOR) then
          CALL GETMEM('CIVEC','FREE','REAL',LW4,NCONF)
          CALL GETMEM('Dtmp ','FREE','REAL',LW6,NACPAR)
          CALL GETMEM('DStmp','FREE','REAL',LW7,NACPAR)
          CALL GETMEM('Ptmp ','FREE','REAL',LW8,NACPR2)
          CALL GETMEM('PAtmp','FREE','REAL',LW9,NACPR2)
          CALL GETMEM('Pscr','FREE','REAL',LW10,NACPR2)
          Call GetMem('CIVtmp','FREE','Real',LW11,nConf)
          Call Lucia_Util('CLOSE',iDummy,iDummy,Dummy)
          Call MKGUGA_FREE_m
       end if
* Exit
*
      Call StatusLine('MCPDFT:','Finished.')
      If (IPRLEV.GE.2) Write(LF,*)
      if(ifvb.eq.1) call make_close_rvb_m
cvv call to grid is moved up, in order to call clssew safely..
c       If (iCIonly.eq.0) Then
c         Call Grid_driver(-1,'RASSCF','RASORB',iR)
c       End If

      Call Timing(Swatch,Swatch,Ebel_3,Swatch)
      IF (IPRLEV.GE.3) THEN
       Call PrtTim_m
       Call FastIO('STATUS')
      END IF
      Call ClsFls_RASSCF_m()

!      Call GetMem(' ','Flush','Real',ipLow,1)
!      Call Free_Work(ipLow)

*
      Rc_RAS = ITERM
      Rc_RAS = Max(RC_RAS,Rc_CI)
      Rc_RAS = Max(RC_RAS,Rc_SX)
      If (Rc_Ras.eq.0) then
         ireturn=_RC_ALL_IS_WELL_
      Else If (Rc_Ras.eq.16) then
         ireturn=_RC_NOT_CONVERGED_
      Else
         Call WarningMessage(2,'Something is wrong: Did CI fail?')
         ireturn=_RC_GENERAL_ERROR_
      End If
*
      If (Do_OFemb) Then
         Call GetEnvF('EMIL_InLoop',EMILOOP)
         If (EMILOOP.eq.' ') EMILOOP='0'
         If (EMILOOP(1:1).ne.'0') Then
            If (iReturn.ne._RC_ALL_IS_WELL_) Then
               Call WarningMessage(1,'RASSCF: non-zero return code.')
            EndIf
            iReturn=_RC_CONTINUE_LOOP_
            Call Check_FThaw(iReturn)
         EndIf
      EndIf

!      if(.not.(iDoGas.or.doDMRG.or.doBlockDMRG.or.iDoNeci)) then
!        Call MKGUGA_FREE_m
!      end if

 9990 Continue

C Close the one-electron integral file:
      iRC=-1
      iOpt=0
      Call ClsOne(iRC,iOpt)
      If (iRC.ne.0) Then
         Write (6,*) 'Error when trying to close the one-electron'
         Write (6,*) 'integral file.'
         Call Quit(_RC_INTERNAL_ERROR_)
      End If

      If (IfVB.ne.2) Then
        DO I=10,99
          INQUIRE(UNIT=I,OPENED=IfOpened)
          IF (IfOpened.and.I.ne.19) CLOSE (I)
        END DO
        Close(LUInput)
      End If
      return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkV_Q22(W2,W1,dima)
! this routine does
! W1(j,u,i,a') = 2W2(i,u,j,a')-W2(j,u,i,a')
!
! N.B. Kvajt odflaknute

use chcc_global, only: no
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima
real(kind=wp), intent(in) :: W2(no,no,no,dima)
real(kind=wp), intent(out) :: W1(no,no,no,dima)
integer(kind=iwp) :: i, u

do i=1,no
  do u=1,no
    W1(:,u,i,:) = W2(:,u,i,:)-Two*W2(i,u,:,:)
  end do
end do

return

end subroutine MkV_Q22

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
*               1993, Per Boussard                                     *
************************************************************************
      SubRoutine PrjInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of ECP integrals.         *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by ECPMem                 *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
*             Physics, University of Stockholm, Sweden, October '93.   *
************************************************************************
      use Basis_Info
      use Center_Info
      use Real_Spherical
      use Symmetry_Info, only: nIrrep, iChTbl
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"

#include "int_interface.fh"

*     Local varables
      Real*8 C(3), TC(3)
      Integer iDCRT(0:7), iTwoj(0:7)
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Character*80 Label
#endif
      Data iTwoj/1,2,4,8,16,32,64,128/
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
#ifdef _DEBUGPRINT_
      Call RecPrt(' In PrjInt: Zeta',' ',Zeta,1,nZeta)
      Call RecPrt(' In PrjInt: A',' ',A,1,3)
      Call RecPrt(' In PrjInt: RB',' ',RB,1,3)
      Call RecPrt(' In PrjInt: Ccoor',' ',Ccoor,1,3)
      Call RecPrt(' In PrjInt: P',' ',P,nZeta,3)
      Write (6,*) ' In PrjInt: la,lb=',' ',la,lb
#endif
*
*     call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
      Final(:,:,:,:)=Zero
*
      llOper = lOper(1)
      iComp = 1
      mdc = 0
      Do iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%ECP) Then
            mdc = mdc + dbsc(iCnttp)%nCntr
            Cycle
         End If
         Do iCnt = 1,dbsc(iCnttp)%nCntr
            C(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
         Do lDCRT = 0, nDCRT-1
            Call OA(iDCRT(lDCRT),C,TC)
            Do iAng = 0, dbsc(iCnttp)%nPrj-1
               iShll = dbsc(iCnttp)%iPrj + iAng
               nExpi=Shells(iShll)%nExp
               nBasisi=Shells(iShll)%nBasis
               If (nExpi.eq.0 .or. nBasisi.eq.0) Cycle
*
#ifdef _DEBUGPRINT_
               Call RecPrt('Cff',' ',Shells(iShll)%pCff,nExpi,
     &                     nBasisi)
#endif
               ip = 1
               ipF1 = ip
               nac = nElem(la)*nElem(iAng)
               ip = ip + nAlpha*nExpi*nac
               ipP1 = ip
               ip = ip + 3 * nAlpha*nExpi
               ipZ1 = ip
               ip = ip + nAlpha*nExpi
               ipK1 = ip
               ip = ip + nAlpha*nExpi
               ipZI1 = ip
               ip = ip + nAlpha*nExpi
               If (ip-1.gt.nArr*nZeta) Then
                  Call WarningMessage(2,'PrjInt: ip-1.gt.nArr*nZeta(1)')
                  Call Abend()
               End If
               mArr = (nArr*nZeta-(ip-1))/nZeta
*
*--------------Calculate Effective center and exponent for <A|core>
*
               Call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,nExpi,
     &                   Alpha,Shells(iShll)%Exp)
               Call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,
     &                     A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))
*
*--------------Calculate Overlap <A|core>
*
               nHer = (la+iAng+2)/2
               Call MltPrm(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,
     &                   Array(ipZ1),Array(ipZI1),
     &                   Array(ipK1),Array(ipP1),
     &                   Array(ipF1),nAlpha*nExpi,iComp,
     &                   la,iAng,A,TC,nHer,Array(ip),
     &                   mArr,CCoor,nOrdOp)
               ip = ip - 6 * nAlpha*nExpi
*
               ipF2 = ip
               ncb = nElem(iAng)*nElem(lb)
               ip = ip + nExpi*nBeta*ncb
               ipP2 = ip
               ip = ip + 3 * nExpi*nBeta
               ipZ2 = ip
               ip = ip + nExpi*nBeta
               ipK2 = ip
               ip = ip + nExpi*nBeta
               ipZI2 = ip
               ip = ip + nExpi*nBeta
               If (ip-1.gt.nArr*nZeta) Then
                  Call WarningMessage(2,'PrjInt: ip-1.gt.nArr*nZeta(2)')
                  Call Abend()
               End If
               mArr = (nArr*nZeta-(ip-1))/nZeta
*
*--------------Calculate Effective center and exponent for <core|B>
*
               Call ZXia(Array(ipZ2),Array(ipZI2),nExpi,nBeta,
     &                   Shells(iShll)%Exp,Beta)
               Call SetUp1(Shells(iShll)%Exp,nExpi,Beta,nBeta,
     &                    TC,RB,Array(ipK2),Array(ipP2),Array(ipZI2))
*
*--------------Calculate Overlap <core|B>
*
               nHer = (iAng+lb+2)/2
               Call MltPrm(Shells(iShll)%Exp,nExpi,Beta,nBeta,
     &                   Array(ipZ2),Array(ipZI2),
     &                   Array(ipK2),Array(ipP2),
     &                   Array(ipF2),nExpi*nBeta,iComp,
     &                   iAng,lb,TC,RB,nHer,Array(ip),
     &                   mArr,CCoor,nOrdOp)
               ip = ip - 6 * nExpi*nBeta
               ipTmp = ip
               ip = ip + Max(nAlpha*nExpi*nac,
     &                       nBeta*ncb*nBasisi)
               If (ip-1.gt.nArr*nZeta) Then
                  Call WarningMessage(2,'PrjInt: ip-1.gt.nArr*nZeta(3)')
                  Call Abend()
               End If
*
*--------------Calculate Contraction over components of the core
*              orbitals of type <A|core>Bc<core|B> where we now have in
*              Array(ipF1) the cartesian components of <A|core>, and
*              similarily, in Array(ipF2), we have stored the cartesian
*              components of <core|B>. Observe that the core orbitals
*              orthonomal atomic orbitals. Hence, the transformation
*              to the spherical harmonics has to be for normilized
*              spherical harminics.
*
*--------------From the lefthandside overlap, form iKaC from ikac by
*              1) i,kac -> k,aci
*
               Call DgeTMo(Array(ipF1),nAlpha,nAlpha,
     &                     nExpi*nac,Array(ipTmp),nExpi*nac)
*
*--------------2) aciK =  k,aci * k,K
*
               Call DGEMM_('T','N',
     &                     nAlpha*nac,nBasisi,nExpi,
     &                     1.0d0,Array(ipTmp),nExpi,
     &                     Shells(iShll)%pCff,nExpi,
     &                     0.0d0,Array(ipF1),nAlpha*nac)
*
*--------------3) Mult by shiftoperators aci,K -> Bk(K) * aci,K
*
               Do iBk = 1, nBasisi
                  Bk = Shells(ishll)%Bk(iBk)
                  Call DScal_(nAlpha*nac,Bk,
     &                       Array(ipF1+(iBk-1)*nAlpha*nac),1)
               End Do ! iBk
*
*--------------4) a,ciK -> ciKa
*
               Call DgeTMo(Array(ipF1),nElem(la),nElem(la),
     &                     nElem(iAng)*nAlpha*nBasisi,
     &                     Array(ipTmp),
     &                     nElem(iAng)*nAlpha*nBasisi)
*
*--------------5) iKa,C = c,iKa * c,C
*
               Call DGEMM_('T','N',
     &                     nAlpha*nBasisi*nElem(la),
     &                     (2*iAng+1),nElem(iAng),
     &                     1.0d0,Array(ipTmp),nElem(iAng),
     &                     RSph(ipSph(iAng)),nElem(iAng),
     &                     0.0d0,Array(ipF1),
     &                     nAlpha*nBasisi*nElem(la))
*
*--------------And (almost) the same thing for the righthand side, form
*              KjCb from kjcb
*              1) jcb,K = k,jcb * k,K
*
               Call DGEMM_('T','N',
     &                     nBeta*ncb,nBasisi,nExpi,
     &                     1.0d0,Array(ipF2),nExpi,
     &                     Shells(iShll)%pCff,nExpi,
     &                     0.0d0,Array(ipTmp),nBeta*ncb)
*
*--------------2)  j,cbK -> cbK,j
*
               Call DgeTMo(Array(ipTmp),nBeta,nBeta,
     &                     nBasisi*ncb,Array(ipF2),
     &                     nBasisi*ncb)
*
*--------------3) bKj,C = c,bKj * c,C
*
               Call DGEMM_('T','N',
     &                     nElem(lb)*nBasisi*nBeta,
     &                     (2*iAng+1),nElem(iAng),
     &                     1.0d0,Array(ipF2),nElem(iAng),
     &                     RSph(ipSph(iAng)),nElem(iAng),
     &                     0.0d0,Array(ipTmp),
     &                     nElem(lb)*nBasisi*nBeta)
*
*--------------4) b,KjC -> KjC,b
*
               Call DgeTMo(Array(ipTmp),nElem(lb),nElem(lb),
     &                     nBasisi*nBeta*(2*iAng+1),Array(ipF2),
     &                     nBasisi*nBeta*(2*iAng+1))
*
*--------------Next Contract (iKaC)*(KjCb) over K and C, producing ijab,
*              by the following procedure:
*              Loop over a and b
*                Loop over C
*                  Contract iK(aC)*Kj(Cb), over K producing ij(aCb),
*                    accumulate to ij(ab)
*                End loop C
*              End Loop b and a
*
               Do ib = 1, nElem(lb)
                  Do ia = 1, nElem(la)
*
                     Do iC = 1, (2*iAng+1)
                        iaC = (iC-1)*nElem(la) + ia
                        ipaC = (iaC-1)*nAlpha*nBasisi + ipF1
                        iCb = (ib-1)*(2*iAng+1) + iC
                        ipCb = (iCb-1)*nBasisi*nBeta  + ipF2
*
                        iIC = 0
                        Do iIrrep = 0, nIrrep-1
                           If (iAnd(llOper,iTwoj(iIrrep)).eq.0) Cycle
                           iIC = iIC + 1
                           nOp = NrOpr(iDCRT(lDCRT))
                           Xg=DBLE(iChTbl(iIrrep,nOp         ))
                           Factor=Xg*Fact
                           Call DGEMM_('N','N',
     &                                nAlpha,nBeta,nBasisi,
     &                                Factor,Array(ipaC),nAlpha,
     &                                    Array(ipCb),nBasisi,
     &                                One,Final(1,ia,ib,iIC),nAlpha)
                        End Do ! iIrrep
*
                     End Do ! iC
                  End Do    ! ia
               End Do       ! ib
            End Do ! iAng
*
         End Do ! lDCRT
         End Do ! iCnt
         mdc = mdc + dbsc(iCnttp)%nCntr
      End Do ! iCnttp
*
#ifdef _DEBUGPRINT_
         Write (6,*) ' Result in PrjInt'
         Do 100 ia = 1, (la+1)*(la+2)/2
            Do 200 ib = 1, (lb+1)*(lb+2)/2
               Write (Label,'(A,I2,A,I2,A)')
     &               ' Final(',ia,',',ib,')'
               Call RecPrt(Label,' ',Final(1,ia,ib,1),nAlpha,nBeta)
 200        Continue
 100     Continue
#endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(P)
         Call Unused_real_array(Zeta)
         Call Unused_real_array(ZInv)
         Call Unused_real_array(rKappa)
         Call Unused_integer(nRys)
         Call Unused_integer_array(iChO)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016, Giovanni Li Manni                                *
************************************************************************
      Subroutine DecoMat(MAT,dimens,eigenvec,NumV,rc)
************* by G. Li Manni Stuttgart March 2016 *************
*
* MAT:      copy of the D1A matrix (1RDM) in AO basis.
*           It will be destroyed in eigen_molcas
*
* DIMENS:   dimension of the square MAT = nbas(isym)
*
* EIGENVEC: First it is used as scratch inside eigen_molcas. Next it will contains eigenvectors
*           of the eigen-decomposed matrix in Cholesky form. Instead of eigenvectors X such that MAT = XDX^t,
*           eigenvectors are presented as Y = X(D**0.5) such that MAT = YY^t.
*           Negative eigenvalues are set to zero and eigenvalue larger than 2.0d0 set to 2.0d0
*
* NUMV    : Number of non negative eigenvalues
      implicit none
      integer dimens,NumV,NumVnull,rc,i,j
      real*8 MAT(dimens,dimens),eigenvec(dimens,dimens)
      real*8 eigenval(dimens)

      Character*12 routine
      Parameter (routine = 'DecoNegatMat')

      rc = 0
      NumV = 0
      NumVnull = 0

      If (dimens .lt. 1) then
       rc= -1
       write(6,*) 'matrix size < 1'
       Go To 10
      end if

* Step 1: diagonalize MAT. MAT is destroyed and replaced by the eigenvectors values.
* IMPORTANT: At this stage eigenvec is used as scratch.
      call eigen_molcas(dimens,MAT,eigenval,eigenvec)
* Move MAT to eigenvec. where it belongs. I could not wait!
      call dcopy_(dimens**2,MAT,1,eigenvec,1)
* Set to zero negative eigenvalue and to TWO values larger than 2.0d0.
* Count only the positive ones (counter NumV)
      do j = 1, dimens
       if(eigenval(j).gt.1.0d-12) then
          NumV = NumV + 1
          if(eigenval(j).gt.2.0d0) eigenval(j) = 2.0d0
       else
        eigenval(j) = 0.0d0
       end if
      end do
* Sort eigenvalues in decreasing order of occupation number
      call IncrSort(eigenval,eigenvec,dimens)
* Compute sqrt(eigenvalues)
      do i = 1, dimens
          eigenval(i) = sqrt(eigenval(i))
      end do
* Generate Y = X(D**0.5)
      do j = 1, dimens
          do i = 1, dimens
           eigenvec(i,j) = eigenvec(i,j)*eigenval(j)
          end do
      end do
****************** Exit ****************
10    Continue
      return
      end subroutine

      SUBROUTINE IncrSort(EVal,EVec,dimens)
      Implicit none
      integer dimens, i, k, j, l
      Real*8 EVal(dimens),EVec(dimens,dimens),swap
      Do i = 1,dimens - 1
         k = i
         do j = i + 1, dimens
            If (EVal(j).gt.EVal(k)) k = j
         end do
         If (k.ne.i) Then
            Swap    = EVal(k)
            EVal(k) = EVal(i)
            EVal(i) = Swap
            do l = 1, dimens
               Swap      =   EVec(l,k)
               EVec(L,K) =   EVec(l,i)
               EVec(L,I) =   Swap
            end do
         End If
      End Do
      Return
      End Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dirvect(P1,R1,P2,R2,vec,dist)
! this Subroutine computes the directional vector of the origins of two points P1 and P2
! P1 : coords of the first point
! P2 : coords of the second point
! R1 : rot. matrix of the  first point to the general coordinate system
! R2 : rot. matrix of the second point to the general coordinate system

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: P1(3), R1(3,3), P2(3), R2(3,3)
real(kind=wp), intent(out) :: vec(3), dist
integer(kind=iwp) :: j
real(kind=wp) :: C1(3), C2(3)
real(kind=wp), external :: distance

C1(:) = Zero
C2(:) = Zero

do j=1,3
  C1(:) = C1(:)+P1(j)*R1(:,j)
  C2(:) = C2(:)+P2(j)*R2(:,j)
end do
dist = distance(3,C1,C2)
vec(:) = (C1(:)-C2(:))/dist

return

end subroutine dirvect

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

* This module simply provides an interface for the EAF subroutines with
* real buffers instead of integers, note that nBuf is still the length
* of the integer buffer.

      Module dEAF
      Use Iso_C_Binding
      Implicit None

      Contains

      Subroutine dEAFARead(Lu,Buf,nBuf,Disk,id)
      Integer :: Lu, nBuf, id
      Real*8, Target :: Buf(nBuf)
      Real*8 :: Disk
      Integer, Pointer :: iBuf(:)
      Call C_F_Pointer(C_Loc(Buf),iBuf,[nBuf])
      Call EAFARead(Lu,iBuf,nBuf,Disk,id)
      Nullify(iBuf)
      End Subroutine dEAFARead

      Subroutine dEAFAWrite(Lu,Buf,nBuf,Disk,id)
      Integer :: Lu, nBuf, id
      Real*8, Target :: Buf(nBuf)
      Real*8 :: Disk
      Integer, Pointer :: iBuf(:)
      Call C_F_Pointer(C_Loc(Buf),iBuf,[nBuf])
      Call EAFAWrite(Lu,iBuf,nBuf,Disk,id)
      Nullify(iBuf)
      End Subroutine dEAFAWrite

      Subroutine dEAFRead(Lu,Buf,nBuf,Disk)
      Integer :: Lu, nBuf
      Real*8, Target :: Buf(nBuf)
      Real*8 :: Disk
      Integer, Pointer :: iBuf(:)
      Call C_F_Pointer(C_Loc(Buf),iBuf,[nBuf])
      Call EAFRead(Lu,iBuf,nBuf,Disk)
      Nullify(iBuf)
      End Subroutine dEAFRead

      Subroutine dEAFWrite(Lu,Buf,nBuf,Disk)
      Integer :: Lu, nBuf
      Real*8, Target :: Buf(nBuf)
      Real*8 :: Disk
      Integer, Pointer :: iBuf(:)
      Call C_F_Pointer(C_Loc(Buf),iBuf,[nBuf])
      Call EAFWrite(Lu,iBuf,nBuf,Disk)
      Nullify(iBuf)
      End Subroutine dEAFWrite

      End Module dEAF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NATSPIN_RASSI(DMAT,TDMZZ,VNAT,OCC,EIGVEC)
      use rassi_aux, only : iDisk_TDM
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "rassi.fh"
#include "symmul.fh"
#include "Files.fh"
#include "WrkSpc.fh"
      DIMENSION DMAT(NBSQ),TDMZZ(NTDMZZ),VNAT(NBSQ),OCC(NBST)
      CHARACTER*14 FNAME
      CHARACTER*8 KNUM
      REAL*8 EIGVEC(NSTATE,NSTATE)

      EXTERNAL ISFREEUNIT
      EXTERNAL DDOT_

      DIMENSION Dummy(1),iDummy(7,8)

C ALLOCATE WORKSPACE AREAS.
      NSZZ=NBTRI
      NVEC=NBSQ
      NVEC2=NBMX**2
      NSCR=NBMX**2
      NEIG=NBST
      CALL GETMEM('SZZ   ','ALLO','REAL',LSZZ,NSZZ)
      CALL GETMEM('VEC   ','ALLO','REAL',LVEC,NVEC)
      CALL GETMEM('VEC2  ','ALLO','REAL',LVEC2,NVEC2)
      CALL GETMEM('SCR   ','ALLO','REAL',LSCR,NSCR)
      CALL GETMEM('EIG   ','ALLO','REAL',LEIG,NEIG)
C READ ORBITAL OVERLAP MATRIX.
      IRC=-1
      IOPT=6
      ICMP=1
      ISYLAB=1
      CALL RDONE(IRC,IOPT,'MLTPL  0',ICMP,WORK(LSZZ),ISYLAB)
      IF ( IRC.NE.0 ) THEN
        WRITE(6,*)
        WRITE(6,*)'      *** ERROR IN SUBROUTINE  NATSPIN ***'
        WRITE(6,*)'      OVERLAP INTEGRALS ARE NOT AVAILABLE'
        WRITE(6,*)
        CALL ABEND()
      ENDIF
C DIAGONALIZE EACH SYMMETRY BLOCK OF THE OVERLAP MATRIX.
      LS=LSZZ
      LV=LVEC
      LE=LEIG
      CALL FZERO(WORK(LVEC),NVEC)
      DO 100 ISYM=1,NSYM
        NB=NBASF(ISYM)
        DO 20 I=1,NB**2,(NB+1)
          WORK(LV-1+I)=1.0D00
20      CONTINUE
        CALL JACOB(WORK(LS),WORK(LV),NB,NB)
C SCALE EACH VECTOR TO OBTAIN AN ORTHONORMAL BASIS.
        LS1=LS
        LV1=LV
        LE1=LE
        DO 30 I=1,NB
          EIG=WORK(LS1)
          WORK(LE1)=EIG
          X=1.0D00/SQRT(MAX(EIG,1.0D-14))
          CALL DSCAL_(NB,X,WORK(LV1),1)
          LS1=LS1+I+1
          LV1=LV1+NB
          LE1=LE1+1
30      CONTINUE
        LS=LS+(NB*(NB+1))/2
        LV=LV+NB**2
        LE=LE+NB
100   CONTINUE
      CALL GETMEM('SZZ   ','FREE','REAL',LSZZ,NSZZ)

C VERY LONG LOOP OVER EIGENSTATES KEIG.
      DO KEIG=1,NRNATO

        CALL DCOPY_(NBSQ,[0.0D0],0,DMAT,1)
C DOUBLE LOOP OVER RASSCF WAVE FUNCTIONS, TRIANGULAR.
        DO I=1,NSTATE
          DO J=1,I
C WEIGHT WITH WHICH THIS TDM CONTRIBUTES IS EIGVEC(I,KEIG)*EIGVEC(J,KEIG).
C HOWEVER, WE ARE LOOPING TRIANGULARLY AND WILL RESTORE SYMMETRY BY
C ADDING TRANSPOSE AFTER DMAT HAS BEEN FINISHED, SO I=J IS SPECIAL CASE:
            X=EIGVEC(I,KEIG)*EIGVEC(J,KEIG)
            IF(ABS(X).GT.1.0D-12) THEN
              iDisk=iDisk_TDM(J,I,1)
              iEmpty=iDisk_TDM(J,I,2)
              If (IAND(iEmpty,2).ne.0) Then
                 iDisk=iDisk_TDM(J,I,1)
                 iOpt=2
                 iGo=2
C PICK UP TRANSITION SPIN DENSITY MATRIX FOR THIS PAIR OF RASSCF STATES:
                 CALL dens2file(TDMZZ,TDMZZ,TDMZZ,nTDMZZ,
     &                          LUTDM,IDISK,iEmpty,iOpt,iGo,I,J)
                 IF(I.EQ.J) X=0.5D00*X
                 CALL DAXPY_(NTDMZZ,X,TDMZZ,1,DMAT,1)
              End If
            END IF
          END DO
        END DO
C LOOP OVER SYMMETRY BLOCKS OF DMAT.
        ID=1
        INV=1
        IOCC=0
        LV=LVEC
        LE=LEIG
        DO ISYM=1,NSYM
          NB=NBASF(ISYM)
C TRANSFORM TO ORTHONORMAL BASIS. THIS REQUIRES THE CONJUGATE
C BASIS, BUT SINCE WE USE CANONICAL ON BASIS THIS AMOUNTS TO A
C SCALING WITH THE EIGENVECTORS OF THE OVERLAP MATRIX:
*          CALL MXMA(DMAT(ID),1,NB,WORK(LV),1,NB,WORK(LSCR),1,NB,
*     *              NB,NB,NB)
          CALL DGEMM_('N','N',NB,NB,NB,1.0D0,
     &                 DMAT(ID),NB,WORK(LV),NB,
     &           0.0D0,WORK(LSCR),NB)
*          CALL MXMA(WORK(LV),NB,1,WORK(LSCR),1,NB,DMAT(ID),1,NB,
*     *              NB,NB,NB)
          CALL DGEMM_('T','N',NB,NB,NB,1.0D0,
     &                 WORK(LV),NB,WORK(LSCR),NB,
     &           0.0D0,DMAT(ID),NB)
          ID1=ID
          ID2=ID
          DO I=1,NB
            EIG=WORK(LE-1+I)
            CALL DSCAL_(NB,EIG,DMAT(ID1),NB)
            CALL DSCAL_(NB,EIG,DMAT(ID2),1)
            ID1=ID1+1
            ID2=ID2+NB
          END DO
C SYMMETRIZE THIS BLOCK INTO SCRATCH AREA, TRIANGULAR STORAGE:
          ISCR=LSCR
          DO I=1,NB
            DO J=1,I
              IJ=I+NB*(J-1)
              JI=J+NB*(I-1)
              WORK(ISCR)=DMAT(ID-1+IJ)+DMAT(ID-1+JI)
              ISCR=ISCR+1
            END DO
          END DO
C DIAGONALIZE THE DENSITY MATRIX BLOCK:
          CALL DCOPY_(NVEC2,[0.0D0],0,WORK(LVEC2),1)
          CALL DCOPY_(NB,[1.0D0],0,WORK(LVEC2),NB+1)
          CALL JACOB(WORK(LSCR),WORK(LVEC2),NB,NB)
          CALL JACORD(WORK(LSCR),WORK(LVEC2),NB,NB)
C JACORD ORDERS BY INCREASING EIGENVALUE. REVERSE THIS ORDER.
          II=LSCR-1
          DO I=1,NB
            II=II+I
            OCC(IOCC+NB+1-I)=WORK(II)
          END DO
          IOCC=IOCC+NB
C REEXPRESS THE EIGENVECTORS IN AO BASIS FUNCTIONS. REVERSE ORDER.
*          CALL MXMA(WORK(LV),1,NB,WORK(LVEC2),1,NB,
*     *              WORK(LSCR),1,NB,NB,NB,NB)
          CALL DGEMM_('N','N',NB,NB,NB,1.0D0,
     &                 WORK(LV),NB,WORK(LVEC2),NB,
     &           0.0D0,WORK(LSCR),NB)
          I1=LSCR
          I2=INV+NB**2
          DO I=1,NB
            I2=I2-NB
            CALL DCOPY_(NB,WORK(I1),1,VNAT(I2),1)
            I1=I1+NB
          END DO
          ID=ID+NB**2
          INV=INV+NB**2
          LV=LV+NB**2
          LE=LE+NB
        END DO

C WRITE OUT THIS SET OF NATURAL SPIN ORBITALS. THE FILES WILL BE NAMED
C SSORB.1, SSORB.2, ...

       WRITE(KNUM,'(I8)') KEIG
       KNUM=ADJUSTL(KNUM)
       FNAME='SSORB.'//KNUM
       WRITE(6,'(A,I2)')' NATURAL SPIN ORBITALS FOR EIGENSTATE NR ',KEIG
       WRITE(6,'(A,A)') ' ORBITALS ARE WRITTEN ONTO FILE ID = ',FNAME
       WRITE(6,'(A)')   ' OCCUPATION NUMBERS:'
        ISTOCC=0
        DO I=1,NSYM
          NB=NBASF(I)
          IF( NB.NE.0 ) THEN
            WRITE(6,'(A,I2)')' SYMMETRY SPECIES:',I
            WRITE(6,'(1X,10F8.5)')(OCC(ISTOCC+J),J=1,NB)
          ENDIF
          ISTOCC=ISTOCC+NB
        END DO
        IFOCC=1
        LuxxVec=50
        LuxxVec=isfreeunit(LuxxVec)
        CALL WRVEC(FNAME,LUXXVEC,'CO',NSYM,NBASF,NBASF,
     &     VNAT, OCC, Dummy, iDummy,
     &     '* NATURAL SPIN ORBITALS FROM RASSI EIGENSTATE NR '//
     &     TRIM(KNUM))
        SUMOCC=DDOT_(SUM(NBASF),OCC,1,OCC,1)
        CALL ADD_INFO("NATSPIN",[SUMOCC],1,5)

C End of very long loop over eigenstates KEIG.
      END DO

      WRITE(6,*)('*',I=1,80)
      CALL GETMEM('VEC   ','FREE','REAL',LVEC,NVEC)
      CALL GETMEM('VEC2  ','FREE','REAL',LVEC2,NVEC2)
      CALL GETMEM('SCR   ','FREE','REAL',LSCR,NSCR)
      CALL GETMEM('EIG   ','FREE','REAL',LEIG,NEIG)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine Restore_mat(n,m,lu_A0,lu_A,iD_A,Scr,lScr,Add0s)
!***********************************************************************
!                                                                      *
!     Author:  F. Aquilante                                            *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n, m, lu_A0, lu_A, iD_A(n), lScr
real(kind=wp), intent(out) :: Scr(lScr)
logical(kind=iwp) :: Add0s
#include "warnings.h"
integer(kind=iwp) :: i, iAddr, iCol, ij, iOff, iScr, jCol, kAddr, kCol, lmax, mNeed, nMem_Col

lmax = lScr-n
if (lmax < n) then
  call WarningMessage(2,'Error in Restore_mat')
  write(u6,*) ' Restore_mat: too little scratch space!! '
  call Quit(_RC_CHO_LOG_)
end if

nMem_Col = m
mNeed = nTri_Elem(nMem_Col)
do while (mNeed > lmax)
  mNeed = mNeed-nMem_Col
  nMem_Col = nMem_Col-1
end do

kAddr = 0
ij = nTri_Elem(nMem_Col)
call dDaFile(lu_A0,2,Scr,ij,kAddr)

iOff = 0
do kCol=1,nMem_Col
  do i=1,kCol
    iCol = iD_A(i)
    iScr = ij+iCol
    jCol = iOff+i
    Scr(iScr) = Scr(jCol)
  end do
  do i=kCol+1,n
    iCol = iD_A(i)
    iScr = ij+iCol
    Scr(iScr) = Zero
  end do
  iAddr = n*(kCol-1)
  call dDaFile(lu_A,1,Scr(ij+1),n,iAddr)
  !call RecPrt('QVec',' ',Scr(ij+1),1,n)
  iOff = iOff+kCol
end do

do kCol=nMem_Col+1,m
  call dDaFile(lu_A0,2,Scr,kCol,kAddr)
  do i=1,kCol
    iCol = iD_A(i)
    iScr = n+iCol
    Scr(iScr) = Scr(i)
  end do
  do i=kCol+1,n
    iCol = iD_A(i)
    iScr = n+iCol
    Scr(iScr) = Zero
  end do
  iAddr = n*(kCol-1)
  call dDaFile(lu_A,1,Scr(n+1),n,iAddr)
  !call RecPrt('QVec',' ',Scr(n+1),1,n)
end do

if (Add0s) then
  do kCol=m+1,n   ! linearly dependent cols
    iAddr = n*(kCol-1)
    Scr(1:n) = Zero
    call dDaFile(lu_A,1,Scr,n,iAddr)
  end do
end if

return

end subroutine Restore_mat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GETINC_ABS_td(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,IKSM,JLSM,INTLST,ICTL)
! Obtain integrals
! ICOUL = 0 :      XINT(IK,JL) = (IJ!KL) for IXCHNG = 0
!                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
! ICOUL = 1 :      XINT(IJ,KL) = (IJ!KL)
!
! Version for integrals stored in INTLST

use Index_Functions, only: iTri
use MCLR_Data, only: IBTSOB, NACOB, NTSOB
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: XINT(*)
integer(kind=iwp), intent(in) :: ITP, ISM, JTP, JSM, KTP, KSM, LTP, LSM, IKSM, JLSM, ICTL
real(kind=wp), intent(in) :: Intlst(*)
integer(kind=iwp) :: iBas, iInt, IJ, IJKL, IL, ILJK, IMIN, iOff, iOrb, jBas, JK, JMIN, jOff, jOrb, kBas, KL, kOff, kOrb, lBas, &
                     lOff, lOrb, NTASH

iOrb = NTSOB(ITP,ISM)
jOrb = NTSOB(JTP,JSM)
kOrb = NTSOB(KTP,KSM)
lOrb = NTSOB(LTP,LSM)
iOff = IBTSOB(ITP,ISM)
jOff = IBTSOB(JTP,JSM)
kOff = IBTSOB(KTP,KSM)
lOff = IBTSOB(LTP,LSM)
ntash = nacob

if (ICTL == 1) then

  ! Collect Coulomb terms

  iint = 1
  do lBas=lOff,lOff+lOrb-1
    jMin = jOff
    if (JLSM /= 0) jMin = lBas
    do jBas=jMin,jOff+jOrb-1
      do kBas=kOff,kOff+kOrb-1
        iMin = iOff
        if (IKSM /= 0) iMin = kBas
        do iBas=iMin,iOff+iOrb-1
          ij = jbas+ntash*(ibas-1)
          kl = lbas+ntash*(kbas-1)
          ijkl = iTri(ij,kl)
          Xint(iInt) = Intlst(ijkl)
          iInt = iInt+1
        end do
      end do
    end do
  end do

else if (ICTL == 4) then

  ! Collect Coulomb-Exchange terms

  iint = 1
  do lBas=lOff,lOff+lOrb-1
    jMin = jOff
    if (JLSM /= 0) jMin = lBas
    do jBas=jMin,jOff+jOrb-1
      do kBas=kOff,kOff+kOrb-1
        iMin = iOff
        if (IKSM /= 0) iMin = kBas
        do iBas=iMin,iOff+iOrb-1
          il = ibas+ntash*(lbas-1)
          jk = kbas+ntash*(jbas-1)
          iljk = iTri(il,jk)
          ij = ibas+ntash*(jbas-1)
          kl = kbas+ntash*(lbas-1)
          ijkl = iTri(ij,kl)
          XInt(iInt) = Intlst(ijkl)-Intlst(iljk)
          iInt = iInt+1
        end do
      end do
    end do
  end do

else
  call Abend()
end if

end subroutine GETINC_ABS_td

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE WRTRS2_MCLR(VECTOR,ISMOST,ICBLTP,IOCOC,NOCTPA,NOCTPB,
     &                  NSASO,NSBSO,NSMST)
*
* Write RAS vector . Storage form is defined by ICBLTP
*
      IMPLICIT REAL*8 (A-H,O-Z)
*
      DIMENSION VECTOR(*)
      DIMENSION IOCOC(NOCTPA,NOCTPB)
      DIMENSION NSASO(NOCTPA,*),NSBSO(NOCTPB,*)
      DIMENSION ICBLTP(*),ISMOST(*)
*
*
      IBASE = 1
      DO 1000 IASM = 1, NSMST
        IBSM = ISMOST(IASM)
        IF(IBSM.EQ.0.OR.ICBLTP(IASM).EQ.0) GOTO 1000
*
        DO 900 IATP = 1, NOCTPA
          IF(ICBLTP(IASM).EQ.2) THEN
            IBTPMX = IATP
          ELSE
            IBTPMX = NOCTPB
          END IF
          NAST = NSASO(IATP,IASM)
*
          DO 800 IBTP = 1 , IBTPMX
            IF(IOCOC(IATP,IBTP) .EQ. 0 ) GOTO 800
            NBST = NSBSO(IBTP,IBSM)
            IF(ICBLTP(IASM).EQ.2.AND.IATP.EQ.IBTP ) THEN
* Diagonal block
              NELMNT = NAST*(NAST+1)/2
              IF(NELMNT.NE.0) THEN
                WRITE(6,'(A,3I3)')
     &          '  Iasm iatp ibtp : ', IASM,IATP,IBTP
                WRITE(6,'(A)')
     &          '  ============================'
!                do i=1,NAST*(NAST+1)/2  !yma
!                  if(dabs(VECTOR(IBASE+i-1)).lt.1e-16)then
!                    VECTOR(IBASE+i-1)=0.0d0
!                  end if
!                  write(*,*)"vector",i,VECTOR(IBASE+i-1)
!                end do
                CALL PRSM2(VECTOR(IBASE),NAST)
                IBASE = IBASE + NELMNT
              END IF
            ELSE
              NELMNT = NAST*NBST
              IF(NELMNT.NE.0) THEN
                WRITE(6,'(A,3I3)')
     &          '  Iasm iatp ibtp : ', IASM,IATP,IBTP
                WRITE(6,'(A)')
     &          '  ============================'
                CALL WRTMAT(VECTOR(IBASE),NAST,NBST,NAST,NBST)
                IBASE = IBASE + NELMNT
              END IF
            END IF
  800     CONTINUE
  900   CONTINUE
 1000 CONTINUE
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2007, Thomas Bondo Pedersen                       *
************************************************************************
      SubRoutine ChoMP2_Col(Col,nDim,iCol,nCol,Buf,l_Buf)
C
C     Thomas Bondo Pedersen, Dec. 2007.
C
C     Purpose: compute specified (ai|bj) or MP2 amplitude columns.
C
      Implicit None
      Integer nDim, nCol, l_Buf
      Real*8  Col(nDim,nCol), Buf(l_Buf)
      Integer iCol(nCol)
#include "chomp2_dec.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"

      Character(LEN=3), Parameter:: ThisNm = 'Col'
      Character(LEN=10), Parameter:: SecNam = 'ChoMP2_Col'

      Integer iSym

C     Check input.
C     ------------

      If (nCol.lt.1 .or. nDim.lt.1) Return
      iSym = NowSym
      If (nDim .ne. nT1am(iSym)) Then
         Write(6,*) SecNam,': inconsistent dimension. Expected: ',
     &              nT1am(iSym),'   Received: ',nDim
         Write(6,*) SecNam,': symmetry from chomp2_dec.fh: ',iSym
         Call ChoMP2_Quit(SecNam,'inconsistent dimension',' ')
      End If


C     Calculate (ai|bj) integrals.
C     ----------------------------

      Call ChoMP2_IntCol(Col,nDim,iCol,nCol,Buf,l_Buf)

C     Postprocess integrals.
C     ----------------------

      If (iOption_MP2CD .eq. 2) Then ! generate amplitudes
         Call ChoMP2_AmpFromInt(Col,nDim,iCol,nCol,
     &                          Work(ip_EOc),Work(ip_EVir))
      End If

      End
      SubRoutine ChoMP2_AmpFromInt(Col,nDim,iCol,nCol,EOcc,EVir)
C
C     Thomas Bondo Pedersen, Dec. 2007.
C
C     Purpose: scale integrals with orbital energies to get
C              (minus) MP2 amplitudes: (ai|bj)/[e(a)-e(i)+e(b)-e(j)].
C
      Implicit None
      Integer nDim, nCol
      Real*8  Col(nDim,nCol), EOcc(*), EVir(*)
      Integer iCol(nCol)
#include "chomp2_dec.fh"
#include "chomp2.fh"
#include "cholesky.fh"

      Integer iSym, bj_, bj, b, iSymb, j, iSymj, iSymi, iSyma, i, ai0
      Integer a, ai
      Real*8  Ebj, DE

      Integer MulD2h, k, l
      MulD2h(k,l)=iEOr(k-1,l-1)+1

      iSym = NowSym
      Do bj_ = 1,nCol
         bj = iCol(bj_)
         Call ChoMP2_Col_Invai(bj,iSym,b,iSymb,j,iSymj)
         Ebj = EVir(iVir(iSymb)+b) - EOcc(iOcc(iSymj)+j)
         Do iSymi = 1,nSym
            iSyma = MulD2h(iSymi,iSym)
            Do i = 1,nOcc(iSymi)
               ai0 = iT1am(iSyma,iSymi) + nVir(iSyma)*(i-1)
               Do a = 1,nVir(iSyma)
                  ai = ai0 + a
                  DE = EVir(iVir(iSyma)+a) - EOcc(iOcc(iSymi)+i) + Ebj
                  Col(ai,bj_) = Col(ai,bj_)/DE
               End Do
            End Do
         End Do
      End Do

      End
      SubRoutine ChoMP2_IntCol(Col,nDim,iCol,nCol,Buf,l_Buf)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C     Renamed (from ChoMP2_Col), Thomas Bondo Pedersen, Dec. 2007.
C
C     Purpose: compute specified (ai|bj) columns.
C
      use ChoMP2, only: OldVec
#include "implicit.fh"
      Real*8  Col(nDim,nCol), Buf(l_Buf)
      Integer iCol(nCol)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"

      Character(LEN=6), Parameter:: ThisNm = 'IntCol'
      Character(LEN=13), Parameter:: SecNam = 'ChoMP2_IntCol'

      Logical DoClose

      Real*8, Allocatable:: Wrk(:)

      iSym = NowSym
      If (NumCho(iSym) .lt. 1) Then
         Call FZero(Col,nDim*nCol)
         Return
      End If

      irc = 0

      If (InCore(iSym)) Then  ! old vectors available in core

         Fac = 0.0D0
         Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                        OldVec,NumCho(iSym),
     &                        Buf,l_Buf,Fac,irc)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_Col_Comp returned ',irc
            Call ChoMP2_Quit(SecNam,'ChoMP2_Col_Comp error','[1]')
         End If

      Else ! old vectors must be read on disk

         DoClose = .false.
         If (lUnit_F(iSym,1) .lt. 1) Then
            Call ChoMP2_OpenF(1,1,iSym)
            DoClose = .true.
         End If

         Call mma_maxDBLE(lWrk)

         If (l_Buf .gt. lWrk) Then ! use Buf as work space

            nVec = min(l_Buf/(nDim+1),NumCho(iSym))
            If (nVec .lt. 1) Then
               Write(6,*) SecNam,': insufficient memory for batch!'
               Call ChoMP2_Quit(SecNam,'insufficient memory','[1]')
               nBat = 0
            Else
               nBat = (NumCho(iSym) - 1)/nVec + 1
            End If

            Do iBat = 1,nBat

               If (iBat .eq. nBat) Then
                  NumV = NumCho(iSym) - nVec*(nBat - 1)
               Else
                  NumV = nVec
               End If
               iVec1 = nVec*(iBat - 1) + 1

               iOpt = 2
               lTot = nDim*NumV
               iAdr = nDim*(iVec1 - 1) + 1
               Call ddaFile(lUnit_F(iSym,1),iOpt,Buf(1),lTot,iAdr)

               If (iBat .eq. 1) Then
                  Fac = 0.0D0
               Else
                  Fac = 1.0D0
               End If

               lScr = l_Buf - lTot
               If (lWrk .gt. lScr) Then
                  lWsav = lWrk
                  Call mma_allocate(Wrk,lWrk,Label='Wrk')
                  Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                                 Buf(1),NumV,
     &                                 Wrk,lWrk,Fac,irc)
                  Call mma_deallocate(Wrk)
                  lWrk = lWsav
               Else
                  Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                                 Buf(1),NumV,
     &                                 Buf(1+lTot),lScr,Fac,irc)
               End If
               If (irc .ne. 0) Then
                  Write(6,*) SecNam,': ChoMP2_Col_Comp returned ',irc
                  Call ChoMP2_Quit(SecNam,'ChoMP2_Col_Comp error','[2]')
               End If

            End Do

         Else ! use Work as work space

            Call mma_allocate(Wrk,lWrk,Label='Wrk')

            nVec = min(lWrk/nDim,NumCho(iSym))
            If (nVec .lt. 1) Then
               Write(6,*) SecNam,': insufficient memory for batch!'
               Call ChoMP2_Quit(SecNam,'insufficient memory','[2]')
               nBat = 0
            Else
               nBat = (NumCho(iSym) - 1)/nVec + 1
            End If

            Do iBat = 1,nBat

               If (iBat .eq. nBat) Then
                  NumV = NumCho(iSym) - nVec*(nBat - 1)
               Else
                  NumV = nVec
               End If
               iVec1 = nVec*(iBat - 1) + 1

               iOpt = 2
               lTot = nDim*NumV
               iAdr = nDim*(iVec1 - 1) + 1
               Call ddaFile(lUnit_F(iSym,1),iOpt,Wrk,lTot,iAdr)

               If (iBat .eq. 1) Then
                  Fac = 0.0D0
               Else
                  Fac = 1.0D0
               End If

               lScr = lWrk - lTot
               If (l_Buf .gt. lScr) Then
                  Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                                 Wrk,NumV,
     &                                 Buf(1),l_Buf,Fac,irc)
               Else
                  Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                                 Wrk,NumV,
     &                                 Wrk(1+lTot),lScr,Fac,irc)
               End If
               If (irc .ne. 0) Then
                  Write(6,*) SecNam,': ChoMP2_Col_Comp returned ',irc
                  Call ChoMP2_Quit(SecNam,'ChoMP2_Col_Comp error','[3]')
               End If

            End Do

            Call mma_deallocate(Wrk)

         End If

         If (DoClose) Then
            Call ChoMP2_OpenF(2,1,iSym)
            DoClose = .false.
         End If

      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Markus P. Fuelscher                              *
!***********************************************************************

subroutine PrtTim()
!***********************************************************************
!                                                                      *
!     print out timings for the various sections of the program        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 2000                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use timers, only: C_Dress, C_get_Cm, TimeAoMo, TimeCIOpt, TimeDavid, TimeDens, TimeFock, TimeHCSCE, TimeHDiag, TimeHSel, &
                  TimeInput, TimeOrb, TimeOutput, TimePage, TimeRelax, TimeSigma, TimeTotal, TimeTrans, TimeWfn, W_Dress, W_get_Cm
use lucia_data, only: TDENSI, TSIGMA
use splitcas_data, only: DoSplitCAS
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), parameter :: MAX_TIMERS = 35
real(kind=wp) :: F(MAX_TIMERS), T(MAX_TIMERS)

T(:) = Zero
F(:) = Zero
F(MAX_TIMERS) = One

T(MAX_TIMERS) = TimeTotal
T(1) = TimeInput
!T(2) = Zero
!T(3) = Zero
T(4) = T(1)-T(2)-T(3)
T(5) = TimeWfn
T(6) = TimeTrans
T(7) = TimeAoMo
T(8) = TimeFock
T(9) = TimeCIOpt
T(10) = TimeHDiag
T(11) = TimeHSel
T(12) = TimeSigma
T(13) = TimeDens
T(14) = TimeOrb
T(15) = TimeOutput
T(16) = TimeRelax
!T(17) = Zero
T(18) = T(15)-T(16)-T(17)
T(19) = TimeDavid
T(20) = TimePage
T(21) = TimeHCSCE
T(22) = C_Dress
T(23) = W_Dress
T(24) = C_get_Cm
T(25) = W_get_Cm
T(26:31) = TSIGMA(:)
T(32:34) = TDENSI(:)

if (T(MAX_TIMERS) > 1.0e-6_wp) F(:) = T(:)/T(MAX_TIMERS)

write(u6,*)
write(u6,100) 'Timings'
write(u6,100) '-------'
write(u6,*)
write(u6,100) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
write(u6,101) ' ',' ','        time','    fraction'
write(u6,100) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
write(u6,102) '1) Input section',':',T(1),F(1)
write(u6,102) '   - Input processing',':',T(4),F(4)
!write(u6,102) '   - Create GUGA tables',':',T(2),F(2)
!write(u6,102) '   - Create determinant tables',':',T(3),F(3)
write(u6,102) '2) Wave function optimization',':',T(5),F(5)
write(u6,102) '   - transformation section',':',T(6),F(6)
write(u6,102) '     . AO=>MO integral transformation',':',T(7),F(7)
write(u6,102) '     . Fock-matrix generation',':',T(8),F(8)
write(u6,102) '   - CI optimization',':',T(9),F(9)
write(u6,102) '     . construct Hdiag',':',T(10),F(10)

if (.not. DoSplitCAS) then ! (GLMJ)
  write(u6,102) '     . construct Hsel',':',T(11),F(11)
  write(u6,102) '     . Davidson diagonalization',':',T(19),F(19)

  write(u6,102) '       .. sigma vector generation',':',T(12),F(12)
  write(u6,102) '          |-> aa/bb 1-electron   ',':',T(26),F(26)
  write(u6,102) '          |-> aa/bb 2-electron   ',':',T(27),F(27)
  write(u6,102) '          \-> alpha-beta         ',':',T(28),F(28)
  write(u6,102) '              |-> C prefetch     ',':',T(29),F(29)
  write(u6,102) '              |-> matrix multiply',':',T(30),F(30)
  write(u6,102) '              \-> S scatter      ',':',T(31),F(31)

  write(u6,102) '       .. HCSCE',':',T(21),F(21)
  write(u6,102) '       .. page_in/page_out',':',T(20),F(20)
else
  write(u6,102) '     . U_AA diagonalization',':',T(22),F(22)
  write(u6,102) '     . compute Cm coeff',':',T(24),F(24)
end if

write(u6,102) '     . density matrix generation',':',T(13),F(13)
write(u6,102) '          |-> aa/bb 1-electron  ',':',T(32),F(32)
write(u6,102) '          |-> aa/bb 2-electron  ',':',T(33),F(33)
write(u6,102) '          \-> alpha-beta        ',':',T(34),F(34)

write(u6,102) '   - orbital optimization',':',T(14),F(14)
write(u6,102) '3) Output section',':',T(15),F(15)
write(u6,102) '   - Create/update the file RELAX',':',T(16),F(16)
!write(u6,102) '   - Create/update the file RUNFILE',':',T(17),F(17)
write(u6,102) '   - Create/update the file JOBIPH',':',T(18),F(18)
write(u6,*)
write(u6,100) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
write(u6,102) '   Total',':',T(MAX_TIMERS),F(MAX_TIMERS)
write(u6,100) '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'
write(u6,*)

100 format(2X,A)
101 format(2X,A,T44,A,A,A)
102 format(2X,A,T44,A,2F12.2)

end subroutine PrtTim

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Roland Lindh                                     *
************************************************************************
      SubRoutine Print_Symmetry()
************************************************************************
*                                                                      *
*     Object: to write the output of seward                            *
*                                                                      *
*     Author: Roland Lindh, Dept Chem. Phys., Lund University, Sweden  *
*             September '06                                            *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChTbl, iOper, lIrrep, lBsFnc,
     &                         SymLab
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "gateway.fh"
      Character SymOpr(0:7)*29, Format*80,  ChSymO(0:7)*5
      Data SymOpr/' Unit operation              ',
     &            ' Reflection in the yz-plane  ',
     &            ' Reflection in the xz-plane  ',
     &            ' Rotation around the z-axis  ',
     &            ' Reflection in the xy-plane  ',
     &            ' Rotation around the y-axis  ',
     &            ' Rotation around the x-axis  ',
     &            ' Inversion through the origin'/
      Data ChSymO/'  E  ','s(yz)','s(xz)','C2(z)',
     &            's(xy)','C2(y)','C2(x)','  i  '/
*                                                                      *
************************************************************************
*                                                                      *
      iRout=2
      iPrint=nPrint(iRout)
      If (iPrint.eq.0) Return
      LuWr=6
*                                                                      *
************************************************************************
*                                                                      *
      Write (LuWr,*)
      Call CollapseOutput(1,'   Symmetry information:')
      Write (LuWr,'(3X,A)') '   ---------------------'
      Write (LuWr,*)
*                                                                      *
************************************************************************
*                                                                      *
      If (nIrrep.ne.1) Then
         Write (LuWr,'(19X,A)') ' --- Group Generators ---'
         nOper=0
         If (nIrrep.eq.8) nOper=3
         If (nIrrep.eq.4) nOper=2
         If (nIrrep.eq.2) nOper=1
         Do i = 1, nOper
            j=i
            if (i.eq.3) j=4
            Write (LuWr,'(19X,A)') SymOpr(iOper(j))
         End Do
         Write (LuWr,*)
      ENd If
*                                                                      *
************************************************************************
*                                                                      *
      Write (LuWr,'(19X,A,A)') ' Character Table for ', SymLab
      Write (LuWr,*)
      Write (Format,'(A,I1,A)')   '(20X,A3,1X,',nIrrep,
     &                            '(1X,I5),2X,A)'
      Write (LuWr,'(27X,8(A5,1X))') (ChSymO(iOper(iIrrep)),iIrrep=
     &      0,nIrrep-1)
      Do iIrrep = 0, nIrrep-1
         LenlBs=Len(lBsFnc(iIrrep))
         Write (LuWr,Format)
     &         lIrrep(iIrrep),(iChTbl(iIrrep,jIrrep),
     &                         jIrrep=0,nIrrep-1),
     &         lBsFnc(iIrrep)(1:iCLast(lBsFnc(iIrrep),LenlBs))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call CollapseOutput(0,'  Symmetry information:')
      Write (LuWr,*)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************
!********************************************************************
!
! Author :   F. Aquilante
!
!  Get_Int :  driver for the integral generator from Cholesky vectors
!********************************************************************

subroutine Get_Int(rc,iOpt,iSymp,iSymq,iSymr,iSyms,Xint,lBuf,nMat)

use Index_Functions, only: nTri_Elem
use GetInt_mod, only: LuCVec, nBas, pq1
use TwoDat, only: rcTwo
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: rc, nMat
integer(kind=iwp), intent(in) :: iOpt, iSymp, iSymq, iSymr, iSyms, lBuf
real(kind=wp), intent(_OUT_) :: Xint(*)
integer(kind=iwp) :: i, Npq, Nrs
character(len=6) :: Fname
character(len=*), parameter :: BaseNm = 'CHFV'

! Check input parameters

rc = rcTwo%good
if ((iOpt /= 1) .and. (iOpt /= 2)) then
  rc = rcTwo%RD06
  write(u6,*) 'Get_Int: Invalid option'
  write(u6,*) 'iOpt= ',iOpt
  call Abend()
end if
if ((iSymp < iSymq) .or. (iSymr < iSyms)) then
  rc = rcTwo%RD02
  write(u6,*) 'Get_Int: invalid order of symmetry labels'
  call Abend()
end if
if (Mul(iSymp,iSymq) /= Mul(iSymr,iSyms)) then
  rc = rcTwo%RD01
  write(u6,*) 'Get_Int: wrong symmetry labels, direct product is not total symmetric'
  call Abend()
end if
if (lBuf < 1) then
  rc = rcTwo%RD04
  write(u6,*) 'Get_Int: invalid buffer size'
  write(u6,*) 'lBuf=',lBuf
  call Abend()
end if

! Open files.
LuCVec(1) = 7
write(Fname,'(A4,I1,I1)') BaseNm,iSymp,iSymq
call DANAME_MF_WA(LuCVec(1),Fname)
if (iSymp /= iSymr) then
  LuCVec(2) = 7
  write(Fname,'(A4,I1,I1)') BaseNm,iSymr,iSyms
  call DANAME_MF_WA(LuCVec(2),Fname)
else
  LuCVec(2) = -1
end if

if (iSymp == iSymq) then
  Npq = nTri_Elem(nBas(iSymp))
else
  Npq = nBas(iSymp)*nBas(iSymq)
end if
if (iSymr == iSyms) then
  Nrs = nTri_Elem(nBas(iSymr))
else
  Nrs = nBas(iSymr)*nBas(iSyms)
end if

! For debug
!lBufs = lBuf
!lBuf = min(Nrs*min(Npq,2)+1,lBufs)

if (iOpt == 1) then
  pq1 = 1
  nMat = min(Npq,(lBuf-1)/Nrs)
else if ((pq1 >= 1) .and. (pq1 <= Npq)) then
  nMat = min((Npq-pq1+1),(lBuf-1)/Nrs)
else
  rc = rcTwo%RD10
  write(u6,*) 'pq1 out of bounds: ',pq1
  call Abend()
  nMat = 99999999
end if

if (nMat < 1) return ! no more integrals to compute

call GEN_INT(rc,iSymp,iSymq,iSymr,iSyms,pq1,nMat,Xint)

pq1 = pq1+nMat

! Close files.
do i=1,2
  if (LuCVec(i) /= -1) then
    call DACLOS(LuCVec(i))
    LuCVec(i) = -1
  end if
end do

! LBuf = lBufs

return

end subroutine Get_Int

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_T2n (T2,dimbe,addbe,dimga,addga,key)
c
c        chek T2n bez menovatelov, nediagonalne
c
        implicit none
        integer dimbe,addbe,dimga,addga,key
#include "chcc1.fh"

         real*8 T2(1:dimbe,1:dimga,1:no,1:no)
c
        integer bstart,bup
        integer u,v,be,ga,bad,ntot
        integer i,j,a,b
        real*8 s,s1
c
        bad=0
        ntot=0
c
        do v=1,no
        do u=1,no
        do ga=addga+1,addga+dimga
        if (key.eq.1) then
             bstart=ga
          bup=addbe+dimbe
        else
          bstart=addbe+1
          bup=addbe+dimbe
        end if
        do be=bstart,bup
c
        ntot=ntot+1
        s=0.0d0
c
c1
          s1=Q21(be,u,ga,v)
          s=s+s1
c
c2
          s1=0.0d0
          do j=1,no
          do i=1,no
          s1=s1+Ac(i,j,u,v)*(T2c(be,ga,i,j)+T1c(be,i)*T1c(ga,j))
          end do
          end do
          s=s+s1
c
c3
          s1=0.0d0
          do b=1,nv
          do a=1,nv
           s1=s1+Bc(a,b,be,ga)*(T2c(a,b,u,v)+T1c(a,u)*T1c(b,v))
          end do
          end do
          s=s+s1
c
c4
          s1=0.0d0
          do a=1,nv
          s1=s1+Gvvc(be,a)*T2c(a,ga,u,v)
          s1=s1+Gvvc(ga,a)*T2c(a,be,v,u)
          end do
          s=s+s1
c
c5
          s1=0.0d0
          do i=1,no
          s1=s1+Gooc(i,u)*T2c(be,ga,i,v)
          s1=s1+Gooc(i,v)*T2c(ga,be,i,u)
          end do
          s=s-s1
c
c6
          s1=0.0d0
          do a=1,nv
          s1=s1+Q3(ga,a,be,u)*T1c(a,v)
          s1=s1+Q3(be,a,ga,v)*T1c(a,u)
          end do
          do i=1,no
          do a=1,nv
          s1=s1-(Q22(ga,a,i,u)*T1c(be,i))*T1c(a,v)
          s1=s1-(Q22(be,a,i,v)*T1c(ga,i))*T1c(a,u)
          end do
          end do
          s=s+s1
c
c7
          s1=0.0d0
          do i=1,no
          s1=s1+Q1(be,u,i,v)*T1c(ga,i)
          s1=s1+Q1(ga,v,i,u)*T1c(be,i)
          end do
          do i=1,no
          do a=1,nv
          s1=s1+(Q21(be,u,a,i)*T1c(a,v))*T1c(ga,i)
          s1=s1+(Q21(ga,v,a,i)*T1c(a,u))*T1c(be,i)
          end do
          end do
          s=s-s1
c
c8
          s1=0.0d0
          do i=1,no
          do a=1,nv
            s1=s1+(2.0d0*Jc(be,i,u,a)-Kc(i,be,u,a))*
     c          (2.0d0*T2c(a,ga,i,v)-T2c(ga,a,i,v))
            s1=s1+(2.0d0*Jc(ga,i,v,a)-Kc(i,ga,v,a))*
     c          (2.0d0*T2c(a,be,i,u)-T2c(be,a,i,u))

          end do
          end do
          s=s+0.5d0*s1
c
c9
          s1=0.0d0
          do i=1,no
          do a=1,nv
          s1=s1+Kc(i,be,u,a)*T2c(ga,a,i,v)
          s1=s1+Kc(i,ga,v,a)*T2c(be,a,i,u)
          end do
          end do
          s=s-0.5d0*s1
c
c10
          s1=0.0d0
          do i=1,no
          do a=1,nv
          s1=s1+Kc(i,ga,u,a)*T2c(be,a,i,v)
          s1=s1+Kc(i,be,v,a)*T2c(ga,a,i,u)
          end do
          end do
          s=s-s1
c
          s=s/(Oeo(u)+Oeo(v)-Oev(be)-Oev(ga))
c
             if  (abs(T2(be-addbe,ga-addga,u,v)-s).gt.1.0d-10) then
c          write (6,*) 'Bad', abs(T2(be-addbe,ga-addga,u,v)
          bad=bad+1
          end if
c
        end do
        end do
        end do
        end do
c
        if (key.eq.1) then
          write (6,*) ' Final test T2 dia',bad,ntot
        else
          write (6,*) ' Final test T2 off',bad,ntot
        end if
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dgetf2( m, n, a, lda, ipiv, info )
  use link_blas
  implicit none
  integer :: info, lda, m, n
  integer :: ipiv( * )
  real*8 :: a( lda, * )
  call lb_dgetf2( m, n, a, lda, ipiv, info )
end subroutine dgetf2

subroutine dpotf2( uplo, n, a, lda, info )
  use link_blas
  implicit none
  character :: uplo
  integer :: info, lda, n
  real*8 :: a( lda, * )
  call lb_dpotf2( uplo, n, a, lda, info )
end subroutine dpotf2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986,1995, Bernd Artur Hess                            *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

subroutine SCFCLI(idbg,eps,S,H,V,PVP,N,ISIZE,VELIT,TMP1,TMP2,TMP3,TMPA,TMPB,TMPC,EW,E,AA,RR,TT,TMP4,TMPD,TMPE,TMPF,TMP5,I_DIM)
! $Id: relsew.r,v 1.4 1995/05/08 14:08:53 hess Exp $
! calculate relativistic operators
!   Bernd Artur Hess, hess@uni-bonn.de
!   Modified: 2005 Jesper Wisborg Krogh, Jesper.Krogh@teokem.lu.se

use DKH_Info, only: IRELAE
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: idbg, N, ISIZE, I_DIM
real(kind=wp), intent(out) :: eps, TMP1(I_DIM*(I_DIM+1)/2), TMP2(ISIZE), TMP3(ISIZE), TMPA(N,N), TMPB(N,N), TMPC(N,N), EW(N), &
                              E(N), AA(N), RR(N), TT(N), TMP4(I_DIM*(I_DIM+1)/2), TMPD(I_DIM,I_DIM), TMPE(N,N), TMPF(N,N), &
                              TMP5(ISIZE)
real(kind=wp), intent(in) :: S(ISIZE), V(ISIZE), VELIT
real(kind=wp), intent(inout) :: H(ISIZE), PVP(ISIZE)
integer(kind=iwp) :: I, IJ, ILL, J, K, M
real(kind=wp) :: CON, CON2, PREA, RATIO, SR, TV1, TV2, TV3, TV4

!write(u6,*) ' in SCFCLI', N, iSize
PREA = One/(VELIT*VELIT)
CON2 = PREA+PREA
CON = One/PREA

#ifdef _DEBUGPRINT_
! CALCULATE DETERMINANT

call Square(S,TMPB,n,1,n)
!do i=1,n
!  write(u6,'(5f10.5)') (TMPB(i,j),j=1,n)
!end do
icontr = -1
dtol = 1.0e-14_wp
call dcopiv(TMPB,TMPB,n,1,n,dtol,det,iex,icontr,TMP2)
if (idbg > 0) write(idbg,2016) icontr,det,iex
if (icontr /= 0) then
  write(u6,2016) icontr,det,iex
  write(u6,2012) dtol
  write(u6,'(a)') ' relsew| singular overlap matrix'
  call Abend()
end if
#endif

! SCHMIDT-ORTHOGONALIZE

call Sogr(idbg,N,S,TMPE,TMP2,TMPC,EW)

! ** TMPE CONTAINS TRANSFORMATION TO ORTHOGONAL AO-BASIS
!-----------------------------------------------------------------------
! NON-RELATIVISTIC KINETIC ENERGY
!-----------------------------------------------------------------------
call Diagr(H,N,TMPF,EW,TMPE,TMPB,TMP2)
if (idbg > 0) write(idbg,556)
do I=1,N
  if (ew(i) < Zero) then
    write(u6,*) ' scfcli| ew(',i,') = ',ew(i)
    write(u6,'(a)') 'kinetic energy eigenvalue less than zero'
    call Abend()
  end if

  ! IF T SUFFICIENTLY SMALL, USE SERIES EXPANSION TO AVOID CANCELLATIO

  RATIO = EW(I)/VELIT

  ! CALCULATE RELATIVISTIC ENERGY AND MOMENTUM

  SR = sqrt(Two*EW(I))
  TT(I) = EW(I)
  if (RATIO > 0.02_wp) then
    TV1 = EW(I)
    EW(I) = CON*(sqrt(One+CON2*EW(I))-One)
    if (idbg > 0) write(idbg,100) I,TV1,RATIO,EW(I),SR
  else
    TV1 = EW(I)
    TV2 = -TV1*EW(I)*PREA*Half
    TV3 = -TV2*EW(I)*PREA
    TV4 = -TV3*EW(I)*PREA*1.25_wp
    EW(I) = TV1+TV2+TV3+TV4
    if (idbg > 0) write(idbg,100) I,TV1,RATIO,EW(I),SR,TV2,TV3,TV4
  end if
  E(I) = EW(I)+CON
end do
!-----------------------------------------------------------------------
! CALCULATE REVERSE TRANSFORMATION
!-----------------------------------------------------------------------
call DGEMM_('N','N',n,n,n,One,TMPE,n,TMPF,n,Zero,TMPB,n)
call Square(S,TMPC,N,1,N)
call DGEMM_('N','N',n,n,n,One,TMPC,n,TMPB,n,Zero,TMPA,n)
! ** TMPC  CONTAINS OVERLAP MATRIX IN FULL

if ((IRELAE /= 21) .and. (IRELAE /= 22) .and. (IRELAE /= 23)) then

  H(:) = Zero
  do K=1,N
    IJ = 0
    do I=1,N
      do J=1,I
        IJ = IJ+1
        H(IJ) = H(IJ)+TMPA(I,K)*TMPA(J,K)*EW(K)
      end do
    end do
  end do

else
  H(:) = Zero
end if

! CALCULATE KINEMATICAL FACTORS

if (IRELAE /= 11) then

  do I=1,N
    AA(I) = sqrt((CON+E(I))/(Two*E(I)))
    RR(I) = sqrt(CON)/(CON+E(I))
  end do

else if (IRELAE == 11) then

  do I=1,N
    AA(I) = (sqrt(One+CON*TT(I)*Two/((CON+E(I))*(CON+E(I)))))/(CON+E(I)) ! O OPERATOR
    RR(I) = sqrt(CON)/(CON+E(I)) ! Q OPERATOR
  end do

end if

! POTENTIAL

! BEYOND THIS POINT, TMPC IS USED AS SCRATCH ARRAY

! TRANSFORM V TO T-BASIS

call TrSmr2(V,TMPE,TMP3,N,TMPB,TMPF,TMPC)
!ulf
if (idbg > 0) call PRMAT(IDBG,V,N,0,'v oper  ')

! MULTIPLY

if ((IRELAE == 0) .or. (IRELAE == 1) .or. (IRELAE == 2) .or. (IRELAE == 3)) then

  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      TMP2(IJ) = TMP3(IJ)
      TMP3(IJ) = TMP3(IJ)*AA(I)*AA(J)
    end do
  end do
  if (IRELAE == 3) then
    call Square(TMP3,TMPD,N,1,N)
  end if

else if (IRELAE == 11) then

  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      TMP2(IJ) = TMP3(IJ)
      TMP3(IJ) = VELIT*TMP3(IJ)*(sqrt(RR(I)*RR(J))*AA(I)/AA(J)+sqrt(RR(J)*RR(I))*AA(J)/AA(I))
    end do
  end do

else if (IRELAE == 22) then  ! ZORA(FP)

  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      TMP3(IJ) = TMP3(IJ)*AA(I)*AA(J)
    end do
  end do

end if

call TrSmtr(TMP3,TMPA,H,One,N,TMPB,TMPC)
!ulf

! PVP INTEGRALS AND TRANSFORM THEM TO T-BASIS

if (idbg > 0) call PRMAT(IDBG,pvp,N,0,'raw pvp integrals  ')
TMP5(:) = PVP(:)
call TrSmr2(TMP5,TMPE,PVP,N,TMPB,TMPF,TMPC)

! MULTIPLY

if ((IRELAE == 0) .or. (IRELAE == 1) .or. (IRELAE == 2) .or. (IRELAE == 3)) then

  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      TMP3(IJ) = PVP(IJ)
      PVP(IJ) = PVP(IJ)*AA(I)*RR(I)*AA(J)*RR(J)
      if (IRELAE == 3) then
        TMPD(I,J) = TMPD(I,J)+PVP(IJ)
        TMPD(J,I) = TMPD(I,J)
      end if
    end do
  end do

else if (IRELAE == 11) then

  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      TMP3(IJ) = PVP(IJ)
      PVP(IJ) = PVP(IJ)*(RR(I)*RR(J)*AA(I)/AA(J)+RR(J)*RR(I)*AA(J)/AA(I))*Half
    end do
  end do

else if ((IRELAE == 21) .or. (IRELAE == 22) .or. (IRELAE == 23)) then

  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      PVP(IJ) = -PVP(IJ)*Half*PREA
      if (I == J) PVP(IJ) = PVP(IJ)+TT(I)*Two
    end do
  end do
  call Square(PVP,TMPD,N,1,N)

  ! inverse operator

  EPS = 1.0e-13_wp
  call MINVD(TMPD,N,N,EPS,ILL)
  IJ = 0
  do I=1,N
    do J=1,I
      IJ = IJ+1
      PVP(IJ) = TMPD(I,J)
      PVP(IJ) = PVP(IJ)*TT(I)*TT(J)*Two
      if (IRELAE == 22) PVP(IJ) = PVP(IJ)*AA(I)*AA(J)
    end do
  end do

end if

call TrSmtr(PVP,TMPA,H,One,N,TMPB,TMPC)
!ulf

if (IRELAE == 23) then
  IJ = 0
  call Square(PVP,TMPE,N,1,N)
  do I=1,N
    do J=1,I
      IJ = IJ+1
      TMPD(I,J) = PVP(IJ)/TT(J)*Half*PREA
      TMPD(J,I) = PVP(IJ)/TT(I)*Half*PREA
    end do
  end do
  M = N
  TMPC(:,:) = Zero
  call dCopy_(N,[One],0,TMPC,N+1)
  call DGEMM_('N','N',N,N,N,One,TMPD,M,TMPE,M,One,TMPC,M)
  ! modified overlap is incorporated into PVP
  call DGEMM_('N','N',N,N,N,One,TMPA,N,TMPC,N,Zero,TMPB,N)
  call dGemm_tri('N','T',N,N,N,One,TMPB,N,TMPA,N,Zero,PVP,N)
end if

if ((IRELAE /= 1) .and. (IRELAE /= 11) .and. (IRELAE /= 21) .and. (IRELAE /= 22) .and. (IRELAE /= 23)) then

  if (IRELAE == 3) then
    ! KEEP T-BASIS VEXT INTO TMP1 FOR HIGHER-ORDER DK
    TMP1(1:N*(N+1)/2) = TMP2(1:N*(N+1)/2)
    ! KEEP T-BASIS PVP INTO TMP4 FOR HIGHER-ORDER DK
    TMP4(1:N*(N+1)/2) = TMP3(1:N*(N+1)/2)
  end if

  ! CALCULATE Even2r OPERATOR

  call Even2r(idbg,N,TMP2,TMP3,E,AA,RR,TT,TMPE,TMPB,TMPC,TMPF)

  ! TRANSFORM BACK

  !ulf
  if (idbg > 0) call PRMAT(IDBG,TMP3,n,0,'ev2 orig')
  call TrSmtr(TMP3,TMPA,H,One,N,TMPB,TMPC)
  !ulf

  if ((IRELAE /= 0) .and. (IRELAE /= 2)) then  ! DK2

    ! CALCULATE Even3r OPERATOR

    call Even3r(N,TMP2,TMP3,E,AA,RR,TT,TMPB,TMPD,TMP1,TMP4,TMPE,TMPF)

    ! TRANSFORM BACK

    !ulf
    if (idbg > 0) call PRMAT(IDBG,TMP3,n,0,'ev2 orig')
    call TrSmtr(TMP3,TMPA,H,One,N,TMPB,TMPC)
    !ulf

    if (IRELAE /= 3) then  ! DK3

      ! More to come!

    end if
  end if
end if

!ulf
if (idbg > 0) call PRMAT(IDBG,h,n,0,'h   oper')
call Sogr(idbg,N,S,TMPE,TMP2,TMPC,EW)
call Diagr(H,N,TMPF,EW,TMPE,TMPB,TMP2)
if (idbg > 0) then
  call PRMAT(IDBG,h,n,0,'h   oper(final)')
  write(idbg,*) '--- EIGENVALUES OF H MATRIX ---'
  write(idbg,'(4D20.12)') EW
end if

return

100 format(1X,I4,7(1X,D15.8))
556 format(//,7X,'- NREL. ENERG.  -  DIVIDED BY C - REL.  ENERG.  -  MOMENTUM    - TERMS OF POWER SERIES (LOW ENERGY ONLY)'//)
#ifdef _DEBUGPRINT_
2012 format('  relsew|****** '/,'        |****** WARNING - OVERLAP MATRIX SINGULAR '/, &
            '        |****** PIVOTAL ELEMENT LESS THAN ',D20.4,' FOUND'/,'        |******'//)
2016 format('  relsew| DCOPIV rc=',I2,', |S|=',D20.6,'x 10**(',I4,') ')
#endif

end subroutine SCFCLI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SUBROUTINE CHO_rassi_twxy(irc,ipScr,ipChoV,ipInt,nAorb,
     &                              JSYM,NUMV,DoReord)

      Implicit Real*8 (a-h,o-z)
      Integer irc,ipChoV(*),ipInt,nAorb(*),JSYM,NUMV,iAorb(8)
      Integer ipScr(8,8)
      Logical DoReord

      parameter (zero = 0.0D0, one = 1.0D0)

#include "WrkSpc.fh"
#include "cholesky.fh"
#include "choorb.fh"

C ************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
C ************************************************
      iTri(i,j) = Max(i,j)*(Max(i,j)-3)/2 + i + j
C ************************************************


      If (NumV .lt. 1) Return

C --- Computing the integrals (TT|TT),(TW,TW) and (TW|XY)
C ---------------------------------------------------------
C --- (tw|xy)  <-  (tw|xy)  +  sum_J  L(tw,#J) * L(xy,#J)
C==========================================================

      Do iSymy=1,nSym

         iSymx=MulD2h(iSymy,JSYM)

         Nxy  = nAorb(iSymx)*nAorb(iSymy)

         If (Nxy.gt.0) then

            Do iSymw=iSymy,nSym   ! iSymw.ge.iSymy (particle symmetry)

               iSymt=MulD2h(iSymw,JSYM)

               Ntw  = nAorb(iSymt)*nAorb(iSymw)

               If (Ntw.gt.0) then

                  CALL DGEMM_('N','T',Ntw,Nxy,NumV,
     &                       ONE,Work(ipChoV(iSymw)),Ntw,
     &                       WORK(ipChoV(iSymy)),Nxy,ONE,
     &                       Work(ipScr(iSymw,iSymy)),Ntw)


               End If

            End Do

         End If

      End Do


C --- Reorder to the storage required by the RASSI program
C ---
C --- There is no permutational symmetry but only particle
C --- symmetry in the (tw|xy) integrals
C ------------------------------------------------------------
      IF (DoReord) THEN

         iAorb(1)= 0
         Do iSym = 2,nSym
            iAorb(iSym) = iAorb(iSym-1) + nAorb(iSym-1)
         End Do

         nTA = iAorb(nSym) + nAorb(nSym) ! total # active orbitals


         Do iSymy=1,nSym

            iSymx=MulD2h(iSymy,JSYM)

            Nxy = nAorb(iSymx)*nAorb(iSymy)

            If (Nxy.gt.0) then

               Do iSymw=iSymy,nSym

                  iSymt=MulD2h(iSymw,JSYM)

                  Ntw = nAorb(iSymt)*nAorb(iSymw)

                  If (Ntw.gt.0) then

                     Do iy=1,nAorb(iSymy)

                      iyG = iAorb(iSymy) + iy  !global index

                      Do ix=1,nAorb(iSymx)

                       ixG  = iAorb(iSymx) + ix

                       ixy  = nAorb(iSymx)*(iy-1) + ix

                       ixyG = nTA*(iyG-1) + ixG ! global index

                       Do iw=1,nAorb(iSymw)

                        iwG  = iAorb(iSymw) + iw

                        Do it=1,nAorb(iSymt)

                           itG  = iAorb(iSymt) + it

                           itw  = nAorb(iSymt)*(iw-1) + it

                           itwG = nTA*(iwG-1) + itG ! global index

                           iScr = ipScr(iSymw,iSymy) + Ntw*(ixy-1)
     &                          + itw - 1

                           iRes = ipInt + iTri(itwG,ixyG) - 1

                           Work(iRes) = Work(iScr)

                        End Do

                       End Do

                      End Do

                     End Do

                  End If

               End Do

            End If

         End Do


      ENDIF



      irc=0

      Return
      END

**************************************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TSHop(CI1,CI2)
      use rassi_global_arrays, only: JBNUM, LROOT
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='TSHOP')
#include "Molcas.fh"
#include "cntrl.fh"
#include "rasdef.fh"
#include "rassi.fh"
#include "Files.fh"
#include "WrkSpc.fh"
#include "tshcntrl.fh"
      REAL*8       CI1,CI1pr,CI2,CI2pr,prdct(2,2)
      INTEGER      I,JOB1,JOB2,file,file2,maxHop,IAD3,IADR3
      CHARACTER    filnam*80,filother*80
      DIMENSION    CI1(NCI1),CI1pr(NCI1),CI2(NCI2),CI2pr(NCI2)
      DIMENSION    IADR3(3)
      LOGICAL      lMaxHop,lAllowHop,fexist,lHopped
*
*
C Skip the test if a hop has occurred
C  (this should happen when testing for state n+1
C  right after a hop to state n-1)
      CALL Get_iScalar('Relax CASSCF root',I)
      IF (I.NE.ISTATE1) THEN
         IF (IPGLOB.GE.USUAL) WRITE(6,'(6X,A)')
     &        'A hop has just been detected, skipping this state.'
         RETURN
      ENDIF
*
C Initialization
      DO i=1, NCI1
         CI1pr(I)=0.0d0
      END DO
      DO i=1, NCI2
         CI2pr(I)=0.0d0
      END DO
      file=83
      file2=83
      lHopped=.FALSE.
C
C Get the CI coefficients for current state
C
C Open JOBIPH file:
      JOB1=JBNUM(ISTATE1)
      CALL DANAME(LUIPH,JBNAME(JOB1))
C Read table of contents on this JOBIPH file:
      IAD=0
      CALL IDAFILE(LUIPH,2,ITOC15,15,IAD)
C Read CI coefficients from interface.
      IDISK=ITOC15(4)
      LROOT1=LROOT(ISTATE1)
      DO I=1,LROOT1-1
         CALL DDAFILE(LUIPH,0,CI1,NCI1,IDISK)
      END DO
      CALL DDAFILE(LUIPH,2,CI1,NCI1,IDISK)
      CALL DACLOS(LUIPH)
C
C Get the CI coefficients for state2
C
C Open JOBIPH file:
      JOB2=JBNUM(ISTATE2)
      CALL DANAME(LUIPH,JBNAME(JOB2))
C Read table of contents on this JOBIPH file:
      IAD=0
      CALL IDAFILE(LUIPH,2,ITOC15,15,IAD)
C Read CI coefficients from interface.
      IDISK=ITOC15(4)
      LROOT1=LROOT(ISTATE2)
      DO I=1,LROOT1-1
         CALL DDAFILE(LUIPH,0,CI2,NCI2,IDISK)
      END DO
      CALL DDAFILE(LUIPH,2,CI2,NCI2,IDISK)
      CALL DACLOS(LUIPH)
C
C Check if it is a hop up or hop down
C
      I=ISTATE1-ISTATE2
      IF (I.GT.0) THEN
         IF (IPGLOB.GE.USUAL)
     &      WRITE(6,*) 'Checking for a hop to a root lower in energy.'
         filnam='CIVECTOR'
         filother='CIVECTUP'
      ELSEIF (I.LT.0) THEN
         IF (IPGLOB.GE.USUAL)
     &      WRITE(6,*) 'Checking for a hop to a root higher in energy.'
         filnam='CIVECTUP'
         filother='CIVECTOR'
      ELSE
         WRITE(6,*) 'Unknown problem'
         WRITE(6,*) 'ISTATE1 = ',ISTATE1
         WRITE(6,*) 'ISTATE2 = ',ISTATE2
      ENDIF
C
C Open the file with the previous CI-vectors
C
      CALL f_inquire(filnam,fexist)
      IF (fexist) THEN
         CALL DANAME(file,filnam)
         IF (IPGLOB.GE.VERBOSE)
     &      WRITE(6,*) filnam(:mylen(filnam))//' file exists.'
      ELSE
C If the file does not exist, create a new one with the
C current vectors
         CALL DANAME(file,filnam)
C Dummy table of contents is written
         DO I=1,3
            IADR3(I)=0
         END DO
         IAD3=0
         CALL IDAFILE(file,1,IADR3,3,IAD3)
         IADR3(1)=IAD3
C Current CI coefficients are written
         CALL DDAFILE(file,1,CI1,NCI1,IAD3)
         IADR3(2)=IAD3
         CALL DDAFILE(file,1,CI2,NCI2,IAD3)
         IADR3(3)=IAD3
C Write the real table of contents
         IAD3=0
         CALL IDAFILE(file,1,IADR3,3,IAD3)
         IF (IPGLOB.GE.VERBOSE)
     &      WRITE(6,*) filnam(:mylen(filnam))//' file created.'
      ENDIF
C
C Check for surface hop if the energy difference is smaller than
C the threshold.
C
      IF (ChkHop) THEN
C
C Read table of contents on this file
         IAD3=0
         CALL IDAFILE(file,2,IADR3,3,IAD3)
C Read the CI coefficients of ISTATE1 from previuos step
         IAD3=IADR3(1)
         CALL DDAFILE(file,2,CI1pr,NCI1,IAD3)
C Read the CI coefficients of ISTATE2 from previuos step
         IAD3=IADR3(2)
         CALL DDAFILE(file,2,CI2pr,NCI2,IAD3)
C
C Calculate the scalar product of the CI coefficient vectors.
         prdct(1,1)=0.0d0
         prdct(1,2)=0.0d0
         prdct(2,1)=0.0d0
         prdct(2,2)=0.0d0
         IF (IPGLOB.GE.VERBOSE)
     &      WRITE(6,'(4(A16))') "CI1","CI1pr","CI2","CI2pr"
         DO i=1, NCI1
            IF (IPGLOB.GE.VERBOSE)
     &         WRITE(6,'(4(3X,E13.6))') CI1(i),CI1pr(i),CI2(i),CI2pr(i)
            prdct(1,1) = prdct(1,1) + CI1pr(i) * CI1(i)
            prdct(1,2) = prdct(1,2) + CI1pr(i) * CI2(i)
            prdct(2,1) = prdct(2,1) + CI2pr(i) * CI1(i)
            prdct(2,2) = prdct(2,2) + CI2pr(i) * CI2(i)
         END DO
         IF (IPGLOB.GE.USUAL) THEN
            WRITE(6,'(6X,A)')'The scalar products of the CI-vectors:'
            WRITE(6,3000)'CIpr(state1) * CI(state1) =',prdct(1,1)
            WRITE(6,3000)'CIpr(state1) * CI(state2) =',prdct(1,2)
            WRITE(6,3000)'CIpr(state2) * CI(state1) =',prdct(2,1)
            WRITE(6,3000)'CIpr(state2) * CI(state2) =',prdct(2,2)
            WRITE(6,*)
         END IF
C Check the conditions for a surface hop
         IF (ABS(prdct(1,2)).GE.0.25.AND.ABS(prdct(2,1)).GE.0.25) THEN
            WRITE(6,'(6X,80A1)')'+',('-',i=1,78),'+'
            WRITE(6,'(6X,A1,T86,A1)')'|','|'
            WRITE(6,'(6X,A1,T35,A,T86,A1)')'|',
     &           'A HOP event is detected!','|'
            WRITE(6,'(6X,A1,T86,A1)')'|','|'
            WRITE(6,'(6X,A1,T32,2(A,I3,4X),T86,A1)')'|','From state:',
     &           ISTATE1,'To state:',ISTATE2,'|'
C Check if the number of Hops is limited:
            CALL qpg_iScalar('MaxHops',lMaxHop)
            IF (lMaxHop) THEN
               CALL Get_iScalar('MaxHops',maxHop)
               lHop=.FALSE.
               CALL qpg_iScalar('Number of Hops',lHop)
               IF (lHop) THEN
                  CALL Get_iScalar('Number of Hops',nHop)
               ELSE
                  nHop=0
               END IF
               IF (maxHop.LE.nHop) THEN
                  lAllowHop=.FALSE.
                  WRITE(6,'(6X,A1,T40,A,T86,A1)') '|','maxHop > nHop',
     &            '|'
                  WRITE(6,'(6X,A1,T31,A,T86,A1)') '|',
     &            'This surface HOP is not allowed','|'
                  WRITE(6,'(6X,A1,T24,A,T86,A1)') '|',
     &            'because the number of allowed Hops is exceeded','|'
               ELSE
                  lAllowHop=.TRUE.
               END IF
            ELSE
               lAllowHop=.TRUE.
            END IF
C Bottom of the printed box
            WRITE(6,'(6X,A1,T86,A1)')'|','|'
            WRITE(6,'(6X,80A1,//)')'+',('-',i=1,78),'+'
C Set the numbers of Hops
            IF (lAllowHop) THEN
               CALL Put_iScalar('Relax CASSCF root',ISTATE2)
               CALL Put_iScalar('NumGradRoot',ISTATE2)
               nHop=nHop+1
               CALL Put_iScalar('Number of Hops',nHop)
               lHopped=.TRUE.
            END IF
         END IF
      END IF
      IF (IPGLOB.GE.VERBOSE) THEN
         WRITE(6,'(2(6X,A8,I3))')'ISTATE1=',ISTATE1,'ISTATE2=',ISTATE2
         DO i=1, NCI1
            WRITE(6,'(6X,E12.5,8X,E12.5)') CI1(i),CI2(i)
         END DO
      END IF
C
C Save the CI coefficients to the right file,
C dependending on whether or not a hop has occurred
C
      IF (lHopped) THEN
C
C Delete the file with the CI-vectors
         CALL DaEras(file)
C
C Note that, if a hop occurred, the vectors are written
C in the *other* file, and in reversed order
         CALL f_inquire(filother,fexist)
         IF (fexist) THEN
            CALL DANAME(file2,filother)
            IAD3=0
            CALL IDAFILE(file2,2,IADR3,3,IAD3)
            IAD3=IADR3(1)
            CALL DDAFILE(file2,1,CI2,NCI2,IAD3)
            IAD3=IADR3(2)
            CALL DDAFILE(file2,1,CI1,NCI1,IAD3)
            CALL DACLOS(file2)
         ELSE
C The file does not exist, create a new one
            CALL DANAME(file2,filother)
            IAD3=0
            CALL IDAFILE(file2,1,IADR3,3,IAD3)
            IADR3(1)=IAD3
            CALL DDAFILE(file2,1,CI2,NCI2,IAD3)
            IADR3(2)=IAD3
            CALL DDAFILE(file2,1,CI1,NCI1,IAD3)
            IADR3(3)=IAD3
            IAD3=0
            CALL IDAFILE(file2,1,IADR3,3,IAD3)
            CALL DACLOS(file2)
         END IF
      ELSE
C
C Write the CI-vectors normally if no hop occurred
         IAD3=0
         CALL IDAFILE(file,2,IADR3,3,IAD3)
         IAD3=IADR3(1)
         CALL DDAFILE(file,1,CI1,NCI1,IAD3)
         IAD3=IADR3(2)
         CALL DDAFILE(file,1,CI2,NCI2,IAD3)
         CALL DACLOS(file)
      ENDIF
*
      RETURN
3000  FORMAT(6X,A,F7.2)
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Igor Schapiro                                    *
!***********************************************************************
!
! *********************************************************************
! *                                                                   *
! * Second part of the velocity Verlet algorithm, which calculates    *
! * velocities of the next time step from the velocities from the     *
! * half step and the new forces.                                     *
! *                                                                   *
! * The algorithm is based on the example F4 of molecular dynamics    *
! * bible from Allen and Tildesley.                                   *
! *                                                                   *
! * 15/10/2006                                                        *
! * Igor Schapiro                                                     *
! *                                                                   *
! *********************************************************************

! REFERENCE:
! SWOPE ET AL., J. CHEM. PHYS. 76, 637, 1982.

subroutine VelVer_Second(irc)

#ifdef _HDF5_
use mh5, only: mh5_put_dset
use Dynamix_Globals, only: dyn_etot, dyn_vel
#endif
use Dynamix_Globals, only: DT, iPrint, PIN, POUT, THERMO, INSANE
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: kBoltzmann, auTokJ, Zero, One, Two, Three, Half, OneHalf
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: i, j, natom, filenum, nsAtom
real(kind=wp) :: scalfac, tempNow, tolerance, DT2, time, Ekin, Epot, Etot, Etot0, Ekin_target, EtotLastPoint
logical(kind=iwp) :: hybrid, found
character(len=15) :: caption
character(len=80) :: lastline, filename, line
real(kind=wp), allocatable :: Mass(:), vel(:), force(:), xyz(:)
character(len=2), allocatable :: atom(:)
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

! The parameter conv converts the gradients (Hartree/Bohr) to
! (i)  forces (Hartree/Bohr)    => -1.0
! (ii) forces (kJ/mole/Agstrom) => -4961.47525891

real(kind=wp), parameter :: conv = -One, kb = kBoltzmann/(auTokJ*1.0e3_wp)

if (IPRINT == INSANE) write(u6,*) ' Entering VelVer_Second'

write(u6,*) '*** Second step of the Velocity Verlet algorithm ***'

filename = 'comqum.dat'
call F_INQUIRE(filename,hybrid)

if (hybrid) then
  write(u6,'(/,5X,A)') 'Perform QM/MM Molecular Dynamics'
  call DxRdNAtomHbrd(natom)
else
  call DxRdNAtomStnd(natom)
end if

call mma_allocate(atom,natom)
call mma_allocate(Mass,natom)
call mma_allocate(vel,natom*3)
call mma_allocate(force,natom*3)
call mma_allocate(xyz,natom*3)

if (hybrid) then
  call DxRdHbrd(natom,atom,xyz,force)
else
  call DxRdStnd(natom,atom,xyz,force)
end if

call Get_Velocity(vel,3*natom)
call GetMassDx(Mass,natom)

! Check if reduced dimensionality
if (POUT /= 0) then
  call project_out_for(force,natom)
else if (PIN /= natom*3) then
  call project_in_for(force,natom)
end if

! Definition of the time step

DT2 = DT/Two
Ekin = Zero

call Get_dScalar('MD_Time',time)

do i=1,natom
  do j=1,3
    vel(3*(i-1)+j) = vel(3*(i-1)+j)+DT2*force(3*(i-1)+j)/Mass(i)
  end do
end do
!  Calling the thermostats for canonical ensemble
if (THERMO == 2) then
  call NhcThermo(vel)
end if

! Check if reduced dimensionality (should not be needed)
if (POUT /= 0) then
  call project_out_vel(vel,natom)
end if

! Final kinetic energy
do i=1,natom
  do j=1,3
    Ekin = Ekin+Half*Mass(i)*(vel(3*(i-1)+j)**2)
  end do
end do

call Add_Info('EKin',[EKin],1,6)

! Write out the velocities

caption = 'Velocities'
lastline = ''
call DxPtTableCo(caption,time,natom,atom,vel,lastline,Mass,force)

! Read in the potential energy

if (hybrid) then
  filenum = IsFreeUnit(81)
  filename = 'fixenergy.out'
  call Molcas_Open(filenum,filename)
  read(filenum,*) line
  do while (i <= 80)
    if (line(i:i) == '$') then
      read(filenum,'(es20.13)') Epot
      i = 80
    else if (i == 80 .and. line(i:i) /= '$') then
      write(u6,*) 'No energy found'
      call Abend()
    end if
    i = i+1
  end do
  close(filenum)
else
  call Get_dScalar('Last Energy',Epot)
end if

Etot = Epot+Ekin

! Output

if (hybrid) then
  write(u6,'(//,5X,A,F8.1)') 'Final QM/MM Energy at time ',time
else
  write(u6,'(//,5X,A,F8.1)') 'Final Energy at time ',time
end if
write(u6,'(5X,A,/)') '============================'
write(u6,'(5X,A,6X,es19.12,1X,A)') 'Kinetic energy',Ekin,'a.u.'
write(u6,'(5X,A,4X,es19.12,1X,A)') 'Potential Energy',Epot,'a.u.'
write(u6,'(5X,A,8X,es19.12,1X,A)') 'Total Energy',Etot,'a.u.'

!--------------------------------------------------------------------C
! CANONICAL ENSEMBLE
!--------------------------------------------------------------------C
tempNow = Two*Ekin/(Three*natom*kb)
if (THERMO == 2) then
  tempNow = Two*Ekin/(Three*natom*kb)
  write(u6,'(//,5x,a)') 'Canonical Ensemble'
  write(u6,'(5x,a)') 'The temperature is control with a '
  write(u6,'(5x,a)') 'Nose-Hoover chain of thermostats'
  write(u6,'(5x,a,/)') '========================'
  write(u6,'(5x,a,5x,es11.4,1x,a,//)') 'instantaneous temperature',tempNow,'kelvin'

end if
!--------------------------------------------------------------------C

!---------------------------------------------------------------------C
!     MICRO-CANONICAL ENSEMBLE
!---------------------------------------------------------------------C
if (THERMO == 1) then
  call Get_dScalar('MD_Etot0',Etot0)
  write(u6,'(//,5x,a)') 'Micro-Canonical Ensemble'
  write(u6,'(5x,a,/)') '========================'
  write(u6,'(5x,a,7x,es11.4,1x,a)') 'Target Total Energy',Etot0,'a.u.'
  write(u6,'(5x,a,es11.4,1x,a)') 'Deviation from this Energy',abs(Etot0-Etot),'a.u.'

  ! Check if the total energy is conserved and scale the velocities
  ! if necessary.

  ! 1.0K * k_B
  tolerance = kb
  tolerance = OneHalf*natom*tolerance
  if (abs(Etot0-Etot) > tolerance) then
    Ekin_target = Etot0-Epot
    scalfac = sqrt(Ekin_target/Ekin)
    do i=1,natom
      do j=1,3
        vel(3*(i-1)+j) = scalfac*vel(3*(i-1)+j)
      end do
    end do
    write(u6,'(5X,A)') 'is larger then Scaling-Threshold XX.'
    write(u6,'(5X,A)') 'Velocity scaling is necessary.'
    write(u6,401) 'Velocity scaling factor',scalfac
    Ekin = Ekin_target
  else
    write(u6,'(5X,A)') 'is smaller then Scaling-Threshold XX.'
    write(u6,'(5X,A)') 'Velocity scaling is not necessary.'
  end if
end if
!---------------------------------------------------------------------C
call Put_dScalar('MD_Time',time)

Etot = Epot+Ekin

!------ Tully reascaling velocities in case of HOP ---------------------C
call qpg_iscalar('hopped',Found)
if (found) call get_lscalar('hopped',Found)
if (found) then
  call Get_iScalar('Unique atoms',nsAtom)
  call get_dScalar('MD_Etot',EtotLastPoint)
  Ekin_target = EtotLastPoint-Epot
  if (Ekin_target < 0.0) then
    Ekin_target = 0.0
    write(u6,*) 'warning negative kin energy rescaled to 0.0'
  end if
  !write(u6,*) 'DEBUGS'
  !write(u6,*) Epot,EtotLastPoint,Etot
  !write(u6,*) 'EtotLastPoint'
  !write(u6,*) EtotLastPoint
  !write(u6,*) 'scalfac'
  !write(u6,*) scalfac
  !write(u6,*) 'nsAtom'
  !write(u6,*) nsAtom
  scalfac = sqrt(Ekin_target/Ekin)
  write(u6,*) 'Velocities before Hop:'
  do i=1,nsAtom
    write(u6,*) vel(i*3-2),vel(i*3-1),vel(i*3)
  end do
  do i=1,natom
    do j=1,3
      vel(3*(i-1)+j) = scalfac*vel(3*(i-1)+j)
    end do
  end do

  write(u6,*) 'Velocities after Hop:'
  do i=1,nsAtom
    write(u6,*) vel(i*3-2),vel(i*3-1),vel(i*3)
  end do
  Etot = Epot+Ekin_target
end if

call Put_dScalar('MD_Etot',Etot)
#ifdef _HDF5_
call mh5_put_dset(dyn_etot,Etot)
#endif
call DxEnergies(time,Epot,Ekin,Etot)

call DxWtVel(vel,3*natom)
call Put_Velocity(vel,3*natom)
#ifdef _HDF5_
call mh5_put_dset(dyn_vel,vel)
#endif

call mma_deallocate(atom)
call mma_deallocate(Mass)
call mma_deallocate(vel)
call mma_deallocate(force)
call mma_deallocate(xyz)

! The return code is set in order to continue the loop

irc = _RC_ALL_IS_WELL_

return

401 format(5x,a,3x,e11.4)

end subroutine VelVer_Second

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine exth1(a,b,dimp,dimq,p,nfact)
! this routine extracts A(p,q) -> B_p(q)
!
! a     - matrix a (Input)
! b     - matrix b (Output)
! dimp  - dimension of p (Input)
! dimq  - dimension of q (Input)
! p     - value of index p (Input)
! nfact - sign (+-1,0) (Input)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, p, nfact
real(kind=wp), intent(in) :: a(dimp,dimq)
real(kind=wp), intent(out) :: b(dimq)

if (nfact == 1) then
  b(:) = a(p,:)
else if (nfact == -1) then
  b(:) = -a(p,:)
else if (nfact == 0) then
  b(:) = Zero
end if

return

end subroutine exth1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SETSXCI()

use sxci, only: IDXCI, IDXSX
use gas_data, only: NGAS, NGSSH
use general_data, only: NSYM
use Molcas, only: MxGAS
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: I, IGAS, IGSSH, IOFF_GSSH(mxgas), ISTOT, ISYM, NGSSHT

!---------------------------------------------------------
!--  SET INDEX VECTORS FOR CI/SX INTEGRAL ORDERING
!---------------------------------------------------------

NGSSHT = 0
do IGAS=1,NGAS
  IOFF_GSSH(IGAS) = NGSSHT
  NGSSHT = NGSSHT+sum(NGSSH(IGAS,1:NSYM))
end do
ISTOT = 0
do ISYM=1,NSYM
  do IGAS=1,NGAS
    do IGSSH=1,NGSSH(IGAS,ISYM)
      IOFF_GSSH(IGAS) = IOFF_GSSH(IGAS)+1
      ISTOT = ISTOT+1
      IDXCI(ISTOT) = IOFF_GSSH(IGAS)
    end do
  end do
end do

do I=1,ISTOT
  IDXSX(IDXCI(I)) = I
end do

#ifdef _DEBUGPRINT_
write(u6,'(1X,A)') 'REORDERING VECTOR FOR CI'
write(u6,'(1X,12I5)') (IDXCI(I),I=1,ISTOT)
write(u6,'(1X,A)') 'REORDERING VECTOR FOR SX'
write(u6,'(1X,12I5)') (IDXSX(I),I=1,ISTOT)
#endif

end subroutine SETSXCI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
*  Query_Grads
*
*> @brief Query sizes from a gradients file
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Reads the number of roots and length of the gradients from the
*> gradients file (GRADS).
*>
*> @param[out] Exists Whether or not the gradients file exists
*> @param[out] nRoots Number of roots allowed in the gradients file
*> @param[out] nGrad  Length of the vectors in the gradients file
************************************************************************
      Subroutine Query_Grads(Exists,nRoots,nGrad)
      Implicit None
      Logical :: Exists
      Integer :: nRoots,nGrad
      Integer, Dimension(5) :: TOC
      Integer, Dimension(1) :: iDum
      Integer :: LuGrad,iAd
      Logical :: Found
      Character(Len=5) :: Filename
*
      Filename='GRADS'
      Call f_Inquire(Filename,Found)
      If (.Not.Found) Then
        Exists=.False.
        nRoots=0
        nGrad=0
        Return
      End If
*
      LuGrad=20
      Call DaName(LuGrad,Filename)
      iAd=0
      Call iDaFile(LuGrad,2,TOC,Size(TOC),iAd)
      Call iDaFile(LuGrad,2,iDum,1,iAd)
      nRoots=iDum(1)
      Call iDaFile(LuGrad,2,iDum,1,iAd)
      nGrad=iDum(1)
      Call DaClos(LuGrad)
*
      End Subroutine Query_Grads

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagFroD(NBSQT,NASHT,DIA,DI,RDMSA,Trf)

use Index_Functions, only: nTri_Elem
use caspt2_global, only: CMOPT2
use caspt2_module, only: NASH, NBAS, NFRO, NISH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NBSQT, nAshT
real(kind=wp), intent(out) :: DIA(NBSQT), DI(NBSQT)
real(kind=wp), intent(in) :: RDMSA(nAshT**2), Trf(NBSQT)
integer(kind=iwp) :: iAOsq, iAOtr, iSym, nAshI, nBasI, nCorI, nFroI, nIshI
real(kind=wp), allocatable :: WRK1(:), WRK2(:)

call mma_allocate(WRK1,NBSQT,Label='WRK1')
call mma_allocate(WRK2,NBSQT,Label='WRK2')

iAOtr = 0
iAOsq = 1
do iSym=1,nSym
  nFroI = nFro(iSym)
  nIshI = nIsh(iSym)
  nAshI = nAsh(iSym)
  nBasI = nBas(iSym)
  nCorI = nFroI+nIshI

  !! full density matrix
  !call SQUARE(WRK1(1+iAOtr),DIA(iAOsq),1,nBasI,nBasI)
  ! !! off-diagonal elements have to be halved
  !do Mu=1,nBasI
  !  do Nu=1,nBasI
  !    if (Mu == Nu) cycle
  !    DIA(iAOsq+Mu-1+nBasI*(Nu-1)) = Half*DIA(iAOsq+Mu-1+nBasI*(Nu-1))
  !  end do
  !end do

  !! inactive density matrix
  call DGEMM_('N','T',nBasI,nBasI,nCorI,Two,CMOPT2,nBasI,CMOPT2,nBasI,Zero,DI(iAOsq),nBasI)

  !! inactive+active density matrix
  !! Somehow, the above density matrix obtained by calling
  !! Get_D1AO is incorrect... at least, cannot be used.
  ! 1) inactive part
  DIA(1:nBasI**2) = DI(1:nBasI**2)
  ! 2)  RDMSA is defined in CASSCF orbitals, so transform RDMSA to
  !     CASPT2 orbital basis
  call DGemm_('T','N',nAshI,nAshI,nAshI,One,Trf(1+nCorI+nBasI*nCorI),nBasI,RDMSA,nAshI,Zero,WRK2,nAshI)
  call DGemm_('N','N',nAshI,nAshI,nAshI,One,WRK2,nAshI,Trf(1+nCorI+nBasI*nCorI),nBasI,Zero,WRK1,nAshI)
  ! 3) Finally, add the active part
  call DGemm_('N','N',nBasI,nAshI,nAshI,One,CMOPT2(1+nBasI*nCorI),nBasI,WRK1,nAshI,Zero,WRK2,nBasI)
  call DGemm_('N','T',nBasI,nBasI,nAshI,One,WRK2,nBasI,CMOPT2(1+nBasI*nCorI),nBasI,One,DIA,nBasI)

  iAOtr = iAOtr+nTri_Elem(nBasI)
  iAOsq = iAOsq+nBasI*nBasI
end do

call mma_deallocate(WRK1)
call mma_deallocate(WRK2)

return

end subroutine OLagFroD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per Ake Malmqvist                                      *
!***********************************************************************

subroutine TRACHO3(CMO,NCMO)

use Symmetry_Info, only: Mul
use CHOVEC_IO, only: ChoVec_Coll, ChoVec_load, ChoVec_Save, npq_ChoType, NVLOC_ChoBatch
use Cholesky, only: InfVec
use ChoCASPT2, only: MxNVc, nChSpc, nFtSpc, nHtSpc, NumCho_PT2
use caspt2_module, only: nAsh, nBas, nBtch, nBtches, nFro, nInaBx, nIsh, nSecBx, nSsh, nSym, RHSDirect
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NCMO
real(kind=wp), intent(in) :: CMO(NCMO)
integer(kind=iwp) :: IAEND, IASTA, IB, IBATCH, IBATCH_TOT, IBEND, IBSTA, IC, ICASE, IIEND, IISTA, ILOC, ip_htspc, ip_HTVec(8), &
                     IP_LHT, IRC, ISTART(8), ISYM, ISYMA, ISYMB, ISYP, ISYQ, JNUM, JRED, JRED1, JRED2, JREDC, JSTART, JSYM, JV1, &
                     JV2, MUSED, N, N1, N2, NA, NASZ, NBATCH, NBUFFY, NCES(8), NHTOFF, NI, NISZ, NPQ, NUMV, NUSE(8), NVECS_RED
real(kind=wp), allocatable :: BUFFY(:), CHSPC(:), FTSPC(:), HTSPC(:)
#include "warnings.h"

!***********************************************************************
! ======================================================================
! This section deals with density matrices and CMO''s
! Offsets into CMO arrays:
IC = 0
do ISYM=1,NSYM
  NCES(ISYM) = IC
  IC = IC+NBAS(ISYM)**2
end do

! ======================================================================
call mma_allocate(CHSPC,NCHSPC,LABEL='CHSPC')
call mma_allocate(HTSPC,NHTSPC,LABEL='HTSPC')
ip_HTSPC = 1
call mma_allocate(FTSPC,NFTSPC,LABEL='FTSPC')
! ======================================================================

!IBATCH_TOT=0
! Loop over JSYM
do JSYM=1,NSYM
  IBATCH_TOT = NBTCHES(JSYM)

  if (NUMCHO_PT2(JSYM) == 0) cycle

  JRED1 = InfVec(1,2,jSym)
  JRED2 = InfVec(NumCho_PT2(jSym),2,jSym)
  !write(u6,*) 'tracho3:  JRED1,JRED2:',JRED1,JRED2

  ! Loop over JRED
  do JRED=JRED1,JRED2

    call Cho_X_nVecRS(JRED,JSYM,JSTART,NVECS_RED)
    if (NVECS_RED == 0) cycle

    ILOC = 3
    call CHO_X_SETRED(IRC,ILOC,JRED)
    ! For a reduced set, the structure is known, including
    ! the mapping between reduced index and basis set pairs.
    ! The reduced set is divided into suitable batches.
    ! First vector is JSTART. Nr of vectors in r.s. is NVECS_RED.

    ! Determine batch length for this reduced set.
    ! Make sure to use the same formula as in the creation of disk
    ! address tables, etc, above:
    NBATCH = 1+(NVECS_RED-1)/MXNVC

    ! Loop over IBATCH
    JV1 = JSTART
    do IBATCH=1,NBATCH
      IBATCH_TOT = IBATCH_TOT+1

      JNUM = NVLOC_CHOBATCH(IBATCH_TOT)
      JV2 = JV1+JNUM-1

      JREDC = JRED
      ! Read a batch of reduced vectors
      call CHO_VECRD(CHSPC,NCHSPC,JV1,JV2,JSYM,NUMV,JREDC,MUSED)
      if (NUMV /= JNUM) then
        write(u6,*) ' Rats! CHO_VECRD was called, assuming it to'
        write(u6,*) ' read JNUM vectors. Instead it returned NUMV'
        write(u6,*) ' vectors: JNUM, NUMV=',JNUM,NUMV
        write(u6,*) ' Back to the drawing board?'
        call QUIT(_RC_INTERNAL_ERROR_)
      end if
      if (JREDC /= JRED) then
        write(u6,*) ' Rats! It was assumed that the Cholesky vectors'
        write(u6,*) ' in HALFTRNSF all belonged to a given reduced'
        write(u6,*) ' set, but they don''t!'
        write(u6,*) ' JRED, JREDC:',JRED,JREDC
        write(u6,*) ' Back to the drawing board?'
        write(u6,*) ' Let the program continue and see what happens.'
      end if

      ! Frozen half-transformation:
      NHTOFF = 0
      do ISYMA=1,NSYM
        ISYMB = Mul(ISYMA,JSYM)
        IP_HTVEC(ISYMA) = IP_HTSPC+NHTOFF
        ISTART(ISYMA) = 1
        NUSE(ISYMA) = NFRO(ISYMA)
        NHTOFF = NHTOFF+NUSE(ISYMA)*NBAS(ISYMB)*JNUM
      end do
      call HALFTRNSF(IRC,CHSPC,NCHSPC,1,JV1,JNUM,JNUM,JSYM,JREDC,CMO,NCMO,ISTART,NUSE,IP_HTVEC,HTSPC,NHTSPC)

      ! Inactive half-transformation:
      ! Vectors of type HALF(K,J,B) = Sum(CHO(AB,J)*CMO(A,K) where
      ! A,B are basis functions of symmetry ISYMA, ISYMB,
      ! K is inactive of symmetry ISYMA, J is vector number in 1..NUMV
      ! numbered within the present batch.
      ! Symmetry block ISYMA,ISYMB is found at HTSPC(IP_HTVEC(ISYMA)
      NHTOFF = 0
      do ISYMA=1,NSYM
        ISYMB = Mul(ISYMA,JSYM)
        IP_HTVEC(ISYMA) = IP_HTSPC+NHTOFF
        ISTART(ISYMA) = NFRO(ISYMA)+1
        NUSE(ISYMA) = NISH(ISYMA)
        NHTOFF = NHTOFF+NUSE(ISYMA)*NBAS(ISYMB)*JNUM
      end do
      call HALFTRNSF(IRC,CHSPC,NCHSPC,1,JV1,JNUM,JNUM,JSYM,JREDC,CMO,NCMO,ISTART,NUSE,IP_HTVEC,HTSPC,NHTSPC)

      ! Loop over ISYQ
      do ISYQ=1,NSYM
        ISYP = Mul(ISYQ,JSYM)

        N = NBAS(ISYP)
        ! ---------------------------------------------------
        N1 = NASH(ISYP)
        N2 = NISH(ISYQ)
        IC = 1+NCES(ISYP)+(NFRO(ISYP)+NISH(ISYP))*N
        IP_LHT = IP_HTVEC(ISYQ)
        ! Compute fully transformed TK
        if (N1*N2 > 0) then
          call FULLTRNSF(N1,N2,N,CMO(IC),JNUM,HTSPC(IP_LHT),FTSPC)
          call CHOVEC_SAVE(FTSPC,NFTSPC,1,ISYQ,JSYM,IBATCH_TOT)
        end if
        ! ---------------------------------------------------
        N1 = NSSH(ISYP)
        N2 = NISH(ISYQ)
        IC = 1+NCES(ISYP)+(NFRO(ISYP)+NISH(ISYP)+NASH(ISYP))*N
        IP_LHT = IP_HTVEC(ISYQ)
        ! Compute fully transformed AK
        if (N1*N2 > 0) then

          !call FULLTRNSF(N1,N2,N,CMO(IC),JNUM,HTSPC(IP_LHT),FTSPC)

          ! =SVC= modified for using boxed ordering of pairs, note that the boxed
          ! routine is less efficient than the original one (loop over J values)
          NA = N1
          NI = N2
          ! Allocate memory for small buffer used in FULLTRNSF_BOXED
          NBUFFY = NA*NI
          call mma_allocate(BUFFY,NBUFFY,LABEL='BUFFY')
          ! Loop over boxes
          do IASTA=1,NA,nSecBX
            IAEND = min(IASTA-1+nSecBX,NA)
            NASZ = 1+IAEND-IASTA
            do IISTA=1,NI,nInaBX
              IIEND = min(IISTA-1+nInaBX,NI)
              NISZ = 1+IIEND-IISTA
              ! =SVC= note that WITHIN this box, the index of the outer box A (P in
              ! the FULLTRNSF subroutine, i.e. the secondary orbital index) is the
              ! fast-running index, as LFT([A],[I],J) = CMO(P,[A])^T * LHT([I],J,P)^T
              ! with P=1,NB.  So if used in e.g. ADDRHS as BRA(c,l,J), making an inner
              ! loop over secondary orbital index c is more efficient.
              call FULLTRNSF_BOXED(IASTA,IISTA,NASZ,NISZ,NA,NI,N,CMO(IC+N*(IASTA-1)),JNUM,HTSPC(IP_LHT),FTSPC,BUFFY)
            end do
          end do
          call mma_deallocate(BUFFY)
          call CHOVEC_SAVE(FTSPC,NFTSPC,4,ISYQ,JSYM,IBATCH_TOT)
        end if
        ! End loop ISYQ
      end do
      ! ---------------------------------------------------

      ! Active scaled natural orbitals half-transformation:
      ! Vectors of type HALF(W,J,B) = Sum(CHO(AB,J)*CMO(A,W) where
      ! A,B are basis functions of symmetry ISYMA, ISYMB,
      ! W is active of symmetry ISYMA, J is vector number in 1..NUMV
      ! numbered within the present batch.
      ! Symmetry block ISYMA,ISYMB is found at HTSPC(IP_HTVEC(ISYMA)
      NHTOFF = 0
      do ISYMA=1,NSYM
        ISYMB = Mul(ISYMA,JSYM)
        IP_HTVEC(ISYMA) = IP_HTSPC+NHTOFF
        ISTART(ISYMA) = NFRO(ISYMA)+NISH(ISYMA)+1
        NUSE(ISYMA) = NASH(ISYMA)
        NHTOFF = NHTOFF+NUSE(ISYMA)*NBAS(ISYMB)*JNUM
      end do
      ! ---------------------------------------------------
      ! Active half-transformation:
      call HALFTRNSF(IRC,CHSPC,NCHSPC,1,JV1,JNUM,JNUM,JSYM,JREDC,CMO,NCMO,ISTART,NUSE,IP_HTVEC,HTSPC,NHTSPC)

      do ISYQ=1,NSYM
        ISYP = Mul(ISYQ,JSYM)

        N = NBAS(ISYP)
        ! ---------------------------------------------------
        ! Loop over ISYQ
        N1 = NASH(ISYP)
        N2 = NASH(ISYQ)
        IC = 1+NCES(ISYP)+(NFRO(ISYP)+NISH(ISYP))*N
        IP_LHT = IP_HTVEC(ISYQ)
        ! Compute fully transformed TV
        if (N1*N2 > 0) then
          call FULLTRNSF(N1,N2,N,CMO(IC),JNUM,HTSPC(IP_LHT),FTSPC)
          call CHOVEC_SAVE(FTSPC,NFTSPC,2,ISYQ,JSYM,IBATCH_TOT)
        end if
        ! ---------------------------------------------------
        N1 = NSSH(ISYP)
        N2 = NASH(ISYQ)
        IC = 1+NCES(ISYP)+(NFRO(ISYP)+NISH(ISYP)+NASH(ISYP))*N
        IP_LHT = IP_HTVEC(ISYQ)
        ! Compute fully transformed AV
        if (N1*N2 > 0) then
          call FULLTRNSF(N1,N2,N,CMO(IC),JNUM,HTSPC(IP_LHT),FTSPC)
          call CHOVEC_SAVE(FTSPC,NFTSPC,3,ISYQ,JSYM,IBATCH_TOT)
        end if
        ! ---------------------------------------------------
        ! End loop ISYQ
      end do

      ! End loop IBATCH
      JV1 = JV1+JNUM
    end do

    ! End loop JRED
  end do

! End loop JSYM
end do

! if using the RHS on-demand, we need all cholesky vectors on each
! process, collect them here
if (RHSDIRECT) then
  do JSYM=1,NSYM
    IBSTA = NBTCHES(JSYM)+1
    IBEND = NBTCHES(JSYM)+NBTCH(JSYM)
    do IB=IBSTA,IBEND
      do ISYQ=1,NSYM
        do ICASE=1,4
          NPQ = NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
          if (NPQ == 0) cycle
          call CHOVEC_LOAD(FTSPC,NFTSPC,ICASE,ISYQ,JSYM,IB)
          call CHOVEC_COLL(FTSPC,NFTSPC,ICASE,ISYQ,JSYM,IB)
        end do
      end do
    end do
  end do
end if

call mma_deallocate(CHSPC)
call mma_deallocate(HTSPC)
call mma_deallocate(FTSPC)

end subroutine TRACHO3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine DIIS_CPF(DPI,DPJ,BST,MIT,BIJ,ITP,CN)

use cpf_global, only: IADDP, IDIIS, IPRINT, ITPUL, Lu_CI, NCONF
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: MIT, ITP
real(kind=wp), intent(inout) :: DPI(*), BST(MIT,MIT)
real(kind=wp), intent(_OUT_) :: DPJ(*), CN(*)
real(kind=wp), intent(inout) :: BIJ(ITP,ITP)
integer(kind=iwp) :: I, IAD, ITM, J
real(kind=wp) :: T, WHS(50)
real(kind=r8), external :: DDOT_

if (ITPUL /= 1) then

  ITM = ITPUL-1
  BIJ(1:ITM,1:ITM) = BST(1:ITM,1:ITM)
  do I=1,ITPUL
    BIJ(ITP,I) = -One
    BIJ(I,ITP) = -One
  end do
  BIJ(ITP,ITP) = Zero

  do I=1,ITM
    IAD = IADDP(I+1)
    call dDAFILE(Lu_CI,2,DPJ,NCONF,IAD)
    T = DDOT_(NCONF,DPI,1,DPJ,1)
    BIJ(I,ITPUL) = T
    BIJ(ITPUL,I) = T
    BST(I,ITPUL) = T
    BST(ITPUL,I) = T
    if (I == 1) then
      T = DDOT_(NCONF,DPJ,1,DPJ,1)
      BIJ(1,1) = T
      BST(1,1) = T
    end if
  end do
  BIJ(ITPUL,ITPUL) = DDOT_(NCONF,DPI,1,DPI,1)
  BST(ITPUL,ITPUL) = BIJ(ITPUL,ITPUL)

  if (IPRINT >= 10) then
    do I=1,ITP
      write(u6,16) (BIJ(J,I),J=1,ITP)
    end do
  end if

end if

if (IDIIS /= 1) then
  do I=1,ITPUL
    IAD = IADDP(I)
    call dDAFILE(Lu_CI,2,DPJ,NCONF,IAD)
    do J=1,NCONF
      DPI(J) = DPI(J)+DPJ(J)
    end do
  end do
  if (IPRINT >= 15) write(u6,14) (DPI(I),I=1,NCONF)
else
  call DECOMP(ITP,BIJ)
  do I=1,ITPUL
    WHS(I) = Zero
  end do
  WHS(ITP) = -One
  call SOLVE(ITP,BIJ,WHS,CN)

  ! UPDATE P AND DELTA P

  call NEXT(DPI,DPJ,CN)

  ITPUL = 0
end if

return

14 format(6X,'C(DIIS)',5F10.6)
16 format(6X,'BIJ ',6F12.6)

end subroutine DIIS_CPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RRINT(K,ALFA,A,BETA,R0,GRINT,lmax)

use welcom, only: binom, fac, fiint, kmax
use Constants, only: Zero, One, Two, Three, Four, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: K, lMax
real(kind=wp), intent(in) :: Alfa, A, Beta, R0
real(kind=wp), intent(out) :: grint(0:lmax,lmax)
integer(kind=iwp) :: i, Ind, kk, l, ll, M, mm, mMax, n
real(kind=wp) :: AA, AA2, AA3, AA4, AA5, AExp, Al, bExp, bExp1, bExp2, Bi, Exp1, ExpA, FiIntM, ggg, Pi4, rri(0:kmax+2), Test, Tmp, &
                 Tmp1, Tmp2, Tmp3, Tmp4
real(kind=wp), external :: QRint

M = K+1
EXPA = -A*A*ALFA-BETA*R0*R0
AEXP = ALFA+BETA
BEXP1 = -Two*(BETA*R0+A*ALFA)/AEXP
BEXP2 = -Two*(BETA*R0-A*ALFA)/AEXP
if (A == Zero) then
  Test = Zero
else
  if (R0 == Zero) then
    Test = One
  else
    TEST = A*ALFA
  end if
end if

if (TEST >= 0.005_wp) then

  !write(u6,*) ' Large A'
  ! K=0 ONE CONTRIBUTION SS-INTEGRAL
  do i=0,k
    rri(i) = qrint(i+1,aexp,bexp1,expa)*real((-1)**i,kind=wp)-qrint(i+1,aexp,bexp2,expa)
  end do
  !call RecPrt(' In RRInt: rri',' ',rri,k+1,1)
  AL = One/(Two*ALFA*A)
  do i=0,k
    mmax = i/2
    do m=1,mmax+1
      ! calculate integral ri(i,m)
      fiintm = fiint(m-1,0)
      grint(i,m) = Zero
      do n=1,m
        Bi = binom(m-1,n-1)*real((-1)**(n+1),kind=wp)
        ind = i-(m-n)*2
        do kk=0,ind
          ggg = fac(ind)/fac(ind-kk)*al**(kk+1)
          grint(i,m) = grint(i,m)+bi*ggg*rri(i-kk)*fiintm
        end do
      end do
    end do
  end do

else

  !write(u6,*) ' SERIES EXPANSION FOR SMALL A'

  ! SERIES EXPANSION FOR SMALL A

  ! K=0 FIRST
  l = (k+1)/2
  EXP1 = -(ALFA*A*A+BETA*R0*R0)
  BEXP = -Two*BETA*R0/(ALFA+BETA)
  do i=0,l+2
    rri(i) = qrint(2*(i+1),AExp,BExp,Exp1)
  end do
  !call RecPrt(' rri',' ',rri,l+3,1)
  pi4 = pi*Four
  AA = Two*(A*Alfa)
  AA2 = Two*(A*Alfa)**2
  AA3 = Four*(A*Alfa)**3
  AA4 = Two*(A*Alfa)**4
  AA5 = Four*(A*Alfa)**5
  GRINT(0,1) = pi4*(rri(0)+AA2/Three*rri(1)+AA4/15.0_wp*rri(2))
  if (K == 0) return
  do ll=1,l
    do kk=1,ll+1

      tmp1 = fiint(kk-1,0)/fiint(0,0)
      tmp2 = real(2-2*kk,kind=wp)
      tmp = Zero
      do mm=0,kk-1
        tmp3 = tmp1*binom(kk-1,mm)*(-One)**mm
        tmp4 = tmp2+real(2*mm+1,kind=wp)
        tmp = tmp+tmp3*(One/(real(2*ll,kind=wp)+tmp4)*rri(ll)+AA2/(real(2*ll+2,kind=wp)+tmp4)*rri(ll+1)+ &
                        AA4/(Three*(real(2*ll+4,kind=wp)+tmp4))*rri(ll+2))
      end do
      Grint(ll*2,kk) = pi4*tmp

      if (kk == 1) cycle
      tmp1 = fiint(kk-2,0)/fiint(0,0)
      tmp = Zero
      do mm=1,kk-1
        tmp3 = tmp1*binom(kk-2,mm-1)*(-One)**(mm+1)
        tmp4 = tmp2+real(2*mm+1)
        tmp = tmp-tmp3*(AA/(real(2*ll,kind=wp)+tmp4)*rri(ll)+AA3/(Three*(real(2*ll+2,kind=wp)+tmp4))*rri(ll+1)+ &
                        AA5/(15.0_wp*(real(2*ll+4,kind=wp)+tmp4))*rri(ll+2))
      end do
      Grint(ll*2-1,kk-1) = pi4*tmp
      Grint(ll*2-1,kk) = Zero

    end do
  end do

end if

!call RecPrt(' In RRint:grint',' ',grint,1+lmax,lmax)

end subroutine RRINT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Setup_Aux(ip_SOShl,ip_ShlSO,ip_nBasSh,nIrrep,nBas,
     &                     nShell,nShell_Aux,nSO,ip_iSSOff,
     &                     TMax,CutOff,ip_iShij,nij_Shell,
     &                     nBas_Aux,nChV,iTOffs)
      use iSD_data
      use SOAO_Info, only: iSOInf
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "setup.fh"
#include "nsd.fh"
      Integer nBas(0:nIrrep-1), nBas_Aux(0:nIrrep-1),
     &        nChV(0:nIrrep-1), iTOffs(3,0:nIrrep-1)
      Real*8  TMax(nShell,nShell)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*) 'Setup_Aux:nIrrep:   ',nIrrep
      Write (6,*) 'Setup_Aux:nBas:     ',nBas
      Write (6,*) 'Setup_Aux:nBas_Aux: ',nBas_Aux
      Write (6,*) 'Setup_Aux:nChV:     ',nChV
#endif
*                                                                      *
************************************************************************
*                                                                      *
      nSO = 0
      nSO_Aux = 0
      Do iIrrep = 0, nIrrep-1
         nSO = nSO + nBas(iIrrep)
         nSO_Aux = nSO_Aux + nBas_Aux(iIrrep)
      End Do
*
      Call GetMem('SOShl','Allo','Integer',ip_SOShl,nSO+nSO_Aux)
      Call GetMem('ShlSO','Allo','Integer',ip_ShlSO,nSO+nSO_Aux)
      Call GetMem('nBasSh','Allo','Integer',ip_nBasSh,
     &            (nShell+nShell_Aux)*nIrrep)
*                                                                      *
************************************************************************
*                                                                      *
      Do iSO = 1, nSO+nSO_Aux
         iCnttp=iSOInf(1,iSO)
         iCnt  =iSOInf(2,iSO)
         iAng  =iSOInf(3,iSO)
C        Write (*,*) 'iCnttp,iCnt,iAng=',iCnttp,iCnt,iAng
*
*        Find the Shell from which this basis function is derived.
*
         Do iSkal = 1, nShell+nShell_Aux
            jCnttp=iSD(13,iSkal)
            jCnt  =iSD(14,iSkal)
            jAng  =iSD( 1,iSkal)
            If (jCnttp.eq.iCnttp .and.
     &          jCnt  .eq.iCnt   .and.
     &          jAng  .eq.iAng         ) Then
               iWork(ip_SOShl-1+iSO)=iSkal
C              Write (*,*) 'Found in shell=',iSkal
               Go To 99
            End If
         End Do
 99      Continue
      End Do
C     Call iVcPrt('SOShl',' ',iWork(ip_SOShl),nSO+nSO_Aux)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the number of effective shell pairs.
*
      TMax_ij=Zero
      Do iSkal = 1, nShell
         Do jSkal = 1, iSkal
            TMax_ij=Max(TMax_ij,TMax(iSkal,jSkal))
         End Do
      End Do
*
      nij_Shell=0
      Do iSkal = 1, nShell
         Do jSkal = 1, iSkal
            If (TMax(iSkal,jSkal)*TMax_ij.ge.CutOff) Then
               nij_Shell = nij_Shell + 1
            End If
         End Do
      End Do
      Call GetMem('Shij','Allo','Inte',ip_iShij,2*nij_Shell)
*
      ij_Shell = 0
      Do iSkal = 1, nShell
         Do jSkal = 1, iSkal
            If (TMax(iSkal,jSkal)*TMax_ij.ge.CutOff) Then
               ij_Shell = ij_Shell + 1
               iWork(ip_iShij+(ij_Shell-1)*2  )=iSkal
               iWork(ip_iShij+(ij_Shell-1)*2+1)=jSkal
#ifdef _DEBUGPRINT_
               Write (6,*) 'ij_Shell,iSkal,jSkal=',
     &                      ij_Shell,iSkal,jSkal
#endif
            End If
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      nSSOff = nIrrep**2 * nij_Shell
      Call GetMem('iSSOff','Allo','Integer',ip_iSSOff,nSSOff)
*                                                                      *
************************************************************************
*                                                                      *
*
      Call Setup_Aux_(iWork(ip_SOShl),nSO+nSO_Aux,iWork(ip_ShlSO),
     &                iWork(ip_nBasSh),nShell+nShell_Aux,nIrrep,nBas,
     &                iWork(ip_iSSOff),nij_Shell,iWork(ip_iShij),
     &                nBas_Aux,nChV,iTOffs)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*) 'ip_iShij=',ip_iShij
      Write (6,*) 'nij_Shell=',nij_Shell
      Write (6,*)
      Do ij_Shell = 1, nij_Shell
         Write (6,*) iWork(ip_iShij+(ij_Shell-1)*2  ),
     &               iWork(ip_iShij+(ij_Shell-1)*2+1)
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      Subroutine Setup_Aux_(iSOShl,nSO,iShlSO,nBasSh,nShell,nIrrep,nBas,
     &                      iSSOff,nij_Shell,iShij,nBas_Aux,nChV,iTOffs)
      Implicit Real*8 (a-h,o-z)
      Integer iSOShl(nSO), iShlSO(nSO), nBasSh(0:nIrrep-1,nShell),
     &        nBas(0:nIrrep-1), nBas_Aux(0:nIrrep-1), nChV(0:nIrrep-1),
     &        iSSOff(0:nIrrep-1,0:nIrrep-1,nij_Shell),
     &        iShij(2,nij_Shell), iTOffs(3,0:nIrrep-1), iTtmp(0:7)
*                                                                      *
************************************************************************
*                                                                      *
*     Generate index array for relative index within the shell and irrep
*
C     Call iVcPrt('iSOShl',' ',iSOShl,nSO)
      iSO = 0
      Do iIrrep = 0, nIrrep-1
         Do iShell = 1, nShell
*
            iSO_Shl = 0
            Do iBas = iSO+1 , iSO+nBas(iIrrep)
               If (iSOShl(iBas).eq.iShell) Then
                  iSO_Shl = iSO_Shl + 1
*                                                                      *
************************************************************************
*                                                                      *
*                 Save the relative index within the shell and irrep
*                 of a given absolute SO index.
*
                  iShlSO(iBas) = iSO_Shl
               End If
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*           Save the total number of basis functions a specific shell
*           has in a given irrep.
*
            nBasSh(iIrrep,iShell)=iSO_Shl
*                                                                      *
************************************************************************
*                                                                      *
         End Do
         iSO = iSO + nBas(iIrrep)
      End Do
*                                                                      *
************************************************************************
*
*     Initialize
*
      Call ICopy(3*nIrrep,[0],0,iTOffs,1)
      Call iCopy(nij_Shell*nIrrep**2,[0],0,iSSOff,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute offsets within the symmetry block for a fixed shell pair.
*
*     Note that for each pair of valence shells all the products which
*     are of the same irrep are consecutive.
*
*
      Do ijShell = 1, nij_Shell
         iShell = iShij(1,ijShell)
         jShell = iShij(2,ijShell)
         Call ICopy(nIrrep,[0],0,iTtmp,1)
*                                                                      *
************************************************************************
*                                                                      *
         If (iShell.gt.jShell) Then   ! iShell > jShell
*
            Do jIrrep = 0, nIrrep-1
               nB = nBasSh(jIrrep,jShell)
               Do iIrrep = 0, nIrrep-1
                  nA = nBasSh(iIrrep,iShell)
*
                  ijIrrep = iEor(iIrrep,jIrrep)
                  iSSOff(iIrrep,jIrrep,ijShell)=iTtmp(ijIrrep)
                  nab = na*nb
                  iTtmp(ijIrrep)=iTtmp(ijIrrep)+nab
*
               End Do
            End Do
*
         Else                        ! iShell = jShell
*
            Do iIrrep = 0, nIrrep-1
               nA = nBasSh(iIrrep,iShell)
               Do jIrrep = 0, iIrrep
                  nB = nBasSh(jIrrep,jShell)
*
                  ijIrrep = iEor(iIrrep,jIrrep)
                  iSSOff(iIrrep,jIrrep,ijShell)=iTtmp(ijIrrep)
                  iSSOff(jIrrep,iIrrep,ijShell)=iTtmp(ijIrrep)
                  nab = na*nb
                  If (iIrrep.eq.jIrrep) nab = na*(na+1)/2
                  iTtmp(ijIrrep) = iTtmp(ijIrrep) + nab
               End Do
            End Do
*
         End If
*
         Do iIrrep = 0, nIrrep-1
            iTOffs(3,iIrrep) = iTOffs(3,iIrrep) + iTtmp(iIrrep)
         End Do
*
*        Now update the index to be the total offset within a slice
*        for a fixed shell-pair
*
         iAcc = 0
         Do ijIrrep = 0, nIrrep-1
            Do iIrrep = 0, nIrrep-1
               jIrrep = iEor(ijIrrep,iIrrep)
               iSSOff(iIrrep,jIrrep,ijShell)=
     &                            iSSOff(iIrrep,jIrrep,ijShell)+iAcc
            End Do
            nI = nBas_Aux(ijIrrep)
            If (ijIrrep.eq.0) nI=nI-1
            iAcc = iAcc + nI*iTtmp(ijIrrep)
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      End Do
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*)  'iSSOff'
      Write (6,*)
      Do ijShell = 1, nij_Shell
         iShell = iShij(1,ijShell)
         jShell = iShij(2,ijShell)
         Write (6,*)
         Write (6,*) 'iShell,jShell=',iShell,jShell
         Write (6,*)
         Do i = 0, nIrrep-1
            Write (6,'(8I4)') (iSSOff(i,j,ijShell),j=0,nIrrep-1)
         End Do
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Set up pointers for the J12 matrix and compute total size of the
*     3-center integrals.
*
      iOff_V12=0
      Do iIrrep = 0, nIrrep-1
         iTOffs(1,iIrrep) = nChV(iIrrep) ! # of vectors
         nAux = nBas_Aux(iIrrep)
         If (iIrrep.eq.0) nAux = nAux - 1
         iTOffs(2,iIrrep) = iOff_V12
         iOff_V12 = iOff_V12 + nAux**2
      End Do
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Write (6,*)
      Write (6,*) ' iSO, iShlSO(iSO), relative index in irrep'
      Do jSO = 1, iSO
         Write (6,*) jSO, iShlSO(jSO)
      End Do
*
      Write (6,*)
      Write (6,*) ' iShell: number of basis functions in each irrep'
      Do iShell = 1, nShell
         Write (6,*) iShell,':',
     &         (nBasSh(iIrrep,iShell),iIrrep=0,nIrrep-1)
      End Do
      Write (6,*)
      Write (6,*)  'iSSOff'
      Write (6,*)
      Do ijShell = 1, nij_Shell
         iShell = iShij(1,ijShell)
         jShell = iShij(2,ijShell)
         Write (6,*)
         Write (6,*) 'iShell,jShell=',iShell,jShell
         Write (6,*)
         Do i = 0, nIrrep-1
            Write (6,'(8I4)') (iSSOff(i,j,ijShell),j=0,nIrrep-1)
         End Do
      End Do
      Write (6,*)
      Write (6,*)  'iTOffs'
      Write (6,*)
      Do i = 0, nIrrep-1
         Write (6,*) (iTOffs(j,i),j=1,3)
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989-1992, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine Alaska(LuSpool,ireturn)
!***********************************************************************
!                                                                      *
!  Object: Driver for the one and two electron integral gradient       *
!          program ALASKA.                                             *
!                                                                      *
!          Alaska is a derivative code of Seward 3.1.                  *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA     *
!          July '89 - May '90                                          *
!                                                                      *
!          Roland Lindh, Dept. of Theoretical Chemistry, University of *
!          Lund, SWEDEN. Modified to gradient calculations September   *
!          1991 - February 1992.                                       *
!***********************************************************************

use Alaska_Info, only: Am
use Basis_Info, only: dbsc, nCnttp
use Gateway_global, only: Onenly, Test
use RICD_Info, only: Do_RI, Cholesky
use Para_Info, only: nProcs, King
use OFembed, only: Do_OFemb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Ten, Half
use Definitions, only: wp, iwp, r8, u6

implicit none
integer(kind=iwp), intent(in) :: LuSpool
integer(kind=iwp), intent(out) :: ireturn
#include "Molcas.fh"
#include "disp.fh"
#include "print.fh"
#include "rctfld.fh"
#include "columbus_gamma.fh"
#include "nac.fh"
integer(kind=iwp) :: i, iCar, iCnt, iCnttp, iPrint, irlxroot1, irlxroot2, iRout, l1, mdc, nCnttp_Valence, ndc, nDiff, nsAtom
real(kind=wp) :: EDiff_f, EDiff_s, TCpu1, TCpu2, TWall1, TWall2
logical(kind=iwp) :: DoRys, Found
character(len=180) :: Label
real(kind=wp), allocatable :: Grad(:), Temp(:), Tmp(:), Rlx(:,:), CSFG(:)
integer(kind=iwp), external :: isFreeUnit
real(kind=r8), external :: dnrm2_
logical(kind=iwp), external :: RF_On
!*********** columbus interface ****************************************
integer(kind=iwp) :: Columbus, colgradmode, lcartgrd, iatom, icen, j
real(kind=wp), allocatable :: Cgrad(:,:)
character(len=LenIn5), allocatable :: CNames(:)
character(len=80) :: Lab

!                                                                      *
!***********************************************************************
!                                                                      *
!call Alaska_banner()

call CWTime(TCpu1,TWall1)
!                                                                      *
!***********************************************************************
!                                                                      *
! Prologue
!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 1
!                                                                      *
!***********************************************************************
!                                                                      *
! Print program header
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the input information as Seward dumped on INFO.

nDiff = 1
DoRys = .true.
call IniSew(DoRys,nDiff)
if (RF_On()) then
  if (NonEq_Ref) then
    call WarningMessage(2,'Error in Alaska')
    write(u6,*) 'NonEq=.True., invalid option'
    call Abend()
  end if
  call Init_RctFld(.false.,iCharge_Ref)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Input specific for the gradient calculation.

call Inputg(LuSpool)

!-- Since the input has changed some of the shell information
!   regenerate the tabulated shell information.

iPrint = nPrint(iRout)

call mma_allocate(Grad,lDisp(0),Label='Grad')
call mma_allocate(Temp,lDisp(0),Label='Temp')
Grad(:) = Zero

! remove LuSpool

call Close_LuSpool(LuSpool)

! identify a Columbus calculation
! Columbus=1
! colgradmode=0   standard gradient written to GRAD
! colgradmode=1   standard gradient written to Grad State1
! colgradmode=2   standard gradient written to Grad State1
! colgradmode=3   non-adiabatic coupling vector written to NADC

call Get_iScalar('Columbus',Columbus)
call Get_iScalar('colgradmode',colgradmode)

!-- Start computing the gradients
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute nuclear contributions.

if (king() .or. HF_Force) then

  ! per default NADC must not have nuclear contributions added

  if (NO_NUC .or. ((Columbus == 1) .and. (colgradmode == 3))) then
    write(u6,*) 'Skipping Nuclear Charge Contribution'
  else
    call DrvN1(Grad,Temp,lDisp(0))
    if (iPrint >= 15) then
      Lab = ' Total Nuclear Contribution'
      call PrGrad(Lab,Grad,lDisp(0),ChDisp)
    end if
  end if
end if

!iPrint = 16
!                                                                      *
!***********************************************************************
!                                                                      *
if (Do_OFemb) then
  ! RepNuc term to the Orbital-Free Embedding gradient
  call DrvN1_EMB(Grad,Temp,lDisp(0))
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. Test) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !-- Compute contribution due to the derivative of the one-
  !   electron hamiltonian and the contribution due the re-
  !   normalization.

  if ((nProcs <= 1) .or. Onenly) then
    call Drvh1(Grad,Temp,lDisp(0))
  end if
  if (Do_OFemb) then
    ! NucAtt term to the Orbital-Free Embedding gradient
    call Drvh1_EMB(Grad,Temp,lDisp(0))
  end if
  !Lab = 'Nuc + One-electron Contribution'
  !call PrGrad(Lab,Grad,lDisp(0),ChDisp)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute the DFT contribution to the gradient

  call DrvDFTg(Grad,Temp,lDisp(0))
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (.not. Onenly) then
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! DFT-type Orbital-Free Embedding term to the gradient

    if (Do_OFemb) call DrvEMBg(Grad,Temp,lDisp(0))
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    !-- Compute contribution due to 2-electron integrals.

    if (Cholesky .or. Do_RI) then
      if (Cholesky) then
        if (iPrint >= 6) write(u6,*) 'Cholesky-ERI gradients!'
      else
        if (iPrint >= 6) write(u6,*) 'RI-ERI gradients!'
      end if
      call Drvg1_RI(Grad,Temp,lDisp(0))
    else
      if (iPrint >= 6) write(u6,*) 'Conventional ERI gradients!'
      call Drvg1(Grad,Temp,lDisp(0))
    end if

    call DScal_(lDisp(0),Half,Temp,1)
    if (iPrint >= 15) then
      Lab = ' Two-electron Contribution'
      call PrGrad(Lab,Temp,lDisp(0),ChDisp)
    end if

    !-- Accumulate contribution to the gradient

    call GR_DArray(Grad,lDisp(0))
    call DaXpY_(lDisp(0),One,Temp,1,Grad,1)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call CWTime(TCpu2,TWall2)
  call SavTim(7,TCpu2-TCpu1,TWall2-TWall1)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !-- Apply the translational and rotational invariance of the energy.

  if (TRSymm) then
    if (iPrint >= 99) then
      call PrGrad(' Molecular gradients (no TR) ',Grad,lDisp(0),ChDisp)
      call RecPrt(' The A matrix',' ',Am,lDisp(0),lDisp(0))
    end if
    Temp(1:lDisp(0)) = Grad(1:lDisp(0))

    call dGeMV_('N',lDisp(0),lDisp(0),One,Am,lDisp(0),Temp,1,Zero,Grad,1)
    call mma_deallocate(Am)
  end if ! TRSymm
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !-- Equivalence option

  if (lEq) then
    do i=1,lDisp(0)
      if (IndxEq(i) /= i) Grad(i) = Grad(IndxEq(i))
    end do
  end if ! lEq
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
nCnttp_Valence = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux) exit
  nCnttp_Valence = nCnttp_Valence+1
end do

! f^AB is the "total derivative coupling"
! h^AB is the "CI derivative coupling"
! f^AB = <B|dA/dR> = h^AB/(E_A-E_B) + f_CSF^AB = -f^BA
! h^AB = <B|dH/dR|A> = h^BA
! f_CSF^AB = -f_CSF^BA
!
! Note that we store h^AB + f_CSF^AB*(E_A-E-B), or just h^AB if
! NOCSF was given, to avoid division by (nearly) zero

if (isNAC) then
  call PrGrad('CI derivative coupling ',Grad,lDisp(0),ChDisp)
  if (DoCSF) then
    call mma_Allocate(CSFG,lDisp(0),Label='CSFG')
    call CSFGrad(CSFG,lDisp(0))
    call PrGrad('CSF derivative coupling ',CSFG,lDisp(0),ChDisp)
    call daxpy_(lDisp(0),EDiff,CSFG,1,Grad,1)
    call mma_deallocate(CSFG)
  end if
  EDiff_s = max(One,Ten**(-floor(log10(abs(EDiff)))-4))
  EDiff_f = EDiff*EDiff_s
  write(u6,'(15X,A,ES13.6)') 'Energy difference: ',EDiff
  Label = ''
  if (EDiff_s > One) write(Label,'(A,ES8.1,A)') ' (divided by',EDiff_s,')'
  Label = 'Total derivative coupling'//trim(Label)
  call mma_allocate(Tmp,lDisp(0),Label='Tmp')
  Tmp(:) = Grad(:)/EDiff_f
  call PrGrad(trim(Label),Tmp,lDisp(0),ChDisp)
  write(u6,'(15X,A,F12.4)') 'norm: ',dnrm2_(lDisp(0),Tmp,1)
  call mma_deallocate(Tmp)
else if (iPrint >= 4) then
  if (HF_Force) then
    call PrGrad('Hellmann-Feynman Forces ',Grad,lDisp(0),ChDisp)
  else
    call PrGrad(' Molecular gradients',Grad,lDisp(0),ChDisp)
  end if
end if
if (isNAC) then
  ! For NAC, the sign is undefined (because the wave functions can
  ! change sign), check only absolute values
  call mma_allocate(Tmp,lDisp(0),Label='Tmp')
  Tmp(:) = abs(Grad(:))
  call Add_Info('Grad',Tmp,lDisp(0),6)
  call mma_deallocate(Tmp)
else
  call Add_Info('Grad',Grad,lDisp(0),6)
end if

!-- Molcas format

!-- Write gradient to runfile.
!
! Save the gradient

call Get_iScalar('Unique atoms',nsAtom)
l1 = 3*nsAtom
call mma_allocate(Rlx,3,nsAtom,Label='Rlx')
mdc = 0
ndc = 0
do iCnttp=1,nCnttp_Valence

  ! Skip gradients for pseudo atoms

  if (dbsc(iCnttp)%pChrg .or. (dbsc(iCnttp)%nFragType > 0) .or. dbsc(iCnttp)%Frag) then
    mdc = mdc+dbsc(iCnttp)%nCntr
  else
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      ndc = ndc+1
      do iCar=1,3
        if (InxDsp(mdc,iCar) /= 0) then
          Rlx(iCar,ndc) = Grad(InxDsp(mdc,iCar))
        else

          ! Put in explicit zero if gradient is zero by symmetry.

          Rlx(iCar,ndc) = Zero
        end if
      end do
    end do
  end if
end do
!
if (HF_Force) then
  call Put_dArray('HF-forces',Rlx,l1)
else if (Columbus == 1) then
  call Put_nadc(colgradmode,Rlx,l1)
else
  call Put_Grad(Rlx,l1)
end if
call mma_deallocate(Rlx)

!*********** columbus interface ****************************************
! print full cartesian gradient in Columbus format

if (Columbus == 1) then
  ! real*8 Cgrad(3,mxatom)
  ! character CNames(MxAtom)*9
  ! integer lcartgrd, iatom,icen,j
  call mma_allocate(CGrad,3,MxAtom,label='CGrad')
  call mma_allocate(CNames,MxAtom,label='CNames')
  call TrGrd_Alaska_(CGrad,CNames,Grad,lDisp(0),iCen)
  lcartgrd = 60
  lcartgrd = isFreeUnit(lcartgrd)
  call Molcas_Open(lcartgrd,'cartgrd')
  do IATOM=1,iCen
    write(60,1010) (CGrad(j,iatom),j=1,3)
  end do
  close(lcartgrd)
  call mma_deallocate(CGrad)
  call mma_deallocate(CNames)
end if

!-- At the end of the calculation free all memory to check for
!   corruption of the memory.

call mma_deallocate(Temp)
call mma_deallocate(Grad)

! Restore iRlxRoot if changed as set by the RASSCF module.

call qpg_iScalar('Relax CASSCF root',Found)
if (Found) then
  call Get_iScalar('Relax CASSCF root',irlxroot1)
  call qpg_iScalar('Relax Original root',Found)
  if (Found) then
    call Get_iScalar('Relax Original root',irlxroot2)
    if (iRlxRoot1 /= iRlxRoot2) then
      call Put_iScalar('Relax CASSCF root',irlxroot2)
      call Put_iScalar('NumGradRoot',irlxroot2)
    end if
  end if
end if

! Epilogue

call ClsSew()

if (iPrint >= 6) then
  call FastIO('STATUS')
end if

if (Test) then
  ireturn = 20
else
  ireturn = 0
end if

return

1010 format(3d15.6)

end subroutine Alaska

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Cho_P_getGV(numV,nSym)

      Implicit None
      Integer nSym, numV(nSym)
#include "cho_para_info.fh"

      If (Cho_Real_Par) Then
         Call Cho_P_getGV_P(numV,nSym)
      Else
         Call Cho_P_getGV_S(numV,nSym)
      End If

      End
*****************************************
      SUBROUTINE Cho_P_getGV_P(numV,nSym)

      Implicit None
      Integer nSym, numV(nSym)

#include "choglob.fh"

      Integer i

      Do i=1,nSym
         numV(i) = numCho_G(i)
      End Do

      End
*****************************************
      SUBROUTINE Cho_P_getGV_S(numV,mSym)

      Implicit None
      Integer mSym, numV(mSym)

#include "cholesky.fh"

      Integer i

      Do i=1,mSym
         numV(i) = numCho(i)
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PGet4(iCmp,iBas,jBas,kBas,lBas,iAO,iAOst,ijkl,PSO,nPSO,PSOPam,n1,n2,n3,n4,iPam,MapPam,mDim,Cred,nCred,Scr1,nScr1,Scr2, &
                 nScr2,PMax)
!***********************************************************************
!                                                                      *
!  Object: to assemble the index list of the batch of the 2nd order    *
!          density matrix.                                             *
!                                                                      *
!          The indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             January '92.                                             *
!             Modified from PGet2, October '92.                        *
!***********************************************************************

use SOAO_Info, only: iAOtSO, iOffSO
use pso_stuff, only: lSA
use Symmetry_Info, only: nIrrep
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iCmp(4), iBas, jBas, kBas, lBas, iAO(4), iAOst(4), ijkl, nPSO, n1, n2, n3, n4, mDim, nCred, &
                                 nScr1, nScr2
real(kind=wp), intent(out) :: PSO(ijkl,nPSO), PSOPam(n1,n2,n3,n4), iPam(n1+n2+n3+n4), MapPam(4,mDim), Cred(nCred), Scr1(nScr1,2), &
                              Scr2(nScr2), PMax
integer(kind=iwp) :: i1, i2, i3, i4, iAOi, iiBas(4), in1, in2, iS, iSO, iSOi, iSym(0:7), j, j1, j12, j123, j2, j3, j4, jAOj, jPam, &
                     jS, jSO, jSOj, jSym(0:7), k1, k2, k3, k4, kAOk, kS, kSO, kSOk, kSym(0:7), lAOl, lS, lSO, lSOl, lSym(0:7), &
                     MemSO2, nijkl, niSym, njSym, nkSym, nlSym, nPam(4,0:7), nPSOPam

! Prepare some data for Pam

iiBas(1) = iBas
iiBas(2) = jBas
iiBas(3) = kBas
iiBas(4) = lBas
nPSOPam = n1*n2*n3*n4

! Set up table with SO indices in iPam and a table
! with number of basis functions in each irrep in nPam.
! Observe that the SO index is only within a given irrep.

nPam(:,:) = 0
in1 = 0
do jPam=1,4
  in2 = 0
  do j=0,nIrrep-1
    do i1=1,iCmp(jPam)
      if (iAOtSO(iAO(jPam)+i1,j) > 0) then
        iSO = iAOtSO(iAO(jPam)+i1,j)+iAOst(jPam)
        nPam(jPam,j) = nPam(jPam,j)+iiBas(jPam)
        do iAOi=0,iiBas(jPam)-1
          iSOi = iSO+iAOi
          in2 = in2+1
          iPam(in1+in2) = real(iSOi,kind=wp)
          MapPam(jPam,iSOi+iOffSO(j)) = real(in2,kind=wp)
        end do
      end if
    end do
  end do
  in1 = in1+in2
end do

! Get the scrambled 2nd order density matrix

if (LSA) then
  call PTrans_sa(nPam,iPam,n1+n2+n3+n4,PSOPam,nPSOPam,Cred,nCred/2,Scr1(:,1),nScr1,Scr2,nScr2,Scr1(:,2),nScr1)
else
  call PTrans(nPam,iPam,n1+n2+n3+n4,PSOPam,nPSOPam,Cred,nCred,Scr1,nScr1,Scr2,nScr2)
end if

! Quadruple loop over elements of the basis functions angular description.
! Observe that we will walk through the memory in AOInt in a sequential way.

PMax = Zero
MemSO2 = 0
do i1=1,iCmp(1)
  niSym = 0
  do j=0,nIrrep-1
    if (iAOtSO(iAO(1)+i1,j) > 0) then
      iSym(niSym) = j
      niSym = niSym+1
    end if
  end do
  do i2=1,iCmp(2)
    njSym = 0
    do j=0,nIrrep-1
      if (iAOtSO(iAO(2)+i2,j) > 0) then
        jSym(njSym) = j
        njSym = njSym+1
      end if
    end do
    do i3=1,iCmp(3)
      nkSym = 0
      do j=0,nIrrep-1
        if (iAOtSO(iAO(3)+i3,j) > 0) then
          kSym(nkSym) = j
          nkSym = nkSym+1
        end if
      end do
      do i4=1,iCmp(4)
        nlSym = 0
        do j=0,nIrrep-1
          if (iAOtSO(iAO(4)+i4,j) > 0) then
            lSym(nlSym) = j
            nlSym = nlSym+1
          end if
        end do

        ! Loop over irreps which are spanned by the basis function.
        ! Again, the loop structure is restricted to ensure unique
        ! integrals.

        do is=0,niSym-1
          j1 = iSym(is)

          do js=0,njSym-1
            j2 = jSym(js)
            j12 = ieor(j1,j2)

            do ks=0,nkSym-1
              j3 = kSym(ks)
              j123 = ieor(j12,j3)
              do ls=0,nlSym-1
                j4 = lSym(ls)
                if (j123 /= j4) cycle

                MemSO2 = MemSO2+1

                ! Unfold the way the eight indices have been reordered.
                iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)+iOffSO(j1)
                jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)+iOffSO(j2)
                kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+iOffSO(j3)
                lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+iOffSO(j4)

                nijkl = 0
                do lAOl=0,lBas-1
                  lSOl = lSO+lAOl
                  k4 = int(MapPam(4,lSOl))
                  do kAOk=0,kBas-1
                    kSOk = kSO+kAOk
                    k3 = int(MapPam(3,kSOk))
                    do jAOj=0,jBas-1
                      jSOj = jSO+jAOj
                      k2 = int(MapPam(2,jSOj))
                      do iAOi=0,iBas-1
                        iSOi = iSO+iAOi
                        nijkl = nijkl+1
                        k1 = int(MapPam(1,iSOi))

                        ! Pick up the contribution.

                        PMax = max(PMax,abs(PSOPam(k1,k2,k3,k4)))
                        PSO(nijkl,MemSO2) = PSOPam(k1,k2,k3,k4)

                      end do
                    end do
                  end do
                end do

              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do
if (nPSO /= MemSO2) then
  call WarningMessage(2,'PGet4: nPSO /= MemSO2')
  call Abend()
end if

return

end subroutine PGet4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine susceptibility_pa( exch, nLoc, nCenter, nneq,
     &                            neqv, neq, nss, nexch, nTempMagn,
     &                            nT, Tmin, Tmax, XTexp,
     &                            eso, dipso, s_so, w, dipexch,
     &                            s_exch, T, R_LG, zJ, tinput,
     &                            XLM, ZLM, XRM, ZRM, iopt,
     &                            chiT_theta, doplot, mem )

c       chi*t ----------- the units are cgsemu: [ cm^3*k/mol ]
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)

      Integer, intent(in) :: nLoc, nCenter, nTempMagn, nT, mem
      Integer, intent(in) :: exch, nneq, neqv, iopt
      Integer, intent(in) :: neq(nneq), nss(nneq), nexch(nneq)

      Real(kind=8), intent(in) :: T(nT+nTempMagn)
      Real(kind=8), intent(in) :: W(exch)
      Real(kind=8), intent(in) :: eso(nneq,nLoc)
      Real(kind=8), intent(in) :: zJ
      Real(kind=8), intent(in) :: Tmin, Tmax
      Real(kind=8), intent(in) :: XTexp(nT+nTempMagn)
      Real(kind=8), intent(in) :: R_LG(nneq,neqv,3,3)
      Real(kind=8), intent(out):: chit_theta(nT+nTempMagn)
c contributions from local excited states, computed in the XT section:
      Real(kind=8), intent(out):: XLM( nCenter,nTempMagn,3,3)
      Real(kind=8), intent(out):: ZLM( nCenter,nTempMagn)
      Real(kind=8), intent(out):: XRM( nCenter,nTempMagn,3,3)
      Real(kind=8), intent(out):: ZRM( nCenter,nTempMagn)
      Logical, intent(in)       :: tinput, doplot
      ! BIG matrices:
      Complex(kind=8), intent(in) :: dipexch(3,exch,exch)
      Complex(kind=8), intent(in) ::  s_exch(3,exch,exch)
      Complex(kind=8), intent(in) :: dipso(nneq,3,nLoc,nLoc)
      Complex(kind=8), intent(in) ::  s_so(nneq,3,nLoc,nLoc)
#include "stdalloc.fh"

c local variables
      Real(kind=8), allocatable ::     chit_tens_l(:,:,:)
!                                       chit_tens_l( nneq,3,3)
      Real(kind=8), allocatable :: smu_chit_tens_l(:,:,:)
!                                   smu_chit_tens_l( nneq,3,3)
      Real(kind=8), allocatable ::  ss_chit_tens_l(:,:,:)
!                                    ss_chit_tens_l( nneq,3,3)
      Real(kind=8), allocatable ::     chit_tens_lr(:,:,:)
!                                       chit_tens_lr(nneq,3,3)
      Real(kind=8), allocatable :: smu_chit_tens_lr(:,:,:)
!                                   smu_chit_tens_lr(nneq,3,3)
      Real(kind=8), allocatable ::  ss_chit_tens_lr(:,:,:)
!                                    ss_chit_tens_lr(nneq,3,3)
      Real(kind=8), allocatable ::     chit_tens_ex(:,:)
!                                       chit_tens_ex(3,3)
      Real(kind=8), allocatable :: smu_chit_tens_ex(:,:)
!                                   smu_chit_tens_ex(3,3)
      Real(kind=8), allocatable ::  ss_chit_tens_ex(:,:)
!                                     ss_chit_tens_ex(3,3)
      Real(kind=8), allocatable ::     chit_tens_tot(:,:,:)
!                                       chit_tens_tot(nT+nTempMagn,3,3)
      Real(kind=8), allocatable :: smu_chit_tens_tot(:,:)
!                                   smu_chit_tens_tot(3,3)
      Real(kind=8), allocatable ::  ss_chit_tens_tot(:,:)
!                                    ss_chit_tens_tot(3,3)
      Real(kind=8), allocatable ::   chit_theta_tens(:,:,:)
!                                     chit_theta_tens(nT+nTempMagn,3,3)
      Real(kind=8), allocatable :: zstat_l(:)       !zstat_l( nneq)
      Real(kind=8), allocatable :: zstat_lr(:)      !zstat_lr(nneq)
      Real(kind=8), allocatable :: zstat_tot(:)
!                                   zstat_tot(nT+nTempMagn)
      Real(kind=8), allocatable :: chit(:)          !chit(nT+nTempMagn)
      Real(kind=8), allocatable :: chi_theta_1(:)
!                                   chi_theta_1(nT+nTempMagn)
      Real(kind=8), allocatable :: XL(:,:,:)        !XL(nCenter,3,3)
      Real(kind=8), allocatable :: ZL(:)            !ZL(nCenter)
      Real(kind=8), allocatable :: XR(:,:,:)        !XR(nCenter,3,3)
      Real(kind=8), allocatable :: ZR(:)            !ZR(nCenter)
      Real(kind=8), allocatable :: SMUR(:,:,:)      !SMUR(nCenter,3,3)
      Real(kind=8), allocatable :: SMUL(:,:,:)      !SMUL(nCenter,3,3)
      Real(kind=8), allocatable :: SSR(:,:,:)       !SSR( nCenter,3,3)
      Real(kind=8), allocatable :: SSL(:,:,:)       !SSL( nCenter,3,3)
      Real(kind=8), allocatable :: wt(:), zt(:,:)   !wt(3),zt(3,3)
      Real(kind=8), allocatable :: A_dir(:,:)               !A_dir(3,3)
      Real(kind=8), allocatable :: A_inv(:,:)               !A_inv(3,3)
      Real(kind=8), allocatable :: unity(:,:)               !unity(3,3)
      Real(kind=8) :: xxm
      Real(kind=8) :: zstat_ex
      Real(kind=8) :: boltz_k,coeff_chi
      Real(kind=8) :: det
      Real(kind=8) :: dev, Fa, Fb, Fc, Fd, Fe, Ff
      external dev
      Integer       :: i,iT,jT,ic,jc
      Integer       :: j,n1,n2,im,jm
      Integer       :: isite,info,mem_local,RtoB
      Logical       :: dbg
      Character(len=50) :: label
      Real(wp), external :: dnrm2_


      mem_local=0
      dbg=.false.
      RtoB=8
!     = n_a*mu_bohr^2/(k_boltz) in cm^3*k/mol
      coeff_chi=0.1250486120_wp*3.0_wp
      boltz_k=0.69503560_wp                    !   in cm^-1*k-1
!-----------------------------------------------------------------------
      If(dbg) Then
         Write(6,*) 'Verification of input data on entrance to PA-SUSC:'
         Write(6,*) 'exch:         ', exch
         Write(6,*) 'nLoc:         ', nLoc
         Write(6,*) 'nCenter:      ', nCenter
         Write(6,*) 'nneq:         ', nneq
         Write(6,*) 'neqv:         ', neqv
         Write(6,*) 'neq():        ', (neq(i),i=1,nneq)
         Write(6,*) 'nss():        ', (nss(i),i=1,nneq)
         Write(6,*) 'nexch():      ', (nexch(i),i=1,nneq)
         Write(6,*) 'nT:           ', nT
         Write(6,*) 'iopt:         ', iopt
         Write(6,*) 'mem:          ', mem
         Write(6,*) 'nTempMagn:    ', nTempMagn
         Write(6,*) 'Tmin:         ', Tmin
         Write(6,*) 'Tmax:         ', Tmax
         Write(6,*) 'XTexp():      ', (XTexp(i),i=1,nT+nTempMagn)
         Write(6,*) 'T():          ', (T(i),i=1,nT+nTempMagn)
         Write(6,*) 'chit_theta(): ', (chit_theta(i),i=1,nT+nTempMagn)
         Write(6,*) 'W()           ', (W(i),i=1,exch)
         Write(6,*) 'zJ:           ', zJ
         Write(6,*) 'tinput:       ', tinput
         Write(6,*) 'doplot:       ', doplot
!         Do i=1,nneq
!            Write(6,*) 'eso()         ', (eso(i,j),j=1,nss(i))
!            Call prMom('SUSC: input  s_so(i,:,:,:):', s_so(i,:,:,:),
!     &               nexch(i))
!            Call prMom('SUSC: input dipso(i,:,:,:):',dipso(i,:,:,:),
!     &               nexch(i))
!            gtens=0.0_wp
!            maxes=0.0_wp
!            Call atens(s_so(i,:,:,:), nexch(i), gtens, maxes, 2)
!            gtens=0.0_wp
!            maxes=0.0_wp
!            Call atens(dipso(i,:,:,:), nexch(i), gtens, maxes, 2)
!         End Do
!         Call prMom('SUSC: input  S_EXCH(l,i,j):', s_exch,exch)
!         Call prMom('SUSC: input DIPEXCH(l,i,j):',dipexch,exch)
!         gtens=0.0_wp
!         maxes=0.0_wp
!         Call atens(s_exch, exch, gtens, maxes, 2)
!         gtens=0.0_wp
!         maxes=0.0_wp
!         Call atens(dipexch, exch, gtens, maxes, 2)
!      change to pseudospin:
!        Call zcopy_(  exch*exch,[(0.0_wp,0.0_wp)],0,Z,1)
!        Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,dipexch2,1)
!        Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0, s_exch2,1)
!        Call zcopy_(3*exch*exch,dipexch,1,dipexch2,1)
!        Call zcopy_(3*exch*exch, s_exch,1, s_exch2,1)
!        Call pseudospin(dipexch2,exch,Z,3,1)

!        Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,dipexch,1)
!        Call zcopy_(3*exch*exch,[(0.0_wp,0.0_wp)],0,s_exch,1)
!        Call UTMU( exch, exch, Z, dipexch2, dipexch )
!        Call UTMU( exch, exch, Z, s_exch2, s_exch )

!        Call prMom('SUSC: input  S_EXCH2(l,i,j):', s_exch,exch)
!        Call prMom('SUSC: input DIPEXCH2(l,i,j):',dipexch,exch)
      End If ! dbg
!-----------------------------------------------------------------------
      Write(6,*)
      Write(6,'(100A)') (('%'),J=1,95)
      Write(6,'(35X,A)') 'CALCULATION OF THE MAGNETIC SUSCEPTIBILITY'
      Write(6,'(100A)') (('%'),J=1,95)
      Write(6,*)

      If(tinput) Then
         Write(6,'(2x,a)') 'Temperature dependence of the magnetic '//
     &                     'susceptibility and'
         Write(6,'(2x,a)') 'high-field magnetization will be '//
     &                     'calculated according to '
         Write(6,'(2x,a)') 'experimental values provided in the '//
     &                     'input.'
      Else
         Write(6,'(2x,a,i3,a)') 'Temperature dependence of the '//
     &                          'magnetic susceptibility will be '//
     &                          'calculated in',nT,' points, '
         Write(6,'(2x,a,f4.1,a,f6.1,a)') 'equally distributed in '//
     &                          'temperature range ',tmin,' ---',
     &                           tmax,' K.'
      End If
      Call XFlush(6)
!-----------------------------------------------------------------------
      Call mma_allocate(chit_tens_tot,(nT+nTempMagn),3,3,'XT_tens_tot')
      Call mma_allocate(chit_theta_tens,(nT+nTempMagn),3,3,'XT_theta_t')
      Call mma_allocate(chit_tens_l ,nneq,3,3,'XT_tens_l')
      Call mma_allocate(chit_tens_lr,nneq,3,3,'XT_tens_lr')
      Call mma_allocate(chit_tens_ex,3,3,'XT_tens_ex')
      Call mma_allocate(zstat_l,nneq,'Zstat_l')
      Call mma_allocate(zstat_lr,nneq,'Zstat_lr')
      mem_local=mem_local+(2+2*3*3)*nneq*RtoB+9*RtoB

      Call mma_allocate(ZR,nCenter,'ZR')
      Call mma_allocate(ZL,nCenter,'ZL')
      Call mma_allocate(XL,nCenter,3,3,'XL')
      Call mma_allocate(XR,nCenter,3,3,'XR')
      mem_local=mem_local+(5+2*3*3)*nCenter*RtoB

      Call mma_allocate(zstat_tot,(nT+nTempMagn),'Zstat_tot')
      Call mma_allocate(chiT,(nT+nTempMagn),'chiT')
      Call mma_allocate(chi_theta_1,(nT+nTempMagn),'chi_theta_1')
      mem_local=mem_local+(3+2*3*3)*(nT+nTempMagn)*RtoB


      Call dcopy_(3*3*(nT+nTempMagn),[0.0_wp],0,chit_tens_tot,1)
      Call dcopy_(3*3*(nT+nTempMagn),[0.0_wp],0,chit_theta_tens,1)
      Call dcopy_(    (nT+nTempMagn),[0.0_wp],0,zstat_tot,1)

      If (zJ == 0.0_wp) Then
         If(dbg) Write(6,*) 'SUSC:  memory allocated (local):'
         If(dbg) Write(6,*) 'mem_local=', mem_local
         If(dbg) Write(6,*) 'SUSC:  memory allocated (total):'
         If(dbg) Write(6,*) 'mem_total=', mem+mem_local

         Do iT=1,nT+nTempMagn
            ! initialize temporary variables:
            Call dcopy_(3*3,[0.0_wp],0,chit_tens_ex,1)
            Call dcopy_(nneq*3*3,[0.0_wp],0,chit_tens_l,1)
            Call dcopy_(nneq*3*3,[0.0_wp],0,chit_tens_lr,1)
            Call dcopy_(nneq,[0.0_wp],0,zstat_l,1)
            Call dcopy_(nneq,[0.0_wp],0,zstat_lr,1)
            Call dcopy_(nCenter,[0.0_wp],0,ZR,1)
            Call dcopy_(nCenter,[0.0_wp],0,ZL,1)
            Call dcopy_(3*3*nCenter,[0.0_wp],0,XL,1)
            Call dcopy_(3*3*nCenter,[0.0_wp],0,XR,1)
            zstat_ex=0.0_wp
c------------------------------------------------------------------------------------
cc  local susceptibility= total susceptibility coming from individual magnetic centers
            Do i=1, nneq
              If(dbg) Write(6,'(A,2I5)') 'nss(i)=',nss(i)
              If(dbg) Write(6,'(A,2I5)') 'nexch(i)=',nexch(i)
              If(dbg) Write(6,'(A,9F10.6)') 'eso(i,:)=',eso(i,1:nss(i))
              If(dbg) Write(6,'(A,9F10.6)') 'W(:)    =',W(1:exch)
              If(dbg) Write(6,'(A,9F10.6)') 'T(iT)=',T(iT)
              Call chi( dipso( i, 1:3, 1:nss(i), 1:nss(i) ),
     &                  dipso( i, 1:3, 1:nss(i), 1:nss(i) ),
     &                    eso( i, 1:nss(i)), nss(i), T(it),
     &                zstat_l( i), chit_tens_l(i,1:3,1:3) )

              Call chi( dipso( i, 1:3, 1:nexch(i), 1:nexch(i) ),
     &                  dipso( i, 1:3, 1:nexch(i), 1:nexch(i) ),
     &                    eso( i, 1:nexch(i)), nexch(i), T(iT),
     &               zstat_lr( i), chit_tens_lr(i,1:3,1:3) )

            End Do ! i (nneq)
            Call chi( dipexch, dipexch, W, exch, T(iT), zstat_ex,
     &                chit_tens_ex )

            Fa=0.0_wp; Fb=0.0_wp; Fc=0.0_wp; Fd=0.0_wp; Fe=0.0_wp;
            Fa=dnrm2_(9*nneq,chit_tens_l ,1)
            Fb=dnrm2_(9*nneq,chit_tens_lr,1)
            Fc=dnrm2_(9     ,chit_tens_ex,1)
            Fd=dnrm2_(nneq  ,zstat_l     ,1)
            Fe=dnrm2_(nneq  ,zstat_lr    ,1)
            Call Add_Info('XT:  chit_tens_l'   ,[Fa],1,6)
            Call Add_Info('XT:  chit_tens_lr'  ,[Fb],1,6)
            Call Add_Info('XT:  chit_tens_exch',[Fc],1,6)
            Call Add_Info('XT:  zstat_exch'    ,[zstat_ex],1,6)
            Call Add_Info('XT:  zstat_l'       ,[Fd],1,6)
            Call Add_Info('XT:  zstat_lr'      ,[Fe],1,6)
c expand the basis and rotate local tensors to the general
c coordinate system:
            isite=0
            Do i=1,nneq
               Do j=1,neq(i)
               isite=isite+1
               ZL(isite)=zstat_l(i)
               ZR(isite)=zstat_lr(i)
                  Do ic=1,3
                     Do jc=1,3
                        Do n1=1,3
                           Do n2=1,3
                           XL(isite,ic,jc)=XL(isite,ic,jc)+
     &                                     r_lg(i,j,ic,n1)*
     &                                     r_lg(i,j,jc,n2)*
     &                                     chit_tens_l(i,n1,n2)
                           XR(isite,ic,jc)=XR(isite,ic,jc)+
     &                                     r_lg(i,j,ic,n1)*
     &                                     r_lg(i,j,jc,n2)*
     &                                     chit_tens_lr(i,n1,n2)
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do

            Fa=0.0_wp; Fb=0.0_wp;
            Fa=dnrm2_(9*nCenter,XL,1)
            Fb=dnrm2_(9*nCenter,XR,1)
            Call Add_Info('XT:  XL',[Fa],1,6)
            Call Add_Info('XT:  XR',[Fb],1,6)
c save some data:
            If(it.le.nTempMagn) Then
               Call dscal_( 3*3*nCenter, coeff_chi, XR, 1 )
               Call dscal_( 3*3*nCenter, coeff_chi, XL, 1 )
               Call dcopy_( 3*3*nCenter, XR, 1, XRM(:,iT,:,:),1)
               Call dcopy_( 3*3*nCenter, XL, 1, XLM(:,iT,:,:),1)
               Call dcopy_(     nCenter, ZR, 1, ZRM(:,iT),1)
               Call dcopy_(     nCenter, ZL, 1, ZLM(:,iT),1)
            End If
            Call chi_sum( nCenter, chit_tens_ex, zstat_ex,
     &                    XL, ZL, XR, ZR, iopt,
     &                    chit_tens_tot(it,1:3,1:3), zstat_tot(it) )

            Fa=0.0_wp; Fb=0.0_wp;
            Fa=dnrm2_(nCenter,ZL,1)
            Fb=dnrm2_(nCenter,ZR,1)
            Call Add_Info('XT:  ZL',[Fa],1,6)
            Call Add_Info('XT:  ZR',[Fb],1,6)
            Call Add_Info('XT: ZEx',[zstat_ex],1,6)

            chit(it)=coeff_chi * ( chit_tens_tot(iT,1,1)
     &                            +chit_tens_tot(iT,2,2)
     &                            +chit_tens_tot(iT,3,3) )/3.0_wp
            chit_theta(iT)=chit(iT)

            If( abs(chit(iT)) < 1.0e-20_wp) Then
               chit(iT)=1.0e-20_wp
               chit_theta(iT)=1.0e-20_wp
            End If
            chi_theta_1(iT)=T(iT)/chit(iT)
            ! add some verification data:
            Fa=0.0_wp
            Fa=dnrm2_(9,chit_theta_tens(iT,1:3,1:3),1)
            Call Add_Info('XT: chit_theta_tens',[Fa],1,6)
         End Do ! iT
         Fb=0.0_wp;
         Fb=dnrm2_(nT+nTempMagn,T,1)
         Call Add_Info('XT: T',[Fb],1,6)

      Else ! i.e. when (zJ .ne. 0)

         ! allocate memory for temporary arrays:
         Call mma_allocate(smu_chit_tens_l,nneq,3,3,'smu_X_tens_l')
         Call mma_allocate(smu_chit_tens_lr,nneq,3,3,'smu_X_tens_lr')
         Call mma_allocate(smu_chit_tens_ex,3,3,'smu_chit_X_ex')
         Call mma_allocate(smu_chit_tens_tot,3,3,'SM_XT')
         Call mma_allocate(ss_chit_tens_l,nneq,3,3,'ss_chit_tens_l')
         Call mma_allocate(ss_chit_tens_lr,nneq,3,3,'ss_chit_tens_lr')
         Call mma_allocate(ss_chit_tens_ex,3,3,'ss_chit_tens_ex')
         Call mma_allocate(ss_chit_tens_tot,3,3,'SS_XT')
         Call mma_allocate(SMUR,nCenter,3,3,'SMUR')
         Call mma_allocate(SMUL,nCenter,3,3,'SMUL')
         Call mma_allocate(SSR,nCenter,3,3,'SSR')
         Call mma_allocate(SSL,nCenter,3,3,'SSL')
         Call mma_allocate(A_dir,3,3,'A_dir')
         Call mma_allocate(A_inv,3,3,'A_inv')
         Call mma_allocate(Unity,3,3,'Unity')
         mem_local=mem_local+4*3*3*(nCenter+nneq)*RtoB
         mem_local=mem_local+7*3*3*RtoB

         If(dbg) Write(6,*) 'SUSC:  memory allocated (local):'
         If(dbg) Write(6,*) 'mem_local=', mem_local
         If(dbg) Write(6,*) 'SUSC:  memory allocated (total):'
         If(dbg) Write(6,*) 'mem_total=', mem+mem_local

         Do iT=1,nT+nTempMagn
            ! initialization:
            Call dcopy_(     3*3   ,[0.0_wp],0,chit_tens_ex,1)
            Call dcopy_(     3*3   ,[0.0_wp],0,smu_chit_tens_ex,1)
            Call dcopy_(     3*3   ,[0.0_wp],0,ss_chit_tens_ex,1)
            Call dcopy_(nneq*3*3   ,[0.0_wp],0,chit_tens_l,1)
            Call dcopy_(nneq*3*3   ,[0.0_wp],0,smu_chit_tens_l,1)
            Call dcopy_(nneq*3*3   ,[0.0_wp],0,ss_chit_tens_l,1)
            Call dcopy_(nneq*3*3   ,[0.0_wp],0,chit_tens_lr,1)
            Call dcopy_(nneq*3*3   ,[0.0_wp],0,smu_chit_tens_lr,1)
            Call dcopy_(nneq*3*3   ,[0.0_wp],0,ss_chit_tens_lr,1)
            Call dcopy_(     3*3   ,[0.0_wp],0,smu_chit_tens_tot,1)
            Call dcopy_(     3*3   ,[0.0_wp],0,ss_chit_tens_tot,1)
            Call dcopy_(nneq       ,[0.0_wp],0,zstat_l,1)
            Call dcopy_(nneq       ,[0.0_wp],0,zstat_lr,1)
            Call dcopy_(nCenter    ,[0.0_wp],0,ZR,1)
            Call dcopy_(nCenter    ,[0.0_wp],0,ZL,1)
            Call dcopy_(nCenter*3*3,[0.0_wp],0,XL,1)
            Call dcopy_(nCenter*3*3,[0.0_wp],0,XR,1)
            Call dcopy_(nCenter*3*3,[0.0_wp],0,SMUR,1)
            Call dcopy_(nCenter*3*3,[0.0_wp],0,SMUL,1)
            Call dcopy_(nCenter*3*3,[0.0_wp],0,SSR,1)
            Call dcopy_(nCenter*3*3,[0.0_wp],0,SSL,1)
            Call dcopy_(        3*3,[0.0_wp],0,A_dir,1)
            Call dcopy_(        3*3,[0.0_wp],0,A_inv,1)
            Call dcopy_(        3*3,[0.0_wp],0,Unity,1)
            zstat_ex=0.0_wp
            det=0.0_wp
            Do ic=1,3
              unity(ic,ic)=1.0_wp
            End Do

            ! compute local tensors  L, and LR:
            Do i=1, nneq
               Call chi( dipso( i, 1:3, 1:nss(i), 1:nss(i) ),
     &                   dipso( i, 1:3, 1:nss(i), 1:nss(i) ),
     &                     eso( i, 1:nss(i)), nss(i), T(iT),
     &                 zstat_l( i), chit_tens_l(i,1:3,1:3) )

               Call chi(  s_so( i, 1:3, 1:nss(i), 1:nss(i) ),
     &                   dipso( i, 1:3, 1:nss(i), 1:nss(i) ),
     &                     eso( i, 1:nss(i)), nss(i), T(iT),
     &                 zstat_l( i), smu_chit_tens_l(i,1:3,1:3) )

               Call chi(  s_so( i, 1:3, 1:nss(i), 1:nss(i) ),
     &                    s_so( i, 1:3, 1:nss(i), 1:nss(i) ),
     &                     eso( i, 1:nss(i)), nss(i), T(iT),
     &                 zstat_l( i), ss_chit_tens_l(i,1:3,1:3) )

               Call chi( dipso( i, 1:3, 1:nexch(i), 1:nexch(i) ),
     &                   dipso( i, 1:3, 1:nexch(i), 1:nexch(i) ),
     &                     eso( i, 1:nexch(i)), nexch(i), T(iT),
     &                zstat_lr( i), chit_tens_lr(i,1:3,1:3) )

               Call chi(  s_so( i, 1:3, 1:nexch(i), 1:nexch(i) ),
     &                   dipso( i, 1:3, 1:nexch(i), 1:nexch(i) ),
     &                     eso( i, 1:nexch(i)), nexch(i), T(iT),
     &                zstat_lr( i), smu_chit_tens_lr(i,1:3,1:3) )

               Call chi(  s_so( i, 1:3, 1:nexch(i), 1:nexch(i) ),
     &                    s_so( i, 1:3, 1:nexch(i), 1:nexch(i) ),
     &                     eso( i, 1:nexch(i)), nexch(i), T(iT),
     &                zstat_lr( i), ss_chit_tens_lr(i,1:3,1:3) )
            End Do ! i (nneq)

            ! compute exchange tensors:
            Call chi( dipexch, dipexch, W, exch, T(it), zstat_ex,
     &                     chit_tens_ex )
            Call chi(  s_exch, dipexch, W, exch, T(iT), zstat_ex,
     &                 smu_chit_tens_ex )
            Call chi(  s_exch,  s_exch, W, exch, T(iT), zstat_ex,
     &                  ss_chit_tens_ex )
c expand the basis and rotate local tensors to the general
c coordinate system:
            isite=0
            Do i=1,nneq
               Do j=1,neq(i)
               isite=isite+1
               ZL(isite)=zstat_l(i)
               ZR(isite)=zstat_lr(i)
!              use R_lg matrices, which have arbitrary determinant:  +1  or -1;
!              reason:  X_ab is a bi-dimensional tensor.
!                       We need to rotate twice ==> the sign of R does not
!                       matter (+1 * +1) = (-1 * -1)
!               >> R_rot matrices have determinant strict +1, and are used to
!                       rotate vectors
                  Do ic=1,3
                     Do jc=1,3
                        Do n1=1,3
                           Do n2=1,3
                           XR(isite,ic,jc)=XR(isite,ic,jc)+
     &                                     r_lg(i,j,ic,n1)*
     &                                     r_lg(i,j,jc,n2)*
     &                                     chit_tens_lr(i,n1,n2)
                           XL(isite,ic,jc)=XL(isite,ic,jc)+
     &                                     r_lg(i,j,ic,n1)*
     &                                     r_lg(i,j,jc,n2)*
     &                                     chit_tens_l(i,n1,n2)

                         SMUL(isite,ic,jc)=SMUL(isite,ic,jc)+
     &                                     r_lg(i,j,ic,n1)*
     &                                     r_lg(i,j,jc,n2)*
     &                                     smu_chit_tens_l(i,n1,n2)
                         SMUR(isite,ic,jc)=SMUR(isite,ic,jc)+
     &                                     r_lg(i,j,ic,n1)*
     &                                     r_lg(i,j,jc,n2)*
     &                                     smu_chit_tens_lr(i,n1,n2)

                         SSL(isite,ic,jc)=SSL(isite,ic,jc)+
     &                                    r_lg(i,j,ic,n1)*
     &                                    r_lg(i,j,jc,n2)*
     &                                    ss_chit_tens_l(i,n1,n2)
                         SSR(isite,ic,jc)=SSR(isite,ic,jc)+
     &                                    r_lg(i,j,ic,n1)*
     &                                    r_lg(i,j,jc,n2)*
     &                                    ss_chit_tens_lr(i,n1,n2)
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do

            ! add verification data:
            Fa=0.0_wp; Fb=0.0_wp; Fc=0.0_wp; Fd=0.0_wp; Fe=0.0_wp;
            Ff=0.0_wp;
            Fa=dnrm2_(9*nCenter,XR  ,1)
            Fb=dnrm2_(9*nCenter,XL  ,1)
            Fc=dnrm2_(9*nCenter,SMUL,1)
            Fd=dnrm2_(9*nCenter,SMUR,1)
            Fe=dnrm2_(9*nCenter,SSL,1)
            Ff=dnrm2_(9*nCenter,SSR,1)
            Call Add_Info('XT:    XR',[Fa],1,6)
            Call Add_Info('XT:    XL',[Fb],1,6)
            Call Add_Info('XT:  SMUL',[Fc],1,6)
            Call Add_Info('XT:  SMUR',[Fd],1,6)
            Call Add_Info('XT:   SSL',[Fe],1,6)
            Call Add_Info('XT:   SSR',[Ff],1,6)

c save some data:
            If(iT.le.nTempMagn) Then
               Call dscal_( 3*3*nCenter, coeff_chi, XR, 1 )
               Call dscal_( 3*3*nCenter, coeff_chi, XL, 1 )
               Call dcopy_( 3*3*nCenter, XR, 1, XRM(:,iT,:,:),1)
               Call dcopy_( 3*3*nCenter, XL, 1, XLM(:,iT,:,:),1)
               Call dcopy_(     nCenter, ZR, 1, ZRM(:,iT),1)
               Call dcopy_(     nCenter, ZL, 1, ZLM(:,iT),1)
            End If
c
            ! compute total tensors:
            Call chi_sum( nCenter, chit_tens_ex, zstat_ex,
     &                    XL,   ZL,   XR, ZR, iopt,
     &                    chit_tens_tot(iT,1:3,1:3),     zstat_tot(iT) )

            Call chi_sum( nCenter, smu_chit_tens_ex, zstat_ex,
     &                    SMUL, ZL, SMUR, ZR, iopt,
     &                    smu_chit_tens_tot, zstat_tot(iT) )

            Call chi_sum( nCenter, ss_chit_tens_ex, zstat_ex,
     &                    SSL,  ZL,  SSR, ZR, iopt,
     &                    ss_chit_tens_tot,  zstat_tot(iT) )

            ! form the A_dir matrix:
            ! A_dir(:,:) = 1(:,:)* kB * T(iT) - zJ*XSS(:,:)
            Call daxpy_(3*3,Boltz_k*T(iT),Unity,1,A_dir,1)
            Call daxpy_(3*3,          -zJ, ss_chit_tens_tot,1,A_dir,1)
            ! invert it:
            Call REVERSE(A_dir,A_inv,DET)
            Do ic=1,3
              Do jc=1,3
                xxm=0.0_wp
                Do im=1,3
                  Do jm=1,3
                    xxm=xxm+smu_chit_tens_tot(im,ic)*a_inv(im,jm)*
     &                      smu_chit_tens_tot(jm,jc)
                  End Do
                End Do
                chit_theta_tens(iT,ic,jc)=chit_tens_tot(iT,ic,jc)+zj*xxm
              End Do ! jc
            End Do ! ic

            chit(iT)=coeff_chi * ( chit_tens_tot(iT,1,1)
     &                           + chit_tens_tot(iT,2,2)
     &                           + chit_tens_tot(iT,3,3) )/3.0_wp

            chit_theta(iT)=coeff_chi * ( chit_theta_tens(iT,1,1)
     &                                + chit_theta_tens(iT,2,2)
     &                                + chit_theta_tens(iT,3,3) )/3.0_wp
            If( abs(chit(iT)) < 1.0d-20) Then
               chit(iT)=1.d-20
               chit_theta(iT)=1.d-20
            End If
            If( abs(chit_theta(iT)) < 1.0d-20) Then
               chit_theta(iT)=1.d-20
            End If

            chi_theta_1(iT)=t(iT)/chit_theta(iT)

            ! add some verification data:
            Fa=0.0_wp; Fb=0.0_wp; Fc=0.0_wp; Fd=0.0_wp; Fe=0.0_wp;
            Ff=0.0_wp;
            Fa=dnrm2_(9,    chit_tens_tot(it,1:3,1:3),1)
            Fb=dnrm2_(9,  chit_theta_tens(it,1:3,1:3),1)
            Fc=dnrm2_(9,smu_chit_tens_tot(1:3,1:3),1)
            Fd=dnrm2_(9, ss_chit_tens_tot(1:3,1:3),1)

            Call Add_Info('XT: chit_tens_tot'    ,[Fa],1,6)
            Call Add_Info('XT: chit_theta_tens'  ,[Fb],1,6)
            Call Add_Info('XT: smu_chit_tens_tot',[Fc],1,6)
            Call Add_Info('XT:  ss_chit_tens_tot',[Fd],1,6)
         End Do ! it
         Fb=0.0_wp;
         Fb=dnrm2_(nT+nTempMagn,T,1)
         Call Add_Info('XT: T',[Fb],1,6)

         Call mma_deallocate(smu_chit_tens_l)
         Call mma_deallocate(smu_chit_tens_lr)
         Call mma_deallocate(smu_chit_tens_ex)
         Call mma_deallocate(smu_chit_tens_tot)
         Call mma_deallocate(ss_chit_tens_l)
         Call mma_deallocate(ss_chit_tens_lr)
         Call mma_deallocate(ss_chit_tens_ex)
         Call mma_deallocate(ss_chit_tens_tot)
         Call mma_deallocate(SMUR)
         Call mma_deallocate(SMUL)
         Call mma_deallocate(SSR)
         Call mma_deallocate(SSL)
         Call mma_deallocate(A_dir)
         Call mma_deallocate(A_inv)
         Call mma_deallocate(Unity)

      End If  !zJ
c------------------------------------------------------------------------------------
c printing the results
      Do iT=1,nT+nTempMagn
        Do ic=1,3
          Do jc=1,3
             chit_tens_tot(iT,ic,jc)  =coeff_chi*
     &                                         chit_tens_tot(iT,ic,jc)
             If(zJ.ne.0.0_wp) Then
             chit_theta_tens(iT,ic,jc)=coeff_chi*
     &                                       chit_theta_tens(iT,ic,jc)
             End If
          End Do
        End Do
      End Do
      Write(6,*)
      Write(6,'(A)') '----------------------------------------------'//
     & '------------------------------------------|'
      Write(6,'(A)') '     |     T      | Statistical |    CHI*T    '//
     & '|    CHI*T    |     CHI     |    1/CHI    |'
      Write(6,'(A)') '     |            |  Sum (Z)    |    (zJ=0)   '//
     & '|             |             |             |'
      Write(6,'(A)') '-----|----------------------------------------'//
     & '------------------------------------------|'
      Write(6,'(A)') 'Units|   Kelvin   |    ---      |  cm3*K/mol  '//
     & '|  cm3*K/mol  |   cm3/mol   |   mol/cm3   |'
      Write(6,'(A)') '-----|----------------------------------------'//
     & '------------------------------------------|'

      Do iT=1,nT
      jT=iT+nTempMagn
      Write(6,'(A,F11.6,A,E12.5,A,F12.8,A,F12.8,A,E12.5,A,E12.5,A)')
     & '     |',         T(jT),       ' |',  zstat_tot(jT),
     &     ' |',      chiT(jT),       ' |', chiT_theta(jT),
     &     ' |',chit_theta(jT)/T(jT), ' |',chi_theta_1(jT),' |'
      End Do
      Write(6,'(A)') '-----|----------------------------------------'//
     & '------------------------------------------|'
      Fb=0.0_wp;
      Fb=dnrm2_(nT+nTempMagn,chiT,1)
      Call Add_Info('XT: T',[Fb],1,6)
      Fa=0.0_wp;
      Fa=dnrm2_(nT+nTempMagn,chiT_theta,1)
      Call Add_Info('XT: CHIT_THETA',[Fa],1,6)
      Fa=0.0_wp;
      Fa=dnrm2_(nT+nTempMagn,zstat_tot,1)
      Call Add_Info('XT: CHIT_THETA',[Fa],1,6)
c  calcualtion of the standard deviation:
      If (tinput) Then
         Write(6,'(a,5x, f20.14)') 'ST.DEV.CHIT:',
     &        dev( nT, chit_theta( (1+nTempMagn):(nT+nTempMagn) ),
     &                      XTexp( (1+nTempMagn):(nT+nTempMagn) )  )
      End If !tinput


!-------------------------  PLOTs -------------------------------------!
      WRITE(label,'(A)') "no_field"
      IF ( DoPlot ) THEN
         IF ( tinput ) THEN
            Call plot_XT_with_Exp(label, nT,
     &                          T((1+nTempMagn):(nT+nTempMagn) ),
     &                 chit_theta((1+nTempMagn):(nT+nTempMagn) ),
     &                      XTexp((1+nTempMagn):(nT+nTempMagn) ), zJ )
         ELSE
            Call plot_XT_no_Exp( label, nT,
     &                          T((1+nTempMagn):(nT+nTempMagn) ),
     &                 chit_theta((1+nTempMagn):(nT+nTempMagn) ), zJ )
         END IF
      END IF
! ------------------------- END PLOTs -------------------------------------!




c print out the main VAN VLECK SUSCEPTIBILITY TENSOR, its main values and main axes:
      Call mma_allocate(wt,3,'wt')
      Call mma_allocate(zt,3,3,'zt')
      If( zJ==0.0_wp ) Then
        Write(6,'(/)')
        Write(6,'(111A)') ('-',i=1,110),'|'
        Write(6,'(31X,A,22x,A)') 'VAN VLECK SUSCEPTIBILITY TENSOR '//
     &                           'FOR zJ = 0,  in cm3*K/mol','|'
        Write(6,'(111A)') ('-',i=1,110),'|'
        Write(6,'(A)') '     T(K)   |   |          Susceptibility '//
     &                 'Tensor      |    Main Values  |           '//
     &                 '    Main Axes             |'
        Do iT=1,nT
          jT=iT+nTempMagn
          info=0
          Call dcopy_(  3,[0.0_wp],0,wt,1)
          Call dcopy_(3*3,[0.0_wp],0,zt,1)
          Call DIAG_R2( chit_tens_tot(jT,:,:) ,3,info,wt,zt)
          Write(6,'(A)') '------------|---|'//
     &                   '------- x --------- y --------- z ---|'//
     &                   '-----------------|'//
     &                   '------ x --------- y --------- z ----|'
          Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                   '            | x |',
     &                    (chit_tens_tot(jT,1,j),j=1,3),
     &                   ' |  X:',wt(1),'|',(zt(j,1),j=1,3),'|'
          Write(6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),
     &                               '| y |',
     &                    (chiT_tens_tot(jT,2,j),j=1,3),
     &                   ' |  Y:',wt(2),'|',(zt(j,2),j=1,3),'|'
          Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                   '            | z |',
     &                    (chiT_tens_tot(jT,3,j),j=1,3),
     &                   ' |  Z:',wt(3),'|',(zt(j,3),j=1,3),'|'
        End Do
        Write(6,'(111A)') ('-',i=1,110),'|'

      Else ! zJ .ne. 0.0_wp

        Write(6,'(/)')
        Write(6,'(111A)') ('-',i=1,110),'|'

        Write(6,'(31X,A,F9.6,A,15x,A)') 'VAN VLECK SUSCEPTIBILITY '//
     &                                'TENSOR FOR zJ =',zJ,
     &                                ',  in cm3*K/mol','|'
        Write(6,'(111A)') ('-',i=1,110),'|'
        Write(6,'(A)') '     T(K)   |   |          Susceptibility '//
     &                 'Tensor      |    Main Values  |           '//
     &                 '    Main Axes             |'
        Do iT=1,nT
          jT=iT+nTempMagn
          info=0
          Call dcopy_(  3,[0.0_wp],0,wt,1)
          Call dcopy_(3*3,[0.0_wp],0,zt,1)
          Call DIAG_R2( chit_theta_tens(jT,:,:) ,3,info,wt,zt)
          Write(6,'(A)') '------------|---|'//
     &                   '------- x --------- y --------- z ---|'//
     &                   '-----------------|'//
     &                   '------ x --------- y --------- z ----|'

          Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                   '            | x |',
     &                    (chit_theta_tens(jT,1,j),j=1,3),
     &                   ' |  X:',wt(1),'|',(zt(j,1),j=1,3),'|'
          Write(6,'(F11.6,1x,A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)') T(jT),
     &                               '| y |',
     &                    (chiT_theta_tens(jT,2,j),j=1,3),
     &                   ' |  Y:',wt(2),'|',(zt(j,2),j=1,3),'|'
          Write(6,'(A,3F12.6,A,F12.6,1x,A,3F12.8,1x,A)')
     &                   '            | z |',
     &                    (chiT_theta_tens(jT,3,j),j=1,3),
     &                   ' |  Z:',wt(3),'|',(zt(j,3),j=1,3),'|'
        End Do
        Write(6,'(111A)') ('-',i=1,110),'|'
      End If
      Call mma_deallocate(wt)
      Call mma_deallocate(zt)

      Call mma_deallocate(chit_tens_tot)
      Call mma_deallocate(chit_theta_tens)
      Call mma_deallocate(chit_tens_l)
      Call mma_deallocate(chit_tens_lr)
      Call mma_deallocate(chit_tens_ex)
      Call mma_deallocate(zstat_l)
      Call mma_deallocate(zstat_lr)
      Call mma_deallocate(zstat_tot)
      Call mma_deallocate(ZR)
      Call mma_deallocate(ZL)
      Call mma_deallocate(XL)
      Call mma_deallocate(XR)
      Call mma_deallocate(chiT)
      Call mma_deallocate(chi_theta_1)

      Go To 190
c------------------------------------------------------------------------------------
      Write(6,*)
      Write(6,'(5x,a)') 'on user request, the magnetic '//
     &                  'susceptibility and '
      Write(6,'(5x,a)') 'the magnetic susceptibility '//
     &                  'tensor were not calculated.'
      Write(6,*)
  190 continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function iChxyz(Coord,iGen,nGen)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Coord(3)
      Integer iGen(nGen), iChCar(3)
*
*     Call RecPrt('iChxyz: Coord',' ',Coord,1,3)
      Call ChCar(iChCar,iGen,nGen)
*     Write (*,*) 'iChxyz: iChCar=',iChCar
      iChxyz=0
      Do iCar = 1, 3
         If (Coord(iCar).ne.Zero) iChxyz = iChxyz + iChCar(iCar)
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine foutij_cvb(fij,ni,nj,a1,a2)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ni, nj
real(kind=wp), intent(in) :: fij(ni,nj)
character(len=*), intent(in) :: a1, a2
character(len=46) :: b2
character(len=15) :: b1
character(len=12) :: b3
integer(kind=iwp) :: i, ichar0, ichar9, ipos, j, jpos
logical(kind=iwp) :: done
real(kind=wp), parameter :: hge = 1.0e20_wp

b1 = a1
b2 = a2
b3 = '     ......'
write(u6,'(/,1x,3a)') b1,b2,b3
b2 = ' '
! Find IPOS/JPOS : position of I/J indices in string
ichar0 = ichar('0')
ichar9 = ichar('9')
done = .false.
do jpos=15,1,-1
  if ((ichar(b1(jpos:jpos)) >= ichar0) .and. (ichar(b1(jpos:jpos)) <= ichar9)) then
    done = .true.
    exit
  end if
end do
if (.not. done) then
  write(u6,*) ' Fatal error in FOUTIJ!'
  call abend_cvb()
end if
done = .false.
do ipos=jpos-1,1,-1
  if ((ichar(b1(ipos:ipos)) >= ichar0) .and. (ichar(b1(ipos:ipos)) <= ichar9)) then
    done = .true.
    exit
  end if
end do
if (.not. done) then
  write(u6,*) ' Fatal error in FOUTIJ!'
  call abend_cvb()
end if
do j=1,nj
  do i=1,ni
    if (abs(fij(i,j)) /= hge) then
      write(b1(ipos:ipos),'(i1)') i
      write(b1(jpos:jpos),'(i1)') j
      write(b3,'(es12.4)') fij(i,j)
      write(u6,'(1x,3a)') b1,b2,b3
    end if
  end do
end do

return

end subroutine foutij_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Roland Lindh                                     *
*               2000, Valera Veryazov                                  *
*               2014, Thomas Dresselhaus                               *
************************************************************************
      Subroutine MOEval(MOValue,nMOs,nCoor,CCoor,CMOs,nCMO,DoIt,
     &                  nDrv,mAO)
************************************************************************
*      Author:Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN. November 1995                           *
*                                                                      *
*      Modified: Thomas Dresselhaus, March 2014                        *
*                Added ability to calculate 2nd derivative as well     *
************************************************************************
      use Real_Spherical
      use Basis_Info
      use Center_Info
      use Phase_Info
      use Sizes_of_Seward, only:S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
      Real*8 A(3),Ccoor(3,nCoor),RA(3)
      Integer DoIt(nMOs)
      Integer nDrv ! Between 0 and 2. The highest derivative to be calc.
      Integer mAO  ! Memory slots per point and basis functions. Should
                   ! be >=1 for nDrv=0, >=4 for nDrv=1, >=10 for nDrv=2.
      Real*8 MOValue(mAO,nCoor,nMOs),CMOs(nCMO)
*
*     Statement functions
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 112
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Write (6,*) ' In MOEval'
      End If
      call dcopy_(mAO*nCoor*nMOs,[Zero],0,MOValue,1)
*
*     Loop over shells.
*
      iSkal=0
      Thr=0.0D0

      Do iAng = S%iAngMx , 0, -1

         If (S%MaxPrm(iAng).eq.0) goto 100
         If (S%MaxBas(iAng).eq.0) goto 100
*
*        Scratch area for contraction step
*
         nScr1 =  S%MaxPrm(iAng)* nElem(iAng)
         Call GetMem('Scrtch','ALLO','REAL',iScrt1,nScr1)
*
*        Scratch area for the transformation to spherical gaussians
*
         nScr2=S%MaxPrm(iAng)*nElem(iAng)
         Call GetMem('ScrSph','Allo','Real',iScrt2,nScr2)
*
*        Loop over basis sets. Skip if basis set do not include
*        angular momentum functions as specified above.
*
         iAOttp=0
         mdc = 0
         Do iCnttp = 1, nCnttp

            nTest = dbsc(iCnttp)%nVal
            If (iAng+1.gt.nTest)  Go To 101
            If (dbsc(iCnttp)%Aux) Go To 101
            If (dbsc(iCnttp)%Frag) Go To 101
            nCnt = dbsc(iCnttp)%nCntr
            iShll = dbsc(iCnttp)%iVal + iAng
            iPrim = Shells(iShll)%nExp
            If (iPrim.eq.0) Go To 101
            iBas  = Shells(iShll)%nBasis
            If (iBas.eq.0) Go To 101
            If (Shells(iShll)%Prjct ) Then
               iCmp = 2*iAng+1
            Else
               iCmp  = nElem(iAng)
            End If

            Call OrdExpD2C(iPrim,Shells(iShll)%Exp,iBas,
     &                           Shells(iShll)%pCff)
            kSh=dbsc(iCnttp)%iVal+iAng
*
*           Compute the total number of function for this
*           basis set, summed over all shells.
*
            Do jAng = 0, nTest-1
               jShll = dbsc(iCnttp)%iVal + jAng
               If (Shells(jShll)%Prjct ) Then
                  jCmp = 2*jAng+1
               Else
                  jCmp  = nElem(jAng)
               End If
            End Do
*
*           Loop over unique centers of basis set "iCnttp"
*
            Do iCnt = 1, nCnt

               iAO = iAOttp + (iCnt-1)*dbsc(iCnttp)%lOffAO
     &             + Shells(kSh)%kOffAO
               A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)

               Do jAng = 0, iAng-1
                  jShll = dbsc(iCnttp)%iVal + jAng
                  If (Shells(jShll)%Prjct ) Then
                     jCmp = 2*jAng+1
                  Else
                     jCmp  = nElem(jAng)
                  End If
               End Do
*
*--------------Allocate memory for SO and AO values
*
               mRad     = nDrv + 1

               nForm    = 0
               Do iDrv  = 0, nDrv
                 nForm = nForm + nElem(iDrv)
               End Do
               nTerm    = 2**nDrv


               nAO=(iCmp*iBas*nCoor)*(mAO)
               nSO=nAO*nIrrep/dc(mdc+iCnt)%nStab
               nDeg=nIrrep/dc(mdc+iCnt)%nStab
               Call GetMem('AOs','Allo','Real',ipAOs,nAO)
               Call GetMem('SOs','Allo','Real',ipSOs,nSO)
               call dcopy_(nSO,[Zero],0,Work(ipSOs),1)
               nxyz=nCoor*3*(iAng+mRad)
               Call GetMem('xyz','Allo','Real',ipxyz,nxyz)
               ntmp=nCoor
               Call GetMem('tmp','Allo','Real',iptmp,ntmp)
               nRadial=iBas*nCoor*mRad
               Call GetMem('Radial','Allo','Real',ipRadial,nRadial)

               nAngular=5*nForm*nTerm
               Call GetMem('Angular','Allo','Inte',ipAng,nAngular)
*
*------------- Loops over symmetry operations operating on the basis
*              set center.
*
               Do iG = 0, nIrrep/dc(mdc+iCnt)%nStab - 1
                  iSkal=iSkal+1
                  Call OA(dc(mdc+iCnt)%iCoSet(iG,0),A,RA)
                  ipx=iPhase(1,dc(mdc+iCnt)%iCoSet(iG,0))
                  ipy=iPhase(2,dc(mdc+iCnt)%iCoSet(iG,0))
                  ipz=iPhase(3,dc(mdc+iCnt)%iCoSet(iG,0))
                  px=DBLE(iPhase(1,dc(mdc+iCnt)%iCoSet(iG,0)))
                  py=DBLE(iPhase(2,dc(mdc+iCnt)%iCoSet(iG,0)))
                  pz=DBLE(iPhase(3,dc(mdc+iCnt)%iCoSet(iG,0)))
                  nOp = NrOpr(dc(mdc+iCnt)%iCoSet(iG,0))
*
*---------------- Evaluate AOs at RA
*
                  call dcopy_(nAO,[Zero],0,Work(ipAOs),1)
                  mTmp=1
                  Call AOEval(iAng,nCoor,CCoor,Work(ipxyz),RA,
     &                        Shells(iShll)%Transf,
     &                        RSph(ipSph(iAng)),nElem(iAng),iCmp,
     &                        iWork(ipAng),nTerm,nForm,Thr,mRad,
     &                        iPrim,iPrim,Shells(iShll)%Exp,
     &                        Work(ipRadial),iBas,
     &                        Shells(iShll)%pCff,
     &                        Work(ipAOs),mAO,px,py,pz,ipx,ipy,ipz)
*
*---------------- Distribute contributions to the SOs
*
                  Call SOAdpt(Work(ipAOs),mAO,nCoor,iBas,iCmp,nOp,
     &                        Work(ipSOs),nDeg,iAO)
*
               End Do ! iG
*
*------------- Distribute contributions to the MOs
*
               Call SODist(Work(ipSOs),mAO,nCoor,iBas,iCmp,nDeg,
     &                     MOValue,nMOs,iAO,CMOs,nCMO,DoIt)
*
               Call GetMem('Radial','Free','Real',ipRadial,nRadial)
               Call GetMem('Angular','Free','Inte',ipAng,nAngular)
               Call GetMem('tmp','Free','Real',iptmp,ntmp)
               Call GetMem('xyz','Free','Real',ipxyz,nxyz)
               Call GetMem('AOs','Free','Real',ipAOs,nAO)
               Call GetMem('SOs','Free','Real',ipSOs,nSO)
*
            End Do ! iCnt
 101        Continue
            mdc = mdc + dbsc(iCnttp)%nCntr
            iAOttp = iAOttp + dbsc(iCnttp)%lOffAO*dbsc(iCnttp)%nCntr
         End Do
         Call GetMem('ScrSph','Free','Real',iScrt2,nScr2)
         Call GetMem('Scrtch','Free','Real',iScrt1,nScr1)
 100     continue
      End Do
*
      Return
      End


      Subroutine MOEvalDel(MOValueD,nMOs,nCoor,CCoor,CMOs,nCMO,DoIt)

      Implicit Real*8 (A-H,O-Z)
      Real*8 Ccoor(3,nCoor),MOValueD(4*nCoor*nMOs),CMOs(nCMO)
      Integer DoIt(nMOs),mAO
      integer nDrv

      mAO  = 4
      nDrv = 1

      Call MOEval(MOValueD,nMOs,nCoor,CCoor,CMOs,nCMO,DoIt,nDrv,mAO)

c        IJ1=1+(I-1)*4
c        IJ2=2+(I-1)*4
c        IJ3=3+(I-1)*4
c        IJ4=4+(I-1)*4
c
c        MOValue(I)=Work(MOTmp-1+IJ1)
c        MOValueDX(I)=Work(MOTmp-1+IJ2)
c        MOValueDY(I)=Work(MOTmp-1+IJ3)
c        MOValueDZ(I)=Work(MOTmp-1+IJ4)
c      END DO

      Return
      End

      Subroutine MOEvalDer(MOValue,iDir,nMOs,nCoor,CCoor,CMOs,nCMO,DoIt)

      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
      Real*8 Ccoor(3,nCoor),MOValue(nCoor*nMOs),CMOs(nCMO)
      Integer DoIt(nMOs),mAO
      integer nDrv

      mAO  = 4
      nDrv = 1

      Call GetMem('MOTMP','Allo','Real',iMoTmp,4*nCoor*nMOs)

      Call MOEval(work(iMoTmp),nMOs,nCoor,CCoor,CMOs,nCMO,DoIt,nDrv,mAO)

c iDir = 1 then do dX
c iDir = 2 then do dY
c iDir = 3 then do dZ
      write(6,*) "iDir:",iDir
      if(iDir.gt.0.and.iDir.lt.4) then
        DO I=1,nCoor*nMOs
          IJ=iDir+1+(I-1)*4
          MOValue(I)=Work(iMoTmp-1+IJ)
        END DO
      else ! do gradient
        DO I=1,nCoor*nMOs
          IJX=2+(I-1)*4
          IJY=3+(I-1)*4
          IJZ=4+(I-1)*4
          MOValue(I)=Work(iMoTmp-1+IJX)+
     &               Work(iMoTmp-1+IJY)+
     &               Work(iMoTmp-1+IJZ)
        END DO
      end if
      Call GetMem('MOTMP','Free','Real',iMoTmp,4*nCoor*nMOs)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine CrSph1(Win,ijkla,Scrt,nScrt,Coeff3,kCar,kSph,Tr3,Coeff4,lCar,lSph,Tr4,Wout,mcd)
!***********************************************************************
!                                                                      *
! Object : to transform the two-electron integrals from cartesian      *
!          gaussians to spherical gaussians.                           *
!                                                                      *
!          Observe that most of the time Win and Wout will overlap.    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ijkla, nScrt, kCar, kSph, lCar, lSph, mcd
real(kind=wp), intent(in) :: Win(ijkla*kCar*lCar), Coeff3(kCar,kCar), Coeff4(lCar,lCar)
real(kind=wp), intent(out) :: Scrt(nScrt)
real(kind=wp), intent(inout) :: Wout(mcd*ijkla)
logical(kind=iwp), intent(in) :: Tr3, Tr4

if (Tr3 .and. Tr4) then
  !call RecPrt(' Right contraction',' ',Coeff4,lCar,lSph)
  ! Starting with IJKL,a,cd transforming to D,IJKL,a,c
  !call xxDGeMul(Coeff4,lCar,'T',Win,ijkla*kCar,'T',Scrt,lSph,lSph,lCar,ijkla*kCar)
  call TTMul(Coeff4,Win,Scrt,lCar,lSph,ijkla*kCar)

  !call RecPrt(' In CrSph: (a0|cD) ',' ',Scrt,lSph*ijkla,kCar)
  !call RecPrt(' Left contraction',' ',Coeff3,kCar,kSph)
  ! Transform D,IJKL,a,c to CD,IJKL,a
  !call xxDGeMul(Coeff3,kCar,'T',Scrt,lSph*ijkla,'T',Wout,kSph,kSph,kCar,lSph*ijkla)
  call TTMul(Coeff3,Scrt,Wout,kCar,kSph,lSph*ijkla)
else if (Tr4) then
  !call RecPrt(' Right contraction',' ',Coeff4,lCar,lSph)
  ! Starting with IJKL,a,cd transforming to D,IJKL,a,c
  !call xxDGeMul(Coeff4,lCar,'T',Win,ijkla*kCar,'T',Scrt,lSph,lSph,lCar,ijkla*kCar)
  call TTMul(Coeff4,Win,Scrt,lCar,lSph,ijkla*kCar)
  ! Transpose D,IJKL,a,c to cD,IJKL,a
  call DGeTMO(Scrt,lSph*ijkla,lSph*ijkla,kCar,Wout,kCar)
else if (Tr3) then
  ! Transpose IJKL,a,c,d to d,IJKL,a,c
  call DGeTMO(Win,ijkla*kCar,ijkla*kCar,lCar,Scrt,lCar)

  !call RecPrt(' Left contraction',' ',Coeff3,kCar,kSph)
  ! Transform D,IJKL,a,c to CD,IJKL,a
  !call xxDGeMul(Coeff3,kCar,'T',Scrt,lSph*ijkla,'T',Wout,kSph,kSph,kCar,lSph*ijkla)
  call TTMul(Coeff3,Scrt,Wout,kCar,kSph,lSph*ijkla)
else
  ! Transpose IJKL,a,c,d to c,d,IJKL,a
  Scrt(1:ijkla*kCar*lCar) = Win(:)
  if (kCar*lCar /= 1) then
    call DGeTMO(Scrt,ijkla,ijkla,kCar*lCar,Wout,kCar*lCar)
  else
    Wout(1:ijkla*kCar*lCar) = Scrt(1:ijkla*kCar*lCar)
  end if
end if

!call RecPrt(' In CrSph1: (a0|CD)  ',' ',Wout,mcd,ijkla)

return

end subroutine CrSph1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1998, Roland Lindh                      *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drv2El(Integral_WrOut,ThrAO)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals.                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Modified for k2 loop. August '91                         *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. '93          *
*             Modified driver. Jan. '98                                *
************************************************************************
      use iSD_data
      use Basis_Info, only: dbsc
      use Real_Info, only: CutInt
      Implicit Real*8 (A-H,O-Z)
      External Integral_WrOut, Rsv_GTList
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
      Parameter(nTInt=1,mDens=1)
      Real*8 Dens(mDens), Fock(mDens), TInt(nTInt)
      Integer iTOffs(8,8,8)
      Logical Verbose, Indexation, FreeK2,
     &        W2Disc, PreSch, DoIntegrals, DoFock, DoGrad,
     &        FckNoClmb, FckNoExch, Rsv_GTList, Triangular
      Character*72 SLine
      Real*8, Dimension(:,:), Allocatable :: TMax
      Integer, Dimension(:,:), Allocatable :: Pair_Index
      Dimension ExFac(1),FckNoClmb(1),FckNoExch(1)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 9
      iPrint = nPrint(iRout)
      SLine='Computing 2-electron integrals'
      Call StatusLine(' Seward:',SLine)
*                                                                      *
************************************************************************
*                                                                      *
      ExFac=One
      Nr_Dens=1
      DoIntegrals=.True.
      DoFock=.False.
      DoGrad=.False.
      FckNoClmb=.False.
      FckNoExch=.False.
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
*                                                                      *
************************************************************************
*                                                                      *
*     Initialize for 2-electron integral evaluation. Do not generate
*     tables for indexation.
*
      Indexation = .False.
      Call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
*                                                                      *
************************************************************************
*                                                                      *
      Thize=Zero               ! Not used for conventional integrals
      PreSch=.True.            ! Not used for conventional integrals
      Disc_Mx=Zero             ! Not used for conventional integrals
*
      Disc=Zero
      Dix_Mx=Zero
      TskHi=Zero
      TskLw=Zero
*                                                                      *
************************************************************************
*                                                                      *
*---  Compute entities for prescreening at shell level
*
      Call mma_allocate(TMax,nSkal,nSkal)
      Call Shell_MxSchwz(nSkal,TMax)
      TMax_all=Zero
      Do iS = 1, nSkal
         Do jS = 1, iS
            TMax_all=Max(TMax_all,TMax(iS,jS))
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Create list of non-vanishing pairs
*
      Call mma_allocate(Pair_Index,2,nSkal*(nSkal+1)/2)
      nij=0
      Do iS = 1, nSkal
         Do jS = 1, iS
            If (TMax_All*TMax(iS,jS).ge.CutInt) Then
               nij = nij + 1
               Pair_Index(1,nij)=iS
               Pair_Index(2,nij)=jS
            End If
         End Do
      End Do
      P_Eff=DBLE(nij)
*                                                                      *
************************************************************************
*                                                                      *
      Triangular=.True.
      Call Alloc_TList(Triangular,P_Eff)
      Call Init_TList(Triangular,P_Eff)
      Call Init_PPList
      Call Init_GTList
      iOpt=0
*
      PP_Eff=P_Eff**2
      PP_Eff_delta=0.10D0*PP_Eff
      PP_Count=Zero
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu1,TWall1)
*
*     big loop over individual tasks distributed over individual nodes
*
 10   Continue
*     make reservations of a tesk in global task list and get task range
*     in return. Function will be false if no more tasks to execute.
      If (.Not.Rsv_GTlist(TskLw,TskHi,iOpt,W2Disc)) Go To 11
      W2Disc=.False.
*
*     Now do a quadruple loop over shells
*
      ijS = Int((One+sqrt(Eight*TskLw-Three))/Two)
      iS = Pair_Index(1,ijS)
      jS = Pair_Index(2,ijS)
      klS = Int(TskLw-DBLE(ijS)*(DBLE(ijS)-One)/Two)
      kS = Pair_Index(1,klS)
      lS = Pair_Index(2,klS)
      Count=TskLw
*
      If (Count-TskHi.gt.1.0D-10) Go To 12
 13   Continue
*
*     Logic to avoid computing integrals in a mixed muonic and
*     electronic basis.
*
      iCnttp=iSD(13,iS)
      jCnttp=iSD(13,jS)
      If (dbsc(iCnttp)%fMass.ne.dbsc(jCnttp)%fMass) Go To 14
      kCnttp=iSD(13,kS)
      lCnttp=iSD(13,lS)
      If (dbsc(kCnttp)%fMass.ne.dbsc(lCnttp)%fMass) Go To 14
*
      S_Eff=DBLE(ijS)
      T_Eff=DBLE(klS)
      ST_Eff=S_Eff*(S_Eff-One)/2D0 + T_Eff
      If (ST_Eff.ge.PP_Count) Then
         Write (SLine,'(A,F5.2,A)') 'Computing 2-electron integrals,',
     &        ST_Eff/PP_Eff*100d0,'% done so far.'
         Call StatusLine(' Seward:',SLine)
         PP_Count = PP_Count + PP_Eff_delta
      End If
*
*
         Aint=TMax(iS,jS)*TMax(kS,lS)
         If (AInt.lt.CutInt) Go To 14
         Call Eval_Ints_New_Internal
     &                  (iS,jS,kS,lS,TInt,nTInt,
     &                   iTOffs,Integral_WrOut,
* the following are dummy arguments
     &                   Dens,Fock,mDens,ExFac,Nr_Dens,
     &                   FckNoClmb,FckNoExch,
     &                   Thize,W2Disc,PreSch,Dix_Mx,Disc,
     &                   Count,DoIntegrals,DoFock)
 14      Continue
         Count=Count+One
         If (Count-TskHi.gt.1.0D-10) Go To 12
         klS = klS + 1
         If (klS.gt.ijS) Then
            ijS = ijS + 1
            klS = 1
         End If
         iS = Pair_Index(1,ijS)
         jS = Pair_Index(2,ijS)
         kS = Pair_Index(1,klS)
         lS = Pair_Index(2,klS)
         Go To 13
*
*     Task endpoint
 12   Continue
*
*     Use a time slot to save the number of tasks and shell
*     quadrupltes process by an individual node
      Call SavStat(1,One,'+')
      Call SavStat(2,TskHi-TskLw+One,'+')
      Go To 10
 11   Continue
*     End of big task loop
      Call CWTime(TCpu2,TWall2)
      Call SavTim(1,TCpu2-TCpu1,TWall2-TWall1)
*                                                                      *
************************************************************************
*                                                                      *
*                         E P I L O G U E                              *
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_GTList
      Call Free_PPList
      Call Free_TList
*
      Call mma_deallocate(Pair_Index)
      Call mma_deallocate(TMax)
*                                                                      *
************************************************************************
*                                                                      *
*     Terminate integral environment.
*
      Verbose = .False.
      FreeK2=.True.
      Call Term_Ints(Verbose,FreeK2)
      Call Free_iSD()
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_WRFVEC(VEC,ISYMA,ISYMB,IVEC1,NUMV)
C
C     Purpose: write full storage vectors to disk.
C
      IMPLICIT NONE
      REAL*8 VEC(*)
      INTEGER ISYMA, ISYMB, IVEC1, NUMV
#include "choreo.fh"

      INTEGER     IOPT, IADR, NTOT

      IOPT = 1
      IADR = NABPK(ISYMA,ISYMB)*(IVEC1 - 1) + 1
      NTOT = NABPK(ISYMA,ISYMB)*NUMV
      CALL DDAFILE(LUFV(ISYMA,ISYMB),IOPT,VEC,NTOT,IADR)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! dbl space partial loop values
subroutine Value_of_PL_IN_DBL()

use gugaci_global, only: fg, jb_sys, pd, pdd, ps1, ps2, ps3, ps4, pt, ptt, v_onevsqtwo, v_sqtwo, w0_d1d, w0_d1d1, w0_d1s, w0_d1t1, &
                         w0_d1v, w0_dd, w0_dd1, w0_ds, w0_dt, w0_dv, w0_sd, w0_sd1, w0_ss, w0_sv, w0_t1d1, w0_t1t1, w0_td, w0_tt, &
                         w0_vv, w1_d1d, w1_d1d1, w1_d1s, w1_d1t1, w1_d1v, w1_dd, w1_dd1, w1_ds, w1_dt, w1_sd, w1_sd1, w1_ss, &
                         w1_st, w1_st1, w1_sv, w1_t1d1, w1_t1s, w1_t1t1, w1_t1v, w1_td, w1_ts, w1_tt, w1_tv
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ib
real(kind=wp) :: db, fgsq2, fgvsq2

DB = JB_SYS
IB = mod(JB_SYS,2)
FG = One
if (IB == 1) FG = -One
!-------------------------- diag ---------------------------------------
! W0=+(-)FG*v_sqtwo  or  W0=+(-)FG/v_sqtwo
!W1 = -(B_SYS+3)/(2*B_SYS+2)
!W1_CS21 = -(DB+3)/(2*DB+2)   ! W1  for  D&R&L(2)D^R^L(1)
!W1_CS12 = -(DB-1)/(2*DB+2)   ! W1  for  D&R&L(1)D^R^L(2)
PD = FG*sqrt((DB+3)/(2*DB+2))
PT = -FG*sqrt((DB+4)/(2*DB+4))
PS1 = FG*sqrt(DB/(2*DB+4))                   ! (2)D&R&L(1)
PS4 = -FG*(DB+3)*sqrt((DB)/(2*DB+4))/(DB+1)  !D&R&L(2)C"(1)

if (JB_SYS /= 0) then
  PDD = -FG*sqrt((DB-1)/(2*DB+2))
  PS2 = -FG*sqrt((DB+2)/(2*DB))                ! (1)D&R&L(2)
  PS3 = FG*(DB-1)*sqrt((DB+2)/(2*DB))/(DB+1)   !D&R&L(1)C"(2)

  if (JB_SYS /= 1) PTT = FG*sqrt((DB-2)/(2*DB))
end if

!---------------------- off diag ---------------------------------------
FGSQ2 = FG*v_sqtwo
FGVSQ2 = FG*v_onevsqtwo

! SS(1-2)  Ar(02)-Bl(31)-
! SS(1-4)  Ar(23)-Bl(10)-
! SS(1-5)  (22)-Ar(13)-Bl(31)-
! SS(1-9)  Ar(23)-C'(11)-Bl(32)-
! SS(1-10) Ar(23)-C'(12)-Bl(31)-
! SS(1-14) Ar(23)-Bl(32)-C"(11)-
! SS(1-15) (22)-Drl(11)-
! SS(1-17) Drl(22)-C"(11)-
! SS(1-20) Drl(33)-C"(00)-
! SS(1-20) Drl(33)-C"(22)-C"(11)-
! SS(1-20) (22)Drl(33)-C"(11)-
! SS(1-20) (22)(11)Drl(33)-
W0_SS(2) = FG*sqrt((DB+2)/(2*DB+2))
W1_SS(2) = -FG*sqrt(DB/(2*DB+2))
W0_SS(4) = FG*sqrt((DB+2)/(2*DB+2))
W1_SS(4) = FG*sqrt(DB/(2*DB+2))
W0_SS(5) = FGVSQ2
W1_SS(5) = -FG*sqrt(DB/(2*DB+4))
W0_SS(9) = -FGVSQ2*sqrt(DB*(DB+2))/(DB+1)
W1_SS(9) = -FGVSQ2*(DB+2)/(DB+1)
W0_SS(10) = -FGVSQ2/(DB+1)
W1_SS(10) = FG*sqrt(DB/(2*DB+4))/(DB+1)
W0_SS(14) = FGVSQ2
W1_SS(14) = FG*(DB+3)*sqrt(DB/(2*DB+4))/(DB+1)
W0_SS(15) = FGVSQ2
W1_SS(15) = FG*sqrt(DB/(2*DB+4))
W0_SS(17) = FGVSQ2
W1_SS(17) = -FG*(DB+3)*sqrt(DB/(2*DB+4))/(DB+1)      !??????
W0_SS(20) = FGSQ2
W1_SS(20) = Zero

! ST(2-1) Ar(02)-Bl(32)-
! ST(2-2) (22)Ar(13)-Bl(32)-
! ST(2-4) Ar(23)-C'(12)-Bl(32)-
! ST(2-4) Ar(23)-Bl(32)-C'(12)-
! ST(2-5) (22)Drl(12)-
! ST(2-6) Drl(22)-C"(12)-
W1_ST(1) = One
W1_ST(2) = sqrt((DB+1)/(DB+2))
W1_ST(4) = -One/sqrt((DB+1)*(DB+2))
W1_ST(5) = -sqrt((DB+1)/(DB+2))
W1_ST(6) = One/sqrt((DB+1)*(DB+2))

! TS(3-1) Ar(23)-Bl(20)-
! TS(3-2) (22)Ar(23)-Bl(31)-
! TS(3-2) Ar(23)-C'(22)-Bl(31)-
! TS(3-4) Ar(23)-Bl(32)-C"(21)-
W1_TS(1) = sqrt((DB+3)/(DB+1))
W1_TS(2) = -sqrt((DB+3)/(DB+2))
W1_TS(4) = sqrt((DB+3)/(DB+2))/(DB+1)

! SD(6-1) A&r(02)-
! SD(6-2) C(22)A&(13)-
! SD(6-4) A&r(23)C'(12)-
! SD(6-5) A&r(23)B&r(13)B^r(32)
! SD(6-8) A&r(23)B&l(32)B^l(13)
! SD(6-9) D&r&r(03)B^r(32)
! SD(6-11) D&r&l(22)B^l(13)
! SD(6-12) D&r&l(33)B^l(02)
! SD(6-14) (22)D&r&l(33)B^l(13)
! SD(6-14) D&r&l(33)C"(22)B^l(13)
! SD(6-16) D&r&l(33)B^l(23)C'(12)
W0_SD(1) = One
W1_SD(1) = One
W0_SD(2) = sqrt((DB+1)/(DB+2))
W1_SD(2) = W0_SD(2)
W0_SD(4) = -One/sqrt((DB+1)*(DB+2))
W1_SD(4) = W0_SD(4)
W0_SD(5) = sqrt((DB+2)/(DB+1))*Half
W1_SD(5) = DB/(2*sqrt((DB+1)*(DB+2)))
W0_SD(8) = -sqrt((DB+1)/(DB+2))*Half
W1_SD(8) = -(DB+3)/(2*sqrt((DB+1)*(DB+2)))
W0_SD(9) = -One
W1_SD(9) = Zero
W0_SD(11) = -sqrt((DB+1)/(DB+2))*Half
W1_SD(11) = (DB+3)/(2*sqrt((DB+1)*(DB+2)))
W0_SD(12) = -One
W1_SD(12) = Zero
W0_SD(14) = -sqrt((DB+1)/(DB+2))
W1_SD(14) = Zero
W0_SD(16) = One/sqrt((DB+1)*(DB+2))
W1_SD(16) = Zero

! DS(7-1) Ar(23)-DRl(30)-
! DS(7-3) Ar(23)-Bl(32)-BR(31)-
W0_DS(1) = -sqrt((DB+2)/(DB+1))
W1_DS(1) = Zero
W0_DS(3) = Half
W1_DS(3) = (DB+3)/(2*DB+2)

! SV(10-2) Ar(23)-Br(13)-
! SV(10-3) Drr(03)-
W0_SV(2) = sqrt((DB+2)/(2*DB+2))
W1_SV(2) = -sqrt(DB/(2*DB+2))
W0_SV(3) = -v_sqtwo
W1_SV(3) = Zero

! TT(11-1) (22)Ar(23)-Bl(32)-
! TT(11-1) Ar(23)-C'(22)-Bl(32)-
! TT(11-1) Ar(23)-Bl(32)-C"(22)-
! TT(11-2) (22)Drl(22)-
! TT(11-2) Drl(22)-C"(22)-
! TT(11-3) (22)Drl(33)-
! TT(11-3) Drl(33)-C"(22)-
! TT(11-3) Drl(33)-C"(22)-C"(22)-
W0_TT(1) = FGVSQ2
W1_TT(1) = FG*sqrt((DB+4)/(2*DB+4))
W0_TT(2) = FGVSQ2
W1_TT(2) = -FG*sqrt((DB+4)/(2*DB+4))
W0_TT(3) = FGSQ2
W1_TT(3) = Zero

! TD(13-1) (22)A&(23)
! TD(13-1) A&(23)C'(22)
! TD(13-2) A&(23)B&r(23)B^r(32)
! TD(13-3) A&(23)B&l(32)B^l(23)
! TD(13-4) D&r&l(22)B^l(23)
! TD(13-5) (22)D&&l(33)B^l(23)
! TD(13-5) D&rl(33)C"(22)B^l(23)
! TD(13-5) D&rl(33)B^l(23)C'(22)
W0_TD(1) = FG*sqrt((DB+3)/(DB+2))
W0_TD(2) = Zero
W1_TD(2) = W0_TD(1)
W0_TD(3) = -W0_TD(1)*Half
W1_TD(3) = W0_TD(1)*Half
W0_TD(4) = W0_TD(3)
W1_TD(4) = W0_TD(3)
W0_TD(5) = -W0_TD(1)
W1_TD(5) = Zero

! DT(14) Ar(23)-Bl(32)-BR(32)-
W0_DT = -FG*Half
W1_DT = FG*Half

! TV(17) Ar(23)-Br(23)-
W1_TV = Zero
W1_TV = -FG*sqrt((DB+3)/(DB+1))

! DD(19-1) Ar(23)-Bl(32)-
! DD(19-2) Drl(22)-
! DD(19-3) (22)Drl(33)-
! DD(19-3) Drl(33)-C"(22)-
W0_DD(1) = -FGVSQ2
W1_DD(1) = -FG*sqrt((DB+3)/(2*DB+2))
W0_DD(2) = -FGVSQ2
W1_DD(2) = FG*sqrt((DB+3)/(2*DB+2))
W0_DD(3) = -FGSQ2
W1_DD(3) = Zero

! DV(23-1) Ar(23)-
! DV(23-2) Drl(33)-BL(23)-
W0_DV(1) = -FG*sqrt((DB+2)/(DB+1))
!W1_DV(1) = W0_DV(1)
W0_DV(2) = FG*sqrt((DB+2)/(DB+1))
!W1_DV(2) = Zero

! VV(25) Drl(33)-
W0_VV = FGSQ2

!=======================================================================
if (JB_SYS == 0) return

! SS(1-1)  Ar(01)-Bl(32)-
! SS(1-3)  Ar(13)-Bl(20)-
! SS(1-6)  (11)-Ar(23)-Bl(32)-
! SS(1-7)  Ar(13)-C'(21)-Bl(32)-
! SS(1-8)  Ar(13)-C'(22)-Bl(31)-
! SS(1-11) Ar(13)-Bl(31)-C"(22)-
! SS(1-12) Ar(13)-Bl(32)-C"(21)-
! SS(1-13) Ar(23)-Bl(31)-C"(12)-
! SS(1-16) (11)-Drl(22)-
! SS(1-18) Drl(11)-C"(22)-
! SS(1-19) Drl(12)-C"(21)-
! SS(1-20) Drl(33)-C"(11)-C"(22)-
! SS(1-20) (11)Drl(33)-C"(22)-
! SS(1-20) (11)(22)Drl(33)-
W0_SS(1) = FGVSQ2*sqrt(DB/(DB+1))
W1_SS(1) = FGVSQ2*sqrt((DB+2)/(DB+1))
W0_SS(3) = FGVSQ2*sqrt(DB/(DB+1))
W1_SS(3) = -FGVSQ2*sqrt((DB+2)/(DB+1))
W0_SS(6) = FGVSQ2
W1_SS(6) = FGVSQ2*sqrt((DB+2)/DB)
W0_SS(7) = FGVSQ2/(DB+1)
W1_SS(7) = FGVSQ2*sqrt((DB+2)/DB)/(DB+1)
W0_SS(8) = -FGVSQ2*sqrt(DB*(DB+2))/(DB+1)
W1_SS(8) = FGVSQ2*DB/(DB+1)
W0_SS(11) = FGVSQ2
W1_SS(11) = -FG*sqrt((DB+2)/(2*DB))*(DB-1)/(DB+1)
W0_SS(12) = Zero
W1_SS(12) = -FGSQ2/(DB+1)
W0_SS(13) = Zero
W1_SS(13) = -FGSQ2/(DB+1)
W0_SS(16) = FGVSQ2
W1_SS(16) = -FGVSQ2*sqrt((DB+2)/DB)
W0_SS(18) = FGVSQ2
W1_SS(18) = FGVSQ2*(DB-1)*sqrt((DB+2)/DB)/(DB+1)
W0_SS(19) = Zero
W1_SS(19) = FGSQ2/(DB+1)

! ST(2-3) Ar(13)-C'(22)-Bl(32)-
! ST(2-3) Ar(13)-Bl(32)-C'(22)-
! ST(2-7) Drl(12)-C"(22)-
W1_ST(3) = -sqrt(DB/(DB+1))
W1_ST(7) = sqrt(DB/(DB+1))

! TS(3-3) Ar(23)-Bl(31)-C"(22)-
W1_TS(3) = sqrt(DB*(DB+3))/(DB+1)

! SD(6-3) A&r(13)C'(22)-
! SD(6-6) A&r(13)B&r(23)B^r(32)
! SD(6-7) A&r(13)B&l(32)B^l(23)
! SD(6-10) D&r&l(12)B^l(23)
! SD(6-15) D&r&l(33)B^l(13)C'(22)
W0_SD(3) = -sqrt(DB/(DB+1))
W1_SD(3) = W0_SD(3)
W0_SD(6) = sqrt(DB/(DB+1))*Half
W1_SD(6) = -W0_SD(6)
W0_SD(7) = Zero
W1_SD(7) = -sqrt(DB/(DB+1))
W0_SD(10) = Zero
W1_SD(10) = sqrt(DB/(DB+1))
W0_SD(15) = sqrt(DB/(DB+1))
W1_SD(15) = Zero

! DS(7-2) Ar(23)-Bl(31)-BR(32)-
W0_DS(2) = Zero
W1_DS(2) = sqrt(DB*(DB+2))/(DB+1)

! SD1(8-1)    Ar(01)-
! SD1(8-2)    Ar(23)-
! SD1(8-3)    Ar(13)-C'(21)-
! SD1(8-4)    Ar(23)-C'(11)-
! SD1(8-5)    Ar(13)-Br(23)-BR(31)-
! SD1(8-6)    Ar(23)-Br(13)-BR(31)-
! SD1(8-7)    Ar(13)-Bl(31)-BL(23)-
! SD1(8-8)    Ar(23)-Bl(31)-BL(13)-
! SD1(8-9)    Drr(03)-BR(31)-
! SD1(8-9)    Drl(33)-BL(01)-
! SD1(8-10) Drl(11)-BL(23)-
! SD1(8-11) (11)Drl(33)-BL(23)-
! SD1(8-11) Drl(33)-C"(11)-BL(23)-
! SD1(8-12) Drl(33)-BL(13)-C'(21)-
! SD1(8-13) Drl(33)-BL(23)-C'(11)-
W0_SD1(1) = FG
W1_SD1(1) = FG
W0_SD1(2) = FG*sqrt((DB+1)/DB)
W1_SD1(2) = W0_SD1(2)
W0_SD1(3) = FG/sqrt(DB*(DB+1))
W1_SD1(3) = W0_SD1(3)
W0_SD1(4) = -FG*sqrt((DB+2)/(DB+1))
W1_SD1(4) = W0_SD1(4)
W0_SD1(5) = FG*sqrt(DB/(DB+1))*Half
W1_SD1(5) = FG*(DB+2)/(2*sqrt(DB*(DB+1)))
W0_SD1(6) = FG*sqrt((DB+2)/(DB+1))*Half
W1_SD1(6) = -W0_SD1(6)
W0_SD1(7) = -FG*sqrt((DB+1)/DB)*Half
W1_SD1(7) = -FG*(DB-1)/(2*sqrt(DB*(DB+1)))
W0_SD1(8) = Zero
W1_SD1(8) = -FG*sqrt((DB+2)/(DB+1))
W0_SD1(9) = -FG
W1_SD1(9) = Zero
W0_SD1(10) = -FG*sqrt((DB+1)/DB)*Half
W1_SD1(10) = FG*(DB-1)/(2*sqrt(DB*(DB+1)))
W0_SD1(11) = -FG*sqrt((DB+1)/DB)
W1_SD1(11) = Zero
W0_SD1(12) = -FG/sqrt(DB*(DB+1))
W1_SD1(12) = Zero
W0_SD1(13) = FG*sqrt((DB+2)/(DB+1))
W1_SD1(13) = Zero

! D1S(9-1)    Ar(13)-DlR(30)-
! D1S(9-2)    Ar(13)-Bl(31)-BR(32)-
! D1S(9-3)    Ar(13)-Bl(32)-BR(31)-
! D1S(9-4)    Drl(12)-Br(31)-
W0_D1S(1) = FG*sqrt(DB/(DB+1))
W1_D1S(1) = Zero
W0_D1S(2) = -FG*Half
W1_D1S(2) = -FG*(DB-One)/(2*DB+2)
W0_D1S(3) = Zero
W1_D1S(3) = -FG*sqrt(DB*(DB+2))/(DB+1)
W0_D1S(4) = Zero
W1_D1S(4) = FG*sqrt(DB*(DB+2))/(DB+1)

! SV(10-1) Ar(13)-Br(23)-
W0_SV(1) = sqrt(DB/(2*DB+2))
W1_SV(1) = sqrt((DB+2)/(2*DB+2))

! D1D1(20-1) Ar(13)-BL(31)-
! D1D1(20-1) Drl(11)-
! D1D1(20-1) Drl(33)-
! D1D1(20-1) Drl(33)-C"(11)-
W0_D1D1(1) = -FGVSQ2
W1_D1D1(1) = FGVSQ2*sqrt((DB-1)/(DB+1))
W0_D1D1(2) = W0_D1D1(1)
W1_D1D1(2) = -W1_D1D1(1)
W0_D1D1(3) = -FGSQ2
W1_D1D1(3) = Zero

! DD1(21)Ar(23)-Bl(31)-
W0_DD1 = Zero
W1_DD1 = -sqrt((DB+2)/(DB+1))

! D1D(22-1)   Ar(13)-Bl(32)-
! D1D(22-2)   Drl(12)-
W0_D1D(1) = Zero
W1_D1D(1) = sqrt(DB/(DB+1))
W0_D1D(2) = Zero
W1_D1D(2) = -W1_D1D(1)

! D1V(24-1)  Ar(13)-
! D1V(24-2)  Drl(33)-BL(13)-
W0_D1V(1) = sqrt(DB/(DB+1))
W1_D1V(1) = W0_D1V(1)
W0_D1V(2) = -W0_D1V(1)
W1_D1V(2) = Zero

!=======================================================================
if (JB_SYS == 1) return

! ST1(4-1) Ar(01)-Bl(31)-
! ST1(4-2) Ar(23)-Bl(31)-
! ST1(4-3) Ar(13)-C'(21)-Bl(31)-
! ST1(4-3) Ar(13)-Bl(31)-C"(21)-
! ST1(4-4) Ar(23)-C'(11)-Bl(31)-
! ST1(4-4) Ar(23)-Bl(31)-C"(11)-
W1_ST1(1) = -One
W1_ST1(2) = -sqrt((DB+1)/DB)
W1_ST1(3) = -One/sqrt(DB*(DB+1))
W1_ST1(4) = sqrt((DB+2)/(DB+1))

! T1S(5-1)   Ar(13)-Bl(10)-
! T1S(5-2)   Ar(13)-Bl(32)-
! T1S(5-2)   Ar(13)-C'(11)-Bl(32)-
! T1S(5-3)   Ar(13)-Bl(31)-C"(12)-
! T1S(5-4)   Ar(13)-Bl(32)-C"(11)-
! T1S(5-5)   Drl(12)-
! T1S(5-6)   Drl(12)-C"(12)-
! T1S(5-7)   Drl(12)-C"(11)-
W1_T1S(1) = -sqrt((DB-1)/(DB+1))
W1_T1S(2) = sqrt((DB-1)/DB)
W1_T1S(3) = sqrt((DB-1)/DB)/(DB+1)
W1_T1S(4) = -sqrt((DB-1)*(DB+2))/(DB+1)
W1_T1S(5) = -sqrt((DB-1)/DB)
W1_T1S(6) = -sqrt((DB-1)/DB)/(DB+1)
W1_T1S(7) = sqrt((DB-1)*(DB+2))/(DB+1)

! T1T1(12-1)  Ar(13)-Bl(31)-
! T1T1(12-1)  Ar(13)-C'(11)-Bl(31)-
! T1T1(12-1)  Ar(13)-Bl(31)-C"(11)-
! T1T1(12-2)  Drl(11)-
! T1T1(12-2)  Drl(11)-C"(11)-
! T1T1(12-3)  Drl(33)-
! T1T1(12-3)  Drl(33)-C"(11)-
! T1T1(12-3)  Drl(33)-C"(11)-C"(11)-
W0_T1T1(1) = FGVSQ2
W1_T1T1(1) = -FGVSQ2*sqrt((DB-2)/DB)
W0_T1T1(2) = FGVSQ2
W1_T1T1(2) = -W1_T1T1(1)
W0_T1T1(3) = FGSQ2
W1_T1T1(3) = Zero

! T1D1(15-1)  Ar(13)-
! T1D1(15-1)  Ar(13)-C'(11)-
! T1D1(15-2)  Ar(13)-Br(13)-BR(31)-
! T1D1(15-3)  Ar(13)-Bl(31)-Bl(13)-
! T1D1(15-4)  Drl(11)-BL(13)-
! T1D1(15-5)  Drl(33)-BL(13)-
! T1D1(15-5)  Drl(33)-C"(11)-BL(13)-
! T1D1(15-5)  Drl(33)-BL(13)-C'(11)-
W0_T1D1(1) = sqrt((DB-1)/DB)
W1_T1D1(1) = W0_T1D1(1)
W0_T1D1(2) = Zero
W1_T1D1(2) = W0_T1D1(1)
W0_T1D1(3) = -W0_T1D1(1)*Half
W1_T1D1(3) = W0_T1D1(1)*Half
W0_T1D1(4) = -W0_T1D1(1)*Half
W1_T1D1(4) = W0_T1D1(4)
W0_T1D1(5) = -W0_T1D1(1)
W1_T1D1(5) = Zero

! D1T1(16) Ar(13)-Bl(31)-BR(31)-
W0_D1T1 = Half
W1_D1T1 = -Half

! T1V(18) Ar(13)-Br(13)-
W1_T1V = FG*sqrt((DB-1)/(DB+1))

end subroutine Value_of_PL_IN_DBL

subroutine SS2_EXT(LRI,LRJ,NK)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, mpl, ni
real(kind=wp) :: w0ss2, w1ss2
integer(kind=iwp), external :: iwalk_ad

LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
LMIJ = Mul(LMI,LMJ)
NK = 0
if ((JML /= 1) .or. (LMIJ /= JMR)) return
! SS(1-2)  Ar(02)-Bl(31)-
NK = 1
W0SS2 = W0_SS(2)
W1SS2 = W1_SS(2)
NI = mod(LRJ-LRI,2)
if (NI == 0) then
  W0SS2 = -W0SS2
  W1SS2 = -W1SS2
end if
do MPL=1,MTYPE
  VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS2
  VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS2
end do
IWDL = JUST(LRI,LRI)
IWDR = JUST(LRI,LRJ)
do MPL=1,MHLP
  IWAL = LPNEW_LWEI(MPL)
  IWAR = LPNEW_RWEI(MPL)
  LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
  LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
end do

return

end subroutine SS2_EXT

!subroutine SS3_EXT(LRI,LRJ)
!! SS(1-3)  Ar(13)-Bl(20)-
!
!use gugaci_global, only: ipae, ipael, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, mhlp, mtype, vplp_w0, vplp_w1, &
!                         vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: lri, lrj
!integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, mpl, ni
!real(kind=wp) :: w0ss3, w1ss3
!integer(kind=iwp), external :: iwalk_ad
!
!W0SS3 = W0_SS(3)
!W1SS3 = W1_SS(3)
!NI = mod(LRJ-LRI,2)
!if (NI == 0) then
!  W0SS3 = -W0SS3
!  W1SS3 = -W1SS3
!end if
!do MPL=1,MTYPE
!  VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS3
!  VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS3
!end do
!IWDL = JUST(LRJ,LRI)
!IWDR = JUST(LRJ,LRJ)
!do MPL=1,MHLP
!  IWAL = LPNEW_LWEI(MPL)
!  IWAR = LPNEW_RWEI(MPL)
!  LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
!  LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
!end do
!
!return
!
!end subroutine SS3_EXT

subroutine SS4_EXT(LRI,LRJ,NK)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, mpl, ni
real(kind=wp) :: w0ss4, w1ss4
integer(kind=iwp), external :: iwalk_ad

LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
LMIJ = Mul(LMI,LMJ)
NK = 0
if ((JMR /= 1) .or. (LMIJ /= JML)) return
NK = 1
! SS(1-4)  Ar(23)-Bl(10)-
W0SS4 = W0_SS(4)
W1SS4 = W1_SS(4)
NI = mod(LRJ-LRI,2)
if (NI == 0) then
  W0SS4 = -W0SS4
  W1SS4 = -W1SS4
end if
do MPL=1,MTYPE
  VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS4
  VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS4
end do
IWDL = JUST(LRI,LRJ)
IWDR = JUST(LRJ,LRJ)
do MPL=1,MHLP
  IWAL = LPNEW_LWEI(MPL)
  IWAR = LPNEW_RWEI(MPL)
  LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
  LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
end do

return

end subroutine SS4_EXT

subroutine SS5_EXT(LRI,LRJ,NK)
! SS(1-5)  (22)-Ar(13)-Bl(31)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, max_innorb, &
                         mhlp, mtype, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, k, lmi, lmj, lmk, lmki, lmkj, lrk, mpl, ni, npl
real(kind=wp) :: w0ss5, w1ss5
integer(kind=iwp), allocatable :: iwdl(:), iwdr(:)
integer(kind=iwp), external :: iwalk_ad

NK = 0
LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
call mma_allocate(iwdl,max_innorb,label='iwdl')
call mma_allocate(iwdr,max_innorb,label='iwdr')
do LRK=NORB_FRZ+1,LRI-1
  LMK = LSM_INN(LRK)
  LMKI = Mul(LMK,LMI)
  LMKJ = Mul(LMK,LMJ)
  if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
  NK = NK+1
  IWDL(NK) = JUST(LRK,LRI)
  IWDR(NK) = JUST(LRK,LRJ)
end do

if (NK /= 0) then
  W0SS5 = W0_SS(5)
  W1SS5 = W1_SS(5)
  NI = mod(LRJ-LRI,2)
  if (NI == 0) then
    W0SS5 = -W0SS5
    W1SS5 = -W1SS5
  end if
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS5
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS5
  end do
  NPL = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    do K=1,NK
      NPL = NPL+1
      LP_LWEI(NPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL(K))
      LP_RWEI(NPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR(K))
    end do
  end do
end if
call mma_deallocate(iwdl)
call mma_deallocate(iwdr)

return

end subroutine SS5_EXT

subroutine SS10_EXT(LRI,LRJ,NK)
! SS(1-10) Ar(23)-C'(12)-Bl(31)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, max_innorb, &
                         mhlp, mtype, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, k, lmi, lmj, lmk, lmki, lmkj, lrk, mpl, ni, npl
real(kind=wp) :: w0ss10, w1ss10
integer(kind=iwp), allocatable :: iwdl(:), iwdr(:)
integer(kind=iwp), external :: iwalk_ad

NK = 0
LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
call mma_allocate(iwdl,max_innorb,label='iwdl')
call mma_allocate(iwdr,max_innorb,label='iwdr')
do LRK=LRI+1,LRJ-1
  LMK = LSM_INN(LRK)
  LMKI = Mul(LMK,LMI)
  LMKJ = Mul(LMK,LMJ)
  if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
  NK = NK+1
  IWDL(NK) = JUST(LRI,LRK)
  IWDR(NK) = JUST(LRK,LRJ)
end do

if (NK /= 0) then
  W0SS10 = -W0_SS(10)
  W1SS10 = -W1_SS(10)
  NI = mod(LRJ-LRI,2)
  if (NI == 0) then
    W0SS10 = -W0SS10
    W1SS10 = -W1SS10
  end if
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS10
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS10
  end do
  NPL = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    do K=1,NK
      NPL = NPL+1
      LP_LWEI(NPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL(K))
      LP_RWEI(NPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR(K))
    end do
  end do
end if
call mma_deallocate(iwdl)
call mma_deallocate(iwdr)

return

end subroutine SS10_EXT

subroutine SS14_EXT(LRI,LRJ,NK)
! SS(1-14) Ar(23)-Bl(32)-C"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, max_innorb, &
                         mhlp, mtype, norb_dz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, k, lmi, lmj, lmk, lmki, lmkj, lrk, mpl, ni, npl
real(kind=wp) :: w0ss14, w1ss14
integer(kind=iwp), allocatable :: iwdl(:), iwdr(:)
integer(kind=iwp), external :: iwalk_ad

NK = 0
LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
call mma_allocate(iwdl,max_innorb,label='iwdl')
call mma_allocate(iwdr,max_innorb,label='iwdr')
do LRK=LRJ+1,NORB_DZ
  LMK = LSM_INN(LRK)
  LMKI = Mul(LMK,LMI)
  LMKJ = Mul(LMK,LMJ)
  if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
  NK = NK+1
  IWDL(NK) = JUST(LRI,LRK)
  IWDR(NK) = JUST(LRJ,LRK)
end do

if (NK /= 0) then
  W0SS14 = W0_SS(14)
  W1SS14 = W1_SS(14)
  NI = mod(LRJ-LRI,2)
  if (NI == 0) then
    W0SS14 = -W0SS14
    W1SS14 = -W1SS14
  end if
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0SS14
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1SS14
  end do
  NPL = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    do K=1,NK
      NPL = NPL+1
      LP_LWEI(NPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL(K))
      LP_RWEI(NPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR(K))
    end do
  end do
end if
call mma_deallocate(iwdl)
call mma_deallocate(iwdr)

return

end subroutine SS14_EXT

subroutine TT1_EXT(LRI,LRJ,NK,IGF)
! SS(1-14) Ar(23)-Bl(32)-C"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, max_innorb, &
                         mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_tt, w1_tt
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, igf
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, k, lmi, lmj, lmk, lmki, lmkj, lrk, mpl, ni, npl
real(kind=wp) :: w0tt1, w1tt1
integer(kind=iwp), allocatable :: iwdl(:), iwdr(:)
integer(kind=iwp), external :: iwalk_ad

NK = 0
LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
call mma_allocate(iwdl,max_innorb,label='iwdl')
call mma_allocate(iwdr,max_innorb,label='iwdr')
if (IGF == -1) then
  ! TT(11-1) Ar(23)-C'(22)-Bl(32)-
  do LRK=LRI+1,LRJ-1
    LMK = LSM_INN(LRK)
    LMKI = Mul(LMK,LMI)
    LMKJ = Mul(LMK,LMJ)
    if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
    NK = NK+1
    IWDL(NK) = JUST(LRI,LRK)
    IWDR(NK) = JUST(LRK,LRJ)
  end do
  W0TT1 = -W0_TT(1)
  W1TT1 = -W1_TT(1)
else
  ! TT(11-1) (22)Ar(23)-Bl(32)-
  do LRK=NORB_FRZ+1,LRI-1
    LMK = LSM_INN(LRK)
    LMKI = Mul(LMK,LMI)
    LMKJ = Mul(LMK,LMJ)
    if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
    NK = NK+1
    IWDL(NK) = JUST(LRK,LRI)
    IWDR(NK) = JUST(LRK,LRJ)
  end do
  ! TT(11-1) Ar(23)-Bl(32)-C"(22)-    ACT -C"-
  do LRK=LRJ+1,NORB_DZ
    LMK = LSM_INN(LRK)
    LMKI = Mul(LMK,LMI)
    LMKJ = Mul(LMK,LMJ)
    if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
    NK = NK+1
    IWDL(NK) = JUST(LRI,LRK)
    IWDR(NK) = JUST(LRJ,LRK)
  end do
  W0TT1 = W0_TT(1)
  W1TT1 = W1_TT(1)
end if

if (NK /= 0) then
  NI = mod(LRJ-LRI,2)
  if (NI == 0) then
    W0TT1 = -W0TT1
    W1TT1 = -W1TT1
  end if
  do MPL=1,MTYPE
    VPLP_W0(MPL) = VPLPNEW_W0(MPL)*W0TT1
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TT1
  end do
  NPL = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    do K=1,NK
      NPL = NPL+1
      LP_LWEI(NPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL(K))
      LP_RWEI(NPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR(K))
    end do
  end do
end if
call mma_deallocate(iwdl)
call mma_deallocate(iwdr)

return

end subroutine TT1_EXT

subroutine TS1_EXT(LRI,LRJ,NK)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         vplp_w0, vplp_w1, vplpnew_w1, w1_ts
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, mpl, ni
real(kind=wp) :: w1ts1
integer(kind=iwp), external :: iwalk_ad

LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
LMIJ = Mul(LMI,LMJ)
NK = 0
if ((JMR /= 1) .or. (LMIJ /= JML)) return
NK = 1
W1TS1 = W1_TS(1)
NI = mod(LRJ-LRI,2)
if (NI == 0) W1TS1 = -W1TS1
! TS(3-1) Ar(23)-Bl(20)-
do MPL=1,MTYPE
  VPLP_W0(MPL) = Zero
  VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TS1
end do
IWDL = JUST(LRI,LRJ)
IWDR = JUST(LRJ,LRJ)
do MPL=1,MHLP
  IWAL = LPNEW_LWEI(MPL)
  IWAR = LPNEW_RWEI(MPL)
  LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
  LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
end do

return

end subroutine TS1_EXT

subroutine TS2_EXT(LRI,LRJ,NK,IGF)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, max_innorb, &
                         mhlp, mtype, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_ts
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, igf
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, k, lmi, lmj, lmk, lmki, lmkj, lrk, mpl, ni, npl
real(kind=wp) :: w1ts2
integer(kind=iwp), allocatable :: iwdl(:), iwdr(:)
integer(kind=iwp), external :: iwalk_ad

NK = 0
LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
call mma_allocate(iwdl,max_innorb,label='iwdl')
call mma_allocate(iwdr,max_innorb,label='iwdr')
if (IGF == -1) then
  ! TS(3-2) Ar(23)-C'(22)-Bl(31)-   ACT -C"-
  do LRK=LRI+1,LRJ-1
    LMK = LSM_INN(LRK)
    LMKI = Mul(LMK,LMI)
    LMKJ = Mul(LMK,LMJ)
    if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
    NK = NK+1
    IWDL(NK) = JUST(LRI,LRK)
    IWDR(NK) = JUST(LRK,LRJ)
  end do
  W1TS2 = -W1_TS(2)
else
  ! TS(3-2) (22)Ar(23)-Bl(31)-
  do LRK=NORB_FRZ+1,LRI-1
    LMK = LSM_INN(LRK)
    LMKI = Mul(LMK,LMI)
    LMKJ = Mul(LMK,LMJ)
    if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
    NK = NK+1
    IWDL(NK) = JUST(LRK,LRI)
    IWDR(NK) = JUST(LRK,LRJ)
  end do
  W1TS2 = W1_TS(2)
end if
if (NK /= 0) then
  NI = mod(LRJ-LRI,2)
  if (NI == 0) then
    W1TS2 = -W1TS2
  end if
  do MPL=1,MTYPE
    VPLP_W0(MPL) = Zero
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TS2
  end do
  NPL = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    do K=1,NK
      NPL = NPL+1
      LP_LWEI(NPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL(K))
      LP_RWEI(NPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR(K))
    end do
  end do
end if
call mma_deallocate(iwdl)
call mma_deallocate(iwdr)

return

end subroutine TS2_EXT

subroutine TS4_EXT(LRI,LRJ,NK)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, max_innorb, &
                         mhlp, mtype, norb_dz, vplp_w0, vplp_w1, vplpnew_w1, w1_ts
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, k, lmi, lmj, lmk, lmki, lmkj, lrk, mpl, ni, npl
real(kind=wp) :: w1ts4
integer(kind=iwp), allocatable :: iwdl(:), iwdr(:)
integer(kind=iwp), external :: iwalk_ad

LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
NK = 0
! TS(3-4) Ar(23)-Bl(32)-C"(21)-
call mma_allocate(iwdl,max_innorb,label='iwdl')
call mma_allocate(iwdr,max_innorb,label='iwdr')
do LRK=LRJ+1,NORB_DZ
  LMK = LSM_INN(LRK)
  LMKI = Mul(LMK,LMI)
  LMKJ = Mul(LMK,LMJ)
  if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
  NK = NK+1
  IWDL(NK) = JUST(LRI,LRK)
  IWDR(NK) = JUST(LRJ,LRK)
end do
if (NK /= 0) then
  W1TS4 = W1_TS(4)
  NI = mod(LRJ-LRI,2)
  if (NI == 0) then
    W1TS4 = -W1TS4
  end if
  do MPL=1,MTYPE
    VPLP_W0(MPL) = Zero
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1TS4
  end do
  NPL = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    do K=1,NK
      NPL = NPL+1
      LP_LWEI(NPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL(K))
      LP_RWEI(NPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR(K))
    end do
  end do
end if
call mma_deallocate(iwdl)
call mma_deallocate(iwdr)

return

end subroutine TS4_EXT

subroutine ST1_EXT(LRI,LRJ,NK)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, mpl, ni
real(kind=wp) :: w1st1
integer(kind=iwp), external :: iwalk_ad

LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
LMIJ = Mul(LMI,LMJ)
NK = 0
if ((JML /= 1) .or. (LMIJ /= JMR)) return
NK = 1
W1ST1 = W1_ST(1)
NI = mod(LRJ-LRI,2)
if (NI == 0) W1ST1 = -W1ST1
! ST(2-1) Ar(02)-Bl(32)-
IWDL = JUST(LRI,LRI)
IWDR = JUST(LRI,LRJ)
do MPL=1,MHLP
  IWAL = LPNEW_LWEI(MPL)
  IWAR = LPNEW_RWEI(MPL)
  LP_LWEI(MPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
  LP_RWEI(MPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR)
end do
do MPL=1,MTYPE
  VPLP_W0(MPL) = Zero
  VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST1
end do

return

end subroutine ST1_EXT

subroutine ST2_EXT(LRI,LRJ,NK)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, max_innorb, &
                         mhlp, mtype, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, k, lmi, lmj, lmk, lmki, lmkj, lrk, mpl, ni, npl
real(kind=wp) :: w1st2
integer(kind=iwp), allocatable :: iwdl(:), iwdr(:)
integer(kind=iwp), external :: iwalk_ad

LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
NK = 0
! ST(2-2) (22)Ar(13)-Bl(32)-
call mma_allocate(iwdl,max_innorb,label='iwdl')
call mma_allocate(iwdr,max_innorb,label='iwdr')
do LRK=NORB_FRZ+1,LRI-1
  LMK = LSM_INN(LRK)
  LMKI = Mul(LMK,LMI)
  LMKJ = Mul(LMK,LMJ)
  if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
  NK = NK+1
  IWDL(NK) = JUST(LRK,LRI)
  IWDR(NK) = JUST(LRK,LRJ)
end do

if (NK /= 0) then
  W1ST2 = W1_ST(2)
  NI = mod(LRJ-LRI,2)
  if (NI == 0) then
    W1ST2 = -W1ST2
  end if
  do MPL=1,MTYPE
    VPLP_W0(MPL) = Zero
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST2
  end do
  NPL = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    do K=1,NK
      NPL = NPL+1
      LP_LWEI(NPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL(K))
      LP_RWEI(NPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR(K))
    end do
  end do
end if
call mma_deallocate(iwdl)
call mma_deallocate(iwdr)

return

end subroutine ST2_EXT

subroutine ST4_EXT(LRI,LRJ,NK,IGF)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, max_innorb, &
                         mhlp, mtype, norb_dz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, igf
integer(kind=iwp), intent(out) :: nk
integer(kind=iwp) :: iwal, iwar, k, lmi, lmj, lmk, lmki, lmkj, lrk, mpl, ni, npl
real(kind=wp) :: w1st4
integer(kind=iwp), allocatable :: iwdl(:), iwdr(:)
integer(kind=iwp), external :: iwalk_ad

NK = 0
LMI = LSM_INN(LRI)
LMJ = LSM_INN(LRJ)
call mma_allocate(iwdl,max_innorb,label='iwdl')
call mma_allocate(iwdr,max_innorb,label='iwdr')
if (IGF == -1) then
  ! ST(2-4) Ar(23)-C'(12)-Bl(32)-
  do LRK=LRI+1,LRJ-1
    LMK = LSM_INN(LRK)
    LMKI = Mul(LMK,LMI)
    LMKJ = Mul(LMK,LMJ)
    if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
    NK = NK+1
    IWDL(NK) = JUST(LRI,LRK)
    IWDR(NK) = JUST(LRK,LRJ)
  end do
  W1ST4 = -W1_ST(4)
else
  ! ST(2-4) Ar(23)-Bl(32)-C'(12)-
  do LRK=LRJ+1,NORB_DZ
    LMK = LSM_INN(LRK)
    LMKI = Mul(LMK,LMI)
    LMKJ = Mul(LMK,LMJ)
    if ((LMKI /= JML) .or. (LMKJ /= JMR)) cycle
    NK = NK+1
    IWDL(NK) = JUST(LRI,LRK)
    IWDR(NK) = JUST(LRJ,LRK)
  end do
  W1ST4 = W1_ST(4)
end if

if (NK /= 0) then
  NI = mod(LRJ-LRI,2)
  if (NI == 0) then
    W1ST4 = -W1ST4
  end if
  do MPL=1,MTYPE
    VPLP_W0(MPL) = Zero
    VPLP_W1(MPL) = VPLPNEW_W1(MPL)*W1ST4
  end do
  NPL = 0
  do MPL=1,MHLP
    IWAL = LPNEW_LWEI(MPL)
    IWAR = LPNEW_RWEI(MPL)
    do K=1,NK
      NPL = NPL+1
      LP_LWEI(NPL) = IWALK_AD(JPADL,IpaeL,IWAL,IWDL(K))
      LP_RWEI(NPL) = IWALK_AD(JPAD,Ipae,IWAR,IWDR(K))
    end do
  end do
end if
call mma_deallocate(iwdl)
call mma_deallocate(iwdr)

return

end subroutine ST4_EXT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine getmediate(wrk,wrksize,lun,map,rc)
! this routine reads required mediate from opened unformatted file
! with number lun, and places it starting with the %pos0
! it also reads %d and %i of the given mediate, and reconstructs
! %d to actual positions
!
! lun - Logical unit number of file, where mediate is stored (Input)
! map - map type corresponding to given mediate (Output)
! rc  - return (error) code (Output)
!
! N.B.
! all mediates are stored as follows
! 1 - Map_Type
! 2 - one record with complete mediate

use ccsd_global, only: Map_Type
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, lun
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(inout) :: map
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: length, rc1

rc = 0

!1 read %d

call getmap(lun,length,map,rc1)

!2 read mediate in one block

if (length == 0) then
  ! RC=1 : there is nothing to read, length of mediate is 0
  rc = 1
  return
end if

call rea(lun,length,wrk(map%pos0))

return

end subroutine getmediate

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetOneEl(Label)
C
C     Thomas Bondo Pedersen, February 2011
C
C     Purpose: set up data needed for evaluation of one-electron
C              integrals for operator OperatorLabel.
C              To unset, call LDF_UnsetOneEl().
C
      Implicit None
      Character*8 Label
#include "ldf_oneel.fh"

      Character*12 SecNam
      Parameter (SecNam='LDF_SetOneEl')

      If (OperatorLabel.eq.'IS_UNSET') Then
         OperatorLabel=Label
         If (OperatorLabel(1:6).eq.'Mltpl ') Then
            Call LDF_SetOneEl_Mltpl()
         Else
            Call WarningMessage(2,SecNam//': Unknown operator label')
            Write(6,'(A,A)') 'Label=',Label
            Call LDF_Quit(1)
         End If
      Else
         Call WarningMessage(2,SecNam//': info exists!')
         Write(6,'(A,A)') 'OperatorLabel=',OperatorLabel
         Write(6,'(A,A)') 'Label=',Label
         Call LDF_Quit(1)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_SetOneEl_Mltpl()
C
C     Thomas Bondo Pedersen, February 2011.
C     - based OneEl() and OneEl_() by R. Lindh.
C
C     Purpose: set up info for calculating multipole integrals.
C
      use MpmC
      use Symmetry_Info, only: nIrrep, iChBas
      use Sizes_of_Seward, only: S
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "real.fh"
#include "rmat_option.fh"
#include "ldf_oneel.fh"

      Character*18 SecNam
      Parameter (SecNam='LDF_SetOneEl_Mltpl')

      External IrrFnc, MltLbl

      Integer iTwoj(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/

      CCoor(i,j)=Coor_MPM(i,j+1)

      ! Check that active operator is a multipole operator
      ! (OperatorLabel stored in ldf_oneel.fh)
      If (OperatorLabel(1:6).ne.'Mltpl ') Then
         Call WarningMessage(2,SecNam//': not multipole operator!')
         Write(6,'(A,A)') 'Operator=',OperatorLabel
         Call LDF_Quit(1)
      End If

      ! Get multipole order from operator label
      Read(OperatorLabel(7:8),'(I2)') iMltpl

      ! Set info (transcript of drv1el() in Seward)
      rHrmt=One
      nComp=(iMltpl+1)*(iMltpl+2)/2
      l_lOper=nComp
      Call GetMem('lOper','Allo','Inte',ip_lOper,l_lOper)
      l_kOper=nComp
      Call GetMem('kOper','Allo','Inte',ip_kOper,l_kOper)
      l_CCoor=3*nComp
      Call GetMem('CCoor','Allo','Real',ip_CCoor,l_CCoor)
      l_xZeta=S%m2Max
      Call GetMem('Zeta','Allo','Real',ip_xZeta,l_xZeta)
      l_xZI=S%m2Max
      Call GetMem('ZI','Allo','Real',ip_xZI,l_xZI)
      l_xKappa=S%m2Max
      Call GetMem('Kappa','Allo','Real',ip_xKappa,l_xKappa)
      l_xPCoor=3*S%m2Max
      Call GetMem('PCoor','Allo','Real',ip_xPCoor,l_xPCoor)
      iComp=0
      Do ix=iMltpl,0,-1
         If (Mod(ix,2).eq.0) Then
            iSymX=1
         Else
            ixyz=1
            iSymX=2**IrrFnc(ixyz)
            If (CCoor(1,iMltpl).ne.Zero) Then
               iSymX=iOr(iSymX,1)
            End If
         End If
         Do iy=iMltpl-ix,0,-1
            If (Mod(iy,2).eq.0) Then
               iSymY=1
            Else
               ixyz=2
               iSymY=2**IrrFnc(ixyz)
               If (CCoor(2,iMltpl).ne.Zero) Then
                  iSymY=iOr(iSymY,1)
               End If
            End If
            iz = iMltpl-ix-iy
            If (Mod(iz,2).eq.0) Then
               iSymZ=1
            Else
               ixyz=4
               iSymZ=2**IrrFnc(ixyz)
               If (CCoor(3,iMltpl).ne.Zero) Then
                  iSymZ = iOr(iSymZ,1)
               End If
            End If
            iChO=Mod(ix,2)*iChBas(2)
     &          +Mod(iy,2)*iChBas(3)
     &          +Mod(iz,2)*iChBas(4)
            iWork(ip_lOper+iComp)=MltLbl(iSymX,MltLbl(iSymY,iSymZ))
            iWork(ip_kOper+iComp)=iChO
            Call dCopy_(3,Coor_MPM(1,iMltpl+1),1,
     &                   Work(ip_CCoor+3*iComp),1)
            iComp=iComp+1
         End Do
      End Do
      nIC=0
      llOper=0
      Do iComp=1,nComp
         llOper=iOr(llOper,iWork(ip_lOper-1+iComp))
         Do iIrrep=0,nIrrep-1
            If (iAnd(iWork(ip_lOper-1+iComp),iTwoj(iIrrep)).ne.0) Then
               nIC=nIC+1
            End If
         End Do
      End Do
      Call SOS(iStabO,nStabO,llOper)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_UnsetOneEl(Label)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: unset data needed for evaluation of one-electron
C              integrals.
C
      Implicit None
      Character*8 Label
#include "ldf_oneel.fh"
      Character*14 SecNam
      Parameter (SecNam='LDF_UnsetOneEl')
      Character*8 ucLabel

      If (OperatorLabel.eq.'IS_UNSET') Then
#if defined (_DEBUGPRINT_)
         Call WarningMessage(0,SecNam//': nothing to do, returning')
         Call xFlush(6)
#endif
         Return
      Else
         ucLabel=Label
         Call UpCase(ucLabel)
         If (ucLabel.eq.'DUMMYLBL' .or. Label.eq.OperatorLabel) Then
            If (l_xPCoor.gt.0) Then
               Call GetMem('PCoor','Free','Real',ip_xPCoor,l_xPCoor)
               ip_xPCoor=0
               l_xPCoor=0
            End If
            If (l_xKappa.gt.0) Then
               Call GetMem('Kappa','Free','Real',ip_xKappa,l_xKappa)
               ip_xKappa=0
               l_xKappa=0
            End If
            If (l_xZI.gt.0) Then
               Call GetMem('ZI','Free','Real',ip_xZI,l_xZI)
               ip_xZI=0
               l_xZI=0
            End If
            If (l_xZeta.gt.0) Then
               Call GetMem('Zeta','Free','Real',ip_xZeta,l_xZeta)
               ip_xZeta=0
               l_xZeta=0
            End If
            If (l_CCoor.gt.0) Then
               Call GetMem('CCoor','Free','Real',ip_CCoor,l_CCoor)
               ip_CCoor=0
               l_CCoor=0
            End If
            If (l_kOper.gt.0) Then
               Call GetMem('kOper','Free','Inte',ip_kOper,l_kOper)
               ip_kOper=0
               l_kOper=0
            End If
            If (l_lOper.gt.0) Then
               Call GetMem('lOper','Free','Inte',ip_lOper,l_lOper)
               ip_lOper=0
               l_lOper=0
            End If
            Call iZero(iStabO,8)
            nStabO=0
            nIC=0
            nComp=0
            rHrmt=-9.9d9
            OperatorLabel='IS_UNSET'
         Else
            Call WarningMessage(2,SecNam//': Label mismatch!')
            Write(6,'(A,A,/,A,A)')
     &      'Label=',Label,'OperatorLabel=',OperatorLabel
            Call LDF_Quit(1)
         End If
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jeppe Olsen                                            *
************************************************************************
      SUBROUTINE ADD_STR_GROUP( NSTADD, IOFADD, ISTADD,   NSTB,   NSTA,
     &                         ISTRING,  IELOF, NELADD, NELTOT)
*
* Part of assembling strings in individual types to
* super group of strings
*
*. Copying strings belonging to a given type to supergroup of strings
*
* Jeppe Olsen, for once improving performance of LUCIA
*
*.Input
* =====
* NSTADD : Number of strings to be added
* IOFADD : First string to be added
* ISTADD : Strings to be added
* NSTB   : Number of strings belonging to lower gasspaces
* NSTA   : Number of strings belonging to higher gasspaces
* ISTRING: Supergroup of strings under construction
* IELOF  : Place of first electron to be added
* NELADD : Number of electrons to be added
* NELTOT : Total number of electrons
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
C     DIMENSION ISTADD(NELADD,*)
      DIMENSION ISTADD(*)
*. Input and output
C     DIMENSION ISTRING(NELTOT,*)
      DIMENSION ISTRING(*)
*
C?    WRITE(6,*) '  Inside ADD ... '
      IF(NSTA.GT.1) THEN
        DO IISTR = 1,NSTADD
*. Address of A(1,IISTR,1)
*. A(I(after),Igas,I(before))
          IOFFY = (IOFADD-2+IISTR)*NELADD
          IOFF1 = (IISTR-1)*NSTA + 1
          IADD2 = NSTADD*NSTA
          IOFF2 = IOFF1 - IADD2
          DO ISTB = 1, NSTB
*. Address of A(1,IISTR,ISTB)
C           IOFF2 = IOFF1 + (ISTB-1)*NSTADD*NSTA
            IOFF2 = IOFF2 + IADD2
            IOFFX = IELOF-1+(IOFF2-2)*NELTOT
            DO ISTA = 1, NSTA
              IOFFX = IOFFX + NELTOT
              DO JEL = 1, NELADD
                ISTRING(JEL+IOFFX)
     &        = ISTADD(JEL+IOFFY)
C               ISTRING(IELOF-1+JEL,IOFF2-1+ISTA)
C    &        = ISTADD(JEL,IOFADD-1+IISTR)
              END DO
            END DO
          END DO
        END DO
      ELSE IF (NSTA .EQ. 1 ) THEN
*. Address of A(1,IISTR,1)
*. A(I(after),Igas,I(before))
        DO ISTB = 1, NSTB
          IOFF0 = (ISTB-1)*NSTADD
          IOFFY  = (IOFADD-2)*NELADD
          IOFFX = IELOF-1+(IOFF0-1)*NELTOT
          DO IISTR = 1,NSTADD
*. Address of A(1,IISTR,ISTB)
C           IOFF2 = IISTR  + IOFF0
C           IOFFX  = IELOF-1+(IOFF2-1)*NELTOT
            IOFFX  = IOFFX + NELTOT
            IOFFY  = IOFFY + NELADD
            DO JEL = 1, NELADD
              ISTRING(JEL+IOFFX)
     &      = ISTADD( JEL+IOFFY)
C             ISTRING(IELOF-1+JEL+(IOFF2-1)*NELTOT)
C    &      = ISTADD(JEL+(IOFADD-1+IISTR-1)*NELADD)
C             ISTRING(IELOF-1+JEL,IOFF2)
C    &      = ISTADD(JEL,IOFADD-1+IISTR)
            END DO
C?          WRITE(6,*) ' New string from ADD '
C?          CALL IWRTMA(ISTRING(IOFFX+1),1,NELADD,1,NELADD)
C?          WRITE(6,*) ' IOFFX, IOFFY, NELADD',
C?   &                   IOFFX, IOFFY, NELADD
          END DO
        END DO
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Francesco Aquilante                              *
************************************************************************
      SubRoutine Cho_SOSmp2_DecChk(irc,iSym,Col,nDim,nCol,Wrk,lWrk,
     &                             ErrStat)
C
C     Francesco Aquilante, May 2007.
C
C     Purpose: check Scaled Opposite-Spin MP2 decomposition of
C              M(ai,bj)=(ai|bj)^2 for sym. block iSym.
C              The columns of the M matrix (actually, the sqrt of
C              their elements) are compared nCol columns at a time
C              with the corresponding integrals obtained from the
C              Cholesky (or RI) vectors.
C              The memory requirement of this routine
C              should be limited to approximately that of the
C              decomposition itself. Note, however, that since all
C              elements are computed, this routine will consume
C              significantly more CPU time.
C              Files are assumed open.
C              On exit,
C              ErrStat(1) = min error
C              ErrStat(2) = max error
C              ErrStat(3) = rms error
C
#include "implicit.fh"
      Real*8  Col(nDim,nCol), Wrk(lWrk), ErrStat(3)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"
#include "WrkSpc.fh"

      external ddot_

      Character*6  ThisNm
      Character*17 SecNam
      Parameter (SecNam = 'Cho_SOSmp2_DecChk', ThisNm = 'DecChk')

      irc = 0

C     Check dimensions.
C     -----------------

      If (nDim.lt.1 .or. nCol.lt.1) Return
      If (nDim .ne. nT1am(iSym)) Then
         irc = -1
         Go To 1 ! exit
      End If

C     Initialize.
C     -----------

      ErrStat(1) =  9.9d15
      ErrStat(2) = -9.9d15
      ErrStat(3) =  0.0d0

C     Set up batching over columns of the (ai|bj) matrix.
C     ---------------------------------------------------

      NumCol  = min(nCol,nT1am(iSym))
      nBatCol = (nT1am(iSym) - 1)/NumCol + 1

C     Start column batch loop.
C     ------------------------

      Nai = nDim
      Do iBatCol = 1,nBatCol

C        Set batch info.
C        ---------------

         If (iBatCol .eq. nBatCol) Then
            Nbj = nT1am(iSym) - NumCol*(nBatCol - 1)
         Else
            Nbj = NumCol
         End If
         ibj1 = NumCol*(iBatCol - 1) + 1

C        Compute  M(ai,bj)=(ai|bj)^2  from "new" vectors.
C        -----------------------------------------------

         lU     = lUnit_F(iSym,2)
         NumVec = nMP2Vec(iSym)
         Fac    = 0.0d0
         Call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,
     &                          Wrk,lWrk,Fac)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': Cho_SOSmp2_DecChk_Int  rc= ',irc,' [1]'
            irc = 1
            Return
         End If

C        Obtain the (ai|bj) integrals from M(ai,bj) .
C        --------------------------------------------

         Do kbj = 1,Nbj
            Do kai = 1,Nai
               Col(kai,kbj) = sqrt(Col(kai,kbj))
            End Do
         End Do


C        Compute "old" and subtract "new".
C        ---------------------------------

         If (InCore(iSym)) Then
            kOff1 = ip_OldVec
            kOff2 = ip_OldVec + ibj1 - 1
            Call DGEMM_('N','T',Nai,Nbj,NumCho(iSym),
     &                 1.0d0,Work(kOff1),Nai,Work(kOff2),Nai,
     &                 -1.0d0,Col,Nai)
         Else
            lU     = lUnit_F(iSym,1)
            NumVec = NumCho(iSym)
            Fac    = -1.0d0
            Call ChoMP2_DecChk_Int(irc,lU,Col,Nai,Nbj,ibj1,NumVec,
     &                             Wrk,lWrk,Fac)
            If (irc .ne. 0) Then
               Write(6,*)SecNam,': Cho_SOSmp2_DecChk_Int returned ',irc,
     &                   ' [2]'
               irc = 2
               Return
            End If
         End If

C        Compute error stats.
C        --------------------

         Do kbj = 1,Nbj
            Do kai = 1,Nai
               ErrStat(1) = min(ErrStat(1),Col(kai,kbj))
               ErrStat(2) = max(ErrStat(2),Col(kai,kbj))
            End Do
         End Do
         ErrStat(3) = ErrStat(3) + dDot_(Nai*Nbj,Col,1,Col,1)

      End Do

C     Compute rms error.
C     ------------------

      xdim = dble(Nai)*dble(Nai)
      ErrStat(3) = sqrt(ErrStat(3)/xdim)

    1   Continue
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CMP_IVEC_ILIST(IVEC,ILIST,LLIST,NLIST,INUM)
! An integer IVEC of LLIST entries are given.
! compare with list of vectors in ILIST and find first
! vector in LLIST that is identical to IVEC.
!
! If INUM = 0, the list was not found
!
! Jeppe Olsen, December 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: LLIST, IVEC(LLIST), NLIST, ILIST(LLIST,NLIST)
integer(kind=iwp), intent(out) :: INUM
integer(kind=iwp) :: IELMNT, JLIST

INUM = 0
do JLIST=1,NLIST
  do IELMNT=1,LLIST
    if (IVEC(IELMNT) /= ILIST(IELMNT,JLIST)) exit
  end do
  if (IELMNT > LLIST) then
    INUM = JLIST
    exit
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Input list :'
call IWRTMA(IVEC,1,LLIST,1,LLIST)
write(u6,*) ' Address of list : ',INUM
#endif

end subroutine CMP_IVEC_ILIST

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ColTss(IOut,Colour,C1,C2,C3)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IOut
character(len=*), intent(in) :: Colour
real(kind=wp), intent(out) :: C1, C2, C3

! Assign tesserae colours for GeomView:

if (Colour == 'White') then
  C1 = 1.0_wp
  C2 = 1.0_wp
  C3 = 1.0_wp
else if (Colour == 'Gray') then
  C1 = 0.66_wp
  C2 = 0.66_wp
  C3 = 0.66_wp
else if ((Colour == 'Blue') .or. (Colour == 'Dark Blue')) then
  C1 = 0.0_wp
  C2 = 0.0_wp
  C3 = 1.0_wp
else if (Colour == 'Light Blue') then
  C1 = 0.0_wp
  C2 = 1.0_wp
  C3 = 1.0_wp
else if (Colour == 'Green') then
  C1 = 0.0_wp
  C2 = 1.0_wp
  C3 = 0.0_wp
else if (Colour == 'Yellow') then
  C1 = 1.0_wp
  C2 = 1.0_wp
  C3 = 0.0_wp
else if (Colour == 'Orange') then
  C1 = 1.0_wp
  C2 = 0.5_wp
  C3 = 0.0_wp
else if (Colour == 'Violet') then
  C1 = 0.6_wp
  C2 = 0.0_wp
  C3 = 1.0_wp
else if ((Colour == 'Pink') .or. (Colour == 'Light Red')) then
  C1 = 1.0_wp
  C2 = 0.5_wp
  C3 = 1.0_wp
else if (Colour == 'Fuchsia') then
  C1 = 1.0_wp
  C2 = 0.0_wp
  C3 = 1.0_wp
else if ((Colour == 'Red') .or. (Colour == 'Dark Red')) then
  C1 = 1.0_wp
  C2 = 0.0_wp
  C3 = 0.0_wp
else if (Colour == 'Black') then
  C1 = 0.0_wp
  C2 = 0.0_wp
  C3 = 0.0_wp
else
  C1 = 0.0_wp  ! dummy assignement
  C2 = 0.0_wp  ! dummy assignement
  C3 = 0.0_wp  ! dummy assignement
  write(IOut,'(a)') 'Unrecognized colour in ColTss'
  call Abend()
end if

return

end subroutine ColTss

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,1994, Per Ake Malmqvist                           *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine FMAT_CASPT2(FIFA,nFIFA,FIMO,NFIMO,DREF,NDREF,HONE,nHONE)
! COMPUTE THE INACTIVE FOCK MATRIX IN MO BASIS.
! COMPUTE THE ACTIVE FOCK MATRIX IN MO BASIS.
! DEFINITIONS ARE:
! FIMO(P,Q)= H(P,Q)+ SUM( (2*(PQ,KK)-(PK,QK)) OVER INACTIVE K)
! WHERE H(P,Q) IS THE CORE FOCK MATRIX OBTAINED FROM THE
! TRANSFORMATION PART, I.E., THE CI 1-ELECTRON HAMILTONIAN.
! SIMILARLY,
! FAMO(P,Q)= (1/2)*SUM( (2*(PQ,TU)-(PU,QT))*DREF(T,U) OVER ACTIVE T,U)
! THIS ROUTINE USES DIRECTLY THE TRANSFORMED INTEGRALS TO SET UP
! FIMO AND FAMO.
! CODED 92-12-04 BY MALMQVIST FOR CASPT2, MOLCAS-3 VERSION.

use Index_Functions, only: iTri, nTri_Elem
use caspt2_global, only: LUINTM
use caspt2_module, only: NAES, NISH, NoMx, NORB, NOSH, NoTri, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nFIFA, NFIMO, NDREF, nHONE
real(kind=wp), intent(out) :: FIFA(nFIFA), FIMO(NFIMO)
real(kind=wp), intent(in) :: DREF(NDREF), HONE(nHONE)
integer(kind=iwp) :: IAD2M(3,36*36), IDISK, IDISK1, IFSTA, IS3PQ, IS3RS, ISADDR, ISYQ, ISYS, ITABS, ITU, IUABS, NAESP, NB3, NBNB, &
                     NBR, nBUF, NDIM2M, nInts, NIP, NOP
real(kind=wp) :: DTU
real(kind=wp), allocatable :: BUF(:)

! Inactive and active Fock matrices:
FIMO(:) = Zero
FIFA(:) = Zero ! ued temporarily as FAMO

! notri=Size of an array with symmetry-blocked triangular
! submatrices, using non-frozen, non-deleted MO indices.
! NBUF=Max size of a LUINTM buffer.
NBUF = max(NOMX**2,notri)
call mma_allocate(BUF,NBUF,Label='BUF')

NDIM2M = (NSYM*(NSYM+1))/2
IDISK = 0
call IDAFILE(LUINTM,2,IAD2M,3*36*36,IDISK)

call Do_Loops(1) ! Do Coulomb contributions
call Do_Loops(2) ! Do exchange contributions

call mma_deallocate(BUF)

! FIMO comes from contractions over inactive orbitals, while FAMO from
! contractions over active orbitals and therefore are summed up together
! here into FIFA.

FIMO(1:notri) = FIMO(1:notri)+HONE(1:notri)
FIFA(1:notri) = FIFA(1:notri)+FIMO(1:notri)

contains

subroutine Do_Loops(icase)

  integer(kind=iwp), intent(in) :: iCase
  integer(kind=iwp) :: ISYP, ISYR, IT, IU

  IFSTA = 1
  do ISYR=1,NSYM
    NBR = NORB(ISYR)
    if (NBR == 0) cycle
    NB3 = nTri_Elem(NBR)
    NBNB = NBR**2
    ISYS = ISYR
    IS3RS = nTri_Elem(ISYR)
    do ISYP=1,NSYM
      NIP = NISH(ISYP)
      NOP = NOSH(ISYP)
      NAESP = NAES(ISYP)
      if (NOP == 0) cycle
      ISYQ = ISYP
      IS3PQ = nTri_Elem(ISYP)
      ISADDR = IS3RS+NDIM2M*(IS3PQ-1)
      IDISK1 = IAD2M(iCase,ISADDR)
      if (IDISK1 == 0) then
        if (iCase == 1) then
          write(u6,*) ' FMAT: COULOMB INTEGRAL BUFFER MISSING!'
        else
          write(u6,*) ' FMAT: EXCH-1  INTEGRAL BUFFER MISSING!'
        end if
        write(u6,'(1X,A,4I4)') 'SYMMETRY BLOCK:',ISYP,ISYQ,ISYR,ISYS
        call ABEND()
      end if
      if (iCase == 1) then
        nInts = NB3
      else
        nInts = NBNB
      end if

      do IT=1,NOP
        do IU=1,IT

          ! Process here contributions to FIMO or FAMO.

          if ((IT <= NIP) .and. (IT == IU)) then
            call DDAFILE(LUINTM,2,BUF,nInts,IDISK1)
            if (iCase == 1) then
              ! ADD 2* BUFFER INTO CORRECT POSITION OF  FIMO.
              FIMO(IFSTA:IFSTA+NB3-1) = FIMO(IFSTA:IFSTA+NB3-1)+Two*BUF(1:NB3)
            else
              call TRIANG(NBR,BUF)
              ! ADD -1* BUFFER INTO CORRECT POSITION OF  FIMO.
              FIMO(IFSTA:IFSTA+NB3-1) = FIMO(IFSTA:IFSTA+NB3-1)-BUF(1:NB3)
            end if
          else if ((IT > NIP) .and. (IT <= NOP) .and. (IU > NIP) .and. (IU <= NOP)) then
            ITABS = NAESP+(IT-NIP)
            IUABS = NAESP+(IU-NIP)
            ITU = iTri(ITABS,IUABS)
            DTU = DREF(ITU)
            if (IT == IU) DTU = half*DTU
            call DDAFILE(LUINTM,2,BUF,nInts,IDISK1)
            if (iCase == 1) then
              FIFA(IFSTA:IFSTA+NB3-1) = FIFA(IFSTA:IFSTA+NB3-1)+Two*DTU*BUF(1:NB3)
            else
              call TRIANG(NBR,BUF)
              FIFA(IFSTA:IFSTA+NB3-1) = FIFA(IFSTA:IFSTA+NB3-1)-DTU*BUF(1:NB3)
            end if
          else
            call DDAFILE(LUINTM,0,BUF,nInts,IDISK1)
          end if

        end do
      end do

    end do
    IFSTA = IFSTA+NB3
  end do
end subroutine Do_Loops

end subroutine FMAT_CASPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mmstringen_cvb(norb,nel,locc,lunocc,nstring,
     >  nkmin,nkmax)
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension locc(*),lunocc(*)
      dimension nkmin(0:norb),nkmax(0:norb)

      i_nk    = mstacki_cvb(norb+1)
c Spin string loop initialization (use xdet as graph storage) :
      call imove_cvb(nkmax,iw(i_nk),norb+1)
c  Spin string loop starts here :
      index=0
100   index=index+1
      i_locc=(index-1)*nel+1
      i_lunocc=(index-1)*(norb-nel)+1
      call occupy_cvb(iw(i_nk),norb,locc(i_locc),lunocc(i_lunocc))
      call loop_cvb(norb,iw(i_nk),nkmin,nkmax,*100)
      call mfreei_cvb(i_nk)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(nstring)
      end
      real*8 function party_cvb(iperm,n)
c  Returns parity of permutation
      implicit real*8(a-h,o-z)
      dimension iperm(n)
#include "malloc_cvb.fh"

      i1 = mstacki_cvb(n)
      call imove_cvb(iperm,iw(i1),n)
      call party2_cvb(iw(i1),n,party)
      call mfreei_cvb(i1)
      party_cvb=party
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine AbsAdd(nVec,Vec1,inc1,Vec2,inc2)
************************************************************************
*                                                                      *
* Object: to add the absolute values of a vector to another vector.    *
*         The square root due to the Cauchy-Schwatz equation.          *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             May '92.                                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Vec1(1+(nVec-1)*Inc1), Vec2(1+(nVec-1)*Inc2)
*
      Do 10 iVec = 1, nVec
         Vec2(1+(iVec-1)*Inc2) = Vec2(1+(iVec-1)*Inc2) +
     &                  Sqrt(Abs(Vec1(1+(iVec-1)*Inc1)))
 10   Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Write_Input()

use stdalloc, only: mma_Allocate, mma_Deallocate
use Definitions, only: wp, iwp
use Constants, only: Angstrom

implicit none
integer(kind=iwp) :: LU, nAtoms, i
real(kind=wp), allocatable :: Coord(:,:)
character(len=2), allocatable :: Symbol(:)
integer(kind=iwp), external :: IsFreeUnit

! read data from RUNFILE
call Get_nAtoms_All(nAtoms)
call mma_Allocate(Coord,3,nAtoms,label='Coord')
call mma_Allocate(Symbol,nAtoms,label='Symbol')
call Get_Coord_All(Coord,nAtoms)
call Get_Name_All(Symbol)

! write interface input file
LU = IsFreeUnit(11)
call Molcas_Open(LU,'INPUT')
write(LU,100) '[XYZ]'
write(LU,101) nAtoms
write(LU,100) 'angstrom'
do i=1,nAtoms
  write(LU,102) Symbol(i),Angstrom*Coord(:,i)
end do
close(LU)

! clean up
call mma_Deallocate(Coord)
call mma_Deallocate(Symbol)

return

100 format(a)
101 format(i6)
102 format(a2,1x,3f20.12)

end subroutine Write_Input

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998,2006, Per Ake Malmqvist                           *
*               2019, Stefano Battaglia                                *
************************************************************************
*--------------------------------------------*
* 1998, 2006, Per Ake Malmqvist              *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
* 2006 update: Use RAS1..RAS3
*--------------------------------------------*
      SUBROUTINE GRDCTL(HEFF)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
#include "SysDef.fh"
      DIMENSION HEFF(NSTATE,NSTATE)

C Purpose: Compute three sets of quantities, needed by MCLR, used to
C compute forces and derivatives.


C--------------------------------------------------------------------
C (A):
C The active/active density matrix contribution <Psi_1| Etu |Psi_1>
C and all the rest was already computed in the PRPCTL section.

C--------------------------------------------------------------------
C (B):
C Compute also (Proj_CAS)*(Ham)*(Wave op) | Psi_0 >
C and (Proj_CAS)*((Wave op)**(dagger))*(Ham) | Psi_0 >.
C Read the Psi_0 wave function:
      CALL GETMEM('GRDCI','ALLO','REAL',LCI,NCONF)
      IF(ISCF.EQ.0) THEN
C This is an ordinary CASSCF or RASSCF calculation.
       ID=IDTCEX
       DO I=1,JSTATE-1
         CALL DDAFILE(LUCIEX,0,WORK(LCI),NCONF,ID)
       END DO
       CALL DDAFILE(LUCIEX,2,WORK(LCI),NCONF,ID)
      ELSE
       WORK(LCI)=1.0D0
      END IF

      IF(ORBIN.EQ.'TRANSFOR') THEN
C Read, and transpose, the active orbital transformation matrices
        CALL DCOPY_(NTAT,[0.0D0],0,WORK(LTAT),1)
        IOFF1=0
        IOFF2=0
        DO ISYM=1,NSYM
          NI=NISH(ISYM)
          NR1=NRAS1(ISYM)
          NR2=NRAS2(ISYM)
          NR3=NRAS3(ISYM)
          NA=NASH(ISYM)
          NS=NSSH(ISYM)
* Skip inactive transformation matrix:
          IOFF1=IOFF1+NI**2
* Copy RAS1 transformation matrix transposed to TAT:
          DO I=1,NR1
            DO J=1,NR1
              IJ=I+NR1*(J-1)
              JI=J+NR1*(I-1)
              WORK(LTAT-1+IOFF2+JI)=WORK(LTORB-1+IOFF1+IJ)
            END DO
          END DO
          IOFF1=IOFF1+NR1**2
          IOFF2=IOFF2+NR1**2
* Copy RAS2 transformation matrix transposed to TAT:
          DO I=1,NR2
            DO J=1,NR2
              IJ=I+NR2*(J-1)
              JI=J+NR2*(I-1)
              WORK(LTAT-1+IOFF2+JI)=WORK(LTORB-1+IOFF1+IJ)
            END DO
          END DO
          IOFF1=IOFF1+NR2**2
          IOFF2=IOFF2+NR2**2
* Copy RAS2 transformation matrix transposed to TAT:
          DO I=1,NR3
            DO J=1,NR3
              IJ=I+NR3*(J-1)
              JI=J+NR3*(I-1)
              WORK(LTAT-1+IOFF2+JI)=WORK(LTORB-1+IOFF1+IJ)
            END DO
          END DO
          IOFF1=IOFF1+NR3**2
          IOFF2=IOFF2+NR3**2
* Skip virtual transformation matrix:
          IOFF1=IOFF1+NS**2
        END DO
      END IF

      NSG=NCONF
      CALL GETMEM('GRDSGM','ALLO','REAL',LSGM,NSG)
C Compute (Proj_CAS)*(Ham)*(Wave op) acting on Psi_0:
      CALL DCOPY_(NCONF,[0.0D0],0,WORK(LSGM),1)
      IF(ISCF.EQ.0) THEN
       CALL W1TW2(IVECW,IVECC,WORK(LCI),WORK(LSGM))
      ELSE
       WORK(LSGM)=E2TOT*WORK(LCI)
      END IF
      IF(IFMSCOUP) THEN
C Multi-State HEFF:
C Loop over all the other root states, and compute off-diagonal
C effective Hamiltonian matrix elements.
        CALL GETMEM('BRACI','ALLO','REAL',LBRACI,NCONF)
        ID=IDTCEX
        DO ISTATE=1,NSTATE
          IF(ISTATE.NE.JSTATE) THEN
            CALL DDAFILE(LUCIEX,2,WORK(LBRACI),NCONF,ID)
            VALUE=DDOT_(NCONF,WORK(LBRACI),1,WORK(LSGM),1)
          ELSE
            CALL DDAFILE(LUCIEX,0,WORK(LBRACI),NCONF,ID)
            VALUE=E2TOT
          END IF
        END DO
        CALL GETMEM('BRACI','FREE','REAL',LBRACI,NCONF)
      END IF
C-End of Multi-State insert -----------------------------------------

      IF(ORBIN.EQ.'TRANSFOR') THEN
C Transform SGM to use original MO:
        ITOEND=0
        DO ISYM=1,NSYM
         NI=NISH(ISYM)
         NA=NASH(ISYM)
         NR1=NRAS1(ISYM)
         NR2=NRAS2(ISYM)
         NR3=NRAS3(ISYM)
         NS=NSSH(ISYM)
         NO=NORB(ISYM)
         NB=NBAS(ISYM)
         ITOSTA=ITOEND+1
         ITOEND=ITOEND+NR1**2+NR2**2+NR3**2
*         ITO=ITOSTA+NI**2
         ITO=ITOSTA
         IF(NR1.GT.0) THEN
           ISTART=NAES(ISYM)+1
           CALL TRACI_RPT2(ISTART,NR1,WORK(LTAT-1+ITO),LSYM,
     &                                           NSG,WORK(LSGM))
         END IF
         ITO=ITO+NR1**2
         IF(NR2.GT.0) THEN
           ISTART=NAES(ISYM)+NR1+1
           CALL TRACI_RPT2(ISTART,NR2,WORK(LTAT-1+ITO),LSYM,
     &                                          NSG,WORK(LSGM))
         END IF
         ITO=ITO+NR2**2
         IF(NR3.GT.0) THEN
           ISTART=NAES(ISYM)+NR1+NR2+1
           CALL TRACI_RPT2(ISTART,NR1,WORK(LTAT-1+ITO),LSYM,
     &                                          NSG,WORK(LSGM))
         END IF
        END DO
      END IF

C-Multi-State insert ------------------------------------------------
C In Multi-State calculations, it is very convenient to use the opportunity
C here, when the SGM wave function is available, to compute the coupling
C elements in Heff simply by contraction with the bra CAS functions.
      IF(IFMSCOUP) THEN
C Multi-State HEFF:
C Loop over all the other root states, and compute off-diagonal
C effective Hamiltonian matrix elements. Given that the SGM
C wave function is available, this is a very efficient way of
C computing the multi-state coupling elements.
        CALL GETMEM('BRACI','ALLO','REAL',LBRACI,NCONF)
        ID=IDTCEX
        DO ISTATE=1,NSTATE
          IF(ISTATE.NE.JSTATE) THEN
            CALL DDAFILE(LUCIEX,2,WORK(LBRACI),NCONF,ID)
            HEFF(ISTATE,JSTATE)=HEFF(ISTATE,JSTATE) +
     &      DDOT_(NCONF,WORK(LBRACI),1,WORK(LSGM),1)
          ELSE
            CALL DDAFILE(LUCIEX,0,WORK(LBRACI),NCONF,ID)
            HEFF(JSTATE,JSTATE)=HEFF(JSTATE,JSTATE)+E2CORR
          END IF
        END DO
        CALL GETMEM('BRACI','FREE','REAL',LBRACI,NCONF)
      END IF
C-End of Multi-State insert -----------------------------------------

C Similar, but (Proj_CAS)*((Wave op)**(dagger))*(Ham) | Psi_0 >.
      CALL DCOPY_(NCONF,[0.0D0],0,WORK(LSGM),1)
      IF(ISCF.EQ.0) THEN
       CALL W1TW2(IVECC,IVECW,WORK(LCI),WORK(LSGM))
      ELSE
       WORK(LSGM)=E2TOT*WORK(LCI)
      END IF

      IF(ORBIN.EQ.'TRANSFOR') THEN
C Transform SGM to use original MO:
        ITOEND=0
        DO ISYM=1,NSYM
         NI=NISH(ISYM)
         NA=NASH(ISYM)
         NR1=NRAS1(ISYM)
         NR2=NRAS2(ISYM)
         NR3=NRAS3(ISYM)
         NS=NSSH(ISYM)
         NO=NORB(ISYM)
         NB=NBAS(ISYM)
         ITOSTA=ITOEND+1
         ITOEND=ITOEND+NR1**2+NR2**2+NR3**2
*         ITO=ITOSTA+NI**2
         ITO=ITOSTA
         IF(NR1.GT.0) THEN
           ISTART=NAES(ISYM)+1
           CALL TRACI_RPT2(ISTART,NR1,WORK(LTAT-1+ITO),LSYM,
     &                                          NSG,WORK(LSGM))
         END IF
         ITO=ITO+NR1**2
         IF(NR2.GT.0) THEN
           ISTART=NAES(ISYM)+NR1+1
           CALL TRACI_RPT2(ISTART,NR2,WORK(LTAT-1+ITO),LSYM,
     &                                          NSG,WORK(LSGM))
         END IF
         ITO=ITO+NR2**2
         IF(NR3.GT.0) THEN
           ISTART=NAES(ISYM)+NR1+NR2+1
           CALL TRACI_RPT2(ISTART,NR1,WORK(LTAT-1+ITO),LSYM,
     &                                          NSG,WORK(LSGM))
         END IF
        END DO
      END IF


C--------------------------------------------------------------------
C (C):
C Compute also < Psi_0 | Epq | Psi_1 > and < Psi_0 | Epqrs | Psi_1 >.
C Actually, the first was already computed in PRPCTL.

C ... Unfinished code.
C--------------------------------------------------------------------

      CALL GETMEM('GRDSGM','FREE','REAL',LSGM,NSG)
      CALL GETMEM('GRDCI','FREE','REAL',LCI,NCONF)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRCEVC(NSS,FRAC,SOENE,MAPST,MAPSP,MAPMS,UMATR,UMATI)

use rassi_aux, only: ipglob
use Cntrl, only: NSTATE
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSS, MAPST(NSS), MAPSP(NSS), MAPMS(NSS)
real(kind=wp), intent(in) :: FRAC, SOENE(NSS), UMATR(NSS,NSS), UMATI(NSS,NSS)
integer(kind=iwp) :: I, IMAXSTATE, ISS, ISTATE, JEND, JSS, JSTA, nmax(5), NW
real(kind=wp) :: CFFLIM, S, smax(5), SSMAX, SZ, TST, WGTMAX, wmax(5), XMAX
real(kind=wp), allocatable :: sstate(:), weight(:)

call mma_allocate(weight,nss)
call mma_allocate(sstate,nss)

if (IPGLOB >= 3) then
  ! Write out the complex eigenvectors of the spin-orbit states.
  ! Four states at a time are written out.
  ! They are written as complex numbers, four on each line.
  ! Coefficients are written out if any of the four complex coeffs
  ! on the same line have absolute value at least as large as
  ! a certain fraction (FRAC) of the largest such value for the
  ! foursome of states.
  do JSTA=1,NSS,4
    JEND = min(NSS,JSTA+3)
    write(u6,*)
    write(u6,'(1X,A16,F16.8,3(2X,F16.8))') '    Energy (au) ',(SOENE(JSS),JSS=JSTA,JEND)
    write(u6,'(1X,A16,6X,I4,3(14X,I4))') ' SFS  S     Ms  ',(JSS,JSS=JSTA,JEND)
    ! Scan coefficients to pick out the largest:
    WGTMAX = maxval(UMATR(:,JSTA:JEND)**2+UMATI(:,JSTA:JEND)**2)

    ! Scan coefficients, write if large enough:
    CFFLIM = FRAC*sqrt(WGTMAX)
    do ISS=1,NSS
      ISTATE = MAPST(ISS)
      S = Half*real(MAPSP(ISS)-1,kind=wp)
      SZ = Half*real(MAPMS(ISS),kind=wp)
      TST = maxval(UMATR(ISS,JSTA:JEND)**2+UMATI(ISS,JSTA:JEND)**2)
      if (TST >= CFFLIM**2) &
        write(u6,'(I4,1X,F4.1,1X,F5.1,3X,4(A1,F7.4,A1,F7.4,A1,1x))') ISTATE,S,SZ, &
                                                                     ('(',UMATR(ISS,JSS),',',UMATI(ISS,JSS),')',JSS=JSTA,JEND)
    end do
  end do
else if (IPGLOB >= 2) then
  ! Write out the weights of the five most important spin-free states
  ! For each spin-orbit state (BOR in Krapperup 070226)

  write(u6,*)
  write(u6,*)
  write(u6,*) 'Weights of the five most important spin-orbit-free states for each spin-orbit state.'
  write(u6,*)
  write(u6,*) 'SO State  Total energy (au)           Spin-free states, spin, and weights'
  write(u6,*) '-------------------------------------------------------------------------------------------------------'
  do iss=1,nss
    weight(1:nstate) = Zero
    do jss=1,nss
      istate = mapst(jss)
      sstate(istate) = Half*real(mapsp(jss)-1,kind=wp)
      weight(istate) = weight(istate)+umatr(jss,iss)**2+umati(jss,iss)**2
    end do
    ! Sort the weights
    imaxstate = 0
    do
      xmax = Zero
      ssmax = Zero
      nw = 0
      do istate=1,nstate
        if (weight(istate) >= xmax) then
          nw = istate
          xmax = weight(istate)
          ssmax = sstate(istate)
        end if
      end do
      weight(nw) = -One
      imaxstate = imaxstate+1
      nmax(imaxstate) = nw
      wmax(imaxstate) = xmax
      smax(imaxstate) = ssmax
      if (imaxstate >= min(nstate,5)) exit
    end do

    write(u6,'(i5,1x,f16.6,3x,5(i5,f4.1,f8.4))') iss,soene(iss),(nmax(i),smax(i),wmax(i),i=1,(min(nstate,5)))

  end do
  write(u6,*) '-------------------------------------------------------------------------------------------------------'
end if

! Added by Ungur Liviu on 04.11.2009
! Addition of UMATR and UMATI on RunFile

call Put_dArray('UMATR_SINGLE',UMATR,NSS**2)
call Put_dArray('UMATI_SINGLE',UMATI,NSS**2)

call mma_deallocate(weight)
call mma_deallocate(sstate)

end subroutine PRCEVC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Print_OpInfo()

#ifdef _EFP_
use EFP_Module, only: ABC, Coor_Type, EFP_Coors, FRAG_TYPE, nEFP_fragments, POINTS_type, ROTMAT_type, XYZABC_type
use EFP, only: EFP_PRINT_BANNER
#endif
use External_Centers, only: DMS_Centers, Dxyz, EF_Centers, iXPolType, nData_XF, nDMS, nEF, nOrd_XF, nOrdEF, nWel, nXF, Wel_Info, XF
use Symmetry_Info, only: nIrrep
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
#include "print.fh"
#include "rmat.fh"
integer(kind=iwp) :: i, iChxyz, iDum, iPrint, iRout, iStb(0:7), iWel, iXF, j, jCoSet(8,8), nSTab_iXF
#ifdef _EFP_
integer(kind=iwp) :: k
#endif
real(kind=wp) :: A(3), Charge_iXF, XnetCharg
logical(kind=iwp) :: PrintOperators
character(len=72) :: tempStr
character(len=14) :: Format_XF
integer(kind=iwp), external :: iChAtm

!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 2
iPrint = nPrint(iRout)
if (iPrint == 0) return
!                                                                      *
!***********************************************************************
!                                                                      *
PrintOperators = .false.
PrintOperators = PrintOperators .or. (nEF /= 0)
PrintOperators = PrintOperators .or. (nDMS /= 0)
PrintOperators = PrintOperators .or. (nWel /= 0)
PrintOperators = PrintOperators .or. allocated(XF)
PrintOperators = PrintOperators .or. RMat_On
if (PrintOperators) then
  write(u6,*)
  call CollapseOutput(1,'   Operator info:')
  write(u6,'(3X,A)') '   --------------'
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (nEF /= 0) then
  if (nOrdEF == 0) then
    write(u6,'(2X,A,1X,I8)') 'Centers for electric potential option:',nEF
  else if (nOrdEF == 1) then
    write(u6,'(2X,A,1X,I8)') 'Centers for electric field option:',nEF
  else if (nOrdEF == 2) then
    write(u6,'(2X,A,1X,I8)') 'Centers for electric field gradient and contact option:',nEF
  end if
  do i=1,nEF
    write(u6,'(4X,I8,3(1X,F14.8))') i,(EF_Centers(j,i),j=1,3)
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (nDMS /= 0) then
  call RecPrt(' Gauge Origin for diamagnetic shielding',' ',Dxyz,1,3)
  call RecPrt(' Centers for diamagnetic shielding',' ',DMS_Centers,3,nDMS)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (nWel /= 0) then
  write(u6,*)
  write(u6,*) ' Spherical well specification in au'
  write(u6,*) ' =================================='
  write(u6,*) '   Coeff.      Exp.        R0      '
  do iWel=1,nWel
    write(u6,'(3(F10.6,2x))') Wel_Info(3,iWel),Wel_Info(2,iWel),Wel_Info(1,iWel)
  end do
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (allocated(XF)) then

  if (nPrint(2) >= 6) then
    if (iXPolType > 0) then
      tempStr = '       a(xx)       a(xy)       a(xz)       a(yy)       a(yz)       a(zz)'
    else
      tempStr = ' '
    end if
    write(u6,*)
    write(u6,*) ' External field specification in au'
    write(u6,*) ' =================================='
    if (nOrd_XF == 0) then
      write(u6,*) '     x           y           z           Z'//tempStr
    else if (nOrd_XF == 1) then
      write(u6,*) '     x           y           z           Z         my(x)       my(y)       my(z)'//tempStr
    else if (nOrd_XF == 2) then
      write(u6,*) '     x           y           z           Z         my(x)       my(y)       my(z)'// &
                  '       Q(xx)       Q(xy)       Q(xz)       Q(yy)       Q(yz)       Q(zz)'//tempStr
    else if (nOrd_XF == -1) then
      write(u6,*) '     x           y           z '//tempstr
    else
      call WarningMessage(2,'Option not implemented yet!')
      call Abend()
    end if
  end if

  write(Format_XF,'(A,I2.2,A)') '(',nData_XF,'(F10.6,2x))'
  XnetCharg = Zero
  do iXF=1,nXF
    A(1:3) = XF(1:3,iXF)
    Charge_iXF = XF(4,iXF)
    iChxyz = iChAtm(A)
    iDum = 0
    call Stblz(iChxyz,nStab_iXF,iStb,iDum,jCoSet)
    if (nPrint(2) >= 6) write(u6,Format_XF) (XF(i,iXF),i=1,nData_XF)
    XnetCharg = XnetCharg+real(nIrrep/nStab_iXF,kind=wp)*Charge_iXF
  end do
  write(u6,*)
  write(u6,*) ' Net charge from external field: ',XnetCharg
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (RMat_On) then
  write(u6,*) ' Parameters for radial integration (R-matrix option)'
  write(u6,*) ' ==================================================='
  write(u6,'(A,G12.5)') '   rmatr     :',RmatR
  write(u6,'(A,G12.5)') '   epsabs    :',Epsabs
  write(u6,'(A,G12.5)') '   epsrel    :',Epsrel
  write(u6,'(A,G12.5)') '   qcoul     :',qCoul
  write(u6,'(A,G12.5)') '   dipol(1)  :',dipol(1)
  write(u6,'(A,G12.5)') '   dipol(2)  :',dipol(2)
  write(u6,'(A,G12.5)') '   dipol(3)  :',dipol(3)
  write(u6,'(A,G12.5)') '   epsq      :',epsq
  write(u6,'(A,G12.5)') '   bparm     :',bParm
end if
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _EFP_
if (nEFP_fragments /= 0) then
  call EFP_PRINT_BANNER()
  write(u6,*)
  write(u6,*) ' Specification of Effective Fragment Potentials'
  write(u6,*)
  if (Coor_Type == XYZABC_type) then
    write(u6,*) 'In XYZABC format'
  else if (Coor_Type == POINTS_type) then
    write(u6,*) 'In Points format'
  else if (Coor_Type == ROTMAT_type) then
    write(u6,*) 'In RotMat format'
  else
    write(u6,*) 'Illegal Coor_type:',Coor_Type
    call Abend()
  end if
  do i=1,nEFP_Fragments
    write(u6,*)
    write(u6,*) 'Fragment:',FRAG_TYPE(i)
    if (Coor_Type == XYZABC_type) then
    else if (Coor_Type == POINTS_type) then
      do j=1,3
        write(u6,'(A10,3F20.10)') ABC(j,i)(1:10),(EFP_Coors((j-1)*3+k,i),k=1,3)
      end do
    else if (Coor_Type == ROTMAT_type) then
    end if
  end do
end if
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
if (PrintOperators) then
  call CollapseOutput(0,'   Operator info:')
  write(u6,*)
end if

return

end subroutine Print_OpInfo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine datimx(TimeStamp)

implicit none
character(len=*), intent(out) :: TimeStamp
interface
  subroutine datimxc(TimeStamp) bind(C,name='datimxc_')
    use, intrinsic :: iso_c_binding, only: c_char
    character(kind=c_char) :: TimeStamp(*)
  end subroutine
end interface

call datimxc(TimeStamp)

end subroutine datimx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Mickael G. Delcey                                *
************************************************************************
      SubRoutine Preca_cho(iB,is,js,nd,ir,rOut,nbai,nbaj,
     &                   fockii,fockai,fockti,
     &                   focki,focka,fock,sign,
     &                   A_J,A_K,Scr,nScr,iAdr)
*     &                   A_J,A_K,Scr,nScr,iAdr2)
************************************************************************
*                                                                      *
*     This routine remplaces precaii, precabi and precabb              *
*     in case the new Cholesky alrgorithm is used,                     *
*     that is if only (ii|ab) and (ia|ib) integrals were computed      *
*                                                                      *
*     The code should be slightly more efficient as the integrals      *
*     are only read once and not for each distinct element             *
*                                                                      *
*     Written by M.G. Delcey, november 2014                            *
*                                                                      *
************************************************************************
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "WrkSpc.fh"
#include "Pointers.fh"
      Real*8 Fock(nbaj,nbaj),FockA(nBaj,nBaj),Focki(nbaj,nbaj)
      Real*8 rout(nd*(nd+1)/2), A_J(nScr), A_K(nScr), Scr(nScr)
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      iTri1(i,j)=nTri-itri(nd-Min(i,j)+1,nd-Min(i,j)+1)
     &          +Max(i,j)-Min(i,j)+1
*                                                                      *
************************************************************************
*                                                                      *
      nO=nAsh(js)+nIsh(js)
      nTri=itri(nd,nd)
      iBB=ib+nA(is)
      iiB=ib+nish(is)
      jVert=nOrb(js)-nIsh(js)-nAsh(js)
      itAA=itri(iBB,iBB)
      i2=nD-jVert+1
*                                                                      *
************************************************************************
*    Integral contribution                                             *
*
*      iAdr=iAdr2 ! do not update iAdr2!
      iAdr=0
      Do ksym=1,nsym
*        ksym=iEor(jsym,)
!!!!!!!!!!!!!
        Do iv=1,nAsh(kSym)
          jCC=iv+nA(kSym)
          Do iu=1,iv
            jDD=iu+nA(kSym)
            Do iJK=1,2 ! 1=coulomb, 2=exchange
              factor=2.0d0
              factor2=1.0d0
              If (iJK.eq.2) factor=1.0d0 ! exchange
              If (iJK.eq.2) factor2=2.0d0 ! exchange
              Do lsym=1,nsym
                nl=nBas(lsym)
                If (nl.le.0) Go to 20
                Call DDAFILE(LuChoInt(2),2,A_J,nl**2,iAdr)

                If (lsym.eq.js) Then
                  If (iJK.eq.1) Then
                    rDens2=2.0d0*sign*
     &                Work(ipg2-1+itri(itri(jCC,jDD),itri(iBB,iBB)))
                  Else
                    rDens2=2.0d0*sign*
     &                work(ipg2-1+itri(itri(iBB,jDD),itri(jCC,iBB)))
                  EndIf
*
                  rDensaii=factor*rDens2
                  rDensabi=-factor2*rDens2
                  rDensabb=factor2*rDens2
                  rDensaiil=0
                  rDensaiiu=0
                  rDensabil=0
                  rDensabiu=0
*
                  If (iBB.eq.jDD) Then
                    rDens1=-2.0d0*work(ipg1-1+itri(jCC,iBB))
                    If (jCC.eq.iBB) rdensaii=rdensaii-2.0d0*factor
                    rDensaiil=rDensaiil-factor*rDens1
                    rDensabil=rDensabil+sign*rDens1
                  ElseIf ((iBB.eq.jCC).and.(iJK.eq.2)) Then
                    rDens1=-2.0d0*work(ipg1-1+itri(jDD,iBB))
                    rDensaiiu=rDensaiiu-factor*rDens1
                    rDensabiu=rDensabiu+sign*rDens1
                  EndIf
                  If ((iBB.eq.jCC).and.(iJK.eq.2)) Then
                    rDensaiil=rDensaiil-factor*
     &                       14.0d0*sign*work(ipg1-1+itri(jDD,iBB))
                    rDensabil=rDensabil+
     &                       8.0d0*sign*work(ipg1-1+itri(jDD,iBB))
                    If (jDD.eq.iBB) rdensaii=rdensaii+factor*14.0d0*sign
                  ElseIf ((iBB.eq.jDD).and.(iJK.eq.2)) Then
                    rDensaiiu=rDensaiiu-factor*
     &                       14.0d0*sign*work(ipg1-1+itri(jCC,iBB))
                    rDensabiu=rDensabiu+
     &                       8.0d0*sign*work(ipg1-1+itri(jCC,iBB))
                  EndIf
                  rDensaiiu=rDensaiiu+rDensaii
                  rDensaii=rDensaiil+rDensaii
                  rDensabiu=rDensabiu+rDensabi
                  rDensabi=rDensabil+rDensabi
                  If ((iJK.eq.1).and.(jCC.gt.jDD)) Then
                      rDensaii=rDensaii*2.0d0
                      rDensabi=rDensabi*2.0d0
                      rDensabb=rDensabb*2.0d0
                  EndIf

                  Do ii=1,nIsh(js)
*
** aii
*
                    ni=nIsh(jS)-ii+1
                    ip=iTri1(ii,ii)
                    Call DaXpY_(ni,rDensaii,
     &                       A_J((ii-1)*nl+ii),1,
     &                       rout(ip),1)
                    If ((iJK.eq.2).and.(jCC.gt.jDD)) Then
                      Call DaXpY_(ni,rDensaiiu,
     &                       A_J((ii-1)*nl+ii),nl,
     &                       rout(ip),1)
                    EndIf
*
** abi
*
                    ip=itri1(ii,nd-jVert+1)
                    Call DaXpY_(jvert,rDensabi,
     &                       A_J((ii-1)*nl+no+1),1,
     &                       rout(ip),1)
                    If ((iJK.eq.2).and.(jCC.gt.jDD)) Then
                      Call DaXpY_(jvert,rDensabiu,
     &                         A_J(no*nl+ii),nl,
     &                         rout(ip),1)
                    EndIf
                  End Do
*
** abb
*
                  Do ii=1,jvert
                    ni=jvert-ii+1
                    ip=itri1(nIsh(jS)+ii,nIsh(jS)+ii)
                    Call DaXpY_(ni,rDensabb,
     &                       A_J((nO+ii-1)*nl+no+ii),1,
     &                       rout(ip),1)
                    If ((iJK.eq.2).and.(jCC.gt.jDD)) Then
                      Call DaXpY_(ni,rDensabb,
     &                         A_J((nO+ii-1)*nl+no+ii),nl,
     &                         rout(ip),1)
                    EndIf
                  End Do
                EndIf
 20             Continue
*
              End Do
            End Do
          End Do
        End Do
      End Do
*                                                                      *
************************************************************************
*    Fock matrix contribution                                          *
*
      rFock = sign*2.0d0*Fockii + sign*2.0d0*Fockai - sign*Fockti
      rdens=sign*2.0d0*Work(ipG1-1+itri(ibb ,ibb))
*
**    aii
*
      Do jA=1,nIsh(jS)
         Do jB=1,jA
            i=itri1(ja,jb)
            rout(i) = rout(i) - sign*4.0d0*( Focka(jA,jB)
     &                                      +Focki(jA,jB) )
     &                        + rdens*Focki(ja,jb)
         End Do
         rout(i) = rout(i) + 2.0d0*rfock
*
**       abi
*
         ip=itri1(jA,nd-jVert+1)
         Fact=(2.0d0-2.0d0*Work(ipG1-1+itAA))
         Call DaxPy_(jVert,Sign*Fact,FockI(nO+1,jA),1,rOut(ip),1)
         Fact=2.0d0
         Call DaxPy_(jVert,Sign*Fact,FockA(nO+1,jA),1,rOut(ip),1)
      End Do
*
**       abb
*
      ip=iTri1(i2,i2)
      rF=sign*Fockti
      Do iI=nAsh(js)+nIsh(js)+1,nBas(js)
         rOut(ip)=rout(ip)-2.0d0*rF+rDens*FockI(iI,ii)
         ip=ip+1
         Do iJ=iI+1,Nbas(js)
            rOut(ip)=rout(ip)+rDens*FockI(iI,iJ)
            ip=ip+1
         End Do
      End Do
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(ir)
        Call Unused_integer(nbai)
        Call Unused_real_array(fock)
        Call Unused_real_array(A_K)
        Call Unused_real_array(Scr)
      End If
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_box_utils

   USE fmm_global_paras
   USE fmm_stats
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_box,                       &
             fmm_box_centre,                &
             fmm_branch,                    &
             fmm_grain,                     &
             fmm_parent_box,                &
             fmm_parent_bra,                &
             fmm_deepest_level,             &
             fmm_def_WS_NF,                 &
             fmm_def_WS_RFF,                &
             fmm_same_box,                  &
             fmm_RFF_boxes,                 &
             fmm_NF_boxes,                  &
             fmm_translate_to_common_grid

CONTAINS

!-------------------------------------------------------------------------------

   FUNCTION fmm_parent_box(box)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: box(3)
      INTEGER(INTK) :: fmm_parent_box(3)

      fmm_parent_box = 1+((box-1)/2)    ! get largest integer after /2

   END FUNCTION fmm_parent_box

!-------------------------------------------------------------------------------

   FUNCTION fmm_parent_bra(branch)

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: branch
      INTEGER(INTK) :: fmm_parent_bra

!      fmm_parent_bra = (((branch-1)/2)/2)*2 +2
!      fmm_parent_bra = MAX(WS_MIN, fmm_parent_bra)
      fmm_parent_bra = WS_MIN

! Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(branch)
   END FUNCTION fmm_parent_bra

!-------------------------------------------------------------------------------
! We use the coordinate shift to ensure all the box indices are positive

   FUNCTION fmm_box(centre,grain_inv)

      USE fmm_qlm_builder, ONLY: fmm_coord_shift

      IMPLICIT NONE
      REAL(REALK),   INTENT(IN) :: centre(3)
      REAL(REALK),   INTENT(IN) :: grain_inv
      INTEGER(INTK) :: fmm_box(3)

!      fmm_box(:) = 1+ INT(centre(:)*grain_inv)
      fmm_box(:) = 1+ INT( (centre(:)-fmm_coord_shift(:)) *grain_inv )

   END FUNCTION fmm_box

!-------------------------------------------------------------------------------
! We take account of the coordinate shift used in fmm_box

   FUNCTION fmm_box_centre(box,grain)

      USE fmm_qlm_builder, ONLY: fmm_coord_shift

      IMPLICIT NONE
      INTEGER(INTK), INTENT(IN) :: box(3)
      REAL(REALK),   INTENT(IN) :: grain
      REAL(REALK) :: fmm_box_centre(3)

!      fmm_box_centre(:) = grain*(box(:)-half)
      fmm_box_centre(:) = grain*(box(:)-half) + fmm_coord_shift(:)

   END FUNCTION fmm_box_centre

!-------------------------------------------------------------------------------

   FUNCTION fmm_branch(extent,grain_inv)

      IMPLICIT NONE
!      TYPE(scheme_paras), INTENT(IN) :: scheme
      REAL(REALK), INTENT(IN) :: extent, grain_inv
      INTEGER(INTK) :: fmm_branch

      ! Note branches are always even in CFMM algorithm
!      IF (scheme%branch_free) THEN
!         fmm_branch = WS_MIN
!      ELSE
!         fmm_branch = 2 * CEILING(extent*grain_inv)
!      END IF

!      fmm_branch = 2 * CEILING(extent*grain_inv)
!      fmm_branch = MAX(WS_MIN, fmm_branch)

      fmm_branch = WS_MIN

      stat_max_branch = MAX(stat_max_branch,fmm_branch)
      stat_min_branch = MIN(stat_min_branch,fmm_branch)

! Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_real(extent)
         CALL Unused_real(grain_inv)
      END IF
   END FUNCTION fmm_branch

!-------------------------------------------------------------------------------

   FUNCTION fmm_deepest_level(scheme)

      USE fmm_qlm_builder, ONLY: fmm_system_size
      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      INTEGER(INTK) :: fmm_deepest_level
      REAL(REALK) :: x

      x = fmm_system_size/scheme%grain
      ! Note we round UP the integer
      fmm_deepest_level = MAX(TOP_LEVEL,(1+INT(LOG(x)/LOG(two))))

      IF (fmm_deepest_level > MAX_LEVEL) THEN
         stat_level_saturation = fmm_deepest_level
         fmm_deepest_level = MAX_LEVEL
      END IF

   END FUNCTION fmm_deepest_level

!-------------------------------------------------------------------------------
! Return the box size at a given level, based on the smallest box size.

   FUNCTION fmm_grain(scheme,level)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      INTEGER(INTK),      INTENT(IN) :: level
      REAL(REALK) :: fmm_grain
      INTEGER(INTK) :: deepest_level

      deepest_level = fmm_deepest_level(scheme)
      fmm_grain = (scheme%grain)*(2**(deepest_level-level))

   END FUNCTION fmm_grain

!-------------------------------------------------------------------------------
! Routine to define the separation parameter for NF interactions
! i.e. boxes closer than this separation are treated as near field.
! only designed for cases where boxes are at the same level (same size)

   SUBROUTINE fmm_def_WS_NF(LHS,RHS,id,WS_para)

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(IN)  :: LHS, RHS
      TYPE(LHS_RHS_type), INTENT(IN)  :: id
      INTEGER(INTK),      INTENT(OUT) :: WS_para

      WS_para = (LHS%box_paras(id%LHS)%bra + RHS%box_paras(id%RHS)%bra) /2

   END SUBROUTINE fmm_def_WS_NF

!-------------------------------------------------------------------------------
! Routine to define local space that contains both LFF and NF space;
! i.e. boxes further apart than this separation are RFF boxes;
! note that this routine is generalised for cases where the boxes are
! at different levels (of different sizes) as is needed for the NlogN
! contraction scheme; in this case, we must choose which box size to express
! WS_para in terms of; by default we take the box size at highest level

   SUBROUTINE fmm_def_WS_RFF(LHS_in,RHS_in,id,WS_para)

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(IN)  :: LHS_in, RHS_in
      TYPE(LHS_RHS_type), INTENT(IN)  :: id
      INTEGER(INTK),      INTENT(OUT) :: WS_para

      TYPE(box_mm_paras) :: LHS, RHS
      LHS = LHS_in%box_paras(id%LHS)
      RHS = RHS_in%box_paras(id%RHS)

      ! we define WS_para in terms of the highest common grid
      CALL fmm_translate_to_common_grid(LHS,RHS)

      ! LFF is related to the parent's NF space
      LHS%bra = fmm_parent_bra(LHS%bra)
      RHS%bra = fmm_parent_bra(RHS%bra)

      ! hence NF-space for _parents_ of common grid
      WS_para = (LHS%bra + RHS%bra) /2
      ! hence LFF-space in common grid itself is
      WS_para = 1 + 2*WS_para
      ! +1 because of asymmetry in LFF space, and we are conservative.

   END SUBROUTINE fmm_def_WS_RFF

!-------------------------------------------------------------------------------
! Are 2 boxes within their near-field space (hence too close to be
! treated by boxed multipole expansions exactly)?
! If number of boxes between A and B < ((Br(A)+Br(B))/2) they are NF

   FUNCTION fmm_NF_boxes(LHS,RHS)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(IN) :: LHS, RHS
      LOGICAL :: fmm_NF_boxes
      INTEGER(INTK) :: WS_NF
      INTEGER(INTK) :: space

      ! test only valid if box grids are at the same level depth
      IF (LHS%level /= RHS%level) CALL fmm_quit('levels not equal in NF_boxes')

      WS_NF = (LHS%bra + RHS%bra)/2

      fmm_NF_boxes = .FALSE.
      space = ABS(LHS%box(3) - RHS%box(3))
      IF (space <= WS_NF) THEN
         space = ABS(LHS%box(2) - RHS%box(2))
         IF (space <= WS_NF) THEN
            space = ABS(LHS%box(1) - RHS%box(1))
            IF (space <= WS_NF) THEN
               ! pair are in near field
               fmm_NF_boxes = .TRUE.
            END IF
         END IF
      END IF

   END FUNCTION fmm_NF_boxes

!-------------------------------------------------------------------------------
! Logical function to test if two boxes are in each others "Remote Far Field"
! based on separation.  Used by FMM and NlogN algorithms.

   FUNCTION fmm_RFF_boxes(LHS,RHS)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(IN) :: LHS, RHS
      LOGICAL :: fmm_RFF_boxes

      TYPE(box_mm_paras) :: LHS_up, RHS_up

      ! test only valid if box grids are at the same level depth
      IF (LHS%level /= RHS%level) CALL fmm_quit('levels in fmm_RFF_boxes')

      LHS_up = LHS
      RHS_up = RHS
      LHS_up%box = fmm_parent_box(LHS%box)
      LHS_up%bra = fmm_parent_bra(LHS%bra)
      RHS_up%box = fmm_parent_box(RHS%box)
      RHS_up%bra = fmm_parent_bra(RHS%bra)

      fmm_RFF_boxes = .NOT.(fmm_NF_boxes(LHS_up,RHS_up))

   END FUNCTION fmm_RFF_boxes

!-------------------------------------------------------------------------------

   FUNCTION fmm_same_box(LHS,RHS)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(IN) :: LHS, RHS
      LOGICAL :: fmm_same_box

      IF (LHS%level /= RHS%level) CALL fmm_quit('levels not equal in same_box')
      fmm_same_box = .FALSE.
      IF (LHS%box(1) == RHS%box(1)  .AND.   &
          LHS%box(2) == RHS%box(2)  .AND.   &
          LHS%box(3) == RHS%box(3))         &
      THEN
         fmm_same_box = .TRUE.
      END IF

   END FUNCTION fmm_same_box

!-------------------------------------------------------------------------------
! Routine to generate a temporary set of box parameters at a common grid
! level.  Parameters at the deeper level are translated to their parent's
! grid until the levels match.

   SUBROUTINE fmm_translate_to_common_grid(LHS,RHS)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: LHS, RHS

      IF (LHS%level == RHS%level) RETURN
      IF (LHS%level > RHS%level) THEN
         DO WHILE (LHS%level > RHS%level)
            LHS%box = fmm_parent_box(LHS%box)
            LHS%bra = fmm_parent_bra(LHS%bra)
            LHS%level = LHS%level -1
         END DO
      ELSE
         DO WHILE (RHS%level > LHS%level)
            RHS%box = fmm_parent_box(RHS%box)
            RHS%bra = fmm_parent_bra(RHS%bra)
            RHS%level = RHS%level -1
         END DO
      END IF

   END SUBROUTINE fmm_translate_to_common_grid

!-------------------------------------------------------------------------------

END MODULE fmm_box_utils

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function nFgBond(iAtom,nAtoms,nMax,iTabBonds,nBondMax,iTabAtoms)

use Slapaf_Info, only: Fragments_Bond
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nFgBond
integer(kind=iwp), intent(in) :: iAtom, nAtoms, nMax, nBondMax, iTabBonds(3,nBondMax), iTabAtoms(2,0:nMax,nAtoms)
integer(kind=iwp) :: i, nn

!                                                                      *
!***********************************************************************
!                                                                      *
nFgBond = 0
nn = iTabAtoms(1,0,iAtom)
do i=1,nn
  if (iTabBonds(3,iTabAtoms(2,i,iAtom)) == Fragments_Bond) nFgBond = nFgBond+1
end do

return

end function nFgBond

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine GetGrad_PM(nAtoms,nOrb2Loc,PA,GradNorm,Rmat,Debug)
! Thomas Bondo Pedersen, December 2005.
!
! Purpose: compute the gradient of the Pipek-Mezey functional.

use Constants, only: Zero, Four
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nOrb2Loc
real(kind=wp), intent(in) :: PA(nOrb2Loc,nOrb2Loc,nAtoms)
real(kind=wp), intent(out) :: GradNorm, Rmat(nOrb2Loc,nOrb2Loc)
logical(kind=iwp), intent(in) :: Debug
integer(kind=iwp) :: i, iAtom, j
real(kind=wp) :: Fun, Rjj

RMat(:,:) = Zero
do iAtom=1,nAtoms
  do j=1,nOrb2Loc
    Rjj = PA(j,j,iAtom)
    do i=1,nOrb2Loc
      Rmat(i,j) = Rmat(i,j)+PA(i,j,iAtom)*Rjj
    end do
  end do
end do

GradNorm = Zero
do i=1,nOrb2Loc-1
  do j=i+1,nOrb2Loc
    GradNorm = GradNorm+(Rmat(i,j)-Rmat(j,i))**2
  end do
end do
GradNorm = Four*sqrt(GradNorm)

if (Debug) then
  Fun = Zero
  do i=1,nOrb2Loc
    Fun = Fun+Rmat(i,i)
  end do
  write(u6,*) 'GetGrad_PM: functional = Tr(R) = ',Fun
end if

end subroutine GetGrad_PM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001-2016, Valera Veryazov                             *
************************************************************************
      subroutine finish(rc)
      use Symmetry_Info, only: Symmetry_Info_Free
#ifndef _HAVE_EXTRA_
      Use Prgm
#endif
C     Gracefully shuts down a program module.
C     After everything is closed properly, xquit is
C     called to do the actual termination.
      implicit none
      integer :: rc
#include "WrkSpc.fh"
#include "timtra.fh"
      integer :: idum = 0
      integer :: iwarn

      Call Symmetry_Info_Free()

      if(nfld_tim.gt.0) Call GetMem('iGATim','Free','Real',
     &                  iGATim,iDum)
      if(nfld_stat.gt.0) Call GetMem('iGAStat','Free','Real',
     &                   iGAStat,iDum)

      Call GetMem('ip_iDum','Free','Inte',ip_iDummy,1)
      Call GetMem('ip_sDum','Free','SNGL',ip_sDummy, 1)
      Call GetMem('ip_Dum', 'Free','Real',ip_Dummy, 1)
      Call GetMem('Finish','List','Real',iDum,iDum)
      Call GetMem('Finish','Term','Real',iDum,iDum)

      Call fin_run_use()

      Call StatusLine('Happy landing',' ')
      Call WarningCheckOut(iWarn)
      If (iWarn.gt.1) Then
        Call WarningMessage(1,
     &          'There were warnings during the execution;'//
     &          'Please, check the output with care!')
      End If

      Call prgmfree()
      Call AixCheck()
      call xml_close('module')

#ifdef _DELAYED_
      Call close_BLAS()
#endif

      Call xquit(rc)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NonSym(nStab,jStab,A,Tx)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 A(3),Tx(3)
      Integer   jStab(0:nStab-1)
*
      Do iStab = 0, nStab-1
         If (A(1).ne.Zero.and.iAnd(jStab(iStab),1).ne.0) Go To 10
         If (A(2).ne.Zero.and.iAnd(jStab(iStab),2).ne.0) Go To 10
         If (A(3).ne.Zero.and.iAnd(jStab(iStab),4).ne.0) Go To 10
         If (iAnd(jStab(iStab),1).ne.0) Tx(1)=Zero
         If (iAnd(jStab(iStab),2).ne.0) Tx(2)=Zero
         If (iAnd(jStab(iStab),4).ne.0) Tx(3)=Zero
10       Continue
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine generate_isotrop_site( nss, nsfs, nexch, nLoc,
     &                                  gtens_input,riso,D,EoverD,
     &                                  E, M, S )

      Implicit none
#include "warnings.h"
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)

      Integer, intent(in)           :: nLoc
      Integer, intent(inout)        :: nexch
      Integer, intent(inout)        :: nss, nsfs
      Real(kind=8), intent(in)     :: gtens_input(3)
      Real(kind=8), intent(in)     :: riso(3,3)
      Real(kind=8), intent(in)     :: D, EoverD ! ZFS factors
      ! spin-orbit energy states, starting from 0
      Real(kind=8), intent(out)    :: E(nExch)
      Complex(kind=8), intent(out) :: M(3,nExch,nExch)
      Complex(kind=8), intent(out) :: S(3,nExch,nExch)

      ! local variables:
      Integer         :: i, j, l
      Integer         :: info
!      Complex(kind=8):: spin
      Complex(kind=8) :: redme
      Complex(kind=8), allocatable :: HZFS(:,:), S2(:,:), Wc(:,:)
      Complex(kind=8), allocatable :: SX2(:,:), SY2(:,:), SZ2(:,:)
      Complex(kind=8), allocatable :: Z(:,:), tmp(:,:)
       Complex(kind=8), allocatable :: MTMP(:,:,:), STMP(:,:,:)
      Real(kind=8), allocatable    :: W(:),gtens(:),maxes(:,:)
      Real(kind=8)                 :: dznrm2_, RM, RS, dnrm2_
      Real(kind=8)                 :: g(3), ma(3,3)
      External                      :: spin, dznrm2_, dnrm2_
      Logical                       :: dbg
      dbg=.false.
!----------------------------------------------------------------------|

      nsfs=1
      nss  = nexch

      If(dbg) Write(6,*) 'GENERATE_SITE:  nss   = ', nss
      If(dbg) Write(6,*) 'GENERATE_SITE:  nsfs  = ', nsfs
      If(dbg) Write(6,*) 'GENERATE_SITE:  nLoc  = ', nLoc
      If(dbg) Write(6,*) 'GENERATE_SITE:  gfact = ',
     &                                           (gtens_input(l),l=1,3)
      If(dbg) Write(6,*) 'GENERATE_SITE:  EoverD= ', EoverD
      If(dbg) Write(6,*) 'GENERATE_SITE:  D     = ', D
      If(dbg) Write(6,*) 'GENERATE_SITE:  riso  = ',
     &                                        ((riso(i,j),i=1,3),j=1,3)

      Do i=1,nExch
         E(i)=0.0_wp
      End Do

      Call zcopy_(3*nExch*nExch,[(0.0_wp,0.0_wp)],0,S,1)
      Call zcopy_(3*nExch*nExch,[(0.0_wp,0.0_wp)],0,M,1)


      IF ( nss >=2 ) THEN
         Call mma_allocate(Wc,nss,nss,'Wc')
         Call ESO(nss,1,1,S(1,1:nss,1:nss),S(2,1:nss,1:nss),redME)
         Call ESO(nss,1,0,S(3,1:nss,1:nss),Wc( 1:nss,1:nss),redME)
         Call mma_deallocate(Wc)
         Call zcopy_(3*nss*nss,S,1,M,1)
         Call zdscal_(nss*nss,-gtens_input(1),M(1,1:nss,1:nss),1)
         Call zdscal_(nss*nss,-gtens_input(2),M(2,1:nss,1:nss),1)
         Call zdscal_(nss*nss,-gtens_input(3),M(3,1:nss,1:nss),1)

         If(dbg) Call prmom('GENERATE_SITE:     SPIN MOMENT:',S,nss)
         If(dbg) Call prmom('GENERATE_SITE: MAGNETIC MOMENT:',M,nss)

         RM=dznrm2_(3*nss*nss,M(1:3,1:nss,1:nss),1)
         RS=dznrm2_(3*nss*nss,S(1:3,1:nss,1:nss),1)
         If(dbg) Write(6,'(A,2ES22.14)') 'Norms of M and S:', RM, RS

         If( (RM>0.0_wp).AND.(RS>0.0_wp) ) Then
!           rotate the spin and magnetic moment to the general coordinate system:
            Call mma_allocate(MTMP,3,nExch,nExch,'MTMP')
            Call mma_allocate(STMP,3,nExch,nExch,'STMP')
            Call mma_allocate(Z,nExch,nExch,'Z')
            Call mma_allocate(tmp,nExch,nExch,'tmp')

            Call zcopy_(3*nExch*nExch,[(0.0_wp,0.0_wp)],0,MTMP,1)
            Call zcopy_(3*nExch*nExch,[(0.0_wp,0.0_wp)],0,STMP,1)

            Call zcopy_(3*nExch*nExch,M,1,MTMP,1)
            Call zcopy_(3*nExch*nExch,S,1,STMP,1)
            Call zcopy_(3*nExch*nExch,[(0.0_wp,0.0_wp)],0,M,1)
            Call zcopy_(3*nExch*nExch,[(0.0_wp,0.0_wp)],0,S,1)
            Call zcopy_(nExch*nExch,[(0.0_wp,0.0_wp)],0,Z,1)


            If(dbg) Write(6,'(A,ES20.10)')
     &                      'GENERATE_SITE: Norm of riso:',
     &                                      dnrm2_(9,riso,1)
            If(dbg) Call xFlush(6)

            Call zcopy_(3*nExch*nExch,MTMP,1,M,1)
            Call zcopy_(3*nExch*nExch,STMP,1,S,1)
            Call rotmom( STMP, nExch, riso, S )
            Call rotmom( MTMP, nExch, riso, M )

            If(dbg) Then
               Call mma_allocate(gtens,3,'gtens')
               Call mma_allocate(maxes,3,3,'maxes')
               Call dcopy_(3,[0.0_wp],0,gtens,1)
               Call dcopy_(3*3,[0.0_wp],0,maxes,1)
               Call atens(M, nExch, gtens, maxes, 2)
               Call mma_deallocate(gtens)
               Call mma_deallocate(maxes)
            End If

            If( abs(D)>0.0_wp ) Then
            ! compute the ZFS
               Call mma_allocate(HZFS,nExch,nExch,'HZFS')
               Call mma_allocate(SX2,nExch,nExch,'SX2')
               Call mma_allocate(SY2,nExch,nExch,'SY2')
               Call mma_allocate(SZ2,nExch,nExch,'SZ2')
               Call mma_allocate(S2,nExch,nExch,'S2')
               Call mma_allocate(W,nExch,'W')

               Call zcopy_(nExch*nExch,[(0.0_wp,0.0_wp)],0,HZFS,1)
               Call zcopy_(nExch*nExch,[(0.0_wp,0.0_wp)],0,SX2,1)
               Call zcopy_(nExch*nExch,[(0.0_wp,0.0_wp)],0,SY2,1)
               Call zcopy_(nExch*nExch,[(0.0_wp,0.0_wp)],0,SZ2,1)
               Call zcopy_(nExch*nExch,[(0.0_wp,0.0_wp)],0,S2,1)
               Call dcopy_(nExch     , [0.0_wp],        0,W,1)

               Call zgemm_('C','N',nEXCH,nEXCH,nEXCH,
     &                    (1.0_wp,0.0_wp),S(1,:,:), nEXCH,
     &                                    S(1,:,:), nEXCH,
     &                    (0.0_wp,0.0_wp),SX2(:,:), nEXCH )
               Call zgemm_('C','N',nEXCH,nEXCH,nEXCH,
     &                    (1.0_wp,0.0_wp),S(2,:,:), nEXCH,
     &                                    S(2,:,:), nEXCH,
     &                    (0.0_wp,0.0_wp),SY2(:,:), nEXCH )
               Call zgemm_('C','N',nEXCH,nEXCH,nEXCH,
     &                    (1.0_wp,0.0_wp),S(3,:,:), nEXCH,
     &                                    S(3,:,:), nEXCH,
     &                    (0.0_wp,0.0_wp),SZ2(:,:), nEXCH )

               S2(:,:)=SX2(:,:)+SY2(:,:)+SZ2(:,:)

               If(dbg) Call pa_prMat('GENERATE_SITE: SX2',SX2,nexch)
               If(dbg) Call pa_prMat('GENERATE_SITE: SY2',SY2,nexch)
               If(dbg) Call pa_prMat('GENERATE_SITE: SZ2',SZ2,nexch)
               If(dbg) Call pa_prMat('GENERATE_SITE: S2 ',S2, nexch)

               HZFS(:,:)=D          * ( SZ2(:,:)-S2(:,:)/3.0_wp) +
     &                   D * EoverD * ( SX2(:,:)-SY2(:,:)      )

               If(dbg) Call print_ZFS('GENERATE_SITE: ZFS matrix:',HZFS,
     &                                 nExch)

               info=0
               Call diag_c2(HZFS,nExch,info,W,Z)

               Do i=1,nExch
                  E(i)=W(i)-W(1)
               End Do
               If(dbg) Then
                 Do i=1,nExch
                   Write(6,'(A,i2,A,F14.8)') 'ZFS  E(',i,') = ',E(i)
                 End Do
               End If
               ! rotate the spin and magnetic moment:

               Do L=1,3
                 Call zcopy_(nexch*nexch,[(0.0_wp,0.0_wp)],0,TMP,1)
                 Call zgemm_('C','N',nEXCH,nEXCH,nEXCH,
     &                      (1.0_wp,0.0_wp),Z, nEXCH,
     &                                      M(L,:,:), nEXCH,
     &                      (0.0_wp,0.0_wp),TMP, nEXCH )
                 Call zcopy_(nexch*nexch,[(0.0_wp,0.0_wp)],0,M(L,:,:),1)
                 Call zgemm_('N','N',nEXCH,nEXCH,nEXCH,
     &                      (1.0_wp,0.0_wp),TMP,nEXCH,
     &                                        Z,nEXCH,
     &                      (0.0_wp,0.0_wp), M(L,:,:), nEXCH )

                 Call zcopy_(nexch*nexch,[(0.0_wp,0.0_wp)],0,TMP,1)
                 Call zgemm_('C','N',nEXCH,nEXCH,nEXCH,
     &                      (1.0_wp,0.0_wp),Z,nEXCH,
     &                                      S(L,:,:), nEXCH,
     &                      (0.0_wp,0.0_wp),TMP,nEXCH )
                 Call zcopy_(nexch*nexch,[(0.0_wp,0.0_wp)],0,S(L,:,:),1)
                 Call zgemm_('N','N',nEXCH,nEXCH,nEXCH,
     &                      (1.0_wp,0.0_wp),TMP,nEXCH,
     &                                        Z,nEXCH,
     &                      (0.0_wp,0.0_wp),S(L,:,:),nEXCH )
               End Do  ! L

               Call mma_deallocate(SX2)
               Call mma_deallocate(SY2)
               Call mma_deallocate(SZ2)
               Call mma_deallocate(S2)
               Call mma_deallocate(W)
               Call mma_deallocate(HZFS)
            End If ! ZFS is defined

            Call mma_deallocate(MTMP)
            Call mma_deallocate(STMP)
            Call mma_deallocate(Z)
            Call mma_deallocate(tmp)
         End If ! dznrm2_ M and S

         If(dbg) Then
            Write(6,'(A)') 'g tensor at the end of GENERATE_SPIN'
            g=0.0_wp
            ma=0.0_wp
            Call atens(M, nExch, g, ma, 2)
         End If
      End If ! nss>=2


      Return
      End subroutine generate_isotrop_site

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_Word2Byte
!
!> @brief
!>   Convert integer number of \p n -byte words to byte with a reasonable prefix (``-``, ``k``, ``M``, ``G``, or ``T``)
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Convert integer number of \p n -byte words to byte, kilobyte,
!> megabyte, gigabyte, or terabyte.
!>
!> @param[in]  iWord Number of \p n -byte words
!> @param[in]  n     Number of byte per word
!> @param[out] Byte  \p iWord in bytes/kb/Mb/Gb/Tb
!> @param[out] Unt   Unit of Byte ['``b ``', '``kb``', '``Mb``', '``Gb``', or '``Tb``']
!***********************************************************************

subroutine Cho_Word2Byte(iWord,n,Byte,Unt)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iWord, n
real(kind=wp), intent(out) :: Byte
character(len=2), intent(out) :: Unt

Byte = real(iWord,kind=wp)*real(n,kind=wp)
Unt = 'b '
if (abs(Byte) > 1.0e3_wp) then
  Byte = Byte/1.024e3_wp
  Unt = 'kb'
  if (abs(Byte) > 1.0e3_wp) then
    Byte = Byte/1.024e3_wp
    Unt = 'Mb'
    if (abs(Byte) > 1.0e3_wp) then
      Byte = Byte/1.024e3_wp
      Unt = 'Gb'
      if (abs(Byte) > 1.0e3_wp) then
        Byte = Byte/1.024e3_wp
        Unt = 'Tb'
      end if
    end if
  end if
end if

end subroutine Cho_Word2Byte

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ComputeIntegrals_JK_2P(AB,CD,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Purpose: compute integrals (J_AB|K_CD).
C
      Implicit None
      Integer AB, CD
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "localdf_mem.fh"
#include "localdf_bas.fh"
#include "localdf_int2.fh"
#include "ldf_atom_pair_info.fh"

      Character*26 SecNam
      Parameter (SecNam='LDF_ComputeIntegrals_JK_2P')

#if defined (_DEBUGPRINT_)
      Logical  isSymmetric
      External isSymmetric
#endif

      Integer  LDF_nBasAux_Pair
      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nBasAux_Pair
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom

      Integer MAB, MCD
      Integer l_xInt
      Integer C, D
      Integer dShell
      Integer nAuxShell_C, ipC
      Integer nAuxShell_D, ipD
      Integer lS, kShell, lShell
      Integer nnShl, klS
      Integer ip_SewWrk, l_SewWrk

      Integer i, j
      Integer AP_Atoms
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Get row dimension of integrals
      MAB=LDF_nBasAux_Pair(AB)

      If (AB.eq.CD) Then
         ! Check integral dimension
         l_xInt=MAB**2
         If (l_xInt.ne.l_xInt_) Then
            Call WarningMessage(2,
     &                      SecNam//': integral dimension problem! [0]')
            Call LDF_Quit(1)
         End If
         ! Use same code as fitting coefficient calculation
         ! (where (J|K) was called the G matrix)
         Call LDF_ComputeGMat(AB,MAB,xInt)
      Else
         ! Get column dimension of integrals
         MCD=LDF_nBasAux_Pair(CD)
         ! Check integral dimension
         l_xInt=MAB*MCD
         If (l_xInt.gt.l_xInt_) Then
            Call WarningMessage(2,
     &                      SecNam//': integral dimension problem! [1]')
            Call LDF_Quit(1)
         End If
         ! Init integral array
         Call FZero(xInt,l_xInt)
         ! Set indices
         Call LDF_SetIndx_JK_2P(AB,CD)
         ! Allocate Seward memory
         Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
         l_SewWrk = min(l_SewWrk,MaxLDFSew)
         Call xSetMem_Ints(l_SewWrk)
         ! Compute integrals
         dShell=nShell_Valence+nShell_Auxiliary+1
         C=AP_Atoms(1,CD)
         D=AP_Atoms(2,CD)
         nAuxShell_C=LDF_nAuxShell_Atom(C)
         ipC=LDF_lAuxShell_Atom(C)-1
         kShell=dShell
         Do lS=1,nAuxShell_C
            lShell=iWork(ipC+lS)
            Call LDF_CJK2P_Col(AB,kShell,lShell,l_xInt,xInt)
         End Do
         If (D.ne.C) Then
            nAuxShell_D=LDF_nAuxShell_Atom(D)
            ipD=LDF_lAuxShell_Atom(D)-1
            Do lS=1,nAuxShell_D
               lShell=iWork(ipD+lS)
               Call LDF_CJK2P_Col(AB,kShell,lShell,l_xInt,xInt)
            End Do
         End If
         If (AP_2CFunctions(1,CD).gt.0) Then
            nnShl=l_CD_2CList_2
            Do klS=0,nnShl-1
               kShell=iWork(ip_CD_2CList+3*klS)
               lShell=iWork(ip_CD_2CList+3*klS+1)
               SPCD=iWork(ip_CD_2CList+3*klS+2)
               Call LDF_CJK2P_Col(AB,kShell,lShell,l_xInt,xInt)
            End Do
         End If
         ! Deallocate Seward memory
         Call xRlsMem_Ints()
         ! Unset indices
         Call LDF_UnsetIndx_JK_2P()
      End If

#if defined (_DEBUGPRINT_)
      ! Check symmetry
      If (AB.eq.CD) Then
         If (.not.isSymmetric(xInt,MAB,1.0d-14)) Then
            Call WarningMessage(2,SecNam//': (J|K) != (K|J)')
            Write(6,'(A,I9,1X,I9)') 'AB,CD=',AB,CD
            Call LDF_Quit(1)
         End If
      End If
#endif

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CJK2P_Col(AB,kShell,lShell,l_xInt,xInt)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Compute integrals (J_AB | kShell lShell)
C
      Implicit None
      Integer AB
      Integer kShell, lShell
      Integer l_xInt
      Real*8  xInt(l_xInt)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "localdf_int2.fh"
#include "ldf_atom_pair_info.fh"

      External Int_LDF_JK_2P

      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom

      Integer dShell
      Integer A, B
      Integer nAuxShell_A, nAuxShell_B
      Integer ipA, ipB
      Integer iShell, jShell
      Integer nnShl
      Integer jS, ijS

      Integer i, j
      Integer AP_Atoms
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      dShell=nShell_Valence+nShell_Auxiliary+1

      SHC=kShell
      SHD=lShell

      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      nAuxShell_A=LDF_nAuxShell_Atom(A)
      nAuxShell_B=LDF_nAuxShell_Atom(B)
      ipA=LDF_lAuxShell_Atom(A)-1
      ipB=LDF_lAuxShell_Atom(B)-1

      iShell=dShell
      SHA=iShell
      Do jS=1,nAuxShell_A
         jShell=iWork(ipA+jS)
         SHB=jShell
         Call Eval_IJKL(iShell,jShell,kShell,lShell,
     &                  xInt,l_xInt,Int_LDF_JK_2P)
      End Do
      If (B.ne.A) Then
         Do jS=1,nAuxShell_B
            jShell=iWork(ipB+jS)
            SHB=jShell
            Call Eval_IJKL(iShell,jShell,kShell,lShell,
     &                     xInt,l_xInt,Int_LDF_JK_2P)
         End Do
      End If
      If (AP_2CFunctions(1,AB).gt.0) Then
         nnShl=l_AB_2CList_2
         Do ijS=0,nnShl-1
            iShell=iWork(ip_AB_2CList+3*ijS)
            jShell=iWork(ip_AB_2CList+3*ijS+1)
            SPAB=iWork(ip_AB_2CList+3*ijS+2)
            SHA=iShell
            SHB=jShell
            Call Eval_IJKL(iShell,jShell,kShell,lShell,
     &                     xInt,l_xInt,Int_LDF_JK_2P)
         End Do
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE POLY0()

      use fciqmc_interface, only: DoFCIQMC
      use stdalloc, only: mma_allocate
      use gugx, only: SGS, L2ACT, LEVEL, CIS, EXS
      use caspt2_module, only: DMRG, DoCumulant, iSCF, iSpin, nActEl,
     &                         nAshT, nEle3, nHole1, nRas1T, nRas2T,
     &                         nRas3T, nSym, STSym, nAsh

      use pt2_guga, only: MxCI
      IMPLICIT NONE


      Integer nLev

      INTEGER I,IT,ITABS,ILEV,ISYM, iq

      if ((.NOT.DoCumulant) .and. (nactel.gt.0) .and. (iscf.eq.0)
     &      .and. (.not. DoFCIQMC) .and. (.not. DMRG)) Then
!     if ((.NOT.DoCumulant) .and. (nactel.gt.0)) Then

         call sginit_cp2(nSym,iSpin,nActEl,nHole1,nEle3,
     &                   nRas1T,nRas2T,nRas3T,SGS,CIS,EXS)

      else

      NLEV=NASHT
      SGS%nLev = NLEV
      Call mma_allocate(SGS%ISM,NLEV,Label='ISM')
C ISM(LEV) IS SYMMETRY LABEL OF ACTIVE ORBITAL AT LEVEL LEV.
C PAM060612: With true RAS space, the orbitals must be ordered
C first by RAS type, then by symmetry.
      ITABS=0
      DO ISYM=1,NSYM
        DO IT=1,NASH(ISYM)
          ITABS=ITABS+1
! Quan: Bug in LEVEL(ITABS) and L2ACT
          if (DoCumulant .or. DoFCIQMC .or. DMRG) then
             do iq=1,NLEV
               LEVEL(iq)=iq
               L2ACT(iq)=iq
             enddo
          endif
          ILEV=LEVEL(ITABS)
          SGS%ISM(ILEV)=ISYM
        END DO
      END DO
C INITIALIZE SPLIT-GRAPH GUGA DATA SETS:
         Call mma_allocate(CIS%NCSF,nSym,Label='CIS%NCSF')
         CIS%NCSF(:)=0
         CIS%NCSF(STSYM)=1
         Call mma_allocate(EXS%ICoup,[1,3],[1,1],Label='EXS%ICoup')
         Call mma_allocate(EXS%VTab,[1,1],Label='EXS%VTab')
      endif

      MXCI=1
      DO I=1,NSYM
        MXCI=MAX(MXCI,CIS%NCSF(I))
      END DO

C NOTE: AT THIS POINT, WE HAVE ALLOCATED MEMORY SPACE FOR SGUGA USE:
C MVL,MVR,NOW,IOW,NOCP,IOCP,NOCSF,IOCSF,ICASE,ICOUP,VTAB,TMP.


      END SUBROUTINE POLY0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GETINCN_RASSCF(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                IXCHNG,IKSM,JLSM,
     &                IPNT2,NSMOB,INH1,ICOUL)
* interface to RASSCF common blocks
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "wadr.fh"
#include "WrkSpc.fh"
*. For Jesper and openMP
      INTEGER IPNT2(*),INH1(*)
      DIMENSION XINT(*)
*
      CALL GETINCN_RASSCFS(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                IXCHNG,IKSM,JLSM,WORK(LTUVX),NSMOB,ICOUL)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(IPNT2)
        CALL Unused_integer_array(INH1)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Jie J. Bao                                       *
************************************************************************
      Subroutine CMSRot(TUVX)
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Aug. 06, 2020, created this file.               *
* ****************************************************************
      use stdalloc, only : mma_allocate, mma_deallocate
      use CMS, only: CMSNotConverged
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
#include "rasscf_lucia.fh"

      Real*8,DIMENSION(NACPR2)::TUVX
      CHARACTER(len=16)::VecName
      Real*8,DIMENSION(:,:,:,:),Allocatable::Gtuvx
      Real*8,DIMENSION(:,:,:,:),Allocatable::DDG
      Real*8,DIMENSION(:,:,:),Allocatable::GDMat
      Real*8,DIMENSION(:,:),Allocatable::RotMat
C     Allocating Memory
      CALL mma_allocate(GDMat,LRoots*(LRoots+1)/2,NAC,NAC)
      CALL mma_allocate(RotMat,lRoots,lRoots)
      CALL mma_allocate(Gtuvx,NAC,NAC,NAC,NAC)
      CALL mma_allocate(DDG,lRoots,lRoots,lRoots,lRoots)

*     printing header
      write(6,*)
      write(6,*)
      write(6,*) '    CMS INTERMEDIATE-STATE OPTIMIZATION'
      IF(trim(CMSStartMat).eq.'XMS') THEN
       CALL ReadMat('ROT_VEC',VecName,RotMat,lroots,lroots,7,16,'N')
      ELSE
       CALL ReadMat(trim(CMSStartMat),VecName,RotMat,lroots,lroots,
     &              len_trim(CMSStartMat),16,'N')
      END IF
      CALL CMSHeader(trim(CMSStartMat),len_trim(CMSStartMat))


      CALL LoadGtuvx(TUVX,Gtuvx)

      CMSNotConverged=.false.
      CALL GetGDMat(GDMat)
      IF(lRoots.lt.NAC) THEN
*       write(6,*)"Optimization Approach 1"
       CALL GetDDgMat(DDg,GDMat,Gtuvx)
       CALL NStateOpt(RotMat,DDg)
      ELSE
*       write(6,*)"Optimization Approach 2"
       CALL NStateOpt2(RotMat,GDMat,Gtuvx)
      END IF
      VecName='CMS-PDFT'
      CALL PrintMat('ROT_VEC',VecName,RotMat,lroots,lroots,7,16,'N')

C     Deallocating Memory
      CALL mma_deallocate(GDMat)
      CALL mma_deallocate(RotMat)
      CALL mma_deallocate(Gtuvx)
      CALL mma_deallocate(DDg)
      IF(CMSNotConverged) THEN
       Call WarningMessage(2,'CMS Intermediate States Not Converged')
       Call Quit(_RC_NOT_CONVERGED_)
      END IF
      RETURN
      End Subroutine

************************************************************************

************************************************************************
      Subroutine NStateOpt(RotMat,DDg)
      use stdalloc, only : mma_allocate, mma_deallocate
      use CMS, only: CMSNotConverged
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
      Real*8,DIMENSION(lRoots,lRoots,lRoots,lRoots)::DDG
      Real*8,DIMENSION(lroots,lroots)::RotMat

      INTEGER IState,JState,NPairs,IPair,ICMSIter
      Real*8 VeeSumOld,VeeSumNew,Threshold
      INTEGER,DIMENSION(:,:),Allocatable::StatePair
      Real*8,DIMENSION(:),Allocatable::theta
      Real*8,DIMENSION(:,:),Allocatable::FRot
      Logical Converged
      Real*8 CalcNSumVee
      External CalcNSumVee

      CALL mma_allocate(StatePair,LRoots*(LRoots-1)/2,2)
      CALL mma_allocate(theta,LRoots*(LRoots-1)/2)
      CALL mma_allocate(FRot,lRoots,lRoots)
      Threshold=CMSThreshold
      NPairs=lRoots*(lRoots-1)/2
      IPair=0
      DO IState=1,lRoots
       Do JState=1,IState-1
        IPair=IPair+1
        StatePair(IPair,1)=IState
        StatePair(IPair,2)=JState
       End Do
      END DO
      Converged=.false.
      CALL Copy2DMat(FRot,RotMat,lRoots,lRoots)
      VeeSumOld=CalcNSumVee(RotMat,DDg)
      ICMSIter=0
      DO WHILE(.not.Converged)
       Do IPair=1,NPairs
        theta(IPair)=0.0d0
       End Do
       ICMSIter=ICMSIter+1
       CALL ThetaOpt(FRot,theta,VeeSumNew,StatePair,NPairs,DDg)
       IF(lRoots.gt.2) THEN
       write(6,'(6X,I4,8X,F16.8,8X,ES16.4E3)')
     & ICMSIter,VeeSumNew,VeeSumNew-VeeSumOld
       ELSE
       write(6,'(6X,I4,8X,F6.1,9X,F16.8,5X,ES16.4E3)')
     & ICMSIter,asin(FRot(2,1))/atan(1.0d0)*45.0d0,VeeSumNew
     & ,VeeSumNew-VeeSumOld
       END IF
       IF(ABS(VeeSumNew-VeeSumOld).lt.Threshold) THEN
        If(ICMSIter.ge.ICMSIterMin) Then
         Converged=.true.
         write(6,'(4X,A)')'CONVERGENCE REACHED'
        End If
       ELSE
        if(ICMSIter.ge.ICMSIterMax) then
         Converged=.true.
         CMSNotConverged=.true.
         write(6,'(4X,A)')'NOT CONVERGED AFTER MAX NUMBER OF CYCLES'
         write(6,'(4X,A)')'TEMPORARY ROTATION MATRIX SAVED'
        end if
       END IF
       VeeSumOld=VeeSumNew
      END DO
      write(6,*)('=',i=1,71)
      CALL Copy2DMat(RotMat,FRot,lRoots,lRoots)
      CALL mma_deallocate(StatePair)
      CALL mma_deallocate(theta)
      CALL mma_deallocate(FRot)
      RETURN
      END SUBROUTINE
************************************************************************

************************************************************************
      Subroutine ThetaOpt(FRot,theta,SumVee,StatePair,NPairs,DDg)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
      INTEGER NPairs
      Real*8 SumVee
      Real*8,DIMENSION(lRoots,lRoots,lRoots,lRoots)::DDG
      Real*8,DIMENSION(lroots,lroots)::FRot
      INTEGER,DIMENSION(NPairs,2)::StatePair
      Real*8,DIMENSION(NPairs)::theta

      INTEGER IPair,IState,JState
C      Real*8,DIMENSION(NPairs)::thetanew

      DO IPair=1,NPairs
       IState=StatePair(IPair,1)
       JState=StatePair(IPair,2)
       CALL
     & OptOneAngle(theta(iPair),SumVee,FRot,DDg,IState,JState,lRoots)
      END DO
      DO IPair=NPairs-1,1,-1
       IState=StatePair(IPair,1)
       JState=StatePair(IPair,2)
       CALL
     & OptOneAngle(theta(iPair),SumVee,FRot,DDg,IState,JState,lRoots)
      END DO
      RETURN
      END SUBROUTINE
************************************************************************
************************************************************************
      SUBROUTINE OptOneAngle(Angle,SumVee,RotMat,DDg,I1,I2,lRoots)
      use stdalloc, only : mma_allocate, mma_deallocate
      real*8 Angle,SumVee
      INTEGER I1,I2,lRoots
      Real*8,DIMENSION(lRoots,lRoots)::RotMat
      Real*8,DIMENSION(lRoots,lRoots,lRoots,lRoots)::DDG

      Logical Converged
      INTEGER Iter,IterMax,IA,IMax
      Real*8 Threshold,StepSize,SumOld
      Real*8,DIMENSION(:),Allocatable::Angles,Sums
      Real*8,DIMENSION(:),Allocatable::ScanA,ScanS
      Real*8,DIMENSION(:,:),Allocatable::RTmp

      Real*8 CalcNSumVee
      External CalcNSumVee
      INTEGER RMax
      External RMax

      CALL mma_allocate(Angles,4)
      CALL mma_allocate(Sums,4)
      CALL mma_allocate(ScanA,31)
      CALL mma_allocate(ScanS,31)
      CALL mma_allocate(RTmp,lRoots,lRoots)

      Converged=.false.
      stepsize=dble(atan(1.0d0))/15
      Threshold=1.0d-8

C       write(6,'(A,2(I2,2X))')
C     &'scanning rotation angles for ',I1,I2
      Angles(2)=0.0d0
      DO Iter=1,31
       ScanA(Iter)=(Iter-16)*stepsize*2
       CALL Copy2DMat(RTmp,RotMat,lRoots,lRoots)
       CALL CMSMatRot(RTmp,ScanA(Iter),I1,I2,lRoots)
       ScanS(Iter)=CalcNSumVee(RTmp,DDg)
C       IF(I2.eq.1) write(6,*) Iter,ScanA(Iter),ScanS(Iter)
      END DO

      IMax=RMax(ScanS,31)

      Iter=0
      IterMax=100
      SumOld=ScanS(IMax)
      Angles(2)=ScanA(IMax)
      DO WHILE(.not.Converged)
       Iter=Iter+1
       Angles(1)=Angles(2)-stepsize
       Angles(3)=Angles(2)+stepsize
       Do iA=1,3
        CALL Copy2DMat(RTmp,RotMat,lRoots,lRoots)
        CALL CMSMatRot(RTmp,Angles(iA),I1,I2,lRoots)
        Sums(iA)=CalcNSumVee(RTmp,DDg)
       End Do
       CALL CMSFitTrigonometric(Angles,Sums)
       CALL Copy2DMat(RTmp,RotMat,lRoots,lRoots)
       CALL CMSMatRot(RTmp,Angles(4),I1,I2,lRoots)
       Sums(4)=CalcNSumVee(RTmp,DDg)
       IF(ABS(Sums(4)-SumOld).lt.Threshold) THEN
        Converged=.true.
        Angle=Angles(4)
        CALL CMSMatRot(RotMat,Angle,I1,I2,lRoots)
        SumVee=CalcNSumVee(RotMat,DDg)
C        write(6,'(A,I3,A)')
C     &'Convergence reached after ',Iter,' micro cycles'
       ELSE
        If(Iter.eq.IterMax) Then
         Converged=.true.
        write(6,'(A,I3,A)')
     &'No convergence reached after ',Iter,' micro cycles'
        Else
         Angles(2)=Angles(4)
         SumOld=Sums(4)
        End If
       END IF
      END DO
      CALL mma_deallocate(Angles)
      CALL mma_deallocate(Sums)
      CALL mma_deallocate(ScanA)
      CALL mma_deallocate(ScanS)
      CALL mma_deallocate(RTmp)

      RETURN
      END SUBROUTINE
************************************************************************
************************************************************************
      Function RMax(A,N)
       INTEGER N,RMax
       Real*8,DIMENSION(N)::A
       INTEGER I
       RMax=1
       DO I=2,N
        IF (A(I).gt.A(RMax)) RMax=I
       END DO
       RETURN
      End Function

************************************************************************
      Function CalcNSumVee(RotMat,DDg)
      use stdalloc, only : mma_allocate, mma_deallocate
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
      Real*8,DIMENSION(lRoots,lRoots,lRoots,lRoots)::DDG
      Real*8,DIMENSION(lroots,lroots)::RotMat
      Real*8,DIMENSION(:),Allocatable::Vee
      Real*8 CalcNSumVee
      INTEGER IState

      CALL mma_allocate(Vee,lRoots)
      CalcNSumVee=0.0d0
      CALL CalcVee(Vee,RotMat,DDg)
      DO IState=1,lRoots
       CalcNSumVee=CalcNSumVee+Vee(IState)
      END DO
      CALL mma_deallocate(Vee)
      RETURN
      END Function
************************************************************************
************************************************************************
      Subroutine Copy2DMat(A,B,NRow,NCol)
      INTEGER NRow,NCol,IRow,ICol
      Real*8,DIMENSION(NRow,NCol)::A,B
      DO ICol=1,NCol
       Do IRow=1,NRow
        A(IRow,ICol)=B(IRow,ICol)
       End Do
      END DO
      RETURN
      END SUBROUTINE
************************************************************************
************************************************************************
      Subroutine CMSMatRot(Mat,A,I,J,N)
      INTEGER I,J,N
      Real*8 A
      Real*8,DIMENSION(N,N)::Mat,TM
      DO K=1,N
       TM(I,K)=Mat(I,K)
       TM(J,K)=Mat(J,K)
      END DO
      DO K=1,N
       Mat(J,K)= cos(A)*TM(J,K)+sin(A)*TM(I,K)
       Mat(I,K)=-sin(A)*TM(J,K)+cos(A)*TM(I,K)
      END DO
      RETURN
      END SUBROUTINE
************************************************************************
************************************************************************
      Subroutine CMSFitTrigonometric(x,y)
      real*8,DIMENSION(4)::x,y
      real*8 s12,s23,c12,c23,d12,d23,k,a,b,c,phi,psi1,psi2,val1,val2
      real*8 atan1
      s12=sin(4.0d0*x(1))-sin(4.0d0*x(2))
      s23=sin(4.0d0*x(2))-sin(4.0d0*x(3))
      c12=cos(4.0d0*x(1))-cos(4.0d0*x(2))
      c23=cos(4.0d0*x(2))-cos(4.0d0*x(3))
      d12=y(1)-y(2)
      d23=y(2)-y(3)
      k=s12/s23
      c=(d12-k*d23)/(c12-k*c23)
      b=(d12-c*c12)/s12
      a=y(1)-b*sin(4.0d0*x(1))-c*cos(4.0d0*x(1))
      phi=atan(b/c)
      atan1=atan(1.0d0)
      psi1=phi/4.0d0
      if(psi1.gt.atan1)then
        psi2=psi1-atan1
       else
        psi2=psi1+atan1
      end if
      val1=b*sin(4.0d0*psi1)+c*cos(4.0d0*psi1)
      val2=b*sin(4.0d0*psi2)+c*cos(4.0d0*psi2)
      if (val1.gt.val2) then
       x(4)=psi1
C       y(4)=val1
      else
       x(4)=psi2
C       y(4)=val2
      end if
      y(4)=a+sqrt(b**2+c**2)
C      write(6,*)a,b,c,x(4),y(4)
      return
      END Subroutine
************************************************************************

************************************************************************
      Subroutine CalcVee(Vee,RMat,DDg)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
      Real*8,DIMENSION(lRoots,lRoots,lRoots,lRoots)::DDG
      Real*8,DIMENSION(lroots,lroots)::RMat
      Real*8,DIMENSION(lroots)::Vee
      INTEGER IState,iJ,iK,iL,iM
      DO IState=1,lRoots
       Vee(IState)=0.0d0
       Do iJ=1,lRoots
        Do iK=1,lRoots
         Do iL=1,lRoots
          Do iM=1,lRoots
          Vee(Istate)=Vee(IState)+RMat(IState,iJ)*RMat(IState,iK)*
     &RMat(IState,iL)*RMat(IState,iM)*DDG(iJ,iK,iL,iM)
          End Do
         End Do
        End Do
       End Do
       Vee(IState)=Vee(IState)/2
C       write(6,'(A,I2,A,F10.6)')'The classic coulomb energy for state ',
C     & IState,' is ',Vee(IState)
      END DO
      RETURN
      END SUBROUTINE
************************************************************************
************************************************************************
      Subroutine GetDDgMat(DDg,GDMat,Gtuvx)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
      Real*8,DIMENSION(lRoots,lRoots,lRoots,lRoots)::DDG
      Real*8,DIMENSION(NAC,NAC,NAC,NAC)::Gtuvx
      Real*8,DIMENSION(LRoots*(LRoots+1)/2,NAC,NAC)::GDMat

      INTEGER iI,iJ,iK,iL,it,iu,iv,ix,iII,iJJ,iKK,iLL
      DO iI=1,lRoots
       DO iJ=1,lRoots
        IF(iJ.gt.iI) THEN
         iJJ=iI
         iII=iJ
        ELSE
         iII=iI
         iJJ=iJ
        END IF
        DO iK=1,lRoots
         DO iL=1,lRoots
          IF(iL.gt.iK) THEN
           iLL=iK
           iKK=iL
          ELSE
           iLL=iL
           iKK=iK
          END IF
          DDG(iI,iJ,iK,iL)=0.0d0
          do it=1,NAC
           do iu=1,NAC
            do iv=1,NAC
             do ix=1,NAC
              DDG(iI,iJ,iK,iL)=DDG(iI,iJ,iK,iL)
     & +GDMat(iII*(iII-1)/2+iJJ,it,iu)*GDMat(iKK*(iKK-1)/2+iLL,iv,ix)
     & *Gtuvx(it,iu,iv,ix)
             end do
            end do
           end do
          end do
         END DO
        END DO
       END DO
      END DO
      RETURN
      End Subroutine
************************************************************************

      Subroutine LoadGtuvx(TUVX,Gtuvx)
* ****************************************************************
* Purpose:                                                       *
* Loading TUVX array to a 4-D tensor.                            *
* Copyied from src/molcas_ci_util/david5.f                       *
* ****************************************************************
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"

      Real*8,DIMENSION(NACPR2)::TUVX
      Real*8,DIMENSION(NAC,NAC,NAC,NAC)::Gtuvx
      INTEGER it,iu,iv,ix,ituvx,ixmax
      ituvx=0
      DO it=1,NAC
       Do iu=1,it
        dO iv=1,it
         ixmax=iv
         if (it==iv) ixmax=iu
         do ix=1,ixmax
          ituvx=ituvx+1
          Gtuvx(it,iu,iv,ix)=TUVX(ituvx)
          Gtuvx(iu,it,iv,ix)=TUVX(ituvx)
          Gtuvx(it,iu,ix,iv)=TUVX(ituvx)
          Gtuvx(iu,it,ix,iv)=TUVX(ituvx)
          Gtuvx(iv,ix,it,iu)=TUVX(ituvx)
          Gtuvx(ix,iv,it,iu)=TUVX(ituvx)
          Gtuvx(iv,ix,iu,it)=TUVX(ituvx)
          Gtuvx(ix,iv,iu,it)=TUVX(ituvx)
         end do
        eND dO
       End Do
      END DO
      RETURN
      End Subroutine
************************************************************************
      Subroutine NStateOpt2(RotMat,GDMat,Gtuvx)
      use stdalloc, only : mma_allocate, mma_deallocate
      use CMS, only: CMSNotConverged
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
#include "rasscf_lucia.fh"

      Real*8,DIMENSION(LRoots*(LRoots+1)/2,NAC,NAC)::GDMat
      Real*8,DIMENSION(lRoots,lRoots)::RotMat
      Real*8,DIMENSION(NAC,NAC,NAC,NAC)::Gtuvx

      INTEGER IState,JState,NPairs,IPair,ICMSIter
      Real*8 VeeSumOld,VeeSumNew,Threshold,VeeSumChange
      INTEGER,DIMENSION(:,:),Allocatable::StatePair
      Real*8,DIMENSION(:),Allocatable::theta
      Real*8,DIMENSION(:),Allocatable::Vee
      Real*8,DIMENSION(:,:),Allocatable::FRot
      Logical Converged
      Real*8 SumArray
      External SumArray

      CALL mma_allocate(StatePair,LRoots*(LRoots-1)/2,2)
      CALL mma_allocate(theta,LRoots*(LRoots-1)/2)
      CALL mma_allocate(Vee,LRoots)
      CALL mma_allocate(FRot,lRoots,lRoots)
      Threshold=CMSThreshold
      NPairs=lRoots*(lRoots-1)/2
      IPair=0
      DO IState=1,lRoots
       Do JState=1,IState-1
        IPair=IPair+1
        StatePair(IPair,1)=IState
        StatePair(IPair,2)=JState
       End Do
      END DO
      Converged=.false.
      CALL Copy2DMat(FRot,RotMat,lRoots,lRoots)
      CALL RotGDMat(FRot,GDMat)
      CALL CalcVee2(Vee,GDMat,Gtuvx)
      VeeSumOld=SumArray(Vee,lRoots)
      ICMSIter=0
*        write(6,'(6X,I4,8X,F16.8,8X,ES16.4E3)')
*     &  ICMSIter,VeeSumOld,0.0d0
      DO WHILE(.not.Converged)
       Do IPair=1,NPairs
        theta(IPair)=0.0d0
       End Do
       ICMSIter=ICMSIter+1
       CALL ThetaOpt2
     & (FRot,theta,VeeSumChange,StatePair,NPairs,GDMat,Vee,Gtuvx)
       VeeSumNew=VeeSumOld+VeeSumChange
       IF(lRoots.gt.2) THEN
        write(6,'(6X,I4,8X,F16.8,8X,ES16.4E3)')
     &  ICMSIter,VeeSumNew,VeeSumChange
*        CALL RecPrt(' ',' ',Vee,lRoots,1)
*        write(6,*) SumArray(Vee,lRoots)
       ELSE
       write(6,'(6X,I4,8X,F6.1,9X,F16.8,5X,ES16.4E3)')
     & ICMSIter,asin(FRot(2,1))/atan(1.0d0)*45.0d0,VeeSumNew
     & ,VeeSumChange
*       CALL RecPrt(' ',' ',Vee,lRoots,1)
*       write(6,*) SumArray(Vee,lRoots)
       END IF
       IF(ABS(VeeSumChange).lt.Threshold) THEN
        If(ICMSIter.ge.ICMSIterMin) Then
         Converged=.true.
         write(6,'(4X,A)')'CONVERGENCE REACHED'
        End If
       ELSE
        if(ICMSIter.ge.ICMSIterMax) then
         Converged=.true.
         CMSNotConverged=.true.
         write(6,'(4X,A)')'NOT CONVERGED AFTER MAX NUMBER OF CYCLES'
         write(6,'(4X,A)')'TEMPORARY ROTATION MATRIX SAVED'
        end if
       END IF
*         Converged=.true.
       VeeSumOld=VeeSumNew
      END DO
      write(6,*)('=',i=1,71)

      CALL Copy2DMat(RotMat,FRot,lRoots,lRoots)
      CALL mma_deallocate(StatePair)
      CALL mma_deallocate(theta)
      CALL mma_deallocate(Vee)
      CALL mma_deallocate(FRot)
      RETURN
      END SUBROUTINE

************************************************************************

      SubRoutine OptOneAngle2(ang,change,R,GD,I1,I2,Vee,G)
      use stdalloc, only : mma_allocate, mma_deallocate
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
      Real*8 ang,change
      Integer I1,I2
      Real*8,DIMENSION(lRoots,lRoots)::R
      Real*8,DIMENSION(LRoots*(LRoots+1)/2,NAC,NAC)::GD
      Real*8,DIMENSION(lRoots)::Vee
      Real*8,DIMENSION(NAC,NAC,NAC,NAC)::G

      Logical Converged
      INTEGER Itera,Itermax,IA,IMax
      Real*8 Threshold,StepSize,SumOld,Vee1,Vee2,SumOld2
      Real*8,DIMENSION(:),Allocatable::Angles,Sums
      Real*8,DIMENSION(:),Allocatable::ScanA,ScanS

      INTEGER RMax
      External RMax

      CALL mma_allocate(Angles,4)
      CALL mma_allocate(Sums,4)
      CALL mma_allocate(ScanA,31)
      CALL mma_allocate(ScanS,31)

      Converged=.false.
      stepsize=dble(atan(1.0d0))/15
      Threshold=1.0d-8

      Angles(2)=0.0d0
      DO Itera=1,31
       ScanA(Itera)=(Itera-16)*stepsize*2
       CALL
     &SumVeeNew(ScanS(Itera),ScanA(Itera),GD,I1,I2,G,Vee1,Vee2,.false.)
C       IF(I2.eq.1) write(6,*) Iter,ScanA(Iter),ScanS(Iter)
      END DO

      IMax=RMax(ScanS,21)

      Itera=0
      IterMax=100
      SumOld=Vee(I1)+Vee(I2)
      SumOld2=SumOld
      Angles(2)=ScanA(IMax)
      DO WHILE(.not.Converged)
       Itera=Itera+1
       Angles(1)=Angles(2)-stepsize
       Angles(3)=Angles(2)+stepsize
       Do iA=1,3
       CALL SumVeeNew(Sums(iA),Angles(iA),GD,I1,I2,G,Vee1,Vee2,.false.)
       End Do
       CALL CMSFitTrigonometric(Angles,Sums)
       CALL SumVeeNew(Sums(4),Angles(4),GD,I1,I2,G,Vee1,Vee2,.false.)
       change=Sums(4)-SumOld
       IF(ABS(change).lt.Threshold) THEN
        Converged=.true.
        Ang=Angles(4)
        Vee(I1)=Vee1
        Vee(I2)=Vee2
        CALL SumVeeNew(Sums(4),Ang,GD,I1,I2,G,Vee1,Vee2,.true.)
        CALL CMSMatRot(R,Ang,I1,I2,lRoots)
       ELSE
        If(Itera.eq.IterMax) Then
         Converged=.true.
        write(6,'(A,I3,A)')
     &'No convergence reached after ',Itera,' micro cycles'
        Else
         Angles(2)=Angles(4)
         SumOld=Sums(4)
        End If
       END IF
      END DO
      change=Vee(I1)+Vee(I2)-SumOld2
      CALL mma_deallocate(Angles)
      CALL mma_deallocate(Sums)
      CALL mma_deallocate(ScanA)
      CALL mma_deallocate(ScanS)
      RETURN
      End Subroutine

************************************************************************
      Subroutine SumVeeNew(SV,A,GD,I1,I2,G,V1,V2,Update)
      use stdalloc, only : mma_allocate, mma_deallocate
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"

      Real*8 SV,A,V1,V2
      INTEGER I1,I2
      Real*8,DIMENSION(LRoots*(LRoots+1)/2,NAC,NAC)::GD
      Real*8,DIMENSION(NAC,NAC,NAC,NAC)::G
      Real*8,DIMENSION(:,:),Allocatable::D11,D22
      Real*8,DIMENSION(:,:,:),Allocatable::D1J,D2J
      Logical Update

      INTEGER t,u,v,x,i11,i22,i12
      INTEGER J,I1J,I2J
      IF(Update) THEN
       CALL mma_allocate(D1J,lRoots,NAC,NAC)
       CALL mma_allocate(D2J,lRoots,NAC,NAC)
*      calculating
       DO J=1,I2-1                           !(J<I2<I1)
        I1J=(I1-1)*I1/2+J
        I2J=(I2-1)*I2/2+J
        Do t=1,NAC
        Do u=1,NAC
         D2J(J,t,u)= cos(A)*GD(I2J,t,u)+sin(A)*GD(I1J,t,u)
         D1J(J,t,u)=-sin(A)*GD(I2J,t,u)+cos(A)*GD(I1J,t,u)
        End Do
        End Do
       END DO
       J=I2                                  !(J=I2<I1)
      i11=(I1+1)*I1/2
      i22=(I2+1)*I2/2
      i12=(I1-1)*I1/2+I2
        Do t=1,NAC
        Do u=1,NAC
         D2J(i2,t,u)=GD(i11,t,u)*sin(A)**2+GD(i22,t,u)*cos(A)**2
     &+cos(A)*sin(A)*(GD(i12,u,t)+GD(i12,t,u))
         D1J(i2,t,u)=cos(A)*sin(A)*(GD(i11,t,u)-GD(i22,t,u))
     &+GD(i12,t,u)*cos(A)**2-GD(i12,u,t)*sin(A)**2
        End Do
        End Do
       DO J=I2+1,I1-1                        !(I2<J<I1)
        I1J=(I1-1)*I1/2+J
        I2J=(J-1)*J/2+I2
        Do t=1,NAC
        Do u=1,NAC
         D2J(J,t,u)= cos(A)*GD(I2J,u,t)+sin(A)*GD(I1J,t,u)
         D1J(J,t,u)=-sin(A)*GD(I2J,u,t)+cos(A)*GD(I1J,t,u)
        End Do
        End Do
       END DO
       J=I1                                  !(I2<J=I1)
      i11=(I1+1)*I1/2
      i22=(I2+1)*I2/2
      i12=(I1-1)*I1/2+I2
        Do t=1,NAC
        Do u=1,NAC
         D1J(i1,t,u)=GD(i11,t,u)*cos(A)**2+GD(i22,t,u)*sin(A)**2
     &   -cos(A)*sin(A)*(GD(i12,t,u)+GD(i12,u,t))
        End Do
        End Do

       DO J=I1+1,lRoots                      !(I2<I1<J)
        I1J=(J-1)*J/2+I1
        I2J=(J-1)*J/2+I2
        Do t=1,NAC
        Do u=1,NAC
         D2J(J,t,u)= cos(A)*GD(I2J,u,t)+sin(A)*GD(I1J,u,t)
         D1J(J,t,u)=-sin(A)*GD(I2J,u,t)+cos(A)*GD(I1J,u,t)
        End Do
        End Do
       END DO
*      updating
       DO J=1,I2-1                           !(J<I2<I1)
        I1J=(I1-1)*I1/2+J
        I2J=(I2-1)*I2/2+J
        Do t=1,NAC
        Do u=1,NAC
         GD(I2J,t,u)=D2J(J,t,u)
         GD(I1J,t,u)=D1J(J,t,u)
        End Do
        End Do
       END DO
       J=I2                                  !(J=I2<I1)
*      i11=(I1+1)*I1/2
      i22=(I2+1)*I2/2
      i12=(I1-1)*I1/2+I2
        Do t=1,NAC
        Do u=1,NAC
         GD(I22,t,u)=D2J(I2,t,u)
         GD(I12,t,u)=D1J(I2,t,u)
        End Do
        End Do
       DO J=I2+1,I1-1                        !(I2<J<I1)
        I1J=(I1-1)*I1/2+J
        I2J=(J-1)*J/2+I2
        Do t=1,NAC
        Do u=1,NAC
         GD(I2J,t,u)=D2J(J,u,t)
         GD(I1J,t,u)=D1J(J,t,u)
        End Do
        End Do
       END DO
       J=I1                                  !(I2<J=I1)
       i11=(I1+1)*I1/2
        Do t=1,NAC
        Do u=1,NAC
         GD(i11,t,u)=D1J(I1,t,u)
        End Do
        End Do

       DO J=I1+1,lRoots                      !(I2<I1<J)
        I1J=(J-1)*J/2+I1
        I2J=(J-1)*J/2+I2
        Do t=1,NAC
        Do u=1,NAC
         GD(I2J,t,u)=D2J(J,u,t)
         GD(I1J,t,u)=D1J(J,u,t)
        End Do
        End Do
       END DO
       Call mma_deallocate(D1J)
       Call mma_deallocate(D2J)
      ELSE
       CALL mma_allocate(D11,NAC,NAC)
       CALL mma_allocate(D22,NAC,NAC)
       i11=(I1+1)*I1/2
       i22=(I2+1)*I2/2
       i12=(I1-1)*I1/2+I2
       V1=0.0d0
       V2=V1
       DO t=1,NAC
        Do u=1,NAC
         D11(t,u)=GD(i11,t,u)*cos(A)**2+GD(i22,t,u)*sin(A)**2
     &   -cos(A)*sin(A)*(GD(i12,t,u)+GD(i12,u,t))
         D22(t,u)=GD(i11,t,u)*sin(A)**2+GD(i22,t,u)*cos(A)**2
     &   +cos(A)*sin(A)*(GD(i12,u,t)+GD(i12,t,u))
        End Do
       END DO
       DO t=1,NAC
       DO u=1,NAC
        Do v=1,NAC
        Do x=1,NAC
         V1=V1+D11(t,u)*D11(v,x)*G(t,u,v,x)
         V2=V2+D22(t,u)*D22(v,x)*G(t,u,v,x)
        End Do
        End Do
       END DO
       END DO
       V1=V1/2.0d0
       V2=V2/2.0d0
       SV=V1+V2
       Call mma_deallocate(D11)
       Call mma_deallocate(D22)
      END IF
      RETURN
      End Subroutine
************************************************************************

************************************************************************


      Subroutine ThetaOpt2(R,theta,deltaQ,SPair,NP,GD,Vee,G)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
      INTEGER NP
      Real*8,DIMENSION(NP)::theta
      Real*8 Change,deltaQ
      INTEGER,DIMENSION(NP,2)::SPair
      Real*8,DIMENSION(lroots,lroots)::R
      Real*8,DIMENSION(lroots)::Vee
      Real*8,DIMENSION(LRoots*(LRoots+1)/2,NAC,NAC)::GD
      Real*8,DIMENSION(NAC,NAC,NAC,NAC)::G

      INTEGER IP,I,J
      deltaQ=0.0d0
      DO IP=1,NP
       I=SPair(IP,1)
       J=SPair(IP,2)
       CALL OptOneAngle2(theta(iP),change,R,GD,I,J,Vee,G)
       deltaQ=deltaQ+change
      END DO

      DO IP=NP-1,1,-1
       I=SPair(IP,1)
       J=SPair(IP,2)
       CALL OptOneAngle2(theta(iP),change,R,GD,I,J,Vee,G)
       deltaQ=deltaQ+change
      END DO

      RETURN
      END SUBROUTINE

************************************************************************
      Function SumArray(A,N)
      INTEGER N,I
      Real*8,DIMENSION(N)::A
      Real*8 SumArray
      SumArray=0.0d0
      DO I=1, N
       SumArray=SumArray+A(I)
      END DO
      RETURN
      End Function


************************************************************************
      Subroutine CalcVee2(Vee,GD,Gtuvx)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
      Real*8,DIMENSION(LRoots*(LRoots+1)/2,NAC,NAC)::GD
      Real*8,DIMENSION(lRoots)::Vee
      Real*8,DIMENSION(NAC,NAC,NAC,NAC)::Gtuvx

      INTEGER I,t,u,v,x,III
      DO I=1,lRoots
       Vee(I)=0.0d0
       III=I*(I+1)/2
       Do t=1,nac
       Do u=1,nac
       Do v=1,nac
       Do x=1,nac
        Vee(I)=Vee(I)+GD(III,t,u)*GD(III,v,x)*Gtuvx(t,u,v,x)
       End Do
       End Do
       End Do
       End Do
       Vee(I)=Vee(I)/2.0d0
      END DO
      RETURN
      END SUBROUTINE

************************************************************************
      Subroutine RotGDMat(R,GD)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"

      Real*8,DIMENSION(LRoots*(LRoots+1)/2,NAC,NAC)::GD,GD2
      Real*8,DIMENSION(lRoots,lRoots)::R

      INTEGER I,J,K,L,p,q,iIJ,iKL,ip,iq

      DO p=1,nac
      DO q=1,nac
       Do I=1,lRoots
       Do J=1,I
        iIJ=(I-1)*I/2+J
        GD2(iIJ,p,q)=0.0d0
        do K=1,lRoots
        do L=1,lRoots
         IF(K.gt.L) THEN
          iKL=(K-1)*K/2+L
          ip=p
          iq=q
         ELSE
          iKL=(L-1)*L/2+K
          ip=q
          iq=p
         END IF
         GD2(iIJ,p,q)=GD2(iIJ,p,q)+GD(iKL,ip,iq)*R(I,K)*R(J,L)
        end do
        end do
       End Do
       End Do
      END DO
      END DO

      DO p=1,nac
      DO q=1,nac
       Do I=1,lRoots
       Do J=1,I
        iIJ=(I-1)*I/2+J
        GD(iIJ,p,q)=GD2(iIJ,p,q)
       End Do
       End Do
      END DO
      END DO
      RETURN
      END SUBROUTINE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Yoshio Nishimoto                                 *
************************************************************************
      SUBROUTINE DERFG3(CI,CLAG,DG1,DG2,DG3,DF1,DF2,DF3,
     &                  DEPSA,G1,G2,nLev)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
#endif
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG, VERBOSE
      use caspt2_global, only: nbuf1_grad
#ifdef _MOLCAS_MPP_
      use caspt2_global, only: iTasks_grad,nTasks_grad
#endif
      use Symmetry_Info, only: Mul
      use gugx, only: CIS, L2ACT, SGS, EXS
      use stdalloc, only: mma_MaxDBLE, mma_allocate, mma_deallocate
      use definitions, only: iwp,wp,u6,RtoB
      use caspt2_module, only: nConf, nActEl, nSym, STSym, EPSA
      use gugx, only: MxLev
      use pt2_guga, only: MxCI
      use Constants, only: Zero, One, Half

      IMPLICIT NONE

      logical(kind=iwp), external :: RSV_TSK

      integer(kind=iwp), intent(in) :: nLev
      real(kind=wp), intent(in) :: CI(MXCI), DG3(*), DF3(*),
     &  G1(NLEV,NLEV), G2(NLEV,NLEV,NLEV,NLEV)
      real(kind=wp), intent(inout) :: CLAG(NCONF), DG1(NLEV,NLEV),
     &  DG2(NLEV,NLEV,NLEV,NLEV), DF1(NLEV,NLEV),
     &  DF2(NLEV,NLEV,NLEV,NLEV), DEPSA(NLEV,NLEV)

      integer(kind=iwp) :: I,J,IDX,JDX
      integer(kind=iwp) :: IB,IBMN,IBMX,IBUF,NB,NBTOT,IBUF1
      integer(kind=iwp) :: IP1,IP2,IP3,IP1MN,IP1MX,IP1I,IP1STA,IP1END,
     &                     IP3MX,IQ1
      integer(kind=iwp) :: IG3,IG3OFF,IG3BK
      integer(kind=iwp) :: ISTU,ISVX,ISYZ
      integer(kind=iwp) :: IT,IU,IV,IX,IY,IZ
      integer(kind=iwp) :: ITLEV,IULEV,IVLEV,IXLEV,IYLEV,IZLEV,IXLEV0
      integer(kind=iwp) :: NBUF1,NBUFX,NDTU,NDAB
      integer(kind=iwp) :: IOFFSET
      integer(kind=iwp) :: ISSG1,ISSG2,ISP1
      integer(kind=iwp) :: ITASK,ISUBTASK,ID,NTASKS,NSUBTASKS,
     &                     MXTASK,MYTASK,MYBUFFER
      integer(kind=iwp) :: NSGM1,NSGM2
      integer(kind=iwp) :: NTRI1,NTRI2
      integer(kind=iwp) :: MEMMAX !, MEMMAX_SAFE
      integer(kind=iwp) :: NLEV2
      integer(kind=iwp) :: NCI,ICSF

      real(kind=wp), external :: DDOT_

      ! translation tables for levels i,j to and from pair indices idx
      integer(kind=iwp) :: IJ2IDX(MXLEV,MXLEV)
      integer(kind=iwp) :: IDX2IJ(2,MXLEV**2)
      integer(kind=iwp) :: ICNJ(MXLEV**2)
      integer(kind=iwp) :: IP1_BUF(MXLEV**2)

      REAL(KIND=WP),ALLOCATABLE:: BUF1(:,:),BUF2(:),BUFT(:),BUFD(:),
     &  DTU(:,:),DYZ(:),DAB(:,:),BUF3(:),BUF4(:),BUFX(:,:)
      INTEGER(KIND=IWP),ALLOCATABLE:: TASKLIST(:,:)

      ! result buffer, maximum size is the largest possible ip1 range,
      ! which is set to nbuf1 later, i.e. a maximum of nlev2 <= mxlev**2
!     REAL*8 BUFR(MXLEV**2)

!     integer(kind=iwp) :: LFCDer1,LFCDer2
      integer(kind=iwp) :: iTask_loc
      real(kind=wp) :: SCAL,ScalG,ScalF
!     real(kind=wp) :: tmp,tmp2
      logical(kind=iwp) :: first
      integer(kind=iwp) :: nMidV
      nMidV = CIS%nMidV

! Put in zeroes. Recognize special cases:
      IF(nlev == 0) return
      IF(NACTEL == 0) return

      NCI=CIS%NCSF(STSYM)
* This should not happen, but...
      IF(NCI == 0) return

! Here, for regular CAS or RAS cases.

! Special pair index idx2ij allows true RAS cases to be handled:
      nlev2=nlev**2
      ntri1=(nlev2-nlev)/2
      ntri2=(nlev2+nlev)/2
      idx=0
      do i=1,nlev-1
        do j=i+1,nlev
          idx=idx+1
          ij2idx(i,j)=idx
          idx2ij(1,idx)=i
          idx2ij(2,idx)=j
          jdx=nlev2+1-idx
          ij2idx(j,i)=jdx
          idx2ij(1,jdx)=j
          idx2ij(2,jdx)=i
        end do
      end do
      do i=1,nlev
        idx=ntri1+i
        ij2idx(i,i)=idx
        idx2ij(1,idx)=i
        idx2ij(2,idx)=i
      end do
      do idx=1,nlev2
        i=idx2ij(1,idx)
        j=idx2ij(2,idx)
        jdx=ij2idx(j,i)
        icnj(idx)=jdx
      end do

* Correction to G3: It is now <0| E_tu E_vx E_yz |0>
* Similar for F3 values.
* These corrections are already done in CLagDXA_FG3 and CLagDXC_FG3

* Correction to F2: Some values not computed follow from symmetry
      do ip1=1,nlev2-1
       itlev=idx2ij(1,ip1)
       iulev=idx2ij(2,ip1)
       it=L2ACT(itlev)
       iu=L2ACT(iulev)
       do ip3=ip1+1,nlev2
        iylev=idx2ij(1,ip3)
        izlev=idx2ij(2,ip3)
        iy=L2ACT(iylev)
        iz=L2ACT(izlev)
        SCAL=DF2(iy,iz,it,iu)+DF2(it,iu,iy,iz)
        DF2(it,iu,iy,iz)=Zero
        DF2(iy,iz,it,iu)=Scal
       end do
      end do
!-SVC20100310: took some spurious mirroring of F2 values out
!-of the loops and put them here, after the parallel section has
!-finished, so that GAdSUM works correctly.
      do ip1=ntri2+1,nlev2
       itlev=idx2ij(1,ip1)
       iulev=idx2ij(2,ip1)
       it=L2ACT(itlev)
       iu=L2ACT(iulev)
       do ip3=ntri1+1,ip1
        iylev=idx2ij(1,ip3)
        izlev=idx2ij(2,ip3)
        iy=L2ACT(iylev)
        iz=L2ACT(izlev)
        Scal=DF2(iz,iy,iu,it)+DF2(it,iu,iy,iz)
        DF2(it,iu,iy,iz)=Zero
        DF2(iz,iy,iu,it)=Scal
       end do
      end do
* Correction to F2: It is now = <0| E_tu H0Diag E_yz |0>
       do iz=1,nlev
        do iy=1,nlev
         do iu=1,nlev
          do it=1,nlev
           DG2(it,iu,iy,iz) = DG2(it,iu,iy,iz)
     &      - DF2(it,iu,iy,iz)*(EPSA(iu)+EPSA(iy))
           !! DEPSA-related operations in the preparation step
           !! are done only on the master node
#ifdef _MOLCAS_MPP_
           if (king()) then
#endif
            do ix=1,nlev
             DEPSA(iu,ix) = DEPSA(iu,ix)
     &         - DF2(it,iu,iy,iz)*G2(it,ix,iy,iz)
             DEPSA(ix,iy) = DEPSA(ix,iy)
     &         - DF2(it,iu,iy,iz)*G2(it,iu,ix,iz)
            end do
#ifdef _MOLCAS_MPP_
           end if
#endif
          end do
         end do
        end do
       end do
       do iz=1,nlev
        do iu=1,nlev
         do it=1,nlev
          DG1(it,iz) = DG1(it,iz) - EPSA(iu)*DF2(it,iu,iu,iz)
          DF1(it,iz) = DF1(it,iz) - DF2(it,iu,iu,iz)
#ifdef _MOLCAS_MPP_
          if (king()) then
#endif
           do iy = 1, nlev
             DEPSA(iu,iy) = DEPSA(iu,iy) - G1(it,iz)*DF2(it,iu,iy,iz)
           end do
#ifdef _MOLCAS_MPP_
          end if
#endif
         end do
        end do
       end do



* Correction to G2: Some values not computed follow from symmetry
      do ip1=1,nlev2-1
       itlev=idx2ij(1,ip1)
       iulev=idx2ij(2,ip1)
       it=L2ACT(itlev)
       iu=L2ACT(iulev)
       do ip3=ip1+1,nlev2
        iylev=idx2ij(1,ip3)
        izlev=idx2ij(2,ip3)
        iy=L2ACT(iylev)
        iz=L2ACT(izlev)
        SCAL=DG2(iy,iz,it,iu)+DG2(it,iu,iy,iz)
        DG2(it,iu,iy,iz)=Zero
        DG2(iy,iz,it,iu)=Scal
       end do
      end do
!-SVC20100310: took some spurious mirroring of G2 values out
!-of the loops and put them here, after the parallel section has
!-finished, so that GAdSUM works correctly.
      do ip1=ntri2+1,nlev2
       itlev=idx2ij(1,ip1)
       iulev=idx2ij(2,ip1)
       it=L2ACT(itlev)
       iu=L2ACT(iulev)
       do ip3=ntri1+1,ip1
        iylev=idx2ij(1,ip3)
        izlev=idx2ij(2,ip3)
        iy=L2ACT(iylev)
        iz=L2ACT(izlev)
        Scal=DG2(iz,iy,iu,it)+DG2(it,iu,iy,iz)
        DG2(it,iu,iy,iz)=Zero
        DG2(iz,iy,iu,it)=Scal
       end do
      end do
* Correction to G2: It is now = <0| E_tu E_yz |0>
      do iu=1,nlev
       do iz=1,nlev
        do it=1,nlev
         DG1(it,iz) = DG1(it,iz) - DG2(it,iu,iu,iz)
        end do
       end do
      end do
* Additional correction terms for F1
      Do iT = 1, NLEV
        Do iU = 1, NLEV
          !! With the improved algorithm, symmetrizing the DF1
          !! contribution to DF1 here is somehow required
          DG1(iT,iU) = DG1(iT,iU)
     &      - (DF1(iT,iU)+DF1(iU,iT))*EPSA(iU)*Half
        End Do
      End Do
#ifdef _MOLCAS_MPP_
      if (king()) then
#endif
        Do iT = 1, NLEV
          Do iU = 1, NLEV
            Do iV = 1, NLEV
              Do iX = 1, nLEV
                DEPSA(iV,iX) = DEPSA(iV,iX) + G2(iT,iU,iV,iX)*DF1(iT,iU)
              End Do
            End DO
          End DO
        End Do
#ifdef _MOLCAS_MPP_
      endif
#endif

      Call CLagSym(nLev,DG1,DG2,DF1,DF2,2)

      call mma_MaxDBLE(memmax)

* Use *almost* all remaining memory:
!     memmax_safe=int(dble(memmax)*0.95D0)

* Buffers to compute CI expansion vectors into:
* <Psi0|E_ip1 | E_ip2 E_ip3|Psi0>
* buf1: bra buffer with E_ip1 excitations of Psi0
*       holds multiple CI vectors (allowed by memory)
* buf2: ket buffer for an E_ip3 excitation of Psi0
* buft: ket buffer for an E_ip2 excitation of E_ip3|Psi0>
* bufd: diagonal matrix elements to compute the F matrix
      nbuf1= nbuf1_grad
      ndtu = nbuf1
      ndab = nbuf1
      nbufx= nlev
      call mma_allocate(BUF1,MXCI,NBUF1,Label='BUF1')
      call mma_allocate(BUF2,MXCI,Label='BUF2')
      call mma_allocate(BUFT,MXCI,Label='BUFT')
      call mma_allocate(BUFD,MXCI,Label='BUFD')

      call mma_allocate(DTU,MXCI,NDTU,Label='DTU')
      call mma_allocate(DYZ,MXCI,Label='DYZ')
      call mma_allocate(DAB,MXCI,NDAB,Label='DAB')
      call mma_allocate(BUF3,MXCI,Label='BUF3')
      call mma_allocate(BUF4,MXCI,Label='BUF4')

      call mma_allocate(BUFX,MXCI,NBUFX,Label='BUFX')

!-SVC20100301: calculate maximum number of tasks possible
      MXTASK=(NTRI2-1)/NBUF1+1+(NTRI1-1)/NBUF1+1
      CALL mma_allocate (TaskList,mxTask,4,LABEL='TaskList')

      IF(iPrGlb >= VERBOSE) THEN
        WRITE(u6,*)
        WRITE(u6,'(2X,A)') 'Constructing derivatives of G3/F3'
        WRITE(u6,'(2X,A,F16.9,A)') ' memory avail: ',
     &    (memmax*RtoB)/1.0e+09_wp, ' GB'
        WRITE(u6,'(2X,A,F16.9,A)') ' memory used:  ',
     &    (((3*nbuf1+6+nlev)*MXCI)*RtoB)/1.0e+09_wp, ' GB'
        call xFlush(u6)
      ENDIF
!     CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
!     CPUT =CPTF10-CPTF0
!     WALLT=TIOTF10-TIOTF0
!     write(6,*) 'PREP    : CPU/WALL TIME=', cput,wallt

      iG3OFF=0
      iTask_loc = 1
      first = .true.
* A *very* long loop over the symmetry of Sgm1 = E_ut Psi as segmentation.
* This also allows precomputing the Hamiltonian (H0) diagonal elements.
      DO issg1=1,nsym
       isp1=Mul(issg1,STSYM)
       nsgm1=CIS%ncsf(issg1)
       !! Work(LBufD) = \sum_t <I|E_{tt}|I>*f_{tt}
       CALL H0DIAG_CASPT2(ISSG1,BUFD,CIS%NOW,CIS%IOW,nMidV)

!-SVC20100301: calculate number of larger tasks for this symmetry, this
!-is basically the number of buffers we fill with sigma1 vectors.
      iTask=1
      ibuf1=0
      DO ip1=1,nlev2
        itlev=idx2ij(1,ip1)
        iulev=idx2ij(2,ip1)
        istu=Mul(SGS%ism(itlev),SGS%ism(iulev))
        IF (istu == isp1) THEN
          ibuf1=ibuf1+1
          ip1_buf(ibuf1)=ip1
          IF (ibuf1 == 1) TaskList(iTask,1)=ip1
        ENDIF
        IF (ibuf1 == nbuf1 .OR. (ibuf1 > 0 .AND.
     &         (ip1 == ntri2 .OR. ip1 == nlev2))) THEN
            TaskList(iTask,2)=ip1_buf(ibuf1)
            TaskList(iTask,3)=ibuf1
            iTask=iTask+1
            ibuf1=0
        ENDIF
      ENDDO
      nTasks=iTask
!     write(u6,*) 'nTasks = ', nTasks
      IF (ibuf1 == 0) nTasks=nTasks-1
!-SVC20100309: calculate number of inner loop iteration tasks.
      iOffSet=0
      DO iTask=1,nTasks
        TaskList(iTask,4)=iOffSet
        ip1sta=TaskList(iTask,1)
        ip1end=TaskList(iTask,2)
        ip3mx=ntri2
        if(ip1end <= ntri2) ip3mx=ip1end
        if(ip1sta > ntri2) ip3mx=ntri1
!       write(u6,*) 'iTask = ', iTask
!       write(u6,*) 'start,end=',ip1sta,ip1end
!       write(u6,*) 'ip3mx = ', ip3mx
!-SVC20100309: Currently -we are going to limit this to the ip3-loop and
!-leave the ip2-loop intact.  This was based on the large overhead which
!-was observed for a very large number of small tasks.
!       iOffSet=iOffSet+ip3mx*ntri2-((ip3mx**2-ip3mx)/2)
        iOffSet=iOffSet+ip3mx
      ENDDO
      nSubTasks=iOffSet
!     write(u6,*) 'nSubTasks = ', nSubTasks

      IF(iPrGlb >= VERBOSE) THEN
        WRITE(u6,'(2X,A,I3,A,I6)') 'Sym: ',issg1,', #Tasks: ',nSubTasks
        call xFlush(u6)
      ENDIF

      IF(iPrGlb >= DEBUG) THEN
        IF (nSubTasks > 0) THEN
          WRITE(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
!-position 12345678901234567890
     &    '--------',
     &    '------------',
     &    '----',
     &    '---------'
          WRITE(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
!-position 12345678901234567890
     &    'task ID ',
     &    ' ip1 range  ',
     &    'ip3 ',
     &    '#elements'
          WRITE(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
!-position 12345678901234567890
     &    '--------',
     &    '------------',
     &    '----',
     &    '---------'
          call xFlush(u6)
        END IF
      END IF

!-SVC20100301: initialize the series of subtasks
      Call Init_Tsk(ID, nSubTasks)

      myBuffer=0

      !! loop start
      do
!-SVC20100908: first check: can I actually do any task?
!     IF ((NG3-iG3OFF) < nbuf1*ntri2) GOTO 501
!-SVC20100831: initialize counter for offset into G3
!-SVC20100302: BEGIN SEPARATE TASK EXECUTION
!     write(u6,*) rsv_tsk(id,isubtask)
#ifdef _MOLCAS_MPP_
        if (is_real_par()) then
          !! do the same tasks here and in mkfg3.f
          iSubTask = iTasks_grad(iTask_loc)
          if (iSubTask == 0) exit
        else
#endif
          If (.NOT.Rsv_Tsk(ID,iSubTask)) exit
#ifdef _MOLCAS_MPP_
        end if
#endif

        myTask=nTasks
        DO iTask=1,nTasks
          iBuf=iSubTask-TaskList(iTask,4)
          IF (iBuf <= 0) THEN
            myTask=iTask-1
            exit
          ENDIF
        ENDDO
        iTask=myTask

        iOffSet=TaskList(iTask,4)

!-SVC20100310: one task handles a range of ip1 values
!-that are in the buffer and one ip3 value, for which
!-a loop over ip2 values is then executed.
        ip1sta=TaskList(iTask,1)
        ip1end=TaskList(iTask,2)
        ip3=iSubTask-iOffSet

!-SVC20100301: fill the buffer with sigma vectors if they
!-have not been computed yet, else just get the number of
!-sigma vectors in the buffer.
!     write(u6,*) 'myBuffer,iTask = ', myBuffer,iTask
        IF (myBuffer /= iTask) THEN
          if (.not.first) then
            !! Compute left derivative and DEPSA contributions before
            !! the TASK is completely switched
            CALL LEFT_DEPSA()
          end if
          ibuf1=0
          do ip1i=ip1sta,ip1end
           itlev=idx2ij(1,ip1i)
           iulev=idx2ij(2,ip1i)
           istu=Mul(SGS%ism(itlev),SGS%ism(iulev))
           it=L2ACT(itlev)
           iu=L2ACT(iulev)
           if(istu == isp1) then
            ibuf1=ibuf1+1
            ip1_buf(ibuf1)=ip1i
            BUF1(1:nsgm1,ibuf1) = Zero
            CALL SIGMA1(SGS,CIS,EXS,
     &                  IULEV,ITLEV,One,STSYM,CI,BUF1(:,ibuf1))
           end if
          end do
          myBuffer=iTask
          DTU(1:MXCI,1:ibuf1) = Zero
          DAB(1:MXCI,1:ibuf1) = Zero
          if (first) first = .false.
        ELSE
          ibuf1=TaskList(iTask,3)
        ENDIF
!-SVC20100301: necessary batch of sigma vectors is now in the buffer

        ! The ip1 buffer could be the same on different processes
        ! so only compute the G1 contribution when ip3 is 1, as
        ! this will only be one task per buffer.
        if (issg1 == STSYM .AND. ip3 == 1) then
          !! buf1 = <Psi0|E_ip1|I>
          !! <0|E_{tu}I> = <I|E_{ut}|0>
!         write(u6,*) 'ib loop'
          do ib=1,ibuf1
            idx=ip1_buf(ib)
            itlev=idx2ij(1,idx)
            iulev=idx2ij(2,idx)
            it=L2ACT(itlev)
            iu=L2ACT(iulev)
!           write(u6,'('itlev,iulev,it,iu = ',4i3)') itlev,iulev,it,iu
            !! DG1 contribution
            SCAL = DG1(iT,iU) + DG1(iT,iU)
            CLag(1:nsgm1) = CLag(1:nsgm1) + SCAL*BUF1(1:nsgm1,ib)

            !! left derivative of DF1
            Do icsf = 1, nsgm1
              DTU(icsf,ib) = DTU(icsf,ib)
     &          + DF1(it,iu)*BUFD(icsf)*CI(icsf)
            End Do
            !! right derivative of DF1
            Do icsf = 1, nsgm1
              CLag(icsf) = CLag(icsf)
     &          + DF1(it,iu)*BUF1(icsf,ib)*BUFD(icsf)
            End Do
!           G1(it,iu)=DDOT_(nsgm1,ci,1,work(lto),1)
!           IF(IFF /= 0) then
!             F1sum=0.0D0
!             do i=1,nsgm1
!               F1sum=F1sum+CI(i)*work(lto-1+i)*bufd(i)
!             end do
!             F1(it,iu)=F1sum-EPSA(iu)*G1(it,iu)
!           end if
          end do
        end if

!       ip3mx=ntri2
!       if(ip1end <= ntri2) ip3mx=ip1end
!       if(ip1sta > ntri2) ip3mx=ntri1
!-SVC20100309: loop over ip3, ip2
!       do ip3=1,ip3mx

!-SVC20100309: PAM's magic formula
*       iCnt=iSubTask-iOffSet
*       ip3=int(dble(ntri2)+1.5D0 -
*    &       sqrt((dble(ntri2)+0.5d0)**2-2*iCnt+0.000001D0))
*       ip2=iCnt-((ip3-1)*ntri2-((ip3-1)*(ip3-2))/2 )+ip3-1

!-SVC20100309: use simpler procedure by keeping inner ip2-loop intact

!       write(u6,*) 'ip3 = ', ip3
!       CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
        iq1=icnj(ip3)
* The indices corresponding to pair index p3:
        iylev=idx2ij(1,ip3)
        izlev=idx2ij(2,ip3)
        isyz=Mul(SGS%ism(iylev),SGS%ism(izlev))
        issg2=Mul(isyz,STSYM)
        nsgm2=CIS%ncsf(issg2)
        iy=L2ACT(iylev)
        iz=L2ACT(izlev)
        buf2(1:nsgm2) = Zero
        CALL SIGMA1(SGS,CIS,EXS,IYLEV,IZLEV,One,STSYM,CI,BUF2)
        DYZ(1:nsgm1) = Zero
        if(issg2 == issg1) then
          buf3(1:nsgm2) = Zero
          do ib=1,ibuf1
            idx=ip1_buf(ib)
            itlev=idx2ij(1,idx)
            iulev=idx2ij(2,idx)
            it=L2ACT(itlev)
            iu=L2ACT(iulev)

            ScalG=DG2(iT,iU,iY,iZ)
            ScalF=DF2(iT,iU,iY,iZ)
            If (ScalG == Zero .and. ScalF == Zero) cycle

            !! left derivative
            Do icsf = 1, nsgm1
             BUFT(icsf) = ScalG*BUF2(icsf) + ScalF*BUF2(icsf)*BUFD(icsf)
            End Do
            DTU(1:nsgm1,ib) = DTU(1:nsgm1,ib) + BUFT(1:nsgm1)

            !! right derivative
            buft(1:mxci) = buf1(1:mxci,ib)
            Do icsf = 1, nsgm1
              BUF3(icsf) = BUF3(icsf)
     &          + ScalG*BUFT(icsf) + ScalF*BUFT(icsf)*BUFD(icsf)
            End Do

            !! For DEPSA
            DAB(1:nsgm1,ib) = DAB(1:nsgm1,ib) + ScalF*BUF2(1:nsgm1)
          end do
          !! Save for Eyz
          DYZ(1:nsgm2) = DYZ(1:nsgm2) + BUF3(1:nsgm2)
        end if
        nbtot=0



        !! Prepare for DEPSA for the -epsa(iv) term with square
        iG3bk = iG3OFF
        Do ixlev0 = 1, nlev
          Do ivlev = 1, nlev
            BUFX(1:nsgm1,ivlev) = Zero
            CALL SIGMA1(SGS,CIS,EXS,
     &                  IVLEV,IXLEV0,One,STSYM,BUF2,BUFX(1,ivlev))
          End Do
          iG3OFF = iG3bk
          do ip2=ip3,ntri2
            ivlev=idx2ij(1,ip2)
            ixlev=idx2ij(2,ip2)
            isvx=Mul(SGS%ism(ivlev),SGS%ism(ixlev))
            iv=L2ACT(ivlev)
            ix=L2ACT(ixlev)
            if(isvx /= Mul(issg1,issg2)) cycle
            !! <I|EvxEyz|0>
            If (IXLEV == IXLEV0) BUFT(1:nsgm1) = BUFX(1:nsgm1,IVLEV)
*-----------
* Max and min values of index p1:
            ip1mx=ntri2
            if(ip3 <= ntri1) then
              ip1mx=nlev2
              if(ip2 > ntri1) ip1mx=iq1
            end if
            ip1mn=max(ip2,ip1sta)
            ip1mx=min(ip1mx,ip1end)
* The corresponding locations in the Sgm1 buffer:
            ibmn=999999
            ibmx=-999999
            do ib=ibuf1,1,-1
              ip1=ip1_buf(ib)
              if(ip1 >= ip1mn)ibmn=ib
            end do
            do ib=1,ibuf1
              ip1=ip1_buf(ib)
              if(ip1 <= ip1mx)ibmx=ib
            end do
            nb=ibmx-ibmn+1
            if(nb <= 0) cycle
            if (ixlev /= ixlev0) then
              iG3OFF = iG3OFF + nb
              cycle
            end if
!
!         ----- left derivative
!
            do icsf = 1, nsgm1
              ! BUF3 = (<I|Ett|I>-EPSA(V))*<I|EvxEyz|0> = <I|fEvxEyz|0>
              buf3(icsf) = (bufd(icsf)-epsa(iv))*buft(icsf)
            end do
            do ib=1,nb
              iG3=iG3OFF+ib
              idx=ip1_buf(ibmn-1+ib)

              !! <I|EvxEyz|0>*Dtuvxyz + <I|fEvxEyz|0>*Ftuvxyz
              DTU(1:nsgm1,ibmn+ib-1) = DTU(1:nsgm1,ibmn+ib-1)
     &          + DG3(iG3)*BUFT(1:nsgm1) + DF3(iG3)*BUF3(1:nsgm1)
              !! DEPSA of the BUFD term
              DAB(1:nsgm1,ibmn+ib-1) = DAB(1:nsgm1,ibmn+ib-1)
     &          + DF3(iG3)*BUFT(1:nsgm1)
            end do
!
!         ----- right derivative
!
            BUF3(1:nsgm1) = Zero
            BUF4(1:nsgm1) = Zero
            !! right derivative (1):
            !! <0|Etu|I>*Dtuvxyz and <0|Etu|I>*Ftuvxyz
            !! <0|EtuEvxEyz|I> -> <I|EzyExvEut|0>
            do ib=1,nb
              iG3=iG3OFF+ib
              idx=ip1_buf(ibmn-1+ib)

              !! BUF3 = <0|Etu|I>*Dtuvxyz
              BUF3(1:nsgm1) = BUF3(1:nsgm1)
     &          + DG3(iG3)*BUF1(1:nsgm1,ibmn+ib-1)
              !! BUFC = <0|Etu|I>*Ftuvxyz
              BUF4(1:nsgm1) = BUF4(1:nsgm1)
     &          + DF3(iG3)*BUF1(1:nsgm1,ibmn+ib-1)
            end do

            !! DEPSA of the -EPSA(iv) term
            Call DGEMV_('T',nsgm1,NLEV,
     &                 -One,BUFX,mxci,buf4,1,
     &                  One,DEPSA(1,IVLEV),1)

            !! Scale the DF3 contribution with the diagonal Fock
            !! and add to the DG3 contribution
            do icsf = 1, nsgm1
              buf3(icsf) = buf3(icsf) + buf4(icsf)*(bufd(icsf)-epsa(iv))
            end do
            !! right derivative (2): <0|EtuEvx|I>*Dtuvxyz
            CALL SIGMA1(SGS,CIS,EXS,IXLEV,IVLEV,One,STSYM,BUF3,DYZ)

            iG3OFF=iG3OFF+nb
            nbtot=nbtot+nb
          end do !! end of ip2 loop
        End Do !! end of ixlev0 loop

        !! Complete the right derivative contribution:
        !! <0|EtuEyz|I> and <0|EtuEvxEyz|I>
        CALL SIGMA1(SGS,CIS,EXS,IZLEV,IYLEV,One,STSYM,DYZ,CLAG)

        IF(iPrGlb >= DEBUG) THEN
          WRITE(u6,'("DEBUG> ",I8,1X,"[",I4,"..",I4,"]",1X,I4,1X,I9)')
     &      iSubTask, ip1sta, ip1end, ip3, nbtot
          call xFlush(u6)
        END IF
        iTask_loc = iTask_loc + 1

!SVC: The master node now continues to only handle task scheduling,
!     needed to achieve better load balancing. So it exits from the task
!     list.  It has to do it here since each process gets at least one
!     task.

      end do
!-SVC20100301: end of the task

      !! Final (the last task) left derivative and DEPSA contributions
      CALL LEFT_DEPSA()

!-SVC20100302: no more tasks, wait here for the others, then proceed
! with next symmetry
      CALL Free_Tsk(ID)

      IF(iPrGlb >= DEBUG) THEN
        IF (nSubTasks > 0) THEN
          WRITE(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
!-position 12345678901234567890
     &    '--------',
     &    '------------',
     &    '----',
     &    '---------'
        END IF
      END IF

* End of sectioning loop over symmetry of Sgm1 wave functions.
      END DO

#ifdef _MOLCAS_MPP_
      if (is_real_par() .and. (iTask_loc-1 /= nTasks_grad)) then
        write (u6,*)
        write (u6,*) 'Somehow, the number of tasks in mkfg3.f and ',
     &              'derfg3.f is not consistent...'
        write (u6,*) 'probably, bug'
        write (u6,*) '# of tasks in  mkfg3.f = ', nTasks_grad
        write (u6,*) '# of tasks in derfg3.f = ', iTask_loc-1
        call abend()
      end if
#endif

      CALL mma_deallocate(TASKLIST)
      ! free CI buffers
      call mma_deallocate(BUF1)
      call mma_deallocate(BUF2)
      call mma_deallocate(BUFT)
      call mma_deallocate(BUFD)

      call mma_deallocate(DTU)
      call mma_deallocate(DYZ)
      call mma_deallocate(DAB)
      call mma_deallocate(BUF3)
      call mma_deallocate(BUF4)

      call mma_deallocate(BUFX)

      contains

      SUBROUTINE LEFT_DEPSA()

      IMPLICIT NONE

      integer(kind=iwp) :: IALEVloc, IBLEVloc, ibloc

      do ibloc=1,ibuf1
        idx=ip1_buf(ibloc)
        itlev=idx2ij(1,idx)
        iulev=idx2ij(2,idx)
        !! left derivative
        CALL SIGMA1(SGS,CIS,EXS,ITLEV,IULEV,One,STSYM,DTU(1,ibloc),CLAG)
        !! the rest is DEPSA contribution
        Do IALEVloc = 1, NLEV
          Do IBLEVloc = 1, NLEV
            BUF2(:) = Zero
            CALL SIGMA1(SGS,CIS,EXS,
     &                 IALEVloc,IBLEVloc,One,STSYM,DAB(1,ibloc),BUF2)
            DEPSA(IALEVloc,IBLEVloc) = DEPSA(IALEVloc,IBLEVloc)
     &        + DDot_(nsgm1,BUF1(1,IBloc),1,BUF2,1)
          End Do
        End Do
      end do

      END SUBROUTINE LEFT_DEPSA

      END SUBROUTINE DERFG3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2006  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE DERSPE(DF1,DF2,DF3,idxG3,DEPSA,G1,G2,G3)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
#endif
      use gugx, only: SGS, LEVEL
      use caspt2_module, only: NACTEL, NASHT, ISCF
      use pt2_guga, only: ETA, NG3
      use Constants, only: Zero, One, Two
      use definitions, only: wp, iwp, byte, u6

      implicit none

      real(kind=wp), intent(in) :: DF1(NASHT,NASHT),
     &  DF2(NASHT,NASHT,NASHT,NASHT), DF3(*), G1(NASHT,NASHT),
     &  G2(NASHT,NASHT,NASHT,NASHT), G3(*)
      integer(kind=byte), intent(inout) :: idxG3(6,*)
      real(kind=wp), intent(inout) :: DEPSA(NASHT,NASHT)

      integer(kind=iwp), parameter :: I1=KIND(idxG3)
! SPECIAL-CASE ROUTINE. DELIVERS G AND F MATRICES FOR A HIGH-SPIN
! OR CLOSED-SHELL SCF CASE.

      logical(kind=iwp), external ::  RSV_TSK
      integer(kind=iwp) :: nLev, I, NLEV2, NLEV4, iG3, nTask, ID, iTask,
     &  IND1, IND2, IT1, IU1, LU1, IT2, IU2, LU2, IT3, IU3, IND3, LU3,
     &  LT, IT, IU, LU, IV, LV
      real(kind=wp) :: ESUM, DESUM, OCC

      nLev = SGS%nLev

      ESUM=Zero
      DESUM=Zero
      DO I=1,NLEV
        ESUM=ESUM+ETA(I)
      END DO
! ISCF=1 for closed-shell, =2 for hispin
      OCC=Two
      IF(ISCF == 2) OCC=One

      if (NACTEL == 1 .or. NACTEL == 2) NG3 = 0
      if (NACTEL /= 1) then
        if (NACTEL /= 2) then
          write(u6,*) 'I have not implemented for non-standard Psi0, ',
     &      'when A and C subspaces contribute to the energy, ',
     &      'in particular'
          write(u6,*) 'I cannot debug, ',
     &      'because I do not know when it happens'
!         call abend()

          NLEV2=NLEV**2
          NLEV4=NLEV**4

          iG3=0
          nTask=NLEV4
! SVC20100908 initialize the series of tasks
          Call Init_Tsk(ID, nTask)

          do
#ifdef _MOLCAS_MPP_
            IF ((NG3-iG3) < NLEV2) exit
#endif
            IF (.NOT.Rsv_Tsk(ID,iTask)) exit

            IND1=MOD(iTask-1,NLEV2)+1
            IND2=((iTask-IND1)/(NLEV2))+1
            IF(IND2 > IND1) cycle

            IT1=MOD(IND1-1,NASHT)+1
            IU1=(IND1-IT1)/NASHT+1
            LU1=LEVEL(IU1)
            IT2=MOD(IND2-1,NASHT)+1
            IU2=(IND2-IT2)/NASHT+1
            LU2=LEVEL(IU2)

            DO IT3=1,NLEV
             DO IU3=1,NLEV
              IND3=IT3+NASHT*(IU3-1)
              IF(IND3 > IND2) cycle
              LU3=LEVEL(IU3)
!             VAL=G1(IT1,IU1)*G1(IT2,IU2)*G1(IT3,IU3)

! Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
! Add here the necessary Kronecker deltas times 2-body matrix
! elements and lower, so we get a true normal-ordered density matrix
! element.

! <PSI1|E(T1,U1,T2,U2,T3,U3)|PSI2>
! = <PSI1|E(T1,U1)E(T2,U2)E(T3,U3)|PSI2>
! -D(T3,U2)*(G2(T1,U1,T2,U3)+D(T2,U1)*G1(T1,U3))
! -D(T2,U1)*G2(T1,U2,T3,U3)
! -D(T3,U1)*G2(T2,U2,T1,U3)

!             IF(IT3 == IU2) THEN
!               VAL=VAL-G2(IT1,IU1,IT2,IU3)
!               IF(IT2 == IU1) THEN
!                 VAL=VAL-G1(IT1,IU3)
!               END IF
!             END IF
!             IF(IT2 == IU1) THEN
!               VAL=VAL-G2(IT1,IU2,IT3,IU3)
!             END IF
!             IF(IT3 == IU1) THEN
!               VAL=VAL-G2(IT2,IU2,IT1,IU3)
!             END IF

! VAL is now =<PSI1|E(IT1,IU1,IT2,IU2,IT3,IU3)|PSI2>
              iG3=iG3+1
              idxG3(1,iG3)=INT(iT1,I1)
              idxG3(2,iG3)=INT(iU1,I1)
              idxG3(3,iG3)=INT(iT2,I1)
              idxG3(4,iG3)=INT(iU2,I1)
              idxG3(5,iG3)=INT(iT3,I1)
              idxG3(6,iG3)=INT(iU3,I1)
!             G3(iG3)=VAL
!             F3(iG3)=(ESUM*OCC-ETA(LU1)-ETA(LU2)-ETA(LU3))*VAL
              DESUM = DESUM + OCC*G3(iG3)*DF3(iG3)
              DEPSA(LU1,LU1) = DEPSA(LU1,LU1) - OCC*G3(iG3)*DF3(iG3)
              DEPSA(LU2,LU2) = DEPSA(LU2,LU2) - OCC*G3(iG3)*DF3(iG3)
              DEPSA(LU3,LU3) = DEPSA(LU3,LU3) - OCC*G3(iG3)*DF3(iG3)
              END DO
            END DO

!SVC: The master node now continues to only handle task scheduling,
!     needed to achieve better load balancing. So it exits from the task
!     list.  It has to do it here since each process gets at least one
!     task.
          end do

! SVC2010: no more tasks, wait here for the others.
          CALL Free_Tsk(ID)

          NG3=iG3
        end if
        DO IT=1,NASHT
         LT=LEVEL(IT)
         DO IU=1,NASHT
          LU=LEVEL(IU)
!         G2(IT,IT,IU,IU)=G1(IT,IT)*G1(IU,IU)
!         IF(IU == IT) THEN
!          G2(IT,IT,IU,IU)=G2(IT,IT,IU,IU)-G1(IT,IU)
!         ELSE
!          G2(IT,IU,IU,IT)=-G1(IT,IT)
!         END IF
!         F2(IT,IT,IU,IU)=(ESUM*OCC-ETA(LT)-ETA(LU))*G2(IT,IT,IU,IU)
!         F2(IT,IU,IU,IT)=(ESUM*OCC-ETA(LT)-ETA(LU))*G2(IT,IU,IU,IT)
          DESUM = DESUM + OCC*G2(IT,IT,IU,IU)*DF2(IT,IT,IU,IU)
          DESUM = DESUM + OCC*G2(IT,IU,IU,IT)*DF2(IT,IU,IU,IT)
          DO IV=1,NASHT
          LV=LEVEL(IV)
          DEPSA(LT,LV)=DEPSA(LT,LV)-OCC*G2(IT,IT,IU,IU)*DF2(IT,IV,IU,IU)
          DEPSA(LU,LV)=DEPSA(LU,LV)-OCC*G2(IT,IT,IU,IU)*DF2(IT,IT,IU,IV)
          DEPSA(LT,LV)=DEPSA(LT,LV)-OCC*G2(IT,IU,IU,IT)*DF2(IT,IU,IU,IV)
          DEPSA(LU,LV)=DEPSA(LU,LV)-OCC*G2(IT,IU,IU,IT)*DF2(IT,IU,IV,IT)
          END DO
         END DO
        END DO
      end if

      DO IT=1,NASHT
!       G1(IT,IT)=OCC
        LT=LEVEL(IT)
!       F1(IT,IT)=(ESUM*OCC-ETA(LT))*G1(IT,IT)
        DESUM = DESUM + OCC*G1(IT,IT)*DF1(IT,IT)
        Do IU=1, NASHT
          LU=LEVEL(IU)
          DEPSA(LT,LU) = DEPSA(LT,LU) - OCC*G1(IT,IT)*DF1(IT,IU)
        End Do
      END DO

      RETURN
      END subroutine DERSPE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 FUNCTION INPRDD(VEC1,VEC2,LU1,LU2,IREW,LBLK)
C
C DISC VERSION OF INPROD
C
C LBLK DEFINES STRUCTURE OF FILE
C
      IMPLICIT REAL*8(A-H,O-Z)
#include "io_util.fh"
      REAL*8 INPROD
      DIMENSION VEC1(*),VEC2(*)
      LOGICAL DIFVEC
      DIMENSION IDUMMY(1)
C
      X = 0.0D0
      IF( LU1 .NE. LU2 ) THEN
        DIFVEC = .TRUE.
      ELSE
        DIFVEC =  .FALSE.
      END IF
C
      IF( IREW .NE. 0 ) THEN
        IF( LBLK .GE. 0 ) THEN
          IDISK(LU1)=0
          IF(DIFVEC) IDISK(LU2)=0
         ELSE
          IDISK(LU1)=0
          IF(DIFVEC) IDISK(LU2)=0
         END IF
      END IF
C
C LOOP OVER BLOCKS OF VECTORS
C
 1000 CONTINUE
C
        IF( LBLK .GT. 0 ) THEN
          NBL1 = LBLK
        ELSE IF ( LBLK .EQ. 0 ) THEN
          CALL IDAFILE(LU1,2,IDUMMY,1,IDISK(LU1))
          NBL1=IDUMMY(1)
          IF( DIFVEC) THEN
            CALL IDAFILE(LU2,2,IDUMMY,1,IDISK(LU2))
          END IF
        ELSE IF ( LBLK .LT. 0 ) THEN
          CALL IDAFILE(LU1,2,IDUMMY,1,IDISK(LU1))
          NBL1=IDUMMY(1)
          CALL IDAFILE(LU1,2,IDUMMY,1,IDISK(LU1))
          IF( DIFVEC) THEN
            CALL IDAFILE(LU2,2,IDUMMY,1,IDISK(LU2))
            CALL IDAFILE(LU2,2,IDUMMY,1,IDISK(LU2))
          END IF
        END IF
C
        IF(NBL1 .GE. 0 ) THEN
          IF(LBLK .GE.0 ) THEN
            KBLK = NBL1
          ELSE
            KBLK = -1
          END IF
          CALL FRMDSC(     VEC1,     NBL1,     KBLK,      LU1,   IMZERO,
     &                  IAMPACK)
          IF( DIFVEC) THEN
            CALL FRMDSC(    VEC2,    NBL1,    KBLK,     LU2,  IMZERO,
     &                   IAMPACK)
            IF(NBL1 .GT. 0 )
     &      X = X + INPROD(VEC1,VEC2,NBL1)
C?          write(6,*) ' vec1 and vec2 in INPRDD '
C?         CALL WRTMAT(VEC1,1,NBL1,1,NBL1)
C?         CALL WRTMAT(VEC2,1,NBL1,1,NBL1)
          ELSE
          IF(NBL1 .GT. 0 )
     &    X = X + INPROD(VEC1,VEC1,NBL1)
        END IF
      END IF
      IF(NBL1.GE. 0 .AND. LBLK .LE. 0) GOTO 1000
C
      INPRDD = X
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RTSWGH(TARR,NT,U2,WGH,NRYS)
      use vRys_RW
      IMPLICIT REAL*8 (A-H,O-Z)
#include "itmax.fh"
#include "real.fh"
#include "print.fh"
#include "abtab.fh"
CMAW
#include "FMM.fh"
      DIMENSION TARR(NT),U2(NRYS,NT),WGH(NRYS,NT)
      DIMENSION ROOT(MXSIZ1,MXSIZ1),RYS(0:MXSIZ1),RYSD(0:MXSIZ1)
      DIMENSION ALPHA(0:MXSIZ1),BETA(0:MXSIZ1)
      DIMENSION BINV(0:MXSIZ1)
      parameter (coef1=-1.0d0/120d0, coef2=-5d0*coef1, coef3=-2d0*coef2)
      parameter (coef4=-coef3, coef5=-coef2, coef6=-coef1)
c
      iRout = 78
      iPrint = nPrint(iRout)
      RYSD(0)=ZERO
c
      IF (NRYS.gt.maxdeg) THEN
        CALL WarningMessage(2,' Too many requested Rys roots.')
        CALL AbEnd()
      ENDIF
c
      DO 5000 IT=1,NT
        T=TARR(IT)
c Use asymptotic formulae if outside table.
CMAW    if(t.gt.TVALUE(NTAB2-NTAB1-1)) then
*
*  For the FMM we use the asymptotic limit to compute the
*  multipole-component of the integrals
*
      If( (t.gt.TVALUE(NTAB2-NTAB1-1)) .OR. asymptotic_Rys ) Then
        do 25 iroot=1,nRYS
          tmp = 1.0D0/T
          U2(iroot,IT)=HerR2(iHerR2(nRys)+iroot-1)*tmp
          WGH(iroot,IT)=HerW2(iHerW2(nRys)+iroot-1)*SQRT(tmp)
 25     Continue
        Go To 5000
      end if
c translate to tabulation function for equidist. interp.
c xn=interpol. variable.
c Ex: T=0.0--0.05 gives xn=0.0--1.0 (approx.)
c itab= Start tab index for interp. Ex above: itab=1.
      xn=5d0*T + 200d0*T/(14d0+T)
      nx=Int(xn)
      itab=nx-1-NTAB1
      p=xn-dble(nx)
      a2=(p+2d0)
      a3=(p+1d0)*a2
      a4=(p    )*a3
      a5=(p-1d0)*a4
      a6=(p-2d0)*a5
      b5=(p-3d0)
      b4=(p-2d0)*b5
      b3=(p-1d0)*b4
      b2=(p    )*b3
      b1=(p+1d0)*b2
      c1=coef1*   b1
      c2=coef2*a2*b2
      c3=coef3*a3*b3
      c4=coef4*a4*b4
      c5=coef5*a5*b5
      c6=coef6*a6
      ALPHA(0)=c1*ATAB(0,itab)+c2*ATAB(0,itab+1)+
     &         c3*ATAB(0,itab+2)+c4*ATAB(0,itab+3)+
     &         c5*ATAB(0,itab+4)+c6*ATAB(0,itab+5)
      do 20 k=1,NRYS
        ALPHA(k)=c1*ATAB(k,itab)+c2*ATAB(k,itab+1)+
     &         c3*ATAB(k,itab+2)+c4*ATAB(k,itab+3)+
     &         c5*ATAB(k,itab+4)+c6*ATAB(k,itab+5)
        BETA(k)=c1*BTAB(k,itab)+c2*BTAB(k,itab+1)+
     &         c3*BTAB(k,itab+2)+c4*BTAB(k,itab+3)+
     &         c5*BTAB(k,itab+4)+c6*BTAB(k,itab+5)
        BINV(K)=ONE/BETA(K)
  20  continue
      rys(0)=c1*p0(itab)+c2*p0(itab+1)+
     &       c3*p0(itab+2)+c4*p0(itab+3)+
     &       c5*p0(itab+4)+c6*p0(itab+5)
        ROOT(1,1)=ALPHA(0)
        x1=(ALPHA(0)+ALPHA(1))/2d0
        x2=(ALPHA(0)-ALPHA(1))/2d0
        x3=SQRT(x2**2+BETA(1)**2)
        ROOT(1,2)=x1-x3
        ROOT(2,2)=x1+x3
C LOOP OVER DEGREE OF RYS POLY
        DO 2000 IDEG=3,NRYS
C ESTIMATE POSITION OF U2 OF THIS DEGREE:
          ROOT(1,IDEG)=(DBLE(IDEG)-0.5D00)*ROOT(1,IDEG-1)/DBLE(IDEG)
          ROOT(IDEG,IDEG)=
     &      ONE-(DBLE(IDEG)-0.5D00)*(ONE-ROOT(IDEG-1,IDEG-1))/DBLE(IDEG)
          DO 80 IROOT=2,IDEG-1
            R1=ROOT(IROOT,IDEG-1)
            R2=ROOT(IROOT-1,IDEG-1)
            x2=(DBLE(IROOT)-0.5D00)/DBLE(IDEG)
            x1=ONE-x2
            R=x1*R1+x2*R2
            ROOT(IROOT,IDEG)=R
  80      CONTINUE
C         IF(IDEG.EQ.NRYS) ITER=0
          RYSD(1)=RYS(0)*BINV(1)
          DO 1000 IROOT=1,IDEG
            Z=ROOT(IROOT,IDEG)
C Compute the correction coefficient:
            corr=zero
            do 91 J=1,iroot-1
              corr=corr+one/(root(iroot,ideg)-root(j,ideg))
  91        continue
            do 92 J=iroot+1,ideg
              corr=corr+one/(root(iroot,ideg)-root(j,ideg))
  92        continue
C COMPUTE RYS AND FIRST DERIVATIVE, DO NEWTON-RAPHSON:
  99        CONTINUE
            RYS(1)=(Z-ALPHA(0))*RYSD(1)
            ZZ=(Z-ALPHA(1))
            RYSD(2)=(ZZ*RYSD(1)+RYS(1))*BINV(2)
            RYS(2) =(ZZ*RYS(1)-BETA(1)*RYS(0))*BINV(2)
            DO 110 K=2,IDEG-1
              ZZ=Z-ALPHA(K)
              BK= BETA(K)
              RYSD(K+1)=(RYS(K)+ZZ*RYSD(K)-BK*RYSD(K-1))*BINV(K+1)
              RYS(K+1) =(       ZZ*RYS(K) -BK*RYS (K-1))*BINV(K+1)
 110        CONTINUE
            DELTA=-RYS(IDEG)/(RYSD(IDEG)-CORR*RYS(IDEG))
            Z=Z+DELTA
C           IF(IDEG.EQ.NRYS) ITER=ITER+1
            IF(ABS(DELTA).GT.1.0d-08) goto 99
            ROOT(IROOT,IDEG)=Z
 1000     CONTINUE
 2000   CONTINUE
C     IF(NRYS.GT.2)
C    &      write(*,'(1x,a,f8.2)')' Avg. iter/root:',(iter*one)/NRYS
      DO 3010 IROOT=1,NRYS
        Z=ROOT(IROOT,NRYS)
C COMPUTE RYS VALUES AND ADD SQUARES TO GET WGH:
        SUM=RYS(0)**2
        IF(NRYS.EQ.1) goto 3021
        RYS(1)=(Z-ALPHA(0))*RYS(0)*BINV(1)
        SUM=SUM+RYS(1)**2
        IF(NRYS.EQ.2) goto 3021
        ZZ=(Z-ALPHA(1))
        RYS(2) =(ZZ*RYS(1)-BETA(1)*RYS(0))*BINV(2)
        SUM=SUM+RYS(2)**2
        IF(NRYS.EQ.3) goto 3021
        DO 3020 K=2,NRYS-2
          ZZ=Z-ALPHA(K)
          BK= BETA(K)
          RYS(K+1) =(ZZ*RYS(K) -BK*RYS (K-1))*BINV(K+1)
          SUM=SUM+RYS(K+1)**2
 3020   CONTINUE
 3021   CONTINUE
        WGH(IROOT,IT)=ONE/SUM
        U2(IROOT,IT)=ROOT(IROOT,NRYS)
 3010 CONTINUE
C
 5000 CONTINUE
C
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' Roots',' ',U2,nRys,nT)
         Call RecPrt(' Weights',' ',Wgh,nRys,nT)
      End If
#endif
      RETURN
      END

!**********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Quan Phung                                       *
!***********************************************************************
! Main control file for DICE. Template from CheMPS2 interface.

subroutine DiceCtl(W1,TUVX,IFINAL,IRST)

#ifdef _MOLCAS_MPP_
use MPI, only: MPI_COMM_WORLD
use Para_Info, only: Is_Real_Par, King
use Definitions, only: MPIInt
#endif
use Index_Functions, only: nTri_Elem
use rasscf_data, only: dice_eps1, dice_eps2, dice_iter, dice_restart, dice_sampleN, dice_stoc, diceocc, ENER, ITER, lroots, mxSym, &
                       NAC, nref_dice
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: W1(*), TUVX(*)
integer(kind=iwp), intent(in) :: IFINAL, IRST
#include "general.fh"
integer(kind=iwp) :: chemroot, iChMolpro(8), iErr, iOper(0:7), iOrb, iref_dice, iSigma, iSym, jOrb, LINSIZE, lSymMolpro, LUDICEIN, &
                     LUTOTE, nIrrep, NUM_TEI
integer(kind=iwp), allocatable :: OrbSym(:)
#ifdef _MOLCAS_MPP_
integer(kind=MPIInt) :: IERROR
#endif
real(kind=wp) :: pt2ener
logical(kind=iwp) :: Found
character(len=3) :: dice_nprocs, Label
character(len=10) :: rootindex
character(len=150) :: imp1, imp2
integer(kind=iwp), external :: isFreeUnit

#include "macros.fh"
unused_var(IFINAL)

! Quan: FIXME: Do we need this?
! Load symmetry info from RunFile
iOper = 0
call Get_iScalar('NSYM',nIrrep)
call Get_iArray('Symmetry operations',iOper,nIrrep)
call Get_iScalar('Rotational Symmetry Number',iSigma)

! Get character table to convert MOLPRO symmetry format
call MOLPRO_ChTab(nSym,Label,iChMolpro)

! Convert orbital symmetry into MOLPRO format
call mma_allocate(OrbSym,NAC,label='OrbSym')
iOrb = 1
do iSym=1,nSym
  do jOrb=1,NASH(iSym)
    OrbSym(iOrb) = iChMolpro(iSym)
    iOrb = iOrb+1
  end do
end do
lSymMolpro = iChMolpro(stSym)

!*********************
!  WRITEOUT FCIDUMP  *
!*********************

LINSIZE = nTri_Elem(NAC)
NUM_TEI = nTri_Elem(LINSIZE)
call FCIDUMP_OUTPUT(NAC,NACTEL,ISPIN-1,lSymMolpro,OrbSym,Zero,W1,TUVX,LINSIZE,NUM_TEI)

call mma_deallocate(OrbSym)
! Dice only reads FCIDUMP file
call systemf('ln -sf FCIDUMP_CHEMPS2 FCIDUMP',iErr)

!************************
!  WRITEOUT INPUT FILE  *
!************************
#ifdef _MOLCAS_MPP_
if (KING() .or. (.not. Is_Real_Par())) then
#endif
  if (IRST == 0) then
    ! Cleanup dice.out.total
    imp1 = 'dice.out.total'
    call f_inquire(imp1,Found)
    if (Found) call aixrm(imp1)
  end if
#ifdef _MOLCAS_MPP_
end if
#endif

write(u6,*) 'DICE> INTERATION : ',ITER
LUDICEIN = isFreeUnit(30)
call molcas_open(LUDICEIN,'input.dat')

write(LUDICEIN,'(a4,i4)') 'nocc',NACTEL
do iref_dice=1,nref_dice
  write(LUDICEIN,'(a)') trim(diceocc(iref_dice))
end do
write(LUDICEIN,'(a3)') 'end'
write(LUDICEIN,'(a6,i3)') 'nroots',lroots
write(LUDICEIN,*)
write(LUDICEIN,'(a8)') 'schedule'
write(LUDICEIN,'(a1,e12.5)') '0',dice_eps1*Ten
write(LUDICEIN,'(a1,e12.5)') '3',dice_eps1*Ten
write(LUDICEIN,'(a1,e12.5)') '6',dice_eps1
write(LUDICEIN,'(a3)') 'end'
write(LUDICEIN,'(a7,i6)') 'maxiter',dice_iter
write(LUDICEIN,'(a5)') 'DoRDM'
write(LUDICEIN,'(a8)') 'dE 1.e-8'
write(LUDICEIN,*)
write(LUDICEIN,'(a7,i6)') 'SampleN',dice_sampleN
write(LUDICEIN,'(a8,e12.5)') 'epsilon2',dice_eps2
write(LUDICEIN,'(a18)') 'targetError 8.0e-5'
if (IRST > 0 .or. dice_restart) then
  write(LUDICEIN,'(a11)') 'fullrestart'
end if

if (.not. dice_stoc) then
  write(LUDICEIN,'(a13)') 'deterministic'
else
  write(LUDICEIN,'(a13,e12.5)') 'epsilon2Large',dice_eps2*Ten
end if

close(LUDICEIN)

!*****************************
!  RUN DICE                  *
!*****************************

#ifdef _MOLCAS_MPP_
if (KING() .or. (.not. Is_Real_Par())) then
#endif
  call get_environment_variable("MOLCAS_DICE",dice_nprocs,status=ierr)
  if (ierr == 0) then
    imp2 = 'mpirun -np '//trim(adjustl(dice_nprocs))//' Dice >dice.out 2>dice.err'
  else
    imp2 = 'Dice >dice.out 2>dice.err'
  end if

  call systemf(imp2,iErr)
  if (iErr /= 0) then
    write(u6,*) 'DICE> DICE ends abnormally, check calculation'
  end if
  call systemf('cat dice.out >> dice.out.total',iErr)
#ifdef _MOLCAS_MPP_
end if

if (Is_Real_Par()) then
  call MPI_Barrier(MPI_COMM_WORLD,IERROR)
end if

if (Is_Real_Par() .and. (.not. KING())) then
  do chemroot=1,lroots
    write(rootindex,'(i2)') chemroot-1
    imp1 = 'ln -sf ../spatialRDM.'//trim(adjustl(rootindex))//'.'//trim(adjustl(rootindex))//'.txt .'
    call systemf(imp1,iErr)
  end do
  call systemf("ln -sf ../dice.out .",iErr)
end if
#endif

!*****************************
!  EXTRACT ENERGY            *
!*****************************

if (.not. dice_stoc) then
  imp1 = 'grep PTEnergy dice.out | cut -c 10- > dice.energy'
  call systemf(imp1,iErr)
else
  do chemroot=1,lroots
    write(rootindex,'(i2)') chemroot+2
    imp1 = 'grep -A '//trim(adjustl(rootindex))// &
           ' "VARIATIONAL CALCULATION RESULT" dice.out | tail -n 1 | cut -c 6-30 >> dice.energy'
    call systemf(imp1,iErr)
  end do
  imp2 = 'grep +/- dice.out | cut -c 10- > PT2.energy'
  call systemf(imp2,iErr)
end if

LUTOTE = isFreeUnit(30)
call molcas_open(LUTOTE,'dice.energy')

do chemroot=1,lroots
  read(LUTOTE,*) ENER(chemroot,ITER)
  write(u6,*) 'DICE> Deterministic PT2 Energy: ',ENER(chemroot,ITER)
end do
close(LUTOTE)

if (dice_stoc) then
  call molcas_open(LUTOTE,'PT2.energy')

  do chemroot=1,lroots
    read(LUTOTE,*) pt2ener
    write(u6,*) 'DICE> Stochastic PT2 Energy: ',pt2ener
  end do
  close(LUTOTE)
end if

return

end subroutine DiceCtl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakeT2m(T2m,Tau,aGrp,bGrp,aSGrp,bSGrp,keyT)
! this routine does:
! Make T2p(i>,(a>b)")  = Tau(i,j,(a>=b)")-Tau(j,i,a>=b)")
!               from     Tau((a>=b)',i,j)
! or Transposed (T(ab",ij)
!
! parameter description:
! T2m   - T2- array (O)
! Tau   - Tau array (I)
! xGrp  - Group of a,b (I)
! xSGrp - SubGroup of a,b (I)
! keyT  - 0 - make T(ij,ab")
!         1 - make T(ab",ij)

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimGrpa, DimSGrpa, no
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: T2m(*)
real(kind=wp), intent(in) :: Tau(*)
integer(kind=iwp), intent(in) :: aGrp, bGrp, aSGrp, bSGrp, keyT
integer(kind=iwp) :: dimabp, dimabpp, dimap, dimapp, dimbp, dimbpp, dimi, dimij

dimi = no
dimij = nTri_Elem(no-1)

dimap = DimGrpa(aGrp)
dimbp = DimGrpa(bGrp)
if (aGrp == bGrp) then
  dimabp = nTri_Elem(dimap)
else
  dimabp = dimap*dimbp
end if

dimapp = DimSGrpa(aSGrp)
dimbpp = DimSGrpa(bSGrp)
if (aSGrp == bSGrp) then
  dimabpp = nTri_Elem(dimapp-1)
else
  dimabpp = dimapp*dimbpp
end if

if (keyT == 0) then
  ! T-(ij,ab") case

  if (aGrp == bGrp) then
    if (aSGrp == bSGrp) then
      call makeT2pHlp1(T2m,Tau,aGrp,bGrp,aSGrp,bSGrp,1,dimi,dimij,dimapp,dimabpp,dimabp)
    else
      call makeT2pHlp2(T2m,Tau,aGrp,bGrp,aSGrp,bSGrp,1,dimi,dimij,dimapp,dimbpp,dimabp)
    end if
  else
    call makeT2pHlp3(T2m,Tau,aGrp,bGrp,aSGrp,bSGrp,1,dimi,dimij,dimapp,dimbpp,dimap,dimbp)
  end if

else
  ! T-(ab",ij) case

  if (aGrp == bGrp) then
    if (aSGrp == bSGrp) then
      call makeT2ptHlp1(T2m,Tau,aGrp,bGrp,aSGrp,bSGrp,1,dimi,dimij,dimapp,dimabpp,dimabp)
    else
      call makeT2ptHlp2(T2m,Tau,aGrp,bGrp,aSGrp,bSGrp,1,dimi,dimij,dimapp,dimbpp,dimabp)
    end if
  else
    call makeT2ptHlp3(T2m,Tau,aGrp,bGrp,aSGrp,bSGrp,1,dimi,dimij,dimapp,dimbpp,dimap,dimbp)
  end if

end if

return

end subroutine MakeT2m

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine EPotPoint(iPotte,nPick,ipPick,ipDPick,nEPP
     &                    ,ipT,ipTi,NucNr
     &                    ,nB,iAtom,jAtom,ip_Center)
      Implicit Real*8 (a-h,o-z)

#include "stdalloc.fh"
#include "WrkSpc.fh"
#include "warnings.fh"
      Real*8, Allocatable:: D1ao(:)
      Character*10 Label
      Logical Found

*
*-- Loop through all points, pick out the relevant ones, obtain the
*   partial expectation value from the appropriate basis and return.
*
      nB2=nB*(nB+1)/2
      nB22=nB**2
      Call GetMem('DSq','Allo','Real',iDSq,nB22)
      Call Qpg_darray('D1ao',Found,nDens)
      If (Found .and. nDens/=0) Then
         Call mma_allocate(D1ao,nDens,Label='D1ao')
      Else
         Write (6,*) 'EPotPoint: D1ao not found.'
         Call abend()
      End If
      Call Get_D1ao(D1ao,nDens)
      Call Dsq(D1ao,Work(iDSq),1,nB,nB)
      Call mma_deallocate(D1ao)
      Call GetMem('TEMP','Allo','Real',iTEMP,nB22)
      Call GetMem('DTrans','Allo','Real',iDTrans,nB22)
*
*-- Contravariant transformation of density matrix.
*
      Call DGEMM_('N','N',nB,nB,nB,1.0d0,Work(ipTi),nB,Work(iDSq),nB
     &          ,0.0d0,Work(iTEMP),nB)
      Call DGEMM_('N','T',nB,nB,nB,1.0d0,Work(iTEMP),nB,Work(ipTi),nB
     &          ,0.0d0,Work(iDTrans),nB)
      Call GetMem('Points','Allo','Real',iPP,nB2+4)
      Call GetMem('PointsSq','Allo','Real',iPSq,nB22)
      Call GetMem('PointsTr','Allo','Real',iPTr,nB22)
      Do iPoint=1,nPick
        iPo=iWork(ipPick+iPoint-1)
        Write(Label,'(A3,I5)')'EF0',iPo
        irc=-1
        iOpt=0
        iSmLbl=0
        iComp=1
        Call RdOne(irc,iOpt,Label,iComp,Work(iPP),iSmLbl)
        Call Square(Work(iPP),Work(iPSq),1,nB,nB)
*
*-- Covariant transformation of the matrix for the potential in this
*   particular point.
*
        Call DGEMM_('T','N',nB,nB,nB,1.0d0,Work(ipT),nB,Work(iPSq),nB
     &            ,0.0d0,Work(iTEMP),nB)
        Call DGEMM_('N','N',nB,nB,nB,1.0d0,Work(iTEMP),nB,Work(ipT),nB
     &            ,0.0d0,Work(iPTr),nB)
        dEx=0.0d0
        kaunter=0
*
*-- The usual stuff to get the localized value.
*
        Do iB1=1,nB
          Do iB2=1,nB
            iC1=iWork(ip_Center+iB1-1)
            iC2=iWork(ip_Center+iB2-1)
            If((iC1.eq.iAtom.and.iC2.eq.jAtom).or.
     &         (iC1.eq.jAtom.and.iC2.eq.iAtom)) then
              dEx=dEx+Work(iDTrans+kaunter)*Work(iPTr+kaunter)
            Endif
            kaunter=kaunter+1
          Enddo
        Enddo
*
*-- Accumulate in the return vector.
*
        If(iAtom.eq.jAtom) then
          Work(iPotte+iPoint-1)=-1.0d0*dEx
     &                         +dble(NucNr)/Work(ipDPick+iPoint-1)
        Else
          Work(iPotte+iPoint-1)=-1.0d0*dEx
        Endif
      Enddo

*
*-- Deallocate.
*
      Call GetMem('DSq','Free','Real',iDSq,nB22)
      Call GetMem('TEMP','Free','Real',iTEMP,nB22)
      Call GetMem('DTrans','Free','Real',iDTrans,nB22)
      Call GetMem('Points','Free','Real',iPP,nB2+4)
      Call GetMem('PointsSq','Free','Real',iPSq,nB22)
      Call GetMem('PointsTr','Free','Real',iPTr,nB22)

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nEPP)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ADADS1_GAS(     NK,     I1,   XI1S,    LI1,   IORB,
     &                        NIORB,   JORB,  NJORB,   KSTR,   NKEL,
     &                        NKSTR,   IREO,     IZ,  NOCOB,   KMAX,
     &                         KMIN,   IEND, SCLFAC)
*
* Obtain I1(KSTR) = +/- A+ IORB A+ JORB !KSTR>
* Only orbital pairs IOB .gt. JOB are included
*
* KSTR is restricted to strings with relative numbers in the
* range KMAX to KMIN
* =====
* Input
* =====
* IORB : First I orbital to be added
* NIORB : Number of orbitals to be added : IORB to IORB-1+NIORB
*        are used. They must all be in the same TS group
* JORB : First J orbital to be added
* LORB : Number of orbitals to be added : JORB to JORB-1+NJORB
*        are used. They must all be in the same TS group
* KMAX : Largest allowed relative number for K strings
* KMIN : Smallest allowed relative number for K strings
*
* ======
* Output
* ======
*
* NK      : Number of K strings
* I1(KSTR,JORB) : ne. 0 =>  a+IORB a+JORB !KSTR> = +/-!ISTR>
* XI1S(KSTR,JORB) : above +/-
*          : eq. 0    a + JORB !KSTR> = 0
* Offset is KMIN
*
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
      INTEGER KSTR(NKEL,NKSTR)
      INTEGER IREO(*), IZ(NOCOB,*)
*.Output
      INTEGER I1(LI1,*)
      DIMENSION XI1S(LI1,*)
*
      NTEST = 000
      IF(NTEST.NE.0) THEN
       WRITE(6,*) ' ==================== '
       WRITE(6,*) ' ADADS1_GAS speaking '
       WRITE(6,*) ' ==================== '
       WRITE(6,*) ' IORB,NIORB ', IORB,NIORB
       WRITE(6,*) ' JORB,NJORB ', JORB,NJORB
      END IF
*
      IORBMIN = IORB
      IORBMAX = IORB + NIORB - 1
*
      JORBMIN = JORB
      JORBMAX = JORB + NJORB - 1
*
      NIJ = NIORB*NJORB
*
      KEND = MIN(NKSTR,KMAX)
      IF(KEND.LT.NKSTR) THEN
        IEND = 0
      ELSE
        IEND = 1
      END IF
      NK = KEND-KMIN+1
*
      DO KKSTR = KMIN,KEND
       IF(NTEST.GE.1000) THEN
         WRITE(6,*) ' Occupation of string ', KKSTR
         CALL IWRTMA(KSTR(1,KKSTR),1,NKEL,1,NKEL)
       END IF
*. Loop over electrons after which JORB can be added
*PAM2009 Added variable ODDJEL to replace ''DBLE((-1)**JEL)''
       ODDJEL=-1.0D0
       DO JEL = 0, NKEL
         ODDJEL=-ODDJEL
*
         IF(JEL.EQ.0 ) THEN
           JORB1 = JORBMIN - 1
         ELSE
           JORB1 = MAX(JORBMIN-1,KSTR(JEL,KKSTR))
         END IF
         IF(JEL.EQ.NKEL) THEN
           JORB2 = JORBMAX + 1
         ELSE
           JORB2 = MIN(JORBMAX+1,KSTR(JEL+1,KKSTR))
         END IF
         IF(NTEST.GE.1000)
     &    WRITE(6,*) ' JEL JORB1 JORB2 ',JEL,JORB1,JORB2
*
         IF(JEL.GT.0.AND.JORB1.GE.JORBMIN.AND.
     &                   JORB1.LE.JORBMAX) THEN
*. vanishing for any IORB
           IJOFF = (JORB1-JORBMIN)*NIORB
           DO IIORB = 1, NIORB
             IJ = IJOFF + IIORB
             if(ij.gt.nij) then
               write(6,*) ' ij .gt. nij '
               write(6,*) ' JORB1 IIORB' , JORB1,IIORB
               write(6,*) ' ijoff ', ijoff
*               stop
        CALL SYSABENDMSG('lucia_util/adads1_gas','Internal error',' ')
             end if
             I1(KKSTR-KMIN+1,IJ) = 0
             XI1S(KKSTR-KMIN+1,IJ) = 0.0D0
           END DO
         END IF
*
         IF(JORB1.LT.JORBMAX.AND.JORB2.GT.JORBMIN) THEN
*. Orbitals JORB1+1 - JORB2-1 can be added after electron JEL
*PAM2009           SIGNJ = DBLE((-1)**JEL) * SCLFAC
           SIGNJ=ODDJEL*SCLFAC
*. reverse lexical number of the first JEL ELECTRONS
           ILEX0 = 1
           DO JJEL = 1, JEL
             ILEX0 = ILEX0 + IZ(KSTR(JJEL,KKSTR),JJEL)
           END DO
           DO JJORB = JORB1+1, JORB2-1
* And electron JEL + 1
             ILEX1 = ILEX0 + IZ(JJORB,JEL+1)
*. Add electron IORB
*PAM2009 Added ODDIEL to replace ''(-1.0)**IEL''
             ODDIEL=-ODDJEL
             DO IEL = JEL, NKEL
               ODDIEL=-ODDIEL
               IF(IEL.EQ.JEL) THEN
                 IORB1 = MAX(JJORB,IORBMIN-1)
               ELSE
                 IORB1 = MAX(IORBMIN-1,KSTR(IEL,KKSTR))
               END IF
               IF(IEL.EQ.NKEL) THEN
                 IORB2 = IORBMAX+1
               ELSE
                 IORB2 = MIN(IORBMAX+1,KSTR(IEL+1,KKSTR))
               END IF
               IF(NTEST.GE.1000)
     &          WRITE(6,*) ' IEL IORB1 IORB2 ',IEL,IORB1,IORB2
               IF(IEL.GT.JEL.AND.IORB1.GE.IORBMIN.AND.
     &                           IORB1.LE.IORBMAX) THEN
                 IJ = (JJORB-JORBMIN)*NIORB+IORB1-IORBMIN+1
             if(ij.gt.nij) then
               write(6,*) ' ij .gt. nij '
               write(6,*) ' JJORB IORB1' , JJORB,IORB1
               write(6,*) ' ijoff ', ijoff
*               stop
               CALL SYSABENDMSG('lucia_util/adads1_gas',
     &                          'Internal error',' ')
             end if
                 I1(KKSTR-KMIN+1,IJ) = 0
                 XI1S(KKSTR-KMIN+1,IJ) = 0.0D0
               END IF
               IF(IORB1.LT.IORBMAX.AND.IORB2.GT.IORBMIN) THEN
*. Orbitals IORB1+1 - IORB2 -1 can be added after ELECTRON IEL in KSTR
*. Reverse lexical number of the first IEL+1 electrons
                 ILEX2 = ILEX1
                 DO IIEL = JEL+1,IEL
                   ILEX2 = ILEX2 + IZ(KSTR(IIEL,KKSTR),IIEL+1)
                 END DO
*. add terms for the last electrons
                 DO IIEL = IEL+1,NKEL
                   ILEX2 = ILEX2 + IZ(KSTR(IIEL,KKSTR),IIEL+2)
                 END DO
                 IJOFF = (JJORB-JORBMIN)*NIORB
*PAM2009                 SIGNIJ =  SIGNJ*(-1.0D0) ** (IEL+1)
                 SIGNIJ =  SIGNJ*(-ODDIEL)
                 DO IIORB = IORB1+1, IORB2-1
                   IJ = IJOFF + IIORB - IORBMIN + 1
                   IF(IJ.LE.0.OR.IJ.GT.NIJ) THEN
                     WRITE(6,*) ' PROBLEMO ADADS1 : IJ : ', IJ
                     WRITE(6,*) ' IJOFF IORBMIN ', IJOFF,IORBMIN
                     WRITE(6,*) ' IIORB JJORB ', IIORB,JJORB
*                     stop
                     CALL SYSABENDMSG('lucia_util/adads1_gas',
     &                          'Internal error',' ')
                     NTEST = 1000
                   END IF
                   ILEX = ILEX2 + IZ(IIORB,IEL+2)
                   IACT = IREO(ILEX)
                   IF(NTEST.GE.1000)
     &             WRITE(6,*) ' IIORB JJORB ', IIORB,JJORB
                   IF(NTEST.GE.1000)
     &             WRITE(6,*) ' IJ ILEX,IACT',IJ, ILEX,IACT
                   IF(NTEST.GE.1000)
     &             WRITE(6,*) ' ILEX0 ILEX1 ILEX2 ILEX ',
     &                          ILEX0,ILEX1,ILEX2,ILEX
                   I1(KKSTR-KMIN+1,IJ) = IACT
                   XI1S(KKSTR-KMIN+1,IJ) = SIGNIJ
                   IF(IJ.LT.0) THEN
                     WRITE(6,*) ' NEGATIVE IJ in ADADS1 '
*                     STOP ' NEGATIVE IJ in ADADS1 '
                     CALL SYSABENDMSG('lucia_util/adads1_gas',
     &                          'Internal error',' ')
                   END IF
                 END DO
               END IF
             END DO
           END DO
         END IF
       END DO
      END DO
*
      IF(NTEST.GT.0) THEN
        WRITE(6,*) ' Output from ADADST1_GAS '
        WRITE(6,*) ' ===================== '
        WRITE(6,*) ' Number of K strings accessed ', NK
        IF(NK.NE.0) THEN
          IJ = 0
          DO  JJORB = JORB,JORB+NJORB-1
            DO  IIORB = IORB, IORB + NIORB - 1
              IJ = IJ + 1
C?            WRITE(6,*) ' IJ = ', IJ
C?            IF(IIORB.GT.JJORB) THEN
                WRITE(6,*)
     &          ' Info for orbitals (iorb,jorb) ', IIORB,JJORB
                WRITE(6,*) ' Excited strings and sign '
                CALL IWRTMA(I1(1,IJ),1,NK,1,NK)
                CALL WRTMAT(XI1S(1,IJ),1,NK,1,NK)
C?            END IF
            END DO
          END DO
        END IF
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CheckPSD_Full(Diagonalization,Mode,
     &                             UseExactIntegrals,tau,irc)
C
C     Thomas Bondo Pedersen, January 2012.
C
C     Purpose: Check if full integral matrix is positive semidefinite.
C
C              Diagonalization: .True.: eigenvalues, .False.: CD
C              Mode=0: conventional integrals
C                  =1: robust LDF integrals
C                  =2: nonrobust LDF integrals
C                  =3: half-and-half LDF integrals
C              UseExactIntegrals=0: do not use exact integrals (Mode>0)
C                  =1: use exact integrals in diagonal blocks
C                  =2: use exact integrals in off-diagonal blocks
C              tau: LDF prescreening threshold (not used when Mode=0)
C              irc: return code (0 if PSD)
C
C     WARNING: requires a LOT of CPU and memory....
C
      Implicit None
      Logical Diagonalization
      Integer Mode
      Integer UseExactIntegrals
      real*8  tau
      Integer irc
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Character*17 SecNam
      Parameter (SecNam='LDF_CheckPSD_Full')

      Real*8 Thr, Tol
      Parameter (Thr=1.0d-10, Tol=1.0d-12)

      Logical  LDF_IntegralPrescreeningInfoIsSet, isSymmetric
      External LDF_IntegralPrescreeningInfoIsSet, isSymmetric
      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Logical IPI_set_here, doDiagonalization

      Integer AB, CD
      Integer A, B
      Integer nAB, nCD
      Integer ip_Int, l_Int
      Integer ip_I, l_I
      Integer ip_Indx, l_Indx
      Integer iShell
      Integer m, N

      Real*8 x, Stat(11)

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      doDiagonalization=Diagonalization
      Call Cho_Head('Enter '//SecNam,'=',80,6)
      Write(6,'(A,I3)') 'Integral mode:',Mode
      If (doDiagonalization) Then
          Write(6,'(A)') 'Using diagonalization'
      Else
          Write(6,'(A)') 'Using Cholesky decomposition'
      End If
      Call xFlush(6)

      ! Prescreening info
      If (Mode.gt.0 .and. Mode.le.3) Then
         If (.not.LDF_IntegralPrescreeningInfoIsSet()) Then
            Call LDF_SetIntegralPrescreeningInfo()
            IPI_set_here=.True.
         Else
            IPI_set_here=.False.
         End If
      Else If (Mode.eq.0) Then
         IPI_set_here=.False.
      Else
         Call WarningMessage(2,SecNam//': illegal Mode')
         Call LDF_Quit(1)
         IPI_set_here=.False.
      End If

      ! Allocations
      N=nBas_Valence*(nBas_Valence+1)/2
      x=dble(N)**2
      l_Int=int(x)
      If (l_Int.lt.0) Then
         Call WarningMessage(2,SecNam//': integer overflow (?)')
         Call LDF_Quit(1)
      End If
      Call GetMem('PSDInt','Allo','Real',ip_Int,l_Int)

      l_I=0
      Do AB=1,NumberOfAtomPairs
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         l_I=max(l_I,LDF_nBas_Atom(A)*LDF_nBas_Atom(B))
      End Do
      l_I=2*l_I**2
      Call GetMem('PSD_I','Allo','Real',ip_I,l_I)

      l_Indx=nShell_Valence
      Call GetMem('PSDIndx','Allo','Inte',ip_Indx,l_Indx)
      m=0
      Do iShell=1,nShell_Valence
         iWork(ip_Indx-1+iShell)=m
         m=m+nBasSh(iShell)
      End Do

      ! Compute integrals
      Call FZero(Work(ip_Int),l_Int)
      If (Mode.eq.0) Then ! exact integrals
         Do AB=1,NumberOfAtomPairs
            nAB=LDF_nBas_Atom(AP_Atoms(1,AB))
     &         *LDF_nBas_Atom(AP_Atoms(2,AB))
            Do CD=1,AB-1
               nCD=LDF_nBas_Atom(AP_Atoms(1,CD))
     &            *LDF_nBas_Atom(AP_Atoms(2,CD))
               Call LDF_ComputeValenceIntegrals(AB,CD,l_I,Work(ip_I))
               Call LDF_CheckPSD_Full_D(AB,CD,iWork(ip_Indx),
     &                                  nAB,nCD,Work(ip_I),
     &                                  N,Work(ip_Int))
               Call Trnsps(nAB,nCD,Work(ip_I),Work(ip_I+nAB*nCD))
               Call LDF_CheckPSD_Full_D(CD,AB,iWork(ip_Indx),
     &                                  nCD,nAB,Work(ip_I+nAB*nCD),
     &                                  N,Work(ip_Int))
            End Do
            Call LDF_ComputeValenceIntegrals(AB,AB,l_I,Work(ip_I))
            Call LDF_CheckPSD_Full_D(AB,AB,iWork(ip_Indx),
     &                               nAB,nAB,Work(ip_I),
     &                               N,Work(ip_Int))
         End Do
      Else
         Do AB=1,NumberOfAtomPairs
            nAB=LDF_nBas_Atom(AP_Atoms(1,AB))
     &         *LDF_nBas_Atom(AP_Atoms(2,AB))
            Do CD=1,AB-1
               nCD=LDF_nBas_Atom(AP_Atoms(1,CD))
     &            *LDF_nBas_Atom(AP_Atoms(2,CD))
               If (UseExactIntegrals.eq.2) Then
                  Call LDF_ComputeValenceIntegrals(AB,CD,l_I,Work(ip_I))
               Else
                  Call LDF_ComputeValenceIntegralsFromC(Mode,tau,AB,CD,
     &                                                  l_I,Work(ip_I))
               End If
               Call LDF_CheckPSD_Full_D(AB,CD,iWork(ip_Indx),
     &                                  nAB,nCD,Work(ip_I),
     &                                  N,Work(ip_Int))
               Call Trnsps(nAB,nCD,Work(ip_I),Work(ip_I+nAB*nCD))
               Call LDF_CheckPSD_Full_D(CD,AB,iWork(ip_Indx),
     &                                  nCD,nAB,Work(ip_I+nAB*nCD),
     &                                  N,Work(ip_Int))
            End Do
            If (UseExactIntegrals.eq.1) Then
               Call LDF_ComputeValenceIntegrals(AB,AB,l_I,Work(ip_I))
            Else
               Call LDF_ComputeValenceIntegralsFromC(Mode,tau,AB,AB,
     &                                               l_I,Work(ip_I))
            End If
            Call LDF_CheckPSD_Full_D(AB,AB,iWork(ip_Indx),
     &                               nAB,nAB,Work(ip_I),
     &                               N,Work(ip_Int))
         End Do
      End If

      ! Deallocation
      Call GetMem('PSDIndx','Free','Inte',ip_Indx,l_Indx)
      Call GetMem('PSD_I','Free','Real',ip_I,l_I)

      ! Check symmetry
      If (.not.isSymmetric(Work(ip_Int),N,Tol)) Then
         Call WarningMessage(2,
     &                        SecNam//': integral matrix not symmetric')
         Write(6,'(A,1P,D20.10)') 'Tolerance for symmetry=',Tol
         Call LDF_Quit(1)
      End If

      ! Check PSD
      irc=-1
      If (doDiagonalization) Then ! diagonalization
         Call LDF_CheckPSD_Full_Diag(N,Work(ip_Int),Stat,irc)
         If (irc.lt.0) Then
            Call WarningMessage(2,
     &                           SecNam//': irc<0 from diagonalization')
            Call LDF_Quit(1)
         Else If (irc.gt.0) Then
            Call WarningMessage(0,
     &                         SecNam//': full integral matrix not PSD')
            Write(6,'(I10,A)') irc,' negative eigenvalues:'
            Do i=1,irc
               Write(6,'(A,1X,I10,1X,1P,D20.10)')
     &         'Negative eigenvalue no.',i,Work(ip_Int-1+i)
            End Do
            Call xFlush(6)
         Else
            Call WarningMessage(0,SecNam//': full integral matrix PSD')
         End If
         Write(6,'(A,10X,I10)')
     &   'Number of eigenvalues..................',N
         Write(6,'(A,10X,I10)')
     &   'Number of large negative eigenvalues...',int(Stat(9))
         Write(6,'(A,10X,I10)')
     &   'Number of slightly neg. eigenvalues....',int(Stat(10))
         Write(6,'(A,10X,I10)')
     &   'Number of zero or pos. eigenvalues.....',int(Stat(11))
         Write(6,'(A,1P,D20.10)')
     &   'Minimum eigenvalue.....................',Stat(1)
         Write(6,'(A,1P,D20.10)')
     &   'Maximum................................',Stat(2)
         Write(6,'(A,1P,D20.10)')
     &   'Sum....................................',Stat(3)
         Write(6,'(A,1P,D20.10)')
     &   'Norm...................................',Stat(4)
         Write(6,'(A,1P,D20.10)')
     &   'Average................................',Stat(5)
         Write(6,'(A,1P,D20.10)')
     &   'Standard deviation.....................',Stat(6)
         Write(6,'(A,1P,D20.10)')
     &   'Skewness...............................',Stat(7)
         Write(6,'(A,1P,D20.10)')
     &   'Kurtosis...............................',Stat(8)
         Call xFlush(6)
      Else ! Cholesky decomposition
         Call LDF_CheckPSD_Full_CD(N,Work(ip_Int),Thr,irc)
         If (irc.lt.0) Then
            Call WarningMessage(2,
     &                    SecNam//': irc<0 from Cholesky decomposition')
            Call LDF_Quit(1)
         Else If (irc.eq.1) Then
            Call WarningMessage(0,
     &                         SecNam//': full integral matrix not PSD')
            x=9.9d9
            Do i=1,N
               x=min(x,Work(ip_Int-1+N*(i-1)+i))
            End Do
            Write(6,'(A,1X,1P,D20.10)')
     &      'Smallest diagonal element in CD:',x
            Call xFlush(6)
         Else If (irc.gt.1) Then
            Call WarningMessage(2,
     &                    SecNam//': irc>1 from Cholesky decomposition')
            Call LDF_Quit(1)
         Else
            Call WarningMessage(0,SecNam//': full integral matrix PSD')
         End If
      End If
      If (irc.ne.0) irc=1

      ! Deallocation
      Call GetMem('PSDInt','Free','Real',ip_Int,l_Int)

      ! Unset prescreening info (if set here)
      If (IPI_set_here) Then
         Call LDF_UnsetIntegralPrescreeningInfo()
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CheckPSD_Full_D(AB,CD,iSB,
     &                               nAB,nCD,Block,
     &                               N,Full)
      Implicit None
      Integer AB, CD
      Integer iSB(*)
      Integer nAB, nCD
      Real*8  Block(nAB,nCD)
      Integer N
      Real*8  Full(N,N)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom

      Integer C, D
      Integer nShellC, nShellD
      Integer iS, jS
      Integer ipi, ipj
      Integer iShell, jShell
      Integer iOffi, iOffj
      Integer j_
      Integer ij, ij0
      Integer iOffB

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms, iTri
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      C=AP_Atoms(1,CD)
      D=AP_Atoms(2,CD)
      nShellC=LDF_nShell_Atom(C)
      nShellD=LDF_nShell_Atom(D)
      ipi=LDF_lShell_Atom(C)-1
      ipj=LDF_lShell_Atom(D)-1

      iOffB=0
      Do jS=1,nShellD
         jShell=iWork(ipj+jS)
         iOffj=iSB(jShell)
         Do iS=1,nShellC
            iShell=iWork(ipi+iS)
            iOffi=iSB(iShell)
            Do j=1,nBasSh(jShell)
               j_=iOffj+j
               ij0=iOffB+nBasSh(iShell)*(j-1)
               Do i=1,nBasSh(iShell)
                  ij=iTri(iOffi+i,j_)
                  Call LDF_Block2Full_Packed(AB,Full(1,ij),iSB,
     &                                       Block(1,ij0+i))
               End Do
            End Do
            iOffB=iOffB+nBasSh(iShell)*nBasSh(jShell)
         End Do
      End Do

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CheckPSD_Full_Diag(N,X,Stat,irc)
      Implicit None
      Integer N
      Real*8  X(N,N)
      Real*8  Stat(11)
      Integer irc
#include "WrkSpc.fh"

      Character*22 SecNam
      Parameter (SecNam='LDF_CheckPSD_Full_Diag')

      Integer iDummy
      Parameter (iDummy=-987654)

      Real*8 Dummy
      Real*8 ThrNeg
      Parameter (Dummy=-9.87654d0)
      Parameter (ThrNeg=-1.0d-10)

      Real*8   dLAMCH_
      External dLAMCH_

      Integer nFound
      Integer ip_EigVal, l_EigVal
      Integer ip_EigVec, l_EigVec
      Integer ip, l
      Integer ip_W, l_W, l_WT
      Integer ip_iW, l_iW, l_iWT

      Real*8 AbsTol

      If (N.lt.1) Then
         irc=0
      Else
         AbsTol=dLAMCH_('Safe minimum')
         l_EigVal=N
         Call GetMem('EigVal','Allo','Real',ip_EigVal,l_EigVal)
         l_EigVec=N
         Call GetMem('EigVec','Allo','Real',ip_EigVec,l_EigVec)
         l=2*N
         Call GetMem('iSuppZ','Allo','Inte',ip,l)
         l_WT=1
         Call GetMem('WA','Allo','Real',ip_W,l_WT)
         l_iWT=1
         Call GetMem('iWA','Allo','Inte',ip_iW,l_iWT)
         call dsyevr_('N','A','L',N,X,N,Dummy,Dummy,iDummy,iDummy,
     &                AbsTol,nFound,Work(ip_EigVal),Work(ip_EigVec),1,
     &                iWork(ip),Work(ip_W),-1,iWork(ip_iW),-1,irc)
         If (irc.ne.0) Then
            Call WarningMessage(2,SecNam//': nonzero rc from dSYEVR[0]')
            Call LDF_Quit(1)
         End If
         l_W=int(Work(ip_W))
         l_iW=iWork(ip_iW)
         Call GetMem('iWA','Free','Inte',ip_iW,l_iWT)
         Call GetMem('WA','Free','Real',ip_W,l_WT)
         Call GetMem('WA','Allo','Real',ip_W,l_W)
         Call GetMem('iWA','Allo','Inte',ip_iW,l_iW)
         call dsyevr_('N','A','L',N,X,N,Dummy,Dummy,iDummy,iDummy,
     &                AbsTol,nFound,Work(ip_EigVal),Work(ip_EigVec),1,
     &                iWork(ip),Work(ip_W),l_W,iWork(ip_iW),l_iW,irc)
         If (irc.ne.0) Then
            Call WarningMessage(2,SecNam//': nonzero rc from dSYEVR')
            Call LDF_Quit(1)
         Else
            If (nFound.ne.N) Then
               Call WarningMessage(2,SecNam//': nFound != N')
               Call LDF_Quit(1)
            End If
C-tbp:
      write(6,*) 'ERI eigenvalues:'
      write(6,'(1P,6D20.12)') (work(ip_eigval+irc),irc=0,N-1)
            Call dCopy_(N,Work(ip_EigVal),1,X(1,1),1) ! save eigenvalues
            Call LDF_CheckPSD_Full_Stat(N,X(1,1),ThrNeg,Stat)
            irc=int(Stat(9))
         End If
         Call GetMem('iWA','Free','Inte',ip_iW,l_iW)
         Call GetMem('WA','Free','Real',ip_W,l_W)
         Call GetMem('iSuppZ','Free','Inte',ip,l)
         Call GetMem('EigVec','Free','Real',ip_EigVec,l_EigVec)
         Call GetMem('EigVal','Free','Real',ip_EigVal,l_EigVal)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CheckPSD_Full_CD(N,X,Thr,irc)
      Implicit None
      Integer N
      Real*8  X(N,N)
      Real*8  Thr
      Integer irc
#include "WrkSpc.fh"

      Integer ip, l, nVec

      If (N.lt.1) Then
         irc=0
      Else
         l=N**2
         Call GetMem('PSDCDV','Allo','Real',ip,l)
         Call CD_InCore(X,N,Work(ip),N,nVec,Thr,irc)
         If (irc.eq.101) irc=1
         Call GetMem('PSDCDV','Free','Real',ip,l)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CheckPSD_Full_Stat(N,X,ThrNeg,Stat)
C1 Stat=(min,
C2       max,
C3       sum,
C4       norm,
C5       average,
C6       std dev wrt average,
C7       skewness,
C8       kurtosis
C9       #x for which x < ThrNeg
C10      #x for which ThrNeg <= x < 0
C11      #x for which x >= 0
      Implicit None
      Integer N
      Real*8  X(N)
      Real*8  Stat(*)
      Real*8  ThrNeg

      Integer nStat
      Parameter (nStat=11)

      real*8 ddot_
      external ddot_

      Real*8 Nx, mu, m1, m2, m3, m4, y
      Real*8 Tol

      Integer i, n1, n2

      If (ThrNeg.ge.0.0d0) Then
         Tol=-ThrNeg
      Else
         Tol=ThrNeg
      End If

      If (N.gt.0) Then
         Nx=dble(N)
         ! (1)=min value
         Stat(1)=X(1)
         Do i=2,N
            Stat(1)=min(Stat(1),X(i))
         End Do
         ! (2)=max value
         Stat(2)=X(1)
         Do i=2,N
            Stat(2)=max(Stat(2),X(i))
         End Do
         ! (3)=sum
         Stat(3)=X(1)
         Do i=2,N
            Stat(3)=Stat(3)+X(i)
         End Do
         ! compute average and moments
         mu=Stat(3)/Nx
         m1=0.0d0
         m2=0.0d0
         m3=0.0d0
         m4=0.0d0
         Do i=1,N
            y=X(i)-mu
            m1=m1+y
            m2=m2+y**2
            m3=m3+y**3
            m4=m4+y**4
         End Do
         m1=m1/Nx
         m2=m2/Nx
         m3=m3/Nx
         m4=m4/Nx
         ! (4)=norm
         Stat(4)=sqrt(dDot_(N,X,1,X,1))
         ! (5)=average
         Stat(5)=mu
         ! (6)=std dev (wrt average)
         Stat(6)=sqrt(m2)
         ! (7)=skewness
         If (m2.ne.0.0d0) Then
            Stat(7)=m3/sqrt(m2**3)
         Else
            Stat(7)=0.0d0
         End If
         ! (8)=kurtosis
         If (m2.ne.0.0d0) Then
            Stat(8)=m4/(m2**2)-3.0d0
         Else
            Stat(8)=0.0d0
         End If
         ! (9)=#x for which x < ThrNeg
         ! (10)=#x for which ThrNeg <= x < 0
         ! (11)=#x for which x >= 0
         n1=0
         n2=0
         Do i=1,N
            If (sign(1.0d0,X(i)).lt.0.0d0) Then
               If (X(i).lt.Tol) Then
                  n1=n1+1
               Else
                  n2=n2+1
               End If
            End If
         End Do
         Stat(9)=dble(n1)
         Stat(10)=dble(n2)
         Stat(11)=dble(N-n1-n2)
      Else
         Call dZero(Stat,nStat)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRPAD3(MAT,FACTOR,NDIM)
! MAT(I,J) = MAT(I,J) + FACTOR*MAT(J,I)
!
! With some considerations of effective cache use for large matrices

use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NDIM
real(kind=wp), intent(inout) :: MAT(NDIM,NDIM)
real(kind=wp), intent(in) :: FACTOR
integer(kind=iwp) :: I, IBLK, IEND, IOFF, J, JBLK, JEND, JOFF, LBLK, NBLK
real(kind=wp) :: FAC2
integer(kind=iwp), parameter :: IMET = 2

FAC2 = One-FACTOR**2

if (IMET == 1) then

  ! No blocking

  ! Lower half
  do J=1,NDIM
    MAT(J:NDIM,J) = MAT(J:NDIM,J)+FACTOR*MAT(J,J:NDIM)
  end do
  ! Upper half
  if (abs(FACTOR) /= One) then
    FAC2 = One-FACTOR**2
    do I=1,NDIM
      MAT(1:I-1,I) = FACTOR*MAT(I,1:I-1)+FAC2*MAT(1:I-1,I)
    end do
  else if (FACTOR == One) then
    do I=1,NDIM
      MAT(1:I-1,I) = MAT(I,1:I-1)
    end do
  else if (FACTOR == -One) then
    do I=1,NDIM
      MAT(1:I-1,I) = -MAT(I,1:I-1)
    end do
  end if

else if (IMET == 2) then

  ! Simple blocking of matrix

  LBLK = 40
  NBLK = NDIM/LBLK
  if (NBLK*LBLK < NDIM) NBLK = NBLK+1
  IOFF = 1-LBLK
  !write(u6,*) 'NBLK ',nblk
  do IBLK=1,NBLK
    if (IBLK == -1) write(u6,*) 'IBLK = ',IBLK
    IOFF = IOFF+LBLK
    IEND = min(IOFF+LBLK-1,NDIM)
    JOFF = 1-LBLK
    do JBLK=1,IBLK
      JOFF = JOFF+LBLK
      JEND = min(JOFF+LBLK-1,NDIM)
      ! Lower half
      do I=IOFF,IEND
        if (IBLK == JBLK) JEND = I
        MAT(I,JOFF:JEND) = MAT(I,JOFF:JEND)+FACTOR*MAT(JOFF:JEND,I)
      end do
      ! Upper half
      if (abs(FACTOR) /= One) then
        FAC2 = One-FACTOR**2
        do I=IOFF,IEND
          if (IBLK == JBLK) JEND = I
          MAT(JOFF:JEND,I) = FACTOR*MAT(I,JOFF:JEND)+FAC2*MAT(JOFF:JEND,I)
        end do
      else if (FACTOR == One) then
        do I=IOFF,IEND
          if (IBLK == JBLK) JEND = I-1
          MAT(JOFF:JEND,I) = MAT(I,JOFF:JEND)
        end do
      else if (FACTOR == -One) then
        do I=IOFF,IEND
          if (IBLK == JBLK) JEND = I
          MAT(JOFF:JEND,I) = -MAT(I,JOFF:JEND)
        end do
      end if
      ! End of loop over blocks
    end do
  end do

end if
! End of IMET branching

end subroutine TRPAD3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
Module Sizes_of_Seward
Implicit None
Private
Public:: S, Size_Dmp, Size_Get
#include  "itmax.fh"
Integer i
Type Sizes_of_Stuff
     Sequence
     Integer :: Low_Anchor
     Integer :: m2Max=0
     Integer :: mCentr      =0
     Integer :: mCentr_Aux  =0
     Integer :: mCentr_Frag =0
     Integer :: Mx_mdc      =0
     Integer :: Mx_Shll     =0
     Integer :: n2Tot       =0
     Integer :: jMax        =5
     Integer :: MaxPrm(0:iTabMx)=[(0,i=0,iTabMx)]
     Integer :: MaxBas(0:iTabMx)=[(0,i=0,iTabMx)]
     Integer :: nDim        =0
     Integer :: nShlls      =0
     Integer :: Max_Center  =15
     Integer :: kCentr      =0
     Integer :: nMltpl      =2
     Integer :: iAngMx      =-1
     Integer :: High_Anchor
End Type Sizes_of_Stuff
!
Type (Sizes_of_Stuff), Target :: S
Integer, Pointer :: p_ix(:)
Integer iix(2)
Integer nByte_i
Integer Len, Len2
Integer iiLoc
External iiLoc
Logical Found


Interface
   Subroutine Abend()
   End Subroutine Abend
   Subroutine Put_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Put_iArray
   Subroutine Get_iArray(Label,Data,nData)
   Character*(*) Label
   Integer       nData
   Integer       Data(nData)
   End Subroutine Get_iArray
   Subroutine Qpg_iArray(Label,Found,nData)
   Character*(*) Label
   Logical       Found
   Integer       nData
   End Subroutine Qpg_iArray
End Interface

Contains

Subroutine Size_Init()
Use Iso_C_Binding
  nbyte_i = iiloc(iix(2)) - iiloc(iix(1))
  Len = iiLoc(S%High_Anchor)-iiLoc(S%Low_Anchor)
  Len = (Len+nByte_i)/nByte_i
  Call C_F_Pointer(C_Loc(S%Low_Anchor),p_ix,[Len])
End Subroutine Size_Init

Subroutine Size_Dmp()
  Call Size_Init()
  Call Put_iArray('Sizes',p_ix,Len)
  Nullify(p_ix)
End Subroutine Size_Dmp

Subroutine Size_Get()
  Call Qpg_iArray('Sizes',Found,Len2)
  If (.NOT.Found) Then
     Write (6,*) 'Size_Get: Sizes not found.'
     Call Abend()
  End If
  Call Size_Init()
  If (Len/=Len2) Then
     Write (6,*) 'Size_Get: Len/=Len2.'
     Call Abend()
  End If
  Call Get_iArray('Sizes',p_ix,Len)
  Nullify(p_ix)
End Subroutine Size_Get

End Module Sizes_of_Seward

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Bernd Artur Hess                                 *
!***********************************************************************

subroutine Ass_pX(Alpha,nZeta,rFinal,la,lb,Slaplb,Slamlb,nComp)
!***********************************************************************
!                                                                      *
! Object: to assemble the pV integrals from                            *
!         derivative integrals of the electric potential.              *
!                                                                      *
!     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
!             Chemie, University of Bonn, Germany, August 1994         *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nComp
real(kind=wp), intent(in) :: Alpha(nZeta), Slaplb(nZeta,nTri_Elem1(la+1),nTri_Elem1(lb),nComp), &
                             Slamlb(nZeta,nTri_Elem1(la-1),nTri_Elem1(lb),nComp)
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),3,nComp)
#include "print.fh"
integer(kind=iwp) :: iComp, ipa, ipb, iPrint, iRout, ixa, ixb, ixm, ixp, iya, iyb, iym, iyp, iza, izb, izm, izp
character(len=80) :: Label

iRout = 203
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  write(u6,*)
  write(u6,*) ' In Ass_pX la,lb,nComp=',la,lb,nComp
  write(u6,*)
  call RecPrt('Alpha','(10G15.8)',Alpha,nZeta,1)
  do iComp=1,nComp
    write(u6,*)
    write(u6,*) 'iComp=',iComp
    write(u6,*)
    write(Label,'(A,I2,A)') 'Ass_pX:  Slaplb(iComp=',iComp,')'
    call RecPrt(Label,'(10f15.8)',Slaplb(:,:,:,iComp),nZeta,nTri_Elem1(la+1)*nTri_Elem1(lb))
    if (la > 0) then
      write(Label,'(A,I2,A)') 'Ass_pX: Slamlb(iComp=,',iComp,')'
      call RecPrt(Label,'(10G15.8)',Slamlb(:,:,:,iComp),nZeta,nTri_Elem1(la-1)*nTri_Elem1(lb))
    end if
  end do
end if

do iComp=1,nComp

  do ixa=la,0,-1
    do iya=la-ixa,0,-1
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)

      do ixb=lb,0,-1
        do iyb=lb-ixb,0,-1
          izb = lb-ixb-iyb
          ipb = C_Ind(lb,ixb,izb)
          !                                                            *
          !*************************************************************
          !                                                            *
          if (ixa == 0) then
            ixp = C_Ind(la+1,ixa+1,iza)
            rFinal(:,ipa,ipb,1,iComp) = Two*Alpha*Slaplb(:,ixp,ipb,iComp)
          else
            ixp = C_Ind(la+1,ixa+1,iza)
            ixm = C_Ind(la-1,ixa-1,iza)
            rFinal(:,ipa,ipb,1,iComp) = Two*Alpha*Slaplb(:,ixp,ipb,iComp)-real(ixa,kind=wp)*Slamlb(:,ixm,ipb,iComp)
          end if

          if (iya == 0) then
            iyp = C_Ind(la+1,ixa,iza)
            rFinal(:,ipa,ipb,2,iComp) = Two*Alpha*Slaplb(:,iyp,ipb,iComp)
          else
            iyp = C_Ind(la+1,ixa,iza)
            iym = C_Ind(la-1,ixa,iza)
            rFinal(:,ipa,ipb,2,iComp) = Two*Alpha*Slaplb(:,iyp,ipb,iComp)-real(iya,kind=wp)*Slamlb(:,iym,ipb,iComp)
          end if

          if (iza == 0) then
            izp = C_Ind(la+1,ixa,iza+1)
            rFinal(:,ipa,ipb,3,iComp) = Two*Alpha*Slaplb(:,izp,ipb,iComp)
          else
            izp = C_Ind(la+1,ixa,iza+1)
            izm = C_Ind(la-1,ixa,iza-1)
            rFinal(:,ipa,ipb,3,iComp) = Two*Alpha*Slaplb(:,izp,ipb,iComp)-real(iza,kind=wp)*Slamlb(:,izm,ipb,iComp)
          end if
          !                                                            *
          !*************************************************************
          !                                                            *
        end do
      end do

    end do
  end do

end do

if (iPrint >= 49) then
  write(u6,*) ' In Ass_pX la,lb,nComp=',la,lb,nComp
  do iComp=1,nComp
    write(u6,*)
    write(u6,*) 'iComp=',iComp
    write(u6,*)

    write(Label,'(A,I2,A)') ' Ass_pX: pX( 1,iComp=',iComp,')'
    call RecPrt(Label,'(10G15.8)',rFinal(:,:,:,1,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb))

    write(Label,'(A,I2,A)') ' Ass_pX: pX( 2,iComp=',iComp,')'
    call RecPrt(Label,'(10G15.8)',rFinal(:,:,:,2,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb))

    write(Label,'(A,I2,A)') ' Ass_pX: pX( 3,iComp=',iComp,')'
    call RecPrt(Label,'(10G15.8)',rFinal(:,:,:,3,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb))
  end do
end if

return

end subroutine Ass_pX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Over(NSJ,ICOORD,GeoGrd,NAt,NTs,NEsf,Eps,Sphere,ISphe,NOrd,Tessera,Q,DerRad,DerCentr)

use Constants, only: Zero, One, Two, Four, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NSJ, ICOORD, NAt, NTs, NEsf, ISphe(NTs), NOrd(NEsf)
real(kind=wp), intent(out) :: GeoGrd
real(kind=wp), intent(in) :: Eps, Sphere(4,NEsf), Tessera(4,NTs), Q(2,NTs), DerRad(NEsf,NAt,3), DerCentr(NEsf,NAt,3,3)
integer(kind=iwp) :: I, ITS, L, NESFJ
real(kind=wp) :: DCENTN, DN, Fact, SESE, SESN, SNSN, XNI, YNI, ZNI

! Calcola la sovrapposizione delle densita' superficiali sulla
! porzione di superficie che appartiene alla sfera
! contenente l'atomo NSJ rispetto al quale stiamo derivando.
!
! NESFJ e' la sfera che sta attorno all'atomo NSJ: se NSJ non ha
! nessuna sfera, NESFJ = 0

NESFJ = 0
do I=1,NESF
  if (NSJ == NORD(I)) NESFJ = I
end do

SESE = ZERO
SNSN = ZERO
SESN = ZERO
do ITS=1,NTS
  L = ISPHE(ITS)
  XNI = -(Sphere(1,L)-Tessera(1,ITS))/Sphere(4,L)
  YNI = -(Sphere(2,L)-Tessera(2,ITS))/Sphere(4,L)
  ZNI = -(Sphere(3,L)-Tessera(3,ITS))/Sphere(4,L)

  if (L == NESFJ) then
    DN = ZERO ! dummy initialize
    if (ICOORD == 1) DN = XNI
    if (ICOORD == 2) DN = YNI
    if (ICOORD == 3) DN = ZNI
  else
    DCENTN = XNI*DerCentr(L,NSJ,ICOORD,1)+YNI*DerCentr(L,NSJ,ICOORD,2)+ZNI*DerCentr(L,NSJ,ICOORD,3)
    DN = DERRAD(L,NSJ,ICOORD)+DCENTN
  end if

  SNSN = SNSN+DN*Q(1,ITS)**2/Tessera(4,ITS)
  SESE = SESE+DN*Q(2,ITS)**2/Tessera(4,ITS)
  SESN = SESN+DN*Q(1,ITS)*Q(2,ITS)/Tessera(4,ITS)
end do
Fact = Four*PI*Eps/(Eps-One)
GeoGrd = Fact*(SESE+SNSN+Two*SESN)

return

end subroutine Over

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,1996, Markus P. Fuelscher                         *
*               1993, Per Ake Malmqvist                                *
************************************************************************
      Subroutine SORT1B
************************************************************************
*                                                                      *
*     Purpose: Phase 1 of the bin sorting algorithm                    *
*              The integral generation is completed and the remaining  *
*              2el integrals stored in the bins are dumped to disk.    *
*                                                                      *
*     Called from: Seward_main                                         *
*                                                                      *
*     Calls to : PKI4,PKR8,SetVec,ErrTra,ISORTX,I4Len,R8Len            *
*                                                                      *
*     Calling parameters: none                                         *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDef  : definitions of the record structure                    *
*     TwoDat : definitions of sorting flags and address tables         *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*     Srt1    : common block containing information the number of      *
*               bins and partitioning of symmetry blocks               *
*     Srt2    : common block containing information pertinent to       *
*               the bin sorting algorithm                              *
*     WSpc    : dynamic work space                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.-AA. Malmqvist                             *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     - modified to use a virtual disk                                 *
*       M. P. Fuelscher, University of Lund, Sweden, 1996              *
*                                                                      *
************************************************************************
*
      use srt2
      Implicit Real*8 (A-H,O-Z)
*
#include "Molcas.fh"
#include "TwoDat.fh"
#include "srt0.fh"
#include "srt1.fh"
#include "stdalloc.fh"
#include "print.fh"
*
*----------------------------------------------------------------------*
*     pick up print level                                              *
*----------------------------------------------------------------------*
*
      iRout = 82
      iPrint = nPrint(iRout)
      If ( iPrint.ge.99 ) Write(6,*) ' >>> Enter SORT1B <<<'
*
*----------------------------------------------------------------------*
*     Turn timing ON                                                   *
*----------------------------------------------------------------------*
*
*
*----------------------------------------------------------------------*
*     dump remaining integrals to disk                                 *
*----------------------------------------------------------------------*
*
      iOpt=0 ! Always tight!
      Do iBin=1,nBin
        Do while ( nInt(iBin).gt.0 )
          Call SaveBin(iBin,iOpt)
        End Do
      End Do
*
*----------------------------------------------------------------------*
*     release the work space used to store bins                        *
*----------------------------------------------------------------------*
*
      call mma_deallocate(lwVBin)
      call mma_deallocate(lwIBin)
*
      call mma_deallocate(lIndx)
      call mma_deallocate(lInts)
*
*----------------------------------------------------------------------*
*     Turn timing OFF and exit                                         *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine reaintsta (wrk,wrksize)
c
c     this routine read integral file INTSTA (reorg), which contains
c     following integrals: foka,fokb,
c     <kl||ij>aaaa,<kl||ij>bbbb,<kl||ij>abab
c     <ka||ij>aaaa,<ka||ij>bbbb,<ka||ij>abab,<ka||ij>baab
c     <ab||ij>aaaa,<ab||ij>bbbb,<ab||ij>abab
c
c     two electron integrals are readed to their fix files,
c     foka,fokb are readed to N,P help files
c
c     use and destroy : V1-3, N,P
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "filemgr.fh"
#include "wrk.fh"
c
c     help variables
c
       integer lunsta,rc,f_recl,f_iostat
       logical is_error
c
c*    open INTSTA file
       lunsta=1
       if (iokey.eq.1) then
c      Fortran IO
       call molcas_open_ext2(lunsta,'INTSTA','sequential','unformatted',
     &                     f_iostat,.false.,f_recl,'unknown',is_error)
c       open (unit=lunsta,file='INTSTA',form='unformatted')
c
       else
c      MOLCAS IO
       call daname (lunsta,'INTSTA')
       daddr(lunsta)=0
       end if
c
c1    read foka to N
       call getmediate (wrk,wrksize,
     & lunsta,possn0,mapdn,mapin,rc)
c
c2    read fokb to P
       call getmediate (wrk,wrksize,
     & lunsta,possp0,mapdp,mapip,rc)
c
c
c3    read <kl||ij>aaaa to W01
       call getmediate (wrk,wrksize,
     & lunsta,possw010,mapdw01,mapiw01,rc)
c
c4    read <kl||ij>bbbb to W02
       call getmediate (wrk,wrksize,
     & lunsta,possw020,mapdw02,mapiw02,rc)
c
c5    read <kl||ij>abab to W03
       call getmediate (wrk,wrksize,
     & lunsta,possw030,mapdw03,mapiw03,rc)
c
c
c6    read <ie||mn>aaaa to W11
       call getmediate (wrk,wrksize,
     & lunsta,possw110,mapdw11,mapiw11,rc)
c
c7    read <ie||mn>bbbb to W12
       call getmediate (wrk,wrksize,
     & lunsta,possw120,mapdw12,mapiw12,rc)
c
c8    read <ie||mn>abab to W13
       call getmediate (wrk,wrksize,
     & lunsta,possw130,mapdw13,mapiw13,rc)
c
c9    read <ie||mn>baab to W14
       call getmediate (wrk,wrksize,
     & lunsta,possw140,mapdw14,mapiw14,rc)
c
c
c10   read <ab||ij>aaaa to V1
       call getmediate (wrk,wrksize,
     & lunsta,possv10,mapdv1,mapiv1,rc)
c
c11   read <ab||ij>bbbb to V2
       call getmediate (wrk,wrksize,
     & lunsta,possv20,mapdv2,mapiv2,rc)
c
c12   read <ab||ij>abab to V3
       call getmediate (wrk,wrksize,
     & lunsta,possv30,mapdv3,mapiv3,rc)
c
c*    close INTSTA file
c
       if (iokey.eq.1) then
c      Fortran IO
       close (lunsta)
c
       else
c      MOLCAS IO
       call daclos (lunsta)
       end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine ModFck(Fock,Ovlp,nFO,CMO,nCMO,mynOcc)
!***********************************************************************
!                                                                      *
!     purpose: Modify Fock matrix taking into account frozen orbitals  *
!              F <- [1 - S*D(f)]*F  (symmetrized).                     *
!                                                                      *
!     input:                                                           *
!       Fock    : Fock matrix of length nFO                            *
!       Ovlp    : overlap matrix of length nFO                         *
!                                                                      *
!     output:                                                          *
!       Fock    : modified Fock matrix                                 *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: MaxBas, nBas, nBO, nBT, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nFO, nCMO, mynOcc(*)
real(kind=wp), intent(inout) :: Fock(nFO)
real(kind=wp), intent(in) :: Ovlp(nFO), CMO(nCMO)
integer(kind=iwp) :: ij, iSym
real(kind=wp), allocatable :: Aux1(:), DFro(:), DFSq(:), OvSq(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Allocate memory for density contribution
call mma_allocate(DFro,nBT,Label='DFro')

! Allocate memory for squared density (then for squared Fock matrix)
call mma_allocate(DFSq,MaxBas**2,Label='DFSq')

! Allocate memory for squared overlap and later for 1 - S*D(f)
call mma_allocate(OvSq,MaxBas**2,Label='OvSq')

! Allocate memory for S*D(f)
call mma_allocate(Aux1,MaxBas**2,Label='Aux1')

! Generate contribution to the density mat. from frozen orbitals
call DFroz(DFro,nBT,CMO,nBO,mynOcc)

ij = 1
do iSym=1,nSym

  if (nBas(iSym) > 0) then
    ! Square density and overlap
    call DSq(DFro(ij),DFSq,1,nBas(iSym),nBas(iSym))
    call Square(Ovlp(ij),OvSq,1,nBas(iSym),nBas(iSym))

    ! Compute S*D(f)
    call DGEMM_('N','N',nBas(iSym),nBas(iSym),nBas(iSym), &
                One,OvSq,nBas(iSym), &
                DFSq,nBas(iSym), &
                Zero,Aux1,nBas(iSym))

    ! Put unit matrix to memory ascribed for overlap and compute 1 - S*D(f)
    call unitmat(OvSq,nBas(iSym))
    OvSq(1:nBas(iSym)**2) = OvSq(1:nBas(iSym)**2)-Aux1(1:nBas(iSym)**2)

    ! Square Fock matrix and store in memory ascribed for density
    call Square(Fock(ij),DFSq,1,nBas(iSym),nBas(iSym))

    ! Compute F <- [1 - S*D(f)]*F
    call DGEMM_('N','N',nBas(iSym),nBas(iSym),nBas(iSym), &
                One,OvSq,nBas(iSym), &
                DFSq,nBas(iSym), &
                Zero,Aux1,nBas(iSym))

    ! Symmetrize modified Fock matrix
    call Sym(Aux1,Fock(ij),nBas(iSym))
  end if

  ! Update pointers
  ij = ij+nTri_Elem(nBas(iSym))

end do

! Deallocate memory
call mma_deallocate(Aux1)
call mma_deallocate(OvSq)
call mma_deallocate(DFSq)
call mma_deallocate(DFro)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine ModFck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HRMCHK(NDIMEN,ARRRE,ARRIM,ERRRE,ERRIM)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDIMEN
real(kind=wp), intent(in) :: ARRRE(NDIMEN,NDIMEN), ARRIM(NDIMEN,NDIMEN)
real(kind=wp), intent(out) :: ERRRE, ERRIM
integer(kind=iwp) :: I, J

ERRRE = Zero
ERRIM = Zero
do I=1,NDIMEN
  do J=1,I-1
    ERRRE = max(ERRRE,abs(ARRRE(I,J)-ARRRE(J,I)))
    ERRIM = max(ERRIM,abs(ARRIM(I,J)+ARRIM(J,I)))
  end do
end do

end subroutine HRMCHK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Fluctuating(AInv,nAtoms,Lambda,dQ,nij,nPert,iANr,rMP,nElem,EC,Alpha)

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nij, nPert, iANr(nAtoms), nElem
real(kind=wp), intent(in) :: AInv(nAtoms,nAtoms), EC(3,nij), Alpha
real(kind=wp), intent(out) :: Lambda(nAtoms), dQ(nAtoms)
real(kind=wp), intent(inout) :: rMP(nij,0:nElem-1,0:nPert-1)
integer(kind=iwp) :: iAtom, ii, ij, iPert, jAtom, jj
real(kind=wp) :: A(3), B(3), R_BS_i, R_BS_j, ri, rij02, rij2, rj
real(kind=wp), external :: Bragg_Slater

do iPert=1,6
  do iAtom=1,nAtoms
    ii = iAtom*(iAtom+1)/2
    dQ(iAtom) = rMP(ii,0,0)-rMP(ii,0,iPert)
  end do
  !call RecPrt('dQ',' ',dQ,1,nAtoms)
  call DGEMM_('N','N',nAtoms,1,nAtoms,One,AInv,nAtoms,dQ,nAtoms,Zero,Lambda,nAtoms)
  !call RecPrt('Lambda',' ',Lambda,1,nAtoms)

  do iAtom=1,nAtoms
    R_BS_i = Bragg_Slater(iANr(iAtom))
    ii = iAtom*(iAtom+1)/2
    A(:) = EC(:,ii)

    do jAtom=1,iAtom-1
      R_BS_j = Bragg_Slater(iANr(jAtom))
      jj = jAtom*(jAtom+1)/2
      B(:) = EC(:,jj)
      rij2 = (A(1)-B(1))**2+(A(2)-B(2))**2+(A(3)-B(3))**2
      ri = Lambda(iAtom)
      rj = Lambda(jAtom)
      rij02 = ((R_BS_i+R_BS_j))**2
      ij = iAtom*(iAtom-1)/2+jAtom
      !write(u6,*) ij,ri,rj,rij02
      rMP(ij,0,iPert) = -(ri-rj)*exp(-Alpha*(rij2/rij02))/Two
      !write(u6,*) 'RMP',iAtom,jAtom,rMP(ij,0,iPert)
    end do

  end do

end do
!call RecPrt('rMP',' ',rMP,nij,nElem*nPert)

return

end subroutine Fluctuating

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GET_CKAJJB(     CB,     NJ,    NJA, CKAJJB,    NKA,
     &                          NJB,      J,   ISCA,   SSCA)
*
* Obtain for given orbital index j the gathered matrix
*
* C(Ka,j,Jb) = SSCA(Ka)C(Jb,ISCA(Ka))
*
* For efficient processing of alpha-beta loop
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
       DIMENSION CB(NJB,NJA), SSCA(*),ISCA(*)
*. Output
       DIMENSION CKAJJB(*)
*
*. To get rid of annoying and incorrect compiler warnings
      ICOFF = 0
*
C?    WRITE(6,*) ' From GET_CKAJJB'
C     LBLK = 100
      LBLK = 40
      NBLK = NJB/LBLK
      IF(LBLK*NBLK.LT.NJB) NBLK = NBLK + 1
      DO ICBL = 1, NBLK
        IF(ICBL.EQ.1) THEN
          ICOFF = 1
        ELSE
          ICOFF = ICOFF + LBLK
        END IF
        ICEND = MIN(ICOFF+LBLK-1,NJB)
        ICONST = NKA*NJ
        IADR0 =  (J-1)*NKA+(ICOFF-1-1)*NKA*NJ
        IF(ICEND.GT.ICOFF) THEN
*. Inner loop over JB
          DO KA  = 1, NKA
            IF(ISCA(KA).NE.0) THEN
              S = SSCA(KA)
              IROW = ISCA(KA)
C             IADR = KA + (J-1)*NKA+(ICOFF-1-1)*NKA*NJ
              IADR = IADR0 + KA
              DO JB = ICOFF,ICEND
*. Adress of C(Ka,j,Jb)
                IADR = IADR + ICONST
                CKAJJB(IADR) = S*CB(JB,IROW)
              END DO
            ELSE
              IADR = IADR0 + KA
              DO JB = ICOFF,ICEND
C               IADR = KA + (J-1)*NKA+(JB-1)*NKA*NJ
                IADR = IADR + ICONST
                CKAJJB(IADR) = 0.0D0
              END DO
            END IF
          END DO
        ELSE
*. No inner loop over JB
          DO KA  = 1, NKA
            IF(ISCA(KA).NE.0) THEN
              S = SSCA(KA)
              IROW = ISCA(KA)
C             IADR = KA + (J-1)*NKA+(ICOFF-1-1)*NKA*NJ
              IADR = IADR0 + KA
C             DO JB = ICOFF,ICEND
*. Adress of C(Ka,j,Jb)
                IADR = IADR + ICONST
                CKAJJB(IADR) = S*CB(ICOFF,IROW)
C             END DO
            ELSE
              IADR = IADR0 + KA
C             DO JB = ICOFF,ICEND
C               IADR = KA + (J-1)*NKA+(JB-1)*NKA*NJ
                IADR = IADR + ICONST
                CKAJJB(IADR) = 0.0D0
C             END DO
            END IF
          END DO
        END IF
*       ^ End of test ICEND,ICOFF
      END DO
*
      RETURN
      END
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine exth4(a,b,dimp,dimpq,dimr,p)
! this routine extracts A(pq,r) -> B_p(q,r)
!
! a     - matrix a (Input)
! b     - matrix b (Output)
! dimp  - dimension of p (and also q) (Input)
! dimpq - dimension of pq (Input)
! dimr  - dimension of r (Input)
! p     - value of index p (Input)

use CCT3_global, only: nshf
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimpq, dimr, p
real(kind=wp), intent(in) :: a(dimpq,dimr)
real(kind=wp), intent(out) :: b(dimp,dimr)
integer(kind=iwp) :: pq0, q, qp

if (p == 0) return

! q>p part
if (p > 1) then
  pq0 = nshf(p)
  b(1:p-1,:) = a(pq0+1:pq0+p-1,:)
end if

! q=p part
b(p,:) = Zero

! r<p part
if (p < dimp) then
  do q=p+1,dimp
    qp = nshf(q)+p
    b(q,:) = -a(qp,:)
  end do
end if

return

end subroutine exth4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine axexbsol_cvb(ap,rhsp,itdav,maxdav,nfrdim,
     >  solp,solp_res,eig,eig_res)
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension ap(maxdav,maxdav),rhsp(maxdav)
      dimension solp(maxdav),solp_res(maxdav)

      i1 = mstackr_cvb(itdav)
      i2 = mstackr_cvb(itdav*itdav)
      i3 = mstackr_cvb(itdav)
      i4 = mstackr_cvb(itdav)
      i5 = mstackr_cvb(itdav)
      call axexbsol2_cvb(ap,rhsp,itdav,maxdav,nfrdim,
     >  solp,solp_res,eig,eig_res,
     >  w(i1),w(i2),w(i3),w(i4),w(i5))
      call mfreer_cvb(i1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine DmpOne
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Print the TOC of the one electron integral file                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher                                                  *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
#include "OneDat.fh"
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
      Write (6,*)
      Write (6,*) ' Auxiliary info on the ONEINT file'
      Write (6,*) ' ---------------------------------'
      Write (6,*)
      Write (6,*) 'pLu     =',pLu  ,' AuxOne(pLu)   =',AuxOne(pLu)
      Write (6,*) 'pOpen   =',pOpen,' AuxOne(pOpen) =',AuxOne(pOpen)
      Write (6,*)
      Write (6,*) ' TOC of the ONEINT file'
      Write (6,*) ' ----------------------'
      Write (6,*)
      Write (6,*) ' pFID  =',pFID  ,' TocOne(pFID)  =',TocOne(pFID)
      Write (6,*) ' pVersN=',pVersN,' TocOne(pVersN)=',TocOne(pVersN)
      Write (6,*) ' pTitle=',pTitle,' TocOne(pTitle)=',TocOne(pTitle)
      Write (6,*) ' pOp   =',pOp   ,' TocOne(pOp)   =',TocOne(pOp)
      Write (6,*) ' pSym  =',pSym  ,' TocOne(pSym)  =',TocOne(pSym)
      Write (6,*) ' pSymOp=',pSymOp,' TocOne(pSymOp)=',TocOne(pSymOp)
      Write (6,*) ' pBas  =',pBas  ,' TocOne(pBas)  =',TocOne(pBas)
      Write (6,*) ' pAtom =',pAtom ,' TocOne(pAtom) =',TocOne(pAtom)
      Write (6,*) ' pCoord=',pCoord,' TocOne(pCoord)=',TocOne(pCoord)
      Write (6,*) ' pPot  =',pPot  ,' TocOne(pPot)  =',TocOne(pPot)
      Write (6,*) ' pCoM  =',pCoM  ,' TocOne(pCoM)  =',TocOne(pCoM)
      Write (6,*) ' pCoC  =',pCoC  ,' TocOne(pCoC)  =',TocOne(pCoC)
      Write (6,*) ' pALbl =',pALbl ,' TocOne(pALbl) =',TocOne(pALbl)
      Write (6,*) ' pType =',pType ,' TocOne(pType) =',TocOne(pType)
      Write (6,*) ' pChrge=',pChrge,' TocOne(pChrge)=',TocOne(pChrge)
      Write (6,*) ' pIndex=',pIndex,' TocOne(pIndex)=',TocOne(pIndex)
      Write (6,*) ' pNext =',pNext ,' TocOne(pNext) =',TocOne(pNext)
      Write (6,*) ' pEnd  =',pEnd  ,' TocOne(pEnd)  =',TocOne(pEnd)
      Write (6,*)
*----------------------------------------------------------------------*
*     Terminate                                                         *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SaveRest(wrk,wrksize,LunAux,niter,E1old,E2old)
! this file saves 1) T1o,OE
!                 2) E1old,E2old,niter
! into RstFil file

use chcc_global, only: no, nv, PosT1o
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, LunAux, niter
real(kind=wp), intent(in) :: wrk(wrksize), E1old, E2old
integer(kind=iwp) :: len_

!open(unit=LunAux,File='RstFil',form='unformatted')
call MOLCAS_BinaryOpen_Vanilla(LunAux,'RstFil')
len_ = no*nv
call wri_chcc(LunAux,len_,wrk(PosT1o))
write(LunAux) E1old,E2old,niter
close(LunAux)

return

end subroutine SaveRest

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_DECOM(DIAG,WRK,LWRK,IPASS,NUM)
C
C     Purpose: calculate Cholesky vectors from qualified integral
C              columns (from disk).
C
#include "implicit.fh"
      DIMENSION DIAG(*), WRK(LWRK)
#include "cholesky.fh"
#include "chovecbuf.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*9 SECNAM
      PARAMETER (SECNAM = 'CHO_DECOM')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

      PARAMETER (ZERO = 0.0D0, ONE = 1.0D0)

      LOGICAL LAST

      INTEGER NUMCHO_OLD(8)

      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)
      IQUAB(I,J)=IWORK(ip_IQUAB-1+MAXQUAL*(J-1)+I)

      LENLIN = 0  ! to avoid compiler warnings...
      IF (IPRINT .GE. INF_PROGRESS) THEN
         CALL CHO_HEAD(SECNAM//
     &                 ': Decomposition of Qualified Diagonals','=',
     &                 80,LUPRI)
         WRITE(LUPRI,'(/,A,I5,A,I4,A)')
     &   'Integral pass number',IPASS,' (',NUM,
     &   ' shell pair distributions calculated)'
         WRITE(LUPRI,'(A,8I8)')
     &   '#Cholesky vec.: ',(NUMCHO(ISYM),ISYM=1,NSYM)
         WRITE(LUPRI,'(A,8I8)')
     &   '#vec. in buff.: ',(NVEC_IN_BUF(ISYM),ISYM=1,NSYM)
         WRITE(LUPRI,'(A,8I8)')
     &   '#qualified    : ',(NQUAL(ISYM),ISYM=1,NSYM)
         WRITE(LUPRI,'(A,8I8)')
     &   'Current  dim. : ',(NNBSTR(ISYM,2),ISYM=1,NSYM)
         WRITE(LUPRI,'(A,8I8)')
     &   'Original dim. : ',(NNBSTR(ISYM,1),ISYM=1,NSYM)
         WRITE(LUPRI,'(/,A,/,A,A)')
     &   '           #Vectors             Treated Diagonal',
     &   'Sym.     Sym.     Total     Index     Before      After',
     &   '   Conv. Neg.   New Max'
         LENLIN = 79
         WRITE(LUPRI,'(80A)') ('-',I=1,LENLIN)
         CALL CHO_FLUSH(LUPRI)
         CALL ICOPY(NSYM,NUMCHO,1,NUMCHO_OLD,1)
      ELSE IF (IPRINT .GE. INF_PASS) THEN
         WRITE(LUPRI,'(/,A,I4)')
     &   'Number of shell pair distributions calculated:',NUM
         WRITE(LUPRI,'(A,8I8)')
     &   '#Cholesky vec.: ',(NUMCHO(ISYM),ISYM=1,NSYM)
         WRITE(LUPRI,'(A,8I8)')
     &   '#vec. in buff.: ',(NVEC_IN_BUF(ISYM),ISYM=1,NSYM)
         WRITE(LUPRI,'(A,8I8)')
     &   '#qualified    : ',(NQUAL(ISYM),ISYM=1,NSYM)
         CALL CHO_FLUSH(LUPRI)
         CALL ICOPY(NSYM,NUMCHO,1,NUMCHO_OLD,1)
      END IF

C     Decompose each symmetry block.
C     ------------------------------

      DO ISYM = 1,NSYM

C        Cycle loop if nothing to do in this symmetry.
C        ---------------------------------------------

         IF ((NQUAL(ISYM).LT.1) .OR. (NNBSTR(ISYM,2).LT.1)) GO TO 100

C        Reserve space for qualified integral columns.
C        ---------------------------------------------

         LINT1 = NNBSTR(ISYM,2)*NQUAL(ISYM) ! integrals

         KINT1 = 1
         KEND0 = KINT1 + LINT1
         LWRK0 = LWRK  - KEND0 + 1
         IF (LWRK0 .LE. 0) THEN
            CALL CHO_QUIT('[0] Insufficient memory in '//SECNAM,101)
         END IF

C        Determine size of Cholesky vector (output) buffer.
C        --------------------------------------------------

         NUMBUF = MIN(LWRK0/NNBSTR(ISYM,2),NQUAL(ISYM))
         IF (NUMBUF .LT. 1) THEN
            CALL CHO_QUIT('[1] Insufficient memory in '//SECNAM,101)
         END IF
         KCHO1 = KEND0
         KEND1 = KCHO1 + NNBSTR(ISYM,2)*NUMBUF
         LWRK1 = LWRK  - KEND1 + 1
         IF (LWRK1 .LT. 0) THEN  ! should be redundant...
            CALL CHO_QUIT('Buffer allocation error in '//SECNAM,101)
         END IF

C        Read qualified integral columns.
C        --------------------------------

         CALL CHO_TIMER(C1,W1)
         IOPT = 2
         LTOT = NNBSTR(ISYM,2)*NQUAL(ISYM)
         IADR = 0
         CALL DDAFILE(LUSEL(ISYM),IOPT,WRK(KINT1),LTOT,IADR)
         CALL CHO_TIMER(C2,W2)
         TDECOM(1,1) = TDECOM(1,1) + C2 - C1
         TDECOM(2,1) = TDECOM(2,1) + W2 - W1

C        Subtract contributions from previous vectors.
C        ---------------------------------------------

         CALL CHO_SUBTR(WRK(KINT1),WRK(KEND0),LWRK0,ISYM)

C        Debug: check diagonal elements in updated integrals.
C        ----------------------------------------------------

         IF (CHO_DIACHK .OR. LOCDBG) THEN
            TOL  = TOL_DIACHK
            NERR = 0
            CALL CHO_CHKINT(WRK(KINT1),DIAG,ISYM,NERR,TOL,.TRUE.)
            IF (NERR .NE. 0) THEN
               WRITE(LUPRI,*) SECNAM,': ',NERR,' diagonal errors found!'
               WRITE(LUPRI,*) '          #tests: ',NQUAL(ISYM)
c              WRITE(LUPRI,*) '          Printing integrals:'
c              CALL CHO_OUTPUT(WRK(KINT1),
c    &                         1,NNBSTR(ISYM,2),1,NQUAL(ISYM),
c    &                         NNBSTR(ISYM,2),NQUAL(ISYM),1,LUPRI)
               CALL CHO_QUIT('Diagonal errors in '//SECNAM,104)
            ELSE
               WRITE(LUPRI,*) SECNAM,': comparison of qual. integrals ',
     &                     'and current diagonal: no errors !'
            END IF
         END IF

C        Decompose in loop over qualified columns.
C        -----------------------------------------

         IVEC  = NUMCHO(ISYM)
         IVECT = NUMCHT
         IDUMP = 0
         DO ICHO = 1,NQUAL(ISYM)

C           Find max. diagonal among qualified.
C           -----------------------------------

            IAB  = 1
            IABG = INDRED(IQUAB(IAB,ISYM),2)
            XC   = DIAG(IABG)
            DO I = 2,NQUAL(ISYM)
               KAB = INDRED(IQUAB(I,ISYM),2)
               IF (DIAG(KAB) .GT. XC) THEN
                  IAB  = I
                  IABG = KAB
                  XC   = DIAG(KAB)
               END IF
            END DO

C           Decompose if max. diagonal is still qualified.
C           ----------------------------------------------

            LAST = (XC.LT.DIAMIN(ISYM)) .OR. (XC.LT.THRCOM)
            IF (.NOT. LAST) THEN

C              Offset to max. diagonal column.
C              -------------------------------

               KOFF0 = KINT1 + NNBSTR(ISYM,2)*(IAB - 1) - 1

C              Scale column corresponding to max. diagonal to obtain
C              the Cholesky vector.
C              -----------------------------------------------------

               FAC  = ONE/SQRT(XC)
               KOFF = KOFF0 + 1
               CALL DSCAL_(NNBSTR(ISYM,2),FAC,WRK(KOFF),1)

C              Zero entries in Cholesky vector corresponding to zero
C              diagonals.
C              -----------------------------------------------------

               DO I = 1,NNBSTR(ISYM,2)
                  II = IIBSTR(ISYM,2) + I
                  JJ = INDRED(II,2)
                  IF (DIAG(JJ) .EQ. ZERO) THEN
                     KOFF = KOFF0 + I
                     WRK(KOFF) = ZERO
                  END IF
               END DO

C              Update diagonal.
C              ----------------

               DO I = 1,NNBSTR(ISYM,2)
                  II   = IIBSTR(ISYM,2) + I
                  JJ   = INDRED(II,2)
                  KOFF = KOFF0 + I
                  DIAG(JJ) = DIAG(JJ) - WRK(KOFF)*WRK(KOFF)
               END DO

C              Zero treated diagonal element and analyze updated diagonal.
C              -----------------------------------------------------------

               OLDIAG     = DIAG(IABG)
               DIAG(IABG) = ZERO
               CALL CHO_CHKDIA(DIAG,ISYM,XMIN,XMAX,XM,NNEGT,NNEG,NCONV)

C              Update total number of zeroed negative diagonals.
C              -------------------------------------------------

               NNZTOT = NNZTOT + NNEG

C              Update DIAMIN from max. abs. diagonal element XM.
C              CHO_1CENTER: update from max. diagonal element among
C                           qualified.
C              CHO_SIMP   : "simulate parallel algorithm" = do not
C                           update DIAMIN.
C              ----------------------------------------------------

               IF (.NOT. CHO_SIMP) THEN
                  IF (CHO_1CENTER) THEN
                     YM = DIAG(INDRED(IQUAB(1,ISYM),2))
                     DO I = 2,NQUAL(ISYM)
                        YM = MAX(YM,DIAG(INDRED(IQUAB(I,ISYM),2)))
                     END DO
                  ELSE
                     YM = XM
                  END IF
                  DIAMIN(ISYM) = MAX(YM*SPAN,THRCOM)
               END IF

C              Subtract this Cholesky vector from integrals. If
C              the corresponding diagonal element is zero, the
C              column will no longer be qualified and subtraction
C              can safely be skipped.
C              --------------------------------------------------

               KOFF1 = KOFF0 + 1
               DO I = 1,NQUAL(ISYM)
                  II = IQUAB(I,ISYM)
                  JJ = INDRED(II,2)
                  IF (DIAG(JJ) .NE. ZERO) THEN
                     KOFF2 = KINT1 + NNBSTR(ISYM,2)*(I - 1)
                     KOFF3 = KOFF0 + II - IIBSTR(ISYM,2)
                     FAC   = -WRK(KOFF3)
                     CALL DAXPY_(NNBSTR(ISYM,2),FAC,WRK(KOFF1),1,
     &                                             WRK(KOFF2),1)
                  END IF
               END DO

C              Store Cholesky vector in buffer.
C              --------------------------------

               IDUMP = IDUMP + 1

               KOFF1 = KOFF0 + 1
               KOFF2 = KCHO1 + NNBSTR(ISYM,2)*(IDUMP - 1)
               CALL DCOPY_(NNBSTR(ISYM,2),WRK(KOFF1),1,WRK(KOFF2),1)

C              Update Cholesky vector counters.
C              --------------------------------

               IVEC  = IVEC  + 1
               IVECT = IVECT + 1

C              Set info for this vector.
C              -------------------------

               CALL CHO_SETVECINF(IWORK(ip_INFVEC),
     &                            MAXVEC,INFVEC_N2,NSYM,
     &                            IVEC,ISYM,IABG,IPASS,2)

C              Print progress report.
C              ----------------------

               IF (IPRINT .GE. INF_PROGRESS) THEN
              WRITE(LUPRI,'(I3,3(1X,I9),2(1X,D11.3),2(1X,I4),1X,D11.3)')
     &            ISYM,IVEC,IVECT,IABG,XC,OLDIAG,NCONV,NNEG,XM
               END IF

            END IF

C           Dump vectors to disk when there is no more to be done, or
C           when the buffer is full.
C           ---------------------------------------------------------

            IF (LAST .OR. (IDUMP.EQ.NUMBUF)) THEN
               CALL CHO_TIMER(C1,W1)
               IVEC1 = NUMCHO(ISYM) + 1
               CALL CHO_PUTVEC(WRK(KCHO1),NNBSTR(ISYM,2),IDUMP,IVEC1,
     &                         ISYM)
               CALL CHO_VECBUF_COPY(WRK(KCHO1),IDUMP,ISYM)
               NUMCHO(ISYM) = NUMCHO(ISYM) + IDUMP
               NUMCHT       = NUMCHT       + IDUMP
               CALL CHO_TIMER(C2,W2)
               TDECOM(1,2) = TDECOM(1,2) + C2 - C1
               TDECOM(2,2) = TDECOM(2,2) + W2 - W1
               IF (LAST) THEN
                  GO TO 100   ! cycle symmetry loop
               ELSE
                  IVEC  = NUMCHO(ISYM)
                  IVECT = NUMCHT
                  IDUMP = 0
               END IF
            END IF

         END DO

C        Cycle point: go to next symmetry.
C        ---------------------------------

  100    CONTINUE
         IF (IPRINT .GE. INF_PROGRESS) CALL CHO_FLUSH(LUPRI)

      END DO

      IF (IPRINT .GE. INF_PROGRESS) THEN
         DO ISYM = 1,NSYM
            NUMCHO_OLD(ISYM) = NUMCHO(ISYM) - NUMCHO_OLD(ISYM)
         END DO
         WRITE(LUPRI,'(80A)') ('-',I=1,LENLIN)
         WRITE(LUPRI,'(A,8I8)')
     &   '#vec. gener.  : ',(NUMCHO_OLD(ISYM),ISYM=1,NSYM)
      ELSE IF (IPRINT .GE. INF_PASS) THEN
         DO ISYM = 1,NSYM
            NUMCHO_OLD(ISYM) = NUMCHO(ISYM) - NUMCHO_OLD(ISYM)
         END DO
         WRITE(LUPRI,'(A,8I8)')
     &   '#vec. gener.  : ',(NUMCHO_OLD(ISYM),ISYM=1,NSYM)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Markus P. Fuelscher                              *
!               1990, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine REORD(SGS,CIS,EXS,NCONF,IMODE,ICONF,ISPIN,kSym,CIOLD)
! AUTHOR:  M.P. FUELSCHER AND J. OLSEN
!          UNIV. OF LUND, SWEDEN 1990
!
! PURPOSE: CONSTRUCT THE REINDEXING ARRAY WHICH REORDERS
!          THE CSFS GENERATED BY THE DETERMINANT CODE INTO
!          THE SPLIT GRAPH GUGA ORDER.
!          FOR THAT CONSTRUCT FOR EACH CSF THE CORRESPONDING
!          STEP VECTOR AND PASS IT TO THE FUNCTIONS IPHASE
!          AND ISGNUM WHICH COMPUTES THE PHASE FACTOR
!          INVOLVED WHEN GOING FROM THE SYMMETRIC TO THE
!          UNITARY GROUP AND THE SPLIT ORDERING NUMBER.
!          FINALLY, THE VECTORS OF CI COEFFICIENTS ARE
!          REORDERED AND, TWO MODE ARE POSSIBLE:
!          IMODE=0 : FROM SYMMETRIC GROUP TO SPLIT GRAPH UGA ORDER
!          IMODE=1 : FROM SPLIT GRAPH UGA TO SYMMETRIC GROUP ORDER

use MCLR_data, only: minop, NCNATS, NCPCNT, NTYP
use gugx, only: CIStruct, EXStruct, SGStruct
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(in) :: CIS
type(EXStruct), intent(in) :: EXS
integer(kind=iwp), intent(in) :: nCONF, IMODE, ICONF(*), ISPIN(*), kSym
real(kind=wp), intent(inout) :: CIOLD(NCONF)
integer(kind=iwp) :: IC, ICL, ICNBS, ICNBS0, ICSBAS, ICSFJP, IICSF, IOPEN, IP, IPBAS, ISG, ITYP, IWALK(50)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I
#endif
real(kind=wp) :: PHASE
real(kind=wp), allocatable :: CINEW(:)
integer(kind=iwp), external :: IPHASE, ISGNUM

call mma_allocate(CINEW,NCONF,Label='CINEW')

! LOOP OVER CONFIGURATIONS TYPES

ICSFJP = 0
ICNBS0 = 0 ! dummy initialize
IPBAS = 0 ! dummy initialize
do ITYP=1,NTYP
  IOPEN = ITYP+MINOP-1 ! MINOP IS NOT INITIALIZED TEOEAW
  ICL = (SGS%nActEl-IOPEN)/2
  ! BASE ADDRESS FOR CONFIGURATION OF THIS TYPE
  if (ITYP == 1) then
    ICNBS0 = 1
  else
    ICNBS0 = ICNBS0+NCNATS(ITYP-1,kSym)*(SGS%nActEl+IOPEN-1)/2
  end if
  ! BASE ADDRESS FOR PROTOTYPE SPIN COUPLINGS
  if (ITYP == 1) then
    IPBAS = 1
  else
    IPBAS = IPBAS+NCPCNT(ITYP-1)*(IOPEN-1)
  end if

  ! LOOP OVER NUMBER OF CONFIGURATIONS OF TYPE ITYP AND PROTOTYPE
  ! SPIN COUPLINGS

  do IC=1,NCNATS(ITYP,kSym)
    ICNBS = ICNBS0+(IC-1)*(IOPEN+ICL)
    do IICSF=1,NCPCNT(ITYP)
      ICSFJP = ICSFJP+1
      ICSBAS = IPBAS+(IICSF-1)*IOPEN
      ! COMPUTE STEP VECTOR
      call STEPVEC(ICONF(ICNBS),ICONF(ICNBS+ICL),ICL,IOPEN,ISPIN(ICSBAS),SGS%nLev,IWALK)
      ! GET SPLIT GRAPH ORDERING NUMBER
      ! FUNCTION ISGNUM
      ISG = ISGNUM(SGS%nLev,SGS%nVert,SGS%MidLev,SGS%MVSta,CIS%nMidV,SGS%MxUp,SGS%MxDwn,SGS%Down,SGS%Up,SGS%DAW,SGS%RAW,EXS%USGN, &
                   EXS%LSGN,IWALK)
      ! GET PHASE PHASE FACTOR
      IP = IPHASE(SGS%nLev,SGS%nVert,SGS%DRT,SGS%Up,IWALK)
      ! NOW REORDER THIS ELEMENT OF THE CI-VECTOR
      PHASE = real(IP,kind=wp)
      select case (iMode)
        case (0)
          CINEW(ISG) = CIOLD(ICSFJP)*PHASE
        case (1)
          CINEW(ICSFJP) = CIOLD(ISG)*PHASE
      end select
    end do
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' OLD CI-VECTORS IN SUBROUTINE REORD'
write(u6,'(10F12.8)') (CIOLD(I),I=1,NCONF)
write(u6,*) ' NEW CI-VECTORS IN SUBROUTINE REORD'
write(u6,'(10F12.8)') (CINEW(I),I=1,NCONF)
write(u6,*)
#endif

CIOLD(:) = CINEW(:)
call mma_deallocate(CINEW)

end subroutine REORD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ZOOS(ISM,IBLTP,MAXSYM,IOCOC,NSSOA,NSSOB,NOCTPA,NOCTPB,IDC,IOOS,NOOS,NCOMB,IXPND)
! Generate offsets for CI vector for RAS CI expansion of given symmetry
! Combination type is defined by IDC
! Total number of combinations NCOMB is also obtained
!
! Symmetry is defined through ISM
!
! ICBLTP gives typo of symmetry block :
! = 0 : symmetry block is not included
! = 1 : symmetry block is included, all OO types
! = 2 : symmetry block is included, lower OO types
!
! If IXPND /= 0, the diagonal blocks are always choosen expanded
!
! ========
!  Output
! ========
!
! IOOS(IOCA,IOCB,ISYM) : Start of block with alpha strings of
!                        symmetry ISYM and type IOCA, and
!                        betastrings of type IOCB
! NOOS(IOCA,IOCB,ISYM) : Number of combinations
! The ordering used for the CI vector is
!
!    SYMMETRY  FOR ALPHA STRINGS..(GIVES SYMMETRY OF BETA STRING)
!         OCCUPATION TYPE  FOR ALPHA STRING
!            OCCUPATION TYPE FOR    BETA STRING
!                BETA STRING (COLUMN INDEX)
!                ALPHA STRINGS (ROW INDEX)
!    END OF LOOPS

use Symmetry_Info, only: Mul
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ISM, IBLTP(*), MAXSYM, NOCTPA, NOCTPB, IOCOC(NOCTPA,NOCTPB), NSSOA(MAXSYM,NOCTPA), &
                                 NSSOB(MAXSYM,NOCTPB), IDC, IXPND
integer(kind=iwp), intent(out) :: IOOS(NOCTPA,NOCTPB,MAXSYM), NOOS(NOCTPA,NOCTPB,MAXSYM), NCOMB
integer(kind=iwp) :: IAOCC, IASYM, IBOCC, IBSYM, IREST1, MXBOCC

IOOS(:,:,:) = 0
NOOS(:,:,:) = 0
!ICBLTP(1:MAXSYM) = 0
NCOMB = 0
do IASYM=1,MAXSYM

  IBSYM = Mul(IASYM,ISM)
  if (IBSYM == 0) cycle
  ! Allowed combination symmetry block?
  if ((IDC /= 1) .and. (IBLTP(IASYM) == 0)) cycle
  ! Allowed occupation combinations
  do IAOCC=1,NOCTPA
    if (IBLTP(IASYM) == 1) then
      MXBOCC = NOCTPB
      IREST1 = 0
    else
      MXBOCC = IAOCC
      IREST1 = 1
    end if
    do IBOCC=1,MXBOCC
      ! Is this block allowed
      if (IOCOC(IAOCC,IBOCC) == 1) then
        IOOS(IAOCC,IBOCC,IASYM) = NCOMB+1
        if ((IXPND == 0) .and. (IREST1 == 1) .and. (IAOCC == IBOCC)) then
          NCOMB = NCOMB+(NSSOA(IASYM,IAOCC)+1)*NSSOB(IBSYM,IBOCC)/2
          NOOS(IAOCC,IBOCC,IASYM) = (NSSOA(IASYM,IAOCC)+1)*NSSOB(IBSYM,IBOCC)/2
        else
          NCOMB = NCOMB+NSSOA(IASYM,IAOCC)*NSSOB(IBSYM,IBOCC)
          NOOS(IAOCC,IBOCC,IASYM) = NSSOA(IASYM,IAOCC)*NSSOB(IBSYM,IBOCC)
        end if
      end if
      !write(u6,*) ' NOOS(IA,IB,ISM) ',NOOS(IAOCC,IBOCC,IASYM)
    end do
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' =============='
write(u6,*) ' ZOOS reporting'
write(u6,*) ' =============='
write(u6,*)
write(u6,*) ' NSSOA, NSSOB (input)'
call IWRTMA(NSSOA,MAXSYM,NOCTPA,MAXSYM,NOCTPA)
call IWRTMA(NSSOB,MAXSYM,NOCTPB,MAXSYM,NOCTPB)
write(u6,*)
write(u6,*) ' Number of combinations obtained ',NCOMB
write(u6,*) ' Offsets for combination OOS blocks'
do IASYM=1,MAXSYM
  write(u6,'(A,I2)') '  Symmetry ',IASYM
  call IWRTMA(IOOS(:,:,IASYM),NOCTPA,NOCTPB,NOCTPA,NOCTPB)
end do
write(u6,*) ' Number of  combinations per OOS blocks'
do IASYM=1,MAXSYM
  write(u6,'(A,I2)') '  Symmetry ',IASYM
  call IWRTMA(NOOS(:,:,IASYM),NOCTPA,NOCTPB,NOCTPA,NOCTPB)
end do
#endif

return

end subroutine ZOOS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_GnVc_GetInt(xInt,lInt,nVecRS,iVecRS,ListSp,mSym,mPass,mmShl,iPass1,NumPass,NumSP)
!
! Purpose: compute integrals for NumPass integral passes starting at
!          pass iPass1.

use Cholesky, only: InfVec, IndRSh, nnShl, nSym
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lInt, mSym, mPass, nVecRS(mSym,mPass), iVecRS(mSym,mPass), mmShl, iPass1, NumPass
real(kind=wp), intent(inout) :: xInt(lInt)
integer(kind=iwp), intent(out) :: ListSP(mmShl), NumSP
integer(kind=iwp) :: iAB, iPass, iPass2, iShAB, iSP, iSym, iV, iV1, iV2, jShAB, lSewInt
integer(kind=iwp), allocatable :: SPTmp(:)
character(len=*), parameter :: SecNam = 'Cho_GnVc_GetInt'
integer(kind=iwp), external :: Cho_F2SP

! Initialization and input check.
! -------------------------------

if (NumPass < 1) then
  NumSP = 0
  return
end if

if (mSym /= nSym) call Cho_Quit('Input error [1] in '//SecNam,103)

if (iPass1 < 1) call Cho_Quit('Input error [2] in '//SecNam,103)

iPass2 = iPass1+NumPass-1
if (iPass2 > mPass) call Cho_Quit('Input error [3] in '//SecNam,103)

if (mmShl < nnShl) call Cho_Quit('Input error [4] in '//SecNam,103)

! Set up list of shell pairs to compute.
! --------------------------------------

call mma_allocate(SPTmp,nnShl,Label='SPTmp')
SPTmp(:) = 0
NumSP = 0
do iPass=iPass1,iPass2
  do iSym=1,nSym
    iV1 = iVecRS(iSym,iPass)
    iV2 = iV1+nVecRS(iSym,iPass)-1
    do iV=iV1,iV2
      iAB = InfVec(iV,1,iSym) ! addr in 1st reduced set
      jShAB = IndRsh(iAB) ! shell pair (full)
      iShAB = Cho_F2SP(jShAB) ! reduced shell pair
      if (iShAB > 0) then
        if (SPTmp(iShAB) == 0) then ! register SP
          SPTmp(iShAB) = 1
          NumSP = NumSP+1
          ListSP(NumSP) = iShAB
        end if
      else
        call Cho_Quit('SP not found in reduced list!',103)
      end if
    end do
  end do
end do
call mma_deallocate(SPTmp)

! Set memory used by Seward.
! --------------------------

call mma_maxDBLE(lSewInt)
call xSetMem_Ints(lSewInt)

! Loop through shell pair list.
! -----------------------------

do iSP=1,NumSP

  ! Get shell pair index.
  ! ---------------------

  iShAB = ListSP(iSP)

  ! Compute integral distribution (**|A B).
  ! ---------------------------------------

  call Cho_MCA_CalcInt_3(xInt,lInt,iShAB)

end do

! Deallocation.
! -------------

call xRlsMem_Ints()

end subroutine Cho_GnVc_GetInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Init_ave(Title,iPrint,PrOcc,PrEne,DensityBased,ThrOcc,Dummy,iDummy)
!-- Initializations and defaults.

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
character(len=72), intent(out) :: Title
integer(kind=iwp), intent(out) :: iPrint, iDummy
real(kind=wp), intent(out) :: ThrOcc, Dummy
logical(kind=iwp), intent(out) :: PrOcc, PrEne, DensityBased

iPrint = 2
PrOcc = .true.
PrEne = .false.
DensityBased = .true.
ThrOcc = 1.0e-5_wp
Dummy = One
iDummy = 1
Title = ' Untitled job. '

return

end subroutine Init_ave

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE SDCI_CPF(H,iH,LIC0)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "cpfmcpf.fh"
c      DIMENSION H(LIC0), iH(RtoI*LIC0)
      DIMENSION H(*), iH(*)
      CALL SDCI_CPF_INTERNAL(H)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE SDCI_CPF_INTERNAL(H)
      USE ISO_C_BINDING
      REAL*8, TARGET :: H(*)
      INTEGER, POINTER :: iH1(:),iH2(:),iH3(:)
      LIC=LIC0
      IPRINT=5
      IDENS=0
C INPUT, SORTING AND DIAGONAL ELEMENTS
      CALL READIN_CPF(H,iH)
      CALL DIAGCT_CPF(H)
      ITER=1
      IF(IREST.EQ.1)ITER=ITER+1
      ITPUL=1
      IF(IREST.EQ.0)CALL START_CPF(H(LW(26)),JSC(4),IREF0)
      IF(IREST.EQ.1)CALL RESTART_CPFMCPF(H(LW(26)),JSC(4))
      IF(ICPF.EQ.0.AND.INCPF.EQ.0.AND.ISDCI.EQ.0) THEN
        CALL C_F_POINTER(C_LOC(H(LW(1))),iH1,[1])
        CALL THETSET(iH1,H(LW(29)),IRC(4))
        NULLIFY(iH1)
      END IF
100   CALL C_F_POINTER(C_LOC(H(LW(1))),iH1,[1])
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL C_F_POINTER(C_LOC(H(LW(3))),iH3,[1])
      CALL NPSET(iH2,iH3,H(LW(26)),H(LW(30)),H(LW(31)),
     *H(LW(72)),H(LW(27)),H(LW(28)),H(LW(32)),iH1)
      NULLIFY(iH1,iH2,iH3)
      CALL TWOCT(H)
      CALL ONECT(H)
      CALL CPFCTL(H)
      ITER=ITER+1
      ITPUL=ITPUL+1
      IF(ITER.GT.MAXIT.OR.ICONV.EQ.1)GO TO 395
      GO TO 100
C     FIRST ORDER DENSITY MATRIX
395   IDENS=1
*
      CALL DENSCT_CPF(H,LIC0)
*
      IF(NREF.GT.1) THEN
         WRITE(6,*) ' This is a single reference program, but more than'
         WRITE(6,*) ' one reference state has been specified in the'
         WRITE(6,*) ' GUGA program. Change input to GUGA and run again.'
      CALL XFLUSH(6)
         RETURN
      END IF
      RETURN
      END SUBROUTINE SDCI_CPF_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine ComputeFuncB2(nOrb2Loc,Lbl,nComp,Functional,Debug)
! Author: T.B. Pedersen
!
! Purpose: compute Boys localisation functional B2.

use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nOrb2Loc, nComp
real(kind=wp), intent(in) :: Lbl(nOrb2Loc,nOrb2Loc,nComp)
real(kind=wp), intent(out) :: Functional
logical(kind=iwp), intent(in) :: Debug
integer(kind=iwp) :: i, iComp, iMO, j
real(kind=wp) :: Cmp, Tst

Functional = Zero
do iComp=1,nComp
  do i=1,nOrb2Loc
    Functional = Functional+Lbl(i,i,iComp)**2
  end do
end do

if (Debug) then
  write(u6,*)
  write(u6,*) 'In ComputeFuncB2'
  write(u6,*) '----------------'
  write(u6,*) 'Functional B2 = ',Functional
  write(u6,*) '[Assuming doubly occupied orbitals]'
  do iComp=1,nComp
    Cmp = Zero
    do iMO=1,nOrb2Loc
      Cmp = Cmp+Lbl(iMO,iMO,iComp)
    end do
    Cmp = Two*Cmp
    write(u6,'(A,I5,1X,F15.8)') 'Component, Exp. Val.:',iComp,Cmp
    do j=1,nOrb2Loc-1
      do i=j+1,nOrb2Loc
        Tst = Lbl(i,j,iComp)-Lbl(j,i,iComp)
        if (abs(Tst) > 1.0e-14_wp) then
          write(u6,*) 'ComputeFuncB2: broken symmetry!'
          write(u6,*) '  Component: ',iComp
          write(u6,*) '  i and j  : ',i,j
          write(u6,*) '  Dij      : ',Lbl(i,j,iComp)
          write(u6,*) '  Dji      : ',Lbl(j,i,iComp)
          write(u6,*) '  Diff.    : ',Tst
          call SysAbendMsg('ComputeFuncB2','Broken symmetry!',' ')
        end if
      end do
    end do
  end do
end if

end subroutine ComputeFuncB2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Module file for the peek/poke utilities.                             *
!                                                                      *
!***********************************************************************

module peekpoke

use Definitions, only: wp, iwp

implicit none
private

integer, parameter :: nTabDS = 32, nTabIS = 32
character(len=24) :: ds_label(nTabDS), is_label(nTabIS)
real(kind=wp) :: ds_value(nTabIS)
integer(kind=iwp) :: is_value(nTabDS)
integer(kind=iwp) :: ds_no, is_no

public :: ds_label, ds_value, ds_no, is_label, is_value, is_no

end module peekpoke

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SUBROUTINE set_nnA(nSym,nAorb,nnA)

      Implicit Real*8 (a-h,o-z)
      Integer nSym,nAorb(8)
      Integer nnA(8,8)

**************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
**************************************************

      do j=1,nSym
         do i=j,nSym

            kSym     = MulD2h(i,j)

            nnA(i,j) = nAorb(i)*nAorb(j)
     &               + Min(0,kSym-2)*nAorb(i)*(nAorb(i)-1)/2

            nnA(j,i) = nnA(i,j)

         end do
      end do

      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Check_Bond(CXi,CXj,iANr,jANr,Factor)
! Returns true if the bond should be included, otherwise false

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: Check_Bond
real(kind=wp), intent(in) :: CXi(3), CXj(3), Factor
integer(kind=iwp), intent(in) :: iANr, jANr
real(kind=wp) :: Bond_Length, Bond_Max, Radius_i, Radius_j
real(kind=wp), external :: Bragg_Slater

Check_Bond = .true.
if (Factor < Zero) then
  Check_Bond = .true.
else
  Radius_i = Bragg_Slater(iANr)
  Radius_j = Bragg_Slater(jANr)
  Bond_Length = sqrt((CXi(1)-CXj(1))**2+(CXi(2)-CXj(2))**2+(CXi(3)-CXj(3))**2)
  Bond_Max = Factor*(Radius_i+Radius_j)
  if (Bond_Length > Bond_Max) Check_Bond = .false.
end if

return

end function Check_Bond

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
*  isFreeUnit
*
*> @brief
*>   Find free unit number
*> @author V. Veryazov
*>
*> @details
*> Find unused unit number, starting from initial value.
*>
*> @param[in] iseed guess for unit number
*>
*> @return Free unit number
************************************************************************
       Function isFreeUnit(iseed)
#include "fio.fh"
       integer, intent(in) :: iseed
c      check free chanal, starting from init
       Logical Opened
*
CVV since more and more developers' calling isfreeunit with constant...
       init=iseed
       if(init.lt.1.or.init.gt.300) then
        write(6,*) '*** Possible bug in opening file'
        write(6,*) '*** isFreeUnit resets the unit number'
        init=12
       endif
       isFreeUnit=-init
       kan=min(init,Mxfile-1)
       kan0=kan
       Go to 2
 1     Continue
       If (kan.eq.MxFile+1) kan=10
       If (kan.eq.kan0) Then
          Call fastio('STATUS')
          Write (6,*) ' isFreeUnit: no available unit!'
          Call Abend()
       End If
 2     Continue
*
*----- Check for Dafile
*
       If (kan.gt.1.and.kan.le.MxFile.and.isOpen(kan).eq.1) Then
          kan=kan+1
          Go To 1
       End If
*
*----- Check for Fortran I/O
*
       Inquire(unit=kan,opened=Opened)
       If (Opened) Then
          kan=kan+1
          Go To 1
       End If
       isFreeUnit=kan
       Return
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2022, Jie J. Bao                                       *
************************************************************************
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Feb. 03, 2022, created this file.               *
* ****************************************************************
* Purpose: Return to the exponent of a skew-symmetric matrix
      Subroutine ExpMat(M,A,DimM,LenA)
*     Input
      INTEGER DimM, LenA
      Real*8 A(LenA)
*     Output
      Real*8 M(DimM**2)
*     Explanation:
*     Calculate M=exp(-A)
*     A is stored as a 1 by LenA vector, and M is a DimM by DimM matrix
*     This subroutine assumes LenA=(DimM-1)*DimM/2
*     How it works:
*     First transform A into a skew-symmetric matrix form. Then call
*     ExpMat_Inner to calculate exp(A)
*     Auxiliary:
      Real*8 MatA(DimM**2)
      INTEGER I,J,N,iIJ1,iIJ2

      N=DimM**2
      CALL FZero(MatA,N)
      DO I=2,DimM
       Do J=1,I-1
        iIJ2=(I-2)*(I-1)/2+J
        iIJ1=(I-1)*DimM+J
        MatA(iIJ1)=A(iIJ2)
        iIJ1=(J-1)*DimM+I
        MatA(iIJ1)=-A(iIJ2)
       End Do
      END DO

      CALL ExpMat_Inner(M,MatA,DimM)
      RETURN
      End SUbroutine

      Subroutine ExpMat_Inner(R,X,nLen)
******Purpose: calculate R=exp(X)
******Explanation:
*     The subroutine uses the algorithm in Section 3.1.5 on Page 83 of
*     'Molecular Electronic-Structure Theory' by T. Helgaker, P.
*     J/orgensen and J. Olsen.
*     Jie Bao acknowledges Dr. Chen Zhou from Xiamen University, China, for
*     showing the resource of this algorithm and his code for reference.
      use stdalloc, only : mma_allocate, mma_deallocate
*     Input
      INTEGER nLen,nLen2
      Real*8 x(nLen**2)
*     Output
      Real*8 R(nLen**2)
*     Auxilliary
      Real*8 tau2(nLen),cospart(nLen**2),sinpart(nLen**2),
     &       scr(nLen**2),X2(nLen**2),tau(nLen)
      INTEGER nScrDiag,INFO,I
      Real*8,DIMENSION(:),Allocatable::ScrDiag
      Real*8 Coeff

      nLen2=nLen**2

*Step 1     calculate X2
      CALL DGEMM_('n','n',nLen,nLen,nLen,1.0d0,X,nLen,X,nLen,
     &                                   0.0d0,X2,nLen)

*Step 2     diagonalize X2
      CALL GetDiagScr(nScrDiag,X2,Scr,nLen)
      CALL mma_allocate(ScrDiag,nScrDiag)
      CALL DSYEV_('V','U',nLen,X2,nLen,tau2,ScrDiag,nScrDiag,INFO)
      CALL mma_deallocate(ScrDiag)

      DO I=1,nLen
       tau(I)=dsqrt(dabs(tau2(I)))
      END DO

*Step 3     build cos part of R matrix
      CALL DCopy_(nLen2,X2,1,CosPart,1)
      DO I=1,nLen
       CALL DScal_(nLen,cos(tau(I)),CosPart((I-1)*nLen+1),1)
      END DO

      CALL DGEMM_('n','t',nLen,nLen,nLen,1.0d0,CosPart,nLen,X2,nLen,
     &                                   0.0d0,Scr,nLen)
*     R=W * cos(tau) * W^T
      CALL DCopy_(nLen2,Scr,1,R,1)
*Step 4     build sin part of R matrix
      CALL DCopy_(nLen2,X2,1,SinPart,1)
      DO I=1,nLen
       IF(tau(I).lt.1.0d-8) THEN
        Coeff=1.0d0
       ELSE
        Coeff=sin(tau(I))/tau(I)
       END IF
       CALL DScal_(nLen,Coeff,SinPart((I-1)*nLen+1),1)
      END DO

      CALL DGEMM_('n','t',nLen,nLen,nLen,1.0d0,SinPart,nLen,X2,nLen,
     &                                   0.0d0,Scr,nLen)
*     R=R+W * tau^(-1) * sin(tau) * W^T * X
      CALL DGEMM_('n','n',nLen,nLen,nLen,1.0d0,Scr,nLen,X,nLen,
     &                                   1.0d0,R,nLen)
      RETURN
      End Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetTauHlp2(Tau,T1,dima,adda,no,nv)
! Make Tau for aGrp == bGrp

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, adda, no, nv
real(kind=wp), intent(inout) :: Tau(nTri_Elem(dima),no,no)
real(kind=wp), intent(in) :: T1(nv,no)
integer(kind=iwp) :: a, ab, i

do i=1,no
  ab = 0
  do a=1,dima
    Tau(ab+1:ab+a,i,:) = Tau(ab+1:ab+a,i,:)+T1(adda+a,i)*T1(adda+1:adda+a,:)
    ab = ab+a
  end do
end do

return

end subroutine GetTauHlp2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Lobatto(ndeg,trw)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ndeg
real(kind=wp), intent(out) :: trw(3*(ndeg+2)*(ndeg+3)/2)
integer(kind=iwp) :: ii, ir, jj, jr, k, n
real(kind=wp) :: c, delta, dmax, f, fnew, fold, fp, fpnew, fpold, rk, x, xterm
real(kind=wp), allocatable :: recurs(:), roots(:,:), wghts(:,:)

call mma_allocate(roots,ndeg,ndeg,label='roots')
call mma_allocate(recurs,ndeg,label='recurs')
! Start: Accurately known are p0=1 and p1=x
roots(1,1) = Zero
! Recursion coefficients:
do k=1,ndeg
  rk = real(k,kind=wp)
  recurs(k) = (rk*(rk+Two))/((Two*rk+One)*(Two*rk+Three))
end do

do k=2,ndeg
  ! Construct a start approximation to the roots:
  roots(1,k) = (real(k,kind=wp)*(roots(1,k-1)+One))/real(k+1,kind=wp)-One
  roots(k,k) = (real(k,kind=wp)*(roots(k-1,k-1)-One))/real(k+1,kind=wp)+One
  do ir=2,k-1
    roots(ir,k) = (real(k+1-ir,kind=wp)*roots(ir,k-1)+real(ir,kind=wp)*roots(ir-1,k-1))/real(k+1,kind=wp)
  end do
  ! Start modified Newton-Raphson iterations. Parallell treatment of roots:
  do
    dmax = Zero
    do ir=1,k
      ! Compute value and derivative of polynomial:
      x = roots(ir,k)
      fpold = Zero
      fold = One
      fp = One
      f = x
      do n=2,k
        c = recurs(n-1)
        fpnew = x*fp+f-c*fpold
        fnew = x*f-c*fold
        fpold = fp
        fold = f
        fp = fpnew
        f = fnew
      end do
      ! Compute the extra denominator term:
      xterm = Zero
      do jr=1,k
        if (jr /= ir) xterm = xterm+One/(x-roots(jr,k))
      end do
      ! Update:
      delta = -f/(fp-f*xterm)
      roots(ir,k) = roots(ir,k)+delta
      dmax = max(dmax,abs(delta))
    end do
    if (dmax <= 1.0e-12_wp) exit
  end do
end do

call mma_deallocate(recurs)
call mma_allocate(wghts,ndeg,ndeg,label='wghts')

! Compute weights:
do k=1,ndeg
  do ir=1,k
    x = roots(ir,k)
    fold = One
    f = x
    do n=1,k
      fnew = x*f*(Two*real(n,kind=wp)+One)/(real(n,kind=wp)+One)-fold*real(n,kind=wp)/(real(n,kind=wp)+One)
      fold = f
      f = fnew
    end do
    wghts(ir,k) = Two/(f*f*real(k+1,kind=wp)*real(k+2,kind=wp))
  end do
end do

do n=3,ndeg+2
  trw(3*n*(n-1)/2+1) = -One                       ! (n-1,1,1)   n=nDeg+2
  trw(3*n*(n-1)/2+2) = Two/real(n*(n-1),kind=wp)  ! (n-1,1,2)
  trw(3*n*(n+1)/2-2) = One                        ! (n-1,n-1,1)
  trw(3*n*(n+1)/2-1) = Two/real(n*(n-1),kind=wp)  ! (n-1,n-1,2)
end do

! (1,1,1)
! (1,1,2)
! (1,1,3)
! (2,1,1)
! (2,1,1)
! (2,1,2)
! (2,2,3)
! (2,2,2)
! (2,2,3)

trw(1:9) = Zero

do k=1,ndeg
  n = k+1
  do ir=1,k
    ii = 3*n*(n+1)/2+ir*3+1  ! (n+1,ir,1)   n=nDeg+1, ir=2,nDeg
    jj = 3*n*(n+1)/2+ir*3+2  ! (n+1,ir,2)
    trw(ii) = roots(ir,k)
    trw(jj) = wghts(ir,k)
  end do
end do

call mma_deallocate(roots)
call mma_deallocate(wghts)

!write(u6,*) 'Lobatto'
!do i=1,ndeg+2
!  write(u6,*) 'i=',i
!  do j=1,i
!    write(u6,*) trw(3*i*(i-1)/2+3*(j-1)+1),trw(3*i*(i-1)/2+3*(j-1)+2),trw(3*i*(i-1)/2+3*(j-1)+3)
!  end do
!end do

return

end subroutine Lobatto

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine prsq(idbg,label,a,n)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idbg, n
character(len=8), intent(in) :: label
real(kind=wp), intent(in) :: a(n,n)
integer(kind=iwp) :: i, j

write(idbg,1001) label
write(idbg,1002) (j,j=1,n)
do i=1,n
  write(idbg,1003) i,(a(i,j),j=1,n)
end do

return

1001 format(' MATRIX PRINTED:',2X,A8)
1002 format(' ',4X,4(6X,I4,6X),/)
1003 format(' ',I4,4d16.8)

end subroutine prsq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine tensor2cart(Jt,Jc)
!     Hexch = S1.Jsph.S2

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Complex(kind=8), intent(in) :: Jt(-1:1,-1:1)
      Real(kind=8), intent(out)   :: Jc(3,3)
      ! local variables
      Complex(kind=8) :: i,pp,pz,pm,zp,zz,zm,mp,mz,mm

      jc(1:3,1:3)=0.0_wp
       i=(0.0_wp,1.0_wp)
      pp=(0.0_wp,0.0_wp)
      pz=(0.0_wp,0.0_wp)
      pm=(0.0_wp,0.0_wp)
      zp=(0.0_wp,0.0_wp)
      zz=(0.0_wp,0.0_wp)
      zm=(0.0_wp,0.0_wp)
      mp=(0.0_wp,0.0_wp)
      mz=(0.0_wp,0.0_wp)
      mm=(0.0_wp,0.0_wp)

      pp=jt( 1, 1)
      pz=jt( 1, 0)
      pm=jt( 1,-1)
      zp=jt( 0, 1)
      zz=jt( 0, 0)
      zm=jt( 0,-1)
      mp=jt(-1, 1)
      mz=jt(-1, 0)
      mm=jt(-1,-1)

      jc(1,1)=0.5_wp * dble(    mm -  mp -  pm +  pp )
      jc(2,2)=0.5_wp * dble( -  mm -  mp -  pm -  pp )
      jc(1,2)=0.5_wp * dble( -i*mm -i*mp +i*pm +i*pp )
      jc(2,1)=0.5_wp * dble( -i*mm +i*mp -i*pm +i*pp )

      jc(1,3)=sqrt(0.5_wp) * dble(   mz-  pz )
      jc(3,1)=sqrt(0.5_wp) * dble(   zm-  zp )

      jc(2,3)=sqrt(0.5_wp) * dble(-i*mz-i*pz )
      jc(3,2)=sqrt(0.5_wp) * dble(-i*zm-i*zp )

      jc(3,3)=dble(zz)

      Return
      End Subroutine tensor2cart






      Subroutine tensor2cart_minus(Jt,Jc)
!     Hexch = -Jsph.S1.S2

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Complex(kind=8), intent(in) :: Jt(-1:1,-1:1)
      Real(kind=8), intent(out)   :: Jc(3,3)
      ! local variables
      Complex(kind=8) :: i,pp,pz,pm,zp,zz,zm,mp,mz,mm

      jc(1:3,1:3)=0.0_wp
       i=(0.0_wp,1.0_wp)
      pp=(0.0_wp,0.0_wp)
      pz=(0.0_wp,0.0_wp)
      pm=(0.0_wp,0.0_wp)
      zp=(0.0_wp,0.0_wp)
      zz=(0.0_wp,0.0_wp)
      zm=(0.0_wp,0.0_wp)
      mp=(0.0_wp,0.0_wp)
      mz=(0.0_wp,0.0_wp)
      mm=(0.0_wp,0.0_wp)

      pp=jt( 1, 1)
      pz=jt( 1, 0)
      pm=jt( 1,-1)
      zp=jt( 0, 1)
      zz=jt( 0, 0)
      zm=jt( 0,-1)
      mp=jt(-1, 1)
      mz=jt(-1, 0)
      mm=jt(-1,-1)

      jc(1,1)=0.5_wp * dble( -  mm +  mp +  pm -  pp )
      jc(2,2)=0.5_wp * dble(    mm +  mp +  pm +  pp )

      jc(1,2)=0.5_wp * dble(  i*mm -i*mp +i*pm -i*pp )
      jc(2,1)=0.5_wp * dble(  i*mm +i*mp -i*pm -i*pp )

      jc(1,3)=sqrt(0.5_wp) * dble(  -zm + zp )
      jc(3,1)=sqrt(0.5_wp) * dble(  -mz + pz )

      jc(2,3)=sqrt(0.5_wp) * dble( i*zm+i*zp )
      jc(3,2)=sqrt(0.5_wp) * dble( i*mz+i*pz )

      jc(3,3)=dble(-zz)

      Return
      End Subroutine tensor2cart_minus








      Subroutine cart2tensor(Jc,Jt)
! this subroutine computed tensorial parameters for
!     Hexch= S1.Jcart.S2

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Real(kind=8), intent(in)    :: Jc(3,3)
      Complex(kind=8), intent(out):: Jt(-1:1,-1:1)
      ! local variables
      Complex(kind=8) :: c2, cx2, i
      Complex(kind=8) :: xx,xy,xz,yx,yy,yz,zx,zy,zz

      jt(-1:1,-1:1)=(0.0_wp,0.0_wp)

      i=(0.0_wp,1.0_wp)
      c2=(0.5_wp,0.0_wp)
      cx2=cmplx(sqrt(0.5_wp),0.0_wp,wp)

      xx=cmplx( jc(1,1), 0.0_wp, wp )
      xy=cmplx( jc(1,2), 0.0_wp, wp )
      xz=cmplx( jc(1,3), 0.0_wp, wp )
      yx=cmplx( jc(2,1), 0.0_wp, wp )
      yy=cmplx( jc(2,2), 0.0_wp, wp )
      yz=cmplx( jc(2,3), 0.0_wp, wp )
      zx=cmplx( jc(3,1), 0.0_wp, wp )
      zy=cmplx( jc(3,2), 0.0_wp, wp )
      zz=cmplx( jc(3,3), 0.0_wp, wp )

      jt( 1, 1)=c2*(  xx -i*xy -i*yx -yy )
      jt(-1,-1)=c2*(  xx +i*xy +i*yx -yy )
      jt( 1,-1)=c2*( -xx -i*xy +i*yx -yy )
      jt(-1, 1)=c2*( -xx +i*xy -i*yx -yy )

      jt( 1, 0)=cx2*(-xz+i*yz)
      jt(-1, 0)=cx2*( xz+i*yz)

      jt( 0, 1)=cx2*(-zx+i*zy)
      jt( 0,-1)=cx2*( zx+i*zy)

      jt( 0, 0)=zz

      Return
      End Subroutine cart2tensor




      Subroutine cart2tensor_minus(Jc,Jt)
! this subroutine computed tensorial parameters for
!     Hexch= -Jcart.S1.S2

      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Real(kind=8), intent(in)    :: Jc(3,3)
      Complex(kind=8), intent(out):: Jt(-1:1,-1:1)
      ! local variables
      Complex(kind=8) :: c2, cx2, i
      Complex(kind=8) :: xx,xy,xz,yx,yy,yz,zx,zy,zz

      jt(-1:1,-1:1)=(0.0_wp,0.0_wp)

      i=(0.0_wp,1.0_wp)
      c2=(0.5_wp,0.0_wp)
      cx2=cmplx(sqrt(0.5_wp),0.0_wp,wp)

      xx=cmplx( jc(1,1), 0.0_wp, wp )
      xy=cmplx( jc(1,2), 0.0_wp, wp )
      xz=cmplx( jc(1,3), 0.0_wp, wp )
      yx=cmplx( jc(2,1), 0.0_wp, wp )
      yy=cmplx( jc(2,2), 0.0_wp, wp )
      yz=cmplx( jc(2,3), 0.0_wp, wp )
      zx=cmplx( jc(3,1), 0.0_wp, wp )
      zy=cmplx( jc(3,2), 0.0_wp, wp )
      zz=cmplx( jc(3,3), 0.0_wp, wp )

      jt( 1, 1)=c2*( -xx +i*xy +i*yx +yy )
      jt(-1,-1)=c2*( -xx -i*xy -i*yx +yy )
      jt( 1,-1)=c2*(  xx -i*xy +i*yx +yy )
      jt(-1, 1)=c2*(  xx +i*xy -i*yx +yy )

      jt( 1, 0)=cx2*( zx-i*zy)
      jt(-1, 0)=cx2*(-zx-i*zy)

      jt( 0, 1)=cx2*( xz-i*yz)
      jt( 0,-1)=cx2*(-xz-i*yz)

      jt( 0, 0)= -zz

      Return
      End Subroutine cart2tensor_minus

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Localize_LoProp_Drv(Ttot,Ttot_Inv,nBas,iCenter,iType,
     &                            nBas1,nBas2,nSym,nBasMax,ipP,Restart)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Ttot(nBas2), Ttot_Inv(nBas2)
      Integer iCenter(nBas1), iType(nBas1), nBas(nSym)
      Character*8 Label
      Logical Found,Restart
      Dimension idum(1)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*---- Get the overlap matrix
*
      iOpt1=1
      iOpt0=0
      Label='Mltpl  0'
      iRc=-1
      iSyLbl=1
      If (Restart) Then
         Call Qpg_iArray('LoProp nInts',Found,nElem)
         Call Allocate_iWork(ip_restart,nElem)
         Call Get_iArray('LoProp nInts',iWork(ip_restart),nElem)
         nInts = iWork(ip_restart+0) - 4
         Call GetMem('Tmp','Allo','Real',ip_SSym,nInts+4)
         Call Qpg_dArray('LoProp Integrals',Found,nInts_tot)
         If (.Not. Found) Then
            Write(6,*) 'LoProp Integrals not available on the RunFile.'
            Call Abend()
         End If
         Call Allocate_Work(ip_all_ints,nInts_Tot)
         Call Get_dArray('LoProp Integrals',Work(ip_all_ints),nInts_tot)
         Call dCopy_(iWork(ip_restart+0),Work(ip_all_ints),1,
     &                                Work(ip_SSym),1)
         Call Get_iArray('LoProp iSyLbl',iWork(ip_restart),nElem)
         iSyLbl = iWork(ip_restart+0)
         Call Free_Work(ip_all_ints)
         Call Free_iWork(ip_restart)
      Else
         Call iRdOne(iRc,iOpt1,Label,1,idum,iSyLbl)
         If ( iRc.ne.0 ) Then
            Write (6,*) 'Polar: error reading length of mu!'
            Write (6,*) 'Mu=',0
            Call Abend()
         End If
         nInts=idum(1)
         Call GetMem('Tmp','Allo','Real',ip_SSym,nInts+4)
         Call RdOne(iRc,iOpt0,Label,1,Work(ip_SSym),iSyLbl)
         If ( iRc.ne.0 ) Then
            Write (6,*) 'Polar: error reading mu!'
            Write (6,*) 'Mu=',0
            Call Abend()
         End If
      End If
#ifdef _DEBUGPRINT_
      Call RecPrt('SSym',' ',Work(ip_SSym),1,nInts)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('SMatrix','Allo','Real',ip_Tmp,nBas2)
      If (nSym.eq.1) Then
         ipS = ip_Tmp
      Else
         Call GetMem('SMatrix','Allo','Real',ipS,nBas1**2)
      End If
*
      iOfft = ip_SSym
      iOffs = ip_Tmp
      Do iSym = 1, nSym
         If (nBas(iSym).eq.0) Go To 99
*
*        Now I square the overlap matrix because it has been stored as a
*        lower triangle
*
         Call Square(Work(iOfft),Work(iOffs),1,nBas(iSym),nBas(iSym))
*
         iOfft = iOfft + nBas(iSym)*(nBas(iSym)+1)/2
         iOffs = iOffs + nBas(iSym)**2
 99      Continue
      End Do
      Call Free_Work(ip_SSym)
*
      If (nSym.ne.1) Then
*
*------- Desymmetrize
*
         nScr=nBasMax*nBas1
         Call Allocate_Work(ipScr,nScr)
         Call FZero(Work(ipS),nBas1**2)
         Call Desymmetrize(Work(ip_Tmp),nBas2,Work(ipScr),nScr,
     &                     Work(ipS),nBas,nBas1,Work(ipP),nSym,
     &                     iSyLbl)
         Call Free_Work(ipScr)
         Call Free_Work(ip_Tmp)
*
      End If
#ifdef _DEBUGPRINT_
      Call RecPrt('Overlap matrix',' ',Work(ipS),nBas1,nBas1)
#endif
*
*
*---- Localize
*
      Call Localize_LoProp(Ttot,Ttot_Inv,nBas1,Work(ipS),iCenter,iType)
#ifdef _DEBUGPRINT_
      Call RecPrt('Ttot',' ',Ttot,nBas1,nBas1)
      Call RecPrt('Ttot_Inv',' ',Ttot_Inv,nBas1,nBas1)
      Call xSpot('Exit Localize_LoProp_Drv')
#endif
*
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_Work(ipS)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mksymorbs2_cvb(orbs,sorbs)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension orbs(norb,norb)
      dimension sorbs(norb,norb)
      dimension dum(1)
      save thresh
      data thresh/1.d-7/

      if(sym)then
        call fmove_cvb(orbs,sorbs,norb*norb)
        nconstr_kp=nconstr
        nconstr=0
        call symtrizorbs_cvb(orbs)
        nconstr=nconstr_kp
        call subvec(sorbs,orbs,sorbs,norb*norb)
        delorbs=dnrm2_(norb*norb,sorbs,1)
        if(delorbs.gt.thresh.and.ip(1).ge.2)then
          write(6,'(/,a)') ' Change in symmetrized orbitals:'
          call report_cvb(sorbs,norb)
        endif
        call nize_cvb(orbs,norb,dum,norb,0,0)
        if(delorbs.gt.thresh.and.ip(1).ge.2)then
          write(6,'(a)') ' Orbitals after symmetrization:'
          call report_cvb(orbs,norb)
        endif
        if(abs(detm_cvb(orbs,norb)).lt.1d-8)then
          write(6,*)' Fatal error - orbital matrix singular',
     >      ' after symmetrization!'
          call abend_cvb()
        endif
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CSFDET_MCLR(NOPEN,IDET,NDET,ICSF,NCSF,CDC,PSSIGN)
! Expand csf's in terms of combinations with
! the use of the Grabenstetter method (I.J.Q.C. 10, P142 (1976))
!
! Input :
!         NOPEN : NUMBER OF OPEN ORBITALS
!         IDET  : OCCUPATION OF combinations
!         NDET  : NUMBER OF combinations
!         ICSF  : INTERMEDIATE SPIN COUPLINGS OF
!                 CSF'S IN BRANCHING DIAGRAM
! Output :
!         CDC :  NDET X NCSF MATRIX
!                GIVING EXPANSION FROM COMB'S TO CSF,S
!                CSF BASIS = Comb basis *CDC
!
! If combinations are use (signaled by PSSIGN /= 0)
! the factors are multiplies with sqrt(2), corresponding to
! a combination being 1/sqrt(2) times the sum or difference of two
! determinants
!
! The terms are not mutiplied with any sqrt(2), so the transformation is to
! the determinant normalization

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NOPEN, NDET, IDET(NOPEN,NDET), NCSF, ICSF(NOPEN,NCSF)
real(kind=wp), intent(out) :: CDC(NDET,NCSF)
real(kind=wp), intent(in) :: PSSIGN
integer(kind=iwp) :: IOPEN, JCSF, JDET
real(kind=wp) :: CMBFAC, COEF, SGN
real(kind=wp), allocatable :: LMDET(:,:), lSCSF(:)

if (PSSIGN == Zero) then
  CMBFAC = One
else
  CMBFAC = sqrt(Two)
end if
call mma_allocate(LMDET,NOPEN,NDET,Label='LMDET')
call mma_allocate(LSCSF,NOPEN,Label='LSCSF')

! OBTAIN INTERMEDIATE VALUES OF MS FOR ALL DETERMINANTS
do JDET=1,NDET
  call MSSTRN_MCLR(IDET(:,JDET),LMDET(:,JDET),NOPEN)
end do

do JCSF=1,NCSF
# ifdef _DEBUGPRINT_
  write(u6,*) ' ....Output for CSF ',JCSF
# endif

  ! OBTAIN INTERMEDIATE COUPLINGS FOR CSF
  call MSSTRN_MCLR(ICSF(1,JCSF),LSCSF,NOPEN)

  do JDET=1,NDET
    ! EXPANSION COEFFICIENT OF DETERMINANT JDET FOR CSF JCSF
    COEF = One
    SGN = One
    do IOPEN=1,NOPEN

      if (ICSF(IOPEN,JCSF) == 1) then
        if (IDET(IOPEN,JDET) == 1) then
          ! + + CASE
          COEF = COEF*(LSCSF(IOPEN)+LMDET(IOPEN,JDET))/(Two*LSCSF(IOPEN))
        else if (IDET(IOPEN,JDET) == 0) then
          ! + - CASE
          COEF = COEF*(LSCSF(IOPEN)-LMDET(IOPEN,JDET))/(Two*LSCSF(IOPEN))
        end if
      else if (ICSF(IOPEN,JCSF) == 0) then
        if (IDET(IOPEN,JDET) == 1) then
          ! - + CASE
          COEF = COEF*(LSCSF(IOPEN)-LMDET(IOPEN,JDET)+One)/(Two*LSCSF(IOPEN)+Two)
          SGN = -SGN
        else if (IDET(IOPEN,JDET) == 0) then
          ! - - CASE
          COEF = COEF*(LSCSF(IOPEN)+LMDET(IOPEN,JDET)+One)/(Two*LSCSF(IOPEN)+Two)
        end if
      end if
    end do
    CDC(JDET,JCSF) = SGN*CMBFAC*sqrt(COEF)
  end do
end do

call mma_deallocate(LSCSF)
call mma_deallocate(LMDET)

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,'(A,2I2)') '  The CDC array for  NOPEN ',NOPEN
write(u6,*)
call WRTMAT(CDC,NDET,NCSF,NDET,NCSF)
#endif

end subroutine CSFDET_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  readgeo
!
!> @brief
!>   Reads a geometry and stores it into memory
!> @author Y. Carissan
!>
!> @details
!> Reads a geometry in the XYZ format and stores it
!> in memory at \c list(ig)%geo.
!>
!> @param[in] iLU logic unit number
!> @param[in] ig  geometry index
!***********************************************************************

subroutine readgeo(iLU,ig)

use Quater_globals, only: debug, list
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iLU, ig
integer(kind=iwp) :: natoms, iat
character(len=180) :: Line
character(len=20) :: lbl
character(len=6) :: cName
character(len=180), external :: Get_ln

if ((ig < 1) .or. (ig > 2)) call SysAbendMsg('ReadGeo','Wrong ig ','Shoot the programmer')

! read natoms
Line = Get_ln(iLU)
call Put_ln(Line)
call Get_I1(1,natoms)

if (natoms > 500) call SysAbendMsg('ReadGeo','Too many atoms in geom','')

if (debug) write(u6,*) 'In READGEO : Nat=',natoms

list(ig)%nat = natoms

! allocate memory for the geometry

if (ig < 10) then
  write(cName,'(a5,i1)') 'GEOM0',ig
  list(ig)%title = cName
else if (ig < 100) then
  write(cName,'(a4,i2)') 'GEOM',ig
  list(ig)%title = cName
end if
call mma_allocate(list(ig)%geo,3,list(ig)%nat,label=cName)
call mma_allocate(list(ig)%geolbl,list(ig)%nat,label=cName)

! read title

Line = Get_ln(iLU)
list(ig)%title = trim(line)

! read label and coords

iat = 0
do
  Line = Get_ln(iLU)
  call Put_ln(Line)
  call Get_S(1,lbl,1)
  if (lbl == 'END ') then
    exit
  else
    iat = iat+1
    if (iat > list(ig)%nat) call SysAbendMsg('ReadGeo','More atoms read than declared','')
    list(ig)%geolbl(iat) = lbl
    call Get_F(2,list(ig)%geo(:,iat),3)
  end if
end do

call PrintGeom(-1_iwp,list(ig)%nat,list(ig)%title,list(ig)%geo,list(ig)%geolbl)

return

end subroutine readgeo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  CheckQuater
*
*> @brief
*>   Check whether the quaternion represents a rotation
*> @author Y. Carissan
*>
*> @details
*> Check whether the quaternion represents a rotation.
*>
*> @param[in] Q The quaternion to be checked
************************************************************************
      Subroutine CheckQuater(Q)
      Implicit none
#include "WrkSpc.fh"
#include "debug.fh"
#include "real.fh"
      Real*8 Q(0:3)
      Real*8 res
      Real*8 thrs,ddot_
      Real*8 angle
      Real*8 axis(3)
      real*8 modangle
      Parameter(thrs=1d-6)

      res=ddot_(4,Q,1,Q,1)

      if ( abs(res-One).gt.thrs ) then
        Call RecPrt("Quaternion tested",' ',Q,4,1)
        Call SysAbendMsg("CheckQuater",
     &      "Quaternion does not represent a rotation","")
      end if

      angle=modangle(Two * acos(Q(0)),Two*pi)

      if ( debug ) then
        Call RecPrt("Quaternion",' ',Q(0),4,1)
        Write(6,'(a8,f10.6,a3,f10.2,a3)') "Angle = ",
     &       angle,"Rad",180*angle/pi,"Deg"
      end if
      call dcopy_(3,Q(1),1,axis,1)
      Call normalizeVec(axis)
      if ( debug ) then
        Call RecPrt("Axis",' ',axis,3,1)
      end if

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DMinvCI(ipSigma,rout,rC_HE_C,idsym)

use ipPage, only: ipin, ipout, opout, W
use MCLR_Data, only: ipCI, ipDia, nConf1, NewPre, ngp
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ipSIgma, idSym
real(kind=wp), intent(inout) :: rout(nConf1)
real(kind=wp), intent(in) :: rC_HE_C
real(kind=wp) :: rCoeff
real(kind=wp), external :: DDot_

!                                  -1           -1
!                             (H -E) |0><0|(H -E) |Sigma>
!                -1             0            0
! |rNew> = (H - E) |Sigma> - -----------------------------
!            0                               -1
!                                    <0|(H -E) |0>
!                                         0

if (nconf1 > 1) then

  call ipin(ipdia)
  call ipin(ipSigma)
  call exphinvv(W(ipdia)%A,W(ipsigma)%A,rout,Zero,One)
  call ipout(ipsigma)
  call opout(ipdia)

  ! OBS <0|(H-E)|Sigma>=0 if idsym=/=1

  if (NewPre .and. (idsym == 1)) then
    !                  -1
    ! rcoeff = <0|(H -E) |Sigma>
    !               0
    !         -------------------
    !                    -1
    !            <0|(H -E) |0>
    !                 0

    if (.not. ngp) then
      call ipin(ipCI)
      rcoeff = ddot_(nconf1,rout,1,W(ipCI)%A,1)/rC_HE_C

      !                          -1
      ! rout = rout-rocoeff*(H -E) |0>
      !                       0
      call ipin(ipdia)
      call exphinvv(W(ipdia)%A,W(ipci)%A,rOUT,One,-rcoeff)
      call opout(ipCI)
    else
      call NEGP(ipdia,ipSigma,rout)
    end if

  end if

  rout(:) = Half*rout(:)

else

  call ipin(ipsigma)
  rout(:) = W(ipSigma)%A(:)

end if

end subroutine DMinvCI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ijkl_inc(i,j,k,l)
      Integer i,j,k,l
      l = l + 1
      If ( i.eq.k.and.l.le.j) Return
      If ( i.ne.k.and.l.le.k) Return
      l = 1
      k = k +1
      If (k.le.i) Return
      k = 1
      j = j + 1
      If (j.le.i) Return
      j=1
      i=i+1
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

! Wrapper for the OpenMolcas PrgmTranslate_Mod routine, so it works
! without using the module (i.e., from C). Some C-to-Fortran conversion
! needs to be done, which feels quite hackish.

#include "compiler_features.h"
#include "intent.fh"
#ifndef _HAVE_EXTRA_
#define MAXSTR 1024

subroutine PrgmTranslateC(InStr,l1,OutStr,l2,Par) bind(C,name='prgmtranslatec_')

use, intrinsic :: iso_c_binding, only: c_char, c_null_char
use Prgm, only: PrgmTranslate_Mod
use Definitions, only: iwp, MOLCAS_C_INT

implicit none
character(kind=c_char), intent(in) :: InStr(*)
integer(kind=MOLCAS_C_INT), intent(in) :: l1, Par
character(kind=c_char), intent(_OUT_) :: OutStr(*)
integer(kind=MOLCAS_C_INT), intent(out) :: l2
character(len=MAXSTR) :: TmpStr, TmpStr2
integer(kind=iwp) :: i

TmpStr = ''
do i=1,l1
  TmpStr(i:i) = InStr(i)
end do
call PrgmTranslate_Mod(TmpStr,l1,TmpStr2,l2,Par)
do i=1,l2
  OutStr(i) = TmpStr2(i:i)
end do
OutStr(l2+1:l2+1) = c_null_char

end subroutine PrgmTranslateC

#elif !defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(PrgmTranslateC)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
************************************************************************
*                                                                      *
*  Integer Function NbfShl    returns # of bf for shell,symmetry       *
*                                                                      *
************************************************************************
c----------------------------------------------------------------------
      Integer Function nbfshl(iSkal,irp)
      use iSD_data
      use SOAO_Info, only: iAOtSO
c----------------------------------------------------------------------
      Implicit Real*8 (A-H,O-Z)
*
*  returns number of basis functions for given shell and symmetry
*
      nbfshl=0
      iAO    = iSD( 7,iSkal)
      iCmp   = iSD( 2,iSkal)
*     loop over components of shell...
      Do i=1, iCmp
         If (iAOtSO(iAO+i,irp)>0) nbfshl = nbfshl + iSD(3,iSkal)
      End Do

      return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FrzDel(NREMO,IREMO,EOCC,E1,
     *                  NREME,IREME,EEXT,E2,
     *                  CMO,CMO1,ISEQ)
C
C     MOLPT2(MOLCAS) SUBROUTINE
C     CODED AJS, MAR. 15, 1990
C
C     THIS SUBROUTINE IS USED TO MOVE THE ADDITIONALLY FROZEN AND
C     ADDITIONALLY DELETED ORBITALS TO THE BOTTOM OR TO THE TOP
C     RESPECTIVELY, OF THE EIGENVECTOR LIST. THE ORBITAL ENERGIES='PRIN'
C     ARE REARRANGED ACCORDINGLY
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "mxdim.fh"
#include "corbinf.fh"
#include "orbinf2.fh"
#include "files_mbpt2.fh"
C
      DIMENSION NREMO(*),IREMO(8,*),EOCC(*),E1(*)
      DIMENSION NREME(*),IREME(8,*),EEXT(*),E2(*)
      DIMENSION CMO(*),CMO1(*),ISEQ(*)
C
C
      IAD0=1
      IADR=1
      IEO=0
      IENO=0
      IENE=0
      IEE=0
      DO 100 ISYM=1,NSYM
        IADF=IADR
        IADO=IADF+NBAS(ISYM)*(NFRO(ISYM)+NREMO(ISYM))
        IADE=IADF+NBAS(ISYM)*(NFRO(ISYM)+NOCC(ISYM))
        IADD=IADF+NBAS(ISYM)*(NBAS(ISYM)-NDEL(ISYM)-NREME(ISYM))
        DO 1 I=1,NBAS(ISYM)
          ISEQ(I)=I
1       CONTINUE
        DO 2 I=1,NFRO(ISYM)
          ISEQ(I)=0
2       CONTINUE
        DO 3 I=NBAS(ISYM),NBAS(ISYM)-NDEL(ISYM)+1,-1
          ISEQ(I)=0
3       CONTINUE
        DO 4 I=1,NREMO(ISYM)
           J=IREMO(ISYM,I)
           ISEQ(J)=0
4       CONTINUE
        DO 5 I=1,NREME(ISYM)
           J=IREME(ISYM,I)+NFRO(ISYM)+NOCC(ISYM)
           ISEQ(J)=0
5       CONTINUE
C
        DO 10 I=1,NFRO(ISYM)+NOCC(ISYM)
          IAD=IAD0+(I-1)*NBAS(ISYM)
          IF (ISEQ(I).EQ.0) THEN
*           frozen, move to appropriate place in symmetry block
*           observe the sequence: frozen/occupied/external/deleted
            CALL DCOPY_(NBAS(ISYM),CMO1(IAD),1,CMO(IADF),1)
            IADF=IADF+NBAS(ISYM)
          ELSE
*           occupied...
            CALL DCOPY_(NBAS(ISYM),CMO1(IAD),1,CMO(IADO),1)
            IADO=IADO+NBAS(ISYM)
            IENO=IENO+1
            EOCC(IENO)=E1(IEO+I-NFRO(ISYM))
          ENDIF
10      CONTINUE
        DO 20 I=NFRO(ISYM)+NOCC(ISYM)+1,NBAS(ISYM)
          IAD=IAD0+(I-1)*NBAS(ISYM)
          IF (ISEQ(I).EQ.0) THEN
*           delete, move to appropriate place in symmetry block
*           observe the sequence: frozen/occupied/external/deleted
            CALL DCOPY_(NBAS(ISYM),CMO1(IAD),1,CMO(IADD),1)
            IADD=IADD+NBAS(ISYM)
          ELSE
*           external...
            CALL DCOPY_(NBAS(ISYM),CMO1(IAD),1,CMO(IADE),1)
            IADE=IADE+NBAS(ISYM)
            IENE=IENE+1
            EEXT(IENE)=E2(IEE+I-NFRO(ISYM)-NOCC(ISYM))
          ENDIF
20      CONTINUE
        IADR=IADR+NBAS(ISYM)**2
        IAD0=IADR
        IEO=IEO+NOCC(ISYM)
        IEE=IEE+NEXT(ISYM)
C
C       UPDATE NFRO, NOCC, NEXT, NDEL, AND NORB
C
        NFRO(ISYM)=NFRO(ISYM)+NREMO(ISYM)
        NOCC(ISYM)=NOCC(ISYM)-NREMO(ISYM)
        NDEL(ISYM)=NDEL(ISYM)+NREME(ISYM)
        NEXT(ISYM)=NEXT(ISYM)-NREME(ISYM)
        NORB(ISYM)=NBAS(ISYM)-NFRO(ISYM)-NDEL(ISYM)
100   CONTINUE
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRCNFTAB(LTAB,MXPRT)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
      CHARACTER*144 TEXT

C Sanity test:
      NPRT=MIN(MXPRT,10000)
C header:
      NTAB =IWORK(LTAB+ 0)
      ITYPE=IWORK(LTAB+ 1)
      NEL  =IWORK(LTAB+ 2)
      NORB =IWORK(LTAB+ 3)
      MINOP=IWORK(LTAB+ 4)
      MAXOP=IWORK(LTAB+ 5)
      NSYM =IWORK(LTAB+ 6)
      LSYM =IWORK(LTAB+ 7)
      NGAS =IWORK(LTAB+ 8)
      IFORM=IWORK(LTAB+ 9)
      WRITE(6,*)'---------------------------------------------------'
      WRITE(6,*)'       Configuration Table Printout'
      WRITE(6,'(1x,a,i16)')' Table address          LTAB=',LTAB
      WRITE(6,*)' Table header:'
      WRITE(6,'(1x,a,i16)')' Table size             NTAB=',NTAB
      WRITE(6,'(1x,a,i16)')' Nr of electrons         NEL=',NEL
      WRITE(6,'(1x,a,i16)')' Nr of orbitals         NORB=',NORB
      WRITE(6,'(1x,a,i16)')' Min nr of open shells MINOP=',MINOP
      WRITE(6,'(1x,a,i16)')' Max nr of open shells MAXOP=',MAXOP
      WRITE(6,'(1x,a,i16)')' Point group order      NSYM=',NSYM
      WRITE(6,'(1x,a,i16)')' Selected symmetry      LSYM=',LSYM
      WRITE(6,'(1x,a,i16)')' Nr of GAS restrictions NGAS=',NGAS
      WRITE(6,'(1x,a,i16)')' Configuration format  IFORM=',IFORM
      IF(ITYPE.NE.37) THEN
        WRITE(6,*)' PRCNFTAB error: This is not a configuration table!'
        CALL ABEND()
      END IF
      IERR=0
      IF(NEL  .LT. 0) IERR=IERR+1
      IF(NEL  .GT.99) IERR=IERR+1
      IF(NORB .LT. 0) IERR=IERR+1
      IF(NORB .GT.199) IERR=IERR+1
      IF(MINOP.LT. 0) IERR=IERR+1
      IF(MAXOP.LT.MINOP) IERR=IERR+1
      IF(NSYM .LT. 1) IERR=IERR+1
      IF(NSYM .GT. 8) IERR=IERR+1
      IF(LSYM .LT. 0) IERR=IERR+1
      IF(LSYM .GT.NSYM) IERR=IERR+1
      IF(NGAS .LT. 0) IERR=IERR+1
      IF(NGAS .GT.19) IERR=IERR+1
      IF(IFORM.LT.1) IERR=IERR+1
      IF(IFORM.GT.4) IERR=IERR+1
      IF(IERR.GT.0) THEN
        WRITE(6,*)' PRCNFTAB error: Those values are unacceptable!'
        CALL ABEND()
      END IF
      LGASORB=LTAB+10
      LGASLIM=LGASORB+(NSYM+1)*(NGAS+1)
      IF(NGAS.GT.0) THEN
        WRITE(6,*)
        WRITE(6,*)' Orbitals by symmetry in GAS partitions:'
        WRITE(6,'(A,8I5)')' Space       Tot     ',(ISYM,ISYM=1,NSYM)
        WRITE(6,'(1X,A,5X,I5,5X,8I5)')'Active',
     &          IWORK(LGASORB),(IWORK(LGASORB+ISYM),ISYM=1,NSYM)
        DO IGAS=1,NGAS
         WRITE(6,'(1X,A,I2,5X,I5,5X,8I5)')'GAS',IGAS,
     &          IWORK(LGASORB     +(NSYM+1)*IGAS),
     &         (IWORK(LGASORB+ISYM+(NSYM+1)*IGAS),ISYM=1,NSYM)
        END DO
        WRITE(6,*)' GAS orbital partitions, min and max population:'
        DO IGAS=1,NGAS
         ISUM=IWORK(LGASORB+(NSYM+1)*IGAS)
         LIM1=IWORK(LGASLIM  +2*(IGAS-1))
         LIM2=IWORK(LGASLIM+1+2*(IGAS-1))
         WRITE(6,'(1X,A,I2,5X,3I5)')'GAS',IGAS,ISUM,LIM1,LIM2
        END DO
      END IF
      LINFO=LGASLIM+2*NGAS
      WRITE(6,*)
      WRITE(6,*)' INFO table starts at LINFO=',LINFO
      WRITE(6,*)'    i.e. KINFO=',LINFO+1-LTAB
      DO NOPN=MINOP,MAXOP
       NCLS=(NEL-NOPN)/2
       DO ISYM=1,NSYM
        NCNF=IWORK(LINFO+0+3*(ISYM-1+NSYM*(NOPN-MINOP)))
        KCNFSTA=IWORK(LINFO+1+3*(ISYM-1+NSYM*(NOPN-MINOP)))
        LENCNF=IWORK(LINFO+2+3*(ISYM-1+NSYM*(NOPN-MINOP)))
        IF(NCNF.NE.0) THEN
         WRITE(6,*)
         WRITE(6,*)'  NOPN ISYM       Nr of conf Start point'//
     &             '  Words/config'
         WRITE(6,'(1X,2I4,5X,3I12)') NOPN,ISYM,NCNF,KCNFSTA,LENCNF
         IF(NCNF.GT.NPRT) THEN
           WRITE(6,'(1X,A,I5)')
     &             ' The first NPRT configurations. NPRT=',NPRT
         ELSE
           WRITE(6,*)' Configurations:'
         END IF
         KSTA=KCNFSTA
         DO ICNF=1,MIN(NCNF,NPRT)
           CALL CNF2TXT(IFORM,NORB,NCLS,NOPN,IWORK(LTAB-1+KSTA),
     &                  LENGTH,TEXT)
           KSTA=KSTA+LENCNF
           IF(LENGTH.LE.72) THEN
            WRITE(6,'(8X,A)')TEXT(1:LENGTH)
           ELSE
            WRITE(6,'(8X,A)')TEXT(1:72)
            WRITE(6,'(8X,A)')TEXT(73:LENGTH)
           END IF
         END DO
         IF(NCNF.GT.NPRT) THEN
           WRITE(6,*)' ( ...and more. This list was truncated.)'
         END IF
        END IF
       END DO
      END DO
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
! Subroutine for calculation of spectroscopic constants for
! diatomic molecules from the raw vibrational term values
! obtained in Vibrot. A least square fit to these data is used
!
! ********** MOLCAS-Release 91 05 01 **********

subroutine Spectc(Req,E0,Atom1,Atom2,nE)

use Vibrot_globals, only: J1A, J2A, Vibwvs, iadrsp
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Three, Half, OneHalf, auTocm, auToeV, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Req, E0
character(len=2), intent(in) :: Atom1, Atom2
integer(kind=iwp), intent(in) :: nE
real(kind=wp) :: ChkSum, B1, B2, A11, A12, A22, Xj, Xj1, Xj2, Xj3, Xj4, Xd, Det, xnv, xnv2, xnv3, xnv4, dc, diff, Tvjc, Tvjnv, &
                 tmax, bc, X(3), A(3,3), G(3)
real(kind=wp) :: alphae, betae, gammae, dele, be, we, wexe, weye, Re, dE, d0
real(kind=wp), allocatable :: T(:,:), Tvj(:,:), F(:), Fc(:), dF(:), B(:), D(:), Gv(:), GV2(:)
integer(kind=iwp) :: nv, i, j, k, ind, jst, jend, jrng, jind(5)

ChkSum = Zero

call mma_allocate(Tvj,[1,nE],[J1A,J2A],label='Tvj')

do j=J1A,J2A
  call DDafile(Vibwvs,2,Tvj(:,j),nE,iadrsp(j-J1A+1))
end do

! Compute rotaional constants B and D for each vibrational band

if (J2A-J1A < 3) then
  write(u6,*) 'SPECTC Error: J2A-J1A < 3'
  write(u6,*) ' SPECTC requires a range of rotational quanta'
  write(u6,*) ' in order to fit spectroscopic constants.'
  write(u6,*) ' The upper and lower limits of J must differ by'
  write(u6,*) '  at least 3.'
  write(u6,'(1x,a,2i6)') 'J2A,J1A:',J2A,J1A
  call Abend()
end if
call mma_allocate(F,[J1A+1,J2A],label='F')
call mma_allocate(Fc,[J1A+1,J2A],label='Fc')
call mma_allocate(dF,[J1A+1,J2A],label='dF')
call mma_allocate(B,nE,label='B')
call mma_allocate(D,nE,label='D')
do nv=1,nE
  ! Term values for this band
  do j=J1A+1,J2A
    F(j) = Tvj(nv,j)-Tvj(nv,J1A)
    F(j) = F(j)*auTocm
  end do
  B1 = Zero
  B2 = Zero
  A11 = Zero
  A12 = Zero
  A22 = Zero
  do j=J1A+1,J2A
    Xj1 = j*(j+1)-J1A*(J1A+1)
    Xj2 = Xj1**2
    Xj3 = Xj1**3
    Xj4 = Xj2**2
    B1 = B1+F(j)*Xj1
    B2 = B2-F(j)*Xj2
    A11 = A11+Xj2
    A12 = A12+Xj3
    A22 = A22+Xj4
  end do

  Xd = A12/A22
  Det = A11-Xd*A12
  B(nv) = (B1+B2*Xd)/Det
  D(nv) = (B2*A11/A22+B1*Xd)/Det
  do j=J1A+1,J2A
    Xj = j*(j+1)-J1A*(J1A+1)
    Fc(j) = B(nv)*Xj-D(nv)*Xj**2
    dF(j) = F(j)-Fc(j)
  end do
  write(u6,990) nv-1,B(nv),D(nv)
  do j=J1A+1,J2A
    write(u6,991) j,F(j),Fc(j),dF(j)
  end do
end do
write(u6,992)
do nv=1,nE
  write(u6,991) nv,B(nv),D(nv)
end do
call mma_deallocate(F)
call mma_deallocate(Fc)
call mma_deallocate(dF)

! Compute spectroscopic constants de (dele) and betae
! by a least square fit

dele = Zero
betae = Zero
if (nE == 1) then
  de = d(1)
else
  A11 = nE
  B1 = Zero
  B2 = Zero
  A12 = Zero
  A22 = Zero
  do nv=1,nE
    xnv = nv-Half
    B1 = B1+D(nv)
    B2 = B2+D(nv)*xnv
    A12 = A12+xnv
    A22 = A22+xnv**2
  end do
  Det = A11*A22-A12*A12
  dele = (B1*A22-B2*A12)/Det
  betae = (B2*A11-B1*A12)/Det
end if
write(u6,994) dele,betae
do nv=1,nE
  dc = dele+betae*(nv-Half)
  diff = D(nv)-dc
  write(u6,991) nv-1,D(nv),dc,diff
end do

call mma_deallocate(D)

! Spectroscopic constants Be,Alphe, and Gammae from rotational
! constants B(nv)

X(:) = Zero
if (nE == 1) then
  X(1) = B(1)
else if (nE == 2) then
  X(1) = OneHalf*B(1)-Half*B(2)
  X(2) = B(2)-B(1)
else
  G(:) = Zero
  A(:,:) = Zero
  A(1,1) = nE
  do nv=1,nE
    xnv = nv-Half
    xnv2 = xnv**2
    xnv3 = xnv**3
    xnv4 = xnv2**2
    G(1) = G(1)+B(nv)
    G(2) = G(2)+B(nv)*xnv
    G(3) = G(3)+B(nv)*xnv2
    A(1,2) = A(1,2)+xnv
    A(1,3) = A(1,3)+xnv2
    A(2,3) = A(2,3)+xnv3
    A(3,3) = A(3,3)+xnv4
  end do
  A(2,1) = A(1,2)
  A(2,2) = A(1,3)
  A(3,1) = A(1,3)
  A(3,2) = A(2,3)
  call dminv(3,3,A)
  do i=1,3
    X(i) = Zero
    do k=1,3
      X(i) = X(i)+A(i,k)*G(k)
    end do
  end do
end if
be = X(1)
alphae = -X(2)
gammae = X(3)
write(u6,995) be,alphae,gammae
do nv=1,nE
  bc = be-alphae*(nv-Half)+gammae*(nv-Half)**2
  diff = B(nv)-bc
  write(u6,991) nv-1,B(nv),bc,diff
end do

call mma_deallocate(B)

! vibrational constants we,wexe and weye from band origins

X(:) = Zero
if (nE == 1) then
  X(1) = Two*Tvj(1,J1A)
else if (nE == 2) then
  X(1) = Three*Tvj(1,J1A)-Tvj(2,J1A)/Three
  x(2) = Two*Tvj(2,J1A)/Three-Two*Tvj(1,J1A)
else
  G(:) = Zero
  A(:,:) = Zero
  do nv=1,nE
    xnv = nv-Half
    xnv2 = xnv**2
    xnv3 = xnv**3
    G(1) = G(1)+Tvj(nv,J1A)*xnv
    G(2) = G(2)+Tvj(nv,J1A)*xnv2
    G(3) = G(3)+Tvj(nv,J1A)*xnv3
    A(1,1) = A(1,1)+xnv2
    A(1,2) = A(1,2)+xnv3
    A(1,3) = A(1,3)+xnv2**2
    A(2,3) = A(2,3)+xnv2*xnv3
    A(3,3) = A(3,3)+xnv3**2
  end do
  A(2,1) = A(1,2)
  A(2,2) = A(1,3)
  A(3,1) = A(1,3)
  A(3,2) = A(2,3)
  call dminv(3,3,a)
  do i=1,3
    X(i) = Zero
    do k=1,3
      X(i) = X(i)+A(i,k)*G(k)
    end do
  end do
end if
we = X(1)*auTocm
wexe = X(2)*auTocm
weye = X(3)*auTocm
write(u6,996) we,wexe,weye
do nv=1,nE
  xnv = nv-Half
  Tvjc = we*xnv+wexe*xnv**2+weye*xnv**3
  Tvjnv = auTocm*Tvj(nv,J1A)
  diff = Tvjnv-Tvjc
  write(u6,991) nv-1,Tvjnv,Tvjc,diff
end do

! print output of spectroscopic constants

write(u6,1000) Atom1,Atom2
write(u6,1100) J1A,J2A,0,nE-1

Re = Req*Angstrom
dE = -E0*auToeV
d0 = dE-Tvj(1,J1A)*auToeV

write(u6,1200) Re,dE,d0,we,wexe,weye,be,alphae,gammae,dele,betae
ChkSum = ChkSum+we+wexe

! compute term values for check

call mma_allocate(T,[1,nE],[J1A,J2A],label='T')

ind = 0
do j=J1A,J2A
  Xj = j*(j+1)
  do nv=1,nE
    ind = ind+1
    xnv = nv-Half
    T(nv,j) = we*xnv+wexe*xnv**2+weye*xnv**3+xj*(be-alphae*xnv+gammae*xnv**2)-xj**2*(dele+betae*xnv)
  end do
end do

! compute max deviation

tmax = Zero
do j=J1A,J2A
  do nv=1,nE
    Tvj(nv,j) = Tvj(nv,j)*auTocm
    diff = abs(T(nv,j)-Tvj(nv,j))
    if (diff >= tmax) tmax = diff
  end do
end do
ChkSum = ChkSum+tmax
write(u6,1300) tmax

! print output of term values

write(u6,1400)
jst = J1A
do
  jend = jst+size(jind)-1
  if (jend > J2A) jend = J2A
  jrng = jend-jst+1
  do i=1,jrng
    jind(i) = jst+i-1
  end do
  write(u6,1500) jind(1:jrng)
  write(u6,1510)
  do nv=1,nE
    write(u6,1600) nv-1,(Tvj(nv,j),T(nv,j),j=jst,jend)
  end do
  jst = jend+1
  if (jend >= J2A) exit
end do

! observed g-values (Tvj for j=0)

call mma_allocate(Gv,nE,label='Gv')
call mma_allocate(Gv2,nE-1,label='Gv')

do i=1,nE
  Gv(i) = Tvj(i,J1A)
  ChkSum = ChkSum+Gv(i)
end do

! compute delta g(v+1/2) values

do i=1,nE-1
  Gv2(i) = Gv(i+1)-Gv(i)
end do

! print Gv and Gv2

write(u6,1700)
do i=1,nE-1
  write(u6,1800) i-1,Gv(i)
  write(u6,1810) Gv2(i)
end do
write(u6,1800) nE-1,Gv(nE)

call mma_deallocate(Gv)
call mma_deallocate(Gv2)
call mma_deallocate(T)

call mma_deallocate(Tvj)

call Add_Info('VIBROT_SPECTC',[ChkSum],1,2)
!write(u6,*) 'Spectc: ChkSum',ChkSum

return

990 format(/5x,'Rotational constants for vibrational quantum number',i3 &
           /5x,'B=',e13.6,' cm-1     D=',e13.6,' cm-1' &
           /5x,'Observed and computed term values (cm-1)')
991 format(5x,i3,3e20.6)
992 format(/5x,'Rotational constants B(nv) and D(nv) in cm-1')
994 format(/5x,'Spectroscopic constants De=',e13.6,' cm-1  Betae=',e13.6,' cm-1' &
           /5x,'Observed and computed D values')
995 format(/5x,'Spectroscopic constants Be,Alphae and Gammae' &
           /5x,'Be=',e13.6,' cm-1    Alphae=',e13.6,' cm-1    Gammae=',e13.6 &
           /5x,'Observed and computed B values')
996 format(/5x,'Vibrational constants we  =',e13.6,' cm-1' &
           /5x,'                      wexe=',e13.6,' cm-1' &
           /5x,'                      weye=',e13.6,' cm-1' &
           /5x,'Observed and computed band origins')
1000 format(//5x,'Spectroscopic constants for ',2a2)
1100 format(//5x,'Range of J-values used in fit',2i3, &
            /5x,'Range of v-values used in fit',2i3)
1200 format(///5x,'Re(a)',15x,f8.4, &
            /5x,'De(ev)',14x,f8.4, &
            /5x,'D0(ev)',14x,f8.4, &
            /5x,'we(cm-1)',7x,e13.6, &
            /5x,'wexe(cm-1)',5x,e13.6, &
            /5x,'weye(cm-1)',5x,e13.6, &
            /5x,'Be(cm-1)',7x,e13.6, &
            /5x,'Alphae(cm-1)',3x,e13.6, &
            /5x,'Gammae(cm-1)',3x,e13.6, &
            /5x,'Dele(cm-1)',5x,e13.6, &
            /5x,'Betae(cm-1)',4x,e13.6)
1300 format(//5x,'Max deviation in term values is',e10.2,' cm(-1)')
1400 format(//5x,'Term values(observed and computed) in cm(-1)')
1500 format(/1x,'J-value',7x,i3,19x,i3,19x,i3,19x,i3,19x,i3)
1510 format(/1x,'v-value')
1600 format(4x,i2,2x,5(f8.2,2x,f8.2,4x))
1700 format(//5x,'observed G-values in cm(-1)' &
            //5x,'v',6x,'G(v)',5x,'deltaG(v+1/2)')
1800 format(4x,i2,f11.2)
1810 format(17x,f13.2)

end subroutine Spectc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE DIIS_CPF(DPI,DPJ,BST,MIT,BIJ,ITP,CN)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DPI(*),DPJ(*),BST(MIT,MIT),BIJ(ITP,ITP),
     *CN(*),WHS(50)
#include "SysDef.fh"
#include "cpfmcpf.fh"
#include "files_cpf.fh"
*
      IF(ITPUL.EQ.1)GO TO 26
C
      ITM=ITPUL-1
      DO 5 I=1,ITM
         DO 10 J=1,ITM
            BIJ(J,I)=BST(J,I)
10       CONTINUE
5     CONTINUE
      DO 15 I=1,ITPUL
         BIJ(ITP,I)=-1.0D0
         BIJ(I,ITP)=-1.0D0
15    CONTINUE
      BIJ(ITP,ITP)=0.0D0
C
      DO 20 I=1,ITM
         IAD=IADDP(I+1)
         CALL dDAFILE(Lu_CI,2,DPJ,NCONF,IAD)
         T=DDOT_(NCONF,DPI,1,DPJ,1)
         BIJ(I,ITPUL)=T
         BIJ(ITPUL,I)=T
         BST(I,ITPUL)=T
         BST(ITPUL,I)=T
         IF(I.EQ.1) THEN
            T=DDOT_(NCONF,DPJ,1,DPJ,1)
            BIJ(1,1)=T
            BST(1,1)=T
         END IF
20    CONTINUE
      BIJ(ITPUL,ITPUL)=DDOT_(NCONF,DPI,1,DPI,1)
      BST(ITPUL,ITPUL)=BIJ(ITPUL,ITPUL)
C
      IF(IPRINT.LT.10)GO TO 26
      DO 17 I=1,ITP
      WRITE(6,16)(BIJ(J,I),J=1,ITP)
      CALL XFLUSH(6)
16    FORMAT(6X,'BIJ ',6F12.6)
17    CONTINUE
C
26    IF(IDIIS.EQ.1)GO TO 25
      DO 7 I=1,ITPUL
         IAD=IADDP(I)
         CALL dDAFILE(Lu_CI,2,DPJ,NCONF,IAD)
         DO 6 J=1,NCONF
            DPI(J)=DPI(J)+DPJ(J)
6        CONTINUE
7     CONTINUE
      IF(IPRINT.GE.15)WRITE(6,14)(DPI(I),I=1,NCONF)
14    FORMAT(6X,'C(DIIS)',5F10.6)
      RETURN
C
25    CALL DECOMP(ITP,BIJ,BIJ)
      DO 55 I=1,ITPUL
      WHS(I)=0.0D00
55    CONTINUE
      WHS(ITP)=-1.0D00
      CALL SOLVE(ITP,BIJ,WHS,CN)
C
C     UPDATE P AND DELTA P
C
      CALL NEXT(DPI,DPJ,CN)
C
      ITPUL=0
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function PIKNAM(LINED,KEYW)
! picks a character item up from a line like
! ITEM_NAME  value  COMMENTS
!
! returns ' ' when it fails to pick the item up.
!
!   LINED        input line to be searched
!   KEYW         keyword

use Definitions, only: iwp

implicit none
character(len=40) :: PIKNAM
character(len=80), intent(in) :: LINED
character(len=40), intent(in) :: KEYW
character(len=80) LINE
integer(kind=iwp) :: I, IK, IL, ISTRT, LK, LL
logical(kind=iwp) :: FOUND

IK = 0
LL = 0
IL = 0

LINE = LINED
LK = 1
do I=40,1,-1
  if (KEYW(I:I) /= ' ') then
    LK = I
    exit
  end if
end do
do I=1,40
  if (KEYW(I:I) /= ' ') then
    IK = I
    exit
  end if
end do

ISTRT = index(LINE,KEYW(IK:LK))
if (ISTRT == 0) then
  ! the keyword has not been found in the line.
  PIKNAM = ' '
  return
end if
ISTRT = ISTRT+LK-IK+1
if (LINE(ISTRT:ISTRT) /= ' ') then
  ! the keyword is not followed by a blank character.
  PIKNAM = ' '
  return
else if (ISTRT >= 80) then
  ! the line finishes after the keyword.
  PIKNAM = ' '
  return
else
  ISTRT = ISTRT+1
end if

FOUND = .false.
do I=ISTRT,80
  if (FOUND) then
    if (LINE(I:I) == ' ') then
      LL = I-1
      exit
    end if
  else
    if (LINE(I:I) /= ' ') then
      FOUND = .true.
      IL = I
    end if
  end if
end do

if (FOUND) then
  PIKNAM = LINE(IL:LL)
  write(LINE,601) LK,LL-IL+1
  !write(u6,LINE) KEYW(:LK),PIKNAM
else
  PIKNAM = ' '
end if

return

601 format("(' PIKNAM:         ',A",I2.2,',1X,A',I2.2,')')

end function PIKNAM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Put_ln(In_Line)
!***********************************************************************
! This function replaces function getln                                *
!                                                                      *
! It reads, broadcasts, and parses an input line                       *
!                                                                      *
! Blank lines or lines containing star (*) in column 1 are skipped     *
! Lines staring with exclaimation (!) in column 1 are skipped          *
!                                                                      *
! After this routine has been called, data can be retrieved using      *
! the subroutines                                                      *
!                                                                      *
!   Get_F(icol,array,n)  (for floating point values)                   *
!   Get_I(icol,iarry,n)  (for integer values)                          *
!   Get_S(icol,strgs,n)  (for character strings)                       *
!                                                                      *
! where icol is the first non-blank work to be taken, and n is the     *
! number of data.                                                      *
!                                                                      *
!***********************************************************************

use getline_mod, only: iEnd, iStrt, Line, nCol
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: In_line
integer(kind=iwp) :: i, icom, j, l

Line = In_Line
l = len(line)
do i=1,l
  if (ichar(line(i:i)) == 9) line(i:i) = ' '
  if (line(i:i) == ';') line(i:l) = ' '
end do
ncol = 0
j = 1
do
  icom = 0
  do i=j,l
    if (line(i:i) == ',') then
      icom = icom+1
      if (icom /= 1) exit
    else
      if (line(i:i) /= ' ') exit
    end if
  end do
  if (i > l) exit

  do j=i,l
    if ((line(j:j) == ' ') .or. (line(j:j) == ',')) exit
  end do
  ncol = ncol+1
  istrt(ncol) = i
  iend(ncol) = j-1
end do

end subroutine Put_ln

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Drvetc(ngrad)
************************************************************************
*                                                                      *
* Object: driver for computation of gradients of one-electron matrices.*
*                                                                      *
* Called from: Mckinley                                                *
*                                                                      *
* Calling    :                                                         *
*              GetMem                                                  *
*              Cnt1El2                                                 *
*                                                                      *
*             Written by Anders Bernhardsson for electric field        *
*             Gradients                                                *
*             October  97                                              *
************************************************************************
      use Basis_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External ElGrd,elgrddot
      External ElMem
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "disp.fh"
      Character*8 Lbl
      Real*8 Ccoor(3)
      Real*8, Allocatable:: D0(:)

      iRc=-1
      iOpt=1
      nDens = 0
      Do iIrrep = 0, nIrrep - 1
         nDens = nDens + nBas(iIrrep)*(nBas(iIrrep)+1)/2
      End Do
      Call mma_Allocate(D0,nDens,Label='D0')
      Call Get_D1ao_Var(D0,nDens)
*     Write(*,*) Ddot_(ndens,D0,1,D0,1)
      call dcopy_(3,[0.0d0],0,CCOOR,1)
      ncomp=1
      loper=0
      Call GetMem('ELEGRD','ALLO','REAL',ipEG,3*ngrad)
      Call Dot1El2(ElGrddot,ElMem,Work(ipEG),3*nGrad,
     &                 .true.,CCoor,D0,1)
      CALL DSCAL_(3*ngrad,-1.0d0,Work(ipEG),1)
      Call mma_deallocate(D0)
      Call GetMem('TEMP','ALLO','Real',ipTemp,3*ngrad)
      Call GetMem('TEMP','CHEC','Real',ipTemp,3*ngrad)
      call dcopy_(3*ngrad,[0.0d0],0,Work(ipTemp),1)
      Call Drvel1(Work(ipTemp))
      Call DaXpY_(3*ngrad,1.0d0,Work(ipTemp),1,Work(ipEG),1)
      Lbl='NUCELGR'
      idum=1
      iopt=128
      irc=3*ngrad
      Call dWrMCk(irc,iopt,LBL,idum,Work(ipTemp),idum)
      if(irc.ne.0)
     & Call SysAbendMsg('drvect','error during write in dwrmck',' ')
      idum=1
      iopt=128
      irc=3*ngrad
      Lbl='DOTELGR'
      Call dWrMCk(irc,iopt,LBL,idum,Work(ipEG),idum)
      if (irc.ne.0)
     & Call SysAbendMsg('drvect','error during write in dwrmck',' ')
      Call GetMem('ELGR','FREE','REAL',ipeg,3*ngrad)
      Call GetMem('TEMP','FREE','Real',ipTemp,3*ngrad)
* needed in RASSI
      Do iCar=1,3
      isym=irrfnc(2**(icar-1))! nropr(ichbas(1+iCar))
      Write(Lbl,'(a,i2)') 'ELEC ',iCar
      idcnt=0
      Do iCnttp=1,nCnttp
        Do iCnt=1,dbsc(iCnttp)%nCntr
          idcnt=idcnt+1
          Do idCar=1,3
            Call Cnt1El2(ELGRD,ELMEM,Lbl,idcnt,idcar,loper,
     &               1.0d0,.true.,
     &               lbl,0,isym,icar,1)
          End Do
        End Do
      End Do
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine FAIBJ_CPF(JSY,INDX,C,S,ABIJ,AIBJ,AJBI,BUFIN,A,B,F,FSEC,ENP,EPP)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use cpf_global, only: IRC, IREF0, IROW, ITER, LASTAD, LBUF, LN, LSYM, Lu_CIGuga, Lu_TiABIJ, NDIAG, NSM, NSYM, NVIR, NVIRT, SQ2
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, r8, RtoI

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JSY(*), INDX(*)
real(kind=wp), intent(inout) :: C(*), S(*), ABIJ(*), AIBJ(*), AJBI(*), FSEC(*), EPP(*)
real(kind=wp), intent(_OUT_) :: BUFIN(*), A(*), B(*), F(*)
real(kind=wp), intent(in) :: ENP(*)
integer(kind=iwp) :: IAB, IADD10, IADR, IBSYM, ICHK, ICOUP, ICOUP1, ICSYM, IFAB, IFT, IFTA, IFTB, IIN, IJ1, ILEN, ILIM, IND, INDA, &
                     INDB, INDI, INMY, INNY, INS, INUM, IPF, IPF1, IPOA(9), IPOB(9), IPOF(9), ISTAR, ITURN, ITYP, JTURN, LBUF0, &
                     LBUF1, LBUF2, LENGTH, MYL, MYSYM, NAC, NBC, NI, NJ, NOT2, NOVST, NSIJ, NVT, NYL, NYSYM
real(kind=wp) :: COPI, CPL, CPLA, CPLL, FAC, TERM
logical(kind=iwp) :: Skip
integer(kind=iwp), external :: JSUNP
real(kind=r8), external :: DDOT_

call FAIBJ_CPF_INTERNAL(BUFIN)

! This is to allow type punning without an explicit interface
contains

subroutine FAIBJ_CPF_INTERNAL(BUFIN)

  real(kind=wp), target, intent(_OUT_) :: BUFIN(*)
  integer(kind=iwp), pointer :: IBUFIN(:)
  integer(kind=iwp) :: IASYM, II

  call c_f_pointer(c_loc(BUFIN),iBUFIN,[1])

  ITYP = 0 ! dummy initialize
  ICOUP = 0 ! dummy initialize
  ICOUP1 = 0 ! dummy initialize
  INUM = IRC(4)-IRC(3)
  call PSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)
  NVT = IROW(NVIRT+1)
  ICHK = 0
  IFAB = 0
  NOVST = LN*NVIRT+1+NVT
  LBUF0 = RTOI*LBUF
  LBUF1 = LBUF0+LBUF+1
  LBUF2 = LBUF1+1
  NOT2 = IROW(LN+1)
  IADD10 = IAD10(6)
  do
    call dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
    call iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
    ILEN = ICOP1(nCOP+1)
    if (ILEN == 0) cycle
    if (ILEN < 0) exit
    do II=1,ILEN
      IND = ICOP1(II)
      if (ICHK == 0) then
        if (IND /= 0) then
          if (IFAB /= 1) then
            IFAB = ibits(IND,0,1)
            ITURN = ibits(IND,1,1)
            ITYP = ibits(IND,2,3)
            ICOUP = ibits(IND,5,13)
            ICOUP1 = ibits(IND,18,13)
            CPL = COP(II)
            CPLA = Zero
            if (IFAB /= 0) cycle
            if (ITURN == 0) then
              ! FIRST ORDER INTERACTION
              INDA = ICOUP
              INDB = IRC(ITYP+1)+ICOUP1
              ISTAR = 1
              if (ITYP == 1) ISTAR = INS+1
              if (INS /= 0) then
                if (INDA == IREF0) then
                  CPLL = CPL/sqrt(ENP(INDB))
                  S(INDX(INDB)+1:INDX(INDB)+INS) = S(INDX(INDB)+1:INDX(INDB)+INS)+CPLL*FSEC(ISTAR:ISTAR+INS-1)
                  if (ITER /= 1) then
                    TERM = DDOT_(INS,C(INDX(INDB)+1),1,FSEC(ISTAR),1)
                    EPP(INDB) = EPP(INDB)+CPLL*TERM
                  end if
                else
                  COPI = CPL*C(INDA)
                  S(INDX(INDB)+1:INDX(INDB)+INS) = S(INDX(INDB)+1:INDX(INDB)+INS)+COPI*FSEC(ISTAR:ISTAR+INS-1)
                  TERM = DDOT_(INS,FSEC(ISTAR),1,C(INDX(INDB)+1),1)
                  S(INDA) = S(INDA)+CPL*TERM
                end if
              end if
              cycle
            end if
          else
            CPLA = COP(II)
            IFAB = 0
          end if
          ! INTERACTIONS BETWEEN DOUBLES AND
          ! INTERACTIONS BETWEEN SINGLES
          if (ITER == 1) cycle
          !call JTIME(IST)
          IFTA = 0
          IFTB = 0
          select case (ITYP)
            case default !(1)
              INDA = IRC(2)+ICOUP1
              INDB = IRC(2)+ICOUP
              IFTA = 1
              IFTB = 1
            case (2)
              INDA = IRC(3)+ICOUP1
              INDB = IRC(3)+ICOUP
            case (3)
              INDA = IRC(2)+ICOUP1
              INDB = IRC(3)+ICOUP
              IFTA = 1
            case (4)
              INDA = IRC(3)+ICOUP1
              INDB = IRC(2)+ICOUP
              IFTB = 1
            case (5)
              INDA = IRC(1)+ICOUP1
              INDB = IRC(1)+ICOUP
          end select
          MYSYM = JSUNP(JSY,INDA)

          NYSYM = MUL(MYSYM,NSIJ)
          MYL = MUL(MYSYM,LSYM)
          NYL = MUL(NYSYM,LSYM)
          call IPO_CPF(IPOA,NVIR,MUL,NSYM,MYL,IFTA)
          call IPO_CPF(IPOB,NVIR,MUL,NSYM,NYL,IFTB)
          INMY = INDX(INDA)+1
          INNY = INDX(INDB)+1
          if (ITYP == 5) then
            ! DOUBLET-DOUBLET INTERACTIONS
            IIN = IPOF(MYL+1)-IPOF(MYL)
            if (IIN /= 0) then
              IPF = IPOF(MYL)
              F(1:IIN) = CPL*AIBJ(IPF+1:IPF+IIN)+CPLA*ABIJ(IPF+1:IPF+IIN)
              if (INDA == INDB) call DCOPY_(NVIR(MYL),[Zero],0,F,NVIR(MYL)+1)
              call FMMM(C(INMY),F,A,1,NVIR(NYL),NVIR(MYL))
              S(INNY:INNY+NVIR(NYL)-1) = S(INNY:INNY+NVIR(NYL)-1)+A(1:NVIR(NYL))
              if (INDA /= INDB) then
                call FMMM(F,C(INNY),A,NVIR(MYL),1,NVIR(NYL))
                S(INMY:INMY+NVIR(MYL)-1) = S(INMY:INMY+NVIR(MYL)-1)+A(1:NVIR(MYL))
              end if
            end if
          else
            ! TRIPLET-SINGLET , SINGLET-TRIPLET ,
            ! TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
            do IASYM=1,NSYM
              IAB = IPOF(IASYM+1)-IPOF(IASYM)
              if (IAB == 0) cycle
              ICSYM = MUL(MYL,IASYM)
              IBSYM = MUL(NYL,ICSYM)
              if ((INDA == INDB) .and. (IBSYM > IASYM)) cycle
              if (NVIR(ICSYM) == 0) cycle
              NAC = NVIR(IASYM)*NVIR(ICSYM)
              NBC = NVIR(IBSYM)*NVIR(ICSYM)
              if (IASYM > ICSYM) then
                if (IBSYM > ICSYM) then
                  ! CASE 1 , IASYM > ICSYM AND IBSYM > ICSYM
                  IPF = IPOF(IASYM)
                  F(1:IAB) = CPL*AIBJ(IPF+1:IPF+IAB)+CPLA*ABIJ(IPF+1:IPF+IAB)
                  if (INDA == INDB) call DCOPY_(NVIR(IASYM),[Zero],0,F,NVIR(IASYM)+1)
                  call FMMM(C(INMY+IPOA(IASYM)),F,A,NVIR(ICSYM),NVIR(IBSYM),NVIR(IASYM))
                  S(INNY+IPOB(IBSYM):INNY+IPOB(IBSYM)+NBC-1) = S(INNY+IPOB(IBSYM):INNY+IPOB(IBSYM)+NBC-1)+A(1:NBC)
                  if (INDA /= INDB) then
                    IPF = IPOF(IBSYM)
                    F(1:IAB) = CPL*AJBI(IPF+1:IPF+IAB)+CPLA*ABIJ(IPF+1:IPF+IAB)
                    call FMMM(C(INNY+IPOB(IBSYM)),F,A,NVIR(ICSYM),NVIR(IASYM),NVIR(IBSYM))
                    S(INMY+IPOA(IASYM):INMY+IPOA(IASYM)+NAC-1) = S(INMY+IPOA(IASYM):INMY+IPOA(IASYM)+NAC-1)+A(1:NAC)
                  end if
                else
                  ! CASE 2 , IASYM > ICSYM AND ICSYM > OR = IBSYM
                  IPF = IPOF(IBSYM)
                  F(1:IAB) = CPL*AJBI(IPF+1:IPF+IAB)+CPLA*ABIJ(IPF+1:IPF+IAB)
                  call MTRANS(C(INMY+IPOA(IASYM)),A,NVIR(IASYM),NVIR(ICSYM))
                  call FMMM(F,A,B,NVIR(IBSYM),NVIR(ICSYM),NVIR(IASYM))
                  if (NYL == 1) then
                    A(1:NBC) = B(1:NBC)
                    if (IFTB /= 1) then
                      call SIADD(A,S(INNY+IPOB(ICSYM)),NVIR(IBSYM))
                      A(1:NBC) = Zero
                      call SQUAR(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM))
                    else
                      call TRADD(A,S(INNY+IPOB(ICSYM)),NVIR(IBSYM))
                      A(1:NBC) = Zero
                      call SQUARN(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM))
                    end if
                  else
                    if (IFTB /= 1) then
                      S(INNY+IPOB(ICSYM):INNY+IPOB(ICSYM)+NBC-1) = S(INNY+IPOB(ICSYM):INNY+IPOB(ICSYM)+NBC-1)+B(1:NBC)
                    else
                      S(INNY+IPOB(ICSYM):INNY+IPOB(ICSYM)+NBC-1) = S(INNY+IPOB(ICSYM):INNY+IPOB(ICSYM)+NBC-1)-B(1:NBC)
                    end if
                    call MTRANS(C(INNY+IPOB(ICSYM)),A,NVIR(ICSYM),NVIR(IBSYM))
                    if (IFTB == 1) A(1:NBC) = -A(1:NBC)
                  end if
                  call FMMM(A,F,B,NVIR(ICSYM),NVIR(IASYM),NVIR(IBSYM))
                  S(INMY+IPOA(IASYM):INMY+IPOA(IASYM)+NAC-1) = S(INMY+IPOA(IASYM):INMY+IPOA(IASYM)+NAC-1)+B(1:NAC)
                end if
              else
                if (IBSYM > ICSYM) then
                  ! CASE 3 , ICSYM > OR = IASYM AND IBSYM > ICSYM
                  IPF = IPOF(IASYM)
                  F(1:IAB) = CPL*AIBJ(IPF+1:IPF+IAB)+CPLA*ABIJ(IPF+1:IPF+IAB)
                  if (MYL == 1) then
                    if (IFTA == 0) call SQUAR(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
                    if (IFTA == 1) call SQUARN(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
                  else
                    call MTRANS(C(INMY+IPOA(ICSYM)),A,NVIR(ICSYM),NVIR(IASYM))
                    if (IFTA == 1) A(1:NAC) = -A(1:NAC)
                  end if
                  call FMMM(A,F,B,NVIR(ICSYM),NVIR(IBSYM),NVIR(IASYM))
                  S(INNY+IPOB(IBSYM):INNY+IPOB(IBSYM)+NBC-1) = S(INNY+IPOB(IBSYM):INNY+IPOB(IBSYM)+NBC-1)+B(1:NBC)
                  call MTRANS(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM),NVIR(ICSYM))
                  call FMMM(F,A,B,NVIR(IASYM),NVIR(ICSYM),NVIR(IBSYM))
                  if (MYL == 1) then
                    A(1:NAC) = B(1:NAC)
                    if (IFTA /= 1) then
                      call SIADD(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
                    else
                      call TRADD(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
                    end if
                    A(1:NAC) = Zero
                  else if (IFTA /= 1) then
                    S(INMY+IPOA(ICSYM):INMY+IPOA(ICSYM)+NAC-1) = S(INMY+IPOA(ICSYM):INMY+IPOA(ICSYM)+NAC-1)+B(1:NAC)
                  else
                    S(INMY+IPOA(ICSYM):INMY+IPOA(ICSYM)+NAC-1) = S(INMY+IPOA(ICSYM):INMY+IPOA(ICSYM)+NAC-1)-B(1:NAC)
                  end if
                else
                  ! CASE 4 , ICSYM > OR = IASYM AND ICSYM > OR = IBSYM
                  IPF = IPOF(IBSYM)
                  F(1:IAB) = CPL*AJBI(IPF+1:IPF+IAB)+CPLA*ABIJ(IPF+1:IPF+IAB)
                  if (INDA == INDB) call DCOPY_(NVIR(IASYM),[Zero],0,F,NVIR(IASYM)+1)
                  if (MYL == 1) then
                    if (IFTA == 0) call SQUAR(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
                    if (IFTA == 1) call SQUARM(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
                  else
                    if (IFTA == 0) call DCOPY_(NAC,C(INMY+IPOA(ICSYM)),1,A,1)
                    if (IFTA == 1) call VNEG(NAC,C(INMY+IPOA(ICSYM)),1,A,1)
                  end if
                  call FMMM(F,A,B,NVIR(IBSYM),NVIR(ICSYM),NVIR(IASYM))
                  if (NYL == 1) then
                    A(1:NBC) = B(1:NBC)
                    if (IFTB /= 1) then
                      call SIADD(A,S(INNY+IPOB(ICSYM)),NVIR(IBSYM))
                    else
                      call TRADD(A,S(INNY+IPOB(ICSYM)),NVIR(IBSYM))
                    end if
                    A(1:NBC) = Zero
                  else if (IFTB /= 1) then
                    S(INNY+IPOB(ICSYM):INNY+IPOB(ICSYM)+NBC-1) = S(INNY+IPOB(ICSYM):INNY+IPOB(ICSYM)+NBC-1)+B(1:NBC)
                  else
                    S(INNY+IPOB(ICSYM):INNY+IPOB(ICSYM)+NBC-1) = S(INNY+IPOB(ICSYM):INNY+IPOB(ICSYM)+NBC-1)-B(1:NBC)
                  end if
                  if (INDA /= INDB) then
                    IPF = IPOF(IASYM)
                    F(1:IAB) = CPL*AIBJ(IPF+1:IPF+IAB)+CPLA*ABIJ(IPF+1:IPF+IAB)
                    if (NYL == 1) then
                      if (IFTB == 0) call SQUAR(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM))
                      if (IFTB == 1) call SQUARM(C(INNY+IPOB(IBSYM)),A,NVIR(IBSYM))
                    else
                      if (IFTB == 0) call DCOPY_(NBC,C(INNY+IPOB(ICSYM)),1,A,1)
                      if (IFTB == 1) call VNEG(NBC,C(INNY+IPOB(ICSYM)),1,A,1)
                    end if
                    call FMMM(F,A,B,NVIR(IASYM),NVIR(ICSYM),NVIR(IBSYM))
                    if (MYL == 1) then
                      A(1:NAC) = B(1:NAC)
                      if (IFTA /= 1) then
                        call SIADD(A,S(INMY+IPOA(ICSYM)),NVIR(IASYM))
                      else
                        call TRADD(A,S(INMY+IPOA(ICSYM)),NVIR(IASYM))
                      end if
                      !A(1:NAC) = Zero
                    else if (IFTA /= 1) then
                      S(INMY+IPOA(ICSYM):INMY+IPOA(ICSYM)+NAC-1) = S(INMY+IPOA(ICSYM):INMY+IPOA(ICSYM)+NAC-1)+B(1:NAC)
                    else
                      S(INMY+IPOA(ICSYM):INMY+IPOA(ICSYM)+NAC-1) = S(INMY+IPOA(ICSYM):INMY+IPOA(ICSYM)+NAC-1)-B(1:NAC)
                    end if
                  end if
                end if
              end if
            end do
          end if
        else
          ICHK = 1
        end if
      else
        ICHK = 0
        INDI = IND
        NI = ibits(INDI,0,10)
        NJ = ibits(INDI,10,10)
        NSIJ = MUL(NSM(NI),NSM(NJ))
        call IPO_CPF(IPOF,NVIR,MUL,NSYM,NSIJ,-1)
        IJ1 = IROW(NI)+NJ
        ILIM = IPOF(NSYM+1)
        ABIJ(1:ILIM) = Zero
        AIBJ(1:ILIM) = Zero
        AJBI(1:ILIM) = Zero
        if (ITER == 1) then
          Skip = .true.
        else
          ! READ (AB/IJ) INTEGRALS
          IADR = LASTAD(NOVST+IJ1)
          JTURN = 0
          Skip = .false.
        end if
        do
          if (Skip) then
            Skip = .false.
          else
            call iDAFILE(Lu_TiABIJ,2,IBUFIN,LBUF2,IADR)
            LENGTH = IBUFIN(LBUF1)
            IADR = IBUFIN(LBUF2)
            if (LENGTH /= 0) then
              if (JTURN /= 1) then
                call SCATTER(LENGTH,ABIJ,IBUFIN(LBUF0+1:LBUF0+LENGTH),BUFIN)
              else
                call SCATTER(LENGTH,AIBJ,IBUFIN(LBUF0+1:LBUF0+LENGTH),BUFIN)
              end if
            end if
            if (IADR /= -1) cycle
            if (JTURN == 1) exit
          end if
          ! READ (AI/BJ) INTEGRALS
          IADR = LASTAD(NOVST+NOT2+IJ1)
          JTURN = 1
        end do
        ! CONSTRUCT FIRST ORDER MATRICES
        FAC = Half
        if (NI /= NJ) FAC = One
        IIN = 0
        IFT = 0
        call IPO_CPF(IPOA,NVIR,MUL,NSYM,NSIJ,IFT)
        do
          do IASYM=1,NSYM
            IBSYM = MUL(NSIJ,IASYM)
            if (IBSYM > IASYM) cycle
            IAB = IPOA(IASYM+1)-IPOA(IASYM)
            if (IAB == 0) cycle
            call SECORD(AIBJ(IPOF(IASYM)+1),AIBJ(IPOF(IBSYM)+1),FSEC(IIN+1),FAC,NVIR(IASYM),NVIR(IBSYM),NSIJ,IFT)
            IIN = IIN+IAB
          end do
          if (IFT == 1) exit
          INS = IIN
          IFT = 1
          FAC = Zero
        end do
        ! SQUARE ABIJ
        if (ITER /= 1) then
          do IASYM=1,NSYM
            if (NVIR(IASYM) == 0) cycle
            IBSYM = MUL(NSIJ,IASYM)
            if (NVIR(IBSYM) == 0) cycle
            IPF = IPOF(IASYM)+1
            IPF1 = IPOF(IBSYM)+1
            if (IASYM <= IBSYM) then
              if (NSIJ == 1) then
                call SQUAR2(ABIJ(IPF),NVIR(IASYM))
                if (NI == NJ) call SQUAR2(AIBJ(IPF),NVIR(IASYM))
                call MTRANS(AIBJ(IPF),AJBI(IPF),NVIR(IASYM),NVIR(IBSYM))
              else
                call MTRANS(ABIJ(IPF1),ABIJ(IPF),NVIR(IASYM),NVIR(IBSYM))
                call MTRANS(AIBJ(IPF1),AJBI(IPF),NVIR(IASYM),NVIR(IBSYM))
              end if
            else
              call MTRANS(AIBJ(IPF1),AJBI(IPF),NVIR(IASYM),NVIR(IBSYM))
            end if
          end do
        end if
      end if
    end do
  end do
  call DSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)

  nullify(IBUFIN)

  return

end subroutine FAIBJ_CPF_INTERNAL

end subroutine FAIBJ_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SIGMA(SGM,AREF,CI,INTSY,INDX,BMN,IBMN,BIAC2,
     &              BICA2,BFIN3,ISAB,AC1,AC2,BFIN4,ABIJ,
     &              AIBJ,AJBI,ASCR1,BSCR1,FSCR1,FSEC,FOCK,
*PAM04     &              BFIN5,ASCR2,BSCR2,FSCR2,DBK,CSPCK)
     &              BFIN5,ASCR2,BSCR2,FSCR2,DBK,ICSPCK)
      IMPLICIT REAL*8 (A-H,O-Z)
*PAM04      Integer INTSY(*),INDX(*),IBMN(*),ISAB(*)
      Integer INTSY(*),INDX(*),IBMN(*),ISAB(*),ICSPCK(*)
      Real*8 SGM(*),AREF(*),CI(*),BMN(*),BIAC2(*),BICA2(*)
      Real*8 BFIN3(*),AC1(*),AC2(*),BFIN4(*),ABIJ(*)
      Real*8 AIBJ(*),AJBI(*),ASCR1(*),BSCR1(*),FSCR1(*)
      Real*8 FSEC(*),FOCK(*),BFIN5(*),ASCR2(*),BSCR2(*),FSCR2(*)
*PAM04      Real*8 DBK(*),CSPCK(*)
      Real*8 DBK(*)
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "mrci.fh"
      CALL DCOPY_(NCONF,[0.0D0],0,SGM,1)

      CALL CSFTRA(' CSF',CI,AREF)
      SQGP=1.0D00
      SQG =1.0D00
      IF(ICPF.EQ.1) THEN
        SQGP=SQRT(GFAC)
        SQG=1.0D00/SQGP
        DO IREF=1,NREF
          ICSF=IREFX(IREF)
           CI(ICSF)=SQGP*CI(ICSF)
        END DO
      END IF

      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      CALL DIAGC(INTSY,CI,SGM)
      IF(IFIRST.EQ.0 .AND. ((IREST.EQ.1).OR.(ITER.GT.1)) ) THEN
        CALL ABCI_MRCI(INTSY,INDX,CI,SGM,BMN,IBMN,BIAC2,BICA2,BFIN3)
        CALL ABCD_MRCI(INTSY,INDX,ISAB,CI,SGM,AC1,AC2,BFIN4)
      END IF
*PAM04      CALL IJKL(INTSY,INDX,CI,SGM,FIJKL)
      CALL IJKL(INTSY,INDX,CI,SGM,WORK(LFIJKL))
c
*PAM04      CALL FAIBJ(INTSY,INDX,CI,SGM,ABIJ,AIBJ,AJBI,BFIN1,BFIN1,
*PAM04     &           ASCR1,BSCR1,FSCR1,FSEC)
      CALL FAIBJ(INTSY,INDX,CI,SGM,ABIJ,AIBJ,AJBI,
     &           ASCR1,BSCR1,FSCR1,FSEC)

      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      IF(ITER.GT.0) THEN
        KTYP=1
* Switch KTYP=1 means AI is actually handling AIJK integrals.
*PAM04        CALL AI(INTSY,INDX,CI,SGM,FOCK,BFIN5,BFIN5,ASCR2,BSCR2,
*PAM04     &          FSCR2,DBK,KTYP)
        CALL AI_MRCI(INTSY,INDX,CI,SGM,FOCK,ASCR2,BSCR2,FSCR2,DBK,KTYP)
      END IF
*PAM04      CALL FIJ(CSPCK,INTSY,INDX,CI,SGM,FOCK,ASCR2,BSCR2,FSCR2,DBK)
      CALL FIJ_MRCI(ICSPCK,INTSY,INDX,CI,SGM,FOCK,ASCR2,BSCR2,FSCR2,DBK)

      CALL DAXPY_(NCONF,POTNUC-ESHIFT,CI,1,SGM,1)
      IF(ICPF.EQ.1) THEN
        GINV=1.0D00/GFAC
        CALL DSCAL_(NCONF,GINV,SGM,1)
        DO IREF=1,NREF
          ICSF=IREFX(IREF)
           CI(ICSF)=SQG*CI(ICSF)
           SGM(ICSF)=SQGP*SGM(ICSF)
        END DO
      END IF

      CALL CSFTRA('MCSF',SGM,AREF)

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_real_array(BFIN5)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine STEPVECTOR_NEXT(MV,IDWN,IUP,STEPVECTOR)

use Definitions, only: iwp, u6

implicit none
#include "gugx.fh"
#include "WrkSpc.fh"
integer(kind=iwp), intent(inout) :: MV, IDWN, IUP
integer(kind=iwp), intent(out) :: STEPVECTOR(NLEV)

! stop when MV is zero
if (MV == 0) then
  write(u6,'(1X,A)') 'stepvector_next has been depleted'
end if

call GETSTEPVECTOR(IWORK(LNOW),IWORK(LIOW),MV,IDWN,IUP,STEPVECTOR)

end subroutine STEPVECTOR_NEXT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Markus P. Fuelscher                              *
*               1999, Roland Lindh                                     *
************************************************************************
      subroutine Motra(ireturn)
************************************************************************
*                                                                      *
*     Objective: AO to MO integral transformation                      *
*                                                                      *
*     Modify one-electron integrals to use dynamic memory allocation.  *
*     R. Lindh, March 1999.                                            *
*                                                                      *
***** M.P. Fuelscher, University of Lund, Sweden, 1991 *****************

      !> module dependencies
#ifdef _HDF5_QCM_
      use hdf5_utils
#endif

#include "motra_global.fh"
#include "trafo_motra.fh"
#include "WrkSpc.fh"
      COMMON / CHO_Minp / iCTonly, iDoInt
      Character*3  tv2disk
      COMMON / CHOTRAW /tv2disk
      Logical DoCholesky, Do_int
*----------------------------------------------------------------------*
*     Start program and say Hello                                      *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*     ( Dynamic work area has been allocated in Start() )              *
*----------------------------------------------------------------------*
*      Call IniMem
*----------------------------------------------------------------------*
*     Run through the input section                                    *
*----------------------------------------------------------------------*
      Call init_motra
      If (iPrintLevel(-1).LE.0) iPrint=-1
      Call InpCtl_Motra(ipOvlp,ipHOne,ipKine,ipCMO)

      !> initialize HDF5 interface
#ifdef _HDF5_QCM_
      if(ihdf5 == 1)then
        !> enable HDF5 support and open the file ijklname
        call hdf5_init()
        call hdf5_create(ijklname, file_id(1))
      end if
#endif

*----------------------------------------------------------------------*
* --- Cholesky check
      Call DecideOnCholesky(DoCholesky)
*----------------------------------------------------------------------*
* --- Use of MOTRA only for AO-->MO transf of the Cholesky vectors
      If (iCTonly.eq.1) Then
         If (.not.DoCholesky) Then
            write(6,*)'      Warning! This is not RI/CD calculation: '
            write(6,*)'                      keyword CTonly ignored! '
         Else
#ifdef _HDF5_QCM_
            If ((ihdf5.eq.1).and.(tv2disk.ne.'KPQ')) Then
              Write(6,*)' Transformed Cholesky vectors cannot be '//
     &          ' written as (pq,K) in HDF5 file as of now. Activate'//
     &          ' the KPQ option to store them or disable'//
     &          ' the HDF5 option.'
              Call Abend()
            End If
#endif
            write(6,*)
            write(6,*)'      ... Skipping MoTRA of ERIs ...'
            write(6,*)
            write(6,*)'      ... but Cholesky vectors will be MoTRA.'
            write(6,*)
!           Cholesky vectors in HDF5 must be stored as KPQ format (for now)
            Do_int=.false.
            If (iDoInt.eq.1) Do_int=.true.
            Call Cho_MOtra(Work(ipCMO),nTot2,Do_int,ihdf5)
            iOneOnly=666
            Go To 100  ! nothing else to be done except OneEl part
         EndIf
      EndIf
*----------------------------------------------------------------------*
* --- Preliminary step for integral transformation with CD
      If (DoCholesky) Then
         CALL CWTIME(TCR1,TWR1)
         Call Cho_X_init(irc,0.0)
         If (irc.ne.0) Then
           write(6,*) ' In MoTRA : Cho_X_Init returned non-zero'//
     &                ' rc = ',irc
           Call Abend()
         EndIf
         Call Cho_X_ReoVec(irc) ! get (if not there) CD vecs full stor
         If (irc.ne.0) Then
           write(6,*) ' In MoTRA : Cho_X_ReoVec returned non-zero'//
     &                ' rc = ',irc
           Call Abend()
         EndIf
         Call Cho_X_final(irc)
         CALL CWTIME(TCR2,TWR2)
         tcpu_reo=(TCR2-TCR1)
         twal_reo=(TWR2-TWR1)
         write(6,*)
         write(6,*)'      Reordering Cholesky vectors to full storage.'
         write(6,*)'       Elapsed time for the reordering : ',tcpu_reo
         write(6,*)'       CPU time for the reordering     : ',tcpu_reo
         write(6,*)
      EndIf


*----------------------------------------------------------------------*
*     Transform the one-electron integrals                             *
*----------------------------------------------------------------------*
100   Continue
      Call Tr1Ctl(Work(ipOvlp),Work(ipHOne),Work(ipKine),Work(ipCMO))
      If ( iOneOnly.ne.0 ) Goto 900
*----------------------------------------------------------------------*
*     Transform the two-electron integrals                             *
*----------------------------------------------------------------------*
      Call Tr2Ctl(Work(ipCMO))
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*     Normal termination                                               *
*----------------------------------------------------------------------*
 900  Continue
      write(6,*)
      Call GetMem('CMO','Free','Real',ipCMO,nTot2)
      Call GetMem('Kine','Free','Real',ipKine,nTot1+4)
      Call GetMem('HOne','Free','Real',ipHOne,nTot1+4)
      Call GetMem('Ovlp','Free','Real',ipOvlp,nTot1+4)
*
#ifdef _HDF5_QCM_
      if(ihdf5 == 1)then
        !> close the file ijkl.h5 and turn off HDF5 support.
        call hdf5_close(file_id(1))
        call hdf5_exit()
      end if
#endif

      Call FastIO('STATUS')
      ireturn=0
      return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NSTRSO_GAS(NEL,NORB1,NORB2,NORB3,NELMN1,NELMX1,NELMN3,NELMX3,IOC,NSTASO,ISTASO,NSMST,IOTYP)
! Number of strings per symmetry for group IOTYP
!
! Gas version, no check of type : set to 1
!
! Jeppe Olsen Winter of 1994

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NEL, NORB1, NORB2, NORB3, NELMN1, NELMX1, NELMN3, NELMX3, NSMST, IOTYP
integer(kind=iwp), intent(out) :: IOC(NEL)
integer(kind=iwp), intent(inout) :: NSTASO(NSMST,IOTYP), ISTASO(NSMST,IOTYP)
integer(kind=iwp) :: i, IEL1, IEL2, IEL3, IFRST1, IFRST2, IFRST3, IORB1F, IORB1L, IORB2F, IORB2L, IORB3F, IORB3L, ISM, ISYM, &
                     NONEW1, NONEW2, NONEW3, NSTRIN
integer(kind=iwp), external :: ISYMST

NSTASO(:,IOTYP) = 0
NSTRIN = 0
IORB1F = 1
IORB1L = IORB1F+NORB1-1
IORB2F = IORB1L+1
IORB2L = IORB2F+NORB2-1
IORB3F = IORB2L+1
IORB3L = IORB3F+NORB3-1
! Loop over possible partitionings between RAS1,RAS2,RAS3
do IEL1=NELMX1,NELMN1,-1
  outer: do IEL3=NELMN3,NELMX3,1
    if (IEL1 > NORB1) exit outer
    if (IEL3 > NORB3) cycle outer
    IEL2 = NEL-IEL1-IEL3
    if ((IEL2 < 0) .or. (IEL2 > NORB2)) cycle outer
    IFRST1 = 1
    ! Loop over RAS 1 occupancies
    ras1: do
      if (IEL1 /= 0) then
        if (IFRST1 == 1) then
          IOC(1:IEL1) = [(i,i=1,IEL1)]
          IFRST1 = 0
        else
          call NXTORD(IOC,IEL1,IORB1F,IORB1L,NONEW1)
          if (NONEW1 == 1) cycle outer
        end if
      end if
#     ifdef _DEBUGPRINT_
      write(u6,*) ' RAS 1 string'
      call IWRTMA(IOC,1,IEL1,1,IEL1)
#     endif
      IFRST2 = 1
      IFRST3 = 1
      ! Loop over RAS 2 occupancies
      ras2: do
        if (IEL2 /= 0) then
          if (IFRST2 == 1) then
            IOC(IEL1+1:IEL1+IEL2) = [(i,i=IORB2F,IORB2F+IEL2-1)]
            IFRST2 = 0
          else
            call NXTORD(IOC(IEL1+1),IEL2,IORB2F,IORB2L,NONEW2)
            if (NONEW2 == 1) then
              if (IEL1 /= 0) cycle ras1
              if (IEL1 == 0) cycle outer
            end if
          end if
        end if
#       ifdef _DEBUGPRINT_
        write(u6,*) ' RAS 1 2 string'
        call IWRTMA(IOC,1,IEL1+IEL2,1,IEL1+IEL2)
#       endif
        IFRST3 = 1
        ! Loop over RAS 3 occupancies
        ras3: do
          if (IEL3 /= 0) then
            if (IFRST3 == 1) then
              IOC(IEL1+IEL2+1:IEL1+IEL2+IEL3) = [(i,i=IORB3F,IORB3F+IEL3-1)]
              IFRST3 = 0
            else
              call NXTORD(IOC(IEL1+IEL2+1),IEL3,IORB3F,IORB3L,NONEW3)
              if (NONEW3 == 1) then
                if (IEL2 /= 0) cycle ras2
                if (IEL1 /= 0) cycle ras1
                cycle outer
              end if
            end if
          end if
#         ifdef _DEBUGPRINT_
          write(u6,*) ' RAS 1 2 3 string'
          call IWRTMA(IOC,1,NEL,1,NEL)
#         endif
          ! Next string has been constructed, enlist it !
          NSTRIN = NSTRIN+1
          ! Symmetry of string
          ISYM = ISYMST(IOC,NEL)
          !      ISYMST(STRING,NEL)
          ! occupation type of string
          !OLD ITYP = IOCTP2(IOC,NEL,IOTYP)
          !           IOCTP2(STRING,NEL)

          NSTASO(ISYM,IOTYP) = NSTASO(ISYM,IOTYP)+1

          if (IEL3 == 0) exit ras3
        end do ras3
        if ((IEL3 /= 0) .or. (IEL2 == 0)) exit ras2
      end do ras2
      if ((IEL3 /= 0) .or. (IEL2 /= 0) .or. (IEL1 == 0)) exit ras1
    end do ras1
  end do outer
end do

! The corresponding offset

do ISM=1,NSMST
  if (ISM == 1) then
    ISTASO(ISM,IOTYP) = 1
  else
    ISTASO(ISM,IOTYP) = ISTASO(ISM-1,IOTYP)+NSTASO(ISM-1,IOTYP)
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Number of strings generated   ',NSTRIN
write(u6,*)
write(u6,*) ' Number of strings per sym for group = ',IOTYP
write(u6,*) '================================================'
call IWRTMA(NSTASO(:,IOTYP),1,NSMST,1,NSMST)
write(u6,*) ' Offset for given symmetry for group = ',IOTYP
write(u6,*) '================================================'
call IWRTMA(ISTASO(:,IOTYP),1,NSMST,1,NSMST)
#endif

end subroutine NSTRSO_GAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine RdCmo()

use Genano_globals, only: kSet, nSym, nBas, kRfSet, isUHF, wSet, Ssym, Cmo, Occ, Cmo2, Occ2, Eps, lftdeg, rydgen, LenIn, BasName
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), parameter :: log1e3 = log(1.0e3_wp)
integer(kind=iwp) :: i, iDummy(1), iErr, indx, iOrb, irc, iSym, iSymOne, iWFtype, Lu_, Lu_One, nCmo, nDim
real(kind=wp) :: Dummy(1), eps0, eta
character(len=6) :: OneInt, NatOrb, RunFile
character(len=72) :: line

if (isUHF == 1) then
  call dCopy_(size(Cmo2),Cmo2,1,Cmo,1)
  call dCopy_(size(Occ2),Occ2,1,Occ,1)
  return
end if
!-----------------------------------------------------------------------
iSymOne = 1
kSet = kSet+1
OneInt = 'ONE'
NatOrb = 'NAT'
RunFile = 'RUN'
write(OneInt(4:6),'(i3.3)') kSet
write(NatOrb(4:6),'(i3.3)') kSet
write(RunFile(4:6),'(i3.3)') kSet
call NameRun(RunFile)
!-----------------------------------------------------------------------
write(u6,*)
write(u6,*) '--------------------------------------------------'
write(u6,*)
write(u6,'(a,i3,a,f7.3)') ' Adding density matrix',kSet,' with weight',wSet(kSet)
write(u6,*)
write(u6,*) 'Reading one-el. file: ',OneInt
Lu_One = 2
call OpnOne(irc,0,OneInt,Lu_One)
call get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)
nDim = 0
nCmo = 0
do iSym=1,nSym
  nDim = nDim+nBas(iSym)
  nCmo = nCmo+nBas(iSym)**2
end do
if (allocated(BasName)) call mma_deallocate(BasName)
call mma_allocate(BasName,nDim,label='BaName')
call Get_cArray('Unique Basis Names',BasName,len(BasName)*nDim)
call ClsOne(irc,0)
write(u6,'(a,i5)') ' nSym:',nSym
write(u6,'(a,8i5)') ' nBas:',(nBas(i),i=1,nSym)
!write(u6,'(a,1x,a)') (BasName(1,i),BasName(2,i),i=1,nDim)
!-----------------------------------------------------------------------
! hack to fix Roland's inconsistent labels
do i=1,nDim
  if (BasName(i)(LenIn+3:LenIn+3) == 's') BasName(i)(LenIn+1:LenIn+3) = '01s'
  if (BasName(i)(LenIn+3:LenIn+3) == 'p') BasName(i)(LenIn+1:LenIn+3) = '02p'
  if (BasName(i)(LenIn+3:LenIn+3) == 'd') BasName(i)(LenIn+1:LenIn+3) = '03d'
  if (BasName(i)(LenIn+3:LenIn+3) == 'f') BasName(i)(LenIn+1:LenIn+3) = '04f'
  if (BasName(i)(LenIn+3:LenIn+3) == 'g') BasName(i)(LenIn+1:LenIn+3) = '05g'
  if (BasName(i)(LenIn+3:LenIn+3) == 'h') BasName(i)(LenIn+1:LenIn+3) = '06h'
  if (BasName(i)(LenIn+3:LenIn+3) == 'i') BasName(i)(LenIn+1:LenIn+3) = '07i'
  if (BasName(i)(LenIn+3:LenIn+3) == 'k') BasName(i)(LenIn+1:LenIn+3) = '08k'
end do
!write(u6,'(a,1x,a)') (BasName(1,i),BasName(2,i),i=1,nDim)
!-----------------------------------------------------------------------
if (kSet == 1) then
  call Init_GenANO()
else
  call Check_genano()
end if
!-----------------------------------------------------------------------
if (kSet == kRfSet) then
  Lu_One = 2
  call OpnOne(irc,0,OneInt,Lu_One)
  if (allocated(Cmo)) call mma_deallocate(Cmo)
  call mma_allocate(Cmo,nCmo,label='Cmo')
  call RdOne(irc,6,'Mltpl  0',1,Cmo,iSymOne)
  call CpOvlp(Cmo,Ssym)
  call ClsOne(irc,0)
end if
!-----------------------------------------------------------------------
write(u6,*)
write(u6,*) 'Reading orbital file: ',NatOrb
Lu_ = 17
call chk_vec_UHF(NatOrb,Lu_,isUHF)
if (allocated(Occ)) call mma_deallocate(Occ)
call mma_allocate(Occ,nDim,label='Occ')
if (allocated(Eps)) call mma_deallocate(Eps)
call mma_allocate(Eps,nDim,label='Eps')
Eps(:) = Zero
if (isUHF == 1) then
  if (allocated(Cmo2)) call mma_deallocate(Cmo2)
  call mma_allocate(Cmo2,nCmo,label='Cmo2')
  if (allocated(Occ2)) call mma_deallocate(Occ2)
  call mma_allocate(Occ2,nDim,label='Occ2')
  call RdVec_(NatOrb,Lu_,'CO',1,nSym,nBas,nBas,Cmo,Cmo2,Occ,Occ2,Dummy,Dummy,iDummy,line,0,iErr,iWFtype)
  write(u6,'(a)') '***'
  write(u6,'(a)') '*** rdcmo: fix reading of eps for uhf!!!'
  write(u6,'(a)') '***'
else
  call RdVec(NatOrb,Lu_,'COE',nSym,nBas,nBas,Cmo,Occ,Eps,iDummy,line,0,iErr)
end if
write(u6,*) 'Orbital set: ',trim(line)
!-----------------------------------------------------------------------
if (lftdeg) then
  indx = 1
  do iSym=1,nSym
    do iOrb=1,nBas(iSym)
      Occ(indx) = (1.001_wp/iOrb)*Occ(indx)
      indx = indx+1
    end do
  end do
end if
!-----------------------------------------------------------------------
if (rydgen) then
  call RdVec(NatOrb,Lu_,'COE',nSym,nBas,nBas,Cmo,Occ,Eps,iDummy,line,0,iErr)
  eps0 = huge(eps0)
  indx = 1
  do iSym=1,nSym
    do iOrb=1,nBas(iSym)
      if (Occ(indx) < 1.0e-2_wp) then
        eps0 = min(eps0,Eps(indx))
      end if
      indx = indx+1
    end do
  end do
  !write(u6,'(a,f12.6)') 'eps0',eps0
  indx = 1
  do iSym=1,nSym
    do iOrb=1,nBas(iSym)
      if (Occ(indx) > 1.0e-2_wp) then
        Occ(indx) = Zero
      else if (Eps(indx) < Zero) then
        eta = exp(log1e3*(Eps(indx)/eps0-One))
        !write(u6,'(a,2f12.6)') 'eps/eta',eps(indx),eta
        Occ(indx) = eta
      else
        Occ(indx) = Zero
      end if
      indx = indx+1
    end do
  end do
end if
!-----------------------------------------------------------------------
call NameRun('#Pop')

return

end subroutine RdCmo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Cho_GetLQ(QVec,l_QVec,LstQSP,nQSP)
!
! Purpose: extract elements corresponding to qualified columns from
!          the Cholesky vectors in buffer and/or on disk.

use Cholesky, only: nQual, nSym, NumCho, nVec_in_Buf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: l_QVec, nQSP, LstQSP(nQSP)
real(kind=wp), target, intent(out) :: QVec(l_Qvec)
integer(kind=iwp) :: iSym, iV1(8), nV(8)

! Check input.
! ------------

if (nQSP < 1) return
if (sum(NumCho(1:nSym)) < 1) return

if (sum(nQual(1:nSym)) < 1) return

! Extract from vectors in buffer.
! -------------------------------

call Cho_VecBuf_GetLQ(QVec,l_QVec)

! Extract from vectors on disk.
! -----------------------------

do iSym=1,nSym
  iV1(iSym) = nVec_in_Buf(iSym)+1
  nV(iSym) = NumCho(iSym)-nVec_in_Buf(iSym)
end do
call Cho_VecDsk_GetLQ(QVec,l_QVec,LstQSP,nQSP,iV1,nV,nSym)

end subroutine Cho_GetLQ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3_bt_aac(nug,ka,kc,la,lc,adim,cdim,N,noab,nnoab,lu,iasblock,nga,ngc,oeh,oepa,oepc,enx,voa,voc,t1aa,t1ba,t1ac,t1bc,t3a, &
                     t3b,ifvo)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nug, adim, cdim, N, noab, nnoab, lu(2), iasblock(3), nga, ngc
real(kind=wp), intent(_OUT_) :: ka(nTri_Elem(adim-1),N,*), kc(adim*cdim,N,*), voa(nTri_Elem(adim-1),*), voc(adim*cdim,*), &
                                t3a(cdim,*), t3b(cdim,adim,*)
real(kind=wp), intent(out) :: la(N*adim,nnoab), lc(N*cdim,nnoab)
real(kind=wp), intent(in) :: oeh(noab), oepa(adim), oepc(cdim)
real(kind=wp), intent(inout) :: enx, t1aa(noab,*), t1ba(noab,*), t1ac(noab,*), t1bc(noab,*)
logical(kind=iwp), intent(in) :: ifvo
integer(kind=iwp) :: a, ab, b, c, i, ias, iasai, iasci, ij, ik, j, jk, k, nadim, ncdim, nga_offset, ngc_offset, nug_offset
real(kind=wp) :: den, dena, denb, denc, sumt3, xx, yy

sumt3 = Zero
if (adim == 1) return
nadim = nTri_Elem(adim-1)
ncdim = adim*cdim
nug_offset = iasblock(1)*nTri_Elem(nug)
ias = iasblock(2)*(nga-1)+1
call multi_readir(la,nnoab*adim*N,lu(2),ias)
ias = iasblock(2)*(ngc-1)+1
call multi_readir(lc,nnoab*cdim*N,lu(2),ias)
! reads vvoo
nga_offset = iasblock(3)*(nTri_Elem(nga-1)+nga-1)+1
ngc_offset = iasblock(3)*(nTri_Elem(nga-1)+ngc-1)+1
ias = iasblock(2)*nug+nga_offset
call multi_readir(voa,nnoab*nadim,lu(2),ias)
ias = iasblock(2)*nug+ngc_offset
call multi_readir(voc,nnoab*ncdim,lu(2),ias)

nga_offset = iasblock(1)*(nTri_Elem(nga-1)+nga-1)+1
ngc_offset = iasblock(1)*(nTri_Elem(nga-1)+ngc-1)+1
do i=1,noab
  iasci = (i-1)*nug_offset+ngc_offset
  call multi_readir(kc(:,:,i),N*ncdim,lu(1),iasci)
  iasai = (i-1)*nug_offset+nga_offset
  call multi_readir(ka(:,:,i),N*nadim,lu(1),iasai)
end do
do i=3,noab
  jk = 0
  do j=2,i-1
    ij = nTri_Elem(i-2)+j
    ik = nTri_Elem(i-2)
    do k=1,j-1
      jk = jk+1
      ik = ik+1
      !!write(u6,'(9I5)') i,j,k,iasai,iasaj,iasak,iasci,iascj,iasck
      ! K_ab^ir x L_rc^jk
      call DGEMM_('T','T',cdim,nadim,N,one,lc(:,jk),N,ka(:,:,i),nadim,zero,t3a,cdim)
      ! K_ab^kr x L_rc^ij
      call DGEMM_('T','T',cdim,nadim,N,one,lc(:,ij),N,ka(:,:,k),nadim,one,t3a,cdim)
      ! -K_ab^jr x L_rc^ik
      call DGEMM_('T','T',cdim,nadim,N,-one,lc(:,ik),N,ka(:,:,j),nadim,one,t3a,cdim)
      ! K_bc^ir x L_ra^jk
      call DGEMM_('N','N',ncdim,adim,N,one,kc(:,:,i),ncdim,la(:,jk),N,zero,t3b,ncdim)
      ! K_bc^kr x L_ra^ij
      call DGEMM_('N','N',ncdim,adim,N,one,kc(:,:,k),ncdim,la(:,ij),N,one,t3b,ncdim)
      ! -K_bc^jr x L_ra^ik
      call DGEMM_('N','N',ncdim,adim,N,-one,kc(:,:,j),ncdim,la(:,ik),N,one,t3b,ncdim)

      ab = 0
      do a=2,adim
        do b=1,a-1
          ab = ab+1
          t3a(:,ab) = t3a(:,ab)-t3b(:,a,b)+t3b(:,b,a)
        end do
      end do
      den = oeh(i)+oeh(j)+oeh(k)
      ab = 0
      !!kaka = 0
      do a=2,adim
        dena = den-oepa(a)
        do b=1,a-1
          ab = ab+1
          denb = dena-oepa(b)
          do c=1,cdim
            denc = denb-oepc(c)
            !!ab = ab+1
            !!kaka = kaka+1
            !!xx = t3a(ab,1)
            xx = t3a(c,ab)
            yy = xx/denc
            sumt3 = sumt3+xx
            enx = enx+yy*xx
            !!t3a(ab,1) = yy
            t3a(c,ab) = yy
            !!write(u6,*) ab,t3a(ab,1)
            !!write(u6,*) kaka,t3a(c,ab)
          end do
        end do
      end do
      call expa2_uhf(t3a,cdim,adim,-1,t3b)
      ! ccsd(T) part vvoo*t3
      call DGEMM_('N','T',1,cdim,nadim,one,voa(:,ij),1,t3a,cdim,one,t1ac(k,1),noab)
      call DGEMM_('N','T',1,cdim,nadim,one,voa(:,jk),1,t3a,cdim,one,t1ac(i,1),noab)
      call DGEMM_('N','T',1,cdim,nadim,-one,voa(:,ik),1,t3a,cdim,one,t1ac(j,1),noab)
      call DGEMM_('N','N',1,adim,ncdim,-one,voc(:,ij),1,t3b,ncdim,one,t1aa(k,1),noab)
      call DGEMM_('N','N',1,adim,ncdim,-one,voc(:,jk),1,t3b,ncdim,one,t1aa(i,1),noab)
      call DGEMM_('N','N',1,adim,ncdim,one,voc(:,ik),1,t3b,ncdim,one,t1aa(j,1),noab)
      ! ccsd(T) part t2*t3
      if (ifvo) then
        call DGEMM_('N','T',1,cdim,nadim,one,ka(:,i,j),1,t3a,cdim,one,t1bc(k,1),noab)
        call DGEMM_('N','T',1,cdim,nadim,one,ka(:,j,k),1,t3a,cdim,one,t1bc(i,1),noab)
        call DGEMM_('N','T',1,cdim,nadim,-one,ka(:,i,k),1,t3a,cdim,one,t1bc(j,1),noab)
        call DGEMM_('N','N',1,adim,ncdim,-one,kc(:,i,j),1,t3b,ncdim,one,t1ba(k,1),noab)
        call DGEMM_('N','N',1,adim,ncdim,-one,kc(:,j,k),1,t3b,ncdim,one,t1ba(i,1),noab)
        call DGEMM_('N','N',1,adim,ncdim,one,kc(:,i,k),1,t3b,ncdim,one,t1ba(j,1),noab)
      end if
    end do !k
  end do !j
end do !i

return

end subroutine t3_bt_aac

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE H0CSF(H0,IPQCSF,IPQCNF,MXP1DM,MXP2DM,MXQDM,
     &                  DTOC,IPRODT,ICONF,
     &                  IREFSM,ECORE,NINOB,NACTOB,
     &                  SCR,ISCR,NCONF,NEL,NAEL,NBEL,IPWAY,
     &                  NP1CSF,NP1CNF,NP2CSF,NP2CNF,
     &                  NQCSF,NQCNF,NPQCSF,NPQCNF,
     &                  DIAG,DIAGCN,
     &                  NTEST,INTSPC,ICOMBI,PSSIGN)
*
* Obtain H0 subspace defined by the three parameters
* MXP1DM,MXP2DM,MXQDM and obtain
* explicit representation of hamilton matrix in subspace
*
*
* The H0 space consist of three subspaces
* P1,P2 AND Q
* The H0 matrix can be pictorized as
*
*              P1    P2        Q
*             ***************************
*             *    *     *              *
*         P1  * Ex *  Ex *   Ex         *    Ex : exact H matrix
*             ***************************         is used in this block
*         P2  *    *     *              *
*             * Ex *  Ex *     Diag     *    Diag : Diagonal
*             ************              *           appriximation used
*             *    *      *             *
*             *    *        *           *
*             * Ex *  Diag    *         *
*         Q   *    *            *       *
*             *    *              *     *
*             *    *                *   *
*             *    *                  * *
*             ***************************
*
* The exact Hamiltonian is therefore calculated in subspace P1 and P2
* but only the interaction between a larger space Q and subspace P1
* is calculated exactly
*
* Lucia Version, September 1993, Jeppe Olsen
*
* ===========
* ARGUMENTS :
* ===========
*   H0 : combined block to contain :
*      PHP : hamilton matrix in subspace P1+P2 output)
*      PHQ : Hamiltonian matrix block with row in P1 and column in Q
*      QHQ : Diagonal approximation to matrix in Q-Q space
*   IPQCSF : CSFs defining subspace (output)
*   IPQCNF : Configurations defining subspace (output )
*   MXP1DM : Largest allowed dimension of subspace P1 (Input)
*   MXP2DM : Largest allowed dimension of subspace P2 (Input)
*   MXQDM  : Largest allowed dimension of subspace Q  (Input)
*   DTOC : Transformation matrix between CSFs and DETs (input)
*   IPRODT : Prototype determinants (input)
*   ICONF : List of configurations  (input)
*   IREFSM : symmetry of considered CI space (input)
*   ECORE : Core energy (input)
*   NINOB : Number of inactive orbitals(input)
*   NACTOB : Number of active orbitals (input)
*   SCR    : Scratch array of length ????
*   NCONF : Number of configurations of symmetry IREFSM
*   IPWAY : Defines way of choosing Primary space
*    = 1  : use the first configurations (until at most
*           MXPDIM CSFs have been included )
*   NP1CNF : Number of primary configurations obtained in P1(output)
*   NP1CSF : Number of primary CSFs obtained in P1 (OUTPUT)
*   NP2CNF : Number of primary configurations obtained in P2 (output)
*   NP2CSF : Number of primary CSFs obtained in P2 (OUTPUT)
*   NQCNF  : Number of primary configurations obtained in Q (output)
*   NQCSF  : Number of primary CSFs obtained in Q (OUTPUT)
*
*   DIAG   : Hamilton diagonal over CSFs ( INPUT )
*   DIAGCN : space for diagonal over configurations
*   INTSPC : Internal space number of actual expansion
*   ICOMBI : = 0 => no spin combinations
*            = 1 =>    spin combinations
*   PSSIGN : Spin combination sign
*
* =========================================
* Jeppe Olsen , Spring of 90 , from PHPCSF
* =========================================
*  Lucia Version, September 1993
* =========================================
      IMPLICIT REAL*8 (A-H,O-Z)
*.Output
      DIMENSION H0(*),IPQCSF(*),IPQCNF(*)
*.Input
      DIMENSION DIAG(*)
      DIMENSION DTOC(*),IPRODT(*),ICONF(*)
*.Scratch space
      DIMENSION SCR(*),ISCR(*),DIAGCN(*)
*. SCR and ISCR are supposed to refer to the same array
*
#include "detdim.fh"

#include "SysDef.fh"
#include "spinfo_mclr.fh"
*
      CALL H0CSF_INTERNAL(SCR,DIAGCN)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE H0CSF_INTERNAL(SCR,DIAGCN)
      USE ISO_C_BINDING
      REAL*8, TARGET :: SCR(*),DIAGCN(*)
      INTEGER, POINTER :: iPTR(:)
*
** 1 : Obtain primary subspace
*
      NP1CSF = 0
      NP1CNF = 0
      NP2CSF = 0
      NP2CNF = 0
      NPCSF  = 0
      NQCSF  = 0
      NQCNF  = 0
      NPQCSF = 0
      NPQCNF = 0
      ICSFMN = 0 ! dummy initialize
      MXPQDM = MXP1DM + MXP2DM + MXQDM
*
*
* ===================================================================== *
* 1 :                 Generate initial subspace
* ===================================================================== *
*
      IF(IPWAY .EQ. 1 ) THEN
*
* Just use the first CSFs as subspace
*
        ICNF = 0
        ICSF = 0
        DO 100 ITYP = 1, NTYP
          NJCNF = NCNATS(ITYP,IREFSM)
          NIRREP = NCPCNT(ITYP)
          DO 90 IICNF = 1, NJCNF
            ICNF = ICNF + 1
            IF(NP1CSF+NIRREP .LE. MXP1DM) THEN
              NPQCNF = NPQCNF + 1
              NP1CNF = NP1CNF + 1
              IPQCNF(NPQCNF) = ICNF
              DO 80 IICSF = 1, NIRREP
                NPQCSF = NPQCSF + 1
                NP1CSF = NP1CSF + 1
                IPQCSF(NPQCSF) = NPQCSF
   80         CONTINUE
            ELSE IF( NP2CSF+NIRREP .LE. MXP2DM ) THEN
              NPQCNF = NPQCNF + 1
              NP2CNF = NP2CNF + 1
              IPQCNF(NPQCNF) = ICNF
              DO 180 IICSF = 1, NIRREP
                NPQCSF = NPQCSF + 1
                NP2CSF = NP2CSF + 1
                IPQCSF(NPQCSF) = NPQCSF
  180         CONTINUE
            ELSE IF( NQCSF+NIRREP .LE. MXQDM ) THEN
              NPQCNF = NPQCNF + 1
              NQCNF = NQCNF + 1
              IPQCNF(NPQCNF) = ICNF
              DO 280 IICSF = 1, NIRREP
                NPQCSF = NPQCSF + 1
                NQCSF = NQCSF + 1
                IPQCSF(NPQCSF) = NPQCSF
  280         CONTINUE
            ELSE
              GOTO 101
            END IF
   90     CONTINUE
  100   CONTINUE
  101   CONTINUE
*
      ELSE IF( IPWAY .EQ. 2 ) THEN
*          Obtain lowest CSFs
*
* 1 :  local Diagonal elements over configurations
*
        IICSF = 1
        IICNF = 1
*
        klFREE=1
        KLDIPQ = 1
        KLFREE = KLFREE + MXPQDM
*
        KLCONF = KLFREE
        KLFREE = KLCONF + NEL
*

        DO 300 ITYP = 1, NTYP
          NJCNF = NCNATS(ITYP,IREFSM)
          NIRREP = NCPCNT(ITYP)
          DO 290 ICNF = 1, NJCNF
            DIAGCN(IICNF) = DIAG(IICSF)
            IICNF = IICNF + 1
            IICSF = IICSF + NIRREP
  290     CONTINUE
  300   CONTINUE
* Largest element
        XMAX = FNDMNX(DIAGCN,NCONF,2)
* loop over lowest configurations
*
        IFINIT = 0
  400   CONTINUE
*
        XMIN = XMAX + 1.0D0
        IMIN = 0
*
        IICNF = 1
        ICSFOF = 1
        DO 500 ITYP = 1, NTYP
          NIRREP = NCPCNT(ITYP)
          DO 450 ICNF = 1,NCNATS(ITYP,IREFSM)
            IF(DIAGCN(     IICNF).LT.XMIN) THEN
              XMIN = DIAGCN(     IICNF)
              IMIN = IICNF
              ICSFMN = ICSFOF
              NCSFMN = NIRREP
            END IF
*
            IICNF = IICNF + 1
            ICSFOF = ICSFOF + NIRREP
  450     CONTINUE
  500   CONTINUE
*
** Next lowest element has been found
*
        IF(NPQCSF + NCSFMN .LE. MXPQDM ) THEN
*.1       add new configuration
          NPQCNF = NPQCNF + 1
          IPQCNF(NPQCNF) = IMIN
          SCR(KLDIPQ-1+NPQCNF) = XMIN
          CALL ISTVC2(IPQCSF(NPQCSF+1),ICSFMN-1,1,NCSFMN)
          NPQCSF = NPQCSF + NCSFMN

*. Mask
          DIAGCN(     IMIN) = XMAX + 1.0D0
        ELSE
          IFINIT = 1
*.2       No space for this configuration , remove previous
*         configurations with the same diagonal value
          IICNF = NPQCNF+1
  600     CONTINUE
            IICNF = IICNF - 1
            DIAVAL = DIAGCN(     IPQCNF(IICNF) )
            IF(ABS(DIAVAL-XMIN) .LE. 1.0D-10) THEN
              NPQCNF = NPQCNF -1
              CALL C_F_POINTER(C_LOC(SCR(KLCONF)),iPTR,[1])
              CALL GETCNF(iPTR,ITYP,IPQCNF(IICNF),
     &        ICONF,IREFSM,NEL,NTEST)
              NULLIFY(iPTR)
              NPQCSF = NPQCSF - NCPCNT(ITYP)
              GOTO 600
            END IF
        END IF
        IF(IFINIT.EQ.0.AND.NPQCNF.LT.NCONF) GOTO 400
*. NPQCSF has now been collected, obtain P1,P2 and Q space
*. so that degenerate configurations are not  in
*. different  subspaces
*
*. Arrange selected configurations in degenerate pairs
*
        KLFREI = rtoi*(KLFREE-1) + 1
*
        KLIDEG = KLFREI
        KLFREE = KLFREE + NPQCNF
*
        KLCONF = KLFREE
        KLFREE = KLFREE + NEL
*
        CALL DEGVEC(SCR(KLDIPQ),NPQCNF,NDGVL,ISCR(KLIDEG))
*. Number of configurations in P1,P2,Q
        ICNF = 0
        DO 800 IDEG = 1, NDGVL
*.Number of CSFs in this group of degenerate values
          IDGVL = ISCR(KLIDEG-1+IDEG)
          IDGCSF = 0
          DO 780 IDGCNF = 1, IDGVL
            ICNF = ICNF + 1
              CALL C_F_POINTER(C_LOC(SCR(KLCONF)),iPTR,[1])
              CALL GETCNF(iPTR,ITYP,IPQCNF(ICNF),
     &        ICONF,IREFSM,NEL,NTEST)
              NULLIFY(iPTR)
              IDGCSF = IDGCSF + NCPCNT(ITYP)
  780    CONTINUE
         IF(NP1CSF+IDGCSF .LE. MXP1DM. AND. NP2CSF+NQCSF.EQ.0) THEN
*. Add to P1
           NP1CSF = NP1CSF + IDGCSF
           NP1CNF = NP1CNF + IDGVL
         ELSE IF(NP2CSF+IDGCSF .LE. MXP2DM .AND. NQCSF .EQ. 0 ) THEN
*. Add to P2
           NP2CSF = NP2CSF + IDGCSF
           NP2CNF = NP2CNF + IDGVL
         ELSE IF( NQCSF+IDGCSF .LE. MXQDM ) THEN
*. Add to Q
           NQCSF = NQCSF + IDGCSF
           NQCNF = NQCNF + IDGVL
         ELSE
*. No space for configuration so
           GOTO 801
         END IF
  800  CONTINUE
  801  CONTINUE
*
       NPCSF = NP1CSF + NP2CSF
       NPCNF = NP1CNF + NP2CNF
*
       NPQCSF = NPCSF + NQCSF
       NPQCNF = NPCNF + NQCNF
*
      END IF
*. End if for IWAY = 2
*
*. This is not beautiful, but neccessary
      MXP1DM = NP1CSF
      MXP2DM = NP2CSF
      MXQDM = NQCSF
*
*
* ============================================================
* 2          Construct Hamiltonian matrix in subspace
* ============================================================
*
*. Do not add core energy to subspace Hamiltonian, add to eigenvalues
*. Pointers in H0
      KLPHP  = 1
      KLPHQ = KLPHP + NPCSF*(NPCSF+1)/2
      KLQHQ = KLPHQ + NP1CSF*NQCSF
*
*.PHP matrix
*
*     CALL C_F_POINTER(C_LOC(DIAGCN(1)),iPTR,[1])
      CALL CNHCNM(H0(KLPHP),1,IPQCNF,NPCNF,IPQCNF,NPCNF,NPCSF,NPCSF,
     &     DIAGCN,ICONF,NEL,IREFSM,NAEL,NBEL,NINOB,NACTOB,ECORE,
     &     IPRODT,DTOC,INTSPC,ICOMBI,PSSIGN,NTEST)
*
*. PHQ matrix
*
      CALL CNHCNM(H0(KLPHQ),0,IPQCNF,NP1CNF,IPQCNF(1+NPCNF),NQCNF,
     &   NP1CSF,NQCSF,DIAGCN,ICONF,NEL,IREFSM,NAEL,NBEL,NINOB,NACTOB,
     &   ECORE,IPRODT,DTOC,INTSPC,ICOMBI,PSSIGN,NTEST)
*     NULLIFY(iPTR)
*
      RETURN
      END SUBROUTINE H0CSF_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine COPVCD(LUIN,LUOUT,SEGMNT,IREW,LBLK)
! COPY VECTOR ON FILE LUIN TO FILE LUOUT
!
! LBLK DEFINES STRUCTURE OF FILE
!
! Structure of output file is inherited by output file,
! if input file is packed, so is output file
!
! Type of file LUOUT is inherited from LUIN

use lucia_data, only: IDISK
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: LUIN, LUOUT, IREW, LBLK
real(kind=wp), intent(_OUT_) :: SEGMNT(*)
integer(kind=iwp) :: IAMPACK, IDUMMY(1), IMZERO, KBLK, LBL(1), NO_ZEROING

if (IREW /= 0) then
  IDISK(LUIN) = 0
  IDISK(LUOUT) = 0
end if

! LOOP OVER BLOCKS

!write(u6,*) ' COPVCD LBLK : ',LBLK
do
  if (LBLK > 0) then
    LBL(1) = LBLK
  else if (LBLK == 0) then
    call IDAFILE(LUIN,2,LBL,1,IDISK(LUIN))
    call IDAFILE(LUOUT,1,LBL,1,IDISK(LUOUT))
    !write(u6,*) ' COPVCD LBL : ',LBL(1)
  else if (LBLK < 0) then
    call IDAFILE(LUIN,2,LBL,1,IDISK(LUIN))
    call IDAFILE(LUIN,2,IDUMMY,1,IDISK(LUIN))
    call IDAFILE(LUOUT,1,LBL,1,IDISK(LUOUT))
    IDUMMY(1) = -1
    call IDAFILE(LUOUT,1,IDUMMY,1,IDISK(LUOUT))
  end if
  if (LBL(1) >= 0) then
    if (LBLK >= 0) then
      KBLK = LBL(1)
    else
      KBLK = -1
    end if
    !write(u6,*) ' LBL and KBLK ',LBL(1),KBLK
    NO_ZEROING = 1
    call FRMDSC2(SEGMNT,LBL(1),KBLK,LUIN,IMZERO,IAMPACK,NO_ZEROING)
    !if (IAMPACK /= 0) write(u6,*) ' COPVCD, IAMPACK,FILE = ',IAMPACK,LUIN
    if (IMZERO == 0) then
      if (IAMPACK == 0) then
        call TODSC(SEGMNT,LBL(1),KBLK,LUOUT)
      else
        call TODSCP(SEGMNT,LBL(1),KBLK,LUOUT)
      end if
    else
      call ZERORC(LUOUT,IAMPACK)
    end if
  end if
  if ((LBL(1) < 0) .or. (LBLK > 0)) exit
end do

end subroutine COPVCD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ChkIfKey_m()
      Implicit Real*8 (A-H,O-Z)
* ------------------------------------------------------------
* Check if the next item on luinput is a string that starts with
* a keyword. Print warning else.
* ------------------------------------------------------------
#include "rasdim.fh"
#include "input_ras.fh"
      Character*4 Command
      Character*(180)  Line
      Read(LUInput,*) Line
      Command=Line(1:4)
      Call UpCase(Command)
      Do iCmd=1,NKeys
        If ( Command.eq.Cmd(iCmd) ) GoTo 900
      End Do
      write(6,*)' ****************************************************'
      write(6,*)' ChkIfKey Warning: The following line seems intended'
      write(6,*)' to give some keyword input, but was not recognized:'
      write(6,*)' '''//line(1:32)//''''
      write(6,*)' Spelling or syntactic mistake? Ignored!'
      write(6,*)' ****************************************************'
 900  Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine tetin(lmax)

use Constants, only: Zero, One
use welcom, only: binom, tetint
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lmax
integer(kind=iwp) :: i, k, l, lm2, m

do k=0,lmax
  lm2 = k/2
  do l=0,lm2
    tetint(k,l) = Zero
    m = k-l*2
    do i=0,l
      tetint(k,l) = tetint(k,l)+binom(l,i)*(-One)**i/real(m+i*2+1,kind=wp)
    end do
  end do
end do

end subroutine tetin

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Cff2Dq(nabMax,ncdMax,nRys,
     &                  Zeta,ZInv,Eta,EInv,nT,
     &                  Coori,CoorAC,P,Q,la,lb,lc,ld,
     &                  U2,PAQP,QCPQ,B10,B00,lac,B01)
************************************************************************
*                                                                      *
* Object: to compute the coefficients in the three terms recurrence    *
*         relation of the 2D-integrals.                                *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
* Modified loop structure for RISC 1991 R. Lindh, Dept. of Theoretical *
* Chemistry, University of Lund, Sweden.                               *
*             May '92. Modified for 2nd order differentiation needed   *
*             for the evaluation of the gradient estimates.            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 Zeta(nT), ZInv(nT), Eta(nT), EInv(nT),
     &       Coori(3,4), CoorAC(3,2),
     &       P(nT,3), Q(nT,3), U2(nRys,nT),
     &       PAQP(nRys,nT,3), QCPQ(nRys,nT,3),
     &       B10(nRys,nT,3),
     &       B00(nRys,nT,3),
     &       B01(nRys,nT,3)
*     Local arrays
      Logical AeqB, CeqD, EQ
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
*     Local arrays
      Character*30 Label
#endif
*
      iRout = 14
      iPrint = nPrint(iRout)
*
#ifdef _DEBUGPRINT_
      iPrint=99
      If (iPrint.ge.99) Then
         Call RecPrt(' In Cff2dq: Coori',' ',Coori,3,4)
         Call RecPrt(' In Cff2dq: U2',' ',U2,nRys,nT)
      End If
#endif
      AeqB = EQ(Coori(1,1),Coori(1,2))
      CeqD = EQ(Coori(1,3),Coori(1,4))
*
      h12 = Half
      If (nabMax.ne.0 .and. ncdMax.ne.0) Then
         Do iT = 1, nT
            Do iRys = 1, nRys
               B00(iRys,iT,1) = (h12 * U2(iRys,iT))
               B10(iRys,iT,1) = ( h12 -
     &           (h12 * U2(iRys,iT)) *
     &           Eta(iT))*ZInv(iT)
               B01(iRys,iT,1) = ( h12 -
     &           (h12 * U2(iRys,iT)) *
     &           Zeta(iT))*EInv(iT)
            End Do
         End Do
      Else If (ncdMax.eq.0 .and. nabMax.ne.0 .and. lac.eq.0) Then
         Call WarningMessage(2,' Cff2dq: You should not be here!')
         Call Abend()
      Else If (nabMax.eq.0 .and. ncdMax.ne.0 .and. lac.eq.0) Then
         Call WarningMessage(2,' Cff2dq: You should not be here!')
         Call Abend()
      Else If (ncdMax.eq.0 .and. nabMax.ne.0) Then
         Call WarningMessage(2,' Cff2dq: You should not be here!')
         Call Abend()
      Else If (nabMax.eq.0 .and. ncdMax.ne.0) Then
         Call WarningMessage(2,' Cff2dq: You should not be here!')
         Call Abend()
      Else  If (nabMax.eq.0 .and. ncdMax.eq.0 .and. lac.ne.0) Then
          Call DYaX(nRys*nT,h12,U2(1,1),1,B00(1,1,1),1)
      End If
      If (nabMax.ne.0) Then
         call dcopy_(nRys*nT,B10(1,1,1),1,B10(1,1,2),1)
         call dcopy_(nRys*nT,B10(1,1,1),1,B10(1,1,3),1)
      End If
      If (lac.ne.0) Then
         call dcopy_(nRys*nT,B00(1,1,1),1,B00(1,1,2),1)
         call dcopy_(nRys*nT,B00(1,1,1),1,B00(1,1,3),1)
      End If
      If (ncdMax.ne.0) Then
         call dcopy_(nRys*nT,B01(1,1,1),1,B01(1,1,2),1)
         call dcopy_(nRys*nT,B01(1,1,1),1,B01(1,1,3),1)
      End If
*
      If (la+lb.ne.0 .and. lc+ld.ne.0) Then
         If (.Not.AeqB .and. .Not.CeqD) Then
         Do 100 iCar = 1, 3
            Do 110 iT = 1, nT
               Do 130 iRys = 1, nRys
                  PAQP(iRys,iT,iCar) =
     &                P(iT,iCar) - CoorAC(iCar,1) + Eta(iT)
     &                * (U2(iRys,iT)
     &                * (Q(iT,iCar)-P(iT,iCar)))
                  QCPQ(iRys,iT,iCar) =
     &                Q(iT,iCar) - CoorAC(iCar,2) - Zeta(iT)
     &                * (U2(iRys,iT)
     &                * (Q(iT,iCar)-P(iT,iCar)))
 130           Continue
 110        Continue
 100     Continue
         Else If (AeqB .and. .Not.CeqD) Then
         Do 200 iCar = 1, 3
            Do 210 iT = 1, nT
              Do 230 iRys = 1, nRys
                  PAQP(iRys,iT,iCar) = Eta(iT)
     &                * (U2(iRys,iT)
     &                * (Q(iT,iCar)-P(iT,iCar)))
                  QCPQ(iRys,iT,iCar) =
     &                Q(iT,iCar) - CoorAC(iCar,2) -
     &                Zeta(iT) * (U2(iRys,iT)
     &                * (Q(iT,iCar)-P(iT,iCar)))
 230           Continue
 210        Continue
 200     Continue
         Else If (.Not.AeqB .and. CeqD) Then
         Do 300 iCar = 1, 3
            Do 310 iT = 1, nT
               Do 330 iRys = 1, nRys
                  PAQP(iRys,iT,iCar) =
     &                P(iT,iCar) - CoorAC(iCar,1) +
     &                Eta(iT) * (U2(iRys,iT)
     &                * (Q(iT,iCar)-P(iT,iCar)))
                  QCPQ(iRys,iT,iCar) = -
     &                Zeta(iT) * (U2(iRys,iT)
     &                * (Q(iT,iCar)-P(iT,iCar)))
 330           Continue
 310        Continue
 300     Continue
         Else
         Do 400 iCar = 1, 3
            Do 410 iT = 1, nT
               Do 430 iRys = 1, nRys
                  PAQP(iRys,iT,iCar) =
     &                Eta(iT) * (U2(iRys,iT)
     &                * (Q(iT,iCar)-P(iT,iCar)))
                  QCPQ(iRys,iT,iCar) = -
     &                Zeta(iT) * (U2(iRys,iT)
     &                * (Q(iT,iCar)-P(iT,iCar)))
 430           Continue
 410        Continue
 400     Continue
         End If
      Else If (la+lb.ne.0) Then
         Call WarningMessage(2,' Cff2dq: You should not be here!')
         Call Abend()
      Else If (lc+ld.ne.0) Then
         Call WarningMessage(2,' Cff2dq: You should not be here!')
         Call Abend()
      End If
#ifdef _DEBUGPRINT_
      If (la+lb.gt.0) Then
         Write (Label,'(A)') ' PAQP(x)'
         Call RecPrt(Label,' ',PAQP(1,1,1),nRys,nT)
         Write (Label,'(A)') ' PAQP(y)'
         Call RecPrt(Label,' ',PAQP(1,1,2),nRys,nT)
         Write (Label,'(A)') ' PAQP(z)'
         Call RecPrt(Label,' ',PAQP(1,1,3),nRys,nT)
      End If
      If (lc+ld.gt.0) Then
         Write (Label,'(A)') ' QCPQ(x)'
         Call RecPrt(Label,' ',QCPQ(1,1,1),nRys,nT)
         Write (Label,'(A)') ' QCPQ(y)'
         Call RecPrt(Label,' ',QCPQ(1,1,2),nRys,nT)
         Write (Label,'(A)') ' QCPQ(z)'
         Call RecPrt(Label,' ',QCPQ(1,1,3),nRys,nT)
      End If
      If (nabMax.ne.0) Then
         Write (Label,'(A)') ' B10(x)'
         Call RecPrt(Label,' ',B10(1,1,1),nRys,nT)
         Write (Label,'(A)') ' B10(y)'
         Call RecPrt(Label,' ',B10(1,1,2),nRys,nT)
         Write (Label,'(A)') ' B10(z)'
         Call RecPrt(Label,' ',B10(1,1,3),nRys,nT)
      End If
      If (lac.ne.0) Then
         Write (Label,'(A)') ' B00(x)'
         Call RecPrt(Label,' ',B00(1,1,1),nRys,nT)
         Write (Label,'(A)') ' B00(y)'
         Call RecPrt(Label,' ',B00(1,1,2),nRys,nT)
         Write (Label,'(A)') ' B00(z)'
         Call RecPrt(Label,' ',B00(1,1,3),nRys,nT)
      End If
      If (ncdMax.ne.0) Then
         Write (Label,'(A)') ' B01(x)'
         Call RecPrt(Label,' ',B01(1,1,1),nRys,nT)
         Write (Label,'(A)') ' B01(y)'
         Call RecPrt(Label,' ',B01(1,1,2),nRys,nT)
         Write (Label,'(A)') ' B01(z)'
         Call RecPrt(Label,' ',B01(1,1,3),nRys,nT)
      End If
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine MKBNEVB(nAshT,NG3,Hbar,Gact,G1,G2,G3,idxG3)

use Index_Functions, only: iTri, nTri_Elem
use caspt2_global, only: LUSBT
use caspt2_module, only: IASYM, NINDEP, NSYM, NTGEU, NTGEUES, NTGTU, NTGTUES, NTU, NTUES
use EQSOLV, only: IDBMAT
use NEVPT2_mod, only: tG2, tG3
use SUPERINDEX, only: KTGTU, KTU, MTGEU, MTU
use Symmetry_Info, only: Mul
use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, byte

implicit none
integer(kind=iwp), intent(in) :: nAshT, NG3
real(kind=wp), intent(in) :: Hbar(nAshT,nAshT), Gact(nAshT,nAshT,nAshT,nAshT), G1(nAshT,nAshT), G2(nAshT,nAshT,nAshT,nAshT), G3(*)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: IBADR, IBMADR, IBPADR, ID, IDISK, iG3, IST, ISU, ISV, ISX, ISY, ISYM, ISZ, IT, ITABS, ITGEU, ITGEUABS, ITGTU, &
                     ITU, ITUABS, ITUVS, IU, IUABS, IV, IVABS, IVX, IW, IWABS, IX, IXABS, IXGEY, IXGEYABS, IXGTY, IXY, IXYABS, &
                     IXYZS, IY, IYABS, IYX, IYZ, IZ, IZABS, NAS, NASM, NASP, NBB, NBBM, NBBP
real(kind=wp) :: BTUXY, BTUYX, G3VAL, Val
real(kind=wp), allocatable :: BB(:), BBM(:), BBP(:)

do ISYM=1,NSYM
  if (NINDEP(ISYM,2) == 0) cycle
  NAS = NTU(ISYM)
  NBB = nTri_Elem(NAS)
  if (NBB > 0) call mma_Allocate(BB,NBB,LABEL='BB')
  BB(:) = Zero
  call Init_Tsk(ID,NAS)

  ! tilde{R}^{(2)} --> tG2
  ! The abcd <--> acbd symmetry is considered in the tG2 subroutine
  !do ITU=1,NAS
  !  if (.not. Rsv_Tsk(ID,ITU)) cycle
  do while (Rsv_Tsk(ID,ITU))
    ITUABS = ITU+NTUES(ISYM)
    ITABS = MTU(1,ITUABS)
    IUABS = MTU(2,ITUABS)
    !iSymT = IASYM(ITABS)
    !iSymU = IASYM(IUABS)
    do IXY=1,ITU
      IXYABS = IXY+NTUES(ISYM)
      IXABS = MTU(1,IXYABS)
      IYABS = MTU(2,IXYABS)
      !iSymX = IASYM(IXABS)
      !iSymY = IASYM(IYABS)
      IBADR = iTri(ITU,IXY)
      Val = Zero
      ! Hbar term
      do IV=1,NASHT
        IVABS = IV!+NAES(ISYM)
        Val = Val+Hbar(IVABS,IXABS)*tG2(ITABS,IUABS,IVABS,IYABS,G1,G2)
        Val = Val+Hbar(IVABS,IYABS)*tG2(ITABS,IUABS,IXABS,IVABS,G1,G2)
      end do
      ! RDM2 term
      do IV=1,NASHT
        IVABS = IV!+NAES(ISYM)
        do IW=1,NASHT
          IWABS = IW!+NAES(ISYM)
          do IZ=1,NASHT
            IZABS = IZ!+NAES(ISYM)
            if (IVABS == IZABS) Val = Val+Two*Gact(IVABS,IZABS,IWABS,IXABS)*tG2(ITABS,IUABS,IWABS,IYABS,G1,G2)
            if (IWABS == IZABS) Val = Val-Half*Gact(IVABS,IZABS,IWABS,IXABS)*tG2(ITABS,IUABS,IVABS,IYABS,G1,G2)
            if (IYABS == IZABS) Val = Val-Half*Gact(IVABS,IZABS,IWABS,IXABS)*tG2(ITABS,IUABS,IWABS,IVABS,G1,G2)

            if (IVABS == IZABS) Val = Val+Two*Gact(IVABS,IZABS,IWABS,IYABS)*tG2(ITABS,IUABS,IXABS,IWABS,G1,G2)
            if (IXABS == IZABS) Val = Val-Half*Gact(IVABS,IZABS,IWABS,IYABS)*tG2(ITABS,IUABS,IVABS,IWABS,G1,G2)
            if (IWABS == IZABS) Val = Val-Half*Gact(IVABS,IZABS,IWABS,IYABS)*tG2(ITABS,IUABS,IXABS,IVABS,G1,G2)
          end do
        end do
      end do
      BB(IBADR) = Val
      !write(u6,'(4i3,f20.10)') itabs,iuabs,ixabs,iyabs,Val
    end do
  end do
  call Free_Tsk(ID)

  ! K (tu,xy) = -(vz|wx)*D(tuz,wyv) - (vz|wy)*D(tuz,xwv)
  ! K1(tu,wy) = -(zv|xw)*D(tuv,xyz)
  !>K1(tx,wv) = -(zu|yw)*D(txu,yvz)
  ! K (tu,xy) = -(vz|wy)*D(tuz,xwv)
  ! K2(tu,xw) = -(zv|yw)*D(tuv,xyz)
  !>K2(tx,yw) = -(zu|vw)*D(txu,yvz)
  do IG3=1,NG3
    iT = idxG3(1,iG3)
    iU = idxG3(2,iG3)
    iV = idxG3(3,iG3)
    iX = idxG3(4,iG3)
    iY = idxG3(5,iG3)
    iZ = idxG3(6,iG3)
    iST = IASYM(iT)
    iSU = IASYM(iU)
    iSV = IASYM(iV)
    iSX = IASYM(iX)
    iSY = IASYM(iY)
    iSZ = IASYM(iZ)
    ituvs = MUL(IST,MUL(ISU,ISV))
    ixyzs = MUL(ISX,MUL(ISY,ISZ))
    if (ituvs /= ixyzs) cycle
    iTU = iT+NASHT*(iU-1)
    iVX = iV+NASHT*(iX-1)
    iYZ = iY+NASHT*(iZ-1)

    ! G3(tuvxyz) = <Psi|t+ v+ y+ z x u|Psi>
    G3VAL = tG3(IT,IU,IV,IX,IY,IZ,G1,G2,G3(iG3))

    ! D(tuvxyz)
    if (MUL(iST,iSV) == iSym) call Add_MKBNEVB(iT,iU,iV,iX,iY,iZ)

    if ((iTU /= iVX) .or. (iVX /= iYZ)) then
      if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
        ! D(vxtuyz)
        if (MUL(iSV,iST) == iSym) call Add_MKBNEVB(iV,iX,iT,iU,iY,iZ)
        ! D(yzvxtu)
        if (MUL(iSY,iSV) == iSym) call Add_MKBNEVB(iY,iZ,iV,iX,iT,iU)
        ! D(tuyzvx)
        if (MUL(iST,iSY) == iSym) call Add_MKBNEVB(iT,iU,iY,iZ,iV,iX)
      end if
      ! D(yztuvx)
      if (MUL(iSY,iST) == iSym) call Add_MKBNEVB(iY,iZ,iT,iU,iV,iX)
      ! D(vxyztu)
      if (MUL(iSV,iSY) == iSym) call Add_MKBNEVB(iV,iX,iY,iZ,iT,iU)
    end if

    if ((iT == iU) .and. (iV == iX) .and. (iY == iZ)) cycle
    if ((iT == iU) .and. (iV == iZ) .and. (iX == iY)) cycle
    if ((iX == iV) .and. (iT == iZ) .and. (iU == iY)) cycle
    if ((iZ == iY) .and. (iV == iU) .and. (iX == iT)) cycle

    ! D(utxvzy)
    if (MUL(iSU,iSX) == iSym) call Add_MKBNEVB(iU,iT,iX,iV,iZ,iY)

    if ((iTU == iVX) .and. (iVX == iYZ)) cycle
    if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
      ! D(xvutzy)
      if (MUL(iSX,iSU) == iSym) call Add_MKBNEVB(iX,iV,iU,iT,iZ,iY)
      ! D(zyxvut)
      if (MUL(iSZ,iSX) == iSym) call Add_MKBNEVB(iZ,iY,iX,iV,iU,iT)
      ! D(utzyxv)
      if (MUL(iSU,iSZ) == iSym) call Add_MKBNEVB(iU,iT,iZ,iY,iX,iV)
    end if
    ! D(zyutxv)
    if (MUL(iSZ,iSU) == iSym) call Add_MKBNEVB(iZ,iY,iU,iT,iX,iV)
    ! D(xvzyut)
    if (MUL(iSX,iSZ) == iSym) call Add_MKBNEVB(iX,iV,iZ,iY,iU,iT)
  end do

  BB(:) = Two*BB(:)

  NASP = NTGEU(ISYM)
  NBBP = nTri_Elem(NASP)
  if (NBBP > 0) call mma_allocate(BBP,NBBP,Label='BBP')
  NASM = NTGTU(ISYM)
  NBBM = nTri_Elem(NASM)
  if (NBBM > 0) call mma_allocate(BBM,NBBM,Label='BBM')

  do ITGEU=1,NASP
    ITGEUABS = ITGEU+NTGEUES(ISYM)
    ITABS = MTGEU(1,ITGEUABS)
    IUABS = MTGEU(2,ITGEUABS)
    ITU = KTU(ITABS,IUABS)-NTUES(ISYM)
    do IXGEY=1,ITGEU
      IXGEYABS = IXGEY+NTGEUES(ISYM)
      IXABS = MTGEU(1,IXGEYABS)
      IYABS = MTGEU(2,IXGEYABS)
      IXY = KTU(IXABS,IYABS)-NTUES(ISYM)
      IYX = KTU(IYABS,IXABS)-NTUES(ISYM)
      IBADR = iTri(ITU,IXY)
      BTUXY = BB(IBADR)
      IBADR = iTri(ITU,IYX)
      BTUYX = BB(IBADR)
      IBPADR = iTri(ITGEU,IXGEY)
      BBP(IBPADR) = BTUXY+BTUYX
      if (ITABS == IUABS) cycle
      if (IXABS == IYABS) cycle
      ITGTU = KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
      IXGTY = KTGTU(IXABS,IYABS)-NTGTUES(ISYM)
      IBMADR = iTri(ITGTU,IXGTY)
      BBM(IBMADR) = BTUXY-BTUYX
    end do
  end do
# ifdef _MOLCAS_MPP_
  if (is_real_par()) then
    call GADGOP(BBP,NBBP,'+')
    call GADGOP(BBM,NBBM,'+')
  end if
# endif

  if (NBB > 0) call mma_deallocate(BB)

  if ((NBBP > 0) .and. (NINDEP(ISYM,2) > 0)) then
    IDISK = IDBMAT(ISYM,2)
    call DDAFILE(LUSBT,1,BBP,NBBP,IDISK)
    call mma_deallocate(BBP)
  end if
  if (NBBM > 0) then
    if (NINDEP(ISYM,3) > 0) then
      IDISK = IDBMAT(ISYM,3)
      call DDAFILE(LUSBT,1,BBM,NBBM,IDISK)
    end if
    call mma_deallocate(BBM)
  end if
end do

contains

subroutine Add_MKBNEVB(ITABS_,IXABS_,IUABS_,IYABS_,IVABS_,IZABS_)

  integer(kind=iwp), intent(in) :: ITABS_, IXABS_, IUABS_, IYABS_, IVABS_, IZABS_
  integer(kind=iwp) :: IBADR, ITU_, IWABS, IXY_

  iTU_ = KTU(ITABS_,IUABS_)-NTUES(ISYM)
  do IWABS=1,nAshT
    if (MUL(IASYM(IWABS),IASYM(IYABS_)) == iSym) then
      iXY_ = KTU(IWABS,IYABS_)-NTUES(ISYM)
      if (iTU_ >= iXY_) then
        IBADR = iTri(iTU_,iXY_)
        BB(IBADR) = BB(IBADR)-G3VAL*Gact(IZABS_,IVABS_,IXABS_,IWABS)
      end if
    end if
    if (MUL(IASYM(IXABS_),IASYM(IWABS)) == iSym) then
      iXY_ = KTU(IXABS_,IWABS)-NTUES(ISYM)
      if (iTU_ >= iXY_) then
        IBADR = iTri(iTU_,iXY_)
        BB(IBADR) = BB(IBADR)-G3VAL*Gact(IZABS_,IVABS_,IYABS_,IWABS)
      end if
    end if
  end do

end subroutine Add_MKBNEVB

end subroutine MKBNEVB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986,1995, Bernd Artur Hess                            *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

subroutine Diagr(A,N,EIG,EW,SINV,AUX,AUXI)

use Constants, only: One, Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: A(*), SINV(N,N)
real(kind=wp), intent(out) :: EIG(N,N), AUX(N,N)
real(kind=wp), intent(_OUT_) :: EW(*), AUXI(*)

if (n == 0) return
call Square(A,Aux,n,1,n)
call DGEMM_('N','N',n,n,n,One,Aux,n,Sinv,n,Zero,Eig,n)
call dGemm_tri('T','N',n,n,n,One,SINV,n,EIG,n,Zero,AUXI,n)

Eig(:,:) = Zero
call dCopy_(n,[One],0,Eig,n+1)
call dCopy_(N*(N+1)/2,AUXI,1,AUX,1)
!call NIDiag(AUXI,EIG,N,N)
call NIDiag_New(AUXI,EIG,N,N)
call vEig(N,AUXI,EW)
call JacOrd2(EW,Eig,n,n)

return

end subroutine Diagr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gather_t2(t2,t2_tmp,tmp)
! temporary routine. In future T2 block structure will be merged
!                    with the block structure of the (T) code
!
! this routine does:
!
! cycle through T2XY files and gather them into on T2 array
! T2(nv_beta,nv_alpha,no_beta,no_alpha)

use ChT3_global, only: DimGrpaR, LunAux, no, nv, NvGrp, T2Name
use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: t2(*)
real(kind=wp), intent(_OUT_) :: t2_tmp(*), tmp(*)
integer(kind=iwp) :: a, a_tmp, b, b_tmp, dima, dimb, lasta, lastb, length

!mp write(u6,*)
!mp write(u6,*) '------ DimGrpaR ------'
!mp write(u6,'(8(i5,2x))') (DimGrpaR(a_tmp),a_tmp=1,NvGrp)
!mp write(u6,*)

do a=1,NvGrp
  do b=1,a

    !mp@@ dima = nv/NvGrp
    dima = DimGrpaR(a)
    dimb = DimGrpaR(b)

    !mp write(u6,'(A,i3,i3,2x,A6)') 'a,b,T2Name(a,b) ',a,b,T2Name(a,b)

    if (a == b) then  ! a=b
      ! open the pertinent file

      !mp@@ if (a == NvGrp) dima = nv-((NvGrp-1)*dima)
      dimb = dima

      !mp write(u6,*) 'dima = ',dima
      length = nTri_Elem(dima)*no*no
      !mp write(u6,*) 'length = ',length
      !mp !write(u6,*) 'file size (g77) = ',16+length*8
      !mp write(u6,*) 'file size (ifort) = ',8+length*8

      call GetX_t3(tmp,length,LunAux,T2Name(a,b),1,1)

    else ! a>b
      ! open the pertinent file

      !mp@@ if (a == NvGrp) dima = nv-((NvGrp-1)*dima)
      !mp@@ if (b == NvGrp) dimb = nv-((NvGrp-1)*dimb)

      !mp write(u6,*) 'dima = ',dima
      !mp write(u6,*) 'dimb = ',dimb
      length = dima*dimb*no*no
      !mp write(u6,*) 'length = ',length
      !mp !write(u6,*) 'file size (g77) = ',16+length*8
      !mp write(u6,*) 'file size (ifort) = ',8+length*8

      call GetX_t3(tmp,length,LunAux,T2Name(a,b),1,1)

    end if

    ! add its contents to the t2 array

    !mp@@ lasta = (a-1)*(nv/NvGrp)
    !mp@@ lastb = (b-1)*(nv/NvGrp)
    !mp@@
    lasta = 0
    if (a > 1) then
      do a_tmp=1,a-1
        lasta = lasta+DimGrpaR(a_tmp)
      end do
    end if

    lastb = 0
    if (b > 1) then
      do b_tmp=1,b-1
        lastb = lastb+DimGrpaR(b_tmp)
      end do
    end if
    !mp@@

    !mp write(u6,'(A,2(i5,2x),2(i3,x))') 'lasta, lastb, a, b = ',lasta,lastb,a,b

    if (a == b) then ! expand and map
      ! expand and map l2_1 (a',b',m) <- tmp (m,ab')
      call expand4_12(tmp,t2_tmp,dima,no,no)
      call grow_t2neq(t2,t2_tmp,dima,dimb,nv,no,lasta,lastb)
    else
      call grow_t2neq(t2,tmp,dima,dimb,nv,no,lasta,lastb)
    end if

  end do
end do

return

end subroutine gather_t2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ADADS1(NK,I1,XI1S,IOBSM,IOBTP,IOBOFF,NIOB,
     &                  JOBSM,JOBTP,JOBOFF,NJOB,IJORD,NKDIM,
     &                  ICLS,ISM,I2MAPO,I2MAPS,
     &                 I2MPF,L2MP,I2MPO,I2MPL,
     &                 I1MAPO,I1MAPS,
     &                 I1MPF,L1MP,I1MPO,I1MPL,
     &                 IEL1,IEL3,I2EL1,I2EL3,
     &                 ISSO,NSSO,I2SSO,N2SSO,NOCTP,N2OCTP,
     &                 NORB1,NORB2,NORB3,NORB,KMAX,KMIN,IEND)
*
* Obtain I1(KSTR) = +/- A+ IORB !KSTR>
*
* KSTR is restricted to strings with relative numbers in the
* range KMAX to KMIN
* =====
* Input
* =====
* ICLS,ISM : Class and symmetry of string with added electron
* I2MAPO,I2MAPS : map N-2 strings to N-1 strings
* I1MAPO,I1MAPS : map N-1 strings to  strings
* IEL1(3) : Number of electrons in RAS1(3) for I strings
* I2EL1(3) : Number of electrons in RAS1(3) for K strings
* ISSO : TS symmetry offset for I strings
* NSSO : Number of TS strings for I strings
* I2SSO : TS symmetry offset for K strings
* N2SSO : Number of TS strings for K strings
* NOCTP : Number of occupation types for I strings
* N2OCTP : Number of occupation types for K strings
* NORB1(2,3) : Number of RAS1(2,3) orbitals
* IORBSM : Orbital symmety array
* NORB : Number of active  orbitals
* KMAX : Largest allowed relative number for K strings
* KMIN : Smallest allowed relative number for K strings
*
* ======
* Output
* ======
*
* NK      : Number of K strings
* I1(KSTR) : ne. 0 => a + IORB a+ JORB !KSTR> = +/-!ISTR>
* XI1S(KSTR) : above +/-
*          : eq. 0    a + IORB !KSTR> = 0
* Offset is KMIN
* IEND : = 0 => end of N-2 strings has not been encountered
* IEND : = 1 => end of N-2 strings has     been encountered
*
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
      INTEGER IEL1(*),IEL3(*),I2EL1(*),I2EL3(*)
      INTEGER ISSO(NOCTP,*),NSSO(NOCTP,*)
      INTEGER I2SSO(N2OCTP,*),N2SSO(N2OCTP,*)
      INTEGER I2MAPO(*),I2MAPS(*)
      INTEGER I1MAPO(*),I1MAPS(*)
      INTEGER I2MPL(*),I2MPO(*)
*eaw
      Integer I1mpo(*),i1mpl(*)
*eaw
*.Output
      INTEGER I1(NKDIM,*)
      DIMENSION XI1S(NKDIM,*)
*
      NIJ = 0 ! dummy initialize
      iprstr=0
      NTEST =  IPRSTR !100
      IF(NTEST.GT.0) THEN
        WRITE(6,*) ' ================ '
        WRITE(6,*) ' Info from ADADS1 '
        WRITE(6,*) ' ================ '
        WRITE(6,*)
     &' Iobsm Iobtp Ioboff, Niob',IOBSM,IOBTP,IOBOFF,NIOB
        WRITE(6,*)
     &' Jobsm Jobtp Joboff, NJob',JOBSM,JOBTP,JOBOFF,NJOB
        WRITE(6,*) ' icls ism',ICLS,ISM
        WRITE(6,*) ' I1MPF, I2MPF ', I1MPF,I2MPF
      END IF
*
      NK = KMAX - KMIN + 1
*. Type of kstrings
      IF(IOBTP.EQ.1) THEN
        KEL1 = IEL1(ICLS) - 1
        KEL3 = IEL3(ICLS)
      ELSE IF(IOBTP.EQ.2) THEN
        KEL1 = IEL1(ICLS)
        KEL3 = IEL3(ICLS)
      ELSE
        KEL1 = IEL1(ICLS)
        KEL3 = IEL3(ICLS) - 1
      END IF
      IF(JOBTP.EQ.1) THEN
        KEL1 = KEL1 - 1
        KEL3 = KEL3
      ELSE IF(JOBTP .EQ. 2 ) THEN
        KEL1 = KEL1
        KEL3 = KEL3
      ELSE
        KEL1 = KEL1
        KEL3 = KEL3 - 1
      END IF
C?    write(6,*) ' icls ', icls
C?    write(6,*) ' iel1 iel3 ',iel1(icls),iel3(icls)
C?    write(6,*) ' kel1 kel3 ',kel1,kel3
      KTYPE = 0
      DO 10 KKTYPE = 1, N2OCTP
       IF(I2EL1(KKTYPE).EQ.KEL1.AND.
     &    I2EL3(KKTYPE).EQ.KEL3) KTYPE = KKTYPE
   10 CONTINUE
C?    write(6,*) ' ktype ', ktype
      IF(KTYPE.EQ.0) THEN
        NK = 0
        IEND = 1
        GOTO 101
      END IF
*. Symmetry of K strings
C          SYMCOM(ITASK,IOBJ,I1,I2,I12)
      CALL SYMCOM_MCLR(2,4,IOBSM,JKSM,ISM)
      IF(JKSM.EQ.0) THEN
        CALL SYMCOM_MCLR(2,4,JOBSM      ,IKSM,ISM)
        IF(IKSM.EQ.0) THEN
          NK = 0
          IEND = 1
          GOTO 101
        ELSE
          CALL SYMCOM_MCLR(2,4,IOBSM,KSM,IKSM)
        END IF
      ELSE
        CALL SYMCOM_MCLR(2,4,JOBSM,KSM,JKSM)
      END IF
C?    write(6,*) ' JOBSM,KSM,JKSM ',JOBSM,KSM,JKSM
      IF(KSM.EQ.0) THEN
        NK = 0
        IEND = 1
        GOTO 101
      END IF
      KOFF = I2SSO(KTYPE,KSM)
      KEND = MIN(KMAX,N2SSO(KTYPE,KSM))
      IF( KEND .EQ. N2SSO(KTYPE,KSM)) THEN
        IEND = 1
      ELSE
        IEND = 0
      END IF
      NK = KEND - KMIN + 1
      IOFF = ISSO(ICLS,ISM)
*. Loop over iorb,jorb
      IF(IJORD.EQ.0) THEN
        NIJ = NIOB* NJOB
      ELSE
        NIJ = NIOB*(NIOB+1)/2
      END IF
      If (NKDim.gt.0) Then
         DO IJ = 1, NIJ
            Call ICopy(NKDIM,[0],0,I1(1,IJ),1)
            call dcopy_(NKDIM,[0.0d0],0,XI1S(1,IJ),1)
         END DO
      End If
*
      DO J = 1, NJOB
        IF(IJORD.EQ.1) THEN
          IMIN = J
        ELSE
          IMIN = 1
        END IF
c       DO I = IMIN,NIOB
c       IJ = IJ + 1
C     DO IJ = 1, NIJ
C       CALL NXTIJ(I,J,NIOB,NJOB,IJORD,NONEW)
c       IORB = IOBOFF-1+I
        JORB = JOBOFF-1+J
        IF(IJORD.EQ.1) THEN
          IJOFF = (J-1)*NIOB-(J-1)*(J-2)/2+1-imin+1
        ELSE
          IJOFF = (J-1)*NIOB+1
        END IF
        DO 100 KSTR = KOFF+KMIN-1 , KOFF+KEND- 1
* N-2 => N-1
          JKSTR = 0
          IF(I2MPF.EQ.1) THEN
            IF(I2MAPO((KSTR-1)*L2MP+JORB).EQ.JORB) THEN
               JKSTR = I2MAPS((KSTR-1)*L2MP+JORB)
            END IF
          ELSE IF (I2MPF.EQ.0) THEN
           IFST = MAX(1,JORB+I2MPL(KSTR)-NORB)
           DO JJORB = IFST, MIN(JORb,I2MPL(KSTR))
             IF(I2MAPO(I2MPO(KSTR)-1+JJORB).EQ.JORB) THEN
               JKSTR = I2MAPS(I2MPO(KSTR)-1+JJORB)
             END IF
           END DO
         END IF
         IF(JKSTR.EQ.0) GOTO 100
            IF(JKSTR.GT.0 ) THEN
              SIGN = 1.0D0
            ELSE
              JKSTR = - JKSTR
              SIGN = - 1.0D0
            END IF
* N-1 => N
            do i = imin,niob
            ij = ijoff + i - 1
            iorb = ioboff-1+i
            ISTR = 0
            IF(I1MPF.EQ.1) THEN
              IF(I1MAPO((JKSTR-1)*L1MP+IORB).EQ.IORB) THEN
               ISTR = I1MAPS((JKSTR-1)*L1MP+IORB)
              END IF
            ELSE IF (I1MPF.EQ.0) THEN
             IFST = MAX(1,IORB+NORB-I1MPL(JKSTR))
             DO IIORB = IFST, MIN(IORB,I1MPL(JKSTR))
               IF(I1MAPO(I1MPO(JKSTR)-1+IIORB).EQ.IORB) THEN
                 ISTR = I1MAPS(I1MPO(JKSTR)-1+IIORB)
               END IF
             END DO
           END IF
           IF(ISTR.EQ.0) GOTO 99
*. Synthesis
           IF(ISTR.GT.0) THEN
              I1(KSTR-KOFF-KMIN+2,IJ) = ISTR - IOFF + 1
              XI1S(KSTR-KOFF-KMIN+2,IJ) = SIGN
           ELSE
             I1(KSTR-KOFF-KMIN+2,IJ) = -ISTR - IOFF + 1
             XI1S(KSTR-KOFF-KMIN+2,IJ) = -SIGN
           END IF
   99      CONTINUE
           END DO
*
  100   CONTINUE
*
C     END DO
      END DO
  101 CONTINUE
*
      IF(NTEST.GT.0) THEN
        WRITE(6,*) ' Output from ADADS1 '
        WRITE(6,*) ' ================== '
        WRITE(6,*) ' Number of K strings accessed ', NK
        IF(NK.NE.0) THEN
          DO IJ = 1, NIJ
            WRITE(6,*) ' Excited strings and sign for ij = ',IJ
            CALL IWRTMA(I1(1,IJ),1,NK,1,NK)
            CALL WRTMAT(XI1S(1,IJ),1,NK,1,NK)
          END DO
        END IF
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(NSSO)
        CALL Unused_integer(NORB1)
        CALL Unused_integer(NORB2)
        CALL Unused_integer(NORB3)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Stblz(iChxyz,nStab,jStab,MaxDCR,iCoSet)

use Symmetry_Info, only: iOper, nIrrep
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iChxyz
integer(kind=iwp), intent(out) :: nStab, jStab(0:7), iCoSet(0:7,0:7)
integer(kind=iwp), intent(inout) :: MaxDCR
integer(kind=iwp) :: i, ielem, iOpMn, ip, iStab, iTest, iTmp, j, nMax

!                                                                      *
!***********************************************************************
!                                                                      *
! Find the Stabilizers of this center
!                                                                      *
!***********************************************************************
!                                                                      *
iStab = 0
do i=0,nIrrep-1
  if (iand(iChxyz,iOper(i)) == 0) then
    iStab = iStab+1
    jStab(iStab-1) = iOper(i)
  end if
end do
nStab = iStab
MaxDCR = max(MaxDCR,iStab)
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate all possible (left) CoSet
!                                                                      *
!***********************************************************************
!                                                                      *
do i=0,nIrrep-1
  do j=0,iStab-1
    iCoSet(i,j) = ieor(iOper(i),jStab(j))
  end do
end do
if (iStab /= 1) then ! skip if all are unique

  ! Order the Coset so we will have the unique ones first

  nMax = 1
  if (nMax /= nIrrep/iStab) then ! skip if there is only one
    iTest = iStab-1 ! Test on the last element
    outer: do j=1,nIrrep-1 !
      ! Check uniqueness
      do i=0,nMax-1
        do ielem=0,iStab-1
          if (iCoSet(i,iTest) == iCoSet(j,ielem)) cycle outer
        end do
      end do
      ! Move unique CoSet to nMax+1
      nMax = nMax+1
      do ielem=0,iStab-1
        iTmp = iCoSet(nMax-1,ielem)
        iCoSet(nMax-1,ielem) = iCoSet(j,ielem)
        iCoSet(j,ielem) = iTmp
      end do
      if (nMax == nIrrep/iStab) exit outer
    end do outer
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
do i=0,nIrrep/iStab-1
  iOpMn = iCoSet(i,0)
  do j=1,iStab-1
    iOpMn = iand(iOpMn,iCoset(i,j))
  end do
  ip = 0
  do j=0,iStab-1
    if (iOpMn == iCoSet(i,j)) ip = j
  end do
  iTmp = iCoSet(i,0)
  iCoSet(i,0) = iCoSet(i,ip)
  iCoSet(i,ip) = iTmp

end do
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Stblz

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Roland Lindh                                     *
!***********************************************************************

subroutine DrvDFT(h1,nh1,KSDFT,ExFac,Do_Grad,Grad,nGrad,iSpin,DFTFOCK)

use KSDFT_Info, only: CoefR, CoefX, Funcaa, Funcbb, Funccc, KSDFA
use nq_Info, only: Dens_a1, Dens_a2, Dens_b1, Dens_b2, Dens_I, Dens_t1, Dens_t2, Energy_integrated, Grad_I, mBas, mIrrep, nFro, &
                   nIsh, Tau_I
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nh1, nGrad, iSpin
real(kind=wp), intent(inout) :: h1(nh1), Grad(nGrad)
character(len=*), intent(in) :: KSDFT
real(kind=wp), intent(out) :: ExFac
logical(kind=iwp), intent(in) :: Do_Grad
character(len=4), intent(in) :: DFTFOCK
#include "debug.fh"
integer(kind=iwp) :: i, nD, nFckDim
real(kind=wp) :: d_Alpha, d_Beta, DSpn, DTot, Fact, Func, PDFT_Ratio, Vxc_ref(2), WF_Ratio
logical(kind=iwp) :: Do_HPDFT, Do_MO, Do_TwoEl
real(kind=wp), allocatable :: D_DS(:,:), F_DFT(:,:)
real(kind=wp), external :: Get_ExFac
real(kind=r8), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
KSDFA = KSDFT  ! Store a local copy
Debug = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
call Put_iScalar('Multiplicity',iSpin)
call Get_iScalar('nSym',mIrrep)
call Get_iArray('nBas',mBas,mIrrep)

call Set_Basis_Mode('Valence')
call Setup_iSD()

call Get_dScalar('DFT exch coeff',CoefX)
call Get_dScalar('DFT corr coeff',CoefR)
!                                                                      *
!***********************************************************************
!                                                                      *
if (Do_Grad) Grad(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
if (iSpin == 1) then
  nD = 1
else
  nD = 2
end if

! What is this?

if (DFTFOCK == 'ROKS') nD = 2
call mma_allocate(D_DS,nh1,nD,Label='D_DS')

! Get the total density

call Get_D1ao(D_DS,nh1)
!call RecPrt('D1ao',' ',D_DS(:,1),nh1,1)

! Get the spin density

if (nD /= 1) then
  call Get_D1Sao(D_DS(:,2),nh1)
  !call RecPrt('D1Sao',' ',D_DS(:,2),nh1,1)
end if

! Compute alpha and beta densities

!call RecPrt('DTot',' ',D_DS(:,1),nh1,1)
!call RecPrt('DSpn',' ',D_DS(:,2),nh1,1)
if (nD == 1) then
  D_DS(:,1) = Half*D_DS(:,1)
else
  do i=1,nh1
    DTot = D_DS(i,1)
    DSpn = D_DS(i,2)
    d_Alpha = Half*(DTot+DSpn)
    d_Beta = Half*(DTot-DSpn)
    D_DS(i,1) = d_Alpha
    D_DS(i,2) = d_Beta
  end do
end if
!call RecPrt('Da',' ',D_DS(:,1),nh1,1)
!call RecPrt('Db',' ',D_DS(:,2),nh1,1)

if (KSDFT(1:3) /= 'SCF') then
  call Get_iArray('nIsh',nIsh,mIrrep)
  call Get_iArray('nFro',nFro,mIrrep)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! DFT functionals, compute integrals over the potential

Func = Zero
Funcaa = Zero
Funcbb = Zero
Funccc = Zero
Dens_I = Zero
Dens_a1 = Zero
Dens_b1 = Zero
Dens_a2 = Zero
Dens_b2 = Zero
Dens_t1 = Zero
Dens_t2 = Zero
Grad_I = Zero
Tau_I = Zero
Do_MO = .false.
Do_TwoEl = .false.

! nFckDim: number of different types of Fock matrices. Normally for
! conventional functionals we have one Fock matrix for closed shell
! calculations and two (F_alpha and F_beta) for open shell systems.
! For CASDFT we have always two (F_inactive and F_active)

nFckDim = nD
call mma_allocate(F_DFT,nh1,nFckDim,Label='F_DFT')
F_DFT(:,:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
call Driver(KSDFA,Do_Grad,Func,Grad,nGrad,Do_MO,Do_TwoEl,D_DS,F_DFT,nh1,nD,DFTFOCK)
!                                                                      *
!***********************************************************************
!                                                                      *
if (Do_Grad) then
  Do_HPDFT = .false.
  call qpg_DScalar('R_WF_HMC',Do_HPDFT)
  if (Do_HPDFT) then
    write(u6,*) 'DFT gradient is scaled in a hybrid formalism.'
    call Get_DScalar('R_WF_HMC',WF_Ratio)
    PDFT_Ratio = One-WF_Ratio
    Grad(:) = PDFT_Ratio*Grad
  end if
end if

!                                                                      *
!***********************************************************************
!                                                                      *
ExFac = Get_ExFac(KSDFT)
!                                                                      *
!***********************************************************************
!                                                                      *
Energy_integrated = Func
!                                                                      *
!***********************************************************************
!                                                                      *
if ((KSDFT == 'Overlap') .or. (KSDFT == 'NucAtt')) then
  h1(:) = F_DFT(:,1)
  if (KSDFT == 'NucAtt') Energy_integrated = Func
else

  ! Put out the integrated DFT energy and the DFT Fock matrices on the RUNFILE

  !call Put_DFT_Energy(Energy_integrated)
  call Poke_dScalar('KSDFT energy',Energy_integrated)
  call Put_dScalar('CASDFT energy',Energy_integrated)
  call Put_dExcdRa(F_DFT,nFckDim*nh1)
  !write(u6,'(a,f22.16)') ' Energy in drvdft ',Energy_integrated
# ifdef _DEBUGPRINT_
  write(u6,'(a,f22.16)') ' Energy ',Energy_integrated
  if (nFckDim == 1) then
    do i=1,nh1
      write(u6,'(i4,f22.16)') i,F_DFT(i,1)
    end do
  else
    do i=1,nh1
      write(u6,'(i4,3f22.16)') i,F_DFT(i,1),F_DFT(i,2),Half*(F_DFT(i,1)+F_DFT(i,2))
    end do
  end if
# endif

  ! In the SCF program (traclc.f) the program computes the trace
  ! of the one-electron hamiltonian over a set of densities. The
  ! DFT contribution is not linear with respect to variations of
  ! the density. However, with the following term we can include
  ! the linear component in that code.

  Fact = Two
  if (nD /= 1) Fact = One
  Vxc_ref(1) = Fact*DDot_(nh1,F_DFT(:,1),1,D_DS,1)
  if (nD /= 1) then
    Vxc_ref(2) = DDot_(nh1,F_DFT(:,2),1,D_DS(:,2),1)
  else
    Vxc_ref(2) = Zero
  end if
  call Put_Temp('Vxc_ref ',Vxc_ref,2)
end if

call mma_deallocate(F_DFT)
call mma_deallocate(D_DS)
call Free_iSD()

return

end subroutine DrvDFT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Jeppe Olsen                                      *
*               1989, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE CNDET(ICONF,IPDET,NDET,NEL,NORB,NOP,NCL,
     *                 IDET,IPRINT)
C
C     AUTHOR:        J. OLSEN, UNIV. OF LUND, SWEDEN, APRIL 1987
C     MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
C                    M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
C
C     PURPOSE:
C
C     A CONFIGURATION ICONF IN COMPRESSED FORM AND A SET OF
C     PROTOTYPE DETERMINANTS ,IPDET, ARE GIVEN .
C     CONSTRUCT THE CORRESPONDING DETERMINANTS IN CONTRACTED  FORM .
C
C     SUBROUTINE CALLS:
C
C     IWRTMA
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION ICONF(*   )
      DIMENSION IPDET(*       )
      DIMENSION IDET(NEL,*   )
C
C POSITIVE NUMBER  : ALPHA ORBITAL
C NEGATIVE NUMBER  : BETA  ORBITAL
C
!      IPRINT=40
!      write(*,*)"iprint eq 40 in CNDET, nclosed, nopen",iprint, ncl,nop
!      write(*,*)"iconf, nclosed, nopen",iconf(1:1+ncl-1)
!      if(nop.ne.0)then
!        write(*,*)"opened orbitals",iconf(1+ncl:ncl+nop)
!      end if

      IF( IPRINT.EQ.40 ) THEN
        IF(NCL .NE. 0 ) THEN
          Write(6,*) ' DOUBLE OCCUPIED ORBITALS '
          CALL IWRTMA(ICONF,1,NCL,1,NCL)
        END IF
        IF(NOP .NE. 0 ) THEN
          Write(6,*) ' OPEN ORBITALS '
          CALL IWRTMA(ICONF(1+NCL),1,NOP,1,NOP)
        END IF
      END IF
C
C.. 1 DOUBLY OCCUPIED ORBITALS ARE PLACED FIRST
C
      DO 100 ICL = 1, NCL
        IBASE = 2 * (ICL-1)
        DO 90 JDET = 1, NDET
          IDET(IBASE+1,JDET) =  ICONF(ICL)
          IDET(IBASE+2,JDET) = -ICONF(ICL)
90      CONTINUE
100   CONTINUE
C
C..2  SINGLY OCCUPIED ORBITALS
C
      IADD = 2*NCL
      DO 200 JDET = 1, NDET
        DO 190 IOP = 1, NOP
          IADR = (JDET-1)*NOP + IOP
          IF( IPDET(IADR    ) .EQ. 1 ) IDET(IADD+IOP,JDET) =
     *    ICONF(NCL +IOP)
C
          IF( IPDET(IADR    ) .EQ. 0 ) IDET(IADD+IOP,JDET) =
     *    - ICONF(NCL +IOP)
C
190     CONTINUE
200   CONTINUE
C
      IF( IPRINT.EQ.40 ) THEN
       Write(6,*) ' CONFIGURATION FROM DETCON '
       CALL IWRTMA(ICONF,1,NORB,1,NORB)
       Write(6,* ) ' PROTO TYPE DETERMINANTS '
       IF(NOP*NDET .GT. 0)
     * CALL IWRTMA(IPDET,NOP,NDET,NOP,NDET)
C
       IF(NEL*NDET .GT. 0 )
     * Write(6,*) ' CORRESPONDING DETERMINANTS '
       CALL IWRTMA(IDET,NEL,NDET,NEL,NDET)
C
      END IF

      IPRINT=0
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine ExpArr(Array,Ind,nArray,lArray)
************************************************************************
*                                                                      *
* Object: to expand arrays according to an index array.                *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             Augusti '91                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Array(lArray,nArray)
      Integer Ind(nArray)
*
      Do 100 iArray = nArray, 1, -1
         jArray = Ind(iArray)
         If (jArray.le.0) Then
*           Set column iArray to zero
            call dcopy_(lArray,[Zero],0,Array(1,iArray),1)
         Else If (jArray.lt.iArray) Then
*           Copy row jArray to position iArray
            call dcopy_(lArray,Array(1,jArray),1,Array(1,iArray),1)
         End If
 100  Continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
*               1996, Luis Serrano-Andres                              *
*               2012, Victor P. Vysotskiy                              *
*               2016, Steven Vancoillie                                *
************************************************************************
      Subroutine MpDaFile(Lu,MaxFileSizel,iOpt,Buf,lBuf,iDisk)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     File systems or disks may be to small to keep a given large      *
*     dataset. Therefore, it may be split into subsets which then      *
*     may be linked to different physical units. This process is       *
*     controlled by the environment variable MOLCASDISK                *
*     (c.f. allocdisk). This routine computes the proper splitting     *
*     and calls the IO routines.                                       *
*                                                                      *
*     calling arguments:                                               *
*     Lu      : integer, input                                         *
*               logical unit number (Lu={1,2,...40,50,60,70,80,90}     *
*     MaxFileSize : integer, input                                     *
*               max length of a file.                                  *
*     iOpt    : integer, input                                         *
*               option code                                            *
*               iOpt= 0 dummy write                                    *
*               iOpt= 1 synchronous write                              *
*               iOpt= 2 synchronous read                               *
*               iOpt= 3 synchronous gather and write                   *
*               iOpt= 4 synchronous read and scatter                   *
*               iOpt= 5 synchronous rewind                             *
*               iOpt= 6 asynchronous write                             *
*               iOpt= 7 asynchronous read                              *
*               iOpt= 8 asynchronous gather and write                  *
*               iOpt= 9 asynchronous read and scatter                  *
*               iOpt=10 asynchronous rewind                            *
*               Note: At present the asynchronous modes are not        *
*                     supported and work identically the synchronous   *
*                     modes                                            *
*     Buf     : array of characters, input/output                      *
*               Buffer carrying/receiving the data to write/read       *
*     lBuf    : integer, input                                         *
*               length of the buffer Buf in bytes!!                    *
*     iDisk   : integer, input/output                                  *
*               disk address as byte offset!!!                         *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher, University of Lund, Sweden, 1996                 *
*     L. Serrano-Andres, University of Lund, Sweden, 1996              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* History:                                                             *
*     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
*     Steven Vancoillie: use of byte lengths/offests (2016)            *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

      Character Buf(*)

#include "SysDef.fh"
#include "blksize.fh"
#include "filesize.fh"
#include "fio.fh"
#ifdef _OLD_IO_STAT_
#include "ofio.fh"
#endif
      Character*8 Stdnam, ext
      Character*100 My_Progname,Get_Progname
      External Get_Progname
      Integer Length_Progname
      Character*256 tmp
      Character*80 Text
      Character*16 TheName
      Data TheName/'MpDaFile'/

      My_Progname=Get_Progname()
      Length_Progname=StrnLn(My_Progname)
*
      max_File_Size = MaxFileSizel*10**6
      max_Bytes     = MIN(max_File_Length,max_File_Size)
      n_Bytes       = lBuf
      offset        = iDisk/max_Bytes
*  set correct char to append: 0-9, A-Z
           start_char=48

         if(offset.le.9) then
           start_char=48
         else
           start_char=55
         endif
c
      If (offset.lt.0 .or. offset.gt.MaxSplitFile-1 ) Then
      StdNam=LuName(Lu)
      Call PrgmTranslate(StdNam,tmp,ltmp)
         Write (6,*) '          Current I/O Status as follows'
         Write (6,*)
         iDum=iPrintLevel(3)
         Call FASTIO('STATUS')
       Call SysAbendFileMsg(TheName,StdNam,
     &   'Extensions out of range!',
     &   'increase MOLCAS_DISK value or MaxSplitFile in fio.fh ')

         Call Abend()
      End If
      LU_mod    = MPUnit(offset,LU)
      iDisk_mod = iDisk-offset*max_Bytes
*
*---- If extension not opened before: open and initiate here!
*
      StdNam=LuName(Lu)
      Call PrgmTranslate(StdNam,tmp,ltmp)
      lStdNam=ltmp
      If (Lu_Mod.lt.0) Then
         Lu_Mod=isfreeunit(Lu)
         MPUnit(offset,LU)=Lu_Mod
         temp = 0
         tmp(1+lStdNam:1+lStdNam)=Char(start_char+offset)
         iext=strnln(StdNam)
         ext=StdNam
         if(offset.le.9) then
          ext(1+iext:1+iext)=Char(start_char+offset)
         else
          ext(1+iext:1+iext)=Char(start_char+offset/10)
          ext(2+iext:2+iext)=Char(start_char+offset-offset/10*10)
         endif
*
         iRc = AixOpn(temp,tmp,.false.)
         If ( iRc.ne.0 ) then
            iRc = AixErr(Text)
            Call SysFileMsg(TheName,'MSG: open', Lu_Mod,Text)
         End If
         isOpen(Lu_Mod)    = 1
         FSCB(Lu_Mod)    = temp
*
cvv         LuName(Lu_Mod)    = tmp
         LuName(Lu_Mod)    = ext
         Call SetLuMark(Lu_Mod)
         Addr(Lu_Mod)    = 0
         Multi_File(Lu_Mod)=.True.
         MPUnit(0,LU_Mod)=Lu
#ifdef _OLD_IO_STAT_
         MxAddr(Lu_Mod)  = 0
         Count(1,Lu_Mod) = 0
         Count(2,Lu_Mod) = 0
         Count(3,Lu_Mod) = 0
         Count(4,Lu_Mod) = 0
#endif
         MBL(Lu_Mod)     = MBL(Lu)
*
      End If
*
      If ( (iDisk_mod+n_Bytes).le.max_Bytes ) then
*
*------- The whole record in contained on a single file.
*
         p_Buf     = 1
         n_Copy    = lBuf
         CALL CHDAFILE(LU_mod,iOpt,Buf(p_Buf),n_Copy,iDisk_mod)
      Else
*
*------- The record must be split over several files.
*
         p_Buf     = 1
         n_Save    = lBuf
         n_Copy    = (max_Bytes-iDisk_mod)
         Do while( n_Save.gt.0 )
            If (LU_MOD.lt.0) Then
               Lu_Mod=isfreeunit(Lu)
               MPUnit(offset,LU)=Lu_Mod
               temp = 0
           start_char=48
         if(offset.le.9) then
           start_char=48
         else
           start_char=55
         endif

               tmp(1+lStdNam:1+lStdNam)=Char(start_char+offset)
         iext=strnln(StdNam)
         ext=StdNam
         if(offset.le.9) then
           ext(1+iext:1+iext)=Char(start_char+offset)
         else
          ext(1+iext:1+iext)=Char(start_char+offset/10)
          ext(2+iext:2+iext)=Char(start_char+offset-offset/10*10)
         endif
*
               iRc = AixOpn(temp,tmp,.false.)
               If ( iRc.ne.0 ) then
                  iRc = AixErr(Text)
                  Call SysFileMsg(TheName,'MSG: open', Lu_Mod,Text)
               End If
               isOpen(Lu_mod)    = 1
               FSCB(Lu_mod)    = temp
*
cvv               LuName(Lu_Mod)    = tmp
               LuName(Lu_Mod)    = ext
               Call SetLuMark(Lu_Mod)

               Addr(Lu_Mod)    = 0
               Multi_File(Lu_Mod)=.True.
               MPUnit(0,LU_Mod)=Lu
#ifdef _OLD_IO_STAT_
               MxAddr(Lu_Mod)  = 0
               Count(1,Lu_Mod) = 0
               Count(2,Lu_Mod) = 0
               Count(3,Lu_Mod) = 0
               Count(4,Lu_Mod) = 0
#endif
               MBL(Lu_Mod)     = MBL(Lu)
*
            End If
            CALL CHDAFILE(LU_mod,iOpt,Buf(p_Buf),n_Copy,iDisk_mod)
            p_Buf     = p_Buf+n_Copy
            n_Save    = n_Save-n_Copy
            n_Copy    = Min(max_Bytes,n_Save)
            offset = offset + 1
      If (offset.gt.MaxSplitFile-1 ) Then
         Write (6,*) '          Current I/O Status as follows'
         Write (6,*)
         iDum=iPrintLevel(3)
         Call FASTIO('STATUS')
       Call SysAbendFileMsg(TheName,StdNam,
     &   'Extensions out of range!',
     &   'increase MOLCAS_DISK value or MaxSplitFile in fio.fh ')

         Call Abend()
      End If

            Lu_Mod=MPUnit(offset,LU)
            iDisk_mod = 0
         End Do
      End If


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine  DistMemChck (PossV1,PossV2,PossV3,PossT)
c
c        Dimensions for DistMemCheck
c        dimensions: V1    - no*nv*nv2, nv2*nv2
c                    V2    - nc*nv2
c                    V3    - nc*nv*no

        implicit none
#include "chcc1.fh"
        integer PossV1,PossV2,PossV3,PossT
c
c        help variables
        integer len
c
        PossT=PossFree
c
        PossV1=PossT
        len=no*nv*nv*(nv+1)/2
        if ((nv*(nv+1)*nv*(nv+1)/4).gt.len) then
        len=nv*(nv+1)*nv*(nv+1)/4
        end if
        PossT=PossT+len
c
        PossV2=PossT
        len=nc*nv*(nv+1)/2
        PossT=PossT+len
c
        PossV3=PossT
        len=nc*no*nv
c
        PossT=PossT+len
c
        write (6,*) ' Poss ChCk',PossV1,PossV2,PossV3,PossT
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Change(iBas,iBsInc,QiBas,kBas,kBsInc,QkBas,jBas,jBsInc,QjBas,lBas,lBsInc,QlBas,jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim, &
                  Fail)
!***********************************************************************
!                                                                      *
! Object: to change the length of the primitive and basis functions    *
!         vectors of center D and B, and center  D, B, C, and A,       *
!         respectively.                                                *
!                                                                      *
! Called from: PSOAOx                                                  *
!                                                                      *
! Calling    : None                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!***********************************************************************

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iBas, kBas, jBas, lBas, jPrim, lPrim
integer(kind=iwp), intent(inout) :: iBsInc, kBsInc, jBsInc, lBsInc, jPrInc, lPrInc
logical(kind=iwp), intent(inout) :: QiBas, QkBas, QjBas, QlBas, QjPrim, QlPrim
logical(kind=iwp), intent(out) :: Fail
integer(kind=iwp) :: i

Fail = .false.
if (QlPrim) then
  if (lPrInc == 1) then
    QlPrim = .false.
    QjPrim = .true.
  else
    do i=2,lPrim
      if ((lPrim+1)/i < lPrInc) then
        lPrInc = max(1,(lPrim+1)/i)
        return
      end if
    end do
  end if
end if
if (QjPrim) then
  lPrInc = lPrim
  if (jPrInc == 1) then
    QjPrim = .false.
    QlBas = .true.
  else
    do i=2,jPrim
      if ((jPrim+1)/i < jPrInc) then
        jPrInc = max(1,(jPrim+1)/i)
        return
      end if
    end do
  end if
end if
lPrInc = lPrim
jPrInc = jPrim
if (QlBas) then
  if (lBsInc == 1) then
    QlBas = .false.
    QjBas = .true.
  else
    do i=2,lBas
      if ((lBas+1)/i < lBsInc) then
        lBsInc = max(1,(lBas+1)/i)
        QlPrim = .true.
        return
      end if
    end do
  end if
end if
if (QjBas) then
  lBsInc = lBas
  if (jBsInc == 1) then
    QjBas = .false.
    QkBas = .true.
  else
    do i=2,jBas
      if ((jBas+1)/i < jBsInc) then
        jBsInc = max((jBas+1)/i,1)
        QlPrim = .true.
        return
      end if
    end do
  end if
end if
if (QkBas) then
  lBsInc = lBas
  jBsInc = jBas
  if (kBsInc == 1) then
    QkBas = .false.
    QiBas = .true.
  else
    do i=2,kBas
      if ((kBas+1)/i < kBsInc) then
        kBsInc = max((kBas+1)/i,1)
        QlPrim = .true.
        return
      end if
    end do
  end if
end if
if (QiBas) then
  lBsInc = lBas
  jBsInc = jBas
  kBsInc = kBas
  if (iBsInc == 1) then
    Fail = .true.
    return
  end if
  do i=2,iBas
    if ((iBas+1)/i < iBsInc) then
      iBsInc = max(1,(iBas+1)/i)
      QlPrim = .true.
      return
    end if
  end do
end if

return

end subroutine Change

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine VeInt(
#define _CALLING_
#include "int_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: to compute the velocity integrals with the Gauss-Hermite     *
*         quadrature.                                                  *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, Sweden, January '91                  *
************************************************************************
      use Her_RW
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables.
      Logical ABeq(3)
      Integer iStabO(0:7), iDCRT(0:7)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 195
      iPrint = nPrint(iRout)
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+1)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+2)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer
      ipQxyz = nip
      nip = nip + nZeta*3*(la+1)*(lb+2)
      ipVxyz = nip
      nip = nip + nZeta*3*(la+1)*(lb+1)
      ipB = nip
      nip = nip + nZeta
      ipRes = nip
      nip = nip + nZeta*nElem(la)*nElem(lb)*nComp
      If (nip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'VeInt: nip-1.gt.nArr*nZeta')
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Write (6,*) ' Abend in VeInt'
         Call Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In VeInt: A',' ',A,1,3)
         Call RecPrt(' In VeInt: RB',' ',RB,1,3)
         Call RecPrt(' In VeInt: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In VeInt: P',' ',P,nZeta,3)
         Write (6,*) ' In VeInt: la,lb=',la,lb
      End If
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb+1,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the contribution from the multipole moment operator
*
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),
     &            0,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the cartesian components for the multipole moment
*     integrals. The integrals are factorized into components.
*
       Call Assmbl(Array(ipQxyz),
     &             Array(ipAxyz),la,
     &             Array(ipRxyz),0,
     &             Array(ipBxyz),lb+1,
     &             nZeta,HerW(iHerW(nHer)),nHer)
*
*     Compute the cartesian components for the velocity integrals.
*     The velocity components are linear combinations of overlap
*     components.
*
      ipBOff = ipB
      Do 210 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
 210  Continue
*
      Call VelInt(Array(ipVxyz),Array(ipQxyz),la,lb,
     &          Array(ipB),nZeta)
*
*     Combine the cartesian components to the full one electron
*     integral.
*
      Call CmbnVe(Array(ipQxyz),nZeta,la,lb,0,Zeta,rKappa,Array(ipRes),
     &          nComp,Array(ipVxyz))
*
      llOper=lOper(1)
      Do 90 iComp = 2, nComp
         llOper = iOr(llOper,lOper(iComp))
 90   Continue
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
      Do 102 lDCRT = 0, nDCRT-1
*
*--------Accumulate contributions
*
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array(ipRes),nZeta,la,lb,nComp,Final,nIC,
     &               nOp         ,lOper,iChO,One)
*
 102  Continue
*
*     Call GetMem(' Exit VeInt','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(ZInv)
         Call Unused_integer(nOrdOp)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Logical Function LDF_ConstraintInfoIsSet(Constraint)
C
C     Thomas Bondo Pedersen, March 2011.
C
C     Purpose: return .True. if constraint info is set.
C
      Implicit None
      Integer Constraint

      Logical LDF_ChargeConstraintInfoIsSet

      If (Constraint.eq.-1) Then ! no constraint
         LDF_ConstraintInfoIsSet=.True.
      Else If (Constraint.eq.0) Then ! charge constraint
         LDF_ConstraintInfoIsSet=LDF_ChargeConstraintInfoIsSet()
      Else ! unknown constraint
         Call WarningMessage(2,
     &                    'LDF_ConstraintInfoIsSet: unknown constraint')
         Call LDF_Quit(1)
         LDF_ConstraintInfoIsSet=.False. ! avoid compiler warnings
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Logical Function LDF_ChargeConstraintInfoIsSet()
      Implicit None
#include "ldf_charge_constraint_info.fh"
      LDF_ChargeConstraintInfoIsSet=ChargeConstraintSet
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine OutPut_td(iKapDisp,isigdisp,iCiDisp,
     &                     iCiSigDisp,iRHSDisp,iRHSCIDisp,
     &                     converged)
********************************************************************
*                                                                  *
* Contracts the response coefficient to the hessian                *
*                                                                  *
* Input                                                            *
*       iKapDisp : Disk locations of solutions to respons equation *
*       iSigDisp : Disk locations of RHS                           *
*       iCIDisp  : Disk locations of CI Soulutions to response     *
*       iCISigDisp : Disk locations of RHS                         *
*       nHess    : Length of hessian                               *
*                                                                  *
* Output to disk                                                   *
*                                                                  *
*       RespHess : Hessian etc                                     *
*       Hess     : Hessian etc                                     *
*                                                                  *
* Author: Anders Bernhardsson, 1996                                *
*         Theoretical Chemistry, University of Lund                *
********************************************************************
      use Arrays, only: Hss
      use ipPage, only: W
      Implicit Real*8 (a-h,o-z)
#include "detdim.fh"
#include "Input.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "disp_mclr.fh"
#include "cicisp_mclr.fh"
#include "stdalloc.fh"
      Character*8 Label
      Character*20 Label2
      Integer Pstate_sym,ldisp2(8),ielec(3)
      Integer iKapDisp(nDisp),isigdisp(nDisp),
     &        iCiDisp(nDisp),iCiSigDisp(nDisp),
     &        iRHSDisp(nDisp),iRHSCiDisp(nDisp)
      Logical elec_On,converged(8),CI
      Real*8 Pola(6)
      Real*8, Allocatable:: RHss(:)
      Real*8, Allocatable:: Kap1(:), Kap2(:), sKap(:),
     &                     rKap1(:),rKap2(:)
      Real*8, Allocatable:: Hess(:), Hess2(:), Temp(:), ELEC(:),
     &                      EG(:), ELOUT(:)
      Integer, Allocatable:: NrDisp(:), DegDisp(:)
*                                                                  *
********************************************************************
*                                                                  *
      debug=.false.
      nHss=SIZE(Hss)
      nhess=nDisp*(nDisp+1)/2
      Call mma_allocate(RHss,nHss,Label='RHss')
      RHss(:)=0.0d0
*
*------------------------------------------------------------------*
*
* Ok construct hessian
*
*------------------------------------------------------------------*
*
       mSym=0
       kSym=0
       idum=1
       idisp=0
       Do 100 iSym=1,nSym
*
*
*          Calculate length of the density, Fock and Kappa matrix etc
*          notice that this matrixes not necessary are symmetric.
*          Store pointers.
*
*          Input:
*                 iSym : Symmetry of perturbation
*
*          Output: Commonblocks (Pointers.fh)
*
          Call Setup_MCLR(iSym)
          PState_SYM=iEor(State_Sym-1,iSym-1)+1
          nconfM=Max(ncsf(PState_Sym),nint(xispsm(Pstate_Sym,1)))
          nconf1=ncsf(PState_Sym)
          if (TimeDep) nconf1=nconf1*2
          if (TimeDep) nconfM=nconfM*2
          CI=.false.
          If (iMethod.eq.2.and.nconf1.gt.0) CI=.true.
          If (CI.and.nconf1.eq.1.and.isym.eq.1) CI=.false.

*
*    Allocate areas for scratch and state variables
*
          Call mma_allocate(Kap1,nDensC,Label='Kap1')
          Call mma_allocate(Kap2,nDensC,Label='Kap2')
          Call mma_allocate(sKap,nDensC,Label='sKap')
          Call mma_allocate(rkap1,nDensC,Label='rKap1')
          Call mma_allocate(rkap2,nDensC,Label='rKap2')
*
*
          If (CI) Then
             ipcip1=ipget(nconfM)
             ipcip2=ipget(nconfM)
             ipsp=ipget(nconfM)
             iprp2=ipget(nconfM)
             iprp1=ipget(nconfM)
          End If
*
*                                    [2]
*         Calculate the diagonal of E    and store in core/disc
*
*
*
        Do 110 jDisp=1,lDisp(iSym)
          iDisp=iDisp+1
          jspin=0
          If (iAnd(nTPert(idisp),1).eq.1) jSpin=1
          if (jspin.eq.0) then
           nconf1=ncsf(Pstate_sym)
          Else
           nconf1=nint(xispsm(Pstate_Sym,1))
          end if
          nCI=nconf1
          if (Timedep) nCI=nCI*2
          If (.not.lCalc(iDisp)) Goto 110


*
          iDisk=iKapDisp(iDisp)
          Len=nDensC
          Call dDaFile(LuTemp,2,Kap1,Len,iDisk)
          iDisk=iSigDisp(iDisp)
          Call dDaFile(LuTemp,2,SKap,Len,iDisk)
          iDisk=iRHSDisp(iDisp)
          Call dDaFile(LuTemp,2,rKap1,Len,iDisk)
          Do i=1,ndensC
           SKap(i)=-SKap(i)-rKap1(i)
          End Do

          If (CI) Then
            ilen=nCI
            idis=iCIDisp(iDisp)
            irc=ipin(ipCIp1)
            Call dDaFile(LuTemp,2,W(ipCIp1)%Vec,iLen,iDis)
            idis=iCISigDisp(idisp)
            irc=ipin(ipSp)
            Call dDaFile(LuTemp,2,W(ipSp)%Vec,iLen,iDis)
            idis=iRHSCIDisp(idisp)
            irc=ipin(iprp1)
            Call dDaFile(LuTemp,2,W(iprp1)%Vec,iLen,iDis)
            irc=ipin(ipsp)
            irc=ipin(iprp1)
            Do i=1,nCI
             W(ipsp)%Vec(i)=-W(ipsp)%Vec(i)-W(iprp1)%Vec(i)
            End Do
          End If

*
************************************************************************
*
           Do 120 kDisp=1, jdisp
*
*                    (x) (2) (y)   (x) (y)    (y) (x)
*            E    = k   E   k   + F   k   +  F   k
*             Resp
*
               kspin=0
               If (iAnd(nTPert(kdisp+ksym),1).eq.1)
     &           kSpin=1
               if (kspin.eq.0) Then
                 nconf1=ncsf(PState_Sym)
               else
                 nConf1=nint(xispsm(Pstate_Sym,1))
               end if
               nCI=nconf1
               if (Timedep) nCI=nCI*2
               If (.not.lCalc(kDisp+ksym)) Goto 120
               iDisk=iKapDisp(kDisp+kSym)
               Len=nDensC
               Call dDaFile(LuTemp,2,Kap2,Len,iDisk)
*
*               Call Recprt('kap2',' ',kap2,nDensC,1)
*               Call Recprt('Skap',' ',Skap,nDensC,1)
              rTempk1=-1.0d0*DDot_(nDensC,Kap2,1,SKap,1)
*
               if (CI) Then
                ilen=nCI
                idis=iCIDisp(kDisp+ksym)
                irc=ipin(ipCIp2)
                Call dDaFile(LuTemp,2,W(ipCIp2)%Vec,iLen,iDis)
*
                irc=ipin(ipsp)
                rTempc1=DDot_(nCI,W(ipCIp2)%Vec,1,W(ipsp)%Vec,1)
               Else
                rtempc1=0.0d0
               End If
*
               iDisk=iRHSDisp(kDisp+kSym)
               Len=nDensC
               Call dDaFile(LuTemp,2,rKap2,Len,iDisk)
               If (CI) Then
                 ilen=nCI
                 idis=iRHSCIDisp(kdisp+ksym)
                 irc=ipin(iprp2)
                 Call dDaFile(LuTemp,2,W(iprp2)%Vec,iLen,iDis)
               End If
*
               Fact=1.0d0
               If (kdisp.eq.jdisp) Fact=2.0d0
*               Call Recprt('kap1',' ',kap1,nDensC,1)
*               Call Recprt('rkap2',' ',rkap2,nDensC,1)
               rTempk2=-1.0d0*Fact*
     &                DDot_(nDensC,Kap1,1,rKap2,1)
               If (kdisp.ne.jdisp) Then
               rtempk3=-1.0d0*DDot_(nDensC,rKap1,1,Kap2,1)
               Else
                rTempk3=0.0d0
               End if
               If (CI) Then
                 Fact=1.0d0
                 If (kdisp.eq.jdisp) Fact=2.0d0
                  irc=ipin(ipCip1)
                  irc=ipin(iprp2)
                  rTempc2=Fact*
     &                DDot_(nCI,W(ipCip1)%Vec,1,W(iprp2)%Vec,1)
                 If (kdisp.ne.jdisp) Then
                  irc=ipin(iprp1)
                  irc=ipin(ipCIp2)
                  rtempc3=1.0d0*
     &                DDot_(nCI,W(iprp1)%Vec,1,W(ipCIp2)%Vec,1)
                 Else
                  rTempc3=0.0d0
                 End if
                Else
                  rtempc2=0.0d0
                  rtempc3=0.0d0
               End if
*
*              Write(*,*) kdisp,jdisp
*              Write(*,*)'rtempk', rTempk1,rtempk2,rtempk3
*              Write(*,*)'rtempc', rtempc1,rtempc2,rtempc3
*
               Maxi=Max(kDisp,jDisp)
               Mini=Min(kDisp,jDisp)
               index=mSym+Maxi*(Maxi-1)/2+Mini
*
               RHss(Index)=RHss(Index)+
     &                     0.5d0*(rTempk1+rtempk2+rtempk3+
     &                            rtempc1+rtempc2+rtempc3)
*
 120       Continue

************************************************************************
*
 110     Continue
         kSym=kSym+lDisp(iSym)
         mSym=mSym+lDisp(iSym)*(lDisp(iSym)+1)/2
*
*    Free areas for scratch and state variables
*
          Call mma_deallocate(rKap2)
          Call mma_deallocate(rKap1)
          Call mma_deallocate(sKap)
          Call mma_deallocate(Kap2)
          Call mma_deallocate(Kap1)
          If (CI)  irc=ipclose(ipcip1)
 100  Continue

      Call mma_allocate(Hess,nHss,Label='Hess')
      Call mma_allocate(Hess2,nHss,Label='Hess2')
      Call mma_allocate(Temp,nHss,Label='Temp')
      Call mma_allocate(ELEC,3*ndisp,Label='ELEC')
      Call mma_allocate(EG  ,3*ndisp,Label='EG')
      Call mma_allocate(ELOUT,3*ndisp,Label='ELOUT')

      If (iMethod.eq.2)  irc=ipclose(-1)
*
*-------------------------------------------------------------------*
*
*     OK now when we have out Hessian, what should  we do with it!
*
*-------------------------------------------------------------------*
*
*
*     If a basis set is dependent on perturbation add terms
*     constructed in mckinley.
*
      call dcopy_(6,[0.0d0],0,pola,1)
      elec_On=.False.
      If (Mckinley) Then
         idum=1
         iopt=128
         irc=3*ndisp
         Label='DOTELGR'
         Call drdMCk(irc,iopt,LaBeL,idum,EG,idum)
         elec_On=.true.
         if (irc.ne.0) elec_On=.false.
      End If
      call dcopy_(nHss,Hss,1,Hess2,1)
      If (debug) Then
         ip=1
         Do iSym=1,nSym
          Write(label2,'(A,I2)') 'CHessian symmetry',iSym
          If (lDisp(iSym).ne.0)
     &    Call TriPrt(label2,' ',Hess2(ip),lDisp(iSym))
         ip=ip+ldisp(isym)*(1+ldisp(isym))/2
         End Do
      End If
*
      If (debug) Then
       Call MMSORT2(HESS2,ELEC,pola,ielec)
       Call Recprt('CONN',' ',Elec,3*nDisp,1)
      End If
*
C
*      Call recprt('rhss',' ',RHss,nHss,1)
*      Call recprt('hess',' ',Hess,nHss,1)
C
      Call DaXpY_(mSym,1.0d0,RHss,1,Hess2,1)
*
      If (debug) Then
       Call MMSORT2(RHSS,ELEC,pola,ielec)
       Call Recprt('RESP',' ',Elec,3*nDisp,1)
      End If
*
      Call MMSORT2(HESS2,ELEC,pola,ielec)
*
      If (debug) Then
       Call Recprt('R+C',' ',Elec,3*nDisp,1)
       ip=1
       Do iSym=1,nSym
        Write(label2,'(A,I2)') 'Hessian symmetry',iSym
        If (lDisp(iSym).ne.0)
     &   Call TriPrt(label2,' ',Hess2(ip),lDisp(iSym))
        ip=ip+ldisp(isym)*(1+ldisp(isym))/2
       End Do
      End If
      Call mmSort(Hess2,Hess,ldisp2)

      If (McKinley) Then
*
        iRC=-1
        iOpt=0
        Label='StatHess'
        Call dRdMck(iRC,iOpt,Label,idum,Temp,idum)
        If (iRC.ne.0) Then
           Write (6,*)
           Write (6,*) ' *** Error in subroutine OUTPUT_TD ***'
           Write (6,*) ' Reading from MCKINT file failed '
           Write (6,*)
        End If
*
        If (debug) Then
         ip=1
         Do iSym=1,nSym
          Write(label2,'(a,i2)') 'SHessian symmetry',iSym
          If (lDisp2(iSym).ne.0)
     &    Call TriPrt(label2,' ',Temp(ip),lDisp2(iSym))
         ip=ip+ldisp2(isym)*(1+ldisp2(isym))/2
         End Do
        End If
        Call DaXpY_(mSym,1.0d0,Temp,1,Hess,1)
      End If
      If (debug) Then
        ip=1
        Do iSym=1,nSym
          Write(label2,'(a,i2)') 'Hessian symmetry',iSym
          If (lDisp2(iSym).ne.0)
     &    Call TriPrt(label2,' ',Hess(ip),lDisp2(iSym))
          ip=ip+ldisp2(isym)*(1+ldisp2(isym))/2
        End Do
      End If
*
*
      If (McKinley) Then
       iRC=-1
       iOpt=0
       Label='Hess    '
       Call dWrMck(iRC,iOpt,Label,iDum,Hess,iDum)
       If (iRC.ne.0) Then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine OUTPUT_TD ***'
         Write (6,*) ' Writing',Label,' to MCKINT file failed '
         Write (6,*)
       End If
*
       Call Put_iScalar('No of Internal coordinates',ldisp2(1))
       Call Put_AnalHess(Hess,ldisp2(1)*(ldisp2(1)+1)/2)
*
      End If
      If (.true.) Then
       iRC=-1
       iOpt=0
       Call mma_allocate(NrDisp,ndisp,Label='NrDisp')
       Call RdMck(irc,iopt,'NRCTDISP',idum,NrDisp,idum)
       iRC=-1
       iOpt=0
       Call mma_allocate(DegDisp,ndisp,Label='DegDisp')
       Label='DegDisp '
       Call RdMck(irc,iopt,Label,idum,DegDisp,idum)
       If (iRC.ne.0) Then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine OUTPUT_TD ***'
         Write (6,*) 'Reading ',Label,' from MCKINT file failed '
         Write (6,*)
       End If
       If (debug)
     &  Call HssPrt_MCLR(DegDisp,Hess,ldisp2)
       call daxpy_(3*ndisp,-1.0d0,EG,1,ELEC,1)
       If (debug.and.elec_On)
     &  Call Recprt('ELEC-ST',' ',EG,3*nDisp,1)
       If (debug.and.elec_On)
     &  Call Recprt('ELEC-TOT',' ',Elec,3*nDisp,1)
*
       Lu_10=10
       Lu_10=IsFreeUnit(Lu_10)
       call molcas_open(lu_10,'UNSYM')
c       Open(unit=Lu_10, file='UNSYM')
*
       If (Mckinley) Then
           Call FreqAnal(DegDisp,NrDisp,Hess,converged,ELEC,ielec,ELOUT,
     &                   ldisp2,Lu_10)
           Call Niclas(Hess,coor,Lu_10)
       End If
       Write(6,*)
       Write(6,*)
       Write(6,*)'************************************'
       Write(6,*)'*                                  *'
       Write(6,*)'*       Time Dependent             *'
       Write(6,*)'*       Polarizabilities           *'
       Write(6,*)'*                                  *'
       Write(6,*)'************************************'
       Write(6,*)
       Write(6,*)
       Call Add_Info('TimeDep_Pol',Pola,6,2)
*
*      Go from energy derivative to polarizability, there is a difference
*      in the sign in the definition.
*
       Call DScal_(6,-1.0D0,Pola,1)
*
       Call TriPrt(' ',' ',Pola,3)
       close(Lu_10)
       Call mma_deallocate(NrDisp)
       Call mma_deallocate(DegDisp)
      End If
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Call mma_deallocate(ELOUT)
      Call mma_deallocate(EG)
      Call mma_deallocate(ELEC)
      Call mma_deallocate(Temp)
      Call mma_deallocate(Hess2)
      Call mma_deallocate(Hess)
      Call mma_deallocate(RHss)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine KnEGrd_mck(
#define _CALLING_
#include "grd_mck_interface.fh"
     &                     )
************************************************************************
*                                                                      *
* Object: to compute the gradient of the kinetic energy integrals      *
*         with the Gauss-Hermite quadrature                            *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Anders Bernhardsson,1995                                 *
************************************************************************
      use Her_RW
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
c#include "print.fh"

#include "grd_mck_interface.fh"

*     Local variables
      Logical ABeq(3)
*
*     Statement function for Cartesian index
*
      nElem(li)=(li+1)*(li+2)/2
*
c     iRout = 150
c     iPrint = nPrint(iRout)
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+3)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+3)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp+1)
      ipRnxyz = nip
      nip = nip + nZeta*3*(la+3)*(lb+3)*(nOrdOp+1)
      ipTxyz = nip
      nip = nip + nZeta*3*(la+2)*(lb+2)
      ipA = nip
      nip = nip + nZeta
      ipB = nip
      nip = nip + nZeta
      ipSc=nip
      nip=nip+nElem(la)*nElem(lb)*nZeta
      If (nip-1.gt.nArr) Then
         Write (6,*) 'KneGrd_Mck: nip-1.gt.nArr'
         Write (6,*) 'nip,nArr=',nip,nArr
         Call Abend()
      End If
*
c     If (iPrint.ge.49) Then
c        Call RecPrt(' In KnEGrd: A',' ',A,1,3)
c        Call RecPrt(' In KnEGrd: B',' ',B,1,3)
c        Call RecPrt(' In KnEGrd: Ccoor',' ',Ccoor,1,3)
c        Call RecPrt(' In KnEGrd: P',' ',P,nZeta,3)
c        Write (*,*) ' In KnEGrd: la,lb=',la,lb
c     End If
*
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la+2,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb+2,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the contribution from the multipole moment operator
*
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),
     &            nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)
*
*     Compute the cartesian components for the multipole moment
*     integrals. The integrals are factorized into components.
*
       Call Assmbl(Array(ipRnxyz),
     &             Array(ipAxyz),la+2,
     &             Array(ipRxyz),nOrdOp,
     &             Array(ipBxyz),lb+2,
     &             nZeta,HerW(iHerW(nHer)),nHer)
*
*     Compute the cartesian components for the kinetic energy integrals.
*     The kinetic energy components are linear combinations of overlap
*     components.
*
      ipAOff = ipA
      Do 200 iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
 200  Continue
*
      ipBOff = ipB
      Do 210 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
 210  Continue
*
      Call Kntc(Array(ipTxyz),Array(ipRnxyz),la+1,lb+1,
     &          Array(ipA),Array(ipB),nZeta)
*
*     Combine the cartesian components to the gradient of the kinetic
*     energy integral and trace with the variational density matrix.
*

      Call CmbnT1_mck(Array(ipRnxyz),nZeta,la,lb,Zeta,rKappa,
     &            Array(ipSc),Array(ipTxyz),
     &            Array(ipA),Array(ipB),IfGrad)
*
      Final(:,:,:,:)=Zero
*
*     Symmetry adopt the gradient operator
*
      Call SymAdO_mck(Array(ipSc),nZeta*nElem(la)*nElem(lb),
     &                Final,nrOp,
     &                nop,loper,IndGrd,iu,iv,ifgrad,idCar,trans)

*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(ZInv)
         Call Unused_integer(iDCnt)
         Call Unused_integer_array(iStabM)
         Call Unused_integer(nStabM)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine InpOne()
      use Arrays, only: CMO, Int1, KAIN1
      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Files_mclr.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
#include "real.fh"
#include "rctfld.fh"
      Logical Do_ESPF,First,Dff,Do_DFT,NonEq
      Character*8 Label
      Integer idum(1)
      Real*8  rdum(1)
      Real*8, Allocatable:: D1ao(:), Nuc(:)
      Real*8, Allocatable:: Temp1(:), Temp2(:), Temp3(:)
      Real*8, Allocatable:: HTmp(:), GTmp(:)
*
      iRc=-1
      iOpt=1
      ndens2=0
      iisym=2**0
      Do iS=1,nSym
        nDens2=nDens2+Nbas(is)**2
      End Do
      Label='ONEHAM'
      Call iRdOne(iRc,iOpt,Label,1,idum,iisym)
      leng=idum(1)
      If (iRC.ne.0)  Then
         Write (6,*) 'InpOne: Error reading ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend()
      End If
      iisym=2**0
      iRc=-1
      iOpt=0
      Call mma_allocate(Int1,ndens2,Label='Int1')
      kain1=>Int1

      Call mma_allocate(Temp1,leng+10,Label='Temp1')
      Call mma_allocate(Temp2,ndens2,Label='Temp2')
      Call mma_allocate(Temp3,ndens2,Label='Temp3')

      Call RdOne(iRc,iOpt,Label,1,Temp1,iisym)
      If (iRC.ne.0)  Then
         Write (6,*) 'InpOne: Error reading ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend()
      End If
cnf
*
*     Modify the one electron Hamiltonian for reaction
*     field and ESPF calculations
*
      Tot_Nuc_Charge=Zero
      Call mma_allocate(Nuc,nAtoms,Label='Nuc')
      Call Get_dArray('Effective nuclear Charge',Nuc,nAtoms)
      Do iNuc = 1, nAtoms
        Tot_Nuc_Charge = Tot_Nuc_Charge + Nuc(iNuc)
      End Do
      Call mma_deallocate(Nuc)
      Tot_El_Charge = Zero
      Do iSym = 1, nSym
         Tot_El_Charge = Tot_El_Charge
     &                 - Two*DBLE(nFro(iSym)+nIsh(iSym))
      End Do
      Tot_El_Charge = Tot_El_Charge - DBLE(nActEl)
      Tot_Charge = Tot_Nuc_Charge + Tot_El_Charge
      iCharge = Int(Tot_Charge)
      Call DecideOnESPF(Do_ESPF)
      If ( Do_ESPF .or. lRF) then
         If (lRF) Then
            Write(6,*) 'Sorry, MCLR+RF NYI'
            Call Quit_OnUserError()
         End If
*
*------ Scratch for one- and two-electron type contributions
*------ + variational density-matrix
*
         Call mma_allocate(Htmp,leng,Label='Htmp')
         Call mma_allocate(Gtmp,leng,Label='Gtmp')
         Htmp(:)=Zero
         Gtmp(:)=Zero
         Call mma_allocate(D1ao,leng,Label='D1ao')
         Call Get_D1ao(D1ao,leng)
*
         NonEq=.False.
         First=.True.
         Dff=.False.
         Do_DFT=.True.
         Call Get_dScalar('PotNuc',PotNuc)
         Call DrvXV(Htmp,Gtmp,D1ao,PotNuc,leng,First,Dff,NonEq,lRF,
*
*------ Don't care about the last arguments: no (CAS-)DFT here I guess)
*
     &              'SCF',Zero,iCharge,iSpin,rdum,rdum,0,'1234',Do_DFT)
         Call Daxpy_(leng,One,Htmp,1,Temp1,1)
*
*------ Hum, where the hell is FI (Fock Inactive) ???
*
*        Call Daxpy_(leng,One,Gtmp,1,FI,1)
         Call mma_deallocate(Gtmp)
         Call mma_deallocate(Htmp)
         Call mma_deallocate(D1ao)
      End If
cnf
      ip=1
      ip2=1
      Do iS=1,nSym
        If (nBas(is).ne.0 .AND. nOrb(iS).ne.0) Then
           Call Square(Temp1(ip),
     &                   Temp2,
     &                   1,nBas(is),nBas(is))
           ip=ip+nBas(is)*(nBas(iS)+1)/2
           Call DGEMM_('T','N',
     &                 nOrb(iS),nBas(iS),nBas(iS),
     &                 1.0d0,CMO(ip2),nBas(iS),
     &                 Temp2,nBas(iS),
     &                 0.0d0,Temp3,nOrb(iS))
           Call DGEMM_('N','N',
     &                 nOrb(is),nOrb(iS),nBas(iS),
     &                 1.0d0,Temp3,nOrb(iS),
     &                 CMO(ip2),nBas(iS),
     &                 0.0d0,Int1(ip2),nOrb(iS))
           ip2=ip2+nBas(is)**2
        End If
      End Do
      Call mma_deallocate(Temp1)
      Call mma_deallocate(Temp2)
      Call mma_deallocate(Temp3)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

subroutine WRT_CONF_LIST(ICONF,NCONF_FOR_OPEN,MAXOP,NELEC)
! Write list of configurations, given in packed form
!
! Jeppe Olsen, November 2001

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ICONF(*), MAXOP, NCONF_FOR_OPEN(MAXOP+1), NELEC
integer(kind=iwp) :: IB, IOPEN, JCONF, NCONF_OP, NOCC_ORB

IB = 1
do IOPEN=0,MAXOP
  NCONF_OP = NCONF_FOR_OPEN(IOPEN+1)
  if (NCONF_OP /= 0) then
    write(u6,*) ' Number of configurations with ',IOPEN,' open orbitals is ',NCONF_OP

    NOCC_ORB = IOPEN+(NELEC-IOPEN)/2
    do JCONF=1,NCONF_OP
      call IWRTMA(ICONF(IB),1,NOCC_ORB,1,NOCC_ORB)
      IB = IB+NOCC_ORB
    end do
  end if
end do

end subroutine WRT_CONF_LIST

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine hymat_2(maxroot,minspace,ndim,kval,mroot,dcrita,eval,vcm,indx,th,nxh,vb1,vb2,nxb,vad)
!***********************************************************************
! The sub. based on the algorithm of Davidson [E.R. Davison, J.
! Comput. Phys. 17, 87 (1975)] for searching the m-th eigenvalue and
! eigenvector of the symmetric matrix. This sub. is an improved
! version of the one given by J. Weber, R. Lacroix and G. Wanner
! in Computers & Chemistry, 4, 55 (1980).
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: maxroot, minspace, ndim, mroot, indx(minspace), nxh, nxb
integer(kind=iwp), intent(inout) :: kval
real(kind=wp), intent(in) :: dcrita, th(nxh), vad(ndim)
real(kind=wp), intent(inout) :: eval(maxroot), vb1(nxb), vb2(nxb)
real(kind=wp), intent(out) :: vcm(ndim*mroot)
integer(kind=iwp) :: i, ijb, ijm, ijmb1, indxm, iterat, jib1, jib2, jicm, k, l, m, mmspace, mn, mrsta, mrsta0, mval, nroot
real(kind=wp) :: depcc, tm, vukm
real(kind=wp), allocatable :: deff(:), ecrita(:), eeval(:), residvb(:), valpha(:), vd(:), ve(:), vp(:), vu(:,:)
real(kind=wp), parameter :: depc = 1.0e-7_wp

!**************************************************************

!write(u6,*) 'generate vector vb2 from matrix a and vector vb1'

!**************************************************************

! debugging
!vb1(1:ndim) = Zero
!vb2(1:ndim) = Zero
!vb1(5) = One
!call abprod2(ndim,1,kval,th,nxh,vb1,vb2,nxb,vad)
!do i=1,ndim
!  write(u6,'(i8,f18.8)') i,vb2(i)
!end do
!call abend()

call mma_allocate(deff,maxroot,label='deff')
call mma_allocate(ecrita,maxroot,label='ecrita')
call mma_allocate(eeval,maxroot,label='eeval')
call mma_allocate(residvb,maxroot,label='residvb')
call mma_allocate(valpha,maxroot,label='valpha')
call mma_allocate(vd,minspace,label='vd')
call mma_allocate(ve,minspace,label='ve')
call mma_allocate(vp,minspace*(minspace+1)/2,label='vp')
call mma_allocate(vu,minspace,minspace,label='vu')

ecrita(:) = 1.0e-8_wp
iterat = 1
mrsta = 1
call abprod2(ndim,1,kval,th,nxh,vb1,vb2,nxb,vad)
call matrmk2(ndim,1,kval,indx,vp,vb1,vb2,nxb)

!=======================================================================
write(u6,*)
l = 0
do k=1,kval
  write(u6,1112) (vp(i),i=l+1,l+k)
  l = l+k
end do
write(u6,*)
!=======================================================================

!write(u6,*) 'diagonalization of matrix p(j,j)'

!=======================================================================
do
  iterat = iterat+1
  if (iterat == 200) then
    write(u6,*) ' h0 space fail to converged'
    write(u6,*) ' program stop'
    call abend()
  end if
  eeval(1:mroot) = eval(1:mroot)
  call hotred(minspace,kval,vp,vd,ve,vu)
  call qlcm(minspace,kval,vd,ve,vu)

  valpha(mrsta:mroot) = Zero
  do m=mrsta,mroot
    eval(m) = vd(m)
    do k=1,kval
      tm = abs(vu(k,m))
      if (valpha(m) < tm) valpha(m) = tm   !max(vu(k,m),k=1,kval)
    end do
    valpha(m) = 1-valpha(m)*valpha(m)
    if (valpha(m) > depc) valpha(m) = sqrt(valpha(m))
    deff(m) = abs(eval(m)-eeval(m))
  end do
  !*********************************************************************
  !
  ! construction of the new approximate eigenvector vcm(n)'
  !
  !*********************************************************************
  ijm = indx(mrsta)
  vcm(ijm+1:ndim*mroot) = Zero
  do k=1,kval
    ijb = indx(k)
    do m=mrsta,mroot
      ijm = indx(m)
      vukm = vu(k,m)
      do i=1,ndim
        vcm(ijm+i) = vcm(ijm+i)+vukm*vb1(ijb+i)
      end do
    end do
  end do

  !do i=1,ndim
  !  write(u6,'(i8,f18.8)') i,vcm(i)
  !end do

  write(u6,1113) iterat,kval,(m,eval(m),deff(m),m=mrsta,mroot)

  nroot = mroot-mrsta+1

  if (kval /= mroot*2) then

    mrsta0 = mrsta
    do m=mrsta0,mroot
      !if ((deff(m) < ecrita(m)) .or. (valpha(m) < dcrita)) then     ! conv
      if ((m == mrsta) .and. (deff(m) < ecrita(m))) then             ! conv
        !if (valpha(m) < dcrita) then                                ! conve
        mrsta = mrsta+1
      end if
    end do
    !mrsta = mrsta+mrooted
    nroot = mroot-mrsta+1
    if (mrsta > mroot) then
      write(u6,*)
      write(u6,*) mroot,' roots are convegenced,after',iterat,' iterat'
      exit
    end if

  end if

  mmspace = min(mroot*3+10,ndim)
  !nroot = 1             ! bbs debug error?
  if (kval+nroot > mmspace) then

    !===== start  reset_basis ==========================================

    do m=mrsta,kval
      indxm = indx(m)
      vb1(indxm+1:indxm+ndim) = Zero
    end do
    do m=mrsta,mroot
      ijm = indx(m)
      do k=1,kval
        ijb = indx(k)
        vukm = vu(k,m)
        do l=1,ndim
          vb1(ijm+l) = vb1(ijm+l)+vukm*vb2(ijb+l)  ! h*cm-->vb1
        end do
      end do
    end do
    ijm = indx(mrsta)
    vb2(ijm+1:ijm+ndim*nroot) = vb1(ijm+1:ijm+ndim*nroot)  ! h*cm-->vb
    vb1(ijm+1:ijm+ndim*nroot) = vcm(ijm+1:ijm+ndim*nroot)  !   cm-->vb
    residvb(mrsta:mroot) = Zero

    mval = mroot
    do m=mrsta,mroot
      ijm = indx(m)
      mval = mval+1
      ijmb1 = indx(mval)
      do l=1,ndim
        depcc = eval(m)-vad(l)
        if (abs(depcc) < depc) depcc = depc
        vb1(ijmb1+l) = (vb2(ijm+l)-vcm(ijm+l)*eval(m))/depcc
        residvb(m) = residvb(m)+vb1(ijmb1+l)*vb1(ijmb1+l)
      end do
      call orthnor(ndim,mval,dcrita,vb1,nxb)
    end do

    vb2(indx(mroot+1)+1:indx(kval+1)) = Zero
    kval = mroot+nroot
    mval = mroot+1
    mn = mroot*(mroot+1)/2
    vp(1:mn) = Zero
    mn = 0
    do m=1,mroot
      mn = mn+m
      vp(mn) = eval(m)
    end do
    !===== end  reset_basis ============================================

  else

    ! form the (j+1)-th approximate vector, vb1(n,j+1)

    jib1 = indx(kval)
    jicm = indx(mrsta)

    residvb(mrsta:mroot) = Zero
    do m=mrsta,mroot
      jib1 = jib1+ndim
      do k=1,kval
        jib2 = indx(k)
        do l=1,ndim
          vb1(jib1+l) = vb1(jib1+l)+vu(k,m)*vb2(jib2+l)
        end do
      end do

      do l=1,ndim
        depcc = eval(m)-vad(l)
        if (abs(depcc) < depc) depcc = depc
        vb1(jib1+l) = (vb1(jib1+l)-vcm(jicm+l)*eval(m))/depcc
        residvb(m) = residvb(m)+vb1(jib1+l)*vb1(jib1+l)
      end do
      jicm = jicm+ndim
    end do
    mval = kval+1
    do m=mrsta,mroot
      kval = kval+1
      call orthnor(ndim,kval,dcrita,vb1,nxb)
    end do

  end if

  call abprod2(ndim,mval,kval,th,nxh,vb1,vb2,nxb,vad)
  call matrmk2(ndim,mval,kval,indx,vp,vb1,vb2,nxb)

  !=====  write out p_matrix ===========================================
  !write(u6,*)
  !write(nf2,*)
  !l = 0
  !do k=1,kval
  !  write(u6,1112) (vp(i),i=l+1,l+k)
  !  write(nf2,1112) (vp(i),i=l+1,l+k)
  !  l = l+k
  !end do
  !write(u6,*)
  !=====  write out p_matrix ===========================================

end do
call mma_deallocate(deff)
call mma_deallocate(ecrita)
call mma_deallocate(eeval)
call mma_deallocate(residvb)
call mma_deallocate(valpha)
call mma_deallocate(vd)
call mma_deallocate(ve)
call mma_deallocate(vp)
call mma_deallocate(vu)

! copy ci vector to VB1
do m=1,mroot
  ijm = indx(m)
  vb1(ijm+1:ijm+ndim) = vcm(ijm+1:ijm+ndim)
  !write(nf1) eval(m),(vcm(ijm+i),i=1,ndim)
  !write(u6,'(5(1x,f18.9),1x,i2)') (vcm(ijm+i),i=1,4),vcm(35)
end do

return

1112 format(2x,20f14.8)
1113 format(2i3,10(2x,i2,f14.8,f14.8))

end subroutine hymat_2

subroutine matrmk2(n,k1,k2,indx,p,vb1,vb2,nxb)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, k1, k2, indx(30), nxb
real(kind=wp), intent(inout) :: p(465)
real(kind=wp), intent(in) :: vb1(nxb), vb2(nxb)
integer(kind=iwp) :: i, iijj, ij, j, ji, l

do i=k1,k2
  iijj = i*(i-1)/2
  ij = indx(i)
  do j=1,i
    ji = indx(j)
    p(iijj+j) = Zero
    !-------------------------------------------------------------------
    do l=1,n
      !-----------------------------------------------------------------
      p(iijj+j) = p(iijj+j)+vb1(ij+l)*vb2(ji+l)
    end do
  end do
end do

return

end subroutine matrmk2

subroutine abprod2(n,k1,k2,th,nxh,vb1,vb2,nxb,vad)

use gugaci_global, only: indx
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, k1, k2, nxh, nxb
real(kind=wp), intent(in) :: th(nxh), vb1(nxb), vad(n)
real(kind=wp), intent(inout) :: vb2(nxb)
integer(kind=iwp) :: i, ij, j, l, mn

ij = 0
do j=k1,k2
  ij = indx(j)
  do i=1,n
    vb2(ij+i) = vad(i)*vb1(ij+i)
  end do
end do
!-----------------------------------------------------------------------
do i=2,n
  mn = i*(i-1)/2
  do j=k1,k2
    ij = indx(j)
    do l=1,i-1
      vb2(ij+i) = vb2(ij+i)+th(mn+l)*vb1(ij+l)
      vb2(ij+l) = vb2(ij+l)+th(mn+l)*vb1(ij+i)
    end do
  end do
end do
!-----------------------------------------------------------------------
return

end subroutine abprod2

subroutine orthnor(n,j,dcrita,vb1,nxb)

use gugaci_global, only: indx
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n, j, nxb
real(kind=wp), intent(in) :: dcrita
real(kind=wp), intent(inout) :: vb1(nxb)
integer(kind=iwp) :: i, ij, ji, jm, l
real(kind=wp) :: s, smax1, smax2

ji = indx(j)
if (j /= 1) then
  jm = j-1
  smax2 = huge(smax2)
  do
    smax1 = Zero
    do l=1,jm
      s = Zero
      ij = indx(l)
      do i=1,n
        s = s+vb1(ij+i)*vb1(ji+i)
      end do
      smax1 = max(smax1,abs(s))
      do i=1,n
        vb1(ji+i) = vb1(ji+i)-s*vb1(ij+i)
      end do
    end do

    if (smax1 < dcrita) exit
    if (smax1 > smax2) then
      write(u6,*) 'diagonalization procedure is non-convergent.'
#     ifndef MOLPRO
      call abend()
#     endif
      !call abend()
    end if
    smax2 = smax1
  end do
end if
! normalization of j-th eigenvector.
s = Zero
do i=1,n
  s = s+vb1(ji+i)*vb1(ji+i)
end do
s = sqrt(s)
do i=1,n
  vb1(ji+i) = vb1(ji+i)/s
end do

return

end subroutine orthnor

subroutine norm_a(n,av)  !bv:basis, av:vector for orth and norm

use Constants, only: Zero
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: av(n)
integer(kind=iwp) :: i
real(kind=wp) :: s
real(kind=wp), parameter :: dcrita = 1.0e-10_wp
real(kind=r8), external :: ddot_

! normalization of av_eigenvector.
s = Zero
s = ddot_(n,av,1,av,1)
s = sqrt(s)
s = max(s,dcrita)
do i=1,n
  av(i) = av(i)/s
end do

return

end subroutine norm_a

subroutine orth_ab(n,av,bv)  !bv:basis, av:vector for orth

use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: av(n)
real(kind=wp), intent(in) :: bv(n)
integer(kind=iwp) :: i
real(kind=wp) :: s
real(kind=r8), external :: ddot_

! orthogonalization av,bv
s = ddot_(n,av,1,bv,1)

do i=1,n
  av(i) = av(i)-s*bv(i)
end do

return

end subroutine orth_ab

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
*               2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine PLF_LDF_JK_2P_2(TInt,nTInt,Map,
     &                           AOint,ijkl,iCmp,jCmp,kCmp,lCmp,
     &                           iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*          Modified for Local DF, Thomas Bondo Pedersen, June 2010     *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit None
      Integer nTInt
      Real*8  TInt(nTInt)
      Integer Map(4)
      Integer ijkl, iCmp, jCmp, kCmp, lCmp
      Real*8  AOInt(ijkl,iCmp,jCmp,kCmp,lCmp)
      Integer iAO(4), iAOst(4)
      Integer iBas, jBas, kBas, lBas
      Integer kOp(4)
#include "localdf_bas.fh"
#include "localdf_int2.fh"
#include "WrkSpc.fh"

      Character*15 SecNam
      Parameter (SecNam='PLF_LDF_JK_2P_2')

      Integer i1, i2, i3, i4
      Integer iShlJ, iShlK
      Integer jSO, lSO, kSO
      Integer jSOj, lSOl, kSOk
      Integer ll, jj, kk
      Integer iShlKL, kl, kl0
      Integer nijkl
      Integer Jkl

      Integer i, j
      Integer nBasSh, iShlSO, iRow, iCol
#if defined (_DEBUGPRINT_)
      Integer iSOShl
      iSOShl(i)=iWork(ip_iSOShl-1+i)
#endif
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iShlSO(i)=iWork(ip_iShlSO-1+i)
      iRow(i,j)=iWork(ip_AB_IndxG-1+l_AB_IndxG_1*(j-1)+i)
      iCol(i,j)=iWork(ip_CD_IndxG2-1+l_CD_IndxG2_1*(j-1)+i)

      If (Map(1).eq.1 .and. Map(2).eq.2 .and.
     &    Map(3).eq.3 .and. Map(4).eq.4) Then
#if defined (_DEBUGPRINT_)
         If (iSOShl(iAOtSO(iAO(1)+1,kOp(1))+iAOst(1)).ne.SHA) Then
            Call WarningMessage(2,SecNam//': Shell problem [1]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(2)+1,kOp(2))+iAOst(2)).ne.SHB) Then
            Call WarningMessage(2,SecNam//': Shell problem [2]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)).ne.SHC) Then
            Call WarningMessage(2,SecNam//': Shell problem [3]')
            Call LDF_Quit(1)
         End If
         If (iSOShl(iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)).ne.SHD) Then
            Call WarningMessage(2,SecNam//': Shell problem [4]')
            Call LDF_Quit(1)
         End If
         If (iCmp*iBas.ne.1) Then
            Call WarningMessage(2,
     &                          SecNam//': Shell dimension problem [1]')
            Call LDF_Quit(1)
         End If
#endif
         iShlJ=SHB
         iShlK=SHC
         iShlKL=SPCD
         i1=1
         Do i4=1,lCmp
            lSO=iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
            Do i3=1,kCmp
               kSO=iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
               Do i2=1,jCmp
                  jSO=iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
                  nijkl=0
                  Do lSOl=lSO,lSO+lBas-1
                     ll=iShlSO(lSOl)
                     kl0=nBasSh(iShlK)*(ll-1)
                     Do kSOk=kSO,kSO+kBas-1
                        kk=iShlSO(kSOk)
                        kl=kl0+kk
                        If (iCol(kl,iShlKL).gt.0) Then
                           Do jSOj=jSO,jSO+jBas-1
                              jj=iShlSO(jSOj)
                              nijkl=nijkl+1
                              If (iRow(jj,iShlJ).gt.0) Then
                                 Jkl=nAB*(iCol(kl,iShlKL)-1)
     &                              +iRow(jj,iShlJ)
                                 TInt(Jkl)=AOInt(nijkl,i1,i2,i3,i4)
                              End If
                           End Do
                        Else
                           nijkl=nijkl+jBas
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
      Else
         Call WarningMessage(2,
     &                    SecNam//': shell reordering not implemented!')
         Call LDF_Quit(1)
      End If

#ifndef _DEBUGPRINT_
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iBas)
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine max5(wrk,wrksize,nind,v,text)
! this routine finds and types:
! a) note
! b) 5 maximal elements with their indices in given vector V
! c) euclidian norm
!
! nind - number of indices in V (I)
! v    - map type of V (I)
! text - notice (I)

use ccsd_global, only: dimm, fullprint, Map_Type
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, nind
real(kind=wp), intent(in) :: wrk(wrksize)
type(Map_Type), intent(in) :: v
character(len=8), intent(in) :: text
integer(kind=iwp) :: a, b, i, imax(8,5), it, j, nhelp1
real(kind=wp) :: rmax(5), val

!0 set rmax,imax=0

rmax(:) = Zero
imax(:,:) = 0

if (nind == 2) then

  !1 T1aa or T1bb amplitudes

  !1.1 find 5 max

  nhelp1 = v%d(1,1)
  do it=1,v%d(0,5)
    do i=1,dimm(v%d(0,2),v%d(it,4))
      do a=1,dimm(v%d(0,1),v%d(it,3))
        val = wrk(nhelp1)
        ! write this amplitude
        if (abs(val) >= abs(rmax(5))) call max5h1(imax,rmax,v%d(it,3),0,v%d(it,4),0,a,0,i,0,val)
        nhelp1 = nhelp1+1
      end do
    end do
  end do

  !1.2 write output
  if (fullprint >= 0) call max5h2(wrk,wrksize,nind,v,rmax,imax,text)

else if (v%d(0,6) == 0) then

  !2 T2abab amplitudes

  !2.1 find 5 max

  nhelp1 = v%d(1,1)
  do it=1,v%d(0,5)
    do j=1,dimm(v%d(0,4),v%d(it,6))
      do i=1,dimm(v%d(0,3),v%d(it,5))
        do b=1,dimm(v%d(0,2),v%d(it,4))
          do a=1,dimm(v%d(0,1),v%d(it,3))
            val = wrk(nhelp1)
            ! write this amplitude
            if (abs(val) >= abs(rmax(5))) call max5h1(imax,rmax,v%d(it,3),v%d(it,4),v%d(it,5),v%d(it,6),a,b,i,j,val)
            nhelp1 = nhelp1+1
          end do
        end do
      end do
    end do
  end do

  !2.2 write output
  if (fullprint >= 0) call max5h2(wrk,wrksize,nind,v,rmax,imax,text)

else

  !3 T2aaaa or T2bbbb amplitudes

  !3.1 find 5 max

  nhelp1 = v%d(1,1)
  do it=1,v%d(0,5)

    if (v%d(it,3) == v%d(it,4)) then
      ! case syma=symb, symi=symj

      do i=2,dimm(v%d(0,3),v%d(it,5))
        do j=1,i-1
          do a=2,dimm(v%d(0,1),v%d(it,3))
            do b=1,a-1
              val = wrk(nhelp1)
              ! write this amplitude
              if (abs(val) >= abs(rmax(5))) call max5h1(imax,rmax,v%d(it,3),v%d(it,4),v%d(it,5),v%d(it,6),a,b,i,j,val)
              nhelp1 = nhelp1+1
            end do
          end do
        end do
      end do

    else
      ! case syma>symb, symi> symj
      do j=1,dimm(v%d(0,4),v%d(it,6))
        do i=1,dimm(v%d(0,3),v%d(it,5))
          do b=1,dimm(v%d(0,2),v%d(it,4))
            do a=1,dimm(v%d(0,1),v%d(it,3))
              val = wrk(nhelp1)
              ! write this amplitude
              if (abs(val) >= abs(rmax(5))) call max5h1(imax,rmax,v%d(it,3),v%d(it,4),v%d(it,5),v%d(it,6),a,b,i,j,val)
              nhelp1 = nhelp1+1
            end do
          end do
        end do
      end do
    end if

  end do

  !3.2 write output
  if (fullprint >= 0) call max5h2(wrk,wrksize,nind,v,rmax,imax,text)

end if

return

end subroutine max5

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRCHAM(NSS,CHAMR,CHAMI)
! Write out a complex Hamiltonian (or other hermitian matrix)
! in a triangular format.

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSS
real(kind=wp), intent(in) :: CHAMR(NSS,NSS), CHAMI(NSS,NSS)
integer(kind=iwp) :: ISS, JEND, JSS, JSTA

do JSTA=1,NSS,2
  JEND = min(NSS,JSTA+1)
  write(u6,*)
  write(u6,'(1X,A8,11X,I4,33X,I4)') 'SO-STATE',(JSS,JSS=JSTA,JEND)
  do ISS=JSTA,NSS
    write(u6,'(1X,I4,2x,2(A1,F15.11,A1,F15.11,A1,3x))') ISS,('(',CHAMR(ISS,JSS),',',CHAMI(ISS,JSS),')',JSS=JSTA,min(ISS,JEND))
  end do
end do

end subroutine PRCHAM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Ci_Ci(ipcid,ips2)

use ipPage, only: ipin, W
use MCLR_Data, only: INT2, FIMO
use MCLR_procedures, only: CISigma_sa
use input_mclr, only: ERASSCF, NCSF, nRoots, PotNuc, rIn_Ene, State_Sym, Weight
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ipCID, ipS2
integer(kind=iwp) :: i, n
real(kind=wp) :: EC, rDum(1)

call CISigma_sa(0,state_sym,state_sym,FIMO,size(FIMO),Int2,size(Int2),rDum,1,ipCId,ips2,.true.)
call ipin(ipCId)
call ipin(ipS2)
n = ncsf(State_Sym)
do i=1,nroots
  EC = (rin_ene+potnuc-ERASSCF(i))*Weight(i)
  W(ipS2)%A((i-1)*n+1:i*n) = W(ipS2)%A((i-1)*n+1:i*n)+EC*W(ipCId)%A((i-1)*n+1:i*n)
end do
W(ipS2)%A(1:nroots*ncsf(state_SYM)) = Two*W(ipS2)%A(1:nroots*ncsf(state_SYM))

end subroutine Ci_Ci

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Giovanni Li Manni                                *
!               2019, Oskar Weser                                      *
!***********************************************************************

#include "macros.fh"

module fcidump_dump

use fcidump_tables, only: FockTable, length, OrbitalTable, TwoElIntTable
use Definitions, only: wp, iwp

implicit none
private

public :: dump_ascii, dump_hdf5

contains

!>  @brief
!>    Create FCIDUMP file
!>
!>  @author Oskar Weser
!>
!>  @details
!>  Create an ASCII formatted FCIDUMP with core energy,
!>  orbital energies, Fock matrix elements and two electron integrals.
!>  Contains information about \p nAsh, \p nActEl,
!>  \p iSpin, and \p stSym.
!>
!>  @param[in] path
!>  @param[in] EMY Core energy
!>  @param[in] orbital_table Orbital energies with index
!>  @param[in] fock_table
!>  @param[in] two_el_table
!>  @param[in] orbsym
subroutine dump_ascii(path,EMY,orbital_table,fock_table,two_el_table,orbsym)

  use general_data, only: nActEl, iSpin, stSym, nAsh

  character(len=*), intent(in) :: path
  real(kind=wp), intent(in) :: EMY
  type(OrbitalTable), intent(in) :: orbital_table
  type(FockTable), intent(in) :: fock_table
  type(TwoElIntTable), intent(in) :: two_el_table
  integer(kind=iwp), intent(in) :: orbsym(:)
  integer(kind=iwp) :: i, j, LuFCI
  integer(kind=iwp), external :: isFreeUnit

  LuFCI = isFreeUnit(38)
  call molcas_open(LuFCI,path)

  write(LuFCI,'(1X,A11,I3,A7,I3,A5,I3,A)') ' &FCI NORB=',sum(nAsh),',NELEC=',nActEl,',MS2=',ISPIN-1,','
  write(LuFCI,'(A,500(I2,","))') '  ORBSYM=',(orbsym(i),i=1,size(orbsym))
  write(LuFCI,'(2X,A5,I1)') 'ISYM=',STSYM-1
  write(LuFCI,'(A)') ' &END'

  do j=1,length(two_el_table)
    write(LuFCI,'(1X,G20.11,4I5)') two_el_table%values(j),(two_el_table%idx(i,j),i=1,4)
  end do

  do j=1,length(fock_table)
    write(LuFCI,'(1X,G20.11,4I5)') fock_table%values(j),(fock_table%idx(i,j),i=1,2),0,0
  end do

  do j=1,length(orbital_table)
    write(LuFCI,'(1X,G20.11,4I5)') orbital_table%values(j),orbital_table%idx(j),0,0,0
  end do

  write(LuFCI,'(1X,G20.11,4I5)') EMY,0,0,0,0

  close(LuFCI)

  ! ========== For testing purposes FROM HERE =============
  if ((length(orbital_table) /= 0) .and. (length(fock_table) /= 0) .and. (length(two_el_table) /= 0)) then
    call Add_Info('core energy',[EMY],1,8)
    call Add_Info('Orbital Energy',orbital_table%values(1),1,8)
    call Add_Info('Fock element',fock_table%values(1),1,8)
    call Add_Info('TwoEl Integral element',two_el_table%values(1),1,8)
  end if
  ! ========== For testing purposes TO HERE ===============

  call FastIO('STATUS')

  return

end subroutine dump_ascii

!>  @brief
!>    Create H5FCIDUMP file
!>
!>  @author Oskar Weser
!>
!>  @details
!>  Create an FCIDUMP in HDF5-file format with core energy,
!>  orbital energies, Fock matrix elements and two electron integrals.
!>  Contains information about \p nAsh, \p nSym, \p nActEl,
!>  \p iSpin, and \p stSym.
!>
!>  @param[in] path
!>  @param[in] EMY Core energy
!>  @param[in] orbital_table Orbital energies with index
!>  @param[in] fock_table
!>  @param[in] two_el_table
!>  @param[in] orbsym
subroutine dump_hdf5(path,EMY,orbital_table,fock_table,two_el_table,orbsym)

# ifdef _HDF5_
  use general_data, only: nSym, nActEl, multiplicity => iSpin, stSym, nAsh
  use gas_data, only: iDoGAS
  use sguga, only: SGS
  use mh5, only: mh5_close_dset, mh5_close_file, mh5_create_file, mh5_create_dset_int, mh5_create_dset_real, mh5_init_attr, &
                 mh5_put_dset
# endif

  character(len=*), intent(in) :: path
  real(kind=wp), intent(in) :: EMY
  type(OrbitalTable), intent(in) :: orbital_table
  type(FockTable), intent(in) :: fock_table
  type(TwoElIntTable), intent(in) :: two_el_table
  integer(kind=iwp), intent(in) :: orbsym(:)
# ifdef _HDF5_
  integer(kind=iwp) :: dset_id, file_id
  character :: lIrrep(24)

  file_id = mh5_create_file(path)

  ! symmetry information
  call Get_cArray('Irreps',lIrrep,24)
  call mh5_init_attr(file_id,'IRREP_LABELS',1,[nSym],lIrrep,3)
  call mh5_init_attr(file_id,'ORBSYM',1,[size(orbsym)],orbsym)
  call mh5_init_attr(file_id,'NORB',sum(nAsh(:nSym)))

  ! Set wavefunction type
  if (iDoGAS) then
    call mh5_init_attr(file_id,'CI_TYPE','GAS')
  else if (SGS%IFRAS == 0) then
    call mh5_init_attr(file_id,'CI_TYPE','CAS')
  else
    call mh5_init_attr(file_id,'CI_TYPE','RAS')
  end if

  call mh5_init_attr(file_id,'MOLCAS_MODULE','RASSCF')
  call mh5_init_attr(file_id,'CORE_ENERGY',EMY)
  call mh5_init_attr(file_id,'NELEC',nActEl)
  call mh5_init_attr(file_id,'MULTIPLICITY',multiplicity)
  call mh5_init_attr(file_id,'ISYM',stSym-1)

  dset_id = mh5_create_dset_int(file_id,'ORBITAL_INDEX',1,[length(orbital_table)])
  call mh5_init_attr(dset_id,'DESCRIPTION','Index for the orbitals in active space.')
  call mh5_put_dset(dset_id,orbital_table%idx)
  call mh5_close_dset(dset_id)

  dset_id = mh5_create_dset_real(file_id,'ORBITAL_ENERGIES',1,[length(orbital_table)])
  call mh5_init_attr(dset_id,'DESCRIPTION','Energies of orbitals in active space.')
  call mh5_put_dset(dset_id,orbital_table%values)
  call mh5_close_dset(dset_id)

  dset_id = mh5_create_dset_int(file_id,'FOCK_INDEX',2,[2,length(fock_table)])
  call mh5_init_attr(dset_id,'DESCRIPTION','The index i, j for the Fock matrix elements <i| F |j>.')
  call mh5_put_dset(dset_id,fock_table%idx)
  call mh5_close_dset(dset_id)

  dset_id = mh5_create_dset_real(file_id,'FOCK_VALUES',1,[length(fock_table)])
  call mh5_init_attr(dset_id,'DESCRIPTION','The Fock matrix elements <i| F |j>.')
  call mh5_init_attr(dset_id,'CUTOFF',fock_table%cutoff)
  call mh5_put_dset(dset_id,fock_table%values)
  call mh5_close_dset(dset_id)

  dset_id = mh5_create_dset_int(file_id,'TWO_EL_INT_INDEX',2,[4,length(two_el_table)])
  call mh5_init_attr(dset_id,'DESCRIPTION','The index i, j, k, l for the two electron integrals <i j | 1/r_{12} | k l >.')
  call mh5_put_dset(dset_id,two_el_table%idx)
  call mh5_close_dset(dset_id)

  dset_id = mh5_create_dset_real(file_id,'TWO_EL_INT_VALUES',1,[length(two_el_table)])
  call mh5_init_attr(dset_id,'DESCRIPTION','The two electron integrals <i j | 1/r_{12} | k l >.')
  call mh5_init_attr(dset_id,'CUTOFF',two_el_table%cutoff)
  call mh5_put_dset(dset_id,two_el_table%values)
  call mh5_close_dset(dset_id)

  call mh5_close_file(file_id)

  call FastIO('STATUS')
# else
  unused_var(EMY)
  unused_var(path)
  unused_var(orbital_table)
  unused_var(fock_table)
  unused_var(two_el_table)
  unused_var(orbsym)
# endif

end subroutine dump_hdf5

end module fcidump_dump

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine rdline_init_cvb(variat)

use casvb_global, only: inp, lenline, line
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp), intent(in) :: variat
integer(kind=iwp) :: istatus
logical(kind=iwp), parameter :: blankdelim = .true. ! BLANKDELIM signifies whether blanks are used to delimit fields
integer(kind=iwp), parameter :: nblank = 2
character(len=*), parameter :: blanks(nblank) = [' ',',']

if (variat) return
rewind(inp)
do
  read(inp,'(a)',iostat=istatus) line
  if (istatus < 0) then
    write(u6,*) ' WARNING: Initiation string not found in input file.'
    return
  end if
  call strip_blanks_cvb(line,blanks,nblank,blankdelim)
  call upcase(line)
  lenline = len_trim(line)
  if (line(1:6) == '&CASVB') exit
  !if (((.not. blankdelim) .and. (line(1:10) == '&CASVB&END')) .or. (blankdelim .and. (line(1:11) == '&CASVB &END'))) exit
end do

return

end subroutine rdline_init_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RdJobIph_td(CIVec)
************************************************************************
*                                                                      *
*     Read the contents of the JOBIPH file.                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Use Arrays, only: CMO, G2t, G2sq, G1t
      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "Files_mclr.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
#include "SysDef.fh"
      Character*72 Line
      Real*8 rdum(1)
      Character(Len=1), Allocatable:: TempTxt(:)
      Real*8, Allocatable::  Tmp2(:), G2tts(:), G2tta(:)
      Real*8, Allocatable:: CIVec(:,:)

      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

*----------------------------------------------------------------------*
*     Save the ROOT input parameter                                    *
*----------------------------------------------------------------------*
      kRoots=lRoots
*----------------------------------------------------------------------*
*     Read the table of disk adresses                                  *
*----------------------------------------------------------------------*
      Call DaName(LuJob,FnJob)
      iDisk=0
      Call iDaFile(LuJob,2,iToc,iTOCIPH,iDisk)
*----------------------------------------------------------------------*
*     Read the the system description                                  *
*----------------------------------------------------------------------*
      Call mma_allocate(TempTxt,LENIN8*MxOrb,Label='TempTxt')
      iDisk=iToc(1)
      Call WR_RASSCF_Info(LuJob,2,iDisk,
     &                    nActEl,iSpin,nSym,State_sym,nFro,
     &                    nIsh,nAsh,nDel,
     &                    nBas,MxSym,TempTxt,LENIN8*mxorb,
     &                    nConf,HeaderJP,144,
     &                    TitleJP,4*18*mxTit,PotNuc0,lRoots,
     &                    nRoots,iRoot,mxRoot,
     &                    nRs1,nRs2,nRs3,
     &                    nHole1,nElec3,iPt2,Weight)
      Call mma_deallocate(TempTxt)
*----------------------------------------------------------------------*
*     Overwrite the variable lroots if approriate                      *
*----------------------------------------------------------------------*
      If ( kRoots.ne.-1 ) then
         If ( iPt2.ne.0 ) then
            Write (6,*)
            Write (6,*) ' *** Error in subroutine RDJOBIPH_TD ***'
            Write (6,*) ' Pt2.ne.0'
            Write (6,*)
         Else if ( kRoots.gt.lRoots ) then
            Write (6,*)
            Write (6,*) ' *** Error in subroutine RDJOBIPH_TD ***'
            Write (6,*) ' kRoots.gt.lRoots'
            Write (6,*)
         End If
         lRoots=kRoots
         nRoots=1
      Else If ( nRoots.ne.1 ) then
         Write (6,*)
         Write (6,*) ' *** Error in subroutine RDJOBIPH_TD ***'
         Write (6,*) ' nRoots.ne.1'
         Write (6,*)
      End If
*----------------------------------------------------------------------*
*     Precompute the total sum of variables and size of matrices       *
*----------------------------------------------------------------------*
      ntIsh=0
      ntItri=0
      ntIsqr=0
      ntAsh=0
      ntAtri=0
      ntAsqr=0
      ntBas=0
      ntBtri=0
      ntBsqr=0
      nna=0
      Length=0
      Do 10 iSym=1,nSym
         norb(isym)=nbas(isym)-ndel(isym)
         ntIsh=ntIsh+nIsh(iSym)
         ntItri=ntItri+nIsh(iSym)*(nIsh(iSym)+1)/2
         ntIsqr=ntIsqr+nIsh(iSym)*nIsh(iSym)
         ntAsh=ntAsh+nAsh(iSym)
         ntAtri=ntAtri+nAsh(iSym)*(nAsh(iSym)+1)/2
         ntAsqr=ntAsqr+nAsh(iSym)*nAsh(iSym)
         ntBas=ntBas+nBas(iSym)
         ntBtri=ntBtri+nBas(iSym)*(nBas(iSym)+1)/2
         ntBsqr=ntBsqr+nBas(iSym)*nBas(iSym)
         nA(iSym)=nna
         nnA=nnA+nAsh(isym)
         Length=Length+nbas(isym)*norb(isym)
10    Continue
*----------------------------------------------------------------------*
*     Load the orbitals used in the last macro iteration               *
*----------------------------------------------------------------------*
*
      Call mma_allocate(CMO,Length,Label='CMO')
      Call Get_CMO(CMO,Length)
*     iDisk=iToc(9)
*     IF(IPT2.EQ.0) iDisk=iToc(2)
*     Call dDaFile(LuJob,2,CMO,ntBsqr,iDisk)
      If ( .false. ) then
         jpCMO=1
         Do 15 iSym=1,nSym
            Write(Line,'(A,i2.2)') 'MO coefficients, iSym = ',iSym
            Call RecPrt(Line,' ',CMO(jpCMO),nBas(iSym),nBas(iSym))
            jpCMO=jpCMO+nBas(iSym)*nBas(iSym)
15       Continue
      End If
*----------------------------------------------------------------------*
*     Load the CI vector for the root lRoots                           *
*----------------------------------------------------------------------*
      Call mma_allocate(CIVec,nConf,1,Label='CIVec')
      iDisk=iToc(4)
      Do i=1,lroots-1
         Call dDaFile(LuJob,0,CIVec,nConf,iDisk)
      End Do
      Call dDaFile(LuJob,2,CIVec,nConf,iDisk)
      If (.false.) Call DVcPrt('CI coefficients',' ',CIVec,nConf)
*----------------------------------------------------------------------*
*     Load state energy                                                *
*----------------------------------------------------------------------*
      Call mma_allocate(Tmp2,mxRoot*mxIter,Label='Tmp2')
      iDisk=iToc(6)
      Call dDaFile(LuJob,2,Tmp2,mxRoot*mxIter,iDisk)
      ERASSCF(1)=0.0d0
      Do 20 iter=0,mxIter-1
         Temp=Tmp2(iter*mxRoot+lRoots)
         If ( Temp.ne.0.0D0 ) ERASSCF(1)=Temp
20    Continue
      Call mma_deallocate(Tmp2)
*     If ( debug ) Write(*,*) ' RASSCF energy =',ERASSCF(1)
*
      nAct  = 0
      nAct2 = 0
      nAct4 = 0
      Do iSym = 1, nSym
       nAct = nAct + nAsh(iSym)
       nAct2=nAct2+nAsh(iSym)**2
      End Do
      Do iS = 1, nSym
       Do jS = 1, nSym
        Do kS = 1, nSym
         lS=iEOr(iEOr(is-1,js-1),ks-1)+1
         nAct4=nAct4+nAsh(iS)*nAsh(jS)*nAsh(kS)*nAsh(lS)
        End Do
       End Do
      End Do
*-----------------------------------
* One electron dens - triang stor.
*-----------------------------------
      nG1 = nAct*(nAct+1)/2
      Call mma_allocate(G1t,nG1,Label='G1t')
      G1t(:)=0.0d0
*
*--------------------------------------------------
* Triangular part of two electron dens,
* symmetric part
*--------------------------------------------------
      nG2=nG1*(nG1+1)/2

      Call mma_allocate(G2sq,nAct**4,Label='G2sq')
      Call mma_allocate(G2t,nG2,Label='G2t')
      Call mma_allocate(G2tts,nG2,Label='G2tts')
      Call mma_allocate(G2tta,nG2,Label='G2tta')
      iDisk=iToc(3)
      Do i=1,lroots-1
         Call dDaFile(LuJob,0,rdum,nG1,iDisk)
         Call dDaFile(LuJob,0,rdum,nG1,iDisk)
         Call dDaFile(LuJob,0,rdum,nG2,iDisk)
         Call dDaFile(LuJob,0,rdum,nG2,iDisk)
      End Do
      Call dDaFile(LuJob,2,G1t,nG1,iDisk)
      Call dDaFile(LuJob,0,rdum,nG1,iDisk)
      Call dDaFile(LuJob,2,G2tts,nG2,iDisk)
      Call dDaFile(LuJob,2,G2tta,nG2,iDisk)

      Do iB=1,nAct
         Do jB=1,iB
            iDij=iTri(ib,jB)
            Do kB=1,ib
               Do lB=1,kB
                  iDkl=iTri(kB,lB)
                  fact=1.0d00
                  if(iDij.ge.iDkl .and. kB.eq.lB) fact=2.0d00
                  if(iDij.lt.iDkl .and. iB.eq.jB) fact=2.0d00
                  iijkl=itri(iDij,iDkl)
                  G2t(iijkl)=Fact*G2tts(iijkl)
               End Do
            End Do
         End Do
      End Do
*
*---------------------------------------------------------------
* Rectangular part of the two el dens,
* symmetric and asymmetric contributions added
* ipG2sq = ipG2tts + ipG2tta
*-----------------------------------------------------------------
*
      Do iB=1,nAct
         Do jB=1,nact
            Factij=1.0d0
            If (ib.gt.jb) Factij=-1.0d0
            iDij=iTri(ib,jB)
            iDij2=ib+(jb-1)*NACT
            Do kB=1,nact
               Do lB=1,nact
                  Factkl=1.0d0
                  If (kb.gt.lb) Factkl=-1.0d0
                  iDkl=iTri(kB,lB)
                  iDkl2=kb+(lb-1)*NACT
                  fact=1.0d00
                  Fact2=Factij*Factkl
                  if(iDij.ge.iDkl .and. kB.eq.lB) fact=2.0d00
                  if(iDij.lt.iDkl .and. iB.eq.jB) fact=2.0d00
                  iijkl=itri(iDij,iDkl)
                  iijkl2=iDij2+nact**2*(iDkl2-1)
*
                  G2sq(iijkl2)=Fact*(G2tts(iijkl)+G2tta(iijkl)*Fact2)
               End Do
            End Do
         End Do
      End Do
      Call mma_deallocate(G2tts)
      Call mma_deallocate(G2tta)
*----------------------------------------------------------------------*
*     exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Jeppe Olsen                                      *
*               1989, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE DETSTR2(IDET,IASTR,IBSTR,NEL,NAEL,NBEL,
     *                  ISIGN,IWORK,IPRINT)
C
C     AUTHOR:        J. OLSEN, UNIV. OF LUND, SWEDEN, APRIL 1987
C     MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
C                    M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
C
C     PURPOSE:
C
C    A DETERMINANT,IDET,IS GIVEN AS A SET OF OCCUPIED SPIN ORBITALS,
C    POSITIVE NUMBER INDICATES ALPHA ORBITAL AND NEGATIVE NUMBER
C    INDICATES BETA ORBITAL .
C    FIND CORRESPONDING ALPHA STRING AND BETA STRING
C
C     SUBROUTINE CALLS:
C
C     IWRTMA,ORDSTR,ICOPY
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IDET(NEL)
      DIMENSION IASTR(NAEL),IBSTR(NBEL)
      DIMENSION IWORK(*)
C required length of IWORK : NEL
C
C FIRST REORDER SPIN ORBITALS IN ASCENDING SEQUENCE
C THIS WILL AUTOMATICALLY SPLIT ALPHA AND BETASTRING
C
      CALL ORDSTR(IDET,IWORK,NEL,ISIGN,IPRINT)
C
C ALPHA STRING IS LAST NAEL ORBITALS
      CALL ICOPY(NAEL,IWORK(NBEL+1),1,IASTR,1)
C
C BETA  STRING MUST BE COMPLETELY TURNED AROUND
      DO 10 IBEL = 1, NBEL
        IBSTR(IBEL) = -IWORK(NBEL+1-IBEL)
10    CONTINUE
C SIGN CHANGE FOR SWITCH OF BETA ORBITALS
      IEXPO = (NBEL*NBEL+NBEL)/2
      ISIGN = ISIGN * (-1) ** IEXPO
C
      IF( IPRINT.GT.30 ) THEN
        Write(6,*) ' INPUT DETERMINANT '
        CALL IWRTMA(IDET,1,NEL,1,NEL)
        Write(6,*) ' CORRESPONDING ALPHA STRING '
        CALL IWRTMA(IASTR,1,NAEL,1,NAEL)
        Write(6,*) ' CORRESPONDING BETA STRING '
        CALL IWRTMA(IBSTR,1,NBEL,1,NBEL)
        Write(6,*) ' ISIGN FOR SWITCH ', ISIGN
      END IF
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKBB(DREF,NDREF,PREF,NPREF,FD,FP)

use Index_Functions, only: iTri, nTri_Elem
use SUPERINDEX, only: KTGTU, KTU, MTGEU, MTU
use EQSOLV, only: IDBMAT, IDSMAT
use caspt2_global, only: ipea_shift, LUSBT
use caspt2_module, only: EASUM, EPSA, NASHT, NINDEP, NSYM, NTGEU, NTGEUES, NTGTU, NTGTUES, NTU, NTUES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two, Four, Eight, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF
real(kind=wp), intent(in) :: DREF(NDREF), PREF(NPREF), FD(NDREF), FP(NPREF)
integer(kind=iwp) :: I, IBADR, IBMADR, IBPADR, ID, IDIAG, IDISK, IDSM, IDSP, IDT, IDU, INSM, IP, ISYM, ITABS, ITGEU, ITGEUABS, &
                     ITGTU, ITU, ITUABS, IUABS, IXABS, IXGEY, IXGEYABS, IXGTY, IXT, IXY, IXYABS, IYABS, IYU, IYX, NAS, NASM, NASP, &
                     NBB, NBBM, NBBP, NINP
real(kind=wp) :: ATUX, ATUXY, ATUY, ATYU, ATYX, BTUXY, BTUYX, ET, EU, EX, EY, Val
real(kind=wp), allocatable :: BB(:), BBP(:), SP(:), SDP(:), BBM(:), SM(:), SDM(:)

! Set up the matrices BBP(tu,xy) and BBM(tu,xy)
! Formulae used:
!    BB(tu,xy)= 2*( Fyuxt - (A-Et-Eu-Ex-Ey)*Gyuxt )
!      + 4*dxt ( (A-Et-Ey-Eu)*Dyu - Fyu)
!      + 4*dyu ( (A-Et-Ey-Ex)*Dxt - Fxt)
!      - 2*dyt ( (A-Et-Eu-Ex)*Dxu - Fxu)
!      - 2*dxu ( (A-Et-Eu-Ey)*Dyt - Fyt)
!      + 8*dxt*dyu (Et+Ey)
!      - 4*dxu*dyt (Et+Ex)
! where A= EASUM= sum over active w of (Ew*Dww).
!    BBP(tu,xy)=BB(tu,xy)+BB(tu,yx)
!    BBM(tu,xy)=BB(tu,xy)-BB(tu,yx)

! Loop over superindex symmetry.
do ISYM=1,NSYM
  NINP = NINDEP(ISYM,2)
  if (NINP == 0) cycle
  NAS = NTU(ISYM)
  NBB = nTri_Elem(NAS)
  if (NBB > 0) call mma_allocate(BB,NBB,Label='BB')
  do ITU=1,NAS
    ITUABS = ITU+NTUES(ISYM)
    ITABS = MTU(1,ITUABS)
    IUABS = MTU(2,ITUABS)
    ET = EPSA(ITABS)
    EU = EPSA(IUABS)
    do IXY=1,ITU
      IXYABS = IXY+NTUES(ISYM)
      IXABS = MTU(1,IXYABS)
      IYABS = MTU(2,IXYABS)
      EX = EPSA(IXABS)
      EY = EPSA(IYABS)
      IBADR = iTri(ITU,IXY)
      IXT = IXABS+NASHT*(ITABS-1)
      IYU = IYABS+NASHT*(IUABS-1)
      IP = iTri(IXT,IYU)
      ATUXY = EASUM-ET-EU-EX-EY
      Val = Four*(FP(IP)-ATUXY*PREF(IP))
      ! Add  + 4*dxt ( (A-Et-Ey-Eu)*Dyu - Fyu)
      if (IXABS == ITABS) then
        ID = iTri(IYABS,IUABS)
        ATYU = EASUM-ET-EY-EU
        Val = Val+Four*(ATYU*DREF(ID)-FD(ID))
        ! Add  + 8*dxt*dyu (Et+Ey)
        if (IYABS == IUABS) Val = Val+Eight*(ET+EY)
      end if
      ! Add  + 4*dyu ( (A-Et-Ey-Ex)*Dxt - Fxt)
      if (IYABS == IUABS) then
        ID = iTri(IXABS,ITABS)
        ATYX = EASUM-ET-EY-EX
        Val = Val+Four*(ATYX*DREF(ID)-FD(ID))
      end if
      ! Add  - 2*dyt ( (A-Et-Eu-Ex)*Dxu - Fxu)
      if (IYABS == ITABS) then
        ID = iTri(IXABS,IUABS)
        ATUX = EASUM-ET-EU-EX
        Val = Val-Two*(ATUX*DREF(ID)-FD(ID))
        ! Add  - 4*dxu*dyt (Et+Ex)
        if (IXABS == IUABS) Val = Val-Four*(ET+EX)
      end if
      ! Add  - 2*dxu ( (A-Et-Eu-Ey)*Dyt - Fyt)
      if (IXABS == IUABS) then
        ID = iTri(IYABS,ITABS)
        ATUY = EASUM-ET-EU-EY
        Val = Val-Two*(ATUY*DREF(ID)-FD(ID))
      end if
      BB(IBADR) = Val
    end do
  end do
  NASP = NTGEU(ISYM)
  NBBP = nTri_Elem(NASP)
  if (NBBP > 0) then
    call mma_allocate(BBP,NBBP,Label='BBP')
    !GG.Nov03  Load in SDP the diagonal elements of SBP matrix:
    call mma_allocate(SP,NBBP,Label='SP')
    call mma_allocate(SDP,NASP,Label='SDP')
    IDSP = IDSMAT(ISYM,2)
    call DDAFILE(LUSBT,2,SP,NBBP,IDSP)
    IDIAG = 0
    do I=1,NASP
      IDIAG = IDIAG+I
      SDP(I) = SP(IDIAG)
    end do
    call mma_deallocate(SP)
    !GG End
  end if

  NASM = NTGTU(ISYM)
  NBBM = nTri_Elem(NASM)
  if (NBBM > 0) then
    call mma_allocate(BBM,NBBM,Label='BBM')
    !GG.Nov03  Load in SDM the diagonal elements of SBM matrix:
    call mma_allocate(SDM,NASM,Label='SDM')
    if (NINDEP(ISYM,3) > 0) then
      call mma_allocate(SM,NBBM,Label='SM')
      IDSM = IDSMAT(ISYM,3)
      call DDAFILE(LUSBT,2,SM,NBBM,IDSM)
      IDIAG = 0
      do I=1,NASM
        IDIAG = IDIAG+I
        SDM(I) = SM(IDIAG)
      end do
      call mma_deallocate(SM)
    end if
    !GG End
  end if

  INSM = 1
  do ITGEU=1,NASP
    ITGEUABS = ITGEU+NTGEUES(ISYM)
    ITABS = MTGEU(1,ITGEUABS)
    IUABS = MTGEU(2,ITGEUABS)
    ITU = KTU(ITABS,IUABS)-NTUES(ISYM)
    do IXGEY=1,ITGEU
      IXGEYABS = IXGEY+NTGEUES(ISYM)
      IXABS = MTGEU(1,IXGEYABS)
      IYABS = MTGEU(2,IXGEYABS)
      IXY = KTU(IXABS,IYABS)-NTUES(ISYM)
      IYX = KTU(IYABS,IXABS)-NTUES(ISYM)
      IBADR = iTri(ITU,IXY)
      BTUXY = BB(IBADR)
      IBADR = iTri(ITU,IYX)
      BTUYX = BB(IBADR)
      IBPADR = iTri(ITGEU,IXGEY)
      BBP(IBPADR) = BTUXY+BTUYX
      !GG.Nov03
      if (ITGEU == IXGEY) then
        IDT = nTri_Elem(ITABS)
        IDU = nTri_Elem(IUABS)
        BBP(IBPADR) = BBP(IBPADR)+ipea_shift*half*(DREF(IDT)+DREF(IDU))*SDP(ITGEU)
      end if
      !GG End
      if (NINDEP(ISYM,3) < 1) cycle
      if (ITABS == IUABS) cycle
      if (IXABS == IYABS) cycle
      ITGTU = KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
      IXGTY = KTGTU(IXABS,IYABS)-NTGTUES(ISYM)
      IBMADR = iTri(ITGTU,IXGTY)
      BBM(IBMADR) = BTUXY-BTUYX
      !GG.Nov03
      if (ITGEU == IXGEY) then
        IDT = nTri_Elem(ITABS)
        IDU = nTri_Elem(IUABS)
        BBM(IBMADR) = BBM(IBMADR)+ipea_shift*half*(DREF(IDT)+DREF(IDU))*SDM(INSM)
        INSM = INSM+1
      end if
      !GG.End
    end do
  end do
  if (NBB > 0) call mma_deallocate(BB)

  ! Write to disk, and save size and address.
  if ((NBBP > 0) .and. (NINDEP(ISYM,2) > 0)) then
    IDISK = IDBMAT(ISYM,2)
    call DDAFILE(LUSBT,1,BBP,NBBP,IDISK)
    call mma_deallocate(BBP)
    !GG.Nov03 DisAlloc SDP
    call mma_deallocate(SDP)
    !GG End
  end if
  if (NBBM > 0) then
    if (NINDEP(ISYM,3) > 0) then
      IDISK = IDBMAT(ISYM,3)
      call DDAFILE(LUSBT,1,BBM,NBBM,IDISK)
    end if
    call mma_deallocate(BBM)
    !GG.Nov03 DisAlloc SDM
    call mma_deallocate(SDM)
    !GG End
  end if
end do

end subroutine MKBB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine ComputeFuncB2(nOrb2Loc,ipLbl,nComp,Functional,Debug)
C
C     Author: T.B. Pedersen
C
C     Purpose: compute Boys localisation functional B2.
C
      Implicit Real*8 (a-h,o-z)
      Integer ipLbl(nComp)
      Logical Debug
#include "WrkSpc.fh"

      Functional = 0.0d0
      Do iComp = 1,nComp
         ip0 = ipLbl(iComp) - 1
         Do i = 1,nOrb2Loc
            Functional = Functional + (Work(ip0+nOrb2Loc*(i-1)+i))**2
         End Do
      End Do

      If (Debug) Then
         Write(6,*)
         Write(6,*) 'In ComputeFuncB2'
         Write(6,*) '----------------'
         Write(6,*) 'Functional B2 = ',Functional
         Write(6,*) '[Assuming doubly occupied orbitals]'
         Do iComp = 1,nComp
            ip0 = ipLbl(iComp) - 1
            Cmp = 0.0d0
            Do iMO = 1,nOrb2Loc
               Cmp = Cmp + Work(ip0+nOrb2Loc*(iMO-1)+iMO)
            End Do
            Cmp = 2.0d0*Cmp
            Write(6,'(A,I5,1X,F15.8)')
     &      'Component, Exp. Val.:',iComp,Cmp
            Do j = 1,nOrb2Loc-1
               Do i = j+1,nOrb2Loc
                  kij = ip0 + nOrb2Loc*(j-1) + i
                  kji = ip0 + nOrb2Loc*(i-1) + j
                  Tst = Work(kij) - Work(kji)
                  If (abs(Tst) .gt. 1.0d-14) Then
                     Write(6,*) 'ComputeFuncB2: broken symmetry!'
                     Write(6,*) '  Component: ',iComp
                     Write(6,*) '  i and j  : ',i,j
                     Write(6,*) '  Dij      : ',Work(kij)
                     Write(6,*) '  Dji      : ',Work(kji)
                     Write(6,*) '  Diff.    : ',Tst
                     Call SysAbendMsg('ComputeFuncB2',
     &                                'Broken symmetry!',' ')
                  End If
               End Do
            End Do
         End Do
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine DMinvCI_sa(ipSigma,rout,rC_HE_C,idsym,S)
      use ipPage, only: W
      use negpre
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "incdia.fh"
      Real*8 rC_HE_C
      Integer idsym
      Real*8 rout(*),rcoeff(mxroot),alpha(mxRoot),
     &       S(nroots,nroots,nroots)
*
*                                    -1           -1
*                               (H -E) |0><0|(H -E)|Sigma>
*                  -1             0            0
*     |rNew>=(H - E) |Sigma> - ----------------------------
*              0                               -1
*                                      <0|(H -E) |0>
*                                           0
*
      If (nconf1.gt.1) Then
       irc=ipin(ipdia)
       irc=ipin(ipsigma)
       k=0
       Do i=1,nroots
          E=ERASSCF(i)
          Do j=1,ncsf(state_SYM)
           k=k+1
           rout(k)=W(ipSigma)%Vec(k)/(W(ipdia)%Vec(j)-E)
          End Do
       End Do
       Do iR=1,nroots

!       We=weight(iR)
        E=ERASSCF(iR)
        irc=ipin(ipCI)
        Do jR=1,nroots
         rcoeff(jR)=ddot_(nconf1,rout(1+(iR-1)*ncsf(State_Sym)),1,
     &             W(ipCI)%Vec(1+(jR-1)*ncsf(State_Sym)),1)
        End Do

        Do i=1,nroots
         alpha(i)=0.0d0
         Do j=1,nroots
          alpha(i)=alpha(i)+S(i,j,iR)*rcoeff(j)
         End Do
        End Do

        Do i=1,nroots
         Do j=1,ncsf(State_Sym)
          rout(j+(iR-1)*ncsf(State_Sym))=
     &    rout(j+(iR-1)*ncsf(State_Sym))-
     &    W(ipCI)%Vec(j+(i-1)*ncsf(State_Sym))*alpha(i)
     &    /(W(ipdia)%Vec(j)-E)
         End Do
        End Do

       End Do
      Else
       call dcopy_(nconf1*nroots,[0.0d0],0,rout,1)
      End If
      return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
c Avoid unused argument warnings
      If (.False.) Then
       Call Unused_real(rC_HE_C)
       Call Unused_integer(idsym)
      End If
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_X_GetTotV(nV,n)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: return total number of vectors (over all nodes).

use Cholesky, only: Cho_Real_Par, nSym, NumCho, NumCho_Bak
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n
integer(kind=iwp), intent(out) :: nV(n)

#ifdef _DEBUGPRINT_
if (n < nSym) call Cho_Quit('Illegal input variable in Cho_X_GetTotV',104)
#endif

if (Cho_Real_Par) then
  nV(1:nSym) = NumCho_Bak(1:nSym)
else
  nV(1:nSym) = NumCho(1:nSym)
end if

end subroutine Cho_X_GetTotV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine binte (k,alfa,beta,r0,a,ggrin,nz)
      Implicit Real*8(A-H,O-Z)
#include "real.fh"
#include "welcom.fh"
      Real*8 grint(0:kmax,kmax), ggrin(nz,0:k,k/2+1,k/4+1),
     &       alfa(nz), a(nz)
*
*     iq = 1
*     Call RecPrt(' In Binte: Alfa',' ',alfa,nz,1)
*     Call RecPrt(' In Binte: A   ',' ',a   ,nz,1)
      call dcopy_(nz*(k+1)*(k/2+1)*(k/4+1),[Zero],0,ggrin,1)
      Do 110 iz=1,nz
         call dcopy_((kMax+1)*kMax,[Zero],0,grint,1)
         Call rrint(k,alfa(iz),a(iz),beta,r0,grint,kmax)
         Do 10 i=0,k
            Do 11 j=0,i,2
               j2=j/2+1
               ggrin(iz,i,j2,1)=Zero
               Do 12 l=j,i
                  If (i-l.eq.0) Then
                     ggrin(iz,i,j2,1)=ggrin(iz,i,j2,1)+
     &                    grint(l,j2)*binom(i-j,l-j)
                  Else
                     ggrin(iz,i,j2,1)=ggrin(iz,i,j2,1)+
     &                    grint(l,j2)*a(iz)**(i-l)*binom(i-j,l-j)
                  End If
12             Continue
               ind=1
               Do 13 k2=2,j2-1,2
                  tal=fiint((j-k2)/2,k2/2)/fiint(j/2,0)
                  ind=ind+1
                  ggrin(iz,i,j2,ind)=ggrin(iz,i,j2,1)*tal
13             Continue
11          Continue
10       Continue
110   Continue
*
*     Call RecPrt(' In Binte: Ggrin',' ',
*    &            Ggrin,nz,(k+1)*(k/2+1)*(k/4+1))
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Integral_RI_2( &
#                        define _CALLING_
#                        include "int_wrout_interface.fh"
                        )
! calls the proper routines IndSft/PLF
! if IntOrd_jikl == .true. integral order within symblk: jikl
!                   else  integral order within symblk: ijkl

use RI_glob, only: iOffA, SO2Ind
use Definitions, only: wp, iwp

implicit none
#include "int_wrout_interface.fh"

#include "macros.fh"
unused_var(MapOrg)
unused_var(iBas)
unused_var(kBas)
unused_var(IJeqKL)
unused_var(iSOSym)
unused_var(nSkal)
unused_var(itOffs)

if (mSym == 1) then
  call PLF_RI_2(AOInt,ijkl,iCmp(2),iCmp(4),iAO,iAOst,jBas,lBas,kOp,TInt,nTInt,SO2Ind,iOffA,nSOs)
else
  call IndSft_RI_2(iCmp,iShell,jBas,lBas,Shijij,iAO,iAOst,ijkl,SOInt,nSOint,nSOs,TInt,nTInt,SO2Ind,iOffA)
end if

return

end subroutine Integral_RI_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Per Ake Malmqvist                                *
*               2018, Jesper Norell                                    *
*               2018, Joel Creutzberg                                  *
*               2023, Ignacio Fdez. Galvan                             *
************************************************************************
      SUBROUTINE SODYSORB(NSS,USOR,USOI,DYSAMPS,NZ,SOENE)
      use rassi_global_arrays, only: SFDYS, SODYSAMPS,
     &                               SODYSAMPSR, SODYSAMPSI, JBNUM
      use OneDat, only: sNoNuc, sNoOri
      use stdalloc, only: mma_allocate, mma_deallocate
      use Cntrl, only: NSTATE, DYSEXPORT, DYSEXPSO, MLTPLT
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: NBASF,NOSH

      IMPLICIT None
      Integer NSS, NZ
      REAL*8 USOR(NSS,NSS), USOI(NSS,NSS)
      ! Array for calculation of amplitudes
      Real*8 DYSAMPS(NSTATE,NSTATE)
      ! Arrays for orbital export
      Real*8 SOENE(NSS)

      ! Arrays, bounds, and indices
      REAL*8    MSPROJI,MSPROJJ, CJR, CJI, CIR, CII, CREAL, CIMAG,
     &          AMPLITUDE, AMPR, AMPI
      INTEGER   SOTOT,SFTOT
      INTEGER   ORBNUM
      INTEGER   SODYSCIND
      INTEGER   SFI,SFJ,ZI,ZJ,NSZZ,NDUM
      INTEGER   ISTATE, JOB1, MPLET1, MSPROJ, JSTATE, NSSQ, NPROD, ISY,
     &          NO, NB, IRC, IOPT, ICMP, ISYLAB, NOFF, JEIG, IEIG, LUNIT
      INTEGER, EXTERNAL:: IsFreeUnit

      ! Arrays for calculation of amplitudes
      Real*8 SODYSCOFSR(NZ),SODYSCOFSI(NZ)
      Real*8 SZZFULL(NZ,NZ)

      ! Arrays for orbital export
      Real*8 SODYSCMOR(NZ*NSS)
      Real*8 SODYSCMOI(NZ*NSS)
      Real*8 DYSEN(NSS)
      Real*8 AMPS(NSS)
      Character(LEN=30) Filename
      Character(LEN=80) TITLE
      character(len=8) :: Label


      Integer, Allocatable:: SO2SF(:)
      Real*8, Allocatable:: MSPROJS(:), SZZ(:)

! +++ J.Norell 2018

C Calculates spin-orbit Dyson orbitals
C The routine was in some part adapted from DO_SONATORB

C Computes SO Dyson amplitudes by expanding the SF results with
C the SO eigenvectors (of the complex Hamiltonian)
C 1. (Fast): Compute the SO amplitudes directly from the SF amplitudes
C    (approximation) for all states
C 2. (Slower): Compute the full SO Dyson orbitals for the requested
C    initial states and export them to .molden format. SO amplitudes
C    are correctly calculated for these states.

! IFG: Added DysOrb export, not sure it's correct

! ****************************************************************

C Setup SO2SF list which contains the original SF state numbers
C as a function of the SO state number
C And MSPROJS which saves their ms projections for later use

      CALL mma_allocate(SO2SF,NSS,Label='SO2SF')
      CALL mma_allocate(MSPROJS,NSS,Label='MSPROJS')
      SOTOT=0
      SFTOT=0
      DO ISTATE=1,NSTATE
       JOB1=JBNUM(ISTATE)
       MPLET1=MLTPLT(JOB1)
       SFTOT=SFTOT+1

       DO MSPROJ=-MPLET1+1,MPLET1-1,2
        SOTOT=SOTOT+1
        SO2SF(SOTOT)=SFTOT
        MSPROJS(SOTOT)=MSPROJ

       END DO ! DO MSPROJ1=-MPLET1+1,MPLET1-1,2
      END DO ! DO ISTATE=1,NSTATE

      IF(.NOT.DYSEXPORT) THEN ! Approximative amplitude calculation

C Now construct the SF dysamps in the multiplicity expanded basis
C (initially all real, therefore put into SODYSAMPSR)
      SODYSAMPSR(:,:)=0.0D0
      SODYSAMPSI(:,:)=0.0D0
      DO JSTATE=1,NSS
         DO ISTATE=JSTATE+1,NSS
          SFJ=SO2SF(JSTATE)
          SFI=SO2SF(ISTATE)
          SODYSAMPSR(JSTATE,ISTATE)=DYSAMPS(SFJ,SFI)
          SODYSAMPSR(ISTATE,JSTATE)=DYSAMPS(SFJ,SFI)
         END DO
      END DO

C Now perform the transformation from SF dysamps to SO dysamps
C by combining the multiplicity expanded SF dysamps with the
C SO eigenvector in the ZTRNSF routine.
      CALL ZTRNSF(NSS,USOR,USOI,SODYSAMPSR,SODYSAMPSI)

C Compute the magnitude of the complex amplitudes as an approximation
      SODYSAMPSR(:,:)=SODYSAMPSR*SODYSAMPSR
      SODYSAMPSI(:,:)=SODYSAMPSI*SODYSAMPSI
      SODYSAMPS(:,:)=SQRT(SODYSAMPSR+SODYSAMPSI)

      END IF ! Approximative amplitude calculation

! ****************************************************************

      IF (.NOT.DYSEXPORT) THEN
       GOTO 100
      END IF

! Export part of the routine and exact calculation of amplitudes

! Read in the atomic overlap matrix, that will be needed below for
! for normalization of DOs
! (Code from mksxy)
      NSZZ=0
      NSSQ=0
      NPROD=0
      DO ISY=1,NSYM
        NO=NOSH(ISY)
        NB=NBASF(ISY)
        NSZZ=NSZZ+(NB*(NB+1))/2
        NSSQ=MAX(NSSQ,NB**2)
        NPROD=MAX(NPROD,NO*NB)
      END DO
      CALL mma_allocate(SZZ,NSZZ,Label='SZZ')
      IRC=-1
      IOPT=ibset(ibset(0,sNoOri),sNoNuc)
      ICMP=1
      ISYLAB=1
      Label='MLTPL  0'
      CALL RDONE(IRC,IOPT,Label,ICMP,SZZ,ISYLAB)
      IF ( IRC.NE.0 ) THEN
        WRITE(6,*)
        WRITE(6,*)'      *** ERROR IN SUBROUTINE SODYSORB ***'
        WRITE(6,*)'     OVERLAP INTEGRALS ARE NOT AVAILABLE'
        WRITE(6,*)
        CALL ABEND()
      ENDIF

! SZZ is originally given in symmetry-blocked triangular form,
! lets make it a full matrix for convenience
      SZZFULL=0.0D0
      NDUM=1
      NOFF=0
      DO ISY=1,NSYM
       NB=NBASF(ISY)
       DO ZJ=1,NB
        DO ZI=1,ZJ
         SZZFULL(ZJ+NOFF,ZI+NOFF)=SZZ(NDUM)
         SZZFULL(ZI+NOFF,ZJ+NOFF)=SZZ(NDUM)
         NDUM=NDUM+1
        END DO
       END DO
       NOFF=NOFF+NB
      END DO
      CALL mma_deallocate(SZZ)

! ****************************************************************

C Multiply together with the SO eigenvector coefficients with the SF
C Dyson orbital coefficients in the atomic basis to obtain the full
C SO Dyson orbitals

C Multiply together with the SO eigenvector coefficients with the SF
C Dyson orbital coefficients in the atomic basis to obtain
C SO Dyson orbitals

      SODYSAMPS(:,:)=0.0D0
      ! For all requested initial states J and all final states I
      DO JSTATE=1,DYSEXPSO

         ! For each initial state JSTATE up to DYSEXPSFSO we will
         ! gather all the obtained Dysorbs
         ! and export to a shared .molden file
         SODYSCIND=0 ! Orbital coeff. index
         ORBNUM=0 ! Dysorb index for given JSTATE
         SODYSCMOR=0.0D0 ! Real orbital coefficients
         SODYSCMOI=0.0D0 ! Imaginary orbital coefficients
         DYSEN=0.0D0 ! Orbital energies
         AMPS=0.0D0 ! Transition amplitudes (shown as occupations)

         DO ISTATE=JSTATE+1,NSS

          ! Reset values for next state combination
          SODYSCOFSR=0.0D0
          SODYSCOFSI=0.0D0

          ! Iterate over the eigenvector components of both states
          DO JEIG=1,NSS

           ! Coefficient of first state
           CJR=USOR(JEIG,JSTATE)
           CJI=USOI(JEIG,JSTATE)
           ! Find the corresponding SF states
           SFJ=SO2SF(JEIG)

           DO IEIG=1,NSS

            ! Coefficient of second state
            CIR=USOR(IEIG,ISTATE)
            CII=USOI(IEIG,ISTATE)
            ! Find the corresponding SF states
            SFI=SO2SF(IEIG)

            ! Check change in ms projection
            MSPROJJ=MSPROJS(JEIG)
            MSPROJI=MSPROJS(IEIG)
            ! Check |delta ms|=0.5 selection rule
            IF(ABS(MSPROJJ-MSPROJI).NE.1) THEN
             CYCLE
            END IF

            IF (DYSAMPS(SFJ,SFI).GT.1.0D-5) THEN
             ! Multiply together coefficients
             CREAL=CJR*CIR+CJI*CII
             CIMAG=CJR*CII-CJI*CIR
             ! Multiply with the corresponding SF Dyson orbital
             SODYSCOFSR=SODYSCOFSR+CREAL*SFDYS(:,SFJ,SFI)
             SODYSCOFSI=SODYSCOFSI+CIMAG*SFDYS(:,SFJ,SFI)
            END IF

           END DO ! IEIG
          END DO ! JEIG

! Normalize the overlap of SODYSCOFS expanded orbitals with the
! atomic overlap matrix SZZ to obtain correct amplitudes

          AMPLITUDE=0.0D0

          DO ZJ=1,NZ
           DO ZI=1,NZ
            AMPR=SODYSCOFSR(ZJ)*SODYSCOFSR(ZI)
     &            +SODYSCOFSI(ZJ)*SODYSCOFSI(ZI)
            AMPI=SODYSCOFSI(ZJ)*SODYSCOFSR(ZI)
     &            -SODYSCOFSR(ZJ)*SODYSCOFSI(ZI)
            AMPLITUDE=AMPLITUDE+(AMPR+AMPI)*SZZFULL(ZJ,ZI)
           END DO ! ZI
          END DO ! ZJ

          AMPLITUDE=SQRT(AMPLITUDE)
          SODYSAMPS(JSTATE,ISTATE)=AMPLITUDE
          SODYSAMPS(ISTATE,JSTATE)=AMPLITUDE

          ! Export Re and Im part of the coefficients
          IF (AMPLITUDE.GT.1.0D-5) THEN
           DO NDUM=1,NZ
              SODYSCIND=SODYSCIND+1
              SODYSCMOR(SODYSCIND)=SODYSCOFSR(NDUM)
              SODYSCMOI(SODYSCIND)=SODYSCOFSI(NDUM)
           END DO
           ORBNUM=ORBNUM+1
           DYSEN(ORBNUM)=SOENE(ISTATE)-SOENE(JSTATE)
           AMPS(ORBNUM)=AMPLITUDE*AMPLITUDE
          END IF

        END DO ! ISTATE

! If at least one orbital was found, export it/them
        IF(ORBNUM.GT.0) THEN
         Write(filename,'(A,I0,A3)') 'MD_DYS.SO.',JSTATE,'.Re'
         Call Molden_DysOrb(filename,DYSEN,AMPS,SODYSCMOR,ORBNUM,NZ)
         Write(filename,'(A,I0,A3)') 'MD_DYS.SO.',JSTATE,'.Im'
         Call Molden_DysOrb(filename,DYSEN,AMPS,SODYSCMOI,ORBNUM,NZ)

         ! This does not work for SO-Dyson orbitals, because they may
         ! contain contributions from several irreps.
         ! Either that's a bug elsewhere in the code, or the InpOrb
         ! format is not adequate for these orbitals.
         Write(filename,'(A,I0,A3)') 'DYSORB.SO.',JSTATE,'.Re'
         LUNIT=IsFreeUnit(50)
         Write(TITLE,'(A,I0,A)') '* Spin-orbit Dyson orbitals for '//
     &                           'state ',JSTATE,' (real part)'
         Call WRVEC_DYSON(filename,LUNIT,NSYM,NBASF,ORBNUM,SODYSCMOR,
     &                    AMPS,DYSEN,Trim(TITLE),NZ)
         Write(filename,'(A,I0,A3)') 'DYSORB.SO.',JSTATE,'.Im'
         Write(TITLE,'(A,I0,A)') '* Spin-orbit Dyson orbitals for '//
     &                           'state ',JSTATE,' (imaginary part)'
         Call WRVEC_DYSON(filename,LUNIT,NSYM,NBASF,ORBNUM,SODYSCMOI,
     &                    AMPS,DYSEN,Trim(TITLE),NZ)
         Close(LUNIT)
        END IF

       END DO ! JSTATE

100    CONTINUE

! ****************************************************************

C Free all the allocated memory

      Call mma_deallocate(SO2SF)
      Call mma_deallocate(MSPROJS)

      END SUBROUTINE SODYSORB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989, Per Ake Malmqvist                           *
!***********************************************************************

subroutine PART(SXY,TRA1,TRA2)
! PURPOSE: SXY CONTAINS THE NONSECONDARY PART OF THE MO OVERLAP
! MATRIX. UPON RETURN, TRA1 AND TRA2 WILL CONTAIN THE COEFFICIENTS
! FOR SEQUENTIAL SINGLE-ORBITAL TRANSFORMATIONS (VI.2, MY IJQC ARTICLE)
! TO BIORTHONORMAL ORBITALS. SXY, TRA1 AND TRA2 ARE SYMMETRY-BLOCKED.
! ORIGINAL VERSION, MALMQUIST 84-04-04
! RASSCF VERSION,   MALMQUIST 89-11-15

use rasdef, only: NRS1, NRS2, NRS3
use Symmetry_Info, only: nIrrep
use rassi_data, only: NISH, NOSH, NSXY, NTRA
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: SXY(NSXY)
real(kind=wp), intent(out) :: TRA1(NTRA), TRA2(NTRA)
integer(kind=iwp) :: II, ISY, N, NBLOCK, NDIMEN, NOMAX, NSIZE(4)
integer(kind=iwp), allocatable :: ScrPiv(:)
real(kind=wp), allocatable :: ScrBuf(:), ScrMat(:)

NOMAX = maxval(NOSH(1:nIrrep))
call mma_allocate(SCRMAT,NOMAX*NOMAX,Label='ScrMat')
call mma_allocate(SCRPIV,2*NOMAX,Label='ScrPiv')
call mma_allocate(SCRBUF,NOMAX,Label='ScrBuf')
II = 1
do ISY=1,nIrrep
  NDIMEN = NOSH(ISY)
  if (NDIMEN == 0) cycle
  NBLOCK = 0
  N = NISH(ISY)
  if (N > 0) then
    NBLOCK = NBLOCK+1
    NSIZE(NBLOCK) = N
  end if
  N = NRS1(ISY)
  if (N > 0) then
    NBLOCK = NBLOCK+1
    NSIZE(NBLOCK) = N
  end if
  N = NRS2(ISY)
  if (N > 0) then
    NBLOCK = NBLOCK+1
    NSIZE(NBLOCK) = N
  end if
  N = NRS3(ISY)
  if (N > 0) then
    NBLOCK = NBLOCK+1
    NSIZE(NBLOCK) = N
  end if
  call PART1(NDIMEN,NBLOCK,NSIZE,SXY(II),TRA1(II),TRA2(II),SCRMAT,SCRPIV,SCRBUF)
  II = II+NDIMEN**2
end do
call mma_deallocate(SCRMAT)
call mma_deallocate(SCRPIV)
call mma_deallocate(SCRBUF)

end subroutine PART

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      LOGICAL FUNCTION Reduce_Prt()
*
      IMPLICIT NONE
      INTEGER :: i,Err
      CHARACTER(LEN=80) :: Word
      CHARACTER(LEN=100) :: SuperName
      CHARACTER(LEN=100), EXTERNAL :: Get_SuperName, Get_ProgName
*
      Reduce_Prt = .FALSE.
*
*     Do not reduce printing in last_energy
*
      SuperName = Get_SuperName()
      IF (SuperName .eq. 'last_energy') RETURN
*
*     Reduce printing if iter > 1
*
      CALL GetEnvF("MOLCAS_ITER",Word)
      READ (Word,*) i
      IF (i .gt. 1) Reduce_Prt = .TRUE.
*
*     ... but not if MOLCAS_REDUCE_PRT = NO
*
      IF (Reduce_Prt) THEN
        CALL GetEnvF("MOLCAS_REDUCE_PRT",Word)
        IF (Word(1:1) .eq. 'N') Reduce_Prt = .FALSE.
      END IF
*
*     ... or if we are not inside a loop (EMIL_InLoop < 1)
*
      IF (Reduce_Prt) THEN
        CALL GetEnvF("EMIL_InLoop",Word)
        i = 0
        READ (Word,*,IOSTAT=Err) i
        IF (i .lt. 1) Reduce_Prt = .FALSE.
      END IF
*
*     ... or if first iteration of a saddle branch (SADDLE_FIRST = 1)
*
      IF (Reduce_Prt) THEN
        CALL GetEnvF("SADDLE_FIRST",Word)
        i = 0
        READ (Word,*,IOSTAT=Err) i
        IF (i .eq. 1) Reduce_Prt = .FALSE.
      END IF
*
*     In any case, reduce printing inside numerical gradients,
*     unless specified otherwise (MOLCAS_REDUCE_NG_PRT = NO).
*
      IF (.NOT. Reduce_Prt) THEN
        IF ((SuperName .eq. 'numerical_gradient') .AND.
     &      (Get_ProgName() .ne. 'numerical_gradient')) THEN
          CALL GetEnvF("MOLCAS_REDUCE_NG_PRT",Word)
          IF (Word(1:1) .ne. 'N') Reduce_Prt = .TRUE.
        END IF
      END IF
*
      RETURN
*
      END FUNCTION

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Diff_MotherGoose(Diffuse,nAt,nB,ipMP,ipC,nij,ip_EC
     &                           ,ip_ANr,ip_Ttot
     &                           ,ip_Ttot_Inv,lMax,iTP,dLimmo
     &                           ,Thrs1,Thrs2,nThrs,iPrint
     &                           ,ThrsMul,LuYou)
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"

      Dimension dLimmo(2),Pot_Expo(nij*2),Pot_Point(nij)
      Dimension Pot_Fac(nij*4)

      Logical Diffuse(3),Diffed(nij*2)

*
*-- Sag hej till publiken.
*
      Write(6,'(A)')'  Enter Slater charge distribution section.'
*
*-- Take different route for the different methods for getting
*   diffuse distributions.
*
      If(Diffuse(2)) then
        Write(6,'(A)')'    ---Run a non-linear fit,'
     &              //' (Levenberg-Marquart).'
        Write(6,'(A)')'        Thresholds'
        Write(6,991)'           Delta                   :',Thrs1
        Write(6,991)'           Lambda                  :',Thrs2
        Write(6,991)'           Factor                  :',ThrsMul
        Write(6,992)'           Min. decreasing steps   :',nThrs
        Write(6,'(A)')'        Local limit factors'
        Write(6,993)'           Low:',dLimmo(1),'     High:',dLimmo(2)
        Call Diff_Numerical(nAt,nB,ipMP,ipC,nij,Work(ip_EC)
     &                     ,iWork(ip_ANr),ip_Ttot
     &                     ,ip_Ttot_Inv,lMax,iTP,dLimmo
     &                     ,Thrs1,Thrs2,nThrs,iPrint
     &                     ,ThrsMul,Pot_Expo,Pot_Point,Pot_Fac
     &                     ,Diffed)
      Elseif(Diffuse(3)) then
        Write(6,*)
        Write(6,*)'Not programmed yet, bitte sehr.'
        Call Abend()
      Endif
991   Format(A,E12.5)
992   Format(A,I2)
993   Format(2(A,F10.5))

*
*-- Print, analyze uzw, the result of the diffuse stuff.
*
      Call WeGotThis(nAt,nB,ipMP,ipC,nij,Work(ip_EC)
     &              ,iWork(ip_ANr),ip_Ttot
     &              ,ip_Ttot_Inv,lMax,iTP,iPrint
     &              ,Pot_Expo,Pot_Point,Pot_Fac,Diffed)

*
*-- Generate file with information for other programs.
*
      lMaxF=1
      Call YouGetThis(nAt,Work(ip_EC),Pot_Expo,Pot_Point,Pot_Fac
     &               ,Diffed,ipMP,lMax,lMaxF,nij,LuYou)


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine change3_cvb()
      implicit real*8 (a-h,o-z)
      logical changed
c ... Change of dimensioning variables ...
      logical, external :: chpcmp_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "rls_cvb.fh"
#include "WrkSpc.fh"

      changed=.false.
c Spin functions coefficients (BIKCOF) + inverse (AIKCOF)
c  Get KBASISCVB if we don't know it already (eqv. to
c  GETGUESS later):
c  Need to reserve enough space for both KBASIS and KBASISCVB
c  --> figure out which one needs most :
      if((kbasis.gt.2.and.kbasis.ne.6).or.
     >   (kbasiscvb.gt.2.and.kbasiscvb.ne.6))then
        kmost=3
      elseif(kbasis.le.2.or.kbasiscvb.le.2)then
        kmost=1
      else
        kmost=6
      endif
      if(chpcmp_cvb(kmost))changed=.true.
      if(changed)call touch_cvb('MEM3')
      return

      entry chop3_cvb()
      if(release(3))call mfreer_cvb(lb(1))
      release(3)=.true.
      release(4)=.false.

      call icomb_cvb(nel,nbet,iretval1)
      call icomb_cvb(nel,nbet-1,iretval2)
      mxfns=iretval1-iretval2
      if(kbasis.eq.5)call icomb_cvb(nel,nalf,mxfns)
      call icomb_cvb(nel,nalf,mxdetvb)
      if((kbasis.gt.2.and.kbasis.ne.6).or.
     >   (kbasiscvb.gt.2.and.kbasiscvb.ne.6))then
        kmost=3
      elseif(kbasis.le.2.or.kbasiscvb.le.2)then
        kmost=1
      else
        kmost=6
      endif
      call bspset_cvb(kmost,1,need)
      if(kmost.eq.3)then
        lb(1) = mstackr_cvb(1+need)
        lb(2) = mstackr_cvb(1+need)
      elseif(kmost.eq.1)then
        lb(1) = mstackr_cvb(1+need)
        lb(2) = lb(1)
      else
        lb(1) = mstackr_cvb(1)
        lb(2) = lb(1)
      endif
c  Flag AIKCOF/BIKCOF as unset :
      work(lb(1))=zero
      work(lb(2))=zero

      lb(3) = mstacki_cvb((nel+1)*(nel+1)*(nel+1))
      lb(4) = mstacki_cvb((nel+1)*(nel+1))
      lb(5) = mstacki_cvb((nel+1)*(nel+1))
      lb(6) = mstacki_cvb((nel+1)*(nel+1))
      call bspset_cvb(kbasiscvb,2,need)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine PLF_RICD(AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp,TInt,nTInt,mTInt,iTOff,iOffij,iOffkl)
!***********************************************************************
!                                                                      *
!  object: to sift and index the petite list format integrals.         *
!                                                                      *
!          the indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          May '90                                                     *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri
use SOAO_Info, only: iAOtSO
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ijkl, iCmp, jCmp, kCmp, lCmp, iAO(4), iAOst(4), iBas, jBas, kBas, lBas, kOp(4), nTInt, mTInt, &
                                 iTOff, iOffij, iOffkl
real(kind=wp), intent(in) :: AOint(ijkl,iCmp,jCmp,kCmp,lCmp)
real(kind=wp), intent(_OUT_) :: TInt(nTInt,mTInt)
#include "ibas_ricd.fh"
integer(kind=iwp) :: i1, i2, i3, i4, iAOi, iAOj, iAOk, iAOl, iAOsti, iAOstj, iAOstk, iAOstl, ijSOij, iSO, iSOi, iSOij, iSOkl, &
                     iSOs(4), jSO, jSOj, klSOkl, kSO, kSOk, lSO, lSOl, nijkl

!                                                                      *
!***********************************************************************
!                                                                      *
!define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
r1 = DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,[One],0)
r2 = DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1)
write(u6,*) ' Sum=',r1
write(u6,*) ' Dot=',r2
call RecPrt(' In PLF_RICD: AOInt',' ',AOInt,ijkl,iCmp*jCmp*kCmp*lCmp)
#endif

! quadruple loop over elements of the basis functions angular
! description. loops are reduced to just produce unique SO integrals
! observe that we will walk through the memory in AOint in a
! sequential way.

iAOsti = iAOst(1)
iAOstj = iAOst(2)
iAOstk = iAOst(3)
iAOstl = iAOst(4)
!write(u6,*) 'iAOsti,iAOstj,iAOstk,iAOstl=',iAOsti,iAOstj,iAOstk,iAOstl
iAOi = iAO(1)
iAOj = iAO(2)
iAOk = iAO(3)
iAOl = iAO(4)
!write(u6,*) 'iAOs=',iAO
!write(u6,*) 'kOps=',kOp
!write(u6,*) 'iTOff,iOffij,iOffkl=',iTOff,iOffij,iOffkl
!write(u6,*) 'iBas,jBas,kBas,lBas=',iBas,jBas,kBas,lBas

! The writing of the integrals here are shell blocked.

do i1=1,iCmp
  iSOs(1) = iAOtSO(iAOi+i1,kOp(1))+iAOsti
  do i2=1,jCmp
    iSOs(2) = iAOtSO(iAOj+i2,kOp(2))+iAOstj
    do i3=1,kCmp
      iSOs(3) = iAOtSO(iAOk+i3,kOp(3))+iAOstk
      do i4=1,lCmp
        iSOs(4) = iAOtSO(iAOl+i4,kOp(4))+iAOstl

        iSO = iSOs(1)
        jSO = iSOs(2)
        kSO = iSOs(3)
        lSO = iSOs(4)

        !write(u6,*)
        !write(u6,*) 'i1,i2,i3,i4,iSOs=',i1,i2,i3,i4,iSOs
        !write(u6,*) 'iBas,jBas,kBas,lBas=',iBas,jBas,kBas,lBas

        nijkl = 0
        do lSOl=lSO,lSO+lBas-1
          do kSOk=kSO,kSO+kBas-1
            if (iAO(3) == iAO(4)) then
              iSOkl = iTri(kSOk,lSOl)+iOffkl
            else
              iSOkl = (kSOk-1)*lCmp*lBas_+lSOl+iOffkl
            end if
            do jSOj=jSO,jSO+jBas-1
              do iSOi=iSO,iSO+iBas-1
                nijkl = nijkl+1
                if (iAO(1) == iAO(2)) then
                  iSOij = iTri(iSOi,jSOj)+iOffij
                else
                  iSOij = (iSOi-1)*jCmp*jBas_+jSOj+iOffij
                end if

                !write(u6,*) 'iSOij,iSOkl,AOint=',iSOij,iSOkl,AOint(nijkl,i1,i2,i3,i4)
                ijSOij = max(iSOij,iSOkl)-iTOff
                klSOkl = min(iSOij,iSOkl)
                TInt(klSOkl,ijSOij) = AOint(nijkl,i1,i2,i3,i4)

              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('TInt','(45G8.2)',TInt,nTInt,mTInt)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine PLF_RICD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!               2021, Yoshio Nishimoto                                 *
!***********************************************************************

!#define _DEBUGPRINT_
!#define _CD_TIMING_
subroutine PrepP()
!***********************************************************************
!                                                                      *
! Object: to set up the handling of the 2nd order density matrix.      *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             January '92                                              *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use setup, only: mSkal, nSOs
use pso_stuff, only: A_PT2, B_PT2, Bin, Case_2C, Case_3C, Case_MP2, CASPT2_On, CMO, CMOPT2, D0, DS, DSVar, DVar, FnGam, G1, G2, &
                     G_ToC, Gamma_MRCISD, Gamma_On, iD0Lbl, iOffAO, KCMO, lBin, lPSO, lSA, LuCMOPT2, LuGam, LuGamma, LuGamma_PT2, &
                     mCMO, mG1, mG2, nBasA, nBasASQ, nBasT, nDens, nFro, nG1, nG2, nOcc, NSSDM, SO2CI, SSDM, Wrk1, Wrk2
use iSD_data, only: iSD, iSO2Sh
use Basis_Info, only: nBas, nBas_Aux
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use RICD_Info, only: Cholesky, Do_RI, Cholesky
use dmrginfo, only: DoDMRG, LRRAS2
use etwas, only: CoulFac, ExFac, mBas, mIrrep, nAsh, nCMO, nDSO, nIsh
use NAC, only: IsNAC
#ifdef _CD_TIMING_
use temptime, only: PREPP_CPU, PREPP_WALL
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: Columbus, i, iBas, iDisk, iGo, iIrrep, ij, iost, iSeed, iSh, iSpin, iSSDM, jBas, LgToC, lRealName, MaxShlAO, &
                     mDens, MxInShl, n, nAct, nBasI, nDim0, nDim1, nDim2, nPair, nQUad, nSA, nShell, nTsT, nXro(0:7)
character(len=4096) :: RealName
real(kind=wp) :: CoefR, CoefX
logical(kind=iwp) :: Do_Hybrid, DoCholesky, is_error
real(kind=wp) :: PDFT_Ratio, WF_Ratio
character(len=80) :: KSDFT
character(len=8) :: Method
real(kind=wp), allocatable :: D1ao(:), D1AV(:), Tmp(:,:)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ipTmp1
character(len=60) :: Frmt
character(len=8) :: RlxLbl
integer(kind=iwp), parameter :: iComp = 1
#endif
#ifdef _CD_TIMING_
real(kind=wp) :: PREPPCPU1, PREPPCPU2, PREPPWALL1, PREPPWALL2
#endif
integer(kind=iwp), external :: IsFreeUnit
real(kind=wp), external :: Get_ExFac

! Prologue

#ifdef _CD_TIMING_
call CWTIME(PreppCPU1,PreppWall1)
#endif

call StatusLine('Alaska: ','Prepare the 2-particle matrix')

iD0Lbl = 1

lsa = .false.
Gamma_On = .false.
Gamma_mrcisd = .false.
lPSO = .false.
Case_2C = .false.
Case_3C = .false.
Case_mp2 = .false.

nDens = 0
do iIrrep=0,nIrrep-1
  nDens = nDens+nTri_Elem(nBas(iIrrep))
end do

! Get the method label
call Get_cArray('Relax Method',Method,8)
call Get_iScalar('Columbus',columbus)
nCMo = S%n2Tot
mCMo = S%n2Tot
if ((Method == 'KS-DFT') .or. (Method == 'MCPDFT') .or. (Method == 'MSPDFT') .or. (Method == 'CASDFT')) then
  call Get_iScalar('Multiplicity',iSpin)
  call Get_cArray('DFT functional',KSDFT,80)
  call Get_dScalar('DFT exch coeff',CoefX)
  call Get_dScalar('DFT corr coeff',CoefR)
  ExFac = Get_ExFac(KSDFT)
  CoulFac = One
else
  iSpin = 0
  ExFac = One
  CoulFac = One
end if

! Check the wave function type

!                                                                      *
!***********************************************************************
!                                                                      *
if ((Method == 'RHF-SCF') .or. (Method == 'UHF-SCF') .or. (Method == 'IVO-SCF') .or. (Method == 'MBPT2') .or. &
    (Method == 'KS-DFT') .or. (Method == 'ROHF')) then
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,'(2A)') ' Wavefunction type: ',Method
  if (Method == 'KS-DFT  ') then
    write(u6,'(2A)') ' Functional type:   ',KSDFT
    Frmt = '(1X,A26,20X,F18.6)'
    write(u6,Frmt) 'Exchange scaling factor',CoefX
    write(u6,Frmt) 'Correlation scaling factor',CoefR
  end if
  write(6,*)
# endif
  if (Method == 'MBPT2   ') then
    Case_mp2 = .true.
    call DecideOnCholesky(DoCholesky)
    if (.not. DoCholesky) then
      iSeed = 10
      LuGam = IsFreeUnit(iSeed)
      write(FnGam,'(A6)') 'LuGam'
      call DaName_MF_WA(LuGam,FnGam)
      Gamma_on = .true.
      call Aces_Gamma()
    end if
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if (Method == 'Corr. WF') then
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) ' Wavefunction type: an Aces 2 correlated wavefunction'
  write(u6,*)
# endif
  Gamma_On = .true.
  call Aces_Gamma()
else if ((Method(1:7) == 'MR-CISD') .and. (Columbus == 1)) then
  !*********** columbus interface ****************************************
  !do not reconstruct the two-particle density from the one-particle
  !density or partial two-particle densities but simply read them from
  !file

  nShell = mSkal
  nPair = nTri_Elem(nShell)
  nQuad = nTri_Elem(nPair)

  ! Allocate Table Of Content for half sorted gammas.

  call mma_Allocate(G_Toc,nQuad+2,Label='G_Toc')

  ! find free unit number
  lgtoc = 61
  lgtoc = isFreeUnit(lgtoc)
  idisk = 0
  ! read table of contents of half-sorted gamma file
  call DaName(lgtoc,'gtoc')
  call ddafile(lgtoc,2,G_Toc,nQuad+2,idisk)
  call Daclos(lgtoc)
  n = int(G_Toc(nQuad+1))
  lbin = int(G_Toc(nQuad+2))
  if (n /= nQuad) then
    call WarningMessage(2,'n /= nQuad')
    write(u6,*) 'n,nQuad=',n,nQuad
    call Abend()
  end if

  Gamma_On = .true.
  Gamma_mrcisd = .true.
  ! open gamma file
  LuGamma = 60
  LuGamma = isfreeunit(LuGamma)
  ! closed in closep
  call DaName_MF(LuGamma,'GAMMA')
  ! allocate space for bins
  call mma_Allocate(Bin,2,lBin,Label='Bin')
  ! compute SO2cI array
  call mma_Allocate(SO2cI,2,nSOs,Label='SO2cI')
  call Mk_SO2cI(SO2cI,iSO2Sh,nsos)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((Method == 'RASSCF') .or. (Method == 'CASSCF') .or. (Method == 'GASSCF') .or. (Method == 'MCPDFT') .or. &
         (Method == 'MSPDFT') .or. (Method == 'DMRGSCF') .or. (Method == 'CASDFT')) then

  call Get_iArray('nAsh',nAsh,nIrrep)
  nAct = sum(nAsh(0:nIrrep-1))
  if (nAct > 0) lPSO = .true.

  nDSO = nDens
  mIrrep = nIrrep
  mBas(0:nIrrep-1) = nBas(0:nIrrep-1)
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,'(2A)') ' Wavefunction type: ',Method
  if ((Method == 'CASDFT') .or. (Method == 'MCPDFT')) write(u6,'(2A)') ' Functional type:   ',KSDFT
  if (Method == 'MSPDFT') write(u6,'(2A)') ' MS-PDFT Functional type:   ',KSDFT
  write(u6,*)
# endif
  if ((Method == 'MCPDFT') .or.(Method == 'MSPDFT')) lSA = .true.
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else if ((Method == 'CASSCFSA') .or. (Method == 'DMRGSCFS') .or. (Method == 'GASSCFSA') .or. (Method == 'RASSCFSA') .or. &
         (Method == 'CASPT2')) then
  call Get_iArray('nAsh',nAsh,nIrrep)
  nAct = sum(nAsh(0:nIrrep-1))
  if (nAct > 0) lPSO = .true.
  nDSO = nDens
  call Get_iScalar('SA ready',iGo)
  if (iGO == 1) lSA = .true.
  mIrrep = nIrrep
  mBas(0:nIrrep-1) = nBas(0:nIrrep-1)
# ifdef _DEBUGPRINT_
  write(u6,*)
  if (lSA) then
    write(u6,'(2A)') ' Wavefunction type: State average ',Method(1:6)
  else
    write(u6,'(2A)') ' Wavefunction type: ',Method
  end if
  write(u6,*)
# endif
  if (Method == 'CASPT2  ') then
    CASPT2_On = .true.
    call DecideOnCholesky(DoCholesky)
    !if (.not. DoCholesky) then
    Gamma_On = .true.
    ! It is opened, but not used actually. I just want to
    ! use the Gamma_On flag.
    ! Just to avoid error termination.
    LuGamma = 65
    call DaName_MF_WA(LuGamma,'GAMMA')
    if (DoCholesky) call mma_allocate(G_Toc,1,Label='G_Toc')
    call mma_allocate(SO2cI,1,1,Label='SO2cI')
    call mma_allocate(Bin,1,1,Label='Bin')
    !end if
    if (Cholesky .or. Do_RI) then
      nBasT = 0
      nBasA = 0
      nBasASQ = 0
      do i=0,nIrrep-1
        nBasT = nBasT+nBas(i)
        nBasA = nBasA+nBas_Aux(i)-1
        nBasASQ = nBasASQ+(nBas_Aux(i)-1)**2
      end do
      call mma_allocate(A_PT2,nBasA,nBasA,Label='A_PT2')

      call Set_Basis_Mode('Valence')
      call Setup_iSD()
      MxInShl = 1
      do i=1,mSkal
        MxInShl = max(MxInShl,iSD(3,i)*iSD(2,i))
      end do
      call Free_iSD()
      call mma_allocate(B_PT2,nBasA,MxInShl,MxInShl,Label='B_PT2')
    else
      nBasT = 0
      do i=0,nIrrep-1
        nBasT = nBasT+nBas(i)
      end do

      nSSDM = 0

      ! The two MO indices in the half-transformed amplitude are
      ! not CASSCF but quasi-canonical orbitals.
      call mma_allocate(CMOPT2,nBasT*nBasT,Label='CMOPT2')
      LuCMOPT2 = isFreeUnit(66)
      call PrgmTranslate('CMOPT2',RealName,lRealName)
      call MOLCAS_Open_Ext2(LuCMOPT2,RealName(1:lRealName),'DIRECT','UNFORMATTED',iost,.false.,1,'OLD',is_error)

      do i=1,nBasT*nBasT
        read(LuCMOPT2) CMOPT2(i)
      end do

      read(LuCMOPT2) nOcc(1)
      read(LuCMOPT2) nOcc(2)
      read(LuCMOPT2) nOcc(3)
      read(LuCMOPT2) nOcc(4)
      read(LuCMOPT2) nOcc(5)
      read(LuCMOPT2) nOcc(6)
      read(LuCMOPT2) nOcc(7)
      read(LuCMOPT2) nOcc(8)
      read(LuCMOPT2) nFro(1)
      read(LuCMOPT2) nFro(2)
      read(LuCMOPT2) nFro(3)
      read(LuCMOPT2) nFro(4)
      read(LuCMOPT2) nFro(5)
      read(LuCMOPT2) nFro(6)
      read(LuCMOPT2) nFro(7)
      read(LuCMOPT2) nFro(8)
      read(LuCMOPT2) nSSDM

      if (nSSDM /= 0) then
        call mma_allocate(SSDM,nBas(0)*(nBas(0)+1)/2,2,nSSDM,Label='SSDM')
        do iSSDM=1,nSSDM
          do i=1,nBas(0)*(nBas(0)+1)/2
            read(LuCMOPT2) SSDM(i,1,iSSDM),SSDM(i,2,iSSDM)
          end do
        end do
      end if

      close(LuCMOPT2)

      write(u6,*) 'Number of Non-Frozen Occupied Orbitals = ',nOcc(1)
      write(u6,*) 'Number of     Frozen          Orbitals = ',nFro(1)

      call mma_allocate(iOffAO,mSkal+1,Label='iOffAO')
      MaxShlAO = 0
      iOffAO(1) = 0
      do iSh=1,mSkal
        nBasI = iSD(2,iSh)*iSD(3,iSh)
        if (nBasI > MaxShlAO) MaxShlAO = nBasI
        iOffAO(iSh+1) = iOffAO(iSh)+nBasI
      end do
      call mma_allocate(G_toc,MaxShlAO**4,Label='GtocCASPT2')

      LuGAMMA_PT2 = isFreeUnit(65)
      call PrgmTranslate('GAMMA',RealName,lRealName)
      call MOLCAS_Open_Ext2(LuGamma_PT2,RealName(1:lRealName),'DIRECT','UNFORMATTED',iost,.true.,nOcc(1)*nOcc(1)*8,'OLD',is_error)

      call mma_allocate(WRK1,nOcc(1)*nOcc(1),Label='WRK1')
      call mma_allocate(WRK2,MaxShlAO*nOcc(1),Label='WRK2')

    end if
  end if
  Method = 'RASSCF  '
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  call WarningMessage(2,'Alaska: Unknown wavefuntion type')
  write(u6,*) 'Wavefunction type:',Method
  write(u6,*) 'Illegal type of wave function!'
  write(u6,*) 'ALASKA cannot continue.'
  call Quit_OnUserError()
end if

! Read the (non) variational 1st order density matrix
! density matrix in AO/SO basis
nsa = 1
if (lsa) nsa = 4
mDens = nsa
if ((Method == 'MCPDFT') .or. (Method == 'MSPDFT')) then
  nsa = 5
  !AMS modification: add another density slot
  mDens = nsa+1
end if
call mma_allocate(D0,nDens,mDens,Label='D0')
D0(:,:) = Zero
call mma_allocate(DVar,nDens,nsa,Label='DVar')
if (.not. gamma_mrcisd) call Get_dArray_chk('D1ao',D0(:,1),nDens)

call Get_D1ao_Var(DVar,nDens)

call mma_Allocate(DS,nDens,Label='DS')
call mma_Allocate(DSVar,nDens,Label='DSVar')
if ((Method == 'UHF-SCF') .or. (Method == 'ROHF') .or. ((Method == 'KS-DFT') .and. (iSpin /= 1)) .or. (Method == 'Corr. WF')) then
  call Get_dArray_chk('D1sao',DS,nDens)
  call Get_D1sao_Var(DSVar,nDens)
else
  DS(:) = Zero
  DSVar(:) = Zero
end if

! This is necessary for the ci-lag

! Unfold density matrix

!*********** columbus interface ****************************************
!do not modify the effective density matrices and fock matrices
if (.not. gamma_mrcisd) then
  ij = 0
  do iIrrep=0,nIrrep-1
    do iBas=1,nBas(iIrrep)
      do jBas=1,iBas-1
        ij = ij+1
        D0(ij,1) = Half*D0(ij,1)
        DVar(ij,1) = Half*DVar(ij,1)
        DS(ij) = Half*DS(ij)
        DSVar(ij) = Half*DSVar(ij)
      end do
      ij = ij+1
    end do
  end do
end if

#ifdef _DEBUGPRINT_
RlxLbl = 'D1AO    '
call PrMtrx(RlxLbl,[iD0Lbl],iComp,[1],D0)
RlxLbl = 'D1AO-Var'
call PrMtrx(RlxLbl,[iD0Lbl],iComp,[1],DVar)
RlxLbl = 'DSAO    '
call PrMtrx(RlxLbl,[iD0Lbl],iComp,[1],DS)
RlxLbl = 'DSAO-Var'
call PrMtrx(RlxLbl,[iD0Lbl],iComp,[1],DSVar)
#endif

! Get the MO-coefficients
!*********** columbus interface ****************************************
! not that the columbus mcscf MO coefficients have been written
! to the RUNFILE !

if ((Method == 'UHF-SCF') .or. (Method == 'ROHF') .or. ((Method == 'KS-DFT') .and. (iSpin /= 1)) .or. (Method == 'Corr. WF')) then
  nsa = 2
else
  nsa = 1
  if (lsa) nsa = 2
end if
kCMO = nsa
call mma_allocate(CMO,mCMO,kCMO,Label='CMO')
call Get_dArray_chk('Last orbitals',CMO(:,1),mCMO)
#ifdef _DEBUGPRINT_
ipTmp1 = 1
do iIrrep=0,nIrrep-1
  call RecPrt(' CMO''s',' ',CMO(ipTmp1,1),nBas(iIrrep),nBas(iIrrep))
  ipTmp1 = ipTmp1+nBas(iIrrep)**2
end do
#endif

! Get additional information in the case of a RASSCF wave function
! Get the number of inactive, active and frozen orbitals
!*********** columbus interface ****************************************
! no need for MRCI gradient
if (lpso .and. (.not. gamma_mrcisd)) then
  call Get_iScalar('nSym',i)
  call Get_iArray('nIsh',nIsh,i)
  call Get_iArray('nAsh',nAsh,i)
  call Get_iArray('nFro',nXro,i)
# ifdef _DEBUGPRINT_
  write(u6,*) ' nISh=',nISh
  write(u6,*) ' nASh=',nASh
  write(u6,*) ' nFro=',nXro
# endif
  nAct = 0
  nTst = 0
  do iIrrep=0,nIrrep-1
    !write(u6,*)"nAsh(iIrrep)",nAsh(iIrrep)  ! yma
    nAct = nAct+nAsh(iIrrep)
    nTst = nTst+nXro(iIrrep)
  end do
  if (nTst /= 0) then
    call WarningMessage(2,'; No frozen orbitals are allowed!; ALASKA cannot continue;')
    call Quit_OnUserError()
  end if

  ! Get the one body density for the active orbitals
  ! (not needed for SA-CASSCF)
  nG1 = nTri_Elem(nAct)
  nsa = 1
  if (lsa) nsa = 0
  mG1 = nsa
  call mma_allocate(G1,nG1,mG1,Label='G1')
  if (nsa > 0) then
    call Get_dArray_chk('D1mo',G1(:,1),nG1)
#   ifdef _DEBUGPRINT_
    call TriPrt(' G1',' ',G1(:,1),nAct)
#   endif
  end if

  ! Get the two body density for the active orbitals
  nG2 = nTri_Elem(nG1)
  nsa = 1
  if (lsa) nsa = 2
  mG2 = nsa
  call mma_allocate(G2,nG2,mG2,Label='G2')
  !write(u6,*) 'got the 2rdm, Ithink.'
  if ((Method == 'MCPDFT') .or. (Method == 'MSPDFT')) then
    call Get_dArray_chk('P2MOt',G2,nG2)!PDFT-modified 2-RDM
  else
    call Get_dArray_chk('P2mo',G2,nG2)
  end if
# ifdef _DEBUGPRINT_
  call TriPrt(' G2',' ',G2(1,1),nG1)
# endif
  if (lsa) then

    ! CMO1 Ordinary CMOs

    ! CMO2 CMO*Kappa

    call Get_dArray_chk('LCMO',CMO(:,2),mCMO)
#   ifdef _DEBUGPRINT_
    ipTmp1 = 1
    do iIrrep=0,nIrrep-1
      call RecPrt('LCMO''s',' ',CMO(ipTmp1,2),nBas(iIrrep),nBas(iIrrep))
      ipTmp1 = ipTmp1+nBas(iIrrep)**2
    end do
#   endif

    ! P are stored as
    !                            _                     _
    !   P1=<i|e_pqrs|i> + sum_i <i|e_pqrs|i>+<i|e_pqrs|i>
    !   P2=sum_i <i|e_pqrs|i>

    call Get_dArray_chk('PLMO',G2(:,2),nG2)
    ndim1 = 0
    if (doDMRG) then
      ndim0 = sum(LRras2(:))  !yma
      ndim1 = nTri_Elem(ndim0)
      ndim2 = nTri_Elem(ndim1)
      do i=1,ng2
        if (i > ndim2) G2(i,2) = Zero
      end do
    end if
    G2(:,1) = G2(:,1)+G2(:,2)
#   ifdef _DEBUGPRINT_
    call TriPrt(' G2L',' ',G2(:,2),nG1)
    call TriPrt(' G2T',' ',G2(:,1),nG1)
#   endif

    call Get_dArray_chk('D2av',G2(:,2),nG2)
#   ifdef _DEBUGPRINT_
    call TriPrt('G2A',' ',G2(:,2),nG1)
#   endif

    ! Densities are stored as:
    !
    !  ipd0 AO:
    !
    !  D1 = inactive diagonal density matrix
    !                                _                 _
    !  D2 = <i|E_pq|i> + sum_i <i|E_pq|i>+<i|E_pq|i> + sum_i sum_o k_po <i|E_oq|i> +k_oq <i|E_po|i> - 1/2 D2
    !
    !  D3 = sum_i <i|E_pq|i> (active)
    !
    !  D4 = sum_i sum_o k_po <i|E_oq|i> +k_oq <i|E_po|i> (inactive)
    !
    !  G1 = <i|e_ab|i>
    !  G2 = sum i <i|e_ab|i>
    !
    !************************
    !RlxLbl = 'D1AO    '
    !call PrMtrx(RlxLbl,iD0Lbl,iComp,[1],D0)

    call mma_allocate(Tmp,nDens,2,Label='Tmp')
    call Get_D1I(CMO(:,1),D0(:,1),Tmp,nIsh,nBas,nIrrep)
    call mma_deallocate(Tmp)

    !************************
    !RlxLbl = 'D1AO    '
    !call PrMtrx(RlxLbl,iD0Lbl,iComp,[1],D0)

    if (isNAC) then
      D0(:,2) = DVar(:,1)
    else
      D0(:,2) = DVar(:,1)-Half*D0(:,1)
    end if
    !RlxLbl = 'D1COMBO  '
    !call PrMtrx(RlxLbl,iD0Lbl,iComp,[1],D0(:,2))

    ! This is necessary for the kap-lag

    nG1 = nTri_Elem(nAct)
    call mma_allocate(D1AV,nG1,Label='D1AV')
    call Get_dArray_chk('D1av',D1AV,nG1)
    call Get_D1A(CMO(:,1),D1AV,D0(:,3),nIrrep,nbas,nish,nash,ndens)
    call mma_deallocate(D1AV)
    !************************
    !RlxLbl = 'D1AOA   '
    !call PrMtrx(RlxLbl,iD0Lbl,iComp,[1],D0(:,3))

    call Get_dArray_chk('DLAO',D0(:,4),nDens)

    ! Getting conditions for hybrid MC-PDFT
    Do_Hybrid = .false.
    PDFT_Ratio = Zero
    call qpg_DScalar('R_WF_HMC',Do_Hybrid)
    if (Do_Hybrid) then
      call Get_DScalar('R_WF_HMC',WF_Ratio)
      PDFT_Ratio = One-WF_Ratio
    end if
    !ANDREW - modify D2: should contain only the correction pieces
    if (Method == 'MCPDFT  ') then
      ! Get the D_theta piece
      call mma_allocate(D1ao,nDens)
      call Get_dArray_chk('D1ao',D1ao,ndens)
      ij = 0
      do iIrrep=0,nIrrep-1
        do iBas=1,nBas(iIrrep)
          do jBas=1,iBas-1
            ij = ij+1
            D1ao(ij) = Half*D1ao(ij)
          end do
          ij = ij+1
        end do
      end do
      D1ao(:) = D1ao(:)-D0(:,1)
      !write(u6,*) 'do they match?'
      !do i=1,ndens
      !  write(u6,*) d1ao(i),DO(i,3)
      !end do

      !ANDREW -   Generate new D5 piece:
      D0(:,5) = Half*D0(:,1)+D1ao(:)
      D0(:,2) = D0(:,2)-D0(:,5)

      if (do_hybrid) then
        ! add back the wave function parts that are subtracted
        ! this might be inefficient, but should have a clear logic
        D0(:,2) = D0(:,2)+WF_Ratio*D0(:,5)
        ! scale the pdft part
        D0(:,5) = PDFT_Ratio*D0(:,5)
      end if
      call mma_deallocate(D1ao)
    else if (Method == 'MSPDFT') then
      call Get_DArray('MSPDFTD5',D0(:,5),nDens)
      call Get_DArray('MSPDFTD6',D0(:,6),nDens)
      D0(:,2) = D0(:,2)-D0(:,5)
    end if

    !D0(:,:) = Zero
    !G2(:) = Zero

    !************************
    !D0(1:Length,4) = Half*D0(1:Length,4)
    !D0(1:Length,4) = Zero

    !RlxLbl = 'DLAO    '
    !call PrMtrx(RlxLbl,iD0Lbl,iComp,[1],D0(1,4))
    ! DMRG with the reduced AS
    !if (doDMRG) length = ndim1  !yma
  end if
# ifdef _DEBUGPRINT_
  call TriPrt(' G2',' ',G2(1,1),nG1)
# endif

end if
! Close 'RELAX' file

! Epilogue, end
#ifdef _CD_TIMING_
call CWTIME(PreppCPU2,PreppWall2)
Prepp_CPU = PreppCPU2-PreppCPU1
Prepp_Wall = PreppWall2-PreppWall1
#endif

return

end subroutine PrepP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************

subroutine MKCOUP(SGS,CIS,EXS)
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*
! Purpose: Compute and return the table ICOUP(1..3,ICOP).
! The number of coupling coeffs is obtained from NOCP, the offset to
! the ICOP numbering is given by IOCP. The numbers ICOUP(1..3,ICOP) are
! then the ket and bra half-walks, enumerated by the Lund scheme,
! and the index into the VTAB table (the pool of possible values of
! coupling coefficients).

! Any loop is regarded as a segment path from top to midlevel, or
! from midlevel to bottom.
! The segment path is described by the table ISGPTH. It is
! essentially a list of which one of segments nr 1..26 that are
! used at each level. The segments are of three types:
! Type 0: Upwalk segment or top loop segment.
! Type 1: Mid segment.
! Type 2: Bottom segment.
! Type 3: Downwalk segment.
! ISGPTH(IVLFT,LEV)=Left upper vertex.
! ISGPTH(ITYPE,LEV)=Type of segment, (0..3).
! ISGPTH(IAWSL,LEV)=Left arc weight sum (from top, or from bottom).
! ISGPTH(IAWSR,LEV)=Similar, right.
! ISGPTH(ILS  ,LEV)=Left symmetry label (accum from top or bottom).
! ISGPTH(ICS  ,LEV)=Left coupling case number (0..3).
! ISGPTH(ISEG ,LEV)=Segment type (1..26).
! These indices are used to denote the columns of table ISGPTH.

use Symmetry_Info, only: Mul
use gugx, only: CIStruct, EXStruct, SGStruct
use segtab, only: IBVPT, IC1, IC2, ITVPT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(inout) :: CIS
type(EXStruct), intent(inout) :: EXS
integer(kind=iwp) :: i, i1, i2, IAWS, IC, ICL, ICOP, ICR, IHALF, iLnd, IndEO, iP, iPos, iQ, iS, iSg, iSgt, iSym, iT, iTyp, iTypMx, &
                     iTypT, iVlb, iVlt, iVrt, iVrTop, iVTab, iVTEnd, iVTop, iVTSta, L, Lev, Lev1, Lev2, LftSym, LL, MV, nCheck, &
                     nVTab_Final
real(kind=wp) :: C
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I3, ICOP1, ICOP2, ICP1, ICP2, N, NRC, NRCPQ
real(kind=wp) :: CP
#endif
integer(kind=iwp), allocatable :: ILNDW(:), ISGPTH(:,:)
real(kind=wp), allocatable :: val(:), VTab(:)
integer(kind=iwp), parameter :: IVLFT = 1, ITYPE = 2, IAWSL = 3, IAWSR = 4, ILS = 5, ICS = 6, ISEG = 7, nVTab = 5000

call mma_allocate(ILNDW,CIS%nWalk,Label='ILNDW')
call mma_allocate(ISGPTH,[1,7],[0,SGS%nLev],Label='ISGPTH')
call mma_allocate(val,[0,SGS%nLev],Label='val')
call mma_allocate(VTab,nVTab,Label='VTab')

call mma_allocate(EXS%ICoup,3,EXS%nICoup,Label='EXS%ICoup')
call mma_allocate(CIS%ICase,CIS%nWalk*CIS%nIpWlk,Label='CIS%ICase',safe='*')

!CIS%nIpWlk = 1+(SGS%MidLev-1)/15
!CIS%nIpWlk = max(CIS%nIpWlk,1+(nLev-SGS%MidLev-1)/15)
! NOW IS ZEROED AND WILL BE USED AS AN ARRAY OF COUNTERS, BUT WILL BE RESTORED FINALLY.
do IHALF=1,2
  do MV=1,CIS%nMidV
    do IS=1,SGS%nSym
      CIS%NOW(IHALF,IS,MV) = 0
    end do
  end do
end do
! SIMILAR FOR THE COUPLING COEFFICIENT TABLE:
do INDEO=1,EXS%MxEO
  do MV=1,CIS%nMidV
    do IS=1,SGS%nSym
      EXS%NOCP(INDEO,IS,MV) = 0
    end do
  end do
end do

! COUPLING COEFFICIENT VALUE TABLE:
NVTAB_FINAL = 2
VTab(1) = One
VTab(2) = -One

NCHECK = 0

do IHALF=1,2
  if (IHALF == 1) then
    IVTSTA = 1
    IVTEND = 1
    LEV1 = SGS%nLev
    LEV2 = SGS%MidLev
    ITYPMX = 0
  else
    IVTSTA = SGS%MVSta
    IVTEND = SGS%MVEnd
    LEV1 = SGS%MidLev
    LEV2 = 0
    ITYPMX = 2
  end if
  do IVTOP=IVTSTA,IVTEND
    do ITYP=0,ITYPMX
      IVRTOP = IVTOP
      if (ITYP > 0) IVRTOP = CIS%IVR(IVTOP,ITYP)
      if (IVRTOP == 0) cycle
      LEV = LEV1
      ISGPTH(IVLFT,LEV) = IVTOP
      ISGPTH(ITYPE,LEV) = ITYP
      ISGPTH(IAWSL,LEV) = 0
      ISGPTH(IAWSR,LEV) = 0
      ISGPTH(ILS,LEV) = 1
      ISGPTH(ISEG,LEV) = 0
      val(LEV) = One
      do while (LEV <= LEV1)
        ITYPT = ISGPTH(ITYPE,LEV)
        IVLT = ISGPTH(IVLFT,LEV)
        do ISGT=ISGPTH(ISEG,LEV)+1,26
          IVLB = CIS%ISGM(IVLT,ISGT)
          if (IVLB == 0) cycle
          if (ITYPT == ITVPT(ISGT)) exit
        end do
        if (ISGT > 26) then
          ISGPTH(ISEG,LEV) = 0
          LEV = LEV+1
        else
          ISGPTH(ISEG,LEV) = ISGT
          ICL = IC1(ISGT)
          ISYM = 1
          if ((ICL == 1) .or. (ICL == 2)) ISYM = SGS%ISm(LEV)
          IVRT = IVLT
          if ((ITYPT == 1) .or. (ITYPT == 2)) IVRT = CIS%IVR(IVLT,ITYPT)
          ICR = IC2(ISGT)
          ISGPTH(ICS,LEV) = ICL
          LEV = LEV-1
          ISGPTH(IAWSL,LEV) = ISGPTH(IAWSL,LEV+1)+SGS%MAW(IVLT,ICL)
          ISGPTH(IAWSR,LEV) = ISGPTH(IAWSR,LEV+1)+SGS%MAW(IVRT,ICR)
          val(LEV) = val(LEV+1)*CIS%VSGM(IVLT,ISGT)
          ISGPTH(ILS,LEV) = Mul(ISYM,ISGPTH(ILS,LEV+1))
          ISGPTH(IVLFT,LEV) = IVLB
          ISGPTH(ITYPE,LEV) = IBVPT(ISGT)
          ISGPTH(ISEG,LEV) = 0
          if (LEV > LEV2) cycle

          MV = ISGPTH(IVLFT,SGS%MidLev)+1-SGS%MVSta
          LFTSYM = ISGPTH(ILS,LEV2)
          IT = ISGPTH(ITYPE,SGS%MidLev)
          if (IT == 0) IT = 3
          if (ISGPTH(ITYPE,LEV2) == 0) IT = 0

          if (IT == 0) then
            ILND = 1+CIS%NOW(IHALF,LFTSYM,MV)
            IAWS = ISGPTH(IAWSL,LEV2)
            ILNDW(IAWS) = ILND
            CIS%NOW(IHALF,LFTSYM,MV) = ILND
            IPOS = CIS%IOW(IHALF,LFTSYM,MV)+(ILND-1)*CIS%nIpWlk
            do LL=LEV2+1,LEV1,15
              IC = 0
              do L=min(LL+14,LEV1),LL,-1
                IC = 4*IC+ISGPTH(ICS,L)
              end do
              IPOS = IPOS+1
              CIS%ICase(IPOS) = IC
            end do
          else
            IP = 0
            IQ = 0
            do L=LEV2+1,LEV1
              ISG = ISGPTH(ISEG,L)
              if ((ISG >= 5) .and. (ISG <= 8)) IP = L
              if ((ISG >= 19) .and. (ISG <= 22)) IQ = L
            end do
            if (IP == 0) IP = IQ
            INDEO = SGS%nLev*(IT-1)+IP
            if (IT == 3) INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
            ICOP = 1+EXS%NOCP(INDEO,LFTSYM,MV)
            EXS%NOCP(INDEO,LFTSYM,MV) = ICOP
            ICOP = EXS%IOCP(INDEO,LFTSYM,MV)+ICOP
            NCHECK = NCHECK+1
            if (ICOP > EXS%nICoup) then
              write(u6,*) ' ERROR: NICOUP=',EXS%nICoup
              write(u6,*) ' NR OF COUPS PRODUCED:',NCHECK
              write(u6,*) '           TYPE NR IT:',IT
              write(u6,*) '            IP,IQ    :',IP,IQ
              write(u6,*) '            INDEO    :',INDEO
              write(u6,*) '        MIDVERTEX MV :',MV
              write(u6,*) ' LEFT SYMMETRY LFTSYM:',LFTSYM
              write(u6,*) ' COUP OFFSET IOCP    :',EXS%IOCP(INDEO,LFTSYM,MV)
              write(u6,*) ' COUP SERIAL NR ICOP :',ICOP
              write(u6,*) ' D:O, WITHOUT OFFSET :',ICOP-EXS%IOCP(INDEO,LFTSYM,MV)
              write(u6,*) ' CURRENT NOCP NUMBER :',EXS%NOCP(INDEO,LFTSYM,MV)
              call ABEND()
            end if

            C = val(LEV2)
            do I=1,NVTAB_FINAL
              IVTAB = I
              if (abs(C-VTab(I)) < 1.0e-10_wp) exit
            end do
            if (I > NVTAB_FINAL) then
              NVTAB_FINAL = NVTAB_FINAL+1
              if (NVTAB_FINAL > nVTab) then
                write(u6,*) 'MKCOUP: NVTAB_FINAL=',NVTAB_FINAL
                write(u6,*) 'NVTAB_FINAL should not be allowed to grow'
                write(u6,*) 'beyond nVTab which was set provisionally'
                write(u6,*) 'in subroutine GINIT in file ginit.f.'
                write(u6,*) 'Now nVTab=',nVTab
                write(u6,*) 'This may indicate a problem with your input.'
                write(u6,*) 'If you do want to do this big calculation, try'
                write(u6,*) 'increasing nVTab in GINIT and recompile.'
                call ABEND()
              end if
              VTab(NVTAB_FINAL) = C
              IVTAB = NVTAB_FINAL
            end if
            EXS%ICoup(1,ICOP) = ISGPTH(IAWSL,LEV2)
            EXS%ICoup(2,ICOP) = ISGPTH(IAWSR,LEV2)
            EXS%ICoup(3,ICOP) = IVTAB
            if (ICOP > EXS%nICoup) then
              write(u6,*) 'MKCOUP: ICOP>NICOUP!'
              call ABEND()
            end if
          end if

          LEV = LEV+1
        end if
      end do

    end do
  end do
end do
! RENUMBER THE COUPLING COEFFICIENT INDICES BY LUND SCHEME:
do ICOP=1,EXS%nICoup
  I1 = EXS%ICoup(1,ICOP)
  I2 = EXS%ICoup(2,ICOP)
  EXS%ICoup(1,ICOP) = ILNDW(I1)
  EXS%ICoup(2,ICOP) = ILNDW(I2)
end do

call mma_deallocate(val)
call mma_deallocate(ISGPTH)
call mma_deallocate(ILNDW)

#ifdef _DEBUGPRINT_
ICOP1 = 0
ICOP2 = 0
write(u6,*) ' NR OF DIFFERENT VALUES OF COUP:',NVTAB_FINAL
do ICOP=1,EXS%nICoup
  I3 = EXS%ICoup(3,ICOP)
  if (I3 == 1) ICOP1 = ICOP1+1
  if (I3 == 2) ICOP2 = ICOP2+1
end do
write(u6,*)
write(u6,*) ' NR OF COUPS WITH VALUE  1.0:',ICOP1
write(u6,*) ' NR OF COUPS WITH VALUE -1.0:',ICOP2
write(u6,*)
write(u6,*) ' COUPLING COEFFICIENTS:'
write(u6,*) '    IP    IQ    MV LFTSYM NOCP'
write(u6,*) ' 1. OPEN LOOPS TYPE 1.'
do IP=1,SGS%nLev
  do MV=1,CIS%nMidV
    do LFTSYM=1,SGS%nSym
      N = EXS%NOCP(IP,LFTSYM,MV)
      write(u6,'(6X,6(1X,I5),F10.7)') IP,MV,LFTSYM,N
    end do
  end do
end do
write(u6,*) ' 2. OPEN LOOPS TYPE 2.'
do IP=1,SGS%nLev
  INDEO = SGS%nLev+IP
  do MV=1,CIS%nMidV
    do LFTSYM=1,SGS%nSym
      N = EXS%NOCP(INDEO,LFTSYM,MV)
      write(u6,'(6X,6(1X,I5),F10.7)') IP,MV,LFTSYM,N
    end do
  end do
end do
write(u6,*) ' 3. CLOSED LOOPS.'
do IP=1,SGS%nLev
  do IQ=1,IP
    INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
    do MV=1,CIS%nMidV
      do LFTSYM=1,SGS%nSym
        N = EXS%NOCP(INDEO,LFTSYM,MV)
        write(u6,'(7(1X,I5),F10.7)') IP,IQ,MV,LFTSYM,N
      end do
    end do
  end do
end do
write(u6,*)
write(u6,*) ' COUPLING COEFFICIENTS:'
write(u6,*) '    IP    IQ    MV LFTSYM ICOP ICOUP1&2   COUP'
write(u6,*) ' 1. OPEN LOOPS TYPE 1.'
do IP=1,SGS%nLev
  do MV=1,CIS%nMidV
    do LFTSYM=1,SGS%nSym
      N = EXS%NOCP(IP,LFTSYM,MV)
      ICOP = EXS%IOCP(IP,LFTSYM,MV)
      do I=1,N
        ICOP = ICOP+1
        ICP1 = EXS%ICoup(1,ICOP)
        ICP2 = EXS%ICoup(2,ICOP)
        CP = VTab(EXS%ICoup(3,ICOP))
        write(u6,'(6X,6(1X,I5),F10.7)') IP,MV,LFTSYM,ICOP,ICP1,ICP2,CP
      end do
    end do
  end do
end do
write(u6,*) ' 2. OPEN LOOPS TYPE 2.'
do IP=1,SGS%nLev
  INDEO = SGS%nLev+IP
  do MV=1,CIS%nMidV
    do LFTSYM=1,SGS%nSym
      N = EXS%NOCP(INDEO,LFTSYM,MV)
      ICOP = EXS%IOCP(INDEO,LFTSYM,MV)
      do I=1,N
        ICOP = ICOP+1
        ICP1 = EXS%ICoup(1,ICOP)
        ICP2 = EXS%ICoup(2,ICOP)
        CP = VTab(EXS%ICoup(3,ICOP))
        write(u6,'(6X,6(1X,I5),F10.7)') IP,MV,LFTSYM,ICOP,ICP1,ICP2,CP
      end do
    end do
  end do
end do
write(u6,*) ' 3. CLOSED LOOPS.'
do IP=1,SGS%nLev
  do IQ=1,IP
    INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
    do MV=1,CIS%nMidV
      do LFTSYM=1,SGS%nSym
        N = EXS%NOCP(INDEO,LFTSYM,MV)
        ICOP = EXS%IOCP(INDEO,LFTSYM,MV)
        do I=1,N
          ICOP = ICOP+1
          ICP1 = EXS%ICoup(1,ICOP)
          ICP2 = EXS%ICoup(2,ICOP)
          CP = VTab(EXS%ICoup(3,ICOP))
          write(u6,'(7(1X,I5),F10.7)') IP,IQ,MV,LFTSYM,ICOP,ICP1,ICP2,CP
        end do
      end do
    end do
  end do
end do
write(u6,*)
write(u6,*) ' CONVENTIONAL NR OF COUPLING COEFFS, BY PAIR:'
NRC = 0
do IP=2,SGS%MidLev
  do IQ=1,IP-1
    NRCPQ = 0
    INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
    do LFTSYM=1,SGS%nSym
      ISYM = LFTSYM
      do MV=1,CIS%nMidV
        NRCPQ = NRCPQ+EXS%NOCP(INDEO,LFTSYM,MV)*CIS%NOW(1,ISYM,MV)
      end do
    end do
    write(u6,'(1X,2I5,5X,I9)') IP,IQ,NRCPQ
    NRC = NRC+NRCPQ
  end do
end do
do IP=SGS%MidLev+1,SGS%nLev
  do IQ=1,SGS%MidLev
    NRCPQ = 0
    do LFTSYM=1,SGS%nSym
      ISYM = LFTSYM
      do MV=1,CIS%nMidV
        NRCPQ = NRCPQ+EXS%NOCP(IP,LFTSYM,MV)*EXS%NOCP(IQ,ISYM,MV)
        NRCPQ = NRCPQ+EXS%NOCP(SGS%nLev+IP,LFTSYM,MV)*EXS%NOCP(SGS%nLev+IQ,ISYM,MV)
      end do
    end do
    write(u6,'(1X,2I5,5X,I9)') IP,IQ,NRCPQ
    NRC = NRC+NRCPQ
  end do
end do
do IP=SGS%MidLev+2,SGS%nLev
  do IQ=SGS%MidLev+1,IP-1
    NRCPQ = 0
    INDEO = 2*SGS%nLev+(IP*(IP-1))/2+IQ
    do LFTSYM=1,SGS%nSym
      ISYM = LFTSYM
      do MV=1,CIS%nMidV
        NRCPQ = NRCPQ+EXS%NOCP(INDEO,LFTSYM,MV)*CIS%NOW(2,ISYM,MV)
      end do
    end do
    write(u6,'(1X,2I5,5X,I9)') IP,IQ,NRCPQ
    NRC = NRC+NRCPQ
  end do
end do
write(u6,*)
write(u6,*) ' TOTAL CONVENTIONAL COUPLING COEFFS:',NRC
#endif

call mma_allocate(EXS%VTab,nVTab_Final,Label='EXS%VTab')
EXS%VTab(1:nVTab_final) = VTab(1:nVTab_final)
call mma_deallocate(VTab)

end subroutine MKCOUP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2007, Roland Lindh                                *
*               2009, Francesco Aquilante                              *
************************************************************************
      SubRoutine PGet1_RI2(PAO,ijkl,nPAO,iCmp,iAO,iAOst,
     &                     Shijij,iBas,jBas,kBas,lBas,kOp,ExFac,
     &                     CoulFac,PMax,V_K,U_K,mV_K,Z_p_K,nSA)
************************************************************************
*  Object: to assemble the 2nd order density matrix of a SCF wave      *
*          function from the 1st order density.                        *
*                                                                      *
*          (Only for use with C1 point group symmetry)                 *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*                                                                      *
*             Modified for RI-DFT, March 2007                          *
*                                                                      *
*             Modified for RI-HF/CAS, Dec 2009 (F. Aquilante)          *
************************************************************************
      use Basis_Info, only: nBas
      use SOAO_Info, only: iAOtSO
      use pso_stuff, only: nnP, lPSO, lsa, DMdiag, nPos
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "WrkSpc.fh"
#include "exterm.fh"
#include "chomp2g_alaska.fh"
      Real*8 PAO(ijkl,nPAO), V_K(mV_K,nSA), U_K(mV_K),
     &       Z_p_K(nnP(0),mV_K,*)
      Integer iAO(4), kOp(4), iAOst(4), iCmp(4)
      Integer ip_CikJ_(2)
      Logical Shijij,Found
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      iRout = 39
      iPrint = nPrint(iRout)
      Do i=1,nSA
         Call RecPrt('PGet1_RI2: V_k',' ',V_k(1,i),1,mV_k)
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     DeSymP will treat up to eight fold degeneracy due to permutational
*     symmetry of shell quadruplets. We will have to compensate for that
*     here since we only have shell doublets.
*
*
      Call CWTime(Cpu1,Wall1)
*
      nMaxBas = Max(lBas,jBas)
*
      If (Min(lBas,jBas) .eq.0) Return
*
      Fac = One / Four
      PMax=Zero
      iPAO=0
      iOffA=nBas(0)
*
      ip_V2 = 0
*
      Call Qpg_iScalar('SCF mode',Found)
      If (Found) Then
         Call Get_iScalar('SCF mode',iUHF) ! either 0 or 1
      Else
         iUHF=0
      EndIf
*
*                                                                      *
************************************************************************
*                                                                      *
*     Pure DFT
*
      If (ExFac.eq.Zero) Then
*                                                                      *
************************************************************************
*                                                                      *
*
*        Pure DFT
*
         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
*
            Do i4 = 1, iCmp(4)
*
               lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
               iPAO = iPAO + 1
               nijkl = 0
*
               Do lAOl = 0, lBas-1
                  lSOl = lSO + lAOl - iOffA
                  Do jAOj = 0, jBas-1
*
                     jSOj = jSO + jAOj - iOffA
                     nijkl = nijkl + 1
*
*----- Coulomb contribution
                     temp=CoulFac*V_K(jSOj,1)*V_K(lSOl,1)
*                    temp=Zero
*
                     PMax=Max(PMax,Abs(temp))
                     PAO(nijkl,iPAO) = Fac * temp
*
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Hybrid DFT and HF
*
      Else If(iMP2prpt .ne. 2 .and. .not. lPSO .and. iUHF.eq.0) Then
*                                                                      *
************************************************************************
*                                                                      *
         iSO=1
*
         jSym = 1
         kSym = jSym
         iSym = 1
         lSym = iEor(jSym-1,iSym-1)+1
*
         ip_CikJ = ip_CijK
*
         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
*
*           Pick up the MO transformed fitting coefficients, C_ik^J
            nik = nIJ1(iSym,kSym,iSO)
            ip_CikL = ip_CikJ + nik*nMaxBas
            jSOj = jSO - iOffA
            iAdrJ = nik*(jSOj-1) + iAdrCVec(jSym,iSym,1)
            Call dDaFile(LuCVector(jSym,1),2,Work(ip_CikJ),
     &                   nik*jBas,iAdrJ)

            Do i4 = 1, iCmp(4)
               lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
               iPAO = iPAO + 1
               nijkl = 0

               If (lSO.ne.jSO) Then
                  lSOl = lSO - iOffA
                  iAdrL = nik*(lSOl-1) + iAdrCVec(jSym,iSym,1)
                  Call dDaFile(LuCVector(jSym,1),2,Work(ip_CikL),
     &                         nik*lBas,iAdrL)

                  ip_V2 = ip_CikL
               Else
                  ip_V2 = ip_CikJ
               EndIf

               Call FZero(Work(ip_A),jBas*lBas)
               CALL DGEMM_('T','N',jBas,lBas,nik,
     &                    1.0d0,Work(ip_CikJ),nik,
     &                    Work(ip_V2),nik,
     &                    0.0d0,Work(ip_A),jBas)
*              Call RecPrt('A_JK',' ',Work(ip_A),
*    &                     jBas,lBas)

               Do lAOl = 0, lBas-1
                  lSOl = lSO + lAOl - iOffA
                  Do jAOj = 0, jBas-1
                     jSOj = jSO + jAOj - iOffA
                     nijkl = nijkl + 1

                     temp = CoulFac*V_K(jSOj,1)*V_K(lSOl,1)
                     temp = temp - ExFac*Work(ip_A+nijkl-1)
*
                     PMax = Max(PMax,Abs(temp))
                     PAO(nijkl,iPAO) = Fac*temp
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Hybrid UDFT and UHF
*
      Else If(iMP2prpt .ne. 2 .and. .not. lPSO .and. iUHF.eq.1) Then
*                                                                      *
************************************************************************
*                                                                      *
         jSym = 1
         kSym = jSym
         iSym = 1
         lSym = iEor(jSym-1,iSym-1)+1
*
         ip_CikJ_(1) = ip_CijK
*
         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
            jSOj = jSO - iOffA
*
*           Pick up the MO transformed fitting coefficients, C_ik^J
            nik = nIJ1(iSym,kSym,1)
            If (nik.ne.0) Then
              iAdrJ = nik*(jSOj-1) + iAdrCVec(jSym,iSym,1)
              Call dDaFile(LuCVector(jSym,1),2,Work(ip_CikJ_(1)),
     &                     nik*jBas,iAdrJ)
            EndIf
*
            ip_CikJ_(2)=ip_CikJ_(1)+nik*nMaxBas
            nik = nIJ1(iSym,kSym,2)
            If (nik.ne.0) Then
              iAdrJ = nik*(jSOj-1) + iAdrCVec(jSym,iSym,2)
*
              Call dDaFile(LuCVector(jSym,2),2,Work(ip_CikJ_(2)),
     &                  nik*jBas,iAdrJ)
            EndIf
*
            ip_CikL = ip_CikJ_(nKVec) + nik*nMaxBas

            Do i4 = 1, iCmp(4)
               lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
               iPAO = iPAO + 1
               nijkl = 0

               Factor=0.0d0
               Call FZero(Work(ip_A),jBas*lBas)
               Do iSO=1,nKVec
                 nik = nIJ1(iSym,kSym,iSO)
                 If (nik.ne.0) Then
                   If (lSO.ne.jSO) Then
                      lSOl = lSO - iOffA
                      iAdrL = nik*(lSOl-1) + iAdrCVec(jSym,iSym,iSO)
                      Call dDaFile(LuCVector(jSym,iSO),2,Work(ip_CikL),
     &                             nik*lBas,iAdrL)
                      ip_V2 = ip_CikL
                   Else
                      ip_V2 = ip_CikJ_(iSO)
                   EndIf
*
                   CALL DGEMM_('T','N',jBas,lBas,nik,
     &                         1.0d0,Work(ip_CikJ_(iSO)),nik,
     &                         Work(ip_V2),nik,
     &                         Factor,Work(ip_A),jBas)
                    Factor=1.0d0
                 EndIf
               End Do

               Do lAOl = 0, lBas-1
                  lSOl = lSO + lAOl - iOffA
                  Do jAOj = 0, jBas-1
                     jSOj = jSO + jAOj - iOffA
                     nijkl = nijkl + 1

                     temp = CoulFac*V_K(jSOj,1)*V_K(lSOl,1)
                     temp = temp - 2.0d0*ExFac*Work(ip_A+nijkl-1)
*
                     PMax = Max(PMax,Abs(temp))
                     PAO(nijkl,iPAO) = Fac*temp
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*     CASSCF
*
      Else If(iMP2prpt .ne. 2 .and. lPSO .and. .not.LSA) Then
*                                                                      *
************************************************************************
*                                                                      *
         iSO=1
*
         jSym = 1
         kSym = jSym
         iSym = 1
         lSym = iEor(jSym-1,iSym-1)+1
*
         ip_CikJ = ip_CijK
*
         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
*
*           Pick up the MO transformed fitting coefficients, C_ik^J
            nik = nIJ1(iSym,kSym,iSO)
            ip_CikL = ip_CikJ + nik*nMaxBas
            jSOj = jSO - iOffA
            iAdrJ = nik*(jSOj-1) + iAdrCVec(jSym,iSym,1)
            Call dDaFile(LuCVector(jSym,1),2,Work(ip_CikJ),
     &                   nik*jBas,iAdrJ)

            Do i4 = 1, iCmp(4)
               lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
               iPAO = iPAO + 1
               nijkl = 0

               If (lSO.ne.jSO) Then
                  lSOl = lSO - iOffA
                  iAdrL = nik*(lSOl-1) + iAdrCVec(jSym,iSym,1)
                  Call dDaFile(LuCVector(jSym,1),2,Work(ip_CikL),
     &                         nik*lBas,iAdrL)

                  ip_V2 = ip_CikL
               Else
                  ip_V2 = ip_CikJ
               EndIf

               Call FZero(Work(ip_A),jBas*lBas)
               CALL DGEMM_('T','N',jBas,lBas,nik,
     &                    1.0d0,Work(ip_CikJ),nik,
     &                    Work(ip_V2),nik,
     &                    0.0d0,Work(ip_A),jBas)

               Do lAOl = 0, lBas-1
                  lSOl = lSO + lAOl - iOffA
                  Do jAOj = 0, jBas-1
                     jSOj = jSO + jAOj - iOffA
                     nijkl = nijkl + 1

                     temp = CoulFac*V_K(jSOj,1)*V_K(lSOl,1)
                     temp = temp - ExFac*Work(ip_A+nijkl-1)
*
*----- Active space contribution
                     temp2=0.0d0
                     Do jp=1,nnP(0)
                       temp2 = temp2 +
     &                         sign(1.0d0,DMdiag(jp,1))*
     &                         Z_p_K(jp,jSOj,1)*Z_p_K(jp,lSOl,1)
                     End Do
                     temp=temp+temp2
*
                     PMax = Max(PMax,Abs(temp))
                     PAO(nijkl,iPAO) = Fac*temp
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*     SA-CASSCF
*
      Else If( iMP2prpt .ne. 2 .and. lPSO .and. lSA ) Then
*                                                                      *
************************************************************************
*                                                                      *
         jSym = 1
         kSym = jSym
         iSym = 1
         lSym = iEor(jSym-1,iSym-1)+1
*
         ip_CikJ_(1) = ip_CijK
*
         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
            jSOj = jSO - iOffA
*
*           Pick up the MO transformed fitting coefficients, C_ik^J
            nik = nIJ1(iSym,kSym,1)
            If (nik.ne.0) Then
              iAdrJ = nik*(jSOj-1) + iAdrCVec(jSym,iSym,1)
              Call dDaFile(LuCVector(jSym,1),2,Work(ip_CikJ_(1)),
     &                     nik*jBas,iAdrJ)
            EndIf
*
            ip_CikJ_(2)=ip_CikJ_(1)+nik*nMaxBas
            nik = nIJ1(iSym,kSym,2)
            If (nik.ne.0) Then
              iAdrJ = nik*(jSOj-1) + iAdrCVec(jSym,iSym,2)
*
              Call dDaFile(LuCVector(jSym,2),2,Work(ip_CikJ_(2)),
     &                  nik*jBas,iAdrJ)
            EndIf
*
            ip_CikL = ip_CikJ_(nKVec) + nik*nMaxBas

            Do i4 = 1, iCmp(4)
               lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
*
               iPAO = iPAO + 1
               nijkl = 0

               Factor=0.0d0
               Call FZero(Work(ip_A),jBas*lBas)

               Do iSO=1,nKVec
                 nik = nIJ1(iSym,kSym,iSO)
                 If (nik.ne.0) Then
                   If (lSO.ne.jSO) Then
                      lSOl = lSO - iOffA
                      iAdrL = nik*(lSOl-1) + iAdrCVec(jSym,iSym,iSO)
                      Call dDaFile(LuCVector(jSym,iSO),2,Work(ip_CikL),
     &                             nik*lBas,iAdrL)
                      ip_V2 = ip_CikL
                   Else
                      ip_V2 = ip_CikJ_(iSO)
                   EndIf
*
** Here one should keep track of negative eigenvalues of the densities
*
                   iSO2=iSO+2
*
                   Do l=0,lBas-1
                     Do k=0,jBas-1
                       tmp=0.0d0
                       Do i=0,nChOrb(0,iSO)-1
                          Do j=0,npos(0,iSO)-1
                             tmp=tmp+
     &                 Work(ip_CikJ_(iSO)+i*nChOrb(0,iSO2)+j+k*nik)*
     &                 Work(ip_V2+i*nChOrb(0,iSO2)+j+l*nik)
                          End Do
                          Do j=npos(0,iSO),nChOrb(0,iSO2)-1
                             tmp=tmp-
     &                 Work(ip_CikJ_(iSO)+i*nChOrb(0,iSO2)+j+k*nik)*
     &                 Work(ip_V2+i*nChOrb(0,iSO2)+j+l*nik)
                          End Do
                       End Do
                       Work(ip_A+l*jBas+k)=
     &                   Factor*Work(ip_A+l*jBas+k)+tmp
                     End Do
                   End Do
                   Factor=1.0d0
                 EndIf
               End Do

               Do lAOl = 0, lBas-1
                  lSOl = lSO + lAOl - iOffA
                  Do jAOj = 0, jBas-1
                     jSOj = jSO + jAOj - iOffA
                     nijkl = nijkl + 1

                     temp=CoulFac*(V_K(lSOl,1)*V_K(jSOj,2)+
     &                             V_K(lSOl,2)*V_K(jSOj,1)+
     &                             V_K(lSOl,3)*V_K(jSOj,4)+
     &                             V_K(lSOl,4)*V_K(jSOj,3)+
     &                             V_K(lSOl,1)*V_K(jSOj,5)+
     &                             V_K(lSOl,5)*V_K(jSOj,1))
                     temp = temp - ExFac*Work(ip_A+nijkl-1)
*
*----- Active space contribution
                     temp2=0.0d0
                     Do jp=1,nnP(0)
                       temp2 = temp2 +
     &                           sign(1.0d0,DMdiag(jp,1))*
     &                         Z_p_K(jp,jSOj,1)*Z_p_K(jp,lSOl,1)+
     &                           sign(2.0d0,DMdiag(jp,2))*
     &                         (Z_p_K(jp,jSOj,2)*Z_p_K(jp,lSOl,3)+
     &                          Z_p_K(jp,jSOj,3)*Z_p_K(jp,lSOl,2))
                     End Do
                     temp=temp+temp2
*
                     PMax = Max(PMax,Abs(temp))
                     PAO(nijkl,iPAO) = Fac*temp
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*     MP2
*
      Else
*                                                                      *
************************************************************************
*                                                                      *
         iSO=1
*
         jSym = 1
         kSym = jSym
         iSym = 1
         lSym = iEor(jSym-1,iSym-1)+1

         nik = nIJ1(iSym,lSym,iSO)

         ip_CijK2 = ip_CijK + nik*nMaxBas
         Do i2 = 1, iCmp(2)
            jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)

            jSOj = jSO - iOffA
            iAdrJ = nik*(jSOj-1) + iAdrCVec(jSym,iSym,1)
            Call dDaFile(LuCVector(jSym,1),2,Work(ip_CijK),
     &                   nik*jBas,iAdrJ)

            Do i4 = 1, iCmp(4)
               lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
               iPAO = iPAO + 1
               nijkl = 0
*
               If (lSO.ne.jSO) Then
                  lSOl = lSO - iOffA
                  iAdrL = nik*(lSOl-1) + iAdrCVec(jSym,iSym,1)
                  Call dDaFile(LuCVector(jSym,1),2,Work(ip_CijK2),
     &                         nik*lBas,iAdrL)

                  ip_V2 = ip_CijK2
               Else
                  ip_V2=ip_CijK
               EndIf

               Call FZero(Work(ip_A),jBas*lBas)
               CALL DGEMM_('T','N',jBas,lBas,nik,
     &                    1.0d0,Work(ip_CijK),nik,
     &                    Work(ip_V2),nik,
     &                    0.0d0,Work(ip_A),jBas)
*              Call RecPrt('A_JK',' ',Work(ip_A),
*    &                     jBas,lBas)
*
               Do lAOl = 0, lBas-1
                  lSOl = lSO + lAOl - iOffA
*
*                 While the I/O here has been moved outside the
*                 inner loop this needs to be reconsidered and
*                 improved such that it can be moved out yet
*                 another loop (or more.)
*
                  lTot = jBas
                  iAdrA = nAuxVe*(lSOl-1) + (jSO - iOffA)
                  Call dDaFile(LuAVector(1),2,Work(ip_A_MP2(1)),
     &                         lTot,iAdrA)
                  iAdrA = nAuxVe*(lSOl-1) + (jSO - iOffA)
                  Call dDaFile(LuAVector(2),2,Work(ip_A_MP2(2)),
     &                         lTot,iAdrA)
*
                  Do jAOj = 0, jBas-1
                     jSOj = jSO + jAOj - iOffA
                     nijkl = nijkl + 1
*
                     temp = CoulFac*V_K(jSOj,1)*V_K(lSOl,1)
     &                    + CoulFac*V_K(jSOj,1)*U_K(lSOl)
     &                    + CoulFac*U_K(jSOj)*V_K(lSOl,1)
     &                    - ExFac*Work(ip_A+nijkl-1)
*
                     tempJ_mp2=Work(ip_A_MP2(2)+jAOj)
                     temp = temp + tempJ_mp2*CoulFac
*
                     tempK_mp2=Work(ip_A_MP2(1)+jAOj)
                     temp = temp - ExFac*half*tempK_mp2
*
                     PMax = Max(PMax,Abs(temp))
                     PAO(nijkl,iPAO) = Fac*temp
                  End Do
               End Do
            End Do
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iPAO.ne.nPAO) Then
         Write (6,*) ' Error in PGet1_RI2!'
         Call Abend
      End If
*
#ifdef _DEBUGPRINT_
      Call RecPrt(' In PGet1_RI2:PAO ',' ',PAO,ijkl,nPAO)
      Call GetMem(' Exit PGet1_RI2','CHECK','REAL',iDum,iDum)
#endif
      Call CWTime(Cpu2,Wall2)
      Cpu = Cpu2 - Cpu1
      Wall = Wall2 - Wall1
      tavec(1) = tavec(1) + Cpu
      tavec(2) = tavec(2) + Wall
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Shijij)
         Call Unused_integer(iBas)
         Call Unused_integer(kBas)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Cho_Fock_MoTra(nSym,nBas,nFro,
     &                DLT,DSQ,FLT,nFLT,FSQ,ExFac)

      Implicit Real*8 (a-h,o-z)
      Integer nSym, nBas(nSym), nFro(nSym)
      Real*8  DLT(*), DSQ(*), FLT(nFLT), FSQ(*)
      Real*8  ExFac
#include "WrkSpc.fh"

      Integer  ip_of_Work
      External ip_of_Work

      Integer NScreen
      Real*8  dmpk, dFKmat
      Integer nDen, nXorb(8), nChMOs(8)


*****************************************************************
*  CALCULATE AND RETURN FMAT DUE TO FROZEN ORBITALS ONLY
*****************************************************************


      NScreen=10
      dmpK=1.0d-1
      dFKmat=0.0d0
      nDen=1
      Call IZero(nXorb,nSym)

* --- Initialize Cholesky information

      ChFracMem=0.0d0
      CALL CHO_X_INIT(irc,ChFracMem)
      if (irc.ne.0) then
         write(6,*)'Cho_Fock_Motra: Cho_X_Init returns error code ',irc
         Call AbEnd()
      endif

      ipDSQ = ip_of_Work(DSQ(1))  ! not needed on exit

      MOdim=0
      Do i=1,nSym
         MOdim=MOdim+nBas(i)**2
      End Do
      CALL GETMEM('choMOs','allo','real',ipMOs,MOdim)

      ipd = ipDSQ
      ipV = ipMOs
      Do i=1,nSym
          if(nBas(i).gt.0)then
            Ymax=0.0d0
            do ja=1,nBas(i)
               jaa=ipd-1+nBas(i)*(ja-1)+ja
               Ymax=Max(Ymax,Work(jaa))
            end do
            Thr = 1.0d-8*Ymax
            CALL CD_InCore(Work(ipd),nBas(i),Work(ipV),nBas(i),
     &                     NumV,Thr,irc)
            if(irc.ne.0)then
              write(6,*)'Cho_Fock_Motra: CD_incore returns rc ',irc
              Call AbEnd()
            endif

            nChMOs(i)= NumV

            if ( NumV .ne. nFro(i) ) then
             write(6,'(a,a,i6,a,i6,a,i6,a,i6,a,i6)')
     &       'Warning! Cho_Fock_Motra: nr of Frozen orbitals from the ',
     &       'decomposition of the density matrix is ',numV,
     &       ' in symm. ',i, '; Expected value = ',nFro(i),
     &       '; Max diagonal of the density in symm. ',i,
     &       ' is equal to ',Ymax
            endif

          else

            nChMOs(i)= 0

          endif

          ipd = ipd + nBas(i)**2
          ipV = ipV + nBas(i)**2
      End Do

      ipDLT = ip_of_Work(DLT(1))
      ipFLT = ip_of_Work(FLT(1))
      ipFSQ = ip_of_Work(FSQ(1))  ! not needed on exit

      CALL CHO_LK_SCF(irc,nDen,[ipFLT],[ipFSQ],nXorb,nFro,
     &                [ipMOs],[ipDLT],0.5d0*ExFac,NScreen,dmpk,dFKmat)
      if (irc.ne.0) then
         write(6,*)'Cho_Fock_Motra: Cho_LK_scf returns error code ',irc
         Call AbEnd()
      endif

      Call GADSUM(FLT,nFLT)

      CALL GETMEM('choMOs','free','real',ipMOs,MOdim)

* --- Finalize Cholesky information

      CALL CHO_X_FINAL(irc)
      if (irc.ne.0) then
         write(6,*)'Cho_Fock_Motra: Cho_X_Final returns error code ',irc
         write(6,*)'Try recovery -- continue.'
      endif

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Per Ake Malmqvist                                *
!               1989, Bjorn O. Roos                                    *
!               1991,1993, Markus P. Fuelscher                         *
!               1991,1993, Jeppe Olsen                                 *
!               1998, Roland Lindh                                     *
!***********************************************************************

subroutine RASSCF(IRETURN)
!***********************************************************************
!                                                                      *
!           ######     #     #####   #####   #####  #######            *
!           #     #   # #   #     # #     # #     # #                  *
!           #     #  #   #  #       #       #       #                  *
!           ######  #     #  #####   #####  #       #####              *
!           #   #   #######       #       # #       #                  *
!           #    #  #     # #     # #     # #     # #                  *
!           #     # #     #  #####   #####   #####  #                  *
!                                                                      *
!                                                                      *
!                   A program for complete (CAS) and                   *
!                   restricted (RAS)SCF calculations                   *
!                                                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher and J. Olsen, P.Aa. Malmqvist and B.O. Roos       *
!     University of Lund, Sweden                                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     MOLCAS version 1 by P.Aa. Malmqvist and B.O. Roos, 1989          *
!     MOLCAS version 2 by M.P. Fuelscher and J. Olsen  , 1991          *
!     MOLCAS version 3 by M.P. Fuelscher and J. Olsen  , 1993          *
!                                                                      *
!     Modified to process only unique symmetry blocks, R. Lindh,       *
!     March 1998.                                                      *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use Fock_util_global, only: ALGO, DoActive, DoCholesky
use write_orbital_files, only: OrbFiles, putOrbFile, write_orb_per_iter
use filesystem, only: copy_, real_path
use generic_CI, only: CI_solver_t
use fciqmc, only: DoNECI, fciqmc_solver_t, tGUGA_in
use fciqmc_read_RDM, only: dump_fciqmc_mats
use para_info, only: king
use fortran_strings, only: str
use spin_correlation, only: orb_range_p, orb_range_q, spin_correlation_driver
use CC_CI_mod, only: CC_CI_solver_t, Do_CC_CI
use fcidump, only: DumpOnly, make_fcidumps, transform
use orthonormalization, only: ON_scheme
use casvb_global, only: ifvb, invec_cvb
use OFembed, only: Do_OFemb, FMaux
use UnixInfo, only: ProgName
use rctfld_module, only: lRF
use Lucia_Interface, only: Lucia_Util
use wadr, only: CMO, D1A, D1I, DIAF, DMAT, DSPN, FA, FI, FockOcc, OccN, PA, PMAT, TUVX
use sguga, only: CIS, EXS, SGS, SG_Free
use gas_data, only: iDOGAS
use input_ras, only: Key, LuInput
use raswfn, only: cre_raswfn, Wfn_FileID
use timers, only: TimeCIOpt, TimeInput, TimeOrb, TimeOutput, TimeRelax, TimeTotal, TimeTrans, TimeWfn
use rasscf_global, only: CBLBM, CMAX, Conv, DE, DOBLOCKDMRG, DoDMRG, DoFaro, DoFCIDump, ECAS, EMY, Ener, ESX, ExFac, FDIAG, HalfQ, &
                         iAdr15, iBLBM, ICICH, iCIOnly, iCIRST, iExpand, IfCrPr, InOCalc, IPCMROOT, iPr, iPT2, iRLXRoot, iRoot, &
                         iSave_Exp, iSymBB, ITER, ITERCI, ITERSX, JBLBM, KSDFT, KSDFT_Temp, l_casdft, lSquare, MaxIt, NAC, NACPAR, &
                         NACPR2, NewFock, nFint, no2m, NonEQ, nROOTS, PotNuc, QNSTEP, QNUPDT, ROTMax, Start_Vectors, SXShft, Thre, &
                         ThrSX, THRTE, TMin, Tot_Charge, VIA_DFT, Weight
use PrintLevel, only: DEBUG, TERSE, USUAL
use output_ras, only: IPRLOC, RC_CI, RC_SX
use general_data, only: CleanMask, CRPROJ, CRVec, INVEC, ISPIN, ITERFILE, JOBIPH, NALTER, NASH, NBAS, NCONF, NCRVEC, NDEL, NFRO, &
                        NISH, NRS1, NRS2, NRS3, NSYM, NTOT, NTOT1, NTOT2
use DWSol, only: DWSol_final, DWSol_init, DWSolv
use Molcas, only: MxRoot
use RASDim, only: MxIter
#ifdef _DMRG_
use qcmaquis_interface, only: dmrg_energy, qcmaquis_interface_deinit, qcmaquis_interface_delete_chkp, &
                              qcmaquis_interface_prepare_hirdm_template, qcmaquis_param, TEMPLATE_4RDM, TEMPLATE_TRANSITION_3RDM
use qcmaquis_interface_mpssi, only: qcmaquis_mpssi_transform
use lucia_data, only: RF1, RF2
use rasscf_global, only: DoDelChk, DoMCPDFTDMRG, DoNEVPT2Prep, Twordm_qcm
#endif
#ifdef _FDE_
use Embedding_global, only: Eemb, embInt, embPot, embPotInBasis, embPotPath, embWriteEsp
#endif
#ifdef _HDF5_
use mh5, only: mh5_put_attr, mh5_put_dset
use csfbas, only: CONF
use lucia_data, only: CFTP, DStmp, Dtmp
use raswfn, only: wfn_energy, wfn_iter, wfn_transdens, wfn_transsdens
use rasscf_global, only: lRoots
use general_data, only: NACTEL, STSYM
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: IReturn
integer(kind=iwp) :: actual_iter, i, i_ROOT, iAd, iAd15, iBas, iComp, iFinal, iFlags, ihh, imm, Ind, IndType(7,8), iOff, iOpt, &
                     iPrLev, iRC, iRot, iss, istatus, iSyLbl, iSym, iTerm, j, kau, kRoot, LuOne, LuvvVec, mRoots, NoScr1, nTav, &
                     RC_RAS
real(kind=wp) :: CASDFT_E, CASDFT_FUNCT, DiffE, DiffETol, dum1, dum2, dum3, EAv, ECAS1, EVAC, ThMax, time0(2), time1(2), time2(2), &
                 time3(2), TMXTOT
logical(kind=iwp) :: DSCF, IfOpened, lOPTO, lTemp
character(len=80) :: Line, VecTyp
character(len=15) :: STLNE2
character(len=8) :: Label
character :: CTHRE, CTHRSX, CTHRTE
class(CI_solver_t), allocatable :: CI_solver
real(kind=wp), allocatable :: CMON(:), Dens(:), EDUM(:), Fock(:), folded_Fock(:), OCCX(:), orbital_E(:), PUVX(:), QMat(:), &
                              Scr1(:), Scr2(:), SMat(:), Tmp1(:), TmpD1S(:), TmpDMat(:), TmpDS(:)
#ifdef _HDF5_
integer(kind=iwp) :: iDX, jDisk, jRoot, kDisk
integer(kind=iwp), allocatable :: kcnf(:)
real(kind=wp), allocatable :: Tmp(:), VecL(:), VecR(:)
#endif
#ifdef _FDE_
integer(kind=iwp) :: iDummyEmb, iEmb, iUnit, nNuc
real(kind=wp), external :: EmbPotEneMODensities
#endif
#ifdef _DMRG_
integer(kind=iwp) :: maxBD, maxtrR
real(kind=wp) :: maxtrW
logical(kind=iwp) :: Do_ESPF
logical(kind=iwp), external :: PCM_On
#endif
integer(kind=iwp), external :: IsFreeUnit, isStructure
real(kind=wp), external :: Get_ExFac
#include "warnings.h"

! Set status line for monitor:
call StatusLine('RASSCF: ','Just started.')

! Set the return code(s)
ITERM = 0
IRETURN = _RC_ALL_IS_WELL_

! Set the HDF5 file id (a proper id will never be 0)
wfn_fileid = 0

! Set some Cholesky stuff
DoActive = .true.
! Initialise doDMRG if compiled without QCMaquis
#ifndef _DMRG_
DoDMRG = .false.
#endif

! Set variable IfVB to check if this is a VB job.
IfVB = 0
if (ProgName(1:5) == 'casvb') IfVB = 2
! Default option switches and values, and initial data.
THMAX = Zero
call RasScf_Init()
call Seward_Init()
! Open the one-olectron integral file:
LuOne = 77
LuOne = isFreeUnit(LuOne)
iRC = -1
iOpt = 0
call OpnOne(iRC,iOpt,'ONEINT',LuOne)
if (iRC /= 0) then
  write(u6,*) 'Error when trying to open the one-electron'
  write(u6,*) 'integral file.'
  call Quit(_RC_INTERNAL_ERROR_)
end if
call StatusLine('RASSCF: ','Read-in ONEINT')

if (IfVB /= 2) then
  ! Make a copy, upper-cased, left-adjusted, of the input between and including
  ! the '&RASSCF' and the 'End of input' markers, skipping all lines beginning
  ! with '*' or '!' or ' '  when left-adjusted, and replacing any rightmost
  ! substring beginning with '!' with blanks.
  ! That copy will be in file 'CleanInput', and its unit number is returned
  ! as LUInput in common (module file input_ras.F90) by the following call:
  call cpinp(LUInput,iRc)
  ! If something wrong with input file:
  if (iRc /= _RC_ALL_IS_WELL_) then
    call WarningMessage(2,'Input file is unusable.')
    write(u6,*) ' RASSCF Error: Could not make a clean copy of'
    write(u6,*) ' the input file. This is an unexpected bug.'
    IRETURN = _RC_INTERNAL_ERROR_
    call Finalize()
    return
  end if

  ! Scan the input file for keywords:
  call Scan_Inp(iRc)
  ! If something wrong with input file:
  if (iRc /= _RC_ALL_IS_WELL_) then
    if (IPRLOC(1) >= TERSE) then
      call WarningMessage(2,'Scanning input file failed.')
      ! Calling again, now with iRc indicating an error, will echo the keywords:
      call Scan_Inp(iRc)
    end if
    IRETURN = _RC_INPUT_ERROR_
    call Finalize()
    return
  end if

  ! Local print level in this routine:
  IPRLEV = IPRLOC(1)
end if

! Open files
call OpnFls_RASSCF(DSCF,DoCholesky)

! Some preliminary input data:
call Rd1Int()
if (.not. DSCF) call Rd2Int_RASSCF()

! Printed program header:

! Process the input:
call StatusLine('RASSCF: ','Processing input')
call Proc_Inp(DSCF,lOPTO,iRc)
! If something goes wrong in proc_inp:
if (iRc /= _RC_ALL_IS_WELL_) then
  if (IPRLEV >= TERSE) then
    call WarningMessage(2,'Input processing failed.')
    write(u6,*) ' RASSCF Error: Proc_Inp failed unexpectedly.'
    write(u6,*) ' Check the output file for any previous messages'
    write(u6,*) ' that can help explain the failure.'
    write(u6,*) ' Here is a printing of the input file that'
    write(u6,*) ' was processed:'
    rewind(LUInput)
    do
      read(LuInput,'(A80)',iostat=istatus) Line
      if (istatus /= 0) exit
      write(u6,*) Line
    end do
  end if
  IRETURN = iRc
  call Finalize()
  return
end if
if (lRF) call DWSol_init(IPCMROOT,nRoots,NonEq)
!call DWSCF_init(1,nRoots)

! Local print level may have changed:
IPRLEV = IPRLOC(1)

call InpPri(lOpto)

! Note that CI_solver subclasses provide a cleanup procedure
! (C++ people might call it destructor). Hence the deallocation and
! cleanup is automatically performed, when it goes out of scope.
if (DoNECI) then
  allocate(CI_solver,source=fciqmc_solver_t(tGUGA_in))
else if (Do_CC_CI) then
  allocate(CI_solver,source=CC_CI_solver_t())
end if

! If this is not CASDFT make sure the DFT flag is unset

if (KSDFT(1:3) == 'SCF') then
  call Get_iScalar('System BitSwitch',iFlags)
  call Put_iScalar('System BitSwitch',ibclr(iFlags,6))
end if

! If the ORBONLY option was chosen, then Proc_Inp just generated
! orbitals from the JOBIPH file. Nothing more to do:
if ((.not. Key('ORBO')) .and. (MAXIT /= 0)) then
# ifdef _DMRG_
  ! delete old checkpoints, unless requested otherwise
  ! this flag is set in proc_inp
  if (.not. DoDelChk) then
    do kroot=1,nroots
      call qcmaquis_interface_delete_chkp(iroot(kroot))
    end do
  end if
# endif

  ! Allocate various matrices

  call mma_allocate(FI,NTOT1,Label='FI')
  call mma_allocate(FA,NTOT1,Label='FA')
  call mma_allocate(D1I,NTOT2,Label='D1I')
  call mma_allocate(D1A,NTOT2,Label='D1A')
  call mma_allocate(OCCN,NTOT,Label='OccN')
  call mma_allocate(CMO,NTOT2,Label='CMO')
  call mma_allocate(DIAF,NTOT,Label='DIAF')
# ifdef _DMRG_
  ! Allocate RDMs for the reaction field reference root in QCMaquis calculations
  if (doDMRG .and. PCM_On()) then
    call mma_allocate(RF1,NACPAR,Label='RF1')
    if (twordm_qcm) call mma_allocate(RF2,NACPR2,Label='RF2')
  end if
# endif
  FI(:) = Zero
  FA(:) = Zero
  DIAF(:) = Zero
  ECAS1 = Zero
  EVAC = Zero

  if ((iCIRST == 1) .and. DumpOnly) then
    write(u6,*) 'ICIRST and DumpOnly flags are not compatible!'
    write(u6,*) 'Choose only one.'
    call Abend()
  end if

  if (DumpOnly) then
    write(u6,*) 'Dumping integrals.'
    write(u6,*) 'Nothing else will be done.'
  end if

  call mma_allocate(TUVX,NACPR2,Label='TUVX')
  TUVX(:) = Zero
  call mma_allocate(DSPN,NACPAR,Label='DSPN')
  DSPN(:) = Zero
  call mma_allocate(DMAT,NACPAR,Label='DMat')
  DMAT(:) = Zero
  call mma_allocate(PMAT,NACPR2,Label='PMat')
  PMAT(:) = Zero
  call mma_allocate(PA,NACPR2,Label='PA')
  PA(:) = Zero
# ifdef _FDE_
  ! Embedding
  iDummyEmb = 0
  call Get_iScalar('embpot',iDummyEmb)
  if (iDummyEmb == 1) embPot = .true.
  if (embPot) call EmbPotRdRun()
  if (embpot) then
    ! I have no idea why i need memory for x+4 entries
    ! and not just x...
    call mma_allocate(embInt,NTOT1+4,label='Emb')
    if (embPotInBasis) then
      ! If the potential is given in basis set representation it
      ! has not been calculated with a OneEl call and is just read
      ! from file here.
      iunit = isFreeUnit(1)
      call molcas_open(iunit,embPotPath)
      do iEmb=1,NTOT1
        read(iunit,*) embInt(iEmb)
      end do
    else
      ! Read in the embedding potential one-electron integrals
      Label = 'embpot  '
      iRC = -1
      iOpt = 0
      iComp = 1
      call RdOne(iRC,iOpt,Label,iComp,embInt,iSyLbl)
      if (iRC /= 0) then
        call WarningMessage(2,'Drv1El: Error reading ONEINT;Label='//Label)
        call Quit(_RC_IO_ERROR_READ_)
      end if
    end if
  end if
# endif

  ! Get start orbitals

  ! Initialize OCCN array, to prevent false alarms later from
  ! automated detection of using uninitialized variables:
  OccN(:) = Zero

  ! PAM03: Note that removal of linear dependence may change the nr
  ! of secondary/deleted orbitals, affecting some of the global
  ! variables: NSSH(),NDEL(),NORB(),NTOT3, etc etc
  call ReadVc(CMO,OCCN,DMAT,DSPN,PMAT,PA,ON_scheme)
  ! TODO(Oskar): Add fourth argument OCC
  ! If the Occupation number is written properly as well.
  if (Key('ORTH')) call putOrbFile(CMO=CMO(:),orbital_E=DIAF(:),iDoGAS=iDoGAS)
  ! Only now are such variables finally known.

  ! Allocate core space for dynamic storage of data

  call ALLOC()

  ! Create job interphase on unit JOBIPH (FT15)

  if (ifvb /= 2) then
    call CREIPH()
    call cre_raswfn()
  end if
  if (ifvb == 1) call casinfo2_cvb()

  call Timing(dum1,dum2,time1(1),dum3)
  TimeInput = time1(1)

  !GG03 Aug 03
  if (NAlter > 0) call Alter_MO(CMO)

  ! At this point all is ready to potentially dump MO integrals... just do it if required.
  if ((.not. DumpOnly) .and. (ifvb /= 2) .and. (.not. dofcidump)) then

    !*******************************************************************
    !
    ! Wave function section
    !
    !*******************************************************************

    call StatusLine('RASSCF: ','Compute wave function.')
    if ((IPRLEV >= 2) .and. (.not. lOPTO)) then
      write(u6,*)
      write(u6,'(6X,A)') repeat('*',120)
      write(u6,'(6X,A,118X,A)') '*','*'
      write(u6,'(6X,A,44X,A,45X,A)') '*','Wave function control section','*'
      write(u6,'(6X,A,118X,A)') '*','*'
      write(u6,'(6X,A)') repeat('*',120)
      write(u6,*)
    end if

    if ((IPRLEV >= 2) .and. (.not. lOPTO)) then
      if (ICIONLY == 0) then
        write(u6,*)
        if (doDMRG) then
          write(u6,'(41X,A)') 'DMRGSCF iterations: Energy and convergence statistics'
          write(u6,'(41X,A)') '-----------------------------------------------------'
        else
          write(u6,'(41X,A)') 'RASSCF iterations: Energy and convergence statistics'
          write(u6,'(41X,A)') '----------------------------------------------------'
        end if
        write(u6,*)
      else
        write(u6,*)
        if (doDMRG) then
          write(u6,'(41X,A)') 'DMRGCI only, no orbital optimization will be done.'
          write(u6,'(41X,A)') '--------------------------------------------------'
        else
          write(u6,'(41X,A)') 'CASCI only, no orbital optimization will be done.'
          write(u6,'(41X,A)') '-------------------------------------------------'
        end if
        write(u6,*)
      end if
#     ifdef _DMRG_
      if (doDMRG) then
        write(u6,'(45x,a//,36x,a/,36x,a/,36x,a//,45x,a//,36x,a/,36x,a/,36x,a//,36x,a/,36x,a,a/,36x,a//)') &
          'Please cite for the QCMaquis-Molcas driver:', &
          'Freitag L.; Keller S.; Knecht S.; Lindh R.; Ma Y.; ', &
          'Stein C. J. and Reiher M., in preparation. (2018).', &
          '---------------------------------------------------------------', &
          'Please cite for the QCMaquis DMRG software:', &
          'S. Keller, M. Dolfi, M. Troyer, M. Reiher,', &
          'J. Chem. Phys. 143, 244118 (2015)', &
          '---------------------------------------------------------------'
      end if
#     endif
      if (INOCALC == 1) then
        write(u6,*)
        write(u6,'(26X,A)') ' No calculation will be performed. Stopping in LUCIA'
      end if
      if (ISAVE_EXP == 1) then
        write(u6,*)
        write(u6,'(26X,A)') ' Information on the CI-vector will be written to ???.'
      end if
      if (IEXPAND == 1) then
        write(u6,*)
        write(u6,'(26X,A)') ' A shorter vector will be expanded in a longer'
      end if
      if (IPRLEV <= 3) then
        if (DoDMRG .and. (ICIONLY == 0)) then
          write(u6,'(6X,A)') 'Iter num   Bond  DMRG max tr DMRG  SX      DMRGSCF       Energy    max ROT   max BLB     '// &
                             'max BLB  Level Ln srch  Step   QN     CPU Time'
          write(u6,'(6X,A)') '   sweeps/ dim  /root weight/root iter     energy        change     param    element     '// &
                             ' value   shift minimum  type update   hh:mm:ss'
        else if (DoDMRG .and. (ICIONLY /= 0)) then

        else if (l_casdft) then

        else
          write(u6,'(6X,A)') 'Iter CI   SX   CI       RASSCF       Energy    max ROT     max BLB   max BLB  Level Ln srch  '// &
                             'Step   QN   Walltime'
          write(u6,'(6X,A)') '    iter iter root      energy       change     param      element    value   shift minimum  '// &
                             'type update hh:mm:ss'
        end if
      end if
    end if
  else if (dofcidump) then
    write(u6,*)
    write(u6,'(26X,A)') 'Dumping integrals on file FCIDUMP - nothing else to be done'
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !     Start iterations
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  Rc_CI = 0
  Rc_SX = 0
  ECAS = Zero
  ROTMAX = Zero
  ITER = 0
  actual_iter = 0
  IFINAL = 0
  TMXTOT = Zero
  call mma_allocate(FockOcc,nTot1,Label='FockOcc')
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !     Entry point for second and successive iterations
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  outer: do

    if (l_casdft) then
      KSDFT_TEMP = KSDFT
      KSDFT = 'SCF'
      ExFac = One
    else
      KSDFT_TEMP = KSDFT
      ExFac = Get_ExFac(KSDFT)
    end if

    ITER = ITER+1
    write(STLNE2,'(A12,I3)') 'Iteration ',ITER
    call StatusLine('RASSCF: ',STLNE2)
    call Timing(dum1,dum2,time0(1),dum3)
#   ifdef _DMRG_
    ! Leon 27/11/2017: Skip the first CI iteration if we're using
    ! DMRGCI and CIOnly.It's enabled only for DMRGCI with QCMaquis
    ! now, (to exclude potential side effects)
    ! but consider extending it to other cases!
    call DecideOnESPF(Do_ESPF)
    !write(u6,*) ' |rasscf> DecideOnESPF == ',Do_ESPF
    if ((ITER == 1) .and. ((.not. (DoDMRG .and. (ICIONLY /= 0))) .or. lRf .or. domcpdftDMRG .or. Do_ESPF)) then
#   else
    if (ITER == 1) then
#   endif
      !*****************************************************************
      !     ^   First iteration
      !*****************************************************************

      ! Print header to file containing informations on CI iterations.

      write(IterFile,'(A)') repeat('*',80)
      write(IterFile,'(15X,A)') 'RASSCF iteration: 1A'

      Start_Vectors = .true.
      lTemp = lRf

      ! Transform two-electron integrals and compute at the same time
      ! the Fock matrices FI and FA

      call Timing(dum1,dum2,time2(1),dum3)

      if ((.not. DoCholesky) .or. (ALGO == 1)) then
        call mma_allocate(PUVX,NFINT,Label='PUVX')
        PUVX(:) = Zero
      end if

      call Get_D1I_RASSCF(CMO,D1I)
      if (IPRLEV >= DEBUG) then
        write(u6,*)
        write(u6,*) ' D1I in AO basis in RASSCF'
        write(u6,*) ' ---------------------'
        write(u6,*)
        iOff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          call wrtmat(D1I(ioff),iBas,iBas,iBas,iBas)
          iOff = iOff+iBas*iBas
        end do
      end if

      ! Compute D1A from CMO coefficients and, if CIREstart, old DMAT.
      if (iCIRST == 1) then

        call mma_allocate(TmpDMAT,NACPAR,Label='TmpDMAT')
        TmpDMAT(:) = DMAT(:)
        if (NASH(1) /= NAC) call DBLOCK(TmpDMAT)
        call Get_D1A_RASSCF(CMO,TmpDMAT,D1A)
        call mma_deallocate(TmpDMAT)

        DoActive = .true.

      else

        lRf = .false.
        if (.not. l_casdft) then
          KSDFT = 'SCF'
          ExFac = One
        end if
        D1A(:) = Zero

        DoActive = .false.

      end if

      IPR = 0
      if (IPRLOC(2) == 4) IPR = 5
      if (IPRLOC(2) == 5) IPR = 10

      if (IPRLEV >= DEBUG) then
        write(u6,*)
        write(u6,*) ' PUVX in rasscf bf first TRACTL2'
        write(u6,*) ' ---------------------'
        write(u6,*)
        call wrtmat(PUVX,1,nFint,1,nFint)

        write(u6,*)
        write(u6,*) ' ---------------------'
        write(u6,*)
        write(u6,*) ' D1A in AO basis in RASSCF bf TRACTL2 1'
        write(u6,*) ' ---------------------'
        write(u6,*)
        iOff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          call wrtmat(D1A(ioff),iBas,iBas,iBas,iBas)
          iOff = iOff+iBas*iBas
        end do
      end if

      ! Transform two-electron integrals and compute the Fock matrices FI and FA
      ! FI and FA are output from TRACTL2...
      call TRACTL2(CMO,PUVX,TUVX,D1I,FI,D1A,FA,IPR,lSquare,ExFac)

      !write(u6,*) ' TUVX after TRACTL2'
      !write(u6,*) (UVX(ind),ind=1,NACPR2)
      ! Core shift applied to projection of WF with doubly occupied core
      if ((ITER == 1) .and. IfCRPR) call MkCRVEC(CMO,CRVEC)

      if (IPRLEV >= DEBUG) then
        write(u6,*)
        write(u6,*) ' D1A in AO basis in RASSCF af TRACTL2 1'
        write(u6,*) ' ---------------------'
        write(u6,*)
        iOff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          call wrtmat(D1A(ioff),iBas,iBas,iBas,iBas)
          iOff = iOff+iBas*iBas
        end do

        write(u6,*)
        write(u6,*) ' ---------------------'
        write(u6,*)
        write(u6,*) ' PUVX in rasscf af first TRACTL2'
        write(u6,*) ' ---------------------'
        write(u6,*)
        call wrtmat(PUVX,1,nFint,1,nFint)

        write(u6,*)
        write(u6,*) ' ---------------------'

        write(u6,*) ' TUVX after TRACTL2'
        write(u6,*) (TUVX(ind),ind=1,NACPR2)
        write(u6,*)
        write(u6,*) ' ---------------------'
      end if

      if ((.not. DoCholesky) .or. (ALGO == 1)) call mma_deallocate(PUVX)

      call Timing(dum1,dum2,time2(2),dum3)
      TimeTrans = TimeTrans+time2(2)-time2(1)

      if (IPRLEV >= DEBUG) then
        write(u6,*)
        write(u6,*) ' CMO in RASSCF bf first call to CICTL'
        write(u6,*) ' ---------------------'
        write(u6,*)
        ioff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          if (iBas /= 0) then
            write(u6,*) 'Sym =',iSym
            do i=1,iBas
              write(u6,*) (CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
            end do
            iOff = iOff+(iBas*iBas)
          end if
        end do
      end if

      ! Compute initial CI vectors and density matrices

      call Timing(dum1,dum2,time3(1),dum3)

      if (DumpOnly) then
        call mma_allocate(orbital_E,nTot)
        call mma_allocate(folded_Fock,nAcPar)
        call transform(iter, &
                       CMO=CMO(:), &
                       DIAF=DIAF(:), &
                       D1I_AO=D1I(:), &
                       D1A_AO=D1A(:), &
                       D1S_MO=DSPN(:), &
                       F_IN=FI(:), &
                       orbital_E=orbital_E, &
                       folded_Fock=folded_Fock)
        call make_fcidumps('FCIDUMP','H5FCIDUMP',orbital_E,folded_Fock,TUVX=tuvx(:),core_energy=EMY)
        call mma_deallocate(orbital_E)
        call mma_deallocate(folded_Fock)
        write(u6,*) 'FCIDMP file generated. Here for serving you!'
        exit outer
      end if

      if (allocated(CI_solver)) then
        call CI_solver%run(actual_iter=actual_iter, &
                           ifinal=ifinal, &
                           iroot=iroot, &
                           weight=weight, &
                           CMO=CMO(:), &
                           DIAF=DIAF(:), &
                           D1I_AO=D1I(:), &
                           D1A_AO=D1A(:), &
                           TUVX=tuvx(:), &
                           F_IN=FI(:), &
                           D1S_MO=DSPN(:), &
                           DMAT=DMAT(:), &
                           PSMAT=pmat(:), &
                           PAMAT=pa(:))

#     if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_) || defined (_ENABLE_DICE_SHCI_)
      else if (DoBlockDMRG) then
        call DMRGCTL(CMO,DMAT,DSPN,PMAT,PA,FI,D1I,D1A,TUVX,IFINAL,0)
#     endif
      else
        call CICTL(CMO,DMAT,DSPN,PMAT,PA,FI,FA,D1I,D1A,TUVX,IFINAL)

        if (dofcidump) then
          write(u6,*) ' FCIDUMP file generated. This is the end...'
          call Finalize()
          return
        end if
#       ifdef _FDE_
        !Thomas Dresselhaus
        if (embpot) then
          !Eemb = DDot_(NACPAR,embInt,1,DMAT,1)
          !Eemb = embPotEne(D1I,D1A,embInt,CMO,nBasFunc,nFrozenOrbs,.true.)
          Eemb = embPotEneMODensities(D1I,D1A,embInt,nBas,nTot2,nSym)
          write(u6,*) 'Energy from embedding potential with the'
          write(u6,*) 'initial CI vectors: ',Eemb
        end if
        !!!!!!!!!!!!!!!!!!!
#       endif
        ! PAM 2015: Additional output line.
        if ((IPRLEV >= USUAL) .and. (.not. doDMRG)) write(u6,'(a,i4)') ' Nr of preliminary CI iterations:',ITERCI
      end if

      !.. dongxia testing jobiph
      !.. upt to here, jobiph are all zeros at iadr15(2)
      ! If CASVB job, go directly to return.
      invec_cvb = invec
      if (DSCF) NewFock = 1
      if (IfVB == 2) then
        call Finalize()
        return
      end if

      EAV = Zero
      do KROOT=1,NROOTS
        EAV = EAV+ENER(IROOT(KROOT),ITER)*WEIGHT(KROOT)
      end do

      call Get_D1A_RASSCF(CMO,DMAT,D1A)

      if (IPRLEV >= DEBUG) then
        write(u6,*)
        write(u6,*) ' D1A in AO basis in RASSCF af Get_D1A_RASSCF'
        write(u6,*) ' ---------------------'
        write(u6,*)
        iOff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          call wrtmat(D1A(ioff),iBas,iBas,iBas,iBas)
          iOff = iOff+iBas*iBas
        end do
      end if

      call Timing(dum1,dum2,time3(2),dum3)
      TimeCIOpt = TimeCIOpt+time3(2)-time3(1)
      lRf = lTemp

      if (.not. l_casdft) then
        KSDFT = KSDFT_TEMP
        ExFac = Get_ExFac(KSDFT)
      end if

      ! v GLM for MC-PDFT
      if ((KSDFT /= 'SCF') .and. (KSDFT /= 'PAM') .or. l_casdft) then
        if (IPRLEV >= DEBUG) then
          write(u6,*)
          write(u6,*) ' CMO in RASSCF bf call NATORB_RASSCF'
          write(u6,*) ' ---------------------'
          write(u6,*)
          ioff = 1
          do iSym=1,nSym
            iBas = nBas(iSym)
            if (iBas /= 0) then
              write(u6,*) 'Sym =',iSym
              do i=1,iBas
                write(u6,*) (CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
              end do
              iOff = iOff+(iBas*iBas)
            end if
          end do
        end if

        call mma_allocate(CMON,NTOT2,Label='CMON')
        call mma_allocate(OCCX,NTOT,Label='OCCX')
        noscr1 = max(nacpar,no2m)
        call mma_allocate(scr1,noscr1,Label='Scr1')
        call mma_allocate(scr2,NO2M,Label='Scr2')
        call mma_allocate(SMAT,NTOT1,Label='SMAT')
        call NATORB_RASSCF(CMO,scr1,scr2,SMAT,CMON,OCCX)
        CMO(:) = CMON(:)
        call Put_dArray('Last orbitals',CMO,ntot2)
        call mma_deallocate(scr1)
        call mma_deallocate(scr2)
        call mma_deallocate(SMAT)
        call mma_deallocate(OCCX)
        call mma_deallocate(CMON)
        if (IPRLEV >= DEBUG) then
          write(u6,*)
          write(u6,*) ' CMO in RASSCF af call NATORB_RASSCF & bf 2 CICTL'
          write(u6,*) ' ---------------------'
          write(u6,*)
          ioff = 1
          do iSym=1,nSym
            iBas = nBas(iSym)
            if (iBas /= 0) then
              write(u6,*) 'Sym =',iSym
              do i=1,iBas
                write(u6,*) (CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
              end do
              iOff = iOff+(iBas*iBas)
            end if
          end do
        end if
      end if
      !^ GLM End If for MC-PDFT

      EAV = Zero
      do KROOT=1,NROOTS
        EAV = EAV+ENER(IROOT(KROOT),ITER)*WEIGHT(KROOT)
      end do
      if (IPRLEV >= DEBUG) then
        if (l_casdft) then
          write(u6,*) 'EAV value in RASSCF after first call to CICTL:'
          write(u6,*) EAV
        end if
      end if
    end if
    !*******************************************************************
    !^ End First iteration
    !*******************************************************************

    ! Print header to file containing informations on CI iterations.

    actual_iter = actual_iter+1
    write(IterFile,*)
    write(IterFile,'(A)') repeat('*',80)
    if (Iter == 1) then
      write(IterFile,'(15X,A)') 'RASSCF iteration: 1B'
    else
      write(IterFile,'(15X,A,I3)') 'RASSCF iteration: ',Iter
    end if

    if ((IPRLEV >= DEBUG) .and. l_casdft) then
      write(u6,*) repeat('*',70)
      write(u6,*) 'we are done withe first standard CAS-CI iteration  '
      write(u6,*) 'CI coeffs are known and mantained fix in next stage'
      write(u6,*) 'We are now going to remove exchange from FI and FA '
      write(u6,*) 'in TRACTL2 --> TRA_CTL2 --> TRADRV --> FTWO        '
      write(u6,*) 'the ExFac is going to be set to 0.0 as DT asked! '
      write(u6,*) 'FI and FA are going to change... '
      write(u6,*) 'Check with previous printout to see differences.\  '
      write(u6,*) repeat('*',70)
    end if

    if (l_casdft) then
      KSDFT = KSDFT_TEMP
      ExFac = Zero
    end if

    if (ICIONLY /= 0) IFINAL = 1

    ! Transform two-electron integrals and compute at the same time
    ! the Fock matrices FI and FA

    call Timing(dum1,dum2,time2(1),dum3)
    if (.not. DoCholesky .or. (ALGO == 1)) then
      call mma_allocate(PUVX,NFINT,Label='PUVX')
      PUVX(:) = Zero
    end if
    call Get_D1I_RASSCF(CMO,D1I)

    DoActive = .true.

    if (DoCholesky .and. (ALGO == 2)) then
      NTav = sum(nBas(1:nSym)*nAsh(1:nSym))
      call mma_allocate(Qmat,NTav,Label='QMat')
      QMat(:) = Zero
    end if

    IPR = 0
    if (IPRLOC(2) == 4) IPR = 5
    if (IPRLOC(2) == 5) IPR = 10
    if (IPRLEV >= DEBUG) then
      write(u6,*)
      write(u6,*) ' D1A in AO basis in RASSCF bf TRACTL2 2'
      write(u6,*) ' ---------------------'
      write(u6,*)
      iOff = 1
      do iSym=1,nSym
        iBas = nBas(iSym)
        call wrtmat(D1A(ioff),iBas,iBas,iBas,iBas)
        iOff = iOff+iBas*iBas
      end do
    end if
    call TRACTL2(CMO,PUVX,TUVX,D1I,FI,D1A,FA,IPR,lSquare,ExFac)

    if (IPRLEV >= DEBUG) then
      write(u6,*)
      write(u6,*) ' D1A in AO basis in RASSCF af TRACTL2 2'
      write(u6,*) ' ---------------------'
      write(u6,*)
      iOff = 1
      do iSym=1,nSym
        iBas = nBas(iSym)
        call wrtmat(D1A(ioff),iBas,iBas,iBas,iBas)
        iOff = iOff+iBas*iBas
      end do
    end if

    if ((.not. DoCholesky) .or. (ALGO == 1)) call mma_deallocate(PUVX)

    call Timing(dum1,dum2,time2(2),dum3)
    TimeTrans = TimeTrans+time2(2)-time2(1)

    ! Compute the CI vectors and density matrices

    call Timing(dum1,dum2,time3(1),dum3)
    if (.not. l_casdft) then !the following is skipped in CASDFT-GLM

      if ((KSDFT /= 'SCF') .and. (KSDFT /= 'PAM')) call Put_dArray('Last orbitals',CMO,ntot2)

      if (allocated(CI_solver)) then
        ! The following is adapted from sxctl.f
        ! In addition to writing the last RasOrb to disk, the current
        ! orbitals have to be dumped *before* the CI step. The PERI
        ! keyword writes only the orbitals from the last iteration.
        IndType(:,:) = 0
        do ISYM=1,NSYM
          IndType(:,ISYM) = [NFRO(ISYM),NISH(ISYM),NRS1(ISYM),NRS2(ISYM),NRS3(ISYM),NDEL(ISYM),NBAS(ISYM)]
          IndType(7,ISYM) = IndType(7,ISYM)-sum(IndType(1:6,ISYM))
        end do
        call mma_allocate(EDUM,NTOT,Label='EDum')
        EDum(:) = Zero
        write(VecTyp,'(A)')
        VecTyp = '* RASSCF average (pseudo-natural) orbitals (Not final)'
        LuvvVec = 50
        LuvvVec = isfreeunit(LuvvVec)
        call WrVec('IterOrb',LuvvVec,'COE',NSYM,NBAS,NBAS,CMO(:),OCCN,EDUM,INDTYPE,VECTYP)
        call WrVec('IterOrb',LuvvVec,'AI',NSYM,NBAS,NBAS,CMO(:),OCCN,EDUM,INDTYPE,VECTYP)
        call mma_deallocate(EDUM)
        write(u6,*) 'MO coeffs for next iteration written to IterOrb.'

        call CI_solver%run(actual_iter=actual_iter, &
                           ifinal=ifinal, &
                           iroot=iroot, &
                           weight=weight, &
                           CMO=CMO(:), &
                           DIAF=DIAF(:), &
                           D1I_AO=D1I(:), &
                           D1A_AO=D1A(:), &
                           TUVX=tuvx(:), &
                           F_IN=FI(:), &
                           D1S_MO=DSPN(:), &
                           DMAT=DMAT(:), &
                           PSMAT=pmat(:), &
                           PAMAT=pa(:))
#     if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_) || defined (_ENABLE_DICE_SHCI_)
      else if (DoBlockDMRG) then
        call DMRGCTL(CMO,DMAT,DSPN,PMAT,PA,FI,D1I,D1A,TUVX,IFINAL,1)
#     endif
      else
        call CICTL(CMO,DMAT,DSPN,PMAT,PA,FI,FA,D1I,D1A,TUVX,IFINAL)
      end if

      ! call triprt('twxy',' ',TUVX,nTri_Elem(nAc))
      ! call triprt('P-mat 2',' ',PMAT,nTri_Elem(nAc))

      EAV = Zero
      do KROOT=1,NROOTS
        EAV = EAV+ENER(IROOT(KROOT),ITER)*WEIGHT(KROOT)
      end do

      if (IPRLEV >= DEBUG) then
        write(u6,*) 'EAV value in RASSCF after second call to CICTL:'
        write(u6,*) EAV

        write(u6,*) 'Printing matrices in RASSCF'
        write(u6,*)
        write(u6,*) ' CMO in RASSCF'
        write(u6,*) ' ---------------------'
        write(u6,*)
        ioff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          if (iBas /= 0) then
            write(u6,*) 'Sym =',iSym
            do i=1,iBas
              write(u6,*) (CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
            end do
            iOff = iOff+(iBas*iBas)
          end if
        end do

        write(u6,*)
        write(u6,*) ' D1I in AO basis in RASSCF'
        write(u6,*) ' ---------------------'
        write(u6,*)
        iOff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          call wrtmat(D1I(ioff),iBas,iBas,iBas,iBas)
          iOff = iOff+iBas*iBas
        end do
        write(u6,*)
        write(u6,*) 'Total Charge :',Tot_Charge

        call mma_allocate(Tmp1,nTot1,Label='Tmp1')
        iComp = 1
        iSyLbl = 1
        iRc = -1
        iOpt = ibset(ibset(0,sNoOri),sNoNuc)
        Label = 'OneHam'
        call RdOne(iRc,iOpt,Label,iComp,Tmp1,iSyLbl)
        if (iRc /= 0) then
          write(u6,*) 'SGFCIN: iRc from Call RdOne not 0'
#         ifdef _FDE_
          write(u6,*) 'Label = ',Label
#         endif
          write(u6,*) 'iRc = ',iRc
          call Abend()
        end if

        write(u6,*)
        write(u6,*) ' OneHam in AO basis in RASSCF'
        write(u6,*) ' ---------------------'
        write(u6,*)
        iOff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          call TriPrt(' ','(5G17.11)',Tmp1(iOff),iBas)
          iOff = iOff+nTri_Elem(iBas)
        end do

        call mma_deallocate(Tmp1)
        call Get_dScalar('PotNuc',potNuc)

        write(u6,*)
        write(u6,*) 'PotNuc :',PotNuc

        write(u6,*)
        write(u6,*) ' D1A in AO basis in RASSCF'
        write(u6,*) ' ---------------------'
        write(u6,*)
        iOff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          call wrtmat(D1A(ioff),iBas,iBas,iBas,iBas)
          iOff = iOff+iBas*iBas
        end do
      end if
    else
      call mma_allocate(FOCK,NACPAR,Label='Fock')
      ! To fix the DS bug... I forgot to transform it to the AO basis... Agrrrrhhh!
      if (iSpin == 1) then
        if (IPRLEV >= DEBUG) write(u6,*) 'running a singlet. DSPN set to zero!'
        DSPN(:) = Zero
      end if
      call mma_allocate(TmpDS,NACPAR,Label='TmpDS')
      call mma_allocate(TmpD1S,NTOT2,Label='TmpD1S')
      TmpDS(:) = DSPN(:)
      if (NASH(1) /= NAC) call DBLOCK(TmpDS)
      call Get_D1A_RASSCF(CMO,TmpDS,TmpD1S)
      call mma_deallocate(TmpDS)
      call CASDFT_terms(CMO,FOCK,FI,D1I,D1A,TmpD1S)
      call mma_deallocate(TmpD1S)
      call mma_deallocate(FOCK)
    end if

    !call TRIPRT('Averaged one-body density matrix, D, in RASSCF',' ',DMAT,NAC)
    !call TRIPRT('Averaged one-body spin density matrix DS, RASSCF',' ',DSPN,NAC)
    !call TRIPRT('Averaged two-body density matrix, P',' ',PMAT,NACPAR)
    !call TRIPRT('Averaged antisym 2-body density matrix PA RASSCF',' ',PA,NACPAR)

    call Get_D1A_RASSCF(CMO,DMAT,D1A)
    if (IPRLEV >= DEBUG) then
      write(u6,*)
      write(u6,*) ' D1A in AO basis in RASSCF bf SXCTL'
      write(u6,*) ' ---------------------'
      write(u6,*)
      iOff = 1
      do iSym=1,nSym
        iBas = nBas(iSym)
        call wrtmat(D1A(ioff),iBas,iBas,iBas,iBas)
        iOff = iOff+iBas*iBas
      end do
    end if
    call Timing(dum1,dum2,time3(2),dum3)
    TimeCIOpt = TimeCIOpt+time3(2)-time3(1)

    !call rasscf_xml(Iter)
    call rasscf_mcontrol(Iter)

    ! SX-section

    call Timing(dum1,dum2,time2(1),dum3)

    if (IPRLEV >= DEBUG) then
      write(u6,*) ' In RASSCF bf SXCTL'
      call TRIPRT('Averaged one-body density matrix, D, in RASSCF',' ',DMAT,NAC)
      call TRIPRT('Averaged two-body density matrix, P',' ',PMAT,NACPAR)
      call TRIPRT('Averaged antisym 2-body density matrix PA RASSCF',' ',PA,NACPAR)
    end if
    call SXCTL(CMO,OCCN,DMAT,PMAT,PA,FI,FA,D1A,THMAX,IFINAL)

    if (IPRLEV >= DEBUG) then
      write(u6,*)
      write(u6,*) ' FI+FA in RASSCF after SXCTL'
      write(u6,*) ' ---------------------'
      write(u6,*)
      iOff = 1
      do iSym=1,nSym
        iBas = nBas(iSym)
        call TriPrt(' ',' ',FA(iOff),iBas)
        iOff = iOff+nTri_Elem(iBas)
      end do
    end if

    !GLM write(u6,*) 'ECAS in RASSCF after call to SXCTL',ECAS
    if (IPRLEV >= DEBUG) then
      write(u6,*)
      write(u6,*) ' D1A in AO basis in RASSCF af SXCTL'
      write(u6,*) ' ---------------------'
      write(u6,*)
      iOff = 1
      do iSym=1,nSym
        iBas = nBas(iSym)
        call wrtmat(D1A(ioff),iBas,iBas,iBas,iBas)
        iOff = iOff+iBas*iBas
      end do
    end if
    call Get_D1A_RASSCF(CMO,DMAT,D1A)
    CASDFT_Funct = Zero
    if ((KSDFT /= 'SCF') .and. (KSDFT /= 'PAM')) call Get_dScalar('CASDFT energy',CASDFT_Funct)

    DE = (ECAS+CASDFT_Funct)-ECAS1
    ECAS1 = ECAS+CASDFT_Funct

    if (NAC == 0) EAV = ECAS

    if ((KSDFT(1:3) /= 'SCF') .and. (KSDFT(1:3) /= 'PAM')) then
      if (nConf == 1) then
        EAV = ECAS
      else
        EAV = EAV-VIA_DFT-HALFQ
      end if
    end if

    if (ITER == 1) DE = Zero
    call Timing(dum1,dum2,time2(2),dum3)
    TimeOrb = TimeOrb+time2(2)-time2(1)
    TMXTOT = max(TMXTOT,THMAX)

    ! Save energies and convergence parameters

    CONV(1,ITER) = ECAS
    CONV(2,ITER) = ESX
    CONV(3,ITER) = CMAX
    CONV(4,ITER) = DE
    CONV(5,ITER) = CBLBM
    CONV(6,ITER) = ROTMAX
    IAD15 = IADR15(6)
    call DDAFILE(JOBIPH,1,ENER,mxRoot*mxIter,IAD15)
    call DDAFILE(JOBIPH,1,CONV,6*mxIter,IAD15)
#   ifdef _HDF5_
    call mh5_put_attr(wfn_iter,Iter)
    call mh5_put_dset(wfn_energy,ENER(1,Iter))
#   endif

    ! Print output of energies and convergence parameters

    call Timing(dum1,dum2,time0(2),dum3)
    time0(2) = time0(2)-time0(1)
    ! Character indicating unconvergence/convergence criterion fulfilled:
    CTHRE = ' '
    CTHRSX = ' '
    CTHRTE = ' '
    if (abs(DE) > THRE) CTHRE = '*'
    if (abs(CBLBM) > THRSX) CTHRSX = '*'
    if (abs(ROTMAX) > THRTE) CTHRTE = '*'
    IROT = 0
    if (NROOTS == 1) IROT = IROOT(1)
    if ((IPRLEV >= 2) .and. (IPRLEV <= 3) .and. (.not. lOPTO)) then
      !----------------------------------
      ! Shift total energies (BOR 070411)
      if ((iter == 1) .and. (ICIONLY == 0)) then
        kau = int(ECAS*1.0e-3_wp)
        EVAC = 1.0e3_wp*real(kau,kind=wp)
        if (kau /= 0) then
          write(u6,'(6x,A,f23.2,A)') 'Total energies have been shifted. Add ',EVAC,' au'
        end if
      end if
      !----------------------------------
      ihh = int(time0(2)/3600)
      imm = int(time0(2)-ihh*3600)/60
      iss = int(time0(2)-ihh*3600-imm*60)
      if (doDMRG .and. Key('CION')) then ! If DMRG only -- yma
        write(u6,'(/6X,a,F19.10)') 'DMRGCI energy              :',EAV+CASDFT_Funct
        write(u6,'(6X,a,I5,A1,I2.2,A1,I2.2/)') 'Total time spent (hh:mm:ss):        ',ihh,':',imm,':',iss
      else if (doDMRG) then
#       ifdef _DMRG_
        maxtrW = Zero
        maxtrR = -1
        maxBD = -1
        ! These dmrg variables are arrays of rank 1
        ITERCI = maxval(dmrg_energy%num_sweeps)
        IROT = maxloc(dmrg_energy%num_sweeps,1)
        maxtrW = maxval(dmrg_energy%max_truncW)
        maxtrR = maxloc(dmrg_energy%max_truncW,1)
        maxBD = maxval(dmrg_energy%bond_dim)
        write(u6,103) ITER,ITERCI,IROT,maxBD,maxtrW,maxtrR,ITERSX,ECAS-EVAC+CASDFT_Funct,DE,CTHRE,ROTMAX,CTHRTE,IBLBM,JBLBM, &
                      ISYMBB,CBLBM,CTHRSX,SXSHFT,TMIN,QNSTEP,QNUPDT,ihh,':',imm,':',iss
#       endif
      else
        write(u6,104) ITER,ITERCI,ITERSX,IROT,ECAS-EVAC+CASDFT_Funct,DE,CTHRE,ROTMAX,CTHRTE,IBLBM,JBLBM,ISYMBB,CBLBM,CTHRSX, &
                      SXSHFT,TMIN,QNSTEP,QNUPDT,ihh,':',imm,':',iss
      end if
    else if (IPRLEV >= 4) then
      write(u6,'(6X,A,I4)') 'Energy statistics and convergence in iteration',ITER
      write(u6,'(6X,A,10X,F26.6)') 'Average of CI energies',EAV-EVAC
      write(u6,'(6X,A,F26.6)') 'Complete active space SCF energy',ECAS-EVAC
      write(u6,'(6X,A,17X,F26.6)') 'Super-CI energy',ESX
      write(u6,'(6X,A,12X,F26.6,3X,A1)') 'RASSCF energy change',DE,CTHRE
      write(u6,'(6X,A,I1,A1,2I3,F19.6)') 'Maximum BLB matrix element(sym=',ISYMBB,')',IBLBM,JBLBM,CBLBM
      write(u6,'(6X,A,10X,F26.6,3X,A1)') 'Max rotation parameter',ROTMAX,CTHRSX
      write(u6,'(6X,A,14X,F26.6,3X,A1)') 'Max rotation angle',THMAX,CTHRTE
      write(u6,'(6X,A,3X,F26.6)') 'Max change in MO coefficients',CMAX
    end if
#   ifdef _FDE_
    ! Embedding
    if (embpot) then
      Eemb = embPotEneMODensities(D1I,D1A,embInt,nBas,nTot2,nSym)
      write(u6,*) 'E from embedding potential (<Psi|v_emb|Psi>): ',Eemb
    end if
#   endif
    !GLM some additional printout for MC-PDFT

    if (l_casdft) then
      CASDFT_E = ECAS-EVAC+CASDFT_Funct
      call print_mcpdft(CASDFT_E)
    end if

    ! Compare RASSCF energy and average CI energy

    DIFFE = abs((ECAS-EAV)/ECAS)
    if (l_casdft) then
      write(u6,'(6X,A)') repeat('=',80)
      write(u6,'(10X,A)') 'This is a POST-SCF correction using a modified  Hamiltonian.'
      write(u6,'(10X,A)') 'The RASSCF energy has been corrected and it will differ from'
      write(u6,'(10X,A)') 'the preceding CI energy.'
      write(u6,'(6X,A)') repeat('=',80)
    else if (doDMRG) then

#     ifdef _DMRG_DEBUGPRINT_
      write(u6,*) 'DMRG-SCF energy    ',ECAS
      write(u6,*) 'DMRG sweeped energy',EAV
#     endif

      if (.not. Key('CION')) then
        if ((DIFFE > 1.0e-6_wp) .and. (NROOTS == 1)) then
          write(u6,'(6X,A)') repeat('=',120)
          call WarningMessage(2,'DMRGSCF and DMRG energies differ.')
          write(u6,'(6X,A,I11)') 'iteration           ',ITER
          write(u6,'(6X,A,F22.10)') 'DMRGSCF energy      ',ECAS
          write(u6,'(6X,A,F22.10)') 'DMRG energy         ',EAV
          write(u6,'(6X,A,F22.10)') 'relative difference ',DIFFE
          write(u6,*) 'About this difference:'
          write(u6,*) '1) If possible, consider a larger M value'
          write(u6,*) '2) Severe convergence problems. Maybe active'
          write(u6,*) '   space is unsuitable for this system?'
          write(u6,'(6X,A)') repeat('=',120)
          if ((DIFFE > 5.0e-4_wp) .and. (NROOTS == 1)) then
            write(u6,*)
            write(u6,*) 'Warning : '
            write(u6,*) ' Relative difference is near unacceptable'
            write(u6,*) ' If possible, consider a larger M value'
            write(u6,*)
          end if
        end if
      end if
    else
      DIFFETol = 1.0e-10_wp
#     ifdef _ENABLE_DICE_SHCI_
      if (DoBlockDMRG) DIFFETol = 1.0e-8_wp
#     endif
      if ((DIFFE > DIFFETol) .and. (NROOTS == 1)) then
        write(u6,'(6X,A)') repeat('=',120)
        call WarningMessage(2,'Rasscf and CI energies differ.')
        write(u6,'(6X,A,I11)') 'iteration           ',ITER
        write(u6,'(6X,A,F22.10)') 'RASSCF energy       ',ECAS
        write(u6,'(6X,A,F22.10)') 'CI energy           ',EAV
        write(u6,'(6X,A,F22.10)') 'relative difference ',DIFFE
        write(u6,*) 'Severe convergence problems. Maybe the active'
        write(u6,*) '   space is unsuitable for this system?'
        write(u6,'(6X,A)') repeat('=',120)
        if ((DIFFE > 1.0e-4_wp) .and. (NROOTS == 1) .and. (.not. l_casdft)) then
          write(u6,*)
          write(u6,'(6X,A)') 'The program has to stop !!!'
          write(u6,*)
          write(u6,'(6X,A)') repeat('=',120)
          write(u6,*)
          ITERM = 99
          exit outer
        end if
      end if
    end if

    if (write_orb_per_iter .and. king()) then
      call copy_(real_path('RASORB'),real_path('ITERORB.'//str(actual_iter)))
#     ifdef _HDF5_
      call copy_(real_path('RASWFN'),real_path('RASWFN.'//str(actual_iter)))
#     endif
    end if

    ! Convergence check:
    ! check is done on largest BLB matrix
    ! element (CBLBM), on difference in
    ! average energy, DE and on maximum value of non-
    ! diagonal rotation matrix element.
    !
    !*******************************************************************
    !*******************************************************************
    ! IF CIONLY calculation the convergence is skipped
    !*******************************************************************
    !*******************************************************************

    if (IFINAL == 1) exit outer
    if (DE > One) then
      call StatusLine('RASSCF: ','No convergence.')
      write(u6,*)
      write(u6,'(6X,A)') repeat('=',120)
      call WarningMessage(2,'Rasscf energy diverges.')
      write(u6,'(6X,A,I11)') 'iteration           ',ITER
      write(u6,'(6X,A,F22.10)') 'RASSCF energy       ',ECAS
      write(u6,'(6X,A,F22.10)') 'energy difference   ',DE
      write(u6,'(6X,A)') repeat('=',120)
      write(u6,*)
      write(u6,'(6X,A)') '!!! The program was forced to stop !!!'
      write(u6,*)
      write(u6,'(6X,A)') repeat('=',120)
      write(u6,*)
      ITERM = 99
      exit outer
    else if (ITER < MAXIT) then
      write(STLNE2,'(A12,I3)') 'Iteration ',ITER
      call StatusLine('RASSCF converged: ',STLNE2)
      if (abs(DE) > THRE) cycle outer
      if (abs(CBLBM) > THRSX) cycle outer
      if (abs(ROTMAX) > THRTE) cycle outer
      if ((ITER <= 3) .and. (ICIONLY == 0)) cycle outer  ! 3->0 checking
      if (IPRLEV >= TERSE) write(u6,'(6X,A,I3,A)') 'Convergence after',ITER,' iterations'
      if (IPRLEV >= DEBUG) then
        write(u6,*)
        write(u6,*) ' CMO in RASSCF after convergence printout'
        write(u6,*) ' ---------------------'
        write(u6,*)
        ioff = 1
        do iSym=1,nSym
          iBas = nBas(iSym)
          if (iBas /= 0) then
            write(u6,*) 'Sym =',iSym
            do i=1,iBas
              write(u6,*) (CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
            end do
            iOff = iOff+(iBas*iBas)
          end if
        end do
      end if
      IFINAL = 1
      call Add_Info('RASSCF_ITER',[real(ITER,kind=wp)],1,8)
      !call Add_Info('RASSCF_THMX',TMXTOT,1,5)
    else
      if (IPRLEV >= TERSE) write(u6,'(6X,A,I3,A)') 'No convergence after',ITER,' iterations'
      write(STLNE2,'(A12,I3)') 'Iteration ',ITER
      call StatusLine('RASSCF max iter: ',STLNE2)
      IFINAL = 1
      ITERM = 16
    end if
  end do outer
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !     Compute Final CI vectors
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (.not. DumpOnly) then
    IFINAL = 2
    ICICH = 0

    if (Key('WRMA')) call dump_fciqmc_mats(dmat=DMAT(:),dspn=DSPN(:),psmat=pmat(:),pamat=pa(:))
  end if

  !*********************************************************************
  !***************           Closing up MC-PDFT      *******************
  !*********************************************************************

  ! Clean-close as much as you can the CASDFT stuff...
  if (.not. (l_casdft .or. DumpOnly)) then

    !* IPT2 = 1 for OUTO, CANOnical keyword...
    if (IPT2 == 1) then
      IAD = IADR15(9)
      call DDAFILE(JOBIPH,2,CMO,NTOT2,IAD)
    else
      IAD = IADR15(2)
      call DDAFILE(JOBIPH,2,CMO,NTOT2,IAD)
    end if
    if (IPRLEV >= DEBUG) then
      write(u6,*)
      write(u6,*) ' CMO in RASSCF after DDAFILE'
      write(u6,*) ' ---------------------'
      write(u6,*)
      ioff = 1
      do iSym=1,nSym
        iBas = nBas(iSym)
        if (iBas /= 0) then
          write(u6,*) 'Sym =',iSym
          do i=1,iBas
            write(u6,*) (CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
          end do
          iOff = iOff+(iBas*iBas)
        end if
      end do
    end if
    if (NROOTS > 1) then
      call StatusLine('RASSCF: ','Compute final CI vectors')
    else
      call StatusLine('RASSCF: ','Compute final CI vector')
    end if

    ! Transform two-electron integrals

    call Timing(dum1,dum2,time2(1),dum3)
    if ((.not. DoCholesky) .or. (ALGO == 1)) then
      call mma_allocate(PUVX,NFINT,Label='PUVX')
      PUVX(:) = Zero
    end if

    call Get_D1I_RASSCF(CMO,D1I)

    IPR = 0
    if (IPRLOC(2) == 4) IPR = 5
    if (IPRLOC(2) == 5) IPR = 10
    call TRACTL2(CMO,PUVX,TUVX,D1I,FI,D1A,FA,IPR,lSquare,ExFac)

    if ((.not. DoCholesky) .or. (ALGO == 1)) call mma_deallocate(PUVX)

    call Timing(dum1,dum2,time2(2),dum3)
    TimeTrans = TimeTrans+time2(2)-time2(1)

    ! CI-section (to obtain final wave function)
    ! 1st and 2nd order density matrix in MO basis
    ! for the gradients.

    ! Print header to file containing informations on CI iterations.

    write(IterFile,*)
    write(IterFile,'(A)') repeat('*',80)
    write(IterFile,'(15X,A)') 'RASSCF iteration: Final'

    call Timing(dum1,dum2,time3(1),dum3)

    if (allocated(CI_solver)) then
      call CI_solver%run(actual_iter=actual_iter, &
                         ifinal=ifinal, &
                         iroot=iroot, &
                         weight=weight, &
                         CMO=CMO(:), &
                         DIAF=DIAF(:), &
                         D1I_AO=D1I(:), &
                         D1A_AO=D1A(:), &
                         TUVX=tuvx(:), &
                         F_IN=FI(:), &
                         D1S_MO=DSPN(:), &
                         DMAT=DMAT(:), &
                         PSMAT=pmat(:), &
                         PAMAT=pa(:))

#   if defined (_ENABLE_BLOCK_DMRG_) || defined (_ENABLE_CHEMPS2_DMRG_) || defined (_ENABLE_DICE_SHCI_)
    else if (DoBlockDMRG) then
      call DMRGCTL(CMO,DMAT,DSPN,PMAT,PA,FI,D1I,D1A,TUVX,IFINAL,1)
#   endif
#   ifdef _DMRG_
    ! Leon 27/11/2017: Skip the final CI iteration if we're using DMRGCI
    ! and CIOnly. It's enabled only for DMRGCI with QCMaquis now
    ! (to exclude potential side effects)
    ! but consider extending it to other cases!
    else if (doDMRG .and. (ICIONLY /= 0)) then
      !continue
#   endif
    else
      call CICTL(CMO,DMAT,DSPN,PMAT,PA,FI,FA,D1I,D1A,TUVX,IFINAL)
    end if
    if (lRF .and. ((iPCMRoot <= 0) .or. (DWSolv%DWZeta /= Zero))) then
      IAD15 = IADR15(6)
      call DDAFILE(JOBIPH,1,ENER,mxRoot*mxIter,IAD15)
    end if

    EAV = Zero
    do KROOT=1,NROOTS
      EAV = EAV+ENER(IROOT(KROOT),ITER)*WEIGHT(KROOT)
    end do
    if (NAC == 0) EAV = ECAS
    if (NCRVEC > 0) then
      ! Core shift has been used
      call mma_deallocate(CRVEC)
      call mma_deallocate(CRPROJ)
    end if
    call Timing(dum1,dum2,time3(2),dum3)
    TimeCIOpt = TimeCIOpt+time3(2)-time3(1)
    TimeWfn = TimeWfn+time3(2)-time1(1)
    time1(1) = time3(2)

    ! Calculation of natural orbitals. These orbitals are stored on
    ! JOBIPH in IADR15(12), followed by the occupation numbers.
    ! Usage: Only for one-electron properties
    ! Note: in an average calculation natural orbitals are obtained
    ! for all roots. Stored sequentially at IADR15(12) on JOBPIH.
    !PAM2009 This is done in NATORB. Note that it places the resulting
    ! natural orbitals and occ nos into JOBIPH. Thus the arguments nr
    ! 5 and 6 are simply those for the last root that NATORB processed,
    ! and they should not be reused for anything after return from NATORB.
    ! NATORB args: Arg1 is current CMO coeffs, used in CI;
    !  all the rest should be regarded as scratch.

    call StatusLine('RASSCF: ','Compute natural orbitals')
    IPR = 0
    if (IPRLOC(6) == 4) IPR = 5
    if (IPRLOC(6) == 5) IPR = 10
    call mma_allocate(CMON,NTOT2,Label='CMON')
    call mma_allocate(OCCX,NTOT,Label='OCCX')
    call mma_allocate(scr1,max(NACPAR,NO2M),Label='scr1')
    call mma_allocate(scr2,NO2M,Label='scr2')
    call mma_allocate(SMAT,NTOT1,Label='SMAT')
    !PAM2009 NATORB args: Arg1 is current CMO coeffs, used in CI;
    !  all the rest should be regarded as scratch.
    call NATORB_RASSCF(CMO,scr1,scr2,SMAT,CMON,OCCX)
    call mma_deallocate(scr1)
    call mma_deallocate(scr2)
    !PAM2009 Deallocate CMON, OCCX.
    call mma_deallocate(CMON)
    call mma_deallocate(OCCX)

    ! Compute transition density matrices
    if (Key('TDM')) then
#     ifdef _HDF5_
      call mma_allocate(Tmp,NConf,Label='Tmp')
      call mma_allocate(VecL,NConf,Label='VecL')
      call mma_allocate(VecR,NConf,Label='VecR')
      call mma_allocate(kcnf,NACTEL,Label='kcnf')
      call mma_allocate(Dtmp,NAC*NAC,Label='Dtmp')
      call mma_allocate(DStmp,NAC*NAC,Label='DStmp')
      jDisk = IADR15(4)
      call DDafile(JOBIPH,2,Tmp,nConf,jDisk)
      do jRoot=2,lRoots
        ! Read and reorder the left CI vector
        call DDafile(JOBIPH,2,Tmp,nConf,jDisk)
        call Reord2(NAC,NACTEL,STSYM,1,CONF,CFTP,Tmp,VecL,kcnf)
        kDisk = IADR15(4)
        do kRoot=1,jRoot-1
          ! Read and reorder the right CI vector
          call DDafile(JOBIPH,2,Tmp,nConf,kDisk)
          call Reord2(NAC,NACTEL,STSYM,1,CONF,CFTP,Tmp,VecR,kcnf)
          ! Compute TDM and store in h5 file
          call Lucia_Util('Densi',CI_Vector=VecL(:),RVec=VecR(:))
          idx = (jRoot-2)*(jRoot-1)/2+kRoot
          call mh5_put_dset(wfn_transdens,Dtmp(1:NAC*NAC),[NAC,NAC,1],[0,0,idx-1])
          if (iSpin > 1) call mh5_put_dset(wfn_transsdens,DStmp(1:NAC**2),[NAC,NAC,1],[0,0,idx-1])
        end do
      end do
      call mma_deallocate(TMP)
      call mma_deallocate(VecL)
      call mma_deallocate(VecR)
      call mma_deallocate(kcnf)
      call mma_deallocate(Dtmp)
      call mma_deallocate(DStmp)
#     else
      call WarningMessage(1,'HDF5 support disabled, TDM keyword ignored.')
#     endif
    end if

    if (Key('SSCR')) then
      call spin_correlation_driver(orb_range_p,orb_range_q,iroot)
      call mma_deallocate(orb_range_p)
      call mma_deallocate(orb_range_q)
    end if

    !*******************************************************************
    ! Export all information relevant to geometry optimizations.
    ! Save also the reaction field operator.
    call Timing(dum1,dum2,time2(1),dum3)
    if (iRlxRoot == 0) iRlxRoot = iRoot(1)

    ! Replace average occ Fock with occ Fock for state iRlxRoot
    ! and densities with the densities for state iRLXRoot
    !write(u6,*) 'I am in RASSCF before call to PutRlx!'
    if (ITERM /= 99) then
      call mma_allocate(Dens,nTot1,Label='Dens')
      call PutRlx(DMAT,DSPN,PMAT,Dens,CMO)
      call Export1(IFINAL,CMO,DMAT,PMAT,Dens,FockOcc)
      call mma_deallocate(Dens)
    end if
    call Timing(dum1,dum2,time2(2),dum3)
    TimeRelax = time2(2)-time2(1)
    !*******************************************************************

    EMY = EMY+CASDFT_Funct
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Output section
    !                                                                  *
    !*******************************************************************
    !                                                                  *

    call StatusLine('RASSCF: ','Printing results')
    if ((IPRLEV >= USUAL) .and. (.not. lOPTO)) then
      write(u6,*)
      write(u6,'(6X,A)') repeat('*',120)
      write(u6,'(6X,A,118X,A)') '*','*'
      write(u6,'(6X,A,52X,A,53X,A)') '*','Final results','*'
      write(u6,'(6X,A,118X,A)') '*','*'
      write(u6,'(6X,A)') repeat('*',120)
      write(u6,*)
    end if
#   ifdef _FDE_
    ! Embedding
    if (embpot) then
      Eemb = embPotEneMODensities(D1I,D1A,embInt,nBas,nTot2,nSym)
      write(u6,*) 'Final energy from embedding potential: ',Eemb
      ! Write out ESP on grid if requested
      if (embWriteEsp) then
        call Get_iScalar('Unique atoms',nNuc)
        call embPotOutputMODensities(nNuc,nSym,D1I,D1A,nBas,nTot2)
      end if
    end if
#   endif

    if (ITERM /= 99) then
        call OUTCTL(CMO,OCCN,SMAT,lOPTO)
    end if

    call mma_deallocate(SMAT)

    ! Write information for MOLDEN

    !  i_root=0 gives state- and spin-averaged natural orbitals
    !  i_root>0 gives natural spin orbitals for that root
    mroots = nroots
    if ((iSpin == 1) .and. (nroots == 1)) mroots = 0
    do i_root=0,mroots
      call Interf(i_root,FDIAG,1,0)
    end do

    ! Create output orbital files:
    call OrbFiles(JOBIPH,IPRLEV)

  end if

  !*********************************************************************
  !***************           Closing up RASSCF       *******************
  !*********************************************************************

  if (DoCholesky .and. (ALGO == 2)) call mma_deallocate(Qmat)

  ! Release  some memory allocations
  call mma_deallocate(DIAF)
  call mma_deallocate(FockOcc)
  call mma_deallocate(FI)
  call mma_deallocate(FA)
  call mma_deallocate(D1I)
  call mma_deallocate(D1A)
  call mma_deallocate(OccN)
  call mma_deallocate(CMO)
# ifdef _DMRG_
  ! Free RDMs for the reaction field reference root in QCMaquis calculations
  if (doDMRG .and. PCM_On()) then
    call mma_deallocate(RF1)
    if (twordm_qcm) call mma_deallocate(RF2)
  end if
# endif
  if (lRF) call DWSol_final()
  !call DWSCF_final()

  ! deallocating TUVX memory...
  call mma_deallocate(TUVX)
  call mma_deallocate(DSPN)
  call mma_deallocate(DMAT)
  call mma_deallocate(PMAT)
  call mma_deallocate(PA)
end if

! release SEWARD
call ClsSew()
! ClsSew is needed for releasing memory used by integral_util, rys... which is allocated when MC-PDFT run is performed.

! Finalize Cholesky information if initialized
if (DoCholesky) then
  call Cho_X_Final(irc)
  if (irc /= 0) then
    write(u6,*) 'RASSCF: Cho_X_Final fails with return code ',irc
    write(u6,*) ' Try to recover. Calculation continues.'
  end if
  if (Do_OFemb) then
    call mma_deallocate(FMaux)
    call OFE_print(EAV)
  end if
end if

!do i=1,NTOT2
!  write(u6,*) 'A,I',D1A(i),D1I(i)
!end do
call mma_deallocate(CleanMask,safe='*')

! Skip Lucia stuff if NECI or BLOCK-DMRG is on
if (.not. any([allocated(CI_solver),DumpOnly,doDMRG,doBlockDMRG])) call Lucia_Util('CLOSE')

call StatusLine('RASSCF: ','Finished.')
if (IPRLEV >= 2) write(u6,*)
if (ifvb == 1) call make_close_rvb()
!vv call to grid is moved up, in order to call clssew safely..
!if (iCIonly == 0) call Grid_driver(-1,'RASSCF','RASORB',iR)

call Timing(dum1,dum2,time1(2),dum3)
TimeTotal = time1(2)
TimeOutput = TimeOutput+time1(2)-time1(1)
if (IPRLEV >= 3) then
  call PrtTim()
  call FastIO('STATUS')
end if
call ClsFls_RASSCF()

! Rc_RAS  =  0 : The RASSCF wave function is converged
!         = 16 : The RASSCF wave function is not(!) converged
!         = 99 : The RASSCF energy is divergent or
!                the CI and SX energies differ
Rc_RAS = ITERM
Rc_RAS = max(RC_RAS,Rc_CI)
Rc_RAS = max(RC_RAS,Rc_SX)
if (Rc_Ras == 0) then
  ireturn = _RC_ALL_IS_WELL_
else if (Rc_Ras == 16) then
  ireturn = _RC_NOT_CONVERGED_
else
  call WarningMessage(2,'Something is wrong: Did CI fail?')
  ireturn = _RC_GENERAL_ERROR_
end if

if (Do_OFemb) then
  if (isStructure() == 1) then
    if (iReturn /= _RC_ALL_IS_WELL_) call WarningMessage(1,'RASSCF: non-zero return code.')
    iReturn = _RC_CONTINUE_LOOP_
    call Check_FThaw(iReturn)
  end if
end if

if (.not. (iDoGas .or. doDMRG .or. doBlockDMRG .or. allocated(CI_solver) .or. DumpOnly)) call SG_Free(SGS,CIS,EXS)

if (DoFaro) then
  call faroald_free()
  call citrans_free()
end if

if (allocated(CI_solver)) then
  call CI_solver%cleanup()
  deallocate(CI_solver)
end if

! DMRG: Save results for other use
! ==========================================================
if (doDMRG) then
# ifdef _DMRG_
  !Leon: Generate 4-RDM evaluation templates for NEVPT2

  ! In the new interface the EvRDM keyword will be ignored.
  ! Instead, NEVPT2Prep will always generate the template.
  ! RDM evaluation will now happen in the NEVPT2 module
  ! where NEVPT2 either can attempt to compute it directly
  ! with the new interface or read from QCMaquis HDF5 result
  ! file.
  if (DoNEVPT2Prep) then
    if (MAXIT == 0) write(u6,*) ' --- DMRG-SCF iterations are skipped, only QCMaquis input for higher-order RDMs will be generated.'
    if (NACTEL > 3) then ! Ignore 4-RDM if we have <4 electrons
      do i=1,NROOTS
        write(u6,'(a)') 'Writing 4-RDM QCMaquis template for state '//str(i)
        call qcmaquis_interface_prepare_hirdm_template(filename='meas-4rdm.'//str(i-1)//'.in',state=i-1,tpl=TEMPLATE_4RDM)
        call qcmaquis_mpssi_transform(trim(qcmaquis_param%workdir)//'/'//trim(qcmaquis_param%project_name),i)
      end do
    else
      write(u6,*) 'Skipping 4-RDM QCMaquis template generation since we have less than 4 electrons.'
    end if
    ! Generate 3-TDM templates
    if (NACTEL > 2) then ! but only if we have more than 3 el.
      do i=1,NROOTS
        do j=i+1,NROOTS
          write(u6,'(a)') 'Writing 3-TDM QCMaquis template for states '//str(i)//' and '//str(j)
          call qcmaquis_interface_prepare_hirdm_template(filename='meas-3tdm.'//str(i-1)//'.'//str(j-1)//'.in', &
                                                         state=i-1, &
                                                         state_j=j-1, &
                                                         tpl=TEMPLATE_TRANSITION_3RDM)
        end do
      end do
    else
      write(u6,*) 'Skipping 3-RDM QCMaquis template generation since we have less than 3 electrons.'
    end if
  end if
  ! is it really needed in the times of Fortran 2008?
  call qcmaquis_interface_deinit()
# endif
end if
! ==========================================================
! Exit

call Finalize()

return

#ifdef _DMRG_
103 format(6X,I3,I3,I4,I7,ES12.2,I4,I5,F15.8,ES12.2,A1,ES9.2,A1,2I4,I2,ES10.2,A1,F6.2,F7.2,4X,A2,3X,A3,I7,A1,I2.2,A1,I2.2)
#endif
104 format(6X,I3,I4,I5,I5,F15.8,ES12.2,A1,ES10.2,A1,2I4,I2,ES10.2,A1,F6.2,F7.2,4X,A2,3X,A3,I5,A1,I2.2,A1,I2.2)

contains

subroutine Finalize()

  integer(kind=iwp) :: I

  ! Close the one-electron integral file:
  iRC = -1
  iOpt = 0
  call ClsOne(iRC,iOpt)
  if (iRC /= 0) then
    write(u6,*) 'Error when trying to close the one-electron'
    write(u6,*) 'integral file.'
    call Quit(_RC_INTERNAL_ERROR_)
  end if

  if (IfVB /= 2) then
    do I=10,99
      inquire(unit=I,opened=IfOpened)
      if (IfOpened .and. (I /= 19)) close(I)
    end do
    close(LUInput)
  end if

end subroutine Finalize

end subroutine rasscf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine findamx_cvb(vec,n,vmx,imx)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: vec(n)
real(kind=wp), intent(out) :: vmx
integer(kind=iwp), intent(out) :: imx
integer(kind=iwp) :: i

if (n > 0) then
  imx = 1
  vmx = abs(vec(1))
  do i=2,n
    if (abs(vec(i)) > vmx) then
      imx = i
      vmx = abs(vec(i))
    end if
  end do
else
  imx = 0
  vmx = Zero
end if

return

end subroutine findamx_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine RPA_RdInp()
C
C     Thomas Bondo Pedersen (CTCC,UiO), July 2013.
C
C     Parse and process RPA input.
C
      Implicit None
#include "WrkSpc.fh"
#include "rpa_config.fh"
#include "rpa_data.fh"

      Character*9 SecNam
      Parameter (SecNam='RPA_RdInp')
      Integer mLine
      Parameter (mLine=100000)

      Logical Reduce_Prt
      External Reduce_Prt
      Character*180 Get_Ln
      External Get_Ln
      Integer  iPrintLevel, RPA_iUHF
      External iPrintLevel, RPA_iUHF

      Character*4   Keyword
      Character*180 Line

      Logical doTitle
      Logical EndOfInput
      Logical DebugPrint

      Integer ip_Integer, l_Integer
      Integer Lu
      Integer iLine
      Integer iUHF
      Integer i

      ! register entry

      ! set default print level
      iPrint=max(iPrintLevel(-1),0)
      If (iPrint.gt.0 .and. iPrint.lt.3) Then
         If (Reduce_Prt()) Then
           iPrint=0
         End If
      End If

      ! set debug print
#if defined (_DEBUGPRINT_)
      DebugPrint=iPrint.gt.4
#else
      DebugPrint=.false.
#endif
      If (DebugPrint) Then
         Write(6,'(A,A,I3)') SecNam,': default print level is',iPrint
      End If

      ! Set restricted (1) or unrestricted (2)
      iUHF=RPA_iUHF()

      ! set defaults
      dRPA=.true.
      SOSEX=.false.
      LumOrb=.false.
      nTitle=0
      nFreeze(1)=0
      nFreeze(2)=0

      ! open input file and find RPA section
      Lu=17
      Call SpoolInp(Lu)
      Rewind(Lu)
      Call RdNLst(Lu,'RPA')

      ! allocate dummy arrays for reading input
      ! (dimension should be the longest needed for reading)
      l_Integer=2
      Call GetMem('InpRdI','Allo','Inte',ip_Integer,l_Integer)

      ! parse input
      doTitle=.false.
      EndOfInput=.false.
      iLine=0
      Do While (.not.EndOfInput .and. iLine.lt.mLine)
         iLine=iLine+1 ! eliminate risk of an infinite loop
         Line=Get_Ln(Lu)
         Call StdFmt(Line,Keyword)
         If (DebugPrint) Then
            Write(6,'(A,A)') SecNam,' processing line:'
            Write(6,'(A)') Line
            Write(6,'(A,A)') 'Key=',Keyword
         End If
         !****************************
         If (Keyword(1:1).eq.' ') Then
         !****************************
            ! blank line: pass
            Continue
         !*********************************
         Else If (Keyword(1:1).eq.'*') Then
         !*********************************
            ! comment line: pass
            Continue
         !***********************************
         Else If (Keyword(1:3).eq.'END') Then
         !***********************************
            ! end of input
            EndOfInput=.true.
         !*******************************
         Else If (Keyword.eq.'TITL') Then
         !*******************************
            ! title
            doTitle=.true.
            nTitle=nTitle+1
            If (nTitle.gt.mTitle) Then
               Write(6,'(A,I8)') 'Maximum number of title lines is',
     *                           mTitle
               Write(6,'(A)') 'Current input line:'
               Write(6,'(A)') Line
               Call RPA_Warn(2,'Too many title lines in RPA input')
            Else
               Line=Get_Ln(Lu)
               Title(nTitle)=Line(1:80)
            End If
         !*******************************
         Else If (Keyword.eq.'PRIN') Then
         !*******************************
            ! print level
            doTitle=.false.
            Call RPA_ReadIntegerInput('PRIN',1,Lu,
     *                                iWork(ip_Integer),l_Integer)
            iPrint=max(iWork(ip_Integer),0)
#if defined (_DEBUGPRINT_)
            DebugPrint=DebugPrint.or.iPrint.gt.4
#endif
         !*******************************
         Else If (Keyword.eq.'LUMO') Then
         !*******************************
            ! use orbitals from InpOrb file
            doTitle=.false.
            LumOrb=.true.
         !*******************************
         Else If (Keyword.eq.'RUNO') Then
         !*******************************
            ! use orbitals from Runfile
            doTitle=.false.
            LumOrb=.false.
         !*******************************
         Else If (Keyword.eq.'DRPA') Then
         !*******************************
            ! direct RPA
            doTitle=.false.
            dRPA=.true.
            SOSEX=.false.
         !*******************************
         Else If (Keyword.eq.'SOSE') Then
         !*******************************
            ! direct RPA + SOSEX
            doTitle=.false.
            dRPA=.true.
            SOSEX=.true.
         !*******************************
         Else If (Keyword.eq.'ALLE') Then
         !*******************************
            ! All electrons correlated (no frozen)
            doTitle=.false.
            Call iZero(nFro,16)
         !*******************************
         Else If (Keyword.eq.'FREE') Then
         !*******************************
            ! Freeze occupied orbitals
            doTitle=.false.
            Call iZero(nFro,16)
            Call RPA_ReadIntegerInput('FREE',iUHF,Lu,
     *                                iWork(ip_Integer),l_Integer)
            Do i=1,iUHF
               nFreeze(i)=iWork(ip_Integer-1+i)
            End Do
         !*******************************
         Else If (Keyword.eq.'DELE') Then
         !*******************************
            ! Delete virtual orbitals
            doTitle=.false.
            Call RPA_Warn(2,
     *                  'Virtual orbital deletion not implemented yet!')
         Else
            ! no keyword match
            ! => either a title line or an unknown keyword
            If (doTitle) Then
               ! process as title line
               nTitle=nTitle+1
               If (nTitle.gt.mTitle) Then
                  Write(6,'(A,I8)') 'Maximum number of title lines is',
     *                              mTitle
                  Write(6,'(A)') 'Current input line:'
                  Write(6,'(A)') Line
                  Call RPA_Warn(2,'Too many title lines in RPA input')
               Else
                  Title(nTitle)=Line(1:80)
               End If
            Else
               ! unknown keyword
               Write(6,'(A)') 'Offending input line:'
               Write(6,'(A)') Line
               Write(6,'(A,A,A)') 'Equivalent keyword input "',Keyword,
     *                            '" not recognized!'
               Call RPA_Warn(2,'RPA input keyword not recognized')
            End If
         End If
      End Do

      ! deallocation
      Call GetMem('InpRdI','Free','Inte',ip_Integer,l_Integer)

      ! close input file
      Call Close_LuSpool(Lu)

      ! register exit

      End
************************************************************************
      Subroutine RPA_ReadIntegerInput(Key,nInp,Lu,iVal,n)
      Implicit None
      Character*4 Key
      Integer nInp
      Integer Lu
      Integer n
      Integer iVal(n)
      Character*180 Line

      Character*180 Get_Ln
      External Get_Ln

      If (n.ge.nInp) Then
         Line=Get_Ln(Lu)
         Call Get_I(1,iVal,nInp)
      Else
         ! insufficent memory for reading (fix in calling routine)
         Call RPA_Warn(3,'Integer read problem for keyword '//Key)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine input_process( nneq, neq, neqv, nmax, nCenter, nexch,
     &                          nDir, nDirZee, nDirTot, nH, nT, exch,
     &                          nBlock, nTempMagn, iopt, nMult, nDim,
     &                          nPair, i_pair, nP, AngPoints, lant,
     &                          multLn, KEOPT, encut_definition, nK,
     &                          mG, ncut, nsfs, nss, nLoc,
     &                          MxRank1, MxRank2, imaxrank, iPrint,

     &                          R_LG, gtens_input, dirX, dirY, dirZ,
     &                          dir_weight, zJ, cryst, coord, hmin,
     &                          hmax, TempMagn, thrs, Hexp, Mexp,
     &                          tmin, tmax, chit_exp, Texp, Xfield,
     &                          Jex, JAex, JAex9, JDMex, tpar, upar,
     &                          MagnCoords, encut_rate, eso,
     &                          JITOexR, JITOexI,

     &                          Title, itype, namefile_aniso,

     &                          Do_structure_abc,
     &                          compute_barrier, fitCHI, fitM, hinput,
     &                          tinput, compute_magnetization,
     &                          compute_Mdir_vector, zeeman_energy,
     &                          m_paranoid, m_accurate, smagn,
     &                          compute_g_tensors,compute_torque,
     &                          compute_susceptibility, Lines,
     &                          AnisoLines3, AnisoLines9, Dipol,
     &                          check_title, KE, DM_exchange,
     &                          JITO_exchange )

      Implicit None
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
#include "mgrid.fh"

      Integer, intent(in)       :: iPrint
!     number of non-equivalent sites
      Integer, intent(in)       :: nneq
!     number of equivalent sites of each type, neqv = MAXVAL(neq(:))
      Integer, intent(in)       :: neq(nneq), neqv
!     number of equivalent sites of each type, neqv = MAXVAL(neq(:))
      Integer, intent(in)       :: nexch(nneq), nmax
      Character(len=1), intent(in)  :: itype(nneq)
      Integer, intent(in)       :: nCenter
      Integer, intent(in)       :: nLoc
      Real(kind=8), intent(in) :: R_LG( nneq,neqv,3,3)
      Real(kind=8), intent(in) :: gtens_input(3,nneq)
      Real(kind=8), intent(in) :: eso(nneq,nLoc)
      Integer, intent(in)       :: nss(nneq), nsfs(nneq)
      Character(len=180), intent(in) :: namefile_aniso(nneq)
c  definition of the exchange:
!     total number of exchange states
      Integer, intent(in)       :: exch
!     number of metal pairs (number of interactions)
      Integer, intent(inout)    :: nPair
!     index of the metal site in a given interacting pair
      Integer, intent(inout)    :: i_pair(nPair,2)
!     index of the ITO ranks for each pair
      Integer, intent(in)       :: imaxrank(nPair,2)
      Integer, intent(in)       :: MxRank1, MxRank2
      Logical, intent(in)       :: Lines, AnisoLines3, AnisoLines9
      Logical, intent(in)       :: Dipol, DM_exchange, JITO_exchange
!     Lines exchange    ( 1 parameter / interacting pair)
      Real(kind=8), intent(in) :: Jex(nPair)
!     Anisotropic Lines ( 3 parameter / interacting pair)
      Real(kind=8), intent(in) :: JAex(nPair,3)
!     Anisotropic Lines full ( 9 parameters / interacting pair)
      Real(kind=8), intent(in) :: JAex9(nPair,3,3)
!     Dzyaloshinsky-Morya exchange
      Real(kind=8), intent(in) :: JDMex(nPair,3)
      Real(kind=8), intent(in) ::
     &                          JITOexR(nPair,MxRank1,-MxRank1:MxRank1,
     &                                        MxRank2,-MxRank2:MxRank2),
     &                          JITOexI(nPair,MxRank1,-MxRank1:MxRank1,
     &                                        MxRank2,-MxRank2:MxRank2)

      ! options used in connection with KE
      Integer, intent(in)       :: lant, KEOPT, multLn
      Logical, intent(in)       :: KE
      Real(kind=8), intent(in) :: tpar, upar
      ! options used in connection with Dipol-Dipol interaction
      Real(kind=8), intent(in) :: MagnCoords(nneq,3)

c  definition of data for susceptibility
      Integer, intent(inout)    :: nT
      Logical, intent(in)       :: tinput
      Logical, intent(inout)    :: compute_susceptibility
      Real(kind=8), intent(inout) :: tmin, tmax
      Real(kind=8), intent(in) :: chit_exp(nT), Texp(nT)
      ! options related to XT_MoverH
      Real(kind=8), intent(in) :: Xfield
      Integer, intent(in)       :: nH
      Integer, intent(in)       :: nTempMagn
      Integer, intent(in)       :: iopt
      Real(kind=8), intent(inout) :: TempMagn(nTempMagn)
      Real(kind=8), intent(in) :: Hexp(nH), Mexp(nH,nTempMagn)
      Real(kind=8), intent(in) :: thrs
      Real(kind=8), intent(in) :: hmin, hmax
      Logical, intent(in)       :: hinput
      Logical, intent(in)       :: compute_magnetization
      Logical, intent(in)       :: compute_Mdir_vector
      Logical, intent(in)       :: zeeman_energy
      Logical, intent(inout)    :: m_paranoid
      Logical, intent(in)       :: m_accurate
      Logical, intent(in)       :: smagn
      ! options used to set up nM and EM
      Integer, intent(in)       :: encut_definition
      Integer, intent(in)       :: nK, mG ! encut_definition=1;
      Integer, intent(in)       :: ncut   ! encut_definition=2;
      Real(kind=8), intent(in) :: encut_rate ! encut_definition=3;

c  definition of g and D tensors
      Integer, intent(in)       :: nMult
      Integer, intent(in)       :: nDim(nMult)
      Logical, intent(in)       :: compute_g_tensors
c  magnetization torque
      Integer, intent(in)       :: nP
      Integer, intent(in)       :: AngPoints
      Logical, intent(in)       :: compute_torque
c  Zeeman energy and M vector
      Integer, intent(in)       :: nDir, nDirZee
      Real(kind=8), intent(in) :: dirX(nDir), dirY(nDir), dirZ(nDir)
      Real(kind=8), intent(in) :: dir_weight(nDirZee,3)
c  definition of mean field parameter
      Real(kind=8), intent(in) :: zJ
c  definintion of the crystal axes:
      Logical, intent(in)       :: Do_structure_abc
!     a, b, c, alpha, beta, gamma
      Real(kind=8), intent(in) :: cryst(6)
!     Cartesian coordinates of the main metal site, or center
      Real(kind=8), intent(in) :: coord(3)
c  definitions for blocking barrier
      Integer, intent(inout)    :: nBlock
      Logical, intent(inout)    :: compute_barrier
c  options for automatic fitting of parameters:
      Logical, intent(in)       :: fitCHI !-- not used so far
      Logical, intent(in)       :: fitM !-- not used so far

      Logical, intent(in)       :: check_title
      Character(len=180),intent(in) :: Title


! local variables
      Character(len=180) fmtline
      Logical  :: nosym
      Logical  :: ab_initio_all
      Logical  :: DBG
      Integer  :: nDirTot
      Integer  :: i,j,k,l,m,n,iT,iH,jEnd,irank1,irank2,iproj1,iproj2
      Integer  :: icount_B_sites


      DBG=.false.
c-----------------------------------------------------------------------
c print the data from this Subroutine:
      If(check_title) Then
        Write(6,'(A,A72)')  'TITL :         = ', Title
      End If
! ======================================================================
c     INFORMATION about individual magnetic sites
! ======================================================================
      Write(6,'(A,  I5)')   'PRLV :         = ', iPrint
      Write(6,'(A)') 'Information about individual magnetic sites:'
      Write(6,'(A)')
      Write(6,'(A,  I5)')   'NNEQ :         = ', nneq
      Write(6,'(A,  I5)')   'NEQV :         = ', neqv
      Write(6,'(A,50I5)')   'NEQ() :        = ', (neq(i),i=1,nneq)
      Write(6,'(A,  I5)')   'nCenter :      = ', nCenter

      Write(6,'(A,50I5  )') 'NEXCH():       = ', (nexch(i),i=1,nneq)
      Write(6,'(A,50I5  )') 'NMAX:          = ', nmax
      Write(6,'(A,50I5  )') 'NSTATE():      = ', (nsfs(i),i=1,nneq)
      Write(6,'(A,50I5  )') 'NSS():         = ', (nss(i),i=1,nneq)

      Do i=1, nneq
         If(itype(i).eq.'A') Then
            Write(6,'(i3,1x,A15,1x,3i5,A)') i, namefile_aniso(i),
     &                                   nsfs(i), nss(i), nexch(i),
     &                                   ' -- computed ab initio'
            Write(6,'(A,i2,A )') 'ESO(',i,' ):'
            Write(6,'(10F10.3)') (ESO(i,j),j=1,nss(i))
         Else
            Write(6,'(i3,A15,1x,3i5,A)') i, ' - - - - - - - ',
     &                                   nsfs(i), nss(i), nexch(i),
     &                                   ' -- generated as isotropic'
         End If
      End Do

      nosym=.true.
      icount_B_sites=0
      ab_initio_all=.true.
      Do i=1,nneq
        If (neq(i)>1) nosym=.false.
        If (itype(i).eq.'B') Then
           icount_B_sites=icount_B_sites+1
           ab_initio_all=.false.
        End If
      End Do
      If(DBG) Write(6,'(A,i3)') 'input_process:  icount_B_sites=',
     &                                           icount_B_sites

      If ( nosym.eqv..false. )  Then
         Write(6,'(A,A)') 'SYMM :         = ',' rotation matrices '//
     &                     'for equivalent magnetic centers:'
         Do i=1,nneq
            Write(6,'(8x,A,i3)') 'center type:',i
            Do j=1,neq(i)
               Do m=1,3
                  Write(6,'(20x,3F11.6)') (R_lg(i,j,m,n),n=1,3)
               End Do
            End Do
         End Do
      Else
         Write(6,'(A,A )') 'SYMM :         = ',' rotation matrices '//
     &                     'are "Identity Matrices" for all '//
     &                     'magnetic centers'
      End If

      If(ab_initio_all) Then
         Write(6,'(17x,A,I2,A)') 'all centers have been computed ' //
     &                           'ab initio and ',nneq,
     &                           ' file(s) of "aniso_i.input" '//
     &                           'type exist.'
      Else
         Write(6,'(17x,I2,A,I2,A)') nneq-icount_B_sites,' center(s) ' //
     &                             'have been computed ab initio and',
     &                              nneq-icount_B_sites ,
     &                             ' file(s) of "aniso_i.input" '//
     &                             'type exist.'
         Write(6,'(17x,I2,A,15F7.3)') icount_B_sites,' center(s) ' //
     &                             'have been defined empirical: '//
     &                             'no ZFS and g_tens = '
         Write(6,'(17x,A,99F10.5)') 'gX = ',(gtens_input(1,i),i=1,nneq)
         Write(6,'(17x,A,99F10.5)') 'gY = ',(gtens_input(2,i),i=1,nneq)
         Write(6,'(17x,A,99F10.5)') 'gZ = ',(gtens_input(3,i),i=1,nneq)
      End If
! ======================================================================
c     INFORMATION about exchange
! ======================================================================
      Write(6,'(A)') 'Information about exchange and magnetic couplings'
      If(Lines) Then
         Write(6,'(A,  I3  )') 'PAIR or LIN1 : = ', npair
         Do i=1,npair
            Write(6,'(17x,2I3,2x, F9.5)') i_pair(i,1),i_pair(i,2),
     &                                    Jex(i)
         End Do
      End If

      If(AnisoLines3) Then
         Write(6,'(A,  I3  )') 'LIN3 :         = ', npair
         Do i=1,npair
            Write(6,'(17x,2I3,2x,3F9.5)') i_pair(i,1),i_pair(i,2),
     &                                    (JAex(i,j),j=1,3)
         End Do
      End If

      If(AnisoLines9) Then
         Write(6,'(A,  I3  )') 'LIN9 :         = ', npair
         Do i=1,npair
            Write(6,'(17x,2I3,2x,9F9.5)') i_pair(i,1),i_pair(i,2),
     &                                    (JAex9(i,1,j),j=1,3),
     &                                    (JAex9(i,2,j),j=1,3),
     &                                    (JAex9(i,3,j),j=1,3)
         End Do
      End If

      If(DM_exchange) Then
         Write(6,'(A,  I3  )') 'DMEX :         = ', npair
         Do i=1,npair
            Write(6,'(17x,2I3,2x,3F9.5)') i_pair(i,1),i_pair(i,2),
     &                                    (JDMex(i,j),j=1,3)
         End Do
      End If


      If(Dipol) Then
         Write(6,'(A,A )') 'DIPO :         = ',' dipolar coupling '//
     &                     'for the above exchange pairs is included'
         Write(6,'(A,A )') 'COOR :         = ',' symmetrized '//
     &                     'cartesian coordinates for each '//
     &                     'non-equivalent magnetic centers '
         Do i=1,nneq
            Write(6,'(17x,i3,3F11.6)') i,(MagnCoords(i,l),l=1,3)
         End Do
      Else
         Write(6,'(A,A )') 'DIPO :         = ',' dipolar coupling '//
     &                     'for the above exchange pairs is NOT '//
     &                     'included.'
      End If


      If(KE) Then
         Write(6,'(A,A )') 'LONG :         = ','kinetic exchange '//
     &                     'coupling is requested:'
         Write(6,'(A,2F14.7)') 't     = ', tpar
         Write(6,'(A,2F14.7)') 'U     = ', upar
         Write(6,'(A,i2    )') 'lant  = ', lant
         Write(6,'(A,i2    )') 'multLn= ', multLn
         Write(6,'(A,i2    )') 'keopt = ', KEOPT
      End If

      If(JITO_exchange) Then
         Write(6,'(A,A )') 'ITOJ :         = ',' Full anisotopic ITO'//
     &                     ' exchange for the above exchange pairs'//
     &                     ' is included (in cm-1)'
         Do i=1,npair
           Write(6,'(17x,2I3)') i_pair(i,1),i_pair(i,2)
           Do irank1=1,imaxrank(i,1),2
            Do iproj1=-irank1,irank1
             Do irank2=1,imaxrank(i,2),2
              Do iproj2=-irank2,irank2
               Write(6,'(23x,4I3,2x,2ES23.14)')
     &                        irank1, iproj1, irank2, iproj2,
     &             JITOexR(i, irank1, iproj1, irank2, iproj2),
     &             JITOexI(i, irank1, iproj1, irank2, iproj2)
              End Do
             End Do
            End Do
           End Do
         End Do
      End If
c-----------------------------------------------------------------------
c     print Exchange Hamiltonian
c     print Exchange Eigenstates
c     print decomposition of exchange
c    ...
! ======================================================================
!  Print out of the UBAR:
      If (compute_barrier) Then
         If (compute_g_tensors) Then
            Nblock=0
            Do i=1,nmult
               Nblock=Nblock+ndim(i)
            End Do
         Else
            Write(6,'(A)') 'UBAR keyword needs to know the sizes of'
            Write(6,'(A)') 'the manIfolds forming the barrier'
            Write(6,'(A)') 'Was the MLTP keyword defined?'
            Write(6,'(A)') 'The program will continue, but UBAR is '//
     &                     'deactivated'
            compute_barrier=.false.
         End If

         If (Nblock > exch) Then
            Write(6,'(A)') 'It seems that you have asked for '//
     &                     'properties of inexistent states.'
            Write(6,'(A)') 'Nblock > Nexch!'
            Write(6,'(A,I5)') 'Nblock = ',nBlock
            Write(6,'(A,I5)') 'Nexch  = ',exch
            Write(6,'(A   )') 'Reset   NBLOCK=EXCH and continue'
            nBlock=exch
         End If
      End If


! ======================================================================
!  Print out of the g and D tensors:

      If ( compute_g_tensors .AND. (nMult > 0)) Then
         Write(6,'(A)') 'Information about g and D tensors:'
         Write(6,'(A,I3)')   'MLTP :         = ', NMULT
         If( nMult <= 20 ) Then
            Write(6,'(A,20I3)') '               = ',(NDIM(i),i=1,NMULT)
         Else
            Write(6,'(A,20I3)') '               = ',(NDIM(i),i=1,20)
            Do j=21,NMULT,20
               jEnd=MIN(NMULT,J+19)
            Write(6,'(A,20I3)') '                 ',(NDIM(i),i=j,jEnd)
           End Do
         End If
      Else
         Write(6,'(A)') 'Computation of pseudospin Hamiltonians '//
     &                  'was not requested'
      End If

      If ( compute_g_tensors .AND. (nMult == 0)) Then
         Write(6,'(A,i3)') 'nMult =',nMult
         Write(6,'(A   )') 'Computation of pseudospin Hamiltonians '//
     &                     'is deactivated.'
      End If
! ======================================================================

      If( Do_structure_abc .AND.
     &    ((nMult>0).OR.compute_susceptibility) ) Then
         Write(6,'(2A)') 'ABCC :         = ','the main axes '//
     &                   'for the computed tensors are '//
     &                   'written also'
         Write(6,'(A)') 'in the crystallographic "abc" axes'
         Write(6,'(10x,A,F9.4)') 'a       = ', cryst(1)
         Write(6,'(10x,A,F9.4)') 'b       = ', cryst(2)
         Write(6,'(10x,A,F9.4)') 'c       = ', cryst(3)
         Write(6,'(10x,A,F9.4)') 'alpha   = ', cryst(4)
         Write(6,'(10x,A,F9.4)') 'beta    = ', cryst(5)
         Write(6,'(10x,A,F9.4)') 'gamma   = ', cryst(6)
         Write(6,'(10x,a,3F9.4)') 'coords: = ',(coord(i),i=1,3)
      End If


! ======================================================================
!  Print out of the SUSCEPTIBILITY
      compute_susceptibility=.true.
!      If(tmin==0.0_wp) tmin=0.0_wp
!      If(tmax==0.0_wp) tmax=0.0_wp
      If(compute_susceptibility) Then
       !-----------------------------------------!
         Write(6,'(A)') 'Magnetic susceptibility will be computed'//
     &                  'in the limit of zero applied magnetic field.'
       !-----------------------------------------!
         Write(6,'(A,A )') 'CHIT :         = ',' molar magnetic '//
     &                     'susceptibility is computed using'
       !-----------------------------------------!
         If (IOPT.eq.1) Then
            Write(6,'(18x,A)') 'newly-derived formula for total '//
     &                         'XT and M'
         Else If (IOPT.eq.2) Then
            Write(6,'(18x,A)') 'additive formula employed for '//
     &                        'total XT and M'
         Else If (IOPT.eq.3) Then
            Write(6,'(18x,A)') 'old formula employed for total XT and M'
         Else
            Write(6,'(18x,A)') 'IOPT parameter out of range.'
            Return
         End If
       !-----------------------------------------!
         If(TINPUT) Then
            Write(6,'(A)') 'TEXP :         = the experimental '//
     &                     'temperature interval is provided:'
            Do iT=1,nT
               Write(6,'(5X,i4,F11.5,F14.7)') iT, Texp(iT), chit_exp(iT)
            End Do
         Else
            Write(6,'(A, I4)')  'TINT :      nT = ', nT
            Write(6,'(A,F7.3)') '          Tmin = ', Tmin
            Write(6,'(A,F7.3)') '          Tmax = ', Tmax
         End If
       !-----------------------------------------!
         If (xField.ne.0.0_wp) Then
            Write(6,'(A)') 'Magnetic susceptibility will be computed '//
     &                     'also by using:'
            Write(6,'(A)') ' X= dM/dH formula and'
            Write(6,'(A)') ' X=  M/H formula (commonly used by '//
     &                     'experimentalists)'
            Write(6,'(A,F9.5,A)') 'FIELD :          ',Xfield,' Telsa'
         End If
       !-----------------------------------------!
      Else
        Write(6,'(A)') 'Computation of magnetic susceptibility '//
     &                 'was not requested.'
      End If

! ======================================================================
!  Print out of the TORQUE
      If(compute_torque) Then
         Write(6,'(A)') 'TORQ :         = ',' magnetic torque '//
     &                  'is computed'
         Write(6,'(A,I4)') 'AngPoints = ', AngPoints
         Write(6,'(A,i4)') 'nP        = ', nP
      Else
         Write(6,'(A)') 'Computation of magnetic torque was not '//
     &                  'requested.'
      End If

! ======================================================================




! ======================================================================
!  Print out of the MAGNETIZATION
      If(compute_magnetization) Then
         Write(6,'(2A )') 'MAGN :         = ',' molar magnetization '//
     &                    'is computed'
       !-----------------------------------------!
        If(nH > 0) Then
           If(HINPUT) Then
              Write(6,'(A)') 'HEXP :         = the experimental '//
     &                       'field interval is provided:'
              Write(fmtline,'(A,i3,A)')
     &                       '(5x,i4,F11.5,',nTempMagn,'F14.7)'
              Do iH=1,nH
                 Write(6,fmtline)
     &               iH, Hexp(iH), (Mexp(iH,iT),iT=1,nTempMagn)
              End Do
           Else
              Write(6,'(A, I4)')  'HINT :      nH = ', nH
              Write(6,'(A,F7.3)') '          Hmin = ', Hmin
              Write(6,'(A,F7.3)') '          Hmax = ', Hmax
           End If
        End If
       !-----------------------------------------!
        If(encut_definition.eq.1) Then
           Write(6,'(A, I4)')  'NCUT :         = ', ncut
        Else If(encut_definition.eq.2) Then
           Write(6,'(A,2I4)')  'ECUT :         = ', nk,mg
        Else If(encut_definition.eq.3) Then
           Write(6,'(A,F7.3)') 'ERAT :         = ', encut_rate
        End If
       !-----------------------------------------!
        Write(6,'(A, I4   )') 'TMAG :         = ',nTempMagn
        ! check for negative T
        Do i=1, nTempMagn
          If(TempMagn(i) <= 0.0_wp) TempMagn(i)=2.0_wp
        End Do

       !-----------------------------------------!
        If (nTempMagn.le.10) Then
           Write(6,'(6x,A,10F7.3)') 'TempMagn = ',
     &                            (TempMagn(i),i=1,nTempMagn)
        Else
           Do i=1,nTempMagn,10
              j=MIN(nTempMagn,i+9)
              Write(6,'(17x,10F7.3)') (TempMagn(k),k=i,j)
           End Do
        End If
       !-----------------------------------------!
        If(zeeman_energy) Then
           Write(6,'(2A,I3,A)') 'ZEEM :         = ',' Zeeman '//
     &                          'splitting for the following ',nDirZee
           Write(6,'(17x,A  )') 'direction(s) of the magnetic '//
     &                          'field is given in the'//
     &                          ' "zeeman_energy_xxx.output" file(s)'
           Do i=1, nDirZee
              Write(6,'(17x,3F11.6)')  (dir_weight(i,l),l=1,3)
           End Do
        End If
       !-----------------------------------------!
        If(compute_Mdir_vector) Then
           Write(6,'(2A,I2,a)') 'MVEC :         = ','Magnetization '//
     &                          'vector(s) for the following ',nDir,
     &                          ' direction(s) of the applied magnetic'
           Write(6,'(17x,A)')   'field will be computed;'
           Do i=1,nDir
              Write(6,'(17x,A,I2,A,3F10.6)') 'Dir :',i,' : ',
     &                                       DirX(i), DirY(i), DirZ(i)
           End Do
        End If

        If(nH > 0) Then
       !-----------------------------------------!
           Write(6,'(A, I4)') 'MAVE :   nsymm = ', nsymm
           Write(6,'(A, I4)') '         ngrid = ', ngrid
           Write(6,'(A, I4)') '       nPoints = ', get_nP(nsymm,ngrid)
       !-----------------------------------------!
           nDirTot = 0
           nDirTot = nDir + nDirZee + get_nP(nsymm,ngrid)
           Write(6,'(A,I4,A)') 'Magnetization will be computed in',
     &                          nDirTot,' directions.'
           Write(6,'(A,I6,A)') 'There will be ',nDirTot*nH,
     &                         ' calculations in total.'

           !-----------------------------------------------------------|
           If (m_accurate) Then
              Write(6,'(2A   )') 'MACC :         = ','Contribution '//
     &                  'to magnetization from local excited states'
              Write(6,'(17x,A)') 'is computed exactly.'
           Else
              Write(6,'(17x,A)') 'is accounted by formula: '//
     &                           ' M_excited = X_excited * H'
           End If
           !-----------------------------------------------------------|

           !-----------------------------------------------------------|
           If((exch.lt.256) .AND. (zJ.ne.0.0_wp)) m_paranoid=.true.

           If ( m_paranoid .AND. (zJ.ne.0.0_wp)) Then
              Write(6,'(2A)') 'MPAR :         = ','Average spin '//
     &                        '< S > of the environment is computed'
              Write(6,'(2A)') '                 ','for each '//
     &                        'temperature point (more accurate)'
           Else
              Write(6,'(2A)') 'MPAR :         = ','Average spin '//
     &                        '< S > of the environment is computed'
              Write(6,'(2A)') '                 ','for the highest '//
     &                        'temperature point only and used for '//
     &                        'all computed temperature points.'
           End If
           !-----------------------------------------------------------|

           !-----------------------------------------------------------|
           If (smagn) Then
              Write(6,'(2A)') 'SMAG :         = ','Spin-only '//
     &                        'magnetisation is computed'
           Else
              Write(6,'(A)') 'Computation of spin magnetization '//
     &                       'was not requested.'
           End If
           !-----------------------------------------------------------|

           Write(6,'(A,ES14.6)') 'THRS = ', thrs
        End If
      Else
           Write(6,'(A)') 'Computation of molar magnetization was '//
     &                    'not requested.'
      End If
!  End Print out of the MAGNETIZATION
! ======================================================================
      If( compute_susceptibility .OR. compute_torque .OR.
     &    compute_magnetization ) Then
         If ( zJ .ne. 0.0_wp ) Then
            Write(6,'(A)') 'Mean field intermolecular interaction '//
     &                     'parameter'
            Write(6,'(A,F12.7)') 'ZJPR :         = ', zJ
         End If
      End If
! ======================================================================
      If( ( fitCHI .OR. fitM ) .AND. ( tinput .OR. hinput ) ) Then
            Write(6,'(A)') 'Automatic fitting of exchange parameters'//
     &                     'is yet in the development'
      End If
! ======================================================================

      Return
      End subroutine input_process

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993,1996, Markus P. Fuelscher                         *
!               1993, Per Ake Malmqvist                                *
!***********************************************************************

subroutine SORT1A(nUt,vInt,nSqNum,nSyBlk)
!***********************************************************************
!                                                                      *
!     Purpose: Phase 1 of the bin sorting algorithm                    *
!             Distribute the integrals into the bins where the indices *
!             and the integral values are stored in different buffers. *
!             When a bin is completed append the buffer containing the *
!             integral values to the file LuTwo and the buffer         *
!             containing the indice to LuTmp. Before draining the      *
!             buffers they are sorted in ascending order using the     *
!             ESSL routine ISORTX.                                     *
!                                                                      *
!     Called from: PLF2,INDSFT2                                        *
!                                                                      *
!     Calls to : PKI4,PKR8,SetVec,ErrTra,ISORTX,I4Len,R8Len            *
!                                                                      *
!     Calling Parameters:                                              *
!     nUt    : number of 2el integrals in the buffers vInt,nSqNum      *
!              and nSyBlk                                              *
!     vInt   : Buffer of 2el integral values                           *
!     nSqNum : sequence number of the integral relative to             *
!              the first adress of the symmetry block                  *
!     nSyBlk : symmetry block number of an integral                    *
!                                                                      *
!     Global data declarations (Include files) :                       *
!     TwoDat : definitions of sorting flags and address tables         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher and P.-AA. Malmqvist                             *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!     - modified to use a virtual disk                                 *
!       M. P. Fuelscher, University of Lund, Sweden, 1996              *
!                                                                      *
!***********************************************************************

use sort_data, only: lBin, lwIBin, lwVBin, mInt, n_Int
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nUt
real(kind=wp), intent(in) :: vInt(nUt), nSqNum(nUt), nSyBlk(nUt)
#include "TwoDat.fh"
#include "print.fh"
integer(kind=iwp) :: iBin, iOpt, iPrint, iRout, iUt, next

!----------------------------------------------------------------------*
!     pick up print level                                              *
!----------------------------------------------------------------------*

iRout = 81
iPrint = nPrint(iRout)
if (iPrint >= 99) then
  write(u6,*) ' >>> Enter SORT1A <<<'
  call dVcPrt('nSqNum',' ',nSqNum,nUt)
  call dVcPrt('nSyBlk',' ',nSyBlk,nUt)
  call dVcPrt('vInt',' ',vInt,nUt)
end if

if (RAMD) then
  call Untested('Sort1a (RAMD)')
  call SORT1C(nUt,vInt,nSqNum,nSyBlk)
  return
end if

iOpt = 0 ! Always tight!

!----------------------------------------------------------------------*
!     put the 2el integrals into the bins                              *
!----------------------------------------------------------------------*

do iUt=1,nUt
  iBin = int(nSyBlk(iUt),kind=iwp)
  next = n_Int(iBin)+1
  lwVBin(next,iBin) = vInt(iUt)
  lwIBin(next,iBin) = int(nSqNum(iUt),kind=iwp)
  n_Int(iBin) = next
  mInt(1,iBin) = mInt(1,iBin)+1

  !--------------------------------------------------------------------*
  !   If a bin is completed pack the buffer and put it to disc         *
  !   First, sort the the integrals such that the indices are given in *
  !   strictly ascending order.                                        *
  !--------------------------------------------------------------------*

  if (next >= (lBin-1)) then
    call SaveBin(iBin,iOpt)
  end if
end do

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine SORT1A

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ZSTINF_MCLR()
! Set up common block /STINF/ from information in /STINP/
!
!=========
! Input
!=========
! Information in /STINP/ and /ORBINP/
!
!====================
! Output (in /STINF/)
!====================
! ISTAC (MXPSTT,2) : string type obtained by creating (ISTAC(ITYP,2))
!                    or annihilating (ISTAC(ITYP,1)) an electron
!                    from a string of type  ITYP. A zero indicates
!                    that this mapping is not included
!                    Only strings having the same ISTTP index are
!                    mapped
! NOCTYP(ITYP) : Number of occupation classes for given type
!
!
! NSTFTP(ITYP) : Number of strings of this type
!
!   / \           Zero order space                         !
!    !            Double excitations from reference space  !  Down
! Up !            single excitation from reference space   !
!    !            reference space                         \ /

use Str_Info, only: ISTAC, MNRS1, MNRS3, MXRS1, MXRS3, NELEC, NOCTYP, NSTFTP, NSTTYP
use MCLR_Data, only: NORB1, NORB2, NORB3
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: ITYP, NUMST3

! *****************************************************************
! Mappings between strings with the same type ISTTP index, +/- 1 el
! *****************************************************************
ISTAC(:,:) = 0
do ITYP=1,NSTTYP-1
  if (NELEC(ITYP+1) == NELEC(ITYP)-1) then
    ISTAC(ITYP,1) = ITYP+1
    ISTAC(ITYP+1,2) = ITYP
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Type - type mapping array ISTAC'
write(u6,*) ' ==============================='
call IWRTMA(ISTAC,NSTTYP,2,size(ISTAC,1),2)
#endif
! *************************************************
! Number of occupation classes and strings per type
! *************************************************
NOCTYP(1:NSTTYP) = (MXRS1(1:NSTTYP)-MNRS1(1:NSTTYP)+1)*(MXRS3(1:NSTTYP)-MNRS3(1:NSTTYP)+1)
#ifdef _DEBUGPRINT_
write(u6,*) ' Number of occupation classes per type'
write(u6,*) ' ====================================='
call IWRTMA(NOCTYP,1,NSTTYP,1,NSTTYP)
#endif

do ITYP=1,NSTTYP
  NSTFTP(ITYP) = NUMST3(NELEC(ITYP),NORB1,MNRS1(ITYP),MXRS1(ITYP),NORB2,NORB3,MNRS3(ITYP),MXRS3(ITYP))
end do
#ifdef _DEBUGPRINT_
write(u6,*) ' Number of strings per  type'
write(u6,*) ' ==========================='
call IWRTMA(NSTFTP,1,NSTTYP,1,NSTTYP)
#endif
! ****************************************************************
! Mappings between strings containing the same number of electrons
! ****************************************************************
!INUMAP(:) = 0
!INDMAP(:) = 0
! Mapping to and from zero order space
! Note: some lines are commented out here since IARTP and IBRTP
!       have never been defined. (R. Lindh 2006)
!INUMAP(IARTP(3,5)) = IAZTP
!if (IARTP(3,4) /= 0) INUMAP(IARTP(3,4)) = IAZTP+1
!if (IARTP(3,3) /= 0) INUMAP(IARTP(3,3)) = IAZTP+2

!INUMAP(IBRTP(3,5)) = IBZTP
!if (IBRTP(3,4) /= 0) INUMAP(IBRTP(3,4)) = IBZTP+1
!if (IBRTP(3,3) /= 0) INUMAP(IBRTP(3,3)) = IBZTP+2

!NAEL = NELEC(IAZTP)
!INDMAP(IAZTP) = IARTP(3,5)
!if (NAEL >= 1) INDMAP(IAZTP+1) = IARTP(3,4)
!if (NAEL >= 2) INDMAP(IAZTP+2) = IARTP(3,3)

!NBEL = NELEC(IBZTP)
!INDMAP(IBZTP) = IBRTP(3,5)
!if (NBEL >= 1) INDMAP(IBZTP+1) = IBRTP(3,4)
!if (NBEL >= 2) INDMAP(IBZTP+2) = IBRTP(3,3)

! Number of electrons compared to reference
!do IDEL=-4,2
!  do IEX=1,2
!    ! Up mappings
!    if (IARTP(IEX,IDEL+5) /= 0) INUMAP(IARTP(IEX,IDEL+5)) = IARTP(IEX+1,IDEL+5)
!    if (IBRTP(IEX,IDEL+5) /= 0) INUMAP(IBRTP(IEX,IDEL+5)) = IBRTP(IEX+1,IDEL+5)
!    ! Down mappings
!    if (IARTP(IEX+1,IDEL+5) /= 0) INDMAP(IARTP(IEX+1,IDEL+5)) = IARTP(IEX,IDEL+5)
!    if (IBRTP(IEX+1,IDEL+5) /= 0) INDMAP(IBRTP(IEX+1,IDEL+5)) = IBRTP(IEX,IDEL+5)
!  end do
!end do

!#ifdef _DEBUGPRINT_
!write(u6,*) ' Up mappings of string types'
!call IWRTMA(INUMAP,1,NSTTYP,1,NSTTYP)
!write(u6,*) ' Down mappings of string types'
!call IWRTMA(INDMAP,1,NSTTYP,1,NSTTYP)
!#endif

return

end subroutine ZSTINF_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine restart_sa(input_to_read,input_file_name,nss,nstate)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: input_to_read
character(len=180), intent(in) :: input_file_name
integer(kind=iwp), intent(inout) :: nss, nstate
integer(kind=iwp) :: iDisk, idum(1), luaniso
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: dbg = _DBG_
integer(kind=iwp), external :: IsFreeUnit

if (input_to_read == 1) then
  ! read the binary file "$Project.aniso":
  luaniso = 8
  call daname(luaniso,'POLYFILE')
  iDisk = 0
  call idafile(luaniso,2,idum,1,iDisk)
  nstate = idum(1)
  call idafile(luaniso,2,idum,1,iDisk)
  nss = idum(1)
  call daclos(luaniso)
  ! put them on RunFile:
  call Put_iScalar('NSTATE_SINGLE   ',nstate)
  call Put_iScalar('NSS_SINGLE      ',nss)
  call Put_iScalar('MXJOB_SINGLE    ',1)
  call Put_iScalar('NJOB_SINGLE     ',1)

else if ((input_to_read == 2) .or. (input_to_read == 4)) then
  ! read the ascii formatted "aniso.input" file:
  luaniso = IsFreeUnit(18)
  call molcas_open(luaniso,input_file_name)
  read(luaniso,*) nstate,nss
  close(luaniso)
  ! put them on RunFile:
  call Put_iScalar('NSTATE_SINGLE   ',nstate)
  call Put_iScalar('NSS_SINGLE      ',nss)
  call Put_iScalar('MXJOB_SINGLE    ',1)
  call Put_iScalar('NJOB_SINGLE     ',1)

else if (input_to_read == 3) then
# ifdef _DEBUGPRINT_
  write(u6,*) 'restart_sa: file h5=',trim(input_file_name)
# endif
# ifdef _HDF5_
  ! NSS and NSTATE are also placed on RunFile
  call read_hdf5_init(input_file_name,nstate,nss)
# ifdef _DEBUGPRINT_
  write(u6,*) 'restart_sa:    nss=',nss
  write(u6,*) 'restart_sa: nstate=',nstate
# endif
  call Put_iScalar('NSTATE_SINGLE   ',nstate)
  call Put_iScalar('NSS_SINGLE      ',nss)
  call Put_iScalar('MXJOB_SINGLE    ',1)
  call Put_iScalar('NJOB_SINGLE     ',1)
# else
  write(u6,'(A)') 'Warning:: restart option was set to 3: i.e. from an HDF5 file'
  write(u6,'(A,A)') 'file id =',trim(input_file_name)
  call WarningMessage(2,'MOLCAS was compiled without _HDF5_ option.')
  call Quit_OnUserError()
# endif

else if (input_to_read == 6) then
  ! read the ascii formatted "aniso.input" file (NEW):
  luaniso = IsFreeUnit(18)
  call molcas_open(luaniso,input_file_name)

  call read_nss(luaniso,nss,dbg)
  call read_nstate(luaniso,nstate,dbg)

  ! put them on RunFile:
  call Put_iScalar('NSTATE_SINGLE   ',nstate)
  call Put_iScalar('NSS_SINGLE      ',nss)
  call Put_iScalar('MXJOB_SINGLE    ',1)
  call Put_iScalar('NJOB_SINGLE     ',1)

  close(luaniso)

else
  call WarningMessage(2,'SINGLE_ANISO:: RESTART  option is not known.')
  write(u6,'(A,I6)') 'restart_option =',input_to_read
  write(u6,'(A,I6)') 'restart_option can only take integer values:'
  write(u6,'(A,I6)') '1 - from binary $Project.aniso'
  write(u6,'(A,I6)') '2 - from formatted file "aniso.input" (filename can be given in the input)'
  write(u6,'(A,I6)') '3 - from an HDF5 type file generated by RASSI code (filename can be given in the input)'
  write(u6,'(A,I6)') '4 - from formatted file "aniso.input" (filename can be given in the input) in molcas-8.0 format'
  call Quit_OnUserError()

end if

return

end subroutine restart_sa

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OrdExpD2C(nExp,Expn,nCntrc,Cff)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nExp, nCntrc
real(kind=wp), intent(inout) :: Expn(nExp), Cff(nExp,nCntrc)
integer(kind=iwp) :: iExp, jExp, kExp
real(kind=wp) :: Exp1, Exp2
#ifdef _ORDER_BAS_
integer(kind=iwp) :: iCntrc, jCntrc, kCntrc
real(kind=wp) :: Bas1, Bas2
#endif

! Order exponents diffuse to compact
! Make the subsequent change in the contraction matrix

do iExp=1,nExp-1
  Exp1 = Expn(iExp)
  kExp = iExp
  do jExp=iExp+1,nExp
    Exp2 = Expn(jExp)
    if (Exp2 < Exp1) then
      Exp1 = Exp2
      kExp = jExp
    end if
  end do
  if (kExp /= iExp) then
    call DSwap_(1,Expn(iExp),1,Expn(kExp),1)
    call DSwap_(nCntrc,Cff(iExp,1),nExp,Cff(kExp,1),nExp)
  end if
end do

#ifdef _ORDER_BAS_
! Now order the contracted basis functions diffuse to compact

do iCntrc=1,nCntrc-1
  Bas1 = abs(Cff(1,iCntrc))
  kCntrc = iCntrc
  do jCntrc=iCntrc+1,nCntrc
    Bas2 = abs(Cff(1,jCntrc))
    if (Bas2 < Bas1) then
      Bas1 = Bas2
      kCntrc = jCntrc
    end if
  end do
  if (kCntrc /= iCntrc) call DSwap_(nExp,Cff(1,iCntrc),1,Cff(1,kCntrc),1)
end do
#endif

return

end subroutine OrdExpD2C

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Francesco Aquilante                              *
!***********************************************************************

subroutine Cho_SOSmp2_Drv(irc,EMP2,CMO,EOcc,EVir)
! Francesco Aquilante, May 2007.
!
! Purpose: driver for computing the Scaled Opposite-Spin (SOS)
!          MP2 energy correction EMP2
!          using Cholesky (or RI) representation for the
!          two-electron integrals.
!          Input must have been processed and MO coefficients
!          and orbital energies must be passed as arguments.
!
! Notes:
!
!   - all MO Cholesky vector files generated here are deleted before
!     exit, except for error terminations (i.e. no cleanup actions
!     are taken!)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Five
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(out) :: EMP2
real(kind=wp), intent(in) :: CMO(*), EOcc(*), EVir(*)
integer(kind=iwp) :: iSym, lDiag, nSym_Sav
real(kind=wp) :: CPUDec1, CPUDec2, CPUEnr1, CPUEnr2, CPUIni1, CPUIni2, CPUTot1, CPUTot2, CPUTra1, CPUTra2, Diff, Dum, FracMem, &
                 WallDec1, WallDec2, WallEnr1, WallEnr2, WallIni1, WallIni2, WallTot1, WallTot2, WallTra1, WallTra2
logical(kind=iwp) :: Delete
real(kind=wp), allocatable :: Diag(:)
integer(kind=iwp), parameter :: iFmt = 0
real(kind=wp), parameter :: Chk_Mem_ChoMP2 = 0.123456789_wp, Tol = 1.0e-15_wp
logical(kind=iwp), parameter :: Delete_def = .true.
character(len=*), parameter :: SecNam = 'Cho_SOSmp2_Drv'
real(kind=r8), external :: ddot_
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_cfg.fh"

#if defined (_DEBUGPRINT_)
Verbose = .true.
#endif
if (Verbose) then
  call CWTime(CPUTot1,WallTot1)
end if

! Initializations.
! ----------------

irc = 0

EMP2 = Zero

if (Verbose) then
  call CWTime(CPUIni1,WallIni1)
end if

Dum = Chk_Mem_ChoMP2

FracMem = Zero ! no buffer allocated
call Cho_X_Init(irc,FracMem)
if (irc /= 0) then
  write(u6,*) SecNam,': Cho_X_Init returned ',irc
  call ChoMP2_Quit(SecNam,'Cholesky initialization error',' ')
end if

call Cho_SOSmp2_Setup(irc)
if (irc /= 0) then
  write(u6,*) SecNam,': Cho_SOSmp2_Setup returned ',irc
  call finalize()
  return
end if

if (Verbose) then
  call Cho_SOSmp2_Setup_Prt(irc)
  if (irc /= 0) then
    write(u6,*) SecNam,': Cho_SOSmp2_Setup_Prt returned ',irc
    call finalize()
    return
  end if
  call CWTime(CPUIni2,WallIni2)
  call Cho_PrtTim('Cholesky SOS-MP2 initialization',CPUIni2,CPUIni1,WallIni2,WallIni1,iFmt)
end if

! Transform Cholesky vectors directly from reduced set to MO
! representation. Result vectors are stored on disk.
! Compute also the (ai|ai)^2 diagonal here.
! ----------------------------------------------------------

if (Verbose) then
  call CWTime(CPUTra1,WallTra1)
end if
lDiag = nT1am(1)
do iSym=2,nSym
  lDiag = lDiag+nT1am(iSym)
end do
call mma_allocate(Diag,lDiag,label='Diag')

call ChoMP2_TraDrv(irc,CMO,Diag,.true.)
if (irc /= 0) then
  write(u6,*) SecNam,': ChoMP2_TraDrv returned ',irc
  call finalize()
  return
end if

! Squaring each diagonal element
! ------------------------------
Diag(:) = Diag(:)**2
if (set_cd_thr) ThrMP2 = ddot_(lDiag,[One],0,Diag,1)/(Five*lDiag)

if (Verbose) then
  call CWTime(CPUTra2,WallTra2)
  call Cho_PrtTim('Cholesky MP2 transformation',CPUTra2,CPUTra1,WallTra2,WallTra1,iFmt)
end if

! Finalize Cholesky info (to release memory).
! Retain essential info: LuPri, nSym, and NumCho(*).
! --------------------------------------------------

nSym_Sav = nSym
nMP2Vec(1:nSym) = NumCho(1:nSym)

call Cho_X_Final(irc)
if (irc /= 0) then
  write(u6,*) SecNam,': Cho_X_Final returned ',irc
  call finalize()
  return
end if

LuPri = u6
nSym = nSym_Sav
NumCho(1:nSym) = nMP2Vec(1:nSym)

! Decompose M(ai,bj) = (ai|bj)^2 .
! Set number of vectors to be used in energy calculation.
! -------------------------------------------------------

if (Verbose) then
  call CWTime(CPUDec1,WallDec1)
end if
Delete = Delete_def ! delete transf. vector files after dec.
call Cho_SOSmp2_DecDrv(irc,Delete,Diag)
if (irc /= 0) then
  write(u6,*) SecNam,': Cho_SOSmp2_DecDrv returned ',irc
  call ChoMP2_Quit(SecNam,'SOS-MP2 decomposition failed!',' ')
end if
if (Verbose) then
  call CWTime(CPUDec2,WallDec2)
  call Cho_PrtTim('Cholesky SOS-MP2 decomposition',CPUDec2,CPUDec1,WallDec2,WallDec1,iFmt)
end if
call mma_deallocate(Diag)

! Compute SOS-MP2 energy correction.
! ----------------------------------

if (Verbose) then
  call CWTime(CPUEnr1,WallEnr1)
end if
Delete = Delete_def
call Cho_SOSmp2_Energy(irc,EMP2,EOcc,EVir,Delete)
if (irc /= 0) then
  write(u6,*) SecNam,': Cho_SOSmp2_Energy returned ',irc
  call finalize
  return
end if
if (Verbose) then
  call CWTime(CPUEnr2,WallEnr2)
  call Cho_PrtTim('Cholesky SOS-MP2 energy',CPUEnr2,CPUEnr1,WallEnr2,WallEnr1,iFmt)
end if

! Exit.
! -----

call finalize()

return

contains

subroutine finalize()
  Diff = abs(Dum-Chk_Mem_ChoMP2)
  if (Diff > Tol) then
    write(u6,*) SecNam,': Memory Boundary Error!'
    if (irc == 0) irc = -9999
  end if
  if (Verbose) then
    call CWTime(CPUTot2,WallTot2)
    call Cho_PrtTim('Cholesky SOS-MP2',CPUTot2,CPUTot1,WallTot2,WallTot1,iFmt)
  end if
end subroutine finalize

end subroutine Cho_SOSmp2_Drv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine distribution (unit,dkhorder,xorder,dkhscfflg,
     *               ordercounter,opcounter,operleng,oporder,evenodd,
     *               doperators,operators,xordercounter,xopcounter,
     *               xoperleng,xoporder,xevenodd,xdoperators,xoperators)
c
c******************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 18.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer unit,dkhorder,xorder,ordercounter(0:maxorder),opcounter,
     *        operleng(maxoperators),oporder(maxoperators,3),
     *        evenodd(maxoperators),
     *        xordercounter(0:maxorder),xopcounter,
     *        xoperleng(maxoperators),xoporder(maxoperators),
     *        xevenodd(maxoperators)
      real*8 doperators(maxoperators),
     *                 xdoperators(maxoperators)
      character*(maxlength) operators(maxoperators),
     *                      xoperators(maxoperators)
c
      logical dkhscfflg
      integer i,j,idum,ddistribution(0:100),xddistribution(0:100)
C     real*8 DABS,DBLE,dscr
      real*8 dscr
c
      if (dkhscfflg) then
        write (unit,1023)
1023    format (2X,88('-'),//9X,'order',6X,'ordercounter',/9X,'(tot)')
        do 20 i=0,dkhorder
          write (unit,1025) i,ordercounter(i)
1025      format (10X,I2,8X,I7)
  20    continue
        write(unit,1027) opcounter
1027    format(20X,7('-'),/20X,I7)
      else
        write (unit,1033)
1033    format (2X,88('-'),//9X,'order',6X,'ordercounter',5X,
     *          'xordercounter',/10X,'(V)')
        do 30 i=0,max(dkhorder,xorder)
          write (unit,1035) i,ordercounter(i),xordercounter(i)
1035      format (10X,I2,8X,I7,11X,I7)
  30    continue
        write(unit,1045) opcounter,xopcounter
1045    format(20X,7('-'),10X,8('-'),/20X,I7,11X,I7)
      endif
c
      do 40 i=0,100
        ddistribution(i)=0
        xddistribution(i)=0
  40  continue
      idum=0
      dscr=1.0d0
      do 45 i=0,20
        if (abs(dscr-dkhzero).le.dkhzero) then
          idum=i
          goto 47
        endif
        dscr=dscr/10.0d0
  45  continue
  47  continue
      do 50 i=1,opcounter
        if (abs(doperators(i)).lt.dkhzero)
     *        ddistribution(idum+1)=ddistribution(idum+1)+1
        dscr=dkhzero
        do 70 j=idum,1,-1
          if (abs(doperators(i)).ge.dscr .and.
     *          abs(doperators(i)).lt.dscr*10.0d0)
     *             ddistribution(j)=ddistribution(j)+1
          dscr=dscr*10.0d0
  70    continue
        if (abs(doperators(i)).eq.1.0d0)
     *                    ddistribution(0)=ddistribution(0)+1
  50  continue
c
c
      if (.not.dkhscfflg) then
        do 51 i=1,xopcounter
          if (abs(xdoperators(i)).lt.dkhzero)
     *          xddistribution(idum+1)=xddistribution(idum+1)+1
          dscr=dkhzero
          do 71 j=idum,1,-1
            if (abs(xdoperators(i)).ge.dscr .and.
     *            abs(xdoperators(i)).lt.dscr*10.0d0)
     *               xddistribution(j)=xddistribution(j)+1
            dscr=dscr*10.0d0
  71      continue
          if (abs(xdoperators(i)).eq.1.0d0)
     *                      xddistribution(0)=xddistribution(0)+1
  51    continue
      endif
c
      if (dkhscfflg) then
        write (unit,1043)
1043    format (/2X,'Distribution of coefficients (doperators):',
     *          3X,'(Absolute values!)',/2X,63('-'),/2X)
        write (unit,1046) dkhzero,ddistribution(idum+1)
1046    format (5X,'[ 0.0     ,',D8.1,' [',5X,I6)
        do 77 i=idum,1,-1
          write (unit,1048) 10.0d0**(-i),10.0d0**(-i+1),ddistribution(i)
1048      format (5X,'[',D8.1,' ,',D8.1,' [',5X,I6)
  77    continue
        write(unit,1049) ddistribution(0),opcounter
1049    format(14X,' = 1.00',10X,I6,/30X,7('-'),/30X,I7)
      else
        write (unit,1053)
1053    format (/2X,'Distribution of coefficients (doperators) and ',
     *          '(xdoperators):',3X,'(Absolute values!)',/2X,60('-'),
     *          /2X)
        write (unit,1056) dkhzero,ddistribution(idum+1),
     *                    xddistribution(idum+1)
1056    format (5X,'[ 0.0     ,',D8.1,' [',5X,I6,12X,I6)
        do 80 i=idum,1,-1
          write (unit,1085) 10.0d0**(-i),10.0d0**(-i+1),
     *                         ddistribution(i),x ddistribution(i)
1085      format (5X,'[',D8.1,' ,',D8.1,' [',5X,I6,12X,I6)
  80    continue
        write(unit,1095) ddistribution(0),xddistribution(0),opcounter,
     *                   xopcounter
1095    format(14X,' = 1.00',10X,I6,12X,I6/30X,7('-'),11X,7('-')/30X,I7,
     *         11X,I7)
      endif
c
      do 140 i=0,100
        ddistribution(i)=0
        xddistribution(i)=0
 140  continue
c
      idum=(maxlength/10)+1
      do 150 i=1,opcounter
        do 170 j=1,idum
          if (operleng(i).ge.10*(j-1) .and. operleng(i).lt.10*j)
     *             ddistribution(j)=ddistribution(j)+1
 170    continue
 150  continue
c
      do 152 i=1,xopcounter
        do 172 j=1,idum
          if (xoperleng(i).ge.10*(j-1) .and. xoperleng(i).lt.10*j)
     *             xddistribution(j)=xddistribution(j)+1
 172    continue
 152  continue
c
      if (dkhscfflg) then
        write (unit,2052)
2052    format (/2X,'Distribution of length of operators (operleng):',
     *          2X,/2X,47('-'),/2X)
        do 179 j=1,idum
          write (unit,2086) 10*(j-1),10*j,ddistribution(j)
2086      format (10X,'[ ',I3,' , ',I3,' [',8X,I6,12X,I6)
 179    continue
        write(unit,2096) opcounter
2096    format(30X,7('-'),/30X,I7)
      else
        write (unit,2053)
2053    format (/2X,'Distribution of length of operators (operleng) ',
     *          'and xoperators (xoperleng):',2X,/2X,74('-'),/2X)
        do 180 j=1,idum
          write (unit,2085) 10*(j-1),10*j,ddistribution(j),
     *                      xddistribution(j)
2085      format (10X,'[ ',I3,' , ',I3,' [',8X,I6,12X,I6)
 180    continue
        write(unit,2095) opcounter,xopcounter
2095    format(30X,7('-'),11X,7('-')/30X,I7,11X,I7)
      endif
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer_array(oporder)
        call Unused_integer_array(evenodd)
        call Unused_character(operators)
        call Unused_integer_array(xoporder)
        call Unused_integer_array(xevenodd)
        call Unused_character(xoperators)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_VecBuf_CompareNormAndSum(n,nVec,Vec,J1,iSym,irc)
!
! Thomas Bondo Pedersen, September 2012.
!
! Compare norm and sum of vectors against values stored in buffer
! for Cholesky vectors J1,J1+1,J1+nVec-1 of symmetry iSym stored in
! array Vec(n,nVec). Comparison is only made for those vectors that
! are actually stored in the buffer, of course.
!
! Return codes:
!    irc=0: no differences detected.
!    irc>0: number of vectors for which differences are detected.

use Cholesky, only: CHVBFI, ip_CHVBFI_SYM, nVec_in_Buf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, nVec, J1, iSym
real(kind=wp), intent(in) :: Vec(n,nVec)
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: J, J0, mVec
real(kind=wp) :: Nrm, Sm
real(kind=wp), parameter :: Tol = 1.0e-12_wp
real(kind=wp), external :: dDot_

irc = 0
if (allocated(CHVBFI)) then
  J0 = J1-1
  mVec = min(J0+nVec,nVec_in_Buf(iSym))-J0
  do J=1,mVec
    Nrm = sqrt(dDot_(n,Vec(:,J),1,Vec(:,J),1))
    Sm = sum(Vec(:,J))
    if ((abs(CHVBFI(1,ip_ChVBfI_Sym(iSym)+J0+J)-Nrm) > Tol) .or. (abs(CHVBFI(2,ip_ChVBfI_Sym(iSym)+J0+J)-Sm) > Tol)) irc = irc+1
  end do
end if

end subroutine Cho_VecBuf_CompareNormAndSum

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Bjorn O. Roos                                    *
************************************************************************
      Subroutine Vibinp(ncase,ngrid,nvib,Umin,Umax,
     *                  Rout,PotR,E0,dE0,Redm,Teas,Req,scale,temp)
************************************************************************
*  Object: Read input and construct default input parameters           *
*  Called from main program                                            *
*  subroutine calls: Isotope (tables of isotope masses)                *
*  written by Bjoern Roos in March 1991                                *
************************************************************************
*     Use Isotopes
      Implicit real*8 (A-H,O-Z)
#include "dimensions.fh"
#include "intinp.fh"
#include "observ.fh"

#include "SysDef.fh"
#include "constants.fh"
*     Character*80 line,Title1(10),Title2(10)
      Character*80 Title1(10),Title2(10)
C For storing character data using gather/scatter DAFILE operations, it
C is imperative that the strings are aligned on integers.
C Assume an 8-byte character string is always dividible into integers.
C Else, IntCh and (maybe) Title1 and Title2 must be changed.
      Character*8 IntCh
      Parameter (ntab=20)
      Character*4 word,tabinp(ntab),Diatom,Diatomx
      Character*2 At1x,At2x
      Character*180 l84,l84x
      Logical exist
      Dimension Rout(npoint+4),potR(npoint+4)
      Dimension Rin(npin),Ein(npin)
*
      Character*180 Line, Get_Ln,Get_Ln_EOF
      External Get_Ln
C
      Data tabinp/'TITL','ATOM','GRID','RANG','VIBR',
     *            'ROTA','ORBI','NOSP','OBSE','STEP',
     *            'POTE','ROVI','TRAN','ASYM','PRWF',
     *            'SCAL','TEMP','ALLR','DUMM','END '/
*
      LuIn=5
C
C     Set default values to input variables
C
      Atom1='  '
      Atom2='  '
      ipot=0
C     ******        Indicator for potential input
      ngrid=199
C     ********      Maximum number of grid points
      Rmin=1.D0
      Rmax=5.D0
C     *********     Integration range
      Umin=log(Rmin)
      Umax=log(Rmax)
      nvib=3
      nvib1=nvib-1
C     ******        Number of vibrational states
      J1A=0
      J2A=5
C     *****         Range of rotational quantum numbers
      lambda=0
C     ********      Orbital angular momentum quantum number
      dE0=0.0004d0
C     **********    Start value for step size in eigenvalue search
      ispc=1
C     ******        Spectroscopic constants will be computed
      iobs=0
C     ******        No calculation of matrix elements for operators
      Teas=0.D0
C     *********     Asymtotic energy difference between two potentials
      iplotp=0
C     ********      No plot file for the potential
      iscale=0
C     ********      No scaling of input potential (BOR in June 2001)
      temp=300.0d0
C     ************  Temperature for Boltzmann weighting
      iallrot=0
C     *********     No calculation of transition between all rot. levels
CPAM97: New key word PRWF, flagged by IFPRWF .gt.0, default=0:
      IFPRWF=0
      do i=1,10
       Title1(i)=' '
      enddo
C
C
C     Position input file
C
      Call RdNLst(5,'VibRot')
C
C     Input format statements
C
1000  FORMAT(A)
C
C     Read input data from unit 5
C
      ntit1=0
 200  Read(5,'(A)') line
      Call Upcase(line)
      If(line(1:1).eq.'*') go to 200
      word=line(1:4)
      If (Word.eq.'   ') Word='END'
210   Continue
      Do 220 i=1,ntab
       ii=i
       if(word.ne.tabinp(i)) go to 220
       If (ii.eq.1) Then
         Goto 1
       Else If (ii.eq.2) Then
         Goto 2
       Else If (ii.eq.3) Then
         Goto 3
       Else If (ii.eq.4) Then
         Goto 4
       Else If (ii.eq.5) Then
         Goto 5
       Else If (ii.eq.6) Then
         Goto 6
       Else If (ii.eq.7) Then
         Goto 7
       Else If (ii.eq.8) Then
         Goto 8
       Else If (ii.eq.9) Then
         Goto 9
       Else If (ii.eq.10) Then
         Goto 10
       Else If (ii.eq.11) Then
         Goto 11
       Else If (ii.eq.12) Then
         Goto 12
       Else If (ii.eq.13) Then
         Goto 13
       Else If (ii.eq.14) Then
         Goto 14
       Else If (ii.eq.15) Then
         Goto 15
       Else If (ii.eq.16) Then
         Goto 16
       Else If (ii.eq.17) Then
         Goto 17
       Else If (ii.eq.18) Then
         Goto 18
       Else If (ii.eq.19) Then
         Goto 19
       Else If (ii.eq.20) Then
         Goto 20
       End If
220   Continue
      Write(6,*)
      Write(6,*)'******************************************'
      Write(6,*)' VIBINP Error: Input line not recognized. '
      Write(6,*)' Input line, in upper case:               '
      Write(6,'(a)') line
      Write(6,*)' Extracted keyword: ',word
      Write(6,*)'******************************************'
      Call Quit_OnUserError()
C
C Read title lines. Maximum 10 is allowed.
C
1     Read(5,'(a)') line
      word=line(1:4)
      Call Upcase(word)
      Do i=1,ntab
        If(word.eq.tabinp(i)) go to 210
      End Do
      If(ntit1.lt.10) then
        ntit1=ntit1+1
        Read(line,1000) Title1(ntit1)
      end if
      go to 1
C
C     Read isotope numbers
C     isn1 and isn2 are the isotope numbers for atoms 1 and 2,
C     Atom1 and Atom2 the corresponding chemical symbols
C     Masses are read from the next one/two lines if one/two
C     of the isotope numbers are negative.
C     Else the masses are obtained from the tables in ISOTOPE.
C     if isn=0 the mass for the most abundant isotope will be used
C
*2    Read(5,'(a)') line
*     If(line(1:1).eq.'*') go to 2
 2    Line=Get_Ln(LuIn)
      Call Upcase(line)
      ii=0
      ist=0
      Do 23 i=1,80
       If(line(i:i).eq.' ') go to 23
       If(i.lt.ist) go to 23
       ii=ii+1
       kk=0
       Do 21 k=i,80
        If(line(k:k).eq.' ') go to 22
        kk=kk+1
21     Continue
22     Continue
       ist=i+kk
       If (ii.eq.1) Then
*         Read(line(i:i+kk-1),*) isn1
          Call Get_I1(1,isn1)
       ElseIf (ii.eq.2) Then
*         Read(line(i:i+kk-1),'(A)') Atom1(1:kk)
          Call Get_S(2,Atom1(1:kk),1)
       ElseIf (ii.eq.3) Then
*         Read(line(i:i+kk-1),*) isn2
          Call Get_I1(3,isn2)
       ElseIf (ii.eq.4) Then
*         Read(line(i:i+kk-1),'(A)') Atom2(1:kk)
          Call Get_S(4,Atom2(1:kk),1)
          Go To 24
       End If
23    Continue
24    Continue
*     If(isn1.lt.0) Read(5,*) xMass1
*     If(isn2.lt.0) Read(5,*) xMass2
*     If(isn1.ge.0) Call Isotope(isn1,Atom1,xMass1)
*     If(isn2.ge.0) Call Isotope(isn2,Atom2,xMass2)
*...+....1....+....2....+....3....+....4....+....5....+....6....+....7....+....8
      Conv=CONV_AMU_TO_AU_
      If(Atom1.eq.'D') Then
         ich1=1
      Else If(Atom1.eq.'T') Then
         ich1=1
      Else
         ich1=iNuclearChargeFromSymbol(Atom1)
      End If
      If(isn1.eq.0) Then
         if(Atom1.eq.'D') Then
            isn1=2
         Else If(Atom1.eq.'T') Then
            isn1=3
         Else
            isn1=iMostAbundantIsotope(ich1)
         End If
         xMass1=dNuclearMass(ich1,isn1)
      Else If(isn1.gt.0) Then
         xMass1=dNuclearMass(ich1,isn1)
      Else
         Read(5,*) xMass1
         xMass1=Conv*xMass1
      End If
*
      If(Atom2.eq.'D') Then
         ich2=1
      Else If(Atom2.eq.'T') Then
         ich2=1
      Else
         ich2=iNuclearChargeFromSymbol(Atom2)
      End If
      If(isn2.eq.0) Then
         if(Atom2.eq.'D') Then
            isn2=2
         Else If(Atom2.eq.'T') Then
            isn2=3
         Else
            isn2=iMostAbundantIsotope(ich2)
         End If
         xMass2=dNuclearMass(ich2,isn2)
      Else If(isn2.gt.0) Then
         xMass2=dNuclearMass(ich2,isn2)
      Else
         Read(5,*) xMass2
         xMass2=Conv*xMass2
      End If
*
*
      Redm=xMass1*xMass2/(xMass1+xMass2)
      go to 200
C
C     Read number of grid points for numerical integration (max: npoint)
C
*3    Read(5,'(a)') line
*     Call Upcase(line)
*     If(line(1:1).eq.'*') go to 3
*     Read(line,*) ngrid
 3    Line=Get_Ln(LuIn)
      Call Get_I1(1,ngrid)
      If((ngrid/2)*2.eq.ngrid) ngrid=ngrid-1
C     ************************************** ngrid should be odd
      If(ngrid.ge.npoint) ngrid=npoint-1
      go to 200
C
C     Read upper and lower integration range in atomic units
C
*4    Read(5,'(a)') line
*     Call Upcase(line)
*     If(line(1:1).eq.'*') go to 4
*     Read(line,*) Rmin,Rmax
 4    Line=Get_Ln(LuIn)
      Call Get_F1(1,Rmin)
      Call Get_F1(2,RMax)
      Umin=log(Rmin)
      Umax=log(Rmax)
      go to 200
C
C     Read number of vibrational quantum numbers
C
*5    Read(5,'(a)') line
*     Call Upcase(line)
*     If(line(1:1).eq.'*') go to 5
*     Read(line,*) nvib
 5    Line=Get_Ln(LuIn)
      Call Get_I1(1,nvib)
      n0=0
      nvib1=nvib-1
      go to 200
C
C     Read range for rotational quantum numbers
C
*6    Read(5,'(a)') line
*     Call Upcase(line)
*     If(line(1:1).eq.'*') go to 6
*     Read(line,*) J1A,J2A
 6    Line=Get_Ln(LuIn)
      Call Get_I1(1,J1A)
      Call Get_I1(2,J2A)
      if(J2A.ge.nRot_Max) Then
        Write(6,*)
        Write(6,*)'********************************'
        Write(6,*)' VIBINP Error: J2A.gt.nRot_Max. '
        Write(6,'(1x,a,2i6)')'J2A:',J2A
        Write(6,*)'********************************'
        Call Quit_OnUserError()
      end if

      go to 200
C
C     Read orbital angular momentum quantum number
C
*7    Read(5,'(a)') line
*     Call Upcase(line)
*     If(line(1:1).eq.'*') go to 7
*     Read(line,*) lambda
 7    Line=Get_Ln(LuIn)
      Call Get_I1(1,lambda)
      go to 200
C
C     Read flag for spectroscopic constants
C
8     ispc=0
      go to 200
C
C     Read input for calculation of matrix elements of observables
C     like the dipole operator, etc.
C
9     Continue
      iobs=iobs+1
      iplot(iobs)=0
      If(iobs.gt.10) Then
        Write(6,*)
        Write(6,*)'***************************'
        Write(6,*)' VIBINP Error: IOBS.gt.10. '
        Write(6,'(1x,a,2i6)')'IOBS:',IOBS
        Write(6,*)'***************************'
        Call Quit_OnUserError()
      end if
cVV: make it really nasty. if it looks like a file - read from the file
c    else-  this is a title

      Read(LuIn,'(a)') Line
      Call f_inquire(Line(1:index(Line,' ')-1), exist)
      if(exist) then
        LuIn1=isFreeUnit(15)
        Call molcas_open(LuIn1,Line(1:index(Line,' ')-1))
        Line=Get_Ln(LuIn1)
      else
        LuIn1=LuIn
      endif
        Titobs(iobs)=Trim(Line)
*      write(6,*)' In VIBINP. IOBS=',IOBS
*      write(6,*)' TITOBS just read:'
*      write(6,'(a80)') TITOBS(IOBS)
      nobsi=0
 91   Line=Get_Ln_EOF(LuIn1)
      if(Line(1:3).eq.'EOF'.and.LuIn1.ne.LuIn) then
        close(LuIn1)
        Line=Get_Ln(LuIn)
      endif

      word=line(1:4)
      Call Upcase(word)
      Do 92 i=1,ntab
       If(word.eq.tabinp(i)) go to 210
92    Continue
      If(word.eq.'PLOT') go to 93
      nobsi=nobsi+1
      If(NOBSI.gt.NPIN) Then
        Write(6,*)
        Write(6,*)'**********************************'
        Write(6,*)' VIBINP Error: NOBSI.gt.NPIN      '
        Write(6,'(1x,a,2i6)')'NOBSI,NPIN:',NOBSI,NPIN
        Write(6,*)'**********************************'
        Call Quit_OnUserError()
      end if
      npobs(iobs)=nobsi
*     Read(line,*) RinO(nobsi,iobs),Obsin(nobsi,iobs)
      Call Get_F1(1,RinO(nobsi,iobs))
      Call Get_F1(2,Obsin(nobsi,iobs))
      go to 91
*93   Read(5,'(a)') line
 93   Line=Get_Ln(LuIn)
      If(line(1:1).eq.'*') go to  93
*     Read(line,*) R0o(iobs),R1o(iobs),dRo(iobs)
      Call Get_F1(1,R0o(iobs))
      Call Get_F1(2,R1o(iobs))
      Call Get_F1(3,dRo(iobs))
      iplot(iobs)=1
      go to 200
C
C     Read starting value for step size in eigenvalue search
C
 10   Line=Get_Ln(LuIn)
      Call Get_F1(1,dE0)
      go to 200
C
C     Read potential
C
11    Continue
      ipot=1
      nop=0
      Line=Get_Ln(LuIn)
      xxx=999.97
      Read(line,*,err=666) xxx
      If(xxx.eq.999.97) go to 666
      backspace(LuIn)
      Luin1=Luin
      go to 111
 666  call f_inquire(line,exist)
      write(6,*) line
      If(.not.exist) then
       write(6,*) 'File with potential non-existent'
       write(6,*) 'File=',line(:mylen(line))
       call Abend
      Endif
      LuIn1=isFreeUnit(15)
      Call molcas_open(LuIn1,line)
 111  Line=Get_Ln_EOF(LuIn1)
      if(Line(1:3).eq.'EOF'.and.LuIn1.ne.LuIn) then
        close(LuIn1)
        Line=Get_Ln(LuIn)
      endif
      word=line(1:4)
      Call Upcase(word)
      Do 112 i=1,ntab
      If(word.eq.tabinp(i)) go to 210
112   Continue
      If(word.eq.'PLOT') go to 113
      nop=nop+1
      If(NOP.gt.NPIN) Then
        Write(6,*)
        Write(6,*)'**********************************'
        Write(6,*)' VIBINP Error: NOP.gt.NPIN'
        Write(6,'(1x,a,2i6)')'NOP,NPIN:',NOP,NPIN
        Write(6,*)'**********************************'
        Call Quit_OnUserError()
      end if
*     Read(line,*) Rin(nop),Ein(nop)
      Call Get_F(1,Rin(nop),1)
      Call Get_F(2,Ein(nop),1)
      go to 111
c      if(Rin(1).gt.Rmax.or.Rin(nop).lt.Rmin) go to 900
*113  Read(5,'(a)') line
*     If(line(1:1).eq.'*') go to 113
*     Read(line,*) R0p,R1p,dRp
 113  Line=Get_Ln(LuIn)
      Call Get_F1(1,R0p)
      Call Get_F1(2,R1p)
      Call Get_F1(3,dRp)
      iplotp=1
      if(LuIn1.ne.LuIn) Close(Unit=LuIn1)
C
C
C     Calculation of ro-vibrational wave functions (ncase=1)
C
12    Continue
      ncase=1
      go to 200
C
C     Calculation of transition moments (ncase=2)
C
13    Continue
      ncase=2
      go to 200
C
C     Asymptotic energy difference between two potentials
C
14    Continue
*141  Read(5,'(a)') line
*     If(line(1:1).eq.'*') go to 141
*     Read(line,*) Teas
*141  Continue
      Line=Get_Ln(LuIn)
      Call Get_F1(1,Teas)
      go to 200
C
15    Continue
C Flag for printing the wave function.
      IFPRWF=1
      go to 200
C
16    Continue
C     Scaling of input potential such that the binding energy is 0.1 au.
      iscale=1
      go to 200
C
17    Continue
C     TEMPerature
C     Temperature for vibrational averaging
      Line=Get_Ln(LuIn)
      Call Get_F1(1,Temp)
      go to 200
C
18    Continue
C     ALLRotational

      iallrot=1
      go to 200
C
19    Continue
      go to 200
C
20    Continue
      if(J1A.lt.lambda) Then
        Write(6,*)
        Write(6,*)'********************************'
        Write(6,*)' VIBINP Warning: J1A.lt.Lambda. '
        Write(6,'(1x,a,2i6)')'J1A,Lambda:',J1A,Lambda
        Write(6,*)' J1A is now reset=Lambda.       '
        Write(6,*)'********************************'
      end if

      if(J2A.lt.J1A) Then
        Write(6,*)
        Write(6,*)'***************************'
        Write(6,*)' VIBINP Error: J2A.lt.J1A. '
        Write(6,'(1x,a,2i6)')'J2A,J1A:',J2A,J1A
        Write(6,*)'***************************'
        Call Quit_OnUserError()
      end if
C
C      Check for input error
C
       If(ncase.eq.1) Then
        If(Atom1.eq.'  '.or.Atom2.eq.'  ') Then
         Write(6,*)
         Write(6,*)'**********************************'
         Write(6,*)' VIBINP Error: No atoms in input.'
         Write(6,*)'**********************************'
         Call Quit_OnUserError()
        End If
       End If
C
C     Retrieve data from Vibwvs1 and Vibwvs2 (ncase=2)
C
      If(ncase.eq.2) then
       iadvi1=0
       Call iDafile(Vibwvs1,2,iad12,100,iadvi1)
       iOpt=2
       Call WR_VibRot_Info1(Vibwvs1,iOpt,iadvi1,
     &                      ntit1,J1A,J2A,lambda,n0,
     &                      nvib1,Redm,Umax,Umin,ngrid,
     &                      isn1,isn2,Req,xMass1,xMass2)
       Call cDaFile(Vibwvs1,iOpt,Title1,10*80,iadvi1)
       Call cDaFile(Vibwvs1,iOpt,IntCh,     8,iadvi1)
*
       Atom1=IntCh(1:2)
       Atom2=IntCh(5:6)
       Rmin=exp(Umin)
       Rmax=exp(Umax)
       iadvi2=0
       Call iDafile(Vibwvs2,2,iad13,100,iadvi2)
       iOpt=2
       Call WR_VibRot_Info1(Vibwvs2,iOpt,iadvi2,
     &                      ntit2,J1B,J2B,lambdx,n02,
     &                      nvib21,Redmx,Umaxx,Uminx,ngridx,
     &                      isn1x,isn2x,Reqx,xMass1,xMass2)
       Call cDaFile(Vibwvs2,iOpt,Title2,10*80,iadvi2)
       Call cDaFile(Vibwvs2,iOpt,IntCh,     8,iadvi2)
       At1x=IntCh(1:2)
       At2x=IntCh(5:6)
#if 0
       if(iadvi2.eq.-666) then
cvv
cvv   This if statement is a dummy!
cvv   to fake f90 under HP-UX64
cvv
       write(6,*)' isn', isn2
       write(6,*)' Mass', xMass1
       write(6,*)' Mass', xMass2
       write(6,*)' Title', Title2
       write(6,*)' IntCh', IntCh
       endif
#endif

C
C      Check for consistency of data on files
C
       IERR=0
       If(Atom1.ne.At1x.or.Atom2.ne.At2x) Then
         Write(6,*)
         Write(6,*)'***************************************'
         Write(6,*)' VIBINP Error: Inconsistent data.'
         Write(6,'(1x,a,1x,a,1x,a)')'ATOM1,AT1X:',ATOM1,AT1X
         IERR=1
       End If
       If(abs(Redm-Redmx).gt.1.d-06) Then
         Write(6,*)
         Write(6,*)'***************************************'
         Write(6,*)' VIBINP Error: REDM.ne.REDMX'
         Write(6,'(1x,a,2f16.6)')'REDM,REDMX:',REDM,REDMX
         IERR=1
       End If
       If(Umax.ne.Umaxx) Then
         Write(6,*)
         Write(6,*)'***************************************'
         Write(6,*)' VIBINP Error: UMAX.ne.UMAXX'
         Write(6,'(1x,a,2f16.6)')'UMAX,UMAXX:',UMAX,UMAXX
         IERR=1
       End If
       If(Umin.ne.Uminx) Then
         Write(6,*)
         Write(6,*)'***************************************'
         Write(6,*)' VIBINP Error: UMIN.ne.UMINX'
         Write(6,'(1x,a,2f16.6)')'UMIN,UMINX:',UMIN,UMINX
         IERR=1
       End If
       If(NGrid.ne.NGridx) Then
         Write(6,*)
         Write(6,*)'***************************************'
         Write(6,*)' VIBINP Error: NGrid.ne.NGridX'
         Write(6,'(1x,a,2i8)')'NGrid,NGridX:',NGrid,NGridX
         IERR=1
       End If
       If(Isn1.ne.Isn1x) Then
         Write(6,*)
         Write(6,*)'***************************************'
         Write(6,*)' VIBINP Error: Isn1.ne.Isn1X'
         Write(6,'(1x,a,2i8)')'Isn1,Isn1X:',Isn1,Isn1X
         IERR=1
       End If
       If(Isn2.ne.Isn2x) Then
         Write(6,*)
         Write(6,*)'***************************************'
         Write(6,*)' VIBINP Error: Isn2.ne.Isn2X'
         Write(6,'(1x,a,2i8)')'Isn2,Isn2X:',Isn2,Isn2X
         IERR=1
       End If
       If(IERR.NE.0) Then
         Write(6,*)'*****************************************'
         Write(6,*)' VIBINP: Irrecoverable errors.'
         Write(6,*)' Transition calculation, but data on the '
         Write(6,*)' two VibWvs files are not compatible.'
         Write(6,*)'*****************************************'
         Call Quit_OnUserError()
       End If
      Endif
C
C
C     Section for print output of input information
C
C
      ii=0
      Diatom=' '
      Diatomx(1:2)=Atom1
      Diatomx(3:4)=Atom2
      Do 110 i=1,4
       If(Diatomx(i:i).ne.' ') then
        ii=ii+1
        Diatom(ii:ii)=Diatomx(i:i)
       Endif
110   Continue
      If(ncase.eq.1) Write(6,1100) Diatom
1100  Format(/1x,'Vibration-Rotation spectrum for the ',A4,' molecule.')
      If(ncase.eq.2) Write(6,1101) Diatom
1101  Format(/1x,'Transition moments for the ',A4,' molecule.')
C
      If(ncase.eq.2) Write(6,1190)
1190  Format(/1x,'State number 1')
      Do i=1,ntit1
        Write(6,*) Title1(i)
      End Do
      Write(6,1200) J1A,J2A,lambda,n0,nvib1,
     *              isn1,Atom1,xMass1,isn2,Atom2,xMass2,Redm
1200  Format(/1x,'Rotational quantum number range ',2I3
     *       /1x,'Electronic angular momentum     ',I3
     *       /1x,'Vibrational quantum number range',2I3
     *       /1x,'Mass of atom ',I3,1x,A2,D15.6,' au'
     *       /1x,'Mass of atom ',I3,1x,A2,D15.6,' au'
     *       /1x,'Reduced mass       ',D15.6,' au')
      If(ncase.eq.2) then
       Write(6,1191)
1191   Format(/1x,'State number 2')
        Do i=1,ntit2
          Write(6,*) Title2(i)
        End Do
       Write(6,1201) J1B,J2B,lambdx,n02,nvib21,
     *              isn1,At1x,xMass1,isn2,At2x,xMass2,Redmx
1201   Format(/1x,'Rotational quantum number range ',2I3
     *        /1x,'Electronic angular momentum     ',I3
     *        /1x,'Vibrational quantum number range',2I3
     *        /1x,'Mass of atom ',I3,1x,A2,D15.6,' au'
     *        /1x,'Mass of atom ',I3,1x,A2,D15.6,' au'
     *        /1x,'Reduced mass       ',D15.6,' au')
      Endif
C
C     Numerical integration data
C
      del=(Umax-Umin)/(ngrid-1)
      Write(6,1300) ngrid,del,Rmin,Rmax,Umin,Umax
1300  Format(/1x,'Statistics for numerical integration'
     *       /1x,'Number of steps         ',I5
     *       /1x,'Step length             ',F10.6
     *       /1x,'Radial integration range',2F10.6,' au'
     *       /1x,'logarithmic range       ',2F10.6)
C
      If(ispc.eq.0.and.ncase.eq.1) Write(6,1400)
1400  Format(/1x,'Spectroscopic constants will not be computed')
      If(ispc.ne.0.and.ncase.eq.1) Write(6,1500)
1500  Format(/1x,'Spectroscopic constants will be computed')
      If(iobs.eq.0) Write(6,1600)
1600  Format(1x,'Matrix elements of operators will not be computed')
      If(iobs.ne.0) Write(6,1700) iobs
1700  Format(1x,'Matrix elements of',I3,' operators will be computed')
      If(ipot.eq.0.and.ncase.eq.1) Then
        Write(6,*)
        Write(6,*)'**********************************'
        Write(6,*)' VIBINP Error: IPOT=0 and NCASE=1 '
        Write(6,*)'**********************************'
        Call Quit_OnUserError()
      End If
C
C     Print input potential
C
      If(ipot.ne.0) then
       Write(6,1800)
1800   Format(/1x,'Potential read from input'/6x,' R(au)     E(au)')
       Do 30 i=1,nop
        Write(6,1810) Rin(i),Ein(i)
1810    Format(1x,2F12.6)
30     Continue
       if(Rin(1).gt.Rmax.or.Rin(nop).lt.Rmin) then
         Write(6,*)
         Write(6,*)'****************************'
         Write(6,*)' VIBINP Error: Potential is '
         Write(6,*)' not within defined range.  '
         Write(6,*)'****************************'
         Call Quit_OnUserError()
       endif
       If(iplotp.ne.0) write(6,1820)
1820   Format(1x,'A plot file of the potential will be generated')
      Endif
C
C     Compute radial coordinates
C
      U=Umin-del
      Rout0=exp(U)
      Do 300 i=1,ngrid
         U=U+del
         Rout(i)=exp(U)
300   Continue
      Rn1=exp(U+del)
      Rout(ngrid+1)=Rout0
      Rout(ngrid+2)=Rn1
      If(ipot.ne.0)
     *Call POT(Rin,Ein,Rout,PotR,ngrid+2,1,E0,Req,R0p,R1p,dRp,
     *          nop,Title1(1),iplotp,Redm,scale,0)
      iadvib=0
      If(ncase.eq.1) then
C Store data on Vibwvs (ncase=1)
         Call iDafile(Vibwvs,1,iad12,100,iadvib)
         iOpt=1
         Redm1=Redm*scale
         Call WR_VibRot_Info1(Vibwvs,iOpt,iadvib,
     &                        ntit1,J1A,J2A,lambda,n0,
     &                        nvib1,Redm1,Umax,Umin,ngrid,
     &                        Abs(isn1),Abs(isn2),Req,xMass1,xMass2)
         IntCh(1:4)=Atom1
         IntCh(5:8)=Atom2
         Call cDaFile(Vibwvs,iOpt,Title1,10*80,iadvib)
         Call cDaFile(Vibwvs,iOpt,IntCh,     8,iadvib)
      Endif

C Fit observable input
      Rout0=Rout(ngrid+1)
      Do 32 i=1,iobs
       Rout(ngrid+1)=Req
       Call POT(RinO(1,i),Obsin(1,i),Rout,EoutO(1,i),ngrid+1,2,O0,
     * Oeq,R0o(i),R1o(i),dRo(i),npobs(i),Titobs(i),iplot(i),Redm,scale,
     * iobs)
32    Continue
      Rout(ngrid+1)=Rout0
C
C     Print observable input data
C
      If(iobs.ne.0) then
       Write(6,1900)
1900   Format(/1x,'Input data for observables')
       Do 40 i=1,iobs,4
        Write(6,1910) (Titobs(k)(1:18),k=i,min(i+3,iobs))
1910    Format(/1x,4A24)
        l84=' '
        Do 35 k=i,min(i+3,iobs)
         l84(24*(k-i)+1:24*(k-i)+10)='     R(au)'
         l84(24*(k-i)+11:24*(k-i+1))='        Value '
35      Continue
        Write(6,'(a)') l84(:mylen(l84))
        Do 37 j=1,npin
         l84=' '
         Do 36 k=i,min(i+3,iobs)
          If(j.le.npobs(k))
     *    Write(l84(24*(k-i)+1:24*(k-i+1)),'(1x,F9.4,F14.6)')
     *          RinO(j,k),Obsin(j,k)
36       Continue
         If(l84.ne.' ') Write(6,'(a)') l84(:mylen(l84))
37      Continue
        l84=' '
        l84x=' '
        Do 38 k=i,min(i+3,iobs)
         If(iplot(i).ne.0)
     *   l84(24*(k-i)+1:24*(k-i)+14)='     Plot file'
         If(iplot(i).eq.0)
     *   l84(24*(k-i)+1:24*(k-i)+17)='     No plot file'
         Write(l84x(24*(k-i)+1:24*(k-i+1)),'(F10.4,F14.6)')
     *          Req,EoutO(ngrid+1,k)
38      Continue
         Write(6,'(A)') l84(:mylen(l84))
         Write(6,*)' Interpolated value at equilibrium for state 1:'
         Write(6,'(A)') l84x(:mylen(l84x))
40     Continue
      Endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Ci_Ci(ipcid,ips2)
      use ipPage, only: W
      use Arrays, only: FIMO, INT2
      Implicit Real*8(A-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
      Real*8 rDum(1)
*                                                                      *
************************************************************************
*                                                                      *
       Interface
       SubRoutine CISigma_sa(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,
     &                       Int2a,nInt2a,ipCI1,ipCI2, Have_2_el)
       Integer iispin, iCsym, iSSym
       Integer nInt1, nInt2s, nInt2a
       Real*8, Target:: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
       Integer ipCI1, ipCI2
       Logical Have_2_el
       End SubRoutine CISigma_sa
       End Interface
*                                                                      *
************************************************************************
*                                                                      *
      Call CISigma_sa(0,state_sym,state_sym,FIMO,SIZE(FIMO),
     &                Int2,SIZE(Int2),rDum,1,ipCId,ips2,.True.)
      irc=ipin(ipCId)
      irc=ipin(ipS2)
      Do i=0,nroots-1
         EC=(rin_ene+potnuc-ERASSCF(i+1))*Weight(i+1)
         Call Daxpy_(ncsf(State_Sym),EC,
     &               W(ipCId)%Vec(1+i*ncsf(state_sym)),1,
     &               W(ipS2)%Vec(1+i*ncsf(state_sym)),1)
      End Do
      Call DSCAL_(nroots*ncsf(state_SYM),2.0d0,W(ipS2)%Vec,1)
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PCM_Hss(Hess,nHss)
      use PCM_arrays
      Implicit real*8 (a-h,o-z)
#include "Molcas.fh"
#include "angstr.fh"
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "rctfld.fh"
#include "periodic_table.fh"
      Dimension Hess(nHss)
      Character*2 Elements(MxAtom*8)
*
      iRout = 1
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the PCM cavity contributions to Hessian in solution
*
*
*---- Retrieve atomic info
      Call Get_nAtoms_All(nAtoms)
      Call Allocate_Work(ipCoor,3*nAtoms)
      Call Get_Coord_All(Work(ipCoor),nAtoms)
      Call Get_Name_All(Elements)
      Call GetMem('ANr','Allo','Inte',ipANr,nAtoms)
      Do i = 1, nAtoms
         Do j = 0, Num_Elem
            If (PTab(j).eq.Elements(i)) iWork(ipANr+i-1)=j
         End Do
      End Do
      Call GetMem('Chrg','Allo','Real',ipChrg,nAtoms)
      Call Get_dArray('Nuclear charge',Work(ipChrg),nAtoms)
*
*----- Allocate space for electric field
      nComp=3
      Call GetMem('EF_n','Allo','Real',ip_EF_n,nComp*nTs)
      Call GetMem('EF_e','Allo','Real',ip_EF_e,nComp*nTs)
*
*----- Allocate space for the matrix derivative, total charges,
*      derivatives of charge, two temporary vectors with tesserae
*      dimensions, one vector for the derivative of the potential
*      on tesserae (with dim. nts*nat3),
*      then the PCM contribution to Hessian
      nAt3 = nAtoms * 3
      Call GetMem('DerMat','Allo','Real',ip_DerMat,nTs*nTs)
      Call GetMem('Qtot','Allo','Real',ip_Qtot,nTs)
      Call GetMem('Qder','Allo','Real',ip_Qder,nAt3*nTs)
      Call GetMem('Der1','Allo','Real',ip_Der1,nTs)
      Call GetMem('Der2','Allo','Real',ip_Der2,nTs)
      Call GetMem('VDer','Allo','Real',ip_VDer,nAt3*nTs)
      Call GetMem('HssPCM','Allo','Real',ip_HssPCM,nAt3*nAt3)

      Call PCM_Cav_Hss(Angstr,nAtoms,nAt3,nTs,nS,Eps,iWork(ipANr),
     &                 Work(ipCoor),Work(ipChrg),Work(ip_EF_n),
     &                 Work(ip_EF_e),PCMSph,PCMiSph,PCM_N,PCMTess,
     &                 PCM_SQ,Work(ip_Qtot),PCMDM,Work(ip_HssPCM),
     &                 Work(ip_DerMat),dTes,dPnt,dRad,dCntr,
     &                 Work(ip_QDer),Work(ip_Der1),Work(ip_Der2),
     &                 Work(ip_VDer))
      Call GetMem('HssPCM','Free','Real',ip_HssPCM,nHss)
      Call GetMem('DerMat','Free','Real',ip_DerMat,nTs*nTs)
      Call GetMem('Qtot','Free','Real',ip_Qtot,nTs)
      Call GetMem('Qder','Free','Real',ip_Qder,nAt3*nTs)
      Call GetMem('Der1','Free','Real',ip_Der1,nTs)
      Call GetMem('Der2','Free','Real',ip_Der2,nTs)
      Call GetMem('VDer','Free','Real',ip_VDer,nAt3*nTs)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Hess)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE get_Cm(IPCSF,IPCNF,
     &                  MXPDIM,NCONF,
     &                  NPCSF,NPCNF,
     &                  Cn,lrootSplit,EnFin,
     &                  DTOC,IPRODT,ICONF,
     &                  IREFSM,ONEBOD,ECORE,
     &                  NACTOB,NEL,NAEL,NBEL,
     &                  DIAG,TUVX,
     &                  NTEST,ExFac,IREOTS,
     &                  FordSplit,
     &                  Ctot)

************** Author : GLMJ *****************
C
C     Obtain Cm coefficients out of the AA Block for root = lrootSplit
C
C     ARGUMENTS :
C     ===========
C     IPCSF      : CSF's order - Index Array -                    (Input)
C     IPCNF      : CNF's order - Index Array -                    (Input)
C     MXPDIM     : Total number of CSFs                           (Input)
C     NCONF      : Total Number of CNFs of symmetry IREFSM        (Input)
C     NPCSF      : Number of CSFs in AA block                     (Input)
C     NPCNF      : Number of CNFs in AA block                     (Input)
C     Cn         : AA Block CI-Coefficients for root selected     (Input)
C     lRootSplit : computed root                                  (Input)
C     EnFin      : Final Energy for the root selected             (Input)
C     DTOC       : Transformation matrix between CSF's and DET's  (input)
C     IPRODT     : Prototype determinants                         (input)
C     ICONF      : List of configurations                         (input)
C     IREFSM     : symmetry of considered CI space                (input)
C     Onebod     : one body hamilton matrix in rectangular form   (input)
C     ECORE      : Core energy                                    (input)
C     NACTOB     : Number of active orbitals                      (input)
C     NEL        : total number of active electrons               (input)
C     NAEL       : number of alpha active electron                (input)
C     NBEL       : number of beta active electron                 (input)
C     DIAG       : Hamilton diagonal over CSFs                    (Input)
C     TUVX       : Two-electron integrals (MO space)
C     IREOTS     : Type => symmetry reordering array
C     Ctot       : Vector of all nConf CI-coeff for a single root (Output)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "spinfo.fh"
#include "WrkSpc.fh"

C
      DIMENSION Ctot(MXPDIM),Cn(NPCSF),IPCSF(MXPDIM),IPCNF(NCONF)
      DIMENSION DIAG(*)
      DIMENSION DTOC(*),IPRODT(*),ICONF(*)
      DIMENSION ONEBOD(*)
      DIMENSION TUVX(*), IREOTS(*)
      LOGICAL FordSplit


      IF( NTEST.GE.30 ) THEN
        WRITE(6,*) ' Input in get_Cm '
        WRITE(6,*) ' ================== '
        WRITE(6,*) ' Total Number of CNFs ',NCONF
        WRITE(6,*) ' Total Number of CSFs ',MXPDIM
        WRITE(6,*) ' CNFs included : '
        CALL IWRTMA(IPCNF,1,NCONF,1,NCONF)
        WRITE(6,*) ' CSFs included : '
        CALL IWRTMA(IPCSF,1,MXPDIM,1,MXPDIM)
        write(6,*) ' Number of CNFs in AA block:',NPCNF
        write(6,*) ' Number of CSFs in AA block:',NPCSF
        write(6,*)'Cn Coefficients'
        call wrtmat(Cn,NPCSF,1,NPCSF,1)
      END IF
************************************************************************
* get Cm coefficients corrected to the firts order                     *
* according to Lowdin's equations                                      *
************************************************************************
      If(FOrdSplit) then
        call get_Cm_(IPCSF,IPCNF,
     &               MXPDIM,NCONF,
     &               NPCSF,NPCNF,
     &               Cn,lrootSplit,EnFin,
     &               DTOC,IPRODT,ICONF,
     &               IREFSM,ONEBOD,ECORE,
     &               NACTOB,NEL,NAEL,NBEL,
     &               DIAG,TUVX,
     &               NTEST,ExFac,IREOTS,
     &               Ctot)
        Return
      End If

************************************************************************
* get Cm coefficients corrected to the zeroth order                    *
* according to Lowdin's equations                                      *
************************************************************************
      call Fzero(Ctot,MXPDIM)

      MXCSFC = 0
      DO ITYP = 1, NTYP
        MXCSFC = MAX(MXCSFC,NCSFTP(ITYP))
      END DO

      IBblockV = MXPDIM-NPCSF
      call getmem('AuxDia' ,'ALLO','REAL', ipAuxD,  MXCSFC)
      call getmem('AuxGa'  ,'ALLO','REAL',ipAuxGa,  MXCSFC)
      call getmem('AuxGaTi','ALLO','REAL',ipAuxGaTi,MXCSFC)
      call getmem('AuxVer' ,'ALLO','REAL',ipAuxV,   MXCSFC*NPCSF)
      CALL GETMEM('EXHSCR','MAX','REAL',LW2,MXXWS)
      CALL GETMEM('EXHSCR','ALLO','REAL',LW2,MXXWS)

      KACONF = LW2
      KLCONF = KACONF+NEL
      KLAUXD = KLCONF+NEL
      KLFREE = KLAUXD+MXCSFC*MXCSFC

C Shape of matrix:
C
C           CNFL (n)
C
C      1  2  4  7 11 16 22 ...
C  C   -  3  5  8 12 17 23 ...
C  N   -  -  6  9 13 18 24 ...
C  F   -  -  - 10 14 19 25 ...
C  R   -  -  -  - 15 20 26 ...
C (m)  -  -  -  -  - 21 27 ...
C      -  -  -  -  -  - 28 ...
C      -  -  -  -  -  -  - ...
C
C Splitting:
C
C          |
C     AA   |   AB
C  --------|--------
C     BA   |   BB
C          |

      call cwtime(C_AlphaLoop1,W_AlphaLoop1)
      C_ComputeH_AB = 0.0d0
      W_ComputeH_AB = 0.0d0
      C_ComputeH_BB = 0.0d0
      W_ComputeH_BB = 0.0d0
      C_Oper = 0.0d0
      W_Oper = 0.0d0

      IIAB = 1
      Do iAlpha = NPCNF+1,NCONF
C       Call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
        call cwtime(C_computeH_AB1,W_computeH_AB1)
        IF( NTEST.GE.30 )  write(6,*)'iAlpha = ', iAlpha
        iKACONF=ip_of_iWork_d(Work(KACONF))
        CALL GETCNF_LUCIA(iWork(iKACONF),IATYP,IPCNF(iAlpha),
     &                    ICONF,IREFSM,NEL)
        NCSFA = NCSFTP(IATYP)
        IF( NTEST.GE.30 ) write(6,*)'NCSFA = ', NCSFA
************************************************************************
*                        BB-Block DIAGONAL Elements                    *
************************************************************************
        iKACONF=ip_of_iWork_d(Work(KACONF))
        CALL CNHCN(iWork(iKACONF),IATYP,iWork(iKACONF),
     &             IATYP,Work(KLAUXD),Work(KLFREE),
     &             NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,
     &             NTEST,ExFac,IREOTS)
        IF( NTEST.GE.30 ) then
          write(6,*)'Alpha_Alpha elements in BB-block'
          call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
        end if
        DO IIA = 1, NCSFA
          ILAI = IIA*IIA
          Work(ipAuxD+IIA-1) = Work(KLAUXD+ILAI-1)
*         Write(6,*)'ILAI =', ILAI
          IF( NTEST.GE.30 ) then
            write(6,*) 'Work(ipAuxD+IIA-1)',Work(ipAuxD+IIA-1)
          end if
        END DO

        IILB = 1
        do Mindex = 1, NPCNF
*       ^ Loop over AB-Block
C         Call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
          IF( NTEST.GE.30 ) then
            write(6,*)'Mindex in AB-Block',Mindex
          End if
          iKLCONF=ip_of_iWork_d(Work(KLCONF))
          CALL GETCNF_LUCIA(iWork(iKLCONF),ILTYP,IPCNF(Mindex),
     &                      ICONF,IREFSM,NEL)
          NCSFL = NCSFTP(ILTYP)
          IF( NTEST.GE.30 ) write(6,*)'NCSFL = ', NCSFL
          iKACONF=ip_of_iWork_d(Work(KACONF))
          iKLCONF=ip_of_iWork_d(Work(KLCONF))
          CALL CNHCN(iWork(iKACONF),IATYP,iWork(iKLCONF),
     &               ILTYP,Work(KLAUXD),Work(KLFREE),
     &               NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,
     &               NTEST,ExFac,IREOTS)
          IF( NTEST.GE.30 ) then
            write(6,*)'M_Alpha elements'
            call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
          End if
          DO IIA = 1, NCSFA
            DO IIL = 1, NCSFL
              IILACT = IILB-1+IIL
              IIAACT = NPCSF*(IIA-1)
              ILAI = (IIL-1)*NCSFA+IIA
*              ILAI = (IIA-1)*MXCSFC+IIL
              ILAOV = IILACT+IIAACT
              Work(ipAuxV+ILAOV-1) = Work(KLAUXD+ILAI-1)
              IF( NTEST.GE.30 ) then
                Write(6,*)'ILAI, ILAOV =', ILAI,ILAOV
                write(6,*) 'Work(ipAuxV+ILAOV-1)',Work(ipAuxV+ILAOV-1)
              END IF
            END DO
          END DO
          IILB = IILB + NCSFL
        end do
*       ^ End loop over AB-Block
        call cwtime(C_computeH_AB2,W_computeH_AB2)
        C_ComputeH_AB = C_ComputeH_AB + C_computeH_AB2 - C_computeH_AB1
        W_ComputeH_AB = W_ComputeH_AB + W_computeH_AB2 - W_computeH_AB1

        IF( NTEST.GE.30 )  then
          write(6,*)'AB-Block Vertical Vector'
          call wrtmat(Work(ipAuxV),NPCSF,NCSFA,NPCSF,NCSFA)
        end if

************************************************************************
*    Compute:                                                          *
*    1.  G_Alpha_tilde                                                 *
*    2.  G_Alpha                                                       *
************************************************************************
        call cwtime(C_oper1,W_oper1)
        do IIA = 1,NCSFA
          Work(ipAuxGaTi+IIA-1) =
     &      ddot_(NPCSF,Work(ipAuxV+(IIA-1)*NPCSF),1,Cn,1)
          Work(ipAuxGa+IIA-1) =
     &      Work(ipAuxGaTi+IIA-1)/(EnFin-Work(ipAuxD+IIA-1))
          IF( NTEST.GE.30 ) then
            write(6,*) 'Work(ipAuxGaTi+IIA-1)',Work(ipAuxGaTi+IIA-1)
            write(6,*) 'Work(ipAuxGa  +IIA-1)',Work(ipAuxGa  +IIA-1)
          end if
        end do
        call cwtime(C_oper2,W_oper2)
        C_oper = C_oper + C_oper2 - C_oper1
        W_oper = W_oper + W_oper2 - W_oper1

        do IIA = 1, NCSFA
          Ctot(NPCSF+IIAB+IIA-1)=
     &           Ctot(NPCSF+IIAB+IIA-1)+ Work(ipAuxGa+IIA-1)
          IF( NTEST.GE.30 ) then
            write(6,*)'Ctot '
            call wrtmat(Ctot,MXPDIM,1,MXPDIM,1)
          end if
        end do
        call cwtime(C_oper2,W_oper2)
        C_oper = C_oper + C_oper2 - C_oper1
        W_oper = W_oper + W_oper2 - W_oper1

        IIAB = IIAB + NCSFA
      End Do
*     ^ End of the loop over iAlpha
      IF( NTEST.GE.30 ) then
       call cwtime(C_AlphaLoop2,W_AlphaLoop2)
       write(6,*) 'Total time needed to get_Cm in Alpha Loop'
       write(6,*) 'CPU timing : ', C_AlphaLoop2 - C_AlphaLoop1
       write(6,*) 'W. timing  : ', W_AlphaLoop2 - W_AlphaLoop1

       write(6,*) 'Total time to read H_AB :'
       write(6,*) 'CPU timing : ', C_ComputeH_AB
       write(6,*) 'W. timing  : ', W_ComputeH_AB

       write(6,*) 'Total time to calculate (ddot+dscal+daxpy) :'
       write(6,*) 'CPU timing : ', C_Oper
       write(6,*) 'W. timing  : ', W_Oper
      end if
      call dcopy_(NPCSF,Cn,1,Ctot,1)
      IF( NTEST.GE.30 ) then
        write(6,*)'final Ctot vector'
        call wrtmat(Ctot,MXPDIM,1,MXPDIM,1)
      end if
      CALL GETMEM('EXHSCR','FREE','REAL',LW2,MXXWS)
      call getmem('AuxVer' ,'FREE','REAL',ipAuxV,   MXCSFC*NPCSF)
      call getmem('AuxGaTi','FREE','REAL',ipAuxGaTi,MXCSFC)
      call getmem('AuxGa'  ,'FREE','REAL',ipAuxGa,  MXCSFC)
      call getmem('AuxDia' ,'FREE','REAL', ipAuxD,  MXCSFC)

      RETURN
      END

      SUBROUTINE get_Cm_(IPCSF,IPCNF,
     &                   MXPDIM,NCONF,
     &                   NPCSF,NPCNF,
     &                   Cn,lrootSplit,EnFin,
     &                   DTOC,IPRODT,ICONF,
     &                   IREFSM,ONEBOD,ECORE,
     &                   NACTOB,NEL,NAEL,NBEL,
     &                   DIAG,TUVX,
     &                   NTEST,ExFac,IREOTS,
     &                   Ctot)
C
C     Obtain Cm coefficients out of the AA Block for root = lrootSplit
C     to the first order in Lowdin equation
C
C     ARGUMENTS :
C     ===========
C     IPCSF      : CSF's order - Index Array -                    (Input)
C     IPCNF      : CNF's order - Index Array -                    (Input)
C     MXPDIM     : Total number of CSFs                           (Input)
C     NCONF      : Total Number of CNFs of symmetry IREFSM        (Input)
C     NPCSF      : Number of CSFs in AA block                     (Input)
C     NPCNF      : Number of CNFs in AA block                     (Input)
C     Cn         : AA Block CI-Coefficients for root selected     (Input)
C     lRootSplit : computed root                                  (Input)
C     EnFin      : Final Energy for the root selected             (Input)
C     DTOC       : Transformation matrix between CSF's and DET's  (input)
C     IPRODT     : Prototype determinants                         (input)
C     ICONF      : List of configurations                         (input)
C     IREFSM     : symmetry of considered CI space                (input)
C     Onebod     : one body hamilton matrix in rectangular form   (input)
C     ECORE      : Core energy                                    (input)
C     NACTOB     : Number of active orbitals                      (input)
C     NEL        : total number of active electrons               (input)
C     NAEL       : number of alpha active electron                (input)
C     NBEL       : number of beta active electron                 (input)
C     DIAG       : Hamilton diagonal over CSFs                    (Input)
C     TUVX       : Two-electron integrals (MO space)
C     IREOTS     : Type => symmetry reordering array
C     Ctot       : Vector of all nConf CI-coeff for a single root (Output)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "spinfo.fh"
#include "WrkSpc.fh"

C
      DIMENSION Ctot(MXPDIM),Cn(NPCSF),IPCSF(MXPDIM),IPCNF(NCONF)
      DIMENSION DIAG(*)
      DIMENSION DTOC(*),IPRODT(*),ICONF(*)
      DIMENSION ONEBOD(*)
      DIMENSION TUVX(*), IREOTS(*)


      IF( NTEST.GE.30 ) THEN
        WRITE(6,*) ' Input in get_Cm '
        WRITE(6,*) ' ================== '
        WRITE(6,*) ' Total Number of CNFs ',NCONF
        WRITE(6,*) ' Total Number of CSFs ',MXPDIM
        WRITE(6,*) ' CNFs included : '
        CALL IWRTMA(IPCNF,1,NCONF,1,NCONF)
        WRITE(6,*) ' CSFs included : '
        CALL IWRTMA(IPCSF,1,MXPDIM,1,MXPDIM)
        write(6,*) ' Number of CNFs in AA block:',NPCNF
        write(6,*) ' Number of CSFs in AA block:',NPCSF
        write(6,*)'Cn Coefficients'
        call wrtmat(Cn,NPCSF,1,NPCSF,1)
      END IF

      call Fzero(Ctot,MXPDIM)

      MXCSFC = 0
      DO ITYP = 1, NTYP
        MXCSFC = MAX(MXCSFC,NCSFTP(ITYP))
      END DO

      IBblockV = MXPDIM-NPCSF
      call getmem('AuxDia' ,'ALLO','REAL', ipAuxD,  MXCSFC)
      call getmem('AuxGa'  ,'ALLO','REAL',ipAuxGa,  MXCSFC)
      call getmem('AuxGaTi','ALLO','REAL',ipAuxGaTi,MXCSFC)
      call getmem('AuxVer' ,'ALLO','REAL',ipAuxV,   MXCSFC*NPCSF)
      call getmem('AuxBB'  ,'ALLO','REAL',ipAuxBB,  MXCSFC*IBblockV)
      CALL GETMEM('EXHSCR','MAX','REAL',LW2,MXXWS)
      CALL GETMEM('EXHSCR','ALLO','REAL',LW2,MXXWS)

      KACONF = LW2
      KLCONF = KACONF+NEL
      KLAUXD = KLCONF+NEL
      KLFREE = KLAUXD+MXCSFC*MXCSFC

C Shape of matrix:
C
C           CNFL (n)
C
C      1  2  4  7 11 16 22 ...
C  C   -  3  5  8 12 17 23 ...
C  N   -  -  6  9 13 18 24 ...
C  F   -  -  - 10 14 19 25 ...
C  R   -  -  -  - 15 20 26 ...
C (m)  -  -  -  -  - 21 27 ...
C      -  -  -  -  -  - 28 ...
C      -  -  -  -  -  -  - ...
C
C Splitting:
C
C          |
C     AA   |   AB
C  --------|--------
C     BA   |   BB
C          |

      call cwtime(C_AlphaLoop1,W_AlphaLoop1)
      C_ComputeH_AB = 0.0d0
      W_ComputeH_AB = 0.0d0
      C_ComputeH_BB = 0.0d0
      W_ComputeH_BB = 0.0d0
      C_Oper = 0.0d0
      W_Oper = 0.0d0

      IIAB = 1
      Do iAlpha = NPCNF+1,NCONF
C       Call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
        call cwtime(C_computeH_AB1,W_computeH_AB1)
        IF( NTEST.GE.30 )  write(6,*)'iAlpha = ', iAlpha
        iKACONF=ip_of_iWork_d(Work(KACONF))
        CALL GETCNF_LUCIA(iWork(iKACONF),IATYP,IPCNF(iAlpha),
     &                    ICONF,IREFSM,NEL)
        NCSFA = NCSFTP(IATYP)
        IF( NTEST.GE.30 ) write(6,*)'NCSFA = ', NCSFA
************************************************************************
*                        BB-Block DIAGONAL Elements                    *
************************************************************************
        iKACONF=ip_of_iWork_d(Work(KACONF))
        CALL CNHCN(iWork(iKACONF),IATYP,iWork(iKACONF),
     &             IATYP,Work(KLAUXD),Work(KLFREE),
     &             NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,
     &             NTEST,ExFac,IREOTS)
        IF( NTEST.GE.30 ) then
          write(6,*)'Alpha_Alpha elements in BB-block'
          call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
        end if
        DO IIA = 1, NCSFA
          ILAI = IIA*IIA
          Work(ipAuxD+IIA-1) = Work(KLAUXD+ILAI-1)
*         Write(6,*)'ILAI =', ILAI
          IF( NTEST.GE.30 ) then
            write(6,*) 'Work(ipAuxD+IIA-1)',Work(ipAuxD+IIA-1)
          end if
        END DO

        IILB = 1
        do Mindex = 1, NPCNF
*       ^ Loop over AB-Block
C         Call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
          IF( NTEST.GE.30 ) then
            write(6,*)'Mindex in AB-Block',Mindex
          End if
          iKLCONF=ip_of_iWork_d(Work(KLCONF))
          CALL GETCNF_LUCIA(iWork(iKLCONF),ILTYP,IPCNF(Mindex),
     &                      ICONF,IREFSM,NEL)
          NCSFL = NCSFTP(ILTYP)
          IF( NTEST.GE.30 ) write(6,*)'NCSFL = ', NCSFL
          iKACONF=ip_of_iWork_d(Work(KACONF))
          iKLCONF=ip_of_iWork_d(Work(KLCONF))
          CALL CNHCN(iWork(iKACONF),IATYP,iWork(iKLCONF),
     &               ILTYP,Work(KLAUXD),Work(KLFREE),
     &               NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,
     &               NTEST,ExFac,IREOTS)
          IF( NTEST.GE.30 ) then
            write(6,*)'M_Alpha elements'
            call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
          End if
          DO IIA = 1, NCSFA
            DO IIL = 1, NCSFL
              IILACT = IILB-1+IIL
              IIAACT = NPCSF*(IIA-1)
              ILAI = (IIL-1)*NCSFA+IIA
*              ILAI = (IIA-1)*MXCSFC+IIL
              ILAOV = IILACT+IIAACT
              Work(ipAuxV+ILAOV-1) = Work(KLAUXD+ILAI-1)
              IF( NTEST.GE.30 ) then
                Write(6,*)'ILAI, ILAOV =', ILAI,ILAOV
                write(6,*) 'Work(ipAuxV+ILAOV-1)',Work(ipAuxV+ILAOV-1)
              END IF
            END DO
          END DO
          IILB = IILB + NCSFL
        end do
*       ^ End loop over AB-Block
        call cwtime(C_computeH_AB2,W_computeH_AB2)
        C_ComputeH_AB = C_ComputeH_AB + C_computeH_AB2 - C_computeH_AB1
        W_ComputeH_AB = W_ComputeH_AB + W_computeH_AB2 - W_computeH_AB1

        IF( NTEST.GE.30 )  then
          write(6,*)'AB-Block Vertical Vector'
          call wrtmat(Work(ipAuxV),NPCSF,NCSFA,NPCSF,NCSFA)
        end if

************************************************************************
*    Compute:                                                          *
*    1.  G_Alpha_tilde                                                 *
*    2.  G_Alpha                                                       *
************************************************************************
        call cwtime(C_oper1,W_oper1)
        do IIA = 1,NCSFA
          Work(ipAuxGaTi+IIA-1) =
     &      ddot_(NPCSF,Work(ipAuxV+(IIA-1)*NPCSF),1,Cn,1)
          Work(ipAuxGa+IIA-1) =
     &      Work(ipAuxGaTi+IIA-1)/(EnFin-Work(ipAuxD+IIA-1))
          IF( NTEST.GE.30 ) then
            write(6,*) 'Work(ipAuxGaTi+IIA-1)',Work(ipAuxGaTi+IIA-1)
            write(6,*) 'Work(ipAuxGa  +IIA-1)',Work(ipAuxGa  +IIA-1)
          end if
        end do
        call cwtime(C_oper2,W_oper2)
        C_oper = C_oper + C_oper2 - C_oper1
        W_oper = W_oper + W_oper2 - W_oper1

************************************************************************
*  Loop over BB block to get the first order correction to Cm.         *
*  If not required by the USER (by using a keyword) it will be skipped!*
************************************************************************

        xmaxGaTi = 0.0d0
        do IIA = 1, NCSFA
          xmaxGaTi = MAX(xmaxGaTi,abs(Work(ipAuxGaTi+IIA-1)))
        end do
        if(xmaxGaTi.ge.1.0d-12) then
*       ^ let's try this trick to make SplitCAS faster!
          call cwtime(C_computeH_BB1,W_computeH_BB1)
          call Fzero(Work(ipAuxBB),MXCSFC*IBblockV)
          IILB = 1
          do Mindex = NPCNF+1, NCONF
*         ^ Loop over BB-Block
C           Call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
*           IF( NTEST.GE.30 ) write(6,*)'Mindex in BB-Block',Mindex
            iKLCONF=ip_of_iWork_d(Work(KLCONF))
            CALL GETCNF_LUCIA(iWork(iKLCONF),ILTYP,IPCNF(Mindex),
     &                        ICONF,IREFSM,NEL)
            NCSFL = NCSFTP(ILTYP)
*           IF( NTEST.GE.30 ) write(6,*)'NCSFL = ', NCSFL
            iKACONF=ip_of_iWork_d(Work(KACONF))
            iKLCONF=ip_of_iWork_d(Work(KLCONF))
            CALL CNHCN(iWork(iKACONF),IATYP,iWork(iKLCONF),
     &                 ILTYP,Work(KLAUXD),Work(KLFREE),
     &                 NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,
     &                 NTEST,ExFac,IREOTS)
*           IF( NTEST.GE.30 ) then
*             write(6,*)'M_Alpha elements in BB-block'
*             call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
*           end if
            DO IIA = 1, NCSFA
              DO IIL = 1, NCSFL
                IILACT = IILB-1+IIL
*               IIAACT = NPCSF*(IIA-1)
                IIAACT = iBblockV*(IIA-1)
                ILAI = (IIL-1)*NCSFA+IIA
*               ILAI = (IIA-1)*MXCSFC+IIL
                ILAOV = IILACT+IIAACT
                Work(ipAuxBB+ILAOV-1) = Work(KLAUXD+ILAI-1)
                if(iAlpha.eq.Mindex.and.IIA.eq.IIL) then
*                 write(6,*)'iAlpha, IIAB', iAlpha, IIAB
                  Work(ipAuxBB+ILAOV-1)=0.0d0
                end if
*               Write(6,*)'ILAI, ILAOV =', ILAI,ILAOV
*               IF( NTEST.GE.30 ) then
*                 write(6,*) 'Work(ipAuxBB+ILAOV-1)',Work(ipAuxBB+ILAOV-1)
*               END IF
              END DO
            END DO
            IILB = IILB + NCSFL
          end do
*         ^ End Loop over BB-Block
*         IF( NTEST.GE.30 ) then
*           write(6,*)'BB-Block Vertical Vector'
*           call wrtmat(Work(ipAuxBB),iBblockV,NCSFA,iBblockV,NCSFA)
*         end if
          call cwtime(C_computeH_BB2,W_computeH_BB2)
          C_ComputeH_BB= C_ComputeH_BB + C_computeH_BB2 - C_computeH_BB1
          W_ComputeH_BB= W_ComputeH_BB + W_computeH_BB2 - W_computeH_BB1

          call cwtime(C_oper1,W_oper1)
          do IIA = 1, NCSFA
            call dscal_(iBblockV,Work(ipAuxGa + IIA-1),
     &                          Work(ipAuxBB +(IIA-1)*iBblockV),1)
            IF( NTEST.GE.30 ) then
              write(6,*)'BB-Block Vertical Vector times Ga'
              call wrtmat(Work(ipAuxBB),iBblockV,NCSFA,iBblockV,NCSFA)
            end if
           call daxpy_(iBblockV,1.0d0,Work(ipAuxBB +(IIA-1)*iBblockV),1,
     &                                Ctot(NPCSF+1),1)
            IF( NTEST.GE.30 ) then
              write(6,*)'Ctot correction'
              call wrtmat(Ctot,MXPDIM,1,MXPDIM,1)
            end if
          end do
        end if
*       ^ End of trick to make SplitCAS faster

        do IIA = 1, NCSFA
          Ctot(NPCSF+IIAB+IIA-1)=
     &           Ctot(NPCSF+IIAB+IIA-1)+ Work(ipAuxGaTi+IIA-1)
          IF( NTEST.GE.30 ) then
            write(6,*)'Ctot '
            call wrtmat(Ctot,MXPDIM,1,MXPDIM,1)
          end if
        end do
        call cwtime(C_oper2,W_oper2)
        C_oper = C_oper + C_oper2 - C_oper1
        W_oper = W_oper + W_oper2 - W_oper1

        IIAB = IIAB + NCSFA
      End Do
*     ^ End of the loop over iAlpha
      IF( NTEST.GE.30 ) THEN
        call cwtime(C_AlphaLoop2,W_AlphaLoop2)
        write(6,*) 'Total time needed to get_Cm in Alpha Loop'
        write(6,*) 'CPU timing : ', C_AlphaLoop2 - C_AlphaLoop1
        write(6,*) 'W. timing  : ', W_AlphaLoop2 - W_AlphaLoop1

        write(6,*) 'Total time to read H_AB :'
        write(6,*) 'CPU timing : ', C_ComputeH_AB
        write(6,*) 'W. timing  : ', W_ComputeH_AB

        write(6,*) 'Total time to read H_BB :'
        write(6,*) 'CPU timing : ', C_ComputeH_BB
        write(6,*) 'W. timing  : ', W_ComputeH_BB

        write(6,*) 'Total time to calculate (ddot+dscal+daxpy) :'
        write(6,*) 'CPU timing : ', C_Oper
        write(6,*) 'W. timing  : ', W_Oper
      END IF

      call cwtime(C_last1,W_last1)
      IIAB = 1
      Do Mindex = NPCNF+1,NCONF
C       Call FZero(Work(KLAUXD),MXCSFC*MXCSFC)
        IF( NTEST.GE.30 ) write(6,*)'Mindex last do loop = ', Mindex
        iKACONF=ip_of_iWork_d(Work(KACONF))
        CALL GETCNF_LUCIA(iWork(iKACONF),IATYP,IPCNF(Mindex),
     &                    ICONF,IREFSM,NEL)
        NCSFA = NCSFTP(IATYP)
        IF( NTEST.GE.30 ) write(6,*)'NCSFA = ', NCSFA
        iKACONF=ip_of_iWork_d(Work(KACONF))
        CALL CNHCN(iWork(iKACONF),IATYP,iWork(iKACONF),
     &             IATYP,Work(KLAUXD),Work(KLFREE),
     &             NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,
     &             NTEST,ExFac,IREOTS)
        IF( NTEST.GE.30 ) then
          write(6,*)'Alpha_Alpha elements in BB-block'
          call wrtmat(Work(KLAUXD),MXCSFC,MXCSFC,MXCSFC,MXCSFC)
        END IF
        DO IIA = 1, NCSFA
          ILAI = IIA*IIA
*         Work(ipAuxD+IIA-1) = Work(KLAUXD+ILAI-1)
          IF( NTEST.GE.30 ) then
            write(6,*)'Work(KLAUXD+ILAI-1)', Work(KLAUXD+ILAI-1)
          END IF
*         Work(ipAuxD+IIA-1) = 1/(EnFin-Work(KLAUXD+ILAI-1))
          Ctot(NPCSF+IIAB+IIA-1) = Ctot(NPCSF+IIAB+IIA-1)/
     &                                  (EnFin-Work(KLAUXD+ILAI-1))
        END DO
        IIAB = IIAB +NCSFA
      End Do
      IF( NTEST.GE.30 ) then
        call cwtime(C_last2,W_last2)
        write(6,*) 'Time last iteration over Hbb :'
        write(6,*) 'CPU timing : ', C_last2 - C_last1
        write(6,*) 'W. timing  : ', W_last2 - W_last1
      END IF

      call dcopy_(NPCSF,Cn,1,Ctot,1)
      IF( NTEST.GE.30 ) then
        write(6,*)'final Ctot vector'
        call wrtmat(Ctot,MXPDIM,1,MXPDIM,1)
      end if
      CALL GETMEM('EXHSCR','FREE','REAL',LW2,MXXWS)
      call getmem('AuxBB'  ,'FREE','REAL',ipAuxBB,  MXCSFC*IBblockV)
      call getmem('AuxVer' ,'FREE','REAL',ipAuxV,   MXCSFC*NPCSF)
      call getmem('AuxGaTi','FREE','REAL',ipAuxGaTi,MXCSFC)
      call getmem('AuxGa'  ,'FREE','REAL',ipAuxGa,  MXCSFC)
      call getmem('AuxDia' ,'FREE','REAL', ipAuxD,  MXCSFC)

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(lrootsPlit)
        CALL Unused_real_array(DIAG)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2006  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MKDREF_RPT2(N,G1,DREF)
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: N
      REAL*8, INTENT(IN) :: G1(N,N)
      REAL*8, INTENT(OUT) :: DREF(*)

      INTEGER I,J,IJ

C Compute DREF(PQ) = <0| Epq |0>
C from G1(P,Q) = <0| Epq |0>
C Storage differs: DREF is triangular.

      DO I=1,N
       DO J=1,I
        IJ=(I*(I-1))/2+J
        DREF(IJ)=G1(I,J)
       END DO
      END DO

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine Flip_Flop(Primitive)
       use Basis_Info
       use Sizes_of_Seward, only:S
       Implicit Real*8 (a-h,o-z)
       Logical Primitive
#include "stdalloc.fh"
#include "Basis_Mode.fh"
*
      S%MaxBas(:)=0
      S%MaxPrm(:)=0
*
      Do iCnttp = 1, nCnttp
         nTest = dbsc(iCnttp)%nVal-1
         If (Shells(iCnttp)%Aux .and.
     &       iCnttp.eq.iCnttp_Dummy) nTest=-1
*        Do iCnt = 1, dbsc(iCnttp)%nCntr
*
            Do iAng=0, S%iAngMx
               If (iAng.gt.nTest)  Cycle
               iShll = dbsc(iCnttp)%iVal + iAng
               nExpi=Shells(iShll)%nExp
               If (nExpi.eq.0)   Cycle
               If (Shells(iShll)%nBasis_C.eq.0) Cycle
*
*              Decontract only the ordinary basis sets!
*
               Call mma_deallocate(Shells(iShll)%pCff)
               If (Primitive.and..Not.Shells(iShll)%Aux
     &                      .and..Not.Shells(iShll)%Frag) Then
                  Shells(iShll)%nBasis=nExpi
                  Call mma_allocate(Shells(iShll)%pCff,nExpi,
     &                              Shells(iShll)%nBasis,Label='pCff')
                  Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_p(:,:,1)
               Else
                  Shells(iShll)%nBasis=Shells(iShll)%nBasis_C
                  Call mma_allocate(Shells(iShll)%pCff,nExpi,
     &                              Shells(iShll)%nBasis,Label='pCff')
                  Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)
               End If
               S%MaxPrm(iAng) = Max(S%MaxPrm(iAng),nExpi)
               S%MaxBas(iAng) = Max(S%MaxBas(iAng),Shells(iShll)%nBasis)
*
            End Do ! iAng
*        End Do    ! iCnt
      End Do       ! iCnttp
*
      Return
      End
!#define _USE_CHECK_CFF_
#ifdef  _USE_CHECK_CFF_
      Subroutine Check_cff(Label)
      Use Basis_Info
      Character*(*) Label
      Write(6,*) Label
      Do i = 1, 30
         Write (6,*) i,
     &               Shells(i)%nExp, Shells(i)%nBasis,
     &               Allocated(Shells(i)%pCff),
     &               Allocated(Shells(i)%Cff_c),
     &               Allocated(Shells(i)%Cff_p)
      End Do
      Return
      End Subroutine Check_cff
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Martin Schuetz                                         *
!               2017, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ErrV(lvec,ivec,QNRstp,ErrVec)
!***********************************************************************
!                                                                      *
!     computes error vector for DIIS, in 1st order case, this          *
!     is just grad(ivec): in 2nd order case (QNRstp == .true.)         *
!     this is -H(iterso)*grad(ivec)                                    *
!     the pointer to the proper error vector is returned as function   *
!     val.                                                             *
!                                                                      *
!***********************************************************************

use LnkLst, only: GetNod, iVPtr, LLGrad
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: lVec, iVec
logical(kind=iwp), intent(in) :: QNRstp
real(kind=wp), intent(out) :: ErrVec(lVec)
integer(kind=iwp) :: inode
real(kind=wp), allocatable :: Grad(:)

call GetNod(ivec,LLGrad,inode)
if (inode == 0) then
  ! Hmmm, no entry found in LList, that's strange
  write(u6,*) 'ErrV: no entry found in LList!'
  call Abend()
end if

if (QNRstp) then

  ! for qNR step compute delta = - H^{-1}g

  call mma_allocate(Grad,lvec,Label='Grad')
  call iVPtr(Grad,lvec,inode)
# ifdef _DEBUGPRINT_
  write(u6,*) 'ErrV, iVec=',iVec
  call NrmClc(Grad,lVec,'ErrV','Grad')
# endif
  call SOrUpV(Grad,lvec,ErrVec,'DISP','BFGS')
# ifdef _DEBUGPRINT_
  call NrmClc(ErrVec,lVec,'ErrV','ErrVec')
# endif
  call mma_deallocate(Grad)

else

  ! Pick up the gradient

  call iVPtr(ErrVec,lvec,inode)

end if

return

end subroutine ErrV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine axesx_cvb(asonc,ddres2upd,vec,resthr_inp,ioptc,iter,fx_exp)

use casvb_global, only: nparm, solp_res, sxc
use casvb_interfaces, only: ddasonc_sub, ddres2upd_sub
use Definitions, only: wp, iwp

implicit none
procedure(ddasonc_sub) :: asonc
procedure(ddres2upd_sub) :: ddres2upd
real(kind=wp), intent(out) :: vec(nparm), fx_exp
real(kind=wp), intent(in) :: resthr_inp
integer(kind=iwp), intent(out) :: ioptc, iter

call axesx2_cvb(asonc,ddres2upd,vec,resthr_inp,ioptc,iter,fx_exp,sxc,.false.,solp_res)

return

end subroutine axesx_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Read_Blocks(iTable,nBlocks,nBas,nIrrep,Buf,nBuf,
     &                       iSO2Shell,nSOs,Bin,nBin,nQuad,G_Toc,
     &                       iSO2cI,CutInt)
      use aces_stuff, only: LuGamma
      use pso_stuff
      use SOAO_Info, only: iOffSO
      Implicit Real*8 (a-h,o-z)
#include "SysDef.fh"
#include "real.fh"
#include "mp2alaska.fh"
      Integer iTable(6,nBlocks), nBas(0:nIrrep-1),
     &        iSO2Shell(nSOs), iSO2cI(2,nSOs)
      Real*8 Buf(nBuf), Bin(2,nBin,nQuad), G_Toc(nQuad)
      Logical Triangular
*                                                                      *
************************************************************************
*                                                                      *
*---- Statement function for triangular indexation
*
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*---- Generate table SO to contigous index
*
*     Write (*,*) 'nQuad=',nQuad
      Call Mk_SO2cI(iSO2cI,iSO2Shell,nSOs)
*                                                                      *
************************************************************************
*                                                                      *
*---- Initiate bins
*
      Do iQuad = 1, nQuad
         Bin(1,nBin,iQuad)=Zero  ! number of elements in bin
         Bin(2,nBin,iQuad)=-One  ! back chaining address
      End Do
      iDisk=0 ! initial disk address
      iWrite=1
*                                                                      *
************************************************************************
*                                                                      *
*---- Loop over symmetry blocks of gammas
*
*     Write (*,*) 'iSO2Shell',iSO2Shell
*     Write (*,*) 'iSO2cI(1)',(iSO2cI(1,i),i=1,nSOs)
*     Write (*,*) 'iSO2cI(2)',(iSO2cI(2,i),i=1,nSOs)
      iBlockAdr = 1
      Do iBlock = 1, nBlocks
         iType   =iTable(1,iBlock)
         iIrrep_A=iTable(2,iBlock)
         iIrrep_B=iTable(3,iBlock)
         iIrrep_C=iTable(4,iBlock)
         iIrrep_D=iTable(5,iBlock)
         IND     =iTable(6,iBlock)
*        Write (*,*)  'Irreps:',iIrrep_A, iIrrep_B, iIrrep_C, iIrrep_D
*
         nA=nBas(iIrrep_A)
         nB=nBas(iIrrep_B)
         nC=nBas(iIrrep_C)
         nD=nBas(iIrrep_D)
*        Write (*,*) 'nA,nB,nC,nD=',nA,nB,nC,nD
         If (iType.eq.1 .or. iType.eq.2) Then
            nAB = nA*(nA+1)/2
            nCD = nC*(nC+1)/2
            Triangular=.True.
         Else
            nAB=nA*nB
            nCD=nC*nD
            Triangular=.False.
         End If
         If (nAB*nCD.eq.0) Go To 999
*
         nAB_dist=Min(nAB,nBuf/nCD)
         iSO_A_r=1
         iSO_B_r=1
         Do iiAB = 1, nAB, nAB_dist
            iAB_s=iiAB
            iAB_e=Min(nAB,iiAB+nAB_dist-1)
*
* This call is to an ACES2 routine. This has to be replaced once this
* code is used by MOLCAS. RL 2007-10-18.
C           Call GetLst(Buf,iAB_s,nAB_dist,2,iType,IND)
************************************************************************
* Jonas B 2010. This code is used for reading nonseparable two-electron
*               density matrices when doing conventional mp2-gradients.
            If(Case_mp2) Then
               iSize = min(nAB_dist*nCD,(nAB-(iiAB-1))*nCD)
               iAdr = iBlockAdr + nCD*(iiAB-1)
               Call dDaFile(LuGam,2,Buf,iSize,iAdr)
            End If
*
************************************************************************
*           Call RecPrt('Aces_Gamma: from GetLst',' ',
*    &                  Buf,iAB_e-iAB_s+1,nCD)
*
            iBuf=0
            Do iAB = iAB_s, iAB_e
*
               iSO_A_a=iOffSO(iIrrep_A)+iSO_A_r
               iSO_B_a=iOffSO(iIrrep_B)+iSO_B_r
               iShell_A=iSO2Shell(iSO_A_a)
               iShell_B=iSO2Shell(iSO_B_a)
               iShell_AB=iTri(iShell_A,iShell_B)
*
               Index_A=iSO2cI(1,iSO_A_a)
               Index_B=iSO2cI(1,iSO_B_a)
               nDim_A=iSO2cI(2,iSO_A_a)
               nDim_B=iSO2cI(2,iSO_B_a)
               nDim_AB=nDim_A*nDim_B
               If (iShell_A.gt.iShell_B) Then
                  Index_AB=(Index_B-1)*nDim_A+Index_A
               Else If (iShell_A.eq.iShell_B) Then
                  Index_AB=iTri(Index_A,Index_B)
               Else
                  Index_AB=(Index_A-1)*nDim_B+Index_B
               End If
*
               iSO_C_r=1
               iSO_D_r=1
               Do iCD = 1, nCD
*
                  iBuf = iBuf + 1
*                 iBuf = (iCD-1)*nAB_dist+iAB
                  ABCD=Buf(iBuf)
*
*     Jonas B 2010. If calculating mp2-integrals the cutoff for small
*     gammas should not be used at the moment.
                  If(.not. Case_mp2) Then
                     If (Abs(ABCD).lt.CutInt) Go To 888
                  End If
                  iSO_C_a=iOffSO(iIrrep_C)+iSO_C_r
                  iSO_D_a=iOffSO(iIrrep_D)+iSO_D_r
                  iShell_C=iSO2Shell(iSO_C_a)
                  iShell_D=iSO2Shell(iSO_D_a)
                  iShell_CD=iTri(iShell_C,iShell_D)
                  iShell_ABCD=iTri(iShell_AB,iShell_CD)
*
*---------------- Compute canonical compound index
*
                  Index_C=iSO2cI(1,iSO_C_a)
                  Index_D=iSO2cI(1,iSO_D_a)
                  nDim_C=iSO2cI(2,iSO_C_a)
                  nDim_D=iSO2cI(2,iSO_D_a)
                  nDim_CD=nDim_C*nDim_D
                  If (iShell_C.gt.iShell_D) Then
                     Index_CD=(Index_D-1)*nDim_C+Index_C
                  Else If(iShell_C.eq.iShell_D) Then
                     Index_CD=iTri(Index_C,Index_D)
                  Else
                     Index_CD=(Index_C-1)*nDim_D+Index_D
                  End If
                  If (iShell_AB.gt.iShell_CD) Then
                     Index_ABCD=(Index_CD-1)*nDim_AB+Index_AB
                  Else If (iShell_AB.eq.iShell_CD) Then
                     Index_ABCD=iTri(Index_AB,Index_CD)
                  Else
                     Index_ABCD=(Index_AB-1)*nDim_CD+Index_CD
                  End If
*                                                                      *
************************************************************************
*                                                                      *
*---------------- Store information in the appropriate bin
*
*                 Write (*,*) 'ABCD, Index_ABCD=',ABCD, Index_ABCD
*                 Write (*,*) 'iSO:',iSO_A_a,iSO_B_a,iSO_C_a,iSO_D_a
*                 Write (*,*) 'iShell:',iShell_A,iShell_B,
*    &                                  iShell_C,iShell_D
*                 Write (*,*) 'cind:',Index_A,Index_B,Index_C,Index_D
*                 Write (*,*) 'ndims:',nDim_A,nDim_B,nDim_C,nDim_D
*                 Write (*,*) 'iShell_AB,iShell_CD=',iShell_AB,iShell_CD
*                 Write (*,*) 'nDim_AB,nDim_CD=',nDim_AB,nDim_CD
*                 Write (*,*) 'iShell_ABCD=',iShell_ABCD
                  kBin=Int(Bin(1,nBin,iShell_ABCD))+1
                  Bin(1,kBin,iShell_ABCD)=ABCD
                  Bin(2,kBin,iShell_ABCD)=DBLE(Index_ABCD)
                  Bin(1,nBin,iShell_ABCD)=DBLE(kBin)  ! Update counter
*                                                                      *
************************************************************************
*                                                                      *
*---------------- Write bin to disk if full.
*
                  If (kBin.eq.nBin-1) Then
                     BackChain=DBLE(iDisk)
                     Call dDaFile(LuGamma,iWrite,Bin(1,1,iShell_ABCD),
     &                            2*nBin,iDisk)
                     Bin(1,nBin,iShell_ABCD)=Zero
                     Bin(2,nBin,iShell_ABCD)=BackChain
                  End If
*                                                                      *
************************************************************************
*                                                                      *
*---------------- Increment indices for C and D
*
                  If (.Not.Triangular) Then
*                    iSO_C_r=iSO_C_r+1
*                    If (iSO_C_r.gt.nBas(iIrrep_C)) Then
*                       iSO_C_r=1
*                       iSO_D_r=iSO_D_r+1
*                    End If
                     iSO_D_r=iSO_D_r+1
                     If (iSO_D_r.gt.nBas(iIrrep_D)) Then
                        iSO_D_r=1
                        iSO_C_r=iSO_C_r+1
                     End If
                  Else
*Lower triangular
                     iSO_D_r=iSO_D_r+1
                     If (iSO_D_r.gt.iSO_C_r) Then
                        iSO_C_r=iSO_C_r+1
                        iSO_D_r=1
                     End If
*Upper triangular
*                    iSO_C_r=iSO_C_r+1
*                    If (iSO_C_r.gt.nBas(iIrrep_C)) Then
*                       iSO_D_r=iSO_D_r+1
*                       iSO_C_r=iSO_D_r
*                    End If
                  End If
*
 888              Continue
               End Do  ! iCD
*                                                                      *
************************************************************************
*                                                                      *
*------------- Increment indices for A and B
*
               If (.Not.Triangular) Then
*                 iSO_A_r=iSO_A_r+1
*                 If (iSO_A_r.gt.nBas(iIrrep_A)) Then
*                    iSO_A_r=1
*                    iSO_B_r=iSO_B_r+1
*                 End If
                  iSO_B_r=iSO_B_r+1
                  If (iSO_B_r.gt.nBas(iIrrep_B)) Then
                     iSO_B_r=1
                     iSO_A_r=iSO_A_r+1
                  End If
               Else
*Lower triangular
                  iSO_B_r=iSO_B_r+1
                  If (iSO_B_r.gt.iSO_A_r) Then
                     iSO_A_r=iSO_A_r+1
                     iSO_B_r=1
                  End If
*Upper triangular
*                 iSO_A_r=iSO_A_r+1
*                 If (iSO_A_r.gt.nBas(iIrrep_A)) Then
*                    iSO_B_r=iSO_B_r+1
*                    iSO_A_r=iSO_B_r
*                 End If
               End If
*
            End Do     ! iAB
*
         End Do        ! iiAB
 999     Continue
         iBlockAdr = iBlockAdr + nAB*nCD
*
      End Do           ! iBlock
*                                                                      *
************************************************************************
*                                                                      *
*---- Flush the bins to disk and save disk addresses
*
*     Write (*,*) 'Flush bins!'
      Do iQuad = 1, nQuad
         BackChain=DBLE(iDisk)
         Call dDaFile(LuGamma,iWrite,Bin(1,1,iQuad),2*nBin,iDisk)
         lxx=Int(Bin(1,nBin,iQuad))
*        Write (*,*) 'lxx=',lxx
*        Call RecPrt('Bins',' ',Bin(1,1,iQuad),2,lxx)
         G_Toc(iQuad)=BackChain
      End Do
*
*     Observe that backchain list is only stored in core!
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine symtrizcvb3_cvb(vecstr,idelstr)

use casvb_global, only: lzrvb, nvb, nzrvb
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: vecstr(nvb)
integer(kind=iwp), intent(in) :: idelstr(nzrvb)
integer(kind=iwp) :: i, ikeep

! Zero coefficients specified by idelstr:
if (lzrvb == 0) then
  do i=1,nzrvb
    if (idelstr(i) > 0) vecstr(idelstr(i)) = Zero
  end do
else
  ! if here, idelstr specifies which structures to *keep*:
  if (nzrvb >= 1) vecstr(1:idelstr(1)-1) = Zero
  do ikeep=1,nzrvb-1
    vecstr(idelstr(ikeep)+1:idelstr(ikeep+1)-1) = Zero
  end do
end if

return

end subroutine symtrizcvb3_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ComputeValenceIntegrals(AB,CD,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Compute valence integrals (u_A v_B | k_C l_D) for atom
C              pairs AB and CD.
C
      Implicit None
      Integer AB
      Integer CD
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"
#include "ldf_atom_pair_info.fh"

      Character*27 SecNam
      Parameter (SecNam='LDF_ComputeValenceIntegrals')

#if defined (_DEBUGPRINT_)
      Logical  isSymmetric
      External isSymmetric
      Integer  ji, lk
#endif

      External Int_LDF_SQ

      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom

      Integer A, B, C, D
      Integer nAB, nCD
      Integer l_xInt
      Integer nShell_A, nShell_B, nShell_C, nShell_D
      Integer ipA, ipB, ipC, ipD
      Integer maxAB, maxCD
      Integer n, n_
      Integer iS, jS, kS, lS
      Integer iShell, jShell, kShell, lShell
      Integer iS1, kS1, nij, nkl, nijkl
      Integer ip_iAB, l_iAB, ip_iCD, l_iCD
      Integer ip_SQ, l_SQ
      Integer ip_SewWrk, l_SewWrk
      Integer ij, ij0, kl, kl0, ijkl, ijkl0
      Integer iCol, iRow, ip, ip0
      Integer k, l

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer iAB, iCD
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      iAB(i,j)=iWork(ip_iAB-1+nShell_A*(j-1)+i)
      iCD(i,j)=iWork(ip_iCD-1+nShell_C*(j-1)+i)

      ! Get atoms of pairs
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      C=AP_Atoms(1,CD)
      D=AP_Atoms(2,CD)

      ! Get dimensions
      nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      nCD=LDF_nBas_Atom(C)*LDF_nBas_Atom(D)
      nShell_A=LDF_nShell_Atom(A)
      nShell_B=LDF_nShell_Atom(B)
      nShell_C=LDF_nShell_Atom(C)
      nShell_D=LDF_nShell_Atom(D)
      ipA=LDF_lShell_Atom(A)-1
      ipB=LDF_lShell_Atom(B)-1
      ipC=LDF_lShell_Atom(C)-1
      ipD=LDF_lShell_Atom(D)-1

      ! Check integral dimension
      l_xInt=nAB*nCD
      If (l_xInt.gt.l_xInt_) Then
         Call WarningMessage(2,
     &                SecNam//': insufficient integral array dimension')
         Call LDF_Quit(1)
      End If

      ! Initialize integral array
      Call Cho_dZero(xInt,l_xInt)

      ! Allocate and set index array to shell rows and cols of integrals
      l_iAB=nShell_A*nShell_B
      Call GetMem('CVIiAB','Allo','Inte',ip_iAB,l_iAB)
      maxAB=0
      n=0
      Do jS=1,nShell_B
         jShell=iWork(ipB+jS)
         Do iS=1,nShell_A
            iShell=iWork(ipA+iS)
            iWork(ip_iAB-1+nShell_A*(jS-1)+iS)=n
            n_=nBasSh(iShell)*nBasSh(jShell)
            n=n+n_
            maxAB=max(maxAB,n_)
         End Do
      End Do
#if defined (_DEBUGPRINT_)
      If (n.ne.nAB) Then
         Call WarningMessage(2,SecNam//': n != nAB')
         Call LDF_Quit(1)
      End If
#endif
      If (CD.eq.AB) Then
         l_iCD=0
         ip_iCD=ip_iAB
         maxCD=maxAB
      Else
         l_iCD=nShell_C*nShell_D
         Call GetMem('CVIiCD','Allo','Inte',ip_iCD,l_iCD)
         maxCD=0
         n=0
         Do jS=1,nShell_D
            jShell=iWork(ipD+jS)
            Do iS=1,nShell_C
               iShell=iWork(ipC+iS)
               iWork(ip_iCD-1+nShell_C*(jS-1)+iS)=n
               n_=nBasSh(iShell)*nBasSh(jShell)
               n=n+n_
               maxCD=max(maxCD,n_)
            End Do
         End Do
      End If
#if defined (_DEBUGPRINT_)
      If (n.ne.nCD) Then
         Call WarningMessage(2,SecNam//': n != nCD')
         Call LDF_Quit(1)
      End If
#endif

      ! Allocate memory for largest shell quadruple
      l_SQ=maxAB*maxCD
      Call GetMem('CVISQ','Allo','Real',ip_SQ,l_SQ)

      ! Allocate memory for Seward
      Call GetMem('Max','Max ','Real',ip_SewWrk,l_SewWrk)
      Call xSetMem_Ints(l_SewWrk)

      ! Compute integrals
      Do lS=1,nShell_D
         lShell=iWork(ipD+lS)
         If (C.eq.D) Then
            kS1=lS
         Else
            kS1=1
         End If
         Do kS=kS1,nShell_C
            kShell=iWork(ipC+kS)
            nkl=nBasSh(kShell)*nBasSh(lShell)
            Do jS=1,nShell_B
               jShell=iWork(ipB+jS)
               If (A.eq.B) Then
                  iS1=jS
               Else
                  iS1=1
               End If
               Do iS=iS1,nShell_A
                  iShell=iWork(ipA+iS)
                  nij=nBasSh(iShell)*nBasSh(jShell)
                  nijkl=nij*nkl
                  Call Cho_dZero(Work(ip_SQ),nijkl)
                  SHA=iShell
                  SHB=jShell
                  SHC=kShell
                  SHD=lShell
                  Call Eval_IJKL(iShell,jShell,kShell,lShell,
     &                           Work(ip_SQ),nijkl,
     &                           Int_LDF_SQ)
                  Do l=1,nBasSh(lShell)
                     kl0=nBasSh(kShell)*(l-1)
                     Do k=1,nBasSh(kShell)
                        kl=kl0+k
                        iCol=iCD(kS,lS)+kl
                        ip0=nAB*(iCol-1)
                        ijkl0=ip_SQ-1+nij*(kl-1)
                        Do j=1,nBasSh(jShell)
                           ij0=nBasSh(iShell)*(j-1)
                           Do i=1,nBasSh(iShell)
                              ij=ij0+i
                              iRow=iAB(iS,jS)+ij
                              ip=ip0+iRow
                              ijkl=ijkl0+ij
                              xInt(ip)=Work(ijkl)
                              If (A.eq.B) Then
                                 iRow=iAB(jS,iS)
     &                               +nBasSh(jShell)*(i-1)+j
                                 ip=ip0+iRow
                                 xInt(ip)=Work(ijkl)
                              End If
                           End Do
                        End Do
                        If (D.eq.C) Then
                           iCol=iCD(lS,kS)
     &                         +nBasSh(lShell)*(k-1)+l
                           ip0=nAB*(iCol-1)
                           Do j=1,nBasSh(jShell)
                              ij0=nBasSh(iShell)*(j-1)
                              Do i=1,nBasSh(iShell)
                                 ij=ij0+i
                                 iRow=iAB(iS,jS)+ij
                                 ip=ip0+iRow
                                 ijkl=ijkl0+ij
                                 xInt(ip)=Work(ijkl)
                                 If (A.eq.B) Then
                                    iRow=iAB(jS,iS)
     &                                  +nBasSh(jShell)*(i-1)+j
                                    ip=ip0+iRow
                                    xInt(ip)=Work(ijkl)
                                 End If
                              End Do
                           End Do
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do

#if defined (_DEBUGPRINT_)
      If (AB.eq.CD) Then
         If (.not. isSymmetric(xInt,nAB,1.0d-14)) Then
            Call WarningMessage(2,SecNam//': (AB|CD) != (CD|AB)')
            Call LDF_Quit(1)
         End If
      End If
      If (A.eq.B) Then
         Do kl=1,nCD
            Do jS=1,nShell_B
               jShell=iWork(ipB+jS)
               iS=jS
               iShell=jShell
               Do j=1,nBasSh(jShell)
                  Do i=j+1,nBasSh(iShell)
                     ij=nAB*(kl-1)+iAB(iS,jS)+nBasSh(iShell)*(j-1)+i
                     ji=nAB*(kl-1)+iAB(jS,iS)+nBasSh(jShell)*(i-1)+j
                     If (abs(xInt(ij)-xInt(ji)).gt.1.0d-14) Then
                        Call WarningMessage(2,
     &                               SecNam//': [1] (AB|CD) != (BA|CD)')
                        Call LDF_Quit(1)
                     End If
                  End Do
               End Do
               Do iS=jS+1,nShell_A
                  iShell=iWork(ipA+iS)
                  Do j=1,nBasSh(jShell)
                     Do i=1,nBasSh(iShell)
                        ij=nAB*(kl-1)+iAB(iS,jS)+nBasSh(iShell)*(j-1)+i
                        ji=nAB*(kl-1)+iAB(jS,iS)+nBasSh(jShell)*(i-1)+j
                        If (abs(xint(ij)-xint(ji)).gt.1.0d-14) Then
                           Call WarningMessage(2,
     &                               SecNam//': [2] (AB|CD) != (BA|CD)')
                           Call LDF_Quit(1)
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End If
      If (C.eq.D) Then
         Do ij=1,nAB
            Do lS=1,nShell_D
               lShell=iWork(ipD+lS)
               kS=lS
               kShell=lShell
               Do l=1,nBasSh(lShell)
                  do k=l+1,nBasSh(kShell)
                     kl=iCD(kS,lS)+nBasSh(kShell)*(l-1)+k
                     lk=iCD(lS,kS)+nBasSh(lShell)*(k-1)+l
                     kl=nAB*(kl-1)+ij
                     lk=nAB*(lk-1)+ij
                     If (abs(xInt(kl)-xInt(lk)).gt.1.0d-14) Then
                        Call WarningMessage(2,
     &                               SecNam//': [1] (AB|CD) != (AB|DC)')
                        Call LDF_Quit(1)
                     End If
                  End Do
               End Do
               Do kS=lS+1,nShell_C
                  kShell=iWork(ipC+kS)
                  Do l=1,nBasSh(lShell)
                     Do k=1,nBasSh(kShell)
                        kl=iCD(kS,lS)+nBasSh(kShell)*(l-1)+k
                        lk=iCD(lS,kS)+nBasSh(lShell)*(k-1)+l
                        kl=nAB*(kl-1)+ij
                        lk=nAB*(lk-1)+ij
                        If (abs(xInt(kl)-xInt(lk)).gt.1.0d-14) Then
                           Call WarningMessage(2,
     &                               SecNam//': [2] (AB|CD) != (AB|DC)')
                           Call LDF_Quit(1)
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End If
#endif

      ! Deallocation
      Call xRlsMem_Ints()
      Call GetMem('CVISQ','Free','Real',ip_SQ,l_SQ)
      If (l_iCD.gt.0) Then
         Call GetMem('CVIiCD','Free','Inte',ip_iCD,l_iCD)
      End If
      Call GetMem('CVIiAB','Free','Inte',ip_iAB,l_iAB)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine ModU2(U2,mT,nRys,ZEInv)
************************************************************************
*                                                                      *
* Object: precompute u2/(zeta+eta)                                     *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             May '90                                                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 U2(nRys,mT), ZEInv(mT)
*
      iRout = 255
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In ModU2: U2',' ',U2,nRys,mT)
         Call RecPrt(' In ModU2: ZEInv',' ',ZEInv,1,mT)
      End If
*
      If (nRys.gt.1) Then
         Do 11 iT = 1, mT
            Do 21 iRys = 1, nRys
                  U2(iRys,iT) = U2(iRys,iT) * ZEInv(iT)
 21         Continue
 11      Continue
      Else
         Do 31 iT = 1, mT
            U2(1,iT) = U2(1,iT) * ZEInv(iT)
 31      Continue
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine hello_cvb()

use casvb_global, only: variat
use Definitions, only: u6

implicit none

if (variat) write(u6,'(a)') ' '
write(u6,10)
if (.not. variat) call date1_cvb()

return
10 format(/,'     CASVB (Valence bond MCSCF)   Authors: T. Thorsteinsson and D. L. Cooper  (1996-2006)',/)

end subroutine hello_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CofMss(Coor,nsAtom,cMass)
!***********************************************************************
!   Object: To calculate the molecular mass, the center of mass and    *
!           move the coordinates so origo is the center of mass.       *
!***********************************************************************

use Slapaf_Info, only: dMass, Smmtrc
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nsAtom
real(kind=wp), intent(in) :: Coor(3,nsAtom)
real(kind=wp), intent(out) :: cMass(3)
integer(kind=iwp) :: i, iCOM, j
real(kind=wp) :: TMass
integer(kind=iwp), external :: iDeg

! Calculate the molecular mass.

TMass = Zero
do I=1,nsAtom
  TMass = TMass+dMass(I)*real(iDeg(Coor(1,i)),kind=wp)
end do
iCOM = -1
if (TMass >= 1.0e99_wp) then
  do i=1,nsAtom
    if (dMass(i) == 1.0e99_wp) then
      iCOM = i
      exit
    end if
  end do
end if

! calculate the center of mass

cMass(:) = Zero
! Loop over the unique centers
do i=1,nsAtom
  do j=1,3
    ! Add contribution
    if (Smmtrc(j,i)) cMass(j) = cMass(j)+dMass(i)*Coor(j,i)*real(iDeg(Coor(1,i)),kind=wp)
  end do
end do

cMass(:) = cMass(:)/TMass
if ((iCOM >= 1) .and. (iCOM <= nsAtom)) cMass(:) = Coor(:,iCom)

#ifdef _DEBUGPRINT_
write(u6,100) cMass(:),TMass
100 format(//,' Center of Mass (bohr) ',3F10.5,/,' Molecular Mass   (au) ',1F15.5)
#endif

#ifdef _DO_NOT_
! translate the center of mass to origo

do i=1,nsAtom
  Coor(:,i) = Coor(:,i)-cMass(:)
end do
#endif

return

end subroutine CofMss

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine kindiag(TKIN,TKINTRIA,ndim,evec,eval,breit)
      implicit real*8 (a-h,o-z)
cbs   determines eigenvectors and -values of TKIN
      dimension tkin(ndim,ndim),
     *TKINTRIA((ndim*ndim+ndim)/2),eval(ndim),evec(ndim,ndim)
      logical breit
cbs   move symmetric matrix to triangular matrix
      itria=1
      do irun2=1,ndim
      do irun1=1,irun2
      TKINTRIA(itria)=TKIN(irun1,irun2)
      itria=itria+1
      enddo
      enddo
      do irun2=1,ndim
      do irun1=1,ndim
      evec(irun1,irun2)=0d0
      enddo
      enddo
      do irun1=1,ndim
      evec(irun1,irun1)=1d0
      enddo
cbs   now diagonalize
            CALL Jacob(TKINTRIA,evec,ndim,ndim)
cbs   get the eigenvalues
      do irun=1,ndim
      eval(irun)=TKINTRIA((irun*irun+irun)/2)
      enddo
      if (breit) then
      do irun=1,ndim
      eval(irun)=0d0
      enddo
      endif
cbs   ensure normalization of the vectors.
      do IRUN=1,ndim
      fact=0d0
      do JRUN=1,ndim
      fact=fact+evec(JRUN,IRUN)*evec(JRUN,IRUN)
      enddo
      fact=1d0/sqrt(fact)
      do JRUN=1,ndim
      evec(JRUN,IRUN)=fact*evec(JRUN,IRUN)
      enddo
      enddo
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine GetChV (wrk,wrksize,
     c                     aGrp,bGrp,beGrp,gaGrp,NL2,L2Status,
     c                     pL21,pL22,pL23,pL24,pL2W,
     c                     PossL11,PossL12,LunAux)
c
c       this rotune do:
c       read L2 files from disc file
c*      L21 (m,a',be')
c       L22 (m,a',ga')
c       L23 (m,b',be')
c       L24 (m,b',ga')
c        and completed it by the term
c        L2x (m,c',de') <<- L2(m,c',i) . T1(T)(de',i)
c
c       Routine define pL2x, which are values, which show, which index
c       i (correspondig to L2Status(i,1-3) correspond to ginev L2x.
c       Array L2Status (neaningful only for i=1,NL2) stores informations
c       about really loaded L2's in memory. If some of the blocks were
c       already defined in previous spep(s), they are not readed repetidly.
c
c       N.B.1 Rutina sa da spravit aj trivialne, ze sa pokazde vsetky
c       L21-4 nacitaju, toto riesenie je menej prehladne, ale setri IO
c       N.B.2 Efektivitu ovplyvnuje hlavne, ako vybera rutine getChVHlp2
c       kam sa ma nove L2 nacitat, najma ak ma vybrat, ktory s
c       existujucich rekordov premaze
c
c       I/O parameter description:
c       aGrp, bGrp   - groups of a,b (I)
c       beGrp, GaGrp - groups of be,ga (I)
c       NL2          - real number of L2 declared in memory(1,2or4) (I)
c       L2Status    - L2 status matrix (I/O)
c                     L2Status(i,1) - cGrp
c                     L2Status(i,2) - deGrp
c                     L2Status(i,3) - Poss
c       pL2x        - possition of L2x in L2Status (i.e. index i
c                     in L2Status(i,1-3) for given L2x (O)
c        PossL11     - Possition of L1(m,a',i) (I)
c        PossL12     - Possition of L1(m,b',i) (I)
c       LunAux      - lun for auxiliary reading (I)
c
c
        implicit none
#include "wrk.fh"
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aGrp,bGrp,beGrp,gaGrp,NL2
        integer pL21,pL22,pL23,pL24,pL2W,PossL11,PossL12,LunAux
        integer L2Status(1:4,1:3)
c
c       help variables
        integer Used(1:4)
        integer WhatNeedToRead(1:4,1:2)
        integer HowMany
        integer Which(1:4)
        integer Kde(1:4)
        integer i,kery,kam,yes,ToDo
        integer cGrp,deGrp,dimc,dimde,addde
c
        kam=-1 ! dummy initialize
c
c
c1      Define
c         a) what need to be read (WhatNeedToRead)
c         b) How many different L2 need to be defined (HowMany)
c         c) How L21-4 is mapped to the unique ones, that need to
c            be read (Which)
c
        if (aGrp.eq.bGrp) then
          if (beGrp.eq.gaGrp) then
c         case L21=L22=L23=L24
            HowMany=1
            WhatNeedToRead(1,1)=aGrp
            WhatNeedToRead(1,2)=beGrp
            Which(1)=1
            Which(2)=1
            Which(3)=1
            Which(4)=1
          else
c         case L21=L23, L22=L24
            HowMany=2
            WhatNeedToRead(1,1)=aGrp
            WhatNeedToRead(1,2)=beGrp
            WhatNeedToRead(2,1)=aGrp
            WhatNeedToRead(2,2)=gaGrp
            Which(1)=1
            Which(2)=2
            Which(3)=1
            Which(4)=2
          end if
        else
          if (beGrp.eq.gaGrp) then
c         case L21=L22,L23=L24
            HowMany=2
            WhatNeedToRead(1,1)=aGrp
            WhatNeedToRead(1,2)=beGrp
            WhatNeedToRead(2,1)=bGrp
            WhatNeedToRead(2,2)=beGrp
            Which(1)=1
            Which(2)=1
            Which(3)=2
            Which(4)=2
          else
c         all L2s are different
            HowMany=4
            WhatNeedToRead(1,1)=aGrp
            WhatNeedToRead(1,2)=beGrp
            WhatNeedToRead(2,1)=aGrp
            WhatNeedToRead(2,2)=gaGrp
            WhatNeedToRead(3,1)=bGrp
            WhatNeedToRead(3,2)=beGrp
            WhatNeedToRead(4,1)=bGrp
            WhatNeedToRead(4,2)=gaGrp
            Which(1)=1
            Which(2)=2
            Which(3)=3
            Which(4)=4
          end if
        end if
c
c
c2      Load neccesarry L2 from disk
c
c2.1    SetUp
        do i=1,NL2
          Kde(i)=0
          Used(i)=0
        end do
c
1       ToDo=HowMany
c
c2.2    Test, which ones of those, that need to be read are
c       already loaded and where (Kde) and find, how many of
c       L2 need to be readed really (ToDo)
        do i=1,HowMany
          call getChVHlp1
     c    (WhatNeedToRead(i,1),WhatNeedToRead(i,2),yes,NL2,L2Status)
          Kde(i)=yes
          if (yes.ne.0) then
            used(yes)=1
            ToDo=ToDo-1
          end if
        end do
c
c2.3    if there is atleast one L2 to read, read only one
c       and run 2.2 section again
        if (ToDo.gt.0) then
c
c         zistit kere L2 treba nacitat (kery)
          kery=0
          do i=1,HowMany
            if (Kde(i).eq.0) then
              kery=i
            end if
          end do
c
c         found, where to read it (kam)
          call getChVHlp2 (L2Status,NL2,used,kam)
c
c         read L2 (kery) into (kam) (+ expand, f needed)
          L2Status(kam,1)=WhatNeedToRead(kery,1)
          L2Status(kam,2)=WhatNeedToRead(kery,2)
          cGrp=L2Status(kam,1)
          deGrp=L2Status(kam,2)
          call getChVHlp3 (wrk(L2Status(kam,3)),wrk(pL2W),
     c                     L2Status(kam,1),L2Status(kam,2),LunAux)
c
c          Create L2W(i,de') <- T1(de,i)
          dimde=DimGrpbe(deGrp)
          addde=0
          do i=1,deGrp-1
            addde=addde+DimGrpbe(i)
          end do
          call getChVHlp4 (wrk(pL2W),wrk(PossT1o),dimde,addde)
c
c          upgrade L2(m,c',de') <<- - L1(m,c',i). L2W(i,de')
          dimc=DimGrpa(cGrp)
          if (cGrp.eq.aGrp) then
            call mc0c2a3b (nc*dimc,no,no,dimde,nc*dimc,dimde,
     c                     nc*dimc,no,dimde,
     c                     wrk(PossL11),wrk(pL2W),wrk(L2Status(kam,3)))
          else if (cGrp.eq.bGrp) then
            call mc0c2a3b (nc*dimc,no,no,dimde,nc*dimc,dimde,
     c                     nc*dimc,no,dimde,
     c                     wrk(PossL12),wrk(pL2W),wrk(L2Status(kam,3)))
          else
            write (6,*) ' Nieje dobre, c nieje ani a ani b :-( Ch. K.'
            call Abend()
          end if
c
          used(kam)=1
c
          goto 1
        end if
c
c
c3      At this point all neccesarry L2 are read - def pL2x
c
        i=Which(1)
        pL21=Kde(i)
        i=Which(2)
        pL22=Kde(i)
        i=Which(3)
        pL23=Kde(i)
        i=Which(4)
        pL24=Kde(i)
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************
!***********************************************************************
!         MODULE for TRANSFORMATION of CHOLESKY VECTORS                *
!              and GENERATION of TWO-ELECTRONS INTEGRALS               *
!***********************************************************************

module Cho_Tra

use Data_Structures, only: Alloc2DArray_Type
use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: MaxSym = 8, MxTCVx = 7
integer(kind=iwp) :: IAD2M(3,36*36), nAsh(MaxSym), nBas(MaxSym), nDel(MaxSym), nFro(MaxSym), nIsh(MaxSym), nOrb(MaxSym), &
                     nOsh(MaxSym), nSsh(MaxSym), nSym, NumCho(MaxSym)
logical(kind=iwp) :: DoCoul, DoExc2, DoFull, DoTCVA, IfTest, SubBlocks(3,3), TCVXist(MxTCVx,MaxSym,MaxSym)
type(Alloc2DArray_Type) :: TCVX(MxTCVx,MaxSym,MaxSym)

public :: DoCoul, DoExc2, DoFull, DoTCVA, IAD2M, IfTest, nAsh, nBas, nDel, nFro, nIsh, nOrb, nOsh, nSsh, nSym, NumCho, SubBlocks, &
          TCVX, TCVXist

end module Cho_Tra

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, IBM                                              *
!***********************************************************************

function iCLast(KWord,iChrct)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iCLast
character(len=*), intent(in) :: KWord
integer(kind=iwp), intent(in) :: iChrct
integer(kind=iwp) :: i

iCLast = 0
do i=iChrct,1,-1
  if (KWord(i:i) /= ' ') then
    iCLast = i
    return
  end if
end do

end function iCLast

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Francesco Aquilante                              *
************************************************************************
      SUBROUTINE Loc_Nat_orb(irc,Cmo,Xmo,OccN,mOrb)
************************************************************************
*                                                                      *
*     Purpose: compute Localized Natural Orbitals (LNOs) to be used    *
*              for instance in Effective Bond Order (EBO) analysis     *
*                                                                      *
*              The density matrix in localized MO basis is             *
*              diagonalized separately in 2 subblocks defined by the   *
*              orbitals that extend within two distinct subregions     *
*              (atoms) of the molecule.                                *
*              The gross Mulliken population of each orbital on the    *
*              atoms of the two subregions determines the splitting    *
*              of the orbitals.                                        *
*              The atoms defining the "active subregion" are specified *
*              by the user with the keyword LOCN .                     *
*              The threshold used for the orbitals splitting criterium *
*              is also required within the keyword LOCN .              *
*                                                                      *
*     Author: F. Aquilante   (Geneva, Feb. 2008)                       *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8  Cmo(*), Xmo(*), OccN(*)
      Integer irc, mOrb(*)
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "inflocal.fh"
      Character*(LENIN) tmp
************************************************************************
      jD(i) = iWork(ip_iD-1+i)
******
      kD(i) = iWork(ip_iD+nBmx-1+i)
******
      lD(i) = iWork(ip_iD+nBmx+nOrbmx-1+i)
************************************************************************
*
      irc=0
*
*----------------------------------------------------------------------*
*     Read the overlap matrix                                          *
*----------------------------------------------------------------------*
      nnB=0
      nBmx=0
      nOrbmx=0
      Do iSym=1,nSym
         nnB=nnB+nBas(iSym)*(nBas(iSym)+1)/2
         nBmx=Max(nBmx,nBas(iSym))
         nOrbmx=Max(nOrbmx,mOrb(iSym))
      End Do
      Call GetMem('iD','Allo','Inte',ip_iD,2*nOrbmx+nBmx)
      Call GetMem('Smat','Allo','Real',ipS,nnB+nBmx**2)
      iSQ=ipS+nnB
      isymlbl=1
      Call RdOne(irc,6,'Mltpl  0',1,Work(ipS),isymlbl)
      If (irc.ne.0) Return
      Call GetMem('LCMO','Allo','Real',ip_C,(5*nBmx+nOrbmx+2)*nOrbmx)
      lScr=nBmx*nOrbmx
      ip_CC=ip_C+lScr
      ip_X=ip_CC+lScr
      iZ=ip_X+lScr
      ipScr=iZ+lScr
      ip_U=ipScr+lScr
      iQ=ip_U+nOrbmx**2
      ip_FOcc=iQ+nOrbmx
*
      iOff=0
      jOff=0
      kOff=0
      Do iSym=1,nSym

         nBa=0
         Do ia=1,nBas(iSym)
            ja=ia+iOff
            tmp=Name(ja)(1:LENIN)
            Do j=1,nActa
               If(NamAct(j).eq.tmp) Then
                  iWork(ip_iD+nBa)=ia
                  nBa=nBa+1
               EndIf
            End Do
         End Do
         Do ia=1,nBa
            ifr=jOff+jD(ia)
            ito=ip_C+ia-1
            call dcopy_(mOrb(iSym),Xmo(ifr),nBas(iSym),Work(ito),nBa)
         End Do
         iS=ipS+kOff
         Do ia=1,nBa
            jb=jD(ia)
            jfr=iS+jb*(jb-1)/2
            jto=iSQ+nBas(iSym)*(ia-1)
            call dcopy_(jb,Work(jfr),1,Work(jto),1)
            jto=jto+jb
            Do ka=jb+1,nBas(iSym)
               iab=iS+ka*(ka-1)/2+jb-1
               Work(jto)=Work(iab)
               jto=jto+1
            End Do
         End Do
         nBx=Max(1,nBas(iSym))
         nBax=Max(1,nBa)
         Call DGEMM_('T','N',nBa,mOrb(iSym),nBas(iSym),
     &                    1.0d0,Work(iSQ),nBx,
     &                          Xmo(jOff+1),nBx,
     &                    0.0d0,Work(iZ),nBax)
         Do i=0,mOrb(iSym)-1
            jQ=iQ+i
            jC=ip_C+nBa*i
            jZ=iZ+nBa*i
            Work(jQ)=ddot_(nBa,Work(jC),1,Work(jZ),1)**2
         End Do
         n_OK=0
         n_KO=0
         Do i=1,mOrb(iSym)
            jQ=iQ+i-1
            jfr=jOff+nBas(iSym)*(i-1)+1
            If (sqrt(Work(jQ)).ge.ThrSel) Then
               jX=ip_X+nBas(iSym)*n_OK
               call dcopy_(nBas(iSym),Xmo(jfr),1,Work(jX),1)
               iWork(ip_iD+nBmx+n_OK)=i
               n_OK=n_OK+1
            Else
               jZ=iZ+nBas(iSym)*n_KO
               call dcopy_(nBas(iSym),Xmo(jfr),1,Work(jZ),1)
               iWork(ip_iD+nBmx+nOrbmx+n_KO)=i
               n_KO=n_KO+1
            EndIf
         End Do
         Call Square(Work(iS),Work(iSQ),1,nBas(iSym),nBas(iSym))
         mOx=Max(1,mOrb(iSym))
         Call DGEMM_('T','N',mOrb(iSym),nBas(iSym),nBas(iSym),
     &                           1.0d0,Cmo(jOff+1),nBx,
     &                                 Work(iSQ),nBx,
     &                           0.0d0,Work(ip_CC),mOx)

         Call DGEMM_('N','N',mOrb(iSym),n_OK,nBas(iSym),
     &                           1.0d0,Work(ip_CC),mOx,
     &                                 Work(ip_X),nBx,
     &                           0.0d0,Work(ip_U),mOx)
         jOcc=iOff+nFro(iSym)+1
         Call Get_Nat_Lorb(OccN(jOcc),Work(ip_FOcc),n_OK,mOrb(iSym),
     &                     iWork(ip_iD+nBmx),Work(ip_U),iSym)
         nOx=Max(1,n_OK)
         Call DGEMM_('N','N',nBas(iSym),n_OK,n_OK,
     &                1.0d0,Work(ip_X),nBx,
     &                      Work(ip_U),nOx,
     &                0.0d0,Work(ipScr),nBx)
         Do i=1,n_OK
            kl=ipScr+nBas(iSym)*(i-1)
            j=kD(i)
            km=jOff+nBas(iSym)*(j-1)+1
            call dcopy_(nBas(iSym),Work(kl),1,Xmo(km),1)
         End Do

         Call DGEMM_('N','N',mOrb(iSym),n_KO,nBas(iSym),
     &                           1.0d0,Work(ip_CC),mOx,
     &                                 Work(iZ),nBx,
     &                           0.0d0,Work(ip_U),mOx)
         Call Get_Nat_Lorb(OccN(jOcc),Work(ip_FOcc),n_KO,mOrb(iSym),
     &                     iWork(ip_iD+nBmx+nOrbmx),Work(ip_U),iSym)
         nOx=Max(1,n_KO)
         Call DGEMM_('N','N',nBas(iSym),n_KO,n_KO,
     &                1.0d0,Work(iZ),nBx,
     &                      Work(ip_U),nOx,
     &                0.0d0,Work(ipScr),nBx)
         Do i=1,n_KO
            kl=ipScr+nBas(iSym)*(i-1)
            j=lD(i)
            km=jOff+nBas(iSym)*(j-1)+1
            call dcopy_(nBas(iSym),Work(kl),1,Xmo(km),1)
            k=jOcc+j-1
            l=ip_FOcc+j-1
            OccN(k)=Work(l)
         End Do
         Do i=1,n_OK
            j=kD(i)
            k=jOcc+j-1
            l=ip_FOcc+j-1
            OccN(k)=Work(l)
         End Do

         iOff=iOff+nBas(iSym)
         jOff=jOff+nBas(iSym)*mOrb(iSym)
         kOff=kOff+nBas(iSym)*(nBas(iSym)+1)/2
      End Do

      Call GetMem('LCMO','Free','Real',ip_C,(5*nBmx+nOrbmx+2)*nOrbmx)
      CALL GetMem('Smat','Free','Real',ipS,nnB+nBmx**2)
      Call GetMem('iD','Free','Inte',ip_iD,2*nOrbmx+nBmx)

      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine Get_Nat_Lorb(Occ,FOcc,nO,nX,jOrb,Umat,iSym)

      Implicit Real*8 (a-h,o-z)
      Real*8  Occ(*), FOcc(*), Umat(*)
      Integer nO, nX, jOrb(nO), iSym
#include "WrkSpc.fh"
*
*
      If (nO.lt.1)  Return
*
      Call GetMem('eta_ik','Allo','Real',ip_eta,2*nX**2+1)
      ip_Z=ip_eta+nX**2
      ip_ZZ=ip_Z+nX
      Call FZero(Work(ip_eta),nX**2)
      Do i=1,nX
         ii=ip_eta+nX*(i-1)+i-1
         Work(ii)=Occ(i)
      End Do
      nXx=Max(1,nX)
      nOx=Max(1,nO)
      Call DGEMM_('N','N',nX,nO,nX,1.0d0,Work(ip_eta),nXx,
     &                                  Umat(1),nXx,
     &                            0.0d0,Work(ip_Z),nXx)
      Call DGEMM_('T','N',nO,nO,nX,1.0d0,Umat(1),nXx,
     &                                  Work(ip_Z),nXx,
     &                            0.0d0,Work(ip_eta),nOx)

      Call Eigen_Molcas(nO,Work(ip_eta),Work(ip_Z),Work(ip_ZZ))

      call dcopy_(nO**2,Work(ip_eta),1,Umat(1),1)
      Do i=1,nO
         ii=ip_Z+i-1
         j=jOrb(i)
         FOcc(j)=Work(ii)
         kk=ip_ZZ+i-1
      End Do
      Call GetMem('eta_ik','Free','Real',ip_eta,2*nX**2+1)

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iSym)
      End
************************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Coen de Graaf                                    *
!               1999, Anders Bernhardsson                              *
!               1999, Roland Lindh                                     *
!***********************************************************************

subroutine Molden_Interface(iUHF,FName,filename)
!***********************************************************************
!                                                                      *
!     Object: to generate MOLDEN input file                            *
!                                                                      *
!     Authors: Coen de Graaf, Anders Bernardsson and R. Lindh, 1999    *
!                                                                      *
!***********************************************************************

use Basis_Info, only: dbsc, MolWgh, nBas, nCnttp, Shells
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep, lIrrep
use Sizes_of_Seward, only: S
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: iUHF
character(len=*), intent(in) :: FName, Filename
integer(kind=iwp) :: i, iAngMx_Valence, iatom, iB, iCntr, iCnttp, icontr, iD, iData, iDeg, iDummy(1), iErr, ii, iIrrep, ik, iPL, &
                     iprim, iRc = 0, iS, isegm, ishell, iWFtype, j, jData, jPL, k, kk, kk_Max, l, Lu_, mdc, MF, nAtom, nB, nData, &
                     nDeg, nOrb(8), nTest, nTot, nTot2
real(kind=wp) :: Check_CMO, Check_Energy, Check_Occupation, coeff, prim
logical(kind=iwp) :: Exists, Found, y_cart, y_sphere
character(len=100) :: Supername
character(len=40) :: VTitle
character(len=8) :: Env
integer(kind=iwp), allocatable :: Cent(:,:), Cent2(:), Cent3(:), ibas_lab(:), Phase(:,:)
real(kind=wp), allocatable :: AdCMO(:), AdCMO_ab(:), AdEor(:), AdEor_ab(:), AdOcc(:), AdOcc_ab(:), C2(:,:), C2_ab(:,:), Coor(:,:), &
                              Mull(:), r_Norm(:), V(:,:), V_ab(:,:), Znuc(:)
character(len=LenIn8+1), allocatable :: gtolabel(:)
character(len=LenIn8), allocatable :: label(:)
character(len=LenIn), allocatable :: AtomLabel(:)
character(len=8), allocatable :: MO_Label(:)
real(kind=wp), parameter :: EorbThr = 50.0_wp
character, parameter :: shelllabel(7) = ['s','p','d','f','g','h','i'], &
                        cNumber(61) = ['1','2','3','4','5','6','7','8','9','0', &
                                       'a','b','c','d','e','f','g','h','i','j', &
                                       'k','l','m','n','o','p','q','r','s','t', &
                                       'u','v','w','x','y','z','A','B','C','D', &
                                       'E','F','G','H','I','J','K','L','M','N', &
                                       'O','P','Q','R','S','T','V','W','X','Y', &
                                       'Z']
integer(kind=iwp), external :: iPrintLevel
real(kind=wp), external :: DblFac
logical(kind=iwp), external :: Reduce_Prt
character(len=100), external :: Get_SuperName
!integer(kind=iwp), parameter :: MaxOrb_Molden = 400

if (iRc == 1) return

! Do nothing within numerical_gradient
SuperName = Get_Supername()
if (SuperName == 'numerical_gradient') then
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the print level

iPL = iPrintLevel(-1)
jPL = iPL
if (Reduce_Prt() .and. (iPL < 3)) jPL = 0
!                                                                      *
!***********************************************************************
!                                                                      *
if (MolWgh == 1) then
  if (jPL >= 2) then
    write(u6,*) 'Molden_Interface: Unsupported normalization,Molwgh=1!'
  end if
  iRc = 1
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call GetEnvf('MOLCAS_MOLDEN',Env)
!if ((Env == ' ') .or. (Env == 'OFF')) then
if (Env == 'OFF') then
  if (jPL >= 2) then
    write(u6,*)
    write(u6,*) ' Molden files will not be produced'
    write(u6,*)
  end if
  iRC = 1
  return
end if
!VV: current version of Molden has no clear limit for MaxOrb
!if (MaxOrb > MaxOrb_Molden) then
!   if (jPL >= 2) then
!      write(u6,*)
!      write(u6,*) ' Molden_Interface: W A R N I N G !!!!'
!      write(u6,*)
!      write(u6,*) ' No Molden input file will be generated!'
!      write(u6,*)
!      write(u6,*) ' Calculation exceeds the max number of orbitals allowed for MOLDEN. To change this modify the'
!      write(u6,*) ' parameter MaxOrb_Molden in src/util/molden_interface.f and follow the instructions in Molden'
!      write(u6,*) ' on how to modify the parameter MaxOrb.'
!      write(u6,*)
!   end if
!   iRC = 1
!   return
!end if
!                                                                      *
!***********************************************************************
!                                                                      *
Check_CMO = Zero
Check_Energy = Zero
Check_Occupation = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
call f_Inquire('RUNFILE',Exists)
if (.not. Exists) then
  iRC = 1
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Read the characteristics of all different basis sets,
! provide each atom with a nuclear charge and establish
! a link between an atom and its basis set ---
!
! NOTICE!!!
! This call will also fill Basis_Info and Center_Info.

call mma_allocate(AtomLabel,MxAtom,label='AtomLabel')
call mma_allocate(iBas_Lab,MxAtom,label='iBas_Lab')
call mma_allocate(Coor,3,MxAtom,label='Coor')
call mma_allocate(Znuc,MxAtom,label='Znuc')
call Inter1(AtomLabel,iBas_Lab,Coor,Znuc,nAtom)
call Qpg_iArray('nOrb',Found,nData)
if (Found) then
  call Get_iArray('nOrb',nOrb,nData)
else
  nOrb(:) = nBas(:)
end if
call mma_deallocate(iBas_Lab)
!                                                                      *
!***********************************************************************
!                                                                      *
iAngMx_Valence = 0
do iCnttp=1,nCnttp
  if ((.not. dbsc(iCnttp)%Aux) .and. (.not. dbsc(iCnttp)%Frag)) then
    nTest = dbsc(iCnttp)%nVal-1
    iAngMx_Valence = max(iAngMx_Valence,nTest)
  end if
end do
if (iAngMx_Valence > 4) then
  if (jPL >= 2) then
    write(u6,*) 'Sorry, Molden does not know how to handle'
    write(u6,*) 'functions with angular momentum larger than g'
  end if
  call End1()
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Unnormalize contraction coefficients for the valence shells

do iCnttp=1,nCnttp
  if ((.not. dbsc(iCnttp)%Aux) .and. (.not. dbsc(iCnttp)%Frag)) then
    do l=0,dbsc(iCnttp)%nVal-1
      ishell = dbsc(iCnttp)%iVal+l
      if (Shells(ishell)%Transf .and. (.not. Shells(iShell)%Prjct)) then
        if (jPL >= 2) then
          write(u6,*) 'Sorry, Molden does not support contaminants'
        end if
        call End1()
        return
      end if
      call Unnrmlz(Shells(ishell)%Exp,Shells(ishell)%nExp,Shells(ishell)%pCff,Shells(ishell)%nBasis,l)
    end do
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute memory requirements and allocate memory

nB = 0
do iS=0,nirrep-1
  nB = nB+nBas(is)
end do
call mma_allocate(MO_Label,nB,label='MO_Label')
call mma_allocate(gtolabel,nB,label='gtolabel')
call mma_allocate(r_Norm,nB,label='r_Norm')
call mma_allocate(Cent,8,nB,label='ICENT')
call mma_allocate(Phase,8,nB,label='IPHASE')
call mma_allocate(Cent2,nB,label='nCENT')
call mma_allocate(Cent3,nB,label='ICENTER')
call mma_allocate(C2,nB,nB,label='CMO2')
call mma_allocate(V,nB,nB,label='VECTOR')
V(:,:) = Zero
if (iUHF == 1) then
  call mma_allocate(C2_ab,nB,nB,label='CMO2')
  call mma_allocate(V_ab,nB,nB,label='VECTOR')
  V_ab(:,:) = Zero
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Open input file for MOLDEN

MF = 9
call molcas_open(MF,filename)
!                                                                      *
!***********************************************************************
!                                                                      *
! Write the atom information in MOLDEN format to unit MF

y_cart = .false.
y_sphere = .false.
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag) cycle
  do iCntr=1,dbsc(iCnttp)%nCntr
    do l=0,dbsc(iCnttp)%nVal-1
      ! Test for the appearance of cartesian functions with l=2,3,4
      ishell = dbsc(iCnttp)%iVal+l
      if ((l >= 2) .and. (.not. y_cart)) then
        if (.not. Shells(ishell)%Transf) y_cart = .true.
      end if
      if ((l >= 2) .and. (.not. y_sphere)) then
        if (Shells(ishell)%Transf) y_sphere = .true.
      end if
      if (y_sphere .and. y_cart) then
        if (jPL >= 2) then
          write(u6,*)
          write(u6,*) 'Failed to generate input file to MOLDEN'
          write(u6,*) 'No mixing allowed of spherical and cartesian d, f, g-functions'
        end if
        call End2()
        return
      end if
    end do
  end do
end do
write(MF,'(A)') '[Molden Format]'
!                                                                      *
!***********************************************************************
!                                                                      *
! Write atomic information

write(MF,'(A)') '[N_Atoms]'
write(MF,*) natom
write(MF,'(A)') '[Atoms] (AU)'
do iatom=1,natom
  write(MF,99) AtomLabel(iatom),iatom,int(Znuc(iatom)),(coor(i,iatom),i=1,3)
end do
if (.not. y_cart) then
  if (S%iAngMx > 1) write(MF,'(A)') '[5D]'
  if (S%iAngMx > 2) write(MF,'(A)') '[7F]'
  if (S%iAngMx > 3) write(MF,'(A)') '[9G]'
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out charges and dipole moments

call qpg_dArray('Mulliken Charge',Found,nData)
if (Found) then
  write(MF,'(A)') '[Charge] (Mulliken)'
  call mma_allocate(Mull,nData,label='Mull')
  call Get_dArray('Mulliken Charge',Mull,nData)

  iData = 0
  jData = 0
  do iCnttp=1,nCnttp
    if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%pChrg) cycle
    do iCntr=1,dbsc(iCnttp)%nCntr
      iData = iData+1
      mdc = iCntr+dbsc(iCnttp)%mdci
      nDeg = nIrrep/dc(mdc)%nStab
      do iDeg=1,nDeg
        jData = jData+1
        write(MF,*) Mull(iData)
      end do
    end do
  end do
  call mma_deallocate(Mull)
  if (iData /= nData) then
    write(u6,*) 'Molden_Interface: iData.ne.nData'
    write(u6,*) 'iData,nData=',iData,nData
    call Abend()
  end if
  if (jData /= nAtom) then
    write(u6,*) 'Molden_Interface: jData.ne.nAtom'
    write(u6,*) 'jData,nAtom=',jData,nAtom
    call Abend()
  end if
end if
!write(MF,'(A)') '[NDIPOLE]'
!write(MF,'(A)') '[DIPOLE]'
!                                                                      *
!***********************************************************************
!                                                                      *
! Write Gaussian basis set information to MOLDEN input file.

write(MF,'(A)') '[GTO] (AU)'

! Read exponents and contraction coefficients of each unique basis.
! Write the present basis set (iCnttp) to the molden.input file for
! the appropriate atoms.
! Moreover, a list is constructed which contains a label for each
! GTO (gtolabel). This list follows the MOLDEN order of GTOs.
! Later this list will be used in the transformation of sabf (the
! symmetry adapted basis functions).

iatom = 0
mdc = 0
kk = 0

do iCnttp=1,nCnttp             ! loop over unique basis sets
  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag) cycle

  do iCntr=1,dbsc(iCnttp)%nCntr  ! loop over sym. unique centers
    mdc = mdc+1
    nDeg = nIrrep/dc(mdc)%nStab
    do iDeg=1,nDeg             ! loop over centers
      iAtom = iAtom+1
      write(MF,'(I4)') iAtom

      do l=0,dbsc(iCnttp)%nVal-1
        ishell = dbsc(iCnttp)%iVal+l
        if (Shells(iShell)%nBasis > size(cNumber)) then
          write(u6,*) 'Interf: too many contracted functions!'
          write(u6,*) 'nBasis(iShell)=',Shells(iShell)%nBasis
          call Abend()
        end if

        ! Iterate over each contracted GTO

        do icontr=1,Shells(ishell)%nBasis

          ! Find the number of exponents with non-zero exponents

          isegm = 0
          do iprim=1,Shells(ishell)%nExp
            coeff = Shells(ishell)%pCff(iprim,icontr)
            if (coeff /= Zero) then
              isegm = isegm+1
            end if
          end do

          write(MF,'(3x,A1,I4)') shelllabel(l+1),isegm

          ! Write exponents and contraction coefficients.

          do iprim=1,Shells(ishell)%nExp
            coeff = Shells(ishell)%pCff(iprim,icontr)
            prim = Shells(ishell)%Exp(iprim)
            if (coeff /= Zero) then
              write(MF,'(E17.9,E17.9)') prim,coeff
            end if
          end do

          ! Construction of gtolabel
          ! Molden order: for p-functions: px(1), py(1), pz(1),
          !                                px(2), py(2), pz(2), etc.
          ! for d-, and f-functions: similar

          if (l == 0) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'01s     '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
          end if
          if (l == 1) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'02px    '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'02py    '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'02pz    '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
          end if
          if ((l == 2) .and. (.not. y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d00   '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d01+  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d01-  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d02+  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'03d02-  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
          end if
          if ((l == 2) .and. (y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d020000 '//cNumber(icontr)
            r_Norm(kk) = CC(2,0,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d000200 '//cNumber(icontr)
            r_Norm(kk) = CC(0,2,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d000002 '//cNumber(icontr)
            r_Norm(kk) = CC(0,0,2)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d010100 '//cNumber(icontr)
            r_Norm(kk) = CC(1,1,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d010001 '//cNumber(icontr)
            r_Norm(kk) = CC(1,0,1)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'d000101 '//cNumber(icontr)
            r_Norm(kk) = CC(0,1,1)
            Cent3(kk) = iAtom
          end if
          if ((l == 3) .and. (.not. y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f00   '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f01+  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f01-  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f02+  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f02-  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f03+  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'04f03-  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
          end if
          if ((l == 3) .and. (y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f030000 '//cNumber(icontr)
            r_Norm(kk) = CC(3,0,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f000300 '//cNumber(icontr)
            r_Norm(kk) = CC(0,3,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f000003 '//cNumber(icontr)
            r_Norm(kk) = CC(0,0,3)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f010200 '//cNumber(icontr)
            r_Norm(kk) = CC(1,2,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f020100 '//cNumber(icontr)
            r_Norm(kk) = CC(2,1,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f020001 '//cNumber(icontr)
            r_Norm(kk) = CC(2,0,1)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f010002 '//cNumber(icontr)
            r_Norm(kk) = CC(1,0,2)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f000102 '//cNumber(icontr)
            r_Norm(kk) = CC(0,1,2)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f000201 '//cNumber(icontr)
            r_Norm(kk) = CC(0,2,1)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'f010101 '//cNumber(icontr)
            r_Norm(kk) = CC(1,1,1)
            Cent3(kk) = iAtom
          end if
          if ((l == 4) .and. (.not. y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g00   '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g01+  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g01-  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g02+  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g02-  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g03+  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g03-  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g04+  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'05g04-  '//cNumber(icontr)
            r_Norm(kk) = One
            Cent3(kk) = iAtom
          end if
          if ((l == 4) .and. (y_cart)) then
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g040000 '//cNumber(icontr)
            r_Norm(kk) = CC(4,0,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000400 '//cNumber(icontr)
            r_Norm(kk) = CC(0,4,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000004 '//cNumber(icontr)
            r_Norm(kk) = CC(0,0,4)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g030100 '//cNumber(icontr)
            r_Norm(kk) = CC(3,1,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g030001 '//cNumber(icontr)
            r_Norm(kk) = CC(3,0,1)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g010300 '//cNumber(icontr)
            r_Norm(kk) = CC(1,3,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000301 '//cNumber(icontr)
            r_Norm(kk) = CC(0,3,1)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g010003 '//cNumber(icontr)
            r_Norm(kk) = CC(1,0,3)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000103 '//cNumber(icontr)
            r_Norm(kk) = CC(0,1,3)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g020200 '//cNumber(icontr)
            r_Norm(kk) = CC(2,2,0)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g020002 '//cNumber(icontr)
            r_Norm(kk) = CC(2,0,2)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g000202 '//cNumber(icontr)
            r_Norm(kk) = CC(0,2,2)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g020101 '//cNumber(icontr)
            r_Norm(kk) = CC(2,1,1)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g010201 '//cNumber(icontr)
            r_Norm(kk) = CC(1,2,1)
            Cent3(kk) = iAtom
            kk = kk+1
            gtolabel(kk) = AtomLabel(iAtom)//'g010102 '//cNumber(icontr)
            r_Norm(kk) = CC(1,1,2)
            Cent3(kk) = iAtom
          end if
        end do
      end do
      write(MF,'(A)') ' '
    end do
  end do
end do
kk_Max = kk
if (nB > kk_max) then
  if (jPL >= 2) then
    write(u6,*) 'Molden_Interface: nB.gt.kk_max'
    write(u6,*) 'nB,kk_Max=',nB,kk_Max
  end if
  call End2()
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
nTot = 0
nTot2 = 0
do iS=0,nIrrep-1
  nTot = nTot+nBas(iS)
  nTot2 = nTot2+nBas(iS)**2
end do
call mma_allocate(AdOcc,nTot,label='Occ')
call mma_allocate(AdEor,nTot,label='Eor')
call mma_allocate(AdCMO,nTot2,label='CMO')
AdOcc(:) = Zero
AdEor(:) = Zero
AdCMO(:) = Zero
if (iUHF == 1) then
  call mma_allocate(AdOcc_ab,nTot,label='Occ')
  call mma_allocate(AdEor_ab,nTot,label='Eor')
  call mma_allocate(AdCMO_ab,nTot2,label='CMO')
  AdOcc_ab(:) = Zero
  AdEor_ab(:) = Zero
  AdCMO_ab(:) = Zero
else
  call mma_allocate(AdOcc_ab,0,label='Occ')
  call mma_allocate(AdEor_ab,0,label='Eor')
  call mma_allocate(AdCMO_ab,0,label='CMO')
end if

! Read HF CMOs from file

Lu_ = 75
call RdVec_(FName,Lu_,'COE',iUHF,nIrrep,nBas,nBas,AdCMO,AdCMO_ab,AdOcc,AdOcc_ab,AdEor,AdEor_ab,iDummy,VTitle,1,iErr,iWFtype)

! Get the coeff. of sym adapted basis functions (C2)

call Dens_IF_SCF(C2,AdCMO,'F')
if (iUHF == 1) then
  call Dens_IF_SCF(C2_ab,AdCMO_ab,'F')
end if
call mma_deallocate(AdCMO)
call mma_deallocate(AdCMO_ab)
!                                                                      *
!***********************************************************************
!                                                                      *
!  Back 'transformation' of the symmetry adapted basis functions.
!  Probably somewhat clumsy, but it seems to work. If someone
!  knows a more elegant way to do it, please improve this part!
!
!  PART 1: Obtain symmetry information (soout), construct a label
!          for each sabf, which will be used in part 2 to find the
!          corresponding GTO in the MOLDEN list by comparing with
!          gtolabel
!
!  nB     --- Total number of contracted basis functions
!  cent2  --- degeneracy of a basis function
!  Cent   --- centres over which the basis function is delocalized
!  Phase  --- phase of the AO in the linear combination

call mma_allocate(label,MaxBfn+MaxBfn_Aux,label='label')
Phase(:,:) = 0
Cent(:,:) = 0
call SOout(label,Cent,Phase)
do iContr=1,nB
  Cent2(iContr) = 0
  do k=1,8
    if (Cent(k,iContr) /= 0) Cent2(iContr) = Cent2(iContr)+1
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
!
! Part 2: -Take a MOLCAS symmetry functions (loop i)
!         -Find the corresponding label in the MOLDEN list (loop j)
!         -Copy the coeff of the sabf in the MOLDEN MO (vector), multiply
!          by the appropriate factor (Phase),and divide by the number of
!          centres over which the sabf is delocalized (Cent3).
!         -The vectors are copied by rows!

! loop over MOLCAS symmetry functions
i = 0
ik = 0
do iIrrep=0,nIrrep-1

  do iB=1,nBas(iIrrep)
    i = i+1

    if (iB == 1) then
      ik = 1
    else
      if (label(i-1) == label(i)) then
        ik = ik+1
      else
        ik = 1
      end if
    end if
    if (ik > size(cNumber)) then
      write(u6,*) 'Molden_Interface: ik > size(cNumber)'
      write(u6,*) 'ik,size(cNumber)=',ik,size(cNumber)
      write(u6,*) 'List of labels'
      do iD=1,nB
        write(u6,'(A)') Label(i)
      end do
      call End3()
      return
    end if

    write(MO_Label(i),'(I5,A3)') iB,lirrep(iIrrep)

    do j=1,nB

      if (gtolabel(j) == label(i)//cNumber(ik)) then
        do k=1,8
          if (Cent(k,i) == Cent3(j)) then
            do ii=1,nB
              if (MolWgh == 0) then
                V(j,ii) = V(j,ii)+(C2(i,ii)*r_Norm(j))*real(Phase(k,i),kind=wp)/real(Cent2(i),kind=wp)
                if (iUHF == 1) V_ab(j,ii) = V_ab(j,ii)+(C2_ab(i,ii)*r_Norm(j))*real(Phase(k,i),kind=wp)/real(Cent2(i),kind=wp)
              else
                V(j,ii) = V(j,ii)+(C2(i,ii)*r_Norm(j))*real(Phase(k,i),kind=wp)/sqrt(real(Cent2(i),kind=wp))
                if (iUHF == 1) V_ab(j,ii) = V_ab(j,ii)+(C2_ab(i,ii)*r_Norm(j))*real(Phase(k,i),kind=wp)/sqrt(real(Cent2(i),kind=wp))
              end if
            end do
          end if
        end do
      end if
    end do
  end do
end do
call mma_deallocate(label)
!                                                                      *
!***********************************************************************
!                                                                      *
!  Dump vector in the molden.input file

write(MF,'(A)') '[MO]'
do i=1,nB
  if (AdEOr(i) <= EorbThr) then
    write(MF,'(A,A)') 'Sym= ',MO_Label(i)
    write(MF,103) AdEOr(i)
    write(MF,'(A)') 'Spin= Alpha'
    write(MF,104) AdOcc(i)
    if (AdEOr(i) < Zero) then
      Check_Energy = Check_Energy+AdEOr(i)*real(i,kind=wp)
    end if
    Check_Occupation = Check_Occupation+AdOcc(i)*real(i,kind=wp)
    do j=1,nB
      write(MF,100) j,V(j,i)
      Check_CMO = Check_CMO+V(j,i)**2
    end do
  end if

  if (iUHF == 1) then
    if (AdEOr_ab(i) <= EorbThr) then
      write(MF,'(A,A)') 'Sym= ',MO_Label(i)
      write(MF,103) AdEOr_ab(i)
      write(MF,'(A)') 'Spin= Beta'
      write(MF,104) AdOcc_ab(i)
      Check_Energy = Check_Energy+AdEOr_ab(i)*real(i,kind=wp)
      Check_Occupation = Check_Occupation+AdOcc_ab(i)*real(i,kind=wp)
      do j=1,nB
        write(MF,100) j,V_ab(j,i)
        Check_CMO = Check_CMO+V_ab(j,i)**2
      end do
    end if
  end if

end do
!                                                                      *
!***********************************************************************
!                                                                      *
!if (Env /= 'OFF') then
!  if (iUHF < 2) call Add_Info('MOLDEN_CMO',Check_CMO,1,2)
!  call Add_Info('MOLDEN_Occupation',Check_Occupation,1,2)
!  call Add_Info('MOLDEN_Energy',Check_Energy,1,2)
!end if
!                                                                      *
!***********************************************************************
!                                                                      *
do iCnttp=1,nCnttp
  if ((.not. dbsc(iCnttp)%Aux) .and. (.not. dbsc(iCnttp)%Frag)) then
    do l=0,dbsc(iCnttp)%nVal-1
      ishell = dbsc(iCnttp)%iVal+l
      call Unnrmlz2(Shells(ishell)%Exp,Shells(ishell)%nExp,Shells(ishell)%pCff,Shells(ishell)%nBasis,l)
    end do
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *
if (jPL >= 2) then
  write(u6,*)
  write(u6,'(6X,A)') 'Input file to MOLDEN was generated!'
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call End3()

return

! -------------FORMATS-------------
99 format(A,2(3x,I4),5x,3F16.8,3I4)
100 format(I4,3x,F16.8)
103 format('Ene= ',F10.4)
104 format('Occup= ',F10.5)

contains

function CC(ix,iy,iz)
  real(kind=wp) :: CC
  integer(kind=iwp), intent(in) :: ix, iy, iz
  CC = sqrt(DblFac(2*ix-1)*DblFac(2*iy-1)*DblFac(2*iz-1))
end function CC

subroutine End1()
  call mma_deallocate(AtomLabel)
  call mma_deallocate(Coor)
  call mma_deallocate(Znuc)
  call ClsSew()
end subroutine End1

subroutine End2()
  call mma_deallocate(MO_Label)
  call mma_deallocate(gtolabel)
  call mma_deallocate(r_Norm)
  call mma_deallocate(Cent)
  call mma_deallocate(Phase)
  call mma_deallocate(Cent2)
  call mma_deallocate(Cent3)
  call mma_deallocate(C2)
  call mma_deallocate(V)
  if (iUHF == 1) then
    call mma_deallocate(C2_ab)
    call mma_deallocate(V_ab)
  end if
  close(MF)
  call End1()
end subroutine End2

subroutine End3()
  call mma_deallocate(AdOcc)
  call mma_deallocate(AdEor)
  call mma_deallocate(AdOcc_ab)
  call mma_deallocate(AdEor_ab)
  call End2()
end subroutine End3

end subroutine Molden_Interface

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrintTriangMat(nRow,A)
! Prints a triangular matrix A(nRow,nRow)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nRow
real(kind=wp), intent(in) :: A(nRow*(nRow+1)/2)
integer(kind=iwp) :: i, iCount

if (nRow > 8) return
iCount = 1
do i=1,nRow
  write(u6,'(8F10.6)') A(iCount:iCount+i-1)
  iCount = iCount+i
end do

return

end subroutine PrintTriangMat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DSQ(A,B,ICB,IRB,NROW)

use Constants, only: Two, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: A(*)
real(kind=wp), intent(_OUT_) :: B(*)
integer(kind=iwp), intent(in) :: ICB, IRB, NROW
integer(kind=iwp) :: ICOL, IND, IROW

IND = 0
do IROW=0,NROW-1
  do ICOL=0,IROW
    IND = IND+1
    B(1+IROW*ICB+ICOL*IRB) = Half*A(IND)
    B(1+ICOL*ICB+IROW*IRB) = Half*A(IND)
  end do
  B(1+IROW*(ICB+IRB)) = Two*B(1+IROW*(ICB+IRB))
end do

return

end subroutine DSQ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Giovanni Li Manni                                *
************************************************************************
      FUNCTION ICHECK_OCC_IN_ACCSPC(IOCC,IMINMAX,NGAS,MXPNGAS)
* Check if Occupation of GAS Spaces defined by IOCC are
* within the constraints of  IMINMAX chosen by the user
*
* Giovanni Li Manni 7Nov2011, for BK implementation
*
#include "implicit.fh"
*. Input
      INTEGER IOCC(NGAS)
      INTEGER IMINMAX(MXPNGAS,2)
*
      I_AM_IN = 1
      DO IGAS = 1, NGAS
       IF(IOCC(IGAS).LT.IMINMAX(IGAS,1) .OR.
     &    IOCC(IGAS).GT.IMINMAX(IGAS,2)) I_AM_IN=0
      END DO
      ICHECK_OCC_IN_ACCSPC = I_AM_IN
*
      NTEST = 000
      IF(NTEST.GE.100) THEN
       WRITE(6,*) ' Input to ICHECK_OCC_IN_ACCSPC, IMINMAX'
       CALL IWRTMA(IMINMAX,NGAS,2,MXPNGAS,2)
      END IF
      IF(NTEST.GE.10) THEN
       WRITE(6,*) ' Input to ICHECK_OCC_IN_ACCSPC, IOCC'
       CALL IWRTMA(IOCC,1,NGAS,1,NGAS)
       WRITE(6,*) ' And the verdict is ', I_AM_IN
      END IF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

c     this file contains routines, required for making
c     integrals for noniterative T3 calculatins:
c     t3intpck1
c     t3intpck2
c     t3reorg
c     ccsort_t3grc0 - the copy of original routine form T3
c     DefT3par
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
       subroutine t3intpck1 (vint,r,dimv1,dimv2,dimv3,dima,dimbc,
     & symq,symr,syms,nob,nvb)
c
c     this routine pack integral block symi,symq,symr,syms
c     R_i(a,bc) = V_i(b,a,c)
c     for symq(b)=syms(c)
c     and write R block onto proper place of opened t3nam file - lunt3
c
c     vint  - integrals for given symetries for given i (I)
c     r     - final R_i matrix (O)
c     dimv1 - 1-st. dimension of V (I)
c     dimv2 - 2-nd. dimension of V (I)
c     dimv3 - 3-rd. dimension of V (I)
c     dima  - dimension of a in R (I)
c     dimbc - dimension of bc in R (I)
c     symq  - symmetry of q (b) (I)
c     symr  - symmetry of r (a) (I)
c     syms  - symmetry of s (c) (I)
c     nob   - number of beta occupied in each irrep (I)
c     nvb   - number of beta virtuals in each irrep (I)
c
       implicit none
#include "reorg.fh"
#include "files_ccsd.fh"
       integer symq,symr,syms
       integer dimv1,dimv2,dimv3,dima,dimbc
       integer nob(1:8)
       integer nvb(1:8)
       real*8 vint(1:dimv1,1:dimv2,1:dimv3)
       real*8 r(1:dima,1:dimbc)
c
c     help variables
c
       integer a,b,c,bc,adda,lenght,iaddr
c
c*    if there are no beta virtuals - goto write section
       if (nvb(symq)*nvb(symr)*nvb(syms).eq.0) then
       goto 200
       end if
c
c*    calc additional constant for a
       adda=nob(symr)
c
c*    do packing
c
       bc=0
       do 100 b=nob(symq)+1,nob(symq)+nvb(symq)
       do 101 c=nob(syms)+1,b
       bc=bc+1
       do 102 a=1,nvb(symr)
       r(a,bc)=vint(b,a+adda,c)
 102    continue
 101    continue
 100    continue
c
c*    write section
c
 200    lenght=dima*dimbc
       if (lenght.gt.0) then
       iaddr=daddr(lunt3)
       call ddafile (lunt3,1,r(1,1),lenght,iaddr)
       end if

       return
       end
c
c     -----------------------------
c
       subroutine t3intpck2 (vint,r,dimv1,dimv2,dimv3,dima,dimb,dimc,
     & symq,symr,syms,nob,nvb)
c
c     this routine pack integral block symi,symq,symr,syms
c     R_i(a,b,c) = V_i(b,a,c)
c     for symq(b)>syms(c)
c     and write R block onto proper place of opened t3nam file - lunt3
c
c     vint  - integrals for given symetries for given i (I)
c     r     - final R_i matrix (O)
c     dimv1 - 1-st. dimension of V (I)
c     dimv2 - 2-nd. dimension of V (I)
c     dimv3 - 3-rd. dimension of V (I)
c     dima  - dimension of a in R (I)
c     dimb  - dimension of b in R (I)
c     dimc  - dimension of c in R (I)
c     symq  - symmetry of q (b) (I)
c     symr  - symmetry of r (a) (I)
c     syms  - symmetry of s (c) (I)
c     nob   - number of beta occupied in each irrep (I)
c     nvb   - number of beta virtuals in each irrep (I)
c
       implicit none
#include "reorg.fh"
#include "files_ccsd.fh"
       integer symq,symr,syms
       integer dimv1,dimv2,dimv3,dima,dimb,dimc
       integer nob(1:8)
       integer nvb(1:8)
       real*8 vint(1:dimv1,1:dimv2,1:dimv3)
       real*8 r(1:dima,1:dimb,1:dimc)
c
c     help variables
c
       integer a,b,c,adda,addb,addc,lenght,iaddr
c
c*    if there are no beta virtuals - skip
       if (nvb(symq)*nvb(symr)*nvb(syms).eq.0) then
       return
       end if
c
c*    calc additional constants for a,b,c
       adda=nob(symr)
       addb=nob(symq)
       addc=nob(syms)

c
c*    do packing
c
       do 100 c=1,nvb(syms)
       do 101 b=1,nvb(symq)
       do 102 a=1,nvb(symr)
       r(a,b,c)=vint(b+addb,a+adda,c+addc)
 102    continue
 101    continue
 100    continue
c
c*    write section
c
        lenght=dima*dimb*dimc
       if (lenght.gt.0) then
       iaddr=daddr(lunt3)
       call ddafile (lunt3,1,r(1,1,1),lenght,iaddr)
       end if
c
       return
       end
c
c     -----------------------------
c
       subroutine t3reorg (wrk,wrksize,
     & noa,nsym)
c
c     this routine do final reorganization of t3nam file
c     and produce final form of this file
c     as it will be required in T3 and close t3nam file
c
c     noa   - array with occupation numbers
c     nsym  - actual number of irreps
c
       implicit none
#include "wrk.fh"
#include "reorg.fh"
#include "files_ccsd.fh"
       integer noa(1:8)
       integer nsym
c
c     help variables
c
       integer lenght,iri,possri
       integer posst
       integer symi,i,iaddr,iindex,iPossPack
c
c*        def iPossPack
c           iPossPack - possition of (maps+Ri) set in packed
c                        (i.e. final) of T3nam file
        iPossPack=T3IntPoss(1)
c
        iindex=0
        do symi=1,nsym
c
c0      get map's of R_i(a,bc)
        call ccsort_t3grc0
     c       (3,8,4,4,4,0,symi,possri0,posst,mapdri,mapiri)
c
        do i=1,noa(symi)
        iindex=iindex+1
c
c1        reconstruct R_i(a,bc) per blocks as in is
c         actually written in t3man file
          do iri=1,mapdri(0,5)
c
c1.1        iind address of this R_i block in t3nam file
            iaddr=T3IntPoss(iindex)+T3Off(iri,symi)
c
c1.2        def possition of of this block in R1
            possri=mapdri(iri,1)
c
c1.3        read integrals into proper possition
            lenght=mapdri(iri,2)
            if (lenght.gt.0) then
            call ddafile (lunt3,2,wrk(possri),lenght,iaddr)
            end if
c
          end do
c
c2          write into t3nam file in packed form
c            1) mapdri, mapiri
c           2) R_i
c2.1          def final (packed) address for i-th set (maps+Ri)
          T3intPoss(iindex)=iPossPack
          iaddr=T3intPoss(iindex)
c
c2.2      write maps
          call idafile (lunt3,1,mapdri,3078,iaddr)
          call idafile (lunt3,1,mapiri,512,iaddr)
c
c2.3      def actual length of Ri
          lenght=0
          do iri=1,mapdri(0,5)
          lenght=lenght+mapdri(iri,2)
          end do
c         lenght=mapdri(iri,1)+mapdri(iri,2)-mapdri(1,1)
c
c2.4          write Ri as one block
          call ddafile (lunt3,1,wrk(possri0),lenght,iaddr)
c
c2.5          save updated address as a new packed (final) possition
c         for next i
          iPossPack=iaddr
c
        end do
        end do
c
c3        store new packed (final) addreses T3IntPoss in t3nam file
c       (at the beggining)
        iaddr=0
        call idafile (lunt3,1,T3IntPoss,mbas,iaddr)
c
c4        close t3nam file
        call daclos (lunt3)
c
       return
       end
c
c     -----------------------------
c
       subroutine ccsort_t3grc0 (nind,typ,typp,typq,typr,typs,stot,
     & poss0,posst,mapd,mapi)
c
c     N.B. This routine is in principle copy of those in T3,
c     but some changes was done:
c     1) mmul is substituted by mul
c     2) dimm is added, since using of ccsd1.com is inpossible
c     3) ccsd1.com is replaced by ccsort.fh
c
c     nind   - number of indexes (I)
c     typ    - typ of mediate (I)
c     typp   - typ of index p (I)
c     typq   - typ of index q (I)
c     typr   - typ of index r (I)
c     typs   - typ of index s (I)
c     stot   - overall symetry of the mediate (I)
c     poss0  - initil possition of mediate (I)
c     posst  - final possition of the mediate (O)
c     mapd   - direct map of the mediate (O)
c     mapi   - inverse map of the mediate (O)
c
c     this routine defines mapd and mapi for given intermediat
c     it can done exactly the same maps like grc0 in CCSD
c     plus additional types of mediates are introduced:
c     type    meaning
c     5     p>q>r,s ; also p>q>r
c     6     p,q>r>s
c     7     p>=q,r,s ; also p>=q,r; p>=q
c     8          p,q>=r,s ; also p,q>=s
c     9     p,q,q>=s
c     10     p>=q,r>=s
c     11     p>=q>=r,s ; also p>=q>=r
c     12     p,q>=r>=s
c
c     currently, these new types are implemented only for nind=3
c
c     $N.B. (this routine cannot run with +OP2)
c     N.B. this routine do not test stupidities
c
c
       integer nind,typ,typp,typq,typr,typs,stot,poss0,posst
c
c@    include 'ccsd1.com'
#include "ccsort.fh"
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
       integer dimm(1:5,1:8)
c
c     help variables
c
       integer sp,sq,sr,ss,spq,spqr
       integer nsymq,nsymr
       integer poss,i,nhelp1,nhelp2,nhelp3,nhelp4
       integer rsk1,rsk2
c
c@    !!!!!!!! def dimm to je tu len terazky, lebo nemozeme pouzivat ccsd1.com !!!!
c
c      Tutok musim cosi inicializovat
       ss=0
       poss=0
       rsk1=0
       rsk2=0
       do i=1,nsym
       dimm(1,i)=noa(i)
       dimm(2,i)=nob(i)
       dimm(3,i)=nva(i)
       dimm(4,i)=nvb(i)
       dimm(5,i)=nva(i)+noa(i)
       end do
c
c@@
c     vanishing mapi files
c
       do nhelp1=1,nsym
       do nhelp2=1,nsym
       do nhelp3=1,nsym
       mapi(nhelp3,nhelp2,nhelp1)=0
       end do
       end do
       end do
c
       if (nind.eq.1) then
c
c     matrix A(p)
c
       i=1
       poss=poss0
       sp=mul(stot,1)
c
       nhelp1=dimm(typp,sp)
c
c     def mapi
       mapi(1,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       mapd(i,2)=nhelp1
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=0
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
       else if (nind.eq.2) then
c
c     matrix A(p,q)
c
       i=1
       poss=poss0
c
       do 100 sp=1,nsym
c
       sq=mul(stot,sp)
       if ((typ.eq.1).and.(sp.lt.sq)) then
c     Meggie out
       goto 100
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
c
c     def mapi
       mapi(sp,1,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2
       end if
c
c     def sym p,q
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=0
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 100    continue
c
       else if (nind.eq.3) then
c
c     matrix A(p,q,r)
c
c     def reucion sumations keys : rsk1 for pq, rsk2 for qr
c
       if (typ.eq.0) then
       rsk1=0
       rsk2=0
       else if (typ.eq.1) then
       rsk1=1
       rsk2=0
       else if (typ.eq.2) then
       rsk1=0
       rsk2=1
       else if (typ.eq.5) then
       rsk1=1
       rsk2=1
       else if (typ.eq.7) then
       rsk1=1
       rsk2=0
       else if (typ.eq.8) then
       rsk1=0
       rsk2=1
       else if (typ.eq.11) then
       rsk1=1
       rsk2=1
       end if
c
       i=1
       poss=poss0
c
       do 200 sp=1,nsym
       if (rsk1.eq.1) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 201 sq=1,nsymq
       spq=mul(sp,sq)
c
       sr=mul(stot,spq)
       if ((rsk2.eq.1).and.(sq.lt.sr)) then
c     Meggie out
       goto 201
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
c
c     def mapi
       mapi(sp,sq,1)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1-1)*nhelp3/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2-1)/2
       else if (typ.eq.5) then
       if (sp.eq.sr) then
       mapd(i,2)=nhelp1*(nhelp1-1)*(nhelp1-2)/6
       else if (sp.eq.sq) then
       mapd(i,2)=nhelp1*(nhelp1-1)*nhelp3/2
       else if (sq.eq.sr) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3
       end if
       else if ((typ.eq.7).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp1+1)*nhelp3/2
       else if ((typ.eq.8).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2+1)/2
       else if (typ.eq.11) then
       if (sp.eq.ss) then
       mapd(i,2)=nhelp1*(nhelp1+1)*(nhelp1+2)/6
       else if (sp.eq.sq) then
       mapd(i,2)=nhelp1*(nhelp1+1)*nhelp3/2
       else if (sq.eq.sr) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp2+1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3
       end if
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3
       end if
c
c     def sym p,q,r
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=0
c
       poss=poss+mapd(i,2)
       i=i+1
c
 201    continue
 200    continue
c
       else if (nind.eq.4) then
c
c     matrix A(p,q,r,s)
c
       i=1
       poss=poss0
c
       do 300 sp=1,nsym
       if ((typ.eq.1).or.(typ.eq.4)) then
       nsymq=sp
       else
       nsymq=nsym
       end if
c
       do 301 sq=1,nsymq
       spq=mul(sp,sq)
       if (typ.eq.2) then
       nsymr=sq
       else
       nsymr=nsym
       end if
c
       do 302 sr=1,nsymr
       spqr=mul(spq,sr)
c
       ss=mul(stot,spqr)
       if (((typ.eq.3).or.(typ.eq.4)).and.(sr.lt.ss)) then
c     Meggie out
       goto 302
       end if
c
       nhelp1=dimm(typp,sp)
       nhelp2=dimm(typq,sq)
       nhelp3=dimm(typr,sr)
       nhelp4=dimm(typs,ss)
c
c     def mapi
       mapi(sp,sq,sr)=i
c
c     def possition
       mapd(i,1)=poss
c
c     def lenght
       if ((typ.eq.1).and.(sp.eq.sq)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if ((typ.eq.2).and.(sq.eq.sr)) then
       mapd(i,2)=nhelp1*nhelp2*(nhelp3-1)*nhelp4/2
       else if ((typ.eq.3).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else if (typ.eq.4) then
       if ((sp.eq.sq).and.(sr.eq.ss)) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*(nhelp4-1)/4
       else if (sp.eq.sq) then
       mapd(i,2)=nhelp1*(nhelp2-1)*nhelp3*nhelp4/2
       else if (sr.eq.ss) then
       mapd(i,2)=nhelp1*nhelp2*nhelp3*(nhelp4-1)/2
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
       else
       mapd(i,2)=nhelp1*nhelp2*nhelp3*nhelp4
       end if
c
c     def sym p,q,r,s
       mapd(i,3)=sp
       mapd(i,4)=sq
       mapd(i,5)=sr
       mapd(i,6)=ss
c
       poss=poss+mapd(i,2)
       i=i+1
c
 302    continue
 301    continue
 300    continue
c
       end if

c
       posst=poss
c
c     definition of other coll
c
       mapd(0,1)=typp
       mapd(0,2)=typq
       mapd(0,3)=typr
       mapd(0,4)=typs
       mapd(0,5)=i-1
       mapd(0,6)=typ
c
       return
       end
c
c     -----------------------------
c
        subroutine DefT3par (noa,nsym)
c
c        this routine do:
c        0) Open t3nam file, with lunt3 lun
c        define parameters, required for T3 integral handling, namely
c        1) def T3IndPoss(i)
c          address possitions for all occupied orbitals in t3nam file
c        2) def T3Off(ii,isym)
c           relative shifts of address for ii-th block of R_i(a,bc)
c          for each symmetry
c
c     noa   - array with occupation numbers
c     nsym  - actual number of irreps
c
        implicit none
#include "reorg.fh"
#include "files_ccsd.fh"
c
       integer noa(1:8)
       integer nsym
c
c        help variables
        integer iorb,ii,i,symi,length,posst
c
c
c0        open t3nam file
c        lunt3=1
        call daname (lunt3,t3nam)
c
c1        set address poiter to 0
        daddr(lunt3)=0
c
c2        first record in t3nam file is T3IntPoss
c       (emulate writing of T3IntPoss)
        call idafile (lunt3,0,[0],mbas,daddr(lunt3))
c
        iorb=0
c3        cycle over irreps
        do symi=1,nsym
c
c3.1      make mapd and mapi for  R_i(a,bc)
          call ccsort_t3grc0
     c         (3,8,4,4,4,0,symi,possri0,posst,mapdri,mapiri)
c
c3.2          cycle over occupied orbitals in symi
          do i=1,noa(symi)
c
c3.2.1      save initial addres for this orbital
            iorb=iorb+1
            T3IntPoss(iorb)=daddr(lunt3)
c
c3.2.2      emulate writing of mapd and mapp
            call idafile (lunt3,0,[0],513*6,daddr(lunt3))
            call idafile (lunt3,0,[0],8*8*8,daddr(lunt3))
c
c3.2.3      cycle over all blocks of R_i(a,bc), which will
c           be stored separately
            do ii=1,mapdri(0,5)
c
c3.2.3.1      def T3Off(ii,symi)
c              note, that iorb is always proper one, since only besides
c             first occ. orbital in given irrep T3Off is defined
              if (i.eq.1) then
                T3Off(ii,symi)=daddr(lunt3)-T3IntPoss(iorb)
              end if
c
c3.2.3.2      emmulate writing of each block
              length=mapdri(ii,2)
              call ddafile (lunt3,0,[0.0d0],length,daddr(lunt3))
c
            end do
          end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine AI_MRCI(INTSYM,INDX,C,S,FC,A,B,FK,DBK,KTYP)

use mrci_global, only: IRC, IREST, IROW, ITER, LASTAD, LN, LSYM, Lu_60, LUSYMB, NBITM3, NBTRI, NSM, NSYM, NVIR, NVIRP, NVIRT, SQ2, &
                       SQ2INV
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: INTSYM(*), INDX(*), KTYP
real(kind=wp), intent(inout) :: C(*), S(*), FC(*)
real(kind=wp), intent(_OUT_) :: A(*), B(*), FK(*), DBK(*)
integer(kind=iwp) :: i, IADD10, IADR, ICHK, ICP1, ICP2, IFT, II, IJ, IJOLD, ILEN, IND, INDA, INDB, INDI, INMY, INNY, IOUT, &
                     IPOB(9), ITYP, J, LENGTH, MYEXTS, MYINTS, NA, NAK, NI, NJ, NK, NKM, NOTT, NOVST, NSA, NSI, NSIJ, NSJ, NSK, &
                     NVIRA, NVM, NVT, NYEXTS, NYINTS
real(kind=wp) :: COPI, SGN, TERM
integer(kind=iwp), allocatable :: iBuf(:)
real(kind=wp), allocatable :: Buf(:)
integer(kind=iwp), external :: JSUNP
real(kind=r8), external :: DDOT_

! KTYP=0,  (A/I)   INTEGRALS
! KTYP=1,  (AI/JK) INTEGRALS

call mma_allocate(Buf,NBITM3,label='BUF')
call mma_allocate(iBuf,NBITM3+2,label='IBUF')

call CSCALE(INDX,INTSYM,C,SQ2)
call CSCALE(INDX,INTSYM,S,SQ2INV)
NVT = IROW(NVIRT+1)
ICHK = 0
IJOLD = 0
NK = 0
NSA = 1
NOTT = LN*(LN+1)
NOVST = LN*NVIRT+1+NVT
!PAM97 New portable code:

if (KTYP == 0) IADD10 = IAD10(9)
if (KTYP == 1) IADD10 = IAD10(7)
! READ A COP BUFFER
do
  call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
  call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
  ILEN = ICOP1(nCOP+1)
  if (ILEN < 0) exit
  ! LOOP THROUGH THE COP BUFFER:
  do II=1,ILEN
    IND = ICOP1(II)
    if (ICHK /= 0) then
      ! BEGIN A RATHER LONG IF-BLOCK.
      ! ICHK FLAG IS SET. THIS SIGNALS THAT PREVIOUS IND WAS 0, WHICH IS
      ! USED TO INDICATE CHANGE TO A NEW BLOCK OF COUPLING COEFFICIENTS.
      ! RESET ICHK FLAG.
      ICHK = 0
      if (KTYP == 0) then
        ! AI CASE. SAVE INTERNAL ORBITAL INDEX IN NK:
        NK = IND
        IJOLD = NK
        NSK = NSM(NK)
        NSA = NSK
      else
        ! AIJK CASE. UNPACK INTERNAL ORBITAL INDICES INTO NI,NJ,NK:
        INDI = IND
        NI = ibits(INDI,0,10)
        NJ = ibits(INDI,10,10)
        NK = ibits(INDI,20,10)
        NSI = NSM(NI)
        NSJ = NSM(NJ)
        NSK = NSM(NK)
        NSIJ = MUL(NSI,NSJ)
        NSA = MUL(NSIJ,NSK)
        IJ = IROW(NI)+NJ
        if (IJ /= IJOLD) then
          ! NEW INTERNAL PAIR IJ. LOAD A NEW SET OF INTEGRALS INTO FC:
          IJOLD = IJ
          IADR = LASTAD(NOVST+NOTT+IJ)
          FC(1:NBTRI) = Zero

          do
            call iDAFILE(Lu_60,2,iBuf,NBITM3+2,IADR)
            call dDAFILE(Lu_60,2,Buf,NBITM3,IADR)
            LENGTH = iBuf(NBITM3+1)
            IADR = iBuf(NBITM3+2)
            do i=1,length
              fc(iBuf(i)) = Buf(i)
            end do
            if (IADR == -1) exit
          end do
        end if
      end if
      ! FOR THIS PARTICULAR K, TRANSFER FC(NK,NA) TO ARRAY FK:
      NVIRA = NVIR(NSA)
      do I=1,NVIRA
        NA = NVIRP(NSA)+I
        NAK = IROW(LN+NA)+NK
        FK(I) = FC(NAK)
      end do
      ! END OF THE LONG IF-BLOCK.
    else if (IND == 0) then
      ! IND=0 SIGNALS SWITCH TO A NEW SET OF INTEGRALS.
      ICHK = 1
    else if (NVIRA /= 0) then
      ! WE ARE PROCESSING A COUPLING COEFFICIENT AS USUAL.
      ITYP = ibits(IND,0,6)
      ICP2 = ibits(IND,6,13)
      ICP1 = ibits(IND,19,13)
      if (ITYP <= 1) then
        ! ITYP=1. VALENCE-SINGLES CASE.
        INDA = ICP1
        INDB = IRC(1)+ICP2
        INNY = INDX(INDB)+1
        COPI = COP(II)*C(INDA)
        S(INNY:INNY+NVIRA-1) = S(INNY:INNY+NVIRA-1)+COPI*FK(1:NVIRA)
        TERM = DDOT_(NVIRA,FK,1,C(INNY),1)
        S(INDA) = S(INDA)+COP(II)*TERM
      else if ((ITER /= 1) .or. (IREST /= 0)) then
        INDA = IRC(1)+ICP1
        INDB = IRC(ITYP)+ICP2
        INMY = INDX(INDA)+1
        INNY = INDX(INDB)+1
        MYINTS = JSUNP(INTSYM,INDA)
        NYINTS = MUL(MYINTS,NSA)
        MYEXTS = MUL(MYINTS,LSYM)
        NYEXTS = MUL(NYINTS,LSYM)
        IFT = 0
        if (ITYP == 2) IFT = 1
        call IPO(IPOB,NVIR,MUL,NSYM,NYEXTS,IFT)
        NVM = NVIR(MYEXTS)
        DBK(1:NVIRA) = COP(II)*FK(1:NVIRA)
        if (NYEXTS == 1) then
          if (IFT == 0) call SQUAR(C(INNY+IPOB(MYEXTS)),A,NVM)
          if (IFT == 1) call SQUARM(C(INNY+IPOB(MYEXTS)),A,NVM)
          B(1:NVM) = Zero
          call FMMM(DBK,A,B,1,NVM,NVIRA)
          S(INMY:INMY+NVM-1) = S(INMY:INMY+NVM-1)+B(1:NVM)
          SGN = One
          if (IFT == 1) SGN = -One
          IOUT = INNY+IPOB(MYEXTS)-1
          do I=1,NVM
            do J=1,I
              IOUT = IOUT+1
              TERM = DBK(I)*C(INMY+J-1)+SGN*DBK(J)*C(INMY+I-1)
              S(IOUT) = S(IOUT)+TERM
            end do
            if (IFT == 1) cycle
            TERM = DBK(I)*C(INMY+I-1)
            S(IOUT) = S(IOUT)-TERM
          end do
        else
          NKM = NVIRA*NVM
          B(1:NVM) = Zero
          if (NSA <= MYEXTS) then
            if (IFT == 1) DBK(1:NVIRA) = -DBK(1:NVIRA)
            call FMMM(DBK,C(INNY+IPOB(MYEXTS)),B,1,NVM,NVIRA)
            S(INMY:INMY+NVM-1) = S(INMY:INMY+NVM-1)+B(1:NVM)
            B(1:NKM) = Zero
            call FMMM(DBK,C(INMY),B,NVIRA,NVM,1)
            J = INNY+IPOB(MYEXTS)
            S(J:J+NKM-1) = S(J:J+NKM-1)+B(1:NKM)
          else
            call FMMM(C(INNY+IPOB(NSA)),DBK,B,NVM,1,NVIRA)
            S(INMY:INMY+NVM-1) = S(INMY:INMY+NVM-1)+B(1:NVM)
            B(1:NKM) = Zero
            call FMMM(C(INMY),DBK,B,NVM,NVIRA,1)
            J = INNY+IPOB(NSA)
            S(J:J+NKM-1) = S(J:J+NKM-1)+B(1:NKM)
          end if
        end if
      end if
    end if
  end do
end do
call CSCALE(INDX,INTSYM,C,SQ2INV)
call CSCALE(INDX,INTSYM,S,SQ2)
call mma_deallocate(Buf)
call mma_deallocate(iBuf)

return

end subroutine AI_MRCI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ci2ordr_cvb(civec,cvbdet,evbdet)

use casvb_global, only: ndet, ndetvb, nfrag, vbdet
use Constants, only: Zero
use Definitions, only: wp

#include "intent.fh"

implicit none
real(kind=wp), intent(_IN_) :: civec(0:ndet), cvbdet(ndetvb)
real(kind=wp), intent(_OUT_) :: evbdet(*)
real(kind=wp) :: dum

if (nfrag <= 1) then
  evbdet(1:ndetvb) = Zero
  return
end if
call dpci2vb2_cvb(civec(1:),cvbdet,vbdet,evbdet,0,dum,5)

return

end subroutine ci2ordr_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Rulin Feng                                       *
************************************************************************
*       ****************************************************
*                 Desymmetrize a given array(matrix)
*       ****************************************************
*        This routine is made to expand a given symmetry-adapted array
*        into a C1 symmetry. SYMLAB is a bit flag,
*        e.g., for symmetry 3, symlab=4=2^(3-1). A is input array with
*        size SIZA, B is output array with size of NBST**2.
*        Not tested for general cases, so for use of SO-NTOs only.
*
*                                                      -RF 8/24,2021
      SUBROUTINE DESYM_SONTO(A,SIZA,B,SYMLAB)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "symmul.fh"
#include "rassi.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='DESYM_SONTO')
      INTEGER SIZA,SYMLAB
      REAL*8 ME
      REAL*8 A(SIZA)
      REAL*8 B(NBST**2)

c Initialize
      Call DCOPY_(NBST**2,[0.0D0],0,B,1)

      Call GETMEM('SCR','ALLO','REAL',LSCR,SIZA)
      Call DCOPY_(SIZA,[0.0D00],0,WORK(LSCR),1)

c Diagonal symmetry blocks.
c Dont need to do anything, just leave it be
      IF(SYMLAB.EQ.1) THEN
        Call DCOPY_(SIZA,A(:),1,WORK(LSCR),1)
c Non-diagonal symmetry blocks
c note that only half of the total matrix has been stored
      ELSE
        ITD=0
        IOF=0
        Do ISY1=1,NSYM
          NB1=NBASF(ISY1)
          Do ISY2=1,NSYM
            NB2=NBASF(ISY2)
            ISY12_ma=MUL(ISY1,ISY2)
            ISY12_ma_bi=2**(ISY12_ma-1)
            If(ISY12_ma_bi.EQ.SYMLAB) then
              IF(ISY1.GT.ISY2) THEN
                Do J=1,NB2
                  Do I=1,NB1
                    ITD=ITD+1
                    TDM=A(ITD)
                    IJ=IOF+J+NB2*(I-1)
                    WORK(LSCR-1+IJ)=TDM
                  Enddo
                Enddo
                IOF=IOF+NB1*NB2
              Endif
            Endif
          Enddo
        Enddo
      Endif
c Expand into C1

      ITD=0
      NB1_i=0
      NB1_f=0
      Do ISY1=1,NSYM
        NB1=NBASF(ISY1)
        NB1_f=NB1_i+NB1
        NB2_i=0
        NB2_f=0
        Do ISY2=1,NSYM
          ISY12_ma=MUL(ISY1,ISY2)
          ISY12_ma_bi=2**(ISY12_ma-1)
          NB2=NBASF(ISY2)
          NB2_f=NB2_i+NB2
          If(ISY12_ma_bi.EQ.SYMLAB) then
            Do J=NB2_i+1,NB2_f
              Do I=NB1_i+1,NB1_f
                If(I.LE.J) then
                  ITD=ITD+1
                  ME=WORK(LSCR-1+ITD)
                  IJ=I+NBST*(J-1)
                  JI=J+NBST*(I-1)
                  B(IJ)=ME
                  B(JI)=ME
                Endif
              Enddo
            Enddo
          Endif
          NB2_i=NB2_i+NB2
        Enddo
        NB1_i=NB1_i+NB1
      Enddo
      Call GETMEM('SCR','FREE','REAL',LSCR,SIZA)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine StoreMpAsLop(nAtoms,ip_ANr,nB,ipT,ipTi
     &                       ,ipMP,lMax,ip_EC)
      Implicit Real*8 (a-h,o-z)

#include "MpParam.fh"
#include "Address.fh"
#include "WrkSpc.fh"
#include "MolProp.fh"

*
*-- Let's fix the ip_ANr.
*
      Call Allocate_iWork(ip_ANr,nAtoms)
      Call Get_iArray('LP_A',iWork(ip_ANr),nAtoms)

*
*-- Let's fix the uber-simple T and T(-1).
*
      Call GetMem('T','Allo','Real',ipT,nB**2)
      Call GetMem('Tinv','Allo','Real',ipTi,nB**2)
      kaunter=0
      Do i=1,nB
        Do j=1,nB
          Work(ipT+kaunter)=0.0d0
          Work(ipTi+kaunter)=0.0d0
          If(i.eq.j) Work(ipT+kaunter)=1.0d0
          If(i.eq.j) Work(ipTi+kaunter)=1.0d0
          kaunter=kaunter+1
        Enddo
      Enddo

*
*-- Let's fix the expansion centres. Cor resides in MolProp.fh.
*
      Call GetMem('ExpCent','Allo','Real',ip_EC,3*nAtoms*(nAtoms+1)/2)
      kaunter=0
      Do i=1,nAtoms
        Do j=1,i
          Work(ip_EC+kaunter*3+0)=Cor(1,i,j)
          Work(ip_EC+kaunter*3+1)=Cor(2,i,j)
          Work(ip_EC+kaunter*3+2)=Cor(3,i,j)
          kaunter=kaunter+1
        Enddo
      Enddo

*
*-- Let's fix the multipole moments. Unlike LoProp, MpProp has here
*   included the nuclei contribution, which we have to remove pronto
*   to be compatible.
*
      nSize1=nAtoms*(nAtoms+1)/2
      nSize2=(lMax*(lMax**2+6*lMax+11)+6)/6
      Call GetMem('MultMom','Allo','Real',ipMP,nSize1*nSize2)
      iMu=-1
      Do l=0,lMax
        kompost=0
        Do ix=l,0,-1
          Do iy=l-ix,0,-1
            kompost=kompost+1
            iz=l-ix-iy
            iMu=iMu+1
            iAtK=0
            Do iAt1=1,nAtoms
              Do iAt2=1,iAt1
                Work(ipMP+iAtK+nSize1*iMu)=
     &          Work(iAtBoMltPlAd(l)+nSize1*(kompost-1)+iAtK)
                iAtK=iAtK+1
              Enddo
              If(l.eq.0) then
                Work(ipMP+iAtK-1+nSize1*iMu)=
     &           Work(ipMP+iAtK-1+nSize1*iMu)-dble(iWork(ip_ANr+iAt1-1))
              Endif
            Enddo
          Enddo
        Enddo
      Enddo

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetX_t3(X,length,Lun,LunName,keyopen,keyclose)
! this routine does:
! 1) keyopen = 0 - nothing (i.e) file is opened
!              1 - open LunName file with Lun
!              2 - rewind Lun file
!              3 - open LunName file with Lun with ACCESS='append'
! 2) read X of dimension length
! 3) keyclose = 0 - nothing
!               1 - close Lun file

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: length, Lun, keyopen, keyclose
real(kind=wp), intent(out) :: X(length)
character(len=6) :: LunName

!1
if (keyopen == 1) then
  !open(unit=Lun,file=LunName,form='unformatted')
  call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
else if (keyopen == 2) then
  rewind(Lun)
else if (keyopen == 3) then
  !mp !open(unit=Lun,file=LunName,form='unformatted',ACCESS='append')

  call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
  call append_file_u(Lun)

end if

!2
read(Lun) X(:)

!3
if (keyclose == 1) then
  close(Lun)
end if

return

end subroutine GetX_t3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine tuneprint_cvb()

use casvb_global, only: alftol, cnrmtol, delopth1, delopth2, dfx, dfxmin, dfxtol, dx, eigwrngtol, endwhenclose, exp12tol, follow, &
                        grd, grdwrngtol, hhaccfac, hhmax, hhrejfac, hhstart, hhtol, imethod, ipr, mxdav, nopth1, nopth2, nortiter, &
                        orththr, resthr, safety, scalesmall, sgn, signtol, singul, zzacclim, zzmax, zzmin, zzrejmax, zzrejmin
use Definitions, only: u6

implicit none

if (ipr(3) < 3) return
if (imethod /= 4) then
  write(u6,'(/,a)') ' -------- Details of parameters used by 2nd-order optimizer: -------------'
  write(u6,'(/,a,/)') ' General parameters:'
  call fout_cvb(safety,'SAFETY','Alpha safety in denominator, (H - alpha * I):')
  call fout_cvb(cnrmtol,'CNRMTOL','Tolerance for size of update:')
  call fout_cvb(signtol,'SIGNTOL','Tolerance for sign of Hessian eigenvalues:')
  call fout_cvb(alftol,'ALFTOL','Convergence criterion on alpha:')
  call fout_cvb(dfxtol,'DFXTOL','DFX tolerance for act/exp ratio:')
  call fout_cvb(exp12tol,'EXP12TOL','Criterion on expected change of f(x):')
  call fout_cvb(grdwrngtol,'GRDWRNGTOL','Gradient tol. for scaling small updates:')
  call fout_cvb(eigwrngtol,'EIGWRNGTOL','Eigenvalue tol. for scaling small updates:')
  call lout_cvb(endwhenclose,'ENDIFCLOSE','Exit if optimization close to convergence?')
  write(u6,'(/,a)') ' Convergence criteria:'
  write(u6,'(/,a)') ' Elements of arrays:'
  write(u6,'(a)') ' (1) ... Optimization is in global region.'
  write(u6,'(a)') ' (2) ... Optimization is in local region.'
  write(u6,'(a)') ' (3) ... Optimization is close to wrong stationary point.'
  call fouti_cvb(singul,3,'SINGUL(3)','Thresholds for sing. Hessian (max abs eig):')
  write(u6,'(/,a)') ' Elements of arrays:'
  write(u6,'(a)') ' (*,1) ... Global region, non-singular Hessian.'
  write(u6,'(a)') ' (*,2) ... Global region, singular Hessian.'
  write(u6,'(a)') ' (*,3) ... Local region, non-singular Hessian.'
  write(u6,'(a)') ' (*,4) ... Local region, singular Hessian.'
  write(u6,'(a)') ' (*,5) ... Wrong stationary point, non-singular Hessian.'
  write(u6,'(a)') ' (*,6) ... Wrong stationary point, singular Hessian.'
  call fouti_cvb(sgn,6,'SIGN(6)','Threshold for sign of Hessian eigenvalues:')
  call fouti_cvb(zzmin,6,'ZZMIN(6)','Mininum allowed act/exp ratio:')
  call fouti_cvb(zzmax,6,'ZZMAX(6)','Maximum allowed act/exp ratio:')
  call fouti_cvb(dfx,6,'DFX(6)','Maximum allowed change in f(x):')
  write(u6,'(/,a)') ' Elements of arrays:'
  write(u6,'(a)') ' (1,*) ... Use maximum absolute value in vector.'
  write(u6,'(a)') ' (2,*) ... Use norm of vector.'
  write(u6,'(a)') ' (3,*) ... Use RMS of elements in vector.'
  call foutij_cvb(dx,3,6,'DX(3,6)','Maximum allowed change in variables:')
  call foutij_cvb(grd,3,6,'GRD(3,6)','Maximum allowed gradient:')
  write(u6,'(/,a,/)') ' Trust region control:'
  call fout_cvb(hhstart,'HHSTART','Initial trust region size:')
  call iout_cvb(nopth1(1),'NOPTH1(1)','Number of steps (primary trust size opt):')
  call iout_cvb(nopth2(1),'NOPTH2(1)','Number of steps (secondary trust size opt):')
  call iout_cvb(nopth1(2),'NOPTH1(2)','Number of steps (primary trust size opt):')
  call iout_cvb(nopth2(2),'NOPTH2(2)','Number of steps (secondary trust size opt):')
  call fouti_cvb(delopth1,2,'DELOPTH1(2)','Primary change of trust region size:')
  call fouti_cvb(delopth2,2,'DELOPTH2(2)','Secondary change of trust region size:')
  call fouti_cvb(hhmax,2,'HHMAX(2)','Maximum allowed trust region size:')
  call fouti_cvb(zzrejmin,2,'ZZREJMIN(2)','Minimum allowed act/exp ratio:')
  call fouti_cvb(zzrejmax,2,'ZZREJMAX(2)','Maximum allowed act/exp ratio:')
  call fouti_cvb(dfxmin,2,'DFXMIN(2)','Minimum allowed change in f(x):')
  call fouti_cvb(hhrejfac,2,'HHREJFAC(2)','Trust region size scale factor for rejections:')
  call foutij_cvb(zzacclim,4,2,'ZZACCLIM(4,2)','Act/exp regions for scaling accepted steps:')
  call foutij_cvb(hhaccfac,5,2,'HHACCFAC(5,2)','Trust scale factors for accepted steps:')
  call fouti_cvb(hhtol,2,'HHTOL(2)','Minimum allowed trust region size:')
  call lout_cvb(scalesmall(1),'SCALESMALL(1)','Scale predicted steps smaller than trust?')
  call lout_cvb(scalesmall(2),'SCALESMALL(2)','Scale predicted steps smaller than trust?')
  write(u6,'(/,a)') ' -------------------------------------------------------------------------'
else if (imethod == 4) then
  write(u6,'(/,a,/)') ' -------- Details of parameters used by Davidson optimizer: --------------'
  call iout_cvb(mxdav,'MXDAV','Maximum dimension of Davidson subspace:')
  call fout_cvb(resthr,'RESTHR','Convergence criterion on residual norm:')
  call lout_cvb(follow,'FOLLOW','Root following (for excited states):')
  call fout_cvb(orththr,'ORTHTHR','Tolerance for orthogonality between vectors:')
  call iout_cvb(nortiter,'NORTITER','Maximum number of orthogonalization attempts:')
  write(u6,'(/,a)') ' -------------------------------------------------------------------------'
end if

return

end subroutine tuneprint_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE IAIB_TO_OCCLS(IAGRP,IATP,IBGRP,IBTP,IOC)
*
* Find address of the occupation class corresponding to given types
* of alpha and beta strings
*
* Jeppe Olsen, December 2001
*
#include "implicit.fh"
#include "mxpdim.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "strbas.fh"
#include "WrkSpc.fh"
*. Local scratch
      INTEGER IABOCC(MXPNGAS)
*
      IATP_ABS = IATP + IBSPGPFTP(IAGRP) - 1
      IBTP_ABS = IBTP + IBSPGPFTP(IBGRP) - 1
C?    WRITE(6,*) ' IATP, IBTP, IAGRP, IBGRP = ',
C?   &             IATP, IBTP, IAGRP, IBGRP
C?    WRITE(6,*) ' IATP_ABS, IBTP_ABS ', IATP_ABS, IBTP_ABS
*
C  IVCSUM(IA,IB,IC,IFACB,IFACC,NDIM)
      IONE = 1
      CALL IVCSUM(   IABOCC,
     &            NELFSPGP(1,IATP_ABS),
     &            NELFSPGP(1,IBTP_ABS),
     &                 IONE,
     &                 IONE,
*
     &                 NGAS)
*. And the address of this occupation class
      CALL CMP_IVEC_ILIST(IABOCC,iWORK(KIOCLS),NGAS,NMXOCCLS,INUM)
*
      IOC = INUM
*
      IF(INUM.EQ.0) THEN
        WRITE(6,*)
     &  ' Combination of alpha and beta string not found as occ-class'
        WRITE(6,*) ' Occ of alpha, Occ of beta, Occ of alpha+beta '
        CALL IWRTMA(NELFSPGP(1,IATP_ABS),1,NGAS,1,NGAS)
        CALL IWRTMA(NELFSPGP(1,IBTP_ABS),1,NGAS,1,NGAS)
        CALL IWRTMA(IABOCC,1,NGAS,1,NGAS)
*        STOP
*     &  ' Combination of alpha and beta string not found as occ-class'
         CALL SYSABENDMSG('lucia_util/iaib_to_occls',
     &                    'Internal error',' ')
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grc43y(a,b,c,mvec,ssa,ssb,ix)

use ccsd_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
type(Map_Type), intent(in) :: a, b
type(Map_Type), intent(inout) :: c
integer(kind=iwp), intent(out) :: mvec(4096,7), ix
integer(kind=iwp), intent(in) :: ssa, ssb
integer(kind=iwp) :: ia, ib, iy, nhelp1, nhelp2, nhelp4, nhelp41, nhelp42, nhelp43, nsymb2, ntest1, ntest2, posct, sa1, sa2, sa23, &
                     sa234, sa3, sa4, sb1, sb12, sb2, sb3

! structure A(p,qrs)*B(qrs)=YC(p)

!1.0 prepare c%d,c%i

call grc0(1,0,a%d(0,1),0,0,0,mmul(ssa,ssb),posct,c)

!1.1 define limitations - p,q>r,s must be tested - ntest1
!                       - p,q,r>s must be tested - ntest2

if (a%d(0,6) == 2) then
  ntest1 = 1
else
  ntest1 = 0
end if

if (a%d(0,6) == 3) then
  ntest2 = 1
else
  ntest2 = 0
end if

!1.2 def symm states and test the limitations

ix = 1
do sb1=1,nsym
  sa2 = sb1
  if (ntest1 == 1) then
    nsymb2 = sb1
  else
    nsymb2 = nsym
  end if

  do sb2=1,nsymb2
    sb12 = mmul(sb1,sb2)
    sa3 = sb2
    sa23 = mmul(sa2,sa3)

    sb3 = mmul(ssb,sb12)
    sa4 = sb3
    sa234 = mmul(sa23,sa4)
    ! Meggie out
    if ((ntest2 == 1) .and. (sb2 < sb3)) cycle

    sa1 = mmul(ssa,sa234)
    ! Meggie out
    if ((ntest1 == 1) .and. (sb1 < sb2)) cycle

    !1.3 def mvec,c%d and c%i

    ia = a%i(sa1,sa2,sa3)
    ib = b%i(sb1,sb2,1)
    iy = c%i(1,1,1)

    ! yes/no
    if ((a%d(ia,2) <= 0) .or. (b%d(ib,2) <= 0)) cycle
    nhelp1 = 1

    ! rowA
    nhelp2 = dimm(a%d(0,1),sa1)

    ! sum
    nhelp41 = dimm(a%d(0,2),sa2)
    nhelp42 = dimm(a%d(0,3),sa3)
    nhelp43 = dimm(a%d(0,4),sa4)
    if ((ntest1 == 1) .and. (sa2 == sa3)) then
      nhelp4 = nhelp41*(nhelp41-1)*nhelp43/2
    else if ((ntest2 == 1) .and. (sa3 == sa4)) then
      nhelp4 = nhelp41*nhelp42*(nhelp42-1)/2
    else
      nhelp4 = nhelp41*nhelp42*nhelp43
    end if

    mvec(ix,1) = nhelp1
    mvec(ix,2) = a%d(ia,1)
    mvec(ix,3) = b%d(ib,1)
    mvec(ix,4) = c%d(iy,1)
    mvec(ix,5) = nhelp2
    mvec(ix,6) = nhelp4
    mvec(ix,7) = 0

    ix = ix+1

  end do
end do
ix = ix-1

return

end subroutine grc43y

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Victor P. Vysotskiy                              *
!***********************************************************************

subroutine DaFile_checkarg(Lu,iOpt,lBuf,iDisk)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Check arguments to iDafile                                       *
!                                                                      *
!     calling arguments:                                               *
!     Lu      : integer, input                                         *
!               logical unit number (Lu={1,2,...40,50,60,70,80,90}     *
!     iOpt    : integer, input                                         *
!               valid values: 0,1,2,5,6,7,8,10,99                      *
!     lBuf    : integer, input                                         *
!               length of the buffer Buf:   0<lBuf<2**29(2**60)        *
!     iDisk   : integer, input/output                                  *
!               disk address  >=0                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
!                                                                      *
!***********************************************************************

use Fast_IO, only: isOpen, MxFile
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Lu, iOpt, lBuf, iDisk
character(len=*), parameter :: TheName = 'DaFile_checkarg'

! 2012
! VpV: a lot of checking is here.
! Check arguments
if ((Lu <= 0) .or. (Lu > MxFile)) call SysFileMsg(TheName,'MSG: unit',Lu,' ')

if (isOpen(Lu) == 0) call SysFileMsg(TheName,'MSG: not opened',Lu,' ')

if (lBuf < 0) then
  write(u6,*) 'Invalid buffer size ',lBuf
  call Error()
end if

if (iDisk < 0) then
  write(u6,*) 'Invalid disk address ',iDisk
  call Error()
end if

if ((iOpt < 0) .or. ((iOpt > 10) .and. (iOpt /= 99))) then
  write(u6,*) 'Invalid action code ',iOpt
  call Error()
end if

if ((iOpt == 3) .or. (iOpt == 4) .or. (iOpt == 9)) then
  write(u6,*) 'DaFile: GSlist option is not in operation!'
  call Error()
end if

return

contains

subroutine Error()
  write(u6,*) 'I/O error in ',TheName
  write(u6,*) 'Unit = ',Lu
  call Abend()
end subroutine Error

end subroutine DaFile_checkarg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_X_GetIP_InfVec(ip_InfVec_T)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Purpose: get pointer to InfVec array for all vectors.
C
      Implicit None
      Integer ip_InfVec_T
#include "choptr.fh"
#include "chopar.fh"
#if defined (_MOLCAS_MPP_)
#include "cho_para_info.fh"
#else
      Logical Cho_Real_Par
      Cho_Real_Par=.False.
#endif

      If (Cho_Real_Par) Then
         If (l_InfVec_Bak .gt. 0) Then
            ip_InfVec_T=ip_InfVec_Bak
          Else
            Call Cho_Quit(
     &               'Initialization problem in Cho_X_GetIP_InfVec',103)
         End If
      Else
         ip_InfVec_T=ip_InfVec
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Roland Lindh                                     *
!***********************************************************************

subroutine GetDens(FName,Density,iPrint)
!***********************************************************************
! Object: to get the 1 particle density from file INPORB               *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chem. Phys.                       *
!             University of Lund, SWEDEN                               *
!             January 2000                                             *
!***********************************************************************

use PrpPnt, only: Den, nDen, nOcc, nVec, Occ, Vec
use Basis_Info, only: nBas
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
#ifdef _HDF5_
use mh5, only: mh5_is_hdf5, mh5_open_file_r, mh5_close_file
#endif
use stdalloc, only: mma_allocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: FName
logical(kind=iwp), intent(in) :: Density
integer(kind=iwp), intent(in) :: iPrint
integer(kind=iwp) :: iadDen, iadOcc, iadVec, iBas, icd, ico, ictd, icto, ictv, icv, iDummy(1), iErr, iIrrep, j1, j2, LuVec
#ifdef _HDF5_
integer(kind=iwp) :: id_file
#endif
real(kind=wp) :: Dummy(1)
character(len=80) :: Line
integer(kind=iwp), external :: n2Tri

nDen = n2Tri(1)
nVec = S%n2Tot
nOcc = S%nDim
if (Density) call mma_allocate(Den,nDen,label='Den')
iadDen = 1
call mma_allocate(Vec,nVec,label='Vec')
call mma_allocate(Occ,nOcc,label='Occ')
iadDen = 1
iadVec = 1
iadOcc = 1
#ifdef _HDF5_
if (mh5_is_hdf5(FName)) then
  id_file = mh5_open_file_r(FName)
  call RdVec_HDF5(id_file,'CO',nIrrep,nBas,Vec,Occ,Dummy,iDummy)
  call mh5_close_file(id_file)
  write(u6,*)
  write(u6,'(A,1X,A)') ' Vectors read from HDF5 file:',trim(FName)
  write(u6,*)
else
#endif
  LuVec = 19
  call RdVec(FName,LuVec,'CO',nIrrep,nBas,nBas,Vec,Occ,Dummy,iDummy,Line,0,iErr)
  write(u6,*)
  write(u6,'(A)') ' Header from vector file:'
  write(u6,*)
  write(u6,'(A)') trim(Line)
  write(u6,*)
#ifdef _HDF5_
end if
#endif

if (Density) then

  ! Build the density matrix.

  Den(:) = Zero

  ictv = iadVec
  icto = iadOcc
  ictd = iadDen
  do iIrrep=0,nIrrep-1
    do iBas=1,nBas(iIrrep)
      icv = ictv
      ico = icto
      icd = ictd
      do j1=0,nBas(iIrrep)-1
        do j2=0,j1-1
          Den(icd) = Den(icd)+Occ(ico)*Vec(icv+j1)*Two*Vec(icv+j2)
          icd = icd+1
        end do
        Den(icd) = Den(icd)+Occ(ico)*Vec(icv+j1)*Vec(icv+j1)
        icd = icd+1
      end do
      ictv = ictv+nBas(iIrrep)
      icto = icto+1
    end do
    ictd = ictd+nBas(iIrrep)*(nBas(iIrrep)+1)/2
  end do
  iadVec = iadDen
  iadOcc = iadDen
  nOcc = nDen
  nVec = nDen
  if (iPrint >= 10) call PrMtrx(' Density matrix',[1],1,[iadDen],Den)

end if

return

end subroutine GetDens

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Prepare(nGrdPt,Grid,B,GrdI)
! Some stuff for preparing the gradient integral computation

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep, iChTbl
use Disp, only: ChDisp, Dirct, Disp_Fac, IndDsp, InxDsp, lDisp, Mult_Disp
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nGrdPt
real(kind=wp), intent(in) :: Grid(3,nGrdPt), B(nGrdPt)
real(kind=wp), intent(out) :: GrdI(4,nGrdPt)
integer(kind=iwp) :: iCar, iCnt, iCnttp, iComp, iIrrep, jOper, LuWr, mc, mdc, mDisp, nCnttp_Valence, nDiff, nDisp
logical(kind=iwp) :: DoRys, TstFnc
character, parameter :: xyz(0:2) = ['x','y','z']
integer(kind=iwp), external :: iPrmt

LuWr = u6
DoRys = .true.
nDiff = 3
call IniSew(DoRys,nDiff)

! Copy the grid coordinates and weights in ONE array
! This is the only solution I found to pass info trough oneel_g !

GrdI(1:3,:) = Grid
GrdI(4,:) = B

nCnttp_Valence = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux) exit
  nCnttp_Valence = nCnttp_Valence+1
end do

! Compute number of centers and displacements. Ignore pseudo centers.
! If any pseudo centers disable use of translational and rotational
! invariance.

mDisp = 0
mdc = 0
do iCnttp=1,nCnttp_Valence
  if (dbsc(iCnttp)%pChrg) then
    mdc = mdc+dbsc(iCnttp)%nCntr
  else
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      mDisp = mDisp+3*(nIrrep/dc(mdc)%nStab)
    end do
  end if
end do

! Initialize the Dirct array. Why? I don't know.

Dirct(:) = .true.

! Generate symmetry adapted cartesian displacements

IndDsp(:,:) = 0
InxDsp(:,:) = 0
Disp_Fac(:,:,:) = One
mult_Disp(:) = 1
nDisp = 0
do iIrrep=0,nIrrep-1
  lDisp(iIrrep) = 0
  ! Loop over basis function definitions
  mdc = 0
  mc = 1
  do iCnttp=1,nCnttp_Valence
    ! Loop over unique centers associated with this basis set.
    do iCnt=1,dbsc(iCnttp)%nCntr
      mdc = mdc+1
      IndDsp(mdc,iIrrep) = nDisp
      ! Loop over the cartesian components
      do iCar=0,2
        iComp = 2**iCar
        if (TstFnc(dc(mdc)%iCoSet,iIrrep,iComp,dc(mdc)%nStab) .and. (.not. dbsc(iCnttp)%pChrg)) then
          nDisp = nDisp+1
          if (iIrrep == 0) InxDsp(mdc,iCar+1) = nDisp
          lDisp(iIrrep) = lDisp(iIrrep)+1
          mult_Disp(nDisp) = nIrrep/dc(mdc)%nStab
          if (iIrrep == 0) then
            do jOper=0,nIrrep-1
              Disp_Fac(iCar+1,jOper,mdc) = iPrmt(jOper,iComp)*iChTbl(iIrrep,jOper)
            end do
          end if
          write(ChDisp(nDisp),'(A,1X,A1)') dc(mdc)%LblCnt,xyz(iCar)

        end if
      end do
      mc = mc+nIrrep/dc(mdc)%nStab
    end do
  end do

end do

if (nDisp /= mDisp) then
  call WarningMessage(2,'Error in espf/prepare')
  write(LuWr,*) ' Wrong number of symmetry adapted displacements',nDisp,'=/=',mDisp
  call Abend()
end if

return

end subroutine Prepare

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Module Aces_Stuff
*
*---- Stuff for Aces 2 read of Gamma file
*
      Logical                Gamma_On
      Integer                LuGamma, lBin, nGamma
      Real*8, Allocatable:: G_Toc(:), Bin(:,:)
      Integer, Allocatable:: SO2cI(:,:)
*
      End Module Aces_Stuff

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Assemble_dTdmu(nZeta,rFinal,la,lb,Elalbp,Elalbm,Beta)
!***********************************************************************
!                                                                      *
! Object: to assemble the diamagnetic shielding integrals from         *
!         electric field integrals.                                    *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             February '91                                             *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),3)
real(kind=wp), intent(in) :: Elalbp(nZeta,nTri_Elem1(la),nTri_Elem1(lb+1),3), Elalbm(nZeta,nTri_Elem1(la),nTri_Elem1(lb-1),3), &
                             Beta(nZeta)
#include "print.fh"
integer(kind=iwp) :: ia, ib, ib_max, iComp, ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyb, iza, izb, iZeta
real(kind=wp) :: xyTmp, xzTmp, yxTmp, yzTmp, zxTmp, zyTmp
character(len=80) Label

iRout = 231
iPrint = nPrint(iRout)

!Fact = -1.0e6_wp*Half/c_in_au**2
if (iPrint >= 99) then
  write(u6,*) ' In Assemble_dTdmu la,lb=',la,lb
  do ia=1,nTri_Elem1(la)
    do ib=1,nTri_Elem1(lb+1)
      write(Label,'(A,I2,A,I2,A)') ' Elalbp(',ia,',',ib,',x)'
      call RecPrt(Label,' ',Elalbp(:,ia,ib,1),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Elalbp(',ia,',',ib,',y)'
      call RecPrt(Label,' ',Elalbp(:,ia,ib,2),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Elalbp(',ia,',',ib,',z)'
      call RecPrt(Label,' ',Elalbp(:,ia,ib,3),nZeta,1)
    end do
  end do
  do ia=1,nTri_Elem1(la)
    ib_max = nTri_Elem1(lb-1)
    if (lb == 0) ib_max = 0
    do ib=1,ib_max
      write(Label,'(A,I2,A,I2,A)') ' Elalbm(',ia,',',ib,',x)'
      call RecPrt(Label,' ',Elalbm(:,ia,ib,1),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Elalbm(',ia,',',ib,',y)'
      call RecPrt(Label,' ',Elalbm(:,ia,ib,2),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Elalbm(',ia,',',ib,',z)'
      call RecPrt(Label,' ',Elalbm(:,ia,ib,3),nZeta,1)
    end do
  end do
end if

do ixa=la,0,-1
  do iya=la-ixa,0,-1
    iza = la-ixa-iya
    ipa = C_Ind(la,ixa,iza)

    do ixb=lb,0,-1
      do iyb=lb-ixb,0,-1
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        do iZeta=1,nZeta
          xyTmp = -Two*Beta(nzeta)*Elalbp(iZeta,ipa,C_Ind(lb+1,ixb,izb),1)
          yxTmp = -Two*Beta(nzeta)*Elalbp(iZeta,ipa,C_Ind(lb+1,ixb+1,izb),2)
          yzTmp = -Two*Beta(nzeta)*Elalbp(iZeta,ipa,C_Ind(lb+1,ixb,izb+1),2)
          zyTmp = -Two*Beta(nzeta)*Elalbp(iZeta,ipa,C_Ind(lb+1,ixb,izb),3)
          zxTmp = -Two*Beta(nzeta)*Elalbp(iZeta,ipa,C_Ind(lb+1,ixb+1,izb),3)
          xzTmp = -Two*Beta(nzeta)*Elalbp(iZeta,ipa,C_Ind(lb+1,ixb,izb+1),1)
          if (ixb >= 1) then
            yxTmp = yxTmp+real(ixb,kind=wp)*Elalbm(iZeta,ipa,C_Ind(lb-1,ixb-1,izb),2)
            zxTmp = zxTmp+real(ixb,kind=wp)*Elalbm(iZeta,ipa,C_Ind(lb-1,ixb-1,izb),3)
          end if
          if (iyb >= 1) then
            xyTmp = xyTmp+real(iyb,kind=wp)*Elalbm(iZeta,ipa,C_Ind(lb-1,ixb,izb),1)
            zyTmp = xyTmp+real(iyb,kind=wp)*Elalbm(iZeta,ipa,C_Ind(lb-1,ixb,izb),3)
          end if
          if (izb >= 1) then
            xzTmp = xzTmp+real(izb,kind=wp)*Elalbm(iZeta,ipa,C_Ind(lb-1,ixb,izb-1),1)
            yzTmp = yzTmp+real(izb,kind=wp)*Elalbm(iZeta,ipa,C_Ind(lb-1,ixb,izb-1),2)
          end if
          rFinal(iZeta,ipa,ipb,1) = -(xyTmp-yxTmp)
          rFinal(iZeta,ipa,ipb,2) = -(yzTmp-zyTmp)
          rFinal(iZeta,ipa,ipb,3) = -(zxTmp-xzTmp)
        end do

      end do
    end do

  end do
end do

if (iPrint >= 49) then
  do iComp=1,3
    write(Label,'(A,I2,A)') ' rFinal (',iComp,') '
    call RecPrt(Label,' ',rFinal(:,:,:,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb))
  end do
end if

return

end subroutine Assemble_dTdmu

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993,1999, Markus P. Fuelscher                         *
!               1993, Per Ake Malmqvist                                *
!***********************************************************************

subroutine UPKI4(nData,nByte,InBuf,OutBuf)
!***********************************************************************
!                                                                      *
!     purpose: unpack Integers                                         *
!                                                                      *
!    Calling parameters:                                               *
!    nData : number of unpacked integrals                              *
!    nByte : length of pack array in bytes                             *
!    InBuf : contains on input pack integers                           *
!    OutBuf: contains unpacked integers on output                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher and P. A. Malmqvist                               *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     replace various older versions of the algorithm                  *
!     M.P. Fuelscher, Univeristy of Lund, Sweden, 1999                 *
!                                                                      *
!***********************************************************************

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nData, InBuf(*)
integer(kind=iwp), intent(out) :: nByte, OutBuf(nData)
integer(kind=iwp) :: iOpt
interface
  subroutine iunzip(OpCode,nData,nBytes,InBuf,OutBuf) bind(C,name='iunzip_')
    use Definitions, only: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: OpCode, nData, nBytes, InBuf(*), OutBuf(*)
  end subroutine iunzip
end interface

!----------------------------------------------------------------------*

iOpt = 1
call iunzip(iOpt,nData,nByte,InBuf,OutBuf)

!----------------------------------------------------------------------*

return

end subroutine UPKI4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Subroutine PLF_Cho_3(TInt,lInt,
     &                AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iShell,
     &                iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,kOp)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use ChoArr, only: iSOShl, iShlSO, nBstSh, iShP2RS, iShP2Q,
     &                  nDim_Batch
      Implicit Real*8 (A-H,O-Z)
#include "cholesky.fh"
#include "real.fh"
#include "print.fh"
*
      Real*8 AOint(ijkl,iCmp,jCmp,kCmp,lCmp), TInt(lInt)
      Integer iShell(4), iAO(4), kOp(4),
     &        iAOst(4), iSOs(4)
      Logical Shijij

      external ddot_

      INTEGER ABCD, CDAB, CD, AB, A, B, C, D
*
      iTri(i,j)=Max(i,j)*(Max(i,j)-3)/2 + i + j
*
      irout = 109
      jprint = nprint(irout)
      If (jPrint.ge.49) Then
         r1=DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,[One],0)
         r2=DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1)
         Write (6,*) ' Sum=',r1
         Write (6,*) ' Dot=',r2
      End If
      If (jPrint.ge.99) Call RecPrt(' In Plf_Cho_3: AOInt',' ',
     &                              AOInt,ijkl,iCmp*jCmp*kCmp*lCmp)

      NUMC = NBSTSH(SHC)
      NUMD = NBSTSH(SHD)
      NUMA = NBSTSH(SHA)
      NUMB = NBSTSH(SHB)

      ISHLCD = SHCD
      ISHLAB = SHAB

C to avoid stupid compiler warnings:

      C = 0
      D = 0
      A = 0
      B = 0

      NTELM = 0
*
*     Allocate space to store integrals to gether with their
*     Symmetry batch and sequence number.
*     To avoid conflicts in using memory this is done in the
*     subroutine PSOAO
*
*
*     quadruple loop over elements of the basis functions angular
*     description. loops are reduced to just produce unique SO integrals
*     observe that we will walk through the memory in AOint in a
*     sequential way.
*
      iAOsti=iAOst(1)
      iAOstj=iAOst(2)
      iAOstk=iAOst(3)
      iAOstl=iAOst(4)
      iAOi=iAO(1)
      iAOj=iAO(2)
      iAOk=iAO(3)
      iAOl=iAO(4)
*
      Do 100 i1 = 1, iCmp
         iSOs(1)=iAOtSO(iAOi+i1,kOp(1))+iAOsti
         Do 200 i2 = 1, jCmp
            iSOs(2)=iAOtSO(iAOj+i2,kOp(2))+iAOstj
            Do 300 i3 = 1, kCmp
               iSOs(3)=iAOtSO(iAOk+i3,kOp(3))+iAOstk
               Do 400 i4 = 1, lCmp
                  iSOs(4)=iAOtSO(iAOl+i4,kOp(4))+iAOstl
*
                iSO =iSOs(1)
                jSO =iSOs(2)
                kSO =iSOs(3)
                lSO =iSOs(4)
*
                nijkl = 0
                Do 120 lSOl = lSO, lSO+lBas-1
                   Do 220 kSOk = kSO, kSO+kBas-1
                      Do 320 jSOj = jSO, jSO+jBas-1
                         Do 420 iSOi = iSO, iSO+iBas-1
*
                            nijkl = nijkl + 1
                            NTELM = NTELM + 1
*
                            ISHLI = ISOSHL(ISOI)
                            ISHLJ = ISOSHL(JSOJ)
                            ISHLK = ISOSHL(KSOK)
                            ISHLL = ISOSHL(LSOL)

                            IF ((ISHLI.EQ.SHC).AND.(ISHLJ.EQ.SHD)
     &                      .AND.(ISHLK.EQ.SHA).AND.(ISHLL.EQ.SHB)) THEN
                               C = ISHLSO(ISOI)
                               D = ISHLSO(JSOJ)
                               A = ISHLSO(KSOK)
                               B = ISHLSO(LSOL)
                            ELSE IF ((ISHLJ.EQ.SHC).AND.(ISHLI.EQ.SHD)
     &                      .AND.(ISHLK.EQ.SHA).AND.(ISHLL.EQ.SHB)) THEN
                               C = ISHLSO(JSOJ)
                               D = ISHLSO(ISOI)
                               A = ISHLSO(KSOK)
                               B = ISHLSO(LSOL)
                            ELSE IF ((ISHLI.EQ.SHC).AND.(ISHLJ.EQ.SHD)
     &                      .AND.(ISHLL.EQ.SHA).AND.(ISHLK.EQ.SHB)) THEN
                               C = ISHLSO(ISOI)
                               D = ISHLSO(JSOJ)
                               A = ISHLSO(LSOL)
                               B = ISHLSO(KSOK)
                            ELSE IF ((ISHLJ.EQ.SHC).AND.(ISHLI.EQ.SHD)
     &                      .AND.(ISHLL.EQ.SHA).AND.(ISHLK.EQ.SHB)) THEN
                               C = ISHLSO(JSOJ)
                               D = ISHLSO(ISOI)
                               A = ISHLSO(LSOL)
                               B = ISHLSO(KSOK)
                            ELSE IF ((ISHLK.EQ.SHC).AND.(ISHLL.EQ.SHD)
     &                      .AND.(ISHLI.EQ.SHA).AND.(ISHLJ.EQ.SHB)) THEN
                               C = ISHLSO(KSOK)
                               D = ISHLSO(LSOL)
                               A = ISHLSO(ISOI)
                               B = ISHLSO(JSOJ)
                            ELSE IF ((ISHLL.EQ.SHC).AND.(ISHLK.EQ.SHD)
     &                      .AND.(ISHLI.EQ.SHA).AND.(ISHLJ.EQ.SHB)) THEN
                               C = ISHLSO(LSOL)
                               D = ISHLSO(KSOK)
                               A = ISHLSO(ISOI)
                               B = ISHLSO(JSOJ)
                            ELSE IF ((ISHLK.EQ.SHC).AND.(ISHLL.EQ.SHD)
     &                      .AND.(ISHLJ.EQ.SHA).AND.(ISHLI.EQ.SHB)) THEN
                               C = ISHLSO(KSOK)
                               D = ISHLSO(LSOL)
                               A = ISHLSO(JSOJ)
                               B = ISHLSO(ISOI)
                            ELSE IF ((ISHLL.EQ.SHC).AND.(ISHLK.EQ.SHD)
     &                      .AND.(ISHLJ.EQ.SHA).AND.(ISHLI.EQ.SHB)) THEN
                               C = ISHLSO(LSOL)
                               D = ISHLSO(KSOK)
                               A = ISHLSO(JSOJ)
                               B = ISHLSO(ISOI)
                            ELSE
                               WRITE(LUPRI,*)
     &                         'Shell quadruple requested: ',
     &                         SHC,SHD,SHA,SHB
                               WRITE(LUPRI,*)
     &                         'Shell quadruple of element ',NTELM,':',
     &                         ISHLI,ISHLJ,ISHLK,ISHLL
                               CALL CHO_QUIT(
     &                                     'Logical error in PLF_Cho_3',
     &                                     103)
                            END IF

                            IF (SHA .EQ. SHB) THEN
                               AB = ITRI(A,B)
                            ELSE
                               AB = NUMA*(B - 1) + A
                            END IF
                            IF (SHC .EQ. SHD) THEN
                               CD = ITRI(C,D)
                            ELSE
                               CD = NUMC*(D - 1) + C
                            END IF

                            ICD = ISHP2RS(1,CD)
                            IAB = ISHP2Q(1,AB)
                            IF (ICD.GT.0 .AND. IAB.GT.0) THEN
                               CDAB = nDim_Batch(1)*(IAB-1) + ICD
                               TINT(CDAB) = AOint(nijkl,i1,i2,i3,i4)
                            END IF

                            IF (ISHLCD .EQ. ISHLAB) THEN
                               IF (SHC.EQ.SHD .OR. SHC.EQ.SHA) THEN
                                  IAB = ISHP2RS(1,AB)
                                  ICD = ISHP2Q(1,CD)
                                  IF (ICD.GT.0 .AND. IAB.GT.0) THEN
                                     ABCD = nDim_Batch(1)*(ICD-1) + IAB
                                     TINT(ABCD) = AOint(nijkl,
     &                                                  i1,i2,i3,i4)
                                  END IF
                               ELSE IF (SHC.EQ.SHB) THEN
                                  AB  = NUMB*(A - 1) + B
                                  CD  = NUMD*(C - 1) + D
                                  IAB = ISHP2RS(1,AB)
                                  ICD = ISHP2Q(1,CD)
                                  IF (ICD.GT.0 .AND. IAB.GT.0) THEN
                                     ABCD = nDim_Batch(1)*(ICD-1) + IAB
                                     TINT(ABCD) = AOint(nijkl,
     &                                                  i1,i2,i3,i4)
                                  END IF
                               END IF
                            END IF

420                      Continue
320                   Continue
220                Continue
120             Continue

400            Continue
300         Continue
200      Continue
100   Continue
      Return
* Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(iShell)
         Call Unused_logical(Shijij)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_CHKCONF(NCONFL,VERBOSE)
!
! Purpose: check configuration, return the number of errors NCONFL.

use Index_Functions, only: nTri_Elem
use Cholesky, only: BLOCKSIZE, CHO_1CENTER, CHO_DECALG, CHO_IOVEC, CHO_NDECALG, CHO_NO2CENTER, CHO_PRESCREEN, Cho_Real_Par, &
                    CHO_SIMRI, Cho_SScreen, Damp, FRAC_CHVBUF, IALQUA, IFCSEW, lBuf, LuPri, MaxQual, MaxRed, MaxVec, MinQual, &
                    MXSHPR, N1_Qual, N1_VecRd, N2_Qual, N2_VecRd, N_Subtr, NALQUA, NBAST, nShell, nSym, RstCho, SCDIAG, Span, &
                    SSTau, Thr_PreScreen, ThrCom, ThrDef, ThrDiag, ThrNeg, TOONEG, WARNEG
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: NCONFL
logical(kind=iwp), intent(in) :: VERBOSE
integer(kind=iwp) :: INEGRR, MMM, NNN
logical(kind=iwp) :: REPORT
real(kind=wp) :: XLBUF, XMBUF

! Initialize.
! -----------

NCONFL = 0
REPORT = VERBOSE

! Check that output unit is appropriately set.
! (Upper bound not checked, as it may vary.)
! --------------------------------------------

if (LUPRI < 1) then
  NCONFL = NCONFL+1
  REPORT = .false.
end if

! Check decomposition algorithm.
! ------------------------------

if ((CHO_DECALG < 1) .or. (CHO_DECALG > CHO_NDECALG)) then
  if (REPORT) write(LUPRI,'(A,I4)') 'Illegal decomposition algorithm, CHO_DECALG = ',CHO_DECALG
  NCONFL = NCONFL+1
end if
if (Cho_Real_Par) then
  if ((CHO_DECALG /= 4) .and. (CHO_DECALG /= 5) .and. (CHO_DECALG /= 6)) then
    if (REPORT) then
      write(LUPRI,'(A,I4)') 'Illegal decomposition algorithm, CHO_DECALG = ',CHO_DECALG
      write(LUPRI,'(A)') 'Only parallel algorithm is allowed for parallel execution'
    end if
    NCONFL = NCONFL+1
  end if
end if

! Cancel exclusion of 2-center diagonals in case of symmetry.
! ----------------------------------------------------------

if (CHO_NO2CENTER) then
  if (NSYM /= 1) then
    if (REPORT) write(LUPRI,'(A)') 'Exclusion of 2-center diagonals only implemented for C1 point group.'
    NCONFL = NCONFL+1
  end if
end if

! Cancel 1-center decomposition in case of symmetry.
! --------------------------------------------------

if (CHO_1CENTER) then
  if (NSYM /= 1) then
    if (REPORT) write(LUPRI,'(A)') '1-center decomposition only implemented for C1 point group.'
    NCONFL = NCONFL+1
  end if
end if

! Checks specific to RI simulation.
! ---------------------------------

if (CHO_SIMRI) then
  if (.not. CHO_1CENTER) then
    if (REPORT) write(LUPRI,'(A)') '1-center decomposition required for RI simulation.'
    NCONFL = NCONFL+1
  end if
  if (CHO_DECALG /= 2) then
    if (REPORT) write(LUPRI,'(A)') 'RI simulation can only be executed with the two-step algorithm.'
    NCONFL = NCONFL+1
  end if
  if (RSTCHO) then
    if (REPORT) write(LUPRI,'(A)') 'RI simulation cannot be executed with decomposition restart.'
    NCONFL = NCONFL+1
  end if
end if

! Check for conflicts for specific algorithms.
! --------------------------------------------

if ((CHO_DECALG == 2) .or. (CHO_DECALG == 5)) then
  if (.not. SCDIAG) then
    if (REPORT) write(LUPRI,'(A)') 'Screening must be turned on for two-step decomposition algorithm.'
    NCONFL = NCONFL+1
  end if
  if (IFCSEW /= 2) then
    if (REPORT) then
      write(LUPRI,'(A)') 'The interface to Seward must be "2" (reduced set communication) for two-step algorithm.'
      write(LUPRI,'(A,I4)') 'Current value is IFCSEW=',IFCSEW
    end if
    NCONFL = NCONFL+1
  end if
  if (RSTCHO) then
    if (REPORT) write(LUPRI,'(A)') 'Decomposition restart is not possible for two-step algorithm.'
    NCONFL = NCONFL+1
  end if
end if

if (CHO_DECALG == 5) then
  if (BLOCKSIZE < 1) then
    if (REPORT) write(LUPRI,'(A,I8)') 'BlockSize must be strictly positive.Current value is BlockSize=',BlockSize
    NCONFL = NCONFL+1
  end if
end if

! Check max. number of Cholesky vectors and reduced sets.
! -------------------------------------------------------

if (MAXVEC < 1) then
  if (REPORT) write(LUPRI,'(A,I8)') 'Max. number of vectors < 1: ',MAXVEC
  NCONFL = NCONFL+1
end if
if (MAXRED < 1) then
  if (REPORT) write(LUPRI,'(A,I8)') 'Max. number of reduced sets < 1: ',MAXRED
  NCONFL = NCONFL+1
end if

! Check qualification algorithm.
! ------------------------------

if (IALQUA < 0) then
  if (REPORT) write(LUPRI,'(A,I4,A)') 'Qualification algorithm reset from ',IALQUA,' to 1'
  IALQUA = 1
else if (IALQUA > NALQUA) then
  if (REPORT) write(LUPRI,'(A,I4,A,I4)') 'Qualification algorithm reset from ',IALQUA,' to ',NALQUA
  IALQUA = NALQUA
end if

! Decomposition threshold.
! ------------------------

if (THRCOM < Zero) then
  if (REPORT) write(LUPRI,'(A,ES15.6,A,ES15.6,A)') 'Decomposition threshold not positive: ',THRCOM,' (default value: ',THRDEF,')'
  NCONFL = NCONFL+1
end if

! Diagonal prescreening threshold.
! --------------------------------

if (CHO_PRESCREEN) then
  if (THR_PRESCREEN > THRCOM) then
    if (REPORT) write(LUPRI,'(A,ES15.6,A,ES15.6)') 'Diagonal prescreening threshold is greater than decomposition threshold: ', &
                                                   THR_PRESCREEN,' > ',THRCOM
    NCONFL = NCONFL+1
  end if
end if

! Screening threshold for vector subtraction.
! -------------------------------------------

if (CHO_SSCREEN) then
  if (SSTAU < Zero) then
    if (REPORT) write(LUPRI,'(A,ES15.6)') 'Screening threshold for vector subtraction not positive: ',SSTAU
    NCONFL = NCONFL+1
  end if
end if

! Buffer length.
! --------------

if (LBUF < 1) then
  if (REPORT) write(LUPRI,'(A,I8)') 'Buffer length < 1: ',LBUF
  NCONFL = NCONFL+1
else
  XLBUF = real(LBUF,kind=wp)
  XMBUF = real(NBAST)*(real(NBAST)+One)*Half
  if (XLBUF > XMBUF) LBUF = nint(XMBUF) ! make sure LBUF is not too large
end if

! Memory split for qualified columns.
! -----------------------------------

if (N1_QUAL >= N2_QUAL) then
  if (REPORT) write(LUPRI,'(A,2I5)') 'N1_QUAL >= N2_QUAL: ',N1_QUAL,N2_QUAL
  NCONFL = NCONFL+1
end if
if ((N1_QUAL < 1) .or. (N2_QUAL < 1)) then
  if (REPORT) write(LUPRI,'(A,2I5)') 'N1_QUAL and/or N2_QUAL < 1: ',N1_QUAL,N2_QUAL
  NCONFL = NCONFL+1
end if

! Memory split for buffered reading of previous vectors.
! Max. #vectors in each call to DGEMM in subtraction.
! (CHO_IOVEC=3,4 only.)
! ------------------------------------------------------

if ((CHO_IOVEC == 3) .or. (CHO_IOVEC == 4)) then
  if (N2_VECRD < N1_VECRD) then
    if (REPORT) write(LUPRI,'(A,2I5)') 'N1_VECRD >= N2_VECRD: ',N1_VECRD,N2_VECRD
    NCONFL = NCONFL+1
  end if
  if ((N1_VECRD < 1) .or. (N2_VECRD < 1)) then
    if (REPORT) write(LUPRI,'(A,2I5)') 'N1_VECRD and/or N2_VECRD < 1: ',N1_VECRD,N2_VECRD
    NCONFL = NCONFL+1
  end if
  if (N_SUBTR < 1) then
    if (REPORT) write(LUPRI,'(A,I8)') 'N_SUBTR: ',N_SUBTR
    NCONFL = NCONFL+1
  end if
end if

! Memory fraction used for vector buffer.
! ---------------------------------------

if (FRAC_CHVBUF < Zero) then
  if (REPORT) write(LUPRI,'(A,ES15.6,A)') 'FRAC_CHVBUF=',FRAC_CHVBUF,' resetting value to 0.0'
  FRAC_CHVBUF = Zero
else if (FRAC_CHVBUF > 0.9_wp) then
  if (REPORT) write(LUPRI,'(A,ES15.6,A)') 'FRAC_CHVBUF=',FRAC_CHVBUF,' resetting value to 0.9'
  FRAC_CHVBUF = 0.9_wp
end if

! Threshold for discarding elements of initial diagonal.
! ------------------------------------------------------

if (THRDIAG > THRCOM) then
  if (REPORT) then
    write(LUPRI,'(A,A,ES15.6)') 'Threshold for discarding initial diagonals',': ',THRDIAG
    write(LUPRI,'(A,ES15.6)') 'is larger than decomposition threshold: ',THRCOM
  end if
  NCONFL = NCONFL+1
end if

! Damping factors.
! ----------------

if (DAMP(1) < One) then
  if (REPORT) write(LUPRI,'(A,ES15.6)') 'First damping factor < 1: ',DAMP(1)
  NCONFL = NCONFL+1
end if
if (DAMP(2) < One) then
  if (REPORT) write(LUPRI,'(A,ES15.6)') 'Second damping factor < 1: ',DAMP(2)
  NCONFL = NCONFL+1
end if

! Span factor.
! ------------

if (SPAN > One) then
  if (REPORT) write(LUPRI,'(A,ES15.6)') 'Span factor > 1: ',SPAN
  NCONFL = NCONFL+1
else if (abs(One-SPAN) < 1.0e-4_wp) then
  if (REPORT) write(LUPRI,'(A)') 'Span factor is too close to 1. Will use 0.9999 instead.'
  SPAN = 0.9999_wp
end if

! Max. #shell pairs allowed before proceeding to deco.
! Max. #qualifieds allowed to proceed to decomposition.
! Min. #qualifieds needed to proceed to decomposition.
! -----------------------------------------------------

NNN = nTri_Elem(NSHELL)
if ((MXSHPR < 0) .or. (MXSHPR > NNN)) then
  if (REPORT) then
    write(LUPRI,'(A,I8)') 'Max. #shell pairs allowed before proceeding to deco. is: ',MXSHPR
    write(LUPRI,'(A)') 'Resetting generic: 0'
  end if
  MXSHPR = 0
end if
if (MAXQUAL < 1) then
  if (REPORT) then
    write(LUPRI,'(A,I8)') 'Max. number of qualifieds is non-positive: ',MAXQUAL
    write(LUPRI,'(A,I8)') 'Using instead: ',abs(MAXQUAL)
  end if
  MAXQUAL = abs(MAXQUAL)
end if
MMM = NSYM*MAXQUAL
if ((MINQUAL < 1) .or. (MINQUAL > MMM)) then
  if (REPORT) then
    write(LUPRI,'(A,I8)') 'Min. #qualified needed before proceeding to deco. is: ',MINQUAL
    write(LUPRI,'(A,I8)') 'resetting to: ',MMM
  end if
  MINQUAL = MMM
end if

! Handling of negative diagonals.
! -------------------------------

INEGRR = 0
if (THRNEG > Zero) then
  if (REPORT) write(LUPRI,'(A,ES15.6)') 'Threshold for zeroing neg. diag. > 0: ',THRNEG
  INEGRR = INEGRR+1
  NCONFL = NCONFL+1
end if
if (WARNEG > Zero) then
  if (REPORT) write(LUPRI,'(A,ES15.6)') 'Threshold for warning about neg. diag.  > 0: ',WARNEG
  INEGRR = INEGRR+1
  NCONFL = NCONFL+1
end if
if (TOONEG > Zero) then
  if (REPORT) write(LUPRI,'(A,ES15.6)') 'Threshold for shutdown due to neg. diag.  > 0: ',TOONEG
  INEGRR = INEGRR+1
  NCONFL = NCONFL+1
end if
if (INEGRR == 0) then
  if (THRNEG < WARNEG) then
    if (REPORT) write(LUPRI,'(A,ES15.6,ES15.6)') 'Threshold for zeroing neg. diag. > threshold for warning about neg. diag.: ', &
                                                 THRNEG,WARNEG
    NCONFL = NCONFL+1
  end if
  if (WARNEG < TOONEG) then
    if (REPORT) write(LUPRI,'(A,ES15.6,ES15.6)') 'Threshold for warning about neg. diag. > threshold for shutdown due to neg. '// &
                                                 'diag.: ',WARNEG,TOONEG
    NCONFL = NCONFL+1
  end if
end if

end subroutine CHO_CHKCONF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Per Ake Malmqvist                                *
!***********************************************************************
!****************************************************************
!  PROGRAM RASSI        PER-AAKE MALMQVIST
!  SUBROUTINE MKTDAB    IBM-3090 RELEASE 89 01 31
!  PURPOSE: CALCULATE TRANSITION DENSITY MATRIX FOR CI EXPANSIONS IN
!  BIORTHONORMAL ORBITAL BASES A AND B.
!****************************************************************

subroutine MKTDAB(OVER,GAMMA1,TDMAB,iRC)

use Cntrl, only: LSYM1, LSYM2
use Symmetry_Info, only: MUL, nIrrep
use rassi_data, only: NASH, NASHT, NISH, NOSH, NTDMAB
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: OVER, GAMMA1(NASHT,NASHT)
real(kind=wp), intent(out) :: TDMAB(NTDMAB)
integer(kind=iwp), intent(out) :: iRC
integer(kind=iwp) :: I, IA, II, IOFFA(8), IOFFTD, IPOS, ISY, ISY1, ISY12, ISY2, J, JA, JJ, NA1, NA2, NI1, NI2, NO1, NO2
real(kind=wp), external :: DDot_

! IOFFA=NR OF ACTIVE ORBITALS IN PREVIOUS SYMMETRY BLOCKS.
IOFFA(1) = 0
do I=1,nIrrep-1
  IOFFA(I+1) = IOFFA(I)+NASH(I)
end do
! INITIALIZE TRANSITION DENSITY MATRIX:
TDMAB(:) = Zero
! CONTRIBUTION FROM INACTIVE ORBITALS:
if (LSYM1 == LSYM2) then
  if (OVER /= Zero) then
    IOFFTD = 0
    do ISY=1,nIrrep
      II = 0
      do I=1,NISH(ISY)
        II = II+1
        IPOS = IOFFTD+(II-1)*NOSH(ISY)+II
        TDMAB(IPOS) = Two*OVER
      end do
      IOFFTD = IOFFTD+NOSH(ISY)**2
    end do
  end if
end if
! THEN ADD CONTRIBUTION FROM ACTIVE SPACE.
ISY12 = MUL(LSYM1,LSYM2)
IOFFTD = 0
do ISY1=1,nIrrep
  NO1 = NOSH(ISY1)
  if (NO1 == 0) cycle
  ISY2 = MUL(ISY1,ISY12)
  NO2 = NOSH(ISY2)
  if (NO2 == 0) cycle
  NA1 = NASH(ISY1)
  if (NA1 /= 0) then
    NA2 = NASH(ISY2)
    if (NA2 /= 0) then
      NI1 = NISH(ISY1)
      NI2 = NISH(ISY2)
      do I=1,NA1
        IA = IOFFA(ISY1)+I
        II = NI1+I
        do J=1,NA2
          JA = IOFFA(ISY2)+J
          JJ = NI2+J
          IPOS = IOFFTD+II+(JJ-1)*NO1
          TDMAB(IPOS) = GAMMA1(IA,JA)
        end do
      end do
    end if
  end if
  IOFFTD = IOFFTD+NO1*NO2
end do

iRC = 1
if (DDot_(nTDMAB,TDMAB,1,TDMAB,1) <= Zero) iRC = 0

end subroutine MKTDAB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine NAGrd( &
#                define _CALLING_
#                include "grd_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: to compute the gradient of the nuclear attraction integrals. *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             October '91                                              *
!***********************************************************************

use Basis_Info, only: dbsc, Gaussian_Type, iCnttp_Dummy, nCnttp, Nuclear_Model, Point_Charge
use Center_Info, only: dc
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One, Two, Three, Pi, TwoP54
use Definitions, only: wp, iwp, u6

implicit none
#include "grd_interface.fh"
integer(kind=iwp) :: i, iAlpha, iAnga(4), iBeta, iCar, iComp, iDAO, iDCRT(0:7), iIrrep, ipA, ipAOff, ipB, ipBOff, ipDAO, iuvwx(4), &
                     iZeta, j, JndGrd(3,4), jpDAO, kCnt, kCnttp, kdc, lDCRT, LmbdT, lOp(4), mGrad, nArray, nDAO, nDCRT, nDisp, &
                     nip, nRys
real(kind=wp) :: C(3), CoorAC(3,2), Coori(3,4), EInv, Eta, Fact, rKappab, rKappcd, TC(3)
logical(kind=iwp) :: JfGrad(3,4)
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: TF
! For normal nuclear attraction
external :: Cff2D, Fake, TNAI1
! Finite nuclei
external :: ModU2, TERI1, vCff2D
#include "Molcas.fh"
#include "disp.fh"
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iPrint, iRout
#include "print.fh"
#endif

#include "macros.fh"
unused_var(rFinal)
unused_var(Ccoor(1))
unused_var(nOrdOp)
unused_var(nComp)

#ifdef _DEBUGPRINT_
iRout = 150
iPrint = nPrint(iRout)
if (iPrint >= 99) then
  write(u6,*) ' In NAGrd: nArr=',nArr
  nDAO = nTri_Elem1(la)*nTri_Elem1(lb)
  call RecPrt('DAO',' ',DAO,nZeta,nDAO)
end if
#endif

nRys = nHer

nip = 1
ipA = nip
nip = nip+nAlpha*nBeta
ipB = nip
nip = nip+nAlpha*nBeta
ipDAO = nip
nip = nip+nAlpha*nBeta*nTri_Elem1(la)*nTri_Elem1(lb)
if (nip-1 > nZeta*nArr) then
  write(u6,*) ' nip-1 > nZeta*nArr'
  call Abend()
end if
nArray = nZeta*nArr-nip+1

iIrrep = 0
iAnga(1) = la
iAnga(2) = lb
iAnga(3) = 0
iAnga(4) = 0
Coori(:,1) = A(:)
Coori(:,2) = RB(:)
if (la >= lb) then
  CoorAC(:,1) = A(:)
else
  CoorAC(:,1) = RB(:)
end if
iuvwx(1) = dc(mdc)%nStab
iuvwx(2) = dc(ndc)%nStab
lOp(1) = kOp(1)
lOp(2) = kOp(2)

ipAOff = ipA
do iBeta=1,nBeta
  call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
  ipAOff = ipAOff+nAlpha
end do

ipBOff = ipB
do iAlpha=1,nAlpha
  call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
  ipBOff = ipBOff+1
end do

! Modify the density matrix with the prefactor

nDAO = nTri_Elem1(la)*nTri_Elem1(lb)
if (Nuclear_Model == Point_Charge) then
  do iDAO=1,nDAO
    do iZeta=1,nZeta
      Fact = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
      DAO(iZeta,iDAO) = Fact*DAO(iZeta,iDAO)
    end do
  end do
end if
!if (iPrint >= 99) call RecPrt('DAO',' ',DAO,nZeta,nDAO)

! Loop over nuclear centers

kdc = 0
do kCnttp=1,nCnttp
  if (kCnttp > 1) kdc = kdc+dbsc(kCnttp-1)%nCntr
  if (kCnttp == iCnttp_Dummy) cycle
  if (dbsc(kCnttp)%Charge == Zero) cycle
  do kCnt=1,dbsc(kCnttp)%nCntr
    C(1:3) = dbsc(kCnttp)%Coor(1:3,kCnt)

    call DCR(LmbdT,iStabM,nStabM,dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
    Fact = -dbsc(kCnttp)%Charge*real(nStabM,kind=wp)/real(LmbdT,kind=wp)

    ! Modify the density matrix with prefactors in case of finite nuclei

    if (Nuclear_Model == Gaussian_Type) then
      Eta = dbsc(kCnttp)%ExpNuc
      rKappcd = TwoP54/Eta
      ! Tag on the normalization factor of the nuclear Gaussian
      Fact = Fact*(Eta/Pi)**(Three/Two)
      jpDAO = ipDAO
      do iDAO=1,nDAO
        do iZeta=1,nZeta
          ! On flight modification of Kappa
          rKappab = TwoP54*rKappa(iZeta)/Zeta(iZeta)
          Array(jpDAO) = Fact*DAO(iZeta,iDAO)*rKappab*rKappcd*sqrt(One/(Zeta(iZeta)+Eta))
          jpDAO = jpDAO+1
        end do
      end do
    else if (Nuclear_Model == Point_Charge) then
      Array(ipDAO:ipDAO+nZeta*nDAO-1) = Fact*pack(DAO,.true.)
    else
      write(u6,*) 'NaGrd: Fermi type nuclear distribution not implemented yet!'
      call Abend()
    end if
    iuvwx(3) = dc(kdc+kCnt)%nStab
    iuvwx(4) = dc(kdc+kCnt)%nStab
    JndGrd(:,1:2) = IndGrd(:,:)
    do i=1,3
      do j=1,2
        JfGrad(i,j) = IfGrad(i,j)
      end do
    end do

    ! Derivatives with respect to the operator is computed via the
    ! translational invariance.

    nDisp = IndDsp(kdc+kCnt,iIrrep)
    do iCar=0,2
      iComp = 2**iCar
      if (TF(kdc+kCnt,iIrrep,iComp) .and. (.not. dbsc(kCnttp)%Frag) .and. (.not. dbsc(kCnttp)%pChrg)) then
        nDisp = nDisp+1
        if (Direct(nDisp)) then
          ! Reset flags for the basis set centers so that we
          ! will explicitly compute the derivatives with
          ! respect to those centers. Activate flag for the
          ! third center so that its derivative will be computed
          ! by the translational invariance.
          JndGrd(iCar+1,1) = abs(JndGrd(iCar+1,1))
          JndGrd(iCar+1,2) = abs(JndGrd(iCar+1,2))
          JndGrd(iCar+1,3) = -nDisp
          JfGrad(iCar+1,1) = .true.
          JfGrad(iCar+1,2) = .true.
          JfGrad(iCar+1,3) = .false.
        else
          JndGrd(iCar+1,3) = 0
          JfGrad(iCar+1,3) = .false.
        end if
      else
        JndGrd(iCar+1,3) = 0
        JfGrad(iCar+1,3) = .false.
      end if
    end do
    ! No derivatives with respect to the fourth center.
    JndGrd(:,4) = 0
    JfGrad(1,4) = .false.
    JfGrad(2,4) = .false.
    JfGrad(3,4) = .false.
    mGrad = 0
    do iCar=1,3
      do i=1,2
        if (JfGrad(iCar,i)) mGrad = mGrad+1
      end do
    end do
    !if (iPrint >= 99) write(u6,*) ' mGrad=',mGrad
    if (mGrad == 0) cycle

    do lDCRT=0,nDCRT-1
      lOp(3) = NrOpr(iDCRT(lDCRT))
      lOp(4) = lOp(3)
      call OA(iDCRT(lDCRT),C,TC)
      CoorAC(:,2) = TC(:)
      Coori(:,3) = TC(:)
      Coori(:,4) = TC(:)

      if (Nuclear_Model == Gaussian_Type) then
        Eta = dbsc(kCnttp)%ExpNuc
        EInv = One/Eta
        call Rysg1(iAnga,nRys,nZeta,Array(ipA),Array(ipB),[One],[One],Zeta,ZInv,nZeta,[Eta],[EInv],1,P,nZeta,TC,1,Coori,Coori, &
                   CoorAC,Array(nip),nArray,TERI1,ModU2,vCff2D,Array(ipDAO),nDAO,Grad,nGrad,JfGrad,JndGrd,lOp,iuvwx)
      else if (Nuclear_Model == Point_Charge) then
        call Rysg1(iAnga,nRys,nZeta,Array(ipA),Array(ipB),[One],[One],Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,Coori,Coori, &
                   CoorAC,Array(nip),nArray,TNAI1,Fake,Cff2D,Array(ipDAO),nDAO,Grad,nGrad,JfGrad,JndGrd,lOp,iuvwx)
      else
        ! more to come...
      end if

      !call RecPrt('In NaGrd: Grad',' ',Grad,nGrad,1)
    end do
  end do
end do

return

end subroutine NAGrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Roland Lindh                                     *
************************************************************************
      SubRoutine NewH(nInter,nIter,dq_orig,g,H,iOptH,HUpMet,mIter)
************************************************************************
*                                                                      *
* Object: Driver for inverse Hessian update.                           *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January '95                                              *
************************************************************************
      Use NewH_Mod
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      Integer nInter, nIter, mIter, iOptH, i, iPrint, iRout, iSing
      Real*8 dq_orig(nInter,nIter), g(nInter,mIter+1), H(nInter,nInter)
      Character*6 HUpMet
      Logical Test, DoMask
      Real*8, Dimension(:), Allocatable :: dg, gi
      Real*8, Dimension(:,:), Allocatable :: dq
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      Test(i)=iAnd(iOptH,2**(i-1)).eq.2**(i-1)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 112
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Write (6,*)
         Write (6,*) ' NewH: lIter=',nIter
         Call RecPrt(' NewH: dq_orig',' ',dq_orig,nInter,nIter)
         Call RecPrt(' NewH: g',' ',g,nInter,nIter)
         Call RecPrt(' NewH: H(Old)',' ',H,nInter,nInter)
         Write(6,*)' NewH: Test(i)==',(Test(i),i=1,8)
      End If
*
*     Branch out if the first iteration
*
      If (nIter.le.1) Go To 999
*                                                                      *
************************************************************************
*                                                                      *
*-----Get the MM mask
      DoMask=.False.
      If (Allocated(UpdMask)) Then
         If (Size(UpdMask).eq.nInter) DoMask=.True.
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(dg,nInter,label="dg")
      Call mma_allocate(gi,nInter,label="gi")
      Call mma_allocate(dq,nInter,nIter,label="dq")
      call dcopy_(nInter*nIter,dq_orig,1,dq,1)
*                                                                      *
************************************************************************
*                                                                      *
*-----Form the difference between the gradients. Observe the order!
*     This since we are storing the forces rather than the gradients,
*     big mistake!!!
*
      Do i = 1, nInter
         dg(i) = g(i,nIter-1) - g(i,nIter)
         If (DoMask) Then
            If (UpdMask(i).ne.0) Then
               dg(i) = Zero
               dq(i,nIter-1) = Zero
            End If
         End If
      End Do
      If (iPrint.ge.99) Call RecPrt(' NewH: dg',' ',dg,nInter,1)
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute the update
*
      iSing=0
      If (Test(4)) Then
*
*------- No update
*
         HUpMet=' None '
*
      Else If (Test(1)) Then
*
*------ Fletcher (or Meyer) update
*
         HUpMet='  F   '
         Write (6,*) 'Deleted option in NewH'
         Call Abend()
*
      Else If (Test(2)) Then
*
*------- Broyden-Powel Symmetric Rank-2 update
*
         HUpMet='  BP  '
         Write (6,*) 'Deleted option in NewH'
         Call Abend()
*
      Else If (Test(3)) Then
*
*------- Broyden-Fletcher-Goldfarb-Shanno update
*
         HUpMet=' BFGS '
         Call  DFP(H,nInter,gi,dq(1,nIter-1),dg)
*
      Else If (Test(5)) Then
*
*------- Murtagh-Sargent-Powell update
*
         HUpMet=' MSP  '
         Call dGeMV_('N',nInter,nInter,
     &              -One,H,nInter,
     &              dq(1,nIter-1),1,
     &              One,dg,1)
         If (iPrint.ge.99) Call RecPrt(' NewH: gamma',' ',dg,nInter,1)
         Call MSP(H,gi,dg,dq(1,nIter-1),nInter)
*
      Else If (Test(7)) Then
*
*------- EU update
*
         HUpMet='  EU  '
*
*        Some precalculations:
         Do i=1,nInter
            gi(i) = -g(i,nIter-1)
            If (DoMask) Then
               If (UpdMask(i).ne.0) gi(i) = Zero
            End If
         End Do
*
         Call EU(dq(1,nIter-1),dg,gi,H,nInter)
*
      Else If (Test(8)) Then
*
*------- TS_BFGS update
*
         HUpMet='TSBFGS'
*
*        Some precalculations:
         Do i=1,nInter
            gi(i) = -g(i,nIter-1)
            If (DoMask) Then
               If (UpdMask(i).ne.0) gi(i) = Zero
            End If
         End Do
*
         Call TS_BFGS(dq(1,nIter-1),dg,gi,H,nInter)
*
      Else
*
         Call WarningMessage(2,'Error in NewH')
         Write (6,*) ' Improper value of iOptH:',iOptH
         Call Abend()
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.99) Then
         Call RecPrt(' NewH:  H(New)',' ',H,nInter,nInter)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(dg)
      Call mma_deallocate(gi)
      Call mma_deallocate(dq)
*                                                                      *
************************************************************************
*                                                                      *
 999  Continue
      Return
      End Subroutine NewH

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!----------------------------------------------------------------------*
! A routine inspired by the wr_motra_info utility.                     *
!----------------------------------------------------------------------*
subroutine WrRdSim(iLu,iOpt,iDisk,iTcSim,nTcSim,Etot,Radie,nPart,Gmma,Gam,Esav)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iLu, iOpt, nTcSim
integer(kind=iwp), intent(inout) :: iDisk, iTcSim(nTcSim), nPart
real(kind=wp), intent(inout) :: Etot, Radie, Gmma, Gam, Esav
integer(kind=iwp) :: iDum(1)
real(kind=wp) :: Dum(1)

call iDaFile(iLu,iOpt,iTcSim,nTcSim,iDisk)
Dum(1) = Etot
call dDaFile(iLu,iOpt,Dum,1,iDisk)
Etot = Dum(1)
Dum(1) = Radie
call dDaFile(iLu,iOpt,Dum,1,iDisk)
Radie = Dum(1)
iDum(1) = nPart
call iDaFile(iLu,iOpt,iDum,1,iDisk)
nPart = iDum(1)
Dum(1) = Gmma
call dDaFile(iLu,iOpt,Dum,1,iDisk)
Gmma = Dum(1)
Dum(1) = Gam
call dDaFile(iLu,iOpt,Dum,1,iDisk)
Gam = Dum(1)
Dum(1) = Esav
call dDaFile(iLu,iOpt,Dum,1,iDisk)
Esav = Dum(1)

return

end subroutine WrRdSim

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetCnt(NATOMS)
! Purpose: Read data from ONEINT

use Cntrl, only: Coor
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: NATOMS

! Read NATOMS, nr of symmetry-unique atoms
call Get_iScalar('Unique atoms',NATOMS)

! Read COOR, cartesian coordinates of each atom
call Get_dArray('Unique Coordinates',COOR,3*nAtoms)

end subroutine GetCnt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine Freeze(TrMat,nTrMat,OneHam,mBT)
************************************************************************
*                                                                      *
*     purpose: Modify transformation matrix such atomic orbitals we    *
*              want to freeze are put in the first position            *
*                                                                      *
*     input:                                                           *
*       TrMat   : transformation matrix of length nTrMat               *
*                                                                      *
*     output:                                                          *
*       TrMat   : modified transformation matrix                       *
*                                                                      *
*     called from: TrGen                                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 TrMat(nTrMat), OneHam(mBT)
      Real*8, Dimension(:), Allocatable:: Temp
*
*
*---- Define local variables
      Integer MapBas(MxBas,MxSym)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*
*---- Allocate temporary spaces
      Call mma_allocate(Temp,nBT,Label='Temp')
*
      call dcopy_(nBT,OneHam,1,Temp,1)
*
*---- Form an array saying which atomic orbitals are frozen
      iStart = 0
      Do iSym = 1, nSym
         nOr = nOrb(iSym)
         Do iFro = 1, nFro(iSym)
            OEMin = 1.0d+06
            iStrt = iStart
            iSta=0
            Do iBas = 1, nOr
               iStrt = iStrt + iBas
               If (Temp(iStrt).lt.OEMin) Then
                  MapBas(iFro,iSym)=iBas
                  OEMin = Temp(iStrt)
                  iSta = iStrt
               End If
            End Do
            If (iSta.ne.0) Temp(iSta) = -Temp(iSta)
         End Do
         iStart = iStart + nOr*(nOr + 1)/2
         Do i = 1, nFro(iSym) - 1
            k = i
            Do j = i + 1, nFro(iSym)
               If (MapBas(j,iSym).lt.MapBas(k,iSym)) k = j
            End Do
            If (k.ne.i) Then
               iSwap          = MapBas(k,iSym)
               MapBas(k,iSym) = MapBas(i,iSym)
               MapBas(i,iSym) = iSwap
            End If
         End Do
      End Do
*
*---- Move frozen atomic orbitals to the first positions
      iCMO = 1
      Do iSym = 1, nSym
         Do iFro = 1, nFro(iSym)
            ind1 = iCMO + (iFro              - 1)*nBas(iSym)
            ind2 = iCMO + (MapBas(iFro,iSym) - 1)*nBas(iSym)
            Call DSwap_(nBas(iSym),TrMat(ind1),1,TrMat(ind2),1)
         End Do
         iCMO = iCMO + nBas(iSym)*nOrb(iSym)
      End Do
*
*---- Deallocate memory
      Call mma_deallocate(Temp)
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Roland Lindh                                     *
!***********************************************************************

subroutine RdTwoEnrg(LU,E2act)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: LU
real(kind=wp), intent(out) :: E2act
integer(kind=iwp) :: istatus
logical(kind=iwp) :: Exists
character(len=80) :: LINE

call OpnFl('INPORB',LU,Exists)
if (.not. Exists) then
  write(u6,*) 'RdTwoEnrg: INPORB not found!'
  call Abend()
end if
rewind(LU)
do
  read(LU,'(A80)',iostat=istatus) Line
  if (istatus /= 0) call Error_quit()
  if (Line(1:22) == '* ACTIVE TWO-EL ENERGY') exit
end do
read(LU,'(ES19.12)',iostat=istatus) E2act
if (istatus /= 0) call Error_quit()

close(LU)

return

contains

subroutine Error_quit()

  call SysWarnFileMsg('RdTwoEnrg','INPORB','Error during reading INPORB\n','Field not there')
  call Abend()

end subroutine Error_quit

end subroutine RdTwoEnrg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1994, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE ADST(IORB,NORB,ICLS,ISM,IGRP,KMIN,KMAX,I1,XI1S,LI1,
     &                NK,IEND)
      Use Str_Info
*
*
* Obtain mappings
* a+JORB !KSTR> = +/-!ISTR> for orbitals IORB - IORB+NORB-1
*. All orbitals are assumed to belong to the same TS class
* In the form
* I1(KSTR,JORB) =  ISTR if A+JORB !KSTR> = +/-!ISTR> , ISTR is in
* ICLS,ISM,IGRP.
* (numbering relative to TS start)
*
* Above +/- is stored in XI1S
* Number of K strings checked is returned in NK
* Only Kstrings with relative numbers from KMIN to KMAX are included
* If KMAX = -1, all strings are included
* If all K strings have been searched IEND is set to 1
*
* Jeppe Olsen , Winter of 1991
*               January 1994 : modified to allow for several orbitals
*
* ======
*. Input
* ======
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "detdim.fh"
#include "orbinp_mclr.fh"
*
* =======
*. Output
* =======
*
      INTEGER I1(*)
      DIMENSION XI1S(*)
*. Type of mapping
C?     write(6,*) ' ADST: IGRP IORB = ',IGRP, IORB
*
      JGRP = IGRP + 1
      IF(IUNIQMP(JGRP).NE.JGRP) THEN
        JGRP = -IUNIQMP(JGRP)
C        write(6,*) ' Unique string group for mappings ',JGRP
      END IF
*
      IF(ISTAC(JGRP,1).NE.0.AND.ISTAC(JGRP,2).NE.0) THEN
*. Full Map
        IMPF = 1
        LMAP = NACOB
      ELSE
*. Only creation map
        IMPF = 0
        LMAP = -1
      END IF
*
      CALL ADS1(NK,I1,XI1S,LI1,IORB,NORB,
     &           ICLS,ISM,
     &           Str(JGRP)%STSTM(:,1),
     &           Str(JGRP)%STSTM(:,2),
     &           Str(JGRP)%STSTMN,
     &           Str(JGRP)%STSTMI,IMPF,LMAP,Str(IGRP)%EL1,
     &           Str(IGRP)%EL3,Str(IGRP+1)%EL1,
     &           Str(IGRP+1)%EL3,Str(IGRP)%ISTSO,
     &           Str(IGRP)%NSTSO,Str(IGRP+1)%ISTSO,
     &           Str(IGRP+1)%NSTSO,NOCTYP(IGRP),NOCTYP(IGRP+1),
     &           NORB1,NORB2,NORB3,ISMFTO,NACOB,KMAX,KMIN,IEND)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ddressvb_cvb( &
#                       define _CALLING_
#                       include "ddres_interface.fh"
                       )

use Definitions, only: wp, iwp

implicit none
#include "ddres_interface.fh"

#include "macros.fh"
unused_var(axc)

call mxatb_cvb(sxc,solp_res,n,itdav,1,res)
res(:) = rhs(:)-eig_res*res(:)

is_converged = .true.

return

end subroutine ddressvb_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine getSeed(iseed)

use UnixInfo, only: ProgName
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: iseed
integer(kind=iwp) :: days, hours, i, minutes, seconds
character(len=72) :: Line

! Externally defined seed
call getenvf('MOLCAS_RANDOM_SEED',Line)
if (Line /= ' ') then
  read(Line,*) iseed
  return
end if

! Somewhat reproducible if inside verification
call getenvf('MOLCAS_TEST',Line)
if (Line /= ' ') then
  call getenvf('MOLCAS_ITER',Line)
  read(Line,*) iseed
  call getenvf('MOLCAS_PRINT',Line)
  do i=1,len_trim(Line)
    iseed = iseed+ichar(Line(i:i))
  end do
  Line = trim(ProgName)
  do i=1,len_trim(Line)
    iseed = iseed+ichar(Line(i:i))
  end do
  return
end if

! Default: based on time and project name
call datimx(Line)
read(Line,'(8x,i2,1x,i2,1x,i2,1x,i2)') days,hours,minutes,seconds
iseed = int(((days*24+hours)*60+minutes)*60+seconds,kind(iseed))
call getenvf('Project',Line)
do i=1,len_trim(Line)
  iseed = iseed+ichar(Line(i:i))
end do

return

end subroutine getSeed

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chk_Numerical(LuSpool,Numerical)

use Alaska_Info, only: Auto, DefRoot, ForceNAC, iRlxRoot
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LuSpool
logical(kind=iwp), intent(out) :: Numerical
#include "nac.fh"
integer(kind=iwp) :: iDNG, iGO, iRoot, iRoot0, istatus, LuWr
real(kind=wp) :: rDelta
logical(kind=iwp) :: Is_Root_Set, DNG, KeepOld, Found
character(len=180) :: KWord, Key
character(len=180), external :: Get_Ln

call Qpg_iScalar('DNG',DNG)
if (DNG) then
  call Get_iScalar('DNG',iDNG)
  Numerical = iDNG == 1
else
  Numerical = .false.
end if
LuWr = u6

! Setting the defaults
!    iRoot     : Which root to optimize the geometry for
!    rDelta    : Displacements are chosen as r_nearest_neighbor * rDelta
iRoot = 1
rDelta = 0.01_wp
NACstates(1) = 0
NACstates(2) = 0
isNAC = .false.
KeepOld = .false.
DefRoot = .true.
ForceNAC = .false.
iRlxRoot = 1
Auto = .false.

! RASSCF will set the default root to the root that is relaxed.

Is_Root_Set = .false.
call Qpg_iScalar('NumGradRoot',Is_Root_Set)
if (Is_Root_Set) then
  call Get_iScalar('NumGradRoot',iRoot)
end if

rewind(LuSpool)
call RdNLst(LuSpool,'ALASKA')
KWord = ' &ALASKA'
do
  read(LuSpool,'(A72)',iostat=istatus) Key
  if (istatus > 0) then
    call WarningMessage(2,'Chk_Numerical: Error reading the input')
    write(LuWr,'(A,A)') 'Last read line=',KWord
    call Quit_OnUserError()
  else if (istatus < 0) then
    exit
  end if
  KWord = Key
  call UpCase(KWord)
  select case (KWord(1:4))
    case ('NUME')
      Numerical = .true.
    case ('ROOT')
      Key = Get_Ln(LuSpool)
      call Get_I1(1,iRoot)
      DefRoot = .false.
    case ('DELT')
      Key = Get_Ln(LuSpool)
      call Get_F1(1,rDelta)
    case ('NAC ')
      Key = Get_Ln(LuSpool)
      call Get_I(1,NACstates,2)
      isNAC = .true.
      DefRoot = .false.
    case ('KEEP')
      KeepOld = .true.
    case ('AUTO')
      Auto = .true.
    case ('END ')
      exit
    case default
  end select
end do

call Get_iScalar('Grad ready',iGO)
iGO = ibclr(iGo,0)
call Put_iScalar('Grad ready',iGO)

! Put on the runfile which root and delta to use

call qpg_iScalar('Relax CASSCF root',Found)
if (Found) then
  call Get_iScalar('Relax CASSCF root',iRoot0)
  call Put_iScalar('NumGradRoot',iRoot)
  call Put_iScalar('Relax CASSCF root',iRoot)
else
  iRoot0 = 0
end if
call Put_dScalar('Numerical Gradient rDelta',rDelta)

! These are really input options for numerical_gradient

call Put_lScalar('Keep old gradient',KeepOld)

return

end subroutine Chk_Numerical

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994,1995,1999, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine LCISPC()
! Number of dets and combinations
! per symmetry for each type of internal space
!
! Jeppe Olsen, Winter 1994/1995 (woops!)
!              MXSOOB_AS added, MXSB removed May 1999
!
! GAS VERSION

use lucia_data, only: IDC, MXNTTS, MXSOOB, NCMBSPC, NIRREP, NOCTYP, NSTSO, XISPSM
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IATP, IBTP, ICI, ISYM, LCOL, MXSOO, MXSOO_AS, NCOMB, NOCTPA, NOCTPB, NTTSBL
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: II
#endif
real(kind=wp) :: XNCOMB
integer(kind=iwp), allocatable :: CVST(:), LBLTP(:), LIOIO(:), NBLKIC(:,:)

!write(u6,*) ' LCISPC : NCMBSPC ',NCMBSPC
! Type of alpha- and beta strings
IATP = 1
IBTP = 2

NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)
! Local memory
call mma_allocate(LBLTP,NIRREP,Label='LBLTP')
call mma_allocate(CVST,NIRREP,Label='CVST')
call mma_allocate(LIOIO,NOCTPA*NOCTPB,Label='LIOIO')
call mma_allocate(NBLKIC,NIRREP,NCMBSPC,Label='NBLKIC')
! Obtain array giving symmetry of sigma v reflection times string
! symmetry.
!if ((IDC == 3) .or. (IDC == 4)) call SIGVST(CVST,NIRREP)

! Number of internal dets for each symmetry

MXSOOB = 0
do ICI=1,NCMBSPC
  ! allowed combination of types
  call IAIBCM(ICI,LIOIO)

  do ISYM=1,NIRREP
    call ZBLTP(ISYM,NIRREP,IDC,LBLTP,CVST)
    call NGASDT(ISYM,NIRREP,NOCTPA,NOCTPB,NSTSO(IATP)%A,NSTSO(IBTP)%A,NCOMB,XNCOMB,MXSOO,LBLTP,NTTSBL,LCOL,LIOIO,MXSOO_AS)

    XISPSM(ISYM,ICI) = XNCOMB
    MXSOOB = max(MXSOOB,MXSOO)
    !MXSOOB_AS = max(MXSOO_AS,MXSOOB_AS)
    NBLKIC(ISYM,ICI) = NTTSBL
    !LCOLIC(ISYM,ICI) = LCOL
  end do
end do
call mma_deallocate(LBLTP)
call mma_deallocate(CVST)
call mma_deallocate(LIOIO)

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*)
write(u6,*) ' Number of internal combinations per symmetry'
write(u6,*) ' ============================================'

do ICI=1,NCMBSPC
  write(u6,*) ' CI space ',ICI
  write(u6,'(1X, 4ES22.15)') (XISPSM(II,ICI),II=1,NIRREP)
  !call WRTMAT(XISPSM(1,ICI),1,NIRREP,1,NIRREP)
end do
write(u6,*)
write(u6,*) ' Largest Symmetry-type-type block ',MXSOOB
!write(u6,*) ' Largest type-type block (all symmetries) ',MXSOOB_AS
write(u6,*)

write(u6,*) ' Number of TTS subblocks per CI expansion'
write(u6,*) ' ========================================'

do ICI=1,NCMBSPC
  write(u6,*) ' Internal CI space ',ICI
  call IWRTMA(NBLKIC(:,ICI),1,NIRREP,1,NIRREP)
end do
#endif
! Largest number of BLOCKS in a CI expansion
MXNTTS = max(0,maxval(NBLKIC(:,:)))

#ifdef _DEBUGPRINT_
write(u6,*) ' Largest number of blocks in CI expansion',MXNTTS

write(u6,*) ' Number of columns per CI expansion'
write(u6,*) ' =================================='

!do ICI=1,NCMBSPC
!  write(u6,*) ' Internal CI space ',ICI
!  call IWRTMA(LCOLIC(:,ICI),1,NIRREP,1,NIRREP)
!end do
#endif

call mma_deallocate(NBLKIC)

end subroutine LCISPC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_T1g(T1,dima,adda)
! this routine tests T1g

use chcc_global, only: no, T1c
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dima, adda
real(kind=wp), intent(inout) :: T1(no,dima)
integer(kind=iwp) :: a, bad, i, ntot
real(kind=wp) :: s

bad = 0
ntot = 0

do i=1,no
  do a=adda+1,adda+dima

    s = T1c(a,i)

    if (abs(T1(i,a-adda)-s) > 1.0e-10_wp) then
      bad = bad+1
      T1(i,a-adda) = s
    end if
    ntot = ntot+1

  end do
end do

write(u6,*) ' T1g   ',bad,ntot

return

end subroutine Chck_T1g

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine initialize guessorb.                                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: Oct 2004                                                    *
!                                                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine InitGO()

use GuessOrb_Global, only: AtName, GapThr, iPrFmt, Label, nBas, nDel, nNuc, nOcc, nSym, nVir, PrintEor, PrintMOs, PrintPop, PrThr, &
                           SThr, TThr
#ifdef _OLD_
use GuessOrb_Global, only: xCharge
#endif
use Molcas, only: MxAtom
use Constants, only: Five
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: iPrt, lenName, nBasTot
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, iBas
#endif
logical(kind=iwp) :: Found
integer(kind=iwp), external :: iPrintLevel

!----------------------------------------------------------------------*
! Setup                                                                *
!----------------------------------------------------------------------*
lenName = len(AtName)
!----------------------------------------------------------------------*
! Set default for MO printing.                                         *
!----------------------------------------------------------------------*
iPrt = iPrintLevel(-1)
if (iPrt >= 4) then
  PrintMOs = .true.
  PrintEor = .true.
  PrintPop = .true.
  iPrFmt = 3
  PrThr = huge(PrThr)
else if (iPrt >= 3) then
  PrintMOs = .false.
  PrintEor = .false.
  PrintPop = .false.
  iPrFmt = 1
  PrThr = Five
else
  PrintMOs = .false.
  PrintEor = .false.
  PrintPop = .false.
  PrThr = Five
end if
!----------------------------------------------------------------------*
! Set other defaults.                                                  *
!----------------------------------------------------------------------*
call Qpg_dScalar('S delete thr',Found)
if (Found) then
  call Get_dScalar('S delete thr',SThr)
else
  SThr = 1.0e-9_wp
  call Put_dScalar('S delete thr',SThr)
end if
call Qpg_dScalar('T delete thr',Found)
if (Found) then
  call Get_dScalar('T delete thr',TThr)
else
  TThr = huge(TThr)
  call Put_dScalar('T delete thr',TThr)
end if
GapThr = 0.01_wp
!----------------------------------------------------------------------*
! Get basic data from runfile.                                         *
!----------------------------------------------------------------------*
call get_iscalar('nSym',nSym)
call get_iarray('nBas',nBas,nSym)
nOcc(:) = 0
nVir(:) = 0
nDel(:) = 0
nBasTot = sum(nBas(1:nSym))
#ifdef _DEBUGPRINT_
write(u6,'(a,8i5)') 'initgo: nSym',nSym
write(u6,'(a,8i5)') 'initgo: nBas',nBas
write(u6,'(a,8i5)') 'initgo: nOcc',nOcc
write(u6,'(a,8i5)') 'initgo: nVir',nVir
write(u6,'(a,8i5)') 'initgo: nBasTot',nBasTot
#endif
call get_iscalar('Unique Atoms',nNuc)
if (nNuc > MxAtom) call SysAbendMsg('initgo','Fatal:','Too many atoms, increase MxAtom')
call get_carray('Unique Atom Names',AtName,lenName*nNuc)
call get_carray('Unique Basis Names',Label,len(Label)*nBasTot)
#ifdef _DEBUGPRINT_
write(u6,'(a,8i5)') 'initgo: nNuc',nNuc
write(u6,'(a,8i5)') 'initgo: nBasTot',nBasTot
#ifdef _OLD_
call get_darray('Nuclear Charge',xCharge,nNuc)
write(u6,'(a,8f12.6)') 'initgo: Charge',(xCharge(i),i=1,nNuc)
#endif
write(u6,'(a,8a4)') 'initgo: Name ',(AtName(i),i=1,nNuc)
write(u6,'(a)') 'initgo: Basis functions'
do iBas=1,nBasTot
  write(u6,'(2a)') Label(iBas)(1:lenName),Label(iBas)(lenName+1:)
end do
#endif
!----------------------------------------------------------------------*
! Done                                                                 *
!----------------------------------------------------------------------*

end subroutine InitGO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine tuneinp_cvb()
      implicit real*8 (a-h,o-z)
      parameter(nstrin=37,ncmp=8)
      character*8 string(nstrin)
      character*1 true(1)
#include "tune_cvb.fh"
#include "tols_cvb.fh"
#include "trst_cvb.fh"
#include "davtune_cvb.fh"
#include "optze_cvb.fh"
#include "print_cvb.fh"
#include "idbl_cvb.fh"
      dimension iaux(1),daux(1)
      save string,true
      data string/'CNRMTOL ','SAFETY  ','SIGNTOL','ALFTOL  ',
     >            'DFXTOL  ','EXP12TOL','GRDWRNGT','EIGWRNG ',
     >            'SINGUL  ','DFX     ','SIGN    ','ZZMAX   ',
     >            'ZZMIN   ','DX      ','GRD     ','NOPTH1  ',
     >            'NOPTH2  ','DELOPTH1','DELOPTH2','HHREJFAC',
     >            'HHACCFAC','ZZACCLIM','HHTOL   ','DFXMIN  ',
     >            'ZZREJMIN','ZZREJMAX','SCALESMA','HHSTART ',
     >            'RESTHR  ','NORTITER','ORTHTHR ','FOLLOW  ',
     >            'MXDAV   ','LASTUPD ','ENDIFCLO','ENDTUNE ',
     >            'END     '/
      data true/'T'/

1000  call fstring_cvb(string,nstrin,istr,ncmp,2)
      if(istr.eq.36.or.istr.eq.37)then
c 'ENDTUNE' or 'END'
        istr=0
      endif
      if(istr.eq.1)then
c  'CNRMTOL'
        call real_cvb(daux,1,nread,1)
        cnrmtol=daux(1)
      elseif(istr.eq.2)then
c  'SAFETY'
        call real_cvb(daux,1,nread,1)
        safety=daux(1)
      elseif(istr.eq.3)then
c  'SIGNTOL'
        call real_cvb(daux,1,nread,1)
        signtol=daux(1)
      elseif(istr.eq.4)then
c  'ALFTOL'
        call real_cvb(daux,1,nread,1)
        alftol=daux(1)
      elseif(istr.eq.5)then
c  'DFXTOL'
        call real_cvb(daux,1,nread,1)
        dfxtol=daux(1)
      elseif(istr.eq.6)then
c  'EXP12TOL'
        call real_cvb(daux,1,nread,1)
        exp12tol=daux(1)
      elseif(istr.eq.7)then
c  'GRDWRNGT'
        call real_cvb(daux,1,nread,1)
        grdwrngtol=daux(1)
      elseif(istr.eq.8)then
c  'EIGWRNG '
        call real_cvb(daux,1,nread,1)
        eigwrntol=daux(1)
      elseif(istr.eq.9)then
c  'SINGUL'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.3)then
          write(6,*)' Illegal I index in SINGUL :',i
          call abend_cvb()
        endif
        call real_cvb(singul(i),1,nread,1)
      elseif(istr.eq.10)then
c  'DFX'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.6)then
          write(6,*)' Illegal I index in DFX :',i
          call abend_cvb()
        endif
        call real_cvb(dfx(i),1,nread,1)
      elseif(istr.eq.11)then
c  'SIGN'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.6)then
          write(6,*)' Illegal I index in SIGN :',i
          call abend_cvb()
        endif
        call real_cvb(sign(i),1,nread,1)
      elseif(istr.eq.12)then
c  'ZZMAX'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.6)then
          write(6,*)' Illegal I index in ZZMAX :',i
          call abend_cvb()
        endif
        call real_cvb(zzmax(i),1,nread,1)
      elseif(istr.eq.13)then
c  'ZZMIN'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.6)then
          write(6,*)' Illegal I index in ZZMIN :',i
          call abend_cvb()
        endif
        call real_cvb(zzmin(i),1,nread,1)
      elseif(istr.eq.14)then
c  'DX'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.3)then
          write(6,*)' Illegal I index in DX :',i
          call abend_cvb()
        endif
        call int_cvb(iaux,1,nread,1)
        j=iaux(1)
        if(j.lt.1.or.j.gt.6)then
          write(6,*)' Illegal J index in DX :',j
          call abend_cvb()
        endif
        call real_cvb(dx(i,j),1,nread,1)
      elseif(istr.eq.15)then
c  'GRD'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.3)then
          write(6,*)' Illegal I index in GRD :',i
          call abend_cvb()
        endif
        call int_cvb(iaux,1,nread,1)
        j=iaux(1)
        if(j.lt.1.or.j.gt.6)then
          write(6,*)' Illegal J index in GRD :',j
          call abend_cvb()
        endif
        call real_cvb(grd(i,j),1,nread,1)
      elseif(istr.eq.16)then
c  'NOPTH1'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in NOPTH1 :',i
          call abend_cvb()
        endif
        call int_cvb(nopth1(i),1,nread,1)
      elseif(istr.eq.17)then
c  'NOPTH2'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in NOPTH2 :',i
          call abend_cvb()
        endif
        call int_cvb(nopth2(i),1,nread,1)
      elseif(istr.eq.18)then
c  'DELOPTH1'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in DELOPTH1 :',i
          call abend_cvb()
        endif
        call real_cvb(delopth1(i),1,nread,1)
      elseif(istr.eq.19)then
c  'DELOPTH2'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in DELOPTH2 :',i
          call abend_cvb()
        endif
        call real_cvb(delopth2(i),1,nread,1)
      elseif(istr.eq.20)then
c  'HHREJFAC'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in HHREJFAC :',i
          call abend_cvb()
        endif
        call real_cvb(hhrejfac(i),1,nread,1)
      elseif(istr.eq.21)then
c  'HHACCFAC'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.5)then
          write(6,*)' Illegal I index in HHACCFAC :',i
          call abend_cvb()
        endif
        call int_cvb(iaux,1,nread,1)
        j=iaux(1)
        if(j.lt.1.or.j.gt.2)then
          write(6,*)' Illegal J index in HHACCFAC :',j
          call abend_cvb()
        endif
        call real_cvb(hhaccfac(i,j),1,nread,1)
      elseif(istr.eq.22)then
c  'ZZACCLIM'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.4)then
          write(6,*)' Illegal I index in ZZACCLIM :',i
          call abend_cvb()
        endif
        call int_cvb(iaux,1,nread,1)
        j=iaux(1)
        if(j.lt.1.or.j.gt.2)then
          write(6,*)' Illegal J index in ZZACCLIM :',j
          call abend_cvb()
        endif
        call real_cvb(zzacclim(i,j),1,nread,1)
      elseif(istr.eq.23)then
c  'HHTOL'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in HHTOL :',i
          call abend_cvb()
        endif
        call real_cvb(hhtol(i),1,nread,1)
      elseif(istr.eq.24)then
c  'DFXMIN'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in DFXMIN :',i
          call abend_cvb()
        endif
        call real_cvb(dfxmin(i),1,nread,1)
      elseif(istr.eq.25)then
c  'ZZREJMIN'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in ZZREJMIN :',i
          call abend_cvb()
        endif
        call real_cvb(zzrejmin(i),1,nread,1)
      elseif(istr.eq.26)then
c  'ZZREJMAX'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in ZZREJMAX :',i
          call abend_cvb()
        endif
        call real_cvb(zzrejmax(i),1,nread,1)
      elseif(istr.eq.27)then
c  'SCALESMALL'
        call int_cvb(iaux,1,nread,1)
        i=iaux(1)
        if(i.lt.1.or.i.gt.2)then
          write(6,*)' Illegal I index in SCALESMALL :',i
          call abend_cvb()
        endif
        call fstring_cvb(true,1,istr2,1,1)
        scalesmall(i)=(istr2.eq.1)
      elseif(istr.eq.28)then
c  'HHSTART'
        call real_cvb(daux,1,nread,1)
        hhstart=daux(1)
      elseif(istr.eq.29)then
c  'RESTHR'
        call real_cvb(daux,1,nread,1)
        resthr=daux(1)
      elseif(istr.eq.30)then
c  'NORTITER'
        call int_cvb(iaux,1,nread,1)
        nortiter=iaux(1)
      elseif(istr.eq.31)then
c  'ORTHTHR'
        call real_cvb(daux,1,nread,1)
        orththr=daux(1)
      elseif(istr.eq.32)then
c  'FOLLOW'
        call fstring_cvb(true,1,istr2,1,1)
        follow=(istr2.eq.1)
      elseif(istr.eq.33)then
c  'MXDAV'
        call int_cvb(iaux,1,nread,1)
        mxdav=iaux(1)
      elseif(istr.eq.34)then
c  'LASTUPD'
        call fstring_cvb(true,1,istr2,1,1)
        lastupd=(istr2.eq.1)
      elseif(istr.eq.35)then
c  'ENDIFCLOSE'
        call fstring_cvb(true,1,istr2,1,1)
        endifclose=(istr2.eq.1)
      endif
c 'END', 'ENDTUNE' or unrecognized keyword -- end of input :
      if(istr.ne.0)goto 1000
      return
      entry tuneprint_cvb()
      if(ip(3).lt.3)return
      if(imethod.ne.4)then
      write(6,'(/,2a)')' -------- Details of parameters used by 2nd-',
     >  'order optimizer: -------------'
      write(6,'(/,a,/)')' General parameters:'
      call fout_cvb(safety,'SAFETY',
     >  'Alpha safety in denominator, (H - alpha * I):')
      call fout_cvb(cnrmtol,'CNRMTOL',
     >  'Tolerance for size of update:')
      call fout_cvb(signtol,'SIGNTOL',
     >  'Tolerance for sign of Hessian eigenvalues:')
      call fout_cvb(alftol,'ALFTOL',
     >  'Convergence criterion on alpha:')
      call fout_cvb(dfxtol,'DFXTOL',
     >  'DFX tolerance for act/exp ratio:')
      call fout_cvb(exp12tol,'EXP12TOL',
     >  'Criterion on expected change of f(x):')
      call fout_cvb(grdwrngtol,'GRDWRNGTOL',
     >  'Gradient tol. for scaling small updates:')
      call fout_cvb(eigwrngtol,'EIGWRNGTOL',
     >  'Eigenvalue tol. for scaling small updates:')
      call lout_cvb(lastupd,'LASTUPD',
     >  'Perform update at convergence?')
      call lout_cvb(endifclose,'ENDIFCLOSE',
     >  'Exit if optimization close to convergence?')
      write(6,'(/,a)')' Convergence criteria:'
      write(6,'(/,a)')' Elements of arrays:'
      write(6,'(a)')' (1) ... Optimization is in global region.'
      write(6,'(a)')' (2) ... Optimization is in local region.'
      write(6,'(2a)')' (3) ... Optimization is close to wrong ',
     >  'stationary point.'
      call fouti_cvb(singul,3,'SINGUL(3)',
     >  'Thresholds for sing. Hessian (max abs eig):')
      write(6,'(/,a)')' Elements of arrays:'
      write(6,'(a)')' (*,1) ... Global region, non-singular Hessian.'
      write(6,'(a)')' (*,2) ... Global region, singular Hessian.'
      write(6,'(a)')' (*,3) ... Local region, non-singular Hessian.'
      write(6,'(a)')' (*,4) ... Local region, singular Hessian.'
      write(6,'(2a)')' (*,5) ... Wrong stationary point, ',
     >  'non-singular Hessian.'
      write(6,'(2a)')' (*,6) ... Wrong stationary point, ',
     >  'singular Hessian.'
      call fouti_cvb(sign,6,'SIGN(6)',
     >  'Threshold for sign of Hessian eigenvalues:')
      call fouti_cvb(zzmin,6,'ZZMIN(6)',
     >  'Mininum allowed act/exp ratio:')
      call fouti_cvb(zzmax,6,'ZZMAX(6)',
     >  'Maximum allowed act/exp ratio:')
      call fouti_cvb(dfx,6,'DFX(6)',
     >  'Maximum allowed change in f(x):')
      write(6,'(/,a)')' Elements of arrays:'
      write(6,'(a)')' (1,*) ... Use maximum absolute value in vector.'
      write(6,'(a)')' (2,*) ... Use norm of vector.'
      write(6,'(a)')' (3,*) ... Use RMS of elements in vector.'
      call foutij_cvb(dx,3,6,'DX(3,6)',
     >  'Maximum allowed change in variables:')
      call foutij_cvb(grd,3,6,'GRD(3,6)',
     >  'Maximum allowed gradient:')
      write(6,'(/,a,/)')' Trust region control:'
      call fout_cvb(hhstart,'HHSTART',
     >  'Initial trust region size:')
      call iout_cvb(nopth1(1),'NOPTH1(1)',
     >  'Number of steps (primary trust size opt):')
      call iout_cvb(nopth2(1),'NOPTH2(1)',
     >  'Number of steps (secondary trust size opt):')
      call iout_cvb(nopth1(2),'NOPTH1(2)',
     >  'Number of steps (primary trust size opt):')
      call iout_cvb(nopth2(2),'NOPTH2(2)',
     >  'Number of steps (secondary trust size opt):')
      call fouti_cvb(delopth1,2,'DELOPTH1(2)',
     >  'Primary change of trust region size:')
      call fouti_cvb(delopth2,2,'DELOPTH2(2)',
     >  'Secondary change of trust region size:')
      call fouti_cvb(hhmax,2,'HHMAX(2)',
     >  'Maximum allowed trust region size:')
      call fouti_cvb(zzrejmin,2,'ZZREJMIN(2)',
     >  'Minimum allowed act/exp ratio:')
      call fouti_cvb(zzrejmax,2,'ZZREJMAX(2)',
     >  'Maximum allowed act/exp ratio:')
      call fouti_cvb(dfxmin,2,'DFXMIN(2)',
     >  'Minimum allowed change in f(x):')
      call fouti_cvb(hhrejfac,2,'HHREJFAC(2)',
     >  'Trust region size scale factor for rejections:')
      call foutij_cvb(zzacclim,4,2,'ZZACCLIM(4,2)',
     >  'Act/exp regions for scaling accepted steps:')
      call foutij_cvb(hhaccfac,5,2,'HHACCFAC(5,2)',
     >  'Trust scale factors for accepted steps:')
      call fouti_cvb(hhtol,2,'HHTOL(2)',
     >  'Minimum allowed trust region size:')
      call lout_cvb(scalesmall(1),'SCALESMALL(1)',
     >  'Scale predicted steps smaller than trust?')
      call lout_cvb(scalesmall(2),'SCALESMALL(2)',
     >  'Scale predicted steps smaller than trust?')
      write(6,'(/,2a)')' -------------------------------------------',
     >  '------------------------------'
      elseif(imethod.eq.4)then
      write(6,'(/,2a,/)')' -------- Details of parameters used by Davi',
     >  'dson optimizer: --------------'
      call iout_cvb(mxdav,'MXDAV',
     >  'Maxium dimension of Davidson subspace:')
      call fout_cvb(resthr,'RESTHR',
     >  'Convergence criterion on residual norm:')
      call lout_cvb(follow,'FOLLOW',
     >  'Root following (for excited states):')
      call fout_cvb(orththr,'ORTHTHR',
     >  'Tolerance for orthogonality between vectors:')
      call iout_cvb(nortiter,'NORTITER',
     >  'Maximum number of orthogonalization attempts:')
      write(6,'(/,2a)')' -------------------------------------------',
     >  '------------------------------'
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
*                                                                      *
*  A collection of subroutines that makes it possible
*  to page out ci vectors that are not in use at the
*  moment
*
*  These functions and functions are:
*
*      Logical Function ipopen(nconf,page)
*      Integer Function ipclose(ia)
*      Integer Function ipget(nn)
*      Integer Function ipin(ii)
*      Integer Function ipin1(ii,nn)
*      Integer Function ipnout(iii)
*      Integer Function opout(ii)
*      Integer Function ipout(ii)
*      Subroutine ipterm()
*      Subroutine ipinit()
*
*                                                                      *
************************************************************************
*                                                                      *
       Logical Function ipopen(nconf,page)
       use ipPage
*
*      Initiate the whole lot.
*
       Implicit Real*8(a-h,o-z)
       Logical page
#include "stdalloc.fh"
*
*      Ask how much memory is available
*
       Call mma_maxDBLE(nMax)
       nmax=nmax/2
*
       If (Page) Then
*
*         Initiate for disk based storage.
*
          If (.Not.DiskBased) Then
             Lu_ip=21
             Lu_ip=IsFreeUnit(Lu_ip)
             Call Daname(Lu_ip,'TEMPCIV')
             DiskBased=.True.
          End If
*
*         n  : Length of CI-vector
*         ida: disk address
*
               n(0:Max_CI_Vectors)=0
             ida(0:Max_CI_Vectors)=-1
          Status(0:Max_CI_Vectors)=Null_Vector
*
*         iDisk_Addr_End: next free disk address
*         n_CI_Vectors : number of CI-vectors
*
          iDisk_Addr_End=0
          n_CI_Vectors=0
*
       Else

          If (DiskBased) Then
             Call ipTerm()
             DiskBased=.False.
          End If

       End If
*
       ipopen=DiskBased
*
       Return
* Avoid unused argument warnings
       If (.False.) Call Unused_integer(nconf)
       End
*                                                                      *
************************************************************************
*                                                                      *
       Integer Function ipclose(ia)
       use ipPage
*
*      Object: release all vectors above and including the vector
*              indexed ia.
*
#include "stdalloc.fh"
       Real*8 rdum(1)
*
       If (ia.gt.Max_CI_Vectors) Then
          Write (6,*) 'ipclose: ia.gt.Max_CI_Vectors'
          Write (6,*) 'ia,Max_CI_Vectors=',ia,Max_CI_Vectors
          Call Abend()
       End If
*
*
*      Update iDisk_Addr_End
*
       iDisk_Addr_End=0
       If (ia.lt.0) then
*
          n_CI_Vectors=0
*
       Else
*
          n_CI_Vectors=ia-1
          If (DiskBased) Then
             Do ii=1,ia-1
                If (Status(ii).ne.Null_Vector)
     &             Call dDafile(Lu_ip,dWrite,rdum,n(ii),
     &                          iDisk_Addr_End)
             End do
          End If
*
       End If
*
*      Release memory and flag as a null vector
*
       Do ii=Max(ia,0),Max_CI_Vectors
          If (Status(ii).eq.In_Memory) Then
             Call mma_deallocate(W(ii)%Vec)
             ida(ii)=-1
             n(ii)=0
             Status(ii)=Null_Vector
          End If
       End Do
*
       If (diskbased.and.ia.lt.0)  Then
          Call DACLOS(Lu_ip)
          DiskBased=.False.
       End If
       ipclose=0
*
       Return
       End
*                                                                      *
************************************************************************
*                                                                      *
       Integer Function ipget(nn)
*
*      Get the index of a vector with the length nn.
*      Memory or disk space is allocated.
*
       use ipPage
       Implicit Integer (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
       Character*4 Label
*
*      Take the next memory slot.
*
       n_CI_Vectors=n_CI_Vectors+1
       ipget=n_CI_Vectors
*
       If (n_CI_Vectors.gt.Max_CI_Vectors) Then
          Write(6,*) 'Number of CI vectors higher than Max_CI_Vectors'
          Write(6,*) 'Max_CI_Vectors=',Max_CI_Vectors
          Call Abend( )
       End If
*
       ida(ipget)=iDisk_Addr_End
       n(ipget)=nn
*
*----- Allocate memory for vector if of non-zero  length
*
       If (nn.gt.0) Then
          Write (Label,'(I3.3)') n_CI_Vectors
          Call mma_allocate(W(ipget)%Vec,nn,Label='ipget'//Label)
          Status(ipget)=In_Memory
          W(ipget)%Vec(:)=Zero
       Else
*         Status(ipget)=Null_Vector
*
*         The calling code doesn't have the logic to handle the
*         case that W(i)%Vec is not allocated. Hence, we have
*         to make a dummy allocation to make sure that the compiler
*         doesn't puke.
          n(ipget)=1
          Write (Label,'(I3.3)') n_CI_Vectors
          Call mma_allocate(W(ipget)%Vec,1,Label='ipget'//Label)
          Status(ipget)=In_Memory
          W(ipget)%Vec(:)=Zero
       End If
*
*      If diskbased mode put vector on disc and release memory
*
       If (DiskBased) then
          If (Status(ipget).ne.Null_Vector) Then
             Call dDafile(Lu_ip,Write,W(ipget)%Vec,nn,iDisk_Addr_End)
             Status(ipget)=On_Disk
             Call mma_deallocate(W(ipget)%Vec)
          End If
       End If
*
       Return
       End
*                                                                      *
************************************************************************
*                                                                      *
       Integer Function ipin(ii)
*
*      Object: return pointer to vector ii with a length of n(ii) and
*              make the vector available in memory as W(ii)%Vec
*
*
       use ipPage
       Implicit Integer (a-h,o-z)
*
       nn=n(ii)
       ipin = ipin1(ii,nn)
*
       Return
       End
*                                                                      *
************************************************************************
*                                                                      *
       Integer Function ipin1(ii,nn)
*
*      Object: return pointer to vector ii with a length of nn and
*              make the vector available in memory as W(ii)%Vec
*
       use ipPage
       Implicit Integer (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
       Real*8, Allocatable:: Tmp(:)
*
       If (ii.gt.Max_CI_Vectors) Then
          Write (6,*) 'ipin1: ii.gt.Max_CI_Vectors'
          Write (6,*) 'ii,Max_CI_Vectors=',ii,Max_CI_Vectors
          Call Abend()
       End If
*
*
       If (Status(ii).eq.In_Memory) Then
*
*-------- ii is in memory
*

*         If the size of the vector is larger than was originally set
*         resize the reservation and copy the content

          If (nn.gt.n(ii)) Then
             Call mma_allocate(Tmp,nn,Label='Tmp')
             Tmp(:) = Zero
             Tmp(1:n(ii)) = W(ii)%Vec(:)
             Call mma_deallocate(W(ii)%Vec)
             Call mma_allocate(W(ii)%Vec,nn,Label='ipin1')
             W(ii)%Vec(:) = Tmp(:)
             Call mma_deallocate(Tmp)
             n(ii)=nn
          End If
*
          ip1=ii
*
       Else If (Status(ii).eq.On_Disk) Then
*
*         ii is on disk
*
          Call mma_allocate(W(ii)%Vec,Max(n(ii),nn),Label='ipin1')
          W(ii)%Vec(:)=Zero
*
          nnn=Min(n(ii),nn)
*
*         pick up from disk
*
          idisk=ida(ii)
          Call dDafile(Lu_ip,Read,W(ii)%Vec,nnn,idisk)
          Status(ii)=In_Memory
*
          ip1=ii
*
       Else If (Status(ii).eq.Null_Vector) Then
*
           ip1=-1
*
       Else
*
          ip1=-1
          Write (6,*)
          Write (6,*) 'ipIn1: illegal Status(ii)'
          Write (6,*) 'ii=',ii
          Write (6,*)
          Call Abend()
*
       End If
*
       ipin1 = ip1
*
       Return
       End
*                                                                      *
************************************************************************
*                                                                      *
       Integer Function ipnout(iii)
       use ipPage
*
*      Object: write all vectors in memory on disk but vector iii
*
       Implicit Integer (a-h,o-z)
#include "stdalloc.fh"
*
       If (iii.gt.Max_CI_Vectors) Then
          Write (6,*) 'ipout: iii.gt.Max_CI_Vectors'
          Write (6,*) 'iii,Max_CI_Vectors=',iii,Max_CI_Vectors
          Call Abend()
       End If
*
       ipnout=0
       If (.not.DiskBased) Return
*
       Do ii=1,Max_CI_Vectors
*
          If (Status(ii).eq.In_Memory .and. ii.ne.iii) Then
             idisk=ida(ii)
             nn=n(ii)
             Call dDafile(Lu_ip,Write,W(ii)%Vec,nn,idisk)
             Status(ii)=On_Disk
             Call mma_deallocate(W(ii)%Vec)
          End If
*
       End Do
*
       Return
       End
*                                                                      *
************************************************************************
*                                                                      *
       Integer Function opout(ii)
*
*      opout will release the memory area of vector ii without updating
*      the disk
*
       use ipPage
       Implicit Integer (a-h,o-z)
#include "stdalloc.fh"
*
       If (ii.gt.Max_CI_Vectors) Then
          Write (6,*) 'opout: ii.gt.Max_CI_Vectors'
          Write (6,*) 'ii,Max_CI_Vectors=',ii,Max_CI_Vectors
          Call Abend()
       End If
*
       opout=0
       If (.not.diskbased) Return
*
       If (Status(ii).eq.In_Memory .and. ii.gt.0) Then
          Status(ii)=On_Disk
          Call mma_deallocate(W(ii)%Vec)
       Else
          opout=-1
       End If
*
       Return
       End
*                                                                      *
************************************************************************
*                                                                      *
       Integer Function ipout(ii)
*
*      ipout will page out vector ii to disk and free the memory area
*
       use ipPage
       Implicit Integer (a-h,o-z)
#include "stdalloc.fh"
*
       ipout=0
       If (.not.diskbased) Return
*
       If (Status(ii).eq.In_Memory .and. ii.gt.0) Then
          idisk=ida(ii)
          nn=n(ii)
          Call dDafile(Lu_ip,Write,W(ii)%Vec,nn,idisk)
          Status(ii)=On_Disk
          Call mma_deallocate(W(ii)%Vec)
       Else
          ipout=-1
       End if
*
       Return
       End
*                                                                      *
************************************************************************
*                                                                      *
       Subroutine ipterm()
       use ipPage
*
*      Termination
*
       use ipPage
*
       If (DiskBased) Call DaClos(Lu_ip)
*
       Return
       End
*                                                                      *
************************************************************************
*                                                                      *
       Subroutine ipinit()
       use ipPage
*
*      Initialization
*
       use ipPage
*
       DiskBased=.False.
*
       Return
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
* MOLCAS wrapper for Celestino Angeli's NEVPT2 code
* rdinput reads input from the MOLCAS input file
*
********************
* This routine is based on the EXPBAS input routine in
* ../src/readinp_expbas.f
* therefore we stick to ugly F77 code and use nice F90 features at the same time! O_o
* One day it should be changed to proper F90 code

      subroutine rdinput(refwfnfile)

      use nevpt2_cfg ! use global variables directly from the NEVPT2 program

      implicit none

      Character(len=*), intent(out) :: refwfnfile

      Character*180  Line, Blank, key, Get_Ln
      Character*9001 dline
      Character*9001 frozen_str

      External Get_Ln, isFreeUnit
      integer LuSpool, isFreeUnit, iError,i, isplit
      logical, external :: next_non_comment

c
c Initial values
c

      refwfnfile = "JOBIPH"
c
      LuSpool=18
      LuSpool=isFreeUnit(LuSpool)
      Call SpoolInp(LuSpool)

      Rewind(LuSpool)
      Call RdNLst(LuSpool,'NEVPT2')
      Blank=' '
      iError=-1

      !> set it to one in order to make sure NEVPT2 runs also with just the basic input
      !> &NEVPT2 &END
      nr_states = 1

  999 Continue
*      Read(LuSpool,'(A)',End=9940) Line
      key =Get_Ln(LuSpool)
      Call LeftAd(key)
      Line = key
      If (Line(1:1).eq.'*' ) Goto 999
      If (Line.eq.Blank ) Goto 999
      Call UpCase(Line)
      If (Line(1:4).eq.'NOPC') Goto 1000
      If (Line(1:4).eq.'STAT') Goto 2000
      If (Line(1:4).eq.'FROZ') Goto 3000
      If (Line(1:4).eq.'SKIP') Goto 4000
      If (Line(1:4).eq.'NOMS') Goto 5000
      If (Line(1:4).eq.'MULT') Goto 6000
      If (Line(1:4).eq.'FILE') Goto 7000
      If (Line(1:4).eq.'END ') Go To 99999
      Write (6,*) 'Unidentified key word  : '
      Call FindErrorLine
      Call Quit_OnUserError()

*========= NOPC =============

 1000 Continue
      no_pc = .true.
      Go To 999

*========= STAT =============
 2000 Continue
      ! read the # of states
      key =Get_Ln(LuSpool)
      Read(key,*,Err=9920) nr_states
      Allocate(MultGroup%State(nr_states))
      do i = 1, nr_states
        MultGroup%State(i) = i
      end do
      Go To 999
*========= FROZ =============
 3000 Continue
      ! Read in the information about frozen orbitals
      ! It can be provided either with a number of frozen orbitals
      ! or with a list -- in the 2nd case one needs to provide a keyword
      ! 'Select' immediately after 'Frozen' and provide a number of frozen
      ! orbitals followed by a list of indexes of the frozen orbitals.
      ! E.g. either
      ! Frozen=20 (orbitals from 1-20 are frozen) or
      ! Frozen
      ! Select
      ! 3 1 2 4 -- 3 orbitals 1 2 4 are frozen
      key =Get_Ln(LuSpool)
      Call LeftAd(key)
      Call UpCase(key)
      ! If the first line after the keyword contains 'SELECT'
      If(key(1:4).eq.'SELE') then
        ! read in the number of frozen orbitals, then the list
        frozen_str =Get_Ln(LuSpool)
        Call LeftAd(frozen_str)
        read (frozen_str,*,Err=9920) nr_frozen_orb
        if (nr_frozen_orb.le.0) then
           Call WarningMessage(2,'Nr of frozen orbitals for selection'
     &      //' must be > 0!')
           Call Quit_OnUserError
        end if
        frozen_str=frozen_str(scan(frozen_str,' '):)
        allocate(igelo(nr_frozen_orb));igelo = 0
        Do While (iError.lt.0)
          Read(frozen_str,*,IOStat=iError) (igelo(i),i=1,nr_frozen_orb)
          If (iError.gt.0) GoTo 9920
          If (iError.lt.0) Then
            frozen_str=trim(frozen_str)//trim(Get_Ln(LuSpool))
          end if
        End Do
      Else ! read only the number of frozen orbitals and fill the frozen
           ! indexes consecutively from 1 to nr_frozen_orb
        read (key,*,Err=9920) nr_frozen_orb
        if (nr_frozen_orb.lt.0) then
          Call WarningMessage(2,'Nr of frozen orbitals must be >= 0!')
          Call Quit_OnUserError
        else
          if (nr_frozen_orb.eq.0) then
            write (6,*) 'Number of frozen orbitals'
     &       //' has been set to 0.'
            ! Set it to -1 to signal that frozen orbs have been set forcibly to 0 here
            ! It will be detected in pt2init and reset back to 0
            nr_frozen_orb = -1
          else
            allocate(igelo(nr_frozen_orb))
            do i=1,nr_frozen_orb
              igelo(i)=i
            end do
          end if
        end if
      end if
      Go To 999
*========= SKIP =============
      ! Skip the calculation of Koopmans' matrices if requested by the
      ! SKIP(Koop) keyword
 4000 Continue
      skip_koopro_molcas = .true.
      Go To 999
*========= NOMS =============
      ! Skip the calculation of an effective Hamiltonian (suitable for multistate state-specific calculations)
 5000 Continue
      skip_effective_ham = .true.
      Go To 999
*========= MULT =============
      ! multi-state QD-NEVPT2 calculation requested with the states given below
 6000 Continue
      If(.NOT.next_non_comment(LuSpool,Line)) GoTo 9910
      Read(Line,*) key
      call upcase(key)
      If (trim(key)=='ALL') Then
        nr_states = 0
      Else
        Read(Line,*,Err=9920,End=9920) nr_states
        If (nr_states.le.0) Then
          Write(6,*)' number of MULT states must be > 0, quitting!'
          Call Quit_OnUserError
        End If
      End If
      Allocate(MultGroup%State(nr_states))
      iSplit = scan(Line,' ')
      dLine = line(iSplit:)
      iError = -1
      Do While (iError.lt.0)
        Read(dLine,*,IOStat=iError)
     &    (MultGroup%State(i), i=1,nr_states)
        If (iError.gt.0) GoTo 9920
        If (iError.lt.0) Then
          If(.NOT.next_non_comment(LuSpool,Line)) GoTo 9910
           dline = trim(dline) // ' ' // line
        End If
      End Do
      Go To 999
*========= FILE =============
      ! Specifiy the name of the reference wfn file for NEVPT2.
 7000 Continue
      If(.NOT.next_non_comment(LuSpool,Line)) GoTo 9910
      Call LeftAd(line)
      call fileorb(Line,refwfnfile)
!     Read(Line,*,Err=9920,End=9920) refwfnfile
      Go To 999
c
c END of Input
c

9910  Continue
      Call WarningMessage(2,'Premature end of input file.')
      GoTo 9920
9920  CONTINUE
      Call WarningMessage(2,'Read error during input preprocessing.')
      Call Quit_OnUserError()
      CALL ABEND()

99999 Continue

      !> make sure the array is allocated for the minimal input
      !> &NEVPT2 &END
      if(.not.allocated(MultGroup%State))
     &  allocate(MultGroup%State(1)); MultGroup%State(1) = 1

      end subroutine rdinput

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************

subroutine XMatrixConverter(LuRd,LuWr,mxAtom,STDINP,lSTDINP,iglobal,nxbas,xb_label,xb_bas,iErr)
!***********************************************************************
! Author: Valera Veryazov                                              *
!                                                                      *
! This is an adaptation of GG Program ZMatrixConverter                 *
!***********************************************************************

use ZMatConv_Mod, only: BasAva, Base, BasReq, Coords, MaxAtoms, NAT, Symbols, Zmat
use isotopes, only: MaxAtomNum
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LuRd, LuWr, mxAtom, iglobal
character(len=180), intent(out) :: STDINP(mxAtom*2)
integer(kind=iwp), intent(out) :: lSTDINP, iErr
integer(kind=iwp), intent(inout) :: nxbas
character(len=*), intent(inout) :: xb_label(*), xb_bas(*)
integer(kind=iwp) :: i, i4, i5, iSTDINP, j, k, nAtoms, NATprev, nBase, nBasis, nXAtoms
real(kind=wp) :: r
logical(kind=iwp) :: IfTest, ineedfix
character(len=180) :: aDebug
character(len=12) :: Angstring
character(len=len(Symbols)) :: ll
character(len=4) :: lll

#ifdef _DEBUGPRINT_
IfTest = .true.
#else
IfTest = .false.
#endif

!  ***  X dummy atoms (NA = 0 )
!  ***  Z ghost atoms (NA =-1 )
!  ***  nAskAtoms == -1  =>  Seward ZMAT input
!  ***  nAskAtoms /= -1  =>  GateWay ZMAT input

! nAtoms : nr. of atoms passed to SEWARD (includes X dummy atoms).
! nXAtoms: nr. of ghost Z atoms (not passed to SEWARD but resumed by OutZMat in SLAPAF).
! nBase  : number of BasisSets found in input.
! Base(i): BasisSet for atom with Atomic Number -i-.
! BasAva(i) & BasReq(i): Logical to check BasisSet-consistency.
! Coords(_,i): X, Y, Z, coordinates (in Angstrom) for atom -i-.

nAtoms = 0
nXAtoms = 0
nBase = 0
lSTDINP = 0
nBasis = 0
iErr = 0
Angstring = '  / Angstrom'

call mma_allocate(Base,MaxAtomNum,label='Base')
call mma_allocate(BasAva,MaxAtomNum,label='BasAva')
call mma_allocate(BasReq,MaxAtomNum,label='BasReq')
call mma_allocate(NAT,MaxAtoms,label='NAT')
call mma_allocate(Symbols,MaxAtoms,label='Symbols')
call mma_allocate(Zmat,3,MaxAtoms,label='Zmat')
Base(:) = ''
BasAva(:) = .false.
BasReq(:) = .false.
NAT(:) = 0
Symbols(:) = ''
Zmat(:,:) = Zero

! Reading input
call BasisReader(LuWr,nBase,iglobal,nxbas,xb_label,xb_bas,iErr)
if (IfTest) then
  write(LuWr,*)
  write(LuWr,*) '------------------------------------------------'
  write(LuWr,*) 'XMatrixConverter - From BasisReader :'
  write(LuWr,*) '                   nBase=',nBase
  do i=1,size(Base)
    if (BasAva(i)) write(LuWr,'(I23,3X,A)') i,Base(i)
  end do
  write(LuWr,*)
end if
if (iErr /= 0) then
  write(LuWr,*) ' ERROR: Wrong input in Bases Set definition !'
  return
end if
call XMatReader(LuRd,LuWr,nAtoms,nXAtoms,nBasis,-1,nxbas,xb_label,xb_bas,iErr)
if (IfTest) then
  do i=1,nAtoms+nXAtoms
    write(LuWr,'(1X,A,I3,3(F10.6))') Symbols(i),NAT(i),(Zmat(j,i),j=1,3)
  end do
  write(LuWr,*)
end if
if (iErr /= 0) then
  write(LuWr,*) ' ERROR: Wrong input in Z-Matrix definition !'
  return
end if

call mma_allocate(Coords,3,nAtoms+nXAtoms,label='Coords')
Coords(:,:) = Zmat(:,1:nAtoms+nXAtoms)

! Some checks
if (nBase == 0) then
  iErr = 1
  write(LuWr,*) 'ERROR: No basis set specified !'
  return
end if
if (nAtoms == 0) then
  iErr = 1
  write(LuWr,*) 'ERROR: No atom coordinates specified !'
  return
end if
if (nBase < nBasis) then
  iErr = 1
  write(LuWr,*) 'ERROR: Wrong number of basis sets !'
  write(LuWr,*) '       Available=',nBase,'  Required=',nBasis
  return
end if
call BasisConsistency(LuWr,iErr)
if (iErr /= 0) then
  iErr = 1
  write(LuWr,*) 'ERROR: Basis set inconsistency !'
  return
end if
call Put_iScalar('N ZMAT',0)

if (IfTest) then
  write(LuWr,*)
  write(LuWr,*) '------------------------------------------------'
  write(LuWr,*) 'ZMatrixConverter - XYZCoords (Angstroms) :'
  do i=1,nAtoms+nXAtoms
    write(LuWr,99) i,NAT(i),(Coords(j,i),j=1,3)
  end do
  write(LuWr,*)
end if

! Check for superposed atoms
do i=1,nAtoms+nXAtoms
  if (NAT(i) > 0) then
    do j=i+1,nAtoms+nXAtoms
      if (NAT(j) > 0) then
        r = Zero
        do k=1,3
          r = r+(Coords(k,i)-Coords(k,j))**2
        end do
        if (r < 1.0e-4_wp) then
          iErr = 1
          write(LuWr,*) ' ERROR: Superimposed atoms: ',i,j,'  r=',sqrt(r)
          return
        end if
      end if
    end do
  end if
end do

! Writing
if (NAT(1) == -1) then
  NATprev = -1
else
  NATprev = -9999
end if
iSTDINP = 1
do i=1,nAtoms+nXAtoms
  if (NAT(i) == -1) exit
  if (NAT(i) /= NATprev) then
    if ((i /= 1) .and. (NATprev /= -1)) then
      write(STDINP(iSTDINP),'(A)') 'End of basis'
      iSTDINP = iSTDINP+1
    end if
    write(STDINP(iSTDINP),'(A)') 'Basis set'
    iSTDINP = iSTDINP+1
    if (NAT(i) > 0) then
      write(STDINP(iSTDINP),'(A)') Base(NAT(i))
    else
      write(STDINP(iSTDINP),'(A)') 'X..... / InLine '
      iSTDINP = iSTDINP+1
      write(STDINP(iSTDINP),'(A)') '0.   0'
      iSTDINP = iSTDINP+1
      write(STDINP(iSTDINP),'(A)') '0    0'
    end if
    iSTDINP = iSTDINP+1
    NATprev = NAT(i)
  end if
  ll = Symbols(i)
  write(lll,'(i4)') i
  ineedfix = .true.
  do i5=1,len(ll)
    if (index('0123456789',ll(i5:i5)) /= 0) ineedfix = .false.
  end do
  if (ineedfix) then
    i5 = index(ll,' ')
    do i4=1,len(lll)
      if (lll(i4:i4) /= ' ') then
        ll(i5:i5) = lll(i4:i4)
        i5 = i5+1
      end if
    end do
  end if
  write(STDINP(iSTDINP),'(A5,3F24.18,A)') ll,(Coords(j,i),j=1,3),Angstring
  iSTDINP = iSTDINP+1
end do
write(STDINP(iSTDINP),'(A)') 'End of basis'
lSTDINP = iSTDINP
if (IfTest) then
  write(LuWr,*)
  write(LuWr,*) '------------------------------------------------'
  write(LuWr,*) 'XMatrixConverter - The input passed to SEWARD : '
  do i=1,iSTDINP
    aDebug = STDINP(i)
    write(LuWr,*) aDebug
  end do
  write(LuWr,*)
end if

call mma_deallocate(Base)
call mma_deallocate(BasAva)
call mma_deallocate(BasReq)
call mma_deallocate(NAT)
call mma_deallocate(Symbols)
call mma_deallocate(Zmat)
call mma_deallocate(Coords)

return

99 format(I3,1X,I3,1X,3(F12.6))

end subroutine XMatrixConverter

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GramSchmidt(S,C,nDim,itype,Center,iRestrict)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, itype(nDim), Center(nDim), iRestrict
real(kind=wp), intent(inout) :: S(nDim,nDim), C(nDim,nDim)
integer(kind=iwp) :: ibas, iOrb, iStart, Jorb, Korb
real(kind=wp) :: A, F
integer(kind=iwp), parameter :: Occ = 1, Vir = 0

#include "macros.fh"
unused_var(Center)

!write(u6,*) 'nDim,nDim',nDim,nDim
!write(u6,*) Center
do iOrb=1,nDim
  if ((iRestrict == 1) .and. (itype(iOrb) == Vir)) cycle
  F = Zero
  if (S(iOrb,iOrb) > Zero) F = One/sqrt(S(iOrb,iOrb))

  do ibas=1,nDim
    C(Ibas,Iorb) = F*C(Ibas,Iorb)
    !write(u6,*) C(Ibas,Iorb),IBas,Iorb
  end do

  do Jorb=1,nDim
    S(Iorb,Jorb) = F*S(Iorb,Jorb)
  end do
  do Jorb=1,nDim
    S(Jorb,Iorb) = F*S(Jorb,Iorb)
  end do

  iStart = 1
  if (iRestrict == 0) iStart = iOrb+1
  do jOrb=iStart,nDim
    if ((iRestrict == 1) .and. (itype(jOrb) == Occ)) cycle
    !if (Center(iOrb) == Center(jOrb)) cycle
    A = S(Iorb,Jorb)
    do Ibas=1,nDim
      C(Ibas,Jorb) = C(Ibas,Jorb)-A*C(Ibas,Iorb)
    end do
    do Korb=1,nDim
      S(Jorb,Korb) = S(Jorb,Korb)-A*S(Iorb,Korb)
    end do
    do Korb=1,nDim
      S(Korb,Jorb) = S(Korb,Jorb)-A*S(Korb,Iorb)
    end do
  end do
end do

return

end subroutine GramSchmidt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKRAW_MCLR(NVERT,IDOWN,IDAW,IUP,IRAW,IPRINT)
C
C     PURPOSE: CONSTRUCT UPCHAIN INDEX TABLE AND REVERSE ARC WEIGHTS
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION IDOWN(NVERT,0:3),IDAW(NVERT,0:4)
      DIMENSION IUP(NVERT,0:3),IRAW(NVERT,0:4)
C
C
C     BEGIN BY CONSTRUCTING THE UPCHAIN TABLE IUP:
C
      DO 10 IV=1,NVERT
        DO 11 IC=0,3
          IUP(IV,IC)=0
11      CONTINUE
10    CONTINUE
      DO 30 IU=1,NVERT-1
        DO 20 IC=0,3
          IDWN=IDOWN(IU,IC)
          IF(IDWN.EQ.0) GOTO 20
          IUP(IDWN,IC)=IU
20      CONTINUE
30    CONTINUE
C
      IF( IPRINT.GE.5 ) THEN
        WRITE(6,*)
        WRITE(6,*)' THE UPCHAIN TABLE IN MKRAW_MCLR:'
        DO 40 IV=1,NVERT
          WRITE(6,'(1X,I4,5X,4(1X,I6))') IV,(IUP(IV,IC),IC=0,3)
40      CONTINUE
        WRITE(6,*)
      ENDIF
C
C     USE UPCHAIN TABLE TO CALCULATE THE REVERSE ARC WEIGHT TABLE:
C
      DO 110 IC=0,3
        IRAW(1,IC)=0
110   CONTINUE
      IRAW(1,4)=1
      DO 130 IV=2,NVERT
        ISUM=0
        DO 120 IC=0,3
          IRAW(IV,IC)=0
          IU=IUP(IV,IC)
          IF(IU.EQ.0) GOTO 120
          IRAW(IV,IC)=ISUM
          ISUM=ISUM+IRAW(IU,4)
120     CONTINUE
        IRAW(IV,4)=ISUM
130   CONTINUE
C
      IF( IPRINT.GE.5 ) THEN
        WRITE(6,*)
        WRITE(6,*)' THE REVERSE ARC WEIGHT TABLE IN MKRAW_MCLR:'
        DO 140 IV=1,NVERT
          WRITE(6,'(1X,I4,5X,5(1X,I6))') IV,(IRAW(IV,IC),IC=0,4)
140     CONTINUE
        WRITE(6,*)
      ENDIF
C
C
C     EXIT
C
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer_array(IDAW)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine fokunpck2 (fok,faa,dimfok,dimfa,shift)
c
c     this routine distribute (Fok - dp) to Faa
c     fok    - Fok matrix (I)
c     faa    - Faa matrix (O)
c     dimfok - dimension for Fok matrix - norb (I)
c     dimfa  - dimension of virtuals - nv (I)
c
       integer dimfok,dimfa,shift
c
       real*8 fok(1:dimfok,1:dimfok)
       real*8 faa(1:dimfa,1:dimfa)
c
c     help variables
c
       integer a,b
c
c1    distribute Fok to Faa
       do 200 b=1,dimfa
       do 201 a=1,dimfa
       faa(a,b)=fok(shift+a,shift+b)
 201    continue
 200    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015, Ignacio Fdez. Galvan                             *
************************************************************************
* Interfaces to C functions needed to create and remove
* a subdirectory in WorkDir
      Module subdirs
      Use iso_c_binding
      implicit none
      private
      public :: f_setsubdir, Sub, OldWorkDir, NewWorkDir
#include "molcastypes.fh"
      Interface
#ifdef _HAVE_EXTRA_
        Subroutine c_setsubdir(sub) bind(C, name="setsubdir")
          Use iso_c_binding
          Character(Kind=c_char) :: sub(*)
        End Subroutine c_setsubdir
#endif
      End Interface
      Character(Len=1024), save :: Sub, OldWorkDir, NewWorkDir

      Contains

#ifdef _HAVE_EXTRA_
      Subroutine f_setsubdir(sub)
        Use iso_c_binding
        Implicit None
        Character(Len=*) :: sub
        If (Trim(sub).eq.'') Then
          Call c_setsubdir(''//c_null_char)
        Else
          Call c_setsubdir('/'//Trim(sub)//c_null_char)
        End If
      End Subroutine f_setsubdir
#else
      Subroutine f_setsubdir(sub)
        Use Prgm
        Implicit None
        Character(Len=*) :: sub
        If (Trim(sub).eq.'') Then
          Call SetSubDir('')
        Else
          Call SetSubDir('/'//Trim(sub))
        End If
      End Subroutine f_setsubdir
#endif

      End Module subdirs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

subroutine RHSOD_F_NOSYM(IVEC)

use Symmetry_Info, only: Mul
use SUPERINDEX, only: MAGEB, MAGTB, MAREL, MTGEU, MTGTU, MTREL
use CHOVEC_IO, only: ChoVec_Read, ChoVec_Size, NVTOT_CHOSYM
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB
#else
use fake_GA, only: GA_Arrays
#endif
use caspt2_global, only: iPrGlb
use caspt2_module, only: NAGEBES, NAGTBES, NASUP, NISUP, NSSH, NSYM, NTGEUES, NTGTUES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: IA, IAABS, IAEND, IAGEB, IAGEBTOT, IAGTB, IAGTBTOT, IASTA, IAT, IAV, IC, ICABS, iCASE, ICT, ICV, IDX, IIEND, &
                     IISTA, IOFFAT, IOFFAV, IOFFCT, IOFFCV, IOSYM(8,8), ISYA, ISYC, ISYM, ISYT, ISYV, IT, ITABS, ITGEU, ITGEUTOT, &
                     ITGTU, ITGTUTOT, IV, IVABS, lg_W, MW, NAS, NCHOBUF, NIS, NV, NW
real(kind=wp) :: ATCV, AVCT, FMTVAC, FPTVAC, SCL
real(kind=wp), allocatable :: CHOBUF(:)
real(kind=wp), parameter :: SQRTH = sqrt(Half)
real(kind=wp), external :: DDot_

if (iPrGlb >= DEBUG) write(u6,*) 'RHS on demand: case F'

!***********************************************************************
! Case F (8,9):
! FP(tv,ac)=((at,cv)+(av,ct))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(a,c))
! FM(tv,ac)= -((at,cv)-(av,ct))/(2*SQRT(1+Kron(a,c))
!***********************************************************************

!***********************************************************************
!SVC: read in all the cholesky vectors (need all symmetries)
!***********************************************************************
call CHOVEC_SIZE(3,NCHOBUF,IOSYM)

call mma_allocate(CHOBUF,NCHOBUF,Label='CHOBUF')

call CHOVEC_READ(3,CHOBUF,NCHOBUF)

iCASE = 8
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  do IAGEB=IISTA,IIEND
    IAGEBTOT = IAGEB+NAGEBES(ISYM)
    IAABS = MAGEB(1,IAGEBTOT)
    ICABS = MAGEB(2,IAGEBTOT)
    IA = MAREL(1,IAABS)
    ISYA = MAREL(2,IAABS)
    IC = MAREL(1,ICABS)
    ISYC = MAREL(2,ICABS)
    do ITGEU=IASTA,IAEND ! these are always all elements
      ITGEUTOT = ITGEU+NTGEUES(ISYM)
      ITABS = MTGEU(1,ITGEUTOT)
      IVABS = MTGEU(2,ITGEUTOT)
      IT = MTREL(1,ITABS)
      ISYT = MTREL(2,ITABS)
      IV = MTREL(1,IVABS)
      ISYV = MTREL(2,IVABS)
      ! compute integrals (ta,vc) and (tc,va)
      NV = NVTOT_CHOSYM(Mul(ISYA,ISYT)) ! JSYM=ISYA*ISYA=ISYC*ISYC
      IAT = IA-1+NSSH(ISYA)*(IT-1)
      ICV = IC-1+NSSH(ISYC)*(IV-1)
      IOFFAT = 1+IOSYM(ISYA,ISYT)+NV*IAT
      IOFFCV = 1+IOSYM(ISYC,ISYV)+NV*ICV
      ATCV = DDOT_(NV,CHOBUF(IOFFAT),1,CHOBUF(IOFFCV),1)

      NV = NVTOT_CHOSYM(Mul(ISYA,ISYV)) ! JSYM=ISYA*ISYA=ISYC*ISYC
      IAV = IA-1+NSSH(ISYA)*(IV-1)
      ICT = IC-1+NSSH(ISYC)*(IT-1)
      IOFFAV = 1+IOSYM(ISYA,ISYV)+NV*IAV
      IOFFCT = 1+IOSYM(ISYC,ISYT)+NV*ICT
      AVCT = DDOT_(NV,CHOBUF(IOFFAV),1,CHOBUF(IOFFCT),1)

      ! FP(tv,ac)=((at,cv)+(av,ct))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(a,c))
      SCL = Half
      if (ITABS == IVABS) SCL = SCL*Half
      if (IAABS == ICABS) SCL = SCL*SQRTH
      FPTVAC = SCL*(ATCV+AVCT)
      ! write element FP(tv,ac)
      IDX = ITGEU+NAS*(IAGEB-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = FPTVAC
#     else
      GA_Arrays(lg_W)%A(IDX) = FPTVAC
#     endif
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

iCASE = 9
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  do IAGTB=IISTA,IIEND
    IAGTBTOT = IAGTB+NAGTBES(ISYM)
    IAABS = MAGTB(1,IAGTBTOT)
    ICABS = MAGTB(2,IAGTBTOT)
    IA = MAREL(1,IAABS)
    ISYA = MAREL(2,IAABS)
    IC = MAREL(1,ICABS)
    ISYC = MAREL(2,ICABS)
    do ITGTU=IASTA,IAEND ! these are always all elements
      ITGTUTOT = ITGTU+NTGTUES(ISYM)
      ITABS = MTGTU(1,ITGTUTOT)
      IVABS = MTGTU(2,ITGTUTOT)
      IT = MTREL(1,ITABS)
      ISYT = MTREL(2,ITABS)
      IV = MTREL(1,IVABS)
      ISYV = MTREL(2,IVABS)
      ! compute integrals (at,cv) and (av,ct)
      NV = NVTOT_CHOSYM(Mul(ISYA,ISYT)) ! JSYM=ISYA*ISYA=ISYC*ISYC
      IAT = IA-1+NSSH(ISYA)*(IT-1)
      ICV = IC-1+NSSH(ISYC)*(IV-1)
      IOFFAT = 1+IOSYM(ISYA,ISYT)+NV*IAT
      IOFFCV = 1+IOSYM(ISYC,ISYV)+NV*ICV
      ATCV = DDOT_(NV,CHOBUF(IOFFAT),1,CHOBUF(IOFFCV),1)

      NV = NVTOT_CHOSYM(Mul(ISYA,ISYV)) ! JSYM=ISYA*ISYA=ISYC*ISYC
      IAV = IA-1+NSSH(ISYA)*(IV-1)
      ICT = IC-1+NSSH(ISYC)*(IT-1)
      IOFFAV = 1+IOSYM(ISYA,ISYV)+NV*IAV
      IOFFCT = 1+IOSYM(ISYC,ISYT)+NV*ICT
      AVCT = DDOT_(NV,CHOBUF(IOFFAV),1,CHOBUF(IOFFCT),1)

      ! FM(tv,ac)= -((at,cv)-(av,ct))/(2*SQRT(1+Kron(a,c))
      SCL = Half
      !if (ITABS == IVABS) SCL = SCL*Half
      !if (IAABS == ICABS) SCL = SCL*SQRTH
      FMTVAC = SCL*(AVCT-ATCV)
      ! write element FM(tv,ac)
      IDX = ITGTU+NAS*(IAGTB-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = FMTVAC
#     else
      GA_Arrays(lg_w)%A(IDX) = FMTVAC
#     endif
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

call mma_deallocate(CHOBUF)

end subroutine RHSOD_F_NOSYM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986,1995, Bernd Artur Hess                            *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

subroutine DKRE1R(A,R,TT,V,G,RE1R,VEXTT,PVPT,N)
! CONSTRUCT RE1R FOR DK3

use Constants, only: Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: A(N), R(N), TT(N), VEXTT(N*(N+1)/2), PVPT(N*(N+1)/2)
real(kind=wp), intent(out) :: V(N*(N+1)/2), G(N*(N+1)/2), RE1R(N,N)
integer(kind=iwp) :: I, IJ, J

IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    V(IJ) = VEXTT(IJ)
    G(IJ) = PVPT(IJ)
  end do
end do

! MULTIPLY

IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    V(IJ) = V(IJ)*A(I)*A(J)*R(I)*R(I)*R(J)*R(J)*TT(I)*TT(J)*Four
    RE1R(I,J) = V(IJ)
    RE1R(J,I) = RE1R(I,J)
  end do
end do

IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    G(IJ) = G(IJ)*A(I)*A(J)*R(I)*R(J)
    RE1R(I,J) = RE1R(I,J)+G(IJ)
    RE1R(J,I) = RE1R(I,J)
  end do
end do

return

end subroutine DKRE1R

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Matthew R. Hennefarth                            *
!***********************************************************************

module mspdftgrad

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp

implicit none
private

real(kind=wp), allocatable :: D1AOMS(:,:), D1SaoMS(:,:), DiDa(:,:), F1MS(:,:), F2MS(:,:), FocMS(:,:), FxyMS(:,:), P2Mot(:,:)

public :: D1AOMS, D1SAoMS, DiDa, F1MS, F2MS, FocMS, FxyMS, mspdftgrad_free, mspdftgrad_init, P2Mot

contains

subroutine mspdftgrad_init()

  use rasscf_global, only: nacpr2, nroots, nTot4
  use mcpdft_input, only: mcpdft_options
  use general_data, only: ispin, ntot1
  use constants, only: Zero

  call mma_allocate(F1MS,nTot1,nRoots,label='F1MS')
  call mma_allocate(F2MS,NacPR2,nRoots,label='F2MS')
  call mma_allocate(FocMS,nTot1,nroots,label='FocMS')
  call mma_allocate(FxyMS,nTot4,nRoots,label='FxyMS')
  call mma_allocate(P2MOT,nacpr2,nroots,label='P2MO')
  call mma_allocate(D1AOMS,ntot1,nroots,label='D1AOMS')
  call mma_allocate(DIDA,ntot1,nroots+1,label='DIDA')
  if (iSpin /= 1) call mma_allocate(D1SaoMS,nTot1,nRoots,label='D1SAOMS')

  P2MOT(:,:) = Zero

  ! Put relevant information to the runfile
  call Put_lScalar('isCMSNAC',mcpdft_options%nac)
  call Put_iArray('cmsNACstates',mcpdft_options%nac_states,2)
  call Put_lScalar('isMECIMSPD',mcpdft_options%meci)

end subroutine mspdftgrad_init

subroutine mspdftgrad_free()

  ! Should in theory check before deallocating!
  call mma_deallocate(F1MS)
  call mma_deallocate(F2MS)
  call mma_deallocate(FocMS)
  call mma_deallocate(FxyMS)
  call mma_deallocate(P2MOT)
  call mma_deallocate(D1aoMS)
  call mma_deallocate(DIDA)

  if (allocated(D1SaoMS)) call mma_deallocate(D1SaoMS)

end subroutine mspdftgrad_free

end module mspdftgrad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine setup_cho(nSym,nIsh,nAsh,nSsh,NumCho,mode)
! -------------------------
! This subroutine uses the input variables to compute
! Unt, nisplit, nasplit, lsplit
! each dimensioned (1:nsym),
! in module chocaspt2
! -------------------------

use Symmetry_Info, only: Mul
use Data_Structures, only: Alloc1DiArray_Type
use ChoCASPT2, only: nasplit, nisplit, nksh, npsh, Unt
use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nIsh(nSym), nAsh(nSym), nSsh(nSym), NumCho(nSym)
character(len=4), intent(in) :: mode
integer(kind=iwp) :: iAorb(8), IfTest, iIorb(8), iK, iK1, iK2, iKorb(8), ioff, iS, iSP, iSym, iw, jfrac, jIAc, jS, jSym, kEnd, &
                     kEndSym, kFrac, kS, kSta, kStaSym, lS, lsplit(8), mDiff, Mem1, MemMx, mRHS, nAO, nIAc, nIO, nKsp, nMin, &
                     nOkrb, nP, nPMax, nPOrb
real(kind=wp) :: xmb, xMemMx
type(Alloc1DiArray_Type) :: ip(8), mp(8), sp(8)
integer(kind=iwp), external :: cho_irange

#ifdef _DEBUGPRINT_
IFTEST = 1
#else
IFTEST = 0
#endif

if (mode == 'FREE') then
  do jSym=1,nSym
    call mma_deallocate(Unt(jSym)%A,safe='*')
  end do
  return
end if

lsplit(:) = 0
nisplit(:) = 0
nasplit(:) = 0
nksh(:) = 0
npsh(:) = 0

! PAM07: New arrays: 'k shells' = inactive+active orbitals
! 'p shells' = active+secondary orbitals
!  nksh(isym)= Nr of shells by symmetry:
nksh(1:nsym) = nish(1:nsym)+nash(1:nsym)
npsh(1:nsym) = nash(1:nsym)+nssh(1:nsym)

! Local arrays:
! iIorb(iSym) = Nr of inactive orbitals in earlier symmetries.
! iAorb(iSym) = Nr of   active orbitals in earlier symmetries.
! iKorb(iSym) = iIorb(iSym) + iAorb(iSym)
iIorb(1) = 0
iAorb(1) = 0
do iSym=2,nSym
  iIorb(iSym) = iIorb(iSym-1)+nIsh(iSym-1)
  iAorb(iSym) = iAorb(iSym-1)+nAsh(iSym-1)
end do
iKorb(1:nSym) = iIorb(1:nSym)+iAorb(1:nSym)

! nIO   = total number of inactive orbitals.
! nAO   = total number of active orbitals.
! nOkrb = total number of inactive+active orbitals.
! nOrb  = total number of orbitals
nIO = sum(nIsh(1:nSym))
nAO = sum(nAsh(1:nSym))
nOkrb = nIO+nAO

!xO = real(nO,kind=wp)

! Task: set up the necessary administration of transformed Cholesky
! vectors. Each such vector is characterized by the composite symmetry
! label JSYM. Vectors with common JSYM are stored on the same unit.
! For a given JSYM, there are NumCho(jSym) vectors. These are separated
! into subsets -- batches -- There will be nISplit(jSym) batches with
! vectors with a fixed inactive orbital index (Inactive vectors), and
! nASplit(jSym) batches with vectors with a fixed active index
! (Active vectors). Each batch has vectors with fixed index within a
! range of size sp(jSym)%A(i) where i is in 1..nISplit(jSym) or
!  in nISplit(jSym)+1..nISplit(jSym)+nASplit(jSym).
! The vectors themselves have a size of mp(jSym)%A(i)
! The vectors are generally referred to as e.g. p#k, where #k stands
! for the fixed inactive or active orbital, while p is all the orbitals
! with a symmetry such that the compound symmetry label is JSYM.
! There will be a (possibly large) number of such vectors, each indexed
! with 'J' generally. This is the summation index in the definition of
! the cholesky vectors.
do jSym=1,nSym
  if (NumCho(jSym) < 1) cycle

  call mma_MaxDBLE(MemMx)
  xMemMx = real(MemMx,kind=wp)
  ! xMemMx = largest allocatable field.

  jfrac = 1

  do
    Mem1 = 2*NumCho(jSym)/jfrac  ! hold 2 vectors in memory
    if ((Mem1 == 0) .and. (jfrac > 1)) then
      write(u6,*) ' Setup_cho fails to set up the data structures'
      write(u6,*) ' used for the Cholesky vectors.'
      write(u6,*) ' Too little memory is available at this point.'
      write(u6,*) ' Details:'
      xmb = xMemMx/(Two**20)
      write(u6,'(1x,a,1x,f10.3)') ' Largest contiguous allocatable memory (MB):',xmb
      xmb = Two*real(NUMCHO(JSYM),kind=wp)/(Two**20)
      write(u6,'(1x,a,1x,f10.3)') '                        2*NumCho(jSym) (MB):',xmb
      write(u6,*) ' Divided up on jFrac pieces. jFrac=',jFrac
      write(u6,*) ' If this seems odd, please tell Molcas programmers.'
      write(u6,*) ' Right now, the allocated memory is:'
      call Cho_x_Quit('setup_cho',': Sorry! Too little memory!!',' ')
    end if

    kfrac = 1
    ! Subdivide the set of orbitals into kfrac pieces of size <= nKsp
    nKsp = nOkrb/kfrac
    ! If kfrac has grown too large, start again using kfrac=1 but larger jfrac
    if (nKsp /= 0) exit
    jfrac = jfrac+1
  end do

  ! Loop over pieces of the orbital set:
  nPmax = 0
  do iK1=1,nOkrb,nKsp
    iK2 = max(iK1-1+nKsp,nOkrb)
    ! For this piece, compute the number of (p,k) orbital pairs
    ! with p active or secondary, and with joint symmetry jSym:
    nP = 0
    do iK=iK1,iK2
      kS = cho_irange(iK,iKorb,nSym,.false.)
      jS = Mul(kS,jSym)
      nP = nP+nAsh(jS)+nSsh(jS)
    end do
    ! nPmax will be the largest number of such pairs in any piece.
    nPmax = max(nPmax,nP)
  end do

  ! PAM:The following looks strange, since the max is over the same set
  ! of numbers no matter what jSym is.
  mRHS = 0
  do iS=1,nSym
    jS = Mul(iS,jSym)
    mRHS = max(mRHS,max(nAsh(jS),nSsh(jS)))
  end do

  ! Conversion to real(kind=wp) to avoid integer overflow on 32-bit machines

  ! PAM:Why would this be 'mem for right-hand side?'
  !xRHS = real(mRHS**2,kind=wp)          ! mem. for right hand side
  !xLpk = real(Mem1*nPmax*nKsp,kind=wp)  ! store Cholesky MO vectors
  !xPIQK = real((nPmax*nKsp)**2,kind=wp) ! store integrals
  !xmNeed = xO+xPIQK+max(xLpk,Two*xRHS)  ! Fmat+integrals+rhs

  ! This also looks strange -- nIAc=all the inact+act orbitals no matter what.?
  nIAc = nOkrb

  jIAc = nIAc
  lsplit(jSym) = 1
  do while (jIAc < nOkrb)
    lsplit(jSym) = lsplit(jSym)+1
    jIAc = jIAc+nIAc
  end do

  ! What does this mean? Simply that lsplit(jSym) will be 'the next'
  ! of something?
  lsplit(jSym) = lsplit(jSym)+1 ! separate out Ina from Act

  ! Need xmNeedNow units of memory
  !xmNeedNow = xmNeed+real((3+nSym,kind=wp)*lsplit(jSym))

  ! Allocate arrays, in all (3+nSym)*lsplit(jSym) elements:
  call mma_allocate(sp(jsym)%A,lsplit(jSym),Label='sp')
  call mma_allocate(mp(jsym)%A,lsplit(jSym),Label='np')
  call mma_allocate(ip(jsym)%A,nSym*lsplit(jSym),Label='ip')
  call mma_allocate(Unt(jsym)%A,lsplit(jSym),Label='Unt')
  sp(jSym)%A(:) = 0
  mp(jSym)%A(:) = 0
  Unt(jSym)%A(:) = 0
  ip(jsym)%A(:) = 0

  nmin = min(nIO,nIAc)
  jS = 0
  if (nmin > 0) jS = nIO/nmin
  sp(jSym)%A(1:jS) = nMin
  mDiff = jS*nmin-nIO
  if (mDiff > 0) then
    sp(jSym)%A(jS+1) = mDiff
    jS = jS+1
  end if
  nisplit(jSym) = jS

  nmin = min(nAO,nIAc)
  jS = 0
  if (nmin > 0) jS = nAO/nmin
  sp(jSym)%A(nisplit(jSym)+1:nisplit(jSym)+jS) = nmin
  mDiff = jS*nmin-nAO
  if (mDiff > 0) then
    sp(jSym)%A(nisplit(jSym)+jS+1) = mDiff
    jS = jS+1
  end if
  nasplit(jSym) = jS

  ! Note: The inactive orbitals will be partitioned.
  ! The isp=1..nisplit(jSym) is counter of the partitions.
  ! ioff will be the number of inactive orbitals in earlier partitions.
  ioff = 0
  do isp=1,nisplit(jSym)
    ! ioff+1 is the first orbital of partition isp.
    lS = cho_irange(ioff+1,iIorb,nSym,.false.)
    ! lS is its symmetry.
    iK = sp(jSym)%A(isp)+ioff
    ! iK is the last orbital of the partition, and kS its symmetry
    kS = cho_irange(iK,iIorb,nSym,.false.)

    nPorb = 0
    ! Loop over the symmetry range of inactive orbitals in the partition
    do iS=lS,kS
      ! jS is then the symmetry of its companion orbital in the pair.
      jS = Mul(iS,jSym)
      ! ipip(jSym) is pointer to an array dimensioned iP(nSym,nisplit(jSym))
      ! which is used for offsets. In some other array, after the position
      ! iP(jS,isp) follows space for nAsh(jS)+nSsh(jS) items.
      ip(jSym)%A(jS+nsym*(isp-1)) = nPorb
      ! Update nPorb.
      nPorb = nPorb+nAsh(jS)+nSsh(jS)
    end do

    ! ipnp(jSym) is pointer to an array dimensioned nP(nisplit(jSym))
    ! It gives the total size for the items mentioned above.
    mp(jSym)%A(isp) = nPorb
    ioff = ioff+sp(jSym)%A(isp)
  end do

  ! Here follows similar arrays for the active orbitals.
  ! Addressing is the same, except we use iP(jS,nisplit(jSym)+isp)
  ! and nP(nisplit(jSym)+isp)
  ioff = 0
  do isp=1,nasplit(jSym)
    lS = cho_irange(ioff+1,iAorb,nSym,.false.)
    iw = sp(jSym)%A(nisplit(jSym)+isp)
    kS = cho_irange(iw,iAorb,nSym,.false.)
    nPorb = 0
    do iS=lS,kS
      jS = Mul(iS,jSym)
      ip(jSym)%A(jS+nsym*(nisplit(jSym)+isp-1)) = nPorb
      nPorb = nPorb+nAsh(jS)+nSsh(jS)
    end do
    mp(jSym)%A(nisplit(jSym)+isp) = nPorb
    ioff = ioff+sp(jSym)%A(nisplit(jSym)+isp)
  end do

end do

if (iftest /= 0) then
  write(u6,*)
  write(u6,*) ' setup_cho report:'
  write(u6,*)
  write(u6,'(1x,a,8i4)') ' Inactive :',(nIsh(isym),isym=1,nSym)
  write(u6,'(1x,a,8i4)') ' Active   :',(nAsh(isym),isym=1,nSym)
  write(u6,'(1x,a,8i4)') ' Secondary:',(nSsh(isym),isym=1,nSym)
  write(u6,*)
  write(u6,'(1x,a,8i4)') ' NumCho   :',(NumCho(isym),isym=1,nSym)
  write(u6,*)
  write(u6,*) ' Partition  Fixed orbitals       nPorb space'
  do jsym=1,nsym
    write(u6,*) ' Symm:',jSym
    kend = 0
    do isp=1,nisplit(jsym)
      ksta = kend+1
      kend = kend+sp(jSym)%A(isp)
      kstasym = cho_irange(ksta,iIorb,nSym,.false.)
      kendsym = cho_irange(kend,iIorb,nSym,.false.)
      nPorb = mp(jSym)%A(isp)
      write(u6,'(1x,i4,5x,i4,a4,i4,2x,i1,a4,i1,5x,i4)') isp,ksta,' -- ',kend,kstasym,' -- ',kendsym,nPorb
      write(u6,'(1x,a,8i8)') ' iP Offsets:',(ip(jSym)%A(nSym*(isp-1)+Mul(jSym,iS)),iS=1,nSym)
      write(u6,*)
    end do
    kend = 0
    do isp=1,nasplit(jsym)
      ksta = kend+1
      kend = kend+sp(jSym)%A(nisplit(jSym)+isp)
      kstasym = cho_irange(ksta,iAorb,nSym,.false.)
      kendsym = cho_irange(kend,iAorb,nSym,.false.)
      nPorb = mp(jSym)%A(nisplit(jSym)+isp)
      write(u6,'(1x,i4,5x,i4,a4,i4,2x,i1,a4,i1,5x,i4)') isp,ksta,' -- ',kend,kstasym,' -- ',kendsym,nPorb
      write(u6,'(1x,a,8i8)') ' iP Offsets:',(ip(jSym)%A(nSym*(nisplit(jSym)+isp-1)+Mul(jSym,iS)),iS=1,nSym)
      write(u6,*)
    end do
  end do
end if

do jSym=1,nSym
  call mma_deallocate(sp(jSym)%A,safe='*')
  call mma_deallocate(mp(jSym)%A,safe='*')
  call mma_deallocate(ip(jSym)%A,safe='*')
end do

end subroutine setup_cho

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Fix_2nder(Fa1,Fa2,Fb1,Fb2,Final,nalpha,nbeta,
     &                     ishll,la,lb,iang,jfhess,nfun,fact)
*----------------------------------------------------------------------*
C
C       Fa1 includes  (  grad   < a | c > , < a | c >  )
C       Fb1 includes  (  grad   < c | b > , < c | b >  )
C
C
C
*
      Implicit Real*8(a-h,o-z)
#include "real.fh"
CBS   Logical jfhess(3,3,2,2)   ! now same dimensions as in prjhss.f
      Logical jfhess(3,3,4,4)
      Real*8 FA1((2*iAng+1)*((la+1)*(la+2)/2)*nAlpha*nFun*4),
     &       FA2((2*iAng+1)*((la+1)*(la+2)/2)*nAlpha*nFun*6),
     &       FB1((2*iAng+1)*((lb+1)*(lb+2)/2)*nBeta*nFun*4),
     &       FB2((2*iAng+1)*((lb+1)*(lb+2)/2)*nBeta*nFun*6),
CBS  &Final(nAlpha*nbeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6)
     &Final(nAlpha*nbeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,21)
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)


*              OK NOW EVERYTHING SHOULD BE MERGED TOGETHER
*
*
CBS   write(*,*) 'nFun ',nfun
CBS   write(*,*) 'FA1 ',FA1
CBS   write(*,*) 'FA2 ',FA2
CBS   write(*,*) 'FB1 ',FB1
CBS   write(*,*) 'FB2 ',FB2
      Do iCar = 1, 3
        Do jCar = 1, 3
         mvec=itri(iCar+3,jcar)
         If (jfHess(iCar,jcar,2,1)) Then
           ipFA1a = 1+ iCar *
     &        nAlpha*nFun*nElem(la)*(2*iAng+1)
           ipFB1a = 1 + jcar *
     &             nFun*nBeta*(2*iAng+1)*nElem(lb)

           Do  ib = 1, nElem(lb)
            Do ia = 1, nElem(la)
*
             Do  iC = 1, (2*iAng+1)
               iaC = (iC-1)*nElem(la) + ia
               ipaC = (iaC-1)*nAlpha*nFun + ipFA1a
               iCb = (ib-1)*(2*iAng+1) + iC
               ipCb = (iCb-1)*nFun*nBeta  + ipFB1a

               Call DGEMM_('N','N',
     &                    nAlpha,nBeta,nFun,
     &                    Fact,FA1(ipaC),nAlpha,
     &                        FB1(ipCb),nFun,
     &                    One,Final(1,ia,ib,mVec),nAlpha)
*
*
             End do
            End do
           End do
         End If
        End do
       End do

CBS   goto 4711
      Do iCar = 1, 3
        Do jCar = 1, icar
         mvec=itri(iCar,jcar)
         If (jfHess(iCar,jcar,1,1)) Then
           ipFA1a = 1 + (itri(iCar,jCar)-1) *
     &        nAlpha*nFun*nElem(la)*(2*iAng+1)
*
           Do  ib = 1, nElem(lb)
            Do ia = 1, nElem(la)

             Do  iC = 1, (2*iAng+1)
               iaC = (iC-1)*nElem(la) + ia
               ipaC = (iaC-1)*nAlpha*nFun + ipFA1a
               iCb = (ib-1)*(2*iAng+1) + iC
               ipCb = (iCb-1)*nFun*nBeta  + 1

               Call DGEMM_('N','N',
     &                    nAlpha,nBeta,nFun,
     &                    Fact,FA2(ipaC),nAlpha,
     &                    FB1(ipCb),nFun,
     &                    One,Final(1,ia,ib,mVec),nAlpha)
*
*
             End do
            End do
           End do
         End If
        End do
       End do
*4711 continue

CBS   goto 4712      ! for testing the different contributions
      Do iCar = 1, 3
        Do jCar = 1, icar
         mvec=itri(3+icar,3+jcar)
         If (jfHess(iCar,jcar,2,2)) Then
           ipFB1a = 1 + (itri(icar,jcar)-1) *
CBS  &        nAlpha*nFun*nElem(la)*(2*iAng+1)
CBS           looks much better ....  (Oh Anders ...)

     &        nBeta*nFun*nElem(lb)*(2*iAng+1)

           Do  ib = 1, nElem(lb)
            Do ia = 1, nElem(la)
*
             Do  iC = 1, (2*iAng+1)
               iaC = (iC-1)*nElem(la) + ia
               ipaC = (iaC-1)*nAlpha*nFun + 1
               iCb = (ib-1)*(2*iAng+1) + iC
               ipCb = (iCb-1)*nFun*nBeta  + ipFB1a

                        Call DGEMM_('N','N',
     &                    nAlpha,nBeta,nFun,
     &                    Fact,FA1(ipaC),nAlpha,
     &                        FB2(ipCb),nFun,
     &                    One,Final(1,ia,ib,mVec),nAlpha)

*
             End do
            End do
           End do
         End If
        End do
       End do
*4712  continue

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(ishll)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_A (AA)
c
c        check AA(ij,u,v)
c
        implicit none
#include "chcc1.fh"
        real*8 AA(1:no*(no+1)/2,1:no,1:no)
c
c        help var
        integer i,j,ij,u,v,a,b,bad
        real*8 s
c
        bad=0
c
        ij=0
        do i=1,no
        do j=1,i
        ij=ij+1
c
        do u=1,no
        do v=1,no
c
          s=Q0(u,i,v,j)
c
          do a=1,nv
           s=s+Q1(a,j,u,i)*T1c(a,v)
          end do
c
          do a=1,nv
           s=s+Q1(a,i,v,j)*T1c(a,u)
          end do
c
          do a=1,nv
          do b=1,nv
           s=s+Q21(a,i,b,j)*(T2c(a,b,u,v)+T1c(a,u)*T1c(b,v))
          end do
          end do
c
          Ac(i,j,u,v)=s
c
c          write (6,99) i,j,u,v,AA(ij,u,v),s,AA(ij,u,v)-s
c99          format (4(i2,1x),3(f15.10,1x))
          if (abs(AA(ij,u,v)-s).gt.1.0d-10) then
          bad=bad+1
          end if
c
        end do
        end do
        end do
        end do
c
c
        do u=1,no
        do v=1,no
        do i=2,no
        do j=1,i-1
          Ac(j,i,v,u)=Ac(i,j,u,v)
        end do
        end do
        end do
        end do
c
        write (6,*) ' A   Chck :',bad
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Dresselhaus                                     *
!***********************************************************************
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
! Object: calculate the energy due to an embedding potential           !
!                                                                      !
! Called from: RASSCF                                                  !
!                                                                      !
! Calling    : ddot_                                                   !
!              dcopy                                                   !
!              daxpy                                                   !
!                                                                      !
!     Author: Thomas Dresselhaus                                       !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!Real*8 function embPotEne1(density, length)
! Implicit none
!
! Real*8,  Intent(in) :: density(length)
! Integer, Intent(in) :: length
!
! ! Local variables
! Integer :: mAdEmbInts, readCheck
! Real*8  :: embpotenescf
!
! ! Includes
!#include "WrkSpc.fh"
!
! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! ! Allocate memory for the integrals
! Call GetMem('EmbPotInts','Allo','Real',mAdEmbInts,length)
!
! ! Read in the one-electron integrals due to the embedding potential
! readCheck=-1
! Call RdOne(readCheck,6,'embpot  ',1,Work(mAdEmbInts),1)
! If (readCheck.ne.0) Then
!    Write (6,*) 'R1Inta: Error readin ONEINT'
!    Write (6,'(A,A)') 'Label=embpot  '
!    Call Abend()
! End If
!
! ! Calculate
! embPotEne1=embPotEneSCF(density, Work(mAdEmbInts), length)
!
! ! Clean Memory
! Call GetMem('EmbPotInts','Free','Real',mAdEmbInts,length)
!
!end function

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Real*8 function embPotEneSCF(density, embeddingInts, length)
 Implicit none

 Integer, Intent(in) :: length
 Real*8,  Intent(in) :: density(length)
 Real*8,  Intent(in) :: embeddingInts(length)
 real*8, external    :: ddot_

 ! In this case the energy is just the dot-product of the vectors which resemble
 ! the packed matrices.
 embPotEneSCF = DDot_(length,density,1,embeddingInts,1)

end function

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Real*8 function embPotEneMODensities( &
        densityInactive, densityActive, embeddingInts, &
        nBasPerSym, nBasTotSquare, nFrozenOrbs, nSym)
 Implicit none

 Real*8,  Intent(in) :: densityInactive(*), densityActive(*)
 Real*8,  Intent(in) :: embeddingInts(*)
! Real*8,  Intent(in) :: coefficientMatrix(nBasFunc**2)
 Integer, Intent(in) :: nBasTotSquare, nFrozenOrbs
 Integer, Intent(in) :: nBasPerSym(*)

 ! Local variables
 Real*8, allocatable :: totalDensity(:)
 Real*8, allocatable :: totalDensityPacked(:)
! Real*8, allocatable :: transformedEmbInts(:)
 Real*8              :: embpotenescf

 Integer :: i, dens_dim_packed, iRow, iCol, counter, nSym, counter2

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 ! TODO
! if (nFrozenOrbs .gt. 0) then
!  write(6,*) "ERROR! Usage of an embedding potential is not yet able to treat frozen orbitals!"
!  call Abend()
! end if

 allocate(totalDensity( nBasTotSquare ))

 dens_dim_packed = 0
 do i=1, nSym
   dens_dim_packed = dens_dim_packed + ((nBasPerSym(i) * (nBasPerSym(i)+1)) / 2)
 end do
 allocate(totalDensityPacked( dens_dim_packed ))

 call dcopy_(nBasTotSquare,densityInactive,1,totalDensity,1)
 call daxpy_(nBasTotSquare,1.0d0,densityActive,1,totalDensity,1)

! write(*,*) "Unpacked total density"
! do i=1, dens_dim
!  write(*,*) totalDensity(i)
! end do

 !Pack density
 counter = 0
 counter2 = 0
 do i=1, nSym
  do iRow=1, nBasPerSym(i)
   do iCol=1, iRow
    counter = counter+1
    if (iRow .eq. iCol) then
     totalDensityPacked(counter) = totalDensity((iRow-1)*nBasPerSym(i)+iCol+counter2)
    else
     totalDensityPacked(counter) = 2*totalDensity((iRow-1)*nBasPerSym(i)+iCol+counter2)
    end if
   end do
  end do
  counter2 = counter2 + nBasPerSym(i)*nBasPerSym(i)
 end do
! write(*,*) "nSym=", nSym
! write(*,*) "nTot2=", nBasTotSquare
! write(*,*) "dens_dim_packed=", dens_dim_packed
! write(*,*) "FOOOO Total dens    |  pot"
! do i=1, dens_dim_packed
!  write(*,*) totalDensityPacked(i), "  |  ", embeddingInts(i)
! end do


! ! Transformation
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Well, a TraFo does not seem to be necessary.                               !
! Justification:                                                             !
! 1. The totalDensity matrix (sum of the incoming ones) is exactly symmetric !
! 2. With the currently activated scheme the integrated density on the grid  !
!    produces the correct number of electrons.                               !
! 3. In a CASSCF calculation with 0 active electrons/orbitals (i.e. actually !
!    a HF calculation) the totalDensity matrix should be diagonal with only  !
!    '2.0's and '0.0's on the diagonal if it is expressed in MO basis. This  !
!    is not observed though.
! Conclusion: the incoming matrices actually are expressed in the AO basis;  !
!             they are just not packed.                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! call transAOtoMO(coefficientMatrix, embeddingInts, transformedEmbInts,&
!                  nBasFunc, nFrozenOrbs)
!
! embPotEneMODensities = embPotEneSCF( totalDensity,&
!                                      transformedEmbInts,&
!                                      dens_dim)
 embPotEneMODensities = embPotEneSCF( totalDensityPacked,&
                                      embeddingInts,&
                                      dens_dim_packed)

 deallocate(totalDensity)
 deallocate(totalDensityPacked)
! deallocate(transformedEmbInts)

! Avoid unused argument warnings
 return
 if (.false.) call Unused_integer(nFrozenOrbs)

end function

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Just to be clean this is in a seperate subroutine          !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!subroutine transAOtoMO (coefficientMatrix, inMatrix, outMatrix,&
!                        nBasFunc, nFrozenOrbs)
!
! implicit none
!
! Real*8,  intent(in)  :: coefficientMatrix(nBasFunc**2)
! Real*8,  intent(in)  :: inMatrix(&
!                          nBasFunc*(nBasFunc+1)/2 )
! Real*8,  intent(out) :: outMatrix(&
!                          nBasFunc*(nBasFunc+1)/2 )
! Integer, intent(in)  :: nBasFunc, nFrozenOrbs
!
! ! Local variables
! Real*8 :: unpackedMatrix(nBasFunc**2), halfTrafoMat(nBasFunc**2)
!
! ! TODO
! if (nFrozenOrbs .gt. 0) then
!  write(6,*) "ERROR! Usage of an embedding potential is not yet able to treat frozen orbitals!"
!  call Abend()
! end if
!
! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Call Square(inMatrix,unpackedMatrix,1,nBasFunc,nBasFunc)
!!Call MXMA(unpackedMatrix,1,nBasFunc,&
!!          coefficientMatrix(nFrozenOrbs*nBasFunc),1,&
!!          nBasFunc,halfTrafoMat,1,nBasFunc,&
!!          nBasFunc,nBasFunc,nBasFunc)
!! stefan: check T (transpose) whether it is correct...
! CALL DGEMM_('T','N',nBasFunc,nBasFunc,nBasFunc, &
!             1.0d0,unpackedMatrix,nBasFunc, &
!             coefficientMatrix(nFrozenOrbs*nBasFunc),nBasFunc,&
!             0.0d0,halfTrafoMat,nBasFunc)
! Call MXMT(halfTrafoMat,nBasFunc,1, &
!           coefficientMatrix(nFrozenOrbs*nBasFunc),1,&
!           nBasFunc,outMatrix,nBasFunc,nBasFunc)
!
!end subroutine

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetSh(nShell_Val,nShell_Aux,Verbose,irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Set data in localdf_bas.fh
C
      use Index_arrays, only: iSO2Sh
      use Basis_Info, only: nBas, nBas_Aux
      Implicit Real*8 (a-h,o-z) ! info.fh misses declarations
      Integer nShell_Val
      Integer nShell_Aux
      Logical Verbose
      Integer irc
#include "localdf_bas.fh"
#include "WrkSpc.fh"

      Integer nBT, nST
      Integer iB, ii, jj

      Integer i
      Integer iSOShl, iShlSO, nBasSh
      iSOShl(i)=iWork(ip_iSOShl-1+i)
      iShlSO(i)=iWork(ip_iShlSO-1+i)
      nBasSh(i)=iWork(ip_nBasSh-1+i)

      ! Init return code
      irc=0

      ! Set number of valence and auxiliary shells
      nShell_Valence=nShell_Val
      nShell_Auxiliary=nShell_Aux

      ! Get number of valence functions from info.fh
      nBas_Valence=nBas(0)

      ! Get number of auxiliary functions from info.fh
      ! Subtract the additional dummy function
      nBas_Auxiliary=nBas_Aux(0)-1

      ! Total number of basis functions (val+aux) + 1 dummy
      nBT=nBas_Valence+nBas_Auxiliary+1

      ! Total number of shells (val+aux) + 1 dummy
      nST=nShell_Valence+nShell_Auxiliary+1

      ! Get iSOShl from index_arrays
      l_iSOShl=nBT
      Call GetMem('LDF_iSOShl','Allo','Inte',ip_iSOShl,l_iSOShl)
      Call iCopy(l_iSOShl,iSO2Sh,1,iWork(ip_iSOShl),1)

      ! Get nBasSh
      l_nBasSh=nST
      Call GetMem('LDF_nBasSh','Allo','Inte',ip_nBasSh,l_nBasSh)
      Call iZero(iWork(ip_nBasSh),l_nBasSh)
      ii=ip_nBasSh-1
      Do iB=1,nBT
         jj=ii+iSOShl(iB)
         iWork(jj)=iWork(jj)+1
      End Do

      ! Get iShlSO
      l_iShlSO=l_iSOShl
      Call GetMem('LDF_iShlSO','Allo','Inte',ip_iShlSO,l_iShlSO)
      Call Cho_SetSh2(iWork(ip_iShlSO),iWork(ip_iSOShl),
     &                iWork(ip_nBasSh),nBT,nST)

      ! Print
      If (Verbose) Then
         Call Cho_Head('Info from LDF_SetSh','-',120,6)
         Write(6,'(/,A,I8)')
     &   'Number of valence shells:  ',nShell_Valence
         Write(6,'(A,I8)')
     &   'Number of auxiliary shells:',nShell_Auxiliary
         Write(6,'(A,I8)')
     &   'Number of valence BF:      ',nBas_Valence
         Write(6,'(A,I8)')
     &   'Number of auxiliary BF:    ',nBas_Auxiliary
         Write(6,'(/,A)')
     &   '      BF    Shell Index in Shell'
         Write(6,'(32A1)') ('-',ii=1,32)
         Do iB=1,nBT
            Write(6,'(I8,1X,I8,7X,I8)')
     &      iB,iSOShl(iB),iShlSO(iB)
         End Do
         Write(6,'(32A1)') ('-',ii=1,32)
         Write(6,'(/,A,/,A)')
     &   'Val Shell   Dimension',
     &   '---------------------'
         Do ii=1,nShell_Valence
            Write(6,'(1X,I8,4X,I8)') ii,nBasSh(ii)
         End Do
         Write(6,'(A)')
     &   '---------------------'
         Write(6,'(/,A,/,A)')
     &   'Aux Shell   Dimension',
     &   '---------------------'
         Do ii=nShell_Valence+1,nShell_Valence+nShell_Auxiliary
            Write(6,'(1X,I8,4X,I8)') ii,nBasSh(ii)
         End Do
         Write(6,'(A)')
     &   '---------------------'
         Call xFlush(6)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine LOOP17(KM,ISTOP,IT1,IT2)

use guga_global, only: BL1, BL2, COUP, COUP1, IA, IB, ICOUP, ICOUP1, IWAY, IY, J1, J2, JM, JM1, K0, K0F, K1, K1F, K2, K2F, K3, K3F
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: KM, IT1, IT2
integer(kind=iwp), intent(out) :: ISTOP
integer(kind=iwp) :: IDIF, IWAYKM, KM1
real(kind=wp) :: WMM, WMP, WPM, WPP

ISTOP = 0
KM1 = KM+1
IDIF = IA(J1(KM1))-IA(J2(KM1))
if ((IDIF < 0) .or. (IDIF > 2)) then
  ISTOP = 1
else if (IDIF-1 < 0) then
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    ! (NR,RO)
    IWAY(KM) = 2
    if ((K1(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else if (K1F(JM(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP1(KM) = COUP(KM1)/(IB(J2(KM1))+2)
      JM1(KM) = K1F(JM(KM1))
      if (K2F(JM(KM1)) /= 0) then
        COUP(KM) = -BL2(IB(J2(KM1))+1)*COUP(KM1)/(IB(J2(KM1))+3)
        JM(KM) = K2F(JM(KM1))
      end if
    else if (K2F(JM(KM1)) == 0) then
      IWAYKM = 2
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM) = -BL2(IB(J2(KM1))+1)*COUP(KM1)/(IB(J2(KM1))+3)
      JM(KM) = K2F(JM(KM1))
    end if
  end if
  if (IWAYKM == 2) then
    ! MM
    IWAY(KM) = 3
    if ((K0(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else if (K0F(JM(KM1)) == 0) then
      IWAYKM = 3
    else
      J1(KM) = K0(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)
      ICOUP(KM) = ICOUP(KM1)
      COUP(KM) = COUP(KM1)
      JM(KM) = K0F(JM(KM1))
    end if
  end if
  if (IWAYKM == 3) then
    ! NN
    IWAY(KM) = 4
    if ((K1(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 4
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 4
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM) = COUP(KM1)
      JM(KM) = K1F(JM(KM1))
    end if
  end if
  if (IWAYKM == 4) then
    ! OO
    IWAY(KM) = 5
    if ((K2(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 5
    else if (K2F(JM(KM1)) == 0) then
      IWAYKM = 5
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM) = BL2(IB(J2(KM1))+2)*BL2(IB(J2(KM1))+1)*COUP(KM1)
      JM(KM) = K2F(JM(KM1))
    end if
  end if
  if (IWAYKM == 5) then
    ! PP
    IWAY(KM) = 6
    if ((K3(IT1+J1(KM1)) == 0) .or. (K3(IT2+J2(KM1)) == 0)) then
      IWAYKM = 6
    else if (K3F(JM(KM1)) == 0) then
      IWAYKM = 6
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K3(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP(KM) = COUP(KM1)
      JM(KM) = K3F(JM(KM1))
    end if
  end if
  if (IWAYKM == 6) ISTOP = 1
else if (IDIF-1 == 0) then
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    ! (NJ,RQ,JN)
    IWAY(KM) = 2
    WMP = Zero
    WPP = Zero
    if ((K1(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else if (K1F(JM1(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM) = -BL1(IB(J2(KM1))+1)*COUP1(KM1)
      JM1(KM) = K1F(JM1(KM1))
      if (K2F(JM1(KM1)) /= 0) then
        WMP = -One/((IB(J2(KM1))+1)*IB(J2(KM1)))
        if (K1F(JM(KM1)) == 0) then
          JM(KM) = K2F(JM1(KM1))
        else
          WPP = -BL1(IB(J2(KM1))+2)
          JM(KM) = K1F(JM(KM1))
        end if
      else if (K1F(JM(KM1)) /= 0) then
        WPP = -BL1(IB(J2(KM1))+2)
        JM(KM) = K1F(JM(KM1))
      end if
      COUP(KM) = WMP*COUP1(KM1)+WPP*COUP(KM1)
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      WMP = -One/((IB(J2(KM1))+1)*IB(J2(KM1)))
      if (K1F(JM(KM1)) == 0) then
        JM(KM) = K2F(JM1(KM1))
      else
        WPP = -BL1(IB(J2(KM1))+2)
        JM(KM) = K1F(JM(KM1))
      end if
      COUP(KM) = WMP*COUP1(KM1)+WPP*COUP(KM1)
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 2
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      WPP = -BL1(IB(J2(KM1))+2)
      JM(KM) = K1F(JM(KM1))
      COUP(KM) = WPP*COUP(KM1)
    end if
  end if
  if (IWAYKM == 2) then
    ! (KO,OK,QR)
    IWAY(KM) = 3
    WMM = Zero
    WPM = Zero
    if ((K2(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else if (K2F(JM(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM) = -BL2(IB(J2(KM1))+1)*COUP(KM1)
      JM(KM) = K2F(JM(KM1))
      if (K2F(JM1(KM1)) /= 0) then
        WMM = -BL2(IB(J2(KM1)))
        if (K1F(JM(KM1)) == 0) then
          JM1(KM) = K2F(JM1(KM1))
        else
          WPM = -One/((IB(J2(KM1))+1)*(IB(J2(KM1))+2))
          JM1(KM) = K1F(JM(KM1))
        end if
      else if (K1F(JM(KM1)) /= 0) then
        WPM = -One/((IB(J2(KM1))+1)*(IB(J2(KM1))+2))
        JM1(KM) = K1F(JM(KM1))
      end if
      COUP1(KM) = WMM*COUP1(KM1)+WPM*COUP(KM1)
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      WMM = -BL2(IB(J2(KM1)))
      if (K1F(JM(KM1)) == 0) then
        JM1(KM) = K2F(JM1(KM1))
      else
        WPM = -One/((IB(J2(KM1))+1)*(IB(J2(KM1))+2))
        JM1(KM) = K1F(JM(KM1))
      end if
      COUP1(KM) = WMM*COUP1(KM1)+WPM*COUP(KM1)
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 3
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      WPM = -One/((IB(J2(KM1))+1)*(IB(J2(KM1))+2))
      JM1(KM) = K1F(JM(KM1))
      COUP1(KM) = WPM*COUP(KM1)
    end if
  end if
  if (IWAYKM == 3) then
    ! (MI,IM)
    IWAY(KM) = 4
    if ((K0(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 4
    else if (K0F(JM1(KM1)) /= 0) then
      J1(KM) = K0(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)
      ICOUP(KM) = ICOUP(KM1)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K0F(JM1(KM1))
      if (K0F(JM(KM1)) /= 0) then
        COUP(KM) = COUP(KM1)
        JM(KM) = K0F(JM(KM1))
      end if
    else if (K0F(JM(KM1)) == 0) then
      IWAYKM = 4
    else
      J1(KM) = K0(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)
      ICOUP(KM) = ICOUP(KM1)
      COUP(KM) = COUP(KM1)
      JM(KM) = K0F(JM(KM1))
    end if
  end if
  if (IWAYKM == 4) then
    ! (PL,LP)
    IWAY(KM) = 5
    if ((K3(IT1+J1(KM1)) == 0) .or. (K3(IT2+J2(KM1)) == 0)) then
      IWAYKM = 5
    else if (K3F(JM1(KM1)) /= 0) then
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K3(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K3F(JM1(KM1))
      if (K3F(JM(KM1)) /= 0) then
        COUP(KM) = COUP(KM1)
        JM(KM) = K3F(JM(KM1))
      end if
    else if (K3F(JM(KM1)) == 0) then
      IWAYKM = 5
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K3(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP(KM) = COUP(KM1)
      JM(KM) = K3F(JM(KM1))
    end if
  end if
  if (IWAYKM == 5) then
    ! (OQ,QN)
    IWAY(KM) = 6
    if ((K2(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 6
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      WMP = BL2(IB(J2(KM1)))/IB(J2(KM1))
      JM(KM) = K2F(JM1(KM1))
      if (K1F(JM(KM1)) == 0) then
        WPP = Zero
      else
        WPP = -One/(IB(J2(KM1))+1)
        JM(KM) = K1F(JM(KM1))
      end if
      COUP(KM) = WMP*COUP1(KM1)+WPP*COUP(KM1)
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 6
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      WPP = -One/(IB(J2(KM1))+1)
      JM(KM) = K1F(JM(KM1))
      COUP(KM) = WPP*COUP(KM1)
    end if
  end if
  if (IWAYKM == 6) then
    ! (RK,JR)
    IWAY(KM) = 7
    if ((K1(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 7
    else if (K2F(JM1(KM1)) /= 0) then
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      WMM = One/(IB(J2(KM1))+1)
      JM1(KM) = K2F(JM1(KM1))
      if (K1F(JM(KM1)) == 0) then
        WPM = Zero
      else
        WPM = -BL1(IB(J2(KM1))+2)/(IB(J2(KM1))+2)
        JM1(KM) = K1F(JM(KM1))
      end if
      COUP1(KM) = WMM*COUP1(KM1)+WPM*COUP(KM1)
    else if (K1F(JM(KM1)) == 0) then
      IWAYKM = 7
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      WPM = -BL1(IB(J2(KM1))+2)/(IB(J2(KM1))+2)
      JM1(KM) = K1F(JM(KM1))
      COUP1(KM) = WPM*COUP(KM1)
    end if
  end if
  if (IWAYKM == 7) ISTOP = 1
else
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    ! (QJ,KQ)
    IWAY(KM) = 2
    if ((K2(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else if (K1F(JM1(KM1)) /= 0) then
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM) = BL1(IB(J2(KM1))+1)*COUP1(KM1)/(IB(J2(KM1))-1)
      JM1(KM) = K1F(JM1(KM1))
      if (K2F(JM1(KM1)) /= 0) then
        COUP(KM) = -COUP1(KM1)/IB(J2(KM1))
        JM(KM) = K2F(JM1(KM1))
      end if
    else if (K2F(JM1(KM1)) == 0) then
      IWAYKM = 2
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM) = -COUP1(KM1)/IB(J2(KM1))
      JM(KM) = K2F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 2) then
    ! II
    IWAY(KM) = 3
    if ((K0(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else if (K0F(JM1(KM1)) == 0) then
      IWAYKM = 3
    else
      J1(KM) = K0(IT1+J1(KM1))
      J2(KM) = K0(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)
      ICOUP(KM) = ICOUP(KM1)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K0F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 3) then
    ! JJ
    IWAY(KM) = 4
    if ((K1(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 4
    else if (K1F(JM1(KM1)) == 0) then
      IWAYKM = 4
    else
      J1(KM) = K1(IT1+J1(KM1))
      J2(KM) = K1(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM) = BL1(IB(J2(KM1)))*BL1(IB(J2(KM1))+1)*COUP1(KM1)
      JM1(KM) = K1F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 4) then
    ! KK
    IWAY(KM) = 5
    if ((K2(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 5
    else if (K2F(JM1(KM1)) == 0) then
      IWAYKM = 5
    else
      J1(KM) = K2(IT1+J1(KM1))
      J2(KM) = K2(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K2F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 5) then
    ! LL
    IWAY(KM) = 6
    if ((K3(IT1+J1(KM1)) == 0) .or. (K3(IT2+J2(KM1)) == 0)) then
      IWAYKM = 6
    else if (K3F(JM1(KM1)) == 0) then
      IWAYKM = 6
    else
      J1(KM) = K3(IT1+J1(KM1))
      J2(KM) = K3(IT2+J2(KM1))
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP1(KM) = COUP1(KM1)
      JM1(KM) = K3F(JM1(KM1))
    end if
  end if
  if (IWAYKM == 6) ISTOP = 1
end if

return

end subroutine LOOP17

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine SlvEqs(N,A,X,B,Error)
!-----------------------------------------------------------------------
! Function : Solve equations (Loesen)
!            Solve AX = B
!-----------------------------------------------------------------------

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(inout) :: A(40,40), X(40), B(40)
logical(kind=iwp), intent(out) :: Error
integer(kind=iwp) :: I, II, J, K
real(kind=wp) :: P, PInv, S, SInv
real(kind=wp), parameter :: G_Eps = 1.0e-19_wp

Error = .false.
do I=1,N
  do K=I,N
    S = sum(A(K,I:N)**2)
    if (S == Zero) return
    S = sqrt(S)
    SInv = One/S
    B(K) = B(K)*SInv
    A(K,1:N) = A(K,1:N)*SInv
  end do

  P = A(I,I)
  K = I
  do J=I,N
    S = A(J,I)
    if (abs(S) > abs(P)) then
      P = S
      K = J
    end if
  end do
  if (K > I) then
    do J=I,N
      S = A(I,J)
      A(I,J) = A(K,J)
      A(K,J) = S
    end do
    S = B(I)
    B(I) = B(K)
    B(K) = S
  end if
  if ((abs(P) < G_Eps) .and. (P == Zero)) return

  PInv = One/P
  B(I) = B(I)*PInv
  A(I,I+1:N) = A(I,I+1:N)*PInv
  do K=I+1,N
    S = A(K,I)
    if (S /= Zero) then
      B(K) = B(K)-S*B(I)
      A(K,J) = A(K,J)-S*sum(A(I,I+1:N))
    end if
  end do
end do

II = N
do I=1,N
  X(II) = B(II)-sum(A(II,II+1:N)*X(II+1:N))
  II = II-1
end do

Error = .true.

return

end subroutine SlvEqs

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Thouless_T1(CMO,nSym,nBas,nFro,nOcc,nSsh,T1amp)

      Implicit Real*8 (a-h,o-z)
      Integer nSym, nBas(nSym), nFro(nSym), nOcc(nSym), nSsh(nSym)
      Real*8 CMO(*), T1amp(*)
      Character*40 OrbTit
      Dimension Dummy(1), iDummy(1)
#include "WrkSpc.fh"

C
C     Compute the T1 amplitudes according to Thouless formula
C     --------------------------------------------------------

      l_S = nBas(1)**2
      lScr=nBas(1)*(nFro(1)+nOcc(1))
      l_O=nOcc(1)
      Do iSym = 2,nSym
         l_S = l_S + nBas(iSym)**2
         lScr=Max(lScr,nBas(iSym)*(nFro(iSym)+nOcc(iSym)))
         l_O=Max(l_O,nOcc(iSym))
      End Do
      l_O2=l_O**2

      Call GetMem('Scr','Allo','Real',ip_Scr,2*lScr)
      ip_U=ip_Scr+lScr

      Call GetMem('WYZR','Allo','Real',ip_w,4*l_O2)
      ip_y = ip_w + l_O2
      ip_z = ip_y + l_O2
      ip_r = ip_z + l_O2

      Call GetMem('S','Allo','Real',ip_S,2*l_S)
      ip_X=ip_S+l_S

      Call GetOvlp_Localisation(Work(ip_S),'Sqr',nBas,nSym)

      Lu=12
      Call RdVec('INPORB',Lu,'C',nSym,nBas,nBas,Work(ip_X),Dummy,Dummy,
     &                    iDummy,OrbTit,1,iErr)

      write(6,*)
      write(6,*) '      Thouless singles amplitudes from: '
      write(6,*) '      '//OrbTit
      write(6,*)

      iOff=0
      kOff=0
      Do iSym=1,nSym
         jp_S = ip_S + iOff
         jp_C = 1 + iOff + nBas(iSym)*nFro(iSym)
         jp_X = ip_X + iOff + nBas(iSym)*nFro(iSym)
         nOrb=nOcc(iSym)+nSsh(iSym)

         Call GetUmat_T1(Work(ip_U),CMO(jp_C),Work(jp_S),Work(jp_X),
     &                   Work(ip_Scr),lScr,nBas(iSym),
     &                   nOrb,nOcc(iSym))

         iU=ip_U
         Do j=1,nOcc(iSym)
            ifr=ip_U+nOrb*(j-1)
            ito=ip_Scr+nOcc(iSym)*(j-1)
            call dcopy_(nOcc(iSym),Work(ifr),1,Work(ito),1)
            jU=ifr+nOcc(iSym)
            Do i=1,nSsh(iSym)
               Work(iU)=Work(jU)
               iU=iU+1
               jU=jU+1
            End Do
         End Do

c --- SVD of U in the oo space:   U = Y * w * Z'

         Call SVD(nOcc(iSym),nOcc(iSym),nOcc(iSym),Work(ip_Scr),
     &            Work(ip_w),.true.,Work(ip_y),.true.,Work(ip_z),
     &            ierr,Work(ip_r))

         If (ierr.ne.0) Then
            write(6,*)
            write(6,*) ' *** Warning: SVD failed to get singval: ',ierr
            write(6,*) ' *** Located in Thouless_T1 -- call to SVD .'
            write(6,*)
            write(6,*) ' omega= ',(Work(ip_w+k),k=0,nOcc(iSym)-1)
         EndIf

         Call FZero(Work(ip_r),nOcc(iSym)**2)
         Do k=1,nOcc(iSym)
            omega=Work(ip_w+k-1)
            kk=nOcc(iSym)*(k-1)+k-1
            If (omega.gt.1.0d-8) Then
               Work(ip_r+kk)=1.0d0/omega
            EndIf
         End Do

c --- Compute U^-1 = Z * w^-1 * Y'

         Call DGEMM_('N','T',nOcc(iSym),nOcc(iSym),nOcc(iSym),
     &                           1.0d0,Work(ip_r),nOcc(iSym),
     &                                 Work(ip_y),nOcc(iSym),
     &                           0.0d0,Work(ip_w),nOcc(iSym))

         Call DGEMM_('N','N',nOcc(iSym),nOcc(iSym),nOcc(iSym),
     &                           1.0d0,Work(ip_z),nOcc(iSym),
     &                                 Work(ip_w),nOcc(iSym),
     &                           0.0d0,Work(ip_Scr),nOcc(iSym))

         jp_T = 1 + kOff
         Call DGEMM_('T','T',nOcc(iSym),nSsh(iSym),nOcc(iSym),
     &                           1.0d0,Work(ip_Scr),nOcc(iSym),
     &                                 Work(ip_U),nSsh(iSym),
     &                           0.0d0,T1amp(jp_T),nOcc(iSym))

         iOff = iOff + nBas(iSym)**2
         kOff = kOff + nOcc(iSym)*nSsh(iSym)
      End Do

      Call GetMem('S','Free','Real',ip_S,2*l_S)
      Call GetMem('WYZR','Free','Real',ip_w,4*l_O2)
      Call GetMem('Scr','Free','Real',ip_Scr,2*lScr)
      Return
      End


      SubRoutine GetUmat_T1(U,C,S,X,Scr,lScr,nBas,nOrb1,nOrb2)
C
C     Purpose: compute transformation matrix U=C^TSX.
C
      Implicit None
      Real*8  U(*), C(*), S(*), X(*)
      Integer lScr
      Real*8  Scr(lScr)
      Integer nBas, nOrb1, nOrb2

      Character*80 Txt
      Character*10 SecNam
      Parameter (SecNam = 'GetUmat_T1')

      Real*8 d0, d1
      Parameter (d0 = 0.0d0, d1 = 1.0d0)

      Integer Need

      If (nOrb1*nOrb2.lt.1 .or. nBas.lt.1) Return

      Need = nBas*nOrb2
      If (lScr .lt. Need) Then
         Write(Txt,'(A,I9,A,I9)')
     &   'lScr =',lScr,'     Need =',Need
         Call SysAbendMsg(SecNam,
     &                   'Insufficient dimension of scratch array!',Txt)
      End If

      Call DGEMM_('N','N',nBas,nOrb2,nBas,
     &                 d1,S,nBas,
     &                    X,nBas,
     &                 d0,Scr,nBas)
      Call DGEMM_('T','N',nOrb1,nOrb2,nBas,
     &                 d1,C,nBas,
     &                    Scr,nBas,
     &                 d0,U,nOrb1)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Matthew R. Hennefarth                            *
!***********************************************************************

subroutine savefock_pdft(cmo,h1e,d1act,nq,p2d)

use wadr, only: fockocc
use rasscf_global, only: istorp, nacpar, nacpr2, nfint, ntot4
use general_data, only: nbas, nfro, norb, nsym, ntot1, ntot2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: cmo(ntot2), h1e(ntot1), d1act(nacpar), p2d(nacpr2)
integer(kind=iwp), intent(in) :: nq
real(kind=wp), allocatable :: dm2(:), fa_v(:), fi_v(:), fock(:), h1e_mo(:), ontopo(:), ontopt(:), q(:), tuvx_tmp(:)

call mma_allocate(h1e_mo,ntot1,label='h1e_mo')
call mma_allocate(fock,ntot4,label='fock')

fock(:) = Zero

write(u6,'(2X,A)') 'Calculating potentials for analytical gradients for MC-PDFT'

call ao2mo_1e(cmo,h1e,h1e_mo,nsym,nbas,norb,nfro)

! Loading 1e and 2e potentials
call mma_allocate(ontopt,nfint,label='ontopt')
call mma_allocate(ontopo,ntot1,label='ontopo')
call get_darray('ONTOPT',ontopt,nfint)
call get_darray('ONTOPO',ontopo,ntot1)

! store for latter..
call mma_allocate(tuvx_tmp,nacpr2,label='tuvx_tmp')
call get_tuvx(ontopt,tuvx_tmp)
call put_darray('F2_PDFT',tuvx_tmp(:),nacpr2)
call mma_deallocate(tuvx_tmp)

call mma_allocate(fi_v,ntot1,label='fi_v')
call mma_allocate(fa_v,ntot1,label='fa_v')
! Note that these are stored in MO basis
call get_darray('FI_V',fi_v,ntot1)
call get_darray('FA_V',fa_v,ntot1)

fi_v(:) = fi_v(:)+ontopo(:)+h1e_mo(:)
call put_darray('F1_PDFT',fi_v(:),ntot1)

! Now we generate generalized fock operator and fockocc

! Reordering of the 2body density matrix
if (istorp(nsym+1) > 0) then
  call mma_allocate(dm2,istorp(nsym+1),label='dm2')
  call pmat_rasscf(p2d,dm2)
else
  call mma_allocate(dm2,1,label='dm2')
  dm2(:) = Zero
end if

call mma_allocate(q,nq,label='q')
call fock_update(fock,fi_v,fa_v,d1act,dm2,q,nq,ontopt,cmo)

call put_darray('FockOcc',fockocc,ntot1)
call put_darray('Fock_PDFT',fock,ntot4)

call mma_deallocate(q)
call mma_deallocate(fock)
call mma_deallocate(h1e_mo)
call mma_deallocate(fi_v)
call mma_deallocate(fa_v)
call mma_deallocate(ontopo)
call mma_deallocate(ontopt)
call mma_deallocate(dm2)

call put_iscalar('SA ready',1)

end subroutine savefock_pdft

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GenBMp_Localisation(D,C,X,nShell,iSym,ColD,ColC,ColX,PreFix)

use Localisation_globals, only: nOrb2Loc
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nShell, iSym
real(kind=wp), intent(in) :: D(nShell,nShell), C(nShell,*), X(nShell,*)
character(len=2), intent(in) :: PreFix
character, intent(in) :: ColD, ColC, ColX
character(len=12) :: FilNam

! Generate bitmap for density.
! ----------------------------

write(FilNam,'(A2,A5,I1,A4)') PreFix,'Dnsty',iSym,'.bmp'
call GenBMp_Loc(D,nShell,nShell,FilNam,ColD)

! Generate bitmap for original MOs.
! ---------------------------------

write(FilNam,'(A2,A5,I1,A4)') PreFix,'MOrig',iSym,'.bmp'
call GenBMp_Loc(C,nShell,nOrb2Loc(iSym),FilNam,ColC)

! Generate bitmap for localised MOs.
! ----------------------------------

write(FilNam,'(A2,A5,I1,A4)') PreFix,'MOloc',iSym,'.bmp'
call GenBMp_Loc(X,nShell,nOrb2Loc(iSym),FilNam,ColX)

end subroutine GenBMp_Localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE STRTYP_GAS(IPRNT)
*
* Find groups of strings in each GA space
*
* Output : /GASSTR/
*
* Jeppe Olsen, Oct 1994
*
      IMPLICIT REAL*8(A-H,O-Z)
*
*
#include "mxpdim.fh"
#include "cgas.fh"
#include "lucinp.fh"
#include "orbinp.fh"
#include "cstate.fh"
#include "gasstr.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "crun.fh"
*. Local scratch
      DIMENSION IOCTYP(MXPSTT),IREOSPGP(MXPSTT),ISCR(MXPSTT)
      INTEGER IOCCLS(1),IBASSPC(1)
*
      NTESTL = 00
      NTEST = MAX(IPRNT,NTESTL)
*. As input NCISPC GAS spaces IGSOCCX are given.
* Obtain space that cantains all these as special cases
*
C?    WRITE(6,*) ' NCISPC ', NCISPC
      DO IGAS = 1, NGAS
       MINI = IGSOCCX(IGAS,1,1)
       MAXI = IGSOCCX(IGAS,2,1)
C?     WRITE(6,*) ' MINI and MAXI for ISPC = 1 ',MINI,MAXI
       DO ICISPC = 2, NCISPC
        MINI = MIN(MINI,IGSOCCX(IGAS,1,ICISPC))
        MAXI = MAX(MAXI,IGSOCCX(IGAS,2,ICISPC))
C?     WRITE(6,*) ' MINI and MAXI for ISPC =  ',ICISPC,MINI,MAXI
       END DO
       IGSOCC(IGAS,1) = MINI
       IGSOCC(IGAS,2) = MAXI
      END DO
*
      IF(NTEST.GE.5) THEN
        WRITE(6,*) ' Compound GAS space : '
        WRITE(6,*) ' ====================='
        WRITE(6,'(A)')
        WRITE(6,'(A)') '         Min. occ    Max. occ '
        WRITE(6,'(A)') '         ========    ======== '
        DO IGAS = 1, NGAS
          WRITE(6,'(A,I2,3X,I3,9X,I3)')
     &    '   GAS',IGAS,IGSOCC(IGAS,1),IGSOCC(IGAS,2)
        END DO
      END IF

*
*. Find min and max number of elecs in each subspace
*
      DO IGAS = 1, NGAS
        IF(IGAS.EQ.1) THEN
          MNGSOC(IGAS) = IGSOCC(IGAS,1)
          MXGSOC(IGAS) = IGSOCC(IGAS,2)
        ELSE
          MXGSOC(IGAS) = IGSOCC(IGAS,2)-IGSOCC(IGAS-1,1)
          MNGSOC(IGAS) = MAX(0,IGSOCC(IGAS,1)-IGSOCC(IGAS-1,2))
        END IF
      END DO
*
*. Particle and hole spaces  :
*  Hole spaces are always more than half occupied
*
      IPHGASL = 0
      NPHGAS = 0
      DO IGAS = 1, NGAS
c        IF(IUSE_PH.EQ.1) THEN
c*. P/H separation for compound space
c          IF(  MNGSOC(IGAS).GT.NOBPT(IGAS)) THEN
c            IPHGAS(IGAS) = 2
c            IPHGASL = IGAS
c            NPHGAS = NPHGAS + 1
c          ELSE
c             IPHGAS(IGAS) = 1
c          END IF
c*. P/H separation for initial  space
c          IF(IGAS.EQ.1) THEN
c            MIN_OC1 = IGSOCCX(IGAS,1,1)
c          ELSE
c            MIN_OC1 = IGSOCCX(IGAS,1,1)-IGSOCCX(IGAS-1,2,1)
c          END IF
c          IF(MIN_OC1.GT.NOBPT(IGAS)) THEN
c            IPHGAS1(IGAS) = 2
c          ELSE
c             IPHGAS1(IGAS) = 1
c          END IF
c        ELSE IF(IUSE_PH.EQ.0) THEN
          IPHGAS(IGAS) = 1
          IPHGAS1(IGAS) = 1
c        END IF
      END DO
*. Large number of particle and hole orbitals
      MXTSOB_P = 0
      MXTSOB_H = 0
      DO IGAS = 1, NGAS
        IF(IPHGAS1(IGAS).EQ.1) THEN
          MXTSOB_P = MAX(MXTSOB_P,NOBPT(IGAS))
        ELSE
          MXTSOB_H = MAX(MXTSOB_H,NOBPT(IGAS))
        END IF
      END DO
      IF (NTEST .GT. 0)
     &   WRITE(6,*) ' MXTSOB_H, MXTSOB_P = ', MXTSOB_H, MXTSOB_P
*
C?    IF(IUSE_PH.EQ.1) THEN
C?    IPHGAS(1) = 2
C?    DO I = 1, 100
C?      WRITE(6,*) ' First space enforced to hole spaces'
C?    END DO
C?    END IF
*
*. In the following I assume that the hole spaces are the first NPGAS spaces
* ( only used when calculating min number of electrons, so it can be modified
*   easily )
*. Min number of electrons in hole spaces
C      IF (NTEST .GT. 0)
C     &   WRITE(6,*) ' IPHGASL, NPHGAS ',  IPHGASL, NPHGAS
C_Jesper      IF(IPHGASL.NE.NPHGAS) THEN
C_Jesper        WRITE(6,*) ' The hole spaces are not the first orbital spaces'
C_Jesper        STOP       ' The hole spaces are not the first orbital spaces'
C_Jesper      END IF
C      MNHL = IGSOCC(IPHGASL,1)
C     MNHL  = 0
C     DO IGAS = 1, NGAS
C       IF(IPHGAS(IGAS).EQ.2) THEN
C         MNHL = MNHL + MNGSOC(IGAS)
C       END IF
C     END DO
*
      IF (NTEST .GT. 0) THEN
        WRITE(6,*)' IPHGASL,NPHGAS:',IPHGASL,NPHGAS
        IF (IPHGASL.GT.0)
     &          WRITE(6,*)'IGSOCC(IPHGASL,1):',IGSOCC(IPHGASL,1)
      END IF
*
      IF(NTEST.GE.5) THEN
        WRITE(6,*)
        WRITE(6,'(A)') ' Min and Max occupation in each GAS space: '
        WRITE(6,'(A)') ' ========================================= '
        WRITE(6,*)
        DO IGAS = 1,  NGAS
          WRITE(6,'(A,I2,4X,2I3)')
     &    '  GAS',IGAS,MNGSOC(IGAS),MXGSOC(IGAS)
        END DO
*
        WRITE(6,*)' Particle(1) or hole(2) spaces (for compound space)'
        CALL IWRTMA(IPHGAS,1,NGAS,1,NGAS)
        WRITE(6,*)' Particle(1) or hole(2) spaces (for initial space)'
        CALL IWRTMA(IPHGAS1,1,NGAS,1,NGAS)
       END IF
*.
*. Occupation classes corresponding to largest CI space
*
      IBASSPC(1)=0
      CALL OCCLS(         1,    NOCCLS,    IOCCLS,    NACTEL,      NGAS,
     &           IGSOCC(1,1),IGSOCC(1,2),       0,    IBASSPC,   NOBPT)
      NMXOCCLS = NOCCLS
*
* Split into alpha and beta parts
*
*. Number of alpha. and beta electrons
*
      NAEL = (MS2 + NACTEL ) / 2
      NBEL = (NACTEL - MS2 ) / 2
*
      IF(NAEL + NBEL .NE. NACTEL ) THEN
        WRITE(6,*) '  MS2 NACTEL NAEL NBEL '
        WRITE(6,'(5I4)')   MS2,NACTEL,NAEL,NBEL
        WRITE(6,*)
     &  ' STOP : NUMBER OF ELECTRONS AND MULTIPLICITY INCONSISTENT '
*        STOP ' NUMBER OF ELECTRONS INCONSISTENT WITH MULTIPLICITY '
        CALL SYSABENDMSG('lucia_util/strtyp_gas','Internal error',' ')
      END IF
*
      IF(NTEST.GE.5) THEN
        WRITE(6,*) '  MS2 NACTEL NAEL NBEL '
        WRITE(6,'(5I6)')   MS2,NACTEL,NAEL,NBEL
      END IF
*
      IF(NAEL + NBEL .NE. NACTEL ) THEN
        WRITE(6,*) '  MS2 NACTEL NAEL NBEL '
        WRITE(6,'(5I4)')   MS2,NACTEL,NAEL,NBEL
        WRITE(6,*)
     &  ' STOP : NUMBER OF ELECTRONS AND MULTIPLICITY INCONSISTENT '
*          STOP ' NUMBER OF ELECTRONS INCONSISTENT WITH MULTIPLICITY '
        CALL SYSABENDMSG('lucia_util/strtyp_gas','Internal error',' ')
      END IF

*. Number of electrons to be subtracted or added
*
      MAXSUB = 2
*. electrons are only added for systems that atleast have halffilled
*. shells
      IGRP = 0
      MXAL = NAEL
      MNAL = NAEL
      MXBL = NBEL
      MNBL = NBEL
      DO IGAS = 1, NGAS
*. occupation constraints 1
       MXA1 = MIN(MXGSOC(IGAS),NOBPT(IGAS),MXAL)
       MXB1 = MIN(MXGSOC(IGAS),NOBPT(IGAS),MXBL)
       MNA1 = MAX(0,MNGSOC(IGAS)-MXA1)
       MNB1 = MAX(0,MNGSOC(IGAS)-MXB1)
*. Additional checks can be made here
       MXA = MXA1
       MXB = MXB1
       MNA = MNA1
       MNB = MNB1
*
       MXAL = MXAL - MNA
       MNAL = MAX(0,MNAL-MXA)
       MXBL = MXBL - MNB
       MNBL = MAX(0,MNBL-MXB)
*
       IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Occupation numbers for IGAS = ', IGAS
        WRITE(6,*) ' MXAL MNAL MXBL MNBL ',MXAL,MNAL,MXBL,MNBL
        WRITE(6,*) ' MXA MNA MXB MNB ',MXA,MNA,MXB,MNB
       END IF
*
       MNAB = MIN(MNA,MNB)
       MXAB = MAX(MXA,MXB)
*. Additional holes only allowed in particle spaces
       IF(IPHGAS(IGAS).EQ.1) THEN
         MNAB = MAX(0,MNAB-MAXSUB)
       ELSE IF(IPHGAS(IGAS).EQ.2) THEN
         MNAB = MNAB
       END IF
C. For coupled cluster- could be refined ...
       MNAB = 0
*. Additional electrons allowed in hole spaces
       IF(IPHGAS(IGAS).EQ.2)  MXAB = MIN(MXAB + 2,NOBPT(IGAS))
*
       IF(NTEST.GE.100) WRITE(6,*) ' MNAB,MXAB',MNAB,MXAB
       NGPSTR(IGAS) = MXAB-MNAB+1
       IBGPSTR(IGAS) = IGRP + 1
       MNELFGP(IGAS) = MNAB
       MXELFGP(IGAS) = MXAB
*
       IADD = 0
       DO JGRP = IGRP+1,IGRP+NGPSTR(IGAS)
         IF(JGRP.GT.MXPSTT) THEN
           WRITE(6,*) ' Too many string groups '
           WRITE(6,*) ' Current limit ', MXPSTT
           WRITE(6,*) ' STOP : GASSTR, Too many string groups'
*                        STOP ' GASSTR, Too many string groups'
           CALL SYSABENDMSG('lucia_util/gasstr','Internal error',' ')
          END IF
*
         IADD = IADD + 1
         IEL = MNAB-1+IADD
         NELFGP(JGRP) = IEL
         IGSFGP(JGRP) = IGAS
         NSTFGP(JGRP) = IBION_LUCIA(NOBPT(IGAS),IEL)
       END DO
       IGRP = IGRP + NGPSTR(IGAS)
      END DO
      NGRP = IGRP
*
      IF(NTEST.GE.5) THEN
        WRITE(6,*)
        WRITE(6,'(A)') ' Information about Groups of strings '
        WRITE(6,'(A)') ' =================================== '
        WRITE(6,*)
        WRITE(6,*) '     GAS  MNEL  MXEL IBGRP  NGRP'
        WRITE(6,*) '    ============================'
        DO IGAS = 1, NGAS
          WRITE(6,'(5(2X,I4))') IGAS,MNELFGP(IGAS),
     &          MXELFGP(IGAS),IBGPSTR(IGAS),NGPSTR(IGAS)
        END DO
        WRITE(6,'(A,I3)')
     &  ' Total number of groups generated ', NGRP
*
        WRITE(6,'(A)') ' Information about each string group '
        WRITE(6,'(A)') ' ===================================='
        WRITE(6,*)
        IITYPE = 0
        WRITE(6,'(A)') ' GROUP  GAS   NEL      NSTR '
        WRITE(6,'(A)') ' ==========================='
        DO IGRP = 1, NGRP
          IITYPE = IITYPE + 1
          WRITE(6,'(3(2X,I4),2X,I8)')
     &    IITYPE,IGSFGP(IGRP),NELFGP(IGRP),NSTFGP(IGRP)
        END DO
      END IF
*
*. Creation-annihilation connections between groups
*
      DO IGRP = 1, NGRP
        ISTAC(IGRP,1) = 0
        ISTAC(IGRP,2) = 0
        DO JGRP = 1, NGRP
          IF(IGSFGP(IGRP).EQ.IGSFGP(JGRP).AND.
     &       NELFGP(IGRP).EQ.NELFGP(JGRP)-1) ISTAC(IGRP,2) = JGRP
          IF(IGSFGP(IGRP).EQ.IGSFGP(JGRP).AND.
     &       NELFGP(IGRP).EQ.NELFGP(JGRP)+1) ISTAC(IGRP,1) = JGRP
        END DO
      END DO
*
      IF(NTEST.GE.5) THEN
        WRITE(6,*)
        WRITE(6,*) ' ======================================'
        WRITE(6,*) ' Annihilation / Creation connections'
        WRITE(6,*) ' ======================================'
        WRITE(6,*)
        CALL IWRTMA(ISTAC,NGRP,2,MXPSTT,2)
      END IF
*.
*
* Construct number of type ( combinations of groups ) with nael and nbel strings
*
*
* Type 1 : NAEL electrons
*      2 : NBEL ELECTRONS
*      3 : NAEL -1 ELECTRONS
*      4 : NBEL -1 ELECTRONS
*      5 : NAEL -2 ELECTRONS
*      6 : NBEL -2 ELECTRONS
*
      NSTTYP = 6
      NSTTP = 6
*
c      IF(IUSE_PH.EQ.1) THEN
c*. allow N+1,N+2 resolution string
c        NSTTYP = 10
c        NSTTP  = 10
c      END IF
*. alpha
      NELEC(1) = NAEL
      NELFTP(1) = NAEL
*. beta
      NELEC(2) = NBEL
      NELFTP(2) = NBEL
*. alpha -1
      NELEC(3) = NAEL-1
      NELFTP(3) = NAEL-1
*. beta  -1
      NELEC(4) = NBEL-1
      NELFTP(4) = NBEL-1
*. alpha -2
      NELEC(5) = NAEL-2
      NELFTP(5) = NAEL-2
*. beta  -2
      NELEC(6) = NBEL-2
      NELFTP(6) = NBEL-2
*
c      IF(IUSE_PH.EQ.1) THEN
c*. Alpha + 1
c        NELEC(7) = NAEL+1
c        NELFTP(7) = NAEL+1
c*. beta  + 1
c        NELEC(8) = NBEL+1
c        NELFTP(8) = NBEL+1
c*. Alpha + 2
c        NELEC(9) = NAEL+2
c        NELFTP(9) = NAEL+2
c*. beta  + 2
c        NELEC(10) = NBEL+2
c        NELFTP(10) = NBEL+2
c      END IF
*. Can easily be extended to relativistic case !!
      DO ITP = 1, NSTTYP
        NOCTYP(ITP) = 0
        NSPGPFTP(ITP) = 0
      END DO
*
* Loop over types, i.e.  given number of electrons
*
      IOFF = 1
      NABEL = NAEL + NBEL
      NSPGP_TOT = 0
      DO 2000 ITYP = 1, NSTTYP
*. Number of electrons in reference space ( alpha or beta )
        IF(MOD(ITYP,2).EQ.1) THEN
*. alpha type
          NELEC_REF = NELEC(1)
        ELSE
*. Beta type
          NELEC_REF = NELEC(2)
        END IF
*. If we are studying beta type, and number of alpha and beta
* electrons are identical, just refer to alpha
        IF(NAEL.EQ.NBEL.AND.MOD(ITYP,2).EQ.0) THEN
          IBSPGPFTP(ITYP) =  IBSPGPFTP(ITYP-1)
          NOCTYP(ITYP) =   NOCTYP(ITYP-1)
          NSPGPFTP(ITYP) =  NSPGPFTP(ITYP-1)
        ELSE
*
*
*. Number of electrons removed compared to reference
        IDEL = NELEC(ITYP) - NELEC_REF
C?      WRITE(6,*) '  GASSPC : ITYP IDEL ', ITYP,IDEL
*. Initial type of strings, relative to offset for given group
        DO IGAS = 1, NGAS
          IOCTYP(IGAS) = 1
        END DO
        NSPGP = 0
        IBSPGPFTP(ITYP) = IOFF
        IF(NELEC(ITYP).LT.0) THEN
          NOCTYP(ITYP) = 0
          NSPGPFTP(ITYP) =  0
          GOTO 2000
        END IF
*. Number of electrons in present type
*. Loop over  SUPER GROUPS with current nomenclature!
        IONE = 1
 1000   CONTINUE
*. Number of electrons in present supergroup
          NEL = 0
          DO IGAS = 1, NGAS
            NEL = NEL + NELFGP(IOCTYP(IGAS)+IBGPSTR(IGAS)-1)
          END DO
*
          IF(NEL.GT.NELEC(ITYP)) THEN
*. If the number of electrons is to large find next number that
* can be correct.
* The following uses that within a given GAS space
* the number of elecs increases as the type number increases
*
*. First integer  that can be reduced
            IRED = 0
            DO IGAS = 1, NGAS
              IF(IOCTYP(IGAS).NE.1) THEN
                IRED = IGAS
                GOTO 888
              END IF
            END DO
  888       CONTINUE
            IF(IRED.EQ.NGAS) THEN
              NONEW = 1
            ELSE IF(IRED.LT.NGAS) THEN
              IOCTYP(IRED) = 1
*. Increase remanining part
              CALL NXTNUM2(
     &        IOCTYP(IRED+1),NGAS-IRED,IONE,NGPSTR(IRED+1),NONEW)
            END IF
            GOTO 2803
          END IF

          IF(NEL.EQ.NELEC(ITYP)) THEN
*. test 1 has been passed, check additional occupation constraints
*
           I_AM_OKAY = 1
*. Number of extra holes in hole spaces
CE         IF(IUSE_PH.EQ.1) THEN
CE           IDELP = 0
CE           IDELM = 0
CE           DO IGAS = 1, NGAS
CE             IF(IPHGAS(IGAS).EQ.2) THEN
CE               NELH =  NELFGP(IOCTYP(IGAS)+IBGPSTR(IGAS)-1)
CE               IF(NELH.LT.MNGSOC(IGAS))
CE    &          IDELM = IDELM +MNGSOC(IGAS)-NELH
CE               IF(NELH.GT.MXGSOC(IGAS))
CE    &          IDELP = IDELP + NELH-MXGSOC(IGAS)
CE             END IF
CE           END DO
CE           IF(IDELM.GT.0.OR.IDELP.GT.MAX(0,IDEL)) THEN
CE             I_AM_OKAY = 0
CE             WRITE(6,*) ' P/H rejected supergroup '
CE             CALL IWRTMA(IOCTYP,1,NGAS,1,NGAS)
CE             WRITE(6,*) ' IDELM, IDELP ', IDELM, IDELP
CE           END IF
CE         END IF
*
*. Check from above
*
           DO IGAS = NGAS, 1, -1
*. Number of electrons when all electrons of AS IGAS have been added
             IF(IGAS.EQ.NGAS ) THEN
               IEL = MAX(NABEL,NABEL+IDEL)
             ELSE
               IEL = IEL-NELFGP(IOCTYP(IGAS+1)+IBGPSTR(IGAS+1)-1)
               IF(IEL.LT.MAX(IGSOCC(IGAS,1),IGSOCC(IGAS,1)+IDEL))
     &         I_AM_OKAY = 0
             END IF
           END DO
*
* Check from below
*
           IEL = 0
           IOELMX = 0
           DO IGAS = 1, NGAS
             IEL = IEL + NELFGP(IOCTYP(IGAS)+IBGPSTR(IGAS)-1)
             IOELMX = IOELMX+NOBPT(IGAS)
             IF(IEL+IOELMX.LT.MIN(IGSOCC(IGAS,1),IGSOCC(IGAS,1)+IDEL))
     &       I_AM_OKAY = 0
           END DO
*
           IF(I_AM_OKAY.EQ.1) THEN
*. passed !!!
             NSPGP = NSPGP + 1
*. Copy supergroup to ISPGPFTP with absolute group numbers
             DO IGAS = 1, NGAS
               ISPGPFTP(IGAS,IOFF-1+NSPGP)
     &       = IOCTYP(IGAS)+IBGPSTR(IGAS)-1
             END DO
           END IF
*
          END IF
*. Next type of strings
          IONE = 1
          CALL NXTNUM2(IOCTYP,NGAS,IONE,NGPSTR,NONEW)
 2803   CONTINUE
        IF(NONEW.EQ.0) GOTO 1000
*. End of loop over possible supergroups, save information about current type
        IOFF = IOFF + NSPGP
        NOCTYP(ITYP) = NSPGP
        NSPGPFTP(ITYP) =  NSPGP
        NSPGP_TOT =  NSPGP_TOT +  NSPGP
      END IF
 2000 CONTINUE
      NTSPGP = NSPGP_TOT
*
      IF(NSPGP_TOT .GT. MXPSTT ) THEN
        WRITE(6,*) ' Too many super groups = ', NSPGP_TOT
        WRITE(6,*) ' Increase MXPSTT to this value'
        WRITE(6,*) ' See you later '
        WRITE(6,*)
        WRITE(6,*) ' STOP Increase MXPSTT '
*        STOP' Increase MXPSTT'
        CALL SYSABENDMSG('lucia_util/strtyp_gas','Internal error',' ')
      END IF
*
*. Reorder supergroups according to dimension
*
      DO ITYP= 1, NSTTP
        IBTYP = IBSPGPFTP(ITYP)
        NSPGP = NSPGPFTP(ITYP)
*.Dimension of supergroups
        DO ISPGP = 1, NSPGP
          IDIM = 1
          DO JGAS = 1, NGAS
            IDIM = IDIM * NSTFGP(ISPGPFTP(JGAS,ISPGP+IBTYP-1))
          END DO
          IOCTYP(ISPGP) = IDIM
        END DO
*. Reorder
C            ORDINT(IINST,IOUTST,NELMNT,INO,IPRNT)
        CALL ORDINT(IOCTYP,ISCR,NSPGP,IREOSPGP,NTEST)
C?      WRITE(6,*) ' IREO array '
C?      CALL IWRTMA(IREOSPGP,1,NSPGP,1,NSPGP)
*. And reorder the definition of supergroups
        DO ISPGP = 1, NSPGP
          CALL ICOPVE(ISPGPFTP(1,ISPGP+IBTYP-1),NELFSPGP(1,ISPGP),NGAS)
        END DO
        DO ISPGP_N = 1, NSPGP
          ISPGP_O = IREOSPGP(ISPGP_N)
          CALL ICOPVE(NELFSPGP(1,ISPGP_O),ISPGPFTP(1,ISPGP_N+IBTYP-1),
     &                NGAS)
        END DO
*
      END DO
*     ^ End of loop over types
*
      IF(NTEST.GE.2) THEN
       WRITE(6,*) ' Total number of super groups ', NTSPGP
       WRITE(6,*) ' Number of alpha supergroups  ', NSPGPFTP(1)
       WRITE(6,*) ' Number of beta  supergroups  ', NSPGPFTP(2)
       WRITE(6,*)
       WRITE(6,*)
      END IF

*
      IF(NTEST.GE.5) THEN
        WRITE(6,*) ' Information about types of strings'
        WRITE(6,*) ' =================================='
        WRITE(6,*)
        DO ITYP = 1, NSTTYP
          WRITE(6,*)
          WRITE(6,*) '      Type : ', ITYP
          WRITE(6,*) '      ==============='
          WRITE(6,*) '      Number of electrons  ',NELFTP(ITYP)
          WRITE(6,*) '      Number of super groups ', NSPGPFTP(ITYP)
          WRITE(6,*) '      Supergroups '
          DO ISPGP = 1, NSPGPFTP(ITYP)
            IOFF = IBSPGPFTP(ITYP)
            CALL IWRTMA(ISPGPFTP(1,IOFF-1+ISPGP),1,NGAS,1,NGAS)
          END DO
        END DO
      END IF
*
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine CCmbnMP(Rnxyz,nZeta,la,lb,lr,Zeta,rKappa,Final,nComp,
     &                   kVector)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Complex*16 Rnxyz(nZeta,3,0:la,0:lb,0:lr), Temp
      Real*8  Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nComp),
     &        Zeta(nZeta), rKappa(nZeta), kVector(3)
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
      iRout = 134
      iPrint = nPrint(iRout)
*
      Do 10 ixa = 0, la
         iyaMax=la-ixa
      Do 11 ixb = 0, lb
         iybMax=lb-ixb
         Do 20 iya = 0, iyaMax
            iza = la-ixa-iya
            ipa= Ind(la,ixa,iza)
         Do 21 iyb = 0, iybMax
            izb = lb-ixb-iyb
            ipb= Ind(lb,ixb,izb)
*
*           Combine multipole moment integrals
*
            iComp = 0
            Do 41 ix = lr, 0, -1
               Do 42 iy = lr-ix, 0, -1
                  iz = lr-ix-iy
                  Do 30 iZeta = 1, nZeta
                     rTemp=KVector(1)**2 + kVector(2)**2 + kVector(3)**2
                     rTemp=rTemp/(Four*Zeta(iZeta))
                     Fact = rKappa(iZeta) * (1.0D0/Sqrt(Zeta(iZeta)**3))
     &                    * Exp(-rTemp)
                     Temp = Fact *
     &                       Rnxyz(iZeta,1,ixa,ixb,ix)*
     &                       Rnxyz(iZeta,2,iya,iyb,iy)*
     &                       Rnxyz(iZeta,3,iza,izb,iz)
                     Final(iZeta,ipa,ipb,iComp+1) = DBLE(Temp)
                     Final(iZeta,ipa,ipb,iComp+2) = DIMAG(Temp)
 30               Continue
                  iComp=iComp+2
 42            Continue
 41         Continue
*
 21      Continue
 20      Continue
 11   Continue
 10   Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016,2017, Stefan Knecht                               *
************************************************************************
#ifdef _DMRG_
!-------------------------------------------------------------------------------
      subroutine mpsrot(smat,nasht,nash,nsym)


      use qcmaquis_interface_cfg
      use qcmaquis_interface_wrapper

      implicit none

#include "stdalloc.fh"
!-------------------------------------------------------------------------------
!
!  Purpose:  driver routine for the MPS rotation wrt the orbital
!            transformation matrix given in t.
!    --> rotate MPS state ISTATE
!    NOTE: t contains square matrices, one per symmetry
!
!-------------------------------------------------------------------------------

      real*8,  intent(inout) :: smat(nasht*nasht)
      integer, intent(in)    :: nasht
      integer, intent(in)    :: nash(nsym)
      integer, intent(in)    :: nsym

      real*8, allocatable    :: x(:)
      real*8, allocatable    :: t(:)
      real*8, allocatable    :: scr(:)

      integer                :: ioff, iadr, icol, irow, i, j, isym, jorb
      real*8                 :: fac(1,1)

      fac(1,1) = 1.0d0
      !> create file with info for inactive orbital rotation
      call dmrg_interface_ctl(
     &                        task    = 'tra dump',
     &                        x1      = fac,
     &                        ndim    =  1,
     &                        mdim    = -1,
     &                        state   =  0,
     &                        stateL  =  0
     &                       )

      call mma_allocate(x, nasht**2)

      x    = 0
      ioff = 0
      iadr = 1
      icol = 1

#ifdef BLUBB
      !> debug
      do i = 1, nasht
      do j = 1, nasht
        write(6,*) 'row i, column j, value ',i,j,smat(i+(j-1)*nasht)
      end do
      end do
#endif

      do isym = 1, nsym
        if(nash(isym) > 0)then
          irow = icol
          do i = 1, nash(isym)
            iadr = (icol-1)*nasht+irow
            do j = 1, nash(isym)
              x(ioff+nash(isym)*(j-1)+i) = smat(iadr+j-1)
            end do
            icol = icol + 1
          end do
          ioff = ioff + nash(isym)**2
        end if
      end do


      call mma_allocate(scr, nasht**2 +nasht*(nasht+1)/2)
      call mma_allocate(t, nasht**2)
      t = 0; scr = 0;

      jorb = 0
      ioff = 1
      do isym = 1, nsym
        if(isym > 1) then
          ioff = ioff + nash(isym-1)**2
        end if
        if(nash(isym) > 0)then
         call pamtmt(x(ioff),t(ioff),scr,nash(isym))
         !> create file(s) with info for active orbital rotation
#ifdef BLUBB
         !> debug
         write(6,*) 'T ... '
         do i = 1, nash(isym)
         do j = 1, nash(isym)
           write(6,*) 'row, column, value ',i,j,t(ioff-1+i+(j-1)*nasht)
         end do
         end do
#endif
         do i = 1, nash(isym)
            jorb = jorb + 1
            call dmrg_interface_ctl(
     &                              task    = 'tra dump',
     &                              x1      = t(ioff),
     &                              ndim    = nash(isym),
     &                              mdim    = 0,
     &                              state   = jorb,
     &                              stateL  = isym
     &                             )
          end do
        end if
      end do
      call mma_deallocate(x)
      call mma_deallocate(scr)
      call mma_deallocate(t)

      do i = 1, dmrg_state%maxroot
        !> make a backup of the actual MPS
        call dmrg_interface_ctl(
     &                          task    = 'MPS back',
     &                          state   = i,
     &                          stateL  = -1
     &                          )
        !> counterrotate MPS
        write(6,*) ' counterrotate MPS #',i
        call dmrg_interface_ctl(
     &                          task    = 'MPS crot',
     &                          state   = i
     &                          )
      end do

      end subroutine mpsrot
#elif defined (NAGFOR)
c Some compilers do not like empty files
      subroutine empty_mpsrot()
      end subroutine empty_mpsrot
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine CMSMatRot(Mat,A,I,J,N)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: I, J, N
real(kind=wp), intent(inout) :: Mat(N,N)
real(kind=wp), intent(in) :: A
real(kind=wp), allocatable :: TM(:,:)

call mma_allocate(TM,2,N,Label='TM')
TM(1,:) = Mat(I,:)
TM(2,:) = Mat(J,:)
Mat(J,:) = cos(A)*TM(2,:)+sin(A)*TM(1,:)
Mat(I,:) = -sin(A)*TM(2,:)+cos(A)*TM(1,:)
call mma_deallocate(TM)

end subroutine CMSMatRot

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PrB(dB,nq,nDim)
      Implicit Real*8 (a-h,o-z)
      Real*8 dB(nq,nDim,nDim)
*
      Do iq = 1, nQ
         Write (6,*) ' iq=',iq
         Do iDim = 1, nDim
            Write (6,'(9F10.6)')
     &            (dB(iq,iDim,jDim),jDim=1,nDim)
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Pavel Neogrady                                   *
************************************************************************
        subroutine extstack (wrk,wrksize,
     &                 mapda,mapdb,b,dimb)
c
c       This routine do:
c       A(ij) <- B(ij,_b) for given b
c
c       A special routine used only in sumoverab for stacking
c       case.
c
c       Yet it is assumed,that blocks in A and B are in the same
c       order. To je pomerne odflaknuty predpoklad, a moze to
c       byt bugous
c
#include "wrk.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer b,dimb
c
c     help variables
c
       integer ii,dimij,possa,possb
c
c
        do ii=1,mapda(0,5)
          dimij=mapda(ii,2)
          possa=mapda(ii,1)
          possb=mapdb(ii,1)
          call extstackhlp1 (wrk(possa),wrk(possb),dimij,dimb,b)
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,1994, Per Ake Malmqvist                           *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE FMAT_CASPT2(FIMO,FAMO,DREF,NBUF,BUF)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "SysDef.fh"
      DIMENSION FIMO(NFIMO),FAMO(NFAMO)
      DIMENSION DREF(NDREF),BUF(NBUF)
      DIMENSION IAD2M(3,36*36)

C COMPUTE THE INACTIVE FOCK MATRIX IN MO BASIS.
C COMPUTE THE ACTIVE FOCK MATRIX IN MO BASIS.
C DEFINITIONS ARE:
C FIMO(P,Q)= H(P,Q)+ SUM( (2*(PQ,KK)-(PK,QK)) OVER INACTIVE K)
C WHERE H(P,Q) IS THE CORE FOCK MATRIX OBTAINED FROM THE
C TRANSFORMATION PART, I.E., THE CI 1-ELECTRON HAMILTONIAN.
C SIMILARLY, FAMO(P,Q)=
C  (1/2)*SUM( (2*(PQ,TU)-(PU,QT))*DREF(T,U) OVER ACTIVE T,U)
C THIS ROUTINE USES DIRECTLY THE TRANSFORMED INTEGRALS TO SET UP
C FIMO AND FAMO.
C CODED 92-12-04 BY MALMQVIST FOR CASPT2, MOLCAS-3 VERSION.


      NDIM2M=(NSYM*(NSYM+1))/2
      IDISK=0
      CALL IDAFILE(LUINTM,2,IAD2M,3*36*36,IDISK)

      IFSTA=1
      DO ISYR=1,NSYM
        NBR=NORB(ISYR)
        IF(NBR.EQ.0) GOTO 120
        NB3=(NBR**2+NBR)/2
        NBNB=NBR**2
        ISYS=ISYR
        IS3RS=(ISYR**2+ISYR)/2
        DO ISYP=1,NSYM
          NIP=NISH(ISYP)
          NOP=NOSH(ISYP)
          NAESP=NAES(ISYP)
          IF(NOP.EQ.0) GOTO 110
          ISYQ=ISYP
          IS3PQ=(ISYP*(ISYP+1))/2
          ISADDR=IS3RS+NDIM2M*(IS3PQ-1)
          IDISK1=IAD2M(1,ISADDR)
          IF(IDISK1.EQ.0) THEN
            WRITE(6,*)' FMAT: COULOMB INTEGRAL BUFFER MISSING!'
            WRITE(6,'(1X,A,4I4)')'SYMMETRY BLOCK:',ISYP,ISYQ,ISYR,ISYS
            CALL ABEND()
          END IF
          DO IT=1,NOP
            DO IU=1,IT
              IF(IT.LE.NIP .AND. IT.EQ.IU) THEN
                CALL DDAFILE(LUINTM,2,BUF,NB3,IDISK1)
C ADD 2* BUFFER INTO CORRECT POSITION OF  FIMO.
                CALL DAXPY_(NB3,2.0D00,BUF,1,FIMO(IFSTA),1)
              ELSE IF(IT.GT.NIP .AND. IT.LE.NOP .AND.
     &                IU.GT.NIP .AND. IU.LE.NOP) THEN
                ITABS=NAESP+(IT-NIP)
                IUABS=NAESP+(IU-NIP)
                ITU=(ITABS*(ITABS-1))/2 + IUABS
                DTU=DREF(ITU)
                IF(IT.EQ.IU) DTU=0.5D0*DTU
                CALL DDAFILE(LUINTM,2,BUF,NB3,IDISK1)
                CALL DAXPY_(NB3,2.0D0*DTU,BUF,1,FAMO(IFSTA),1)
              ELSE
                CALL DDAFILE(LUINTM,0,BUF,NB3,IDISK1)
              END IF
            END DO
          END DO
 110      CONTINUE
        END DO
        IFSTA=IFSTA+NB3
 120    CONTINUE
      END DO

      IFSTA=1
      DO ISYR=1,NSYM
        NBR=NORB(ISYR)
        IF(NBR.EQ.0) GOTO 220
        NB3=(NBR**2+NBR)/2
        NBNB=NBR**2
        ISYS=ISYR
        IS3RS=(ISYR**2+ISYR)/2
        DO ISYP=1,NSYM
          NIP=NISH(ISYP)
          NOP=NOSH(ISYP)
          NAESP=NAES(ISYP)
          IF(NOP.EQ.0) GOTO 210
          ISYQ=ISYP
          IS3PQ=(ISYP*(ISYP+1))/2
          ISADDR=IS3RS+NDIM2M*(IS3PQ-1)
          IDISK2=IAD2M(2,ISADDR)
          IF(IDISK2.EQ.0) THEN
            WRITE(6,*)' FMAT: EXCH-1  INTEGRAL BUFFER MISSING!'
            WRITE(6,'(1X,A,4I4)')'SYMMETRY BLOCK:',ISYP,ISYQ,ISYR,ISYS
            CALL ABEND()
          END IF
          DO IT=1,NOP
            DO IU=1,IT
              IF(IT.LE.NIP .AND. IT.EQ.IU) THEN
                CALL DDAFILE(LUINTM,2,BUF,NBNB,IDISK2)
                CALL TRIANG(NBR,BUF)
C ADD -1* BUFFER INTO CORRECT POSITION OF  FIMO.
                CALL DAXPY_(NB3,-1.0D00,BUF,1,FIMO(IFSTA),1)
              ELSE IF(IT.GT.NIP .AND. IT.LE.NOP .AND.
     &                IU.GT.NIP .AND. IU.LE.NOP) THEN
                ITABS=NAESP+(IT-NIP)
                IUABS=NAESP+(IU-NIP)
                ITU=(ITABS*(ITABS-1))/2 + IUABS
                DTU=DREF(ITU)
                IF(IT.EQ.IU) DTU=0.5D0*DTU
                CALL DDAFILE(LUINTM,2,BUF,NBNB,IDISK2)
                CALL TRIANG(NBR,BUF)
                CALL DAXPY_(NB3,-DTU,BUF,1,FAMO(IFSTA),1)
              ELSE
                CALL DDAFILE(LUINTM,0,BUF,NBNB,IDISK2)
              END IF
            END DO
          END DO
 210      CONTINUE
        END DO
        IFSTA=IFSTA+NB3
 220    CONTINUE
      END DO


      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Pseudo(ai,xi,yi,zi,lit,
     &                  aj,xj,yj,zj,ljt,gout,intmax,lmn1u,
     &                  ccr,zcr,nkcrl,nkcru,lcr,ncr,xc,yc,zc,npot)
************************************************************************
c This collection of subroutines, adapted from the ARGOS suite of programs,
c calculates integrals of an atomic semi-local one-component (i.e., non-
c relativistic or scalar-relativistic) pseudopotential (PP) between two shells
c of primitive cartesian GTOs. The integrals are contained in field gout(*).
c lmn1u is the maximum l value + 1 of the basis functions
c lproju is the maximum l value + 1 of the pseudopotential
c GTO parameters
c
c The GTOs are given by Ni (x-xi)^li (y-yi)^mi (z-zi)^ni exp(-ai(r-ri)^2)
c and Nj (x-xj)^lj (y-yj)^mj (z-zj)^nj exp(-aj(r-rj)^2). The Ni, Nj are
c chosen such that the integrals are normalized to (2l-1)!!(2m-1)!!(2n-1)!!.
c Input data are
c ai, aj : exponents
c xi,yi,zi, xj,yj,zj : centers
c lit = li+mi+ni+1, ljt = lj+mj+nj+1 : angular-momentum values + 1
c PP parameters
c
c The pseudopotential is of the form V_loc + sum_l V_l P_l, where V_loc and the V_l
c are radial potentials and P_l is the projector onto angular-momentum l.
c Both V_loc and the V_l are given by expansions of the form
c V = sum_i ccr(i) ( r^(ncr(i)-2) exp(-zcr(i)*r^2) ),
c where r is the distance from the PP center (xc, yc, zc).
c The PP parameters are assumed to be taken from a list of PPs for several atoms
c containing the following input data:
c npot : number of radial potentials in the list
c ccr(i) : coefficients
c ncr(i), zcr(i) : exponential parameters
c nkcrl(1,k) : lower index i for V_loc at nucleus k
c nkcru(1,k) : upper index i for V_loc at nucleus k
c nkcrl(l+2,k) : lower index i for V_l at nucleus k
c nkcru(l+2,k) : upper index i for V_l at nucleus k
c lcr(k) : maximum l value + 1 of the PP at nucleus k
c k=kcrs : specifies the PP for which integrals are calculated
c xc,yc,zc : position of nucleus kcrs
c
************************************************************************
      implicit real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      parameter(lproju=9)
      parameter (imax=100,kcrs=1)
cAOM      parameter(iptmax=100000)
      parameter(facij=5.56832799683170784522d0)
      real*8 gout(2*intmax)
      Real*8 ccr(npot),zcr(npot), crda(lproju,3), crdb(lproju,3)
      Integer nkcrl(lproju+1,kcrs),nkcru(lproju+1,kcrs),lcr(kcrs),
     &        ncr(imax)
*
cAOM      dimension ipt(55),a(iptmax)
      dimension ipt(55)
*
C     Write (*,*) 'ncr',(ncr(i),i=1,npot)
C     Write (*,*) 'zcr',(zcr(i),i=1,npot)
C     Write (*,*) 'ccr',(ccr(i),i=1,npot)
C     Write (*,*) 'nkcrl',(nkcrl(i,1),i=1,lcr(1)+1)
C     Write (*,*) 'nkcru',(nkcru(i,1),i=1,lcr(1)+1)
C     Write (*,*)
*                                                                      *
************************************************************************
*                                                                      *
* precalculation of tables for PP integrals
* iptmax is the dimension of the work space
*
      ipt(1) = 1
      lmnvmx = (lmn1u*(lmn1u + 1)*(lmn1u + 2))/6
      ipt(9) = ipt(1) +  3*lmnvmx
      ipt(10) = ipt(9) + 35
      ipt(11) = ipt(10) + 35
      ncru = 0
      do  1 i=1,npot
        ncru=max(ncru,ncr(i))
  1   continue
      ndfac = max(4*lmn1u+2*lproju-3,6*lproju+3,4*lmn1u-1,
     &    2*lmn1u+2*lproju+1,4,ncru+4*lmn1u+2*lproju-1)
      ipt(12) = ipt(11) +  ndfac
      ipt(13) = ipt(12) +  (lmn1u*(lmn1u+1))/2
      lmax =  max(1,lmn1u-1 + max(lmn1u-1,lproju))
      l1max2 = (lmax+1)**2
      ipt(14) = ipt(13) +  l1max2
      ipt(15) = ipt(14) +  l1max2
      lmnpwr = (((lmax*(lmax+2)*(lmax+4))/3)*(lmax+3)+
     &    (lmax+2)**2*(lmax+4))/16
      ipt(16) = ipt(15) +  lmnpwr
      ipt(17) = ipt(16) +  lmnpwr
      ipt(18) = ipt(17) +  lmnpwr
      ipt(19) = ipt(18) +  lmnpwr
      ipt(20) = ipt(19) +  3*lproju**2
      l2m1 = 2*lproju-1
      ipt(21) = ipt(20) +  3*l2m1
      ipt(31) = ipt(21) +  3*l2m1
cAOM      if ( ipt(31) .gt. iptmax ) stop 'work space too small'
      ltot1 = lit + ljt - 1
      ltot12 = ltot1**2
      ipt(33) = ipt(31) +  ltot12
      ipt(34) = ipt(33) +  ltot12
      ipt(35) = ipt(34) +  ltot1
      ipt(36) = ipt(35) +  ltot1
      ipt(37) = ipt(36) +  ltot1
cAOM      if ( ipt(37) .gt. iptmax ) stop 'work space too small'
      mproju = 2*lproju+1
      lamau = lit+lproju
      ipt(38) = ipt(37) +  lit*mproju*lamau
      lambu = ljt+lproju
      ipt(39) = ipt(38) +  ljt*mproju*lambu
      ipt(40) = ipt(39) +  ltot1*lambu*lamau
      ipt(41) = ipt(40) +  ljt
      ipt(42) = ipt(41) +  ljt
      ipt(43) = ipt(42) +  ljt
      ipt(44) = ipt(43) +  ljt
      ipt(45) = ipt(44) +  lit
      ipt(46) = ipt(45) +  lit
      ipt(47) = ipt(46) +  ltot1+lproju
      ipt(48) = ipt(47) +  lamau
      ipt(49) = ipt(48) +  lambu
      ipt(50) = ipt(49) +  ltot1
cAOM      ipt(51) = ipt(50) +  lambu*lamau
      lWork = ipt(50) +  lambu*lamau

cAOM      if ( ipt(51) .gt. iptmax ) stop 'work space too small'
      Call GetMem('Wrk','Allo','Real',mWrk,lWork)
      Do I=1,50
        ipt(i)=ipt(i)+mWrk-1
      Enddo
      ipt1=ip_of_iWork_d(Work(ipt(1)))
      call lmnvgn_molcas(lmn1u,iWork(ipt1))
      eps = 1.0d-12
      ipt1=ip_of_iWork_d(Work(ipt(1)))
      ipt13=ip_of_iWork_d(Work(ipt(13)))
      ipt14=ip_of_iWork_d(Work(ipt(14)))
      ipt15=ip_of_iWork_d(Work(ipt(15)))
      ipt16=ip_of_iWork_d(Work(ipt(16)))
      ipt17=ip_of_iWork_d(Work(ipt(17)))
      ipt20=ip_of_iWork_d(Work(ipt(20)))
      ipt21=ip_of_iWork_d(Work(ipt(21)))
      call cortab_molcas(Work(ipt(12)),Work(ipt(11)),eps,Work(ipt(19)),
     &      Work(ipt(9)),Work(ipt(10)),iWork(ipt13),iWork(ipt14),
     &      iWork(ipt15),iWork(ipt16),iWork(ipt17),lmax,lmn1u,lproju,
     &      iWork(ipt20),iWork(ipt21),ndfac,Work(ipt(18)))
*                                                                      *
************************************************************************
*                                                                      *
*     integrals for V_loc part of PP
*
      lproju1=lproju+1
      call pseud1_molcas(Work,Work(ipt(31)),ccr,gout,ipt,
     &        iWork(ipt1),ltot1,ncr,nkcrl,nkcru,Work(ipt(33)),
     &        Work(ipt(34)),Work(ipt(35)),Work(ipt(36)),zcr,lit,ljt,
     &        ai,aj,xi,yi,zi,xj,yj,zj,xc,yc,zc,kcrs,lproju1,crda,crdb)
*                                                                      *
************************************************************************
*                                                                      *
*     integrals for V_l P_l parts of PP
*
      lcru=lcr(kcrs)
      call pseud2_molcas(Work,Work(ipt(37)),Work(ipt(38)),ccr,
     &        gout,ipt,lambu,ltot1,mproju,ncr,nkcrl,nkcru,Work(ipt(39)),
     &        zcr,lit,ljt,ai,aj,xi,yi,zi,xj,yj,zj,xc,yc,zc,
     &        kcrs,lcru,lproju1,crda,crdb)
      Call GetMem('Wrk','Free','Real',mWrk,lWork)
*                                                                      *
************************************************************************
*                                                                      *
*     final results with normalization factors
*
*     faci=sqrt( (4.D0*ai)**lit/2.D0*sqrt(2.D0*ai) )
*    &   /  ( (4.D0*ai)**((lit-1)/2.D0) * (Two*ai/Pi)**(Three/Four) )
*     facj=sqrt( (4.D0*aj)**ljt/2.D0*sqrt(2.D0*aj) )
*    &   /  ( (4.D0*aj)**((ljt-1)/2.D0) * (Two*aj/Pi)**(Three/Four) )
*     facij=faci*facj
      litot=lit*(lit+1)/2
      ljtot=ljt*(ljt+1)/2
*
      Call DScal_(litot*ljtot,facij,gout,1)
*
*     Do  i=1,litot
*        Do  j=1,ljtot
*          gout(i+(j-1)*litot) = gout(i+(j-1)*litot)*facij
*        End Do
*     End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Reorder integrals from Argos to Molcas order
*
      Call Molcas_Order(GOut,litot,ljtot)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SupSym(FrcCrt,nsAtom,Coor,nSupSy,Idntcl,iAtom)
!***********************************************************************
!                                                                      *
!     Object: To constrain forces to higher symmetry.                  *
!                                                                      *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nsAtom, nSupSy, Idntcl(nSupSy), iAtom(nsAtom)
real(kind=wp), intent(inout) :: FrcCrt(3,nsAtom)
real(kind=wp), intent(in) :: Coor(3,nsAtom)
integer(kind=iwp) :: I, ICEN, IDIV, J, K
real(kind=wp) :: cMass(3), E(3), FORCE, PROJ
integer(kind=iwp), external :: iDeg
real(kind=wp), external :: DDot_

call CofMss(Coor,nsAtom,cMass)

! Loop over groups of centers which are identical.

K = 0
do I=1,nSupSy
  FORCE = Zero

  ! loop over centers which are identical.

  IDIV = 0
  do J=1,Idntcl(I)
    K = K+1
    ! Get the number of this center
    ICEN = iAtom(K)

    ! Get an unit vector in the direction from center of mass to
    ! the ICEN'th center.

    E(:) = Coor(:,ICEN)-cMass(:)
    ! Normalize the vector.
    E(:) = E(:)/sqrt(sum(E(:)**2))

    ! Project the force of the ICEN'th center on this unit vector

    PROJ = DDot_(3,E,1,FrcCrt(1,ICEN),1)

    ! Sum forces which should be equal
    FORCE = FORCE+PROJ*real(iDeg(Coor(1,iCen)),kind=wp)
    IDIV = IDIV+iDeg(Coor(1,iCen))

    ! Save the unit vector of the new force of this center

    FrcCrt(:,ICEN) = E(:)
  end do

  ! Get the new force
  FORCE = FORCE/real(IDIV,kind=wp)
  K = K-Idntcl(I)

  ! Symmetrize the forces

  do J=1,Idntcl(I)
    K = K+1
    ICEN = iAtom(K)

    FrcCrt(:,ICEN) = FrcCrt(:,ICEN)*FORCE
  end do
end do

end subroutine SupSym

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
*               Ajitha Devarajan                                       *
************************************************************************
      Subroutine LYP_OFE(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                   Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object:  Lyp Functional(Formula taken from Molpro Manual)            *
*                                                                      *
*      Author: Per-AAke Malmquist,Department of Theoretical Chemistry  *
*              University of LUnd, SWEDEN                              *
*              D. Ajitha , Department of Theoretical Chemistry         *
*              University of Lund, SWEDEN                              *
*              Modify Per-AAke's code for open shell case              *
*              and adopt for closed shell case                         *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 dF_dRho(ndF_dRho,mGrid),Rho(nRho,mGrid),F_xc(mGrid)
*
      dimension ec(0:4)
      data Cfconst / 2.8712340001881918D0 /
      data aconst,bconst,cconst,dconst
     &        /0.04918d0,0.132d0,0.2533d0,0.349d0/
* Constants aconst,..,dconst are from ???
* Cfconst is = (3/10)*(3*Pi**2)**(2/3)
      Cfconst2=Cfconst*2.0D0**(11.0D0/3.D0)
      Rho_Min=T_X*1.0D-2
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=1
*
************************************************************************

      If (iSpin.eq.1) Then
*                                                                      *
************************************************************************
*                                                                      *
      Do iGrid = 1, mGrid
*
      rhoa=Rho(ipR,iGrid)
      rhob=rhoa
      rho_tot=rhoa+rhob
      if(rho_tot.lt.T_X) Go To 101

      gxa=Rho(ipdRx,iGrid)
      gya=Rho(ipdRy,iGrid)
      gza=Rho(ipdRz,iGrid)
      gxb=gxa
      gyb=gya
      gzb=gza

* New LYP code.
      gx=gxa+gxb
      gy=gya+gyb
      gz=gza+gzb

      rho3=rho_tot**(-1.0D0/3.D0)
      crho3=cconst*rho3
      R=1.D0/(1.D0+dconst*rho3)
      if(crho3.lt.709.0d0) then
        expcr=exp(-crho3)
      else
        expcr=0.0D0
      end if
      omega=expcr*R*rho_tot**(-11.0D0/3.D0)
      delta=crho3+1.D0-R
      dlogodr=(delta-11.D0)/(3.D0*rho_tot)
      ddeltadr=-(crho3+R*(1.D0-R))/(3.D0*rho_tot)
      p=aconst*bconst*omega

      ec1=-(4.D0*aconst*R)*rhoa*(rhob/rho_tot)


      dec1dra=(ec1*(1.D0-R)/(3.D0*rho_tot))
     &       -(4.D0*aconst*R)*(rhob/rho_tot)**2
      dec1drb=(ec1*(1.D0-R)/(3.D0*rho_tot))
     &       -(4.D0*aconst*R)*(rhoa/rho_tot)**2
      tmp1=-Cfconst2*p*rhoa**(11.0D0/3.D0)*rhob
      tmp2=-Cfconst2*p*rhob**(11.0D0/3.D0)*rhoa
      ec2=tmp1+tmp2
      dec2dra=(ec2*dlogodr)+(11.D0*tmp1+3.D0*tmp2)/(3.D0*rhoa)
      dec2drb=(ec2*dlogodr)+(3.D0*tmp1+11.D0*tmp2)/(3.D0*rhob)
      sa=gxa**2+gya**2+gza**2
      sb=sa
      s =4.D0*sa
      pp=-p*rhoa*rhob/(18.D0*rho_tot)
      dppdra=((dlogodr-1.D0/rho_tot)+1.D0/rhoa)*pp
      dppdrb=((dlogodr-1.D0/rho_tot)+1.D0/rhob)*pp
      dqq1ds =47.D0*rho_tot
      dqq1dsa=22.D0*rhoa-45.D0*rho_tot
      dqq1dsb=22.D0*rhob-45.D0*rho_tot
      dqq2ds =-7.D0*rho_tot
      dqq2dsa= rhob-rhoa
      dqq2dsb= rhoa-rhob
      dqqds =dqq1ds +delta*dqq2ds
      dqqdsa=dqq1dsa+delta*dqq2dsa
      dqqdsb=dqq1dsb+delta*dqq2dsb
      dqq1dra=47.D0*s-23.D0*sa-45.D0*sb
      dqq1drb=47.D0*s-45.D0*sa-23.D0*sb
      qq1=dqq1dra*rhoa+dqq1drb*rhob
      dqq2dra=-7.D0*s -sa +sb
      dqq2drb=-7.D0*s +sa -sb
      qq2=dqq2dra*rhoa+dqq2drb*rhob
      dqqdra=dqq1dra+dqq2dra*delta+qq2*ddeltadr
      dqqdrb=dqq1drb+dqq2drb*delta+qq2*ddeltadr
      qq=qq1+qq2*delta
      ec3=pp*qq
      dec3dra=dppdra*qq+pp*dqqdra
      dec3drb=dppdrb*qq+pp*dqqdrb
      dec3ds =pp*dqqds
      dec3dsa=pp*dqqdsa
      dec3dsb=pp*dqqdsb

      dqdra=((4.0D0/3.D0)*rho_tot*(s-sa-sb))+2.D0*rhoa*sb
      dqdrb=((4.0D0/3.D0)*rho_tot*(s-sa-sb))+2.D0*rhob*sa
      q=(dqdra*rhoa+dqdrb*rhob)/2.D0
      ec4=p*q
      dec4dra=dlogodr*ec4+p*dqdra
      dec4drb=dlogodr*ec4+p*dqdrb
      dec4ds =p*(2.0D0/3.D0)*(rho_tot**2)
      dec4dsa=p*(rhob**2)-dec4ds
      dec4dsb=p*(rhoa**2)-dec4ds

      dec34ds =dec3ds +dec4ds
      dec34dsa=dec3dsa+dec4dsa
      dec34dsb=dec3dsb+dec4dsb

      ec(0)=ec1+ec2+ec3+ec4
      ec(1)=ec1
      ec(2)=ec2
      ec(3)=ec3
      ec(4)=ec4

      Functional= ec1+ec2+ec3+ec4
      F_xc(iGrid)=F_xc(iGrid)+functional
*                                                                      *
************************************************************************
*                                                                      *
*      dF/dRho
       dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)
     &                   +Coeff*(dec1dra+dec2dra+dec3dra+dec4dra)
*      dF/dGaa
       dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)
     &                     +Coeff*(dec34dsa+dec34ds)
*      dF/dGab
       dF_dRho(ipGxy,iGrid)=dF_dRho(ipGxy,iGrid)+2.0d0*Coeff*(dec34ds)
101   Continue
      End Do

*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=/= 1
      Else
*                                                                      *
************************************************************************
*                                                                      *
*
      Do iGrid = 1, mGrid
      rhoa=Max(Rho_min,Rho(ipRa,iGrid))
      rhob=Max(Rho_min,Rho(ipRb,iGrid))
      rho_tot=rhoa+rhob
      if(rho_tot.lt.T_X) Go To 201
      gxa=Rho(ipdRxa,iGrid)
      gya=Rho(ipdRya,iGrid)
      gza=Rho(ipdRza,iGrid)
      gxb=Rho(ipdRxb,iGrid)
      gyb=Rho(ipdRyb,iGrid)
      gzb=Rho(ipdRzb,iGrid)

      gx=gxa+gxb
      gy=gya+gyb
      gz=gza+gzb

      rho3=rho_tot**(-1.0D0/3.D0)
      crho3=cconst*rho3
      R=1.D0/(1.D0+dconst*rho3)
      if(crho3.lt.709.0d0) then
        expcr=exp(-crho3)
      else
        expcr=0.0D0
      end if
      omega=expcr*R*rho_tot**(-11.0D0/3.D0)
      delta=crho3+1.D0-R
      dlogodr=(delta-11.D0)/(3.D0*rho_tot)
      ddeltadr=-(crho3+R*(1.D0-R))/(3.D0*rho_tot)
      p=aconst*bconst*omega

      ec1=-(4.D0*aconst*R)*rhoa*(rhob/rho_tot)

      dec1dra=(ec1*(1.D0-R)/(3.D0*rho_tot))
     &       -(4.D0*aconst*R)*(rhob/rho_tot)**2
      dec1drb=(ec1*(1.D0-R)/(3.D0*rho_tot))
     &       -(4.D0*aconst*R)*(rhoa/rho_tot)**2

      tmp1=-Cfconst2*p*rhoa**(11.0D0/3.D0)*rhob
      tmp2=-Cfconst2*p*rhob**(11.0D0/3.D0)*rhoa
      ec2=tmp1+tmp2
      dec2dra=(ec2*dlogodr)+(11.D0*tmp1+3.D0*tmp2)
     &       /(3.D0*Max(rhoa,0.5D-50))
      dec2drb=(ec2*dlogodr)+(3.D0*tmp1+11.D0*tmp2)
     &       /(3.D0*Max(rhob,0.5D-50))

      sa=gxa**2+gya**2+gza**2
      sb=gxb**2+gyb**2+gzb**2
      s =gx**2+gy**2+gz**2
      pp=-p*rhoa*rhob/(18.D0*rho_tot)
      dppdra=((dlogodr-1.D0/rho_tot)+1.D0/Max(rhoa,0.5D-50))*pp
      dppdrb=((dlogodr-1.D0/rho_tot)+1.D0/Max(rhob,0.5D-50))*pp
      dqq1ds =47.D0*rho_tot
      dqq1dsa=22.D0*rhoa-45.D0*rho_tot
      dqq1dsb=22.D0*rhob-45.D0*rho_tot
      dqq2ds =-7.D0*rho_tot
      dqq2dsa= rhob-rhoa
      dqq2dsb= rhoa-rhob
      dqqds =dqq1ds +delta*dqq2ds
      dqqdsa=dqq1dsa+delta*dqq2dsa
      dqqdsb=dqq1dsb+delta*dqq2dsb
      dqq1dra=47.D0*s-23.D0*sa-45.D0*sb
      dqq1drb=47.D0*s-45.D0*sa-23.D0*sb
      qq1=dqq1dra*rhoa+dqq1drb*rhob
      dqq2dra=-7.D0*s -sa +sb
      dqq2drb=-7.D0*s +sa -sb
      qq2=dqq2dra*rhoa+dqq2drb*rhob
      dqqdra=dqq1dra+dqq2dra*delta+qq2*ddeltadr
      dqqdrb=dqq1drb+dqq2drb*delta+qq2*ddeltadr
      qq=qq1+qq2*delta
      ec3=pp*qq
      dec3dra=dppdra*qq+pp*dqqdra
      dec3drb=dppdrb*qq+pp*dqqdrb
      dec3ds =pp*dqqds
      dec3dsa=pp*dqqdsa
      dec3dsb=pp*dqqdsb

      dqdra=((4.0D0/3.D0)*rho_tot*(s-sa-sb))+2.D0*rhoa*sb
      dqdrb=((4.0D0/3.D0)*rho_tot*(s-sa-sb))+2.D0*rhob*sa
      q=(dqdra*rhoa+dqdrb*rhob)/2.D0
      ec4=p*q
      dec4dra=dlogodr*ec4+p*dqdra
      dec4drb=dlogodr*ec4+p*dqdrb
      dec4ds =p*(2.0D0/3.D0)*(rho_tot**2)
      dec4dsa=p*(rhob**2)-dec4ds
      dec4dsb=p*(rhoa**2)-dec4ds

      dec34ds =dec3ds +dec4ds
      dec34dsa=dec3dsa+dec4dsa
      dec34dsb=dec3dsb+dec4dsb

      ec(0)=ec1+ec2+ec3+ec4
      ec(1)=ec1
      ec(2)=ec2
      ec(3)=ec3
      ec(4)=ec4

      Functional= ec1+ec2+ec3+ec4
      F_xc(iGrid)=F_xc(iGrid)+functional
*                                                                      *
************************************************************************
*                                                                      *
*       dF/dRhoa, dF/dRhob
        dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)
     &                   +Coeff*(dec1dra+dec2dra+dec3dra+dec4dra)
        dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)
     &                   +Coeff*(dec1drb+dec2drb+dec3drb+dec4drb)
*       dF/dGaa, dF/dGab, and dF/dGbb
        dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)
     &                      +Coeff*(dec34dsa+dec34ds)
        dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)
     &                      +Coeff*(dec34dsb+dec34ds)
        dF_dRho(ipGab,iGrid)=dF_dRho(ipGab,iGrid)+2.0d0*Coeff*dec34ds
201   Continue
      End Do
      Endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function tstfile_cvb(fileid)

use casvb_global, only: ifilio, filename
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: tstfile_cvb
real(kind=wp), intent(in) :: fileid
integer(kind=iwp) :: ibf
logical(kind=iwp) :: ex

if (fileid < 1.0e-2_wp) then
  tstfile_cvb = .false.
  return
end if
call mkfn_cvb(fileid,ibf)
if (ifilio(ibf) == 0) then
  call f_inquire(filename(ibf),ex)
  tstfile_cvb = ex
else
  tstfile_cvb = .true.
end if

return

end function tstfile_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Eq_Solver(Mode,M,N,NRHS,B,Curvilinear,Degen,dSS,DFC)
      Implicit Real*8 (a-h,o-z)
************************************************************************
#include "real.fh"
#include "stdalloc.fh"
#include "warnings.h"
      Real*8 B(M,*),Degen(M),dSS(*),DFC(*)
      Logical Curvilinear
      Character(LEN=1) Mode
      Integer INFO
      Real*8 Temp(1)
      Real*8, Allocatable:: A(:), Btmp(:), Work(:)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*     Solve the equation Ax=b
*
      LDA=M
      LDB=Max(1,M,N)
      If (Mode.eq.'T') Then
         Call mma_allocate(A,M*M,Label='A')
         A(:)=Zero
         call dcopy_(M*N,B,1,A,1)
         If (.NOT.Curvilinear) Then
            Do i = 1, M
               Call DScal_(M,Sqrt(Degen(i)),A(i),M)
            End Do
         End If
#ifdef _DEBUGPRINT_
         Call RecPrt('A',' ',A,M,M)
#endif
      Else
         Call mma_allocate(A,M*N,Label='A')
         call dcopy_(M*N,B,1,A,1)
         If (.NOT.Curvilinear) Then
            Do i = 1, M
               Call DScal_(N,Sqrt(Degen(i)),A(i),M)
            End Do
         End If
#ifdef _DEBUGPRINT_
         Call RecPrt('A',' ',A,M,N)
#endif
      End If
*
      Call mma_allocate(Btmp,LDB*NRHS,Label='Btmp')
      Btmp(:)=Zero
*
      jpB=1
      If (Mode.eq.'T') Then
         Do iRHS = 1, nRHS
            ij = (iRHS-1)*N + 1
            call dcopy_(N,dss(ij),1,Btmp(jpB),1)
            jpB=jpB+LDB
         End Do
      Else
#ifdef _DEBUGPRINT_
         Call RecPrt('B(raw)',' ',dss,M,nRHS)
#endif
         Do iRHS = 1, nRHS
            If (.Not.Curvilinear) Then
               Do i = 0, M-1
                  ij = (iRHS-1)*M + i+1
                  Btmp(jpB+i) = dss(ij)*Sqrt(Degen(i+1))
               End Do
            Else
               ij = (iRHS-1)*M + 1
               call dcopy_(M,dss(ij),1,Btmp(jpB),1)
            End If
            jpB=jpB+LDB
         End Do
      End If
#ifdef _DEBUGPRINT_
      Call RecPrt('B(in)',' ',Btmp,LDB,NRHS)
#endif
*
      LWork=-1
      INFO=0
      call dgels_(Mode,M,N,NRHS,A,LDA,Btmp,LDB,Temp,LWork,INFO)
      LWork=INT(Temp(1))
      Call mma_allocate(Work,LWork,Label='Work')
      INFO=0
      call dgels_(Mode,M,N,NRHS,A,LDA,Btmp,LDB,Work,LWork,INFO)
      If (INFO.gt.0) Then
         Call WarningMessage(2,'Error in Eq_Solver')
         Write (6,*)
         Write (6,*) '***********************************************'
         Write (6,*) ' ERROR: Eq_Solver could not find a solution.   '
         Write (6,*) ' The matrix is rank deficient.                 '
         Write (6,*) '***********************************************'
         Call Quit(_RC_INTERNAL_ERROR_)
      End If
*
#ifdef _DEBUGPRINT_
      Call RecPrt('B(out)',' ',Btmp,LDB,NRHS)
#endif
      jpB=1
      If (Mode.eq.'T') Then
         Do iRHS = 1, nRHS
            If (.Not.Curvilinear) Then
               Do i = 0, M-1
                  Btmp(jpB+i) = Btmp(jpB+i)/Sqrt(Degen(i+1))
               End Do
            End If
            ij = (iRHS-1)*M + 1
            call dcopy_(M,Btmp(jpB),1,DFC(ij),1)
            jpB=jpB+LDB
         End Do
      Else
         Do iRHS = 1, nRHS
            ij = (iRHS-1)*N + 1
            call dcopy_(N,Btmp(jpB),1,DFC(ij),1)
            jpB=jpB+LDB
         End Do
      End If
*
      Call mma_deallocate(Work)
      Call mma_deallocate(Btmp)
      Call mma_deallocate(A)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000,2021, Roland Lindh                                *
!***********************************************************************

subroutine Mk_Rho(list_s,nlist_s,Fact,mdc,list_bas,Indx,nIndex,Do_Grad)
!***********************************************************************
!      Author:Roland Lindh, Department of Chemical Physics, University *
!             of Lund, SWEDEN.  2000                                   *
!***********************************************************************

use iSD_data, only: iSD
use k2_arrays, only: DeDe, ipDijS
use nq_Grid, only: Dens_AO, dRho_dR, GradRho, Grid_AO, iBfn_Index, kAO, Lapl, List_G, Rho, TabAO, TabAO_Short, Tau
use nq_Info, only: Functional_type, GGA_Type, LDA_Type, meta_GGA_Type1, meta_GGA_Type2
#ifdef _DEBUGPRINT_
use nq_Grid, only: nRho
#endif
use Index_Functions, only: iTri
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nlist_s, list_s(2,nlist_s), mdc, list_bas(2,nlist_s), nIndex, Indx(nIndex)
real(kind=wp), intent(in) :: Fact(mdc,mdc)
logical(kind=iwp), intent(in) :: Do_Grad
integer(kind=iwp) :: i1, i2, i_R, iAO, iBas, iBas_Eff, iBfn, iCar, iCB, iCmp, iD, idjx, idjx2, idjy, idjy2, idjz, idjz2, iDx, &
                     idx2, iDy, idy2, iDz, idz2, iER, iGrid, ij_D, ijS, iL, ilist_s, Ind_xyz, index_i, index_j, ip_D_a, ip_D_b, &
                     ip_Tmp, ipD(2), ipDDij, ipDij, ipDSij, iShell, iSkal, iT, ix, iy, iz, j, j1, j2, j_R, jBas, jBas_Eff, jBfn, &
                     jCB, jCmp, jlist_s, jShell, jSkal, kDCRE, kDCRR, lDCRER, mAO, mdci, mdcj, mDCRij, mDij, mGrid, nAO, nBfn, nD, &
                     nFunc_i, nFunc_j
real(kind=wp) :: DAij, Factor
integer(kind=iwp), parameter :: Index_d2(3,3) = reshape([5,6,7,6,8,9,7,9,10],[3,3]), &
                                Index_d3(3,3) = reshape([11,14,16,12,17,19,13,18,20],[3,3])
integer(kind=iwp), allocatable :: Ind_Grd(:,:)
integer(kind=iwp), external :: NrOpr

!                                                                      *
!***********************************************************************
!                                                                      *
nD = size(Dens_AO,3)
nAO = size(Dens_AO,1)
Dens_AO(:,:,:) = Zero
mAO = size(TabAO,1)
mGrid = size(TabAO,2)

!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
write(u6,*) 'mAO=',mAO
write(u6,*) 'mGrid=',mGrid
write(u6,*) 'nlist_s=',nlist_s
call RecPrt('Rho: TabAO',' ',TabAO,mAO*mGrid,nAO)
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     Generate the one-particle density matrix, D(mu,nu)               *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *

if (Do_Grad) then
  call mma_Allocate(Ind_Grd,3,nAO,Label='Ind_Grd')
  Ind_Grd(:,:) = 0
end if

nBfn = size(iBfn_Index,2)
if (nBfn /= nAO) then
  write(u6,*) 'mk_Rho: internal error!'
  call Abend()
end if
Factor = real(2/nD,kind=wp)
do iBfn=1,nBfn
  ilist_s = iBfn_Index(2,iBfn)
  i1 = iBfn_Index(3,iBfn)
  i2 = iBfn_Index(4,iBfn)
  iSkal = list_s(1,ilist_s)
  kDCRE = list_s(2,ilist_s)
  iCmp = iSD(2,iSkal)
  iBas = iSD(3,iSkal)
  mdci = iSD(10,iSkal)
  iShell = iSD(11,iSkal)
  iBas_Eff = list_bas(1,ilist_s)
  index_i = list_bas(2,ilist_s)
  nFunc_i = iBas*iCmp

  i_R = (i1-1)*iBas_Eff+i2
  iCB = Indx(index_i-1+i_R)

  if (Do_Grad) Ind_Grd(:,iBfn) = List_g(:,ilist_s)

  do jBfn=1,iBfn
    jlist_s = iBfn_Index(2,jBfn)
    j1 = iBfn_Index(3,jBfn)
    j2 = iBfn_Index(4,jBfn)
    jSkal = list_s(1,jlist_s)
    kDCRR = list_s(2,jlist_s)
    jCmp = iSD(2,jSkal)
    jBas = iSD(3,jSkal)
    mdcj = iSD(10,jSkal)
    jShell = iSD(11,jSkal)
    jBas_Eff = list_bas(1,jlist_s)
    index_j = list_bas(2,jlist_s)
    nFunc_j = jBas*jCmp

    j_R = (j1-1)*jBas_Eff+j2
    jCB = Indx(index_j-1+j_R)

    ijS = iTri(iShell,jShell)
    ip_Tmp = ipDijs
    call Dens_Info(ijS,ipDij,ipDSij,mDCRij,ipDDij,ip_Tmp,nD)

    iER = ieor(kDCRE,kDCRR)
    lDCRER = NrOpr(iER)

    mDij = nFunc_i*nFunc_j
    ip_D_a = ipDij+lDCRER*mDij
    ip_D_b = ip_D_a
    if (nD /= 1) ip_D_b = ipDSij+lDCRER*mDij
    ipD(1) = ip_D_a
    ipD(2) = ip_D_b

    ij_D = (jCB-1)*nFunc_i+iCB-1
    do iD=1,nD
      DAij = DeDe(ipD(iD)+ij_D)*Fact(mdci,mdcj)*Factor
      Dens_AO(iBfn,jBfn,iD) = DAij
      Dens_AO(jBfn,iBfn,iD) = DAij
    end do

  end do

end do
!                                                                      *
!***********************************************************************
!                                                                      *
!#define _ANALYSIS_
#ifdef _ANALYSIS_
Thr = 1.0e-15_wp
write(u6,*)
write(u6,*) ' Sparsity analysis of D(i,j)'
write(u6,*) ' Threshold: ',Thr
write(u6,*) ' Grid size: ',mGrid
write(u6,*) ' Dimension: ',n,' x ',n
n = size(Dens_AO,1)
n2 = n**2
do iD=1,nD
  m = 0
  do i=1,n
    do j=1,n
      if (abs(Dens_AO(i,j,iD)) < Thr) m = m+1
    end do
  end do
  write(u6,*) 'Total Sparsity in %',100.0_wp*real(m,kind=wp)/real(n2,kind=wp)
  k = 0
  do i=1,n
    m = 0
    do j=1,n
      if (abs(Dens_AO(i,j,iD)) < Thr) m = m+1
    end do
    if (m == n) k = k+1
  end do
  write(u6,*) 'Column Sparsity in %',100.0_wp*real(k,kind=wp)/real(n,kind=wp)
  k = 0
  do j=1,n
    m = 0
    do i=1,n
      if (abs(Dens_AO(i,j,iD)) < Thr) m = m+1
    end do
    if (m == n) k = k+1
  end do
  write(u6,*) 'Row Sparsity in %',100.0_wp*real(k,kind=wp)/real(n,kind=wp)
end do
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Construct: Sum_i D_ij TabAO(i,iGrid,iAO)
!      D_ij is the one-electron density
!      TabAO(i,iGrid,iAO) are values with respect to the ith AO
!      i=1 is the value of the AO
!      i=2-4 are the values of the first order derivatives
!      i=5-10 are the values of the second order derivatives
!      i=11-20 are the values of the third order derivatives
!
! During a gradient calculation the size of the fast index of
! TabAO is larger than that of Grid_AO. In those cases we copy
! the part of TabAO which we need to TabAO_Short before we make the
! contraction with the 1-particle density matrix.

if (Do_Grad) then
  TabAO_Short(1:kAO,1:mGrid,:) = TabAO(1:kAO,1:mGrid,:)
  call DGEMM_('N','N',kAO*mGrid,nAO*nD,nAO,One,TabAO_Short,kAO*mGrid,Dens_AO,nAO,Zero,Grid_AO,kAO*mGrid)
else
  call DGEMM_('N','N',kAO*mGrid,nAO*nD,nAO,One,TabAO,mAO*mGrid,Dens_AO,nAO,Zero,Grid_AO,kAO*mGrid)
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (allocated(dRho_dR)) dRho_dR(:,:,:) = Zero

select case (Functional_Type)
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  case (LDA_Type)
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    Rho(:,1:mGrid) = Zero
    do iD=1,nD
      do iAO=1,nAO

        do iGrid=1,mGrid
          Rho(iD,iGrid) = Rho(iD,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
        end do

        if (Do_Grad) then

          ! Loop over cartesian components

          do iCar=1,3

            Ind_xyz = Ind_Grd(iCar,iAO)
            j = iCar+1

            if (Ind_xyz /= 0) then
              do iGrid=1,mGrid

                ! Cartesian derivative of the density.

                dRho_dR(iD,iGrid,Ind_xyz) = dRho_dR(iD,iGrid,Ind_xyz)+Two*Grid_AO(1,iGrid,iAO,iD)*TabAO(j,iGrid,iAO)
              end do
            end if

          end do

        end if
      end do
    end do
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  case (GGA_Type)
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    Rho(:,1:mGrid) = Zero
    GradRho(:,1:mGrid) = Zero
    do iD=1,nD
      ix = (iD-1)*3+1
      iy = (iD-1)*3+2
      iz = (iD-1)*3+3
      do iAO=1,nAO

        do iGrid=1,mGrid
          Rho(iD,iGrid) = Rho(iD,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          GradRho(ix,iGrid) = GradRho(ix,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(2,iGrid,iAO)+ &
                              Grid_AO(2,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          GradRho(iy,iGrid) = GradRho(iy,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(3,iGrid,iAO)+ &
                              Grid_AO(3,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          GradRho(iz,iGrid) = GradRho(iz,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(4,iGrid,iAO)+ &
                              Grid_AO(4,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
        end do

        if (Do_Grad) then

          ! Loop over cartesian components

          do iCar=1,3

            Ind_xyz = Ind_Grd(iCar,iAO) ! index of  nuclear gradient

            j = iCar+1 ! index derivative of AO

            iDx = nD+(iD-1)*3+1 ! index of grad rho component
            iDy = iDx+1
            iDz = iDy+1

            idjx = Index_d2(1,iCar)
            idjy = Index_d2(2,iCar)
            idjz = Index_d2(3,iCar)
            if (Ind_xyz /= 0) then
              do iGrid=1,mGrid

                ! Cartesian derivative of rho

                dRho_dR(iD,iGrid,Ind_xyz) = dRho_dR(iD,iGrid,Ind_xyz)+Two*Grid_AO(1,iGrid,iAO,iD)*TabAO(j,iGrid,iAO)

                ! Cartesian derivatives of grad rho

                dRho_dR(iDx,iGrid,Ind_xyz) = dRho_dR(iDx,iGrid,Ind_xyz)+Two*TabAO(idjx,iGrid,iAO)*Grid_AO(1,iGrid,iAO,iD)+ &
                                             Two*TabAO(j,iGrid,iAO)*Grid_AO(2,iGrid,iAO,iD)
                dRho_dR(iDy,iGrid,Ind_xyz) = dRho_dR(iDy,iGrid,Ind_xyz)+Two*TabAO(idjy,iGrid,iAO)*Grid_AO(1,iGrid,iAO,iD)+ &
                                             Two*TabAO(j,iGrid,iAO)*Grid_AO(3,iGrid,iAO,iD)
                dRho_dR(iDz,iGrid,Ind_xyz) = dRho_dR(iDz,iGrid,Ind_xyz)+Two*TabAO(idjz,iGrid,iAO)*Grid_AO(1,iGrid,iAO,iD)+ &
                                             Two*TabAO(j,iGrid,iAO)*Grid_AO(4,iGrid,iAO,iD)
              end do
            end if

          end do
        end if

      end do
    end do
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  case (meta_GGA_Type1)
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    Rho(:,1:mGrid) = Zero
    GradRho(:,1:mGrid) = Zero
    Tau(:,1:mGrid) = Zero
    do iD=1,nD
      ix = (iD-1)*3+1
      iy = (iD-1)*3+2
      iz = (iD-1)*3+3
      do iAO=1,nAO

        do iGrid=1,mGrid
          Rho(iD,iGrid) = Rho(iD,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          GradRho(ix,iGrid) = GradRho(ix,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(2,iGrid,iAO)+ &
                              Grid_AO(2,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          GradRho(iy,iGrid) = GradRho(iy,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(3,iGrid,iAO)+ &
                              Grid_AO(3,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          GradRho(iz,iGrid) = GradRho(iz,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(4,iGrid,iAO)+ &
                              Grid_AO(4,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          Tau(iD,iGrid) = Tau(iD,iGrid)+Grid_AO(2,iGrid,iAO,iD)*TabAO(2,iGrid,iAO)+Grid_AO(3,iGrid,iAO,iD)*TabAO(3,iGrid,iAO)+ &
                          Grid_AO(4,iGrid,iAO,iD)*TabAO(4,iGrid,iAO)
        end do

        if (Do_Grad) then

          ! Loop over cartesian components

          do iCar=1,3

            Ind_xyz = Ind_Grd(iCar,iAO) ! index of  nuclear gradient

            j = iCar+1 ! index derivative of AO

            iDx = nD+(iD-1)*3+1 ! index of grad rho component
            iDy = iDx+1
            iDz = iDy+1

            iT = nD*4+iD ! index of tau component

            idjx = Index_d2(1,iCar)
            idjy = Index_d2(2,iCar)
            idjz = Index_d2(3,iCar)
            if (Ind_xyz /= 0) then
              do iGrid=1,mGrid

                ! Cartesian derivative of rho

                dRho_dR(iD,iGrid,Ind_xyz) = dRho_dR(iD,iGrid,Ind_xyz)+Two*Grid_AO(1,iGrid,iAO,iD)*TabAO(j,iGrid,iAO)

                ! Cartesian derivatives of grad rho

                dRho_dR(iDx,iGrid,Ind_xyz) = dRho_dR(iDx,iGrid,Ind_xyz)+Two*TabAO(idjx,iGrid,iAO)*Grid_AO(1,iGrid,iAO,iD)+ &
                                             Two*TabAO(j,iGrid,iAO)*Grid_AO(2,iGrid,iAO,iD)
                dRho_dR(iDy,iGrid,Ind_xyz) = dRho_dR(iDy,iGrid,Ind_xyz)+Two*TabAO(idjy,iGrid,iAO)*Grid_AO(1,iGrid,iAO,iD)+ &
                                             Two*TabAO(j,iGrid,iAO)*Grid_AO(3,iGrid,iAO,iD)
                dRho_dR(iDz,iGrid,Ind_xyz) = dRho_dR(iDz,iGrid,Ind_xyz)+Two*TabAO(idjz,iGrid,iAO)*Grid_AO(1,iGrid,iAO,iD)+ &
                                             Two*TabAO(j,iGrid,iAO)*Grid_AO(4,iGrid,iAO,iD)

                ! Cartesian derivatives of tau

                dRho_dR(iT,iGrid,Ind_xyz) = dRho_dR(iT,iGrid,Ind_xyz)+Four*TabAO(idjx,iGrid,iAO)*Grid_AO(2,iGrid,iAO,iD)+ &
                                            Four*TabAO(idjy,iGrid,iAO)*Grid_AO(3,iGrid,iAO,iD)+ &
                                            Four*TabAO(idjz,iGrid,iAO)*Grid_AO(4,iGrid,iAO,iD)
              end do
            end if

          end do

        end if
      end do
    end do
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  case (meta_GGA_Type2)
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    Rho(:,1:mGrid) = Zero
    GradRho(:,1:mGrid) = Zero
    Tau(:,1:mGrid) = Zero
    Lapl(:,1:mGrid) = Zero
    do iD=1,nD
      ix = (iD-1)*3+1
      iy = (iD-1)*3+2
      iz = (iD-1)*3+3
      do iAO=1,nAO

        do iGrid=1,mGrid
          Rho(iD,iGrid) = Rho(iD,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          GradRho(ix,iGrid) = GradRho(ix,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(2,iGrid,iAO)+ &
                              Grid_AO(2,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          GradRho(iy,iGrid) = GradRho(iy,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(3,iGrid,iAO)+ &
                              Grid_AO(3,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          GradRho(iz,iGrid) = GradRho(iz,iGrid)+Grid_AO(1,iGrid,iAO,iD)*TabAO(4,iGrid,iAO)+ &
                              Grid_AO(4,iGrid,iAO,iD)*TabAO(1,iGrid,iAO)
          Tau(iD,iGrid) = Tau(iD,iGrid)+Grid_AO(2,iGrid,iAO,iD)*TabAO(2,iGrid,iAO)+Grid_AO(3,iGrid,iAO,iD)*TabAO(3,iGrid,iAO)+ &
                          Grid_AO(4,iGrid,iAO,iD)*TabAO(4,iGrid,iAO)
          Lapl(iD,iGrid) = Lapl(iD,iGrid)+TabAO(1,iGrid,iAO)*(Grid_AO(5,iGrid,iAO,iD)+Grid_AO(8,iGrid,iAO,iD)+ &
                           Grid_AO(10,iGrid,iAO,iD))+Two*(Grid_AO(2,iGrid,iAO,iD)*TabAO(2,iGrid,iAO)+ &
                           Grid_AO(3,iGrid,iAO,iD)*TabAO(3,iGrid,iAO)+Grid_AO(4,iGrid,iAO,iD)*TabAO(4,iGrid,iAO))+ &
                           Grid_AO(1,iGrid,iAO,iD)*(TabAO(5,iGrid,iAO)+TabAO(8,iGrid,iAO)+TabAO(10,iGrid,iAO))
        end do

        if (Do_Grad) then

          ! Loop over cartesian components

          do iCar=1,3

            Ind_xyz = Ind_Grd(iCar,iAO) ! index of  nuclear gradient

            j = iCar+1 ! index derivative of AO

            iDx = nD+(iD-1)*3+1 ! index of grad rho component
            iDy = iDx+1
            iDz = iDy+1

            iT = nD*4+iD ! index of tau component

            iL = nD*5+iD ! index of laplacian component

            idjx = Index_d2(1,iCar)
            idjy = Index_d2(2,iCar)
            idjz = Index_d2(3,iCar)

            idjx2 = Index_d3(1,iCar)
            idjy2 = Index_d3(2,iCar)
            idjz2 = Index_d3(3,iCar)
            idx2 = Index_d2(1,1)
            idy2 = Index_d2(2,2)
            idz2 = Index_d2(3,3)
            if (Ind_xyz /= 0) then
              do iGrid=1,mGrid

                ! Cartesian derivative of rho

                dRho_dR(iD,iGrid,Ind_xyz) = dRho_dR(iD,iGrid,Ind_xyz)+Two*Grid_AO(1,iGrid,iAO,iD)*TabAO(j,iGrid,iAO)

                ! Cartesian derivatives of grad rho

                dRho_dR(iDx,iGrid,Ind_xyz) = dRho_dR(iDx,iGrid,Ind_xyz)+Two*TabAO(idjx,iGrid,iAO)*Grid_AO(1,iGrid,iAO,iD)+ &
                                             Two*TabAO(j,iGrid,iAO)*Grid_AO(2,iGrid,iAO,iD)
                dRho_dR(iDy,iGrid,Ind_xyz) = dRho_dR(iDy,iGrid,Ind_xyz)+Two*TabAO(idjy,iGrid,iAO)*Grid_AO(1,iGrid,iAO,iD)+ &
                                             Two*TabAO(j,iGrid,iAO)*Grid_AO(3,iGrid,iAO,iD)
                dRho_dR(iDz,iGrid,Ind_xyz) = dRho_dR(iDz,iGrid,Ind_xyz)+Two*TabAO(idjz,iGrid,iAO)*Grid_AO(1,iGrid,iAO,iD)+ &
                                             Two*TabAO(j,iGrid,iAO)*Grid_AO(4,iGrid,iAO,iD)

                ! Cartesian derivatives of tau

                dRho_dR(iT,iGrid,Ind_xyz) = dRho_dR(iT,iGrid,Ind_xyz)+Four*TabAO(idjx,iGrid,iAO)*Grid_AO(2,iGrid,iAO,iD)+ &
                                            Four*TabAO(idjy,iGrid,iAO)*Grid_AO(3,iGrid,iAO,iD)+ &
                                            Four*TabAO(idjz,iGrid,iAO)*Grid_AO(4,iGrid,iAO,iD)

                ! Cartesian derivatives of the laplacian

                dRho_dR(iL,iGrid,Ind_xyz) = dRho_dR(iL,iGrid,Ind_xyz)+Two*Grid_AO(1,iGrid,iAO,iD)*(TabAO(idjx2,iGrid,iAO)+ &
                                            TabAO(idjy2,iGrid,iAO)+TabAO(idjz2,iGrid,iAO))+Two*(Grid_AO(idx2,iGrid,iAO,iD)+ &
                                            Grid_AO(idy2,iGrid,iAO,iD)+Grid_AO(idz2,iGrid,iAO,iD))*TabAO(j,iGrid,iAO)+ &
                                            Four*Grid_AO(2,iGrid,iAO,iD)*TabAO(idjx,iGrid,iAO)+ &
                                            Four*Grid_AO(3,iGrid,iAO,iD)*TabAO(idjy,iGrid,iAO)+ &
                                            Four*Grid_AO(4,iGrid,iAO,iD)*TabAO(idjz,iGrid,iAO)

              end do
            end if

          end do

        end if

      end do
    end do
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  case default
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
    call abend()
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
end select
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
#ifdef _ANALYSIS_
write(u6,*)
write(u6,*) 'Rho Sparsity analysis'
n = 0
do iGrid=1,mGrid
  tmp = Zero
  do iD=1,nD
    tmp = tmp+Rho(iD,iGrid)
  end do
  if (tmp < Thr) n = n+1
end do
write(u6,*) 'Rho Sparsity in %: ',100.0_wp*real(n,kind=wp)/real(mGrid,kind=wp)
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
!      Scale Tau to compy with the Libxc definition.
!
if (allocated(Tau)) Tau(:,1:mGrid) = Half*Tau(:,1:mGrid)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
do iD=1,nD
  call RecPrt('Dens_AO',' ',Dens_AO(:,:,iD),nAO,nAO)
  call RecPrt('Grid_AO',' ',Grid_AO(:,:,:,iD),mAO*mGrid,nAO)
end do
if (Do_Grad) then
  nGrad_Eff = size(dRho_dR,3)
  call RecPrt('dRho_dR_LDA: dRho_dR',' ',dRho_dR,size(dRho_dR,1)*mGrid,nGrad_Eff)
end if
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (allocated(Ind_grd)) call mma_deAllocate(Ind_Grd)

return

end subroutine Mk_Rho

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
*               2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine PLF_LDF_uvJ_1(TInt,nTInt,
     &                         AOint,ijkl,iCmp,jCmp,kCmp,lCmp,
     &                         iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*          Modified for Local DF, Thomas Bondo Pedersen, June 2010     *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit None
      Integer nTInt
      Real*8  TInt(nTInt)
      Integer ijkl, iCmp, jCmp, kCmp, lCmp
      Real*8  AOInt(ijkl,iCmp,jCmp,kCmp,lCmp)
      Integer iAO(4), iAOst(4)
      Integer iBas, jBas, kBas, lBas
      Integer kOp(4)
#include "localdf_bas.fh"
#include "localdf_int.fh"
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      Character*13 SecNam
      Parameter (SecNam='PLF_LDF_uvJ_1')
#endif

      Integer i1, i2, i3, i4
      Integer iShlJ, iShlK
      Integer jSO, kSO, lSO
      Integer jSOj, kSOk, lSOl
      Integer jj, kk, ll
      Integer nijkl, ip, ip0, ip1

      Integer i, j
      Integer iShlSO, IndxG, nBasSh
#if defined (_DEBUGPRINT_)
      Integer iSOShl
      iSOShl(i)=iWork(ip_iSOShl-1+i)
#endif
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iShlSO(i)=iWork(ip_iShlSO-1+i)
      IndxG(i,j)=iWork(ip_IndxG-1+l_IndxG_1*(j-1)+i)

#if defined (_DEBUGPRINT_)
      If (iSOShl(iAOtSO(iAO(1)+1,kOp(1))+iAOst(1)).ne.SHA) Then
         Call WarningMessage(2,SecNam//': Shell problem [1]')
         Call LDF_Quit(1)
      End If
      If (iSOShl(iAOtSO(iAO(2)+1,kOp(2))+iAOst(2)).ne.SHB) Then
         Call WarningMessage(2,SecNam//': Shell problem [2]')
         Call LDF_Quit(1)
      End If
      If (iSOShl(iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)).ne.SHC) Then
         Call WarningMessage(2,SecNam//': Shell problem [3]')
         Call LDF_Quit(1)
      End If
      If (iSOShl(iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)).ne.SHD) Then
         Call WarningMessage(2,SecNam//': Shell problem [4]')
         Call LDF_Quit(1)
      End If
      If (iCmp*iBas.ne.1) Then
         Call WarningMessage(2,SecNam//': Shell dimension problem [1]')
         Call LDF_Quit(1)
      End If
#endif

      i1=1
      iShlJ=SHB
      iShlK=SHC
      Do i4=1,lCmp
         lSO=iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
         Do i3=1,kCmp
            kSO=iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
            Do i2=1,jCmp
               jSO=iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
               nijkl=0
               Do lSOl=lSO,lSO+lBas-1
                  ll=iShlSO(lSOl)
                  ip0=iOffuv+nBasSh(iShlK)*(ll-1)
                  Do kSOk=kSO,kSO+kBas-1
                     kk=iShlSO(kSOk)
                     ip1=ip0+kk
                     Do jSOj=jSO,jSO+jBas-1
                        jj=iShlSO(jSOj)
                        nijkl=nijkl+1
                        If (IndxG(jj,iShlJ).gt.0) Then
                           ip=nRow_uvJ*(IndxG(jj,iShlJ)-1)+ip1
                           TInt(ip)=AOInt(nijkl,i1,i2,i3,i4)
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do

#ifndef _DEBUGPRINT_
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iBas)
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Bjorn O. Roos                                    *
!               1991, Roland Lindh                                     *
!               Valera Veryazov                                        *
!***********************************************************************

function Lbl2Nr(Atom)

use Isotopes, only: MaxAtomNum, PTab
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: Lbl2Nr
character(len=*), intent(in) :: Atom
integer(kind=iwp) :: i, lAtom
character(len=2) :: TmpLbl(2)

if ((len_trim(Atom) > 2) .or. (len_trim(Atom) <= 0)) then
  call WarningMessage(2,'The atom label;-->'//Atom(1:4)//'<--; is not a proper string to define an element.')
  call Quit_OnUserError()
end if

Lbl2Nr = -1

lAtom = 0
do i=1,80
  if (Atom(i:i) == ' ') exit
  lAtom = lAtom+1
end do
if (lAtom > 2) lAtom = 2
TmpLbl(1) = '  '
if (lAtom > 0) then
  if (lAtom == 1) then
    TmpLbl(1)(2:2) = Atom(1:1)
  else
    TmpLbl(1) = Atom(1:2)
  end if
  call UpCase(TmpLbl(1))
  do i=0,MaxAtomNum
    TmpLbl(2) = PTab(i)
    call UpCase(TmpLbl(2))
    if (TmpLbl(2) == TmpLbl(1)) then
      Lbl2Nr = i
      exit
    end if
  end do
end if
if (Lbl2Nr == -1) then
  call WarningMessage(2,'The atom label;-->'//Atom(1:4)//'<--; does not define an element.')
  call Quit_OnUserError()
end if

return

end function Lbl2Nr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine TrGen(TrMat,nTrMat,Ovrlp,OneHam,mBT)
!***********************************************************************
!                                                                      *
!     purpose: Generate transformation matrix from AO's in which       *
!              integrals are computed to orthogonal, symmetry adapted  *
!              (and spherical, if desired) functions - near linear     *
!              dependencies are also removed.                          *
!                                                                      *
!     input:                                                           *
!       Ovrlp    : overlap matrix in AO basis of length mBT            *
!                                                                      *
!     output:                                                          *
!       TrMat   : Transformation matrix of length nTrMat               *
!                                                                      *
!***********************************************************************

use InfSCF, only: DelThr, nBas, nBO, nBT, nnFr, nSym
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nTrMat, mBT
real(kind=wp), intent(out) :: TrMat(nTrMat)
real(kind=wp), intent(in) :: Ovrlp(mBT), OneHam(mBT)
integer(kind=iwp) :: i, ind, iSym, j

ind = 0
do iSym=1,nSym
  do i=1,nBas(iSym)
    do j=1,nBas(iSym)
      ind = ind+1
      TrMat(ind) = Zero
      if (I == J) TrMat(ind) = One
    end do
  end do
end do

! Set up certain parameters (nOrb(i) may be changed)
call SetUp_SCF()

! Move frozen atomic orbitals to the begining
if (nnFr > 0) then
  call Freeze(TrMat,nBO,OneHam,mBT)
  call SetUp_SCF()
end if

! Remove near linear dependencies from basis set
if (DelThr /= Zero) then
  call OvlDel(Ovrlp,nBT,TrMat,nBO)
  call SetUp_SCF()
end if

! Orthogonalize final orbitals
call Ortho(TrMat,nBO,Ovrlp,nBT)

end subroutine TrGen

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine prtopt_cvb()

use Index_Functions, only: nTri_Elem
use casvb_global, only: ioptim, istackrep, nfxvb, noptim, norb, nort, nvb, nzrvb, recinp
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ioffs, ioptstep1, ioptstep2, italter, kk2, mxalter, nc_zeroed, nconvinone
integer(kind=iwp), allocatable :: idelstr(:), ifxorb(:), ifxstr(:), iorts(:,:)
logical(kind=iwp), external :: istkprobe_cvb

! First determine if end of multi-step optimization may have been reached:
if (istkprobe_cvb(istackrep)) then
  call istkpop_cvb(istackrep,nc_zeroed)
  call istkpop_cvb(istackrep,nconvinone)
  call istkpop_cvb(istackrep,italter)
  call istkpop_cvb(istackrep,mxalter)
  call istkpop_cvb(istackrep,kk2)
  call istkpop_cvb(istackrep,ioptstep2)
  call istkpop_cvb(istackrep,ioptstep1)
  call istkpush_cvb(istackrep,ioptstep1)
  call istkpush_cvb(istackrep,ioptstep2)
  call istkpush_cvb(istackrep,kk2)
  call istkpush_cvb(istackrep,mxalter)
  call istkpush_cvb(istackrep,italter)
  call istkpush_cvb(istackrep,nconvinone)
  call istkpush_cvb(istackrep,nc_zeroed)
else
  ioptstep1 = 0
  italter = 0
end if

call mma_allocate(iorts,2,nTri_Elem(norb-1),label='iorts')
call mma_allocate(ifxorb,norb,label='ifxorb')
call mma_allocate(ifxstr,nvb,label='ifxstr')
call mma_allocate(idelstr,nvb,label='idelstr')

call rdioff_cvb(11,recinp,ioffs)
call rdis_cvb(ifxorb,norb,recinp,ioffs)
call rdis_cvb(ifxstr,nfxvb,recinp,ioffs)
call rdis_cvb(idelstr,nzrvb,recinp,ioffs)
call rdis_cvb(iorts,2*nort,recinp,ioffs)

call prtopt2_cvb(ioptstep1,ioptim,italter,noptim,iorts,ifxorb,ifxstr,idelstr)

call mma_deallocate(iorts)
call mma_deallocate(ifxorb)
call mma_deallocate(ifxstr)
call mma_deallocate(idelstr)

return

end subroutine prtopt_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine TTMul(A,B,C,nRowA,nColA,nRowB)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 A(nRowA,nColA), B(nRowB,nRowA),
     &       C(nColA,nRowB)
*
      nCache_=(64/8)*1024
      mCache=(nCache_*3)/4 - nRowA*nColA
      Incj=mCache/(nRowA+nColA)
*
*-----Sectioning of long index
*
      Do jj = 1, nRowB, Incj
         njVec=Min(Incj,nRowB-jj+1)
*
         Do i = 1, nColA
*-----------Set target to zero
            Do j = jj, jj+njVec-1
               C(i,j) = Zero
            End Do
            Do k = 1, nRowA
               If (A(k,i).ne.Zero) Then
                  Do j = jj, jj+njVec-1
                     C(i,j) = C(i,j) + A(k,i)*B(j,k)
                  End Do
               End If
            End Do
         End Do
*
      End Do    ! End of sectioning
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dgetf2(m,n,a,lda,ipiv,info)
use link_blas, only: lb_dgetf2
use Definitions, only: BLASInt, BLASR8
implicit none
integer(kind=BLASInt) :: info, lda, m, n
integer(kind=BLASInt) :: ipiv(*)
real(kind=BLASR8) :: a(lda,*)
call lb_dgetf2(m,n,a,lda,ipiv,info)
end subroutine dgetf2

subroutine dpotf2(uplo,n,a,lda,info)
use link_blas, only: lb_dpotf2
use Definitions, only: BLASInt, BLASR8
implicit none
character :: uplo
integer(kind=BLASInt) :: info, lda, n
real(kind=BLASR8) :: a(lda,*)
call lb_dpotf2(uplo,n,a,lda,info)
end subroutine dpotf2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SetUp_CASPT2_Tra(nSym_,nBas_,nOrb_,nIsh_,nAsh_,
     &                            nFro_,nDel_,ipCMO,lthCMO,
     &                            LuIntM_,LuHlf1_,LuHlf2_,LuHlf3_)
      Implicit Real*8 (a-h,o-z)

#include "rasdim.fh"
#include "caspt2.fh"
*
      Integer nBas_(8),nOrb_(8),nAsh_(8),nIsh_(8), nFro_(8),nDel_(8)
*                                                                      *
************************************************************************
*                                                                      *
      nSym=nSym_
      Do i = 1, nSym
         nBas(i) = nBas_(i)
         nOrb(i) = nOrb_(i)
         nFro(i) = nFro_(i)
         nDel(i) = nDel_(i)
         nAsh(i) = nAsh_(i)
         nIsh(i) = nIsh_(i)
         nOsh(i) = nAsh_(i) + nIsh_(i)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Do i = 1, 8
         Do j = 1, 8
            Mul(i,j)=iEor(i-1,j-1)+1
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      LCMO=ipCMO
      nCMO=lthCMO
*                                                                      *
************************************************************************
*                                                                      *
*---- Open the temporary files here! This is where they get their final
*     unit numbers.
*
*
      CALL DANAME_MF_wa(LuHlf1_,'LUHLF1')
      CALL DANAME_MF_wa(LuHlf2_,'LUHLF2')
      CALL DANAME_MF_wa(LuHlf3_,'LUHLF3')
      LuHlf1=LuHlf1_
      LuHlf2=LuHlf2_
      LuHlf3=LuHlf3_
*
*     Observe that LuIntM should be opened prior to this call!
*
      LuIntM=LuIntM_
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Mickael G. Delcey                                      *
************************************************************************
      SUBROUTINE CHO_Fock_MCLR(DA,G2,W_JA,W_KA,W_FkA,CVa,W_CMO,nIsh,
     &                         nAsh,LuAChoVec)
************************************************************************
*                                                                      *
*  Author : M. G. Delcey                                               *
*                                                                      *
************************************************************************
      use ChoArr, only: nBasSh, nDimRS
      use ChoSwp, only: InfVec
      use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
      Implicit Real*8 (a-h,o-z)
#include "warnings.h"
      Character(LEN=13), Parameter :: SECNAM = 'CHO_FOCK_MCLR'
      Integer   ipLpq(8,3)
      Integer   LuAChoVec(8)
      Integer   nAsh(8),nIsh(8)
#include "cholesky.fh"
#include "choorb.fh"
#include "real.fh"
#include "stdalloc.fh"
      Type (DSBA_type) CVa, JA(1), KA, Fka, CMO, Scr
      Real*8 DA(*), G2(*), W_JA(*), W_KA(*), W_FkA(*), W_CMO(*)
      Real*8, parameter:: xone=-One, FactCI = -Two, FactXI = Half
      Integer , External :: Cho_LK_MaxVecPerBatch
      Integer, Allocatable:: kOffSh(:,:)
      Real*8, Allocatable::  Fab(:), Lrs(:), LF(:)
      Logical add
************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
************************************************************************
*
      Call Allocate_DT(JA(1),nBas,nBas,nSym,aCase='TRI',Ref=W_JA )
      Call Allocate_DT(KA ,nBas,nBas,nSym,            Ref=W_KA )
      Call Allocate_DT(FkA,nBas,nBas,nSym,            Ref=W_FkA)
      Call Allocate_DT(CMO,nBas,nBas,nSym,            Ref=W_CMO)
*
**    Compute Shell Offsets ( MOs and transformed vectors)
*
      Call mma_allocate(kOffSh,nShell,nSym,Label='kOffSh')
      Do iSyma=1,nSym
         LKsh=0
         Do iaSh=1,nShell    ! kOffSh(iSh,iSym)
            kOffSh(iaSh,iSyma) = LKsh
            LKsh = LKsh + nBasSh(iSyma,iaSh)
         End Do
      End Do
*
*     memory for the Q matrices --- temporary array
      Call Allocate_DT(Scr,nBas,nBas,nSym)
      Scr%A0(:)=Zero
*
      MaxVecPerBatch=Cho_LK_MaxVecPerBatch()
*
**    Start looping!
*
      DO jSym=1,nSym
        NumCV=NumCho(jSym)
        Call GAIGOP_SCAL(NumCV,'max')
        If (NumCV .lt. 1) GOTO 1000
*
        iLoc = 3 ! use scratch location in reduced index arrays
*
**    Estimate memory need
*
        mTvec = 0
        do l=1,nSym
           k=Muld2h(l,JSYM)
           mTvec = mTvec + nAsh(k)*nBas(l)*3
        end do
*
        JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
        JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

c --- entire red sets range for parallel run
        Call GAIGOP_SCAL(JRED1,'min')
        Call GAIGOP_SCAL(JRED2,'max')

        Do JRED=JRED1,JRED2
          CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)
          If (nVrs.eq.0) GOTO 999
          if (nVrs.lt.0) then
            Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
     &                            ,nVrs
            call Abend
          endif
          Call Cho_X_SetRed(irc,iLoc,JRED)
c         !set index arrays at iLoc
          if(irc.ne.0)then
            Write(6,*)SECNAM//'cho_X_setred non-zero return code.'//
     &                        ' rc= ',irc
            call Abend
          endif
          IREDC=JRED

          nRS = nDimRS(JSYM,JRED)
          If (jSym.eq.1) Then
            Call mma_allocate(Fab,nRS,Label='Fab')
            Fab(:)=Zero
          EndIf

          Call mma_MaxDBLE(LWORK)
          nVec = min(LWORK/(nRS+mTvec+1),min(nVrs,MaxVecPerBatch))
          If (nVec.lt.1) Then
             WRITE(6,*) SECNAM//': Insufficient memory for batch'
             WRITE(6,*) 'LWORK= ',LWORK
             WRITE(6,*) 'min. mem. need= ',nRS+mTvec+1
             WRITE(6,*) 'nRS= ',nRS
             WRITE(6,*) 'mTvec= ',mTvec
             WRITE(6,*) 'jsym= ',jsym
             CALL Quit(_RC_MEMORY_ERROR_)
             nBatch = -9999  ! dummy assignment
          End If
          LREAD = nRS*nVec

          Call mma_allocate(Lrs,LREAD,Label='Lrs')
          CALL mma_allocate(LF,mTvec*nVec,Label='LF')

          nBatch = (nVrs-1)/nVec + 1

          DO iBatch=1,nBatch

            If (iBatch.eq.nBatch) Then
               JNUM = nVrs - nVec*(nBatch-1)
            else
               JNUM = nVec
            endif
************************************************************************
*                                                                      *
*           START WORKING                                              *
*                                                                      *
************************************************************************
*
**          Read Cholesky vector
*
            JVEC = nVec*(iBatch-1) + iVrs
            IVEC2 = JVEC - 1 + JNUM

            CALL CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,
     &                     NUMV,IREDC,MUSED)

            If (NUMV.le.0 .or.NUMV.ne.JNUM ) then
               RETURN
            End If
*
*            CALL CWTIME(TCINT1,TWINT1)

C --- Set up the skipping flags and the pointers ipLpq
C --- The memory used before for the full-dimension AO-vectors
C ---     is now re-used to store half and full transformed
C ---     vectors in the active space
C -------------------------------------------------------------
             lChoa=0
             Do i=1,nSym

                k = Muld2h(i,JSYM)

                ipLpq(k,1) = 1 + lChoa   ! Lvb,J
                ipLpq(k,2) = ipLpq(k,1)     ! Lvi,J i general MO index
     &                     + nAsh(k)*nBas(i)*JNUM
                ipLpq(k,3) = ipLpq(k,2)     ! L~vi,J ~ transformed index
     &                       + nAsh(k)*nBas(i)*JNUM

                lChoa= lChoa + nAsh(k)*nBas(i)*3*JNUM

             End Do
*
**  Read half-transformed cho vectors
*
             ioff=0
             Do i=1,nSym
                k = Muld2h(i,JSYM)
                lvec=nAsh(k)*nBas(i)*JNUM
                iAdr=(JVEC-1)*nAsh(k)*nBas(i)+ioff
                call DDAFILE(LuAChoVec(Jsym),2,LF(ipLpq(k,1)),
     &                       lvec,iAdr)
                ioff=ioff+nAsh(k)*nBas(i)*NumCho(jSym)
             End Do
*             CALL CWTIME(TCINT2,TWINT2)
*             tint1(1) = tint1(1) + (TCINT2 - TCINT1)
*             tint1(2) = tint1(2) + (TWINT2 - TWINT1)
C --------------------------------------------------------------------
C --- Active-Active transformation  Lvw,J = sum_b  Lvb,J * C2(w,b)
C --------------------------------------------------------------------
             Do iSymb=1,nSym

               iSymv = MulD2h(JSYM,iSymb)
               NAv = nAsh(iSymv)
               NAw = nAsh(iSymb)

               If(NAv*NBAS(iSymb).ne.0)Then

*                CALL CWTIME(TCINT2,TWINT2)

                 Do JVC=1,JNUM
                  ipLvb = ipLpq(iSymv,1) + NAv*NBAS(iSymb)*(JVC-1)
                  ipLvw = ipLpq(iSymv,2) + NAv*Naw*(JVC-1)
                  CALL DGEMM_('N','T',NAv,Naw,NBAS(iSymb),
     &                       One,LF(ipLvb),NAv,
     &                       CVa%SB(iSymb)%A2,Naw,
     &                      Zero,LF(ipLvw),NAv)
                 End Do
*                 CALL CWTIME(TCINT2,TWINT2)
*                 tint1(1) = tint1(1) + (TCINT2 - TCINT3)
*                 tint1(2) = tint1(2) + (TWINT2 - TWINT3)
C
C
C ************ EVALUATION OF THE ACTIVE FOCK MATRIX *************
*Coulomb term
                 ipVJ = ipLpq(iSymv,3)
                 ipLvtw = ipLpq(iSymv,2)

                 CALL DGEMV_('T',Nav*Naw,JNUM,
     &                  ONE,LF(ipLvtw),Nav*Naw,
     &                  DA,1,ZERO,LF(ipVJ),1)
*
                 CALL DGEMV_('N',nRS,JNUM,
     &                -FactCI,Lrs,nRS,
     &                LF(ipVJ),1,1.0d0,Fab,1)

*                 CALL CWTIME(TCINT2,TWINT2)
*                 tact(1) = tact(1) + (TCINT2 - TCINT3)
*                 tact(2) = tact(2) + (TWINT2 - TWINT3)
C --------------------------------------------------------------------
C --- Formation of the Q matrix Qpx = L~py Lvw Gxyvw
C --------------------------------------------------------------------
                 Do JVC=1,JNUM
*Lxy=Lvw Gxyvw
*MGD probably additional nSym loop
                  ipLvb = ipLpq(iSymv,1) + NAv*NBAS(iSymb)*(JVC-1)
                  ipLvw = ipLpq(iSymv,2) + NAv*Naw*(JVC-1)
                  ipLxy = ipLpq(iSymv,3) + NAv*Naw*(JVC-1)
                  CALL DGEMV_('N',NAv*Naw,NAv*Naw,
     &               ONE,G2,NAv*Naw,
     &               LF(ipLvw),1,ZERO,LF(ipLxy),1)
*Qpx=Lpy Lxy
                  Call DGEMM_('T','N',NBAS(iSymb),NAw,Nav,
     &                       One,LF(ipLvb),NAv,
     &                       LF(ipLxy),Naw,
     &                      ONE,Scr%SB(iSymb)%A2,NBAS(iSymb))
                 End Do
*                 CALL CWTIME(TCINT3,TWINT3)
*                 tQmat(1) = tQmat(1) + (TCINT3 - TCINT2)
*                 tQmat(2) = tQmat(2) + (TWINT3 - TWINT2)
C
C
C ************ EVALUATION OF THE ACTIVE FOCK MATRIX *************
*Exchange term
                 Do JVC=1,JNUM
                   ipLvb = ipLpq(iSymv,1)+ NAv*NBAS(iSymb)*(JVC-1)
                   ipLwb = ipLpq(iSymv,2)+ NAv*NBAS(iSymb)*(JVC-1)
                   Call DGEMM_('T','N',NBAS(iSymb),Nav,Nav,
     &                         ONE,LF(ipLvb),Nav,
     &                         DA,Nav,ZERO,
     &                         LF(ipLwb),NBAS(iSymb))
                 End Do
*                 CALL CWTIME(TCINT2,TWINT2)
*                 tact(1) = tact(1) + (TCINT2 - TCINT3)
*                 tact(2) = tact(2) + (TWINT2 - TWINT3)
                 Do JVC=1,JNUM
                   ipLwb = ipLpq(iSymv,2)+ NAv*NBAS(iSymb)*(JVC-1)
                   Do is=1,NBAS(iSymb)
                    ipLtvb = ipLpq(iSymv,1)+ NAv*NBAS(iSymb)*(JVC-1)
     &                      + Nav*(is-1)
                    CALL DGEMV_('N',NBAS(iSymb),Nav,
     &                   -FactXI,LF(ipLwb),NBAS(iSymb),
     &                   LF(ipLtvb),1,ONE,KA%SB(iSymb)%A2(:,is),1)

                  EndDo
                 End Do
*                 CALL CWTIME(TCINT3,TWINT3)
*                 tact(1) = tact(1) + (TCINT3 - TCINT2)
*                 tact(2) = tact(2) + (TWINT3 - TWINT2)
               End If
             End Do
*
**          All good things come to an end
*
          END DO  ! end batch loop

c --- backtransform fock matrix to full storage
          If(JSYM.eq.1)Then
             add = .True.
             nMat = 1
             Call swap_rs2full(irc,iLoc,nRS,nMat,JSYM,
     &                           JA,Fab,add)
             Call mma_deallocate(Fab)
          EndIf
          Call mma_deallocate(Lrs)
          Call mma_deallocate(LF)
 999      Continue
        End Do  ! loop over red sets
 1000   CONTINUE
      End Do    ! loop over JSYM
************************************************************************
*                                                                      *
*     POST PROCESSING                                                  *
*                                                                      *
************************************************************************
*
**    Accumulate Coulomb and Exchange contributions
*
      Do iSym=1,nSym

         Do iaSh=1,nShell
            ioffa = kOffSh(iaSh,iSym)

            Do ibSh=1,nShell

               ioffb = kOffSh(ibSh,iSym)

               Do ib=1,nBasSh(iSym,ibSh)
                Do ia=1,nBasSh(iSym,iaSh)
*MGD warning with sym

                  iag = ioffa + ia
                  ibg = ioffb + ib
                  iabg= iTri(iag,ibg)

                  FkA%SB(iSym)%A2(iag,ibg)
     &                    = JA(1)%SB(iSym)%A1(iabg)
     &                    + KA%SB(iSym)%A2(iag,ibg)
     &                    + KA%SB(iSym)%A2(ibg,iag)
                End Do
               End Do
            End Do
         End Do
      End Do

      Call Deallocate_DT(JA(1))
      Call Allocate_DT(JA(1) ,nBas,nBas,nSym,           Ref=W_JA )
*
**Transform Fock and Q matrix to MO basis
*
      Do iS=1,nSym
        jS=iS
        If (nBas(iS).ne.0) Then
          Call DGEMM_('T','N',nBas(jS),nBas(iS),nBas(iS),
     &                1.0d0,FkA%SB(iS)%A2,nBas(iS),
     &                      CMO%SB(iS)%A2,nBas(iS),
     &                0.0d0,JA(1)%SB(iS)%A2,nBas(jS))
          FkA%SB(is)%A2(:,:)=Zero
          Call DGEMM_('T','N',nBas(jS),nIsh(jS),nBas(iS),
     &                1.0d0,JA(1)%SB(iS)%A2,nBas(iS),
     &                      CMO%SB(jS)%A2,nBas(jS),
     &                0.0d0,FkA%SB(iS)%A2,nBas(jS))
*         ioff=nIsh(iS)+1
          iOff = 1 + nIsh(iS) * nBas(iS)
          Call DGEMM_('T','N',nBas(jS),nAsh(iS),nBas(jS),
     &                 1.0d0,CMO%SB(iS)%A2,nBas(jS),
     &                       Scr%SB(iS)%A2,nBas(jS),
*    &                 0.0d0,FkA%SB(iS)%A2(1:,ioff),nBas(jS))
     &                 0.0d0,FkA%SB(iS)%A1(iOff:),nBas(jS))
        EndIf
      End Do
************************************************************************
*                                                                      *
*     TERMINATING                                                      *
*                                                                      *
************************************************************************
      Call deallocate_DT(Scr)
      Call mma_deallocate(kOffSh)
      Call Deallocate_DT(CMO)
      Call Deallocate_DT(FkA)
      Call Deallocate_DT(KA)
      Call Deallocate_DT(JA(1))

      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Binom(n,i,iBin)
!***********************************************************************
!                                                                      *
! Object: to compute the binomial factor                               *
!                                                                      *
! Called from: TraPAB                                                  *
!                                                                      *
! Calling    : None                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!***********************************************************************

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n, i
integer(kind=iwp), intent(out) :: iBin
integer(kind=iwp) :: iDen, j, Num

Num = 1
iDen = 1
do j=1,i
  Num = Num*(n-j+1)
  iDen = iDen*j
end do
iBin = Num/iDen

return

end subroutine Binom

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pXpMem( &
#                 define _CALLING_
#                 include "mem_interface.fh"
                 )

use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: MemPX, nOrder

Mem = 0
nHer = 0
call PXMem(nOrder,MemPX,la,lb+1,lr-1)
Mem = max(Mem,MemPX)
nHer = max(nHer,nOrder)
if (lb > 0) then
  call PXMem(nOrder,MemPX,la,lb-1,lr-1)
  Mem = max(Mem,MemPX)
  nHer = max(nHer,nOrder)
end if

return

end subroutine pXpMem

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefW4dcab(W,Wx,dima,dimb,dimc,dimd,abLen,cdLen,aSGrp,bSGrp,cSGrp,dSGrp)
! define W(a,b,c,d) from (dc|ab)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimc, dimd, abLen, cdLen, aSGrp, bSGrp, cSGrp, dSGrp
real(kind=wp), intent(inout) :: W(dima,dimb,dimc,dimd)
real(kind=wp), intent(in) :: Wx(cdLen,abLen)
integer(kind=iwp) :: a, b, c, d, ab, dc

#include "macros.fh"
unused_var(cSGrp)
unused_var(dSGrp)

if (aSGrp == bSGrp) then
  ! case (d,c|a=b)
  do a=1,dima
    ab = nTri_Elem(a-1)
    dc = 0
    do c=1,dimc
      do d=1,dimd
        dc = dc+1
        W(a,1:a-1,c,d) = W(a,1:a-1,c,d)+Wx(dc,ab+1:ab+a-1)
        W(1:a,a,c,d) = W(1:a,a,c,d)+Wx(dc,ab+1:ab+a)
      end do
    end do
  end do

else
  ! case (d,c|a,b)
  ab = 0
  do b=1,dimb
    dc = 0
    do c=1,dimc
      do d=1,dimd
        dc = dc+1
        W(:,b,c,d) = W(:,b,c,d)+Wx(dc,ab+1:ab+dima)
      end do
    end do
  end do

end if

return

end subroutine DefW4dcab

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Stefan Knecht                                    *
!***********************************************************************

subroutine set_as_solver()

! module dependencies
use active_space_solver_cfg, only: as_solver
#ifdef _DMRG_
use qcmaquis_interface_cfg, only: dmrg_warmup
#endif
use Definitions, only: iwp, u6
use rasscf_data, only: doDMRG

implicit none
! ----------------------------------------------------------------------
character(len=8)   :: is_solver
character(len=2)   :: onoff
integer(kind=iwp)  :: luspool
character(len=180) :: line, line2

character(len=180), external :: get_ln
integer(kind=iwp), external  :: isfreeunit
! ----------------------------------------------------------------------

luspool = isfreeunit(18)
call spoolinp(luspool)

rewind(luspool)
call rdnlst(luspool,'DMRGSCF')

!> find line as_solver; next unblank line should be the active space solver
do
  line = get_ln(luspool)
  call upcase(line)
  line = adjustl(line)

  if (line == '') cycle

  if (line(1:4) == 'ACTI') then
    do
      line2 = get_ln(luspool)
      call upcase(line2)
      line2 = adjustl(line2)
      if (line2 /= '') then
        is_solver(1:8) = line2(1:8)
        exit
      end if
    end do
    !exit
  end if
  if (line(1:4) == 'CIDE') then
    do
      line2 = get_ln(luspool)
      call upcase(line2)
      line2 = adjustl(line2)
      if (line2 /= '') then
        onoff(1:2) = line2(1:2)
#       ifdef _DMRG_
        if (onoff(1:2) == 'ON') dmrg_warmup%doCIDEAS = .true.
#       endif
        exit
      end if
    end do
    !exit
  end if
  if (line(1:4) == 'FIED') then
    do
      line2 = get_ln(luspool)
      call upcase(line2)
      line2 = adjustl(line2)
      if (line2 /= '') then
        onoff(1:2) = line2(1:2)
#       ifdef _DMRG_
        if (onoff(1:2) == 'ON') dmrg_warmup%doFIEDLER = .true.
#       endif
        exit
      end if
    end do
    !exit
  end if
  if ((line(1:6) == 'END OF') .or. (line(1:6) == 'DMRGSE') .or. (line(1:6) == 'OOPTIM')) exit

end do

!> set user-selected DMRG driver as active space solver
call upcase(is_solver)

select case (is_solver)

  !> QCMaquis
  case ('QCMAQUIS')

    as_solver(1:8) = 'qcmaquis'

  !> BLOCK
  case ('BLOCK')

    as_solver(1:8) = 'block   '

  !> CheMPS2
  case ('CHEMPS2')

    as_solver(1:8) = 'chemps2 '

  case default
    write(u6,*) 'unknown DMRG active space solver'
    call abend()
end select

write(u6,'(/5x,a,a )') ' DMRGSCF: active space solver is set to ',as_solver(1:8)
write(u6,'( 5x,a,a/)') ' -------                                ','--------'

#ifdef _DMRG_
if (as_solver(1:8) == 'qcmaquis') doDMRG = .true.
#endif

call Close_LuSpool(luspool)

end subroutine set_as_solver
! ----------------------------------------------------------------------

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkT1T2
c
c        T1(a,i) = 0 (mozno neskor ine)
c        T2(a,b,i,j) = (ai|bj)/Dabij
c
        implicit none
#include "chcc1.fh"
c
c        help variables
        integer a,b,i,j
c
        do i=1,no
        do a=1,nv
          T1c(a,i)=0.0d0
        end do
        end do
c
        do j=1,no
        do i=1,no
          do b=1,nv
          do a=1,nv
            T2c(a,b,i,j)=Q21(a,i,b,j)/(OEo(i)+OEo(j)-OEv(a)-OEv(b))
          end do
          end do
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Steven Vancoillie                                      *
************************************************************************
*SVC: compute RHS elements "on demand". If we have access to all the
* Cholesky vectors, we can just instruct a process to compute it's own
* block of RHS elements, computing the integrals directly. This is much
* more computationally intensive, but should scale much better since we
* go from a badly scaling scatter algorithm to no communication at all.
* This also eliminates the need for the GA library in creating the RHS.

* This is a special optimized version for non-symmetric molecules, as
* this allows for convenient sub-blocking of cholesky vectors.

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_NOSYM(IVEC)
      use definitions, only: iwp
#ifdef _DEBUGPRINT_
      use definitions, only: wp
      use caspt2_module, only: nASup, nISup, nSym
#endif
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: VERBOSE
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      IMPLICIT None
      integer(kind=iwp), Intent(In):: IVEC
#ifdef _DEBUGPRINT_
      integer(kind=iwp) iCase, iSym, NAS, NIS, lg_W
      real(kind=wp) DNRM2
      real(kind=wp), external :: RHS_DDot
#endif


      IF (IPRGLB>=VERBOSE) THEN
        WRITE(6,'(1X,A)') ' Using special RHS on-demand algorithm,'
        WRITE(6,'(1X,A)') ' optimized for non-symmetric molecules'
      END IF

#ifdef _MOLCAS_MPP_
      IF (.NOT.Is_Real_Par()) THEN
        WRITE(6,'(1X,A)') 'RHSOD_NOSYM: error: '//
     &                    'fake parallel not supported'
        CALL AbEnd()
      END IF
#endif

      CALL RHSOD_A_NOSYM(IVEC)
      CALL RHSOD_B_NOSYM(IVEC)
      CALL RHSOD_C_NOSYM(IVEC)
      CALL RHSOD_D_NOSYM(IVEC)
      CALL RHSOD_E_NOSYM(IVEC)
      CALL RHSOD_F_NOSYM(IVEC)
      CALL RHSOD_G_NOSYM(IVEC)
      CALL RHSOD_H_NOSYM(IVEC)

#ifdef _DEBUGPRINT_
* compute and print RHS fingerprints
      WRITE(6,'(1X,A4,1X,A3,1X,A18)') 'Case','Sym','Fingerprint'
      WRITE(6,'(1X,A4,1X,A3,1X,A18)') '====','===','==========='
      DO ICASE=1,13
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF (NAS*NIS/=0) THEN
            CALL RHS_ALLO (NAS,NIS,lg_W)
            CALL RHS_READ (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
            DNRM2 = RHS_DDOT(NAS,NIS,lg_W,lg_W)
            WRITE(6,'(1X,I4,1X,I3,1X,F18.11)') ICASE,ISYM,DNRM2
          END IF
        END DO
      END DO
#endif

      END SUBROUTINE RHSOD_NOSYM


************************************************************************
* SUBROUTINES FOR THE SEPARATE CASES
************************************************************************

*|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
      SUBROUTINE RHSOD_A_NOSYM(IVEC)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      USE SUPERINDEX, only: MTUV, MTREL
      USE CHOVEC_IO, only: NVTOT_ChoSym, ChoVec_Size, ChoVec_read
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use caspt2_global, only: FIMO
      use stdalloc, only: mma_allocate, mma_deallocate
#ifndef _MOLCAS_MPP_
      use fake_GA, only: GA_Arrays
#endif
      use caspt2_module, only: nSym, NTUV, nIsh, nTUVES, nAsh,
     &                         nOrb, nActEl

      IMPLICIT None

      integer(kind=iwp), intent(in):: IVEC

      integer(kind=iwp) IOBRA(8,8), IOKET(8,8)
      real(kind=wp), ALLOCATABLE:: BRA(:), KET(:)
      real(kind=wp) ATVXJ, FTJ, TJVX
      real(kind=wp), External:: DDot_
      integer(kind=iwp) iAEnd, iASta, iCase, IDX, IIEnd, IJ, IOFFTJ,
     &                  IOFFVX, ISYJ, iSym, iSYT, iSYV, iSYX, IT, ITABS,
     &                  ITJ, ITTOT, ITVX, ITVXTOT, IV, IVABS,
     &                  iVX, iX, iXABS, lg_W, mW, nAS, nBra, nFIMOES,
     &                  nIS, nKet, nV, nW, IISTA
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      IF (iPrGlb>=DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case A'
      END IF

************************************************************************
* Case A:
C   RHS(tvx,j)=(tj,vx)+FIMO(t,j)*kron(v,x)/NACTEL
************************************************************************

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(1,NBRA,IOBRA)
      CALL CHOVEC_SIZE(2,NKET,IOKET)

      CALL mma_allocate(BRA,NBRA,LABEL='BRA')
      CALL mma_allocate(KET,NKET,LABEL='KET')

      CALL CHOVEC_READ(1,BRA,NBRA)
      CALL CHOVEC_READ(2,KET,NKET)

      ICASE=1
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      NFIMOES=0
      DO ISYM=1,NSYM

        NAS=NTUV(ISYM) !NASUP(ISYM,ICASE)
        NIS=NISH(ISYM) !NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Then
          NFIMOES=NFIMOES+(NORB(ISYM)*(NORB(ISYM)+1))/2
          Cycle
        End If

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IJ=IISTA,IIEND
          ISYJ=ISYM
          DO ITVX=IASTA,IAEND ! these are always all elements
            ITVXTOT=ITVX+NTUVES(ISYM)
            ITABS=MTUV(1,ITVXTOT)
            IVABS=MTUV(2,ITVXTOT)
            IXABS=MTUV(3,ITVXTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
            IX  =MTREL(1,IXABS)
            ISYX=MTREL(2,IXABS)
! compute integrals (tiuv)
            NV=NVTOT_CHOSYM(Mul(ISYT,ISYJ)) ! JSYM=ISYT*ISYI=ISYU*ISYV
            ITJ=IT-1+NASH(ISYT)*(IJ-1)
            IVX=IV-1+NASH(ISYV)*(IX-1)
            IOFFTJ=1+IOBRA(ISYT,ISYJ)+NV*ITJ
            IOFFVX=1+IOKET(ISYV,ISYX)+NV*IVX
            TJVX=DDOT_(NV,BRA(IOFFTJ),1,KET(IOFFVX),1)
! A(tvx,j) = (tjvx) + FIMO(t,j)*delta(v,x)/NACTEL
            IF (ISYT==ISYJ.AND.IVABS==IXABS) THEN
              ITTOT=IT+NISH(ISYT)
              FTJ=FIMO(NFIMOES+(ITTOT*(ITTOT-1))/2+IJ)
              ATVXJ=TJVX+FTJ/DBLE(MAX(1,NACTEL))
            ELSE
              ATVXJ=TJVX
            END IF
! write element A(tvx,j)
            IDX=ITVX+NAS*(IJ-IISTA)
#ifdef _MOLCAS_MPP_
            DBL_MB(MW+IDX-1)=ATVXJ
#else
            GA_Arrays(lg_W)%A(IDX)=ATVXJ
#endif
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)

        NFIMOES=NFIMOES+(NORB(ISYM)*(NORB(ISYM)+1))/2

      END DO
************************************************************************

      CALL mma_deallocate(BRA)
      CALL mma_deallocate(KET)

      END SUBROUTINE RHSOD_A_NOSYM

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_C_NOSYM(IVEC)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use Constants, only: Zero
      USE SUPERINDEX, only: MTUV, MTREL, KTUV
      USE CHOVEC_IO, only: NVTOT_CHOSYM, CHOVEC_SIZE, CHOVEC_READ
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use caspt2_global, only: FIMO
      use stdalloc, only: mma_allocate, mma_deallocate
#ifndef _MOLCAS_MPP_
      use fake_GA, only: GA_Arrays
#endif
      use caspt2_module, only: nActEl, nAshT, nSym, nASup, nISup,
     &                         NTUVES, nSsh, nAsh, nIsh, NAES, nOrb
      IMPLICIT None
      integer(kind=iwp), intent(in):: IVEC

      integer(kind=iwp) IOBRA(8,8), IOKET(8,8)
      real(kind=wp), ALLOCATABLE:: BRA(:), KET(:)
      real(kind=wp) AddOne, ATVX, FAT, SUMU
      real(kind=wp), External:: DDot_
      integer(kind=iwp) IA, IAEND, IASTA, IAT, IATOT, iCASE, IDX,
     &                  IIEND, IISTA, IOFFAT, IOFFVX, ISYA, iSym,
     &                  ISYT, ISYV, ISYX, IT, ITABS, ITTOT, ITVV,
     &                  ITVX, ITVXTOT, IUABS, IUUT, IV, IVABS, IVX,
     &                  IX, IXABS, lg_W, mW, NAS, NBRA, NFIMOES, NIS,
     &                  NKET, NV, NW
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      IF (iPrGlb>=DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case C'
      END IF

************************************************************************
* Case C:
C   RHS(tvx,a)=(at,vx)+(FIMO(a,t)-Sum_u(au,ut))*delta(v,x)/NACTEL
************************************************************************

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(3,NBRA,IOBRA)
      CALL CHOVEC_SIZE(2,NKET,IOKET)

      CALL mma_allocate(BRA,NBRA,LABEL='BRA')
      CALL mma_allocate(KET,NKET,LABEL='KET')

      CALL CHOVEC_READ(3,BRA,NBRA)
      CALL CHOVEC_READ(2,KET,NKET)

      ICASE=4
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      NFIMOES=0
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE) !NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE) !NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Then
           NFIMOES=NFIMOES+(NORB(ISYM)*(NORB(ISYM)+1))/2
           Cycle
        End If

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IA=IISTA,IIEND
          ISYA=ISYM
          DO ITVX=IASTA,IAEND ! these are always all elements
            ITVXTOT=ITVX+NTUVES(ISYM)
            ITABS=MTUV(1,ITVXTOT)
            IVABS=MTUV(2,ITVXTOT)
            IXABS=MTUV(3,ITVXTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
            IX  =MTREL(1,IXABS)
            ISYX=MTREL(2,IXABS)
! compute integrals (at,vx)
            NV=NVTOT_CHOSYM(Mul(ISYA,ISYT)) ! JSYM=ISYT*ISYI=ISYU*ISYV
            IAT=IA-1+NSSH(ISYA)*(IT-1)
            IVX=IV-1+NASH(ISYV)*(IX-1)
            IOFFAT=1+IOBRA(ISYA,ISYT)+NV*IAT
            IOFFVX=1+IOKET(ISYV,ISYX)+NV*IVX
            ATVX=DDOT_(NV,BRA(IOFFAT),1,KET(IOFFVX),1)

! W(tvx,a) = (at,vx) + (FIMO(a,t)-Sum_u(au,ut))*delta(v,x)/NACTEL
! write element W(tvx,j), only the (at,vx) part
            IDX=ITVX+NAS*(IA-IISTA)
#ifdef _MOLCAS_MPP_
            DBL_MB(MW+IDX-1)=ATVX
#else
            GA_Arrays(lg_W)%A(IDX)=ATVX
#endif
          END DO
! now, add in the part with corrections to the integrals
          IATOT=IA+NISH(ISYM)+NASH(ISYM)
          DO IT=1,NASH(ISYM)
            ITTOT=IT+NISH(ISYM)
            FAT=FIMO(NFIMOES+(IATOT*(IATOT-1))/2+ITTOT)
            SUMU=Zero
            ITABS=NAES(ISYM)+IT
            DO IUABS=1,NASHT
              IUUT=KTUV(IUABS,IUABS,ITABS)-NTUVES(ISYM)
              IDX=IUUT+NAS*(IA-IISTA)
#ifdef _MOLCAS_MPP_
              SUMU=SUMU+DBL_MB(MW+IDX-1)
#else
              SUMU=SUMU+GA_Arrays(lg_w)%A(IDX)
#endif
            END DO
            ADDONE=(FAT-SUMU)/DBLE(MAX(1,NACTEL))
            DO IVABS=1,NASHT
              ITVV=KTUV(ITABS,IVABS,IVABS)-NTUVES(ISYM)
              IDX=ITVV+NAS*(IA-IISTA)
#ifdef _MOLCAS_MPP_
              DBL_MB(MW+IDX-1)=DBL_MB(MW+IDX-1)+ADDONE
#else
              GA_Arrays(lg_w)%A(IDX)=GA_Arrays(lg_w)%A(IDX)
     &                                  +ADDONE
#endif
            END DO
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)

        NFIMOES=NFIMOES+(NORB(ISYM)*(NORB(ISYM)+1))/2

      END DO
************************************************************************

      CALL mma_deallocate(BRA)
      CALL mma_deallocate(KET)

      END SUBROUTINE RHSOD_C_NOSYM

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_B_NOSYM(IVEC)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: Half
      USE SUPERINDEX, only: MIGEJ, MIREL, MTGEU, MTREL, MIGTJ, MTGTU
      USE CHOVEC_IO, only: NVTOT_ChoSym, ChoVec_Size, ChoVec_Read
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use stdalloc, only: mma_allocate, mma_deallocate
#ifndef _MOLCAS_MPP_
      use fake_GA, only: GA_Arrays
#endif
      use caspt2_module, only: nSym, nASup, nISup, NIGEJES, NTGEUES,
     &                         nAsh, NIGTJES, NTGTUES

      IMPLICIT None

      integer(kind=iwp), intent(in) :: iVec

      integer(kind=iwp) IOSYM(8,8)
      real(kind=wp), ALLOCATABLE:: CHOBUF(:)
      real(kind=wp), parameter:: SQRTH=SQRT(Half)
      real(kind=wp) BMTVJL, BPTVJL, SCL, TJVL, TLVJ
      integer(kind=iwp) IAEND, IASTA, iCASE, IDX, IIEND,
     &              IISTA, IJ, IJABS, IJGEL, IJGELTOT, IJGTL, IJGTLTOT,
     &              IL, ILABS, IOFFTJ, IOFFTL, IOFFVJ, IOFFVL, ISYJ,
     &              ISYL, ISYM, ISYT, ISYV, IT, ITABS, ITGEU,
     &              ITGEUTOT, ITGTU, ITGTUTOT, ITJ, ITL, IV, IVABS,
     &              IVJ, IVL, lg_W, MW, NAS, NCHOBUF, NIS, NV, NW
      real(kind=wp), external:: DDot_
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      IF (iPrGlb>=DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case B'
      END IF

************************************************************************
* Case B (2,3):
C   Let  W(tv,j,l)=(jt,lv):
C   BP(tv,jl)=((tj,vl)+(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
C   BM(tv,jl)=((tj,vl)-(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
************************************************************************

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(1,NCHOBUF,IOSYM)

      CALL mma_allocate(CHOBUF,NCHOBUF,LABEL='CHOBUF')

      CALL CHOVEC_READ(1,CHOBUF,NCHOBUF)

      iCASE=2
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Cycle

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IJGEL=IISTA,IIEND
          IJGELTOT=IJGEL+NIGEJES(ISYM)
          IJABS=MIGEJ(1,IJGELTOT)
          ILABS=MIGEJ(2,IJGELTOT)
          IJ  =MIREL(1,IJABS)
          ISYJ=MIREL(2,IJABS)
          IL  =MIREL(1,ILABS)
          ISYL=MIREL(2,ILABS)
          DO ITGEU=IASTA,IAEND ! these are always all elements
            ITGEUTOT=ITGEU+NTGEUES(ISYM)
            ITABS=MTGEU(1,ITGEUTOT)
            IVABS=MTGEU(2,ITGEUTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integrals (ajcl) and (alcj)
            NV=NVTOT_CHOSYM(Mul(ISYT,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
            ITJ=IT-1+NASH(ISYT)*(IJ-1)
            IVL=IV-1+NASH(ISYV)*(IL-1)
            IOFFTJ=1+IOSYM(ISYT,ISYJ)+NV*ITJ
            IOFFVL=1+IOSYM(ISYV,ISYL)+NV*IVL
            TJVL=DDOT_(NV,CHOBUF(IOFFTJ),1,CHOBUF(IOFFVL),1)

            NV=NVTOT_CHOSYM(Mul(ISYT,ISYL))
            ITL=IT-1+NASH(ISYT)*(IL-1)
            IVJ=IV-1+NASH(ISYV)*(IJ-1)
            IOFFTL=1+IOSYM(ISYT,ISYL)+NV*ITL
            IOFFVJ=1+IOSYM(ISYV,ISYJ)+NV*IVJ
            TLVJ=DDOT_(NV,CHOBUF(IOFFTL),1,CHOBUF(IOFFVJ),1)

! BP(tv,jl)=((tj,vl)+(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
            SCL=Half
            IF (ITABS==IVABS) SCL=SCL*Half
            IF (ILABS==IJABS) SCL=SCL*SQRTH
            BPTVJL=SCL*(TJVL+TLVJ)
! write element HP(ac,jl)
            IDX=ITGEU+NAS*(IJGEL-IISTA)
#ifdef _MOLCAS_MPP_
            DBL_MB(MW+IDX-1)=BPTVJL
#else
            GA_Arrays(lg_w)%A(IDX)=BPTVJL
#endif
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)
      END DO
************************************************************************



      iCASE=3
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Cycle

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IJGTL=IISTA,IIEND
          IJGTLTOT=IJGTL+NIGTJES(ISYM)
          IJABS=MIGTJ(1,IJGTLTOT)
          ILABS=MIGTJ(2,IJGTLTOT)
          IJ  =MIREL(1,IJABS)
          ISYJ=MIREL(2,IJABS)
          IL  =MIREL(1,ILABS)
          ISYL=MIREL(2,ILABS)
          DO ITGTU=IASTA,IAEND ! these are always all elements
            ITGTUTOT=ITGTU+NTGTUES(ISYM)
            ITABS=MTGTU(1,ITGTUTOT)
            IVABS=MTGTU(2,ITGTUTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integrals (tj,vl) and (tlvj)
            NV=NVTOT_CHOSYM(Mul(ISYT,ISYJ)) ! JSYM=ISYA*ISYJ=ISYC*ISYL
            ITJ=IT-1+NASH(ISYT)*(IJ-1)
            IVL=IV-1+NASH(ISYV)*(IL-1)
            IOFFTJ=1+IOSYM(ISYT,ISYJ)+NV*ITJ
            IOFFVL=1+IOSYM(ISYV,ISYL)+NV*IVL
            TJVL=DDOT_(NV,CHOBUF(IOFFTJ),1,CHOBUF(IOFFVL),1)

            NV=NVTOT_CHOSYM(Mul(ISYT,ISYL))
            ITL=IT-1+NASH(ISYT)*(IL-1)
            IVJ=IV-1+NASH(ISYV)*(IJ-1)
            IOFFTL=1+IOSYM(ISYT,ISYL)+NV*ITL
            IOFFVJ=1+IOSYM(ISYV,ISYJ)+NV*IVJ
            TLVJ=DDOT_(NV,CHOBUF(IOFFTL),1,CHOBUF(IOFFVJ),1)

! BM(tv,jl)=((tj,vl)-(tl,vj))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(j,l))
            SCL=Half
            !IF (ITABS==IVABS) SCL=SCL*0.5D0
            !IF (ILABS==IJABS) SCL=SCL*SQRTH
            BMTVJL=SCL*(TJVL-TLVJ)
! write element BM(tv,jl)
            IDX=ITGTU+NAS*(IJGTL-IISTA)
#ifdef _MOLCAS_MPP_
            DBL_MB(MW+IDX-1)=BMTVJL
#else
            GA_Arrays(lg_w)%A(IDX)=BMTVJL
#endif
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)
      END DO
************************************************************************

      CALL mma_deallocate(CHOBUF)

      END SUBROUTINE RHSOD_B_NOSYM

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_F_NOSYM(IVEC)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: Half
      USE SUPERINDEX, only: MAGEB, MAREL, MTGEU, MTREL, MAGTB, MTGTU
      USE CHOVEC_IO, only: NVTOT_CHOSYM, ChoVec_Size, ChoVec_Read
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use stdalloc, only: mma_allocate, mma_deallocate
#ifndef _MOLCAS_MPP_
      use fake_GA, only: GA_Arrays
#endif
      use caspt2_module, only: NSYM, NASUP, NISUP, NAGEBES, NTGEUES,
     &                         NSSH, NAGTBES, NTGTUES

      IMPLICIT None

      integer(kind=iwp), intent(in):: IVEC

      integer(kind=iwp) IOSYM(8,8)
      real(kind=wp), ALLOCATABLE:: CHOBUF(:)
      real(kind=wp), Parameter:: SQRTH=SQRT(Half)
      real(kind=wp) ATCV, AVCT, FMTVAC, FPTVAC, SCL
      integer(kind=iwp) IA, IAABS, IAEND, IASTA, IIEND, IISTA, MW,
     &                  IAGEB, IAGEBTOT, IAGTB, IAGTBTOT, IAT, IAV, IC,
     &                  ICABS, iCASE, ICT, ICV, IDX, IOFFAT, IOFFAV,
     &                  IOFFCT, IOFFCV, ISYA, ISYC, ISYM, ISYT, ISYV,
     &                  IT, ITABS, ITGEU, ITGEUTOT, ITGTU, ITGTUTOT,
     &                  IV, IVABS, lg_W, NAS, NCHOBUF, NIS, NV, NW
      real(kind=wp), external:: DDot_
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      IF (iPrGlb>=DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case F'
      END IF

************************************************************************
* Case F (8,9):
C FP(tv,ac)=((at,cv)+(av,ct))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(a,c))
C FM(tv,ac)= -((at,cv)-(av,ct))/(2*SQRT(1+Kron(a,c))
************************************************************************

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(3,NCHOBUF,IOSYM)

      CALL mma_allocate(CHOBUF,NCHOBUF,Label='CHOBUF')

      CALL CHOVEC_READ(3,CHOBUF,NCHOBUF)

      iCASE=8
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Cycle

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IAGEB=IISTA,IIEND
          IAGEBTOT=IAGEB+NAGEBES(ISYM)
          IAABS=MAGEB(1,IAGEBTOT)
          ICABS=MAGEB(2,IAGEBTOT)
          IA  =MAREL(1,IAABS)
          ISYA=MAREL(2,IAABS)
          IC  =MAREL(1,ICABS)
          ISYC=MAREL(2,ICABS)
          DO ITGEU=IASTA,IAEND ! these are always all elements
            ITGEUTOT=ITGEU+NTGEUES(ISYM)
            ITABS=MTGEU(1,ITGEUTOT)
            IVABS=MTGEU(2,ITGEUTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integrals (ta,vc) and (tc,va)
            NV=NVTOT_CHOSYM(Mul(ISYA,ISYT)) ! JSYM=ISYA*ISYA=ISYC*ISYC
            IAT=IA-1+NSSH(ISYA)*(IT-1)
            ICV=IC-1+NSSH(ISYC)*(IV-1)
            IOFFAT=1+IOSYM(ISYA,ISYT)+NV*IAT
            IOFFCV=1+IOSYM(ISYC,ISYV)+NV*ICV
            ATCV=DDOT_(NV,CHOBUF(IOFFAT),1,CHOBUF(IOFFCV),1)

            NV=NVTOT_CHOSYM(Mul(ISYA,ISYV)) ! JSYM=ISYA*ISYA=ISYC*ISYC
            IAV=IA-1+NSSH(ISYA)*(IV-1)
            ICT=IC-1+NSSH(ISYC)*(IT-1)
            IOFFAV=1+IOSYM(ISYA,ISYV)+NV*IAV
            IOFFCT=1+IOSYM(ISYC,ISYT)+NV*ICT
            AVCT=DDOT_(NV,CHOBUF(IOFFAV),1,CHOBUF(IOFFCT),1)

! FP(tv,ac)=((at,cv)+(av,ct))*(1-Kron(t,v)/2)/(2*SQRT(1+Kron(a,c))
            SCL=Half
            IF (ITABS==IVABS) SCL=SCL*Half
            IF (IAABS==ICABS) SCL=SCL*SQRTH
            FPTVAC=SCL*(ATCV+AVCT)
! write element FP(tv,ac)
            IDX=ITGEU+NAS*(IAGEB-IISTA)
#ifdef _MOLCAS_MPP_
            DBL_MB(MW+IDX-1)=FPTVAC
#else
            GA_Arrays(lg_W)%A(IDX)=FPTVAC
#endif
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)
      END DO
************************************************************************



      iCASE=9
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Cycle

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IAGTB=IISTA,IIEND
          IAGTBTOT=IAGTB+NAGTBES(ISYM)
          IAABS=MAGTB(1,IAGTBTOT)
          ICABS=MAGTB(2,IAGTBTOT)
          IA  =MAREL(1,IAABS)
          ISYA=MAREL(2,IAABS)
          IC  =MAREL(1,ICABS)
          ISYC=MAREL(2,ICABS)
          DO ITGTU=IASTA,IAEND ! these are always all elements
            ITGTUTOT=ITGTU+NTGTUES(ISYM)
            ITABS=MTGTU(1,ITGTUTOT)
            IVABS=MTGTU(2,ITGTUTOT)
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integrals (at,cv) and (av,ct)
            NV=NVTOT_CHOSYM(Mul(ISYA,ISYT)) ! JSYM=ISYA*ISYA=ISYC*ISYC
            IAT=IA-1+NSSH(ISYA)*(IT-1)
            ICV=IC-1+NSSH(ISYC)*(IV-1)
            IOFFAT=1+IOSYM(ISYA,ISYT)+NV*IAT
            IOFFCV=1+IOSYM(ISYC,ISYV)+NV*ICV
            ATCV=DDOT_(NV,CHOBUF(IOFFAT),1,CHOBUF(IOFFCV),1)

            NV=NVTOT_CHOSYM(Mul(ISYA,ISYV)) ! JSYM=ISYA*ISYA=ISYC*ISYC
            IAV=IA-1+NSSH(ISYA)*(IV-1)
            ICT=IC-1+NSSH(ISYC)*(IT-1)
            IOFFAV=1+IOSYM(ISYA,ISYV)+NV*IAV
            IOFFCT=1+IOSYM(ISYC,ISYT)+NV*ICT
            AVCT=DDOT_(NV,CHOBUF(IOFFAV),1,CHOBUF(IOFFCT),1)

! FM(tv,ac)= -((at,cv)-(av,ct))/(2*SQRT(1+Kron(a,c))
            SCL=Half
            !IF (ITABS==IVABS) SCL=SCL*0.5D0
            !IF (IAABS==ICABS) SCL=SCL*SQRTH
            FMTVAC=SCL*(AVCT-ATCV)
! write element FM(tv,ac)
            IDX=ITGTU+NAS*(IAGTB-IISTA)
#ifdef _MOLCAS_MPP_
            DBL_MB(MW+IDX-1)=FMTVAC
#else
            GA_Arrays(lg_w)%A(IDX)=FMTVAC
#endif
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)
      END DO
************************************************************************

      CALL mma_deallocate(CHOBUF)

      END SUBROUTINE RHSOD_F_NOSYM

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_H_NOSYM(IVEC)
      use definitions, only: iwp, wp
      use constants, only: Zero, Half, One, Three
      USE SUPERINDEX, only: MIGEJ, MAGEB, MIGTJ, MAGTB
      USE CHOVEC_IO, only: NVTOT_CHOSYM, ChoVec_Size, ChoVec_Read
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use stdalloc, only: mma_allocate, mma_deallocate
#ifndef _MOLCAS_MPP_
      use fake_GA, only: GA_Arrays
#endif
      use caspt2_module, only: NSSHT, NAGEB, NIGEJ, NAGTB, NIGTJ

      IMPLICIT None

      integer(kind=iwp), intent(in):: IVEC

      integer(kind=iwp) IOSYM(8,8)
      real(kind=wp), ALLOCATABLE:: CHOBUF(:)
      real(kind=wp) AJCL, ALCJ, HMACJL, HPACJL, SCL
      integer(kind=iwp) IA, IASTA, IAEND, IISTA, IIEND, MW, IAGEB,
     &                  IAGTB, IC, iCASE, IDX, IJ, IJGEL, IJGTL, IL,
     &                  lg_W, LIJOFF, LILOFF, NAS, NBLOCK, NCHOBUF,
     &                  NIS, NV, NW
*      Logical Incore
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif
      integer(kind=iwp), PARAMETER :: NOSYM = 1
      real(kind=wp), ALLOCATABLE :: AIBJ(:,:)
      real(kind=wp), parameter:: SQRT3=SQRT(Three), SQRTH=SQRT(Half)

      IF (iPrGlb>=DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case H'
      END IF

************************************************************************
* Case H:
C   WP(jl,ac)=((ajcl)+(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
C   WM(jl,ac)=((ajcl)-(alcj))*SQRT(3.0D0)
************************************************************************

      NV=NVTOT_CHOSYM(NOSYM)
      Call mma_ALLOCATE(AIBJ,NSSHT,NSSHT,Label='AIBJ')
      NBLOCK=NV*NSSHT

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(4,NCHOBUF,IOSYM)

      CALL mma_allocate(CHOBUF,NCHOBUF,Label='CHOBUF')

      CALL CHOVEC_READ(4,CHOBUF,NCHOBUF)

      iCASE=12

      NAS=NAGEB(NOSYM)
      NIS=NIGEJ(NOSYM)
      NW=NAS*NIS

      IF(NW/=0) Then

      CALL RHS_ALLO (NAS,NIS,lg_W)
      CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
      NW=NAS*(IIEND-IISTA+1)

      DO IJGEL=IISTA,IIEND
        IJ=MIGEJ(1,IJGEL)
        IL=MIGEJ(2,IJGEL)
        LIJOFF=1+NBLOCK*(IJ-1)
        LILOFF=1+NBLOCK*(IL-1)
        ! precompute integral blocks
        CALL DGEMM_('T','N',NSSHT,NSSHT,NV,
     &              One,CHOBUF(LIJOFF),NV,CHOBUF(LILOFF),NV,
     &              Zero,AIBJ,NSSHT)
        DO IAGEB=IASTA,IAEND ! these are always all elements
          IA=MAGEB(1,IAGEB)
          IC=MAGEB(2,IAGEB)
          AJCL=AIBJ(IA,IC)
          ALCJ=AIBJ(IC,IA)
! HP(ac,jl)=((ajcl)+(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
          SCL=One
          IF (IA==IC) SCL=SCL*SQRTH
          IF (IL==IJ) SCL=SCL*SQRTH
          HPACJL=SCL*(AJCL+ALCJ)
! write element HP(ac,jl)
          IDX=IAGEB+NAS*(IJGEL-IISTA)
#ifdef _MOLCAS_MPP_
          DBL_MB(MW+IDX-1)=HPACJL
#else
          GA_Arrays(lg_w)%A(IDX)=HPACJL
#endif
        END DO
      END DO
************************************************************************
      CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
      CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,NOSYM,iVEC)
      CALL RHS_FREE (lg_W)
************************************************************************
      End If

      iCASE=13

      NAS=NAGTB(NOSYM)
      NIS=NIGTJ(NOSYM)
      NW=NAS*NIS

      IF(NW/=0) Then

      CALL RHS_ALLO (NAS,NIS,lg_W)
      CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
      NW=NAS*(IIEND-IISTA+1)

      DO IJGTL=IISTA,IIEND
        IJ=MIGTJ(1,IJGTL)
        IL=MIGTJ(2,IJGTL)
        LIJOFF=1+NBLOCK*(IJ-1)
        LILOFF=1+NBLOCK*(IL-1)
        ! precompute integral blocks
        CALL DGEMM_('T','N',NSSHT,NSSHT,NV,
     &              One,CHOBUF(LIJOFF),NV,CHOBUF(LILOFF),NV,
     &              Zero,AIBJ,NSSHT)
        DO IAGTB=IASTA,IAEND ! these are always all elements
          IA=MAGTB(1,IAGTB)
          IC=MAGTB(2,IAGTB)
          AJCL=AIBJ(IA,IC)
          ALCJ=AIBJ(IC,IA)
! HM(ac,jl)=((ajcl)-(alcj))/SQRT((1+Kron(jl))*(1+Kron(ac))
          SCL=SQRT3
          HMACJL=SCL*(AJCL-ALCJ)
! write element HM(ac,jl)
          IDX=IAGTB+NAS*(IJGTL-IISTA)
#ifdef _MOLCAS_MPP_
          DBL_MB(MW+IDX-1)=HMACJL
#else
          GA_Arrays(lg_W)%A(IDX)=HMACJL
#endif
        END DO
      END DO
************************************************************************

      CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
      CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,NOSYM,iVEC)
      CALL RHS_FREE (lg_W)
      End If
************************************************************************

      CALL mma_deallocate(CHOBUF)

      call mma_DEALLOCATE(AIBJ)

      END SUBROUTINE RHSOD_H_NOSYM


*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_D_NOSYM(IVEC)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: One
      USE SUPERINDEX, only: MIA, MAREL, MIREL, MTU, MTREL, KTU
      USE CHOVEC_IO, only: NVTOT_CHOSYM, ChoVec_Size, ChoVec_Read
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use caspt2_global, only: FIMO
      use stdalloc, only: mma_allocate, mma_deallocate
#ifndef _MOLCAS_MPP_
      use fake_GA, only: GA_Arrays
#endif
      use caspt2_module, only: NACTEL, NASHT, NSYM, NORB, NASUP, NISUP,
     &                         NIAES, NTUES, NSSH, NASH, NISH, NISH

      IMPLICIT None

      integer(kind=iwp), intent(in):: IVEC

      integer(kind=iwp) IOBRA1(8,8), IOKET1(8,8), IOBRA2(8,8),
     &                  IOKET2(8,8)
      real(kind=wp), ALLOCATABLE:: BRABUF1(:), KETBUF1(:),
     &                      BRABUF2(:), KETBUF2(:)
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif
      integer(kind=iwp) NFIMOES(8)
      real(kind=wp) ACTINV, AJTV, AVTJ, FAJ, ONEADD
      integer(kind=iwp) IA, IAABS, NAS, NIS, lg_W, IASTA, IAEND, IISTA,
     &                  IIEND, MW, IAEND1, IAEND2, IAJ, IAJTOT, IASTA1,
     &                  IASTA2, IATOT, iCASE, IDX, IFIMOES, IJ, IJABS,
     &                  IOAJ, IOAV, IOFFAJ, IOFFAV, IOFFTJ, IOFFTV,
     &                  IOTJ, IOTV, ISYA, ISYJ, ISYM, ISYT, ISYV, IT,
     &                  ITABS, ITV, IUABS, IUU, IV, IVABS, NAS1,
     &                  NBRABUF1, NBRABUF2, NKETBUF1, NKETBUF2, NV, NW
      real(kind=wp), external:: DDot_

      IF (iPrGlb>=DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case D'
      END IF

************************************************************************
* Case D (5,6):
C D1(tv,aj)=(aj,tv) + FIMO(a,j)*Kron(t,v)/NACTEL
C D2(tv,aj)=(tj,av)
************************************************************************

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(4,NBRABUF1,IOBRA1)
      CALL CHOVEC_SIZE(2,NKETBUF1,IOKET1)

      CALL mma_allocate(BRABUF1,NBRABUF1,LABEL='BRABUF1')
      CALL mma_allocate(KETBUF1,NKETBUF1,LABEL='KETBUF1')

      CALL CHOVEC_READ(4,BRABUF1,NBRABUF1)
      CALL CHOVEC_READ(2,KETBUF1,NKETBUF1)

      CALL CHOVEC_SIZE(3,NBRABUF2,IOBRA2)
      CALL CHOVEC_SIZE(1,NKETBUF2,IOKET2)

      CALL mma_allocate(BRABUF2,NBRABUF2,LABEL='BRABUF2')
      CALL mma_allocate(KETBUF2,NKETBUF2,LABEL='KETBUF2')

      CALL CHOVEC_READ(3,BRABUF2,NBRABUF2)
      CALL CHOVEC_READ(1,KETBUF2,NKETBUF2)

      iCASE=5
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      ! set up FIMO access
      ACTINV=One/DBLE(MAX(1,NACTEL))
      IFIMOES=0
      DO ISYM=1,NSYM
        NFIMOES(ISYM)=IFIMOES
        IFIMOES=IFIMOES+(NORB(ISYM)*(NORB(ISYM)+1))/2
      END DO

      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Cycle

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

! cases D1, D2 share the RHS along the tu superindex
        NAS1=NAS/2
        IASTA1=IASTA
        IAEND1=IAEND/2
        IASTA2=IAEND1+1
        IAEND2=IAEND

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
        DO IAJ=IISTA,IIEND
          IAJTOT=IAJ+NIAES(ISYM)
          IJABS=MIA(1,IAJTOT)
          IAABS=MIA(2,IAJTOT)
          IA  =MAREL(1,IAABS)
          ISYA=MAREL(2,IAABS)
          IJ  =MIREL(1,IJABS)
          ISYJ=MIREL(2,IJABS)
          DO ITV=IASTA1,IAEND1 ! these are always all elements
            ITABS=MTU(1,ITV+NTUES(ISYM))
            IVABS=MTU(2,ITV+NTUES(ISYM))
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integral (aj,tv)
            NV=NVTOT_CHOSYM(Mul(ISYA,ISYJ))
            IOAJ=IA-1+NSSH(ISYA)*(IJ-1)
            IOTV=IT-1+NASH(ISYT)*(IV-1)
            IOFFAJ=1+IOBRA1(ISYA,ISYJ)+NV*IOAJ
            IOFFTV=1+IOKET1(ISYT,ISYV)+NV*IOTV
            AJTV=DDOT_(NV,BRABUF1(IOFFAJ),1,KETBUF1(IOFFTV),1)

! D1(tv,aj)=(aj,tv) + FIMO(a,j)*Kron(t,v)/NACTEL
! integrals only
            IDX=ITV+NAS*(IAJ-IISTA)
#ifdef _MOLCAS_MPP_
            DBL_MB(MW+IDX-1)=AJTV
#else
            GA_Arrays(lg_w)%A(IDX)=AJTV
#endif
          END DO
! now, dress with FIMO(a,j), only if T==V, so ISYT==ISYV, so if ISYM==1
          IF (ISYM==1) THEN
            IATOT=IA+NISH(ISYA)+NASH(ISYA)
            FAJ=FIMO(NFIMOES(ISYA)+(IATOT*(IATOT-1))/2+IJ)
            ONEADD=FAJ*ACTINV
            DO IUABS=1,NASHT
              IUU=KTU(IUABS,IUABS)
              IDX=IUU+NAS*(IAJ-IISTA)
#ifdef _MOLCAS_MPP_
              DBL_MB(MW+IDX-1)=DBL_MB(MW+IDX-1)+ONEADD
#else
              GA_Arrays(lg_w)%A(IDX)=GA_Arrays(lg_w)%A(IDX)
     &                                  +ONEADD
#endif
            END DO
          END IF
          DO ITV=IASTA2,IAEND2 ! these are always all elements
            ITABS=MTU(1,ITV-NAS1+NTUES(ISYM))
            IVABS=MTU(2,ITV-NAS1+NTUES(ISYM))
            IT  =MTREL(1,ITABS)
            ISYT=MTREL(2,ITABS)
            IV  =MTREL(1,IVABS)
            ISYV=MTREL(2,IVABS)
! compute integral (av,tj)
            NV=NVTOT_CHOSYM(Mul(ISYA,ISYV))
            IOAV=IA-1+NSSH(ISYA)*(IV-1)
            IOTJ=IT-1+NASH(ISYT)*(IJ-1)
            IOFFAV=1+IOBRA2(ISYA,ISYV)+NV*IOAV
            IOFFTJ=1+IOKET2(ISYT,ISYJ)+NV*IOTJ
            AVTJ=DDOT_(NV,BRABUF2(IOFFAV),1,KETBUF2(IOFFTJ),1)

! D2(tv,aj)=(av,tj) + FIMO(a,j)*Kron(t,v)/NACTEL
            IDX=ITV+NAS*(IAJ-IISTA)
#ifdef _MOLCAS_MPP_
            DBL_MB(MW+IDX-1)=AVTJ
#else
            GA_Arrays(lg_W)%A(IDX)=AVTJ
#endif
          END DO
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)

      END DO
************************************************************************

      CALL mma_deallocate(BRABUF1)
      CALL mma_deallocate(KETBUF1)

      CALL mma_deallocate(BRABUF2)
      CALL mma_deallocate(KETBUF2)

************************************************************************

      END SUBROUTINE RHSOD_D_NOSYM

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_E_NOSYM(IVEC)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use Constants, only: Half, OneHalf
      USE SUPERINDEX, only: MIGEJ, MIREL, MIGTJ, MIREL
      USE CHOVEC_IO, only: NVTOT_CHOSYM, ChoVec_Size, ChoVec_Read
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use stdalloc, only: mma_allocate, mma_deallocate
#ifndef _MOLCAS_MPP_
      use fake_GA, only: GA_Arrays
#endif
      use caspt2_module, only: NSYM, NASUP, NISUP, NSSH, NIGEJ,
     &                         NASH, NIGEJES, NIGTJ, NIGTJES

      IMPLICIT None

      integer(kind=iwp), intent(in):: IVEC

      integer(kind=iwp) IOBRA(8,8), IOKET(8,8)
      real(kind=wp), ALLOCATABLE:: BRABUF(:), KETBUF(:)
      real(kind=wp), parameter:: SQRTH=SQRT(Half), SQRTA=SQRT(OneHalf)
      real(kind=wp) AJVL, ALVJ, EM, EP, SCL
      integer(kind=iwp) IA, NAS, NIS, lg_W, IASTA, IAEND, IISTA, IIEND,
     &                  MW, IAJ, IAJGEL, IAJGELEND, IAJGELSTA, IAJGTL,
     &                  IAJGTLEND, IAJGTLSTA, IAL, iCASE, IDX, IJ,
     &                  IJABS, IJGEL, IJGELTOT, IJGTL, IJGTLTOT, IL,
     &                  ILABS, IOFF, IOFFAJ, IOFFAL, IOFFVJ, IOFFVL,
     &                  ISYA, ISYJ, ISYJL, ISYL, ISYM, ISYV, IV, IVJ,
     &                  IVL, NA, NBRABUF, NJL, NKETBUF, NV, NW
      real(kind=wp), External:: DDot_
*      Logical Incore
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      IF (iPrGlb>=DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case E'
      END IF

************************************************************************
* Case E (6,7):
C EP(v,ajl)=((aj,vl)+(al,vj))/SQRT(2+2*Kron(j,l))
C EM(v,ajl)=((aj,vl)-(al,vj))*SQRT(3/2)
************************************************************************

* -SVC- Case E is slightly special, in that the inactive superindices are
* so large, that it is suboptimal to have a direct translation table for
* them. Instead, the code loops over symmetry blocks of A-JL and figures
* out if the indices on the processor fall within a block or not. Within
* a A-JL symmetry block, NA(ISYA) and NIGEJ(ISYJL) are known, so they can
* be determined by integer division. This could be optimized by combining
* it with loop peeling (on the todo list?).


************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(4,NBRABUF,IOBRA)
      CALL CHOVEC_SIZE(1,NKETBUF,IOKET)

      CALL mma_allocate(BRABUF,NBRABUF,LABEL='BRABUF')
      CALL mma_allocate(KETBUF,NKETBUF,LABEL='KETBUF')

      CALL CHOVEC_READ(4,BRABUF,NBRABUF)
      CALL CHOVEC_READ(1,KETBUF,NKETBUF)

      iCASE=6
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Cycle

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
! find start and end block
        IOFF=0
        DO ISYA=1,NSYM
          ISYJL=Mul(ISYA,ISYM)
          ISYV=ISYM

          NA=NSSH(ISYA)
          NJL=NIGEJ(ISYJL)
          ! what is start/end in this block?
          IAJGELSTA=MAX(IISTA-IOFF,1)
          IAJGELEND=MIN(IIEND-IOFF,NA*NJL)

          DO IAJGEL=IAJGELSTA,IAJGELEND
            IJGEL=(IAJGEL-1)/NA+1
            IA=IAJGEL-NA*(IJGEL-1)
            IJGELTOT=IJGEL+NIGEJES(ISYJL)
            IJABS=MIGEJ(1,IJGELTOT)
            ILABS=MIGEJ(2,IJGELTOT)
            IJ  =MIREL(1,IJABS)
            ISYJ=MIREL(2,IJABS)
            IL  =MIREL(1,ILABS)
            ISYL=MIREL(2,ILABS)
            DO IV=IASTA,IAEND ! these are always all elements
! compute integrals (ajvl) and (alvj)
              NV=NVTOT_CHOSYM(Mul(ISYA,ISYJ))
              IAJ=IA-1+NSSH(ISYA)*(IJ-1)
              IVL=IV-1+NASH(ISYV)*(IL-1)
              IOFFAJ=1+IOBRA(ISYA,ISYJ)+NV*IAJ
              IOFFVL=1+IOKET(ISYV,ISYL)+NV*IVL
              AJVL=DDOT_(NV,BRABUF(IOFFAJ),1,KETBUF(IOFFVL),1)

              NV=NVTOT_CHOSYM(Mul(ISYA,ISYL))
              IAL=IA-1+NSSH(ISYA)*(IL-1)
              IVJ=IV-1+NASH(ISYV)*(IJ-1)
              IOFFAL=1+IOBRA(ISYA,ISYL)+NV*IAL
              IOFFVJ=1+IOKET(ISYV,ISYJ)+NV*IVJ
              ALVJ=DDOT_(NV,BRABUF(IOFFAL),1,KETBUF(IOFFVJ),1)

! EP(v,ajl)=((aj,vl)+(al,vj))/SQRT(2+2*Kron(j,l))
              IF (ILABS==IJABS) THEN
                SCL=Half
              ELSE
                SCL=SQRTH
              END IF
              EP=SCL*(AJVL+ALVJ)
! write element EP
              IDX=IV+NAS*(IAJGEL+IOFF-IISTA)
#ifdef _MOLCAS_MPP_
              DBL_MB(MW+IDX-1)=EP
#else
              GA_Arrays(lg_w)%A(IDX)=EP
#endif
            END DO
          END DO

          IOFF=IOFF+NA*NJL
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)
      END DO
************************************************************************



      iCASE=7
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Cycle

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
! find start and end block
        IOFF=0
        DO ISYA=1,NSYM
          ISYJL=Mul(ISYA,ISYM)
          ISYV=ISYM

          NA=NSSH(ISYA)
          NJL=NIGTJ(ISYJL)
          ! what is start/end in this block?
          IAJGTLSTA=MAX(IISTA-IOFF,1)
          IAJGTLEND=MIN(IIEND-IOFF,NA*NJL)

          DO IAJGTL=IAJGTLSTA,IAJGTLEND
            IJGTL=(IAJGTL-1)/NA+1
            IA=IAJGTL-NA*(IJGTL-1)
            IJGTLTOT=IJGTL+NIGTJES(ISYJL)
            IJABS=MIGTJ(1,IJGTLTOT)
            ILABS=MIGTJ(2,IJGTLTOT)
            IJ  =MIREL(1,IJABS)
            ISYJ=MIREL(2,IJABS)
            IL  =MIREL(1,ILABS)
            ISYL=MIREL(2,ILABS)
            DO IV=IASTA,IAEND ! these are always all elements
! compute integrals (ajvl) and (alvj)
              NV=NVTOT_CHOSYM(Mul(ISYA,ISYJ))
              IAJ=IA-1+NSSH(ISYA)*(IJ-1)
              IVL=IV-1+NASH(ISYV)*(IL-1)
              IOFFAJ=1+IOBRA(ISYA,ISYJ)+NV*IAJ
              IOFFVL=1+IOKET(ISYV,ISYL)+NV*IVL
              AJVL=DDOT_(NV,BRABUF(IOFFAJ),1,KETBUF(IOFFVL),1)

              NV=NVTOT_CHOSYM(Mul(ISYA,ISYL))
              IAL=IA-1+NSSH(ISYA)*(IL-1)
              IVJ=IV-1+NASH(ISYV)*(IJ-1)
              IOFFAL=1+IOBRA(ISYA,ISYL)+NV*IAL
              IOFFVJ=1+IOKET(ISYV,ISYJ)+NV*IVJ
              ALVJ=DDOT_(NV,BRABUF(IOFFAL),1,KETBUF(IOFFVJ),1)

! EM(v,ajl)=((aj,vl)-(al,vj))*SQRT(3/2)
              EM=SQRTA*(AJVL-ALVJ)
! write element EM
              IDX=IV+NAS*(IAJGTL+IOFF-IISTA)
#ifdef _MOLCAS_MPP_
              DBL_MB(MW+IDX-1)=EM
#else
              GA_Arrays(lg_w)%A(IDX)=EM
#endif
            END DO
          END DO

          IOFF=IOFF+NA*NJL
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)
      END DO
************************************************************************

      CALL mma_deallocate(BRABUF)
      CALL mma_deallocate(KETBUF)

      END SUBROUTINE RHSOD_E_NOSYM

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHSOD_G_NOSYM(IVEC)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp
      use constants, only: Half, OneHalf
      USE SUPERINDEX, only: MAGEB, MAREL, MAGTB
      USE CHOVEC_IO, only: NVTOT_CHOSYM, ChoVec_Size, ChoVec_Read
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
      use stdalloc, only: mma_allocate, mma_deallocate
#ifndef _MOLCAS_MPP_
      use fake_GA, only: GA_Arrays
#endif
      use caspt2_module, only: NSYM, NASUP, NISUP, NISH, NAGEB,
     &                         NAGEBES, NSSH, NAGTB, NAGTBES

      IMPLICIT None

      integer(iwp), intent(in):: IVEC

      integer(iwp) IOBRA(8,8), IOKET(8,8)
      real(kind=wp), ALLOCATABLE:: BRABUF(:), KETBUF(:)
      real(kind=wp), parameter:: SQRTH=SQRT(Half), SQRTA=SQRT(OneHalf)
      real(kind=wp) AVCJ, CVAJ, GM, GP, SCL
      integer(iwp) IA, IAABS, NAS, NIS, lg_W, IASTA, IAEND, IISTA,
     &             IIEND, MW, IAGEC, IAGECTOT, IAGTC, IAGTCTOT, IAJ,
     &             IAV, IC, ICABS, iCASE, ICJ, ICV, IDX, IJ, IJAGEC,
     &             IJAGECEND, IJAGECSTA, IJAGTC, IJAGTCEND, IJAGTCSTA,
     &             IOFF, IOFFAJ, IOFFAV, IOFFCJ, IOFFCV, ISYA, ISYAC,
     &             ISYC, ISYJ, ISYM, ISYV, IV, NAC, NBRABUF, NJ,
     &             NKETBUF, NV, NW
      real(kind=wp), external:: DDOT_
*      Logical Incore
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      IF (iPrGlb>=DEBUG) THEN
        WRITE(6,*) 'RHS on demand: case G'
      END IF

************************************************************************
* Case G (10,11):
C GP(v,jac)=((av,cj)+(cv,aj))/SQRT(2+2*Kron(a,b))
C GM(v,jac)=((av,cj)-(cv,aj))*SQRT(3/2)
************************************************************************

* -SVC- Case G is slightly special, in that the inactive superindices are
* so large, that it is suboptimal to have a direct translation table for
* them. Instead, the code loops over symmetry blocks of J-AC and figures
* out if the indices on the processor fall within a block or not. Within
* a J-AC symmetry block, NJ(ISYJ) and NAGEB(ISYAC) are known, so they can
* be determined by integer division. This could be optimized by combining
* it with loop peeling (on the todo list?).

************************************************************************
CSVC: read in all the cholesky vectors (need all symmetries)
************************************************************************
      CALL CHOVEC_SIZE(3,NBRABUF,IOBRA)
      CALL CHOVEC_SIZE(4,NKETBUF,IOKET)

      CALL mma_allocate(BRABUF,NBRABUF,LABEL='BRABUF')
      CALL mma_allocate(KETBUF,NKETBUF,LABEL='KETBUF')

      CALL CHOVEC_READ(3,BRABUF,NBRABUF)
      CALL CHOVEC_READ(4,KETBUF,NKETBUF)

      iCASE=10
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Cycle

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
! find start and end block
        IOFF=0
        DO ISYJ=1,NSYM
          ISYAC=Mul(ISYJ,ISYM)
          ISYV=ISYM

          NJ=NISH(ISYJ)
          NAC=NAGEB(ISYAC)
          ! what is start/end in this block?
          IJAGECSTA=MAX(IISTA-IOFF,1)
          IJAGECEND=MIN(IIEND-IOFF,NJ*NAC)

          DO IJAGEC=IJAGECSTA,IJAGECEND
            IAGEC=(IJAGEC-1)/NJ+1
            IJ=IJAGEC-NJ*(IAGEC-1)
            IAGECTOT=IAGEC+NAGEBES(ISYAC)
            IAABS=MAGEB(1,IAGECTOT)
            ICABS=MAGEB(2,IAGECTOT)
            IA  =MAREL(1,IAABS)
            ISYA=MAREL(2,IAABS)
            IC  =MAREL(1,ICABS)
            ISYC=MAREL(2,ICABS)
            DO IV=IASTA,IAEND ! these are always all elements
! compute integrals (ajvl) and (alvj)
              NV=NVTOT_CHOSYM(Mul(ISYA,ISYV))
              IAV=IA-1+NSSH(ISYA)*(IV-1)
              ICJ=IC-1+NSSH(ISYC)*(IJ-1)
              IOFFAV=1+IOBRA(ISYA,ISYV)+NV*IAV
              IOFFCJ=1+IOKET(ISYC,ISYJ)+NV*ICJ
              AVCJ=DDOT_(NV,BRABUF(IOFFAV),1,KETBUF(IOFFCJ),1)

              NV=NVTOT_CHOSYM(Mul(ISYC,ISYV))
              ICV=IC-1+NSSH(ISYC)*(IV-1)
              IAJ=IA-1+NSSH(ISYA)*(IJ-1)
              IOFFCV=1+IOBRA(ISYC,ISYV)+NV*ICV
              IOFFAJ=1+IOKET(ISYA,ISYJ)+NV*IAJ
              CVAJ=DDOT_(NV,BRABUF(IOFFCV),1,KETBUF(IOFFAJ),1)

C GP(v,jac)=((av,cj)+(cv,aj))/SQRT(2+2*Kron(a,b))
              IF (IAABS==ICABS) THEN
                SCL=Half
              ELSE
                SCL=SQRTH
              END IF
              GP=SCL*(AVCJ+CVAJ)
! write element EP
              IDX=IV+NAS*(IJAGEC+IOFF-IISTA)
#ifdef _MOLCAS_MPP_
              DBL_MB(MW+IDX-1)=GP
#else
              GA_Arrays(lg_w)%A(IDX)=GP
#endif
            END DO
          END DO

          IOFF=IOFF+NJ*NAC
        END DO
************************************************************************

        CALL RHS_RELEASE_UPDATE (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)
      END DO
************************************************************************



      iCASE=11
************************************************************************
* outer loop over symmetry blocks in the RHS
************************************************************************
      DO ISYM=1,NSYM

        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS

        IF(NW==0) Cycle

        CALL RHS_ALLO (NAS,NIS,lg_W)
        CALL RHS_ACCESS (NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
        NW=NAS*(IIEND-IISTA+1)

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
! find start and end block
        IOFF=0
        DO ISYJ=1,NSYM
          ISYAC=Mul(ISYJ,ISYM)
          ISYV=ISYM

          NJ=NISH(ISYJ)
          NAC=NAGTB(ISYAC)
          ! what is start/end in this block?
          IJAGTCSTA=MAX(IISTA-IOFF,1)
          IJAGTCEND=MIN(IIEND-IOFF,NJ*NAC)

          DO IJAGTC=IJAGTCSTA,IJAGTCEND
            IAGTC=(IJAGTC-1)/NJ+1
            IJ=IJAGTC-NJ*(IAGTC-1)
            IAGTCTOT=IAGTC+NAGTBES(ISYAC)
            IAABS=MAGTB(1,IAGTCTOT)
            ICABS=MAGTB(2,IAGTCTOT)
            IA  =MAREL(1,IAABS)
            ISYA=MAREL(2,IAABS)
            IC  =MAREL(1,ICABS)
            ISYC=MAREL(2,ICABS)
            DO IV=IASTA,IAEND ! these are always all elements
! compute integrals (ajvl) and (alvj)
              NV=NVTOT_CHOSYM(Mul(ISYA,ISYV))
              IAV=IA-1+NSSH(ISYA)*(IV-1)
              ICJ=IC-1+NSSH(ISYC)*(IJ-1)
              IOFFAV=1+IOBRA(ISYA,ISYV)+NV*IAV
              IOFFCJ=1+IOKET(ISYC,ISYJ)+NV*ICJ
              AVCJ=DDOT_(NV,BRABUF(IOFFAV),1,KETBUF(IOFFCJ),1)

              NV=NVTOT_CHOSYM(Mul(ISYC,ISYV))
              ICV=IC-1+NSSH(ISYC)*(IV-1)
              IAJ=IA-1+NSSH(ISYA)*(IJ-1)
              IOFFCV=1+IOBRA(ISYC,ISYV)+NV*ICV
              IOFFAJ=1+IOKET(ISYA,ISYJ)+NV*IAJ
              CVAJ=DDOT_(NV,BRABUF(IOFFCV),1,KETBUF(IOFFAJ),1)

C GM(v,jac)=((av,cj)-(cv,aj))*SQRT(3/2)
              GM=SQRTA*(AVCJ-CVAJ)
! write element GM
              IDX=IV+NAS*(IJAGTC+IOFF-IISTA)
#ifdef _MOLCAS_MPP_
              DBL_MB(MW+IDX-1)=GM
#else
              GA_Arrays(lg_w)%A(IDX)=GM
#endif
            END DO
          END DO

          IOFF=IOFF+NJ*NAC
        END DO
************************************************************************

        CALL RHS_Release_Update (lg_W,IASTA,IAEND,IISTA,IIEND)
        CALL RHS_SAVE (NAS,NIS,lg_W,iCASE,iSYM,iVEC)
        CALL RHS_FREE (lg_W)
      END DO
************************************************************************

      CALL mma_deallocate(BRABUF)
      CALL mma_deallocate(KETBUF)

      END SUBROUTINE RHSOD_G_NOSYM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine contf14 (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,
     &                     lunt2o3)
c
c     this routine do:
c     2)  FI4   f1(a,e) <- -sum(m>n,f) [Tap(af,mn) . <ef||mn>]
c
c     N.B. use and destroy : V1,V2,V3,V4,M1
c     N.B. # of get v2o2 : 6
c     N.B. possible fusion with f24 graph
c
       use Para_Info, only: MyRank
       implicit none
#include "ccsd2.fh"
#include "parallel.fh"
#include "wrk.fh"
       integer lunabij1,lunabij2,lunabij3,lunt2o1,lunt2o2,lunt2o3
c
c     help variables
c
       integer posst,rc,ssc
c
c1    f1(a,e)aa <- -sum(m>n,f-aaa) [ Tap(a,f,mn)aaaa . <ef||mn>aaaa ]
c
cpar
      if (myRank.eq.idbaab) then
c
c1.1  read V1(af,mn) <= T2o(af,mn)aaaa
       call filemanager (2,lunt2o1,rc)
       call getmediate (wrk,wrksize,
     & lunt2o1,possv10,mapdv1,mapiv1,rc)
c
c1.2  make Tap V1(af,mn) from V1(af,mn)
       call mktau (wrk,wrksize,
     & mapdv1,mapiv1,mapdt11,mapit11,mapdt12,mapit12,0.5d0,
     &             rc)
c
c1.3  expand V2(a,f,mn) <= V1(af,mn)
       call expand (wrk,wrksize,
     & 4,5,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c1.4  read V1(ef,mn) <= <ef||mn>aaaa
       call filemanager (2,lunabij1,rc)
       call getmediate (wrk,wrksize,
     & lunabij1,possv10,mapdv1,mapiv1,rc)
c
c1.5  expand V3(e,f,mn) <= V1(ef,mn)
       call expand (wrk,wrksize,
     & 4,5,mapdv1,mapiv1,1,possv30,mapdv3,mapiv3,rc)
c
c1.6  map V1(f,mn,e) <= V3(e,f,mn)
       call map (wrk,wrksize,
     & 4,4,1,2,3,mapdv3,mapiv3,1,mapdv1,mapiv1,possv10,posst,
     &           rc)
c
c1.7  mult M1(a,e) <= V2(a,f,mn) . V1(f,mn,e)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c1.8  add f1(a,e)aa <- M1(a,e)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,-1.0d0,mapdm1,1,mapdf11,mapif11,1,rc)
c
       end if
c
c
c2    f1(a,e)bb <- -sum(m>n,f-bbb) [ Tap(a,f,mn)bbbb . <ef||mn>bbbb ]
c
cpar
      if (myRank.eq.idaabb) then
c
c2.1  read V1(af,mn) <= T2o(af,mn)bbbb
       call filemanager (2,lunt2o2,rc)
       call getmediate (wrk,wrksize,
     & lunt2o2,possv10,mapdv1,mapiv1,rc)
c
c2.2  make Tap V1(af,mn) from V1(af,mn)
       call mktau (wrk,wrksize,
     & mapdv1,mapiv1,mapdt11,mapit11,mapdt12,mapit12,0.5d0,
     &             rc)
c
c2.3  expand V2(a,f,mn) <= V1(af,mn)
       call expand (wrk,wrksize,
     & 4,5,mapdv1,mapiv1,1,possv20,mapdv2,mapiv2,rc)
c
c2.4  read V1(ef,mn) <= <ef||mn>bbbb
       call filemanager (2,lunabij2,rc)
       call getmediate (wrk,wrksize,
     & lunabij2,possv10,mapdv1,mapiv1,rc)
c
c2.5  expand V3(e,f,mn) <= V1(ef,mn)
       call expand (wrk,wrksize,
     & 4,5,mapdv1,mapiv1,1,possv30,mapdv3,mapiv3,rc)
c
c2.6  map V1(f,mn,e) <= V3(e,f,mn)
       call map (wrk,wrksize,
     & 4,4,1,2,3,mapdv3,mapiv3,1,mapdv1,mapiv1,possv10,posst,
     &           rc)
c
c2.7  mult M1(a,e) <= V2(a,f,mn) . V1(f,mn,e)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv2,mapiv2,1,mapdv1,mapiv1,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c2.8  add f1(a,e)bb <- M1(a,e)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,-1.0d0,mapdm1,1,mapdf12,mapif12,1,rc)
c
       end if
c
c
c3    f1(a,e)aa <- -sum(m,n,f-abb) [ Tap(a,f,m,n)abab . <ef||mn>abab
c4    f1(a,e)bb <- -sum(m,n,f-aba) [ Tap(f,a,m,n)abab . <fe||mn>abab
c
cpar
      if ((myRank.eq.idbaab).or.(myRank.eq.idaabb)) then
c
c34.1 read V1(c,d,m,n) <= T2o(c,d,m,n)abab
       call filemanager (2,lunt2o3,rc)
       call getmediate (wrk,wrksize,
     & lunt2o3,possv10,mapdv1,mapiv1,rc)
c
c34.2 read V2(c,d,m,n) <= <cd||mn>abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,possv20,mapdv2,mapiv2,rc)
c
c34.3 make Tap V1(c,d,m,n) from V1(c,d,m,n)
       call mktau (wrk,wrksize,
     & mapdv1,mapiv1,mapdt11,mapit11,mapdt12,mapit12,0.5d0,
     &             rc)
c
c
c3.1  map V3(f,m,n,e) <= V2(e,f,m,n)
       call map (wrk,wrksize,
     & 4,4,1,2,3,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
c
      end if
c
cpar
      if (myRank.eq.idbaab) then
c
c3.2  mult M1(a,e) <= V1(a,f,m,n) . V3(f,m,n,e)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv1,mapiv1,1,mapdv3,mapiv3,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c3.3  add f1(a,e))aa <- - M1(a,e)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,-1.0d0,mapdm1,1,mapdf11,mapif11,1,rc)
      end if
c
c
cpar
      if (myRank.eq.idaabb) then
c
c4.1  map V4(a,f,m,n) <= V1(f,a,m,n)
       call map (wrk,wrksize,
     & 4,2,1,3,4,mapdv1,mapiv1,1,mapdv4,mapiv4,possv40,posst,
     &           rc)
c
c4.2  map V3(f,m,n,e) <= V2 (f,e,m,n)
       call map (wrk,wrksize,
     & 4,1,4,2,3,mapdv2,mapiv2,1,mapdv3,mapiv3,possv30,posst,
     &           rc)
c
c4.3  mult M1(a,e) <= V4(a,f,m,n) . V3(f,m,n,e)
       call mult (wrk,wrksize,
     & 4,4,2,3,mapdv4,mapiv4,1,mapdv3,mapiv3,1,mapdm1,mapim1,
     &            ssc,possm10,rc)
c
c4.4  add f1(a,e))bb <- - M1(a,e)
       call add (wrk,wrksize,
     & 2,2,0,0,0,0,1,1,-1.0d0,mapdm1,1,mapdf12,mapif12,1,rc)
c
        end if
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_IniLQ(MaxQual,nSym)

use Cholesky, only: Cho_Real_Par, iQL2G, iQuAB_L, iQuAB_L_Hidden, nQual_L
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: MaxQual, nSym

if (Cho_Real_Par) then
  call mma_allocate(iQuAB_L_Hidden,MaxQual,nSym,Label='iQuAB_L_Hidden')
  iQuAB_L => iQuAB_L_Hidden
  call mma_allocate(iQL2G,MaxQual,nSym,Label='iQL2G')
end if

nQual_L(:) = 0

end subroutine Cho_P_IniLQ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine oneexc2_cvb(cfrom,cto,vij,
     > i1alf,i1bet,iato,ibto,phato,phbto,
     > iapr,ixapr,ibpr,ixbpr,npvb,
     > nda,ndb,n1a,n1b,nam1,nbm1,norb,commut,sc,absym,diag,idens,
     > iPvb)
c  Calculates Cto = Pvb Eij Cfrom
      implicit real*8 (a-h,o-z)
      logical commut,sc,absym,diag
      dimension cfrom(nda,ndb),cto(nda,ndb)
      dimension vij(*)
      dimension i1alf(n1a,norb),i1bet(n1b,norb)
      dimension iato(norb,0:nam1),ibto(norb,0:nbm1)
      dimension phato(norb,nam1),phbto(norb,nbm1)
      dimension iapr(npvb),ixapr(nda+1),ibpr(npvb),ixbpr(ndb+1)
      save two,half,thresh
      data two/2d0/,half/.5d0/,thresh/1.d-10/

      if(diag)then
        nvij=norb*norb
      elseif(idens.eq.1)then
        nvij=norb*(norb-1)
      endif
      if(absym)then
        if(idens.eq.0)then
          call dscal_(nda*ndb,half,cto,1)
        else
          call dscal_(nvij,half,vij,1)
        endif
      endif
      iprm=0
      do 1100 jorb=1,norb
      do 1200 iorb=1,norb
      if(iorb.eq.jorb.and..not.diag)goto 1200
      iprm=iprm+1
      if(idens.eq.0.and.abs(vij(iprm)).lt.thresh)goto 1200
      if(.not.sc)then
c  a) Alpha excitation
      do 2100 ia=1,n1a
      iaxtmp=i1alf(ia,iorb)
      jax=iato(jorb,iaxtmp)
      if(jax.ne.0)then
        iax=iato(iorb,iaxtmp)
        if(idens.eq.0)then
          tcof=vij(iprm)*phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          if(iPvb.eq.0)then
            call daxpy_(ndb,tcof,cfrom(jax,1),nda,cto(iax,1),nda)
          elseif(iPvb.eq.1)then
            do 2200 ixa=ixapr(jax),ixapr(jax+1)-1
            ibx=iapr(ixa)
            cto(iax,ibx)=cto(iax,ibx)+tcof*cfrom(jax,ibx)
2200        continue
          elseif(iPvb.eq.2)then
            do 2300 ixa=ixapr(iax),ixapr(iax+1)-1
            ibx=iapr(ixa)
            cto(iax,ibx)=cto(iax,ibx)+tcof*cfrom(jax,ibx)
2300        continue
          endif
        else
          tcof=phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          if(iPvb.eq.0)then
            vij(iprm)=vij(iprm)+tcof*
     >        ddot_(ndb,cto(iax,1),nda,cfrom(jax,1),nda)
          elseif(iPvb.eq.1)then
            do 2400 ixa=ixapr(jax),ixapr(jax+1)-1
            ibx=iapr(ixa)
            vij(iprm)=vij(iprm)+tcof*cto(iax,ibx)*cfrom(jax,ibx)
2400        continue
          elseif(iPvb.eq.2)then
            do 2500 ixa=ixapr(iax),ixapr(iax+1)-1
            ibx=iapr(ixa)
            vij(iprm)=vij(iprm)+tcof*cto(iax,ibx)*cfrom(jax,ibx)
2500        continue
          endif
        endif
      endif
2100  continue

      if(.not.absym)then
c  c) Beta excitation
        do 3100 ib=1,n1b
        ibxtmp=i1bet(ib,iorb)
        jbx=ibto(jorb,ibxtmp)
        if(jbx.ne.0)then
          ibx=ibto(iorb,ibxtmp)
          if(idens.eq.0)then
            tcof=vij(iprm)*phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            if(iPvb.eq.0)then
              call daxpy_(nda,tcof,cfrom(1,jbx),1,cto(1,ibx),1)
            elseif(iPvb.eq.1)then
              do 3200 ixb=ixbpr(jbx),ixbpr(jbx+1)-1
              iax=ibpr(ixb)
              cto(iax,ibx)=cto(iax,ibx)+tcof*cfrom(iax,jbx)
3200          continue
            elseif(iPvb.eq.2)then
              do 3300 ixb=ixbpr(ibx),ixbpr(ibx+1)-1
              iax=ibpr(ixb)
              cto(iax,ibx)=cto(iax,ibx)+tcof*cfrom(iax,jbx)
3300          continue
            endif
          else
            tcof=phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            if(iPvb.eq.0)then
              vij(iprm)=vij(iprm)+tcof*
     >          ddot_(nda,cto(1,ibx),1,cfrom(1,jbx),1)
            elseif(iPvb.eq.1)then
              do 3400 ixb=ixbpr(jbx),ixbpr(jbx+1)-1
              iax=ibpr(ixb)
              vij(iprm)=vij(iprm)+tcof*cto(iax,ibx)*cfrom(iax,jbx)
3400          continue
            elseif(iPvb.eq.2)then
              do 3500 ixb=ixbpr(ibx),ixbpr(ibx+1)-1
              iax=ibpr(ixb)
              vij(iprm)=vij(iprm)+tcof*cto(iax,ibx)*cfrom(iax,jbx)
3500          continue
            endif
          endif
        endif
3100    continue
      endif
      elseif(sc)then
c  a) Alpha excitation
      do 4100 ia=1,n1a
      iaxtmp=i1alf(ia,iorb)
      jax=iato(jorb,iaxtmp)
      if(jax.ne.0)then
        iax=iato(iorb,iaxtmp)
        if(idens.eq.0)then
          tcof=vij(iprm)*phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          if(iPvb.eq.0)then
            call daxpy_(ndb,tcof,cfrom(jax,1),nda,cto(iax,1),nda)
          elseif(iPvb.eq.1)then
            ibx=ndb-jax+1
            cto(iax,ibx)=cto(iax,ibx)+tcof*cfrom(jax,ibx)
          elseif(iPvb.eq.2)then
            ibx=ndb-iax+1
            cto(iax,ibx)=cto(iax,ibx)+tcof*cfrom(jax,ibx)
          endif
        else
          tcof=phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          if(iPvb.eq.0)then
            vij(iprm)=vij(iprm)+tcof*
     >        ddot_(ndb,cto(iax,1),nda,cfrom(jax,1),nda)
          elseif(iPvb.eq.1)then
            ibx=ndb-jax+1
            vij(iprm)=vij(iprm)+tcof*cto(iax,ibx)*cfrom(jax,ibx)
          elseif(iPvb.eq.2)then
            ibx=ndb-iax+1
            vij(iprm)=vij(iprm)+tcof*cto(iax,ibx)*cfrom(jax,ibx)
          endif
        endif
      endif
4100  continue

      if(.not.absym)then
c  c) Beta excitation
        do 5100 ib=1,n1b
        ibxtmp=i1bet(ib,iorb)
        jbx=ibto(jorb,ibxtmp)
        if(jbx.ne.0)then
          ibx=ibto(iorb,ibxtmp)
          if(idens.eq.0)then
            tcof=vij(iprm)*phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            if(iPvb.eq.0)then
              call daxpy_(nda,tcof,cfrom(1,jbx),1,cto(1,ibx),1)
            elseif(iPvb.eq.1)then
              iax=nda-jbx+1
              cto(iax,ibx)=cto(iax,ibx)+tcof*cfrom(iax,jbx)
            elseif(iPvb.eq.2)then
              iax=nda-ibx+1
              cto(iax,ibx)=cto(iax,ibx)+tcof*cfrom(iax,jbx)
            endif
          else
            tcof=phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
            if(iPvb.eq.0)then
              vij(iprm)=vij(iprm)+tcof*
     >          ddot_(nda,cto(1,ibx),1,cfrom(1,jbx),1)
            elseif(iPvb.eq.1)then
              iax=nda-jbx+1
              vij(iprm)=vij(iprm)+tcof*cto(iax,ibx)*cfrom(iax,jbx)
            elseif(iPvb.eq.2)then
              iax=nda-ibx+1
              vij(iprm)=vij(iprm)+tcof*cto(iax,ibx)*cfrom(iax,jbx)
            endif
          endif
        endif
5100    continue
      endif
      endif
1200  continue
1100  continue
      if(absym)then
        if(idens.eq.0)then
          do 6000 ia=1,nda
          do 6001 ib=ia,nda
          cto(ia,ib)=cto(ia,ib)+cto(ib,ia)
          cto(ib,ia)=cto(ia,ib)
6001      continue
6000      continue
        else
          call dscal_(nvij,two,vij,1)
        endif
      endif
      return
c Avoid unused argument warnings
      if (.false.) call Unused_logical(commut)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! WRAPPER FOR PARALLEL S AND B MATRIX ROUTINES
function PSBMAT_FPRINT(lg_M,NM)

use Index_Functions, only: nTri_Elem
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: GA_DDot
#endif
use fake_ga, only: GA_arrays
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: PSBMAT_FPRINT
integer(kind=iwp), intent(in) :: lg_M, NM
real(kind=wp), external :: DNRM2_

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  PSBMAT_FPRINT = sqrt(GA_DDOT(lg_M,lg_M))
else
#endif
  PSBMAT_FPRINT = DNRM2_(nTri_Elem(NM),GA_Arrays(lg_M)%A,1)
#ifdef _MOLCAS_MPP_
end if
#endif

end function PSBMAT_FPRINT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RunTinker(nAtom,Cord,ipMltp,IsMM,MltOrd,DynExtPot,
     &                     iQMChg,nAtMM,StandAlone,DoDirect)
      Use Para_Info, Only: MyRank
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit Real*8 (a-h,o-z)
*
#include "espf.fh"
#include "stdalloc.fh"
*
      Integer, Intent(In):: nAtom
      Real*8, Intent(In):: Cord(3,nAtom)
      Integer, Intent(In):: ipMltp
      Integer, Intent(In):: IsMM(nAtom)
      Integer, Intent(In):: MltOrd
      Logical, Intent(InOut):: DynExtPot
      Integer, Intent(In):: iQMChg
      Integer, Intent(InOut):: nAtMM
      Logical, Intent(In):: StandAlone
      Logical, Intent(In):: DoDirect

      Character*180 Line
      Character*180 Get_Ln
      Character*12 ExtPotFormat
      Character*256 TkLine
      Logical lFirst
      Integer RC
      Real*8, Allocatable:: Mull(:), LPC(:), ESPF(:,:), MMqx(:,:)
1000  Format('Molcas  ',i2,2x,i2)
1010  Format(3F15.8)
*
      iPL = iPL_espf()
      Write(ExtPotFormat,'(a4,i2,a6)') '(I4,',MxExtPotComp,'F13.8)'
*
* Always update the coordinates of the tinker xyz file
* WARNING: coordinates are converted to Angstroms
* This is done through a communication file: Project.qmmm
*
      lFirst = (ipMltp .eq. ip_Dummy)
*
* Only call Tinker on the master node
*
      ITkQMMM = 1
      If (MyRank .eq. 0) Then
        ITkQMMM = IsFreeUnit(ITkQMMM)
        Call Molcas_Open (ITkQMMM,'QMMM')
*
*     The MM subsystem can relax (microiterations, MD, ...) unless:
*     1) there are no QM multipoles
*     2) this is a call to retrieve MM energy/gradient/electrostatic potential only
*
        iRelax = 1
        If (lFirst .or. .not. StandAlone) iRelax = 0
        If (DoDirect) Then
          Write(ITkQMMM,1000) iRelax,-1
        Else
          Write(ITkQMMM,1000) iRelax,MltOrd/4
        End If
        Do iAtom = 1, nAtom
          Write(ITkQMMM,1010) Cord(:,iAtom)*Angstrom
        End Do
        If (.not.lFirst) Then
          Write(ITkQMMM,'(A)') 'Multipoles'
          If (iQMChg .eq. 0) Then
            If(iPL.ge.3) Write(6,'(A)') ' Multipoles passed to Tinker'
            iMlt = 0
            Do iAtom = 1, nAtom
               If (IsMM(iAtom).eq.0) Then
                  If (MltOrd.eq.1) Then
                     Write(ITkQMMM,'(I6,4F15.8)') iAtom,
     &                                  Work(ipMltp+iMlt),Zero,Zero,Zero
                  Else
                     Write(ITkQMMM,'(I6,4F15.8)') iAtom,
     &                                       (Work(ipMltp+iMlt+j),j=0,3)
                  End If
                  iMlt = iMlt + MltOrd
               Else
                  Write(ITkQMMM,'(I6,4F15.8)') iAtom,Zero,Zero,Zero,Zero
               End If
            End Do
          Else If (iQMChg .eq. 1) Then
            If (          (StandAlone.and.iPL.ge.2)
     &           .or.(.not.StandAlone.and.iPL.ge.3))
     &               Write(6,'(A)') ' ESPF multipoles passed to Tinker'
            iMlt = 0
            Do iAtom = 1, nAtom
               If (IsMM(iAtom).eq.0) Then
                  If (MltOrd.eq.1) Then
                     Write(ITkQMMM,'(I6,4F15.8)') iAtom,
     &                                  Work(ipMltp+iMlt),Zero,Zero,Zero
                  Else
                     Write(ITkQMMM,'(I6,4F15.8)') iAtom,
     &                                       (Work(ipMltp+iMlt+j),j=0,3)
                  End If
                  iMlt = iMlt + MltOrd
               Else
                  Write(ITkQMMM,'(I6,4F15.8)') iAtom,Zero,Zero,Zero,Zero
               End If
            End Do
          Else If (iQMChg.eq.2) Then
            If (          (StandAlone.and.iPL.ge.2)
     &           .or.(.not.StandAlone.and.iPL.ge.3))
     &              Write(6,'(A)') ' Mulliken charges passed to Tinker'
            Call mma_allocate(Mull,nAtom,Label='Mull')
            Call Get_dArray('Mulliken Charge',Mull,nAtom)
            Do iAtom = 1, nAtom
               If (IsMM(iAtom).eq.0)
     &            Write(ITkQMMM,'(I6,4F15.8)') iAtom,
     &                               Mull(iAtom),Zero,Zero,Zero
            End Do
            Call mma_deallocate(Mull)
          Else If (iQMChg.eq.3) Then
            If (          (StandAlone.and.iPL.ge.2)
     &           .or.(.not.StandAlone.and.iPL.ge.3))
     &                Write(6,'(A)') ' LoProp charges passed to Tinker'
            Call mma_allocate(LPC,nAtom,Label='LPC')
            Call Get_dArray('LoProp Charge',LPC,nAtom)
            Do iAtom = 1, nAtom
               If (IsMM(iAtom).eq.0)
     &            Write(ITkQMMM,'(I6,4F15.8)') iAtom,
     &                                LPC(iAtom),Zero,Zero,Zero
            End Do
            Call mma_deallocate(LPC)
          End If
        End If
        Close (ITkQMMM)
*
* Tinker is running
*
        Call Getenvf('Project ',Line)
        mLine = Len(Line)
        iLast = iCLast(Line,mLine)
        Line = Line(1:iLast)//'.xyz'
        Line = Line(1:iLast)//'.key'
        Line = '/tkr2qm_s ${Project}.xyz>${Project}.Tinker.log'
        Call Getenvf('TINKER ',TkLine)
        mLine = Len(TkLine)
        iLast = iCLast(TkLine,mLine)
        If (iLast.eq.0) Then
          Call Getenvf('MOLCAS',TkLine)
          mLine = Len(TkLine)
          iLast = iCLast(TkLine,mLine)
          TkLine = TkLine(1:iLast)//'/tinker/bin'
        End If
        iLast = iCLast(TkLine,mLine)
        nLine = Len(Line)
        jLast = iCLast(Line,nLine)
        Line = TkLine(1:iLast)//Line(1:jLast)
        Call StatusLine(' espf:',' Calling Tinker')
        RC=0
        Call Systemf(Line(1:iLast+jLast),RC)
      End If
#ifdef _MOLCAS_MPP_
      If (Is_Real_Par()) Then
        Call GA_Sync()
        Call PFGET_ASCII('TINKER.LOG')
        Call PFGET_ASCII('QMMM')
        Call PFGET_ASCII('ESPF.EXTPOT')
        Call GA_Sync()
      End If
#endif
      If (           (StandAlone.and.iPL.ge.2)
     &     .or. (.not.StandAlone.and.iPL.ge.3)) Then
         iSomething = 0
         Lu=55
         Lu=IsFreeUnit(Lu)
         Call Molcas_Open(Lu,'TINKER.LOG')
 666     Continue
         Read(Lu,'(A)',End=667) Line
         iSomething = iSomething + 1
         nLine=LEN(Line)
         iLast = iCLast(Line,nLine)
         Write(6,*) Line(1:iLast)
         Go To 666
 667     Close (Lu)
         If (iSomething.eq.0) Then
            Write(6,*) ' Something bad with Tinker: no output !'
            Call Quit_OnUserError()
         End If
      End If
*
* Tinker post-processing
* WARNING: all Tinker results must be converted to atomic units !!!
* Convert the ESPF external potential and derivatives to something
* understandable by molcas, stored in the ESPF.EXTPOT file
*
      If (iPL.ge.2) Then
         Write(6,*) 'Back from Tinker'
         Write(6,*)
      End If
      Call mma_allocate(ESPF,MxExtPotComp,nAtom,Label='ESPF')
      ESPF(:,:)=Zero
      ITkQMMM = IsFreeUnit(ITkQMMM)
      Call Molcas_Open (ITkQMMM,'QMMM')
      Line = Get_Ln(ITkQMMM)
      If (Index(Line,'MMisOK') .eq. 0) Then
         Write(6,*) 'Something wrong happend with Tinker'
         Call Abend()
      End If
      Do While (Index(Line,'TheEnd ') .eq. 0)
         Line=Get_Ln(ITkQMMM)
         If (Index(Line,'NMM ').ne.0) Then
            Call Get_I1(2,nAtMM)
         Else If (Index(Line,'ESPF1 ').ne.0) Then
            Call Get_I1(2,iAtom)
            Call Get_F(3,ESPF(1:4,iAtom),4)
         Else If (Index(Line,'ESPF21 ').ne.0) Then
            Call Get_I1(2,iAtom)
            Call Get_F(3,ESPF(5:7,iAtom),3)
         Else If (Index(Line,'ESPF22 ').ne.0) Then
            Call Get_I1(2,iAtom)
            Call Get_F(3,ESPF(8:10,iAtom),3)
         Else If (Index(Line,'FullCoupling ').ne.0) Then
            DynExtPot = .True.
         Else If (Index(Line,'MMq ').ne.0) Then
            Call Get_I1(2,nMMq)
            Call mma_allocate(MMqx,4,nMMq,Label='MMqx')
            Do iq = 1, nMMq
               Line=Get_Ln(ITkQMMM)
               Call Get_F(1,MMqx(1:4,iq),4)
            End Do
         End If
      End Do
      Close (ITkQMMM)
      ITkPot = IsFreeUnit(ITkQMMM)
      Call Molcas_Open (ITkPot,'ESPF.EXTPOT')
      If (DoDirect) Then
         Write(ITkPot,'(I10,1X,I2)') nMMq,0
         Do iq = 1, nMMq
            MMqx(1:3,iq)= MMqx(1:3,iq) * Angstrom
            Write(ITkPot,'(4F15.8)') MMqx(1:4,iq)
         End Do
         Call mma_deallocate(MMqx)
      Else
         Write(ITkPot,'(I1)') 0
         Do iAtom = 1, nAtom
            ESPF(1,iAtom)=ESPF(1,iAtom) * Angstrom
            ESPF(2:4,iAtom)=ESPF(2:4,iAtom) * Angstrom2
            ESPF(5:10,iAtom)=ESPF(5:10,iAtom) * Angstrom3
            Write(ITkPot,ExtPotFormat) iAtom,ESPF(:,iAtom)
         End Do
      End If
      Close (ITkPot)
      Call mma_deallocate(ESPF)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Prec_td(pre2,DigPrec,isym)
! pre2      Preconditioner from Prec
! DigPrec Output - Diagonal of prec2
! isym      Symmetry of PT

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use MCLR_Data, only: G1t, ipCM, ipMat, nA, nDens
use input_mclr, only: nAsh, nBas, nIsh, nSym, Omega
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: pre2(*)
real(kind=wp), intent(_OUT_) :: DigPrec(*)
integer(kind=iwp), intent(in) :: iSym
integer(kind=iwp) :: i, iA, iB, Inc, ip, ip1, ip2, ip3, iS, j, jA, jB, jS, k, l, nBasTot, nD
real(kind=wp) :: nonzero
real(kind=wp), allocatable :: Dens(:), PreTd(:), TempTd(:)

!                                                                      *
!***********************************************************************
!                                                                      *

!---------------------------------------------
! Construct one el density in MO Dens
!---------------------------------------------

nBasTot = sum(nBas(1:nSym)**2)
call mma_allocate(Dens,nBasTot,Label='Dens')

Dens(:) = Zero
ip3 = 1
do iS=1,nSym
  inc = nBas(iS)+1
  Dens(ip3:ip3+nIsh(iS)*inc-1:inc) = Two
  ip3 = ip3+nBas(iS)**2
end do

! For a CASSCF wavefunc. From Anders subrout r2elint
! Add the active active dens

do iS=1,nSym
  do iB=1,nAsh(iS)
    do jB=1,nAsh(iS)
      ip = ipCM(iS)+ib+nIsh(is)+(jB+nIsh(is)-1)*nBas(is)-1
      iA = nA(is)+ib
      jA = nA(is)+jb
      ip2 = iTri(iA,jA)
      Dens(ip) = G1t(ip2)
    end do
  end do
end do

!call RECPRT('Dens',' ',Dens,nBasTot,1)
!write(u6,*) 'Diagnonal elements in D'
!do iS=1,nSym
!  do k=0,nBas(iS)-1
!    write(u6,*) Dens(ipCM(iS)+k*(nBas(iS)+1))
!  end do
!end do
!stop

!-------------------------------------------------------------------
! Construct the diagonal approximation to the orbital prec, PreTd
!-------------------------------------------------------------------

call mma_allocate(PreTd,nDens,Label='PreTd')
PreTd(:) = Zero
ip1 = 1
ip2 = 1
!ipsave = 0
do iS=1,nSym
  jS = Mul(iS,iSym)
  nD = nBas(jS)-nIsh(jS)
  do k=1,nIsh(iS)
    ip1 = ip1+nIsh(jS)
    PreTd(ip1:ip1+nD-1) = Pre2(ip2:ip2+nD-1)
    ip1 = ip1+nD
    ip2 = ip2+nD
  end do
  nD = nBas(jS)-nAsh(jS)
  do k=1,nAsh(iS)
    PreTd(ip1+1:ip1+nIsh(jS)) = Pre2(ip2+1:ip2+nIsh(jS))
    ip1 = ip1+nIsh(jS)+nAsh(jS)
    ip2 = ip2+nIsh(jS)
    PreTd(ip1+1:ip1+nD-nIsh(jS)) = Pre2(ip2+1:ip2+nD-nIsh(jS))
    ip1 = ip1+nD-nIsh(jS)
    ip2 = ip2+nD-nIsh(jS)
    if ((nBas(jS)-nAsh(jS)-nIsh(jS)) == 0) ip1 = ip1+nAsh(jS)
  end do
  !call RECPRT('PreTd',' ',PreTd(1+ipsave),nBas(jS),nBas(iS))
  ip1 = ip1+(nBas(iS)-nIsh(iS)-nAsh(iS))*nBas(jS)
  !ipsave = ip1
end do
!call RECPRT('PreTd',' ',PreTd,nDens,1)

!----------------------
! Symmetrize PreTd
!----------------------
call mma_allocate(TempTd,nDens,Label='TempTd')

do iS=1,nSym
  jS = Mul(iS,iSym)
  TempTd(:) = Zero
  call Trnsps(nBas(iS),nBas(jS),PreTd(ipMat(jS,iS)),TempTd)
  nD = nBas(iS)*nBas(jS)
  do i=0,nD-1
    nonzero = PreTd(ipMat(iS,jS)+i)
    if (nonzero /= Zero) TempTd(1+i) = PreTd(ipMat(iS,jS)+i)
  end do
  call Trnsps(nBas(jS),nBas(iS),TempTd,PreTd(ipMat(jS,iS)))

end do

!------------------------------------------------------------------
! Add the density part PreTd_at = PreTd_at - omega(D_aa - D_tt)
!------------------------------------------------------------------
i = 0
do iS=1,nSym
  jS = Mul(iS,iSym)
  nD = nBas(iS)*nBas(jS)
  j = 0
  l = 0
  do k=0,nD-1
    if (l == nBas(jS)) l = 0
    if (k == (j+1)*nBas(jS)) j = j+1

    i = i+1
    PreTd(i) = PreTd(i)+Two*Omega*(Dens(ipCM(iS)+j*(nBas(iS)+1))+Dens(ipCM(jS)+l*(nBas(jS)+1)))

    l = l+1
  end do

end do

!-----------------------------------------------------------------------
! Symmetry transpose PreTd - To get the same order fo sym as in b_x and
! as required by compress.
!-----------------------------------------------------------------------

TempTd(:) = Zero

do iS=1,nSym
  jS = Mul(iS,iSym)
  nD = nBas(iS)*nBas(jS)
  do k=0,nD-1
    TempTd(ipmat(iS,jS)+k) = PreTd(ipmat(jS,iS)+k)
  end do
end do

call Compress(TempTd,DigPrec,isym)

call mma_deallocate(TempTd)
call mma_deallocate(PreTd)
call mma_deallocate(Dens)

end subroutine Prec_td

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine UpDens
      Implicit Real*8 (a-h,o-z)
#include "parm.fh"
#include "common.fh"
      Do 100 i=1,nDsym
         pDsym(i)=0.0d0
100   Continue
      IndOcc=1
      IndCmo=1
      IndNme=1
      Do 200 iSym=1,nSym
*        Write(*,'(a,i5)') ' iSym:   ',iSym
         Do 210 iOrb=1,nBas(iSym)
*           Write(*,'(a,i5)') '   iOrb:   ',iOrb
*           Write(*,'(a,i5)') '   IndOcc: ',IndOcc
*           Write(*,'(a,i5)') '   IndCmo: ',IndCmo
            o=Occ(IndOcc)
            e=Eps(IndOcc)
            w=wc0-wc1*e
            w=Max(w,1.0d0)
*           Write(6,'(a,2i3,3f12.6)') 'iSym.iOrb,o,e,w',iSym,iOrb,o,e,w
            If(Abs(o).gt.thr) Then
               Call UpOrb(nBas(iSym),o,w,Cmo(IndCmo),
     &                    Name(IndNme))
            End If
            IndCmo=IndCmo+nBas(iSym)
            IndOcc=IndOcc+1
210      Continue
         IndNme=IndNme+nBas(iSym)
200   Continue
*     Write(*,*) '*** Partial density matrix in UpDens ***'
      iBlk=0
      Do 300 iLqn=0,MxLqn
         Do 310 iShell=-iLqn,iLqn
            iBlk=iBlk+1
            If(nPrim(iLqn).gt.0) Then
*              Write(*,'(a,2i5)') ' Block',iLqn,iShell
*              Call Triprt(' ','(6F12.6)',pDsym(iSymbk(iBlk)),
*    &                     nPrim(iLqn))
            End If
310      Continue
300   Continue
      Do 400 i=1,nDsym
         tDsym(i)=tDsym(i)+wSet(kSet)*pDsym(i)
400   Continue
*     Write(*,*) '*** Total density matrix in UpDens ***'
      iBlk=0
      Do 500 iLqn=0,MxLqn
         Do 510 iShell=-iLqn,iLqn
            iBlk=iBlk+1
            If(nPrim(iLqn).gt.0) Then
*              Write(*,'(a,2i5)') ' Block',iLqn,iShell
*              Call Triprt(' ','(6F12.6)',tDsym(iSymbk(iBlk)),
*    &                     nPrim(iLqn))
            End If
510      Continue
500   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Thermo_Driver(UserT,UserP,nUserPT,nsRot,EVal,nFreq,lSlapaf)

use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: UserT(64), UserP
real(kind=wp), intent(in) :: Eval(*)
integer(kind=iwp), intent(inout) :: nUserPT, nsRot
integer(kind=iwp), intent(in) :: nFreq
logical(kind=iwp), intent(in) :: lSlapaf ! If .true. then Thermo_Driver called by SLAPAF
integer(kind=iwp) :: iMult, nAtom, nSym
real(kind=wp) :: TotalM, TRotA, TRotB, TRotC
logical(kind=iwp) :: lTest

lTest = .false.

if (lSlapaf) then
  call Get_iScalar('NSYM',nSym)
  if (nSym /= 1) then
    write(u6,'(A)') 'WARNING: No thermochemistry analysis conducted for numerical frequencies unless no symmetry is used!'
    return
  end if
end if

write(u6,*)
call CollapseOutput(1,'Thermochemistry')
write(u6,*)
write(u6,'(1X,A)') '*********************'
write(u6,'(1X,A)') '*                   *'
write(u6,'(1X,A)') '*  THERMOCHEMISTRY  *'
write(u6,'(1X,A)') '*                   *'
write(u6,'(1X,A)') '*********************'
write(u6,*)

if (lTest) then
  write(u6,*) '----------------------------------------------------'
  write(u6,*) '[Thermo_Driver] Input Data:'
  write(u6,*) '    UserP=',UserP,'  nsRot=',nsRot,'nUserPT=',nUserPT
  write(u6,*) '    UserT(1-5)==',UserT(1:5)
  write(u6,'(A,I3,A,256F8.2)') '  nFreq=',nFreq,'  Freq(i)==',EVal(1:nFreq)
  write(u6,*) '----------------------------------------------------'
  call XFlush(u6)
end if

call Rotation(TotalM,TRotA,TRotB,TRotC,nsRot,nAtom,lSlapaf)
call Get_iScalar('Multiplicity',iMult)

if (lTest) then
  write(u6,*) ' Calling ThermoChem_,  iMult=',iMult
  write(u6,*) ' UserP=',UserP,'  nsRot=',nsRot,'  nAtom=',nAtom
  write(u6,*) ' TotalM,TRotA,TRotB,TRotC==',TotalM,TRotA,TRotB,TRotC
  write(u6,'(A,I3,A,256F8.2)') ' nFreq=',nFreq,'  Freq(i)==',EVal(1:nFreq)
  call XFlush(u6)
end if

call ThermoChem_(UserT,UserP,TotalM,TRotA,TRotB,TRotC,nUserPT,nsRot,iMult,EVal,nFreq,lSlapaf)
call CollapseOutput(0,'Thermochemistry')

return

end subroutine Thermo_Driver

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Jonas Bostrom                                    *
************************************************************************
      SubRoutine ChoMP2g_Tra(COrb1,COrb2,Diag,DoDiag,iMoType1,iMoType2)
C
C     Jonas Bostrom, Dec. 2004.
C
C     Purpose: transform Cholesky vectors to (pq) MO basis.
C
#include "implicit.fh"
      Real*8  COrb1(*), COrb2(*), Diag(*)
      Logical DoDiag
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2g.fh"
#include "WrkSpc.fh"

      Character*10 SecNam
      Parameter (SecNam = 'ChoMP2_Tra')


C     Allocate remaining memory.
C     --------------------------

*     Check what type of Cholesky vector to make (fro-occ, occ-occ.....)
      iVecType = iMoType2 + (iMoType1-1)*nMoType

      Call GetMem('TraGetMax','Max ','Real',ipW,lW)
      Call GetMem('TraMax','Allo','Real',ipW,lW)

      kOffD = 1
      Do iSym = 1,nSym

C        Open files for MO vectors.
C        --------------------------

         Call ChoMP2_OpenF(1,1,iSym)

C        Transform vectors.
C        ------------------

         Call ChoMP2g_Tra_1(COrb1,COrb2,Diag(kOffD),DoDiag,Work(ipW),lW,
     &                     iSym,iMoType1,iMoType2)
         kOffD = kOffD + nMoMo(iSym,iVecType)

C        Close files for MO vectors.
C        ---------------------------

         Call ChoMP2_OpenF(2,1,iSym)

      End Do

C     Free memory.
C     ------------

      Call GetMem('TraMax','Free','Real',ipW,lW)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Pavel Neogrady                                   *
!***********************************************************************

subroutine sumoverab(wrk,wrksize,lunt2o1,lunt2o2,lunt2o3,nabstack,posabstack)
! this routine realizes summation over ab
! and calculates following contributions:
!
! T25
! T2n(ab,ij)aaaa   <- sum(e>f-aa) [ <ab||ef>aaaa . Tau(ef,ij)aaaa ]
! T2n(ab,ij)bbbb   <- sum(e>f-bb) [ <ab||ef>bbbb . Tau(ef,ij)bbbb ]
! T2n(a,b,i,j)abab <- sum(e,f-ab) [ <ab||ef>abab . Tau(ef,ij)abab ]
!
! T28
!  Q(ab,k,l)aaaa   <= sum(e-a)    [ <ab||ke>aaaa . T1o(e,l)aa ]
! T2n(ab,ij)aaaa   <- Q(ab,i,j)aaaa - Q(ab,j,i)aaaa
!  Q(ab,k,l)bbbb   <= sum(e-b)    [ <ab||ke>bbbb . T1o(e,l)bb ]
! T2n(ab,ij)bbbb   <- Q(ab,i,j)bbbb - Q(ab,j,i)bbbb
! T2n(a,b,i,j)abab <- - sum(e-a)  [ <ab||je>abba . T1o(e,i)aa ]
!    <- + sum(e-b)  [ <ab||ie>abab . T1o(e,j)bb ]
!
! General Status:
!
! 1) Tau ampitudes are stored and properly mapped in V1-V3
! V1(ij,ef)   = Tau(ef,ij)aaaa
! V2(ij,ef)   = Tau(ef,ij)bbbb
! V3(i,j,e,f) = Tau(e,f,i,j)abab
!
! 2) Integrals are stored in file nab
!
! syma=1,nsym
!   symb=1,syma
!     ! one record n - in all cases
!     a = 1,nvb(syma)
!       if (syma == symb) then
!         limb = a
!       else
!         limb = nvb(symb)
!       end if
!       b=1,limb
!         ! one record N _a_b(p,q) - if any
!       end b
!     end a
!   end sumb
! end syma
!
! N.B. nab musi byt dakde deklarovane (daky common)
!
! N.B. II. in parallel.fh there are:
! nprocab - number of nodes chosen for 'sumoverab' part
! idab    - array of id's of these nodes

use ccsd_global, only: fullprint, h1, h2, h3, h4, idab, m1, m2, m3, m4, maxproc, mmul, n, nprocab, nsym, nva, nvb, r1, r2, r3, r4, &
                       r5, r6, t11, t12, t21, t22, t23, v1, v2, v3, v4
use Para_Info, only: MyRank
use Constants, only: One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, nabstack, posabstack
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp), intent(_IN_) :: lunt2o1, lunt2o2, lunt2o3
integer(kind=iwp) :: a, aeqb, b, bb, bstart, bstop, iab, idtot(maxproc), key, left, limb, lunab, nab, nabnow, nadd, nlength, nsa, &
                     nsb, posab, post, rc, ssh1, ssh3, ssn, syma, symb, todo, yes

todo = 0
posab = posabstack

!I.parallel

!I.par.1 - escape, if this node is not reserved for sumoverab
yes = 0
do a=1,nprocab
  !if ((idab(a) == myRank) .and. (ideffab(a) > Zero)) yes = a
  if (idab(a) == myRank) yes = a
end do

if (yes == 0) return

!I.par.2 - cal overal number of ab records
nab = 0
do syma=1,nsym
  do symb=1,syma
    if (syma == symb) then
      nab = nab+(nvb(syma)*(nvb(syma)+1))/2
    else
      nab = nab+nvb(syma)*nvb(symb)
    end if
  end do
end do

!I.par.3 - distribute and calc add parameter
call sumabdistt(nab,idtot)
nab = idtot(yes)
! escape, if there is nothing to do on this node
if (nab == 0) return
nadd = sum(idtot(1:yes-1))

!I.1 open nab file

lunab = 10
call filemanager(4,lunab,rc)

!I.2  prepair
! V1(ij,ef)   = Tau(ef,ij)aaaa
! V2(ij,ef)   = Tau(ef,ij)bbbb
! V3(i,j,e,f) = Tau(e,f,i,j)abab

call filemanager(2,lunt2o1,rc)
call getmediate(wrk,wrksize,lunt2o1,v4,rc)
call mktau(wrk,wrksize,v4,t11,t12,One,rc)
call map(wrk,wrksize,4,3,4,1,2,v4,1,v1,post,rc)

call filemanager(2,lunt2o2,rc)
call getmediate(wrk,wrksize,lunt2o2,v4,rc)
call mktau(wrk,wrksize,v4,t11,t12,One,rc)
call map(wrk,wrksize,4,3,4,1,2,v4,1,v2,post,rc)

call filemanager(2,lunt2o3,rc)
call getmediate(wrk,wrksize,lunt2o3,v4,rc)
call mktau(wrk,wrksize,v4,t11,t12,One,rc)
call map(wrk,wrksize,4,3,4,1,2,v4,1,v3,post,rc)

!II. sum over ab
outer: do syma=1,nsym
  do symb=1,syma
    if (fullprint >= 2) write(u6,*) ' SymA, SymB ',syma,symb

    !II.1 read n
    call getmap(lunab,nlength,n,rc)

    !II.3 skip sum over a,b if N is empty
    if (nlength == 0) cycle

    !II.4 skip sum over a,b if # of ab is zero
    if ((nvb(syma)*nvb(symb)) == 0) cycle

    !II.5 def symmetry of N
    ssn = mmul(syma,symb)

    !II.5.1 def %d and %i for R1 _a,_b(j,e)aaaa = <ab||je>  (pos
    r1%pos0 = m1%pos0
    call grc0(2,0,1,3,0,0,ssn,post,r1)
    !II.5.2 def %d and %i for R2 _a,_b(j,e)bbbb = <ab||je>  (pos
    r2%pos0 = m2%pos0
    call grc0(2,0,2,4,0,0,ssn,post,r2)
    !II.5.3 def %d and %i for R3 _a,_b(j,e)abba = <ab||je>  (pos
    r3%pos0 = m3%pos0
    call grc0(2,0,2,3,0,0,ssn,post,r3)
    !II.5.4 def %d and %i for R4 _b,_a(j,e)abba = <ba||je>  (pos
    r4%pos0 = m4%pos0
    call grc0(2,0,2,3,0,0,ssn,post,r4)
    r5%pos0 = h1%pos0
    !II.5.5 def %d and %i for R5 _a,_b(j,e)abab = <ab||je>  (pos
    call grc0(2,0,1,4,0,0,ssn,post,r5)
    r6%pos0 = h2%pos0
    !II.5.6 def %d and %i for R6 _b,_a(j,e)abab = <ba||je>  (pos
    call grc0(2,0,1,4,0,0,ssn,post,r6)

    !II.6.1 def %d and %i for M1 _a,_b(ef)aaaa = <ab||ef>
    call grc0(2,1,3,3,0,0,ssn,post,m1)
    !II.6.2 def %d and %i for M2 _a,_b(ef)bbbb = <ab||ef>
    call grc0(2,1,4,4,0,0,ssn,post,m2)
    !II.6.3 def %d and %i for M3 _a,_b(e,f)abab = <ab||ef>
    call grc0(2,0,3,4,0,0,ssn,post,m3)
    !II.6.4 def %d and %i for M4 _b,_a(e,f)abab = <ba||fe>
    call grc0(2,0,3,4,0,0,ssn,post,m4)

    !II.7 def # of S orbitals in syma and symb
    nsa = nvb(syma)-nva(syma)
    nsb = nvb(symb)-nva(symb)

    do a=1,nvb(syma)

      if (fullprint >= 3) write(u6,*) ' A',a

      !II.7 def limitations for b
      if (syma == symb) then
        limb = a
      else
        limb = nvb(symb)
      end if

      !@@
      !par for nodes, selected for sumab process:
      !    1) only blank read (instead of _a_b(e,f) form lunab file for records,
      !    pre-standing to the portion, that is going to be done on this node
      !    2) prepair setup (def bstart,limb), if needed

      if (nadd >= limb) then
        ! all cycle over b need to be skipped
        do b=1,limb
          ! blank read and nothing more
          call reajalovy(lunab,nlength,wrk(n%pos0))
          nadd = nadd-1
        end do
        ! no setup needed
        cycle

      else if (nadd > 0) then
        ! setup first
        bstart = nadd
        if (nab < (limb-bstart)) limb = bstart+nab
        ! part of the cycle over b need to be skipped
        do b=1,nadd
          ! blank read and nothing more
          call reajalovy(lunab,nlength,wrk(n%pos0))
        end do
        nadd = 0

      else
        ! nabadd musi byt 0, inak nieje dobre
        ! no part of the cycle over b need to be skipped
        ! only setup
        bstart = 0
        if (nab < limb) limb = nab
      end if

      !* define conditions for reading to stack
      !  bstart - lower limit of b-summation
      !  bstop  - upper limit of b-summation
      !  nabnow - actual size af stack (if=1, no stacking)

      !*.1 initialization
      !Stare bstart=0

      !*.1 set unstacking conditions
      do
        bstart = bstart+1
        bstop = bstart
        nabnow = 1

        !*.2 without stacking if: 1)a=b; 2)a or b \in S; 3) nabnow <= 3
        !    (N.B. it was found inconvenient to execute stacking if
        !          size of stack is less then 4, or even more)

        ! ad 1)
        if ((bstart /= a) .or. (syma /= symb)) then
          ! ad 2)
          if ((bstart > nsb) .and. (a > nsa)) then
            ! ad 3)
            left = limb-bstart+1
            if (syma == symb) left = left-1
            if (left > 3) then

              !*.3 set stacking conditions for real stacking
              if (left <= nabstack) then
                nabnow = left
              else
                nabnow = nabstack
              end if
              bstop = bstart+nabnow-1
              todo = 1
              posab = posabstack
            end if
          end if
        end if

        !*. reading to N or to stack
        if (nabnow == 1) then
          call rea(lunab,nlength,wrk(n%pos0))
        else
          do iab=1,nabnow
            call rea(lunab,nlength,wrk(posabstack+(iab-1)*nlength))
            !if ((posabstack+iab*nlength) >= m1%pos0) then
            !end if
          end do
          !qq = wrk(posabstack)
        end if

        do b=bstart,bstop

          !III.3 read N
          !Stare call rea(lunab,nlength,wrk(n%pos0))

          !III.4 def aeqb
          if ((syma == symb) .and. (a == b)) then
            aeqb = 1
          else
            aeqb = 0
          end if

          !III.5 def key
          if ((a > nsa) .and. (b > nsb)) then
            key = 4
          else if ((a > nsa) .and. (b <= nsb)) then
            key = 2
          else if ((a <= nsa) .and. (b > nsb)) then
            key = 3
          else
            key = 1
          end if

          ! def yes for T25.1
          if (syma == symb) then
            if (a == b) then
              yes = 0
            else if (key == 4) then
              yes = 1
            else
              yes = 0
            end if
          else
            if (key == 4) then
              yes = 1
            else
              yes = 0
            end if
          end if

          ! T25
          ! T2n(ab,ij)aaaa   <- sum(e>f-aa) [ <ab||ef>aaaa . Tau(ef,ij)aaaa ]
          ! T2n(ab,ij)bbbb   <- sum(e>f-bb) [ <ab||ef>bbbb . Tau(ef,ij)bbbb ]
          ! T2n(a,b,i,j)abab <- sum(e,f-ab) [ <ab||ef>abab . Tau(ef,ij)abab ]

          if (nabnow == 1) then
            ! AB stacking is not active

            !III.6 get
            ! -> M1 _a,_b(ef)aaaa  = <ab||ef>
            ! -> M2 _a,_b(ef)bbbb  = <ab||ef>
            ! -> M3 _a,_b(e,f)abab = <ab||ef>
            ! -> M4 _b,_a(e,f)abab = <ba||fe>
            ! free: H1-H4 (V4 reserved for stacking)
            call unpackab1(wrk,wrksize,n,m1,m2,m3,m4,ssn,key,aeqb)

            if (yes == 1) then
              ! T25.1.1 H1 (ij) = V1(ij,ef) . M1 (ef)
              call ccmult(wrk,wrksize,4,2,2,2,v1,1,m1,ssn,h1,ssh1,rc)
              ! T25.1.2 T2n(ab,ij)aaaa <- 1.0 . H1(ij)
              call add(wrk,wrksize,2,4,2,5,a-nsa,b-nsb,syma,symb,One,h1,ssn,t21,1,rc)
            end if

            if (aeqb == 0) then
              ! T25.2.1 H1 (ij) = V2(ij,ef) . M2 (ef)
              call ccmult(wrk,wrksize,4,2,2,2,v2,1,m2,ssn,h1,ssh1,rc)
              ! T25.2.2 T2n(ab,ij)bbbb <- 1.0 . H1(ij)
              call add(wrk,wrksize,2,4,2,5,a,b,syma,symb,One,h1,ssn,t22,1,rc)
            end if

            if ((key == 2) .or. (key == 4)) then
              ! T25.3.1 H1 (i,j) = V3(i,j,e,f) . M3 (e,f)
              call ccmult(wrk,wrksize,4,2,2,2,v3,1,m3,ssn,h1,ssh1,rc)
              ! T25.3.2 T2n(a,b,i,j)abab <- 1.0 . H1(i,j)
              call add(wrk,wrksize,2,4,2,5,a-nsa,b,syma,symb,One,h1,ssn,t23,1,rc)
            end if

            if (((key == 3) .or. (key == 4)) .and. (aeqb == 0)) then
              ! T25.3.3 H1 (i,j) = V3(i,j,e,f) . M4 (e,f)
              call ccmult(wrk,wrksize,4,2,2,2,v3,1,m4,ssn,h1,ssh1,rc)

              ! T25.3.4 T2n(a,b,i,j)abab <- 1.0 . H1(i,j)
              call add(wrk,wrksize,2,4,2,5,b-nsb,a,symb,syma,One,h1,ssn,t23,1,rc)
            end if

          else
            ! AB stacking is active

            if (todo == 1) then
              ! once it need to be done
              todo = 0

              !III.6 get
              ! -> M1 _a,_b(ef)aaaa  = <ab||ef>
              ! -> M2 _a,_b(ef)bbbb  = <ab||ef>
              ! -> M3 _a,_b(e,f)abab = <ab||ef>
              ! -> M4 _b,_a(e,f)abab = <ba||fe>
              ! free: H1-H4 (V4 reserved for stacking)

              ! def %d and %i for V4 _a,(ef,Bp)
              call grc0stack(nabnow,1,3,3,3,0,ssn,post,v4)
              ! -> V4 _a,_b(ef)aaaa  = <ab||ef>
              call unpackab3(wrk,wrksize,n,v4,ssn,nabnow,posabstack,nlength,1)

              !T25.1.1 H2 (ij,Bp) = V1(ij,ef) . V4 (ef,Bp)
              call multstack(wrk,wrksize,v1,v4,h2,1,ssn,nabnow)

              ! def %d and %i for H1 _a,_b(ij)aa
              call grc0(2,1,1,1,0,0,ssn,post,h1)
              do bb=bstart,bstop
                !T25.1.2 ext H1(ij) <- H2(ij,_Bb) (only data transfer)
                call extstack(wrk,wrksize,h1,h2,(bb-bstart+1),nabnow)
                !T25.1.3 T2n(ab,ij)aaaa <- 1.0 . H1(ij)
                call add(wrk,wrksize,2,4,2,5,a-nsa,bb-nsb,syma,symb,One,h1,ssn,t21,1,rc)
              end do

              ! def %d and %i for V4 _a,(ef,Bp)
              call grc0stack(nabnow,1,4,4,4,0,ssn,post,v4)
              ! -> V4 _a,_b(ef)bbbb  = <ab||ef>
              call unpackab3(wrk,wrksize,n,v4,ssn,nabnow,posabstack,nlength,2)

              !T25.2.1 H2 (ij,Bp) = V2(ij,ef) . V4 (ef,Bp)
              call multstack(wrk,wrksize,v2,v4,h2,1,ssn,nabnow)

              ! def %d and %i for H1 _a,_b(ij)bb
              call grc0(2,1,2,2,0,0,ssn,post,h1)
              do bb=bstart,bstop
                !T25.2.2 ext H1(ij) <- H2(ij,Bb)
                call extstack(wrk,wrksize,h1,h2,(bb-bstart+1),nabnow)
                !T25.2 T2n(ab,ij)bbbb <- 1.0 . H1(ij)
                call add(wrk,wrksize,2,4,2,5,a,bb,syma,symb,One,h1,ssn,t22,1,rc)
              end do

              ! def %d and %i for V4 _a,(ef,Bp)
              call grc0stack(nabnow,0,3,4,4,0,ssn,post,v4)
              ! -> V4 _a,_b(e,f)abab = <ab||ef>
              call unpackab3(wrk,wrksize,n,v4,ssn,nabnow,posabstack,nlength,3)

              !T25.3.1 H2 (i,j,Bp) = V3(i,j,e,f) . V4 (e,f,Bp)
              call multstack(wrk,wrksize,v3,v4,h2,1,ssn,nabnow)

              ! def %d and %i for H1 _a,_b(ij)ab
              call grc0(2,0,1,2,0,0,ssn,post,h1)
              do bb=bstart,bstop
                !T25.3.2 ext H1(i,j) <- H2(ij,Bb)
                call extstack(wrk,wrksize,h1,h2,(bb-bstart+1),nabnow)
                !T25.3.3 T2n(a,b,i,j)abab <- 1.0 . H1(i,j)
                call add(wrk,wrksize,2,4,2,5,a-nsa,bb,syma,symb,One,h1,ssn,t23,1,rc)
              end do

              ! def %d and %i for V4 _a,(ef,Bp)
              call grc0stack(nabnow,0,3,4,3,0,ssn,post,v4)
              ! -> V4 _b,_a(e,f)abab = <ba||fe>
              call unpackab3(wrk,wrksize,n,v4,ssn,nabnow,posabstack,nlength,4)

              !T25.3.4 H2 (i,j,Bp) = V3(i,j,e,f) . V4 (e,f,Bp)
              call multstack(wrk,wrksize,v3,v4,h2,1,ssn,nabnow)

              ! def %d and %i for H1 _a,_b(ij)ab
              call grc0(2,0,1,2,0,0,ssn,post,h1)
              do bb=bstart,bstop
                !T25.3.5 ext H1(i,j) <- H2(i,j,Bb)
                call extstack(wrk,wrksize,h1,h2,(bb-bstart+1),nabnow)
                !T25.3.6 T2n(a,b,i,j)abab <- 1.0 . H1(i,j)
                call add(wrk,wrksize,2,4,2,5,bb-nsb,a,symb,syma,One,h1,ssn,t23,1,rc)
              end do

            end if
          end if

          ! T28
          !  Q(ab,k,l)aaaa   <= sum(e-a)    [ <ab||ke>aaaa . T1o(e,l)aa ]
          ! T2n(ab,ij)aaaa   <- Q(ab,i,j)aaaa - Q(ab,j,i)aaaa
          !  Q(ab,k,l)bbbb   <= sum(e-b)    [ <ab||ke>bbbb . T1o(e,l)bb ]
          ! T2n(ab,ij)bbbb   <- Q(ab,i,j)bbbb - Q(ab,j,i)bbbb
          ! T2n(a,b,i,j)abab <- - sum(e-a)  [ <ab||je>abba . T1o(e,i)aa ]
          !    <- + sum(e-b)  [ <ab||ie>abab . T1o(e,j)bb ]

          ! put appropriate data from AB_stack to N mediate, if needed
          if (nabnow > 1) then
            ! transfer data
            wrk(n%pos0:n%pos0+nlength-1) = wrk(posab:posab+nlength-1)
            ! upgrade address
            posab = posab+nlength
          end if

          !III.7 get
          ! -> M1 _a,_b(j,e)aaaa = <ab||je> (map is R1)
          ! -> M2 _a,_b(j,e)bbbb = <ab||je> (map is R2)
          ! -> M3 _a,_b(j,e)abba = <ab||je> (map is R3)
          ! -> M4 _b,_a(j,e)abba = <ba||je> (map is R4)
          ! -> H1 _a,_b(j,e)abab = <ab||je> (map is R5)
          ! -> H2 _b,_a(j,e)abab = <ba||je> (map is R6)
          ! free: H3,H4 (V4 reserved for stacking)

          call unpackab2(wrk,wrksize,n,r1,r2,r3,r4,r5,r6,ssn,key,aeqb)

          ! T28
          !  Q(ab,k,l)aaaa   <= sum(e-a)    [ <ab||ke>aaaa . T1o(e,l)aa ]
          ! T2n(ab,ij)aaaa   <- Q(ab,i,j)aaaa - Q(ab,j,i)aaaa
          !  Q(ab,k,l)bbbb   <= sum(e-b)    [ <ab||ke>bbbb . T1o(e,l)bb ]
          ! T2n(ab,ij)bbbb   <- Q(ab,i,j)bbbb - Q(ab,j,i)bbbb
          ! T2n(a,b,i,j)abab <- - sum(e-a)  [ <ab||je>abba . T1o(e,i)aa ]
          !    <- + sum(e-b)  [ <ab||ie>abab . T1o(e,j)bb ]

          ! def yes for T28.1
          if (syma == symb) then
            if (a == b) then
              yes = 0
            else if (key == 4) then
              yes = 1
            else
              yes = 0
            end if
          else
            if (key == 4) then
              yes = 1
            else
              yes = 0
            end if
          end if

          if (yes == 1) then
            !T28.1.1 H3(k,l) = M1(k,e) . T1o(e,l)aa
            call ccmult(wrk,wrksize,2,2,2,1,r1,ssn,t11,1,h3,ssh3,rc)
            !T28.1.2 H4(kl)  = H3(k,l)-H3(l,k)
            call fack(wrk,wrksize,2,1,h3,ssh3,h4,rc)
            !T28.1.3 T2n(ab,ij)aaaa <- 1.0 H4(ij)
            call add(wrk,wrksize,2,4,2,5,a-nsa,b-nsb,syma,symb,One,h4,ssn,t21,1,rc)
          end if

          if (aeqb == 0) then
            !T28.2.1 H3(k,l) = M2(k,e) . T1o(e,l)bb
            call ccmult(wrk,wrksize,2,2,2,1,r2,ssn,t12,1,h3,ssh3,rc)
            !T28.2.2 H4(kl)  = H3(k,l)-H3(l,k)
            call fack(wrk,wrksize,2,1,h3,ssh3,h4,rc)
            !T28.2.3 T2n(ab,ij)bbbb <- 1.0 H4(ij)
            call add(wrk,wrksize,2,4,2,5,a,b,syma,symb,One,h4,ssn,t22,1,rc)
          end if

          if ((key == 2) .or. (key == 4)) then
            !T28.3.1 H3(j,i)  = M3(j,e) . T1o(e,i)aa
            call ccmult(wrk,wrksize,2,2,2,1,r3,ssn,t11,1,h3,ssh3,rc)
            !T28.3.2 H4(i,j)  = H3(j,i)
            call map(wrk,wrksize,2,2,1,0,0,h3,ssn,h4,post,rc)
            !T28.3.3 T2n(a,b,i,j)abab <- -1.0 H4(i,j)
            call add(wrk,wrksize,2,4,2,5,a-nsa,b,syma,symb,-One,h4,ssn,t23,1,rc)
          end if

          if (((key == 3) .or. (key == 4)) .and. (aeqb == 0)) then
            !T28.3.4 H3(j,i)  = M4(j,e) . T1o(e,i)aa
            call ccmult(wrk,wrksize,2,2,2,1,r4,ssn,t11,1,h3,ssh3,rc)
            !T28.3.5 H4(i,j)  = H3(j,i)
            call map(wrk,wrksize,2,2,1,0,0,h3,ssn,h4,post,rc)
            !T28.3.6 T2n(a,b,i,j)abab <- -1.0 H4(i,j)
            call add(wrk,wrksize,2,4,2,5,b-nsb,a,symb,syma,-One,h4,ssn,t23,1,rc)
          end if

          if ((key == 2) .or. (key == 4)) then
            !T28.3.7 H3(i,j)  = H1(i,e) . T1o(e,j)bb
            call ccmult(wrk,wrksize,2,2,2,1,r5,ssn,t12,1,h3,ssh3,rc)
            !T28.3.8 T2n(a,b,i,j)abab <- 1.0 H3(i,j)
            call add(wrk,wrksize,2,4,2,5,a-nsa,b,syma,symb,One,h3,ssn,t23,1,rc)
          end if

          if (((key == 3) .or. (key == 4)) .and. (aeqb == 0)) then
            !T28.3.9 H3(j,i)  = H2(i,e) . T1o(e,j)bb
            call ccmult(wrk,wrksize,2,2,2,1,r6,ssn,t12,1,h3,ssh3,rc)
            !T28.3.10 T2n(a,b,i,j)abab <- 1.0 H3(i,j)
            call add(wrk,wrksize,2,4,2,5,b-nsb,a,symb,syma,One,h3,ssn,t23,1,rc)
          end if

        end do

        !par
        nab = nab-(bstop-bstart+1)
        if (nab == 0) exit outer

        if (bstop >= limb) exit
        bstart = bstop
      end do
    end do

  end do
end do outer

!IV. close lunab
call filemanager(3,lunab,rc)

return

end subroutine sumoverab

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE DIAGCT_CPF(H)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      DIMENSION H(*)
      CALL DIAGCT_INTERNAL(H)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE DIAGCT_INTERNAL(H)
      USE ISO_C_BINDING
      REAL*8, TARGET :: H(*)
      INTEGER, POINTER :: iH1(:),iH2(:),iH4(:),iH11(:),iH12(:),iH13(:),
     &iH17(:),iH18(:),iH19(:),iH20(:),iH21(:),iH22(:),iH25(:)
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      NCONF=JSC(ILIM)
* Initialize sorting buffer, so that automatic detection of
* uninitialized variables does not give false alarms.
      CALL DCOPY_(LW(21)-LW(20),[0.0D0],0,H(LW(20)),1)
* Now H(LW(20)) and up are filled with zeroes.
* Similar before SORTB_CPF and SORT_CPF.
      CALL C_F_POINTER(C_LOC(H(LW(4))),iH4,[1])
      CALL C_F_POINTER(C_LOC(H(LW(20))),iH20,[1])
      CALL C_F_POINTER(C_LOC(H(LW(21))),iH21,[1])
      CALL C_F_POINTER(C_LOC(H(LW(22))),iH22,[1])
      CALL C_F_POINTER(C_LOC(H(LW(25))),iH25,[1])
      CALL SORTA_CPF(H(LW(20)),iH20,iH21,iH22,H(LW(10)),
     &   iH4,H(LW(25)),iH25,H(LW(23)),H(LW(24)),NINTGR)
      NULLIFY(iH4,iH20,iH21,iH22,iH25)
      IF(IFIRST.EQ.0) THEN
        CALL DCOPY_(LW(18)-LW(17),[0.0D0],0,H(LW(17)),1)
        CALL C_F_POINTER(C_LOC(H(LW(4))),iH4,[1])
        CALL C_F_POINTER(C_LOC(H(LW(17))),iH17,[1])
        CALL C_F_POINTER(C_LOC(H(LW(18))),iH18,[1])
        CALL C_F_POINTER(C_LOC(H(LW(19))),iH19,[1])
        CALL SORTB_CPF(H(LW(17)),iH17,iH18,
     &   iH19,H(LW(10)),H(LW(94)),H(LW(95)),iH4,H(LW(96)))
        NULLIFY(iH4,iH17,iH18,iH19)
      END IF
      CALL DCOPY_(LW(12)-LW(11),[0.0D0],0,H(LW(11)),1)
      CALL C_F_POINTER(C_LOC(H(LW(11))),iH11,[1])
      CALL C_F_POINTER(C_LOC(H(LW(12))),iH12,[1])
      CALL C_F_POINTER(C_LOC(H(LW(13))),iH13,[1])
      CALL SORT_CPF(H(LW(11)),iH11,iH12,iH13,H(LW(14)),
     &   H(LW(15)),H(LW(16)),H(LW(10)))
      NULLIFY(iH11,iH12,iH13)
      CALL C_F_POINTER(C_LOC(H(LW(1))),iH1,[1])
      CALL C_F_POINTER(C_LOC(H(LW(2))),iH2,[1])
      CALL DIAG_CPF(iH1,iH2,H(LW(11)),H(LW(14)),H(LW(15)),
     &   H(LW(16)))
      NULLIFY(iH1,iH2)
      RETURN
      END SUBROUTINE DIAGCT_INTERNAL
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NACInt(xyz,nCent,H12,Bf,lWrite_,Label,dBf,ldB,lIter)

use Slapaf_Info, only: NAC
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCent, lIter
real(kind=wp), intent(in) :: xyz(3,nCent)
real(kind=wp), intent(out) :: H12, Bf(3,nCent)
logical(kind=iwp), intent(in) :: lWrite_, ldB
character(len=8), intent(in) :: Label
real(kind=wp), intent(inout) :: dBf(3,nCent,3,nCent)
integer(kind=iwp) :: iCent
real(kind=wp) :: Fact
integer(kind=iwp), external :: iDeg

H12 = Zero
if (lWrite_) write(u6,'(2A,F18.8,A,F18.8,A)') Label,' : H12               = ',H12,' hartree '

! Compute the WDC B-matrix

do iCent=1,nCent
  Fact = real(iDeg(xyz(1,iCent)),kind=wp)
  Bf(:,iCent) = Fact*NAC(:,iCent,lIter)
end do
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
write(u6,*) 'NACInt, lIter:',lIter
call RecPrt('NAC',' ',NAC(1,1,lIter),3,nCent)
call RecPrt('Bf',' ',Bf,3,nCent)
#endif

! Compute the cartesian derivative of the B-Matrix.

if (ldB) dBf(:,:,:,:) = Zero

return

end subroutine NACInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine  DefW3y (aGrp,bGrp,cGrp,w3y)
c
c        this routine do:
c        define w3y key, which indicates, if atleast one
c        W3 file need to be calculated on this node for given
c        a',b',c'
c
        implicit none
        integer aGrp,bGrp,cGrp,w3y
#include "chcc1.fh"
#include "o2v4.fh"
#ifdef _MOLCAS_MPP_
#include "parcc.fh"
c
c        help variables
        integer aSGrp,bSGrp,abSGrp,bSGrpUp,cSGrp
c
        w3y=0
c
c       cycle over a">=b" subgroups for a',b'
        do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
        if (aGrp.eq.bGrp) then
          bSGrpUp=aSGrp
        else
          bSGrpUp=GrpaUp(bGrp)
        end if
        do bSGrp=GrpaLow(bGrp),bSGrpUp
        abSGrp=aSGrp*(aSGrp-1)/2+bSGrp
c
c          cycle over c" for c'
          do cSGrp=GrpaLow(cGrp),GrpaUp(cGrp)
          if (InqW3(abSGrp,cSGrp)) then
            w3y=w3y+1
          end if
          end do
c
c       end cycle over a">=b" subgroups
        end do
        end do
c
#else
        w3y=1
c Avoid unused argument warnings
        if (.false.) then
          call Unused_integer(aGrp)
          call Unused_integer(bGrp)
          call Unused_integer(cGrp)
        end if
#endif
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C     Computes eigenvalues and optionally (right) eigenvectors of a
C     general square matrix
C
      SUBROUTINE XEIGEN (NVEC,NA,N,A,EVR,EVI,VECS,IERR)
      INTEGER NVEC,NA,N,IERR
      REAL*8 A(NA,N),EVR(N),EVI(N),VECS(NA,N)
*
#include "stdalloc.fh"
      CHARACTER JL,JR
      INTEGER NW
      REAL*8 TMP(1)
      REAL*8, DIMENSION(:), ALLOCATABLE :: WRK
      JL='N'
      JR='N'
      IF (NVEC.NE.0) JR='V'
      IERR=0
      CALL DGEEV_(JL,JR,N,A,NA,EVR,EVI,VECS,NA,VECS,NA,TMP,-1,IERR)
      NW=INT(TMP(1))
      CALL mma_allocate(WRK,NW)
      CALL DGEEV_(JL,JR,N,A,NA,EVR,EVI,VECS,NA,VECS,NA,WRK,NW,IERR)
      CALL mma_deallocate(WRK)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine OutOfPlane_List(nq,nsAtom,iIter,nIter,Cx,Process,Valu,nB,qLbl,iRef,fconst,rMult,LuIC,Indq,iPrv,Proc_dB,iTabBonds, &
                           nBonds,iTabAI,mAtoms,iTabAtoms,nMax,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,nqB)
!***********************************************************************
!     This is a quick and possibly dirty implementation of the out-    *
!     of-plane angle. RL, Tokyo June, 2004.                            *
!***********************************************************************

use Symmetry_Info, only: iOper, nIrrep
use Slapaf_Info, only: ANr, AtomLbl, Fragments_Bond, jStab, Magic_Bond, nStab, vdW_Bond
use ddvdt, only: aAV, f_Const_Min, rAV, rko
use Molcas, only: LenIn
use Constants, only: Zero, Pi, deg2rad
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nsAtom, iIter, nIter, nB, iRef, LuIC, iPrv, nBonds, iTabBonds(3,nBonds), mAtoms, &
                                 iTabAI(2,mAtoms), nMax, iTabAtoms(2,0:nMax,mAtoms), nB_Tot, ndB_tot
integer(kind=iwp), intent(inout) :: nq, Indq(3,nB), mB_Tot, mdB_Tot, iBM(nB_Tot), idBM(2,ndB_Tot), nqB(nB)
real(kind=wp), intent(in) :: Cx(3,nsAtom,nIter)
logical(kind=iwp), intent(in) :: Process, Proc_dB
real(kind=wp), intent(inout) :: Valu(nB,nIter), fconst(nB), rMult(nB), BM(nB_Tot), dBM(ndB_Tot)
character(len=14), intent(inout) :: qLbl(nB)
integer(kind=iwp), parameter :: mB = 4*3
integer(kind=iwp) :: iAtom, iAtom_, iCase, iDCR(4), iDCRR(0:7), iDCRS(0:7), iDCRT(0:7), iDCRX(0:7), iDCRY(0:7), iDeg, iE1, iE2, &
                     iE3, iE4, iF1, iF2, iF3, iF4, ij, ijDCR, Ind(4), ir, iStabM(0:7), iStabN(0:7), iStabO(0:7), jAtom, jAtom_, &
                     jBond, jBondType, jr, kAtom, kAtom_, kBond, kBondType, kDCRR, kDCRS, kDCRT, kDCRTS, kl, kNeighbor, kr, &
                     Lambda, lAtom, lAtom_, lBond, lBondType, lNeighbor, lr, mCent, nCent, nCoBond_j, nDCRR, nDCRS, nDCRT, nDCRX, &
                     nDCRY, nFgBond_j, nNeighbor_i, nqO, nStabM, nStabN, nStabO
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif
real(kind=wp) :: A(3,4), Alpha, Deg, delta, delta0, f_Const, f_Const_ij, f_Const_ij_Ref, f_Const_ijk, f_Const_ijk_Ref, &
                 f_Const_Ref, Fi2, Fi3, Fi4, Grad(mB), Grad_ref(9), Hess(mB**2), Prv(3,4), r0, Ref(3,4), rij2, rij2_Ref, rik2, &
                 rik2_Ref, ril2, ril2_Ref, RX4Y(3,3), Val
logical(kind=iwp) :: Help
character(len=LenIn+4) :: Lbls(4)
character(len=14) :: Label
integer(kind=iwp), parameter :: iChOp(0:7) = [1,1,1,2,1,2,2,3]
character(len=*), parameter :: ChOp(0:7) = ['E  ','X  ','Y  ','XY ','Z  ','XZ ','YZ ','XYZ']
integer(kind=iwp), external :: iTabRow, nCoBond, nFgBond
logical(kind=iwp), external :: R_Stab_A

!                                                                      *
!***********************************************************************
!                                                                      *

if (nBonds < 3) return
nqO = 0
Hess(:) = Zero

! Loop over out-of-plane angles.

nCent = 4
!
!***********************************************************************
!     Notes relevant to the out-of-plane implementation                *
!                                                                      *
!    Connection is 1-4, 2-4, and 3-4. We renumber them according to    *
!    j-i, k-i, and l-i                                                 *
!                                                                      *
!***********************************************************************
!
! Order will play a role here. That is, the torsion
! A-R(B)-T(C)-TS(D) is NOT identical to
! A-R(B)-TS(D)-T(C). Hence we put no restriction on the
! pairs AB and CD. However, for the pair of pairs we have
! that order is irrelevant, i.e. ABCD is identical to
! DCBA. To garantee this we limit the pairs to the unique
! combinations.

do jBond=1,nBonds
  jBondType = iTabBonds(3,jBond)
  if (jBondType == vdW_Bond) cycle
  if (jBondType > Magic_Bond) cycle

  do iCase=1,2

    if (iCase == 1) then
      iAtom_ = iTabBonds(1,jBond)
      jAtom_ = iTabBonds(2,jBond)
    else
      iAtom_ = iTabBonds(2,jBond)
      jAtom_ = iTabBonds(1,jBond)
    end if
    iAtom = iTabAI(1,iAtom_)
    jAtom = iTabAI(1,jAtom_)
    ir = iTabRow(ANr(iAtom))
    jr = iTabRow(ANr(jAtom))
    Ind(1) = jAtom
    Ind(4) = iAtom

    Help = (ir > 3) .or. (jr > 3)
    iDCR(4) = iTabAI(2,iAtom_)
    iDCR(1) = iTabAI(2,jAtom_)
#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) 'E,R=',AtomLbl(iAtom),ChOp(iDCR(4)),AtomLbl(jAtom),ChOp(iDCR(1))
#   endif
    nCoBond_j = nCoBond(jAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
    nFgBond_j = nFgBond(jAtom_,mAtoms,nMax,iTabBonds,nBonds,iTabAtoms)
    if ((nCoBond_j > 1) .and. (nFgBond_j == 0)) cycle
    if (iDCR(4) /= iOper(0)) cycle

    ! R

    if (R_Stab_A(iDCR(1),jStab(0,iAtom),nStab(iAtom)) .and. (iDCR(1) /= iOper(0))) cycle

    A(:,4) = Cx(:,iAtom,iIter)
    Ref(:,4) = Cx(:,iAtom,iRef)
    Prv(:,4) = Cx(:,iAtom,iPrv)

    ! Form double coset representatives for (iAtom,jAtom)

    call DCR(Lambda,jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),iDCRR,nDCRR)
    kDCRR = iDCR(1)
#   ifdef _DEBUGPRINT_
    write(u6,'(10A)') 'U={',(ChOp(jStab(i,iAtom)),i=0,nStab(iAtom)-1),'}  '
    write(u6,'(10A)') 'V={',(ChOp(jStab(i,jAtom)),i=0,nStab(jAtom)-1),'}  '
    write(u6,'(10A)') 'R={',(ChOp(iDCRR(i)),i=0,nDCRR-1),'}  '
    write(u6,'(2A)') 'R=',ChOp(kDCRR)
#   endif

    call OA(kDCRR,Cx(:,jAtom,iIter),A(:,1))
    call OA(kDCRR,Cx(:,jAtom,iRef),Ref(:,1))
    call OA(kDCRR,Cx(:,jAtom,iPrv),Prv(:,1))

    ! Form stabilizer for (iAtom,jAtom)

    call Inter(jStab(0,iAtom),nStab(iAtom),jStab(0,jAtom),nStab(jAtom),iStabM,nStabM)
#   ifdef _DEBUGPRINT_
    write(u6,'(10A)') 'M={',(ChOp(iStabM(i)),i=0,nStabM-1),'}  '
#   endif

    if (Help) then
      f_Const_ij_Ref = rko
      f_Const_ij = rko
    else
      r0 = rAV(ir,jr)
      Alpha = aAv(ir,jr)
      rij2_Ref = (Ref(1,4)-Ref(1,1))**2+(Ref(2,4)-Ref(2,1))**2+(Ref(3,4)-Ref(3,1))**2
      f_Const_ij_Ref = rko*exp(Alpha*(r0**2-rij2_Ref))
      rij2 = (A(1,4)-A(1,1))**2+(A(2,4)-A(2,1))**2+(A(3,4)-A(3,1))**2
      f_Const_ij = rko*exp(Alpha*(r0**2-rij2))
    end if

    nNeighbor_i = iTabAtoms(1,0,iAtom_)
    do kNeighbor=1,nNeighbor_i
      kAtom_ = iTabAtoms(1,kNeighbor,iAtom_)
      if (kAtom_ == jAtom_) cycle
      kBond = iTabAtoms(2,kNeighbor,iAtom_)
      kBondType = iTabBonds(3,kBond)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'kBond,kBondType=',kBond,kBondType
#     endif
      if (kBondType == vdW_Bond) cycle
      if (kBondType > Magic_Bond) cycle
      if (kBond == jBond) cycle

      kAtom = iTabAI(1,kAtom_)
      kr = iTabRow(ANr(kAtom))
      Ind(2) = kAtom
      iDCR(2) = iTabAI(2,kAtom_)

      if (iDCR(1) == iOper(0)) then
        if (R_Stab_A(iDCR(2),jStab(0,iAtom),nStab(iAtom)) .and. R_Stab_A(iDCR(2),jStab(0,jAtom),nStab(jAtom)) .and. &
            (iDCR(2) /= iOper(0))) cycle
      else
        if (R_Stab_A(iDCR(2),jStab(0,iAtom),nStab(iAtom)) .and. (iDCR(2) /= iOper(0))) cycle
      end if
#     ifdef _DEBUGPRINT_
      write(u6,*)
      write(u6,*) 'T=',AtomLbl(kAtom),ChOp(iDCR(2))
      write(u6,*) 'kAtom=',kAtom
#     endif

      do lNeighbor=1,nNeighbor_i
        lAtom_ = iTabAtoms(1,lNeighbor,iAtom_)
        if (lAtom_ == jAtom_) cycle
        if (lAtom_ <= kAtom_) cycle
        lBond = iTabAtoms(2,lNeighbor,iAtom_)
        lBondType = iTabBonds(3,lBond)
        if (lBondType == vdW_Bond) cycle
        if (lBondType > Magic_Bond) cycle
        if (lBond == jBond) cycle
        if (lBond == kBond) cycle
        lAtom = iTabAI(1,lAtom_)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'lBond,lBondType=',lBond,lBondType
        write(u6,*) 'lAtom=',lAtom
#       endif

        lr = iTabRow(ANr(lAtom))
        Ind(3) = lAtom
        iDCR(3) = iTabAI(2,lAtom_)
        !if (kAtom > lAtom) cycle

        if (iDCR(1) == iOper(0)) then
          if (R_Stab_A(iDCR(3),jStab(0,iAtom),nStab(iAtom)) .and. R_Stab_A(iDCR(3),jStab(0,jAtom),nStab(jAtom)) .and. &
              (iDCR(3) /= iOper(0)) .and. (iDCR(2) /= iOper(0))) cycle
        else
          if (R_Stab_A(iDCR(2),jStab(0,iAtom),nStab(iAtom)) .and. (iDCR(3) /= iOper(0)) .and. (iDCR(2) /= iOper(0))) cycle
        end if

        if (kAtom == lAtom) then
          if (R_Stab_A(iDCR(2),jStab(0,iAtom),nStab(iAtom)) .and. R_Stab_A(iDCR(2),jStab(0,jAtom),nStab(jAtom)) .and. &
              (iDCR(2) /= iOper(0))) cycle
          if (iDCR(3) == iOper(0)) cycle
          if (R_Stab_A(iDCR(3),jStab(0,iAtom),nStab(iAtom)) .and. R_Stab_A(iDCR(3),jStab(0,jAtom),nStab(jAtom)) .and. &
              (iDCR(3) /= iOper(0)) .and. (iDCR(2) /= iOper(0))) cycle
        end if
#       ifdef _DEBUGPRINT_
        write(u6,*)
        write(u6,*) 'TS=',AtomLbl(lAtom),ChOp(iDCR(3))
#       endif

        Help = (ir > 3) .or. (jr > 3) .or. (kr > 3) .or. (lr > 3)

        write(Label,'(A,I2,A,I2,A,I2,A,I2,A)') 'D(',iAtom,',',jAtom,',',kAtom,',',lAtom,')'

        ! Form double coset representatives for (kAtom,lAtom)

        call DCR(Lambda,jStab(0,kAtom),nStab(kAtom),jStab(0,lAtom),nStab(lAtom),iDCRS,nDCRS)
        kDCRS = ieor(iDCR(2),iDCR(3))

#       ifdef _DEBUGPRINT_
        write(u6,'(10A)') 'W={',(ChOp(jStab(i,kAtom)),i=0,nStab(kAtom)-1),'}  '
        write(u6,'(10A)') 'X={',(ChOp(jStab(i,lAtom)),i=0,nStab(lAtom)-1),'}  '
        write(u6,'(10A)') 'S={',(ChOp(iDCRS(i)),i=0,nDCRS-1),'}  '
        write(u6,'(2A)') 'S=',ChOp(kDCRS)
#       endif

        Ref(:,2) = Cx(:,kAtom,iRef)
        call OA(kDCRS,Cx(:,lAtom,iRef),Ref(:,3))
        Prv(:,2) = Cx(:,kAtom,iPrv)
        call OA(kDCRS,Cx(:,lAtom,iPrv),Prv(:,3))

        ! Form stabilizer for (kAtom,lAtom)

        call Inter(jStab(0,kAtom),nStab(kAtom),jStab(0,lAtom),nStab(lAtom),iStabN,nStabN)

#       ifdef _DEBUGPRINT_
        write(u6,'(10A)') 'N={',(ChOp(iStabN(i)),i=0,nStabN-1),'}  '
#       endif

        ! Form double coset representatives for
        ! ((iAtom,jAtom),(kAtom,lAtom))

        call DCR(Lambda,iSTabM,nStabM,iStabN,nStabN,iDCRT,nDCRT)

        ! Take care of some special cases which normally
        ! are not included. If A=B we will normally exclude
        ! the pairs R(A)-A and TS(C)-T(C).

        iDCRX(0:nDCRT-1) = iDCRT(0:nDCRT-1)
        iDCRY(0:nDCRT-1) = iDCRT(0:nDCRT-1)
        nDCRX = nDCRT
        nDCRY = nDCRT
        if (iAtom == jAtom) then
          !write(u6,*) ' Special fix'
          call Union(iDCRX,nDCRX,iDCRY,nDCRY,kDCRR,iDCRT,nDCRT)
        else if (kAtom == lAtom) then
          !write(u6,*) ' Special fix'
          call Union(iDCRX,nDCRX,iDCRY,nDCRY,kDCRS,iDCRT,nDCRT)
        end if

        kDCRT = iDCR(2)
        kDCRTS = iDCR(3)

#       ifdef _DEBUGPRINT_
        write(u6,'(10A)') 'T={',(ChOp(iDCRT(i)),i=0,nDCRT-1),'}  '
        write(u6,'(2A)') 'T=',ChOp(kDCRT)
#       endif

        call OA(kDCRT,Cx(:,kAtom,iIter),A(:,2))
        call OA(kDCRT,Cx(:,kAtom,iRef),Ref(:,2))
        call OA(kDCRT,Cx(:,kAtom,iPrv),Prv(:,2))
        call OA(kDCRTS,Cx(:,lAtom,iIter),A(:,3))
        call OA(kDCRTS,Cx(:,lAtom,iRef),Ref(:,3))
        call OA(kDCRTS,Cx(:,lAtom,iPrv),Prv(:,3))

        ! Form the stabilizer for the out-of-plane

        if ((iAtom == lAtom) .and. (jAtom == kAtom) .and. (kDCRR == kDCRS)) then
          call Union(iStabM,nStabM,iStabN,nStabN,kDCRTS,iStabO,nStabO)
        else
          call Inter(iStabM,nStabM,iStabN,nStabN,iStabO,nStabO)
        end if

#       ifdef _DEBUGPRINT_
        write(u6,'(10A)') 'M={',(ChOp(iStabM(i)),i=0,nStabM-1),'}  '
        write(u6,'(10A)') 'N={',(ChOp(iStabN(i)),i=0,nStabN-1),'}  '
        write(u6,'(10A)') 'O={',(ChOp(iStabO(i)),i=0,nStabO-1),'}  '
        write(u6,*) 'jAtom,iAtom,kAtom,lAtom=',jAtom,iAtom,kAtom,lAtom
#       endif

        ! Compute the degeneracy of the torsion

        iDeg = nIrrep/nStabO
        Deg = sqrt(real(iDeg,kind=wp))

        ! Test if coordinate should be included

        if (Help) then
          f_Const_ijk_Ref = f_Const_ij_Ref
          f_Const_ijk = f_Const_ij
          f_Const_Ref = f_Const_ijk_Ref
          f_Const = f_Const_ijk
        else

          ! Test the ik-pair

          r0 = rAV(ir,kr)
          Alpha = aAv(ir,kr)
          rik2_Ref = (Ref(1,4)-Ref(1,2))**2+(Ref(2,4)-Ref(2,2))**2+(Ref(3,4)-Ref(3,2))**2
          f_Const_ijk_Ref = f_Const_ij_Ref*exp(Alpha*(r0**2-rik2_Ref))
          rik2 = (A(1,4)-A(1,2))**2+(A(2,4)-A(2,2))**2+(A(3,4)-A(3,2))**2
          f_Const_ijk = f_Const_ij*exp(Alpha*(r0**2-rik2))

          ! Test the il-pair

          r0 = rAV(ir,lr)
          Alpha = aAv(ir,lr)
          ril2_Ref = (Ref(1,4)-Ref(1,3))**2+(Ref(2,4)-Ref(2,3))**2+(Ref(3,4)-Ref(3,3))**2
          f_Const_Ref = f_Const_ijk_Ref*exp(Alpha*(r0**2-ril2_Ref))
          ril2 = (A(1,4)-A(1,3))**2+(A(2,4)-A(2,3))**2+(A(3,4)-A(3,3))**2
          f_Const = f_Const_ijk*exp(Alpha*(r0**2-ril2))
        end if
        if ((f_Const_Ref < f_Const_Min) .and. (jBondtype /= Fragments_Bond) .and. (kBondtype /= Fragments_Bond) .and. &
            (lBondtype /= Fragments_Bond)) cycle

        ! Check that valence angles are above threshold

        mCent = 3
        delta0 = 45.0_wp*deg2rad
        !if ((jBondType == Fragments_Bond) .or. (kBondType == Fragments_Bond) .or. (lBondType == Fragments_Bond)) delta = Zero

        ! 1-4-2

        RX4Y(:,1) = Ref(:,1)
        RX4Y(:,2) = Ref(:,4)
        RX4Y(:,3) = Ref(:,2)
        call Bend(RX4Y,mCent,Fi2,Grad_ref,.false.,.false.,'        ',Hess,.false.)
#       ifdef _DEBUGPRINT_
        write(u6,*) '1-4-2: Fi2=',Fi2
#       endif
        delta = delta0
        if ((jBondType == Fragments_Bond) .or. (kBondType == Fragments_Bond)) delta = Zero
        if (Fi2 > Pi-delta) cycle
        if (Fi2 < delta) cycle

        ! 1-4-3

        RX4Y(:,3) = Ref(:,3)
        call Bend(RX4Y,mCent,Fi3,Grad_ref,.false.,.false.,'        ',Hess,.false.)
#       ifdef _DEBUGPRINT_
        write(u6,*) '1-4-3: Fi3=',Fi3
#       endif
        delta = delta0
        if ((jBondType == Fragments_Bond) .or. (lBondType == Fragments_Bond)) delta = Zero
        if (Fi3 > Pi-delta) cycle
        if (Fi3 < delta) cycle

        ! 2-4-3

        RX4Y(:,1) = Ref(:,2)
        call Bend(RX4Y,mCent,Fi4,Grad_ref,.false.,.false.,'        ',Hess,.false.)
#       ifdef _DEBUGPRINT_
        write(u6,*) '2-4-3: Fi4=',Fi4
#       endif
        delta = delta0
        if ((kBondType == Fragments_Bond) .or. (lBondType == Fragments_Bond)) delta = Zero
        if (Fi4 > Pi-delta) cycle
        if (Fi4 < delta) cycle

        call OutofP(Ref,nCent,Val,Grad,.false.,.false.,'        ',Hess,.false.)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Val=',Val/deg2rad
#       endif

        if (abs(Val) > 35.0_wp*deg2rad) cycle

        call OutofP(A,nCent,Val,Grad,.false.,.false.,'        ',Hess,Proc_dB)

        nq = nq+1
        if (.not. Process) mB_Tot = mB_Tot+mB
        if (.not. Proc_dB) mdB_Tot = mdB_Tot+mB**2
#       ifdef _DEBUGPRINT_
        write(u6,*) 'nq=',nq
#       endif

        nqO = nqO+1
        iF1 = 1
        call NxtWrd(AtomLbl(iAtom),iF1,iE1)
        Lbls(1) = AtomLbl(iAtom)(iF1:iE1)

        iF2 = 1
        call NxtWrd(AtomLbl(jAtom),iF2,iE2)
        Lbls(2) = AtomLbl(jAtom)(iF2:iE2)
        if (kDCRR /= 0) then
          Lbls(2)(iE2+1:iE2+2+iChOp(kDCRR)) = '('//ChOp(kDCRR)(1:iChOp(kDCRR))//')'
          call NxtWrd(Lbls(2),iF2,iE2)
        end if

        iF3 = 1
        call NxtWrd(AtomLbl(kAtom),iF3,iE3)
        Lbls(3) = AtomLbl(kAtom)(iF3:iE3)
        if (kDCRT /= 0) then
          Lbls(3)(iE3+1:iE3+2+iChOp(kDCRT)) = '('//ChOp(kDCRT)(1:iChOp(kDCRT))//')'
          call NxtWrd(Lbls(3),iF3,iE3)
        end if

        iF4 = 1
        call NxtWrd(AtomLbl(lAtom),iF4,iE4)
        Lbls(4) = AtomLbl(lAtom)(iF4:iE4)
        if (kDCRTS /= 0) then
          Lbls(4)(iE4+1:iE4+2+iChOp(kDCRTS)) = '('//ChOp(kDCRTS)(1:iChOp(kDCRTS))//')'
          call NxtWrd(Lbls(4),iF4,iE4)
        end if
        write(LuIC,'(A,I3.3,8A)') 'o',nqO,' = Outofp   ',Lbls(2)(iF2:iE2),' ',Lbls(3)(iF3:iE3),' ',Lbls(4)(iF4:iE4),' ', &
                                  Lbls(1)(iF1:iE1)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,I3.3,8A)') 'o',nqO,' = Outofp   ',Lbls(2)(iF2:iE2),' ',Lbls(3)(iF3:iE3),' ',Lbls(4)(iF4:iE4),' ', &
                                Lbls(1)(iF1:iE1)
        write(u6,*) 'iDeg=',iDeg
#       endif
        Label = ' '
        write(Label,'(A,I3.3)') 'o',nqO

        if (Process) then

          Indq(1,nq) = 6
          ij = (jAtom-1)*nsAtom+iAtom
          kl = (lAtom-1)*nsAtom+kAtom
          Indq(2,nq) = (kl-1)*nsAtom**2+ij
          ijDCR = kDCRT*8+kDCRR+1
          Indq(3,nq) = kDCRS*8**2+ijDCR

          !f_Const = Max(f_Const,f_Const_Min)
#         ifdef _DEBUGPRINT_
          write(u6,*) 'f_const=',f_const
#         endif
          fconst(nq) = sqrt(f_Const)
          rMult(nq) = Deg

          Valu(nq,iIter) = Val
          qLbl(nq) = Label

          ! Project the gradient vector

          call ProjSym(nCent,Ind,A,iDCR,Grad,Hess,mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,Proc_dB,nqB,nB,nq,rMult(nq))

        end if

      end do            ! lNeighbor
    end do              ! kNeighbor
  end do                ! iCase
end do                  ! jBond

return

end subroutine OutOfPlane_List

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per Ake Malmqvist                                      *
!               Steven Vancoillie                                      *
!***********************************************************************
!> @brief
!>  Procedure for computing 1-body, 2-body, and 3-body
!>  density elements with active indices only,
!>  and related matrices obtained from contractions with
!>  the diagonal one-electron Hamiltonian.
!> @author Per &Aring;ke Malmqvist
!> @modified_by Steven Vancoillie
!>
!> @details
!> Computation of the 1-, 2-, and 3-body density matrices defined as
!> \f{align}{
!> G1(t,u)         &= \langle 0 \lvert E_{tu} \rvert 0 \rangle \\
!> G2(t,u,v,x)     &= \langle 0 \lvert E_{tuvx} \rvert 0 \rangle \\
!> G3(t,u,v,x,y,z) &= \langle 0 \lvert E_{tuvxyz} \rvert 0 \rangle \\
!> \f}
!> and the contractions with the diagonal 1-el Hamiltonian
!> \f{align}{
!> F1(t,u)         &= \sum_w \langle 0 \lvert E_{tuww} \rvert 0 \rangle e_w \\
!> F2(t,u,v,x)     &= \sum_w \langle 0 \lvert E_{tuvxww} \rvert 0 \rangle e_w \\
!> F3(t,u,v,x,y,z) &= \sum_w \langle 0 \lvert E_{tuvxyzww} \rvert 0 \rangle e_w \\
!> \f}
!> Storage: \p G1 and \p G2 are simple two- and four-index arrays, and
!> includes also such zeroes that are implied by symmetry.
!> But \p G3 is quite large, and while it is stored with zeroes, it
!> is made more compact by calculating only the minimum amount of
!> unique values and storing the active indices in the array \p idxG3.
!> Later, the full matrix can be restored on the fly by using the
!> full permutational symmetry (see ::mksmat and ::mkbmat). The
!> same storage applies to the \f$ F \f$ matrices.
!>
!> @param[in]  mkF   switch to activate computation of \f$ F \f$ matrices
!> @param[in]  CI    wave function CI coefficients, with symmetry \c STSYM
!> @param[in]  nCI   number of CI coefficients, with symmetry \c STSYM
!> @param[out] G1    1-body active density matrix
!> @param[out] G2    2-body active density matrix
!> @param[out] G3    process-local part of 3-body active density matrix
!> @param[out] F1    1-body active density matrix contracted with
!>                   diagonal 1-el Hamiltonian
!> @param[out] F2    2-body active density matrix contracted with
!>                   diagonal 1-el Hamiltonian
!> @param[out] F3    process-local part of 3-body active density matrix
!>                   contracted with diagonal 1-el Hamiltonian
!> @param[out] idxG3 table to translate from process-local array index
!>                   to active indices

subroutine MKFG3(mkF,CI,nCI,G1,F1,G2,F2,G3,F3,idxG3,NLEV,nG1,nG2,nG3)

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use fciqmc_interface, only: DoFCIQMC, mkfg3fciqmc
use PrintLevel, only: DEBUG, VERBOSE
use sguga, only: CIS, EXS, L2ACT, SGS
use caspt2_global, only: do_grad, iPrGlb, iTasks_grad, nbuf1_grad, nStpGrd, nTasks_grad
use caspt2_module, only: EPSA, MxCI, nActEl, nAshT, nBasT, nSym, STSym
use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, byte, RtoB

implicit none
logical(kind=iwp), intent(in) :: mkF
integer(kind=iwp), intent(in) :: nCI, NLEV, nG1, nG2
real(kind=wp), intent(in) :: CI(nCI)
integer(kind=iwp), intent(inout) :: nG3
real(kind=wp), intent(out) :: G1(NLEV,NLEV), F1(NLEV,NLEV), G2(NLEV,NLEV,NLEV,NLEV), F2(NLEV,NLEV,NLEV,NLEV), G3(nG3), F3(nG3)
integer(kind=byte), intent(out) :: idxG3(6,nG3)
integer(kind=iwp) :: I, IB, IBMN, IBMX, IBUF, IBUF1, ID, IDX, IG3, IG3OFF, IOFFSET, IP1, IP1END, IP1I, IP1MN, IP1MX, IP1STA, IP2, &
                     IP3, IP3MX, IQ1, ISP1, ISSG1, ISSG2, ISTU, ISUBTASK, ISVX, ISYZ, IT, ITASK, ITLEV, IU, IULEV, IV, IVLEV, IX, &
                     IXLEV, IY, IYLEV, IZ, IZLEV, J, JDX, MEMMAX, MEMMAX_SAFE, MXTASK, MYBUFFER, MYTASK, NB, NBTOT, NBUF1, NLEV2, &
                     NSGM1, NSGM2, NSUBTASKS, NTASKS, NTRI1, NTRI2
real(kind=wp) :: DF1, DF2, DF3, DG1, DG2, DG3
integer(kind=iwp), allocatable :: ICNJ(:), IDX2IJ(:,:), IJ2IDX(:,:), IP1_BUF(:), TASKLIST(:,:)
real(kind=wp), allocatable :: BUF1(:,:), BUF2(:), BUFD(:), BUFR(:), BUFT(:)
real(kind=wp), external :: DDOT_, DNRM2_

! IJ2IDX, IDX2IJ, ICNJ, IP1_BUF: translation tables for levels i,j to and from pair indices idx
! BUFR: result buffer, maximum size is the largest possible ip1 range,
! which is set to nbuf1 later, i.e. a maximum of nlev2 <= mxlev**2

! Put in zeroes. Recognize special cases:
if (nlev == 0) return

G1(:,:) = Zero
G2(:,:,:,:) = Zero
G3(:) = Zero
if (mkF) then
  F1(:,:) = Zero
  F2(:,:,:,:) = Zero
  F3(:) = Zero
end if

if (NACTEL == 0) return

! This should not happen, but...
if (NCI == 0) return

! Here, for regular CAS or RAS cases.

call mma_allocate(IJ2IDX,nLev,nLev,Label='IJ2IDX')
call mma_allocate(IDX2IJ,2,nLev**2,Label='IDX2IJ')
call mma_allocate(ICNJ,nLev**2,Label='ICNJ')
IJ2IDX(:,:) = -1
IDX2IJ(:,:) = -1
ICNJ(:) = -1

! Special pair index idx2ij allows true RAS cases to be handled:
nlev2 = nlev**2
ntri1 = nTri_Elem(nlev-1)
ntri2 = nTri_Elem(nlev)
idx = 0
do i=1,nlev-1
  do j=i+1,nlev
    ! i<j
    idx = idx+1
    ij2idx(i,j) = idx
    idx2ij(1,idx) = i
    idx2ij(2,idx) = j
    ! i>j
    jdx = nlev2+1-idx ! note the reverse indexation, ...-idx!
    ij2idx(j,i) = jdx
    idx2ij(1,jdx) = j
    idx2ij(2,jdx) = i
  end do
end do
! i=j
do i=1,nlev
  idx = ntri1+i
  ij2idx(i,i) = idx
  idx2ij(1,idx) = i
  idx2ij(2,idx) = i
end do
! Loop over the compond index, idx, corresponding to (i,j) and
! tabulate in icnj(idx) the compound index jdx that corresponds
! to the pair (j,i)
do idx=1,nlev2
  i = idx2ij(1,idx)
  j = idx2ij(2,idx)
  icnj(idx) = ij2idx(j,i)
end do

call mma_deallocate(IJ2IDX)

call mma_MaxDBLE(memmax)

! Use *almost* all remaining memory:
memmax_safe = int(real(memmax,kind=wp)*0.95_wp)

! Buffers to compute CI expansion vectors into:
! <Psi0|E_ip1 | E_ip2 E_ip3|Psi0>
! buf1: bra buffer with E_ip1 excitations of Psi0
!       holds multiple CI vectors (allowed by memory)
! buf2: ket buffer for an E_ip3 excitation of Psi0
! buft: ket buffer for an E_ip2 excitation of E_ip3|Psi0>
! bufd: diagonal matrix elements to compute the F matrix
nbuf1 = max(1,min(nlev2,(memmax_safe-3*mxci)/mxci))
!! if gradient, nbuf1 must be consistent here and in derfg3
if (do_grad .or. (nStpGrd == 2)) then
  !! Compute approximate available memory in derfg3
  !! allocated in DENS
  memmax_safe = memmax_safe-16*NBAST**2-3*NASHT**2
  !! allocated (additionally) in CLagX
  memmax_safe = memmax_safe-2*(NG1+NG2+NG3)
  nbuf1 = max(1,min(nlev2,(memmax_safe-(6+nlev)*mxci)/mxci/3))
  nbuf1_grad = nbuf1
  nTasks_grad = 0
  iTasks_grad(:) = 0
end if
call mma_allocate(BUF1,MXCI,NBUF1,LABEL='BUF1')
call mma_allocate(BUF2,MXCI,LABEL='BUF2')
call mma_allocate(BUFT,MXCI,LABEL='BUFT')
call mma_allocate(BUFD,MXCI,LABEL='BUFD')

!-SVC20100301: calculate maximum number of tasks possible
MXTASK = (NTRI2-1)/NBUF1+1+(NTRI1-1)/NBUF1+1
call mma_allocate(TaskList,mxTask,4,LABEL='TaskList')

if (iPrGlb >= VERBOSE) then
  write(u6,*)
  write(u6,'(2X,A)') 'Constructing G3/F3'
  write(u6,'(2X,A,F16.9,A)') ' memory avail: ',real(memmax*RtoB,kind=wp)*1.0e-9_wp,' GB'
  write(u6,'(2X,A,F16.9,A)') ' memory used:  ',real(((nbuf1+3)*MXCI)*RtoB,kind=wp)*1.0e-9_wp,' GB'
end if

call mma_allocate(ip1_buf,nlev2,Label='ip1_buf')
call mma_allocate(bufr,nlev2,Label='bufr')

!***********************************************************************
!                                                                      *
! A *very* long loop over the symmetry of Sgm1 = E_ut Psi as segmentation.
! This also allows precomputing the Hamiltonian (H0) diagonal elements.

iG3OFF = 0
Symmetry_Loop: do issg1=1,nsym   ! Symmetry index of E_ut/0>
!                                                                      *
!***********************************************************************

  isp1 = Mul(issg1,stsym)       ! Symmetry index of E_ut

  if (.not. DoFCIQMC) then

    ! form: H0_I = \sum_t e_{t}  |I><I|E_{tt}|I><I|

    ! Note: this only works if the Fock matrix is presented in the
    ! block diagonal form. i.e. in the pseudo canonical basis.

    nsgm1 = CIS%ncsf(issg1)
    if (mkF) call H0DIAG_CASPT2(ISSG1,BUFD,nsgm1,CIS%NOW,CIS%IOW,CIS%nMidV)

  end if

  !-SVC20100301: calculate number of larger tasks for this symmetry, this
  !-is basically the number of buffers we fill with SG_Epq_Psi vectors.

  iTask = 1
  ibuf1 = 0
  do ip1=1,nlev2
    itlev = idx2ij(1,ip1)
    iulev = idx2ij(2,ip1)
    istu = Mul(SGS%ism(itlev),SGS%ism(iulev)) ! Symmetry of E_tu

    if (istu == isp1) then
      ! Add pair index to ip1_buf
      ibuf1 = ibuf1+1
      ip1_buf(ibuf1) = ip1
      ! Add pair index to Tasklist(iTask,1) if it is the first entry in ip1_buf
      if (ibuf1 == 1) TaskList(iTask,1) = ip1  ! Start ip1 index
    end if

    ! Terminate if buffer is full, or, if
    if ((ibuf1 == nbuf1) .or. ((ibuf1 > 0) .and. ((ip1 == ntri2) .or. (ip1 == nlev2)))) then
      TaskList(iTask,2) = ip1_buf(ibuf1)  ! End ip1 index
      TaskList(iTask,3) = ibuf1           ! End ibuf value
      iTask = iTask+1
      ibuf1 = 0
    end if

  end do

  nTasks = iTask
  if (ibuf1 == 0) nTasks = nTasks-1

  !-SVC20100309: calculate number of inner loop iteration tasks.
  iOffSet = 0
  do iTask=1,nTasks
    TaskList(iTask,4) = iOffSet
    ip1sta = TaskList(iTask,1)
    ip1end = TaskList(iTask,2)
    ip3mx = ntri2
    if (ip1end <= ntri2) ip3mx = ip1end
    if (ip1sta > ntri2) ip3mx = ntri1
    !-SVC20100309: Currently -we are going to limit this to the ip3-loop and
    !-leave the ip2-loop intact.  This was based on the large overhead which
    !-was observed for a very large number of small tasks.
    !iOffSet = iOffSet+ip3mx*ntri2-nTri_Elem(ip3mx-1)
    iOffSet = iOffSet+ip3mx
  end do
  nSubTasks = iOffSet

  if (iPrGlb >= VERBOSE) write(u6,'(2X,A,I3,A,I6)') 'Sym: ',issg1,', #Tasks: ',nSubTasks

  if (iPrGlb >= DEBUG) then
    if (nSubTasks > 0) then
      write(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)') '--------','------------','----','---------'
      write(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)') 'task ID ',' ip1 range  ','ip3 ','#elements'
      write(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)') '--------','------------','----','---------'
    end if
  end if

  !-SVC20100301: initialize the series of subtasks
  call Init_Tsk(ID,nSubTasks)

  myBuffer = 0
  do

    !-SVC20100908: first check: can I actually do any task?
    if ((NG3-iG3OFF) < nbuf1*ntri2) exit
    !-SVC20100831: initialize counter for offset into G3
    !-SVC20100302: BEGIN SEPARATE TASK EXECUTION
    if (.not. Rsv_Tsk(ID,iSubTask)) exit

    myTask = nTasks
    do iTask=1,nTasks
      iBuf = iSubTask-TaskList(iTask,4)
      if (iBuf <= 0) then
        myTask = iTask-1
        exit
      end if
    end do
    iTask = myTask

    iOffSet = TaskList(iTask,4)

    !-SVC20100310: one task handles a range of ip1 values
    !-that are in the buffer and one ip3 value, for which
    !-a loop over ip2 values is then executed.
    ip1sta = TaskList(iTask,1)
    ip1end = TaskList(iTask,2)
    ip3 = iSubTask-iOffSet

    !-SVC20100301: fill the buffer with sigma vectors if they
    !-have not been computed yet, else just get the number of
    !-sigma vectors in the buffer.
    if (myBuffer /= iTask) then
      ibuf1 = 0

      if (.not. DoFCIQMC) then
        do ip1i=ip1sta,ip1end
          itlev = idx2ij(1,ip1i)
          iulev = idx2ij(2,ip1i)

          istu = Mul(SGS%ism(itlev),SGS%ism(iulev))

          it = L2ACT(itlev)
          iu = L2ACT(iulev)

          if (istu == isp1) then
            ibuf1 = ibuf1+1
            ip1_buf(ibuf1) = ip1i
            ! form E_ut |0>
            BUF1(1:nSgm1,iBuf1) = Zero
            call SG_Epq_Psi(SGS,CIS,EXS,IULEV,ITLEV,One,STSYM,CI,BUF1(:,ibuf1))
          end if
        end do

      else

        do ip1i=ip1sta,ip1end
          itlev = idx2ij(1,ip1i)
          iulev = idx2ij(2,ip1i)
          istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
          it = L2ACT(itlev)
          iu = L2ACT(iulev)
          if (istu == isp1) then
            ibuf1 = ibuf1+1
            ip1_buf(ibuf1) = ip1i
          end if
        end do
      end if

      myBuffer = iTask
    else
      ibuf1 = TaskList(iTask,3)
    end if

    !-SVC20100301: necessary batch of sigma vectors is now in the buffer
    if (.not. DoFCIQMC) then
      ! The ip1 buffer could be the same on different processes
      ! so only compute the G1 contribution when ip3 is 1, as
      ! this will only be one task per buffer.

      ! form <0| *  E_ut|0> = G_tu and
      !      <0| * H0 * E_ut|0> - e_t G_tu = F1_tu

      if ((issg1 == stsym) .and. (ip3 == 1)) then
        if (mkF) then
          do ib=1,ibuf1
            idx = ip1_buf(ib)
            itlev = idx2ij(1,idx)
            iulev = idx2ij(2,idx)
            it = L2ACT(itlev)
            iu = L2ACT(iulev)
            G1(it,iu) = dot_product(CI(1:nsgm1),BUF1(1:nsgm1,ib))
            F1(it,iu) = sum(CI(1:nsgm1)*BUF1(1:nsgm1,ib)*bufd(1:nsgm1))-EPSA(iu)*G1(it,iu)
          end do
        else
          do ib=1,ibuf1
            idx = ip1_buf(ib)
            itlev = idx2ij(1,idx)
            iulev = idx2ij(2,idx)
            it = L2ACT(itlev)
            iu = L2ACT(iulev)
            G1(it,iu) = dot_product(CI(1:nsgm1),BUF1(1:nsgm1,ib))
          end do
        end if
      end if
    end if

    !ip3mx = ntri2
    !if (ip1end <= ntri2) ip3mx =ip1end
    !if (ip1sta > ntri2) ip3mx =ntri1
    !-SVC20100309: loop over ip3, ip2
    !do ip3=1,ip3mx

    !-SVC20100309: PAM's magic formula
    !iCnt = iSubTask-iOffSet
    !ip3 = int(real(ntri2,kind=wp)+OneHalf-sqrt((real(ntri2,kind=wp)+Half)**2-2*iCnt+1.0e-6_wp))
    !ip2 = iCnt-((ip3-1)*ntri2-nTri_Elem(ip3-2)+ip3-1

    !-SVC20100309: use simpler procedure by keeping inner ip2-loop intact

    iq1 = icnj(ip3)
    ! The indices corresponding to pair index p3:
    iylev = idx2ij(1,ip3)
    izlev = idx2ij(2,ip3)
    isyz = Mul(SGS%ism(iylev),SGS%ism(izlev))
    issg2 = Mul(isyz,stsym)
    iy = L2ACT(iylev)
    iz = L2ACT(izlev)
    if (.not. DoFCIQMC) then
      nsgm2 = CIS%ncsf(issg2)
      BUF2(1:nSgm2) = Zero
      ! form <0| E_zy|
      call SG_Epq_Psi(SGS,CIS,EXS,IYLEV,IZLEV,One,STSYM,CI,BUF2)

      if (issg2 == issg1) then

        if (mkF) then
          do ib=1,ibuf1
            idx = ip1_buf(ib)
            itlev = idx2ij(1,idx)
            iulev = idx2ij(2,idx)
            it = L2ACT(itlev)
            iu = L2ACT(iulev)
            ! form <0| E_zy E_ut |0> = G_tu,yz
            !      <0| E_zy * H0 * E_ut |0> = F_tu,yz
            G2(it,iu,iy,iz) = dot_product(BUF2(1:nsgm1),BUF1(1:nsgm1,ib))
            F2(it,iu,iy,iz) = sum(BUF2(1:nsgm1)*bufd(1:nsgm1)*buf1(1:nsgm1,ib))
          end do
        else
          do ib=1,ibuf1
            idx = ip1_buf(ib)
            itlev = idx2ij(1,idx)
            iulev = idx2ij(2,idx)
            it = L2ACT(itlev)
            iu = L2ACT(iulev)
            G2(it,iu,iy,iz) = dot_product(BUF2(1:nsgm1),BUF1(1:nsgm1,ib))
          end do
        end if

      end if

    end if

    nbtot = 0
    do ip2=ip3,ntri2
      ivlev = idx2ij(1,ip2)
      ixlev = idx2ij(2,ip2)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      iv = L2ACT(ivlev)
      ix = L2ACT(ixlev)
      if (isvx == Mul(issg1,issg2)) then
        if (.not. DoFCIQMC) then
          BUFT(1:nSgm1) = Zero
          ! form <0| E_zy E_xv
          call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,ISSG2,BUF2,BUFT)
        end if
        !-----------
        ! Max and min values of index p1:
        ip1mx = ntri2
        if (ip3 <= ntri1) then
          ip1mx = nlev2
          if (ip2 > ntri1) ip1mx = iq1
        end if
        ip1mn = max(ip2,ip1sta)
        ip1mx = min(ip1mx,ip1end)
        ! The corresponding locations in the Sgm1 buffer:
        ibmn = 999999
        ibmx = -999999
        do ib=ibuf1,1,-1
          ip1 = ip1_buf(ib)
          if (ip1 >= ip1mn) ibmn = ib
        end do
        do ib=1,ibuf1
          ip1 = ip1_buf(ib)
          if (ip1 <= ip1mx) ibmx = ib
        end do
        nb = ibmx-ibmn+1
        if (nb > 0) then

          !-----------
          ! Contract the Sgm1 wave functions with the Tau wave function.
          if (.not. DoFCIQMC) then
            ! form <0| E_zy E_xv * E_ut|0>
            call DGEMV_('T',nsgm1,nb,One,BUF1(:,ibmn),mxci,buft,1,Zero,bufr,1)
            ! and distribute this result into G3:
            G3(iG3OFF+1:iG3OFF+nb) = Bufr(1:nb)
            ! and copy the active indices into idxG3:
          end if
          do ib=1,nb
            iG3 = iG3OFF+ib
            idx = ip1_buf(ibmn-1+ib)
            itlev = idx2ij(1,idx)
            iulev = idx2ij(2,idx)
            iT = l2act(itlev)
            iU = l2act(iulev)
            idxG3(1,iG3) = int(iT,kind=byte)
            idxG3(2,iG3) = int(iU,kind=byte)
            idxG3(3,iG3) = int(iV,kind=byte)
            idxG3(4,iG3) = int(iX,kind=byte)
            idxG3(5,iG3) = int(iY,kind=byte)
            idxG3(6,iG3) = int(iZ,kind=byte)
          end do

          if (.not. DoFCIQMC) then
            if (mkF) then
              ! Elementwise multiplication of Tau with H0 diagonal - EPSA(IV):
              ! form <0| E_zy E_xv (H0 -e_v)
              BufT(1:nSgm1) = (BufD(1:nSgm1)-EpsA(iV))*BufT(1:nSgm1)
              !do icsf=1,nsgm1
              !  buft(icsf) = (bufd(icsf)-epsa(iv))*buft(icsf)
              !end do
              ! so Tau is now = Sum(eps(w)*E_vxww) Psi. Contract and distribute:

              ! form <0| E_zy E_xv (H0 -e_v) E_ut|0> = F3(iuv,xyz)
              call DGEMV_('T',nsgm1,nb,One,BUF1(:,ibmn),mxci,buft,1,Zero,bufr,1)
              F3(iG3OFF+1:iG3OFF+nb) = Bufr(1:nb)
            end if
          end if

          iG3OFF = iG3OFF+nb
          nbtot = nbtot+nb
        end if
      end if
    end do

    if (iPrGlb >= DEBUG) write(u6,'("DEBUG> ",I8,1X,"[",I4,"..",I4,"]",1X,I4,1X,I9)') iSubTask,ip1sta,ip1end,ip3,nbtot
    !! consistent tasks must be executed here and in derfg3 for grad
    if (do_grad .or. (nStpGrd == 2)) then
      nTasks_grad = nTasks_grad+1
      iTasks_grad(nTasks_grad) = iSubTask
    end if

    !SVC: The master node now continues to only handle task scheduling,
    !     needed to achieve better load balancing. So it exits from the task
    !     list.  It has to do it here since each process gets at least one
    !     task.

    !-SVC20100301: end of the task
  end do

  !-SVC20100302: no more tasks, wait here for the others, then proceed
  ! with next symmetry
  call Free_Tsk(ID)

  if (iPrGlb >= DEBUG) then
    if (nSubTasks > 0) write(u6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)') '--------','------------','----','---------'
  end if

!***********************************************************************
!                                                                      *
! End of sectioning loop over symmetry of Sgm1 wave functions.
end do Symmetry_Loop
!-SVC20100831: set correct number of elements in new G3
NG3 = iG3OFF
!                                                                      *
!***********************************************************************

call mma_deallocate(ip1_buf)
call mma_deallocate(bufr)
call mma_deallocate(TASKLIST)
! free CI buffers
call mma_deallocate(BUF1)
call mma_deallocate(BUF2)
call mma_deallocate(BUFT)
call mma_deallocate(BUFD)

!-SVC20100302: Synchronized add into the densitry matrices
!  only for the G1 and G2 replicate arrays
call GADGOP(G1,NG1,'+')
call GADGOP(G2,NG2,'+')

if (mkF) then
  call GADGOP(F1,NG1,'+')
  call GADGOP(F2,NG2,'+')
end if

if (DoFCIQMC) then
  call mkfg3fciqmc(G1,G2,G3,F1,F2,F3,idxG3,nLev)
else
  ! Correction to G2: It is now = <0| E_tu E_yz |0>
  do iu=1,nlev
    G2(:,iu,iu,:) = G2(:,iu,iu,:)-G1(:,:)
  end do
  ! SVC20100310: took some spurious mirroring of G2 values out
  ! of the loops and put them here, after the parallel section has
  ! finished, so that GAdGOP works correctly.
  do ip1=ntri2+1,nlev2
    itlev = idx2ij(1,ip1)
    iulev = idx2ij(2,ip1)
    it = L2ACT(itlev)
    iu = L2ACT(iulev)
    do ip3=ntri1+1,ip1
      iylev = idx2ij(1,ip3)
      izlev = idx2ij(2,ip3)
      iy = L2ACT(iylev)
      iz = L2ACT(izlev)
      G2(it,iu,iy,iz) = G2(iz,iy,iu,it)
    end do
  end do
  ! Correction to G2: Some values not computed follow from symmetry
  do ip1=1,nlev2-1
    itlev = idx2ij(1,ip1)
    iulev = idx2ij(2,ip1)
    it = L2ACT(itlev)
    iu = L2ACT(iulev)
    do ip3=ip1+1,nlev2
      iylev = idx2ij(1,ip3)
      izlev = idx2ij(2,ip3)
      iy = L2ACT(iylev)
      iz = L2ACT(izlev)
      G2(it,iu,iy,iz) = G2(iy,iz,it,iu)
    end do
  end do
  if (mkF) then
    ! Correction to F2: It is now = <0| E_tu H0Diag E_yz |0>
    do iy=1,nlev
      do iu=1,nlev
        F2(:,iu,iy,:) = F2(:,iu,iy,:)-(EPSA(iu)+EPSA(iy))*G2(:,iu,iy,:)
      end do
    end do
    do iu=1,nlev
      F2(:,iu,iu,:) = F2(:,iu,iu,:)-(F1(:,:)+EPSA(iu)*G1(:,:))
    end do
    ! SVC20100310: took some spurious mirroring of F2 values out
    ! of the loops and put them here, after the parallel section has
    ! finished, so that GAdGOP works correctly.
    do ip1=ntri2+1,nlev2
      itlev = idx2ij(1,ip1)
      iulev = idx2ij(2,ip1)
      it = L2ACT(itlev)
      iu = L2ACT(iulev)
      do ip3=ntri1+1,ip1
        iylev = idx2ij(1,ip3)
        izlev = idx2ij(2,ip3)
        iy = L2ACT(iylev)
        iz = L2ACT(izlev)
        F2(it,iu,iy,iz) = F2(iz,iy,iu,it)
      end do
    end do
    ! Correction to F2: Some values not computed follow from symmetry
    do ip1=1,nlev2-1
      itlev = idx2ij(1,ip1)
      iulev = idx2ij(2,ip1)
      it = L2ACT(itlev)
      iu = L2ACT(iulev)
      do ip3=ip1+1,nlev2
        iylev = idx2ij(1,ip3)
        izlev = idx2ij(2,ip3)
        iy = L2ACT(iylev)
        iz = L2ACT(izlev)
        F2(it,iu,iy,iz) = F2(iy,iz,it,iu)
      end do
    end do
  end if

  ! Correction to G3: It is now <0| E_tu E_vx E_yz |0>
  ! Similar for F3 values.
  if (mkF) then
    do iG3=1,NG3
      iT = idxG3(1,iG3)
      iU = idxG3(2,iG3)
      iV = idxG3(3,iG3)
      iX = idxG3(4,iG3)
      iY = idxG3(5,iG3)
      iZ = idxG3(6,iG3)
      ! Correction: From <0| E_tu E_vx E_yz |0>, form <0| E_tuvxyz |0>
      if (iY == iX) then
        G3(iG3) = G3(iG3)-G2(iT,iU,iV,iZ)
        F3(iG3) = F3(iG3)-(F2(iT,iU,iV,iZ)+EPSA(iu)*G2(iT,iU,iV,iZ))
        if (iv == iu) then
          G3(iG3) = G3(iG3)-G1(iT,iZ)
          F3(iG3) = F3(iG3)-F1(iT,iZ)
        end if
      end if
      if (iV == iU) then
        G3(iG3) = G3(iG3)-G2(iT,iX,iY,iZ)
        F3(iG3) = F3(iG3)-(F2(iT,iX,iY,iZ)+EPSA(iY)*G2(iT,iX,iY,iZ))
      end if
      if (iY == iU) then
        G3(iG3) = G3(iG3)-G2(iV,iX,iT,iZ)
        F3(iG3) = F3(iG3)-(F2(iV,iX,iT,iZ)+EPSA(iU)*G2(iV,iX,iT,iZ))
      end if
      F3(iG3) = F3(iG3)-(EPSA(iU)+EPSA(iY))*G3(iG3)
    end do
  else
    do iG3=1,NG3
      iT = idxG3(1,iG3)
      iU = idxG3(2,iG3)
      iV = idxG3(3,iG3)
      iX = idxG3(4,iG3)
      iY = idxG3(5,iG3)
      iZ = idxG3(6,iG3)
      ! Correction: From <0| E_tu E_vx E_yz |0>, form <0| E_tuvxyz |0>
      if (iY == iX) then
        G3(iG3) = G3(iG3)-G2(iT,iU,iV,iZ)
        if (iv == iu) G3(iG3) = G3(iG3)-G1(iT,iZ)
      end if
      if (iV == iU) G3(iG3) = G3(iG3)-G2(iT,iX,iY,iZ)
      if (iY == iU) G3(iG3) = G3(iG3)-G2(iV,iX,iT,iZ)
    end do
  end if
end if

call mma_deallocate(idx2ij)
call mma_deallocate(icnj)

if (iPrGlb >= DEBUG) then
  !SVC: if running parallel, G3/F3 are spread over processes,
  !     so make sure that the _total_ fingerprint is computed
  dG1 = DNRM2_(NG1,G1,1)
  dG2 = DNRM2_(NG2,G2,1)
  dG3 = DDOT_(NG3,G3,1,G3,1)
  call GADGOP_SCAL(dG3,'+')
  dG3 = sqrt(dG3)
  dF1 = DNRM2_(NG1,F1,1)
  dF2 = DNRM2_(NG2,F2,1)
  dF3 = DDOT_(NG3,F3,1,F3,1)
  call GADGOP_SCAL(dF3,'+')
  dF3 = sqrt(dF3)

  write(u6,'("DEBUG> ",A)') 'MKFG3: norms of the density matrices:'
  write(u6,'("DEBUG> ",A,1X,ES21.14)') 'G1:',dG1
  write(u6,'("DEBUG> ",A,1X,ES21.14)') 'G2:',dG2
  write(u6,'("DEBUG> ",A,1X,ES21.14)') 'G3:',dG3
  write(u6,'("DEBUG> ",A,1X,ES21.14)') 'F1:',dF1
  write(u6,'("DEBUG> ",A,1X,ES21.14)') 'F2:',dF2
  write(u6,'("DEBUG> ",A,1X,ES21.14)') 'F3:',dF3
end if

end subroutine MKFG3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      ! The initialization subroutine lives outside of the
      ! faroald module so that it can be called separately.
      ! It fills in the necessary global data in the module,
      ! in preparation for the sigma_update routine.
      subroutine faroald_init(nactel,nasht,ispin)
      use faroald
      use second_quantization
      implicit none

      integer, intent(in) :: nactel, nasht, ispin

      my_nel = nactel
      my_norb = nasht
      mult = ispin

      ! compute alpha/beta subsets
      nela = (my_nel+(mult-1))/2
      nhoa = my_norb - nela
      nelb = (my_nel-(mult-1))/2
      nhob = my_norb - nelb
      ndeta = binom_coef(nela,my_norb)
      ndetb = binom_coef(nelb,my_norb)
      my_ndet = ndeta * ndetb

      ! initialize binomial tables needed for ranking
      call rank_init

      ! number of possible non-desctructive single excitations
      max_ex1a = nela * (nhoa + 1)
      max_ex1b = nelb * (nhob + 1)

!     The number of non-vanishing elements in F is the number of
!     non-vanashing single and double excitations from a string, and
!     computed as the number of strings which differ in two, one, or zero
!     spin orbitals from a given string.
      max_ex2a = (nela * (nela - 1) * (nhoa) * (nhoa - 1))/4 +
     & nela * nhoa + 1
      max_ex2b = (nelb * (nelb - 1) * (nhob) * (nhob - 1))/4 +
     & nelb * nhob + 1

!     For sigma1, we use an excitation table for the beta strings.
      allocate (ex1_b(max_ex1b,ndetb))
      call ex1_init(nelb, my_norb, ex1_b)

!     For sigma2, we use an excitation table for the alpha strings, unless
!     Ms = 0 (mult = 1), as for singlet spins sigma2 is not computed and
!     just taken as the transpose of sigma1.
      if (mult.ne.1) then
        allocate (ex1_a(max_ex1a,ndeta))
        call ex1_init(nela, my_norb, ex1_a)
      end if

!     For sigma3, we need to construct a list of determinant couples L(i)
!     = E_pq R(i) for a given p and q for the alpha strings. This is done
!     by a subroutine that takes L, R, and sgn arrays. The maximum size of
!     these arrays is when p=q, at which point the number of couples is:
      max_LRs = binom_coef(nela-1,my_norb-1)

      end subroutine

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993, Roland Lindh                           *
*               1990, IBM                                              *
************************************************************************
      SubRoutine TwoEl_Sym_New(iS_,jS_,kS_,lS_,
     &           Coor,
     &           iAnga,iCmp,iShell,iShll,iAO,iAOst,
     &           NoInts,iStb,jStb,kStb,lStb,
     &           nAlpha,iPrInc, nBeta,jPrInc,
     &           nGamma,kPrInc,nDelta,lPrInc,
     &           Data1,mData1,nData1,Data2,mData2,nData2,
     &           IJeqKL,kOp,
     &           Disc_Mx,Disc,Thize,
     &           Dij,mDij,mDCRij,Dkl,mDkl,mDCRkl,Dik,mDik,mDCRik,
     &           Dil,mDil,mDCRil,Djk,mDjk,mDCRjk,Djl,mDjl,mDCRjl,
     &           TwoHam,Dens,nDens,
     &           Coeff1,iBasi,Coeff2,jBasj,Coeff3,kBask,Coeff4,lBasl,
     &           FckTmp,nFT,Zeta,ZInv,IndZet,Kappab,P,nZeta,
     &           Eta,EInv,IndEta,Kappcd,Q,nEta,
     &           SOInt,nSOInt,Wrk,nWork2,
     &           Shijij,W2Disc,IntOnly,Quad_ijkl,nHRRAB,nHRRCD,
     &           DoIntegrals,DoFock,FckNoClmb,FckNoExch,Aux,nAux,ExFac)
************************************************************************
*                                                                      *
* Object: to generate the SO integrals for four fixed centers and      *
*         fixed basis set types.                                       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*          Roland Lindh, Dept. of Theoretical Chemistry, University of *
*          Lund, SWEDEN. Modified to use Schwartz inequality for pre-  *
*          screening, July 1991.                                       *
*          Modified for direct SCF, January '93                        *
************************************************************************
      use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
      use Real_Spherical
      use Basis_Info
      use Center_Info
      use Phase_Info
      use Gateway_Info, only: ThrInt, CutInt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
#include "real.fh"
#include "print.fh"
#include "twoswi.fh"
      Real*8 SOInt(iBasi*jBasj*kBask*lBasl,nSOInt)
      Real*8 Coor(3,4), CoorM(3,4), CoorAC(3,2),
     &       Data1(mData1,nData1),Data2(mData2,nData2),
     &       Zeta(nZeta), ZInv(nZeta), KappAB(nZeta), P(nZeta,3),
     &       Eta(nEta),   EInv(nEta),  KappCD(nEta),  Q(nEta,3),
     &       Coeff1(nAlpha,iBasi), Coeff2(nBeta,jBasj),
     &       Coeff3(nGamma,kBask), Coeff4(nDelta,lBasl),
     &       Wrk(nWork2), QInd(2), Aux(nAux),
     &       TwoHam(nDens), Dens(nDens), FckTmp(nFT),
     &       Dij(mDij,mDCRij),Dkl(mDkl,mDCRkl),Dik(mDik,mDCRik),
     &       Dil(mDil,mDCRil),Djk(mDjk,mDCRjk),Djl(mDjl,mDCRjl)
      Integer iDCRR(0:7), iDCRS(0:7), iDCRT(0:7), iStabN(0:7),
     &        iStabM(0:7), IndZet(nZeta), IndEta(nEta),
     &        iAO(4), iAnga(4), iCmp(4),
     &        iShell(4), iShll(4), kOp(4), iAOst(4), jOp(6), iWR(2)
      Logical NoPInts, Shijij, AeqB, CeqD, AeqC, ABeqCD,
     &        EQ, Copy, NoCopy,Do_TnsCtl,
     &        IJeqKL,IeqK,JeqL,
     &        lEmpty, Prescreen_On_Int_Only, DoCoul, DoExch,
     &        Scrij, Scrkl, Scrik, Scril, Scrjk, Scrjl,
     &        Batch_On_Disk, W2Disc,
     &        IntOnly, DoIntegrals,DoFock,FckNoClmb, FckNoExch, NoInts,
     &        DoAOBatch, All_Spherical
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Character ChOper(0:7)*3
      Data ChOper/' E ',' x ',' y ',' xy',' z ',' xz',' yz','xyz'/
#endif
      Data Copy/.True./, NoCopy/.False./, jOp/0,0,0,0,0,0/
#include "SysDef.fh"
      External EQ, lEmpty
      Interface
      Integer Function iGet(A,n)
      Integer :: n
      Real*8, Target :: A(*)
      End Function iGet
      End Interface
*
*     Declaration of statement functions to compute canonical index
*
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      Call TwoEl_Sym_New_Internal(Data1,Data2)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iS_)
         Call Unused_integer(jS_)
         Call Unused_integer(kS_)
         Call Unused_integer(lS_)
         Call Unused_integer(iPrInc)
         Call Unused_integer(kPrInc)
         Call Unused_real_array(Dens)
      End If
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine TwoEl_Sym_New_Internal(Data1,Data2)
      Real*8, Target :: Data1(mData1,nData1),Data2(mData2,nData2)
      Integer, Pointer :: iData1(:),iData2(:)
*
#ifdef _DEBUGPRINT_
      iRout = 12
      iPrint = nPrint(iRout)
#endif
*
      All_Spherical=Shells(iShll(1))%Prjct.and.
     &              Shells(iShll(2))%Prjct.and.
     &              Shells(iShll(3))%Prjct.and.
     &              Shells(iShll(4))%Prjct
      QInd(1)=Quad_ijkl
      RST_triplet=One
*
      Do_tnsctl=.False.
      kabcd=0
*
#ifdef _DEBUGPRINT_
      Do iData = 1, nData1
         Call RecPrt('Twoel: Data1',' ',
     &                Data1(1,iData),nAlpha*nBeta,nDArray)
      End Do
      Do iData = 1, nData2
         Call RecPrt('Twoel: Data2',' ',
     &               Data2(1,iData),nGamma*nDelta,nDArray)
      End Do
      Call RecPrt('Coeff1',' ',Coeff1,nAlpha,iBasi)
      Call RecPrt('Coeff2',' ',Coeff2,nBeta,jBasj)
      Call RecPrt('Coeff3',' ',Coeff3,nGamma,kBask)
      Call RecPrt('Coeff4',' ',Coeff4,nDelta,lBasl)
      Call RecPrt('Coor',' ',Coor,3,4)
#endif
*
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      iSmAng=la+lb+lc+ld
      LmbdT=0
      nijkl = iBasi*jBasj*kBask*lBasl
      nab = iCmp(1)*iCmp(2)
      ncd = iCmp(3)*iCmp(4)
      nabcd = nab*ncd
      nInts =nijkl*nabcd
      If (nSOInt.ne.0) Call FZero(SOInt,nSOInt*nijkl)
      iW2=1
      iW3=1+nInts
      iW4=1
*                                                                      *
************************************************************************
*                                                                      *
*-----Find the Double Coset Representatives for center A and B
*
      Call DCR(LmbdR,dc(iStb)%iStab,dc(iStb)%nStab,
     &               dc(jStb)%iStab,dc(jStb)%nStab,iDCRR,nDCRR)
      u = DBLE(dc(iStb)%nStab)
      v = DBLE(dc(jStb)%nStab)
#ifdef _DEBUGPRINT_
      If (iPrint.ge.9) Write (6,'(20A)') ' {R}=(',
     &      (ChOper(iDCRR(i)),',',i=0,nDCRR-1),')'
#endif
*
*-----Find stabilizer for center A and B
*
      Call Inter(dc(iStb)%iStab,dc(iStb)%nStab,
     &           dc(jStb)%iStab,dc(jStb)%nStab,iStabM,lStabM)
*     Write (*,'(20A)') ' M=(',
*    &      (ChOper(iStabM(i)),',',i=0,lStabM-1),')'
*
*                                                                      *
************************************************************************
*                                                                      *
*-----Find the Double Coset Representatives for center C and D.
*
      Call DCR(LmbdS,dc(kStb)%iStab,dc(kStb)%nStab,
     &               dc(lStb)%iStab,dc(lStb)%nStab,iDCRS,nDCRS)
      w = DBLE(dc(kStb)%nStab)
      x = DBLE(dc(lStb)%nStab)
#ifdef _DEBUGPRINT_
      If (iPrint.ge.9) Write (6,'(20A)') ' {S}=(',
     &      (ChOper(iDCRS(i)),',',i=0,nDCRS-1),')'
#endif
*
*-----Find stabilizer for center C and D
*
      Call Inter(dc(kStb)%iStab,dc(kStb)%nStab,
     &           dc(lStb)%iStab,dc(lStb)%nStab,iStabN,lStabN)
*     Write (*,'(20A)') ' N=(',
*    &      (ChOper(iStabN(i)),',',i=0,lStabN-1),')'
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Find the Double Coset Representatives for the two charge
*     distributions.
*
      Call DCR(LmbdT,iStabM,lStabM,iStabN,lStabN,iDCRT,nDCRT)
*     Write (*,*) ' LmbdT=',LmbdT
*     Write (*,'(20A)') ' T=(',
*    &      (ChOper(iDCRT(i)),',',i=0,nDCRT-1),')'
*                                                                      *
************************************************************************
*                                                                      *
      kOp(1)=NrOpr(0)
      call dcopy_(3,Coor(1,1),1,CoorM(1,1),1)
      Do 100 lDCRR = 0, nDCRR-1
         kOp(2)=NrOpr(iDCRR(lDCRR))
         Call OA(iDCRR(lDCRR),Coor(1:3,2),CoorM(1:3,2))
         AeqB = EQ(CoorM(1,1),CoorM(1,2))
*
         lDCR1=NrOpr(iDCRR(lDCRR))+1
*
         vijij=Data1(ip_abMax(nZeta),lDCR1)
*
*switch (to generate better start orbitals...)
         If (NDDO .AND. .NOT.AeqB) Go To 100
*switch
         MxDCRS = nDCRS-1
         Do 200 lDCRS = 0, MxDCRS
            RS_doublet=DBLE(lDCRS*nDCRR+lDCRR+1)
            call dcopy_(3,Coor(1,3),1,CoorM(1,3),1)
            Call OA(iDCRS(lDCRS),Coor(1:3,4),CoorM(1:3,4))
            CeqD = EQ(Coor(1,3),CoorM(1,4))
*
*switch (to generate better start orbitals...)
            If (NDDO .AND. .NOT.CeqD) Go To 200
*
            lDCR2=NrOpr(iDCRS(lDCRS))+1
*
*-----------Pickup estimated largest integral value (AO)
*
            vijkl = vijij * Data2(ip_abMax( nEta),lDCR2)
            Do 300 lDCRT = 0, nDCRT-1
               iW2=1
               iW3=1+nInts
               RS_doublet=DBLE(lDCRS*nDCRR+lDCRR+1)
               RST_triplet=DBLE(lDCRT*nDCRR*nDCRS)+RS_doublet
               QInd(2)=RST_triplet
*              Write (*,*) QInd(1), QInd(2)
               iDCRTS=iEor(iDCRT(lDCRT),iDCRS(lDCRS))
               Call OA(iDCRTS,Coor(1:3,4),CoorM(1:3,4))
               Call OA(iDCRT(lDCRT),Coor(1:3,3),CoorM(1:3,3))
*              If (iPrint.ge.9)
*
*    &            Call RecPrt(' CoorM in TwoEl',' ',CoorM,3,4)
               AeqC = EQ(CoorM(1,1),CoorM(1,3))
               ABeqCD = AeqB .and. CeqD .and. AeqC
               If (ABeqCD .and. Mod(iSmAng,2).eq.1) Go To 300
clwj
clwj           For Spherical Gaussians, batches like
clwj           (DS|SS), (FP|SS) and (FS|PS) vanish as well
               If (ABeqCD .and. All_Spherical .and.
     &                2*Max(la,lb,lc,ld).gt.iSmAng) Go To 300
clwj
*
#ifdef _DEBUGPRINT_
               If (iPrint.ge.9) Write (6,'(6A)')
     &         ' R=',ChOper(iDCRR(lDCRR)),
     &         ', S=',ChOper(iDCRS(lDCRS)),
     &         ', T=',ChOper(iDCRT(lDCRT))
#endif
*
               kOp(3) = NrOpr(iDCRT(lDCRT))
               kOp(4) = NrOpr(iEor(iDCRT(lDCRT),iDCRS(lDCRS)))
*
               ix1 = 1
               iy1 = 1
               iz1 = 1
               ix2 = iPhase(1,iDCRT(lDCRT))
               iy2 = iPhase(2,iDCRT(lDCRT))
               iz2 = iPhase(3,iDCRT(lDCRT))
               lDCRE_=0
               lDCRT_=iDCRT(lDCRT)
*
*------------- Find index to desymmetrized Dij, Dkl, Dik, Dil, Djk, and
*              Djl. Some care has to be taken here. Assume that there
*              are two operators, T and S which generates the center
*              pairs A,T(B) and A,S(B). If these pairs are symmetry
*              related we will only
*
               If (DoFock) Then
*--------------Dij
               iR = iDCRR(lDCRR)
               jOp(1) = NrOpr(iR) + 1
*--------------Dkl
               iS = iDCRS(lDCRS)
               jOp(2)= NrOpr(iS) + 1
*--------------Dik
               iT  = iDCRT(lDCRT)
               jOp(3)= NrOpr(iT) + 1
*--------------Dil
               iTS = iEor(iT,iS)
               jOp(4)= NrOpr(iTS) + 1
*--------------Djk
               iRT = iEor(iR,iT)
               jOp(5)= NrOpr(iRT) + 1
*--------------Djl
               iRTS= iEor(iRT,iS)
               jOp(6)= NrOpr(iRTS) + 1
*
               End If ! DoFock
*                                                                      *
************************************************************************
*                                                                      *
*--------------Prescreening at group level
*
*--------------Select if batch should be written on the disc at the
*              first iteration and then later on read.
*
               Batch_On_Disk = (vijkl.gt.Thize) .and.
     &                (Disc+DBLE(nInts+2+2/RtoI).le.Disc_Mx)
*              Write (*,*) 'Batch_On_Disk=',Batch_On_Disk
*
*--------------Set prescreening level
*
*              IntOnly = T  prescreening on integral value only
*              IntOnly = F  prescreening on integral & density matrix
*
*              If integral batch is written to disc, no prescreening
*              since prescreening on integrals only was done in k2 loop.
*
               Prescreen_On_Int_Only = IntOnly
               If (DoIntegrals) Prescreen_On_Int_Only=.True.
               If (Batch_On_Disk) Prescreen_On_Int_Only = .True.
*
*--------------Prescreening based on the 1st order density in AO
*              basis (contracted). Observe that this is a rough
*              estimate of if there will be any contribution due to
*              this integral batch.
*
*--------------Special care here for RS, RT and ST degeneracy.
*
*............. Get maximum density elements in AO basis.
*
               If (DoFock) Then
                  vij = Dij(mDij,jOp(1))
                  vkl = Dkl(mDkl,jOp(2))
                  vik = Dik(mDik,jOp(3))
                  vil = Dil(mDil,jOp(4))
                  vjk = Djk(mDjk,jOp(5))
                  vjl = Djl(mDjl,jOp(6))
*                 Coulomb contributions
                  Scrkl = vij*vijkl.ge.ThrInt
                  Scrij = vkl*vijkl.ge.ThrInt
                  DoCoul  = Scrij .or. Scrkl
*
*                 Exchange contributions
                  vik = vik/Four
                  vil = vil/Four
                  vjk = vjk/Four
                  vjl = vjl/Four
                  Scrjl = vik*vijkl.ge.ThrInt
                  Scrjk = vil*vijkl.ge.ThrInt
                  Scril = vjk*vijkl.ge.ThrInt
                  Scrik = vjl*vijkl.ge.ThrInt
                  DoExch = Scrjl .or. Scrjk .or. Scril .or. Scrik
                  If (FckNoClmb) DoCoul=.False.
                  If (FckNoExch) DoExch=.False.
               Else
                  DoCoul=.False.
                  DoExch=.False.
               End If
               DoAOBatch=(DoIntegrals.and.vijkl.gt.CutInt).or.
     &                   (DoFock.and.(DoCoul.or.DoExch)) .or.
     &                   (Batch_On_Disk.and.W2Disc)
C              Write (*,*) 'DoAOBatch=',DoAOBatch
*
*--------------Branch out if crude estimate indicates no contributions!
*
               If (.Not.DoAOBatch) Then
                  If (.Not.Batch_On_Disk) Then
*
*                    AO batch is not on the disk
*
*                    Write (*,*) ' Skip the batch!'
                     Go To 300
                  Else If (Batch_On_Disk.and..Not.W2Disc) Then
*
*                    AO batch is on disk! Do a no copy read to
*                    position the next batch on the disc.
*
*                    Write (*,*) ' Skip the batch!'
*
 1111                Continue
                     Call iRBuf(iWR,2,Copy)
                     Call dRBuf(QInd,2,Copy)
                     Call Store_QLast(QInd)
                     kInts=iWR(1)
                     mInts=iWR(2)
*                    Write (*,*) 'kInts,mInts=',kInts,mInts
                     If (QInd(1).eq.Quad_ijkl .and.
     &                   QInd(2).eq.RST_triplet) Then
                        If (kInts.ne.nInts) Then
                           Call WarningMessage(2,
     &                                 'Twoel: kInts.ne.nInts!')
                           Write (6,*) 'Twoel: kInts,mInts,nInts=',
     &                                         kInts,mInts,nInts
                           Write (6,*) 'Index,1:',QInd(1),QInd(2),
     &                                  Quad_ijkl,RST_triplet
                           Call Abend()
                        End If
                        If (mInts.gt.0) Call dRBuf(Wrk(iW3),mInts,
     &                                             NoCopy)
                        Disc = Disc + DBLE(2/RtoI + 2 + mInts)
                        Go To 300
                     Else If (QInd(1).le.Quad_ijkl) Then
                        If (mInts.gt.0) Call dRBuf(Wrk(iW3),mInts,
     &                                             NoCopy)
                        Disc = Disc + DBLE(2/RtoI + 2 + mInts)
                        Go To 1111
                     Else
                        Call WarningMessage(2,
     &                              'Twoel: batch is lost!')
                        Write (6,*) 'Index,1:',QInd(1),QInd(2),
     &                               Quad_ijkl,RST_triplet
                        Call Abend()
                     End If
*                    Write (*,*) QInd(1),QInd(2),'Empty'
                  End If
               End If
*
               If (DoFock) Then
                  If (iShell(1).ge.iShell(2)) Then
                     ij1 = iBasi
                     ij2 = jBasj
                     ij3 = iCmp(1)
                     ij4 = iCmp(2)
                  Else
                     ij1 = jBasj
                     ij2 = iBasi
                     ij3 = iCmp(2)
                     ij4 = iCmp(1)
                  End If
                  If (iShell(3).ge.iShell(4)) Then
                     kl1 = kBask
                     kl2 = lBasl
                     kl3 = iCmp(3)
                     kl4 = iCmp(4)
                  Else
                     kl1 = lBasl
                     kl2 = kBask
                     kl3 = iCmp(4)
                     kl4 = iCmp(3)
                  End If
                  If (iShell(1).ge.iShell(3)) Then
                     ik1 = iBasi
                     ik2 = kBask
                     ik3 = iCmp(1)
                     ik4 = iCmp(3)
                  Else
                     ik1 = kBask
                     ik2 = iBasi
                     ik3 = iCmp(3)
                     ik4 = iCmp(1)
                  End If
                  If (iShell(1).ge.iShell(4)) Then
                     il1 = iBasi
                     il2 = lBasl
                     il3 = iCmp(1)
                     il4 = iCmp(4)
                  Else
                     il1 = lBasl
                     il2 = iBasi
                     il3 = iCmp(4)
                     il4 = iCmp(1)
                  End If
                  If (iShell(2).ge.iShell(3)) Then
                     jk1 = jBasj
                     jk2 = kBask
                     jk3 = iCmp(2)
                     jk4 = iCmp(3)
                  Else
                     jk1 = kBask
                     jk2 = jBasj
                     jk3 = iCmp(3)
                     jk4 = iCmp(2)
                  End If
                  If (iShell(2).ge.iShell(4)) Then
                     jl1 = jBasj
                     jl2 = lBasl
                     jl3 = iCmp(2)
                     jl4 = iCmp(4)
                  Else
                     jl1 = lBasl
                     jl2 = jBasj
                     jl3 = iCmp(4)
                     jl4 = iCmp(2)
                  End If
               End If ! DoFock
*
*--------------Branch point for partial integral storage.
*
               If (Batch_On_Disk.and..Not.W2Disc) Go To 6767
*                                                                      *
************************************************************************
*                                                                      *
*              Here if the AO batch will be computed !
*
*--------------Compute actual size of the {a0|c0} block
*
               mabMin=nabSz(Max(la,lb)-1)+1
               If (EQ(CoorM(1,1),CoorM(1,2))) mabMin = nabSz(la+lb-1)+1
               mabMax=nabSz(la+lb)
               mcdMin=nabSz(Max(lc,ld)-1)+1
               If (EQ(CoorM(1,3),CoorM(1,4))) mcdMin = nabSz(lc+ld-1)+1
               mcdMax=nabSz(lc+ld)
               mabcd=(mabMax-mabMin+1)*(mcdMax-mcdMin+1)
*
*--------------Find the proper centers to start of with the angular
*              momentum on. If la.eq.lb there will exist an
*              ambiguity to which center that angular momentum should
*              be accumulated on. In that case we will use A and C of
*              the order as defined by the basis functions types.
*
               If (iAnga(1).ge.iAnga(2)) Then
                  call dcopy_(3,CoorM(1,1),1,CoorAC(1,1),1)
               Else
                  call dcopy_(3,CoorM(1,2),1,CoorAC(1,1),1)
               End If
               If (iAnga(3).ge.iAnga(4)) Then
                   call dcopy_(3,CoorM(1,3),1,CoorAC(1,2),1)
               Else
                   call dcopy_(3,CoorM(1,4),1,CoorAC(1,2),1)
               End If
*
*--------------Set flags if triangularization will be used
*
               IeqK = EQ(CoorM(1,1),CoorM(1,3))
               JeqL = EQ(CoorM(1,2),CoorM(1,4))
               IJeqKL = IeqK .and. JeqL
*
*--------------Loops to partition the primitives
*
*              Reset pointer iW2 if we need to reserve speacial
*              space for the contracted integrals.
*
               IncZet=nAlpha*jPrInc
               IncEta=nGamma*lPrInc
               If (nZeta.ne.IncZet.or.nEta.ne.IncEta) Then
                  mWork2 = nWork2 - nijkl*mabcd
                  iW2=1+nijkl*mabcd
               Else
                  mWork2 = nWork2
                  iW2=1
               End If
*
*
               nZeta_Tot=iGet(Data1(ip_IndZ(1,nZeta),lDCR1),nZeta+1)
               nEta_Tot =iGet(Data2(ip_IndZ(1,nEta ),lDCR2),nEta +1)
*
               iZ13_=ip_HrrMtrx(nZeta)+(NrOpr(lDCRE_)*nHRRAB)/nIrrep
               iE13_=ip_HrrMtrx( nEta)+(NrOpr(lDCRT_)*nHRRCD)/nIrrep
*
               kabcd=0
               Do_TnsCtl=.False.
               NoInts   =.True.
               NoPInts  =.True.
               iW2_=iW2
               iW4_=iW4
*
               Do iZeta = 1, nZeta_Tot, IncZet
                  mZeta=Min(IncZet,nZeta_Tot-iZeta+1)
                  If (lEmpty(Coeff2,nBeta,nBeta,jBasj)) Cycle
*
               Do iEta  = 1, nEta_Tot,  IncEta
                  mEta=Min(IncEta,nEta_Tot-iEta+1)
                  If (lEmpty(Coeff4,nDelta,nDelta,lBasl)) Cycle
*
                  Call C_F_Pointer(C_Loc(Data1(ip_IndZ(1,nZeta),lDCR1)),
     &                             iData1,[nZeta])
                  Call C_F_Pointer(C_Loc(Data2(ip_IndZ(1,nEta ),lDCR2)),
     &                             iData2,[nEta])
                  Call DrvRys(iZeta,iEta,nZeta,nEta,mZeta,mEta,
     &                        nZeta_Tot,nEta_Tot,
     &                        Data1(1,lDCR1),mData1,
     &                        Data2(1,lDCR2),mData2,
     &                        nAlpha,nBeta,nGamma,nDelta,
     &                        iData1,
     &                        Zeta,ZInv,P,KappAB,IndZet,
     &                        iData2,
     &                        Eta,EInv,Q,KappCD,IndEta,
     &                        ix1,iy1,iz1,ix2,iy2,iz2,ThrInt,CutInt,
     &                        vij,vkl,vik,vil,vjk,vjl,
     &                        Prescreen_On_Int_Only,NoInts,iAnga,
     &                        CoorM,CoorAC,
     &                        mabMin,mabMax,mcdMin,mcdMax,nijkl,
     &                        nabcd,mabcd,Wrk,iW2_,iW4_,
     &                        nWork2,mWork2,
     &                        Data1(iZ13_,lDCR1),Data2(iE13_,lDCR2),
     &                        la,lb,lc,ld,
     &                        iCmp,iShll,NoPInts,
     &                        Dij(1,jOp(1)),mDij,Dkl(1,jOp(2)),mDkl,
     &                        Do_TnsCtl,kabcd,
     &                        Coeff1,iBasi,Coeff2,jBasj,
     &                        Coeff3,kBask,Coeff4,lBasl)
                  Nullify(iData1,iData2)
*
               End Do
               End Do
*              Call RecPrt('(e0,f0) Total',' ',Wrk(iW4),nijkl,kabcd)
*
               If (NoPInts) Then
                  If (W2Disc) Then
                     If (Batch_On_Disk) Then
*
*                       If the batch was supposed to be on disk make
*                       a mark.
*
                        mInts=0
*
                        iWR(1)=nInts
                        iWR(2)=mInts
                        Call iWBuf(iWR,RtoI)
                        Call dWBuf(QInd,2)
                        Call Store_QLast(QInd)
*
                        Disc = Disc + DBLE(2/RtoI + 2 + mInts)
                     End If
                  End If
                  Go To 300
               End If
*
*------------- Multiply with factors due to summation over DCR
*
               If (MolWgh.eq.1) Then
                  FactNd = DBLE(nIrrep) / DBLE(LmbdT)
               Else If (MolWgh.eq.0) Then
                  FactNd = u*v*w*x / DBLE(nIrrep**3 * LmbdT)
               Else
                  FactNd = sqrt(u*v*w*x)/DBLE(nirrep*lmbdt)
               End If
               If (FactNd.ne.One) Call DScal_(kabcd*nijkl,FactNd,
     &                                       Wrk(iW4),1)
*
*--------------Apply the transfer equation and transform the spherical
*              harmonic gaussian.
*
               If (Do_TnsCtl) Then
                  Call TnsCtl(Wrk(iW4),nWork2,CoorM,
     &                        mabcd,nijkl,mabMax,mabMin,mcdMax,mcdMin,
     &                        Data1(iZ13_,lDCR1),Data2(iE13_,lDCR2),
     &                        la,lb,lc,ld,
     &                        iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &                        iShll(1),iShll(2),iShll(3),iShll(4),i_Int)
                  iW2=i_Int
                  If (i_Int.eq.1) Then
                     iW3=1+nijkl*nabcd
                  Else
                     iW3=1
                  End If
               Else
*
*---------------- Undo the late Cntrct
*
                  call dcopy_(nijkl*nabcd,Wrk(iW2),1,Wrk(iW3),1)
                  Call DGeTMO(Wrk(iW3),nabcd,nabcd,nijkl,Wrk(iW2),nijkl)
*
               End If
*
*--------------Branch point for partial integral storage
*
               If (Batch_On_Disk.and.W2Disc) Then
*
*---------------- Write integrals to current position on disc.
*
                  iOpt=0 ! Always Packing, not run length
                  Call PkR8(iOpt,nInts,nByte,Wrk(iW2),Wrk(iW3))
                  mInts=(nByte+RtoB-1)/RtoB
*
                  iWR(1)=nInts
                  iWR(2)=mInts
*                 Write (*,*) 'nInts,mInts=',nInts,mInts
                  Call iWBuf(iWR,2)
                  Call dWBuf(QInd,2)
                  Call Store_QLast(Qind)
                  Call dWBuf(Wrk(iW3),mInts)
*                 Write (*,*) QInd(1),QInd(2),DDot_(nInts,Wrk(iW2),1,
*    &                                                   Wrk(iW2),1)
*
                  Disc = Disc + DBLE(2/RtoI + 2 + mInts)
*
               End If
*
 6767          Continue
               If (Batch_On_Disk.and..Not.W2Disc) Then
 1112             Continue
                  Call iRBuf(iWR,2,Copy)
                  Call dRBuf(QInd,2,Copy)
                  Call Store_QLast(QInd)
                  kInts=iWR(1)
                  mInts=iWR(2)
*                 Write (*,*) 'kInts,mInts=',kInts,mInts
                  If (QInd(1).eq.Quad_ijkl .and.
     &                QInd(2).eq.RST_triplet) Then
                     If (kInts.ne.nInts) Then
                        Call WarningMessage(2,
     &                              'Twoel: kInts.ne.nInts!')
                        Write (6,*) 'Twoel: kInts,mInts,nInts=',
     &                                      kInts,mInts,nInts
                        Write (6,*) 'Index,1:',QInd(1),QInd(2),
     &                               Quad_ijkl,RST_triplet
                        Call Abend()
                     End If
                     If (mInts.gt.0) Call dRBuf(Wrk(iW3),mInts,Copy)
                     Disc = Disc + DBLE(2/RtoI + 2 + mInts)
                     If (mInts.eq.0) Go To 300
                  Else If (QInd(1).lt.Quad_ijkl) Then
                     If (mInts.gt.0) Call dRBuf(Wrk(iW3),mInts,NoCopy)
                     Disc = Disc + DBLE(2/RtoI + 2 + mInts)
                     Go To 1112
                  Else
                     Call WarningMessage(2,'Twoel: batch is lost!')
                     Write (6,*) 'Index,1:',QInd(1),QInd(2),
     &                            Quad_ijkl,RST_triplet
                     Call Abend()
                  End If
*
                  iOpt=0 ! Always packing, not run length
                  Call UpkR8(iOpt,nInts,nByte,Wrk(iW3),Wrk(iW2))
*                 Write (*,*) QInd(1),QInd(2),DDot_(nInts,Wrk(iW2),1,
*    &                                                   Wrk(iW2),1)
               End If
*
*--------------Accumulate contributions directly to the symmetry
*              adapted Fock matrix.
*
               mWork3=nWork2-iW3+1
               If (DoFock)
     &         Call FckAcc(iAnga,iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &                     Shijij,iShll,iShell,kOp,nijkl,
     &                     Wrk(iW2),TwoHam,nDens,Wrk(iW3),mWork3,
     &                     iAO,iAOst,
     &                     iBasi,jBasj,kBask,lBasl,
     &                     Dij(1,jOp(1)),ij1,ij2,ij3,ij4,
     &                     Dkl(1,jOp(2)),kl1,kl2,kl3,kl4,
     &                     Dik(1,jOp(3)),ik1,ik2,ik3,ik4,
     &                     Dil(1,jOp(4)),il1,il2,il3,il4,
     &                     Djk(1,jOp(5)),jk1,jk2,jk3,jk4,
     &                     Djl(1,jOp(6)),jl1,jl2,jl3,jl4,
     &                     FckTmp,nFT,DoCoul,DoExch,ExFac)
*
*              Transform from AO basis to SO basis
*
               If (DoIntegrals)
     &         Call SymAdp(iAnga, iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &                     Shijij,iShll,iShell,iAO,kOp,nijkl,
     &                     Aux,nAux,Wrk(iW2),SOInt,nSOInt,NoInts)
*
 300        Continue
 200     Continue
 100  Continue
      End Subroutine TwoEl_Sym_New_Internal
*
      End
      SubRoutine TwoEl_NoSym_New(iS_,jS_,kS_,lS_,
     &           Coor,
     &           iAnga,iCmp,iShell,iShll,iAO,iAOst,
     &           NoInts,iStb,jStb,kStb,lStb,
     &           nAlpha,iPrInc, nBeta,jPrInc,
     &           nGamma,kPrInc,nDelta,lPrInc,
     &           Data1,mData1,nData1,Data2,mData2,nData2,
     &           IJeqKL,kOp,
     &           Disc_Mx,Disc,Thize,
     &           Dij,mDij,mDCRij,Dkl,mDkl,mDCRkl,Dik,mDik,mDCRik,
     &           Dil,mDil,mDCRil,Djk,mDjk,mDCRjk,Djl,mDjl,mDCRjl,
     &           TwoHam,Dens,nDens,
     &           Coeff1,iBasi,Coeff2,jBasj,Coeff3,kBask,Coeff4,lBasl,
     &           FckTmp,nFT,Zeta,ZInv,IndZet,Kappab,P,nZeta,
     &           Eta,EInv,IndEta,Kappcd,Q,nEta,
     &           SoInt,nSoInt,Wrk,nWork2,
     &           Shijij, W2Disc,IntOnly,Quad_ijkl,nHRRAB,nHRRCD,
     &           DoIntegrals,DoFock,FckNoClmb,FckNoExch,Aux,nAux,ExFac)
************************************************************************
*                                                                      *
* Object: to generate the SO integrals for four fixed centers and      *
*         fixed basis set types.                                       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*          Roland Lindh, Dept. of Theoretical Chemistry, University of *
*          Lund, SWEDEN. Modified to use Schwartz inequality for pre-  *
*          screening, July 1991.                                       *
*          Modified for direct SCF, January '93                        *
************************************************************************
      use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
      use Real_Spherical
      use Basis_Info
      use Center_Info
      use Gateway_Info, only: ThrInt, CutInt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
#include "real.fh"
#include "print.fh"
#include "twoswi.fh"
      Real*8 Coor(3,4), CoorAC(3,2),
     &       Data1(mData1),Data2(mData2),
     &       Zeta(nZeta), ZInv(nZeta), KappAB(nZeta), P(nZeta,3),
     &       Eta(nEta),   EInv(nEta),  KappCD(nEta),  Q(nEta,3),
     &       Coeff1(nAlpha,iBasi), Coeff2(nBeta,jBasj),
     &       Coeff3(nGamma,kBask), Coeff4(nDelta,lBasl),
     &       SOInt(nSOInt),Wrk(nWork2), QInd(2), Aux(nAux),
     &       TwoHam(nDens), Dens(nDens), FckTmp(nFT),
     &       Dij(mDij,mDCRij),Dkl(mDkl,mDCRkl),Dik(mDik,mDCRik),
     &       Dil(mDil,mDCRil),Djk(mDjk,mDCRjk),Djl(mDjl,mDCRjl)
      Integer IndZet(nZeta),IndEta(nEta),iAO(4), kOp(4),
     &        iAnga(4), iCmp(4), iShell(4), iShll(4), iAOst(4), iWR(2)
      Logical NoPInts, Shijij, AeqB, CeqD, AeqC, ABeqCD,
     &        EQ, Copy, NoCopy, Do_TnsCtl, IJeqKL,IeqK,JeqL,
     &        Pij, Pkl, Pijkl, Pik, Pjl,
     &        lEmpty, Prescreen_On_Int_Only, DoCoul, DoExch,
     &        Scrij, Scrkl, Scrik, Scril, Scrjk, Scrjl,
     &        Batch_On_Disk, W2Disc, DoAOBatch, All_Spherical,
     &        IntOnly, DoIntegrals,DoFock,FckNoClmb, FckNoExch, NoInts
      Data Copy/.True./, NoCopy/.False./
#include "SysDef.fh"
      External EQ, lEmpty
      Interface
      Integer Function iGet(A,n)
      Integer :: n
      Real*8, Target :: A(*)
      End Function iGet
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*
*     Declaration of statement functions to compute canonical index
*
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      Call TwoEl_NoSym_New_Internal(Data1,Data2)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iStb)
         Call Unused_integer(jStb)
         Call Unused_integer(kStb)
         Call Unused_integer(lStb)
         Call Unused_integer(iPrInc)
         Call Unused_integer(kPrInc)
         Call Unused_integer(nData1)
         Call Unused_integer(nData2)
         Call Unused_real_array(FckTmp)
         Call Unused_real_array(SoInt)
         Call Unused_integer(nHRRAB)
         Call Unused_integer(nHRRCD)
         Call Unused_real_array(Aux)
      End If
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine TwoEl_NoSym_New_Internal(Data1,Data2)
      Real*8, Target :: Data1(*),Data2(*)
      Integer, Pointer :: iData1(:),iData2(:)
*
      All_Spherical=Shells(iShll(1))%Prjct.and.
     &              Shells(iShll(2))%Prjct.and.
     &              Shells(iShll(3))%Prjct.and.
     &              Shells(iShll(4))%Prjct
*
#ifdef _DEBUGPRINT_
      Call RecPrt('Twoel: Data1',' ',
     &             Data1,nAlpha*nBeta,nDArray-1)
      Call RecPrt('Twoel: Data2',' ',
     &             Data2,nGamma*nDelta,nDArray-1)
      Call RecPrt('Coeff1',' ',Coeff1,nAlpha,iBasi)
      Call RecPrt('Coeff2',' ',Coeff2,nBeta,jBasj)
      Call RecPrt('Coeff3',' ',Coeff3,nGamma,kBask)
      Call RecPrt('Coeff4',' ',Coeff4,nDelta,lBasl)
#endif
*
      RST_triplet=One
      QInd(2)=RST_triplet
      kOp(1)=0
      kOp(2)=0
      kOp(3)=0
      kOp(4)=0
*
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      iSmAng=la+lb+lc+ld
*
*switch (to generate better start orbitals...)
      AeqB = EQ(Coor(1,1),Coor(1,2))
      If (NDDO .AND. .NOT.AeqB) Go To 99
      CeqD = EQ(Coor(1,3),Coor(1,4))
      If (NDDO .AND. .NOT.CeqD) Go To 99
*switch
*
      AeqC = EQ(Coor(1,1),Coor(1,3))
      ABeqCD = AeqB .and. CeqD .and. AeqC
      If (ABeqCD .and. Mod(iSmAng,2).eq.1) Go To 99
c     For Spherical Gaussians, batches like
c     (DS|SS), (FP|SS) and (FS|PS) vanish as well
      If (ABeqCD .and. All_Spherical .and.
     &    2*Max(la,lb,lc,ld).gt.iSmAng) Go To 99
*
      nab = iCmp(1)*iCmp(2)
      ncd = iCmp(3)*iCmp(4)
      nijkl = iBasi*jBasj*kBask*lBasl
      nabcd = nab*ncd
      nInts =nijkl*nabcd
      iW2=1
      iW3=1+nInts
      iW4=1
*
      vijkl = Data1(ip_abMax(nZeta))
     &      * Data2(ip_abMax( nEta))
*
      Batch_On_Disk = (vijkl.gt.Thize) .and.
     &       (Disc+DBLE(nInts+2+2/RtoI).le.Disc_Mx)
*
      Prescreen_On_Int_Only = IntOnly
      If (DoIntegrals) Prescreen_On_Int_Only=.True.
      If (Batch_On_Disk) Prescreen_On_Int_Only = .True.
*
      If (DoFock) Then
         vij = Dij(mDij,1)
         vkl = Dkl(mDkl,1)
*        Coulomb contributions
         Scrkl = vij*vijkl.ge.ThrInt
         Scrij = vkl*vijkl.ge.ThrInt
         DoCoul  = Scrij .or. Scrkl
*
*        Exchange contributions
         vik = Dik(mDik,1)/Four
         vil = Dil(mDil,1)/Four
         vjk = Djk(mDjk,1)/Four
         vjl = Djl(mDjl,1)/Four
         Scrjl = vik*vijkl.ge.ThrInt
         Scrjk = vil*vijkl.ge.ThrInt
         Scril = vjk*vijkl.ge.ThrInt
         Scrik = vjl*vijkl.ge.ThrInt
         DoExch = Scrjl .or. Scrjk .or. Scril .or. Scrik
         If (FckNoClmb) DoCoul=.False.
         If (FckNoExch) DoExch=.False.
      Else
         DoCoul=.False.
         DoExch=.False.
      End If
      DoAOBatch=(DoIntegrals.and.vijkl.gt.CutInt).or.
     &          (DoFock.and.(DoCoul.or.DoExch)) .or.
     &          (Batch_On_Disk.and.W2Disc)
*
*-----Branch out if crude estimate indicates no contributions!
*
      If (.Not.DoAOBatch) Then
         If (.Not.Batch_On_Disk) Then
*           Write (*,*) ' Skip the batch!'
            Go To 99
         Else If (Batch_On_Disk.and..Not.W2Disc) Then
*           Write (*,*) ' Skip the batch!'
 1111       Continue
            Call iRBuf(iWR,2,Copy)
            Call dRBuf(QInd,2,Copy)
            Call Store_QLast(QInd)
            kInts=iWR(1)
            mInts=iWR(2)
            If (QInd(1).eq.Quad_ijkl) Then
               If (kInts.ne.nInts) Then
                  Call WarningMessage(2,
     &                        'Twoel: kInts.ne.nInts!')
                  Write (6,*) 'Twoel: kInts,mInts,nInts=',
     &                                kInts,mInts,nInts
                  Write (6,*) 'Index,1:',QInd(1),Quad_ijkl
                  Call Abend()
               End If
               If (mInts.gt.0) Call dRBuf(Wrk(iW3),mInts,NoCopy)
               Disc = Disc + DBLE(2/RtoI + 2 + mInts)
               Go To 99
            Else If (QInd(1).lt.Quad_ijkl) Then
               If (mInts.gt.0) Call dRBuf(Wrk(iW3),mInts,NoCopy)
               Disc = Disc + DBLE(2/RtoI + 2 + mInts)
               Go To 1111
            Else
               Call WarningMessage(2,'Twoel: batch is lost!')
               Write (6,*) 'Index,1:',QInd(1),QInd(2),
     &                      Quad_ijkl,RST_triplet
               Call Abend()
            End If
         End If
      End If
*
*
*-----Branch point for partial integral storage
*
      If (Batch_On_Disk.and..Not.W2Disc) Go To 6767
*                                                                      *
************************************************************************
*                                                                      *
*     Here if the AO batch will be computed!
*
*-----Compute actual size of the {a0|c0} block
*
      mabMin=nabSz(Max(la,lb)-1)+1
      If (EQ(Coor(1,1),Coor(1,2))) mabMin = nabSz(la+lb-1)+1
      mabMax=nabSz(la+lb)
      mcdMin=nabSz(Max(lc,ld)-1)+1
      If (EQ(Coor(1,3),Coor(1,4))) mcdMin = nabSz(lc+ld-1)+1
      mcdMax=nabSz(lc+ld)
      mabcd=(mabMax-mabMin+1)*(mcdMax-mcdMin+1)
*
*-----Find the proper centers to start of with the angular
*     momentum on. If la.eq.lb there will exist an
*     ambiguity to which center that angular momentum should
*     be accumulated on. In that case we will use A and C of
*     the order as defined by the basis functions types.
*
      If (iAnga(1).ge.iAnga(2)) Then
         call dcopy_(3,Coor(1,1),1,CoorAC(1,1),1)
      Else
         call dcopy_(3,Coor(1,2),1,CoorAC(1,1),1)
      End If
      If (iAnga(3).ge.iAnga(4)) Then
         call dcopy_(3,Coor(1,3),1,CoorAC(1,2),1)
      Else
         call dcopy_(3,Coor(1,4),1,CoorAC(1,2),1)
      End If
*
*-----Set flags if triangularization will be used
*
      IeqK = EQ(Coor(1,1),Coor(1,3))
      JeqL = EQ(Coor(1,2),Coor(1,4))
      IJeqKL = IeqK .and. JeqL
*
*-----Loops to partion the primitives
*
      IncZet=nAlpha*jPrInc
      IncEta=nGamma*lPrInc
      If (nZeta.ne.IncZet.or.nEta.ne.IncEta) Then
         mWork2 = nWork2 - nijkl*mabcd
         iW2=1+nijkl*mabcd
      Else
         mWork2 = nWork2
         iW2=1
      End If
*
      nZeta_Tot=iGet(Data1(ip_IndZ(1,nZeta)),nZeta+1)
      nEta_Tot =iGet(Data2(ip_IndZ(1,nEta )),nEta +1)
#ifdef _DEBUGPRINT_
      Write (6,*) 'nZeta_Tot, IncZet=',nZeta_Tot, IncZet
      Write (6,*) 'nEta_Tot,  IncEta=',nEta_Tot,  IncEta
#endif
*
*
      kabcd=0
      Do_TnsCtl=.False.
      NoInts=.True.
      NoPInts = .True.
      iW2_=iW2
      iW4_=iW4
*
      Do iZeta = 1, nZeta_Tot, IncZet
         mZeta=Min(IncZet,nZeta_Tot-iZeta+1)
         If (lEmpty(Coeff2,nBeta,nBeta,jBasj)) Cycle
*
         Do iEta  = 1, nEta_Tot,  IncEta
            mEta=Min(IncEta,nEta_Tot-iEta+1)
            If (lEmpty(Coeff4,nDelta,nDelta,lBasl)) Cycle
*
            Call C_F_Pointer(C_Loc(Data1(ip_IndZ(1,nZeta))),
     &                             iData1,[nZeta])
            Call C_F_Pointer(C_Loc(Data2(ip_IndZ(1,nEta))),
     &                             iData2,[nEta])
            Call DrvRys(iZeta,iEta,nZeta,nEta,mZeta,mEta,
     &                  nZeta_Tot,nEta_Tot,
     &                  Data1,mData1,
     &                  Data2,mData2,
     &                  nAlpha,nBeta,nGamma,nDelta,
     &                  iData1,
     &                  Zeta,ZInv,P,KappAB,IndZet,
     &                  iData2,
     &                  Eta,EInv,Q,KappCD,IndEta,
     &                  1,1,1,1,1,1,ThrInt,CutInt,
     &                  vij,vkl,vik,vil,vjk,vjl,
     &                  Prescreen_On_Int_Only,NoInts,iAnga,
     &                  Coor,CoorAC,
     &                  mabMin,mabMax,mcdMin,mcdMax,nijkl,
     &                  nabcd,mabcd,Wrk,iW2_,iW4_,
     &                  nWork2,mWork2,
     &                  Data1(ip_HrrMtrx(nZeta)),
     &                  Data2(ip_HrrMtrx(nEta) ),
     &                  la,lb,lc,ld,
     &                  iCmp,iShll,NoPInts,
     &                  Dij(1,1),mDij,Dkl(1,1),mDkl,Do_TnsCtl,kabcd,
     &                  Coeff1,iBasi,Coeff2,jBasj,
     &                  Coeff3,kBask,Coeff4,lBasl)
            Nullify(iData1,iData2)
*
         End Do
      End Do
*              Call RecPrt('(e0,f0) Total',' ',Wrk(iW4),nijkl,kabcd)
*
      If (NoPInts) Then
         If (W2Disc) Then
            If (Batch_On_Disk) Then
               iOpt=0
               mInts=0
*
               iWR(1)=nInts
               iWR(2)=mInts
               Call iWBuf(iWR,2)
               QInd(1)=Quad_ijkl
               Call dWBuf(QInd,2)
               Call Store_QLast(QInd)
*
               Disc = Disc + DBLE(2/RtoI + 2 + mInts)
            End If
         End If
         Go To 99
      End If
*
*-----Apply the transfer equation and transform the spherical
*     harmonic gaussian.
*
      If (Do_TnsCtl) Then
         Call TnsCtl(Wrk(iW4),nWork2,Coor,
     &               mabcd,nijkl,mabMax,mabMin,mcdMax,mcdMin,
     &               Data1(ip_HrrMtrx(nZeta)),
     &               Data2(ip_HrrMtrx(nEta) ),
     &               la,lb,lc,ld,
     &               iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &               iShll(1),iShll(2),iShll(3),iShll(4),i_Int)
         iW2=i_Int
         If (i_Int.eq.1) Then
            iW3=1+nijkl*nabcd
         Else
            iW3=1
         End If
      Else
*
*--------Undo the late Cntrct
*
         call dcopy_(nijkl*nabcd,Wrk(iW2),1,Wrk(iW3),1)
         Call DGeTMO(Wrk(iW3),nabcd,nabcd,nijkl,Wrk(iW2),nijkl)
*
      End If
#ifdef _DEBUGPRINT_
      Call RecPrt('(AB|CD)',' ',Wrk(iW2),nijkl,
     &            iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4))
#endif
*
*-----Branch point for partial integral storage
*
      If (Batch_On_Disk.and.W2Disc) Then
*
*--------Write integrals to current position on disc.
*
         iOpt=0
         Call PkR8(iOpt,nInts,nByte,Wrk(iW2),Wrk(iW3))
         mInts=(nByte+RtoB-1)/RtoB
*
         iWR(1)=nInts
         iWR(2)=mInts
*        Write (*,*) 'nInts,mInts=',nInts,mInts
         Call iWBuf(iWR,2)
         QInd(1)=Quad_ijkl
         Call dWBuf(QInd,2)
         Call Store_QLast(QInd)
         Call dWBuf(Wrk(iW3),mInts)
*
         Disc = Disc + DBLE(2/RtoI + 2 + mInts)
*
      End If
*
 6767 Continue
      If (Batch_On_Disk.and..Not.W2Disc) Then
 1112    Continue
         Call iRBuf(iWR,2,Copy)
         Call dRBuf(QInd,2,Copy)
         Call Store_QLast(QInd)
         kInts=iWR(1)
         mInts=iWR(2)
         If (QInd(1).eq.Quad_ijkl) Then
            If (kInts.ne.nInts) Then
               Call WarningMessage(2,
     &                     'Twoel: kInts.ne.nInts!')
               Write (6,*) 'Twoel: kInts,mInts,nInts=',
     &                             kInts,mInts,nInts
               Write (6,*) 'Index,1:',QInd(1),Quad_ijkl
               Call Abend()
            End If
            If (mInts.gt.0) Call dRBuf(Wrk(iW3),mInts,Copy)
            Disc = Disc + DBLE(2/RtoI + 2 + mInts)
            If (mInts.eq.0) Go To 99
         Else If (QInd(1).lt.Quad_ijkl) Then
            If (mInts.gt.0) Call dRBuf(Wrk(iW3),mInts,NoCopy)
            Disc = Disc + DBLE(2/RtoI + 2 + mInts)
            Go To 1112
         Else
            Call WarningMessage(2,'Twoel: batch is lost!')
            Write (6,*) 'Index,1:',QInd(1),QInd(2),
     &                   Quad_ijkl,RST_triplet
            Call Abend()
         End If
*
         iOpt=0
         Call UpkR8(iOpt,nInts,nByte,Wrk(iW3),Wrk(iW2))
      End If
*
*-----Accumulate contributions directly to the Fock matrix.
*
      If (DoFock)
     &Call FckAcc_NoSymq(iAnga,iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &                  Shijij, iShll, iShell, nijkl,
     &                  Wrk(iW2),TwoHam,Dens,nDens,
     &                  iAO,iAOst,
     &                  iBasi,jBasj,kBask,lBasl,DoCoul,DoExch,
     &                  vij,vkl,vik,vil,vjk,vjl,ExFac)
*
      If (DoIntegrals) Then
         If (iW2.ne.1) call dcopy_(nijkl*iCmp(1)*iCmp(2)*
     &                            iCmp(3)*iCmp(4),Wrk(iW2),1,Wrk(1),1)
         iPer = 1
         Pij= iS_.eq.jS_
         Pkl= kS_.eq.lS_
         Pik= iS_.eq.kS_
         Pjl= jS_.eq.lS_
         Pijkl= Pij. and. Pkl .and. Pik .and. Pjl
         If (Pij)   iPer = iPer*2
         If (Pkl)   iPer = iPer*2
         If (Pijkl) iPer = iPer*2
         q4 = DBLE(8)/DBLE(iPer)
         If (nIrrep.eq.1) q4 = One
         If (q4.ne.One) Call DScal_(nijkl*iCmp(1)*iCmp(2)
     &                            *iCmp(3)*iCmp(4),q4,Wrk(iW2),1)
      End If
  99  Continue
      End Subroutine TwoEl_NoSym_New_Internal
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine vbgendet_cvb(iapr,ixapr,ibpr,ixbpr,iconfs,idetvb,nconf,nconfion,nda,ndb,ndetvb,nel,noe,nalf,nbet,norb)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nconf, noe, iconfs(noe,nconf), nel, nconfion(0:nel), nda, ndb, ndetvb, nalf, nbet, norb
integer(kind=iwp), intent(out) :: iapr(ndetvb), ixapr(nda+1), ibpr(ndetvb), ixbpr(ndb+1), idetvb(ndetvb)
integer(kind=iwp) :: i, j
integer(kind=iwp), allocatable :: idetavb(:), idetbvb(:), iwrk1(:), iwrk2(:)
logical(kind=iwp), parameter :: debug = .false.

call mma_allocate(idetavb,ndetvb,label='idetavb')
call mma_allocate(idetbvb,ndetvb,label='idetbvb')
call mma_allocate(iwrk1,ndetvb,label='iwrk1')
call mma_allocate(iwrk2,ndetvb,label='iwrk2')

if (debug) then
  write(u6,*) ' Generate determinant information :'
  write(u6,*) ' ----------------------------------'
end if

! vbgenabdet gives all VB alpha and beta strings, to use in CASSCF
! space we sort in A/B strings to get increasing order:
call vbgenabdet_cvb(idetavb,idetbvb,iconfs,nconf,nconfion,ndetvb,nel,noe,nalf,nbet,norb)

call sortindxi_cvb(ndetvb,idetbvb,idetvb)
do i=1,ndetvb
  iwrk1(i) = idetbvb(idetvb(i))
  ibpr(i) = idetavb(idetvb(i))
end do
ixbpr(1) = 1
do i=1,ndb
  do j=ixbpr(i),ndetvb
    if (iwrk1(j) /= i) exit
  end do
  ixbpr(i+1) = j
end do
do i=1,ndb
  call sortindxi_cvb(ixbpr(i+1)-ixbpr(i),ibpr(ixbpr(i)),iwrk2)
  do j=1,ixbpr(i+1)-ixbpr(i)
    iwrk1(j) = ibpr(iwrk2(j)+ixbpr(i)-1)
  end do
  ibpr(ixbpr(i):ixbpr(i+1)-1) = iwrk1(1:ixbpr(i+1)-ixbpr(i))
end do
if (debug) then
  write(u6,*) ' ixbpr='
  write(u6,'(10i6)') ixbpr
  write(u6,*) ' ibpr='
  write(u6,'(10i6)') ibpr
end if

call sortindxi_cvb(ndetvb,idetavb,idetvb)
do i=1,ndetvb
  iwrk1(i) = idetavb(idetvb(i))
  iapr(i) = idetbvb(idetvb(i))
end do
ixapr(1) = 1
do i=1,nda
  do j=ixapr(i),ndetvb
    if (iwrk1(j) /= i) exit
  end do
  ixapr(i+1) = j
end do
do i=1,nda
  call sortindxi_cvb(ixapr(i+1)-ixapr(i),iapr(ixapr(i)),iwrk2)
  do j=1,ixapr(i+1)-ixapr(i)
    iwrk1(j) = iapr(iwrk2(j)+ixapr(i)-1)
  end do
  iapr(ixapr(i):ixapr(i+1)-1) = iwrk1(1:ixapr(i+1)-ixapr(i))
  do j=1,ixapr(i+1)-ixapr(i)
    iwrk1(j) = idetvb(iwrk2(j)+ixapr(i)-1)
  end do
  idetvb(ixapr(i):ixapr(i+1)-1) = iwrk1(1:ixapr(i+1)-ixapr(i))
end do
if (debug) then
  write(u6,*) ' ixapr='
  write(u6,'(10i6)') ixapr
  write(u6,*) ' iapr='
  write(u6,'(10i6)') iapr
end if
do i=1,ndetvb
  idetavb(idetvb(i)) = i
end do
idetvb(:) = idetavb(:)
if (debug) then
  write(u6,*) ' idetvb='
  write(u6,'(10i6)') idetvb
end if

call mma_deallocate(idetavb)
call mma_deallocate(idetbvb)
call mma_deallocate(iwrk1)
call mma_deallocate(iwrk2)

return

end subroutine vbgendet_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE INPUT_GUGA(ISO,JSYM,JSY,L0,L1,L2,L3,ISPAC)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "niocr.fh"
#include "SysDef.fh"
#include "files_guga.fh"
      DIMENSION ISO(*),JSYM(*),JSY(*),L0(*),L1(*),L2(*),L3(*)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
#include "warnings.fh"
      DIMENSION MLL(64),IOCR(nIOCR),JREFX(9000),
     *NISH(8),JJS(18),NVAL(8),NCOR(8),ICOR(55),IONE(8),JONE(8)
*
      Parameter ( nCmd=18 )
      Parameter ( mxTit=10 )
      Character*4 Command,Cmd(nCmd)
      Character*72  Line,Title(mxTit)
      Character*132 ModLine
      DATA MLL/1,2,3,4,5,6,7,8, 2,1,4,3,6,5,8,7, 3,4,1,2,7,8,5,6,
     * 4,3,2,1,8,7,6,5, 5,6,7,8,1,2,3,4, 6,5,8,7,2,1,4,3,
     * 7,8,5,6,3,4,1,2, 8,7,6,5,4,3,2,1/
      Data Cmd /'TITL','ELEC','SPIN','SYMM','ACTI',
     &          'PRIN','REFE','FIRS','INAC','CIAL',
     &          'VALE','INTE','NOCO','ONEO','EXTR',
     &          'NONI','NACT','END '/
*
*---  Initialize data and variables -----------------------------------*
      IOM=55
      IVER=MXVERT
      IFIRST=0
      IPRINT=0
      ICIALL=0
      ILIM=4
      N=-1
      NACTEL=-1
      IS=1
      NISHT=0
*     NSYM=1
      Call Get_iScalar('nSym',NSYM)
      NREF=0
CPAM97 New default: Interacting space.
      INTNUM=1
CPAM97 IFCORE.ne.0 means core-polarization orbitals (NOCO keyword).
      IFCORE=0
      LSYM=1
      IN=0
      DO 5 I=1,8
        NISH(I)=0
        NVAL(I)=0
        NCOR(I)=0
        NSH(I)=0
        IONE(I)=0
        DO 6 J=1,8
          IN=IN+1
          MUL(I,J)=MLL(IN)
6       CONTINUE
5     CONTINUE
      DO 207 I=1,55
        ICOR(I)=0
207   CONTINUE
      nTit=0
*
*---  Read input from standard input ----------------------------------*
      Call RdNLst(5,'GUGA')
10    Read(5,'(A)',End=991) Line
      Command=Line(1:8)
      Call UpCase(Command)
      If ( Command(1:1).eq.'*' ) Goto 10
      If (Command.eq.' ') Goto 10
      jCmd=0
      Do iCmd=1,nCmd
         If ( Command.eq.Cmd(iCmd) ) jCmd=iCmd
      End Do
20    Goto ( 100, 200, 300, 400, 500, 600, 700 ,800, 900,1000,
     &      1100,1200,1300,1400,1500,1600,1700,1800           ) jCmd
      Write (6,*) 'Input: Illegal Keyword'
      Write (6,'(A,A)') 'Command=',Command
      Call Quit(_RC_INPUT_ERROR_)
*
*---  process TITLE    command ----------------------------------------*
 100  Continue
      Read(5,'(A)',End=991) Line
      Command=Line(1:8)
      Call UpCase(Command)
      If ( Command(1:1).eq.'*' ) Goto 100
      jCmd=0
      Do iCmd=1,nCmd
         If ( Command.eq.Cmd(iCmd) ) jCmd=iCmd
      End Do
      If ( jCmd.ne.0 ) Goto 20
      nTit=nTit+1
      If ( nTit.le.mxTit ) Title(nTit)=Line
      Goto 100
*
*---  process ELECTRON command ----------------------------------------*
 200  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 200
      Read(Line,*,Err=992) N
      Goto 10
*
*---  process SPIN     command ----------------------------------------*
 300  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 300
      Read(Line,*,Err=992) ISPIN
      Goto 10
*
*---  process SYMMETRY command ----------------------------------------*
 400  Continue
      Write (6,*)'Input_GUGA: keyword SYMMETRY is obsolete and ignored!'
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 400
      Read(Line,*,Err=992) iDummy
      Goto 10
*
*---  process ACTIVE   command ----------------------------------------*
 500  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 500
      ModLine=Line//' 0 0 0 0 0 0 0 0'
      Read(ModLine,*,Err=992) (NSH(I),I=1,8)
      Goto 10
*
*---  process PRINT    command ----------------------------------------*
 600  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 600
      Read(Line,*,Err=992) IPRINT
      Goto 10
*
*---  process REFERENC command ----------------------------------------*
 700  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 700
      Read(Line,*,Err=992) nRef,LN1
      If ( LN1.eq.0 ) Goto 10
      jEnd=0
      Do 710 iRef=1,nRef
         jStart=jEnd+1
         jEnd=jEnd+LN1
         Read(5,'(80I1)',End=991,Err=992) (IOCR(j),j=jStart,jEnd)
 710  Continue
      Goto 10
*
*---  process FIRST    command ----------------------------------------*
 800  Continue
      IFIRST=1
      ILIM=2
      Goto 10
*
*---  process INACTIVE command ----------------------------------------*
 900  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 900
      ModLine=Line//' 0 0 0 0 0 0 0 0'
      Read(ModLine,*,Err=992) (NISH(I),I=1,8)
      NISHT=0
      DO I=1,8
       NISHT=NISHT+NISH(I)
      END DO
      Goto 10
*
*---  process CIALL    command ----------------------------------------*
1000  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1000
      Read(Line,*,Err=992) LSYM
      ICIALL=1
      Goto 10
*
*---  process VALENCE  command ----------------------------------------*
1100  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1100
      ModLine=Line//' 0 0 0 0 0 0 0 0'
      Read(ModLine,*,Err=992) (NVAL(I),I=1,8)
      Goto 10
*
*---  process INTERACT command ----------------------------------------*
1200  Continue
      INTNUM=1
      Goto 10
*
*---  process NOCORR   command ----------------------------------------*
1300  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1300
      ModLine=Line//' 0 0 0 0 0 0 0 0'
      Read(ModLine,*,Err=992) (NCOR(I),I=1,8)
CPAM97 IFCORE was not set -- assume bug. Following line inserted:
      IFCORE=1
      Goto 10
*
*---  process ONEOCC   command ----------------------------------------*
1400  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 1400
      ModLine=Line//' 0 0 0 0 0 0 0 0'
      Read(ModLine,*,Err=992) (IONE(I),I=1,8)
      Goto 10
*
*---  process EXTRACT  command ----------------------------------------*
1500  Write (6,*) 'Input: EXTRACT option is redundant and is ignored!'
      Goto 10
*
*---  process NON-INTERACT command ----------------------------------------*
1600  Continue
      INTNUM=0
      Goto 10
*
*---  process NACTEL       command ----------------------------------------*
1700  Continue
      Read(5,'(A)',End=991) Line
      If ( Line(1:1).eq.'*' ) Goto 200
      Read(Line,*,Err=992) NACTEL
      Goto 10
*
*---  The end of the input is reached, print the title ----------------*
1800  Continue
      if(ntit.eq.0) then
        ntit=1
        title(1)=' (No title was given)'
      end if

* Nr of correlated electrons:
      IF(N.eq.-1 .and. NACTEL.eq.-1) THEN
        Write(6,*)' Neither the number of correlated electrons '//
     &            '(Keyword ELECTRONS)'
        Write(6,*)' nor the nr of active electrons in the reference '//
     &            'space (NACTEL) has been specified.'
        Write(6,*)' The number of active electrons are set to zero.'
        NACTEL=0
      ELSE IF(N.gt.-1 .and. NACTEL.gt.-1) THEN
        Write(6,*)' Both the number of correlated electrons '//
     &            '(Keyword ELECTRONS)'
        Write(6,*)' and the nr of active electrons in the reference '//
     &            'space (NACTEL) have been specified.'
        IF(N.ne.2*NISHT+NACTEL) THEN
         N=2*NISHT+NACTEL
         Write(6,*)' Number of correlated electrons is recomputed,=',N
        END IF
      END IF
      IF(N.eq.-1) N=2*NISHT+NACTEL
      IF(NACTEL.eq.-1) NACTEL=N-2*NISHT

      Write(6,*)
      Write(6,'(6X,120A1)') ('*',i=1,120)
      Write(6,'(6X,120A1)') '*',(' ',i=1,118),'*'
      Write(6,'(6X,57A1,A6,57A1)')'*',(' ',i=1,56),'Title:',
     &                                (' ',i=1,56),'*'
      Do i=1,nTit
         Call Center(Title(i))
         Write(6,'(6X,24A1,A72,24A1)')
     &        '*',(' ',j=1,23),Title(i),(' ',j=1,23),'*'
      End Do
      Write(6,'(6X,120A1)') '*',(' ',i=1,118),'*'
      Write(6,'(6X,120A1)') ('*',i=1,120)
      Write(6,*)
      S=(ISPIN-1)*0.5D0
      IF(IFIRST.EQ.0)WRITE(IW,2)
2     FORMAT(//,6X,'ALL SINGLE AND DOUBLE REPLACEMENTS')
      IF(IFIRST.NE.0)WRITE(IW,1)
1     FORMAT(//,6X,'ONLY SINGLE REPLACEMENTS INCLUDED')
      WRITE(IW,110)N,S
110   FORMAT(/,6X,'NUMBER OF ELECTRONS IN CI',I10,
     */,6X,'TOTAL SPIN QUANTUM NUMBER',F10.2)
      WRITE(IW,109)(I,I=1,NSYM)
109   FORMAT(//,14X,'ORBITALS PER SYMMETRY',/,14X,8I5)
      WRITE(IW,106)(NISH(I),I=1,NSYM)
106   FORMAT(6X,'INACTIVE',8I5)
      WRITE(IW,108)(NSH(I),I=1,NSYM)
108   FORMAT(6X,'ACTIVE  ',8I5)
      WRITE(IW,208)(NVAL(I),I=1,NSYM)
208   FORMAT(6X,'VALENCE ',8I5)
      WRITE(IW,206)(NCOR(I),I=1,NSYM)
206   FORMAT(6X,'CORE    ',8I5)
      WRITE(IW,209)(IONE(I),I=1,NSYM)
209   FORMAT(6X,'ONEOCC  ',8I5)
      LN=0
      LV=0
      NIORB=0
      DO 803 I=1,NSYM
      NIORB=NIORB+NISH(I)
      LN=LN+NSH(I)+NISH(I)
      LV=LV+NVAL(I)
803   CONTINUE
      NONE=0
      IN=LV+NIORB
      DO 904 I=1,NSYM
      NN=IONE(I)
      IF(NN.EQ.0)GO TO 905
      DO 906 NO=1,NN
      NONE=NONE+1
      IN=IN+1
      JONE(NONE)=IN
906   CONTINUE
905   IN=IN+NSH(I)-NN
904   CONTINUE
      LN=LN+LV
      IF(ICIALL.EQ.1)LN1=LN-LV-NIORB
      If (LN.NE.LN1+LV+NIORB) Then
         Write (6,*) 'Input: LN.NE.LN1+LV+NIORB'
         Write (6,*) 'LN,LN1,LV,NIORB=',LN,LN1,LV,NIORB
         Call Quit(_RC_INPUT_ERROR_)
      End If
      LNP=LN*(LN+1)/2
      IN=0
      IN3=0
      IN1=LV
      IN2=NIORB+LV
      DO 801 I=1,NSYM
      NISHI=NISH(I)
      NSHI=NSH(I)
      NVALI=NVAL(I)
      NCORI=NCOR(I)
      IF(NVALI.EQ.0)GO TO 806
      DO 807 J=1,NVALI
      IN3=IN3+1
      IN=IN+1
      NSM(IN3)=I
      ICH(IN)=IN3
807   CONTINUE
806   IF(NISHI.EQ.0)GO TO 804
      DO 805 J=1,NISHI
      IN1=IN1+1
      IN=IN+1
      NSM(IN1)=I
      ICH(IN)=IN1
      IF(J.GT.NCORI)GO TO 805
      ICOR(IN1)=1
805   CONTINUE
804   IF(NSHI.EQ.0)GO TO 801
      DO 802 J=1,NSHI
      IN2=IN2+1
      IN=IN+1
      NSM(IN2)=I
      ICH(IN)=IN2
802   CONTINUE
801   CONTINUE
      If (LN.GT.IOM) Then
         Write (6,*) 'Input: LN.GT.IOM'
         Write (6,*) 'LN,IOM=',LN,IOM
         Call Quit(_RC_INPUT_ERROR_)
      End If
      CALL TAB2F(IVER-1,LV)
      CALL TAB2(NREF,IOCR,nIOCR,L0,L1,L2,L3,INTNUM,LV,LSYM,ICIALL,
     &          IFCORE,ICOR,NONE,JONE)
      LN2=LN1
      IF(LN1.GT.8)LN2=16
      IF(LN1.NE.0)GO TO 50
      WRITE(IW,55)
55    FORMAT(//,6X,'ONE CLOSED SHELL REFERENCE STATE')
      GO TO 75

50    WRITE(IW,107)(I,I=1,LN2)
107   FORMAT(//,6X,'OCCUPATION OF REFERENCE STATES',
     &//,6X,'REF.STATE',2X,'ORB:',I2,15I4)
      NO=N-2*NIORB
      MAX=0
      DO 111 IREF=1,NREF
       MIN=MAX+1
       MAX=MAX+LN1
       WRITE(IW,112)IREF,(IOCR(J),J=MIN,MAX)
112    FORMAT(6X,I5,8X,16I4)

* Sum up the occupation numbers of the first reference:
       ISUM=0
       DO 113 I=1,LN1
         ISUM=ISUM+IOCR(MIN+I-1)
113    CONTINUE
       If (ISUM.NE.NO) Then
          Write (6,*) ' Summed occupation nums of this reference does'
          Write (6,*) ' not match nr of electrons.'
          Write (6,*) ' In closed shells: 2*NIORB=',2*NIORB
          Write (6,*) ' Summed occupation nums   =',NO
          Write (6,*) ' Sum total is             =',2*NIORB+NO
          Write (6,*) ' But input says nr of elec=',N
          Call Quit(_RC_INPUT_ERROR_)
       End If
111   CONTINUE

75    CONTINUE
* Here with ILIM=2 (FIRST command) or 4 (normal, default).
      CALL CONFIG(NREF,IOCR,nIOCR,L0,L1,L2,L3,JSYM,JSY,INTNUM,LSYM,
     &            JJS,ISO,LV,IFCORE,ICOR,NONE,JONE,JREFX,NFREF)
      IR=JRC(ILIM)
      ISPAC=IR*LNP
      IF(IPRINT.GE.2) WRITE(IW,9)ISPAC,ISPA
9     FORMAT(//,6X,'ELEMENTS TO BE SORTED',I7,/6X,'SORTING AREA',I16)
      NRLN1=NREF*LN1
      IF(LN1.EQ.0)NRLN1=1
CPAM97      IR1=(LN*IR+29)/30
      IR1=(LN*IR+14)/15
      IR2=(IR+9)/10
*
      iOpt=1
      nMUL=64
      nJJS=18
      nJRC=4
      Call WR_GUGA(Lu_10,iOpt,IADD10,
     &             NFREF,S,N,LN,NSYM,IR1,IR2,IFIRST,INTNUM,
     &             LSYM,NREF,LN1,NRLN1,MUL,nMUL,NSH,NISH,8,
     &             JRC,nJRC,JJS,nJJS,NVAL,IOCR,nIOCR)
      CALL iDAFILE(Lu_10,1,ICASE,IR1,IADD10)
      CALL iDAFILE(Lu_10,1,JSY,IR2,IADD10)
      IAD10(2)=IADD10
      CALL iDAFILE(Lu_10,1,JREFX,JRC(1),IADD10)
*
      RETURN
991   Write (6,*) 'Input: End of input file encountered'
      Write (6,'(A,A)') 'Last Command: ',Command
      Call Quit(_RC_INPUT_ERROR_)
992   Write (6,*) 'Input: Error while reading input!'
      Write (6,'(A,A)') 'Last Command: ',Command
      Call Quit(_RC_INPUT_ERROR_)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1997, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine TS_SYM_PNT2(IGRP,NIGRP,MXVAL,MNVAL,ISYM,IPNT,LPNT)
! Construct pointers to start of symmetry distributions
! for supergroup of strings with given symmetry
!
! The start of symmetry block ISYM1 ISYM2 ISYM3 .... ISYMN
! is given as
!     1
!     +  (ISM1-MNVAL(1))
!     +  (ISM2-MNVAL(2))*(MXVAL(1)-MNVAL(1)+1)
!     +  (ISM3-MNVAL(3))*(MXVAL(1)-MNVAL(1)+1)*(MXVAL(2)-MNVAL(2)+1)
!     +  ...
!     +  (ISM L-1-MNVAL(L-1))*Prod(i=1,L-2)(MXVAL(i)-MNVAL(i)+1)
!
! Where L is the last group of strings with nonvanishing occupation
!
! Jeppe Olsen, September 1997
!
! Version 2 : Uses IGRP and NIGRP to define supergroup

use Symmetry_Info, only: Mul
use lucia_data, only: MINMAX_SM_GP, MXPNGAS, MXPNSMST, NELFGP, NIRREP, NSTFSMGP
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NIGRP, IGRP(NIGRP), ISYM, LPNT
integer(kind=iwp), intent(out) :: MNVAL(NIGRP), MXVAL(NIGRP), IPNT(LPNT)
integer(kind=iwp) :: IFIRST, IGAS, IOFF, ISMFGS(MXPNGAS), ISTSMM1, ISYMSTR, MULT, NBLKS, NGASL, NNSTSGP(MXPNSMST,MXPNGAS), NONEW, &
                     NSTRII, NSTRINT

! Info on groups of strings in supergroup
NGASL = 1
do IGAS=1,NIGRP
  !ITPFGS(IGAS) = IGRP(IGAS)
  if (NELFGP(IGRP(IGAS)) > 0) NGASL = IGAS
  ! Number of strings per symmetry in each gasspace
  !NNSTSGP(1:NIRREP,IGAS) = NSTSGP(1)%I((ITPFGS(IGAS)-1)*NIRREP+1:ITPFGS(IGAS)*NIRREP)
  NNSTSGP(1:NIRREP,IGAS) = NSTFSMGP(1:NIRREP,IGRP(IGAS))
end do

!NGASL = NIGRP

!do IGAS=1,NIGRP
!  do ISMST=1,NIRREP
!    if (NNSTSGP(ISMST,IGAS) > 0) MXVAL(IGAS) = ISMST
!  end do
!  do ISMST=NIRREP,1,-1
!    if (NNSTSGP(ISMST,IGAS) > 0) MNVAL(IGAS) = ISMST
!  end do
!end do
do IGAS=1,NIGRP
  MNVAL(IGAS) = MINMAX_SM_GP(1,IGRP(IGAS))
  MXVAL(IGAS) = MINMAX_SM_GP(2,IGRP(IGAS))
end do

#ifdef _DEBUGPRINT_
write(u6,*) 'NIGRP:',NIGRP
write(u6,*) ' MNVAL and MXVAL'
call IWRTMA(MNVAL,1,NIGRP,1,NIGRP)
call IWRTMA(MXVAL,1,NIGRP,1,NIGRP)
#endif

! Total number of symmetry blocks that will be generated
NBLKS = product(MXVAL(1:NGASL-1)-MNVAL(1:NGASL-1)+1)
if (NBLKS > LPNT) then
  write(u6,*) ' Problem in TS_SYM_PNT'
  write(u6,*) ' Dimension of IPNT too small'
  write(u6,*) ' Actual and required length',NBLKS,LPNT
  write(u6,*)
  write(u6,*) ' I will Stop and wait for instructions'
  !stop ' TS_SYM_PNT too small'
  call SYSABENDMSG('lucia_util/ts_sym_pnt','Internal error','')
end if
! Loop over symmetry blocks in standard order
IFIRST = 1
NSTRINT = 0
do
  if (IFIRST == 1) then
    ISMFGS(1:NGASL-1) = MNVAL(1:NGASL-1)
  else
    ! Next distribution of symmetries in NGAS -1
    call NXTNUM3(ISMFGS,NGASL-1,MNVAL,MXVAL,NONEW)
    if (NONEW /= 0) exit
  end if
  IFIRST = 0
  ! Symmetry of NGASL -1 spaces given, symmetry of full space
  !ISTSMM1 = 1
  !do IGAS=1,NGASL-1
  !  ISTSMM1 = Mul(ISTSMM1,ISMFGS(IGAS))
  !end do
  ISTSMM1 = ISYMSTR(ISMFGS,NGASL-1)
  ! sym of SPACE NGASL
  ISMFGS(NGASL) = Mul(ISTSMM1,ISYM)
# ifdef _DEBUGPRINT_
  write(u6,*) ' next symmetry of NGASL spaces'
  call IWRTMA(ISMFGS,1,NGASL,1,NGASL)
# endif
  ! Number of strings with this symmetry combination
  NSTRII = 1
  do IGAS=1,NGASL
    NSTRII = NSTRII*NNSTSGP(ISMFGS(IGAS),IGAS)
  end do
  ! Offset for this symmetry distribution in IOFFI
  IOFF = 1
  MULT = 1
  do IGAS=1,NGASL-1
    IOFF = IOFF+(ISMFGS(IGAS)-MNVAL(IGAS))*MULT
    MULT = MULT*(MXVAL(IGAS)-MNVAL(IGAS)+1)
  end do

  IPNT(IOFF) = NSTRINT+1
  NSTRINT = NSTRINT+NSTRII
# ifdef _DEBUGPRINT_
  write(u6,*) ' IOFF, IPNT(IOFF) NSTRII ',IOFF,IPNT(IOFF),NSTRII
# endif

  if (NGASL <= 1) exit
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' Output from TS_SYM_PNT'
write(u6,*) ' Required total symmetry',ISYM
write(u6,*) ' Number of symmetry blocks ',NBLKS
write(u6,*)
write(u6,*) ' Offset array  for symmetry blocks'
call IWRTMA(IPNT,1,NBLKS,1,NBLKS)
#endif

end subroutine TS_SYM_PNT2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine stermha4(w,ww,ind1,jbr)

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case default ! (1)
    ! case a&l
    ! case a&r
    w = fq
  case (2)
    w = One
  case (3)
    w = sqrt(b/(b+One))
  case (4)
    w = -fq*sqrt((b+Two)/(b+One))
    !if (abs(w) > 1.0e-13_wp) then
end select
ww = w

return

end subroutine stermha4

subroutine stermhd1(w,ww,ind1,jbr)

use gugaci_global, only: v_onevsqtwo, v_sqtwo
use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case default !(1)
    ! d1: case d&r&l
    w = -fq*v_onevsqtwo
    ww = -fq*sqrt((b-One)/(b+b+Two))
  case (2)
    ww = -sqrt(b/(b+One))
    !if (dldr == 2101) ww=(b+Two)/(b+One)
  case (3)
    w = -fq*v_onevsqtwo
    ww = fq*sqrt((b+Three)/(b+b+Two))
  case (4)
    w = fq*v_sqtwo
end select

return

end subroutine stermhd1

subroutine stermhd5(w,ww)

use gugaci_global, only: v_sqtwo
use Constants, only: Zero
use Definitions, only: wp

implicit none
real(kind=wp), intent(out) :: w, ww

w = -v_sqtwo
ww = Zero

return

end subroutine stermhd5

subroutine stermla1(w,ww,ind1,jbr)
! case a^l

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case default ! (1)
    w = -sqrt((b+1)/(b+2))
  case (2)
    w = -One
  case (3)
    w = fq*sqrt((b+1)/b)
  case (4)
    w = fq
end select
ww = w

return

end subroutine stermla1

subroutine stermla2(w,ww,ind1,jbr)
! case a^r

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case default ! (1)
    w = -fq
  case (2)
    w = -fq*sqrt((b+One)/(b+Two))
  case (3)
    w = One
  case (4)
    w = sqrt((b+One)/b)
end select
ww = w

return

end subroutine stermla2

subroutine stermld2(w,ww,ind1,jbr)
! d2: case d^r^l

use gugaci_global, only: v_onevsqtwo, v_sqtwo
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case (1)
    ww = -sqrt((b+One)/(b+Two))
  case default ! (2)
    w = -fq*v_onevsqtwo
    ww = fq*sqrt((b+Two)/(b*Two))
  case (3)
    w = -fq*v_onevsqtwo
    ww = -fq*sqrt(b/(b+b+Four))
  case (4)
    w = -fq*v_sqtwo
  case (5)
    ww = sqrt((b+One)/b)
end select

return

end subroutine stermld2

subroutine stermld6(w,ww)
! d6: case d^r^r

use gugaci_global, only: v_sqtwo
use Constants, only: Zero
use Definitions, only: wp

implicit none
real(kind=wp), intent(out) :: w, ww

w = -v_sqtwo
ww = Zero

return

end subroutine stermld6

subroutine segmidc1(w,ww,ind1,jbr)
! case c1

use Constants, only: Zero, One, Three, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case default ! (1)
    w = One
  case (2)
    w = One
  case (3)
    w = fq/sqrt((b*b+Four*b+Four))
  case (4)
    w = -sqrt((b+One)*(b+Three)/(b*b+Four*b+Four))
  case (5)
    w = -One
  case (6)
    w = One
  case (7)
    w = sqrt((b+One)*(b-One)/(b*b))
  case (8)
    w = fq/b
  case (9)
    w = -One
  case (10)
    w = -One
end select
ww = w

return

end subroutine segmidc1

subroutine segmidc2(w,ww,ind1,jbr)
! case c2

use Constants, only: Zero, One, Two, Three, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case (1)
    ww = One
  case (2)
    ww = -One
  case (3)
    ww = -fq*sqrt(Two/((b+Two)*(b+Three)))
  case (4)
    ww = -sqrt((b+One)*(b+Four)/((b+Two)*(b+Three)))
  case (5)
    ww = One
  case default ! (6)
    w = One
    ww = One
  case (7)
    w = -One
    ww = -sqrt((b-One)*(b+Two)/(b*b+b))
  case (8)
    ww = -fq*sqrt(Two/(b*b+Three*b+Two))
  case (9)
    ww = fq*sqrt(Two/(b*(b+One)))
  case (10)
    w = -One
    ww = -sqrt(b*(b+Three)/(b*b+Three*b+Two))
  case (11)
    w = One
    ww = One
  case (12)
    ww = One
  case (13)
    ww = -sqrt((b-Two)*(b+One)/(b*b-b))
  case (14)
    ww = fq*sqrt(Two/(b*b-b))
  case (15)
    ww = -One
  case (16)
    ww = One
end select

return

end subroutine segmidc2

!subroutine segmidc22(w,ww,ind1,jbr)
!! case c22
!
!use Constants, only: Zero, One, Two, Three, Four
!use Definitions, only: wp, iwp
!
!implicit none
!real(kind=wp), intent(out) :: w, ww
!integer(kind=iwp), intent(in) :: ind1, jbr
!real(kind=wp) :: b, fq
!
!w = Zero
!ww = Zero
!! calculate w,ww
!b = real(jbr,kind=wp)
!if (mod(jbr,2) == 0) fq = One
!if (mod(jbr,2) /= 0) fq = -One
!select case (ind1)
!  case (1)
!    ww = One
!  case (2)
!    ww = -One
!  case (3)
!    ww = -fq*sqrt(Two/((b+Two)*(b+Three)))
!  case (4)
!    ww = -sqrt((b+One)*(b+Four)/((b+Two)*(b+Three)))
!  case (5)
!    ww = One
!  case default ! (6)
!    w = One
!    ww = One
!  case (7)
!    w = -One
!    ww = -sqrt((b-One)*(b+Two)/(b*b+b))
!  case (8)
!    ww = -fq*sqrt(Two/(b*b+Three*b+Two))
!  case (9)
!    w = -One
!    ww = -sqrt(b*(b+Three)/(b*b+Three*b+Two))
!  case (10)
!    w = One
!    ww = One
!  case (11)
!    ww = One
!  case (12)
!    ww = -sqrt((b-Two)*(b+One)/(b*b-b))
!  case (13)
!    ww = -One
!  case (14)
!    ww = One
!end select
!
!return
!
!end subroutine segmidc22

subroutine segmidb3(w,ww,ind1,jbr)
! submid b3(b&l)

use gugaci_global, only: v_onevsqtwo
use Constants, only: Zero, One, Two, Three, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case default ! (1)
    w = -v_onevsqtwo
    ww = -sqrt(b/(b+b+Four))
  case (2)
    ww = -fq*sqrt((b+Three)/(b+Two))
  case (3)
    ww = fq
  case (4)
    w = sqrt((b+One)/(b+b+Four))
    ww = sqrt((b+Three)/(b+b+Four))
  case (5)
    ww = -sqrt((b-One)/b)
  case (6)
    w = fq*v_onevsqtwo
    ww = -fq*sqrt((b+Two)/(b+b))
  case (7)
    w = -fq*sqrt((b+One)/(b+b))
    ww = fq*sqrt((b-One)/(b+b))
  case (8)
    ww = One
end select

return

end subroutine segmidb3

subroutine segmidb4(w,ww,ind1,jbr)
! segmid b4(b&r)

use gugaci_global, only: v_onevsqtwo
use Constants, only: Zero, One, Two, Three, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case (1)
    ww = -One
  case (2)
    w = fq*sqrt((b+One)/(b+b+Four))
    ww = -fq*sqrt((b+Three)/(b+b+Four))
  case (3)
    w = -fq*v_onevsqtwo
    ww = fq*sqrt(b/(b+b+Four))
  case (4)
    ww = sqrt((b+Three)/(b+Two))
  case default ! (5)
    w = -sqrt((b+One)/(b+b))
    ww = -sqrt((b-One)/(b+b))
  case (6)
    ww = -fq
  case (7)
    ww = fq*sqrt((b-One)/b)
  case (8)
    w = v_onevsqtwo
    ww = sqrt((b+Two)/(b+b))
end select

return

end subroutine segmidb4

subroutine segmidd10(w,ww,ind1,jbr)
! segmid d10(d^r&l)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: fq

w = Zero
ww = Zero
! calculate w,ww
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case (1)
    w = fq
  case default ! (2)
    w = fq
end select

return

end subroutine segmidd10

subroutine segmidb2(w,ww,ind1,jbr)
! segmid b2(b^r)

use gugaci_global, only: v_onevsqtwo
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case (1)
    ww = One
  case (2)
    ww = -sqrt((b+One)/(b+Two))
  case default ! (3)
    w = -sqrt(b/(b+b+Two))
    ww = sqrt((b+Two)/(b+b+Two))
  case (4)
    w = fq*sqrt((b+Two)/(b+b+Two))
    ww = fq*sqrt(b/(b+b+Two))
  case (5)
    w = fq*v_onevsqtwo
    ww = fq*sqrt((b+Two)/(b+b))
  case (6)
    w = v_onevsqtwo
    ww = -sqrt(b/(b+b+Four))
  case (7)
    ww = fq
  case (8)
    ww = fq*sqrt((b+One)/b)
end select

return

end subroutine segmidb2

subroutine segmidb1(w,ww,ind1,jbr)
! segmid b1(b^l)

use gugaci_global, only: v_onevsqtwo
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case (1)
    ww = -fq*sqrt((b+One)/(b+Two))
  case (2)
    ww = -fq
  case default ! (3)
    w = -v_onevsqtwo
    ww = sqrt((b+Two)/(b+b))
  case (4)
    w = -fq*v_onevsqtwo
    ww = -fq*sqrt(b/(b+b+Four))
  case (5)
    w = -fq*sqrt(b/(b+b+Two))
    ww = -fq*sqrt((b+Two)/(b+b+Two))
  case (6)
    w = sqrt((b+Two)/(b+b+Two))
    ww = -sqrt(b/(b+b+Two))
  case (7)
    ww = sqrt((b+One)/b)
  case (8)
    ww = -One
end select

return

end subroutine segmidb1

!subroutine stermh(isq,w,ww,ind1,jbr)
!
!use gugaci_global, only: v_onevsqtwo, v_sqtwo
!use Constants, only: Zero, One, Two, Three
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(out) :: isq
!real(kind=wp), intent(out) :: w, ww
!integer(kind=iwp), intent(in) :: ind1, jbr
!real(kind=wp) :: b, fq
!
!isq = 0
!w = Zero
!ww = Zero
!! calculate w,ww
!b = real(jbr,kind=wp)
!if (mod(jbr,2) == 0) fq = One
!if (mod(jbr,2) /= 0) fq = -One
!select case (ind1)
!  case default ! (1)
!    ! case a&l
!    ! case a&r
!    w = fq
!    isq = 1
!    ww = w
!  case (2)
!    w = One
!    isq = 1
!    ww = w
!  case (3)
!    ! case d&l&l
!    ! case d&r&r
!    w = -v_sqtwo
!    isq = 3
!  case (4)
!    ! case d&r&l
!    w = -fq*v_onevsqtwo
!    ww = -fq*sqrt((b-One)/(b+b+Two))
!    isq = 2
!  case (5)
!    ww = -sqrt(b/(b+One))
!    !if (dldr == 2101) ww=(b+Two)/(b+One)
!    isq = 2
!  case (6)
!    w = sqrt(b/(b+One))
!    isq = 1
!    ww = w
!  case (7)
!    w = -fq*sqrt((b+Two)/(b+One))
!    !if (abs(w) > 1.0e-13_wp) then
!    isq = 1
!    ww = w
!  case (8)
!    w = -fq*v_onevsqtwo
!    ww = fq*sqrt((b+Three)/(b+b+Two))
!    isq = 2
!  case (9)
!    w = fq*v_sqtwo
!    isq = 2
!end select
!
!return
!
!end subroutine stermh

subroutine stmh(isq,w,ww,mw,ind1,jbr)

use gugaci_global, only: v_onevsqtwo, v_sqtwo
use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: isq, mw
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

mw = 0
isq = 0
w = Zero
ww = Zero
! calculate w,w
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case default ! (1)
    w = -fq*v_onevsqtwo
    ww = -fq*sqrt((b-One)/(b+b+Two))
  case (2)
    w = -fq*v_onevsqtwo
    ww = fq*sqrt((b+Three)/(b+b+Two))
  case (3)
    w = fq*v_sqtwo
end select
if (abs(ww) > 1.0e-13_wp) mw = 2
if (abs(w) > 1.0e-13_wp) mw = mw+1
isq = 401

return

end subroutine stmh

subroutine smidc2(isq,w,ww,mw,ind1,jbr)

use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: isq, mw
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b

w = Zero
ww = Zero
isq = 0
mw = 0
! calculate w,ww
b = real(jbr,kind=wp)
select case (ind1)
  case default ! (1)
    !write(6,*) 'this is case c2'
    w = One
    ww = One
  case (2)
    w = -One
    ww = -sqrt((b-One)*(b+Two)/(b*b+b))
  case (3)
    w = -One
    ww = -sqrt(b*(b+Three)/(b*b+Three*b+Two))
  case (4)
    w = One
    ww = One
end select
isq = 302

return

end subroutine smidc2

subroutine stml(isq,w,ww,mw,ind1,jbr)

use gugaci_global, only: v_onevsqtwo, v_sqtwo
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: isq, mw
real(kind=wp), intent(out) :: w, ww
integer(kind=iwp), intent(in) :: ind1, jbr
real(kind=wp) :: b, fq

mw = 0
isq = 0
w = Zero
ww = Zero
! calculate w,ww
b = real(jbr,kind=wp)
if (mod(jbr,2) == 0) fq = One
if (mod(jbr,2) /= 0) fq = -One
select case (ind1)
  case default ! (1)
    ! case d^r^l
    w = -fq*v_onevsqtwo
    ww = fq*sqrt((b+Two)/(b*Two))
  case (2)
    w = -fq*v_onevsqtwo
    ww = -fq*sqrt(b/(b+b+Four))
  case (3)
    w = -fq*v_sqtwo
end select
if (abs(ww) > 1.0e-13_wp) mw = 2
if (abs(w) > 1.0e-13_wp) mw = mw+1
isq = 402

return

end subroutine stml

subroutine neoc(kcoe,nocc,tcoe)

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: kcoe
integer(kind=iwp), intent(out) :: nocc
real(kind=wp), intent(out) :: tcoe

nocc = 1
tcoe = kcoe
if (kcoe == 0) nocc = 0
if (kcoe == 100) tcoe = Zero
if (kcoe == 200) then
  nocc = 2
  tcoe = -Half
end if

return

end subroutine neoc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Integral_Interfaces

! Dummy modules to get correct order of compilation
use IOBuf, only:
use Real_Spherical, only:
use k2_arrays, only:
use rmat, only:
use define_af, only:
use Property_Label, only:
use Basis_Info, only:
use Center_Info, only:
use Gateway_Info, only:
use Sizes_of_Seward, only:
use Symmetry_Info, only:
use SOAO_Info, only:
use Dens_Stuff, only:
use stdalloc, only:
use Constants, only:

use iSD_data, only: nSD
use Index_Functions, only: nTri_Elem1
use k2_structure, only: k2_type
use Definitions, only: wp, iwp

implicit none
private

abstract interface
  subroutine int_kernel( &
#                       define _CALLING_
#                       include "int_interface.fh"
                       )
    import :: nTri_Elem1, wp, iwp
#   include "int_interface.fh"
  end subroutine int_kernel

  subroutine int_mem( &
#                    define _CALLING_
#                    include "mem_interface.fh"
                    )
    import :: iwp
#   include "mem_interface.fh"
  end subroutine int_mem

  subroutine int_wrout( &
#                      define _CALLING_
#                      include "int_wrout_interface.fh"
                      )
    import :: wp, iwp
#   include "int_wrout_interface.fh"
  end subroutine int_wrout

  subroutine prm_kernel( &
#                       define _CALLING_
#                       include "prm_interface.fh"
                       )
    import :: nTri_Elem1, wp, iwp
#   include "prm_interface.fh"
  end subroutine prm_kernel

  subroutine twoel_kernel( &
#                         define _CALLING_
#                         include "twoel_interface.fh"
                         )
    import :: wp, iwp, k2_type, nSD
#   include "twoel_interface.fh"
  end subroutine twoel_kernel
end interface

! Intel 13 compiler only works with "public" here
procedure(int_wrout), public, pointer :: Int_postprocess => null()

public :: DeDe_SCF, Drv2El_dscf, FckAcc, int_kernel, int_mem, int_wrout, OneEl_ij, OneEl_Integrals, prm_kernel, twoel_kernel

contains

! Subroutines that need an explicit interface (target or allocatable arguments)
#define _IN_MODULE_
#include "dede_scf.F90"
#include "drv2el_dscf.F90"
#include "fckacc.F90"
#include "oneel_ij.F90"
#include "oneel_integrals.F90"

end module Integral_Interfaces

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
SUBROUTINE CASPT2_AXB(PSI,F,NMO,ONEINT,TWOINT)
  ! Computes the CASPT2 second-order energy of the wavefunction PSI, provided
  ! that the full Fock matrix and necessary 1- and 2-el integrals are given.
  USE ISO_FORTRAN_ENV, ONLY: REAL64
  USE SECOND_QUANTIZATION
  USE WAVEFUNCTION
  USE DENSITY
  USE FOCKMATRIX
  USE ORBINT
  IMPLICIT NONE

  TYPE(WFN), INTENT(IN) :: PSI
  TYPE(FMAT), INTENT(IN) :: F
  INTEGER, INTENT(IN) :: NMO
  REAL(REAL64), INTENT(IN) :: ONEINT(NMO,NMO), TWOINT(NMO,NMO,NMO,NMO)

  INTEGER :: NI, NA, NS
  INTEGER :: NACTEL, NTOTEL, MULT

  REAL(REAL64), ALLOCATABLE :: FTOT(:,:)

  TYPE(WFN) :: PSI1, SGM, TAU
  REAL(REAL64), ALLOCATABLE :: D1(:,:), D2(:,:,:,:)
  REAL(REAL64) :: FACT

  REAL(REAL64), ALLOCATABLE :: VPQRS(:,:,:,:), V0(:), X(:)
  REAL(REAL64), ALLOCATABLE :: H0(:,:), S0(:,:), U0(:,:), T0(:,:)
  REAL(REAL64) :: E0, E2
  INTEGER :: ISD, JSD, NSD, MSD

  REAL(REAL64), ALLOCATABLE :: PSI1BRA(:,:,:), PSI1KET(:,:,:), FOCKKET(:,:,:)

  REAL(REAL64), ALLOCATABLE :: WORK(:), EVAL(:)
  INTEGER :: NWORK, INFO

  INTEGER, ALLOCATABLE :: IPIV(:)

  INTEGER :: I, J, P, Q, R, S, IA, IB
  INTEGER :: DETA, DETB, TMPA, TMPB

  REAL(REAL64), EXTERNAL :: DNRM2_, DDOT_

  ! get appropriate orbital space dimensions from the supplied Fock matrix
  NI=SIZE(F%II,1)
  NA=SIZE(F%AA,1)
  NS=SIZE(F%SS,1)

#ifdef _DEBUG_
  WRITE(*,'(1X,A,I6)') '#inactive  orbitals = ', NI
  WRITE(*,'(1X,A,I6)') '#active    orbitals = ', NA
  WRITE(*,'(1X,A,I6)') '#secondary orbitals = ', NS
  WRITE(*,'(1X,A,I6)') '#molecular orbitals = ', NMO
#endif

  ! some sanity checks
  IF (PSI%NORB.NE.NA) STOP 'CASPT2_AXB: PSI%NORB does not match #active orbitals'
  IF (NMO.NE.NI+NA+NS) STOP 'CASPT2_AXB: supplied total #orbitals does not compute'

  NACTEL=PSI%NEL
  NTOTEL=2*NI+NACTEL
  MULT=PSI%MULT

  ! put Fock matrix in general matrix format
  ALLOCATE(FTOT(NMO,NMO))
  CALL FMAT_COPY(F,FTOT,NMO)

  ! first, set up PSI1 as a (sparse) full-CI wavefunction for which we will use
  ! projectors to handle the restriction of single-double replacement states
  CALL WFN_INIT(PSI1,NTOTEL,NMO,MULT)

  PSI1%COEF=0.0D0
  CALL WFN_COPY0(NI,PSI,PSI1)

#ifdef _DEBUG_
  WRITE(*,'(1X,A)') 'The 0th-order wavefunction in FCI space:'
  CALL WFN_PRINT(PSI1,1.0D-15)
#endif

  ! compute the CASSCF energy for the 0-th order wavefunction
  ALLOCATE(D1(NMO,NMO))
  ALLOCATE(D2(NMO,NMO,NMO,NMO))
  CALL D1_ANN(PSI1,D1)
  CALL D2_ANN(PSI1,D2)
  
  CALL WFN_ENERGY(0,NMO,0,D1,D2,ONEINT,TWOINT)

  CALL WFN_INIT(SGM,NTOTEL,NMO,MULT)
  CALL WFN_INIT(TAU,NTOTEL,NMO,MULT)

  ! set up the equation system Ax=b as (H0 -E0*S0) X = -V0 with:
  ! H0_ij = <i|Ĥ_0|j>
  ! E0    = <0|Ĥ_0|0>
  ! S0_ij = <i|j>
  ! V0_i  = <i|Ĥ|0>
  ! |i>, |j> = P_SD Ê_pqrs |0>

  ! First, compute the 0-th order energy and construct the right hand side
  ! vector -V0, which is computed for each |i> that is non-zero. This still
  ! leaves an overcomplete basis for the VSD space, but that is solved later by
  ! diagonalization of S0 and removal of any linear dependency before solving
  ! Ax=b.

  ! step 1: |TAU> = Ĥ|0>; |SGM> = Ĥ_0|0>
  TAU%COEF=0.0D0
  SGM%COEF=0.0D0

  DETB=LEX_INIT(PSI%NELB,PSI%NORB)
  DO IB=1,PSI%NDETB
    TMPB=ISHFT(DETB,NI)+(2**NI-1)
    DETA=LEX_INIT(PSI%NELA,PSI%NORB)
    DO IA=1,PSI%NDETA
      TMPA=ISHFT(DETA,NI)+(2**NI-1)

      FACT=PSI%COEF(IA,IB)
      DO P=1,NMO
        DO Q=1,NMO
          ! h_pq, g_pqrs for TAU
          CALL DET_EX1(FACT*ONEINT(P,Q),P,Q,TMPA,TMPB,TAU)
          DO R=1,NMO
            DO S=1,NMO
              CALL DET_EX2(FACT*0.5D0*TWOINT(P,Q,R,S),P,Q,R,S,TMPA,TMPB,TAU)
            END DO
          END DO
          ! f_pq for SGM
          CALL DET_EX1(FACT*FTOT(P,Q),P,Q,TMPA,TMPB,SGM)
        END DO
      END DO

      DETA=LEX_NEXT(DETA)
    END DO
    DETB=LEX_NEXT(DETB)
  END DO

#ifdef _DEBUG_
  WRITE(*,'(1X,A)') 'wavefunction Ĥ|0>'
  CALL WFN_PRINT(TAU,1.0D-6)
  WRITE(*,'(1X,A)') 'wavefunction Ĥ_0|0>'
  CALL WFN_PRINT(SGM,1.0D-6)
#endif

  ! step 2: compute 0-th order energy E0 = <0|SGM>
  E0 = 0.0D0

  DETB=LEX_INIT(PSI%NELB,PSI%NORB)
  DO IB=1,PSI%NDETB
    TMPB=ISHFT(DETB,NI)+(2**NI-1)
    DETA=LEX_INIT(PSI%NELA,PSI%NORB)
    DO IA=1,PSI%NDETA
      TMPA=ISHFT(DETA,NI)+(2**NI-1)
  
      E0 = E0 + PSI%COEF(IA,IB) * SGM%COEF(RANK_(TMPA),RANK_(TMPB))

      DETA=LEX_NEXT(DETA)
    END DO
    DETB=LEX_NEXT(DETB)
  END DO

  WRITE(*,'(1X,A32,F21.14)') "0-th order energy E0 = ", E0

  ! step 3: construct V0 = <i|TAU>, store the computed functions |i> in PSI1KET
  ! and PSI1BRA
  ALLOCATE(VPQRS(NMO,NMO,NMO,NMO))

  NSD=0
  VPQRS=0.0D0
  DO S=1,NMO
    DO R=1,NMO
      DO Q=1,NMO
        DO P=1,NMO

          ! determine |i> = E_pqrs |Psi0>
          SGM%COEF=0.0D0
          DETB=LEX_INIT(PSI%NELB,PSI%NORB)
          DO IB=1,PSI%NDETB
            TMPB=ISHFT(DETB,NI)+(2**NI-1)
            DETA=LEX_INIT(PSI%NELA,PSI%NORB)
            DO IA=1,PSI%NDETA
              TMPA=ISHFT(DETA,NI)+(2**NI-1)

              CALL DET_EX2(PSI%COEF(IA,IB),P,Q,R,S,TMPA,TMPB,SGM)

              DETA=LEX_NEXT(DETA)
            END DO
            DETB=LEX_NEXT(DETB)
          END DO

          PSI1%COEF=0.0D0
          CALL WFN_PSD(NI,NA,NS,SGM,PSI1)

          IF (DNRM2_(PSI1%NDET,PSI1%COEF,1).NE.0.0D0) THEN
            VPQRS(P,Q,R,S)=DDOT_(PSI1%NDET,PSI1%COEF,1,TAU%COEF,1)
            NSD=NSD+1
          END IF

        END DO
      END DO
    END DO
  END DO

  ALLOCATE(V0(NSD))

  ISD=0
  DO S=1,NMO
    DO R=1,NMO
      DO Q=1,NMO
        DO P=1,NMO
          IF (ABS(VPQRS(P,Q,R,S)).GT.0.0D0) THEN
            ISD=ISD+1
            V0(ISD)=VPQRS(P,Q,R,S)
          END IF
        END DO
      END DO
    END DO
  END DO

  ! Now compute H0 and S0 matrices

  ALLOCATE(H0(NSD,NSD))
  ALLOCATE(S0(NSD,NSD))

  H0 = 0.0D0
  S0 = 0.0D0

  ALLOCATE(PSI1BRA(NSD,PSI1%NDETA,PSI1%NDETB))
  ALLOCATE(PSI1KET(PSI1%NDETA,PSI1%NDETB,NSD))
  ALLOCATE(FOCKKET(PSI1%NDETA,PSI1%NDETB,NSD))

  ISD=0
  DO S=1,NMO
    DO R=1,NMO
      DO Q=1,NMO
        DO P=1,NMO

          SGM%COEF=0.0D0
          ! determine |i> = E_pqrs |Psi0>
          DETB=LEX_INIT(PSI%NELB,PSI%NORB)
          DO IB=1,PSI%NDETB
            TMPB=ISHFT(DETB,NI)+(2**NI-1)
            DETA=LEX_INIT(PSI%NELA,PSI%NORB)
            DO IA=1,PSI%NDETA
              TMPA=ISHFT(DETA,NI)+(2**NI-1)

              CALL DET_EX2(PSI%COEF(IA,IB),P,Q,R,S,TMPA,TMPB,SGM)

              DETA=LEX_NEXT(DETA)
            END DO
            DETB=LEX_NEXT(DETB)
          END DO
          PSI1%COEF=0.0D0
          CALL WFN_PSD(NI,NA,NS,SGM,PSI1)

          IF (DNRM2_(PSI1%NDET,PSI1%COEF,1).NE.0.0D0) THEN
            ISD=ISD+1
            ! put |i> = E_pqrs |0> into PSI1BRA and PSI1KET
            PSI1BRA(ISD,:,:) = PSI1%COEF
            PSI1KET(:,:,ISD) = PSI1%COEF

            ! compute Ĥ_0|i> = Sum_ij f_ij Ê_ij |i>
            SGM%COEF=0.0D0
            DETB=LEX_INIT(PSI1%NELB,PSI1%NORB)
            DO IB=1,PSI1%NDETB
              DETA=LEX_INIT(PSI1%NELA,PSI1%NORB)
              DO IA=1,PSI1%NDETA

                DO J=1,NMO
                  DO I=1,NMO
                    ! accumulate F_ij Ê_ij |i>
                    CALL DET_EX1(PSI1%COEF(IA,IB)*FTOT(I,J),I,J,DETA,DETB,SGM)
                  END DO
                END DO

                DETA=LEX_NEXT(DETA)
              END DO
              DETB=LEX_NEXT(DETB)
            END DO
            ! put Ĥ_0|i> into FOCKKET
            FOCKKET(:,:,ISD) = SGM%COEF
          END IF

        END DO
      END DO
    END DO
  END DO

  CALL DGEMM_('N','N',NSD,NSD,PSI1%NDET,1.0D0, &
       & PSI1BRA,NSD,PSI1KET,PSI1%NDET, &
       & 0.0D0,S0,NSD)

  CALL DGEMM_('N','N',NSD,NSD,PSI1%NDET,1.0D0, &
       & PSI1BRA,NSD,FOCKKET,PSI1%NDET, &
       & 0.0D0,H0,NSD)

  DEALLOCATE(PSI1BRA)
  DEALLOCATE(PSI1KET)
  DEALLOCATE(FOCKKET)

  ! remove linear dependencies by diagonalizing the overlap matrix, construct a
  ! transformation matrix to orthogonal basis, and transform S0, H0 and V0
  ! accordingly

  ALLOCATE(U0(NSD,NSD))
  U0(:,:)=S0

  NWORK=NSD**2
  ALLOCATE(WORK(NWORK))
  ALLOCATE(EVAL(NSD))

  call dsyev_('V','U',NSD,U0,NSD,EVAL,WORK,NWORK,INFO)
  IF (INFO.NE.0) STOP 'CASPT2_UDL: diagonalization of S0 failed'

  ! go through columns of U0, keep non-zero eigenvalues
  MSD=0
  DO ISD=1,NSD
    IF (EVAL(ISD).GT.1.0D-6) THEN
      MSD=MSD+1
    END IF
  END DO
  WRITE(*,'(1X,A,I6)') '#non-zero overlap eigenvalues = ', MSD

  ALLOCATE(T0(NSD,MSD))
  ISD=0
  DO JSD=1,NSD
    IF (EVAL(JSD).GT.1.0D-6) THEN
      ISD=ISD+1
      T0(:,ISD) = U0(:,JSD)/SQRT(EVAL(JSD))
    END IF
  END DO

  ! transform equation system
  H0(1:MSD,1:MSD) = MATMUL(TRANSPOSE(T0),MATMUL(H0,T0))
  S0(1:MSD,1:MSD) = MATMUL(TRANSPOSE(T0),MATMUL(S0,T0))

  ! Solve (H0 - E0 S0) X = -V0

  H0(:,:) = H0 - E0 * S0

  ALLOCATE(IPIV(NSD))

  ! solution vector is initially filled with the RHS = -V0
  ALLOCATE(X(NSD))
  X(1:MSD) = -1.0D0 * MATMUL(TRANSPOSE(T0),V0)

  call dgesv_(MSD,1,H0,NSD,IPIV,X,NSD,INFO)
  IF (INFO.NE.0) THEN
    WRITE(*,*) 'INFO = ', INFO
    STOP 'Failed to solve linear equation system'
  END IF

  X(:)=MATMUL(T0,X(1:MSD))

  ! compute the energy

  ! method 1: E2 = <V0|X>
  E2 = DDOT_(NSD,V0,1,X,1)
  WRITE(*,'(1X,A32,F21.14)') 'E2 as <V0|X> = ', E2

  ! method 2: E2 = <0|Ĥ|Psi1>
  ! first, form the first-order wavefunction |Psi1>
  ISD=0
  SGM%COEF=0.0D0
  DO S=1,NMO
    DO R=1,NMO
      DO Q=1,NMO
        DO P=1,NMO

          IF (VPQRS(P,Q,R,S).NE.0.0D0) THEN
            ISD=ISD+1

            DETB=LEX_INIT(PSI%NELB,PSI%NORB)
            DO IB=1,PSI%NDETB
              TMPB=ISHFT(DETB,NI)+(2**NI-1)
              DETA=LEX_INIT(PSI%NELA,PSI%NORB)
              DO IA=1,PSI%NDETA
                TMPA=ISHFT(DETA,NI)+(2**NI-1)

                CALL DET_EX2(PSI%COEF(IA,IB)*X(ISD),P,Q,R,S,TMPA,TMPB,SGM)

                DETA=LEX_NEXT(DETA)
              END DO
              DETB=LEX_NEXT(DETB)
            END DO
            
          END IF

        END DO
      END DO
    END DO
  END DO
  PSI1%COEF=0.0D0
  CALL WFN_PSD(NI,NA,NS,SGM,PSI1)

  !WRITE(*,*) 'Final first-order wavefunction from Ax=b method:'
  !CALL WFN_PRINT(PSI1,1.0D-8)

  ! TAU still contains Ĥ|0>, so contract with |Psi1>
  E2 = DDOT_(PSI1%NDET,PSI1%COEF,1,TAU%COEF,1)
  WRITE(*,'(1X,A32,F21.14)') 'E2 as <Psi1|H|0> = ', E2

END SUBROUTINE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine multc0 (wrk,wrksize,
     & mvec,ix,mapdc,key)
c
c     This routine realize multiplying according mvec
c     for C=A*B
c     N.B. if key=0, C file is not vanished (ie can be used for
c     adding to some existing file)
c
c     If C=A*B process is faster or comparambe with C=AT*B then mchntyp should be set to 1.
c     If C=AT*B is significantly faster than C=A*T (more than 20%), than mchntyp should be set
c     to 2. (default is 1)
c     if mchntyp is 2, than
c     1) proceses with scale(A)/scale(B) > scalelim will be calculated as C=A*B
c     2) processes with scale(A)/scale(B) < scalelim will be calculated as C=AT*B
c     Note, that for mchntyp =2 more memory is required, due to requirement of
c     aditional o2v2 help file possd0        (parameter possd0 is transported through ccsd1.fh, not
c     through ccsd2.fh)
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer mvec(1:4096,1:7)
       integer ix,key
       integer mapdc(0:512,1:6)

c     help variables
c
       integer nhelp1,nhelp2,nhelp3,nhelp4,nhelp5,nhelp6
       integer iix,ic
       real*8 scale
c
c1    set C=0
c
       if (key.eq.1) then
c
c     C matrix must be vanished
c
       do 100 ic=1,mapdc(0,5)
       nhelp1=mapdc(ic,1)
       nhelp2=mapdc(ic,2)
       call mv0zero (nhelp2,nhelp2,wrk(nhelp1))
 100    continue
c
       end if
c
c2    C=C+A*B
c
       if (ix.eq.0) then
       return
       end if
c
       do 200 iix=1,ix
c
c     skip this sumation if yes/no=0
       if (mvec(iix,1).eq.0) goto 200
c
c     realize individial sumation
c
c     def possitions of A,B,C
       nhelp1=mvec(iix,2)
       nhelp2=mvec(iix,3)
       nhelp3=mvec(iix,4)
c
c     def rowA(rowC), colA(rowB,sum), colB(colC)
       nhelp4=mvec(iix,5)
       nhelp5=mvec(iix,6)
       nhelp6=mvec(iix,7)
c
       if (mchntyp.eq.1) then
c
c*    Typ 1
       call mc0c1a3b (nhelp4,nhelp5,nhelp5,nhelp6,nhelp4,nhelp6,
     & nhelp4,nhelp5,nhelp6,wrk(nhelp1),wrk(nhelp2),wrk(nhelp3))
c
       else
c
c*    Typ2
       scale=(1.0d0*nhelp4)/(1.0d0*nhelp6)
       if (scale.gt.slim) then
       call mc0c1a3b (nhelp4,nhelp5,nhelp5,nhelp6,nhelp4,nhelp6,
     & nhelp4,nhelp5,nhelp6,wrk(nhelp1),wrk(nhelp2),wrk(nhelp3))

       else
c     map D=AT
       call map21 (wrk(nhelp1),wrk(possd0),nhelp4,nhelp5,2,1,1)
c     calc C=DT*B
       call mc0c1at3b (nhelp5,nhelp4,nhelp5,nhelp6,nhelp4,nhelp6,
     & nhelp4,nhelp5,nhelp6,wrk(possd0),wrk(nhelp2),wrk(nhelp3))
       end if
c
       end if
c
 200    continue
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_add41(a,b,p,dimp,dimpq,dimr,fact)
! this routine does:
! B(pq,r) <-- fact * A(q,r) for given p

use CCT3_global, only: nshf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: p, dimp, dimpq, dimr
real(kind=wp), intent(in) :: a(dimp,dimr), fact
real(kind=wp), intent(inout) :: b(dimpq,dimr)
integer(kind=iwp) :: pq, q, qp

if (p /= 1) then
  pq = nshf(p)
  b(pq+1:pq+p-1,:) = b(pq+1:pq+p-1,:)+fact*a(1:p-1,:)
end if

do q=p+1,dimp
  qp = nshf(q)+p
  b(qp,:) = b(qp,:)-fact*a(q,:)
end do

return

end subroutine cct3_add41

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Init_Data
************************************************************************
*                                                                      *
*     Initialize variables in common blocks                            *
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8  (a-h,o-z)
#include "Files_mclr.fh"
#include "Input.fh"
*----------------------------------------------------------------------*
*     Define files ( file names and unit numbers )                     *
*----------------------------------------------------------------------*
      FnJob=    'JOBIPH  '
      LuJob   = 10
      FnOne=    'ONEINT  '
      LuOne   = 11
      FnMol=    'MOLINT  '
      LuMol   = 13
      FnMck=    'MCKINT  '
      LuMck   = 15
      FnRlx=    'RELAX   '
      LuRlx   = 16
      FnPT2=    '.RLXPT2 '
      LuPT2   = 17
      FnTemp=   'RESP    '
      LuTemp  = 19
      FnCSF2SD= 'REORD   '
      LuCSF2SD= 20
*
      FnTwo= 'ORDINT  '
      LuTwo = 40
      FnHLF2='TEMP06  '
      LuHLF2= 50
      FnHLF3='TEMP07  '
      LuHLF3= 60
*
      FNTRI1='TEMP01  '
      LUTRI1= 24
      FNTRI2='TEMP02  '
      LUTRI2= 25
      FNTRI3='TEMP03  '
      LUTRI3= 26
      FNTRI4='TEMP04  '
      LUTRI4= 27
      FNTRI5='TEMP05  '
      LUTRI5= 28
*     files used only within the TwoStep Run of MCLR
      FnQDAT='QDAT    ' ! some temporary data is stored here
      LuQDAT= 29
      ! this file is exactly the same as TEMP01, but is not deleted
      FnMOTRA='MOTRA   '
      LuMOTRA=30
*
      BLine=' '
      State_Sym=1
      nUserPT=0
      UserP=1.0d0
      Do i=1,64
        UserT(i)=0.0d0
      EndDo
      nsRot=0
*
*----------------------------------------------------------------------*
*     Normal termination                                               *
*----------------------------------------------------------------------*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _MOLCAS_MPP_

module allgather_wrapper

use MPI_Wrapper, only: MPI_AllGatherV, MPI_COMM_WORLD, MPI_INTEGER
use GA_Wrapper, only: GA_NNodes
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6, MPIInt

implicit none
private

interface allgather
  module procedure :: allgather_R, allgather_R2, allgather_I, allgather_I2
end interface

public :: allgather

contains

subroutine ALLGATHER_R(SEND,NSEND,RECV,NRECV)
  !*********************************************************************
  ! allgather: gathers local buffers SEND of size NSEND on
  !            each process into a buffer RECV of size NRECV.
  !            The receiving buffer is allocated by this subroutine.
  !*********************************************************************

  use MPI_Wrapper, only: MPI_REAL8

  integer(kind=iwp), intent(in) :: nSend, nRecv
  real(kind=wp), intent(in) :: SEND(nSend)
  real(kind=wp), intent(out) :: RECV(nRecv)
  integer(kind=iwp) :: i, nBytes, nProcs
  integer(kind=MPIInt) :: IERROR4, ITYPE4, nRecv4Tot, NSEND4(1)
  integer(kind=MPIInt), allocatable :: IDISP4(:), NRECV4(:)

  ITYPE4 = MPI_REAL8
  NBYTES = 8*NRECV

  if (NBYTES > 2147483647) then
    write(u6,'(1X,A)') 'WARNING: ALLGATHER: receive buffer > 2GB'
    write(u6,'(1X,A)') 'some MPI implementations cannot handle this'
    write(u6,'(1X,A)') 'I will continue, but it might crash...'
  end if

  NPROCS = GA_NNODES()

  call MMA_ALLOCATE(NRECV4,[0,NPROCS-1],Label='NRECV4')
  call MMA_ALLOCATE(IDISP4,[0,NPROCS-1],Label='IDISP4')

  ! first, gather the sendbuffer size of each process in NRECV4
  NSEND4(1) = int(NSEND,kind=MPIInt)
  call MPI_ALLGATHER(NSEND4,1_MPIInt,MPI_INTEGER,NRECV4,1_MPIInt,MPI_INTEGER,MPI_COMM_WORLD,IERROR4)
  if (IERROR4 /= 0) then
    write(u6,'(1X,A,I4)') 'ERROR: ALLGATHER: MPI_Allgather ',IERROR4
    call ABEND()
  end if

  ! check sum of send buffers against size of the receive buffer
  NRECV4TOT = sum(NRECV4(0:NPROCS-1))
  if (NRECV4TOT /= NRECV) then
    write(u6,'(1X,A)') 'ERROR: ALLGATHER: buffer sizes do not match'
    call ABEND()
  end if

  ! compute the displacements from the different sizes in IDISP
  IDISP4(0) = 0
  do I=1,NPROCS-1
    IDISP4(I) = IDISP4(I-1)+NRECV4(I-1)
  end do

  ! gather the local send buffers into the receive buffer
  call MPI_ALLGATHERV(SEND,NSEND4(1),ITYPE4,RECV,NRECV4,IDISP4,ITYPE4,MPI_COMM_WORLD,IERROR4)
  if (IERROR4 /= 0) then
    write(u6,'(1X,A,I4)') 'ERROR: ALLGATHER: MPI_Allgatherv ',IERROR4
    call ABEND()
  end if
  call MMA_DEALLOCATE(NRECV4)
  call MMA_DEALLOCATE(IDISP4)

end subroutine allgather_R

subroutine ALLGATHER_R2(SEND,NSEND,RECV,NRECV)
  ! wrapper for 2-dimensional arrays

  integer(kind=iwp), intent(in) :: nSend, nRecv
  real(kind=wp), intent(in) :: SEND(:,:)
  real(kind=wp), intent(out) :: RECV(:,:)

  call ALLGATHER_R(SEND,NSEND,RECV,NRECV)

end subroutine ALLGATHER_R2

subroutine ALLGATHER_I(SEND,NSEND,RECV,NRECV)
  !*********************************************************************
  ! allgather: gathers local buffers SEND of size NSEND on
  !            each process into a buffer RECV of size NRECV.
  !            The receiving buffer is allocated by this subroutine.
  !*********************************************************************

# ifdef _I8_
  use MPI_Wrapper, only: MPI_INTEGER8
# else
  use MPI_Wrapper, only: MPI_INTEGER4
# endif

  integer(kind=iwp), intent(in) :: nSend, SEND(nSend), nRecv
  integer(kind=iwp), intent(out) :: RECV(nRecv)
  integer(kind=iwp) :: i, nBytes, nProcs
  integer(kind=MPIInt) :: IERROR4, ITYPE4, nRecv4Tot, NSEND4(1)
  integer(kind=MPIInt), allocatable :: IDISP4(:), NRECV4(:)

# ifdef _I8_
  ITYPE4 = MPI_INTEGER8
  NBYTES = 8*NRECV
# else
  ITYPE4 = MPI_INTEGER4
  NBYTES = 4*NRECV
# endif

  if (NBYTES > 2147483647) then
    write(u6,'(1X,A)') 'WARNING: ALLGATHER: receive buffer > 2GB'
    write(u6,'(1X,A)') 'some MPI implementations cannot handle this'
    write(u6,'(1X,A)') 'I will continue, but it might crash...'
  end if

  NPROCS = GA_NNODES()

  call MMA_ALLOCATE(NRECV4,[0,NPROCS-1],Label='NRECV4')
  call MMA_ALLOCATE(IDISP4,[0,NPROCS-1],Label='IDISP4')

  ! first, gather the sendbuffer size of each process in NRECV4
  NSEND4(1) = int(NSEND,kind=MPIInt)
  call MPI_ALLGATHER(NSEND4,1_MPIInt,MPI_INTEGER,NRECV4,1_MPIInt,MPI_INTEGER,MPI_COMM_WORLD,IERROR4)
  if (IERROR4 /= 0) then
    write(u6,'(1X,A,I4)') 'ERROR: ALLGATHER: MPI_Allgather ',IERROR4
    call ABEND()
  end if

  ! check sum of send buffers against size of the receive buffer
  NRECV4TOT = sum(NRECV4(0:NPROCS-1))
  if (NRECV4TOT /= NRECV) then
    write(u6,'(1X,A)') 'ERROR: ALLGATHER: buffer sizes do not match'
    call ABEND()
  end if

  ! compute the displacements from the different sizes in IDISP
  IDISP4(0) = 0
  do I=1,NPROCS-1
    IDISP4(I) = IDISP4(I-1)+NRECV4(I-1)
  end do

  ! gather the local send buffers into the receive buffer
  call MPI_ALLGATHERV(SEND,NSEND4(1),ITYPE4,RECV,NRECV4,IDISP4,ITYPE4,MPI_COMM_WORLD,IERROR4)
  if (IERROR4 /= 0) then
    write(u6,'(1X,A,I4)') 'ERROR: ALLGATHER: MPI_Allgatherv ',IERROR4
    call ABEND()
  end if
  call MMA_DEALLOCATE(NRECV4)
  call MMA_DEALLOCATE(IDISP4)

end subroutine allgather_I

subroutine ALLGATHER_I2(SEND,NSEND,RECV,NRECV)
  ! wrapper for 2-dimensional arrays

  integer(kind=iwp), intent(in) :: nSend, SEND(:,:), nRecv
  integer(kind=iwp), intent(out) :: RECV(:,:)

  call ALLGATHER_I(SEND,NSEND,RECV,NRECV)

end subroutine ALLGATHER_I2

end module allgather_wrapper

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(allgather_wrapper)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_TraDrv(irc,CMO,Diag,DoDiag)
!
! Jonas Bostrom, Jan. 2010. (modified from ChoMP2_TraDrv)
!
! Purpose: AO-to-MO (pq) transformation of Cholesky vectors
!          performed directly in reduced sets. This assumes
!          that the MP2 program has been appropriately initialized.

use Cholesky, only: nSym
use ChoMP2, only: nAdrOff, nMoAo, nMoType
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(_OUT_) :: Diag(*)
logical(kind=iwp), intent(in) :: DoDiag
integer(kind=iwp) :: i, iMoType, iSym, jMOType, l_COrb, nProdType
logical(kind=iwp) :: DoDiag_
real(kind=wp), allocatable :: COrb1(:), COrb2(:)

#include "macros.fh"
unused_var(DoDiag)

irc = 0

! Reorder MO coefficients.
! ------------------------

DoDiag_ = .false.
nProdType = nMOType**2
l_COrb = 0
nAdrOff(1:nSym) = 0

do iSym=1,nSym
  do i=1,nProdType
    l_COrb = max(l_COrb,nMoAo(iSym,i))
  end do
end do
call mma_allocate(COrb1,l_COrb,Label='COrb1')
call mma_allocate(COrb2,l_COrb,Label='COrb2')

DoDiag_ = .true.
call ChoMP2g_MOReOrd(CMO,COrb1,COrb2,2,3)
call ChoMP2g_Tra(COrb1,COrb2,Diag,DoDiag_,2,3)
DoDiag_ = .false.
do iMoType=1,3
  do jMOType=1,3
    if ((iMoType == 2) .and. (jMoType == 3)) cycle

    call ChoMP2g_MOReOrd(CMO,COrb1,COrb2,iMOType,jMOType)
    ! Transform vectors.
    ! ------------------
    call ChoMP2g_Tra(COrb1,COrb2,Diag,DoDiag_,iMoType,jMoType)

  end do
end do

! Deallocate reordered MO coefficients.
! -------------------------------------

call mma_deallocate(COrb2)
call mma_deallocate(COrb1)

end subroutine ChoMP2g_TraDrv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Roland Lindh                                     *
!***********************************************************************

subroutine EMFInt( &
#                 define _CALLING_
#                 include "int_interface.fh"
                 )
!***********************************************************************
!                                                                      *
! Object: to compute the electromagnetic field radiation integrals     *
!         using a complex Gauss-Hermite quadrature.                    *
!                                                                      *
! Called from: OneEl                                                   *
!                                                                      *
! Calling    : RecPrt                                                  *
!              CCrtCmp                                                 *
!              CAssmbl                                                 *
!              CVelInt                                                 *
!              CCmbnVe                                                 *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chemistry - Angstrom,             *
!             University of Uppsala, Sweden. December 2015             *
!***********************************************************************

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Her_RW, only: HerR, HerW, iHerR, iHerW
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: iComp, iDCRT(0:7), ipA, ipAOff, ipAxyz, ipB, ipBOff, ipBxyz, ipQxyz, ipRes, iPrint, ipVxyz, iRout, &
                     iStabO(0:7), lDCRT, llOper, LmbdT, nDCRT, nip, nOp, nStabO
integer(kind=iwp), external :: NrOpr

#include "macros.fh"
unused_var(ZInv)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 195
iPrint = nPrint(iRout)

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+1+nOrdOp)*2
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+1+nOrdOp)*2
ipQxyz = nip
nip = nip+nZeta*3*(la+1+nOrdOp)*(lb+1+nOrdOp)*2
if (nOrdOp == 1) then
  ipVxyz = nip
  nip = nip+nZeta*6*(la+1)*(lb+1)*2
  ipA = nip
  nip = nip+nZeta
  ipB = nip
  nip = nip+nZeta
  ipRes = nip
  nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp
else
  ipVxyz = nip
  ipA = nip
  ipB = nip
  ipRes = nip
  nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp
end if
if (nip-1 > nArr*nZeta) then
  call WarningMessage(2,'EMFInt: nip-1 > nArr*nZeta')
  write(u6,*) ' nArr is Wrong! ',nip-1,' > ',nArr*nZeta
  write(u6,*) ' Abend in EMFInt'
  call Abend()
end if

if (iPrint >= 49) then
  call RecPrt(' In EMFInt: A',' ',A,1,3)
  call RecPrt(' In EMFInt: RB',' ',RB,1,3)
  call RecPrt(' In EMFInt: KVector',' ',CCoor,1,3)
  call RecPrt(' In EMFInt: P',' ',P,nZeta,3)
  write(u6,*) ' In EMFInt: la,lb=',la,lb
end if

rFinal(:,:,:,:) = Zero

call EMFInt_Internal(Array)

llOper = lOper(1)
do iComp=2,nComp
  llOper = ior(llOper,lOper(iComp))
end do
call SOS(iStabO,nStabO,llOper)
call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

do lDCRT=0,nDCRT-1

  ! Accumulate contributions

  nOp = NrOpr(iDCRT(lDCRT))
  call SymAdO(Array(ipRes),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,One)

end do

return

! This is to allow type punning without an explicit interface
contains

subroutine EMFInt_Internal(Array)

  real(kind=wp), target :: Array(*)
  complex(kind=wp), pointer :: zAxyz(:,:,:,:), zBxyz(:,:,:,:), zQxyz(:,:,:,:), zQxyz2(:,:,:,:,:), zVxyz(:,:,:,:,:)
  integer(kind=iwp) :: iBeta

  ! Compute the cartesian values of the basis functions angular part
  ! Note that these arrays are complex.

  call c_f_pointer(c_loc(Array(ipAxyz)),zAxyz,[nZeta,3,nHer,la+nOrdOp+1])
  call c_f_pointer(c_loc(Array(ipBxyz)),zBxyz,[nZeta,3,nHer,lb+nOrdOp+1])
  call c_f_pointer(c_loc(Array(ipQxyz)),zQxyz,[nZeta,3,la+nOrdOp+1,lb+nOrdOp+1])

  call CCrtCmp(Zeta,P,nZeta,A,zAxyz,la+nOrdOp,HerR(iHerR(nHer)),nHer,CCoor)
  call CCrtCmp(Zeta,P,nZeta,RB,zBxyz,lb+nOrdOp,HerR(iHerR(nHer)),nHer,CCoor)

  ! Compute the cartesian components for the multipole moment
  ! integrals. The integrals are factorized into components.

  call CAssmbl(zQxyz,zAxyz,la+nOrdOp,zBxyz,lb+nOrdOp,nZeta,HerW(iHerW(nHer)),nHer)

  ! Compute the cartesian components for the velocity integrals.
  ! The velocity components are linear combinations of overlap components.

  if (nOrdOp == 1) then
    ipAOff = ipA-1
    do iBeta=1,nBeta
      Array(ipAOff+1:ipAOff+nAlpha) = Alpha
      ipAOff = ipAOff+nAlpha
    end do

    ipBOff = ipB-1
    do iBeta=1,nBeta
      Array(ipBOff+1:ipBOff+nAlpha) = Beta(iBeta)
      ipBOff = ipBOff+nAlpha
    end do

    call c_f_pointer(c_loc(Array(ipVxyz)),zVxyz,[nZeta,3,la+1,lb+1,2])
    call CVelInt(zVxyz,zQxyz,la,lb,Array(ipA),Array(ipB),nZeta)

    ! Combine the cartesian components to the full one electron integral.

    call CCmbnVe(zQxyz,nZeta,la,lb,Zeta,rKappa,Array(ipRes),nComp,zVxyz,CCoor,P)
    nullify(zVxyz)
  else
    call c_f_pointer(c_loc(Array(ipQxyz)),zQxyz2,[nZeta,3,la+1,lb+1,nOrdOp+1])
    call CCmbnMP(zQxyz2,nZeta,la,lb,nOrdOp,Zeta,rKappa,Array(ipRes),nComp,CCoor,P)
    nullify(zQxyz2)
  end if

  nullify(zAxyz,zBxyz,zQxyz)

  return

end subroutine EMFInt_internal

end subroutine EMFInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Markus P. Fuelscher                              *
*               2012, Giovanni Li Manni                                *
************************************************************************
      SUBROUTINE CSDTVC(CSFVEC,DETVEC,IWAY,DTOCMT,ICTSDT,
     *                  IREFSM,ICOPY)
C
C     PURPOSE: TRANSFORM FROM DETERMINANT TO CSF BASIS AND VICE VERSA
C              IWAY = 1 : CSF TO DETERMINANT TRANSFORMATION
C              IWAY = 2 : DETERMINANT TO CSF TRANSFORMATION
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "ciinfo.fh"
#include "spinfo.fh"
C
      DIMENSION CSFVEC(*),DETVEC(*)
      DIMENSION DTOCMT(*),ICTSDT(*)

C
C     To avoid compiler complaints
C
      IOFFCS = 0
      IOFFDT = 0
      IOFFCD = 0
C
      NTEST = 00
C
      NDET = NDTASM(IREFSM)
      NCSF = NCSASM(IREFSM)
      IF (NTEST .GE. 100) THEN
         WRITE(6,*) '======================================='
         WRITE(6,*) '         CSDTVC INFORMATIONS'
         IF (IWAY .EQ. 1) THEN
            WRITE(6,*) '   CSF TO DETERMINANT TRANSFORMATION'
         ELSE
            WRITE(6,*) '   DETERMINANT TO CSF TRANSFORMATION'
         END IF
         WRITE(6,*) '======================================='
         WRITE(6,*)
         WRITE(6,*) '  NDET                  = ',NDET
         WRITE(6,*) '  NCSF                  = ',NCSF
         WRITE(6,*)
      END IF
C
C     CSF ==> DET TRANSFORMATION
C
      IF( IWAY.EQ.1 ) THEN
        IF (NTEST .GE. 100) THEN
          WRITE(6,*) '   INPUT CSF VECTOR:'
          CALL WRTMAT(CSFVEC,1,NCSF,1,NCSF)
          WRITE(6,*)
        END IF
        CALL DCOPY_(NDET,[0.0d0],0,DETVEC,1)
        DO ITYP = 1,NTYP
          IDET = NDTFTP(ITYP)
          ICSF = NCSFTP(ITYP)
          ICNF = NCNFTP(ITYP,IREFSM)
          IF( ITYP.EQ.1 ) THEN
            IOFFCS = 1
            IOFFDT = 1
            IOFFCD = 1
          ELSE
            IOFFCS = IOFFCS+NCNFTP(ITYP-1,IREFSM)*NCSFTP(ITYP-1)
            IOFFDT = IOFFDT+NCNFTP(ITYP-1,IREFSM)*NDTFTP(ITYP-1)
            IOFFCD = IOFFCD + NDTFTP(ITYP-1)*NCSFTP(ITYP-1)
          END IF
          IF( (IDET*ICNF*ICSF).GT.0 )
     &         CALL MATML4(DETVEC(IOFFDT),DTOCMT(IOFFCD),
     &         CSFVEC(IOFFCS), IDET,ICNF,IDET,ICSF,ICSF,ICNF,0)
        END DO
        Call Sort_Cdet(nDet,ICTSDT,DetVec)
        IF( ICOPY.NE.0 ) CALL DCOPY_(NDET,DETVEC,1,CSFVEC,1)
        IF (NTEST .GE. 100) THEN
          WRITE(6,*) '   OUTPUT DET VECTOR:'
          CALL WRTMAT(DETVEC,1,NDET,1,NDET)
          WRITE(6,*)
        END IF

      ELSE
C
C     DET ==> CSF TRANSFORMATION
C
        IF (NTEST .GE. 100) THEN
          WRITE(6,*) '   INPUT DET VECTOR:'
          CALL WRTMAT(DETVEC,1,NDET,1,NDET)
          WRITE(6,*)
        END IF
        CALL GATVCS(CSFVEC,DETVEC,ICTSDT,NDET)
        IF (NTEST .GE. 100) THEN
           WRITE(6,*) ' ICTSDT reorder array '
           CALL IWRTMA(ICTSDT,1,100,1,100)
        END IF
        CALL DCOPY_(NDET,CSFVEC,1,DETVEC,1)
        DO ITYP = 1,NTYP
          IDET = NDTFTP(ITYP)
          ICSF = NCSFTP(ITYP)
          ICNF = NCNFTP(ITYP,IREFSM)
          IF( ITYP.EQ. 1 ) THEN
            IOFFCS = 1
            IOFFDT = 1
            IOFFCD = 1
          ELSE
            IOFFCS = IOFFCS+NCNFTP(ITYP-1,IREFSM)*NCSFTP(ITYP-1)
            IOFFDT = IOFFDT+NCNFTP(ITYP-1,IREFSM)*NDTFTP(ITYP-1)
            IOFFCD = IOFFCD + NDTFTP(ITYP-1)*NCSFTP(ITYP-1)
          END IF
          IF( (IDET*ICNF*ICSF).GT.0 )
     &         CALL MATML4(CSFVEC(IOFFCS),DTOCMT(IOFFCD),
     &         DETVEC(IOFFDT), ICSF,ICNF,IDET,ICSF,IDET,ICNF,1)
        END DO
        IF( ICOPY.NE.0 ) CALL DCOPY_(NCSF,CSFVEC,1,DETVEC,1)
        IF (NTEST .GE. 100) THEN
          WRITE(6,*) '   OUTPUT CSF VECTOR:'
          CALL WRTMAT(CSFVEC,1,NCSF,1,NCSF)
          WRITE(6,*)
        END IF
       END IF
C
      RETURN
      END

      Subroutine Sort_Cdet(N,Index,X)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Sort CI-coefficients in determinant basis and change phase       *
*                                                                      *
*     calling arguments:                                               *
*     N       : integer                                                *
*               dimension of the CI-vector                             *
*     Index   : integer                                                *
*               reordering indices                                     *
*     X       : real*8                                                 *
*               CI-vector                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     G. Li Manni on 03 Feb 2012 on a desperate situation for saving   *
*     time!                                                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1999                                 *
*                                                                      *
* It was a great piece of code for those times when memory was a very  *
* big issue! Nowadays only time is important!                          *
************************************************************************
*      Do i = 1,N                                                      *
*        i_old = i                                                     *
*        i_new = ABS(Index(i_old))                                     *
*        Do while ( i_new.gt.i )                                       *
*          i_old = i_new                                               *
*          i_new = ABS(Index(i_old))                                   *
*        End Do                                                        *
*        If ( i_new.eq.i ) then                                        *
*          i_old = i                                                   *
*          X_old = X(i_old)                                            *
*          i_new = ABS(Index(i_old))                                   *
*          X_new = X(i_new)                                            *
*          alpha = DBLE(SIGN(1,Index(i_old)))                          *
*          Do while ( i_new.gt.i )                                     *
*            X(i_new) = alpha*X_old                                    *
*            i_old = i_new                                             *
*            X_old = X_new                                             *
*            i_new = ABS(Index(i_old))                                 *
*            X_new = X(i_new)                                          *
*            alpha = DBLE(SIGN(1,Index(i_old)))                        *
*          End Do                                                      *
*          X(i) = alpha*X_old                                          *
*        End If                                                        *
*      End Do                                                          *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Dimension Index(N),X(N)
      Intrinsic SIGN
#include "WrkSpc.fh"
      call getmem('ReordSDs','Allo','Real',iReoSDs,N)
      Do i = 1,N
        i_new = ABS(Index(i))
        alpha = DBLE(SIGN(1,Index(i)))
        Work(iReoSDs+i_new -1) = alpha*X(i)
      End do
      call dcopy_(N,Work(iReoSDs),1,X,1)
      call getmem('ReordSDs','Free','Real',iReoSDs,N)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ABD(ICSPCK,INTSYM,INDX,C,DMO,A,B,F)

use mrci_global, only: ENP, IFIRST, IRC, IROW, LN, LSYM, NCSHT, NELEC, NSYM, NVIR, NVIRP, SQ2, SQ2INV
use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICSPCK(*), INTSYM(*), INDX(*)
real(kind=wp), intent(inout) :: C(*)
real(kind=wp), intent(_OUT_) :: DMO(*), A(*), B(*), F(*)
integer(kind=iwp) :: I, IAB, IASYM, ICSYM, IFT, II1, IIA, IIC, IIN, IJ, INDA, INMY, INN, IOC(55), IPF, IPOA(9), IPOF(9), ITAIL, &
                     LNA, LNC, MYL, MYSYM, NA, NA1, NA2, NAB, NAC, NB, NCLIM, NVIRA, NVIRC
real(kind=wp) :: ENPINV, RSUM, TR, TSUM
integer(kind=iwp), external :: ICUNP, JSUNP
real(kind=r8), external :: DDOT_

! SCRATCH SPACE: A(),B(),F().
call CSCALE(INDX,INTSYM,C,SQ2)
NCLIM = 4
if (IFIRST /= 0) NCLIM = 2
ENPINV = One/ENP
! MOVE DENSITY MATRIX TO F IN SYMMETRY BLOCKS
call IPO(IPOF,NVIR,MUL,NSYM,1,-1)
do IASYM=1,NSYM
  IAB = IPOF(IASYM)
  NA1 = NVIRP(IASYM)+1
  NA2 = NVIRP(IASYM)+NVIR(IASYM)
  do NA=NA1,NA2
    do NB=NA1,NA2
      IAB = IAB+1
      NAB = IROW(LN+NA)+LN+NB
      if (NB > NA) NAB = IROW(LN+NB)+LN+NA
      F(IAB) = DMO(NAB)
    end do
  end do
end do
II1 = 0
ITAIL = IRC(NCLIM)
do INDA=1,ITAIL
  do I=1,LN
    II1 = II1+1
    IOC(I) = (1+ICUNP(ICSPCK,II1))/2
  end do
  if (INDA <= IRC(1)) then
    TSUM = ENPINV*C(INDA)**2
  else
    MYSYM = JSUNP(INTSYM,INDA)
    MYL = MUL(MYSYM,LSYM)
    INMY = INDX(INDA)+1
    if (INDA <= IRC(2)) then
      ! DOUBLET-DOUBLET INTERACTIONS
      if (NVIR(MYL) == 0) cycle
      call FMUL2(C(INMY),C(INMY),A,NVIR(MYL),NVIR(MYL),1)
      IPF = IPOF(MYL)+1
      IIN = IPOF(MYL+1)-IPOF(MYL)
      F(IPF:IPF+IIN-1) = F(IPF:IPF+IIN-1)+ENPINV*A(1:IIN)
      NVIRA = NVIR(MYL)
      LNA = LN+NVIRP(MYL)
      IIA = IROW(LNA+1)
      TSUM = Zero
      do I=1,NVIRA
        RSUM = ENPINV*C(INMY)**2
        INMY = INMY+1
        TSUM = TSUM+RSUM
        IIA = IIA+LNA+I
        DMO(IIA) = DMO(IIA)+RSUM
      end do
    else
      ! TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
      IFT = 1
      if (INDA > IRC(3)) IFT = 0
      call IPO(IPOA,NVIR,MUL,NSYM,MYL,IFT)
      IIN = 0
      TSUM = Zero
      do IASYM=1,NSYM
        IAB = IPOF(IASYM+1)-IPOF(IASYM)
        if (IAB == 0) cycle
        ICSYM = MUL(MYL,IASYM)
        if (NVIR(ICSYM) == 0) cycle
        if (MYL /= 1) then
          if (IASYM > ICSYM) then
            call MTRANS(C(INMY+IPOA(IASYM)),A,NVIR(IASYM),NVIR(ICSYM))
          else
            NAC = NVIR(IASYM)*NVIR(ICSYM)
            if (IFT == 0) call DCOPY_(NAC,C(INMY+IPOA(ICSYM)),1,A,1)
            if (IFT == 1) call VNEG(NAC,C(INMY+IPOA(ICSYM)),1,A,1)
          end if
        else
          if (IFT == 0) call SQUAR(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
          if (IFT == 1) call SQUARM(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
        end if
        NVIRA = NVIR(IASYM)
        NVIRC = NVIR(ICSYM)
        call FMUL2(A,A,B,NVIR(IASYM),NVIR(IASYM),NVIR(ICSYM))
        IPF = IPOF(IASYM)+1
        F(IPF:IPF+IAB-1) = F(IPF:IPF+IAB-1)+ENPINV*B(1:IAB)
        INN = 1
        LNC = LN+NVIRP(ICSYM)
        IIC = IROW(LNC+1)
        do I=1,NVIRC
          RSUM = ENPINV*DDOT_(NVIRA,A(INN),1,A(INN),1)
          TSUM = TSUM+RSUM
          IIC = IIC+LNC+I
          DMO(IIC) = DMO(IIC)+RSUM
          INN = INN+NVIRA
        end do
      end do
      TSUM = TSUM/2
    end if
  end if
  IJ = 0
  do I=1,LN
    IJ = IJ+I
    DMO(IJ) = DMO(IJ)+IOC(I)*TSUM
  end do
end do
do IASYM=1,NSYM
  IAB = IPOF(IASYM)
  NA1 = NVIRP(IASYM)+1
  NA2 = NVIRP(IASYM)+NVIR(IASYM)
  do NA=NA1,NA2
    do NB=NA1,NA2
      IAB = IAB+1
      if (NA >= NB) cycle
      NAB = IROW(LN+NB)+LN+NA
      DMO(NAB) = F(IAB)
    end do
  end do
end do
TR = Zero
IJ = 0
do I=1,NCSHT
  IJ = IJ+I
  TR = TR+DMO(IJ)
end do
if (abs(TR-real(NELEC,kind=wp)) > 1.0e-8_wp) write(u6,310) TR
call CSCALE(INDX,INTSYM,C,SQ2INV)

return

310 format(/,6X,'TRACE OF DENSITY MATRIX',F16.8)

end subroutine ABD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FIJD(INTSYM,INDX,C,DMO,JREFX,AREF)

use mrci_global, only: ENP, ICPF, IRC, IROW, IVVER, LSYM, LUSYMB, NVIR, NVPAIR
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: INTSYM(*), INDX(*), JREFX(*)
real(kind=wp), intent(in) :: C(*), AREF(*)
real(kind=wp), intent(inout) :: DMO(*)
integer(kind=iwp) :: IADD10, IC1, IC2, ICHK, IIN, IK, ILEN, IND, INDA, INDB, INDI, INUM, IRC1, IRC2, IVL, NA, NB, NI, NK, NS1, NS1L
real(kind=wp) :: ENPINV, TERM
integer(kind=iwp), external :: JSUNP
real(kind=wp), external :: DDOT_

ICHK = 0
IK = 0
ENPINV = One/ENP
IADD10 = IAD10(8)
do
  call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
  call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
  ILEN = ICOP1(nCOP+1)
  if (ILEN < 0) exit
  do IIN=1,ILEN
    IND = ICOP1(IIN)
    if (ICHK /= 0) then
      ICHK = 0
      INDI = IND
      NI = ibits(INDI,0,10)
      NK = ibits(INDI,10,10)
      IK = IROW(NK)+NI
    else if (IND == 0) then
      ICHK = 1
    else
      IVL = ibits(IND,0,6)
      IC2 = ibits(IND,6,13)
      IC1 = ibits(IND,19,13)
      if (IVL == IVVER) then
        DMO(IK) = DMO(IK)+COP(IIN)*C(IC1)*C(IC2)*ENPINV
        if (ICPF /= 0) then
          IRC1 = JREFX(IC1)
          if (IRC1 /= 0) then
            IRC2 = JREFX(IC2)
            if (IRC2 /= 0) DMO(IK) = DMO(IK)+COP(IIN)*AREF(IRC1)*AREF(IRC2)*(One-ENPINV)
          end if
        end if
      else
        INDA = IRC(IVL)+IC1
        INDB = IRC(IVL)+IC2
        NA = INDX(INDA)
        NB = INDX(INDB)
        NS1 = JSUNP(INTSYM,INDA)
        NS1L = MUL(NS1,LSYM)
        INUM = NVIR(NS1L)
        if (IVL >= 2) INUM = NVPAIR(NS1L)
        TERM = DDOT_(INUM,C(NA+1),1,C(NB+1),1)
        DMO(IK) = DMO(IK)+COP(IIN)*TERM*ENPINV
      end if
    end if
  end do
end do

return

end subroutine FIJD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Roland Lindh                                     *
!***********************************************************************

subroutine Mk_aCD_acCD_Shells(iCnttp,W2L)
!***********************************************************************
!                                                                      *
!    Objective: To generate aCD auxiliary basis sets on-the-fly.       *
!                                                                      *
! Called from: Mk_RICD_Shells                                          *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chemistry - Angstrom              *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem, nTri_Elem1
use RI_procedures, only: Drv2El_Atomic_NoSym, Fix_Exponents
use SOAO_Info, only: iAOtSO, nSOInf, SOAO_Info_Free, SOAO_Info_Init
use Basis_Info, only: dbsc, Max_Shells, nCnttp, Shells
use Sizes_of_Seward, only: S
use RICD_Info, only: Do_acCD_Basis, Skip_High_AC, Thrshld_CD
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCnttp
logical(kind=iwp), intent(in) :: W2L
#include "Molcas.fh"
#include "itmax.fh"
#include "print.fh"
integer(kind=iwp) :: i, iAng, iAngMax, iAngMin, iAO, iBS, iCho_c, iCho_p, iCmp, iCntrc, iDum, iExp_k, iExp_l, ijS, ijS_req, ijSO, &
                     ijT, ik, ikl, il, Indx, iOff, iOff_Ak, iOff_Qk, ip_Exp, iRC, iSeed, iShell, iShll, iShll_, iSO, iSph, &
                     istatus, iTheta, iTheta_full, iVal, iZ, j, jAng, jAngMax, jAngMin, jCho_p, jCnttp, jkl, jp_Exp, jp_Exp_Max, &
                     jShll, jShll_, jTheta, jTheta_full, kAng, kC, Keep_All, Keep_Shell, kShll, lAng, lC, LinDep, lScr, lShll, &
                     Lu_A, Lu_B, Lu_lib, mData, mdc, mPrim, mSOInf, n, nBS, nCmp, nCmpi, nCmpj, nCnt, nCntrc, nCntrc_Max, &
                     nCnttp_Start, nExpi, nExpk, nExpl, nk, nl, nn, nPhi, nPhi_All, npi, npj, npk, npl, nPrim, nPrim_Max, nSO, &
                     nSO_p, nTest, nTheta, nTheta_All, nTheta_Full, nTInt_c, nTInt_p, nTri, NumCho_c, NumCho_p
real(kind=wp) :: Coeff_, Coeff_k, Coeff_kk, Coeff_kl, Coeff_l, Coeff_lk, Coeff_ll, Dummy(1), Exp_i, Exp_j, Fact, Thr_aCD, ThrAO, &
                 Thrs, Thrshld_CD_p
integer(kind=iwp), allocatable :: Con(:), ConR(:,:), iD_c(:), iD_p(:), iList2_c(:,:), iList2_p(:,:), Indkl(:), Indkl_p(:), &
                                  LTP(:,:), Prm(:)
real(kind=wp), allocatable :: A(:), ADiag(:), C(:), Q(:), QTmp(:), Scr(:), Temp(:), TInt_c(:), TInt_p(:), Tmp(:), TP(:), tVp(:), &
                              tVt(:), tVtF(:), Vec(:), Wg(:), Z(:)
#ifdef _DEBUGPRINT_
real(kind=wp), allocatable :: H(:), tVtInv(:), U(:)
#endif
logical(kind=iwp) :: Diagonal, Found, Hit, In_Core, Keep_Basis
character(len=80) :: atom, author, Aux, basis, BSLbl, btype, CGTO, Label
integer(kind=iwp), external :: IsFreeUnit
external :: Integral_RICD

!                                                                      *
!***********************************************************************
!                                                                      *
ThrAO = Zero
mData = 4
nCnttp_Start = nCnttp
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Loop now over all unique valence basis sets and generate the
! corresponding aCD auxiliary basis sets. Note that there are two
! different types of aCD auxiliary basis sets, aCD and acCD.

nSO_p = 0
nTheta_All = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Pick up the threshold for the CD procedure. Note that basis
! sets might have individual accuracy!

mdc = dbsc(iCnttp)%mdci
Thr_aCD = dbsc(iCnttp)%aCD_Thr*Thrshld_CD
!
nTest = dbsc(iCnttp)%nVal-1
!                                                                      *
!***********************************************************************
!                                                                      *
if (Skip_High_AC) then

  ! Pick up the angular index of the highest valence shell

  if (dbsc(iCnttp)%AtmNr <= 2) then
    iVal = 0
  else if (dbsc(iCnttp)%AtmNr <= 10) then
    iVal = 1
  else if (dbsc(iCnttp)%AtmNr <= 18) then
    iVal = 1
  else if (dbsc(iCnttp)%AtmNr <= 36) then
    iVal = 2
  else if (dbsc(iCnttp)%AtmNr <= 54) then
    iVal = 2
  else if (dbsc(iCnttp)%AtmNr <= 86) then
    iVal = 3
  else
    iVal = 3
  end if
  Keep_All = 2*nTest
  ! Find the number of polarization shells
  iZ = max(0,nTest-iVal)
  ! Reduce the product basis from excessive shells
  Keep_Shell = Keep_All-iZ
else
  Keep_Shell = iTabmx
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Define some parameters to facilitate the atomic calculation

iShell = dbsc(iCnttp)%nVal
S%nShlls = iShell
!                                                                      *
!***********************************************************************
!                                                                      *
! Use the name of the old valence basis

Label = dbsc(iCnttp)%Bsl_old

Hit = .true.
call Decode(Label,atom,1,Hit)
Hit = .true.
call Decode(Label,btype,2,Hit)
Hit = .true.
call Decode(Label,author,3,Hit)
Hit = .true.
call Decode(Label,basis,4,Hit)
Hit = .true.
call Decode(Label,CGTO,5,Hit)
Hit = .false.
call Decode(Label,Aux,6,Hit)
if (.not. Hit) Aux = ' '

n = index(Atom,' ')-1
Label = ' '
Label(1:n+1) = atom(1:n)//'.'
nn = n+1

n = index(btype,' ')-1
if (Do_acCD_Basis) then
  Label(nn+1:nn+n+23) = btype(1:n)//'....acCD-aux-basis.'
else
  Label(nn+1:nn+n+22) = btype(1:n)//'....aCD-aux-basis.'
end if

Indx = index(Label,' ')
BSLbl = ' '
BSLbl(1:Indx-1) = Label(1:Indx-1)

! Make a temporary setup of the SOAO_Info arrays for the
! atomic auxiliary basis set.
! Note that the auxiliary basis set will carry an angular value
! which at most is twice that of valence basis set.

mSOInf = 0

do iAng=0,2*nTest
  nCmp = nTri_Elem1(iAng)
  mSOInf = mSOInf+nCmp
end do
call SOAO_Info_Init(mSOInf,1)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! C O N T R A C T E D    S E C T I O N
!
! Run in contracted mode to generate the auxiliary basis for the
! aCD primitive product basis.

call Flip_Flop(.false.)
!                                                                      *
!***********************************************************************
!                                                                      *
! Define AOtSO

iAO = 0
iSO = 0
nSO = 0
do iAng=0,nTest
  iShll_ = dbsc(iCnttp)%iVal+iAng
  nCmp = nTri_Elem1(iAng)
  if (Shells(iShll_)%Prjct) nCmp = 2*iAng+1
  iSO = 0
  if (Shells(iShll_)%nBasis_C*Shells(iShll_)%nExp == 0) cycle
  do iCmp=1,nCmp
    iAO = iAO+1
    if (iAO > nSOInf) then
      write(u6,*) 'mk_acd_accd_shells: iAO>nSOInf (1)'
      write(u6,*) 'iAO=',iAO
      write(u6,*) 'nSOInf=',nSOInf
      call Abend()
    end if
    iAOtSO(iAO,0) = iSO+1
    iSO = iSO+Shells(iShll_)%nBasis
  end do
  nSO = nSO+iSO
end do

! Generate list

nPhi_All = nTri_Elem(nSO)
call mma_allocate(iList2_c,mData*2,nPhi_All,label='iList2_c')
call Mk_List2(iList2_c,nPhi_All,mData,nSO,iCnttp,nTest,0)
!                                                                      *
!***********************************************************************
!                                                                      *
! If the full product basis is used no need for decomposition!

if (Thr_aCD == Zero) then
  nTInt_c = nPhi_All
  call mma_allocate(iD_c,nTInt_c,label='iD_c')
  do i=1,nTInt_c
    iD_c(i) = i
  end do
  NumCho_c = nTInt_c
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Generate atomic two-electron integrals to decompose.

  ijS_req = 0
  call Drv2El_Atomic_NoSym(Integral_RICD,ThrAO,iCnttp,iCnttp,TInt_c,nTInt_c,In_Core,ADiag,Lu_A,ijS_req,Keep_Shell)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Let us now decompose and retrieve the most important
  ! contracted products, indicies stored in iD_c

  call mma_allocate(iD_c,nTInt_c,label='iD_c')

  ! Temporary code for weights to be used in a MS-aCD/acCD
  ! scheme. Currently set to unit giving the convential
  ! all purpose aCD/acCD auxiliary basis sets.

  call mma_allocate(Wg,nTInt_c,label='Wg')
  Wg(:) = One

  if (In_Core) then
#   ifdef _DEBUGPRINT_
    call RecPrt('TInt_c',' ',TInt_c,nTInt_c,nTInt_c)
#   endif
    call mma_allocate(Vec,nTInt_c**2,label='Vec')

    call CD_InCore_p_w(TInt_c,nTInt_c,Wg,Vec,nTInt_c,iD_c,NumCho_c,Thr_aCD,iRC)

    if (iRC /= 0) then
      call WarningMessage(2,'Error in Mk_RICD_Shells')
      write(u6,*) 'Mk_aCD_Shells: CD_InCore_p(c) failed!'
      call Abend()
    end if
#   ifdef _DEBUGPRINT_
    call RecPrt('Vec',' ',Vec,nTInt_c,NumCho_c)
#   endif
    call mma_deallocate(TInt_c)
    call mma_deallocate(Vec)

  else    ! out-of-core part

    call mma_maxDBLE(lScr)
    lScr = min(lScr-2*nTInt_c,nTInt_c**2+3*nTInt_c)
    call mma_Allocate(Scr,lScr,label='Scr')

    iSeed = Lu_A+1
    Lu_B = IsFreeUnit(iSeed)
    call DaName_MF_WA(Lu_B,'AVEC1')

    call Get_Pivot_idx_w(ADiag,Wg,nTInt_c,NumCho_c,Lu_A,Lu_B,iD_c,Scr,lScr,Thr_aCD)

    call mma_deallocate(Scr)
    call mma_deallocate(ADiag)
    call DaEras(Lu_B)
    call DaEras(Lu_A)

  end if

  call mma_deallocate(Wg)

end if

if (NumCho_c < 1) then
  call WarningMessage(2,'Error in Mk_RICD_Shells')
  write(u6,*) 'Mk_aCD_Shells: NumCho_c < 1 is illegal!'
  call Abend()
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Thr_aCD:',Thr_aCD
write(u6,*) 'NumCho_c:',NumCho_c
call iVcPrt('iD_c',' ',iD_c,NumCho_c)
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Define AOtSO for primitive integral calculations.

if (Do_acCD_Basis) then
  iAO = 0
  iSO = 0
  nSO_p = 0
  do iAng=0,nTest
    iShll_ = dbsc(iCnttp)%iVal+iAng
    nCmp = nTri_Elem1(iAng)
    if (Shells(iShll_)%Prjct) nCmp = 2*iAng+1
    iSO = 0
    do iCmp=1,nCmp
      iAO = iAO+1
      if (iAO > nSOInf) then
        write(u6,*) 'mk_acd_accd_shells: iAO>nSOInf (2)'
        call Abend()
      end if
      iAOtSO(iAO,0) = iSO+1
      iSO = iSO+Shells(iShll_)%nExp
    end do
    nSO_p = nSO_p+iSO
  end do
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!***********************************************************************
!                                                                      *
! Loop through angular products. Note that all the products
! of an atom require multiple basis sets since Seward is not
! structured to handle more than one shell of a specific
! angular at the time, i.e. a basis set contains only, for
! example, one d-shell. For an atomic basis spd we will have
! the p*p and d*s resulting in two independent shells with
! the same total angular momentum, d.

iShll = S%Mx_Shll-1

! Start now looping over the products and analys the result
! of the CD. Note the very peculiar loop structure over
! iBS, iAng, and jAng. This to reduce the number of
! created basis sets.

nBS = (nTest+2)/2
do iBS=0,nBS-1
  iAngMin = iBS
  iAngMax = nTest-iBS

  nCnttp = nCnttp+1
  Keep_Basis = .false.

  if (nCnttp > Mxdbsc) then
    call WarningMessage(2,'Error in Mk_RICD_Shells')
    write(u6,*) 'Mk_RICD_Shells: Increase Mxdbsc'
    call Abend()
  end if

  ! Some generic setting of information

  dbsc(nCnttp)%Bsl = Label
  dbsc(nCnttp)%Bsl_old = dbsc(nCnttp)%Bsl
  dbsc(nCnttp)%pChrg = dbsc(iCnttp)%pChrg
  dbsc(nCnttp)%Fixed = dbsc(iCnttp)%Fixed
  dbsc(nCnttp)%Parent_iCnttp = iCnttp
  dbsc(nCnttp)%iVal = iShll+1
  dbsc(nCnttp)%Aux = .true.
  dbsc(nCnttp)%aCD_Thr = dbsc(iCnttp)%aCD_Thr
  dbsc(nCnttp)%fMass = dbsc(iCnttp)%fMass
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Loop over shell pairs

  jShll = iShll
  do iAng=0,iAngMax
    jAngMax = min(iAng,iAngMin)
    iShll_ = dbsc(iCnttp)%iVal+iAng
    if (iAng == iAngMax) jAngMax = iAngMax
    if (iAng < iAngMin) jAngMax = 0
    jAngMin = iAngMin
    if (iAng <= iAngMin) jAngMin = 0
    do jAng=jAngMin,jAngMax
      jShll_ = dbsc(iCnttp)%iVal+jAng

      iShll = iShll+1
#     ifdef _DEBUGPRINT_
      write(u6,*)
      write(u6,*) 'iAng,jAng=',iAng,jAng
      write(u6,*) 'iAngMax=',iAngMax
#     endif
      if (iShll > MxShll) then
        call WarningMessage(2,'Error in Mk_RICD_Shells')
        write(u6,*) 'Mk_RICD_Shells: iShll > MxShll'
        write(u6,*) 'iShll,MxShll=',iShll,MxShll
        call Abend()
      end if
      Diagonal = iAng == jAng

      ! Examine if any contracted products of these two shells
      ! survived the CD procedure, or that it is an empty shell.

      Found = .false.
      kShll = -1
      lShll = -1
      do iCho_c=1,NumCho_c
        ijSO = iD_c(iCho_c)
        kAng = iList2_c(1,ijSO)
        lAng = iList2_c(2,ijSO)
        if ((iAng == kAng) .and. (jAng == lAng)) then
          kShll = iList2_c(7,ijSO)
          lShll = iList2_c(8,ijSO)
          Found = .true.
          exit
        end if
      end do

      ! Fake Found=.FALSE. for shells which should explicitly be empty.

      Found = Found .and. (jAng >= iAngMin) .and. (iAng >= iAngMin) .and. (iAng+jAng <= Keep_Shell)
      Keep_Basis = Found .or. Keep_Basis
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Found,kShll,lShll=',Found,kShll,lShll
#     endif
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
      ! P R I M I T I V E   S E C T I O N
      !
      ! Run in uncontracted mode to produce a SLIM
      ! primitive product  basis.

      if (Do_acCD_Basis .and. Found) then

        call Flip_Flop(.true.)

        ! Generate list

        npi = Shells(iShll_)%nExp
        nCmpi = nTri_Elem1(iAng)
        if (Shells(iShll_)%Prjct) nCmpi = 2*iAng+1
        npj = Shells(jShll_)%nExp
        nCmpj = nTri_Elem1(jAng)
        if (Shells(jShll_)%Prjct) nCmpj = 2*jAng+1
        if (iAng == jAng) then
          nTheta_All = nTri_Elem(npi*nCmpi)
        else
          nTheta_All = npi*nCmpi*npj*nCmpj
        end if

        call mma_allocate(iList2_p,2*mData,nTheta_all,label='iList2_p')

        ijS_Req = iTri(iAng+1,jAng+1)

        call Mk_List2(iList2_p,nTheta_All,mData,nSO_p,iCnttp,nTest,ijS_Req)
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Generate atomic two-electron integrals

        call Drv2El_Atomic_NoSym(Integral_RICD,ThrAO,iCnttp,iCnttp,TInt_p,nTInt_p,In_Core,ADiag,Lu_A,ijS_Req,Keep_Shell)

        if (.not. In_Core) then
          call WarningMessage(2,'Error in Mk_RICD_Shells')
          write(u6,*) 'Out-of-core acCD not implemented!'
          call Abend()
        end if
#       ifdef _DEBUGPRINT_
        call RecPrt('TInt_p','(5G20.11)',TInt_p,nTInt_p,nTInt_p)
#       endif
        call Flip_Flop(.false.)

      end if
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
      ! Now mimic the procedure of GetBS!
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Working on the CONTRACTED functions.
      !
      ! This section is identical for acCD and aCD auxiliary basis sets!
      !                                                                *
      !*****************************************************************
      !                                                                *
      if (Found) then

        lAng = iAng+jAng

        ! Now figure out how many and which!

        nk = Shells(kShll)%nBasis_C
        nl = Shells(lShll)%nBasis_C
        if (Diagonal) then
          nCntrc_Max = nTri_Elem(nk)
        else
          nCntrc_Max = nk*nl
        end if
#       ifdef _DEBUGPRINT_
        write(u6,*) 'nCntrc_Max=',nCntrc_Max
#       endif
        call mma_allocate(Con,nCntrc_Max,label='Con')
        call mma_allocate(ConR,2,nCntrc_Max,label='ConR')
        Con(:) = 0
        ConR(:,:) = 0
        nCntrc = 0
        do iCho_c=1,NumCho_c
          ijSO = iD_c(iCho_c)
          kAng = iList2_c(1,ijSO)
          lAng = iList2_c(2,ijSO)
          if ((kAng == iAng) .and. (lAng == jAng)) then

            ! Pick up the radial index!

            ik = iList2_c(5,ijSO)
            il = iList2_c(6,ijSO)

            if (Diagonal) then
              ikl = iTri(ik,il)
            else
              ikl = (il-1)*nk+ik
            end if

            ! Note that this migh be done several time since several
            ! angular pairs might have the same radial function!

            if (Con(ikl) == 0) then
              nCntrc = nCntrc+1
              Con(ikl) = 1
              ConR(1,nCntrc) = ik
#             ifdef _DEBUGPRINT_
              write(u6,*) 'iCho_c,  ijSO=',iCho_c+1,ijSO
#             endif
              ConR(2,nCntrc) = il
            end if
          end if
        end do    !  iCho_c
#       ifdef _DEBUGPRINT_
        write(u6,*) 'nCntrc=',nCntrc
        call iVcPrt('Con',' ',Con,nCntrc_Max)
        call iVcPrt('ConR',' ',ConR,2*nCntrc)
        write(u6,*)
        write(u6,*) 'ConR'
        write(u6,'(30I3)') (ConR(1,i),i=1,nCntrc)
        write(u6,'(30I3)') (ConR(2,i),i=1,nCntrc)
#       endif

      else

        ! Let us put in an empty shell!

        nk = 0
        nl = 0
        nCntrc = 0
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Work on the PRIMITIVE products!
      !
      ! Here the work is trivial in case of the aCD basis
      !                                                                *
      !*****************************************************************
      !                                                                *
      if (Found) then
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Produce the SLIM primitive products
        !                                                              *
        !***************************************************************
        !                                                              *
        if (Do_acCD_Basis) then

          ! Now figure out how many and which!

          npk = Shells(kShll)%nExp
          npl = Shells(lShll)%nExp
          if (Diagonal) then
            nPrim_Max = nTri_Elem(npk)
          else
            nPrim_Max = npk*npl
          end if
#         ifdef _DEBUGPRINT_
          write(u6,*) 'nPrim_Max:',nPrim_Max
#         endif
          call mma_allocate(Prm,nPrim_Max,label='Prm')
          Prm(:) = 0

          ! Pick up the diagonal elements from TInt_p
          ! corresponding to this shell pair. We sum over
          ! the angular parts identical to those of the contracted.

          ! First make a list from the contracted which angular products to include.

          call mma_allocate(TP,nPrim_Max**2,label='TP')
          call mma_allocate(LTP,2,nPrim_Max,label='LTP')
          call Mk_TInt_P(TInt_p,nTheta_All,TP,nPrim_Max,iList2_p,nTheta_All,2*mData,iAng,jAng,npk,LTP)

#         ifdef _DEBUGPRINT_
          call RecPrt('TIntP','(5G20.10)',TP,nPrim_Max,nPrim_Max)
          call iVcPrt('List_TP',' ',LTP,2*nPrim_Max)
#         endif
          ! Let us now decompose and retrieve the most
          ! important primitive products, indicies stored in iD_p

          call mma_allocate(iD_p,nPrim_Max,label='iD_p')
          call mma_allocate(Vec,nPrim_Max**2,label='Vec')

          Thrshld_CD_p = Thr_aCD*0.2_wp
          do
            call CD_InCore_p(TP,nPrim_Max,Vec,nPrim_Max,iD_p,NumCho_p,Thrshld_CD_p,iRC)
            if (NumCho_p < 1) then
              call WarningMessage(2,'Error in Mk_RICD_Shells')
              write(u6,*) 'Mk_aCD_Shells: NumCho_p < 1 is illegal!'
              write(u6,*) 'iAng,jAng=',iAng,jAng
              write(u6,*) 'nPrim_Max=',nPrim_Max
              write(u6,*) 'NumCho_p=',NumCho_p
              write(u6,*) 'iRC=',iRC
              call Abend()
            end if

#           ifdef _DEBUGPRINT_
            write(u6,*) 'Thrshld_CD_p:',Thrshld_CD_p
            write(u6,*) 'NumCho_p    :',NumCho_p
            call iVcPrt('iD_p',' ',iD_p,NumCho_p)
            call RecPrt('Vec',' ',Vec,nPrim_Max,NumCho_p)
#           endif
            if (NumCho_p >= nCntrc) exit
            write(u6,*) 'W a r n i n g!'
            write(u6,*) 'Fewer primitive functions than contracted functions!'
            write(u6,*) 'NumCho_p=',NumCho_p
            write(u6,*) '  nCntrc=',nCntrc
            Thrshld_CD_p = Thrshld_CD_p*Half
            if (Thrshld_CD_p <= 1.0e-14_wp) then
              call WarningMessage(2,'Error in Mk_RICD_Shells')
              write(u6,*) 'Thrshld_CD_p is too low!'
              write(u6,*) 'iAng, jAng:',iAng,jAng
              call Abend()
            end if
            call Mk_TInt_P(TInt_p,nTheta_All,TP,nPrim_Max,iList2_p,nTheta_All,2*mData,iAng,jAng,npk,LTP)
          end do
          call mma_deallocate(TP)
          call mma_deallocate(Vec)

          do iCho_p=1,NumCho_p
            ijSO = iD_p(iCho_p)
            Prm(ijSO) = 1
          end do
          nPrim = NumCho_p
          call mma_allocate(Shells(iShll)%Exp,nPrim,Label='ExpacCD')
          Shells(iShll)%nExp = nPrim

#         ifdef _DEBUGPRINT_
          write(u6,*) 'nPrim=',nPrim
          call iVcPrt('Prm',' ',Prm,nPrim_Max)
#         endif
          call mma_allocate(Indkl_p,nPrim_Max,label='Indkl_p')
          call Mk_Indkl(Prm,Indkl_p,nPrim_Max)

          ! Observe that the exponents are ordered according
          ! to their importance as given by the CD.

          do iCho_p=1,NumCho_p
            iTheta = iD_p(iCho_p)
            ik = LTP(1,iTheta)
            il = LTP(2,iTheta)
            Exp_i = Shells(kShll)%Exp(ik)
            Exp_j = Shells(lShll)%Exp(il)
            Shells(iShll)%Exp(iCho_p) = Exp_i+Exp_j
          end do
#         ifdef _DEBUGPRINT_
          call RecPrt('SLIM Exponents',' ',Shells(iShll)%Exp,1,nPrim)
#         endif
          !                                                            *
          !*************************************************************
          !                                                            *
        else ! Do_aCD_Basis
          !                                                            *
          !*************************************************************
          !                                                            *
          ! Put in the aCD set of exponents, i.e. all unique sums.

          nExpk = Shells(kShll)%nExp
          nExpl = Shells(lShll)%nExp
          if (Diagonal) then
            nPrim = nTri_Elem(nExpk)
          else
            nPrim = nExpk*nExpl
          end if
          call mma_allocate(Shells(iShll)%Exp,nPrim,Label='ExpaCD')
          Shells(iShll)%nExp = nPrim

          iOff = 0
          do ip_Exp=1,nExpk
            jp_Exp_Max = nExpl
            if (Diagonal) jp_Exp_Max = ip_Exp
            do jp_Exp=1,jp_Exp_Max
              iOff = iOff+1
              Shells(iShll)%Exp(iOff) = Shells(kShll)%Exp(ip_Exp)+Shells(lShll)%Exp(jp_Exp)
            end do
          end do

          if (iOff /= nPrim) then
            call WarningMessage(2,'Error in Mk_RICD_Shells')
            write(u6,*) 'Mk_aCD_Shell: iOff /= iEnd'
            call Abend()
          end if

#         ifdef _DEBUGPRINT_
          if (Diagonal) then
            call TriPrt('aCD Exponents',' ',Shells(iShll)%Exp,nExpk)
          else
            call RecPrt('aCD Exponents',' ',Shells(iShll)%Exp,nExpk,nExpl)
          end if
#         endif
        end if

      else
        !                                                              *
        !***************************************************************
        !                                                              *
        ! An empty shell

        nPrim = 0
        Shells(iShll)%nExp = nPrim
        !                                                              *
        !***************************************************************
        !                                                              *
      end if ! Found
      !
      !*****************************************************************
      !
      lAng = iAng+jAng
      S%iAngMx = max(S%iAngMx,lAng)
      S%MaxPrm(lAng) = max(S%MaxPrm(lAng),nPrim)

#     ifdef _DEBUGPRINT_
      write(u6,*)
      write(u6,*) 'iShll=',iShll
      write(u6,*) 'nPrim,nCntrc=',nPrim,nCntrc
      write(u6,*) 'lAng=',lAng
      write(u6,*) 'S%MaxPrm(lAng)=',S%MaxPrm(lAng)
#     endif

      Shells(iShll)%nBasis_c = nCntrc
      !                                                                *
      !*****************************************************************
      !                                                                *
      call mma_allocate(Shells(iShll)%Cff_c,nPrim,nCntrc,2,Label='Cff_c')
      call mma_allocate(Shells(iShll)%pCff,nPrim,nCntrc,Label='pCff')
      Shells(iShll)%nBasis = nCntrc
      call mma_allocate(Shells(iShll)%Cff_p,nPrim,nPrim,2,Label='Cff_p')
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! C O N T R A C T I O N    C O E F F I C I E N T S

      if (Found) then
        !                                                              *
        !***************************************************************
        !                                                              *
        ! For SLIM basis sets
        !                                                              *
        !***************************************************************
        !                                                              *
        if (Do_acCD_Basis) then

          ! Alright this is a bit more elaborate than for
          ! the aCD basis set. Surprise!

          ! Some care has to be taken here. There might be
          ! different angular products, for example, px*px
          ! and px*py, which carry the same radial part but
          ! have different angular part! To overcome this
          ! possible source of redundancy we use the sum of
          ! such terms in the fitting procedure!

          nTheta = nPrim
          nExpk = Shells(kShll)%nExp
          nExpl = Shells(lShll)%nExp
          if (iAng == jAng) then
            nTheta_Full = nTri_Elem(nExpk)
          else
            nTheta_Full = nExpk*nExpl
          end if
          nPhi = nCntrc

          ! Generate the (theta'|V|theta') matrix in the
          ! SLIM primitive product basis.

          call mma_allocate(tVt,nTheta**2,label='tVt')
          call Mk_tVt(TInt_p,nTInt_p,tVt,nTheta,iList2_p,2*mData,Prm,nPrim_Max,iAng,jAng,nExpk,Indkl_p,nPrim_Max)

#         ifdef _DEBUGPRINT_
          write(u6,*)
          write(u6,*) 'tVt(Diag)'
          write(u6,*) (tVt(i),i=1,nTheta**2,nTheta+1)
          call RecPrt('tVt',' ',tVt,nTheta,nTheta)
          call iVcPrt('iD_p',' ',iD_p,NumCho_p)
#         endif

          ! Generate (theta'|V|theta')^{-1}

          ! Let's do a Cholesky decomposition with pivoting
          ! according to the previous CD.

          nTri = nTri_Elem(nTheta)
          call mma_allocate(Q,nTri,label='Q')
          call mma_allocate(A,nTri,label='A')
          call mma_allocate(Z,nTheta,label='Z')
          do iCho_p=1,NumCho_p
            iTheta_full = iD_p(iCho_p)
            iTheta = Indkl_p(iTheta_full)
            do jCho_p=1,iCho_p
              jTheta_full = iD_p(jCho_p)
              jTheta = Indkl_p(jTheta_full)
              ijT = iTri(iCho_p,jCho_p)
              ijS = (jTheta-1)*nTheta+iTheta
              A(ijT) = tVt(ijS)
            end do
          end do
#         ifdef _DEBUGPRINT_
          call TriPrt('A',' ',A,nTheta)

          call mma_allocate(H,nTri,label='H')
          call mma_allocate(U,nTri,label='U')
          H(:) = A
          U(1:nTheta**2) = Zero
          call dcopy_(nTheta,[One],0,U,nTheta+1)
          call Jacob(H,U,nTheta,nTheta)
          call TriPrt('H','(10G20.10)',H,nTheta)
          call RecPrt('U',' ',U,nTheta,nTheta)
          call mma_deallocate(H)
          call mma_deallocate(U)
#         endif

#         ifdef _DEBUGPRINT_
          call mma_allocate(tVtInv,nTheta**2,label='tVtInv')
          iSing = 0
          Det = Zero
          call MInv(tVt,tVtInv,iSing,Det,nTheta)
          write(u6,*) 'iSing,Det=',iSing,Det
#         endif
          call mma_deallocate(tVt)

          do iTheta=1,nTheta
            iOff_Ak = nTri_Elem(iTheta-1)+1
            iOff_Qk = nTri_Elem(iTheta-1)+1
            Thrs = Thrshld_CD_p
            !Thrs = 1.0e-12_wp
            call Inv_Cho_Factor(A(iOff_Ak),iTheta,A,Q,iTheta,iDum,iDum,Dummy,0,Z,Dummy,Thrs,Q(iOff_Qk),LinDep)
            if (LinDep == 1) then
              call WarningMessage(2,'Error in Mk_RICD_Shells')
              write(u6,*) 'Mk_aCD_Shells: linear dependence found in tVt!'
              write(u6,*) 'Found for vector:',iTheta
              call Abend()
            end if
          end do
          call mma_deallocate(Z)
          call mma_deallocate(A)
#         ifdef _DEBUGPRINT_
          call TriPrt('Q','(9G10.3)',Q,nTheta)
#         endif

          ! Generate the (theta'|V|theta) matrix in the mixed product basis.

          call mma_allocate(tVp,nTheta*nPhi,label='tVp')
          call mma_allocate(tVtF,nTheta*nTheta_Full,label='tVtF')
          call Mk_tVtF(TInt_p,nTInt_p,tVtF,nTheta,iList2_p,2*mData,Prm,nPrim_Max,iAng,jAng,nExpk,Indkl_p,nPrim_Max,nTheta_Full)
#         ifdef _DEBUGPRINT_
          call RecPrt('tVtF',' ',tVtF,nTheta,nTheta_Full)
#         endif

          ! Pick up the contraction coefficients of the aCD
          ! basis set. Be careful what this means in the
          ! case that the shells are identical!

          call mma_allocate(Indkl,nCntrc_Max,label='Indkl')
          call Mk_Indkl(Con,Indkl,nCntrc_Max)
          call mma_allocate(C,nTheta_Full*nPhi,label='C')
          call Mk_Coeffs(Shells(kShll)%Cff_c(1,1,1),nExpk,Shells(kShll)%nBasis_C,Shells(lShll)%Cff_c(1,1,1),nExpl, &
                         Shells(lShll)%nBasis_C,C,nTheta_Full,nPhi,iD_c,NumCho_c,iList2_c,2*mData,nPhi_All,Indkl,nCntrc_Max, &
                         Shells(kShll)%nBasis_C,iAng,jAng,Shells(kShll)%Cff_p(1,1,1),Shells(lShll)%Cff_p(1,1,1))
          call mma_deallocate(Indkl)
#         ifdef _DEBUGPRINT_
          call RecPrt('C',' ',C,nTheta_Full,nPhi)
#         endif

          ! Generate the (theta'|V|phi') matrix.

          call DGEMM_('N','N',nTheta,nPhi,nTheta_Full,One,tVtF,nTheta,C,nTheta_Full,Zero,tVp,nTheta)
          call mma_deallocate(tVtF)
#         ifdef _DEBUGPRINT_
          call RecPrt('tVp',' ',tVp,nTheta,nPhi)
#         endif
          call mma_deallocate(C)

          ! Generate the contraction coefficients of the
          ! SLIM contracted product basis in terms of the
          ! SLIM primitive product basis as
          ! Sum(nu') (mu'|V|nu')^-1  (nu'|V|i')=C_{mu',i'}

          ! To simplify life I will put the Q matrix into square storage.

          call mma_Allocate(Temp,nTheta**2,label='Temp')
          Temp(:) = Zero
          do iTheta=1,nTheta
            do jTheta=1,iTheta
              ijT = iTri(iTheta,jTheta)
              ijS = (iTheta-1)*nTheta+jTheta
              Temp(ijS) = Q(ijT)
            end do
          end do
          call mma_deallocate(Q)
#         ifdef _DEBUGPRINT_
          call RecPrt('Q',' ',Temp,nTheta,nTheta)
#         endif

          ! Resort the external index back to original
          ! order. The column index is external.

          call mma_allocate(QTmp,nTheta**2,label='QTmp')
          do iCho_p=1,NumCho_p
            iTheta_Full = iD_p(iCho_p)
            iTheta = Indkl_p(iTheta_Full)
            call dcopy_(nTheta,Temp(iCho_p),nTheta,QTmp(iTheta),nTheta)
          end do
          call mma_deallocate(Temp)
#         ifdef _DEBUGPRINT_
          call RecPrt('Q',' ',QTmp,nTheta,nTheta)
          call RecPrt('tVp',' ',tVp,nTheta,nPhi)
#         endif
          ! Q(T) tVp
          call mma_allocate(Scr,nTheta*nPhi,label='Scr')
          Scr(:) = Zero
          call DGEMM_('T','N',nTheta,nPhi,nTheta,One,QTmp,nTheta,tVp,nTheta,Zero,Scr,nTheta)
          ! QQ(T) tVp
          call DGEMM_('N','N',nTheta,nPhi,nTheta,One,QTmp,nTheta,Scr,nTheta,Zero,Shells(iShll)%Cff_c(1,1,1),nTheta)
#         ifdef _DEBUGPRINT_
          call RecPrt('SLIM coeffcients',' ',Shells(iShll)%Cff_c(1,1,1),nTheta,nPhi)
          Scr(:) = Zero
          call DGEMM_('N','N',nTheta,nPhi,nTheta,One,tVtInv,nTheta,tVp,nTheta,Zero,Scr,nTheta)
          call RecPrt('SLIM coeffcients2',' ',Scr,nTheta,nPhi)
          call mma_deallocate(tVtInv)
#         endif
          call mma_deallocate(tVp)

          ! Now reorder the coefficients to the CD order of the exponents.

          call mma_allocate(Tmp,nTheta*nPhi,label='Tmp')
          call dcopy_(nTheta*nPhi,Shells(iShll)%Cff_c(:,:,1),1,Tmp,1)
          do iCho_p=1,NumCho_p
            iTheta_full = iD_p(iCho_p)
            iTheta = Indkl_p(iTheta_full)
            call dcopy_(nPhi,Tmp(iTheta),nTheta,Shells(iShll)%Cff_c(iCho_p,1,1),nTheta)
          end do
          call mma_deallocate(Tmp)

          ! Modify from coefficients for normalized
          ! Gaussians to unnormalized Gaussians.

          do iCho_p=1,NumCho_p
            iTheta = iD_p(iCho_p)
            ik = LTP(1,iTheta)
            il = LTP(2,iTheta)
            Fact = Shells(kShll)%Cff_p(ik,ik,1)*Shells(lShll)%Cff_p(il,il,1)
            Shells(iShll)%Cff_c(iCho_p,:,1) = Fact*Shells(iShll)%Cff_c(iCho_p,:,1)
          end do
          call mma_deallocate(LTP)

          call mma_deallocate(iD_p)
          call mma_deallocate(Indkl_p)
          call mma_deallocate(Scr)
          call mma_deallocate(QTmp)
#         ifdef _DEBUGPRINT_
          call RecPrt('SLIM coeffcients',' ',Shells(iShll)%Cff_c(:,:,1),nTheta,nPhi)
#         endif
          !                                                            *
          !*************************************************************
          !                                                            *
        else ! Do_aCD_Basis
          !                                                            *
          !*************************************************************
          !                                                            *
          ! Put in the selected set of coeffients. Note
          ! again that the order should be that according
          ! to the CD in order to prepivot, since the CD
          ! itself is implemented without pivoting.

          do iCntrc=1,nCntrc
            kC = ConR(1,iCntrc)
            lC = ConR(2,iCntrc)
#           ifdef _DEBUGPRINT_
            write(u6,*) 'kC,lC=',kC,lC
#           endif
            !                                                          *
            !***********************************************************
            !                                                          *
            ! Form the unnormalized coefficients!

            jkl = 0
            if (Diagonal) then
              do iExp_k=1,Shells(kShll)%nExp

                Coeff_kk = Shells(kShll)%Cff_c(iExp_k,kC,1)
                Coeff_lk = Shells(lShll)%Cff_c(iExp_k,lC,1)

                do iExp_l=1,iExp_k

                  Coeff_ll = Shells(lShll)%Cff_c(iExp_l,lC,1)
                  Coeff_kl = Shells(kShll)%Cff_c(iExp_l,kC,1)
                  Coeff_ = Coeff_ll*Coeff_kk+Coeff_kl*Coeff_lk
                  if (iExp_k == iExp_l) then
                    Coeff_ = Coeff_*Half
                  end if
                  jkl = jkl+1

                  Shells(iShll)%Cff_c(jkl,iCntrc,1) = Coeff_

                end do
              end do
            else
              do iExp_k=1,Shells(kShll)%nExp

                Coeff_k = Shells(kShll)%Cff_c(iExp_k,kC,1)

                do iExp_l=1,Shells(lShll)%nExp

                  Coeff_l = Shells(lShll)%Cff_c(iExp_l,lC,1)

                  Coeff_kl = Coeff_l*Coeff_k

                  jkl = jkl+1
                  Shells(iShll)%Cff_c(jkl,iCntrc,1) = Coeff_kl
                end do
              end do
            end if

          end do ! iCntrc
#         ifdef _DEBUGPRINT_
          call RecPrt('aCD Coefficients','(6G20.12)',Shells(iShll)%Cff_c(1,1,1),nPrim,nCntrc)
#         endif
          !                                                            *
          !*************************************************************
          !                                                            *
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        Shells(iShll)%Cff_c(:,:,2) = Shells(iShll)%Cff_c(:,:,1)

        call mma_deallocate(Con)
        call mma_deallocate(ConR)
        if (Do_acCD_Basis) call mma_deallocate(Prm)

        ! Put in unit matrix of uncontracted set

        Shells(iShll)%Cff_p(:,:,1) = Zero
        do i=1,nPrim
          Shells(iShll)%Cff_p(i,i,1) = One
        end do

        Shells(iShll)%Cff_p(:,:,2) = Shells(iShll)%Cff_p(:,:,1)
        call Nrmlz(Shells(iShll)%Exp,nPrim,Shells(iShll)%Cff_p(1,1,1),nPrim,lAng)
#       ifdef _DEBUGPRINT_
        call RecPrt('uncon1',' ',Shells(iShll)%Cff_p(:,:,1),nPrim,nPrim)
        call RecPrt('uncon2',' ',Shells(iShll)%Cff_p(:,:,2),nPrim,nPrim)
#       endif

        ! OK let's do the correction now!

#       ifdef _DEBUGPRINT_
        call RecPrt('Coefficients 10',' ',Shells(iShll)%Cff_c(:,:,1),nPrim,nCntrc)
        iOff = nPrim*nCntrc
        call RecPrt('Coefficients 20',' ',Shells(iShll)%Cff_c(:,:,2),nPrim,nCntrc)
#       endif
        iOff = nPrim*nCntrc
        call Fix_Coeff(nPrim,nCntrc,Shells(iShll)%Cff_c(:,:,2),Shells(iShll)%Cff_p(:,:,1),'F')
#       ifdef _DEBUGPRINT_
        call RecPrt('Coefficients 1',' ',Shells(iShll)%Cff_c(:,:,1),nPrim,nCntrc)
        iOff = nPrim*nCntrc
        call RecPrt('Coefficients 2','(6G20.13)',Shells(iShll)%Cff_c(:,:,2),nPrim,nCntrc)
#       endif

        ! Now remove any primitives with all zero coefficents!

        call Fix_Exponents(nPrim,mPrim,nCntrc,Shells(iShll)%Exp,Shells(iShll)%Cff_c,Shells(iShll)%Cff_p)
        nPrim = mPrim
        Shells(iShll)%nExp = nPrim
#       ifdef _DEBUGPRINT_
        call RecPrt('Coefficients 1',' ',Shells(iShll)%Cff_c(:,:,1),nPrim,nCntrc)
        iOff = nPrim*nCntrc
        call RecPrt('Coefficients 2',' ',Shells(iShll)%Cff_c(:,:,2),nPrim,nCntrc)
#       endif
      end if

      Shells(iShll)%nBasis = Shells(iShll)%nBasis_c
      if ((jAng == 0) .and. Found) then
        Shells(iShll)%Transf = Shells(kShll)%Transf
        Shells(iShll)%Prjct = Shells(kShll)%Prjct
      else
        Shells(iShll)%Transf = .true.
        Shells(iShll)%Prjct = .false.
      end if
      Shells(iShll)%Aux = .true.

      if (Do_acCD_Basis .and. Found) then
        call mma_deallocate(iList2_p)
        call mma_deallocate(TInt_p)
      end if
      Shells(iShll)%pCff(:,:) = Shells(iShll)%Cff_c(:,:,1)

    end do ! jAng
  end do ! iAng

  dbsc(nCnttp)%nVal = iShll-jShll
  dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal
  !                                                                    *
  !*********************************************************************
  !*********************************************************************
  !*********************************************************************
  !                                                                    *
  if (Keep_Basis) then
    if (Show .and. (nPrint(2) >= 6)) then
      write(u6,*)
      write(u6,*)
      write(u6,'(1X,A,I5,A,A)') 'Basis Set ',nCnttp,' Label: ',BSLbl(1:Indx-1)
      write(u6,'(1X,A)') 'On-the-fly basis set generation'
    end if

    ! Transfer the coordinate information

    nCnt = dbsc(iCnttp)%nCntr
    dbsc(nCnttp)%nCntr = nCnt
    dbsc(nCnttp)%mdci = mdc
    ! Create a pointer to the actual coordinates
    dbsc(nCnttp)%Coor => dbsc(iCnttp)%Coor(1:3,1:nCnt)

    ! Compute the number of elements stored in the dynamic memory so far.
    S%Mx_Shll = iShll+1
    Max_Shells = S%Mx_Shll
    S%Mx_mdc = mdc

  else

    ! If all the shells are empty, skip the whole basis set!

    nCnttp = nCnttp-1
  end if

end do   ! iBS

! Done for this valence basis set.

S%Mx_Shll = iShll+1
Max_Shells = S%Mx_Shll
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate

call mma_deallocate(iD_c)
call mma_deallocate(iList2_c)
!                                                                      *
!***********************************************************************
!                                                                      *
! Let us now Gram-Schmidt orthonormalize the auxiliary basis for
! better numerics and balance.

do jCnttp=nCnttp_start+1,nCnttp
  call Renorm2(jCnttp)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Optionally add auxiliary basis set to the end of the
! temporary auxiliary basis set library.

if (W2L) then
  Lu_lib = 17
  Lu_lib = IsFreeUnit(Lu_lib)
  call molcas_open(Lu_lib,'RICDLIB')
  rewind(Lu_lib)
  istatus = 0
  do while (istatus == 0)
    read(Lu_lib,*,iostat=istatus)
  end do
  backspace(Lu_lib)

  do jCnttp=nCnttp_start+1,nCnttp
    if (jCnttp == nCnttp_start+1) then
      write(Lu_lib,'(A)') '/'//Label
    else
      write(Lu_lib,'(A)') Label
    end if
    if (jCnttp == nCnttp_start+1) then
      write(Lu_lib,'(F6.2,2I10)') dbsc(jCnttp)%Charge,dbsc(jCnttp)%nVal-1,nCnttp-nCnttp_start
    else
      write(Lu_lib,'(F6.2, I10)') dbsc(jCnttp)%Charge,dbsc(jCnttp)%nVal-1
    end if
    write(Lu_lib,*) ' Dummy reference line.'
    write(Lu_lib,*) ' Dummy reference line.'
    do iAng=0,dbsc(jCnttp)%nVal-1
      iShll_ = dbsc(jCnttp)%iVal+iAng
      nExpi = Shells(iShll_)%nExp
      iSph = 0
      if (Shells(iShll_)%Prjct) iSph = 1
      if (Shells(iShll_)%Transf) iSph = iSph+2
      write(Lu_lib,'(3I10)') nExpi,Shells(iShll_)%nBasis,iSph

      ! Skip if the shell is empty.

      if (nExpi == 0) cycle

      ! Write out the exponents

      write(Lu_lib,'(5(1X,D20.13))') (Shells(iShll_)%Exp(i),i=1,nExpi)

      ! Write out the contraction coefficients

      do i=1,nExpi
        write(Lu_lib,'(5(1X,D20.13))') (Shells(iShll_)%Cff_c(i,j,1),j=1,Shells(iShll_)%nBasis)
      end do

    end do
  end do
  close(Lu_lib)
end if

call SOAO_Info_Free()
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Mk_aCD_acCD_Shells

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FOCK(F,BM,FI,FP,D,P,Q,FINT,IFINAL,CMO)
C
C     RASSCF program version IBM-3090: SX section
c
******************************************************************************
*   BM    : output
*   F     : used only in this routine
*   Q     : used only in this routine
*   FP    : in Input it is the FA matrix in MO. in Output it is FI + FA in MO.
*   FI    : input. FI in MO basis
*   D     : input. Active 1RDM in MO basis
*   P     : input. Active 2RDM in MO basis
*   FINT  : input. Active two-electron integrals in MO basis.
*   IFINAL: input
*   CMO   : input
******************************************************************************
c     Calculation of the MCSCF fock matrix F(eq.(7) in I.J.Q.C.S14,175)
c     FP is the matrix FI+FA (FP is FA at entrance)
c     F is stored as a symmetry blocked square matrix, by columns.
c     Note that F contains all elements, also the zero elements
c     occurring when the first index is secondary.
c     F is used to construct the Brillouin elements and the first row
c     of the super-CI Hamiltonian, while FP is used as the effective
c     one-electron operator in the construction of the super-CI
c     interaction matrix.
c
C          ********** IBM-3090 MOLCAS Release: 90 02 22 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FI(*),FP(*),D(*),P(*),Q(*),FINT(*),F(*),BM(*),CMO(*)
      integer ISTSQ(8),ISTAV(8)
      real*8 ECAS0

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='FOCK    ')
#include "WrkSpc.fh"
      Logical DoActive,DoQmat,DoCholesky
      Integer ALGO
      Dimension P2reo(1)

      COMMON /CHOTODO /DoActive,DoQmat,ipQmat
      COMMON /CHLCAS  /DoCholesky,ALGO
C
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF

      ISTSQ(1)=0
      ISTAV(1)=0
      DO iSym=2,nSym
         ISTSQ(iSym) = ISTSQ(iSym-1) + nBas(iSym-1)**2
         ISTAV(iSym) = ISTAV(iSym-1) + nBas(iSym-1)*nAsh(iSym-1)
      End Do

      ipFint = ip_Dummy
      ipP2reo= ip_Dummy
      If(KSDFT(1:3).ne.'SCF'.and.
     &         DFTFOCK(1:4).eq.'DIFF'.and.
     &         nac.ne.0) Then
        Call GetMem('TmpPUVX','Allo','Real',ipFint,nFint)
        Call Get_dArray('DFT_TwoEl',Work(ipFint),nFint)
        HALFQ=0.0d0
        HALFQ1=0.0d0
        If(Exfac.ne.1.0d0) Then
          Call Get_Temp('nP2reo  ',P2reo,1)
          nP2reo=Int(P2reo(1))
          CALL GETMEM('P2_reo','ALLO','REAL',ipP2reo,nP2reo)
          Call Get_Temp('P2_reo  ',Work(ipP2reo),nP2reo)
        End If
      End If

*********************************************************************************
* add FI to FA to obtain FP
*********************************************************************************
      CALL DAXPY_(NTOT3,1.0D0,FI,1,FP,1)

*********************************************************************************
* Loop over symmetry blocks
*********************************************************************************
      ISTFCK=0
      ISTFP=0
      ISTD=0
      ISTBM=0
      IX1=0
      ISTZ=0
      ioffQmat=0
      E2act=0.0d0

      DO ISYM=1,NSYM
       IX=IX1+NFRO(ISYM)
       NIO=NISH(ISYM)
       NAO=NASH(ISYM)
       NEO=NSSH(ISYM)
       NIA=NIO+NAO
       NO=NORB(ISYM)
       NO2=(NO**2+NO)/2
       CSX=0.0D0
       N1=0
       N2=0

* If no orbitals in this symmetry block go to next symm
       IF(NO.EQ.0) GO TO 90

*************************
* clear F_gen matrix
*************************
       CALL FZERO(F(ISTFCK+1),NO**2)

*********************************************************************************
* first index in F is inactive: F_gen is twice FP=FI+FA (Eq.10.8.27 MEST)
*********************************************************************************
       IF(NIO.NE.0) THEN
        DO NP=1,NO
         DO NI=1,NIO
          N1=MAX(NP,NI)
          N2=MIN(NP,NI)
          F(ISTFCK+NO*(NP-1)+NI)=2*FP(ISTFP+(N1**2-N1)/2+N2)
         END DO
        END DO
       ENDIF

*********************************************************************************
* first index in F active
*********************************************************************************
       IF(NAO.NE.0) THEN
        ISTP=ISTORP(ISYM)+1
        JSTF=ISTORD(ISYM)+1
        NUVX=(ISTORP(ISYM+1)-ISTORP(ISYM))/NAO

        If (.not.DoCholesky .or. ALGO.eq.1) Then
*********************************************************************************
* Compute the Q-matrix (Eq. (19) in IJQC S14 175 1980 or Eq. 10.8.31 MEST)
* Q(m,v) = sum_wxy  (m|wxy) * P(wxy,v)
* P is packed in xy and pre-multiplied by 2 and reordered
*********************************************************************************
           IF(IPRLEV.ge.DEBUG) THEN
             write(6,*) 'PUVX integrals in FOCK'
             call wrtmat(FINT(JSTF),NO,NUVX,NO,NUVX)
             write(6,*) 'two-elec density mat OR DMAT*DMAT in FOCK'
             call wrtmat(P(ISTP),NAO,NUVX,NAO,NUVX)
           END IF

           CALL DGEMM_('N','N',
     &                 NO,NAO,NUVX,
     &                 1.0d0,FINT(JSTF),NO,
     &                 P(ISTP),NUVX,
     &                 0.0d0,Q,NO)

        ElseIf (ALGO.eq.2) Then
*********************************************************************************
c --- the Q-matrix has been already computed as Q(a,v)
c --- where a is an AO index and v is an active index
c --- Transform the 1st index to MOs (one symmetry at the time)
c --- Q(m,v) = C(a,m) * Q(a,v)
*********************************************************************************
          ipQS = ipQmat + ISTAV(iSym)
          ipMOs= 1 + ISTSQ(iSym) + nBas(iSym)*nFro(iSym)

          CALL DGEMM_('T','N',nOrb(iSym),nAsh(iSym),nBas(iSym),
     &               1.0d0,CMO(ipMOs),nBas(iSym),
     &               Work(ipQS),nBas(iSym),
     &               0.0d0,Q(1),nOrb(iSym))
        Else
          Write(LF,*)'FOCK: illegal Cholesky parameter ALGO= ',ALGO
          call abend()
        EndIf

        IF(IPRLEV.ge.DEBUG) THEN
          call recprt('Q-mat in fock.f',' ',Q(1),NO,NAO)
        END IF

*********************************************************************************
* active-active interaction energy term in the RASSCF energy: trace of Q
*********************************************************************************
        ECAS0=ECAS
        DO NT=1,NAO
         NTT=(NT-1)*NO+NIO+NT
         ECAS=ECAS+0.5D0*Q(NTT)
         HALFQ1=HALFQ1+0.5D0*Q(NTT)
         E2act=E2act+0.5D0*Q(NTT)
        END DO
        IF(IPRLEV.ge.DEBUG) THEN
          write(6,*) 'Two-electron contribution (Q term):', ECAS-ECAS0
          write(6,*) 'ECAS aft adding Q in fock.f :', ECAS
        END IF

*********************************************************************************
* Is this relevant?
          If(ipFint.ne.ip_Dummy) Then
            Call GetMem('TmpQ','Allo','Real',ipQ,NAO*NO)
            If (ipP2reo.ne.ip_Dummy) Then
               CALL DGEMM_('N','N',
     &                     NO,NAO,NUVX,
     &                     1.0d0,Work(ipFint+JSTF-1),NO,
     &                     Work(ipP2reo+ISTP-1),NUVX,
     &                     0.0d0,Work(ipQ),NO)
            Else
               CALL DGEMM_('N','N',
     &                     NO,NAO,NUVX,
     &                     1.0d0,Work(ipFint+JSTF-1),NO,
     &                     P(ISTP),NUVX,
     &                     0.0d0,Work(ipQ),NO)
            End If
            Call DaXpY_(NAO*NO,1.0d0,Work(ipQ),1,Q,1)
*
            DO NT=1,NAO
              NTT=(NT-1)*NO+NIO+NT
              HALFQ=HALFQ+0.5D0*Work(ipQ+NTT-1)
            END DO
            Call GetMem('TmpQ','Free','Real',ipQ,NAO*NO)
          End If

*********************************************************************************
* Continue... Fock matrix for first index active
*********************************************************************************
          NTM=0
          DO NT=1,NAO
           DO NM=1,NO
            NTM=NTM+1
            QNTM=Q(NTM)
            DO NV=1,NAO
             NVI=NV+NIO
             NTV=ITRI(MAX(NT,NV))+MIN(NT,NV)+ISTD
             NVM=ITRI(MAX(NVI,NM))+MIN(NVI,NM)+ISTFP
             QNTM=QNTM+D(NTV)*FI(NVM)
            END DO
            F(ISTFCK+NO*(NM-1)+NT+NIO)=QNTM
           END DO
          END DO

       ENDIF
*********************************************************************************
*      ^ End if related to first index in F active
*********************************************************************************

*********************************************************************************
*       The Brillouin matrix BM(pq)=F(qp)-F(pq)
*********************************************************************************
       NPQ=ISTBM
       DO NP=NIO+1,NO
        DO NQ=1,NIA
         NPQ=NPQ+1
         BM(NPQ)=F(ISTFCK+NO*(NP-1)+NQ)-F(ISTFCK+NO*(NQ-1)+NP)
c
c        Set zeroes to BM elements corresponding to rotations not allowed
c        as controlled by the array IZROT.
c
         IF(NP.LE.NIA.AND.NQ.GT.NIO) THEN
          NT=NP-NIO
          NU=NQ-NIO
          IF(NT.LE.NU) THEN
           BM(NPQ)=0.0D0
          ELSE
           NTU=ISTZ+ITRI(NT-1)+NU
           IF(IZROT(NTU).NE.0) THEN
            BM(NPQ)=0.0D0
C            Write(LF,*)'FOCK: IZROT=1 so BLB=0 for NP,NQ=',NP,NQ
           END IF
           IF(IXSYM(IX+NP).NE.IXSYM(IX+NQ)) THEN
            BM(NPQ)=0.0D0
C            Write(LF,*)'FOCK: IXSYM=1 so BLB=0 for NP,NQ=',NP,NQ
           END IF
          ENDIF
         ENDIF
c
c        check for largest Brillouin matrix element
c
         IF(ABS(BM(NPQ)).LT.ABS(CSX)) GO TO 20
         IF(IXSYM(IX+NP).NE.IXSYM(IX+NQ)) GO TO 20
         CSX=BM(NPQ)
         N1=NQ+NFRO(ISYM)
         N2=NP+NFRO(ISYM)
 20      CONTINUE
        END DO
       END DO
c
90     CONTINUE
       ISTFCK=ISTFCK+NO**2
       ISTFP=ISTFP+NO2
       ISTD=ISTD+(NAO**2+NAO)/2
       ISTBM=ISTBM+(NIO+NAO)*(NAO+NEO)
       IX1=IX1+NBAS(ISYM)
       ISTZ=ISTZ+(NAO**2-NAO)/2
       CBLB(ISYM)=CSX
       IBLB(ISYM)=N1
       JBLB(ISYM)=N2
      END DO
*********************************************************************************
*     ^ End of long loop over symmetry
*********************************************************************************

      If ( iPrLev.ge.DEBUG ) then
        CASDFT_En=0.0d0
        If(KSDFT(1:3).ne.'SCF'.and.KSDFT(1:3).ne.'PAM')
     &   Call Get_dScalar('CASDFT energy',CASDFT_En)
        Write(LF,'(A,2F22.16)') ' RASSCF energy: ',
     &                  ECAS+CASDFT_En,VIA_DFT
      End If
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,'(A)')' MCSCF Fock-matrix in MO-basis'
        ipFMCSCF=1
        Do iSym=1,nSym
           nOr=nOrb(iSym)
           Call RecPrt(' ',' ',F(ipFMCSCF),nOr,nOr)
           ipFMCSCF=ipFMCSCF+nOr*nOr
        End Do
      End If
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,'(A)')' Brillouin matrix'
        ipBM=1
        Do iSym=1,nSym
           nIs=nIsh(iSym)
           nAs=nAsh(iSym)
           nSs=nSsh(iSym)
           Call RecPrt(' ',' ',BM(ipBM),(nAs+nIs),(nAs+nSs))
           ipBM=ipBM+(nAs+nIs)*(nAs+nSs)
        End Do
      End If
C
C     Maximum BLB matrix element all symmetries
C
      CBLBM=0.0D0
      ISYMBB=0
      DO ISYM=1,NSYM
       IF(ABS(CBLB(ISYM)).LT.ABS(CBLBM)) GO TO 150
       CBLBM=CBLB(ISYM)
       IBLBM=IBLB(ISYM)
       JBLBM=JBLB(ISYM)
       ISYMBB=ISYM
 150   CONTINUE
      END DO

*********************************************************************************
*     Calculate Fock matrix for occupied orbitals.
*********************************************************************************
      If (iFinal.eq.1) CALL FOCKOC(F,CMO)
C
      If(ipFint.ne.ip_Dummy) Then
        Call GetMem('TmpPUVX','Free','Real',ipFint,nFint)
      End If

      If(ipP2reo.ne.ip_Dummy) Then
        CALL GETMEM('P2_reo','FREE','REAL',ipP2reo,nP2reo)
      End If

      If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' >>> Exit Fock <<< '
         Write(LF,*)
      End If
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DEALLOC_LUCIA
* Deallocate memory allocated during alloc_lucia

*. Input
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
#include "lucinp.fh"
#include "orbinp.fh"
#include "cstate.fh"
#include "csm.fh"
#include "crun.fh"
#include "cprnt.fh"
#include "cicisp.fh"
*.CSMPRD
      INTEGER ADASX,ASXAD,ADSXA,SXSXDX,SXDXSX
      COMMON/CSMPRD/ADASX(MXPOBS,MXPOBS),ASXAD(MXPOBS,2*MXPOBS),
     &              ADSXA(MXPOBS,2*MXPOBS),
     &              SXSXDX(2*MXPOBS,2*MXPOBS),SXDXSX(2*MXPOBS,4*MXPOBS)
#include "cintfo.fh"
#include "rasscf_lucia.fh"
*.Output
#include "glbbas.fh"

*.1 : One electron integrals( Complete matrix allocated )
      CALL GETMEM('INT1  ','FREE','REAL',KINT1,NTOOB ** 2)
*. A copy of the original UNMODIFIED 1-elecs ints
      CALL GETMEM('INT1O ','FREE','REAL',KINT1O,NTOOB ** 2)
*.1.1 : Inactive fock matrix
      CALL GETMEM('FI    ','FREE','REAL',KFI  ,NTOOB ** 2)
      CALL GETMEM('FIO   ','FREE','REAL',KFIO ,NTOOB ** 2)
*.1.2 Inactive Fock matrx in zero order space
      CALL GETMEM('FIZ    ','FREE','REAL',KFIZ,NTOOB **2)
*.2 : Two electron integrals
*. Pointers to symmetry block of integrals
      CALL GETMEM('PINT1 ','FREE','INTE',KPINT1,NBINT1)
      CALL GETMEM('PINT2 ','FREE','INTE',KPINT2,NBINT2)
*. Pointers to nonsymmetric one-electron integrals
      DO ISM = 1, NSMOB
*. triangular packed
        CALL GETMEM('PGINT1','FREE','INTE',KPGINT1(ISM),NSMOB)
*. no packing
        CALL GETMEM('PGIN1A','FREE','INTE',KPGINT1A(ISM),NSMOB)
      END DO
*. Symmetry of last index as a function of initial index
      CALL GETMEM('LSM1   ','FREE','INTE',KLSM1,NBINT1)
      CALL GETMEM('LSM2   ','FREE','INTE',KLSM2,NBINT2)
*.3 One-body density
      CALL GETMEM('RHO1  ','FREE','REAL',KRHO1,NTOOB ** 2)
*.3.1 : One-body spin density
      CALL GETMEM('SRHO1 ','FREE','REAL',KSRHO1,NTOOB **2)
*. indices for pair of orbitals symmetry ordered
*. Lower half packed
      CALL GETMEM('KINH1  ','FREE','INTE',KINH1,NTOOB*NTOOB)
*. Complete form
      CALL GETMEM('KINH1  ','FREE','INTE',KINH1_NOCCSYM,NTOOB*NTOOB)

* arrays allocated at end of lucia
      LBLOCK = MXSOOB
      LBLOCK = MAX(LBLOCK,LCSBLK)
      LBLOCK = MAX(INT(XISPSM(IREFSM,1)),MXSOOB)
      IF(PSSIGN.NE.0.0D0) LBLOCK = INT(2.0D0*XISPSM(IREFSM,1))
      CALL GETMEM('VEC1  ','FREE','REAL',KCI_POINTER,LBLOCK)
      CALL GETMEM('VEC2  ','FREE','REAL',KSIGMA_POINTER,LBLOCK)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************
!  ElPointPot
!
!> @brief
!>   Evaluate the electric potential from point multipoles in a given point
!> @author A. Ohrn
!>
!> @param[in] rinv Inverse distance between multipole and point where the electric potential is to be computed
!> @param[in] x    \f$ x \f$-coordinate for vector between the two relevant points
!> @param[in] y    \f$ y \f$-coordinate of the same vector
!> @param[in] z    \f$ z \f$-coordinate of the same vector
!> @param[in] L    Angular momentum of the multipole, \p L = ``0`` charge, \p L = ``1`` dipole, etc.
!> @param[in] D    The components of the multipole, ordered in the usual Molcas fashion. Should not be in Buckingham form,
!>                 rather as pure moments
!>
!> @return The electric potential
!***********************************************************************

function ElPointPot(rinv,x,y,z,L,D)

use Constants, only: Zero, Two, Three, Four, Six, Nine, Twelve
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: ElPointPot
integer(kind=iwp), intent(in) :: L
real(kind=wp), intent(in) :: rinv, x, y, z, D((L+1)*(L+2)/2)
real(kind=wp) :: Pot, r3, r5, r7, r9, r11, x2, x3, x4, x5, y2, y3, y4, y5, z2, z3, z4, z5
real(kind=wp), parameter :: r15 = 15.0_wp, r24 = 24.0_wp, r45 = 45.0_wp, r90 = 90.0_wp, r105 = 105.0_wp, r120 = 120.0_wp, &
                            r225 = 225.0_wp, r315 = 315.0_wp, r630 = 630.0_wp, r945 = 945.0_wp, r1050 = 1050.0_wp

Pot = Zero
r3 = rinv**3
r5 = rinv**5
x2 = x*x
y2 = y*y
z2 = z*z
r7 = rinv**7
x3 = x**3
y3 = y**3
z3 = z**3
r9 = rinv**9
x4 = x**4
y4 = y**4
z4 = z**4
r11 = rinv**11
x5 = x**5
y5 = y**5
z5 = z**5
if (L == 0) then
  Pot = Pot+D(1)*rinv
else if (L == 1) then
  Pot = Pot+D(1)*x*r3
  Pot = Pot+D(2)*y*r3
  Pot = Pot+D(3)*z*r3
else if (L == 2) then
  Pot = Pot+D(1)*(Three*x2*r5-r3)
  Pot = Pot+Two*D(2)*(Three*x*y*r5)
  Pot = Pot+Two*D(3)*(Three*x*z*r5)
  Pot = Pot+D(4)*(Three*y2*r5-r3)
  Pot = Pot+Two*D(5)*(Three*y*z*r5)
  Pot = Pot+D(6)*(Three*z2*r5-r3)
  Pot = Pot/Two
else if (L == 3) then
  Pot = Pot+D(1)*(r15*x3*r7-Nine*x*r5)
  Pot = Pot+Three*D(2)*(r15*x2*y*r7-Three*y*r5)
  Pot = Pot+Three*D(3)*(r15*x2*z*r7-Three*z*r5)
  Pot = Pot+Three*D(4)*(r15*x*y2*r7-Three*x*r5)
  Pot = Pot+Six*D(5)*(r15*x*y*z*r7)
  Pot = Pot+Three*D(6)*(r15*x*z2*r7-Three*x*r5)
  Pot = Pot+D(7)*(r15*y3*r7-Nine*y*r5)
  Pot = Pot+Three*D(8)*(r15*y2*z*r7-Three*z*r5)
  Pot = Pot+Three*D(9)*(r15*y*z2*r7-Three*y*r5)
  Pot = Pot+D(10)*(r15*z3*r7-Nine*z*r5)
  Pot = Pot/Six
else if (L == 4) then
  Pot = Pot+D(1)*(r105*x4*r9-r90*x2*r7+Nine*r5)
  Pot = Pot+D(2)*Four*(r105*x3*y*r9-r45*x*y*r7)
  Pot = Pot+D(3)*Four*(r105*x3*z*r9-r45*x*z*r7)
  Pot = Pot+D(4)*Six*(r105*x2*y2*r9-r15*x2*r7-r15*y2*r7+Three*r5)
  Pot = Pot+D(5)*Twelve*(r105*x2*y*z*r9-r15*y*z*r7)
  Pot = Pot+D(6)*Six*(r105*x2*z2*r9-r15*x2*r7-r15*z2*r7+Three*r5)
  Pot = Pot+D(7)*Four*(r105*x*y3*r9-r45*x*y*r7)
  Pot = Pot+D(8)*Twelve*(r105*x*y2*z*r9-r15*x*z*r7)
  Pot = Pot+D(9)*Twelve*(r105*x*y*z2*r9-r15*x*y*r7)
  Pot = Pot+D(10)*Four*(r105*x*z3*r9-r45*x*z*r7)
  Pot = Pot+D(11)*(r105*y4*r9-r90*y2*r7+Nine*r5)
  Pot = Pot+D(12)*Four*(r105*y3*z*r9-r45*y*z*r7)
  Pot = Pot+D(13)*Six*(r105*y2*z2*r9-r15*z2*r7-r15*y2*r7+Three*r5)
  Pot = Pot+D(14)*Four*(r105*y*z3*r9-r45*y*z*r7)
  Pot = Pot+D(15)*(r105*z4*r9-r90*z2*r7+Nine*r5)
  Pot = Pot/r24
else if (L == 5) then
  Pot = Pot+D(1)*(r945*x5*r11-r1050*x3*r9+r225*x*r7)
  Pot = Pot+D(2)*(r945*x4*y*r11-r630*x2*y*r9+r45*y*r7)
  Pot = Pot+D(3)*(r945*x4*z*r11-r630*x2*z*r9+r45*z*r7)
  Pot = Pot+D(4)*(r945*x3*y2*r11-r315*x*y2*r9-r105*x3*r9+r45*x*r7)
  Pot = Pot+D(5)*(r945*x3*y*z*r11-r315*x*y*z*r9)
  Pot = Pot+D(6)*(r945*x3*z2*r11-r315*x*z2*r9-r105*x3*r9+r45*x*r7)
  Pot = Pot+D(7)*(r945*x2*y3*r11-r315*x2*y*r9-r105*y3*r9+r45*y*r7)
  Pot = Pot+D(8)*(r945*x2*y2*z*r11-r105*y2*z*r9-r105*x2*z*r9+r15*z*r7)
  Pot = Pot+D(9)*(r945*x2*y*z2*r11-r105*z2*y*r9-r105*x2*y*r9+r15*y*r7)
  Pot = Pot+D(10)*(r945*x2*z3*r11-r315*x2*z*r9-r105*z3*r9+r45*z*r7)
  Pot = Pot+D(11)*(r945*x*y4*r11-r630*x*y2*r9+r45*x*r7)
  Pot = Pot+D(12)*(r945*x*y3*z*r11-r315*x*y*z*r9)
  Pot = Pot+D(13)*(r945*x*y2*z2*r11-r105*x*y2*r9-r105*x*z2*r9+r15*x*r7)
  Pot = Pot+D(14)*(r945*x*y*z3*r11-r315*x*y*z*r9)
  Pot = Pot+D(15)*(r945*x*z4*r11-r630*x*z2*r9+r45*x*r7)
  Pot = Pot+D(16)*(r945*y5*r11-r1050*y3*r9+r225*y*r7)
  Pot = Pot+D(17)*(r945*y4*z*r11-r630*y2*z+r45*z*r7)
  Pot = Pot+D(18)*(r945*y3*z2*r11-r315*y*z2*r9-r105*y3*r9+r45*y*r9)
  Pot = Pot+D(19)*(r945*y2*z3*r11-r315*y2*z*r9-r105*z3*r9+r45*z*r9)
  Pot = Pot+D(20)*(r945*y*z4*r11-r630*y*z2*r9+r45*y*r7)
  Pot = Pot+D(21)*(r945*z5*r11-r1050*z3*r9+r225*z*r7)
  Pot = Pot/r120
end if

ElPointPot = Pot

return

end function ElPointPot

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

subroutine COMPRS2LST(I1,XI1,N1,I2,XI2,N2,NKIN,NKOUT)
! Two lists of excitations/annihilations/creations are given.
! Compress to common nonvanishing entries
!
! Jeppe Olsen, November 1996

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N1, N2, NKIN
integer(kind=iwp), intent(inout) :: I1(NKIN,N1), I2(NKIN,N2)
real(kind=wp), intent(inout) :: XI1(NKIN,N1), XI2(NKIN,N2)
integer(kind=iwp), intent(out) :: NKOUT
integer(kind=iwp) :: I1ACT, I2ACT, K

NKOUT = 0
do K=1,NKIN
  I1ACT = 0
  if (any(I1(K,:) /= 0)) I1ACT = 1
  I2ACT = 0
  if (any(I2(K,:) /= 0)) I2ACT = 1
  if ((I1ACT == 1) .and. (I2ACT == 1)) then
    NKOUT = NKOUT+1
    if (NKOUT /= K) then
      I1(NKOUT,:) = I1(K,:)
      XI1(NKOUT,:) = XI1(K,:)
      I2(NKOUT,:) = I2(K,:)
      XI2(NKOUT,:) = XI2(K,:)
    end if
  end if
end do

end subroutine COMPRS2LST

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine ReaW4 (W,Wa,aSGrp,bSGrp,cSGrp,dSGrp,LunAux)
c
c        this routine do:
c        Add W(a",b",c",d") <<- (a",b"|c",d") for any a",b",c",d"
c        via reading records W4 (p">=q")>=(r">=s")
c
c        Wa is an auxiliary file
c
c        Structure of records:
c        1) only records for pSGrp>=qSGrp & rSGrp>=sSGrp & pqSGrp>=rsSGrp
c           exists
c        2) in individual records p">=q",r">=s" are stored
c           however p">=q")>=(r">=a") reduction is not yet used
c
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        integer aSGrp,bSGrp,cSGrp,dSGrp,LunAux
        real*8 W(1)
        real*8 Wa(1)
c
c        help variables
        integer abPerm,cdPerm,abcdPerm
        integer abSGrp,cdSGrp
        integer abLen,cdLen,abcdLen
        integer dima,dimb,dimc,dimd
        integer pSGrp,qSGrp,rSGrp,sSGrp,dimp,dimq,dimr,dims
        character*10 LunName
        integer i
c
c
c        -------- part I - define basic parameters
c
c1        Def dima,dimb,dimc,dimc
        dima=DimSGrpa(aSGrp)
        dimb=DimSGrpbe(bSGrp)
        dimc=DimSGrpa(cSGrp)
        dimd=DimSGrpbe(dSGrp)
c
c
c        In steps 2.1 - 2.3 also dimp-dims and pSGrp-sSGrp
c2.1        Def abPerm, abSGrp
        if (aSGrp.ge.bSGrp) then
          abPerm=0
          abSGrp=(aSGrp*(aSGrp-1)/2)+bSGrp
          pSGrp=aSGrp
          qSGrp=bSGrp
          dimp=dima
          dimq=dimb
        else
          abPerm=1
          abSGrp=(bSGrp*(bSGrp-1)/2)+aSGrp
          pSGrp=bSGrp
          qSGrp=aSGrp
          dimp=dimb
          dimq=dima
        end if
c
c2.2        Def cdPerm, cdSGrp
        if (cSGrp.ge.dSGrp) then
          cdPerm=0
          cdSGrp=(cSGrp*(cSGrp-1)/2)+dSGrp
          rSGrp=cSGrp
          sSGrp=dSGrp
          dimr=dimc
          dims=dimd
        else
          cdPerm=1
          cdSGrp=(dSGrp*(dSGrp-1)/2)+cSGrp
          rSGrp=dSGrp
          sSGrp=cSGrp
          dimr=dimd
          dims=dimc
        end if
c
c2.3        Def abcdPerm
        if (abSGrp.ge.cdSGrp) then
          abcdPerm=0
        else
          abcdPerm=1
          i=pSGrp
          pSGrp=rSGrp
          rSGrp=i
          i=qSGrp
          qSGrp=sSGrp
          sSGrp=i
          i=dimp
          dimp=dimr
          dimr=i
          i=dimq
          dimq=dims
          dims=i
        end if
c
c
c3.1        Def abLen
        if (aSGrp.eq.bSGrp) then
          abLen=dima*(dima+1)/2
        else
          abLen=dima*dimb
        end if
c
c3.2        Def cdLen
        if (cSGrp.eq.dSGrp) then
          cdLen=dimc*(dimc+1)/2
        else
          cdLen=dimc*dimd
        end if
c
c3.3        Def abcdLen
        abcdLen=abLen*cdLen
c
c
c        -------- part II - read proper integrals (pq|rs) from disc
c
c4        Def proper LunName
        call MkNameV4 (pSGrp,qSGrp,rSGrp,sSGrp,'W4',LunName)
c
c
c5        Read Wa(pqrs) - velka udalost
C       open (unit=LunAux,file=LunName,form='unformatted')
        Call Molcas_BinaryOpen_Vanilla(LunAux,LunName)
        call rea_chcc (LunAux,abcdLen,Wa(1))
        close (LunAux)
c
c
c        -------- part III - Upgrade W(a",b",c",d") from Wx(pqrs)
c        symbolics used: [xy] means xy or yx
c
        if (abcdPerm.eq.0) then
c          case ([ab]|[cd])
c
          if ((abPerm.eq.0).and.(cdPerm.eq.0)) then
c            subcase (ab|cd)
            call DefW4abcd (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else if ((abPerm.eq.0).and.(cdPerm.eq.1)) then
c            subcase (ab|dc)
            call DefW4abdc (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else if ((abPerm.eq.1).and.(cdPerm.eq.0)) then
c            subcase (ba|cd)
            call DefW4bacd (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else
c            subcase (ba|cd)
            call DefW4badc (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          end if
c
        else
c        case ([cd]|[ab])
c
          if ((abPerm.eq.0).and.(cdPerm.eq.0)) then
c            subcase (cd|ab)
            call DefW4cdab (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else if ((abPerm.eq.0).and.(cdPerm.eq.1)) then
c            subcase (cd|ab)
            call DefW4dcab (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else if ((abPerm.eq.1).and.(cdPerm.eq.0)) then
c            subcase (cd|ba)
            call DefW4cdba (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          else
c            subcase (dc|ba)
            call DefW4dcba (W,Wa,dima,dimb,dimc,dimd,abLen,cdLen,
     c                      aSGrp,bSGrp,cSGrp,dSGrp)
c
          end if
c
        end if
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Lobatto(ndeg,Trw)
      implicit real*8 (a-h,o-z)
      parameter(mxdeg=100)
      dimension roots(mxdeg,mxdeg),wghts(mxdeg,mxdeg)
      dimension recurs(mxdeg),trw(3*(ndeg+2)*(ndeg+3)/2)

C Start: Accurately known are p0=1 and p1=x
      roots(1,1)=0.0d0
C Recursion coefficients:
      do k=1,ndeg
        rk=DBLE(k)*1.0d0
        recurs(k)=(rk*(rk+2.0d0))/((2.0D0*rk+1.0d0)*(2.0D0*rk+3.0d0))
      end do

      do k=2,ndeg
C Construct a start approximation to the roots:
        roots(1,k)=(DBLE(k)*(roots(1,  k-1)+1.0d0))/DBLE(k+1)-1.0d0
        roots(k,k)=(DBLE(k)*(roots(k-1,k-1)-1.0d0))/DBLE(k+1)+1.0d0
        do ir=2,k-1
          roots(ir,k)=( DBLE(k+1-ir)*roots(ir  ,k-1)
     &                 +DBLE(ir    )*roots(ir-1,k-1) )/DBLE(k+1)
        end do
C Start modified Newton-Raphson iterations. Parallell treatment of roots:
  10  continue
        dmax=0.0d0
        do ir=1,k
C Compute value and derivative of polynomial:
          x=roots(ir,k)
          fpold=0.0d0
          fold=1.0d0
          fp=1.0d0
          f=x
          do n=2,k
            c=recurs(n-1)
            fpnew=x*fp+f-c*fpold
            fnew=x*f-c*fold
            fpold=fp
            fold=f
            fp=fpnew
            f=fnew
          end do
C Compute the extra denominator term:
          xterm=0.0d0
          do jr=1,k
            if(jr.ne.ir) xterm=xterm+1.0d0/(x-roots(jr,k))
          end do
C Update:
          delta=-f/(fp-f*xterm)
          roots(ir,k)=roots(ir,k)+delta
          dmax=max(dmax,abs(delta))
        end do
        if(dmax.gt.1.0d-12) goto 10
      end do

C Compute weights:
      do k=1,ndeg
        do ir=1,k
          x=roots(ir,k)
          fold=1.0d0
          f=x
          do n=1,k
            fnew=x*f*(2.0d0*DBLE(n)+1.0d0)
     &          / (DBLE(n)+1.0d0)-fold*DBLE(n)/(DBLE(n)+1.0d0)
            fold=f
            f=fnew
          end do
          wghts(ir,k)=2.0d0/(f*f*DBLE(k+1)*DBLE(k+2))
        end do
      end do

      do n=3,ndeg+2
        trw(3*n*(n-1)/2+1)=-1.0d0               ! (n-1,1,1)   n=nDeg+2
        trw(3*n*(n-1)/2+2)=2.0d0/DBLE(n*(n-1))  ! (n-1,1,2)
        trw(3*n*(n+1)/2-2)=1.0d0                ! (n-1,n-1,1)
        trw(3*n*(n+1)/2-1)=2.0d0/DBLE(n*(n-1))  ! (n-1,n-1,2)
      end do

*   (1,1,1)
*   (1,1,2)
*   (1,1,3)
*   (2,1,1)
*   (2,1,1)
*   (2,1,2)
*   (2,2,3)
*   (2,2,2)
*   (2,2,3)

      do i=1,9
        trw(i)=0.0D0
      end do

      do k=1,ndeg
        n=k+1
        do ir=1,k
          ii=3*n*(n+1)/2+ir*3+1    ! (n+1,ir,1)   n=nDeg+1, ir=2,nDeg
          jj=3*n*(n+1)/2+ir*3+2    ! (n+1,ir,2)
          trw(ii)=roots(ir,k)
          trw(jj)=wghts(ir,k)
        end do
      end do

*      write(*,*) 'Lobatto'
*      do i=1,ndeg+2
*        write(*,*) 'i=',i
*        do j=1,i
*          write(*,*) trw(3*i*(i-1)/2+3*(j-1)+1),
*     &               trw(3*i*(i-1)/2+3*(j-1)+2),
*     &               trw(3*i*(i-1)/2+3*(j-1)+3)
*        end do
*      end do

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine UrobChV(L2,NaGrp,NbeGrp,LunAux)
! vyraba fily so simulovanymi Cholesky vektormi
! so spravnou strukturou

use chcc_global, only: DimGrpv, L2Name, nc
use Definitions, only: wp, iwp,u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: L2(*)
integer(kind=iwp), intent(in) :: NaGrp, NbeGrp, LunAux
integer(kind=iwp) :: aGrp, beGrp, len_
real(kind=wp) :: schem

!1 cycle over a,be Groups

do aGrp=1,NaGrp
  do beGrp=1,NbeGrp

    !1.1 def length
    len_ = nc*DimGrpv(aGrp)*DimGrpv(beGrp)

    !1.2 full L2 with random numbers
    schem = 1.0e-2_wp
    call RNFill(len_,L2,schem)

    !1.3 open proper file
    !open(unit=LunAux,file=L2Name(aGrp,beGrp),form='unformatted')
    call MOLCAS_BinaryOpen_Vanilla(LunAux,L2Name(aGrp,beGrp))

    !1.4 write L2 into proper file
    write(u6,*) aGrp,beGrp,len_
    call wri_chcc(LunAux,len_,L2)

  end do
end do

return

end subroutine UrobChV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
*               1995, Martin Schuetz                                   *
************************************************************************
      Subroutine RdMBPT(ipCMO,lthCMO,ipEOrb,lthEOr)
************************************************************************
*                                                                      *
*     Read the MBPTOUT file genereated by the SCF program              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*     modified by:                                                     *
*     M.G. Schuetz                                                     *
*     University of Lund, Sweden, 1995                                 *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)

*     declaration of calling arguments
      Integer ipCMO,ipEOrb,lthCMO,lthEOr

#include "real.fh"
#include "mxdim.fh"
#include "corbinf.fh"
#include "orbinf2.fh"
#include "mbpt2aux.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "files_mbpt2.fh"
      Real*8, Allocatable:: CMO_t(:)

*     declaration of local variables...
      Logical Debug
      Data Debug/.False./


#include "SysDef.fh"

*
*...  Read nSym, nBas, nOrb, nOcc, nFro, CMO and orbital energies from COMFILE
*
         Call Get_iScalar('nSym',nSym)
         Call Get_iArray('nBas',nBas,nSym)
         Call Get_iArray('nOrb',nOrb,nSym)
         Call Get_iArray('nIsh',nOcc,nSym)
         Call Get_iArray('nFro',nFro,nSym)
         If (Debug) Then
            Write (6,'(A,8I5)') 'nSym:',nSym
            Write (6,'(A,8I5)') 'nBas:',(nBas(i),i=1,nSym)
            Write (6,'(A,8I5)') 'nOrb:',(nOrb(i),i=1,nSym)
            Write (6,'(A,8I5)') 'nOcc:',(nOcc(i),i=1,nSym)
            Write (6,'(A,8I5)') 'nFro:',(nFro(i),i=1,nSym)
         End If
         lthCMO=0
         Do iSym=1,nSym
            If (nFro(iSym).ne.0) Then
               Write (6,*) 'Some orbitals where frozen in the SCF!'
               Call Abend()
            End If
            nDel(iSym)=nBas(iSym)-nOrb(iSym)
            nExt(iSym)=nOrb(iSym)-nOcc(iSym)
            nDsto(iSym)=nDel(iSym)
            lthCMO = lthCMO + nBas(iSym)*nOrb(iSym)
         End Do
*
         Call mma_allocate(CMO_t,lthCMO,Label='CMO_t')
         Call Get_CMO_(CMO_t,lthCMO)
         Call GetMem('CMO   ','Allo','Real',ipCMO,lthCMO)
*
*...  set MO coefficients of the deleted orbitals to zero
*     Observe that these are not included at all in the basis
         iStart   = ipCMO
         iStart_t = 1
         Do iSym=1,nSym
            call dcopy_(nOrb(iSym)*nBas(iSym),CMO_t(iStart_t),1,
     &                                       Work(iStart),1)
            iStart   = iStart   + nOrb(iSym)*nBas(iSym)
            iStart_t = iStart_t + nOrb(iSym)*nBas(iSym)
            call dcopy_((nBas(iSym)-nOrb(iSym))*nBas(iSym),
     &                  [Zero],0,Work(iStart),1)
            iStart   = iStart   +
     &                 (nBas(iSym)-nOrb(iSym))*nBas(iSym)
         End Do
         Call mma_deallocate(CMO_t)
*
         Call Get_OrbE_(ipEOrb_t,lthEOr)
         nnB=lthEOr
         Call GetMem('EOrb  ','Allo','Real',ipEOrb,lthEOr)
*
*...  set energies of the deleted orbitals to zero
*
         iStart   = ipEOrb
         iStart_t = ipEOrb_t
         Do iSym=1,nSym
            call dcopy_(nOrb(iSym),Work(iStart_t),1,Work(iStart),1)
            iStart  = iStart   + nOrb(iSym)
            iStart_t= iStart_t + nOrb(iSym)
*
            call dcopy_(nBas(iSym)-nOrb(iSym),[Zero],0,Work(iStart),1)
            iStart  = iStart   + nBas(iSym)-nOrb(iSym)
         End Do
         Call GetMem('EOrb_t','Free','Real',ipEOrb_t,lthEOr)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_X_RSCopy
!
!> @brief
!>   Copy reduced set index arrays
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Copy index arrays from location \p iRS (``1``,``2``,``3``) to location
!> \p jRS (``1``,``2``,``3``). Special handling of the case \p iRS = ``1``:
!> ``IndRed(i,jRS) = i`` rather than ``IndRed(i,jRS)=IndRed(i,iRS)``.
!> If \p iRS and/or \p jRS are out of bounds, \p irc = ``1`` on exit and nothing
!> has been done!
!>
!> @note
!> The Cholesky module must have been initialized.
!>
!> @param[out] irc return code
!> @param[in]  iRS location of reference reduced set
!> @param[in]  jRS location of target reduced set
!***********************************************************************

subroutine Cho_X_RSCopy(irc,iRS,jRS)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iRS, jRS

if ((iRS < 1) .or. (iRS > 3) .or. (jRS < 1) .or. (jRS > 3)) then
  irc = 1
else
  call Cho_RSCopy(iRS,jRS)
  irc = 0
end if

end subroutine Cho_X_RSCopy

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RDCMO_RASSI(JOB,CMO)

use rassi_aux, only: ipglob
use Cntrl, only: IDCMO, iTOC15, JBNAME, LuIph, NJOB, PRORB
use Symmetry_Info, only: nIrrep
use rassi_data, only: NBASF, NCMO, NOSH
#ifdef _HDF5_
use mh5, only: mh5_close_file, mh5_fetch_dset, mh5_is_hdf5, mh5_open_file_r
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: JOB
real(kind=wp), intent(out) :: CMO(NCMO)
integer(kind=iwp) :: I, IAD, IDISK, ISY, L1, L2, Length, NBUF
#ifdef _HDF5_
integer(kind=iwp) :: refwfn_id
#endif
real(kind=wp), allocatable :: BUF(:)

CMO(:) = Zero
if ((JOB < 1) .or. (JOB > NJOB)) then
  write(u6,*) ' RDCMO_RASSI: Invalid JOB parameter.'
  write(u6,*) ' JOB, NJOB:',JOB,NJOB
  call ABEND()
end if
if (IPGLOB >= 4) write(u6,*) ' RDCMO_RASSI called for file '//trim(JBNAME(JOB))
! READ ORBITAL COEFFICIENTS FROM INTERFACE. ORIGINALLY ALL
! CMO COEFFS, INCLUDING VIRTUALS, WERE WRITTEN CONTIGUOUSLY.
NBUF = sum(NBASF(1:nIrrep)**2)
call mma_allocate(BUF,NBUF,Label='BUF')

#ifdef _HDF5_
if (mh5_is_hdf5(jbname(job))) then
  !*********************************************************************
  !
  ! For HDF5 formatted job files
  !
  !*********************************************************************
  refwfn_id = mh5_open_file_r(jbname(job))
  call mh5_fetch_dset(refwfn_id,'MO_VECTORS',BUF)
  call mh5_close_file(refwfn_id)
else
#endif
  !*********************************************************************
  !
  ! For JOBIPH/JOBMIX formatted job files
  !
  !*********************************************************************
  call DANAME(LUIPH,JBNAME(JOB))
  IAD = 0
  call IDAFILE(LUIPH,2,ITOC15,30,IAD)
  IDISK = IDCMO(JOB)
  call DDAFILE(LUIPH,2,BUF,NBUF,IDISK)
  call DACLOS(LUIPH)
#ifdef _HDF5_
end if
!***********************************************************************
#endif

if (IPGLOB >= 5) then
  write(u6,*) ' Reading CMO'
  write(u6,*) ' NBUF=',NBUF
  write(u6,*) ' Array read in:'
  write(u6,'(1x,5f16.8)') (buf(i),i=1,nbuf)
end if
L1 = 1
L2 = 1
do ISY=1,nIrrep
  Length = NOSH(ISY)*NBASF(ISY)
  CMO(L2:L2+Length-1) = BUF(L1:L1+Length-1)
  L2 = L2+Length
  L1 = L1+NBASF(ISY)**2
end do
if (IPGLOB >= 5) then
  write(u6,*) ' Gathered CMO from array.'
  write(u6,*) ' NCMO=',NCMO
  write(u6,'(1x,5f16.8)') (CMO(i),i=1,ncmo)
end if
call mma_deallocate(BUF)

if ((IPGLOB > 0) .and. PRORB) then
  write(u6,*)
  call WRMAT('MO ORBITAL COEFFICIENTS:',1,NBASF,NOSH,NCMO,CMO)
end if

end subroutine RDCMO_RASSI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CIDIA_CI_UTIL(NCONF,IREFSM,CSFDIA,LUDAVID)
! PURPOSE: - COMPUTE DIAGONAL ELEMENTS OF THE CI-MATRIX
!            THE DETERMINANT BASIS
!          - TRANSLATE FORM DET => CSF BASIS
!
! CALLING PARAMETERS:
! NCONF :  NO. OF CSF
! IREFSM:  REFERENCE SYMMETRY
! CSFDIA:  DIAGONAL OF CI MATRIX IN CSF BASIS

use csfbas, only: CTS
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: NCONF, IREFSM, LUDAVID
real(kind=wp), intent(out) :: CSFDIA(NCONF)
integer(kind=iwp) :: iDummy, IPRINT, IPRL, IPRLEV
real(kind=wp) :: Dummy(1), eCore_Hex
real(kind=wp), allocatable :: DDIA(:)
real(kind=r8), external :: Get_eCore
#include "ciinfo.fh"
#include "spinfo.fh"
#include "WrkSpc.fh"
#include "timers.fh"
#include "output_ras.fh"

call Timing(Tissot_1,Swatch,Swatch,Swatch)
IPRLEV = IPRLOC(3)

! COMPUTE CI DIAGONAL IN DETERMINANT BASIS

call Lucia_Util('Diag',iDummy,iDummy,Dummy)

call mma_allocate(DDIA,NDET,label='DETDIA')
call get_diag(DDIA,ndet)

! TRANSFORM CI DIAGONAL FROM DET TO CSF BASIS

IPRINT = 0
if (IPRLEV == INSANE) IPRINT = 40
call CSDIAG_CI_UTIL(NCONF,ndet,CSFDIA,DDIA,NCNFTP(1,IREFSM),NTYP,CTS,NDTFTP,NCSFTP,IPRINT)
eCore_Hex = Get_eCore()
CSFDIA(:) = CSFDIA(:)+eCore_Hex

! DEALLOCATE LOCAL MEMORY

call mma_deallocate(DDIA)

! PRINT CI-DIAGONAL

if (IPRLEV >= DEBUG) then
  IPRL = NCONF
  if (IPRLEV < INSANE) IPRL = min(IPRL,200)
  call dVcPrt('CI-DIAGONAL (max.200 elemwnts)',' ',CSFDIA,NCONF)
end if

! SAVE THE CI_DIAGONAL ON TAPE

call Save_H_diag(nConf,CSFDIA,LUDAVID)

call Timing(Tissot_2,Swatch,Swatch,Swatch)
Tissot_2 = Tissot_2-Tissot_1
Tissot_3 = Tissot_3+Tissot_2

return

end subroutine CIDIA_CI_UTIL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_DIACHO(DIAG,ISYM,WRK,LWRK)
C
C     Purpose: update (i.e. subtract contributions from vectors on disk)
C              of symmetry block ISYM of diagonal in red. set 1.
C              This emulates the actual procedure during decomposition.
C
#include "implicit.fh"
      DIMENSION DIAG(*), WRK(LWRK)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_DIACHO')

      LOGICAL SCDIAG_SAVE

      PARAMETER (N2 = INFVEC_N2)
      PARAMETER (ZERO = 0.0D0)

      INFVEC(I,J,K)=IWORK(ip_INFVEC-1+MAXVEC*N2*(K-1)+MAXVEC*(J-1)+I)
      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)

C     Return if nothing to do.
C     ------------------------

      IF (NNBSTR(ISYM,1) .LT. 1) RETURN
      IF (NUMCHO(ISYM)   .LT. 1) RETURN

C     Save read-call counter.
C     -----------------------

      NSCALL = NSYS_CALL

C     Set pointer to scratch for reduced set indices.
C     -----------------------------------------------

      ILOC  = 3

C     Set up rs1 indices at location ILOC.
C     Set IREDC to identify this.
C     ------------------------------------

      CALL CHO_RSCOPY(IWORK(ip_IIBSTRSH),IWORK(ip_NNBSTRSH),
     &                IWORK(ip_INDRED),1,ILOC,NSYM,NNSHL,NNBSTRT(1),3)
      IREDC = 1

C     Start read buffer batch loop.
C     -----------------------------

      IVEC1 = 1
      DO WHILE (IVEC1 .LE. NUMCHO(ISYM))

C        Read as many vectors as possible into buffer (entire WRK).
C        ----------------------------------------------------------

         NVRD  = 0
         MUSED = 0
         CALL CHO_VECRD(WRK,LWRK,IVEC1,NUMCHO(ISYM),ISYM,
     &                  NVRD,IREDC,MUSED)
         IF (NVRD .LT. 1) THEN
            CALL CHO_QUIT('Insufficient scratch space for read in '
     &                    //SECNAM,101)
         END IF

C        Initialize vector offset.
C        -------------------------

         KOFFV = 0

C        Loop over vectors in core.
C        --------------------------

         DO JVEC = 1,NVRD

C           Set index arrays for current reduced set (if not already
C           set).
C           --------------------------------------------------------

            JRED = INFVEC(IVEC1+JVEC-1,2,ISYM)
            IF (JRED .NE. IREDC) THEN
               IF (JRED .EQ. 1) THEN
                  CALL CHO_RSCOPY(IWORK(ip_IIBSTRSH),IWORK(ip_NNBSTRSH),
     &                            IWORK(ip_INDRED),1,ILOC,
     &                            NSYM,NNSHL,NNBSTRT(1),3)
               ELSE
                  KOFF1 = ip_NNBSTRSH + NSYM*NNSHL*(ILOC - 1)
                  KOFF2 = ip_INDRED   + MMBSTRT*(ILOC - 1)
                  CALL CHO_GETRED(IWORK(ip_INFRED),IWORK(KOFF1),
     &                            IWORK(KOFF2),IWORK(ip_INDRSH),
     &                            IWORK(ip_iSP2F),
     &                            MAXRED,NSYM,NNSHL,MMBSTRT,JRED,
     &                            .FALSE.)
                  CALL CHO_SETREDIND(IWORK(ip_IIBSTRSH),
     &                               IWORK(ip_NNBSTRSH),NSYM,NNSHL,
     &                               ILOC)
               END IF
               IREDC = JRED
            END IF

C           Compute contributions to diagonal.
C           Zero the diagonal element associated with this vector.
C           ------------------------------------------------------

            DO JAB = 1,NNBSTR(ISYM,ILOC)
               IAB = INDRED(IIBSTR(ISYM,ILOC)+JAB,ILOC) ! address in rs1
               KAB = KOFFV + JAB ! vector address
               DIAG(IAB) = DIAG(IAB) - WRK(KAB)*WRK(KAB)
            END DO
            IABG = INFVEC(IVEC1+JVEC-1,1,ISYM)
            CALL CHO_P_ZERODIAG_RST(DIAG,ISYM,IABG)

C           Check diagonal.
C           ---------------

            IF (CHO_DECALG .EQ. 4) THEN
               SCDIAG_SAVE = SCDIAG
               SCDIAG = .FALSE. ! do NOT screen
               DMX = 1.0D0
               CALL CHO_CHKDIA_A4(DIAG,DMX,ISYM,NNEG,NNEGT,NCONV,XMAX,
     &                            XMIN,XM)
               SCDIAG = SCDIAG_SAVE
            ELSE
               CALL CHO_CHKDIA(DIAG,ISYM,XMIN,XMAX,XM,NNEGT,NNEG,NCONV)
            END IF


C           Update vector offset.
C           ---------------------

            KOFFV = KOFFV + NNBSTR(ISYM,ILOC)

         END DO

C        Check memory.
C        -------------

         IF (KOFFV .NE. MUSED) THEN
            CALL CHO_QUIT('Memory error detected in '//SECNAM,101)
         END IF

C        Update vector counter.
C        ----------------------

         IVEC1 = IVEC1 + NVRD

      END DO

C     Restore read-call counter.
C     --------------------------

      NSYS_CALL = NSCALL

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_VecRd
*
*> @brief
*>   Read as many Cholesky vectors as possible in the range \p jVec1, \p jVec1+1, \p jVec1+2, ..., \p jVec2.
*> @author Thomas Bondo Pedersen
*>
*> @details
*> The vectors are returned in their native storage (reduced set).
*> Starting with vector \p jVec1, this routine will read as many
*> vectors as possible, although at most (\p jVec2-\p jVec1+1) vectors
*> are read.
*>
*> On entry as well as exit, \p iRedC identifies the
*> reduced set stored at location ``3`` (``-1`` if none or unknown).
*> On exit, \p jNum is the number
*> of vectors actually read and \p mUsed is the memory
*> (in ``real*8`` words) actually used.
*>
*> @note
*> cholesky.fh must be initialized.
*>
*> @param[out]    Scr   contains the vectors on exit
*> @param[in]     lScr  dimension of \p Scr
*> @param[in]     jVec1 first vector to read
*> @param[in]     jVec2 last vector allowed to read
*> @param[in]     iSym  vector symmetry
*> @param[out]    jNum  number of vectors actually read
*> @param[in,out] iRedC reduced set stored at location ``3`` on entry as well as exit
*> @param[out]    mUsed amount of memory actually used (in ``real*8`` words)
************************************************************************
      Subroutine Cho_X_VecRd(Scr,lScr,jVec1,jVec2,iSym,jNum,iRedC,mUsed)
      Implicit None
      Integer lScr, jVec1, jVec2, iSym, jNum, iRedC, mUsed
      Real*8  Scr(lScr)
#include "cholesky.fh"

      Integer l_jVec2

      If (iSym.lt.1 .or. iSym.gt.8) Then
         jNum = 0
         mUsed = 0
      Else
         l_jVec2 = min(NumCho(iSym),jVec2)
         Call Cho_VecRd(Scr,lScr,jVec1,l_jVec2,iSym,jNum,iRedC,mUsed)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine decomp_aniso(A,Jiso,Jsym,Jantisym,dbg)

use Constants, only: Zero, Three, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: A(3,3)
real(kind=wp), intent(out) :: Jiso, Jsym(3,3), Jantisym(3,3)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, j
real(kind=wp) :: Dtmp(3,3)

Jiso = Zero
Jsym(:,:) = Zero
Jantisym(:,:) = Zero
!-------------------------------------
do i=1,3
  Jiso = Jiso+A(i,i)
end do
Jiso = Jiso/Three
!-------------------------------------
do i=1,3
  Jsym(i,i) = A(i,i)-Jiso
end do

! find the symmetric matrix:
do i=1,3
  do j=1,3
    if (i /= j) Jsym(i,j) = (A(i,j)+A(j,i))*Half
  end do
end do
! find the anti-symmetric matrix:
do i=1,3
  do j=1,3
    if (i /= j) Jantisym(i,j) = (A(i,j)-A(j,i))*Half
  end do
end do

if (dbg) then
  Dtmp(:,:) = Zero
  do i=1,3
    Dtmp(i,i) = Jiso+Jsym(i,i)+Jantisym(i,i)
    do j=1,3
      if (i /= j) Dtmp(i,j) = Jsym(i,j)+Jantisym(i,j)
    end do
  end do

  write(u6,*)
  write(u6,*) 'J recovered = '
  do i=1,3
    write(u6,'(3F24.14)') (Dtmp(i,j),j=1,3)
  end do
end if

end subroutine decomp_aniso

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RPA_CheckIntegralRepresentation()

use RPA_globals, only: doCD, doDF, doLDF

implicit none

if (.not. (doCD .or. doDF .or. doLDF)) then
  call RPA_Warn(2,'RPA requires CD, DF, or LDF. Conventional integrals not implemented.')
end if

end subroutine RPA_CheckIntegralRepresentation

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Victor P. Vysotskiy                              *
!               2025, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  GetMem
!
!> @brief
!>   A simple work space manager, used by all programs in MOLCAS
!> @author Victor P. Vysotskiy
!>
!> @details
!> This is now a simple wrapper around c_getmem, and it should not be used.
!> Use functions from the ::stdalloc module instead.
!>
!> @param[in]     NameIn Arbitrary label
!> @param[in]     KeyIn  ``RGST`` / ``EXCL`` / ``LIST`` / ``TERM``
!> @param[in]     TypeIn ``REAL`` / ``INTE`` / ``CHAR``
!> @param[in,out] iPos   Position
!> @param[in,out] Length Nr of items
!***********************************************************************

subroutine GetMem(NameIn,KeyIn,TypeIn,iPos,Length)
!***********************************************************************
!                                                                      *
! History: Victor P. Vysotskiy                                         *
!    2012: Native Molcas's Memory Allocator; Thread safety             *
!          Ignacio Fdez. Galvan                                        *
!    2025: Garble using C pointers                                     *
!    2025: Reduce to minimum expression                                *
!                                                                      *
!***********************************************************************

use, intrinsic :: iso_c_binding, only: c_null_char
use mma_module, only: c_getmem, MemStat
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: NameIn, KeyIn, TypeIn
integer(kind=iwp), intent(in) :: iPos, Length
#include "warnings.h"
integer(kind=iwp) :: irc, itmp
character(len=9) :: elbl, eopr, etyp

!----------------------------------------------------------------------*
!     Initialize the mma module the first time it is referenced        *
!----------------------------------------------------------------------*
if (.not. MemStat) call IniMem()

!----------------------------------------------------------------------*
!     prepare passed values to the C char format                       *
!----------------------------------------------------------------------*
elbl = NameIn
elbl(9:9) = c_null_char
eopr = KeyIn
eopr(9:9) = c_null_char
etyp = TypeIn
etyp(9:9) = c_null_char

!----------------------------------------------------------------------*
!     Call the C function                                              *
!----------------------------------------------------------------------*
itmp = iPos-1
iRc = c_getmem(elbl,eopr,etyp,itmp,Length)
if (iRc < 0) call Quit(_RC_MEMORY_ERROR_)

end subroutine GetMem

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine prints the body part to the postscript figure of        *
! occupation numbers.                                                  *
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine FigPrt(lu,Title,nLqn,nOrb,Occ)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lu, nLqn, nOrb(0:nLqn)
character(len=*), intent(in) :: Title
real(kind=wp), intent(in) :: Occ(*)
integer(kind=iwp) :: i, k0, k1, lqn0, lqn1, mxNqn, n, nOff, iOff(0:25)
real(kind=wp) :: O, Oa, Ob
character, parameter :: tp(0:5) = ['s','p','d','f','g','h']

write(lu,'(a)') 'HF setfont'
write(lu,'(a)') '2.25 X -7.0 Y moveto'
k0 = 0
k1 = 0
do i=len(Title),1,-1
  if (Title(i:i) /= ' ') k0 = i
end do
do i=1,len(Title)
  if (Title(i:i) /= ' ') k1 = i
end do
write(lu,'(3a)') '(',Title(k0:k1),') CenterLine'
nOff = 0
mxNqn = 0
do i=0,nLqn
  if (nOrb(i) > 0) mxNqn = max(mxNqn,nOrb(i)+i)
  iOff(i) = nOff
  nOff = nOff+nOrb(i)
end do
do n=1,mxNqn
  write(lu,'(a,i2)') '%--- shell n=',n
  lqn0 = nLqn
  lqn1 = 0
  do i=0,min(n-1,nLqn)
    if (n-i <= nOrb(i)) then
      if (i > lqn1) lqn1 = i
      if (i < lqn0) lqn0 = i
      O = log10(Occ(iOff(i)+n-i))
      write(lu,'(i2,a,f7.4,a)') i,' X ',O,' Y Draw'
    end if
  end do
  if (n < 10) then
    write(lu,'(a,i1,a,a,i1,a,a)') ' (',n,tp(lqn0),'\261',n,tp(lqn1),') Label'
  else
    write(lu,'(a,i2,a,a,i2,a,a)') ' (',n,tp(lqn0),'\261',n,tp(lqn1),') Label'
  end if
  do i=1,min(n-1,nLqn)
    if ((n-i <= nOrb(i)) .and. (n-i+1 <= nOrb(i-1))) then
      Oa = log10(Occ(iOff(i-1)+n-i+1))
      Ob = log10(Occ(iOff(i)+n-i))
      write(lu,'(i2,a,f7.4,a,i2,a,f7.4,a)') i-1,' X ',Oa,' Y ',i,' X ',Ob,' Y Connect'
    end if
  end do
end do

return

end subroutine FigPrt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Bernd Artur Hess                                 *
!***********************************************************************

subroutine VPInt( &
#                define _CALLING_
#                include "int_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of  pV integrals          *
!                                                                      *
!     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
!             Chemie, University of Bonn, Germany, April 1993          *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: i, iBeta, ipArr, ipB, ipOff, iPrint, ipS1, ipS2, iRout, kComp, kIC, kRys, mArr, nip, nRys
external :: Fake, TNAI, XCff2D, XRys2D

iRout = 221
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  call RecPrt(' In vpint: Alpha','(5D20.13)',Alpha,nAlpha,1)
  call RecPrt(' In vpint: Beta','(5D20.13)',Beta,nBeta,1)
end if

nRys = nHer

nip = 1
ipB = nip
nip = nip+nZeta
ipS1 = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb+1)
if (lb > 0) then
  ipS2 = nip
  nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb-1)
else
  ipS2 = ipS1
end if
ipArr = nip
mArr = nArr-(nip-1)/nZeta
if (mArr < 0) then
  call WarningMessage(2,'VpInt: mArr<0!')
  call Abend()
end if

rFinal(:,:,:,:) = Zero
Array(:) = Zero
! Compute contribution from a,b+1

kRys = ((la+1)+lb+2)/2

kIC = 1
kComp = 1
call NAInt(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS1),nZeta,nIC,nComp,la,lb+1,A,RB,kRys,Array(ipArr),mArr,CCoor, &
           nOrdOp,lOper,iChO,iStabM,nStabM,PtChrg,nGrid,iAddPot)

ipOff = ipB-1
do iBeta=1,nBeta
  Array(ipOff+1:ipOff+nAlpha) = Beta(iBeta)
  ipOff = ipOff+nAlpha
end do

! Compute contribution from a,b-1

if (lb > 0) then
  kRys = ((la-1)+lb+2)/2

  call NAInt(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS2),nZeta,kIC,kComp,la,lb-1,A,RB,nRys,Array(ipArr),mArr,CCoor, &
             nOrdOp,lOper,iChO,iStabM,nStabM,PtChrg,nGrid,iAddPot)
end if

! Assemble final integral from the derivative integrals

if (iPrint >= 99) call RecPrt(' In vpint: Beta (expanded)','(5D20.13)',Array(ipB),nZeta,1)

call Util8(Array(ipB),nZeta,rFinal,la,lb,Array(ipS1),Array(ipS2))

if (iPrint >= 49) then
  do i=1,3
    call RecPrt('VpInt: rFinal',' ',rFinal(:,:,:,i),nZeta,nTri_Elem1(la)*nTri_Elem1(lb))
  end do
end if

return

end subroutine VPInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2001, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE CSDTMT_GAS(IPDTCNF,IPCSCNF,DTOC,IPRCSF)
*
* Construct in IDTFTP list of proto type combinations in IDFTP
* Construct in ICFTP list of proto type CSF's in ICFTP
* Construct in DTOC matrix expanding proto type CSF's in terms of
* prototype combinations in DTOC
*
* Construct also array for going from lexical address of prototype det
* to address in IDFTP
*
* where MXPDBL is size of largest prototype combination block .
*
* Jeppe Olsen
*
* Changed to Combination form, June 92
* Adapted to LUCIA December 2001
*
#include "implicit.fh"
#include "mxpdim.fh"
#include "spinfo_lucia.fh"
#include "WrkSpc.fh"
#include "cstate.fh"
#include "glbbas.fh"
*. Output
      INTEGER IPDTCNF(*),IPCSCNF(*)
      DIMENSION DTOC(*)
*
      NTEST = 0
      NTEST = MAX(NTEST,IPRCSF)
*. Size of largest csf-sd block
      MAX_DC = 0
      DO IOPEN = 0, MAXOP
        L = NPCMCNF(IOPEN+1)
        MAX_DC = MAX(MAX_DC,L)
      END DO
      IF(NTEST.GE.100) WRITE(6,*) ' Size of largest D to C block ',
     &MAX_DC
      LSCR = MAX(MAX_DC,MAXOP)
                LSCR = MAX_DC*MAXOP+MAXOP
      CALL GETMEM('SCR_CS','ALLO','REAL',KLSCR1,LSCR)
*
*
* .. Set up combinations and upper determinants
*
      IF(NTEST.GE.5) THEN
        WRITE(6,*)
        WRITE(6,*) ' **************************************'
        WRITE(6,*) ' Generation of proto type determinants '
        WRITE(6,*) ' **************************************'
        WRITE(6,*)
      END IF
*. Still tired of stupid compiler warnings
      IDTBS = 0
      ICSBS = 0
      DO IOPEN = 0, MAXOP
        ITP = IOPEN + 1
        IF( NTEST .GE. 5 ) THEN
          WRITE(6,*)
          WRITE(6,'(A,I3,A)')
     &    '       Type with ',IOPEN,' open orbitals '
          WRITE(6,'(A)')
     &    '       **********************************'
          WRITE(6,*)
        END IF
        IF( ITP .EQ. 1 ) THEN
          IDTBS = 1
          ICSBS = 1
        ELSE
          IDTBS = IDTBS + (IOPEN-1)*NPCMCNF(ITP-1)
          ICSBS = ICSBS + (IOPEN-1)*NPCSCNF(ITP-1)
        END IF
C
        IF( IOPEN .NE. 0 ) THEN
*. Proto type combinations and branching diagram for
*  proto type combinations
          IF( MS2+1 .EQ. MULTS ) THEN
            IFLAG = 2
            CALL SPNCOM_LUCIA(  IOPEN,
     &                            MS2,
     &                          NNDET,
     &                        IPDTCNF(IDTBS),
     &                        IPCSCNF(ICSBS),
*
     &                          IFLAG,
     &                         PSSIGN,
     &                         IPRCSF)
C                SPNCOM(NOPEN,MS2,NDET,IABDET,
C    &                  IABUPP,IFLAG,PSSIGN,IPRCSF)
          ELSE
            IFLAG = 1
            CALL SPNCOM_LUCIA(  IOPEN,
     &                            MS2,
     &                          NNDET,
     &                        IPDTCNF(IDTBS),
     &                        IPCSCNF(ICSBS),
*
     &                          IFLAG,
     &                         PSSIGN,
     &                         IPRCSF)
            IFLAG = 3
            CALL SPNCOM_LUCIA(  IOPEN,
     &                        MULTS-1,
     &                          NNDET,
     &                        IPDTCNF(IDTBS),
     &                        IPCSCNF(ICSBS),
*
     &                          IFLAG,
     &                         PSSIGN,
     &                         IPRCSF)
           END IF
         END IF
      END DO
*     ^ End of loop over number of open orbitals
*
* Set up z-matrices for addressing prototype determinants with
* a given number of open orbitals, and for readdressing to
* the order given in IDCNF
*. Scr : largest block of 2*NOPEN + (NALPHA+1)*(NOPEN+1)
      LSCR = 0
      DO IOPEN = MINOP, MAXOP
        IF(MOD(IOPEN-MS2,2).EQ.0) THEN
          IALPHA = (IOPEN+MS2)/2
          L = 2*IOPEN + (IALPHA+1)*(IOPEN+1)
          LSCR = MAX(L,LSCR)
        END IF
      END DO
      CALL GETMEM('KLSCR2','ALLO','INTE',KLSCR2,LSCR)
*
      IDTBS = 1
C-jwk      DO IOPEN = 0, MAXOP
      DO IOPEN = MINOP, MAXOP
        ITP = IOPEN + 1
        IF( ITP .EQ. 1 ) THEN
          IDTBS = 1
        ELSE
          IDTBS = IDTBS + (IOPEN-1)*NPCMCNF(ITP-1)
        END IF

        IALPHA = (IOPEN+MS2)/2
        IDET = NPCMCNF(IOPEN+1)
C?      WRITE(6,*) ' IOPEN, IDET = ', IOPEN, IDET
        CALL REO_PTDET(   IOPEN,
     &                   IALPHA,
     &                 IWORK(KZ_PTDT(ITP)),
     &                 IWORK(KREO_PTDT(ITP)),
     &                 IPDTCNF(IDTBS),
*
     &                     IDET,
     &                 IWORK(KLSCR2) )
C?     WRITE(6,*) ' Z array as delivered by REO_PTDET'
C?     CALL IWRTMA(WORK(KZ_PTDT(ITP)),IOPEN,IALPHA,IOPEN,IALPHA)
C     REO_PTDET(NOPEN,NALPHA,IZ_PTDET,IREO_PTDET,ILIST_PTDET,
C    &                     NLIST_PTDET,ISCR)
      END DO

*
*. matrix expressing csf's in terms of determinants
*
*
*. Tired of compiler warnings
      IDTBS = 0
      ICSBS = 0
      ICDCBS = 0
      DO IOPEN = 0, MAXOP
        ITP = IOPEN + 1
        IF( ITP .EQ. 1 ) THEN
          IDTBS = 1
          ICSBS = 1
          ICDCBS =1
        ELSE
          IDTBS = IDTBS + (IOPEN-1)*NPCMCNF(ITP-1)
          ICSBS = ICSBS + (IOPEN-1)*NPCSCNF(ITP-1)
          ICDCBS = ICDCBS + NPCMCNF(ITP-1)*NPCSCNF(ITP-1)
        END IF
C       IF(NPCMCNF(ITP)*NPCSCNF(ITP).EQ.0) GOTO 30
        IF( NTEST .GE. 5 ) THEN
          WRITE(6,*)
          WRITE(6,*) ' ************************************'
          WRITE(6,*) ' CSF - SD/COMB transformation matrix '
          WRITE(6,*) ' ************************************'
          WRITE(6,'(A)')
          WRITE(6,'(A,I3,A)')
     &    '  Type with ',IOPEN,' open orbitals '
          WRITE(6,'(A)')
     &    '  ************************************'
          WRITE(6,*)
        END IF
        IF(IOPEN .EQ. 0 ) THEN
           DTOC(ICDCBS) = 1.0D0
        ELSE
          CALL CSFDET_LUCIA(  IOPEN,
     &                      IPDTCNF(IDTBS),
     &                      NPCMCNF(ITP),
     &                      IPCSCNF(ICSBS),
     &                      NPCSCNF(ITP),
*
     &                      DTOC(ICDCBS),WORK(KLSCR1),PSSIGN,IPRCSF)
C              CSFDET(NOPEN,IDET,NDET,ICSF,NCSF,CDC,WORK,PSSIGN,
C    &                IPRCSF)
        END IF
      END DO
*     ^ End of loop over number of open shells
*
      CALL GETMEM('SCR_CS','FREE','REAL',KLSCR1,LSCR)
      CALL GETMEM('KLSCR2','FREE','INTE',KLSCR2,LSCR)
*
      IF(NTEST.GE.10) THEN
        WRITE(6,*)  ' List of CSF-SD transformation matrices '
        WRITE(6,*)  ' ======================================='
        WRITE(6,*)
        IDTBS = 1
        ICSBS = 1
        ICDCBS = 1
        DO IOPEN = 0, MAXOP
          ITP = IOPEN + 1
          IF( ITP .EQ. 1 ) THEN
            IDTBS = 1
            ICSBS = 1
            ICDCBS =1
          ELSE
            IDTBS = IDTBS + (IOPEN-1)*NPCMCNF(ITP-1)
            ICSBS = ICSBS + (IOPEN-1)*NPCSCNF(ITP-1)
            ICDCBS = ICDCBS + NPCMCNF(ITP-1)*NPCSCNF(ITP-1)
          END IF
          NNCS = NPCSCNF(ITP)
          NNCM = NPCMCNF(ITP)
          IF(NNCS.GT.0.AND.NNCM.GT.0) THEN
            WRITE(6,*) ' Number of open shells : ', IOPEN
            WRITE(6,*) ' Number of combinations per conf ', NNCM
            WRITE(6,*) ' Number of CSFs per conf         ', NNCS
            CALL WRTMAT(DTOC(ICDCBS),NNCM,NNCS,NNCM,NNCS)
          END IF
        END DO
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_XCV_CloseAndKeepTmpFiles()

use Cholesky, only: LuTmp, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iSym

do iSym=1,nSym
  if (LuTmp(iSym) > 0) then
    call DAClos(LuTmp(iSym))
    LuTmp(iSym) = 0
  end if
end do

end subroutine Cho_XCV_CloseAndKeepTmpFiles

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine genprexyz6(preY,preXZ)
      implicit real*8(a-h,o-z)
#include "para.fh"
#include "Molcas.fh"
      Dimension preY(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax),
     *preXZ(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax)
cbs #####################################################################
cbs   prefactors preXZ und preY include the factors 1/root(2)
cbs   for the +/- linear combinations of spherical harmonics
cbs #####################################################################
      do M4=-Lmax,Lmax
      do M3=-Lmax,Lmax
      do M2=-Lmax,Lmax
      do M1=-Lmax,Lmax
              preY(m1,m2,m3,m4)=preXZ(m1,m2,m3,m4)
      enddo
      enddo
      enddo
      enddo
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MemRys_g(iSD4,nSD,nRys,MemPrm)
      Implicit Real*8 (a-h,o-z)
      Integer iSD4(0:nSD,4), iAnga(4)
*
      iAnga(1) = iSD4(1,1)
      iAnga(2) = iSD4(1,2)
      iAnga(3) = iSD4(1,3)
      iAnga(4) = iSD4(1,4)
      Call MemRg1(iAnga,nRys,MemPrm)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine expand0(a,b,dimpq,dimp)
! expand a(pq) -> b(p,q)
! assumption: p>q, a(p,q)=-a(q,p)
! RISC version

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimpq, dimp
real(kind=wp), intent(in) :: a(dimpq)
real(kind=wp), intent(out) :: b(dimp,dimp)
integer(kind=iwp) :: p, pq, q
real(kind=wp) :: scalar

if (dimp > 1) then

  pq = 0
  do p=2,dimp
    do q=1,p-1
      pq = pq+1
      scalar = a(pq)
      b(p,q) = scalar
      b(q,p) = -scalar
    end do
  end do

end if

do p=1,dimp
  b(p,p) = Zero
end do

return

end subroutine expand0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine H0SPCT()
! Write pertinent warnings and statistics for the energy
! denominators, i.e. the spectrum of (H0(diag)-E0).

use PrintLevel, only: VERBOSE
use SC_NEVPT2, only: SC_prop
#ifdef _MOLCAS_MPP_
use allgather_wrapper, only: allgather
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
#endif
use EQSOLV, only: IDBMAT, IRHS, IVECX
use fake_GA, only: GA_Arrays
use caspt2_global, only: cmpThr, cntThr, dnmThr, iPrGlb, LUSBT
use caspt2_module, only: NSYM, NASUP, NISUP, NINDEP, CASES, ORBNAM
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: IAEND, IAS, IASTA, IBUF, ICASE, IIEND, IIS, IISTA, IP, IQ, IR, IS, ISYM, JD, lg_RHS, lg_VEC, MAXBUF, NAS, &
                     NBUF, NIN, NIS
real(kind=wp) :: COEF, DNOM, ECNT, RHS
character(len=80) :: LINE
integer(kind=iwp), allocatable, target :: IDXBUF(:,:)
integer(kind=iwp), pointer :: IDX(:,:)
real(kind=wp), allocatable :: BD(:), ID(:)
real(kind=wp), allocatable, target :: VALBUF(:,:)
real(kind=wp), pointer :: VAL(:,:)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: LD, myRank, mRHS, mVEC
integer(kind=iwp), allocatable, target :: IDX_H(:,:)
real(kind=wp), allocatable, target :: VAL_H(:,:)
#endif

! While it is possible to do a similar wf inspection,
! the denominators etc. are very differently formulated for SC-NEVPT2, so we just skip here.
if (SC_prop) then
  write(u6,*) '  (Skip denominator check etc. with SC-NEVPT2 wavefunction)'
  return
end if

write(u6,*)
call CollapseOutput(1,'Denominators, etc.')
write(u6,'(A)') repeat('-',110)
write(u6,'(A)') ' Report on small energy denominators, large coefficients, and large energy contributions.'

if (IPRGLB >= VERBOSE) then
  write(u6,'(A)') '  The ACTIVE-MIX index denotes linear combinations which gives ON expansion functions'
  write(u6,'(A)') '  and makes H0 diagonal within type.'
  write(u6,'(A)') '  DENOMINATOR: The (H0_ii - E0) value from the above-mentioned diagonal approximation.'
  write(u6,'(A)') '  RHS VALUE  : Right-Hand Side of CASPT2 Eqs.'
  write(u6,'(A)') '  COEFFICIENT: Multiplies each of the above ON terms in the first-order wave function.'
  write(u6,'(A)') ' Thresholds used:'
  write(u6,'(a,f7.4)') '         Denominators:',DNMTHR
  write(u6,'(a,f7.4)') '         Coefficients:',CMPTHR
  write(u6,'(a,f7.4)') ' Energy contributions:',CNTTHR
  write(u6,*)
end if

write(u6,'(A)') 'CASE  SYMM ACTIVE-MIX  NON-ACTIVE INDICES          DENOMINATOR     RHS VALUE       COEFFICIENT     CONTRIBUTION'

!SVC: initial buffer size, will be reallocated on the fly
MAXBUF = 1024
call mma_allocate(IDXBUF,2,MAXBUF,LABEL='IDXBUF')
call mma_allocate(VALBUF,4,MAXBUF,LABEL='VALBUF')

! Very long loop over symmetry and case:
do ICASE=1,13
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (NIS == 0) cycle
    NIN = NINDEP(ISYM,ICASE)
    if (NIN == 0) cycle
    LINE(1:12) = CASES(ICASE)//'    '
    write(LINE(10:10),'(i1)') ISYM

    ! Remember: NIN values in BDIAG, but must read NAS for correct
    ! positioning.
    call mma_allocate(BD,NAS,LABEL='BD')
    call mma_allocate(ID,NIS,LABEL='ID')
    JD = IDBMAT(ISYM,ICASE)
    call DDAFILE(LUSBT,2,BD,NAS,JD)
    call DDAFILE(LUSBT,2,ID,NIS,JD)

    call RHS_ALLO(NIN,NIS,lg_RHS)
    call RHS_ALLO(NIN,NIS,lg_VEC)
    call RHS_READ_SR(lg_RHS,ICASE,ISYM,IRHS)
    call RHS_READ_SR(lg_VEC,ICASE,ISYM,IVECX)
    IBUF = 0
#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      ! Get the superindex ranges of this process's block. If no elements are
      ! owned by a process, then ilo=0 and ihi=-1 such that the loop further
      ! down will just be skipped.
      call GA_Sync()
      myRank = GA_NodeID()
      call GA_Distribution(lg_RHS,myRank,IASTA,IAEND,IISTA,IIEND)
      if ((IASTA /= 0) .and. (IAEND-IASTA+1 /= NIN)) then
        write(u6,*) 'RHSOD: mismatch in range of the superindices'
        call AbEnd()
      end if
      ! if the block is non-empty, loop over its elements
      if ((IASTA > 0) .and. (IISTA > 0)) then
        call GA_Access(lg_RHS,IASTA,IAEND,IISTA,IIEND,mRHS,LD)
        call GA_Access(lg_VEC,IASTA,IAEND,IISTA,IIEND,mVEC,LD)
        if (LD /= NIN) then
          write(u6,*) 'RHSOD: assumption NAS=LDW wrong, abort'
          call AbEnd()
        end if
      end if
    else
#   endif
      IASTA = 1
      IAEND = NIN
      IISTA = 1
      IIEND = NIS
#   ifdef _MOLCAS_MPP_
    end if
#   endif

    !*******************************************************************
    ! inner loop over RHS elements in symmetry ISYM
    !*******************************************************************
    do IIS=IISTA,IIEND
      do IAS=IASTA,IAEND
        DNOM = BD(IAS)+ID(IIS)
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          RHS = DBL_MB(mRHS+IAS-1+NIN*(IIS-IISTA))
          COEF = DBL_MB(mVEC+IAS-1+NIN*(IIS-IISTA))
        else
#       endif
          RHS = GA_Arrays(lg_RHS)%A(IAS+NIN*(IIS-IISTA))
          COEF = GA_Arrays(lg_VEC)%A(IAS+NIN*(IIS-IISTA))
#       ifdef _MOLCAS_MPP_
        end if
#       endif
        ECNT = COEF*RHS
        if ((abs(DNOM) < DNMTHR) .or. (abs(COEF) > CMPTHR) .or. (abs(ECNT) > CNTTHR)) then
          if (IBUF < MAXBUF) then
            IBUF = IBUF+1
            IDXBUF(1,IBUF) = IAS
            IDXBUF(2,IBUF) = IIS
            VALBUF(1,IBUF) = DNOM
            VALBUF(2,IBUF) = RHS
            VALBUF(3,IBUF) = COEF
            VALBUF(4,IBUF) = ECNT
          end if
        end if
      end do
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      if ((IASTA > 0) .and. (IISTA > 0)) then
        call GA_Release(lg_RHS,IASTA,IAEND,IISTA,IIEND)
        call GA_Release(lg_VEC,IASTA,IAEND,IISTA,IIEND)
      end if
    end if
#   endif
    NBUF = IBUF
#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call GAIGOP_SCAL(NBUF,'+')
      call mma_allocate(IDX_H,2,NBUF,LABEL='IDX_H')
      call mma_allocate(VAL_H,4,NBUF,LABEL='VAL_H')
      call allgather(IDXBUF,2*IBUF,IDX_H,2*NBUF)
      call allgather(VALBUF,4*IBUF,VAL_H,4*NBUF)
      IDX => IDX_H
      VAL => VAL_H
    else
#   endif
      IDX => IDXBUF
      VAL => VALBUF
#   ifdef _MOLCAS_MPP_
    end if
#   endif

    do IBUF=1,NBUF
      IAS = IDX(1,IBUF)
      IIS = IDX(2,IBUF)
      DNOM = VAL(1,IBUF)
      RHS = VAL(2,IBUF)
      COEF = VAL(3,IBUF)
      ECNT = VAL(4,IBUF)
      if ((ICASE == 12) .or. (ICASE == 13)) then
        call EXCIND(IAS,IIS,ISYM,ICASE,IP,IQ,IR,IS)
        LINE(13:20) = ORBNAM(IP)
        LINE(21:28) = ORBNAM(IQ)
        LINE(29:36) = ORBNAM(IR)
        LINE(37:44) = ORBNAM(IS)
        LINE(45:46) = '  '
      else
        write(LINE(13:22),'(A2,I1,A1,I4.4)') 'Mu',ISYM,'.',IAS
        call NSIND(IIS,ISYM,ICASE,IP,IQ,IR)
        LINE(23:30) = ORBNAM(IP)
        LINE(31:46) = '                '
        if (IQ > 0) LINE(31:38) = ORBNAM(IQ)
        if (IR > 0) LINE(39:46) = ORBNAM(IR)
      end if
      write(u6,'(A,4F16.8)') LINE(1:46),DNOM,RHS,COEF,ECNT
    end do

#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) then
      call mma_deallocate(IDX_H)
      call mma_deallocate(VAL_H)
    end if
#   endif

    call RHS_FREE(lg_RHS)
    call RHS_FREE(lg_VEC)

    call mma_deallocate(BD)
    call mma_deallocate(ID)

    ! End of very long loop over symmetry and case:
  end do
end do

call mma_deallocate(IDXBUF)
call mma_deallocate(VALBUF)
nullify(IDX,VAL)

call CollapseOutput(0,'Denominators, etc.')

end subroutine H0SPCT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION GETH2A(I,J,K,L,TUVX)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TUVX(*)
      NI=MAX(I,J)
      NJ=MIN(I,J)
      IJ=NJ+NI*(NI-1)/2
      NK=MAX(K,L)
      NL=MIN(K,L)
      KL=NL+NK*(NK-1)/2
      NIJ=MAX(IJ,KL)
      NKL=MIN(IJ,KL)
      NIJKL=NKL+NIJ*(NIJ-1)/2
      GETH2A=TUVX(NIJKL)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Giovanni Ghigo                                   *
!***********************************************************************
!  Cho_TwoEl
!
!> @brief
!>   Driver for the generation of the two-electrons integrals file (``MOLINT``) from the Transformed Cholesky vectors TCVx
!> @author Giovanni Ghigo
!>
!> @details
!> The routine generates the symmetry
!> block \p iSymI, \p iSymJ, \p iSymA, \p iSymB of two-electrons integrals. The
!> number of integrals to generate for each  \p iSymI, \p iSymJ couple is
!> defined by \c LenInt. The exch-1 and exch-2 integrals are then
!> generated for the occupied MO calling ::Cho_GenE.
!>
!> @param[in]     iBatch                  Main batch current number
!> @param[in]     NumV                    Number of Cholesky vectors to transform in the current batch
!> @param[in]     LUINTM                  Unit number of two-electrons integrals file (``MOLINT``)
!> @param[in,out] iAddrIAD2M              Current disk address in ``MOLINT``
!> @param[in]     iSymI,iSymJ,iSymA,iSymB Symmetry block of the two-electrons integrals
!***********************************************************************

subroutine Cho_TwoEl(iBatch,numV,LUINTM,iAddrIAD2M,iSymI,iSymJ,iSymA,iSymB)
!***********************************************************************
! Author :  Giovanni Ghigo                                             *
!           Lund University, Sweden                                    *
!           October-November 2004                                      *
!----------------------------------------------------------------------*
! Routine for the generation of the new Two-electrons integrals files  *
! (MOLINT) from the Transformed Cholesky Full Vectors (TCVX).          *
!                                                                      *
! A,B are MO indices, counting only non-frozen and non-deleted.        *
! I,J are occupied MO indices, only non-frozen and non-deleted.        *
! (AB/IJ) ARE ALWAYS GENERATED                                         *
! (AI/BJ) IF ISP >= ISR                                                *
! (AI/JB) IF ISP > ISS AND ISP /= ISQ                                  *
! (IA/BJ) IF ISQ > ISR AND ISP /= ISQ                                  *
! (IA/JB) IF ISQ >= ISS AND ISP /= ISQ                                 *
!                                                                      *
!   IAD2M CONTAINS START ADRESS FOR EACH TYPE OF INTEGRALS:            *
!    IAD2M(1,ISPQRS)   COULOMB INTEGRALS <AB|IJ>                       *
!    IAD2M(2,ISPQRS)   EXCHANGE INTEGRALS <AB|IJ> FOR iSymI > iSymJ    *
!    IAD2M(3,ISPQRS)   EXCHANGE INTEGRALS <AB|IJ> FOR iSymI < iSymJ    *
!   THE LAST ADRESS IS ZERO IF iSymI = iSymJ                           *
!                                                                      *
!***********************************************************************

use Cho_Tra, only: DoCoul, DoExc2, DoTCVA, IAD2M, IfTest, nOrb, nOsh, nSsh, nSym, SubBlocks, TCVXist
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iBatch, numV, LUINTM, iSymI, iSymJ, iSymA, iSymB
integer(kind=iwp), intent(inout) :: iAddrIAD2M
integer(kind=iwp) :: i, iAddrIAD2Mij, iEndJ, iI, iIJAB, iJ, iType, j, nA, nB, nN_AB, nN_Ex1, nN_Ex2, nN_IJ, nSymP
real(kind=wp), allocatable :: AddCou(:), AddEx1(:), AddEx2(:), AddEx2t(:)

nSymP = (nSym**2+nSym)/2
call LenInt(iSymI,iSymJ,iSymA,iSymB,nN_IJ,nN_AB,nN_Ex1,nN_Ex2)
!-----------------------------------------------------------------------
if (IfTest) then
  write(u6,*)
  write(u6,'(A,4I3,A,I8,A,I9,A,I9)') '    * [CGG:Cho_TwoEl]: SYMMETRY BLOCK < A B | I J >',iSymA,iSymB,iSymI,iSymJ,': nN_AB=', &
                                     nN_AB,', nN_Ex1=',nN_Ex1,', nN_Ex2=',nN_Ex2
  if (nN_IJ*(nN_AB+nN_Ex1+nN_Ex2) == 0) write(u6,*) '                      Nothing to do!'
  call XFlush(u6)
end if
!-----------------------------------------------------------------------
if (nN_IJ*(nN_AB+nN_Ex1+nN_Ex2) > 0) then
  iIJAB = ((iSymI**2-iSymI)/2+iSymJ-1)*nSymP+(iSymA**2-iSymA)/2+iSymB

  !**** START GENERATION of COULOMB INTEGRALS **************************
  if (DoCoul .and. (nN_AB > 0)) then
    !call Def_SubBlockC(iSymA,iSymB)
    call Def_SubBlockE(iSymA,iSymB)
    !-------------------------------------------------------------------
    if (IfTest) then
      write(u6,*)
      write(u6,*) '    Generation of Coulomb Integrals'
      write(u6,*) '       Available TCVx for Cou: '
      do iType=1,6
        if (TCVXist(iType,iSymA,iSymI)) write(u6,*) '       -TCV x=',iType,' Sym=',iSymA,iSymI
        if (TCVXist(iType,iSymB,iSymJ) .and. (iSymA /= iSymB)) write(u6,*) '       -TCV x=',iType,' Sym=',iSymB,iSymJ
      end do
      write(u6,*)
      write(u6,*) '       SubBlocks to create for Cou: '
      do i=1,3
        do j=1,3
          if (SubBlocks(i,j)) write(u6,*) '       -SB(',i,',',j,')'
        end do
      end do
      call XFlush(u6)
    end if
    !-------------------------------------------------------------------
    if (iBatch == 1) then
      IAD2M(1,iIJAB) = iAddrIAD2M
    else
      iAddrIAD2M = IAD2M(1,iIJAB)
    end if
    ! Start Loop on i, j
    iAddrIAD2Mij = iAddrIAD2M
    do iI=1,nOsh(iSymI)
      if (iSymI == iSymJ) then
        iEndJ = iI
      else
        iEndJ = nOsh(iSymJ)
      end if
      do iJ=1,iEndJ
        !---------------------------------------------------------------
        if (IfTest) then
          write(u6,*)
          write(u6,*) '   Coulomb Integrals for |ij> pair',iI,iJ,'  iAddrIAD2Mij=',iAddrIAD2Mij
          call XFlush(u6)
        end if
        !---------------------------------------------------------------
        call mma_allocate(AddCou,nN_AB,Label='AddCou')
        if (iBatch > 1) then
          call dDaFile(LUINTM,2,AddCou,nN_AB,iAddrIAD2Mij)
          ! Reload Int
          iAddrIAD2Mij = iAddrIAD2Mij-nN_AB
        else
          AddCou(:) = Zero
        end if
        call Cho_GenC(iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddCou,nN_AB,nN_Ex1)
        call GAdSum(AddCou,nN_AB)
        call dDaFile(LUINTM,1,AddCou,nN_AB,iAddrIAD2Mij)
        call mma_deallocate(AddCou)
      end do
    end do
    ! End Loop on i, j
    iAddrIAD2M = iAddrIAD2Mij ! Last written+1 in iAddrIAD2M
  end if
  !**** END GENERATION of COULOMB INTEGRALS ****************************

  !**** START GENERATION of EXCHANGE-1 INTEGRALS ***********************
  if (nN_Ex1 > 0) then
    call Def_SubBlockE(iSymA,iSymB)
    !-------------------------------------------------------------------
    !If(IfTest) then
    !  write(u6,*)
    !  write(u6,*) '    Generation of Exchange-1 Integrals'
    !  write(u6,*) '       Available TCVx for Ex-1: '
    !  do iType=1,MxTCVx
    !    if (TCVXist(iType,iSymA,iSymI)) write(u6,*) '       -TCV x=',iType,' Sym=',iSymA,iSymI
    !    if (TCVXist(iType,iSymB,iSymJ) .and. (iSymA /= iSymB)) write(u6,*) '       -TCV x=',iType,' Sym=',iSymB,iSymJ
    !  end do
    !  write(u6,*)
    !  write(u6,*) '       SubBlocks to create for Ex-1: '
    !  do i=1,3
    !    do j=1,3
    !      if (SubBlocks(i,j)) write(u6,*) '       -SB(',i,',',j,')'
    !    end do
    !  end do
    !  call XFlush(u6)
    !end if
    !-------------------------------------------------------------------
    if (iBatch == 1) then
      IAD2M(2,iIJAB) = iAddrIAD2M
    else
      iAddrIAD2M = IAD2M(2,iIJAB)
    end if
    ! Start Loop on i, j
    iAddrIAD2Mij = iAddrIAD2M
    do iI=1,nOsh(iSymI)
      if (iSymI == iSymJ) then
        iEndJ = iI
      else
        iEndJ = nOsh(iSymJ)
      end if
      do iJ=1,iEndJ
        !---------------------------------------------------------------
        !if (IfTest) then
        !  write(u6,*)
        !  write(u6,*) '   Excha-1 Integrals for |ij> pair',iI,iJ,'  iAddrIAD2Mij=',iAddrIAD2Mij,'   #'
        !  call XFlush(u6)
        !end if
        !---------------------------------------------------------------
        call mma_allocate(AddEx1,nN_Ex1,Label='AddEx1')
        if (iBatch > 1) then
          ! Reload Int
          call dDaFile(LUINTM,2,AddEx1,nN_Ex1,iAddrIAD2Mij)
          iAddrIAD2Mij = iAddrIAD2Mij-nN_Ex1
        else
          AddEx1(:) = Zero
        end if
        call Cho_GenE(iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddEx1,nN_Ex1)
        call GAdSum(AddEx1,nN_Ex1)
        call dDaFile(LUINTM,1,AddEx1,nN_Ex1,iAddrIAD2Mij)
        call mma_deallocate(AddEx1)
      end do
    end do
    ! End Loop on i, j
    iAddrIAD2M = iAddrIAD2Mij
  end if
  !**** END GENERATION of EXCHANGE-1 INTEGRALS *************************

  !**** START GENERATION of EXCHANGE-2 INTEGRALS ***********************
  if ((nN_Ex2 > 0) .and. DoExc2) then
    iIJAB = ((iSymI**2-iSymI)/2+iSymJ-1)*nSymP+(iSymB**2-iSymB)/2+iSymA
    call Def_SubBlockE(iSymA,iSymB)
    ! ------------------------------------------------------------------
    !if (IfTest) then
    !  write(u6,*)
    !  write(u6,*) '    Generation of Exchange-2 Integrals'
    !  write(u6,*) '       Available TCVx for Ex-2: '
    !  do iType=1,MxTCVx
    !    if (TCVXist(iType,iSymA,iSymI)) write(u6,*) '       -TCV x=',iType,' Sym=',iSymA,iSymI
    !    if (TCVXist(iType,iSymB,iSymJ) .and. (iSymA /= iSymB)) write(u6,*) '       -TCV x=',iType,' Sym=',iSymB,iSymJ
    !  end do
    !  write(u6,*)
    !  write(u6,*) '       SubBlocks to create for Ex-2: '
    !  do i = 1, 3
    !    do j = 1, 3
    !      if (SubBlocks(i,j)) write(u6,*) '       -SB(',i,',',j,')'
    !    end do
    !  end do
    !  call XFlush(u6)
    !end if
    ! ------------------------------------------------------------------
    if (iBatch == 1) then
      IAD2M(3,iIJAB) = iAddrIAD2M
    else
      iAddrIAD2M = IAD2M(3,iIJAB)
    end if
    ! Start Loop on i, j
    iAddrIAD2Mij = iAddrIAD2M
    do iI=1,nOsh(iSymI)
      if (iSymI == iSymJ) then
        iEndJ = iI
      else
        iEndJ = nOsh(iSymJ)
      end if
      do iJ=1,iEndJ
        !---------------------------------------------------------------
        !if (IfTest) then
        !  write(u6,*)
        !  write(u6,*) '   Excha-2 Integrals for |ij> pair',iI,iJ,'  iAddrIAD2Mij=',iAddrIAD2Mij,'   #'
        !  call XFlush(u6)
        !end if
        !---------------------------------------------------------------
        if (DoTCVA) then
          nA = nOrb(iSymA)
          nB = nOrb(iSymB)
        else
          nA = nSsh(iSymA)
          nB = nSsh(iSymB)
        end if
        call mma_allocate(AddEx2,nN_Ex2,Label='AddEx2')
        call mma_allocate(AddEx2t,nN_Ex2,Label='AddEx2t')
        if (iBatch > 1) then
          ! Reload Int
          call dDaFile(LUINTM,2,AddEx2,nN_Ex2,iAddrIAD2Mij)
          iAddrIAD2Mij = iAddrIAD2Mij-nN_Ex2
          call Trnsps(nA,nB,AddEx2,AddEx2t)
        else
          AddEx2t(:) = Zero
        end if
        call Cho_GenE(iSymI,iSymJ,iSymA,iSymB,iI,iJ,numV,AddEx2t,nN_Ex2)
        call Trnsps(nB,nA,AddEx2t,AddEx2)
        !---------------------------------------------------------------
        !if (IfTest) then
        !  write(u6,*) '    Integrals from Production code:'
        !  write(u6,'(8F10.6)') (AddEx2(i),i=1,nN_Ex2)
        !  call XFlush(u6)
        !end if
        !---------------------------------------------------------------
        call GAdSum(AddEx2,nN_Ex2)
        call dDaFile(LUINTM,1,AddEx2,nN_Ex2,iAddrIAD2Mij)
        call mma_deallocate(AddEx2t)
        call mma_deallocate(AddEx2)
      end do
    end do
    ! End Loop on i, j
    iAddrIAD2M = iAddrIAD2Mij
  end if
  !**** END GENERATION of EXCHANGE-2 INTEGRALS *************************
end if

return

end subroutine Cho_TwoEl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Per Ake Malmqvist                                *
*               1989, Bjorn O. Roos                                    *
*               1991,1993, Markus P. Fuelscher                         *
*               1991,1993, Jeppe Olsen                                 *
*               1998, Roland Lindh                                     *
************************************************************************
      SUBROUTINE RASSCF(IRETURN)
************************************************************************
*                                                                      *
*           ######     #     #####   #####   #####  #######            *
*           #     #   # #   #     # #     # #     # #                  *
*           #     #  #   #  #       #       #       #                  *
*           ######  #     #  #####   #####  #       #####              *
*           #   #   #######       #       # #       #                  *
*           #    #  #     # #     # #     # #     # #                  *
*           #     # #     #  #####   #####   #####  #                  *
*                                                                      *
*                                                                      *
*                   A program for complete (CAS) and                   *
*                   restricted (RAS)SCF calculations                   *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and J. Olsen, P.Aa. Malmqvist and B.O. Roos       *
*     University of Lund, Sweden                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     MOLCAS version 1 by P.Aa. Malmqvist and B.O. Roos, 1989          *
*     MOLCAS version 2 by M.P. Fuelscher and J. Olsen  , 1991          *
*     MOLCAS version 3 by M.P. Fuelscher and J. Olsen  , 1993          *
*                                                                      *
*     Modified to process only unique symmetry blocks, R. Lindh,       *
*     March 1998.                                                      *
*                                                                      *
************************************************************************

#ifdef _DMRG_
!     module dependencies
      use qcmaquis_interface, only: qcmaquis_interface_delete_chkp,
     &  qcmaquis_interface_prepare_hirdm_template,
     &  qcmaquis_interface_deinit, qcmaquis_param,
     &  TEMPLATE_4RDM, TEMPLATE_TRANSITION_3RDM, dmrg_energy
      use qcmaquis_interface_mpssi, only: qcmaquis_mpssi_transform
#endif
      use stdalloc, only: mma_allocate, mma_deallocate
      use Fock_util_global, only: ALGO, DoActive, DoCholesky
      use write_orbital_files, only : OrbFiles, putOrbFile,
     &  write_orb_per_iter
      use filesystem, only: copy_, real_path
      use generic_CI, only: CI_solver_t
      use fciqmc, only: DoNECI, fciqmc_solver_t, tGUGA_in
      use para_info, only: king
      use fortran_strings, only: str
      use spin_correlation, only: spin_correlation_driver,
     &    orb_range_p, orb_range_q
      use CC_CI_mod, only: Do_CC_CI, CC_CI_solver_t
      use fcidump, only : make_fcidumps, transform, DumpOnly
      use orthonormalization, only : ON_scheme
#ifdef _FDE_
      use Embedding_global, only: Eemb, embInt, embPot, embPotInBasis,
     &    embPotPath, embWriteEsp
#endif
#ifdef _HDF5_
      use mh5, only: mh5_put_attr, mh5_put_dset
      use csfbas, only: CONF, KCFTP
#endif
      use OFembed, only: Do_OFemb, FMaux

      Implicit Real*8 (A-H,O-Z)

#include "WrkSpc.fh"
#include "wadr.fh"
#include "rasdim.fh"
#include "warnings.h"
#include "input_ras.fh"
#include "rasscf.fh"
#include "rasrc.fh"
#include "general.fh"
#include "gas.fh"
#include "splitcas.fh"
#include "bk_approx.fh"
#include "output_ras.fh"
#include "rctfld.fh"
#include "timers.fh"
#include "casvb.fh"
#include "rasscf_lucia.fh"
#include "lucia_ini.fh"
#include "gugx.fh"
#include "pamint.fh"
#include "qnctl.fh"
#include "orthonormalize.fh"
#include "ciinfo.fh"
#include "raswfn.fh"

      Logical DSCF
      Logical lTemp, lOPTO
#ifdef _FDE_
      Character*8 label
#endif
      Character*80 Line
      Character*1 CTHRE, CTHRSX, CTHRTE
      Logical IfOpened
#ifdef _DMRG_
      Logical Do_ESPF
      ! function defined in misc_util/pcm_on.f
      Logical, External :: PCM_On
#endif

* --------- Cholesky stuff:
#include "chopar.fh"
#include "chotime.fh"
#include "qmat.fh"
* --------- End Cholesky stuff
      Character*8 EMILOOP
* --------- FCIDUMP stuff:
      real*8, allocatable :: orbital_E(:), folded_Fock(:)
* --------- End FCIDUMP stuff:
* --------- CI-solver class
        class(CI_solver_t), allocatable :: CI_solver

! actual_iter starts at 0, so iter 1A == 0, 1B == 1, 2 == 2, 3 == 3 and so on
      integer :: actual_iter

#include "sxci.fh"

      External Get_ProgName
      Character*100 ProgName, Get_ProgName
      Character*15 STLNE2
      External RasScf_Init
      External Scan_Inp
      External Proc_Inp
#ifdef _DMRG_
      integer :: maxtrR
      real*8  :: maxtrW
#include "nevptp.fh"
#endif
      Dimension Dummy(1)

* Set status line for monitor:
      Call StatusLine('RASSCF:',' Just started.')

* Set the return code(s)
      ITERM  = 0
      IRETURN=_RC_ALL_IS_WELL_

* Set the HDF5 file id (a proper id will never be 0)
      wfn_fileid = 0

* Set some Cholesky stuff
      DoActive=.true.
      DoQmat=.false.
      lOPTO=.False.
* Initialise doDMRG if compiled without QCMaquis
#ifndef _DMRG_
      DoDMRG = .false.
#endif

* Set variable IfVB to check if this is a VB job.
      ProgName=Get_ProgName()
      IfVB=0
      If (ProgName(1:5).eq.'casvb') IfVB=2
* Default option switches and values, and initial data.
      THMAX=0.0d0
      Call RasScf_Init()
      Call Seward_Init()
* Open the one-olectron integral file:
       LuOne=77
       LuOne=isFreeUnit(LuOne)
       iRC=-1
       iOpt=0
       Call OpnOne(iRC,iOpt,'ONEINT',LuOne)
       If (iRC.ne.0) Then
        Write (6,*) 'Error when trying to open the one-electron'
        Write (6,*) 'integral file.'
        Call Quit(_RC_INTERNAL_ERROR_)
       End If
       Call StatusLine('RASSCF:',' Read-in ONEINT')
      If (IfVB.eq.2) go to 10

*
* Make a copy, upper-cased, left-adjusted, of the input between and including
* the '&RASSCF' and the 'End of input' markers, skipping all lines beginning
* with '*' or '!' or ' '  when left-adjusted, and replacing any rightmost
* substring beginning with '!' with blanks.
* That copy will be in file 'CleanInput', and its unit number is returned
* as LUInput in common (included file input_ras.fh) by the following call:
      Call cpinp(LUInput,iRc)
* If something wrong with input file:
      If (iRc.ne._RC_ALL_IS_WELL_) Then
       Call WarningMessage(2,'Input file is unusable.')
       Write(6,*)' RASSCF Error: Could not make a clean copy of'
       Write(6,*)' the input file. This is an unexpected bug.'
       IRETURN=_RC_INTERNAL_ERROR_
       GOTO 9990
      End If

* Scan the input file for keywords:
      Call Scan_Inp(iRc)
* If something wrong with input file:
      If (iRc.ne._RC_ALL_IS_WELL_) Then
       If (IPRLOC(1).GE.TERSE) Then
        Call WarningMessage(2,'Scanning input file failed.')
* Calling again, now with iRc indicating an error, will echo the keywords:
        Call Scan_Inp(iRc)
       End If
       IRETURN=_RC_INPUT_ERROR_
       GOTO 9990
      End If

* Local print level in this routine:
      IPRLEV=IPRLOC(1)
*
10    CONTINUE
* Open files
      Call OpnFls_RASSCF(DSCF,DoCholesky)

* Some preliminary input data:
      Call Rd1Int
      If ( .not.DSCF ) Call Rd2Int_RASSCF

* Printed program header:

* Process the input:
      Call StatusLine('RASSCF:',' Processing input')
      Call Proc_Inp(DSCF,lOPTO,iRc)
* If something goes wrong in proc_inp:
      If (iRc.ne._RC_ALL_IS_WELL_) Then
       If (IPRLEV.ge.TERSE) Then
        Call WarningMessage(2,'Input processing failed.')
        Write(6,*)' RASSCF Error: Proc_Inp failed unexpectedly.'
        Write(6,*)' Check the output file for any previous messages'
        Write(6,*)' that can help explain the failure.'
        Write(6,*)' Here is a printing of the input file that'
        Write(6,*)' was processed:'
        Rewind(LUInput)
  15    Continue
        Read(LuInput,'(A80)',End=16,Err=16) Line
        Write(6,*) Line
        Go To 15
  16    Continue
       End If
       IRETURN=iRc
       GOTO 9990
      End If


* Local print level may have changed:
      IPRLEV=IPRLOC(1)


      Call InpPri(lOpto)

* Note that CI_solver subclasses provide a cleanup procedure
* (C++ people might call it destructor). Hence the deallocation and
* cleanup is automatically performed, when it goes out of scope.
      if (DoNECI) then
        allocate(CI_solver, source=fciqmc_solver_t(tGUGA_in))
      else if (Do_CC_CI) then
        allocate(CI_solver, source=CC_CI_solver_t())
      end if

*
* If this is not CASDFT make sure the DFT flag is unset
*
      If (KSDFT(1:3).eq.'SCF') Then
        Call Get_iScalar('System BitSwitch',iFlags)
        iFlags=iAnd(iFlags,Not(2**6))
        Call Put_iScalar('System BitSwitch',iFlags)
      End If

* If the ORBONLY option was chosen, then Proc_Inp just generated
*  orbitals from the JOBIPH file. Nothing more to do:
      IF((KeyORBO).or.(MAXIT.eq.0)) GOTO 9989
#ifdef _DMRG_
      ! delete old checkpoints, unless requested otherwise
      ! this flag is set in proc_inp
      if (.not.DoDelChk) then
        do kroot=1,nroots
          call qcmaquis_interface_delete_chkp(iroot(kroot))
        end do
      end if
#endif
*
* Allocate various matrices
*
      Call GetMem('FI','Allo','Real',LFI,NTOT1)
      Call GetMem('FA','Allo','Real',LFA,NTOT1)
      Call GetMem('D1I','Allo','Real',LD1I,NTOT2)
      Call GetMem('D1A','Allo','Real',LD1A,NTOT2)
      Call GetMem('D1tot','Allo','Real',LD1tot,NTOT1)
      Call GetMem('OCCN','Allo','Real',LOCCN,NTOT)
      Call GetMem('LCMO','Allo','Real',LCMO,NTOT2)
      Call GetMem('DIAF','Allo','Real',LDIAF,NTOT)
#ifdef _DMRG_
* Allocate RDMs for the reaction field reference root in QCMaquis calculations
      if (doDMRG.and.PCM_On()) then
        Call GetMem('D1RF','Allo','Real',LW_RF1,NACPAR)
        if (twordm_qcm) then
          Call GetMem('D2RF','Allo','Real',LW_RF2,NACPR2)
        end if
      end if
#endif
      lfi_cvb=lfi
      lfa_cvb=lfa
      ld1i_cvb=ld1i
      ld1a_cvb=ld1a
      ld1tot_cvb=ld1tot
      loccn_cvb=loccn
      lcmo_cvb=lcmo
      ldiaf_cvb=ldiaf
      Call FZero(Work(LFA),NTOT1)
      Call FZero(Work(LDIAF),NTOT)
*
      LTUVX=1
      LDMAT=1
      LDSPN=1
      LPMAT=1
      LPA  =1

      If (iCIRST.eq.1.and.DumpOnly) then
        write(6,*) 'ICIRST and DumpOnly flags are not compatible!'
        write(6,*) 'Choose only one.'
        Call Abend
      end if

      If(DumpOnly) then
        write(6,*) 'Dumping integrals.'
        write(6,*) 'Nothing else will be done.'
      end if

        If ( NAC.GT.0 ) then
         Call GetMem('TUVX','Allo','Real',LTUVX,NACPR2)
         Call FZero(Work(LTUVX),NACPR2)
         ltuvx_cvb=ltuvx
         Call GetMem('DSPN','Allo','Real',LDSPN,NACPAR)
         call dcopy_(NACPAR,[0.0d0],0,Work(LDSPN),1)
         if(.not.DumpOnly) then
           Call GetMem('DMAT','Allo','Real',LDMAT,NACPAR)
           Call GetMem('PMAT','Allo','Real',LPMAT,NACPR2)
           Call GetMem('P2AS','Allo','Real',LPA,NACPR2)
           call dcopy_(NACPAR,[0.0d0],0,Work(LDMAT),1)
           ldmat_cvb=ldmat
           ldspn_cvb=ldspn
           lpmat_cvb=lpmat
           lpa_cvb=lpa
         end if
        Else
         LTUVX = ip_Dummy
         ltuvx_cvb=ltuvx
         LDMAT = ip_Dummy
         LDSPN = ip_Dummy
         LPMAT = ip_Dummy
         LPA   = ip_Dummy
        End If
#ifdef _FDE_
      ! Embedding
      iDummyEmb=0
      Call Get_iScalar('embpot', iDummyEmb)
      if (iDummyEmb.eq.1) embPot=.true.
      if (embPot) then
       Call EmbPotRdRun
      end if
      if (embpot) then
       ! I have no idea why i need memory for x+4 entries
       ! and not just x...
       call mma_allocate(embInt,NTOT1+4,label='Emb')
       if (embPotInBasis) then
        ! If the potential is given in basis set representation it
        ! has not been calculated with a OneEl call and is just read
        ! from file here.
        iunit = isFreeUnit(1)
        call molcas_open(iunit, embPotPath)
        do iEmb=1, NTOT1
         read(iunit,*) embInt(iEmb)
        end do
       else
        ! Read in the embedding potential one-electron integrals
        Label='embpot  '
        iRC=-1
        iOpt=0
        Call RdOne(iRC,iOpt,Label,1,embInt,iSyLbl)
        If (iRC.ne.0) then
         Call WarningMessage(2,
     &                'Drv1El: Error reading ONEINT;'
     &              //'Label='//Label)
         Call Quit(_RC_IO_ERROR_READ_)
        End If
       end if
      end if
#endif

*
* Get start orbitals

* Initialize OCCN array, to prevent false alarms later from
* automated detection of using uninitialized variables:
      call dcopy_(NTot,[0.0D0],0,Work(lOCCN),1)

* PAM03: Note that removal of linear dependence may change the nr
* of secondary/deleted orbitals, affecting some of the global
* variables: NSSH(),NDEL(),NORB(),NTOT3, etc etc
      Call ReadVc(Work(LCMO),Work(lOCCN),
     & WORK(LDMAT),WORK(LDSPN),WORK(LPMAT),WORK(LPA),ON_scheme)
      if (KeyORTH) then
! TODO(Oskar): Add fourth argument OCC
!   If the Occupation number is written properly as well.
        call putOrbFile(CMO=Work(lCMO : lCMO + nTot2 - 1),
     &                  orbital_E=work(lDIAF : lDIAF + nTot - 1),
     &                  iDoGAS=iDoGAS)
      end if
* Only now are such variables finally known.

*
* Allocate core space for dynamic storage of data
*
      CALL ALLOC
*
* Create job interphase on unit JOBIPH (FT15)
*

      if(ifvb.ne.2) then
        CALL CREIPH
        call cre_raswfn
      end if
      if(ifvb.eq.1)call casinfo2_cvb()

      Call Timing(Swatch,Swatch,Ebel_1,Swatch)

CGG03 Aug 03
      If(NAlter.gt.0) Call Alter_MO(Work(LCMO))

c At this point all is ready to potentially dump MO integrals... just do it if required.
      If(DumpOnly) goto 20
      if(ifvb.eq.2)goto 20

      if(dofcidump)then
        Write(LF,*)
        Write(LF,'(26X,A)')
     &  'Dumping integrals on file FCIDUMP - nothing else to be done'
        goto 20
      end if

************************************************************************
*
* Wave function section
*
************************************************************************

      Call StatusLine('RASSCF:',' Compute wave function.')
      If ( IPRLEV.GE.2 .AND..NOT.lOPTO) then
       Write(LF,*)
       Write(LF,'(6X,120A1)') ('*',i=1,120)
       Write(LF,'(6X,A,118X,A)') '*','*'
       Write(LF,'(6X,A,44X,A,45X,A)')
     &      '*','Wave function control section','*'
       Write(LF,'(6X,A,118X,A)') '*','*'
       Write(LF,'(6X,120A1)') ('*',i=1,120)
       Write(LF,*)
      End If

      If ( IPRLEV.GE.2 .AND..NOT.lOPTO) then
       IF (ICIONLY.eq.0) THEN
        Write(LF,*)
        if(doDMRG)then
          Write(LF,'(41X,A)')
     &         'DMRGSCF iterations: Energy and convergence statistics'
          Write(LF,'(41X,A)')
     &         '-----------------------------------------------------'
        else
          Write(LF,'(41X,A)')
     &         'RASSCF iterations: Energy and convergence statistics'
          Write(LF,'(41X,A)')
     &         '----------------------------------------------------'
        end if
        Write(LF,*)
       ELSE
        Write(LF,*)
        if(doDMRG)then
          Write(LF,'(41X,A)')
     &        'DMRGCI only, no orbital optimization will be done.'
          Write(LF,'(41X,A)')
     &        '--------------------------------------------------'
        else
          Write(LF,'(41X,A)')
     &        'CASCI only, no orbital optimization will be done.'
          Write(LF,'(41X,A)')
     &        '-------------------------------------------------'
        end if
        Write(LF,*)
       END IF
#ifdef _DMRG_
       if(doDMRG)then
          Write(LF,'(45x,a//,36x,a/,36x,a/,36x,a//,45x,a//,'//
     &               '36x,a/,36x,a/,36x,a//,36x,a/,36x,a,a/,36x,a//)')
     &        'Please cite for the QCMaquis-Molcas driver:',
     &        'Freitag L.; Keller S.; Knecht S.; Lindh R.; Ma Y.; ',
     &        'Stein C. J. and Reiher M., in preparation. (2018).',
     &        '------------------------------------------------'//
     &        '---------------',
     &        'Please cite for the QCMaquis DMRG software:',
     &        'S. Keller, M. Dolfi, M. Troyer, M. Reiher,',
     &        'J. Chem. Phys. 143, 244118 (2015)',
     &        '------------------------------------------------'//
     &        '---------------'
       end if
#endif
       IF(INOCALC.EQ.1) THEN
         WRITE(LF,*)
         WRITE(LF,'(26X,A)')
     &      ' No calculation will be performed. Stopping in LUCIA'
       END IF
       IF(ISAVE_EXP.EQ.1) THEN
         WRITE(LF,*)
         WRITE(LF,'(26X,A)')
     &      ' Information on the CI-vector will be written to ???.'
       END IF
       IF(IEXPAND.EQ.1) THEN
         WRITE(LF,*)
         WRITE(LF,'(26X,A)')
     &      ' A shorter vector will be expanded in a longer'
       END IF
       If ( IPRLEV.LE.3) then
        If(DoSplitCAS) then
         Write(LF,'(6X,A)')
     &         'Iter CI   SX   CI       SplitCAS       Energy    '//
     &         'max ROT     max BLB   max BLB  Level Ln srch  Step '//
     &         '  QN   Walltime'
         Write(LF,'(6X,A)')
     &         '    iter iter root      energy       change    '//
     &         ' param      element    value   shift minimum  type '//
     &         'update hh:mm:ss'
        else if (DoBKAP) then
         Write(LF,'(6X,A)')
     &         'Iter CI   SX   CI   RASSCF      CI    Energy    '//
     &         'max ROT     max BLB   max BLB  Level Ln srch  Step '//
     &         '  QN   Walltime'
         Write(LF,'(6X,A)')
     &         '    iter iter root  energy    energy  change    '//
     &         ' param      element    value   shift minimum  type '//
     &         'update hh:mm:ss'
        else if (DoDMRG .and. ICIONLY == 0)then
         Write(LF,'(6X,A)')
     &         'Iter num  DMRG max tr DMRG  SX      DMRGSCF'//
     &         '       Energy    '//
     &         'max ROT   max BLB     max BLB  Level Ln srch  Step '//
     &         '  QN     CPU Time'
         Write(LF,'(6X,A)')
     &         '   sweeps/root weight/root iter     energy'//
     &         '        change    '//
     &         ' param    element      value   shift minimum  type '//
     &         'update   hh:mm:ss'
        else if (DoDMRG .and. ICIONLY /= 0)then

        else if( l_casdft ) then

        else
         Write(LF,'(6X,A)')
     &         'Iter CI   SX   CI       RASSCF       Energy    '//
     &         'max ROT     max BLB   max BLB  Level Ln srch  Step '//
     &         '  QN   Walltime'
         Write(LF,'(6X,A)')
     &         '    iter iter root      energy       change    '//
     &         ' param      element    value   shift minimum  type '//
     &         'update hh:mm:ss'
        end if
       End If
      End If
20    continue
*                                                                      *
************************************************************************
*                                                                      *
*     Start iterations
*                                                                      *
************************************************************************
*                                                                      *
      Rc_CI  = 0
      Rc_SX  = 0
      ECAS   = 0.0d0
      ROTMAX = 0.0d0
      ITER   = 0
      actual_iter = 0
      IFINAL = 0
      TMXTOT = 0.0D0
      Call GetMem('FOcc','ALLO','REAL',ipFocc,nTot1)
      ipfocc_cvb=ipfocc
*                                                                      *
************************************************************************
*                                                                      *
*     Entry point for second and successive iterations
*                                                                      *
************************************************************************
*                                                                      *
 1000 CONTINUE

      if( l_casdft ) then
        KSDFT_TEMP=KSDFT
        KSDFT='SCF'
        ExFac=1.0D0
      else
         KSDFT_TEMP=KSDFT
         ExFac=Get_ExFac(KSDFT)
      end if

      ITER=ITER+1
      Write(STLNE2,'(A12,I3)')' Iteration ',ITER
      Call StatusLine('RASSCF:',STLNE2)
      Call Timing(Swatch,Swatch,Certina_1,Swatch)
#ifdef _DMRG_
      ! Leon 27/11/2017: Skip the first CI iteration if we're using
      ! DMRGCI and CIOnly.It's enabled only for DMRGCI with QCMaquis
      ! now, (to exclude potential side effects)
      ! but consider extending it to other cases!
      call DecideOnESPF(Do_ESPF)
      !write(LF,*) ' |rasscf> DecideOnESPF == ',Do_ESPF
      If (( ITER.EQ.1 ).and.((.not.(DoDMRG.and.(ICIONLY.NE.0))).or.lRf
     &    .or.domcpdftDMRG.or.Do_ESPF))THEN
#else
      If ( ITER.EQ.1 ) THEN
#endif
************************************************************************
*     ^   First iteration
************************************************************************
*

* Print header to file containing informations on CI iterations.
*
        Write(IterFile,'(20A4)') ('****',i=1,20)
        Write(IterFile,'(15X,A)') 'RASSCF iteration: 1A'
*
        Start_Vectors=.True.
        lTemp = lRf
*
* Transform two-electron integrals and compute at the same time
* the Fock matrices FI and FA
*
        Call Timing(Swatch,Swatch,Fortis_1,Swatch)

        If (.not.DoCholesky .or. ALGO.eq.1) Then
           Call GetMem('PUVX','Allo','Real',LPUVX,NFINT)
           Call FZero(Work(LPUVX),NFINT)
        EndIf

        Call Get_D1I_RASSCF(Work(LCMO),Work(lD1I))
        If ( IPRLEV.ge.DEBUG ) then
          Write(LF,*)
          Write(LF,*) ' D1I in AO basis in RASSCF'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
             call wrtmat(Work(lD1I+ioff-1),iBas,iBas, iBas, iBas)
            iOff = iOff + iBas*iBas
          End Do
        End If

* Compute D1A from CMO coefficients and, if CIREstart, old DMAT.
        If (iCIRST.eq.1) Then

           Call GetMem('TmpDMAT','Allo','Real',ipTmpDMAT,NACPAR)
           call dcopy_(NACPAR,Work(LDMAT),1,Work(ipTmpDMAT),1)
           If (NASH(1).ne.NAC) Call DBLOCK(Work(ipTmpDMAT))
           Call Get_D1A_RASSCF(Work(LCMO),Work(ipTmpDMAT),WORK(LD1A))
           Call GetMem('TmpDMAT','Free','Real',ipTmpDMAT,NACPAR)

           DoActive = .true.

        Else

           lRf = .false.
           IF( .not.l_casdft )  then
             KSDFT='SCF'
             ExFac=1.0D0
           end IF
           Call dcopy_(NTOT2,[0.0D0],0,WORK(LD1A),1)

           DoActive = .false.

        End If

        DoQmat=.false.

        IPR=0
        IF(IPRLOC(2).EQ.4) IPR=5
        IF(IPRLOC(2).EQ.5) IPR=10

        If ( IPRLEV.ge.DEBUG ) then
          Write(LF,*)
          Write(LF,*) ' PUVX in rasscf bf first TRACTL2'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          call wrtmat(Work(LPUVX),1,nFint, 1, nFint)

          Write(LF,*)
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          Write(LF,*) ' D1A in AO basis in RASSCF bf TRACTL2 1'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            call wrtmat(Work(lD1A+ioff-1),iBas,iBas, iBas, iBas)
            iOff = iOff + iBas*iBas
          End Do
        end if

*
* Transform two-electron integrals and compute the Fock matrices FI and FA
* FI and FA are output from TRACTL2...
        CALL TRACTL2(WORK(LCMO),WORK(LPUVX),WORK(LTUVX),WORK(LD1I),
     &               WORK(LFI),WORK(LD1A),WORK(LFA),IPR,lSquare,ExFac)

c         Write(6,*) ' TUVX after TRACTL2'
c         write(6,*) (WORK(LTUVX+ind),ind=0,NACPR2-1)
        IF (ITER.eq.1 .and. IfCRPR) Then
* Core shift applied to projection of WF with doubly occupied core
          Call MkCRVEC(Work(LCMO),Work(LCRVEC))
        END IF

        If ( IPRLEV.ge.DEBUG ) then
          Write(LF,*)
          Write(LF,*) ' D1A in AO basis in RASSCF af TRACTL2 1'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            call wrtmat(Work(lD1A+ioff-1),iBas,iBas, iBas, iBas)
            iOff = iOff + iBas*iBas
          End Do

          Write(LF,*)
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          Write(LF,*) ' PUVX in rasscf af first TRACTL2'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          call wrtmat(Work(LPUVX),1,nFint, 1, nFint)

          Write(LF,*)
          Write(LF,*) ' ---------------------'

          Write(6,*) ' TUVX after TRACTL2'
          write(6,*) (WORK(LTUVX+ind),ind=0,NACPR2-1)
          Write(LF,*)
          Write(LF,*) ' ---------------------'
        end if

        If (.not.DoCholesky .or. ALGO.eq.1) Then
          Call GetMem('PUVX','Free','Real',LPUVX,NFINT)
        EndIf

        Call Timing(Swatch,Swatch,Fortis_2,Swatch)
        Fortis_2 = Fortis_2 - Fortis_1
        Fortis_3 = Fortis_3 + Fortis_2

        If ( IPRLEV.ge.DEBUG ) then
          Write(LF,*)
          Write(LF,*) ' CMO in RASSCF bf first call to CICTL'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          ioff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            if(iBas.ne.0) then
              write(6,*) 'Sym =', iSym
              do i= 1,iBas
                write(6,*) (Work(LCMO+ioff-1+iBas*(i-1)+j),j=0,iBas-1)
              end do
              iOff = iOff + (iBas*iBas)
            end if
          End Do
        End If

*
* Compute initial CI vectors and density matrices
*
        Call Timing(Swatch,Swatch,Zenith_1,Swatch)

        if (DumpOnly) then
          call mma_allocate(orbital_E, nTot)
          call mma_allocate(folded_Fock, nAcPar)
          call transform(iter,
     &                   CMO=work(LCMO : LCMO + nTot2 - 1),
     &                   DIAF=work(LDIAF : LDiaf + nTot - 1),
     &                   D1I_AO=work(lD1I : lD1I + nTot2 - 1),
     &                   D1A_AO=work(lD1A : lD1A + nTot2 - 1),
     &                   D1S_MO=work(lDSPN : lDSPN + nAcPar - 1),
     &                   F_IN=work(lFI : lFI + nTot1 - 1),
     &                   orbital_E=orbital_E,
     &                   folded_Fock=folded_Fock)
          call make_fcidumps('FCIDUMP', 'H5FCIDUMP',
     &      orbital_E, folded_Fock,
     &      TUVX=work(ltuvx : ltuvx + nAcPr2 - 1), core_energy=EMY)
          call mma_deallocate(orbital_E)
          call mma_deallocate(folded_Fock)
          write(6,*) "FCIDMP file generated. Here for serving you!"
          goto 2010
        end if

        if (allocated(CI_solver)) then
          call CI_solver%run(actual_iter=actual_iter,
     &                    ifinal=ifinal,
     &                    iroot=iroot,
     &                    weight=weight,
     &                    CMO=work(LCMO : LCMO + nTot2 - 1),
     &                    DIAF=work(LDIAF : LDiaf + nTot - 1),
     &                    D1I_AO=work(lD1I : lD1I + nTot2 - 1),
     &                    D1A_AO=work(lD1A : lD1A + nTot2 - 1),
     &                    TUVX=work(ltuvx : ltuvx + nAcPr2 - 1),
     &                    F_IN=work(lFI : lFI + nTot1 - 1),
     &                    D1S_MO=work(lDSPN : lDSPN + nAcPar - 1),
     &                    DMAT=work(lDMAT : lDMAT + nAcPar - 1),
     &                    PSMAT=work(lpmat : lPMat + nAcpr2 - 1),
     &                    PAMAT=work(lpa : lpa + nAcPr2 - 1))

#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_ || defined _ENABLE_DICE_SHCI_
        else If(DoBlockDMRG) then
          CALL DMRGCTL(WORK(LCMO),
     &                 WORK(LDMAT),WORK(LDSPN),WORK(LPMAT),WORK(LPA),
     &                 WORK(LFI),WORK(LD1I),WORK(LD1A),
     &                 WORK(LTUVX),IFINAL,0)
#endif
        else
          CALL CICTL(WORK(LCMO),
     &               WORK(LDMAT),WORK(LDSPN),WORK(LPMAT),WORK(LPA),
     &               WORK(LFI),WORK(LFA),WORK(LD1I),WORK(LD1A),
     &               WORK(LTUVX),IFINAL)

          if(dofcidump)then
           write(LF,*) " FCIDUMP file generated. This is the end..."
           goto 9990
          end if
#ifdef _FDE_
          !Thomas Dresselhaus
          if (embpot) then
            !Eemb=DDot_(NACPAR,embInt,1,Work(LDMAT),1)
!           Eemb=embPotEne(Work(LD1I), Work(LD1A), embInt,
!    &                   Work(LCMO), nBasFunc, nFrozenOrbs, .true.)
            Eemb=embPotEneMODensities(Work(LD1I), Work(LD1A),
     &            embInt, nBas, nTot2, nSym)
            Write(LF,*) "Energy from embedding potential with the"
            Write(LF,*) "initial CI vectors: ", Eemb
          end if
        !!!!!!!!!!!!!!!!!!!
#endif
* PAM 2015: Additional output line.
          If ( IPRLEV.ge.USUAL .and. .not. doDMRG) Then
             write(6,'(a,i4)')' Nr of preliminary CI iterations:',ITERCI
          End If
        end if

c.. dongxia testing jobiph
c.. upt to here, jobiph are all zeros at iadr15(2)
* If CASVB job, go directly to return.
        invec_cvb=invec
        If (DSCF) NewFock=1
        If (IfVB.eq.2) GoTo 9990

        EAV=0.0d0
        If(DoSplitCAS) then
          EAV = ENER(lRootSplit,ITER)
        Else
          DO KROOT=1,NROOTS
            EAV=EAV+ENER(IROOT(KROOT),ITER)*WEIGHT(KROOT)
          END DO
        End If

        Call Get_D1A_RASSCF(WORK(LCMO),WORK(LDMAT),WORK(LD1A))

        If ( IPRLEV.ge.DEBUG ) then
          Write(LF,*)
          Write(LF,*) ' D1A in AO basis in RASSCF af Get_D1A_RASSCF'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            call wrtmat(Work(lD1A+ioff-1),iBas,iBas, iBas, iBas)
            iOff = iOff + iBas*iBas
          End Do
        end if

        Call Timing(Swatch,Swatch,Zenith_2,Swatch)
        Zenith_2 = Zenith_2 - Zenith_1
        Zenith_3 = Zenith_3 + Zenith_2
        lRf = lTemp

        IF( .not.l_casdft ) then
          KSDFT=KSDFT_TEMP
          ExFac=Get_ExFac(KSDFT)
        end IF

*     v GLM for MC-PDFT
      If(KSDFT.ne.'SCF'.and.KSDFT.ne.'PAM'.or.l_casdft) Then
        If ( IPRLEV.ge.DEBUG ) then
          Write(LF,*)
          Write(LF,*) ' CMO in RASSCF bf call NATORB_RASSCF'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          ioff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            if(iBas.ne.0) then
              write(6,*) 'Sym =', iSym
              do i= 1,iBas
                write(6,*) (Work(LCMO+ioff-1+iBas*(i-1)+j),j=0,iBas-1)
              end do
              iOff = iOff + (iBas*iBas)
            end if
          End Do
        End If

        Call GetMem('CMON','Allo','Real',LCMON,NTOT2)
        Call GetMem('OCCX','Allo','Real',LOCCX,NTOT)
        noscr1=max(nacpar,no2m)
        Call GetMem('NOscr1','Allo','Real',lNOscr1,noscr1)
        Call GetMem('NOscr2','Allo','Real',lNOscr2,NO2M)
        Call GetMem('SMAT','Allo','Real',LSMAT,NTOT1)
        CALL NATORB_RASSCF(Work(LCMO),
     &            Work(lNOscr1),Work(lNOscr2),Work(LSMAT),
     &            Work(LCMON),Work(LOCCX))
        Call dCopy_(NTOT2,WORK(LCMON),1,WORK(LCMO),1)
        Call Put_CMO(WORK(LCMO),ntot2)
        Call GetMem('NOscr1','Free','Real',lNOscr1,NOscr1)
        Call GetMem('NOscr2','Free','Real',lNOscr2,NO2M)
        Call GetMem('SMAT','Free','Real',LSMAT,NTOT1)
        Call GetMem('OCCX','Free','Real',LOCCX,NTOT)
        Call GetMem('CMON','Free','Real',LCMON,NTOT2)
        If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' CMO in RASSCF af call NATORB_RASSCF & bf 2 CICTL'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         ioff=1
         Do iSym = 1,nSym
           iBas = nBas(iSym)
           if(iBas.ne.0) then
             write(6,*) 'Sym =', iSym
             do i= 1,iBas
               write(6,*) (Work(LCMO+ioff-1+iBas*(i-1)+j),j=0,iBas-1)
             end do
             iOff = iOff + (iBas*iBas)
           end if
         End Do
        End If
      End If
*     ^ GLM End If for MC-PDFT

        EAV=0.0d0
        DO KROOT=1,NROOTS
         EAV=EAV+ENER(IROOT(KROOT),ITER)*WEIGHT(KROOT)
        END DO
        If ( IPRLEV.ge.DEBUG ) then
          IF( l_casdft ) then
            write(6,*) 'EAV value in RASSCF after first call to CICTL:'
            write(6,*) EAV
          END if
        End if
      END IF
************************************************************************
*     ^ End First iteration
************************************************************************
*
* Print header to file containing informations on CI iterations.
*
      actual_iter = actual_iter + 1
      Write(IterFile,*)
      Write(IterFile,'(20A4)') ('****',i=1,20)
      IF (Iter .Eq. 1) Then
         Write(IterFile,'(15X,A)') 'RASSCF iteration: 1B'
      Else
         Write(IterFile,'(15X,A,I3)') 'RASSCF iteration: ',Iter
      End If
*
      If ( IPRLEV.ge.DEBUG .and. l_casdft) then
        write(6,*) ('*',i=1,70)
        write(6,*) 'we are done withe first standard CAS-CI iteration  '
        write(6,*) 'CI coeffs are known and mantained fix in next stage'
        write(6,*) 'We are now going to remove exchange from FI and FA '
        write(6,*) 'in TRACTL2 --> TRA_CTL2 --> TRADRV --> FTWO        '
        write(6,*) 'the ExFac is going to be set to 0.0d0 as DT asked! '
        write(6,*) 'FI and FA are going to change... '
        write(6,*) 'Check with previous printout to see differences.\  '
        write(6,*) ('*',i=1,70)
      End if


      IF( l_casdft ) then
        KSDFT=KSDFT_TEMP
        ExFac=0.0d0
      end IF


      IF(ICIONLY.NE.0) IFINAL=1
*
* Transform two-electron integrals and compute at the same time
* the Fock matrices FI and FA
*
      Call Timing(Swatch,Swatch,Fortis_1,Swatch)
      If (.not.DoCholesky .or. ALGO.eq.1) Then
         Call GetMem('PUVX','Allo','Real',LPUVX,NFINT)
         Call FZero(Work(LPUVX),NFINT)
      EndIf
      Call Get_D1I_RASSCF(Work(LCMO),Work(lD1I))

      DoActive = .true.

      If (DoCholesky.and.ALGO.eq.2) Then
         DoQmat=.true. ! to be used in the subsequent SX-section
         NTav=0
         do iSym=1,nSym
            NTav = NTav + nBas(iSym)*nAsh(iSym)
         end do
         Call GetMem('Q-mat','Allo','Real',ipQmat,NTav)
         Call Fzero(Work(ipQmat),NTav)
      EndIf

       IPR=0
       IF(IPRLOC(2).EQ.4) IPR=5
       IF(IPRLOC(2).EQ.5) IPR=10
       If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' D1A in AO basis in RASSCF bf TRACTL2 2'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         iOff=1
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          call wrtmat(Work(lD1A+ioff-1),iBas,iBas, iBas, iBas)
          iOff = iOff + iBas*iBas
         End Do
       end if
       CALL TRACTL2(WORK(LCMO),WORK(LPUVX),WORK(LTUVX),WORK(LD1I),
     &              WORK(LFI),WORK(LD1A),WORK(LFA),IPR,lSquare,ExFac)

      If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' D1A in AO basis in RASSCF af TRACTL2 2'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         iOff=1
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          call wrtmat(Work(lD1A+ioff-1),iBas,iBas, iBas, iBas)
          iOff = iOff + iBas*iBas
         End Do
      end if

      If (.not.DoCholesky .or. ALGO.eq.1) Then
         Call GetMem('PUVX','Free','Real',LPUVX,NFINT)
      EndIf

      Call Timing(Swatch,Swatch,Fortis_2,Swatch)
      Fortis_2 = Fortis_2 - Fortis_1
      Fortis_3 = Fortis_3 + Fortis_2

*
* Compute the CI vectors and density matrices
*
      IF (.not. l_casdft) THEN !the following is skipped in CASDFT-GLM

        If(KSDFT.ne.'SCF'.and.KSDFT.ne.'PAM') Then
          Call Put_CMO(WORK(LCMO),ntot2)
        End If

        Call Timing(Swatch,Swatch,Zenith_1,Swatch)
        if (allocated(CI_solver)) then
          call CI_solver%run(actual_iter=actual_iter,
     &                    ifinal=ifinal,
     &                    iroot=iroot,
     &                    weight=weight,
     &                    CMO=work(LCMO : LCMO + nTot2 - 1),
     &                    DIAF=work(LDIAF : LDiaf + nTot - 1),
     &                    D1I_AO=work(lD1I : lD1I + nTot2 - 1),
     &                    D1A_AO=work(lD1A : lD1A + nTot2 - 1),
     &                    TUVX=work(ltuvx : ltuvx + nAcPr2 - 1),
     &                    F_IN=work(lFI : lFI + nTot1 - 1),
     &                    D1S_MO=work(lDSPN : lDSPN + nAcPar - 1),
     &                    DMAT=work(lDMAT : lDMAT + nAcPar - 1),
     &                    PSMAT=work(lpmat : lPMat + nAcpr2 - 1),
     &                    PAMAT=work(lpa : lpa + nAcPr2 - 1))
#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_ || defined _ENABLE_DICE_SHCI_
        else If(DoBlockDMRG) Then
            CALL DMRGCTL(WORK(LCMO),
     &             WORK(LDMAT),WORK(LDSPN),WORK(LPMAT),WORK(LPA),
     &             WORK(LFI),WORK(LD1I),WORK(LD1A),
     &             WORK(LTUVX),IFINAL,1)
#endif
        else
          CALL CICTL(WORK(LCMO),
     &               WORK(LDMAT),WORK(LDSPN),WORK(LPMAT),WORK(LPA),
     &               WORK(LFI),WORK(LFA),WORK(LD1I),WORK(LD1A),
     &               WORK(LTUVX),IFINAL)
        end if

c      call triprt('twxy',' ',WORK(LTUVX),nAc*(nAc+1)/2)
c      call triprt('P-mat 2',' ',WORK(LPMAT),nAc*(nAc+1)/2)

        EAV=0.0d0
        If (DoSplitCAS) Then
          EAV = ENER(lRootSplit,ITER)
        Else
         DO KROOT=1,NROOTS
           EAV=EAV+ENER(IROOT(KROOT),ITER)*WEIGHT(KROOT)
         END DO
        End If

        IF (IPRLEV.ge.DEBUG) THEN
          write(6,*) 'EAV value in RASSCF after second call to CICTL:'
          write(6,*) EAV

          write(6,*) 'Printing matrices in RASSCF'
          Write(LF,*)
          Write(LF,*) ' CMO in RASSCF'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          ioff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            if(iBas.ne.0) then
              write(6,*) 'Sym =', iSym
              do i= 1,iBas
                write(6,*) (Work(LCMO+ioff-1+iBas*(i-1)+j),j=0,iBas-1)
              end do
              iOff = iOff + (iBas*iBas)
            end if
          End Do

          Write(LF,*)
          Write(LF,*) ' D1I in AO basis in RASSCF'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            call wrtmat(Work(lD1I+ioff-1),iBas,iBas, iBas, iBas)
            iOff = iOff + iBas*iBas
          End Do
          write(6,*)
          write(6,*) 'Total Charge :', Tot_Charge

          Call GetMem('Fcore','Allo','Real',iTmp1,nTot1)
          iComp  =  1
          iSyLbl =  1
          iRc    = -1
          iOpt   =  6
          Call RdOne(iRc,iOpt,'OneHam',iComp,Work(iTmp1),iSyLbl)
          If ( iRc.ne.0 ) then
           Write(LF,*) 'SGFCIN: iRc from Call RdOne not 0'
#ifdef _FDE_
           Write(LF,*) 'Label = ',Label
#endif
           Write(LF,*) 'iRc = ',iRc
           Call Abend
          End if

          Write(LF,*)
          Write(LF,*) ' OneHam in AO basis in RASSCF'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=0
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            Call TriPrt(' ','(5G17.11)',Work(iTmp1+iOff),iBas)
            iOff = iOff + (iBas*iBas+iBas)/2
          End Do

          Call GetMem('Fcore','Free','Real',iTmp1,nTot1)
          Call Get_dScalar('PotNuc',potNuc)

          write(6,*)
          write(6,*) 'PotNuc :', PotNuc

          Write(LF,*)
          Write(LF,*) ' D1A in AO basis in RASSCF'
          Write(LF,*) ' ---------------------'
          Write(LF,*)
          iOff=1
          Do iSym = 1,nSym
            iBas = nBas(iSym)
            call wrtmat(Work(lD1A+ioff-1),iBas,iBas, iBas, iBas)
            iOff = iOff + iBas*iBas
          End Do
        End if
      else
        CALL GETMEM('CASDFT_Fock','ALLO','REAL',LFOCK,NACPAR)
* To fix the DS bug... I forgot to transform it to the AO basis... Agrrrrhhh!
        if(iSpin.eq.1) then
          If ( IPRLEV.ge.DEBUG ) then
            write(6,*) 'running a singlet. LDSPN set to zero!'
          end if
          Call dcopy_(NACPAR,[0.0d0],0,Work(LDSPN),1)
        end if
        CALL GETMEM('TmpDS_DFT' ,'Allo','REAL',ipTmpDS_DFT ,NACPAR)
        CALL GETMEM('TmpD1S_DFT','Allo','REAL',ipTmpD1S_DFT,NTOT2)
        Call dcopy_(NACPAR,Work(LDSPN),1,Work(ipTmpDS_DFT),1)
        IF ( NASH(1).NE.NAC ) then
          CALL DBLOCK(Work(ipTmpDS_DFT))
        end if
        Call Get_D1A_RASSCF(Work(LCMO),Work(ipTmpDS_DFT),
     &                      Work(ipTmpD1S_DFT))
        CALL GETMEM('TmpDS_DFT' ,'Free','REAL',ipTmpDS_DFT ,NACPAR)
        call CASDFT_terms(WORK(LCMO),WORK(LFOCK),WORK(LFI),WORK(LD1I),
     &                    WORK(LD1A),Work(ipTmpD1S_DFT))
        CALL GETMEM('TmpD1S_DFT','Free','REAL',ipTmpD1S_DFT,NTOT2)
        CALL GETMEM('CASDFT_Fock','FREE','REAL',LFOCK,NACPAR)
      end if

c        CALL TRIPRT('Averaged one-body density matrix, D, in RASSCF',
c     &              ' ',Work(LDMAT),NAC)
c        CALL TRIPRT('Averaged one-body spin density matrix DS, RASSCF',
c     &              ' ',Work(LDSPN),NAC)
c        CALL TRIPRT('Averaged two-body density matrix, P',
c     &              ' ',WORK(LPMAT),NACPAR)
c        CALL TRIPRT('Averaged antisym 2-body density matrix PA RASSCF',
c     &              ' ',WORK(LPA),NACPAR)

      Call Get_D1A_RASSCF(WORK(LCMO),WORK(LDMAT),WORK(LD1A))
       If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' D1A in AO basis in RASSCF bf SXCTL'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
         iBas = nBas(iSym)
         call wrtmat(Work(LD1A+ioff-1),iBas,iBas, iBas, iBas)
         iOff = iOff + iBas*iBas
        End Do
       End If
      Call Timing(Swatch,Swatch,Zenith_2,Swatch)
      Zenith_2 = Zenith_2 - Zenith_1
      Zenith_3 = Zenith_3 + Zenith_2

*
c      Call rasscf_xml(Iter)
      Call rasscf_mcontrol(Iter)
*
* SX-section
*
      Call Timing(Swatch,Swatch,Gucci_1,Swatch)

       If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*) ' In RASSCF bf SXCTL'
        CALL TRIPRT('Averaged one-body density matrix, D, in RASSCF',
     &              ' ',Work(LDMAT),NAC)
        CALL TRIPRT('Averaged two-body density matrix, P',
     &              ' ',WORK(LPMAT),NACPAR)
        CALL TRIPRT('Averaged antisym 2-body density matrix PA RASSCF',
     &              ' ',WORK(LPA),NACPAR)
       end if
      CALL SXCTL(WORK(LCMO),WORK(LOCCN),
     &           WORK(LDMAT),WORK(LPMAT),WORK(LPA),
     &           WORK(LFI),WORK(LFA),WORK(LD1A),THMAX,IFINAL)
      If ( IPRLEV.ge.DEBUG ) then
       Write(LF,*)
       Write(LF,*) ' FI+FA in RASSCF after SXCTL'
       Write(LF,*) ' ---------------------'
       Write(LF,*)
       iOff=0
       Do iSym = 1,nSym
        iBas = nBas(iSym)
        Call TriPrt(' ',' ',Work(LFA+iOff),iBas)
        iOff = iOff + (iBas*iBas+iBas)/2
       End Do
      End If

cGLM   write(6,*) 'ECAS in RASSCF after call to SXCTL', ECAS
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' D1A in AO basis in RASSCF af SXCTL'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
         iBas = nBas(iSym)
         call wrtmat(Work(LD1A+ioff-1),iBas,iBas, iBas, iBas)
         iOff = iOff + iBas*iBas
        End Do
      end if
      Call Get_D1A_RASSCF(WORK(LCMO),WORK(LDMAT),WORK(LD1A))
      CASDFT_Funct=0.0d0
      If (KSDFT.ne.'SCF'.and.KSDFT.ne.'PAM') then
        Call Get_dScalar('CASDFT energy',CASDFT_Funct)
cGLM        write(6,*) 'CASDFT energy :', CASDFT_Funct

      end IF
      DE=(ECAS+CASDFT_Funct)-ECAS1
      ECAS1=ECAS+CASDFT_Funct

      IF(NAC.EQ.0)   EAV=ECAS

      If (KSDFT(1:3).ne.'SCF'.and.KSDFT(1:3).ne.'PAM') Then
        IF (nConf.EQ.1) Then
          EAV = ECAS
        Else
          EAV = EAV - VIA_DFT - HALFQ
        End If
      End IF

      IF (ITER.EQ.1) DE=0.0d0
      Call Timing(Swatch,Swatch,Gucci_2,Swatch)
      Gucci_2 = Gucci_2 - Gucci_1
      Gucci_3 = Gucci_3 + Gucci_2
      TMXTOT=MAX(TMXTOT,THMAX)
*
* Save energies and convergence parameters
*
      CONV(1,ITER)=ECAS
      CONV(2,ITER)=ESX
      CONV(3,ITER)=CMAX
      CONV(4,ITER)=DE
      CONV(5,ITER)=CBLBM
      CONV(6,ITER)=ROTMAX
      IAD15 = IADR15(6)
      CALL DDAFILE(JOBIPH,1,ENER,mxRoot*mxIter,IAD15)
      CALL DDAFILE(JOBIPH,1,CONV,6*mxIter,IAD15)
#ifdef _HDF5_
      call mh5_put_attr(wfn_iter, Iter)
      call mh5_put_dset(wfn_energy, ENER(1,Iter))
#endif

*
* Print output of energies and convergence parameters
*
      Call Timing(Swatch,Swatch,Certina_2,Swatch)
      Certina_3 = Certina_2 - Certina_1
* Character indicating unconvergence/convergence criterion fulfilled:
      CTHRE=' '
      CTHRSX=' '
      CTHRTE=' '
      IF(ABS(DE).GT.THRE) CTHRE='*'
      IF(ABS(CBLBM).GT.THRSX) CTHRSX='*'
      IF(ABS(ROTMAX).GT.THRTE) CTHRTE='*'
      IROT=0
      IF(NROOTS.EQ.1) IROT=IROOT(1)
      IF ( IPRLEV.GE.2 .and. IPRLEV.LE.3 .AND..NOT.lOPTO) THEN
*----------------------------------
* Shift total energies (BOR 070411)
        if(iter.eq.1 .and. ICIONLY == 0)then
         kau=int(ECAS/1000.d0)
         EVAC=1000.d0*DBLE(kau)
         if(kau.ne.0) THEN
          write(6,'(6x,A,f23.2,A)')
     &       'Total energies have been shifted. Add ', EVAC,' au'
         end if
        endif
*----------------------------------
        ihh=int(Certina_3/3600)
        imm=int(Certina_3-ihh*3600)/60
        iss=int(Certina_3-ihh*3600-imm*60)
        if (DoSplitCAS) then
         Write(LF,'(6X,I3,I4,I5,I5,F15.8,E12.2,A1,E10.2,A1,2I4,I2,'//
     &            'E10.2,A1,F6.2,F7.2,4X,A2,3X,A3,I5,A1,I2.2,A1,I2.2)')
     &        ITER,iterSplit,
     &        ITERSX,IROT,EAV,
     &        DE,CTHRE,ROTMAX,CTHRTE,IBLBM,JBLBM,ISYMBB,CBLBM,CTHRSX,
     &        SXSHFT,TMIN,QNSTEP,QNUPDT,ihh,':',imm,':',iss
        else if(DoBKAP) then
      Write(LF,'(3X,I3,I4,I2,I2,F15.8,F15.8,E12.2,A1,E10.2,A1,2I4,I2,'//
     &            'E10.2,A1,F6.2,F7.2,4X,A2,3X,A3,I5,A1,I2.2,A1,I2.2)')
     &        ITER,ITERCI,
     &        ITERSX,IROT,ECAS-EVAC+CASDFT_Funct,EAV,DE,CTHRE,
     &        ROTMAX,CTHRTE,IBLBM,JBLBM,ISYMBB,CBLBM,CTHRSX,
     &        SXSHFT,TMIN,QNSTEP,QNUPDT,ihh,':',imm,':',iss

        else
          if(doDMRG.and.KeyCION)then ! If DMRG only -- yma
            Write(LF,'(/6X,a,F19.10)')
     &      'DMRGCI energy              :',EAV+CASDFT_Funct
            Write(LF,'(6X,a,I5,A1,I2.2,A1,I2.2/)')
     &      'Total time spent (hh:mm:ss):        ',ihh,':',imm,':',iss
          else
            if(doDMRG)then
#ifdef _DMRG_
              maxtrW = 0.0d0
              maxtrR = -1
              ITERCI = MAXVAL(dmrg_energy%num_sweeps)
              IROT   = MAXLOC(dmrg_energy%num_sweeps,nroots)
              maxtrW = MAXVAL(dmrg_energy%max_truncW)
              maxtrR = MAXLOC(dmrg_energy%max_truncW,nroots)
         Write(LF,'(6X,I3,I3,I4,E12.2,I4,I5,F15.8,E12.2,A1,E9.2,A1,'//
     &   '2I4,I2,E10.2,A1,F6.2,F7.2,4X,A2,3X,A3,I7,A1,I2.2,A1,I2.2)')
     &        ITER,ITERCI,IROT,maxtrW,maxtrR,
     &        ITERSX,ECAS-EVAC+CASDFT_Funct,DE,CTHRE,
     &        ROTMAX,CTHRTE,IBLBM,JBLBM,ISYMBB,CBLBM,CTHRSX,
     &        SXSHFT,TMIN,QNSTEP,QNUPDT,ihh,':',imm,':',iss
#endif
            else
            Write(LF,'(6X,I3,I4,I5,I5,F15.8,E12.2,A1,E10.2,A1,2I4,I2,'//
     &          'E10.2,A1,F6.2,F7.2,4X,A2,3X,A3,I5,A1,I2.2,A1,I2.2)')
     &          ITER,ITERCI,
     &          ITERSX,IROT,ECAS-EVAC+CASDFT_Funct,DE,CTHRE,
     &          ROTMAX,CTHRTE,IBLBM,JBLBM,ISYMBB,CBLBM,CTHRSX,
     &          SXSHFT,TMIN,QNSTEP,QNUPDT,ihh,':',imm,':',iss
            end if
          end if
        end if
      ELSE IF ( IPRLEV.GE.4) THEN
        Write(LF,'(6X,A,I4)') 'Energy statistics and convergence'//
     &                                          ' in iteration',ITER
        Write(LF,'(6X,A,10X,F26.6)') 'Average of CI energies',EAV-EVAC
        Write(LF,'(6X,A,F26.6)') 'Complete active space SCF energy',
     &                                                       ECAS-EVAC
        Write(LF,'(6X,A,17X,F26.6)') 'Super-CI energy',ESX
        Write(LF,'(6X,A,12X,F26.6,3X,A1)') 'RASSCF energy change',
     &                                                        DE,CTHRE
        Write(LF,'(6X,A,I1,A1,2I3,F19.6)') 'Maximum BLB matrix'
     &                  //' element(sym=',ISYMBB,')',IBLBM,JBLBM,CBLBM
        Write(LF,'(6X,A,10X,F26.6,3X,A1)') 'Max rotation parameter',
     &                                               ROTMAX,CTHRSX
        Write(LF,'(6X,A,14X,F26.6,3X,A1)') 'Max rotation angle',
     &                                               THMAX,CTHRTE
        Write(LF,'(6X,A,3X,F26.6)') 'Max change in MO coefficients',CMAX
      END IF
#ifdef _FDE_
      ! Embedding
      if (embpot) then
       Eemb=embPotEneMODensities(Work(LD1I), Work(LD1A), embInt,
     &                nBas, nTot2, nSym)
       Write(LF,*)"E from embedding potential (<Psi|v_emb|Psi>): ",Eemb
      end if
#endif
      Call XFlush(6)
cGLM some additional printout for MC-PDFT

      If( l_casdft ) then
             CASDFT_E = ECAS-EVAC+CASDFT_Funct
             call print_mcpdft(CASDFT_E)
      end if
*
* Compare RASSCF energy and average CI energy
*
        DIFFE = ABS((ECAS-EAV)/ECAS)
      if(.not.DoSplitCAS) then
        if(DoBKAP) then
         if(iter.eq.1) then
          IF (DIFFE.GT.1.D-10 .AND. NROOTS.EQ.1) THEN
            Write(LF,'(6X,120A1)') ('=',i=1,120)
            Call WarningMessage(2,'Rasscf and CI energies will differ.')
            Write(LF,*)'This is the price you pay by the diagonal '
     &   //'approximation over the BB block in the SplitCAS method.'
            Write(LF,*)'The RASSCF energy might also diverge!'
            Write(LF,'(80A1)') ('#',i=1,80)
          END IF
         end if
        else if( l_casdft ) then
          Write(LF,'(6X,80A)') ('=',i=1,80)
          Write(LF,'(10X,A)') 'This is a POST-SCF correction using a '
     & //'modified  Hamiltonian.'
          write(LF,'(10X,A)') 'The RASSCF energy has been corrected and'
     & //' it will differ from'
          write(LF,'(10X,A)') 'the preceding CI energy.'
          Write(LF,'(6X,80A)') ('=',i=1,80)
        else
          IF(doDMRG)then

#ifdef _DMRG_DEBUGPRINT_
            write(lf,*) "DMRG-SCF energy    ",ECAS
            write(lf,*) "DMRG sweeped energy",EAV
#endif

            if(KeyCION)then
            else
              IF (DIFFE.GT.1.D-6 .AND. NROOTS.EQ.1) THEN
                Write(LF,'(6X,120A1)') ('=',i=1,120)
              Call WarningMessage(2,'DMRGSCF and DMRG energies differ.')
                Write(LF,'(6X,A,I11)')    'iteration           ',ITER
                Write(LF,'(6X,A,F22.10)') 'DMRGSCF energy      ',ECAS
                Write(LF,'(6X,A,F22.10)') 'DMRG energy         ',EAV
                Write(LF,'(6X,A,F22.10)') 'relative difference ',DIFFE
                Write(LF,*)'About this difference:'
                Write(LF,*)'1) If possible, consider a larger M value'
               Write(LF,*)'2) Severe convergence problems. Maybe active'
                Write(LF,*)'   space is unsuitable for this system?'
                Write(LF,'(6X,120A1)') ('=',i=1,120)
                IF (DIFFE.GT.5.D-04 .AND. NROOTS.EQ.1) THEN
                  Write(LF,*)
                  Write(LF,*)"Warning : "
                  Write(LF,*)" Relative difference is near unacceptable"
                  Write(LF,*)" If possible, consider a larger M value"
                  Write(LF,*)
                end if
              end if
            end if
          else
            DIFFETol = 1.D-10
#ifdef _ENABLE_DICE_SHCI_
            if (DoBlockDMRG) DIFFETol = 1.D-8
#endif
            IF (DIFFE.GT.DIFFETol .AND. NROOTS.EQ.1) THEN
              Write(LF,'(6X,120A1)') ('=',i=1,120)
              Call WarningMessage(2,'Rasscf and CI energies differ.')
              Write(LF,'(6X,A,I11)')    'iteration           ',ITER
              Write(LF,'(6X,A,F22.10)') 'RASSCF energy       ',ECAS
              Write(LF,'(6X,A,F22.10)') 'CI energy           ',EAV
              Write(LF,'(6X,A,F22.10)') 'relative difference ',DIFFE
              Write(LF,*)'Severe convergence problems. Maybe the active'
              Write(LF,*)'   space is unsuitable for this system?'
              Write(LF,'(6X,120A1)') ('=',i=1,120)
              IF(DIFFE.GT.1.D-04.AND.NROOTS.EQ.1.AND. .not.l_casdft)THEN
                Write(LF,*)
                Write(LF,'(6X,A)') 'The program has to stop !!!'
                Write(LF,*)
                Write(LF,'(6X,120A1)') ('=',i=1,120)
                Write(LF,*)
                ITERM=99
                GOTO 2000
              END IF
            end if
          END IF
        end if
      else
*          Write(LF,'(6X,A,F22.10)') 'Split-RASSCF energy    ',ECAS
        IF (DIFFE.GT.5.0D-03) THEN
          Write(LF,'(6X,120A1)') ('*',i=1,120)
          Write(LF,'(6X,A)') 'The Split-RASSCF and Split-CI '//
     &                       'energies differ !!!'
*          Write(LF,'(6X,A,I11)')    'iteration           ',ITER
          Write(LF,'(6X,A,F22.10)') 'Split-RASSCF energy    ',ECAS
          Write(LF,'(6X,A,F22.10)') 'Split-CI energy        ',EAV
          Write(LF,'(6X,A,F22.10)') 'Relative difference    ', DIFFE
          Write(LF,*)'     Smaller is the difference more realiable is',
     &               ' the result.'
          Write(LF,*)'     To make the difference smaller try',
     &               ' to select a bigger AA block or use firstOrder ',
     &               ' keyword.'
          Write(LF,'(6X,120A1)') ('*',i=1,120)
        END IF
      end if

      if (write_orb_per_iter .and. king()) then
        call copy_(real_path('RASORB'),
     &             real_path('ITERORB.'//str(actual_iter)))
#ifdef _HDF5_
        call copy_(real_path('RASWFN'),
     &             real_path('RASWFN.'//str(actual_iter)))

#endif
      end if

*
* Convergence check:
* check is done on largest BLB matrix
* element (CBLBM), on difference in
* average energy, DE and on maximum value of non-
* diagonal rotation matrix element.
*
************************************************************************
************************************************************************
* IF CIONLY calculation the convergence is skipped and goes to line 2000
************************************************************************
************************************************************************

      IF (IFINAL.EQ.1) GOTO 2000
      IF (DE.GT.1.0D0) THEN
        Call StatusLine('RASSCF:','No convergence.')
        Write(LF,*)
        Write(LF,'(6X,120A1)') ('=',i=1,120)
        Call WarningMessage(2,'Rasscf energy diverges.')
        Write(LF,'(6X,A,I11)')    'iteration           ',ITER
        Write(LF,'(6X,A,F22.10)') 'RASSCF energy       ',ECAS
        Write(LF,'(6X,A,F22.10)') 'energy difference   ',DE
        Write(LF,'(6X,120A1)') ('=',i=1,120)
        Write(LF,*)
        Write(LF,'(6X,A)') '!!! The program was forced to stop !!!'
        Write(LF,*)
        Write(LF,'(6X,120A1)') ('=',i=1,120)
        Write(LF,*)
        ITERM=99
        GOTO 2000
      ENDIF
      IF(ITER.LT.MAXIT) THEN
        Write(STLNE2,'(A12,I3)')' Iteration ',ITER
        Call StatusLine('RASSCF converged:',STLNE2)
        IF(ABS(DE).GT.THRE) GO TO 1000
        IF(ABS(CBLBM).GT.THRSX) GO TO 1000
        IF(ABS(ROTMAX).GT.THRTE) GO TO 1000
        IF(ITER.LE.3.AND.ICIONLY.EQ.0) GO TO 1000   ! 3->0 checking
        IF(IPRLEV.ge.TERSE) Write(LF,'(6X,A,I3,A)')
     &        'Convergence after',ITER,' iterations'
        If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' CMO in RASSCF after convergence printout'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         ioff=1
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          if(iBas.ne.0) then
            write(6,*) 'Sym =', iSym
            do i= 1,iBas
              write(6,*) (Work(LCMO+ioff-1+iBas*(i-1)+j),j=0,iBas-1)
            end do
            iOff = iOff + (iBas*iBas)
          end if
         End Do
        End If
        IFINAL=1
        Call Add_Info('RASSCF_ITER',[DBLE(ITER)],1,8)
*    Call Add_Info('RASSCF_THMX',TMXTOT,1,5)
        GOTO 1000
      ELSE
        IF(IPRLEV.ge.TERSE) Write(LF,'(6X,A,I3,A)')
     &        'No convergence after',ITER,' iterations'
        Write(STLNE2,'(A12,I3)')' Iteration ',ITER
        Call StatusLine('RASSCF max iter:',STLNE2)
        IFINAL=1
        ITERM=16
        GOTO 1000
      ENDIF
*                                                                      *
************************************************************************
*                                                                      *
*     Compute Final CI vectors
*                                                                      *
************************************************************************
*                                                                      *
 2000 IFINAL=2
      ICICH=0
************************************************************************
******************           Closing up MC-PDFT      *******************
************************************************************************

c Clean-close as much as you can the CASDFT stuff...
      if( l_casdft ) goto 2010

** IPT2 = 1 for OUTO, CANOnical keyword...
      IF(IPT2.EQ.1) THEN
        IAD=IADR15(9)
        CALL DDAFILE(JOBIPH,2,WORK(LCMO),NTOT2,IAD)
      ELSE
        IAD=IADR15(2)
        CALL DDAFILE(JOBIPH,2,WORK(LCMO),NTOT2,IAD)
      ENDIF
        If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*)
         Write(LF,*) ' CMO in RASSCF after DDAFILE'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         ioff=1
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          if(iBas.ne.0) then
            write(6,*) 'Sym =', iSym
            do i= 1,iBas
              write(6,*) (Work(LCMO+ioff-1+iBas*(i-1)+j),j=0,iBas-1)
            end do
            iOff = iOff + (iBas*iBas)
          end if
         End Do
        End If
      IF (NROOTS.GT.1) THEN
       Call StatusLine('RASSCF:','Compute final CI vectors')
      ELSE
       Call StatusLine('RASSCF:','Compute final CI vector')
      END IF
*
* Transform two-electron integrals
*
      Call Timing(Swatch,Swatch,Fortis_1,Swatch)
      If (.not.DoCholesky .or. ALGO.eq.1) Then
         Call GetMem('PVX1','Allo','Real',LPUVX,NFINT)
         Call FZero(Work(LPUVX),NFINT)
      EndIf

      Call Get_D1I_RASSCF(Work(LCMO),Work(lD1I))

       DoQmat=.false.

       IPR=0
       IF(IPRLOC(2).EQ.4) IPR=5
       IF(IPRLOC(2).EQ.5) IPR=10
       CALL TRACTL2(WORK(LCMO),WORK(LPUVX),WORK(LTUVX),WORK(LD1I),
     &              WORK(LFI),WORK(LD1A),WORK(LFA),IPR,lSquare,ExFac)
*
       If (.not.DoCholesky .or. ALGO.eq.1) Then
          Call GetMem('PVX1','Free','Real',LPUVX,NFINT)
       EndIf

      Call Timing(Swatch,Swatch,Fortis_2,Swatch)
      Fortis_2 = Fortis_2 - Fortis_1
      Fortis_3 = Fortis_3 + Fortis_2
*
* CI-section (to obtain final wave function)
* 1st and 2nd order density matrix in MO basis
* for the gradients.
*
*
* Print header to file containing informations on CI iterations.
*
       Write(IterFile,*)
       Write(IterFile,'(20A4)') ('****',i=1,20)
       Write(IterFile,'(15X,A)') 'RASSCF iteration: Final'
*
      Call Timing(Swatch,Swatch,Zenith_1,Swatch)

      if (allocated(CI_solver)) then
          call CI_solver%run(actual_iter=actual_iter,
     &                    ifinal=ifinal,
     &                    iroot=iroot,
     &                    weight=weight,
     &                    CMO=work(LCMO : LCMO + nTot2 - 1),
     &                    DIAF=work(LDIAF : LDiaf + nTot - 1),
     &                    D1I_AO=work(lD1I : lD1I + nTot2 - 1),
     &                    D1A_AO=work(lD1A : lD1A + nTot2 - 1),
     &                    TUVX=work(ltuvx : ltuvx + nAcPr2 - 1),
     &                    F_IN=work(lFI : lFI + nTot1 - 1),
     &                    D1S_MO=work(lDSPN : lDSPN + nAcPar - 1),
     &                    DMAT=work(lDMAT : lDMAT + nAcPar - 1),
     &                    PSMAT=work(lpmat : lPMat + nAcpr2 - 1),
     &                    PAMAT=work(lpa : lpa + nAcPr2 - 1))
#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_ || defined _ENABLE_DICE_SHCI_
      else If(DoBlockDMRG) Then
        CALL DMRGCTL(WORK(LCMO),
     &           WORK(LDMAT),WORK(LDSPN),WORK(LPMAT),WORK(LPA),
     &           WORK(LFI),WORK(LD1I),WORK(LD1A),
     &           WORK(LTUVX),IFINAL,1)
#endif
#ifdef _DMRG_
! Leon 27/11/2017: Skip the final CI iteration if we're using DMRGCI
! and CIOnly. It's enabled only for DMRGCI with QCMaquis now
! (to exclude potential side effects)
! but consider extending it to other cases!
      else if (doDMRG .and. (ICIONLY.NE.0)) then
        continue
#endif
      else
        CALL CICTL(WORK(LCMO),
     &           WORK(LDMAT),WORK(LDSPN),WORK(LPMAT),WORK(LPA),
     &           WORK(LFI),WORK(LFA),WORK(LD1I),WORK(LD1A),
     &           WORK(LTUVX),IFINAL)
      end if

      EAV=0.0d0
      If(DoSplitCAS) then
        EAV = ENER(lRootSplit,ITER)
      else
       DO KROOT=1,NROOTS
         EAV=EAV+ENER(IROOT(KROOT),ITER)*WEIGHT(KROOT)
       END DO
      end if
      IF(NAC.EQ.0) EAV=ECAS
      IF(NCRVEC.gt.0) then
* Core shift has been used
        Call GetMem('CRVEC','Free','Real',LCRVEC,NCRVEC)
        Call GetMem('CRPROJ','Free','Real',LCRPROJ,NCRPROJ)
      END IF
      Call Timing(Swatch,Swatch,Zenith_2,Swatch)
      Zenith_2 = Zenith_2 - Zenith_1
      Zenith_3 = Zenith_3 + Zenith_2
      Call Timing(Swatch,Swatch,Ebel_2,Swatch)
*
* Calculation of natural orbitals. These orbitals are stored on
* JOBIPH in IADR15(12), followed by the occupation numbers.
* Usage: Only for one-electron properties
* Note: in an average calculation natural orbitals are obtained
* for all roots. Stored sequentially at IADR15(12) on JOBPIH.
*PAM2009 This is done in NATORB. Note that it places the resulting
* natural orbitals and occ nos into JOBIPH. Thus the arguments nr
* 5 and 6 are simply those for the last root that NATORB processed,
* and they should not be reused for anything after return from NATORB.
* NATORB args: Arg1 is current CMO coeffs, used in CI;
*  all the rest should be regarded as scratch.
*
      Call StatusLine('RASSCF:','Compute natural orbitals')
      IPR=0
      IF(IPRLOC(6).EQ.4) IPR=5
      IF(IPRLOC(6).EQ.5) IPR=10
      Call GetMem('CMON','Allo','Real',LCMON,NTOT2)
      Call GetMem('OCCX','Allo','Real',LOCCX,NTOT)
      Call GetMem('NOscr1','Allo','Real',lNOscr1,MAX(NACPAR,NO2M))
      Call GetMem('NOscr2','Allo','Real',lNOscr2,NO2M)
      Call GetMem('SMAT','Allo','Real',LSMAT,NTOT1)
*PAM2009 NATORB args: Arg1 is current CMO coeffs, used in CI;
*  all the rest should be regarded as scratch.
      CALL NATORB_RASSCF(Work(LCMO),
     &            Work(lNOscr1),Work(lNOscr2),Work(LSMAT),
     &            Work(LCMON),Work(LOCCX))
      Call GetMem('NOscr1','Free','Real',lNOscr1,MAX(NACPAR,NO2M))
      Call GetMem('NOscr2','Free','Real',lNOscr2,NO2M)
*PAM2009 Deallocate CMON, OCCX.
      Call GetMem('CMON','Free','Real',LCMON,NTOT2)
      Call GetMem('OCCX','Free','Real',LOCCX,NTOT)

*
* Compute transition density matrices
      If (KeyTDM) Then
#ifdef _HDF5_
         Call GetMem('TMP','ALLO','REAL',iTmp,NConf)
         Call GetMem('LVEC','ALLO','REAL',iVecL,NConf)
         Call GetMem('RVEC','ALLO','REAL',iVecR,NConf)
         Call GetMem('KCNF','ALLO','INTE',ivkcnf,NACTEL)
         Call GetMem('Dtmp','ALLO','REAL',LW6,NAC*NAC)
         Call GetMem('SDtmp','ALLO','REAL',LW7,NAC*NAC)
         jDisk=IADR15(4)
         Call DDafile(JOBIPH,2,Work(iTmp),nConf,jDisk)
         Do jRoot=2,lRoots
*           Read and reorder the left CI vector
            Call DDafile(JOBIPH,2,Work(iTmp),nConf,jDisk)
            Call Reord2(NAC,NACTEL,STSYM,1,
     &                  CONF,iWork(KCFTP),
     &                  Work(iTmp),Work(iVecL),iWork(ivkcnf))
            C_Pointer=iVecL
            kDisk=IADR15(4)
            Do kRoot=1,jRoot-1
*              Read and reorder the right CI vector
               Call DDafile(JOBIPH,2,Work(iTmp),nConf,kDisk)
               Call Reord2(NAC,NACTEL,STSYM,1,
     &                     CONF,iWork(KCFTP),
     &                     Work(iTmp),Work(iVecR),iWork(ivkcnf))
*              Compute TDM and store in h5 file
               Call Lucia_Util('Densi',iVecR,iDummy,Dummy)
               idx=(jRoot-2)*(jRoot-1)/2+kRoot
               Call mh5_put_dset(wfn_transdens,Work(LW6:LW6+NAC*NAC-1),
     &              [NAC,NAC,1], [0,0,idx-1])
               If (iSpin.gt.1)
     &         Call mh5_put_dset(wfn_transsdens,Work(LW7:LW7+NAC*NAC-1),
     &              [NAC,NAC,1], [0,0,idx-1])
            End Do
         End Do
         Call GetMem('TMP','FREE','REAL',iTmp,NConf)
         Call GetMem('LVEC','FREE','REAL',iVecL,NConf)
         Call GetMem('RVEC','FREE','REAL',iVecR,NConf)
         Call GetMem('KCNF','FREE','INTE',ivkcnf,NACTEL)
         Call GetMem('Dtmp','FREE','REAL',LW6,NAC*NAC)
         Call GetMem('SDtmp','FREE','REAL',LW7,NAC*NAC)
#else
         Call WarningMessage(1,'HDF5 support disabled, '//
     &                         'TDM keyword ignored.')
#endif
      End If

      if (KeySSCR) then
        call spin_correlation_driver(orb_range_p, orb_range_q, iroot)
        call mma_deallocate(orb_range_p)
        call mma_deallocate(orb_range_q)
      end if

*
*****************************************************************
* Export all information relevant to geometry optimizations.
* Save also the reaction field operator.
      Call Timing(Swatch,Swatch,Oris_1,Swatch)
      If (iRlxRoot.eq.0) iRlxRoot=iRoot(1)
*
* Replace average occ Fock with occ Fock for state iRlxRoot
* and densities with the densities for state iRLXRoot
c      write(6,*) 'I am in RASSCF before call to PutRlx!'
      If ( ITERM.ne.99 ) Then
         Call GetMem('Dens','ALLO','REAL',ipDens,nTot1)
         Call PutRlx(Work(LDMAT),Work(LDSPN),WORK(LPMAT),
     &            Work(ipDens),Work(LCMO))
         Call Export1(IFINAL,WORK(LCMO),WORK(LDMAT),WORK(LPMAT),
     &             Work(ipDens),Work(ipFocc))
         Call GetMem('Dens','FREE','REAL',ipDens,nTot1)
      End If
      Call Timing(Swatch,Swatch,Oris_2,Swatch)
      Oris_2 = Oris_2 - Oris_1
*****************************************************************
*
      EMY=EMY+CASDFT_Funct
*                                                                      *
************************************************************************
*                                                                      *
*     Output section
*                                                                      *
************************************************************************
*                                                                      *

      Call StatusLine('RASSCF:','Printing results')
      IF (IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
        Write(LF,*)
        Write(LF,'(6X,120A1)') ('*',i=1,120)
        Write(LF,'(6X,A,118X,A)') '*','*'
        Write(LF,'(6X,A,52X,A,53X,A)')
     &        '*','Final results','*'
        Write(LF,'(6X,A,118X,A)') '*','*'
        Write(LF,'(6X,120A1)') ('*',i=1,120)
        Write(LF,*)
      END IF
#ifdef _FDE_
      ! Embedding
      if (embpot) then
       Eemb=embPotEneMODensities(Work(LD1I), Work(LD1A), embInt,
     &                nBas, nTot2, nSym)
       Write(LF,*) "Final energy from embedding potential: ", Eemb
       ! Write out ESP on grid if requested
       if (embWriteEsp) then
        Call Get_iScalar('Unique atoms',nNuc)
        Call embPotOutputMODensities(nNuc,nSym,Work(LD1I),Work(LD1A),
     &                               nBas,nTot2)
       end if
      end if
#endif

      If ( ITERM.ne.99 ) THEN
       If (.not.DoSplitCAS) then
        CALL OUTCTL(WORK(LCMO),WORK(LOCCN),WORK(LSMAT),lOPTO)
       else
        CALL OUTCTLSplit(WORK(LCMO),WORK(LOCCN),WORK(LSMAT),lOPTO)
       end if
      End If

      Call GetMem('SMAT','Free','Real',LSMAT,NTOT1)

*
* Write information for MOLDEN
*
c  i_root=0 gives state- and spin-averaged natural orbitals
c  i_root>0 gives natural spin orbitals for that root
      mroots=nroots
      if ((iSpin.eq.1).and.(nroots.eq.1)) mroots=0
      Do i_root=0,mroots
        Call Interf(i_root,FDIAG,1,0)
      End Do

* Create output orbital files:
      Call OrbFiles(JOBIPH,IPRLEV)

************************************************************************
******************           Closing up RASSCF       *******************
************************************************************************

2010   continue

      If (DoCholesky.and.ALGO.eq.2) Then
         Call GetMem('Q-mat','Free','Real',ipQmat,NTav)
      EndIf

*  Release  some memory allocations
      Call GetMem('DIAF','Free','Real',LDIAF,NTOT)
      Call GetMem('FOCC','FREE','REAL',ipFocc,idum)
      Call GetMem('FI','Free','Real',LFI,NTOT1)
      Call GetMem('FA','Free','Real',LFA,NTOT1)
      Call GetMem('D1I','Free','Real',LD1I,NTOT2)
      Call GetMem('D1A','Free','Real',LD1A,NTOT2)
      Call GetMem('D1tot','Free','Real',lD1tot,NTOT1)
      Call GetMem('OCCN','Free','Real',LOCCN,NTOT)
      Call GetMem('LCMO','Free','Real',LCMO,NTOT2)
#ifdef _DMRG_
* Free RDMs for the reaction field reference root in QCMaquis calculations
      if (doDMRG.and.PCM_On()) then
        Call GetMem('D1RF','FREE','Real',LW_RF1,NACPAR)
        if (twordm_qcm) then
          Call GetMem('D2RF','FREE','Real',LW_RF2,NACPR2)
        end if
      end if
#endif

c deallocating TUVX memory...
      IF(NAC.GT.0) THEN
         Call GetMem('TUVX','Free','Real',LTUVX,NACPR2)
         Call GetMem('DSPN','Free','Real',LDSPN,NACPAR)
         if(.not.DumpOnly) Then
            Call GetMem('P2AS','Free','Real',LPA,NACPR2)
            Call GetMem('PMAT','Free','Real',LPMAT,NACPR2)
            Call GetMem('DMAT','Free','Real',LDMAT,NACPAR)
         endif
      END IF
!Leon: The velociraptor comes! xkcd.com/292/
9989  Continue
*
* release SEWARD
      Call ClsSew
* ClsSew is needed for releasing memory used by integral_util, rys... which is allocated when MC-PDFT run is performed.

*---  Finalize Cholesky information if initialized
      if (DoCholesky)then
         Call Cho_X_Final(irc)
         if (irc.ne.0) then
            Write(LF,*)'RASSCF: Cho_X_Final fails with return code ',irc
            Write(LF,*)' Try to recover. Calculation continues.'
         endif
         If (Do_OFemb) Then
            Call mma_deallocate(FMaux)
            Call OFE_print(EAV)
         EndIf
      endif

!      do i=1,NTOT2
!        write(*,*) "A,I",work(LD1A+i-1),work(LD1I+i-1)
!      end do
      If (iClean.eq.1) Call Free_iWork(ipCleanMask)

*
* Skip Lucia stuff if NECI or BLOCK-DMRG is on
      If (.not. any([allocated(CI_solver), DumpOnly,
     &              doDMRG, doBlockDMRG])) then
        Call Lucia_Util('CLOSE',iDummy,iDummy,Dummy)
      end if


      Call StatusLine('RASSCF:','Finished.')
      If (IPRLEV.GE.2) Write(LF,*)
      if(ifvb.eq.1) call make_close_rvb
cvv call to grid is moved up, in order to call clssew safely..
c      If (iCIonly.eq.0) Then
c        Call Grid_driver(-1,'RASSCF','RASORB',iR)
c      End If

      Call Timing(Swatch,Swatch,Ebel_3,Swatch)
      IF (IPRLEV.GE.3) THEN
       Call PrtTim
       Call FastIO('STATUS')
      END IF
      Call ClsFls_RASSCF()

*
      Rc_RAS = ITERM
      Rc_RAS = Max(RC_RAS,Rc_CI)
      Rc_RAS = Max(RC_RAS,Rc_SX)
      If (Rc_Ras.eq.0) then
         ireturn=_RC_ALL_IS_WELL_
      Else If (Rc_Ras.eq.16) then
         ireturn=_RC_NOT_CONVERGED_
      Else
         Call WarningMessage(2,'Something is wrong: Did CI fail?')
         ireturn=_RC_GENERAL_ERROR_
      End If
*
      If (Do_OFemb) Then
         Call GetEnvF('EMIL_InLoop',EMILOOP)
         If (EMILOOP.eq.' ') EMILOOP='0'
         If (EMILOOP(1:1).ne.'0') Then
            If (iReturn.ne._RC_ALL_IS_WELL_) Then
               Call WarningMessage(1,'RASSCF: non-zero return code.')
            EndIf
            iReturn=_RC_CONTINUE_LOOP_
            Call Check_FThaw(iReturn)
         EndIf
      EndIf

      if (.not. (iDoGas .or. doDMRG .or. doBlockDMRG
     &          .or. allocated(CI_solver) .or. DumpOnly)) then
        Call MKGUGA_FREE
      end if

      if (DoFaro) then
         call faroald_free()
         call citrans_free()
      end if

      if (allocated(CI_solver)) then
          call CI_solver%cleanup()
          deallocate(CI_solver)
      end if

* DMRG: Save results for other use
! ==========================================================
      if(doDMRG)then
#ifdef _DMRG_
        !Leon: Generate 4-RDM evaluation templates for NEVPT2

        !In the new interface the EvRDM keyword will be ignored.
        !Instead, NEVPT2Prep will always generate the template.
        !RDM evaluation will now happen in the NEVPT2 module
        !where NEVPT2 either can attempt to compute it directly
        !with the new interface or read from QCMaquis HDF5 result
        !file.
        if (DoNEVPT2Prep) then
          if (MAXIT.eq.0) then
            write(6,*) " --- DMRG-SCF iterations are skipped, only "//
     &        "QCMaquis input for higher-order RDMs will be generated."
          endif
          if (NACTEL.gt.3) then ! Ignore 4-RDM if we have <4 electrons
          do i=1,NROOTS
              Write (6,'(a)') 'Writing 4-RDM QCMaquis template'//
     &   ' for state '//str(i)
              call qcmaquis_interface_prepare_hirdm_template(
     &        filename="meas-4rdm."//str(i-1)//".in",
     &        state=i-1,
     &        tpl=TEMPLATE_4RDM)
              call qcmaquis_mpssi_transform(
     &             trim(qcmaquis_param%currdir)//'/'//
     &             trim(qcmaquis_param%project_name), i)
          end do
          else
            write(6,*) "Skipping 4-RDM QCMaquis template generation "//
     &        "since we have less than 4 electrons."
          end if
          ! Generate 3-TDM templates
          if(NACTEL.gt.2) then ! but only if we have more than 3 el.
          do i=1,NROOTS
            do j=i+1,NROOTS
              Write (6,'(a)') 'Writing 3-TDM QCMaquis template'//
     &   ' for states '//str(i)//" and "//str(j)
              call qcmaquis_interface_prepare_hirdm_template(
     &        filename="meas-3tdm."//str(i-1)//"."//str(j-1)//".in",
     &        state=i-1,
     &        state_j=j-1,
     &        tpl=TEMPLATE_TRANSITION_3RDM)
            end do
          end do
          else
            write(6,*) "Skipping 3-RDM QCMaquis template generation "//
     &        "since we have less than 3 electrons."
          end if
        end if
        ! is it really needed in the times of Fortran 2008?
        call qcmaquis_interface_deinit
#endif
      end if
! ==========================================================
! Exit

 9990 Continue
C Close the one-electron integral file:
      iRC=-1
      iOpt=0
      Call ClsOne(iRC,iOpt)
      If (iRC.ne.0) Then
         Write (6,*) 'Error when trying to close the one-electron'
         Write (6,*) 'integral file.'
         Call Quit(_RC_INTERNAL_ERROR_)
      End If

      If (IfVB.ne.2) Then
        DO I=10,99
          INQUIRE(UNIT=I,OPENED=IfOpened)
          IF (IfOpened.and.I.ne.19) CLOSE (I)
        END DO
        Close(LUInput)
      End If

      return

      end subroutine rasscf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************

subroutine CMSRot(TUVX)
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

use Index_Functions, only: nTri_Elem
use CMS, only: CMSNotConverged
use rasscf_global, only: CMSStartMat, lRoots, NAC, NACPR2
use PrintLevel, only: USUAL
use output_ras, only: IPRLOC
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: TUVX(NACPR2)
integer(kind=iwp) :: iPrLev
character(len=16) :: VecName
real(kind=wp), allocatable :: DDG(:,:,:,:), GDMat(:,:,:), Gtuvx(:,:,:,:), RotMat(:,:)
#include "warnings.h"

! Allocating Memory
call mma_allocate(GDMat,nTri_Elem(lRoots),NAC,NAC)
call mma_allocate(RotMat,lRoots,lRoots)
call mma_allocate(Gtuvx,NAC,NAC,NAC,NAC)
call mma_allocate(DDG,lRoots,lRoots,lRoots,lRoots)

IPRLEV = IPRLOC(6)

! printing header
if (IPRLEV >= USUAL) then
  write(u6,*)
  write(u6,*)
  write(u6,*) '    CMS INTERMEDIATE-STATE OPTIMIZATION'
end if
if (trim(CMSStartMat) == 'XMS') then
  call ReadMat('ROT_VEC',VecName,RotMat,lroots,lroots,7,16,'N')
else
  call ReadMat(trim(CMSStartMat),VecName,RotMat,lroots,lroots,len_trim(CMSStartMat),16,'N')
end if
if (IPRLEV >= USUAL) call CMSHeader(trim(CMSStartMat))

call LoadGtuvx(TUVX,Gtuvx)

CMSNotConverged = .false.
call GetGDMat(GDMat)
if (lRoots < NAC) then
  !write(u6,*) 'Optimization Approach 1'
  call GetDDgMat(DDg,GDMat,Gtuvx)
  call NStateOpt(RotMat,DDg)
else
  !write(u6,*) 'Optimization Approach 2'
  call NStateOpt2(RotMat,GDMat,Gtuvx)
end if
call PrintMat('ROT_VEC','CMS-PDFT',RotMat,lroots,lroots,7,8,'N')

! Deallocating Memory
call mma_deallocate(GDMat)
call mma_deallocate(RotMat)
call mma_deallocate(Gtuvx)
call mma_deallocate(DDg)
if (CMSNotConverged) then
  call WarningMessage(2,'CMS Intermediate States Not Converged')
  call Quit(_RC_NOT_CONVERGED_)
end if

end subroutine CMSRot

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001-2005, Valera Veryazov                             *
************************************************************************
      Subroutine molcas_open(Lu,Name)
      Integer Lu,f_recl,f_iostat
      Character*10 f_access,f_form,f_status
      Logical is_recl,is_error
      Character*(*) Name

      f_recl=1
      f_iostat=100
      f_access='SEQUENTIAL'
      f_form='FORMATTED'
      f_status='UNKNOWN'
      is_recl=.false.
      is_error=.false.

      Call molcas_open_ext2(Lu,Name,f_access,f_form,f_iostat,is_recl,
     &                      f_recl,f_status,is_error)
      If(f_iostat.ne.0) Then
         Write(6,*)
         Write(6,'(3a)')   'molcas_open: Error opening file "',Name,'"'
         Write(6,'(a,i9)') '   iostat is',f_iostat
         Write(6,'(a)')    '   Aborting'
         Write(6,*)
         Call Abend()
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Cho_P_LocalSP(iShlAB)
!
! Purpose: return local shell pair corresponding to global shell
!          pair iShlAB (returns 0 if not found).

use Cholesky, only: Cho_Real_Par, MySP, n_MySP
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: Cho_P_LocalSP
integer(kind=iwp), intent(in) :: iShlAB
integer(kind=iwp) :: iSP

if (Cho_Real_Par) then
  Cho_P_LocalSP = 0
  do iSP=1,n_mySP
    if (mySP(iSP) == iShlAB) then
      Cho_P_LocalSP = iSP
      return
    end if
  end do
else
  Cho_P_LocalSP = iShlAB
end if

end function Cho_P_LocalSP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine Util4(nZeta,rFinal,la,lb,Elalbp,Elalb,Bcoor,Dcoor)
!***********************************************************************
!                                                                      *
! Object: to assemble the diamagnetic shielding integrals from         *
!         electric field integrals.                                    *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             February '91                                             *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Half, c_in_au
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb
real(kind=wp), intent(out) :: rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),9)
real(kind=wp), intent(in) :: Elalbp(nZeta,nTri_Elem1(la),nTri_Elem1(lb+1),3), Elalb(nZeta,nTri_Elem1(la),nTri_Elem1(lb),3), &
                             Bcoor(3), Dcoor(3)
#include "print.fh"
integer(kind=iwp) :: ia, ib, iComp, ipa, ipb, iPrint, iRout, ixa, ixb, iya, iyb, iza, izb
real(kind=wp) :: BD(3), Fact
character(len=80) :: Label

iRout = 231
iPrint = nPrint(iRout)

BD(1) = Bcoor(1)-Dcoor(1)
BD(2) = Bcoor(2)-Dcoor(2)
BD(3) = Bcoor(3)-Dcoor(3)
Fact = -1.0e-6_wp*Half/c_in_au**2
if (iPrint >= 99) then
  write(u6,*) ' In Util4 la,lb=',la,lb
  do ia=1,nTri_Elem1(la)
    do ib=1,nTri_Elem1(lb+1)
      write(Label,'(A,I2,A,I2,A)') ' Elalbp(',ia,',',ib,',x)'
      call RecPrt(Label,' ',Elalbp(:,ia,ib,1),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Elalbp(',ia,',',ib,',y)'
      call RecPrt(Label,' ',Elalbp(:,ia,ib,2),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Elalbp(',ia,',',ib,',z)'
      call RecPrt(Label,' ',Elalbp(:,ia,ib,3),nZeta,1)
    end do
  end do
  do ia=1,nTri_Elem1(la)
    do ib=1,nTri_Elem1(lb)
      write(Label,'(A,I2,A,I2,A)') ' Elalb(',ia,',',ib,',x)'
      call RecPrt(Label,' ',Elalb(:,ia,ib,1),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Elalb(',ia,',',ib,',y)'
      call RecPrt(Label,' ',Elalb(:,ia,ib,2),nZeta,1)
      write(Label,'(A,I2,A,I2,A)') ' Elalb(',ia,',',ib,',z)'
      call RecPrt(Label,' ',Elalb(:,ia,ib,3),nZeta,1)
    end do
  end do
end if

do ixa=la,0,-1
  do iya=la-ixa,0,-1
    iza = la-ixa-iya
    ipa = C_Ind(la,ixa,iza)

    do ixb=lb,0,-1
      do iyb=lb-ixb,0,-1
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        rFinal(:,ipa,ipb,1) = Fact*(Elalbp(:,ipa,C_Ind(lb+1,ixb,izb),2)+BD(2)*Elalb(:,ipa,ipb,2)+ &
                                    Elalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),3)+BD(3)*Elalb(:,ipa,ipb,3))
        rFinal(:,ipa,ipb,2) = -Fact*(Elalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),2)+BD(1)*Elalb(:,ipa,ipb,2))
        rFinal(:,ipa,ipb,3) = -Fact*(Elalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),3)+BD(1)*Elalb(:,ipa,ipb,3))
        rFinal(:,ipa,ipb,4) = -Fact*(Elalbp(:,ipa,C_Ind(lb+1,ixb,izb),1)+BD(2)*Elalb(:,ipa,ipb,1))
        rFinal(:,ipa,ipb,5) = Fact*(Elalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),1)+BD(1)*Elalb(:,ipa,ipb,1)+ &
                                    Elalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),3)+BD(3)*Elalb(:,ipa,ipb,3))
        rFinal(:,ipa,ipb,6) = -Fact*(Elalbp(:,ipa,C_Ind(lb+1,ixb,izb),3)+BD(2)*Elalb(:,ipa,ipb,3))
        rFinal(:,ipa,ipb,7) = -Fact*(Elalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),1)+BD(3)*Elalb(:,ipa,ipb,1))
        rFinal(:,ipa,ipb,8) = -Fact*(Elalbp(:,ipa,C_Ind(lb+1,ixb,izb+1),2)+BD(3)*Elalb(:,ipa,ipb,2))
        rFinal(:,ipa,ipb,9) = Fact*(Elalbp(:,ipa,C_Ind(lb+1,ixb+1,izb),1)+BD(1)*Elalb(:,ipa,ipb,1)+ &
                                    Elalbp(:,ipa,C_Ind(lb+1,ixb,izb),2)+BD(2)*Elalb(:,ipa,ipb,2))

      end do
    end do

  end do
end do

if (iPrint >= 49) then
  do iComp=1,9
    write(Label,'(A,I2,A)') ' rFinal (',iComp,') '
    call RecPrt(Label,' ',rFinal(:,:,:,iComp),nZeta,nTri_Elem1(la)*nTri_Elem1(lb))
  end do
end if

return

end subroutine Util4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine DELF(FNAM,INUM1,INUM2)
       Implicit None
       Integer I,inum1,inum2
       character FNAM*6,FN*8
       FN(1:6)=FNAM
       do I=inum1,inum2
       write(fn(7:8),'(I2.2)')I
c       write(6,*)'File ',FN,' to be deleted'
       call Molcas_Open(8,fn)
       close(8,status='DELETE')
       enddo
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine AI_CPF(JSY,INDX,C,S,FC,BUFIN,A,B,FK,DBK,ENP,EPP,KTYP)
! KTYP=0  ,  (A/I)   INTEGRALS
! KTYP=1  ,  (AI/JK) INTEGRALS

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use cpf_global, only: IDENS, IRC, IREF0, IROW, ITER, LASTAD, LBUF, LN, LSYM, Lu_CIGuga, Lu_TiABIJ, NDIAG, NORBT, NSM, NSYM, NSYS, &
                      NVIR, NVIRT, SQ2
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8, RtoI

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JSY(*), INDX(*), KTYP
real(kind=wp), intent(inout) :: C(*), S(*), FK(*), EPP(*)
real(kind=wp), intent(_OUT_) :: FC(*), BUFIN(*), A(*), B(*), DBK(*)
real(kind=wp), intent(in) :: ENP(*)
integer(kind=iwp) :: IADD10, IADR, ICHK, ICP1, ICP2, IFT, IJ, IJOLD, ILEN, IND, INDA, INDB, INDI, INK, INMY, INNY, INUM, IOUT, &
                     IPOB(9), ITURN, ITYP, LBUF0, LBUF1, LBUF2, LENGTH, MYL, MYSYM, NA1, NA2, NAK, NI, NJ, NK, NKM, NOB2, NOT2, &
                     NOTT, NOVST, NSIJ, NSK, NVM, NVT, NYL, NYSYM
real(kind=wp) :: COPI, SGN, TERM
logical(kind=iwp) :: Skip
integer(kind=iwp), external :: JSUNP
real(kind=r8), external :: DDOT_

call AI_CPF_INTERNAL(BUFIN)

! This is to allow type punning without an explicit interface
contains

subroutine AI_CPF_INTERNAL(BUFIN)

  real(kind=wp), target, intent(_OUT_) :: BUFIN(*)
  integer(kind=iwp), pointer :: IBUFIN(:)
  integer(kind=iwp) :: I, II, J, NA

  call c_f_pointer(c_loc(BUFIN),iBUFIN,[1])

  NK = 0 ! dummy initialize
  NSK = 0 ! dummy initialize
  INUM = IRC(4)-IRC(3)
  call PSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)
  NVT = IROW(NVIRT+1)
  ICHK = 0
  IJOLD = 0
  NOB2 = IROW(NORBT+1)
  NOT2 = IROW(LN+1)
  NOTT = 2*NOT2
  NOVST = LN*NVIRT+1+NVT
  LBUF0 = RTOI*LBUF
  LBUF1 = LBUF0+LBUF+1
  LBUF2 = LBUF1+1
  if (KTYP == 0) IADD10 = IAD10(9)
  if (KTYP == 1) IADD10 = IAD10(7)
  do
    call dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
    call iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
    ILEN = ICOP1(nCOP+1)
    if (ILEN == 0) cycle
    if (ILEN < 0) exit
    do II=1,ILEN
      IND = ICOP1(II)
      if (ICHK == 0) then
        if (IND == 0) then
          ICHK = 1
        else if (INK /= 0) then
          ITYP = ibits(IND,0,6)
          ICP2 = ibits(IND,6,13)
          ICP1 = ibits(IND,19,13)
          if (ITYP <= 1) then
            INDA = ICP1
            INDB = IRC(1)+ICP2
            INNY = INDX(INDB)+1
            if (IDENS /= 1) then
              if (INDA == IREF0) then
                COPI = COP(II)/sqrt(ENP(INDB))
                S(INNY:INNY+INK-1) = S(INNY:INNY+INK-1)+COPI*FK(1:INK)
                if (ITER /= 1) then
                  TERM = DDOT_(INK,FK,1,C(INNY),1)
                  EPP(INDB) = EPP(INDB)+COPI*TERM
                end if
              else
                COPI = COP(II)*C(INDA)
                S(INNY:INNY+INK-1) = S(INNY:INNY+INK-1)+COPI*FK(1:INK)
                TERM = DDOT_(INK,FK,1,C(INNY),1)
                S(INDA) = S(INDA)+COP(II)*TERM
              end if
            else
              if (INDA == IREF0) COPI = C(INDA)*COP(II)/ENP(INDB)
              if (INDA /= IREF0) COPI = C(INDA)*COP(II)/(sqrt(ENP(INDA))*sqrt(ENP(INDB)))
              FK(1:INK) = FK(1:INK)+COPI*C(INNY:INNY+INK-1)
              !write(u6,654) NK,NSK,INDB
              !write(u6,653) (FK(I),I=1,INK)
            end if
          else if (ITER /= 1) then
            INDA = IRC(1)+ICP1
            INDB = IRC(ITYP)+ICP2
            INMY = INDX(INDA)+1
            INNY = INDX(INDB)+1
            MYSYM = JSUNP(JSY,INDA)
            NYSYM = MUL(MYSYM,NSK)
            MYL = MUL(MYSYM,LSYM)
            NYL = MUL(NYSYM,LSYM)
            IFT = 0
            if (ITYP == 2) IFT = 1
            call IPO_CPF(IPOB,NVIR,MUL,NSYM,NYL,IFT)
            NVM = NVIR(MYL)
            if (IDENS /= 1) then
              DBK(1:INK) = COP(II)*FK(1:INK)
              if (NYL == 1) then
                if (IFT == 0) call SQUAR(C(INNY+IPOB(MYL)),A,NVM)
                if (IFT == 1) call SQUARM(C(INNY+IPOB(MYL)),A,NVM)
                call FMMM(DBK,A,B,1,NVM,INK)
                S(INMY:INMY+NVM-1) = S(INMY:INMY+NVM-1)+B(1:NVM)
                SGN = One
                if (IFT == 1) SGN = -One
                IOUT = INNY+IPOB(MYL)-1
                do I=1,NVM
                  do J=1,I
                    IOUT = IOUT+1
                    TERM = DBK(I)*C(INMY+J-1)+SGN*DBK(J)*C(INMY+I-1)
                    S(IOUT) = S(IOUT)+TERM
                  end do
                  if (IFT == 1) cycle
                  TERM = DBK(I)*C(INMY+I-1)
                  S(IOUT) = S(IOUT)-TERM
                end do
              else
                NKM = INK*NVM
                if (NSK <= MYL) then
                  if (IFT == 1) DBK(1:INK) = -DBK(1:INK)
                  I = INNY+IPOB(MYL)
                  call FMMM(DBK,C(I),B,1,NVM,INK)
                  S(INMY:INMY+NVM-1) = S(INMY:INMY+NVM-1)+B(1:NVM)
                  call FMMM(DBK,C(INMY),B,INK,NVM,1)
                else
                  I = INNY+IPOB(NSK)
                  call FMMM(C(I),DBK,B,NVM,1,INK)
                  S(INMY:INMY+NVM-1) = S(INMY:INMY+NVM-1)+B(1:NVM)
                  call FMMM(C(INMY),DBK,B,NVM,INK,1)
                end if
                S(I:I+NKM-1) = S(I:I+NKM-1)+B(1:NKM)
              end if
            else
              COPI = COP(II)/(sqrt(ENP(INDA))*sqrt(ENP(INDB)))
              !write(u6,652) IFT,NYL,NSK,MYL,INDA,INDB
              if (NYL /= 1) then
                if (NSK > MYL) then
                  call FMMM(C(INMY),C(INNY+IPOB(NSK)),B,1,INK,NVM)
                else
                  call FMMM(C(INNY+IPOB(MYL)),C(INMY),B,INK,1,NVM)
                  if (IFT == 1) COPI = -COPI
                end if
              else
                if (IFT == 0) call SQUAR(C(INNY+IPOB(MYL)),A,NVM)
                if (IFT == 1) call SQUARN(C(INNY+IPOB(MYL)),A,NVM)
                call FMMM(C(INMY),A,B,1,INK,NVM)
              end if
              FK(1:INK) = FK(1:INK)+COPI*B(1:INK)
              !write(u6,651) (FK(I),I=1,INK)
            end if
          end if
        end if
      else
        ICHK = 0
        ITURN = 0
        Skip = .false.
        if ((IDENS == 1) .and. (IJOLD /= 0)) Skip = .true.
        do
          if (Skip) then
            Skip = .false.
          else
            ITURN = 1
            if (KTYP /= 1) then
              NK = IND
              IJOLD = NK
              NSK = NSM(NK)
            else
              INDI = IND
              NI = ibits(INDI,0,10)
              NJ = ibits(INDI,10,10)
              NK = ibits(INDI,20,10)
              NSIJ = MUL(NSM(NI),NSM(NJ))
              NSK = MUL(NSIJ,NSM(NK))
              IJ = IROW(NI)+NJ
              if (IJ /= IJOLD) then
                IJOLD = IJ
                IADR = LASTAD(NOVST+NOTT+IJ)
                FC(1:NOB2) = Zero
                do
                  call iDAFILE(Lu_TiABIJ,2,IBUFIN,LBUF2,IADR)
                  LENGTH = IBUFIN(LBUF1)
                  IADR = IBUFIN(LBUF2)
                  if (LENGTH /= 0) call SCATTER(LENGTH,FC,IBUFIN(LBUF0+1:LBUF0+LENGTH),BUFIN)
                  if (IADR == -1) exit
                end do
              end if
            end if
          end if
          ! FORM VECTOR FK
          NA1 = NSYS(NSK)+1
          NA2 = NSYS(NSK+1)
          INK = 0
          if (NA2 < NA1) exit
          do NA=NA1,NA2
            INK = INK+1
            NAK = IROW(LN+NA)+NK
            if (ITURN == 0) FC(NAK) = FK(INK)
            if (ITURN == 1) FK(INK) = FC(NAK)
          end do
          if (ITURN /= 0) exit
        end do
      end if
    end do
  end do
  if (IDENS /= 0) then
    NA1 = NSYS(NSK)+1
    NA2 = NSYS(NSK+1)
    INK = 0
    do NA=NA1,NA2
      INK = INK+1
      NAK = IROW(LN+NA)+NK
      FC(NAK) = FK(INK)
    end do
  end if
  call DSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC(3),LSYM,NVIRT,SQ2)

  nullify(IBUFIN)

  return

  !651 format(1X,'FK',5F12.6)
  !652 format(1X,'TYP2',6I7)
  !653 format(1X,'FK',5F12.6)
  !654 format(1X,'TYP1,NK,NSK,INDB',3I7)

end subroutine AI_CPF_INTERNAL

end subroutine AI_CPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine applyt2_cvb(vec,gjorb,igjorb,i1alf,i1bet,iato,ibto,phato,phbto)
! Apply T(O) to the vector VEC. O is defined in terms of GJORB.

use casvb_global, only: absym, n1a, n1b, nam1, nbm1, nda, ndb, norb
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: vec(nda,ndb)
real(kind=wp), intent(in) :: gjorb(norb*norb), phato(norb,nam1), phbto(norb,nbm1)
integer(kind=iwp), intent(in) :: igjorb(2,norb*norb), i1alf(n1a,norb), i1bet(n1b,norb), iato(norb,0:nam1), ibto(norb,0:nbm1)
integer(kind=iwp) :: ia, iak, iax, iaxtmp, ib, ibk, ibx, ibxtmp, ij, iorb, jax, jbx, jorb
real(kind=wp) :: scl, tcof
real(kind=wp), parameter :: thresh = 1.0e-10_wp

do ij=1,norb*norb
  iorb = igjorb(2,ij)
  jorb = igjorb(1,ij)
  scl = gjorb(ij)
  if ((iorb /= jorb) .and. (abs(scl) > thresh)) then
    ! a) Alpha excitation
    if (absym(2)) then
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = scl*phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          if (jax > iax) then
            vec(jax,jax:) = vec(jax,jax:)+tcof*vec(iax,jax:)
          else
            vec(jax,jax:iax) = vec(jax,jax:iax)+tcof*vec(jax:iax,iax)
            if (iax < ndb) vec(jax,iax+1:) = vec(jax,iax+1:)+tcof*vec(iax,iax+1:)
          end if
        end if
      end do
    else
      do ia=1,n1a
        iaxtmp = i1alf(ia,iorb)
        jax = iato(jorb,iaxtmp)
        if (jax /= 0) then
          iax = iato(iorb,iaxtmp)
          tcof = scl*phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
          vec(jax,:) = vec(jax,:)+tcof*vec(iax,:)
        end if
      end do
    end if
    ! b) Beta excitation
    if (absym(2)) then
      do ib=1,n1b
        ibxtmp = i1bet(ib,iorb)
        jbx = ibto(jorb,ibxtmp)
        if (jbx /= 0) then
          ibx = ibto(iorb,ibxtmp)
          tcof = scl*phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
          if (jbx > ibx) then
            vec(1:ibx,jbx) = vec(1:ibx,jbx)+tcof*vec(1:ibx,ibx)
            vec(ibx+1:jbx,jbx) = vec(ibx+1:jbx,jbx)+tcof*vec(ibx,ibx+1:jbx)
          else
            vec(1:jbx,jbx) = vec(1:jbx,jbx)+tcof*vec(1:jbx,ibx)
          end if
        end if
      end do
    else
      do ib=1,n1b
        ibxtmp = i1bet(ib,iorb)
        jbx = ibto(jorb,ibxtmp)
        if (jbx /= 0) then
          ibx = ibto(iorb,ibxtmp)
          tcof = scl*phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
          vec(:,jbx) = vec(:,jbx)+tcof*vec(:,ibx)
        end if
      end do
    end if
  else if ((iorb == jorb) .and. (abs(scl-One) > thresh)) then
    ! Alpha singly occupied
    if (absym(2)) then
      do ia=1,n1a
        iak = iato(iorb,i1alf(ia,iorb))
        vec(iak,iak:) = scl*vec(iak,iak:)
      end do
    else
      do ia=1,n1a
        iak = iato(iorb,i1alf(ia,iorb))
        vec(iak,:) = scl*vec(iak,:)
      end do
    end if
    ! Beta singly occupied
    if (absym(2)) then
      do ib=1,n1b
        ibk = ibto(iorb,i1bet(ib,iorb))
        vec(1:ibk,ibk) = scl*vec(1:ibk,ibk)
      end do
    else
      do ib=1,n1b
        ibk = ibto(iorb,i1bet(ib,iorb))
        vec(:,ibk) = scl*vec(:,ibk)
      end do
    end if
  end if
end do
if (absym(2)) then
  do ia=1,nda
    vec(ia+1:ndb,ia) = vec(ia,ia+1:ndb)
  end do
end if

return

end subroutine applyt2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Yoshio Nishimoto                                 *
************************************************************************
      Subroutine OLagVVVO(iSym,DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,T2AO,
     &                    DIA,DI,FIFA,FIMO,A_PT2,MaxVec_PT2)
      USE iSD_data, only: iSD
      use caspt2_global, only: LuGAMMA,LuCMOPT2,LuAPT2,OLag
      use caspt2_global, only: CMOPT2
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp, u6
      use Constants, only: Zero, One
      use caspt2_module, only: IFMSCOUP, IFXMS, IFRMS, IFDW, IFSADREF,
     &                         NSYM, NFRO, NISH, NASH, NSSH,
     &                         NBAS, NBAST, NBMX, NSTATE, JSTATE,
     &                         iRlxRoot
#ifdef _MOLCAS_MPP_
      use caspt2_module, only: NFROT
      use caspt2_global, only: nOLag
      USE Para_Info, ONLY: Is_Real_Par
#endif

      implicit none

      integer(kind=iwp), intent(in) :: iSym, MaxVec_PT2
      real(kind=wp), intent(in) :: DPT2AO(*), DPT2CAO(*), T2AO(*),
     &  DIA(*), DI(*)
      real(kind=wp), intent(inout) :: FPT2AO(*), FPT2CAO(*), A_PT2(*),
     &  FIFA(*), FIMO(*)

      character(len=4096) :: RealName
      logical(kind=iwp) :: DoRys, DoCholesky, is_error, Square
      real(kind=wp), allocatable :: T_hbf(:,:,:,:), vLag(:), WRK1(:),
     &                              WRK2(:)
      integer(kind=iwp), allocatable :: iOffAO(:)
      integer(kind=iwp) :: nBasX(8), KEEP(8), IRC, nSymX, id, lRealName,
     &  iost, iSymI, iSymJ, iSymA, iSymB, nocc, i, nSSDM, nDiff, nSkal,
     &  MaxShlAO, iSh, nBasI, jSh, nBasJ, iBas0, iBas, jBas0, jBas,
     &  iOcc, jOcc, loc1, loc2, j, iRec, nOrbA
      integer(kind=iwp), external :: isFreeUnit
!
!     ----- (VV|VO)
!
!     Compute L_{pq} = (pa|jb) * T_{qj}^{ab}, in particular for
!     (p,q) \in  (virt, inact+act). This operation involves
!     (VV|VO) integrals which are stored in neither disk nor memory.
!     The back-transformation is applied to occupied orbital derivatives
!     of two-electron integrals that have two virtual indices (F, G, H).
!     In principle, the algorithm is to avoid (VV|VO) integrals,
!     i.e. U_{pq} for (p,q) = (vir, inact+act), but can also be applied
!     to U_{pq} for (p,q) = (all, inact+act).
!
      call mma_allocate(vLag,nBasT*nBasT,Label='vLag')
      call mma_allocate(WRK1,nBasT*nBasT,Label='WRK1')
      Call GetOrd(IRC,Square,nSymX,nBasX,KEEP)

      vLag(:) = Zero

      Call DecideOncholesky(DoCholesky)
      If (DoCholesky) Then
        !! No need to save CMOPT2. Just save A_PT2 and B_PT2.
        !! First, save A_PT2 in LuCMOPT2
        If (IFMSCOUP .and. jState /= 1) Then
          call mma_allocate(WRK2,MaxVec_PT2**2,Label='WRK2')

          ! read A_PT2 from LUAPT2
          id = 0
          call ddafile(LUAPT2, 2, WRK2, MaxVec_PT2**2, id)

          A_PT2(1:MaxVec_PT2**2) = A_PT2(1:MaxVec_PT2**2)
     &      + WRK2(1:MaxVec_PT2**2)
          call mma_deallocate(WRK2)
        End If

        ! For SS-CASPT2 I should write A_PT2 on disk only
        ! for the correct iRlxRoot
        if (jState == iRlxRoot .or. IFMSCOUP) then
          ! write A_PT2 in LUAPT2
          id = 0
          call ddafile(LUAPT2,1,A_PT2,MaxVec_PT2**2,id)
        end if

        !rewind(LuGamma)
        Call PrgmTranslate('GAMMA',RealName,lRealName)
        LuGAMMA = isFreeUnit(LuGAMMA)
        Call MOLCAS_Open_Ext2(LuGamma,RealName(1:lRealName),
     &                       'DIRECT','UNFORMATTED',
     &                        iost,.TRUE.,
     &                        nBas(iSym)**2*8,'OLD',is_error)
      End If
      !! 2) Compute ERI (mu rho | nu sigma)
      !! 3) Quarter-transformation of ERI
      !!    (mu rho | j sigma) = sum_{j} C_{nu j} (mu rho | nu sigma)
      !! 4) Contract with AO amplitude
      !!    L_{mu i} = sum_{j,rho sigma} T_{ij}^{mu nu}*(mu rho|j sigma)
      !! the third argument is used wrongly, but should be no problem

      !! D_{mu nu} := DPT2AO
      !! FPT2AO = ((mu nu|rho sigma)-(mu rho|nu sigma)/4
      !!          -(mu sigma|nu rho)/4)*D_{rho sigma}
      isymi = 1
      isymj = 1
      isyma = 1
      isymb = 1
!     nocc = nfro(1)+nish(1)+nash(1)
      nocc = nish(1)+nash(1)
      Call VVVO_Drv(nSym,nBas,nIsh,nFro,KEEP,
     &              iSym,iSymI,iSymA,iSymJ,iSymB,
     &              T2AO,vLag,
     &              nOcc,nBasT,nBMX,
     &              CMOPT2(1+nBasT*nFro(iSymA)),
     &              DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,
     &              DIA,DI,FIFA,FIMO)

      !! Save the half transformed integrals on disk.
      !! It will be used in drvg1.f etc for gradient.
      If (DoCholesky) Then
        !! Do nothing
        Close (LuGAMMA)
      Else
        !! This is only for conventional calculations!!
        Call PrgmTranslate('CMOPT2',RealName,lRealName)
        LuCMOPT2 = isFreeUnit(LuCMOPT2)
        Call MOLCAS_Open_Ext2(LuCMOPT2,RealName(1:lRealName),
     &                       'DIRECT','UNFORMATTED',
     &                        iost,.FALSE.,1,'OLD',is_error)
        !! First, CMOPT2 has to be saved. The MO coefficient matrix in
        !! grvg1.f may be different from CMOPT2.
        Do i = 1, nBasT*nBasT
          Write (LuCMOPT2) CMOPT2(i)
        End Do
        write (LuCMOPT2) (nIsh(1)+nAsh(1))
        write (LuCMOPT2) (nIsh(2)+nAsh(2))
        write (LuCMOPT2) (nIsh(3)+nAsh(3))
        write (LuCMOPT2) (nIsh(4)+nAsh(4))
        write (LuCMOPT2) (nIsh(5)+nAsh(5))
        write (LuCMOPT2) (nIsh(6)+nAsh(6))
        write (LuCMOPT2) (nIsh(7)+nAsh(7))
        write (LuCMOPT2) (nIsh(8)+nAsh(8))
        write (LuCMOPT2) (nFro(1))
        write (LuCMOPT2) (nFro(2))
        write (LuCMOPT2) (nFro(3))
        write (LuCMOPT2) (nFro(4))
        write (LuCMOPT2) (nFro(5))
        write (LuCMOPT2) (nFro(6))
        write (LuCMOPT2) (nFro(7))
        write (LuCMOPT2) (nFro(8))
        !! Number of state-specific density matrix
        !! It is needed, because the separable contribution to the
        !! electron repulsion integral is different
        nSSDM = 0
        If (.not.IFSADREF) Then
          If (nState == 1) Then
            nSSDM = 0
          Else If (IFDW .or. IFRMS) Then
            !! For (X)DW, use nState density matrix
            nSSDM = nState
          Else If (IFXMS) Then
            !! For XMS, use SA density matrix
            nSSDM = 0
          Else If (IFMSCOUP) Then
            !! For MS, use nState density matrix
            nSSDM = nState
          Else
            !! Otherwise, use one SS density matrix
            nSSDM = 1
          End If
        End If
        write (LuCMOPT2) nSSDM

        Close (LuCMOPT2)

!       write(u6,*) 'mo saved'
!       call sqprt(CMOPT2,nbast)
!
        Call PrgmTranslate('GAMMA',RealName,lRealName)
        LuGAMMA = isFreeUnit(LuGAMMA)
        Call MOLCAS_Open_Ext2(LuGamma,RealName(1:lRealName),
     &                       'DIRECT','UNFORMATTED',
     &                        iost,.TRUE.,
     &                        nOcc*nOcc*8,'OLD',is_error)
        if (is_error) then
        write (u6,*) 'Something is wrong in opening LuGamma in olagvvvo'
          call abend()
        end if
        !  Setup for shell. Why do I have to call IniSew damn here?
        !  The number of shells should be able to be referred globally.
        nDiff=1
        DoRys=.True.
        Call IniSew(DoRys,nDiff)
        Call Nr_Shells(nSkal)
        Call Setup_iSD()
        !! see Include/info.fh
        Allocate (iOffAO(nSkal+1))
        MaxShlAO = 0
        iOffAO(1) = 0
        Do iSh = 1, nSkal
          nBasI = iSD(2,iSh)*iSD(3,iSh)
          If (nBasI > MaxShlAO) MaxShlAO = nBasI
          iOffAO(iSh+1) = iOffAO(iSh)+nBasI
        End Do
        ! nMax = MaxShlAO*MaxShlAO*nOcc*nOcc

        Allocate (T_hbf(nOcc,nOcc,MaxShlAO,MaxShlAO))
        Do iSh = 1, nSkal
          !! iSD(2,iSh): number of AOs of the shell
          !! iSD(3,iSh): number of cont. func. of the shell
          nBasI = iSD(2,iSh)*iSD(3,iSh)
          Do jSh = 1, nSkal
            nBasJ = iSD(2,jSh)*iSD(3,jSh)
            Do iBas0 = 1, nBasI
              iBas = iOffAO(iSh) + iBas0
              Do jBas0 = 1, nBasJ
                jBas = iOffAO(jSh) + jBas0
                Do iOcc = 1, nOcc
                  Do jOcc = 1, nOcc
                    loc1 = jOcc-1 + (jBas-1)*nOcc
     &                   + (iOcc-1)*nOcc*nBasT
     &                   + (iBas-1)*nOcc*nBasT*nOcc
                    loc2 = iOcc-1 + (iBas-1)*nOcc
     &                   + (jOcc-1)*nOcc*nBasT
     &                   + (jBas-1)*nOcc*nBasT*nOcc
                    T_hbf(iOcc,jOcc,iBas0,jBas0)
     &                = T2AO(loc1+1)+T2AO(loc2+1)
                  End Do
                End Do
                iRec = iBas+nBasT*(jBas-1)
                if (ifmscoup .and. jstate /= 1) then
                  read (lugamma,rec=irec) (wrk1(i),i=1,nocc*nocc)
                  call daxpy_(nocc*nocc,One,wrk2,1,
     &                        t_hbf(1,1,ibas0,jbas0),1)
                end if
                Write (LuGamma,Rec=iRec)
     &            ((T_hbf(i,j,iBas0,jBas0),i=1,nOcc),j=1,nOcc)
              End Do
            End Do
          End Do
        End Do
        Deallocate (iOffAO)
        Deallocate (T_hbf)
        Close (LuGAMMA)
        Call Free_iSD()
        call clssew()
      End If

      !! 5) L_{ai} = sum_{mu} C_{mu a} L_{mu i}
!     CALL DGEMM_('T','N',nSsh(iSym),nOcc,nBasT,
!    *            One,CMOPT2(1+nBasT*nOcc),nBasT,
!    *                vLag,nBasT,
!    *            One,OLAG(nOCC+1),nOrb(iSymA))
!     write(u6,*) 'olag before vvvo'
!     call sqprt(olag,nbast)
      nOrbA = nFro(iSymA)+nIsh(iSymA)+nAsh(iSymA)+nSsh(iSymA)
      If (DoCholesky) nOcc = nOrbA-nFro(iSymA)
!     write(u6,*) 'vLag'
!     call sqprt(vLag,nbast)
      CALL DGEMM_('T','N',nOrbA,nOcc,nBasT,
     &            One,CMOPT2,nBasT,vLag,nBasT,
     &            One,OLAG(nOrbA*nFro(iSymA)+1),nOrbA)
!     write(u6,*) 'olag after vvvo'
!     call sqprt(olag,nbast)
!
#ifdef _MOLCAS_MPP_
      If (Is_Real_Par()) Then
        if (DoCholesky) call GADSUM(OLag,nOLag)
        If (nFroT == 0) Then
          CALL GADSUM (FPT2AO,nBasT**2)
          CALL GADSUM (FPT2CAO,nBasT**2)
        End If
      End If
#endif
      call mma_deallocate(vLag)
      call mma_deallocate(WRK1)

      END SUBROUTINE OLagVVVO
!
!-----------------------------------------------------------------------
!
      !! focktwo_drv.f
      Subroutine VVVO_Drv(nSym,nBas,nAux,nFro,Keep,
     &                    iSym,iSymI,iSymJ,iSymK,iSymL,
     &                    T2AO,vLag,nOcc,nBasT,
     &                    nBMX,CMO,DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,
     &                    DIA,DI,FIFA,FIMO)

      use stdalloc, only: mma_MaxDBLE, mma_allocate, mma_deallocate
      use Definitions, only: wp, iwp, u6

      implicit none

      integer(kind=iwp), intent(in) :: nSym, iSym, iSymI, iSymJ, iSymK,
     &  iSymL, nBas(8), nAux(8), nFro(8), Keep(8), nOcc, nBasT, nBMX
      real(kind=wp), intent(in) :: CMO(*), T2AO(*), DPT2AO(*),
     &  DPT2CAO(*), DIA(*), DI(*)
      real(kind=wp), intent(inout) :: vLag(*), FPT2AO(*), FPT2CAO(*),
     &  FIFA(*), FIMO(*)

      logical(kind=iwp) :: DoCholesky
      real(kind=wp), allocatable :: W1(:), W2(:), WRK(:)

      integer(kind=iwp) :: i, j, LBUF
*
* nAux is the number of occupied orbitals
      DoCholesky=.false.
      Call DecideOnCholesky(DoCholesky)
!     IF (DoCholesky.and.ALGO == 2)THEN
      !! I assume ALGO=2 does not exist (it is not documented and under
      !! debugging, according to rasscf/cho_rasscf_rdinp.f)
!       call abend()
!     end if

      call mma_allocate(W2,NBMX*NBMX,Label='W2')
      call mma_allocate(WRK,nBasT*nBasT,Label='WRK')
*
      Call mma_MaxDBLE(LBUF)
      If (DoCholesky) LBUF = NBMX*NBMX+1
*
* Standard building of the Fock matrix from Two-el integrals
*
      call mma_allocate(W1,LBUF,Label='W1')

      If (LBUF < 1+NBMX**2) Then
         WRITE(u6,*)' FockTwo_Drv Error: Too little memory remains for'
     &     //' the call to FOCKTWO.'
         WRITE(u6,*)' Largest allocatable array size LBUF=',LBUF
         WRITE(u6,*)' Max nr of bf in any symmetry,  NBMX=',NBMX
         WRITE(u6,*)' Required minimum size     1+NBMX**2=',1+NBMX**2
         WRITE(u6,*)'    (All in Real*8-size words)'
         Call  ABEND()
      End If
*
      IF (DoCholesky) Then
        Call VVVOX2(nAux,Keep,iSym,iSymI,iSymJ,iSymK,iSymL,
     &              vLag,CMO,WRK,
     &              DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,
     &              FIFA,FIMO)
      Else
        Call VVVOX(nSym,nBas,nFro,Keep,
     &             iSymI,iSymJ,iSymK,iSymL,
     &             T2AO,vLag,CMO,nOcc,nBasT,
     &             LBUF,W1,W2,WRK,
     &             DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,
     &             DIA,DI,FIFA,FIMO)
      End If
      !! vLag must be transposed
      !! In VVVOX(2) subroutines, vLag(p,mu) is constructed.
      WRK(1:nBasT**2) = vLag(1:nBasT**2)
      do i = 1, nbast
        do j = 1, nbast
          vlag(i+nbast*(j-1)) = WRK(j+nbast*(i-1))
        end do
      end do
      call mma_deallocate(WRK)
      call mma_deallocate(W1)
      call mma_deallocate(W2)
*
      End SUBROUTINE VVVO_Drv
!
!-----------------------------------------------------------------------
!
      !! focktwo.f
      SUBROUTINE VVVOX(NSYM,NBAS,NFRO,KEEP,
     &                 iSymI,iSymJ,iSymK,iSymL,
     &                 T2AO,vLag,CMO,nOcc,nBasT,LBUF,X1,X2,WRK,
     &                 DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,
     &                 DIA,DI,FIFA,FIMO)

      use definitions, only: wp, iwp, u6
      use Constants, only: Zero, One, Half

      implicit none

      integer(kind=iwp), intent(in) :: NSYM, NBAS(8), NFRO(8), KEEP(8),
     &  iSymI, iSymJ, iSymK, iSymL, nOcc, nBasT, LBUF
      real(kind=wp), intent(in) :: T2AO(nOcc,nBasT,nOcc,nBasT),
     &  CMO(nBasT,*), DPT2AO(*), DPT2CAO(*), DIA(*), DI(*)
      real(kind=wp), intent(inout) :: vLag(nBasT,*), X1(*), X2(*),
     &  WRK(*), FPT2AO(*), FPT2CAO(*), FIFA(*), FIMO(*)

      integer(kind=iwp) ::ISTLT(8), ISTSQ(8), iSym, nB, nB2, nB3, nFroT,
     &  nBasI, KEEPI, nBasJ, KEEPJ, iSymIJ, nBasIJ, nBasK, KEEPK, iSMax,
     &  iSymL_, nBasL, KEEPL, nBasKL, IOPT, LPQ, IPQ, NPQ, IP, JQ, IRC,
     &  ISX
!
      ISTSQ(1)=0
      ISTLT(1)=0
      Do iSym = 2, nSym
        nB  = nBas(iSym-1)
        nB2 = nB*nB
        nB3 = (nB2+nB)/2
        ISTSQ(iSym) = ISTSQ(iSym-1) + nB2
        ISTLT(iSym) = ISTLT(iSym-1) + nB3
      End Do
      nFroT = 0
      Do iSym = 1, nSym
        nFroT = nFroT + nFro(iSym)
      End Do

      nBasI  = nBas(iSymI)
      KEEPI  = KEEP(iSymI)
      ! nAuxI  = nAux(iSymI)
      nBasJ  = nBas(iSymJ)
      KEEPJ  = KEEP(iSymJ)
      ! nAuxJ  = nAux(iSymJ)
      iSymIJ = 1+iEor(iSymI-1,iSymJ-1)
      nBasIJ = nBasI*nBasJ
      If (iSymI == iSymJ) nBasIJ = (nBasI*(nBasI+1))/2
      If (nBasIJ == 0) Return

      nBasK  = nBas(iSymK)
      KEEPK  = KEEP(iSymK)
      ! nAuxK  = nAux(iSymK)
      iSMax  = iSymK
      If (iSymK == iSymI) iSMax = iSymJ
      iSymL_ = 1+iEor(iSymIJ-1,iSymK-1)
      IF (iSymL_ > iSMax) Return !! should not
      nBasL  = nBas(iSymL_)
      KEEPL  = KEEP(iSymL_)
      ! nAuxL  = nAux(iSymL_)
      nBasKL = nBasK*nBasL
      IF (iSymK == iSymL_) nBasKL = (nBasK*(nBasK+1))/2
      If (nBasKL == 0) Return

      ! INTEGRAL BLOCK EXCLUDED BY SETTING KEEP PARAMETERS?
      IF (KEEPI+KEEPJ+KEEPK+KEEPL /= 0) Return
      !! This will not work when the number of the inactive orbital is 0
!     IF (nAuxI+nAuxJ+nAuxK+nAuxL == 0) Return ! frozen orbitals

      !! (ij|kl)
      If (iSymI == iSymJ .AND. iSymI == iSymK) Then
        IOPT=1
        LPQ=0
        IPQ=0
        NPQ=0
        DO IP = 1, nBasI
          DO JQ = 1, IP
            IPQ=IPQ+1
            LPQ=LPQ+1
            IF (IPQ > NPQ) THEN
              CALL RDORD(IRC,IOPT,iSymI,iSymJ,iSymK,iSymL,X1,LBUF,NPQ)
              IF(IRC > 1) then
                WRITE(u6,*)' Error return code IRC=',IRC
                WRITE(u6,*)' from RDORD call, in FTWOI.'
                CALL Abend()
              end if
              IOPT=2
              IPQ=1
            ENDIF
            ISX=(IPQ-1)*nBasKL+1
!           ISF=ISTLT(iSymI)+LPQ
!           ISD=ISTLT(iSymI)+1
            !! coulomb
!           TEMP=DDOT_(KLB,X1(ISX),1,DLT(ISD),1)
!           FLT(ISF)=FLT(ISF)+TEMP
            !! exchange
            !! f_{ik} = (ij|kl)*D_{jl}
            !! read (ij|kl) for given ij as (kl)
            !! first  dgemv: (kl)*D_{l,i} -> f_{ki}
            !! second dgemv: (kl)*D_{l,i} -> f_{ki}

            !! For (mu nu), read (mu nu|rho sigma) as I(rho sigma)
            !! (mu j|rho sigma) = sum_{nu} C_{nu j} (mu nu|rho sigma)

            !! L_{mu i} = T_{ij}^{mu nu} * (mu rho | j sigma)
            !!          = T_{ij}^{rho sigma} * C_{nu j}
            !!                 * (mu rho | nu sigma)

            !! IP = mu, JQ = rho
            !! X2 = (nu sigma) --> X2' = C_{nu j}*(nu sigma) = (j sigma)
            !! T_{ij}^{rho sigma} * (j sigma)
            !!   -> U_{i rho} for (mu, rho) pairs

            CALL SQUARE (X1(ISX),X2(1),1,nBasK,nBasL)
!           If (DoCholesky) Then
!           Else
            !! (mu(ip) rho(jq) | nu sigma) -> (mu(ip) rho(jq) | j sigma)
            call dgemm_('T','N',nOcc,nBasT,nBasT,
     &                  One,CMO,nBasT,X2,nBasT,
     &                  Zero,WRK,nOcc)
            !! wrk(j,sigma) for the given mu(ip), mu(jq)
            !! T2AO(j,sigma,i,rho) = T_{ij}^{rho sigma}
            !! rather than L_{mu i}, L_{i mu} is computed
            !! L_{i mu} = wrk(j,sigma)*(T2AO(j,sigma,i,rho)
            call dgemv_('t',nOcc*nBasT,nOcc,
     &                  One,t2ao(1,1,1,jq),nOcc*nBasT,wrk,1,
     &                  One,vlag(1,ip),1)
            if (ip /= jq) then
              call dgemv_('t',nOcc*nBasT,nOcc,
     &                    One,t2ao(1,1,1,ip),nOcc*nBasT,wrk,1,
     &                    One,vlag(1,jq),1)
!           call dgemm_('T','T',nOcc,nBasT,nBasT,
!    *                  One,CMO,nBasT,X2,nBasT,
!    *                  One,WRK,nOcc)
!           call dgemv_('n',nOcc*nBasT,nOcc,
!    *                  One,t2ao(1,ip,1,1),nOcc*nBasT,wrk,1,
!    *                  One,vlag(1,jq),1)
            end if
!           End If

            !! DPT2AO -> FPT2AO transformation
            !! FPT2 = G(DPT2)
            Call FDGTRF(DPT2AO,FPT2AO)
            Call FDGTRF(DPT2CAO,FPT2CAO)
            If (nFroT /= 0) Then
              Call FDGTRF(DIA,FIFA)
              Call FDGTRF(DI,FIMO)
            End If
            !! Coulomb
!           Val = DDot_(nBasK*nBasL,X2,1,DPT2AO(ISTSQ(iSymI)+1),1)
!           iSF = ISTSQ(iSYmI) + iP + nBasI*(jQ-1)
!           FPT2AO(iSF) = FPT2AO(iSF) + Val
!           !! Exchange
!           iSF = ISTSQ(iSymI) + (jQ-1)*nBasJ+1
!           iSD = ISTSQ(iSymI) + (iP-1)*nBasI+1
!           CALL DGEMV_('N',nBasK,nBasL,
!    *                  -Half,X2,nBasK,DPT2AO(iSD),1,
!    *                  One,FPT2AO(iSF),1)
!           If (iP /= jQ) Then
!             iSF = ISTSQ(iSymI) + jQ + nBasJ*(iP-1)
!             FPT2AO(iSF) = FPT2AO(iSF) + Val
!             iSF = ISTSQ(iSymI) + (iP-1)*nBasI+1
!             iSD = ISTSQ(iSymI) + (jQ-1)*nBasJ+1
!             CALL DGEMV_('N',nBasK,nBasL,
!    *                    -Half,X2,nBasK,DPT2AO(iSD),1,
!    *                    One,FPT2AO(iSF),1)
!           End If
!
!           !! DPT2CAO -> FPT2CAO transformation
!           !! Coulomb
!           Val = DDot_(nBasK*nBasL,X2,1,DPT2CAO(ISTSQ(iSymI)+1),1)
!           iSF = ISTSQ(iSYmI) + iP + nBasI*(jQ-1)
!           FPT2CAO(iSF) = FPT2CAO(iSF) + Val
!           !! Exchange
!           iSF = ISTSQ(iSymI) + (jQ-1)*nBasJ+1
!           iSD = ISTSQ(iSymI) + (iP-1)*nBasI+1
!           CALL DGEMV_('N',nBasK,nBasL,
!    *                  -Half,X2,nBasK,DPT2CAO(iSD),1,
!    *                  One,FPT2CAO(iSF),1)
!           If (iP /= jQ) Then
!             iSF = ISTSQ(iSymI) + jQ + nBasJ*(iP-1)
!             FPT2CAO(iSF) = FPT2CAO(iSF) + Val
!             iSF = ISTSQ(iSymI) + (iP-1)*nBasI+1
!             iSD = ISTSQ(iSymI) + (jQ-1)*nBasJ+1
!             CALL DGEMV_('N',nBasK,nBasL,
!    *                    -Half,X2,nBasK,DPT2CAO(iSD),1,
!    *                    One,FPT2CAO(iSF),1)
!           End If
          End Do
        End Do
      End If

!     ELSE IF ( IS == JS .AND. IS /= KS ) THEN
!       ! CASE 2: Integrals are of symmetry type (II/JJ)
!       ! Coulomb terms need to be accumulated only
!     ELSE IF ( IS == KS .AND. JS == LS ) THEN
!       ! CASE 3: Integrals are of symmetry type (IJ/IJ)
!       ! Exchange terms need to be accumulated only
!         IOPT=1
!         LPQ=0
!         IPQ=0
!         NPQ=0
!         DO IP=1,IB
!           DO JQ=1,JB
!             IPQ=IPQ+1
!             LPQ=LPQ+1
!             IF ( IPQ > NPQ ) THEN
!               CALL RDORD(IRC,IOPT,IS,JS,KS,LS,X1,LBUF,NPQ)
!               IF(IRC > 1) then
!                 WRITE(u6,*)' Error return code IRC=',IRC
!                 WRITE(u6,*)' from RDORD call, in FTWOI.'
!                 CALL Abend()
!               end if
!               IOPT=2
!               IPQ=1
!             ENDIF
!             ISX=(IPQ-1)*KLB+1
!             IF ( NFI /= 0 ) THEN
!               ISD=ISTSQ(IS)+(IP-1)*IB+1
!               ISF=ISTSQ(JS)+(JQ-1)*JB+1
!               CALL DGEMV_('N',LB,KB,(-Half*ExFac),X1(ISX),LB,
!    &                       DSQ(ISD),1,One,FSQ(ISF),1)
!             ENDIF
!             IF ( NFJ /= 0 ) THEN
!               ISD=ISTSQ(JS)+(JQ-1)*JB+1
!               ISF=ISTSQ(IS)+(IP-1)*IB+1
!               CALL DGEMV_('T',LB,KB,(-Half*ExFac),X1(ISX),LB,
!    &                       DSQ(ISD),1,One,FSQ(ISF),1)
!             ENDIF
!           End Do
!         End Do
!     End If

      RETURN

      Contains

      Subroutine FDGTRF(DD,FF)

      implicit none

      real(kind=wp), intent(in) :: DD(*)
      real(kind=wp), intent(inout) :: FF(*)

      real(kind=wp) :: Val
      real(kind=wp), external :: ddot_
      integer(kind=iwp) :: iSF, iSD

      !! Coulomb
      Val = DDot_(nBasK*nBasL,X2,1,DD(ISTSQ(iSymI)+1),1)
      iSF = ISTSQ(iSYmI) + iP + nBasI*(jQ-1)
      FF(iSF) = FF(iSF) + Val

      !! Exchange
      iSF = ISTSQ(iSymI) + (jQ-1)*nBasJ+1
      iSD = ISTSQ(iSymI) + (iP-1)*nBasI+1
      CALL DGEMV_('N',nBasK,nBasL,
     &           -Half,X2,nBasK,DD(iSD),1,
     &            One,FF(iSF),1)
      If (iP /= jQ) Then
        iSF = ISTSQ(iSymI) + jQ + nBasJ*(iP-1)
        FF(iSF) = FF(iSF) + Val
        iSF = ISTSQ(iSymI) + (iP-1)*nBasI+1
        iSD = ISTSQ(iSymI) + (jQ-1)*nBasJ+1
        CALL DGEMV_('N',nBasK,nBasL,
     &             -Half,X2,nBasK,DD(iSD),1,
     &              One,FF(iSF),1)
      End If

      End Subroutine FDGTRF

      End Subroutine VVVOX
!
!-----------------------------------------------------------------------
!
      !! mabe taken from tracho3.f
      SUBROUTINE VVVOX2(nAux,KEEP,iSym,iSymI,iSymJ,iSymK,iSymL,
     &                  vLag,CMO,WRK,
     &                  DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,
     &                  FIFA,FIMO)

      use ChoVec_io, only: NVLOC_CHOBATCH
      use Cholesky, only: InfVec, nDimRS
      use caspt2_global, only: LuGAMMA
      use ChoCASPT2, only: numcho_pt2, NCHSPC, MXNVC
      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: IFMSCOUP, NSYM, NFROT, NISH, NASH, NSSH,
     &                         NBAS, NBAST, JSTATE, iRlxRoot, NBTCHES
      use Constants, only: Zero, One, Half, Two

      implicit none

#include "warnings.h"

      integer(kind=iwp), intent(in) :: nAux(8), KEEP(8), iSym, iSymI,
     &  iSymJ, iSymK, iSymL
      real(kind=wp), intent(inout) :: vLag(nBasT,*), WRK(nBasT,nBasT),
     &  FPT2AO(*), FPT2CAO(*), FIFA(*), FIMO(*)
      real(kind=wp), intent(in) :: CMO(nBasT,*), DPT2AO(*), DPT2CAO(*)

      real(kind=wp), allocatable :: CHSPC(:), HTSPC(:), HTVec(:)
      integer(kind=iwp) :: ISTLT(8), ISTSQ(8), iSkip(8), ipWRK(8), jSym,
     &  nAuxT, nB, nB2, nB3, nBasI, KEEPI, nBasJ, KEEPJ, iSymIJ, nBasIJ,
     &  nBasK, KEEPK, iSMax, iSymL_, nBasL, KEEPL, nBasKL, nIshI, nAshI,
     &  nSshI, nOrbI, IBATCH_TOT, JRED1, JRED2, JRED, JSTART, NVECS_RED,
     &  ILOC, IRC, NBATCH, JV1, IBATCH, JNUM, JV2, JREDC, NUMV, MUSED,
     &  iVec, i, j
      real(kind=wp) :: tmp

      Do jSym = 1, nSym
        iSkip(jSym) = 1
        ipWRK(jSym) = 1
      End Do

      ISTSQ(1)=0
      ISTLT(1)=0
      nAuxT = 0
      Do jSym = 2, nSym
        nB  = nBas(jSym-1)
        nB2 = nB*nB
        nB3 = (nB2+nB)/2
        ISTSQ(jSym) = ISTSQ(jSym-1) + nB2
        ISTLT(jSym) = ISTLT(jSym-1) + nB3
        nAuxT = nAuxT + nAux(jSym)
      End Do

      nBasI  = nBas(iSymI)
      KEEPI  = KEEP(iSymI)
      ! nAuxI  = nAux(iSymI)
      nBasJ  = nBas(iSymJ)
      KEEPJ  = KEEP(iSymJ)
      ! nAuxJ  = nAux(iSymJ)
      iSymIJ = 1+iEor(iSymI-1,iSymJ-1)
      nBasIJ = nBasI*nBasJ
      If (iSymI == iSymJ) nBasIJ = (nBasI*(nBasI+1))/2
      If (nBasIJ == 0) Return

      nBasK  = nBas(iSymK)
      KEEPK  = KEEP(iSymK)
      ! nAuxK  = nAux(iSymK)
      iSMax  = iSymK
      If (iSymK == iSymI) iSMax = iSymJ
      iSymL_ = 1+iEor(iSymIJ-1,iSymK-1)
      IF (iSymL_ > iSMax) Return !! should not
      nBasL  = nBas(iSymL_)
      KEEPL  = KEEP(iSymL_)
      ! nAuxL  = nAux(iSymL_)
      nBasKL = nBasK*nBasL
      IF (iSymK == iSymL) nBasKL = (nBasK*(nBasK+1))/2
      If (nBasKL == 0) Return

      ! INTEGRAL BLOCK EXCLUDED BY SETTING KEEP PARAMETERS?
      IF (KEEPI+KEEPJ+KEEPK+KEEPL /= 0) Return
      !! This will not work when the number of the inactive orbital is 0
!     IF (nAuxI+nAuxJ+nAuxK+nAuxL == 0) Return ! frozen orbitals

      jSym = iSymJ
      ! kSym = iSymK
      ! lSym = iSymL
      nIshI = nIsh(iSym)
      ! nIshJ = nIsh(jSym)
      ! nIshK = nIsh(kSym)
      ! nIshL = nIsh(lSym)
      nAshI = nAsh(iSym)
      ! nAshJ = nAsh(jSym)
      ! nAshK = nAsh(kSym)
      ! nAshL = nAsh(lSym)
      nSshI = nSsh(iSym)
      ! nSshJ = nSsh(jSym)
      ! nSshK = nSsh(kSym)
      ! nSshL = nSsh(lSym)
      nOrbI = nIshI+nAshI+nSshI

      call mma_allocate(CHSPC,NCHSPC,Label='CHSPC')
      call mma_allocate(HTSPC,NCHSPC,Label='HISPC')
      call mma_allocate(HTVec,nBasT*nBasT,Label='HTVEC')

      IBATCH_TOT=NBTCHES(iSym)

      IF(NUMCHO_PT2(iSym) == 0) Return

      JRED1=InfVec(1,2,jSym)
      JRED2=InfVec(NumCho_PT2(jSym),2,jSym)

* Loop over JRED
      DO JRED=JRED1,JRED2

        CALL Cho_X_nVecRS(JRED,iSym,JSTART,NVECS_RED)
        IF(NVECS_RED == 0) Cycle

        ILOC=3
        CALL CHO_X_SETRED(IRC,ILOC,JRED)
* For a reduced set, the structure is known, including
* the mapping between reduced index and basis set pairs.
* The reduced set is divided into suitable batches.
* First vector is JSTART. Nr of vectors in r.s. is NVECS_RED.
        ! JEND=JSTART+NVECS_RED-1

* Determine batch length for this reduced set.
* Make sure to use the same formula as in the creation of disk
* address tables, etc, above:
        NBATCH=1+(NVECS_RED-1)/MXNVC

* Loop over IBATCH
        JV1=JSTART
        DO IBATCH=1,NBATCH
!         write(6,*) 'ibatch,nbatch = ', ibatch,nbatch
          IBATCH_TOT=IBATCH_TOT+1

          JNUM=NVLOC_CHOBATCH(IBATCH_TOT)
          JV2=JV1+JNUM-1
!
!         ----- Construct orbital Lagrangian -----
!
          !! CHSPC       :: (mu nu|P)
          !! HTSPC       :: ( q nu|P)
          !! Bra and Ket :: (ia|P) = T_{ij}^{ab}*(jb|P)
          !! In 1), HT_{i mu,P} = C_{mu a}*(ia|P)
          !!        (ia|P) read from disk
          !! In 3), L_{i mu} = HT_{i nu,P} * (mu nu|P)
          !! Then, L_{pi} = C_{mu p} * L_{i mu}^T
          !! Transpose is done in VVVO_Drv2,
          !! and C_{mu p} is in OLagVVVO

          !! 1) Half back-transformation of Bra and Ket density
          !! Read the 3c-2e pseudo-density (in MO), and half transform
          CALL VVVOTRA_RI(CMO,CHSPC,HTSPC,
     &                    JNUM,IBATCH_TOT,IBATCH_TOT,nOrbI)

          !! 2) read AO Cholesky vectors,
          !!    then, (strange) reduced form -> squared AO (mu nu|iVec)
          JREDC=JRED
* Read a batch of reduced vectors
          CALL CHO_VECRD(CHSPC,NCHSPC,JV1,JV2,iSym,
     &                            NUMV,JREDC,MUSED)
          IF(NUMV /= JNUM) THEN
            write(u6,*)' Rats! CHO_VECRD was called, assuming it to'
            write(u6,*)' read JNUM vectors. Instead it returned NUMV'
            write(u6,*)' vectors: JNUM, NUMV=',JNUM,NUMV
            write(u6,*)' Back to the drawing board?'
            CALL QUIT(_RC_INTERNAL_ERROR_)
          END IF
          IF(JREDC /= JRED) THEN
            write(u6,*)' Rats! It was assumed that the Cholesky vectors'
            write(u6,*)' in HALFTRNSF all belonged to a given reduced'
            write(u6,*)' set, but they don''t!'
            write(u6,*)' JRED, JREDC:',JRED,JREDC
            write(u6,*)' Back to the drawing board?'
            write(u6,*)' Let the program continue and see what happens.'
          END IF

          !! (strange) reduced form -> squared AO (mu nu|iVec)
          !! is it possible to avoid this transformation?
      ! choptr.fh
          Call R2FIP(CHSPC,WRK,ipWRK(iSym),NUMV,
     &               size(nDimRS),infVec,nDimRS,
     &               nBasT,nSym,iSym,iSkip,irc,JREDC)
!
!           ----- Fock-like transformations (if needed) -----
!
          If (nFroT == 0) Then
            Do iVec = 1, NUMV
              Call FDGTRF(CHSPC(1+nBasT**2*(iVec-1)),
     &                    DPT2AO,FPT2AO)
              Call FDGTRF(CHSPC(1+nBasT**2*(iVec-1)),
     &                    DPT2CAO,FPT2CAO)
            End Do
          End If

          !! 3) Contract with Cholesky vectors
          Call DGemm_('N','T',nOrbI,nBasI,nBasI*JNUM,
     &                Two,HTSPC,nOrbI,CHSPC,nBasI,
     &                One,vLag,nBasI)

          !! 4) Construct the 3c-2e pseudo-density in AO
          !! D_{p nu} -> D_{mu nu}
          !! i.e., construct B_PT2, used in ALASKA
          Call DGemm_('N','N',nBasI,nBasI*JNUM,nOrbI,
     &                One,CMO(1,1),nBasI,HTSPC,nOrbI,
     &                Zero,CHSPC,nBasI)

          !! 5) Save the 3c-2e pseudo-density in the disk
          !! it may be replaced with ddafile
          Do iVec = 1, NUMV
            If (IFMSCOUP .and. jState /= 1) Then
              Read (LuGamma,Rec=iVec+JV1-1) HTVec(1:nBasI**2)
              Call DaXpY_(nBasI**2,One,
     &                    CHSPC(1+nBasI**2*(iVec-1)),1,
     &                    HTVec,1)
              Write (LuGamma,Rec=iVec+JV1-1) HTVec(1:nBasI**2)
            Else
             if (jState == iRlxRoot .or. IFMSCOUP) then
              Write (LuGamma,Rec=iVec+JV1-1)
     &        CHSPC(1+nBasI**2*(iVec-1):nBasI**2*iVec)
             end if
            End If
          End Do

          JV1=JV1+JNUM
        End Do
      End Do

      call mma_deallocate(CHSPC)
      call mma_deallocate(HTSPC)
      call mma_deallocate(HTVec)

      !! Have to (?) symmetrize Fock-transformed matrices
      If (nFroT == 0) Then
        Do i = 1, nBasI
          Do j = 1, i-1
            tmp = (FPT2AO(i+nBasI*(j-1))+FPT2AO(j+nBasI*(i-1)))*Half
            FPT2AO(i+nBasI*(j-1)) = Tmp
            FPT2AO(j+nBasI*(i-1)) = Tmp
            tmp = (FPT2CAO(i+nBasI*(j-1))+FPT2CAO(j+nBasI*(i-1)))*Half
            FPT2CAO(i+nBasI*(j-1)) = Tmp
            FPT2CAO(j+nBasI*(i-1)) = Tmp
            If (nFroT /= 0) Then
              tmp = (FIFA(i+nBasI*(j-1))+FIFA(j+nBasI*(i-1)))*Half
              FIFA(i+nBasI*(j-1)) = Tmp
              FIFA(j+nBasI*(i-1)) = Tmp
              tmp = (FIMO(i+nBasI*(j-1))+FIMO(j+nBasI*(i-1)))*Half
              FIMO(i+nBasI*(j-1)) = Tmp
              FIMO(j+nBasI*(i-1)) = Tmp
            End If
          End Do
        End Do
      End If

      Return

      Contains

      Subroutine FDGTRF(ChoVec,DD,FF)

      implicit none

      real(kind=wp), intent(in) :: ChoVec(*), DD(*)
      real(kind=wp), intent(inout) :: FF(*)

      real(kind=wp) :: Scal
      real(kind=wp), external :: ddot_

      !! Coulomb
      Scal = DDot_(nBasI**2,DD,1,ChoVec,1)
      Call DaXpY_(nBasI**2,Scal,ChoVec,1,FF,1)

      !! Exchange
      Call DGEMM_('T','N',nBasI,nBasI,nBasI,
     &            One,ChoVec,nBasI,DD,nBasI,
     &            Zero,WRK,nBasI)
      Call DGEMM_('T','T',nBasI,nBasI,nBasI,
     &           -Half,ChoVec,nBasI,WRK,nBasI,
     &            One,FF,nBasI)

      End Subroutine FDGTRF

      Subroutine VVVOTRA_RI(CMO,CHSPC_,HTSPC_,NVEC,IBSTA,IBEND,nOrbI)

      implicit none

      integer(kind=iwp), intent(in) :: NVEC, IBSTA, IBEND, nOrbI
      real(kind=wp), intent(in) :: CMO(nBasI,nOrbI)
      !! CHSPC is used as a temporary array
      real(kind=wp), intent(inout) :: CHSPC_(*), HTSPC_(nOrbI,nBasT,*)

      integer(kind=iwp), parameter :: Inactive=1, Active=2, Virtual=3
      integer(kind=iwp) :: IPQ, jVec, nBra

      !! BraAI
      Call Cholesky_Vectors(2,Inactive,Active,JSYM,CHSPC_,nBra,
     &                      IBSTA,IBEND)
      IPQ = nAshI*nIshI
      Do jVec = 1, NVEC
        ! a. AI -> mu I
        Call DGemm_('T','T',nIshI,nBasI,nAshI,
     &              One,CHSPC_(1+IPQ*(jVec-1)),nAshI,
     &                  CMO(1,1+nIshI),nBasI,
     &              Zero,HTSPC_(1,1,jVec),nOrbI)
        ! a. AI -> A mu
        Call DGemm_('N','T',nAshI,nBasI,nIshI,
     &              One,CHSPC_(1+IPQ*(jVec-1)),nAshI,
     &                  CMO(1,1),nBasI,
     &              Zero,HTSPC_(1+nIshI,1,jVec),nOrbI)
      End Do

      !! BraSI
      Call Cholesky_Vectors(2,Inactive,Virtual,JSYM,CHSPC_,nBra,
     &                      IBSTA,IBEND)
      IPQ = nIshI*nSshI
      Do jVec = 1, NVEC
        ! b. SI -> mu I
        Call DGemm_('T','T',nIshI,nBasI,nSshI,
     &              One,CHSPC_(1+IPQ*(jVec-1)),nSshI,
     &                  CMO(1,1+nIshI+nAshI),nBasI,
     &              One,HTSPC_(1,1,jVec),nOrbI)
        ! a. SI -> S mu
        Call DGemm_('N','T',nSshI,nBasI,nIshI,
     &              One,CHSPC_(1+IPQ*(jVec-1)),nSshI,
     &                  CMO(1,1),nBasI,
     &              Zero,HTSPC_(1+nIshI+nAshI,1,jVec),nOrbI)
      End Do

      !! BraSA
      Call Cholesky_Vectors(2,Active,Virtual,JSYM,CHSPC_,nBra,
     &                      IBSTA,IBEND)
      IPQ = nAshI*nSshI
      Do jVec = 1, NVEC
        ! d. SA -> mu A
        Call DGemm_('T','T',nAshI,nBasI,nSshI,
     &              One,CHSPC_(1+IPQ*(jVec-1)),nSshI,
     &                  CMO(1,1+nIshI+nAshI),nBasI,
     &              One,HTSPC_(1+nIshI,1,jVec),nOrbI)
        ! b. SA -> S mu
        Call DGemm_('N','T',nSshI,nBasI,nAshI,
     &              One,CHSPC_(1+IPQ*(jVec-1)),nSshI,
     &                  CMO(1,1+nIshI),nBasI,
     &              One,HTSPC_(1+nIshI+nAshI,1,jVec),nOrbI)
      End Do

      !! BraAA
      Call Cholesky_Vectors(2,Active,Active,JSYM,CHSPC_,nBra,
     &                      IBSTA,IBEND)
      IPQ = nAshI*nAshI
      Do jVec = 1, NVEC
        ! b. AA -> mu A
        Call DGemm_('T','T',nAshI,nBasI,nAshI,
     &              One,CHSPC_(1+IPQ*(jVec-1)),nAshI,
     &                  CMO(1,1+nIshI),nBasI,
     &              One,HTSPC_(1+nIshI,1,jVec),nOrbI)
        ! c. AA -> A mu
        Call DGemm_('N','T',nAshI,nBasI,nAshI,
     &              One,CHSPC_(1+IPQ*(jVec-1)),nAshI,
     &                  CMO(1,1+nIshI),nBasI,
     &              One,HTSPC_(1+nIshI,1,jVec),nOrbI)
      End Do

      End Subroutine VVVOTRA_RI

      End Subroutine VVVOX2
!
!-----------------------------------------------------------------------
!
      subroutine getritrfinfo(nnbstr_,maxvec_,n2_)
      use Cholesky, only: infvec_N2, MaxVec, nnBstR
      use definitions, only: iwp
      implicit none
      integer(kind=iwp), intent(out) :: nnbstr_(8,3), maxvec_, n2_
      maxvec_ = maxvec
      n2_     = infvec_n2
      nnbstr_ = nnbstr
      end subroutine getritrfinfo
!
!-----------------------------------------------------------------------
!
      Subroutine R2FIP(CHSPC,WRK,ipWRK,NUMV,l_NDIMRS,INFVEC,
     &                 nDimRS,nBasT,nSym0,iSym,iSkip,irc,JREDC)

      Use Cholesky, only: INFVEC_N2, MaxVec, nnBstR
      use definitions, only: wp, iwp
      use Constants, only: Zero

      implicit none

      real(kind=wp), intent(inout) :: CHSPC(*), WRK(*)
      integer(kind=iwp), intent(in) :: ipWRK(*), NUMV, l_NDIMRS,
     &  INFVEC(MAXVEC,INFVEC_N2,*), nSym0, nDimRS(nSym0,*), nBasT, iSym,
     &  iSkip(8)
      integer(kind=iwp), intent(inout) :: irc, JREDC

      integer(kind=iwp) :: kloc, iVec, lscr, JREDL, ipVecL, jloc
!
!     Transform the reduced form to the full form in place
!
      kloc = 0
      Do iVec = 1, NUMV
        If (l_NDIMRS < 1) Then
          lscr  = NNBSTR(iSym,3)
        Else
          JREDL = INFVEC(iVec,2,iSym)
          lscr  = nDimRS(iSym,JREDL) !! JRED?
        End If
        kloc = kloc + lscr
      End Do

      ipVecL = 1 + kloc !! lscr*(JNUM-1)
      jloc = (NUMV-1)*nBasT**2+1
      Do iVec = NUMV, 1, -1
        If (l_NDIMRS < 1) Then
          lscr  = NNBSTR(iSym,3)
        Else
          JREDL = INFVEC(iVec,2,iSym)
          lscr  = nDimRS(iSym,JREDL) !! JRED?
        End If
        ipVecL = ipVecL - lscr
        WRK(1:nBasT**2) = Zero
        Call Cho_ReOrdr(irc,CHSPC(ipVecL),lscr,1,
     &                  1,1,1,iSym,JREDC,2,ipWRK,WRK,
     &                  iSkip)
        CHSPC(jloc:jloc+nBasT**2-1) = WRK(1:nBasT**2)
        jloc = jloc-nBasT**2
      End Do

      Return

      End Subroutine R2FIP

!************************************************************************
!* This file is part of OpenMolcas.                                     *
!*                                                                      *
!* OpenMolcas is free software; you can redistribute it and/or modify   *
!* it under the terms of the GNU Lesser General Public License, v. 2.1. *
!* OpenMolcas is distributed in the hope that it will be useful, but it *
!* is provided "as is" and without any express or implied warranties.   *
!* For more details see the full text of the license in the file        *
!* LICENSE or in <http://www.gnu.org/licenses/>.                        *
!************************************************************************
!
!PUBLIC ::      read_magnetic_moment,       write_magnetic_moment,  &
!               read_electric_moment,       write_electric_moment,  &
!               read_spin_moment,           write_spin_moment,      &
!               read_angmom,                write_angmom,           &
!               read_edipmom,               write_edipmom,          &
!               read_amfi,                  write_amfi,             &
!               read_nss,                   write_nss,              &
!               read_nmult,                 write_nmult,            &
!               read_imult,                 write_imult,            &
!               read_format,                write_format,           &
!               read_nroot,                 write_nroot,            &
!               read_nstate,                write_nstate,           &
!               read_multiplicity,          write_multiplicity,     &
!               read_szproj,                write_szproj,           &
!               read_eso,                   write_eso,              &
!               read_esfs,                  write_esfs,             &
!               read_hso,                   write_hso,              &
!               read_eigen,                 write_eigen,            &
!               read_gtens,                 write_gtens,            &
!               read_stev_cfp,              write_stev_cfp,         &
!               read_susc,                  write_susc,             &
!               read_magn,                  write_magn,             &
!               read_complex_matrix,        write_complex_matrix,   &
!               open_datafile_read,         open_datafile_write,    &
!               close_datafile,                                     &
!               check_hermiticity_matrix,   check_commutation,      &
!               check_S_square
!
!
!PRIVATE ::     file_advance_to_string,     inquire_key_presence,   &
!               read_INTEGER_scalar,        write_INTEGER_scalar,   &
!               read_1d_INTEGER_array,      write_1d_INTEGER_array, &
!               read_1d_real_array,         write_1d_real_array,    &
!               read_2d_real_array,         write_2d_real_array,    &
!               read_3d_real_array,         write_3d_real_array
!
!               write_string,                                       &
!               read_real_scalar,           write_real_scalar,      &
!               read_complex_scalar,        write_complex_scalar,   &
!               read_1d_size,                                       &
!               read_2d_size,                                       &
!               read_3d_size,                                       &
!               read_4d_size,                                       &
!               read_1d_complex_array,      write_1d_complex_array, &
!               read_2d_complex_array,      write_2d_complex_array
!               read_2d_INTEGER_array,      write_2d_INTEGER_array, &
!               read_3d_INTEGER_array,      write_3d_INTEGER_array, &
!               read_4d_INTEGER_array,      write_4d_INTEGER_array, &
!               read_4d_real_array,         write_4d_real_array,    &
!               read_3d_complex_array,      write_3d_complex_array, &
!               read_4d_complex_array,      write_4d_complex_array
! Keywords:
!    $dipm   --  electric dipole moment, SO basis  (6 components: _xr,_xi,  _yr,_yi,  _zr,_zi)
!    $magn   --  magnetic dipole moment, SO basis  (6 components: _xr,_xi,  _yr,_yi,  _zr,_zi)
!    $angmom --  orbital moment (L)    , SF basis  (3 compinents: _x, _y, _z)
!    $edip   --  electric dipole moment, SF basis  (3 components: _x, _y, _z)
!    $hso    --  spin-orbit hamiltonian, SO basis  (2 components: _r, _i)
!    $eigen  --  spin-orbit eigenstates, SO basis  (2 components: _r, _i)
!
!    $eso
!    $esfs
!    $multiplicity
!    $szvalue

!---- high level functions -------
!     >>> available <<<
! read_magnetic_moment
! read_electric_moment
! read_angmom
! read_edipmom
! read_eigenv
! read_hso
! read_nss
! read_nstate
! read_eso
! read_esfs
! read_szproj
! read_gtens
! xt,               &
! xt_field,         &
!    >>> verification functions <<<
! verify_commutation(L, S)
! verify_L2
! verify_S2
! verify_hermiticity
!---------------------------------
!   >>> yet_to_add <<<
! write_exch_ham
! write_exch_functions
! write_CFP
! write_magnetic_axes
! write_xyz
!
! x,                &
! x_field,          &
! x_minus_one,      &
! x_field,          &
! x_field_minus_one,&
! magnetization,    &
!
! read_MOs
! read_CI_in_SD
! read_CI_in_CSF
! read_coeff_of_CSF
!--------------------------

!------ low-level functions ----
! read_INTEGER_scalar
! read_real_scalar
! read_complex_scalar
! read_string
!
! read_string_length
!
! read_1d_size
! read_2d_size
! read_3d_size
! read_4d_size
!
! read_1d_INTEGER_array
! read_2d_INTEGER_array
! read_3d_INTEGER_array
! read_4d_INTEGER_array
!
! read_1d_real_array
! read_2d_real_array
! read_3d_real_array
! read_4d_real_array
!
! read_1d_complex_array
! read_2d_complex_array
! read_3d_complex_array
! read_4d_complex_array
!
!
! write_INTEGER_scalar
! write_real_scalar
! write_complex_scalar
! write_string
!
! write_1d_INTEGER_array
! write_2d_INTEGER_array
! write_3d_INTEGER_array
! write_4d_INTEGER_array
!
! write_1d_real_array
! write_2d_real_array
! write_3d_real_array
! write_4d_real_array
!
! write_1d_complex_array
! write_2d_complex_array
! write_3d_complex_array
! write_4d_complex_array
!
! open_datafile_write
! open_datafile_read
! close_datafile
! key_found
! file_advance_to_string
!--------------------------------------------------------------------------------------------------!

!--------------------------------------------------------------------------------------------------!
!           HIGH LEVEL VERIFICATION SUBROUTINES
!--------------------------------------------------------------------------------------------------!
SUBROUTINE check_commutation( n, moment, dbg )
   ! valid for S, L, J in spin-orbit basis
   IMPLICIT NONE
   INTEGER, PARAMETER        :: wp = kind(0.d0)
   INTEGER, INTENT (IN)      :: N
   COMPLEX (wp), INTENT (IN) :: moment(3,N,N)
   COMPLEX (wp), ALLOCATABLE :: XY(:,:), YX(:,:), YZ(:,:), ZY(:,:), ZX(:,:), XZ(:,:)
   COMPLEX (wp)              :: tr
   LOGICAL, INTENT (IN)      :: dbg
   COMPLEX (wp), PARAMETER   :: ZeroC=(0.0_wp,0.0_wp), OneC=(1.0_wp,0.0_wp), cI=(0.0_wp,1.0_wp)
   INTEGER                   :: i, j, l
   INTEGER, PARAMETER        :: StdOut = 6

   ! verify the commutation relations for S
   ALLOCATE (XY(n,n))
   ALLOCATE (YX(n,n))
   ALLOCATE (YZ(n,n))
   ALLOCATE (ZY(n,n))
   ALLOCATE (ZX(n,n))
   ALLOCATE (XZ(n,n))
   XY=ZeroC
   YX=ZeroC
   CALL zgemm_('n', 'n', n, n, n, OneC,     &
              moment(1,1:n,1:n), n,         &
              moment(2,1:n,1:n), n, ZeroC,  &
              XY, n )

   CALL zgemm_('n', 'n', n, n, n, OneC,     &
              moment(2,1:n,1:n), n,         &
              moment(1,1:n,1:n), n, ZeroC,  &
              YX, n )

   YZ=ZeroC
   ZY=ZeroC
   CALL zgemm_('n', 'n', n, n, n, OneC,     &
              moment(2,1:n,1:n), n,         &
              moment(3,1:n,1:n), n, ZeroC,  &
              YZ, n )

   CALL zgemm_('n', 'n', n, n, n, OneC,     &
              moment(3,1:n,1:n), n,         &
              moment(2,1:n,1:n), n, ZeroC,  &
              ZY, n )

   ZX=ZeroC
   XZ=ZeroC
   CALL zgemm_('n', 'n', n, n, n, OneC,     &
              moment(3,1:n,1:n), n,         &
              moment(1,1:n,1:n), n, ZeroC,  &
              ZX, n )

   CALL zgemm_('n', 'n', n, n, n, OneC,     &
              moment(1,1:n,1:n), n,         &
              moment(3,1:n,1:n), n, ZeroC,  &
              XZ, n )

   IF (dbg) THEN
      DO l=1, 3
        WRITE(StdOut,'(A,I2)') 'check_commutation:: moment, projection, L=', l
        DO i=1,n
           WRITE(StdOut,'(10(2F8.4,2x))') (moment(l,i,j),j=1,n)
        END DO
      END DO

      WRITE(StdOut,'(A,I2)') 'check_commutation:: XY-YX'
      DO i=1,n
         WRITE(StdOut,'(10(2F8.4,2x))') (XY(i,j)-YX(i,j), j=1,n)
      END DO

      WRITE(StdOut,'(A,I2)') 'check_commutation:: i*Z'
      DO i=1,n
         WRITE(StdOut,'(10(2F8.4,2x))') (cI*moment(3,i,j), j=1,n)
      END DO

      WRITE(StdOut,'(A,I2)') 'check_commutation:: (XY-YX) -i*Z'
      DO i=1,n
         WRITE(StdOut,'(10(2F8.4,2x))') (XY(i,j)-YX(i,j)-cI*moment(3,i,j), j=1,n)
      END DO
   ENDIF


   tr=ZeroC
   DO i=1,n
     DO j=1,n
       tr = tr  + XY(i,j) - YX(i,j) - cI*moment(3,i,j) &
                + YZ(i,j) - ZY(i,j) - cI*moment(1,i,j) &
                + ZX(i,j) - XZ(i,j) - cI*moment(2,i,j)
     END DO
   END DO

   IF (dbg) WRITE (StdOut,'(A,ES22.14)') 'check_commutation::  trace of [Sx,Sy]-iSz = ', ABS(tr)
   IF (ABS(tr)>1.0e-6_wp) THEN
      CALL WarningMessage(1,'check_commutation:: trace of [Sx,Sy]-iSz  is larger than 1.0e-6. '//&
                            'The input moment looks inacurate')
   ELSE
      WRITE (StdOut,'(A,ES22.14)') 'check_commutation:  The input moment passes all three commutation tests.'
   END IF

   DEALLOCATE (XY)
   DEALLOCATE (YX)
   DEALLOCATE (YZ)
   DEALLOCATE (ZY)
   DEALLOCATE (ZX)
   DEALLOCATE (XZ)

   RETURN
END SUBROUTINE check_commutation


SUBROUTINE check_S_square (n, moment, dbg)
!  valid also for J, L, S
   IMPLICIT NONE
   INTEGER, PARAMETER :: wp = kind(0.d0)
   INTEGER, INTENT (IN)      :: n
   COMPLEX (wp), INTENT (IN) :: moment(3,n,n)
   COMPLEX (wp), ALLOCATABLE :: X2(:,:), Y2(:,:), Z2(:,:), S2(:,:)
   COMPLEX (wp), PARAMETER   :: ZeroC=(0.0_wp,0.0_wp), OneC=(1.0_wp,0.0_wp)
   REAL (wp), PARAMETER      :: Zero=0.0_wp
   COMPLEX (wp)              :: tr
   REAL (wp)                 :: S2_theoretic
   LOGICAL, INTENT (IN)      :: dbg
   INTEGER                   :: i
   INTEGER, PARAMETER        :: StdOut = 6

   ALLOCATE (X2(n,n))
   ALLOCATE (Y2(n,n))
   ALLOCATE (Z2(n,n))
   ALLOCATE (S2(n,n))
   X2=ZeroC
   Y2=ZeroC
   Z2=ZeroC
   S2=ZeroC

   CALL zgemm_('c', 'n', n, n, n, OneC,     &
              moment(1,1:n,1:n), n,         &
              moment(1,1:n,1:n), n, ZeroC,  &
               X2, n )

   CALL zgemm_('c', 'n', n, n, n, OneC,     &
              moment(2,1:n,1:n), n,         &
              moment(2,1:n,1:n), n, ZeroC,  &
               Y2, n )

   CALL zgemm_('c', 'n', n, n, n, OneC,     &
              moment(3,1:n,1:n), n,         &
              moment(3,1:n,1:n), n, ZeroC,  &
               Z2, n )

   ! matrix add:
   ! S2 = X2 + Y2 + Z2
   CALL zaxpy_(n*n, OneC, X2, 1, S2, 1 )
   CALL zaxpy_(n*n, OneC, Y2, 1, S2, 1 )
   CALL zaxpy_(n*n, OneC, Z2, 1, S2, 1 )

   tr=ZeroC
   DO i=1,n
     tr = tr + S2(i,i)
   END DO

   S2_theoretic=Zero
   S2_theoretic=DBLE(n**3-n)/4.0_wp

   IF (dbg) WRITE (StdOut,'(A,ES22.14)') 'check_S_square::  trace of S2=(Sx).Sx+(Sy).Sy+(Sz).Sz = ', ABS(tr)
   IF ( (ABS(tr) - S2_theoretic) > 1.0e-6_wp) THEN
      CALL WarningMessage(1,'check_S_square:: tr(S^2) - S2_theoretic is larger than 1.0e-6. '//&
                            'The input moment looks inacurate')
   ELSE
      WRITE (StdOut,'(A,ES22.14)') 'check_S_square:  The input moment passes the S^2 test.'
   END IF
   DEALLOCATE (X2)
   DEALLOCATE (Y2)
   DEALLOCATE (Z2)
   DEALLOCATE (S2)

   RETURN
END SUBROUTINE check_S_square

SUBROUTINE check_hermiticity_moment (n, moment, dbg)
   IMPLICIT NONE
   INTEGER, PARAMETER        :: wp = kind(0.d0)
   INTEGER, INTENT (IN)      :: n
   COMPLEX (wp), INTENT (IN) :: moment(3,n,n)
   LOGICAL, INTENT (IN)      :: dbg
   COMPLEX (wp), PARAMETER   :: ZeroC=(0.0_wp,0.0_wp)
   COMPLEX (wp)              :: c
   INTEGER                   :: i, j, l
   INTEGER, PARAMETER        :: StdOut = 6
   ! build difference SUM ( M ATRIX(i,j) - DCONJG(MATRIX(j,i)) )
   c=ZeroC
   DO i=1,n
      DO j=1,n
         IF ( i==j ) CYCLE
         DO l=1,3
            c = c + moment(l,i,j) - CONJG( moment(l,j,i) )
         END DO
      END DO
   END DO
   IF (dbg) WRITE (StdOut,'(A,2ES22.14)') 'check_hermiticity_moment::  trace of A(i,j)-DCONJG(A(j,i)) = ', c
   IF (ABS(c) > 1.0e-6_wp) THEN
      CALL WarningMessage(1,'check_hermiticity_moment:: trace of M(1:3,i,j)-DCONJG(A(1:3,j,i)) is larger than 1.0e-6. '//&
                            'The hermiticity of input moment is not quite fulfilled')
   ELSE
      WRITE (StdOut,'(A,ES22.14)') 'check_hermiticity_moment:  The input moment passes the hermiticity test.'
   END IF
   RETURN
END SUBROUTINE check_hermiticity_moment

SUBROUTINE check_hermiticity_matrix (n, matrix, dbg)
   IMPLICIT NONE
   INTEGER, PARAMETER        :: wp = kind(0.d0)
   INTEGER, INTENT (IN)      :: n
   COMPLEX (wp), INTENT (IN) :: matrix(n,n)
   LOGICAL, INTENT (IN)      :: dbg
   COMPLEX (wp)              :: c
   INTEGER                   :: i, j
   INTEGER, PARAMETER        :: StdOut = 6
   COMPLEX (wp), PARAMETER   :: ZeroC = (0.0_wp, 0.0_wp)
   ! build difference ( MATRIX(i,j) - DCONJG(MATRIX(j,i)) )
   c=ZeroC
   DO i=1,n
      DO j=i,n
         IF ( i==j ) CYCLE
         c = c + ( matrix(i,j) - CONJG(matrix(j,i)) )
      END DO
   END DO
   IF (dbg) WRITE (StdOut,'(A,2ES22.14)') 'check_hermiticity_matrix::  trace of A(i,j)-DCONJG(A(j,i)) = ', c
   IF (ABS(c) > 1.0e-6_wp) THEN
      CALL WarningMessage(1,'check_hermiticity_matrix:: trace of A(i,j)-DCONJG(A(j,i)) is larger than 1.0e-6. '//&
                            'The hermiticity of input matrix is not quite fulfilled')
   ELSE
      WRITE (StdOut,'(A,ES22.14)') 'check_hermiticity_matrix:  The input matrix passes the hermiticity test.'
   END IF
   RETURN
END SUBROUTINE check_hermiticity_matrix





!--------------------------------------------------------------------------------------------------!
!           HIGH LEVEL READING SUBROUTINES
!--------------------------------------------------------------------------------------------------!
! read_magnetic_moment
! read_electric_moment
! read_spin_moment
! read_amfi
! read_angmom
! read_edipmom
! read_eigen
! read_hso
! read_eso
! read_esfs
! read_szproj
! read_nss
! read_nstate
!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_magnetic_moment ( DATA_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER         :: wp = kind(0.d0)
   INTEGER, INTENT (IN)       :: DATA_FILE
   INTEGER, INTENT (IN)       :: N
   COMPLEX (wp), INTENT (OUT) :: moment(3,N,N)
   REAL (wp), ALLOCATABLE     :: rr(:,:), ri(:,:)
   INTEGER                    :: i, j
   REAL (wp), EXTERNAL        :: dnrm2_, dznrm2_
   LOGICAL, INTENT (IN)       :: dbg
   INTEGER, PARAMETER         :: StdOut = 6
   COMPLEX (wp), PARAMETER    :: ZeroC = (0.0_wp, 0.0_wp)
   REAL (wp), PARAMETER       :: Zero = 0.0_wp
   LOGICAL, EXTERNAL          :: inquire_key_presence
   REAL (wp), PARAMETER       :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp

   moment=ZeroC
   ALLOCATE (rr(n,n))
   ALLOCATE (ri(n,n))
! projection X
   rr=Zero; ri=Zero;
   IF (inquire_key_presence( DATA_FILE, '$magn_xr')) CALL read_2d_real_array( DATA_FILE, '$magn_xr', n, n, rr, dbg )
   IF (inquire_key_presence( DATA_FILE, '$magn_xi')) CALL read_2d_real_array( DATA_FILE, '$magn_xi', n, n, ri, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_magnetic_moment::  norm of moment_xr=',dnrm2_(n*n,rr,1)
   IF (dbg) WRITE (StdOut,*) 'read_magnetic_moment::  norm of moment_xi=',dnrm2_(n*n,ri,1)
   DO i=1,n
      DO j=1,n
         moment(1,i,j) = CMPLX(rr(i,j),ri(i,j),wp)
      END DO
   END DO
   IF (dbg) CALL check_hermiticity_matrix(n,moment(1,1:n,1:n),dbg)
! projection Y
   rr=Zero; ri=Zero;
   IF (inquire_key_presence( DATA_FILE, '$magn_yr')) CALL read_2d_real_array( DATA_FILE, '$magn_yr', n, n, rr, dbg )
   IF (inquire_key_presence( DATA_FILE, '$magn_yi')) CALL read_2d_real_array( DATA_FILE, '$magn_yi', n, n, ri, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_magnetic_moment::  norm of moment_yr=',dnrm2_(n*n,rr,1)
   IF (dbg) WRITE (StdOut,*) 'read_magnetic_moment::  norm of moment_yi=',dnrm2_(n*n,ri,1)
   DO i=1,n
      DO j=1,n
         moment(2,i,j) = CMPLX(rr(i,j),ri(i,j),wp)
      END DO
   END DO
   IF (dbg) CALL check_hermiticity_matrix(n,moment(2,1:n,1:n),dbg)
! projection Z
   rr=Zero; ri=Zero;
   IF (inquire_key_presence( DATA_FILE, '$magn_zr')) CALL read_2d_real_array( DATA_FILE, '$magn_zr', n, n, rr, dbg )
   IF (inquire_key_presence( DATA_FILE, '$magn_zi')) CALL read_2d_real_array( DATA_FILE, '$magn_zi', n, n, ri, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_magnetic_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
   IF (dbg) WRITE (StdOut,*) 'read_magnetic_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
   DO i=1,n
      DO j=1,n
         moment(3,i,j) = CMPLX(rr(i,j),ri(i,j),wp)
      END DO
   END DO
   IF ( dznrm2_(3*n*n,moment,1) <=MINIMAL_REAL ) &
        CALL WarningMessage(1,'read_magnetic_moment:: the norm of the read moment is zero!')
   IF (dbg) CALL check_hermiticity_matrix(n,moment(3,1:n,1:n),dbg)
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   IF (dbg) THEN
      WRITE(StdOut,*) 'read_magnetic_moment::  ELECTRIC MOMENT at the end of the suboutine'
      WRITE(StdOut,*) 'projection X'
      DO i=1,n
         WRITE(StdOut,'(100(2F10.6,2x))') (moment(1,i,j),j=1,n)
      END DO
      WRITE(StdOut,*) 'projection Y'
      DO i=1,n
         WRITE(StdOut,'(100(2F10.6,2x))') (moment(2,i,j),j=1,n)
      END DO
      WRITE(StdOut,*) 'projection Z'
      DO i=1,n
         WRITE(StdOut,'(100(2F10.6,2x))') (moment(3,i,j),j=1,n)
      END DO
   END IF
   RETURN
END SUBROUTINE read_magnetic_moment

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_electric_moment ( DATA_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER         :: wp = kind(0.d0)
   INTEGER, INTENT (IN)       :: DATA_FILE
   INTEGER, INTENT (IN)       :: N
   COMPLEX (wp), INTENT (OUT) :: moment(3,N,N)
   REAL (wp), ALLOCATABLE     :: rr(:,:), ri(:,:)
   INTEGER                    :: i, j
   REAL (wp), EXTERNAL        :: dnrm2_, dznrm2_
   LOGICAL, INTENT (IN)       :: dbg
   INTEGER, PARAMETER         :: StdOut = 6
   COMPLEX (wp), PARAMETER    :: ZeroC = (0.0_wp, 0.0_wp)
   REAL (wp), PARAMETER       :: Zero = 0.0_wp
   LOGICAL, EXTERNAL          :: inquire_key_presence
   REAL (wp), PARAMETER       :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp

   moment=ZeroC
   ALLOCATE (rr(n,n))
   ALLOCATE (ri(n,n))
! projection X
   rr=Zero; ri=Zero;
   IF (inquire_key_presence( DATA_FILE, '$edipm_xr')) CALL read_2d_real_array( DATA_FILE, '$edipm_xr', n, n, rr, dbg )
   IF (inquire_key_presence( DATA_FILE, '$edipm_xi')) CALL read_2d_real_array( DATA_FILE, '$edipm_xi', n, n, ri, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_electric_moment::  norm of moment_xr=',dnrm2_(n*n,rr,1)
   IF (dbg) WRITE (StdOut,*) 'read_electric_moment::  norm of moment_xi=',dnrm2_(n*n,ri,1)
   DO i=1,n
      DO j=1,n
         moment(1,i,j) = CMPLX(rr(i,j),ri(i,j),wp)
      END DO
   END DO
   IF (dbg) CALL check_hermiticity_matrix(n,moment(1,:,:),dbg)
! projection Y
   rr=Zero; ri=Zero;
   IF (inquire_key_presence( DATA_FILE, '$edipm_yr')) CALL read_2d_real_array( DATA_FILE, '$edipm_yr', n, n, rr, dbg )
   IF (inquire_key_presence( DATA_FILE, '$edipm_yi')) CALL read_2d_real_array( DATA_FILE, '$edipm_yi', n, n, ri, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_electric_moment::  norm of moment_yr=',dnrm2_(n*n,rr,1)
   IF (dbg) WRITE (StdOut,*) 'read_electric_moment::  norm of moment_yi=',dnrm2_(n*n,ri,1)
   DO i=1,n
      DO j=1,n
         moment(2,i,j) = CMPLX(rr(i,j),ri(i,j),wp)
      END DO
   END DO
   IF (dbg) CALL check_hermiticity_matrix(n,moment(2,:,:),dbg)
! projection Z
   rr=Zero; ri=Zero;
   IF (inquire_key_presence( DATA_FILE, '$edipm_zr')) CALL read_2d_real_array( DATA_FILE, '$edipm_zr', n, n, rr, dbg )
   IF (inquire_key_presence( DATA_FILE, '$edipm_zi')) CALL read_2d_real_array( DATA_FILE, '$edipm_zi', n, n, ri, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_electric_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
   IF (dbg) WRITE (StdOut,*) 'read_electric_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
   DO i=1,n
      DO j=1,n
         moment(3,i,j) = CMPLX(rr(i,j),ri(i,j),wp)
      END DO
   END DO
   IF ( dznrm2_(3*n*n,moment,1) <=MINIMAL_REAL) CALL WarningMessage(1,'read_electric_moment:: the norm of the read moment is zero!')
   IF (dbg) CALL check_hermiticity_matrix(n,moment(3,:,:),dbg)
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   IF (dbg) THEN
      WRITE(StdOut,*) 'read_electric_moment::  ELECTRIC MOMENT at the end of the suboutine'
      WRITE(StdOut,*) 'projection X'
      DO i=1,n
         WRITE(StdOut,'(100(2F10.6,2x))') (moment(1,i,j),j=1,n)
      END DO
      WRITE(StdOut,*) 'projection Y'
      DO i=1,n
         WRITE(StdOut,'(100(2F10.6,2x))') (moment(2,i,j),j=1,n)
      END DO
      WRITE(StdOut,*) 'projection Z'
      DO i=1,n
         WRITE(StdOut,'(100(2F10.6,2x))') (moment(3,i,j),j=1,n)
      END DO
   END IF
   RETURN
END SUBROUTINE read_electric_moment

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_spin_moment ( DATA_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER         :: wp = kind(0.d0)
   INTEGER, INTENT (IN)       :: DATA_FILE
   INTEGER, INTENT (IN)       :: N
   COMPLEX (wp), INTENT (OUT) :: moment(3,N,N)
   REAL (wp), ALLOCATABLE     :: rr(:,:), ri(:,:)
   INTEGER                    :: i, j
   REAL (wp), EXTERNAL        :: dnrm2_, dznrm2_
   LOGICAL, INTENT (IN)       :: dbg
   INTEGER, PARAMETER         :: StdOut = 6
   COMPLEX (wp), PARAMETER    :: ZeroC = (0.0_wp, 0.0_wp)
   REAL (wp), PARAMETER       :: Zero = 0.0_wp
   LOGICAL, EXTERNAL          :: inquire_key_presence
   REAL (wp), PARAMETER       :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp

   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment'
   moment=(0.0_wp, 0.0_wp)
   ALLOCATE (rr(n,n))
   ALLOCATE (ri(n,n))
! projection X
   rr=Zero; ri=Zero;
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p2  :spin_xr: ', inquire_key_presence( DATA_FILE, '$spin_xr')
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p2  :spin_xi: ', inquire_key_presence( DATA_FILE, '$spin_xi')
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p2  :spin_yr: ', inquire_key_presence( DATA_FILE, '$spin_yr')
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p2  :spin_yi: ', inquire_key_presence( DATA_FILE, '$spin_yi')
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p2  :spin_zr: ', inquire_key_presence( DATA_FILE, '$spin_zr')
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p2  :spin_zi: ', inquire_key_presence( DATA_FILE, '$spin_zi')
   FLUSH(StdOut)
   IF (inquire_key_presence( DATA_FILE, '$spin_xr')) CALL read_2d_real_array( DATA_FILE, '$spin_xr', n, n, rr, dbg )
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p3'
   FLUSH(StdOut)
   IF (inquire_key_presence( DATA_FILE, '$spin_xi')) CALL read_2d_real_array( DATA_FILE, '$spin_xi', n, n, ri, dbg )
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p4'
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'read_spin_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'read_spin_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
   FLUSH(StdOut)
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p5'
   FLUSH(StdOut)
   DO i=1,n
      DO j=1,n
         moment(1,i,j) = CMPLX( rr(i,j), ri(i,j), wp )
      END DO
   END DO
   IF (dbg) WRITE (StdOut,*) 'ENTER read_spin_moment p6'
   FLUSH(StdOut)
   IF (dbg) CALL check_hermiticity_matrix(n,moment(1,1:n,1:n),dbg)
! projection Y
   rr=Zero; ri=Zero;
   IF (inquire_key_presence( DATA_FILE, '$spin_yr')) CALL read_2d_real_array( DATA_FILE, '$spin_yr', n, n, rr, dbg )
   IF (inquire_key_presence( DATA_FILE, '$spin_yi')) CALL read_2d_real_array( DATA_FILE, '$spin_yi', n, n, ri, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_spin_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
   IF (dbg) WRITE (StdOut,*) 'read_spin_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
   DO i=1,n
      DO j=1,n
         moment(2,i,j) = CMPLX( rr(i,j), ri(i,j), wp )
      END DO
   END DO
   IF (dbg) CALL check_hermiticity_matrix(n,moment(2,1:n,1:n),dbg)
! projection Z
   rr=Zero; ri=Zero;
   IF (inquire_key_presence( DATA_FILE, '$spin_zr')) CALL read_2d_real_array( DATA_FILE, '$spin_zr', n, n, rr, dbg )
   IF (inquire_key_presence( DATA_FILE, '$spin_zi')) CALL read_2d_real_array( DATA_FILE, '$spin_zi', n, n, ri, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_spin_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
   IF (dbg) WRITE (StdOut,*) 'read_spin_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
   DO i=1,n
      DO j=1,n
         moment(3,i,j) = CMPLX( rr(i,j), ri(i,j), wp )
      END DO
   END DO
   IF ( dznrm2_(3*n*n,moment,1) <=MINIMAL_REAL) CALL WarningMessage(1,'read_spin:: the norm of the read moment is zero!')
   IF (dbg) CALL check_hermiticity_matrix(n,moment(3,1:n,1:n),dbg)
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   IF (dbg) CALL check_commutation( n, moment, dbg )

   IF (dbg) THEN
      WRITE(StdOut,*) 'read_spin_moment::  SPIN MOMENT at the end of the suboutine'
      WRITE(StdOut,*) 'projection X'
      DO i=1,n
         WRITE(StdOut,'(100(2F10.6,2x))') (moment(1,i,j),j=1,n)
      END DO
      WRITE(StdOut,*) 'projection Y'
      DO i=1,n
         WRITE(StdOut,'(100(2F10.6,2x))') (moment(2,i,j),j=1,n)
      END DO
      WRITE(StdOut,*) 'projection Z'
      DO i=1,n
         WRITE(StdOut,'(100(2F10.6,2x))') (moment(3,i,j),j=1,n)
      END DO
   END IF
   IF (dbg) WRITE (StdOut,*) 'EXIT read_spin_moment'
   RETURN
END SUBROUTINE read_spin_moment

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_angmom ( DATA_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER      :: wp = kind(0.d0)
   INTEGER, INTENT (IN)    :: DATA_FILE
   INTEGER, INTENT (IN)    :: N
   REAL (wp), INTENT (OUT) :: moment(3,N,N)
   REAL (wp), ALLOCATABLE  :: rr(:,:)
   INTEGER                 :: i, j
   REAL (wp), EXTERNAL     :: dnrm2_
   LOGICAL, INTENT (IN)    :: dbg
   INTEGER, PARAMETER      :: StdOut = 6
   REAL (wp), PARAMETER    :: Zero = 0.0_wp
   LOGICAL, EXTERNAL       :: inquire_key_presence
   REAL (wp), PARAMETER    :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp

   moment=Zero
   ALLOCATE (rr(n,n))
! projection X
   rr=Zero
   IF (inquire_key_presence( DATA_FILE, '$angmom_x')) CALL read_2d_real_array( DATA_FILE, '$angmom_x', n, n, rr, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_angmom::  norm of moment_x=',dnrm2_(n*n,rr,1)
   DO i=1,n
      DO j=1,n
         moment(1,i,j) = rr(i,j)
      END DO
   END DO
! projection Y
   rr=Zero
   IF (inquire_key_presence( DATA_FILE, '$angmom_y')) CALL read_2d_real_array( DATA_FILE, '$angmom_y', n, n, rr, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_angmom::  norm of moment_y=',dnrm2_(n*n,rr,1)
   DO i=1,n
      DO j=1,n
         moment(2,i,j) = rr(i,j)
      END DO
   END DO
! projection Z
   rr=Zero
   IF (inquire_key_presence( DATA_FILE, '$angmom_z')) CALL read_2d_real_array( DATA_FILE, '$angmom_z', n, n, rr, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_angmom::  norm of moment_z=',dnrm2_(n*n,rr,1)
   DO i=1,n
      DO j=1,n
         moment(3,i,j) = rr(i,j)
      END DO
   END DO
   DEALLOCATE (rr)
   IF (dnrm2_(3*n*n,moment,1) <=MINIMAL_REAL) CALL WarningMessage(1,'read_angmom:: the norm of the read moment is zero!')
   RETURN
END SUBROUTINE read_angmom

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_edipmom ( DATA_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER      :: wp = kind(0.d0)
   INTEGER, INTENT (IN)    :: DATA_FILE
   INTEGER, INTENT (IN)    :: N
   REAL (wp), INTENT (OUT) :: moment(3,N,N)
   REAL (wp), ALLOCATABLE  :: rr(:,:)
   INTEGER                 :: i, j
   REAL (wp), EXTERNAL     :: dnrm2_
   LOGICAL, INTENT (IN)    :: dbg
   INTEGER, PARAMETER      :: StdOut = 6
   REAL (wp), PARAMETER    :: Zero = 0.0_wp
   LOGICAL, EXTERNAL       :: inquire_key_presence
   REAL (wp), PARAMETER    :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp

   moment=Zero
   ALLOCATE (rr(n,n))
! projection X
   rr=Zero
   IF (inquire_key_presence( DATA_FILE, '$edmom_x')) CALL read_2d_real_array( DATA_FILE, '$edmom_x', n, n, rr, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_edipmom::  norm of moment_x=',dnrm2_(n*n,rr,1)
   DO i=1,n
      DO j=1,n
         moment(1,i,j) = rr(i,j)
      END DO
   END DO
! projection Y
   rr=Zero
   IF (inquire_key_presence( DATA_FILE, '$edmom_y')) CALL read_2d_real_array( DATA_FILE, '$edmom_y', n, n, rr, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_edipmom::  norm of moment_y=',dnrm2_(n*n,rr,1)
   DO i=1,n
      DO j=1,n
         moment(2,i,j) = rr(i,j)
      END DO
   END DO
! projection Z
   rr=Zero
   IF (inquire_key_presence( DATA_FILE, '$edmom_z')) CALL read_2d_real_array( DATA_FILE, '$edmom_z', n, n, rr, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_edipmom::  norm of moment_z=',dnrm2_(n*n,rr,1)
   DO i=1,n
      DO j=1,n
         moment(3,i,j) = rr(i,j)
      END DO
   END DO
   DEALLOCATE (rr)
   IF (dnrm2_(3*n*n,moment,1) <=MINIMAL_REAL) CALL WarningMessage(1,'read_edipmom:: the norm of the read moment is zero!')
   RETURN
END SUBROUTINE read_edipmom

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_amfi ( DATA_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER      :: wp = kind(0.d0)
   INTEGER, INTENT (IN)    :: DATA_FILE
   INTEGER, INTENT (IN)    :: N
   REAL (wp), INTENT (OUT) :: moment(3,N,N)
   REAL (wp), ALLOCATABLE  :: rr(:,:)
   INTEGER                 :: i, j
   REAL (wp), EXTERNAL     :: dnrm2_
   LOGICAL, INTENT (IN)    :: dbg
   INTEGER, PARAMETER      :: StdOut = 6
   REAL (wp), PARAMETER    :: Zero = 0.0_wp
   LOGICAL, EXTERNAL       :: inquire_key_presence
   REAL (wp), PARAMETER    :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp

   moment=Zero
   ALLOCATE (rr(n,n))
! projection X
   rr=Zero
   IF (inquire_key_presence( DATA_FILE, '$amfi_x')) CALL read_2d_real_array( DATA_FILE, '$amfi_x', n, n, rr, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_amfi::  norm of moment_x=',dnrm2_(n*n,rr,1)
   DO i=1,n
      DO j=1,n
         moment(1,i,j) = rr(i,j)
      END DO
   END DO
! projection Y
   rr=Zero
   IF (inquire_key_presence( DATA_FILE, '$amfi_y')) CALL read_2d_real_array( DATA_FILE, '$amfi_y', n, n, rr, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_amfi::  norm of moment_y=',dnrm2_(n*n,rr,1)
   DO i=1,n
      DO j=1,n
         moment(2,i,j) = rr(i,j)
      END DO
   END DO
! projection Z
   rr=Zero
   IF (inquire_key_presence( DATA_FILE, '$amfi_z')) CALL read_2d_real_array( DATA_FILE, '$amfi_z', n, n, rr, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_amfi::  norm of moment_z=',dnrm2_(n*n,rr,1)
   DO i=1,n
      DO j=1,n
         moment(3,i,j) = rr(i,j)
      END DO
   END DO
   DEALLOCATE (rr)
   IF (dnrm2_(3*n*n,moment,1) <=MINIMAL_REAL) CALL WarningMessage(1,'read_amfi:: the norm of the read moment is zero!')
   RETURN
END SUBROUTINE read_amfi

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_nss ( DATA_FILE, n, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: DATA_FILE
   INTEGER, INTENT (OUT)  :: n
   LOGICAL, INTENT (IN)   :: dbg
   LOGICAL, EXTERNAL      :: inquire_key_presence

   n=0
   IF (inquire_key_presence( DATA_FILE, '$nss')) CALL read_INTEGER_scalar ( DATA_FILE, '$nss', n, dbg )
   IF ( n<=0 ) THEN
      CALL WarningMessage(1,'read_nss:: nss value in DATA_FILE = 0. Is it really the case?')
   ENDIF
   RETURN
END SUBROUTINE read_nss

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_nstate ( DATA_FILE, n, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)  :: DATA_FILE
   INTEGER, INTENT (OUT) :: n
   LOGICAL, INTENT (IN)  :: dbg
   LOGICAL, EXTERNAL     :: inquire_key_presence

   n=0
   IF (inquire_key_presence( DATA_FILE, '$nstate')) CALL read_INTEGER_scalar ( DATA_FILE, '$nstate', n, dbg )
   IF ( n<=0 ) THEN
      CALL WarningMessage(1,'read_nstate:: nstate value in DATA_FILE = 0. Is it really the case?')
   ENDIF
   RETURN
END SUBROUTINE read_nstate

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_nmult ( DATA_FILE, n, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)  :: DATA_FILE
   INTEGER, INTENT (OUT) :: n
   LOGICAL, INTENT (IN)  :: dbg
   LOGICAL, EXTERNAL     :: inquire_key_presence

   n=0
   IF (inquire_key_presence( DATA_FILE, '$nmult')) CALL read_INTEGER_scalar ( DATA_FILE, '$nmult', n, dbg )
   IF ( n<=0 ) THEN
      CALL WarningMessage(1,'read_nmult:: nmult value in DATA_FILE = 0. Is it really the case?')
   ENDIF
   RETURN
END SUBROUTINE read_nmult

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_multiplicity ( DATA_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)  :: DATA_FILE
   INTEGER, INTENT (IN)  :: n
   INTEGER, INTENT (OUT) :: array(n)
   INTEGER, PARAMETER    :: StdOut = 6
   LOGICAL, INTENT (IN)  :: dbg
   LOGICAL, EXTERNAL     :: inquire_key_presence

   array=0
   IF (inquire_key_presence( DATA_FILE, '$multiplicity')) CALL read_1d_INTEGER_array( DATA_FILE, '$multiplicity', n, array, dbg )
   IF ( SUM(ABS(array(1:n)))==0 ) THEN
      CALL WarningMessage(1,'read_multiplicity:: it seems that all the multiplicities in DATA_FILE are 0. '// &
                            'Is it really the case?')
      WRITE (StdOut, *) 'read_multiplicity:: SUM(Sz) = ',SUM(ABS(array(1:n)))
   ENDIF
   IF ( SUM(array(1:n))==0 ) THEN
      CALL WarningMessage(1,'read_multiplicity:: it seems that all the multiplicities in DATA_FILE are 0. '// &
                            'Is it really the case?')
      WRITE (StdOut, *) 'read_szproj:: SUM(Sz) = ',SUM(array(1:n))
   ENDIF
   RETURN
END SUBROUTINE read_multiplicity

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_imult ( DATA_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)  :: DATA_FILE
   INTEGER, INTENT (IN)  :: n
   INTEGER, INTENT (OUT) :: array(n)
   INTEGER, PARAMETER    :: StdOut = 6
   LOGICAL, EXTERNAL     :: inquire_key_presence
   LOGICAL, INTENT (IN)  :: dbg

   array=0
   IF (inquire_key_presence( DATA_FILE, '$imult')) CALL read_1d_INTEGER_array( DATA_FILE, '$imult', n, array, dbg )
   IF ( SUM(array(1:n))==0 ) THEN
      CALL WarningMessage(1,'read_imult:: it seems that all the multiplicities in DATA_FILE are 0. '// &
                            'Is it really the case?')
      WRITE (StdOut, *) 'read_imult:: SUM(mult()) = ',SUM(array(1:n))
   ENDIF
   RETURN
END SUBROUTINE read_imult

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_format ( DATA_FILE, n, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)  :: DATA_FILE
   INTEGER, INTENT (OUT) :: n
   INTEGER, PARAMETER    :: StdOut = 6
   LOGICAL, EXTERNAL     :: inquire_key_presence
   LOGICAL, INTENT (IN)  :: dbg
   n=0
   IF (inquire_key_presence( DATA_FILE, '$format')) CALL read_INTEGER_scalar ( DATA_FILE, '$format', n, dbg )
   IF ( n<=0 ) THEN
      CALL WarningMessage(2,'read_format:: FORMAT value in DATA_FILE = 0.'// &
                            ' The FORMAT must be equal or larger than 2020. Please check.' )
   ENDIF
   RETURN
END SUBROUTINE read_format

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_nroot ( DATA_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)  :: DATA_FILE
   INTEGER, INTENT (IN)  :: n
   INTEGER, INTENT (OUT) :: array(n)
   INTEGER, PARAMETER    :: StdOut = 6
   LOGICAL, EXTERNAL     :: inquire_key_presence
   LOGICAL, INTENT (IN)  :: dbg

   array=0
   IF (inquire_key_presence( DATA_FILE, '$nroot')) CALL read_1d_INTEGER_array( DATA_FILE, '$nroot', n, array, dbg )
   IF ( SUM(array(1:n))==0 ) THEN
      CALL WarningMessage(1,'read_nroot:: it seems that the number of roots included in spin-orbit '// &
                            'interaction in DATA_FILE are 0.  Is it really the case?')
      WRITE (StdOut, *) 'read_szproj:: SUM(array()) = ',SUM(array(1:n))
   ENDIF
   RETURN
END SUBROUTINE read_nroot

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_szproj ( DATA_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)  :: DATA_FILE
   INTEGER, INTENT (IN)  :: n
   INTEGER, INTENT (OUT) :: array(n)
   INTEGER, PARAMETER    :: StdOut = 6
   LOGICAL, EXTERNAL     :: inquire_key_presence
   LOGICAL, INTENT (IN)  :: dbg

   array=0
   IF (inquire_key_presence( DATA_FILE, '$szproj')) CALL read_1d_INTEGER_array( DATA_FILE, '$szproj', n, array, dbg )
   IF ( SUM(ABS(array(1:n))) == 0 ) THEN
      CALL WarningMessage(1,'read_szproj:: it seems that SUM(ABS(Sz)) in DATA_FILE is 0. '// &
                            'Is it really the case?')
      WRITE (StdOut, *) 'read_szproj:: SUM(ABS(Sz)) = ',SUM(ABS(array(1:n)))
   ENDIF
   IF ( SUM(array(1:n)) /= 0 ) THEN
      CALL WarningMessage(1,'read_szproj:: it seems that SUM(Sz) in DATA_FILE is not 0. '// &
                            'Is it really the case?')
      WRITE (StdOut, *) 'read_szproj:: SUM(Sz) = ',SUM(array(1:n))
   ENDIF
   RETURN
END SUBROUTINE read_szproj

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_eso ( DATA_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER      :: wp = kind(0.d0)
   INTEGER, INTENT (IN)    :: DATA_FILE
   INTEGER, INTENT (IN)    :: n
   REAL (wp), INTENT (OUT) :: array(n)
   REAL (wp), EXTERNAL     :: dnrm2_
   LOGICAL, INTENT (IN)    :: dbg
   REAL (wp), PARAMETER    :: Zero = 0.0_wp
   INTEGER, PARAMETER      :: StdOut = 6
   LOGICAL, EXTERNAL       :: inquire_key_presence
   REAL (wp), PARAMETER    :: MINIMAL_REAL = TINY(0.0_wp)*10.0_wp

   array=Zero
   IF (inquire_key_presence( DATA_FILE, '$eso')) CALL read_1d_real_array( DATA_FILE, '$eso', n, array, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_eso::  norm of eso=',dnrm2_(n,array,1)
   IF ( dnrm2_(n,array,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'read_eso:: it seems that the norm of ESO array in DATA_FILE is 0. '// &
                            'Is it really the case?')
      WRITE (StdOut, *) 'read_eso:: dnrm2_(eso) = ',dnrm2_(n,array,1)
   ENDIF
   RETURN
END SUBROUTINE read_eso

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_esfs ( DATA_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER      :: wp = kind(0.d0)
   INTEGER, INTENT (IN)    :: DATA_FILE
   INTEGER, INTENT (IN)    :: n
   REAL (wp), INTENT (OUT) :: array(n)
   REAL (wp), EXTERNAL     :: dnrm2_
   LOGICAL, INTENT (IN)    :: dbg
   REAL (wp), PARAMETER    :: Zero = 0.0_wp
   INTEGER, PARAMETER      :: StdOut = 6
   LOGICAL, EXTERNAL       :: inquire_key_presence
   REAL (wp), PARAMETER    :: MINIMAL_REAL = TINY(0.0_wp)*10.0_wp

   array=Zero
   IF (inquire_key_presence( DATA_FILE, '$esfs')) CALL read_1d_real_array( DATA_FILE, '$esfs', n, array, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_esfs::  norm of esfs=',dnrm2_(n,array,1)
   IF ( dnrm2_(n,array,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'read_esfs:: it seems that the norm of ESFS in DATA_FILE is 0. '// &
                            'Is it really the case?')
      WRITE (StdOut, *) 'read_esfs:: dnrm2_(esfs) = ',dnrm2_(n,array,1)
   ENDIF
   RETURN
END SUBROUTINE read_esfs

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_hso ( DATA_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER         :: wp = kind(0.d0)
   INTEGER, INTENT (IN)       :: DATA_FILE
   INTEGER, INTENT (IN)       :: n
   COMPLEX (wp), INTENT (OUT) :: array(n)
   REAL (wp), EXTERNAL        :: dznrm2_
   LOGICAL, INTENT (IN)       :: dbg
   COMPLEX (wp), PARAMETER    :: ZeroC = (0.0_wp,0.0_wp)
   INTEGER, PARAMETER         :: StdOut = 6
   LOGICAL, EXTERNAL          :: inquire_key_presence
   REAL (wp), PARAMETER       :: MINIMAL_REAL = TINY(0.0_wp)*10.0_wp

   array=ZeroC
   IF (inquire_key_presence( DATA_FILE, '$hso')) CALL read_complex_matrix( DATA_FILE, '$hso', n, array, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_hso::  norm of hso=',dznrm2_(n*n,array,1)
   IF ( dznrm2_(n*n,array,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'read_hso:: it seems that norm of HSO in DATA_FILE is 0. '// &
                            'Is it really the case?')
      WRITE (StdOut, *) 'read_hso:: dznrm2_(hso) = ',dznrm2_(n*n,array,1)
   END IF
   RETURN
END SUBROUTINE read_hso

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_eigen ( DATA_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER         :: wp = kind(0.d0)
   INTEGER, INTENT (IN)       :: DATA_FILE
   INTEGER, INTENT (IN)       :: n
   COMPLEX (wp), INTENT (OUT) :: array(n)
   REAL (wp), EXTERNAL        :: dznrm2_
   LOGICAL, INTENT (IN)       :: dbg
   COMPLEX (wp), PARAMETER    :: ZeroC = (0.0_wp,0.0_wp)
   INTEGER, PARAMETER         :: StdOut = 6
   LOGICAL, EXTERNAL          :: inquire_key_presence
   REAL (wp), PARAMETER       :: MINIMAL_REAL = TINY(0.0_wp)*10.0_wp

   array=ZeroC
   IF (inquire_key_presence( DATA_FILE, '$eigen')) CALL read_complex_matrix( DATA_FILE, '$eigen', n, array, dbg )
   IF (dbg) WRITE (StdOut,*) 'read_eigen::  norm of eigenv=',dznrm2_(n*n,array,1)
   IF ( dznrm2_(n*n,array,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'read_eigen:: it seems that norm of EIGENV in DATA_FILE is 0. '// &
                            'Is it really the case?')
      WRITE (StdOut, *) 'read_eigen:: dznrm2_(array) = ',dznrm2_(n*n,array,1)
   END IF
   RETURN
END SUBROUTINE read_eigen

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_gtens ( DATA_FILE, nmult, gtens, axes, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER      :: wp = kind(0.d0)
   INTEGER, INTENT (IN)    :: DATA_FILE
   INTEGER, INTENT (IN)    :: nmult
   REAL (wp), INTENT (OUT) :: gtens(nmult,3)
   REAL (wp), INTENT (OUT) ::  axes(nmult,3,3)
   LOGICAL, INTENT (IN)    :: dbg
   gtens=0.0_wp ; axes=0.0_wp ;
   CALL read_2d_real_array( DATA_FILE, '$gtens_main', nmult, 3, gtens, dbg )
   CALL read_3d_real_array( DATA_FILE, '$gtens_axes', nmult, 3, 3, axes, dbg )
   RETURN
END SUBROUTINE read_gtens

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_stev_cfp ( DATA_FILE, s, n, cfp, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER      :: wp = kind(0.d0)
   INTEGER, INTENT (IN)    :: DATA_FILE
   INTEGER, INTENT (IN)    :: n   ! 2J+1, or 2L+1, i.e. the dimension of the J or L multiplet
   REAL (wp), INTENT (OUT) :: cfp(n-1, -(n-1):(n-1) )
   CHARACTER (LEN=1)       :: s
   INTEGER                 :: k, q, i, ik, iq, ierr
   LOGICAL, INTENT (IN)    :: dbg
   REAL (wp), PARAMETER    :: Zero=0.0_wp
   INTEGER, PARAMETER      :: StdOut = 6
   CHARACTER (LEN=500)     :: line

   ierr=0
   IF ( (n<=0) ) THEN
      CALL WarningMessage(1,'read_stev_cfp_'//trim(s)//':: nothing to read. Array size = 0.')
      RETURN
   END IF
   CFP=Zero

   REWIND ( DATA_FILE )
   CALL file_advance_to_string( DATA_FILE, '$stev_cfp_'//trim(s), line, ierr, dbg )

   READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) i
   IF ( i /= n ) CALL WarningMessage(2,'read_stev_cfp_'//trim(s)//':: size of the multiplet is not the same i/=n')

   ! if key is found, THEN read the data
   IF ( ierr == 0 ) THEN
      DO k=2,n-1,2
         DO q=-k,k,2
            ik=99999;
            iq=9999999;
            READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) ik,iq, cfp(ik,iq)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'read_stev_cfp_'//trim(s)//':: Something went wrong reading the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'read_stev_cfp_'//trim(s)//'::  k, q =',k, q
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   END IF
   RETURN
END SUBROUTINE read_stev_cfp

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_susc ( DATA_FILE, s, n, field, zj, t, x, x_tens, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: DATA_FILE
   INTEGER, INTENT (INOUT)        :: n                  ! number of temperature points
   REAL (wp), INTENT (OUT)        :: zj                 ! intermolecular interaction
   REAL (wp), INTENT (OUT)        :: field              ! applied field
   REAL (wp), INTENT (OUT)        :: t(n)               ! temperature points
   REAL (wp), INTENT (OUT)        :: x(n)               ! susceptibility X
   REAL (wp), INTENT (OUT)        :: x_tens(n,3,3)      ! susceptibility tensor, X_tens
   CHARACTER (LEN=*), INTENT (IN) :: s
   INTEGER                        :: i, j, k
   REAL (wp), EXTERNAL            :: dnrm2_
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   INTEGER                        :: ierr
   REAL (wp), PARAMETER           :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp

   t=0.0_wp ; x=0.0_wp ; x_tens=0.0_wp
   ! s takes the values:
   ! 'x'
   ! 'x_field'
   ! 'x_minus_one'
   ! 'x_field_minus_one'
   ! 'xt'
   ! 'xt_field'
   ! 'xt_minus_one'
   ! 'xt_field_minus_one'
   ! 'x_zj'
   ! 'x_field_zj'
   ! 'x_minus_one_zj'
   ! 'x_field_minus_one_zj'
   ! 'xt_zj'
   ! 'xt_field_zj'
   ! 'xt_minus_one_zj'
   ! 'xt_field_minus_one_zj'
!   IF ( (trim(s).ne.'x')                      .OR.   &
!       (trim(s).ne.'x_field')                .OR.   &
!       (trim(s).ne.'x_minus_one')            .OR.   &
!       (trim(s).ne.'x_field_minus_one')      .OR.   &
!       (trim(s).ne.'xt')                     .OR.   &
!       (trim(s).ne.'xt_field')               .OR.   &
!       (trim(s).ne.'xt_minus_one')           .OR.   &
!       (trim(s).ne.'xt_field_minus_one')     .OR.   &
!       (trim(s).ne.'x_zj')                   .OR.   &
!       (trim(s).ne.'x_field_zj')             .OR.   &
!       (trim(s).ne.'x_minus_one_zj')         .OR.   &
!       (trim(s).ne.'x_field_minus_one_zj')   .OR.   &
!       (trim(s).ne.'xt_zj')                  .OR.   &
!       (trim(s).ne.'xt_field_zj')            .OR.   &
!       (trim(s).ne.'xt_minus_one_zj')        .OR.   &
!       (trim(s).ne.'xt_field_minus_one_zj') ) THEN
!
!       CALL WarningMessage(1,'read_x '//trim(s)//' :: the parameter s='//trim(s)//'is not understood. RETURN without'// &
!                             ' read of X data.')
!       RETURN
!   END IF

   ierr=0
   IF ( (n<=0) ) THEN
      CALL WarningMessage(1,'read_x '//trim(s)//' :: nothing to read. Array size = 0.')
      RETURN
   END IF

   REWIND ( DATA_FILE )
   CALL file_advance_to_string( DATA_FILE, '$susceptibility_'//trim(s), line, ierr, dbg )

   ! if key is found, THEN read the data
   IF ( ierr == 0 ) THEN
      READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) n
      READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) zj, field
      IF (ierr /= 0) THEN
         CALL WarningMessage(2,'read_x '//trim(s)//' :: Something went wrong reading the zJ and field values.')
      END IF
      READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) (T(i),i=1,n)
      IF (dnrm2_(n,T,1)<MINIMAL_REAL) CALL WarningMessage(1,'read_x '//trim(s)//' :: all array T elements are zero = 0.')
      IF (ierr /= 0) THEN
         CALL WarningMessage(2,'read_x '//trim(s)//' :: Something went wrong reading the T array.')
      END IF
      READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) (X(i),i=1,n)
      IF (dnrm2_(n,X,1)<MINIMAL_REAL) CALL WarningMessage(1,'read_x '//trim(s)//' :: all array X elements are zero = 0.')
      IF (ierr /= 0) THEN
         CALL WarningMessage(2,'read_x '//trim(s)//' :: Something went wrong reading the X array.')
      END IF
      DO j=1,3
         DO k=1,3
            READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) ( X_tens(i,j,k), i=1,n )
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'read_x '//trim(s)//' :: Something went wrong reading the X_tens array.')
            END IF
         END DO
      END DO
      IF (dnrm2_(n*3*3,X_tens,1)<MINIMAL_REAL) CALL WarningMessage(1,'read_x '//trim(s)//' :: all array X_tens elements are zero.')
      IF (dbg) FLUSH (StdOut)
   ELSE
      WRITE (StdOut,*) 'keyword $susceptibility_'//trim(s)//' was not found in DATA_FILE'
   END IF
   RETURN
END SUBROUTINE read_susc

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_magn (DATA_FILE, nt, nh, nd, nss, zj, t, h, x, y, z, w, m, mav, energy, dbg)
   IMPLICIT NONE
   INTEGER, PARAMETER      :: wp = kind(0.d0)
   INTEGER, INTENT (IN)    :: DATA_FILE
   INTEGER, INTENT (IN)    :: nt                         ! number of temperature points
   INTEGER, INTENT (IN)    :: nh                         ! number of field points
   INTEGER, INTENT (IN)    :: nd                         ! number of directions of aplied field
   INTEGER, INTENT (IN)    :: nss                        ! number of spin-orbit states
   REAL (wp), INTENT (OUT) :: zj                         ! inter-molecular parameter zJ
   REAL (wp), INTENT (OUT) :: t(nt)                      ! temperature points
   REAL (wp), INTENT (OUT) :: h(nh)                      ! field points
   REAL (wp), INTENT (OUT) :: x(nd), y(nd), z(nd), w(nd) ! Lebedev grid directions and weight
   REAL (wp), INTENT (OUT) :: m(nd, 3, nt, nh)           ! magnetisation vector
   REAL (wp), INTENT (OUT) :: mav(nt, nh)                ! average magnetisation vector
   REAL (wp), INTENT (OUT) :: energy(nd, nh, nss)        ! Zeeman energy states
   INTEGER                 :: id, ih, it, i, iss, l, ierr
   LOGICAL, INTENT (IN)    :: dbg
   CHARACTER (LEN=500)     :: line
   INTEGER, PARAMETER      :: StdOut = 6
   REAL (wp), PARAMETER    :: Zero = 0.0_wp

   ierr=0
   IF ( (nt<=0) .OR. (nh<=0) .OR. (nd<=0) .OR. (nss<=0) ) THEN
      CALL WarningMessage(1,'read_magn :: nothing to read. Array size = 0.')
      RETURN
   END IF

   REWIND ( DATA_FILE )
   CALL file_advance_to_string( DATA_FILE, '$magnetisation', line, ierr, dbg )

   READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) it, ih, id, iss
   IF (it/=nt) CALL WarningMessage(1,'read_magn :: nt read from DATA_FILE is not the same as the parameter used to CALL '//&
                                    'this function.')
   IF (ih/=nh) CALL WarningMessage(1,'read_magn :: nh read from DATA_FILE is not the same as the parameter used to CALL '//&
                                    'this function.')
   IF (id/=nd) CALL WarningMessage(1,'read_magn :: nd read from DATA_FILE is not the same as the parameter used to CALL '//&
                                    'this function.')
   IF (iss/=nss) CALL WarningMessage(1,'read_magn :: nss read from DATA_FILE is not the same as the parameter used to CALL '//&
                                    'this function.')
   zJ=Zero ; T=Zero ; H=Zero ; X=Zero ; Y=Zero ; Z=Zero ; W=Zero ;
   energy=Zero ; m=Zero ; mav=Zero ;

   READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) zJ
   READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) (T(i),i=1,nt)
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_magn :: Something went wrong reading the T array.')
   END IF
   ! Magnetic field points
   READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) (H(i),i=1,nh)
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_magn :: Something went wrong reading the H array.')
   END IF
   ! Lebedev grid data (X, Y, Z, W)
   READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) ( X(i), i=1,nd )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_magn :: Something went wrong reading the Lebedev grid X rray.')
   END IF
   READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) ( Y(i), i=1,nd )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_magn :: Something went wrong reading the Lebedev grid Y array.')
   END IF
   READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) ( Z(i), i=1,nd )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_magn :: Something went wrong reading the Lebedev grid Z array.')
   END IF
   READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) ( W(i), i=1,nd )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_magn :: Something went wrong reading the Lebedev grid W array.')
   END IF
   ! Zeeman energy
   DO id=1,nd
      DO ih=1,nh
         READ ( DATA_FILE, FMT=*, IOSTAT=ierr )  (energy(ih,id,iss),iss=1,nss)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'read_magn :: Something went wrong reading the Zeeman energy data.')
         END IF
      END DO
   END DO
   ! magnetisation vector data
   DO id=1,nd
      DO l=1,3
         DO ih=1,nh
            READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) (m(id,l,ih,it),it=1,nt)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'read_magn :: Something went wrong reading the M data.')
            END IF
         END DO
      END DO
   END DO
   DO ih=1,nh
      READ ( DATA_FILE, FMT=*, IOSTAT=ierr ) (mav(ih,it),it=1,nt)
      IF (ierr /= 0) THEN
         CALL WarningMessage(2,'read_magn :: Something went wrong reading the average M data.')
      END IF
   END DO
   IF (dbg) FLUSH (StdOut)
   RETURN
END SUBROUTINE read_magn











!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_complex_matrix ( LU, key, n, matrix, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   INTEGER, INTENT (IN)           :: N
   CHARACTER (LEN=*), INTENT (IN) :: key
   COMPLEX (wp), INTENT (OUT)     :: matrix(N,N)
   REAL (wp), ALLOCATABLE         :: rr(:,:), ri(:,:)
   INTEGER                        :: i, j
   LOGICAL, INTENT (IN)           :: dbg
   REAL (wp), PARAMETER           :: Zero=0.0_wp
   COMPLEX (wp), PARAMETER        :: ZeroC=(0.0_wp,0.0_wp)

   matrix=ZeroC
   ALLOCATE (rr(n,n))
   ALLOCATE (ri(n,n))
   rr=Zero ; ri=Zero ;

   CALL read_2d_real_array( LU, key//'r' , n, n, rr, dbg )
   CALL read_2d_real_array( LU, key//'i' , n, n, ri, dbg )
   DO i=1,n
      DO j=1,n
         matrix(i,j) = CMPLX( rr(i,j), ri(i,j), wp)
      END DO
   END DO
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   RETURN
END SUBROUTINE read_complex_matrix

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_complex_matrix ( LU, key, n, matrix, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   INTEGER, INTENT (IN)           :: N
   CHARACTER (LEN=*), INTENT (IN) :: key
   COMPLEX (wp), INTENT (IN)      :: matrix(N,N)
   REAL (wp), ALLOCATABLE         :: rr(:,:), ri(:,:)
   INTEGER                        :: i, j
   LOGICAL, INTENT (IN)           :: dbg

   ALLOCATE (rr(n,n))
   ALLOCATE (ri(n,n))
   rr=0.0_wp ; ri=0.0_wp ;
   DO i=1,n
      DO j=1,n
         rr(i,j)= DBLE(matrix(i,j))
         ri(i,j)=AIMAG(matrix(i,j))
      END DO
   END DO
   CALL write_2d_real_array( LU, key//'r', n, n, rr, dbg )
   CALL write_2d_real_array( LU, key//'i', n, n, ri, dbg )
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   RETURN
END SUBROUTINE write_complex_matrix

!--------------------------------------------------------------------------------------------------!















!--------------------------------------------------------------------------------------------------!
!           HIGH LEVEL WRITING SUBROUTINES
!--------------------------------------------------------------------------------------------------!
!
! write_magnetic_moment
! write_electric_moment
! write_amfi
! write_angmom
! write_edipmom
! write_eigenv
! write_hso
! write_eso
! write_esfs
! write_nss
! write_nmult
! write_nroot
! write_iroot
! write_nstate
! write_szproj
! write_multiplicty
! write_gtens
! write_stev_cfp
! write_susc
! write_magn
!
!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_magnetic_moment ( ANISO_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER        :: wp = kind(0.d0)
   INTEGER, INTENT (IN)      :: ANISO_FILE
   INTEGER, INTENT (IN)      :: N
   COMPLEX (wp), INTENT (IN) :: moment(3,N,N)
   REAL (wp), ALLOCATABLE    :: rr(:,:), ri(:,:)
   INTEGER                   :: i, j
   REAL (wp), PARAMETER      :: Zero=0.0_wp
   LOGICAL, INTENT (IN)      :: dbg

   ALLOCATE (rr(n,n))
   ALLOCATE (ri(n,n))
! projection X
   rr=Zero; ri=Zero;
   DO i=1,n
      DO j=1,n
         rr(i,j)= DBLE(moment(1,i,j))
         ri(i,j)=AIMAG(moment(1,i,j))
      END DO
   END DO
   CALL write_2d_real_array( ANISO_FILE, '$magn_xr', n, n, rr, dbg )
   CALL write_2d_real_array( ANISO_FILE, '$magn_xi', n, n, ri, dbg )
! projection Y
   rr=Zero; ri=Zero;
   DO i=1,n
      DO j=1,n
         rr(i,j)= DBLE(moment(2,i,j))
         ri(i,j)=AIMAG(moment(2,i,j))
      END DO
   END DO
   CALL write_2d_real_array( ANISO_FILE, '$magn_yr', n, n, rr, dbg )
   CALL write_2d_real_array( ANISO_FILE, '$magn_yi', n, n, ri, dbg )
! projection Z
   rr=Zero; ri=Zero;
   DO i=1,n
      DO j=1,n
         rr(i,j)= DBLE(moment(3,i,j))
         ri(i,j)=AIMAG(moment(3,i,j))
      END DO
   END DO
   CALL write_2d_real_array( ANISO_FILE, '$magn_zr', n, n, rr, dbg )
   CALL write_2d_real_array( ANISO_FILE, '$magn_zi', n, n, ri, dbg )
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   RETURN
END SUBROUTINE write_magnetic_moment

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_electric_moment ( ANISO_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER        :: wp = kind(0.d0)
   INTEGER, INTENT (IN)      :: ANISO_FILE
   INTEGER, INTENT (IN)      :: N
   COMPLEX (wp), INTENT (IN) :: moment(3,N,N)
   REAL (wp), ALLOCATABLE    :: rr(:,:), ri(:,:)
   INTEGER                   :: i, j
   REAL (wp), PARAMETER      :: Zero=0.0_wp
   LOGICAL, INTENT (IN)      :: dbg

   ALLOCATE (rr(n,n))
   ALLOCATE (ri(n,n))
! projection X
   rr=Zero; ri=Zero;
   DO i=1,n
      DO j=1,n
         rr(i,j)= DBLE(moment(1,i,j))
         ri(i,j)=AIMAG(moment(1,i,j))
      END DO
   END DO
   CALL write_2d_real_array( ANISO_FILE, '$edipm_xr', n, n, rr, dbg )
   CALL write_2d_real_array( ANISO_FILE, '$edipm_xi', n, n, ri, dbg )
! projection Y
   rr=Zero; ri=Zero;
   DO i=1,n
      DO j=1,n
         rr(i,j)= DBLE(moment(2,i,j))
         ri(i,j)=AIMAG(moment(2,i,j))
      END DO
   END DO
   CALL write_2d_real_array( ANISO_FILE, '$edipm_yr', n, n, rr, dbg )
   CALL write_2d_real_array( ANISO_FILE, '$edipm_yi', n, n, ri, dbg )
! projection Z
   rr=Zero; ri=Zero;
   DO i=1,n
      DO j=1,n
         rr(i,j)=DBLE(moment(3,i,j))
         ri(i,j)=AIMAG(moment(3,i,j))
      END DO
   END DO
   CALL write_2d_real_array( ANISO_FILE, '$edipm_zr', n, n, rr, dbg )
   CALL write_2d_real_array( ANISO_FILE, '$edipm_zi', n, n, ri, dbg )
   DEALLOCATE (rr)
   DEALLOCATE (ri)

   RETURN
END SUBROUTINE write_electric_moment

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_spin_moment ( ANISO_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER         :: wp = kind(0.d0)
   INTEGER, INTENT (IN)       :: ANISO_FILE
   INTEGER, INTENT (IN)       :: N
   COMPLEX (wp), INTENT (IN)  :: moment(3,N,N)
   REAL (wp), ALLOCATABLE     :: rr(:,:), ri(:,:)
   INTEGER                    :: i, j
   REAL (wp), PARAMETER       :: Zero=0.0_wp
   LOGICAL, INTENT (IN)       :: dbg

   ALLOCATE (rr(n,n))
   ALLOCATE (ri(n,n))
! projection X
   rr=Zero; ri=Zero;
   DO i=1,n
      DO j=1,n
         rr(i,j)= DBLE(moment(1,i,j))
         ri(i,j)=AIMAG(moment(1,i,j))
      END DO
   END DO
   CALL write_2d_real_array( ANISO_FILE, '$spin_xr', n, n, rr, dbg )
   CALL write_2d_real_array( ANISO_FILE, '$spin_xi', n, n, ri, dbg )
! projection Y
   rr=Zero; ri=Zero;
   DO i=1,n
      DO j=1,n
         rr(i,j)= DBLE(moment(2,i,j))
         ri(i,j)=AIMAG(moment(2,i,j))
      END DO
   END DO
   CALL write_2d_real_array( ANISO_FILE, '$spin_yr', n, n, rr, dbg )
   CALL write_2d_real_array( ANISO_FILE, '$spin_yi', n, n, ri, dbg )
! projection Z
   rr=Zero; ri=Zero;
   DO i=1,n
      DO j=1,n
         rr(i,j)= DBLE(moment(3,i,j))
         ri(i,j)=AIMAG(moment(3,i,j))
      END DO
   END DO
   CALL write_2d_real_array( ANISO_FILE, '$spin_zr', n, n, rr, dbg )
   CALL write_2d_real_array( ANISO_FILE, '$spin_zi', n, n, ri, dbg )
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   RETURN
END SUBROUTINE write_spin_moment

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_angmom ( ANISO_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER       :: wp = kind(0.d0)
   INTEGER, INTENT (IN)     :: ANISO_FILE
   INTEGER, INTENT (IN)     :: N
   REAL (wp), INTENT (IN)   :: moment(3,N,N)
   LOGICAL, INTENT (IN)     :: dbg

   CALL write_2d_real_array( ANISO_FILE, '$angmom_x', n, n, moment(1,:,:), dbg )
   CALL write_2d_real_array( ANISO_FILE, '$angmom_y', n, n, moment(2,:,:), dbg )
   CALL write_2d_real_array( ANISO_FILE, '$angmom_z', n, n, moment(3,:,:), dbg )
   RETURN
END SUBROUTINE write_angmom

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_edipmom ( ANISO_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER       :: wp = kind(0.d0)
   INTEGER, INTENT (IN)     :: ANISO_FILE
   INTEGER, INTENT (IN)     :: N
   REAL (wp), INTENT (IN)   :: moment(3,N,N)
   LOGICAL, INTENT (IN)     :: dbg

   CALL write_2d_real_array( ANISO_FILE, '$edmom_x',n,n,moment(1,:,:), dbg )
   CALL write_2d_real_array( ANISO_FILE, '$edmom_y',n,n,moment(2,:,:), dbg )
   CALL write_2d_real_array( ANISO_FILE, '$edmom_z',n,n,moment(3,:,:), dbg )
   RETURN
END SUBROUTINE write_edipmom

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_amfi ( ANISO_FILE, n, moment, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER     :: wp = kind(0.d0)
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: N
   REAL (wp), INTENT (IN) :: moment(3,N,N)
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_2d_real_array( ANISO_FILE, '$amfi_x', n, n, moment(1,:,:), dbg )
   CALL write_2d_real_array( ANISO_FILE, '$amfi_y', n, n, moment(2,:,:), dbg )
   CALL write_2d_real_array( ANISO_FILE, '$amfi_z', n, n, moment(3,:,:), dbg )
   RETURN
END SUBROUTINE write_amfi

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_format( ANISO_FILE, n, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_INTEGER_scalar ( ANISO_FILE, '$format', n, dbg )
   RETURN
END SUBROUTINE write_format

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_nss ( ANISO_FILE, n, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_INTEGER_scalar ( ANISO_FILE, '$nss', n, dbg )
   RETURN
END SUBROUTINE write_nss

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_nstate ( ANISO_FILE, n, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_INTEGER_scalar ( ANISO_FILE, '$nstate', n, dbg )
   RETURN
END SUBROUTINE write_nstate

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_nmult (ANISO_FILE, n, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_INTEGER_scalar ( ANISO_FILE, '$nmult', n, dbg )
   RETURN
END SUBROUTINE write_nmult

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_multiplicity ( ANISO_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   INTEGER, INTENT (IN)   :: array(n)
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_1d_INTEGER_array( ANISO_FILE, '$multiplicity', n, array, dbg )
   RETURN
END SUBROUTINE write_multiplicity

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_imult ( ANISO_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   INTEGER, INTENT (IN)   :: array(n)
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_1d_INTEGER_array( ANISO_FILE, '$imult', n, array, dbg )
   RETURN
END SUBROUTINE write_imult

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_nroot ( ANISO_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   INTEGER, INTENT (IN)   :: array(n)
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_1d_INTEGER_array( ANISO_FILE, '$nroot', n, array, dbg )
   RETURN
END SUBROUTINE write_nroot
!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_szproj ( ANISO_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   INTEGER, INTENT (IN)   :: array(n)
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_1d_INTEGER_array( ANISO_FILE, '$szproj', n, array, dbg )
   RETURN
END SUBROUTINE write_szproj

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_eso ( ANISO_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER     :: wp = kind(0.d0)
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   REAL (wp), INTENT (IN) :: array(n)
   LOGICAL, INTENT (IN)   :: dbg
   INTEGER, PARAMETER     :: StdOut = 6

   IF (dbg) WRITE (StdOut,*) 'write_eso: '
   CALL write_1d_real_array( ANISO_FILE, '$eso', n, array, dbg )
   RETURN
END SUBROUTINE write_eso

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_esfs ( ANISO_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER     :: wp = kind(0.d0)
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n
   REAL (wp), INTENT (IN) :: array(n)
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_1d_real_array( ANISO_FILE, '$esfs', n, array, dbg )
   RETURN
END SUBROUTINE write_esfs

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_hso ( ANISO_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER        :: wp = kind(0.d0)
   INTEGER, INTENT (IN)      :: ANISO_FILE
   INTEGER, INTENT (IN)      :: n
   COMPLEX (wp), INTENT (IN) :: array(n)
   LOGICAL, INTENT (IN)      :: dbg

   CALL write_complex_matrix( ANISO_FILE, '$hso', n, array, dbg )
   RETURN
END SUBROUTINE write_hso

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_eigen ( ANISO_FILE, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER        :: wp = kind(0.d0)
   INTEGER, INTENT (IN)      :: ANISO_FILE
   INTEGER, INTENT (IN)      :: n
   COMPLEX (wp), INTENT (IN) :: array(n)
   LOGICAL, INTENT (IN)      :: dbg

   CALL write_complex_matrix( ANISO_FILE, '$eigen', n, array, dbg )
   RETURN
END SUBROUTINE write_eigen

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_gtens ( ANISO_FILE, nmult, gtens, axes, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER     :: wp = kind(0.d0)
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: nmult
   REAL (wp), INTENT (IN) :: gtens(nmult,3)
   REAL (wp), INTENT (IN) ::  axes(nmult,3,3)
   LOGICAL, INTENT (IN)   :: dbg

   CALL write_2d_real_array( ANISO_FILE, '$gtens_main', nmult, 3, gtens, dbg )
   CALL write_3d_real_array( ANISO_FILE, '$gtens_axes', nmult, 3, 3, axes, dbg )
   RETURN
END SUBROUTINE write_gtens

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_stev_cfp ( ANISO_FILE, s, n, cfp, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER     :: wp = kind(0.d0)
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n   ! 2J+1, or 2L+1, i.e. the dimension of the J or L multiplet
   REAL (wp), INTENT (IN) :: cfp(n-1, -(n-1):(n-1) )
   CHARACTER (LEN=*)      :: s
   INTEGER                :: k, q, ierr
   INTEGER, PARAMETER     :: StdOut=6
   LOGICAL, INTENT (IN)   :: dbg
   CHARACTER (LEN=500)    :: line
   REAL (wp), PARAMETER   :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp
   CHARACTER (LEN=30)     :: FMTCFP='(2(I0,1x),ES22.14)'


   ! s takes the value:
   ! 'L' == CFP for a term
   ! 'J' == CFP for a spin-orbit multiplet

   ierr=0
   IF ( (n<=0) ) THEN
      CALL WarningMessage(1,'write_stev_cfp_'//trim(s)//' :: nothing to write. Array size = 0.')
      RETURN
   END IF

   IF ( (trim(s).ne.'l')  .OR.  (trim(s).ne.'j') ) THEN
       CALL WarningMessage(1,'write_stev_cfp_'//trim(s)//' :: the parameter s='//trim(s)//'is not understood. '// &
                             'RETURN without writing cfp')
       RETURN
   END IF

   IF ( SUM(ABS( cfp(  1:(n-1), -(n-1):(n-1) ) )) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_stev_cfp_'//trim(s)//':: all array elements are zero = 0.')
   END IF

   REWIND ( ANISO_FILE )
   CALL file_advance_to_string( ANISO_FILE, '$stev_cfp_'//trim(s), line, ierr, dbg )

   IF (ierr /= 0 ) THEN
      WRITE ( ANISO_FILE, FMT='(A)', IOSTAT=ierr )
      WRITE ( ANISO_FILE, FMT='(A)', IOSTAT=ierr ) '$stev_cfp_'//trim(s)
   END IF

   ! if key is found, THEN rewrite the data
   WRITE ( ANISO_FILE, FMT=*, IOSTAT=ierr ) n
   DO k=2,n-1,2
      DO q=-k,k,2
         IF ( ABS(cfp(k,q)) > MINIMAL_REAL ) THEN
            WRITE ( ANISO_FILE, FMT=FMTCFP, IOSTAT=ierr ) k,q, cfp(k,q)
         END IF
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'write_stev_cfp_'//trim(s)//':: Something went wrong writing the array.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'write_stev_cfp_'//trim(s)//'::  k, q =',k, q
         IF (dbg) FLUSH (StdOut)
      END DO
   END DO
   WRITE ( ANISO_FILE, FMT='(A)', IOSTAT=ierr )
   FLUSH ( ANISO_FILE )
RETURN
END SUBROUTINE write_stev_cfp

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_susc ( ANISO_FILE, s, n, field, zj, t, z, x, x_tens, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER     :: wp = kind(0.d0)
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: n                  ! number of temperature points
   REAL (wp), INTENT (IN) :: field              ! applied field
   REAL (wp), INTENT (IN) :: zJ                 ! intermolecular interaction
   REAL (wp), INTENT (IN) :: t(n)               ! temperature points
   REAL (wp), INTENT (IN) :: z(n)               ! partition function
   REAL (wp), INTENT (IN) :: x(n)               ! susceptibility X
   REAL (wp), INTENT (IN) :: x_tens(n,3,3)      ! susceptibility tensor  X_tens
   CHARACTER (LEN=*), INTENT (IN) :: s
   INTEGER                :: i, j, k, ierr
   REAL (wp), EXTERNAL    :: dnrm2_
   LOGICAL, INTENT (IN)   :: dbg
   INTEGER, PARAMETER     :: StdOut=6
   REAL (wp), PARAMETER   :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp
   CHARACTER (LEN=500)    :: line
   CHARACTER (LEN=20)     :: FMTR='(5ES22.14)'
   CHARACTER (LEN=20)     :: FMTI='(20(I0,1x))'

   ! s takes the values:
   ! 'x'
   ! 'x_field'
   ! 'x_minus_one'
   ! 'x_field_minus_one'
   ! 'xt'
   ! 'xt_field'
   ! 'xt_minus_one'
   ! 'xt_field_minus_one'
   ! 'x_zj'
   ! 'x_field_zj'
   ! 'x_minus_one_zj'
   ! 'x_field_minus_one_zj'
   ! 'xt_zj'
   ! 'xt_field_zj'
   ! 'xt_minus_one_zj'
   ! 'xt_field_minus_one_zj'
!    IF ( (trim(s).ne.'x')                      .OR.   &
!         (trim(s).ne.'x_field')                .OR.   &
!         (trim(s).ne.'x_minus_one')            .OR.   &
!         (trim(s).ne.'x_field_minus_one')      .OR.   &
!         (trim(s).ne.'xt')                     .OR.   &
!         (trim(s).ne.'xt_field')               .OR.   &
!         (trim(s).ne.'xt_minus_one')           .OR.   &
!         (trim(s).ne.'xt_field_minus_one')     .OR.   &
!         (trim(s).ne.'x_zj')                   .OR.   &
!         (trim(s).ne.'x_field_zj')             .OR.   &
!         (trim(s).ne.'x_minus_one_zj')         .OR.   &
!         (trim(s).ne.'x_field_minus_one_zj')   .OR.   &
!         (trim(s).ne.'xt_zj')                  .OR.   &
!         (trim(s).ne.'xt_field_zj')            .OR.   &
!         (trim(s).ne.'xt_minus_one_zj')        .OR.   &
!         (trim(s).ne.'xt_field_minus_one_zj') ) THEN
!
!       CALL WarningMessage(1,'write_susc '//trim(s)//' :: the parameter s='//trim(s)//' is not understood. RETURN without'// &
!                             ' write of X data.')
!       RETURN
!   END IF

   ierr=0
   IF ( (n<=0) ) THEN
      CALL WarningMessage(1,'write_susc '//trim(s)//' :: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF ( dnrm2_(n,T,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_susc '//trim(s)//' :: all array T elements are zero = 0.')
   END IF
   IF ( dnrm2_(n,X,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_susc '//trim(s)//' :: all array X elements are zero = 0.')
   END IF
   IF ( dnrm2_(n,Z,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_susc '//trim(s)//' :: all array Z elements are zero = 0.')
   END IF
   IF ( dnrm2_(3*3*n,X_tens,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_susc '//trim(s)//' :: all array X_tens elements are zero = 0.')
   END IF

   REWIND ( ANISO_FILE )
   CALL file_advance_to_string( ANISO_FILE, '$susceptibility_'//trim(s), line, ierr, dbg )

   IF (ierr /= 0 ) THEN
      WRITE ( ANISO_FILE, FMT='(A)', IOSTAT=ierr )
      WRITE ( ANISO_FILE, FMT='(A)', IOSTAT=ierr ) '$susceptibility_'//trim(s)
   END IF

   WRITE ( ANISO_FILE, FMT=FMTI, IOSTAT=ierr ) n
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) zj, field
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the zJ and field values.')
   END IF
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) (T(i),i=1,n)
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the T array.')
   END IF
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) (Z(i),i=1,n)
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the Z array.')
   END IF
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) (X(i),i=1,n)
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the X array.')
   END IF
   FLUSH ( ANISO_FILE )
   DO j=1,3
      DO k=1,3
         WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) ( X_tens(i,j,k), i=1,n )
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the X_tens array.')
         END IF
      END DO
   END DO
   WRITE ( ANISO_FILE, FMT=*, IOSTAT=ierr )
   FLUSH ( ANISO_FILE )
   IF (dbg) FLUSH (StdOut)
   RETURN
END SUBROUTINE write_susc

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_magn (ANISO_FILE, nt, nh, nd, nss, zj, t, h, x, y, z, w, m, mav, energy, dbg)
   IMPLICIT NONE
   INTEGER, PARAMETER :: wp = kind(0.d0)
   INTEGER, INTENT (IN)   :: ANISO_FILE
   INTEGER, INTENT (IN)   :: nt                         ! number of temperature points
   INTEGER, INTENT (IN)   :: nh                         ! number of field points
   INTEGER, INTENT (IN)   :: nd                         ! number of directions of aplied field
   INTEGER, INTENT (IN)   :: nss                        ! number of spin-orbit states included in the Zeeman interaction
   REAL (wp), INTENT (IN) :: zj                         ! inter-molecular parameter zJ
   REAL (wp), INTENT (IN) :: t(nt)                      ! temperature points
   REAL (wp), INTENT (IN) :: h(nh)                      ! field points
   REAL (wp), INTENT (IN) :: x(nd), y(nd), z(nd), w(nd) ! Lebedev grid directions and weight
   REAL (wp), INTENT (IN) :: m(nd, 3, nh, nt)           ! magnetisation vector
   REAL (wp), INTENT (IN) :: mav(nh, nt)                ! average magnetisation vector
   REAL (wp), INTENT (IN) :: energy(nd, nh, nss)        ! Zeeman energy states
   INTEGER                :: id, ih, it, i, iss, l, ierr
   REAL (wp), EXTERNAL    :: dnrm2_
   INTEGER, PARAMETER     :: StdOut=6
   LOGICAL, INTENT (IN)   :: dbg
   REAL (wp), PARAMETER   :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp
   CHARACTER (LEN=500)    :: line
   CHARACTER (LEN=20)     :: FMTR='(5ES22.14)'
   CHARACTER (LEN=20)     :: FMTI='(20(I0,1x))'

   ierr=0
   IF ( (nt<=0) .OR. (nh<=0) .OR. (nd<=0) ) THEN
      CALL WarningMessage(1,'write_magn :: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF ( dnrm2_(nt,t,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_magn :: all array T elements are zero = 0.')
   END IF
   IF ( dnrm2_(nh,h,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_magn :: all array H elements are zero = 0.')
   END IF
   IF ( dnrm2_(nd*3*nt*nh,m,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_magn :: all array M elements are zero = 0.')
   END IF
   IF ( dnrm2_(nt*nh,mav,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_magn :: all array MAV elements are zero = 0.')
   END IF
   IF ( dnrm2_(nd*nh*nss,energy,1) <= MINIMAL_REAL ) THEN
      CALL WarningMessage(1,'write_magn :: all array energy elements are zero = 0.')
   END IF
   IF ( (dnrm2_(nd,x,1) <= MINIMAL_REAL) .OR. (dnrm2_(nd,y,1) <= MINIMAL_REAL) .OR.  &
        (dnrm2_(nd,z,1) <= MINIMAL_REAL) .OR. (dnrm2_(nd,w,1) <= MINIMAL_REAL) )    THEN
      CALL WarningMessage(1,'write_magn :: all array of X,Y,X,W elements are zero = 0.')
   END IF

   REWIND ( ANISO_FILE )
   CALL file_advance_to_string( ANISO_FILE, '$magnetisation', line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr /= 0 ) THEN
      WRITE ( ANISO_FILE, FMT='(A)', IOSTAT=ierr )
      WRITE ( ANISO_FILE, FMT='(A)', IOSTAT=ierr ) '$magnetisation'
   END IF

   WRITE ( ANISO_FILE, FMT=FMTI, IOSTAT=ierr ) nt, nh, nd, nss
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) zJ
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) (T(i),i=1,nt)
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_magn :: Something went wrong writing the T array.')
   END IF
   ! Magnetic field points
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) (H(i),i=1,nh)
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_magn :: Something went wrong writing the H array.')
   END IF
   ! Lebedev grid data (X, Y, Z, W)
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) ( X(i), i=1,nd )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_magn :: Something went wrong writing the Lebedev grid X rray.')
   END IF
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) ( Y(i), i=1,nd )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_magn :: Something went wrong writing the Lebedev grid Y array.')
   END IF
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) ( Z(i), i=1,nd )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_magn :: Something went wrong writing the Lebedev grid Z array.')
   END IF
   WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) ( W(i), i=1,nd )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'write_magn :: Something went wrong writing the Lebedev grid W array.')
   END IF
   FLUSH ( ANISO_FILE )
   ! Zeeman energy
   DO id=1,nd
      DO ih=1,nh
         WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr )  (energy(id,ih,iss),iss=1,nss)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'write_magn :: Something went wrong writing the Zeeman energy data.')
         END IF
      END DO
   END DO
   FLUSH ( ANISO_FILE )
   ! magnetisation vector data
   DO id=1,nd
      DO l=1,3
         DO ih=1,nh
            WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) (m(id,l,ih,it),it=1,nt)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'write_magn :: Something went wrong writing the M data.')
            END IF
         END DO
      END DO
   END DO
   FLUSH ( ANISO_FILE )
   DO ih=1,nh
      WRITE ( ANISO_FILE, FMT=FMTR, IOSTAT=ierr ) (mav(ih,it),it=1,nt)
      IF (ierr /= 0) THEN
         CALL WarningMessage(2,'write_magn :: Something went wrong writing the average M data.')
      END IF
   END DO
   WRITE ( ANISO_FILE, FMT=*, IOSTAT=ierr )
   FLUSH ( ANISO_FILE )
   IF (dbg) FLUSH (StdOut)
   RETURN
END SUBROUTINE write_magn














































!--------------------------------------------------------------------------------------------------!
!  BASIC  OPEN FILE / CLOSE FILE / SEARCH KEY INSIDE FILE etc. functions
!
!   open_datafile_write
!   open_datafile_read
!   close_datafile
!   key_found
!   file_advance_to_string
!
!--------------------------------------------------------------------------------------------------!
SUBROUTINE open_datafile_write(DATA_FILE,DATA_FILE_NAME)
   IMPLICIT NONE
   INTEGER            :: DATA_FILE
   CHARACTER(LEN=180) :: DATA_FILE_NAME
!#ifdef _ALONE_
!   INTEGER :: ierr
!   ierr=0
!   OPEN (UNIT=DATA_FILE, FILE=DATA_FILE_NAME, FORM='formatted', STATUS='old', ACCESS='sequential', ACTION='write', IOSTAT=ierr )
!   IF (ierr /= 0) THEN
!      CALL WarningMessage(2,'open_datafile_write:: Something went wrong opening DATA_FILE')
!      STOP
!   END IF
!#else
   Call molcas_open(DATA_FILE,DATA_FILE_NAME)
!#endif

   RETURN
END SUBROUTINE open_datafile_write

!--------------------------------------------------------------------------------------------------!
SUBROUTINE open_aniso_file(ANISO_FILE,ANISO_FILE_NAME)
   IMPLICIT NONE
   INTEGER            :: ANISO_FILE
   CHARACTER(LEN=180) :: ANISO_FILE_NAME
!#ifdef _ALONE_
!   INTEGER :: ierr
!   ierr=0
!   OPEN (UNIT=ANISO_FILE, FORM='formatted', STATUS='old', ACCESS='sequential', ACTION='write', IOSTAT=ierr )
!   IF (ierr /= 0) THEN
!      CALL WarningMessage(2,'open_datafile_write:: Something went wrong opening ANISO_FILE')
!      STOP
!   END IF
!#else
   Call molcas_open(ANISO_FILE,ANISO_FILE_NAME)
!#endif

   RETURN
END SUBROUTINE open_aniso_file

!--------------------------------------------------------------------------------------------------!
SUBROUTINE open_datafile_read(DATA_FILE,DATA_FILE_NAME)
   IMPLICIT NONE
   INTEGER            :: DATA_FILE
   CHARACTER(LEN=180) :: DATA_FILE_NAME
!#ifdef _ALONE_
!   INTEGER :: ierr
!   ierr=0
!   OPEN (UNIT=DATA_FILE, FORM='FORMATTED', STATUS='old', ACCESS='sequential', ACTION='read', IOSTAT=ierr )
!   IF (ierr /= 0) THEN
!      CALL WarningMessage(2,'open_datafile_read:: Something went wrong opening DATA_FILE')
!      STOP
!   END IF
!#else
   Call molcas_open(DATA_FILE,DATA_FILE_NAME)
!#endif
   RETURN
END SUBROUTINE open_datafile_read

!--------------------------------------------------------------------------------------------------!
SUBROUTINE close_datafile(DATA_FILE)
   IMPLICIT NONE
   INTEGER :: DATA_FILE
   INTEGER :: ierr
   ierr=0
   CLOSE (UNIT=DATA_FILE, IOSTAT=ierr )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'close_datafile:: Something went wrong closing DATA_FILE')
      !STOP
   END IF
   RETURN
END SUBROUTINE close_datafile

!--------------------------------------------------------------------------------------------------!
SUBROUTINE close_anisofile(ANISO_FILE)
   IMPLICIT NONE
   INTEGER :: ANISO_FILE
   INTEGER :: ierr
   ierr=0
   CLOSE (UNIT=ANISO_FILE, IOSTAT=ierr )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'close_datafile:: Something went wrong closing ANISO_FILE')
      !STOP
   END IF
   RETURN
END SUBROUTINE close_anisofile
!--------------------------------------------------------------------------------------------------!
LOGICAL FUNCTION key_found (DATA_FILE, key, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: DATA_FILE
   CHARACTER (LEN=*), INTENT (IN) :: key
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   INTEGER                        :: ierr

   ierr=0
   key_found=.false.
   REWIND ( DATA_FILE )
   CALL file_advance_to_string( DATA_FILE, key, line, ierr, dbg )
   IF ( index (line, trim(key)) /= 0 ) THEN
      key_found=.true.
   END IF

   RETURN
END FUNCTION key_found

!--------------------------------------------------------------------------------------------------!
SUBROUTINE file_advance_to_string ( LU, key, line, ierr, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   INTEGER                        :: ios
   INTEGER                        :: num_read
   CHARACTER (LEN=*), INTENT (IN) :: key
   CHARACTER (LEN=*)              :: line
   INTEGER, INTENT (OUT)          :: ierr
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER, PARAMETER             :: StdOut=6

   ierr = 0
   num_read = 0

   REWIND ( LU )
   DO
      READ ( LU, '(a)', IOSTAT = ios ) line

      IF ( ios /= 0 ) THEN
         !STOP 'file_advance_to_string:: error reading line'
         !print '(A,i0,2A)', 'file_advance_to_string:: error reading line: LU=',LU,' key=',key
         GO TO 1
      END IF

      num_read = num_read + 1

      IF ( index (line, trim(key)) /= 0 ) THEN
         RETURN
      END IF
   END DO

1  CONTINUE
   line = ' '
   ierr = 1

   IF ( dbg ) THEN
      WRITE (StdOut, '(a)' ) ' '
      WRITE (StdOut, '(a)' ) 'FILE_ADVANCE_TO_STRING - Warning!'
      WRITE (StdOut, '(a)' ) '  Did not find the key:'
      WRITE (StdOut, '(a)' ) '    ' // trim ( key )
      WRITE (StdOut, '(a,i6)' ) '  Number of lines read was ', num_read
   END IF

   RETURN
END SUBROUTINE file_advance_to_string
!--------------------------------------------------------------------------------------------------!


!--------------------------------------------------------------------------------------------------!
LOGICAL FUNCTION inquire_key_presence ( LU, key )
   IMPLICIT NONE
   INTEGER, INTENT (IN)   :: LU
   CHARACTER (LEN=*)      :: key
   INTEGER                :: ios
   CHARACTER (LEN=500)    :: line

   inquire_key_presence=.false.
   REWIND ( LU )
   DO
      READ ( LU, '(a)', IOSTAT = ios ) line
      IF ( ios /= 0 ) THEN
         !STOP 'inquire_key_presence:: error reading line'
         CALL WarningMessage(1,'inquire_key_presence:: error reading line')
      END IF
      IF ( index (line, trim(key)) /= 0 ) THEN
         inquire_key_presence=.true.
         RETURN
      END IF
   END DO
   line = ' '
   RETURN
END FUNCTION inquire_key_presence
!--------------------------------------------------------------------------------------------------!




































!--------------------------------------------------------------------------------------------------!
!   READING  SUBROUTINES
!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_INTEGER_scalar( LU, key, i, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (OUT)          :: i
   CHARACTER(LEN=500)             :: line
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: ierr
   INTEGER, PARAMETER             :: StdOut = 6

   ierr=0
   i=0
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   READ ( LU, FMT=*, IOSTAT=ierr ) i
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_INTEGER_scalar:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_INTEGER_scalar:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_INTEGER_scalar::   i =',i
   RETURN
END SUBROUTINE read_INTEGER_scalar

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_real_scalar( LU, key, r, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   REAL (wp), INTENT (OUT)        :: r
   INTEGER, PARAMETER             :: StdOut=6
   REAL (wp), PARAMETER           :: Zero=0.0_wp
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: ierr
   CHARACTER(LEN=500)             :: line


   ierr=0
   r=Zero
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   READ ( LU, FMT=*, IOSTAT=ierr ) r
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_real_scalar:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_real_scalar:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_real_scalar::   r =',r
   RETURN
END SUBROUTINE read_real_scalar

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_complex_scalar( LU, key, c, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   COMPLEX (wp), INTENT (OUT)     :: c
   REAL (wp)                      :: rr, ri
   REAL (wp), PARAMETER           :: Zero=0.0_wp
   COMPLEX (wp), PARAMETER        :: ZeroC=(0.0_wp,0.0_wp)
   INTEGER, PARAMETER             :: StdOut=6
   INTEGER                        :: ierr
   CHARACTER (LEN=500)            :: line
   LOGICAL, INTENT (IN)           :: dbg

   ierr=0
   rr=Zero ; ri=Zero ; c=ZeroC
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   READ ( LU, FMT=*, IOSTAT=ierr ) rr, ri
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_complex_scalar:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_complex_scalar::   key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_complex_scalar:: (r,i) =', rr, ri
   IF (dbg) WRITE (StdOut,*) 'read_complex_scalar::     c =', c
   c=CMPLX(rr,ri,wp)
   RETURN
END SUBROUTINE read_complex_scalar

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_string ( LU, key, length, s, dbg )
   !result ( s )
   IMPLICIT NONE
   INTEGER, INTENT (IN)                :: LU
   CHARACTER (LEN=*), INTENT (IN)      :: key
   INTEGER, INTENT (IN)                :: length
   CHARACTER (LEN=length),INTENT (OUT) :: s
   CHARACTER (LEN=500)                 :: c, f, line
   INTEGER                             :: i, ierr
   LOGICAL, INTENT (IN)                :: dbg
   INTEGER, PARAMETER                  :: StdOut=6

   IF (dbg) WRITE (StdOut,*) 'read_string::    key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_string:: length =',length
   FLUSH (StdOut)
   WRITE (f,'(A,i0,2A)') '"(A',length,')"'
   WRITE (StdOut,'(2A)') 'format =', trim(f)
   FLUSH (StdOut)
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   READ ( LU, FMT=f, IOSTAT=ierr ) c
   WRITE (StdOut,'(2A)') 'c =', trim(c)
   WRITE (s,'(A)') trim(c)

   DO i=1,LEN(TRIM(LINE))
     READ (LINE,'(A500)') c
     WRITE (s,'(A)') trim(c)
     FLUSH (StdOut)
     IF (dbg) WRITE (StdOut,*) 'read_string::   c =', trim(c)
     FLUSH (StdOut)
   END DO

   RETURN
END SUBROUTINE read_string

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_1d_size( LU, key, n, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (OUT)          :: n
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: ierr

   ierr=0
   n=0
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   READ ( LU, FMT=*, IOSTAT=ierr ) n
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_1d_size:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_1d_size:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_1d_size::   n =',n
   RETURN
END SUBROUTINE read_1d_size

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_2d_size( LU, key, n1, n2, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (OUT)          :: n1, n2
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: ierr

   ierr=0
   n1=0 ; n2=0 ;
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   READ ( LU, FMT=*, IOSTAT=ierr ) n1, n2
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_2d_size:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_2d_size:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_2d_size::  n1 =',n1
   IF (dbg) WRITE (StdOut,*) 'read_2d_size::  n2 =',n2
   RETURN
END SUBROUTINE read_2d_size

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_3d_size( LU, key, n1, n2, n3, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (OUT)          :: n1, n2, n3
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: ierr

   ierr=0
   n1=0 ; n2=0 ; n3=0 ;
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   READ ( LU, FMT=*, IOSTAT=ierr ) n1, n2, n3
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_3d_size:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_3d_size:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_3d_size::  n1 =',n1
   IF (dbg) WRITE (StdOut,*) 'read_3d_size::  n2 =',n2
   IF (dbg) WRITE (StdOut,*) 'read_3d_size::  n3 =',n3
   RETURN
END SUBROUTINE read_3d_size

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_4d_size( LU, key, n1, n2, n3, n4, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (OUT)          :: n1, n2, n3, n4
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: ierr

   ierr=0
   n1=0 ; n2=0 ; n3=0 ; n4=0 ;
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   READ ( LU, FMT=*, IOSTAT=ierr ) n1, n2, n3, n4
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_4d_size:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_4d_size:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_4d_size::  n1 =',n1
   IF (dbg) WRITE (StdOut,*) 'read_4d_size::  n2 =',n2
   IF (dbg) WRITE (StdOut,*) 'read_4d_size::  n3 =',n3
   IF (dbg) WRITE (StdOut,*) 'read_4d_size::  n4 =',n4
   RETURN
END SUBROUTINE read_4d_size

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_1d_INTEGER_array( LU, key, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n
   INTEGER, INTENT (OUT)          :: array(n)
   INTEGER                        :: i, ierr
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   LOGICAL, INTENT (IN)           :: dbg

   ierr=0
   array=0
   IF (n<=0) THEN
      CALL WarningMessage(1,'read_1d_INTEGER_array:: nothing to read. Array size = 0.')
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_1d_INTEGER_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_1d_INTEGER_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_1d_INTEGER_array::   n =',i
   IF ( i/=n ) THEN
      CALL WarningMessage(2,'read_1d_INTEGER_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF

   READ ( LU, FMT=*, IOSTAT=ierr ) (array(i),i=1,n)
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_1d_INTEGER_array:: Something went wrong reading the array.')
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_1d_INTEGER_array:: array =',(array(i),i=1,n)

   RETURN
END SUBROUTINE read_1d_INTEGER_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_2d_INTEGER_array( LU, key, n1, n2, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2
   INTEGER, INTENT (OUT)          :: array(n1,n2)
   INTEGER                        :: i,j
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   INTEGER                        :: ierr

   ierr=0
   array=0
   IF ( (n1<=0).OR.(n2<=0) ) THEN
      CALL WarningMessage(1,'read_2d_INTEGER_array:: nothing to read. Array size = 0.')
      IF (dbg) WRITE (StdOut,*) 'read_2d_INTEGER_array::   n1 =',n1
      IF (dbg) WRITE (StdOut,*) 'read_2d_INTEGER_array::   n2 =',n2
      IF (dbg) FLUSH (StdOut)
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i,j
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_2d_INTEGER_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_2d_INTEGER_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_2d_INTEGER_array::  n1 =',i
   IF (dbg) WRITE (StdOut,*) 'read_2d_INTEGER_array::  n2 =',j
   IF ( (i/=n1).OR.(j/=n2) ) THEN
      CALL WarningMessage(2,'read_2d_INTEGER_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF
   DO i=1, n1
      READ ( LU, FMT=*, IOSTAT=ierr ) (array(i,j),j=1,n2)
      IF (ierr /= 0) THEN
         CALL WarningMessage(2,'read_2d_INTEGER_array:: Something went wrong reading the array.')
      END IF
      IF (dbg) WRITE (StdOut,*) 'read_2d_INTEGER_array::  i =',i
      IF (dbg) FLUSH (StdOut)
   END DO

   RETURN
END SUBROUTINE read_2d_INTEGER_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_3d_INTEGER_array( LU, key, n1, n2, n3, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3
   INTEGER, INTENT (OUT)          :: array(n1,n2,n3)
   INTEGER                        :: i,j,k
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   INTEGER                        :: ierr

   ierr=0
   array=0
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) ) THEN
      CALL WarningMessage(1,'read_3d_INTEGER_array:: nothing to read. Array size = 0.')
      IF (dbg) WRITE (StdOut,*) 'read_3d_INTEGER_array::   n1 =',n1
      IF (dbg) WRITE (StdOut,*) 'read_3d_INTEGER_array::   n2 =',n2
      IF (dbg) WRITE (StdOut,*) 'read_3d_INTEGER_array::   n3 =',n3
      IF (dbg) FLUSH (StdOut)
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i,j,k
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_3d_INTEGER_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_3d_INTEGER_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_3d_INTEGER_array::  n1 =',i
   IF (dbg) WRITE (StdOut,*) 'read_3d_INTEGER_array::  n2 =',j
   IF (dbg) WRITE (StdOut,*) 'read_3d_INTEGER_array::  n3 =',k
   IF ( (i/=n1) .OR. (j/=n2) .OR. (k/=n3) ) THEN
      CALL WarningMessage(2,'read_3d_INTEGER_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF
   DO i=1, n1
      DO j=1, n2
         READ ( LU, FMT=*, IOSTAT=ierr ) (array(i,j,k),k=1,n3)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'read_3d_INTEGER_array:: Something went wrong reading the array.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'read_3d_INTEGER_array::  i,j =',i,j
         IF (dbg) FLUSH (StdOut)
      END DO
   END DO

   RETURN
END SUBROUTINE read_3d_INTEGER_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_4d_INTEGER_array( LU, key, n1, n2, n3, n4, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3, n4
   INTEGER, INTENT (OUT)          :: array(n1,n2,n3,n4)
   INTEGER                        :: i,j,k,l
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   INTEGER                        :: ierr

   ierr=0
   array=0
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) .OR. (n4<=0) ) THEN
      CALL WarningMessage(1,'read_4d_INTEGER_array:: nothing to read. Array size = 0.')
      IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array::   n1 =',n1
      IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array::   n2 =',n2
      IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array::   n3 =',n3
      IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array::   n4 =',n4
      IF (dbg) FLUSH (StdOut)
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i,j,k,l
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_4d_INTEGER_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array::  n1 =',i
   IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array::  n2 =',j
   IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array::  n3 =',k
   IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array::  n4 =',l
   IF ( (i/=n1) .OR. (j/=n2) .OR. (k/=n3) .OR. (l/=n4) ) THEN
      CALL WarningMessage(2,'read_4d_INTEGER_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF
   DO i=1, n1
      DO j=1, n2
         DO k=1, n3
            READ ( LU, FMT=*, IOSTAT=ierr ) (array(i,j,k,l),l=1,n4)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'read_4d_INTEGER_array:: Something went wrong reading the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'read_4d_INTEGER_array::  i,j,k =',i,j,k
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   END DO

   RETURN
END SUBROUTINE read_4d_INTEGER_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_1d_real_array( LU, key, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n
   REAL (wp), INTENT (OUT)        :: array(n)
   INTEGER                        :: i
   LOGICAL, INTENT (IN)           :: dbg
   REAL (wp), PARAMETER           :: Zero = 0.0_wp
   INTEGER                        :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   INTEGER                        :: ierr

   ierr=0
   array=Zero
   IF (n<=0) THEN
      CALL WarningMessage(1,'read_1d_real_array:: nothing to read. Array size = 0.')
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_1d_real_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_1d_real_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_1d_real_array::   n =',i
   IF ( (i/=n) ) THEN
      CALL WarningMessage(2,'read_1d_real_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF

   READ ( LU, FMT=*, IOSTAT=ierr ) (array(i),i=1,n)
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_1d_real_array:: Something went wrong reading the array.')
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_1d_real_array:: array =',(array(i),i=1,n)

   RETURN
END SUBROUTINE read_1d_real_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_2d_real_array( LU, key, n1, n2, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2
   REAL (wp), INTENT (OUT)        :: array(n1,n2)
   INTEGER                        :: i,j,ierr
   LOGICAL, INTENT (IN)           :: dbg
   REAL (wp), PARAMETER           :: Zero = 0.0_wp
   CHARACTER (LEN=500)            :: line
   INTEGER                        :: StdOut = 6

   ierr=0
   array=Zero
   IF ( (n1<=0) .OR. (n2<=0) ) THEN
      CALL WarningMessage(1,'read_2d_real_array:: nothing to read. Array size = 0.')
      IF (dbg) WRITE (StdOut,*) 'read_2d_real_array::   n1 =',n1
      IF (dbg) WRITE (StdOut,*) 'read_2d_real_array::   n2 =',n2
      IF (dbg) FLUSH (StdOut)
      RETURN
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_2d_real_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_2d_real_array:: key =',trim(key)

   READ ( LU, FMT=*, IOSTAT=ierr ) i, j

   IF (dbg) WRITE (StdOut,*) 'read_2d_real_array::  n1 =',i
   IF (dbg) WRITE (StdOut,*) 'read_2d_real_array::  n2 =',j
   IF ( (i/=n1) .OR. (j/=n2) ) THEN
      CALL WarningMessage(2,'read_2d_real_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF

   DO i=1, n1
      READ ( LU, FMT=*, IOSTAT=ierr ) ( array(i,j), j=1,n2 )
      IF (dbg) WRITE (StdOut,*) ( array(i,j), j=1,n2 )
      IF (ierr /= 0) THEN
         CALL WarningMessage(2,'read_2d_real_array:: Something went wrong reading the array.')
      END IF
      IF (dbg) WRITE (StdOut,*) 'read_2d_real_array::  i =',i
      IF (dbg) FLUSH (StdOut)
   END DO

   RETURN
END SUBROUTINE read_2d_real_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_3d_real_array( LU, key, n1, n2, n3, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3
   REAL (wp), INTENT (OUT)        :: array(n1,n2,n3)
   INTEGER                        :: i,j,k,ierr
   LOGICAL, INTENT (IN)           :: dbg
   REAL (wp), PARAMETER           :: Zero = 0.0_wp
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line

   ierr=0
   array=Zero
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) ) THEN
      CALL WarningMessage(1,'read_3d_real_array:: nothing to read. Array size = 0.')
      IF (dbg) WRITE (StdOut,*) 'read_3d_real_array::   n1 =',n1
      IF (dbg) WRITE (StdOut,*) 'read_3d_real_array::   n2 =',n2
      IF (dbg) WRITE (StdOut,*) 'read_3d_real_array::   n3 =',n3
      IF (dbg) FLUSH (StdOut)
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i,j,k
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_3d_real_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_3d_real_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_3d_real_array::  n1 =',i
   IF (dbg) WRITE (StdOut,*) 'read_3d_real_array::  n2 =',j
   IF (dbg) WRITE (StdOut,*) 'read_3d_real_array::  n3 =',k
   IF ( (i/=n1) .OR. (j/=n2) .OR. (k/=n3) ) THEN
      CALL WarningMessage(2,'read_3d_real_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF
   DO i=1, n1
      DO j=1, n2
         READ ( LU, FMT=*, IOSTAT=ierr ) (array(i,j,k),k=1,n3)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'read_3d_real_array:: Something went wrong reading the array.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'read_3d_real_array::  i,j =',i,j
         IF (dbg) FLUSH (StdOut)
      END DO
   END DO

   RETURN
END SUBROUTINE read_3d_real_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_4d_real_array( LU, key, n1, n2, n3, n4, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3, n4
   REAL (wp), INTENT (OUT)        :: array(n1,n2,n3,n4)
   INTEGER                        :: i, j, k, l, ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   INTEGER, PARAMETER             :: StdOut = 6
   REAL (wp), PARAMETER           :: Zero = 0.0_wp

   ierr=0
   array=Zero
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) .OR. (n4<=0) ) THEN
      CALL WarningMessage(1,'read_4d_real_array:: nothing to read. Array size = 0.')
      IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::   n1 =',n1
      IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::   n2 =',n2
      IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::   n3 =',n3
      IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::   n4 =',n4
      IF (dbg) FLUSH (StdOut)
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i,j,k,l
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_4d_real_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_4d_real_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::  n1 =',i
   IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::  n2 =',j
   IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::  n3 =',k
   IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::  n4 =',l
   IF ( (i/=n1) .OR. (j/=n2) .OR. (k/=n3) .OR. (l/=n4) ) THEN
      CALL WarningMessage(2,'read_4d_real_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF
   DO i=1, n1
      DO j=1, n2
         DO k=1, n3
            READ ( LU, FMT=*, IOSTAT=ierr ) (array(i,j,k,l),l=1,n4)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'read_4d_real_array:: Something went wrong reading the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::  i,j,k =',i,j,k
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   END DO

   RETURN
END SUBROUTINE read_4d_real_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_1d_complex_array( LU, key, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n
   COMPLEX (wp), INTENT (OUT)     :: array(n)
   REAL (wp), ALLOCATABLE         :: rr(:), ri(:)
   INTEGER                        :: i, ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   INTEGER, PARAMETER             :: StdOut = 6
   REAL (wp), PARAMETER           :: Zero = 0.0_wp
   COMPLEX (wp), PARAMETER        :: ZeroC = (0.0_wp, 0.0_wp)

   ierr=0
   array=ZeroC
   IF (n<=0) THEN
      CALL WarningMessage(1,'read_1d_complex_array:: nothing to read. Array size = 0.')
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_1d_complex_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_1d_complex_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_1d_complex_array::   n =',i
   IF ( (i/=n) ) THEN
      CALL WarningMessage(2,'read_1d_complex_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF
   ALLOCATE (rr(n))
   ALLOCATE (ri(n))
   rr=Zero ; ri=Zero
   READ ( LU, FMT=*, IOSTAT=ierr ) ( rr(i), ri(i), i=1,n )
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_1d_complex_array:: Something went wrong reading the array.')
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_1d_complex_array:: array =',(rr(i),ri(i),i=1,n)
   DO i=1, n
     array(i)=CMPLX(rr(i), ri(i), wp)
   END DO
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   RETURN
END SUBROUTINE read_1d_complex_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_2d_complex_array( LU, key, n1, n2, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2
   COMPLEX (wp), INTENT (OUT)     :: array(n1,n2)
   REAL (wp), ALLOCATABLE         :: rr(:,:), ri(:,:)
   INTEGER                        :: i, j, ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   INTEGER, PARAMETER             :: StdOut = 6
   REAL (wp), PARAMETER           :: Zero = 0.0_wp
   COMPLEX (wp), PARAMETER        :: ZeroC = (0.0_wp, 0.0_wp)

   ierr=0
   array=ZeroC
   IF ( (n1<=0) .OR. (n2<=0) ) THEN
      CALL WarningMessage(1,'read_2d_complex_array:: nothing to read. Array size = 0.')
      IF (dbg) WRITE (StdOut,*) 'read_2d_complex_array::   n1 =',n1
      IF (dbg) WRITE (StdOut,*) 'read_2d_complex_array::   n2 =',n2
      IF (dbg) FLUSH (StdOut)
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i,j
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_2d_complex_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_2d_complex_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_2d_complex_array::  n1 =',i
   IF (dbg) WRITE (StdOut,*) 'read_2d_complex_array::  n2 =',j
   IF ( (i/=n1) .OR. (j/=n2) ) THEN
      CALL WarningMessage(2,'read_2d_complex_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF
   ALLOCATE (rr(n1,n2))
   ALLOCATE (ri(n1,n2))
   rr=Zero ; ri=Zero
   DO i=1, n1
      READ ( LU, FMT=*, IOSTAT=ierr ) (rr(i,j), ri(i,j), j=1,n2)
      IF (ierr /= 0) THEN
         CALL WarningMessage(2,'read_2d_complex_array:: Something went wrong reading the array.')
      END IF
      IF (dbg) WRITE (StdOut,*) 'read_2d_complex_array::  i =',i
      IF (dbg) FLUSH (StdOut)
   END DO
   DO i=1, n1
      DO j=1, n2
         array(i,j)=CMPLX(rr(i,j), ri(i,j), wp)
      END DO
   END DO
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   RETURN
END SUBROUTINE read_2d_complex_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_3d_complex_array( LU, key, n1, n2, n3, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3
   COMPLEX (wp), INTENT (OUT)     :: array(n1,n2,n3)
   REAL (wp), ALLOCATABLE         :: rr(:,:,:), ri(:,:,:)
   INTEGER                        :: i, j, k, ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   INTEGER, PARAMETER             :: StdOut = 6
   REAL (wp), PARAMETER           :: Zero = 0.0_wp
   COMPLEX (wp), PARAMETER        :: ZeroC = (0.0_wp, 0.0_wp)

   ierr=0
   array=ZeroC
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) ) THEN
      CALL WarningMessage(1,'read_3d_complex_array:: nothing to read. Array size = 0.')
      IF (dbg) WRITE (StdOut,*) 'read_3d_complex_array::   n1 =',n1
      IF (dbg) WRITE (StdOut,*) 'read_3d_complex_array::   n2 =',n2
      IF (dbg) WRITE (StdOut,*) 'read_3d_complex_array::   n3 =',n3
      IF (dbg) FLUSH (StdOut)
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i,j,k
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_3d_complex_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_3d_complex_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_3d_complex_array::  n1 =',i
   IF (dbg) WRITE (StdOut,*) 'read_3d_complex_array::  n2 =',j
   IF (dbg) WRITE (StdOut,*) 'read_3d_complex_array::  n3 =',k
   IF ( (i/=n1) .OR. (j/=n2) .OR. (k/=n3) ) THEN
      CALL WarningMessage(2,'read_3d_complex_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF
   ALLOCATE (rr(n1,n2,n3))
   ALLOCATE (ri(n1,n2,n3))
   rr=Zero ; ri=Zero
   DO i=1, n1
      DO j=1, n2
         READ ( LU, FMT=*, IOSTAT=ierr ) ( rr(i,j,k), ri(i,j,k), k=1,n3 )
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'read_3d_complex_array:: Something went wrong reading the array.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'read_3d_complex_array::  i,j =',i,j
         IF (dbg) FLUSH (StdOut)
      END DO
   END DO
   DO i=1, n1
      DO j=1, n2
         DO k=1, n3
            array(i,j,k)=CMPLX(rr(i,j,k), ri(i,j,k), wp)
         END DO
      END DO
   END DO
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   RETURN
END SUBROUTINE read_3d_complex_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE read_4d_complex_array( LU, key, n1, n2, n3, n4, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3, n4
   COMPLEX (wp), INTENT (OUT)     :: array(n1,n2,n3,n4)
   REAL (wp), ALLOCATABLE         :: rr(:,:,:,:), ri(:,:,:,:)
   INTEGER                        :: i, j, k, l, ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   INTEGER, PARAMETER             :: StdOut = 6
   REAL (wp), PARAMETER           :: Zero = 0.0_wp
   COMPLEX (wp), PARAMETER        :: ZeroC = (0.0_wp, 0.0_wp)

   ierr=0
   array=ZeroC
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) .OR. (n4<=0) ) THEN
      CALL WarningMessage(1,'read_4d_complex_array:: nothing to read. Array size = 0.')
      IF (dbg) WRITE (StdOut,*) 'read_4d_complex_array::   n1 =',n1
      IF (dbg) WRITE (StdOut,*) 'read_4d_complex_array::   n2 =',n2
      IF (dbg) WRITE (StdOut,*) 'read_4d_complex_array::   n3 =',n3
      IF (dbg) WRITE (StdOut,*) 'read_4d_complex_array::   n4 =',n4
      IF (dbg) FLUSH (StdOut)
      RETURN
   END IF
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   READ ( LU, FMT=*, IOSTAT=ierr ) i,j,k,l
   IF (ierr /= 0) THEN
      CALL WarningMessage(2,'read_4d_complex_array:: Something went wrong reading key'//trim(key))
   END IF
   IF (dbg) WRITE (StdOut,*) 'read_4d_complex_array:: key =',trim(key)
   IF (dbg) WRITE (StdOut,*) 'read_4d_complex_array::  n1 =',i
   IF (dbg) WRITE (StdOut,*) 'read_4d_complex_array::  n2 =',j
   IF (dbg) WRITE (StdOut,*) 'read_4d_complex_array::  n3 =',k
   IF (dbg) WRITE (StdOut,*) 'read_4d_complex_array::  n4 =',l
   IF ( (i/=n1) .OR. (j/=n2) .OR. (k/=n3) .OR. (l/=n4) ) THEN
      CALL WarningMessage(2,'read_4d_complex_array:: sizes of the array are different from the ones used '// &
                            'to CALL this SUBROUTINE')
   END IF
   ALLOCATE (rr(n1,n2,n3,n4))
   ALLOCATE (ri(n1,n2,n3,n4))
   rr=Zero; ri=Zero;
   DO i=1, n1
      DO j=1, n2
         DO k=1, n3
            READ ( LU, FMT=*, IOSTAT=ierr ) (rr(i,j,k,l), ri(i,j,k,l), l=1,n4)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'read_4d_real_array:: Something went wrong reading the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'read_4d_real_array::  i,j,k =',i,j,k
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   END DO
   DO i=1, n1
      DO j=1, n2
         DO k=1, n3
            DO l=1, n4
               array(i,j,k,l)=CMPLX(rr(i,j,k,l), ri(i,j,k,l), wp)
            END DO
         END DO
      END DO
   END DO
   DEALLOCATE (rr)
   DEALLOCATE (ri)
   RETURN
END SUBROUTINE read_4d_complex_array
!--------------------------------------------------------------------------------------------------!


























!--------------------------------------------------------------------------------------------------!
!  WRITING SUBROUTINES
!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_INTEGER_scalar( LU, key, i, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: i
   INTEGER                        :: ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'

   ierr=0
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) i
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_INTEGER_scalar:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) i
      IF (ierr /= 0) CALL WarningMessage(1,'write_INTEGER_scalar:: Something went wrong writing data')
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_INTEGER_scalar

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_real_scalar( LU, key, r, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   REAL (wp), INTENT (IN)         :: r
   INTEGER                        :: ierr
   CHARACTER (LEN=500)            :: line
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=20)             :: FMTR='(5ES22.14)'

   ierr=0
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) r
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_real_scalar:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) r
      IF (ierr /= 0) CALL WarningMessage(1,'write_real_scalar:: Something went wrong writing data')
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_real_scalar

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_complex_scalar( LU, key, c, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   COMPLEX (wp), INTENT (IN)      :: c
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER                        :: ierr
   CHARACTER (LEN=500)            :: line
   CHARACTER (LEN=20)             :: FMTC='(3(2ES22.14))'

   ierr=0
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) c
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_complex_scalar:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) c
      IF (ierr /= 0) CALL WarningMessage(1,'write_complex_scalar:: Something went wrong writing data')
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_complex_scalar

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_string( LU, key, s, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   CHARACTER (LEN=*), INTENT (IN) :: s
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   INTEGER                        :: ierr

   ierr=0
   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )
   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT='(A   )', IOSTAT=ierr ) trim(s)
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A   )', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_string:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT='(100A)', IOSTAT=ierr ) trim(s)
      IF (ierr /= 0) CALL WarningMessage(1,'write_string:: Something went wrong writing data')
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_string

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_1d_INTEGER_array( LU, key, n, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n
   INTEGER, INTENT (IN)           :: array(n)
   INTEGER                        :: i,ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'

   ierr=0
   IF (n<=0) THEN
      CALL WarningMessage(1,'write_1d_INTEGER_array:: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF (SUM(ABS(array(1:n)))==0) THEN
      CALL WarningMessage(1,'write_1d_INTEGER_array:: all array elements are zero = 0.')
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) (array(i),i=1,n)
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_1d_INTEGER_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) (array(i),i=1,n)
      IF (ierr /= 0) CALL WarningMessage(1,'write_1d_INTEGER_array:: Something went wrong writing data')
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_1d_INTEGER_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_2d_INTEGER_array( LU, key, n1, n2, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2
   INTEGER, INTENT (IN)           :: array(n1,n2)
   INTEGER                        :: i, j, ierr
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'

   ierr=0
   IF ( (n1<=0) .OR. (n2<=0) ) THEN
      CALL WarningMessage(1,'write_2d_INTEGER_array:: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF (SUM(ABS(array(1:n1,1:n2)))==0) THEN
      CALL WarningMessage(1,'write_2d_INTEGER_array:: all array elements are zero = 0.')
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2
      DO i=1,n1
         WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) (array(i,j),j=1,n2)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'write_2d_INTEGER_array:: Something went wrong writing the array.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'write_2d_INTEGER_array::  i =',i
         IF (dbg) FLUSH (StdOut)
      END DO
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_2d_INTEGER_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2
      DO i=1,n1
         WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) (array(i,j),j=1,n2)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'write_2d_INTEGER_array:: Something went wrong writing data.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'write_2d_INTEGER_array::  i =',i
         IF (dbg) FLUSH (StdOut)
      END DO
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_2d_INTEGER_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_3d_INTEGER_array( LU, key, n1, n2, n3, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3
   INTEGER, INTENT (IN)           :: array(n1,n2,n3)
   INTEGER                        :: i, j, k, ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line

   ierr=0
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) ) THEN
      CALL WarningMessage(1,'write_3d_INTEGER_array:: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF (SUM(ABS(array(1:n1,1:n2,1:n3)))==0) THEN
      CALL WarningMessage(1,'write_3d_INTEGER_array:: all array elements are zero = 0.')
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3
      DO i=1,n1
         DO j=1,n2
            WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) (array(i,j,k),k=1,n3)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'write_3d_INTEGER_array:: Something went wrong writing the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'write_3d_INTEGER_array::  i,j =',i,j
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_3d_INTEGER_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3
      DO i=1,n1
         DO j=1,n2
            WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) (array(i,j,k),k=1,n3)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'write_3d_INTEGER_array:: Something went wrong writing the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'write_3d_INTEGER_array::  i,j =',i,j
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_3d_INTEGER_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_4d_INTEGER_array( LU, key, n1, n2, n3, n4, array, dbg )
   IMPLICIT NONE
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3, n4
   INTEGER, INTENT (IN)           :: array(n1,n2,n3,n4)
   INTEGER                        :: i, j, k, l, ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line

   ierr=0
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) .OR. (n4<=0) ) THEN
      CALL WarningMessage(1,'write_4d_INTEGER_array:: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF (SUM(ABS(array(1:n1,1:n2,1:n3,1:n4)))==0) THEN
      CALL WarningMessage(1,'write_4d_INTEGER_array:: all array elements are zero = 0.')
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3, n4
      DO i=1,n1
         DO j=1,n2
            DO k=1,n3
               WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) (array(i,j,k,l),l=1,n4)
               IF (ierr /= 0) THEN
                  CALL WarningMessage(2,'write_4d_INTEGER_array:: Something went wrong reading the array.')
               END IF
               IF (dbg) WRITE (StdOut,*) 'write_4d_INTEGER_array::  i,j,k =',i,j,k
               IF (dbg) FLUSH (StdOut)
            END DO
         END DO
      END DO
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_4d_INTEGER_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3, n4
      DO i=1,n1
         DO j=1,n2
            DO k=1,n3
               WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) (array(i,j,k,l),l=1,n4)
               IF (ierr /= 0) THEN
                  CALL WarningMessage(2,'write_4d_INTEGER_array:: Something went wrong writting the array.')
               END IF
               IF (dbg) WRITE (StdOut,*) 'write_4d_INTEGER_array::  i,j,k =',i,j,k
               IF (dbg) FLUSH (StdOut)
            END DO
         END DO
      END DO
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_4d_INTEGER_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_1d_real_array( LU, key, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n
   REAL (wp), INTENT (IN)         :: array(n)
   INTEGER                        :: i, ierr
   REAL (wp), EXTERNAL            :: dnrm2_
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   REAL (wp), PARAMETER           :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp
   CHARACTER (LEN=20)             :: FMTR='(5ES22.14)'
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'

   ierr=0
   IF (n<=0) THEN
      CALL WarningMessage(1,'write_1d_real_array:: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF (dnrm2_(n,array,1)<=MINIMAL_REAL) THEN
      CALL WarningMessage(1,'write_1d_real_array:: all array elements are zero = 0.0')
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n
      WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) (array(i),i=1,n)
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_1d_real_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n
      WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) (array(i),i=1,n)
      IF (ierr /= 0) CALL WarningMessage(1,'write_1d_real_array:: Something went wrong writing data')
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_1d_real_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_2d_real_array( LU, key, n1, n2, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2
   REAL (wp), INTENT (IN)         :: array(n1,n2)
   INTEGER                        :: i, j, ierr
   REAL (wp), EXTERNAL            :: dnrm2_
   LOGICAL, INTENT (IN)           :: dbg
   REAL (wp), PARAMETER           :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   CHARACTER (LEN=20)             :: FMTR='(5ES22.14)'
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'

   ierr=0
   IF ( (n1<=0) .OR. (n2<=0) ) THEN
      CALL WarningMessage(1,'write_2d_real_array:: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF (dnrm2_(n1*n2,array,1)<=MINIMAL_REAL) THEN
      CALL WarningMessage(1,'write_2d_real_array:: all array elements are zero = 0.')
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2
      DO i=1,n1
         WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) (array(i,j),j=1,n2)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'write_2d_real_array:: Something went wrong writing the array.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'write_2d_real_array::  i =',i
         IF (dbg) FLUSH (StdOut)
      END DO
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_2d_real_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2
      DO i=1,n1
         WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) (array(i,j),j=1,n2)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'write_2d_real_array:: Something went wrong writing data.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'write_2d_real_array::  i =',i
         IF (dbg) FLUSH (StdOut)
      END DO
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_2d_real_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_3d_real_array( LU, key, n1, n2, n3, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3
   REAL (wp), INTENT (IN)         :: array(n1,n2,n3)
   INTEGER                        :: i, j, k, ierr
   REAL (wp), EXTERNAL            :: dnrm2_
   LOGICAL, INTENT (IN)           :: dbg
   REAL (wp), PARAMETER           :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=500)            :: line
   CHARACTER (LEN=20)             :: FMTR='(5ES22.14)'
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'

   ierr=0
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) ) THEN
      CALL WarningMessage(1,'write_3d_real_array:: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF (dnrm2_(n1*n2*n3,array,1) <= MINIMAL_REAL) THEN
      CALL WarningMessage(1,'write_3d_real_array:: all array elements are zero = 0.')
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3
      DO i=1,n1
         DO j=1,n2
            WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) (array(i,j,k),k=1,n3)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'write_3d_real_array:: Something went wrong writing the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'write_3d_real_array::  i,j =',i,j
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_3d_real_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3
      DO i=1,n1
         DO j=1,n2
            WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) (array(i,j,k),k=1,n3)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'write_3d_real_array:: Something went wrong writing the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'write_3d_real_array::  i,j =',i,j
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_3d_real_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_4d_real_array( LU, key, n1, n2, n3, n4, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3, n4
   REAL (wp), INTENT (IN)         :: array(n1,n2,n3,n4)
   INTEGER                        :: i, j, k, l, ierr
   REAL (wp), EXTERNAL            :: dnrm2_
   REAL (wp), PARAMETER           :: MINIMAL_REAL=TINY(0.0_wp)*10.0_wp
   INTEGER, PARAMETER             :: StdOut = 6
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=500)            :: line
   CHARACTER (LEN=20)             :: FMTR='(5ES22.14)'
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'

   ierr=0
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) .OR. (n4<=0) ) THEN
      CALL WarningMessage(1,'write_4d_real_array:: nothing to write. Array size = 0.')
      RETURN
   END IF
   IF (dnrm2_(n1*n2*n3*n4,array,1) <= MINIMAL_REAL) THEN
      CALL WarningMessage(1,'write_4d_real_array:: all array elements are zero = 0.')
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3, n4
      DO i=1,n1
         DO j=1,n2
            DO k=1,n3
               WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) (array(i,j,k,l),l=1,n4)
               IF (ierr /= 0) THEN
                  CALL WarningMessage(2,'write_4d_real_array:: Something went wrong reading the array.')
               END IF
               IF (dbg) WRITE (StdOut,*) 'write_4d_real_array::  i,j,k =',i,j,k
               IF (dbg) FLUSH (StdOut)
            END DO
         END DO
      END DO
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_4d_real_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3, n4
      DO i=1,n1
         DO j=1,n2
            DO k=1,n3
               WRITE ( LU, FMT=FMTR, IOSTAT=ierr ) (array(i,j,k,l),l=1,n4)
               IF (ierr /= 0) THEN
                  CALL WarningMessage(2,'write_4d_real_array:: Something went wrong writting the array.')
               END IF
               IF (dbg) WRITE (StdOut,*) 'write_4d_real_array::  i,j,k =',i,j,k
               IF (dbg) FLUSH (StdOut)
            END DO
         END DO
      END DO
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_4d_real_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_1d_complex_array( LU, key, n, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n
   COMPLEX (wp), INTENT (IN)      :: array(n)
   INTEGER                        :: i, ierr
   LOGICAL, INTENT (IN)           :: dbg
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'
   CHARACTER (LEN=20)             :: FMTC='(3(2ES22.14))'
   CHARACTER (LEN=500)            :: line

   ierr=0
   IF (n<=0) THEN
      CALL WarningMessage(1,'write_1d_complex_array:: nothing to write. Array size = 0.')
      RETURN
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n
      WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) (array(i),i=1,n)
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_1d_complex_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n
      WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) (array(i),i=1,n)
      IF (ierr /= 0) CALL WarningMessage(1,'write_1d_complex_array:: Something went wrong writing data')
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_1d_complex_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_2d_complex_array( LU, key, n1, n2, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2
   COMPLEX (wp), INTENT (IN)      :: array(n1,n2)
   INTEGER                        :: i, j, ierr
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'
   CHARACTER (LEN=20)             :: FMTC='(3(2ES22.14))'
   CHARACTER (LEN=500)            :: line

   ierr=0
   IF ( (n1<=0) .OR. (n2<=0) ) THEN
      CALL WarningMessage(1,'write_2d_complex_array:: nothing to write. Array size = 0.')
      RETURN
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2
      DO i=1,n1
         WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) (array(i,j),j=1,n2)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'write_2d_complex_array:: Something went wrong writing the array.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'write_2d_complex_array::  i =',i
         IF (dbg) FLUSH (StdOut)
      END DO
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_2d_complex_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2
      DO i=1,n1
         WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) (array(i,j),j=1,n2)
         IF (ierr /= 0) THEN
            CALL WarningMessage(2,'write_2d_complex_array:: Something went wrong writing data.')
         END IF
         IF (dbg) WRITE (StdOut,*) 'write_2d_complex_array::  i =',i
         IF (dbg) FLUSH (StdOut)
      END DO
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_2d_complex_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_3d_complex_array( LU, key, n1, n2, n3, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3
   COMPLEX (wp), INTENT (IN)      :: array(n1,n2,n3)
   INTEGER                        :: i, j, k, ierr
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'
   CHARACTER (LEN=20)             :: FMTC='(3(2ES22.14))'
   CHARACTER (LEN=500)            :: line

   ierr=0
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) ) THEN
      CALL WarningMessage(1,'write_3d_complex_array:: nothing to write. Array size = 0.')
      RETURN
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3
      DO i=1,n1
         DO j=1,n2
            WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) (array(i,j,k),k=1,n3)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'write_3d_complex_array:: Something went wrong writing the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'write_3d_complex_array::  i,j =',i,j
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_3d_complex_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3
      DO i=1,n1
         DO j=1,n2
            WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) (array(i,j,k),k=1,n3)
            IF (ierr /= 0) THEN
               CALL WarningMessage(2,'write_3d_complex_array:: Something went wrong writing the array.')
            END IF
            IF (dbg) WRITE (StdOut,*) 'write_3d_complex_array::  i,j =',i,j
            IF (dbg) FLUSH (StdOut)
         END DO
      END DO
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_3d_complex_array

!--------------------------------------------------------------------------------------------------!
SUBROUTINE write_4d_complex_array( LU, key, n1, n2, n3, n4, array, dbg )
   IMPLICIT NONE
   INTEGER, PARAMETER             :: wp = kind(0.d0)
   INTEGER, INTENT (IN)           :: LU
   CHARACTER (LEN=*), INTENT (IN) :: key
   INTEGER, INTENT (IN)           :: n1, n2, n3, n4
   COMPLEX (wp), INTENT (IN)      :: array(n1,n2,n3,n4)
   INTEGER                        :: i, j, k, l, ierr
   LOGICAL, INTENT (IN)           :: dbg
   INTEGER, PARAMETER             :: StdOut = 6
   CHARACTER (LEN=20)             :: FMTI='(20(I0,1x))'
   CHARACTER (LEN=20)             :: FMTC='(3(2ES22.14))'
   CHARACTER (LEN=500)            :: line

   ierr=0
   IF ( (n1<=0) .OR. (n2<=0) .OR. (n3<=0) .OR. (n4<=0) ) THEN
      CALL WarningMessage(1,'write_4d_complex_array:: nothing to write. Array size = 0.')
      RETURN
   END IF

   REWIND ( LU )
   CALL file_advance_to_string( LU, key, line, ierr, dbg )

   ! if key is found, THEN rewrite the data
   IF ( ierr == 0 ) THEN
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3, n4
      DO i=1,n1
         DO j=1,n2
            DO k=1,n3
               WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) (array(i,j,k,l),l=1,n4)
               IF (ierr /= 0) THEN
                  CALL WarningMessage(2,'write_4d_complex_array:: Something went wrong reading the array.')
               END IF
               IF (dbg) WRITE (StdOut,*) 'write_4d_complex_array::  i,j,k =',i,j,k
               IF (dbg) FLUSH (StdOut)
            END DO
         END DO
      END DO
   ! if the keyword is not found, THEN append the new keyword and data
   ELSE IF (ierr /= 0 ) THEN
      WRITE ( LU, FMT='(A)', IOSTAT=ierr )
      WRITE ( LU, FMT='(A)', IOSTAT=ierr ) trim(key)
      IF (ierr /= 0) CALL WarningMessage(1,'write_4d_complex_array:: Something went wrong writing key'//trim(key))
      WRITE ( LU, FMT=FMTI, IOSTAT=ierr ) n1, n2, n3, n4
      DO i=1,n1
         DO j=1,n2
            DO k=1,n3
               WRITE ( LU, FMT=FMTC, IOSTAT=ierr ) (array(i,j,k,l),l=1,n4)
               IF (ierr /= 0) THEN
                  CALL WarningMessage(2,'write_4d_complex_array:: Something went wrong writting the array.')
               END IF
               IF (dbg) WRITE (StdOut,*) 'write_4d_complex_array::  i,j,k =',i,j,k
               IF (dbg) FLUSH (StdOut)
            END DO
         END DO
      END DO
   END IF
   WRITE ( LU, FMT=*, IOSTAT=ierr )
   FLUSH ( LU )
   RETURN
END SUBROUTINE write_4d_complex_array

!END MODULE io_data

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION IOCTP2_MCLR(STRING,NEL,ITYP)
*
* Obtain occupation type for STRING .
* For forbidden strings a zero is returned
*
* New version allowing general set of strings
*
#include "detdim.fh"
*. Specific input
      INTEGER  STRING(*)
      Logical Reduce_Prt
      External Reduce_Prt
*. General input
#include "strinp_mclr.fh"
#include "orbinp_mclr.fh"
*
      IF(ITYP.LE.0) THEN
        Write (6,*) 'IOCTP2: ITYP.LE.0'
        Write (6,*) 'ITYP=',ITYP
************************************************************************
*     The argument iPL was missing so I inserted this piece inside the
*     stars to calculate it the same way as in the start of mclr.f
*     //Jonas B
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=iPL-1
*                                                                      *
************************************************************************
*                                                                      *
        Call PrInp_MCLR(iPL)
        Call Abend()
      END IF
*. Number of electrons in RAS1 and RAS 3
      IEL1 = 0
      IEL3 = 0
      DO 20 IEL = 1,NEL
        IF(STRING(IEL) .LE. NORB1) IEL1 = IEL1 +1
        IF(NORB1+NORB2+1 .LE. STRING(IEL)) IEL3 = IEL3 + 1
20    CONTINUE
*. Type
      IF((IEL1.GE.MNRS1(ITYP).AND.IEL1.LE.MXRS1(ITYP)).AND.
     *   (IEL3.GE.MNRS3(ITYP).AND.IEL3.LE.MXRS3(ITYP))) THEN
          ITYP2 = (MXRS1(ITYP)-IEL1)
     *         * (MXRS3(ITYP)-MNRS3(ITYP)+1 )
     *         + IEL3-MNRS3(ITYP)+1
      ELSE
          ITYP2 = 0
      END IF
      IOCTP2_MCLR = ITYP2
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Prpt_old(nirrep,nbas,ndim,n2dim,vec,occ)
!***********************************************************************
!                                                                      *
! Purpose: calculation of expectation values of different              *
!          operators as available on the 'ONEINT' file                 *
!                                                                      *
! Caution: before calling this subroutine one needs to                 *
!          open the ONEINT file                                        *
!                                                                      *
! Calling parameters:                                                  *
!                                                                      *
!   nIrRep            number of irreducible representations            *
!   nBas(0:nIrRep)    number of basis functions in each repre-         *
!                     sentation                                        *
!   ndim              total number of basis functions                  *
!   n2dim             sum(i,i=0,nirrep-1)(nbas(i)**2): elements        *
!                     of all vectors in all representations            *
!   vec(n2dim)        eigenvectors, all for each representation        *
!   occ(ndim)         occupation number for all eigenvectors           *
!                                                                      *
! 1991 R. Lindh, Dept. of Theor. Chem. Univ. of Lund, Sweden.          *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nirrep, nbas(0:nirrep), ndim, n2dim
real(kind=wp), intent(in) :: vec(n2dim), occ(ndim)
integer(kind=iwp) :: i, iComp, iCount, idum(1), iEF, ii, il, iOcc, iopt, ir, irc, iSmLbl, iVec, j, jCount, jRC, maxCen, maxGG, &
                     mDim, mInt, nblock, nComp, nfblock
real(kind=wp) :: C1(3), C2(3), dummy
logical(kind=iwp) :: short, NxtOpr, ifallorb
character(len=8) :: label
real(kind=wp), allocatable :: Den(:), El(:), Nuc(:), Opr(:)

write(u6,*)
call CollapseOutput(1,'   Molecular properties:')
write(u6,'(3X,A)') '   ---------------------'
write(u6,*)
short = .true.
ifallorb = .false.
mDim = 1

nblock = 0
do i=0,nirrep-1
  nblock = nblock+nbas(i)*(nbas(i)+1)/2
end do
nfblock = ndim*(ndim+1)/2

! calculate the density matrix with all off-diagonal elements
! multipled by 2

call mma_allocate(Den,nblock,label='Den')
Den(:) = Zero
iCount = 1
iVec = 0
iOcc = 0
do i=0,nIrrep-1
  do ii=1,nBas(i)
    iOcc = iOcc+1
    jCount = iCount
    do il=1,nBas(i)
      do ir=1,il-1
        Den(jCount) = Den(jCount)+Two*Vec(iVec+il)*Vec(iVec+ir)*Occ(iOcc)
        jCount = jCount+1
      end do
      Den(jCount) = Den(jCount)+Vec(iVec+il)*Vec(iVec+il)*Occ(iOcc)
      jCount = jCount+1
    end do
    iVec = iVec+nBas(i)
  end do
  iCount = iCount+nbas(i)*(nBas(i)+1)/2
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Scan the ONEINT file for multipole moment operators

call mma_allocate(Opr,nfblock+4,label='Opr')

!write(u6,*) ' Starting scan of ONEINT for multipole moments'
do i=1,99
  NxtOpr = .false.
  nComp = (i+1)*(i+2)/2
  if (allocated(Nuc)) call mma_deallocate(Nuc)
  call mma_allocate(Nuc,nComp,label='Nuc')
  if (allocated(El)) call mma_deallocate(El)
  call mma_allocate(El,nComp,label='El')

  Nuc(:) = Zero
  El(:) = Zero
  write(label,'(a,i2)') 'MLTPL ',i
  do iComp=1,nComp
    irc = -1
    iopt = 1
    call iRdOne(irc,iopt,label,iComp,idum,iSmLbl)
    if (irc /= 0) cycle
    mInt = idum(1)
    NxtOpr = .true.
    irc = -1
    iopt = 0
    call RdOne(irc,iopt,label,iComp,Opr,iSmLbl)
    if (irc /= 0) cycle
    if (mInt /= 0) call CmpInt(Opr,mInt,nBas,nIrrep,iSmLbl)
    Nuc(iComp) = Opr(mInt+4)
    if (iComp == 1) C1(:) = Opr(mInt+1:mInt+3)
    if (mInt == 0) cycle
    call Xprop(short,ifallorb,nIrrep,nBas,nBlock,Den,nDim,Occ,nblock,Opr,El(iComp))
  end do
  if (.not. NxtOpr) exit

  call prop(short,label,C1,C1,nirrep,nBas,mDim,occ,dummy,El,Nuc,i,ifallorb)
end do
if (allocated(Nuc)) call mma_deallocate(Nuc)
if (allocated(El)) call mma_deallocate(El)
!                                                                      *
!***********************************************************************
!                                                                      *
! Scan 'ONEINT' for electric field integrals

!write(u6,*) ' Starting scan of ONEINT for various elec. field integrals'

do iEF=0,2
  nComp = (iEF+1)*(iEF+2)/2
  if (allocated(Nuc)) call mma_deallocate(Nuc)
  call mma_allocate(Nuc,nComp,label='Nuc')
  if (allocated(El)) call mma_deallocate(El)
  call mma_allocate(El,nComp,label='El')

  ! loop over different operator origins (max. 9999)

  maxCen = 9999
  do i=1,maxCen
    Nuc(:) = Zero
    El(:) = Zero
    write(label,'(a,i1,i5)') 'EF',iEF,i
    NxtOpr = .false.
    do iComp=1,nComp
      irc = -1
      iopt = 1
      call iRdOne(irc,iopt,label,iComp,idum,iSmLbl)
      if (irc /= 0) cycle
      mInt = idum(1)
      NxtOpr = .true.
      irc = -1
      iopt = 0
      call RdOne(irc,iopt,label,iComp,Opr,iSmLbl)
      if (irc /= 0) cycle
      if (mInt /= 0) call CmpInt(Opr,mInt,nBas,nIrrep,iSmLbl)
      Nuc(iComp) = Opr(mInt+4)
      if (iComp == 1) C1(:) = Opr(mInt+1:mInt+3)
      if (mInt == 0) cycle
      call Xprop(short,ifallorb,nIrrep,nBas,nBlock,Den,nDim,Occ,nblock,Opr,El(iComp))
    end do
    if (.not. NxtOpr) exit

    call prop(short,label,C1,C1,nirrep,nBas,mDim,occ,dummy,El,Nuc,i,ifallorb)
  end do

end do
if (allocated(Nuc)) call mma_deallocate(Nuc)
if (allocated(El)) call mma_deallocate(El)
!                                                                      *
!***********************************************************************
!                                                                      *
!write(u6,*) ' Starting scan of ONEINT diamagnetic shielding'

nComp = 9
call mma_allocate(Nuc,nComp,label='Nuc')
call mma_allocate(El,nComp,label='El')

maxGG = 99
maxCen = 99
! loop over differnt gauge origins (max.99)
do j=1,maxGG
  Nuc(:) = Zero
  El(:) = Zero
  jRC = 0
  ! loop over differnt operator origins (max.99)
  do i=1,maxCen
    write(label,'(a,i2,i2)') 'DMS ',j,i
    NxtOpr = .false.
    do iComp=1,nComp
      irc = -1
      iopt = 1
      call iRdOne(irc,iopt,label,iComp,idum,iSmLbl)
      if (irc /= 0) cycle
      mInt = idum(1)
      NxtOpr = .true.
      irc = -1
      iopt = 0
      call RdOne(irc,iopt,label,iComp,Opr,iSmLbl)
      if (irc /= 0) cycle
      if (mInt /= 0) call CmpInt(Opr,mInt,nBas,nIrrep,iSmLbl)
      Nuc(iComp) = Opr(mInt+4)
      if (iComp == 1) then
        C1(:) = Opr(mInt+1:mInt+3)
        C2(:) = C1(:)
      else if (iComp == 2) then
        C2(:) = Opr(mInt+1:mInt+3)
      end if
      if (mInt == 0) cycle
      call Xprop(short,ifallorb,nIrrep,nBas,nBlock,Den,nDim,Occ,nblock,Opr,El(iComp))
    end do
    if (.not. NxtOpr) exit

    call prop(short,label,C1,C2,nirrep,nBas,mDim,occ,dummy,El,Nuc,i,ifallorb)
    jRC = 1
  end do
  if (jRC == 0) exit
end do
call mma_deallocate(Nuc)
call mma_deallocate(El)
call mma_deallocate(Opr)
call mma_deallocate(Den)
!                                                                      *
!***********************************************************************
!                                                                      *

call CollapseOutput(0,'   Molecular properties:')
write(u6,*)

end subroutine Prpt_old

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
*               Markus P. Fuelscher                                    *
************************************************************************
      SUBROUTINE GUGACTL_m
C
C     PURPOSE: CONTROL ROUTINE TO SET UP GUGA TABLES
C     AUTHOR:  P.-AA. MALMQVIST
C
C     MODIFIED TO FIT THE DETRAS PROGRAM BY M.P. FUELSCHER
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "rasdim.fh"
#include "warnings.h"
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
#include "output_ras.fh"
      Character*16 ROUTINE
      Parameter (ROUTINE='GUGACTL ')
#include "gugx.fh"
#include "WrkSpc.fh"

C Local print level (if any)
      IPRLEV=IPRLOC(3)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
C
C     SET IFCAS FLAG
C     IFCAS = 0 : THIS IS A CAS CALCULATION
C     IFCAS = 1 : THIS IS A RAS CALCULATION
C
      IFCAS=0
      IF (NHOLE1.NE.0.OR.NELEC3.NE.0) IFCAS=1
      DO IS=1,NSYM
        IF (IFCAS.NE.0.AND.NASH(IS).NE.0)IFCAS=IFCAS+1
      END DO
C
C     CREATE THE SYMMETRY INDEX VECTOR
C
      CALL MKNSM_m
C
C     (IFCAS-1) IS THE NUMBER OF SYMMETRIES CONTAINING ACTIVE ORBITALS
C     IF THIS IS GREATER THAN 1 ORBITAL REORDERING INTEGRALS IS REQUIRED
C     SET UP THE REINDEXING TABLE
C
      CALL SETSXCI_m
C
C     FIND TOTAL NUMBER OF VERTICES IN THE SUBSPACES
C
C... for RAS
      NLEV=0
      DO IS=1,NSYM
        NLEV=NLEV+NRS1(IS)
      END DO
      LV1RAS=NLEV
      DO IS=1,NSYM
        NLEV=NLEV+NRS2(IS)
      END DO
      NRAS2=NLEV-LV1RAS
      DO IS=1,NSYM
        NLEV=NLEV+NRS3(IS)
      END DO
C
C     COMPUTE RAS RESTRICTIONS ON VERTICES:
C
      LV3RAS=LV1RAS+NRAS2
      LM1RAS=2*LV1RAS-NHOLE1
      LM3RAS=NACTEL-NELEC3
C
C     COMPUTE TOP ROW OF THE GUGA TABLE
C
      IB0=ISPIN-1
      IA0=(NACTEL-IB0)/2
      IC0=NLEV-IA0-IB0
      IF ( ((2*IA0+IB0).NE.NACTEL) .OR.
     &     (IA0.LT.0) .OR.
     &     (IB0.LT.0) .OR.
     &     (IC0.LT.0) ) then
        Write(LF,*)'GUGACTL Error: Impossible specifications.'
        Write(LF,'(1x,a,3I8)')'NACTEL,NLEV,ISPIN:',NACTEL,NLEV,ISPIN
        Write(LF,'(1x,a,3I8)')'IA0,IB0,IC0:      ',IA0,IB0,IC0
        Write(LF,*)' This is a severe internal error, or possibly'
        Write(LF,*)' indicates a strange input which should have been'
        Write(LF,*)' diagnosed earlier. Please submit a bug report.'
        Call Quit(_RC_GENERAL_ERROR_)
      End If
      IAC=MIN(IA0,IC0)
      NVERT0=((IA0+1)*(IC0+1)*(2*IB0+IAC+2))/2-(IAC*(IAC+1)*(IAC+2))/6
      If ( NVERT0.eq.0 ) then
        NCONF=0
        Goto 100
      End If
C
C     INITIALIZE GUGA TABLES:
C
      CALL MKGUGA_m(NSM,IPRLEV)
      NCONF=NCSF(STSYM)
      If ( NAC.eq.0 ) NCONF=1

100   Continue

      RETURN
      END


      SUBROUTINE CISX_m(IDX,D,DS,PS,PA,SCR)

      IMPLICIT REAL*8 (A-H,O-Z)

      DIMENSION IDX(NAC),D(*),DS(*),PS(*),PA(*),SCR(*)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"

*
* Convert from CI to SX ordering
* Note: A factor of 2 arises because matrices are folded
*
      ITR(I)=I*(I-1)/2

*     one-body density
      IJO=0
      NIJ=ITR(NAC+1)
      NIJKL=ITR(NIJ+1)
      DO I=1,NAC
        DO J=1,I
          INEW=IDX(I)
          JNEW=IDX(J)
          IF (JNEW.GT.INEW)THEN
            JNEW=IDX(I)
            INEW=IDX(J)
          ENDIF
          IJNEW=ITR(INEW)+JNEW
          IJO=IJO+1
          SCR(IJNEW)=D(IJO)
        END DO
      END DO
      CALL DCOPY_(NIJ,SCR,1,D,1)

*     spin density
      IJO=0
      NIJ=ITR(NAC+1)
      NIJKL=ITR(NIJ+1)
      DO I=1,NAC
        DO J=1,I
          INEW=IDX(I)
          JNEW=IDX(J)
          IF (JNEW.GT.INEW)THEN
            JNEW=IDX(I)
            INEW=IDX(J)
          ENDIF
          IJNEW=ITR(INEW)+JNEW
          IJO=IJO+1
          SCR(IJNEW)=DS(IJO)
        END DO
      END DO
      CALL DCOPY_(NIJ,SCR,1,DS,1)

*     symmetrized (iCase=1) and antisymmetrized (iCase=2)
*     two-body density
      DO  ICASE=1,2
      IJKLO=0
      CALL DCOPY_(NACPR2,[0.0D0],0,SCR,1)
      DO I=1,NAC
        DO J=1,I
          INEW=IDX(I)
          JNEW=IDX(J)
          SGN0=1.0D0
          IF (JNEW.GT.INEW)THEN
            JNEW=IDX(I)
            INEW=IDX(J)
            SGN0=-1.0D0
          ENDIF
          IJNEW=ITR(INEW)+JNEW
          DO K=1,I
            LLIM=K
            IF (K.EQ.I)LLIM=J
            DO L=1,LLIM
              IJKLO=IJKLO+1
              KNEW=IDX(K)
              LNEW=IDX(L)
              SGN=SGN0
              IF (LNEW.GT.KNEW)THEN
                KNEW=IDX(L)
                LNEW=IDX(K)
                SGN=-SGN0
              ENDIF
              KLNEW=ITR(KNEW)+LNEW
              IF(KLNEW.GT.IJNEW) THEN
                IJKLN=ITR(KLNEW)+IJNEW
              ELSE
                IJKLN=ITR(IJNEW)+KLNEW
              END IF
              IF(ICASE.EQ.1) THEN
                IF (KLNEW.GT.IJNEW)THEN
                  IF (K.EQ.L.AND.I.NE.J) THEN
                    SCR(IJKLN)=2.0D0*PS(IJKLO)
                  ELSE IF (I.EQ.J.AND.K.NE.L)THEN
                    SCR(IJKLN)=0.5D0*PS(IJKLO)
                  ELSE
                    SCR(IJKLN)=PS(IJKLO)
                  ENDIF
                ELSE
                  SCR(IJKLN)=PS(IJKLO)
                ENDIF
              ELSE
                SCR(IJKLN)=SGN*PA(IJKLO)
              END IF
            END DO
          END DO
        END DO
      END DO
      IF(ICASE.EQ.1) THEN
        CALL DCOPY_(NIJKL,SCR,1,PS,1)
      ELSE
        CALL DCOPY_(NIJKL,SCR,1,PA,1)
      END IF

* End of long loop over ICASE.
      END DO

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Pos_QLast(Disc)
      use definitions, only: iwp, wp, u6, RtoI
      use TList_Mod, only: iTskCan, Not_Used, TskQ, QLast
      Implicit None
      real(kind=wp), intent(inout):: Disc

      Integer(kind=iwp) iWR(2), mInts
      Real(kind=wp) Dummy(1), Quad_ijkl, RST_triplet
      Logical :: Copy=.True., NoCopy=.False.
*
      if(.NOT.Allocated(TskQ)) return

      Quad_ijkl  =TskQ(1,iTskCan)
      RST_triplet=TskQ(2,iTskCan)
      If (Quad_ijkl.eq.Not_Used) Return
*
*---- If already at the right position return
*
      If (Quad_ijkl==QLast(1) .and.
     &    RST_triplet==QLast(2)) Return
*
      Do

         Call iRBuf(iWR,2,Copy)
         Call dRBuf(QLast,2,Copy)
         mInts=iWR(2)
         If (QLast(1)==Quad_ijkl .and.
     &       QLast(2)==RST_triplet) Then
            If (mInts.gt.0) Call dRBuf(Dummy,mInts,NoCopy)
            Disc = Disc + DBLE(2/RtoI + 2 + mInts)
            Return
         Else If (QLast(1)<=Quad_ijkl ) Then
            If (mInts>0) Call dRBuf(Dummy,mInts,NoCopy)
            Disc = Disc + DBLE(2/RtoI + 2 + mInts)
            Cycle
         Else
            Write (u6,*) 'Pos_QLast: batch is lost!'
            Write (u6,'(A,2F10.1)') 'Index,1.0:  ',QLast(1),QLast(2)
            Write (u6,'(A,2F10.1)') 'Looking for ',Quad_ijkl,RST_triplet
            Write (u6,*) ' iTskCan,=',iTskCan
            Call RecPrt('TskQ',' ',TskQ,2,iTskCan)
            Write (u6,*)
            Call Abend()
       End If
*
      End Do

      Write (u6,*) 'Pos_QLast: Fatal problem!'
      Call XFlush(6)
      Call Abend()

      End Subroutine Pos_QLast

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine loopstr_cvb(iocc,indx,nel,norb)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nel, norb
integer(kind=iwp), intent(inout) :: iocc(nel), indx
integer(kind=iwp) :: iel, jel
logical(kind=iwp) :: done

indx = indx+1
! Find electron for which orbital number can be increased:
done = .false.
do iel=1,nel-1
  if (iocc(iel+1) > iocc(iel)+1) then
    done = .true.
    exit
  end if
end do
if (.not. done) then
  iel = nel
  if (iocc(iel) >= norb) then
    call loopstr0_cvb(iocc,indx,nel,norb)
    return
  end if
end if

iocc(iel) = iocc(iel)+1
do jel=1,iel-1
  iocc(jel) = jel
end do

return

end subroutine loopstr_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine SORTA_CPF(BUFOUT,INDOUT,ICAD,IBUFL,TIBUF,ISAB,BUFBI,INDBI,BIAC,BICA,NINTGR)
! SORTS INTEGRALS (AB/CI)
! FOR FIXED B,I ALL A,C
! FIRST CHAIN FOR IJKL

use cpf_global, only: IADABCI, ICH, IFIRST, IPRINT, IROW, KBUF, KBUFF1, LASTAD, LN, Lu_CIGuga, Lu_TiABCI, Lu_TiABIJ, Lu_TraInt, &
                      MADR, NNS, NORB, NSM, NSYM, NTIBUF, NVIRT
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, RtoI

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: BUFOUT(*), TIBUF(NTIBUF), BUFBI(*), BIAC(*), BICA(*)
integer(kind=iwp), intent(_OUT_) :: INDOUT(*), ICAD(*), IBUFL(*), INDBI(*), NINTGR
integer(kind=iwp), intent(in) :: ISAB(*)
#include "tratoc.fh"
integer(kind=iwp) :: I, IACS, IAD15, IAD50, IADD10, IADR, IBUFIJ, ICHK, ICP, ICPP, ICQ, ID, IDISK, IDIV, IIJ, IIN, IJ, IJKL, ILEN, &
                     ILOOP, INND, INS, INSOUT, IOUT, IREC, ITURN, JDISK, KBUF0, KBUF1, KBUF2, KK, KKBUF0, KKBUF1, KKBUF2, KL, &
                     LENGTH, M1, M2, M3, M4, N1, N2, N3, N4, NA, NAC, NAT, NB, NC, NI, NIB, NJ, NK, NL, NOP, NOQ, NOR, NORB0(9), &
                     NORBP, NOS, NOV, NOVST, NSAVE, NSIB, NSP, NSPQ, NSPQR, NSQ, NSR, NSS, NSSM, NT, NTM, NU, NUMAX, NUMIN, NV, &
                     NX, NXM
real(kind=wp) :: FINI
logical(kind=iwp) :: Skip

call COUNT_CPF(NINTGR,NSYM,NORB,MUL)
if (IPRINT >= 2) then
  write(6,*) ' NUMBER OF TWO-ELECTRON INTEGRALS:',NINTGR
end if
IAD50 = 0
call iDAFILE(Lu_TraInt,2,iTraToc,nTraToc,IAD50)
KKBUF0 = (RTOI*(KBUFF1+2)-2)/(RTOI+1)
KKBUF1 = RTOI*KKBUF0+KKBUF0+1
KKBUF2 = KKBUF1+1
NOV = LN*NVIRT+1
if (IFIRST /= 0) NOV = 1
IDISK = 0
KBUF0 = RTOI*KBUF
KBUF1 = KBUF0+KBUF+1
KBUF2 = KBUF1+1
IDIV = RTOI
ID = 0
do IREC=1,NOV
  IBUFL(IREC) = 0
  ICAD(IREC) = ID
  INDOUT(ID+KBUF2) = -1
  ID = ID+KBUF2
end do
NORB0(1) = 0
do I=1,NSYM
  NORB0(I+1) = NORB0(I)+NORB(I)
end do

! TWO-ELECTRON INTEGRALS

do NSP=1,NSYM
  NOP = NORB(NSP)
  do NSQ=1,NSP
    NSPQ = MUL(NSP,NSQ)
    NOQ = NORB(NSQ)
    do NSR=1,NSP
      NSPQR = MUL(NSPQ,NSR)
      NOR = NORB(NSR)
      NSSM = NSR
      if (NSR == NSP) NSSM = NSQ
      do NSS=1,NSSM
        if (NSS /= NSPQR) cycle
        NOS = NORB(NSS)
        NORBP = NOP*NOQ*NOR*NOS
        if (NORBP == 0) cycle
        call dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
        IOUT = 0
        do NV=1,NOR
          NXM = NOS
          if (NSR == NSS) NXM = NV
          do NX=1,NXM
            NTM = 1
            if (NSP == NSR) NTM = NV
            do NT=NTM,NOP
              NUMIN = 1
              if ((NSP == NSR) .and. (NT == NV)) NUMIN = NX
              NUMAX = NOQ
              if (NSP == NSQ) NUMAX = NT
              loop1: do NU=NUMIN,NUMAX
                IOUT = IOUT+1
                if (IOUT > NTIBUF) then
                  call dDAFILE(Lu_TraInt,2,TIBUF,NTIBUF,IAD50)
                  IOUT = 1
                end if
                M1 = ICH(NORB0(NSP)+NT)
                M2 = ICH(NORB0(NSQ)+NU)
                M3 = ICH(NORB0(NSR)+NV)
                M4 = ICH(NORB0(NSS)+NX)
                if ((M1 <= 0) .or. (M2 <= 0) .or. (M3 <= 0) .or. (M4 <= 0)) cycle loop1
                ! ORDER THESE INDICES CANONICALLY
                N1 = max(M1,M2)
                N2 = min(M1,M2)
                N3 = max(M3,M4)
                N4 = min(M3,M4)
                NI = N1
                NJ = N2
                NK = N3
                NL = N4
                if (NI <= NK) then
                  if (NI /= NK) then
                    NI = N3
                    NJ = N4
                    NK = N1
                    NL = N2
                  else if (NJ <= NL) then
                    NL = N2
                    NJ = N4
                  end if
                end if
                FINI = TIBUF(IOUT)
                if (abs(FINI) < 1.0e-9_wp) cycle loop1
                if (NI > LN) then
                  if (NK <= LN) cycle loop1
                  if (NJ > LN) then
                    if (NL > LN) cycle loop1
                    if (IFIRST /= 0) cycle loop1

                    ! ABCI

                    NA = NI-LN
                    NB = NJ-LN
                    NC = NK-LN
                    NI = NL
                    Skip = .false.
                  else
                    Skip = .true.
                  end if
                  do
                    if (Skip) then
                      Skip = .false.
                    else
                      ITURN = 0
                      do
                        NIB = (NI-1)*NVIRT+NB+1
                        IBUFL(NIB) = IBUFL(NIB)+1
                        ICQ = ICAD(NIB)
                        ICP = ICQ/IDIV+IBUFL(NIB)
                        BUFOUT(ICP) = FINI
                        ICPP = ICQ+KBUF0+IBUFL(NIB)
                        INDOUT(ICPP) = (NA-1)*NVIRT+NC
                        if (IBUFL(NIB) >= KBUF) then
                          INDOUT(ICQ+KBUF1) = KBUF
                          JDISK = IDISK
                          call iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),KBUF2,IDISK)
                          INDOUT(ICQ+KBUF2) = JDISK
                          IBUFL(NIB) = 0
                        end if
                        if ((ITURN == 1) .or. (NA == NB)) cycle loop1
                        ITURN = 1
                        NAT = NA
                        NA = NB
                        NB = NAT
                      end do
                    end if
                    if ((NJ <= 0) .or. (NL <= LN)) cycle loop1

                    ! CIAB

                    if (IFIRST /= 0) cycle loop1
                    NA = NK-LN
                    NB = NL-LN
                    NC = NI-LN
                    NI = NJ
                  end do
                end if

                ! IJKL

                IIJ = IROW(NI)+NJ
                KL = IROW(NK)+NL
                IJKL = IIJ*(IIJ-1)/2+KL
                IJ = 1
                IBUFL(IJ) = IBUFL(IJ)+1
                ICQ = ICAD(IJ)
                ICP = ICQ/IDIV+IBUFL(IJ)
                BUFOUT(ICP) = FINI
                ICPP = ICQ+KBUF0+IBUFL(IJ)
                INDOUT(ICPP) = IJKL
                if (IBUFL(IJ) >= KBUF) then
                  INDOUT(ICQ+KBUF1) = KBUF
                  JDISK = IDISK
                  call iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),KBUF2,IDISK)
                  INDOUT(ICQ+KBUF2) = JDISK
                  IBUFL(IJ) = 0
                end if
              end do loop1
            end do
          end do
        end do
      end do
    end do
  end do
end do
! EMPTY LAST BUFFERS
!FUE Start of insertion
if (NOV > MADR) then
  write(u6,*) 'SORTA_CPF Error: NOV > MADR (See code).'
  call Abend()
end if
!FUE End of insertion
do I=1,NOV
  ICQ = ICAD(I)
  INDOUT(ICQ+KBUF1) = IBUFL(I)
  JDISK = IDISK
  call iDAFILE(Lu_TiABIJ,1,INDOUT(ICQ+1),KBUF2,IDISK)
  LASTAD(I) = JDISK
end do

! IJKL

IDISK = 0
IBUFIJ = 0
INDBI(KKBUF2) = -1
IADR = LASTAD(1)
do
  call iDAFILE(Lu_TiABIJ,2,INDOUT,KBUF2,IADR)
  LENGTH = INDOUT(KBUF1)
  IADR = INDOUT(KBUF2)
  do I=1,LENGTH
    IBUFIJ = IBUFIJ+1
    BUFBI(IBUFIJ) = BUFOUT(I)
    INDBI(RTOI*KKBUF0+IBUFIJ) = INDOUT(KBUF0+I)
    if (IBUFIJ >= KKBUF0) then
      INDBI(KKBUF1) = KKBUF0
      JDISK = IDISK
      call iDAFILE(Lu_TiABCI,1,INDBI,KKBUF2,IDISK)
      INDBI(KKBUF2) = JDISK
      IBUFIJ = 0
    end if
  end do
  if (IADR == -1) exit
end do
! EMPTY LAST BUFFER
INDBI(KKBUF1) = IBUFIJ
JDISK = IDISK
call iDAFILE(Lu_TiABCI,1,INDBI,KKBUF2,IDISK)
LASTAD(1) = JDISK

! ABCI

ICHK = 0
IAD15 = IDISK
IADABCI = IAD15
INSOUT = 0
NOVST = 1
IADD10 = IAD10(4)
call dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
call iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
ILEN = ICOP1(nCOP+1)
IIN = 2
NSAVE = ICOP1(IIN)
do
  NI = NSAVE
  IOUT = 0
  Skip = .false.
  do
    IIN = IIN+1
    if (IIN > ILEN) then
      call dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
      call iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
      ILEN = ICOP1(nCOP+1)
      if (ILEN <= 0) then
        Skip = .true.
        exit
      end if
      IIN = 1
    end if
    if (ICHK /= 0) exit
    if (ICOP1(IIN) /= 0) then
      IOUT = IOUT+1
    else
      ICHK = 1
    end if
  end do
  if (.not. Skip) then
    ICHK = 0
    NSAVE = ICOP1(IIN)
  end if
  NIB = (NI-1)*NVIRT+NOVST
  do NB=1,NVIRT
    NSIB = MUL(NSM(LN+NB),NSM(NI))
    INS = NNS(NSIB)
    BIAC(1:INS) = Zero
    BICA(1:INS) = Zero
    NIB = NIB+1
    IADR = LASTAD(NIB)
    do
      call iDAFILE(Lu_TiABIJ,2,INDOUT,KBUF2,IADR)
      LENGTH = INDOUT(KBUF1)
      IADR = INDOUT(KBUF2)
      do KK=1,LENGTH
        INND = INDOUT(KBUF0+KK)
        NA = (INND-1)/NVIRT+1
        NC = INND-(NA-1)*NVIRT
        NAC = (NA-1)*NVIRT+NC
        IACS = ISAB(NAC)
        BIAC(IACS) = BIAC(IACS)+BUFOUT(KK)
        if (NA > NC) BICA(IACS) = BICA(IACS)-BUFOUT(KK)
        if (NA < NC) BICA(IACS) = BICA(IACS)+BUFOUT(KK)
      end do
      if (IADR == -1) exit
    end do
    ILOOP = 0
    do
      do I=1,INS
        INSOUT = INSOUT+1
        if (ILOOP == 0) BUFBI(INSOUT) = BIAC(I)
        if (ILOOP == 1) BUFBI(INSOUT) = BICA(I)
        if (INSOUT >= KBUFF1) then
          call dDAFILE(Lu_TiABCI,1,BUFBI,KBUFF1,IAD15)
          INSOUT = 0
        end if
      end do
      ILOOP = ILOOP+1
      if (ILOOP /= 1) exit
    end do
  end do
  if (ILEN < 0) exit
end do
! EMPTY LAST BUFFER
if (INSOUT /= 0) call dDAFILE(Lu_TiABCI,1,BUFBI,KBUFF1,IAD15)

return

end subroutine SORTA_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      real*8 function  regge3j(
     *j1,     ! integer  2*j1
     *j2,     ! integer  2*j2
     *j3,     ! integer  2*j3
     *m1,     ! integer  2*m1
     *m2,     ! integer  2*m2
     *m3)     ! integer  2*m3
cbs   uses magic square of regge (see Lindner pp. 38-39)
cbs
cbs    ---                                            ---
cbs   |                                                  |
cbs   | -j1+j2+j3     j1-j2+j3         j1+j2-j3          |
cbs   |                                                  |
cbs   |                                                  |
cbs   |  j1-m1        j2-m2            j3-m3             |
cbs   |                                                  |
cbs   |                                                  |
cbs   |  j1+m1        j2+m2            j3+m3             |
cbs   |                                                  |
cbs    ---                                            ---
cbs
      implicit real*8(a-h,o-z)
      dimension MAT(3,3)
CBS   logical testup,testdown
#include "Regge.fh"
cbs  facul,   integer array (nprim,0:mxLinRE) prime-expansion of factorials
cbs  mxLinRE,    integer max. number for facul is given
cbs  nprim,   number of primes for expansion of factorials
cbs  prim,    integer array with the first nprim prime numbers
cbs  iwork)   integer array of size nprim
      regge3j=0d0
c     write(6,'(A24,6I3)') '3J to be calculated for ',
c    *j1,j2,j3,m1,m2,m3
cbs   quick check  if =/= 0 at all
      icheck=m1+m2+m3
      if (icheck.ne.0) then
c     write(6,*) 'sum over m =/= 0'
      return
      endif
cbs   check triangular relation (|j1-j2|<= j3 <= j1+j2 )
      imini=iabs(j1-j2)
      imaxi=j1+j2
      if (j3.lt.imini.or.j3.gt.imaxi) then
c     write(6,*) 'triangular relation not fulfilled'
      return
      endif
cbs   quick check  if =/= 0 at all  end
cbs
cbs   3J-symbol is not zero by simple rules
cbs
cbs   initialize MAT
      MAT(1,1) =-j1+j2+j3
      MAT(2,1) =j1-m1
      MAT(3,1) =j1+m1
      MAT(1,2) =j1-j2+j3
      MAT(2,2) =j2-m2
      MAT(3,2) =j2+m2
      MAT(1,3) =j1+j2-j3
      MAT(2,3) =j3-m3
      MAT(3,3) =j3+m3
      do I=1,3
      do J=1,3
cbs   check for even numbers (2*integer) and positive or zero
      if (mod(MAT(J,I),2).ne.0.or.MAT(J,I).lt.0)  then
c     write(6,*) 'J,I,MAT(J,I): ',J,I,MAT(J,I)
      return
      endif
      MAT(J,I)=MAT(J,I)/2
      if (Mat(j,i).gt.mxLinRE)
     *Call SysAbendMsg('regge3j','increase mxLinRE for regge3j',' ')
      enddo
      enddo
      Isigma=(j1+j2+j3)/2
cbs   check the magic sums
      do I=1,3
      IROW=0
      ICOL=0
      do J=1,3
      IROW=IROW+MAT(I,J)
      ICOL=ICOL+MAT(J,I)
      enddo
      if (IROW.ne.Isigma.or.ICOL.ne.Isigma) then
c     write(6,*) 'I,IROW,ICOL ',I,IROW,ICOL
      return
      endif
      enddo
cbs   if j1+j2+j3 is odd: check for equal rows or columns
      Isign=1
      if (iabs(mod(Isigma,2)).eq.1) then
      isign=-1
         do I=1,3
         do J=I+1,3
            if (MAT(1,I).eq.MAT(1,J).and.
     *         MAT(2,I).eq.MAT(2,J).and.
     *         MAT(3,I).eq.MAT(3,J)) return
            if (MAT(I,1).eq.MAT(J,1).and.
     *         MAT(I,2).eq.MAT(J,2).and.
     *         MAT(I,3).eq.MAT(J,3)) return
         enddo
         enddo
      endif
cbs   look for the lowest element indices: IFIRST,ISECOND
      imini=MAT(1,1)
      IFIRST=1
      ISECOND=1
      do I=1,3
      do J=1,3
      if (MAT(J,I).lt.imini) then
      IFIRST=J
      ISECOND=I
      imini=MAT(J,I)
      endif
      enddo
      enddo
c     write(6,*) 'Matrix before commuting vectors'
      do ibm=1,3
c     write(6,'(3I5)') (Mat(ibm,j),j=1,3)
      enddo
      if (IFIRST.ne.1) then  !interchange rows
c     write(6,*) 'IFIRST = ',ifirst
      do I=1,3
      IDUMMY=MAT(1,I)
      MAT(1,I)=MAT(IFIRST,I)
      MAT(IFIRST,I)=IDUMMY
      enddo
      endif
      if (ISECOND.ne.1) then  !interchange columns
c     write(6,*) 'ISECOND = ',isecond
      do I=1,3
      IDUMMY=MAT(I,1)
      MAT(I,1)=MAT(I,ISECOND)
      MAT(I,ISECOND)=IDUMMY
      enddo
      endif
cbs   lowest element is now on (1,1)
c     write(6,*) 'Matrix after commuting vectors'
c     do ibm=1,3
c     write(6,'(3I5)') (Mat(ibm,j),j=1,3)
c     enddo
cbs   begin to calculate Sum over s_n
cbs   first the simple cases
      if (Mat(1,1).eq.0) then
      isum=1
      elseif (Mat(1,1).eq.1) then
      isum=Mat(2,3)*Mat(3,2)-Mat(2,2)*Mat(3,3)
      elseif (Mat(1,1).eq.2) then
      isum=Mat(2,3)*(Mat(2,3)-1)*Mat(3,2)*(Mat(3,2)-1)-
     *2*Mat(2,3)*Mat(3,2)*Mat(2,2)*Mat(3,3)+
     *Mat(2,2)*(Mat(2,2)-1)*Mat(3,3)*(Mat(3,3)-1)
      else !  all the cases with Mat(1,1) >= 3
              Icoeff=1
              do Ibm=Mat(3,2)-Mat(1,1)+1,Mat(3,2)
                icoeff=icoeff*ibm
              enddo
              do Ibm=Mat(2,3)-Mat(1,1)+1,Mat(2,3)
                icoeff=icoeff*ibm
              enddo
              isum=icoeff
              do Icount=1,MAT(1,1)
                 icoeff=-icoeff*(Mat(1,1)+1-icount)*(Mat(2,2)+1-icount)*
     *           (Mat(3,3)+1-icount)
                 Idenom=icount*(Mat(2,3)-Mat(1,1)+icount)*
     *           (Mat(3,2)-Mat(1,1)+icount)
                 icoeff=icoeff/Idenom
                 isum=isum+icoeff
              enddo
      endif
cbs  additional sign from interchanging rows or columns
      if (ifirst.ne.1) isum=isum*isign
      if (isecond.ne.1) isum=isum*isign
c     write(6,*) 'isum = ',isum
cbs       Mat(2,3)+Mat(3,2)
cbs    (-)
      if (iabs(mod((Mat(2,3)+Mat(3,2)),2)).eq.1) isum=-isum
cbs   final factor
      LIMIT=ihigh(max(Mat(1,1),Mat(1,2),Mat(1,3),
     *Mat(2,1),Mat(2,2),Mat(2,3),Mat(3,1),Mat(3,2),
     *Mat(3,3),(Isigma+1)))
      do I=1,LIMIT
      iwork(I)=facul(I,Mat(1,2))+facul(I,Mat(2,1))+
     *facul(I,Mat(3,1))+facul(I,Mat(1,3))-
     *facul(I,Mat(1,1))-facul(I,Mat(2,2))-
     *facul(I,Mat(3,3))-facul(I,(Isigma+1))-
     *facul(I,Mat(2,3))-facul(I,Mat(3,2))
      enddo
c     write(6,*) 'Iwork: ',(iwork(i),i=1,LIMIT)
      factor=1d0
cbs   iup=1
CBS   idown=1
CBS   testup=.true.
CBS   testdown=.true.
CBS   do I=1,LIMIT
CBS   do J=1,iwork(I)
CBS   iup=iup*prim(i)
CBS   if (iup.lt.0) testup=.false. !check for Integer overflow
CBS   enddo
CBS   Enddo
CBS   up=DBLE(iup)
CBS   if(.not.testup) then ! if the integers did not run correctly
              up=1d0
              do I=1,LIMIT
              do J=1,iwork(I)
              up=up*DBLE(prim(i))
              enddo
              enddo
CBS   endif
CBS   do I=1,LIMIT
CBS   do J=1,-iwork(I)
CBS   idown=idown*prim(i)
CBS   if (idown.lt.0) testdown=.false.
CBS   enddo
CBS   enddo
CBS   down=DBLE(idown)
CBS   if(.not.testdown) then
              down=1d0
              do I=1,LIMIT
              do J=1,-iwork(I)
              down=down*DBLE(prim(i))
              enddo
              enddo
CBS   endif
c     if (.not.(testup.and.testdown)) then
c     write(6,*) 'j1,j2,j3,m1,m2,m3 ',j1,j2,j3,m1,m2,m3
c     write(6,*) 'iup,idown ',iup,idown,'up,down ',up,down
c     endif
      factor=factor*up/down
cbs   final result
      regge3j=sqrt(factor)*DBLE(isum)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Real*8 Function LDF_FittedCharge(PackedD,ip_D)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: compute charge from density using only atom pair blocks
C              as defined by LDF and the fitted overlap matrix,
C              S(uv)=sum_J C(uv,J)*n(J),  n(J)=\int J(r)dr.
C
      Implicit None
      Logical PackedD
      Integer ip_D
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      real*8 ddot_
      external ddot_

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair_wLD
      External LDF_nBas_Atom, LDF_nBasAux_Pair_wLD

      Integer ip_DBlocks
      Integer ip_AuxIntVec
      Integer AB
      Integer A, B
      Integer nAB, nABmax
      Integer ipD
      Integer ip_S, l_S
      Integer ip_C, l_C, l_Cmax

      Real*8 Factor

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      LDF_FittedCharge=0.0d0
      l_Cmax=0
      nABmax=0
      Do AB=1,NumberOfAtomPairs
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
         l_Cmax=max(l_Cmax,nAB*LDF_nBasAux_Pair_wLD(AB))
         nABmax=max(nABmax,nAB)
      End Do
      If (l_Cmax.lt.1) Return
      l_S=nABmax
      Call GetMem('FQS','Allo','Real',ip_S,l_S)
      Call GetMem('FQC','Allo','Real',ip_C,l_Cmax)
      Call LDF_AllocateBlockMatrix('Den',ip_DBlocks)
      Call LDF_Full2Blocked(Work(ip_D),PackedD,ip_DBlocks)
      Call LDF_AllocateAuxBasVector('Int',ip_AuxIntVec)
      Call LDF_ComputeAuxInt(ip_AuxIntVec)
      Do AB=1,NumberOfAtomPairs
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
         l_C=nAB*LDF_nBasAux_Pair_wLD(AB)
         If (l_C.gt.0) Then
            Call LDF_CIO_ReadC_wLD(AB,Work(ip_C),l_C)
            Call LDF_ComputeOverlapFromAuxInt(AB,
     &                                1.0d0,l_C,Work(ip_C),ip_AuxIntVec,
     &                                             0.0d0,nAB,Work(ip_S))
            ipD=iWork(ip_DBlocks-1+AB)
            Factor=1.0d0+dble(min(abs(A-B),1))
            LDF_FittedCharge=LDF_FittedCharge
     &                      +Factor*dDot_(nAB,Work(ipD),1,Work(ip_S),1)
         End If
      End Do
      Call LDF_DeallocateAuxBasVector('Int',ip_AuxIntVec)
      Call LDF_DeallocateBlockMatrix('Den',ip_DBlocks)
      Call GetMem('FQS','Free','Real',ip_S,l_S)
      Call GetMem('FQC','Free','Real',ip_C,l_Cmax)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Jeppe Olsen                                      *
!***********************************************************************

subroutine CNHCNM(HSUB,ISYM,ILCNF,NLCNF,IRCNF,NRCNF,NLCSF,SCR,ICONF,NEL,IREFSM,NAEL,NBEL,NACOB,IPRODT,DTOC,INTSPC,ICOMBI,PSSIGN)
! Calculate  Hamiltonian block defined by configuration
! lists ILCNF,IRCNF
! If ISYM /= 0 only the lower half of the matrix is constructed
!
! Jeppe Olsen April 1990
! ========================
!
! No modifications
! ================

use Index_Functions, only: nTri_Elem
use MCLR_Data, only: NCPCNT, NTYP
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: HSUB(*), SCR(*)
integer(kind=iwp), intent(in) :: ISYM, ILCNF(*), NLCNF, IRCNF(*), NRCNF, NLCSF, ICONF(*), NEL, IREFSM, NAEL, NBEL, NACOB, &
                                 IPRODT(*), INTSPC, ICOMBI
real(kind=wp), intent(in) :: DTOC(*), PSSIGN
integer(kind=iwp) :: ICNL, ICNR, IIL, IILACT, IILB, IIR, IIRACT, IIRB, IIRMAX, ILRI, ILRO, ILTYP, IRTYP, KLFREE, KLPHPS, MDIF0, &
                     MDIF1, MDIF2, MXCSFC, MXR, NCSFL, NCSFR, NDIF0, NDIF1, NDIF2
integer(kind=iwp), allocatable :: iSCR(:,:)

! Length of scratch: MXCSFC                             (used in CNHCNM)
!                  + 2*MXDTFC+MXDTFC**2+MXDTFC+MXCSFC   (used in CNHCN2)
!                  + MAX(MXDTFC*NEL+2*NEL,4*NORB+2*NEL) (used in DIHDJ,CNFSTR)

NDIF0 = 0
NDIF1 = 0
NDIF2 = 0
! Largest configuration block possible
MXCSFC = max(0,maxval(NCPCNT(1:NTYP)))

KLFREE = 1

KLPHPS = KLFREE
KLFREE = KLFREE+MXCSFC**2

call mma_allocate(iSCR,NEL,2,Label='iSCR')

! LHR
IILB = 1
do ICNL=1,NLCNF
  call GETCNF_MCLR(iSCR(:,1),ILTYP,ILCNF(ICNL),ICONF,IREFSM,NEL)
  NCSFL = NCPCNT(ILTYP)
  IIRB = 1
  if (ISYM == 0) then
    MXR = NRCNF
  else
    MXR = ICNL
  end if
  do ICNR=1,MXR
    call GETCNF_MCLR(iSCR(:,2),IRTYP,IRCNF(ICNR),ICONF,IREFSM,NEL)
    NCSFR = NCPCNT(IRTYP)
    call CNHCN2(iSCR(:,1),ILTYP,iSCR(:,2),IRTYP,SCR(KLPHPS),SCR(KLFREE),NEL,NAEL,NBEL,INTSPC,IPRODT,DTOC,NACOB,ICOMBI,PSSIGN, &
                MDIF0,MDIF1,MDIF2)
    NDIF0 = NDIF0+MDIF0
    NDIF1 = NDIF1+MDIF1
    NDIF2 = NDIF2+MDIF2

    ! Copy to HSUB matrix
    if (ISYM /= 0) then
      ! Copy to lower half format
      do IIL=1,NCSFL
        if (IILB == IIRB) then
          IIRMAX = IIL
        else
          IIRMAX = NCSFR
        end if
        do IIR=1,IIRMAX
          IIRACT = IIRB-1+IIR
          IILACT = IILB-1+IIL
          ILRO = nTri_Elem(IILACT-1)+IIRACT
          ILRI = (IIR-1)*NCSFL+IIL
          HSUB(ILRO) = SCR(KLPHPS-1+ILRI)
        end do
      end do
    else
      ! Pack to full format
      do IIL=1,NCSFL
        do IIR=1,NCSFR
          IIRACT = IIRB-1+IIR
          IILACT = IILB-1+IIL
          ILRO = (IIRACT-1)*NLCSF+IILACT
          ILRI = (IIR-1)*NCSFL+IIL
          HSUB(ILRO) = SCR(KLPHPS-1+ILRI)
        end do
      end do
    end if
    IIRB = IIRB+NCSFR
  end do
  IILB = IILB+NCSFL
end do

call mma_deallocate(iSCR)

end subroutine CNHCNM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Sttstc
      Implicit Real*8(a-h,o-z)
#include "cputime.fh"
      Character*50 NamFld(nTotal+1)
      Character*60 Fmt
      Data NamFld
     &    / '1) Calculation of one electron integrals        :',
     &      '2) Calculation of two electron integrals        :',
     &      '     a) Decontraction of two electron density   :',
     &      '     b) Integral evalution & 2nd derivatives    :',
     &      '     c) Screening                               :',
     &      '     d) Transfromation of integrals             :',
     &      '     e) Direct Fock matrix generation           :',
     &      '     f) Direct MO transformation                :',
     &      '3)  Control and input                           :',
     &      '   T O T A L                                    :' /
*---- Write out timing informations
      Fmt='(2x,A)'
      Write(6,*)
      Call CollapseOutput(1,'Statistics and timing')
      Write(6,'(3X,A)')     '---------------------'
      Write(6,*)
      Write(6,Fmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
     &          //' - - - - - - - - -'
      Write(6,Fmt)'   Part of the program                           '
     &          //'   CPU    fraction'
      Write(6,Fmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
     &          //' - - - - - - - - -'
      If (CPUStat(nTotal).gt.0.01D0) Then
         TotCpu=CPUStat(nTotal)
      Else
         TotCpu=0.01D0
      End If
*     TotCpu=max(0.01,CPUStat(nTotal))
      CPUStat(nTwoel)=CPUStat(nIntegrals)+CPUStat(nScreen)+
     &                CPUStat(nTrans)+CPUStat(nTwoDens)+
     &                CPUStat(nFckAck)+CPUStat(nMOTrans)
      Diverse=CPUStat(nTotal)-CPUStat(nTwoEl)-CPUStat(nOneel)

      Do iFld = 1, nTotal - 1
         Write(6,'(2x,A45,2f10.2)')NamFld(iFld),CPUStat(iFld),
     &                             CPUStat(iFld)/TotCpu
      End Do
      Write(6,'(2x,A45,2f10.2)')NamFld(nTotal),diverse,
     &                          diverse/TotCpu

      Write(6,*)
      Write(6,'(2x,A45,2F10.2)')NamFld(nTotal+1),TotCpu
      Write(6,Fmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
     &          //' - - - - - - - - -'
      Call CollapseOutput(0,'Statistics and timing')
      Write(6,*)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_Distrib_Vec(Jin,Jfi,iDV,nV)
      Implicit none
      Integer  Jin, Jfi, nV
      Integer  iDV(*)
#include "cho_para_info.fh"

      Integer J0, J

      If (Cho_Real_Par) Then
         Call Cho_Distrib_Vec(Jin,Jfi,iDV,nV)
      Else
         J0 = Jin - 1
         nV = Jfi - J0
         Do J = 1,nV
            iDV(J) = J0 + J
         End Do
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 FUNCTION OVLMP (NP,ZP,NQ,ZQ)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C         <NP,ZP|NQ,ZQ>
C     Note that both NP and NQ should be either even or odd, but
C     not mixed.
C
C...  auxiliar constant pool:       ready only up to g-valence/g-core
      PARAMETER (lp1=5,lp12=lp1*lp1,lp13=(lp1*lp1+lp1)/2)
      COMMON/CONST/RCA(lp1,lp13),DFAC(lp12),KOSUU(lp13),NYU(lp1,lp13)
      IT11=2*NP
      IT22=2*NQ
      RT1=sqrt(ZP**(IT11+1)*ZQ**(IT22+1))/(DFAC(IT11)*DFAC(IT22))
      RT1=sqrt(RT1)
      IT33=NP+NQ
      ZAV=0.5D0*(ZP+ZQ)
      OVLMP=RT1*DFAC(IT33)/sqrt(ZAV**(IT33+1))
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Dresselhaus                                     *
************************************************************************
      subroutine embPotOutput(nAtoms, mAdDns)
************************************************************************
*                                                                      *
* Object: Calculates and writes out the electrostatic potential on a   *
*         grid.                                                        *
*                                                                      *
* Called from: OneEl                                                   *
*              RASSCF (version below)                                  *
*                                                                      *
* Calling    : GetMem                                                  *
*              IniSewM                                                 *
*              Drv1_Pot                                                *
*              molcas_open                                             *
*              embpot routines                                         *
*                                                                      *
*     Author: Thomas Dresselhaus                                       *
*                                                                      *
************************************************************************

#include "WrkSpc.fh"

#include "embpotdata.fh"
       Real*8 distGpAtom

       Call EmbPotInit(.true.)
!      I dunno whether the coordinates/charges are still stored
!      somewhere, but I'll just read them in again here.
       Call GetMem('Coor','ALLO','REAL',ipCoordsEmb,3*nAtoms)
       Call Get_dArray('Unique Coordinates',Work(ipCoordsEmb),3*nAtoms)
       Call GetMem('Charge','ALLO','REAL',ipChargesEmb,nAtoms)
       Call Get_dArray('Nuclear charge',Work(ipChargesEmb),nAtoms)
!      write(*,*) "Work(mAdDns:+2)=", Work(mAdDns),
!    &             Work(mAdDns+1), Work(mAdDns+2)
!      write(*,*) "Coords of gridpt 1:", Work(posEmbGridCoord),
!    &             Work(posEmbGridCoord+1), Work(posEmbGridCoord+2)
!      write(*,*) "Coords of gridpt 3:", Work(posEmbGridCoord+6),
!    &             Work(posEmbGridCoord+7), Work(posEmbGridCoord+8)
       ! Get the electrostatic potential on the grid
!      write(*,*) "nEmbGridPoints=", nEmbGridPoints
       if (embWriteEsp) then
        Call GetMem('ESP','ALLO','REAL',ipEspGrid,nEmbGridPoints)
!       write(*,*) "Work(ipEspGrid:+2)=", Work(ipEspGrid),
!    &             Work(ipEspGrid+1), Work(ipEspGrid+2)
        call inisewm('mltpl',0)
!       write(*,*) "inisewm done!"
        nordop=0
        Call Drv1_Pot(Work(mAdDns),Work(posEmbGridCoord),
     &               Work(ipEspGrid),nEmbGridPoints,1,nordop)
!       write(*,*) "Coords:"
!       write(*,*) Work(ipCoordsEmb),Work(ipCoordsEmb+1),
!    &            Work(ipCoordsEmb+2)
!       write(*,*) Work(ipCoordsEmb+3),Work(ipCoordsEmb+4),
!    &            Work(ipCoordsEmb+5)
!       write(*,*) Work(ipCoordsEmb+6),Work(ipCoordsEmb+7),
!    &            Work(ipCoordsEmb+8)
!       write(*,*) "----------------------------------------------------"
!       write(*,*) "Charges:"
!       write(*,*) Work(ipChargesEmb),Work(ipChargesEmb+1),
!    &            Work(ipChargesEmb+2)
        iUnitEmb = isFreeUnit(1)
        call molcas_open(iUnitEmb, embOutEspPath)
       end if
       do i=0, nEmbGridPoints-1
        do j=0, nAtoms-1
         distGpAtom=sqrt(
     &              (Work(ipCoordsEmb+3*j)-Work(posEmbGridCoord+3*i))*
     &              (Work(ipCoordsEmb+3*j)-Work(posEmbGridCoord+3*i))+
     &            (Work(ipCoordsEmb+3*j+1)-Work(posEmbGridCoord+3*i+1))*
     &            (Work(ipCoordsEmb+3*j+1)-Work(posEmbGridCoord+3*i+1))+
     &            (Work(ipCoordsEmb+3*j+2)-Work(posEmbGridCoord+3*i+2))*
     &            (Work(ipCoordsEmb+3*j+2)-Work(posEmbGridCoord+3*i+2)))
         if (embWriteEsp) Work(ipEspGrid+i) = Work(ipEspGrid+i)+
     &                       Work(ipChargesEmb+j)/distGpAtom
        end do
        if (embWriteEsp) then
!        write(*,*) "ESP on grid point ", i, ": ",Work(ipEspGrid+i)
         ! Write to file
         write(iUnitEmb,'(e18.10)') (-1.0*Work(ipEspGrid+i))
!         write(iUnitEmb,'(e18.10)') Work(ipEspGrid+i)
        end if
       end do
       if (embWriteEsp) then
        close(iUnitEmb)
        Call GetMem('ESP','FREE','REAL',ipEspGrid,nEmbGridPoints)
       end if
       Call GetMem('Coor','FREE','REAL',ipCoordsEmb,3*nAtoms)
       Call GetMem('Charge','FREE','REAL',ipChargesEmb,nAtoms)
       call embpotfreemem()

      end subroutine


      ! Actually the incoming densities are in an AO basis and treated
      ! as such...
      subroutine embPotOutputMODensities(nAtoms, nSym,
     &             ipDensInact, ipDensAct, nBasPerSym, nBasTotSquare)

#include "WrkSpc.fh"

       Integer nBasTotSquare, nSym
       Integer nBasPerSym(nSym)

       iDensDimPck = 0
       do i=1, nSym
        iDensDimPck = iDensDimPck+((nBasPerSym(i)*(nBasPerSym(i)+1))/2)
       end do

       call GetMem('TotD','ALLO','REAL',ipTotDens,nBasTotSquare)
       call GetMem('TotDp','ALLO','REAL',ipTotDensP,iDensDimPck)

       call dcopy_(nBasTotSquare,Work(ipDensInact),1,Work(ipTotDens),1)
       call daxpy_(nBasTotSquare,1.0d0,Work(ipDensAct),1,Work(ipTotDens)
     &            ,1)
       !Pack density
       iCnt = 0
       iCnt2 = 0
       do i=1, nSym
        do iRow=1, nBasPerSym(i)
         do iCol=1, iRow
          iCnt = iCnt+1
          if (iRow .eq. iCol) then
           Work(ipTotDensP+iCnt-1)=
     &              Work(ipTotDens+(iRow-1)*nBasPerSym(i)+iCol-1+iCnt2)
          else
           Work(ipTotDensP+iCnt-1)=
     &            2*Work(ipTotDens+(iRow-1)*nBasPerSym(i)+iCol-1+iCnt2)
          end if
         end do
        end do
        iCnt2 = iCnt2 + nBasPerSym(i)*nBasPerSym(i)
       end do

       call embPotOutput(nAtoms,ipTotDensP)

       call GetMem('TotD','FREE','REAL',ipTotDens,iDensDim)
       call GetMem('TotDp','FREE','REAL',ipTotDensP,iDensDimPck)

      end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Thermo_VibG(nFreq,Freq,T,P,TotalM,nTR,nsRot,TRotA,TRotB,TRotC,iMult,Energy)

use Constants, only: Zero, One, Two, Half, OneHalf, Pi, auTokcalmol, auTokJ, atmToPa, cal_to_J, hPlanck, kBoltzmann, Rgas, rNAVO
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nFreq, nTR, nsRot, iMult
real(kind=wp), intent(in) :: Freq(nFreq), T, P, TotalM, TRotA, TRotB, TRotC, Energy
integer(kind=iwp) :: i
real(kind=wp) :: beta, Const, CQ_e, dFact, dG_TOT, dH_TOT, dMT, dS_e, dS_rot, dS_TOT, dS_tr, dS_vib, dS_vib_Tot, dU_e, dU_rot, &
                 dU_TOT, dU_tr, dU_vib, dU_vib_Tot, dVM, eta, q_e, q_rot, q_TOT, q_tr, q_vib, q_vib_Tot, ZPVE
real(kind=wp), parameter :: R_gas_kcal = 1.0e-3_wp*Rgas/cal_to_J, rk = kBoltzmann*1.0e-3_wp/auTokJ ! Boltzmann constant in a.u./ K

q_e = One
q_tr = One
q_rot = One
q_vib_Tot = One
dS_e = Zero
dS_tr = Zero
dS_rot = Zero
dS_vib_Tot = Zero
dU_e = Zero
dU_tr = Zero
dU_rot = Zero
dU_vib_Tot = Zero
ZPVE = Zero
q_TOT = One
dS_TOT = Zero
dU_TOT = Zero
dH_TOT = Zero
dG_TOT = Zero

! Electronic Contributions

! Molecular Partition Function
q_e = iMult
! Canonical Partition Function
CQ_e = q_e
! Entropy
dS_e = R_gas_kcal*log(CQ_e)
! Thermal
dU_e = Zero

! Translational Contributions

if (T > Zero) then
  ! Molecular Partition Function (q/V in 1/m^3)
  dFact = (Two*Pi*kBoltzmann/(hPlanck**2*rNAVO*1.0e3_wp))**OneHalf ! ((2*PI*k_B)/(h^2*N_A*1000))^(3/2)
  dMT = (TotalM*1.0e-3_wp)*T  ! m = PM/1000
  q_tr = dFact*dMT
  q_tr = q_tr*sqrt(dMT)
  ! Entropy
  dVM = Rgas/atmToPa*T/P ! Gas Molar Volume / m**3
  Const = log(dFact/rNAVO*1.0e3_wp**OneHalf)+2.5_wp ! ~ 18.605
  dS_tr = 1.0e3_wp*R_gas_kcal*(log(dVM)+OneHalf*(log(T)+log(TotalM*1.0e-3_wp))+Const)
  ! Thermal
  dU_tr = OneHalf*R_gas_kcal*T
end if

! Rotational Contributions

if (T > Zero) then
  ! Molecular Partition Function
  if (nTR == 5) then
    q_rot = T/(nsRot*TRotC)
  else if (nTR == 3) then
    q_rot = One
  else
    q_rot = T*T*T
    q_rot = q_rot/TRotA
    q_rot = q_rot/TRotB
    q_rot = q_rot/TRotC
    q_rot = PI*q_rot
    q_rot = sqrt(q_rot)
    q_rot = q_rot/nsRot
  end if
end if
! Entropy
if (nTR == 5) then
  dS_rot = 1.0e3_wp*R_gas_kcal*(log(q_rot)+One)
else if (nTR == 3) then
  dS_rot = Zero
else
  dS_rot = 1.0e3_wp*R_gas_kcal*(log(q_rot)+OneHalf)
end if
! Thermal
if (nTR == 5) then
  dU_rot = R_gas_kcal*T
else if (nTr == 3) then
  dU_rot = Zero
else
  dU_rot = OneHalf*R_gas_kcal*T
end if

! Vibrational Contributions

if (T == Zero) then
  beta = 1.0e99_wp
else
  beta = One/(rk*T)
end if
do i=1,nFreq
  q_vib = One
  dU_vib = Zero
  dS_vib = Zero
  eta = Freq(i)
  if (eta > Zero) then
    ZPVE = ZPVE+eta*Half
    if (T == Zero) then
      q_vib = One
      dU_vib = eta*Half
      dS_vib = Zero
    else
      ! Eq. (6-20)
      q_vib = exp(-eta*beta*Half)/(One-exp(-eta*beta))
      dU_vib = (eta*Half)+(eta/(exp(eta*beta)-One))
      dS_vib = (eta*beta)/(exp(eta*beta)-One)
      dS_vib = dS_vib-log(One-exp(-eta*beta))
    end if
    q_vib_Tot = q_vib_Tot*q_vib
    dU_vib_Tot = dU_vib_Tot+dU_vib
    dS_vib_Tot = dS_vib_Tot+dS_vib
  end if
end do
dU_vib_Tot = dU_vib_Tot*auTokcalmol
dS_vib_Tot = dS_vib_Tot*R_gas_kcal*1.0e3_wp

q_TOT = q_e*q_tr*q_rot*q_vib_Tot
dS_TOT = dS_e+dS_tr+dS_rot+dS_vib_Tot
dU_TOT = dU_e+dU_tr+dU_rot+dU_vib_Tot
dH_TOT = dU_TOT+R_gas_kcal*T
dG_TOT = dH_TOT-dS_TOT*T*1.0e-3_wp

! Print Results

write(u6,*)
write(u6,'(A)') ' *****************************************************'
write(u6,'(A,F8.2,A,F7.2,A)') ' Temperature = ',T,' kelvin, Pressure =',P,' atm'
write(u6,'(A)') ' -----------------------------------------------------'
write(u6,'(A)') ' Molecular Partition Function and Molar Entropy:'
write(u6,'(A)') '                        q/V (M**-3)    S(kcal/mol*K)'
write(u6,'(A,ES17.6,F13.3)') ' Electronic       ',q_e,dS_e
write(u6,'(A,ES17.6,F13.3)') ' Translational    ',q_tr,dS_tr
write(u6,'(A,ES17.6,F13.3)') ' Rotational       ',q_rot,dS_rot
write(u6,'(A,ES17.6,F13.3)') ' Vibrational      ',q_vib_Tot,dS_vib_Tot
write(u6,'(A,ES17.6,F13.3)') ' TOTAL            ',q_TOT,dS_TOT

write(u6,*)
write(u6,'(A)') ' Thermal contributions to INTERNAL ENERGY:'
write(u6,'(A,F9.3,A,F9.6,A)') ' Electronic       ',dU_e,' kcal/mol     ',dU_e/auTokcalmol,' au.'
write(u6,'(A,F9.3,A,F9.6,A)') ' Translational    ',dU_tr,' kcal/mol     ',dU_tr/auTokcalmol,' au.'
write(u6,'(A,F9.3,A,F9.6,A)') ' Rotational       ',dU_rot,' kcal/mol     ',dU_rot/auTokcalmol,' au.'
write(u6,'(A,F9.3,A,F9.6,A)') ' Vibrational      ',dU_vib_Tot,' kcal/mol     ',dU_vib_Tot/auTokcalmol,' au.'
write(u6,'(A,F9.3,A,F9.6,A)') ' TOTAL            ',dU_TOT,' kcal/mol     ',dU_TOT/auTokcalmol,' au.'
write(u6,*)
write(u6,'(A)') ' Thermal contributions to'
write(u6,'(A,F9.3,A,F9.6,A)') ' ENTHALPY         ',dH_TOT,' kcal/mol     ',dH_TOT/auTokcalmol,' au.'
write(u6,'(A,F9.3,A,F9.6,A)') ' GIBBS FREE ENERGY',dG_TOT,' kcal/mol     ',dG_TOT/auTokcalmol,' au.'
write(u6,*)
write(u6,'(A)') ' Sum of energy and thermal contributions'
write(u6,'(A,17X,F15.6,A)') ' INTERNAL ENERGY  ',Energy+dU_TOT/auTokcalmol,' au.'
write(u6,'(A,17X,F15.6,A)') ' ENTHALPY         ',Energy+dH_TOT/auTokcalmol,' au.'
write(u6,'(A,17X,F15.6,A)') ' GIBBS FREE ENERGY',Energy+dG_TOT/auTokcalmol,' au.'
write(u6,'(A)') ' -----------------------------------------------------'

return

end subroutine Thermo_VibG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Compute_V12(V,V12,nDim)
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
      Real*8 V(nDim,nDim), V12(nDim,nDim)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*
      Call Allocate_Work(ipVec,nDim**2)
      Call Allocate_Work(ipVTri,nDim*(nDim+1)/2)
*
      Call Compute_V12_(V,V12,Work(ipVTri),Work(ipVec),nDim)
*
      Call Free_Work(ipVTri)
      Call Free_Work(ipVec)
*
      Return
      End
      SubRoutine Compute_V12_(V,V12,VTri,Vec,nDim)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 V(nDim,nDim), V12(nDim,nDim), VTri(nDim*(nDim+1)/2),
     &       Vec(nDim,nDim)
*
      Call FZero(Vec,nDim**2)
      call dcopy_(nDim,[One],0,Vec,nDim+1)
*
      Do i = 1, nDim
         Do j = 1, i
            VTri(i*(i-1)/2+j) = V(i,j)
         End Do
      End Do
*
      Call JACOB(VTri,Vec,nDim,nDim)
*
      Call FZero(V12,nDim**2)
      Do i = 1, nDim
#ifdef _DEBUGPRINT_
         tmp=VTri(i*(i+1)/2)
         Write (6,*) 'i,tmp=',i,tmp
#endif
         tmp=Sqrt(VTri(i*(i+1)/2))
         If (tmp.lt.1.0D-90) Then
            V12(i,i)=1.0D90
         Else
            V12(i,i)=One/tmp
         End If
      End Do
*
      Call DGEMM_('N','T',
     &            nDim,nDim,nDim,
     &            1.0d0,V12,nDim,
     &            Vec,nDim,
     &            0.0d0,V,nDim)
      Call DGEMM_('N','N',
     &            nDim,nDim,nDim,
     &            1.0d0,Vec,nDim,
     &            V,nDim,
     &            0.0d0,V12,nDim)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine weight_cvb(ix,nkmin,nkmax,n,nel)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nel, nkmin(0:nel), nkmax(0:nel), n
integer(kind=iwp), intent(out) :: ix(0:nel,0:n)
integer(kind=iwp) :: iel, ik

ix(:,:) = 0
ix(0,0) = 1
do iel=1,nel
  do ik=nkmin(iel),nkmax(iel)
    if (ik /= 0) then
      ix(iel,ik) = ix(iel-1,ik)+ix(iel-1,ik-1)
    else
      ix(iel,ik) = ix(iel-1,ik)
    end if
  end do
end do

return

end subroutine weight_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine oit_sp(rkappa,sigma,i1,i2,r3,p11,r4,p12,D,FA,
     &                  rm1,rm2,focki)
*
*                              ~
*     Constructs  F  = <0|[Q  ,H]|0>
*                  pq       pq
*
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
      Real*8 rkappa(nDensC), sigma(ndensC),FA(ndens2),D(*),
     &       p12(*),p11(*),rm1(*),rm2(*),Focki(*)
      Real*8, Allocatable:: K(:), FAtemp(:), Fock(:), Q(:), Q1(:)
*
      irec(i,j)=i+nna*(j-1)
*
      isym=1
*     sign1  Kappa**t=Sign1*Kappa
*     sign2  <0|[Qip,H]|0>=Aip+sign2*Api
      r1=DBLE(i1)
      Fact=-1.0d0 ! bullshit
      reco=-1.0d0 !(k*a+reco*a*k)
      jspin=1 ! triplet
      Call mma_allocate(K,ndens2,Label='K')
      Call mma_allocate(FAtemp,ndens2,Label='FAtemp')
      Call mma_allocate(Fock,ndens2,Label='Fock')
      Call mma_allocate(Q,ndens2,Label='Q')
      Call mma_allocate(Q1,ndens2,Label='Q1')
      call dcopy_(nmba,[0.0d0],0,rm1,1)
      call dcopy_(nmba,[0.0d0],0,rm2,1)
      call dcopy_(ndens2,[0.0d0],0,Focki,1)
      Q(:)=0.0D0
      Q1(:)=0.0D0
      Call Unc(rkappa,K,isym,r1)

      Call R2ElInt_SP(K,rm1,rm2,
     %             FockI,FAtemp,
     &             nDens2,iSym,ReCo,Fact,jspin,D,FA)
*
*
*
      call dcopy_(ndens2,[0.0d0],0,Fock,1)
*
*
*     Q  = sum(jkl)=(pj|kl)d(ijkl)
*      pi
*
*                          __
*     <o|E(S)  E- E(S) |o>(pb|cd)
*            ab cd    ad
      Call CreQ_sp(Q,rm1,P11,isym)
      Call DSCAL_(ndens,r3,Q,1)

*                             __
*     <o|E(S)  E- E(S) |o>(pb|cd)
*            ab cd   ad
      Call CreQ_sp(Q1,rm2,p12,isym)
      call daxpy_(ndens,r4,Q1,1,Q,1)
*
      Do iS=1,nSym
*
*             A
*      F  =2 F
*       pi    pi
*
       Call DaXpY_(nIsh(is)*nBas(is),-r1*2.0d0,
     &            FAtemp(ipMat(is,is)),1,
     &            Fock(ipMat(is,is)),1)

       Do iAsh=1,nAsh(iS)
        Do jAsh=1,nAsh(is)
         Dij=D(irec(iash+nA(is),jAsh+nA(is)))
         ipF1= ipMat(is,is)+(Nish(is)+iAsh-1)*nBas(is)
         ipF2= ipMat(is,is)+Nish(is)+iAsh-1
         ipFI1=ipMat(is,is)+(Nish(is)+jAsh-1)*nBas(is)
*
*                I
*        F  = F + F  D
*         pa   pa  pb ab
*
          Call DaXpY_(nBas(is),-r1*Dij,
     &               FockI(ipFI1),1,
     &               Fock(ipF1),1)
          Call DaXpY_(nIsh(is),-Dij,
     &               FockI(ipFI1),1,
     &               Fock(ipF2),nbas(is))
        End Do
       End Do
*
*
*      F  = F  + Q
*       pa   pa   pa
*
       Call DaXpY_(nAsh(is)*nBas(is),-r1,
     &            Q(nbas(is)*nish(is)+ipMat(is,is)),1,
     &            Fock(ipMat(is,is)+nBas(is)*nIsh(is)),1)
       Do iA=nish(is),nish(is)+nAsh(is)-1
        Call DaXpY_(nBas(is),-1.0d0,
     &            Q(nbas(is)*ia+ipMat(is,is)),1,
     &            Fock(ipMat(is,is)+iA),nbas(is))

       End Do
       End Do
*
      Call Compress(Fock,Sigma,isym)
*
      Call mma_deallocate(Q1)
      Call mma_deallocate(Q)
      Call mma_deallocate(K)
      Call mma_deallocate(FAtemp)
      Call mma_deallocate(FOck)
*
      return
* Avoid unused argument warnings
      if (.false.) call Unused_integer(i2)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine DecideOnDF(DoDF)
      Implicit None
      Logical DoDF

      Integer iOption

      Call Get_iScalar('System BitSwitch',iOption)
      DoDF=IAND(iOption,1024).eq.1024

#if defined (_DEBUGPRINT_)
      Write(6,*) '>>> Exit from DecideOnDF:'
      Write(6,*) '    System Bit Switch = ',iOption
      Write(6,*) '    DoDF = ',DoDF
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! This defines the highest angular momentum quantum number which
! Seward will be able to treat.

module Define_af

use Definitions, only: wp, iwp

implicit none
private

#ifndef _DEMO_
integer(kind=iwp), parameter :: iTabMx = 15
character, parameter :: AngTp(0:iTabMx) = ['s','p','d','f','g','h','i','k','l','m','n','o','q','r','t','u']
#else
integer(kind=iwp), parameter :: iTabMx = 3
character, parameter :: AngTp(0:iTabMx) = ['s','p','d']
#endif

integer(kind=iwp), parameter :: lab = 2*iTabMx+1, ipMax = lab*(lab+1)*(lab+2)/6
real(kind=wp) :: Binom(0:2*iTabMx,-1:2*iTabMx)
integer(kind=iwp) :: iCan(3,ipMax)

public :: AngTp, Binom, iCan, ipMax, iTabMx, lab

end module Define_af

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!***********************************************************************
!                                                                      *
!-----Data for reaction field calculations.                            *
!                                                                      *
!     lMax: highest angular momentum for multipole expansion           *
!     Eps  : dielectric constant                                       *
!     EpsInf: refraction index                                         *
!     rds: radius of cavity                                            *
!     latato: Gitter type                                              *
!     polsi: site polarizability                                       *
!     dipsi: site dipole moment                                        *
!     radlat: maximum extension of the lattice                         *
!     scala,scalb,scalc: lengths of the cell dimensions                *
!     scaaa: overall scaling                                           *
!     gatom: atoms in the lattice.                                     *
!     diedel: controls deletion of gitter polarizabilities             *
!     tK: Boltzmann factor                                             *
!     clim: convergence threshold for solver                           *
!     afac: controls equation solver (valid values 0.1-0.97)           *
!     nexpo: exponent of the potential with which the QM system kills  *
!            the gitter polarizabilities                               *
!     prefac: scaling of the polarization energies                     *
!     fmax: the square of the largest field in any grid point          *
!                                                                      *
!     PCM: whether to use the PCM solvent model                        *
!     Conductor: whether to use the Conductor-PCM model                *
!     Solvent: the name of the solvent we are using                    *
!             (allowed solvents in datasol.f)                          *
!     ISlPar: 100 integers to pass quickly PCM information             *
!            (defaulted and explained in pcmdef.f)                     *
!     RSlPar: 100 reals to pass quickly PCM information                *
!            (defaulted and explained in pcmdef.f)                     *
!     MxA: maximum number of atoms for the building of PCM cavity      *
!     NSinit: initial number of atomic spheres                         *
!     NS: actual number of spheres (initial+smoothing)                 *
!     nTs: number of surface tesserae                                  *
!     NOrdInp: number of atoms where explicit spheres are centered     *
!     RadInp: radius of spheres explicitly given in the input          *
!                                                                      *
!***********************************************************************

module Rctfld_Module

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: MxA = 1000, MxPar = 100
integer(kind=iwp) :: iCharge_ref, ISlPar(MxPar), latato, lMax = -1, maxa, maxb, maxc, nCavxyz, nexpo, nGrid, nGrid_Eff, &
                     nGridAverage, nGridSeed, NOrdInp(MxA), nPCM_Info, NS, NSinit, nSparse = 0, nTs
real(kind=wp) :: afac, clim = Zero, Cordsi(3,4) = Zero, dampIter = Zero, diedel, dipCutoff = Zero, dipsi = Zero, &
                 distSparse = Zero, Eps, Eps_User, EpsInf, EpsInf_User, fmax, gatom, polsi = Zero, prefac, RadInp(MxA), &
                 radlat = Zero, rds, rotAlpha = Zero, rotBeta = Zero, rotGamma = Zero, rsca, RSlPar(MxPar), RSolv, scaaa, scal14, &
                 scala = Zero, scalb, scalc, tK = Zero, VMol
logical(kind=iwp) :: Conductor, DoDeriv, Done_Lattice, lAmberPol, lDamping, lDiprestart, lFirstIter, LGridAverage, lLangevin, lRF, &
                     lRFCav, LSparse, NonEq_ref, PCM
character(len=32) :: Solvent
real(kind=wp), allocatable :: MM(:,:)

public :: aFac, cLim, Conductor, Cordsi, DampIter, DieDel, DipCutOff, Dipsi, DistSparse, DoDeriv, Done_Lattice, Eps, Eps_USER, &
          EpsInf, EpsInf_USER, fMax, gAtom, iCharge_Ref, ISlPar, lAmberPol, LatAto, lDamping, lDipRestart, lFirstIter, &
          lGridAverage, lLangevin, lMax, lRF, lRFCav, lSparse, MaxA, MaxB, MaxC, MM, MXA, nCavxyz, nExpO, nGrid, nGrid_Eff, &
          nGridAverage, nGridSeed, NonEQ_Ref, nOrdInp, nPCM_Info, nS, nSInit, nSparse, nTS, PCM, PCM_Info_Dmp, PCM_Info_Get, &
          Polsi, PreFac, RadInp, RadLat, RDS, RotAlpha, RotBeta, RotGamma, rSca, RSlPar, RSolv, ScaAA, Scal14, Scala, ScalB, &
          Scalc, Solvent, TK, vMol

contains

subroutine PCM_Info_Dmp()

  integer(kind=iwp) :: i, l_cRF, l_iRF, l_bRF, l_rRF
  integer(kind=iwp), allocatable :: bRF(:), iRF(:)
  real(kind=wp), allocatable :: rRF(:)
  character(len=:), allocatable :: cRF

  l_iRF = 17+size(ISlPar)+size(NOrdInp)
  call mma_allocate(iRF,l_iRF,label='iRF')
  i = 1
  iRF(i) = lMax
  i = i+1
  iRF(i) = latato
  i = i+1
  iRF(i) = nexpo
  i = i+1
  iRF(i) = maxa
  i = i+1
  iRF(i) = maxb
  i = i+1
  iRF(i) = maxc
  i = i+1
  iRF(i) = nCavxyz
  i = i+1
  iRF(i) = nGrid
  i = i+1
  iRF(i) = nGrid_Eff
  i = i+1
  iRF(i) = nSparse
  i = i+1
  iRF(i:i+size(ISlPar)-1) = ISlPar(:)
  i = i+size(ISlPar)
  iRF(i) = NSinit
  i = i+1
  iRF(i) = NS
  i = i+1
  iRF(i) = nTs
  i = i+1
  iRF(i:i+size(NOrdInp)-1) = NOrdInp(:)
  i = i+size(NOrdInp)
  iRF(i) = nPCM_Info
  i = i+1
  iRF(i) = iCharge_ref
  i = i+1
  iRF(i) = nGridAverage
  i = i+1
  iRF(i) = nGridSeed
  call Put_iArray('RFiInfo',iRF,l_iRF)
  call mma_deallocate(iRF)

  l_rRF = 29+size(Cordsi)+size(RSlPar)+size(RadInp)
  call mma_allocate(rRF,l_rRF,label='rRF')
  i = 1
  rRF(i) = EpsInf_User
  i = i+1
  rRF(i) = Eps_User
  i = i+1
  rRF(i) = rds
  i = i+1
  rRF(i:i+size(Cordsi)-1) = pack(Cordsi,.true.)
  i = i+size(Cordsi)
  rRF(i) = polsi
  i = i+1
  rRF(i) = dipsi
  i = i+1
  rRF(i) = radlat
  i = i+1
  rRF(i) = scala
  i = i+1
  rRF(i) = scalb
  i = i+1
  rRF(i) = scalc
  i = i+1
  rRF(i) = scaaa
  i = i+1
  rRF(i) = gatom
  i = i+1
  rRF(i) = diedel
  i = i+1
  rRF(i) = tK
  i = i+1
  rRF(i) = rotAlpha
  i = i+1
  rRF(i) = rotBeta
  i = i+1
  rRF(i) = rotGamma
  i = i+1
  rRF(i) = distSparse
  i = i+1
  rRF(i) = clim
  i = i+1
  rRF(i) = afac
  i = i+1
  rRF(i) = prefac
  i = i+1
  rRF(i) = fmax
  i = i+1
  rRF(i) = rsca
  i = i+1
  rRF(i) = Eps
  i = i+1
  rRF(i) = EpsInf
  i = i+1
  rRF(i) = RSolv
  i = i+1
  rRF(i) = VMol
  i = i+1
  rRF(i:i+size(RadInp)-1) = RadInp(:)
  i = i+size(RadInp)
  rRF(i:i+size(RSlPar)-1) = RSlPar(:)
  i = i+size(RSlPar)
  rRF(i) = dampIter
  i = i+1
  rRF(i) = dipCutoff
  i = i+1
  rRF(i) = scal14
  call Put_dArray('RFrInfo',rRF,l_rRF)
  call mma_deallocate(rRF)

  l_bRF = 14
  call mma_allocate(bRF,l_bRF,label='bRF')
  i = 1
  bRF(i) = merge(1,0,lRF)
  i = i+1
  bRF(i) = merge(1,0,lLangevin)
  i = i+1
  bRF(i) = merge(1,0,PCM)
  i = i+1
  bRF(i) = merge(1,0,Conductor)
  i = i+1
  bRF(i) = merge(1,0,NonEq_ref)
  i = i+1
  bRF(i) = merge(1,0,DoDeriv)
  i = i+1
  bRF(i) = merge(1,0,lRFCav)
  i = i+1
  bRF(i) = merge(1,0,LSparse)
  i = i+1
  bRF(i) = merge(1,0,LGridAverage)
  i = i+1
  bRF(i) = merge(1,0,lDamping)
  i = i+1
  bRF(i) = merge(1,0,lAmberPol)
  i = i+1
  bRF(i) = merge(1,0,Done_Lattice)
  i = i+1
  bRF(i) = merge(1,0,lFirstIter)
  i = i+1
  bRF(i) = merge(1,0,lDiprestart)
  call Put_iArray('RFlInfo',bRF,l_bRF)
  call mma_deallocate(bRF)

  l_cRF = len(Solvent)
  call mma_allocate(cRF,l_cRF,label='cRF')
  i = 1
  cRF(i:i+len(Solvent)-1) = Solvent
  call Put_cArray('RFcInfo',cRF,l_cRF)
  call mma_deallocate(cRF)

end subroutine PCM_Info_Dmp

subroutine PCM_Info_Get()

  integer(kind=iwp) :: i, l_cRF, l_iRF, l_bRF, l_rRF
  integer(kind=iwp), allocatable :: bRF(:), iRF(:)
  real(kind=wp), allocatable :: rRF(:)
  character(len=:), allocatable :: cRF

  l_iRF = 17+size(ISlPar)+size(NOrdInp)
  call mma_allocate(iRF,l_iRF,label='iRF')
  call Get_iArray('RFiInfo',iRF,l_iRF)
  i = 1
  lMax = iRF(i)
  i = i+1
  latato = iRF(i)
  i = i+1
  nexpo = iRF(i)
  i = i+1
  maxa = iRF(i)
  i = i+1
  maxb = iRF(i)
  i = i+1
  maxc = iRF(i)
  i = i+1
  nCavxyz = iRF(i)
  i = i+1
  nGrid = iRF(i)
  i = i+1
  nGrid_Eff = iRF(i)
  i = i+1
  nSparse = iRF(i)
  i = i+1
  ISlPar(:) = iRF(i:i+size(ISlPar)-1)
  i = i+size(ISlPar)
  NSInit = iRF(i)
  i = i+1
  NS = iRF(i)
  i = i+1
  nTs = iRF(i)
  i = i+1
  NOrdInp = iRF(i:i+size(NOrdInp)-1)
  i = i+size(NOrdInp)
  nPCM_Info = iRF(i)
  i = i+1
  iCharge_ref = iRF(i)
  i = i+1
  nGridAverage = iRF(i)
  i = i+1
  nGridSeed = iRF(i)
  call mma_deallocate(iRF)

  l_rRF = 29+size(Cordsi)+size(RSlPar)+size(RadInp)
  call mma_allocate(rRF,l_rRF,label='rRF')
  call Get_dArray('RFrInfo',rRF,l_rRF)
  i = 1
  EpsInf_User = rRF(i)
  i = i+1
  Eps_User = rRF(i)
  i = i+1
  rds = rRF(i)
  i = i+1
  Cordsi(:,:) = reshape(rRF(i:i+size(Cordsi)-1), shape(Cordsi))
  i = i+size(Cordsi)
  polsi = rRF(i)
  i = i+1
  dipsi = rRF(i)
  i = i+1
  radlat = rRF(i)
  i = i+1
  scala = rRF(i)
  i = i+1
  scalb = rRF(i)
  i = i+1
  scalc = rRF(i)
  i = i+1
  scaaa = rRF(i)
  i = i+1
  gatom = rRF(i)
  i = i+1
  diedel = rRF(i)
  i = i+1
  tK = rRF(i)
  i = i+1
  rotAlpha = rRF(i)
  i = i+1
  rotBeta = rRF(i)
  i = i+1
  rotGamma = rRF(i)
  i = i+1
  distSparse = rRF(i)
  i = i+1
  clim = rRF(i)
  i = i+1
  afac = rRF(i)
  i = i+1
  prefac = rRF(i)
  i = i+1
  fmax = rRF(i)
  i = i+1
  rsca = rRF(i)
  i = i+1
  Eps = rRF(i)
  i = i+1
  EpsInf = rRF(i)
  i = i+1
  RSolv = rRF(i)
  i = i+1
  VMol = rRF(i)
  i = i+1
  RadInp(:) = rRF(i:i+size(RadInp)-1)
  i = i+size(RadInp)
  RSlPar(:) = rRF(i:i+size(RSlPar)-1)
  i = i+size(RSlPar)
  dampIter = rRF(i)
  i = i+1
  dipCutoff = rRF(i)
  i = i+1
  scal14 = rRF(i)
  call mma_deallocate(rRF)


  l_bRF = 14
  call mma_allocate(bRF,l_bRF,label='bRF')
  call Get_iArray('RFlInfo',bRF,l_bRF)
  i = 1
  lRF = bRF(i) > 0
  i = i+1
  lLangevin = bRF(i) > 0
  i = i+1
  PCM = bRF(i) > 0
  i = i+1
  Conductor = bRF(i) > 0
  i = i+1
  NonEq_ref = bRF(i) > 0
  i = i+1
  DoDeriv = bRF(i) > 0
  i = i+1
  lRFCav = bRF(i) > 0
  i = i+1
  LSparse = bRF(i) > 0
  i = i+1
  LGridAverage = bRF(i) > 0
  i = i+1
  lDamping = bRF(i) > 0
  i = i+1
  lAmberPol = bRF(i) > 0
  i = i+1
  Done_Lattice = bRF(i) > 0
  i = i+1
  lFirstIter = bRF(i) > 0
  i = i+1
  lDiprestart = bRF(i) > 0
  call mma_deallocate(bRF)

  l_cRF = len(Solvent)
  call mma_allocate(cRF,l_cRF,label='cRF')
  call Get_cArray('RFcInfo',cRF,l_cRF)
  i = 1
  Solvent = cRF(i:i+len(Solvent)-1)
  call mma_deallocate(cRF)

end subroutine PCM_Info_Get

end module Rctfld_Module

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Ben Swerts                                             *
!***********************************************************************

subroutine PrepP_FAIEMP(nBas_Valence,nBT,nBVT)
!***********************************************************************
!                                                                      *
! Object: to set up the handling of the 2nd order density matrix for   *
!         the calculation of the 2-electron FAIEMP derivatives         *
!                                                                      *
!     Author: Ben Swerts                                               *
!                                                                      *
! Based on PrepP                                                       *
!***********************************************************************

use aces_stuff, only: Gamma_On
use pso_stuff, only: CMO, D0, DVar, DS, DSVar, G1, G2, id0Lbl, kCMO, lPSO, lsa, mCMo, mDens, mG1, mG2, nDens, nG1, nG2
use Basis_Info, only: nBas
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nBas_Valence(0:7), nBT, nBVT
#include "print.fh"
#include "etwas.fh"
#include "nac.fh"
integer(kind=iwp) :: nFro(0:7), i, iBas, iGo, iIrrep, ij, ipTmp1, iSpin, jBas, nAct, nDens_Valence, nsa, nTst, iRout, iPrint, iComp
logical(kind=iwp) :: lPrint
real(kind=wp) :: CoefX, CoefR
character(len=8) :: RlxLbl, Method
character(len=80) :: KSDFT
real(kind=wp), allocatable :: D1AV(:), Tmp(:)
real(kind=wp), external :: Get_ExFac

!...  Prologue
iRout = 205
iPrint = nPrint(iRout)
lPrint = .true.
iD0Lbl = 1
iComp = 1

nDens = nBT
nDens_Valence = nBVT

lsa = .false.
Gamma_On = .false.
lPSO = .false.

!...  Get the method label
call Get_cArray('Relax Method',Method,8)
nCMo = S%n2Tot
mCMo = S%n2Tot
if (Method == 'KS-DFT  ' .or. Method == 'CASDFT  ') then
  call Get_iScalar('Multiplicity',iSpin)
  call Get_cArray('DFT functional',KSDFT,80)
  call Get_dScalar('DFT exch coeff',CoefX)
  call Get_dScalar('DFT corr coeff',CoefR)
  ExFac = Get_ExFac(KSDFT)
  CoulFac = One
else
  iSpin = 0
  ExFac = One
  CoulFac = One
end if

!... Check the wave function type

!                                                                      *
!***********************************************************************
!                                                                      *
if (Method == 'RHF-SCF ' .or. Method == 'UHF-SCF ' .or. (Method == 'KS-DFT  ' .and. iSpin == 1) .or. Method == 'ROHF    ') then
  if (lPrint) then
    write(u6,*)
    write(u6,'(2A)') ' Wavefunction type: ',Method
    if (Method == 'KS-DFT  ') then
      write(u6,'(2A)') ' Functional type:   ',KSDFT
      write(u6,100) 'Exchange scaling factor',CoefX
      write(u6,100) 'Correlation scaling factor',CoefR
    end if
    write(u6,*)
  end if
!                                                                      *
!***********************************************************************
!                                                                      *
else if (Method == 'Corr. WF') then
  if (lPrint) then
    write(u6,*)
    write(u6,*) ' Wavefunction type: an Aces 2 correlated wavefunction'
    write(u6,*)
  end if
  Gamma_On = .true.
  call Aces_Gamma()
!                                                                      *
!***********************************************************************
!                                                                      *
else if (Method == 'RASSCF  ' .or. Method == 'CASSCF  ' .or. Method == 'CASDFT  ') then

  call Get_iArray('nAsh',nAsh,nIrrep)
  nAct = 0
  do iIrrep=0,nIrrep-1
    nAct = nAct+nAsh(iIrrep)
  end do
  if (nAct > 0) lPSO = .true.

  nDSO = nDens
  mIrrep = nIrrep
  mBas(0:nIrrep-1) = nBas(0:nIrrep-1)
  if (lPrint) then
    write(u6,*)
    write(u6,'(2A)') ' Wavefunction type: ',Method
    if (Method == 'CASDFT  ') write(u6,'(2A)') ' Functional type:   ',KSDFT
    write(u6,*)
  end if
!                                                                      *
!***********************************************************************
!                                                                      *
else if (Method == 'CASSCFSA' .or. Method == 'RASSCFSA') then
  call Get_iArray('nAsh',nAsh,nIrrep)
  nAct = 0
  do iIrrep=0,nIrrep-1
    nAct = nAct+nAsh(iIrrep)
  end do
  if (nAct > 0) lPSO = .true.
  nDSO = nDens
  call Get_iScalar('SA ready',iGo)
  if (iGO == 1) lSA = .true.
  mIrrep = nIrrep
  mBas(0:nIrrep-1) = nBas(0:nIrrep-1)
  if (lPrint .and. lSA) then
    write(u6,*)
    write(u6,'(2A)') ' Wavefunction type: State average ',Method(1:6)
    write(u6,*)
  else if (lPrint) then
    write(u6,*)
    write(u6,'(2A)') ' Wavefunction type: ',Method
  end if
  Method = 'RASSCF  '
!                                                                      *
!***********************************************************************
!                                                                      *
else
  write(u6,*)
  write(u6,*) ' Wavefunction type:',Method
  write(u6,*) ' Illegal type of wave function!'
  write(u6,*) ' ALASKA can not continue'
  write(u6,*)
  call Quit_OnUserError()
end if

!...  Read the (non) variational 1st order density matrix
!...  density matrix in AO/SO basis
nsa = 1
if (lsa) nsa = 4
mDens = nsa
call mma_allocate(D0,nDens,mDens,Label='D0')
call mma_allocate(DVar,nDens,mDens,Label='DVar')
D0(:,:) = Zero
DVar(:,:) = Zero
call Get_D1ao(D0,nDens)
call Get_D1ao_Var(DVar,nDens)

call ReIndexFrag(D0,nDens,nDens_Valence,nBas,nBas_Valence,nIrrep)
call ReIndexFrag(DVar,nDens,nDens_Valence,nBas,nBas_Valence,nIrrep)
call AddFragDens(D0,nDens,nBas_Valence)
call AddFragDens(DVar,nDens,nBas_Valence)

call mma_allocate(DS,nDens,Label='DS')
call mma_allocate(DSVar,nDens,Label='DSVar')
DS(:) = Zero
DSVar(:) = Zero
if (Method == 'UHF-SCF ' .or. Method == 'ROHF    ' .or. Method == 'Corr. WF') then
  call Get_D1sao(DS,nDens)
  call Get_D1sao_Var(DSVar,nDens)
end if

! Unfold density matrix

ij = -1
do iIrrep=0,nIrrep-1
  do iBas=1,nBas(iIrrep)
    do jBas=1,iBas-1
      ij = ij+1
      D0(1+ij,1) = Half*D0(1+ij,1)
      DVar(1+ij,1) = Half*DVar(1+ij,1)
      DS(1+ij) = Half*DS(1+ij)
      DSVar(1+ij) = Half*DSVar(1+ij)
    end do
    ij = ij+1
  end do
end do
if (iPrint >= 99) then
  RlxLbl = 'D1AO    '
  call PrMtrx(RlxLbl,[iD0Lbl],iComp,[1],D0)
  RlxLbl = 'D1AO-Var'
  call PrMtrx(RlxLbl,[iD0Lbl],iComp,[1],DVar)
  RlxLbl = 'DSAO    '
  call PrMtrx(RlxLbl,[iD0Lbl],iComp,[1],DS)
  RlxLbl = 'DSAO-Var'
  call PrMtrx(RlxLbl,[iD0Lbl],iComp,[1],DSVar)
end if

!...  Get the MO-coefficients
if (Method == 'UHF-SCF ' .or. Method == 'ROHF    ' .or. Method == 'Corr. WF') then
  nsa = 2
else
  nsa = 1
  if (lsa) nsa = 2
end if
kCMO = nsa
call mma_allocate(CMO,mCMO,kCMO,Label='CMO')
call Get_CMO(CMO(:,1),mCMO)
if (iPrint >= 99) then
  ipTmp1 = 1
  do iIrrep=0,nIrrep-1
    call RecPrt(' CMO''s',' ',CMO(ipTmp1,1),nBas_Valence(iIrrep),nBas_Valence(iIrrep))
    ipTmp1 = ipTmp1+nBas_Valence(iIrrep)**2
  end do
end if

!...  Get additional information in the case of a RASSCF wave function
!...  Get the number of inactive, active and frozen orbitals
if (lpso) then
  call Get_iScalar('nSym',i)
  call Get_iArray('nIsh',nIsh,i)
  call Get_iArray('nAsh',nAsh,i)
  call Get_iArray('nFro',nFro,i)
  if (iPrint >= 99) then
    write(u6,*) ' nISh=',nISh
    write(u6,*) ' nASh=',nASh
    write(u6,*) ' nFro=',nFro
  end if
  nAct = 0
  nTst = 0
  do iIrrep=0,nIrrep-1
    nAct = nAct+nAsh(iIrrep)
    nTst = nTst+nFro(iIrrep)
  end do
  if (nTst /= 0) then
    write(u6,*)
    write(u6,*) ' No frozen orbitals are allowed!'
    write(u6,*) ' ALASKA can not continue'
    write(u6,*)
    call Quit_OnUserError()
  end if

  !...  Get the one body density for the active orbitals
  !     (not needed for SA-CASSCF)
  nG1 = nAct*(nAct+1)/2
  nsa = 1
  if (lsa) nsa = 0
  mG1 = nsa
  call mma_allocate(G1,nG1,mG1,Label='G1')
  if (nsa > 0) then
    call Get_D1MO(G1(:,1),nG1)
    if (iPrint >= 99) call TriPrt(' G1',' ',G1(:,1),nAct)
  end if

  !...  Get the two body density for the active orbitals
  nG2 = nG1*(nG1+1)/2
  nsa = 1
  if (lsa) nsa = 2
  mG2 = nsa
  call mma_allocate(G2,nG2,mG2,Label='G2')
  call Get_P2MO(G2(:,1),nG2)
  if (iPrint >= 99) call TriPrt(' G2',' ',G2(1,1),nG1)
  if (lsa) then

    ! CMO1 Ordinary CMO's
    !
    ! CMO2 CMO*Kappa

    call Get_LCMO(CMO(:,2),mCMO)
    if (iPrint >= 99) then
      ipTmp1 = 1
      do iIrrep=0,nIrrep-1
        call RecPrt('LCMO''s',' ',CMO(ipTmp1,2),nBas_Valence(iIrrep),nBas_Valence(iIrrep))
        ipTmp1 = ipTmp1+nBas_Valence(iIrrep)**2
      end do
    end if

    ! P are stored as
    !                              _                     _
    !   P1 = <i|e_pqrs|i> + sum_i <i|e_pqrs|i>+<i|e_pqrs|i>
    !   P2 = sum_i <i|e_pqrs|i>

    call Get_PLMO(G2(:,2),nG2)
    call Daxpy_(nG2,One,G2(:,2),1,G2(:,1),1)
    if (iPrint >= 99) call TriPrt(' G2L',' ',G2(:,2),nG1)
    if (iPrint >= 99) call TriPrt(' G2T',' ',G2(:,1),nG1)

    call Get_D2AV(G2(:,2),nG2)
    if (iPrint >= 99) call TriPrt('G2A',' ',G2(:,2),nG2)

    ! Densities are stored as:
    !
    !     ipd0 AO:
    !
    !     D1 = inactive diagonal density matrix
    !                              _                 _
    !     D2 = <i|E_pq|i> + sum_i <i|E_pq|i>+<i|E_pq|i> + sum_i sum_o k_po <i|E_oq|i> +k_oq <i|E_po|i> - 1/2 D1
    !
    !     D3 = sum_i <i|E_pq|i> (active)
    !
    !     D4 = sum_i sum_o k_po <i|E_oq|i> +k_oq <i|E_po|i> (inactive)
    !
    !     G1 = <i|e_ab|i>
    !     G2 = sum i <i|e_ab|i>
    call mma_allocate(Tmp,2*ndens,label='Tmp')
    call Get_D1I(CMO(1,1),D0(1,1),Tmp,nish,nBas_Valence,nIrrep)
    call mma_deallocate(Tmp)

    call dcopy_(nDens_Valence,DVar,1,D0(1,2),1)
    if (.not. isNAC) call daxpy_(ndens,-Half,D0(1,1),1,D0(1,2),1)
    if (iprint > 90) call PrMtrx('D0',[iD0Lbl],iComp,[1],D0)

    ! This is necessary for the kap-lag

    nG1 = nAct*(NAct+1)/2
    call mma_Allocate(D1AV,nG1,Label='D1AV')
    call Get_D1AV(D1AV,nG1)
    call Get_D1A(CMO(1,1),D1AV,D0(1,3),nIrrep,nBas_Valence,nish,nash,nDens_Valence)
    call mma_deallocate(D1AV)

    call Get_DLAO(D0(1,4),nDens)
  end if
  if (iPrint >= 99) call TriPrt(' G2',' ',G2(1,1),nG1)

end if

return

100 format(1X,A26,20X,F18.6)

end subroutine PrepP_FAIEMP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2018, Ignacio Fdez. Galvan                             *
************************************************************************
*  Get_Mass
*
*> @brief
*>   Get (symmetry-unique) atomic masses from RUNFILE
*> @author Ignacio Fdez. Galn&aacute;n
*>
*> @details
*> Place atomic masses (in a.u.) into array \p Mass_All(*).
*>
*> @param[out] Mass   Array of masses
*> @param[in]  nAtoms Number of atoms
************************************************************************
      Subroutine Get_Mass(Mass,nAtoms)
      Implicit None
#include "stdalloc.fh"
      Integer nAtoms,mAtoms,nCent,i
      Real*8 Mass(nAtoms)
      Integer, Dimension (:), Allocatable :: AtoB
      Real*8, Dimension (:), Allocatable :: CentMass
      Logical Found

      Call Get_iScalar('Unique atoms',mAtoms)
      If (mAtoms.ne.nAtoms) Then
        Write (6,*) 'Get_Mass: mAtoms.ne.nAtoms'
        Write (6,*) 'mAtoms=',mAtoms
        Write (6,*) 'nAtoms=',nAtoms
        Call Abend()
      End If
      Call mma_allocate(AtoB,nAtoms)
      Call Get_iArray('Atom -> Basis',AtoB,nAtoms)
      Call Qpg_dArray('Isotopes',Found,nCent)
      If (.not.Found) Then
        Write (6,*) 'Get_Mass: Isotopes array not found'
        Call Abend()
      End If
      Call mma_allocate(CentMass,nCent)
      Call Get_dArray('Isotopes',CentMass,nCent)
      Do i=1,nAtoms
        Mass(i) = CentMass(AtoB(i))
      End Do
      Call mma_deallocate(CentMass)
      Call mma_deallocate(AtoB)

      Return
      End Subroutine Get_Mass

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------
! 1998  PER-AAKE MALMQUIST
! DEPARTMENT OF THEORETICAL CHEMISTRY
! UNIVERSITY OF LUND
! SWEDEN
!--------------------------------------------
! NOTE: This new MKRHS code produces ONLY the
! contravariant components. 980928, P-A Malmqvist
!--------------------------------------------

subroutine MKRHS(IVEC)
! Set up RHS vector of PT2 Linear Equation System, in vector
! number IVEC of LUSOLV. The coupling matrix elements from the
! root state to the 1st order interacting space are computed, as
! combinations of MO integrals.
! This is the RHS vector in contravariant representation.

use caspt2_global, only: FIMO, iPrGlb
use PrintLevel, only: VERBOSE
use caspt2_module, only: NASHT, NOMX
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: NERI, NFIMO
real(kind=wp), pointer :: ERI0(:), ERI1(:), ERI2(:), SCR(:)
real(kind=wp), allocatable, target :: ERI(:)

if (IPRGLB >= VERBOSE) write(u6,'(1X,A)') ' Using conventional MKRHS algorithm'

! INTEGRAL BUFFERS:
NERI = NOMX**2
call mma_allocate(ERI,3*NERI,Label='ERI')
ERI0(1:2*NERI) => ERI(1:2*NERI)
ERI1(1:NERI) => ERI(1:NERI)
ERI2(1:NERI) => ERI(NERI+1:2*NERI)
SCR(1:NERI) => ERI(2*NERI+1:3*NERI)

if (NASHT > 0) then
  NFIMO = size(FIMO)
  call MKRHSA(IVEC,FIMO,NFIMO,ERI0,2*NERI,SCR,NERI)
  call MKRHSB(IVEC,ERI0,2*NERI,SCR,NERI)
  call MKRHSC(IVEC,FIMO,NFIMO,ERI0,2*NERI,SCR,NERI)
  call MKRHSD(IVEC,FIMO,NFIMO,ERI1,NERI,ERI2,NERI,SCR,NERI)
  call MKRHSE(IVEC,ERI1,NERI,ERI2,NERI,SCR,NERI)
  call MKRHSF(IVEC,ERI1,NERI,ERI2,NERI,SCR,NERI)
  call MKRHSG(IVEC,ERI1,NERI,ERI2,NERI,SCR,NERI)
end if
call MKRHSH(IVEC,ERI1,NERI,ERI2,NERI,SCR,NERI)

nullify(ERI0,ERI1,ERI2,SCR)
call mma_deallocate(ERI)

end subroutine MKRHS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine reprt_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"

      i1 = mstackr_cvb(norb*norb)
      i2 = mstackr_cvb(norb)

      if(lciweights) then
        lc_citmp=lc(5)
      else
C citmp is not used
        lc_citmp=lc(1)
      endif

      call reprt2_cvb(w(lv(1)),w(lv(2)),
     >  w(lc(1)),w(lc(2)),w(lc(3)),w(lc(4)),w(lc_citmp),
     >  w(lp(1)),w(lp(2)),
     >  w(lw(1)),w(lw(2)),w(lw(3)),w(lw(4)),w(lw(5)),w(lw(6)),
     >  w(lw(7)),w(lw(8)),w(lw(9)),w(lw(10)),w(lw(11)),
     >  w(i1),w(i2))
      call mfreer_cvb(i1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
       SubRoutine creqadd(q,G2,idSym,MO,Scr,n2)
*
*      Constructs the Q matrix
*
       Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "standard_iounits.fh"
#include "Pointers.fh"
       Real*8 Q(nDens2),G2(*), MO(n2), Scr(n2)
*                                                                      *
************************************************************************
*                                                                      *
       itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*      Q = (pj|kl)P
*       pi         ijkl
*                                                                      *
************************************************************************
*                                                                      *
       Do iS=1,nSym
          ipS=iEOr(is-1,idsym-1)+1
          if (norb(ips).ne.0) Then
             Do jS=1,nsym
                ijS=iEOR(is-1,js-1)+1
                Do kS=1,nSym
                   ls=iEOr(ijs-1,iEor(ks-1,idsym-1))+1
*                                                                      *
************************************************************************
*                                                                      *
                   Do kAsh=1,nAsh(kS)
                      kAA=kAsh+nIsh(kS)
                      Do lAsh=1,nAsh(lS)
                         lAA=lAsh+nIsh(lS)
                         ikl=nna*(lAsh+nA(lS)-1)+kAsh+nA(kS)
*
*                        Pick up (pj|kl)
*
                         Call Coul(ipS,jS,kS,lS,kAA,lAA,MO,Scr)
*
                         Do iAsh=1,nAsh(iS)
                            iAA=iAsh+nIsh(iS)
                            ipQ=ipMat(ipS,iS)+nOrb(ipS)*(iAA-1)
                            ipM=1+nIsh(jS)*nOrb(ipS)
                            Do jAsh=1,nAsh(jS)
                               iij=nna*(jAsh+nA(jS)-1)+iAsh+nA(iS)
                               ipG=itri(iij,ikl)
                               P_ijkl=G2(ipG)
*
                               Call DaXpY_(nOrb(ipS),P_ijkl,MO(ipM),1,
     &                                     Q(ipQ),1)
                               ipM=ipM+nOrb(ipS)
*
                            End Do
                         End Do
*
                      End Do
                   End Do
*                                                                      *
************************************************************************
*                                                                      *
                End Do  ! kS
             End Do     ! jS
          End If
       End Do           ! iS
*                                                                      *
************************************************************************
*                                                                      *
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function nbfshl(iSkal,irp)
!***********************************************************************
!                                                                      *
!  Integer Function NbfShl    returns # of bf for shell,symmetry       *
!                                                                      *
!***********************************************************************

use iSD_data, only: iSD
use SOAO_Info, only: iAOtSO
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nbfshl
integer(kind=iwp), intent(in) :: iSkal, irp
integer(kind=iwp) :: i, iAO, iCmp

! returns number of basis functions for given shell and symmetry

nbfshl = 0
iAO = iSD(7,iSkal)
iCmp = iSD(2,iSkal)
! loop over components of shell...
do i=1,iCmp
  if (iAOtSO(iAO+i,irp) > 0) nbfshl = nbfshl+iSD(3,iSkal)
end do

return

end function nbfshl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DCORR(JREFX,AREF,ICSPCK,DMO)

use mrci_global, only: ENP, IPRINT, IRC, LN, Lu_27, NREF
use Constants, only: One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JREFX(*), ICSPCK(*)
real(kind=wp), intent(_OUT_) :: AREF(*), DMO(*)
integer(kind=iwp) :: I, IAD27, II1, IJ, IK, INDA, IOC
real(kind=wp) :: FAC, TSUM
integer(kind=iwp), external :: ICUNP

! CORRECTION TO DENSITY MATRIX IN ACPF CASE.
if (IPRINT >= 7) write(u6,*) ' ENP IN DENS =',ENP
FAC = One-(One/ENP)
IAD27 = 0
call dDAFILE(Lu_27,2,AREF,NREF,IAD27)
IK = 0
do INDA=1,IRC(1)
  II1 = (INDA-1)*LN
  if (JREFX(INDA) /= 0) then
    IK = IK+1
    TSUM = AREF(IK)*AREF(IK)*FAC
    IJ = 0
    do I=1,LN
      IOC = (1+ICUNP(ICSPCK,II1+I))/2
      IJ = IJ+I
      DMO(IJ) = DMO(IJ)+IOC*TSUM
    end do
  end if
end do

return

end subroutine DCORR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MMCount(natom,nAtMM,IsMM)
! Count the number of MM atoms

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtom
integer(kind=iwp), intent(out) :: nAtMM, IsMM(nAtom)
integer(kind=iwp) :: iAt, iAtom, iPL, nBla
logical(kind=iwp) :: Exists
integer(kind=iwp), allocatable :: IsMM1(:), NTC(:)
integer(kind=iwp), external :: iPL_espf

iPL = iPL_espf()

call Qpg_iArray('IsMM',Exists,nBla)
if (.not. Exists) then
  write(u6,'(A)') 'MMCount: IsMM not on the runfile'
  call Abend()
end if
if (nBla <= 0) then
  write(u6,'(A,I5)') 'MMCount: IsMM bad length:',nBla
  call Abend()
end if
call mma_allocate(IsMM1,nBla,Label='IsMM1')
call Get_iArray('IsMM',IsMM1,nBla)

call mma_allocate(NTC,natom,Label='NTC')
call Get_iArray('Atom -> Basis',NTC,natom)

do iAtom=1,natom
  IsMM(iAtom) = IsMM1(NTC(iAtom))
end do

call mma_deallocate(NTC)
call mma_deallocate(IsMM1)

nAtMM = 0
do iAt=1,natom
  if (IsMM(iAt) == 1) nAtMM = nAtMM+1
end do

if (nAtMM < 0) then
  write(u6,'(A)') 'Error in MMCount: nAtMM < 0!'
  call Quit_OnUserError()
else if (nAtMM > natom) then
  write(u6,'(A)') 'Error in MMCount: nAtMM >= natom!'
  call Quit_OnUserError()
else if ((nAtMM /= 0) .and. (iPL >= 3)) then
  write(u6,'(A,I5,A)') ' QM/MM: found ',nAtMM,' MM atoms'
end if

return

end subroutine MMCount

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Ignacio Fdez. Galvan                             *
************************************************************************
*
* "False" is a wrapper program that calls an external program and reads
* its output into the runfile.
* It is named after False Island (not False Pass), Alaska.
*
      subroutine False_Program(rc)
      use False_Global, only: Run_Command, Will_Print
      implicit none
      integer, intent(out) :: rc
      character(len=180) :: InFile,OutFile
      integer :: n
      integer, external :: iPrintLevel
      logical, external :: Reduce_Prt
#include "para_info.fh"

      rc = 0

      Will_Print = (iPrintLevel(-1) >= 2) .and. (.not. Reduce_Prt())

      call Read_Input()

      ! only the master process calls the external program
      if (King()) then
        call Write_Input()

        call PrgmTranslate('INPUT',InFile,n)
        call PrgmTranslate('OUTPUT',OutFile,n)
        if (Will_Print) then
          write(6,100) 'Command to run:  '//trim(Run_Command)
          write(6,100) 'First argument:  '//trim(InFile)
          write(6,100) 'Second argument: '//trim(OutFile)
          write(6,*)
        end if
        call CollapseOutput(1, 'External program output')
        call SystemF(trim(Run_Command)
     &     //' '//trim(InFile)//' '//trim(OutFile),rc)
        call CollapseOutput(0, 'External program output')
      end if

#ifdef _MOLCAS_MPP_
      ! files of interest are broadcasted to all slaves
      if (Is_Real_Par()) then
        call GA_Sync()
        call PFGet_ASCII('INPUT')
        call PFGet_ASCII('OUTPUT')
        call GA_Sync()
      end if
#endif

      call Write_Data()
      return

100   format(A)
      end subroutine False_Program

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Steven Vancoillie                                *
!***********************************************************************

subroutine HCOUP_BLK(ICASE,ISYM,NAS,IISTA,IIEND,V1,nV1,V2,nV2,OVL,HEBLK,TG1,TG2,NASHT,TG3,NTG3)
! Compute a contribution to the coupling Hamiltonian element (HEL)
! defined as HEL = < ROOT1 | H * OMEGA | ROOT2 >. The contribution
! arises from the block V_(A,I), with A=1,NAS and I=IISTA,IIEND,
! with A the active superindex and I the inactive superindex. Since
! the inactive superindex is partitioned over processes, each process
! only computes part of the HEL value, which is then sum reduced in the
! calling subroutine.

use Index_Functions, only: nTri_Elem, nTri3_Elem
use SUPERINDEX, only: MTGEU, MTGTU, MTU, MTUV
use caspt2_module, only: NAES, NTGEUES, NTGTUES, NTUES, NTUVES
use Constants, only: Zero, Two, Four, Eight
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ICASE, ISYM, NAS, IISTA, IIEND, NV1, NV2, NASHT, NTG3
real(kind=wp), intent(in) :: V1(NV1), V2(NV2), OVL, TG1(NASHT,NASHT), TG2(NASHT,NASHT,NASHT,NASHT), TG3(NTG3)
real(kind=wp), intent(out) :: HEBLK
integer(kind=iwp) :: IAS, IAS1, IAS2, IASABS, IND1, IND2, IND3, ITABS, ITG3, IUABS, IVABS, IXABS, IYABS, IZABS, JAS, JAS1, JAS2, &
                     JASABS, JND1, JND2, JND3, NAS1, NISBLK
real(kind=wp) :: GUTXY, GUY, SA, SBM, SBP, SBtuxy, SBtuyx, SC, SD11, SD12, SD21, SD22, SE, SFM, SFP, SFtuxy, SFtuyx, SG, TMP
real(kind=wp), external :: DDot_

! The dimension of TG3 is NTG3=(NASHT**2+2 over 3)

HEBLK = Zero

if (IISTA <= 0) return

NISBLK = IIEND-IISTA+1
select case (ICASE)
  !*********************************************************************
  case (1)
    do IAS=1,NAS
      IASABS = NTUVES(ISYM)+IAS
      ITABS = MTUV(1,IASABS)
      IUABS = MTUV(2,IASABS)
      IVABS = MTUV(3,IASABS)
      do JAS=1,NAS
        JASABS = NTUVES(ISYM)+JAS
        IXABS = MTUV(1,JASABS)
        IYABS = MTUV(2,JASABS)
        IZABS = MTUV(3,JASABS)
        ! Compute and use SA(ITABS IUABS IVABS, IXABS IYABS IZABS)
        ! Formulae used:
        !  SA(tuv,xyz) =  -Gvuxtyz -dyu Gvzxt - dyt Gvuxz - dxu Gvtyz - dxu dyt Gvz +2 dtx Gvuyz + 2 dtx dyu Gvz
        ! Gvuxtyz is stored using full permutation symmetry of three pairs
        ! (vu),(xt), and (yz):
        IND1 = IVABS+NASHT*(IUABS-1)
        IND2 = IXABS+NASHT*(ITABS-1)
        IND3 = IYABS+NASHT*(IZABS-1)
        if (IND2 > IND3) then
          if (IND1 > IND2) then
            JND1 = IND1
            JND2 = IND2
            JND3 = IND3
          else if (IND1 > IND3) then
            JND1 = IND2
            JND2 = IND1
            JND3 = IND3
          else
            JND1 = IND2
            JND2 = IND3
            JND3 = IND1
          end if
        else
          if (IND1 > IND3) then
            JND1 = IND1
            JND2 = IND3
            JND3 = IND2
          else if (IND1 > IND2) then
            JND1 = IND3
            JND2 = IND1
            JND3 = IND2
          else
            JND1 = IND3
            JND2 = IND2
            JND3 = IND1
          end if
        end if
        ITG3 = nTri3_Elem(JND1-1)+nTri_Elem(JND2-1)+JND3
        !  SA(tuv,xyz) =  -Gvuxtyz -dyu Gvzxt - dyt Gvuxz - dxu Gvtyz - dxu dyt Gvz +2 dtx Gvuyz + 2 dtx dyu Gvz
        ! Compute TMP=Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
        TMP = TG3(ITG3)
        if (IYABS == IUABS) TMP = TMP+TG2(IVABS,IZABS,IXABS,ITABS)
        if (IYABS == ITABS) then
          TMP = TMP+TG2(IVABS,IUABS,IXABS,IZABS)
          if (IXABS == IUABS) TMP = TMP+TG1(IVABS,IZABS)
        end if
        if (IXABS == IUABS) TMP = TMP+TG2(IVABS,ITABS,IYABS,IZABS)
        ! SA is the negative of this, and then some correction:
        SA = -TMP
        if (IXABS == ITABS) then
          SA = SA+Two*TG2(IVABS,IUABS,IYABS,IZABS)
          if (IYABS == IUABS) SA = SA+Two*TG1(IVABS,IZABS)
        end if
        ! SA has been computed.

        HEBLK = HEBLK+SA*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
  case (4)
    do IAS=1,NAS
      IASABS = NTUVES(ISYM)+IAS
      IXABS = MTUV(1,IASABS)
      IUABS = MTUV(2,IASABS)
      IVABS = MTUV(3,IASABS)
      do JAS=1,NAS
        JASABS = NTUVES(ISYM)+JAS
        ITABS = MTUV(1,JASABS)
        IYABS = MTUV(2,JASABS)
        IZABS = MTUV(3,JASABS)
        ! Compute and use SC(IXABS IUABS IVABS, ITABS IYABS IZABS)
        ! In SBMAT, the formula is written as
        !  SC(tuv,xyz) = Gvutxyz +dyu Gvztx + dyx Gvutz + dtu Gvxyz + dtu dyx Gvz
        ! Rewritten, in order to reuse same quantities as in SA:
        !  SC(xuv,tyz) = Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
        ! Gvuxtyz is stored using full permutation symmetry of three pairs
        ! (vu),(xt), and (yz):
        IND1 = IVABS+NASHT*(IUABS-1)
        IND2 = IXABS+NASHT*(ITABS-1)
        IND3 = IYABS+NASHT*(IZABS-1)
        if (IND2 > IND3) then
          if (IND1 > IND2) then
            JND1 = IND1
            JND2 = IND2
            JND3 = IND3
          else if (IND1 > IND3) then
            JND1 = IND2
            JND2 = IND1
            JND3 = IND3
          else
            JND1 = IND2
            JND2 = IND3
            JND3 = IND1
          end if
        else
          if (IND1 > IND3) then
            JND1 = IND1
            JND2 = IND3
            JND3 = IND2
          else if (IND1 > IND2) then
            JND1 = IND3
            JND2 = IND1
            JND3 = IND2
          else
            JND1 = IND3
            JND2 = IND2
            JND3 = IND1
          end if
        end if
        ITG3 = nTri3_Elem(JND1-1)+nTri_Elem(JND2-1)+JND3
        !  SC(xuv,tyz) (rewritten, swapping x and t)
        !    = Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
        TMP = TG3(ITG3)
        if (IYABS == IUABS) TMP = TMP+TG2(IVABS,IZABS,IXABS,ITABS)
        if (IYABS == ITABS) then
          TMP = TMP+TG2(IVABS,IUABS,IXABS,IZABS)
          if (IXABS == IUABS) TMP = TMP+TG1(IVABS,IZABS)
        end if
        if (IXABS == IUABS) TMP = TMP+TG2(IVABS,ITABS,IYABS,IZABS)
        SC = TMP

        HEBLK = HEBLK+SC*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
  case (2)
    do IAS=1,NAS
      IASABS = NTGEUES(ISYM)+IAS
      ITABS = MTGEU(1,IASABS)
      IUABS = MTGEU(2,IASABS)
      do JAS=1,NAS
        JASABS = NTGEUES(ISYM)+JAS
        IXABS = MTGEU(1,JASABS)
        IYABS = MTGEU(2,JASABS)
        ! Formulae used:
        !    SB(tu,xy)= 2 Gxtyu -4dxt Gyu -4dyu Gxt +2dyt Gxu + 8 dxt dyu -4dxu dyt + 2dxu Gyt
        !    SB(tu,yx)= 2 Gytxu -4dyt Gxu -4dxu Gyt +2dxt Gyu + 8 dyt dxu -4dyu dxt + 2dyu Gxt
        !    SBP(tu,xy)=SB(tu,xy)+SB(tu,yx)
        !    SBM(tu,xy)=SB(tu,xy)-SB(tu,yx)
        SBtuxy = Two*TG2(IXABS,ITABS,IYABS,IUABS)
        SBtuyx = Two*TG2(IYABS,ITABS,IXABS,IUABS)
        if (IXABS == ITABS) then
          SBtuxy = SBtuxy-Four*TG1(IYABS,IUABS)
          SBtuyx = SBtuyx+Two*TG1(IYABS,IUABS)
          if (IYABS == IUABS) then
            SBtuxy = SBtuxy+Eight*OVL
            SBtuyx = SBtuyx-Four*OVL
          end if
        end if
        if (IYABS == IUABS) then
          SBtuxy = SBtuxy-Four*TG1(IXABS,ITABS)
          SBtuyx = SBtuyx+Two*TG1(IXABS,ITABS)
        end if
        if (IYABS == ITABS) then
          SBtuxy = SBtuxy+Two*TG1(IXABS,IUABS)
          SBtuyx = SBtuyx-Four*TG1(IXABS,IUABS)
          if (IXABS == IUABS) then
            SBtuxy = SBtuxy-Four*OVL
            SBtuyx = SBtuyx+Eight*OVL
          end if
        end if
        if (IXABS == IUABS) then
          SBtuxy = SBtuxy+Two*TG1(IYABS,ITABS)
          SBtuyx = SBtuyx-Four*TG1(IYABS,ITABS)
        end if

        SBP = SBtuxy+SBtuyx

        HEBLK = HEBLK+SBP*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
  case (3)
    do IAS=1,NAS
      IASABS = NTGTUES(ISYM)+IAS
      ITABS = MTGTU(1,IASABS)
      IUABS = MTGTU(2,IASABS)
      do JAS=1,NAS
        JASABS = NTGTUES(ISYM)+JAS
        IXABS = MTGTU(1,JASABS)
        IYABS = MTGTU(2,JASABS)
        ! Formulae used:
        !    SB(tu,xy)= 2 Gxtyu -4dxt Gyu -4dyu Gxt +2dyt Gxu + 8 dxt dyu -4dxu dyt + 2dxu Gyt
        !    SB(tu,yx)= 2 Gytxu -4dyt Gxu -4dxu Gyt +2dxt Gyu + 8 dyt dxu -4dyu dxt + 2dyu Gxt
        !    SBP(tu,xy)=SB(tu,xy)+SB(tu,yx)
        !    SBM(tu,xy)=SB(tu,xy)-SB(tu,yx)
        SBtuxy = Two*TG2(IXABS,ITABS,IYABS,IUABS)
        SBtuyx = Two*TG2(IYABS,ITABS,IXABS,IUABS)
        if (IXABS == ITABS) then
          SBtuxy = SBtuxy-Four*TG1(IYABS,IUABS)
          SBtuyx = SBtuyx+Two*TG1(IYABS,IUABS)
          if (IYABS == IUABS) then
            SBtuxy = SBtuxy+Eight*OVL
            SBtuyx = SBtuyx-Four*OVL
          end if
        end if
        if (IYABS == IUABS) then
          SBtuxy = SBtuxy-Four*TG1(IXABS,ITABS)
          SBtuyx = SBtuyx+Two*TG1(IXABS,ITABS)
        end if
        if (IYABS == ITABS) then
          SBtuxy = SBtuxy+Two*TG1(IXABS,IUABS)
          SBtuyx = SBtuyx-Four*TG1(IXABS,IUABS)
          if (IXABS == IUABS) then
            SBtuxy = SBtuxy-Four*OVL
            SBtuyx = SBtuyx+Eight*OVL
          end if
        end if
        if (IXABS == IUABS) then
          SBtuxy = SBtuxy+Two*TG1(IYABS,ITABS)
          SBtuyx = SBtuyx-Four*TG1(IYABS,ITABS)
        end if

        SBM = SBtuxy-SBtuyx

        HEBLK = HEBLK+SBM*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
  case (5)
    NAS1 = NAS/2
    do IAS1=1,NAS1
      IAS2 = IAS1+NAS1
      IASABS = NTUES(ISYM)+IAS1
      ITABS = MTU(1,IASABS)
      IUABS = MTU(2,IASABS)
      do JAS1=1,NAS1
        JAS2 = JAS1+NAS1
        JASABS = NTUES(ISYM)+JAS1
        IXABS = MTU(1,JASABS)
        IYABS = MTU(2,JASABS)
        ! Formulae used:
        !    SD11(tu1,xy1)=2*(Gutxy + dtx Guy)
        !    SD12(tu2,xy1)= -(Gutxy + dtx Guy)
        !    SD21(tu2,xy1)= -(Gutxy + dtx Guy)
        !    SD22(tu2,xy2)= -Gxtuy +2*dtx Guy
        GUTXY = TG2(IUABS,ITABS,IXABS,IYABS)
        SD11 = Two*GUTXY
        SD12 = -GUTXY
        SD21 = -GUTXY
        SD22 = -TG2(IXABS,ITABS,IUABS,IYABS)
        if (ITABS == IXABS) then
          GUY = TG1(IUABS,IYABS)
          SD11 = SD11+Two*GUY
          SD12 = SD12-GUY
          SD21 = SD21-GUY
          SD22 = SD22+Two*GUY
        end if

        HEBLK = HEBLK+SD11*DDOT_(NISBLK,V2(JAS1),NAS,V1(IAS1),NAS)
        HEBLK = HEBLK+SD12*DDOT_(NISBLK,V2(JAS2),NAS,V1(IAS1),NAS)
        HEBLK = HEBLK+SD21*DDOT_(NISBLK,V2(JAS1),NAS,V1(IAS2),NAS)
        HEBLK = HEBLK+SD22*DDOT_(NISBLK,V2(JAS2),NAS,V1(IAS2),NAS)
      end do
    end do
    !*******************************************************************
  case (6)
    do IAS=1,NAS
      ITABS = IAS+NAES(ISYM)
      do JAS=1,NAS
        IXABS = JAS+NAES(ISYM)
        ! Formula used: SE(t,x)=2*dxt - Dxt
        SE = -TG1(IXABS,ITABS)
        if (IXABS == ITABS) SE = SE+Two*OVL
        HEBLK = HEBLK+SE*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
  case (7)
    do IAS=1,NAS
      ITABS = IAS+NAES(ISYM)
      do JAS=1,NAS
        IXABS = JAS+NAES(ISYM)
        ! Formula used: SE(t,x)=2*dxt - Dxt
        SE = -TG1(IXABS,ITABS)
        if (IXABS == ITABS) SE = SE+Two*OVL
        HEBLK = HEBLK+SE*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
  case (8)
    ! ========================================================
    ! Compute and use SFP(ITABS IUABS , IXABS IYABS)
    ! and (later, similar) SFM(ITABS IUABS , IXABS IYABS)
    do IAS=1,NAS
      IASABS = NTGEUES(ISYM)+IAS
      ITABS = MTGEU(1,IASABS)
      IUABS = MTGEU(2,IASABS)
      do JAS=1,NAS
        JASABS = NTGEUES(ISYM)+JAS
        IXABS = MTGEU(1,JASABS)
        IYABS = MTGEU(2,JASABS)
        ! Formulae used:
        !    SF(tu,xy)= 2 Gtxuy
        !    SFP(tu,xy)=SF(tu,xy)+SF(tu,yx)
        !    SFM(tu,xy)=SF(tu,xy)-SF(tu,yx)
        SFtuxy = Two*TG2(ITABS,IXABS,IUABS,IYABS)
        SFtuyx = Two*TG2(ITABS,IYABS,IUABS,IXABS)

        SFP = SFtuxy+SFtuyx
        HEBLK = HEBLK+SFP*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
  case (9)
    ! ========================================================
    ! Compute and use SFM(ITABS IUABS, IXABS ,IYABS)
    do IAS=1,NAS
      IASABS = NTGTUES(ISYM)+IAS
      ITABS = MTGTU(1,IASABS)
      IUABS = MTGTU(2,IASABS)
      do JAS=1,NAS
        JASABS = NTGTUES(ISYM)+JAS
        IXABS = MTGTU(1,JASABS)
        IYABS = MTGTU(2,JASABS)
        ! Formulae used:
        !    SF(tu,xy)= 4 Ptxuy
        !    SFP(tu,xy)=SF(tu,xy)+SF(tu,yx)
        !    SFM(tu,xy)=SF(tu,xy)-SF(tu,yx)
        SFtuxy = Two*TG2(ITABS,IXABS,IUABS,IYABS)
        SFtuyx = Two*TG2(ITABS,IYABS,IUABS,IXABS)

        SFM = SFtuxy-SFtuyx
        HEBLK = HEBLK+SFM*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
    ! CASES GP, GM
    ! Compute and use SG(ITABS , IXABS) (Same for cases GP and GM)
    !*******************************************************************
  case (10)
    do IAS=1,NAS
      ITABS = IAS+NAES(ISYM)
      do JAS=1,NAS
        IXABS = JAS+NAES(ISYM)
        ! Formula used: SG(t,x)= Gtx
        SG = TG1(ITABS,IXABS)

        HEBLK = HEBLK+SG*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
  case (11)
    do IAS=1,NAS
      ITABS = IAS+NAES(ISYM)
      do JAS=1,NAS
        IXABS = JAS+NAES(ISYM)
        ! Formula used: SG(t,x)= Gtx
        SG = TG1(ITABS,IXABS)

        HEBLK = HEBLK+SG*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
      end do
    end do
    !*******************************************************************
  case (12)
    if (abs(OVL) >= 1.0e-12_wp) HEBLK = HEBLK+OVL*DDOT_(NAS*NISBLK,V2,1,V1,1)
    !*******************************************************************
  case (13)
    if (abs(OVL) >= 1.0e-12_wp) HEBLK = HEBLK+OVL*DDOT_(NAS*NISBLK,V2,1,V1,1)
    !*******************************************************************
end select

end subroutine HCOUP_BLK

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE SPEC1D(IFC,FACT,X,Y)
      USE SUPERINDEX
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
      INTEGER IFC
      REAL*8 FACT,X(*),Y(*)
      INTEGER NAS,NIS,ITQ,ITT
C If IFC=0, compute
C X(tt1,ia) <- X(tt1,ia)+FACT*Y(ia), else
C the conjugate expression (summing into Y, values from X).

      NAS=NASUP(1,5)
      NIS=NISUP(1,5)
      IF(NIS*NAS.EQ.0) RETURN
      IF(IFC.EQ.0) THEN
        DO 20 ITQ=1,NASHT
          ITT=KTU(ITQ,ITQ)
          CALL DAXPY_(NIS,FACT,Y,1,X(ITT),NAS)
  20    CONTINUE
      ELSE
        CALL DCOPY_(NIS,[0.0D0],0,Y,1)
        DO 30 ITQ=1,NASHT
          ITT=KTU(ITQ,ITQ)
          CALL DAXPY_(NIS,FACT,X(ITT),NAS,Y,1)
  30    CONTINUE
      END IF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Grad(Grad,nGrad)
      Implicit None
      Integer nGrad
      Real*8 Grad(nGrad)
*     Local variables
      Integer :: mGrad=0
      Character(LEN=24), Parameter:: Label='GRAD'
      Logical :: Found=.False.

      Call qpg_dArray(Label,Found,mGrad)
      If(.not.Found .or. nGrad==0) Then
         Call SysAbendmsg('get_grad','Did not find:',Label)
      End If
      If (mGrad/=nGrad) Then
         Write (6,*) 'mGrad=',mGrad
         Write (6,*) 'nGrad=',nGrad
         Call SysAbendmsg('get_grad','mGrad/=nGrad:',Label)
      End If
      Call Get_dArray(Label,Grad,nGrad)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Gunnar Karlstrom                                 *
************************************************************************
      Subroutine Rowel(nZeta,r0,Beta,K,alpha,P,a,gri,grin,jsum)
************************************************************************
* 1992                                                                 *
* Gunnar Karlstrom                                                     *
* Department of Theoretical Chemistry                                  *
* University of Lund                                                   *
* Lund                                                                 *
* Sweden                                                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "welcom.fh"
      Real*8 gri(nZeta*jsum), alpha(nZeta), a(nZeta),
     &       grin((k+1)*(k/2+1)*(k/4+1)*nZeta), P(nZeta,3)
*
*
      Call poti(k,ipot3)
*     Call IecPrt(' ipot3(0:k+1)',ipot3,k+2,1)
      isum=ipot3(k+1)
      Call bino(k+6)
      Call fiin(k+1)
      Call tetin(k+1)
      Call ylmnor(k+1)
*
      Do 200 iZeta = 1, nZeta
         a(iZeta) = Sqrt(P(iZeta,1)**2 +
     &                   P(iZeta,2)**2 +
     &                   P(iZeta,3)**2 )
 200  Continue
*     Call RecPrt(' In Rowel: Distances',' ',a,nZeta,1)
*
      fac(0)=One
      Do 99 i=1,k+2
         fac(i)=fac(i-1)*DBLE(i)
 99   Continue
      Call priwel(k,alpha,beta,r0,a,gri,nZeta,isum,grin)
*     Call RecPrt('Internal well integrals',' ',gri,nZeta,isum)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine GetCnt(NGROUP,IGROUP,NATOMS,ATLBL)
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "WrkSpc.fh"
      Dimension IGROUP(8)
      Character*(LENIN) ATLBL(*)
C Purpose: Read data from ONEINT

C Read NGROUP
      Call Get_iScalar('nSym',NGROUP)

C Read SYMMETRY GROUP ELEMENTS (Symmetry operations)
      Call Get_iArray('Symmetry operations',IGROUP,NGROUP)

C Read NATOMS, nr of symmetry-unique atoms
      Call Get_iScalar('Unique atoms',NATOMS)

C Read ATLBL, an array of atom labels
      Call Get_cArray('Unique Atom Names',ATLBL,LENIN*NATOMS)

C Read COOR, cartesian coordinates of each atom
!     Call Get_dArray('Unique Coordinates',COOR,3*nAtoms)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine TRINT(CMO1,CMO2,ECORE,NGAM1,FOCKMO,NGAM2,TUVX)
!****************************************************************
! CALCULATE AND RETURN ECORE, FOCKMO, AND TUVX. ECORE IS THE
! INACTIVE-INACTIVE ENERGY CONTRIBUTION, WHICH IS TO BE MULTI-
! PLIED WITH AN OVERLAP TO GIVE A CONTRIBUTION TO THE HAMILTONIAN
! MATRIX ELEMENT. SIMILARLY, THE INACTIVE-ACTIVE CONTRIBUTION IS
! GIVEN BY THE FOCKMO ARRAY CONTRACTED WITH AN ACTIVE TRANSITION
! DENSITY MATRIX, AND THE ACTIVE-ACTIVE IS THE TRANSFORMED
! INTEGRALS IN ARRAY TUVX CONTRACTED WITH THE TRANSITION DENSITY
! TWO-ELECTRON MATRIX. THEREFORE, THE STORAGE OF THE FOCKMO AND
! THE TUVX MATRICES ARE IN THE SAME FORMAT AS THE DENSITY MATRICES.
!****************************************************************

use Index_Functions, only: nTri_Elem
use Fock_util_global, only: Fake_CMO2
use Data_structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use Cntrl, only: ALGO, dmpk, ERFNUC, LuOrd, Nscreen, RFPert
use Symmetry_Info, only: nIrrep
use rassi_data, only: CHFRACMEM, NASH, NASHT, NBASF, NBSQ, NBTRI, NCMO, NISH, NOSH
#ifdef _MOLCAS_MPP_
use Para_Info, only: nProcs
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CMO1(NCMO), CMO2(NCMO)
integer(kind=iwp), intent(in) :: NGAM1, NGAM2
real(kind=wp), intent(out) :: ECORE, FOCKMO(NGAM1)
real(kind=wp), intent(inout) :: TUVX(NGAM2)
integer(kind=iwp) :: I, IERR, IKK, IOFF, IOFF1, IOFF2, IOFF3, iOpt, IRC, ISTA, ISTC, ISTFMO, iSym, JKK, KEEP(8), NA, nAux(8), NB, &
                     NB1, NB2, NBSX(8), nDINAO, NFAO, NI, NO, NPROD, nSymX
real(kind=wp) :: ECORE1, ECORE2
#ifdef _MOLCAS_MPP_
real(kind=wp) :: SCX
#endif
logical(kind=iwp) :: DoCholesky, FoundTwoEls, IfTest, ISQARX
type(DSBA_Type) :: Ash(2), DInAO, DLT(1), FAO, FLT(1), KSQ, MO1(2), MO2(2), Temp_SQ
real(kind=wp), allocatable :: Prod(:)
real(kind=wp), external :: DDot_

#ifdef _DEBUGPRINT_
IfTest = .true.
#else
IfTest = .false.
#endif
! THE FOLLOWING PROGRAMS USE THE ORDERED INTEGRAL FILE FOR BOTH
! THE FOCKMO MATRIX AND THE TUVX ARRAY. THEREFORE, IT IS IMPERATIVE
! THAT SYMMETRY BLOCKS HAVE NOT BEEN EXCLUDED IN THE GENERATION OF
! THIS ORDERED INTEGRAL FILE, UNLESS BOTH ACTIVE AND INACTIVE ORBITALS
! ARE MISSING FOR THAT SYMMETRY LABEL. THIS IS CHECKED FIRST:

! OPEN THE ELECTRON REPULSION INTEGRAL FILE
call f_Inquire('ORDINT',FoundTwoEls)
!call DecideOnDirect(.false.,FoundTwoEls,DoDirect,DoCholesky)
call DecideOnCholesky(DoCholesky)

if (.not. DoCholesky) then

  IOPT = 0
  IRC = 0
  call OPNORD(IRC,IOPT,'ORDINT',LUORD)
  if (IRC /= 0) then
    write(u6,*) ' ERROR: RETURN CODE=',IRC
    write(u6,*) ' RECEIVED WHEN OPENING ORDINT.'
    call ABEND()
  end if

  IRC = 0
  call GETORD(IRC,ISQARX,NSYMX,NBSX,KEEP)
  if (IRC /= 0) then
    write(u6,*) ' ERROR: RETURN CODE=',IRC
    write(u6,*) ' RECEIVED WHEN CALLING GETORD.'
    call ABEND()
  end if
  if (NSYMX /= nIrrep) then
    write(u6,*)
    write(u6,*) '     *** ERROR IN SUBROUTINE TRINT ***'
    write(u6,*) '     INCOMPATIBLE NUMBERS OF IRRED. REP.'
    write(u6,*)
    call ABEND()
  end if
  do ISYM=1,nIrrep
    NB1 = NBASF(ISYM)
    NB2 = NBSX(ISYM)
    if (NB1 /= NB2) then
      write(u6,*)
      write(u6,*) '     *** ERROR IN SUBROUTINE TRINT ***'
      write(u6,*) '   INCOMPATIBLE NUMBERS OF BASIS FUNCTION'
      write(u6,*)
      call ABEND()
    end if
  end do
  do I=1,nIrrep
    if ((KEEP(I) /= 0) .and. (NOSH(I) > 0)) then
      write(u6,*) ' ERROR IN KEEP PARAMETERS ON ORDINT FILE.'
      write(u6,'(A,8I5)') ' KEEP ARRAY:',KEEP(1:nIrrep)
      write(u6,'(A,8I5)') ' NASH ARRAY:',NASH(1:nIrrep)
      write(u6,*) ' A NON-ZERO KEEP PARAMETER INDICATES THAT BASIS'
      write(u6,*) ' FUNCTIONS WITH A SPECIFIC SYMMETRY LABEL HAS'
      write(u6,*) ' BEEN SKIPPED. THIS IS POSSIBLE ONLY IF INACTIVE'
      write(u6,*) ' AND ACTIVE ORBITALS OF THAT SYMMETRY ARE MISSING.'
      call ABEND()
    end if
  end do

end if

! CALCULATE AN INACTIVE TRANSITION DENSITY MATRIX IN AO BASIS:
NDINAO = NBSQ
call Allocate_DT(DInAO,nBasF,nBasF,nIrrep)
call DIMAT(CMO1,CMO2,DINAO%A0)

NFAO = NBSQ
call Allocate_DT(FAO,nBasF,nBasF,nIrrep)
!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. DoCholesky) then     ! Conventional integrals
  !                                                                    *
  !*********************************************************************
  !                                                                    *

  if (IfTest) call dVcPrt('Done',' ',DINAO%A0,NDINAO)
  ! GET THE ONE-ELECTRON HAMILTONIAN MATRIX FROM ONE-EL FILE AND
  ! PUT IT INTO A FOCK MATRIX IN AO BASIS:
  ! Note: GETH1 also adds the reaction field contribution to the
  ! 1-electron hamiltonian, and the variable ERFNuc in common /general/,
  ! which is the RF contribution to the nuclear repulsion
  call GETH1_RASSI(FAO%A0)
  if (IfTest) call dVcPrt('h0',' ',FAO%A0,NFAO)
  ! ONE CONTRIBUTION TO ECORE MUST BE CALCULATED FROM THE NAKED
  ! ONE-EL HAMILTONIAN:
  ECORE1 = DDOT_(NBSQ,FAO%A0,1,DINAO%A0,1)
  if (IfTest) write(u6,*) '      ECore1=',ECORE1

  ! ADD IN THE TWO-ELECTRON CONTRIBUTIONS TO THE FOCKAO MATRIX:

  call Allocate_DT(Temp_SQ,nBasF,nBasF,nIrrep)
  Temp_SQ%A0(:) = Zero
  call FOCK_RASSI(DINAO%A0,Temp_SQ%A0)

  ! --- FAO already contains the one-electron part
  FAO%A0(:) = FAO%A0(:)+Temp_SQ%A0(:)
  call Deallocate_DT(Temp_SQ)

# ifdef _DEBUGPRINT_
  do i=1,nIrrep
    call CHO_OUTPUT(FAO%SB(i)%A2,1,nBasF(i),1,nBasF(i),nBasF(i),nBasF(i),1,u6)
  end do
# endif

  ECORE2 = DDOT_(NBSQ,FAO%A0,1,DINAO%A0,1)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else       ! RI/CD integrals
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Initialize Cholesky information

  call CHO_X_INIT(irc,ChFracMem)
  if (irc /= 0) then
    write(u6,*) 'TrInt: Cho_X_Init returns error code ',irc
    call AbEnd()
  end if

  call Allocate_DT(DLT(1),nBasF,nBasF,nIrrep,aCase='TRI')
  call Fold_Mat(nIrrep,nBasF,DINAO%A0,DLT(1)%A0)

# ifdef _DEBUGPRINT_

  do i=1,nIrrep
    call cho_output(DInAO%SB(i)%A2,1,nBasF(i),1,nBasF(i),nBasF(i),nBasF(i),1,u6)
    call triprt('DLT','',DLT(1)%SB(i)%A1,nBasF(i))
  end do

# endif

  call Allocate_DT(FLT(1),nBasF,nBasF,nIrrep,aCase='TRI')

  ! GET THE ONE-ELECTRON HAMILTONIAN MATRIX FROM ONE-EL FILE AND
  ! PUT IT INTO A FOCK MATRIX IN AO BASIS:
  ! Note: CHO_GETH1 also adds the reaction field contribution to the
  ! 1-electron hamiltonian, and the variable ERFNuc in common /general/,
  ! which is the RF contribution to the nuclear repulsion

  call CHO_GETH1(nBtri,FLT(1)%A0,RFpert,ERFNuc)

  ECORE1 = DDOT_(nBtri,FLT(1)%A0,1,DLT(1)%A0,1)
  if (IfTest) write(u6,*) '      ECore1=',ECORE1,ALGO
  if (IfTest) write(u6,*) '      FAKE_CMO2=',FAKE_CMO2

# ifdef _MOLCAS_MPP_
  if (nProcs > 1) then
    scx = One/real(nProcs,kind=wp)
    ! to avoid double counting when using gadgop
    FLT(1)%A0(:) = scx*FLT(1)%A0(:)
  end if
# endif

  FAO%A0(:) = Zero ! Used as Exchange F matrix
  !                                                                    !
  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
  !                                                                    !
  if (ALGO == 1) then
    !                                                                  !
    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
    !                                                                  !
    ! reorder the MOs to fit Cholesky needs

    call Allocate_DT(MO1(1),nIsh,nBasF,nIrrep)
    call Allocate_DT(MO1(2),nIsh,nBasF,nIrrep)
    call Allocate_DT(MO2(1),nAsh,nBasF,nIrrep)
    call Allocate_DT(MO2(2),nAsh,nBasF,nIrrep)

    ioff = 0
    do iSym=1,nIrrep

      do ikk=1,nIsh(iSym)

        ioff1 = ioff+nBasF(iSym)*(ikk-1)

        MO1(1)%SB(iSym)%A2(ikk,:) = CMO1(ioff1+1:ioff1+nBasF(iSym))

        MO1(2)%SB(iSym)%A2(ikk,:) = CMO2(ioff1+1:ioff1+nBasF(iSym))
      end do

      ioff2 = ioff+nBasF(iSym)*nIsh(iSym)

      do ikk=1,nAsh(iSym)

        ioff3 = ioff2+nBasF(iSym)*(ikk-1)

        MO2(1)%SB(iSym)%A2(ikk,:) = CMO1(ioff3+1:ioff3+nBasF(iSym))

        MO2(2)%SB(iSym)%A2(ikk,:) = CMO2(ioff3+1:ioff3+nBasF(iSym))
      end do

      ioff = ioff+nBasF(iSym)*(nIsh(iSym)+nAsh(iSym))

    end do

    ! Add the two-electron contribution to the Fock matrix
    !     and compute the (tu|vx) integrals

    if (Fake_CMO2) then
      call CHO_FOCK_RASSI(DLT,MO1,MO2,FLT,TUVX,NGAM2)
    else
      call CHO_FOCK_RASSI_X(DLT,MO1,MO2,FLT,FAO,TUVX,NGAM2)
    end if

    call Deallocate_DT(MO2(2))
    call Deallocate_DT(MO2(1))
    call Deallocate_DT(MO1(2))
    call Deallocate_DT(MO1(1))
    !                                                                  !
    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
    !                                                                  !
  else  ! algo=2 (local exchange algorithm)
    !                                                                  !
    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
    !                                                                  !

    nAux(:) = nIsh(:)+nAsh(:)
    call Allocate_DT(MO1(1),nBasF,nAux,nIrrep,Ref=CMO1)
    call Allocate_DT(MO1(2),nBasF,nAux,nIrrep,Ref=CMO2)

    ! *** Only the active orbitals MO coeff need reordering
    call Allocate_DT(Ash(1),nAsh,nBasF,nIrrep)
    call Allocate_DT(Ash(2),nAsh,nBasF,nIrrep)

    do iSym=1,nIrrep

      do ikk=1,nAsh(iSym)
        jkk = nIsh(iSym)+ikk

        Ash(1)%SB(iSym)%A2(ikk,:) = MO1(1)%SB(iSym)%A2(:,jkk)

        Ash(2)%SB(iSym)%A2(ikk,:) = MO1(2)%SB(iSym)%A2(:,jkk)

      end do

    end do

    ! Add the two-electron contribution to the Fock matrix
    !     and compute the (tu|vx) integrals

    if (Fake_CMO2) then

      call CHO_LK_RASSI(DLT,MO1,FLT,FAO,TUVX,nGAM2,Ash,nScreen,dmpk)
    else

      call Allocate_DT(KSQ,nBasF,nBasF,nIrrep)
      KSQ%A0(:) = Zero

      call CHO_LK_RASSI_X(DLT,MO1,FLT,KSQ,FAO,TUVX,nGAM2,Ash,nScreen,dmpk)

      call Deallocate_DT(KSQ)
    end if

    call Deallocate_DT(Ash(2))
    call Deallocate_DT(Ash(1))
    call Deallocate_DT(MO1(2))
    call Deallocate_DT(MO1(1))

    !                                                                  !
    !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
    !                                                                  !
  end if
  !                                                                    !
  !)()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()()(!
  !                                                                    !

  if (Fake_CMO2) then
    do i=1,nIrrep
      call SQUARE(FLT(1)%SB(i)%A1,FAO%SB(i)%A2,1,nBasF(i),nBasF(i))
    end do
  end if

  call Deallocate_DT(FLT(1))
  call Deallocate_DT(DLT(1))

  call GADGOP(FAO%A0,NBSQ,'+')
  call GADGOP(TUVX,NGAM2,'+')

  ECORE2 = DDOT_(NBSQ,FAO%A0,1,DINAO%A0,1)

  ! Finalize Cholesky information

  call CHO_X_FINAL(irc)
  if (irc /= 0) then
    write(u6,*) 'TrInt: Cho_X_Final returns error code ',irc
    write(u6,*) 'Try recovery -- continue.'
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (IfTest) write(u6,*) '      Etwo  =',ECORE2
ECORE = Half*(ECORE1+ECORE2)
if (IfTest) write(u6,*) '      Ecore =',ECORE
! (NOTE COMPENSATION FOR DOUBLE-COUNTING OF TWO-ELECTRON CONTRIBUTION.)
call Deallocate_DT(DInAO)

! TRANSFORM THE FOCK MATRIX TO MO BASIS:
NPROD = 0
do I=1,nIrrep
  NPROD = max(NPROD,NASH(I)*NBASF(I))
end do

call mma_allocate(Prod,nProd,Label='Prod')
PROD(:) = Zero
ISTFMO = 1
ISTC = 1
FOCKMO(:) = Zero
do ISYM=1,nIrrep
  NA = NASH(ISYM)
  NI = NISH(ISYM)
  NO = NI+NA
  NB = NBASF(ISYM)
  if (NA /= 0) then
    ISTA = ISTC+NI*NB
    ! ISTFMO: BEGINNING OF F(MO,MO) BLOCK OF SYMMETRY ISYM.
    ! ISTC: BEGINNING OF MO-S OF SYMMETRY ISYM.
    ! ISTA: BEGINNING OF ACTIVE MO-S OF SYMMETRY ISYM.
    ! MATRIX MULT. PROD(AO,ACTIVE MO)=F(AO,AO)*CMO2(AO,ACTIVE MO)
    call DGEMM_('N','N',NB,NA,NB,One,FAO%SB(ISYM)%A2,NB,CMO2(ISTA),NB,Zero,PROD,NB)
    ! MATRIX MULT. F(ACT MO,ACT MO)=CMO1(AO,ACT MO)(TRP)*PROD(AO,ACT MO)
    call DGEMM_('T','N',NA,NA,NB,One,CMO1(ISTA),NB,PROD,NB,Zero,FOCKMO(ISTFMO),NASHT)
  end if
  ISTFMO = ISTFMO+NA*(NASHT+1)
  ISTC = ISTC+NO*NB
end do
call mma_deallocate(Prod)
call Deallocate_DT(FAO)

if (.not. DoCholesky) then
  ! TRANSFORM TWO-ELECTRON INTEGRALS:
  call TRAINT(CMO1,CMO2,NGAM2,TUVX)

  IRC = 0
  call CLSORD(IRC)

end if
call Chk4NaN(nTri_Elem(nasht),TUVX,iErr)
if (iErr /= 0) then
  write(u6,*) 'TrInt: TUVX corrupted'
  call Abend()
end if
call Chk4NaN(nGam1,FOCKMO,iErr)
if (iErr /= 0) then
  write(u6,*) 'TrInt: FOCKMO corrupted'
  call Abend()
end if
!call triprt('tuvx',' ',TUVX,nasht)

end subroutine TRINT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrInp_MCLR(iPL)
!***********************************************************************
!                                                                      *
!     Echo input                                                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use MCLR_Data, only: ChDisp, DspVec, IRLXROOT, ISNAC, ISTATE, lDisp, NACSTATES, nexp_max, NSSA, SA, SwLbl, XISPSM
use input_mclr, only: AtLbl, ChIrr, Coor, Eps, ERASSCF, ESCF, Header1I, iMCPD, iMethod, iPT2, iRoot, iSpin, mTit, nActEl, nAsh, &
                      nAtoms, nBas, nCSF, nDel, nDisp, nElec3, NewCho, nFro, nHole1, nIsh, nIter, nOrb, nRoots, nRS1, nRS2, nRS3, &
                      nSkip, nSym, ntAsh, ntBas, ntIsh, nTPert, Perturbation, PotNuc, PT2, SpinPol, State_Sym, State_Sym, &
                      StepType, TitleIn, TwoStep, Weight
use PCM_grad, only: RFPERT
use Constants, only: Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPL
integer(kind=iwp) :: i, iAT, iDisp, iSym, j, jDisp, Left, lLine, nLine, nTSsh
logical(kind=iwp) :: RICD
character(len=100) :: Line
character(len=8) :: Fmt1, Fmt2
character, parameter :: XYZ(3) = ['X','Y','Z']

!----------------------------------------------------------------------*
!     Initialize blank and header lines                                *
!----------------------------------------------------------------------*

lLine = len(Line)
!lPaper = 132
!left = (lPaper-lLine)/2
left = 5
write(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
!----------------------------------------------------------------------*
call DecideOnCholesky(RICD)
!----------------------------------------------------------------------*
!     Print the project title                                          *
!----------------------------------------------------------------------*
!if (mTit > 0) then
if (iPL >= 3) write(u6,*)
nLine = mTit+5
do i=1,nLine
  Line = ''
  if ((i == 1) .or. (i == nLine)) Line = repeat('*',lLine)
  if (i == 3) Line = 'Project:'
  if ((i >= 4) .and. (i <= nLine-2)) write(Line,'(18A4)') (TitleIN((i-4)*18+j),j=1,18)
  if (iPL >= 3) then
    call Center_Text(Line)
    write(u6,Fmt1) '*'//Line//'*'
  end if
end do
if (iPL >= 3) write(u6,*)
!end if
!----------------------------------------------------------------------*
!     Print file identifiers                                           *
!----------------------------------------------------------------------*
if (iPL >= 3) then
  write(u6,*)
  write(u6,Fmt1) 'Header of the ONEINT file:'
  write(u6,Fmt1) '--------------------------'
  write(Line,Fmt1) Header1I(1)
  write(u6,'(A)') trim(Line)
  write(Line,Fmt1) Header1I(2)
  write(u6,'(A)') trim(Line)
  write(u6,*)
  !--------------------------------------------------------------------*
  !     Print cartesian coordinates of the system                      *
  !--------------------------------------------------------------------*
  write(u6,*)
  write(u6,Fmt1) 'Cartesian coordinates:'
  write(u6,Fmt1) '----------------------'
  write(u6,*)
  write(u6,Fmt1) '----------------------------------------------'
  write(u6,Fmt1) ' No.    Label       X         Y         Z'
  write(u6,Fmt1) '----------------------------------------------'
  do iAt=1,nAtoms
    write(u6,Fmt2//'I3,5X,A6,2X,3F10.5)') iAt,AtLbl(iAt),Coor(1,iAt),Coor(2,iAt),Coor(3,iAt)
  end do
  write(u6,Fmt1) '----------------------------------------------'
  write(u6,Fmt2//'A,F20.10)') 'Nuclear repulsion energy =',PotNuc
end if
!----------------------------------------------------------------------*
!     Print orbital and wavefunction specifications                    *
!----------------------------------------------------------------------*
if (iMethod == 2) then
  ntIsh = sum(nIsh(1:nSym))
  ntAsh = sum(nAsh(1:nSym))
  ntBas = sum(nBas(1:nSym))
  ntSsh = ntBas-ntIsh-ntAsh-sum(nFro(1:nSym)+nDel(1:nSym))
  if (iPL >= 2) then
    write(u6,*)
    Line = ''
    write(Line(left-2:),'(A)') 'Wave function specifications:'
    call CollapseOutput(1,Line)
    write(u6,Fmt1) '-----------------------------'
    write(u6,*)
    write(u6,Fmt2//'A,T47,I6)') 'Number of closed shell electrons',2*ntIsh
    write(u6,Fmt2//'A,T47,I6)') 'Number of electrons in active shells',nActEl
    write(u6,Fmt2//'A,T47,I6)') 'Max number of holes in RAS1 space',nHole1
    write(u6,Fmt2//'A,T47,I6)') 'Max number of electrons in RAS3 space',nElec3
    write(u6,Fmt2//'A,T47,I6)') 'Number of inactive orbitals',ntIsh
    write(u6,Fmt2//'A,T47,I6)') 'Number of active orbitals',ntAsh
    write(u6,Fmt2//'A,T47,I6)') 'Number of secondary orbitals',ntSsh
    write(u6,Fmt2//'A,T47,F6.1)') 'Spin quantum number',real(iSpin-1,kind=wp)*Half
    write(u6,Fmt2//'A,T47,I6)') 'State symmetry',State_Sym
    write(u6,Fmt2//'A,T47,I6)') 'Number of CI roots',nroots
    write(u6,Fmt2//'A,(T47,10I6))') 'States considered',(iroot(i),i=1,nroots)
    write(u6,Fmt2//'A,(T47,10F6.3))') 'Weights',(weight(i),i=1,nroots)
    write(u6,*)
    write(u6,Fmt2//'A,T47,8I6)') 'Symmetry species',(i,i=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'Skipped sym. species',(nSkip(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'Frozen orbitals',(nFro(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'Inactive orbitals',(nIsh(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'Active orbitals',(nAsh(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'RAS1 orbitals',(nRs1(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'RAS2 orbitals',(nRs2(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'RAS3 orbitals',(nRs3(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'Deleted orbitals',(nDel(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'Number of basis functions',(nBas(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'Number of orbitals',(nOrb(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T47,8I6)') 'Number of configurations',(ncsf(isym),isym=1,nsym)

    write(u6,Fmt2//'A,T47,8I6)') 'Number of combinations',(nint(xispsm(isym,1)),isym=1,nsym)

    if (iPt2 == 0) then
      write(u6,Fmt1) 'Natural orbitals are used in the last CI'
    else
      write(u6,Fmt1) 'Pseudo canonical orbitals are used in the last CI'
    end if

    write(u6,Fmt2//'A,T33,F20.10)') 'RASSCF state energy =',ERASSCF(istate)
    write(u6,Fmt2//'A,T47,I6)') 'Size of explicit Hamiltonian in PCG:',nExp_Max
    call CollapseOutput(0,'Wave function specifications:')
  end if
else
  if (iPL >= 2) then
    write(u6,*)
    Line = ''
    write(Line(left-2:),'(A)') 'Wave function specifications:'
    call CollapseOutput(1,Line)
    write(u6,Fmt1) '-----------------------------'
    write(u6,Fmt2//'A,T50,A)') 'Wavefunction type:','SCF'
    write(u6,Fmt2//'A,T45,I6)') 'Number of irreducible symmetry groups',nSym
    write(u6,Fmt2//'A,T45,8I6)') 'Number of basis functions',(nBas(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T45,8I6)') 'Number of occupied orbitals',(nish(iSym),iSym=1,nSym)
    write(u6,Fmt2//'A,T31,F20.10)') 'SCF energy =',ESCF
    call CollapseOutput(0,'Wave function specifications:')
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (iPL >= 2) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  write(u6,*)
  write(u6,Fmt2//'A,T42,ES11.4)') 'Convergence threshold=',Eps
  write(u6,Fmt2//'A,T45,I8)') 'Max number of iterations in PCG:',nIter
  if (RICD) then
    if (NewCho) then
      write(u6,Fmt2//'A)') 'Using the Cho-Fock Algorithm'
    else
      write(u6,Fmt2//'A)') 'Using the Cho-MO Algorithm'
    end if
  end if

  if (SPINPOL) then
    write(u6,Fmt1) 'Calculating spin polarization'
  else if (SA .or. iMCPD .or. PT2) then
    if (PT2) write(u6,Fmt2//'A)') 'Calculating Lagrangian multipliers for CASPT2'
    if (isNAC) then
      write(u6,Fmt2//'A,I3,"/",I3)') 'Lagrangian multipliers are calculated for states no. ',NACstates(1),NACstates(2)
      if ((NSSA(1) /= NACstates(1)) .or. (NSSA(2) /= NACstates(2))) &
        write(u6,Fmt2//'39X,A,I3,"/",I3,A)') '(SA roots no. ',NSSA(1),NSSA(2),')'
    else
      write(u6,Fmt2//'A,I3)') 'Lagrangian multipliers are calculated for state no. ',irlxroot
      if (istate /= irlxroot) write(u6,Fmt2//'39X,A,I3,A)') '(SA root no. ',istate,')'
    end if
    if (TwoStep) then
      if (StepType == 'RUN1') write(u6,Fmt1) 'TwoStep activated. Run 1 (preparation).'
      if (StepType == 'RUN2') write(u6,Fmt1) 'TwoStep activated. Run 2 (final run).'
    end if
  else
    if (ndisp /= 0) then
      write(u6,*)
      Line = ''
      write(Line(left-2:),'(A)') 'Perturbation specifications:'
      call CollapseOutput(1,Line)
      write(u6,Fmt1) '----------------------------'
      write(u6,*)
      write(u6,Fmt2//'A,T49,8I4)') 'Number of perturbations in each symmetry',(ldisp(iSym),iSym=1,nSym)
      write(u6,Fmt2//'A,T52,A)') 'Type of perturbation:',Perturbation
      call CollapseOutput(0,'Perturbation specifications:')
      write(u6,*)
      Line = ''
      write(Line(left-2:),'(A)') 'Perturbations:'
      call CollapseOutput(1,Line)
      write(u6,Fmt1) '--------------'
      write(u6,*)
      write(u6,Fmt1) '-------------------------------------'
      write(u6,Fmt1) ' No.    Symmetry    Center Direction'
      write(u6,Fmt1) '-------------------------------------'
      jDisp = 0
      do iSym=1,nSym
        do iDisp=1,lDisp(iSym)
          jDisp = jDisp+1
          if (btest(ntpert(jdisp),4)) then
            write(u6,Fmt2//'I3,T16,A3,T29,A)') jDisp,chIrr(isym),ChDisp(dspvec(jDisp))
          else
            write(u6,Fmt2//'I3,T16,A3,T29,A8,A,A)') jDisp,chIrr(isym),swlbl(jDisp),' ',XYZ(dspvec(jDisp))
          end if
        end do
      end do
      write(u6,Fmt1) '-------------------------------------'
      call CollapseOutput(0,'Perturbations:')
    end if
  end if
  write(u6,*)
  !--------------------------------------------------------------------*
  !     Print reference state information                              *
  !--------------------------------------------------------------------*
  if (.not. SA) then
    write(u6,*)
    if (iMethod == 2) then
      write(u6,Fmt2//'A,I3)') 'Linear response function is computed for root no. = ',irlxroot
    else
      write(u6,Fmt2//'A,I3)') 'Linear response function is computed for Restricted Hartree-Fock wavefunction'
    end if
  end if

  if (RFpert) then
    write(u6,*)
    write(u6,Fmt1) 'Reaction field specifications:'
    write(u6,Fmt1) '------------------------------'
    write(u6,*)
    write(u6,'(6X,A)') 'The Reaction field is added as a perturbation and has been determined in a previous calculation'
    write(u6,*)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
write(u6,*)
!                                                                      *
!***********************************************************************
!                                                                      *
if (isNAC .and. (nSym > 1)) then
  call WarningMessage(2,'NAC is not supported with symmetry')
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine PrInp_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_T_pair_tests

   USE fmm_global_paras
   USE fmm_box_utils, ONLY: fmm_NF_boxes, fmm_RFF_boxes

   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_init_T_pair_tests,         &
             fmm_close_T_pair_tests,        &
             fmm_test_and_buffer_T_pair

    ! Flag to test initialisation
   CHARACTER(LEN=11), SAVE :: init_tests

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_T_pair_tests(scheme)

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme

      IF (scheme%phase == NEAR_FIELD) THEN
         CALL fmm_store_test(fmm_test_NF_ext)
      ELSE
         SELECT CASE (scheme%algorithm)
            CASE (DO_FQ)
               CALL fmm_store_test(fmm_test_raw_FF)
            CASE (DO_BQ)
               CALL fmm_store_test(fmm_test_FF)
            CASE (DO_NlogN)
               CALL fmm_store_test(fmm_test_LFF)
            CASE (DO_FMM)
               CALL fmm_store_test(fmm_test_LFF)
            CASE DEFAULT
               CALL fmm_quit ('unable to initialise T_pair_tests')
         END SELECT
      END IF

      init_tests = 'initialised'

   END SUBROUTINE fmm_init_T_pair_tests

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_close_T_pair_tests

      IMPLICIT NONE
      IF (init_tests /= 'initialised') STOP 'must initialise pair_tests!'
      init_tests = ' '

   END SUBROUTINE fmm_close_T_pair_tests

!-------------------------------------------------------------------------------
! routine to perform T-pair test on two raw or boxed moments, and if they
! pass the pair is sent for evaluation.

   SUBROUTINE fmm_test_and_buffer_T_pair(LHS,RHS,id,weight)

      USE fmm_T_buffer, ONLY: fmm_add_to_T_buffer

      TYPE(gen_mm_paras), INTENT(IN) :: LHS, RHS
      TYPE(LHS_RHS_type), INTENT(IN) :: id
      INTEGER(INTK),      INTENT(IN) :: weight
      TYPE(T_pair_single) :: T_pair
      LOGICAL, EXTERNAL   :: fmm_included_pair
      EXTERNAL fmm_stored_t_pair_mould

      IF (fmm_included_pair(LHS,RHS,id)) THEN
        ! pour all relevant info into the T-pair mould
         CALL fmm_stored_t_pair_mould(LHS,RHS,id,weight,T_pair)
        ! pass single T_pair entity to contractors via buffer
         CALL fmm_add_to_T_buffer(T_pair)
      END IF

   END SUBROUTINE fmm_test_and_buffer_T_pair

!-------------------------------------------------------------------------------
! fmm_test_pass is always TRUE, bypassing normal classical/nonclassical tests

   FUNCTION fmm_test_pass(LHS,RHS,id)

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(IN) :: LHS, RHS
      TYPE(LHS_RHS_type), INTENT(IN) :: id
      LOGICAL :: fmm_test_pass
      fmm_test_pass = .TRUE.

! Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_integer_array(LHS%raw_paras%id)
         CALL Unused_integer_array(RHS%raw_paras%id)
         CALL Unused_integer(id%LHS)
      END IF
   END FUNCTION fmm_test_pass

!-------------------------------------------------------------------------------
! Logical function to test if two gaussian overlaps are separated by
! more than the sum of their extents.
! fmm_test_ext is TRUE if sufficiently well-separated.

   FUNCTION fmm_test_ext(LHS,RHS,id)

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(IN) :: LHS, RHS
      TYPE(LHS_RHS_type), INTENT(IN) :: id
      LOGICAL :: fmm_test_ext
      REAL(REALK) :: r_ij(3), ext_ij, r_mod, r_zero

      ext_ij = RHS%raw_paras(id%RHS)%ext + LHS%raw_paras(id%LHS)%ext
      r_ij   = RHS%raw_paras(id%RHS)%cntr - LHS%raw_paras(id%LHS)%cntr
      r_mod  = r_ij(1)*r_ij(1) + r_ij(2)*r_ij(2) + r_ij(3)*r_ij(3)
      ext_ij = ext_ij*ext_ij
      r_zero = ZERO_DIST_TOL*ZERO_DIST_TOL
      fmm_test_ext = ((r_mod - ext_ij) > r_zero)

   END FUNCTION fmm_test_ext

!-------------------------------------------------------------------------------
! Interaction pair test routine for near-field phase.
! An interaction should be treated by multipoles if in NF boxes and
! sufficiently well-separated.

   FUNCTION fmm_test_NF_ext(LHS,RHS,id)

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(IN) :: LHS, RHS
      TYPE(LHS_RHS_type), INTENT(IN) :: id
      LOGICAL :: fmm_test_NF_ext
      TYPE(box_mm_paras) :: LHStmp, RHStmp

      LHStmp%box = LHS%raw_paras(id%LHS)%box
      RHStmp%box = RHS%raw_paras(id%RHS)%box
      LHStmp%bra = LHS%raw_paras(id%LHS)%bra
      RHStmp%bra = RHS%raw_paras(id%RHS)%bra
      LHStmp%level = 0
      RHStmp%level = 0

      fmm_test_NF_ext = fmm_NF_boxes(LHStmp,RHStmp) .AND.   &
                        fmm_test_ext(LHS,RHS,id)

   END FUNCTION fmm_test_NF_ext

!-------------------------------------------------------------------------------
! Logical function to test if two boxes are in each others "Far Field"
! based on separation.  Used in simple full quadratic (FQ) algorithm
! when we wish to compare unboxed moments (c.f. fmm_test_FF function)

   FUNCTION fmm_test_raw_FF(LHS,RHS,id)

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(IN) :: LHS, RHS
      TYPE(LHS_RHS_type), INTENT(IN) :: id
      LOGICAL            :: fmm_test_raw_FF
      TYPE(box_mm_paras) :: LHStmp, RHStmp

      LHStmp%box = LHS%raw_paras(id%LHS)%box
      RHStmp%box = RHS%raw_paras(id%RHS)%box
      LHStmp%bra = LHS%raw_paras(id%LHS)%bra
      RHStmp%bra = RHS%raw_paras(id%RHS)%bra
      LHStmp%level = 0
      RHStmp%level = 0

      fmm_test_raw_FF = .NOT. (fmm_NF_boxes(LHStmp,RHStmp))

   END FUNCTION fmm_test_raw_FF

!-------------------------------------------------------------------------------
! Logical function to test if two boxes are in each others "Far Field"
! based on separation.  Used by Boxed Quadratic (BQ) algorithm.

   FUNCTION fmm_test_FF(LHS,RHS,id)

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(IN) :: LHS, RHS
      TYPE(LHS_RHS_type), INTENT(IN) :: id
      LOGICAL :: fmm_test_FF

      fmm_test_FF = .NOT.(fmm_NF_boxes(LHS%box_paras(id%LHS),   &
                                       RHS%box_paras(id%RHS)))

   END FUNCTION fmm_test_FF

!-------------------------------------------------------------------------------
! Logical function to test if two boxes are in each others "Local Far Field"
! based on separation;  used by FMM and NlogN algorithms;
! note that in the NlogN scheme boxes are at different levels, but the
! definition of LFF is such that we can then translate the box at the
! deeper level to the higher level and apply the same criteria as for
! two boxes at the deeper level (assuming branches join at higher levels)
! FIXME: how about branch scheme where branches don't join at higher levels??

   FUNCTION fmm_test_LFF(LHS_in,RHS_in,id)

      USE fmm_box_utils, ONLY: fmm_translate_to_common_grid

      IMPLICIT NONE
      TYPE(gen_mm_paras), INTENT(IN) :: LHS_in, RHS_in
      TYPE(LHS_RHS_type), INTENT(IN) :: id
      LOGICAL :: fmm_test_LFF

      ! introduce these so we can translate to common grid if needed
      TYPE(box_mm_paras) :: LHS, RHS

      LHS = LHS_in%box_paras(id%LHS)
      RHS = RHS_in%box_paras(id%RHS)
      IF (LHS%level /= RHS%level) THEN
         ! All NF, LFF and RFF definitions are based on boxes in ONE grid.
         ! We must therefore translate the boxes into a common grid first.
         ! Of course, this can be avoided by passing the transformed paras.
         CALL fmm_translate_to_common_grid(LHS,RHS)
      END IF

      fmm_test_LFF = .FALSE.
      IF (fmm_NF_boxes(LHS,RHS)) RETURN
      IF (fmm_RFF_boxes(LHS,RHS)) RETURN
      fmm_test_LFF = .TRUE.

   END FUNCTION fmm_test_LFF

!-------------------------------------------------------------------------------

END MODULE fmm_T_pair_tests

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986,1995, Bernd Artur Hess                            *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

subroutine Even2r(idbg,N,V,G,E,A,R,TT,AUXF,AUXG,AUXH,W1W1)
!     EVEN2 - BERND HESS - V 1.0 - 5.2.86
!     CALCULATE EVEN2 OPERATORS
!
!     N       DIMENSION OF MATRICES
!     V       POTENTIAL MATRIX
!     G       MATRIX OF PVP OPERATOR. WILL CONTAIN EVEN2 OPERATORS
!             ON OUTPUT
!     E       RELATIVISTIC ENERGY (DIAGONAL)
!     A       A-FACTORS (DIAGONAL)
!     R       R-FACTORS (DIAGONAL)
!     TT      NONREL. KINETIC ENERGY (DIAGONAL)
!     AUXF,AUXG,AUXH  SCRATCH ARAYS

use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idbg, N
real(kind=wp), intent(inout) :: V(N*(N+1)/2), G(N*(N+1)/2)
real(kind=wp), intent(in) :: E(N), A(N), R(N), TT(N)
real(kind=wp), intent(out) :: AUXF(N,N), AUXG(N,N), AUXH(N,N), W1W1(N,N)
integer(kind=iwp) :: I, IE, IJ, J, M

#ifndef _DEBUGPRINT_
#include "macros.fh"
unused_var(idbg)
#endif

!ulf
#ifdef _DEBUGPRINT_
if (idbg > 0) then
  call PRMAT(IDBG,V,N,0,'V       ')
  call PRMAT(IDBG,G,N,0,'G       ')
  call PRMAT(IDBG,E,N,1,'E       ')
  call PRMAT(IDBG,A,N,1,'A       ')
  call PRMAT(IDBG,R,N,1,'R       ')
  call PRMAT(IDBG,TT,N,1,'TT      ')
end if
#endif
M = N
AUXH(:,:) = Zero
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    V(IJ) = V(IJ)/(E(I)+E(J))
    G(IJ) = G(IJ)/(E(I)+E(J))
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXF(I,J) = A(I)*R(I)*G(IJ)*A(J)*A(J)
    AUXG(I,J) = R(I)*V(IJ)*A(J)
  end do
end do
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXF(J,I) = A(J)*R(J)*G(IJ)*A(I)*A(I)
    AUXG(J,I) = R(J)*V(IJ)*A(I)
  end do
end do

! ARQA ARQA

call CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
#ifdef _DEBUGPRINT_
if (IE /= 0) call SysHalt('relsew')
!ulf
if (idbg > 0) call prsq(idbg,'AUXH   1',auxh,n)
#endif
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXG(J,I) = -Half/TT(J)*G(IJ)*A(I)*R(I)
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXG(I,J) = -Half/TT(I)*G(IJ)*A(J)*R(J)
  end do
end do

! ARQA AQRA

call CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
!ulf
#ifdef _DEBUGPRINT_
if (idbg > 0) call prsq(idbg,'AUXH   2',auxh,n)
#endif
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXF(J,I) = A(J)*V(IJ)*A(I)*A(I)*R(I)
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXF(I,J) = A(I)*V(IJ)*A(J)*A(J)*R(J)
  end do
end do
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXG(J,I) = -Two*TT(J)*R(J)*V(IJ)*A(I)
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXG(I,J) = -Two*TT(I)*R(I)*V(IJ)*A(J)
  end do
end do

! AQRA ARQA

call CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
!ulf
#ifdef _DEBUGPRINT_
if (idbg > 0) call prsq(idbg,'AUXH   3',auxh,n)
#endif
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXG(J,I) = G(IJ)*A(I)*R(I)
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXG(I,J) = G(IJ)*A(J)*R(J)
  end do
end do

! AQRA AQRA

call CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)

! KEEP W1*W1 FOR HIGHER-ORDER DK

W1W1(:,:) = AuxH

!ulf
#ifdef _DEBUGPRINT_
if (idbg > 0) call prsq(IDBG,'W*W     ',AUXH,N)
#endif

! 1/2 EW*W + 1/2 W*WE

do I=1,N
  do J=1,N
    AUXH(I,J) = Half*(AUXH(I,J)*E(I)+AUXH(I,J)*E(J))
  end do
end do
!ulf
#ifdef _DEBUGPRINT_
if (idbg > 0) call prsq(idbg,'AUXH SYM',auxh,n)
#endif

IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXF(J,I) = A(J)*R(J)*G(IJ)*A(I)*E(I)*A(I)
    AUXG(J,I) = R(J)*V(IJ)*A(I)
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXF(I,J) = A(I)*R(I)*G(IJ)*A(J)*E(J)*A(J)
    AUXG(I,J) = R(I)*V(IJ)*A(J)
  end do
end do
call CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
!ulf
#ifdef _DEBUGPRINT_
if (idbg > 0) call prsq(idbg,'AUXH   5',auxh,n)
#endif
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXG(J,I) = -Half/TT(J)*G(IJ)*A(I)*R(I)
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXG(I,J) = -Half/TT(I)*G(IJ)*A(J)*R(J)
  end do
end do
call CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
!ulf
#ifdef _DEBUGPRINT_
if (idbg > 0) call prsq(idbg,'AUXH   6',auxh,n)
#endif
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXF(J,I) = A(J)*V(IJ)*R(I)*A(I)*E(I)*A(I)
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXF(I,J) = A(I)*V(IJ)*R(J)*A(J)*E(J)*A(J)
  end do
end do
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXG(J,I) = -Two*TT(J)*R(J)*V(IJ)*A(I)
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXG(I,J) = -Two*TT(I)*R(I)*V(IJ)*A(J)
  end do
end do
call CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
!ulf
#ifdef _DEBUGPRINT_
if (idbg > 0) call prsq(idbg,'AUXH   7',auxh,n)
#endif
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    AUXG(J,I) = G(IJ)*A(I)*R(I)
  end do
end do
do J=1,N
  IJ = J*(J-1)/2+1
  do I=J,N
    IJ = IJ+I-1
    AUXG(I,J) = G(IJ)*A(J)*R(J)
  end do
end do
call CpLabr(AUXF,AUXG,N,N,N,M,M,AUXH,M,IE)
!ulf
#ifdef _DEBUGPRINT_
if (idbg > 0) call prsq(idbg,'AUXH   8',auxh,n)
#endif

! SYMMETRISIEREN

IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    G(IJ) = -Half*(AUXH(I,J)+AUXH(J,I))
  end do
end do
!call PRM('OUTPUT  ',G,N)

return

end subroutine Even2r

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001-2005, Valera Veryazov                             *
!***********************************************************************

module BasisType_Mod

implicit none
private

!
!  'strange' order is due to back compatibility issues
!    UNK: unknown
!
character(len=*), parameter :: BasTypeCon = 'SEG:ANO:RAF:CCC:UNK:UNC:ARC:GEN:SEC:'
! 1: Contraction type
!  - SEG: segmented
!  - SEC: segmented Cartesian
!  - ANO: ANO
!  - RAF: Raffenetti
!  - CCC: CC contraction
!  - UNC: uncontracted
!  - ARC: automatic Raffenetti
!  - GEN: general contraction

character(len=*), parameter :: BasTypeAll = 'AE_:NAE:YES:NO_:UNK:'
! 2: All electron
!  - AE_: all electron
!  - NAE: not all electron
!  - YES: same as AE_
!  - NO_: same as NAE

character(len=*), parameter :: BasTypeRel = 'NRH:RH_:RCP:DKH:UNK:DK2:DK3:DK4:DK5:DK6:DK7:DK8:RYD:X2C:'
! 3: Relativity
!  - RH_: relativistic Hamiltonian
!  - NRH: non relativistic Hamiltonian
!  - RCP: relativistic core potential
!  - DKH: DKH
!  - X2C: exact 2-component
!  - RYD: Rydberg

character(len=*), parameter :: BasTypeNuc = 'PN_:GN_:MGN:UNK:'
! 4: Nucleus
!  - PN_: point nucleus
!  - GN_: Gaussian nucleus
!  - MGN: modified Gaussian

public :: BasTypeCon, BasTypeAll, BasTypeRel, BasTypeNuc

end module BasisType_Mod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mkrdcas_cvb()

use casvb_global, only: civb1, civb2, corenrg, formE, icrit, ifhamil, ifinish, ipr, memplenty, projcas, strtci, variat
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: iscf
real(kind=wp) :: cnrm, cscf, eexp
logical(kind=iwp) :: need_cas
logical(kind=iwp), external :: ifcasci_cvb, & ! ... Files available ...
                               up2date_cvb, & ! ... Make: up to date? ...
                               valid_cvb

if (ifinish == 0) then
  need_cas = (icrit == 1) .or. projcas
else
  need_cas = ifcasci_cvb() .and. (.not. variat)
end if
if (.not. need_cas) return
! Get CASSCF eigenvector
if (.not. ifcasci_cvb()) then
  if ((ipr(1) >= 0) .and. valid_cvb(strtci)) call prtfid_cvb(' Warning: CI vector not found - no ',strtci)
  if (icrit == 1) then
    write(u6,*) ' No optimization without CASSCF vector!'
    call abend_cvb()
  end if
else
  if (ipr(3) >= 2) write(u6,'(/,a)') ' Read CASSCF eigenvector:'
  call getci_cvb(civb1)
end if
call cinorm2_cvb(civb1,cnrm)
cnrm = One/cnrm
call ciscale2_cvb(civb1,cnrm,iscf,cscf)
if ((.not. up2date_cvb('CASCHECK')) .or. (ipr(3) >= 2)) then
  call untouch_cvb('CASCHECK')
  ! Some checks
  if (abs(cnrm-One) > 1.0e-3_wp) then
    if (ipr(3) >= 0) write(u6,formE) ' WARNING: Norm of CI vector read differs from one :',cnrm
  else if (ipr(3) >= 2) then
    write(u6,formE) ' Norm of CI vector read ',cnrm
  end if
  if ((ipr(3) >= 2) .and. (iscf /= 0)) then
    write(u6,'(a,i6)') ' SCF determinant:',iscf
    write(u6,formE) '     coefficient:',cscf
  end if
  if (ifhamil) then
    call cicopy_cvb(civb1,civb2)
    call applyh_cvb(civb2)
    call cidot_cvb(civb1,civb2,eexp)
    if (ipr(3) >= 1) write(u6,formE) ' CASSCF energy :',eexp+corenrg
    if (ipr(3) >= 1) write(u6,'(a)') ' '
  end if
end if
if (.not. memplenty) call ciwr_cvb(civb1,61001.2_wp)

return

end subroutine mkrdcas_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine scorr_cvb(cvbdet,dvbdet,evbdet)

use Index_Functions, only: nTri_Elem
use casvb_global, only: formAD, formAF, nalf, nbet, ndetvb, norb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: cvbdet(ndetvb), dvbdet(ndetvb), evbdet(ndetvb)
real(kind=wp), parameter :: cut = 1.0e-10_wp
integer(kind=iwp) :: i, mu, nu
real(kind=wp) :: phase, rsum, scheck, snorm, ssnorm, ssum, stot, tot
integer(kind=iwp), allocatable :: iperm(:)
real(kind=wp), allocatable :: ssq(:,:), wvbdet(:)
real(kind=wp), external :: ddot_

call mma_allocate(ssq,norb,norb,label='ssq')
call mma_allocate(wvbdet,ndetvb,label='wvbdet')
call mma_allocate(iperm,norb,label='iperm')

write(u6,'(/,1x,a)') 'Expectation values of (s(i)+s(j))**2'
snorm = ddot_(ndetvb,cvbdet,1,dvbdet,1)
ssnorm = ddot_(ndetvb,cvbdet,1,evbdet,1)
write(u6,formAF) ' Lower triangle uses SPIN function with Snorm=',ssnorm
write(u6,formAF) ' Upper triangle uses FULL function with Snorm=',snorm
! DLC
!snorm = One/snorm
!ssnorm = One/ssnorm
phase = (-One)**abs(nalf-nbet)
snorm = phase/snorm
ssnorm = phase/ssnorm
!! DLC
ssq(:,:) = Zero
tot = Zero
stot = Zero
do mu=1,norb
  do nu=mu+1,norb
    ! Apply s_mu x s_nu to the wavefunction
    do i=1,norb
      iperm(i) = i
    end do
    iperm(mu) = nu
    iperm(nu) = mu
    wvbdet(:) = cvbdet(:)
    call permvb_cvb(wvbdet,iperm)
    rsum = One-ddot_(ndetvb,wvbdet,1,dvbdet,1)*snorm
    ssum = One-ddot_(ndetvb,wvbdet,1,evbdet,1)*ssnorm
    tot = tot+rsum
    stot = stot+ssum
    ssq(mu,nu) = rsum
    ssq(nu,mu) = ssum
  end do
end do
call mxprint_cvb(ssq,norb,norb,0)
tot = tot+0.75_wp*real(norb-2*nTri_Elem(norb-1),kind=wp)
stot = stot+0.75_wp*real(norb-2*nTri_Elem(norb-1),kind=wp)
scheck = Half*real(abs(nalf-nbet),kind=wp)*(Half*real(abs(nalf-nbet),kind=wp)+One)
if ((abs(tot-scheck) > cut) .or. (abs(stot-scheck) > cut)) write(u6,formAD) 'WARNING: spins ',stot,tot,scheck

call mma_deallocate(ssq)
call mma_deallocate(wvbdet)
call mma_deallocate(iperm)

return

end subroutine scorr_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE COUNT(NINTGR,NSYM,NORB,MUL)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NORB(*),MUL(8,8)
      DIMENSION NDPROD(8)
C COUNT TWO-ELECTRON INTEGRALS
C FIRST, COUNT NUMBER OF DENSITY PRODUCTS IN EACH SYMMETRY:
      NDPROD(1)=0
      NORBT=0
      DO 10 IS=1,NSYM
        NDPROD(IS)=0
        NORBT=NORBT+NORB(IS)
10    CONTINUE
      DO 30 IJS=1,NSYM
        ISUM=0
        DO 20 IS=1,NSYM
          JS=MUL(IS,IJS)
          IF(JS.GT.IS) GOTO 20
          ISUM=ISUM+NORB(IS)*NORB(JS)
20      CONTINUE
        NDPROD(IJS)=ISUM
30    CONTINUE
      NDPROD(1)=(NDPROD(1)+NORBT)/2
C THEN COUNT NUMBER OF TOTALLY SYMMETRIC PRODUCTS OF DENS-PRODUCTS:
      NINTGR=0
      DO 40 IJS=1,NSYM
        NINTGR=NINTGR+NDPROD(IJS)*(1+NDPROD(IJS))
40    CONTINUE
      NINTGR=NINTGR/2
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  PMLoc
!
!> @brief
!>   Pipek--Mezey localization of occupied orbitals
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Performs iterative (Jacobi sweeps) Pipek--Mezey localization of
!> molecular orbitals. CMO is assumed to be the full set of
!> orbitals, but only the first \p nOcc will be localized. On exit,
!> the localized MOs are returned in CMO.
!> Note that symmetry is not allowed.
!>
!> If successful, \p irc = ``0`` is returned. If \p irc = ``-1``
!> is returned, an error was found in the input and nothing has
!> been done. If \p irc = ``1`` is returned, the iterative procedure did
!> not converge to within the threshold (\p Thr, \p ThrGrad) in the
!> requested max. number of iterations (\p MxIter). If the user
!> specifies negative thresholds, \p Thr = ``1.0e-6_wp`` and \p ThrGrad = ``1.0e-3_wp``
!> will be used.
!> If the user specifies a negative screening threshold,
!> \p ThrRot = ``1.0e-10_wp`` is used.
!>
!> @param[out]    irc     Return code
!> @param[in,out] CMO     Molecular orbital coefficients
!> @param[in]     Thr     Threshold for functional
!> @param[in]     ThrGrad Threshold for gradient
!> @param[in]     ThrRot  Screening threshold
!> @param[in]     MxIter  Max. number of iterations
!> @param[in]     nBas    Number of basis functions per irrep
!> @param[in]     nOcc    Number of occupied orbitals to localize
!> @param[in]     nFro    Number of frozen occupied orbitals
!> @param[in]     nSym    Number of irreps
!> @param[in]     Silent  Flag to avoid printing
!***********************************************************************

subroutine PMLoc(irc,CMO,Thr,ThrGrad,ThrRot,MxIter,nBas,nOcc,nFro,nSym,Silent)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(inout) :: CMO(*)
real(kind=wp), intent(in) :: Thr, ThrGrad, ThrRot
integer(kind=iwp), intent(in) :: MxIter, nSym, nBas(nSym), nOcc(nSym), nFro(nSym)
logical(kind=iwp), intent(in) :: Silent
#include "Molcas.fh"
integer(kind=iwp) :: iSym, nAtoms, nBasT, nOccT
real(kind=wp) :: Functional, ThrGLoc, ThrLoc, ThrRotLoc
character(len=80) :: Txt
logical(kind=iwp) :: Converged, Debug, Maximization
character(len=LenIn8), allocatable :: myName(:)
character(len=*), parameter :: SecNam = 'PMLoc'

! Initialization.
! ---------------

irc = 0
if (MxIter < 1) return

nBasT = nBas(1)
do iSym=2,nSym
  nBasT = nBasT+nBas(iSym)
end do
if (nBasT < 1) return

nOccT = nOcc(1)
do iSym=2,nSym
  nOccT = nOccT+nOcc(iSym)
end do
if (nOccT < 1) return

! Pipek-Mezey does not work with symmetry.
! TODO/FIXME: we might consider de-symmetrization.
! ------------------------------------------------

if (nSym /= 1) then
  irc = -1
  return
end if

! Read number of atoms, atomic labels, and basis functions labels
! from runfile.
! ---------------------------------------------------------------

call Get_nAtoms_All(nAtoms)
if ((nAtoms < 1) .or. (nAtoms > MxAtom)) then
  write(Txt,'(A,I9)') 'nAtoms =',nAtoms
  call SysAbendMsg(SecNam,'Atom limit exceeded!',Txt)
end if
call mma_allocate(myName,nBasT,label='myName')
call Get_cArray('Unique Basis Names',myName,LenIn8*nBasT)

! Localize.
! ---------

Functional = -huge(Functional)
if (Thr <= Zero) then
  ThrLoc = 1.0e-6_wp
else
  ThrLoc = Thr
end if
if (ThrGrad <= Zero) then
  ThrGLoc = 1.0e-3_wp
else
  ThrGLoc = ThrGrad
end if
if (ThrRot < Zero) then
  ThrRotLoc = 1.0e-10_wp
else
  ThrRotLoc = ThrRot
end if
Maximization = .true.
Converged = .false.
Debug = .false.
call PipekMezey(Functional,CMO,ThrLoc,ThrRotLoc,ThrGLoc,myName,nBas,nOcc,nFro,nSym,nAtoms,MxIter,Maximization,Converged,Debug, &
                Silent)
call mma_deallocate(myName)

! Check convergence.
! ------------------

if (.not. Converged) irc = 1

end subroutine PMLoc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkTau_chcc(T2,T11,T12,dima,dimb,no,f1,f2)
! this routine does:
! T2(a',b',i,j) = f1 . T2(a',b',i,j) + f2 . T11(a',i) . T12(b',j)
!
! N.B. Kvajt odflaknute

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, no
real(kind=wp), intent(inout) :: T2(dima,dimb,no,no)
real(kind=wp), intent(in) :: T11(dima,no), T12(dimb,no), f1, f2
integer(kind=iwp) :: b, j

do j=1,no
  do b=1,dimb
    T2(:,b,:,j) = f1*T2(:,b,:,j)+f2*T11(:,:)*T12(b,j)
  end do
end do

return

end subroutine MkTau_chcc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HZLP1(CBUF,SBUF,DBUF,ARR,CSECT,RSECT,XI1,XI2,ICI)

use mrci_global, only: ESMALL, IDISKC, IDISKD, IDISKS, LUEIG, MBUF, MXVEC, NCONF, NRROOT, NSECT, NVEC, VSMALL
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: CBUF(MBUF,MXVEC), SBUF(MBUF,MXVEC), DBUF(MBUF), ARR(NRROOT,NRROOT,11), CSECT(NSECT,MXVEC), &
                              RSECT(NSECT,MXVEC), XI1(NSECT,NRROOT), XI2(NSECT,NRROOT)
integer(kind=iwp), intent(out) :: ICI(MBUF)
integer(kind=iwp) :: I, IBUF, IDD, IEND, ISECT, ISTA, JEND, JSTA, K
integer(kind=iwp), parameter :: IX1F = 1, IX2F = 2, IRR = 3, IX1R = 4, IX2R = 5, IX1X1 = 6, IX2X1 = 7, IX2X2 = 8, IFDF = 9, &
                                IFDR = 10, IRDR = 11
integer(kind=iwp), allocatable :: IDC(:), IDS(:)

! THIS SUBROUTINE LOOPS OVER SECTIONS OF PSI AND SIGMA ARRAYS
! ON DISK, AND ACCUMULATES OVERLAP MATRICES AND A COUPLE OF
! HAMILTONIAN MATRICES IN THE BASIS SET PSI, RHO, XI1 AND XI2.
! THE 11 MATRICES X1F,..,RDR ARE STORED CONSECUTIVELY IN THE
! SINGLE ARRAY ARR.
ARR(:,:,:) = Zero
call mma_allocate(IDC,NVEC,label='IDC')
call mma_allocate(IDS,NVEC,label='IDS')
do K=1,NVEC
  IDC(K) = IDISKC(K)
  IDS(K) = IDISKS(K)
end do
IDD = IDISKD
! LOOP OVER BUFFERS FOR READING PSI, SIGMA AND DBUF:
do ISTA=1,NCONF,MBUF
  IEND = min(NCONF,ISTA+MBUF-1)
  IBUF = 1+IEND-ISTA
  call dDAFILE(LUEIG,2,DBUF,IBUF,IDD)
  do K=1,NVEC
    call iDAFILE(LUEIG,2,ICI,IBUF,IDC(K))
    call UPKVEC(IBUF,ICI,CBUF(1,K))
    call dDAFILE(LUEIG,2,SBUF(1,K),IBUF,IDS(K))
  end do
  ! LOOP OVER VECTOR SECTIONS, LENGTH AT MOST NSECT:
  do JSTA=1,IBUF,NSECT
    JEND = min(IBUF,JSTA+NSECT-1)
    ISECT = 1+JEND-JSTA
    ! TRANSFORM TO EIGENFUNCTIONS OF HSMALL: FIRST, CI SECTION.
    call DGEMM_('N','N',ISECT,NRROOT,NVEC,One,CBUF(JSTA,1),MBUF,VSMALL,MXVEC,Zero,CSECT,NSECT)
    ! THEN, SIGMA SECTION INTO RSECT.
    call DGEMM_('N','N',ISECT,NRROOT,NVEC,One,SBUF(JSTA,1),MBUF,VSMALL,MXVEC,Zero,RSECT,NSECT)
    ! AND THEN FORM RSECT=SECTION OF RESIDUAL ARRAY, AND XI1 AND XI2:
    do I=1,ISECT
      do K=1,NRROOT
        RSECT(I,K) = RSECT(I,K)-ESMALL(K)*CSECT(I,K)
        XI1(I,K) = CSECT(I,K)/(DBUF(I+JSTA-1)-ESMALL(K))
        XI2(I,K) = RSECT(I,K)/(DBUF(I+JSTA-1)-ESMALL(K))
      end do
    end do
    ! ACCUMULATE OVERLAP MATRICES:
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI1,NSECT,CSECT,NSECT,One,ARR(1,1,IX1F),NRROOT)
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI2,NSECT,CSECT,NSECT,One,ARR(1,1,IX2F),NRROOT)
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,RSECT,NSECT,RSECT,NSECT,One,ARR(1,1,IRR),NRROOT)
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI1,NSECT,RSECT,NSECT,One,ARR(1,1,IX1R),NRROOT)
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI2,NSECT,RSECT,NSECT,One,ARR(1,1,IX2R),NRROOT)
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI1,NSECT,XI1,NSECT,One,ARR(1,1,IX1X1),NRROOT)
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI2,NSECT,XI1,NSECT,One,ARR(1,1,IX2X1),NRROOT)
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI2,NSECT,XI2,NSECT,One,ARR(1,1,IX2X2),NRROOT)
    ! PUT D*CSECT INTO XI1, AND D*RSECT INTO XI2:
    do I=1,ISECT
      do K=1,NRROOT
        XI1(I,K) = DBUF(I+JSTA-1)*CSECT(I,K)
        XI2(I,K) = DBUF(I+JSTA-1)*RSECT(I,K)
      end do
    end do
    ! ACCUMULATE ARRAYS FDF, FDR, AND RDR:
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI1,NSECT,CSECT,NSECT,One,ARR(1,1,IFDF),NRROOT)
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI1,NSECT,RSECT,NSECT,One,ARR(1,1,IFDR),NRROOT)
    call DGEMM_('T','N',NRROOT,NRROOT,ISECT,One,XI2,NSECT,RSECT,NSECT,One,ARR(1,1,IRDR),NRROOT)
    ! CONTINUE, NEXT SECTION.
  end do
  ! CONTINUE, NEXT BUFFER.
end do
call mma_deallocate(IDC)
call mma_deallocate(IDS)

return

end subroutine HZLP1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine TrGrd_Alaska(GradIn,nGrad)
********************************************************************
*                                                                  *
*      Transforms a symmetry adapted gradient to unsymmetric  form *
*                                                                  *
*       Written by Anders Bernhardsson                             *
*       960427                                                     *
********************************************************************
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8(a-h,o-z)
      parameter (tol=1d-8)
#include "Molcas.fh"
#include "disp.fh"
#include "real.fh"
#include "SysDef.fh"
      Real*8 CGrad(3,MxAtom)
      dimension GradIn(nGrad)
      Logical, External :: TF
*
      mdc=0
      iIrrep=0
*
      call dcopy_(3*MxAtom,[Zero],0,CGrad,1)
      iCen=0
      nCnttp_Valence=0
      Do iCnttp = 1, nCnttp
         If (dbsc(iCnttp)%Aux) Go To 999
         nCnttp_Valence = nCnttp_Valence+1
      End Do
 999  Continue
*
      Do iCnttp=1,nCnttp_Valence
         Do iCnt=1,dbsc(iCnttp)%nCntr
            mdc=mdc+1
            Do iCo=0,nIrrep/dc(mdc)%nStab-1
               kop=dc(mdc)%iCoSet(iCo,0)
               nDispS = IndDsp(mdc,iIrrep)
               iCen=iCen+1
               Do iCar=0,2
                  iComp = 2**iCar
                  If ( TF(mdc,iIrrep,iComp)) Then
                     nDispS = nDispS + 1
                     XR=DBLE(iPrmt(NrOpr(kop),icomp))
                     CGrad(iCar+1,iCen)=XR*GradIn(nDispS)
                  End If
               End Do
            End Do
         End Do
      End Do
*
*     Call RecPrt('CGrad',' ',CGrad,3,iCen)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mksymelm_cvb()

use casvb_global, only: ipr, norb, nsyme, recinp, symelm, tags
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: ioffs, isyme
logical(kind=iwp), external :: up2date_cvb ! ... Make: up to date? ...

call rdioff_cvb(8,recinp,ioffs)
call rdlow_cvb(symelm,nsyme*norb*norb,recinp,ioffs)
if ((ipr(2) >= 1) .and. (.not. up2date_cvb('PRSYMELM'))) then
  do isyme=1,nsyme
    write(u6,'(/,a,i4,3x,a)') ' Symmetry element no.',isyme,tags(isyme)
    call mxprint_cvb(symelm(:,:,isyme),norb,norb,0)
  end do
  if (nsyme > 0) write(u6,*) ' '
  call untouch_cvb('PRSYMELM')
end if

return

end subroutine mksymelm_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GeoDer(nAt,Cond,nTs,nS,Eps,Sphere,ISphe,NOrd,Tessera,Q,DerDM,Grd,DerTes,DerPunt,DerRad,DerCentr)

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt, nTs, nS, ISphe(nTs), NOrd(nS)
logical(kind=iwp), intent(in) :: Cond
real(kind=wp), intent(in) :: Eps, Sphere(4,nS), Tessera(4,nTs), Q(2,nTs), DerTes(nTs,nAt,3), DerPunt(nTs,nAt,3,3), &
                             DerRad(nS,nAt,3), DerCentr(nS,nAt,3,3)
real(kind=wp), intent(out) :: DerDM(nTs,nTs), Grd(3,nAt)
integer(kind=iwp) :: IAtom, iTs, IXYZ, jTs
real(kind=wp) :: GeoGrd, Qi, Qj

! Compute the PCM geometric contribution to gradients

Grd(:,:) = Zero
DerDM(:,:) = Zero
do IAtom=1,nAt
  do IXYZ=1,3
    ! Dielectric model
    if (.not. Cond) then
      call Over(IAtom,IXYZ,GeoGrd,nAt,nTs,nS,Eps,Sphere,ISphe,NOrd,Tessera,Q,DerRad,DerCentr)
    ! Conductor model
    else if (Cond) then
      GeoGrd = Zero
      call DerD(IAtom,IXYZ,Tessera,ISphe,DerDM,DerTes,DerPunt,DerCentr,nTs,nAt,nS)
      do iTs=1,nTs
        Qi = Q(1,iTs)+Q(2,iTs)
        do jTs=1,nTs
          Qj = Q(1,jTs)+Q(2,jTs)
          GeoGrd = GeoGrd+Qi*DerDM(iTs,jTs)*Qj
        end do
      end do
    end if
    Grd(IXYZ,IAtom) = GeoGrd*Half
  end do
end do

return

end subroutine GeoDer

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE WRMAT1(ND1,ND2,XMAT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XMAT(ND1,ND2)
      NCOL=5
C     NCOL=NR OF PRINTING COLUMNS.
      NBL=(ND2+NCOL-1)/NCOL
      DO 20 IBL=1,NBL
        JSTA=1+NCOL*(IBL-1)
        JEND=MIN(NCOL*IBL,ND2)
        WRITE(6,'(//,5(8X,I8),/)')(J,J=JSTA,JEND)
        DO 10 I=1,ND1
          WRITE(6,'(1X,I3,5(1X,G16.9))')I,(XMAT(I,J),J=JSTA,JEND)
10      CONTINUE
20    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!***********************************************************************

subroutine OpnOrd(rc,Option,FName,Lu)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Open the two-electron integral file and initialize/load          *
!     the table of contents.                                           *
!                                                                      *
!     input:                                                           *
!     option : Switch to set options                                   *
!              = 0 old file                                            *
!              = 1 new file                                            *
!     FName  : Logical file name                                       *
!     Lu     : FORTRAN unit number                                     *
!                                                                      *
!     output:                                                          *
!     rc     : Return code.                                            *
!              A value of 0 (zero) is returned upon successful         *
!              completion of the request. A nonzero value indi-        *
!              cates an error.                                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher                                                  *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use TwoDat, only: AuxTwo, FInfoTwo, iNoNum, lTocTwo, isId, isForm, isPkPa, isVer, rcTwo, sNew, TocTwo
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp), intent(in) :: Option, Lu
character(len=*), intent(in) :: FName
integer(kind=iwp) :: iDisk, iDummy, LuTwo, nDummy1(8), nDummy2(8), rd_Dummy, SumOpt
logical(kind=iwp) :: Exists, lDummy, NewToc
character(len=8) :: FnTwo
integer(kind=iwp), parameter :: NaN = -1
character(len=*), parameter :: TheName = 'OpnOrd'

!----------------------------------------------------------------------*
! Start procedure:                                                     *
!----------------------------------------------------------------------*
rc = rcTwo%good
!----------------------------------------------------------------------*
! Check the file status                                                *
!----------------------------------------------------------------------*
AuxTwo%Opn = .false.
AuxTwo%Unt = iNoNum
AuxTwo%DaDa = iNoNum
TocTwo(isPkPa) = iNoNum
call StdFmt(FName,FnTwo)
LuTwo = Lu
call f_Inquire(FnTwo,Exists)
!----------------------------------------------------------------------*
! Check the options                                                    *
!----------------------------------------------------------------------*
if (Option /= 0) then
  SumOpt = 0
  if (btest(Option,sNew)) SumOpt = ibset(SumOpt,sNew)
  if (SumOpt /= Option) then
    call SysWarnMsg(TheName,'MSG: invalid option',' ')
    call SysCondMsg('SumOpt /= Option',SumOpt,'/=',Option)
  end if
end if
NewToc = btest(Option,sNew)
!----------------------------------------------------------------------*
! Compare file status with options                                     *
!----------------------------------------------------------------------*
if ((.not. Exists) .and. (.not. NewToc)) then
  !--------------------------------------------------------------------*
  ! Old file did not exist                                             *
  !--------------------------------------------------------------------*
  call SysAbendMsg(TheName,'ORDINT file does not exist',' ')
else if (NewToc) then
  !--------------------------------------------------------------------*
  ! New Toc                                                            *
  !--------------------------------------------------------------------*
  call DaName_MF(LuTwo,FnTwo)
  TocTwo(:) = NaN
  TocTwo(isId) = FInfoTwo%ID
  TocTwo(isVer) = FInfoTwo%VN
  TocTwo(isForm) = 0
  iDisk = 0
  call iDaFile(LuTwo,1,TocTwo,lTocTwo,iDisk)
  AuxTwo%Opn = .true.
  AuxTwo%Unt = LuTwo
  AuxTwo%DaDa = 0
else
  !--------------------------------------------------------------------*
  ! Keep Toc                                                           *
  !--------------------------------------------------------------------*
  call DaName_MF(LuTwo,FnTwo)
  iDisk = 0
  call iDaFile(LuTwo,2,TocTwo,lTocTwo,iDisk)
  if ((TocTwo(isId) /= FInfoTwo%ID) .or. (TocTwo(isVer) /= FInfoTwo%VN)) &
    call SysFileMsg(TheName,'file version number is outdated',LuTwo,' ')
  AuxTwo%Opn = .true.
  AuxTwo%Unt = LuTwo
  AuxTwo%DaDa = iDisk
end if

! Call to GetOrd to fill nBatch etc.

if (Option == 0) call GetOrd(rd_Dummy,lDummy,iDummy,nDummy1,nDummy2)

!----------------------------------------------------------------------*
! normal end                                                           *
!----------------------------------------------------------------------*
return

end subroutine OpnOrd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ClasClas(iCNum,iCStart,ncParm,Coord,iFP,iGP,iDT,iFI
     &                ,iDist,iDistIm,Elene,Edisp,Exrep,E2Die,ExDie)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "qmcom.fh"
#include "WrkSpc.fh"

      Dimension iFP(3),iGP(3),iDT(3),iFI(3)
      Dimension Coord(MxAt*3)
      Character Memlabel*20,Memlaabe*20,Memlaaab*20,MemLaaaa*20,ChCo*2
      Parameter (ExLim=10)

*----------------------------------------------------------------------*
* Compute the distance matrices between the classical centers and the  *
* classical image centers.                                             *
*----------------------------------------------------------------------*
      nClas=nPart-iCNum
      Adisp=Disp(1,2)
      nSize=(nClas*(nClas-1)/2)*(nCent**2)   !Get memory
      Call GetMem('DistMat','Allo','Real',iDist,nSize)
      nSizeIm=(nClas*nCent)**2
      Call GetMem('DistMatIm','Allo','Real',iDistIm,nSizeIm)
      Ind=0
      Do 201, ii=iCNum+2,nPart
        Do 202, jj=iCNum+1,ii-1
          Do 203, ij=1,nCent
            i=(ii-1)*nCent+ij
            Do 204, k=1,nCent
              Ind=Ind+1
              j=(jj-1)*nCent+k
              r=0
              Do 205, l=1,3
                r=(Cordst(i,l)-Cordst(j,l))**2+r
205           Continue
              Work(iDist+Ind-1)=1/Sqrt(r)
204         Continue
203       Continue
202     Continue
201   Continue
      Jnd=0
      Do 206, i=iCStart,nCent*nPart
        Do 207, j=iCStart,nCent*nPart
          Jnd=Jnd+1
          r=0
          Do 208, k=1,3
            r=(CordIm(i,k)-Cordst(j,k))**2+r
208       Continue
          Work(iDistIm+Jnd-1)=1.0d0/Sqrt(r)
207     Continue
206   Continue
*----------------------------------------------------------------------*
* Compute the pairwise interaction between the solvent. Classical all  *
* the  way... early NEMO all the way.                                  *
*----------------------------------------------------------------------*
      Elene=0
      Edisp=0
      Exrep=0
      aLim=1.0d0/ExLim
      Sum1=0
      Sum2=0
      Sum3=0
      Sum4=0
*The electrostatic part
      Do 2011, i=1,nSize,nCent**2  !This loop ONLY works for the
                     !early Nemo model of water. If the solvent
                   !model is changed this loop must be rewritten.
        Sum1=Sum1+Work(iDist+i-1+6)*Qsta(1)*Qsta(1)!H-H
        Sum2=Sum2+Work(iDist+i-1+7)*Qsta(1)*Qsta(2)!H-H
        Sum3=Sum3+Work(iDist+i-1+8)*Qsta(1)*Qsta(3)!H-V
        Sum4=Sum4+Work(iDist+i-1+9)*Qsta(1)*Qsta(4)!H-V
        Sum1=Sum1+Work(iDist+i-1+11)*Qsta(2)*Qsta(1)!H-H
        Sum2=Sum2+Work(iDist+i-1+12)*Qsta(2)*Qsta(2)!H-H
        Sum3=Sum3+Work(iDist+i-1+13)*Qsta(2)*Qsta(3)!H-V
        Sum4=Sum4+Work(iDist+i-1+14)*Qsta(2)*Qsta(4)!H-V
        Sum1=Sum1+Work(iDist+i-1+18)*Qsta(3)*Qsta(3)!V-V
        Sum2=Sum2+Work(iDist+i-1+19)*Qsta(3)*Qsta(4)!V-V
        Sum3=Sum3+Work(iDist+i-1+16)*Qsta(3)*Qsta(1)!V-H
        Sum4=Sum4+Work(iDist+i-1+17)*Qsta(3)*Qsta(2)!V-H
        Sum1=Sum1+Work(iDist+i-1+23)*Qsta(4)*Qsta(3)!V-V
        Sum2=Sum2+Work(iDist+i-1+24)*Qsta(4)*Qsta(4)!V-V
        Sum3=Sum3+Work(iDist+i-1+21)*Qsta(4)*Qsta(1)!V-H
        Sum4=Sum4+Work(iDist+i-1+22)*Qsta(4)*Qsta(2)!V-H
2011  Continue
      Elene=Sum1+Sum2+Sum3+Sum4

      Sum1=0
      Sum2=0
      Sum3=0
      Sum4=0
      Sum5=0
*The dispersion, now with damping.
      Do 211, i=1,nSize,nCent**2
        DampFunk=1-Exp(-1.0d0/(Work(iDist+i-1)*2.2677d0))**4
        Sum1=Sum1+Work(iDist+i-1)**6*DampFunk
        DampFunk=1-Exp(-1.0d0/(Work(iDist+i-1+1)*2.2677d0))**4
        Sum2=Sum2+Work(iDist+i-1+1)**6*DampFunk
        DampFunk=1-Exp(-1.0d0/(Work(iDist+i-1+2)*2.2677d0))**4
        Sum3=Sum3+Work(iDist+i-1+2)**6*DampFunk
        DampFunk=1-Exp(-1.0d0/(Work(iDist+i-1+11)*2.2677d0))**4
        Sum4=Sum4+Work(iDist+i-1+11)**6*DampFunk
        DampFunk=1-Exp(-1.0d0/(Work(iDist+i-1+7)*2.2677d0))**4
        Sum5=Sum5+Work(iDist+i-1+7)**6*DampFunk
        DampFunk=1-Exp(-1.0d0/(Work(iDist+i-1+5)*2.2677d0))**4
        Sum2=Sum2+Work(iDist+i-1+5)**6*DampFunk
        DampFunk=1-Exp(-1.0d0/(Work(iDist+i-1+10)*2.2677d0))**4
        Sum3=Sum3+Work(iDist+i-1+10)**6*DampFunk
        DampFunk=1-Exp(-1.0d0/(Work(iDist+i-1+6)*2.2677d0))**4
        Sum4=Sum4+Work(iDist+i-1+6)**6*DampFunk
        DampFunk=1-Exp(-1.0d0/(Work(iDist+i-1+12)*2.2677d0))**4
        Sum5=Sum5+Work(iDist+i-1+12)**6*DampFunk
211   Continue
      Edisp=Sum1*Disp(1,1)+(Sum2+Sum3)*Disp(1,2)+(Sum4+Sum5)*Disp(2,2)
*The exchange repulsion
      Do 221, i=1,nSize,nCent**2
        If(Work(iDist+i-1).gt.aLim) Exrep=Exrep+
     &                          ExNemo(1,1,Work(iDist+i-1))
        If(Work(iDist+i-1+1).gt.aLim) Exrep=Exrep+
     &                          ExNemo(1,2,Work(iDist+i-1+1))
        If(Work(iDist+i-1+2).gt.aLim) Exrep=Exrep+
     &                          ExNemo(1,2,Work(iDist+i-1+2))
        If(Work(iDist+i-1+5).gt.aLim) Exrep=Exrep+
     &                          ExNemo(1,2,Work(iDist+i-1+5))
        If(Work(iDist+i-1+6).gt.aLim) Exrep=Exrep+
     &                          ExNemo(2,2,Work(iDist+i-1+6))
        If(Work(iDist+i-1+7).gt.aLim) Exrep=Exrep+
     &                          ExNemo(2,2,Work(iDist+i-1+7))
        If(Work(iDist+i-1+10).gt.aLim) Exrep=Exrep+
     &                          ExNemo(1,2,Work(iDist+i-1+10))
        If(Work(iDist+i-1+11).gt.aLim) Exrep=Exrep+
     &                          ExNemo(2,2,Work(iDist+i-1+11))
        If(Work(iDist+i-1+12).gt.aLim) Exrep=Exrep+
     &                          ExNemo(2,2,Work(iDist+i-1+12))
221   Continue
*----------------------------------------------------------------------*
* Compute pair-wise interaction with image charges.                    *
*----------------------------------------------------------------------*
      Sum1=0.0d0
      Sum2=0.0d0
      Do 231, i=iCNum+1,nPart
        Do 232, j=nCent-nCha+1,nCent  !Only count over
                                   !charged centers.
          Q1=QIm((i-1)*nCent+j)  !The image charge.
          Inc=ncParm*nCent*(i-(iCNum+1))+(j-1)*ncParm !Counting
                                                  !elements.
          Do 233, k=nCent-nCha+1,nCent
            Inc2=Inc+k
            Q2=QSta(k-nCent+nCha)
            Do 234, l=iCNum+1,nPart !Here is the electrostatic
           !interaction computed. Observe the difference with the real
              !charges, since here interaction between ALL
             !real-image charge pair is computed.
            Sum1=Sum1+Q1*Q2*Work(iDistIm+Inc2+(l-(iCnum+1))*nCent-1)
         Sum1=Sum1-Adisp*Work(iDistIm+Inc2+(l-(iCnum+1))*nCent-1)**6
     &       *(1-Exp(-1/(Work(iDistIm+Inc2+(l-(iCnum+1))*nCent-1)
     &       *2.9677d0)**6))
234         Continue
233       Continue
232     Continue
* Include a repulsion with the boundary to prevent the waters to merge
*into the dielectric continuum. Its construction is such that the
*repulsion only is between the particle and the image of the particle,
*no other repulsion over the boundary.
        Sum2=Sum2+ExNemo(1,2,Work(iDistIm-1+(i-(iCNum+1))
     &       *nClas*nCent**2
     &       +(nClas+i-(iCNum+1))*nCent+2))
        Sum2=Sum2+ExNemo(1,2,Work(iDistIm-1+(i-(iCNum+1))
     &       *nClas*nCent**2
     &       +(2*nClas+i-(iCNum+1))*nCent+3))
        Sum2=Sum2+ExNemo(1,1,Work(iDistIm-1+(i-(iCNum+1))
     &       *nClas*nCent**2
     &       +1+(i-(iCNum+1))*nCent))*Exdt1
231   Continue
      E2Die=sum1*0.5d0  !The half is added since what we actually has
          !computed is the interaction between charge and a part
          !of its reaction field (recall:0.5*q*fi_q).
      EXDie=sum2*0.5d0*ExdTal
*----------------------------------------------------------------------*
* Compute the static electric field on the polarizabilities and obtain *
* initial guess of induced dipoles.                                    *
*----------------------------------------------------------------------*
      IndMa=nPol*nPart
      Do 300,i=1,3   !Allocate memory
        Write(ChCo,'(I2.2)')i
        Write(MemLabel,*)'FP'//ChCo
        Write(MemLaabe,*)'GP'//ChCo
        Write(MemLaaab,*)'DT'//ChCo
        Write(MemLaaaa,*)'FI'//ChCo
        !Explanation: iFP-field iGP plus reaction field,
        !      iGP-field from real charges on polarizable centers,
        !      iFi-induced field.
        Call GetMem(MemLabel,'Allo','Real',iFP(i),IndMa)
        Call GetMem(MemLaabe,'Allo','Real',iGP(i),IndMa)
        Call GetMem(MemLaaab,'Allo','Real',iDT(i),IndMa)
        Call GetMem(MemLaaaa,'Allo','Real',iFi(i),IndMa)
300   Continue
      Do 302, j=1,3
        Do 301, i=0,Indma-1  !Set some zeros
          Work(iFI(j)+i)=0.0d0
          Work(iGP(j)+i)=0.0d0
          Work(iDT(j)+i)=0.0d0
          Work(iFP(j)+i)=0.0d0
301     Continue
302   Continue
*Real centers: The field at the polarizabilities - no reaction field.
      Ind=0
      Do 310, ii=iCNum+2,nPart
        Do 311, jj=iCNum+1,ii-1
          Do 312, ij=1,nCent
            i=(ii-1)*nCent+ij
            Do 313, l=1,nCent
              j=(jj-1)*nCent+l
              Ind=Ind+1
              X=Cordst(i,1)-Cordst(j,1)
              Y=Cordst(i,2)-Cordst(j,2)
              Z=Cordst(i,3)-Cordst(j,3)
              ri=Work(iDist+Ind-1)**3
              If(ij.gt.(nCent-nCha).and.l.le.nPol) then
                          !Given that ij is
                          !counting on centers with charges and
                          !l on polarizable centers, then compute
                         !the field from charge ij on center l.
                Q1=Qsta(ij-nCent+nCha)
                Ind1=(jj-1)*nPol+l
                Work(iGP(1)+Ind1-1)=Work(iGP(1)+Ind1-1)+x*Q1*ri
                Work(iGP(2)+Ind1-1)=Work(iGP(2)+Ind1-1)+y*Q1*ri
                Work(iGP(3)+Ind1-1)=Work(iGP(3)+Ind1-1)+z*Q1*ri
              Endif
              If(l.gt.(nCent-nCha).and.ij.le.nPol) then  !If ij is
                       !on center with polarizability and l is on
                       !center with charge, then compute the field
                       !from charge l on center ij.
                Q2=Qsta(l-nCent+nCha)
                Ind1=(ii-1)*nPol+ij
                Work(iGP(1)+Ind1-1)=Work(iGP(1)+Ind1-1)-x*Q2*ri
                Work(iGP(2)+Ind1-1)=Work(iGP(2)+Ind1-1)-y*Q2*ri
                Work(iGP(3)+Ind1-1)=Work(iGP(3)+Ind1-1)-z*Q2*ri
              Endif
313         Continue
312       Continue
311     Continue
310   Continue
      Epoll=0
      Do 320, i=1+nPol*iCNum,IndMa !Compute polarization energy.
                              !This is only for checking, and will
                              !not enter the energy expression.
        k=i-((i-1)/nPol)*nPol
        Work(iFP(1)+i-1)=Work(iGP(1)+i-1)
        Work(iFP(2)+i-1)=Work(iGP(2)+i-1)
        Work(iFP(3)+i-1)=Work(iGP(3)+i-1)
        F=(Work(iFP(1)+i-1)**2+Work(iFP(2)+i-1)**2+Work(iFP(3)+i-1)**2)
     &   *Pol(k)
        Epoll=Epoll+F
320   Continue
      Epoll=-Epoll*0.5d0
*Image centers: The field at the polarizabilities - reaction field to the
*point charges added.
      Do 330, i=iCStart,nCent*nPart
        Q=Qim(i)
        Do 331, k=1,nPol
          indSep=(i-iCStart)*nCent*(nPart-iCNum)+k
          indR=k+iCNum*nCent
          indF=k+iCNum*nPol
          Do 332, j=nPol*(iCNum+1),IndMa,nPol
            x=CordIm(i,1)-Cordst(indR,1)
            y=CordIm(i,2)-Cordst(indR,2)
            z=CordIm(i,3)-Cordst(indR,3)
            r3=Work(iDistIm-1+indSep)**3
            Work(iFP(1)+indF-1)=Work(iFP(1)+indF-1)+x*Q*r3
            Work(iFP(2)+indF-1)=Work(iFP(2)+indF-1)+y*Q*r3
            Work(iFP(3)+indF-1)=Work(iFP(3)+indF-1)+z*Q*r3
            indR=indR+nCent
            indSep=indSep+nCent
            indF=indF+nPol
332       Continue
331     Continue
330   Continue
*We obtain an initial guess of the induced dipoles on the solvent.
      Do 340, i=1+nPol*iCnum,IndMa
        k=i-((i-1)/nPol)*nPol
        Do 341, l=1,3
          Work(iDt(l)+i-1)=Work(iFP(l)+i-1)*Pol(k)
341     Continue
340   Continue

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Coord)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine chcc(ireturn)
! docasny drajver reorder procesu

use chcc_global, only: conv, deallocate_arrays, generkey, maxiter, nc, printkey, restkey, TCpu, TCpu_l, TCpu0, TWall, TWall_l, &
                       TWall0
use Para_Info, only: MyRank, nProcs
#ifdef _MOLCAS_MPP_
use chcc_global, only: NChLoc
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: iter, Jal1, Jal2, LunAux, maxdim, maxspace, NchBlk, NChHere, NvGrp, NvSGrp, wrksize
real(kind=wp) :: e1new, e1old, e2new, e2old, e2os, escf
real(kind=wp), allocatable :: wrk(:)

!mp

#ifdef _MOLCAS_MPP_
if (is_real_par()) then
  write(u6,*) ' Parallel run'
else
  write(u6,*) ' Serial run'
end if
!mp write(u6,*) ' MyRank, Nprocs',MyRank,Nprocs
#else
write(u6,*) ' Serial run'
!mp write(u6,*) ' MyRank, Nprocs',MyRank,Nprocs
#endif
!mp
! vynuluj hodiny
call CWTime(TCpu,TWall)
TCpu0 = TCpu
TWall0 = TWall
TCpu_l = TCpu
TCpu_l = TCpu
TWall_l = TWall
TWall_l = TWall
!mp

!@@ real(kind=wp), allocatable :: wrk(:)
!   real(kind=wp) :: wrk(1:40000000)
!   real(kind=wp) :: wrk(1:26593281)
!   wrksize = 26593281
!   wrksize = 40000000

!mp ##########################################################
!0  info o cholesky vektoroch

call frankie_drv_fake(NChHere)
write(u6,'(A,i9,A,i4)') ' Number of Cholesky vectors ',NChHere,' on node ',myRank

#ifdef _MOLCAS_MPP_

NChLoc(:) = 0

NChLoc(MyRank) = NChHere
call gaigop(NChLoc(0),NProcs,'+')

jal2 = sum(NChLoc)

nc = jal2
#else
nc = NChHere
#endif
!mp ##########################################################
!
! Get the maximum available memory

call mma_maxDBLE(maxspace)
maxspace = maxspace-8
write(u6,'(A,i13,A,f9.1,A,f5.1,A)') ' Max Size              : ',maxspace,' in r*8 Words,',real(maxspace*8,kind=wp)/1024**2,' Mb,', &
                                    real(maxspace,kind=wp)*8/1024**3,' Gb'

!1 Nacitanie vstupu (Docasne) + time Delay

call IniReord(NvGrp,NvSGrp,NchBlk,LunAux)
!mp call TimeDelay(LunAux) ! temporarily disabled (MP)

! Decide on automatic segmentation generation
if (NvGrp == 0) then
  call autoSegmentation(Nprocs,maxspace,Jal1,Jal2,NvGrp,NvSGrp,NchBlk,wrksize,maxdim)
else
  call checkMem(NvGrp,NvSGrp,NchBlk,Jal1,Jal2,wrksize,maxdim)

  if (wrksize > maxspace) then
    write(u6,*) ' Not Enough Memory! Increase large and/or small segmentation',real(wrksize,kind=wp)/real(maxspace,kind=wp)
    call abend()
  end if
end if

! write Large segmentation to RunFile
call Put_iScalar('CHCCLarge',NvGrp)

! ---------------------------------------------------------
!
! Transformation of Local L(ao) -> L(mo)
! CD1tmp file is created

call frankie_drv(NChHere)
if (printkey >= 10) write(u6,*) ' After Frankie',myRank,NChHere

! ---------------------------------------------------------

call mma_allocate(wrk,wrksize,label='CCSD')
write(u6,'(A,i13,A,f9.1,A,f5.1,A)') ' Real Allocated Memory : ',wrksize,' in r*8 Words,',real(wrksize,kind=wp)*8/1024**2,' Mb,', &
                                    real(wrksize,kind=wp)*8/1024**2,' Gb'
wrk(:) = Zero

!3 Priprava integralov

call Reord_chcc(wrk,wrksize,NvGrp,NvSGrp,NchBlk,LunAux)
if (generkey == 1) then
  !mp if (printkey >= 10) then ! uvidime ...
  write(u6,*) ' Generation of integrals (Reord_chcc) done'
  write(u6,*)
  !mp end if
else
  write(u6,*) ' Generation of integrals (Reord_chcc) skipped, only basic'
  write(u6,*)
end if
!mp
call CWTime(TCpu,TWall)

if (printkey > 1) then
  write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
  write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
  write(u6,*)
  write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
  write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
  write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
  write(u6,*)
end if
TCpu_l = TCpu
TWall_l = TWall
!mp

!4 Restart, ak treba

if (restkey == 1) then
  ! read T1o,niter,E1old,E2old (T2 are in T2files)
  call GetRest(wrk,wrksize,LunAux,iter,E1old,E2old)
else
  !Bug v originale chyba
  ! set T1o=0
  call VanishT1(wrk,wrksize)

  !@@
  !write(u6,*) ' Pred Chck'
  !call MakeChckData(wrk,wrksize,LunAux)
  !call SaveChckData(LunAux)
  !call GetChckData(LunAux)
  !write(u6,*) ' Chck  done'
  !@@

  !5 iteracny cyklus

  e1old = Zero
  e2old = Zero
  iter = 1

  !mp

  write(u6,*)
  write(u6,*) '------------------------'
  write(u6,*) 'Starting CCSD iterations'
  write(u6,*) '------------------------'
  write(u6,*)

  write(u6,*) '                  CCSD Energy      Difference'
  write(u6,*)
  !mp!
  call xflush(u6)
  !mp!

  call CWTime(TCpu,TWall)

  if (printkey > 1) then
    write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
    write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
    write(u6,*)
    write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
    write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
    write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
    write(u6,*)
  end if
  TCpu_l = TCpu
  TWall_l = TWall
  !mp
end if

do

  call o3v3ctl(wrk,wrksize,NvGrp,LunAux)
  if (printkey > 1) write(u6,*) ' o3v3 done'
  !mp
  call CWTime(TCpu,TWall)
  if (printkey > 1) then
    write(u6,*)
    write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
    write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
    write(u6,*)
    write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
    write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
    write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
    write(u6,*)
  end if
  TCpu_l = TCpu
  TWall_l = TWall
  !mp
  call o2v4ctl(wrk,wrksize,NvGrp,NvSGrp,LunAux)
  if (printkey > 1) write(u6,*) ' o2v4 done'
  !mp
  call CWTime(TCpu,TWall)
  if (printkey > 1) then
    write(u6,*)
    write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
    write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
    write(u6,*)
    write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
    write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
    write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
    write(u6,*)
  end if
  TCpu_l = TCpu
  TWall_l = TWall
  !mp
  call summary(wrk,wrksize,NvGrp,LunAux,maxdim,e1new,e2new,e2os)
  if (printkey > 1) write(u6,*) ' summary done'
  !mp
  call CWTime(TCpu,TWall)
  if (printkey > 1) then
    write(u6,*)
    write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
    write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
    write(u6,*)
    write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
    write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
    write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
    write(u6,*)
  end if
  TCpu_l = TCpu
  TWall_l = TWall
  !mp
  call SaveRest(wrk,wrksize,LunAux,(iter+1),E1new,E2new)

  !mp write(u6,91) ' Iteration :',iter,e1new,e2new,e1old+e2old-e1new-e2new
  !mp 91 format(a12,1x,i3,1x,3(f15.12,1x))

  if (iter == 1) then
    write(u6,91) ' Iteration :',iter,e2new
  else
    write(u6,93) ' Iteration :',iter,e2new,e1old+e2old-e1new-e2new
  end if

  call xflush(u6)

  if ((abs(e1old+e2old-e1new-e2new) <= conv) .or. (iter >= maxiter)) exit
  e1old = e1new
  e2old = e2new
  iter = iter+1

end do

write(u6,*)
write(u6,*) ' Final CCSD energy decomposition'
write(u6,92) ' E1 CCSD energy :',e1new
write(u6,92) ' E2 CCSD energy :',e2new
write(u6,92) ' E2 CCSD ss     :',e2new-e2os
write(u6,92) ' E2 CCSD os     :',e2os
write(u6,*)
!mp for MOLCAS verify
call Get_dScalar('SCF energy',escf)
call Add_Info('CHCCene',[e2new],1,6)
call Add_Info('E_CHCC',[e2new],1,6)
call Add_Info('E_HYPE',[e2new+escf],1,6)
! for NUMERICAL_GRADIENTS
call Put_cArray('Relax Method','CHCC    ',8)
call Store_Energies(1,e2new+escf,1)
!mp

!@@ deallocate(wrk)
call mma_deallocate(wrk)
call deallocate_arrays()

ireturn = 0

return

91 format(a12,1x,i3,1x,f15.12,1x)
92 format(a17,1x,f15.12)
93 format(a12,1x,i3,1x,2(f15.12,1x))

end subroutine chcc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module qmstat_global

use Definitions, only: wp, iwp

implicit none
private

!----------------------------------------------------------------------*
! Define some bounds for qmstat.
!----------------------------------------------------------------------*
! MxAngqNr      -        Maximal angular quantum number for basis
!                        functions in QM-region. 1 is s, 2 is p etc.
! MxMltp        -        Highest order multipole in MME
! MxPut         -        Maximal number of molecules to put in system
! MxSymQ        -        Maximal number of symmetries
!----------------------------------------------------------------------*

!----------------------------------------------------------------------*
! Common variables shared by all QmTypes.
!----------------------------------------------------------------------*
! INTEGER:
! --------
! lMax          -        How many bases in solvent region.
! info_atom     -        Atomic number of QM atoms.
!
! REAL:
! -----
! QIm           -       Vector of charges of the imagepoints.
! CordIm        -       Coordinates of the imagepoints.
! QImp          -       Image charge due to dipole in cavity.
! DipIm         -       Image dipole due to dipole in cavity.
! c_orbene      -       Solvent orbital energies.
! ChaNuc        -       Nuclear charges.
! qTot          -       Total charge on QM molecule.
! xyzMyQ        -       Total dipole of QM-region.
! xyzMyI        -       The induced dipole of QM-region.
! xyzMyP        -       Total dipole of the explicit solvent.
! xyzQuQ        -       Total traceless quadrupole moment of QM-region.
! CT            -       Centre of mass for QM-molecule.
!----------------------------------------------------------------------*

!----------------------------------------------------------------------*
! Common variables, unique for SCF.
!----------------------------------------------------------------------*
! INTEGER:
! --------
! SupM          -       The supermatrix.
! V1            -       MO-coefficients for QM-region.
!
! REAL:
! -----
! HHMat         -       The one-electron contribution to the Hamiltonian.
! outxyz        -       Coordinates of the MME-sites in the QM-mol.
! Cha           -       The charges in the MME expansion.
! DipMy         -       The dipoles in the MME expansion.
! Quad          -       The quadrupoles in the MME expansion.
! PotNuc        -       Nuclear repulsion.
! DenCorrD      -       Density difference between HF and MP2.
! Trace_MP2     -       Trace to MP2-HF difference density.
!----------------------------------------------------------------------*

!----------------------------------------------------------------------*
! Variables to include for the Rassi-stuff.
!----------------------------------------------------------------------*
! INTEGER:
! --------
! nState        -       Number of contracted RASSI states.
! BigT          -       ALL Gamma-matrices.
! nRedMO        -       Number of reduced MOs in reduced basis.
! AvRed         -       Optional reduced MO-basis.
!
! REAL:
! -----
! HmatState     -       The Hamiltonian matrix.
! HmatSOld      -       The stored Hamiltonian matrix.
! RasCha        -       MME-charges.
! RasDip        -       MME-dipoles.
! RasQua        -       MME-quadrupoles.
! outxyzRAS     -       The MME-centers for RASSI.
!----------------------------------------------------------------------*

!----------------------------------------------------------------------*
! iQn           -       Array that specifies the angular momentum
!                       quantum number for each basis function on
!                       solvent molecules.
! iQang         -       Like iQn, but for QM-region.
! nPrimus       -       Actually a rewriting of Icon.
! mPrimus       -       Like nPrim but for solvent.
! iWoGehenQ     -       The (ith,jth) element tells which index the
!                       ith QM-region base (not basis-function) of
!                       the jth m_l-quantum number is to take.
!                       Needed when ordering the AO-overlaps.
! iWoGehenC     -       Like iWoGehenQ but for solvent molecule.
! nBonA_Q       -       Number of basis functions on atoms in QM.
! nBonA_C       -       Like nBonA_Q but for solvent molecule.
! CasOri        -       Array with coordinates for each basis
!                       function for solvent molecules.
! SavOri        -       Initially like CasOri, but not overwritten.
! BasOri        -       Like CasOri, but for QM-region.
! Alfa          -       Basis exponents.
! Beta          -       Like Alfa but for solvent.
! Cont          -       Contraction coefficients for QM-region.
! Dont          -       Like Cont but for solvent.
! V3            -       Original solvent MOs.
! Trans         -       Cartesian to spherical transformation.
!----------------------------------------------------------------------*

integer(kind=iwp), parameter :: MxAngqNr = 7, MxMltp = 3, MxPut = 220, MxSymQ = 1

integer(kind=iwp) :: iExtr_Eig, iExtra, iLuSaIn, iLuSaUt, iLuStIn, iLuStUt, iNrIn, iNrUt, Inter, iOcc1, iOrb(3), iPrint, iRead, &
                     iSeed, iSta, iTcSim(64), itMax, lmax, lMltSlC, nAdd, nAtom, nCent, nCha, nCIRef, nDel, nEqState, nExtAddOns, &
                     nLvlShift, nMacro, nMicro, nMlt, nPart, nPol, nRedMO, NrFiles, NrStarti, NrStartu, nSlSiteC, nState, nTemp
real(kind=wp) :: CAFieldG, CBFieldG, CFexp, CharDi(2), CT(3), Cut_Elc, Cut_Ex1, Cut_Ex2, DelFi, DelR, DelX, Diel, DifSlExp, &
                 dLJrep, Enelim, Exdt1, Exdtal, Exrep10, Exrep2, Exrep4, Exrep6, Forcek, Pollim, PotNuc, Pres, qTot, QuaDi(3,2), &
                 rStart, Surf, Temp, ThrsCont, ThrsRedOcc, Trace_MP2, xyzMyI(3), xyzMyP(3), xyzMyQ(3), xyzQuQ(6)
logical(kind=iwp) :: AddExt, Anal, ATitle, ChargedQM, ContrStateB, DelOrAdd(12), DispDamp, EdSt, FieldDamp, lCiSelect, lExtr(12), &
                     lQuad, lSlater, MoAveRed, Mp2DensCorr, ParallelT, Qmeq, QmProd, SingPoint
character(len=100) :: JobLab
character(len=10) :: cDumpForm
character(len=6) :: StFilIn, SaFilIn, StFilUt, SaFilUt, FieldNuc, SimEx, RassiM, EigV, QmType
integer(kind=iwp), allocatable :: iCIInd(:), iCompExt(:), iExtr_Atm(:), iLvlShift(:), info_atom(:), iQang(:), iQn(:), &
                                  iWoGehenC(:,:), iWoGehenQ(:,:), mPrimus(:), nPrimus(:), nBA_C(:), nBA_Q(:), nBonA_C(:), &
                                  nBonA_Q(:), nCBoA_C(:,:), nCBoA_Q(:,:), nCnC_C(:), NrStates(:), nStFilT(:)
real(kind=wp), allocatable :: Alfa(:,:), AvElcPot(:,:), AvRed(:,:), BasOri(:,:), Beta(:,:), BigT(:,:), c_orbene(:), CasOri(:,:), &
                              Cha(:,:), ChaNuc(:), CharDiQ(:), Cont(:,:), CordIm(:,:), Cordst(:,:), dCIRef(:), DenCorrD(:), &
                              DipIm(:,:), DipMy(:,:,:), Disp(:,:), dLvlShift(:), Dont(:,:), FockM(:), HHmat(:), HmatSOld(:), &
                              HmatState(:), OldGeo(:,:), outxyz(:,:), outxyzRAS(:,:), Paratemps(:), PertNElcInt(:), Pol(:), &
                              QIm(:), QImp(:), Qsta(:), Quad(:,:,:), QuaDiQ(:,:), RasCha(:,:), RasDip(:,:,:), RasQua(:,:,:), &
                              SavOri(:,:), ScalExt(:), Sexre1(:,:), Sexre2(:,:), Sexrep(:,:), SlExpC(:,:), SlExpQ(:,:), &
                              SlFactC(:,:), SlPC(:), Sqrs(:), SupM(:,:), Trans(:), Udisp(:,:), V1(:,:), V3(:,:)
character(len=8), allocatable :: ExtLabel(:)

public :: AddExt, Alfa, Anal, ATitle, AvElcPot, AvRed, BasOri, Beta, BigT, c_orbene, CAFieldG, CasOri, CBFieldG, cDumpForm, CFexp, &
          Cha, ChaNuc, CharDi, CharDiQ, ChargedQM, Cont, ContrStateB, CordIm, Cordst, CT, Cut_Elc, Cut_Ex1, Cut_Ex2, dCIRef, &
          DelFi, DelOrAdd, DelR, DelX, DenCorrD, Diel, DifSlExp, DipIm, DipMy, Disp, DispDamp, dLJrep, dLvlShift, Dont, EdSt, &
          EigV, Enelim, Exdt1, Exdtal, Exrep10, Exrep2, Exrep4, Exrep6, ExtLabel, FieldDamp, FieldNuc, FockM, Forcek, HHMat, &
          HmatSOld, HmatState, iCIInd, iCompExt, iExtr_Atm, iExtr_Eig, iExtra, iLuSaIn, iLuSaUt, iLuStIn, iLuStUt, iLvlShift, &
          info_atom, iNrIn, iNrUt, Inter, iOcc1, iOrb, iPrint, iQang, iQn, iRead, iSeed, iSta, iTcSim, itMax, iWoGehenC, &
          iWoGehenQ, JobLab, lCiSelect, lExtr, lmax, lMltSlC, lQuad, lSlater, MoAveRed, Mp2DensCorr, mPrimus, MxAngqNr, MxMltp, &
          MxPut, MxSymQ, nAdd, nAtom, nBA_C, nBA_Q, nBonA_C, nBonA_Q, nCBoA_C, nCBoA_Q, nCent, nCha, nCIRef, nCnC_C, nDel, &
          nEqState, nExtAddOns, nLvlShift, nMacro, nMicro, nMlt, nPart, nPol, nPrimus, nRedMO, NrFiles, NrStarti, NrStartu, &
          NrStates, nSlSiteC, nState, nStFilT, nTemp, OldGeo, outxyz, outxyzRAS, ParallelT, ParaTemps, PertNElcInt, Pol, Pollim, &
          PotNuc, Pres, QIm, QImp, Qmeq, QmProd, Qmstat_end, QmType, Qsta, qTot, Quad, QuaDi, QuaDiQ, RasCha, RasDip, RasQua, &
          RassiM, rStart, SaFilIn, SaFilUt, SavOri, ScalExt, SexRe1, SexRe2, SexRep, SimEx, SingPoint, SlExpC, SlExpQ, SlFactC, &
          SlPC, Sqrs, StFilIn, StFilUt, SupM, Surf, Temp, ThrsCont, ThrsRedOcc, Trace_MP2, Trans, Udisp, V1, V3, xyzMyI, xyzMyP, &
          xyzMyQ, xyzQuQ

contains

subroutine Qmstat_end()

  use stdalloc, only: mma_deallocate

  if (lCiSelect) then
    call mma_deallocate(iCIInd)
    call mma_deallocate(dCIRef)
  end if

  if (nLvlShift > 0) then
    call mma_deallocate(iLvlShift)
    call mma_deallocate(dLvlShift)
  end if

  if (AddExt) then
    call mma_deallocate(ScalExt)
    call mma_deallocate(ExtLabel)
    call mma_deallocate(iCompExt)
  end if

  if (ParallelT) then
    call mma_deallocate(nStFilT)
  end if

  if (DispDamp) then
    call mma_deallocate(CharDiQ)
    call mma_deallocate(QuaDiQ)
  end if

  if (allocated(Alfa)) call mma_deallocate(Alfa)
  if (allocated(AvElcPot)) call mma_deallocate(AvElcPot)
  if (allocated(Beta)) call mma_deallocate(Beta)
  if (allocated(c_orbene)) call mma_deallocate(c_orbene)
  if (allocated(Cha)) call mma_deallocate(Cha)
  if (allocated(Cont)) call mma_deallocate(Cont)
  if (allocated(CordIm)) call mma_deallocate(CordIm)
  if (allocated(DenCorrD)) call mma_deallocate(DenCorrD)
  if (allocated(DipMy)) call mma_deallocate(DipMy)
  if (allocated(Dont)) call mma_deallocate(Dont)
  if (allocated(HHmat)) call mma_deallocate(HHmat)
  if (allocated(HmatSOld)) call mma_deallocate(HmatSOld)
  if (allocated(HmatState)) call mma_deallocate(HmatState)
  if (allocated(NrStates)) call mma_deallocate(NrStates)
  if (allocated(outxyz)) call mma_deallocate(outxyz)
  if (allocated(outxyzRAS)) call mma_deallocate(outxyzRAS)
  if (allocated(Quad)) call mma_deallocate(Quad)
  if (allocated(RasCha)) call mma_deallocate(RasCha)
  if (allocated(RasDip)) call mma_deallocate(RasDip)
  if (allocated(RasQua)) call mma_deallocate(RasQua)
  if (allocated(SlExpQ)) call mma_deallocate(SlExpQ)
  if (allocated(Udisp)) call mma_deallocate(Udisp)
  if (allocated(V3)) call mma_deallocate(V3)

  call mma_deallocate(Cordst)
  call mma_deallocate(Disp)
  call mma_deallocate(iExtr_Atm)
  call mma_deallocate(Pol)
  call mma_deallocate(Qsta)
  call mma_deallocate(Sexre1)
  call mma_deallocate(Sexre2)
  call mma_deallocate(Sexrep)
  call mma_deallocate(SlExpC)
  call mma_deallocate(SlFactC)
  call mma_deallocate(SlPC)

end subroutine Qmstat_end

end module qmstat_global

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C----------------------------------------------------------------------|
      subroutine XDR_Info_Local(n,indx,nb,ib,map)
C
C calculate information of Local blocks
C
      implicit none
C Input variables
      integer n,indx(n)
C Output variables
      integer nb,ib(n),map(n)
C Local variables
      integer i,j,k,m
C
      do i=1,n
        ib(i)=0
      end do
      nb = 0
      k  = 0
      do i=1,n
        if(ib(i).eq.0)then
          nb = nb + 1
          m  = k
          k  = k  + 1
          map(k) = i
          do j=i+1,n
            if( ib(j).eq.0 .and. indx(j).eq.indx(i) )then
              k = k + 1
              map(k) = j
              ib(j) = -1
            end if
          end do
          ib(nb) = k - m
        end if
      end do
CDP      write(6,"(a,9i4)") " nb,k,n : ",nb,k,n
CDP      write(6,"(a,9i5)") " blocks : ",(ib(i),i=1,nb)
CDP      write(6,"(a,999i4)") " map ; ",(map(i),i=1,n)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine unpackk_zr(i,vint,ndimv1,ndimv2,ndimv3,key)
! this routine expands integrals packed in i-th TEMP file
! to vint(j,k,l) = <i,j|k,l>
!
! i      - value of pivot index (I)
! vint   - array of integrals (O)
! ndimv1 - first dimension of vint (norb(symj)) (I)
! ndimv2 - second dimension of vint (norb(symk)) (I)
! ndimv3 - third dimension of vint (norb(syml)) (I)
! key    - reduced storing key (I)
!          = 0 if symj is not syml
!          = 1 if symj = syml

use ccsort_global, only: iokey, jh, kh, lh, lrectemp, lunpublic, nrectemp, nsize, tmpnam, valh
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: i, ndimv1, ndimv2, ndimv3, key
real(kind=wp), intent(out) :: vint(ndimv1,ndimv2,ndimv3)
integer(kind=iwp) :: daddr, ihelp, ires, length, nhelp, nrec
integer(kind=iwp), allocatable :: iBuf(:)
integer(kind=iwp), parameter :: constj = 1024**2, constk = 1024

! set vint=0

vint(:,:,:) = Zero

! open corresponding TEMP file

if (iokey == 1) then
  ! Fortran IO
  call molcas_binaryopen_vanilla(lunpublic,tmpnam(i))
  !open(unit=lunpublic,file=tmpnam(i),form='unformatted')
else
  ! MOLCAS IO
  call daname(lunpublic,tmpnam(i))
  daddr = 0
end if

call mma_allocate(iBuf,nsize)

do nrec=1,nrectemp(i)

  if (nrec /= nrectemp(i)) then
    length = nsize
  else
    length = lrectemp(i)
  end if

  if (iokey == 1) then
    ! Fortran IO
    read(lunpublic) valh(1:length),iBuf(1:length)
  else
    ! MOLCAS IO
    call ddafile(lunpublic,2,valh,length,daddr)
    call idafile(lunpublic,2,iBuf,length,daddr)
  end if

  ! get indexes jh,kh,lh and value valh from packed form

  do nhelp=1,length
    ihelp = iBuf(nhelp)
    jh(nhelp) = int(ihelp/constj,kind=kind(jh))
    ires = ihelp-constj*jh(nhelp)
    kh(nhelp) = int(ires/constk,kind=kind(jh))
    lh(nhelp) = int(ires-constk*kh(nhelp),kind=kind(lh))
  end do

  if (key == 0) then
    do nhelp=1,length
      vint(jh(nhelp),kh(nhelp),lh(nhelp)) = valh(nhelp)
    end do
  else
    do nhelp=1,length
      vint(jh(nhelp),kh(nhelp),lh(nhelp)) = valh(nhelp)
      vint(lh(nhelp),kh(nhelp),jh(nhelp)) = valh(nhelp)
    end do
  end if

end do

call mma_deallocate(iBuf)

if (iokey == 1) then
  ! Fortran IO
  close(lunpublic)
else
  ! Molcas IO
  call daclos(lunpublic)
end if

return

end subroutine unpackk_zr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_X_Final
!
!> @brief
!>   Finalize Cholesky utilities
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Deallocates memory, closes files, etc., as initialized
!> by ::Cho_X_Init. On exit, \p irc = ``0`` signals successful finalization.
!>
!> @param[out] irc Return code
!***********************************************************************

subroutine Cho_X_Final(irc)

use Cholesky, only: BkmThr, BkmVec, ChoIniCheck, MySP, nCol_BkmThr, nCol_BkmVec, nRow_BkmThr, nRow_BkmVec
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: ChoIsIni

! Set  error code.
! ----------------

irc = 0

! Read initialization integer flag from runfile.
! ----------------------------------------------

call Get_iScalar('ChoIni',ChoIsIni)

! Finalize if needed.
! -------------------

if (ChoIsIni == ChoIniCheck) then

  ! Close files.
  ! ------------

  call Cho_OpenVR(2,2)

  ! Deallocate vector buffer.
  ! -------------------------

  call Cho_VecBuf_Final()

  ! Deallocate memory.
  ! ------------------

  call Cho_X_Dealloc(irc)
  if (irc == 0) then

    call mma_deallocate(MySP,safe='*')
    if (allocated(BkmVec)) then
      call mma_deallocate(BkmVec)
      nRow_BkmVec = 0
      nCol_BkmVec = 0
    end if
    if (allocated(BkmThr)) then
      call mma_deallocate(BkmThr)
      nRow_BkmThr = 0
      nCol_BkmThr = 0
    end if

  end if

  ! Reset initialization integer on runfile to "not set".
  ! -----------------------------------------------------

  ChoIsIni = ChoIniCheck+1
  call Put_iScalar('ChoIni',ChoIsIni)

end if

end subroutine Cho_X_Final

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2006, Alexander Wolf                              *
*               2006, Markus Reiher                                    *
************************************************************************
      integer function dkh_char2int (leng,string)
c
c***********************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1)
c                  and dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 07.07.2006  (MR, ETH Zurich, name changed)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***********************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer leng,idum,j
      character*(*) string
c
      if (leng.lt.1) then
        write (stdout,1001)
1001    format (/2X,'ERROR in function char2int: length of string ',
     *          'is smaller than 1.',//2X,'STOP.',/)
        call Abend
      endif
c
      idum=0
      do 10 j=1,leng
        if (string(j:j).eq.'0') then
          idum=idum+0*(10**(leng-j))
          goto 222
        endif
        if (string(j:j).eq.'1') then
          idum=idum+1*(10**(leng-j))
          goto 222
        endif
        if (string(j:j).eq.'2') then
          idum=idum+2*(10**(leng-j))
          goto 222
        endif
        if (string(j:j).eq.'3') then
          idum=idum+3*(10**(leng-j))
          goto 222
        endif
        if (string(j:j).eq.'4') then
          idum=idum+4*(10**(leng-j))
          goto 222
        endif
        if (string(j:j).eq.'5') then
          idum=idum+5*(10**(leng-j))
          goto 222
        endif
        if (string(j:j).eq.'6') then
          idum=idum+6*(10**(leng-j))
          goto 222
        endif
        if (string(j:j).eq.'7') then
          idum=idum+7*(10**(leng-j))
          goto 222
        endif
        if (string(j:j).eq.'8') then
          idum=idum+8*(10**(leng-j))
          goto 222
        endif
        if (string(j:j).eq.'9') then
          idum=idum+9*(10**(leng-j))
          goto 222
        endif
        write (stdout,1004)
1004    format (/2X,'ERROR in function char2int: string ',
     *          'contains illegal character (no figure).',
     *           //2X,'STOP.',/)
        call Abend
 222    continue
 10   continue
c
      dkh_char2int = idum
c
      return
      end

!**********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on May. 19, 2022, created this file.               *
!*****************************************************************

subroutine ReadMat2(FileName,MatInfo,Matrix,NRow,NCol,LenName,LenInfo,Trans)
! This subroutine is to replace ReadMat in the long run.

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NRow, NCol, LenName, LenInfo
character(len=LenName), intent(in) :: FileName
character(len=LenInfo), intent(out) :: MatInfo
real(kind=wp), intent(out) :: Matrix(NRow*NCol)
character, intent(in) :: Trans
integer(kind=iwp) :: ICol, iOff, IRow, LU
integer(kind=iwp), external :: IsFreeUnit

if (LenName > 0) then
  LU = IsFreeUnit(100)
  call Molcas_Open(LU,FileName)
else
  LU = u6
end if
if (Trans == 'T') then
  do IRow=1,NRow
    iOff = (IRow-1)*nCol
    read(LU,*) (Matrix(iOff+ICol),ICol=1,NCol)
  end do
else
  do ICol=1,NCol
    read(LU,*) (Matrix((iRow-1)*nCol+iCol),IRow=1,NRow)
  end do
end if
read(LU,*) MatInfo
if (LenName > 0) close(LU)

return

end subroutine ReadMat2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Giovanni Li Manni                                *
*               2019-2021, Oskar Weser                                 *
*               2021, Werner Dobrautz                                  *
*               2021,2022, Arta Safari                                 *
************************************************************************
#include "macros.fh"
      module fciqmc
#ifdef _MOLCAS_MPP_
      use mpi
      use definitions, only: MPIInt
      use Para_Info, only: Is_Real_Par
#endif
      use definitions, only: wp
      use Para_Info, only: MyRank
#ifdef _NECI_
      use filesystem, only: chdir_
      use stdalloc, only: mxMem
      use fortran_strings, only: str
#endif
      use filesystem, only: getcwd_, get_errno_, strerror_,
     &    real_path, basename
      use linalg_mod, only: abort_
      use stdalloc, only: mma_allocate, mma_deallocate

      use rasscf_data, only: nAcPar, nAcPr2, nroots
      use general_data, only: nSym, nConf

      use CI_solver_util, only: wait_and_read

      use generic_CI, only: CI_solver_t
      use fciqmc_read_RDM, only: read_neci_RDM, tHDF5_RDMs,
     &    MCM7
      use definitions, only: u6

      implicit none
      save
      private
      public :: DoNECI, DoEmbdNECI, fciqmc_solver_t, tGUGA_in

      logical :: DoEmbdNECI = .false., DoNECI = .false.,
     &  tGUGA_in  = .false.

#ifdef _NECI_
      interface
        subroutine NECImain(fcidmp, input_name, MemSize, NECIen)
          use, intrinsic :: iso_fortran_env, only: int64
          import :: wp, nroots
          implicit none
          character(len=*), intent(in) :: fcidmp, input_name
          integer(int64), intent(in) :: MemSize
          real(wp), intent (out) :: NECIen(nroots)
        end subroutine
      end interface
#endif

      type, extends(CI_solver_t) :: fciqmc_solver_t
        private
        logical :: tGUGA
      contains
        private
        procedure, public :: run => fciqmc_ctl
        procedure, public :: cleanup
      end type

      interface fciqmc_solver_t
        module procedure construct_FciqmcSolver_t
      end interface

      contains

      function construct_FciqmcSolver_t(tGUGA) result(res)
        logical, intent(in) :: tGUGA
        type(fciqmc_solver_t) :: res
        res%tGUGA = tGUGA
        write(u6,*)
     &      ' NECI activated. List of Confs might get lengthy.'
        write(u6,*)
     &      ' Number of Configurations computed by GUGA: ', nConf
        write(u6,*)
     &      ' nConf variable is set to zero to avoid JOBIPH i/o'
        nConf= 0
      end function

!>  @brief
!>    Start and control FCIQMC.
!>
!>  @author Giovanni Li Manni, Oskar Weser
!>
!>  @details
!>  This routine will replace CICTL in FCIQMC regime.
!>  Density matrices are generated via double-run procedure in NECI.
!>  They are then dumped on arrays DMAT, DSPN, PSMAT, PAMAT to replace
!>  what normally would be done in DavCtl if NECI is not used.
!>  F_In is still generated by SGFCIN... in input contains
!>  only two-electron terms as computed in TRA_CTL2.
!>  In output it contains also the one-electron contribution
!>
!>  @param[in] this
!>  @param[in] actual_iter The actual iteration number starting at 0.
!>      This means 0 is 1A, 1 is 1B, 2 is 2 and so on.
!>  @param[in] ifinal
!>  @param[in] iroot
!>  @param[in] weight
!>  @param[in] CMO MO coefficients
!>  @param[in] DIAF Diagonal of Fock matrix useful for NECI
!>  @param[in] D1I_AO Inactive 1-dens matrix
!>  @param[in] D1A_AO
!>  @param[in] TUVX Active 2-el integrals
!>  @param[in,out] F_In Fock matrix from inactive density
!>  @param[in,out] D1S_MO Average spin 1-dens matrix
!>  @param[out] DMAT Average 1 body density matrix
!>  @param[out] PSMAT Average symm. 2-dens matrix
!>  @param[out] PAMAT Average antisymm. 2-dens matrix
      subroutine fciqmc_ctl(
     &    this, actual_iter, ifinal, iroot, weight, CMO, DIAF, D1I_AO,
     &    D1A_AO, TUVX, F_IN, D1S_MO, DMAT, PSMAT, PAMAT
     &    )

          use general_data, only : iSpin, ntot, ntot1, ntot2, nAsh
          use rasscf_data, only : iter, nroots, lRoots,
     &                            S, KSDFT, EMY, rotmax, Ener, Nac,
     &                            nAcPar, nAcpr2
          use gas_data, only : ngssh, iDoGas, nGAS, iGSOCCX
          use fcidump_reorder, only : get_P_GAS, get_P_inp,ReOrFlag,
     &                                ReOrInp
          use fcidump, only : make_fcidumps, transform
#include "rctfld.fh"

          class(fciqmc_solver_t), intent(in) :: this
          integer, intent(in) :: actual_iter, iroot(nroots), ifinal
          real(wp), intent(in) :: weight(nroots), CMO(nTot2),
     &                            DIAF(nTot), D1I_AO(nTot2),
     &                            D1A_AO(nTot2), TUVX(nAcpr2)
          real(wp), intent(inout) :: F_In(nTot1), D1S_MO(nAcPar)
          real(wp), intent(out) :: DMAT(nAcpar), PSMAT(nAcpr2),
     &                             PAMAT(nAcpr2)
          integer, allocatable :: permutation(:), GAS_spaces(:, :),
     &                            GAS_particles(:, :)
          real(wp) :: NECIen(nroots), orbital_E(nTot),
     &                folded_Fock(nAcPar)
#ifdef _MOLCAS_MPP_
          integer(MPIInt) :: error
#endif
          character(len=*), parameter ::
     &      ascii_fcidmp = 'FCIDUMP', h5_fcidmp = 'H5FCIDUMP'

!         ! SOME DIRTY SETUPS
          S = 0.5_wp * dble(iSpin - 1)
          call check_options(lRf, KSDFT)
          ! Produce a working FCIDUMP file
          if (ReOrFlag /= 0) then
            allocate(permutation(sum(nAsh(:nSym))))
            if (ReOrFlag >= 2) permutation(:) = get_P_inp(ReOrInp)
            if (ReOrFlag == -1) permutation(:) = get_P_GAS(nGSSH)
          end if

!         ! This call is not side effect free, sets EMY and modifies
!         ! F_IN
          call transform(actual_iter, CMO, DIAF, D1I_AO, D1A_AO, D1S_MO,
     &                   F_IN, orbital_E, folded_Fock)

!         ! Fortran Standard 2008 12.5.2.12:
!         ! Allocatable actual arguments that are passed to
!         ! non-allocatable, optional dummy arguments are **not**
!         ! present.
          call make_fcidumps(
     &        ascii_fcidmp, h5_fcidmp, orbital_E, folded_Fock, TUVX,
     &        EMY, permutation
     &    )

! Run NECI
#ifdef _MOLCAS_MPP_
          if (is_real_par()) call MPI_Barrier(MPI_COMM_WORLD, error)
#endif

          if (iDoGAS) then
            call mma_allocate(GAS_spaces, nGAS, nSym)
            GAS_spaces(:, :) = nGSSH(: nGAS, : nSym)
            call mma_allocate(GAS_particles, nGAS, nGAS)
            GAS_particles(:, :) = iGSOCCX(: nGAS, : nGAS)
          end if

          call run_neci(DoEmbdNECI,
     &      fake_run=actual_iter == 1 .or. ifinal == 2,
     &      ascii_fcidmp=ascii_fcidmp, h5_fcidmp=h5_fcidmp,
     &      GAS_spaces=GAS_spaces, GAS_particles=GAS_particles,
     &      reuse_pops=actual_iter >= 5 .and. abs(rotmax) < 1d-2,
     &      NECIen=NECIen, iroot=iroot, weight=weight,
     &      D1S_MO=D1S_MO, DMAT=DMAT, PSMAT=PSMAT, PAMAT=PAMAT,
     &      tGUGA=this%tGUGA, ifinal=ifinal)
          ENER(1 : lRoots, iter) = NECIen

          if (nAsh(1) /= nac) call dblock(dmat)
          if (allocated(GAS_spaces)) then
              call mma_deallocate(GAS_spaces)
              call mma_deallocate(GAS_particles)
          end if
      end subroutine fciqmc_ctl


      subroutine run_neci(DoEmbdNECI, fake_run,
     &      ascii_fcidmp, h5_fcidmp,
     &      reuse_pops,
     &      NECIen, iroot, weight,
     &      D1S_MO, DMAT, PSMAT, PAMAT,
     &      GAS_spaces, GAS_particles, tGUGA, ifinal)
        use fciqmc_make_inp, only: make_inp
        logical, intent(in) :: DoEmbdNECI, fake_run, reuse_pops
        character(len=*), intent(in) :: ascii_fcidmp, h5_fcidmp
        real(wp), intent(out) :: NECIen(nroots),
     &      D1S_MO(nAcPar), DMAT(nAcpar), PSMAT(nAcpr2), PAMAT(nAcpr2)
        logical, intent(in) :: tGUGA
        integer, intent(in) :: iroot(nroots), ifinal
        real(wp), intent(in) :: weight(nroots)
        integer, intent(in), optional ::
     &      GAS_spaces(:, :), GAS_particles(:, :)
        real(wp), allocatable, save :: previous_NECIen(:)
        character(len=*), parameter :: input_name = 'FCINP',
     &    energy_file = 'NEWCYCLE'

#ifdef _WARNING_WORKAROUND_
        ! there are wrong maybe-unitialized warnings otherwise.
        ! (unitialized codepaths lead to abortion).
        NECIen = huge(NECIen)
#endif
        if (.not. allocated(previous_NECIen)) then
            allocate(previous_NECIen(nroots))
            previous_NECIen(:) = 0.0_wp
        end if
        if (fake_run) then
          NECIen(:) = previous_NECIen(:)
        else if (DoEmbdNECI) then
            call make_inp(input_name, readpops=reuse_pops, tGUGA=tGUGA,
     &          GAS_spaces=GAS_spaces, GAS_particles=GAS_particles)
#ifdef _NECI_
            write(u6,*) 'NECI called automatically within Molcas!'
            if (myrank /= 0) call chdir_('..')
            call necimain(real_path(ascii_fcidmp),
     &                    real_path(input_name),
     &                    MxMem, NECIen)
            if (myrank /= 0) call chdir_('tmp_'//str(myrank))
#else
            call WarningMessage(2, 'EmbdNECI is given in input, '//
     &'so the embedded NECI should be used. Unfortunately MOLCAS was '//
     &'not compiled with embedded NECI. Please use -DNECI=ON '//
     &'for compiling or use an external NECI.')
#endif
        else
            call make_inp(input_name, readpops=.false., tGUGA=tGUGA,
     &              FCIDUMP_name=basename(real_path(ascii_fcidmp)),
     &              GAS_spaces=GAS_spaces, GAS_particles=GAS_particles)
            if (myrank == 0) then
              call write_ExNECI_message(input_name, ascii_fcidmp,
     &                                  h5_fcidmp, energy_file, tGUGA)
            end if

            call wait_and_read(energy_file, NECIen)
        end if
        previous_NECIen(:) = NECIen(:)
        call read_neci_RDM(iroot, weight, tGUGA, ifinal,
     &                     DMAT, D1S_MO, PSMAT, PAMAT)
      end subroutine run_neci

      subroutine cleanup(this)
        use fciqmc_make_inp, only: make_inp_cleanup => cleanup
        use fciqmc_read_RDM, only: read_RDM_cleanup => cleanup
        use fcidump, only : fcidump_cleanup => cleanup
        class(fciqmc_solver_t), intent(inout) :: this
        unused_var(this)
        call make_inp_cleanup()
        call read_RDM_cleanup()
        call fcidump_cleanup()
      end subroutine cleanup

      subroutine check_options(lRf, KSDFT)
        logical, intent(in) :: lRf
        character(len=*), intent(in) :: KSDFT
        logical :: Do_ESPF
        call DecideOnESPF(Do_ESPF)
        if ( lRf .or. KSDFT /= 'SCF' .or. Do_ESPF) then
          call abort_('FCIQMC does not support Reaction Field yet!')
        end if
      end subroutine check_options

      subroutine write_ExNECI_message(
     &      input_name, ascii_fcidmp, h5_fcidmp, energy_file, tGUGA)
        character(len=*), intent(in) :: input_name, ascii_fcidmp,
     &          h5_fcidmp, energy_file
        logical, intent(in) :: tGUGA
        character(len=1024) :: WorkDir
        integer :: err

        call getcwd_(WorkDir, err)
        if (err /= 0) write(u6, *) strerror_(get_errno_())

        if (tGUGA) then
            write(u6,'(A)')'Run spin-free GUGA NECI externally.'
        else
            write(u6,'(A)')'Run NECI externally.'
        end if
        write(u6,'(A)')'Get the (example) NECI input:'
        write(u6,'(4x, A, 1x, A, 1x, A)')
     &    'cp', real_path(input_name), '$NECI_RUN_DIR'
        write(u6,'(A)')'Get the ASCII formatted FCIDUMP:'
        write(u6,'(4x, A, 1x, A, 1x, A)')
     &    'cp', real_path(ascii_fcidmp), '$NECI_RUN_DIR'
        write(u6,'(A)')'Or the HDF5 FCIDUMP:'
        write(u6,'(4x, A, 1x, A, 1x, A)')
     &    'cp', real_path(h5_fcidmp), '$NECI_RUN_DIR'
        write(u6, *)
        write(u6,'(A)') "When finished do:"
        if (tGUGA) then
          write(u6,'(4x, A)') 'cp PSMAT.* PAMAT.* DMAT.* '//
     &          trim(WorkDir)
        else if (tHDF5_RDMs) then
          if (MCM7) then
          write(u6,'(4x, a)')
     &    'copy your M7.h5 file into '//trim(WorkDir)
          else
          write(u6,'(4x, a)')
     &    'copy your fciqmc.rdms.{iroot}.h5 file into '//trim(WorkDir)
          end if
        else
          write(u6,'(4x, A)')
     &      'cp TwoRDM_* '//trim(WorkDir)
        end if
        write(u6,'(4x, A)')
     &    'echo $your_RDM_Energy > '//real_path(energy_file)
        call xflush(6)
      end subroutine write_ExNECI_message

      end module fciqmc

!************************************************************************
!* This file is part of OpenMolcas.                                     *
!*                                                                      *
!* OpenMolcas is free software; you can redistribute it and/or modify   *
!* it under the terms of the GNU Lesser General Public License, v. 2.1. *
!* OpenMolcas is distributed in the hope that it will be useful, but it *
!* is provided "as is" and without any express or implied warranties.   *
!* For more details see the full text of the license in the file        *
!* LICENSE or in <http://www.gnu.org/licenses/>.                        *
!************************************************************************

!MODULE io_data
!
!PUBLIC :: read_magnetic_moment,       write_magnetic_moment,  &
!          read_electric_moment,       write_electric_moment,  &
!          read_spin_moment,           write_spin_moment,      &
!          read_angmom,                write_angmom,           &
!          read_edipmom,               write_edipmom,          &
!          read_amfi,                  write_amfi,             &
!          read_nss,                   write_nss,              &
!          read_nmult,                 write_nmult,            &
!          read_imult,                 write_imult,            &
!          read_format,                write_format,           &
!          read_nroot,                 write_nroot,            &
!          read_nstate,                write_nstate,           &
!          read_multiplicity,          write_multiplicity,     &
!          read_szproj,                write_szproj,           &
!          read_eso,                   write_eso,              &
!          read_esfs,                  write_esfs,             &
!          read_hso,                   write_hso,              &
!          read_eigen,                 write_eigen,            &
!          read_gtens,                 write_gtens,            &
!          read_stev_cfp,              write_stev_cfp,         &
!          read_susc,                  write_susc,             &
!          read_magn,                  write_magn,             &
!          read_complex_matrix,        write_complex_matrix,   &
!          open_datafile_read,         open_datafile_write,    &
!          close_datafile,                                     &
!          check_hermiticity_matrix,   check_commutation,      &
!          check_S_square
!
!PRIVATE :: file_advance_to_string,     inquire_key_presence,   &
!           read_INTEGER_scalar,        write_INTEGER_scalar,   &
!           read_1d_INTEGER_array,      write_1d_INTEGER_array, &
!           read_1d_real_array,         write_1d_real_array,    &
!           read_2d_real_array,         write_2d_real_array,    &
!           read_3d_real_array,         write_3d_real_array
!
!           write_string,                                       &
!           read_real_scalar,           write_real_scalar,      &
!           read_complex_scalar,        write_complex_scalar,   &
!           read_1d_size,                                       &
!           read_2d_size,                                       &
!           read_3d_size,                                       &
!           read_4d_size,                                       &
!           read_1d_complex_array,      write_1d_complex_array, &
!           read_2d_complex_array,      write_2d_complex_array, &
!           read_2d_INTEGER_array,      write_2d_INTEGER_array, &
!           read_3d_INTEGER_array,      write_3d_INTEGER_array, &
!           read_4d_INTEGER_array,      write_4d_INTEGER_array, &
!           read_4d_real_array,         write_4d_real_array,    &
!           read_3d_complex_array,      write_3d_complex_array, &
!           read_4d_complex_array,      write_4d_complex_array
!
! Keywords:
!    $dipm   --  electric dipole moment, SO basis  (6 components: _xr,_xi,  _yr,_yi,  _zr,_zi)
!    $magn   --  magnetic dipole moment, SO basis  (6 components: _xr,_xi,  _yr,_yi,  _zr,_zi)
!    $angmom --  orbital moment (L)    , SF basis  (3 compinents: _x, _y, _z)
!    $edip   --  electric dipole moment, SF basis  (3 components: _x, _y, _z)
!    $hso    --  spin-orbit hamiltonian, SO basis  (2 components: _r, _i)
!    $eigen  --  spin-orbit eigenstates, SO basis  (2 components: _r, _i)
!    $eso
!    $esfs
!    $multiplicity
!    $szvalue

!---- high level functions -------
!     >>> available <<<
! read_magnetic_moment
! read_electric_moment
! read_angmom
! read_edipmom
! read_eigenv
! read_hso
! read_nss
! read_nstate
! read_eso
! read_esfs
! read_szproj
! read_gtens
! xt,
! xt_field,
!    >>> verification functions <<<
! verify_commutation(L, S)
! verify_L2
! verify_S2
! verify_hermiticity
!---------------------------------
!   >>> yet_to_add <<<
! write_exch_ham
! write_exch_functions
! write_CFP
! write_magnetic_axes
! write_xyz
!
! x,
! x_field,
! x_minus_one,
! x_field,
! x_field_minus_one,
! magnetization,
!
! read_MOs
! read_CI_in_SD
! read_CI_in_CSF
! read_coeff_of_CSF
!---------------------------------

!------ low-level functions ----
! read_INTEGER_scalar
! read_real_scalar
! read_complex_scalar
! read_string
!
! read_string_length
!
! read_1d_size
! read_2d_size
! read_3d_size
! read_4d_size
!
! read_1d_INTEGER_array
! read_2d_INTEGER_array
! read_3d_INTEGER_array
! read_4d_INTEGER_array
!
! read_1d_real_array
! read_2d_real_array
! read_3d_real_array
! read_4d_real_array
!
! read_1d_complex_array
! read_2d_complex_array
! read_3d_complex_array
! read_4d_complex_array
!
!
! write_INTEGER_scalar
! write_real_scalar
! write_complex_scalar
! write_string
!
! write_1d_INTEGER_array
! write_2d_INTEGER_array
! write_3d_INTEGER_array
! write_4d_INTEGER_array
!
! write_1d_real_array
! write_2d_real_array
! write_3d_real_array
! write_4d_real_array
!
! write_1d_complex_array
! write_2d_complex_array
! write_3d_complex_array
! write_4d_complex_array
!
! open_datafile_write
! open_datafile_read
! close_datafile
! key_found
! file_advance_to_string
!----------------------------------------------------------------------!

!----------------------------------------------------------------------!
!           HIGH LEVEL VERIFICATION SUBROUTINES
!----------------------------------------------------------------------!

subroutine check_commutation(n,moment,dbg)
! valid for S, L, J in spin-orbit basis

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero, cOne, Onei
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N
complex(kind=wp), intent(in) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, j, l
complex(kind=wp) :: tr
complex(kind=wp), allocatable :: X(:,:), Y(:,:), Z(:,:), XY(:,:), XZ(:,:), YX(:,:), YZ(:,:), ZX(:,:), ZY(:,:)

! verify the commutation relations for S
call mma_allocate(X,n,n,label='X')
call mma_allocate(Y,n,n,label='Y')
call mma_allocate(Z,n,n,label='Z')
call mma_allocate(XY,n,n,label='XY')
call mma_allocate(YX,n,n,label='YX')
call mma_allocate(YZ,n,n,label='YZ')
call mma_allocate(ZY,n,n,label='ZY')
call mma_allocate(ZX,n,n,label='ZX')
call mma_allocate(XZ,n,n,label='XZ')

X(:,:) = moment(1,:,:)
Y(:,:) = moment(2,:,:)
Z(:,:) = moment(3,:,:)

call zgemm_('n','n',n,n,n,cOne,X,n,Y,n,cZero,XY,n)
call zgemm_('n','n',n,n,n,cOne,Y,n,X,n,cZero,YX,n)

call zgemm_('n','n',n,n,n,cOne,Y,n,Z,n,cZero,YZ,n)
call zgemm_('n','n',n,n,n,cOne,Z,n,Y,n,cZero,ZY,n)

call zgemm_('n','n',n,n,n,cOne,Z,n,X,n,cZero,ZX,n)
call zgemm_('n','n',n,n,n,cOne,X,n,Z,n,cZero,XZ,n)

if (dbg) then
  do l=1,3
    write(u6,'(A,I2)') 'check_commutation:: moment, projection, L=',l
    do i=1,n
      write(u6,'(10(2F8.4,2x))') (moment(l,i,j),j=1,n)
    end do
  end do

  write(u6,'(A,I2)') 'check_commutation:: XY-YX'
  do i=1,n
    write(u6,'(10(2F8.4,2x))') (XY(i,j)-YX(i,j),j=1,n)
  end do

  write(u6,'(A,I2)') 'check_commutation:: i*Z'
  do i=1,n
    write(u6,'(10(2F8.4,2x))') (Onei*moment(3,i,j),j=1,n)
  end do

  write(u6,'(A,I2)') 'check_commutation:: (XY-YX) -i*Z'
  do i=1,n
    write(u6,'(10(2F8.4,2x))') (XY(i,j)-YX(i,j)-Onei*moment(3,i,j),j=1,n)
  end do
end if

tr = cZero
do j=1,n
  do i=1,n
    tr = tr+XY(i,j)-YX(i,j)-Onei*moment(3,i,j)+YZ(i,j)-ZY(i,j)-Onei*moment(1,i,j)+ZX(i,j)-XZ(i,j)-Onei*moment(2,i,j)
  end do
end do

if (dbg) write(u6,'(A,ES22.14)') 'check_commutation::  trace of [Sx,Sy]-iSz = ',abs(tr)
if (abs(tr) > 1.0e-6_wp) then
  call WarningMessage(1,'check_commutation:: trace of [Sx,Sy]-iSz  is larger than 1.0e-6. The input moment looks inacurate')
else
  write(u6,'(A,ES22.14)') 'check_commutation:  The input moment passes all three commutation tests.'
end if

call mma_deallocate(X)
call mma_deallocate(Y)
call mma_deallocate(Z)
call mma_deallocate(XY)
call mma_deallocate(YX)
call mma_deallocate(YZ)
call mma_deallocate(ZY)
call mma_deallocate(ZX)
call mma_deallocate(XZ)

return

end subroutine check_commutation

subroutine check_S_square(n,moment,dbg)
! valid also for J, L, S

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Quart, cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
complex(kind=wp), intent(in) :: moment(3,n,n)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i
real(kind=wp) :: S2_theoretic
complex(kind=wp) :: tr
complex(kind=wp), allocatable :: M(:,:), S2(:,:), X2(:,:), Y2(:,:), Z2(:,:)

call mma_allocate(X2,n,n,label='X2')
call mma_allocate(Y2,n,n,label='Y2')
call mma_allocate(Z2,n,n,label='Z2')
call mma_allocate(M,n,n,label='M')

M(:,:) = moment(1,:,:)
call zgemm_('c','n',n,n,n,cOne,M,n,M,n,cZero,X2,n)

M(:,:) = moment(2,:,:)
call zgemm_('c','n',n,n,n,cOne,M,n,M,n,cZero,Y2,n)

M(:,:) = moment(3,:,:)
call zgemm_('c','n',n,n,n,cOne,M,n,M,n,cZero,Z2,n)

call mma_deallocate(M)
call mma_allocate(S2,n,n,label='S2')

! matrix add:
! S2 = X2 + Y2 + Z2
S2(:,:) = X2(:,:)+Y2(:,:)+Z2(:,:)

tr = cZero
do i=1,n
  tr = tr+S2(i,i)
end do

S2_theoretic = real(n**3-n,kind=wp)*Quart

if (dbg) write(u6,'(A,ES22.14)') 'check_S_square::  trace of S2=(Sx).Sx+(Sy).Sy+(Sz).Sz = ',abs(tr)
if ((abs(tr)-S2_theoretic) > 1.0e-6_wp) then
  call WarningMessage(1,'check_S_square:: tr(S^2) - S2_theoretic is larger than 1.0e-6. The input moment looks inacurate')
else
  write(u6,'(A,ES22.14)') 'check_S_square:  The input moment passes the S^2 test.'
end if
call mma_deallocate(X2)
call mma_deallocate(Y2)
call mma_deallocate(Z2)
call mma_deallocate(S2)

return

end subroutine check_S_square

subroutine check_hermiticity_moment(n,moment,dbg)

use Constants, only: cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
complex(kind=wp), intent(in) :: moment(3,n,n)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, j, l
complex(kind=wp) :: c

! build difference SUM ( M ATRIX(i,j) - CONJG(MATRIX(j,i)) )
c = cZero
do i=1,n
  do j=1,n
    if (i == j) cycle
    do l=1,3
      c = c+moment(l,i,j)-conjg(moment(l,j,i))
    end do
  end do
end do
if (dbg) write(u6,'(A,2ES22.14)') 'check_hermiticity_moment::  trace of A(i,j)-CONJG(A(j,i)) = ',c
if (abs(c) > 1.0e-6_wp) then
  call WarningMessage(1,'check_hermiticity_moment:: trace of M(:,i,j)-CONJG(A(:,j,i)) is larger than 1.0e-6. '// &
                      'The hermiticity of input moment is not quite fulfilled')
else
  write(u6,'(A,ES22.14)') 'check_hermiticity_moment:  The input moment passes the hermiticity test.'
end if

return

end subroutine check_hermiticity_moment

subroutine check_hermiticity_matrix(n,matrix,dbg)

use Constants, only: cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
complex(kind=wp), intent(in) :: matrix(n,n)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, j
complex(kind=wp) :: c

! build difference ( MATRIX(i,j) - CONJG(MATRIX(j,i)) )
c = cZero
do i=1,n
  do j=i,n
    if (i == j) cycle
    c = c+(matrix(i,j)-conjg(matrix(j,i)))
  end do
end do
if (dbg) write(u6,'(A,2ES22.14)') 'check_hermiticity_matrix::  trace of A(i,j)-CONJG(A(j,i)) = ',c
if (abs(c) > 1.0e-6_wp) then
  call WarningMessage(1,'check_hermiticity_matrix:: trace of A(i,j)-CONJG(A(j,i)) is larger than 1.0e-6. '// &
                      'The hermiticity of input matrix is not quite fulfilled')
else
  write(u6,'(A,ES22.14)') 'check_hermiticity_matrix:  The input matrix passes the hermiticity test.'
end if

return

end subroutine check_hermiticity_matrix

!----------------------------------------------------------------------!
!           HIGH LEVEL READING SUBROUTINES
!----------------------------------------------------------------------!
! read_magnetic_moment
! read_electric_moment
! read_spin_moment
! read_amfi
! read_angmom
! read_edipmom
! read_eigen
! read_hso
! read_eso
! read_esfs
! read_szproj
! read_nss
! read_nstate
!----------------------------------------------------------------------!

subroutine read_magnetic_moment(DATA_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, N
complex(kind=wp), intent(out) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, j
real(kind=wp), allocatable :: ri(:,:), rr(:,:)
complex(kind=wp), allocatable :: M(:,:)
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_, dznrm2_
logical(kind=iwp), external :: inquire_key_presence

moment(:,:,:) = cZero
call mma_allocate(rr,n,n,label='rr')
call mma_allocate(ri,n,n,label='ri')
! projection X
rr = Zero
ri = Zero
if (inquire_key_presence(DATA_FILE,'$magn_xr')) call read_2d_real_array(DATA_FILE,'$magn_xr',n,n,rr,dbg)
if (inquire_key_presence(DATA_FILE,'$magn_xi')) call read_2d_real_array(DATA_FILE,'$magn_xi',n,n,ri,dbg)
if (dbg) then
  write(u6,*) 'read_magnetic_moment::  norm of moment_xr=',dnrm2_(n*n,rr,1)
  write(u6,*) 'read_magnetic_moment::  norm of moment_xi=',dnrm2_(n*n,ri,1)
end if
moment(1,:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
if (dbg) then
  call mma_allocate(M,n,n,label='M')
  M(:,:) = moment(1,:,:)
  call check_hermiticity_matrix(n,M,dbg)
end if
! projection Y
rr = Zero
ri = Zero
if (inquire_key_presence(DATA_FILE,'$magn_yr')) call read_2d_real_array(DATA_FILE,'$magn_yr',n,n,rr,dbg)
if (inquire_key_presence(DATA_FILE,'$magn_yi')) call read_2d_real_array(DATA_FILE,'$magn_yi',n,n,ri,dbg)
if (dbg) then
  write(u6,*) 'read_magnetic_moment::  norm of moment_yr=',dnrm2_(n*n,rr,1)
  write(u6,*) 'read_magnetic_moment::  norm of moment_yi=',dnrm2_(n*n,ri,1)
end if
moment(2,:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
if (dbg) then
  M(:,:) = moment(2,:,:)
  call check_hermiticity_matrix(n,M,dbg)
end if
! projection Z
rr = Zero
ri = Zero
if (inquire_key_presence(DATA_FILE,'$magn_zr')) call read_2d_real_array(DATA_FILE,'$magn_zr',n,n,rr,dbg)
if (inquire_key_presence(DATA_FILE,'$magn_zi')) call read_2d_real_array(DATA_FILE,'$magn_zi',n,n,ri,dbg)
if (dbg) then
  write(u6,*) 'read_magnetic_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
  write(u6,*) 'read_magnetic_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
end if
moment(3,:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
if (dznrm2_(3*n*n,moment,1) <= MINIMAL_REAL) call WarningMessage(1,'read_magnetic_moment:: the norm of the read moment is zero!')
if (dbg) then
  M(:,:) = moment(3,:,:)
  call check_hermiticity_matrix(n,M,dbg)
  call mma_deallocate(M)
end if
call mma_deallocate(rr)
call mma_deallocate(ri)
if (dbg) then
  write(u6,*) 'read_magnetic_moment::  ELECTRIC MOMENT at the end of the suboutine'
  write(u6,*) 'projection X'
  do i=1,n
    write(u6,'(100(2F10.6,2x))') (moment(1,i,j),j=1,n)
  end do
  write(u6,*) 'projection Y'
  do i=1,n
    write(u6,'(100(2F10.6,2x))') (moment(2,i,j),j=1,n)
  end do
  write(u6,*) 'projection Z'
  do i=1,n
    write(u6,'(100(2F10.6,2x))') (moment(3,i,j),j=1,n)
  end do
end if

return

end subroutine read_magnetic_moment

subroutine read_electric_moment(DATA_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, N
complex(kind=wp), intent(out) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, j
real(kind=wp), allocatable :: ri(:,:), rr(:,:)
complex(kind=wp), allocatable :: M(:,:)
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_, dznrm2_
logical(kind=iwp), external :: inquire_key_presence

moment(:,:,:) = cZero
call mma_allocate(rr,n,n,label='rr')
call mma_allocate(ri,n,n,label='ri')
! projection X
rr = Zero
ri = Zero
if (inquire_key_presence(DATA_FILE,'$edipm_xr')) call read_2d_real_array(DATA_FILE,'$edipm_xr',n,n,rr,dbg)
if (inquire_key_presence(DATA_FILE,'$edipm_xi')) call read_2d_real_array(DATA_FILE,'$edipm_xi',n,n,ri,dbg)
if (dbg) then
  write(u6,*) 'read_electric_moment::  norm of moment_xr=',dnrm2_(n*n,rr,1)
  write(u6,*) 'read_electric_moment::  norm of moment_xi=',dnrm2_(n*n,ri,1)
end if
moment(1,:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
if (dbg) then
  call mma_allocate(M,n,n,label='M')
  M(:,:) = moment(1,:,:)
  call check_hermiticity_matrix(n,M,dbg)
end if
! projection Y
rr = Zero
ri = Zero
if (inquire_key_presence(DATA_FILE,'$edipm_yr')) call read_2d_real_array(DATA_FILE,'$edipm_yr',n,n,rr,dbg)
if (inquire_key_presence(DATA_FILE,'$edipm_yi')) call read_2d_real_array(DATA_FILE,'$edipm_yi',n,n,ri,dbg)
if (dbg) then
  write(u6,*) 'read_electric_moment::  norm of moment_yr=',dnrm2_(n*n,rr,1)
  write(u6,*) 'read_electric_moment::  norm of moment_yi=',dnrm2_(n*n,ri,1)
end if
moment(2,:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
if (dbg) then
  M(:,:) = moment(2,:,:)
  call check_hermiticity_matrix(n,M,dbg)
end if
! projection Z
rr = Zero
ri = Zero
if (inquire_key_presence(DATA_FILE,'$edipm_zr')) call read_2d_real_array(DATA_FILE,'$edipm_zr',n,n,rr,dbg)
if (inquire_key_presence(DATA_FILE,'$edipm_zi')) call read_2d_real_array(DATA_FILE,'$edipm_zi',n,n,ri,dbg)
if (dbg) then
  write(u6,*) 'read_electric_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
  write(u6,*) 'read_electric_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
end if
moment(3,:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
if (dznrm2_(3*n*n,moment,1) <= MINIMAL_REAL) call WarningMessage(1,'read_electric_moment:: the norm of the read moment is zero!')
if (dbg) then
  M(:,:) = moment(3,:,:)
  call check_hermiticity_matrix(n,M,dbg)
  call mma_deallocate(M)
end if
call mma_deallocate(rr)
call mma_deallocate(ri)
if (dbg) then
  write(u6,*) 'read_electric_moment::  ELECTRIC MOMENT at the end of the suboutine'
  write(u6,*) 'projection X'
  do i=1,n
    write(u6,'(100(2F10.6,2x))') (moment(1,i,j),j=1,n)
  end do
  write(u6,*) 'projection Y'
  do i=1,n
    write(u6,'(100(2F10.6,2x))') (moment(2,i,j),j=1,n)
  end do
  write(u6,*) 'projection Z'
  do i=1,n
    write(u6,'(100(2F10.6,2x))') (moment(3,i,j),j=1,n)
  end do
end if

return

end subroutine read_electric_moment

subroutine read_spin_moment(DATA_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, N
complex(kind=wp), intent(out) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, j
real(kind=wp), allocatable :: ri(:,:), rr(:,:)
complex(kind=wp), allocatable :: M(:,:)
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_, dznrm2_
logical(kind=iwp), external :: inquire_key_presence

if (dbg) write(u6,*) 'ENTER read_spin_moment'
moment(:,:,:) = cZero
call mma_allocate(rr,n,n,label='rr')
call mma_allocate(ri,n,n,label='ri')
! projection X
rr = Zero
ri = Zero
if (dbg) then
  write(u6,*) 'ENTER read_spin_moment p2  :spin_xr: ',inquire_key_presence(DATA_FILE,'$spin_xr')
  write(u6,*) 'ENTER read_spin_moment p2  :spin_xi: ',inquire_key_presence(DATA_FILE,'$spin_xi')
  write(u6,*) 'ENTER read_spin_moment p2  :spin_yr: ',inquire_key_presence(DATA_FILE,'$spin_yr')
  write(u6,*) 'ENTER read_spin_moment p2  :spin_yi: ',inquire_key_presence(DATA_FILE,'$spin_yi')
  write(u6,*) 'ENTER read_spin_moment p2  :spin_zr: ',inquire_key_presence(DATA_FILE,'$spin_zr')
  write(u6,*) 'ENTER read_spin_moment p2  :spin_zi: ',inquire_key_presence(DATA_FILE,'$spin_zi')
  call xFlush(u6)
end if
if (inquire_key_presence(DATA_FILE,'$spin_xr')) call read_2d_real_array(DATA_FILE,'$spin_xr',n,n,rr,dbg)
if (dbg) then
  write(u6,*) 'ENTER read_spin_moment p3'
  call xFlush(u6)
end if
if (inquire_key_presence(DATA_FILE,'$spin_xi')) call read_2d_real_array(DATA_FILE,'$spin_xi',n,n,ri,dbg)
if (dbg) then
  write(u6,*) 'ENTER read_spin_moment p4'
  write(u6,*) 'read_spin_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
  write(u6,*) 'read_spin_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
  write(u6,*) 'ENTER read_spin_moment p5'
  call xFlush(u6)
end if
moment(1,:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
if (dbg) then
  write(u6,*) 'ENTER read_spin_moment p6'
  call mma_allocate(M,n,n,label='M')
  M(:,:) = moment(1,:,:)
  call check_hermiticity_matrix(n,M,dbg)
  call xFlush(u6)
end if
! projection Y
rr = Zero
ri = Zero
if (inquire_key_presence(DATA_FILE,'$spin_yr')) call read_2d_real_array(DATA_FILE,'$spin_yr',n,n,rr,dbg)
if (inquire_key_presence(DATA_FILE,'$spin_yi')) call read_2d_real_array(DATA_FILE,'$spin_yi',n,n,ri,dbg)
if (dbg) then
  write(u6,*) 'read_spin_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
  write(u6,*) 'read_spin_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
  call xFlush(u6)
end if
moment(2,:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
if (dbg) then
  M(:,:) = moment(2,:,:)
  call check_hermiticity_matrix(n,M,dbg)
end if
! projection Z
rr = Zero
ri = Zero
if (inquire_key_presence(DATA_FILE,'$spin_zr')) call read_2d_real_array(DATA_FILE,'$spin_zr',n,n,rr,dbg)
if (inquire_key_presence(DATA_FILE,'$spin_zi')) call read_2d_real_array(DATA_FILE,'$spin_zi',n,n,ri,dbg)
if (dbg) then
  write(u6,*) 'read_spin_moment::  norm of moment_zr=',dnrm2_(n*n,rr,1)
  write(u6,*) 'read_spin_moment::  norm of moment_zi=',dnrm2_(n*n,ri,1)
  call xFlush(u6)
end if
moment(3,:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
if (dznrm2_(3*n*n,moment,1) <= MINIMAL_REAL) call WarningMessage(1,'read_spin:: the norm of the read moment is zero!')
if (dbg) then
  M(:,:) = moment(3,:,:)
  call check_hermiticity_matrix(n,M,dbg)
  call mma_deallocate(M)
end if
call mma_deallocate(rr)
call mma_deallocate(ri)
if (dbg) call check_commutation(n,moment,dbg)

if (dbg) then
  write(u6,*) 'read_spin_moment::  SPIN MOMENT at the end of the suboutine'
  write(u6,*) 'projection X'
  do i=1,n
    write(u6,'(100(2F10.6,2x))') (moment(1,i,j),j=1,n)
  end do
  write(u6,*) 'projection Y'
  do i=1,n
    write(u6,'(100(2F10.6,2x))') (moment(2,i,j),j=1,n)
  end do
  write(u6,*) 'projection Z'
  do i=1,n
    write(u6,'(100(2F10.6,2x))') (moment(3,i,j),j=1,n)
  end do
end if
if (dbg) write(u6,*) 'EXIT read_spin_moment'

return

end subroutine read_spin_moment

subroutine read_angmom(DATA_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, N
real(kind=wp), intent(out) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: rr(:,:)
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_
logical(kind=iwp), external :: inquire_key_presence

moment(:,:,:) = Zero
call mma_allocate(rr,n,n,label='rr')
! projection X
rr = Zero
if (inquire_key_presence(DATA_FILE,'$angmom_x')) call read_2d_real_array(DATA_FILE,'$angmom_x',n,n,rr,dbg)
if (dbg) write(u6,*) 'read_angmom::  norm of moment_x=',dnrm2_(n*n,rr,1)
moment(1,:,:) = rr(:,:)
! projection Y
rr = Zero
if (inquire_key_presence(DATA_FILE,'$angmom_y')) call read_2d_real_array(DATA_FILE,'$angmom_y',n,n,rr,dbg)
if (dbg) write(u6,*) 'read_angmom::  norm of moment_y=',dnrm2_(n*n,rr,1)
moment(2,:,:) = rr(:,:)
! projection Z
rr = Zero
if (inquire_key_presence(DATA_FILE,'$angmom_z')) call read_2d_real_array(DATA_FILE,'$angmom_z',n,n,rr,dbg)
if (dbg) write(u6,*) 'read_angmom::  norm of moment_z=',dnrm2_(n*n,rr,1)
moment(3,:,:) = rr(:,:)
call mma_deallocate(rr)
if (dnrm2_(3*n*n,moment,1) <= MINIMAL_REAL) call WarningMessage(1,'read_angmom:: the norm of the read moment is zero!')

return

end subroutine read_angmom

subroutine read_edipmom(DATA_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, N
real(kind=wp), intent(out) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: rr(:,:)
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_
logical(kind=iwp), external :: inquire_key_presence

moment(:,:,:) = Zero
call mma_allocate(rr,n,n,label='rr')
! projection X
rr = Zero
if (inquire_key_presence(DATA_FILE,'$edmom_x')) call read_2d_real_array(DATA_FILE,'$edmom_x',n,n,rr,dbg)
if (dbg) write(u6,*) 'read_edipmom::  norm of moment_x=',dnrm2_(n*n,rr,1)
moment(1,:,:) = rr(:,:)
! projection Y
rr = Zero
if (inquire_key_presence(DATA_FILE,'$edmom_y')) call read_2d_real_array(DATA_FILE,'$edmom_y',n,n,rr,dbg)
if (dbg) write(u6,*) 'read_edipmom::  norm of moment_y=',dnrm2_(n*n,rr,1)
moment(2,:,:) = rr(:,:)
! projection Z
rr = Zero
if (inquire_key_presence(DATA_FILE,'$edmom_z')) call read_2d_real_array(DATA_FILE,'$edmom_z',n,n,rr,dbg)
if (dbg) write(u6,*) 'read_edipmom::  norm of moment_z=',dnrm2_(n*n,rr,1)
moment(3,:,:) = rr(:,:)
call mma_deallocate(rr)
if (dnrm2_(3*n*n,moment,1) <= MINIMAL_REAL) call WarningMessage(1,'read_edipmom:: the norm of the read moment is zero!')

return

end subroutine read_edipmom

subroutine read_amfi(DATA_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, N
real(kind=wp), intent(out) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: rr(:,:)
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_
logical(kind=iwp), external :: inquire_key_presence

moment(:,:,:) = Zero
call mma_allocate(rr,n,n,label='rr')
! projection X
rr = Zero
if (inquire_key_presence(DATA_FILE,'$amfi_x')) call read_2d_real_array(DATA_FILE,'$amfi_x',n,n,rr,dbg)
if (dbg) write(u6,*) 'read_amfi::  norm of moment_x=',dnrm2_(n*n,rr,1)
moment(1,:,:) = rr(:,:)
! projection Y
rr = Zero
if (inquire_key_presence(DATA_FILE,'$amfi_y')) call read_2d_real_array(DATA_FILE,'$amfi_y',n,n,rr,dbg)
if (dbg) write(u6,*) 'read_amfi::  norm of moment_y=',dnrm2_(n*n,rr,1)
moment(2,:,:) = rr(:,:)
! projection Z
rr = Zero
if (inquire_key_presence(DATA_FILE,'$amfi_z')) call read_2d_real_array(DATA_FILE,'$amfi_z',n,n,rr,dbg)
if (dbg) write(u6,*) 'read_amfi::  norm of moment_z=',dnrm2_(n*n,rr,1)
moment(3,:,:) = rr(:,:)
call mma_deallocate(rr)
if (dnrm2_(3*n*n,moment,1) <= MINIMAL_REAL) call WarningMessage(1,'read_amfi:: the norm of the read moment is zero!')

return

end subroutine read_amfi

subroutine read_nss(DATA_FILE,n,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE
integer(kind=iwp), intent(out) :: n
logical(kind=iwp), intent(in) :: dbg
logical(kind=iwp), external :: inquire_key_presence

n = 0
if (inquire_key_presence(DATA_FILE,'$nss')) call read_INTEGER_scalar(DATA_FILE,'$nss',n,dbg)
if (n <= 0) call WarningMessage(1,'read_nss:: nss value in DATA_FILE = 0. Is it really the case?')

return

end subroutine read_nss

subroutine read_nstate(DATA_FILE,n,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE
integer(kind=iwp), intent(out) :: n
logical(kind=iwp), intent(in) :: dbg
logical(kind=iwp), external :: inquire_key_presence

n = 0
if (inquire_key_presence(DATA_FILE,'$nstate')) call read_INTEGER_scalar(DATA_FILE,'$nstate',n,dbg)
if (n <= 0) call WarningMessage(1,'read_nstate:: nstate value in DATA_FILE = 0. Is it really the case?')

return

end subroutine read_nstate

subroutine read_nmult(DATA_FILE,n,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE
integer(kind=iwp), intent(out) :: n
logical(kind=iwp), intent(in) :: dbg
logical(kind=iwp), external :: inquire_key_presence

n = 0
if (inquire_key_presence(DATA_FILE,'$nmult')) call read_INTEGER_scalar(DATA_FILE,'$nmult',n,dbg)
if (n <= 0) call WarningMessage(1,'read_nmult:: nmult value in DATA_FILE = 0. Is it really the case?')

return

end subroutine read_nmult

subroutine read_multiplicity(DATA_FILE,n,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, n
integer(kind=iwp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
logical(kind=iwp), external :: inquire_key_presence

array(:) = 0
if (inquire_key_presence(DATA_FILE,'$multiplicity')) call read_1d_INTEGER_array(DATA_FILE,'$multiplicity',n,array,dbg)
if (sum(abs(array)) == 0) then
  call WarningMessage(1,'read_multiplicity:: it seems that all the multiplicities in DATA_FILE are 0. Is it really the case?')
  write(u6,*) 'read_multiplicity:: SUM(Sz) = ',sum(abs(array))
end if
if (sum(array) == 0) then
  call WarningMessage(1,'read_multiplicity:: it seems that all the multiplicities in DATA_FILE are 0. Is it really the case?')
  write(u6,*) 'read_szproj:: SUM(Sz) = ',sum(array)
end if

return

end subroutine read_multiplicity

subroutine read_imult(DATA_FILE,n,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, n
integer(kind=iwp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
logical(kind=iwp), external :: inquire_key_presence

array(:) = 0
if (inquire_key_presence(DATA_FILE,'$imult')) call read_1d_INTEGER_array(DATA_FILE,'$imult',n,array,dbg)
if (sum(array) == 0) then
  call WarningMessage(1,'read_imult:: it seems that all the multiplicities in DATA_FILE are 0. Is it really the case?')
  write(u6,*) 'read_imult:: SUM(mult()) = ',sum(array)
end if

return

end subroutine read_imult

subroutine read_format(DATA_FILE,n,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE
integer(kind=iwp), intent(out) :: n
logical(kind=iwp), intent(in) :: dbg
logical(kind=iwp), external :: inquire_key_presence

n = 0
if (inquire_key_presence(DATA_FILE,'$format')) call read_INTEGER_scalar(DATA_FILE,'$format',n,dbg)
if (n <= 0) call WarningMessage(2,'read_format:: FORMAT value in DATA_FILE = 0. The FORMAT must be equal or larger than 2020. '// &
                                'Please check.')

return

end subroutine read_format

subroutine read_nroot(DATA_FILE,n,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, n
integer(kind=iwp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
logical(kind=iwp), external :: inquire_key_presence

array(:) = 0
if (inquire_key_presence(DATA_FILE,'$nroot')) call read_1d_INTEGER_array(DATA_FILE,'$nroot',n,array,dbg)
if (sum(array) == 0) then
  call WarningMessage(1,'read_nroot:: it seems that the number of roots included in spin-orbit interaction in DATA_FILE are 0. '// &
                      'Is it really the case?')
  write(u6,*) 'read_szproj:: SUM(array()) = ',sum(array)
end if

return

end subroutine read_nroot

subroutine read_szproj(DATA_FILE,n,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, n
integer(kind=iwp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
logical(kind=iwp), external :: inquire_key_presence

array(:) = 0
if (inquire_key_presence(DATA_FILE,'$szproj')) call read_1d_INTEGER_array(DATA_FILE,'$szproj',n,array,dbg)
if (sum(abs(array)) == 0) then
  call WarningMessage(1,'read_szproj:: it seems that SUM(ABS(Sz)) in DATA_FILE is 0. Is it really the case?')
  write(u6,*) 'read_szproj:: SUM(ABS(Sz)) = ',sum(abs(array))
end if
if (sum(array) /= 0) then
  call WarningMessage(1,'read_szproj:: it seems that SUM(Sz) in DATA_FILE is not 0. Is it really the case?')
  write(u6,*) 'read_szproj:: SUM(Sz) = ',sum(array)
end if

return

end subroutine read_szproj

subroutine read_eso(DATA_FILE,n,array,dbg)

use Constants, only: Zero, Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, n
real(kind=wp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_
logical(kind=iwp), external :: inquire_key_presence

array(:) = Zero
if (inquire_key_presence(DATA_FILE,'$eso')) call read_1d_real_array(DATA_FILE,'$eso',n,array,dbg)
if (dbg) write(u6,*) 'read_eso::  norm of eso=',dnrm2_(n,array,1)
if (dnrm2_(n,array,1) <= MINIMAL_REAL) then
  call WarningMessage(1,'read_eso:: it seems that the norm of ESO array in DATA_FILE is 0. Is it really the case?')
  write(u6,*) 'read_eso:: dnrm2_(eso) = ',dnrm2_(n,array,1)
end if

return

end subroutine read_eso

subroutine read_esfs(DATA_FILE,n,array,dbg)

use Constants, only: Zero, Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, n
real(kind=wp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_
logical(kind=iwp), external :: inquire_key_presence

array(:) = Zero
if (inquire_key_presence(DATA_FILE,'$esfs')) call read_1d_real_array(DATA_FILE,'$esfs',n,array,dbg)
if (dbg) write(u6,*) 'read_esfs::  norm of esfs=',dnrm2_(n,array,1)
if (dnrm2_(n,array,1) <= MINIMAL_REAL) then
  call WarningMessage(1,'read_esfs:: it seems that the norm of ESFS in DATA_FILE is 0. Is it really the case?')
  write(u6,*) 'read_esfs:: dnrm2_(esfs) = ',dnrm2_(n,array,1)
end if

return

end subroutine read_esfs

subroutine read_hso(DATA_FILE,n,array,dbg)

use Constants, only: Ten, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, n
complex(kind=wp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dznrm2_
logical(kind=iwp), external :: inquire_key_presence

array(:) = cZero
if (inquire_key_presence(DATA_FILE,'$hso')) call read_complex_matrix(DATA_FILE,'$hso',n,array,dbg)
if (dbg) write(u6,*) 'read_hso::  norm of hso=',dznrm2_(n*n,array,1)
if (dznrm2_(n*n,array,1) <= MINIMAL_REAL) then
  call WarningMessage(1,'read_hso:: it seems that norm of HSO in DATA_FILE is 0. Is it really the case?')
  write(u6,*) 'read_hso:: dznrm2_(hso) = ',dznrm2_(n*n,array,1)
end if

return

end subroutine read_hso

subroutine read_eigen(DATA_FILE,n,array,dbg)

use Constants, only: Ten, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, n
complex(kind=wp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dznrm2_
logical(kind=iwp), external :: inquire_key_presence

array(:) = cZero
if (inquire_key_presence(DATA_FILE,'$eigen')) call read_complex_matrix(DATA_FILE,'$eigen',n,array,dbg)
if (dbg) write(u6,*) 'read_eigen::  norm of eigenv=',dznrm2_(n*n,array,1)
if (dznrm2_(n*n,array,1) <= MINIMAL_REAL) then
  call WarningMessage(1,'read_eigen:: it seems that norm of EIGENV in DATA_FILE is 0. Is it really the case?')
  write(u6,*) 'read_eigen:: dznrm2_(array) = ',dznrm2_(n*n,array,1)
end if

return

end subroutine read_eigen

subroutine read_gtens(DATA_FILE,nmult,gtens,axes,dbg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, nmult
real(kind=wp), intent(out) :: gtens(nmult,3), axes(nmult,3,3)
logical(kind=iwp), intent(in) :: dbg

call read_2d_real_array(DATA_FILE,'$gtens_main',nmult,3,gtens,dbg)
call read_3d_real_array(DATA_FILE,'$gtens_axes',nmult,3,3,axes,dbg)

return

end subroutine read_gtens

subroutine read_stev_cfp(DATA_FILE,s,n,cfp,dbg)

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, n   ! 2J+1, or 2L+1, i.e. the dimension of the J or L multiplet
character(len=*), intent(in) :: s
real(kind=wp), intent(out) :: cfp(n-1,-(n-1):n-1)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, ik, iq, k, q
character(len=500) :: line

ierr = 0
if ((n <= 0)) then
  call WarningMessage(1,'read_stev_cfp_'//trim(s)//':: nothing to read. Array size = 0.')
  return
end if
CFP(:,:) = Zero

rewind(DATA_FILE)
call file_advance_to_string(DATA_FILE,'$stev_cfp_'//trim(s),line,ierr,dbg)

read(DATA_FILE,*,iostat=ierr) i
if (i /= n) call WarningMessage(2,'read_stev_cfp_'//trim(s)//':: size of the multiplet is not the same i/=n')

! if key is found, THEN read the data
if (ierr == 0) then
  do k=2,n-1,2
    do q=-k,k,2
      read(DATA_FILE,*,iostat=ierr) ik,iq,cfp(ik,iq)
      if (ierr /= 0) call WarningMessage(2,'read_stev_cfp_'//trim(s)//':: Something went wrong reading the array.')
      if (dbg) write(u6,*) 'read_stev_cfp_'//trim(s)//'::  k, q =',k,q
    end do
  end do
end if

return

end subroutine read_stev_cfp

subroutine read_susc(DATA_FILE,s,n,field,zj,t,x,x_tens,dbg)
! n     : number of temperature points
! zj    : intermolecular interaction
! field : applied field
! t     : temperature points
! x     : susceptibility X
! x_tens: susceptibility tensor, X_tens

use Constants, only: Zero, Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE
integer(kind=iwp), intent(inout) :: n
character(len=*), intent(in) :: s
real(kind=wp), intent(out) :: field, zj, t(n), x(n), x_tens(n,3,3)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k
character(len=500) :: line
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_

t(:) = Zero
x(:) = Zero
x_tens(:,:,:) = Zero
! s takes the values:
! 'x'
! 'x_field'
! 'x_minus_one'
! 'x_field_minus_one'
! 'xt'
! 'xt_field'
! 'xt_minus_one'
! 'xt_field_minus_one'
! 'x_zj'
! 'x_field_zj'
! 'x_minus_one_zj'
! 'x_field_minus_one_zj'
! 'xt_zj'
! 'xt_field_zj'
! 'xt_minus_one_zj'
! 'xt_field_minus_one_zj'
!if ((trim(s) /= 'x')                    .or. &
!    (trim(s) /= 'x_field')              .or. &
!    (trim(s) /= 'x_minus_one')          .or. &
!    (trim(s) /= 'x_field_minus_one')    .or. &
!    (trim(s) /= 'xt')                   .or. &
!    (trim(s) /= 'xt_field')             .or. &
!    (trim(s) /= 'xt_minus_one')         .or. &
!    (trim(s) /= 'xt_field_minus_one')   .or. &
!    (trim(s) /= 'x_zj')                 .or. &
!    (trim(s) /= 'x_field_zj')           .or. &
!    (trim(s) /= 'x_minus_one_zj')       .or. &
!    (trim(s) /= 'x_field_minus_one_zj') .or. &
!    (trim(s) /= 'xt_zj')                .or. &
!    (trim(s) /= 'xt_field_zj')          .or. &
!    (trim(s) /= 'xt_minus_one_zj')      .or. &
!    (trim(s) /= 'xt_field_minus_one_zj')) then
!
!  call WarningMessage(1,'read_x '//trim(s)//' :: the parameter s='//trim(s)//'is not understood. RETURN without read of X data.')
!  return
!end if

ierr = 0
if ((n <= 0)) then
  call WarningMessage(1,'read_x '//trim(s)//' :: nothing to read. Array size = 0.')
  return
end if

rewind(DATA_FILE)
call file_advance_to_string(DATA_FILE,'$susceptibility_'//trim(s),line,ierr,dbg)

! if key is found, THEN read the data
if (ierr == 0) then
  read(DATA_FILE,*,iostat=ierr) n
  read(DATA_FILE,*,iostat=ierr) zj,field
  if (ierr /= 0) call WarningMessage(2,'read_x '//trim(s)//' :: Something went wrong reading the zJ and field values.')
  read(DATA_FILE,*,iostat=ierr) (T(i),i=1,n)
  if (dnrm2_(n,T,1) < MINIMAL_REAL) call WarningMessage(1,'read_x '//trim(s)//' :: all array T elements are zero = 0.')
  if (ierr /= 0) call WarningMessage(2,'read_x '//trim(s)//' :: Something went wrong reading the T array.')
  read(DATA_FILE,*,iostat=ierr) (X(i),i=1,n)
  if (dnrm2_(n,X,1) < MINIMAL_REAL) call WarningMessage(1,'read_x '//trim(s)//' :: all array X elements are zero = 0.')
  if (ierr /= 0) call WarningMessage(2,'read_x '//trim(s)//' :: Something went wrong reading the X array.')
  do j=1,3
    do k=1,3
      read(DATA_FILE,*,iostat=ierr) (X_tens(i,j,k),i=1,n)
      if (ierr /= 0) call WarningMessage(2,'read_x '//trim(s)//' :: Something went wrong reading the X_tens array.')
    end do
  end do
  if (dnrm2_(n*3*3,X_tens,1) < MINIMAL_REAL) call WarningMessage(1,'read_x '//trim(s)//' :: all array X_tens elements are zero.')
  if (dbg) call xFlush(u6)
else
  write(u6,*) 'keyword $susceptibility_'//trim(s)//' was not found in DATA_FILE'
end if

return

end subroutine read_susc

subroutine read_magn(DATA_FILE,nt,nh,nd,nss,zj,t,h,x,y,z,w,m,mav,energy,dbg)
! nt        :  number of temperature points
! nh        :  number of field points
! nd        :  number of directions of aplied field
! nss       :  number of spin-orbit states
! zj        :  inter-molecular parameter zJ
! t         :  temperature points
! h         :  field points
! x, y, z, w:  Lebedev grid directions and weight
! m         :  magnetisation vector
! mav       :  average magnetisation vector
! energy    :  Zeeman energy states

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE, nt, nh, nd, nss
real(kind=wp), intent(out) :: zj, t(nt), h(nh), x(nd), y(nd), z(nd), w(nd), m(nd,3,nt,nh), mav(nt,nh), energy(nd,nh,nss)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, id, ierr, ih, iss, it, l
character(len=500) :: line

ierr = 0
if ((nt <= 0) .or. (nh <= 0) .or. (nd <= 0) .or. (nss <= 0)) then
  call WarningMessage(1,'read_magn :: nothing to read. Array size = 0.')
  return
end if

rewind(DATA_FILE)
call file_advance_to_string(DATA_FILE,'$magnetisation',line,ierr,dbg)

read(DATA_FILE,*,iostat=ierr) it,ih,id,iss
if (it /= nt) call WarningMessage(1,'read_magn :: nt read from DATA_FILE is not the same as the parameter used to CALL '// &
                                  'this function.')
if (ih /= nh) call WarningMessage(1,'read_magn :: nh read from DATA_FILE is not the same as the parameter used to CALL '// &
                                  'this function.')
if (id /= nd) call WarningMessage(1,'read_magn :: nd read from DATA_FILE is not the same as the parameter used to CALL '// &
                                  'this function.')
if (iss /= nss) call WarningMessage(1,'read_magn :: nss read from DATA_FILE is not the same as the parameter used to CALL '// &
                                    'this function.')
zJ = Zero
T(:) = Zero
H(:) = Zero
X(:) = Zero
Y(:) = Zero
Z(:) = Zero
W(:) = Zero
energy(:,:,:) = Zero
m(:,:,:,:) = Zero
mav(:,:) = Zero
read(DATA_FILE,*,iostat=ierr) zJ
read(DATA_FILE,*,iostat=ierr) (T(i),i=1,nt)
if (ierr /= 0) call WarningMessage(2,'read_magn :: Something went wrong reading the T array.')
! Magnetic field points
read(DATA_FILE,*,iostat=ierr) (H(i),i=1,nh)
if (ierr /= 0) call WarningMessage(2,'read_magn :: Something went wrong reading the H array.')
! Lebedev grid data (X, Y, Z, W)
read(DATA_FILE,*,iostat=ierr) (X(i),i=1,nd)
if (ierr /= 0) call WarningMessage(2,'read_magn :: Something went wrong reading the Lebedev grid X rray.')
read(DATA_FILE,*,iostat=ierr) (Y(i),i=1,nd)
if (ierr /= 0) call WarningMessage(2,'read_magn :: Something went wrong reading the Lebedev grid Y array.')
read(DATA_FILE,*,iostat=ierr) (Z(i),i=1,nd)
if (ierr /= 0) call WarningMessage(2,'read_magn :: Something went wrong reading the Lebedev grid Z array.')
read(DATA_FILE,*,iostat=ierr) (W(i),i=1,nd)
if (ierr /= 0) call WarningMessage(2,'read_magn :: Something went wrong reading the Lebedev grid W array.')
! Zeeman energy
do id=1,nd
  do ih=1,nh
    read(DATA_FILE,*,iostat=ierr) (energy(ih,id,iss),iss=1,nss)
    if (ierr /= 0) call WarningMessage(2,'read_magn :: Something went wrong reading the Zeeman energy data.')
  end do
end do
! magnetisation vector data
do id=1,nd
  do l=1,3
    do ih=1,nh
      read(DATA_FILE,*,iostat=ierr) (m(id,l,ih,it),it=1,nt)
      if (ierr /= 0) call WarningMessage(2,'read_magn :: Something went wrong reading the M data.')
    end do
  end do
end do
do ih=1,nh
  read(DATA_FILE,*,iostat=ierr) (mav(ih,it),it=1,nt)
  if (ierr /= 0) call WarningMessage(2,'read_magn :: Something went wrong reading the average M data.')
end do
if (dbg) call xFlush(u6)

return

end subroutine read_magn

subroutine read_complex_matrix(LU,key,n,matrix,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LU, N
character(len=*), intent(in) :: key
complex(kind=wp), intent(out) :: matrix(N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: ri(:,:), rr(:,:)

call mma_allocate(rr,n,n,label='rr')
call mma_allocate(ri,n,n,label='ri')
call read_2d_real_array(LU,key//'r',n,n,rr,dbg)
call read_2d_real_array(LU,key//'i',n,n,ri,dbg)
matrix(:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
call mma_deallocate(rr)
call mma_deallocate(ri)

return

end subroutine read_complex_matrix

subroutine write_complex_matrix(LU,key,n,matrix,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LU, N
character(len=*), intent(in) :: key
complex(kind=wp), intent(in) :: matrix(N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: ri(:,:), rr(:,:)

call mma_allocate(rr,n,n,label='rr')
call mma_allocate(ri,n,n,label='ri')
rr(:,:) = real(matrix(:,:))
ri(:,:) = aimag(matrix(:,:))
call write_2d_real_array(LU,key//'r',n,n,rr,dbg)
call write_2d_real_array(LU,key//'i',n,n,ri,dbg)
call mma_deallocate(rr)
call mma_deallocate(ri)

return

end subroutine write_complex_matrix

!----------------------------------------------------------------------!
!           HIGH LEVEL WRITING SUBROUTINES
!----------------------------------------------------------------------!
!
! write_magnetic_moment
! write_electric_moment
! write_amfi
! write_angmom
! write_edipmom
! write_eigenv
! write_hso
! write_eso
! write_esfs
! write_nss
! write_nmult
! write_nroot
! write_iroot
! write_nstate
! write_szproj
! write_multiplicty
! write_gtens
! write_stev_cfp
! write_susc
! write_magn
!
!----------------------------------------------------------------------!

subroutine write_magnetic_moment(ANISO_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE
integer(kind=iwp), intent(in) :: N
complex(kind=wp), intent(in) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: ri(:,:), rr(:,:)

call mma_allocate(rr,n,n,label='rr')
call mma_allocate(ri,n,n,label='ri')
! projection X
rr(:,:) = real(moment(1,:,:))
ri(:,:) = aimag(moment(1,:,:))
call write_2d_real_array(ANISO_FILE,'$magn_xr',n,n,rr,dbg)
call write_2d_real_array(ANISO_FILE,'$magn_xi',n,n,ri,dbg)
! projection Y
rr(:,:) = real(moment(2,:,:))
ri(:,:) = aimag(moment(2,:,:))
call write_2d_real_array(ANISO_FILE,'$magn_yr',n,n,rr,dbg)
call write_2d_real_array(ANISO_FILE,'$magn_yi',n,n,ri,dbg)
! projection Z
rr(:,:) = real(moment(3,:,:))
ri(:,:) = aimag(moment(3,:,:))
call write_2d_real_array(ANISO_FILE,'$magn_zr',n,n,rr,dbg)
call write_2d_real_array(ANISO_FILE,'$magn_zi',n,n,ri,dbg)
call mma_deallocate(rr)
call mma_deallocate(ri)

return

end subroutine write_magnetic_moment

subroutine write_electric_moment(ANISO_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE
integer(kind=iwp), intent(in) :: N
complex(kind=wp), intent(in) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: ri(:,:), rr(:,:)

call mma_allocate(rr,n,n,label='rr')
call mma_allocate(ri,n,n,label='ri')
! projection X
rr(:,:) = real(moment(1,:,:))
ri(:,:) = aimag(moment(1,:,:))
call write_2d_real_array(ANISO_FILE,'$edipm_xr',n,n,rr,dbg)
call write_2d_real_array(ANISO_FILE,'$edipm_xi',n,n,ri,dbg)
! projection Y
rr(:,:) = real(moment(2,:,:))
ri(:,:) = aimag(moment(2,:,:))
call write_2d_real_array(ANISO_FILE,'$edipm_yr',n,n,rr,dbg)
call write_2d_real_array(ANISO_FILE,'$edipm_yi',n,n,ri,dbg)
! projection Z
rr(:,:) = real(moment(3,:,:))
ri(:,:) = aimag(moment(3,:,:))
call write_2d_real_array(ANISO_FILE,'$edipm_zr',n,n,rr,dbg)
call write_2d_real_array(ANISO_FILE,'$edipm_zi',n,n,ri,dbg)
call mma_deallocate(rr)
call mma_deallocate(ri)

return

end subroutine write_electric_moment

subroutine write_spin_moment(ANISO_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE
integer(kind=iwp), intent(in) :: N
complex(kind=wp), intent(in) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: ri(:,:), rr(:,:)

call mma_allocate(rr,n,n,label='rr')
call mma_allocate(ri,n,n,label='ri')
! projection X
rr(:,:) = real(moment(1,:,:))
ri(:,:) = aimag(moment(1,:,:))
call write_2d_real_array(ANISO_FILE,'$spin_xr',n,n,rr,dbg)
call write_2d_real_array(ANISO_FILE,'$spin_xi',n,n,ri,dbg)
! projection Y
rr(:,:) = real(moment(2,:,:))
ri(:,:) = aimag(moment(2,:,:))
call write_2d_real_array(ANISO_FILE,'$spin_yr',n,n,rr,dbg)
call write_2d_real_array(ANISO_FILE,'$spin_yi',n,n,ri,dbg)
! projection Z
rr(:,:) = real(moment(3,:,:))
ri(:,:) = aimag(moment(3,:,:))
call write_2d_real_array(ANISO_FILE,'$spin_zr',n,n,rr,dbg)
call write_2d_real_array(ANISO_FILE,'$spin_zi',n,n,ri,dbg)
call mma_deallocate(rr)
call mma_deallocate(ri)

return

end subroutine write_spin_moment

subroutine write_angmom(ANISO_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: tmp(:,:)

call mma_allocate(tmp,N,N,label='tmp')
tmp(:,:) = moment(1,:,:)
call write_2d_real_array(ANISO_FILE,'$angmom_x',n,n,tmp,dbg)
tmp(:,:) = moment(2,:,:)
call write_2d_real_array(ANISO_FILE,'$angmom_y',n,n,tmp,dbg)
tmp(:,:) = moment(3,:,:)
call write_2d_real_array(ANISO_FILE,'$angmom_z',n,n,tmp,dbg)
call mma_deallocate(tmp)

return

end subroutine write_angmom

subroutine write_edipmom(ANISO_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: tmp(:,:)

call mma_allocate(tmp,N,N,label='tmp')
tmp(:,:) = moment(1,:,:)
call write_2d_real_array(ANISO_FILE,'$edmom_x',n,n,tmp,dbg)
tmp(:,:) = moment(2,:,:)
call write_2d_real_array(ANISO_FILE,'$edmom_y',n,n,tmp,dbg)
tmp(:,:) = moment(3,:,:)
call write_2d_real_array(ANISO_FILE,'$edmom_z',n,n,tmp,dbg)
call mma_deallocate(tmp)

return

end subroutine write_edipmom

subroutine write_amfi(ANISO_FILE,n,moment,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: moment(3,N,N)
logical(kind=iwp), intent(in) :: dbg
real(kind=wp), allocatable :: tmp(:,:)

call mma_allocate(tmp,N,N,label='tmp')
tmp(:,:) = moment(1,:,:)
call write_2d_real_array(ANISO_FILE,'$amfi_x',n,n,tmp,dbg)
tmp(:,:) = moment(2,:,:)
call write_2d_real_array(ANISO_FILE,'$amfi_y',n,n,tmp,dbg)
tmp(:,:) = moment(3,:,:)
call write_2d_real_array(ANISO_FILE,'$amfi_z',n,n,tmp,dbg)
call mma_deallocate(tmp)

return

end subroutine write_amfi

subroutine write_format(ANISO_FILE,n,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE
integer(kind=iwp), intent(in) :: n
logical(kind=iwp), intent(in) :: dbg

call write_INTEGER_scalar(ANISO_FILE,'$format',n,dbg)

return

end subroutine write_format

subroutine write_nss(ANISO_FILE,n,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n
logical(kind=iwp), intent(in) :: dbg

call write_INTEGER_scalar(ANISO_FILE,'$nss',n,dbg)

return

end subroutine write_nss

subroutine write_nstate(ANISO_FILE,n,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n
logical(kind=iwp), intent(in) :: dbg

call write_INTEGER_scalar(ANISO_FILE,'$nstate',n,dbg)

return

end subroutine write_nstate

subroutine write_nmult(ANISO_FILE,n,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n
logical(kind=iwp), intent(in) :: dbg

call write_INTEGER_scalar(ANISO_FILE,'$nmult',n,dbg)

return

end subroutine write_nmult

subroutine write_multiplicity(ANISO_FILE,n,array,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n, array(n)
logical(kind=iwp), intent(in) :: dbg

call write_1d_INTEGER_array(ANISO_FILE,'$multiplicity',n,array,dbg)

return

end subroutine write_multiplicity

subroutine write_imult(ANISO_FILE,n,array,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n, array(n)
logical(kind=iwp), intent(in) :: dbg

call write_1d_INTEGER_array(ANISO_FILE,'$imult',n,array,dbg)

return

end subroutine write_imult

subroutine write_nroot(ANISO_FILE,n,array,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n, array(n)
logical(kind=iwp), intent(in) :: dbg

call write_1d_INTEGER_array(ANISO_FILE,'$nroot',n,array,dbg)

return

end subroutine write_nroot

subroutine write_szproj(ANISO_FILE,n,array,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n, array(n)
logical(kind=iwp), intent(in) :: dbg

call write_1d_INTEGER_array(ANISO_FILE,'$szproj',n,array,dbg)

return

end subroutine write_szproj

subroutine write_eso(ANISO_FILE,n,array,dbg)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n
real(kind=wp), intent(in) :: array(n)
logical(kind=iwp), intent(in) :: dbg

if (dbg) write(u6,*) 'write_eso: '
call write_1d_real_array(ANISO_FILE,'$eso',n,array,dbg)

return

end subroutine write_eso

subroutine write_esfs(ANISO_FILE,n,array,dbg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n
real(kind=wp), intent(in) :: array(n)
logical(kind=iwp), intent(in) :: dbg

call write_1d_real_array(ANISO_FILE,'$esfs',n,array,dbg)

return

end subroutine write_esfs

subroutine write_hso(ANISO_FILE,n,array,dbg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n
complex(kind=wp), intent(in) :: array(n)
logical(kind=iwp), intent(in) :: dbg

call write_complex_matrix(ANISO_FILE,'$hso',n,array,dbg)

return

end subroutine write_hso

subroutine write_eigen(ANISO_FILE,n,array,dbg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n
complex(kind=wp), intent(in) :: array(n)
logical(kind=iwp), intent(in) :: dbg

call write_complex_matrix(ANISO_FILE,'$eigen',n,array,dbg)

return

end subroutine write_eigen

subroutine write_gtens(ANISO_FILE,nmult,gtens,axes,dbg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, nmult
real(kind=wp), intent(in) :: gtens(nmult,3), axes(nmult,3,3)
logical(kind=iwp), intent(in) :: dbg

call write_2d_real_array(ANISO_FILE,'$gtens_main',nmult,3,gtens,dbg)
call write_3d_real_array(ANISO_FILE,'$gtens_axes',nmult,3,3,axes,dbg)

return

end subroutine write_gtens

subroutine write_stev_cfp(ANISO_FILE,s,n,cfp,dbg)

use Constants, only: Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n   ! 2J+1, or 2L+1, i.e. the dimension of the J or L multiplet
character(len=*), intent(in) :: s
real(kind=wp), intent(in) :: cfp(n-1,-(n-1):n-1)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr, k, q
character(len=500) :: line
character(len=30) :: FMTCFP = '(2(I0,1x),ES22.14)'
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten

! s takes the value:
! 'L' == CFP for a term
! 'J' == CFP for a spin-orbit multiplet

ierr = 0
if ((n <= 0)) then
  call WarningMessage(1,'write_stev_cfp_'//trim(s)//' :: nothing to write. Array size = 0.')
  return
end if

if ((trim(s) /= 'l') .or. (trim(s) /= 'j')) then
  call WarningMessage(1,'write_stev_cfp_'//trim(s)//' :: the parameter s='//trim(s)// &
                      'is not understood. RETURN without writing cfp')
  return
end if

if (sum(abs(cfp)) <= MINIMAL_REAL) call WarningMessage(1,'write_stev_cfp_'//trim(s)//':: all array elements are zero = 0.')

rewind(ANISO_FILE)
call file_advance_to_string(ANISO_FILE,'$stev_cfp_'//trim(s),line,ierr,dbg)

if (ierr /= 0) then
  write(ANISO_FILE,'(A)',iostat=ierr)
  write(ANISO_FILE,'(A)',iostat=ierr) '$stev_cfp_'//trim(s)
end if

! if key is found, THEN rewrite the data
write(ANISO_FILE,*,iostat=ierr) n
do k=2,n-1,2
  do q=-k,k,2
    if (abs(cfp(k,q)) > MINIMAL_REAL) write(ANISO_FILE,FMTCFP,iostat=ierr) k,q,cfp(k,q)
    if (ierr /= 0) call WarningMessage(2,'write_stev_cfp_'//trim(s)//':: Something went wrong writing the array.')
    if (dbg) write(u6,*) 'write_stev_cfp_'//trim(s)//'::  k, q =',k,q
  end do
end do
write(ANISO_FILE,'(A)',iostat=ierr)
call xFlush(ANISO_FILE)

return

end subroutine write_stev_cfp

subroutine write_susc(ANISO_FILE,s,n,field,zj,t,z,x,x_tens,dbg)
! n     :  number of temperature points
! field :  applied field
! zJ    :  intermolecular interaction
! t     :  temperature points
! z     :  partition function
! x     :  susceptibility X
! x_tens:  susceptibility tensor X_tens

use Constants, only: Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, n
character(len=*), intent(in) :: s
real(kind=wp), intent(in) :: field, zJ, t(n), z(n), x(n), x_tens(n,3,3)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k
character(len=500) :: line
character(len=*), parameter :: FMTI = '(20(I0,1x))', FMTR = '(5ES22.14)'
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
real(kind=wp), external :: dnrm2_

! s takes the values:
! 'x'
! 'x_field'
! 'x_minus_one'
! 'x_field_minus_one'
! 'xt'
! 'xt_field'
! 'xt_minus_one'
! 'xt_field_minus_one'
! 'x_zj'
! 'x_field_zj'
! 'x_minus_one_zj'
! 'x_field_minus_one_zj'
! 'xt_zj'
! 'xt_field_zj'
! 'xt_minus_one_zj'
! 'xt_field_minus_one_zj'
!if ((trim(s) /= 'x')                    .or. &
!    (trim(s) /= 'x_field')              .or. &
!    (trim(s) /= 'x_minus_one')          .or. &
!    (trim(s) /= 'x_field_minus_one')    .or. &
!    (trim(s) /= 'xt')                   .or. &
!    (trim(s) /= 'xt_field')             .or. &
!    (trim(s) /= 'xt_minus_one')         .or. &
!    (trim(s) /= 'xt_field_minus_one')   .or. &
!    (trim(s) /= 'x_zj')                 .or. &
!    (trim(s) /= 'x_field_zj')           .or. &
!    (trim(s) /= 'x_minus_one_zj')       .or. &
!    (trim(s) /= 'x_field_minus_one_zj') .or. &
!    (trim(s) /= 'xt_zj')                .or. &
!    (trim(s) /= 'xt_field_zj')          .or. &
!    (trim(s) /= 'xt_minus_one_zj')      .or. &
!    (trim(s) /= 'xt_field_minus_one_zj')) then
!
!  call WarningMessage(1,'write_susc '//trim(s)//' :: the parameter s='//trim(s)// &
!                      ' is not understood. RETURN without write of X data.')
!  return
!end if

ierr = 0
if ((n <= 0)) then
  call WarningMessage(1,'write_susc '//trim(s)//' :: nothing to write. Array size = 0.')
  return
end if
if (dnrm2_(n,T,1) <= MINIMAL_REAL) call WarningMessage(1,'write_susc '//trim(s)//' :: all array T elements are zero = 0.')
if (dnrm2_(n,X,1) <= MINIMAL_REAL) call WarningMessage(1,'write_susc '//trim(s)//' :: all array X elements are zero = 0.')
if (dnrm2_(n,Z,1) <= MINIMAL_REAL) call WarningMessage(1,'write_susc '//trim(s)//' :: all array Z elements are zero = 0.')
if (dnrm2_(3*3*n,X_tens,1) <= MINIMAL_REAL) call WarningMessage(1,'write_susc '//trim(s)// &
                                                                ' :: all array X_tens elements are zero = 0.')

rewind(ANISO_FILE)
call file_advance_to_string(ANISO_FILE,'$susceptibility_'//trim(s),line,ierr,dbg)

if (ierr /= 0) then
  write(ANISO_FILE,'(A)',iostat=ierr)
  write(ANISO_FILE,'(A)',iostat=ierr) '$susceptibility_'//trim(s)
end if

write(ANISO_FILE,FMTI,iostat=ierr) n
write(ANISO_FILE,FMTR,iostat=ierr) zj,field
if (ierr /= 0) call WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the zJ and field values.')
write(ANISO_FILE,FMTR,iostat=ierr) (T(i),i=1,n)
if (ierr /= 0) call WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the T array.')
write(ANISO_FILE,FMTR,iostat=ierr) (Z(i),i=1,n)
if (ierr /= 0) call WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the Z array.')
write(ANISO_FILE,FMTR,iostat=ierr) (X(i),i=1,n)
if (ierr /= 0) call WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the X array.')
call xFlush(ANISO_FILE)
do j=1,3
  do k=1,3
    write(ANISO_FILE,FMTR,iostat=ierr) (X_tens(i,j,k),i=1,n)
    if (ierr /= 0) call WarningMessage(2,'write_susc '//trim(s)//' :: Something went wrong writing the X_tens array.')
  end do
end do
write(ANISO_FILE,*,iostat=ierr)
call xFlush(ANISO_FILE)
if (dbg) call xFlush(u6)

return

end subroutine write_susc

subroutine write_magn(ANISO_FILE,nt,nh,nd,nss,zj,t,h,x,y,z,w,m,mav,energy,dbg)
! nt        :  number of temperature points
! nh        :  number of field points
! nd        :  number of directions of aplied field
! nss       :  number of spin-orbit states included in the Zeeman interaction
! zj        :  inter-molecular parameter zJ
! t         :  temperature points
! h         :  field points
! x, y, z, w:  Lebedev grid directions and weight
! m         :  magnetisation vector
! mav       :  average magnetisation vector
! energy    :  Zeeman energy states

use Constants, only: Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE, nt, nh, nd, nss
real(kind=wp), intent(in) :: zj, t(nt), h(nh), x(nd), y(nd), z(nd), w(nd), m(nd,3,nh,nt), mav(nh,nt), energy(nd,nh,nss)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, id, ierr, ih, iss, it, l
character(len=500) :: line
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
character(len=*), parameter :: FMTI = '(20(I0,1x))', FMTR = '(5ES22.14)'
real(kind=wp), external :: dnrm2_

ierr = 0
if ((nt <= 0) .or. (nh <= 0) .or. (nd <= 0)) then
  call WarningMessage(1,'write_magn :: nothing to write. Array size = 0.')
  return
end if
if (dnrm2_(nt,t,1) <= MINIMAL_REAL) call WarningMessage(1,'write_magn :: all array T elements are zero = 0.')
if (dnrm2_(nh,h,1) <= MINIMAL_REAL) call WarningMessage(1,'write_magn :: all array H elements are zero = 0.')
if (dnrm2_(nd*3*nt*nh,m,1) <= MINIMAL_REAL) call WarningMessage(1,'write_magn :: all array M elements are zero = 0.')
if (dnrm2_(nt*nh,mav,1) <= MINIMAL_REAL) call WarningMessage(1,'write_magn :: all array MAV elements are zero = 0.')
if (dnrm2_(nd*nh*nss,energy,1) <= MINIMAL_REAL) call WarningMessage(1,'write_magn :: all array energy elements are zero = 0.')
if ((dnrm2_(nd,x,1) <= MINIMAL_REAL) .or. (dnrm2_(nd,y,1) <= MINIMAL_REAL) .or. &
    (dnrm2_(nd,z,1) <= MINIMAL_REAL) .or. (dnrm2_(nd,w,1) <= MINIMAL_REAL)) &
  call WarningMessage(1,'write_magn :: all array of X,Y,X,W elements are zero = 0.')

rewind(ANISO_FILE)
call file_advance_to_string(ANISO_FILE,'$magnetisation',line,ierr,dbg)

! if key is found, THEN rewrite the data
if (ierr /= 0) then
  write(ANISO_FILE,'(A)',iostat=ierr)
  write(ANISO_FILE,'(A)',iostat=ierr) '$magnetisation'
end if

write(ANISO_FILE,FMTI,iostat=ierr) nt,nh,nd,nss
write(ANISO_FILE,FMTR,iostat=ierr) zJ
write(ANISO_FILE,FMTR,iostat=ierr) (T(i),i=1,nt)
if (ierr /= 0) call WarningMessage(2,'write_magn :: Something went wrong writing the T array.')
! Magnetic field points
write(ANISO_FILE,FMTR,iostat=ierr) (H(i),i=1,nh)
if (ierr /= 0) call WarningMessage(2,'write_magn :: Something went wrong writing the H array.')
! Lebedev grid data (X, Y, Z, W)
write(ANISO_FILE,FMTR,iostat=ierr) (X(i),i=1,nd)
if (ierr /= 0) call WarningMessage(2,'write_magn :: Something went wrong writing the Lebedev grid X rray.')
write(ANISO_FILE,FMTR,iostat=ierr) (Y(i),i=1,nd)
if (ierr /= 0) call WarningMessage(2,'write_magn :: Something went wrong writing the Lebedev grid Y array.')
write(ANISO_FILE,FMTR,iostat=ierr) (Z(i),i=1,nd)
if (ierr /= 0) call WarningMessage(2,'write_magn :: Something went wrong writing the Lebedev grid Z array.')
write(ANISO_FILE,FMTR,iostat=ierr) (W(i),i=1,nd)
if (ierr /= 0) call WarningMessage(2,'write_magn :: Something went wrong writing the Lebedev grid W array.')
call xFlush(ANISO_FILE)
! Zeeman energy
do id=1,nd
  do ih=1,nh
    write(ANISO_FILE,FMTR,iostat=ierr) (energy(id,ih,iss),iss=1,nss)
    if (ierr /= 0) call WarningMessage(2,'write_magn :: Something went wrong writing the Zeeman energy data.')
  end do
end do
call xFlush(ANISO_FILE)
! magnetisation vector data
do id=1,nd
  do l=1,3
    do ih=1,nh
      write(ANISO_FILE,FMTR,iostat=ierr) (m(id,l,ih,it),it=1,nt)
      if (ierr /= 0) call WarningMessage(2,'write_magn :: Something went wrong writing the M data.')
    end do
  end do
end do
call xFlush(ANISO_FILE)
do ih=1,nh
  write(ANISO_FILE,FMTR,iostat=ierr) (mav(ih,it),it=1,nt)
  if (ierr /= 0) call WarningMessage(2,'write_magn :: Something went wrong writing the average M data.')
end do
write(ANISO_FILE,*,iostat=ierr)
call xFlush(ANISO_FILE)
if (dbg) call xFlush(u6)

return

end subroutine write_magn

!--------------------------------------------------------------------------------------------------!
!  BASIC  OPEN FILE / CLOSE FILE / SEARCH KEY INSIDE FILE etc. functions
!
!   open_datafile_write
!   open_datafile_read
!   close_datafile
!   key_found
!   file_advance_to_string
!
!--------------------------------------------------------------------------------------------------!

subroutine open_datafile_write(DATA_FILE,DATA_FILE_NAME)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE
character(len=180), intent(in) :: DATA_FILE_NAME
!#ifdef _ALONE_
!integer :: ierr
!#endif

!#ifdef _ALONE_
!ierr = 0
!open(unit=DATA_FILE,file=DATA_FILE_NAME,form='formatted',status='old',access='sequential',action='write',iostat=ierr )
!if (ierr /= 0) call WarningMessage(2,'open_datafile_write:: Something went wrong opening DATA_FILE')
!#else
call molcas_open(DATA_FILE,DATA_FILE_NAME)
!#endif

return

end subroutine open_datafile_write

subroutine open_aniso_file(ANISO_FILE,ANISO_FILE_NAME)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE
character(len=180), intent(in) :: ANISO_FILE_NAME
!#ifdef _ALONE_
!integer :: ierr
!#endif

!#ifdef _ALONE_
!ierr = 0
!open(unit=ANISO_FILE,form='formatted',status='old',access='sequential',action='write',iostat=ierr )
!if (ierr /= 0) call WarningMessage(2,'open_datafile_write:: Something went wrong opening ANISO_FILE')
!#else
call molcas_open(ANISO_FILE,ANISO_FILE_NAME)
!#endif

return

end subroutine open_aniso_file

subroutine open_datafile_read(DATA_FILE,DATA_FILE_NAME)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE
character(len=180), intent(in) :: DATA_FILE_NAME
!#ifdef _ALONE_
!integer :: ierr
!#endif

!#ifdef _ALONE_
!ierr = 0
!open(unit=DATA_FILE,form='FORMATTED',status='old',access='sequential',action='read',iostat=ierr )
!if (ierr /= 0) call WarningMessage(2,'open_datafile_read:: Something went wrong opening DATA_FILE')
!#else
call molcas_open(DATA_FILE,DATA_FILE_NAME)
!#endif

return

end subroutine open_datafile_read

subroutine close_datafile(DATA_FILE)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: DATA_FILE
integer(kind=iwp) :: ierr

ierr = 0
close(unit=DATA_FILE,iostat=ierr)
if (ierr /= 0) call WarningMessage(2,'close_datafile:: Something went wrong closing DATA_FILE')

return

end subroutine close_datafile

subroutine close_anisofile(ANISO_FILE)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ANISO_FILE
integer(kind=iwp) :: ierr

ierr = 0
close(unit=ANISO_FILE,iostat=ierr)
if (ierr /= 0) call WarningMessage(2,'close_datafile:: Something went wrong closing ANISO_FILE')

return

end subroutine close_anisofile

function key_found(DATA_FILE,key,dbg)

use Definitions, only: iwp

implicit none
logical(kind=iwp) :: key_found
integer(kind=iwp), intent(in) :: DATA_FILE
character(len=*), intent(in) :: key
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line

ierr = 0
key_found = .false.
rewind(DATA_FILE)
call file_advance_to_string(DATA_FILE,key,line,ierr,dbg)
if (index(line,trim(key)) /= 0) key_found = .true.

return

end function key_found

subroutine file_advance_to_string(LU,key,line,ierr,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
character(len=*), intent(out) :: line
integer(kind=iwp), intent(out) :: ierr
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ios, num_read

ierr = 0
num_read = 0

rewind(LU)
do
  read(LU,'(a)',iostat=ios) line

  if (ios /= 0) then
    !write(u6,'(A,i0,2A)') 'file_advance_to_string:: error reading line: LU=',LU,' key=',key
    exit
  end if

  num_read = num_read+1

  if (index(line,trim(key)) /= 0) return
end do

line = ' '
ierr = 1

if (dbg) then
  write(u6,'(a)') ' '
  write(u6,'(a)') 'FILE_ADVANCE_TO_STRING - Warning!'
  write(u6,'(a)') '  Did not find the key:'
  write(u6,'(a)') '    '//trim(key)
  write(u6,'(a,i6)') '  Number of lines read was ',num_read
end if

return

end subroutine file_advance_to_string

function inquire_key_presence(LU,key)

use Definitions, only: iwp

implicit none
logical(kind=iwp) :: inquire_key_presence
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
integer(kind=iwp) :: ios
character(len=500) :: line

inquire_key_presence = .false.
rewind(LU)
do
  read(LU,'(a)',iostat=ios) line
  if (ios /= 0) call WarningMessage(1,'inquire_key_presence:: error reading line')
  if (index(line,trim(key)) /= 0) then
    inquire_key_presence = .true.
    return
  end if
end do
line = ' '

return

end function inquire_key_presence

!----------------------------------------------------------------------!
!   READING  SUBROUTINES
!----------------------------------------------------------------------!

subroutine read_INTEGER_scalar(LU,key,i,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
integer(kind=iwp), intent(out) :: i
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line

ierr = 0
i = 0
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
read(LU,*,iostat=ierr) i
if (ierr /= 0) call WarningMessage(2,'read_INTEGER_scalar:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_INTEGER_scalar:: key =',trim(key)
  write(u6,*) 'read_INTEGER_scalar::   i =',i
end if

return

end subroutine read_INTEGER_scalar

subroutine read_real_scalar(LU,key,r,dbg)

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
real(kind=wp), intent(out) :: r
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line

ierr = 0
r = Zero
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
read(LU,*,iostat=ierr) r
if (ierr /= 0) call WarningMessage(2,'read_real_scalar:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_real_scalar:: key =',trim(key)
  write(u6,*) 'read_real_scalar::   r =',r
end if

return

end subroutine read_real_scalar

subroutine read_complex_scalar(LU,key,c,dbg)

use Constants, only: Zero, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
complex(kind=wp), intent(out) :: c
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
real(kind=wp) :: ri, rr
character(len=500) :: line

ierr = 0
rr = Zero
ri = Zero
c = cZero
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
read(LU,*,iostat=ierr) rr,ri
if (ierr /= 0) call WarningMessage(2,'read_complex_scalar:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_complex_scalar::   key =',trim(key)
  write(u6,*) 'read_complex_scalar:: (r,i) =',rr,ri
  write(u6,*) 'read_complex_scalar::     c =',c
end if
c = cmplx(rr,ri,kind=wp)

return

end subroutine read_complex_scalar

subroutine read_string(LU,key,length,s,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, length
character(len=*), intent(in) :: key
character(len=length), intent(out) :: s
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr
character(len=500) :: c, f, line

if (dbg) then
  write(u6,*) 'read_string::    key =',trim(key)
  write(u6,*) 'read_string:: length =',length
end if
write(f,'(A,i0,2A)') '"(A',length,')"'
write(u6,'(2A)') 'format =',trim(f)
call xFlush(u6)
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
read(LU,f,iostat=ierr) c
write(u6,'(2A)') 'c =',trim(c)
write(s,'(A)') trim(c)

do i=1,len(trim(LINE))
  read(LINE,'(A500)') c
  write(s,'(A)') trim(c)
  if (dbg) write(u6,*) 'read_string::   c =',trim(c)
  call xFlush(u6)
end do

return

end subroutine read_string

subroutine read_1d_size(LU,key,n,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
integer(kind=iwp), intent(out) :: n
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line

ierr = 0
n = 0
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
read(LU,*,iostat=ierr) n
if (ierr /= 0) call WarningMessage(2,'read_1d_size:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_1d_size:: key =',trim(key)
  write(u6,*) 'read_1d_size::   n =',n
end if

return

end subroutine read_1d_size

subroutine read_2d_size(LU,key,n1,n2,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
integer(kind=iwp), intent(out) :: n1, n2
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line

ierr = 0
n1 = 0
n2 = 0
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
read(LU,*,iostat=ierr) n1,n2
if (ierr /= 0) call WarningMessage(2,'read_2d_size:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_2d_size:: key =',trim(key)
  write(u6,*) 'read_2d_size::  n1 =',n1
  write(u6,*) 'read_2d_size::  n2 =',n2
end if

return

end subroutine read_2d_size

subroutine read_3d_size(LU,key,n1,n2,n3,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
integer(kind=iwp), intent(out) :: n1, n2, n3
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line

ierr = 0
n1 = 0
n2 = 0
n3 = 0
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
read(LU,*,iostat=ierr) n1,n2,n3
if (ierr /= 0) call WarningMessage(2,'read_3d_size:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_3d_size:: key =',trim(key)
  write(u6,*) 'read_3d_size::  n1 =',n1
  write(u6,*) 'read_3d_size::  n2 =',n2
  write(u6,*) 'read_3d_size::  n3 =',n3
end if

return

end subroutine read_3d_size

subroutine read_4d_size(LU,key,n1,n2,n3,n4,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
integer(kind=iwp), intent(out) :: n1, n2, n3, n4
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line

ierr = 0
n1 = 0
n2 = 0
n3 = 0
n4 = 0
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
read(LU,*,iostat=ierr) n1,n2,n3,n4
if (ierr /= 0) call WarningMessage(2,'read_4d_size:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_4d_size:: key =',trim(key)
  write(u6,*) 'read_4d_size::  n1 =',n1
  write(u6,*) 'read_4d_size::  n2 =',n2
  write(u6,*) 'read_4d_size::  n3 =',n3
  write(u6,*) 'read_4d_size::  n4 =',n4
end if

return

end subroutine read_4d_size

subroutine read_1d_INTEGER_array(LU,key,n,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n
character(len=*), intent(in) :: key
integer(kind=iwp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr
character(len=500) :: line

ierr = 0
array = 0
if (n <= 0) then
  call WarningMessage(1,'read_1d_INTEGER_array:: nothing to read. Array size = 0.')
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i
if (ierr /= 0) call WarningMessage(2,'read_1d_INTEGER_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_1d_INTEGER_array:: key =',trim(key)
  write(u6,*) 'read_1d_INTEGER_array::   n =',i
end if
if (i /= n) call WarningMessage(2,'read_1d_INTEGER_array:: sizes of the array are different from the ones used to CALL this '// &
                                'SUBROUTINE')

read(LU,*,iostat=ierr) (array(i),i=1,n)
if (ierr /= 0) call WarningMessage(2,'read_1d_INTEGER_array:: Something went wrong reading the array.')
if (dbg) write(u6,*) 'read_1d_INTEGER_array:: array =',(array(i),i=1,n)

return

end subroutine read_1d_INTEGER_array

subroutine read_2d_INTEGER_array(LU,key,n1,n2,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2
character(len=*), intent(in) :: key
integer(kind=iwp), intent(out) :: array(n1,n2)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j
character(len=500) :: line

ierr = 0
array = 0
if ((n1 <= 0) .or. (n2 <= 0)) then
  call WarningMessage(1,'read_2d_INTEGER_array:: nothing to read. Array size = 0.')
  if (dbg) then
    write(u6,*) 'read_2d_INTEGER_array::   n1 =',n1
    write(u6,*) 'read_2d_INTEGER_array::   n2 =',n2
  end if
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i,j
if (ierr /= 0) call WarningMessage(2,'read_2d_INTEGER_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_2d_INTEGER_array:: key =',trim(key)
  write(u6,*) 'read_2d_INTEGER_array::  n1 =',i
  write(u6,*) 'read_2d_INTEGER_array::  n2 =',j
end if
if ((i /= n1) .or. (j /= n2)) call WarningMessage(2,'read_2d_INTEGER_array:: sizes of the array are different from the ones '// &
                                                  'used to CALL this SUBROUTINE')
do i=1,n1
  read(LU,*,iostat=ierr) (array(i,j),j=1,n2)
  if (ierr /= 0) call WarningMessage(2,'read_2d_INTEGER_array:: Something went wrong reading the array.')
  if (dbg) write(u6,*) 'read_2d_INTEGER_array::  i =',i
end do

return

end subroutine read_2d_INTEGER_array

subroutine read_3d_INTEGER_array(LU,key,n1,n2,n3,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3
character(len=*), intent(in) :: key
integer(kind=iwp), intent(out) :: array(n1,n2,n3)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k
character(len=500) :: line

ierr = 0
array = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0)) then
  call WarningMessage(1,'read_3d_INTEGER_array:: nothing to read. Array size = 0.')
  if (dbg) then
    write(u6,*) 'read_3d_INTEGER_array::   n1 =',n1
    write(u6,*) 'read_3d_INTEGER_array::   n2 =',n2
    write(u6,*) 'read_3d_INTEGER_array::   n3 =',n3
  end if
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i,j,k
if (ierr /= 0) call WarningMessage(2,'read_3d_INTEGER_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_3d_INTEGER_array:: key =',trim(key)
  write(u6,*) 'read_3d_INTEGER_array::  n1 =',i
  write(u6,*) 'read_3d_INTEGER_array::  n2 =',j
  write(u6,*) 'read_3d_INTEGER_array::  n3 =',k
end if
if ((i /= n1) .or. (j /= n2) .or. (k /= n3)) call WarningMessage(2,'read_3d_INTEGER_array:: sizes of the array are different '// &
                                                                 'from the ones used to CALL this SUBROUTINE')
do i=1,n1
  do j=1,n2
    read(LU,*,iostat=ierr) (array(i,j,k),k=1,n3)
    if (ierr /= 0) call WarningMessage(2,'read_3d_INTEGER_array:: Something went wrong reading the array.')
    if (dbg) write(u6,*) 'read_3d_INTEGER_array::  i,j =',i,j
  end do
end do

return

end subroutine read_3d_INTEGER_array

subroutine read_4d_INTEGER_array(LU,key,n1,n2,n3,n4,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3, n4
character(len=*), intent(in) :: key
integer(kind=iwp), intent(out) :: array(n1,n2,n3,n4)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k, l
character(len=500) :: line

ierr = 0
array = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0) .or. (n4 <= 0)) then
  call WarningMessage(1,'read_4d_INTEGER_array:: nothing to read. Array size = 0.')
  if (dbg) then
    write(u6,*) 'read_4d_INTEGER_array::   n1 =',n1
    write(u6,*) 'read_4d_INTEGER_array::   n2 =',n2
    write(u6,*) 'read_4d_INTEGER_array::   n3 =',n3
    write(u6,*) 'read_4d_INTEGER_array::   n4 =',n4
  end if
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i,j,k,l
if (ierr /= 0) call WarningMessage(2,'read_4d_INTEGER_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_4d_INTEGER_array:: key =',trim(key)
  write(u6,*) 'read_4d_INTEGER_array::  n1 =',i
  write(u6,*) 'read_4d_INTEGER_array::  n2 =',j
  write(u6,*) 'read_4d_INTEGER_array::  n3 =',k
  write(u6,*) 'read_4d_INTEGER_array::  n4 =',l
end if
if ((i /= n1) .or. (j /= n2) .or. (k /= n3) .or. (l /= n4)) &
  call WarningMessage(2,'read_4d_INTEGER_array:: sizes of the array are different from the ones used to CALL this SUBROUTINE')
do i=1,n1
  do j=1,n2
    do k=1,n3
      read(LU,*,iostat=ierr) (array(i,j,k,l),l=1,n4)
      if (ierr /= 0) call WarningMessage(2,'read_4d_INTEGER_array:: Something went wrong reading the array.')
      if (dbg) write(u6,*) 'read_4d_INTEGER_array::  i,j,k =',i,j,k
    end do
  end do
end do

return

end subroutine read_4d_INTEGER_array

subroutine read_1d_real_array(LU,key,n,array,dbg)

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n
character(len=*), intent(in) :: key
real(kind=wp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr
character(len=500) :: line

ierr = 0
array(:) = Zero
if (n <= 0) then
  call WarningMessage(1,'read_1d_real_array:: nothing to read. Array size = 0.')
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i
if (ierr /= 0) call WarningMessage(2,'read_1d_real_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_1d_real_array:: key =',trim(key)
  write(u6,*) 'read_1d_real_array::   n =',i
end if
if ((i /= n)) call WarningMessage(2,'read_1d_real_array:: sizes of the array are different from the ones used to CALL this '// &
                                  'SUBROUTINE')

read(LU,*,iostat=ierr) (array(i),i=1,n)
if (ierr /= 0) call WarningMessage(2,'read_1d_real_array:: Something went wrong reading the array.')
if (dbg) write(u6,*) 'read_1d_real_array:: array =',(array(i),i=1,n)

return

end subroutine read_1d_real_array

subroutine read_2d_real_array(LU,key,n1,n2,array,dbg)

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2
character(len=*), intent(in) :: key
real(kind=wp), intent(out) :: array(n1,n2)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j
character(len=500) :: line

ierr = 0
array(:,:) = Zero
if ((n1 <= 0) .or. (n2 <= 0)) then
  call WarningMessage(1,'read_2d_real_array:: nothing to read. Array size = 0.')
  if (dbg) then
    write(u6,*) 'read_2d_real_array::   n1 =',n1
    write(u6,*) 'read_2d_real_array::   n2 =',n2
  end if
  return
end if

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr /= 0) call WarningMessage(2,'read_2d_real_array:: Something went wrong reading key'//trim(key))
if (dbg) write(u6,*) 'read_2d_real_array:: key =',trim(key)

read(LU,*,iostat=ierr) i,j

if (dbg) then
  write(u6,*) 'read_2d_real_array::  n1 =',i
  write(u6,*) 'read_2d_real_array::  n2 =',j
end if
if ((i /= n1) .or. (j /= n2)) call WarningMessage(2,'read_2d_real_array:: sizes of the array are different from the ones used '// &
                                                  'to CALL this SUBROUTINE')

do i=1,n1
  read(LU,*,iostat=ierr) (array(i,j),j=1,n2)
  if (dbg) write(u6,*) (array(i,j),j=1,n2)
  if (ierr /= 0) call WarningMessage(2,'read_2d_real_array:: Something went wrong reading the array.')
  if (dbg) write(u6,*) 'read_2d_real_array::  i =',i
end do

return

end subroutine read_2d_real_array

subroutine read_3d_real_array(LU,key,n1,n2,n3,array,dbg)

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3
character(len=*), intent(in) :: key
real(kind=wp), intent(out) :: array(n1,n2,n3)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k
character(len=500) :: line

ierr = 0
array(:,:,:) = Zero
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0)) then
  call WarningMessage(1,'read_3d_real_array:: nothing to read. Array size = 0.')
  if (dbg) then
    write(u6,*) 'read_3d_real_array::   n1 =',n1
    write(u6,*) 'read_3d_real_array::   n2 =',n2
    write(u6,*) 'read_3d_real_array::   n3 =',n3
  end if
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i,j,k
if (ierr /= 0) call WarningMessage(2,'read_3d_real_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_3d_real_array:: key =',trim(key)
  write(u6,*) 'read_3d_real_array::  n1 =',i
  write(u6,*) 'read_3d_real_array::  n2 =',j
  write(u6,*) 'read_3d_real_array::  n3 =',k
end if
if ((i /= n1) .or. (j /= n2) .or. (k /= n3)) call WarningMessage(2,'read_3d_real_array:: sizes of the array are different from '// &
                                                                 'the ones used to CALL this SUBROUTINE')
do i=1,n1
  do j=1,n2
    read(LU,*,iostat=ierr) (array(i,j,k),k=1,n3)
    if (ierr /= 0) call WarningMessage(2,'read_3d_real_array:: Something went wrong reading the array.')
    if (dbg) write(u6,*) 'read_3d_real_array::  i,j =',i,j
  end do
end do

return

end subroutine read_3d_real_array

subroutine read_4d_real_array(LU,key,n1,n2,n3,n4,array,dbg)

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3, n4
character(len=*), intent(in) :: key
real(kind=wp), intent(out) :: array(n1,n2,n3,n4)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k, l
character(len=500) :: line

ierr = 0
array(:,:,:,:) = Zero
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0) .or. (n4 <= 0)) then
  call WarningMessage(1,'read_4d_real_array:: nothing to read. Array size = 0.')
  if (dbg) then
    write(u6,*) 'read_4d_real_array::   n1 =',n1
    write(u6,*) 'read_4d_real_array::   n2 =',n2
    write(u6,*) 'read_4d_real_array::   n3 =',n3
    write(u6,*) 'read_4d_real_array::   n4 =',n4
  end if
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i,j,k,l
if (ierr /= 0) call WarningMessage(2,'read_4d_real_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_4d_real_array:: key =',trim(key)
  write(u6,*) 'read_4d_real_array::  n1 =',i
  write(u6,*) 'read_4d_real_array::  n2 =',j
  write(u6,*) 'read_4d_real_array::  n3 =',k
  write(u6,*) 'read_4d_real_array::  n4 =',l
end if
if ((i /= n1) .or. (j /= n2) .or. (k /= n3) .or. (l /= n4)) &
  call WarningMessage(2,'read_4d_real_array:: sizes of the array are different from the ones used to CALL this SUBROUTINE')
do i=1,n1
  do j=1,n2
    do k=1,n3
      read(LU,*,iostat=ierr) (array(i,j,k,l),l=1,n4)
      if (ierr /= 0) call WarningMessage(2,'read_4d_real_array:: Something went wrong reading the array.')
      if (dbg) write(u6,*) 'read_4d_real_array::  i,j,k =',i,j,k
    end do
  end do
end do

return

end subroutine read_4d_real_array

subroutine read_1d_complex_array(LU,key,n,array,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n
character(len=*), intent(in) :: key
complex(kind=wp), intent(out) :: array(n)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr
character(len=500) :: line
real(kind=wp), allocatable :: ri(:), rr(:)

ierr = 0
if (n <= 0) then
  call WarningMessage(1,'read_1d_complex_array:: nothing to read. Array size = 0.')
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i
if (ierr /= 0) call WarningMessage(2,'read_1d_complex_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_1d_complex_array:: key =',trim(key)
  write(u6,*) 'read_1d_complex_array::   n =',i
end if
if ((i /= n)) call WarningMessage(2,'read_1d_complex_array:: sizes of the array are different from the ones used to CALL this '// &
                                  'SUBROUTINE')
call mma_allocate(rr,n,label='rr')
call mma_allocate(ri,n,label='ri')
rr(:) = Zero
ri(:) = Zero
read(LU,*,iostat=ierr) (rr(i),ri(i),i=1,n)
if (ierr /= 0) call WarningMessage(2,'read_1d_complex_array:: Something went wrong reading the array.')
if (dbg) write(u6,*) 'read_1d_complex_array:: array =',(rr(i),ri(i),i=1,n)
array(:) = cmplx(rr(:),ri(:),kind=wp)
call mma_deallocate(rr)
call mma_deallocate(ri)

return

end subroutine read_1d_complex_array

subroutine read_2d_complex_array(LU,key,n1,n2,array,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2
character(len=*), intent(in) :: key
complex(kind=wp), intent(out) :: array(n1,n2)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j
character(len=500) :: line
real(kind=wp), allocatable :: ri(:,:), rr(:,:)

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0)) then
  call WarningMessage(1,'read_2d_complex_array:: nothing to read. Array size = 0.')
  if (dbg) then
    write(u6,*) 'read_2d_complex_array::   n1 =',n1
    write(u6,*) 'read_2d_complex_array::   n2 =',n2
  end if
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i,j
if (ierr /= 0) call WarningMessage(2,'read_2d_complex_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_2d_complex_array:: key =',trim(key)
  write(u6,*) 'read_2d_complex_array::  n1 =',i
  write(u6,*) 'read_2d_complex_array::  n2 =',j
end if
if ((i /= n1) .or. (j /= n2)) call WarningMessage(2,'read_2d_complex_array:: sizes of the array are different from the ones '// &
                                                  'used to CALL this SUBROUTINE')
call mma_allocate(rr,n1,n2,label='rr')
call mma_allocate(ri,n1,n2,label='ri')
rr(:,:) = Zero
ri(:,:) = Zero
do i=1,n1
  read(LU,*,iostat=ierr) (rr(i,j),ri(i,j),j=1,n2)
  if (ierr /= 0) call WarningMessage(2,'read_2d_complex_array:: Something went wrong reading the array.')
  if (dbg) write(u6,*) 'read_2d_complex_array::  i =',i
end do
array(:,:) = cmplx(rr(:,:),ri(:,:),kind=wp)
call mma_deallocate(rr)
call mma_deallocate(ri)

return

end subroutine read_2d_complex_array

subroutine read_3d_complex_array(LU,key,n1,n2,n3,array,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3
character(len=*), intent(in) :: key
complex(kind=wp), intent(out) :: array(n1,n2,n3)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k
character(len=500) :: line
real(kind=wp), allocatable :: ri(:,:,:), rr(:,:,:)

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0)) then
  call WarningMessage(1,'read_3d_complex_array:: nothing to read. Array size = 0.')
  if (dbg) then
    write(u6,*) 'read_3d_complex_array::   n1 =',n1
    write(u6,*) 'read_3d_complex_array::   n2 =',n2
    write(u6,*) 'read_3d_complex_array::   n3 =',n3
  end if
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i,j,k
if (ierr /= 0) call WarningMessage(2,'read_3d_complex_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_3d_complex_array:: key =',trim(key)
  write(u6,*) 'read_3d_complex_array::  n1 =',i
  write(u6,*) 'read_3d_complex_array::  n2 =',j
  write(u6,*) 'read_3d_complex_array::  n3 =',k
end if
if ((i /= n1) .or. (j /= n2) .or. (k /= n3)) call WarningMessage(2,'read_3d_complex_array:: sizes of the array are different '// &
                                                                 'from the ones used to CALL this SUBROUTINE')
call mma_allocate(rr,n1,n2,n3,label='rr')
call mma_allocate(ri,n1,n2,n3,label='ri')
rr(:,:,:) = Zero
ri(:,:,:) = Zero
do i=1,n1
  do j=1,n2
    read(LU,*,iostat=ierr) (rr(i,j,k),ri(i,j,k),k=1,n3)
    if (ierr /= 0) call WarningMessage(2,'read_3d_complex_array:: Something went wrong reading the array.')
    if (dbg) write(u6,*) 'read_3d_complex_array::  i,j =',i,j
  end do
end do
array(:,:,:) = cmplx(rr(:,:,:),ri(:,:,:),kind=wp)
call mma_deallocate(rr)
call mma_deallocate(ri)

return

end subroutine read_3d_complex_array

subroutine read_4d_complex_array(LU,key,n1,n2,n3,n4,array,dbg)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3, n4
character(len=*), intent(in) :: key
complex(kind=wp), intent(out) :: array(n1,n2,n3,n4)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k, l
character(len=500) :: line
real(kind=wp), allocatable :: ri(:,:,:,:), rr(:,:,:,:)

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0) .or. (n4 <= 0)) then
  call WarningMessage(1,'read_4d_complex_array:: nothing to read. Array size = 0.')
  if (dbg) then
    write(u6,*) 'read_4d_complex_array::   n1 =',n1
    write(u6,*) 'read_4d_complex_array::   n2 =',n2
    write(u6,*) 'read_4d_complex_array::   n3 =',n3
    write(u6,*) 'read_4d_complex_array::   n4 =',n4
  end if
  return
end if
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

read(LU,*,iostat=ierr) i,j,k,l
if (ierr /= 0) call WarningMessage(2,'read_4d_complex_array:: Something went wrong reading key'//trim(key))
if (dbg) then
  write(u6,*) 'read_4d_complex_array:: key =',trim(key)
  write(u6,*) 'read_4d_complex_array::  n1 =',i
  write(u6,*) 'read_4d_complex_array::  n2 =',j
  write(u6,*) 'read_4d_complex_array::  n3 =',k
  write(u6,*) 'read_4d_complex_array::  n4 =',l
end if
if ((i /= n1) .or. (j /= n2) .or. (k /= n3) .or. (l /= n4)) &
  call WarningMessage(2,'read_4d_complex_array:: sizes of the array are different from the ones used to CALL this SUBROUTINE')
call mma_allocate(rr,n1,n2,n3,n4,label='rr')
call mma_allocate(ri,n1,n2,n3,n4,label='ri')
rr(:,:,:,:) = Zero
ri(:,:,:,:) = Zero
do i=1,n1
  do j=1,n2
    do k=1,n3
      read(LU,*,iostat=ierr) (rr(i,j,k,l),ri(i,j,k,l),l=1,n4)
      if (ierr /= 0) call WarningMessage(2,'read_4d_real_array:: Something went wrong reading the array.')
      if (dbg) write(u6,*) 'read_4d_real_array::  i,j,k =',i,j,k
    end do
  end do
end do
array(:,:,:,:) = cmplx(rr(:,:,:,:),ri(:,:,:,:),kind=wp)
call mma_deallocate(rr)
call mma_deallocate(ri)

return

end subroutine read_4d_complex_array

!----------------------------------------------------------------------!
!  WRITING SUBROUTINES
!----------------------------------------------------------------------!

subroutine write_INTEGER_scalar(LU,key,i,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LU, i
character(len=*), intent(in) :: key
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line
character(len=*), parameter :: FMTI = '(20(I0,1x))'

ierr = 0
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
! if key is found, THEN rewrite the data
if (ierr == 0) then
  write(LU,FMTI,iostat=ierr) i
  ! if the keyword is not found, THEN append the new keyword and data
else if (ierr /= 0) then
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_INTEGER_scalar:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) i
  if (ierr /= 0) call WarningMessage(1,'write_INTEGER_scalar:: Something went wrong writing data')
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_INTEGER_scalar

subroutine write_real_scalar(LU,key,r,dbg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
real(kind=wp), intent(in) :: r
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line
character(len=*), parameter :: FMTR = '(5ES22.14)'

ierr = 0
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTR,iostat=ierr) r
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_real_scalar:: Something went wrong writing key'//trim(key))
  write(LU,FMTR,iostat=ierr) r
  if (ierr /= 0) call WarningMessage(1,'write_real_scalar:: Something went wrong writing data')
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_real_scalar

subroutine write_complex_scalar(LU,key,c,dbg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key
complex(kind=wp), intent(in) :: c
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line
character(len=*), parameter :: FMTC = '(3(2ES22.14))'

ierr = 0
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTC,iostat=ierr) c
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_complex_scalar:: Something went wrong writing key'//trim(key))
  write(LU,FMTC,iostat=ierr) c
  if (ierr /= 0) call WarningMessage(1,'write_complex_scalar:: Something went wrong writing data')
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_complex_scalar

subroutine write_string(LU,key,s,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LU
character(len=*), intent(in) :: key, s
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: ierr
character(len=500) :: line

ierr = 0
rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)
if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,'(A   )',iostat=ierr) trim(s)
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A   )',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_string:: Something went wrong writing key'//trim(key))
  write(LU,'(100A)',iostat=ierr) trim(s)
  if (ierr /= 0) call WarningMessage(1,'write_string:: Something went wrong writing data')
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_string

subroutine write_1d_INTEGER_array(LU,key,n,array,dbg)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LU, n, array(n)
character(len=*), intent(in) :: key
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr
character(len=500) :: line
character(len=*), parameter :: FMTI = '(20(I0,1x))'

ierr = 0
if (n <= 0) then
  call WarningMessage(1,'write_1d_INTEGER_array:: nothing to write. Array size = 0.')
  return
end if
if (sum(abs(array)) == 0) call WarningMessage(1,'write_1d_INTEGER_array:: all array elements are zero = 0.')

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n
  write(LU,FMTI,iostat=ierr) (array(i),i=1,n)
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_1d_INTEGER_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n
  write(LU,FMTI,iostat=ierr) (array(i),i=1,n)
  if (ierr /= 0) call WarningMessage(1,'write_1d_INTEGER_array:: Something went wrong writing data')
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_1d_INTEGER_array

subroutine write_2d_INTEGER_array(LU,key,n1,n2,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, array(n1,n2)
character(len=*), intent(in) :: key
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j
character(len=500) :: line
character(len=*), parameter :: FMTI = '(20(I0,1x))'

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0)) then
  call WarningMessage(1,'write_2d_INTEGER_array:: nothing to write. Array size = 0.')
  return
end if
if (sum(abs(array)) == 0) call WarningMessage(1,'write_2d_INTEGER_array:: all array elements are zero = 0.')

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n1,n2
  do i=1,n1
    write(LU,FMTI,iostat=ierr) (array(i,j),j=1,n2)
    if (ierr /= 0) call WarningMessage(2,'write_2d_INTEGER_array:: Something went wrong writing the array.')
    if (dbg) write(u6,*) 'write_2d_INTEGER_array::  i =',i
  end do
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_2d_INTEGER_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n1,n2
  do i=1,n1
    write(LU,FMTI,iostat=ierr) (array(i,j),j=1,n2)
    if (ierr /= 0) call WarningMessage(2,'write_2d_INTEGER_array:: Something went wrong writing data.')
    if (dbg) write(u6,*) 'write_2d_INTEGER_array::  i =',i
  end do
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_2d_INTEGER_array

subroutine write_3d_INTEGER_array(LU,key,n1,n2,n3,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3, array(n1,n2,n3)
character(len=*), intent(in) :: key
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k
character(len=500) :: line
character(len=*), parameter :: FMTI = '(20(I0,1x))'

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0)) then
  call WarningMessage(1,'write_3d_INTEGER_array:: nothing to write. Array size = 0.')
  return
end if
if (sum(abs(array)) == 0) call WarningMessage(1,'write_3d_INTEGER_array:: all array elements are zero = 0.')

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n1,n2,n3
  do i=1,n1
    do j=1,n2
      write(LU,FMTI,iostat=ierr) (array(i,j,k),k=1,n3)
      if (ierr /= 0) call WarningMessage(2,'write_3d_INTEGER_array:: Something went wrong writing the array.')
      if (dbg) write(u6,*) 'write_3d_INTEGER_array::  i,j =',i,j
    end do
  end do
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_3d_INTEGER_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n1,n2,n3
  do i=1,n1
    do j=1,n2
      write(LU,FMTI,iostat=ierr) (array(i,j,k),k=1,n3)
      if (ierr /= 0) call WarningMessage(2,'write_3d_INTEGER_array:: Something went wrong writing the array.')
      if (dbg) write(u6,*) 'write_3d_INTEGER_array::  i,j =',i,j
    end do
  end do
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_3d_INTEGER_array

subroutine write_4d_INTEGER_array(LU,key,n1,n2,n3,n4,array,dbg)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3, n4, array(n1,n2,n3,n4)
character(len=*), intent(in) :: key
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k, l
character(len=500) :: line
character(len=*), parameter :: FMTI = '(20(I0,1x))'

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0) .or. (n4 <= 0)) then
  call WarningMessage(1,'write_4d_INTEGER_array:: nothing to write. Array size = 0.')
  return
end if
if (sum(abs(array)) == 0) call WarningMessage(1,'write_4d_INTEGER_array:: all array elements are zero = 0.')

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n1,n2,n3,n4
  do i=1,n1
    do j=1,n2
      do k=1,n3
        write(LU,FMTI,iostat=ierr) (array(i,j,k,l),l=1,n4)
        if (ierr /= 0) call WarningMessage(2,'write_4d_INTEGER_array:: Something went wrong reading the array.')
        if (dbg) write(u6,*) 'write_4d_INTEGER_array::  i,j,k =',i,j,k
      end do
    end do
  end do
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_4d_INTEGER_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n1,n2,n3,n4
  do i=1,n1
    do j=1,n2
      do k=1,n3
        write(LU,FMTI,iostat=ierr) (array(i,j,k,l),l=1,n4)
        if (ierr /= 0) call WarningMessage(2,'write_4d_INTEGER_array:: Something went wrong writting the array.')
        if (dbg) write(u6,*) 'write_4d_INTEGER_array::  i,j,k =',i,j,k
      end do
    end do
  end do
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_4d_INTEGER_array

subroutine write_1d_real_array(LU,key,n,array,dbg)

use Constants, only: Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LU, n
character(len=*), intent(in) :: key
real(kind=wp), intent(in) :: array(n)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr
character(len=500) :: line
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
character(len=*), parameter :: FMTI = '(20(I0,1x))', FMTR = '(5ES22.14)'
real(kind=wp), external :: dnrm2_

ierr = 0
if (n <= 0) then
  call WarningMessage(1,'write_1d_real_array:: nothing to write. Array size = 0.')
  return
end if
if (dnrm2_(n,array,1) <= MINIMAL_REAL) call WarningMessage(1,'write_1d_real_array:: all array elements are zero = 0.0')

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n
  write(LU,FMTR,iostat=ierr) (array(i),i=1,n)
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_1d_real_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n
  write(LU,FMTR,iostat=ierr) (array(i),i=1,n)
  if (ierr /= 0) call WarningMessage(1,'write_1d_real_array:: Something went wrong writing data')
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_1d_real_array

subroutine write_2d_real_array(LU,key,n1,n2,array,dbg)

use Constants, only: Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2
character(len=*), intent(in) :: key
real(kind=wp), intent(in) :: array(n1,n2)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j
character(len=500) :: line
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
character(len=*), parameter :: FMTI = '(20(I0,1x))', FMTR = '(5ES22.14)'
real(kind=wp), external :: dnrm2_

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0)) then
  call WarningMessage(1,'write_2d_real_array:: nothing to write. Array size = 0.')
  return
end if
if (dnrm2_(n1*n2,array,1) <= MINIMAL_REAL) call WarningMessage(1,'write_2d_real_array:: all array elements are zero = 0.')

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n1,n2
  do i=1,n1
    write(LU,FMTR,iostat=ierr) (array(i,j),j=1,n2)
    if (ierr /= 0) call WarningMessage(2,'write_2d_real_array:: Something went wrong writing the array.')
    if (dbg) write(u6,*) 'write_2d_real_array::  i =',i
  end do
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_2d_real_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n1,n2
  do i=1,n1
    write(LU,FMTR,iostat=ierr) (array(i,j),j=1,n2)
    if (ierr /= 0) call WarningMessage(2,'write_2d_real_array:: Something went wrong writing data.')
    if (dbg) write(u6,*) 'write_2d_real_array::  i =',i
  end do
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_2d_real_array

subroutine write_3d_real_array(LU,key,n1,n2,n3,array,dbg)

use Constants, only: Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3
character(len=*), intent(in) :: key
real(kind=wp), intent(in) :: array(n1,n2,n3)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k
character(len=500) :: line
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
character(len=*), parameter :: FMTI = '(20(I0,1x))', FMTR = '(5ES22.14)'
real(kind=wp), external :: dnrm2_

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0)) then
  call WarningMessage(1,'write_3d_real_array:: nothing to write. Array size = 0.')
  return
end if
if (dnrm2_(n1*n2*n3,array,1) <= MINIMAL_REAL) call WarningMessage(1,'write_3d_real_array:: all array elements are zero = 0.')

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n1,n2,n3
  do i=1,n1
    do j=1,n2
      write(LU,FMTR,iostat=ierr) (array(i,j,k),k=1,n3)
      if (ierr /= 0) call WarningMessage(2,'write_3d_real_array:: Something went wrong writing the array.')
      if (dbg) write(u6,*) 'write_3d_real_array::  i,j =',i,j
    end do
  end do
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_3d_real_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n1,n2,n3
  do i=1,n1
    do j=1,n2
      write(LU,FMTR,iostat=ierr) (array(i,j,k),k=1,n3)
      if (ierr /= 0) call WarningMessage(2,'write_3d_real_array:: Something went wrong writing the array.')
      if (dbg) write(u6,*) 'write_3d_real_array::  i,j =',i,j
    end do
  end do
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_3d_real_array

subroutine write_4d_real_array(LU,key,n1,n2,n3,n4,array,dbg)

use Constants, only: Ten
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3, n4
character(len=*), intent(in) :: key
real(kind=wp), intent(in) :: array(n1,n2,n3,n4)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k, l
character(len=500) :: line
real(kind=wp), parameter :: MINIMAL_REAL = tiny(MINIMAL_REAL)*Ten
character(len=*), parameter :: FMTI = '(20(I0,1x))', FMTR = '(5ES22.14)'
real(kind=wp), external :: dnrm2_

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0) .or. (n4 <= 0)) then
  call WarningMessage(1,'write_4d_real_array:: nothing to write. Array size = 0.')
  return
end if
if (dnrm2_(n1*n2*n3*n4,array,1) <= MINIMAL_REAL) call WarningMessage(1,'write_4d_real_array:: all array elements are zero = 0.')

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n1,n2,n3,n4
  do i=1,n1
    do j=1,n2
      do k=1,n3
        write(LU,FMTR,iostat=ierr) (array(i,j,k,l),l=1,n4)
        if (ierr /= 0) call WarningMessage(2,'write_4d_real_array:: Something went wrong reading the array.')
        if (dbg) write(u6,*) 'write_4d_real_array::  i,j,k =',i,j,k
      end do
    end do
  end do
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_4d_real_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n1,n2,n3,n4
  do i=1,n1
    do j=1,n2
      do k=1,n3
        write(LU,FMTR,iostat=ierr) (array(i,j,k,l),l=1,n4)
        if (ierr /= 0) call WarningMessage(2,'write_4d_real_array:: Something went wrong writting the array.')
        if (dbg) write(u6,*) 'write_4d_real_array::  i,j,k =',i,j,k
      end do
    end do
  end do
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_4d_real_array

subroutine write_1d_complex_array(LU,key,n,array,dbg)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LU, n
character(len=*), intent(in) :: key
complex(kind=wp), intent(in) :: array(n)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr
character(len=500) :: line
character(len=*), parameter :: FMTC = '(3(2ES22.14))', FMTI = '(20(I0,1x))'

ierr = 0
if (n <= 0) then
  call WarningMessage(1,'write_1d_complex_array:: nothing to write. Array size = 0.')
  return
end if

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n
  write(LU,FMTC,iostat=ierr) (array(i),i=1,n)
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_1d_complex_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n
  write(LU,FMTC,iostat=ierr) (array(i),i=1,n)
  if (ierr /= 0) call WarningMessage(1,'write_1d_complex_array:: Something went wrong writing data')
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_1d_complex_array

subroutine write_2d_complex_array(LU,key,n1,n2,array,dbg)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2
character(len=*), intent(in) :: key
complex(kind=wp), intent(in) :: array(n1,n2)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j
character(len=500) :: line
character(len=*), parameter :: FMTC = '(3(2ES22.14))', FMTI = '(20(I0,1x))'

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0)) then
  call WarningMessage(1,'write_2d_complex_array:: nothing to write. Array size = 0.')
  return
end if

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n1,n2
  do i=1,n1
    write(LU,FMTC,iostat=ierr) (array(i,j),j=1,n2)
    if (ierr /= 0) call WarningMessage(2,'write_2d_complex_array:: Something went wrong writing the array.')
    if (dbg) write(u6,*) 'write_2d_complex_array::  i =',i
  end do
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_2d_complex_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n1,n2
  do i=1,n1
    write(LU,FMTC,iostat=ierr) (array(i,j),j=1,n2)
    if (ierr /= 0) call WarningMessage(2,'write_2d_complex_array:: Something went wrong writing data.')
    if (dbg) write(u6,*) 'write_2d_complex_array::  i =',i
  end do
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_2d_complex_array

subroutine write_3d_complex_array(LU,key,n1,n2,n3,array,dbg)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3
character(len=*), intent(in) :: key
complex(kind=wp), intent(in) :: array(n1,n2,n3)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k
character(len=500) :: line
character(len=*), parameter :: FMTC = '(3(2ES22.14))', FMTI = '(20(I0,1x))'

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0)) then
  call WarningMessage(1,'write_3d_complex_array:: nothing to write. Array size = 0.')
  return
end if

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n1,n2,n3
  do i=1,n1
    do j=1,n2
      write(LU,FMTC,iostat=ierr) (array(i,j,k),k=1,n3)
      if (ierr /= 0) call WarningMessage(2,'write_3d_complex_array:: Something went wrong writing the array.')
      if (dbg) write(u6,*) 'write_3d_complex_array::  i,j =',i,j
    end do
  end do
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_3d_complex_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n1,n2,n3
  do i=1,n1
    do j=1,n2
      write(LU,FMTC,iostat=ierr) (array(i,j,k),k=1,n3)
      if (ierr /= 0) call WarningMessage(2,'write_3d_complex_array:: Something went wrong writing the array.')
      if (dbg) write(u6,*) 'write_3d_complex_array::  i,j =',i,j
    end do
  end do
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_3d_complex_array

subroutine write_4d_complex_array(LU,key,n1,n2,n3,n4,array,dbg)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LU, n1, n2, n3, n4
character(len=*), intent(in) :: key
complex(kind=wp), intent(in) :: array(n1,n2,n3,n4)
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i, ierr, j, k, l
character(len=500) :: line
character(len=*), parameter :: FMTC = '(3(2ES22.14))', FMTI = '(20(I0,1x))'

ierr = 0
if ((n1 <= 0) .or. (n2 <= 0) .or. (n3 <= 0) .or. (n4 <= 0)) then
  call WarningMessage(1,'write_4d_complex_array:: nothing to write. Array size = 0.')
  return
end if

rewind(LU)
call file_advance_to_string(LU,key,line,ierr,dbg)

if (ierr == 0) then
  ! if key is found, THEN rewrite the data
  write(LU,FMTI,iostat=ierr) n1,n2,n3,n4
  do i=1,n1
    do j=1,n2
      do k=1,n3
        write(LU,FMTC,iostat=ierr) (array(i,j,k,l),l=1,n4)
        if (ierr /= 0) call WarningMessage(2,'write_4d_complex_array:: Something went wrong reading the array.')
        if (dbg) write(u6,*) 'write_4d_complex_array::  i,j,k =',i,j,k
      end do
    end do
  end do
else if (ierr /= 0) then
  ! if the keyword is not found, THEN append the new keyword and data
  write(LU,'(A)',iostat=ierr)
  write(LU,'(A)',iostat=ierr) trim(key)
  if (ierr /= 0) call WarningMessage(1,'write_4d_complex_array:: Something went wrong writing key'//trim(key))
  write(LU,FMTI,iostat=ierr) n1,n2,n3,n4
  do i=1,n1
    do j=1,n2
      do k=1,n3
        write(LU,FMTC,iostat=ierr) (array(i,j,k,l),l=1,n4)
        if (ierr /= 0) call WarningMessage(2,'write_4d_complex_array:: Something went wrong writting the array.')
        if (dbg) write(u6,*) 'write_4d_complex_array::  i,j,k =',i,j,k
      end do
    end do
  end do
end if
write(LU,*,iostat=ierr)
call xFlush(LU)

return

end subroutine write_4d_complex_array

!END MODULE io_data

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SPHPUR(CMO)

use define_af, only: AngTp, iTabMx
use rasscf_global, only: BName, IXSYM
use general_data, only: NBAS, NORB, NSYM
use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp) :: I, IB, IBAS, IBASES, ICMOES, IO, IORB, IORBES, ISSLAB, ISYM, ITP, L, LCOUNT, LEXIST, LMX, MNL, MXL, NB, &
                     NBTOT, NO, NONZ
real(kind=wp) :: WGT, WGTLQN(0:9), WMX
logical(kind=iwp) :: IFTEST
character :: LCHAR
integer(kind=iwp), allocatable :: LQN(:)

! Set IFTEST=.true. to get supsym input generated in the output
! for further use, or for testing.
IFTEST = .false.
if (IFTEST) write(u6,*) 'SUPSYM'

! Set up array with angular quant num for each basis function:
NBTOT = sum(NBAS(1:NSYM))
call mma_allocate(LQN,NBTOT,Label='LQN')
do IBAS=1,NBTOT
  LCHAR = BName(IBAS)(LenIn+3:LenIn+3)
  L = -999999
  do ITP=0,ITABMX
    if (LCHAR == ANGTP(ITP)) L = ITP
  end do
  LQN(IBAS) = L
end do
ICMOES = 0
IBASES = 0
IORBES = 0
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  NO = NORB(ISYM)
  if (NO /= 0) then
    do IO=1,NO
      IORB = IORBES+IO
      WGTLQN(:) = Zero
      do IB=1,NB
        IBAS = IBASES+IB
        L = LQN(IBAS)
        WGT = CMO(ICMOES+IB+NB*(IO-1))**2
        WGTLQN(L) = WGTLQN(L)+WGT
      end do
      LMX = 0
      WMX = WGTLQN(0)
      do L=0,9
        if (WGTLQN(L) > WMX) then
          LMX = L
          WMX = WGTLQN(L)
        end if
      end do
      IXSYM(IORB) = LMX
    end do
    ! We have now a provisional IXSYM array. How many different
    ! L values appear in it?
    MNL = 9
    MXL = 0
    NONZ = 0
    do L=0,9
      LEXIST = 0
      do IO=1,NO
        IORB = IORBES+IO
        if (L == IXSYM(IORB)) then
          LEXIST = 1
          MNL = min(L,MNL)
          MXL = max(L,MXL)
          exit
        end if
      end do
      NONZ = NONZ+LEXIST
    end do
    ! There are NONZ different values, so we want NONZ-1 special supsym
    ! labels for this symmetry. Reuse IWORK(LLQN) for orbital numbers:
    ! This will be the supsym label:
    if (IFTEST) write(u6,*) NONZ-1
    ISSLAB = 0
    do L=MNL,MXL
      LCOUNT = 0
      do IO=1,NO
        IORB = IORBES+IO
        if (L == IXSYM(IORB)) then
          LCOUNT = LCOUNT+1
          LQN(LCOUNT) = IO
        end if
      end do
      if (LCOUNT > 0) then
        ! Replace provisional IXSYM value with correct label:
        do IO=1,NO
          IORB = IORBES+IO
          if (IXSYM(IORB) == L) IXSYM(IORB) = ISSLAB
        end do
        ! Lowest L = label zero = do not specify in input:
        if (IFTEST .and. (ISSLAB > 0)) write(u6,'(1x,I3,16I5,(/,5X,16I5))') LCOUNT,(LQN(i),i=1,LCOUNT)
        ISSLAB = ISSLAB+1
      end if
    end do

    ICMOES = ICMOES+NO*NB
    IORBES = IORBES+NO
  end if
  IBASES = IBASES+NB
end do
call mma_deallocate(LQN)

end subroutine SPHPUR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DENSCT(AREF)

use mrci_global, only: CSPCK, DMO, ICPF, INDX, INTSY, JREFX, ITRANS, LUEIG, LUREST, NBAST, NBTRI, NCONF, NRROOT, NVMAX, NVSQ, TDMO
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: AREF(*)
integer(kind=iwp) :: I, IDDMO, IDREST, J
integer(kind=iwp), allocatable :: IDC(:)
real(kind=wp), allocatable :: ASCR2(:), BSCR2(:), CI(:), FSCR2(:), SGM(:)

IDREST = 0
IDDMO = 0
call mma_allocate(CI,NCONF,label='CI')
call mma_allocate(SGM,NCONF,label='SGM')
call mma_allocate(ASCR2,NVMAX**2,label='ASCR2')
call mma_allocate(BSCR2,NVMAX**2,label='BSCR2')
call mma_allocate(FSCR2,NVSQ,label='FSCR2')
call mma_allocate(IDC,NRROOT,label='IDC')
do I=1,NRROOT
  IDC(I) = IDREST
  call dDAFILE(LUREST,2,CI,NCONF,IDREST)
  DMO(:) = Zero
  if (ICPF /= 0) call DCORR(JREFX,AREF,CSPCK,DMO)
  call FIJD(INTSY,INDX,CI,DMO,JREFX,AREF)
  call AID(INTSY,INDX,CI,DMO,ASCR2,BSCR2,FSCR2)
  call ABD(CSPCK,INTSY,INDX,CI,DMO,ASCR2,BSCR2,FSCR2)
  call dDAFILE(LUEIG,1,DMO,NBTRI,IDDMO)
end do
if (ITRANS /= 0) then
  do I=2,NRROOT
    IDREST = IDC(I)
    call dDAFILE(LUREST,2,CI,NCONF,IDREST)
    do J=1,I-1
      IDREST = IDC(J)
      call dDAFILE(LUREST,2,SGM,NCONF,IDREST)
      TDMO(:,:) = Zero
      call FIJTD(INTSY,INDX,CI,SGM,TDMO)
      call AITD(INTSY,INDX,CI,SGM,TDMO,ASCR2,BSCR2,FSCR2)
      call ABTD(CSPCK,INTSY,INDX,CI,SGM,TDMO,ASCR2,BSCR2,FSCR2)
      call dDAFILE(LUEIG,1,TDMO,NBAST**2,IDDMO)
    end do
  end do
end if
call mma_deallocate(CI)
call mma_deallocate(SGM)
call mma_deallocate(ASCR2)
call mma_deallocate(BSCR2)
call mma_deallocate(FSCR2)
call mma_deallocate(IDC)

return

end subroutine DENSCT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Compute_T(Z_Tot,T,ZA,RA,nAtoms)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 T(3), ZA(nAtoms), RA(3,nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
*---- Form the center of nuclear charge
*
      Do iCar = 1, 3
         Tmp = Zero
         Do iAtom = 1, nAtoms
            Tmp = Tmp + ZA(iAtom)*RA(iCar,iAtom)
         End Do
         T(iCar) = Tmp/Z_Tot
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine angular(Lhigh,keep,makemean,bonn,breit,sameorb,ifinite,onecartx,onecarty,onecartz,powexp,coulovlp,preXZ,preY,icheckxy, &
                   icheckz,interxyz,isgnprod)
!bs COMBINES THE RADIAL INTEGRALS WITH THE ANGULAR FACTORS
!
!bs if keep=.true. then
!bs all the integrals will be kept in memory.
!bs Perhaps, there will be the option to make the
!bs transformation to the cartesian basis-sets
!bs everytime, they are required.
!bs Therefore, the integrals are kept in memory and
!bs can be further transformed, whenever required.
!bs in order not to waste to much memory, the atomic
!bs integrals are thrown away after each l,l,l,l-block

use AMFI_global, only: AOcoeffs, ipowxyz, Lblocks, Lfirst, Llast, Lmax, Lstarter, MxcontL, MxprimL, ncontrac, noccorb, occup
use index_functions, only: iTri
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Quart
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Lhigh, ifinite
logical(kind=iwp), intent(in) :: keep, makemean, bonn, breit, sameorb
real(kind=wp), intent(inout) :: onecartX(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax), &
                                onecartY(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax), &
                                onecartZ(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax)
real(kind=wp), intent(in) :: powexp(MxprimL,MxprimL,0:Lmax,0:Lmax,0:(Lmax+Lmax+5)), coulovlp(*)
real(kind=wp), intent(out) :: preXZ(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax), preY(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax)
integer(kind=iwp), intent(out) :: icheckxy(0:Lmax,0:Lmax,0:Lmax,0:Lmax), icheckz(0:Lmax,0:Lmax,0:Lmax,0:Lmax), &
                                  interxyz(16,0:Lmax,0:Lmax,0:Lmax,0:Lmax), isgnprod(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax)
integer(kind=iwp) :: iangfirst, icont4, indx, indy, indz, inter2, inter3, inter4, isignM(-Lmax:Lmax), jblock, l1, l2, l3, l4, &
                     Lleftmax, Lleftmin, locstar, Lrightmax, Lrightmin, M1, m1upper, M2, m2upper, M3, M4, mblock, mblockx, &
                     mblocky, mblockz, mxangint, ncont, numbcart
real(kind=wp) :: preroots(2,0:Lmax), scratch(0:2*Lmax+1)
logical(kind=iwp) :: cleaner, NFINI
integer(kind=iwp), allocatable :: mcombcart(:,:,:,:,:), mcombina(:,:,:,:,:)
real(kind=wp), allocatable :: clebsch(:,:,:,:), ConOO(:), ConSO(:), CartOO(:), CartSO(:), AngOO(:), AngSO(:)
!bs NFINI means not finite nucleus

!bs ####################################################################
!bs   some preparation of factors needed later on..                    #
!bs ####################################################################
!bs calculate some prefactors that will be needed quite often
call mma_allocate(clebsch,[1,3],[1,2],[-Lmax,Lmax],[0,Lmax],label='clebsch')
call prefac(Lmax,preroots,clebsch)
if (ifinite /= 2) then
  !bs clean array for one electron integrals
  onecartX(:,:,:,:) = Zero
  onecartY(:,:,:,:) = Zero
  onecartZ(:,:,:,:) = Zero
  NFINI = .true.
else
  NFINI = .false.
end if

!bs generate an array with sign for (even/odd) m-values
if (mod(Lmax,2) == 0) then
  isignM(-Lmax:Lmax:2) = 1
  isignM(-Lmax+1:Lmax-1:2) = -1
else
  isignM(-Lmax:Lmax:2) = -1
  isignM(-Lmax+1:Lmax-1:2) = 1
end if
!bs ####################################################################
!bs   prefactors preXZ und preY include the factors 1/root(2)
!bs   for the +/- linear combinations of spherical harmonics
!bs ####################################################################
preXZ(:,:,:,:) = Quart
preXZ(:,:,:,0) = preXZ(:,:,:,0)*sqrt(Two)
preXZ(:,:,0,:) = preXZ(:,:,0,:)*sqrt(Two)
preXZ(:,0,:,:) = preXZ(:,0,:,:)*sqrt(Two)
preXZ(0,:,:,:) = preXZ(0,:,:,:)*sqrt(Two)
preY(:,:,:,:) = preXZ(:,:,:,:)
!bs ####################################################################
!bs   additional (-) signs from the (-i) factors  in the
!bs   (-) linear combinations   (see tosigX(Y,Z))
!bs ####################################################################
!bs   + - - -   =>   minus
preXZ(0:,:-1,:-1,:-1) = -preXZ(0:,:-1,:-1,:-1)
!bs   - + - -   =>   minus
preXZ(:-1,0:,:-1,:-1) = -preXZ(:-1,0:,:-1,:-1)
!bs   + + + -   =>   minus
preXZ(0:,0:,0:,:-1) = -preXZ(0:,0:,0:,:-1)
!bs   + + - +   =>   minus
preXZ(0:,0:,:-1,0:) = -preXZ(0:,0:,:-1,0:)
!bs   + + - -   =>   minus
preY(0:,0:,:-1,:-1) = -preY(0:,0:,:-1,:-1)
!bs   - - + +   =>   minus
preY(:-1,:-1,0:,0:) = -preY(:-1,:-1,0:,0:)
call genprexyz13(icheckxy)
call genprexyz14(icheckz,interxyz)
call genprexyz15a(icheckxy,icheckz,interxyz)
!bs ####################################################################
!bs   isgnprod gives the sign due to powers (-1)**M  this are again
!bs   angular m-values
!bs ####################################################################
do M4=-Lmax,Lmax
  if (M4 > 0) then
    inter4 = isignM(M4)
  else
    inter4 = 1
  end if
  do M3=-Lmax,Lmax
    if (M3 > 0) then
      inter3 = inter4*isignM(M3)
    else
      inter3 = inter4
    end if
    do M2=-Lmax,Lmax
      if (M2 > 0) then
        inter2 = inter3*isignM(M2)
      else
        inter2 = inter3
      end if
      do M1=-Lmax,Lmax
        if (M1 > 0) then
          isgnprod(m1,m2,m3,m4) = inter2*isignM(M1)
        else
          isgnprod(m1,m2,m3,m4) = inter2
        end if
      end do
    end do
  end do
end do
!bs ####################################################################
!bs   some preparation of factors needed later on..  finished          #
!bs ####################################################################

! set some counters
call mma_allocate(mcombina,[1,2],[-Lmax,Lmax],[-Lmax,Lmax],[-Lmax,Lmax],[-Lmax,Lmax],label='mcombina')
call mma_allocate(mcombcart,[1,2],[-Lmax,Lmax],[-Lmax,Lmax],[-Lmax,Lmax],[-Lmax,Lmax],label='mcombcart')
!bs counter for total number of cartesian integrals
numbcart = 0
!bs same orbit integrals integrals  on carteXSO carteYSO and carteSO
!bs other orbit integrals  on carteXOO carteYOO and carteOO
iangfirst = 0 ! first block of angular integrals
!bs loop over all possible < l1 l2, l3 l4 > blocks
!BS write(u6,'(A)') '   L1   L2   L3   L4'
do l1=0,Lhigh   ! improving is probably possible...
  do l2=0,Lhigh
    do l3=0,l1
      do l4=0,l2
        !bs check parity
        if (mod(l1+l2+l3+l4,2) == 0) then
          !bs check that Lleft and Lright do not always differ by more than one
          !bs a difference of two means two spin flips and is therefore not allowed
          Lleftmax = l1+l2
          Lrightmax = l3+l4
          Lleftmin = abs(l1-l2)
          Lrightmin = abs(l3-l4)
          if (((Lrightmin-Lleftmax <= 1) .and. (Lrightmax-Lleftmin > -1)) .or. &
              ((Lleftmin-Lrightmax <= 1) .and. (Lleftmax-Lrightmin > -1))) then
            !bs additional check for mean-field
            if (((l1 == l3) .and. (l2 == l4)) .or. ((l1 == l2) .and. (l3 == l4))) then
              if (l1+l3 /= 0) then
                !BS write(u6,'(4I5)') l1,l2,l3,l4
                !BS now I determine the size of the angular integral arrays
                jblock = 0
                do m1=-l1,l1
                  do m2=-l2,l2
                    do m3=-l3,l3
                      m4 = m1+m2-m3+1
                      if (abs(m4) <= l4) then
                        if ((.not. makemean) .or. ((l1 == l3) .and. (l2 == l4) .and. (abs(m2) == abs(m4))) .or. &
                            ((l1 == l2) .and. (l3 == l4) .and. ((abs(m1) == abs(m2)) .or. (abs(m3) == abs(m4))))) then
                          jblock = jblock+1
                        end if
                      end if
                    end do
                  end do
                end do
                do m1=0,l1
                  do m2=-l2,l2
                    do m3=-l3,l3
                      m4 = m1+m2-m3
                      if ((.not. makemean) .or. ((l1 == l3) .and. (l2 == l4) .and. (abs(m2) == abs(m4))) .or. &
                          ((l1 == l2) .and. (l3 == l4) .and. ((abs(m1) == abs(m2)) .or. (abs(m3) == abs(m4))))) then
                        if ((m1 /= 0) .or. (m2 /= 0) .or. (m3 /= 0)) then !  all m=0 make no sense
                          if (abs(m4) <= l4) then
                            jblock = jblock+1
                          end if
                        end if
                      end if
                    end do
                  end do
                end do
                !BS done !!
                !bs number of contracted integrals for each block
                ncont = ncontrac(l1)*ncontrac(l2)*ncontrac(l3)*ncontrac(l4)
                mxangint = jblock*ncont
                !bs determine the size icont4 for the radial integrals
                call gencoulDIM(l1,l2,l3,l4,makemean,icont4)

                call mma_allocate(ANGSO,mxangint,Label='AngSO')
                call mma_allocate(ANGOO,mxangint,Label='AngOO')
                call mma_allocate(CartSO,nCont,Label='CartSO')
                call mma_allocate(CartOO,nCont,Label='CartOO')
                call mma_allocate(ConSO,iCont4,Label='ConSO')
                call mma_allocate(ConOO,iCont4,Label='ConOO')

                call gencoul(l1,l2,l3,l4,makemean,bonn,breit,sameorb,conSO,conOO,icont4,powexp,coulovlp)
                ! gen and trans integrals
                !bs local counter for integral adresses
                mblock = 0 ! counter of (m,m,m,m)-blocks for (l1,l2,l3,l4)
                !bs if keep is set to false, the angular integrals are
                !bs thrown away after each block of l-values
                !bs which means integrals start at address 0
                if (.not. keep) iangfirst = 0
                locstar = iangfirst ! local starting adress counter
                ! col 1 will hold type of integrals (1,2,3)
                ! col 2 will hold number of block
                mcombina(:,-l1:l1,-l2:l2,-l3:l3,-l4:l4) = 0
                do m1=-l1,l1
                  do m2=-l2,l2
                    do m3=-l3,l3
                      !bs m4 is more or less fixed by m1-3
                      !#######################################################################
                      !#######################################################################
                      !########## the L- -type block to be combined with sigma+ ##############
                      !#######################################################################
                      !#######################################################################
                      m4 = m1+m2-m3+1
                      if (abs(m4) <= l4) then !the L- -block to  combine with sigma+
                        !bs not all m-combinations are needed for the mean-field
                        if ((.not. makemean) .or. ((l1 == l3) .and. (l2 == l4) .and. (abs(m2) == abs(m4))) .or. &
                            ((l1 == l2) .and. (l3 == l4) .and. ((abs(m1) == abs(m2)) .or. (abs(m3) == abs(m4))))) then
                          mcombina(1,m1,m2,m3,m4) = 1
                          mblock = mblock+1
                          if (locstar+ncont > mxangint) then
                            write(u6,*) 'not enough space allocated for angular integrals'
                            write(u6,*) 'increase mxangint to at least ',locstar+ncont
                            call Abend()
                          end if
                          !bs mkangLmin = make_angular_integrals_for_L- type operator
                          !bs really generates  the angular prefactors and combines them with
                          !bs the radial integrals
                          call mkangLmin(Lmax,l1,l2,l3,l4,m1,m2,m3,m4,AngSO(1+locstar),AngOO(1+locstar),Lfirst,Llast,Lblocks, &
                                         ncontrac(l1),ncontrac(l2),ncontrac(l3),ncontrac(l4),ConSO(Lstarter(1)), &
                                         ConSO(Lstarter(2)),ConSO(Lstarter(3)),ConSO(Lstarter(4)),ConOO(Lstarter(1)), &
                                         ConOO(Lstarter(2)),ConOO(Lstarter(3)),ConOO(Lstarter(4)),preroots,clebsch,scratch,bonn, &
                                         breit,sameorb)
                          locstar = locstar+ncont ! increase starting address
                          mcombina(2,m1,m2,m3,m4) = mblock  ! set the block number
                          !#######################################################################
                          !#######################################################################
                          !########## the L+ -type block to be combined with sigma- ##############
                          !#######################################################################
                          !#######################################################################

                          ! these integrals are obtained by changing the signs of the m-values.
                          ! As the integrals are the same, the pointer points to the same integrals...

                          mcombina(1,-m1,-m2,-m3,-m4) = 3
                          mcombina(2,-m1,-m2,-m3,-m4) = mblock
                        end if
                      end if
                    end do
                  end do
                end do
                !#######################################################################
                !#######################################################################
                !########## the L0 -type block to be combined with sigma0 ##############
                !#######################################################################
                !#######################################################################
                do m1=0,l1
                  do m2=-l2,l2
                    do m3=-l3,l3
                      !bs m4 is more or less fixed by m1-3
                      m4 = m1+m2-m3 ! the L0-block to be combined with sigma0
                      !bs not all m-combinations are needed for the mean-field
                      if ((.not. makemean) .or. ((l1 == l3) .and. (l2 == l4) .and. (abs(m2) == abs(m4))) .or. &
                          ((l1 == l2) .and. (l3 == l4) .and. ((abs(m1) == abs(m2)) .or. (abs(m3) == abs(m4))))) then

                        if ((m1 /= 0) .or. (m2 /= 0) .or. (m3 /= 0)) then !all m=0 make no sense
                          if (abs(m4) <= l4) then
                            mcombina(1,m1,m2,m3,m4) = 2
                            mblock = mblock+1
                            if (locstar+ncont > mxangint) then
                              write(u6,*) 'not enough space allocated for angular integrals'
                              write(u6,*) 'increase mxangint to at least ',locstar+ncont
                              call Abend()
                            end if
                            call mkangL0(Lmax,l1,l2,l3,l4,m1,m2,m3,m4,angSO(1+locstar),AngOO(1+locstar),Lfirst,Llast,Lblocks, &
                                         ncontrac(l1),ncontrac(l2),ncontrac(l3),ncontrac(l4),ConSO(Lstarter(1)), &
                                         ConSO(Lstarter(2)),ConSO(Lstarter(3)),ConSO(Lstarter(4)),ConOO(Lstarter(1)), &
                                         ConOO(Lstarter(2)),ConOO(Lstarter(3)),ConOO(Lstarter(4)),preroots,clebsch,scratch,bonn, &
                                         breit,sameorb)
                            locstar = locstar+ncont
                            mcombina(2,m1,m2,m3,m4) = mblock
                          end if
                        end if
                      end if
                    end do
                  end do
                end do
                !bs ###################################################################
                !bs ###################################################################
                !bs   transformation to l,m dependent integrals is finished
                !bs ###################################################################

                !bs ###################################################################
                !bs   begin transformation to cartesian integrals
                !bs ###################################################################
                !bs ###################################################################
                !bs check out, which combinations of m-values will
                !bs contribute to cartesian integrals
                ! col 1 will hold the type  x=1 y=2 z=3
                ! col 2 will hold the block number
                mcombcart(:,-l1:l1,-l2:l2,-l3:l3,-l4:l4) = 0
                mblockx = 0
                mblocky = 0
                mblockz = 0
                do m3=-l3,l3
                  do m4=-l4,l4
                    !bs if the l-values are the same : triangular matrix over m-values
                    !bs is sufficient
                    if (l1 == l3) then
                      m1upper = m3
                    else
                      m1upper = l1
                    end if
                    if (makemean) m1upper = l1
                    !bs if the l-values are the same : triangular matrix over m-values
                    !bs is sufficient
                    if (l2 == l4) then
                      m2upper = m4
                    else
                      m2upper = l2
                    end if
                    if (makemean) m2upper = l2
                    do m1=-l1,m1upper
                      if ((l1 == l3) .and. (m1 == m3)) then ! clean real zeros by symmetry
                        !bs this a problem of the spin-other-orbit integrals, as they are by
                        !bs formula not antisymmetric in the indices for particle 1.
                        cleaner = .true.
                      else
                        cleaner = .false.
                      end if
                      do m2=-l2,m2upper
                        !bs not all m-combinations are needed for the mean-field
                        if ((.not. makemean) .or. ((l1 == l3) .and. (l2 == l4) .and. (m2 == m4)) .or. &
                            ((l1 == l2) .and. (l3 == l4) .and. ((m1 == m2) .or. (m3 == m4)))) then

                          indx = ipowxyz(1,m1,l1)+ipowxyz(1,m2,l2)+ipowxyz(1,m3,l3)+ipowxyz(1,m4,l4)
                          indy = ipowxyz(2,m1,l1)+ipowxyz(2,m2,l2)+ipowxyz(2,m3,l3)+ipowxyz(2,m4,l4)
                          indz = ipowxyz(3,m1,l1)+ipowxyz(3,m2,l2)+ipowxyz(3,m3,l3)+ipowxyz(3,m4,l4)
                          indx = mod(indx,2)
                          indy = mod(indy,2)
                          indz = mod(indz,2)
                          if ((indx == 0) .and. (indy == 1) .and. (indz == 1) .and. &
                              (icheckxy(abs(m1),abs(m2),abs(m3),abs(m4)) > 0)) then
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            !++++++++++++++++      SIGMA X      ++++++++++++++++++++++++++++++++++++
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            ! Y*Z ->  transforms like  L_x (B1)
                            !bs integrals for sigma_x
                            mblockx = mblockx+1
                            mcombcart(1,m1,m2,m3,m4) = 1
                            mcombcart(2,m1,m2,m3,m4) = mblockx
                            call tosigX(m1,m2,m3,m4,AngSO(1+iangfirst),mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3), &
                                        ncontrac(l4),CartSO,preXZ,interxyz(1,abs(m1),abs(m2),abs(m3),abs(m4)),isgnprod,cleaner)

                            if ((.not. bonn) .and. (.not. breit)) &
                              call tosigX(m1,m2,m3,m4,AngOO(1+iangfirst),mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3), &
                                          ncontrac(l4),cartOO,preXZ,interxyz(1,abs(m1),abs(m2),abs(m3),abs(m4)),isgnprod,cleaner)
                            if (makemean) then ! generate mean-field-contributions
                              !#######################################################################
                              !############  mean-field-part #########################################
                              !#######################################################################
                              if ((l1 == l3) .and. (l2 == l4)) then
                                if ((m2 == m4) .and. (m1 < m3) .and. (abs(m1+m3) == 1) .and. (l1 /= 0)) then
                                  call two2mean13(CartSO,occup(1,l2),AOcoeffs(1,1,l2),onecartx(1,1,iTri(m1+l1+1,m3+l3+1),l1), &
                                                  ncontrac(l1),ncontrac(l2),noccorb(l2))
                                end if
                              end if

                              if (NFINI) then
                                if ((l1 == l2) .and. (l3 == l4)) then
                                  if ((m1 == m2) .and. (l3 /= 0) .and. (l3 /= l1)) then
                                    if ((m3 < m4) .and. (abs(m4+m3) == 1)) then
                                      !bs for the "Bonn-approach"   exchange cartexOO by cartexSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean34a(cartSO,cartSO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartx(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      else
                                        if (NFINI) call two2mean34a(cartSO,cartOO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartx(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      end if
                                    end if
                                    if ((m3 > m4) .and. (abs(m4+m3) == 1)) then
                                      !bs for the "Bonn-approach"   exchange cartexOO by cartexSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean34b(CartSO,CartSO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartx(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      else
                                        if (NFINI) call two2mean34b(CartSO,CartOO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartx(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      end if
                                    end if
                                  else if ((m3 == m4) .and. (l1 /= 0)) then
                                    if (m1 < m2 .and. abs(m1+m2) == 1) then
                                      !bs for the "Bonn-approach"   exchange cartexOO by cartexSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean12a(CartSO,CartSO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartx(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      else
                                        if (NFINI) call two2mean12a(CartSO,cartOO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartx(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      end if
                                    end if
                                    if ((m1 > m2) .and. (abs(m1+m2) == 1)) then
                                      !bs for the "Bonn-approach"   exchange cartexOO by cartexSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean12b(cartSO,CartSO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartx(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      else
                                        if (NFINI) call two2mean12b(CartSO,CartOO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartx(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      end if
                                    end if
                                  end if
                                end if
                              end if ! If (NFINI) Then
                              !#######################################################################
                              !############  mean-field-part #########################################
                              !#######################################################################
                            end if
                          else if ((indx == 1) .and. (indy == 0) .and. (indz == 1) .and. &
                                   (icheckxy(abs(m1),abs(m2),abs(m3),abs(m4)) > 0)) then
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            !++++++++++++++++      SIGMA Y      ++++++++++++++++++++++++++++++++++++
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            ! X*Z transforms like L_y  (B2)
                            !bs integrals for sigma_y
                            mblocky = mblocky+1
                            mcombcart(1,m1,m2,m3,m4) = 2
                            mcombcart(2,m1,m2,m3,m4) = mblocky
                            call tosigY(m1,m2,m3,m4,AngSO(1+iangfirst),mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3), &
                                        ncontrac(l4),CartSO,preY,interxyz(1,abs(m1),abs(m2),abs(m3),abs(m4)),isgnprod,cleaner)

                            if ((.not. bonn) .and. (.not. breit)) &
                              call tosigY(m1,m2,m3,m4,AngOO(1+iangfirst),mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3), &
                                          ncontrac(l4),cartOO,preY,interxyz(1,abs(m1),abs(m2),abs(m3),abs(m4)),isgnprod,cleaner)
                            if (makemean) then ! generate mean-field-contributions
                              !#######################################################################
                              !############  mean-field-part #########################################
                              !#######################################################################
                              if ((l1 == l3) .and. (l2 == l4)) then
                                if ((m2 == m4) .and. (m1 < m3) .and. (abs(m3-m1) == 1) .and. (l1 /= 0)) then
                                  call two2mean13(CartSO,occup(1,l2),AOcoeffs(1,1,l2),onecartY(1,1,iTri(m1+l1+1,m3+l3+1),l1), &
                                                  ncontrac(l1),ncontrac(l2),noccorb(l2))
                                end if
                              end if

                              if (NFINI) then
                                if ((l1 == l2) .and. (l3 == l4)) then
                                  if ((m1 == m2) .and. (l3 /= 0) .and. (l3 /= l1)) then
                                    if ((m3 < m4) .and. (abs(m3-m4) == 1)) then
                                      !bs for the "Bonn-approach"   exchange carteYOO by carteYSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean34a(CartSO,CartSO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartY(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      else
                                        if (NFINI) call two2mean34a(CartSO,CartOO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartY(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      end if
                                    end if
                                    if ((m3 > m4) .and. (abs(m3-m4) == 1)) then
                                      !bs for the "Bonn-approach"   exchange carteYOO by carteYSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean34b(CartSO,CartSO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartY(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      else
                                        if (NFINI) call two2mean34b(CartSO,CartOO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartY(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      end if
                                    end if
                                  else if ((m3 == m4) .and. (l1 /= 0)) then
                                    if ((m1 < m2) .and. (abs(m1-m2) == 1)) then
                                      !bs for the "Bonn-approach"   exchange carteOO by carteSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean12a(CartSO,CartSO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartY(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      else
                                        if (NFINI) call two2mean12a(CartSO,CartOO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartY(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      end if
                                    end if
                                    if ((m1 > m2) .and. (abs(m1-m2) == 1)) then
                                      !bs for the "Bonn-approach"   exchange carteYOO by carteYSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean12b(CartSO,CartSO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartY(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      else
                                        if (NFINI) call two2mean12b(CartSO,CartOO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartY(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      end if
                                    end if
                                  end if
                                end if
                              end if ! If (NFINI) Then
                              !#######################################################################
                              !############  mean-field-part #########################################
                              !#######################################################################
                            end if
                          else if ((indx == 1) .and. (indy == 1) .and. (indz == 0) .and. &
                                   (icheckz(abs(m1),abs(m2),abs(m3),abs(m4)) > 0)) then
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            !++++++++++++++++      SIGMA Z      ++++++++++++++++++++++++++++++++++++
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            ! X*Y transforms like L_z  (A2)
                            !bs integrals for sigma_z
                            mblockz = mblockz+1
                            mcombcart(1,m1,m2,m3,m4) = 3
                            mcombcart(2,m1,m2,m3,m4) = mblockz
                            call tosigZ(m1,m2,m3,m4,angSO(1+iangfirst),mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3), &
                                        ncontrac(l4),CartSO,preXZ,interxyz(1,abs(m1),abs(m2),abs(m3),abs(m4)),isgnprod,cleaner)

                            if ((.not. bonn) .and. (.not. breit)) &
                              call tosigZ(m1,m2,m3,m4,AngOO(1+iangfirst),mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3), &
                                          ncontrac(l4),CartOO,preXZ,interxyz(1,abs(m1),abs(m2),abs(m3),abs(m4)),isgnprod,cleaner)
                            if (makemean) then ! generate mean-field-contributions
                              !#######################################################################
                              !############  mean-field-part #########################################
                              !#######################################################################
                              if ((l1 == l3) .and. (l2 == l4)) then
                                if ((m2 == m4) .and. (m1 < m3) .and. (m1 == -m3) .and. (l1 /= 0)) then
                                  call two2mean13(CartSO,occup(1,l2),AOcoeffs(1,1,l2),onecartz(1,1,iTri(m1+l1+1,m3+l3+1),l1), &
                                                  ncontrac(l1),ncontrac(l2),noccorb(l2))
                                end if
                              end if

                              if (NFINI) then
                                if ((l1 == l2) .and. (l3 == l4)) then
                                  if ((m1 == m2) .and. (l3 /= 0) .and. (l3 /= l1)) then
                                    if ((m3 < m4) .and. (m3 == -m4)) then
                                      !bs for the "Bonn-approach"   exchange carteOO by carteSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean34a(CartSO,CartSO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartz(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      else
                                        if (NFINI) call two2mean34a(CartSO,CartOO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartz(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      end if
                                    end if
                                    if ((m3 > m4) .and. (m3 == -m4)) then
                                      !bs for the "Bonn-approach"   exchange carteOO by carteSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean34b(CartSO,CartSO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartz(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      else
                                        if (NFINI) call two2mean34b(CartSO,CartOO,occup(1,l1),AOcoeffs(1,1,l1), &
                                                                    onecartz(1,1,iTri(m3+l3+1,m4+l4+1),l3),ncontrac(l3), &
                                                                    ncontrac(l1),noccorb(l2),sameorb)
                                      end if
                                    end if
                                  else if ((m3 == m4) .and. (l1 /= 0)) then
                                    if (m1 < m2 .and. m1 == -m2) then
                                      !bs for the "Bonn-approach"   exchange carteOO by carteSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean12a(CartSO,CartSO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartz(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      else
                                        if (NFINI) call two2mean12a(CartSO,CartOO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartz(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      end if
                                    end if
                                    if ((m1 > m2) .and. (m1 == -m2)) then
                                      !bs for the "Bonn-approach"   exchange carteOO by carteSO
                                      if (bonn .or. breit) then
                                        if (NFINI) call two2mean12b(cartSO,CartSO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartz(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      else
                                        if (NFINI) call two2mean12b(cartSO,cartOO,occup(1,l3),AOcoeffs(1,1,l3), &
                                                                    onecartz(1,1,iTri(m1+l1+1,m2+l2+1),l1),ncontrac(l1), &
                                                                    ncontrac(l3),noccorb(l3),sameorb)
                                      end if
                                    end if
                                  end if
                                end if
                              end if ! If (NFINI) Then
                              !#######################################################################
                              !############  mean-field-part #########################################
                              !#######################################################################
                            end if
                          end if
                          !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                          !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                          !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                          !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        end if ! for check of significance for meanfield.
                      end do
                    end do
                  end do
                end do
                numbcart = numbcart+(mblockx+mblocky+mblockz)*ncont
                !bs just controlling if x and y integrals have the same number of blocks
                if (mblockx /= mblocky) then
                  write(u6,*) 'numbers of integrals for sigma_x and sigma_y not equal!'
                  write(u6,'(A12,4I3,2(A3,I5))') 'l1,l2,l3,l4 ',l1,l2,l3,l4,' X:',mblockx,' Y:',mblocky
                  write(u6,*) ' check the ipowxyz-array'
                  call Abend()
                end if
                !bs start adresses for the next <ll|ll> block of integrals
                call mma_deallocate(AngSO)
                call mma_deallocate(AngOO)
                call mma_deallocate(CartSO)
                call mma_deallocate(CartOO)
                call mma_deallocate(ConSO)
                call mma_deallocate(ConOO)
              end if
            end if
          end if
        end if
      end do
    end do
  end do
end do
call mma_deallocate(clebsch)
call mma_deallocate(mcombina)
call mma_deallocate(mcombcart)

return

end subroutine angular

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989,1993, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE CNHCN2(ICNL,ITPL,ICNR,ITPR,CNHCNM,SCR,NEL,
     &                 NAEL,NBEL,INTSPC,
     &                 NINOC,ECORE,IPRODT,DTOC,
     &                 NORB,ICOMBI,PSSIGN,NTERMS,NDIF0,NDIF1,NDIF2,
     &                 NTEST)
      use Str_Info, only: Str
*
* Obtain Hamilton matrix over CSFs of configurations ICNL,ICNR
*
* Jeppe Olsen , Summer of 89
*
*. Modified for LUCIA, september 1993
*
      IMPLICIT real*8(A-H,O-Z)
*. Specific input
      DIMENSION ICNL(*),ICNR(*)
*. General input
      DIMENSION IPRODT(*),DTOC(*)
*. Scratch
      DIMENSION SCR(*),IDUMMY(1)
*. Output
      DIMENSION CNHCNM(*)
*. Interface to LUCIA common blocks in order to access strings
#include "detdim.fh"
#include "spinfo_mclr.fh"
#include "cicisp_mclr.fh"
*
      CALL CNHCN2_INTERNAL(SCR)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NINOC)
        CALL Unused_real(ECORE)
        CALL Unused_integer(NTERMS)
      END IF
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE CNHCN2_INTERNAL(SCR)
      USE ISO_C_BINDING
      REAL*8, TARGET :: SCR(*)
      INTEGER, POINTER :: iSCR(:),iSCRa(:),iSCRb(:),iSCRar(:),iSCRbr(:),
     &                    iSCRn(:),iSCRnn(:)
*
* Length of SCR : 6 * NDET + NDET**2 + NDET*NCSF +
*                 MAX((NDET*NEL + 2*NEL),4*NORB + 2*NEL)
* where the last line arises from the local memory in CNFSTR and DIHDJ,
* respectively
*
      IAGRP = IASTFI(INTSPC)
      IBGRP = IBSTFI(INTSPC)
*
** 1 : Obtain determinants corresponding to configurations
*
      IOPL = ITPL - 1 + MINOP
      IOPR = ITPR - 1 + MINOP
*
      ICLL = (NEL-IOPL)/2
      ICLR = (NEL-IOPR)/2
*
      NDETL = NDPCNT(ITPL)
      NDETR = NDPCNT(ITPR)
*
      NCSFL = NCPCNT(ITPL)
      NCSFR = NCPCNT(ITPR)
*
*
      KLFREE = 1
* :  6* Ndet for holding string numbers and signs
      KLDTLA = KLFREE
      KLFREE = KLFREE + NDETL
*
      KLDTLB = KLFREE
      KLFREE = KLFREE + NDETL
*
      KLISL  = KLFREE
      KLFREE = KLFREE + NDETL
*
      KLDTRA = KLFREE
      KLFREE = KLFREE + NDETR
*
      KLDTRB = KLFREE
      KLFREE = KLFREE + NDETR
*
      KLISR  = KLFREE
      KLFREE = KLFREE + NDETR
*. : for transforming to CSFs
      KLDHD = KLFREE
      KLFREE = KLFREE + NDETL*NDETR
*
      KLCHD = KLFREE
      KLFREE = KLFREE + NCSFL*NDETR
*. : Scratch space for routines called ( DIHDJ, CNFSTR )
      KLROU = KLFREE
      LDIHDJ = 4 * NORB + 2*NEL
      LCNFST = MAX(NDETL,NDETR)*NEL + 2 * NEL
      KLFREE = KLROU + MAX(LDIHDJ,LCNFST)
*
*. Prescreen for CNFs that do not interact
*
      CALL C_F_POINTER(C_LOC(SCR(1)),iSCR,[1])
      CALL CMP2CN(ICNL,ICLL,IOPL,ICNR,ICLR,IOPR,iSCR,NORB,NDIFF,
     &            NTEST)
      NULLIFY(iSCR)
*
      IF(NDIFF .LE. 2 ) THEN
*. Strings for determinants of these configurations
        CALL C_F_POINTER(C_LOC(SCR(KLROU)),iSCR,[1])
        CALL C_F_POINTER(C_LOC(SCR(KLDTLA)),iSCRa,[1])
        CALL C_F_POINTER(C_LOC(SCR(KLDTLB)),iSCRb,[1])
        CALL CNFSTR_MCLR(ICNL,ITPL,iSCRa,iSCRb,
     &              NORB,NAEL,NBEL,NDETL,IPRODT,IAGRP,IBGRP,
     &              iSCR,SCR(KLISL),NTEST)
        CALL C_F_POINTER(C_LOC(SCR(KLDTRA)),iSCRar,[1])
        CALL C_F_POINTER(C_LOC(SCR(KLDTRB)),iSCRbr,[1])
        CALL CNFSTR_MCLR(ICNR,ITPR,iSCRar,iSCRbr,
     &              NORB,NAEL,NBEL,NDETR,IPRODT,IAGRP,IBGRP,
     &              iSCR,SCR(KLISR),NTEST)
*
** Hamiltonian matrix over determinants of the configurations
*
        isym=0       ! eaw
        ecorep=0.0d0 ! eaw
        CALL C_F_POINTER(C_LOC(SCR(KLROU+NEL)),iSCRn,[1])
        CALL C_F_POINTER(C_LOC(SCR(KLROU+2*NEL)),iSCRnn,[1])
        CALL DIHDJ2_MCLR(iSCRa,iSCRb,NDETL,
     &              iSCRar,iSCRbr,NDETR,
     &              NAEL,NBEL,iSCRnn,LWORK,NORB,
     &              SCR(KLDHD),ISYM,0,ECOREP,ICOMBI,PSSIGN,
     &              Str(IAGRP)%OCSTR, Str(IBGRP)%OCSTR,
     &              Str(IAGRP)%OCSTR, Str(IBGRP)%OCSTR,
     &              0,IDUMMY,IDUMMY,IDUMMY,IDUMMY,iSCR,
     &              iSCRn,NDIF0,NDIF1,NDIF2,NTEST)
        NULLIFY(iSCR,iSCRa,iSCRb,iSCRar,iSCRbr,iSCRn,iSCRnn)
*
** Transform matrix to CSF basis
*
** : sign changes
        CALL DGMM2 (SCR(KLDHD),SCR(KLDHD),SCR(KLISL),1,NDETL,NDETR)
        CALL DGMM2 (SCR(KLDHD),SCR(KLDHD),SCR(KLISR),2,NDETL,NDETR)
        IPL = 1
        DO 200 JTYP = 1, ITPL - 1
          JCSF = NCPCNT(JTYP)
          JDET = NDPCNT(JTYP)
          IPL = IPL + JCSF*JDET
  200   CONTINUE
        IF(ITPR.EQ. ITPL) THEN
          IPR = IPL
        ELSE
          IPR = 1
          DO 300 JTYP = 1, ITPR - 1
          JCSF = NCPCNT(JTYP)
          JDET = NDPCNT(JTYP)
          IPR = IPR + JCSF*JDET
  300     CONTINUE
        END IF
*
        CALL MATML4(SCR(KLCHD),DTOC(IPL),SCR(KLDHD),
     &              NCSFL,NDETR,NDETL,NCSFL,NDETL,NDETR,1)
        CALL MATML4(CNHCNM,SCR(KLCHD),DTOC(IPR),
     &              NCSFL,NCSFR,NCSFL,NDETR,NDETR,NCSFR,0)
*
      ELSE IF(NDIFF.GT. 2) THEN
        CALL SETVEC(CNHCNM,0.0D0,NCSFL*NCSFR)
      END IF
*
*
      RETURN
      END SUBROUTINE CNHCN2_INTERNAL
*
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine evbd2_cvb(orbs,cvb,fx,ioptc,iter,
     >  gjorb,gjorb2,gjorb3,
     >  c,axc,sxc,res,hp,solp,solp_res)
      implicit real*8 (a-h,o-z)
      external asonc_cvb,ddsol7_cvb,ddres7_cvb,ddres2upd10_cvb
      external ddrestart_cvb
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "davtune_cvb.fh"
#include "opt2_cvb.fh"
#include "malloc_cvb.fh"
      dimension orbs(norb,norb),cvb(nvb)
      dimension gjorb(*),gjorb2(*),gjorb3(*)
      dimension c(nvb,maxdav),axc(nvb,maxdav),sxc(nvb,maxdav),res(nvb)
      dimension hp(maxdav,maxdav),solp(maxdav),solp_res(maxdav)
      dimension dum(max(nvb,maxdav))

      call makegjorbs_cvb(orbs,gjorb,gjorb2,gjorb3)

      ioptc=1
      nvguess=1
      nvrestart=0
      call fmove_cvb(cvb,c,nvb)
      if(.not.follow)then
        ifollow=2
      else
        ifollow=4
      endif

      call ddinit7_cvb(ifollow,isaddle,ip(3))
      call ddres2updinit_cvb(0)
      call dirdiag_cvb(
     >  asonc_cvb,ddsol7_cvb,ddres7_cvb,ddres2upd10_cvb,
     >  ddrestart_cvb,
     >  c,axc,sxc,.false.,cvb,res,dum,
     >  hp,dum,solp,solp_res,
     >  .false.,.true.,.false.,maxdav,nvb,nvb,
     >  nvguess,nvrestart,isaddle,ifollow,mxiter,
     >  resthr,orththr,nortiter,corenrg,
     >  ioptc,iter,fx,ip(3))
      have_solved_it=.true.

      ovraa=one
      evb=fx
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pack210(a,b,dimpq,dimp,rc)
! this routine does: B(pq) = A(p,q) - A(q,p) for symp=symq

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimpq, dimp
real(kind=wp), intent(in) :: a(dimp,dimp)
real(kind=wp), intent(inout) :: b(dimpq)
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: p, pq, q

rc = 0
if (dimp > 1) then

  pq = 0
  do p=2,dimp
    do q=1,p-1
      pq = pq+1
      b(pq) = a(p,q)-a(q,p)
    end do
  end do

else
  ! RC=1 : dimp is less than 2
  rc = 1
end if

return

end subroutine pack210

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!---------------------------------------------------------------------
! Read input for averd.
!
! Title         -Title
! Wset          -Set of weights. Dimension is nSet.
! iPrint        -How much print.(1=minimal,2=print average orbitals,
!                5=print all orbitals,99=wacko!)
! nSet          -Number of orbitals to read
! DensityBased  -Is the procedure density or orbital based
! ThrOcc        -Print which orbitals have occupation number below
!                this threshold.
!-----------------------------------------------------------------------

subroutine Get_Averd_input(Title,iPrint,nSet,DensityBased,ThrOcc)

use Averd_global, only: Wset
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u6

implicit none
character(len=72), intent(inout) :: Title
real(kind=wp), intent(inout) :: ThrOcc
integer(kind=iwp), intent(inout) :: iPrint, nSet
logical(kind=iwp), intent(inout) :: DensityBased
integer(kind=iwp) :: iChrct, Last, LuRd
character(len=180) :: Key
character(len=4) :: Kword
character(len=180), external :: Get_Ln
integer(kind=iwp), external :: iCLast
#include "warnings.h"

!-- Call subroutines that handle the input.

LuRd = 21
call SpoolInp(LuRd)
rewind(LuRd)
call RdNLst(LuRd,'AVERD')

do

  !-- Get_Ln read the keyword and skips line starting with *
  !   or is empty.

  Key = Get_Ln(LuRd)
  Kword = trim(Key)
  call UpCase(Kword)

  !-- The keywords...

  select case (Kword(1:4))

    case ('WSET')

      !-- Read weights.

      Key = Get_Ln(LuRd)
      call Get_I1(1,nSet)
      call mma_allocate(Wset,nSet,label='Wset')
      Key = Get_Ln(LuRd)
      call Get_F(1,Wset,nSet)

    case ('PRIN')

      !-- How much print?

      Key = Get_Ln(LuRd)
      call Get_I1(1,iPrint)

    case ('TITL')

      !-- Title

      Key = Get_Ln(LuRd)
      Title = Key(1:len(Title))

    case ('ORBI')

      !-- Should it be density based, or orbital based.

      DensityBased = .false.

    case ('OCCU')

      !-- I want to be told which orbitals have occ.num. below threshold.

      Key = Get_Ln(LuRd)
      call Get_F1(1,ThrOcc)

    case ('END ')

      exit

    case default

      !-- ...and what happens if something else is encountered.

      iChrct = len(KWord)
      Last = iCLast(KWord,iChrct)
      write(u6,*) ' '
      write(u6,'(1x,a,a)') Kword(1:Last),' is not a valid keyword!'
      write(u6,*) ' ERROR!'
      call Quit(_RC_INPUT_ERROR_)

  end select

end do

!-- A most Graceful Exit.

return

end subroutine Get_Averd_input

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

!***********************************************************************
! Case C (ICASE=4)
!***********************************************************************
subroutine MKBC(DREF,NDREF,PREF,NPREF,FD,FP,NG3,F3,idxG3)

use Index_Functions, only: nTri_Elem
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
#endif
use fake_GA, only: GA_Arrays
use caspt2_global, only: iPrGlb
use caspt2_module, only: NINDEP, NSYM, NTUV
use Definitions, only: wp, iwp, u6, byte

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF, NG3
real(kind=wp), intent(in) :: DREF(NDREF), PREF(NPREF), FD(NDREF), FP(NPREF), F3(NG3)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: ICASE, IHI, ILO, ISYM, JHI, JLO, LDA, lg_BC, MBC, NAS, NBC, NIN
real(kind=wp) :: DBC
real(kind=wp), external :: PSBMAT_FPRINT
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: MA, MYRANK
real(kind=wp) :: Dummy(1)
#endif

ICASE = 4
! LONG loop over superindex symmetry.
do ISYM=1,NSYM
  NIN = NINDEP(ISYM,ICASE)
  if (NIN == 0) cycle
  NAS = NTUV(ISYM)
  NBC = nTri_Elem(NAS)
  if (NBC <= 0) cycle

  ! Set up the matrix BC(tuv,xyz) defined by the expression
  ! <atuv|H0-E0|cxyz> = dac ( alpha(a) SC(tuv,xyz) + BC(tuv,xyz) )
  ! Formula used:
  !    BC(tuv,xyz)
  !    = Fvutxyz +dyu Fvztx + dyx Fvutz + dtu Fvxyz + dtu dyx Fvz
  !    +(Ey+Eu-EASUM)*SC(tuv,xyz)
  !    -Eu*( dyu Gvztx + dtu Gvxyz )
  !    -Ey dyx Gvutz
  !    -(Eu+Ey)*( dtu dyx Gvz )

  ! where dyu = Kronecker(y,u) etc. Gvutxyz=<Evutxyz>, etc.
  ! Similarly, Fvutxyz= Sum(w)(EPSA(w)<Evutxyzww>, etc.

  call PSBMAT_GETMEM('BC',lg_BC,NAS)
  call PSBMAT_READ('S',iCase,iSym,lg_BC,NAS)

  ! fill in the 3-el parts
# ifdef _MOLCAS_MPP_
  if (IS_REAL_PAR()) then
    MYRANK = GA_NODEID()
    call GA_DISTRIBUTION(LG_BC,MYRANK,ILO,IHI,JLO,JHI)
    if ((JLO /= 0) .and. (JHI-JLO+1 /= NAS)) then
      write(u6,*) 'MKBC: MISMATCH IN RANGE OF THE SUPERINDICES'
      call ABEND()
    end if
    if ((ILO > 0) .and. (JLO > 0)) then
      call GA_ACCESS(LG_BC,ILO,IHI,JLO,JHI,MA,LDA)
      MBC = LDA*(JHI-JLO+1)
      call MKBC_DP(DREF,NDREF,PREF,NPREF,FD,FP,iSYM,DBL_MB(MA),MBC,ILO,IHI,JLO,JHI,LDA)
      call MKBC_F3_MPP(ISYM,DBL_MB(MA),ILO,NAS,LDA,NG3,F3,IDXG3)
      call GA_RELEASE_UPDATE(LG_BC,ILO,IHI,JLO,JHI)
    else
      call MKBC_F3_MPP(ISYM,DUMMY,ILO,NAS,LDA,NG3,F3,IDXG3)
    end if
  else
# endif
    ILO = 1
    IHI = NAS
    JLO = 1
    JHI = NAS
    LDA = 0
    MBC = nTri_Elem(NAS)
    call MKBC_DP(DREF,NDREF,PREF,NPREF,FD,FP,ISYM,GA_Arrays(lg_BC)%A(:),MBC,ILO,IHI,JLO,JHI,LDA)
    call MKBC_F3(ISYM,GA_Arrays(lg_BC)%A(:),MBC,NG3,F3,IDXG3)

# ifdef _MOLCAS_MPP_
  end if
# endif

  call PSBMAT_WRITE('B',iCase,iSYM,lg_BC,NAS)

  if (IPRGLB >= DEBUG) then
    DBC = PSBMAT_FPRINT(lg_BC,NAS)
    write(u6,'("DEBUG> ",A4,1X,I3,1X,ES21.14)') 'C',ISYM,DBC
  end if

  call PSBMAT_FREEMEM(lg_BC)
end do

end subroutine MKBC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Fix_Ref(Old_Ref)
! Transform coordinates, displacements and gradients
! to make them consistent with a new reference

use LnkLst, only: GetNod, iVPtr, LLDelt, LLdGrd, LLGrad, LLlGrd, LLx, LstPtr, PutVec, SCF_V
use InfSCF, only: Iter, Iter_Start, kOV, mOV, nD, nFro, nOcc, nOFS, nOrb, nSym, TimFld
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Old_Ref
integer(kind=iwp) :: i, iD, iEnd, inode, iORef, iO, iOff1, iOff2, iSt, iSyBlpt, iSym, nO, nOccmF(8,nD), nOF, nVrt
real(kind=wp) :: Cpu1, Cpu2, Tim1, Tim2, Tim3
logical(kind=iwp) :: NotUnit
real(kind=wp), allocatable :: dG(:), dX(:), G(:), RedRot(:,:), RoM(:), RotRef(:,:), tmp(:), X(:), XRef(:)
logical(kind=iwp), external :: isUnit
real(kind=wp), parameter :: thrs = 1.0e-10

call Timing(Cpu1,Tim1,Tim2,Tim3)

call mma_allocate(X,mOV,Label='X')
call mma_allocate(dX,mOV,Label='dX')
call mma_allocate(G,mOV,Label='G')
call mma_allocate(dG,mOV,Label='dG')
call mma_allocate(RoM,nOFS,Label='RoM')
call mma_allocate(RedRot,nOFS,nD,Label='RedRot')
call mma_allocate(tmp,mOV,Label='tmp')

iORef = LstPtr(Old_Ref,LLx)   ! Pointer to X_old(i_oldref)
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'Iter=',Iter
write(u6,*) 'Iter_Start=',Iter_Start
write(u6,*) 'Old_Ref=',Old_Ref
call NrmClc(SCF_V(iORef)%A,mOV,'Fix_Ref','X(i_oldref)')
write(u6,*)
#endif

! Get the displacement for the new reference
call mma_allocate(XRef,mOV,Label='XRef')
XRef(:) = -SCF_V(iORef)%A(:)
! Get the rotation matrix for the new reference
call mma_allocate(RotRef,nOFS,nD,Label='RotRef')
iEnd = 0
do iD=1,nD
  iSt = iEnd+1
  iEnd = iEnd+kOV(iD)
  nOccmF(:,iD) = nOcc(:,iD)-nFro(:)
  call ExpKap(XRef(iSt:iEnd),kOV(iD),RotRef(:,iD),nOccmF(:,iD))
end do

! Loop over all iterations starting at Iter_Start

do i=Iter_Start,Iter

  call GetNod(i,LLx,inode)
  if (inode == 0) then
    write(u6,*) 'inode == 0'
    call Abend()
  end if
  call iVPtr(X,mOV,inode)
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'X(i) before  i=',i
  call NrmClc(X,mOV,'Fix_Ref','X')
# endif

  !***************************************************************
  ! Transform the coordinates (kappa matrix, rotation parameters)
  !***************************************************************

  X(:) = X(:)+XRef(:)

  iEnd = 0
  do iD=1,nD
    iSt = iEnd+1
    iEnd = iEnd+kOV(iD)
    iOff1 = iSt-1
    ! Get the rotation matrix from the old reference
    call ExpKap(X(iSt:iEnd),kOV(iD),RoM,nOccmF(:,iD))
    iSyBlpt = 1
    do iSym=1,nSym
      nOF = nOrb(iSym)-nFro(iSym)
      nVrt = nOrb(iSym)-nOcc(iSym,iD)
      nO = nOccmF(iSym,iD)
      if (nVrt*nO < 1) cycle
      ! Calculate the combined rotation matrix from the new reference
      call dgemm_('T','N',nOF,nOF,nOF,One,RotRef(iSyBlpt,iD),nOF,RoM(iSyBlpt),nOF,Zero,RedRot(iSyBlpt,iD),nOF)
      ! Obtain the kappa matrix and redundant rotations corresponding to the combined rotation
      call log_SVD(nOF,nO,RedRot(iSyBlpt,iD))
      iOff2 = iSyBlpt+nO-1
      do iO=1,nO
        X(iOff1+1:iOff1+nVrt) = RedRot(iOff2+1:iOff2+nVrt,iD)
        iOff1 = iOff1+nVrt
        iOff2 = iOff2+nOF
      end do
      iSyBlpt = iSyBlpt+nOF**2
    end do
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) 'X(i) after  i=',i
  call NrmClc(X,mOV,'Fix_Ref','X')
# endif

  call PutVec(X,mOV,i,'OVWR',LLx)

  !*****************************
  ! Recompute the displacements
  ! dX(i-1) = X(i)-X(i-1)
  !*****************************

  if (i > Iter_Start) then
    dX(:) = X(:)-dX(:)
    call PutVec(dX,mOV,i-1,'OVWR',LLDelt)
  end if
  dX(:) = X(:)

  !*****************************************************
  ! Transform the gradients
  ! (these are local gradients at the rotated orbitals)
  !*****************************************************

  call GetNod(i,LLlGrd,inode)
  if (inode == 0) then
    write(u6,*) 'inode == 0'
    call Abend()
  end if
  call iVPtr(G,mOV,inode)

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'G(i) before  i=',i
  call NrmClc(G,mOV,'Fix_Ref','G')
# endif

  iEnd = 0
  do iD=1,nD
    iSt = iEnd+1
    iEnd = iEnd+kOV(iD)
    iOff1 = iSt
    iSyBlpt = 1
    do iSym=1,nSym
      nOF = nOrb(iSym)-nFro(iSym)
      nVrt = nOrb(iSym)-nOcc(iSym,iD)
      nO = nOccmF(iSym,iD)
      if (nVrt*nO < 1) cycle
      ! This is a straightforward multiplication by the redundant rotations
      ! Only transform if not a unit matrix
      iOff2 = iSyBlpt+nO*(nOF+1)
      if (isUnit(RedRot(iSyBlpt,iD),nO,nOF,thrs)) then
        NotUnit = .not. isUnit(RedRot(iOff2,iD),nVrt,nOF,thrs)
      else
        NotUnit = .true.
      end if
      if (NotUnit) then
        call dgemm_('N','T',nVrt,nO,nO,One,G(iOff1),nVrt,RedRot(iSyBlpt,iD),nOF,Zero,tmp,nVrt)
        call dgemm_('N','N',nVrt,nO,nVrt,One,RedRot(iOff2,iD),nOF,tmp,nVrt,Zero,G(iOff1),nVrt)
      end if
      iOff1 = iOff1+nO*nVrt
      iSyBlpt = iSyBlpt+nOF**2
    end do
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) 'G(i) after  i=',i
  call NrmClc(G,mOV,'Fix_Ref','loc G')
# endif

  call PutVec(G,mOV,i,'OVWR',LLlGrd)

  !*****************************************************
  ! Transform the gradients to the new reference
  !*****************************************************

  iEnd = 0
  do iD=1,nD
    iSt = iEnd+1
    iEnd = iEnd+kOV(iD)
    call TrGrad(X(iSt),kOV(iD),G(iSt),nOccmF(:,iD))
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) 'G(i) after  i=',i
  call NrmClc(G,mOV,'Fix_Ref','G')
# endif

  call PutVec(G,mOV,i,'OVWR',LLGrad)

  !************************************
  ! Recompute the gradient differences
  ! dG(i-1) = G(i)-G(i-1)
  !************************************

  if (i > Iter_Start) then
    dG(:) = G(:)-dG(:)
    call PutVec(dG,mOV,i-1,'OVWR',LLdGrd)
  end if
  dG(:) = G(:)

end do

call mma_deallocate(RotRef)

call mma_deallocate(X)
call mma_deallocate(dX)
call mma_deallocate(G)
call mma_deallocate(dG)
call mma_deallocate(RoM)
call mma_deallocate(RedRot)
call mma_deallocate(tmp)
call mma_deallocate(XRef)

call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(11) = TimFld(11)+(Cpu2-Cpu1)

return

end subroutine Fix_Ref

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SXHAM(D,P,PA,FP,SXN,F1,F2,DIA,G,H,HDIAG,DF,DDIAG)
C
C RASSCF VERSION IBM-3090: SX-SECTION
C
C Objective: Compute the auxiliary matrices G,H,F1,F2,and SXN
C defined as:
C
C G(pq)=sum(r,s)(2*P(pqrs)-D(pq)*D(rs))*FP(rs)
C H(pq)=G(pq)+DF(pq)+DF(qp)  where
C DF(pq)=sum(r)D(pr)*FP(rq)
C F1 is the occupied part of the SX Fock matrix FP
C F2 is the active-external part of the same matrix
C DIA is the occupied part of the density matrix(squared)
C SXN contains normalization factors for the SX states
C HDIAG is the diagonal of the SX Hamiltonian
C All matrices are blocked according to symmetry
C Each block having the dimension
C G, DIA, AND F1:     (NIO+NAO)**2
C F2:                 (NAO+NEO)**2
C H:                  NAO*NAE
C SXN:                (NIO+NAO)*(NAO+NEO)
C HDIAG:              NROOT+(NIO+NAO)*(NAO+NEO)
C
C These matrices are used to simplify the calculation
C of the sigma vector (see SIGVEC for further details).
C
C Called from SXCTL
C
C Subroutine calls: none
C
C ********** IBM-3090 RELEASE 89 01 23 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "warnings.fh"
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='SXHAM   ')
      DIMENSION D(*),P(*),PA(*),FP(*),SXN(*),F1(*),F2(*),DIA(*),
     *          G(*),H(*),HDIAG(*),DF(*),DDIAG(*)
C -- THRA: THRESHOLD FOR WARNING, ACTIVE OCC NO CLOSE TO 0 OR 2.
      DATA THRA/1.D-06/
      DIMENSION P2Act(1)
C Local print level (if any)
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
C
C Loop over all symmetry blocks
C
      ISTBM=0
      ISTD=0
      ISTFP=0
      ISTIA=0
      ISTAE=0
      ISTH=0
      IASHI=0
      ISTZ=0
      IX1=0
      DO 100 ISYM=1,NSYM
       IX=IX1+NFRO(ISYM)
       NIO=NISH(ISYM)
       NAO=NASH(ISYM)
c      NR1O=NRS1(ISYM)
c      NR2O=NRS2(ISYM)
c      NR3O=NRS3(ISYM)
c      NAO=NR1O+NR2O+NR3O
       NIA=NIO+NAO
       NEO=NSSH(ISYM)
       NAE=NAO+NEO
       NO=NORB(ISYM)
       IF(NIA.EQ.0.OR.NAE.EQ.0) GO TO 98
C
C Form the diagonal of the density matrix for all orbitals
C
       justone=0
       DO 10 NP=1,NO
        IF(NP.LE.NIO) DDIAG(NP)=2.0D0
        IF(NP.GT.NIA) DDIAG(NP)=0.0D0
        IF(NP.GT.NIO.AND.NP.LE.NIA) THEN
         DDIAG(NP)=D(ISTD+ITRI(NP-NIO+1))
         If ( DDIAG(NP).LT.THRA .AND. ISCF.EQ.0 ) Then
          If (JustOne.eq.0) Then
           Call WarningMessage(1,'Problems in orbital optimization.')
           JustOne=JustOne+1
          End If
          Write(LF,'(1x,a,i2,a,i4,a,d14.6)')' Warning: In symmetry ',
     &     ISYM,', orbital p=',NP,' has diagonal density matrix ' //
     &     'element D(p,p) close to zero. D(p,p)=',DDIAG(NP)
          End If
         If ( 2.0D0-DDIAG(NP).LT.THRA .AND. ISCF.EQ.0 ) Then
          If (JustOne.eq.0) Then
           Call WarningMessage(1,'Problems in orbital optimization.')
           JustOne=JustOne+1
          End If
          Write(LF,'(1x,a,i2,a,i4,a,d14.6)')' Warning: In symmetry ',
     &     ISYM,', orbital p=',NP,' has diagonal density matrix ' //
     &     'element D(p,p) close to two. (2 - D(p,p))=',2.0D0-DDIAG(NP)
         End If
        ENDIF
10     CONTINUE
C
C Compute the normalization constants:
C SXN(pq)=4*(P(prrp)-P(prpr))+D(rr)+D(pp)
C
       NPR=ISTBM
C NP loops over active and secondary indices.
       DO 15 NP=NIO+1,NO
C NR loops over inactive and active indices.
       DO 16 NR=1,NIA
        NPR=NPR+1
        SXN(NPR)=1.0D0
        IF(NR.GE.NP) GO TO 95
        DRR=DDIAG(NR)
        DPP=DDIAG(NP)
        PRPR=-2.0D0*DPP
        IF(NP.GT.NIA) PRPR=0.0D0
        IF(NR.GT.NIO.AND.NP.LE.NIA) THEN
         NT=NP-NIO+IASHI
         NU=NR-NIO+IASHI
         NTU=ITRI(NT)+NU
         NTUTU=ITRI(NTU+1)
         PRPR=-4.0D0*PA(NTUTU)
        ENDIF
        SXNRM2=PRPR+DRR+DPP
        IF(SXNRM2.LT.-1.0D-12) THEN
          Call WarningMessage(1,'Negative norm occured in SXHAM.')
          Write(LF,*)'SXHAM Error: Negative SXNRM2.'
          Write(LF,*)' Symmetry block ISYM:',ISYM
          Write(LF,*)'      Orbitals NP,NR:',NP,NR
          Write(LF,*)'                PRPR:',PRPR
          Write(LF,*)'                 DRR:',DRR
          Write(LF,*)'                 DPP:',DPP
          Write(LF,*)'      Norm**2 SXNRM2:',SXNRM2
         Write(LF,*)
         Write(LF,*)' The squared norm of a trial vector has been'
         Write(LF,*)' computed to be negative.'
         Write(LF,*)' This is possible only for some severe malfunction'
         Write(LF,*)' of the rasscf program. Please issue a bug report.'
         Write(LF,*)
          Call Quit(_RC_GENERAL_ERROR_)
        ENDIF
C
        IF(SXNRM2.LT.1.0D-12) THEN
          SXN(NPR)=0.0D0
        ELSE
          SXN(NPR)=1.0D0/sqrt(SXNRM2)
        END IF
95      CONTINUE
16     CONTINUE
15     CONTINUE
C
C Form the occupied (F1) and active-external (F2) part of FP
C and the occupied part DIA of the density matrix D
C
       IPQ=ISTFP
       CALL FZERO(DIA(ISTIA+1),NIA**2)
       DO 20 NP=1,NO
       DO 21 NQ=1,NP
        IPQ=IPQ+1
        IF(NP.LE.NIA.AND.NQ.LE.NIA) THEN
         F1(ISTIA+NIA*(NP-1)+NQ)=FP(IPQ)
         F1(ISTIA+NIA*(NQ-1)+NP)=FP(IPQ)
        ENDIF
        IF(NP.GT.NIO.AND.NQ.GT.NIO)THEN
         F2(NAE*(NP-NIO-1)+NQ-NIO+ISTAE)=FP(IPQ)
         F2(NAE*(NQ-NIO-1)+NP-NIO+ISTAE)=FP(IPQ)
        ENDIF
        IF(NP.LE.NIO.AND.NP.EQ.NQ) DIA(ISTIA+NIA*(NP-1)+NP)=2.0D0
        IF((NP.GT.NIO.AND.NP.LE.NIA).AND.NQ.GT.NIO)THEN
         NT=NP-NIO
         NU=NQ-NIO
         NTU=ITRI(NT)+NU+ISTD
         DIA(ISTIA+NIA*(NP-1)+NQ)=D(NTU)
         DIA(ISTIA+NIA*(NQ-1)+NP)=D(NTU)
        ENDIF
21     CONTINUE
20     CONTINUE
       IF(IPRLEV.ge.DEBUG) THEN
         write(6,*) 'DIA in SXHAM:'
         write(6,*) (DIA(ISTIA+i),i=1,NIA**2)
       END IF
C
C Form the matrix DF (row index active, column index all orbitals)
C
       IF(NAO.NE.0) THEN
        CALL DGEMM_('N','N',
     &              NAO,NAE,NAO,
     &              1.0d0,DIA(ISTIA+NIO*NIA+NIO+1),NIA,
     &              F2(ISTAE+1),NAE,
     &              0.0d0,DF(NAO*NIO+1),NAO)
        IF(NIO.NE.0) THEN
         CALL DGEMM_('N','N',
     &               NAO,NIO,NAO,
     &               1.0d0,DIA(ISTIA+NIO*NIA+NIO+1),NIA,
     &               F1(ISTIA+NIO+1),NIA,
     &               0.0d0,DF,NAO)
        ENDIF
       ENDIF
C
C compute the G matrix:
C G(ij)=-2*FP(ij)
C G(ti)=G(it)=-DF(ti)
C G(tu)=sum(vx)(2P(tuvx)-D(tu)D(vx))F(vx)
C
       If (ExFac.ne.1.0D0) Then
          Call Get_Temp('nP2Act  ',P2Act,1)
          nP2Act=Int(P2Act(1))
          Call Get_Temp('P2_RAW  ',P,nP2Act)
       End If
       DO 30 NP=1,NIA
       DO 31 NQ=1,NP
        IPQ=ISTIA+NIA*(NP-1)+NQ
        IQP=ISTIA+NIA*(NQ-1)+NP
        IF(NP.LE.NIO) THEN
         G(IPQ)=-2.0D0*F1(IPQ)
         G(IQP)=G(IPQ)
        ELSE IF(NP.GT.NIO.AND.NQ.LE.NIO) THEN
         G(IPQ)=-DF(NAO*(NQ-1)+NP-NIO)
         G(IQP)=G(IPQ)
        ELSE IF(NQ.GT.NIO) THEN
         DTU=DIA(ISTIA+NIA*(NP-1)+NQ)
         GTU=0.0D0
         NTT=NP-NIO+IASHI
         NUT=NQ-NIO+IASHI
         NTUT=ITRI(NTT)+NUT
C
         IASHJ=0
         ISTFPJ=0
         NVX=0
         DO 24 JSYM=1,NSYM
          NAOJ=NASH(JSYM)
          NIOJ=NISH(JSYM)
          IF(NAOJ.EQ.0) GO TO 23
          DO 22 NV=1,NAOJ
           NVT=NV+IASHJ
          DO 25 NX=1,NV
           NXT=NX+IASHJ
           NVX=NVX+1
           NVXT=ITRI(NVT)+NXT
           NTUVX=ITRI(MAX(NTUT,NVXT))+MIN(NTUT,NVXT)
           FAC=2.0D0
           FACD=2.0D0
           IF(NV.EQ.NX) FACD=1.0D0
           IF(NTUT.LT.NVXT) THEN
            IF(NVT.NE.NXT.AND.NTT.EQ.NUT) FAC=4.0D0
            IF(NVT.EQ.NXT.AND.NTT.NE.NUT) FAC=1.0D0
           ENDIF
           NVXF=ISTFPJ+ITRI(NV+NIOJ)+NX+NIOJ
           GTU=GTU+FP(NVXF)*(FAC*P(NTUVX)-FACD*DTU*D(NVX))
25        CONTINUE
22        CONTINUE
          IASHJ=IASHJ+NAOJ
23        ISTFPJ=ISTFPJ+ITRI(NORB(JSYM)+1)
24       CONTINUE
         G(IPQ)=GTU
         G(IQP)=GTU
        ENDIF
31     CONTINUE
30     CONTINUE
       If (ExFac.ne.1.0D0) Call Get_Temp('P2_KS   ',P,nP2Act)
C
C FORM THE H MATRIX (only the nae*nao block is needed)
C H(tu)=G(tu)+DF(tu)+DF(ut)
C H(at)=DF(ta)
C H(ab) and H(ta) are not included.
C
       IF(NAO.NE.0) THEN
        IPQ=ISTH
        DO 40 NP=1,NAO
        DO 41 NQ=1,NAE
         IPQ=IPQ+1
         IF(NQ.LE.NAO) THEN
          H(IPQ)=G(ISTIA+NIA*(NP+NIO-1)+NQ+NIO)
     *          +DF(NAO*(NP+NIO-1)+NQ)+DF(NAO*(NQ+NIO-1)+NP)
         ELSE
          H(IPQ)=DF(NAO*(NQ+NIO-1)+NP)
         ENDIF
41      CONTINUE
40      CONTINUE
       ENDIF
C
C Diagonal elements of the SX Hamiltonian
C
       NPR=ISTBM
       DO 50 NP=1,NAE
        FPP=F2(ISTAE+NAE*(NP-1)+NP)
        HPP=0.0D0
        DPP=0.0D0
        IF(NP.LE.NAO) THEN
         HPP=H(ISTH+NAE*(NP-1)+NP)
         DPP=DIA(ISTIA+NIA*(NP+NIO-1)+NP+NIO)
        ENDIF
        NRR=ISTIA+1
        DO 48 NR=1,NIA
         NPR=NPR+1
         HDIAG(NPR+NROOT)=
     *   (G(NRR)-HPP+DIA(NRR)*FPP+DPP*F1(NRR))*SXN(NPR)**2
         NRR=NRR+NIA+1
C
C Make this matrix element large for forbidden rotations
C
         IF(NP.LE.NAO.AND.NR.GT.NIO) THEN
          NT=NP
          NU=NR-NIO
          IF(NT.LE.NU) THEN
           HDIAG(NPR+NROOT)=1.D32
           SXN(NPR)=0.0D0
          ELSE
           NTU=ISTZ+ITRI(NT-1)+NU
           IF(IZROT(NTU).NE.0) THEN
             HDIAG(NPR+NROOT)=1.D32
             SXN(NPR)=0.0D0
C             Write(LF,*)'SXHAM. IZROT.eq.1 for NP,NR=',NP,NR
           END IF
          ENDIF
         ENDIF

C
C Make HDIAG large for rotations forbidden by IXSYM input
C
         IF(IXSYM(NR+IX).NE.IXSYM(NP+NIO+IX)) THEN
C           Write(LF,*)'SXHAM. IXSYM forbids NP,NR=',NP,NR
           HDIAG(NPR+NROOT)=1.D32
           SXN(NPR)=0.0D0
         END IF
C
48      CONTINUE
50     CONTINUE
C       Write(LF,*)'SXHAM: The IXSYM array='
C       Write(LF,'(1x,40i2)')(ixsym(i),i=1,ntot)
C
C Test print of all matrices
C
       IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,1000) ISYM
1000    FORMAT(/1X,'Matrices in SXHAM for symmetry block',I2)
        Write(LF,1100) (DDIAG(I),I=1,NO)
1100    FORMAT(/1X,'Diagonal of the full density matrix'/(1X,5G18.6))
        Write(LF,1200) (SXN(I),I=ISTBM+1,ISTBM+NIA*NAE)
1200    FORMAT(/1X,'Normalization constants for SX-states'/(1X,5G18.6))
        Write(LF,1300) (DF(I),I=1,NAO*NO)
1300    FORMAT(/1X,'The matrix sum(D(pr)F(rq)) -DF'/(1X,5G18.6))
        Write(LF,1400) (F1(I),I=ISTIA+1,ISTIA+NIA**2)
1400    FORMAT(/1X,'The occupied part of the Fock matrix'/(1X,5G18.6))
        Write(LF,1500) (F2(I),I=ISTAE+1,ISTAE+NAE**2)
1500    FORMAT(/1X,'The act-ext part of the Fock matrix'/(1X,5G18.6))
        Write(LF,1600) (G(I),I=ISTIA+1,ISTIA+NIA**2)
1600    FORMAT(/1X,'The G-matrix'/(1X,5G18.6))
        Write(LF,1700) (H(I),I=ISTH+1,ISTH+NAO*NAE)
1700    FORMAT(/1X,'The H-matrix'/(1X,5G18.6))
        Write(LF,1800) (HDIAG(I),I=ISTBM+1+NROOT,ISTBM+NAE*NIA+NROOT)
1800    FORMAT(/1X,'Diagonal of the SX Hamiltonian'/(1X,5G18.6))
       ENDIF
C
       IASHI=IASHI+NAO
       ISTD=ISTD+ITRI(NAO+1)
98     ISTIA=ISTIA+NIA**2
       ISTAE=ISTAE+NAE**2
       ISTFP=ISTFP+ITRI(NO+1)
       ISTBM=ISTBM+NIA*NAE
       ISTH=ISTH+NAO*NAE
       ISTZ=ISTZ+(NAO**2-NAO)/2
       IX1=IX1+NBAS(ISYM)
C
100   CONTINUE
C
C Level shift section
C
       XLEV=LVSHFT
       SXSHFT=0.0D0
       HDMIN=1.D32
       DO 152 I=NROOT+1,NROOT+NSXS
        IF(HDIAG(I).LT.HDMIN)  HDMIN=HDIAG(I)
152    CONTINUE
       SXSHFT=MAX(XLEV-HDMIN,0.0D0)
C
C no level shift if input (alpha) is zero
C
       IF(LVSHFT.EQ.0.0D0) SXSHFT=0.0D0
       DO 154 I=NROOT+1,NROOT+NSXS
        HDIAG(I)=HDIAG(I)+SXSHFT
154    CONTINUE
       IF(IPRLEV.GE.DEBUG) THEN
         Write(LF,1101) HDMIN,SXSHFT
1101   FORMAT(1X,'Lowest diagonal element has the value',F12.6,
     *        ' A level shift of',F12.6,' has been used')
       END IF
C
C Add diagonal elements for the reference space (CI-states)
C
      HDIAG(1)=0.0D0
      IF(ICICP.NE.0) THEN
       IROOT1=IROOT(1)
       DO 56 I=1,NROOT
        HDIAG(I)=ENER(I,ITER)-ENER(IROOT1,ITER)
56     CONTINUE
      ENDIF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2003, Valera Veryazov                                  *
*               2016,2017, Roland Lindh                                *
************************************************************************
      SubRoutine Final()
      use SCF_Arrays
      Implicit Real*8 (a-h,o-z)
#ifdef _EFP_
      External EFP_On
#endif
#include "mxdm.fh"
#include "infscf.fh"
*
*
*---- Read remaining one-electron integrals
      Call R1IntB

      nD = iUHF + 1
      Call Final_(Dens,OneHam,Ovrlp,TwoHam,CMO,EOrb,
     &            Fock,OccNo,nBT,nDens,nD,nBB,nnB,KntE,MssVlc,Darwin)
*
      Return
      End
      SubRoutine Final_(Dens,OneHam,Ovrlp,TwoHam,CMO,EOrb,Fock,
     &                  OccNo,mBT,mDens,nD,mBB,mmB,KntE,MssVlc,Darwin)
************************************************************************
*                                                                      *
*     purpose: perform final calculations                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: UHF - V.Veryazov, 2003                                  *
*                                                                      *
************************************************************************
#ifdef _EFP_
      use EFP_Module
      use EFP
#endif
      Implicit Real*8 (a-h,o-z)
*
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "file.fh"
#ifdef _FDE_
      ! Thomas Dresselhaus
#include "embpotdata.fh"
#endif
#include "scfwfn.fh"
#include "stdalloc.fh"
*
      Real*8 Dens(mBT,nD,mDens), OneHam(mBT), Ovrlp(mBT),
     &       TwoHam(mBT,nD,mDens), CMO(mBB,nD), EOrb(mmB,nD),
     &       Fock(mBT,nD), OccNo(mmB,nD), KntE(mBT), MssVlc(mBT),
     &       Darwin(mBT)
*
      Logical Do_OFemb, KEonly, OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_I / ipFMaux, ip_NDSD, l_NDSD
      Logical Do_SpinAV
      COMMON  / SPAVE_L  / Do_SpinAV
      COMMON  / SPAVE_I  / ip_DSc
      Logical Do_Addc
      COMMON  / ADDcorr_L   / Do_Addc
      Logical Do_Tw
      COMMON  / Tw_corr_L   / Do_Tw
#ifdef _EFP_
      Logical EFP_On
#endif
*
*---- Define local variables
      Logical FstItr
      Character*8 RlxLbl,Method
      Character*60 Fmt
      Character*128 OrbName
      Logical RF_On,Langevin_On,PCM_On
      Character*80 Note
      Character*8 What
      Integer IndType(7,8)
      Real*8, Dimension(:), Allocatable:: Temp, CMOn, Etan, Epsn
      Real*8, Dimension(:,:), Allocatable:: GVFck, Scrt1, Scrt2, DMat,
     &                                      EOr
#ifdef _HDF5_
      character(Len=1), allocatable :: typestring(:)
      Integer nSSh(mxSym), nZero(mxSym)
#endif
      Integer nFldP
#include "interfaces_scf.fh"
      Dimension Dummy(1)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      Call CWTime(TCpu1,TWall1)
*
         What='COEI'

      Call SorbCMOs(CMO,mBB,nD,EOrb,OccNo,mmB,nBas,nOrb,nSym)
*
      Call Put_darray('SCF orbitals',CMO(1,1),mBB)
      If (nD.eq.2) Then
         Call Put_darray('SCF orbitals_ab',CMO(1,2),mBB)
      End If
*
      If (nIter(nIterP).le.0) Then
*
         FstItr=.TRUE.
         Call SCF_Energy(FstItr,E1V,E2V,EneV)
         call dcopy_(nBT*nD,Dens(1,1,1),1,Dens(1,1,nDens),1)
         call dcopy_(nBT*nD,TwoHam(1,1,1),1,TwoHam(1,1,nDens),1)
*
         DMOMax = Zero
         FMOMax = Zero
*
      Else
*
*------- Compute improved virtuals (if needed)
         If (kIvo.eq.1) then
            Do iD = 1, nD
               Call IvoGen(OneHam,nBT,CMO(1,iD),nBO,
     &                     EOrb(1,iD),nnO,nOcc(1,iD))
            End Do
         End If
*
*--------------------------------------------------
*------- Write stuff for gradient calculation -----
*--------------------------------------------------
*
*...  Add Fock operator matrix
*
*     Note that we need an array with four additional
*     elements due to the use of WrOne, which adds
*     four elements for some auxiliary information!
*
      Call mma_allocate(Temp,nBT+4,Label='Temp')
      Call FZero(Temp,nBT+4)
*
      Do iD = 1, nD
         Call DCopy_(nBT,Fock(1,iD),1,Temp,1)
         iRc=-1
         iOpt=0
         RlxLbl='Fock Op '
         If (iD.eq.2) RlxLbl='Fock Op2'
         iSymLb=1
         Call WrOne(iRc,iOpt,RlxLbl,1,Temp,iSymLb)
         If ( iRc.ne.0 ) Then
            Write (6,*) 'Final: Error writing on ONEINT'
            Write (6,'(A,A)') 'RlxLbl=',RlxLbl
            Call Abend()
         End If
      End Do
      Call mma_deallocate(Temp)
*
*------- Construct the generalized variational Fock matrix
*
         Call mma_allocate(GVFck,nBT,nD,Label='GVFck')
         Call mma_allocate(Scrt1,MaxBas**2,nD,Label='Scrt1')
         Call mma_allocate(Scrt2,MaxBxO,nD,Label='Scrt2')
*
         iFock = 1
         jFock = 1
         iCMo  = 1
         Do iSym = 1, nSym
            If (nOrb(iSym).le.0) Cycle
*
            Do iD = 1, nD
               Call Square(Fock(jFock,iD),Scrt1(1,iD),
     &                     1,nBas(iSym),nBas(iSym))
*----------    Transform to MO basis
               Call DGEMM_('T','N',
     &                     nOrb(iSym),nBas(iSym),nBas(iSym),
     &                     1.0d0,CMO(iCMo,iD),nBas(iSym),
     &                           Scrt1(1,iD),nBas(iSym),
     &                     0.0d0,Scrt2(1,iD),nOrb(iSym))
               Call DGEMM_('N','N',
     &                     nOrb(iSym),nOrb(iSym),nBas(iSym),
     &                     1.0d0,Scrt2(1,iD),nOrb(iSym),
     &                           CMO(iCMo,iD),nBas(iSym),
     &                     0.0d0,Scrt1(1,iD),nOrb(iSym))
*
*----------    Set elements with both indices virtual to zero
               Do iVirt = 1, nOrb(iSym)-nOcc(iSym,iD)
                  jVirt = 1 + nOcc(iSym,iD)*nOrb(iSym) + nOcc(iSym,iD) +
     &                    (iVirt-1)*nOrb(iSym)
                  call dcopy_(nOrb(iSym)-nOcc(iSym,iD),[Zero],0,
     &                                             Scrt1(jVirt,iD),1)
               End Do
*----------    Now project back to the SO basis
               Call DGEMM_('N','N',
     &                     nBas(iSym),nOrb(iSym),nOrb(iSym),
     &                     1.0d0,CMO(iCMo,iD),nBas(iSym),
     &                           Scrt1(1,iD),nOrb(iSym),
     &                     0.0d0,Scrt2(1,iD),nBas(iSym))
               Call DGEMM_('N','T',
     &                     nBas(iSym),nBas(iSym),nOrb(iSym),
     &                     1.0d0,Scrt2(1,iD),nBas(iSym),
     &                           CMO(iCMo,iD),nBas(iSym),
     &                     0.0d0,Scrt1(1,iD),nBas(iSym))

               ij = iFock
               Do iBas = 1, nBas(iSym)
                  Do jBas = 1, iBas-1
                     kl =  nBas(iSym)*(jBas-1) + iBas
                     lk =  nBas(iSym)*(iBas-1) + jBas
                     GVFck(ij,iD) = Scrt1(kl,iD) + Scrt1(lk,iD)
                     ij = ij + 1
                  End Do
                  kl =  nBas(iSym)*(iBas-1) + iBas
                  GVFck(ij,iD) = Scrt1(kl,iD)
                  ij = ij + 1
               End Do
*
            End Do ! iD
*
            iFock = iFock + nBas(iSym)*(nBas(iSym)+1)/2
            jFock = jFock + nBas(iSym)*(nBas(iSym)+1)/2
            iCMo  = iCMo  + nBas(iSym)*nOrb(iSym)

         End Do  ! iSym
         Call mma_deallocate(Scrt2)
         Call mma_deallocate(Scrt1)
*
*...  Add elementary info
         Method='RHF-SCF '
         If (iUHF.eq.1) Method='UHF-SCF '

         If (kIvo.ne.0) Method='IVO-SCF '
         If (KSDFT.ne.'SCF') Method='KS-DFT  '
         Call Put_cArray('Relax Method',Method,8)
*        Call Put_Energy(EneV)
         Call Store_Energies(1,[EneV],1)
         Call Put_dScalar('SCF energy',EneV)
c         If (iUHF.eq.1) Call Put_dScalar('Ener_ab',EneV_ab)
         Call Put_iArray('nIsh',nOcc(1,1),nSym)
         If (iUHF.eq.1) Call Put_iArray('nIsh_ab',nOcc(1,2),nSym)
         Call Put_iArray('nOrb',nOrb,nSym)
         Call Put_iArray('nDel',nDel,nSym)
         Call Put_iArray('nFroPT',nFro,nSym)    ! for Cholesky-CC
         Call Put_iArray('nDelPT',nDel,nSym)    !
*
*...  Add MO-coefficients
         Call Put_CMO(CMO(1,1),nBB)
         If (iUHF.eq.1) Call Put_dArray('CMO_ab',CMO(1,2),nBB)
*
*...  Add one body density matrix in AO/SO basis
*
*     If the density matrix is explicitly calculated in the beginning we will
*     use that one instead.
         If (nIter(nIterP).le.0) Then
            Call DensAB(nBT,nDens,nD,Dens)
         Else
            Call mma_allocate(DMat,nBT,nD,Label='DMat')
*
            if(iUHF.eq.0) then
               Call dOne_SCF(nSym,nBas,nOrb,nFro,CMO(1,1),mBB,
     &                       OccNo(1,1),DMat(1,1),.true.)
            else
               Call dOne_SCF(nSym,nBas,nOrb,nFro,CMO(1,1),mBB,
     &                       OccNo(1,1),DMat(1,1),.true.)
               Call dOne_SCF(nSym,nBas,nOrb,nFro,CMO(1,2),mBB,
     &                       OccNo(1,2),DMat(1,2),.false.)
               Call Put_D1ao_Var(Dummy,0) ! Undefined the field.
            End If

            Call DensAB(nBT,1,nD,DMat)
            Call mma_deallocate(DMat)
         End If

         If(nD.eq.2) Then
            Call mma_allocate(CMOn,nBB,Label='CMOn')
            Call mma_allocate(Etan,nnB,Label='Etan')
            Call mma_allocate(Epsn,nnB,Label='Epsn')
            Call NatoUHF(Dens(1,1,1),Dens(1,2,1),
     &                   Fock(1,1),Fock(1,2),nBT,
     &                   CMO(1,1),nBB,Ovrlp,
     &                   CMOn,Etan,Epsn,
     &                   nnB,nSym,nBas,nOrb)
            Call PadCMO(CMOn,CMOn,nSym,nBas,nOrb)
            Call PadEor(Etan,Etan,nSym,nBas,nOrb)
            Call PadEor(Epsn,Epsn,nSym,nBas,nOrb)
         End If
*
*...  Add generalized Fock matrix
         If (iUHF.eq.1) Then
            Call DaXpY_(nBT,One,GVFck(1,2),1,GVFck(1,1),1)
         Else
            Call DScal_(nBT,Two,GvFck(1,1),1)
         End If
         Call Put_Fock_Occ(GVFck(1,1),nBT)
         Call mma_deallocate(GVFck)
*
*... Add SCF orbital energies
         Call Put_OrbE(EOrb(1,1),nnB)
         if(iUHF.eq.1) Call Put_dArray('OrbE_ab',EOrb(1,2),nnB)
*
         Call Put_dScalar('Thrs',Fthr)
      EndIf

#ifdef _FDE_
      ! Embedding
      if (embPot.and.(embWriteEsp)) then
         Call embPotOutput(nAtoms,ip_of_Work(Dens(1,1,1)))
      end if
#endif
*
c t.t.;
c    store Fock matrix in Runfile in case of fragment calculation
      If (Falcon) Then
c                 write(6,*)'Fock matrix is written in RunFile.'
c                 write(6,*)'fck:'
c                 write(6,*)'nbt=',nbt
c                 write(6,*)'ndens=',ndens
c                 write(6,*) (Fock(itt),itt=1,nbt)
         Call Put_dArray('Fragment_Fock',Fock(1,1),nBT)
      End if

c t.t.; end
*---- Final printout
c original PrFin was splitted to 3 parts to run in UHF mode
*
      Do iSym=1,nSym
         nDel(iSym)=nBas(iSym)-nOrb(iSym)
      End Do
      Call PrFin0(Dens(1,1,nDens),Dens(1,2,nDens),nBT,EOrb(1,1),nnB,
     &            CMO(1,1),nBO,KntE)
*
      Do iD = 1, nD
         Call PrFin(OneHam,Ovrlp,Dens(1,iD,nDens),TwoHam(1,iD,nDens),
     &              nBT,EOrb(1,iD),OccNo(1,iD),nnB,CMO(1,iD),nBO,Note,
     &              iD-1,MssVlc,Darwin)
*
         Call PrFin2(Ovrlp,nBT,OccNo(1,iD),nnB,CMO(1,iD),nBO,Note)
      End Do
*
      If (iPrint.ge.2.and.iUHF.eq.1) Then
         Call PriMO('Natural orbitals',.true.,.true.,0.0d0,2.0d9,
     &              nSym,nBas,nOrb,Name,Epsn,Etan,CMOn,iPrForm)
      End If
*------- Calculate expectation values
      If (.not.NoProp) Then
         If (iPrint.ge.3) Then
            Write(6,'(/6X,A)') 'Expectation values of various operators'
         End If
         Call Prpt()
      End If
*
c make a fix for energies for deleted orbitals
      Call mma_allocate(EOr,nnB,nD,Label='EOr')
*
      iRef=1
      jRef=1
      Do iSym=1,nSym
         iiOrb=nOrb(iSym)-nDel(iSym)
         Do iOrb=1,iiOrb
            Do iD = 1, nD
               EOr(iRef,iD)=EOrb(jRef,iD)
            End Do
            iRef=iRef+1
            jRef=jRef+1
         End do
         Do iOrb=1,nDel(iSym)
            Do iD = 1, nD
               EOr(iRef,iD)=1000
            End Do
            iRef=iRef+1
         End do
      End Do

      If(iUHF.eq.0) Then
         Do iSym=1,nSym
            IndType(1,iSym)=nFro(iSym)
            IndType(2,iSym)=nOcc(iSym,1)
            IndType(3,iSym)=0
            IndType(4,iSym)=0
            IndType(5,iSym)=0
            IndType(6,iSym)=nOrb(iSym)-nFro(iSym)-nOcc(iSym,1)
     &                     -nDel(iSym)
            IndType(7,iSym)=nDel(iSym)
         End Do
      Else
         Do iSym=1,nSym
            nOccMax=Max(nOcc(iSym,1),nOcc(iSym,2))
            nOccMin=Min(nOcc(iSym,1),nOcc(iSym,2))
            IndType(1,iSym)=nFro(iSym)
            IndType(2,iSym)=nOccMin
            IndType(3,iSym)=0
            IndType(4,iSym)=nOccMax-nOccMin
            IndType(5,iSym)=0
            IndType(6,iSym)=nOrb(iSym)-nFro(iSym)-nOccMax-nDel(iSym)
            IndType(7,iSym)=nDel(iSym)
         End Do
      End If
      If(iUHF.eq.0) then
         OrbName='SCFORB'
         If(KSDFT.EQ.'SCF') Then
            iWFtype=2
         Else
            Note=Trim(Note)//' / '//Trim(KSDFT)
            iWFtype=3
         End If
         Call WrVec_(OrbName,LuOut,What,iUHF,nSym,nBas,nBas,
     &             CMO(1,1),Dummy, OccNo(1,1),Dummy,EOr(1,1),
     &     Dummy,IndType,Note,iWFtype)
#ifdef _HDF5_
         nZero = 0
         call mma_allocate(typestring, nnB)
         Do i = 1, nSym
         nSSh(i) = nBas(i) - nFro(i) - nOcc(i,1) - nDel(i)
         End Do
         call orb2tpstr(NSYM,NBAS,
     $           NFRO,NOCC(1,1),NZERO,NZERO,NZERO,NSSH,NDEL,
     $           typestring)
         call mh5_put_dset(wfn_tpidx, typestring)
         call mma_deallocate(typestring)
         call mh5_put_dset(wfn_mocoef, CMO(1,1))
         call mh5_put_dset(wfn_occnum, OccNo(1,1))
         call mh5_put_dset(wfn_orbene, EOrb(1,1))
#endif
      Else
         OrbName='UHFORB'
         If(KSDFT.EQ.'SCF') Then
            iWFtype=4
         Else
            Note=Trim(Note)//' / '//Trim(KSDFT)
            iWFtype=5
         End If
         Call WrVec_(OrbName,LuOut,What,iUHF,nSym,nBas,nBas,
     &               CMO(1,1),CMO(1,2), OccNo(1,1),OccNo(1,2),
     &               EOr(1,1),EOr(1,2), IndType, Note,iWFtype)
#ifdef _HDF5_
         nZero = 0
         call mma_allocate(typestring, nnB)
         Do i = 1, nSym
         nSSh(i) = nBas(i) - nFro(i) - nOcc(i,1) - nDel(i)
         End Do
         call orb2tpstr(NSYM,NBAS,
     $           NFRO,NOCC(1,1),NZERO,NZERO,NZERO,NSSH,NDEL,
     $           typestring)
         call mh5_put_dset(wfn_tpidx_a, typestring)
         Do i = 1, nSym
         nSSh(i) = nBas(i) - nFro(i) - nOcc(i,2) - nDel(i)
         End Do
         call orb2tpstr(NSYM,NBAS,
     $           NFRO,NOCC(1,2),NZERO,NZERO,NZERO,NSSH,NDEL,
     $           typestring)
         call mh5_put_dset(wfn_tpidx_b, typestring)
         call mh5_put_dset(wfn_mocoef_a, CMO(1,1))
         call mh5_put_dset(wfn_occnum_a, OccNo(1,1))
         call mh5_put_dset(wfn_orbene_a, EOrb(1,1))
         call mh5_put_dset(wfn_mocoef_b, CMO(1,2))
         call mh5_put_dset(wfn_occnum_b, OccNo(1,2))
         call mh5_put_dset(wfn_orbene_b, EOrb(1,2))
#endif
         iBas=0
         Do iSym=1,nSym
            IndType(1,iSym)=nFro(iSym)
            IndType(2,iSym)=0
            IndType(3,iSym)=0
            IndType(4,iSym)=0
            IndType(5,iSym)=0
            IndType(6,iSym)=nOrb(iSym)-nFro(iSym)-nDel(iSym)
            IndType(7,iSym)=nDel(iSym)
            Do kBas=1,nBas(iSym)
               iBas=iBas+1
               If(Etan(iBas).gt.1.99d0) Then
                  IndType(2,iSym)=IndType(2,iSym)+1
                  IndType(6,iSym)=IndType(6,iSym)-1
               Else If(Etan(iBas).gt.0.01d0) Then
                  IndType(4,iSym)=IndType(4,iSym)+1
                  IndType(6,iSym)=IndType(6,iSym)-1
               End If
            End Do
         End Do
         OrbName='UNAORB'
         Note='UHF natural orbitals'
         If(KSDFT.EQ.'SCF') Then
            iWFtype=6
         Else
            iWFtype=7
         End If
         Call WrVec_(OrbName,LuOut,What,0,nSym,nBas,nBas,
     &               CMOn,Dummy,Etan,Dummy,Epsn,
     &               Dummy,IndType, Note,iWFtype)
#ifdef _HDF5_
         call orb2tpstr(NSYM,NBAS,
     $           NFRO,IndType(2,:),NZERO,IndType(4,:),NZERO,
     $           IndType(6,:),NDEL,typestring)
         call mh5_put_dset(wfn_tpidx, typestring)
         call mma_deallocate(typestring)
         call mh5_put_dset(wfn_mocoef, CMOn)
         call mh5_put_dset(wfn_occnum, Etan)
         call mh5_put_dset(wfn_orbene, Epsn)
#endif
         Call mma_deallocate(Epsn)
         Call mma_deallocate(Etan)
         Call mma_deallocate(CMOn)
      End If

      Call mma_deallocate(EOr)
*
*---- release Buffers for semi-direct SCF
      If (DSCF) Call ClsBuf(nDisc,nCore)
*---- release SEWARD
      If ( DSCF             .or.
     &     RF_On()          .or.
     &     Langevin_On()    .or.
     &     PCM_On()         .or.
     &     Do_OFemb         .or.
     &     Do_Tw            .or.
     &     Do_Addc          .or.
#ifdef _EFP_
     &     EFP_On()         .or.
#endif
     &     KSDFT.ne.'SCF'        ) Call ClsSew
*
      If (Do_OFemb) Then
          Call GetMem('FMaux','Free','Real',ipFMaux,nBT)
#ifdef _NOT_USED_CODE_
          If (l_NDSD.gt.0)
     &        Call GetMem('NDSD','Free','Real',ip_NDSD,l_NDSD)
#endif
      EndIf
      If (MxConstr.gt.0) Then
         If (Do_SpinAV) Call GetMem('DSc','Free','Real',ip_DSc,nBB)
      EndIf
#ifdef _EFP_
      If (EFP_On()) Then
         Call EFP_ShutDown(EFP_Instance)
      End If
#endif
*
      Call CWTime(TCpu2,TWall2)
      TimFld(15) = TimFld(15) + (TCpu2 - TCpu1)
      Call SavTim(3,TCpu2-TCpu1,TWall2-TWall1)
      TotCpu=Max(TCpu2,0.1D0)
*
*---- Write out timing informations
      If(.not.NoProp) Then
         nFldP=nFld-1
      Else
         nFldP=nFld-2
      End If
      Fmt='(2x,A)'
      if(iStatPRN.gt.0) then
      Write(6,*)
      Call CollapseOutput(1,'Statistics and timing')
      Write(6,'(3X,A)')     '---------------------'
      Write(6,*)
      Write(6,Fmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
     &          //' - - - - - - - - -'
      Write(6,Fmt)'   Part of the program                           '
     &          //'   CPU    fraction'
      Write(6,Fmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
     &          //' - - - - - - - - -'
      Do iFld = 1, nFldP
         Write(6,'(2x,A45,2f10.2)')NamFld(iFld),TimFld(iFld),
     &                             TimFld(iFld)/TotCpu
      End Do
      Write(6,*)
      Write(6,'(2x,A45,2F10.2)')NamFld(nFld),TotCpu
      Write(6,Fmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
     &          //' - - - - - - - - -'
      Call CollapseOutput(0,'Statistics and timing')
      Write(6,*)
      endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function iTabRow(i)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iTabRow
integer(kind=iwp), intent(in) :: i

iTabRow = 0
iTabRow = 1
select case (i)
  case (1:2)
    iTabRow = 1
  case (3:10)
    iTabRow = 2
  case (11:18)
    iTabRow = 3
  case (19:36)
    iTabRow = 4
  case (37:54)
    iTabRow = 5
  case (55:86)
    iTabRow = 6
  case (87:)
    iTabRow = 7
  case default
    iTabRow = 1
end select

return

end function iTabRow

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cartoneX(L,Lmax,onecontr,ncontrac,MxcontL,onecartX)
!bs arranges the cartesian one-electron-integrals for X on a square matrix

use index_functions, only: iTri
use Constants, only: Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: L, Lmax, ncontrac, MxcontL
real(kind=wp), intent(in) :: onecontr(MxcontL,MxcontL,-Lmax:Lmax,3)
real(kind=wp), intent(inout) :: onecartX(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1))
integer(kind=iwp) :: iaddr, M, Mprime
real(kind=wp) :: pre

!bs - + Integrals    m || mprime     mprime=m+1
do Mprime=2,L
  M = mprime-1
  iaddr = iTri(Mprime+L+1,-M+L+1)
  onecartX(1:ncontrac,1:ncontrac,iaddr) = onecartX(1:ncontrac,1:ncontrac,iaddr)- &
                                          Quart*(onecontr(1:ncontrac,1:ncontrac,Mprime,1)+onecontr(1:ncontrac,1:ncontrac,-Mprime,3))
end do
!bs - + Integrals    m || mprime     mprime=m-1
do Mprime=1,L-1
  M = mprime+1
  iaddr = iTri(Mprime+L+1,-M+L+1)
  onecartX(1:ncontrac,1:ncontrac,iaddr) = onecartX(1:ncontrac,1:ncontrac,iaddr)- &
                                          Quart*(onecontr(1:ncontrac,1:ncontrac,Mprime,3)+onecontr(1:ncontrac,1:ncontrac,-Mprime,1))
end do
!bs -1 || 0 integrals
pre = sqrt(0.125_wp)
iaddr = iTri(L,L+1)
onecartX(1:ncontrac,1:ncontrac,iaddr) = onecartX(1:ncontrac,1:ncontrac,iaddr)- &
                                        pre*(onecontr(1:ncontrac,1:ncontrac,0,3)+onecontr(1:ncontrac,1:ncontrac,0,1))

return

end subroutine cartoneX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Jeppe Olsen                                      *
*               2011, Giovanni Li Manni                                *
************************************************************************
      SUBROUTINE ADDDIA_TERMS(NAEL,IASTR,NBEL,IBSTR,
     &                  NORB,CVEC,SVEC,NSMST,H,
     &                  XA,XB,SCR,RJ,RK,
     &                  NSSOA,NSSOB,
     &                  ECORE,
     &                  IPRNT,NTOOB,RJKAA,
     &                  IASPGP,IASM,IBSPGP,IBSM,FACTOR)
*
*. Update Sigma vector with diagonal terms for a given block
*     SVEC(IASPGP,IBSPGP) = SVEC(IASPGP,IBSPGP)
*                         + FACTOR*DIAG(IASPGP,IBSPGP)CVEC(IASPGP,IBSPGP)
* ========================
* General symmetry version
* ========================
*
* Jeppe Olsen and Giovanni Li Manni, September 2011
*
* I12 = 1 => only one-body part
*     = 2 =>      one+two-body part
      IMPLICIT REAL*8           (A-H,O-Z)
*. Input
      DIMENSION NSSOA(NSMST,*), NSSOB(NSMST,*)
      DIMENSION H(NORB)
      DIMENSION CVEC(*)
*. Scratch
      DIMENSION RJ(NTOOB,NTOOB),RK(NTOOB,NTOOB)
      DIMENSION XA(NORB),XB(NORB),SCR(2*NORB)
      DIMENSION IASTR(NAEL,*),IBSTR(NBEL,*)
      DIMENSION RJKAA(*)
      DIMENSION IDUM(1)
*. Output
      DIMENSION SVEC(*)
*
      NTEST =  00
      NTEST = MAX(NTEST,IPRNT)
      IDUM(1) = 0
      I12 = 2
c      IF(LUIN.GT.0) REWIND LUIN
c      IF(LUOUT.GT.0) REWIND LUOUT

      IF( NTEST .GE. 20 ) THEN
        WRITE(6,*) ' ======================= '
        WRITE(6,*) ' ADDDIA_TERMS in action '
        WRITE(6,*) ' ======================= '
        WRITE(6,*)
        WRITE(6,*) ' IASM, IASPGP, IBSM, IBSPGP = ',
     &               IASM, IASPGP, IBSM, IBSPGP
      END IF
*
      IF(NTEST.GE.1000) THEN
        WRITE(6,*) ' Diagonal one electron integrals'
        CALL WRTMAT(H,1,NORB,1,NORB)
        IF(I12.EQ.2) THEN
          WRITE(6,*) ' Coulomb and exchange integrals '
          CALL WRTMAT(RJ,NORB,NORB,NTOOB,NTOOB)
          WRITE(6,*)
          CALL WRTMAT(RK,NORB,NORB,NTOOB,NTOOB)
        END IF
        WRITE(6,*) ' FACTOR = ',FACTOR
      END IF
*
**3 Diagonal elements according to Handys formulae
*   (corrected for error)
*
*   DIAG(IDET) = HII*(NIA+NIB)
*              + 0.5 * ( J(I,J)-K(I,J) ) * N(I,A)*N(J,A)
*              + 0.5 * ( J(I,J)-K(I,J) ) * N(I,B)*N(J,B)
*              +         J(I,J) * N(I,A)*N(J,B)
* N(X) are occupation numbers
*
*. K goes to J - K
      IF(I12.EQ.2) CALL VECSUM(RK,RK,RJ,-1.0D0,+1.0D0,NTOOB **2)
*
*. Construct array RJKAA(*) =   SUM(I) H(I)*N(I) +
*                           0.5*SUM(I,J) ( J(I,J) - K(I,J))*N(I)*N(J)
*
*. Obtain alpha strings of sym IASM and type IASPGP
      CALL GETSTR_TOTSM_SPGP(1,IASPGP,IASM,NAEL,NASTR1,IASTR,
     &                         NORB,0,IDUM,IDUM)
*
      NIA = NSSOA(IASM,IASPGP)
*
      IF(NTEST.GE.1000) THEN
        write(6,*) ' After GETSTR for A strings '
        WRITE(6,*) ' alpha strings obtained '
        CALL IWRTMA(IASTR,NAEL,NIA,NAEL,NIA)
      END IF
*
      DO IA = 1 ,NIA
        EAA = 0.0D0
        DO IEL = 1, NAEL
          IAEL = IASTR(IEL,IA)
          EAA = EAA + H(IAEL)
          IF(I12.EQ.2) THEN
            DO JEL = 1, NAEL
              EAA =   EAA + 0.5D0*RK(IASTR(JEL,IA),IAEL )
            END DO
          END IF
        END DO
        RJKAA(IA) = EAA
      END DO
*. Obtain alpha strings of sym IBSM and type IBTP
      CALL GETSTR_TOTSM_SPGP(2,IBSPGP,IBSM,NBEL,NBSTR1,IBSTR,
     &                       NORB,0,IDUM,IDUM)
      NIB =  NSSOB(IBSM,IBSPGP)
      IDET = 0
      DO IB = 1 ,NIB
*. Terms depending only on IB
        HB = 0.0D0
        RJBB = 0.0D0
        CALL SETVEC(XB,0.0D0,NORB)

        DO IEL = 1, NBEL
          IBEL = IBSTR(IEL,IB)
          HB = HB + H(IBEL )
*
          IF(I12.EQ.2) THEN
            DO JEL = 1, NBEL
              RJBB = RJBB + RK(IBSTR(JEL,IB),IBEL )
            END DO
*
            DO IORB = 1, NORB
              XB(IORB) = XB(IORB) + RJ(IORB,IBEL)
            END DO
          END IF
        END DO

        EB = HB + 0.5D0*RJBB + ECORE
        DO IA = 1,NSSOA(IASM,IASPGP)
          IDET = IDET + 1
          X = EB + RJKAA(IA)
          DO IEL = 1, NAEL
            X = X +XB(IASTR(IEL,IA))
          END DO
          SVEC(IDET) = SVEC(IDET) + CVEC(IDET)*(X+FACTOR)
        END DO ! IA
      END DO ! IB
*
      IF(NTEST.GE.1000) THEN
        WRITE(6,*) ' Input and output vectord, ADDDIA_TERMS '
        CALL WRTMAT(CVEC,1,IDET,1,IDET)
        CALL WRTMAT(SVEC,1,IDET,1,IDET)
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_real_array(XA)
        CALL Unused_real_array(SCR)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Martin Schuetz                                   *
*               2017, Roland Lindh                                     *
*               2018, Ignacio Fdez. Galvan                             *
************************************************************************
      SubRoutine SOrUpV(NoAllo,V,HDiag,lvec,W,Mode,UpTp)
************************************************************************
*     for Ref., see T.H. Fischer and J. Almloef, JPC 96, 9768 (1992)   *
*               doi:10.1021/j100203a036                                *
*                                                                      *
*     purpose: Second Order Updated vector V using BFGS and            *
*              diagonal Hessian of Orbital Rotations                   *
*     input  : NoAllo     -> this routine tries to allocate memory     *
*                to construct linked lists, so you have to tell, how   *
*                much you want to keep for your own purpose...         *
*              for all procedure parameters, iad prefix means the      *
*              address of the var on Work Array                        *
*              V          -> input vector                              *
*              HDiag      -> initial diagonal Hessian                  *
*              lvec       -> lengths of vectors delta, grad, HDiag & V *
*              Mode       -> update mode, see below                    *
*     The routine expects, that grad(n) and delta(n-1) are already     *
*     stored on the appropriate linked lists LLGrad & LLDelt.          *
*     output:  W          -> H(n)V with H(n) SOrUp (inverse) Hessian   *
*                            after n-1 updates                         *
*                            mem has to be allocated from caller side  *
*                                                                      *
*     called from: WfCtl_SCF, iErrV                                    *
*                                                                      *
*     calls to: uses SubRoutines and Functions from Module lnklst.f    *
*               -linked list implementation to store series of vectors *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1994                                 *
*                                                                      *
*     Adapted to work both for d=-H(-1)g and g = -Hd                   *
*     depending on the value of MODE                                   *
*     Mode='DISP':  d=-H(-1)g    BFGS update for the inverse Hessian   *
*     Mode='GRAD':  g=-Hd        DFP  update for the Hessian           *
*     2017, Roland Lindh, Harvard, Cambridge                           *
*                                                                      *
*     Adapted to do both BFGS and DFP updates depending on the value   *
*     of UPTP                                                          *
*     UpTp='BFGS':  BFGS update                                        *
*     UpTp='DFP ':  DFP update                                         *
*     Mode='DISP':  d=-H(-1)g    update for the Hessian                *
*     Mode='GRAD':  g=-Hd        update for the inverse Hessian        *
*     2018, Ignacio Fdez. Galvan                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "file.fh"
#include "llists.fh"
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
*     only tentatively this inc file
#include "infso.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
*
*     declaration subroutine parameters
      Integer NoAllo,lvec
      Real*8 W(lVec), HDiag(lVec), V(lvec)
      Character*4 Mode, UpTp
*
*     declaration local variables
      Character*8 Mode_Old
      Save Mode_Old
      Integer ipdel,ipdgd,ipynm1
      Integer i,it,inode,leny
      Logical updy
      Real*8 S(6),T(4)
*     declarations of functions
      Integer LstPtr
      real*8 ddot_
      Real*8 Cpu1,Tim1,Tim2,Tim3
      Real*8, Dimension(:), Allocatable:: SOGrd, SODel, SOScr
      Logical Inverse_H
*
      Call Timing(Cpu1,Tim1,Tim2,Tim3)
      nD = iUHF + 1
      Thr=1.0D-9
*
*     Dummy initializations
*
      Inverse_H=.False.
      Lu1=-1
      LL1=-1
      Lu2=-1
      LL2=-1
*
*     This section will control the mode
*
      If (Mode.eq.'DISP') Then
*
*        Mode for computation d = -H(-1)g
*
         Inverse_H=.True.
         Lu1=LuDel
         LL1=LLDelt
         Lu2=LudGd
         LL2=LLdGrd
*
      Else If (Mode.eq.'GRAD') Then
*
*        Mode for computation g = -Hd
*
         Inverse_H=.False.
         Lu1=LudGd
         LL1=LLdGrd
         Lu2=LuDel
         LL2=LLDelt
*
      End If
*
      If (Lu1.lt.0) Then
         Write (6,*) 'SOrUpV: Illegal mode'
         Call Abend()
      End If
*
      If ((UpTp.ne.'BFGS').and.(UpTp.ne.'DFP ')) Then
         Write (6,*) 'SOrUpV: Illegal update type',UpTp
         Call Abend()
      End If
*
      If (iterso.gt.1.AND.Mode//UpTp.ne.Mode_Old) Then
         Write (6,*) 'SOrUpV: Illegal mode switch'
         Call Abend()
      End If
*
*     Steps denoted as in the reference paper!
*
*     (1): initialize w=HDiag*v
*
      Do i=1,lvec
         If (Inverse_H) Then
            If (Abs(HDiag(i)).lt.Thr) Then
               W(i)=1.0D2*V(i)
            Else
               W(i)=V(i)/HDiag(i)
            End If
         Else
            W(i)=HDiag(i)*V(i)
         End If
      End Do
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt('SORUPV: v        ',' ',V,1,lvec)
      Call RecPrt('SORUPV: HDiag    ',' ',HDiag,1,lvec)
      If (Mode.eq.'DISP') Then
         Call RecPrt('SORUPV: W=HDiag(-1)*v',' ',W,1,lvec)
      Else
         Call RecPrt('SORUPV: W=HDiag*v',' ',W,1,lvec)
      End If
#endif

*define _DIAGONAL_ONLY_
#ifdef _DIAGONAL_ONLY_
      If (.True.) Then
         Write (6,*) ' SorUpV: Only diagonal approximation'
#else
      If (iterso.eq.1) Then
#endif
*        (2): no further work required this time
         Call Timing(Cpu2,Tim1,Tim2,Tim3)
         TimFld( 7) = TimFld( 7) + (Cpu2 - Cpu1)
         Mode_Old=Mode//UpTp
         Return
      End If
*
*     need three vectors of length lvec as scratch space
*
      Call mma_allocate(SOGrd,lvec,Label='SOGrd')
      Call mma_allocate(SODel,lvec,Label='SODel')
      Call mma_allocate(SOScr,lvec,Label='SOScr')
*
      Call GetNod(iter-1,LL2,inode)
      If (inode.eq.0) GoTo 555
      Call iVPtr(Lu2,SOGrd,lvec,inode)
*
*     (3b): initialize y(n-1)=HDiag*dGrd(n-1) ...
*
      Do i=1,lvec
        If (Inverse_H) Then
           If (Abs(HDiag(i)).lt.Thr) Then
              SOScr(i)=1.0D2*SOGrd(i)
           Else
              SOScr(i)=SOGrd(i)/HDiag(i)
           End If
        Else
           SOScr(i)=HDiag(i)*SOGrd(i)
        End If
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('Init y(n-1)',' ',SOScr,1,lVec)
#endif
*
*     and store it on appropriate linked list
*
      leny=LLLen(LLy)
      Call PutVec(SOScr,lvec,Luy,iter-1,NoAllo,'NOOP',LLy)
      If (leny.eq.LLLen(LLy)) Then
*        already there, so we don't have to recalculate later
         updy=.False.
      Else
*        new listhead generated in ipy, we have to update
         updy=.True.
      End If
*
*     (4): now loop over 1..n-2 iterations.
*
      Do it=iter-iterso+1,iter-2
*
*        fetch delta(i), dGrd(i) and y(i) from corresponding LLists
*
         Call GetNod(it,LL1,inode)
         If (inode.eq.0) GoTo 555
         Call iVPtr(Lu1,SODel,lvec,inode)
*
         Call GetNod(it,LL2,inode)
         If (inode.eq.0) GoTo 555
         Call iVPtr(Lu2,SOGrd,lvec,inode)
*
         Call GetNod(it,LLy,inode)
         If (inode.eq.0) GoTo 555
         Call iVPtr(Luy,SOScr,lvec,inode)
*
*        calculate S_k and T_k dot products.
*        (note that S(2) is the inverse of the one in the paper
*
         S(1)=ddot_(lvec,SODel,1,SOGrd,1)
         If (Abs(S(1)).lt.Thr) Then
            S(1)=Zero
            !S(1)=One/Thr
         Else
            S(1)=One/S(1)
         End If
         S(2)=ddot_(lvec,SOGrd,1,SOScr,1)
         S(3)=ddot_(lvec,SODel,1,V,1)
         S(4)=ddot_(lvec,SOScr,1,V,1)
         If (updy) Then
*
*           here we have to reload dGrd(n-1) from llist, but this
*           for sure is a memory hit, since it was put there last
*
            ipdgd=LstPtr(Lu2,iter-1,LL2)
*
            S(5)=ddot_(lvec,SODel,1,Work(ipdgd),1)
            S(6)=ddot_(lvec,SOScr,1,Work(ipdgd),1)
         Else
            S(5)=Zero
            S(6)=Zero
         End If
#ifdef _DEBUGPRINT_
         Write (6,*) 'it=',it
         Write (6,*) '(S(i),i=1,6)=',(S(i),i=1,6)
#endif
*
         If ((Mode_Old.eq.'DISPBFGS').or.
     &       (Mode_Old.eq.'GRADDFP ')) Then
            If (Abs(S(2)).lt.Thr) Then
               S(2)=One
               !S(2)=One+S(1)/Thr
            Else
               S(2)=One+S(1)*S(2)
            End If
            T(2)=S(1)*S(3)
            T(4)=S(1)*S(5)
            T(1)=S(2)*T(2)-S(1)*S(4)
            T(3)=S(2)*T(4)-S(1)*S(6)
         Else If ((Mode_Old.eq.'DISPDFP ').or.
     &            (Mode_Old.eq.'GRADBFGS')) Then
*           DFP update (or BFGS for the Hessian) use
*           a slightly different and simpler formula
            If (Abs(S(2)).lt.Thr) Then
               S(2)=Zero
               S(2)=One/Thr
            Else
               S(2)=One/S(2)
            End If
            T(1)=S(1)*S(3)
            T(2)=S(2)*S(4)
            T(3)=S(1)*S(5)
            T(4)=S(2)*S(6)
         End If
*
*        Compute w and y(n-1)
*
#ifdef _DEBUGPRINT_
         Write (6,*) '(T(i),i=1,4)=',(T(i),i=1,4)
#endif
         Call daxpy_(lvec, T(1),SODel,1,W,1)
         Call daxpy_(lvec,-T(2),SOScr,1,W,1)
         If (updy) Then
*
*           here we have to reload y(n-1) from llist, but this
*           for sure is a memory hit, since it was put there last
*           -> we operate directly on the memory cells of the LList,
*           where y(n-1) resides.
*
            ipynm1=LstPtr(Luy,iter-1,LLy)
            Call daxpy_(lvec, T(3),SODel,1,Work(ipynm1),1)
            Call daxpy_(lvec,-T(4),SOScr,1,Work(ipynm1),1)
         End If
*
      End Do
*
*     (5): reload y(n-1), delta(n-1) & dGrd(n-1) from linked list.
*     these all are memory hits, of course
*
      ipynm1=LstPtr(Luy,iter-1,LLy)
      ipdel =LstPtr(Lu1,iter-1,LL1)
      ipdgd =LstPtr(Lu2,iter-1,LL2)
#ifdef _DEBUGPRINT_
      Call RecPrt('y(n-1)',' ',Work(ipynm1),1,lVec)
      If (Mode.eq.'DISP') Then
         Call RecPrt('dX(n-1)',' ',Work(ipdel),1,lVec)
         Call RecPrt('dg(n-1)',' ',Work(ipdgd),1,lVec)
      Else
         Call RecPrt('dg(n-1)',' ',Work(ipdel),1,lVec)
         Call RecPrt('dX(n-1)',' ',Work(ipdgd),1,lVec)
      End If
#endif
*
*     calculate diverse dot products...
*
      S(1)=ddot_(lvec,Work(ipdel),1,Work(ipdgd),1)
      If (Abs(S(1)).lt.Thr) Then
         S(1)=Zero
         !S(1)=One/Thr
      Else
         S(1)=One/S(1)
      End If
      S(2)=ddot_(lvec,Work(ipdgd),1,Work(ipynm1),1)
      S(3)=ddot_(lvec,Work(ipdel),1,V,1)
      S(4)=ddot_(lvec,Work(ipynm1),1,V,1)
#ifdef _DEBUGPRINT_
      Write (6,*) '(S(i),i=1,4)=',(S(i),i=1,4)
#endif
      If ((Mode_Old.eq.'DISPBFGS').or.
     &    (Mode_Old.eq.'GRADDFP ')) Then
         If (Abs(S(2)).lt.Thr) Then
            S(2)=One
            !S(2)=One+S(1)/Thr
         Else
            S(2)=One+S(1)*S(2)
         End If
         T(2)=S(1)*S(3)
         T(1)=S(2)*T(2)-S(1)*S(4)
      Else If ((Mode_Old.eq.'DISPDFP ').or.
     &         (Mode_Old.eq.'GRADBFGS')) Then
         If (Abs(S(2)).lt.Thr) Then
            S(2)=Zero
            S(2)=One/Thr
         Else
            S(2)=One/S(2)
         End If
         T(1)=S(1)*S(3)
         T(2)=S(2)*S(4)
      End If
*
*     update the vector w
*
#ifdef _DEBUGPRINT_
      Write (6,*) '(T(i),i=1,2)=',(T(i),i=1,2)
#endif
      Call daxpy_(lvec, T(1),Work(ipdel),1,W,1)
      Call daxpy_(lvec,-T(2),Work(ipynm1),1,W,1)
#ifdef _DEBUGPRINT_
      Call RecPrt('The final W array',' ',W,1,lVec)
#endif
*
*     so, we've made it, let's clean up workbench
*
      Call mma_deallocate(SOGrd)
      Call mma_deallocate(SODel)
      Call mma_deallocate(SOScr)
*
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld( 7) = TimFld( 7) + (Cpu2 - Cpu1)
      Return
*
*-----Error handling
*
*     Hmmm, no entry found in LList, that's strange
 555  Write (6,*) 'SOrUpV: no entry found in LList'
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_VecBuf_PrtRef(Txt)
!
! Thomas Bondo Pedersen, September 2012.
!
! Print reference norm and sum of vectors in buffer.
! Txt is printed along with the reference values (for
! identification).

use Cholesky, only: CHVBFI, InfVec, ip_CHVBFI_SYM, LuPri, nDimRS, nSym, nVec_in_Buf
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: Txt
integer(kind=iwp) :: iSym, jRed, jVec, nDim

if (.not. allocated(nDimRS)) call Cho_Quit('Cho_VecBuf_PrtRef: unable to print reference values',104)
if (allocated(CHVBFI)) then
  do iSym=1,nSym
    do jVec=1,nVec_in_Buf(iSym)
      jRed = InfVec(jVec,2,iSym)
      nDim = nDimRS(iSym,jRed)
      write(LuPri,'(A,A,I6,A,I2,A,I9,2(A,ES25.16))') Txt,' Cholesky vector',jVec,' sym.',iSym,' dim.',nDim,'  Norm=', &
                                                     CHVBFI(1,ip_ChVBfI_Sym(iSym)+jVec),' Sum=',CHVBFI(2,ip_ChVBfI_Sym(iSym)+jVec)
    end do
  end do
else
  write(LuPri,'(A,A)') Txt,' Cho_VecBuf_PrtRef: no reference values available!'
end if

end subroutine Cho_VecBuf_PrtRef

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,2006, Per Ake Malmqvist                           *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
* 2006  PER-AAKE MALMQUIST                   *
*--------------------------------------------*
      SUBROUTINE GINIT_CP2
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "WrkSpc.fh"
#include "pt2_guga.fh"
#include "segtab.fh"


C SET UP A FULL PALDUS DRT TABLE:
      IB0=ISPIN-1
      IA0=(NACTEL-IB0)/2
      IC0=NLEV-IA0-IB0
      IF ((2*IA0+IB0).NE.NACTEL) GOTO 9001
      IF((IA0.LT.0).OR.(IB0.LT.0).OR.(IC0.LT.0)) GOTO 9001
      IAC=MIN(IA0,IC0)
      NVERT0=((IA0+1)*(IC0+1)*(2*IB0+IAC+2))/2-(IAC*(IAC+1)*(IAC+2))/6
      NDRT0=5*NVERT0
      NDOWN0=4*NVERT0
      CALL GETMEM('DRT0','ALLO','INTEGER',LDRT0,NDRT0)
      CALL GETMEM('DOWN0','ALLO','INTEGER',LDOWN0,NDOWN0)
      NVCD=((NLEV+1)*(NLEV+2))/2
      CALL GETMEM('VCD','ALLO','INTEGER',LVCD,NVCD)
      CALL DRT0_CP2(IA0,IB0,IC0,NVERT0,IWORK(LDRT0),IWORK(LDOWN0),
     &           NVCD,IWORK(LVCD))
      CALL GETMEM('VCD','FREE','INTEGER',LVCD,NVCD)
#ifdef _DEBUGPRINT_
      WRITE(6,*)
      WRITE(6,*)' PALDUS DRT TABLE (UNRESTRICTED):'
      CALL PRDRT_CP2(NVERT0,IWORK(LDRT0),IWORK(LDOWN0))
#endif
      LDRT=LDRT0
      NDRT=NDRT0
      LDOWN=LDOWN0
      NDOWN=NDOWN0
      NVERT=NVERT0
C RESTRICTIONS?
      IF((NRAS1T+NRAS3T).NE.0) THEN
C  CONSTRUCT A RESTRICTED GRAPH.
        CALL GETMEM('VERT','ALLO','INTEG',LV,NVERT0)
        LV1RAS=NRAS1T
        LV3RAS=LV1RAS+NRAS2T
        LM1RAS=2*LV1RAS-NHOLE1
        LM3RAS=NACTEL-NELE3
        CALL RESTR_RPT2(LV1RAS,LM1RAS,LV3RAS,LM3RAS,
     &              IWORK(LDRT0),IWORK(LDOWN0),IWORK(LV))
        NDRT=5*NVERT
        NDOWN=4*NVERT
        CALL GETMEM('DRT','ALLO','INTEG',LDRT,NDRT)
        CALL GETMEM('DOWN','ALLO','INTEG',LDOWN,NDOWN)
        CALL DRT_RPT2(IWORK(LDRT0),IWORK(LDOWN0),IWORK(LV),
     &             IWORK(LDRT),IWORK(LDOWN))
        CALL GETMEM('VERT','FREE','INTEG',LV,NVERT0)
        CALL GETMEM('DRT0','FREE','INTEG',LDRT0,NDRT0)
        CALL GETMEM('DOWN0','FREE','INTEG',LDOWN0,NDOWN0)
#ifdef _DEBUGPRINT_
        WRITE(6,*)
        WRITE(6,*)' PALDUS DRT TABLE (RESTRICTED):'
        CALL PRDRT_CP2(NVERT,IWORK(LDRT),IWORK(LDOWN))
#endif
      END IF
C CALCULATE DIRECT ARC WEIGHT AND LTV TABLES.
      NDAW=5*NVERT
      CALL GETMEM('DAW','ALLO','INTEG',LDAW,NDAW)
      NLTV=NLEV+2
      CALL GETMEM('LTV','ALLO','INTEG',LLTV,NLTV)
      CALL MKDAW_CP2(IWORK(LDRT),IWORK(LDOWN),IWORK(LDAW),IWORK(LLTV))
C UPCHAIN INDEX TABLE:
      NUP=4*NVERT
      CALL GETMEM('UP','ALLO','INTEG',LUP,NUP)
C REVERSE ARC WEIGHT TABLE:
      NRAW=5*NVERT
      CALL GETMEM('RAW','ALLO','INTEG',LRAW,NRAW)
C DECIDE MIDLEV AND CALCULATE MODIFIED ARC WEIGHT TABLE.
      NMAW=4*NVERT
      CALL GETMEM('MAW','ALLO','INTEG',LMAW,NMAW)
      CALL MKMAW_CP2(IWORK(LDOWN),IWORK(LDAW),IWORK(LUP),IWORK(LRAW),
     &           IWORK(LMAW),IWORK(LLTV))
C THE DAW, UP AND RAW TABLES WILL NOT BE NEEDED ANY MORE:
      CALL GETMEM('DAW','FREE','INTEG',LDAW,NDAW)
      CALL GETMEM('UP','FREE','INTEG',LUP,NUP)
      CALL GETMEM('RAW','FREE','INTEG',LRAW,NRAW)
C CALCULATE SEGMENT VALUES. ALSO, MVL AND MVR TABLES.
      NIVR=2*NVERT
      CALL GETMEM('IVR','ALLO','INTEG',LIVR,NIVR)
      NMVL=2*NMIDV
      NMVR=2*NMIDV
      CALL GETMEM('MVL','ALLO','INTEG',LMVL,NMVL)
      CALL GETMEM('MVR','ALLO','INTEG',LMVR,NMVR)
      NSGMNT=26*NVERT
      CALL GETMEM('ISGM','ALLO','INTEG',LISGM,NSGMNT)
      CALL GETMEM('VSGM','ALLO','REAL',LVSGM,NSGMNT)
      CALL MKSEG_CP2(IWORK(LDRT),IWORK(LDOWN),IWORK(LLTV),IWORK(LIVR),
     &           IWORK(LMVL),IWORK(LMVR),IWORK(LISGM),WORK(LVSGM))
      CALL GETMEM('DOWN','FREE','INTEG',LDOWN,NDOWN)
      CALL GETMEM('LTV','FREE','INTEG',LLTV,NLTV)
C FORM VARIOUS OFFSET TABLES:
      NNOW=2*NMIDV*NSYM
      NIOW=NNOW
      CALL GETMEM('NOW','ALLO','INTEG',LNOW,NNOW)
      CALL GETMEM('IOW','ALLO','INTEG',LIOW,NIOW)
      MXEO=(NLEV*(NLEV+5))/2
      NNOCP=MXEO*NMIDV*NSYM
      NIOCP=NNOCP
      NNRL=(1+MXEO)*NVERT*NSYM
      CALL GETMEM('NOCP','ALLO','INTEG',LNOCP,NNOCP)
      CALL GETMEM('IOCP','ALLO','INTEG',LIOCP,NIOCP)
      CALL GETMEM('NRL','ALLO','INTEG',LNRL,NNRL)
      NNOCSF=NMIDV*(NSYM**2)
      NIOCSF=NNOCSF
C NIPWLK: NR OF INTEGERS USED TO PACK EACH UP- OR DOWNWALK.
      NIPWLK=1+(MIDLEV-1)/15
      NIPWLK=MAX(NIPWLK,1+(NLEV-MIDLEV-1)/15)
      CALL GETMEM('NOCSF','ALLO','INTEG',LNOCSF,NNOCSF)
      CALL GETMEM('IOCSF','ALLO','INTEG',LIOCSF,NIOCSF)
      CALL NRCOUP_CP2(IWORK(LDRT),IWORK(LISGM),IWORK(LNOW),
     &            IWORK(LIOW),IWORK(LNOCP),IWORK(LIOCP),IWORK(LNOCSF),
     &            IWORK(LIOCSF),IWORK(LNRL),IWORK(LMVL),IWORK(LMVR))
      CALL GETMEM('DRT','FREE','INTEG',LDRT,NDRT)
      CALL GETMEM('NRL','FREE','INTEG',LNRL,NNRL)
      NILNDW=NWALK
      NICASE=NWALK*NIPWLK
      CALL GETMEM('ICASE','ALLO','INTEG',LICASE,NICASE)
      NNICOUP=3*NICOUP
      CALL GETMEM('ICOUP','ALLO','INTEG',LICOUP,NNICOUP)
      NVTAB_TMP=20000
      CALL GETMEM('VTAB_TMP','ALLO','REAL',LVTAB_TMP,NVTAB_TMP)
      NSCR=7*(NLEV+1)
      CALL GETMEM('ILNDW','ALLO','INTEG',LILNDW,NILNDW)
      CALL GETMEM('SCR','ALLO','INTEG',LSCR,NSCR)
      CALL GETMEM('VAL','ALLO','REAL',LVAL,NLEV+1)
      CALL MKCOUP_CP2(IWORK(LIVR),IWORK(LMAW),IWORK(LISGM),
     &            WORK(LVSGM),IWORK(LNOW),IWORK(LIOW),IWORK(LNOCP),
     &     IWORK(LIOCP),IWORK(LILNDW),IWORK(LICASE),IWORK(LICOUP),
     &     NVTAB_TMP,WORK(LVTAB_TMP),NVTAB_FINAL,IWORK(LSCR),
     &     WORK(LVAL))
* Set NVTAB in common block /IGUGA/ in file pt2_guga.fh:
      NVTAB=NVTAB_FINAL
      CALL GETMEM('VTAB','ALLO','REAL',LVTAB,NVTAB)
      CALL DCOPY_(NVTAB,WORK(LVTAB_TMP),1,WORK(LVTAB),1)
      CALL GETMEM('VTAB_TMP','FREE','REAL',LVTAB_TMP,NVTAB_TMP)
      CALL GETMEM('ILNDW','FREE','INTEG',LILNDW,NILNDW)
      CALL GETMEM('SCR','FREE','INTEG',LSCR,NSCR)
      CALL GETMEM('VAL','FREE','REAL',LVAL,NLEV+1)
      CALL GETMEM('ISGM','FREE','INTEG',LISGM,NSGMNT)
      CALL GETMEM('VSGM','FREE','REAL',LVSGM,NSGMNT)
      CALL GETMEM('MAW','FREE','INTEG',LMAW,NMAW)
      CALL GETMEM('IVR','FREE','INTEG',LIVR,NIVR)


      RETURN
 9001 WRITE(6,*)' ERROR IN SUBROUTINE GINIT.'
      WRITE(6,*)'  NR OF ACTIVE ORBITALS:',NLEV
      WRITE(6,*)' NR OF ACTIVE ELECTRONS:',NACTEL
      WRITE(6,*)'        SPIN DEGENERACY:',ISPIN
      CALL ABEND()
      END

#ifdef _DEBUGPRINT_
      SUBROUTINE PRDRT_CP2(NVERT,DRT,DOWN)
      IMPLICIT NONE
      INTEGER NVERT,DRT(NVERT,5),DOWN(NVERT,0:3)
      INTEGER I,S,V
      WRITE(6,*)
      WRITE(6,*)' VERT      L  N    A  B  C      CHAINING INDICES.'
      DO V=1,NVERT
        WRITE(6,'(1X,I4,5X,2I3,2X,3I3,5X,4I4)')
     &                         V,(DRT(V,I),I=1,5),(DOWN(V,S),S=0,3)
      END DO
      WRITE(6,*)
      RETURN
      END
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ColChg(q,QMAX,QMIN,C1,C2,C3)

use Constants, only: Zero, Half
use Definitions, only: wp, u6

implicit none
real(kind=wp), intent(in) :: q, QMAX, QMIN
real(kind=wp), intent(out) :: C1, C2, C3
real(kind=wp) :: DNeg, DPos
character(len=20) :: Colour

! Assign tesserae colours for GeomView:

DPos = QMax*Half
DNeg = QMin*Half
! Total charge density < 0
if (q < DNeg) then
  Colour = 'Dark Blue'
else if (q < Zero) then
  Colour = 'Light Blue'
! Total charge density > 0
else if (q < DPos) then
  Colour = 'Pink'
else
  Colour = 'Red'
end if
call ColTss(u6,Colour,C1,C2,C3)

return

end subroutine ColChg

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cRdMCK(rc,Option,InLab,iComp,cData,iSymLab)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp), intent(in) :: Option, iComp, iSymLab
character(len=*), intent(inout) :: InLab
character, intent(_OUT_) :: cData(*)

call cRdMCK_Internal(cData)

! This is to allow type punning without an explicit interface
contains

subroutine cRdMCK_Internal(cData)

  character, target, intent(_OUT_) :: cData(*)
  integer(kind=iwp), pointer :: iData(:)

  call c_f_pointer(c_loc(cData(1)),iData,[1])
  call RdMCK(rc,Option,InLab,iComp,iData,iSymLab)
  nullify(iData)

  return

end subroutine cRdMCK_Internal

end subroutine cRdMCK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2026, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DERE4(NLEV,iSym0,NASA,NASC,NCONF,BDERA,BDERC,Clag)

use Index_Functions, only: nTri_Elem
use BDerNEV, only: Gact, Gder
use caspt2_global, only: IDTCEX, iPrGlb, LUCIEX
use caspt2_module, only: JSTATE, MXCI, NACTEL, NSYM, STSYM
use sguga, only: CIS, EXS, SGS
use NEVPT2_E4, only: do_xvec, do_yvec, ixyzend, ixyzsta, NEVPT2_E4_derivative1, NEVPT2_E4_derivative2, NEVPT2_E4_derivative3, &
                     NEVPT2_E4_XYder1, NEVPT2_E4_XYder2, NEVPT2_E4_XYVEC, NEVPT2_E4_ZVEC, NXY_work, NXYVEC, nxyzdim, NZVEC
use PrintLevel, only: verbose
use Symmetry_Info, only: Mul
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(in) :: NLEV, iSym0, NASA, NASC, NCONF
real(kind=wp), intent(in) :: BDERA(NASA,NASA), BDERC(NASC,NASC)
real(kind=wp), intent(inout) :: CLag(nconf)
integer(kind=iwp) :: I, IALEV, IBLEV, IDCI, IDX, IP1, IP2, IP3, IP4, IPXYEND, IPXYSTA, ISAB, ISSG1, ISSG2, ISSG3, ISSG4, ISTU, &
                     ISVX, iSym, ISYZ, ITLEV, IULEV, IVLEV, IXLEV, ixy_local, IYLEV, IZLEV, J, JDX, MEMMAX, MEMMAX_SAFE, &
                     memory_per_xy, memory_per_xy2, memory_per_z, NCI, NLEV2, NSGM1, NSGM2, NSGM3, NSGM4, NTRI1
real(kind=wp) :: cpe, cptf0, cptf10, cput, tioe, tiotf0, tiotf10, wallt
integer(kind=iwp), allocatable :: IJ2IDX(:,:), IDX2IJ(:,:)
real(kind=wp), allocatable :: BUF2(:,:), BUFT(:), CI(:), XYcont(:,:,:), XYcontder(:,:,:), XYDER(:,:,:), XYtmp(:,:,:), &
                              XYVEC(:,:,:), ZDER(:,:), ZVEC(:,:)

! translation tables for levels i,j to and from pair indices idx: IJ2IDX, IDX2IJ
! result buffer, maximum size is the largest possible ip1 range,
! which is set to nbuf1 later, i.e. a maximum of nlev2 <= mxlev**2

! Note
! If RAS, computing E_tu|Psi> for t > u is wrong?
! sigma1 with t > u can be called, but it is used only for <Psi|Eut, then u < t
! only lowering operation is permitted

if (nlev == 0) return
if (NACTEL == 0) return

NCI = CIS%NCSF(STSYM)
! This should not happen, but...
if (NCI == 0) return

! Here, for regular CAS or RAS cases.

call mma_allocate(IJ2IDX,nLev,nLev,Label='IJ2IDX')
call mma_allocate(IDX2IJ,2,nLev**2,Label='IDX2IJ')
IJ2IDX(:,:) = -1
IDX2IJ(:,:) = -1

! Special pair index idx2ij allows true RAS cases to be handled:
nlev2 = nlev**2
ntri1 = nTri_Elem(nlev-1)
!ntri2 = nTri_Elem(nlev)
idx = 0
do i=1,nlev-1
  do j=i+1,nlev
    idx = idx+1
    ij2idx(i,j) = idx
    idx2ij(1,idx) = i
    idx2ij(2,idx) = j
    jdx = nlev2+1-idx
    ij2idx(j,i) = jdx
    idx2ij(1,jdx) = j
    idx2ij(2,jdx) = i
  end do
end do
do i=1,nlev
  idx = ntri1+i
  ij2idx(i,i) = idx
  idx2ij(1,idx) = i
  idx2ij(2,idx) = i
end do

! Dummy values necessary for fooling syntax checkers:
call mma_MaxDBLE(memmax)
! Use *almost* all remaining memory:
memmax_safe = int(real(memmax,kind=wp)*0.95_wp)

call mma_allocate(CI,NCONF,Label='CI')
IDCI = IDTCEX(JSTATE)
call DDAFILE(LUCIEX,2,CI,NCONF,IDCI)

call mma_allocate(BUFT,MXCI,LABEL='BUFT')
memmax_safe = memmax_safe-MXCI

! memory_min = NLEV2*2 ! allocated in XYder2

memory_per_z = mxci*2+nlev2
memory_per_xy = mxci*2+4*nlev2+2*nTri_Elem(nlev2)
memory_per_xy2 = mxci*4+4*nlev2+2*nTri_Elem(nlev2)
if (.false.) then ! maybe for RAS? idk
  NXY_work = 1
  NXYVEC = 0
  NZVEC = 1
else if (memmax_safe/(memory_per_z+memory_per_xy2) > nlev2) then
  !! sufficient memory strat: construct XVEC and YVEC simultaneously
  NXY_work = nlev
  NXYVEC = nlev2
  NZVEC = nlev2
  do_xvec = .true.
  do_yvec = .true.
else if (memmax_safe/(memory_per_z+memory_per_xy) > nlev2) then
  !! reasonable memory strat: construct XVEC and YVEC one by one
  NXY_work = nlev
  NXYVEC = nlev2
  NZVEC = nlev2
  do_xvec = .true.
  do_yvec = .false.
else if (memmax_safe/(memory_per_z+memory_per_xy) > nlev) then
  !! insufficient memory strat: batching
  NXY_work = max(1,min(nlev,memmax_safe/nlev/(memory_per_z+memory_per_xy)))
  !nxy_work = 3
  NXYVEC = NLEV*NXY_work
  NZVEC = NXYVEC
  do_xvec = .true.
  do_yvec = .false.
else
  write(u6,'(" Too little memory left for MKBNEVAC_E4.")')
  i = (memory_per_z+memory_per_xy)*nlev
  write(u6,'(" Requested memory  : ", i12," words")') i
  write(u6,'(" allocatable memory: ", i12," words")') memmax_safe
  i = i-memmax_safe
  write(u6,'(" Need an additional memory of ",i12," words")') i
  i = int(real(i*RtoB,kind=wp)*1.0e-6_wp,kind=iwp)+1
  write(u6,'(" Please increase MOLCAS_MEM by roughly ",i6," (MB)")') i
  call ABEND()
end if

call mma_allocate(ZVEC,MXCI,NZVEC,LABEL='ZVEC')
call mma_allocate(Zder,MXCI,NZVEC,LABEL='Zder')

if (do_xvec .and. do_yvec) then
  call mma_allocate(XYVEC,MXCI,NXYVEC,2,LABEL='XYVEC')
  call mma_allocate(XYder,MXCI,NXYVEC,2,LABEL='XYder')
else if (do_xvec .and. (.not. do_yvec)) then
  call mma_allocate(XYVEC,MXCI,NXYVEC,1,LABEL='XYVEC')
  call mma_allocate(XYder,MXCI,NXYVEC,1,LABEL='XYder')
end if

call mma_allocate(XYtmp,NXYVEC,NLEV2,2,LABEL='XYtmp')
call mma_allocate(XYcont,nxyvec,2,nlev2,LABEL='XYcont')
call mma_allocate(XYcontder,nxyvec,2,nTri_Elem(nlev2),LABEL='XYcontder')

if (iPrGlb >= VERBOSE) then
  write(u6,*)
  write(u6,'(2X,A)') 'Constructing E4 terms for NEVPT2'
  write(u6,'(2X,A,1X,I1)') 'Symmetry of B matrix:',iSym0
  write(u6,'(2X,A,F16.9,A)') ' memory available:   ',real(memmax*RtoB,kind=wp)*1.0e-9_wp,' GB'
  i = nconf+mxci+memory_per_xy2*nlev2+memory_per_z*nlev2
  write(u6,'(2X,A,F16.9,A)') ' memory sufficient:  ',real(i*RtoB,kind=wp)*1.0e-9_wp,' GB'
  i = nconf+mxci+memory_per_xy*nlev2+memory_per_z*nlev2
  write(u6,'(2X,A,F16.9,A)') ' memory reasonable:  ',real(i*RtoB,kind=wp)*1.0e-9_wp,' GB'
  i = nconf+mxci+memory_per_xy*nlev+memory_per_z*nlev
  write(u6,'(2X,A,F16.9,A)') ' memory insufficient:',real(i*RtoB,kind=wp)*1.0e-9_wp,' GB'
  write(u6,*)
  if (NXYVEC == 0) then
    write(u6,'(" (0) special case")')
  else if (do_xvec .and. do_yvec) then
    write(u6,'(" (1) memory sufficient strat")')
  else if (do_xvec) then
    if ((nxyvec == nlev2) .and. (nzvec == nlev2)) then
      write(u6,'(" (2) memory reasonable strat")')
    else
      write(u6,'(" (3) memory insufficient strat")')
    end if
  end if
  if (do_xvec .and. do_yvec) then
    i = nconf+mxci+memory_per_xy*nxyvec+memory_per_z*nzvec
  else if (do_xvec .and. (.not. do_yvec)) then
    i = nconf+mxci+memory_per_xy2*nxyvec+memory_per_z*nzvec
  end if
  write(u6,'(2X,A,F16.9,A)') ' memory allocated:   ',real(i*RtoB,kind=wp)*1.0e-9_wp,' GB'
  call mma_MaxDBLE(memmax)
  write(u6,'(2X,A,F16.9,A)') ' memory left     :   ',real(memmax*RtoB,kind=wp)*1.0e-9_wp,' GB'
  write(u6,'(2X," allocated/total Zvecs. : ",i3,"/",i3)') nzvec,nlev2
  write(u6,'(2X," allocated/total XYvecs.: ",i3,"/",i3)') nxyvec,nlev2
  call xflush(u6)
end if

call GASync()

if (NXYVEC > 0) then
  SymmetryLoop: do iSym=1,nSym !! Symmetry of CSF (I) for RI
    !! Stride loop of Z_{t,u}^I
    !! Construct Z_{t,u}^I for ixyzsta <= t <= ixyzend and 1 <= u <= NLEV
    XYvecLoop2: do ixy_local=1,NLEV,NXY_work
      ipxysta = 1
      ipxyend = NLEV2
      ixyzsta = ixy_local
      ixyzend = min(NLEV,ixyzsta-1+NXY_work)
      nxyzdim = ixyzend-ixyzsta+1
      if (iPrGlb >= VERBOSE) call TIMING(CPTF0,CPE,TIOTF0,TIOE)
      !! Construct ZVEC
      call NEVPT2_E4_ZVEC(NLEV,idx2ij,Gact,CI,ZVEC,XYVEC)
      !! Construct XVEC and YVEC
      call NEVPT2_E4_XYVEC(iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,ZVEC,XYVEC)
      if (iPrGlb >= VERBOSE) then
        call TIMING(CPTF10,CPE,TIOTF10,TIOE)
        CPUT = CPTF10-CPTF0
        WALLT = TIOTF10-TIOTF0
        write(u6,'(a,2f10.3)') ' AC_E4(1): CPU/WALL TIME=',cput,wallt
        call TIMING(CPTF0,CPE,TIOTF0,TIOE)
      end if
      !! Construct XYcont for X*E and Y*E
      call NEVPT2_E4_derivative1(iSym0,iSym,NLEV,idx2ij,ipxysta,ipxyend,BDERA,BDERC,XYcont)
      if (iPrGlb >= VERBOSE) then
        call TIMING(CPTF10,CPE,TIOTF10,TIOE)
        CPUT = CPTF10-CPTF0
        WALLT = TIOTF10-TIOTF0
        write(u6,'(a,2f10.3)') ' AC_E4(2): CPU/WALL TIME=',cput,wallt
        call TIMING(CPTF0,CPE,TIOTF0,TIOE)
      end if
      !! Construct XYcont and XYder for X*E*E and Y*E*E
      call NEVPT2_E4_derivative2(iSym0,iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,BDERA,BDERC,XYcont,XYcontder,XYder,ZVEC, &
                                 XYtmp)

      if (iPrGlb >= VERBOSE) then
        call TIMING(CPTF10,CPE,TIOTF10,TIOE)
        CPUT = CPTF10-CPTF0
        WALLT = TIOTF10-TIOTF0
        write(u6,'(a,2f10.3)') ' AC_E4(3): CPU/WALL TIME=',cput,wallt
        call TIMING(CPTF0,CPE,TIOTF0,TIOE)
      end if
      !! Construct XYder for X*E and Y*E
      call NEVPT2_E4_derivative3(iSym,NLEV,idx2ij,ipxysta,ipxyend,BUFT,CI,XYcont,XYder)
      if (iPrGlb >= VERBOSE) then
        call TIMING(CPTF10,CPE,TIOTF10,TIOE)
        CPUT = CPTF10-CPTF0
        WALLT = TIOTF10-TIOTF0
        write(u6,'(a,2f10.3)') ' AC_E4(4): CPU/WALL TIME=',cput,wallt
        call TIMING(CPTF0,CPE,TIOTF0,TIOE)
      end if
      !! Construct Zder from XYder
      call NEVPT2_E4_XYder1(iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,XYder,Gder,Zder)
      if (iPrGlb >= VERBOSE) then
        call TIMING(CPTF10,CPE,TIOTF10,TIOE)
        CPUT = CPTF10-CPTF0
        WALLT = TIOTF10-TIOTF0
        write(u6,'(a,2f10.3)') ' AC_E4(5): CPU/WALL TIME=',cput,wallt
        call TIMING(CPTF0,CPE,TIOTF0,TIOE)
      end if
      !! Complete CI and ERI derivatives of Zder
      call NEVPT2_E4_XYder2(iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,Gact,XYvec,XYder,XYcont,XYcontder,ZVEC,Zder,CLag,Gder, &
                            XYtmp)
      if (iPrGlb >= VERBOSE) then
        call TIMING(CPTF10,CPE,TIOTF10,TIOE)
        CPUT = CPTF10-CPTF0
        WALLT = TIOTF10-TIOTF0
        write(u6,'(a,2f10.3)') ' AC_E4(6): CPU/WALL TIME=',cput,wallt
        call TIMING(CPTF0,CPE,TIOTF0,TIOE)
      end if
      if (do_xvec .and. (.not. do_yvec)) then
        call TIMING(CPTF0,CPE,TIOTF0,TIOE)
        do_xvec = .false.
        do_yvec = .true.

        call NEVPT2_E4_ZVEC(NLEV,idx2ij,Gact,CI,ZVEC,XYVEC)
        call NEVPT2_E4_XYVEC(iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,ZVEC,XYVEC)
        call NEVPT2_E4_derivative1(iSym0,iSym,NLEV,idx2ij,ipxysta,ipxyend,BDERA,BDERC,XYcont)
        call NEVPT2_E4_derivative2(iSym0,iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,BDERA,BDERC,XYcont,XYcontder,XYder,ZVEC, &
                                   XYtmp)
        call NEVPT2_E4_derivative3(iSym,NLEV,idx2ij,ipxysta,ipxyend,BUFT,CI,XYcont,XYder)
        call NEVPT2_E4_XYder1(iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,XYder,Gder,Zder)
        call NEVPT2_E4_XYder2(iSym,NLEV,idx2ij,ij2idx,ipxysta,ipxyend,BUFT,CI,Gact,XYvec,XYder,XYcont,XYcontder,ZVEC,Zder,CLag, &
                              Gder,XYtmp)

        if (iPrGlb >= VERBOSE) then
          call TIMING(CPTF10,CPE,TIOTF10,TIOE)
          CPUT = CPTF10-CPTF0
          WALLT = TIOTF10-TIOTF0
          write(u6,'(a,2f10.3)') ' AC_E4(7): CPU/WALL TIME=',cput,wallt
        end if
        do_xvec = .true.
        do_yvec = .false.
      end if
    end do XYvecLoop2
  end do SymmetryLoop
else
  write(u6,*) 'notyet'
  call abend()
  !! least memory strategy: directly compute E*E*E*E
  call mma_deallocate(BUFT)
  call mma_allocate(BUFT,1,LABEL='BUFT')

  call mma_MaxDBLE(memmax)
  memmax_safe = int(real(memmax,kind=wp)*0.95_wp)
  if (memmax_safe/mxci <= 4) then
    write(u6,*) ' Too little memory left for MKBNEVAC_E4.'
    write(u6,*) ' Need at least 4 vector of length MXCI=',MXCI
    call ABEND()
  end if
  call mma_allocate(BUF2,MXCI,4,LABEL='BUF2')

  do ip4=1,nlev2
    ialev = idx2ij(1,ip4)
    iblev = idx2ij(2,ip4)
    isab = Mul(SGS%ism(ialev),SGS%ism(iblev))
    issg4 = Mul(isab,stsym)
    nsgm4 = CIS%ncsf(issg4)
    !ia = L2ACT(ialev)
    !ib = L2ACT(iblev)
    BUF2(1:nsgm4,4) = Zero
    call SG_Epq_Psi(SGS,CIS,EXS,IALEV,IBLEV,One,STSYM,CI,BUF2(:,4))
    do ip3=ip4,nlev2
      iylev = idx2ij(1,ip3)
      izlev = idx2ij(2,ip3)
      isyz = Mul(SGS%ism(iylev),SGS%ism(izlev))
      issg3 = Mul(isyz,issg4)
      nsgm3 = CIS%ncsf(issg3)
      !iy = L2ACT(iylev)
      !iz = L2ACT(izlev)
      BUF2(1:nsgm3,3) = Zero
      call SG_Epq_Psi(SGS,CIS,EXS,IYLEV,IZLEV,One,issg4,BUF2(:,4),BUF2(:,3))
      write(u6,'(a,2f10.3)') ' AC_E4(1): CPU/WALL TIME=',cput,wallt
    end do
    do ip2=ip3,nlev2
      ivlev = idx2ij(1,ip2)
      ixlev = idx2ij(2,ip2)
      isvx = Mul(SGS%ism(ivlev),SGS%ism(ixlev))
      issg2 = Mul(isvx,issg3)
      nsgm2 = CIS%ncsf(issg2)
      !iv = L2ACT(ivlev)
      !ix = L2ACT(ixlev)
      BUF2(1:nsgm2,2) = Zero
      call SG_Epq_Psi(SGS,CIS,EXS,IVLEV,IXLEV,One,issg3,BUF2(:,3),BUF2(:,2))
      do ip1=ip2,nlev2
        itlev = idx2ij(1,ip1)
        iulev = idx2ij(2,ip1)
        istu = Mul(SGS%ism(itlev),SGS%ism(iulev))
        issg1 = Mul(istu,issg2)
        nsgm1 = CIS%ncsf(issg1)
        !it = L2ACT(itlev)
        !iu = L2ACT(iulev)
        BUF2(1:nsgm1,1) = Zero
        call SG_Epq_Psi(SGS,CIS,EXS,ITLEV,IULEV,One,issg2,BUF2(:,2),BUF2(:,1))
      end do
    end do
  end do
end if

call mma_deallocate(BUFT)

call mma_deallocate(XYVEC,safe='*')
call mma_deallocate(XYtmp,safe='*')
call mma_deallocate(XYcont,safe='*')
call mma_deallocate(XYcontder,safe='*')

call mma_deallocate(XYDER,safe='*')
call mma_deallocate(ZVEC,safe='*')
call mma_deallocate(Zder,safe='*')

call mma_deallocate(CI)

call mma_deallocate(ij2idx)
call mma_deallocate(idx2ij)

return

end subroutine DERE4

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Eval_RMax(alpha,m,R_L)

use Constants, only: One, Ten, Half, Pi
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: Eval_RMax
real(kind=wp), intent(in) :: alpha, R_L
integer(kind=iwp), intent(in) :: m
real(kind=wp) :: Gmma, x, x_new
integer(kind=iwp) :: i

!write(u6,*) 'alpha,m,R_L=',alpha,m,R_L

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute r_k_H as a function of m and R_L
!
! Eq(19) R. Lindh, P.-A. Malmqvist, L. Gagliardi,
! TCA, 106:178-187 (2001)

if (mod(m+3,2) == 0) then
  Gmma = One
  do i=2,(m+3)/2,1
    Gmma = Gmma*real(i-1,kind=wp)
  end do
else
  Gmma = sqrt(Pi)
  do i=5,m+3,2
    Gmma = Gmma*real(i-1,kind=wp)*Half
  end do
end if

!x = Alpha*(r_k_H)**2

x = Ten ! Start value
do
  x_new = log((Gmma/R_L)*x**(Half*(real(m,kind=wp)+One)))
  !write(u6,*) 'x,x_new=',x,x_new
  if (abs(x-x_new) <= 1.0e-8_wp) exit
  x = x_new
end do

Eval_RMax = sqrt(x/alpha)
!write(u6,*) 'Eval_RMax=',Eval_RMax
!                                                                      *
!***********************************************************************
!                                                                      *

return

end function Eval_RMax

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mean_field_exch(N,H,X,Y,Z,zJ,T,W,thrs,dM,sM,ST)
! this Subroutine computes the mean field of neighboring spins ST(3)
! for zJ /= 0.0
! using ONLY Zeeman basis (N)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: H, X, Y, Z, zJ, T, W(N), thrs
complex(kind=wp), intent(in) :: DM(3,N,N), SM(3,N,N)
real(kind=wp), intent(out) :: ST(3)
integer(kind=iwp) :: i, iter, l
real(kind=wp) :: S(3), SCHK, SL(3), ZB
logical(kind=iwp) :: Conv
real(kind=wp), allocatable :: RWORK(:), WM(:)
complex(kind=wp), allocatable :: HZEE(:), SZ(:,:,:), TMP(:,:), W_c(:), WORK(:), ZM(:,:)
integer(kind=iwp), parameter :: mxIter = 100
real(kind=wp), parameter :: THRS2 = 1.0e-12_wp ! FIXME: overriding input thrs
#ifdef _DEBUGPRINT_
# define _DBG_ .true.
#else
# define _DBG_ .false.
#endif

#include "macros.fh"
unused_var(thrs)

SCHK = Zero
S(:) = Zero
ST(:) = Zero

call mma_allocate(WM,N,label='WM')
call mma_allocate(SZ,3,N,N,label='SZ')
call mma_allocate(ZM,N,N,label='ZM')
call mma_allocate(TMP,N,N,label='TMP')

! temporary arrays used in ZEEM_SA:
call mma_allocate(RWORK,3*N-2,'ZEEM_RWORK')
call mma_allocate(HZEE,nTri_Elem(N),'ZEEM_HZEE')
call mma_allocate(WORK,2*N-1,'ZEEM_WORK')
call mma_allocate(W_c,N,'ZEEM_W_c')

! zero everything:
RWORK(:) = Zero
HZEE(:) = cZero
WORK(:) = cZero
W_c(:) = cZero
! determine first the average spin of neighboring
! molecules for each temperature point
Conv = .false.
do iter=1,mxIter
  WM(:) = Zero
  ZM(:,:) = cZero
  ! build and diagonalize the Zeeman Hamiltonian (size N x N)
  ! for the field direction (X,Y,Z) and strength (H)
  call ZEEM_SA(N,H,X,Y,Z,W,dM,sM,ST,zJ,WM,ZM,_DBG_,RWORK,HZEE,WORK,W_c)
  !write(u6,'(A,3ES16.8)') 'WM:',(WM(l),l=1,N)
  !write(u6,'(A,9(2ES16.8,2x))') 'ZM:',((ZM(l,i),l=1,N),i=1,N)
  ! transform the spin momenta to the Zeeman eigenstate basis
  SZ(:,:,:) = cZero
  call UTMU(N,N,ZM,SM,SZ)
  ! compute the spin magnetization vector at this temperature (T):
  if (iter == mxIter) SL(:) = S(:)
  S(:) = Zero
  do l=1,3
    ZB = Zero
    TMP(:,:) = SZ(l,:,:)
    call calcmagn1(N,WM,TMP,T,S(l),ZB)
  end do

  ! check if average spin is converged
  SCHK = sum(abs(S(:)-ST(:)))

# ifdef _DEBUGPRINT_
  write(u6,'(A,i4,1x,A,3ES20.10,2x,A,3ES20.10)') 'ST:   End of iteration',iter,':',(ST(l),l=1,3),'DIFF:',(S(l)-ST(l),l=1,3)
  write(u6,'(A,i4,1x,A,3ES20.10,2x,A,3ES20.10)') 'SCHK: End of iteration',iter,':',SCHK
# endif

  ! decide to continue the iterative process or exit
  if (SCHK < THRS2) then
    Conv = .true.
    exit
  end if
  ST(:) = S(:)
end do ! iter

if (.not. Conv) then
  write(u6,'(A, ES24.14)') 'This message shows that the average spin did NOT converge after 100 iterations. Temp.(in K)=',T
  write(u6,'(A,4ES24.14)') 'Field: (X, Y, Z), and (H):',X,Y,Z,H
  write(u6,'(A,4ES24.14)') 'Last values of the average spin: (Sx,Sy,Sz):',(ST(i),i=1,3)
  write(u6,'(A,4ES24.14)') 'Last values of the deviation:              :',(SL(i)-ST(i),i=1,3)
  write(u6,'(A,4ES24.14)') 'Absolute value of the deviation:           :',SCHK
  write(u6,'(A,4ES24.14)') 'Convergence threshold:    THRS =           :',THRS2
  write(u6,'(A         )') 'The program will continue, using the last value of the average spin'
end if

! deallocate temporary data:
call mma_deallocate(WM)
call mma_deallocate(SZ)
call mma_deallocate(ZM)
call mma_deallocate(TMP)
call mma_deallocate(RWORK)
call mma_deallocate(HZEE)
call mma_deallocate(WORK)
call mma_deallocate(W_c)

return

end subroutine mean_field_exch

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
*               2019, Stefano Battaglia                                *
************************************************************************
*--------------------------------------------*
* 1998  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MCCTL(HEFF)
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
#include "SysDef.fh"
#include "stdalloc.fh"
      REAL*8 HEFF(NSTATE,NSTATE)

      INTEGER ISTATE
      REAL*8 DVALUE
      REAL*8 TOTCPU1, TOTWALL1, TOTCPU2, TOTWALL2
      Character(len=160) string
      real*8, allocatable :: cpu_timing(:), wall_timing(:)


      Call mma_allocate( cpu_timing,nstate,'timing in mcctl')
      Call mma_allocate(wall_timing,nstate,'timing in mcctl')
      Call dcopy_(nstate,[0.0d0],0, cpu_timing,1)
      Call dcopy_(nstate,[0.0d0],0,wall_timing,1)
C The ket state is JSTATE.
C Loop over the bra states
      DO ISTATE=1,NSTATE
        Write(string,'(A,I4,A,I4,A,I4)')
     &     'Multistate coupling between state',ISTATE,' and',JSTATE,
     &     ' out of ',NSTATE
        Call StatusLine('CASPT2: MCCTL: ',trim(string))
        TOTCPU1=0.0d0; TOTWALL1=0.0d0; TOTCPU2=0.0d0; TOTWALL2=0.0d0;
        Call CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        IF(ISTATE.EQ.JSTATE) THEN
          HEFF(ISTATE,JSTATE)=HEFF(ISTATE,JSTATE)+E2CORR
        ELSE
C Compute the effective Hamiltonian:
          CALL HEFVAL(ISTATE,JSTATE,DVALUE)
          HEFF(ISTATE,JSTATE)=HEFF(ISTATE,JSTATE)+DVALUE
        END IF

        Call CWTIME(TOTCPU2,TOTWALL2)
        cpu_timing(istate)=TOTCPU2-TOTCPU1
        wall_timing(istate)=TOTWALL2-TOTWALL1
      END DO

      IF ((IPRGLB.GE.VERBOSE).OR.(NLYROOT.NE.0)) THEN
       WRITE(6,*)
       WRITE(6,*) 'Hamiltonian Effective Couplings'
       WRITE(6,*) '-------------------------------'
       WRITE(6,*)
       WRITE(6,'(10X,6X,A3,I4,A3)') ' | ', MSTATE(JSTATE), ' > '
       DO ISTATE=1,NSTATE
        WRITE(6,'(A3,I4,A3,ES22.14)')
     &   ' < ',MSTATE(ISTATE),' | ', HEFF(ISTATE,JSTATE)
       ENDDO
      ENDIF

      IF ((IPRGLB.GE.VERBOSE).OR.(NLYROOT.NE.0)) THEN
       WRITE(6,*)
       WRITE(6,'(A,I4,A)')
     &           'Time spent for multi-state couplings for root ',
     &            MSTATE(JSTATE),':'
       WRITE(6,*) '----------------- CPU TIME  -------- WALL TIME'
       DO ISTATE=1,NSTATE
        WRITE(6,'(A3,I4,A,F18.3,2x,F18.3)') ' < ',MSTATE(ISTATE),' |',
     &    cpu_timing(istate),  wall_timing(istate)
       ENDDO
      ENDIF
      Call mma_deallocate(cpu_timing)
      Call mma_deallocate(wall_timing)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine daread(lun,irec0,vector,length,reclen)
! this routine reads vector with required length from
! open direct access file lun starting from record number
! irec0
! lun   - logical unit of direct access file (I)
! irec0 - initial record number (I)
! vector- vector (O)
! length- number of R8 data to be read (I)
! reclen- length of one record in lun in R8 (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lun, irec0, length, reclen
real(kind=wp), intent(out) :: vector(length)
integer(kind=iwp) :: ilow, irec, iup, need

if (length == 0) return

! def need,ilow,iup,irec

need = length
ilow = 1
iup = 0
irec = irec0

do
  if (reclen >= need) then
    iup = iup+need
  else
    iup = iup+reclen
  end if

  read(lun,rec=irec) vector(ilow:iup)

  need = need-(iup-ilow+1)
  irec = irec+1
  ilow = ilow+reclen

  if (need <= 0) exit
end do

return

end subroutine daread

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine small_svd(m,n,amat,umat,vmat,svals)
      implicit real*8 (a-h,o-z)
      dimension amat(m,*)
      dimension umat(m,*)
      dimension vmat(n,*)
      dimension svals(*)

      if (m.ge.n) then
       call svd_mgen(m,n,amat,umat,vmat,svals)
      else
       call svd_mlen(m,n,amat,umat,vmat,svals)
      end if
      return
      end

      subroutine svd_mgen(m,n,amat,umat,vmat,svals)
      implicit real*8 (a-h,o-z)
      dimension amat(m,n)
      dimension umat(m,n)
      dimension vmat(n,n)
      dimension svals(n)
#include "WrkSpc.fh"

      sq2=sqrt(2.0D0)
      mn=m+n
      mn3=(mn*(mn+1))/2
      mnsq=mn**2
      call getmem('bigA','allo','real',labig,mn3)
      call getmem('bigU','allo','real',lubig,mnsq)
      call dcopy_(mn3,[0.0D0],0,work(labig),1)
      call dcopy_(mnsq,[0.0D0],0,work(lubig),1)
      call dcopy_(mn,[sq2],0,work(lubig),mn+1)
      do i=1,m
       do j=1,n
        work(labig-1+((n+i)*(n+i-1))/2+j)=amat(i,j)
       end do
      end do
      call jacob(work(labig),work(lubig),mn,mn)
      call jacord(work(labig),work(lubig),mn,mn)
      do i=1,n
       irev=mn+1-i
       svals(i)=work(labig-1+(irev*(irev+1))/2)
       do j=1,n
        vmat(j,i)=work(lubig-1+j+mn*(irev-1))
       end do
       do j=1,m
        umat(j,i)=work(lubig-1+n+j+mn*(irev-1))
       end do
      end do
      call getmem('bigA','free','real',labig,mn3)
      call getmem('bigU','free','real',lubig,mnsq)
      return
      end

      subroutine svd_mlen(m,n,amat,umat,vmat,svals)
      implicit real*8 (a-h,o-z)
      dimension amat(m,n)
      dimension umat(m,m)
      dimension vmat(n,m)
      dimension svals(m)
#include "WrkSpc.fh"

      sq2=sqrt(2.0D0)
      mn=m+n
      mn3=(mn*(mn+1))/2
      mnsq=mn**2
      call getmem('bigA','allo','real',labig,mn3)
      call getmem('bigU','allo','real',lubig,mnsq)
      call dcopy_(mn3,[0.0D0],0,work(labig),1)
      call dcopy_(mnsq,[0.0D0],0,work(lubig),1)
      call dcopy_(mn,[sq2],0,work(lubig),mn+1)
      do i=1,m
       do j=1,n
        work(labig-1+((n+i)*(n+i-1))/2+j)=amat(i,j)
       end do
      end do
      call jacob(work(labig),work(lubig),mn,mn)
      call jacord(work(labig),work(lubig),mn,mn)
      do i=1,m
       irev=mn+1-i
       svals(i)=work(labig-1+(irev*(irev+1))/2)
       do j=1,n
        vmat(j,i)=work(lubig-1+j+mn*(irev-1))
       end do
       do j=1,m
        umat(j,i)=work(lubig-1+n+j+mn*(irev-1))
       end do
      end do
      call getmem('bigA','free','real',labig,mn3)
      call getmem('bigU','free','real',lubig,mnsq)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine getmap (lun,poss0,length,mapd,mapi,rc)
c
c     this routine reads mapd and mapi of the given mediade
c     from lun and reconstruct mapd to actual possitions poss0
c
c     lun   - Logical unit number of file, where mediate is stored (Input)
c     poss0 - initial possition in WRK, where mediate will be stored (Input)
c     length- overall length of mediate (Output)
c     mapd  - direct map matrix corresponding to given mediate (Output)
c     mapi  - inverse map matrix corresponding to given mediate (Output)
c     rc    - return (error) code (Output)
c
c     N.B.
c     all mediates are storred as follows
c     1 - mapd, mapi
c     2 - one record with complete mediate
c
#include "filemgr.fh"
#include "ccsd1.fh"

#include "SysDef.fh"
c
       integer lun,poss0,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer poss,im,length
c
       rc=0
c
c1    read mapd
c
       if (iokey.eq.1) then
c      Fortran IO
       read (lun) ((mapd(i,j),i=0,512),j=1,6),
     & (((mapi(l,m,n),l=1,8),m=1,8),n=1,8)
c workaround for a bug in some Intel versions
#ifdef __INTEL_COMPILER
       else if (iokey.lt.0) then
       write(6,*) "this should never happen"
#endif
c
       else
c      MOLCAS IO
       call idafile (lun,2,mapd,513*6,daddr(lun))
       call idafile (lun,2,mapi,8*8*8,daddr(lun))
       end if
c
c2    change possitions in mapd to proper one and calculate overall length
c
       poss=poss0
       length=0
c
       do 100 im=1,mapd(0,5)
c
       mapd(im,1)=poss
       poss=poss+mapd(im,2)
       length=length+mapd(im,2)
c
 100    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PMPLFM(AP,B,NDIM)
*
* Add lower half of a full matrix to a matrix packed
* in lower triangular form ( packed matrix stored columnwise )
*
      IMPLICIT REAL*8           ( A-H,O-Z)
      DIMENSION AP(*),B(*)
*
      IBSP = 1
      IBSF = 1
      DO 100 ICOL = 1, NDIM
        NELMNT = NDIM - ICOL + 1
        CALL VECSUM(AP(IBSP),AP(IBSP),B(IBSF),1.0D0,1.0D0,NELMNT)
        IBSP = IBSP + NELMNT
        IBSF = IBSF + NDIM
  100 CONTINUE
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1999, Roland Lindh                      *
*               1990, IBM                                              *
************************************************************************
      SubRoutine OneEl(Kernel,KrnlMm,Label,ip,lOper,nComp,CCoor,
     &                 nOrdOp,rNuc,rHrmt,iChO,
     &                 opmol,ipad,opnuc,iopadr,idirect,isyop,
     &                 PtChrg,nGrid,iAddPot)
      use Basis_Info, only: nBas
      use PrpPnt
      use Temporary_Parameters, only: PrPrt, Short, IfAllOrb
      use Sizes_of_Seward, only: S
      use Real_Info, only: Thrs
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Kernel, KrnlMm
#include "stdalloc.fh"
#include "real.fh"
      Real*8, Dimension(:), Allocatable :: Out, Nuc, TMat, Temp, El,
     &                                     Array
      Character*16, Dimension(:), Allocatable :: plabs
      Character Label*8, LBL*4
      Character L_Temp*8
      Real*8 CCoor(3,nComp), rNuc(nComp), PtChrg(nGrid)
      Integer ip(nComp), lOper(nComp), iChO(nComp), iStabO(0:7)
      dimension opmol(*),opnuc(*),iopadr(ncomp,*)
      Integer iTwoj(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
*                                                                      *
************************************************************************
*                                                                      *
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*) ' In OneEl: Label', Label
      Write (6,*) ' In OneEl: nComp'
      Write (6,'(1X,8I5)') nComp
      Write (6,*) ' In OneEl: lOper'
      Write (6,'(1X,8I5)') lOper
      Write (6,*) ' In OneEl: n2Tri'
      Do iComp = 1, nComp
         ip(iComp) = n2Tri(lOper(iComp))
      End Do
      Write (6,'(1X,8I5)') (ip(iComp),iComp=1,nComp)
      Call RecPrt(' CCoor',' ',CCoor,3,nComp)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute the number of blocks from each component of the operator
*     and the irreps it will span.
*
      nIC = 0
      llOper = 0
      Do iComp = 1, nComp
         llOper = iOr(llOper,lOper(iComp))
         Do iIrrep = 0, nIrrep-1
            If (iAnd(lOper(iComp),iTwoj(iIrrep)).ne.0) nIC = nIC + 1
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Write (6,*) ' nIC =',nIC
#endif
*
      If (nIC.eq.0) Return
*
      Call SOS(iStabO,nStabO,llOper)
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate memory for symmetry adapted one electron integrals.
*     Will just store the unique elements, i.e. low triangular blocks
*     and lower triangular elements in the diagonal blocks.
*
      Call ICopy(nComp,[-1],0,ip,1)
      LenTot=0
      Do iComp = 1, nComp
         LenInt=n2Tri(lOper(iComp))
         LenTot=LenTot+LenInt+4
      End Do
      Call mma_allocate(Array,LenTot,label='Array')
      ip(1)=1
      call dcopy_(LenTot,[Zero],0,Array(ip(1)),1)
      iadr=ip(1)
      do iComp = 1, nComp
         LenInt=n2Tri(lOper(iComp))
         ip(icomp)=iadr
         iadr=iadr+LenInt+4
*        Copy center of operator to work area.
         call dcopy_(3,Ccoor(1,iComp),1,Array(ip(iComp)+LenInt),1)
*        Copy nuclear contribution to work area.
         Array(ip(iComp)+LenInt+3) = rNuc(iComp)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute all SO integrals for all components of the operator.
*
      Call OneEl_Internal
     &           (Kernel,KrnlMm,Label,ip,lOper,nComp,CCoor,
     &            nOrdOp,rHrmt,iChO,
     &            opmol,opnuc,ipad,iopadr,idirect,isyop,
     &            iStabO,nStabO,nIC,
     &            PtChrg,nGrid,iAddPot,Array,LenTot)
*                                                                      *
************************************************************************
*                                                                      *
*                    P O S T P R O C E S S I N G                       *
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Call PrMtrx(Label,lOper,nComp,ip,Array)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Make a square sum on all the integrals for verification
      Call VrfMtrx(Label,lOper,nComp,ip,Array)
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute properties or write integrals to disc.
*
      Do iComp = 1, nComp
         iSmLbl = lOper(iComp)
         If (Prprt) Then
*                                                                      *
************************************************************************
*                                                                      *
*---------- Compute properties directly from integrals
*
*---------- Allocate some memory
*
            If (iComp.eq.1) Then
               If (short) Then
                  mDim = 1
               Else
                  mDim = S%nDim
               End If
               call mma_allocate(Out,mDim*nComp,label='Out')
               ipOut=1
               call dcopy_(mDim*nComp,[Zero],0,Out,1)
               call mma_allocate(Nuc,nComp,label='Nuc')
               ipNuc=1
               call dcopy_(nComp,[Zero],0,Nuc,1)
            End If
            nInt=n2Tri(iSmLbl)
            If (nInt.ne.0)
     &      Call CmpInt(Array(ip(iComp)),nInt,nBas,nIrrep,iSmLbl)
            Nuc(ipNuc+(iComp-1)) = Array(ip(iComp)+nInt+3)
            If (nInt.ne.0)
     &      Call XProp(Short,ifallorb,
     &                 nIrrep,nBas,nVec,Vec,nOcc,Occ,
     &                 Thrs,nDen,Array(ip(iComp)),
     &                 Out(ipOut+(iComp-1)*mDim))
*
            If (Label(1:3).eq.'PAM') Then
c               Open(unit=28,file='R_vect',access='append')
               EndFile(28)
               If(Short) Then
                  write(28,'(a8,2x,f20.14)')
     &                 Label, Out(ipOut+(iComp-1)*mDim)
               Else
                  Sum = 0.00d0
                  Do ii= 1 , nOcc
                    Sum = Sum + Out(ipOut+ii-1+(iComp-1)*mDim)
                  End Do
                  write(28,'(a8,2x,f20.14)') Label,-Sum
               End If
c               Close(28)
             End If
*
*---------- Once all components have been computed print them.
*
            If (iComp.eq.nComp) Then
               LBL=Label(1:4)
               Call UpCase(LBL)
               lpole = 0
               If (LBL.eq.'MLTP') Then
                   Read(Label,'(5X,I3)') lpole
               Else If (LBL.eq.'PAM ') Then
                   Read(Label,'(5X,I1)') lpole
               Else If (LBL.eq.'L_MP') Then
                   Read(Label,'(5X,I1)') lpole
               Else If (LBL(1:2).eq.'EF') Then
                   Read(Label,'(2X,I1)') lpole
               Else If (LBL.eq.'DMS ') Then
                   lpole = 3
               Else If (LBL.eq.'VELO') Then
                   lpole = 1
               End If
               Call mma_allocate(plabs,nComp,label='plabs')
               Call mma_allocate(TMat,nComp**2,label='TMat')
               Call mma_allocate(Temp,nComp,label='Temp')
               If (nComp.eq.1) Then
                  ipC2 = 1 ! dummy
               Else
                  ipC2 = 2 ! Used only for diamagnetic shielding.
               End If
               Call Prop(Short,Label,Ccoor(1,1),Ccoor(1,ipC2),
     &                   nIrrep,nBas,mDim,Occ,Thrs,
     &                   Out,Nuc,lpole,plabs,TMat,Temp,ifallorb)
*
* For a properties calculation, save the values of EF or CNT operators,
* they will be used to write the sum through Add_Info in Drv1El
*
               If (PrPrt.and.
     &             (LBL(1:2).eq.'EF'.or.LBL(1:3).eq.'CNT')) Then
                 Call mma_allocate(El,nComp,label='El')
                 ipEl=1
                 Call FZero(El,nComp)
*                Compute the sum of all orbital components
                 Do jComp=0,nComp-1
                   iInd1=ipEl+jComp
                   iInd2=ipOut+jComp*mDim
                   Do iOcc=0,mDim-1
                     El(iInd1)=El(iInd1)+Out(iInd2+iOcc)
                   End Do
                 End Do
*                Write electronic and nuclear components in temp file
                 LuTmp=10
                 Call DaName(LuTmp,'TMPPRP')
                 Read(Label(4:8),*) iEF
                 iDisk=(iEF-1)*2
                 Call dDaFile(LuTmp,1,El,nComp,iDisk)
                 Call dDaFile(LuTmp,1,Nuc,nComp,iDisk)
                 Call DaClos(LuTmp)
                 Call mma_deallocate(El)
               End If
*
               Call mma_deallocate(Temp)
               Call mma_deallocate(TMat)
               Call mma_deallocate(plabs)
               Call mma_deallocate(Nuc)
               Call mma_deallocate(Out)
            End If
         Else
*                                                                      *
************************************************************************
*                                                                      *
*---------- Write integrals to disc
*
            iOpt = 0
            iRC = -1
            If (Label(1:3).eq.'PAM') Then
               Write(L_Temp,'(A5,I3.3)') 'PAM  ',iPAMcount
               iPAMcount=iPAMcount+1
               iComp_=1
            Else If (Label(1:5).eq.'EMFR0') Then
               iComp_=1
               If (iComp.eq.1) Then
                  L_Temp='EMFR0  R'
               Else
                  L_Temp='EMFR0  I'
               End If
            Else If (Label(1:5).eq.'EMFR ') Then
               iComp_=MOD(iComp+2,3)+1
               If ((iComp+2)/3.eq.1) Then
                  L_Temp='EMFR  RS'
               Else If ((iComp+2)/3.eq.2) Then
                  L_Temp='EMFR  RA'
               Else If ((iComp+2)/3.eq.3) Then
                  L_Temp='EMFR  IS'
               Else If ((iComp+2)/3.eq.4) Then
                  L_Temp='EMFR  IA'
               End If
             Else If (Label(1:5).eq.'TMOM0') Then
               If (iComp.eq.1) Then
                  L_Temp='TMOM0  R'
                  iComp_=1
               Else
                  L_Temp='TMOM0  I'
                  iComp_=1
               End If
             Else If (Label(1:5).eq.'TMOM2') Then
               If (iComp.eq.1) Then
                  L_Temp='TMOM2  R'
                  iComp_=1
               Else
                  L_Temp='TMOM2  I'
                  iComp_=1
               End If
            Else If (Label(1:5).eq.'TMOM ') Then
               iComp_=MOD(iComp+2,3)+1
               If ((iComp+2)/3.eq.1) Then
                  L_Temp='TMOM  RS'
               Else If ((iComp+2)/3.eq.2) Then
                  L_Temp='TMOM  RA'
               Else If ((iComp+2)/3.eq.3) Then
                  L_Temp='TMOM  IS'
               Else If ((iComp+2)/3.eq.4) Then
                  L_Temp='TMOM  IA'
               End If
            Else
               L_Temp=Label
               iComp_=iComp
            End If
            Call WrOne(iRC,iOpt,L_Temp,iComp_,Array(ip(iComp)),iSmLbl)

            If (iRC.ne.0) then
               Call WarningMessage(2,
     &               ' *** Error in subroutine ONEEL ***,'//
     &               '     Abend in subroutine WrOne')
               Call Abend()
            End If
         End If
      End Do  ! iComp
*
      if (Label.eq.'Attract ')
     &   Call Add_info('SEWARD_ATTRACT',Array(ip(1)),1,5)
      if (Label.eq.'Kinetic ')
     &   Call Add_info('SEWARD_KINETIC',Array(ip(1)),1,5)
      if (Label.eq.'Mltpl  1')
     &   Call Add_info('SEWARD_MLTPL1X',Array(ip(1)),1,5)
*                                                                      *
************************************************************************
*                                                                      *
*---- Deallocate memory for integral
*
      Call mma_deallocate(Array)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine VrfMtrx(Label,lOper,nComp,ip,Matrix)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, Sweden, January '91                  *
************************************************************************
      use Basis_Info, only: nBas
      use Gateway_global, only: PrPrt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
*     Local arrays
      Real*8 Matrix(*)
      Character Label*(*), Line*80, Status
      Integer ip(nComp), lOper(nComp)
*
      Call GetEnvf('MOLCAS_TEST_not_yet_here',Status)
      If (Status.eq.' ') Return
      Do 10 iComp = 1, nComp
         VrfSum=0.0D0
         ip1 = ip(iComp)
         iSmLbl = lOper(iComp)
         If (Prprt) iSmLbl = iAnd(1,iSmLbl)
         Do 30 iIrrep = 0, nIrrep - 1
            If (nBas(iIrrep).le.0) Go To 30
            Do 40 jIrrep = 0, iIrrep
               If (nBas(jIrrep).le.0) Go To 40
               If (iAnd(iSmLbl,2**iEor(iIrrep,jIrrep)).eq.0) Go To 40
               If (iIrrep.eq.jIrrep) Then
                  n2=nBas(iIrrep)*(nBas(iIrrep)+1)/2
                  VrfSum=VrfSum+DDot_(n2,Matrix(ip1),1,Matrix(ip1),1)
                  ip1 = ip1 + n2
               Else
                  n2 =  nBas(iIrrep)*nBas(jIrrep)
                  VrfSum=VrfSum+DDot_(n2,Matrix(ip1),1,Matrix(ip1),1)
                  ip1 = ip1 + n2
               End If
 40         Continue
 30      Continue
*        Add the nuclear contribution and the operator position.
         n2=4
         VrfSum=VrfSum+DDot_(n2,Matrix(ip1),1,Matrix(ip1),1)
         Write (Line,'(A,I5)') Label,iComp
         Call Add_info(Line,[VrfSum],1,8)
 10   Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Lines_Exchange( Jex, N1, N2, S1, S2, HAM )
!     this Subroutine calculates the Lines exchange interaction between
!     two sites, of the one interacting pair
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      ! input variables
      Integer, intent(in)           :: N1, N2
      Real(kind=8), intent(in)     :: Jex
      Complex(kind=8), intent(in)  :: S1(3,N1,N1)
      Complex(kind=8), intent(in)  :: S2(3,N2,N2)
      ! output variables
      Complex(kind=8), intent(out) ::  HAM( N1,N1, N2,N2 )
      ! local variables
      Integer          :: i1,i2,j1,j2,l

      If( (N1<=0).OR.(N2<=0) ) Return
      Call zcopy_(N1*N1*N2*N2,[(0.0_wp,0.0_wp)],0,HAM,1)
      If (Jex==0.0_wp) Return

      ! kind=8, complex double precision
      Do i1=1,N1
        Do j1=1,N1
          Do i2=1,N2
            Do j2=1,N2

              Do l=1,3
                HAM(i1,j1, i2,j2) = HAM(i1,j1, i2,j2)
     &                         + cmplx(-Jex,0.0_wp,wp)
     &                         * S1(l,i1,j1)
     &                         * S2(l,i2,j2)
              End Do

            End Do
          End Do
        End Do
      End Do
      Return
      End Subroutine Lines_Exchange


      Subroutine Aniso_Lines_Exchange3( Jex, N1, N2, S1, S2, HAM )
!     this Subroutine calculates the Lines exchange interaction between
!     two sites, of the one interacting pair
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      ! input variables
      Integer, intent(in)           :: N1, N2
      Real(kind=8), intent(in)     :: Jex(3)
      Complex(kind=8), intent(in)  :: S1(3,N1,N1)
      Complex(kind=8), intent(in)  :: S2(3,N2,N2)
      ! output variables
      Complex(kind=8), intent(out) ::  HAM( N1,N1, N2,N2 )
      ! local variables
      Integer          :: i1,i2,j1,j2,l
      Complex(kind=8) :: Jc(3)
      Real(kind=8)    :: dnrm2_
      External         :: dnrm2_

      If( (N1<=0).OR.(N2<=0) ) Return
      Call zcopy_(N1*N1*N2*N2,[(0.0_wp,0.0_wp)],0,HAM,1)
      If ( dnrm2_(3,Jex,1)==0.0_wp) Return

      Call zcopy_(3,[(0.0_wp,0.0_wp)],0,Jc,1)
      Do l=1,3
        Jc(l) = cmplx(-Jex(l),0.0_wp,wp)
      End Do

      Do i1=1,N1
        Do j1=1,N1
          Do i2=1,N2
            Do j2=1,N2

              Do l=1,3
                HAM(i1,j1, i2,j2) = HAM(i1,j1, i2,j2)
     &                            + Jc(l) * S1(l,i1,j1) * S2(l,i2,j2)
              End Do

            End Do
          End Do
        End Do
      End Do
      Return
      End Subroutine Aniso_Lines_Exchange3



      Subroutine Aniso_Lines_Exchange9( Jex, N1, N2, S1, S2, HAM )
!     this Subroutine calculates the Lines exchange interaction between
!     two sites, of the one interacting pair
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      ! input variables
      Integer, intent(in)           :: N1, N2
      Real(kind=8), intent(in)     :: Jex(3,3)
      Complex(kind=8), intent(in)  :: S1(3,N1,N1)
      Complex(kind=8), intent(in)  :: S2(3,N2,N2)
      ! output variables
      Complex(kind=8), intent(out) ::  HAM( N1,N1, N2,N2 )
      ! local variables
      Integer          :: i1,i2,j1,j2,l,m
      Complex(kind=8) :: Jc(3,3)
      Real(kind=8)    :: dnrm2_
      External         :: dnrm2_

      If( (N1<=0).OR.(N2<=0) ) Return
      Call zcopy_(N1*N1*N2*N2,[(0.0_wp,0.0_wp)],0,HAM,1)
      If ( dnrm2_(9,Jex,1)==0.0_wp) Return

      Call zcopy_(3*3,[(0.0_wp,0.0_wp)],0,Jc,1)
      Do l=1,3
        Do m=1,3
           Jc(l,m)=cmplx(-Jex(l,m),0.0_wp,wp)
        End Do
      End Do

      ! kind=8, complex double precision
      Do i1=1,N1
        Do j1=1,N1
          Do i2=1,N2
            Do j2=1,N2

              Do l=1,3
                Do m=1,3
                  HAM(i1,j1, i2,j2) = HAM(i1,j1, i2,j2)
     &                    + Jc(l,m) * S1( l, i1,j1 ) * S2( m, i2,j2 )
                End Do
              End Do

            End Do
          End Do
        End Do
      End Do
      Return
      End Subroutine Aniso_Lines_Exchange9



      Subroutine Dzyaloshinsky_Morya_Exchange(Jex, N1, N2, S1, S2, HAM)
!     this Subroutine calculates the Dzyaloshinsky-Morya exchange interaction between
!     two sites, of the one interacting pair
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      ! input variables
      Integer, intent(in)           :: N1, N2
      Real(kind=8), intent(in)     :: Jex(3)
      Complex(kind=8), intent(in)  :: S1(3,N1,N1)
      Complex(kind=8), intent(in)  :: S2(3,N2,N2)
      ! output variables
      Complex(kind=8), intent(out) ::  HAM( N1,N1, N2,N2 )
      ! local variables
      Integer          :: i1,i2,j1,j2,l
      Complex(kind=8) :: X,Y,Z, Jc(3)
      Real(kind=8)    :: dnrm2_
      External         :: dnrm2_

      If( (N1<=0).OR.(N2<=0) ) Return
      Call zcopy_(N1*N1*N2*N2,[(0.0_wp,0.0_wp)],0,HAM,1)
      If ( dnrm2_(3,Jex,1)==0.0_wp) Return

      Jc=(0.0_wp,0.0_wp)
      Do l=1,3
        Jc(l)=cmplx( -Jex(l),0.0_wp,wp )
      End Do

      ! kind=8, complex double precision
      Do i1=1,N1
        Do j1=1,N1
          Do i2=1,N2
            Do j2=1,N2

              X=(0.0_wp,0.0_wp)
              Y=(0.0_wp,0.0_wp)
              Z=(0.0_wp,0.0_wp)

              X =  S1(2,i1,j1) * S2(3,i2,j2)
     &            -S1(3,i1,j1) * S2(2,i2,j2)

              Y =  S1(3,i1,j1) * S2(1,i2,j2)
     &            -S1(1,i1,j1) * S2(3,i2,j2)

              Z =  S1(1,i1,j1) * S2(2,i2,j2)
     &            -S1(2,i1,j1) * S2(1,i2,j2)

              HAM(i1,j1, i2,j2) = HAM(i1,j1, i2,j2)
     &                           + Jc(1)*X
     &                           + Jc(2)*Y
     &                           + Jc(3)*Z

            End Do
          End Do
        End Do
      End Do
      Return
      End Subroutine Dzyaloshinsky_Morya_Exchange



      Subroutine JITO_Exchange_Int( MxR1, MxR2, imaxrank,
     &                              n1, n2, JR, JI, HAM )

!     this Subroutine calculates the anisotropic exchange interaction between
!     two sites, of the one interacting pair on the basis of input ITO parameters
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
      ! input variables
      Integer, intent(in)           :: imaxrank(2)
      Integer, intent(in)           :: MxR1, MxR2
      Integer, intent(in)           :: n1, n2
      Real(kind=8), intent(in)     :: JR(MxR1,-MxR1:MxR1,
     &                                    MxR2,-MxR2:MxR2)
      Real(kind=8), intent(in)     :: JI(MxR1,-MxR1:MxR1,
     &                                    MxR2,-MxR2:MxR2)
      ! output variables
      Complex(kind=8), intent(out) ::  HAM( n1,n1, n2,n2 )

      ! lcoal variables:
      Integer                       :: ibuf, k1,q1,k2,q2,m1,m2,l1,l2
      Real(kind=8)                 :: jpar, RR, RI
!      Real(kind=8)                 :: rK1,rK2,rQ1,rQ2,rM1,rM2,rJ1,rJ2,
!     &                                 CGp1,CGp2,CGm1,CGm2,CG01,CG02
      Real(kind=8)                :: C01,C02
      Complex(kind=8)             :: J(MxR1,-MxR1:MxR1,MxR2,-MxR2:MxR2)
      Complex(kind=8), allocatable :: O1(:,:), O2(:,:)
      Complex(kind=8), allocatable :: W1(:,:), W2(:,:)
      Complex(kind=8), allocatable :: OO(:,:,:,:), WW(:,:,:,:),
     &                                 OW(:,:,:,:), WO(:,:,:,:)
      Logical                       :: dbg
      Real(kind=8)                 :: dnrm2_
      External                      :: dnrm2_

      dbg=.false.
! ----  initial checks
      If( (n1<=0).OR.(n2<=0) ) Return
      Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,HAM,1)
      ibuf=0
      ibuf=MxR1*(2*MxR1+1)*MxR2*(2*MxR2+1)
      If(ibuf==0) Return
      jpar=0.0_wp
      jpar=dnrm2_(ibuf,JR(1:MxR1,-MxR1:MxR1,1:MxR2,-MxR2:MxR2),1)
     &    +dnrm2_(ibuf,JI(1:MxR1,-MxR1:MxR1,1:MxR2,-MxR2:MxR2),1)
      If (jpar==0.0_wp) Return
! ---- end initial checks
      Call zcopy_(ibuf,[(0.0_wp,0.0_wp)],0,
     &                 J(1:MxR1,-MxR1:MxR1,1:MxR2,-MxR2:MxR2),1)
      Do k1=1,MxR1,2
       Do k2=1,MxR2,2
        Do q1=-k1,k1
         Do q2=-k2,k2
          RR=JR(k1,q1,k2,q2)
          RI=JI(k1,q1,k2,q2)
          J(k1,q1,k2,q2)=cmplx(RR,RI,wp)
         End Do
        End Do
       End Do
      End Do
!----------------------------------------------------------------
      Call mma_allocate(O1,n1,n1,'operator O1')
      Call mma_allocate(W1,n1,n1,'operator W1')
      Call mma_allocate(O2,n2,n2,'operator O2')
      Call mma_allocate(W2,n2,n2,'operator W2')
      Call mma_allocate(OO,n1,n1,n2,n2,'operator OO')
      Call mma_allocate(OW,n1,n1,n2,n2,'operator WO')
      Call mma_allocate(WO,n1,n1,n2,n2,'operator OW')
      Call mma_allocate(WW,n1,n1,n2,n2,'operator WW')
!----------------------------------------------------------------
      Do k1=1,imaxrank(1),2
       Do q1=0,k1
        Do k2=1,imaxrank(2),2
         Do q2=0,k2
          ! generate the operator matrix K=ik, Q=iq, dimension=na
          Call ITO(n1,k1,q1,C01,O1,W1)
          Call ITO(n2,k2,q2,C02,O2,W2)
          !generate coupled operators:
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,OO,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,OW,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,WO,1)
          Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,WW,1)
          Do m1=1,n1
           Do m2=1,n1
            Do l1=1,n2
             Do l2=1,n2
               OO(m1,m2,l1,l2) = O1(m1,m2) * O2(l1,l2)
               OW(m1,m2,l1,l2) = O1(m1,m2) * W2(l1,l2)
               WO(m1,m2,l1,l2) = W1(m1,m2) * O2(l1,l2)
               WW(m1,m2,l1,l2) = W1(m1,m2) * W2(l1,l2)
             End Do
            End Do
           End Do
          End Do !m1
          ! compute the exchange Hamiltonian:
          If((q1==0).and.(q2==0)) Then
           Call zaxpy_(n1*n1*n2*n2,J(k1,  0,k2,  0),OO,1,HAM,1)
          Else If ((q1==0).and.(q2.ne.0)) Then
           Call zaxpy_(n1*n1*n2*n2,J(k1,  0,k2, q2),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1,  0,k2,-q2),OW,1,HAM,1)
          Else If ((q1.ne.0).and.(q2==0)) Then
           Call zaxpy_(n1*n1*n2*n2,J(k1, q1,k2,  0),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1,-q1,k2,  0),WO,1,HAM,1)
          Else If ((q1.ne.0).and.(q2.ne.0)) Then
           Call zaxpy_(n1*n1*n2*n2,J(k1, q1,k2, q2),OO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1, q1,k2,-q2),OW,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1,-q1,k2, q2),WO,1,HAM,1)
           Call zaxpy_(n1*n1*n2*n2,J(k1,-q1,k2,-q2),WW,1,HAM,1)
          End If
         End Do
        End Do
       End Do
      End Do ! k1

      If(dbg) Then
       Write(6,'(A)') 'JITO_Exchange_Int: generated <m1,l1|HAM|m2,l2>'
       Do m1=1,n1
        Do m2=1,n1
         Do l1=1,n2
          Do l2=1,n2
           Write(6,'(A,i2,A,i2,A,i2,A,i2,A,2ES22.14)')
     &        '<',m1,',',l1,'| HAM |',m2,',',l2,'> = ',HAM(m1,m2,l1,l2)
          End Do
         End Do
        End Do
       End Do
      End If

      Call mma_deallocate(OO)
      Call mma_deallocate(OW)
      Call mma_deallocate(WO)
      Call mma_deallocate(WW)
      Call mma_deallocate(O1)
      Call mma_deallocate(W1)
      Call mma_deallocate(O2)
      Call mma_deallocate(W2)

      Return
      End Subroutine JITO_Exchange_Int

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine OutRAS(iKapDisp,iCiDisp)
********************************************************************
*                                                                  *
* Contracts the response coefficient to the hessian                *
*                                                                  *
* Input                                                            *
*       iKapDisp : Disk locations of solutions to respons equation *
*       iCIDisp  : Disk locations of CI Soulutions to response     *
*                                                                  *
* Author: Anders Bernhardsson, 1996                                *
*         Theoretical Chemistry, University of Lund                *
********************************************************************
      Implicit Real*8 (a-h,o-z)
#include "detdim.fh"

#include "Input.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "disp_mclr.fh"
#include "cicisp_mclr.fh"
#include "WrkSpc.fh"
      Character*8 Label
      Integer Pstate_sym
      Integer iKapDisp(nDisp),iCiDisp(nDisp)
      Logical CI
*
*-------------------------------------------------------------------*
*
* Ok construct hessian
*
*-------------------------------------------------------------------*
*
      Write(6,*)
      Write(6,*) '      Writing response to disk in Split guga '//
     &     'GUGA format'
      Write(6,*)
      idisp=0
      Do iSym=1,nSym
         rsuM=0.0d0
         Call Setup_MCLR(iSym)
         PState_SYM=iEor(State_Sym-1,iSym-1)+1
         nconfM=ncsf(PState_Sym)
         nconf1=ncsf(PState_Sym)
         CI=.false.
         If (iMethod.eq.2.and.nconf1.gt.0) CI=.true.
         If (CI.and.nconf1.eq.1.and.isym.eq.1) CI=.false.
*
*    Allocate areas for scratch and state variables
*
         Call GetMem('kappa1','Allo','Real',ipKap1,nDens2)
         Call GetMem('kappa2','Allo','Real',ipKap2,nDens2)
         Call GetMem('kappa3','Allo','Real',ipKap3,nDens2)
         If (CI) Then
            Call GetMem('CI1','Allo','Real',ipcip1,nconfM)
            call InCSFSD(Pstate_sym,State_sym,.true.)
         End If
         Do jDisp=1,lDisp(iSym)
            iDisp=iDisp+1
            If (iAnd(ntpert(idisp),2**4).eq.16) Then
               kdisp=DspVec(idisp)
*
               iDisk=iKapDisp(iDisp)
               If (iDisk.ne.-1) Then
                  Len=nDensC
                  Call dDaFile(LuTemp,2,Work(ipKap1),Len,iDisk)
                  Call Uncompress(Work(ipKap1),Work(ipKap3),isym)
                  If (CI) Then
                     ilen=nconfM
                     idis=iCIDisp(iDisp)
                     Call dDaFile(LuTemp,2,Work(ipCIp1),iLen,iDis)
                  End If
                  Call GASync()
               Else
                  Call GASync()
                  Len=nDensC
                  Call FZero(Work(ipKap1),Len)
                  Call GADSum(Work(ipKap1),Len)
                  If (CI) Then
                     len=nconfM
                     Call FZero(Work(ipCIp1),Len)
                     Call GADSum(Work(ipCIp1),Len)
                  End If
               End If
               Call GASync()
               Call TCMO(Work(ipKap3),isym,-1)
               irc=ndens2
               Label='KAPPA   '
               iopt=128
               isyml=2**(isym-1)
               ipert=kdisp
               write(6,'(A,I5," jDisp: ",I5," and iSym:",I5)')
     &           "Writing KAPPA and CI in mclr for iDisp:",
     &           iDisp, jDisp, iSym
               Call dWrMCk(iRC,iOpt,Label,ipert,Work(ipKap3),isyml)
               if (irc.ne.0) Call SysAbendMsg('outras','Error in wrmck',
     &              'label=KAPPA')
               irc=nconfM
               iopt=128
               Label='CI      '
               isyml=2**(isym-1)
               ipert=kdisp

               If (iAnd(kprint,8).eq.8)
     &              Write(6,*) 'Perturbation ',ipert
               If (CI) call Guganew(ipcip1,0,pstate_sym)
               If (imethod.eq.2.and.(.not.CI).and.nconfM.eq.1)
     &              Work(ipcip1)=0.0d0
               Call dWrMCk(iRC,iOpt,Label,ipert,Work(ipcip1),isyml)
               if (irc.ne.0) Call SysAbendMsg('outras','Error in wrmck',
     &              ' ')
            End If
**********************************************************************
*
         End Do
*
*     Free areas for scratch and state variables
*
*
*
         If (CI)  Then
            Call GetMem('CI1','Free','Real',ipcip1,nconfM)
         End If
*        Call GetMem('KICONF2','FREE','INTE',kiconf(2),idum)
         Call Getmem('rkappa3','FREE','Real',ipkap3,nDensC)
         Call Getmem('rkappa2','FREE','Real',ipkap2,nDensC)
         Call Getmem('rkappa1','FREE','Real',ipkap1,nDensC)
      End Do

*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Roland Lindh                                     *
!***********************************************************************

module SOAO_Info

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), allocatable :: iAOtSO(:,:), iSOInf(:,:)
integer(kind=iwp) :: iOffSO(0:7) = 0, nIrrep = 0, nSOInf = 0

! Do not change this value, since it also explicitly signals symmetry information.
! This is explicitly used in some routines. (where?)
integer(kind=iwp) :: initValue = -99999999

public :: iAOtSO, iOffSO, iSOInf, nSOInf, SOAO_Info_Dmp, SOAO_Info_Free, SOAO_Info_Get, SOAO_Info_Init

!***********************************************************************
!***********************************************************************

contains

!***********************************************************************
!***********************************************************************

subroutine SOAO_Info_Init(nSize,mIrrep)

  use stdalloc, only: mma_allocate

  integer(kind=iwp), intent(in) :: mIrrep, nSize

  if (allocated(iSOInf) .or. allocated(iAOtSO)) call SOAO_Info_Free()
  nSOInf = nSize
  nIrrep = mIrrep
  call mma_allocate(iSOInf,3,nSOInf,Label='iSOInf')
  iSOInf(:,:) = initValue
  call mma_allocate(iAOtSO,[1,nSOInf],[0,nIrrep-1],Label='iAOtSO')
  iAOtSO(:,:) = initValue

end subroutine SOAO_Info_Init

!***********************************************************************

subroutine SOAO_Info_Dmp()

  use stdalloc, only: mma_allocate, mma_deallocate
# ifdef _DEBUGPRINT_
  use Definitions, only: u6
# endif

  integer(kind=iwp) :: i, j
  integer(kind=iwp), allocatable :: iDmp(:)

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Enter SOAO_Info_Dmp'
  write(u6,*)
  write(u6,*)
  write(u6,*) 'iAOtSO:'
  do i=0,nIrrep-1
    write(u6,'(8I9)') iAOtSO(1:nSOInf,i)
  end do
# endif
  call mma_allocate(iDmp,3*nSOInf+8,Label='iDmp')
  j = 0
  do i=1,nSOInf
    iDmp(j+1:j+3) = iSOInf(1:3,i)
    j = j+3
  end do
  iDmp(j+1:j+8) = iOffSO(0:7)
  call Put_iArray('iSOInf',iDmp,3*nSOInf+8)
  call mma_deallocate(iDmp)
  call Put_iArray('iAOtSO',iAOtSO,nSOInf*nIrrep)

end subroutine SOAO_Info_Dmp

!***********************************************************************

subroutine SOAO_Info_Get()

  use Definitions, only: u6

  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp) :: i, j
  logical(kind=iwp) :: Found
  integer(kind=iwp), allocatable :: iDmp(:)

# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'Enter SOAO_Info_Get'
  write(u6,*)
# endif
  if (allocated(iSOInf) .or. allocated(iAOtSO)) call SOAO_Info_Free()
  call Qpg_iArray('iSOInf',Found,nSOInf)
  if (.not. Found) then
    write(u6,*) 'SOAO_Info_Get: iSOInf not found.'
    call Abend()
  end if
  nSOInf = (nSOInf-8)/3
  call mma_allocate(iSOInf,3,nSOInf,Label='iSOInf')
  call mma_allocate(iDmp,3*nSOInf+8,Label='iDmp')
  call Get_iArray('iSOInf',iDmp,3*nSOInf+8)
  j = 0
  do i=1,nSOInf
    iSOInf(1:3,i) = iDmp(j+1:j+3)
    j = j+3
  end do
  iOffSO(0:7) = iDmp(j+1:j+8)
  call mma_deallocate(iDmp)

  call Qpg_iArray('iAOtSO',Found,nIrrep)
  if (.not. Found) then
    write(u6,*) 'SOAO_Info_Get: iAOtSO not found.'
    call Abend()
  end if
  nIrrep = nIrrep/nSOInf
  call mma_allocate(iAOtSO,[1,nSOInf],[0,nIrrep-1],Label='iAOtSO')
  call Get_iArray('iAOtSO',iAOtSO,nSOInf*nIrrep)
# ifdef _DEBUGPRINT_
  write(u6,*)
  write(u6,*) 'iAOtSO:'
  do i=0,nIrrep-1
    write(u6,'(8I9)') iAOtSO(1:nSOInf,i)
  end do
  write(u6,*)
  write(u6,*) 'Exit SOAO_Info_Get'
  write(u6,*)
# endif

end subroutine SOAO_Info_Get

!***********************************************************************

subroutine SOAO_Info_Free()

  use stdalloc, only: mma_deallocate

  if (allocated(iSOInf)) call mma_deallocate(iSOInf)
  if (allocated(iAOtSO)) call mma_deallocate(iAOtSO)
  nSOInf = 0
  nIrrep = 0

end subroutine SOAO_Info_Free

!***********************************************************************
!***********************************************************************

end module SOAO_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine espf(ireturn,StandAlone)

use espf_global, only: MxExtPotComp
use Index_Functions, only: nTri_Elem
use Basis_Info, only: nBas
use OneDat, only: sOpSiz
use Symmetry_Info, only: VarR, VarT, Symmetry_Info_Dmp
use Data_Structures, only: Alloc1DArray_Type, Alloc2DArray_Type, Alloc4DArray_Type
use NAC, only: isNAC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
logical(kind=iwp), intent(in) :: StandAlone
integer(kind=iwp) :: iComp, idum(1), iGrdTyp, iOpt, iOption, iPL, iRc, iRMax, iSyLbl, MltOrd, nAtMM, natom, nAtQM, nBas0, nGrdPt, &
                     nInts, nMult, nSize, nSym
real(kind=wp) :: DeltaR, EnergyCl, RepNuc
logical(kind=iwp) :: Close_Seward, DoDirect, DoGromacs, DoTinker, DynExtPot, Forces, isNAC_tmp, lMorok, Show_espf
character(len=8) :: Label
type(Alloc1DArray_Type) :: Mltp
type(Alloc2DArray_Type) :: GradCl, Grid
type(Alloc4DArray_Type) :: DGrid
integer(kind=iwp), allocatable :: IsMM(:)
real(kind=wp), allocatable :: B(:), Cord(:,:), DB(:,:,:), Ext(:,:), H(:), T(:,:), TT(:,:), TTT(:,:)
integer(kind=iwp), external :: iPL_espf

iReturn = 99

! Print

iPL = iPL_espf()
Close_Seward = .false.

! Some warnings

call Get_iScalar('nSym',nSym)
if (nSym > 1) then
  write(u6,'(A)') ' Symmetry cannot be used together with ESPF.'
  call Quit_OnUserError()
end if

! Set on the System Bit 11

call Get_iScalar('System Bitswitch',iOption)
iOption = ibset(iOption,11)
call Put_iScalar('System Bitswitch',iOption)

! Some initializations

call Get_iScalar('Unique atoms',natom)
call mma_allocate(Cord,3,natom,label='AtomCoord')
call Get_dArray('Unique Coordinates',Cord,3*natom)
call mma_allocate(IsMM,natom,label='IsMM for atoms')
call mma_allocate(Ext,MxExtPotComp,natom,label='ExtPot')
Ext(:,:) = Zero
call MMCount(natom,nAtMM,IsMM)
nAtQM = natom-nAtMM
nGrdPt = 0
isNAC_tmp = isNAC

! Read the input and compute the external potential

call StatusLine('espf: ','Reading input')
call ReadIn_ESPF(natom,Cord,Ext,MltOrd,iRMax,DeltaR,Forces,Show_espf,IsMM,StandAlone,iGrdTyp,DoTinker,DoGromacs,DynExtPot,Mltp, &
                 nAtMM,lMorok,DoDirect,GradCl,EnergyCl)

! If the present calculation does not use ESPF but the Direct scheme

if (DoDirect) then

  call No_ESPF(Forces,DoTinker)

else

  nMult = MltOrd*nAtQM
  if (iPL >= 2) write(u6,'(/,A,I2,A,i4,A,i6)') ' Number of ESPF operators (nMult=',MltOrd,' * nAtQM=',nAtQM,'): ',nMult

  ! Compute the grid around the molecule

  call StatusLine('espf: ','Making the grid')
  if (iGrdTyp == 1) then
    if (nGrdPt == 0) call MkGrid(natom,Cord,Grid,nGrdPt,iRMax,DeltaR,Forces,IsMM,-iGrdTyp,DGrid,nAtQM)
    call MkGrid(natom,Cord,Grid,nGrdPt,iRMax,DeltaR,Forces,IsMM,iGrdTyp,DGrid,nAtQM)
    if (iPL >= 2) then
      write(u6,'(A)') ' PNT Grid (Warning: no grid derivatives)'
      write(u6,'(A)') ' (C. Chipot and J. Angyan, Henri Poincare University, Nancy, France)'
      write(u6,'(5X,I5,A)') nGrdPt,' grid points'
    end if
  else
    call MkGrid(natom,Cord,Grid,nGrdPt,iRMax,DeltaR,Forces,IsMM,iGrdTyp,DGrid,nAtQM)
    if (iPL >= 2) then
      write(u6,'(A)') ' GEPOL Grid, using United Atoms radii'
      write(u6,'(5X,I5,A)') nGrdPt,' grid points'
    end if
  end if

  ! If this is a standalone call to &ESPF, there are 2 options:
  !    1) static external potential: compute here the ESPF contributions
  !    2) dynamic external potential: nothing more to compute here

  if (.not. (StandAlone .and. DynExtPot)) then

    ! Compute the cartesian tensor T, TtT^-1, [TtT^-1]Tt
    ! and B=ExtPot[TtT^-1]Tt
    ! Tt means the transpose of T

    call mma_allocate(T,nMult,nGrdPt,label='CartTensor')
    call mma_allocate(TT,nMult,nMult,label='TT')
    call mma_allocate(TTT,nGrdPt,nMult,label='TTT')
    call mma_allocate(B,nGrdPt,label='ExtPot*TTT')
    call InitB(nMult,natom,nAtQM,nGrdPt,Cord,Grid%A,T,TT,TTT,Ext,B,IsMM)
    call mma_allocate(DB,nGrdPt,3,nAtQM,label='DerivB')
    call InitDB(nMult,natom,nAtQM,nGrdPt,Cord,Grid%A,T,TT,TTT,Ext,DB,IsMM)

    ! Here we must distinguish between an energy run and a gradient run

    if (.not. Forces) then
      call StatusLine('espf: ','Computing energy components')
      call Get_iArray('nBas',nBas,nSym)
      nBas0 = nBas(0)
      nSize = nTri_Elem(nBas0)+4
      call mma_allocate(H,nSize,label='H')
      iComp = 1
      iSyLbl = 1
      Label = 'OneHam  '
      iRc = -1
      iOpt = ibset(0,sOpSiz)
      call iRdOne(iRc,iOpt,Label,iComp,idum,iSyLbl)
      nInts = idum(1)
      if (iRc /= 0) then
        write(u6,'(A)') ' ESPF: Error reading ONEINT'
        write(u6,'(A,A8)') ' Label = ',Label
        call Abend()
      end if
      if (nInts+4 /= nSize) then
        write(u6,'(A,2I5)') ' ESPF: nInts+4 /= nSize',nInts+4,nSize
        call Abend()
      end if
      iRc = -1
      iOpt = 0
      call RdOne(iRc,iOpt,Label,iComp,H,iSyLbl)
      call Get_dScalar('PotNuc',RepNuc)
      call espf_energy(nBas0,natom,nGrdPt,Ext,Grid%A,B,H,nSize-4,RepNuc,EnergyCl,DoTinker,DoGromacs,DynExtPot)
      call Put_dScalar('PotNuc',RepNuc)
      call WrOne(iRc,iOpt,Label,iComp,H,iSyLbl)
      if (iRC /= 0) then
        write(u6,*) 'ESPF: Error writing to ONEINT'
        write(u6,'(A,A8)') 'Label=',Label
        call Abend()
      end if
      call mma_deallocate(H)
      if (iPL >= 3) write(u6,*) 'The 1-e hamiltonian is now updated.'
      if (iPL >= 2) write(u6,'(A,F16.10)') ' Nuclear energy, including Ext Pot = ',RepNuc
    else
      call StatusLine('espf: ','Computing gradient components')
      call mma_allocate(GradCl%A,0,0,label='GradCl',safe='*')
      call espf_grad(natom,nGrdPt,nAtQM,Ext,Grid%A,B,DB,IsMM,GradCl%A,DoTinker,DoGromacs)
      call mma_allocate(Mltp%A,nMult,label='ESPFMltp',safe='*')
      call espf_mltp(natom,MltOrd,nMult,nGrdPt,TTT,Mltp%A,Grid%A,IsMM,Ext,iPL,Cord)
    end if
    Close_Seward = .true.

  end if

end if

! Save data in the ESPF.DATA file

if (.not. allocated(Mltp%A)) then
  nMult = 0
  call mma_allocate(Mltp%A,nMult,label='ESPFMltp')
end if
call espf_write(MltOrd,iRMax,DeltaR,iGrdTyp,nGrdPt,DoTinker,DoGromacs,lMorok,Mltp%A,nMult,IsMM,natom,Show_espf,Forces,DoDirect)

! Exit

isNAC = isNAC_tmp
if (.not. (StandAlone .and. DynExtPot)) then
  call mma_deallocate(T)
  call mma_deallocate(TT)
  call mma_deallocate(TTT)
  call mma_deallocate(B)
  call mma_deallocate(DB)
end if
call mma_deallocate(Cord)
call mma_deallocate(IsMM)
call mma_deallocate(Ext)
call mma_deallocate(Mltp%A)
call mma_deallocate(Grid%A,safe='*')
call mma_deallocate(DGrid%A,safe='*')
call mma_deallocate(GradCl%A,safe='*')

! Slapaf needs to know that the gradient is NOT translational
! and rotational invariant.

if ((.not. Forces) .and. (nAtMM > 0)) then
  VarR = .true.
  VarT = .true.
  call Symmetry_Info_Dmp()
end if
if (Close_Seward) call ClsSew()

iReturn = 0
return

end subroutine espf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine asonc1_cvb( &
#                     define _CALLING_
#                     include "ddasonc_interface.fh"
                     )
! Applies S on c vector(s).

use casvb_global, only: civb2, cvbdet, orbs
use Definitions, only: wp, iwp

implicit none
#include "ddasonc_interface.fh"
integer(kind=iwp) :: ivec

#include "macros.fh"
unused_var(axc)

do ivec=1,nvec
  call str2vbc_cvb(c(:,ivec),cvbdet)
  call vb2cif_cvb(cvbdet,civb2)
  call applyts_cvb(civb2,orbs)
  call ci2vbg_cvb(civb2,cvbdet)
  call vb2strg_cvb(cvbdet,sxc(:,ivec))
end do

return

end subroutine asonc1_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine RHS_SCAL(NAS,NIS,lg_W,FACT)
!SVC: this routine multiplies the RHS array with FACT

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
#endif
use fake_GA, only: GA_Arrays
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NAS, NIS, lg_W
real(kind=wp), intent(in) :: FACT
#ifdef _MOLCAS_MPP_

if (Is_Real_Par()) then
  if (FACT == Zero) then
    !call GA_Fill (lg_W,Zero)
    call GA_Zero(lg_W)
  else if (FACT /= One) then
    call GA_Scale(lg_W,FACT)
  end if
else
#endif
  if (FACT == Zero) then
    GA_Arrays(lg_W)%A(1:NAS*NIS) = Zero
  else if (FACT /= One) then
    GA_Arrays(lg_W)%A(1:NAS*NIS) = FACT*GA_Arrays(lg_W)%A(1:NAS*NIS)
  end if
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine RHS_SCAL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE rdinp_surfacehop()
      use Tully_variables
      IMPLICIT none
#include "Molcas.fh"
#include "surfacehop.fh"
#include "stdalloc.fh"
      character*180 Get_Ln, Key, Line
      logical Found
      integer LuSpool, isfreeunit, NSTATE,i,j,ndata,maxHop
      real*8  temp(mxroot)
      real*8, allocatable :: AmatrixVR(:),AmatrixVI(:)
      external Get_Ln, isfreeunit

      LuSpool = isfreeunit(21)
      CALL SpoolInp(LuSpool)

      CALL RdNLst(LuSpool,'surfacehop')

      do
      Key = Get_Ln(LuSpool)
      Line = Key
      CALL UpCase(Line)

      select case(Line(1:4))
        case('TULL')
             tullyL=.true.
        case('DECO')
             Line = Get_Ln(LuSpool)
             CALL Get_F1(1,DECO)
             decoherence=.true.
        case('SUBS')
             Line = Get_Ln(LuSpool)
             CALL Get_I1(1,NSUBSTEPS)
        case('ETHR')
             Line = Get_Ln(LuSpool)
             CALL Get_F1(1,Ethreshold)
        case('RTHR')
             Line = Get_Ln(LuSpool)
             CALL Get_F1(1,RandThreshold)
        case('PSUB')
             tullySubVerb=.true.
        case('DMTX')
             Line = Get_Ln(LuSpool)
             CALL Get_I1(1,NSTATE)
             call mma_allocate(AmatrixVR,NSTATE*NSTATE,
     &                         label='AmatrixVR')
             call mma_allocate(AmatrixVI,NSTATE*NSTATE,
     &                         label='AmatrixVI')
             do i=1, NSTATE
                Line = Get_Ln(LuSpool)
                CALL Get_F(1,temp,NSTATE)
                do j=1, NSTATE
                   AmatrixVR((i-1)*NSTATE+j)=temp(j)
                end do
             end do
             do i=1, NSTATE
                Line = Get_Ln(LuSpool)
                CALL Get_F(1,temp,NSTATE)
                do j=1, NSTATE
                   AmatrixVI((i-1)*NSTATE+j)=temp(j)
                end do
             end do
             call Qpg_zArray('AmatrixV', Found, ndata)
             IF (.NOT.Found) THEN
               call Put_dArray('RAmatrixV', AmatrixVR, NSTATE*NSTATE)
               call Put_dArray('IAmatrixV', AmatrixVI, NSTATE*NSTATE)
             else if (ndata.ne.NSTATE*NSTATE) then
               call warningmessage(2,'The A matrix dimension on the '//
     &         'input is different from the one in runfile')
               CALL Abend()
             end if
             call mma_deallocate(AmatrixVR)
             call mma_deallocate(AmatrixVI)
        case('FRAN')
             Line = Get_Ln(LuSpool)
             CALL Get_F1(1,FixedRand)
             fixedrandL=.true.
        case('ISEE') ! initial seed number
             Line = Get_Ln(LuSpool)
             CALL Get_I1(1,InitSeed)
             iseedL=.true.
        case('MAXH')
             Line = Get_Ln(LuSpool)
             CALL Get_I1(1,maxHop)
             CALL Put_iScalar('MaxHopsTully',maxHop)
C             Write (6,*) 'MaxHops set to ', maxHop
        case('H5RE')
#ifdef _HDF5_
             lH5Restart = .True.
             Line = Get_Ln(LuSpool)
             CALL Get_S(1,FILE_H5RES,1)
#else
             write (6,*) 'The user asks to restart the dynamics '
             write (6,*) 'calculation from a HDF5 file, but this is not'
             write (6,*) ' supported in this installation.'
             call Quit_OnUserError()
#endif
        case('END ')
             exit
        case default
             Write (6,*) 'Unknown keyword: ', trim(Key)
             CALL Abend()
      end select
      end do
      CLOSE(LuSpool)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Pavel Neogrady                                   *
************************************************************************
        subroutine extstackhlp1 (a,b,dimij,dimb,bb)
        integer dimij,dimb,bb,ij
        real*8 a(1:dimij),b(1:dimij,1:dimb)
        do ij=1,dimij
        a(ij)=b(ij,bb)
        end do
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  TrGrad
!
!> @brief Transform a gradient to a rotated reference, all symmetry blocks
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Transforms a gradient computed with respect to the rotation parameters
!> at the "current" orbitals to the rotation parameters at the "reference"
!> orbitals.
!>
!> @param[in]    kapOV  Parameters of the antisymmetric matrix
!> @param[in]    nkapOV Number of elements in kapOV
!> @param[inout] Grad   Gradient to transform
!> @param[in]    nOcc   Number of occupied orbitals (not including frozen) in each symmetry
!***********************************************************************

subroutine TrGrad(kapOV,nKapOV,Grad,nOcc)

use InfSCF, only: nFro, nOrb, nSym
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nKapOV, nOcc(8)
real(kind=wp), intent(in) :: kapOV(nKapOV)
real(kind=wp), intent(inout) :: Grad(nKapOV)
integer(kind=iwp) :: iOff, iSym, nVir

iOff = 1

do iSym=1,nSym
  nVir = nOrb(iSym)-nFro(iSym)-nOcc(iSym)

  if (nVir*nOcc(iSym) == 0) cycle

# ifdef _SVD_
  call trg_svd(nVir,nOcc(iSym),kapOV(iOff),Grad(iOff))
# else
  call trg_series(nVir,nOcc(iSym),kapOV(iOff),Grad(iOff))
# endif

  iOff = iOff+nOcc(iSym)*nVir
end do

end subroutine TrGrad

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
*               2009, Grigory A. Shamov                                *
************************************************************************
      Subroutine xG96(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object Gill-1996 Exchange: Peter Gill, Mol Phys 1996 vol 89, 433     *
*                                                                      *
* Called from:                                                         *
*                                                                      *
* Calling    :                                                         *
*                                                                      *
*      Author:Per Ake Malmqvist, Department of Theoretical Chemistry,  *
*             University of Lund, SWEDEN. June 2006  (B88 code)        *
*             Grigory A. Shamov, U of Manitoba, Dec 2009               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)

* IDORD=Order of derivatives to request from XPBE:
      idord=1
*
      Rho_Min=T_X*1.0D-2
*
      if (ispin.eq.1) then
* ispin=1 means spin zero.

* T_X: Screening threshold of total density.
        Ta=0.5D0*T_X
        do iGrid=1,mgrid
         rhoa=rho(ipR,iGrid)
         if(rhoa.lt.Ta) goto 110
         grdrhoa_x=rho(ipdRx,iGrid)
         grdrhoa_y=rho(ipdRy,iGrid)
         grdrhoa_z=rho(ipdRz,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2

         call xG96_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*(2.0D0*Fa)
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*dFdrhoa
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*dFdgammaaa
* Note: For xpbe, dFdgammaab is zero.
 110     continue
        end do

      else
* ispin .ne. 1, use both alpha and beta components.

        do iGrid=1,mgrid
         rhoa=Max(Rho_Min,rho(ipRa,iGrid))
         rhob=Max(Rho_Min,rho(ipRb,iGrid))
         rho_tot=rhoa+rhob
         if(rho_tot.lt.T_X) goto 210
         grdrhoa_x=rho(ipdRxa,iGrid)
         grdrhoa_y=rho(ipdRya,iGrid)
         grdrhoa_z=rho(ipdRza,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         call xG96_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)

         grdrhob_x=rho(ipdRxb,iGrid)
         grdrhob_y=rho(ipdRyb,iGrid)
         grdrhob_z=rho(ipdRzb,iGrid)
         sigmabb=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
         call xG96_(idord,rhob,sigmabb,Fb,dFdrhob,dFdgammabb,
     &          d2Fdrb2,d2Fdrbdgbb,d2Fdgbb2)

         F_xc(iGrid)=F_xc(iGrid)+Coeff*(Fa+Fb)
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+Coeff*dFdrhoa
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+Coeff*dFdrhob
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
* Note: For xpbe, dFdgammaab is zero.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*dFdgammaaa
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*dFdgammabb
 210     continue
        end do

      end if

      Return
      End

      subroutine xG96_(idord,rho_s,gamma_s,B88,dB88dr,dB88dg,d2B88dr2,
     &                d2B88drdg,d2B88dg2)
      implicit real*8 (a-h,o-z)
      parameter(third=1.0d0/3.0d0)
      parameter(four3=4.0d0/3.0d0)
      parameter(seven3=7.0d0/3.0d0)
C      parameter(bcoef=0.0042d0)
C     parameter(xldacff=0.930525736349100025D0)

      parameter(b=1.0d0/137.0d0)

C      rho = min(rho_s , 1.0D-16 )
         rho=rho_s
C      gamma = min(gamma_s, 1.0D-16 )
        gamma=gamma_s
      r43 = rho**four3
      rhoinv=1.0d0/rho
* lda part:
C     xlda=-xldacff*r43
* Note: Use x=sqrt(gamma)/rho**four3
      x = sqrt(gamma)/r43

      hgi = 0.50d0 / gamma

C Gill-1996 Exchange: Peter Gill, Mol Phys 1996 vol 89, 433
C      B88 = - b * x ** (3.0d0 / 2.0d0)  * r43

      B88 =  - b * x * sqrt(x)  * r43

      if(idord.lt.1) goto 99

      dB88Dr = 2.d+0*b*rho**((-5.d+0)/3.d+0)*gamma**(3.d+0/4.d+0)/3.d+0
      dB88Dg = (-3.d+0)*b*rho**((-2.d+0)/3.d+0)*gamma**((-1.d+0)/4.d+0)/
     1   4.d+0


      if(idord.lt.2) goto 99


      d2B88Dr2 = (-1.d+1)*b*rho**((-8.d+0)/3.d+0)*gamma**(3.d+0/4.d+0)/9
     1   .d+0
      d2B88DrDg = b*rho**((-5.d+0)/3.d+0)*gamma**((-1.d+0)/4.d+0
     2   )/2.d+0
      d2B88Dg2 = 3.d+0*b*rho**((-2.d+0)/3.d+0)*gamma**((-5.d+0
     3   )/4.d+0)/1.6d+1


  99  continue

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1992, Roland Lindh                                *
*               1990, IBM                                              *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine PSOAO2(nSO,MemPrm,MemM,
     &                            iAnga, iCmpa, iAO, iFnc,
     &                            iBas,  iBsInc, jBas,  jBsInc,
     &                            kBas,  kBsInc, lBas,  lBsInc,
     &                            iPrim, iPrInc, jPrim, jPrInc,
     &                            kPrim, kPrInc, lPrim, lPrInc,
     &                            nAco,
     &                            Mem1,Mem2,Mem3,Mem4,
     &                            MemX,MemPSO,
     &                            MemFck,nFT,nCMO,
     &                            MemFin,MemBuffer,
     &                            iMemB)
************************************************************************
*                                                                      *
*  Object: to partion the SO and AO block. It will go to some length   *
*          before it will start and break up the SO block. This will   *
*          reduce the total flop count. However, as we are breaking up *
*          the AO block this will affect the vectorization. Hence, at  *
*          some point it will actually be better to recompute the      *
*          primitives.                                                 *
*          Current stratergy:                                          *
*          1. Reduce the size of the density matrix and buffer so that *
*             it fits into memory.                                     *
*                                                                      *
*          2. Start reducing the length of the primitives in the order *
*             lPrim,jPrim.                                             *
*                                                                      *
*          3. Reduce the size of the SO block by reducing the number of*
*             basis functions in the order lBas, jBas.                 *
*                                                                      *
*          4. Reduce the size of the Buffer.                           *
*                                                                      *
*          5. Reduce kBas,iBas                                         *
*                                                                      *
*          6. Terminate run telling job max and min of additional      *
*             memory needed to perform the calculation.                *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*             Modified to first order derivatives. January '92         *
*             Anders Bernhardsson Theoretical chemistry, Lund 1995     *
************************************************************************
*
*               Memory map for mckinley
*
*---------------------------------------------------------------------------
*|      |               |       |               |               |          |
*|REAL  |  P TRANSF     | RYSG2 |   Transf      | FCK GENERAT   |MO Transf |
*|      |               |       |               |               |          |
*---------------------------------------------------------------------------
*|      |               |       |               |               |Scratch   |
*|  MX  |               |       | 9*abcd*ijkl   |    SS         |space     |
*|      |               |       |               |               |          |
*---------------------------------------------------------------------------
*|      |               |       |               |               |          |
*|  M3  |Scratch space  |Memrys |Scratch space  |    SS         | Scratch  |
*|      |               |       |               |               | space    |
*---------------------------------------------------------------------------
*|      |MEM4 (half tr) |*******|***************|               |          |
*|  M2  |               |       |               |               |  SS      |
*|      |PSO transf     |       |               |Scratch space  |          |
*---------------------------------------------------------------------------
*|      |               |       |               |               |          |
*|  M1  |      P        |   *   |      *        |     *         |    *     |
*|      |               |       |               |               |          |
*---------------------------------------------------------------------------
*|      |      ?        |       |               |               |          |
*|Buffer|***************|*******|Transformed    |***************|**********|
*|      |               |       |integrals      |               |          |
*---------------------------------------------------------------------------
*
c     use Temporary_parameters, only: force_part_c, force_part_p
      use Temporary_parameters, only: force_part_p
      use SOAO_Info, only: iAOtSO
      use pso_stuff
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "pstat.fh"
#include "disp.fh"
#include "disp2.fh"
#include "buffer.fh"
      Integer iAnga(4), iCmpa(4), nPam(4,0:7), iiBas(4), iAO(4),
     &        iFnc(4)
      Logical QiBas, QjBas, QkBas, QlBas, QjPrim, QlPrim, Fail
      Integer iTwoj(0:7),iMemB
      Data iTwoj/1,2,4,8,16,32,64,128/
*
*     Statement function to compute canonical index
*
      nElem(i) = (i+1)*(i+2)/2
*
c     iRout = 10
c     iPrint = nPrint(iRout)
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      iCmp = iCmpa(1)
      jCmp = iCmpa(2)
      kCmp = iCmpa(3)
      lCmp = iCmpa(4)
      iTotal = iTotal + 1
      mabcd=nElem(la)*nElem(lb)*nElem(lc)*nElem(ld)
      nabcd=iCmp*jCmp*kCmp*lCmp
*
*     If (force_part_c) Then
*        iBsInc = (iBas+1)/2
*        jBsInc = (jBas+1)/2
*        kBsInc = (kBas+1)/2
*        lBsInc = (lBas+1)/2
*     Else
         iBsInc = iBas
         jBsInc = jBas
         kBsInc = kBas
         lBsInc = lBas
*     End If
      If (force_part_p) Then
         jPrInc = (jPrim+1)/2
*        lPrInc = (lPrim+1)/2
      Else
         jPrInc = jPrim
*        lPrInc = lPrim
      End If
      iPrInc = iPrim
      kPrInc = kPrim
      lPrInc = lPrim
      MemBuffer = iMemB
      MemMax=MemM-MemBuffer
*
 999  Continue
      nijkl=iBsInc*jBsInc*kBsInc*lBsInc
      QjPrim = .False.
      QlPrim = .True.
      QiBas  = .False.
      QjBas  = .False.
      QkBas  = .False.
      QlBas  = .False.
      Mem0 = MemMax
*
*    Picked MO coeff
*
      If (nMethod.eq.RASSCF) Then
       nCMO=nACO*kCmp*kBas+nACO*lCmp*lBas
      Else
       nCMO=0
      End If
*
*     Area for integral storage before transforming them to FM/MO
*     and place for the CMOs
*
      MemFin=9*nijkl*nabcd
      If (MemFin+ncmo+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,nCMO+MemFin+1-Mem0)
         QlPrim=.false.
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) 'PSOAO2: memory partitioning failed!'
            Write (6,*) '        Restart with more memory!'
            Call Abend()
         End If
         Go To 999
      End If
*-----Subtract one additional word for getmem's internal error check
      Mem0 = Mem0 - MemFin -nCMO - 1
*
*
*--------------------------------------------------------------------
*
*-----*** Work1 ***
*
*
*-----Memory for 2nd order density matrix in SO basis.
*
      kSOInt = nSO*iBsInc*jBsInc*kBsInc*lBsInc
      Mem1 = kSOInt
*
*-----Allocate memory for MO to SO/AO transformation
*     of the 2nd order density matrix for this shell quadruplet.
*     and area for AO/SO transformation of Fock matrix.
*
      If (lPSO) Then
         iiBas(1) = iBsInc
         iiBas(2) = jBsInc
         iiBas(3) = kBsInc
         iiBas(4) = lBsInc
         Call ICopy(4*8,[0],0,nPam,1)
         MemPSO = 1
         nTmp2 = 0
*        Call IecPrt('iiBas',iiBas,1,4)
*
         Do 9 jPam = 1, 4
            iTmp1= 0
            nTmp1= 0
            Do 10 j = 0, nIrrep-1
               Do 11 i1 = 1, iCmpa(jPam)
                  If (iAOtSO(iAO(jPam)+i1,j)>0) Then
                      nPam(jPam,j) = nPam(jPam,j) + iiBas(jPam)
                      nTmp1= nTmp1+ iiBas(jPam)
                      iTmp1= iTmp1+ 1
                  End If
 11            Continue
 10         Continue
            MemPSO = MemPSO * nTmp1
            nTmp2 = nTmp2 + nTmp1
            iFnc(jPam) = iTmp1
 9       Continue
         MemScr=MemTra(nPam)
         nFac = 4
         nTmp2 = nTmp2 + 4
      Else
         MemScr=0
         MemPSO=0
         nFac = 0
         nTmp2 = 0
      End If
      MemAux = MemPSO + MemScr + nFac*S%nDim + nTmp2 + 4
      MemB_AUX=MemAux
      If (Mem1+1+MemAux.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem1+1+MemAux-Mem0)
         QjPrim = .False.
         QlPrim = .False.
         QiBas  = .False.
         QjBas  = .False.
         QkBas  = .False.
         QlBas  = .True.
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) 'PSOAO2: memory partitioning failed!'
            Write (6,*) '        Restart with more memory!'
            Call Abend()
         End If
         Go To 999
      End If
      Mem0 = Mem0 - Mem1 - 1
*---------------------------------------------------------------
*
*     MemFck: Target for generating the symmetrized Fock Matrix.
*              Distributed localy.
*     MemMo : Target for generating the  MO integrals
*              Distributed localy.
*    Whole work area is used, if work area is big enough
*    work3 is increased
*
*---------------------------------------------------------------
*
      MemDep=nijkl*nabcd
*     Temp+S1+S2
      MemFck=2*MemDep+Max(MemDep,nijkl+
     &        Max(iBsInc*lBsInc,jBsInc*lBsInc,
     &            iBsInc*kBsInc,jBsInc*kBsInc))
      nFT=iBsInc*jBsInc*iCmp*jCmp+kBsInc*lBsInc*kCmp*lCmp+
     &    iBsInc*kBsInc*iCmp*kCmp+jBsInc*lBsInc*jCmp*lCmp+
     &    iBsInc*lBsInc*iCmp*lCmp+jBsInc*kBsInc*jCmp*kCmp
      MemFck=MemFck+nFT
      If (nmethod.eq.RASSCF) Then
*
*     3 scratch spaces, sorted integrals and translation
*
       nMaxC=nACO
       MemFck=MemFck+2*nMaxC
       nMax=Max(iCmp*iBsInc,jCmp*jBsInc,kCmp*kBsInc,lcmp*lBsInc)
       nMax=Max(nMax,nMaxC)
       memMO=3*nMax**4+10*nabcd*nijkl
      Else
       MemMo=0
      End If
*
*---------------------------------------------------------------------
*
*-----*** Work2 and Work4 ***
*
*-----Memory for 2nd order density matrix in contracted basis (both
*     cartesian and spherical harmonic) and in primitive basis.
*     MemDeP: Target for desymmetrization
*     MemTrn: Scratch and target for decontraction
*     MemAux: Contracted 2nd order density matrix (if partial decon.)
*     MemSph: transformation spherical harmonics to cartesian, source
*             and target.

      MemDeP = nabcd * nijkl
      MemTrn = mabcd * Max(iBsInc*jBsInc*kBsInc*lBsInc,
     &                     iPrInc*jPrInc*kBsInc*lBsInc,
     &                     iPrInc*jPrInc*kPrInc*lPrInc)
      MemTrn=MemTrn+1

*-----If partial decontraction we need to keep the contracted 2nd
*     order density matrix. (Work4)
      If (jPrInc.ne.jPrim .or. lPrInc.ne.lPrim) Then
         MemAux = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
      Else
         MemAux = 0
      End If
      MemSph = mabcd * iBsInc*jBsInc*kBsInc*lBsInc
      Mem2 = Max(MemTrn+MemAux,MemDeP,MemSph)
      MemFck=MemFck-Mem2
      MemMO=MemMo-Mem2
      If (Mem2+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem2+1-Mem0)
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) 'PSOAO2: memory partitioning failed!'
            Write (6,*) '        Restart with more memory!'
            Call Abend()
         End If
         Go To 999
      End If
*-----Subtracte one additional word for getmem's internal error check
      Mem0 = Mem0 - Mem2 - 1
      MemX = 9*mabcd * iBsInc*jBsInc*kBsInc*lBsInc
      MemFck=MemFck-MemX
      MemMO=MemMo-MemX
      If (MemX+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,MemX+1-Mem0)
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) 'PSOAO2: memory partitioning failed!'
            Write (6,*) '        Restart with more memory!'
            Call Abend()
         End If
         Go To 999
      End If
      Mem0=Mem0-MemX

*
*-----*** Work3 and Work5 ***
*
*-----Scratch for decontraction and transformation to spherical gaussian.
*     Working array for Rysg2.
*     Scratch area for resolving degeneracies due to the double coset
*     treatement of the symmetry.
*     MemTrn: Scratch for decontraction
*     MemRys: Scratch for calualation of primitive integral gradients.
*
      iFac = 1
      If (mabcd.ne.1) iFac = 2
      MemF=9*nabcd*nijkl
      MemTrn=mabcd * Max(iPrInc*jBsInc*kBsInc*lBsInc,
     &                   iPrInc*jPrInc*kPrInc*lBsInc,
     &                   iPrInc*jPrInc*kPrInc*lPrInc*iFac)
      MemRys=MemPrm * iPrInc*jPrInc*kPrInc*lPrInc+80
*
*  Scratch space for contraction of the integrals
*
      MemCntrct=9*mabcd*(Max(iBsInc*jBsInc*kBsInc*lPrInc,
     &                       iBsInc*jPrInc*kPrInc*lPrInc)+
     &                       iBsInc*jBsInc*kPrInc*lPrInc)

      MemFck=Max(0,MemFck)
      MemMo=Max(0,MemMo)
      Mem3 = Max(MemMO,MemFck,MemTrn, MemRys, 2*MemF,
     &           MemF+MemCntrct)
      If (Mem3+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem3+1-Mem0)
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) 'PSOAO2: memory partitioning failed!'
            Write (6,*) '        Restart with more memory!'
            Call Abend()
         End If
         Go To 999
      End If
*-----Subtracte one additional word for getmem's internal error check
      Mem0 = Mem0 - Mem3 - 1
*
*-----Work4, if used, is placed at the end of Work2
      If (jPrInc.ne.jPrim .or. lPrInc.ne.lPrim) Then
         Mem4 = MemAux
      Else
         Mem4 = Mem2
      End If
*
      MemSum=Mem1+Mem2+Mem3+MemX+MemFin
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Int_Prep_g(iSD4,nSD,Coor,Shijij,iAOV,iStabs)

use Basis_Info, only: dbsc
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSD, iSD4(0:nSD,4)
real(kind=wp), intent(out) :: Coor(3,4)
logical(kind=iwp), intent(out) :: Shijij
integer(kind=iwp), intent(out) :: iAOV(4), iStabs(4)
integer(kind=iwp) :: iCnt, iCnttp, iQuad, jCnt, jCnttp, kCnt, kCnttp, lCnt, lCnttp

iCnttp = iSD4(13,1)
iCnt = iSD4(14,1)
jCnttp = iSD4(13,2)
jCnt = iSD4(14,2)
kCnttp = iSD4(13,3)
kCnt = iSD4(14,3)
lCnttp = iSD4(13,4)
lCnt = iSD4(14,4)

if (dbsc(iCnttp)%Aux) then
  Coor(1:3,1) = dbsc(jCnttp)%Coor(1:3,jCnt)
else
  Coor(1:3,1) = dbsc(iCnttp)%Coor(1:3,iCnt)
end if
Coor(1:3,2) = dbsc(jCnttp)%Coor(1:3,jCnt)

if (dbsc(kCnttp)%Aux) then
  Coor(1:3,3) = dbsc(lCnttp)%Coor(1:3,lCnt)
else
  Coor(1:3,3) = dbsc(kCnttp)%Coor(1:3,kCnt)
end if
Coor(1:3,4) = dbsc(lCnttp)%Coor(1:3,lCnt)

Shijij = (iSD4(11,1) == iSD4(11,3)) .and. (iSD4(11,2) == iSD4(11,4))

do iQuad=1,4
  iAOV(iQuad) = iSD4(7,iQuad)
  iStabs(iQuad) = iSD4(10,iQuad)
end do

return

end subroutine Int_Prep_g

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1995, Roland Lindh                                *
************************************************************************
      SubRoutine EFInt(
#define _CALLING_
#include "int_interface.fh"
     &                )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of electric field         *
*         integrals.                                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, January '91                             *
*                                                                      *
* Modified for explicit code, R. Lindh, February '95.                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      External TNAI, Fake, XCff2D, XRys2D
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables
      Integer iDCRT(0:7), iStabO(0:7)
      Real*8 TC(3), Coori(3,4), CoorAC(3,2)
      Logical EQ, NoSpecial
      Integer iAnga(4)
      Character*80 Label
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      iRout = 200
      iPrint = nPrint(iRout)
*
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = nOrdOp
      iAnga(4) = 0
      call dcopy_(3, A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
      mabMin=nabSz(Max(la,lb)-1)+1
      mabMax=nabSz(la+lb)
      If (EQ(A,RB)) mabMin=nabSz(la+lb-1)+1
      mcdMin=nabSz(nOrdOp-1)+1
      mcdMax=nabSz(nOrdop)
      lab=(mabMax-mabMin+1)
      kab=nElem(la)*nElem(lb)
      lcd=(mcdMax-mcdMin+1)
      labcd=lab*lcd
*
*---- Compute Flop's and size of work array which HRR will Use.
*
      Call mHRR(la,lb,nFLOP,nMem)
*
*---- Distribute the work array
*
      ip2 = 1
      ip1 = ip2 + nZeta*Max(labcd,lcd*nMem)
      mArr = nArr - Max(labcd,lcd*nMem)
*
*---- Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
         call dcopy_(3, A,1,CoorAC(1,1),1)
      Else
         call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
      llOper = lOper(1)
      Do 90 iComp = 2, nComp
         llOper = iOr(llOper,lOper(iComp))
 90   Continue
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
*
      Do 102 lDCRT = 0, nDCRT-1
         Call OA(iDCRT(lDCRT),CCoor,TC)
         call dcopy_(3,TC,1,CoorAC(1,2),1)
         call dcopy_(3,TC,1, Coori(1,3),1)
         call dcopy_(3,TC,1, Coori(1,4),1)
*
*------- Compute integrals with the Rys-Gauss quadrature.
*
         nT=nZeta
         NoSpecial=.True.
         Call Rys(iAnga,nT,
     &            Zeta,ZInv,nZeta,[One],[One],1,
     &            P,nZeta,TC,1,
     &            rKappa,[One],Coori,Coori,CoorAC,
     &            mabMin,mabMax,mcdMin,mcdMax,Array(ip1),mArr*nZeta,
     &            TNAI,Fake,XCff2D,XRys2D,NoSpecial)
*
*------- The integrals are now ordered as ijkl,e,f
*
*        a) Change the order to f,ijkl,e
*        b) Unfold e to ab, f,ijkl,ab
*        c) Change the order back to ijkl,ab,f
*
*a)-----
*
         Call DGetMO(Array(ip1),nZeta*lab,nZeta*lab,lcd,Array(ip2),lcd)
*
*b)----- Use the HRR to unfold e to ab
*
         Call HRR(la,lb,A,RB,Array(ip2),lcd*nZeta,nMem,ipIn)
         ip3=ip2-1+ipIn
*
*c)-----
*
         Call DGetMO(Array(ip3),lcd,lcd,nZeta*kab,Array(ip1),nZeta*kab)
*
*------- Modify to traceless form, the sixth element contains r*r and
*
         If (nOrdOp.eq.2) Then
*        If (.False.) Then
            nzab=nZeta*kab
            iOffxx=ip1
            iOffyy=ip1+nzab*3
            iOffzz=ip1+nzab*5
            ThreeI = One / Three
            Do i = 0, nzab-1
               RR = Array(iOffxx+i)
     &            + Array(iOffyy+i)
     &            + Array(iOffzz+i)
               XX = Two * Array(iOffxx+i) -
     &            Array(iOffyy+i) - Array(iOffzz+i)
               YY = Two * Array(iOffyy+i) -
     &            Array(iOffxx+i) - Array(iOffzz+i)
               ZZ = Two * Array(iOffzz+i) -
     &            Array(iOffxx+i) - Array(iOffyy+i)
               Array(iOffxx+i) = XX * ThreeI
               Array(iOffyy+i) = YY * ThreeI
               Array(iOffzz+i) = RR
            End Do
         End If
*
*        Stored as nZeta,iElem,jElem,iComp
*
         If (iPrint.ge.49) Then
            Write (6,*) ' In EFInt la,lb=',la,lb
            nzab=nZeta*kab
            Do iElem = 1, nElem(la)
               Do jElem = 1, nElem(lb)
                  ij = (jElem-1)*nElem(la) + iElem
                  ip = ip1 + nZeta*(ij-1)
                  Do iComp = 1, nComp
                     Write (Label,'(A,I2,A,I2,A,I2,A)')
     &                     ' Final (',iElem,',',jElem,',',iComp,') '
                     Call RecPrt(Label,' ',Array(ip),nZeta,1)
                     ip = ip + nzab
                  End Do
               End Do
            End Do
         End If
*
*------- Accumulate contributions
*
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array(ip1),nZeta,la,lb,nComp,Final,nIC,
     &               nOp         ,lOper,iChO,One)
*
 102  Continue
*     Call GetMem(' Exit EFInt','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_integer(nHer)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine SetUp_MCLR(DSYM)
      use Arrays, only: pInt1, pInt2
*
*   Setup pointers and size of metrixes (includes in Pointers.fh)
*
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"
* for the integrals needed in sigma gen
#include "Input.fh"
      integer dsym
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      ip=1
      Call ICopy(8**3,[0],0,ipMO,1)
*
      nn=0
      nbmx=0
      Do iS=1,nsym
         nA(iS)=nn
         nB(is)=nAsh(is)+nIsh(is)
         nn=nn+nAsh(iS)
         nbmx=Max(nbmx,nBas(iS))
      End Do
*
      Call Set_nbmx(nbmx)
*
      nna=nn
      n2Dens=itri(nnA**2,nnA**2)

      n1Dens=nnA*nnA
      ip=1
      Do kS=1,nSym
         Do lS=1,nsym
            klS=iEOr(lS-1,kS-1)+1
            Do jS=1,nSym
               Do iS=1,nSym
                  ijS=iEOr(iS-1,jS-1)+1
                  ipp=nOrb(iS)*nAsh(jS)*nAsh(kS)*nAsh(lS)
                  If (iEOr(ijS-1,klS-1)+1.eq.DSym.and.(ipp.ne.0)) Then
                     ipMO(kS,lS,jS)=ip
                     ip=ip+ipp
                  End If
               End Do
            End Do
         End Do
      End Do
*
      nmba=ip-1
      nDens=0
      nDensLT=0
      nCMO=0
      nDensC=0
      Call iCopy(8**2,[0],0,ipMat,1)
      Call iCopy(8**2,[0],0,ipMC,1)
      Call iCopy(8**2,[0],0,ipMatLT,1)
      Call iCopy(8,[0],0,ipCM,1)

      Do jS=1,nSym
         Do iS=1,js
            If (iEOr(iS-1,jS-1).eq.DSym-1) Then
               If (is.lt.js) Then
                  ipMatLT(jS,iS)=ipntso(js-1,is-1,2**(dsym-1),nBas)+1
                  nDensLT=nDensLT+nBas(iS)*nBas(jS)
                  iExt0=nOrb(is)-nIsh(is)
                  iExt1=nOrb(iS)-nRs1(iS)
                  iExt2=nOrb(iS)-nRs2(iS)
                  iExt3=nOrb(iS)-nRs3(iS)
                  iInt4=nOrb(js)-nish(js)-nAsh(js)
                  iExt4=nIsh(is)+nAsh(is)
                  ipMC(jS,iS)=nDensC+1
                  nDensC=nDensC+iExt0*nIsh(js)+
     &                          iExt1*nRs1(js)+
     &                          iExt2*nRs2(js)+
     &                          iExt3*nRs3(js)+
     &                          iExt4*iInt4
               End If
               If (is.eq.js) Then
                  i1=nOrb(is)-nish(is)-nAsh(is)
                  ipMatLT(jS,iS)=nDensLT+1
                  nDensLT=nDensLT+nBas(iS)*(nBas(is)+1)/2
                  ipMC(jS,iS)=nDensC+1
                  iint0=nOrb(is)-nIsh(is)
                  iint1=i1+nRs2(is)+nRs3(is)
                  iint2=i1+nRs3(is)
                  iint3=i1
                  nDensC=nDensC+iint0*nIsh(is)+
     &                          iint1*nRs1(is)+
     &                          iint2*nRs2(is)+
     &                          iint3*nRs3(is)
               End If
            End If
         End Do
         ipCM(jS)=nCMO+1
         nCMO=nCMO+nBas(js)**2
      End Do
*
      If (TimeDep) nDensC=2*nDensC
      ndens2=0
      matab=1
      Do jS=1,nSym
         Do iS=1,nSym
            If (iEOr(iS-1,jS-1).eq.DSym-1) Then
               ipMatba(is,js)=matab
               ipMat(jS,iS)=nDens2+1
               nDens2=nDens2+nBas(iS)*nBas(jS)
               matab=matab+nash(js)*nOrb(iS)
            End If
         End Do
      End Do
      ndens=ndens2
*
*  To begin with we assume that we have permutation symmetry
*
      if(iMethod.eq.2) then
      iOff=1
      Do iiSym=1,nSym
         iOrb=nRs1(iiSym)+nRs2(iiSym)+nRs3(iiSym)
         Do jjSym=1,iiSym
            jOrb=nRs1(jjSym)+nRs2(jjSym)+nRs3(jjSym)
*
            If (iEOr(iiSym-1,jjSym-1)+1.eq.Dsym) Then
               pINT1(iiSym)=iOff
               If (iiSym.eq.jjSym) Then
                  iOff=iOff+iOrb*(iOrb+1)/2
               Else
                  iOff=iOff+iOrb*jOrb
               End If
            End If
*
         End Do
      End Do
*
      iOff=1
      Do iiSym=1,nSym
         iOrb=nRs1(iiSym)+nRs2(iiSym)+nRs3(iiSym)
         Do jjSym=1,iiSym
            jOrb=nRs1(jjSym)+nRs2(jjSym)+nRs3(jjSym)
*
            ijSym=iEOr(iiSym-1,jjSym-1)+1
            klSym=iEOr(ijSym-1,DSym-1)+1
*
            ijNum= iiSym*(iiSym+1)/2+jjSym
*
            If (iiSym.eq.jjSym) Then
               ijOrb=iOrb*(iOrb+1)/2
            Else
               ijOrb=iOrb*jOrb
            End If
            Do kkSym=1,nsym
               kOrb=nRs1(kkSym)+nRs2(kkSym)+nRs3(kkSym)
*
               llSym=iEor(klSym-1,kkSym-1)+1
               lOrb=nRs1(llSym)+nRs2(llSym)+nRs3(llSym)
*
               If (llSym.gt.kkSym) Goto 100
*
               klNum=kkSym*(kkSym+1)/2+llSym
               If (klNum.gt.ijNum) Goto 100
*
               If (kkSym.eq.llSym) Then
                  klOrb=kOrb*(kOrb+1)/2
               Else
                  klOrb=kOrb*lOrb
               End If
               ip=iiSym+nSym*((jjSym-1)+nSym*(kkSym-1))
               If (ijNum.eq.klNum) Then
                  iPlus=ijOrb*(ijOrb+1)/2
               Else
                  iPlus=ijOrb*klOrb
               End If
*
               If (iPlus.gt.0) pINT2(ip)=iOff
*
               iOff=iOff+iPlus
*
 100           Continue
            End Do
         End Do
      End Do
      Endif
*

      Call Get_iArray('nFro',nFro,nSym)
      Do i = 1, nSym
         If (nFro(i).ne.0) Then
            Call WarningMessage(2,
     &               'MCLR module can not handle frozen orbitals!')
            Call Abend()
         End If
      End Do
      Call Put_iArray('nFroPT',nFro,nSym)
      Call Get_iArray('nDel',nDel,nSym)
      Do i = 1, nSym
         If (nDel(i).ne.0) Then
            Call WarningMessage(2,
     &               'MCLR module can not handle deleted orbitals!')
            Call Abend()
         End If
      End Do
      Call Put_iArray('nDelPT',nDel,nSym)

*     Call iWrtMa(pINT2,64,8,64,8)
*
      Return
      End

      Subroutine Set_nbmx(nbmx_)
      Implicit Real*8 (a-h,o-z)
#include "rasdim.fh"
#include "caspt2.fh"
*
      nbmx=nbmx_
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine EdmistonRuedenberg_Iter(Functional,CMO,Thrs,ThrRot,
     &                                   ThrGrad,
     &                                   nBasis,nOrb2Loc,nMxIter,
     &                                   Maximisation,Converged,Debug,
     &                                   Silent)
C
C     Thomas Bondo Pedersen, November 2005.
C
C     Purpose: ER localisation of orbitals.
C
C     The optimization algorithm is the "generalized eta step" of
C     Subotnik, Shao, Liang, and Head-Gordon, JCP 121, 9220 (2004).
C
C     Redundant arguments that might be used at a later stage:
C       ThrRot [might be used for DIIS]
C       Maximisation [might be used for Jacobi sweeps]
C
C     Note that two-electron integrals (Cholesky decomposed) must be
C     available and appropriately set up when calling this routine.
C
      Implicit Real*8 (a-h,o-z)
      Real*8  CMO(nBasis,nOrb2Loc)
      Logical Maximisation, Converged, Debug, Silent
#include "WrkSpc.fh"

      Character*23 SecNam
      Parameter (SecNam = 'EdmistonRuedenberg_Iter')

      Logical Timing

      If (Debug) Then
         Write(6,*) SecNam,'[debug]: Maximisation: ',Maximisation
         Write(6,*) SecNam,'[debug]: ThrRot      : ',ThrRot
      End If

C     Print iteration table header.
C     -----------------------------

      If (.not.Silent) Then
         Write(6,'(//,1X,A,A,/,1X,A,A)')
     &   '                                                        CPU ',
     &   '      Wall',
     &   'nIter      Functional ER        Delta     Gradient     (sec)',
     &   '     (sec)'
      End If

C     Initialization.
C     ---------------

      Converged = .False.
      Timing = Debug

      lRmat = nOrb2Loc**2
      Call GetMem('Rmat','Allo','Real',ipRmat,lRmat)

C     Iteration 0.
C     ------------

      If (.not.Silent) Call CWTime(C1,W1)
      nIter = 0
      Functional = 0.0d0
      Gradient = 1.0d15
      Call GetGrad_ER(Functional,GradNorm,Work(ipRmat),CMO,
     &                nBasis,nOrb2Loc,Timing)
      OldFunctional = Functional
      FirstFunctional = Functional
      FirstGradient = GradNorm
      Delta = Functional
      If (.not.Silent) Then
         Call CWTime(C2,W2)
         TimC = C2 - C1
         TimW = W2 - W1
         Write(6,'(1X,I5,1X,F18.8,2(1X,D12.4),2(1X,F9.1))')
     &   nIter,Functional,Delta,GradNorm,TimC,TimW
      End If

C     Iterations.
C     -----------

      Do While (nIter.lt.nMxIter .and. .not.Converged)
         If (.not.Silent) Call CWTime(C1,W1)
         Call RotateOrb_ER(Work(ipRmat),CMO,nBasis,nOrb2Loc,Debug)
         Call GetGrad_ER(Functional,GradNorm,Work(ipRmat),
     &                   CMO,nBasis,nOrb2Loc,Timing)
         nIter = nIter + 1
         Delta = Functional - OldFunctional
         OldFunctional = Functional
         If (.not.Silent) Then
            Call CWTime(C2,W2)
            TimC = C2 - C1
            TimW = W2 - W1
            Write(6,'(1X,I5,1X,F18.8,2(1X,D12.4),2(1X,F9.1))')
     &      nIter,Functional,Delta,GradNorm,TimC,TimW
         End If
         Converged=GradNorm.le.ThrGrad .and. abs(Delta).le.Thrs
      End Do

C     Print convergence message.
C     --------------------------

      If (.not.Silent) Then
         If (.not.Converged) Then
            Write(6,'(/,A,I4,A)')
     &      'No convergence after',nIter,' iterations.'
         Else
            Write(6,'(/,A,I4,A)')
     &      'Convergence after',nIter,' iterations.'
            Write(6,*)
            Write(6,'(A,I8)')    'Number of localised orbitals  : ',
     &                                                 nOrb2loc
            Write(6,'(A,F12.8)') 'Value of P before localisation: ',
     &                                                 FirstFunctional
            Write(6,'(A,F12.8)') 'Value of P after localisation : ',
     &                                                 Functional
         End If
      End If

C     Finalization.
C     -------------

      Call GetMem('Rmat','Free','Real',ipRmat,lRmat)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_INT_1_DBG(DIAG,LEVEL)
!
! Purpose: debug seward interface routine CHO_MCA_INT_1.
!
! LEVEL =  1: test diagonal, reduced set 1 (i.e. initial).
!          2: test diagonal, reduced set 2 (i.e. current).
!          3: test symmetry of integral matrix (shell quadruple-based)

use Cholesky, only: LuPri
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*)
integer(kind=iwp), intent(in) :: Level
integer(kind=iwp) :: IRED
logical(kind=iwp) :: LOCDIAG, LOCSYM

call CHO_HEAD('Debugging CHO_MCA_INT_1','=',80,LUPRI)
write(LUPRI,'(A,I2)') 'Debug level',LEVEL

if (LEVEL == 1) then
  LOCDIAG = .true.
  LOCSYM = .false.
  IRED = 1
else if (LEVEL == 2) then
  LOCDIAG = .true.
  LOCSYM = .false.
  IRED = 2
else if (LEVEL == 3) then
  LOCDIAG = .false.
  LOCSYM = .true.
else
  LOCDIAG = .false.
  LOCSYM = .false.
  write(LUPRI,'(A)') 'Debug level not recognized --- debug cancelled!'
end if

if (LOCDIAG) call CHO_MCA_INT_1_DBG1(DIAG,IRED)

if (LOCSYM) call CHO_MCA_INT_1_DBG2()

end subroutine CHO_MCA_INT_1_DBG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Ben Swerts                                             *
*               2016, Liviu Ungur                                      *
************************************************************************
      SubRoutine MakeDens(nBas,nOrb,Cff,OrbEn,EnergyWeight,Dens)
************************************************************************
*                                                                      *
*     purpose: Compute (energy weighted) density matrix in AO basis    *
*                                                                      *
*     input:                                                           *
*       nBas    : number of basis functions                            *
*       nOrb    : number of orbitals                                   *
*       Cff     : molecular orbital coefficients                       *
*       OrbEn   : molecular orbital energies                           *
*       EnergyWeight : if .true. do energy weighting                   *
*                                                                      *
*     output:                                                          *
*       Dens    : density matrix in triangular storage                 *
*                                                                      *
*     called from: Drv2El_FAIEMP                                       *
*                  FragPInt                                            *
*                                                                      *
*     written by: B. Swerts                                            *
*     modified by L. Ungur                                             *
*     simplified version of scf/done_scf.f                             *
*                                                                      *
************************************************************************
*
      Implicit  None
      Integer   nBas,nOrb
      Real*8    Cff(nBas*nOrb)
      Real*8    OrbEn(nOrb)
      Real*8    Dens(nBas*(nBas+1)/2)
      Logical   EnergyWeight
#include "real.fh"
      Integer i,j,Ind
      Integer ij,iRow,iCol
      Real*8  energy,Sum
      Logical DBG
*
*---- Statement function for triangular storage
      Ind(i,j) = i*(i - 1)/2 + j
      energy = One
*
      DBG=.false.
      if(DBG) write(6,*) 'MakeDens:  EnergyWeight',EnergyWeight
      if(DBG) call xFlush(6)
      if(DBG) write(6,*) 'MakeDens:  nBas=',nBas
      if(DBG) call xFlush(6)
      if(DBG) write(6,*) 'MakeDens:  nOrb=',nOrb
      if(DBG) call xFlush(6)
      if(DBG) write(6,*) 'MakeDens: OrbEn=',(OrbEn(i),i=1,nOrb)
      if(DBG) call xFlush(6)
      if(DBG) write(6,*) 'MakeDens:   Cff=',(Cff(i),i=1,nBas*nOrb)
      if(DBG) call xFlush(6)


      Do iRow = 1, nBas
        Sum = Zero
        ij  = -1
        Do i = 1, nOrb
          ij  = ij  + 1
          If(EnergyWeight) energy = OrbEn(i)
          Sum = Sum + energy * Cff(iRow + ij*nBas)
     &                       * Cff(iRow + ij*nBas)
        End Do
        Dens(Ind(iRow,iRow)) = Two*Sum
*
        Do iCol = 1, iRow - 1
          Sum = Zero
          ij  = -1
          Do i = 1, nOrb
             ij = ij  + 1
             If(EnergyWeight) energy = OrbEn(i)
             Sum = Sum + energy * Cff(iRow + ij*nBas)
     &                          * Cff(iCol + ij*nBas)
          End Do
          Dens(Ind(iRow,iCol)) = Two*Two*Sum
        End Do
      End Do
      if(DBG) call TriPrt('Dens in MakeDens',' ',Dens,nBas)
      if(DBG) call xFlush(6)
* Title,FmtIn,A,N
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ThermoChem_(UserT,UserP,TotalM,TRotA,TRotB,TRotC,nUserPT,nsRot,iMult,EVal,in_nFreq,lSlapaf)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, auTocm, auTokcalmol, auTokJ, kBoltzmann
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: UserT(64), UserP, TRotA, TRotB, TRotC
real(kind=wp), intent(in) :: TotalM, EVal(*)
integer(kind=iwp), intent(inout) :: nUserPT
integer(kind=iwp), intent(in) :: nsRot, iMult, in_nFreq
logical(kind=iwp), intent(in) :: lSlapaf
integer(kind=iwp) :: i, nFreq, nTR, nTr2
real(kind=wp) :: dFreqI, Energy, ZPVE
real(kind=wp), allocatable :: Freq(:), VibT(:)
real(kind=wp), parameter :: rk = kBoltzmann*1.0e-3_wp/auTokJ ! Boltzmann constant in a.u./ K

! If nUserPT == 0 (no User-defined Pressure and Temperatures)
! Compute thermodynamic data at 1.00 atm & 298.15 kelvin.

if (nUserPT == 0) then
  nUserPT = 1
  UserP = One
  UserT(1) = 298.15_wp
end if
call Get_dScalar('Last energy',Energy)

! Is the system linear?

nTR = 6
if (TRotA > 1.0e99_wp) then
  TRotA = Zero
  nTR = nTR-1
end if
if (TRotB > 1.0e99_wp) then
  TRotB = Zero
  nTR = nTR-1
end if
if (TRotC > 1.0e99_wp) then
  TRotC = Zero
  nTR = nTR-1
end if

! Remove translational and rotational frequencies

call mma_allocate(Freq,in_nFreq,label='Freq')
nFreq = 0
nTr2 = nTr
if (lSlapaf) nTr2 = 0
do i=1,in_nFreq
  dFreqI = EVal(i)
  if (dFreqI > 20.0_wp) then
    nFreq = nFreq+1
    Freq(nFreq) = dFreqI
  end if
end do
Freq(nFreq+1:) = Zero
if ((in_nFreq-nFreq-nTR2) > 0) write(u6,*) ' *** Warning: ',(in_nFreq-nFreq-nTR2),' vibrational contributions removed.'

! Convert frequencies from cm-1 to hartree

call mma_allocate(VibT,nFreq,label='VibT')
ZPVE = Zero
do i=1,nFreq
  Freq(i) = Freq(i)/auTocm ! = 219474.625
  VibT(i) = Freq(i)/rk
  ZPVE = ZPVE+Freq(i)*Half
end do
write(u6,'(A)') ' Vibrational temperature (K): '
do i=1,nFreq,5
  if (i <= (nFreq-4)) write(u6,'(1X,5F9.2)') VibT(i:i+4)
  if (i == (nFreq-3)) write(u6,'(1X,4F9.2)') VibT(i:i+3)
  if (i == (nFreq-2)) write(u6,'(1X,3F9.2)') VibT(i:i+2)
  if (i == (nFreq-1)) write(u6,'(1X,2F9.2)') VibT(i:i+1)
  if (i == (nFreq)) write(u6,'(1X, F9.2)') VibT(i)
end do
write(u6,'(A,I2)') ' Number of trans. and rot. degrees of freedom: ',nTR
write(u6,'(A,F9.3,A,F9.6,A)') ' ZPVE             ',ZPVE*auTokcalmol,' kcal/mol     ',ZPVE,' au.'
write(u6,'(A,13X,F15.6,A)') ' ZPVE corrected energy',ZPVE+Energy,' au.'

do i=1,nUserPT
  call Thermo_VibG(nFreq,Freq,UserT(i),UserP,TotalM,nTR,nsRot,TRotA,TRotB,TRotC,iMult,Energy)
end do
call mma_deallocate(Freq)
call mma_deallocate(VibT)

return

end subroutine ThermoChem_

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RdRfld()

use motra_global, only: HOne, nBas, nSym, PotNuc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iSym, nTemp
real(kind=wp) :: ERFself
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: Temp(:)

!----------------------------------------------------------------------*
! If this is a perturbative reaction field calculation then            *
! modifiy the one-electron Hamiltonian by the reaction field and       *
! the nuclear attraction by the cavity self-energy                     *
!----------------------------------------------------------------------*
nTemp = 0
do iSym=1,nSym
  nTemp = nTemp+nBas(iSym)*(nBas(iSym)+1)/2
end do
call mma_allocate(Temp,nTemp,label='RFFLD')
call f_Inquire('RUNOLD',Found)
if (Found) call NameRun('RUNOLD')
call get_dscalar('RF Self Energy',ERFself)
PotNuc = PotNuc+ERFself
call get_darray('Reaction field',Temp,nTemp)
if (Found) call NameRun('RUNFILE')
call Daxpy_(nTemp,One,Temp,1,HOne,1)
call mma_deallocate(Temp)
!----------------------------------------------------------------------*
! Normal termination                                                   *
!----------------------------------------------------------------------*
return

end subroutine RdRfld

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! PUT NUMBERS ON STARTFILE.
subroutine Put8(Ract,Etot,Gmma,Gam,Esav)

use qmstat_global, only: Cordst, iLuStut, iPrint, iTcSim, nCent, nPart, StFilUt
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_IN_) :: Ract, Etot, Gmma, Gam, Esav
integer(kind=iwp) :: i, iDisk
character(len=200) :: Head
real(kind=wp), allocatable :: CT(:)

call DaName(iLuStUt,StFilUt) !Here follows a general output to the startfile
iDisk = 0
call WrRdSim(iLuStUt,1,iDisk,iTcSim,64,Etot,Ract,nPart,Gmma,Gam,Esav)
iTcSim(1) = iDisk
! In this loop the coordinates are put on file.
! The loop is needed due to how Cordst is statically allocated.
call mma_allocate(CT,nPart*nCent,label='CTemp')
do i=1,3
  CT(:) = Cordst(i,1:nPart*nCent)
  call dDaFile(iLuStUt,1,CT,nPart*nCent,iDisk)
  iTcSim(1+i) = iDisk
end do
call mma_deallocate(CT)
iDisk = 0
call WrRdSim(iLuStUt,1,iDisk,iTcSim,64,Etot,Ract,nPart,Gmma,Gam,Esav)
call DaClos(iLuStUt)
if (iPrint >= 10) then !Print the stored configuration.
  write(Head,*) ' Coordinates put on the startfile solvent configuration.'
  call Cooout(Head,Cordst,nPart,nCent)
end if

return

end subroutine PUT8

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SUBVEC(A,B,C,N)

implicit real*8(A-H,O-Z)
dimension A(N), B(N), C(N)

do I=1,N
  A(I) = B(I)-C(I)
end do

return

end subroutine SUBVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!----------------------------------------------------------------------*
! This subroutine reads from the formatted file DIFFPR coming from     *
! generated by MpProp the Slater Exponents, Factors and Nuclear Charges*
!----------------------------------------------------------------------*
subroutine Get_Slater(LMltSlQ,outxyz,nAt)

use qmstat_global, only: SlExpQ
use Index_Functions, only: nTri3_Elem, nTri_Elem
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: LMltSlQ
integer(kind=iwp), intent(in) :: nAt
real(kind=wp), intent(in) :: outxyz(3,nTri_Elem(nAt))
integer(kind=iwp) :: iC, ind, jhr, l, Lu, nS, nSlCentQ, nT, nTestjhr
real(kind=wp) :: CoordTest(3), SlFactQ(6)
logical(kind=iwp) :: Exists
integer(kind=iwp), external :: IsFreeUnit
#include "warnings.h"

#include "macros.fh"

! Open the file
Lu = IsFreeUnit(40)
call Opnfl('DIFFPR',Lu,Exists)
if (.not. Exists) then
  write(u6,*)
  write(u6,*) ' Can not locate output file DiffPr. '
  call Quit(_RC_IO_ERROR_READ_)
end if
rewind(Lu)

! Read Number of centers and angular momenta.

read(Lu,101) nSlCentQ
read(Lu,101) LMltSlQ

! A first test
nTestjhr = nTri_Elem(nAt)
if (nSlCentQ /= nTestjhr) then
  write(u6,*) 'ERROR! Number of centers in DiffPr file',nSlCentQ,' is different from number of centers obtained from RUNFILE', &
              nTestjhr,' Check your files.'
  call Quit(_RC_GENERAL_ERROR_)
end if

! Read Exponentials for the Centers
call mma_allocate(SlExpQ,[0,LMltSlq],[1,nSlCentQ],label='SlExpQ')
do iC=1,nSlCentQ
  read(Lu,103) CoordTest(:)
  ind = 0
  do jhr=1,nSlCentQ
    if (abs(CoordTest(1)-outxyz(1,jhr)) < 1.0e-4_wp) then
      if (abs(CoordTest(2)-outxyz(2,jhr)) < 1.0e-4_wp) then
        if (abs(CoordTest(3)-outxyz(3,jhr)) < 1.0e-4_wp) then
          ind = jhr
        end if
      end if
    end if
  end do
  if (ind == 0) write(u6,*) 'ERROR. Something is very wrong, coordinates of DiffPr and MpProp files do not match. DiffPr center',iC
  do l=0,LMltSlQ
    nS = nTri3_Elem(l)
    nT = nTri3_Elem(l+1)
    read(Lu,104) SlExpQ(l,ind)
    read(Lu,105) SlFactQ(nS+1:nT)
    !read(Lu,105) SlFactQ(nS+1:nT,ind)
    unused_var(SlFactQ)
  end do
  !Jose. No read nuclear charge
  !read(Lu,104) PointP(ind)
  read(Lu,*)
end do

close(Lu)

return

101 format(I5)
103 format(3(F20.14))
104 format(F20.14)
105 format(3(F20.14))

end subroutine Get_Slater

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine casinfo2_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "casinfo_cvb.fh"

c  Information from molcas interface file "JOBIPH" :
      call rdjobiph_cvb('JOBIPH')
      call setjobiph_cvb(iorcore_c,iorclos_c,iorocc_c,mxirrep,
     >  nstsym_c,weight_c,istnel_c,istsy_c,istms2_c,nstats_c,
     >  mxstt_ci,mxstsy_ci,nel_c,norb_c,i2s_c,isym_c,mcore_c,neltot_c)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ProcInp_Caspt2
CSVC: process CASPT2 input based on the data in the input table, and
C initialize global common-block variables appropriately.
      Use InputData
      Implicit None
#include "rasdim.fh"
#include "warnings.fh"
#include "caspt2.fh"
#include "output.fh"
#include "pt2_guga.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "SysDef.fh"
#include "ofembed.fh"
#include "para_info.fh"

      Integer iDummy

* Number of non-valence orbitals per symmetry
      Integer nCore(mxSym)
      Integer nDiff, NFI, NSD
* Geometry-determining root
      Logical Is_iRlxRoot_Set
* Cholesky stuff
      Logical REORD,DECO,timings
      Integer Algo
      COMMON /CHORAS  / REORD,DECO,ALGO
      COMMON /CHOTIME / timings
* Environment
      Character(Len=180) Env

      Integer I, J, M, N
      Integer ISYM
* State selection
      Integer iGroup, IOFF
* Error condition
      Integer IERR

#include "chocaspt2.fh"


* Hzero and Focktype are merged together into Hzero. We keep the
* variable Focktype not to break the input keyword which is documented
* in the manual. However, eventually we will have to keep only Hzero
* and remove Focktype.
      Hzero = input%Hzero
      if (Hzero.ne.'STANDARD'.and.Hzero.ne.'CUSTOM') then
        call WarningMessage(2,
     &   'invalid 0th-order Hamiltonian: '//TRIM(Hzero))
        call Quit_OnUserError
      end if

* Choose Focktype, reset IPEA shift to 0 for non-standard fock matrices
      Focktype = input%Focktype
      if (Focktype.ne.'STANDARD') then
        if (IfChol) then
          Call WarningMessage(2,'Requested FOCKtype not possible.')
          WRITE(6,*)'Calculations using Cholesky vectors can only'
          WRITE(6,*)'be used with the standard FOCKtype!'
          Call Quit_OnUserError
        end if
* If both Hzero and Focktype are not standard, quit
        if (Hzero.ne.'STANDARD') then
          Call WarningMessage(2,'Requested combination of FOCKtype'//
     &                          ' and HZERo not possible.')
          Call Quit_OnUserError
        end if
* IPEA different from zero only for standard Focktype
        if (BSHIFT.gt.0.0d0.or.BSHIFT.lt.0.0d0) then
          BSHIFT = 0.0d0
          if (IPRGLB.ge.TERSE) then
            call WarningMessage(1,'IPEA shift reset to zero!')
          end if
        end if
      else
* user-specified IPEA shift or not?
        if (input%IPEA) then
          BSHIFT = input%BSHIFT
        else
* Set default IPEA to 0.25 Eh or 0.0
          call getenvf('MOLCAS_NEW_DEFAULTS', Env)
          call upcase(Env)
          if (Env.eq.'YES') then
            BSHIFT = 0.0d0
          else
            BSHIFT = 0.25d0
          end if
        end if
      end if

* Copy over to Hzero the content of Focktype, if Hzero is not CUSTOM
      if (Hzero.ne.'CUSTOM') then
        Hzero = Focktype
      end if

* print warnings if deviating from the default
      if (Hzero.ne.'STANDARD') then
        call warningmessage(1,'User-modified 0th-order Hamiltonian!')
      end if

* real/imaginary shifts
      SHIFT = Input % Shift
      SHIFTI = Input % ShiftI

* RHS algorithm selection
#ifdef _MOLCAS_MPP_
#  ifdef _GA_
C     The RHS on-demand algorithm doesn't handle serial calculations
C     because it's not adapted for use with regular Work arrays, only
C     global arrays, and needs to be switched off (using rhsall instead)
      RHSDIRECT=(Is_Real_Par().AND.Input%RHSD)
#  else
C     Without the Global Arrays library, we can't use the RHSALL2
C     and ADDRHS algorithms in parallel. Here we force the use of
C     RHS on-demand instead, depending on if the calculation is
C     really parallel or not.
      RHSDIRECT=Is_Real_Par()
#  endif
#else
      RHSDIRECT=.False.
#endif

* Cholesky: set defaults if it was not called during input
      If (.NOT.(Input % ChoI .or. Input % Chol)) Then
        Call Cho_caspt2_rdInp(.True.,iDummy)
      End If

*---  Initialize
      IDCIEX=0
      IEOF1M=0
      DO I=1,64
        IAD1M(I)=-1
      END DO
      RFpert = Input % RFPert

      NTIT=0
      OUTFMT='DEFAULT'
      G1SECIN=.FALSE.
      PRORB=.TRUE.
      PRSD=.FALSE.
      NCASES=13

      JMS = Input % JMS
      NLYROOT = Input % OnlyRoot
      NLYGROUP = 0

      DoCumulant = Input % DoCumulant

************************************************************************
*
* Root selection
*
************************************************************************
*SB: create a flat array, putting (X)MS states with increasing
* group number. Do not allow to run both MS and XMS in the same
* calculation, it can lead to catastrophic results.
* For MS, put one state per group, for XMS put all states in
* a single group.
* Example: lets say the input is:
* MULTistate = 3 3 4 5
*
* Then the arrays that are created will be:
* nstate = 3
* mstate(nstate): 3 4 5
* nGroup = 3
* nGroupState(nGroup): 1 1 1
*
* On the other hand, if the input is
* XMULtistate = 4 1 2 3 4
*
* Then the arrays that are created will be:
* nstate = 4
* mstate(nstate): 1 2 3 4
* nGroup = 1
* nGroupState(nGroup): 4
      NSTATE = 0
      MSTATE = 0
      NGROUP = 0
      NGROUPSTATE = 0
* This is the case for MS-CASPT2 and DW-CASPT2
      If (Input%MULT) Then
        If (Input%XMUL) Then
          Call WarningMessage(2,'Keyword MULTistate cannot be used '//
     &                          'together with keyword XMULtistate.')
          Call Quit_OnUserError
        End If
* Either the states were specified manually or the keyword "all"
* was used, so first we check the keyword all
        If (Input%AllMult) Then
          NSTATE = NROOTS
          MSTATE = IROOT
          NGROUP = NSTATE
          NGROUPSTATE(1:NGROUP)=1
        Else
* Save the states that need to be computed
          Do I=1,Input%nMultState
            MSTATE(I) = Input%MultGroup%State(I)
            NSTATE = NSTATE + 1
          End Do
          NGROUP = Input%nMultState
          NGROUPSTATE(1:NGROUP) = 1
        End If
      End If
      IOFF=NSTATE
* This is the case for XMS-CASPT2 and XDW-CASPT2
      if (Input%XMUL) then
        if (Input%MULT) then
          call WarningMessage(2,'Keyword XMULtistate cannot be used '//
     &                          'together with keyword MULTistate.')
          call Quit_OnUserError
        end if
* This is a XDW-CASPT2 calculation. It is actually more similar to
* a MS-CASPT2 one since we need to put one state per group and thus
* have as many groups as states. Nevertheless, it makes more sense
* from the user point of view to ask for it through XMUL and DWMS
        if (Input%DWMS) then
          if (Input%AllXMult) Then
            NSTATE = NROOTS
            MSTATE = IROOT
            NGROUP = NSTATE
            NGROUPSTATE(1:NGROUP)=1
          else
            do I=1,Input%nXMulState
              MSTATE(I) = Input%XMulGroup%State(I)
              NSTATE = NSTATE + 1
            end do
            NGROUP = Input%nXMulState
            NGROUPSTATE(1:NGROUP) = 1
          end if
* This is a XMS-CASPT2: one group with all the states
        else
          if (Input%AllXMult) Then
            NSTATE = NROOTS
            MSTATE = IROOT
            NGROUP=1
            NGROUPSTATE(1)=NSTATE
          else
            NGROUP = 1
            NGROUPSTATE(NGROUP) = Input%nXMulState
            do I=1,Input%nXMulState
              MSTATE(I) = Input%XMulGroup%State(I)
              NSTATE = NSTATE + 1
            end do
          end if
        end if
      End If
* After parsing mult or xmult, check that no two equal states where
* given in the input
      If (Input%MULT.OR.Input%XMUL) Then
        Do I=1,NSTATE
          Do J=I+1,NSTATE
            If (MSTATE(I).EQ.MSTATE(J)) Then
             Call WarningMessage(2,'The same root cannot be used '//
     &                             'twice in MULT/XMULT blocks.')
              Call Quit_OnUserError
            End If
          End Do
        End Do
      End If
* The LROOt keyword specifies a single root to be used. It should not be
* used together with either MULT or XMUL keywords.
      If (Input%LROO) Then
        If (Input%MULT.OR.Input%XMUL) Then
          Call WarningMessage(2,'Keyword LROO cannot be used together'//
     &                          'with the MULT or XMUL keywords.')
          Call Quit_OnUserError
        End If
        NSTATE=1
        MSTATE(1)=Input%SingleRoot
        NGROUP=1
        NGROUPSTATE(1)=1
      End If
* If still nothing was selected we should default to compute all the
* roots that were part of the rasscf orbital optimization.
      IF (NSTATE.EQ.0) THEN
        NSTATE=NROOTS
        MSTATE=IROOT
        NGROUP=NSTATE
        NGROUPSTATE(1:NGROUP)=1
      END IF
* Find the group number for OnlyRoot
      If (NLYROOT.ne.0) Then
        IOFF=0
        Do IGROUP=1,NGROUP
          Do I=1,NGROUPSTATE(IGROUP)
            If (IOFF+I.eq.NLYROOT) NLYGROUP=IGROUP
          End Do
          IOFF=IOFF+NGROUPSTATE(IGROUP)
        End Do
      End If
* Finally, some sanity checks.
      IF(NSTATE.LE.0.OR.NSTATE.GT.MXROOT) Then
        Call WarningMessage(2,'Number of states is <0 or too large.')
        WRITE(6,'(a,i8)')' NSTATE = ',NSTATE
        WRITE(6,*)' Check usage of keywords MULT/XMUL.'
        Call Quit_OnUserError
      END IF
* setup root to state translation
      ROOT2STATE = 0
      DO I=1,NSTATE
        ROOT2STATE(MSTATE(I))=I
      END DO
*
* Relax root selection
*
      iRlxRoot=-1
      Call Qpg_iScalar('NumGradRoot',Is_iRlxRoot_Set)
      If (Is_iRlxRoot_Set) Then
          Call Get_iScalar('NumGradRoot',iRlxRoot)
      End If
      If (Input % RlxRoot.gt.0) iRlxRoot=Input%RlxRoot
      If (iRlxRoot.eq.-1) iRlxRoot=NSTATE
      If (iRlxRoot.gt.NSTATE) Then
        If (IPRGLB.GE.TERSE) then
         Call WarningMessage(1,'Too large iRlxRoot.')
         WRITE(6,*)' Reset to NSTATE=',NSTATE
        End If
        iRlxRoot=NSTATE
      End If

************************************************************************
*
* Determine number of Frozen/Deleted orbitals
*
************************************************************************
* The number of Frozen orbitals is initially read from the reference
* wavefunction. Here, we modify that number to be the larger of what
* was in the reference and the non-valence orbitals.
      Call Get_iArray('Non valence orbitals',nCore,nSym)
      Do iSym = 1, nSym
        If (nCore(iSym).gt.nFro(iSym)) Then
          nDiff=nCore(iSym)-nFro(iSym)
          nDiff=min(nDiff,nISh(iSym))
          nFro(iSym)=nFro(iSym)+nDiff
          nISh(iSym)=nISh(iSym)-nDiff
        End If
      End Do
* If a user specified the number of frozen orbitals explicitely, then
* that number overwrites the automatically chosen numbers, but it we
* warn the user and report what the computed number was.
      IF(Input % FROZ) THEN
        IF(IPRGLB.GE.TERSE) THEN
          Call WarningMessage(1,'User changed nr of frozen orbitals.')
        END IF
        IERR=0
        DO I=1,NSYM
          NFI=NFRO(I)+NISH(I)
          IF(NFI.LT.Input%nFro(I)) THEN
            Call WarningMessage(2,'Too many frozen orbitals!')
            Call Quit_OnUserError
          ELSE
            nFro(I)=Input%nFro(I)
          END IF
          NISH(I)=NFI-nFro(I)
        END DO
      ENDIF
* Set user-specified number of deleted orbitals.
      IF(Input % DELE) THEN
        IERR=0
        DO I=1,NSYM
          NSD=NSSH(I)+NDEL(I)
          IF(NSD.LT.Input%nDel(I)) THEN
            Call WarningMessage(2,'Too many deleted orbitals!')
            Call Quit_OnUserError
          ELSE
            NDEL(I)=Input%nDel(I)
          END IF
          NSSH(I)=NSD-nDel(I)
        ENDDO
      ENDIF

* NOT TESTED
#if 0
************************************************************************
*
* Orbital-free embedding.
*
************************************************************************
      Done_OFemb=.false.
      First_OFE =.true.
      ipFMaux = -666666
      If (Input % OFEmbedding) Then
        Done_OFemb=.true.
        write(6,*)
        write(6,*)  '  --------------------------------------'
        write(6,*)  '   Orbital-Free Embedding Calculation   '
        write(6,*)  '  --------------------------------------'
        write(6,*)
      End If
#endif
************************************************************************
*
* Determine what kind of calculations are needed/requested.
*
************************************************************************
* flags for enabling/disabling sections
      IFPROP = Input % Properties
      IFDENS = Input % DENS
      IFMIX  = .NOT.Input % NoMix
      IFMSCOUP = (Input % MULT .OR. Input % XMUL)
     &           .AND.(.NOT.Input % NoMult)
      IFXMS = Input % XMUL
      IFDW = Input % DWMS
* Set exponent for DWMS
      if (IFDW) then
        zeta = Input % zeta
      end if

      IFEFOCK = Input % EFOC
      if (Input % EFOC) then
        if (.not.(IFXMS.and.IFDW)) then
          Call WarningMessage(2,'Keyword EFOCk can only be used'//
     &                          'in (X)DW-CASPT2 calculations.')
          Call Quit_OnUserError
        else
        end if
      end if

* Choice? of preprocessing route
      ORBIN='TRANSFOR'

*---  Expectation values of H0 needed or not? Spectral resolution?
      BMATRIX='YES     '
      BTRANS ='YES     '
      BSPECT ='YES     '
*---  Overlap matrix needed? Linear dependence removal needed?
      SMATRIX='YES     '
      SDECOM ='YES     '
C Presently, we always need the ON transformation/Lindep removal.
C Consistency of these demands:
      IF(BSPECT.NE.'NO      ') BTRANS ='YES     '
      IF(BTRANS.NE.'NO      ') BMATRIX='YES     '
      IF(BTRANS.NE.'NO      ') SDECOM ='YES     '
      IF(SDECOM.NE.'NO      ') SMATRIX='YES     '

************************************************************************
*
* Thresholds
*
************************************************************************
      If (Input%THRE) Then
        If (IPRGLB.GE.TERSE) THEN
          Call WarningMessage(1,
     &          'User modified linear dependency thresholds!')
        End If
      End If
      THRSHN=Input%THRSHN
      THRSHS=Input%THRSHS
      THRCONV=Input%THRCONV
      CITHR=Input%PrWF
      THRENE=5.0d+01
      THROCC=5.0d-04
      MAXIT=Input%MaxIter
      DNMTHR=Input%DNMTHR
      CMPTHR=Input%CMPTHR
      CNTTHR=Input%CNTTHR

*---  Create the symmetry multiplication table
      MUL(1,1)=1
      M=1
      DO N=1,3
        DO I=1,M
          DO J=1,M
            MUL(I+M,J)=M+MUL(I,J)
            MUL(I,J+M)=MUL(I+M,J)
            MUL(I+M,J+M)=MUL(I,J)
          END DO
        END DO
        M=2*M
      END DO
*
*---  Exit
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MKSEG_CP2(IDRT,IDOWN,LTV,IVR,MVL,MVR,ISGMNT,VSGMNT)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER(LEN=26) CC1,CC2,CTVPT,CBVPT,CSVC
      CHARACTER(LEN=20) FRML(7)
#include "pt2_guga.fh"
      COMMON /SEGTAB/ IC1(26),IC2(26),ITVPT(26),IBVPT(26),ISVC(26),
     &                NIVR,LIVR,NSGMNT,LSGMNT
      DIMENSION IVR(NVERT,2),ISGMNT(NVERT,26),VSGMNT(NVERT,26)
      DIMENSION IDRT(NVERT,5),IDOWN(NVERT,0:3),LTV(-1:NLEV)
      DIMENSION MVL(NMIDV,2),MVR(NMIDV,2)
C     PARAMETER (LTAB=1, NTAB=2, IATAB=3, IBTAB=4, ICTAB=5)
      PARAMETER (IATAB=3, IBTAB=4)
      PARAMETER (ZERO=0.0D0, ONE=1.0D00)
#ifdef _DEBUGPRINT_
      CHARACTER(LEN=20) TEXT
#endif

C PURPOSE: CONSTRUCT THE TABLES ISGMNT AND VSGMNT.
C ISGMNT(IVLT,ISGT) REFERS TO A SEGMENT OF THE SEGMENT TYPE
C    ISGT=1,..,26, WHOSE TOP LEFT VERTEX IS IVLT. ISGMNT GIVES
C    ZERO IF THE SEGMENT IS IMPOSSIBLE IN THE GRAPH DEFINED BY
C    THE PALDUS TABLE IDRT. ELSE IT IS THE BOTTOM LEFT VERTEX
C    NUMBER OF THE SEGMENT. THE SEGMENT VALUE IS THEN VSGMNT.

      CC1=  '01230201011230122313230123'
      CC2=  '01231323012230112302010123'
      CTVPT='00000000111112222211223333'
      CBVPT='00001122112112212233333333'
      CSVC ='11111615124721732215161111'
      FRML(1)='        1.0         '
      FRML(2)='       -1.0         '
      FRML(3)='        1/(B+1)     '
      FRML(4)='       -1/(B+1)     '
      FRML(5)='  SQRT(   B /(B+1)) '
      FRML(6)='  SQRT((B+2)/(B+1)) '
      FRML(7)='  SQRT(B(B+2))/(B+1)'
      READ(CC1,'(26I1)') IC1
      READ(CC2,'(26I1)') IC2
      READ(CTVPT,'(26I1)') ITVPT
      READ(CBVPT,'(26I1)') IBVPT
      READ(CSVC,'(26I1)') ISVC
      DO 5 IV=1,NVERT
        IVR(IV,1)=0
        IVR(IV,2)=0
   5  CONTINUE
      DO 20 LEV=1,NLEV
        IV1=LTV(LEV)
        IV2=LTV(LEV-1)-1
        DO 21 IVL=IV1,IV2
          IAL=IDRT(IVL,IATAB)
          IBL=IDRT(IVL,IBTAB)
          DO 10 IV=IVL+1,IV2
            IA=IDRT(IV,IATAB)
            IF(IA.EQ.IAL) THEN
              IB=IDRT(IV,IBTAB)
              IF(IB.EQ.(IBL-1)) IVR(IVL,1)=IV
            ELSE IF (IA.EQ.(IAL-1)) THEN
              IB=IDRT(IV,IBTAB)
              IF(IB.EQ.(IBL+1)) IVR(IVL,2)=IV
            END IF
  10      CONTINUE
  21    CONTINUE
  20  CONTINUE
C CONSTRUCT THE MVL AND MVR TABLES:
      DO 30 IVL=MIDV1,MIDV2
        MVLL=IVL-MIDV1+1
        MVRR=0
        IF(IVR(IVL,1).NE.0) MVRR=IVR(IVL,1)-MIDV1+1
        MVR(MVLL,1)=MVRR
        MVRR=0
        IF(IVR(IVL,2).NE.0) MVRR=IVR(IVL,2)-MIDV1+1
        MVR(MVLL,2)=MVRR
        MVL(MVLL,1)=0
        MVL(MVLL,2)=0
  30  CONTINUE
      DO 31 MV=1,NMIDV
        IF(MVR(MV,1).NE.0) MVL(MVR(MV,1),1)=MV
        IF(MVR(MV,2).NE.0) MVL(MVR(MV,2),2)=MV
  31  CONTINUE
#ifdef _DEBUGPRINT_
      WRITE(6,*)
      WRITE(6,*)' MIDVERT PAIR TABLES MVL,MVR IN MKSEG:'
      WRITE(6,*)' MVL TABLE:'
      WRITE(6,1234)(MV,MVL(MV,1),MVL(MV,2),MV=1,NMIDV)
      WRITE(6,*)' MVR TABLE:'
      WRITE(6,1234)(MV,MVR(MV,1),MVR(MV,2),MV=1,NMIDV)
 1234 FORMAT(3(3(1X,I4),4X))
      WRITE(6,*)
      WRITE(6,*)' VERTEX PAIR TABLE IVR IN MKSEG:'
      WRITE(6,1234)(IVL,IVR(IVL,1),IVR(IVL,2),IVL=1,NVERT)
#endif

C INITIALIZE SEGMENT TABLES, AND MARK VERTICES AS UNUSABLE:
      DO 40 IVLT=1,NVERT
        DO 41 ISGT=1,26
          ISGMNT(IVLT,ISGT)=0
          VSGMNT(IVLT,ISGT)=ZERO
  41    CONTINUE
  40  CONTINUE
      DO 100 IVLT=1,NVERT
        DO 101 ISGT=1,26
          ITT=ITVPT(ISGT)
          IVRT=IVLT
          IF((ITT.EQ.1).OR.(ITT.EQ.2)) IVRT=IVR(IVLT,ITT)
          IF(IVRT.EQ.0) GOTO 101
          IVLB=IDOWN(IVLT,IC1(ISGT))
          IF(IVLB.EQ.0) GOTO 101
          IVRB=IDOWN(IVRT,IC2(ISGT))
          IF(IVRB.EQ.0) GOTO 101
C SEGMENT IS NOW ACCEPTED AS POSSIBLE.

          ISGMNT(IVLT,ISGT)=IVLB
          IB=IDRT(IVLT,IBTAB)
          GOTO (1001,1002,1003,1004,1005,1006,1007) ISVC(ISGT)
 1001     V=ONE
          GOTO 99
 1002     V=-ONE
          GOTO 99
 1003     V=ONE/DBLE(1+IB)
          GOTO 99
 1004     V=-ONE/DBLE(1+IB)
          GOTO 99
 1005     V=SQRT(DBLE(IB)/DBLE(1+IB))
          GOTO 99
 1006     V=SQRT(DBLE(2+IB)/DBLE(1+IB))
          GOTO 99
 1007     V=SQRT(DBLE(IB*(2+IB)))/DBLE(1+IB)
  99      VSGMNT(IVLT,ISGT)=V
 101    CONTINUE
 100  CONTINUE

#ifdef _DEBUGPRINT_
        WRITE(6,*)' SEGMENT TABLE IN MKSEG.'
        WRITE(6,*)' VLT SGT ICL ICR VLB       SEGMENT TYPE    ',
     &            '     FORMULA'
        DO 200 IV=1,NVERT
          DO 201 ISGT=1,26
            ID=ISGMNT(IV,ISGT)
            IF(ID.EQ.0) GOTO 201
            ICL=IC1(ISGT)
            ICR=IC2(ISGT)
            IF(ISGT.LE.4) TEXT='  WALK SECTION.'
            IF((ISGT.GE.5).AND.(ISGT.LE.8)) TEXT=' TOP SEGMENT.'
            IF((ISGT.GE.9).AND.(ISGT.LE.18)) TEXT=' MID-SEGMENT.'
            IF((ISGT.GE.19).AND.(ISGT.LE.22)) TEXT=' BOTTOM SEGMENT.'
            IF(ISGT.GT.22) TEXT=' DOWN-WALK SECTION.'
            WRITE(6,2345) IV,ISGT,ICL,ICR,ID,TEXT,FRML(ISVC(ISGT))
 2345       FORMAT(1X,5I4,5X,A20,5X,A20)
  201     CONTINUE
  200   CONTINUE
#endif
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Write_QMMM(Coord,nAtIn,Iter)

use espf_global, only: MMI, MMO, QM
use Isotopes, only: PTab
use Molcas, only: LenIn
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Angstrom
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Iter, nAtIn
real(kind=wp), intent(in) :: Coord(3*nAtIn,Iter)
integer(kind=iwp) :: i, iAtIn, iAtNum, iAtOut, iAtTot, iFirst, k, Lu_XYZ, nAtOut, nAtTot
logical(kind=iwp) :: Found, isMMI, isMMO, isQM
character(len=LenIn) :: Symbol
character(len=16) :: FileName
character(len=LenIn), allocatable :: LabMMO(:)
integer(kind=iwp), allocatable :: AT(:)
real(kind=wp), allocatable :: Charge(:), CoordMMO(:,:)

call Qpg_dArray('MMO Coords',Found,nAtOut)
if (Found) then
  nAtOut = nAtOut/3
  nAtTot = nAtIn+nAtOut
  call mma_allocate(Charge,nAtIn)
  call mma_allocate(CoordMMO,3,nAtOut)
  call mma_allocate(LabMMO,nAtOut)
  call mma_allocate(AT,nAtTot)
  call Get_dArray('Nuclear charge',Charge,nAtIn)
  call Get_dArray('MMO Coords',CoordMMO,3*nAtOut)
  call Get_cArray('MMO Labels',LabMMO,LenIn*nAtOut)
  call Get_iArray('Atom Types',AT,nAtTot)

  ! Write one file per iteration and one for the current geometry
  do k=1,2
    if (k == 1) then
      write(FileName,'(I16.4)') Iter
      FileName = 'QMMMITXYZ.'//trim(adjustl(FileName))
    else
      FileName = 'QMMMENDXYZ'
    end if
    Lu_XYZ = 1
    call molcas_open(Lu_XYZ,FileName)
    write(Lu_XYZ,'(I6)') nAtTot
    write(Lu_XYZ,*)
    iAtIn = 1
    iAtOut = 1
    do iAtTot=1,nAtTot
      isQM = AT(iAtTot) == QM
      isMMI = AT(iAtTot) == MMI
      isMMO = AT(iAtTot) == MMO
      if (isQM .or. isMMI) then
        iAtNum = nint(Charge(iAtIn))
        iFirst = index(PTab(iAtNum),' ')+1
        Symbol = PTab(iAtNum)(iFirst:2)
        write(Lu_XYZ,100) Symbol,(Coord(3*(iAtIn-1)+i,Iter)*Angstrom,i=1,3)
        iAtIn = iAtIn+1
      else if (isMMO) then
        Symbol = LabMMO(iAtOut)
        if (index(Symbol,'_') > 1) then
          Symbol = Symbol(1:index(Symbol,'_')-1)
        end if
        write(Lu_XYZ,100) Symbol,(CoordMMO(i,iAtOut)*Angstrom,i=1,3)
        iAtOut = iAtOut+1
      end if
    end do
    close(Lu_XYZ)
  end do
  call mma_deallocate(Charge)
  call mma_deallocate(CoordMMO)
  call mma_deallocate(LabMMO)
  call mma_deallocate(AT)
end if

return

100 format(A6,3(1X,F12.6))

end subroutine Write_QMMM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Jeppe Olsen                                      *
!               2003, Jesper Wisborg Krogh                             *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MXMNOC_OCCLS(MINEL,MAXEL,NORBTP,NORBFTP,NELFTP,MINOP)
! Construct accumulated MAX and MIN arrays for an occupation class
!
! MINOP (Smallest allowed number of open orbitals) added
! April2, 2003, JO (modified by JWK, April - June 2003)

use lucia_data, only: MXPNGAS
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: MINEL(*), MAXEL(*)
integer(kind=iwp), intent(in) :: NORBTP, NORBFTP(*), NELFTP(*), MINOP
integer(kind=iwp) :: IBORB, IGAS, IORB, IORB_START, MAX_DOUBLE, MAXOP_EXL, MAXOP_GAS(MXPNGAS), MAXOP_T, MINOP_GAS(MXPNGAS), &
                     NEL_INI, NELEC, NGAS
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: NORB

write(u6,*)
write(u6,*) ' ============'
write(u6,*) ' MXMNOC_OCCLS'
write(u6,*) ' ============'
write(u6,*)
write(u6,*) ' MINOP  = ',MINOP
write(u6,*) ' NORBTP = ',NORBTP
write(u6,*) ' NORBFTP :'
call IWRTMA(NORBFTP,1,NORBTP,1,NORBTP)
#endif
! Well
NGAS = NORBTP

! Largest number of unpaired electrons in each gas space

MAXOP_GAS(1:NGAS) = min(NELFTP(1:NGAS),2*NORBFTP(1:NGAS)-NELFTP(1:NGAS))

! Smallest number of electrons in each GAS space

! 1 : Just based on number of electrons in each space
MINOP_GAS(1:NGAS) = mod(NELFTP(1:NGAS),2)
! 2 : the total number of open orbitals should be MINOP, this puts
! also a constraint on the number of open orbitals

! The largest number of open orbitals, all spaces
MAXOP_T = sum(MAXOP_GAS(1:NGAS))
do IGAS=1,NGAS
  ! Max number of open orbitals in all spaces except IGAS
  MAXOP_EXL = MAXOP_T-MAXOP_GAS(IGAS)
  MINOP_GAS(IGAS) = max(MINOP_GAS(IGAS),MINOP-MAXOP_EXL)
  if (mod(NELFTP(IGAS)-MINOP_GAS(IGAS),2) == 1) MINOP_GAS(IGAS) = MINOP_GAS(IGAS)+1
end do
! We now have the min and max number of open shells per occls,
! Find the corresponding min and max number accumulated electrons,

! The Max occupation is obtained by occupying in max in the
! first orbitals
! The Min occupation is obtained by occopying max in the
! last orbitals.

NEL_INI = 0
IBORB = 1
do IGAS=1,NGAS
  NELEC = NELFTP(IGAS)
  ! PAM2009: This looks like a bug. MAX_DOUBLE can go negative.
  !MAX_DOUBLE = (NELEC-MINOP_GAS(IGAS))/2
  ! Replace with:
  MAX_DOUBLE = max(0,(NELEC-MINOP_GAS(IGAS))/2)

  ! If you are in a situation with no electrons to spare

  if (NELEC == 0) then
    do IORB=1,NORBFTP(IGAS)
      if (IORB+IBORB-1 == 1) then
        MINEL(IORB+IBORB-1) = 0
        MAXEL(IORB+IBORB-1) = 0
      else
        MINEL(IORB+IBORB-1) = MINEL(IORB+IBORB-2)
        MAXEL(IORB+IBORB-1) = MAXEL(IORB+IBORB-2)
      end if
    end do
  else
    ! The min number of electrons

    ! Doubly occupy the last MAX_DOUBLE orbitals
    ! Start Jesper !!!
    if ((NORBFTP(IGAS)-MAX_DOUBLE <= 0) .and. (MINOP_GAS(IGAS) > 0)) call Abend()
    ! End Jesper !!!
    IORB_START = max(1,NORBFTP(IGAS)-MAX_DOUBLE)
    do IORB=IORB_START,NORBFTP(IGAS)
      MINEL(IORB+IBORB-1) = NEL_INI+NELEC-2*(NORBFTP(IGAS)-IORB)
      !write(u6,*) ' 1 IORB+IBORB-1, MINEL() ',IORB+IBORB-1,MINEL(IORB+IBORB-1)
    end do
    ! Singly occupy
    do IORB=NORBFTP(IGAS)-MAX_DOUBLE-1,1,-1
      MINEL(IORB+IBORB-1) = max(NEL_INI,MINEL(IORB+IBORB-1+1)-1)
      !write(u6,*) ' 2 IORB+IBORB-1, MINEL() ',IORB+IBORB-1,MINEL(IORB+IBORB-1)
    end do

    ! The max number of electrons

    do IORB=1,MAX_DOUBLE
      MAXEL(IORB+IBORB-1) = NEL_INI+2*IORB
    end do
    do IORB=MAX_DOUBLE+1,NORBFTP(IGAS)
      if (IORB+IBORB-1 == 1) then
        MAXEL(IORB+IBORB-1) = 1
      else
        MAXEL(IORB+IBORB-1) = min(NEL_INI+NELEC,MAXEL(IORB+IBORB-2)+1)
      end if
    end do
  end if
  NEL_INI = NEL_INI+NELFTP(IGAS)
  IBORB = IBORB+NORBFTP(IGAS)
end do

#ifdef _DEBUGPRINT_
NORB = sum(NORBFTP(1:NORBTP))
write(u6,*) ' MINEL :'
call IWRTMA(MINEL,1,NORB,1,NORB)
write(u6,*) ' MAXEL :'
call IWRTMA(MAXEL,1,NORB,1,NORB)
#endif

end subroutine MXMNOC_OCCLS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine PSGMDIA(ALPHA,BETA,IVEC,JVEC)
! Compute |JVEC> := BETA*|JVEC> + ALPHA*(H0(diag)-E0)*|IVEC>
! If real_shift /= Zero or imag_shift /= Zero, use a modified H0

use EQSOLV, only: IDBMat
use caspt2_global, only: LUSBT
use caspt2_module, only: nASup, nInDep, nISup, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: ALPHA, BETA
integer(kind=iwp), intent(in) :: IVEC, JVEC
integer(kind=iwp) :: ICASE, ISYM, JD, lg_V1, lg_V2, NAS, NIN, NIS
real(kind=wp), allocatable :: BD(:), ID(:)

do ICASE=1,13
  do ISYM=1,NSYM
    NIN = NINDEP(ISYM,ICASE)
    if (NIN == 0) cycle
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (NIS == 0) cycle
    ! Remember: NIN values in BDIAG, but must read NAS for correct
    ! positioning.
    call mma_allocate(BD,NAS,LABEL='BD')
    call mma_allocate(ID,NIS,LABEL='ID')
    JD = IDBMAT(ISYM,ICASE)
    call DDAFILE(LUSBT,2,BD,NAS,JD)
    call DDAFILE(LUSBT,2,ID,NIS,JD)

    call RHS_ALLO(NIN,NIS,lg_V2)

    if (BETA /= Zero) then
      call RHS_READ(NIN,NIS,lg_V2,ICASE,ISYM,JVEC)
      if (BETA /= 1) then
        call RHS_SCAL(NIN,NIS,lg_V2,BETA)
      !else
      !  call RHS_SCAL(NIN,NIS,lg_V2,Zero)
      end if
    end if

    if (ALPHA /= Zero) then
      if (BETA /= Zero) then
        call RHS_ALLO(NIN,NIS,lg_V1)
        call RHS_READ(NIN,NIS,lg_V1,ICASE,ISYM,IVEC)
        call RHS_SGMDIA(NIN,NIS,lg_V1,BD,ID)
        call RHS_DAXPY(NIN,NIS,ALPHA,lg_V1,lg_V2)
        call RHS_FREE(lg_V1)
      else
        call RHS_READ(NIN,NIS,lg_V2,ICASE,ISYM,IVEC)
        call RHS_SGMDIA(NIN,NIS,lg_V2,BD,ID)
        call RHS_SCAL(NIN,NIS,lg_V2,ALPHA)
      end if
    end if

    call RHS_SAVE(NIN,NIS,lg_V2,ICASE,ISYM,JVEC)
    call RHS_FREE(lg_V2)
    call mma_deallocate(BD)
    call mma_deallocate(ID)
  end do
end do

end subroutine PSGMDIA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Christophe Chipot                                      *
*               Janos G. Angyan                                        *
************************************************************************
      Subroutine PNT(IOut,nAtoms,CO,IRMax,DeltaR,IAn,nPts,Grid,
     &               IsMM,Process)
      Implicit Real*8(A-H,O-Z)
C
c     THIS SUBROUTINE CREATES A GRID OF POINTS AROUND A MOLECULE.
C
c     THE POINTS ARE INITIALLY SELECTED IN A CUBE, THEN RE-SCALED TO THE
c     SIZE OF THE MOLECULE.
C
c     THE POINTS LYING WITHIN THE VAN DER WAALS ENVELOPE OF THE
c     MOLECULE ARE EXCLUDED, BECAUSE OF THE PENETRATION EFFECTS.
c     THIS PROCEDURE IS BASED ON THE SCALED VDW RADII.
c     THE SCALING FACTOR : VDWFact
C
c     THE POINTS LYING OUTSIDE THE EXCLUSION RADIUS ARE EXCLUDED TOO.
c     THE EXCLUSION RADIUS  :  r_max
c     THE GRID STEP         :  delta_r
C
C     This subroutine comes from the Grid_3.1.2 program (C.CHIPOT, J.G.ANGYAN,
C     Universite' Henri Poincare' - Nancy 1, France)
C
      Logical Retain1,Retain2,Process
      Integer IsMM(nAtoms)
      Dimension CO(3,nAtoms),IAn(nAtoms),Grid(3,*),RVDW(0:54)
      Save Zero,Two,Huge,RVDW
      Data Zero/0.0D0/,Two/2.0D0/,Huge/1.0D8/,
     &     RVDW/2.00D0,1.20D0,1.40D0,
     1          1.82D0,0.00D0,0.00D0,1.70D0,1.55D0,1.50D0,1.47D0,
     2          1.54D0,2.27D0,1.73D0,2.30D0,2.10D0,1.80D0,1.80D0,
     3          1.75D0,1.88D0,2.75D0,0.00D0,0.00D0,0.00D0,1.22D0,
     4          0.00D0,0.00D0,0.00D0,0.00D0,1.63D0,1.40D0,1.39D0,
     5          1.87D0,0.00D0,1.85D0,1.90D0,1.85D0,2.02D0,0.00D0,
     6          0.00D0,0.00D0,0.00D0,0.00D0,0.00D0,0.00D0,0.0D00,
     7          0.00D0,1.63D0,1.72D0,1.58D0,1.93D0,2.17D0,0.00D0,
     8          2.06D0,1.98D0,2.16D0/
C
c     Criteria ?
C
      iPL = iPL_espf()-1
      RMax=dble(IRMax)
      If (Process .and. iPL.ge.3) then
        Write(IOut,'(A,I2,A)') ' Max : ',IRMax,' van der Waals radii'
        Write(IOut,'(A,F4.2,A)') ' ... with ',DeltaR,' angstroms'//
     &                           ' between grid points.'
      End If
C
c     The VDW scaling factor is currently hard-coded. Too be changed.
C
      VDWFact = 1.0d0
C
C
c     SEARCH FOR THE EXTREMA OF THE MOLECULAR GEOMETRY WITHIN A CUBE.
C
      xmax = - Huge
      xmin =   Huge
      ymax = - Huge
      ymin =   Huge
      zmax = - Huge
      zmin =   Huge
C
      RVDWMX = Zero
      Do 10 iAtom = 1, nAtoms
         If(IsMM(iAtom).ne.0) Then
           If (Process .and. iPL.ge.3) then
              Write(6,11) iAtom
11         Format (' MM atom',I3,' is ignored in the grid construction')
           End If
           Goto 10
         End If
         xmax   = Max(xmax,CO(1,iAtom))
         xmin   = Min(xmin,CO(1,iAtom))
         ymax   = Max(ymax,CO(2,iAtom))
         ymin   = Min(ymin,CO(2,iAtom))
         zmax   = Max(zmax,CO(3,iAtom))
         zmin   = Min(zmin,CO(3,iAtom))
         RVDWMX = Max(RVDWMX,RVDW(IAn(iAtom)))
10    Continue
      rSpher = RMax*RVDWMX
C
c     DETERMINE THE MINIMUM PARALLELEPIPED DIMENSIONS REQUIRED TO
c     CONTAIN THE MOLECULE, INCLUDING A MAXIMUM SELECTION RADIUS
c     ON BOTH SIDES.
C
      xrange = xmax - xmin + Two*rSpher
      yrange = ymax - ymin + Two*rSpher
      zrange = zmax - zmin + Two*rSpher
C
      nbptx = Int(xrange/DeltaR)
      nbpty = Int(yrange/DeltaR)
      nbptz = Int(zrange/DeltaR)
C
C
c     DETERMINE THE MAXIMUM NUMBER OF POINTS FOR THE FITTING PROCEDURE.
C
      maxpt = nbptx * nbpty * nbptz
C
C
c     PRINT OUT INTERMEDIATE RESULTS, IF SO REQUESTED
C
      If (iPL.gt.2) then
         Write(IOut,'(" EXTREMA OF THE MOLECULAR GEOMETRY : ")')
         Write(IOut,'(a)')
         Write(IOut,'(" X_min = ",f8.4,4x,"X_max = ",f8.4)')
     &        xmin, xmax
         Write(IOut,'(" Y_min = ",f8.4,4x,"Y_max = ",f8.4)')
     &        ymin, ymax
         Write(IOut,'(" Z_min = ",f8.4,4x,"Z_max = ",f8.4)')
     &        zmin, zmax
         Write(IOut,'(a)')
         Write(IOut,'(" RE-SCALED PARALLELEPIPED SIZE : ")')
         Write(IOut,'(a)')
         Write(IOut,'(" X = ",f8.4)') xrange
         Write(IOut,'(" Y = ",f8.4)') yrange
         Write(IOut,'(" Z = ",f8.4)') zrange
         Write(IOut,'(a)')
         Write(IOut,'(" NUMBER OF POINTS PER DIRECTION : ")')
         Write(IOut,'(a)')
         Write(IOut,'(" Nb_x = ",i5)') nbptx
         Write(IOut,'(" Nb_y = ",i5)') nbpty
         Write(IOut,'(" Nb_z = ",i5)') nbptz
         Write(IOut,'(a)')
         Write(IOut,'(" MAXIMUM POSSIBLE NUMBER OF POINTS : ")')
         Write(IOut,'(a)')
         Write(IOut,'(" Nb_max = ",i10)') maxpt
         Write(IOut,'(a)')
      End If
C
C
c     LOOP OVER ALL POSSIBLE POINTS IN THE PARALLELEPIPED.
C
      nPts = 0
C
      Do 20 Ipx = 0, nbptx
         pointa = xmin - rSpher + Dble(Ipx)*DeltaR
C
         Do 30 Ipy = 0, nbpty
            pointb = ymin - rSpher + Dble(Ipy)*DeltaR
C
            Do 40 Ipz = 0, nbptz
               pointc = zmin - rSpher + Dble(Ipz)*DeltaR
C
C
c     IS THIS POINT WITHIN THE VAN DER WAALS ENVELOPE ?
c          Retain1 => false
c     IS THIS POINT BEYOND THE EXCLUSION RADIUS FROM ALL ATOMS ?
c          Retain2 => false
C
               Retain1 = .True.
               Retain2 = .False.
C
               iAtom = 0
50             iAtom = iAtom + 1
               If (iAtom.gt.nAtoms) Goto 60
               If(IsMM(iAtom).ne.0) Goto 50
               RZ = RVDW(IAn(iAtom))
               VDWEnv = RZ*VDWFact
               Distance = (pointa - CO(1,iAtom))**2 +
     &                    (pointb - CO(2,iAtom))**2 +
     &                    (pointc - CO(3,iAtom))**2
               Distance = Sqrt(Distance)
               If(Retain1) Retain1 = Distance .gt. VDWEnv
               Retain2 = Retain2 .or. (Distance .le. (rmax*RZ))
               If(Retain1) Goto 50
C
c     STORE THE POINTS REQUIRED FOR THE FITTING PROCEDURE.
C
60             If (Retain1.and.Retain2) Then
                   nPts = nPts + 1
                   If (Process) Then
                      Grid(1,nPts) = pointa
                      Grid(2,nPts) = pointb
                      Grid(3,nPts) = pointc
                   End If
               End If
40          Continue
30       Continue
20    Continue
C
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cav_Hss(nAt,nAt3,nTs,nS,Eps,Sphere,iSphe,nOrd,Tessera,Q,DM,Der1,DerDM,Temp,DerTes,DerPunt,DerRad,DerCentr,Hess)

use PCM_Arrays, only: DiagScale
use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt, nAt3, nTs, nS, iSphe(nTs), nOrd(nS)
real(kind=wp), intent(in) :: Eps, Sphere(4,nS), Tessera(4,nTs), Q(2,nTs), DM(nTs,nTs), DerTes(nTs,nAt,3), DerPunt(nTs,nAt,3,3), &
                             DerRad(nS,nAt,3), DerCentr(nS,nAt,3,3)
real(kind=wp), intent(out) :: Der1(nTs), DerDM(nTs,nTs), Temp(nTs,nTs), Hess(nAt3,nAt3)
integer(kind=iwp) :: iAt1, iAt2, iAt2_S, iCoord1, iCoord2, Index1, Index2, iS, iTs, jTs, L
real(kind=wp) :: dCent, Diag, dN, dNI, Fact, QtotI, QtotJ, Sum1, Sum2, XN, YN, ZN

! Derivative of the cavity factor U_x(q)=2 Pi Eps/(Eps-1) sum_i [Qtot**2 * n_x]

Fact = Two*PI*Eps/(Eps-One)
Diag = -DiagScale*sqrt(PI)
dN = Zero
! Double loop on atoms and coordinates
do Index1=1,nAt3
  iAt1 = int((Index1-1)/3)+1
  iCoord1 = Index1-3*(iAt1-1)
  ! Derivative of the PCM matrix
  call DMat_CPCM(iAt1,iCoord1,nTs,nS,nAt,Diag,Tessera,DerDM,DerTes,DerPunt,DerCentr,iSphe)
  ! Matrix product: derivative of PCM matrix times the inverted matrix
  call DGEMM_('N','N',nTs,nTs,nTs,One,DerDM,nTs,DM,nTs,Zero,Temp,nTs)

  do Index2=1,nAt3
    iAt2 = int((Index2-1)/3)+1
    iCoord2 = Index2-3*(iAt2-1)
    ! Derivative of the normal factor n_x
    call Der_Norm(iAt1,iCoord1,iAt2,iCOord2,nTs,nAt,nS,Tessera,Der1,DerRad,DerTes,DerPunt,Sphere,iSphe,nOrd)
    ! Find out if atom iAt2 has a sphere around
    iAt2_S = 0
    do iS=1,nS
      if (iAt2 == nOrd(iS)) iAt2_S = iS
    end do
    Sum1 = Zero
    Sum2 = Zero
    ! Loop on tesserae
    do iTs=1,nTs
      QtotI = Q(1,iTs)+Q(2,iTs)
      L = iSphe(iTs)
      XN = -(Sphere(1,L)-Tessera(1,iTs))/Sphere(4,L)
      YN = -(Sphere(2,L)-Tessera(2,iTs))/Sphere(4,L)
      ZN = -(Sphere(3,L)-Tessera(3,iTs))/Sphere(4,L)
      if (L == iAt2_S) then
        if (iCoord2 == 1) dN = XN
        if (iCoord2 == 2) dN = YN
        if (iCoord2 == 3) dN = ZN
      else
        dCent = XN*DerCentr(L,iAt2,iCoord2,1)+YN*DerCentr(L,iAt2,iCoord2,2)+ZN*DerCentr(L,iAt2,iCoord2,3)
        dN = DerRad(L,iAt2,iCoord2)+dCent
      end if
      dNI = dN/Tessera(4,iTs)
      Sum1 = Sum1+QtotI*QtotI*Der1(iTs)
      do jTs=1,nTs
        QtotJ = Q(1,jTs)+Q(2,jTs)
        Sum2 = Sum2+Two*QtotI*dNI*Temp(iTs,jTs)*QtotJ
      end do
    end do
    Hess(Index1,Index2) = Fact*(Sum1+Sum2)
  end do
end do

return

end subroutine Cav_Hss

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992,1999, Roland Lindh                           *
!***********************************************************************

subroutine drv_ef_PCM(FactOp,nTs,FD,nFD,CCoor,lOper,VTessera,nOrdOp)
!***********************************************************************
!                                                                      *
! Object: to compute the local multipole moment, desymmetrize the 1st  *
!         order density matrix and accumulate contributions to the     *
!         global multipole expansion.                                  *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!             Modified for Hermite-Gauss quadrature November '90       *
!             Modified for Rys quadrature November '90                 *
!             Modified for multipole moments November '90              *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for general kernel routines January  91         *
!             Modified for nonsymmetrical operators February  91       *
!             Modified for gradients October  91                       *
!             Modified for reaction field calculations July  92        *
!             Modified loop structure  99                              *
!***********************************************************************

use Real_Spherical, only: ipSph, RSph
use iSD_data, only: iSD
use Basis_Info, only: dbsc, MolWgh, Shells
use Center_Info, only: dc
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use Index_Functions, only: nTri_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nTs, nFD, lOper(nTs), nOrdOp
real(kind=wp), intent(in) :: FactOp(nTs), FD(nFD), CCoor(4,nTs)
real(kind=wp), intent(inout) :: VTessera(3,nTs)
#include "angtp.fh"
#include "print.fh"
#include "nsd.fh"
#include "setup.fh"
integer(kind=iwp) :: i, iAng, iAO, iBas, iCmp, iCnt, iCnttp, iComp, iDCRR(0:7), iDCRT(0:7), ipFnlc, iPrim, iPrint, iRout, iS, &
                     iShell, iShll, iSmLbl, iStabM(0:7), iStabO(0:7), iTile, iuv, jAng, jAO, jBas, jCmp, jCnt, jCnttp, jPrim, jS, &
                     jShell, jShll, kk, lDCRR, lDCRT, lFinal, LmbdR, LmbdT, mdci, mdcj, MemKer, MemKrn, nComp, nDAO, nDCRR, nDCRT, &
                     niAng, njAng, nOp(3), nOrder, nScr1, nScr2, nSkal, nSO, nStabM, nStabO
real(kind=wp) :: A(3), B(3), C(3), FactNd, RB(3), TA(3), TRB(3)
logical(kind=iwp) :: AeqB
real(kind=wp), allocatable :: DAO(:), DSO(:), DSOp(:), Fnl(:), Kappa(:), Kern(:), PCoor(:), Scrt1(:), Scrt2(:), Zeta(:), ZI(:)
character(len=3), parameter :: ChOper(0:7) = ['E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz']
integer(kind=iwp), external :: MemSO1, n2Tri, NrOpr
real(kind=r8), external :: DDot_

iRout = 112
iPrint = nPrint(iRout)

! Auxiliary memory allocation.

call mma_allocate(Zeta,S%m2Max,label='Zeta')
call mma_allocate(ZI,S%m2Max,label='ZI')
call mma_allocate(Kappa,S%m2Max,label='Kappa')
call mma_allocate(PCoor,3*S%m2Max,label='PCoor')
!                                                                      *
!***********************************************************************
!                                                                      *
call Nr_Shells(nSkal)
!                                                                      *
!***********************************************************************
!                                                                      *
! Double loop over shells. These loops decide the integral type

do iS=1,nSkal
  iShll = iSD(0,iS)
  iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  mdci = iSD(10,iS)
  iShell = iSD(11,iS)
  iCnttp = iSD(13,iS)
  iCnt = iSD(14,iS)
  A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
  niAng = nTri_Elem1(iAng)
  do jS=1,iS
    jShll = iSD(0,jS)
    jAng = iSD(1,jS)
    jCmp = iSD(2,jS)
    jBas = iSD(3,jS)
    jPrim = iSD(5,jS)
    jAO = iSD(7,jS)
    mdcj = iSD(10,jS)
    jShell = iSD(11,jS)
    jCnttp = iSD(13,jS)
    jCnt = iSD(14,jS)
    B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
    njAng = nTri_Elem1(jAng)

    iSmLbl = 1
    nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
    if (nSO == 0) cycle
    if (iPrint >= 19) write(u6,'(A,A,A,A,A)') ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'

    ! Call kernel routine to get memory requirement.

    call EFMmP(nOrder,MemKer,iAng,jAng,nOrdOp)
    !write(u6,*) nOrder,MemKer,iAng,jAng,nOrdOp
    MemKrn = MemKer*S%m2Max
    call mma_allocate(Kern,MemKrn,label='Kernel')

    ! Allocate memory for the final integrals, all in the
    ! primitive basis.

    nComp = (nOrdOp+1)*(nOrdOp+2)/2
    lFinal = S%MaxPrm(iAng)*S%MaxPrm(jAng)*niAng*njAng*nComp
    call mma_allocate(Fnl,lFinal,label='Final')

    ! Scratch area for contraction step

    nScr1 = S%MaxPrm(iAng)*S%MaxPrm(jAng)*niAng*njAng
    call mma_allocate(Scrt1,nScr1,label='Scrtch')

    ! Scratch area for the transformation to spherical gaussians

    nScr2 = S%MaxPrm(iAng)*S%MaxPrm(jAng)*niAng*njAng
    call mma_allocate(Scrt2,nScr2,label='ScrSph')

    nDAO = iPrim*jPrim*niAng*njAng
    call mma_allocate(DAO,nDAO,label='DAO')

    ! At this point we can compute Zeta.

    call ZXia(Zeta,ZI,iPrim,jPrim,Shells(iShll)%Exp,Shells(jShll)%Exp)

    AeqB = iS == jS

    ! Find the DCR for A and B

    call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
    if (iPrint >= 49) write(u6,'(10A)') ' {R}=(',(ChOper(iDCRR(i)),i=0,nDCRR-1),')'

    ! Find the stabilizer for A and B

    call Inter(dc(mdci)%iStab,dc(mdci)%nStab,dc(mdcj)%iStab,dc(mdcj)%nStab,iStabM,nStabM)

    ! Allocate memory for the elements of the Fock or 1st order
    ! denisty matrix which are associated with the current shell
    ! pair.

    call mma_allocate(DSOp,nSO*iPrim*jPrim,label='DSOpr')
    call mma_allocate(DSO,nSO*iPrim*jPrim,label='DSO')

    ! Gather the elements from 1st order density / Fock matrix.

    call SOGthr(DSO,iBas,jBas,nSO,FD,n2Tri(iSmLbl),iSmLbl,iCmp,jCmp,iShell,jShell,AeqB,iAO,jAO)

    ! Project the Fock/1st order density matrix in AO
    ! basis on to the primitive basis.

    if (iPrint >= 99) then
      call RecPrt(' Left side contraction',' ',Shells(iShll)%pCff,iPrim,iBas)
      call RecPrt(' Right side contraction',' ',Shells(jShll)%pCff,jPrim,jBas)
    end if

    ! Transform IJ,AB to J,ABi
    call DGEMM_('T','T',jBas*nSO,iPrim,iBas,One,DSO,iBas,Shells(iShll)%pCff,iPrim,Zero,DSOp,jBas*nSO)
    ! Transform J,ABi to AB,ij
    call DGEMM_('T','T',nSO*iPrim,jPrim,jBas,One,DSOp,jBas,Shells(jShll)%pCff,jPrim,Zero,DSO,nSO*iPrim)
    ! Transpose to ij,AB
    call DGeTmO(DSO,nSO,nSO,iPrim*jPrim,DSOp,iPrim*jPrim)
    call mma_deallocate(DSO)

    if (iPrint >= 99) call RecPrt(' Decontracted 1st order density/Fock matrix',' ',DSOp,iPrim*jPrim,nSO)

    ! Loops over symmetry operations.

    do lDCRR=0,nDCRR-1
      call OA(iDCRR(lDCRR),B,RB)

      ! Loop over operators

      do iTile=1,nTs
        if (FactOp(iTile) == Zero) cycle
        C = Ccoor(1:3,iTile)

        ! Generate stabilizer of the operator.

        call SOS(iStabO,nStabO,lOper(iTile))

        ! Find the DCR for M and S

        call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
        if (iPrint >= 49) then
          write(u6,'(10A)') ' {M}=(',(ChOper(iStabM(i)),i=0,nStabM-1),')'
          write(u6,'(10A)') ' {O}=(',(ChOper(iStabO(i)),i=0,nStabO-1),')'
          write(u6,'(10A)') ' {T}=(',(ChOper(iDCRT(i)),i=0,nDCRT-1),')'
        end if

        ! Compute normalization factor due the DCR symmetrization
        ! of the two basis functions and the operator.

        iuv = dc(mdci)%nStab*dc(mdcj)%nStab
        FactNd = real(iuv*nStabO,kind=wp)/real(nIrrep**2*LmbdT,kind=wp)
        if (MolWgh == 1) then
          FactNd = FactNd*real(nIrrep,kind=wp)**2/real(iuv,kind=wp)
        else if (MolWgh == 2) then
          FactNd = sqrt(real(iuv,kind=wp))*real(nStabO,kind=wp)/real(nIrrep*LmbdT,kind=wp)
        end if
        FactNd = FactNd*FactOp(iTile)

        do lDCRT=0,nDCRT-1
          nOp(1) = NrOpr(iDCRT(lDCRT))
          nOp(2) = NrOpr(ieor(iDCRT(lDCRT),iDCRR(lDCRR)))
          nOp(3) = NrOpr(0)

          call OA(iDCRT(lDCRT),A,TA)
          call OA(iDCRT(lDCRT),RB,TRB)
          if (iPrint >= 49) then
            write(u6,'(A,/,3(3F6.2,2X))') ' *** Centers A, B, C ***',(TA(i),i=1,3),(TRB(i),i=1,3),(C(i),i=1,3)
            write(u6,*) ' nOp=',nOp
          end if

          ! Desymmetrize the matrix with which we will contract the trace.

          call DesymD(iSmLbl,iAng,jAng,iCmp,jCmp,iShell,jShell,iShll,jShll,iAO,jAO,DAO,iPrim,jPrim,DSOp,nSO,nOp,FactNd)

          ! Project the spherical harmonic space onto the cartesian space.

          kk = niAng*njAng
          if (Shells(iShll)%Transf .or. Shells(jShll)%Transf) then

            ! ij,AB --> AB,ij
            call DGeTmO(DAO,iPrim*jPrim,iPrim*jPrim,iCmp*jCmp,Scrt1,iCmp*jCmp)
            ! AB,ij --> ij,ab
            call SphCar(Scrt1,iCmp*jCmp,iPrim*jPrim,Scrt2,nScr2,RSph(ipSph(iAng)),iAng,Shells(iShll)%Transf,Shells(iShll)%Prjct, &
                        RSph(ipSph(jAng)),jAng,Shells(jShll)%Transf,Shells(jShll)%Prjct,DAO,kk)
          end if
          if (iPrint >= 99) call RecPrt(' Decontracted FD in the cartesian space',' ',DAO,iPrim*jPrim,kk)

          ! Compute kappa and P.

          call Setup1(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,TA,TRB,Kappa,PCoor,ZI)

          ! Compute the potential at a tessera.

          ! pcm_solvent
          !write(u6,*) 'Shells(iShll)%Exp(1),iPrim,Shells(jShll)%Exp(1),jPrim'
          !write(u6,*) Shells(iShll)%Exp(1),iPrim,Shells(jShll)%Exp(1),jPrim
          !write(u6,*) 'Zeta,ZI,Kappa,Pcoor'
          !write(u6,*) Zeta(1),ZI(1),Kappa(1),Pcoor(:)
          !write(u6,*) 'Fnl,iPrim*jPrim,nComp,iAng,jAng,norder'
          !write(u6,*) Fnl(1),iPrim*jPrim,nComp,iAng,jAng,norder
          ! pcm_solvent end
          call EFPrm(Shells(iShll)%Exp,iPrim,Shells(jShll)%Exp,jPrim,Zeta,ZI,Kappa,Pcoor,Fnl,iPrim*jPrim,nComp,iAng,jAng,TA,TRB, &
                     nOrder,Kern,MemKer,C,nOrdOp)
          if (iPrint >= 49) call RecPrt(' Final Integrals',' ',Fnl,nDAO,nComp)

          ! Trace with 1st order density matrix and accumulate
          ! to the potenital at tessera iTile

          if (iPrint >= 49) call RecPrt(' Decontracted FD in the cartesian space',' ',DAO,nDAO,1)
          ipFnlc = 1
          do iComp=1,nComp
            if (iPrint >= 49) call RecPrt('VTessera(iComp,iTile)',' ',VTessera(iComp,iTile),1,1)
            VTessera(iComp,iTile) = VTessera(iComp,iTile)+DDot_(nDAO,DAO,1,Fnl(ipFnlc),1)
            if (iPrint >= 49) call RecPrt('VTessera(iComp,iTile)',' ',VTessera(iComp,iTile),1,1)
            ipFnlc = ipFnlc+nDAO
          end do

        end do
      end do
    end do

    call mma_deallocate(Kern)
    call mma_deallocate(Fnl)
    call mma_deallocate(Scrt1)
    call mma_deallocate(Scrt1)
    call mma_deallocate(DAO)
    call mma_deallocate(DSOp)
  end do
end do

call mma_deallocate(Zeta)
call mma_deallocate(ZI)
call mma_deallocate(Kappa)
call mma_deallocate(PCoor)

return

end subroutine drv_ef_PCM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989-1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      Subroutine Alaska(LuSpool,ireturn)
************************************************************************
*                                                                      *
*  Object: Driver for the one and two electron integral gradient       *
*          program ALASKA.                                             *
*                                                                      *
*          Alaska is a derivative code of Seward 3.1.                  *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA     *
*          July '89 - May '90                                          *
*                                                                      *
*          Roland Lindh, Dept. of Theoretical Chemistry, University of *
*          Lund, SWEDEN. Modified to gradient calculations September   *
*          1991 - February 1992.                                       *
************************************************************************
      use Alaska_Info
      use Real_Spherical
      use Basis_Info
      use Temporary_Parameters
      use RICD_Info, only: Do_RI, Cholesky
      Implicit Real*8 (A-H,O-Z)
      External RF_On
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "disp.fh"
#include "rctfld.fh"
#include "nsd.fh"
#include "setup.fh"
#include "columbus_gamma.fh"
#include "nac.fh"
#include "alaska_root.fh"
#include "para_info.fh"
      Logical OldTst, DoRys, RF_On, Found
      Character(Len=180) Label
      Real*8, Allocatable:: Grad(:), Temp(:), Tmp(:), Rlx(:,:), CSFG(:)

      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
************ columbus interface ****************************************
        Integer  Columbus, colgradmode
        Integer lcartgrd
        Real*8 Cgrad(3,MxAtom)
        Character CNames(MxAtom)*(LENIN5),Lab*80
        Integer iatom,icen,j
*                                                                      *
************************************************************************
*                                                                      *
*     Call Alaska_banner()
      npelem=3
*                                                                      *
      Call CWTime(TCpu1,TWall1)
*                                                                      *
************************************************************************
*                                                                      *
*     Prologue
*                                                                      *
************************************************************************
*                                                                      *
      iRout=1
*                                                                      *
************************************************************************
*                                                                      *
*     Print program header
*
*                                                                      *
************************************************************************
*                                                                      *
*     Get the input information as Seward dumped on INFO.
*
      nDiff=1
      DoRys=.True.
      Call IniSew(DoRys,nDiff)
      If (RF_On()) Then
         If (NonEq_Ref) Then
            Call WarningMessage(2,'Error in Alaska')
            Write (6,*) 'NonEq=.True., invalid option'
            Call Abend()
         End If
         Call Init_RctFld(.False.,iCharge_Ref)
      End If
*
      OldTst = Test
*                                                                      *
************************************************************************
*                                                                      *
*     Input specific for the gradient calculation.
*
      Call Inputg(LuSpool)
*
*---- Since the input has changed some of the shell information
*     regenerate the tabulated shell information.
*
      iPrint=nPrint(iRout)


      Call mma_allocate(Grad,lDisp(0),Label='Grad')
      Call mma_allocate(Temp,lDisp(0),Label='Temp')
      Grad(:)=Zero
*
*     remove LuSpool
*
      Call Close_LuSpool(LuSpool)
*
*      identify a Columbus calculation
*      Columbus=1
*      colgradmode=0   standard gradient written to GRAD
*      colgradmode=1   standard gradient written to Grad State1
*      colgradmode=2   standard gradient written to Grad State1
*      colgradmode=3   non-adiabatic coupling vector written to NADC
*
       Call Get_iScalar('Columbus',Columbus)
       Call Get_iScalar('colgradmode',colgradmode)
*
*-----Start computing the gradients
*                                                                      *
************************************************************************
*                                                                      *
*     Compute nuclear contributions.
*
      If (king().or.HF_Force) Then
*
*    per default NADC must not have nuclear contributions added
*
       If (NO_NUC .or. (Columbus.eq.1 .and. colgradmode.eq.3)) then
         write(6,*) 'Skipping Nuclear Charge Contribution'
       Else
         Call DrvN1(Grad,Temp,lDisp(0))
         If (iPrint.ge.15) Then
            Lab=' Total Nuclear Contribution'
            Call PrGrad(Lab,Grad,lDisp(0),ChDisp,iPrint)
         End If
       End If
      End If

!      iPrint=16
*
************************************************************************
*                                                                      *
      If (Do_OFemb) Then
* RepNuc term to the Orbital-Free Embedding gradient
         Call DrvN1_EMB(Grad,Temp,lDisp(0))
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
      If (Test) Go To 999
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute contribution due to the derivative of the one-
*     electron hamiltonian and the contribution due the re-
*     normalization.
*
      If (.Not.(nProcs.gt.1).or.Onenly) Then
         Call Drvh1(Grad,Temp,lDisp(0))
      End If ! .Not.(nProcs.gt.1).or.Onenly
      If (Do_OFemb) Then
* NucAtt term to the Orbital-Free Embedding gradient
         Call Drvh1_EMB(Grad,Temp,lDisp(0))
      EndIf
!         Lab='Nuc + One-electron Contribution'
!         Call PrGrad(Lab,Grad,lDisp(0),ChDisp,iPrint)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the DFT contribution to the gradient
*
      Call DrvDFTg(Grad,Temp,lDisp(0))
*                                                                      *
************************************************************************
*                                                                      *
      If (Onenly) Go To 998
*                                                                      *
************************************************************************
*                                                                      *
*     DFT-type Orbital-Free Embedding term to the gradient
*
      If (Do_OFemb) Call DrvEMBg(Grad,Temp,lDisp(0))
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute contribution due to 2-electron integrals.
*
      If (Cholesky.or.Do_RI) Then
         If (Cholesky) Then
            If (iPrint.ge.6) Write (6,*) 'Cholesky-ERI gradients!'
         Else
            If (iPrint.ge.6) Write (6,*) 'RI-ERI gradients!'
         End If
         Call Drvg1_RI (Grad,Temp,lDisp(0))
      Else
         If (iPrint.ge.6) Write (6,*) 'Conventional ERI gradients!'
         Call Drvg1    (Grad,Temp,lDisp(0))
      End If
*
      Call DScal_(lDisp(0),Half,Temp,1)
      If (iPrint.ge.15) Then
         Lab=' Two-electron Contribution'
         Call PrGrad(Lab,Temp,lDisp(0),ChDisp,iPrint)
      End If
*
*-----Accumulate contribution to the gradient
*
      Call GR_DArray(Grad,lDisp(0))
      Call DaXpY_(lDisp(0),One,Temp,1,Grad,1)
*
*                                                                      *
************************************************************************
*                                                                      *
 998  Continue
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu2,TWall2)
      Call SavTim(7,TCpu2-TCpu1,TWall2-TWall1)
*                                                                      *
************************************************************************
*                                                                      *
*-----Apply the translational and rotational invariance of
*     the energy.
*
      If (TRSymm) Then
         If (iPrint.ge.99) Then
            Call PrGrad(
     &       ' Molecular gradients (no TR) ',
     &           Grad,lDisp(0),ChDisp,iPrint)
            Call RecPrt(' The A matrix',' ',Am,lDisp(0),lDisp(0))
         End If
         call dcopy_(lDisp(0),Grad,1,Temp,1)

         Call dGeMV_('N',lDisp(0),lDisp(0),
     &              One,Am,lDisp(0),
     &              Temp,1,
     &              Zero,Grad,1)
         Call mma_deallocate(Am)
      End If ! TRSymm
*                                                                      *
************************************************************************
*                                                                      *
*-----Equivalence option
*
      If (lEq) Then
         Do i = 1, lDisp(0)
            If (IndxEq(i).ne.i) Grad(i) = Grad(IndxEq(i))
         End Do
      End If ! lEq
*                                                                      *
************************************************************************
*                                                                      *
 999  Continue
*                                                                      *
************************************************************************
*                                                                      *
      nCnttp_Valence=0
      Do iCnttp = 1, nCnttp
         If (dbsc(iCnttp)%Aux) Exit
         nCnttp_Valence = nCnttp_Valence+1
      End Do
*
*     f^AB is the "total derivative coupling"
*     h^AB is the "CI derivative coupling"
*     f^AB = <B|dA/dR> = h^AB/(E_A-E_B) + f_CSF^AB = -f^BA
*     h^AB = <B|dH/dR|A> = h^BA
*     f_CSF^AB = -f_CSF^BA
*
*     Note that we store h^AB + f_CSF^AB*(E_A-E-B), or just h^AB if
*     NOCSF was given, to avoid division by (nearly) zero
*
      If (isNAC) Then
        Call PrGrad('CI derivative coupling ',
     &                 Grad,lDisp(0),ChDisp,iPrint)
        EDiff_s = Max(One, Ten**(-Floor(Log10(Abs(EDiff)))-4))
        EDiff_f = EDiff*EDiff_s
        If (DoCSF) Then
          Call mma_Allocate(CSFG,lDisp(0),Label='CSFG')
          Call CSFGrad(CSFG,lDisp(0))
          Call PrGrad('CSF derivative coupling ',
     &                  CSFG,lDisp(0),ChDisp,iPrint)
          Call daxpy_(lDisp(0),EDiff_f,CSFG,1,Grad,1)
          Call mma_deallocate(CSFG)
        End If
        write(6,'(15X,A,ES13.6)') 'Energy difference: ',EDiff
        Label = ''
        If (EDiff_s.gt.One)
     &      Write(Label,'(A,ES8.1,A)') ' (divided by',EDiff_s,')'
        Label = 'Total derivative coupling'//Trim(Label)
        Call mma_allocate(Tmp,lDisp(0),Label='Tmp')
        Tmp(:)=Grad(:)/EDiff_f
        Call PrGrad(Trim(Label),Tmp,lDisp(0),ChDisp,iPrint)
        write(6,'(15X,A,F12.4)') 'norm: ',dnrm2_(lDisp(0),Tmp,1)
        Call mma_deallocate(Tmp)
      ElseIf (iPrint.ge.4) then
         If (HF_Force) Then
            Call PrGrad('Hellmann-Feynman Forces ',
     &                 Grad,lDisp(0),ChDisp,iPrint)
         Else
            Call PrGrad(' Molecular gradients',
     &                    Grad,lDisp(0),ChDisp,iPrint)
         End If
      End If
      If (isNAC) Then
*        For NAC, the sign is undefined (because the wave functions can
*        change sign), check only absolute values
         Call mma_allocate(Tmp,lDisp(0),Label='Tmp')
         Tmp(:)=ABS(Grad(:))
         Call Add_Info('Grad',Tmp,lDisp(0),6)
         Call mma_deallocate(Tmp)
      Else
         Call Add_Info('Grad',Grad,lDisp(0),6)
      End If
*
*---- Molcas format
*
*-----Write gradient to runfile.
*
*     Save the gradient
*

      Call Get_iScalar('Unique atoms',nsAtom)
      l1 = 3*nsAtom
      Call mma_allocate(Rlx,3,nsAtom,Label='Rlx')
      mdc = 0
      ndc = 0
      Do iCnttp = 1, nCnttp_Valence
*
*        Skip gradients for pseudo atoms
*
         If (dbsc(iCnttp)%pChrg.or.dbsc(iCnttp)%nFragType.gt.0.or.
     &       dbsc(iCnttp)%Frag) Then
            mdc=mdc+dbsc(iCnttp)%nCntr
         Else
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               mdc=mdc+1
               ndc=ndc+1
               Do iCar = 1, 3
                  If (InxDsp(mdc,iCar).ne.0) Then
                     Rlx(iCar,ndc) = Grad(InxDsp(mdc,iCar))
                  Else
*
*                    Put in explicit zero if gradient is zero
*                    by symmetry.
*
                     Rlx(iCar,ndc) = Zero
                  End If
               End Do
            End Do
         End If
      End Do
*
      If (HF_Force) Then
         Call Put_dArray('HF-forces',Rlx,l1)
      Elseif (Columbus.eq.1) then
         Call Put_nadc(colgradmode,Rlx,l1)
      Else
         Call Put_Grad(Rlx,l1)
      End If
      Call mma_deallocate(Rlx)


************ columbus interface ****************************************
* print full cartesian gradient in Columbus format
*

      if (Columbus.eq.1) then
*     Real*8 Cgrad(3,mxatom)
*     Character CNames(MxAtom)*9
*     Integer lcartgrd, iatom,icen,j
      Call TrGrd_Alaska_(CGrad,CNames,Grad,lDisp(0),iCen)
      lcartgrd=60
      lcartgrd=isFreeUnit(lcartgrd)
      Call Molcas_Open(lcartgrd,'cartgrd')
      DO 300 IATOM = 1,iCen
        write (60,1010) (CGrad(j,iatom), j=1,3)
  300 CONTINUE
      close(lcartgrd)
 1010 format (3d15.6)
      endif

*
*-----At the end of the calculation free all memory to check for
*     corruption of the memory.
*
      Call mma_deallocate(Temp)
      Call mma_deallocate(Grad)
*
*     Restore iRlxRoot if changed as set by the RASSCF module.
*
      Call qpg_iScalar('Relax CASSCF root',Found)
      If (Found) Then
         Call Get_iScalar('Relax CASSCF root',irlxroot1)
         Call qpg_iScalar('Relax Original root',Found)
         If (Found) Then
            Call Get_iScalar('Relax Original root',irlxroot2)
            If (iRlxRoot1.ne.iRlxRoot2) Then
               Call Put_iScalar('Relax CASSCF root',irlxroot2)
               Call Put_iScalar('NumGradRoot',irlxroot2)
            End If
         End If
      End If
*
*     Epilogue
*
      Call ClsSew()
*
      If (iPrint.ge.6) Then
         Call FastIO('STATUS')
      End If
*
      If (Test) Then
         ireturn=20
      Else
         ireturn=0
      End If
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine SetUp_iSD()
      use iSD_data
      use k2_arrays, only: MxDij, MxFT
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "nsd.fh"
#include "setup.fh"
#include "stdalloc.fh"
*
*                                                                      *
************************************************************************
*                                                                      *
      If (Allocated(iSD)) Call mma_deallocate(iSD)
      Call Nr_Shells(nSkal)
      mSkal=nSkal
      nSkal_iSD=nSkal+4  ! Add four slots for future use.
      call mma_allocate(iSD,[0,nSD],[1,nSkal_iSD],label='iSD')
      Call Def_Shells(iSD,nSD,nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*.... Compute the size of and allocate auxiliary memory
*
      MxPrm = 0
      MxFT = 0
      MxDij = 0
      Do iS = 1, nSkal
         iCmp =iSD(2,iS)
         iBas =iSD(3,iS)
         iPrim=iSD(5,iS)
         MxPrm=Max(MxPrm,iPrim)
         If (nIrrep.eq.1) Then
            MxFT=1 ! Dummay assignment
            MxDij= Max(MxDij,iCmp**2+iPrim**2+1)
         Else
            MxFT = Max(MxFT,6*(iBas*iCmp)**2)
            MxDij= Max(MxDij,(iBas**2+1)*iCmp**2+iPrim**2+1)
         End If
      End Do
      MxDij = 6 * nIrrep * MxDij
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine COUNT_MRCI(NINTGR,NSYM,NORB,MUL)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: NINTGR
integer(kind=iwp), intent(in) :: NSYM, NORB(*), MUL(8,8)
integer(kind=iwp) :: IJS, IS, ISUM, JS, NDPROD(8), NORBT

! COUNT TWO-ELECTRON INTEGRALS
! FIRST, COUNT NUMBER OF DENSITY PRODUCTS IN EACH SYMMETRY:
NDPROD(1) = 0
NORBT = 0
do IS=1,NSYM
  NDPROD(IS) = 0
  NORBT = NORBT+NORB(IS)
end do
do IJS=1,NSYM
  ISUM = 0
  do IS=1,NSYM
    JS = MUL(IS,IJS)
    if (JS <= IS) ISUM = ISUM+NORB(IS)*NORB(JS)
  end do
  NDPROD(IJS) = ISUM
end do
NDPROD(1) = (NDPROD(1)+NORBT)/2
! THEN COUNT NUMBER OF TOTALLY SYMMETRIC PRODUCTS OF DENS-PRODUCTS:
NINTGR = 0
do IJS=1,NSYM
  NINTGR = NINTGR+NDPROD(IJS)*(1+NDPROD(IJS))
end do
NINTGR = NINTGR/2

return

end subroutine COUNT_MRCI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine GetTau (Tau,T1,
     c                     aGrp,bGrp,dima,dimb,adda,addb,lunTau)
c
c       this routine do:
c       1) read the block of T2((a,b)',ij) from T2Name(aGrp,bGrp)
c        2) Make Tau ((a,b)',ij) in T2((a,b)',ij) array
c
c       I/O parameter description:
c       Tau      - array for Tau((a,b),ij) (O)
c       aGrp     - group of a index
c       bGrp     - group of b index
c       dima     - dimension group of a' index
c       dimb     - dimension group of b' index
c       adda     - shift of a' in full virtual space
c       addb     - shift of b' in full virtual space
c       lunTau   - Lun of opened file, where Tau is stored
c
c
        implicit none
#include "chcc1.fh"
#include "chcc_files.fh"
c
        real*8 Tau(1)
        real*8 T1(1)
        integer aGrp,bGrp,dima,dimb,adda,addb,lunTau
c
c       help variables
        integer length
c
c
c1      def legth
c
        if (aGrp.eq.bGrp) then
c       groups of a and b are equal, reading for a'>=b'
          length=no*no*Dima*(Dima+1)/2
        else
c       aGrp>bGrp, reading for a',b' in given groups
          length=no*no*Dima*Dimb
        end if
c
c
c2      read block of T2 amplitudes
c
        call GetX (Tau(1),length,LunTau,T2Name(aGrp,bGrp),1,1)
c
c
c3        make Tau
c
        if (aGrp.ne.bGrp) then
           call GetTauHlp1 (Tau(1),T1(1),dima,dimb,adda,addb,no,nv)
        else
           call GetTauHlp2 (Tau(1),T1(1),dima,adda,no,nv)
        end if


        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Cav_Hss(nAt,nAt3,nTs,nS,Eps,Sphere,iSphe,nOrd,
     &     Tessera,Q,DM,Der1,DerDM,Temp,DerTes,DerPunt,DerRad,DerCentr,
     &     Hess,nHess)
      Implicit Real*8(a-h,o-z)
      Dimension Sphere(4,*),iSphe(*),nOrd(*)
      Dimension Tessera(4,*),Q(2,*),Der1(*)
      Dimension DM(nTs,*),DerDM(nTs,*),Temp(nTs,*)
      Dimension DerTes(nTs,nAt,3), DerPunt(nTs,nAt,3,3)
      Dimension DerRad(nS,nAt,3),DerCentr(nS,nAt,3,3)
      Dimension Hess(nAt3,*)
#include "angstr.fh"
#include "real.fh"
*
*---- Derivative of the cavity factor U_x(q)=2 Pi Eps/(Eps-1) sum_i [Qtot**2 * n_x]
*
      Fact = Two * PI * Eps / (Eps-One)
      FPI = Four * PI
      Diag = - 1.0694d0 * Sqrt(FPI) / Two
      dN = Zero
c     Double loop on atoms and coordinates
      Do 100 Index1 = 1, nAt3
        iAt1 = Int( (Index1-1)/3 ) + 1
        iCoord1 = Index1 - 3 * (iAt1-1)
c       Derivative of the PCM matrix
        Call DMat_CPCM(iAt1,iCoord1,Eps,nTs,nS,nAt,Diag,Tessera,
     &                 DerDM,DerTes,DerPunt,DerCentr,iSphe)
c       Matrix product: derivative of PCM matrix times the inverted matrix
        Call DGEMM_('N','N',nTs,nTs,nTs,One,DerDM,nTs,
     &             DM,nTs,Zero,Temp,nTs)

        Do 101 Index2 = 1, nAt3
          iAt2 = Int( (Index2-1)/3 ) + 1
          iCoord2 = Index2 - 3 * (iAt2-1)
c         Derivative of the normal factor n_x
          Call Der_Norm(Angstr,iAt1,iCoord1,iAt2,iCOord2,nTs,nAt,nS,
     &    Tessera,Der1,DerRad,DerTes,DerPunt,Sphere,iSphe,nOrd)
c         Find out if atom iAt2 has a sphere around
          iAt2_S = 0
          Do iS = 1, nS
           If(iAt2.eq.nOrd(iS)) iAt2_S = iS
          EndDo
          Sum1 = Zero
          Sum2 = Zero
c         Loop on tesserae
          Do 200 iTs = 1, nTs
            QtotI = Q(1,iTs) + Q(2,iTs)
            L = iSphe(iTs)
            XN = - (Sphere(1,L) - Tessera(1,iTs)) / Sphere(4,L)
            YN = - (Sphere(2,L) - Tessera(2,iTs)) / Sphere(4,L)
            ZN = - (Sphere(3,L) - Tessera(3,iTs)) / Sphere(4,L)
            If(L.eq.iAt2_S) then
             if(iCoord2.eq.1)dN = XN
             if(iCoord2.eq.2)dN = YN
             if(iCoord2.eq.3)dN = ZN
            Else
              dCent = XN * DerCentr(L,iAt2,iCoord2,1)
     &              + YN * DerCentr(L,iAt2,iCoord2,2)
     &              + ZN * DerCentr(L,iAt2,iCoord2,3)
              dN = DerRad(L,iAt2,iCoord2) + dCent
            EndIf
            dNI = dN / Tessera(4,iTs)
            Sum1 = Sum1 + QtotI * QtotI * Der1(iTs)
            Do  201 jTs = 1, nTs
              QtotJ = Q(1,jTs) + Q(2,jTs)
              Sum2 = Sum2 + Two * QtotI * dNI * Temp(iTs,jTs) * QtotJ
  201       Continue
  200     Continue
          Hess(Index1,Index2) = Fact * (Sum1 + Sum2)
  101   Continue
  100 Continue
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nHess)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine set_defaults(nneq,nTempMagn,nDir,nDirZee,nMult,neq,nexch,nK,mG,ncut,nP,AngPoints,nBlock,encut_definition,iopt,iPrint, &
                        nsymm,ngrid,dltT0,dltH0,zJ,tmin,tmax,hmin,hmax,XField,thrs,TempMagn,cryst,coord,encut_rate,gtens_input, &
                        D_fact,EoverD_fact,riso,decompose_exchange,AnisoLines1,AnisoLines3,AnisoLines9,DM_exchange,Dipol,KE, &
                        JITO_exchange,fitCHI,fitM,Do_structure_abc,doplot,compute_g_tensors,tinput,compute_susceptibility, &
                        compute_torque,compute_barrier,compute_magnetization,hinput,compute_Mdir_vector,zeeman_energy,m_paranoid, &
                        m_accurate,smagn,itype)
! definition of the cluster
!  nneq, neq, gtens_input, D_fact, EoverD_fact, riso, itype
! definition of exchange interaction
!  nexch
! definition of g and D tensors
!  nMult, compute_g_tensors
! Zeeman energy and M vector
!  nDir, nDirZee
! definition of the exchange:
!  AnisoLines1, AnisoLines3, AnisoLines9
! options used in connection with Dipol-Dipol interaction
!  Dipol
! options used in connection with KE
!  KE
! option for Dzialoshinsky-Morya antisymmetric exchange
!  DM_exchange
! option for ITO exchange
!  JITO_exchange
! options for automatic fitting of parameters:
!  fitCHI : not used so far
!  fitM   : not used so far
! definition of data for susceptibility
!  tinput, compute_susceptibility, tmin, tmax, dltT0
! options related to XT_MoverH
!  Xfield
! definition of data for magnetization:
!  nTempMagn, TempMagn, iopt, dltH0, thrs, hmin, hmax, hinput, compute_magnetization, compute_Mdir_vector, zeeman_energy,
!  m_paranoid, m_accurate, smagn
! options used to set up nM and EM
!  nK, mG     : encut_definition=1;
!  ncut       : encut_definition=2;
!  encut_rate : encut_definition=3;
!  encut_definition
! decompose exchange
!  decompose_exchange
! magnetization torque
!  compute_torque, nP, AngPoints
! mean field parameter
!  zJ
! definition of the crystal axes:
!  cryst : a, b, c, alpha, beta, gamma
!  Do_structure_abc
! Cartesian coordinates of the main metal site, or center
!  coord
! definitions for blocking barrier
!  nBlock, compute_barrier
! default print level
!  iPrint, DoPlot

use Constants, only: Zero, Two, Ten, gElectron
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nneq, nTempMagn, nDir, nDirZee, nMult
integer(kind=iwp), intent(out) :: neq(nneq), nexch(nneq), nK, mG, ncut, nP, AngPoints, nBlock, encut_definition, iopt, iPrint, &
                                  nsymm, ngrid
real(kind=wp), intent(out) :: dltT0, dltH0, zJ, tmin, tmax, hmin, hmax, Xfield, thrs, TempMagn(nTempMagn), cryst(6), coord(3), &
                              encut_rate, gtens_input(3,nneq), D_fact(nneq), EoverD_fact(nneq), riso(3,3,nneq)
logical(kind=iwp), intent(out) :: decompose_exchange, AnisoLines1, AnisoLines3, AnisoLines9, DM_exchange, Dipol, KE, &
                                  JITO_exchange, fitCHI, fitM, Do_structure_abc, DoPlot, compute_g_tensors, tinput, &
                                  compute_susceptibility, compute_torque, compute_barrier, compute_magnetization, hinput, &
                                  compute_Mdir_vector, zeeman_energy, m_paranoid, m_accurate, smagn
character, intent(out) :: itype(nneq)
integer(kind=iwp) :: i

!------------------------------------------------------------------
! at this point, the follwing variables have been already assigned
! their values
!integer :: nneq, exch, nLoc, nCenter, nT, nH, nTempMagn, nDir, nDirZee, nMult, nPair
!
!ntotcenter = 1
!local_states = 1
!nDirZee = 0
!nCenter = 1
!exch = 1
!nT = 301
! --  in this subroutine we define other default values of other variables
! --  these values will be (partly) overwritten by the subsequent
!     "readin_poly" subroutine

!-----------------------------------------------------------------------
! variables related to the cluster:
if (nneq > 0) then
  neq(:) = 1
  nexch(:) = 1
  itype(:) = ' '
  D_fact(:) = Zero
  EoverD_fact(:) = Zero
  gtens_input(:,:) = -gElectron
  do i=1,nneq
    call unitmat(riso(:,:,i),3)
  end do
end if
!-----------------------------------------------------------------------
! magnetic exchange
Dipol = .false.
AnisoLines1 = .false.
AnisoLines3 = .false.
AnisoLines9 = .false.
KE = .false.
DM_exchange = .false.
decompose_exchange = .false.
JITO_exchange = .false.
!-----------------------------------------------------------------------
! g and D tensors
compute_g_tensors = nMult > 0
!-----------------------------------------------------------------------
! Magnetization vector and Zeeman energy spliting
compute_Mdir_vector = nDir > 0
zeeman_energy = nDirZee > 0
!-----------------------------------------------------------------------
! powder magnetization:
compute_magnetization = .false.
m_accurate = .true.
m_paranoid = .true.
smagn = .false.
THRS = 1.0e-10_wp ! threshold for convergence of average spin when zJ /= 0.0
iopt = 1
dltH0 = 0.001_wp ! the non-zero field point
NK = 50
MG = 50
HMIN = Zero
HMAX = Ten
encut_definition = 2
encut_rate = 1.0_wp
if (nTempMagn > 0) TempMagn(1) = Two
ncut = 0
!-----------------------------------------------------------------------
! magnetic susceptibility
compute_susceptibility = .false.
TMIN = Zero
TMAX = 300.0_wp
DLTT0 = 0.001_wp
Xfield = Zero
!-----------------------------------------------------------------------
! magnetic torque
compute_torque = .false.
nP = 0
AngPoints = 0
!-----------------------------------------------------------------------
! perform comparison with experiment
TINPUT = .false.
HINPUT = .false.
!-----------------------------------------------------------------------
! relate to crystallographic axes
Do_structure_abc = .false.
Cryst(:) = Zero
coord(:) = Zero
!-----------------------------------------------------------------------
! mean field parameter
ZJ = Zero
!-----------------------------------------------------------------------
! automatic fitting:
fitCHI = .false.
fitM = .false.
!-----------------------------------------------------------------------
! print level
iPrint = 2
!-----------------------------------------------------------------------
! blocking barrier
nBlock = 0
compute_barrier = .false.
!ccc
DoPlot = .false.
!-----------------------------------------------------------------------
! angular grid
nsymm = 1
ngrid = 15

return

end subroutine set_defaults

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SA_PREC2(rdia,S,CI,ENE)

use input_mclr, only: nCSF, nRoots, State_Sym
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: rdia(nCSF(State_Sym)), CI(nCSF(State_Sym),nCSF(State_Sym)), ENE
real(kind=wp), intent(out) :: S(nroots,nroots)
integer(kind=iwp) :: i, j, k, n
real(kind=wp) :: dnum

n = nCSF(State_Sym)
S(:,:) = Zero
do i=1,nroots
  do j=1,nroots
    do k=1,n
      dnum = rdia(k)-Ene
      dnum = sign(max(abs(dnum),1.0e-16_wp),dnum)
      S(i,j) = S(i,j)+CI(k,i)*CI(k,j)/dnum
    end do
  end do
end do
call MatInvert(S,nroots)

end subroutine SA_PREC2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  hasNonnegativeDiagonal
*
*> @brief
*>   Return ``.True.`` if all diagonal elements of \p M are non-negative
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Test if all diagonal elements of matrix \p M are non-negative.
*> If \f$ \forall i \; M_{ii} \ge 0 \f$ return ``.True.``.
*>
*> @param[in] M \p n &times; \p n square matrix
*> @param[in] n Dimension of \p M
*>
*> @return ``.True.`` if all diagonal elements of \p M are non-negative.
************************************************************************
      Logical Function hasNonnegativeDiagonal(M,n)
      Implicit None
      Integer n
      Real*8  M(n,n)

      Integer i

      hasNonnegativeDiagonal=.True.
      Do i=1,n
         If (M(i,i).lt.0.0d0) Then
            hasNonnegativeDiagonal=.False.
            Return
         End If
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function GETH1I_MCLR(I,J)
! Obtain one-electron integral H(IORB,JOB)

use MCLR_Data, only: FIMO, IBSO, ipCM, IREOTS, ISMFTO
use input_mclr, only: nIsh, nOrb
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: GETH1I_MCLR
integer(kind=iwp), intent(in) :: I, J
integer(kind=iwp) :: I1, IJ, ISM, J1, JSM

ISM = ISMFTO(I)
JSM = ISMFTO(J)
I1 = IREOTS(I)-IBSO(ISM)+nISH(ISM)+1
J1 = IREOTS(J)-IBSO(JSM)+nISH(JSM)+1

IJ = ipCM(iSM)-1+(J1-1)*NORB(ISM)+I1

GETH1I_MCLR = FIMO(IJ)

end function GETH1I_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
*  get_BasisType
*
*> @brief
*>   Logical function to check basis set
*> @author V. Veryazov
*>
*> @details
*> Function returns ``.true.`` if the basis set in the current
*> calculation has specific type.
*> Only 3 first characters are used, so
*> ``get_BasisType('segmented')`` is the same as ``get_BasisType('SEG')``.
*>
*> The list of available basis set types is available at
*> src/Include/basistype.fh and basis_library/basistype.tbl.
*>
*> @param[in] BasisType Basis set type
*>
*> @return ``.true.`` if the basis set in the current calculation has specific type
************************************************************************
        Logical function get_BasisType(BasisType)
        character*(*) BasisType
        Character*3 temp, TypeCon, TypeAll,TypeRel
#include "basistype.fh"
        Logical Found
        integer BasisTypes(4)
*
        nData=0
        Found=.False.
        Call Qpg_iArray('BasType',Found,nData)
        if (.not.Found) then
          get_BasisType=.false.
          return
        endif
        call get_bastype(BasisTypes,nData)
        i=BasisTypes(1)
        if(i.le.0) then
          TypeCon='UNK'
        else
          TypeCon=BasTypeCon((i-1)*4+1:(i-1)*4+3)
        endif
        i=BasisTypes(2)
        if(i.le.0) then
          TypeAll='UNK'
        else
          TypeAll=BasTypeAll((i-1)*4+1:(i-1)*4+3)
        endif
        i=BasisTypes(3)
        if(i.le.0) then
          TypeRel='UNK'
        else
          TypeRel=BasTypeRel((i-1)*4+1:(i-1)*4+3)
        endif

        i=len(BasisType)
        if(i.gt.3) i=3
        temp='___'
        temp(1:i)=BasisType(1:i)
        call UpCase(temp)
        get_BasisType=.false.
        if(temp.eq.TypeCon.or.temp.eq.TypeAll.or.temp.eq.TypeRel)
     &  get_BasisType=.true.

        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Steven Vancoillie                                *
************************************************************************
      SUBROUTINE HCOUP(IVEC,JVEC,OVL,TG1,TG2,TG3,HEL)
      use output_caspt2, only:iPrGlb,debug
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
C Compute the coupling Hamiltonian element defined as
C     HEL = < ROOT1 | H * OMEGA | ROOT2 >
C assuming that IVEC contains a contravariant representation of
C H|ROOT1>, JVEC contains a contravariant representation of
C OMEGA|ROOT2>, and OVL, TG1, TG2, TG3 contain the overlap (normally
C expected to be 0 or 1) and active transition density matrices of ROOT1
C and ROOT2. See also subroutine TSVEC for explanations.

C SVC (March 2014): modification of original code to handle distributed
C RHS arrays. There is now a main HCOUP subroutine that loops over cases
C and irreps and gets access to the process-specific block of the RHS.
C The coupling for that block is computed by the subroutine HCOUP_BLK.

#include "rasdim.fh"
#include "caspt2.fh"
#include "SysDef.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      Dimension TG1(NASHT,NASHT)
      Dimension TG2(NASHT,NASHT,NASHT,NASHT)
C The dimension of TG3 is NTG3=(NASHT**2+2 over 3)
      Dimension TG3(*)

      DIMENSION HECOMP(14,9)

#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif


C Sketch of procedure:
C  HEL=0.0D0
C  Loop over every (case/symmetry)-block.
C           If (No such vector block) Skip to end of loop
C           Allocate two places for this block, VEC1 and VEC2
C           Read VEC1 as IVEC component from file.
C           Read VEC2 as JVEC component from file.
C           Loop nest, computing
C              HEL := HEL + VEC1*GOM*VEC2
C           End of loop nest
C           Deallocate VEC1 and VEC2
C  End of loop.

      HEL=0.0D0
      HECOMP=0.0D0
      DO ICASE=1,13
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIN=NINDEP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          HEBLK=0.0D0

          IF(NAS*NIS.EQ.0) GOTO 1
          IF(NIN.EQ.0) GOTO 1

          CALL RHS_ALLO (NAS,NIS,lg_V1)
          CALL RHS_ALLO (NAS,NIS,lg_V2)
          CALL RHS_READ (NAS,NIS,lg_V1,ICASE,ISYM,IVEC)
          CALL RHS_READ (NAS,NIS,lg_V2,ICASE,ISYM,JVEC)
          CALL RHS_ACCESS(NAS,NIS,lg_V1,iLo1,iHi1,jLo1,jHi1,MV1)
          CALL RHS_ACCESS(NAS,NIS,lg_V2,iLo2,iHi2,jLo2,jHi2,MV2)

          IF ((iLo1.NE.iLo2) .OR.
     &        (iHi1.NE.iHi2) .OR.
     &        (jLo1.NE.jLo2) .OR.
     &        (jHi1.NE.jHi2)) THEN
            WRITE(6,'(1X,A)') 'HCOUP: Error: block mismatch, abort...'
            CALL ABEND()
          END IF

#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            CALL HCOUP_BLK(ICASE,ISYM,NAS,jLo1,jHi1,
     &                     DBL_MB(MV1),DBL_MB(MV2),OVL,HEBLK,
     &                     TG1,TG2,TG3)
          ELSE
            CALL HCOUP_BLK(ICASE,ISYM,NAS,jLo1,jHi1,
     &                     WORK(MV1),WORK(MV2),OVL,HEBLK,
     &                     TG1,TG2,TG3)
          END IF
#else
          CALL HCOUP_BLK(ICASE,ISYM,NAS,jLo1,jHi1,
     &                   WORK(MV1),WORK(MV2),OVL,HEBLK,
     &                   TG1,TG2,TG3)
#endif
          CALL RHS_RELEASE (lg_V1,IASTA1,IAEND1,IISTA1,IIEND1)
          CALL RHS_RELEASE (lg_V2,IASTA2,IAEND2,IISTA2,IIEND2)
          CALL RHS_FREE (NAS,NIS,lg_V1)
          CALL RHS_FREE (NAS,NIS,lg_V2)

 1        CONTINUE
          HECOMP(ICASE,ISYM)=HEBLK
          HEL=HEL+HEBLK
        END DO
      END DO

C Sum-reduce the per-process contributions
      CALL GADGOP_SCAL(HEL,'+')
      NHECOMP=14*9
      CALL GADGOP(HECOMP,NHECOMP,'+')

      IF(IPRGLB.GE.DEBUG) THEN
        DO ICASE=1,13
          SUMSYM=0.0D0
          DO ISYM=1,NSYM
            SUMSYM=SUMSYM+HECOMP(ICASE,ISYM)
          END DO
          HECOMP(ICASE,NSYM+1)=SUMSYM
        END DO

        DO ISYM=1,NSYM+1
          SUMCASE=0.0D0
          DO ICASE=1,13
            SUMCASE=SUMCASE+HECOMP(ICASE,ISYM)
          END DO
          HECOMP(14,ISYM)=SUMCASE
        END DO

        WRITE(6,'(20a4)')('----',i=1,20)
        WRITE(6,*)'HCOUP: The contributions to the Hamiltonian coupling'
        WRITE(6,*)' elements, by case and by symmetry label.'
        DO IC=1,13
          WRITE(6,'(1X,A8,9F12.8)')
     &      CASES(IC),(HECOMP(IC,IS),IS=1,NSYM+1)
        END DO
        CALL XFLUSH(6)
        WRITE(6,'(1X,A8,9F12.8)')
     &    'Summed: ', (HECOMP(14,IS),IS=1,NSYM+1)
        WRITE(6,*)
      END IF


      END

      SUBROUTINE HCOUP_BLK(ICASE,ISYM,NAS,IISTA,IIEND,V1,V2,OVL,HEBLK,
     &                     TG1,TG2,TG3)
      USE SUPERINDEX
C Compute a contribution to the coupling Hamiltonian element (HEL)
C defined as HEL = < ROOT1 | H * OMEGA | ROOT2 >. The contribution
C arises from the block V_(A,I), with A=1,NAS and I=IISTA,IIEND,
C with A the active superindex and I the inactive superindex. Since
C the inactive superindex is partitioned over processes, each process
C only computes part of the HEL value, which is then sum reduced in the
C calling subroutine.
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "SysDef.fh"
#include "eqsolv.fh"

      DIMENSION V1(*), V2(*)

      Dimension TG1(NASHT,NASHT)
      Dimension TG2(NASHT,NASHT,NASHT,NASHT)
C The dimension of TG3 is NTG3=(NASHT**2+2 over 3)
      Dimension TG3(*)


      HEBLK=0.0D0

      IF (IISTA.LE.0) RETURN

      NISBLK=IIEND-IISTA+1
      SELECT CASE (ICASE)
************************************************************************
      CASE (1)
        DO IAS=1,NAS
          IASABS=NTUVES(ISYM)+IAS
          ITABS=MTUV(1,IASABS)
          IUABS=MTUV(2,IASABS)
          IVABS=MTUV(3,IASABS)
          DO JAS=1,NAS
            JASABS=NTUVES(ISYM)+JAS
            IXABS=MTUV(1,JASABS)
            IYABS=MTUV(2,JASABS)
            IZABS=MTUV(3,JASABS)
C Compute and use SA(ITABS IUABS IVABS, IXABS IYABS IZABS)
C Formulae used:
C  SA(tuv,xyz) =  -Gvuxtyz -dyu Gvzxt - dyt Gvuxz -
C         - dxu Gvtyz - dxu dyt Gvz +2 dtx Gvuyz + 2 dtx dyu Gvz
C Gvuxtyz is stored using full permutation symmetry of three pairs
C (vu),(xt), and (yz):
            IND1=IVABS+NASHT*(IUABS-1)
            IND2=IXABS+NASHT*(ITABS-1)
            IND3=IYABS+NASHT*(IZABS-1)
            IF(IND2.GT.IND3) THEN
              IF(IND1.GT.IND2) THEN
                JND1=IND1
                JND2=IND2
                JND3=IND3
              ELSE IF(IND1.GT.IND3) THEN
                JND1=IND2
                JND2=IND1
                JND3=IND3
              ELSE
                JND1=IND2
                JND2=IND3
                JND3=IND1
              END IF
            ELSE
              IF(IND1.GT.IND3) THEN
                JND1=IND1
                JND2=IND3
                JND3=IND2
              ELSE IF(IND1.GT.IND2) THEN
                JND1=IND3
                JND2=IND1
                JND3=IND2
              ELSE
                JND1=IND3
                JND2=IND2
                JND3=IND1
              END IF
            END IF
            ITG3=((JND1+1)*JND1*(JND1-1))/6+(JND2*(JND2-1))/2+JND3
C  SA(tuv,xyz) =  -Gvuxtyz -dyu Gvzxt - dyt Gvuxz -
C         - dxu Gvtyz - dxu dyt Gvz +2 dtx Gvuyz + 2 dtx dyu Gvz
C Compute TMP=Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
            TMP=TG3(ITG3)
            IF(IYABS.EQ.IUABS) THEN
              TMP=TMP+TG2(IVABS,IZABS,IXABS,ITABS)
            END IF
            IF(IYABS.EQ.ITABS) THEN
              TMP=TMP+TG2(IVABS,IUABS,IXABS,IZABS)
              IF(IXABS.EQ.IUABS) THEN
                TMP=TMP+TG1(IVABS,IZABS)
              END IF
            END IF
            IF(IXABS.EQ.IUABS) THEN
              TMP=TMP+TG2(IVABS,ITABS,IYABS,IZABS)
            END IF
C SA is the negative of this, and then some correction:
            SA=-TMP
            IF(IXABS.EQ.ITABS) THEN
              SA=SA+2.0D0*TG2(IVABS,IUABS,IYABS,IZABS)
              IF(IYABS.EQ.IUABS) THEN
                SA=SA+2.0D0*TG1(IVABS,IZABS)
              END IF
            END IF
C SA has been computed.

            HEBLK=HEBLK+SA*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(4)
        DO IAS=1,NAS
          IASABS=NTUVES(ISYM)+IAS
          IXABS=MTUV(1,IASABS)
          IUABS=MTUV(2,IASABS)
          IVABS=MTUV(3,IASABS)
          DO JAS=1,NAS
            JASABS=NTUVES(ISYM)+JAS
            ITABS=MTUV(1,JASABS)
            IYABS=MTUV(2,JASABS)
            IZABS=MTUV(3,JASABS)
C Compute and use SC(IXABS IUABS IVABS, ITABS IYABS IZABS)
C In SBMAT, the formula is written as SC(tuv,xyz)
C    = Gvutxyz +dyu Gvztx + dyx Gvutz + dtu Gvxyz + dtu dyx Gvz
C Rewritten, in order to reuse same quantities as in SA:
C  SC(xuv,tyz)
C    = Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
C Gvuxtyz is stored using full permutation symmetry of three pairs
C (vu),(xt), and (yz):
            IND1=IVABS+NASHT*(IUABS-1)
            IND2=IXABS+NASHT*(ITABS-1)
            IND3=IYABS+NASHT*(IZABS-1)
            IF(IND2.GT.IND3) THEN
              IF(IND1.GT.IND2) THEN
                JND1=IND1
                JND2=IND2
                JND3=IND3
              ELSE IF(IND1.GT.IND3) THEN
                JND1=IND2
                JND2=IND1
                JND3=IND3
              ELSE
                JND1=IND2
                JND2=IND3
                JND3=IND1
              END IF
            ELSE
              IF(IND1.GT.IND3) THEN
                JND1=IND1
                JND2=IND3
                JND3=IND2
              ELSE IF(IND1.GT.IND2) THEN
                JND1=IND3
                JND2=IND1
                JND3=IND2
              ELSE
                JND1=IND3
                JND2=IND2
                JND3=IND1
              END IF
            END IF
            ITG3=((JND1+1)*JND1*(JND1-1))/6+(JND2*(JND2-1))/2+JND3
C  SC(xuv,tyz) (rewritten, swapping x and t)
C    = Gvuxtyz +dyu Gvzxt + dyt Gvuxz + dxu Gvtyz + dxu dyt Gvz
            TMP=TG3(ITG3)
            IF(IYABS.EQ.IUABS) THEN
              TMP=TMP+TG2(IVABS,IZABS,IXABS,ITABS)
            END IF
            IF(IYABS.EQ.ITABS) THEN
              TMP=TMP+TG2(IVABS,IUABS,IXABS,IZABS)
              IF(IXABS.EQ.IUABS) THEN
                TMP=TMP+TG1(IVABS,IZABS)
              END IF
            END IF
            IF(IXABS.EQ.IUABS) THEN
              TMP=TMP+TG2(IVABS,ITABS,IYABS,IZABS)
            END IF
            SC= TMP

            HEBLK=HEBLK+SC*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(2)
        DO IAS=1,NAS
          IASABS=NTGEUES(ISYM)+IAS
          ITABS=MTGEU(1,IASABS)
          IUABS=MTGEU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGEUES(ISYM)+JAS
            IXABS=MTGEU(1,JASABS)
            IYABS=MTGEU(2,JASABS)
C Formulae used:
C    SB(tu,xy)=
C    = 2 Gxtyu -4dxt Gyu -4dyu Gxt +2dyt Gxu + 8 dxt dyu
C      -4dxu dyt + 2dxu Gyt
C    SB(tu,yx)=
C    = 2 Gytxu -4dyt Gxu -4dxu Gyt +2dxt Gyu + 8 dyt dxu
C      -4dyu dxt + 2dyu Gxt
C    SBP(tu,xy)=SB(tu,xy)+SB(tu,yx)
C    SBM(tu,xy)=SB(tu,xy)-SB(tu,yx)
            SBtuxy=2.0d0*TG2(IXABS,ITABS,IYABS,IUABS)
            SBtuyx=2.0d0*TG2(IYABS,ITABS,IXABS,IUABS)
            IF(IXABS.EQ.ITABS) THEN
              SBtuxy=SBtuxy-4.0d0*TG1(IYABS,IUABS)
              SBtuyx=SBtuyx+2.0d0*TG1(IYABS,IUABS)
              IF(IYABS.EQ.IUABS) THEN
                SBtuxy=SBtuxy+8.0d0*OVL
                SBtuyx=SBtuyx-4.0d0*OVL
              END IF
            END IF
            IF(IYABS.EQ.IUABS) THEN
              SBtuxy=SBtuxy-4.0d0*TG1(IXABS,ITABS)
              SBtuyx=SBtuyx+2.0d0*TG1(IXABS,ITABS)
            END IF
            IF(IYABS.EQ.ITABS) THEN
              SBtuxy=SBtuxy+2.0d0*TG1(IXABS,IUABS)
              SBtuyx=SBtuyx-4.0d0*TG1(IXABS,IUABS)
              IF(IXABS.EQ.IUABS) THEN
                SBtuxy=SBtuxy-4.0d0*OVL
                SBtuyx=SBtuyx+8.0d0*OVL
              END IF
            END IF
            IF(IXABS.EQ.IUABS) THEN
              SBtuxy=SBtuxy+2.0d0*TG1(IYABS,ITABS)
              SBtuyx=SBtuyx-4.0d0*TG1(IYABS,ITABS)
            END IF

            SBP=SBtuxy + SBtuyx

            HEBLK=HEBLK+SBP*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(3)
        DO IAS=1,NAS
          IASABS=NTGTUES(ISYM)+IAS
          ITABS=MTGTU(1,IASABS)
          IUABS=MTGTU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGTUES(ISYM)+JAS
            IXABS=MTGTU(1,JASABS)
            IYABS=MTGTU(2,JASABS)
C Formulae used:
C    SB(tu,xy)=
C    = 2 Gxtyu -4dxt Gyu -4dyu Gxt +2dyt Gxu + 8 dxt dyu
C      -4dxu dyt + 2dxu Gyt
C    SB(tu,yx)=
C    = 2 Gytxu -4dyt Gxu -4dxu Gyt +2dxt Gyu + 8 dyt dxu
C      -4dyu dxt + 2dyu Gxt
C    SBP(tu,xy)=SB(tu,xy)+SB(tu,yx)
C    SBM(tu,xy)=SB(tu,xy)-SB(tu,yx)
            SBtuxy=2.0d0*TG2(IXABS,ITABS,IYABS,IUABS)
            SBtuyx=2.0d0*TG2(IYABS,ITABS,IXABS,IUABS)
            IF(IXABS.EQ.ITABS) THEN
              SBtuxy=SBtuxy-4.0d0*TG1(IYABS,IUABS)
              SBtuyx=SBtuyx+2.0d0*TG1(IYABS,IUABS)
              IF(IYABS.EQ.IUABS) THEN
                SBtuxy=SBtuxy+8.0d0*OVL
                SBtuyx=SBtuyx-4.0d0*OVL
              END IF
            END IF
            IF(IYABS.EQ.IUABS) THEN
              SBtuxy=SBtuxy-4.0d0*TG1(IXABS,ITABS)
              SBtuyx=SBtuyx+2.0d0*TG1(IXABS,ITABS)
            END IF
            IF(IYABS.EQ.ITABS) THEN
              SBtuxy=SBtuxy+2.0d0*TG1(IXABS,IUABS)
              SBtuyx=SBtuyx-4.0d0*TG1(IXABS,IUABS)
              IF(IXABS.EQ.IUABS) THEN
                SBtuxy=SBtuxy-4.0d0*OVL
                SBtuyx=SBtuyx+8.0d0*OVL
              END IF
            END IF
            IF(IXABS.EQ.IUABS) THEN
              SBtuxy=SBtuxy+2.0d0*TG1(IYABS,ITABS)
              SBtuyx=SBtuyx-4.0d0*TG1(IYABS,ITABS)
            END IF

            SBM=SBtuxy - SBtuyx

            HEBLK=HEBLK+SBM*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(5)
        NAS1=NAS/2
        DO IAS1=1,NAS1
          IAS2=IAS1+NAS1
          IASABS=NTUES(ISYM)+IAS1
          ITABS=MTU(1,IASABS)
          IUABS=MTU(2,IASABS)
          DO JAS1=1,NAS1
            JAS2=JAS1+NAS1
            JASABS=NTUES(ISYM)+JAS1
            IXABS=MTU(1,JASABS)
            IYABS=MTU(2,JASABS)
C Formulae used:
C    SD11(tu1,xy1)=2*(Gutxy + dtx Guy)
C    SD12(tu2,xy1)= -(Gutxy + dtx Guy)
C    SD21(tu2,xy1)= -(Gutxy + dtx Guy)
C    SD22(tu2,xy2)= -Gxtuy +2*dtx Guy
            GUTXY= TG2(IUABS,ITABS,IXABS,IYABS)
            SD11=2.0D0*GUTXY
            SD12= -GUTXY
            SD21= -GUTXY
            SD22= -TG2(IXABS,ITABS,IUABS,IYABS)
            IF(ITABS.EQ.IXABS) THEN
              GUY=TG1(IUABS,IYABS)
              SD11=SD11+2.0D0*GUY
              SD12=SD12 -GUY
              SD21=SD21 -GUY
              SD22=SD22+2.0D0*GUY
            END IF

            HEBLK=HEBLK+SD11*DDOT_(NISBLK,V2(JAS1),NAS,V1(IAS1),NAS)
            HEBLK=HEBLK+SD12*DDOT_(NISBLK,V2(JAS2),NAS,V1(IAS1),NAS)
            HEBLK=HEBLK+SD21*DDOT_(NISBLK,V2(JAS1),NAS,V1(IAS2),NAS)
            HEBLK=HEBLK+SD22*DDOT_(NISBLK,V2(JAS2),NAS,V1(IAS2),NAS)
          END DO
        END DO
************************************************************************
      CASE(6)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
C Formula used: SE(t,x)=2*dxt - Dxt
            SE=-TG1(IXABS,ITABS)
            IF(IXABS.EQ.ITABS) SE=SE+2.0d0*OVL
            HEBLK=HEBLK+SE*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(7)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
C Formula used: SE(t,x)=2*dxt - Dxt
            SE=-TG1(IXABS,ITABS)
            IF(IXABS.EQ.ITABS) SE=SE+2.0d0*OVL
            HEBLK=HEBLK+SE*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(8)
C ========================================================
C Compute and use SFP(ITABS IUABS , IXABS IYABS)
C and (later, similar) SFM(ITABS IUABS , IXABS IYABS)
        DO IAS=1,NAS
          IASABS=NTGEUES(ISYM)+IAS
          ITABS=MTGEU(1,IASABS)
          IUABS=MTGEU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGEUES(ISYM)+JAS
            IXABS=MTGEU(1,JASABS)
            IYABS=MTGEU(2,JASABS)
C Formulae used:
C    SF(tu,xy)= 2 Gtxuy
C    SFP(tu,xy)=SF(tu,xy)+SF(tu,yx)
C    SFM(tu,xy)=SF(tu,xy)-SF(tu,yx)
            SFtuxy=2.0d0*TG2(ITABS,IXABS,IUABS,IYABS)
            SFtuyx=2.0d0*TG2(ITABS,IYABS,IUABS,IXABS)

            SFP=SFtuxy + SFtuyx
            HEBLK=HEBLK+SFP*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(9)
C ========================================================
C Compute and use SFM(ITABS IUABS, IXABS ,IYABS)
        DO IAS=1,NAS
          IASABS=NTGTUES(ISYM)+IAS
          ITABS=MTGTU(1,IASABS)
          IUABS=MTGTU(2,IASABS)
          DO JAS=1,NAS
            JASABS=NTGTUES(ISYM)+JAS
            IXABS=MTGTU(1,JASABS)
            IYABS=MTGTU(2,JASABS)
C Formulae used:
C    SF(tu,xy)= 4 Ptxuy
C    SFP(tu,xy)=SF(tu,xy)+SF(tu,yx)
C    SFM(tu,xy)=SF(tu,xy)-SF(tu,yx)
            SFtuxy=2.0d0*TG2(ITABS,IXABS,IUABS,IYABS)
            SFtuyx=2.0d0*TG2(ITABS,IYABS,IUABS,IXABS)

            SFM=SFtuxy - SFtuyx
            HEBLK=HEBLK+SFM*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
C CASES GP, GM
C Compute and use SG(ITABS , IXABS) (Same for cases GP and GM)
************************************************************************
      CASE(10)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
C Formula used: SG(t,x)= Gtx
            SG= TG1(ITABS,IXABS)

            HEBLK=HEBLK+SG*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(11)
        DO IAS=1,NAS
          ITABS=IAS+NAES(ISYM)
          DO JAS=1,NAS
            IXABS=JAS+NAES(ISYM)
C Formula used: SG(t,x)= Gtx
            SG= TG1(ITABS,IXABS)

            HEBLK=HEBLK+SG*DDOT_(NISBLK,V2(JAS),NAS,V1(IAS),NAS)
          END DO
        END DO
************************************************************************
      CASE(12)
        IF(ABS(OVL).GE.1.0D-12) THEN
          HEBLK=HEBLK+OVL*DDOT_(NAS*NISBLK,V2,1,V1,1)
        END IF
************************************************************************
      CASE(13)
        IF(ABS(OVL).GE.1.0D-12) THEN
          HEBLK=HEBLK+OVL*DDOT_(NAS*NISBLK,V2,1,V1,1)
        END IF
************************************************************************
      END SELECT
      Return
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine ModInd(IndxZt,IndZt,nZeta,CutZt,IncZet,SkipZt,A,B)
************************************************************************
* Object : to modify the index array.                                  *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN.                              *
*             June '91                                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 A(3), B(3)
      Integer IndZt(nZeta), IndxZt(nZeta)
      Logical CutZt, SkipZt
*
      iRout = 246
      iPrint = nPrint(iRout)
*
      AB2 = (A(1)-B(1))**2 + (A(2)-B(2))**2 + (A(3)-B(3))**2
      CutZt = .False.
      SkipZt = .False.
*
*     If (AB2.gt.Zero) Then
         If (IncZet.eq.nZeta) Then
            Call ICopy(nZeta,IndxZt,1,IndZt,1)
            Ind = Abs(IndZt(nZeta))
         Else
            Ind = 0
            Jnd = 0
            Do 10 iZeta = 1, nZeta
               If (Mod(iZeta-1,IncZet).eq.0) Jnd = 0
               IndZt(iZeta) = -Jnd
*              Check if primitive function can be omitted
               If (IndxZt(iZeta).gt.0) Then
                  Ind = Ind + 1
                  Jnd = Jnd + 1
                  IndZt(iZeta) = Jnd
               End If
 10         Continue
         End If
*        Set flag to indicate if arguments were ignored
         CutZt = nZeta .ne. Ind
*        Set flag to indicate that all arguments were ignored.
         SkipZt= Ind.eq.0
*     End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************

**************************************************************
* Initializes info needed by the Cholesky integral generator
*
* F. Aquilante
**************************************************************
      SUBROUTINE INIT_GETINT(RC)

      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER RC

#include "RdOrd.fh"

      rc = 0
      Call get_iscalar('nSym',nSym)
      Call get_iarray('nBas',nBas,nSym)
      Call INIT_NumCV(NumCho,nSym)

      LuCVec(1) = -1
      LuCVec(2) = -1

      pq1 = 0


      RETURN
      END

**************************************************************
**************************************************************
      SUBROUTINE INIT_NumCV(NumCV,nSymm)

      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER nSymm, NumCV(nSymm)

#include "cholesky.fh"

      Do i=1,nSymm
         NumCV(i)=NumCho(i)
      End Do

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine simplify1 (i,uniorder,dkhorder,xorder,dkhscfflg,
     *                 ordercounter,opcounter,operleng,oporder,evenodd,
     *                 doperators,operators,xordercounter,xopcounter,
     *                 xoperleng,xoporder,xevenodd,xdoperators,
     *                 xoperators)
c
c***************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 01.07.2005
c
c   first version: 18.06.2004  (Theoretical Chemistry, Univ. Bonn)
c
c***************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer i,uniorder,dkhorder,xorder,ordercounter(0:maxorder),
     *        opcounter,operleng(maxoperators),oporder(maxoperators,3),
     *        evenodd(maxoperators),
     *        xordercounter(0:maxorder),xopcounter,
     *        xoperleng(maxoperators),xoporder(maxoperators),
     *        xevenodd(maxoperators)
      REAL*8 doperators(maxoperators),
     *                 xdoperators(maxoperators)
#if defined(_MOLCAS_) || defined(MOLPRO)
      character operators(*),xoperators(*)
      character*(maxlength) opstring,xopstring
#else
      character*(*) operators(maxoperators)
     *                      xoperators(maxoperators)
#endif
c
      logical dkhscfflg
C     integer l,k,idum1,idum2
      integer l,  idum1,idum2
      idum1=0
      do 10 l=1,opcounter
        if (i.eq.uniorder) then
  20      continue
          if (evenodd(l+idum1).eq.-1) then
            ordercounter(oporder(l+idum1,3))=
     *        ordercounter(oporder(l+idum1,3))-1
            idum1=idum1+1
            if (evenodd(l+idum1).eq.-1) goto 20
          endif
        else
  30      continue
          if (evenodd(l+idum1).eq.-1.and.oporder(l+idum1,3).eq.i ) then
            ordercounter(oporder(l+idum1,3))=
     *        ordercounter(oporder(l+idum1,3))-1
            idum1=idum1+1
            if (evenodd(l+idum1).eq.-1) goto 30
          endif
        endif
        if (l+idum1.gt.opcounter) goto 10
        oporder(l,1)=oporder(l+idum1,1)
        oporder(l,2)=oporder(l+idum1,2)
        oporder(l,3)=oporder(l+idum1,3)
        evenodd(l)=evenodd(l+idum1)
        doperators(l)=doperators(l+idum1)
        operleng(l)=operleng(l+idum1)
#if defined(_MOLCAS_) || defined(MOLPRO)
        call copy_dkoperators(l+idum1,operators,l,operators)
#else
        operators(l)=operators(l+idum1)
#endif
  10  continue
c
#if defined(_MOLCAS_) || defined(MOLPRO)
      opstring=' '
#endif
      do 40 l=opcounter-idum1+1,opcounter
        oporder(l,1)=0
        oporder(l,2)=0
        oporder(l,3)=0
        evenodd(l)=0
        doperators(l)=0.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
        call put_dkoperators(l,opstring,operators)
#else
        do 50 k=1,operleng(l)
          operators(l)(k:k)=' '
50      continue
#endif
        operleng(l)=0
  40  continue
c
      opcounter=opcounter-idum1
c
      if (.not.dkhscfflg) then
        idum2=0
        do 100 l=1,xopcounter
          if (i.eq.uniorder) then
 110        continue
            if (xevenodd(l+idum2).eq.-1) then
              xordercounter(xoporder(l+idum2))=
     *          xordercounter(xoporder(l+idum2))-1
              idum2=idum2+1
              if (xevenodd(l+idum2).eq.-1) goto 110
            endif
          else
 120        continue
            if ( xevenodd(l+idum2).eq.-1 .and.
     *           (xoporder(l+idum2).gt.xorder-i-1) ) then
              xordercounter(xoporder(l+idum2))=
     *          xordercounter(xoporder(l+idum2))-1
              idum2=idum2+1
              if (xevenodd(l+idum2).eq.-1) goto 120
            endif
          endif
          if (l+idum2.gt.xopcounter) goto 100
          xoporder(l)=xoporder(l+idum2)
          xevenodd(l)=xevenodd(l+idum2)
          xdoperators(l)=xdoperators(l+idum2)
          xoperleng(l)=xoperleng(l+idum2)
#if defined(_MOLCAS_) || defined(MOLPRO)
          call copy_dkoperators(l+idum2,xoperators,l,xoperators)
#else
          xoperators(l)=xoperators(l+idum2)
#endif
 100    continue
c
#if defined(_MOLCAS_) || defined(MOLPRO)
        xopstring=' '
#endif
        do 140 l=xopcounter-idum2+1,xopcounter
          xoporder(l)=0
          xevenodd(l)=0
          xdoperators(l)=0.0d0
#if defined(_MOLCAS_) || defined(MOLPRO)
        call put_dkoperators(l,xopstring,xoperators)
#else
        do 150 k=1,xoperleng(l)
          xoperators(l)(k:k)=' '
 150    continue
#endif
          xoperleng(l)=0
 140    continue
c
        xopcounter=xopcounter-idum2
      endif
c
c
CAW---------
c      write (stdout,3097) opcounter
c3097  format (2X,'Reduced no. of operators after elimination of ',
c     *        'odd terms:',4X,I8)
c      if (.not.dkhscfflg) write (stdout,3098) xopcounter
c3098  format (2X,'Reduced no. of xoperators after elimination of odd',
c     *        ' terms:',3X,I8)
CAW---------
c
c
c  DEBUGGING: write actual operators to dbgout.32
      if (dbgflg.ge.1) write (dbgunit,4025)
4025  format (/2X,'Irrelevant odd terms have been removed.',
     *        ' (SR "simplify1")')
      if (dbgflg.ge.3) then
        if (i.le.9) then
          write (dbgunit,4030) i+1,i,i
4030      format (/2X,'Terms of Hamiltonian H',I1,' = [U',I1,' * ',
     *            '(operators) * U',I1,'^t]:',/2X,52('-'))
          call output3 (dbgunit,opcounter,operleng,oporder,evenodd,
     *                  doperators,operators)
          if (.not.dkhscfflg) then
            write (dbgunit,4031) i+1,i,i
4031        format (/2X,'Terms of property X',I1,' = [U',I1,' * ',
     *              '(xoperators) * U',I1,'^t]:',/2X,50('-'))
            call output3b (dbgunit,xopcounter,xoperleng,xoporder,
     *                     xevenodd,xdoperators,xoperators)
          endif
        endif
        if (i.ge.10) then
          write (dbgunit,4032) i+1,i,i
4032      format (/2X,'Terms of Hamiltonian H',I2,' = [U',I2,' * ',
     *            '(operators) * U',I2,'^t]:',/2X,55('-'))
          call output3 (dbgunit,opcounter,operleng,oporder,evenodd,
     *                  doperators,operators)
          if (.not.dkhscfflg) then
            write (dbgunit,4033) i+1,i,i
4033        format (/2X,'Terms of property X',I2,' = [U',I2,' * ',
     *              '(xoperators) * U',I2,'^t]:',/2X,53('-'))
            call output3b (dbgunit,xopcounter,xoperleng,xoporder,
     *                     xevenodd,xdoperators,xoperators)
          endif
        endif
      endif
c
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(dkhorder)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_INP(DFONLY,LUNIT,LUOUT)
!
! Purpose: If DFONLY, set defaults only.
!          Else, read and process input for Cholesky decomposition
!          from unit LUNIT. LUOUT is the unit of the output file
!          which is stored internally in the Cholesky program as
!          LUPRI

use Para_Info, only: Is_Real_Par
use Cholesky, only: BLOCKSIZE, CHKONLY, CHO_1CENTER, CHO_ADRVEC, CHO_DECALG, CHO_DECALG_DEF, CHO_DIACHK, CHO_FAKE_PAR, CHO_INTCHK, &
                    CHO_IOVEC, CHO_MINCHK, CHO_NO2CENTER, CHO_PRESCREEN, Cho_Real_Par, CHO_REORD, CHO_SIMP, CHO_SIMRI, &
                    Cho_SScreen, CHO_TRCNEG, CHO_TSTSCREEN, CHO_USEABS, Damp, FRAC_CHVBUF, HALTIT, IALQUA, IFCSEW, IPRINT, LBUF, &
                    LuPri, MaxQual, MaxRed, MaxVec, MinQual, ModRst, MXSHPR, N1_Qual, N1_VecRd, N2_Qual, N2_VecRd, N_Subtr, &
                    NCOL_CHK, n_MySP, RstCho, RstDia, RUN_INTERNAL, RUN_MODE, SCDIAG, Span, SSNorm, SSTau, SubScrStat, &
                    Thr_PreScreen, THR_SIMRI, ThrCom, ThrDef, ThrDiag, Tol_DiaChk, Trace_Idle, ThrNeg, TOONEG, WARNEG, XlDiag
use RICD_Info, only: Do_RI, Thrshld_CD
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: DFONLY
integer(kind=iwp), intent(in) :: LUNIT, LUOUT
integer(kind=iwp), parameter :: LINTSCR = 2, NOPTION = 58
integer(kind=iwp) :: IDKEY, INTSCR(LINTSCR), IRC, MXSHPR_DEF
logical(kind=iwp) :: DECALG_USRDEF, FAKE_USRDEF, FORCEPARALLEL, MXSHPR_USRDEF
character(len=180) :: LINE
character(len=*), parameter :: OPTION(NOPTION) = ['set decomposition threshold                       ', &
                                                  'set print level                                   ', &
                                                  'set buffer length for diagonal calculation        ', &
                                                  'set threshold for discarding initial diag. elem.  ', &
                                                  'set damping factor for first reduced set          ', &
                                                  'set damping factor for later reduced sets         ', &
                                                  'set span                                          ', &
                                                  'set minimum number of qualifieds for decomposition', &
                                                  'set maximum number of shell pair distributions    ', &
                                                  'turn on diag. screening (using damping factors)   ', &
                                                  'turn off diag. screening                          ', &
                                                  'set qualification algorithm                       ', &
                                                  'set threshold for zeroing negative diagonals      ', &
                                                  'set threshold for warning about negative diagonals', &
                                                  'set threshold for shutdown due to negative diag.  ', &
                                                  'check configuration only                          ', &
                                                  'check all integrals (debug)                       ', &
                                                  'diagonal restart                                  ', &
                                                  'decomposition restart with default restart model  ', &
                                                  'set restart model                                 ', &
                                                  'set maximum #qualifieds per symmetry              ', &
                                                  'set maximum #Cholesky vectors per symmetry        ', &
                                                  'set max. #reduced sets (i.e., integral passes)    ', &
                                                  'check specified #columns (debug)                  ', &
                                                  'minimal integral check (debug)                    ', &
                                                  'use abs. value to set up reduced sets             ', &
                                                  'do not use abs. value to set up red. sets         ', &
                                                  'turn on tracing of negative diagonals (debug)     ', &
                                                  'set algorithm for reading Cholesky vectors        ', &
                                                  'set vector reordering (for int. re-generation)    ', &
                                                  'halt execution after decomposition                ', &
                                                  'set memory fraction used as buffer for vec. read  ', &
                                                  'set fraction of memory to be used for qual. col.  ', &
                                                  'set maximum number of vectors in subtraction      ', &
                                                  'set file address mode (WA or DA for vector files) ', &
                                                  'set model used to interface to integral code      ', &
                                                  'one-step (conventional) decomposition             ', &
                                                  'two-step (generate map, then vectors) decomp.     ', &
                                                  'naive decomposition                               ', &
                                                  'set memory fraction used for global vector buffer ', &
                                                  'set diagonal checking and set tolerance (debug)   ', &
                                                  'test vector subtraction screening (statistics)    ', &
                                                  'use screening in vector subtraction               ', &
                                                  'do not use screening in vector subtraction        ', &
                                                  'threshold for screening in vector subtraction     ', &
                                                  'norm to use in vector subtraction screening       ', &
                                                  'decompose 1-center diagonals only                 ', &
                                                  'decompose 1-center diagonals only; excl. 2-center ', &
                                                  'turn off diagonal prescreening                    ', &
                                                  'turn on diagonal prescreening                     ', &
                                                  'set diagonal prescreening threshold               ', &
                                                  'use parallel decomposition algorithm              ', &
                                                  'simulate parallel algorithm (i.e. modified span)  ', &
                                                  'simulate RI (input 1-center threshold)            ', &
                                                  'activate fake parallel decomposition              ', &
                                                  'activate true parallel decomposition (deact. fake)', &
                                                  'set block size for Z vectors (parallel two-step)  ', &
                                                  'activate tracing of idle nodes (parallel run)     '], &
                               SECNAM = 'CHO_INP'
integer(kind=iwp), external :: IPRINTLEVEL
character(len=180), external :: GET_LN

! Define all entries in common blocks.
! Set output unit.
! Set run mode to "internal".
! ------------------------------------

IRC = 0
call CHO_X_SETINC(IRC)
LUPRI = LUOUT
RUN_MODE = RUN_INTERNAL
if (IRC /= 0) then
  write(LUPRI,*) SECNAM,': CHO_X_SETINC returned error code ',IRC
  write(LUPRI,*) '(most likely due to a programming error...)'
  call CHO_QUIT('Include file initialization error in '//SECNAM,102)
end if
n_MySP = 0
call CHO_SETGLOB()

! Set default parallel configuration.
! CHO_FAKE_PAR = .true. : fake parallel.
! CHO_FAKE_PAR = .false.: true parallel.
! --------------------------------------

CHO_FAKE_PAR = .false.
Cho_Real_Par = Is_Real_Par() .and. (.not. CHO_FAKE_PAR)

! Set default decomposition algorithm (depends on parallel or serial
! installation).
! ------------------------------------------------------------------

call CHO_SETDECALG_DEF()

! Set default MXSHPR (depends on parallel or serial).
! ---------------------------------------------------

call CHO_SETMXSHPR_DEF(MXSHPR_DEF)

! Set defaults.
! -------------

DECALG_USRDEF = .false.
MXSHPR_USRDEF = .false.
FAKE_USRDEF = .false.

CHO_DECALG = CHO_DECALG_DEF ! default decomposition algorithm
CHO_SIMP = .false.          ! do not simulate parallel algorithm
THRCOM = THRDEF             ! default decomposition threshold
LBUF = 1000000              ! buffer length for initial diagonal
THRDIAG = Zero              ! threshold for initial diag. screening
XLDIAG = Zero               ! just an initialization
DAMP(1) = -1.0e9_wp         ! damping for initial screening (neg.=>generic)
DAMP(2) = -1.0e9_wp         ! damping for later screenings (neg.=>generic)
SPAN = 1.0e-2_wp            ! span factor
MINQUAL = 50                ! min. #qual. needed for proceeding
MAXQUAL = 100               ! max. #qual. per symmetry
MXSHPR = MXSHPR_DEF         ! max. #sh. pairs for proceeding (0=>generic)
SCDIAG = .true.             ! screen diagonal during decom.
IALQUA = 2                  ! qualification algorithm
THRNEG = -1.0e-40_wp        ! diag<THRNEG => diag=0
WARNEG = -1.0e-10_wp        ! diag<WARNEG => diag=0, issue warning
TOONEG = -1.0e-8_wp         ! diag<TOONEG => shutdown
CHKONLY = .false.           ! flag for "check input only"
RSTDIA = .false.            ! flag for diagonal restart
RSTCHO = .false.            ! flag for decomposition restart
MODRST = -1                 ! default restart model (if restart at all)
MAXVEC = 0                  ! max. #Cholesky vectors (0=>generic)
MAXRED = 0                  ! max. #reduced sets (0=>generic)
NCOL_CHK = 0                ! #columns to check (0=>all if requested)
CHO_USEABS = .false.        ! do not use abs. value to set up red. sets
CHO_ADRVEC = 1              ! use WA addressing of vector files
CHO_IOVEC = 3               ! i/o model for reading Cholesky vectors
CHO_REORD = .false.         ! reorder Cholesky vectors to full storage
N1_VECRD = 2                ! numerator for fraction of mem. for iovec
N2_VECRD = 3                ! denominator for fraction of mem. for iovec
N1_QUAL = 1                 ! numerator for fraction of mem. for qual.
N2_QUAL = 3                 ! denominator for fraction of mem. for qual.
N_SUBTR = MAXQUAL           ! max. #vectors in subtraction of prev. vecs.
HALTIT = .false.            ! halt execution after decomposition
IFCSEW = 2                  ! get integrals directly in reduced set
FRAC_CHVBUF = 0.35_wp       ! memory fraction used for vector buffer
CHO_SSCREEN = .false.       ! screening in vector subtraction
SSTAU = -1.0e9_wp           ! threshold in vector subtraction (neg=>generic)
SSNORM = 'Max'              ! norm used for vector screening
SUBSCRSTAT(1) = Zero        ! vector screening statistics
SUBSCRSTAT(2) = Zero        ! vector screening statistics
CHO_1CENTER = .false.       ! do not decompose 1-center diagonals only
CHO_NO2CENTER = .false.     ! do not exclude 2-center diagonals
CHO_PRESCREEN = .true.      ! prescreen diagonal
THR_PRESCREEN = -1.0e9_wp   ! diag. prescreen threshold (neg=>generic)
CHO_SIMRI = .false.         ! simulate RI
THR_SIMRI = -1.0e9_wp       ! threshold for qualifying diags. in RI sim
#ifdef _DEBUGPRINT_
CHO_INTCHK = .true.         ! check integrals after decomposition
CHO_MINCHK = .true.         ! minimal integral check
CHO_TRCNEG = .true.         ! tracing of negative diagonals
CHO_DIACHK = .true.         ! check diagonals in qualified columns
TOL_DIACHK = 1.0e-10_wp     ! tolerance for dia. checking (if requested)
CHO_TSTSCREEN = .true.      ! test vector subtraction screening
#else
CHO_INTCHK = .false.        ! check integrals after decomposition
CHO_MINCHK = .false.        ! minimal integral check
CHO_TRCNEG = .false.        ! tracing of negative diagonals
CHO_DIACHK = .false.        ! check diagonals in qualified columns
TOL_DIACHK = 1.0e-14_wp     ! tolerance for dia. checking (if requested)
CHO_TSTSCREEN = .false.     ! test vector subtraction screening
#endif
BLOCKSIZE = 500             ! #vecs in each Z vector block
TRACE_IDLE = .false.        ! trace idle processes

! Set default print level using molcas environment (or whatever was
! set in seward initially).
! -----------------------------------------------------------------

IPRINT = IPRINTLEVEL(-1)
if (IPRINT <= 2) IPRINT = 1
IPRINT = IPRINT-1

! Return if defaults only.
! ------------------------

FORCEPARALLEL = .false.
if (.not. DFONLY) then

  ! Loop through keyword input.
  ! ---------------------------

  do

    ! Read next keyword and get corresponding ID.
    ! -------------------------------------------

    IDKEY = 0
    call CHO_MCA_GETKEY(LUNIT,OPTION,len(OPTION),NOPTION,IDKEY,LUPRI)

    if ((IDKEY >= 1) .and. (IDKEY <= NOPTION)) then  ! key found

      ! Branch for further processing.
      ! ------------------------------

      select case (IDKEY)

        case (1)
          ! Read decomposition threshold.
          ! -----------------------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,THRCOM)

        case (2)
          ! Read print level.
          ! -----------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,IPRINT)

        case (3)
          ! Read buffer length for diagonal calculation.
          ! --------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,LBUF)

        case (4)
          ! Read threshold for discarding initial diagonal elements.
          ! --------------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,THRDIAG)

        case (5)
          ! Read damping factor for 1st reduced set.
          ! ----------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,DAMP(1))

        case (6)
          ! Read damping factor for later reduced set.
          ! ------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,DAMP(2))

        case (7)
          ! Read span factor.
          ! -----------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,SPAN)
          SPAN = min(abs(SPAN),One)

        case (8)
          ! Read minimum number of qualifieds for decomposition.
          ! ----------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,MINQUAL)

        case (9)
          ! Read maximum number of shell pair distributions that should
          ! be calculated before passing to decomposition.
          ! -----------------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,MXSHPR)

        case (10)
          ! Turn on screening.
          ! ------------------

          SCDIAG = .true.

        case (11)
          ! Turn off screening.
          ! -------------------

          SCDIAG = .false.

        case (12)
          ! Read algorithm ID for qualification procedure,
          ! 1: qualify from 1 to max.
          ! 2: qualify the largest qualifiables
          ! ----------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,IALQUA)

        case (13)
          ! Read threshold for zeroing (small) negative diagonals.
          ! Diag < THRNEG => Diag = 0.
          ! ------------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,THRNEG)

        case (14)
          ! Read threshold for warning about negative diagonals.
          ! Diag < WARNEG => Diag = 0, but issue warning.
          ! ----------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,WARNEG)

        case (15)
          ! Read threshold for shutdown due to negative diagonals.
          ! Diag < TOONEG => shutdown.
          ! ------------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,TOONEG)

        case (16)
          ! Check configuration only.
          ! -------------------------

          CHKONLY = .true.

        case (17)
          ! Check all integrals after decomposition.
          ! ----------------------------------------

          CHO_INTCHK = .true.
          CHO_MINCHK = .false.
          NCOL_CHK = 0  ! => all

        case (18)
          ! Restart diagonal.
          ! -----------------

          RSTDIA = .true.

        case (19)
          ! Restart decomposition using default model.
          ! ------------------------------------------

          if (.not. RSTCHO) then
            RSTCHO = .true.
            MODRST = -1  ! use configuration from restart file
          end if

        case (20)
          ! Read restart model and set restart.
          ! -----------------------------------

          RSTCHO = .true.
          LINE = GET_LN(LUNIT)
          call GET_I1(1,MODRST)
          if (MODRST < 0) then
            MODRST = -1  ! use configuration from restart file
          else if (MODRST > 0) then
            MODRST = 1   ! use configuration from input
          end if

        case (21)
          ! Read max. #qualifieds per symmetry.
          ! -----------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,MAXQUAL)

        case (22)
          ! Read max. #Cholesky vectors per symmetry.
          ! -----------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,MAXVEC)

        case (23)
          ! Read max. #reduced sets.
          ! ------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,MAXRED)

        case (24)
          ! Read number of integral columns to check.
          ! -----------------------------------------

          CHO_INTCHK = .true.
          CHO_MINCHK = .false.
          LINE = GET_LN(LUNIT)
          call GET_I1(1,NCOL_CHK)

        case (25)
          ! Minimal integral check.
          ! -----------------------

          CHO_INTCHK = .true.
          CHO_MINCHK = .true.

        case (26)
          ! Use abs. value to set up reduced sets.
          ! --------------------------------------

          CHO_USEABS = .true.

        case (27)
          ! Do not use abs. value to set up reduced sets.
          ! ---------------------------------------------

          CHO_USEABS = .false.

        case (28)
          ! Turn on tracing of negative diagonals.
          ! --------------------------------------

          CHO_TRCNEG = .true.

        case (29)
          ! Read I/O model used for reading Cholesky vectors.
          ! -------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,CHO_IOVEC)

        case (30)
          ! Set vector reordering.
          ! ----------------------

          CHO_REORD = .true.

        case (31)
          ! Halt execution after decomposition.
          ! -----------------------------------

          HALTIT = .true.

        case (32)
          ! Set fraction of memory to be used as vector buffer during subtraction.
          ! ----------------------------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I(1,INTSCR,2)
          N1_VECRD = INTSCR(1)
          N2_VECRD = INTSCR(2)

        case (33)
          ! Set fraction of memory to be used for qualified columns.
          ! --------------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I(1,INTSCR,2)
          N1_QUAL = INTSCR(1)
          N2_QUAL = INTSCR(2)

        case (34)
          ! Set max. #vectors in subtraction of prev. vectors.
          ! --------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,N_SUBTR)

        case (35)
          ! Set address mode for vector I/O: WA (=1) or DA (=2).
          ! ----------------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,CHO_ADRVEC)

        case (36)
          ! Set model used to interface to integral code.
          ! ---------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,IFCSEW)
          if (IFCSEW < 1) then
            IFCSEW = 1
          else if (IFCSEW > 2) then
            IFCSEW = 2
          end if

        case (37)
          ! One-step (conventional) decomposition.
          ! --------------------------------------

          CHO_DECALG = 1
          DECALG_USRDEF = .true.

        case (38)
          ! Two-step (generate map, then vectors) decomposition.
          ! ----------------------------------------------------

          CHO_DECALG = 2
          DECALG_USRDEF = .true.

        case (39)
          ! Naive decomposition (remove diagonals as soon as smaller than threshold).
          ! -------------------------------------------------------------------------

          CHO_DECALG = 3
          DECALG_USRDEF = .true.

        case (40)
          ! Set memory fraction used for vector buffer.
          ! -------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,FRAC_CHVBUF)

        case (41)
          ! Turn on diagonal checking of qualified columns both before
          ! and after subtraction of previous vectors. Set tolerance in checking.
          ! ---------------------------------------------------------------------

          CHO_DIACHK = .true.
          LINE = GET_LN(LUNIT)
          call GET_F1(1,TOL_DIACHK)

        case (42)
          ! Test vector subtraction screening.
          ! ----------------------------------

          CHO_TSTSCREEN = .true.

        case (43)
          ! Use screening in vector subtraction.
          ! ------------------------------------

          CHO_SSCREEN = .true.

        case (44)
          ! Do not use screening in vector subtraction.
          ! -------------------------------------------

          CHO_SSCREEN = .false.

        case (45)
          ! Threshold for screening in vector subtraction.
          ! ----------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_F1(1,SSTAU)

        case (46)
          ! Threshold for screening in vector subtraction.
          ! ----------------------------------------------

          LINE = GET_LN(LUNIT)
          call GET_S(1,SSNORM,1)

        case (47)
          ! Decompose 1-center diagonals only. 2-center diagonals are
          ! still included, but never explicitly decomposed.
          ! ---------------------------------------------------------

          CHO_1CENTER = .true.

        case (48)
          ! Decompose 1-center diagonals only. 2-center diagonals are
          ! never included.
          ! ---------------------------------------------------------

          CHO_1CENTER = .true.
          CHO_NO2CENTER = .true.

        case (49)
          ! Turn off diagonal prescreening.
          ! -------------------------------

          CHO_PRESCREEN = .false.

        case (50)
          ! Turn on diagonal prescreening.
          ! ------------------------------

          CHO_PRESCREEN = .true.

        case (51)
          ! Set diagonal prescreening threshold.
          ! ------------------------------------

          CHO_PRESCREEN = .true.
          LINE = GET_LN(LUNIT)
          call GET_F1(1,THR_PRESCREEN)

        case (52)
          ! Use "parallel" decomposition algorithm.
          ! ---------------------------------------

          FORCEPARALLEL = .true.

        case (53)
          ! Use "parallel" decomposition algorithm.
          ! ---------------------------------------

          CHO_SIMP = .true.

        case (54)
          ! Simulate RI.
          ! Activate 1-center decomposition.
          ! Read threshold for removing 1-center diagonals in map generation.
          ! -----------------------------------------------------------------

          CHO_SIMRI = .true.
          CHO_1CENTER = .true.
          LINE = GET_LN(LUNIT)
          call GET_F1(1,THR_SIMRI)

        case (55)
          ! Activate fake parallel:
          ! Run parallel decomposition, then distribute vectors if parallel.
          ! ----------------------------------------------------------------

          CHO_FAKE_PAR = .true.
          FAKE_USRDEF = .true.

        case (56)
          ! Activate true parallel decomposition (deactivate fake).
          ! -------------------------------------------------------

          CHO_FAKE_PAR = .false.
          FAKE_USRDEF = .true.

        case (57)
          ! Read BlockSize (Z vectors).
          ! ---------------------------

          LINE = GET_LN(LUNIT)
          call GET_I1(1,BLOCKSIZE)

        case (58)
          ! Turn on tracing of idle nodes.
          ! ------------------------------

          TRACE_IDLE = .true.

        case default

          ! If this section is executed, it's most likely a bug.
          ! ----------------------------------------------------

          write(LUPRI,*) 'IDKEY = ',IDKEY,' is formally legal, but:'
          write(LUPRI,*) 'Did you forget to change the select case ',SECNAM,'?'
          call CHO_QUIT('Illegal address in select case in '//SECNAM,105)

      end select

    else if (IDKEY == NOPTION+1) then  ! end of input
      exit
    else if (IDKEY == -5) then ! some internal error
      write(LUPRI,*) SECNAM,': internal error detected, IDKEY = ',IDKEY
      IRC = 103
      call CHO_QUIT('Error in '//SECNAM,IRC)
    else if (IDKEY == -1) then ! keyword error
      write(LUPRI,*) SECNAM,': keyword error detected, IDKEY = ',IDKEY
      IRC = 105
      call CHO_QUIT('Error in '//SECNAM,IRC)
    else  ! catch all out-of-bound errors
      write(LUPRI,*) SECNAM,': IDKEY out of bounds: ',IDKEY
      IRC = 104
      call CHO_QUIT('Error in '//SECNAM,IRC)
    end if
  end do
end if

! Post processing.
! ----------------

if (FAKE_USRDEF) then
  ! reset parallel configuration
  Cho_Real_Par = Is_Real_Par() .and. (.not. CHO_FAKE_PAR)
  if (.not. DECALG_USRDEF) then ! reset default decomposition alg
    call CHO_SETDECALG_DEF()
    CHO_DECALG = CHO_DECALG_DEF
  end if
  if (.not. MXSHPR_USRDEF) then ! reset default MXSHPR
    call CHO_SETMXSHPR_DEF(MXSHPR_DEF)
    MXSHPR = MXSHPR_DEF
  end if
end if
call CHO_INP_SETDECALG(FORCEPARALLEL)
if (.not. MXSHPR_USRDEF) then
  if ((CHO_DECALG == 4) .or. (CHO_DECALG == 5) .or. (CHO_DECALG == 6)) then
    MXSHPR = 1
  else
    MXSHPR = 0
  end if
end if

! Put decomposition threshold in RICD_Info.
! -----------------------------------------

if (.not. Do_RI) Thrshld_CD = THRCOM

! Normal exit.
! ------------

return

! "Line" is unused, but the function it comes from (Get_Ln) has side effects
#include "macros.fh"
unused_var(Line)

end subroutine CHO_INP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine decomp_aniso(A,Jiso,Jsym,Jantisym,dbg)
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
      Real(kind=8), intent(in) :: A(3,3)
      Real(kind=8), intent(out):: Jiso, Jsym(3,3), Jantisym(3,3)
      Logical, intent(in)       :: dbg

      Integer :: i, j
      Real(kind=8) :: tmp
      Real(kind=8) :: Dtmp(3,3)

      tmp=0.0_wp
      Jiso=0.0_wp
      Jsym=0.0_wp
      Jantisym=0.0_wp
      !-------------------------------------
      do i=1,3
        tmp=tmp+A(i,i)
      end do
      Jiso=tmp/3.0_wp
      !-------------------------------------
      Do i=1,3
        Jsym(i,i)=A(i,i)-Jiso
      End Do

      ! find the symmetric matrix:
      Do i=1,3
        Do j=1,3
          if(i==j) cycle
          Jsym(i,j)=(A(i,j)+A(j,i))/2.0_wp
        End Do
      End Do
      ! find the anti-symmetric matrix:
      Do i=1,3
        Do j=1,3
          if(i==j) cycle
          Jantisym(i,j)=(A(i,j)-A(j,i))/2.0_wp
        End Do
      End Do

      If (dbg) Then
         Dtmp=0.0_wp
         Do i=1,3
           Dtmp(i,i)=Jiso+Jsym(i,i)+Jantisym(i,i)
           Do j=1,3
             if(i==j) cycle
               Dtmp(i,j)=Jsym(i,j)+Jantisym(i,j)
           End Do
         End Do

         Write(6,*)
         Write(6,*) 'J recovered = '
         Do i=1,3
            Write(6,'(3F24.14)') (Dtmp(i,j), j=1,3)
         End Do
      End If

      End subroutine decomp_aniso

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION ISYMST_MCLR(STRING,NEL)
*
* Master routine for symmetry of string
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input ( PNTGRP is used )
#include "detdim.fh"
#include "orbinp_mclr.fh"
*. Specific input
      INTEGER STRING(*)
*
      ISYM = 1
      DO 100 IEL = 1, NEL
        JSYM=ISMFTO(STRING(IEL))-1
cVV: this ugly code needed for CRAY SV1
        IVV=ISYM-1
        KVV = IEOR(IVV,JSYM)
        ISYM=KVV+1
100   CONTINUE
      ISYMST_MCLR = ISYM
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine bufio_wrzbuf_cvb()

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use casvb_global, only: file_id, ibuf, izbuffer, lbuf, nbuf, nword
use Definitions, only: wp, iwp, RtoI

implicit none
integer(kind=iwp) :: ioffset

if (ibuf == 0) return
ioffset = (ibuf-1)*lbuf/RtoI
call bufio_wrzbuf_cvb_internal(izbuffer)
if (ibuf > nbuf) nbuf = ibuf

return

! This is to allow type punning without an explicit interface
contains

subroutine bufio_wrzbuf_cvb_internal(izbuffer)
  integer(kind=iwp), target :: izbuffer(*)
  real(kind=wp), pointer :: buffer(:)
  call c_f_pointer(c_loc(izbuffer(1)),buffer,[nword])
  call wrlow_cvb(buffer,nword,file_id,ioffset+1)
  nullify(buffer)
end subroutine bufio_wrzbuf_cvb_internal

end subroutine bufio_wrzbuf_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Stefano Battaglia                                *
!***********************************************************************

#include "compiler_features.h"
#ifdef _DMRG_

subroutine mktg3qcm(lsym1,lsym2,state1,state2,ovl,tg1,tg2,ntg3,tg3)
! state 1: bra
! state 2: ket

use, intrinsic :: iso_c_binding, only: c_bool, c_int
use Symmetry_Info, only: Mul
use qcmaquis_interface, only: qcmaquis_interface_get_trans_1rdm_full, qcmaquis_interface_get_trans_2rdm_full, &
                              qcmaquis_interface_get_trans_3rdm_full, qcmaquis_interface_read_rdm_full
use printLevel, only: debug
use sguga, only: SGS
use caspt2_global, only: iPrGlb
use caspt2_module, only: nAshT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: lsym1, lsym2, state1, state2, ntg3
real(kind=wp), intent(out) :: ovl, tg1(nasht,nasht), tg2(nasht,nasht,nasht,nasht), tg3(ntg3)
integer(kind=iwp) :: ituvxyz, sym_sig1, sym_sig2, sym_tau, t, u, v, x, y, z
real(kind=wp), allocatable :: tg1_tmp(:,:), tg3_tmp(:,:,:,:,:,:)

if (iPrGlb >= debug) then
  write(u6,*) '=== QCM: Building TRANSITION-RDM ==='
  write(u6,*) 'between bra',state1,' and ket',state2
end if

! This might be memory hungry
call mma_allocate(tg3_tmp,nasht,nasht,nasht,nasht,nasht,nasht)
tg3_tmp(:,:,:,:,:,:) = Zero
tg2(:,:,:,:) = Zero
tg1(:,:) = Zero

! Needed to detect phase
! We compute the transition RDM in two ways in order to detect if a phase
! Flip occured whilst optimizing
call mma_allocate(tg1_tmp,nasht,nasht)

! Remeasure TDM using rotated MPS
call qcmaquis_interface_get_trans_1rdm_full(tg1,state2-1,state1-1)
call qcmaquis_interface_get_trans_2rdm_full(tg2,state2-1,state1-1)
call qcmaquis_interface_get_trans_3rdm_full(tg3_tmp,state2-1,state1-1)

! Fetch rotated TDM from unrotated MPS
call qcmaquis_interface_read_rdm_full(int(state2-1,kind=c_int),int(state1-1,kind=c_int),tg1_tmp,1_c_int,.true._c_bool)
call qcmaquis_interface_read_rdm_full(int(state2-1,kind=c_int),int(state1-1,kind=c_int),tg2,2_c_int,.true._c_bool)
call qcmaquis_interface_read_rdm_full(int(state2-1,kind=c_int),int(state1-1,kind=c_int),tg3_tmp,3_c_int,.true._c_bool)

! Detecting phase flip
! TODO: Implement this check, should abort
! currently fails as the two TDMs are not always the same
if (abs(tg1(1,1))-abs(tg1_tmp(1,1)) > 1.0e-9_wp) then
  write(u6,*) 'Internal error: 1-TDM do not correspond to the same state'
  write(u6,*) 'TG1:'
  do u=1,nasht
    do t=1,nasht
      write(u6,'(2I3,2F18.12)') t,u,tg1(t,u),tg1_tmp(t,u)
    end do
  end do
  call exit(1)
end if

! Rotating MPS or TDM yields different phase different phase
if (tg1(1,1)*tg1_tmp(1,1) < Zero) then
  write(u6,*) 'Phase flip detected: flipping phase'
  tg1(:,:) = -tg1(:,:)
  tg2(:,:,:,:) = -tg2(:,:,:,:)
  tg3_tmp(:,:,:,:,:,:) = -tg3_tmp(:,:,:,:,:,:)
end if
call mma_deallocate(tg1_tmp)

! TODO: compute the overlap, check in the original code how
! ovl = qcmaquis_interface_get_overlap_with_ket_bra(int(state1-1, c_int), int(state2-1, c_int))
ovl = Zero

do z=1,nasht
  do y=1,nasht
    ! symmetry of sigma2 = E_yz|Psi2>
    sym_sig2 = Mul(Mul(SGS%ism(y),SGS%ism(z)),lsym2)
    do x=1,nasht
      do v=1,nasht
        ! if (y + (z - 1) * nasht  < v + (x - 1) * nasht) then
        !   cycle
        ! end if
        ! symmetry of tau = E_vx|sigma2>
        sym_tau = Mul(Mul(SGS%ism(x),SGS%ism(v)),sym_sig2)
        do u=1,nasht
          do t=1,nasht
            ! if (v + (x - 1) * nasht  < t + (u - 1) * nasht) then
            !   cycle
            ! end if
            ! symmetry of SG_Epq_Psi = <Psi1|E_tu
            sym_sig1 = Mul(Mul(SGS%ism(t),SGS%ism(u)),lsym1)
            ! only for for matching symmetries we have an element different from 0
            if (sym_sig1 == sym_tau) then
              ! generate the flat index
              call get_tg3_index(t,u,v,x,y,z,nasht,ituvxyz)
              tg3(ituvxyz) = tg3_tmp(t,v,y,u,x,z)
            end if
          end do
        end do
      end do
    end do
  end do
end do
call mma_deallocate(tg3_tmp)
end subroutine mktg3qcm

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(mktg3qcm)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Francesco Aquilante                              *
!***********************************************************************

subroutine CHO_LR_MOs(iOK,nDen,nSym,nBas,nIsh,CM,MSQ)
!***********************************************************************
!
!   Computes Left (L) and Right (R) Cholesky vectors to represent a
!            non-symmetric density matrix
!
!            D = C[a] * C[b]^T = L * R^T
!
!   The code is generalized to treat density matrices with any number
!            (nDen) of distinct blocks. The corresponding Cholesky
!            vectors are returned in the arrays defined by the
!            DSBA_typed array MSQ
!
!   A non-zero value for the return code iOK indicates that something
!            went wrong and therefore the returned arrays may contain
!            junk
!
!   Author: F. Aquilante    (October 2008)
!
!***********************************************************************

use Data_Structures, only: DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: iOK
integer(kind=iwp), intent(in) :: nDen, nSym, nBas(nSym), nIsh(nSym)
type(DSBA_Type), intent(in) :: CM(nDen)
type(DSBA_Type), target, intent(inout) :: MSQ(nDen)
integer(kind=iwp) :: ia, ib, ikc, irc, iSym, iv, ja, jden, jv, k, l, n2b, nBm, NumV
real(kind=wp) :: Thr, Ymax
real(kind=wp), allocatable, target :: DMat0(:), PMat0(:)
real(kind=wp), pointer :: DMat(:,:) => null(), PMat(:,:,:,:) => null(), V(:,:) => null()

!***********************************************************************
irc = 0
ikc = 0

nBm = nBas(1)
do iSym=2,nSym
  nBm = max(nBm,nBas(iSym))
end do
call mma_allocate(DMat0,nBm**2,Label='DMat0')
if (nDen > 1) then
  call mma_allocate(PMat0,2*(nDen*nBm)**2,Label='PMat0')
end if

iSym = 1
do while (iSym <= nSym)

  DMat(1:nBas(iSym),1:nBas(iSym)) => DMat0(1:nBas(iSym)**2)
  if (nDen == 1) then
    PMat(1:nBas(iSym),1:1,1:nBas(iSym),1:1) => DMat0(1:nBas(iSym)**2)
  else
    PMat(1:nBas(iSym),1:nDen,1:nBas(iSym),1:nDen) => PMat0(1:(nDen*nBas(iSym))**2)
  end if

  if ((nBas(iSym) > 0) .and. (nIsh(iSym) > 0)) then

    ! Inactive P[kl](a,b) = sum_i C[k](a,i)*C[l](b,i)

    n2b = nDen*nBas(iSym)

    do k=1,nDen

      do l=1,nDen

        call DGEMM_('N','T',nBas(iSym),nBas(iSym),nIsh(iSym),One,CM(k)%SB(iSym)%A2,nBas(iSym),CM(l)%SB(iSym)%A2,nBas(iSym),Zero, &
                    DMat,nBas(iSym))

        do ib=1,nBas(iSym)
          PMat(:,k,ib,l) = DMat(:,ib)
        end do

      end do

    end do

    Ymax = Zero
    do ja=1,n2b ! Loop over the compound index
      k = (ja-1)/nBas(iSym)+1
      ia = ja-(k-1)*nBas(iSym)
      Ymax = max(Ymax,PMat(ia,k,ia,k))
    end do
    Thr = 1.0e-13_wp*Ymax

    if (nDen == 1) then
      V(1:,1:) => MSQ(1)%SB(iSym)%A2(:,:)
    else
      V(1:n2b,1:n2b) => PMat0((nDen*nBm)**2+1:(nDen*nBm)**2+n2b**2)
    end if

    call CD_InCore(PMat,n2b,V,n2b,NumV,Thr,irc)

    if (NumV /= nIsh(iSym)) ikc = 1

    if (nDen > 1) then
      do jden=1,nDen
        do jv=1,NumV
          iv = 1+nBas(iSym)*(jden-1)
          call dcopy_(nBas(iSym),V(iv:,jv),1,MSQ(jDen)%SB(iSym)%A2(:,jv),1)
        end do
      end do
    end if

  end if

  if ((irc /= 0) .or. (ikc /= 0)) iSym = nSym

  iSym = iSym+1

  V => null()
  DMat => null()
  PMat => null()

end do

if (nDen > 1) call mma_deallocate(PMat0)
call mma_deallocate(DMat0)

iOK = 0
if ((irc /= 0) .or. (ikc /= 0)) iOK = 1

return

end subroutine CHO_LR_MOs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine PNT2DM(I12SM,NSMOB,IPSM,JPSM,IJSM,ISM2,IPNTR)
! Pointer to two dimensional array
!
! =====
! Input
! =====
! I12SM : /= 0 => restrict to lower half
!         == 0 => complete matrix
! NSMOB : Number of orbital symmetries
! IPSM  : Number of orbitals per symmetry for index 1
! JPSM  : Number of orbitals per symmetry for index 2
! IJSM  : Symmetry of two index array
!
! =======
! Output
! =======
! IPNTR : Pointer to block with first index of given symmetry
!         = 0 indicates forbidden block
! ISM2  : symmetry of second index for given first index

use Symmetry_Info, only: Mul
use Index_Functions, only: nTri_Elem
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: I12SM, NSMOB, IPSM(NSMOB), JPSM(NSMOB), IJSM
integer(kind=iwp), intent(out) :: ISM2(NSMOB), IPNTR(NSMOB)
integer(kind=iwp) :: IOFF, ISM, JSM

IPNTR(1:NSMOB) = 0
ISM2(1:NSMOB) = 0
IOFF = 1
do ISM=1,NSMOB
  JSM = Mul(ISM,IJSM)
  if (JSM == 0) exit
  if ((I12SM == 0) .or. (ISM >= JSM)) then
    ! Allowed block
    IPNTR(ISM) = IOFF
    ISM2(ISM) = JSM
    if ((I12SM > 0) .and. (ISM == JSM)) then
      IOFF = IOFF+nTri_Elem(IPSM(ISM))
    else
      IOFF = IOFF+IPSM(ISM)*JPSM(JSM)
    end if
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' dimension of two-dimensional array ',IOFF-1
write(u6,*) ' Pointer'
call IWRTMA(IPNTR,1,NSMOB,1,NSMOB)
write(u6,*) ' Symmetry of other array'
call IWRTMA(ISM2,1,NSMOB,1,NSMOB)
#endif

end subroutine PNT2DM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine max5h1 (imax,rmax,symp,symq,symr,syms,p,q,r,s,value)
c
c     this routine add new max amplitude and skip smallest
c
c     imax - store of indexes of 5 max (I/O)
c     rmax - store of values of 5 max (I/O)
c     symp - symmetry of p index (I)
c     symq - symmetry of q index (I)
c     symr - symmetry of r index (I)
c     syms - symmetry of s index (I)
c     p    - value of p index (I)
c     q    - value of q index (I)
c     r    - value of r index (I)
c     s    - value of s index (I)
c     value- value of amplitude (I)
c
       integer imax(1:8,1:5)
       real*8 rmax (1:5)
       integer symp,symq,symr,syms,p,q,r,s
       real*8 value
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3
c
c1    find possition of this value
c
       do 10 nhelp1=1,5
       if (abs(value).ge.abs(rmax(nhelp1))) then
       goto 20
       end if
 10     continue
c
c2    1-(nhelp1-1) stay untought
c
c3    push other records if necc.
c
 20     if (nhelp1.lt.5) then
       do 30 nhelp2=4,nhelp1,-1
       rmax(nhelp2+1)=rmax(nhelp2)
       do 31 nhelp3=1,8
       imax(nhelp3,nhelp2+1)=imax(nhelp3,nhelp2)
 31     continue
 30     continue
       end if
c
c4    add new one
c
       rmax(nhelp1)=value
       imax(1,nhelp1)=symp
       imax(2,nhelp1)=symq
       imax(3,nhelp1)=symr
       imax(4,nhelp1)=syms
       imax(5,nhelp1)=p
       imax(6,nhelp1)=q
       imax(7,nhelp1)=r
       imax(8,nhelp1)=s
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_T1(T1,key)
! check T1

use chcc_global, only: Hooc, Hvoc, Hvvc, no, nv, Q1, Q21, Q22, Q3, T1c, T2c
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: T1(nv,no)
integer(kind=iwp), intent(in) :: key
integer(kind=iwp) :: a, b, bad, be, i, j, u
real(kind=wp) :: s

bad = 0

do u=1,no
  do be=1,nv

    s = Zero

    do a=1,nv
      s = s+Hvvc(be,a)*T1c(a,u)
    end do

    do i=1,no
      s = s-Hooc(i,u)*T1c(be,i)
    end do

    do i=1,no
      do a=1,nv
        s = s+Hvoc(a,i)*(Two*T2c(a,be,i,u)-T2c(a,be,u,i)+T1c(a,u)*T1c(be,i))
      end do
    end do

    do i=1,no
      do a=1,nv
        s = s+(Two*Q21(a,i,be,u)-Q22(a,be,i,u))*T1c(a,i)
      end do
    end do

    do i=1,no
      do b=1,nv
        do a=1,nv
          s = s+(Two*Q3(b,be,a,i)-Q3(a,be,b,i))*(T2c(a,b,i,u)+T1c(a,i)*T1c(b,u))
        end do
      end do
    end do

    do i=1,no
      do j=1,no
        do a=1,nv
          s = s-(Two*Q1(a,i,u,j)-Q1(a,j,u,i))*(T2c(a,be,i,j)+T1c(a,i)*T1c(be,j))
        end do
      end do
    end do

    !s = s/(Oeo(u)-Oev(be))

    if (abs(T1(be,u)-s) > 1.0e-10_wp) then
      bad = bad+1
      if (key == 1) T1(be,u) = s
    end if

  end do
end do

write(u6,*) ' T1 test :',bad

return

end subroutine Chck_T1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2002, Laura Gagliardi                                  *
*               2002, Roland Lindh                                     *
************************************************************************
      Subroutine LoProp(ireturn)
************************************************************************
*      Author:Laura Gagliardi, Dipartimento di Chimica Fisica,         *
*             University of Palermo, ITALY. December 2002              *
*             Roland Lindh, Department of Chemical Physics,            *
*             University of Lund, SWEDEN.                              *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "itmax.fh"
#include "Molcas.fh"
      Parameter (nElem=(iTabMx*(iTabMx**2+6*iTabMx+11)+6)/6)
#include "WrkSpc.fh"
#include "real.fh"
      Real*8 Origin(3,0:iTabMx), CoC(3)
      Integer nBas(8), ip_mu(0:nElem-1), nOrb(8),ip_sq_mu(0:nElem-1),
     &        ip_D(0:6)
      Logical NoField, Standard, Utility, UserDen,PrintDen,SubtractDen
      Logical Restart, TDensity,lSave, Reduce_Prt
      External Reduce_Prt
      Character*(LENIN4) LblCnt(MxAtom)
      Character*12  Opt_Method
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      Utility = .True.
      Utility = .False.
      lSave = ireturn.eq.0
      ireturn=99

      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0

*                                                                      *
************************************************************************
*                                                                      *
*     Prelude
*
      Call Init_LoProp(nSym,nBas,nOrb,CoC,nAtoms,ipC,ipQ_Nuc,ip_ANr,
     &                 ip_Type,ip_Center,nSize,nBas1,nBas2,nBasMax,ipP,
     &                 ipPInv)
*                                                                      *
************************************************************************
*                                                                      *
*     Read the input
*
*     NoField is defaulted to true if symmetry is implied.
*
      NoField = .True.
      Standard=.True.
      UserDen=.False.
      PrintDen=.False.
      SubtractDen=.False.
      Restart=.False.
      TDensity=.false.
      nStateI=1
      nStateF=1
      Delta=0.001D0
      MpProp_Level=0
      Bond_Threshold=-1.0D0
      iPlot = 0
      iPrint = 0
*                                                                      *
************************************************************************
*                                                                      *
*     Do the LoProp localization.
*
      Call GetMem('Ttot','Allo','Real',ip_Ttot,nBas1**2)
      Call GetMem('TtotInv','Allo','Real',ip_Ttot_Inv,nBas1**2)
*
      Call  Localize_LoProp_Drv(Work(ip_Ttot),Work(ip_Ttot_Inv),nBas,
     &                          iWork(ip_Center),iWork(ip_Type),
     &                          nBas1,nBas2,nSym,nBasMax,ipPInv,Restart)
*
      Call Free_iWork(ip_type)
*                                                                      *
************************************************************************
*                                                                      *
*     Read in the multipole moment integrals once and for all.
*
      lMax=0   ! do only charges
      mElem=(lMax*(lMax**2+6*lMax+11)+6)/6
*
      nTemp = nBas1**2
      Call Allocate_Work(ip_tmp,nTemp)
*
      Call Allocate_Work(ipMPq,mElem)
      Call Read_Multipole_Int(lMax,ip_sq_mu,nBas,ip_mu,
     &                        Work(ip_Ttot),Work(ip_tmp),Origin,
     &                        Work(ipMPq),mElem,nBas1,nBas2,nBasMax,
     &                        nTemp,nSym,ipPInv,Restart,Utility)
      Call Free_Work(ip_Ttot)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the 1-particle density matrix
*
      Dlt=-Delta
      iPert = 0
      Call Get_Density_Matrix(ip_D(0),nBas1,nBas2,nBasMax,nBas,nSym,
     &                       ipP,UserDen,PrintDen,SubtractDen,SubScale,
     &                       Work(ipQ_Nuc),nAtoms,iPert,Restart,Utility,
     &                       TDensity,nStateI,nStateF)
*
      Do i = mElem, 1, -1
         Call Free_Work(ip_mu(i-1))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     S T A T I C   P R O P E R T I E S                                *
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute localized multipole moments
*
      nPert = 2*3+1
      If (NoField) nPert=1
      nij= (nAtoms*(nAtoms+1)/2)
      nmu=nij*mElem*nPert
      Call Allocate_Work(ipMP,nmu)
      Call Allocate_Work(ip_sq_temp,nTemp)
      Call Allocate_Work(ip_EC,3*nij)
*
      If (iPL.ge.2) Then
         Write(6,*)
         Call CollapseOutput(1,'   Static properties:')
         Write(6,'(3X,A)')     '   ------------------'
         Write(6,*)
      End If
      Call Local_Properties(Work(ipC),nAtoms,ip_sq_mu,mElem,
     &                      Work(ip_sq_temp),Origin,
     &                      iWork(ip_center),Work(ip_Ttot_Inv),
     &                      Work(ip_tmp),nij,nPert,ip_D,
     &                      Work(ipMP),lMax,Work(ipMPq),CoC,Work(ip_EC),
     &                      iWork(ip_ANr),Standard,nBas1,nTemp,
     &                      Work(ipQ_Nuc),Bond_Threshold,
     &                      Utility,Opt_Method,iPlot,iPrint,nSym)
*
      Do i = mElem, 1, -1
         Call Free_Work(ip_sq_mu(i-1))
      End Do
      Call Free_Work(ip_Ttot_Inv)
      Call Free_Work(ip_sq_temp)
      Call Free_iWork(ip_center)
*                                                                      *
************************************************************************
*                                                                      *
      Call Allocate_Work(ipPol,6*nij)
*                                                                      *
************************************************************************
*                                                                      *
*     Print out the properties
*
      Call Get_cArray('LP_L',LblCnt,(LENIN4)*nAtoms)
      Call LoProp_Print(Work(ipMP),nij,nElem,nAtoms,Work(ipQ_Nuc),
     &                       LblCnt,lSave)
      If (iPL.ge.2) Then
         Call CollapseOutput(0,'   Static properties:')
         Write(6,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_Work(ipPol)
      Call Free_Work(ipQ_Nuc)
      Call Free_Work(ipMPq)
      Call Free_Work(ip_EC)
      Call Free_Work(ipMP)
      Call Free_Work(ip_Tmp)
      Call Free_iWork(ip_ANr)
      Call Free_Work(ipC)
      If (nSym.ne.1) Then
         Call Free_Work(ipP)
         Call Free_Work(ipPInv)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      ireturn=0
*                                                                      *
************************************************************************
*                                                                      *
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKCLIST_m(ISM,IDOWN,NOW,IOW,ICASE,ISCR)
C
C     PURPOSE: CONSTRUCT THE COMPRESSED CASE-LIST, I.E.,
C              STORE THE STEP VECTOR FOR ALL POSSIBLE WALKS
C              IN THE ARRAY ICASE. GROUPS OF 15 CASES ARE PACKED
C              INTO ONE INTEGER WORD.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "rasdim.fh"
#include "general.fh"
#include "gugx.fh"
C
      DIMENSION ISM(NLEV),IDOWN(NVERT,0:3)
      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)
      DIMENSION ICASE(NICASE)
      DIMENSION ISCR(3,0:NLEV)
      PARAMETER(IVERT=1,ISYM=2,ISTEP=3)
C
C     CLEAR ARRAY NOW. IT WILL BE RESTORED FINALLY
C
      DO IHALF=1,2
        DO MV=1,NMIDV
          DO IS=1,NSYM
            NOW(IHALF,IS,MV)=0
          END DO
        END DO
      END DO
C
C     START MAIN LOOP OVER UPPER AND LOWER WALKS, RESPECTIVELY.
C
      DO IHALF=1,2
        IF(IHALF.EQ.1) THEN
          IVTSTA=1
          IVTEND=1
          LEV1=NLEV
          LEV2=MIDLEV
        ELSE
          IVTSTA=MIDV1
          IVTEND=MIDV2
          LEV1=MIDLEV
          LEV2=0
        END IF
C
C     LOOP OVER VERTICES STARTING AT TOP OF SUBGRAPH
C
        DO IVTOP=IVTSTA,IVTEND
C SET CURRENT LEVEL=TOP LEVEL OF SUBGRAPH:
          LEV=LEV1
          ISCR(IVERT,LEV)=IVTOP
          ISCR(ISYM,LEV)=1
          ISCR(ISTEP,LEV)=-1
100       IF(LEV.GT.LEV1) GOTO 400
C FIND FIRST POSSIBLE UNTRIED ARC DOWN FROM CURRENT VERTEX:
          IVT=ISCR(IVERT,LEV)
          DO ISTP=ISCR(ISTEP,LEV)+1,3
            IVB=IDOWN(IVT,ISTP)
            IF(IVB.EQ.0) GOTO 110
            GOTO 200
110         CONTINUE
          END DO
C ALT A -- NO SUCH ARC WAS POSSIBLE. GO UP ONE STEP AND TRY AGAIN.
          ISCR(ISTEP,LEV)=-1
          LEV=LEV+1
          GOTO 100
C ALT B -- SUCH AN ARC WAS FOUND. WALK DOWN:
200       ISCR(ISTEP,LEV)=ISTP
          ISML=1
          IF((ISTP.EQ.1).OR.(ISTP.EQ.2)) ISML=ISM(LEV)
          LEV=LEV-1
          ISCR(ISYM,LEV)=MUL(ISML,ISCR(ISYM,LEV+1))
          ISCR(IVERT,LEV)=IVB
          ISCR(ISTEP,LEV)=-1
          IF (LEV.GT.LEV2) GOTO 100
C WE HAVE REACHED THE LOWER LEVEL. THE WALK IS COMPLETE.
C MIDVERTEX NUMBER:
          MV=ISCR(IVERT,MIDLEV)+1-MIDV1
C SYMMETRY LABEL OF THIS WALK:
          IWSYM=ISCR(ISYM,LEV2)
C ITS ORDERING NUMBER WITHIN THE SAME BATCH OF (IHALF,IWSYM,MV):
          ILND=1+NOW(IHALF,IWSYM,MV)
          NOW(IHALF,IWSYM,MV)=ILND
C CONSEQUENTLY, THE POSITION IMMEDIATELY BEFORE THIS COMPRESSED WALK:
          IPOS=IOW(IHALF,IWSYM,MV)+(ILND-1)*NIPWLK
C PACK THE STEPS IN GROUPS OF 15 LEVELS PER INTEGER:
          DO LL=LEV2+1,LEV1,15
            IC=0
            DO L=MIN(LL+14,LEV1),LL,-1
              IC=4*IC+ISCR(ISTEP,L)
            END DO
            IPOS=IPOS+1
            ICASE(IPOS)=IC
          END DO
C FINISHED WITH THIS WALK. BACK UP ONE LEVEL AND TRY AGAIN:
          LEV=LEV+1
          GOTO 100
400       CONTINUE
        END DO
      END DO
C
C     EXIT
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ProdsA_2t(AB,iA,iB,CMO,nMO,Y)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iA, iB, nMO
real(kind=wp), intent(in) :: AB(iA,iB), CMO(iA,nMO)
real(kind=wp), intent(out) :: Y(iB,nMO)

call DGEMM_('T','N',iB,nMO,iA,One,AB,iA,CMO,iA,Zero,Y,iB)

return

end subroutine ProdsA_2t

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine vbgendet2_cvb(
     >  iapr,ixapr,ibpr,ixbpr,
     >  iconfs,idetvb,
     >  nconf,nconfion,
     >  nda,ndb,ndetvb,nel,
     >  noe,nalf,nbet,norb,
     >  idetavb,idetbvb,iwrk1,iwrk2)
      implicit real*8 (a-h,o-w,y-z),integer(x)
      dimension iapr(ndetvb),ixapr(nda+1),ibpr(ndetvb),ixbpr(ndb+1)
      dimension iconfs(noe,nconf),idetvb(ndetvb)
      dimension nconfion(0:nel)
      dimension idetavb(ndetvb),idetbvb(ndetvb)
      dimension iwrk1(ndetvb),iwrk2(ndetvb)
      logical debug
      data debug/.false./

      if(debug)then
        write(6,*)' Generate determinant information :'
        write(6,*)' ----------------------------------'
      endif

c  vbgenabdet gives all VB alpha and beta strings, to use in CASSCF
c  space we sort in A/B strings to get increasing order :
      call vbgenabdet_cvb(idetavb,idetbvb,
     >  iconfs,nconf,nconfion,
     >  ndetvb,nel,noe,
     >  nalf,nbet,norb)

      call sortindxi_cvb(ndetvb,idetbvb,idetvb)
      do 100 i=1,ndetvb
      iwrk1(i)=idetbvb(idetvb(i))
      ibpr(i)=idetavb(idetvb(i))
100   continue
      ixbpr(1)=1
      do 200 i=1,ndb
      do 300 j=ixbpr(i),ndetvb
      if(iwrk1(j).ne.i)goto 400
300   continue
      j=ndetvb+1
400   ixbpr(i+1)=j
200   continue
      do 500 i=1,ndb
      call sortindxi_cvb(ixbpr(i+1)-ixbpr(i),ibpr(ixbpr(i)),iwrk2)
      do 600 j=1,ixbpr(i+1)-ixbpr(i)
      iwrk1(j)=ibpr(iwrk2(j)+ixbpr(i)-1)
600   continue
      call imove_cvb(iwrk1,ibpr(ixbpr(i)),ixbpr(i+1)-ixbpr(i))
500   continue
      if(debug)then
        write(6,*)' ixbpr='
        write(6,'(10i6)')ixbpr
        write(6,*)' ibpr='
        write(6,'(10i6)')ibpr
      endif

      call sortindxi_cvb(ndetvb,idetavb,idetvb)
      do 700 i=1,ndetvb
      iwrk1(i)=idetavb(idetvb(i))
      iapr(i)=idetbvb(idetvb(i))
700   continue
      ixapr(1)=1
      do 800 i=1,nda
      do 900 j=ixapr(i),ndetvb
      if(iwrk1(j).ne.i)goto 1000
900   continue
      j=ndetvb+1
1000  ixapr(i+1)=j
800   continue
      do 1100 i=1,nda
      call sortindxi_cvb(ixapr(i+1)-ixapr(i),iapr(ixapr(i)),iwrk2)
      do 1200 j=1,ixapr(i+1)-ixapr(i)
      iwrk1(j)=iapr(iwrk2(j)+ixapr(i)-1)
1200  continue
      call imove_cvb(iwrk1,iapr(ixapr(i)),ixapr(i+1)-ixapr(i))
      do 1300 j=1,ixapr(i+1)-ixapr(i)
      iwrk1(j)=idetvb(iwrk2(j)+ixapr(i)-1)
1300  continue
      call imove_cvb(iwrk1,idetvb(ixapr(i)),ixapr(i+1)-ixapr(i))
1100  continue
      if(debug)then
        write(6,*)' ixapr='
        write(6,'(10i6)')ixapr
        write(6,*)' iapr='
        write(6,'(10i6)')iapr
      endif
      do 1400 i=1,ndetvb
      idetavb(idetvb(i))=i
1400  continue
      call imove_cvb(idetavb,idetvb,ndetvb)
      if(debug)then
        write(6,*)' idetvb='
        write(6,'(10i6)')idetvb
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE AIBJ(L0,L1,L2,L3,ITAI)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
      DIMENSION L0(*),L1(*),L2(*),L3(*),ITAI(*)
#include "real_guga.fh"
#include "integ.fh"
#include "files_guga.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
      COMMON/D/JNDX(500 000)
      DIMENSION NUMM(7)
*
      JO(L)=ICUNP(ICASE,L)
*
      IC1=0    ! dummy initialize
      IC2=0    ! dummy initialize
      COPLA=D0 ! dummy initialize
      DO 5 I=1,7
      NUMM(I)=0
5     CONTINUE
      IOUT=0
      NMAT=0
      DO 10 NI=1,LN
      DO 20 NJ=1,NI
      I=ICH(NI)
      J=ICH(NJ)
      IF(I.GT.J)GO TO 19
      I=ICH(NJ)
      J=ICH(NI)
19    LTYP=0
      IOUT=IOUT+1
      ICOP1(IOUT)=0
      IF(IOUT.LT.NBUF)GO TO 460
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
460   IOUT=IOUT+1
CPAM96      ICOP1(IOUT)=IOR(I,ISHFT(J,10))
*      ICOP1(IOUT)=I+2**10*J
      ICOP1(IOUT)=IOR(I,ISHFT(J,10))
      IF(IOUT.LT.NBUF)GO TO 11
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
11    IJS=IJ(I+1)+1
      IJM=IJ(I)
C     FIRST ORDER INTERACTION
C     TRIPLET-VALENCE INTERACTIONS
      JTURN=1
      ITURN=0
      ITT1=2
      ITT2=0
150   IT1=ITT1*MXVERT
culf      IT2=ITT2*300
      IT2=ITT2*MXVERT
      II=0
      IID=0
      IF(ITT2.EQ.0)GO TO 149
      II=IRC(ITT2)
      IID=JRC(ITT2)
149   JJ=IRC(ITT1)
      JJD=JRC(ITT1)
      ITYP=JTURN
      IF(ITURN.NE.0)ITYP=JTURN-2
      DO 30 IJJ=IJS,IJM
      ITAIL=IX(IT2+IJJ)
      IF(IT1.NE.IT2)CALL TAIL(I,IJJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
      IWAY(I)=1
32    KM=I
      J2(KM+1)=IJJ
      J1(KM+1)=IJJ
      IF(I.EQ.J)GO TO 51
      CALL LOOP1(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 30
41    KM=KM-1
      IWAY(KM)=1
      IF(KM.EQ.J)GO TO 51
42    CALL LOOP5(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 41
      KM=KM+1
      IF(KM.EQ.I)GO TO 32
      GO TO 42
51    IWAY(J)=1
52    KM=J
      JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      IABIJ=0
      IF(I.EQ.J)GO TO 12
      IF(ITURN.EQ.0)CALL LOOP10(KM,ISTOP,IT1,IT2)
      IFAI=1
      IF(ITURN.EQ.1)CALL LOOP13(KM,ISTOP,IFAI,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 14
      IF(J1(KM).NE.J2(KM))GO TO 13
      IABIJ=1
      IC1=ICOUP(KM)
      IC2=ICOUP1(KM)
      KM1=KM+1
      IDIF=IA(J1(KM1))-IA(J2(KM1))
      IF(IWAY(J).EQ.2)COPLA=COUP(J+1)
      IF(IDIF.EQ.0.AND.IWAY(J).EQ.5)COPLA=COUP(J+1)*BS4(IB(J2(J+1))+1)
      IF(IDIF.EQ.1.AND.IWAY(J).EQ.4)COPLA=COUP(J+1)*BS3(IB(J2(J+1))+1)
      GO TO 53
12    IF(ITURN.EQ.0)CALL LOOP7(KM,ISTOP,IT1,IT2)
      IFAI=1
      IF(ITURN.EQ.1)CALL LOOP26(KM,ISTOP,IFAI,IT1,IT2)
      LTYP=1
      IF(IWAY(I).EQ.5)LTYP=0
13    IF(ISTOP.EQ.0)GO TO 53
14    IF(I.EQ.J)GO TO 30
      KM=KM+1
      IF(KM.EQ.I)GO TO 32
      GO TO 42
53    KM=KM-1
      IF(KM.EQ.0)GO TO 61
      IWAY(KM)=1
62    JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      IF(ITURN.EQ.0)CALL LOOP17(KM,ISTOP,IT1,IT2)
      IFAI=0
      IF(J1(KM+1).NE.J2(KM+1))GO TO 165
      IF(I.EQ.J)GO TO 162
      IF(IABIJ.EQ.0)GO TO 165
      IC11=ICOUP(KM+1)-IC1
      IC22=ICOUP1(KM+1)-IC2
      IF(IC11.EQ.IC22)IFAI=1
      GO TO 165
162   IF(ICOUP(KM+1).NE.ICOUP1(KM+1))GO TO 165
      IFAI=1
165   IF(ITURN.EQ.1)CALL LOOP23(KM,ISTOP,IFAI,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 53
      KM=KM+1
      IF(KM.EQ.J)GO TO 52
      GO TO 62
61    COPL=COUP(1)
      IF(JTURN.GE.6.OR.JTURN.EQ.3)COPL=COUP1(1)
      IFAB=0
      IF(JTURN.NE.5)GO TO 63
      IF(I.EQ.J.AND.LTYP.EQ.1)GO TO 72
63    IF(ITT1.NE.ITT2)GO TO 70
      IF(I.NE.J)GO TO 65
      IF(LTYP.EQ.1.AND.ICOUP(1).GT.ICOUP1(1))GO TO 72
65    IF(IABIJ.EQ.0)GO TO 70
      IC11=ICOUP(1)-IC1
      IC22=ICOUP1(1)-IC2
      IF(IC11.EQ.IC22)IFAB=1
70    COPLA0=COPLA
      IF(IFAB.EQ.0)COPLA0=D0
      DO 80 IN=1,ITAIL
      ICP1=ICOUP(1)+IN
      JND1=JNDX(II+ICP1)
      IF(JND1.EQ.0)GO TO 80
      ICP1=JND1-IID
      IF(ITT1.NE.ITT2)GO TO 289
      IN2=IN
      GO TO 288
289   IN2=ITAI(IN)
      IF(IN2.EQ.0)GO TO 80
288   ICP2=ICOUP1(1)+IN2
      JND2=JNDX(JJ+ICP2)
      IF(JND2.EQ.0)GO TO 80
      ICP2=JND2-JJD
      IF(ITT1.NE.ITT2.OR.ICP1.NE.ICP2)GO TO 100
      JJ1=(JJD+ICP1-1)*LN+I
      JOJ=JO(JJ1)
      IF(JOJ.GT.1)JOJ=JOJ-1
      COPLA0=JOJ-2
      IFAB=1
100   IOUT=IOUT+1
      NUMM(JTURN)=NUMM(JTURN)+1
      COP(IOUT)=COPL
CPAM96      IND1=IOR(IFAB,ISHFT(ITURN,1))
CPAM96      IND2=IOR(IND1,ISHFT(ITYP,2))
CPAM96      IND3=IOR(IND2,ISHFT(ICP1,5))
CPAM96      ICOP1(IOUT)=IOR(IND3,ISHFT(ICP2,18))
*      IND1=IFAB+2**1*ITURN
*      IND2=IND1+2**2*ITYP
*      IND3=IND2+2**5*ICP1
*      ICOP1(IOUT)=IND3+2**18*ICP2
      IND1=IOR(IFAB,ISHFT(ITURN,1))
      IND2=IOR(IND1,ISHFT(ITYP,2))
      IND3=IOR(IND2,ISHFT(ICP1,5))
      ICOP1(IOUT)=IOR(IND3,ISHFT(ICP2,18))
      IF(IOUT.LT.NBUF)GO TO 71
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
71    IF(IFAB.EQ.0)GO TO 80
      IOUT=IOUT+1
      NUMM(JTURN)=NUMM(JTURN)+1
      COP(IOUT)=COPLA0
      ICOP1(IOUT)=1
      IF(IOUT.LT.NBUF)GO TO 80
      ICOP1(nCOP+1)=NBUF
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+NBUF
      IOUT=0
80    CONTINUE
72    KM=KM+1
      IF(KM.EQ.J)GO TO 52
      GO TO 62
30    CONTINUE
      GO TO (151,152,153,154,155,156,20),JTURN
C     SINGLET-VALENCE INTERACTIONS
151   JTURN=2
      ITT1=3
      GO TO 150
C     TRIPLET-TRIPLET INTERACTIONS
152   JTURN=3
      ITURN=1
      ITT1=2
      ITT2=2
      GO TO 150
C     SINGLET-SINGLET INTERACTIONS
153   JTURN=4
      ITT1=3
      ITT2=3
      GO TO 150
C     TRIPLET-SINGLET INTERACTIONS
154   JTURN=5
      ITT1=2
      ITT2=3
      GO TO 150
C     SINGLET-TRIPLET INTERACTIONS
155   JTURN=6
      ITT1=3
      ITT2=2
      GO TO 150
C     DOUBLET-DOUBLET INTERACTIONS
156   JTURN=7
      ITT1=1
      ITT2=1
      GO TO 150
20    CONTINUE
10    CONTINUE
      ICOP1(nCOP+1)=IOUT
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT=NMAT+IOUT
      ICOP1(nCOP+1)=-1
      CALL dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      CALL iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      WRITE(IW,600)NMAT
600   FORMAT(/,6X,'COEFFICIENTS FOR AIBJ',I9)
      WRITE(IW,610)(NUMM(I),I=1,7)
610   FORMAT(6X,'DIFFERENT TYPES',7I9)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine InitT(K_Lap,T,RIni,RNew)
!-----------------------------------------------------------------------
! Function : Set the initial T()
!-----------------------------------------------------------------------

use ReMez_mod, only: IW
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: K_Lap
real(kind=wp), intent(out) :: T(2*K_Lap)
real(kind=wp), intent(in) :: RIni, RNew
integer(kind=iwp) :: I
real(kind=wp) :: Val
logical(kind=iwp) :: Dbg

Dbg = .false.
Val = (RNew-One)/(RIni-One)

if (Dbg) write(IW,'(A)') 'T(I)'
do I=1,2*K_Lap
  T(I) = One+(T(I)-One)*Val
  if (Dbg) write(IW,'(I3,2X,F20.14)') I,T(I)
end do

return

end subroutine InitT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Read_Bin_Columbus(iShell_A,iShell_B,iShell_C,iShell_D,G_Toc,nQuad,Gmma,nGamma,LuGamma,Bin,lBin)

use Index_Functions, only: iTri
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iShell_A, iShell_B, iShell_C, iShell_D, nQuad, nGamma, LuGamma, lBin
real(kind=wp), intent(in) :: G_Toc(nQuad)
real(kind=wp), intent(out) :: Gmma(nGamma), Bin(2,lBin)
integer(kind=iwp) :: iDisk, idisk_save, iGamma, iShell_AB, iShell_ABCD, iShell_CD, jGamma, lGamma
integer(kind=iwp), parameter :: iRead = 2

Gmma(:) = Zero

iShell_AB = iTri(iShell_A,iShell_B)
iShell_CD = iTri(iShell_C,iShell_D)
iShell_ABCD = iTri(iShell_AB,iShell_CD)

!write(u6,*) 'Reading Gammas for shell quadruplet ',iShell_ABCD

iDisk = int(G_Toc(iShell_ABCD))
do while (iDisk >= 0)
  idisk_save = idisk
  call dDaFile(LuGamma,iRead,Bin,2,iDisk)
  lGamma = int(Bin(1,1))
  if (lGamma > lBin) then
    call WarningMessage(2,'Read_Bin_Columbus: lGamma > lbin')
    call Abend()
  end if
  iDisk = idisk_save
  call dDaFile(LuGamma,iRead,Bin,2*lGamma,iDisk)
  iDisk = int(Bin(2,1))

  do iGamma=2,lGamma
    jGamma = int(Bin(2,iGamma))
    if (jGamma > nGamma) then
      call WarningMessage(2,'Read_Bin_Columbus: jGamma > nGamma')
      call Abend()
    end if
    Gmma(jGamma) = Bin(1,iGamma)
    !write(u6,*) Gmma(jGamma),jGamma
  end do

end do

end subroutine Read_Bin_Columbus

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine EditStart()

use qmstat_global, only: cDumpForm, Cordst, DelOrAdd, iPrint, iSeed, iTcSim, nAdd, nCent, nDel, nPart, NrStarti, NrStartu, rStart
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: Coo(3,nCent), CooRef(3,nCent)
integer(kind=iwp) :: i, iCent, iDisk, iLu, ind, indMax, iPart, j, jnd1, jnd2, jP, k, l, nRemoved, nTmp
real(kind=wp) :: dCMx, dCMy, dCMz, dSpread, Esub, Etot, Gamold, GaOld, r, Ract, rMax
logical(kind=iwp) :: Exists, ValidOrNot
character(len=200) :: Head
character(len=6) :: FilSlut, Filstart
real(kind=wp), allocatable :: C(:,:), C2(:,:), Coord(:,:)
real(kind=wp), parameter :: ThrdSpread = One
#include "warnings.h"

! Inquire if file exists, and if so open it.

write(FilStart,'(A5,i1.1)') 'STFIL',NrStarti
call f_Inquire(FilStart,Exists)
if (.not. Exists) then
  write(u6,*)
  write(u6,*) 'The input startfile given in the EDITstartfile section was not found.'
  call Quit(_RC_IO_ERROR_READ_)
end if
iLu = 73
call DaName(iLu,Filstart)

! Read header and coordinates.

iDisk = 0
call WrRdSim(iLu,2,iDisk,iTcSim,64,Etot,Ract,nPart,Gamold,GaOld,Esub)
iDisk = iTcSim(1)
call mma_allocate(C,nPart*nCent,3,label='Coordinates')
call dDaFile(iLu,2,C,3*nPart*nCent,iDisk)
call DaClos(iLu)

! Now take different paths depending of what user have requested in the input.

call mma_allocate(Coord,3,nPart*nCent,label='Coord')

! If deleting solvent molecules.

if (DelOrAdd(1)) then

  ! Find the solvent molecules farthest away from origo and delete them.

  do i=1,nDel
    rMax = Zero
    indMax = 0
    do j=1,nPart
      r = C((j-1)*nCent+1,1)**2+C((j-1)*nCent+1,2)**2+C((j-1)*nCent+1,3)**2
      if (r > rMax) then
        rMax = r
        indMax = j
      end if
    end do
    do j=indMax,nPart-i
      k = (j-1)*nCent
      C(k+1:k+nCent,:) = C(k+nCent+1:k+2*nCent,:)
    end do
  end do

  ! Print the new set of coordinates to a startfile.

  nTmp = nPart-nDel
  iLu = 74
  write(FilSlut,'(A5,i1.1)') 'STFIL',NrStartu
  call DaName(iLu,FilSlut)
  iDisk = 0
  call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,Ract,nTmp,Gamold,Gaold,Esub)
  iTcSim(1) = iDisk
  do l=1,3
    call dDaFile(iLu,1,C(:,l),(nPart-nDel)*nCent,iDisk)
    iTcSim(1+l) = iDisk
  end do
  iDisk = 0
  call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,Ract,nTmp,Gamold,Gaold,Esub)
  call DaClos(iLu)

  ! If user wants, print print print.

  if (iPrint >= 10) then
    do i=1,(nPart-nDel)*nCent
      Coord(:,i) = C(i,:)
    end do
    write(Head,*) 'Final coordinates'
    call Cooout(Head,Coord,nPart-nDel,nCent)
  end if
end if

! If adding solvent molecules.

if (DelOrAdd(2)) then
  do i=1,nPart*nCent
    Coord(:,i) = C(i,:)
  end do
  if (nAdd /= 0) then
    ! Just an ugly trick for using nypart. It requires that the first
    ! slot contains the solvent coordinates, so we, temporarily, put
    ! them there.
    Coord(:,1:nCent) = Cordst(:,1:nCent)
    ! Introduce the new particles. nPart is redefined.
    call NyPart(nAdd,nPart,Coord,rStart,nCent,iSeed)
    ! The ugly trick is reversed, and the first slot is retained.
    do j=1,3
      Coord(j,1:nCent) = C(1:nCent,j)
    end do
  end if

  ! Then dump new coordinates on designated startfile.

  call mma_allocate(C2,nPart*nCent,3,label='NewCoo')
  do i=1,3
    C2(:,i) = Coord(i,:)
  end do
  iLu = 74
  write(FilSlut,'(A5,i1.1)') 'STFIL',NrStartu
  call DaName(iLu,FilSlut)
  iDisk = 0
  call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,rStart,nPart,Gamold,Gaold,Esub)
  iTcSim(1) = iDisk
  do l=1,3
    call dDaFile(iLu,1,C2(:,l),nPart*nCent,iDisk)
    iTcSim(1+l) = iDisk
  end do
  iDisk = 0
  call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,rStart,nPart,Gamold,Gaold,Esub)
  call DaClos(iLu)
  if (iPrint >= 10) then
    write(Head,*) 'Final coordinates'
    call Cooout(Head,Coord,nPart,nCent)
  end if
  call mma_deallocate(C2)
end if

! If requested, substitute all particles that are not of valid water
! geometry for, you guessed it, valid water molecules.

if (DelOrAdd(3)) then
  nRemoved = 0
  do iPart=1,nPart
    ind = nCent*(iPart-1)
    do iCent=1,nCent
      Coo(:,iCent) = C(ind+iCent,:)
      CooRef(:,iCent) = Cordst(:,iCent)
    end do
    call IsItValid(Coo,CooRef,ValidOrNot)
    if (.not. ValidOrNot) then
      dCMx = Zero
      dCMy = Zero
      dCMz = Zero
      do iCent=1,nCent
        dCMx = dCMx+C(ind+iCent,1)
        dCMy = dCMy+C(ind+iCent,2)
        dCMz = dCMz+C(ind+iCent,3)
      end do
      dCMx = dCMx/real(nCent,kind=wp)
      dCMy = dCMy/real(nCent,kind=wp)
      dCMz = dCMz/real(nCent,kind=wp)
      ! Check if the points are spread out, otherwise just delete.
      dSpread = Zero
      do iCent=1,nCent
        dSpread = dSpread+(C(ind+iCent,1)-dCMx)**2+(C(ind+iCent,2)-dCMy)**2+(C(ind+iCent,3)-dCMz)**2
      end do
      dSpread = dSpread/real(nCent,kind=wp)
      if (dSpread < ThrdSpread) then
        nRemoved = nRemoved+1
        do jP=iPart,nPart-1
          jnd1 = (jP-1)*nCent
          jnd2 = (jP)*nCent
          do iCent=1,nCent
            C(jnd1+iCent,:) = C(jnd2+iCent,:)
          end do
        end do
      else
        do iCent=1,nCent
          C(ind+iCent,1) = dCMx+CooRef(1,iCent)
          C(ind+iCent,2) = dCMy+CooRef(2,iCent)
          C(ind+iCent,3) = dCMz+CooRef(3,iCent)
        end do
      end if
    end if
  end do
  nPart = nPart-nRemoved

  ! Print the new set of coordinates to a startfile.

  iLu = 74
  write(FilSlut,'(A5,i1.1)') 'STFIL',NrStartu
  call DaName(iLu,FilSlut)
  iDisk = 0
  call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,Ract,nPart,Gamold,Gaold,Esub)
  iTcSim(1) = iDisk
  do l=1,3
    call dDaFile(iLu,1,C(:,l),nPart*nCent,iDisk)
    iTcSim(1+l) = iDisk
  end do
  iDisk = 0
  call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,Ract,nPart,Gamold,Gaold,Esub)
  call DaClos(iLu)

  ! If user wants, print print print.

  if (iPrint >= 10) then
    do i=1,3
      Coord(i,:) = C(:,i)
    end do
    write(Head,*) 'Final coordinates'
    call Cooout(Head,Coord,nPart,nCent)
  end if
end if

call mma_deallocate(Coord)

! If the user want to, print the coordinates in some format suitable
! for graphical representation.

if (DelOrAdd(4)) then
  if (cDumpForm(1:4) == 'MOLD') then
    CooRef(:,1:nCent) = Cordst(:,1:nCent)
    call MoldenDump(C,CooRef,nPart,nCent)
  end if
end if

! Deallocate.

call mma_deallocate(C)

! This routine ends now!

return

end subroutine EditStart

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
* This routine perform some consistency checks.                        *
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine Check_genano
      Implicit Real*8 (a-h,o-z)
#include "parm.fh"
#include "common.fh"
#include "symlab.fh"
      Dimension icnt(0:MxLqn)
      Do 10 i=0,MxLqn
         icnt(i)=0
10    Continue
      ind=0
      Do 100 iSym=1,nSym
*        Write(*,'(a,i1,a)') ' <<< Symmetry ',iSym,' >>>'
         Do 110 iBas=1,nBas(iSym)
            ind=ind+1
*           Write(*,*) Name(1,ind),Name(2,ind)
            Do 111 l=0,MxLqn
               If(Name(ind)(1:LENIN).eq.Center) Then
                  If(Name(ind)(LENIN1:LENIN8).eq.type(l*(l+1)+1)) Then
                     icnt(l)=icnt(l)+1
                  End If
               End If
111         Continue
110      Continue
100   Continue
      Do 200 l=0,MxLqn
         If(icnt(l).ne.nPrim(l)) Then
            Write(6,*) 'Number of primitives do not match!'
            Write(6,'(1x,a,2i5)') type(l*(l+1)+1),nPrim(l),icnt(l)
            Call Quit_OnUserError()
         End If
200   Continue
      Do 300 i=1,nDsym
         pDsym(i)=0.0d0
300   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SDCMRF_MCLR_1(CSD,CCM,IATP,IBTP,IASM,IBSM,NA,NB,IDC,PS,PL,ISGVST,LDET,LCOMB)
! Change a block of coefficients bwtween combination format and
! Slater determinant format
!
!     SD => Combinations
!
! Input
! =====
! CSD       : Block in determinant form
! CCM       : Block in combination form
! IATP,IBTP : type of alpha- and beta- string
! NA,NB     : Number of alpha- and beta- strings
! IDC       : Combination type
! PS        : Spin combination sign
! PL        : Ml   combination sign
! ISGVST    : Ml reflection of strings

use Constants, only: One, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CSD(*), PS, PL
real(kind=wp), intent(_OUT_) :: CCM(*)
integer(kind=iwp), intent(in) :: IATP, IBTP, IASM, IBSM, NA, NB, IDC, ISGVST
integer(kind=iwp), intent(out) :: LDET, LCOMB
integer(kind=iwp) :: IPACK
real(kind=wp) :: FACTOR, SGN
real(kind=wp), parameter :: SQRT2I = sqrt(Half)

call SDCMRF_PRE(IATP,IBTP,IASM,IBSM,NA,NB,IDC,PS,PL,ISGVST,LDET,LCOMB,IPACK,FACTOR,SGN)

! SD => combination transformation

if (IPACK == 1) then
  ! Pack to triangular form
  call TRIPK2_1(CSD,CCM,NA,NA)
  !    TRIPK2_1(AUTPAK,APAK,MATDIM,NDIM)
else
  CCM(1:NA*NB) = CSD(1:NA*NB)
end if
! Scale
if (FACTOR /= One) then
  CCM(1:LCOMB) = FACTOR*CCM(1:LCOMB)
  if (IPACK == 1) call SCLDIA(CCM,SQRT2I,NA,1)
end if

end subroutine SDCMRF_MCLR_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  GETNCI    := Get number of CASSCF determinants in each irrep.    *
c  *                                                                   *
c  *********************************************************************
      subroutine getnci_cvb(nciloc,nelloc,i2sloc,isymloc)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension nciloc(*)

      nalf1=(nelloc+i2sloc)/2
      nbet1=nelloc-nalf1
      call icomb_cvb(norb,nalf1,nda1)
      call icomb_cvb(norb,nbet1,ndb1)
      k1 = mstacki_cvb(nda1)
      k2 = mstacki_cvb(ndb1)
      k3 = mstacki_cvb(mxirrep+1)
      k4 = mstacki_cvb(mxirrep+1)
      k5 = mstacki_cvb(nda1)
      k6 = mstacki_cvb(ndb1)
      k7 = mstacki_cvb(mxirrep)
      k8 = mstacki_cvb(mxirrep)
      k9 = mstacki_cvb(mxirrep)
      k10= mstacki_cvb(norb+1)
      k11= mstacki_cvb(norb+1)
      k12= mstacki_cvb(norb+1)
      k13= mstacki_cvb(norb+1)
      k14= mstacki_cvb(norb+1)
      k15= mstacki_cvb((norb+1)*(nalf1+1))
      k16= mstacki_cvb((norb+1)*(nbet1+1))
      k17= mstacki_cvb(mxirrep)

      call symgen_cvb(nalf1,nbet1,nda1,ndb1,
     >  iw(k1),iw(k2),iw(k3),iw(k4),
     >  iw(k5),iw(k6),iw(k7),iw(k8),iw(k9),
     >  iw(k10),iw(k11),iw(k12),iw(k13),iw(k14),iw(k15),
     >  iw(k16),iw(k17))

      if(isymloc.eq.0)then
        call imove_cvb(iw(k7),nciloc,mxirrep)
      else
        nciloc(1)=iw(isymloc+k7-1)
      endif
      call mfreei_cvb(k1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Multipole_E(q,Dipole,R,E)

use Constants, only: Zero, One, Three
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: q, Dipole, R
real(kind=wp), intent(out) :: E
real(kind=wp) :: R_Inv, R2_Inv, xDipole, xMonopole

R_Inv = One/R
R2_Inv = R_Inv*R_Inv

if (R < Zero) then
  xMonopole = -q*R2_Inv
  xDipole = -Three*Dipole*R*R2_Inv*R2_Inv
else
  xMonopole = q*R2_Inv
  xDipole = Three*Dipole*R*R2_Inv*R2_Inv
end if

E = xMonopole+xDipole

return

end subroutine Multipole_E

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine diagonal_loop_wyb_g()  !  for norb_act<>0
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      nst=norb_all
      ndy=norb_ext
c      do lr0=2,norb_all
c        do lr=1,lr0-1
c          vdint(lr,lr0)=voint(lr0,lr)
c     :      -vdint(lr0,lr)-vdint(lr0,lr)   ! 520
c      write(*,'(2i4,3f14.8)')
c     :   lr,lr0,voint(lr0,lr),vdint(lr0,lr),vdint(lr,lr0)
c        enddo
c      enddo
c     write(*,*)'               ***** start h-diaelm *****'
c**************lyb***************
c     vector1(1:nci_dim)=vpotnuc
c********************************
!      wl8 = hnil*(hnil-1)*vmd(lr,lr)*0.5d0+hnil*vo(lr,lr)   800
c      write(*,*)'         jpad,     jpae,     ndim,      nohy'

      ndimsum=0
      jpae=jv
      ipae=1
      jaedownwei=iseg_downwei(ipae)
      do jpad=1,mxnode
        iw_sta(jpad,ipae)=ndimsum
        if(nu_ad(jpad).eq.0) cycle
        call seg_drt()
        iwupwei=jpad_upwei(jpad)
        iw_downwei(jpad,ipae)=ndim
        ndimsum=ndimsum+ndim*jaedownwei*iwupwei
        if(ndim .eq. 0) cycle
        call diagonal_act_d_g()
        call diagonal_act_c_g()
      enddo
      do im=1,ng_sm
        jpae=jd(im)
        ipae=1+im
        if(nu_ae(ipae).eq.0) cycle
        jaedownwei=iseg_downwei(ipae)
        do jpad=1,mxnode
          iw_sta(jpad,ipae)=ndimsum
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          iwupwei=jpad_upwei(jpad)
          iw_downwei(jpad,ipae)=ndim
c       if(jpad.ge.26) then
c     write(*,*)
c     endif
          ndimsum=ndimsum+ndim*jaedownwei*iwupwei
          if(ndim .eq. 0) cycle
          call diagonal_act_d_g()
          call diagonal_act_c_g()
          ista=iw_sta(jpad,ipae)+1
        enddo
      enddo

      do im=1,ng_sm
        jpae=jt(im)
        ipae=9+im
        if(nu_ae(ipae).eq.0) cycle
        jaedownwei=iseg_downwei(ipae)
        do jpad=1,mxnode
          iw_sta(jpad,ipae)=ndimsum
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          iwupwei=jpad_upwei(jpad)
         iw_downwei(jpad,ipae)=ndim
          ndimsum=ndimsum+ndim*jaedownwei*iwupwei
          if(ndim .eq. 0) cycle
          call diagonal_act_d_g()
          call diagonal_act_c_g()
        enddo
      enddo
      do im=1,ng_sm
        jpae=js(im)
        ipae=17+im
        jaedownwei=iseg_downwei(ipae)
        if(nu_ae(ipae).eq.0) cycle
        do jpad=1,mxnode
          iw_sta(jpad,ipae)=ndimsum
          if(nu_ad(jpad).eq.0) cycle
          call seg_drt()
          iwupwei=jpad_upwei(jpad)
          iw_downwei(jpad,ipae)=ndim
          ndimsum=ndimsum+ndim*jaedownwei*iwupwei
          if(ndim .eq. 0) cycle
          call diagonal_act_d_g()
          call diagonal_act_c_g()
        enddo
      enddo
      call diagonal_dbl_g()
      call diagonal_ext_g()
      return
      end

      subroutine diagonal_act_c_g()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      dimension ndr(max_innorb)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      real*8, allocatable :: te(:), tee(:)
      integer, allocatable :: jpe(:), jee(:), jwe(:)
c     write(*,*)'               ***** start h-diaelm *****'
c      write(*,*)  jpad,jpae
      allocate(te(maxpl),tee(maxpl),jpe(maxpl),jee(maxpl),jwe(maxpl))
      ndr=0
      if(norb_act.eq.0) then
        mh=1
        th(1)=1.d0
        thh(1)=1.d0
        call diagonal_link_dae_g(mh)
        return
      endif
      mp=0
      nsum=0
c 520
          mh=0
          me=0
          jp=jpad
          jpb=jb(jp)
          do idl=1,4
            if(jj_sub(idl,jp).eq.0) cycle
           ind1=idl
c     link c"
            call smidc2(isq,w,ww,mw,ind1,jpb)
            mh=mh+1
            jeh(mh)=jj_sub(idl,jp)
            th(mh)=w
            thh(mh)=ww
            jph(mh)=0
            jwh(mh)=0
            if(idl.ne.1) jwh(mh)=iy(idl,jp)
c     complete a loop 'v'
            if(ind1.eq.1) cycle
            call stml(isq,w,ww,mw,ind1-1,jpb)
            vlop0=w
            vlop1=ww
            if(vlop0.eq.0.0d0.and.vlop1.eq.0.0d0) cycle
            mpe=jj_sub(idl,jp)
            iwa=iy(idl,jp)
            call diagonal_link_ad_g(mpe,iwa,vlop0,vlop1)
          enddo
c************************************************************
c      write(*,*)ad(i)
c************************************************************
        lr=norb_dz+1
40      if(lr.eq.norb_inn) then
          if(mh.ne.0) call diagonal_link_dae_g(mh)
          return
        end if
        lr=lr+1
        me=0
        do 160 m=1,mh
          je=jeh(m)
          jeb=jb(je)
c          jp=jph(m)
          do idl=1,4
            if(jj_sub(idl,je).eq.0) cycle
           ind1=idl
c            if(lr.eq.1) goto 20
c     link loop
            call smidc2(isq,w,ww,mw,ind1,jeb)
            me=me+1
            jwe(me)=jwh(m)
            if(idl.ne.1) jwe(me)=jwe(me)+iy(idl,je)
            jee(me)=jj_sub(idl,je)
            te(me)=th(m)*w
            tee(me)=thh(m)*ww
            jpe(me)=jph(m)
c     complete a loop 'v'
c20          continue
            if(ind1.eq.1) cycle
            call stml(isq,w,ww,mw,ind1-1,jeb)
            vlop0=th(m)*w
            vlop1=thh(m)*ww
            if(vlop0.eq.0.0d0.and.vlop1.eq.0.0d0) cycle
            mp=mp+1
            mpe=jj_sub(idl,je)
            iwa=jwh(m)
           if(idl.ne.1) iwa=iwa+iy(idl,je)
            call diagonal_link_ad_g(mpe,iwa,vlop0,vlop1)
c*****   520  ******************************************************
          enddo
160     continue
c***********************************************************
c      write(*,*) ad(i)
c************************************************************
        do m=1,me
          th(m)=te(m)
          te(m)=0.0d0
          thh(m)=tee(m)
          tee(m)=0.0d0
          jwh(m)=jwe(m)
          jwe(m)=0
          jeh(m)=jee(m)
          jee(m)=0
          jph(m)=jpe(m)
          jpe(m)=0
        enddo
        mh=me
        if(ndr(lr).lt.mh) ndr(lr)=mh
        goto 40
        do m=1,mh
          th(m)=0.0d0
          thh(m)=0.0d0
          jwh(m)=0
          jph(m)=0
          jeh(m)=0
        enddo
      return
      end

      subroutine diagonal_act_d_g()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      dimension ndr(max_innorb)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      real*8, allocatable :: te(:), tee(:)
      integer, allocatable :: jpe(:), jee(:), jwe(:)
c     write(*,*)'               ***** start h-diaelm *****'
c      write(*,*)   '   diagonal_act_d:',jpad,ipae
      allocate(te(maxpl),tee(maxpl),jpe(maxpl),jee(maxpl),jwe(maxpl))
      ndr=0
      nsum=0
      do lr=norb_dz+1,norb_inn
        jp0=no(lr-1)+1
        jp1=no(lr)
        lr0=lr
        do jp=jp0,jp1
          if(iy(1,jp).eq.0) cycle
c  800
          do idl=2,3
            mpe=jj_sub(idl,jp)
            if(mpe.eq.0) cycle
c            wt = voint(lr0,lr0)    ! hnil=1
             wt=1.0d0
            jw=iy(idl,jp)
            call prodel_1(3,wt,jp,mpe,jw,lr0,lr0)
          enddo
          mpe=jj_sub(4,jp)
          if(mpe.ne.0) then
c            wt = vdint(lr0,lr0)+2.d0*voint(lr0,lr0)     !idl=4 hnil=2
            jw=iy(4,jp)
            wt=2.0d0
            call prodel_1(3,wt,jp,mpe,jw,lr0,lr0)
            wt=1.0d0
            call trans_ijkl_intpos(lr0,lr0,lr0,lr0,nxo)
            call prodel_2(3,wt,jp,mpe,jw,nxo)
          endif
        enddo
      enddo
c 520
      do 5 lr0=norb_dz+1,norb_inn
        mh=0
        me=0
        jp0=no(lr0-1)+1
        jp1=no(lr0)
        if(jp0.gt.jp1) jp0=jp1
        do 1 jp=jp0,jp1
          if(iy(1,jp).eq.0) cycle
c     start '^'
          do idl=1,4
            if(jj_sub(idl,jp).eq.0) cycle
            idr=idl
            jbl=jb(jp)
            ind1=idl-1
            if(ind1.eq.0) cycle
            call stmh(isq,w,ww,mw,ind1,jbl)
            mh=mh+1
            jeh(mh)=jj_sub(idl,jp)
            th(mh)=w
            thh(mh)=ww
            jph(mh)=jp
            jwh(mh)=0
            if(idl.ne.1) jwh(mh)=iy(idl,jp)
          enddo
1       continue
c************************************************************
c      write(*,*)ad(i)
c************************************************************
        lr=lr0
        if(ndr(lr).lt.mh) ndr(lr)=mh
40      if(lr.eq.norb_inn) then
        call diagonal_link_ae_g(mh)
        goto 5
        end if
        lr=lr+1
        me=0

        mp=0
        do 160 m=1,mh
          je=jeh(m)
          jeb=jb(je)
          jp=jph(m)
          do 17 idl=1,4
            if(jj_sub(idl,je).eq.0) goto 17
            ind1=idl
            if(lr.eq.1) goto 20
c     link loop
            call smidc2(isq,w,ww,mw,ind1,jeb)
            me=me+1
            jwe(me)=jwh(m)
            if(idl.ne.1) jwe(me)=jwe(me)+iy(idl,je)
            jee(me)=jj_sub(idl,je)
            te(me)=th(m)*w
            tee(me)=thh(m)*ww
            jpe(me)=jph(m)
c     complete a loop 'v'
20          if(ind1.eq.1) goto 17
            call stml(isq,w,ww,mw,ind1-1,jeb)
            vlop0=th(m)*w
            vlop1=thh(m)*ww
            if(vlop0.eq.0.0d0.and.vlop1.eq.0.0d0) goto 17
            mp=mp+1
            mpe=jj_sub(idl,je)
            iwa=jwh(m)
           if(idl.ne.1) iwa=iy(idl,je)+iwa
c            wt=(vlop0-vlop1)*voint(lr,lr0)-2.d0*vlop0*vdint(lr,lr0)
            wt=vlop0-vlop1
            call trans_ijkl_intpos(lr,lr0,lr,lr0,nxo)
c            write(nf2,'(4i4,i8)') lr,lr0,lr,lr0,nxo
            call prodel_2(3,wt,jp,mpe,iwa,nxo)
            wt=-2.d0*vlop0
            call trans_ijkl_intpos(lr,lr,lr0,lr0,nxo)
            call prodel_2(3,wt,jp,mpe,iwa,nxo)

c*****   520  ******************************************************
17        continue
160     continue
c***********************************************************
c      write(*,*) ad(i)
c************************************************************
      do  m=1,me
          th(m)=te(m)
          te(m)=0.0d0
          thh(m)=tee(m)
          tee(m)=0.0d0
          jwh(m)=jwe(m)
          jwe(m)=0
          jeh(m)=jee(m)
          jee(m)=0
          jph(m)=jpe(m)
          jpe(m)=0
        enddo
        mh=me
        if(ndr(lr).lt.mh) ndr(lr)=mh
        goto 40
        do m=1,mh
          th(m)=0.0d0
          thh(m)=0.0d0
          jwh(m)=0
          jph(m)=0
          jeh(m)=0
        enddo
5     continue
      return
      end

      subroutine diagonal_link_ae_g(mh)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      data dsq2,vsq2/1.414213562373095d0,0.7071067811865d0/
!     dsq2=sqrt(2.d0)
!     vsq2=1/sqrt(2.d0)
!     dsq3vsq2=sqrt(3.d0)/sqrt(2.d0)
      if(ipae.eq.1) return   !could not  link
      ityae=(ipae-1)/8+1
      imae=mod(ipae-1,8)
      if(imae.eq.0) then
        ityae=ityae-1
        imae=8
      endif
      do 108 ip=1,mh
        iwe=0
        jp=jph(ip)
        lr0=kk(jp)
c      write(*,*)'ip,jpe,ind0',ip,jpe,ind0
        iwa=jwh(ip)
        vlop0=th(ip)
        vlop1=thh(ip)

c      wl5=(vlop0-vlop1)*vo(lr0,lr)-2.0d0*vlop0*vmd(lr0,lr)
c      wl8=vlop0*(vo(lr0,lr0)+(vlop0-1)*0.5*vmd(lr0,lr0))
c             two-index,one-loop 520
c   520=<a,j,k,a>:13,14(ss=3),38(tt=2),50(dd=1)
c       write(nf2,*) 'ityae',ityae
      goto(100,200,300),ityae

!link arc_d
!100     zz='  g50  '
100     wg50 = vlop0*vsq2
        wwg50=-vlop1*sqrt(3.d0)/sqrt(2.d0)
        do la=1,norb_ext
         ma=lsm(la)
          if(ma.ne.imae) cycle
          lra=norb_all-la+1
          iwe=iwe+1
c          wld =(wg50-wwg50)*voint(lra,lr0)-2.d0*wg50*vdint(lra,lr0)
          wld=wg50-wwg50
          call trans_ijkl_intpos(lra,lr0,lra,lr0,nxo)
          call prodel_2(5,wld,jp,iwa,iwe,nxo)
          wld=-2.d0*wg50
          call trans_ijkl_intpos(lra,lra,lr0,lr0,nxo)
          call prodel_2(5,wld,jp,iwa,iwe,nxo)

c       write(*,'(a11,2i3,i6,1x,5f10.4)')
c     :   zz,lr0,la,jwl,vo(lr0,la),vmd(lr0,la),wg50,wwg50,wl
        enddo
        goto 108
!200     zz='  g38,39  '
200     wg38 =-vlop0*vsq2
        wwg38= vlop1
        do ima=1,ng_sm
          imb=mul_tab(ima,imae)
          if(imb.gt.ima) cycle
          do la=ibsm_ext(ima),iesm_ext(ima)
            lra=norb_all-la+1
            lbsta=ibsm_ext(imb)
            lbend=iesm_ext(imb)
            if(ima.eq.imb) lbend=la-1
            do lb=lbsta,lbend
              lrb=norb_all-lb+1
              iwe=iwe+1
c              wlt =(wg38-wwg38)*(voint(lra,lr0)+voint(lrb,lr0))
c     :          -2.d0*wg38*(vdint(lra,lr0)+vdint(lrb,lr0))
              wlt=wg38-wwg38
              call trans_ijkl_intpos(lra,lr0,lra,lr0,nxo)
              call prodel_2(5,wlt,jp,iwa,iwe,nxo)
              wlt=wg38-wwg38
              call trans_ijkl_intpos(lrb,lr0,lrb,lr0,nxo)
              call prodel_2(5,wlt,jp,iwa,iwe,nxo)
              wlt=-2.d0*wg38
              call trans_ijkl_intpos(lra,lra,lr0,lr0,nxo)
              call prodel_2(5,wlt,jp,iwa,iwe,nxo)
              wlt=-2.d0*wg38
              call trans_ijkl_intpos(lrb,lrb,lr0,lr0,nxo)
              call prodel_2(5,wlt,jp,iwa,iwe,nxo)
            enddo
         enddo
        enddo
        goto 108
!300     zz='  g14,15  '
300     wg14 =-vlop0*vsq2
        do ima=1,ng_sm
          imb=mul_tab(ima,imae)
          if(imb.gt.ima) cycle
          if(nlsm_ext(ima).eq.0) cycle
          if(nlsm_ext(imb).eq.0) cycle
         do la=ibsm_ext(ima),iesm_ext(ima)
            lra=norb_all-la+1
            lbsta=ibsm_ext(imb)
            lbend=iesm_ext(imb)
            if(ima.eq.imb) lbend=la-1
            do lb=lbsta,lbend
              lrb=norb_all-lb+1
              iwe=iwe+1
c              wls =wg14*(voint(lra,lr0)+voint(lrb,lr0))
c     :           -2.d0*wg14*(vdint(lra,lr0)+vdint(lrb,lr0))
              wls=wg14
              call trans_ijkl_intpos(lra,lr0,lra,lr0,nxo)
              call prodel_2(5,wls,jp,iwa,iwe,nxo)
              wls=wg14
              call trans_ijkl_intpos(lrb,lr0,lrb,lr0,nxo)
              call prodel_2(5,wls,jp,iwa,iwe,nxo)
              wls=-2.d0*wg14
              call trans_ijkl_intpos(lra,lra,lr0,lr0,nxo)
              call prodel_2(5,wls,jp,iwa,iwe,nxo)
              wls=-2.d0*wg14
              call trans_ijkl_intpos(lrb,lrb,lr0,lr0,nxo)
              call prodel_2(5,wls,jp,iwa,iwe,nxo)
            enddo
         enddo
        enddo
        if(ipae.ne.18) goto 108
!       zz='  g13     '
        wg13 =-vlop0*dsq2
        do la=1,norb_ext
          lra=norb_all-la+1
          iwe=iwe+1
c          wls =wg13*(voint(lra,lr0)-2.d0*vdint(lra,lr0))
          wls=wg13
          call trans_ijkl_intpos(lra,lr0,lra,lr0,nxo)
          call prodel_2(5,wls,jp,iwa,iwe,nxo)
          wls=-2.d0*wg13
          call trans_ijkl_intpos(lra,lra,lr0,lr0,nxo)
          call prodel_2(5,wls,jp,iwa,iwe,nxo)

c        write(*,*)' g13 ',
c     :   vo(lr0,la),vo(lr0,lb),vmd(lr0,la),vmd(lr0,lb)
        enddo
108   continue
      mh=0
      return
      end

      subroutine diagonal_link_ad_g(mpe,iwa,vlop0,vlop1)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
c      common/delm_value/iq,pd,pdd,pt,ptt,ps1,ps2,ps3,ps4
      data dsq2,vsq2/1.414213562373095d0, 0.7071067811865d0/
!     dsq2=sqrt(2.d0)
!     vsq2=1/sqrt(2.d0)
!     dsq3vsq2=sqrt(3.d0)/sqrt(2.d0)
      if(norb_dz.eq.0) return
      ityad=1
      if(jpad.ne.1) ityad=(jpad-1)/8+2
      imad=mod(jpad-1,8)
      if(imad.eq.0) then
        ityad=ityad-1
        imad=8
      endif
      lra=kk(mpe)-1
      goto(100,200,300,400,500,600),ityad
! v: d&r&l(3)
100   fqi=-fg
          vl0=fqi*dsq2*vlop0
          wlv=0.d0
           do lr=1,norb_dz
c           wlv=wlv-vl0*vdint(lr,lra)
            wlv=-vl0
            call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
c            write(nf2,'(4i4,i8)') lra,lr,lra,lr,nxo
            call prodel_2(4,wlv,mpe,0,iwa,nxo)
            wlv=2.0d0*vl0
            call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
            call prodel_2(4,wlv,mpe,0,iwa,nxo)
           enddo
c          call prodel(4,wlv,mpe,0,iwa)
      return
!  jpad=jd(im)
200   fqi=-fg
      do lri=norb_frz+1,norb_dz
        imd=mul_tab(lsm_inn(lri),ns_sm)
        if(imd.ne.imad) cycle
        iwd=jud(lri)

! d: d&r&l(2)
        vl0=fqi*vsq2*vlop0
        vl1=pd*vlop1
c       wld=-2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
        wld=-2.0d0*vl0
        call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
        call prodel_2(4,wld,mpe,iwd,iwa,nxo)
        wld=vl0-vl1
        call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
        call prodel_2(4,wld,mpe,iwd,iwa,nxo)

! d: d&r&l(3)+c"(2)
        vl0=fqi*dsq2*vlop0
        do lr=1,lri-1
c          wld=wld+vl0*(voint(lra,lr)-2.d0*vdint(lra,lr))
        wld=-2.0d0*vl0
        call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
        call prodel_2(4,wld,mpe,iwd,iwa,nxo)
        wld=vl0
        call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
        call prodel_2(4,wld,mpe,iwd,iwa,nxo)
        enddo
! d: d&r&l(3)
        do lr=lri+1,norb_dz
c          wld=wld+vl0*(voint(lra,lr)-2.d0*vdint(lra,lr))
        wld=-2.0d0*vl0
        call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
        call prodel_2(4,wld,mpe,iwd,iwa,nxo)
        wld=vl0
        call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
        call prodel_2(4,wld,mpe,iwd,iwa,nxo)
        enddo

c       call prodel(4,wld,mpe,iwd,iwa)
      enddo
      return
!  jpad=jt(im)
300   fqi=fg
      iwt=0
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iwt=just(lri,lrj)    !

! t: d&r&l(2)
! t: d&r&l(2)+c"(2)
          vl0=fqi*vsq2*vlop0
          vl1=pt*vlop1
c          wlt=   -2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=vl0-vl1
          call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)


c          wlt=wlt-2.0d0*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=vl0-vl1
          call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)


          vl0=fqi*dsq2*vlop0
          do lr=1,lri-1
! t: d&r&l(3)+c"(2)+c"(2)
c            wlt=wlt+vl0*vdint(lr,lra)
          wlt=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          enddo
! t: d&r&l(3)+c"(2)
          do lr=lri+1,lrj-1
c            wlt=wlt+vl0*vdint(lr,lra)
          wlt=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          enddo
! t: d&r&l(3)
          do lr=lrj+1,norb_dz
c            wlt=wlt+vl0*vdint(lr,lra)
          wlt=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
         enddo
c         call prodel(4,wlt,mpe,iwt,iwa)
        enddo
      enddo
      return
400   fqi=fg
      iws=0
      do lri=norb_frz+1,norb_dz
        if(imad.eq.ns_sm)  then
          lrj=lri
          iws=just(lri,lri)
! s: d&r&l(3)+c"(0)
! s: d&r&l(3)
        vl0=fqi*dsq2*vlop0
c         wls=0.d0
          do lr=1,norb_dz
            if(lr.eq.lri) cycle
c           wls=wls+vl0*(voint(lra,lr)-2.d0*vdint(lra,lr))
          wls=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          enddo
c          call prodel(4,wls,mpe,iws,iwa)
        endif

        imi=mul_tab(lsm_inn(lri),ns_sm)
        lrjsta=lri+1
        do lrj=lrjsta,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iws=just(lri,lrj)
! s1: d&r&l(1)
          vl0=fqi*vsq2*vlop0
          vl1=ps1*vlop1
c          wls=-2.0d0*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=vl0-vl1
          call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)

! s4: d&r&l(2)+c"(1)
          vl0=fqi*vsq2*vlop0
          vl1=ps4*vlop1
c          wls=wls-2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=vl0-vl1
          call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)

          vl0=fqi*dsq2*vlop0
! s: d&r&l(3)+c"(2)+c"(1)
          do lr=1,lri-1
c            wls=wls+vl0*vdint(lr,lra)
          wls=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          enddo
! s: d&r&l(3)+c"(1)
          do lr=lri+1,lrj-1
c            wls=wls+vl0*vdint(lr,lra)
          wls=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          enddo
! s: d&r&l(3)
          do lr=lrj+1,norb_dz
c            wls=wls+vl0*vdint(lr,lra)
          wls=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
         enddo
c          call prodel(4,wls,mpe,iws,iwa)
        enddo
      enddo

      if(jb_sys.eq.0) return      !any diffrence when jb_sys=1 and jb_sy
      fqi=fg
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
       !   iws=iws+1
          iws=just(lrj,lri)
! s1: d&r&l(1)-c"(2)
          vl0=fqi*vsq2*vlop0
          vl1=ps3*vlop1
c          wls=-2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=vl0-vl1
          call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)

! s3: (11)d&r&l(2)
          vl0=fqi*vsq2*vlop0
          vl1=ps2*vlop1
c          wls=wls-2.0d0*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=vl0-vl1
          call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)

          vl0=fqi*dsq2*vlop0
! s: d&r&l(3)+c"(1)+c"(2)
          do lr=1,lri-1
c            wls=wls+vl0*vdint(lr,lra)
          wls=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          enddo
! s: d&r&l(3)+c"(2)
          do lr=lri+1,lrj-1
c            wls=wls+vl0*vdint(lr,lra)
          wls=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          enddo
! s: d&r&l(3)
          do lr=lrj+1,norb_dz
c            wls=wls+vl0*vdint(lr,lra)
          wls=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
          wls=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wls,mpe,iws,iwa,nxo)
           enddo
c          call prodel(4,wls,mpe,iws,iwa)
        enddo
      enddo
      return

500   fqi=-fg
      iwd=0
      do lri=norb_frz+1,norb_dz
        imd=mul_tab(lsm_inn(lri),ns_sm)
        if(imd.ne.imad) cycle
        iwd=jud(lri)

! dd1: d&r&l(1)
        vl0=fqi*vsq2*vlop0
        vl1=pdd*vlop1
c        wld=-2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
          wld=vl0-vl1
          call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
          call prodel_2(4,wld,mpe,iwd,iwa,nxo)
          wld=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
          call prodel_2(4,wld,mpe,iwd,iwa,nxo)

        vl0=fqi*dsq2*vlop0
! d: d&r&l(3)+c"(1)
        do lr=1,lri-1
c          wld=wld+vl0*vdint(lr,lra)
          wld=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wld,mpe,iwd,iwa,nxo)
          wld=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wld,mpe,iwd,iwa,nxo)
        enddo
! d: d&r&l(3)
        do lr=lri+1,norb_dz
c          wld=wld+vl0*vdint(lr,lra)
          wld=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wld,mpe,iwd,iwa,nxo)
          wld=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wld,mpe,iwd,iwa,nxo)
        enddo

c       call prodel(4,wld,mpe,iwd,iwa)
      enddo
      return

600   fqi=fg
      iwt=0
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iwt=just(lri,lrj)

! tt: d&r&l(1)
! tt: d&r&l(1)+c"(1)
          vl0=fqi*vsq2*vlop0
          vl1=ptt*vlop1
c          wlt=   -2.0d0*vl0*vdint(lra,lri)+(vl0-vl1)*voint(lra,lri)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=vl0-vl1
          call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)

c          wlt=wlt-2.0d0*vl0*vdint(lra,lrj)+(vl0-vl1)*voint(lra,lrj)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=vl0-vl1
          call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)

          vl0=fqi*dsq2*vlop0
          do lr=1,lri-1
! t: d&r&l(3)+c"(1)+c"(1)
c            wlt=wlt+vl0*vdint(lr,lra)
          wlt=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          enddo
! t: d&r&l(3)+c"(1)
          do lr=lri+1,lrj-1
c            wlt=wlt+vl0*vdint(lr,lra)
          wlt=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          enddo
! t: d&r&l(3)
          do lr=lrj+1,norb_dz
c            wlt=wlt+vl0*vdint(lr,lra)
          wlt=vl0
          call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
          wlt=-2.0d0*vl0
          call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
          call prodel_2(4,wlt,mpe,iwt,iwa,nxo)
         enddo

c         call prodel(4,wlt,mpe,iwt,iwa)
        enddo
      enddo
      return
      end


      subroutine diagonal_link_dae_g(mh)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      data dsq2,vsq2/1.414213562373095d0, 0.7071067811865d0/
!     dsq2=sqrt(2.d0)
!     vsq2=1/sqrt(2.d0)
!     dsq3vsq2=sqrt(3.d0)/sqrt(2.d0)
      ityad=1
      if(jpad.ne.1) ityad= (jpad-1)/8+2
      imad=mod(jpad-1,8)
      if(imad.eq.0) then
        ityad=ityad-1
        imad=8
      endif
      do 108 ip=1,mh
        iwa=jwh(ip)
        vlop0=th(ip)
        vlop1=thh(ip)

      goto(100,200,300,400,500,600),ityad

!  jpad=1
100   if(abs(vlop0).lt.1e-30) goto 108
        fqi=fg
! v: d&r&l(3)
        lri=0
        lrj=0
        iwd=0
        vij0=0.d0
        vij1=0.d0
        vij2=0.d0
        vl0=fqi*dsq2*vlop0
        call diagonal_call_dae_g(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)
        goto 108
!  jpad=jd(im)
200   fqi=-fg
      lrj=0
      do lri=norb_frz+1,norb_dz
        imd=mul_tab(lsm_inn(lri),ns_sm)
        if(imd.ne.imad) cycle
        iwd=jud(lri)

! d: d&r&l(2)
        vij0=fqi*vsq2*vlop0
        vij1=pd*vlop1
        vij2=0.d0
! d: d&r&l(3)+c"(2)
! d: d&r&l(3)
        vl0=fqi*dsq2*vlop0

        call diagonal_call_dae_g(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)

      enddo
      goto 108
!  jpad=jt(im)
300   fqi=fg
      iwt=0
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iwt=just(lri,lrj)      !

! t: d&r&l(2)
! t: d&r&l(2)+c"(2)
          vij0=fqi*vsq2*vlop0
          vij1=pt*vlop1
          vij2=vij1
! t: d&r&l(3)+c"(2)+c"(2)
! t: d&r&l(3)+c"(2)
! t: d&r&l(3)
          vl0=fqi*dsq2*vlop0

          call diagonal_call_dae_g(lri,lrj,iwt,iwa,vij0,vij1,vij2,vl0)
        enddo
      enddo
      goto 108
400   fqi=fg
      iws=0
      do lri=norb_frz+1,norb_dz           !cc
        if(imad.eq.ns_sm) then
          lrj=lri
         iws=just(lri,lri)
         vij0=0.d0
          vij1=0.d0
          vij2=0.d0
! s: d&r&l(3)+c"(0)
! s: d&r&l(3)
          vl0=fqi*dsq2*vlop0
          call diagonal_call_dae_g(lri,lrj,iws,iwa,vij0,vij1,vij2,vl0)
        endif

        imi=mul_tab(lsm_inn(lri),ns_sm)
        lrjsta=lri+1
        do lrj=lrjsta,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iws=just(lri,lrj)
! s2: d&r&l(2)
! s4: d&r&l(2)+c"(1)
          vij0=fqi*vsq2*vlop0
          vij1=ps1*vlop1
          vij2=ps4*vlop1
! s: d&r&l(3)+c"(2)+c"(1)
! s: d&r&l(3)+c"(1)
! s: d&r&l(3)
          vl0=fqi*dsq2*vlop0
          call diagonal_call_dae_g(lri,lrj,iws,iwa,vij0,vij1,vij2,vl0)
        enddo
      enddo
      if(jb_sys.eq.0) goto 108
      fqi=fg
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        if(imad.eq.ns_sm) lrjsta=lri
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iws=just(lrj,lri)
! s1: d&r&l(1)
! s3: d&r&l(1)+c"(2)
          vij0=fqi*vsq2*vlop0
          vij1=ps2*vlop1
          vij2=ps3*vlop1
! s: d&r&l(3)+c"(1)+c"(2)
! s: d&r&l(3)+c"(2)
! s: d&r&l(3)
          vl0=fqi*dsq2*vlop0

          call diagonal_call_dae_g(lri,lrj,iws,iwa,vij0,vij1,vij2,vl0)

        enddo
      enddo
      goto 108
500   fqi=-fg
      lrj=0
      do lri=norb_frz+1,norb_dz
        imd=mul_tab(lsm_inn(lri),ns_sm)
        if(imd.ne.imad) cycle
        iwd=jud(lri)

! dd1: d&r&l(1)
        vij0=fqi*vsq2*vlop0
        vij1=pdd*vlop1
        vij2=0.d0
! d: d&r&l(3)+c"(1)
! d: d&r&l(3)
        vl0=fqi*dsq2*vlop0

        call diagonal_call_dae_g(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)

      enddo
      goto 108

600   fqi=fg               !aa
      iwt=0
      do lri=norb_frz+1,norb_dz
        imi=mul_tab(lsm_inn(lri),ns_sm)
        do lrj=lri+1,norb_dz
          imj=lsm_inn(lrj)
          imij=mul_tab(imi,imj)
          if(imij.ne.imad) cycle
          iwt=just(lri,lrj)

          vij0=fqi*vsq2*vlop0
! tt: d&r&l(1)
          vij1=ptt*vlop1
! tt: d&r&l(1)+c"(1)
          vij2=ptt*vlop1
! t: d&r&l(3)+c"(1)+c"(1)
! t: d&r&l(3)+c"(1)
! t: d&r&l(3)
          vl0=fqi*dsq2*vlop0
          call diagonal_call_dae_g(lri,lrj,iwt,iwa,vij0,vij1,vij2,vl0)
        enddo
      enddo

108   continue
      return
      end

      subroutine diagonal_call_dae_g(lri,lrj,iwd,iwa,vij0,vij1,vij2,vl0)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      integer, pointer :: jph(:),jeh(:),jwh(:)
      real*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh
      data dsq2,vsq2/1.414213562373095d0, 0.7071067811865d0 /
      data dsq3vsq2/1.224744871392d0/
!     dsq2=sqrt(2.d0)
!     vsq2=1/sqrt(2.d0)
!     dsq3vsq2=sqrt(3.d0)/sqrt(2.d0)

      if(norb_dz.eq.0) return
      if(ipae.eq.1) return   !could not  link
      ityae=(ipae-1)/8+1
      imae=mod(ipae-1,8)
      if(imae.eq.0) then
        ityae=ityae-1
        imae=8
      endif
      iwe=0
c   520=<a,j,k,a>:13,14(ss=3),38(tt=2),50(dd=1)
      goto(100,200,300),ityae
!link arc_d
!100     zz='  g50  '

100   do la=ibsm_ext(imae),iesm_ext(imae)
          lra=norb_all-la+1
         iwe=iwe+1
         vlop0=vl0*vsq2
c        wl=0.d0
         do lr=1,norb_dz
            if(lr.eq.lri) cycle
            if(lr.eq.lrj) cycle
c            wl =wl+vlop0*vdint(lr,lra)    !db space drl(33)- ext space
            wl=vlop0
            call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
         enddo
      if(lri.ge.lrj) then
         vlop0= vij0*vsq2
          vlop1=-vij1*dsq3vsq2
c         wl=wl+(vlop0-vlop1)*voint(lra,lri)-2.d0*vlop0*vdint(lra,lri)
          if(lri.ne.0) then
            wl=vlop0-vlop1
            call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
          endif
          vlop1=-vij2*dsq3vsq2
c         wl=wl+(vlop0-vlop1)*voint(lra,lrj)-2.d0*vlop0*vdint(lra,lrj)
          if(lrj.ne.0) then
            wl=vlop0-vlop1
            call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
          endif
c       write(*,'(a11,2i3,i6,1x,5f10.4)')
c     :   zz,lr0,la,jwl,vo(lr0,la),vmd(lr0,la),wg50,wwg50,wl
      else
          vlop0= vij0*vsq2
          vlop1=-vij1*dsq3vsq2       !db space (22)drl(11)- ext space -g
c          wl=wl+(vlop0-vlop1)*voint(lra,lrj)-2.d0*vlop0*vdint(lra,lrj)
          if(lrj.ne.0) then
            wl=vlop0-vlop1
            call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
          endif
          vlop1=-vij2*dsq3vsq2        !db space drl(22)c"(11)- ext space
c          wl=wl+(vlop0-vlop1)*voint(lra,lri)-2.d0*vlop0*vdint(lra,lri)
          if(lri.ne.0) then
            wl=vlop0-vlop1
            call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
          endif
      endif
c         call prodel(6,wl,iwd,iwa,iwe)
        enddo
        goto 108
!200     zz='  g38,39  '
200   do ima=1,ng_sm
        imb=mul_tab(ima,imae)
        if(imb.gt.ima) cycle
        do la=ibsm_ext(ima),iesm_ext(ima)
          lra=norb_all-la+1
          lbsta=ibsm_ext(imb)
          lbend=iesm_ext(imb)
          if(ima.eq.imb) lbend=la-1
          do lb=lbsta,lbend
            lrb=norb_all-lb+1
            iwe=iwe+1
            volalb=0.d0
            vd2lalb=0.d0
            vlop0=-vl0*vsq2

           do lr=1,norb_dz
              if(lr.eq.lri) cycle
              if(lr.eq.lrj) cycle
c            volalb=volalb+(voint(lra,lr)+voint(lrb,lr))
c            vd2lalb=vd2lalb-2.d0*(vdint(lra,lr)+vdint(lrb,lr))
            wl=vlop0
            call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lr,lrb,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrb,lr,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)

            enddo

c           wl=vlop0*(volalb+vd2lalb)
      if(lri.ge.lrj) then
            vlop0=-vij0*vsq2
            vlop1=vij1
c           wl=wl+(vlop0-vlop1)*(voint(lra,lri)+voint(lrb,lri))
c     :          -2.d0*vlop0*(vdint(lra,lri)+vdint(lrb,lri))
        if(lri.ne.0) then
            wl=vlop0-vlop1
            call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lri,lrb,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrb,lri,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
        endif
            vlop1=vij2
c           wl=wl+(vlop0-vlop1)*(voint(lra,lrj)+voint(lrb,lrj))
c     :          -2.d0*vlop0*(vdint(lra,lrj)+vdint(lrb,lrj))
        if(lrj.ne.0) then
            wl=vlop0-vlop1
            call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrj,lrb,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrb,lrj,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
        endif
      else
            vlop0=-vij0*vsq2
            vlop1=vij1
c           wl=wl+(vlop0-vlop1)*(voint(lra,lrj)+voint(lrb,lrj))
c     :          -2.d0*vlop0*(vdint(lra,lrj)+vdint(lrb,lrj))
        if(lrj.ne.0) then
            wl=vlop0-vlop1
            call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrj,lrb,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrb,lrj,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
        endif
            vlop1=vij2
c           wl=wl+(vlop0-vlop1)*(voint(lra,lri)+voint(lrb,lri))
c     :          -2.d0*vlop0*(vdint(lra,lri)+vdint(lrb,lri))
        if(lri.ne.0) then
            wl=vlop0-vlop1
            call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lri,lrb,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*vlop0
            call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrb,lri,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
        endif
      endif
c              call prodel(6,wl,iwd,iwa,iwe)
            enddo
         enddo
        enddo
        goto 108
!300     zz='  g14,15  '
c===========================lyb=======
c300   do ima=1,8
c      the 8 should be changed to ng_sm

300   do ima=1,ng_sm
        imb=mul_tab(ima,imae)
        if(imb.gt.ima) cycle
        do la=ibsm_ext(ima),iesm_ext(ima)
          lra=norb_all-la+1
          lbsta=ibsm_ext(imb)
          lbend=iesm_ext(imb)
          if(ima.eq.imb) lbend=la-1
          do lb=lbsta,lbend
            lrb=norb_all-lb+1
            iwe=iwe+1
            volalb=0.d0
            vd2lalb=0.d0

            wg14 =-vl0*vsq2

           do lr=1,norb_dz
              if(lr.eq.lri) cycle
              if(lr.eq.lrj) cycle
c            volalb=volalb+(voint(lra,lr)+voint(lrb,lr))
c            vd2lalb=vd2lalb-2.d0*(vdint(lra,lr)+vdint(lrb,lr))
            wl=wg14
            call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lr,lrb,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*wg14
            call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrb,lr,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            enddo

c           wl=wg14*(volalb+vd2lalb)

            if(jpad.eq.18.and.lri.eq.lrj) goto 301
            wg14 =-vij0*vsq2
c           wl=wl+wg14*(voint(lra,lri)+voint(lrb,lri))
c     :          -2.d0*wg14*(vdint(lra,lri)+vdint(lrb,lri))
        if(lri.ne.0) then
            wl=wg14
            call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lri,lrb,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*wg14
            call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrb,lri,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
        endif
c           wl=wl+wg14*(voint(lra,lrj)+voint(lrb,lrj))
c     :          -2.d0*wg14*(vdint(lra,lrj)+vdint(lrb,lrj))
        if(lrj.ne.0) then
            wl=wg14
            call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrj,lrb,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*wg14
            call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            call trans_ijkl_intpos(lrb,lrb,lrj,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
        endif
c301
c         call prodel(6,wl,iwd,iwa,iwe)
301        continue
        enddo
         enddo
        enddo

        if(ipae.ne.18) return
!       zz='  g13     '
        do la=1,norb_ext
           lra=norb_all-la+1

           iwe=iwe+1
           vovdla=0.d0

           wg13 =-vl0*dsq2

          do lr=1,norb_dz
            if(lr.eq.lri) cycle
            if(lr.eq.lrj) cycle
c           vovdla=vovdla+vdint(lr,lra)
            wl=wg13
            call trans_ijkl_intpos(lra,lr,lra,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*wg13
            call trans_ijkl_intpos(lra,lra,lr,lr,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
          enddo

c           wl=wg13*vovdla

            wg13 =-vij0*dsq2
c           wl=wl+wg13*(vdint(lri,lra)+vdint(lrj,lra))
        if(lri.ne.0) then
            wl=wg13
            call trans_ijkl_intpos(lra,lri,lra,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*wg13
            call trans_ijkl_intpos(lra,lra,lri,lri,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
        endif
        if(lrj.ne.0) then
            wl=wg13
            call trans_ijkl_intpos(lra,lrj,lra,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
            wl=-2.0d0*wg13
            call trans_ijkl_intpos(lra,lra,lrj,lrj,nxo)
            call prodel_2(6,wl,iwd,iwa,iwe,nxo)
         endif
c            call prodel(6,wl,iwd,iwa,iwe)
        enddo
108   continue
      return
      end

      subroutine diagonal_dbl_g()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      data dzero/0.d0/
      logical logic_lij

      if(norb_dz.eq.0) return
c        wt0=dzero
      do lr=1,norb_dz                   ! ........800...
c        wt0=wt0+voint(lr,lr)+voint(lr,lr)+vdint(lr,lr)
         wt0_1=2.0d0
         wt0_2=1.0d0
         call trans_ijkl_intpos(lr,lr,lr,lr,nxo)
        do ipae=1,25
          if(nu_ae(ipae).eq.0) cycle
          iwdownv=iw_downwei(1,ipae)
          do iwa=0,iwdownv-1
c       zz=' doub_800_v'
             iwad=iwalk_ad(1,ipae,iwa,0)
             call prodel_1(1,wt0_1,0,ipae,iwad,lr,lr)
             call prodel_2(1,wt0_2,0,ipae,iwad,nxo)
c         zz=' doub_800_s'
          enddo
        enddo
      enddo

c       jps=js(1)

      mr0=1
      do 100 lr0=norb_frz+1,norb_dz
      do lrd=1,norb_dz
         mr0=mul_tab(lsm_inn(lr0),ns_sm)
         iwd=jud(lr0)
         jpad =1+mr0
         jpad1=jpad+24

         call trans_ijkl_intpos(lrd,lrd,lrd,lrd,nxo)

        if(lr0.eq.lrd) then
! ......d_800.
c         wld=wt0-voint(lr0,lr0)-vdint(lr0,lr0)
c          wls=wld-voint(lr0,lr0)
           wld_1=1.0d0
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpad,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpad,ipae,iwa,iwd)
             call prodel_1(1,wld_1,0,ipae,iwad,lrd,lrd)
c             call prodel(1,wld,0,ipae,iwad)
            enddo
          enddo

          if(jb_sys.gt.0) then
            do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpad1,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpad1,ipae,iwa,iwd)
             call prodel_1(1,wld_1,0,ipae,iwad,lrd,lrd)
c             call prodel(1,wld,0,ipae,iwad)
            enddo
            enddo
          endif

        else
           wld_1=2.0d0
           wld_2=1.0d0
           wls_1=2.0d0
           wls_2=1.0d0

          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpad,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpad,ipae,iwa,iwd)
             call prodel_1(1,wld_1,0,ipae,iwad,lrd,lrd)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo)
c             call prodel(1,wld,0,ipae,iwad)
            enddo
          enddo

          if(jb_sys.gt.0) then
            do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpad1,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpad1,ipae,iwa,iwd)
             call prodel_1(1,wld_1,0,ipae,iwad,lrd,lrd)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo)
c             call prodel(1,wld,0,ipae,iwad)
            enddo
            enddo
          endif
! 0.....s_800.
          jpad=17+ns_sm
          iwd=just(lr0,lr0)
          do ipae=1,25
          if(nu_ae(ipae).eq.0) cycle
          iwdownv=iw_downwei(jpad,ipae)
          do iwa=0,iwdownv-1
            iwad=iwalk_ad(jpad,ipae,iwa,iwd)
             call prodel_1(1,wls_1,0,ipae,iwad,lrd,lrd)
             call prodel_2(1,wls_2,0,ipae,iwad,nxo)
c         call prodel(1,wls,0,ipae,iwad)
          enddo
          enddo
        endif
      enddo
      if(lr0.eq.norb_dz) goto 100
c        wld0=wld
! ........800...
      do 200 lr=lr0+1,norb_dz
        mr=mul_tab(mr0,lsm_inn(lr))
        jpat=9+mr
        jpas=17+mr
        jpat1=jpat+24
        iws=just(lr0,lr)
        iwt=iws            !
c          wld=wld0-voint(lr,lr)-vdint(lr,lr)
c=============
c      lr0 and lr

         wld_1=1.0d0
         wld_2=0.0d0
         call trans_ijkl_intpos(lr0,lr0,lr0,lr0,nxo)
         nxo_1=nxo
         call trans_ijkl_intpos(lr,lr,lr,lr,nxo)
         nxo_2=nxo

         do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
             call prodel_1(1,wld_1,0,ipae,iwad,lr0,lr0)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo_1)
             call prodel_1(1,wld_1,0,ipae,iwad,lr,lr)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo_2)
c           call prodel(1,wld,0,ipae,iwad)
            enddo
            if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
            do iwa=0,iwdownv-1
                iwad=iwalk_ad(jpat1,ipae,iwa,iwt)         !t1
             call prodel_1(1,wld_1,0,ipae,iwad,lr0,lr0)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo_1)
             call prodel_1(1,wld_1,0,ipae,iwad,lr,lr)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo_2)
c             call prodel(1,wld,0,ipae,iwad)
            enddo
            endif
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
             call prodel_1(1,wld_1,0,ipae,iwad,lr0,lr0)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo_1)
             call prodel_1(1,wld_1,0,ipae,iwad,lr,lr)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo_2)
c           call prodel(1,wld,0,ipae,iwad)
            enddo
            if(jb_sys.gt.0) then
            iws1=just(lr,lr0)
            do iwa=0,iwdownv-1
                iwad=iwalk_ad(jpas,ipae,iwa,iws1)
             call prodel_1(1,wld_1,0,ipae,iwad,lr0,lr0)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo_1)
             call prodel_1(1,wld_1,0,ipae,iwad,lr,lr)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo_2)
c             call prodel(1,wld,0,ipae,iwad)
            enddo
            endif
         enddo

c==============
c     1 <= lrd < norb_dz and lrd.ne.lr0.and.lrd.ne.lr
      do lrd=1,norb_dz

       if(lrd.ne.lr0.and.lrd.ne.lr) then
         wld_1=2.0d0
         wld_2=1.0d0
         call trans_ijkl_intpos(lrd,lrd,lrd,lrd,nxo)
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
             call prodel_1(1,wld_1,0,ipae,iwad,lrd,lrd)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo)
c           call prodel(1,wld,0,ipae,iwad)
          enddo
            if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
              do iwa=0,iwdownv-1
                iwad=iwalk_ad(jpat1,ipae,iwa,iwt)         !t1
             call prodel_1(1,wld_1,0,ipae,iwad,lrd,lrd)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo)
c             call prodel(1,wld,0,ipae,iwad)
            enddo
          endif
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
             call prodel_1(1,wld_1,0,ipae,iwad,lrd,lrd)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo)
c           call prodel(1,wld,0,ipae,iwad)
          enddo
            if(jb_sys.gt.0) then
            iws1=just(lr,lr0)
              do iwa=0,iwdownv-1
                iwad=iwalk_ad(jpas,ipae,iwa,iws1)
             call prodel_1(1,wld_1,0,ipae,iwad,lrd,lrd)
             call prodel_2(1,wld_2,0,ipae,iwad,nxo)
c             call prodel(1,wld,0,ipae,iwad)
            enddo
          endif
        enddo
       endif
      enddo
200     continue
100   continue

!     wl8 = 1/2*hnil*(hnil-1)*vmd(lr,lr)+hnil*voint(lr,lr)   800
!     wl5=(vlop0-vlop1)*vo(lr0,lr)-2*vlop0*vmd(lr0,lr)
!     wl5= vlop0*vmd(lr,lr0)   -vlop1*vo(lr0,lr)   2000.11.26
c     wt0=dzero
      do lr0=2,norb_dz
        do lr=1,lr0-1
                        ! .........520...   vlop0=-2 vlop1=0
c         wt0=wt0-2.d0*vdint(lr,lr0)
           wt0_1=-2.0d0
           wt0_2=4.0d0
           call trans_ijkl_intpos(lr0,lr,lr0,lr,nxo)
           nxo1_0=nxo
           call trans_ijkl_intpos(lr0,lr0,lr,lr,nxo)
           nxo2_0=nxo
           jpad=1
           iwd=0
           do ipae=1,25
              if(nu_ae(ipae).eq.0) cycle
              iwdownv=iw_downwei(jpad,ipae)
              do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpad,ipae,iwa,iwd)
                 call prodel_2(1,wt0_1,0,ipae,iwad,nxo1_0)
                 call prodel_2(1,wt0_2,0,ipae,iwad,nxo2_0)
c                 call prodel(1,wt0,0,ipae,iwad)
              enddo
           enddo
        enddo
      enddo
      do 300 lrm=norb_frz+1,norb_dz
          mrm=mul_tab(lsm_inn(lrm),ns_sm)
          iws=just(lrm,lrm)
          iwd=jud(lrm)
          jpad=1+mrm
          jpad1=jpad+24
          jpas=17+ns_sm
          do lrd=2,norb_dz
             do lrds=1,lrd-1

             logic_lij=.false.
             call trans_ijkl_intpos(lrd,lrds,lrd,lrds,nxo)
             nxod_1=nxo
             call trans_ijkl_intpos(lrd,lrd,lrds,lrds,nxo)
             nxod_2=nxo

             do lr=1,lrm-1
               if(lr.eq.lrds.and.lrm.eq.lrd)   then
                   logic_lij=.true.
c              wld=wld+vdint(lr,lrm)
               wld_1=-1.0d0
               wld_2=2.0d0
               do ipae=1,25
                  if(nu_ae(ipae).eq.0) cycle
                     iwdownv=iw_downwei(jpad,ipae)
                  do iwa=0,iwdownv-1
                     iwad=iwalk_ad(jpad,ipae,iwa,iwd)
                     call prodel_2(1,wld_1,0,ipae,iwad,nxod_1)
                     call prodel_2(1,wld_2,0,ipae,iwad,nxod_2)

c                     call prodel(1,wld,0,ipae,iwad)
                  enddo
                  if(jb_sys.gt.0) then
                     iwdownv=iw_downwei(jpad1,ipae)
                     do iwa=0,iwdownv-1
                        iwad=iwalk_ad(jpad1,ipae,iwa,iwd)
                     call prodel_2(1,wld_1,0,ipae,iwad,nxod_1)
                     call prodel_2(1,wld_2,0,ipae,iwad,nxod_2)

c                        call prodel(1,wld,0,ipae,iwad)
                     enddo
                  endif
               enddo
               exit
               endif
             enddo

             do lr0=lrm+1,norb_dz
               if(lrm.eq.lrds.and.lr0.eq.lrd)   then
                   logic_lij=.true.
c              wld=wld+vdint(lrm,lr0)
               wld_1=-1.0d0
               wld_2=2.0d0
               do ipae=1,25
                  if(nu_ae(ipae).eq.0) cycle
                     iwdownv=iw_downwei(jpad,ipae)
                  do iwa=0,iwdownv-1
                     iwad=iwalk_ad(jpad,ipae,iwa,iwd)
                     call prodel_2(1,wld_1,0,ipae,iwad,nxod_1)
                     call prodel_2(1,wld_2,0,ipae,iwad,nxod_2)

c                     call prodel(1,wld,0,ipae,iwad)
                  enddo
                  if(jb_sys.gt.0) then
                     iwdownv=iw_downwei(jpad1,ipae)
                     do iwa=0,iwdownv-1
                        iwad=iwalk_ad(jpad1,ipae,iwa,iwd)
                     call prodel_2(1,wld_1,0,ipae,iwad,nxod_1)
                     call prodel_2(1,wld_2,0,ipae,iwad,nxod_2)

c                        call prodel(1,wld,0,ipae,iwad)
                     enddo
                  endif
               enddo
               exit
               endif
             enddo

c      wls=wld
c      do lr=lrm+1,norb_dz
c       wls=wls+vdint(lrm,lr)
c      enddo
c      do lr0=1,lrm-1
c       wls=wls+vdint(lr0,lrm)
c      enddo

      if(.not.logic_lij) then
           wt0_1=-2.0d0
           wt0_2=4.0d0
      do ipae=1,25
        if(nu_ae(ipae).eq.0) cycle
        iwdownv=iw_downwei(jpad,ipae)
        do iwa=0,iwdownv-1
          iwad=iwalk_ad(jpad,ipae,iwa,iwd)
          call prodel_2(1,wt0_1,0,ipae,iwad,nxod_1)
          call prodel_2(1,wt0_2,0,ipae,iwad,nxod_2)

c          call prodel(1,wld,0,ipae,iwad)
        enddo
        if(jb_sys.gt.0) then
        iwdownv=iw_downwei(jpad1,ipae)
        do iwa=0,iwdownv-1
          iwad=iwalk_ad(jpad1,ipae,iwa,iwd)
          call prodel_2(1,wt0_1,0,ipae,iwad,nxod_1)
          call prodel_2(1,wt0_2,0,ipae,iwad,nxod_2)

c            call prodel(1,wld,0,ipae,iwad)
        enddo
        endif
! ....s_520.
        iwdownv=iw_downwei(jpas,ipae)
        do iwa=0,iwdownv-1
          iwad=iwalk_ad(jpas,ipae,iwa,iws)
          call prodel_2(1,wt0_1,0,ipae,iwad,nxod_1)
          call prodel_2(1,wt0_2,0,ipae,iwad,nxod_2)

c          call prodel(1,wls,0,ipae,iwad)
        enddo
      enddo
      endif
      enddo
      enddo

300   continue

                                             ! ........520.
      do 400 lr0=norb_frz+1,norb_dz-1
        mr0=mul_tab(lsm_inn(lr0),ns_sm)
        do 401 lr=lr0+1,norb_dz
         mr=mul_tab(mr0,lsm_inn(lr))

         jpat=9+mr
         jpas=17+mr
          jpat1=jpat+24
         iws=just(lr0,lr)
         iwt=iws            !
            iws1=just(lr,lr0)

          do lrd=2,norb_dz
             do lrds=1,lrd-1

             logic_lij=.false.
             call trans_ijkl_intpos(lrd,lrds,lrd,lrds,nxo)
             nxos_1=nxo
             call trans_ijkl_intpos(lrd,lrd,lrds,lrds,nxo)
             nxos_2=nxo
             if(lr0.eq.lrds.and.lr.eq.lrd) then
                logic_lij=.true.
               if(jb_sys.eq.0) then
c           wls=wt0+3.d0*(voint(lr,lr0)-vdint(lr,lr0))
c          wlt=wt0+voint(lr,lr0)-3.d0*vdint(lr,lr0)
                   wls_1=1.0d0
                   wls_2=1.0d0
                   wlt_1=-1.0d0
                   wlt_2=1.0d0
                endif
           !  ..3.3  2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
           !  ..2.1    vo(lr0,lr)+  vmd(lr0,lr)  w0=-1/2  w1=-3/2
           !  ..3.3  2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
           !  ..2.2  - vo(lr0,lr)+  vmd(lr0,lr)  w0=-1/2  w1=1/2
               if(jb_sys.gt.0) then
                  db=jb_sys
                 w1=-(db+3)/(2.d0*db+2)
c           wls=wt0+(1.50d0-w1)*voint(lr,lr0)-3.d0*vdint(lr,lr0)
                  wls_1=-0.5d0-w1
                  wls_2=1.0d0
c          wlt=wt0+voint(lr,lr0)-3.d0*vdint(lr,lr0)
                  wlt_1=-1.0d0
                  wlt_2=1.0d0
                 w1=-(db-1)/(2.d0*db+2)
c          wls1=wt0+(1.50d0-w1)*voint(lr,lr0)-3.d0*vdint(lr,lr0)
                  wls1_1=-0.5d0-w1
                  wls1_2=1.0d0
            !    ..3.3  2*vo(lr0,lr)-4*vmd(lr0,lr)  w0=-2  w1=0
            !    ..1.2  (-1/2-w1)*vo(lr0,lr)+vmd(lr0,lr)
           !  w0=-1/2    w1=-(db-1)/(2*db+2)
               endif
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
              call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wlt,0,ipae,iwad)
            enddo
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
              call prodel_2(1,wls_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wls_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls,0,ipae,iwad)
           enddo
            if(jb_sys.gt.0) then
              iwdownv=iw_downwei(jpas,ipae)
              do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
                call prodel_2(1,wls1_1,0,ipae,iwad,nxos_1)
                call prodel_2(1,wls1_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls1,0,ipae,iwad)
            enddo
           endif
           if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
               do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpat1,ipae,iwa,iwt)     !t 1-1
                 call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
                 call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c                 call prodel(1,wlt,0,ipae,iwad)
               enddo
           endif
          enddo
             cycle
            endif

        do lrg=1,lr0-1
           if(lrg.eq.lrds.and.lr0.eq.lrd) then
               logic_lij=.true.
               wls_1=-1.0d0
               wls_2=2.0d0
               wlt_1=-1.0d0
               wlt_2=2.0d0
               if(jb_sys.gt.0) then
                  wls1_1=-1.0d0
                  wls1_2=2.0d0
               endif
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
              call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wlt,0,ipae,iwad)
           enddo
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
              call prodel_2(1,wls_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wls_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls,0,ipae,iwad)
           enddo
            if(jb_sys.gt.0) then
              iwdownv=iw_downwei(jpas,ipae)
              do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
                call prodel_2(1,wls1_1,0,ipae,iwad,nxos_1)
                call prodel_2(1,wls1_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls1,0,ipae,iwad)
            enddo
           endif
           if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
               do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpat1,ipae,iwa,iwt)     !t 1-1
                 call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
                 call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c                 call prodel(1,wlt,0,ipae,iwad)
               enddo
           endif
          enddo
          exit
         endif

         if(lrg.eq.lrds.and.lr.eq.lrd) then
               logic_lij=.true.
               wls_1=-1.0d0
               wls_2=2.0d0
               wlt_1=-1.0d0
               wlt_2=2.0d0
               if(jb_sys.gt.0) then
                  wls1_1=-1.0d0
                  wls1_2=2.0d0
               endif
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
              call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wlt,0,ipae,iwad)
           enddo
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
              call prodel_2(1,wls_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wls_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls,0,ipae,iwad)
           enddo
            if(jb_sys.gt.0) then
              iwdownv=iw_downwei(jpas,ipae)
              do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
                call prodel_2(1,wls1_1,0,ipae,iwad,nxos_1)
                call prodel_2(1,wls1_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls1,0,ipae,iwad)
            enddo
           endif
           if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
               do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpat1,ipae,iwa,iwt)     !t 1-1
                 call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
                 call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c                 call prodel(1,wlt,0,ipae,iwad)
               enddo
           endif
          enddo
          exit
         endif
        enddo

        do lrg=lr0+1,lr-1
           if(lr0.eq.lrds.and.lrg.eq.lrd) then
               logic_lij=.true.
               wls_1=-1.0d0
               wls_2=2.0d0
               wlt_1=-1.0d0
               wlt_2=2.0d0
               if(jb_sys.gt.0) then
                  wls1_1=-1.0d0
                  wls1_2=2.0d0
               endif
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
              call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wlt,0,ipae,iwad)
           enddo
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
              call prodel_2(1,wls_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wls_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls,0,ipae,iwad)
           enddo
            if(jb_sys.gt.0) then
              iwdownv=iw_downwei(jpas,ipae)
              do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
                call prodel_2(1,wls1_1,0,ipae,iwad,nxos_1)
                call prodel_2(1,wls1_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls1,0,ipae,iwad)
            enddo
           endif
           if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
               do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpat1,ipae,iwa,iwt)     !t 1-1
                 call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
                 call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c                 call prodel(1,wlt,0,ipae,iwad)
               enddo
           endif
          enddo
          exit
         endif

         if(lrg.eq.lrds.and.lr.eq.lrd) then
               logic_lij=.true.
               wls_1=-1.0d0
               wls_2=2.0d0
               wlt_1=-1.0d0
               wlt_2=2.0d0
               if(jb_sys.gt.0) then
                  wls1_1=-1.0d0
                  wls1_2=2.0d0
               endif
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
              call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wlt,0,ipae,iwad)
           enddo
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
              call prodel_2(1,wls_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wls_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls,0,ipae,iwad)
           enddo
            if(jb_sys.gt.0) then
              iwdownv=iw_downwei(jpas,ipae)
              do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
                call prodel_2(1,wls1_1,0,ipae,iwad,nxos_1)
                call prodel_2(1,wls1_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls1,0,ipae,iwad)
            enddo
           endif
           if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
               do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpat1,ipae,iwa,iwt)     !t 1-1
                 call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
                 call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c                 call prodel(1,wlt,0,ipae,iwad)
               enddo
           endif
          enddo
          exit
         endif
        enddo


        do lrg=lr+1,norb_dz
           if(lr.eq.lrds.and.lrg.eq.lrd) then
               logic_lij=.true.
               wls_1=-1.0d0
               wls_2=2.0d0
               wlt_1=-1.0d0
               wlt_2=2.0d0
               if(jb_sys.gt.0) then
                  wls1_1=-1.0d0
                  wls1_2=2.0d0
               endif
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
              call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wlt,0,ipae,iwad)
           enddo
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
              call prodel_2(1,wls_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wls_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls,0,ipae,iwad)
           enddo
            if(jb_sys.gt.0) then
              iwdownv=iw_downwei(jpas,ipae)
              do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
                call prodel_2(1,wls1_1,0,ipae,iwad,nxos_1)
                call prodel_2(1,wls1_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls1,0,ipae,iwad)
            enddo
           endif
           if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
               do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpat1,ipae,iwa,iwt)     !t 1-1
                 call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
                 call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c                 call prodel(1,wlt,0,ipae,iwad)
               enddo
           endif
          enddo
          exit
         endif

         if(lr0.eq.lrds.and.lrg.eq.lrd) then
               logic_lij=.true.
               wls_1=-1.0d0
               wls_2=2.0d0
               wlt_1=-1.0d0
               wlt_2=2.0d0
               if(jb_sys.gt.0) then
                  wls1_1=-1.0d0
                  wls1_2=2.0d0
               endif
          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
              call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wlt,0,ipae,iwad)
           enddo
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
              call prodel_2(1,wls_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wls_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls,0,ipae,iwad)
           enddo
            if(jb_sys.gt.0) then
              iwdownv=iw_downwei(jpas,ipae)
              do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
                call prodel_2(1,wls1_1,0,ipae,iwad,nxos_1)
                call prodel_2(1,wls1_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls1,0,ipae,iwad)
            enddo
           endif
           if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
               do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpat1,ipae,iwa,iwt)     !t 1-1
                 call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
                 call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c                 call prodel(1,wlt,0,ipae,iwad)
               enddo
           endif
          enddo
          exit
         endif
        enddo

        if(.not.logic_lij) then
           if(jb_sys.eq.0) then
              wls_1=-2.0d0
              wls_2=4.0d0
              wlt_1=-2.0d0
              wlt_2=4.0d0
           endif

           if(jb_sys.gt.0) then
              wls_1=-2.0d0
              wls_2=4.0d0
              wlt_1=-2.0d0
              wlt_2=4.0d0
              wls1_1=-2.0d0
              wls1_2=4.0d0
           endif

          do ipae=1,25
            if(nu_ae(ipae).eq.0) cycle
            iwdownv=iw_downwei(jpat,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpat,ipae,iwa,iwt)
              call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wlt,0,ipae,iwad)
           enddo
            iwdownv=iw_downwei(jpas,ipae)
            do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws)
              call prodel_2(1,wls_1,0,ipae,iwad,nxos_1)
              call prodel_2(1,wls_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls,0,ipae,iwad)
           enddo
            if(jb_sys.gt.0) then
              iwdownv=iw_downwei(jpas,ipae)
              do iwa=0,iwdownv-1
              iwad=iwalk_ad(jpas,ipae,iwa,iws1)     ! s 1-2
                call prodel_2(1,wls1_1,0,ipae,iwad,nxos_1)
                call prodel_2(1,wls1_2,0,ipae,iwad,nxos_2)
c             call prodel(1,wls1,0,ipae,iwad)
            enddo
           endif
           if(jb_sys.gt.1) then
              iwdownv=iw_downwei(jpat1,ipae)
               do iwa=0,iwdownv-1
                 iwad=iwalk_ad(jpat1,ipae,iwa,iwt)     !t 1-1
                 call prodel_2(1,wlt_1,0,ipae,iwad,nxos_1)
                 call prodel_2(1,wlt_2,0,ipae,iwad,nxos_2)
c                 call prodel(1,wlt,0,ipae,iwad)
               enddo
           endif
          enddo

        endif
        enddo
      enddo
401     continue
400   continue
c ------------- end of .......h_delm --------------
      return
      end



      subroutine diagonal_ext_g()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
!     common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
!     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
!     :    ,jv,jd(8),jt(8),js(8)
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      character*10 cc
        cc=' out_800_d'
        jws0=0
c      do mra=1,8
       do mra=1,ng_sm
        ipae=1+mra
        lasta=ibsm_ext(mra)
        laend=iesm_ext(mra)
        lrzz=laend-lasta+1
        lrzz=lrzz*(lrzz-1)/2
        jws0=jws0+lrzz
        jw=0
        do la=lasta,laend
c        jpd=jd(mra)
          jw=jw+1
          lra=norb_all-la+1
c        wld=voint(lra,lra)
          wld=1.0d0
          call prodel_1(2,wld,0,ipae,jw,lra,lra)
c         call prodel(2,wld,0,ipae,jw)
        enddo
      enddo

!      zz=' out_800_s'
c       jps=js(1)

      jweis=jws0
      do la=1,norb_ext
c        jpd=jd(mra)
        lra=norb_all-la+1
        jweis=jweis+1
c        wls=2.d0*voint(lra,lra)+vdint(lra,lra)
c       call prodel(2,wls,0,18,jweis)
        wls=2.0d0
        call prodel_1(2,wls,0,18,jweis,lra,lra)
        wls=1.0d0
        call trans_ijkl_intpos(lra,lra,lra,lra,nxo)
        call prodel_2(2,wls,0,18,jweis,nxo)
      enddo
c      do im=1,8
       do im=1,ng_sm
        jws=0
        jwt=0
        ipat=9+im
        ipas=17+im
        do la=2,norb_ext
         lra=norb_all-la+1
         ima=lsm(la)
         do 600 lb=1,la-1
           lrb=norb_all-lb+1
           imb=lsm(lb)
           mr=mul_tab(ima,imb)
           if(mr.ne.im) goto 600
c          jps=js(mr)
c          jpt=jt(mr)
           jws=jws+1
           jwt=jwt+1
c            wls=voint(lra,lra)+voint(lrb,lrb)
            wls=1.0d0
            wlt=wls
           call prodel_1(2,wls,0,ipas,jws,lra,lra)
            call prodel_1(2,wlt,0,ipat,jwt,lra,lra)
           call prodel_1(2,wls,0,ipas,jws,lrb,lrb)
            call prodel_1(2,wlt,0,ipat,jwt,lrb,lrb)

c           wls=wls+voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=-3/2
           wls=1.0d0
           call trans_ijkl_intpos(lrb,lra,lrb,lra,nxo)
           call prodel_2(2,wls,0,ipas,jws,nxo)
           call trans_ijkl_intpos(lrb,lrb,lra,lra,nxo)
           call prodel_2(2,wls,0,ipas,jws,nxo)
c           wlt=wlt-voint(lrb,lra)+vdint(lrb,lra)   ! w0=-1/2  w1=1/2
           wlt=-1.0d0
           call trans_ijkl_intpos(lrb,lra,lrb,lra,nxo)
           call prodel_2(2,wlt,0,ipat,jwt,nxo)
           wlt=1.0d0
           call trans_ijkl_intpos(lrb,lrb,lra,lra,nxo)
           call prodel_2(2,wlt,0,ipat,jwt,nxo)

c          call prodel(2,wls,0,ipas,jws)
c           call prodel(2,wlt,0,ipat,jwt)
600       continue
          enddo
      enddo
      return
      end

!  idb=1  in dbl_space      ity_up=0-5             jd_type,jd_im,iwd
!  idb=2  in ext_space      ity_down=0-3          je_type,je_im,iwe
!  idb=3  in act_space      ity_up=0-5,itdown=0,3      jp ,mpe,iwa
!  idb=4  betwin dbl and act   ity_up=0-5,itdown=0,3      mpe,iwd,iwa
!  idb=5  betwin act and ext  ity_down=0-3            jp ,iwa,iwe
!  idb=6  betwin dbl and ext   ity_down=0-3            iwd,iwa,iwe

!  this subroutine prodel_1 does the dm1 part, which corresponds to voin

      subroutine prodel_1(idb,wl,mg1,mg2,mg3,mg6,mg7)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "grad_h.fh"
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)

      ndr=88
      goto(100,200,300,400,500,600),idb
! in dbl_space
100   ipae=mg2
      iwad=mg3
        isegdownwei=iseg_downwei(ipae)
        do mm=iwad+1,iwad+isegdownwei
c        vector1(mm)=vector1(mm)+wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(mm)*wl*vector1(mm)
c         if(mg7.eq.4)
c     :      write(nf2,'(3i4,f18.10)')mg7,mg6,mm,wl

c         write(nf2,'(3i4,3f18.10)')mg7,mg6,mm,wl,vector1(mm),vector1(mm
!     if(mm.eq.ndr) then
!       write(nf2,'(a8,3i6,2f20.14)')
!     :     ' in dbl _',mg1,mg2,mg3,wl,vector1(mm)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' in dbl _',mg1,mg2,mg3,wl,vector1(mm)
!      endif
        enddo
      goto 1000
! in ext_space
 200  ipae=mg2
      iwe=mg3
      do jdbl=1,mxnode
        if(nu_ad(jdbl).eq.0) cycle
        iw=iw_downwei(jdbl,ipae)
        iwupwei=jpad_upwei(jdbl)
        do iwa=0,iw-1
          do iwd=0,iwupwei-1
            mm=iwalk_ad(jdbl,ipae,iwa,iwd)+iwe
c          vector1(mm)=vector1(mm)+wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(mm)*wl*vector1(mm)

!     if(mm.eq.ndr) then
!       write(nf2,'(a8,3i6,2f20.14)')
!     :     ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' in ext _',mg1,mg2,mg3,wl,vector1(mm)
!      endif
          enddo
        enddo
      enddo
      goto 1000
! in act_space
300   jp=mg1
      mpe=mg2
      jw=mg3
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jph=jphy(jp)
      in=ihy(jph)
      lwnu=iy(1,mpe)
      do jwu=jph+1,jph+in
        iwa=jw+ihy(jwu)-1
        do jwd=1,lwnu
          iwa=iwa+1
          do iwd=0,iwupwei-1
            iwad=iwalk_ad(jpad,ipae,iwa,iwd)
            do iwe=1,isegdownwei
              mm=iwe+iwad
c            vector1(mm)=vector1(mm)+wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(mm)*wl*vector1(mm)

!     if(mm.eq.ndr) then
!       write(nf2,'(a8,3i6,2f20.14)')
!     :     ' in act _',mg1,mg2,mg3,wl,vector1(mm)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' in act _',mg1,mg2,mg3,wl,vector1(mm)
!      endif
            enddo
          enddo
        enddo
      enddo
      goto 1000
! betwin dbl and act
400   mpe=mg1
      iwd=mg2
      iwa=mg3-1
      isegdownwei=iseg_downwei(ipae)   ! betwin dbl and act
      jwnu=iy(1,mpe)
      do ii=1,jwnu
        iwa=iwa+1
        iwad=iwalk_ad(jpad,ipae,iwa,iwd)
        do iwe=1,isegdownwei
          mm=iwe+iwad                  ! iwl=iwalk_ad
c             vector1(mm)=vector1(mm)+wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(mm)*wl*vector1(mm)

!     if(mm.eq.ndr) then
!       write(nf2,'(a8,3i6,2f20.14)')
!     :     ' dbl_act ',mg1,mg2,mg3,wl,vector1(mm)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' dbl_act ',mg1,mg2,mg3,wl,vector1(mm)
!      endif
        enddo
      enddo
      goto 1000
! betwin act and ext
500   jp=mg1
      iwa0=mg2
      iwe=mg3
      iwupwei=jpad_upwei(jpad)
      jph=jphy(jp)
      in=ihy(jph)
      do jwu=jph+1,jph+in
        iwa=iwa0+ihy(jwu)
        do iwd=0,iwupwei-1
          iwad=iwalk_ad(jpad,ipae,iwa,iwd)
          mm=iwe+iwad
c          vector1(mm)=vector1(mm)+wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(mm)*wl*vector1(mm)

!     if(mm.eq.ndr) then
!       write(nf2,'(a8,3i6,2f20.14)')
!     :     ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
!      endif
        enddo
      enddo
      goto 1000
! betwin dbl and ext
600   iwd=mg1
      iwa=mg2
      iwe=mg3
      iwad=iwalk_ad(jpad,ipae,iwa,iwd)   ! betwin dbl,act and ext
      mm=iwe+iwad
c          vector1(mm)=vector1(mm)+wl
            mg67=ican_a(mg7)+mg6
            dm1tmp(mg67)=dm1tmp(mg67)+vector1(mm)*wl*vector1(mm)

!     if(mm.eq.ndr) then
!       write(nf2,'(a8,3i6,2f20.14)')
!     :     ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
!      endif
1000  return
      end

!this subroutine prodel_2 does the dm2 part, which corresponds to vint_c

      subroutine prodel_2(idb,wl,mg1,mg2,mg3,mg6)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "grad_h.fh"
!      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
!     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
c      ndr=88
       ndr=6
      goto(100,200,300,400,500,600),idb
! in dbl_space
100   ipae=mg2
      iwad=mg3
        isegdownwei=iseg_downwei(ipae)
        do mm=iwad+1,iwad+isegdownwei
c        vector1(mm)=vector1(mm)+wl
           vector2(mg6)=vector2(mg6)+vector1(mm)*wl*vector1(mm)
c      if(mg6.eq.45)
c     :     write(nf2,'(i8,2i4,4f18.10)')mg6,mm,mm,vector2(mg6),
c     :                          vector1(mm),wl,vector1(mm)

c      if(mg6.eq.ndr) then
c       write(nf2,'(a9,3i6,3f20.14)')
c     :     ' in dbl_ ',mg6,mm,mm,wl,vector1(mm),vector2(mg6)
c        write(*,'(a8,3i6,2f20.14)')
c     :     ' in dbl _',mg1,mg2,mg3,wl,vector1(mm)
c      endif
        enddo
      goto 1000
! in ext_space
 200  ipae=mg2
      iwe=mg3
      do jdbl=1,mxnode
        if(nu_ad(jdbl).eq.0) cycle
        iw=iw_downwei(jdbl,ipae)
        iwupwei=jpad_upwei(jdbl)
        do iwa=0,iw-1
          do iwd=0,iwupwei-1
            mm=iwalk_ad(jdbl,ipae,iwa,iwd)+iwe
c          vector1(mm)=vector1(mm)+wl
           vector2(mg6)=vector2(mg6)+vector1(mm)*wl*vector1(mm)
c          write(nf2,'(i8,2i4,4f18.10)')mg6,mm,mm,vector2(mg6),
c     :                          vector1(mm),wl,vector1(mm)


c      if(mg6.eq.2926) then
c       write(nf2,'(a9,3i6,3f20.14)')
c     :     ' in ext_ ',mg6,mm,mm,wl,vector1(mm),vector2(mg6)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' in ext _',mg1,mg2,mg3,wl,vector1(mm)

c      endif
          enddo
        enddo
      enddo
      goto 1000
! in act_space
300   jp=mg1
      mpe=mg2
      jw=mg3
      iwupwei=jpad_upwei(jpad)
      isegdownwei=iseg_downwei(ipae)
      jph=jphy(jp)
      in=ihy(jph)
      lwnu=iy(1,mpe)
      do jwu=jph+1,jph+in
        iwa=jw+ihy(jwu)-1
        do jwd=1,lwnu
          iwa=iwa+1
          do iwd=0,iwupwei-1
            iwad=iwalk_ad(jpad,ipae,iwa,iwd)
            do iwe=1,isegdownwei
              mm=iwe+iwad
c            vector1(mm)=vector1(mm)+wl
           vector2(mg6)=vector2(mg6)+vector1(mm)*wl*vector1(mm)
c      if(mg6.eq.231)  write(nf2,'(i4,3f18.10)') mm,wl,vector1(mm),
c     :     vector2(mg6)
c           write(nf2,'(a3,i4)') 'act',mm

c          write(nf2,'(i8,2i4,4f18.10)')mg6,mm,mm,vector2(mg6),
c     :                          vector1(mm),wl,vector1(mm)

c      if(mg6.eq.ndr) then
c       write(nf2,'(a9,3i6,3f20.14)')
c     :     ' in act_ ',mg6,mm,mm,wl,vector1(mm),vector2(mg6)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' in act _',mg1,mg2,mg3,wl,vector1(mm)
c      endif
            enddo
          enddo
        enddo
      enddo
      goto 1000
! betwin dbl and act
400   mpe=mg1
      iwd=mg2
      iwa=mg3-1
      isegdownwei=iseg_downwei(ipae)   ! betwin dbl and act
      jwnu=iy(1,mpe)
      do ii=1,jwnu
        iwa=iwa+1
        iwad=iwalk_ad(jpad,ipae,iwa,iwd)
        do iwe=1,isegdownwei
          mm=iwe+iwad                  ! iwl=iwalk_ad
c             vector1(mm)=vector1(mm)+wl
           vector2(mg6)=vector2(mg6)+vector1(mm)*wl*vector1(mm)
c           if(mg6.eq.91)
c     :      write(nf2,'(i8,i4,3f18.10)')mg6,mm,vector2(mg6),
c     :                          wl,vector1(mm)
c        write(nf2,'(a7,i4)') 'dbl_act',mm

c      if(mg6.eq.3)  write(nf2,'(i4,2f18.10)') mm,wl,vector1(mm)
c      if(mg6.eq.ndr) then
c       write(nf2,'(a9,3i6,3f20.14)')
c     :     ' dbl_act ',mg6,mm,mm,wl,vector1(mm),vector2(mg6)
c!       write(*,'(a8,3i6,2f20.14)')
!     :     ' dbl_act ',mg1,mg2,mg3,wl,vector1(mm)
c      endif
        enddo
      enddo
      goto 1000
! betwin act and ext
500   jp=mg1
      iwa0=mg2
      iwe=mg3
      iwupwei=jpad_upwei(jpad)
      jph=jphy(jp)
      in=ihy(jph)
      do jwu=jph+1,jph+in
        iwa=iwa0+ihy(jwu)
        do iwd=0,iwupwei-1
          iwad=iwalk_ad(jpad,ipae,iwa,iwd)
          mm=iwe+iwad
c          vector1(mm)=vector1(mm)+wl
           vector2(mg6)=vector2(mg6)+vector1(mm)*wl*vector1(mm)
c           write(nf2,*) 'ae',mm,wl,vector1(mm)
c          write(nf2,'(i8,2i4,4f18.10)')mg6,mm,mm,vector2(mg6),
c     :                          vector1(mm),wl,vector1(mm)


c      if(mg6.eq.ndr) then
c       write(nf2,'(a9,3i6,3f20.14)')
c     :     ' act_ext ',mg6,mm,mm,wl,vector1(mm),vector2(mg6)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' act_ext ',mg1,mg2,mg3,wl,vector1(mm)
c      endif
        enddo
      enddo
      goto 1000
! betwin dbl and ext
600   iwd=mg1
      iwa=mg2
      iwe=mg3
      iwad=iwalk_ad(jpad,ipae,iwa,iwd)   ! betwin dbl,act and ext
      mm=iwe+iwad
c          vector1(mm)=vector1(mm)+wl
           vector2(mg6)=vector2(mg6)+vector1(mm)*wl*vector1(mm)
c          write(nf2,'(i8,2i4,4f18.10)')mg6,mm,mm,vector2(mg6),
c     :                          vector1(mm),wl,vector1(mm)


c      if(mg6.eq.ndr) then
c       write(nf2,'(a9,3i6,3f20.14)')
c     :     ' dbl_ext ',mg6,mm,mm,wl,vector1(mm),vector2(mg6)
!       write(*,'(a8,3i6,2f20.14)')
!     :     ' dbl_ext ',mg1,mg2,mg3,wl,vector1(mm)
c      endif
1000  return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  ChoLoc
*
*> @brief
*>   Cholesky decompose density to obtain Cholesky localized orbitals
*> @author T. B. Pedersen
*>
*> @details
*> Localize orbitals by Cholesky decomposition of the density
*> matrix. The threshold should be set such that the
*> decomposition is essentially exact (e.g. ``1.0d-12``). If not, you
*> might risk that the localization fails (non-zero return code),
*> since the number of Cholesky vectors will be less than the
*> number of occupied (\p nOcc) molecular orbitals. On sucessful
*> completion, \p irc = ``0`` is returned.
*>
*> @note
*> The density matrix is destroyed during the localization!
*>
*> @param[out]    irc  Return code
*> @param[in,out] Dens Density matrix
*> @param[out]    CMO  Cholesky MO coefficients
*> @param[in]     Thrs Threshold for decomposition
*> @param[out]    xNrm Total norm of Cholesky vectors
*> @param[in]     nBas Number of basis functions
*> @param[in]     nOcc Number of occupied orbitals
************************************************************************
      SubRoutine ChoLoc(irc,Dens,CMO,Thrs,xNrm,nBas,nOcc)
      Implicit None
      Integer irc, nBas, nOcc
      Real*8  Thrs, xNrm
      Real*8  Dens(nBas,nBas), CMO(nBas,nOcc)

      Character*6 SecNam
      Parameter (SecNam = 'ChoLoc')

      Integer  nVec
      real*8 ddot_
      external ddot_

      irc  = 0
      xNrm = -9.9d9

      nVec = 0
      Call CD_InCore(Dens,nBas,CMO,nOcc,nVec,Thrs,irc)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': CD_InCore returned ',irc
         Return
      Else If (nVec .ne. nOcc) Then
         Write(6,*) SecNam,': nVec.NE.nOcc'
         Write(6,*) '   nVec,nOcc = ',nVec,nOcc
         irc = 1
         Return
      End If

      xNrm = sqrt(dDot_(nBas*nOcc,CMO,1,CMO,1))

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Giovanni Li Manni                                *
!***********************************************************************

subroutine ChkSplit()
!***********************************************************************
!     SplitCAS Check for obvious errors or violation  of limits        *
!----------------------------------------------------------------------*
!     written by:                                                      *
!     Giovanni Li Manni (GLMJ)                                         *
!     University of Geneva, Switzerland, 2010                          *
!----------------------------------------------------------------------*
!     history: none                                                    *
!***********************************************************************

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IERR
#include "rasdim.fh"
#include "output_ras.fh"
#include "general.fh"
#include "splitcas.fh"
#include "warnings.h"

!if (DoSplitCAS) then
IERR = 0
if (lRootSplit > nConf) IERR = 1
if (IERR == 1) then
  write(LF,*)
  write(LF,*) '******************** ERROR *********************'
  write(LF,'(1X,A)') 'Input Error:'
  write(LF,*) ' Root you are looking for is not reachable within'
  write(LF,*) ' the selected active space.'
  write(LF,*) ' Try to select a bigger active space!'
  write(LF,*) ' Root selected by user = ',lRootSplit
  write(LF,*) ' Root reachable = ',nConf
  write(LF,*) '************************************************'
  call Quit(_RC_INPUT_ERROR_)
end if

!if (NumSplit) then
IERR = 0
if (iDimBlockA < lRootSplit) IERR = 1
if (IERR == 1) then
  write(LF,*)
  write(LF,*) '******************** ERROR **********************'
  write(LF,*) 'Input Error: AA-Block selected is too small!'
  write(LF,'(1X,A,I5)') ' Root to be optimized :',lRootSplit
  write(LF,'(1X,A,I5)') ' AA-Block dimension   :',iDimBlockA
  write(LF,*) 'AA-Block must be always equal or greater than root.'
  write(LF,*) 'In a NUSP calculation increase iDimBlockA'
  write(LF,*) 'In a ENSP calculation increase the energy-gap'
  write(LF,*) 'In a PESP calculation increase the percentage'
  write(LF,*) '*************************************************'
  call Quit(_RC_INPUT_ERROR_)
  !iDimBlockA = lRootSplit
  !ircWar = 1
  !write(LF,'(1X,A,I8)') 'iDimBlockA has been reset to =',iDimBlockA
end if

IERR = 0
if (iDimBlockA > mxDimBlockA) IERR = 1
if (IERR == 1) then
  write(LF,*)
  write(LF,*) '***************** ERROR *****************'
  write(LF,'(1X,A,I6)') 'Input Error: Max dim. BlockA exceeded',mxDimBlockA
  write(LF,*) 'iDimBlockA selected by user = ',iDimBlockA
  write(LF,*) 'If you are running a NUSP calculation, please, decrease the value of iDimBlockA!'
  write(LF,*) 'If you are running a ENSP calculation, please, decrease the energy-gap!'
  write(LF,*) 'If you are running a PESP calculation, please, decrease the percentage!'
  write(LF,*) '************************************************'
  call Quit(_RC_INPUT_ERROR_)
end if
!end If
!^ End chk over NumSplit

IERR = 0
if (ThrSplit < min_ThrSplit) IERR = 1
if (IERR == 1) then
  write(LF,*)
  write(LF,*) '***************** ERROR *****************'
  write(LF,'(1X,A,I6)') 'Input Error: ThrSplit too small'
  write(LF,'(1X,A,I6)') 'minimum value ThrSplit = ',min_ThrSplit
  write(LF,*) 'ThrSplit selected by user = ',ThrSplit
  write(LF,*) '************************************************'
  call Quit(_RC_INPUT_ERROR_)
end if

!end if

return

end subroutine ChkSplit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine trans_amfi(
cbs   makes the transformation for the ich-th index
     *coeffs, !(nolds(ith),nnew(ith)) modified contraction coefficients
     *idim1,  !  first dimension
     *idim2,  !  second dimension
     *ich,    ! index to be changed
     *nolds1,nolds2,nolds3,nolds4,  ! old dimensions
     *nnew1,nnew2,nnew3,nnew4, ! new dimensions
     *array1, ! array of size (nolds1,nolds2,nolds3,nolds4)
     *array2  ! array of size (nnew1,nnew2,nnew3,nnew4)
     *)
      implicit real*8 (a-h,o-z)
      dimension coeffs(idim1,idim2),
     *array1(nolds1,nolds2,nolds3,nolds4),
     *array2(nnew1,nnew2,nnew3,nnew4)
c     write(6,*) 'begin trans ' ,ich
c     write(6,'(8I5)') nolds1,nolds2,nolds3,nolds4,
c    *nnew1,nnew2,nnew3,nnew4
      do ind4=1,nnew4
      do ind3=1,nnew3
      do ind2=1,nnew2
      do ind1=1,nnew1
      array2(ind1,ind2,ind3,ind4)=0d0
      enddo
      enddo
      enddo
      enddo
      if (ich.eq.1) then
      do ind4=1,nnew4
      do ind3=1,nnew3
      do ind2=1,nnew2
      do ind5=1,nnew1
      do ind1=1,nolds1
      array2(ind5,ind2,ind3,ind4)=array2(ind5,ind2,ind3,ind4)+
     *coeffs(ind1,ind5)*array1(ind1,ind2,ind3,ind4)
      enddo
      enddo
      enddo
      enddo
      enddo
      elseif (ich.eq.2) then
c     write(6,*) 'transform second index '
      do ind4=1,nnew4
      do ind3=1,nnew3
      do ind5=1,nnew2
      do ind2=1,nolds2
      coeff=coeffs(ind2,ind5)
      do ind1=1,nnew1
      array2(ind1,ind5,ind3,ind4)=array2(ind1,ind5,ind3,ind4)+
     *coeff*array1(ind1,ind2,ind3,ind4)
      enddo
      enddo
      enddo
      enddo
      enddo
c     write(6,*) 'end  to transform second index '
      elseif (ich.eq.3) then
      do ind4=1,nnew4
      do ind5=1,nnew3
      do ind3=1,nolds3
      coeff=coeffs(ind3,ind5)
      do ind2=1,nnew2
      do ind1=1,nnew1
      array2(ind1,ind2,ind5,ind4)=array2(ind1,ind2,ind5,ind4)+
     *coeff*array1(ind1,ind2,ind3,ind4)
      enddo
      enddo
      enddo
      enddo
      enddo
      elseif (ich.eq.4) then
      do ind5=1,nnew4
      do ind4=1,nolds4
      coeff=coeffs(ind4,ind5)
      do ind3=1,nnew3
      do ind2=1,nnew2
      do ind1=1,nnew1
      array2(ind1,ind2,ind3,ind5)=array2(ind1,ind2,ind3,ind5)+
     *coeff*array1(ind1,ind2,ind3,ind4)
      enddo
      enddo
      enddo
      enddo
      enddo
      endif
c     write(6,*) 'end  trans '
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per-Olof Widmark                                 *
!               1986, Bjorn O. Roos                                    *
!***********************************************************************
!***********************************************************************
!                                                                      *
! WRITTEN IN 1986 BY                                                   *
! PER-OLOF WIDMARK AND BJOERN O. ROOS                                  *
! DEPARTMENT OF THEORETICAL CHEMISTRY                                  *
! UNIVERSITY OF LUND                                                   *
! SWEDEN                                                               *
!                                                                      *
!***********************************************************************

subroutine vibrotmain(ireturn)

use Vibrot_globals, only: EoutO, ifPrWf, iobs, npoint, Titobs, Vibwvs, Vibwvs1, Vibwvs2
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: ncase, ngrid, nvib, i
real(kind=wp) :: Umin, Umax, E0, dE0, Redm, Teas, Req, sc, temp
real(kind=wp) :: R(npoint+4), PotR(npoint+4)

! Logical units
! Vibwvs can be saved for later Transition moment calculations
! where it will be redefined as Vibwvs1 or Vibwvs2:
Vibwvs = 12
Vibwvs1 = Vibwvs+1
Vibwvs2 = Vibwvs+2
call Daname(Vibwvs,'VIBWVS')
call Daname(Vibwvs1,'VIBWVS1')
call Daname(Vibwvs2,'VIBWVS2')
ncase = 0
call Vibinp(ncase,ngrid,nvib,Umin,Umax,R,PotR,E0,dE0,Redm,Teas,Req,sc,temp)
select case (ncase)
  case (1)
    call Vibrot(ngrid,nvib,Umin,Umax,R,PotR,E0,dE0,Redm,Req,sc,temp)
    if (IfPrWf > 0) call PrWf_VibRot(ngrid,R)
  case (2)
    do i=1,iobs
      call Vibtrm(ngrid,Umin,Umax,Teas,R,EoutO(1,i),Titobs(i))
    end do
  case default
    write(u6,1000)
    call Quit_OnUserError()
end select
call Daclos(Vibwvs)
call Daclos(Vibwvs1)
call Daclos(Vibwvs2)
ireturn = 0

return

1000 format(/1x,'No ROVIbrational or TRANsition keywordsspecified in input.')

end subroutine Vibrotmain

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_map42(a,b,dimp,dimq,dimr,dims,dim_1,dim_2,dim_3,dim_4,p,q,r,nfact)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dimr, dims, dim_1, dim_2, dim_3, dim_4, p, q, r, nfact
real(kind=wp), intent(in) :: a(dimp,dimq,dimr,dims)
real(kind=wp), intent(out) :: b(dim_1,dim_2,dim_3,dim_4)
integer(kind=iwp) :: pp, qq, rr, ss !, indx(4)

if (nfact == 1) then

  ! factor + 1

  !do ss=1,dims
  !  indx(s) = ss
  !  do rr=1,dimr
  !    indx(r) = rr
  !    do qq=1,dimq
  !      indx(q) = qq
  !      do pp=1,dimp
  !        indx(p) = pp
  !        b(indx(1),indx(2),indx(3),indx(4)) = a(pp,qq,rr,ss)
  !      end do
  !    end do
  !  end do
  !end do

  if (p == 1) then
    !1***
    if (q == 2) then
      !12**
      if (r == 3) then
        !123* (4)
        b(1:dimp,1:dimq,1:dimr,1:dims) = a
      else
        !124* (3)
        do rr=1,dimr
          b(1:dimp,1:dimq,1:dims,rr) = a(:,:,rr,:)
        end do
      end if
    else if (q == 3) then
      !13**
      if (r == 2) then
        !132* (4)
        do qq=1,dimq
          b(1:dimp,1:dimr,qq,1:dims) = a(:,qq,:,:)
        end do
      else
        !134* (2)
        do ss=1,dims
          b(1:dimp,ss,1:dimq,1:dimr) = a(:,:,:,ss)
        end do
      end if
    else if (q == 4) then
      !14**
      if (r == 2) then
        !142* (3)
        do qq=1,dimq
          b(1:dimp,1:dimr,1:dims,qq) = a(:,qq,:,:)
        end do
      else
        !143* (2)
        do ss=1,dims
          do rr=1,dimr
            b(1:dimp,ss,rr,1:dimq) = a(:,:,rr,ss)
          end do
        end do
      end if
    end if

  else if (p == 2) then
    !2***
    if (q == 1) then
      !21**
      if (r == 3) then
        !213* (4)
        do pp=1,dimp
          b(1:dimq,pp,1:dimr,1:dims) = a(pp,:,:,:)
        end do
      else
        !214* (3)
        do rr=1,dimr
          do pp=1,dimp
            b(1:dimq,pp,1:dims,rr) = a(pp,:,rr,:)
          end do
        end do
      end if
    else if (q == 3) then
      !23**
      if (r == 1) then
        !231* (4)
        do rr=1,dimr
          b(rr,1:dimp,1:dimq,1:dims) = a(:,:,rr,:)
        end do
      else
        !234* (1)
        do ss=1,dims
          b(ss,1:dimp,1:dimq,1:dimr) = a(:,:,:,ss)
        end do
      end if
    else if (q == 4) then
      !24**
      if (r == 3) then
        !243* (1)
        do ss=1,dims
          do qq=1,dimq
            b(ss,1:dimp,1:dimr,qq) = a(:,qq,:,ss)
          end do
        end do
      else
        !241* (3)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,pp,1:dims,qq) = a(pp,qq,:,:)
          end do
        end do
      end if
    end if

  else if (p == 3) then
    !3***
    if (q == 1) then
      !31**
      if (r == 2) then
        !312* (4)
        do pp=1,dimp
          b(1:dimq,1:dimr,pp,1:dims) = a(pp,:,:,:)
        end do
      else
        !314* (2)
        do rr=1,dimr
          do pp=1,dimp
            b(1:dimq,1:dims,pp,rr) = a(pp,:,rr,:)
          end do
        end do
      end if
    else if (q == 2) then
      !32**
      if (r == 1) then
        !321* (4)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,qq,pp,1:dims) = a(pp,qq,:,:)
          end do
        end do
      else
        !324* (1)
        do ss=1,dims
          do pp=1,dimp
            b(ss,1:dimq,pp,1:dimr) = a(pp,:,:,ss)
          end do
        end do
      end if
    else if (q == 4) then
      !34**
      if (r == 1) then
        !341* (2)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,1:dims,pp,qq) = a(pp,qq,:,:)
          end do
        end do
      else
        !342* (1)
        do ss=1,dims
          do rr=1,dimr
            b(ss,rr,1:dimp,1:dimq) = a(:,:,rr,ss)
          end do
        end do
      end if
    end if

  else if (p == 4) then
    !4***
    if (q == 1) then
      !41**
      if (r == 3) then
        !413* (2)
        do ss=1,dims
          do pp=1,dimp
            b(1:dimq,ss,1:dimr,pp) = a(pp,:,:,ss)
          end do
        end do
      else
        !412* (3)
        do pp=1,dimp
          b(1:dimq,1:dimr,1:dims,pp) = a(pp,:,:,:)
        end do
      end if
    else if (q == 2) then
      !42**
      if (r == 1) then
        !421* (3)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,qq,1:dims,pp) = a(pp,qq,:,:)
          end do
        end do
      else
        !423* (1)
        do ss=1,dims
          do pp=1,dimp
            b(ss,1:dimq,1:dimr,pp) = a(pp,:,:,ss)
          end do
        end do
      end if
    else if (q == 3) then
      !43**
      if (r == 1) then
        !431* (2)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,1:dims,qq,pp) = a(pp,qq,:,:)
          end do
        end do
      else
        !432* (1)
        do rr=1,dimr
          do qq=1,dimq
            do pp=1,dimp
              b(1:dims,rr,qq,pp) = a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    end if

  end if

else

  ! factor = -1

  !do ss=1,dims
  !  indx(s) = ss
  !  do rr=1,dimr
  !    indx(r) = rr
  !    do qq=1,dimq
  !      indx(q) = qq
  !      do pp=1,dimp
  !        indx(p) = pp
  !        b(indx(1),indx(2),indx(3),indx(4)) = -a(pp,qq,rr,ss)
  !      end do
  !    end do
  !  end do
  !end do

  if (p == 1) then
    !1***
    if (q == 2) then
      !12**
      if (r == 3) then
        !123* (4)
        b(1:dimp,1:dimq,1:dimr,1:dims) = -a
      else
        !124* (3)
        do rr=1,dimr
          b(1:dimp,1:dimq,1:dims,rr) = -a(:,:,rr,:)
        end do
      end if
    else if (q == 3) then
      !13**
      if (r == 2) then
        !132* (4)
        do qq=1,dimq
          b(1:dimp,1:dimr,qq,1:dims) = -a(:,qq,:,:)
        end do
      else
        !134* (2)
        do ss=1,dims
          b(1:dimp,ss,1:dimq,1:dimr) = -a(:,:,:,ss)
        end do
      end if
    else if (q == 4) then
      !14**
      if (r == 2) then
        !142* (3)
        do qq=1,dimq
          b(1:dimp,1:dimr,1:dims,qq) = -a(:,qq,:,:)
        end do
      else
        !143* (2)
        do ss=1,dims
          do rr=1,dimr
            b(1:dimp,ss,rr,1:dimq) = -a(:,:,rr,ss)
          end do
        end do
      end if
    end if

  else if (p == 2) then
    !2***
    if (q == 1) then
      !21**
      if (r == 3) then
        !213* (4)
        do pp=1,dimp
          b(1:dimq,pp,1:dimr,1:dims) = -a(pp,:,:,:)
        end do
      else
        !214* (3)
        do rr=1,dimr
          do pp=1,dimp
            b(1:dimq,pp,1:dims,rr) = -a(pp,:,rr,:)
          end do
        end do
      end if
    else if (q == 3) then
      !23**
      if (r == 1) then
        !231* (4)
        do rr=1,dimr
          b(rr,1:dimp,1:dimq,1:dims) = -a(:,:,rr,:)
        end do
      else
        !234* (1)
        do ss=1,dims
          b(ss,1:dimp,1:dimq,1:dimr) = -a(:,:,:,ss)
        end do
      end if
    else if (q == 4) then
      !24**
      if (r == 3) then
        !243* (1)
        do ss=1,dims
          do qq=1,dimq
            b(ss,1:dimp,1:dimr,qq) = -a(:,qq,:,ss)
          end do
        end do
      else
        !241* (3)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,pp,1:dims,qq) = -a(pp,qq,:,:)
          end do
        end do
      end if
    end if

  else if (p == 3) then
    !3***
    if (q == 1) then
      !31**
      if (r == 2) then
        !312* (4)
        do pp=1,dimp
          b(1:dimq,1:dimr,pp,1:dims) = -a(pp,:,:,:)
        end do
      else
        !314* (2)
        do rr=1,dimr
          do pp=1,dimp
            b(1:dimq,1:dims,pp,rr) = -a(pp,:,rr,:)
          end do
        end do
      end if
    else if (q == 2) then
      !32**
      if (r == 1) then
        !321* (4)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,qq,pp,1:dims) = -a(pp,qq,:,:)
          end do
        end do
      else
        !324* (1)
        do ss=1,dims
          do pp=1,dimp
            b(ss,1:dimq,pp,1:dimr) = -a(pp,:,:,ss)
          end do
        end do
      end if
    else if (q == 4) then
      !34**
      if (r == 1) then
        !341* (2)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,1:dims,pp,qq) = -a(pp,qq,:,:)
          end do
        end do
      else
        !342* (1)
        do ss=1,dims
          do rr=1,dimr
            b(ss,rr,1:dimp,1:dimq) = -a(:,:,rr,ss)
          end do
        end do
      end if
    end if

  else if (p == 4) then
    !4***
    if (q == 1) then
      !41**
      if (r == 3) then
        !413* (2)
        do ss=1,dims
          do pp=1,dimp
            b(1:dimq,ss,1:dimr,pp) = -a(pp,:,:,ss)
          end do
        end do
      else
        !412* (3)
        do pp=1,dimp
          b(1:dimq,1:dimr,1:dims,pp) = -a(pp,:,:,:)
        end do
      end if
    else if (q == 2) then
      !42**
      if (r == 1) then
        !421* (3)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,qq,1:dims,pp) = -a(pp,qq,:,:)
          end do
        end do
      else
        !423* (1)
        do ss=1,dims
          do pp=1,dimp
            b(ss,1:dimq,1:dimr,pp) = -a(pp,:,:,ss)
          end do
        end do
      end if
    else if (q == 3) then
      !43**
      if (r == 1) then
        !431* (2)
        do qq=1,dimq
          do pp=1,dimp
            b(1:dimr,1:dims,qq,pp) = -a(pp,qq,:,:)
          end do
        end do
      else
        !432* (1)
        do rr=1,dimr
          do qq=1,dimq
            do pp=1,dimp
              b(1:dims,rr,qq,pp) = -a(pp,qq,rr,:)
            end do
          end do
        end do
      end if
    end if

  end if

end if

return

end subroutine cct3_map42

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Bingbing Suo                                     *
************************************************************************
c 26 feb 2007 -bsuo- revised by suo bing for multi-root calculation
c***********************************************************
      subroutine gdv_sequence_extspace(ilw,irw)
c***********************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
c      write(6,*) '  dv_test ','  vd_test '

      ! mrpt2
      if(log_prod.eq.3) then
        call gdv_sequence_extspace_pt(ilw,irw)
        return
      endif

      do irot=1,mcroot
        irtidx=indx(irot)
        mm=ilw+irtidx
        nn=irw+1+irtidx
        valuelp=vector2(nn)
        valuelptmp1=vector1(nn)
        do iij=1,ilsegdownwei
          vlptmp=value_lpext(iij)
          mm=mm+1
          vector2(mm)=vector2(mm)+valuelptmp1*vlptmp
          valuelp=valuelp+vector1(mm)*vlptmp
          !if(mm.eq.86.and.nn.eq.5) then
          !  write(6,*) "dv_test 1 ",vlptmp,vector2(mm)
          !endif
          !if(mm.eq.5.and.nn.eq.86) then
          !  write(6,*) "dv_test 2 ",valuelp,vector2(nn)
          !endif
        enddo
        vector2(nn)=valuelp
      enddo
      end

      subroutine gdv_sequence_extspace_pt(ilw,irw)  !log_prod=
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "pl_structure_h.fh"
      mm=ilw
      nn=irw+1
      do iij=1,ilsegdownwei
        mm=mm+1
        wl=value_lpext(iij)
        vector2(mm)=vector2(mm)+vcm(nn)*wl
!        if(jpad.eq.1.and.ipae.eq.2)then
!          write(6,'(a,4i6,3f18.8)') "dv_test_pt 1 ",jpadl,ipael,mm,nn,
!     *      wl,vcm(nn),
!     *      vector2(mm)
!        endif
!        if(jpadl.eq.1.and.ipael.eq.2)then
!          write(6,'(a,4i6,3f18.8)') "dv_test_pt 2 ",jpad,ipae,mm,nn,
!     *      wl,vcm(nn),
!     *      vector2(mm)
!        endif
      enddo
      end

c********************************************************************
      subroutine gtd_sequence_extspace(iplplweiin,iplprweiin)
c********************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
      common /cont_tmp/icount_ext
      parameter (   v_sqtwo=1.414213562373095d0 )
c     write(6,*) ' td_test _1/2',' dt_test '

      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ilpvalue=0
        if ( logic_g25a ) then
          mm=iplplwei+iweista_g25-1
          nn0=iplprwei
          do itmp=1,nint_g25
            ilpvalue=ilpvalue+1
            vlptmp=value_lpext(ilpvalue)
            nn=nn0
            do i=1,nwei_g25
              mm=mm+1
              nn=nn+1
              vector2(mm)=vector2(mm)+vector1(nn)*vlptmp
              vector2(nn)=vector2(nn)+vector1(mm)*vlptmp
            enddo
          enddo
        elseif ( logic_g25b ) then
          mm=iplplwei+iweista_g25-1
          nn0=iplprwei
          ilpvalue=ilpvalue+1
          do itmp=2,nint_g25
            ilpvalue=ilpvalue+1
            vlptmp=value_lpext(ilpvalue)
            nn=nn0
            do i=1,itmp-1
              mm=mm+1
              nn=nn+1
              vector2(mm)=vector2(mm)+vector1(nn)*vlptmp
              vector2(nn)=vector2(nn)+vector1(mm)*vlptmp
            enddo
          enddo
          mm=iplplwei+iweista_g28-1
          nn=iplprwei
          nn=nn+1
          do itmp=2,nwei_g28
            nn=nn+1
            vlptmp=vector2(nn)
            vlptmp1=vector1(nn)
            ilpvalue=0
            do i=1,itmp-1
              ilpvalue=ilpvalue+1
              vlptmp2=-value_lpext(ilpvalue)
              mm=mm+1
              vector2(mm)=vector2(mm)+vlptmp1*vlptmp2
              vlptmp=vlptmp+vector1(mm)*vlptmp2
            enddo
            vector2(nn)=vlptmp
          enddo
        elseif ( logic_g28a ) then
          mm=iplplwei+iweista_g28-1
          nn0=iplprwei
          do nn=nn0+1,nn0+nwei_g28
            vlptmp=vector2(nn)
            vlptmp1=vector1(nn)
            ilpvalue=0
            do i=1,nint_g28
              ilpvalue=ilpvalue+1
              vlptmp2=-value_lpext(ilpvalue)
              mm=mm+1
              vector2(mm)=vector2(mm)+vlptmp1*vlptmp2
              vlptmp=vlptmp+vector1(mm)*vlptmp2
            enddo
            vector2(nn)=vlptmp
          enddo
        endif
      enddo

c...end of gtd_sequence_extspace
      end

c**************************************************************
      subroutine inn_ext_ss_loop_unpack(iplplweiin,iplprweiin)
c**************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"

c     write(6,*) ' ss_test 1/2'
      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ii=1
        if ( logic_g1415 ) then
          mm=iplplwei
          nn=iplprwei
          do i=1,idownwei_g131415
            valuelp=value_lpext(ii)
            mm=mm+1
            nn=nn+1
            vector2(mm)=vector2(mm)+vector1(nn)*valuelp
            vector2(nn)=vector2(nn)+vector1(mm)*valuelp
            ii=ii+1
          enddo
        endif

        ii0=ii
        if ( logic_g2g4a ) then
          ii=ii0
          mm0=iplplwei
          nn0=iplprwei+iwt_sm_s_ext
          mm=mm0
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp1=value_lpext(ii)
                valuelp2=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                     +vector1(nnb)*valuelp2
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                ii=ii+2
              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif
        if ( logic_g2g4b ) then
          ii=ii0
          mm0=iplprwei
          nn0=iplplwei+iwt_sm_s_ext
          mm=mm0
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp2=value_lpext(ii)
                valuelp1=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                     +vector1(nnb)*valuelp2
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                ii=ii+2
              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif
!     iaddii=(ii-ii0)/2
        ii0=ii-1

        do icle=1,2
          if ( icle.eq.1 .and. logic_g36a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta36=lpsta36a
            lpend36=lpend36a
          elseif (  icle.eq.2 .and. logic_g36b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta36=lpsta36b
            lpend36=lpend36b
          else
            goto 936
          endif
          do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
              valuetmp=value_lpext(ii)
              vector2(mm)=vector2(mm)+vector1(nn)*valuetmp
              vector2(nn)=vector2(nn)+vector1(mm)*valuetmp
              mm=mm+1
              nn=nn+1
            enddo
          enddo

936       continue

          if ( icle.eq.1 .and. logic_g35a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta35=lpsta35a
            lpend35=lpend35a
          elseif (  icle.eq.2 .and. logic_g35b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta35=lpsta35b
            lpend35=lpend35b
          else
            goto 935
          endif

          do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp
          enddo

935       continue
!     cycle

          if ( icle.eq.1 .and. logic_g34a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta34=lpsta34a
            lpend34=lpend34a
          elseif (  icle.eq.2 .and. logic_g34b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta34=lpsta34b
            lpend34=lpend34b
          else
            goto 934
          endif
          do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp
          enddo

934       continue

          ii0=ii0+nvalue_space_ss
        enddo

      enddo

c...end of inn_ext_ss_loop_unpack
      end

c********************************************************************
      subroutine inn_ext_ss_drl_loop_unpack(iplplweiin,iplprweiin)
c********************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"

c     write(6,*) ' ss_test 2/2'
      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ii=1
        if ( logic_g1415 ) then
          mm=iplplwei
          nn=iplprwei
          do i=1,idownwei_g131415
            valuelp=value_lpext(ii)
            mm=mm+1
            nn=nn+1
            vector2(mm)=vector2(mm)+vector1(nn)*valuelp
            vector2(nn)=vector2(nn)+vector1(mm)*valuelp
            ii=ii+1
          enddo
        endif

        ii0=ii
        if ( logic_g2g4a ) then
          ii=ii0
          mm0=iplplwei
          nn0=iplprwei+iwt_sm_s_ext
          mm=mm0
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp1=value_lpext(ii)
                valuelp2=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp2
     *                     +vector1(nnb)*valuelp2
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp2
                ii=ii+2
              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif

        if ( logic_g2g4b ) then
          ii=ii0
          mm0=iplprwei
          nn0=iplplwei+iwt_sm_s_ext
          mm=mm0
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp2=value_lpext(ii)
                valuelp1=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                     +vector1(nnb)*valuelp1
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp1
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                ii=ii+2
              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif
!     iaddii=(ii-ii0)/2
        ii0=ii-1

        do icle=1,2
          if ( icle.eq.1 .and. logic_g36a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta36=lpsta36a
            lpend36=lpend36a
          elseif (  icle.eq.2 .and. logic_g36b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta36=lpsta36b
            lpend36=lpend36b
          else
            goto 936
          endif
          do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
              valuetmp=value_lpext(ii)
              vector2(mm)=vector2(mm)+vector1(nn)*valuetmp
              vector2(nn)=vector2(nn)+vector1(mm)*valuetmp
              mm=mm+1
              nn=nn+1
            enddo
          enddo

936       continue

          if ( icle.eq.1 .and. logic_g35a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta35=lpsta35a
            lpend35=lpend35a
          elseif (  icle.eq.2 .and. logic_g35b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta35=lpsta35b
            lpend35=lpend35b
          else
            goto 935
          endif

          do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp
          enddo

935       continue
!     cycle

          if ( icle.eq.1 .and. logic_g34a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta34=lpsta34a
            lpend34=lpend34a
          elseif (  icle.eq.2 .and. logic_g34b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta34=lpsta34b
            lpend34=lpend34b
          else
            goto 934
          endif
          do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp
          enddo

934       continue
        enddo

      enddo

c...end of inn_ext_ss_drl_loop_unpack
      end

c********************************************************************
      subroutine inn_ext_sv_loop_unpack(ilw,irw)   !,ilsegdownwei)
c********************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(6,*) 'sv_test,   tv_test '
      if(log_prod.eq.3) then
        call inn_ext_svloop_unpack_pt(ilw,irw)
        return
      endif

      do irot=1,mcroot
        irtidx=indx(irot)
        mm=ilw+irtidx
        nn=irw+1+irtidx
        valuelp=vector2(nn)
        valuelptmp1=vector1(nn)
        do iij=1,ilsegdownwei
           mm=mm+1
           vector2(mm)=vector2(mm)+valuelptmp1*value_lpext(iij)
           valuelp=valuelp+vector1(mm)*value_lpext(iij)
        enddo
        vector2(nn)=valuelp
      enddo

c...end of inn_ext_sv_loop_unpack
      end

      subroutine inn_ext_svloop_unpack_pt(ilw,irw)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "pl_structure_h.fh"
      !character*16 loop_type
      !loop_type=' sv_test_pt, tv_test_pt'
      mm=ilw
      nn=irw+1
      do iij=1,ilsegdownwei
        mm=mm+1
        wl=value_lpext(iij)
        vector2(mm)=vector2(mm)+vcm(nn)*wl
!            vector2(mm)=vector2(mm)+vcm0(nn)*wl
!        if(mm.eq.mtest)then
!           write(nf2,'(2i5,3f18.10)')
!     :         1, nn,vcm0(nn),wl,vector2(mm-ndim_h0)
!         endif
      enddo
      end

c*******************************************************************
      subroutine inn_ext_tt_loop_unpack(iplplweiin,iplprweiin)
c*******************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(6,*) '  tt_test 1/2'


      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ii=1
        if ( logic_g1415 ) then
          mm=iplplwei
          nn=iplprwei
          do i=1,idownwei_g131415
            valuelp=value_lpext(ii)
            mm=mm+1
            nn=nn+1
            vector2(mm)=vector2(mm)+vector1(nn)*valuelp
            vector2(nn)=vector2(nn)+vector1(mm)*valuelp
            ii=ii+1
          enddo
        endif

        ii0=ii-1         !severe_error

        do icle=1,2
          if ( icle.eq.1 .and. logic_g36a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta36=lpsta36a
            lpend36=lpend36a
          elseif (  icle.eq.2 .and. logic_g36b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta36=lpsta36b
            lpend36=lpend36b
          else
            goto 936
          endif
          do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
              valuelp=value_lpext(ii)
              vector2(mm)=vector2(mm)+vector1(nn)*valuelp
              vector2(nn)=vector2(nn)+vector1(mm)*valuelp
              mm=mm+1
              nn=nn+1
            enddo
          enddo
936       continue

          if ( icle.eq.1 .and. logic_g35a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta35=lpsta35a
            lpend35=lpend35a
          elseif (  icle.eq.2 .and. logic_g35b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta35=lpsta35b
            lpend35=lpend35b
          else
            goto 935
          endif

          do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=-value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp      !severe_error_1202
          enddo
935       continue

          if ( icle.eq.1 .and. logic_g34a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta34=lpsta34a
            lpend34=lpend34a
          elseif (  icle.eq.2 .and. logic_g34b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta34=lpsta34b
            lpend34=lpend34b
          else
            goto 934
          endif
          do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              vector2(mm)=vector2(mm)+valuelptmp1*value_lpext(iij)
              valuelp=valuelp+vector1(mm)*value_lpext(iij)
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp
          enddo
934       continue
          ii0=ii0+nvalue_space_ss
        enddo

      enddo

c...end of inn_ext_tt_loop_unpack
      end

c*******************************************************************
      subroutine inn_ext_ts_loop_unpack(iplplweiin,iplprweiin)
c*******************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(6,*) '  ts_test 1/2 '

      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ii=1
        if ( logic_g1415 ) then
          mm=iplplwei
          nn=iplprwei
          do i=1,idownwei_g131415
            valuelp=value_lpext(ii)
            mm=mm+1
            nn=nn+1
            vector2(mm)=vector2(mm)+vector1(nn)*valuelp
            vector2(nn)=vector2(nn)+vector1(mm)*valuelp
            ii=ii+1
          enddo
        endif

        ii0=ii
        if ( logic_g2g4a ) then
          ii=ii0
          mm0=iplplwei
          nn0=iplprwei+iwt_sm_s_ext
          mm=mm0            !severe_error
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp1=value_lpext(ii)
                valuelp2=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                     +vector1(nnb)*valuelp2
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                ii=ii+2

              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif
        if ( logic_g2g4b ) then
          ii=ii0
          mm0=iplprwei
          nn0=iplplwei+iwt_sm_s_ext
          mm=mm0             !severe_error
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp2=value_lpext(ii)
                valuelp1=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                     +vector1(nnb)*valuelp2
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                ii=ii+2
              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif
        ii0=ii-1         !severe_error

        do icle=1,2
          if ( icle.eq.1 .and. logic_g36a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta36=lpsta36a
            lpend36=lpend36a
          elseif (  icle.eq.2 .and. logic_g36b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta36=lpsta36b
            lpend36=lpend36b
          else
            goto 936
          endif
          do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
              vector2(mm)=vector2(mm)+vector1(nn)*value_lpext(ii)
              vector2(nn)=vector2(nn)+vector1(mm)*value_lpext(ii)
              mm=mm+1
              nn=nn+1
            enddo
          enddo
936       continue

          if ( icle.eq.1 .and. logic_g35a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta35=lpsta35a
            lpend35=lpend35a
            do iii=lpsta35,lpend35,4
              mm=mm0+lpext_wei(iii)
              nn=nn0+lpext_wei(iii+1)
              iij=ii0+lpext_wei(iii+2)
              valuelp=vector2(nn)
              valuelptmp1=vector1(nn)
              do i=1,lpext_wei(iii+3)
                valuetmp=-value_lpext(iij)
                vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
                valuelp=valuelp+vector1(mm)*valuetmp
                iij=iij+1
                mm=mm+1
              enddo
              vector2(nn)=valuelp
            enddo
          elseif (  icle.eq.2 .and. logic_g35b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta35=lpsta35b
            lpend35=lpend35b
            do iii=lpsta35,lpend35,4
              mm=mm0+lpext_wei(iii)
              nn=nn0+lpext_wei(iii+1)
              iij=ii0+lpext_wei(iii+2)
              valuelp=vector2(nn)         !severe_error
              valuelptmp1=vector1(nn)
              do i=1,lpext_wei(iii+3)
                vector2(mm)=vector2(mm)+valuelptmp1*value_lpext(iij)
                valuelp=valuelp+vector1(mm)*value_lpext(iij)
                iij=iij+1
                mm=mm+1
              enddo
              vector2(nn)=valuelp      !severe_error
            enddo
          endif

          if ( icle.eq.1 .and. logic_g34a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta34=lpsta34a
            lpend34=lpend34a
          elseif (  icle.eq.2 .and. logic_g34b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta34=lpsta34b
            lpend34=lpend34b
          else
            goto 934
          endif
          do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=-value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp      !severe_error
          enddo
934       continue
          ii0=ii0+nvalue_space_ss
        enddo
      enddo

c...end of inn_ext_ts_loop_unpack
      end

c*********************************************************************
      subroutine inn_ext_ts_drl_loop_unpack(iplplweiin,iplprweiin)
c*********************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(6,*) '  ts_test 2/2'

      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ii=1
        if ( logic_g1415 ) then
          mm=iplplwei
          nn=iplprwei
          do i=1,idownwei_g131415
            valuelp=value_lpext(ii)
            mm=mm+1
            nn=nn+1
            vector2(mm)=vector2(mm)+vector1(nn)*valuelp
            vector2(nn)=vector2(nn)+vector1(mm)*valuelp
            ii=ii+1
          enddo
        endif

        ii0=ii
        if ( logic_g2g4a ) then
           ii=ii0
           mm0=iplplwei
           nn0=iplprwei+iwt_sm_s_ext
           mm=mm0            !severe_error
           do ismb=1,ng_sm
             isma=mul_tab(ismb,ism_g2g4)
             if ( isma .gt. ismb ) cycle
               ibsta=ibsm_ext(ismb)
               ibend=iesm_ext(ismb)
               iasta=ibsm_ext(isma)
               iaend=iesm_ext(isma)
               if ( ismb .eq. isma ) ibsta=ibsta+1
               nna=nn0+ibsta-1
               do ib=ibsta,ibend
                 nna=nna+1
                 nnb=nn0+iasta-1
                 valuelptmp1=vector1(nna)
                 valuelptmp2=vector2(nna)
                 do ia=iasta,min(iaend,ib-1)
                   valuelp1=value_lpext(ii)
                   valuelp2=value_lpext(ii+1)
                   mm=mm+1
                   nnb=nnb+1
                   vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                        +vector1(nnb)*valuelp2
                   vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                   valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                   ii=ii+2
                enddo
                vector2(nna)=valuelptmp2
              enddo
            enddo
          endif

          if ( logic_g2g4b ) then
            ii=ii0
            mm0=iplprwei
            nn0=iplplwei+iwt_sm_s_ext
            mm=mm0             !severe_error
            do ismb=1,ng_sm
              isma=mul_tab(ismb,ism_g2g4)
              if ( isma .gt. ismb ) cycle
              ibsta=ibsm_ext(ismb)
              ibend=iesm_ext(ismb)
              iasta=ibsm_ext(isma)
              iaend=iesm_ext(isma)
              if ( ismb .eq. isma ) ibsta=ibsta+1
              nna=nn0+ibsta-1
              do ib=ibsta,ibend
                nna=nna+1
                nnb=nn0+iasta-1
                valuelptmp1=vector1(nna)
                valuelptmp2=vector2(nna)
                do ia=iasta,min(iaend,ib-1)
                  valuelp2=value_lpext(ii)
                  valuelp1=value_lpext(ii+1)
                  mm=mm+1
                  nnb=nnb+1
                  vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                       +vector1(nnb)*valuelp2
                  vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                  valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                  ii=ii+2
                enddo
                vector2(nna)=valuelptmp2
              enddo
            enddo
          endif

          ii0=ii-1         !severe_error

          do icle=1,2
            if ( icle.eq.1 .and. logic_g36a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta36=lpsta36a
            lpend36=lpend36a
          elseif (  icle.eq.2 .and. logic_g36b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta36=lpsta36b
            lpend36=lpend36b
          else
            goto 936
          endif
          do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
              vector2(mm)=vector2(mm)+vector1(nn)*value_lpext(ii)
              vector2(nn)=vector2(nn)+vector1(mm)*value_lpext(ii)
              mm=mm+1
              nn=nn+1
            enddo
          enddo
936       continue

          if ( icle.eq.1 .and. logic_g35a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta35=lpsta35a
            lpend35=lpend35a
            do iii=lpsta35,lpend35,4
              mm=mm0+lpext_wei(iii)
              nn=nn0+lpext_wei(iii+1)
              iij=ii0+lpext_wei(iii+2)
              valuelp=vector2(nn)
              valuelptmp1=vector1(nn)
              do i=1,lpext_wei(iii+3)
                valuetmp=-value_lpext(iij)
                vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
                valuelp=valuelp+vector1(mm)*valuetmp
                iij=iij+1
                mm=mm+1
              enddo
              vector2(nn)=valuelp
            enddo
          elseif (  icle.eq.2 .and. logic_g35b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta35=lpsta35b
            lpend35=lpend35b
            do iii=lpsta35,lpend35,4
              mm=mm0+lpext_wei(iii)
              nn=nn0+lpext_wei(iii+1)
              iij=ii0+lpext_wei(iii+2)
              valuelp=vector2(nn)         !severe_error
              valuelptmp1=vector1(nn)
              do i=1,lpext_wei(iii+3)
                vector2(mm)=vector2(mm)+valuelptmp1*value_lpext(iij)
                valuelp=valuelp+vector1(mm)*value_lpext(iij)
                iij=iij+1
                mm=mm+1
              enddo
              vector2(nn)=valuelp      !severe_error
            enddo
          endif

          if ( icle.eq.1 .and. logic_g34a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta34=lpsta34a
            lpend34=lpend34a
          elseif (  icle.eq.2 .and. logic_g34b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta34=lpsta34b
            lpend34=lpend34b
          else
            goto 934
          endif
          do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=-value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp      !severe_error
          enddo
934       continue
        enddo

      enddo

c...end of inn_ext_ts_drl_loop_unpack
      end

c*****************************************************************
      subroutine inn_ext_st_loop_unpack(iplplweiin,iplprweiin)
c*****************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(6,*) ' st_test 1/2'

      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ii=1
        if ( logic_g1415 ) then
          mm=iplplwei
          nn=iplprwei
          do i=1,idownwei_g131415
            valuelp=value_lpext(ii)
            mm=mm+1
            nn=nn+1
            vector2(mm)=vector2(mm)+vector1(nn)*valuelp
            vector2(nn)=vector2(nn)+vector1(mm)*valuelp
            ii=ii+1
          enddo
        endif

c      write(6,*)'st_g2g4a',iplplwei,iplprwei,vector2(137)
        ii0=ii
        if ( logic_g2g4a ) then
          ii=ii0
          mm0=iplplwei
          nn0=iplprwei+iwt_sm_s_ext
          mm=mm0            !severe_error
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp1=value_lpext(ii)
                valuelp2=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                     +vector1(nnb)*valuelp2
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                ii=ii+2
              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif
c      write(6,*)'st_g2g4b',iplplwei,iplprwei,vector2(137)
        if ( logic_g2g4b ) then
          ii=ii0
          mm0=iplprwei
          nn0=iplplwei+iwt_sm_s_ext
          mm=mm0             !severe_error
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp2=value_lpext(ii)
                valuelp1=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                     +vector1(nnb)*valuelp2
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                ii=ii+2
              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif
        ii0=ii-1

c      write(6,*)'st_g36a',iplplwei,iplprwei,vector2(137)
        do icle=1,2
          if ( icle.eq.1 .and. logic_g36a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta36=lpsta36a
            lpend36=lpend36a
          elseif (  icle.eq.2 .and. logic_g36b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta36=lpsta36b
            lpend36=lpend36b
          else
            goto 936
          endif
          do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
              vector2(mm)=vector2(mm)+vector1(nn)*value_lpext(ii)
              vector2(nn)=vector2(nn)+vector1(mm)*value_lpext(ii)
              mm=mm+1
              nn=nn+1
            enddo
          enddo
936       continue

c      write(6,*)'st_g35a',iplplwei,iplprwei,vector2(137)
          if ( icle.eq.1 .and. logic_g35a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta35=lpsta35a
            lpend35=lpend35a
            do iii=lpsta35,lpend35,4
              mm=mm0+lpext_wei(iii)
              nn=nn0+lpext_wei(iii+1)
              iij=ii0+lpext_wei(iii+2)
              valuelp=vector2(nn)
              valuelptmp1=vector1(nn)
              do i=1,lpext_wei(iii+3)
                valtmp=value_lpext(iij)
                vector2(mm)=vector2(mm)+valuelptmp1*valtmp
                valuelp=valuelp+vector1(mm)*valtmp
                iij=iij+1
                mm=mm+1
              enddo
              vector2(nn)=valuelp
            enddo
          elseif (  icle.eq.2 .and. logic_g35b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta35=lpsta35b
            lpend35=lpend35b
            do iii=lpsta35,lpend35,4
              mm=mm0+lpext_wei(iii)
              nn=nn0+lpext_wei(iii+1)
              iij=ii0+lpext_wei(iii+2)
              valuelp=vector2(nn)
              valuelptmp1=vector1(nn)
              do i=1,lpext_wei(iii+3)
                valtmp=-value_lpext(iij)
                vector2(mm)=vector2(mm)+valuelptmp1*valtmp
                valuelp=valuelp+vector1(mm)*valtmp
                iij=iij+1
                mm=mm+1
              enddo
              vector2(nn)=valuelp      !severe_error
            enddo
          endif

c      write(6,*)'st_g34',iplplwei,iplprwei,vector2(137)
          if ( icle.eq.1 .and. logic_g34a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta34=lpsta34a
            lpend34=lpend34a
          elseif (  icle.eq.2 .and. logic_g34b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta34=lpsta34b
            lpend34=lpend34b
          else
            goto 934
          endif
          do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=-value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp
          enddo
934       continue
          ii0=ii0+nvalue_space_ss
        enddo

      enddo

c...end of inn_ext_st_loop_unpack
      end

c*******************************************************************
      subroutine inn_ext_st_drl_loop_unpack(iplplweiin,iplprweiin)
c*******************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
c     write(6,*) ' st_test 2/2'

      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ii=1
        if ( logic_g1415 ) then
          mm=iplplwei
          nn=iplprwei
          do i=1,idownwei_g131415
            valuelp=value_lpext(ii)
            mm=mm+1
            nn=nn+1
            vector2(mm)=vector2(mm)+vector1(nn)*valuelp
            vector2(nn)=vector2(nn)+vector1(mm)*valuelp
            ii=ii+1
          enddo
        endif

        ii0=ii
        if ( logic_g2g4a ) then
          ii=ii0
          mm0=iplplwei
          nn0=iplprwei+iwt_sm_s_ext
          mm=mm0            !severe_error
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp1=value_lpext(ii)
                valuelp2=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                     +vector1(nnb)*valuelp2
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                ii=ii+2
              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif
        if ( logic_g2g4b ) then
          ii=ii0
          mm0=iplprwei
          nn0=iplplwei+iwt_sm_s_ext
          mm=mm0             !severe_error
          do ismb=1,ng_sm
            isma=mul_tab(ismb,ism_g2g4)
            if ( isma .gt. ismb ) cycle
            ibsta=ibsm_ext(ismb)
            ibend=iesm_ext(ismb)
            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) ibsta=ibsta+1
            nna=nn0+ibsta-1
            do ib=ibsta,ibend
              nna=nna+1
              nnb=nn0+iasta-1
              valuelptmp1=vector1(nna)
              valuelptmp2=vector2(nna)
              do ia=iasta,min(iaend,ib-1)
                valuelp2=value_lpext(ii)
                valuelp1=value_lpext(ii+1)
                mm=mm+1
                nnb=nnb+1
                vector2(mm)=vector2(mm)+valuelptmp1*valuelp1
     *                     +vector1(nnb)*valuelp2
                vector2(nnb)=vector2(nnb)+vector1(mm)*valuelp2
                valuelptmp2=valuelptmp2+vector1(mm)*valuelp1
                ii=ii+2
              enddo
              vector2(nna)=valuelptmp2
            enddo
          enddo
        endif
        ii0=ii-1

        do icle=1,2
          if ( icle.eq.1 .and. logic_g36a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta36=lpsta36a
            lpend36=lpend36a
          elseif (  icle.eq.2 .and. logic_g36b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta36=lpsta36b
            lpend36=lpend36b
          else
            goto 936
          endif
          do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
              valuetmp=value_lpext(ii)
              vector2(mm)=vector2(mm)+vector1(nn)*valuetmp
              vector2(nn)=vector2(nn)+vector1(mm)*valuetmp
              mm=mm+1
              nn=nn+1
            enddo
          enddo
936       continue
          if ( icle.eq.1 .and. logic_g35a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta35=lpsta35a
            lpend35=lpend35a
            do iii=lpsta35,lpend35,4
              mm=mm0+lpext_wei(iii)
              nn=nn0+lpext_wei(iii+1)
              iij=ii0+lpext_wei(iii+2)
              valuelp=vector2(nn)
              valuelptmp1=vector1(nn)
              do i=1,lpext_wei(iii+3)
                valuetmp=value_lpext(iij)
                vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
                valuelp=valuelp+vector1(mm)*valuetmp
                iij=iij+1
                mm=mm+1
              enddo
              vector2(nn)=valuelp
            enddo
          elseif (  icle.eq.2 .and. logic_g35b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta35=lpsta35b
            lpend35=lpend35b
            do iii=lpsta35,lpend35,4
              mm=mm0+lpext_wei(iii)
              nn=nn0+lpext_wei(iii+1)
              iij=ii0+lpext_wei(iii+2)
              valuelp=vector2(nn)         !severe_error
              valuelptmp1=vector1(nn)
              do i=1,lpext_wei(iii+3)
                valuetmp=-value_lpext(iij)
                vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
                valuelp=valuelp+vector1(mm)*valuetmp
                iij=iij+1
                mm=mm+1
              enddo
              vector2(nn)=valuelp      !severe_error
            enddo
          endif

          if ( icle.eq.1 .and. logic_g34a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta34=lpsta34a
            lpend34=lpend34a
          elseif (  icle.eq.2 .and. logic_g34b ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta34=lpsta34b
            lpend34=lpend34b
          else
            goto 934
          endif
          do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=-value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp
          enddo
934       continue
        enddo
      enddo

c...end of inn_ext_st_drl_loop_unpack
      end


c**************************************************************
      subroutine gsd_sequence_extspace(iplplweiin,iplprweiin)
c**************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
      parameter (v_sqtwo=1.414213562373095d0 )
c      write(6,*) '  sd_test 1/2','  ds_test 011'

      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx
        ilpvalue=0
        if ( logic_g25a ) then
          mm=iplplwei+iweista_g25-1
          nn0=iplprwei
          do itmp=1,nint_g25
            ilpvalue=ilpvalue+1
            vlptmp=value_lpext(ilpvalue)
            nn=nn0
            do i=1,nwei_g25
              mm=mm+1
              nn=nn+1
              vector2(mm)=vector2(mm)+vector1(nn)*vlptmp
              vector2(nn)=vector2(nn)+vector1(mm)*vlptmp
            enddo
          enddo
        elseif ( logic_g25b ) then
          mm=iplplwei+iweista_g25-1
          nn0=iplprwei
          ilpvalue=ilpvalue+1
          do itmp=2,nint_g25
            ilpvalue=ilpvalue+1
            vlptmp=value_lpext(ilpvalue)
            nn=nn0
            do i=1,itmp-1
              mm=mm+1
              nn=nn+1
              vector2(mm)=vector2(mm)+vector1(nn)*vlptmp
              vector2(nn)=vector2(nn)+vector1(mm)*vlptmp
            enddo
          enddo

          mm=iplplwei+iweista_g28-1
          nn=iplprwei
          nn=nn+1
          do itmp=2,nwei_g28
            nn=nn+1
            vlptmp=vector2(nn)
            vlptmp1=vector1(nn)
            ilpvalue=0
            do i=1,itmp-1
              ilpvalue=ilpvalue+1
              vtmp=value_lpext(ilpvalue)
              mm=mm+1
              vector2(mm)=vector2(mm)+vlptmp1*vtmp
              vlptmp=vlptmp+vector1(mm)*vtmp
            enddo
            vector2(nn)=vlptmp
          enddo
        elseif ( logic_g28a ) then
          mm=iplplwei+iweista_g28-1
          nn0=iplprwei
          do nn=nn0+1,nn0+nwei_g28
            vlptmp=vector2(nn)
            vlptmp1=vector1(nn)
            ilpvalue=0
            do i=1,nint_g28
              ilpvalue=ilpvalue+1
              mm=mm+1
              vector2(mm)=vector2(mm)+
     *                    vlptmp1*value_lpext(ilpvalue)
              vlptmp=vlptmp+
     *               vector1(mm)*value_lpext(ilpvalue)
            enddo
            vector2(nn)=vlptmp
          enddo
        endif

        if ( logic_g26 ) then
          ilpvalue=ivaluesta_g26
          mm=iplplwei+iweista_g26
          nn0=iplprwei
          do nn=nn0+1,nn0+nwei_g26
            ilpvalue=ilpvalue+1
            vlptmp=value_lpext(ilpvalue)*v_sqtwo   !for g26
            vector2(mm)=vector2(mm)+vector1(nn)*vlptmp
            vector2(nn)=vector2(nn)+vector1(mm)*vlptmp
            mm=mm+1
          enddo
        endif
      enddo

c...end of gsd_sequence_extspace
      end

c***********************************************************************
      subroutine complete_sd_ar_ext_loop(ilweiin,irweiin,isdownwei)
c***********************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
c      write(6,*) 'sd_test 2/2','  td_test_2/2 012'


      do irot=1,mcroot
        irtidx=indx(irot)
        ilwei=ilweiin+irtidx
        irwei=irweiin+irtidx

        ilpvalue=0
        mm0=ilwei
        nn=irwei+icano_nnsta-1
        do nntmp=icano_nnsta,icano_nnend
          nn=nn+1
          mm=mm0
          vlptmp1=vector1(nn)
          vlptmp=vector2(nn)
          do mmtmp=1,isdownwei
            ilpvalue=ilpvalue+1
            mm=mm+1
            vector2(mm)=vector2(mm)+vlptmp1*value_lpext(ilpvalue)
            vlptmp=vlptmp+vector1(mm)*value_lpext(ilpvalue)
          enddo
          vector2(nn)=vlptmp
        enddo
      enddo
      return

c...end of complete_sd_ar_ext_loop
      end

c******************************************************************
      subroutine inn_ext_dd_loop_unpack(iplplweiin,iplprweiin)
c******************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
c        'dd_test '

      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ii=1
        if ( logic_g50 ) then         !arbl=.true.
          if ( logic_g49b) then
            mm=iplplwei
            nn=iplprwei
            do i=1,ildownwei_segdd
              valuelp=value_lpext(ii)
              mm=mm+1
              nn=nn+1
              vector2(mm)=vector2(mm)+vector1(nn)*valuelp
              vector2(nn)=vector2(nn)+vector1(mm)*valuelp
              ii=ii+1
            enddo
          endif

          ii=ii+int_dd_drl
          mm0=iplplwei
          nn=iplprwei+1
          do icle=1,2
            do j=2,ildownwei_segdd
              nn=nn+1
              valuelp=vector2(nn)
              valuelptmp1=vector1(nn)
              mm=mm0
              do i=1,j-1
                mm=mm+1
                valuetmp=value_lpext(ii)
                vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
                valuelp=valuelp+vector1(mm)*valuetmp
                ii=ii+1
              enddo
              vector2(nn)=valuelp
            enddo
            if ( .not. logic_g49b ) exit
            mm0=iplprwei
            nn=iplplwei+1
          enddo

        else               !drl=.true.


          ii=ii+int_dd_drl
          if ( logic_g49a ) then
            mm0=iplplwei
            nn=iplprwei
            ildownwei=ildownwei_segdd
            irdownwei=irdownwei_segdd
          else
            mm0=iplprwei
            nn=iplplwei
            ildownwei=irdownwei_segdd
            irdownwei=ildownwei_segdd
          endif
          do j=1,irdownwei
            nn=nn+1
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            mm=mm0
            do i=1,ildownwei
              mm=mm+1
              valuetmp=value_lpext(ii)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              ii=ii+1
            enddo
            vector2(nn)=valuelp
          enddo
        endif
      enddo

c...end of inn_ext_dd_loop_unpack
      end

c***********************************************************************
      subroutine inn_ext_tt_drl_loop_unpack(iplplweiin,iplprweiin,n1415)
c***********************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
#include "lpextmode_h.fh"
      logical logic_g14150,logic_g34b0,logic_g35b0,logic_g36b0
c     write(6,*) '  tt_test 2/2'

      logic_g14150=logic_g1415
      logic_g36b0=logic_g36b
      logic_g35b0=logic_g35b
      logic_g34b0=logic_g34b
      if(iplplweiin.eq.iplprweiin) then
        logic_g14150=.false.
        logic_g36b0=.false.
        logic_g35b0=.false.
        logic_g34b0=.false.
      endif

      do irot=1,mcroot
        irtidx=indx(irot)
        iplplwei=iplplweiin+irtidx
        iplprwei=iplprweiin+irtidx

        ii=1
        if ( logic_g14150 ) then
          mm=iplplwei
          nn=iplprwei
          do i=1,idownwei_g131415
            valuelp=value_lpext(ii)
            mm=mm+1
            nn=nn+1
            vector2(mm)=vector2(mm)+vector1(nn)*valuelp
            vector2(nn)=vector2(nn)+vector1(mm)*valuelp
            ii=ii+1
          enddo
        endif

        ii0=n1415         !severe_error

        do icle=1,2
          if ( icle.eq.1 .and. logic_g36a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta36=lpsta36a
            lpend36=lpend36a
          elseif (  icle.eq.2 .and. logic_g36b0 ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta36=lpsta36b
            lpend36=lpend36b
          else
            goto 936
          endif
          do iii=lpsta36,lpend36,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            ii=ii0+lpext_wei(iii+2)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            do i=1,lpext_wei(iii+3)
              valuelp=value_lpext(ii)
              vector2(mm)=vector2(mm)+vector1(nn)*valuelp
              vector2(nn)=vector2(nn)+vector1(mm)*valuelp
              mm=mm+1
              nn=nn+1
            enddo
          enddo
936       continue

          if ( icle.eq.1 .and. logic_g35a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta35=lpsta35a
            lpend35=lpend35a
          elseif (  icle.eq.2 .and. logic_g35b0 ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta35=lpsta35b
            lpend35=lpend35b
          else
            goto 935
          endif

          do iii=lpsta35,lpend35,4
            mm=mm0+lpext_wei(iii)
            nn=nn0+lpext_wei(iii+1)
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              valuetmp=-value_lpext(iij)
              vector2(mm)=vector2(mm)+valuelptmp1*valuetmp
              valuelp=valuelp+vector1(mm)*valuetmp
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp      !severe_error_1202
          enddo
935       continue

          if ( icle.eq.1 .and. logic_g34a ) then
            mm0=iplplwei
            nn0=iplprwei
            lpsta34=lpsta34a
            lpend34=lpend34a
          elseif (  icle.eq.2 .and. logic_g34b0 ) then
            mm0=iplprwei
            nn0=iplplwei
            lpsta34=lpsta34b
            lpend34=lpend34b
          else
            goto 934
          endif
          do iii=lpsta34,lpend34,4
            ilwtmp=lpext_wei(iii)
            irwtmp=lpext_wei(iii+1)
            mm=mm0+ilwtmp
            nn=nn0+irwtmp
            iij=ii0+lpext_wei(iii+2)
            valuelp=vector2(nn)
            valuelptmp1=vector1(nn)
            do i=1,lpext_wei(iii+3)
              vector2(mm)=vector2(mm)+valuelptmp1*value_lpext(iij)
              valuelp=valuelp+vector1(mm)*value_lpext(iij)
              iij=iij+1
              mm=mm+1
            enddo
            vector2(nn)=valuelp
          enddo
934       continue
        enddo
      enddo

c...end of inn_ext_tt_drl_loop_unpack
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine OptOneAngle2(ang,change,R,GD,I1,I2,Vee,G)

use Index_Functions, only: nTri_Elem
use rasscf_global, only: lRoots, NAC
use Constants, only: Zero, Three, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: ang, change
real(kind=wp), intent(inout) :: R(lRoots,lRoots), GD(nTri_Elem(lRoots),NAC,NAC), Vee(lRoots)
integer(kind=iwp), intent(in) :: I1, I2
real(kind=wp), intent(in) :: G(NAC,NAC,NAC,NAC)
integer(kind=iwp) :: IA, IMax, Itera, Itermax
real(kind=wp) :: Angles(4), ScanA(31), ScanS(31), StepSize, SumOld, SumOld2, Sums(4), Vee1, Vee2
logical(kind=iwp) :: Converged
real(kind=wp), parameter :: Threshold = 1.0e-8_wp

Converged = .false.
stepsize = Three*deg2rad

Angles(2) = Zero
do Itera=1,31
  ScanA(Itera) = (Itera-16)*stepsize*2
  call SumVeeNew(ScanS(Itera),ScanA(Itera),GD,I1,I2,G,Vee1,Vee2,.false.)
  !if (I2 == 1) write(u6,*) Iter,ScanA(Iter),ScanS(Iter)
end do

IMax = sum(maxloc(ScanS(:)))

Itera = 0
IterMax = 100
SumOld = Vee(I1)+Vee(I2)
SumOld2 = SumOld
Angles(2) = ScanA(IMax)
do while (.not. Converged)
  Itera = Itera+1
  Angles(1) = Angles(2)-stepsize
  Angles(3) = Angles(2)+stepsize
  do iA=1,3
    call SumVeeNew(Sums(iA),Angles(iA),GD,I1,I2,G,Vee1,Vee2,.false.)
  end do
  call CMSFitTrigonometric(Angles,Sums)
  call SumVeeNew(Sums(4),Angles(4),GD,I1,I2,G,Vee1,Vee2,.false.)
  change = Sums(4)-SumOld
  if (abs(change) < Threshold) then
    Converged = .true.
    Ang = Angles(4)
    Vee(I1) = Vee1
    Vee(I2) = Vee2
    call SumVeeNew(Sums(4),Ang,GD,I1,I2,G,Vee1,Vee2,.true.)
    call CMSMatRot(R,Ang,I1,I2,lRoots)
  else
    if (Itera == IterMax) then
      Converged = .true.
      write(u6,'(A,I3,A)') 'No convergence reached after ',Itera,' micro cycles'
    else
      Angles(2) = Angles(4)
      SumOld = Sums(4)
    end if
  end if
end do
change = Vee(I1)+Vee(I2)-SumOld2

end subroutine OptOneAngle2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine  ReMap_V_k(iSym,V_k,nV_k,V_k_New,nV_k_New,iSO_ab,ij2K,
     &                      m_ij2K)
      Implicit Real*8 (A-H,O-Z)
      Real*8 V_k(nV_k), V_k_New(nV_k_New)
      Integer iSym, iSO_ab(2,nV_k), ij2K(m_ij2K)
*
      If (iSym .eq. 1) Then
         Do k=1,nV_k
            i=iSO_ab(1,k)
            j=iSO_ab(2,k)
            ij=i*(i-1)/2 + j
            If (i.eq.j) Then
               V_k_New(ij) = V_k(k)
            Else
               V_k_New(ij) = 0.5D0*V_k(k)
            End If
            ij2K(ij)=k
         End Do
*
c        write(6,*) 'Triang <Vk|Vk> : ',ddot_(nV_k_New,V_k_New,1,
c     &                                               V_k_New,1)
*
      Else

         Do k=1,nV_k
            i=iSO_ab(1,k)
            j=iSO_ab(2,k)
            ij=i*(i-1)/2 + j
            ij2K(ij)=k
         End Do
      EndIf
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Francesco Aquilante                              *
************************************************************************
      SubRoutine Cho_SOSmp2_Col(Col,nDim,iCol,nCol,Buf,l_Buf)
C
C     Francesco Aquilante, May 2007.
C
C     Purpose: compute specified M(ai,bj)=(ai|bj)^2 columns.
C
#include "implicit.fh"
      Real*8  Col(nDim,nCol), Buf(l_Buf)
      Integer iCol(nCol)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"
#include "WrkSpc.fh"

      Character*3  ThisNm
      Character*14 SecNam
      Parameter (SecNam = 'Cho_SOSmp2_Col', ThisNm = 'Col')

      Logical DoClose

      If (nCol.lt.1 .or. nDim.lt.1) Return

      iSym = NowSym
      If (nDim .ne. nT1am(iSym)) Then
         Write(6,*) SecNam,': inconsistent dimension. Expected: ',
     &              nT1am(iSym),'   Received: ',nDim
         Write(6,*) SecNam,': symmetry from chomp2_dec.fh: ',iSym
         Call ChoMP2_Quit(SecNam,'inconsistent dimension',' ')
      End If

      If (NumCho(iSym) .lt. 1) Then
         Call Cho_dZero(Col,nDim*nCol)
         Return
      End If

      irc = 0

      If (InCore(iSym)) Then  ! old vectors available in core

         Fac = 0.0D0
         Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                        Work(ip_OldVec),NumCho(iSym),
     &                        Buf,l_Buf,Fac,irc)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_Col_Comp returned ',irc
            Call ChoMP2_Quit(SecNam,'ChoMP2_Col_Comp error','[1]')
         End If

      Else ! old vectors must be read on disk

         DoClose = .false.
         If (lUnit_F(iSym,1) .lt. 1) Then
            Call ChoMP2_OpenF(1,1,iSym)
            DoClose = .true.
         End If

         Call GetMem('MaxCol','Max ','Real',ipWrk,lWrk)

         If (l_Buf .gt. lWrk) Then ! use Buf as work space

            nVec = min(l_Buf/(nDim+1),NumCho(iSym))
            If (nVec .lt. 1) Then
               Write(6,*) SecNam,': insufficient memory for batch!'
               Call ChoMP2_Quit(SecNam,'insufficient memory','[1]')
               nBat = 0
            Else
               nBat = (NumCho(iSym) - 1)/nVec + 1
            End If

            Do iBat = 1,nBat

               If (iBat .eq. nBat) Then
                  NumV = NumCho(iSym) - nVec*(nBat - 1)
               Else
                  NumV = nVec
               End If
               iVec1 = nVec*(iBat - 1) + 1

               iOpt = 2
               lTot = nDim*NumV
               iAdr = nDim*(iVec1 - 1) + 1
               Call ddaFile(lUnit_F(iSym,1),iOpt,Buf(1),lTot,iAdr)

               If (iBat .eq. 1) Then
                  Fac = 0.0D0
               Else
                  Fac = 1.0D0
               End If

               lScr = l_Buf - lTot
               If (lWrk .gt. lScr) Then
                  lWsav = lWrk
                  Call GetMem('ColScr','Allo','Real',ipWrk,lWrk)
                  Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                                 Buf(1),NumV,
     &                                 Work(ipWrk),lWrk,Fac,irc)
                  Call GetMem('ColScr','Free','Real',ipWrk,lWrk)
                  lWrk = lWsav
               Else
                  Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                                 Buf(1),NumV,
     &                                 Buf(1+lTot),lScr,Fac,irc)
               End If
               If (irc .ne. 0) Then
                  Write(6,*) SecNam,': ChoMP2_Col_Comp returned ',irc
                  Call ChoMP2_Quit(SecNam,'ChoMP2_Col_Comp error','[2]')
               End If

            End Do

         Else ! use Work as work space

            Call GetMem('ColWrk','Allo','Real',ipWrk,lWrk)

            nVec = min(lWrk/nDim,NumCho(iSym))
            If (nVec .lt. 1) Then
               Write(6,*) SecNam,': insufficient memory for batch!'
               Call ChoMP2_Quit(SecNam,'insufficient memory','[2]')
               nBat = 0
            Else
               nBat = (NumCho(iSym) - 1)/nVec + 1
            End If

            Do iBat = 1,nBat

               If (iBat .eq. nBat) Then
                  NumV = NumCho(iSym) - nVec*(nBat - 1)
               Else
                  NumV = nVec
               End If
               iVec1 = nVec*(iBat - 1) + 1

               iOpt = 2
               lTot = nDim*NumV
               iAdr = nDim*(iVec1 - 1) + 1
               Call ddaFile(lUnit_F(iSym,1),iOpt,Work(ipWrk),lTot,iAdr)

               If (iBat .eq. 1) Then
                  Fac = 0.0D0
               Else
                  Fac = 1.0D0
               End If

               lScr = lWrk - lTot
               If (l_Buf .gt. lScr) Then
                  Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                                 Work(ipWrk),NumV,
     &                                 Buf(1),l_Buf,Fac,irc)
               Else
                  Call ChoMP2_Col_Comp(Col,nDim,iCol,nCol,
     &                                 Work(ipWrk),NumV,
     &                                 Work(ipWrk+lTot),lScr,Fac,irc)
               End If
               If (irc .ne. 0) Then
                  Write(6,*) SecNam,': ChoMP2_Col_Comp returned ',irc
                  Call ChoMP2_Quit(SecNam,'ChoMP2_Col_Comp error','[3]')
               End If

            End Do

            Call GetMem('ColWrk','Free','Real',ipWrk,lWrk)

         End If

         If (DoClose) Then
            Call ChoMP2_OpenF(2,1,iSym)
            DoClose = .false.
         End If

      End If

C     Squaring each element of the integral columns
C     ---------------------------------------------
      Do jCol=1,nCol
         Do ia=1,nDim
            Col(ia,jCol)=Col(ia,jCol)**2
         End Do
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine divfok (wrk,wrksize,
     & mapdfa,mapifa,possfa0,mapdfb,mapifb,possfb0,
     & mapdfk1,mapifk1,possfk10,mapdfk2,mapifk2,possfk20,
     & mapdfk3,mapifk3,possfk30,mapdfk4,mapifk4,possfk40,
     & mapdfk5,mapifk5,possfk50,mapdfk6,mapifk6,possfk60,
     & mapddp1,mapidp1,possdp10,mapddp2,mapidp2,possdp20,rc)
c
c     this routine divide fok(p,q) -> fk(a,b) + fk(a,i) + f(i,j) + dp(p)
c     to diagonal part and rest
c
c     mapd and mapi for:
c     fa,fb - fok(p,q)aa,bb
c     fk1-6 - f(ab)aa,f(ab)bb,f(ai)aa,f(ai)bb,f(ij)aa,f(ij)bb
c     dp1,2 - diagonal part dp(p)a,b
c     rc    - return (error) code
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer rc
c
c1    maps for FOKA,FOKB
c
       integer mapdfa(0:512,1:6)
       integer mapifa(1:8,1:8,1:8)
       integer possfa0
c
       integer mapdfb(0:512,1:6)
       integer mapifb(1:8,1:8,1:8)
       integer possfb0
c
c2    maps for FK
c     FK1 - f(a,b)aa
c     FK2 - f(a,b)bb
c     FK3 - f(a,i)aa
c     FK4 - f(a,i)bb
c     FK5 - f(i,j)aa
c     FK6 - f(i,j)bb
c
       integer mapdfk1(0:512,1:6)
       integer mapifk1(1:8,1:8,1:8)
       integer possfk10
c
       integer mapdfk2(0:512,1:6)
       integer mapifk2(1:8,1:8,1:8)
       integer possfk20
c
       integer mapdfk3(0:512,1:6)
       integer mapifk3(1:8,1:8,1:8)
       integer possfk30
c
       integer mapdfk4(0:512,1:6)
       integer mapifk4(1:8,1:8,1:8)
       integer possfk40
c
       integer mapdfk5(0:512,1:6)
       integer mapifk5(1:8,1:8,1:8)
       integer possfk50
c
       integer mapdfk6(0:512,1:6)
       integer mapifk6(1:8,1:8,1:8)
       integer possfk60
c
c
c3    maps for DP - diagonal part
c     DP1 - dp(p)a
c     DP2 - dp(p)b
c
       integer mapddp1(0:512,1:6)
       integer mapidp1(1:8,1:8,1:8)
       integer possdp10
c
       integer mapddp2(0:512,1:6)
       integer mapidp2(1:8,1:8,1:8)
       integer possdp20
c
c     help variables
c
       integer symp,rc1
       integer iifoka,iifokb,iifok,iifaa,iifai,iifii,iidpa,iidpb,iidp
       integer possfoka,possfokb,possfok,possfaa,possfai,possfii
       integer possdpa,possdpb,possdp
c
       rc=0
c
c1    define dp
c
       do 500 symp=1,nsym
c
       iidpa=mapidp1(symp,1,1)
       possdpa=mapddp1(iidpa,1)
       iidpb=mapidp2(symp,1,1)
       possdpb=mapddp2(iidpb,1)
       iifoka=mapifa(symp,1,1)
       possfoka=mapdfa(iifoka,1)
       iifokb=mapifb(symp,1,1)
       possfokb=mapdfb(iifokb,1)
c
       if (norb(symp).gt.0) then
       call fokunpck5 (symp,wrk(possfoka),wrk(possfokb),
     & wrk(possdpa),wrk(possdpb),norb(symp),rc1)
       end if
c
 500    continue
c
c2    define faa,fai,fii
c
       do 1000 symp=1,nsym
       if (norb(symp).eq.0) goto 1000
c
c2.1  alpha case
c
       iifok=mapifa(symp,1,1)
       iifaa=mapifk1(symp,1,1)
       iifai=mapifk3(symp,1,1)
       iifii=mapifk5(symp,1,1)
       iidp=mapidp1(symp,1,1)
c
       possfok=mapdfa(iifok,1)
       possfaa=mapdfk1(iifaa,1)
       possfai=mapdfk3(iifai,1)
       possfii=mapdfk5(iifii,1)
       possdp=mapddp1(iidp,1)
c
       call fokunpck1 (wrk(possfok),wrk(possdp),norb(symp))
       if (nva(symp).gt.0) then
       call fokunpck2 (wrk(possfok),wrk(possfaa),norb(symp),nva(symp),
     &                 noa(symp))
       end if
       if ((noa(symp)*nva(symp)).gt.0) then
       call fokunpck3 (wrk(possfok),wrk(possfai),norb(symp),nva(symp),
     &                 noa(symp))
       end if
       if (noa(symp).gt.0) then
       call fokunpck4 (wrk(possfok),wrk(possfii),norb(symp),noa(symp))
       end if
c
c2.2  alpha case
c
       iifok=mapifb(symp,1,1)
       iifaa=mapifk2(symp,1,1)
       iifai=mapifk4(symp,1,1)
       iifii=mapifk6(symp,1,1)
       iidp=mapidp2(symp,1,1)
c
       possfok=mapdfb(iifok,1)
       possfaa=mapdfk2(iifaa,1)
       possfai=mapdfk4(iifai,1)
       possfii=mapdfk6(iifii,1)
       possdp=mapddp2(iidp,1)
c
       call fokunpck1 (wrk(possfok),wrk(possdp),norb(symp))
       if (nvb(symp).gt.0) then
       call fokunpck2 (wrk(possfok),wrk(possfaa),norb(symp),nvb(symp),
     &                 nob(symp))
       end if
       if ((nob(symp)*nvb(symp)).gt.0) then
       call fokunpck3 (wrk(possfok),wrk(possfai),norb(symp),nvb(symp),
     &                 nob(symp))
       end if
       if (nob(symp).gt.0) then
       call fokunpck4 (wrk(possfok),wrk(possfii),norb(symp),nob(symp))
       end if
c
 1000   continue
c
       return
c Avoid unused argument warnings
       if (.false.) then
         call Unused_integer(possfa0)
         call Unused_integer(possfb0)
         call Unused_integer(possfk10)
         call Unused_integer(possfk20)
         call Unused_integer(possfk30)
         call Unused_integer(possfk40)
         call Unused_integer(possfk50)
         call Unused_integer(possfk60)
         call Unused_integer(possdp10)
         call Unused_integer(possdp20)
       end if
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_Energy(irc,EMP2,EOcc,EVir,Sorted,DelOrig)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: compute MP2 energy correction from MO Cholesky vectors,
C              constructing (ai|bj) integrals on the fly. Flag Sorted
C              refers to whether or not the MO vectors have been sorted
C              into the sizes of the batches over occupied orbitals.
C
      Implicit None
      Real*8  EMP2
      Real*8  EOcc(*), EVir(*)
      Integer irc
      Logical Sorted, DelOrig
#include "chomp2.fh"
#include "chomp2_cfg.fh"
#include "WrkSpc.fh"

      Character*6  ThisNm
      Character*13 SecNam
      Parameter (SecNam = 'ChoMP2_Energy', ThisNm = 'Energy')

      Integer ipWrk, lWrk

      irc = 0

      Call GetMem('GetMax','Max ','Real',ipWrk,lWrk)
      Call GetMem('GetMax','Allo','Real',ipWrk,lWrk)

      If (Sorted) Then
         Call ChoMP2_Energy_Srt(irc,DelOrig,EMP2,EOcc,EVir,
     &                          Work(ipWrk),lWrk)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_Energy_Srt returned ',irc
            Go To 1 ! exit
         End If
      Else
         If (nBatch .eq. 1) Then
            Call ChoMP2_Energy_Fll(irc,DelOrig,EMP2,EOcc,EVir,
     &                             Work(ipWrk),lWrk)
            If (irc .ne. 0) Then
               Write(6,*) SecNam,': ChoMP2_Energy_Fll returned ',irc
               Go To 1 ! exit
            End If
         Else
            Call ChoMP2_Energy_Org(irc,DelOrig,EMP2,EOcc,EVir,
     &                             Work(ipWrk),lWrk)
            If (irc .ne. 0) Then
               Write(6,*) SecNam,': ChoMP2_Energy_Org returned ',irc
               Go To 1 ! exit
            End If
         End If
      End If

    1 Call GetMem('GetMax','Free','Real',ipWrk,lWrk)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
************************************************************************
*                                                                      *
* PER SIEGBAHN                                                         *
* DEPARTMENT OF THEORETICAL PHYSICS                                    *
* UNIVERSITY OF STOCKHOLM                                              *
* SWEDEN                                                               *
*                                                                      *
* UPDATED FOR MOLCAS-4 BY P-A MALMQVIST & NIGEL MORIARTY 1996          *
************************************************************************
      SUBROUTINE GUGA(IRETURN)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "WrkSpc.fh"
#include "real_guga.fh"
#include "integ.fh"
#include "files_guga.fh"
      COMMON/CNSTS/D0,D1,D2
#include "addr_guga.fh"
      COMMON/D/JNDX(500 000)
*      DIMENSION JSYM(30000),SO(1 000 000),JSY(3000)
      DIMENSION JSYM(30000),JSY(3000)
      DIMENSION L0(4*MXVERT),L1(4*MXVERT),L2(4*MXVERT),L3(4*MXVERT)
*
*     Prologue
*
* Allocate workspace through GETMEM:
* PAM Aug -06: Get rid of fixed upper limit of workspace
* PAM      NCOR=1 000 000
* PAM      Call GETMEM('SOArr','Allo','Real',LSOArr,NCOR)
* Replace by: Find max possible allocatable
      Call GETMEM('SOArr','Max','Inte',LDummy,NCOR)
* Grab almost all of it, but leave a little to be safe:
      NCOR=NCOR-100000
      Call GETMEM('SOArr','Allo','Inte',LSOArr,NCOR)
*     Call SetQue('Trace=On')
      CALL SETTIM
      CALL XUFLOW
      CALL ERRSET(208,256,-1,1,1,208)
      CALL ERRSET(151,256,-1,1,1,151)
      CALL JTIME(IST)
*
*     Print program header
*
*
*     Initialize files
*
      Lu_11=11
      CALL DANAME_wa(Lu_11,'TEMP01')
      Lu_10=10
      CALL DANAME(Lu_10,'CIGUGA')
      DO 5 I=1,9
         IAD10(I)=0
5     CONTINUE
      IADD10=0
      CALL iDAFILE(Lu_10,1,IAD10,9,IADD10)
*
*     Read input
*
      IO=5
      IW=6
      ISPA=NCOR
      LIX=500 000
      NBUF=600
CPAM96: Use variable MCOP, size of buffers:
      MCOP=NBUF*RTOI+NBUF+1
      D0=0.0d0
      D1=1.0d0
      D2=2.0d0
      CALL INPUT_GUGA(iWork(LSOArr),JSYM,JSY,L0,L1,L2,L3,ISPAC)
*
*     Main body
*
C     SORT ALLOCATION , ISPAC WORDS TO BE SORTED IN NCOR CORE SPACE
C     TWO BUFFERS OF LENGTH NBINS NEEDED
C     NCOR IS IN UNITS OF FLOATING-POINT WORDS, e.g. REAL*8
C     NBINS=ISPAC/(NCORX-2*NBINS)+1
      NCORX=NCOR-(MCOP+1)
      A=D2
      B=-NCORX-2
      C=ISPAC+NCORX
      NBINS=INT((-B-SQRT(B*B-D2*D2*A*C))/(D2*A))
C     NUMBER OF WORDS IN EACH BIN
      NTPB=(ISPAC-1)/NBINS+1
C     SPACE IN CORE FOR EACH BIN
      KB=RTOI*(NCORX-2*NBINS)/NBINS
      KBUF=(KB-1)/(RTOI+1)
      KBUF=(KBUF/2)*2
      IF(KBUF.GT.600)KBUF=600
      KBUF2=KBUF*RTOI+KBUF+2
      IF(IPRINT.GE.2) WRITE(IW,10)KBUF,NBINS,NTPB,NCOR,ISPAC
10    FORMAT(/6X,'SORTING INFORMATION',
     */6X,'KBUF=',I7,/6X,'NBINS=',I6,/6X,'NTPB=',I7,
     */6X,'NCOR=',I7,/6X,'ISPAC=',I6)
C     STORAGE FOR NBINS BINS EACH OF SIZE KBUF2 IN AIAI
      LSTO=NBINS*KBUF2
C     ALSO SPACE FOR NTPB WORDS IN EMPTY
      IF(NTPB.GT.LSTO)LSTO=NTPB
      LW1=LSTO+1
      LW2=LW1+NBINS
      LIM=LW2+NBINS
      If (LIM.GT.NCOR) Then
         Write (6,*) 'Guga: LIM.GT.NCOR, position 1'
         Write (6,*) 'LIM,NCOR=',LIM,NCOR
         Call Abend
      End If
      LIM=LW2+KBUF2
      If (LIM.GT.NCOR) Then
         Write (6,*) 'Guga: LIM.GT.NCOR, position 2'
         Write (6,*) 'LIM,NCOR=',LIM,NCOR
         Call Abend
      End If
      CALL ICOPY(LW1,[0],0,iWork(LSOArr),1)
      CALL CI_SELECT(iWork(LSOArr),iWork(LSOArr-1+LW1),
     &               iWork(LSOArr-1+LW2),
     &               L0,L1,L2,L3,KBUF,NTPB,NBINS)
      IADD10=0
      CALL iDAFILE(Lu_10,1,IAD10,9,IADD10)
*
*     Epilogue, end
      Call GETMEM('SOArr','Free','Inte',LSOArr,NCOR)
*
*                                                                      *
************************************************************************
*                                                                      *
*     Close open dafiles
*
      Call DaClos(Lu_10)
      Call DaClos(Lu_11)

*                                                                      *
************************************************************************
*                                                                      *
      ireturn=0
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Jeppe Olsen                                      *
!***********************************************************************

subroutine T_TO_NK_VEC(T,KORB,ISM,ISPC,LUCIN,LUCOUT,C)
! Evaluate T**(NK_operator) times vector on file LUIN
! to yield vector on file LUOUT
! (NK_operator is number operator for orbital K)
!
! Note LUCIN and LUCOUT are both rewound before read/write
! Input
! =====
!  T : Input constant
!  KORB : Orbital in symmetry order
!
!  ISM,ISPC : Symmetry and space of state on LUIN
!  C : Scratch block
!
! Jeppe Olsen, Feb. 98

use lucia_data, only: CBLTP, CIBT, Deallocate_Local_Arrays, ICISTR, IREOST, MXNSTR, NELEC, NIRREP, NSTSO, NTOOB
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: T
integer(kind=iwp), intent(in) :: KORB, ISM, ISPC, LUCIN, LUCOUT
real(kind=wp), intent(_OUT_) :: C(*)
integer(kind=iwp) :: IATP, IBTP, KKORB, NAEL, NBATCH, NBEL, NBLOCK
integer(kind=iwp), allocatable :: LASTR(:), LBSTR(:), LKAOC(:), LKBOC(:)

#ifdef _DEBUGPRINT_
write(u6,*) ' T_TO_NK_VEC speaking'
write(u6,*) ' ISM, ISPC = ',ISM,ISPC
#endif
! Set up block and batch structure of vector
IATP = 1
IBTP = 2

NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)

call Z_BLKFO(ISPC,ISM,IATP,IBTP,NBATCH,NBLOCK)
NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)

call mma_allocate(LASTR,MXNSTR*NAEL,Label='LASTR')
call mma_allocate(LBSTR,MXNSTR*NBEL,Label='LBSTR')
call mma_allocate(LKAOC,MXNSTR,Label='LKAOC')
call mma_allocate(LKBOC,MXNSTR,Label='LKBOC')
! Orbital K in type ordering
KKORB = IREOST(KORB)
call T_TO_NK_VECS(T,KKORB,C,LUCIN,LUCOUT,NSTSO(IATP)%A,NSTSO(IBTP)%A,NBLOCK,CIBT,NAEL,NBEL,LASTR,LBSTR,CBLTP,NIRREP,ICISTR,NTOOB, &
                  LKAOC,LKBOC)

call mma_deallocate(LASTR)
call mma_deallocate(LBSTR)
call mma_deallocate(LKAOC)
call mma_deallocate(LKBOC)

call Deallocate_Local_Arrays()

end subroutine T_TO_NK_VEC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SPIN_PHASE(MM,dim,Zinp,Zout)
C
C     The RASSI program gives a random phase to the spin-orbit functions.
C
C     This routine performs a simple check with the obtained spin functions,
C     in order to determine the phase of the spin functions.
C     If the phase is not the same, Then the spin functions will be multiplied
C     with the correspondind coefficient that sets the same phase to all spin
C     eigenfunctions
C
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)           :: dim
      Complex(kind=8), intent(in)  :: mm(3,dim,dim)
      Complex(kind=8), intent(in)  :: Zinp(dim,dim)
      Complex(kind=8), intent(out) :: Zout(dim,dim)
! ------------------------------------------------------------
      Integer                       :: i, j, i1, i2, l
      Real(kind=8), allocatable    :: rxr(:) !dim)
      Real(kind=8), allocatable    :: rxi(:) !dim)
      Complex(kind=8), allocatable :: r(:) !(dim)
      Complex(kind=8), allocatable :: phs(:,:,:)  !3,dim,dim)
      Complex(kind=8), allocatable :: tmp(:,:) !dim,dim
      Logical :: dbg


      dbg=.false.

      Call mma_allocate(rxr,dim,'rxr')
      Call mma_allocate(rxi,dim,'rxi')
      Call mma_allocate(r,dim,'r')
      Call mma_allocate(phs,3,dim,dim,'phs')
      Call mma_allocate(tmp,dim,dim,'tmp')
! ------------------------------------------------------------
      Call zcopy_(3*dim*dim,[(0.0_wp,0.0_wp)],0,phs,1)
      Call zcopy_(  dim*dim,[(0.0_wp,0.0_wp)],0,tmp,1)
      Call zcopy_(dim,[(0.0_wp,0.0_wp)],0,r,1)
      Call dcopy_(dim,[0.0_wp],0,rxr,1)
      Call dcopy_(dim,[0.0_wp],0,rxi,1)
      rxr(1)=1.0_wp
      rxi(1)=0.0_wp

      Do i=1,dim-1
        j = i+1
        r(j)=(0.0_wp,0.0_wp)
        Do i1=1,dim
          Zout(i1,1)=Zinp(i1,1)
        End Do

        Do i1=1,dim
          Do i2=1,dim
            phs(1,i,j)=phs(1,i,j)+ MM(1,i1,i2)*CONJG(Zout(i1,i))*
     &                                               Zinp(i2,j)
          End Do
        End Do

        If(ABS(phs(1,i,j)).gt.1.0e-14_wp ) Then
          rxr(j)= DBLE(phs(1,i,j))/ABS(phs(1,i,j))
          rxi(j)=AIMAG(phs(1,i,j))/ABS(phs(1,i,j))
        Else
          rxr(j)=1.0_wp
          rxi(j)=0.0_wp
        End If
        r(1)=(1.0_wp,0.0_wp)

        ! kind=8, complex double precision
        r(j)=DCMPLX( rxr(j), rxi(j))

        Do i1=1,dim
          Zout(i1,j)=CONJG(r(j))*Zinp(i1,j)
        End Do

        If(dbg) Then
          Write(6,'(A,i2,A,2ES24.14)') 'SPIN-PHASE:'//
     &                        ' R(',j,') = ', CONJG(r(j))
        End If
      End Do ! i


      Call zcopy_(3*dim*dim,[(0.0_wp,0.0_wp)],0,phs,1)
      Call zcopy_(  dim*dim,[(0.0_wp,0.0_wp)],0,tmp,1)
      Call zgemm_('C','N',  dim,  dim,  dim, (1.0_wp,0.0_wp),
     &            Zout(  1:dim,1:dim), dim,
     &              mm(1,1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &             TMP(  1:dim,1:dim), dim )
      Call zgemm_('N','N',  dim,  dim,  dim, (1.0_wp,0.0_wp),
     &             TMP(  1:dim,1:dim), dim,
     &            Zout(  1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &             phs(1,1:dim,1:dim), dim )
cc convention:
cc    mX(i,i+1) => Real, negative
cc    mY(i,i+1) => imag, positive
cc    mZ(i,i)   => diagonal
      Do i=1,dim-1,2
        j=i+1
        If(DBLE( phs(1,i,j) ).gt.0.0_wp ) Then
          Do i1=1,dim
            Zout(i1,j)=-Zout(i1,j)
          End Do
        End If
      End Do

      If(dbg) Then

        Call zcopy_(3*dim*dim,[(0.0_wp,0.0_wp)],0,phs,1)
        Do l=1,3
          Call zcopy_(  dim*dim,[(0.0_wp,0.0_wp)],0,tmp,1)
          Call zgemm_('C','N',  dim,  dim,  dim, (1.0_wp,0.0_wp),
     &                Zout(  1:dim,1:dim), dim,
     &                  mm(l,1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &                 TMP(  1:dim,1:dim), dim )
          Call zgemm_('N','N',  dim,  dim,  dim, (1.0_wp,0.0_wp),
     &                 TMP(  1:dim,1:dim), dim,
     &                Zout(  1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &                 phs(l,1:dim,1:dim), dim )
        End Do

       Do i=1,dim
         Do j=1,dim
           Write(6,'(a,i2,a,i2,a,2ES24.14)') 'SPIN-PHASE:'//
     &      '  Zout(',i,',',j,') = ',Zout(i,j)
         End Do
       End Do

       Write(6,'(//)')
       Do i=1,dim
        Do j=1,dim
         If((j==(i-1)).or.(j==(i+1))) Then
          Write(6,'(A,i2,A,i2,A, 3(2ES24.14,3x))') 'SPIN-PHASE:'//
     &             ' PHS(',i,',',j,') = (x,y,z) =',(phs(l,i,j),l=1,3)
         Else
           cycle
         End If
        End Do
       End Do
      End If



! ------------------------------------------------------------
      Call mma_deallocate(rxr)
      Call mma_deallocate(rxi)
      Call mma_deallocate(r)
      Call mma_deallocate(phs)
      Call mma_deallocate(tmp)

      Return
      End
c





      Subroutine SPIN_PHASE2(MM,dim,Zinp,Zout)
C
C     The RASSI program gives a ranDom phase to the spin-orbit functions.
C
C     This routine performs a simple check with the obtained spin functions,
C     in order to determine the phase of the spin functions.
C     If the phase is not the same, Then the spin functions will be multiplied
C     with the correspondind coefficient that sets the same phase to all spin
C     eigenfunctions
C
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)           :: dim
      Complex(kind=8), intent(in)  :: mm(3,dim,dim)
      Complex(kind=8), intent(in)  :: Zinp(dim,dim)
      Complex(kind=8), intent(out) :: Zout(dim,dim)
! ------------------------------------------------------------
      Integer                       :: i, j, i1, l
      Complex(kind=8)              :: t
      Real(kind=8), allocatable    :: rxr(:) !dim)
      Real(kind=8), allocatable    :: rxi(:) !dim)
      Complex(kind=8), allocatable :: r(:) !(dim)
      Complex(kind=8), allocatable :: phs(:,:,:)  !3,dim,dim)
      Complex(kind=8), allocatable :: tmp(:,:) !dim,dim
      Logical :: dbg

      dbg=.false.

      Call mma_allocate(rxr,dim,'rxr')
      Call mma_allocate(rxi,dim,'rxi')
      Call mma_allocate(r,dim,'r')
      Call mma_allocate(phs,3,dim,dim,'phs')
      Call mma_allocate(tmp,dim,dim,'tmp')
! ------------------------------------------------------------
      Call zcopy_(3*dim*dim,[(0.0_wp,0.0_wp)],0,phs,1)
      Call zcopy_(  dim*dim,[(0.0_wp,0.0_wp)],0,tmp,1)
      Call zcopy_(dim,[(0.0_wp,0.0_wp)],0,r,1)
      Call dcopy_(dim,[0.0_wp],0,rxr,1)
      Call dcopy_(dim,[0.0_wp],0,rxi,1)
      rxr(1)=1.0_wp
      rxi(1)=0.0_wp

      ! compute magnetic moment, X
      Call zcopy_(3*dim*dim,[(0.0_wp,0.0_wp)],0,phs,1)
      Call zcopy_(  dim*dim,[(0.0_wp,0.0_wp)],0,tmp,1)
      Call zgemm_('C','N', dim,  dim,  dim, (1.0_wp,0.0_wp),
     &            Zinp(  1:dim,1:dim), dim,
     &              mm(1,1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &             TMP(  1:dim,1:dim), dim )
      Call zgemm_('N','N', dim,  dim,  dim, (1.0_wp,0.0_wp),
     &             TMP(  1:dim,1:dim), dim,
     &            Zinp(  1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &             phs(1,1:dim,1:dim), dim )

      r(1)=(1.0_wp,0.0_wp)
      Do i=1,dim-1
        j=i+1

        If(ABS(phs(1,i,j)).gt.1.0e-14_wp ) Then
          rxr(j)= DBLE(phs(1,i,j))/ABS(phs(1,i,j))
          rxi(j)=AIMAG(phs(1,i,j))/ABS(phs(1,i,j))
        Else
          rxr(j)=1.0_wp
          rxi(j)=0.0_wp
        End If

        ! kind=8, complex double precision
        r(j)=DCMPLX( rxr(j),-rxi(j))

        If(dbg) Then
          Write(6,'(A,i2,A,2ES24.14)') 'SPIN-PHASE:'//
     &                        ' R(',j,') = ', r(j)*r(i)
        End If
      End Do

      t=(1.0_wp,0.0_wp)
      Do j=1,dim
        t=t*r(j)
        Do i1=1,dim
          Zout(i1,j)=t*Zinp(i1,j)
        End Do
      End Do

      ! compute the momentum using the ZOUT functions:
      Call zcopy_(3*dim*dim,[(0.0_wp,0.0_wp)],0,phs,1)
      Call zcopy_(  dim*dim,[(0.0_wp,0.0_wp)],0,tmp,1)
      Call zgemm_('C','N',  dim,  dim,  dim, (1.0_wp,0.0_wp),
     &            Zout(  1:dim,1:dim), dim,
     &              mm(1,1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &             TMP(  1:dim,1:dim), dim )
      Call zgemm_('N','N',  dim,  dim,  dim, (1.0_wp,0.0_wp),
     &             TMP(  1:dim,1:dim), dim,
     &            Zout(  1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &             phs(1,1:dim,1:dim), dim )
cc convention:
cc    mX(i,i+1) => Real, negative
cc    mY(i,i+1) => imag, positive
cc    mZ(i,i)   => diagonal
      Do i=1,dim-1,2
        j=i+1
        If(DBLE( phs(1,i,j) ).gt.0.0_wp ) Then
          Do i1=1,dim
            Zout(i1,j)=-Zout(i1,j)
          End Do
        End If
      End Do


      If(dbg) Then

        Call zcopy_(3*dim*dim,[(0.0_wp,0.0_wp)],0,phs,1)
        Do l=1,3
           Call zcopy_(  dim*dim,[(0.0_wp,0.0_wp)],0,tmp,1)
           CALL ZGEMM_('C','N',  dim,  dim,  dim, (1.0_wp,0.0_wp),
     &                 Zout(  1:dim,1:dim), dim,
     &                   mm(l,1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &                  TMP(  1:dim,1:dim), dim )
           CALL ZGEMM_('N','N',  dim,  dim,  dim, (1.0_wp,0.0_wp),
     &                  TMP(  1:dim,1:dim), dim,
     &                 Zout(  1:dim,1:dim), dim, (0.0_wp,0.0_wp),
     &                  phs(l,1:dim,1:dim), dim )
        End Do

       Do i=1,dim
         Do j=1,dim
           Write(6,'(a,i2,a,i2,a,2ES24.14)') 'SPIN-PHASE:'//
     &      '  Zout(',i,',',j,') = ',Zout(i,j)
         End Do
       End Do

       Write(6,'(//)')
       Do i=1,dim
        Do j=1,diM
         If((j.eq.(i-1)).or.(j.eq.(i+1))) Then
          Write(6,'(A,i2,A,i2,A, 3(2ES24.14,3x))') 'SPIN-PHASE:'//
     &             ' PHS(',i,',',j,') = (x,y,z) =',(phs(l,i,j),l=1,3)
         Else
           cycle
         End If
        End Do
       End Do
      End If


! ------------------------------------------------------------
      Call mma_deallocate(rxr)
      Call mma_deallocate(rxi)
      Call mma_deallocate(r)
      Call mma_deallocate(phs)
      Call mma_deallocate(tmp)

      Return
      End
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine UrobL1 (L1,NaGrp,LunAux)
c
c       vyraba fily so simulovanymi L1       vektormi
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
#include "o3v3.fh"
#include "chcc_files.fh"
c
        integer NaGrp,LunAux
        real*8 L1(1)
c
c       help variables
        integer aGrp,len
        real*8 schem
c
c1      cycle over a,be Groups
c
        do aGrp=1,NaGrp
c
c1.1      def length
          len=nc*DimGrpv(aGrp)*no
c
c1.2      full L1 with random numbers
          schem=1.0d-2
          call RNFill (len,L1(1),schem)
c
c1.3      open proper file
*         open (unit=LunAux,file=L1Name(aGrp),form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(LunAux,L1Name(aGrp))
c
c1.4      write L1 into proper file
          write (6,*) aGrp,len
          call wri_chcc (LunAux,len,L1(1))
c
        close (LunAux)
c
        end do
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MAGN( EXCH,N,X,Y,Z,H,W,zJ,THRS,dM,sM,nT,T,sopt,
     &                 WZ,ZB,S,M, m_paranoid, DBG)
c this Subroutine is a wrapper for various MAGN subroutines

      Implicit None
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)          :: EXCH, N, nT
      Real(kind=8), intent(in)    :: X, Y, Z, H, zJ
      Real(kind=8), intent(in)    :: W(EXCH), T(nT)
      Complex(kind=8), intent(in) :: dM(3,EXCH,EXCH)
      Complex(kind=8), intent(in) :: sM(3,EXCH,EXCH)
      Logical, intent(in)          :: sopt

      Real(kind=8), intent(out)   :: ZB(nT), WZ(N)
      Real(kind=8), intent(out)   :: S(3,nT), M(3,nT)

      Real(kind=8), intent(in)    :: THRS
      Logical, intent(in)          :: m_paranoid
      Logical, intent(in)          :: DBG
c local variables:


      If( abs(zJ) .lt. tiny(0.0_wp) ) Then


         If(DBG) Write(6,*) 'Enter MAGN_NO_MF :'

         Call MAGN_NO_MF( EXCH, N, X,Y,Z, H, W, dM, sM, nT, T, sopt,
     &                    WZ, ZB, S, M, DBG )

         If(DBG) Write(6,*) 'Exit MAGN_NO_MF :'


      Else ! zJ .ne. 0.0_wp


         If(DBG) Write(6,*) 'Enter MAGN_ZJ_PAR :'

         Call MAGN_ZJ_PAR( EXCH, N, X,Y,Z, H, W, zJ, dM, sM,
     &                     nT, T, sopt, WZ, ZB, S, M, thrs,
     &                     m_paranoid, DBG )

         If(DBG) Write(6,*) 'Exit MAGN_ZJ_PAR :'


      End If



      Return
      End subroutine magn

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_T17g(V,dima,adda,dimbe,addbe)
! check V(a',u) - sum(be',b,i)  (b,i|be',a') . [ 2 Ta(b,be',i,u) - Ta(b,be',u,i)]

use chcc_global, only: no, nv, Q3, T1c, T2c
use Constants, only: Zero, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: dima, adda, dimbe, addbe
real(kind=wp), intent(in) :: V(dima,no)
integer(kind=iwp) :: a, b, bad, be, i, tot, u
real(kind=wp) :: s

tot = 0
bad = 0

do u=1,no
  do a=adda+1,adda+dima

    s = Zero
    do b=1,nv
      do be=1+addbe,addbe+dimbe
        do i=1,no

          s = s+Q3(be,a,b,i)*(Two*(T2c(be,b,u,i)+T1c(be,u)*T1c(b,i))-(T2c(be,b,i,u)+T1c(be,i)*T1c(b,u)))
        end do
      end do
    end do

    if (abs(V(a-adda,u)-s) > 1.0e-10_wp) bad = bad+1
    tot = tot+1

  end do
end do

write(u6,*) ' T17 Chck :',bad,tot

return

end subroutine Chck_T17g

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Anders Bernhardsson                              *
************************************************************************
      Subroutine Niclas(H,coor,LUT)
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iChTbl
* eaw 970909
      Implicit Real*8(a-h,o-z)
#include "stdalloc.fh"
#include "SysDef.fh"
      Real*8 H(*)
      Character*40 Label
      Integer nDeg(200),ldisp(0:7)
      Integer inddsp(100,0:7)
      Logical, External :: TF
      Real*8 Coor(*)
      Real*8 Dummy(1)
      Real*8, Allocatable:: Htmp(:), Tmp(:)
*
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      irec(i,j)=nd*(j-1)+i-1
*
      idsp=0
      Call iCOPY(nirrep,[0],0,ldisp,1)
      Do iIrrep=0,nIrrep-1
      mdc=0
       Do iCnttp = 1, nCnttp
        nCnti = dbsc(iCnttp)%nCntr
        Do iCnt = 1, nCnti
         mdc=mdc+1
         IndDsp(mdc,iIrrep)=idsp
         Do iCar = 0, 2
          iComp = 2**iCar
          If (TF(mdc,iIrrep,iComp)) Then
             idsp=idsp+1
             ldisp(iirrep)=ldisp(iirrep)+1
             ndeg(idsp)=nIrrep/dc(mdc)%nStab
          End If
         End Do
        End Do
       End Do
      End Do
*
************************************************************************
*
*    Steady
*
*    Make the symmetrized Hessian correct for degenerated geometries
*
************************************************************************
*
      nd=0
      Do i=0,nIrrep-1
       nD=ldisp(i)+nd
      End Do
      Call mma_allocate(TMP,nd**2,Label='Tmp')
      Call mma_allocate(HTMP,nd**2,Label='Htmp')
      Htmp(:)=0.0d0
      ii=0
      iii=0
      Do iS=1,Nirrep
       Do i = 1, ldisp(iS-1)
        Do j=1,i
            Tmp(itri(iii+i,iii+j)) =
     &                 sqrt(DBLE(nDeg(i+iii)*nDeg(j+iii)))*
     &                  H(ii+itri(i,j))
*          Write(*,*) H(ii+itri(i,j)),Tmo(itri(iii+i,iii+j))
        End Do
       End Do
       ii=ii+ldisp(is-1)*(ldisp(is-1)+1)/2
       iii=iii+ldisp(is-1)
      End Do
*
********************************************************************************
*
*   Go
*
********************************************************************************
*
      Call FCOOR(LUT,Coor)
      mdc=0
      iPERT=0
      Do iCnttp = 1, nCnttp
       nCnti = dbsc(iCnttp)%nCntr
       Do iCnt = 1, nCnti
        mdc=mdc+1
*
        nCenti=nIrrep/dc(mdc)%nStab
*
      ndc=0
      jPERT=0
      Do jCnttp = 1, nCnttp
       nCntj = dbsc(jCnttp)%nCntr
       Do jCnt = 1, nCntj
        ndc=ndc+1

        nCentj=nIrrep/dc(ndc)%nStab
        Do iIrrep=0,nIrrep-1
         iDsp = IndDsp(mdc,iIrrep)
         Do iCar = 0, 2
          iComp = 2**iCar
          If (TF(mdc,iIrrep,iComp)) Then
            idsp=idsp+1
            jDsp = IndDsp(ndc,iIrrep)
            Do jCar = 0, 2
             jComp = 2**jCar
             If (TF(ndc,iIrrep,jComp)) Then
              jdsp=jdsp+1
              HE=Tmp(itri(idsp,jdsp))
              Do iCo=0,Ncenti-1
               Do jCo=0,Ncentj-1
                i=iPert+ico*3+icar+1
                j=jPert+jco*3+jcar+1
                kop_m=dc(mdc)%iCoSet(iCo,0)
                nop_m=nropr(kop_m)
                kop_n=dc(ndc)%iCoSet(jCo,0)
                nop_n=nropr(kop_n)
                riPh=DBLE(iPrmt(nop_m,icomp)*iChTbl(iIrrep,nop_m))
     &           /sqrt(DBLE(nCENTI))
                rjPh=DBLE(iPrmt(nop_n,jcomp)*ichtbl(iirrep,nop_n))
     &          /sqrt(DBLE(nCENTJ))
                Htmp(1+irec(i,j))=Htmp(1+irec(i,j))+riph*rjph*HE
               End Do ! jco
              End Do ! ico
            End If
          End Do ! jcar
            End If
          End do ! icar
         End Do ! irrep
        jPert=jpert+ncentj*3
       End Do ! jcnt
      End Do ! jcnttp
        iPert=ipert+ncenti*3
       End Do ! icnt
      End Do ! icnttp
*
      Label='Unsymmetrized Hessian'
      WRITE(LUT,'(A)') Label
      Write(LUT,'(A)') '*BEGIN HESSIAN'
      Write(LUT,'(A,I5)') '*Number of pert. ',nd
      Call WRH(LUT,1,[nd],[nd],Htmp,Dummy,0,Label)
      Write(LUT,'(A)') '*END HESSIAN'
*
      Call Put_dArray('FC-Matrix',Htmp,nd**2)
*
      Call mma_deallocate(HTMP)
      Call mma_deallocate(TMP)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Mod_P2(P2mo,nP2Act,D1mo,nD1mo,DS1mo,ExFac,nDet)
      use nq_Info, only: iOff_Ash, mIrrep, nAsh
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "output_ras.fh"
      Real*8 P2mo(nP2Act),D1mo(nD1mo), DS1mo(nD1mo)
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      iOff_=0
      Do iIrrep = 0, mIrrep-1
         iOff_Ash(iIrrep)=iOff_
         iOff_=iOff_+nAsh(iIrrep)
      End Do
*
************************************************************************
*
*---   active space Ptvxy
*
      IF (nDet.eq.1) THEN
*
      P2Act=DBLE(nP2Act)
      Call Put_Temp('nP2Act  ',[P2Act],1)
      Call Put_Temp('P2_RAW  ',P2mo,nP2Act)
*
      Do iIrrep = 0, mIrrep-1
         Do jIrrep = 0, mIrrep-1
         ijIrrep=iEor(iIrrep,jIrrep)
            Do kIrrep = 0, mIrrep-1
            ijkIrrep=iEor(ijIrrep,kIrrep)
*
               Do k_ = 1, nASh(kIrrep)
                  k=iOff_Ash(kIrrep)+k_
                  Do l_ = 1, nASh(ijkIrrep)
                     l=iOff_Ash(ijkIrrep)+l_
                     If (l.gt.k) Go To 100
                     kl   = iTri(k,l)
                     Do i_ = 1, nASh(iIrrep)
                        i=iOff_Ash(iIrrep)+i_
                        il   = iTri(i,l)
                        ik   = iTri(i,k)
                        Do j_ = 1, nASh(jIrrep)
                           j=iOff_Ash(jIrrep)+j_
                           If (j.gt.i) Go To 200
                           ij   = iTri(i,j)
                           If (kl.gt.ij) Go To 200
                           ijkl = iTri(ij,kl)
                           jk   = iTri(j,k)
                           jl   = iTri(j,l)
*
                           Fact=One
                           If (iIrrep.eq.jIrrep) Then
                              If (k.eq.l) Fact=Two
                           End If
                           P2mo(ijkl) = Fact * P2mo(ijkl)
*
                           If (iIrrep.eq.ijkIrrep) Then
                              P2mo(ijkl) = P2mo(ijkl)
     &                                   + (1.0d0-ExFac)*
     &                                   (0.25d0* D1mo(jk)* D1mo(il)+
     &                                    0.25d0*DS1mo(jk)*DS1mo(il))
                           End If
*
                           If (iIrrep.eq.kIrrep) Then
                              P2mo(ijkl) = P2mo(ijkl)
     &                                   + (1.0d0-ExFac)*
     &                                   (0.25d0* D1mo(jl)* D1mo(ik)+
     &                                    0.25d0*DS1mo(jl)*DS1mo(ik))
                           End If
*
                           P2mo(ijkl) = P2mo(ijkl)/Fact
*
 200                       Continue
                        End Do
                     End Do
 100                 Continue
                  End Do
               End Do
*
            End Do
         End Do
      End Do
      Call Put_Temp('P2_KS   ',P2mo,nP2Act)
      ELSE
         Write(LF,*) ' Not implemented yet!!! nDet=',nDet
         Call Abend()
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SolveA(AlfMat,AlfMatI,dLambda,ARaw,BRaw,dA,iPrint,AboveMul,ddUpper,ddLower)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: AlfMat(4), AlfMatI(4), dA(2)
integer(kind=iwp), intent(in) :: iPrint
real(kind=wp), intent(in) :: dLambda, ARaw(2,2), BRaw(2), ddUpper, ddLower
logical(kind=iwp), intent(in) :: AboveMul(2)
integer(kind=iwp) :: i, iMull, Ising, j, kaunt, nDim
real(kind=wp) :: Beta(2), Det, dtA(2)
logical(kind=iwp) :: Yeps(2)

! Which elements can be non-zero? Too low magnitude of multipoles
! and they are screened.

nDim = 0
do iMull=1,2
  if (AboveMul(iMull)) then
    Yeps(iMull) = .true.
    nDim = nDim+1
    Beta(nDim) = BRaw(iMull)
  else
    Yeps(iMull) = .false.
  end if
end do
if (iPrint >= 10) then
  call RecPrt('Beta',' ',Beta,nDim,1)
end if

! Shuffle around, and create a matrix for exponents with non-zero factors.

kaunt = 0
do i=1,2
  do j=1,2
    if (Yeps(i) .and. Yeps(j)) then
      kaunt = kaunt+1
      if (i == j) then
        AlfMat(kaunt) = ARaw(max(i,j),min(i,j))*(One+dLambda)
      else
        AlfMat(kaunt) = ARaw(max(i,j),min(i,j))
      end if
    end if
  end do
end do

! Invert and solve.

call MInv(AlfMat,AlfMatI,Ising,Det,nDim)
call dGeMV_('N',nDim,nDim,One,AlfMatI,nDim,Beta,1,Zero,dtA,1)

! Optional printing.

if (iPrint >= 10) then
  call RecPrt('Alfa',' ',AlfMat,nDim,nDim)
  call RecPrt('InverseA',' ',AlfMatI,nDim,nDim)
  call RecPrt('deltatA',' ',dtA,nDim,1)
end if

! Damp large steps since such steps can take the optimization
! too far away and put it in a region with very small derivatives,
! and there things turns into baloney.

if (dtA(1) < ddLower) dtA(1) = ddLower
if (dtA(2) < ddLower) dtA(2) = ddLower
if (dtA(1) > ddUpper) dtA(1) = ddUpper
if (dtA(2) > ddUpper) dtA(2) = ddUpper

! Extend to full dimension.

kaunt = 0
do i=1,2
  if (Yeps(i)) then
    kaunt = kaunt+1
    dA(i) = dtA(kaunt)
  else
    dA(i) = Zero
  end if
end do

return

end subroutine SolveA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_PFake_GetVec(Vec,lVec,IDV,lIDV,InfV,iSym,nRead,iRedC)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lVec, lIDV, IDV(lIDV), iSym
real(kind=wp), intent(inout) :: Vec(lVec)
integer(kind=iwp), intent(inout) :: InfV(2,*), iRedC
integer(kind=iwp), intent(out) :: nRead
integer(kind=iwp) :: ipV, iVec, m, Mem, n
character(len=*), parameter :: SecNam = 'Cho_PFake_GetVec'

nRead = 0
ipV = 1
Mem = lVec
do iVec=1,lIDV
  n = 0
  m = 0
  call Cho_VecRd(Vec(ipV),Mem,IDV(iVec),IDV(iVec),iSym,n,iRedC,m)
  if (n == 1) then
    nRead = nRead+1
    ipV = ipV+m
    Mem = Mem-m
    InfV(1,iVec) = m
  else if (n == 0) then
    return
  else
    call Cho_Quit('Logical error in '//SecNam,103)
  end if
end do

end subroutine Cho_PFake_GetVec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WR_VibRot_Info1(Lu,iOpt,iDisk,
     &                           ntit1,J1A,J2A,lambda,n0,
     &                           nvib1,Redm,Umax,Umin,ngrid,
     &                           isn1,isn2,Req,xMass1,xMass2)
      Implicit Real*8 (a-h,o-z)
      Dimension dum(1),idum(1)
*
      idum(1)=ntit1
      Call iDaFile(Lu,iOpt,idum,1,iDisk)
      ntit1=idum(1)
      idum(1)=J1A
      Call iDaFile(Lu,iOpt,idum,1,iDisk)
      J1A=idum(1)
      idum(1)=J2A
      Call iDaFile(Lu,iOpt,idum,1,iDisk)
      J2A=idum(1)
      idum(1)=lambda
      Call iDaFile(Lu,iOpt,idum,1,iDisk)
      lambda=idum(1)
      idum(1)=n0
      Call iDaFile(Lu,iOpt,idum,1,iDisk)
      n0=idum(1)
      idum(1)=nvib1
      Call iDaFile(Lu,iOpt,idum,1,iDisk)
      nvib1=idum(1)
      dum(1)=Redm
      Call dDaFile(Lu,iOpt,dum,1,iDisk)
      Redm=dum(1)
      dum(1)=Umax
      Call dDaFile(Lu,iOpt,dum,1,iDisk)
      Umax=dum(1)
      dum(1)=Umin
      Call dDaFile(Lu,iOpt,dum,1,iDisk)
      Umin=dum(1)
      idum(1)=ngrid
      Call iDaFile(Lu,iOpt,idum,1,iDisk)
      ngrid=idum(1)
      idum(1)=isn1
      Call iDaFile(Lu,iOpt,idum,1,iDisk)
      isn1=idum(1)
      idum(1)=isn2
      Call iDaFile(Lu,iOpt,idum,1,iDisk)
      isn2=idum(1)
      dum(1)=Req
      Call dDaFile(Lu,iOpt,dum,1,iDisk)
      Req=dum(1)
      dum(1)=xMass1
      Call dDaFile(Lu,iOpt,dum,1,iDisk)
      xMass1=dum(1)
      dum(1)=xMass2
      Call dDaFile(Lu,iOpt,dum,1,iDisk)
      xMass2=dum(1)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mkorbfree_cvb()
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"

      i1 = mstackr_cvb(norb*norb)
      i2 = mstackr_cvb(norb*norb)
      i3 = mstackr_cvb(norb*norb)
      i4 = mstacki_cvb(nprorb)
      call mkorbfree2_cvb(work(lv(1)),iwork(ls(3)),work(ls(4)),
     >  iwork(ls(5)),work(ls(6)),iwork(ls(8)),iwork(ls(11)),
     >  iwork(ls(12)),
     >  work(ls(14)),work(i1),work(i2),work(i3),iwork(i4))
      call mfreer_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Readin_poly(nneq,neq,neqv,exch,nCenter,nT,nH,nTempMagn,nDir,nDirZee,nMult,nPair,nexch,nDim,i_pair,lant,multLn,iPrint, &
                       keopt,encut_definition,nK,mG,iopt,nP,AngPoints,ncut,LUZee,MxRank1,MxRank2,imaxrank,nsymm,ngrid,TempMagn, &
                       R_LG,R_ROT,Jex,JAex,JAex9,JDMex,JITOexR,JITOexI,tpar,upar,cryst,coord,Xfield,gtens_input,D_fact, &
                       EoverD_fact,riso,MagnCoords,thrs,tmin,tmax,hmin,hmax,Texp,chit_exp,Hexp,Mexp,encut_rate,zJ,dirX,dirY,dirZ, &
                       dir_weight,Title,itype,ifHDF,compute_g_tensors,compute_magnetization,TINPUT,HINPUT,Do_structure_abc,DoPlot, &
                       compute_Mdir_vector,zeeman_energy,m_paranoid,m_accurate,smagn,compute_susceptibility,decompose_exchange,KE, &
                       fitCHI,fitM,compute_torque,compute_barrier,Dipol,check_title,AnisoLines1,AnisoLines3,AnisoLines9, &
                       DM_exchange,JITO_exchange)
! THIS ROUTINE READS THE standard input.
! definition of the cluster:
!  nneq, neqv, neq, nCenter, ifHDF
! definition of the local metal sites
!  R_LG, R_ROT, gtens_input, D_fact, EoverD_fact, riso, itype
! definition of the exchange:
!  exch          : total number of exchange states
!  nPair         : number of metal pairs (number of interactions)
!  nexch         : exchange basis, nmax= MAX(nexch(:))
!  i_pair        : index of the metal site in a given interacting pair
!  Jex           : Lines exchange    ( 1 parameter / interacting pair)
!  JAex          : Anisotropic Lines ( 3 parameter / interacting pair)
!  JAex9         : Anisotropic Lines full ( 9 parameters / interacting pair)
!  JITO_exchange : options used in connection with ITO exchange:
!  JDMex, AnisoLines1, AnisoLines3, AnisoLines9, Dipol, DM_exchange, MxRank1, MxRank2, imaxrank, JITOexR, JITOexI
! options used in connection with KE
!  lant, KEOPT, multLn, KE, tpar, upar
! options used in connection with Dipol-Dipol interaction
!  MagnCoords
! definition of g and D tensors
!  nMult, nDim, compute_g_tensors
! definition of data for susceptibility
!  nT, tinput, compute_susceptibility, tmin, tmax, chit_exp, Texp
! options related to XT_MoverH
!  Xfield
! definition of data for magnetization:
!  nH, nTempMagn, iopt, TempMagn, Hexp, Mexp, thrs, hmin, hmax, hinput, compute_magnetization, compute_Mdir_vector, zeeman_energy,
!  m_paranoid, m_accurate, smagn
! options used to set up nM and EM
!  nK, mG     : encut_definition=1;
!  ncut       : encut_definition=2;
!  encut_rate : encut_definition=3;
!  encut_definition
! decompose exchange
!  decompose_exchange
! magnetization torque
!  nP, AngPoints, compute_torque
! Zeeman energy and M vector
!  nDir, nDirZee, LUZee, dirX, dirY, dirZ, dir_weight
! definition of mean field parameter
!  zJ
! definition of the crystal axes:
!  cryst ! a, b, c, alpha, beta, gamma
!  Do_structure_abc
! Cartesian coordinates of the main metal site, or center
!  coord
! definitions for blocking barrier
!  compute_barrier
! options for automatic fitting of parameters:
!  fitCHI : not used so far
!  fitM   : not used so far
! definition of print level
!  iPrint, check_title, Title, DoPlot

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three
use Definitions, only: wp, iwp, u5, u6

implicit none
integer(kind=iwp), intent(inout) :: nneq, neq(nneq), nT, nH, nTempMagn, nDir, nDirZee, nMult, nPair, nexch(nneq), nDim(nMult), &
                                    lant, multLn, iPrint, KEOPT, encut_definition, nK, mG, iopt, nP, AngPoints, ncut, &
                                    LUZee(nDirZee), imaxrank(npair,2), nsymm, ngrid
integer(kind=iwp), intent(in) :: neqv, exch, nCenter, MxRank1, MxRank2
integer(kind=iwp), intent(out) :: i_pair(nPair,2)
real(kind=wp), intent(inout) :: TempMagn(nTempMagn), R_LG(nneq,neqv,3,3), R_ROT(nneq,neqv,3,3), Jex(nPair), JAex(nPair,3), &
                                JAex9(nPair,3,3), JDMex(nPair,3), &
                                JITOexR(nPair,MxRank1,-MxRank1:MxRank1,MxRank2,-MxRank2:MxRank2), &
                                JITOexI(nPair,MxRank1,-MxRank1:MxRank1,MxRank2,-MxRank2:MxRank2), tpar, upar, cryst(6), coord(3), &
                                Xfield, gtens_input(3,nneq), D_fact(nneq), EoverD_fact(nneq), riso(3,3,nneq), MagnCoords(nneq,3), &
                                thrs, tmin, tmax, hmin, hmax, Texp(nT), chit_exp(nT), Hexp(nH), Mexp(nH,nTempMagn), encut_rate, &
                                zJ, dirX(nDir), dirY(nDir), dirZ(nDir), dir_weight(nDirZee,3)
character(len=180), intent(inout) :: Title
character, intent(inout) :: itype(nneq)
logical(kind=iwp), intent(inout) :: ifHDF, compute_g_tensors, compute_magnetization, Do_structure_abc, DoPlot, &
                                    compute_Mdir_vector, zeeman_energy, m_paranoid, m_accurate, smagn, compute_susceptibility, &
                                    decompose_exchange, KE, fitCHI, fitM, compute_torque, compute_barrier, Dipol, AnisoLines1, &
                                    AnisoLines3, AnisoLines9, DM_exchange, JITO_exchange
logical(kind=iwp), intent(out) :: tinput, hinput, check_title
integer(kind=iwp) :: ASUM, i, i1, i2, ic, icount_b_sites, inneq, iproj1, iproj2, irank1, irank2, istatus, j, jc, jproj1, jproj2, &
                     jrank1, jrank2, l, lb1, lb2, linenr, ll, lp, m, n, nst
real(kind=wp) :: check_dir_weight, detR, rsum, t1, t2, tmp, tmpR(3,3)
logical(kind=iwp) :: ab_initio_all, check_symm_presence, checktmag, encut_check, hcheck, nosym, tcheck
character(len=2) :: lanth
character(len=21) :: namefile_energy
character(len=288) :: ctmp, Line, string
integer(kind=iwp), allocatable :: duplicate_check(:), nind(:,:)
integer(kind=iwp), external :: IsFreeUnit
real(kind=wp), external :: finddetr

#include "warnings.h"
#include "macros.fh"

check_title = .false.
icount_B_sites = 0
i_pair(:,:) = 0
nosym = .true.
ENCUT_check = .false.
TINPUT = .false.
HINPUT = .false.
TCHECK = .false.
HCHECK = .false.

do i=1,nneq
  do j=1,Neq(i)
    R_rot(i,j,1,1) = One
    R_rot(i,j,2,2) = One
    R_rot(i,j,3,3) = One
    R_lg(i,j,1,1) = One
    R_lg(i,j,2,2) = One
    R_lg(i,j,3,3) = One
  end do
end do
check_symm_presence = .true.
if (neqv > 1) check_symm_presence = .false.

#ifdef _DEBUGPRINT_
write(u6,'(A,  i6)') 'RDIN:      nneq=',nneq
write(u6,'(A,  i6)') 'RDIN:      neqv=',neqv
write(u6,'(A,  i6)') 'RDIN:     nPair=',nPair
!write(u6,'(A,99I6)') 'RDIN:  i_pair(:,1)=',(i_pair(i,1),i=1,nPair)
!write(u6,'(A,99I6)') 'RDIN:  i_pair(:,2)=',(i_pair(i,2),i=1,nPair)
write(u6,'(A,99i6)') 'RDIN:     neq()=',(neq(i),i=1,nneq)
write(u6,'(A,99i6)') 'RDIN:   nexch()=',(nexch(i),i=1,nneq)
#endif

!=========== End of default settings====================================
rewind(u5)
do
  read(u5,'(A72)',iostat=istatus) LINE
  if (istatus < 0) call Error(5)
# ifdef _DEBUGPRINT_
  write(u6,'(A)') LINE
# endif
  call NORMAL(LINE)
  if (LINE(1:5) == '&POLY') exit
end do
LINENR = 0

do
  call xFlush(u6)
  read(u5,'(A72)',iostat=istatus) LINE
  if (istatus < 0) call Error(5)
  LINENR = LINENR+1
  call NORMAL(LINE)
  if ((LINE(1:1) == '*') .or. (LINE == ' ')) cycle
  if (LINE(1:3) == 'END') exit
  select case (LINE(1:4))

    ! ------------ TITL -----------------------------------------------*
    case ('TITL')

      read(u5,*,iostat=istatus) ctmp
      if (istatus /= 0) call Error(4)

#     ifdef _DEBUGPRINT_
      write(u6,'(A)') ctmp
#     endif
      check_title = .true.
      Title = trim(ctmp)
      LINENR = LINENR+1

    ! ------------ OLDA -----------------------------------------------*
    case ('OLDA')
      LINENR = LINENR+1

    !---  process MLTP command ----------------------------------------*
    case ('MLTP')

      read(u5,*,iostat=istatus) NMULT
      if (istatus /= 0) call Error(4)

#     ifdef _DEBUGPRINT_
      write(u6,'(A,i4)') 'NMULT =',NMULT
#     endif

      read(u5,*,iostat=istatus) (NDIM(i),i=1,NMULT)
      if (istatus /= 0) call Error(4)

      do i=1,NMULT
        if (NDIM(i) < 0) then
          ctmp = ''
          write(ctmp,'(A,I2,A)') 'MLTP: the dimension of the multiplet ',i,' is negative!!!'
          call WarningMessage(2,ctmp)
          call quit(_RC_INPUT_ERROR_)
        else if (NDIM(i) == 0) then
          ctmp = ''
          write(ctmp,'(A,I2,A)') 'MLTP: the dimension of the multiplet ',i,' is zero!!!'
          call WarningMessage(2,ctmp)
          call quit(_RC_INPUT_ERROR_)
        end if
      end do

#     ifdef _DEBUGPRINT_
      write(u6,'(A,100i4)') 'NDIM: ',(NDIM(i),i=1,NMULT)
#     endif
      compute_g_tensors = .true.
      LINENR = LINENR+2

    !---  process TINT command ----------------------------------------*
    case ('TINT')
      compute_susceptibility = .true.
      if (TINPUT) then
        call Error(1)
      else
        TCHECK = .true.

        read(u5,*,iostat=istatus) t1,t2,nT
        if (istatus /= 0) call Error(4)

        if ((t1 < 0) .or. (t2 < 0)) then
          call WarningMessage(2,'TINT: negative temperature requested! ')
          call quit(_RC_INPUT_ERROR_)
        end if
        if ((t1-t2) > Zero) then
          Tmin = t2
          Tmax = t1
        else if ((t1-t2) < Zero) then
          Tmin = t1
          Tmax = t2
        else ! t1==t2
          call WarningMessage(2,'TINT: temperature interval == 0! ')
          call quit(_RC_INPUT_ERROR_)
        end if

#       ifdef _DEBUGPRINT_
        write(u6,'(A,2ES15.7,i6)') 'Tmin, Tmax, nT: ',Tmin,Tmax,nT
#       endif
      end if
      LINENR = LINENR+1

    !---  process HINT command ----------------------------------------*
    case ('HINT')
      if (HINPUT) then
        call Error(2)
      else
        HCHECK = .true.
        compute_magnetization = .true.

        read(u5,*,iostat=istatus) t1,t2,nH
        if (istatus /= 0) call Error(4)

        if ((t1 < 0) .or. (t2 < 0)) then
          call WarningMessage(2,'HINT: negative field requested! ')
          call quit(_RC_INPUT_ERROR_)
        end if
        if ((t1-t2) > Zero) then
          Hmin = t2
          Hmax = t1
        else if ((t1-t2) < Zero) then
          Hmin = t1
          Hmax = t2
        else ! t1==t2
          call WarningMessage(2,'HINT: temperature interval == 0! ')
          call quit(_RC_INPUT_ERROR_)
        end if

#       ifdef _DEBUGPRINT_
        write(u6,'(A,2ES15.7,i6)') 'Hmin, Hmax, nH: ',Hmin,Hmax,nH
#       endif
      end if
      LINENR = LINENR+1

    !---  process THRS command ----------------------------------------*
    case ('THRS')

      read(u5,*,iostat=istatus) THRS
      if (istatus /= 0) call Error(4)

      if (thrs < Zero) then
        call WarningMessage(2,'THRS: negative threshold for  average M!!! ')
        write(u6,'(A)') 'Set to default thrs=1.0e-10'
        thrs = 1.0e-10_wp
      end if

#     ifdef _DEBUGPRINT_
      write(u6,'(A,ES15.7)') 'THRS: ',THRS
#     endif
      LINENR = LINENR+1

    !---  process XFIE command ----------------------------------------*
    case ('XFIE')
      compute_susceptibility = .true.

      read(u5,*,iostat=istatus) tmp
      if (istatus /= 0) call Error(4)

      if (tmp < Zero) then
        call WarningMessage(2,'XFIE: negative value of the applied field !')
        write(u6,'(A)') 'Set to positive !'
        Xfield = abs(tmp)
      else if (tmp == Zero) then
        call WarningMessage(2,'XFIE: zero value of the applied field !')
        write(u6,'(A)') 'Field-applied XT will not be computed!'
      else
        Xfield = tmp
      end if
#     ifdef _DEBUGPRINT_
      write(u6,'(A,ES15.7)') 'XFIE: ',xField
#     endif

      LINENR = LINENR+1

    !---  process PLOT command ----------------------------------------*
    case ('PLOT')
      DoPlot = .true.

#     ifdef _DEBUGPRINT_
      write(u6,'(A,L2)') 'PLOT: ',DoPlot
#     endif

      LINENR = LINENR+1

    !---  process IOPT command ----------------------------------------*
    case ('IOPT')

      read(u5,*,iostat=istatus) I  !option for computing MSUM and XTSUM
      if (istatus /= 0) call Error(4)

      if ((i < 0) .or. (i > 3)) then
        call WarningMessage(2,'IOPT: value out of range!!!')
        write(u6,'(A)') 'Set to default !'
        iopt = 1
      else
        iopt = i
      end if

#     ifdef _DEBUGPRINT_
      write(u6,'(A,I6)') 'IOPT: ',IOPT
#     endif
      LINENR = LINENR+1

    !---  process SMAG command ----------------------------------------*
    case ('SMAG')
      smagn = .true.
      compute_magnetization = .true.
#     ifdef _DEBUGPRINT_
      write(u6,'(A,L2)') 'SMAG: ',smagn
#     endif
      LINENR = LINENR+1

    !---  process MACC command ----------------------------------------*
    case ('MACC')
      compute_magnetization = .true.  ! request for computation of M(H)
      m_accurate = .true.             ! request for computation of M(H)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,L2)') 'MACC: ',m_accurate
#     endif
      LINENR = LINENR+1

    !---  process FITX command ----------------------------------------*
    case ('FITX')
      fitCHI = .true.
      LINENR = LINENR+1

    !---  process FITM command ----------------------------------------*
    case ('FITM')
      fitM = .true.
      LINENR = LINENR+1

    !---  process MPAR command ----------------------------------------*
    case ('MPAR')
      m_paranoid = .true.             ! request for computation of M(H)
      compute_magnetization = .true.
#     ifdef _DEBUGPRINT_
      write(u6,'(A,L2)') 'MPAR: ',m_paranoid
#     endif
      LINENR = LINENR+1

    !---  process TORQ command ----------------------------------------*
    case ('TORQ')

      compute_torque = .true.         ! request for computation of M(H)
      read(u5,*,iostat=istatus) i        ! number of angular points
      if (istatus /= 0) call Error(4)

      if (i <= 0) then
        call WarningMessage(2,'TORQ: nP value out of range!!!')
        write(u6,'(A)') 'Set to default !'
        nP = 45
      else
        nP = i
      end if

#     ifdef _DEBUGPRINT_
      write(u6,'(A)') 'TORQ: nP=',nP
#     endif
      AngPoints = nP+1
      LINENR = LINENR+1

    !---  process MAVE command ----------------------------------------*
    case ('MAVE')
      compute_magnetization = .true.  ! request for computation of M(H)

      read(u5,*,iostat=istatus) i,j  !nsymm, ngrid
      if (istatus /= 0) call Error(4)

      if ((i <= 0) .or. (i >= 4)) then
        call WarningMessage(2,'MAVE: nSYMM value out of range!!!')
        write(u6,'(A)') 'Set to default !'
        nsymm = 1
      else
        nsymm = i
      end if

      if ((j <= 0) .or. (j >= 33)) then
        call WarningMessage(2,'MAVE: nGRID value out of range!!!')
        write(u6,'(A)') 'Set to default !'
        ngrid = 15
      else
        ngrid = i
      end if

#     ifdef _DEBUGPRINT_
      write(u6,'(2(A,i6))') ' nsymm:  ',nsymm,' ngrid:  ',ngrid
#     endif
      LINENR = LINENR+1

    !---  process NCUT command ----------------------------------------*
    case ('NCUT')
      if (ENCUT_check) then
        call Error(3)
      else
        ENCUT_check = .true.
        ! request for computation of M(H)
        compute_magnetization = .true.
        encut_definition = 1

        read(u5,*,iostat=istatus) i ! NCUT
        if (istatus /= 0) call Error(4)
        !E_cut = exchange_energy(Ncut)

        if ((i <= 0) .or. (i > exch)) then
          call WarningMessage(2,'NCUT: value out of range!!!')
          write(u6,'(A)') 'Set to full exchange basis.'
          nCUT = exch
        else
          nCUT = i
        end if
#       ifdef _DEBUGPRINT_
        write(u6,'(A,2i6)') 'ncut:  ',nCut
#       endif

        LINENR = LINENR+1
      end if

    !---  process ENCU command ----------------------------------------*
    case ('ENCU')
      if (ENCUT_check) then
        call Error(3)
      else
        ENCUT_check = .true.
        ! request for computation of M(H)
        compute_magnetization = .true.
        encut_definition = 2

        read(u5,*,iostat=istatus) NK,MG
        if (istatus /= 0) call Error(4)
        !E_cut = NK*K_Boltz+MG*mu_Bohr
#       ifdef _DEBUGPRINT_
        write(u6,'(A,2i6)') 'encu:  nK, mG=',NK,MG
#       endif

        LINENR = LINENR+1
      end if

    !---  process ERAT command ----------------------------------------*
    case ('ERAT')
      if (ENCUT_check) then
        call Error(3)
      else
        ENCUT_check = .true.
        ! request for computation of M(H)
        compute_magnetization = .true.
        encut_definition = 3

        read(u5,*,iostat=istatus) encut_rate
        if (istatus /= 0) call Error(4)
        !Ncut = int(nexch*encut_rate)
        !E_cut = E(Ncut)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,i6)') 'encut_rate=',encut_rate
#       endif

        LINENR = LINENR+1
      end if

    !---  process ZJPR command ----------------------------------------*
    case ('ZJPR')
      read(u5,*,iostat=istatus) ZJ
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,ES18.10)') 'zJ    =',zJ
#     endif
      LINENR = LINENR+1

    !---  process PRLV command ----------------------------------------*
    case ('PRLV')
      read(u5,*,iostat=istatus) iPrint
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i6)') 'iPrint=',iPrint
#     endif
      LINENR = LINENR+1

    !---  process COOR command ----------------------------------------*
    case ('COOR')
      Dipol = .true.
#     ifdef _DEBUGPRINT_
      write(u6,'(A)') 'isite   MagnCoords:'
#     endif
      do i=1,nneq
        read(u5,*,iostat=istatus) (MagnCoords(i,l),l=1,3)
        if (istatus /= 0) call Error(4)
#       ifdef _DEBUGPRINT_
        write(u6,'(i3,5x,3ES18.10)') i,(MagnCoords(i,l),l=1,3)
#       endif
      end do
      LINENR = LINENR+nneq

    !---  process MVEC command ----------------------------------------*
    case ('MVEC')
      compute_magnetization = .true.  ! request for computation of M(H)
      compute_Mdir_vector = .true.

      read(u5,*,iostat=istatus) nDir
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i3)') 'nDir = ',nDir
#     endif

      do i=1,nDir
        read(u5,*,iostat=istatus) DirX(i),DirY(i),DirZ(i)
        if (istatus /= 0) call Error(4)
#       ifdef _DEBUGPRINT_
        write(u6,'(i3,5x,3ES18.10)') i,DirX(i),DirY(i),DirZ(i)
#       endif
      end do
      ! some processing:
      do i=1,nDir
        rsum = DirX(i)*DirX(i)+DirY(i)*DirY(i)+DirZ(i)*DirZ(i)
        if (rsum == Zero) then
          write(u6,'(a,i3,a)') 'error: MVEC  vector ',i,'has the modulus = 0.0.'
          write(u6,'(a     )') 'the program will stop now.'
          call quit(_RC_INPUT_ERROR_)
        end if
        if (abs(rsum-One) > 0.5e-13_wp) then
          write(u6,'(a,i3,a)') 'the vector ',i,'was re-normalized.'
          tmp = dirX(i)/sqrt(rsum)
          dirX(i) = tmp
          tmp = dirY(i)/sqrt(rsum)
          dirY(i) = tmp
          tmp = dirZ(i)/sqrt(rsum)
          dirZ(i) = tmp
        end if
      end do

      LINENR = LINENR+NDIR+1

    !---  process TEXP command ----------------------------------------*
    case ('TEXP')
      compute_susceptibility = .true.
      if (TCHECK) then
        call Error(1)
      else
        TINPUT = .true.

        read(u5,*,iostat=istatus) NT
        if (istatus /= 0) call Error(4)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,i3)') 'nT = ',nT
#       endif

        do i=1,NT

          read(u5,*,iostat=istatus) texp(i),chit_exp(i)
          if (istatus /= 0) call Error(4)

          ! check and clean negative values:
          if (texp(i) < Zero) texp(i) = abs(texp(i))
          if (chit_exp(i) < Zero) chit_exp(i) = abs(chit_exp(i))
        end do
        tmin = texp(1)
        tmax = texp(nT)
      end if
      LINENR = LINENR+NT+1

    !---  process HEXP command ----------------------------------------*
    case ('HEXP')
      compute_magnetization = .true.
      if (checkTMAG) write(u6,'(A)') 'The data provided in TMAG will be ignored.'

      if (HCHECK) then
        call Error(2)
      else
        HINPUT = .true.

        read(u5,*) nTempMagn,(TempMagn(i),i=1,nTempMagn)
        read(u5,*) nH
#       ifdef _DEBUGPRINT_
        write(u6,*) 'HEXP: nTempMagn =',nTempMagn
        write(u6,*) 'HEXP: TempMagn()=',(TempMagn(i),i=1,nTempMagn)
        write(u6,*) 'HEXP: nH        =',nH
#       endif

        if (nH < 0) nH = abs(nH)
        if (nH == 0) call Quit_OnUserError()

        do i=1,nH
          read(u5,*,iostat=istatus) Hexp(i),(Mexp(i,j),j=1,nTempMagn)
          if (istatus /= 0) call Error(4)
          ! check and clean negative values:
          if (hexp(i) < Zero) hexp(i) = abs(hexp(i))
          do j=1,nTempMagn
            if (Mexp(i,j) < Zero) Mexp(i,j) = abs(Mexp(i,j))
          end do
        end do
        hmin = hexp(1)
        hmax = hexp(nH)
      end if
      LINENR = LINENR+NH+2

    !---  process TMAG command ----------------------------------------*
    case ('TMAG')
      if (.not. HINPUT) then
        compute_magnetization = .true.
        checkTMAG = .true.

        read(u5,*,iostat=istatus) nTempMagn,(TempMagn(i),i=1,nTempMagn)
        if (istatus /= 0) call Error(4)
#       ifdef _DEBUGPRINT_
        write(u6,*) 'TMAG: nTempMagn =',nTempMagn
        write(u6,*) 'TMAG: TempMagn()=',(TempMagn(i),i=1,nTempMagn)
#       endif

        ! check and clean for zero / negative values:
        do i=1,nTempMagn
          if (TempMagn(i) < Zero) then
            call WarningMessage(2,'TMAG: negative temperature requested! ')
            write(u6,'(A)') 'Set to positive.'
            TempMagn(i) = abs(TempMagn(i))
          else if (TempMagn(i) == Zero) then
            call WarningMessage(2,'TMAG: zero temperature requested! ')
            write(u6,'(A)') 'Set to 0.0001 K.'
            TempMagn(i) = 0.0001_wp
          end if
        end do
      else
        write(u6,'(A)') 'TMAG data is taken from HEXP.'
      end if
      LINENR = LINENR+1

    !---  process NNEQ command ----------------------------------------*
    ! this is the most important keyword for Poly_Aniso
    case ('NNEQ')
      ! number of non-equivalent centers; type of all centers
      read(u5,*,iostat=istatus) NNEQ,ab_initio_all,ifHDF
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i4,A,L2,A,L2)') 'NNEQ=',NNEQ,' ab_initio_all=',ab_initio_all,' ifHDF=',ifHDF
#     endif
      ! number of equivalent centers of type "i"
      read(u5,*,iostat=istatus) (NEQ(i),i=1,Nneq)
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,100I4)') 'NEQ(I)=',(NEQ(i),i=1,nneq)
#     endif
      ! number of RASSI wf for exchange
      read(u5,*,iostat=istatus) (Nexch(i),i=1,Nneq)
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,100I4)') 'NExch(I)=',(NExch(i),i=1,nneq)
#     endif

      do i=1,nneq
        if (Nexch(i) < 0) then
          write(u6,'(A,i1,a)') 'The number of functions taken in the exchange interaction from center of type ',i,' is negative!'
          write(u6,'(A     )') 'The program has to stop, since the input is not reasonable.'
          call quit(_RC_INPUT_ERROR_)
        else if (Nexch(i) == 0) then
          write(u6,'(A,i1,a)') 'The number of functions taken in the exchange interaction from center of type ',i,' is 0 (zero).'
          write(u6,'(A)') 'The program has to stop, since the input is not reasonable.'
          call quit(_RC_INPUT_ERROR_)
        end if
      end do
      do i=1,nneq
        if (neq(i) > 1) nosym = .false.
      end do
      !write(u6,'(A,i5)') 'exch = ',exch
      if (exch == 1) then
        write(u6,'(3/)')
        write(u6,'(A)') repeat('#',100)
        write(u6,'(3/)')
        write(u6,'(A)') 'The size of the exchange matrix is 1. Is this really what you intended to compute?'
        write(u6,'(A)') 'The program will continue...'
        write(u6,'(3/)')
        write(u6,'(A)') repeat('#',100)
        write(u6,'(3/)')
      end if

      ! If the EXCH is above the limit => exit with an error
      if (exch > 15000) then
        write(u6,'(A)') 'The number of exchange states is very large'
        write(u6,'(A)') 'EXCH=',exch
        write(u6,'(A)') 'The calculation will continue, but might take a LOT of time'
        write(u6,'(A)') 'We recomend to switch OFF the computation of powder magnetization'
      end if

      if (.not. ab_initio_all) then

        !type of the center:   A -- the information is read from aniso_ion.input
        !                      B -- the center is isotropic with g factor read from the input
        !                      C -- the center is anisotropic with
        read(u5,*,iostat=istatus) (itype(i),i=1,Nneq)
        if (istatus /= 0) call Error(4)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,100A3)') 'itype: ',(itype(i),i=1,nneq)
        call xFlush(u6)
#       endif
        icount_B_sites = 0
        do i=1,nneq
          if ((itype(i) == 'B') .or. (itype(i) == 'C')) then
            icount_B_sites = icount_B_sites+1
            read(u5,*,iostat=istatus) (gtens_input(l,i),l=1,3),D_fact(i),EoverD_fact(i)
            if (istatus /= 0) call Error(4)
#           ifdef _DEBUGPRINT_
            write(u6,'(A,i4,A,3ES20.10, 2(A,ES20.10) )') 'gtens_input(',i,')=',(gtens_input(l,i),l=1,3),' D = ',D_fact(i), &
                                                         ' E/D =',EoverD_fact(i)
#           endif
            if ((itype(i) == 'C') .and. &
                ((gtens_input(1,i) /= gtens_input(2,i)) .or. (gtens_input(1,i) /= gtens_input(3,i)) .or. &
                 (gtens_input(2,i) /= gtens_input(3,i)))) then
              do ic=1,3
                read(u5,*,iostat=istatus) (riso(jc,ic,i),jc=1,3)
                if (istatus /= 0) call Error(4)
              end do

            else
              call unitmat(riso(:,:,i),3)
            end if
          end if

          if (abs(D_fact(i)) > Zero) then
            if (abs(EoverD_fact(i)/D_fact(i)) > One/Three) then
              write(string,'(A,i3,A)') 'NNEQ: |E/D| for center',i,' > 1/3'
              call WarningMessage(2,trim(string))
              write(u6,'(A,i3,A)') '|E/D| for center ',i,' is set to 1/3'
            end if
          end if
        end do
      else
        itype(:) = 'A'
      end if !ab_initio_all
      LINENR = LINENR+3+icount_B_sites
#     ifdef _DEBUGPRINT_
      call xFlush(u6)
#     endif

    !---  process LIN9 command ----------------------------------------*
    case ('LIN9')
      AnisoLines9 = .true.

      read(u5,*,iostat=istatus) npair
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i6)') 'LIN9:  nPair=',nPair
#     endif

      do i=1,npair
        ! the convention for 9 exchange interactions is
        ! Jxx, Jxy, Jxz, Jyx, Jyy, Jyz, Jzx, Jzy, Jzz
        read(u5,*,iostat=istatus) i_pair(i,1),i_pair(i,2),(JAex9(i,1,j),j=1,3),(JAex9(i,2,j),j=1,3),(JAex9(i,3,j),j=1,3)
        if (istatus /= 0) call Error(4)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,2I3,9F14.8)') 'LIN9: ',i_pair(i,1),i_pair(i,2),(JAex9(i,1,j),j=1,3),(JAex9(i,2,j),j=1,3),(JAex9(i,3,j),j=1,3)
#       endif
      end do
      LINENR = LINENR+npair+1

    !---  process LIN3 command ----------------------------------------*
    case ('ALIN','LIN3')
      AnisoLines3 = .true.

      read(u5,*,iostat=istatus) npair
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i6)') 'nPair=',nPair
#     endif

      do i=1,npair
        ! the convention for 3 exchange interactions is
        ! Jxx, Jyy, Jzz
        read(u5,*,iostat=istatus) i_pair(i,1),i_pair(i,2),(JAex(i,j),j=1,3)
        if (istatus /= 0) call Error(4)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,2i3,3F14.8)') 'ALIN/LIN3: ',i_pair(i,1),i_pair(i,2),(JAex(i,j),j=1,3)
#       endif
      end do
      LINENR = LINENR+npair+1

    !---  process JITO command ----------------------------------------*
    case ('ITOJ')
      JITO_exchange = .true.

      read(u5,*,iostat=istatus) npair
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i6)') 'nPair=',nPair
#     endif
      JITOexR(:,:,:,:,:) = Zero
      JITOexI(:,:,:,:,:) = Zero

      do i=1,npair
        ! the convention for exchange interactions is

        read(u5,*,iostat=istatus) i_pair(i,1),i_pair(i,2),imaxrank(i,1),imaxrank(i,2)
        if (istatus /= 0) call Error(4)
        do irank1=1,imaxrank(i,1),2
          do iproj1=-irank1,irank1
            do irank2=1,imaxrank(i,2),2
              do iproj2=-irank2,irank2
                read(u5,*,iostat=istatus) jrank1,jproj1,jrank2,jproj2,JITOexR(i,jrank1,jproj1,jrank2,jproj2), &
                                          JITOexI(i,jrank1,jproj1,jrank2,jproj2)
                if (istatus /= 0) call Error(4)
              end do
            end do
          end do
        end do

#       ifdef _DEBUGPRINT_
        write(u6,'(A,I3)') 'ITO Exchange parameters for pair:',i
        do jrank1=1,imaxrank(i,1),2
          do jproj1=-jrank1,jrank1
            do jrank2=1,imaxrank(i,2),2
              do jproj2=-jrank2,jrank2
                write(u6,'(4I3,2x,2ES21.14)') jrank1,jproj1,jrank2,jproj2,JITOexR(i,jrank1,jproj1,jrank2,jproj2), &
                                              JITOexI(i,jrank1,jproj1,jrank2,jproj2)
              end do
            end do
          end do
        end do
#       endif
      end do
      LINENR = LINENR+npair+1

    !---  process PAIR = LIN1 command ---------------------------------*
    case ('PAIR','LIN1')
      AnisoLines1 = .true.

      read(u5,*,iostat=istatus) npair
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i6)') 'nPair=',nPair
#     endif

      do i=1,npair

        read(u5,*,iostat=istatus) i_pair(i,1),i_pair(i,2),Jex(i)
        if (istatus /= 0) call Error(4)
#       ifdef _DEBUGPRINT_
        write(u6,'(i4,2x,2I4,2x,ES18.10)') i,i_pair(i,1),i_pair(i,2),Jex(i)
#       endif

      end do
      LINENR = LINENR+npair+1

    !---  process DMEX command ----------------------------------------*
    case ('DMEX')
      DM_exchange = .true.
#     ifdef _DEBUGPRINT_
      write(u6,'(A,L2)') 'DMEX::  DM_exchange=',DM_exchange
#     endif

      read(u5,*,iostat=istatus) npair
      if (istatus /= 0) call Error(4)
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i6)') 'nPair=',nPair
#     endif

      do i=1,npair
        ! the convention for 3 exchange interactions is
        ! JDMex(x, y, z)
        read(u5,*,iostat=istatus) i_pair(i,1),i_pair(i,2),(JDMex(i,j),j=1,3)
        if (istatus /= 0) call Error(4)
      end do
      LINENR = LINENR+npair+1
      !LINENR = LINENR+1

    !---  process ZEEM command ----------------------------------------*
    case ('ZEEM')
      zeeman_energy = .true.
      compute_magnetization = .true.
      LUZEE(:) = 0

      read(u5,*,iostat=istatus) nDirZee
      if (istatus /= 0) call Error(4)

      do i=1,nDirZee
        ! open the zeeman_energy_xxx.txt file where Zeeman eigenstates will
        ! be further written in mangetization() subroutine
        write(namefile_energy,'(5A)') 'zeeman_energy_',char(48+mod(i/100,10)),char(48+mod(i/10,10)),char(48+mod(i,10)),'.txt'
#       ifdef _DEBUGPRINT_
        write(u6,'(2A)') 'namefile_energy: ',namefile_energy
#       endif
        LUZee(i) = IsFreeUnit(30+i)
        call molcas_open(LUZee(i),namefile_energy)

        read(u5,*,iostat=istatus) (dir_weight(i,l),l=1,3)
        if (istatus /= 0) call Error(4)

        check_dir_weight = sqrt(dir_weight(i,1)**2+dir_weight(i,2)**2+dir_weight(i,3)**2)

        if (abs(check_dir_weight-One) > 0.005_wp) then
          write(u6,'(A)') 'The directions for the magnetic field for the computation of the Zeeman splitting are wrong.'
          write(u6,'(A)') '( px^2 + py^2 + pz^2 ) must give 1.!'
          write(u6,'(A,I3,2x,A,F9.5)') 'In the present case for direction Nr.',i,' the dir_weight = px^2 + py^2 + pz^2 = ', &
                                       check_dir_weight**2
          LINENR = LINENR+2+i
          call Error(4)
        end if

      end do
      LINENR = LINENR+nDirZee+1

    !---  process MAGN command ----------------------------------------*
    !case ('MAGN')
    !  compute_magnetization = .true.

    !---  process SYMM command ----------------------------------------*
    case ('SYMM')
      nosym = .false.
      check_symm_presence = .true.
      R_lg(:,:,:,:) = Zero
      R_rot(:,:,:,:) = Zero
#     ifdef _DEBUGPRINT_
      write(u6,'(A,i6)') 'SYMM - at init'
#     endif
      ll = 0
      do i=1,nneq
#       ifdef _DEBUGPRINT_
        write(u6,'(A,i6)') 'SYMM:  i=',i
#       endif

        read(u5,*,iostat=istatus) inneq
        if (istatus /= 0) call Error(4)
        unused_var(inneq)
#       ifdef _DEBUGPRINT_
        write(u6,'(A,i6)') 'inneq=',inneq
#       endif

        do j=1,Neq(i)
#         ifdef _DEBUGPRINT_
          write(u6,'(A,i6)') 'SYMM:  j=',j
#         endif
          do m=1,3
            ll = ll+1
            read(u5,*,iostat=istatus) (R_lg(i,j,m,n),n=1,3)
            if (istatus /= 0) call Error(4)
#           ifdef _DEBUGPRINT_
            write(u6,'(3ES20.12)') (R_lg(i,j,m,n),n=1,3)
#           endif
          end do
        end do

        do j=1,neq(i)
          tmpR(:,:) = R_lg(i,j,:,:)

          detR = FindDetR(tmpR,3)
#         ifdef _DEBUGPRINT_
          write(u6,'(A,3ES20.12)') 'SYMM:  detR=',detR
#         endif

          if (abs(abs(detR)-One) > 0.001_wp) then
            write(u6,'(A)') 'The rotation matrices must be UNITARY.'
            write(u6,'(A)') 'and of RIGHT hand system'
            write(u6,'(A,F11.6)') 'DET = ',detR
            LINENR = LINENR+ll+i+1
            call Error(4)
          end if
          if (detR < Zero) then
            R_rot(i,j,:,:) = -R_lg(i,j,:,:)
          else if (detR > Zero) then
            R_rot(i,j,:,:) = R_lg(i,j,:,:)
          end if
        end do !neq(i)
      end do !nneq
      LINENR = LINENR+nneq+ll

    !---  process EXCH command ----------------------------------------*
    case ('EXCH')
      decompose_exchange = .true.

    !---  process OLDA command ----------------------------------------*
    !case ('OLDA')
    !  old_aniso_format = .true.

    !---  process END command -----------------------------------------*
    !case ('END ')

    !---  process UBAR command ----------------------------------------*
    case ('UBAR')
      compute_barrier = .true.
      !read(u5,*,iostat=istatus) icase
      !if (istatus /= 0) call Error(4)
      !if (icase == 1) then
      !! icase =1  --> magnetic field is applied along the main magnetic
      !!               axis of each doublet (multiplet)
      !  continue
      !else if (icase == 2) then
      !! icase =2  --> magnetic field is applied along the main magnetic
      !!               axis of the specified doublet (number) number (NDim)
      !  read(u5,*,iostat=istatus) NmagMult
      !  if (istatus /= 0) call Error(4)
      !else if (icase == 3) then
      !! icase =3  --> a new coordination system is defined by the user,
      !!               and the magnetic field is applied along gZ (third axis)
      !  do i=1,3
      !    read(u5,*,iostat=istatus) (uBar_Rot(i,j),j=1,3)
      !    if (istatus /= 0) call Error(4)
      !  end do
      !  LINENR = LINENR+3
      !else
      !  write(u6,'(A)') 'Is the UBAR keyword used correctly?'
      !  write(u6,'(A)') 'The ICASE parameter is not understood.'
      !end if
      LINENR = LINENR+1

    !------------------------------------------------------------------*
    case ('ABCC')
      Do_structure_abc = .true.
      read(u5,*,iostat=istatus) (cryst(i),i=1,6)
      if (istatus /= 0) call Error(4)
      coord(:) = Zero
      !read(u5,*,iostat=istatus) (coord(i),i=1,3)
      !if (istatus /= 0) call Error(4)
      LINENR = LINENR+2
      ! array "cryst" collects the crystallographic data:
      !  cryst(1)= a
      !  cryst(2)= b
      !  cryst(3)= c
      !  cryst(4)= alpha
      !  cryst(5)= beta
      !  cryst(6)= gamma
      !  coord(i) =the coordinates of the magnetic center in "abc" axes
      !  logical variable 'Do_structure_abc' will make the program compute
      !  the magnetic and anisotropy axes in the "abc" coordinate system

    !---  process LONG command ----------------------------------------*
    case ('LONG')
      KE = .true.

      read(u5,*,iostat=istatus) lanth,tpar,upar,KEOPT
      if (istatus /= 0) call Error(4)
      call UpCase(lanth)

      select case (lanth)
        case ('GD')
          lant = 1
          multLn = 8
        case ('TB')
          lant = 2
          multLn = 13
        case ('DY')
          lant = 3
          multLn = 16
        case ('HO')
          lant = 4
          multLn = 17
        case ('ER')
          lant = 5
          multLn = 16
        case ('TM')
          lant = 6
          multLn = 13
        case ('YB')
          lant = 7
          multLn = 8
        case default
          write(u6,'( A)') 'Error in getting the type of the lanthanide!'
          write(u6,'(2A)') 'The program has this info: lanth =',lanth
          write(u6,'(26x,A,i2)') 'multLn =',multLn
      end select
      LINENR = LINENR+2

  end select
end do

! end of reading input keywords

!-----------------------------------------------------------------------

!=====  Perform some PROCESSING of the data ============================

if (.not. nosym) then
  if (.not. check_symm_presence) then
    write(u6,'(A)') 'The SYMM keyword is mandatory if the system '
    write(u6,'(A)') 'contains more than one center of the same type!'
    call quit(_RC_INPUT_ERROR_)
  end if !check_symm_presence
end if !nosym

! preparing the info for computation of molar magnetization
! calculate the total number of directions for the average procedure

!--------  definition g and D tensors ----------------------------------
if (compute_g_tensors) then
  nst = 0
  do i=1,nMult
    nst = nst+ndim(i)
    if (nst > exch) then
      write(u6,'(A)') 'You have requested the computation of properties of more states'
      write(u6,'(A)') 'than the total number of exchange states.'
      write(u6,'(A)') 'The program does not know how to compute'
      write(u6,'(A)') 'properties of inexistent states'
      write(u6,'(A)') 'New settings:'
      write(u6,'(A,i6)') 'NMULT = ',i-1

      nmult = i-1
      exit
    end if
  end do
end if
#ifdef _DEBUGPRINT_
write(u6,*) 'READIN_POLY:  after proc g and D'
call xFlush(u6)
#endif

!--------  definition of exchange --------------------------------------
if (npair > 0) then
  ASUM = 0
  do lp=1,nPair
    ASUM = ASUM+i_pair(lp,1)+i_pair(lp,2)
  end do
  if (Dipol .and. (ASUM == 0)) then
    lp = 0
    do i=1,nCenter-1
      do j=i+1,nCenter
        lp = lp+1
        i_pair(lp,1) = i
        i_pair(lp,2) = j
#       ifdef _DEBUGPRINT_
        write(u6,'(A,i3,A,2I3)') 'lp=',lp,' i_pair(lp,1:2)=',i_pair(lp,1),i_pair(lp,2)
#       endif
      end do
    end do
  end if

  call mma_allocate(Duplicate_check,nPair,label='Duplicate_check')
  do i=1,npair
    Duplicate_check(i) = 1000*i_pair(i,1)+i_pair(i,2)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Duplicate_check: ',Duplicate_check(i)
#   endif

    if (i_pair(i,1) == i_pair(i,2)) then
      write(u6,'(A,i2,a)') 'The center ',i_pair(i,1),' interacts with itself.'
      write(u6,'(A)') 'This is not possible. The program has to stop.'
      call quit(_RC_INPUT_ERROR_)

    else if (i_pair(i,1) > i_pair(i,2)) then
      write(u6,'(A)') 'The convention of this program enforces the label of the first magnetic center of a given '
      write(u6,'(A)') 'interaction to be smaller than the label of the second magnetic center.'
      write(u6,'(A)') 'In order to avoid confusions, please respect this convention.'
      write(u6,'(A)') 'Avoid duplicate interactions!'
      write(u6,'(A)') 'The program will stop now.'
      call quit(_RC_INPUT_ERROR_)
    end if
  end do
# ifdef _DEBUGPRINT_
  call xFlush(u6)
# endif

  ! check on the duplicate
  do i=1,npair
    do j=i+1,npair
      if (Duplicate_check(i) == Duplicate_check(j)) then
        write(u6,'(A)') 'Some interactions are declared twice in the input. Please declare all interactions only once!'
        write(u6,'(A)') 'The program has to stop.'
        call quit(_RC_INPUT_ERROR_)
      end if
    end do
  end do
  call mma_deallocate(Duplicate_check)

  ! check on the indices of the exchange couplings:
  do i=1,nPair
    if ((i_pair(i,1) > nCenter) .or. (i_pair(i,2) > nCenter)) then
      write(u6,'(A)') 'The numbering of the magnetic centers within NPAIR keyword is wrong.'
      write(u6,'(A,i2,a)') 'For the interaction Nr. = ',i, &
                           ' you numerate individual centers with numbers larger than the total number of centers in this molecule.'
      write(u6,'(A)') 'NPAIR keyword is wrong.'
      write(u6,'(A,I4)') 'i_pair(i,1) =',i_pair(i,1)
      write(u6,'(A,I4)') 'i_pair(i,2) =',i_pair(i,2)
      write(u6,'(A)') 'The program has to stop.'
      call quit(_RC_INPUT_ERROR_)
    end if
  end do

  ! check on the size of MxRank1 and MxRank2 wrt nexch(1) and nexch(2)
  if (JITO_exchange) then
    call mma_allocate(nind,exch,2,label='nind')
    l = 0
    do i=1,nneq
      do j=1,neq(i)
        l = l+1
        nind(l,1) = i
        nind(l,2) = j
      end do
    end do

    do lp=1,npair
      lb1 = i_pair(lp,1)
      lb2 = i_pair(lp,2)
      i1 = nind(lb1,1) ! indices of non-equivalent sites
      i2 = nind(lb2,1) ! indices of non-equivalent sites
      if (nExch(i1) < (imaxrank(lp,1)+1)) then
        write(u6,'(A)') repeat('#',100)
        write(u6,'(A)') 'interacting pair = ',lp
        write(u6,'(A)') 'type of site 1 = ',i1
        write(u6,'(A,i2,A,i2)') 'nExch(',i1,') = ',nExch(i1)
        write(u6,'(A,i2,A,i2)') 'Rank2(',lp,',1) = ',imaxrank(lp,1)
        write(u6,'(A)') 'nExch < Rank+1 !!!'
        write(u6,'(A)') 'Rank of ITO operators for site 1 is larger than the number of defined exchange states for this site'
        write(u6,'(A)') 'The program will use only parameters which bring non-zero contribution to exchange.'
        write(u6,'(A)') repeat('#',100)
      end if
      if (nExch(i2) < (imaxrank(lp,2)+1)) then
        write(u6,'(A)') repeat('#',100)
        write(u6,'(A)') 'interacting pair = ',lp
        write(u6,'(A)') 'type of site 2 = ',i2
        write(u6,'(A,i2,A,i2)') 'nExch(',i2,') = ',nExch(i2)
        write(u6,'(A,i2,A,i2)') 'Rank2(',lp,',2) = ',imaxrank(lp,2)
        write(u6,'(A)') 'nExch < Rank+1 !!!'
        write(u6,'(A)') 'Rank of ITO operators for site 2 is larger than the number of defined exchange states for this site'
        write(u6,'(A)') 'The program will use only parameters which bring non-zero contribution to exchange.'
        write(u6,'(A)') repeat('#',100)
      end if
    end do
    call mma_deallocate(nind)
  end if ! JITO_exchange
end if ! nPair

#ifdef _DEBUGPRINT_
write(u6,*) 'READIN_POLY:  before 200 '
call xFlush(u6)
#endif
!--------  definition of exchange --------------------------------------

!-----------------------------------------------------------------------
!write(u6,*) ' The following input line was not understood:'
!write(u6,'(A)') LINE

! ===============   NORMAL ENDING  =====================================

if (IPRINT > 2) write(u6,'(5X,A)') 'NO ERROR WAS LOCATED WHILE READING INPUT'

return

contains

subroutine Error(code)

  integer(kind=iwp), intent(in) :: code

  select case (code)
    case (1)
      write(u6,*) 'READIN_POLY: THE TINT command is incompatible with TEXP'
    case (2)
      write(u6,*) 'READIN_POLY: THE HINT command is incompatible with HEXP'
    case (3)
      write(u6,*) 'READIN_POLY: THE NCUT, ENCU, and ERAT are mutually exclusive. '// &
                  'You cannot use more than one keyword at the same time.'
    case (4)
      write(u6,*) ' READIN_POLY: Error reading "poly_aniso.input" '
      write(u6,*) ' near line nr.',LINENR+1
    case (5)
      write(u6,*) ' READIN_POLY: Unexpected End of input file.'
  end select
  call quit(_RC_INPUT_ERROR_)

end subroutine Error

end subroutine Readin_poly

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_PRTDIA(DIAG,ISYLST,NSYLST,IRED)
!
! Purpose: print requested symmetry block(s) of diagonal in
!          first (IRED=1) or current (IRED=2) reduced set.

use Cholesky, only: iiBstR, iiBstRSh, IndRed, IndRSh, iSP2F, LuPri, nnBstRSh, nnShl, nSym
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NSYLST, ISYLST(NSYLST), IRED
real(kind=wp), intent(in) :: Diag(*)
integer(kind=iwp) :: IAB, IAB1, IAB2, ILST, ISHLAB, ISYM, JAB
character(len=*), parameter :: SECNAM = 'CHO_PRTDIA'

! Check dimension of symmetry list.
! ---------------------------------

if (NSYLST < 1) then
  return
else if (NSYLST > NSYM) then
  write(LUPRI,'(//,1X,A,A)') SECNAM,': NSYLST <= NSYM required!'
  write(LUPRI,'(1X,A,I10)') 'NSYLST = ',NSYLST
  write(LUPRI,'(1X,A,I10,/)') 'NSYM   = ',NSYM
  call CHO_QUIT('[0] Symmetry error in '//SECNAM,102)
end if

! Code for first or current reduced set.
! --------------------------------------

if (IRED == 1) then
  call CHO_HEAD(SECNAM//': Diagonal in Original Reduced Set','=',80,LUPRI)
  do ILST=1,NSYLST
    ISYM = ISYLST(ILST)
    if ((ISYM < 1) .or. (ISYM > NSYM)) then
      write(LUPRI,*) SECNAM,': element ',ILST,': ',ISYM,' of list ISYLST is out of bounds!'
      call CHO_QUIT('ISYLST input error in '//SECNAM,104)
    else
      write(LUPRI,'(/,A,I2)') 'Symmetry block:',ISYM
      write(LUPRI,'(/,A,/,A)') '  Element Shell-Pair  SP Index         Diagonal','-----------------------------------------------'
      do ISHLAB=1,NNSHL
        IAB1 = IIBSTR(ISYM,IRED)+IIBSTRSH(ISYM,ISHLAB,IRED)+1
        IAB2 = IAB1+NNBSTRSH(ISYM,ISHLAB,IRED)-1
        do IAB=IAB1,IAB2
          if (INDRSH(IAB) /= ISP2F(ISHLAB)) then
            write(LUPRI,*) 'Shell Pair error: INDRSH,ISP2F,ISHLAB',INDRSH(IAB),ISP2F(ISHLAB),ISHLAB
            call CHO_QUIT('Shell-Pair error in '//SECNAM,104)
          else
            JAB = IAB
            write(LUPRI,'(I9,2X,I9,1X,I9,1X,ES16.8)') JAB,ISP2F(ISHLAB),INDRED(IAB,IRED),DIAG(JAB)
          end if
        end do
      end do
      write(LUPRI,'(A)') '-----------------------------------------------'
    end if
  end do
else if (IRED == 2) then
  call CHO_HEAD(SECNAM//': Diagonal in Current Reduced Set','=',80,LUPRI)
  do ILST=1,NSYLST
    ISYM = ISYLST(ILST)
    if ((ISYM < 1) .or. (ISYM > NSYM)) then
      write(LUPRI,*) SECNAM,': element ',ILST,': ',ISYM,' of list ISYLST is out of bounds!'
      call CHO_QUIT('ISYLST input error in '//SECNAM,104)
    else
      write(LUPRI,'(/,A,I2)') 'Symmetry block:',ISYM
      write(LUPRI,'(/,A,/,A)') '  Element  RedSet 1 Shell-Pair  SP Index         Diagonal', &
                               '---------------------------------------------------------'
      do ISHLAB=1,NNSHL
        IAB1 = IIBSTR(ISYM,IRED)+IIBSTRSH(ISYM,ISHLAB,IRED)+1
        IAB2 = IAB1+NNBSTRSH(ISYM,ISHLAB,IRED)-1
        do IAB=IAB1,IAB2
          JAB = INDRED(IAB,IRED)
          if (INDRSH(JAB) /= ISP2F(ISHLAB)) then
            write(LUPRI,*) 'Shell Pair error: INDRSH,ISP2F,ISHLAB',INDRSH(JAB),ISP2F(ISHLAB),ISHLAB
            call CHO_QUIT('Shell-Pair error in '//SECNAM,104)
          else
            write(LUPRI,'(I9,1X,I9,2X,I9,1X,I9,1X,ES16.8)') IAB,JAB,ISP2F(ISHLAB),INDRED(JAB,1),DIAG(JAB)
          end if
        end do
      end do
      write(LUPRI,'(A)') '---------------------------------------------------------'
    end if
  end do
end if

end subroutine CHO_PRTDIA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine MVeMem( &
#                 define _CALLING_
#                 include "mem_interface.fh"
                 )

use Definitions, only: iwp

implicit none
#include "mem_interface.fh"

nHer = (la+lb+lr+2)/2
Mem = 3*nHer*(la+3)+3*nHer*(lb+3)+3*nHer*(lr-3)+3*(la+3)*(lb+3)*(lr-3)+3*(la+1)*(lb+1)*2+3*(la+1)*(lb+1)+1+1

return

end subroutine MVeMem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
*               1994, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Dot1El2(Kernel,KrnlMm,Hess,nGrad,DiffOp,CCoor,
     &                 FD,nordop)
************************************************************************
*                                                                      *
* Object: to compute gradients of the one electron integrals.          *
*         The memory at this point is assumed to be large enough to do *
*         the computation in core.                                     *
*         The data is structured with respect to four indices, two (my *
*         ny or i j) refer to primitives or basis functions and two (a *
*         b) refer to the components of the cartesian or spherical     *
*         harmonic gaussians.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*             Modified for Hermite-Gauss quadrature November '90       *
*             Modified for Rys quadrature November '90                 *
*             Modified for multipole moments November '90              *
*                                                                      *
*             Modified for general kernel routines January '91         *
*             Modified for nonsymmetrical operators February '91       *
*             Modified for gradients October '91                       *
*             Modified for Hessians by AB   Dec '94                    *
************************************************************************
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iOper
      use Sizes_of_Seward, only: S
      Implicit Real*8 (A-H,O-Z)
      External Kernel, KrnlMm
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "disp.fh"
#include "nsd.fh"
#include "setup.fh"
      Real*8 A(3), B(3), Ccoor(3), FD(*),
     &       RB(3), Hess(nGrad)
      Integer iDCRR(0:7), iDCRT(0:7), iStabM(0:7),iCoM(0:7,0:7),
     &           nOp(2),
     &           iStabO(0:7),IndGrd(2,3,3,0:7)
      Logical AeqB, EQ, TstFnc, DiffOp,
     &        TF
*
*     Statement functions
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
*
      call dcopy_(nGrad,[Zero],0,Hess,1)
*
*     Auxiliary memory allocation.
*
      Call GetMem('Zeta','ALLO','REAL',iZeta,S%m2Max)
      Call GetMem('Zeta','ALLO','REAL',ipZI ,S%m2Max)
      Call GetMem('Kappa','ALLO','REAL',iKappa,S%m2Max)
      Call GetMem('PCoor','ALLO','REAL',iPCoor,S%m2Max*3)
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Basis_Mode('Valence')
      Call Nr_Shells(nSkal)
      Call Setup_iSD()
*                                                                      *
************************************************************************
*                                                                      *
*     Double loop over shells.
*
      nTasks = nSkal*(nSkal+1)/2
      iS = 0
      jS = 0
      Do ijS = 1, nTasks
         jS = jS + 1
         If (jS.gt.iS) Then
            iS = jS
            jS = 1
         End If
C     Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
C        Do jS = 1, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
            B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
*       Call kernel routine to get memory requirement.
*
        Call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)
        MemKrn=MemKer*S%m2Max
        Call GetMem('Kernel','ALLO','REAL',iKern,MemKrn)
*
*       Allocate memory for the final integrals, all in the
*       primitive basis.
*
*
*       Scratch area for contraction step
*
        nScr1 =  S%MaxPrm(iAng)*S%MaxPrm(jAng) *
     &           nElem(iAng)*nElem(jAng)
        Call GetMem('Scrtch','ALLO','REAL',iScrt1,nScr1)
*
*       Scratch area for the transformation to spherical gaussians
*
        nScr2=S%MaxPrm(iAng)*S%MaxPrm(jAng)*nElem(iAng)*nElem(jAng)
        Call GetMem('ScrSph','Allo','Real',iScrt2,nScr2)
*
          Call GetMem(' DAO ','Allo','Real',ipDAO,
     &                iPrim*jPrim*nElem(iAng)*nElem(jAng))
*
*         At this point we can compute Zeta.
*
          Call ZXia(Work(iZeta),Work(ipZI),
     &              iPrim,jPrim,Shells(iShll)%Exp,
     &                          Shells(jShll)%Exp)
*
            AeqB = iS.eq.jS
*
*           Find the DCR for A and B
*
            Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &                     dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
            If (.Not.DiffOp .and. nDCRR.eq.1 .and. EQ(A,B)) Go To 131
*
*-----------Find the stabilizer for A and B
*
            Call Inter(dc(mdci)%iStab,dc(mdci)%nStab,
     &                 dc(mdcj)%iStab,dc(mdcj)%nStab,
     &                 iStabM,nStabM)
*
*          Generate all possible (left) CoSet
*          To the stabil. of A and B
*
            Do 433 i = 0, nIrrep-1
               Do 434 j = 0, nStabM-1
                  iCoM(i,j) = iEor(iOper(i),iStabM(j))
 434            Continue
 433         Continue
*           Order the Coset so we will have the unique ones first
            nMax = 1
            Do 435 j = 1, nIrrep-1
*              Check uniqueness
               Do 436 i = 0, nMax - 1
                  Do 437 ielem = 0, nStabM-1
                     If (iCoM(i,1).eq.iCoM(j,ielem))
     &                  Go To 435
 437               Continue
 436            Continue
*              Move unique CoSet
               nMax = nMax + 1
               Do 438 ielem = 0, nStabM-1
                  iTmp = iCoM(nMax-1,ielem)
                  iCoM(nMax-1,ielem) = iCoM(j,ielem)
                  iCoM(j,ielem) = iTmp
 438            Continue
               If (nMax.eq.nIrrep/nStabM) Go To 439
 435         Continue
 439         Continue
             nCoM=nIrrep/nStabM
*
*           Allocate memory for the elements of the Fock or 1st order
*           denisty matrix which are associated with the current shell
*           pair.
*
            iSmLbl = 1
            nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            If (nSO.eq.0) Go To 131
            Call GetMem('DSOpr ','ALLO','REAL',ipDSOp,nSO*iPrim*jPrim)
            Call GetMem('DSO ','ALLO','REAL',ipDSO,nSO*iPrim*jPrim)
            call dcopy_(nSO*iPrim*jPrim,[Zero],0,Work(ipDSO),1)
            call dcopy_(nSO*iPrim*jPrim,[Zero],0,Work(ipDSOp),1)
*
*           Gather the elements from 1st order density / Fock matrix.
*
            Call SOGthr(Work(ipDSO),iBas,jBas,nSO,FD,
     &                  n2Tri(iSmLbl),iSmLbl,
     &                  iCmp,jCmp,iShell,jShell,
     &                  AeqB,iAO,jAO)
*
*           Project the Fock/1st order density matrix in AO
*           basis on to the primitive basis.
*
*
*           Transform IJ,AB to J,ABi
            Call DGEMM_('T','T',
     &                  jBas*nSO,iPrim,iBas,
     &                  1.0d0,Work(ipDSO),iBas,
     &                        Shells(iShll)%pCff,iPrim,
     &                  0.0d0,Work(ipDSOp),jBas*nSO)
*           Transform J,ABi to AB,ij
            Call DGEMM_('T','T',
     &                  nSO*iPrim,jPrim,jBas,
     &                  1.0d0,Work(ipDSOp),jBas,
     &                        Shells(jShll)%pCff,jPrim,
     &                  0.0d0,Work(ipDSO),nSO*iPrim)
*           Transpose to ij,AB
            Call DGeTmO(Work(ipDSO),nSO,nSO,iPrim*jPrim,Work(ipDSOp),
     &                  iPrim*jPrim)
            Call GetMem('DSO ','Free','Real',ipDSO,nSO*iBas*jBas)
*
*
*           Loops over symmetry operations.
*
            nOp(1) = NrOpr(0)
            if(jBas.lt.-999999) write(6,*) 'gcc overoptimization',nDCRR
            Do 140 lDCRR = 0, nDCRR-1
               Call OA(iDCRR(lDCRR),B,RB)
               nOp(2) = NrOpr(iDCRR(lDCRR))
               If (EQ(A,RB).and. (.Not.DiffOp)) Go To 140
*
*
               lloper=1
               Call SOS(iStabO,nStabO,llOper)
               Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
*--------------Compute normalization factor due the DCR symmetrization
*              of the two basis functions and the operator.
*
               iuv = dc(mdci)%nStab*dc(mdcj)%nStab
               FactNd = DBLE(iuv*nStabO) / DBLE(nIrrep**2 * LmbdT)
               If (MolWgh.eq.1) Then
                  FactNd = FactNd * DBLE(nIrrep)**2 / DBLE(iuv)
               Else If (MolWgh.eq.2) Then
                  FactNd = sqrt(DBLE(iuv))*nStabO/DBLE(nIrrep*LmbdT)
               End If
*
*
*--------------Desymmetrize the matrix with which we will
*              contracte the trace.
*
               Call DesymD(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                     iShell,jShell,iShll,jShll,
     &                     iAO,jAO,Work(ipDAO),iPrim,jPrim,
     &                     Work(ipDSOp),nSO,nOp,FactNd)
*
*--------------Project the spherical harmonic space onto the
*              cartesian space.
*
               kk = nElem(iAng)*nElem(jAng)
               If (Shells(iShll)%Transf.or.Shells(jShll)%Transf) Then
*
*-----------------ij,AB --> AB,ij
                  Call DGeTmO(Work(ipDAO),iPrim*jPrim,iPrim*jPrim,
     &                        iCmp*jCmp,Work(iScrt1),iCmp*jCmp)
*-----------------AB,ij --> ij,ab
                  Call SphCar(Work(iScrt1),iCmp*jCmp,iPrim*jPrim,
     &                        Work(iScrt2),nScr2,
     &                        RSph(ipSph(iAng)),iAng,
     &                        Shells(iShll)%Transf,
     &                        Shells(iShll)%Prjct,
     &                        RSph(ipSph(jAng)),jAng,
     &                        Shells(jShll)%Transf,
     &                        Shells(jShll)%Prjct,
     &                        Work(ipDAO),kk)
               End If
*
*--------------Compute kappa and P.
*
               Call Setup1(Shells(iShll)%Exp,iPrim,
     &                     Shells(jShll)%Exp,jPrim,
     &                     A,RB,Work(iKappa),Work(iPCoor),Work(ipZI))
*
*
               Call Icopy(18*nirrep,[0],0,IndGrd,1)
               kk=0
               Do jIrrep=0,nirrep-1
               Do Jcar=1,3
                iirrep=irrfnc(2**(jcar-1))
                If (iirrep.eq.jirrep) Then
                jj=0
                Do i=0,jirrep-1
                 jj=ldisp(i)+jj
                End do
                nDisp = IndDsp(mdci,jIrrep)-jj
                Do iCar=1,3
                 iComp = 2**(iCar-1)
                 If ( TF(mdci,jIrrep,iComp)) Then
                  ndisp=ndisp+1
                  IndGrd(1,icar,jcar,jIrrep) = kk+nDisp
                 End If
                end do
                kk=kk+ldisp(jirrep)
               End If
               End Do
               End Do
*
               kk=0
               Do jIrrep=0,nirrep-1
               Do Jcar=1,3
                iirrep=irrfnc(2**(jcar-1))
                If (iirrep.eq.jirrep) then
                jj=0
                Do i=0,jirrep-1
                 jj=ldisp(i)+jj
                End do
                nDisp = IndDsp(mdcj,jIrrep)-jj
                Do iCar=1,3
                 iComp = 2**(iCar-1)
                 If ( TF(mdcj,jIrrep,iComp)) Then
                  ndisp=ndisp+1
                  IndGrd(2,icar,jcar,jIrrep) = kk+nDisp
                 End If
                end do
                kk=kk+ldisp(jirrep)
               End If
               End Do
               End Do

*
*--------------Compute gradients of the primitive integrals and
*              trace the result.
*


               Call Kernel(Shells(iShll)%Exp,iPrim,
     &                     Shells(jShll)%Exp,jPrim,
     &                     Work(iZeta),Work(ipZI),
     &                     Work(iKappa),Work(iPcoor),
     &                     iPrim*jPrim,
     &                     iAng,jAng,A,RB,nOrder,Work(iKern),
     &                     MemKer,Ccoor,
     &                     nOrdOp,Hess,
     &                     indgrd,Work(ipDAO),
     &                     mdci,mdcj,nOp,
     &                     iStabM,nStabM)
*
 140        Continue
*
            Call GetMem('DSOpr ','Free','REAL',ipDSOp,nSO*iPrim*jPrim)
 131        Continue
         Call GetMem(' DAO ','Free','Real',ipDAO,iPrim*jPrim*
     &                nElem(iAng)*nElem(jAng))
         Call GetMem('ScrSph','Free','Real',iScrt2,nScr2)
         Call GetMem('Scrtch','Free','Real',iScrt1,nScr1)
         Call GetMem('Kernel','Free','Real',iKern,MemKrn)
*
C        End Do
C     End Do
      End Do
*
      Call Free_iSD()
*
      Call GetMem('Kappa','FREE','REAL',iKappa,S%m2Max)
      Call GetMem('PCoor','FREE','REAL',iPCoor,S%m2Max*3)
      Call GetMem('Zeta','FREE','REAL',ipZI ,S%m2Max)
      Call GetMem('Zeta','FREE','REAL',iZeta,S%m2Max)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
      Subroutine ChkLumo(OccSet,FermSet,SpinSet)
************************************************************************
*                                                                      *
* This routine figure out the status of the lumo file, i.e. should it  *
* trigger keywords OCCUpied or FERMi?                                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University, Sweden                                     *
*                                                                      *
************************************************************************
#ifdef _HDF5_
      Use mh5, Only: mh5_exists_dset
#endif
      Implicit Real*8 (A-H,O-Z)
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*----------------------------------------------------------------------*
* Dummy arguments                                                      *
*----------------------------------------------------------------------*
      Logical OccSet
      Logical FermSet
      Logical SpinSet
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Character*512 FNAME
      Logical      Idem
      Real*8, Dimension(:,:), Allocatable:: OccVec, EpsVec
      Dimension Dummy(1),iDummy(1)
*----------------------------------------------------------------------*
* Setup                                                                *
*----------------------------------------------------------------------*
      Call Peek_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      nVec=0
      Do iSym=1,nSym
         nVec=nVec+nBas(iSym)
      End Do
*----------------------------------------------------------------------*
* Allocate fields                                                      *
*----------------------------------------------------------------------*
      nD = (iUHF+1)
      Call mma_Allocate(OccVec,nVec,nD,Label='OccVec')
      Call mma_Allocate(EpsVec,nVec,nD,Label='EpsVec')
*----------------------------------------------------------------------*
* Read occupation numbers and orbital energies                         *
*----------------------------------------------------------------------*
      Lu=17
      FName=SCF_FileOrb
      If(iUHF.eq.0) Then
         If (isHDF5) Then
            Call RdVec_HDF5(fileorb_id,'OE',nSym,nBas,
     &                      Dummy,OccVec(1,1),EpsVec(1,1),iDummy)
         Else
            Call RdVec_(FNAME,Lu,'OE',iUHF,nSym,nBas,nOrb,Dummy,Dummy,
     &         OccVec(1,1),Dummy,EpsVec(1,1),Dummy,
     &         iDummy,VTitle,1,iErr,iWFtype)
         End If
      Else
         isUHF=0
         If (isHDF5) Then
#ifdef _HDF5_
            If (mh5_exists_dset(fileorb_id,'MO_ALPHA_VECTORS')) isUHF=1
#endif
         Else
            Lu_=18
            isUHF=-1
            Call Chk_Vec_UHF(FNAME,Lu_,isUHF)
         End If
         If(isUHF.eq.1) Then
            If (isHDF5) Then
               Call RdVec_HDF5(fileorb_id,'OEA',nSym,nBas,
     &                         Dummy,OccVec(1,1),EpsVec(1,1),iDummy)
               Call RdVec_HDF5(fileorb_id,'OEB',nSym,nBas,
     &                         Dummy,OccVec(1,2),EpsVec(1,2),iDummy)
            Else
               Call RdVec_(FNAME,Lu,'OE',iUHF,nSym,nBas,nOrb,Dummy,
     &            Dummy,OccVec(1,1),OccVec(1,2),EpsVec(1,1),EpsVec(1,2),
     &            iDummy,VTitle,1,iErr,iWFtype)
            End If
         Else
            If (isHDF5) Then
               Call RdVec_HDF5(fileorb_id,'OE',nSym,nBas,
     &                         Dummy,OccVec(1,1),EpsVec(1,1),iDummy)
            Else
               Call RdVec_(FNAME,Lu,'OE',0,nSym,nBas,nOrb,Dummy,Dummy,
     &            OccVec(1,1),Dummy,EpsVec(1,1),Dummy,
     &            iDummy,VTitle,1,iErr,iWFtype)
            End If
            Call dCopy_(nVec,OccVec(1,1),1,OccVec(1,2),1)
            Call dCopy_(nVec,EpsVec(1,1),1,EpsVec(1,2),1)
            Call dScal_(nVec*nD,0.5d0,OccVec,1)
         End If
      End If
*     If(iUHF.eq.0) Then
*        Write(6,*) 'Orbital energies'
*        Write(6,'(10f12.6)') (Work(ipEpsa-1+i),i=1,nVec)
*        Write(6,*) 'Occupation numbers'
*        Write(6,'(10f12.6)') (Work(ipOcca-1+i),i=1,nVec)
*     Else
*        Write(6,*) 'Alpha orbital energies'
*        Write(6,'(10f12.6)') (Work(ipEpsa-1+i),i=1,nVec)
*        Write(6,*) 'Alpha occupation numbers'
*        Write(6,'(10f12.6)') (Work(ipOcca-1+i),i=1,nVec)
*        Write(6,*) 'Beta orbital energies'
*        Write(6,'(10f12.6)') (Work(ipEpsb-1+i),i=1,nVec)
*        Write(6,*) 'Beta occupation numbers'
*        Write(6,'(10f12.6)') (Work(ipOccb-1+i),i=1,nVec)
*     End If
*----------------------------------------------------------------------*
* What are the charges                                                 *
*----------------------------------------------------------------------*
      qa=0.0d0
      qb=0.0d0
      If(iUHF.eq.0) Then
         Do i=1,nVec
            qa=qa+OccVec(i,1)
         End Do
         qa=0.5d0*qa
         qb=qa
      Else
         Do i=1,nVec
            qa=qa+OccVec(i,1)
         End Do
         Do i=1,nVec
            qb=qb+OccVec(i,2)
         End Do
      End If
*     If(iUHF.eq.0) Then
*        Write(6,'(a,f12.6)') 'Tot charge         ',Tot_charge
*        Write(6,'(a,f12.6)') 'Tot nuc. charge    ',Tot_nuc_charge
*        Write(6,'(a,f12.6)') 'Tot el. charge     ',Tot_el_charge
*        Write(6,'(a,f12.6)') 'Electron count     ',qa
*     Else
*        Write(6,'(a,f12.6)') 'Tot charge         ',Tot_charge
*        Write(6,'(a,f12.6)') 'Tot nuc. charge    ',Tot_nuc_charge
*        Write(6,'(a,f12.6)') 'Tot el. charge     ',Tot_el_charge
*        Write(6,'(a,f12.6)') 'Alpha count        ',qa
*        Write(6,'(a,f12.6)') 'Beta count         ',qb
*     End If
*----------------------------------------------------------------------*
* Is it the same charge.                                               *
*----------------------------------------------------------------------*
      If(Abs(qa+qb+Tot_el_charge).gt.0.5d0) Then
*        Write(6,*) 'chklumo: System have changed charge!'
         Occset=.false.
         FermSet=.true.
         Goto 999
      End If
*----------------------------------------------------------------------*
* Is it the same spin.                                                 *
*----------------------------------------------------------------------*
      If(SpinSet) Then
*        Write(6,*) 'chklumo: System might have changed spin!'
*        Write(6,*) '   iAu_ab=',iAu_ab
*        Write(6,*) '   qa-qb=',qa-qb
         idiff=iAu_ab-Int(qa-qb)
         If(idiff.ne.0) Then
*           Write(6,*) '   yes indeed, spin has changed!'
            Occset=.false.
            FermSet=.true.
            Goto 999
         End If
      End If
*----------------------------------------------------------------------*
* Is it idempotent                                                     *
*----------------------------------------------------------------------*
      If(iUHF.eq.0) Then
         Idem=.true.
         Do i=1,nVec
            tmp=0.5d0*OccVec(i,1)*(1.0d0-0.5d0*OccVec(i,1))
            If(Abs(tmp).gt.0.05d0) Idem=.false.
         End Do
*        Write(6,*) 'chklumo: Idempotency'
*        Write(6,'(10f12.6)') (Work(ic+i),i=1,nVec)
      Else
         Idem=.true.
         Do i=1,nVec
            tmp=OccVec(i,1)*(1.0d0-OccVec(i,1))
            If(Abs(tmp).gt.0.05d0) Idem=.false.
         End Do
*        Write(6,*) 'chklumo: Alpha idempotency'
*        Write(6,'(10f12.6)') (Work(ic+i),i=1,nVec)
         Do i=1,nVec
            tmp=OccVec(i,2)*(1.0d0-OccVec(i,2))
            If(Abs(tmp).gt.0.05d0) Idem=.false.
         End Do
*        Write(6,*) 'chklumo: Beta idempotency'
*        Write(6,'(10f12.6)') (Work(ic+i),i=1,nVec)
      End If
*----------------------------------------------------------------------*
* Was it idempotent?                                                   *
*----------------------------------------------------------------------*
      If(Idem) Then
*        Write(6,*) 'chklumo: Idempotent'
         If(iUHF.eq.0) Then
            iOff=0
            Do iSym=1,nSym
               n=0
               Do iBas=1,nBas(iSym)
                  If(OccVec(iOff+iBas,1).gt.1.0d0) n=n+1
               End Do
               nOcc(iSym,1)=n
               iOff=iOff+nBas(iSym)
            End Do
*           Write(6,'(a,8i5)') 'Occupation       ',(nOcc(i,1),i=1,nSym)
         Else
            iOff=0
            Do iSym=1,nSym
               n=0
               Do iBas=1,nBas(iSym)
                  If(OccVec(iOff+iBas,1).gt.0.5d0) n=n+1
               End Do
               nOcc(iSym,1)=n
               iOff=iOff+nBas(iSym)
            End Do
            iOff=0
            Do iSym=1,nSym
               n=0
               Do iBas=1,nBas(iSym)
                  If(OccVec(iOff+iBas,2).gt.0.5d0) n=n+1
               End Do
               nOcc(iSym,2)=n
               iOff=iOff+nBas(iSym)
            End Do
*           Write(6,'(a,8i5)') 'Alpha occupation ',(nOcc(i,1),i=1,nSym)
*           Write(6,'(a,8i5)') 'Beta occupation  ',(nOcc(i,2),i=1,nSym)
         End If
         Occset=.true.
         FermSet=.false.
      Else
*        Write(6,*) 'Not idempotent'
         Occset=.false.
         FermSet=.true.
      End If
*----------------------------------------------------------------------*
* Deallocate fields                                                    *
*----------------------------------------------------------------------*
999   Continue
      Call mma_deallocate(EpsVec)
      Call mma_deallocate(OccVec)
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_X_NumRd
!
!> @brief
!>   Return the number of Cholesky vectors that may be read into \p Mem words of memory.
!> @author Thomas Bondo Pedersen
!>
!> @details
!> The count starts at vector \p iVec1 of symmetry \p iSym
!> (this is needed since the vectors are stored in
!> different reduces sets).
!> On exit, \p Cho_X_NumRd is negative if some error has
!> occurred (``-1``, ``-2``, and ``-3`` signify errors in input
!> variables, ``-4`` indicates an error in \p Cho_X_SetRed).
!>
!> @note
!> The Cholesky procedure must have been successfully initialized (by ::Cho_X_Init).
!>
!> @param[in]     iVec1 First vector
!> @param[in]     iSym  Symmetry
!> @param[in,out] iRedC Reduced set in core (location ``3``); ``0`` (or ``-1``) if unknown or undefined
!> @param[in]     Mem   Memory available for read
!***********************************************************************

function Cho_X_NumRd(iVec1,iSym,iRedC,Mem)

use Cholesky, only: InfVec, MaxVec, nDimRS, nnBstR, nSym, NumCho
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: Cho_X_NumRd
integer(kind=iwp), intent(in) :: iVec1, iSym, Mem
integer(kind=iwp), intent(inout) :: iRedC
integer(kind=iwp) :: iLoc, irc, iRed, iVec, Need, NumRd

if ((iSym < 1) .or. (iSym > nSym)) then
  Cho_X_NumRd = -1
else if (NumCho(iSym) < 1) then
  Cho_X_NumRd = 0
else if (NumCho(iSym) > MaxVec) then
  Cho_X_NumRd = -2
else if ((iVec1 < 1) .or. (iVec1 > NumCho(iSym))) then
  Cho_X_NumRd = -3
else if (Mem < 1) then
  Cho_X_NumRd = 0
else
  NumRd = 0
  Need = 0
  iVec = iVec1-1
  if (.not. allocated(nDimRS)) then
    iLoc = 3
    do while ((iVec < NumCho(iSym)) .and. (Need < Mem))
      iVec = iVec+1
      iRed = InfVec(iVec,2,iSym)
      if (iRed /= iRedC) then
        irc = 0
        call Cho_X_SetRed(irc,iLoc,iRed)
        if (irc /= 0) then
          Cho_X_NumRd = -4
          iRedC = -1
          return
        end if
        iRedC = iRed
      end if
      Need = Need+nnBstR(iSym,iLoc)
      if (Need <= Mem) NumRd = NumRd+1
    end do
  else
    do while ((iVec < NumCho(iSym)) .and. (Need < Mem))
      iVec = iVec+1
      iRed = InfVec(iVec,2,iSym)
      Need = Need+nDimRS(iSym,iRed)
      if (Need <= Mem) NumRd = NumRd+1
    end do
  end if
  Cho_X_NumRd = NumRd
end if

end function Cho_X_NumRd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine TNAI(Zeta,Eta,P,Q,rKapab,rKapcd,T,Fact,ZEInv,nT,IsChi,
     &                ChiI2)
************************************************************************
*                                                                      *
* Object: to entities for the nucelar attraction integrals which are   *
*         used in the Rys quadrature to evaluate these integrals.      *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 Zeta(nT), Eta(nT), P(nT,3), Q(nT,3),
     &       rKapab(nT), rKapcd(nT), ZEInv(nT), T(nT), Fact(nT)
*
      iRout = 57
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' Zeta in TNAI',' ',Zeta,nT,1)
         Call RecPrt(' Eta in TNAI',' ',Eta,nT,1)
         Call RecPrt(' P in TNAI',' ',P,nT,3)
         Call RecPrt(' Q in TNAI',' ',Q,nT,3)
         Call RecPrt(' Kab in TNAI',' ',rKapab,nT,1)
         Call RecPrt(' Kcd in TNAI',' ',rKapcd,nT,1)
         Write (6,*) ' In TNAI: ABeqCD=',ABeqCD
      End If
#endif
      Do iT = 1, nT
         PQ2 = (P(iT,1)-Q(iT,1))**2
     &       + (P(iT,2)-Q(iT,2))**2
     &       + (P(iT,3)-Q(iT,3))**2
         T(iT) = Zeta(iT)*PQ2
         ZEInv(iT) = 1.0D0/Zeta(iT)
         Fact(iT) =  2.0D0*rKapab(iT)*Pi/Zeta(iT)
      End Do
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt('Tvalue',' ',T,nT,1)
         Call RecPrt('Fact  ',' ',Fact,nT,1)
      End If
#endif
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Eta)
         Call Unused_real_array(rKapcd)
         Call Unused_integer(IsChi)
         Call Unused_real(ChiI2)
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE WEIGHT_LUCIA(      Z,    NEL,  NORB1,  NORB2,  NORB3,
     &                          MNRS1,  MXRS1,  MNRS3,  MXRS3,   ISCR,
     &                          NTEST)
*
* construct vertex weights
*
* Reverse lexical ordering is used for restricted space
*
      IMPLICIT REAL*8           ( A-H,O-Z)
      INTEGER Z(*), ISCR(*)
*
      NORB = NORB1 + NORB2 + NORB3
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' >>>> WEIGHT <<<<< '
        WRITE(6,*) ' NORB1 NORB2 NORB3 ',NORB1,NORB2,NORB3
        WRITE(6,*) ' NEL MNRS1 MXRS1 MNRS3 MXRS3 '
        WRITE(6,*)   NEL,MNRS1,MXRS1,MNRS3,MXRS3
      END IF
*
      KLFREE = 1
      KLMAX = KLFREE
      KLFREE = KLFREE + NORB
*
      KLMIN = KLFREE
      KLFREE = KLFREE + NORB
*
      KW = KLFREE
      KLFREE = KW + (NEL+1)*(NORB+1)
*.Max and min arrays for strings
      CALL RSMXMN_LUCIA(ISCR(KLMAX),ISCR(KLMIN),NORB1,NORB2,NORB3,
     &                       NEL,   MNRS1,   MXRS1,   MNRS3,   MXRS3,
     &                     NTEST)
*. Arc weights
      CALL GRAPW(  ISCR(KW),         Z,ISCR(KLMIN),ISCR(KLMAX),    NORB,
     &                  NEL,     NTEST)
*
      RETURN
      END
C                WRSVCD(LU1,LBLK,VEC1,ISCR1(IBASE),SCR1,NDEG,NDIM,
C    &           LUDIA)

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Bjorn O. Roos                                    *
*               1992, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1987  B. O. ROOS                           *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND, SWEDEN                 *
*--------------------------------------------*
      SUBROUTINE TR2Sq(CMO,X1,X2,X3,URPQ,RUPQ,TUPQ,lBuf)
C
C SECOND ORDER TWO-ELECTRON TRANSFORMATION ROUTINE
C
C THIS ROUTINE IS CALLED FOR EACH SYMMETRY BLOCK OF INTEGRALS
C (ISP,ISQ,ISR,ISS) WITH ISP.GE.ISQ AND ISR.GE.ISS.
C P,Q,R,S are SO indices.
C A,B are MO indices, counting only non-frozen and non-deleted.
C T,U are occupied MO indices, only non-frozen and non-deleted.
C INTEGRALS (AB/TU) ARE ALWAYS GENERATED
C EXCHANGE INTEGRALS (AT/BU) ARE GENERATED AS FOLLOWS:
C (AT/BU) IF ISP.GE.ISR
C (AT/UB) IF ISP.GT.ISS AND ISP.NE.ISQ
C (TA/BU) IF ISQ.GT.ISR AND ISP.NE.ISQ
C (TA/UB) IF ISQ.GE.ISS AND ISP.NE.ISQ
C
C     ********** IBM-3090 RELEASE 87 09 14 **********
C     Replace MXMA with DGEMM. P-AA Malmqvist 1992-05-06.
C
      IMPLICIT REAL*8 (A-H,O-Z)
CPAM98      COMMON/INTTRA/ISP,ISQ,ISR,ISS,NBP,NBQ,NBR,NBS,NBPQ,NBRS,IRRST,
CPAM98     &              NOCP,NOCQ,NOCR,NOCS,NPQ,LADX,LRUPQ,LURPQ,LTUPQ,
CPAM98     &              NOP,NOQ,NOR,NOS,LMOP,LMOQ,LMOR,LMOS,LMOP2,LMOQ2,
CPAM98     &              LMOR2,LMOS2,IAD13,ITP,ITQ,ITR,ITS

#include "rasdim.fh"
#include "caspt2.fh"
#include "intgrl.fh"

#include "SysDef.fh"
#include "trafo.fh"
      DIMENSION CMO(NCMO)
      DIMENSION X1(*),X2(*),X3(*),RUPQ(*),URPQ(*),TUPQ(*)


      Kount=0
      NSYMP=(NSYM**2+NSYM)/2
      NORU=NBR*NOCS
      NOUR=NBS*NOCR
      NOTU=NOCR*NOCS
      IF(ISR.EQ.ISS) NOTU=(NOCR**2+NOCR)/2
C
C     CHECK FOR IN CORE OR OUT OF CORE TRANSFORMATION
C
C     1. SORT OF PARTIALLY TRANSFORMED INTEGRALS (RU/PQ) ON UNIT LUHLF1
      IPQMX1=NBPQ
      IF(NBPQ*NORU.GT.LRUPQ) THEN
       IPQMX1=LRUPQ/NORU
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (RU/PQ)',IPQMX1
       IAD1S=0
       CALL dDAFILE(LUHLF1,0,RUPQ,IPQMX1,IAD1S)
      ENDIF
      IAD1=0
      IOUT1=0
C     2. SORT OF PARTIALLY TRANSFORMED INTEGRALS (UR/PQ) ON UNIT LUHLF2
      IPQMX2=NBPQ
      IF(NBPQ*NOUR.GT.LURPQ) THEN
       IPQMX2=LURPQ/NOUR
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (UR/PQ)',IPQMX2
       IAD2S=0
       CALL dDAFILE(LUHLF2,0,URPQ,IPQMX2,IAD2S)
      ENDIF
      IAD2=0
      IOUT2=0
C     3. SORT OF PARTIALLY TRANSFORMED INTEGRALS (TU/PQ) ON UNIT LUHLF3
      IPQMX3=NBPQ
      IF(NBPQ*NOTU.GT.LTUPQ) THEN
       IPQMX3=LTUPQ/NOTU
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (TU/PQ)',IPQMX3
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,TUPQ,IPQMX3,IAD3S)
      ENDIF
      IAD3=0
      IOUT3=0
C
C     START LOOP OVER SORTED AO-INTEGRALS: NPQ PQ-PAIRS IN EACH BUFFER
C
      IPQ=0
      LPQ=0
      NPQ=0
      iOpt=1
      iRc=0
      IRSST=1-NBRS
      DO 11 NP=1,NBP
       NQM=NBQ
       IF(ISP.EQ.ISQ) NQM=NP
       DO 10 NQ=1,NQM
        IPQ=IPQ+1
        IOUT1=IOUT1+1
        IOUT2=IOUT2+1
        IOUT3=IOUT3+1
C
C        READ IN A BLOCK OF INTEGRALS FOR NPQ PQ-VALUES
C
        IF(LPQ.EQ.NPQ) THEN
         Call RdOrd(iRc,iOpt,isP,isQ,isR,isS,X1,lBuf,nPQ)
         IF(IRC.GT.1) THEN
           WRITE(6,*)' ERROR RETURN CODE IRC=',IRC
           WRITE(6,*)' FROM RDORD, CALLED FROM TRA2.'
           CALL Abend
         END IF
         iOpt=2
         LPQ=0
         IRSST=1-NBRS
        ENDIF
        LPQ=LPQ+1
        IRSST=IRSST+NBRS
C
C       START TRANFORMATION OF THIS PQ PAIR
C
        IF(ISR.EQ.ISS) THEN
         CALL SQUARE(X1(IRSST),X2,1,NBS,NBS)
        ELSE
         CALL DCOPY_(NBRS,X1(IRSST),1,X2,1)
        ENDIF
C
C       INTEGRALS (PQ/UR)
C
        IF((ISP.NE.ISQ.AND.ISP.GT.ISS).AND.NOCR.NE.0) THEN
         CALL DGEMM_('N','N',
     &               NBS,NOCR,NBR,
     &               1.0d0,X2,NBS,
     &               CMO(LMOR2),NBR,
     &               0.0d0,X3,NBS)
C
C        SORT THESE INTEGRALS AS (UR/PQ)
C
         IF(IOUT2.GT.IPQMX2) THEN
          IOUT2=1
cvv          DO 2 I=1,NOUR
cvv           CALL dDAFILE(LUHLF2,1,URPQ(1+IPQMX2*(I-1)),IPQMX2,IAD2)
cvv    2     CONTINUE
         CALL dDAFILE(LUHLF2,1,URPQ,IPQMX2*NOUR,IAD2)
         ENDIF
         CALL DCOPY_(NOUR,X3,1,URPQ(IOUT2),IPQMX2)
        ENDIF
C
C       INTEGRALS (PQ/RU)
C
        IF(NOCS.NE.0) THEN
         CALL DGEMM_('T','N',
     &               NBR,NOCS,NBS,
     &               1.0d0,X2,NBS,
     &               CMO(LMOS2),NBS,
     &               0.0d0,X3,NBR)
C
C        SORT THESE INTEGRALS AS (RU/PQ)
C
         IF(ISP.GE.ISR) THEN
          IF(IOUT1.GT.IPQMX1) THEN
           IOUT1=1
cvv           DO 4 I=1,NORU
cvv            CALL dDAFILE(LUHLF1,1,RUPQ(1+IPQMX1*(I-1)),IPQMX1,IAD1)
cvv    4      CONTINUE
        CALL dDAFILE(LUHLF1,1,RUPQ,IPQMX1*NORU,IAD1)
          ENDIF
          CALL DCOPY_(NORU,X3,1,RUPQ(IOUT1),IPQMX1)
         ENDIF
        ENDIF
C
C       INTEGRALS (PQ/TU)
C
        IF(NOCR*NOCS.NE.0) THEN
         IF(ISR.EQ.ISS) THEN
          CALL MXMT(X3,        NBR,1,
     &              CMO(LMOR2),1,NBR,
     &              X2,
     &              NOCR,NBR)
         ELSE
          CALL DGEMM_('T','N',
     &                NOCS,NOCR,NBR,
     &                1.0d0,X3,NBR,
     &                CMO(LMOR2),NBR,
     &                0.0d0,X2,NOCS)
         ENDIF
C
C        SORT INTEGRALS (PQ/TU) INTO TUPQ (SORT AFTER PQ INSTEAD OF TU)
C
         IF(IOUT3.GT.IPQMX3) THEN
          IOUT3=1
cvv          DO 6 I=1,NOTU
cvv           CALL dDAFILE(LUHLF3,1,TUPQ(1+IPQMX3*(I-1)),IPQMX3,IAD3)
cvv    6     CONTINUE
        CALL dDAFILE(LUHLF3,1,TUPQ,IPQMX3*NOTU,IAD3)

         ENDIF
         CALL DCOPY_(NOTU,X2,1,TUPQ(IOUT3),IPQMX3)
        ENDIF
C
C       WE NOW HAVE THREE SETS OF PARTIALLY TRANSFORMED INTEGRALS
C       IN TUPQ: (TU/PQ)   TRIANGULAR FOR ISR.EQ.ISS
C       IN RUPQ: (RU/PQ)   IF ISP.GE.ISR
C       IN URPQ: (UR/PQ)   IF ISP.GT.ISQ.AND.ISP.GT.ISS
C
   10  CONTINUE
   11 CONTINUE
C
C     EMPTY LAST BUFFERS
C
      IF(IPQMX1.LT.NBPQ) THEN
cvv       DO 12 I=1,NORU
cvv        CALL dDAFILE(LUHLF1,1,RUPQ(1+IPQMX1*(I-1)),IPQMX1,IAD1)
cvv   12  CONTINUE
      CALL dDAFILE(LUHLF1,1,RUPQ,IPQMX1*NORU,IAD1)
      ENDIF
      IF(IPQMX2.LT.NBPQ) THEN
cvv       DO 13 I=1,NOUR
cvv        CALL dDAFILE(LUHLF2,1,URPQ(1+IPQMX2*(I-1)),IPQMX2,IAD2)
cvv   13  CONTINUE
      CALL dDAFILE(LUHLF2,1,URPQ,IPQMX2*NOUR,IAD2)
      ENDIF
      IF(IPQMX3.LT.NBPQ) THEN
cvv       DO 14 I=1,NOTU
cvv        CALL dDAFILE(LUHLF3,1,TUPQ(1+IPQMX3*(I-1)),IPQMX3,IAD3)
cvv   14  CONTINUE
      CALL dDAFILE(LUHLF3,1,TUPQ,IPQMX3*NOTU,IAD3)

      ENDIF
C
C     FIRST PARTIAL TRANSFORMATION FINISHED
C     SORTED INTEGRALS ARE ON UNITS LUHLF1 (RUPQ), LUHLF2 (URPQ),
C     AND LUHLF3 (TUPQ), CONTROLLED BY THE ADRESSES IAD1,IAD2, AND IAD3,
C     OR IN CORE (RUPQ, URPQ, AND TUPQ)
C
C     SECOND HALF TRANSFORMATION FOR INTEGRALS (PQ/TU)
C     FIRST SAVE THE START ADDRESS ON LUINTM FOR THIS BLOCK OF INTEGRALS
C     NOTE THAT THE SYMMETRY LABEL ISPQRS ASSUMES THAT SYMMETRY LOOPS
C     IN THE ORDER T,U,A,B FOR ALL INTEGRAL TYPES.
C
      IF(NOCR*NOCS.EQ.0) GO TO 22
      ISPQRS=((ISR**2-ISR)/2+ISS-1)*NSYMP+(ISP**2-ISP)/2+ISQ
      IAD2M(1,ISPQRS)=IAD13
      ITU=0
      DO 20 NT=1,NOCR
       NUM=NT
       IF(ISS.NE.ISR) NUM=NOCS
      DO 21 NU=1,NUM
       IPQST=1+NBPQ*ITU
       ITU=ITU+1
C
C      READ ONE BUFFER OF INTEGRALS BACK INTO CORE
C
       IF(IPQMX3.LT.NBPQ) THEN
**sta0830
          Call RBuf_tra2(LUHLF3,TUPQ,NBPQ,IPQMX3,NOTU,ITU,IPQST,IAD3S)
**end0830
       ENDIF
C
       IF(ISP.EQ.ISQ) THEN
        CALL SQUARE(TUPQ(IPQST),X2,1,NBQ,NBQ)
        CALL DGEMM_('N','N',
     &              NBQ,NOP,NBP,
     &              1.0d0,X2,NBQ,
     &              CMO(LMOP),NBP,
     &              0.0d0,X1,NBP)
        CALL MXMT(X1,       NBQ,1,
     &            CMO(LMOQ),1,NBQ,
     &            X2,
     &            NOP,NBQ)
        IX2=(NOP+NOP**2)/2
       ELSE
        CALL DGEMM_('N','N',
     &              NBQ,NOP,NBP,
     &              1.0d0,TUPQ(IPQST),NBQ,
     &              CMO(LMOP),NBP,
     &              0.0d0,X1,NBQ)
        CALL DGEMM_('T','N',
     &              NOQ,NOP,NBQ,
     &              1.0d0,CMO(LMOQ),NBQ,
     &              X1,NBQ,
     &              0.0d0,X2,NOQ)
        IX2=NOP*NOQ
       ENDIF
C
C      WRITE INTEGRALS (AB/TU) ON OUTPUT UNIT LUINTM
C      INTEGRALS FOR SYMMETRY BLOCK (ISP,ISQ,ISR,ISS) ARE STORED
C      ONE BLOCK FOR EACH TU STARTING AT ADDRESS IAD2M(1,ISPQRS).
C      TRIANGULAR IN AB AND TU IF ISP.EQ.ISQ ( AND ISR.EQ.ISS)
C
       Call GADSum(X2,IX2)
       CALL dDAFILE(LUINTM,1,X2,IX2,IAD13)
C
C      EXTRACT INTEGRALS WITH ALL INDICES ACTIVE INTO TUVX
C      Not used with caspt2. If wanted, TUVX must be declared.
C
C      IF(ISP.GE.ISR.AND.NASH(ISP)*NASH(ISQ).NE.0)
C    & CALL GTUVX(X2,TUVX,NT,NU,ITP,ITQ,ITR,ITS,ISP,ISQ)

   21 CONTINUE
   20 CONTINUE
   22 CONTINUE
C
C     SECOND PARTIAL TRANSFORMATION FOR INTEGRALS (PQ/RU)-> (AT/BU)
C     IF ISP.EQ.ISR THEN T.GE.U BUT ALWAYS ALL A AND B
C
      NOTU=NOCQ*NOCS
      IF(ISQ.EQ.ISS) NOTU=(NOCQ**2+NOCQ)/2
      IF(ISP.GE.ISR.AND.NOTU.NE.0) THEN
       LAR=LTUPQ/NOTU
       LR=LAR/NOP
       IF(LR.GT.NBR) LR=NBR
       LAR=NOP*LR
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,TUPQ,LAR,IAD3S)
       IAD3=0
       IR=0
       DO 30 NR=1,NBR
        IR=IR+1
       DO 31 NU=1,NOCS
        IRU=NBR*(NU-1)+NR
        IPQST=1+NBPQ*(IRU-1)
C
C       READ ONE BUFFER OF INTEGRALS BACK INTO CORE
C
        IF(IPQMX1.LT.NBPQ) THEN
**sta0830
          Call RBuf_tra2(LUHLF1,RUPQ,NBPQ,IPQMX1,NORU,IRU,IPQST,IAD1S)
**end0830
        ENDIF
        IF(ISP.EQ.ISQ) THEN
         CALL SQUARE(RUPQ(IPQST),X2,1,NBQ,NBQ)
        ELSE
         CALL DCOPY_(NBPQ,RUPQ(IPQST),1,X2,1)
        ENDIF
        IF(ISQ.EQ.ISS) THEN
         CALL DGEMM_('T','N',
     &               NBP,NOCQ-NU+1,NBQ,
     &               1.0d0,X2,NBQ,
     &               CMO(LMOQ2+NBQ*(NU-1)),NBQ,
     &               0.0d0,X1,NBP)
         CALL DGEMM_('T','N',
     &               NOCQ-NU+1,NOP,NBP,
     &               1.0d0,X1,NBP,
     &               CMO(LMOP),NBP,
     &               0.0d0,X2,NOCQ-NU+1)
        ELSE
         CALL DGEMM_('T','N',
     &               NBP,NOCQ,NBQ,
     &               1.0d0,X2,NBQ,
     &               CMO(LMOQ2),NBQ,
     &               0.0d0,X1,NBP)
         CALL DGEMM_('T','N',
     &               NOCQ,NOP,NBP,
     &               1.0d0,X1,NBP,
     &               CMO(LMOP),NBP,
     &               0.0d0,X2,NOCQ)
         ENDIF
C
C       INTEGRALS (AT/RU) ARE NOW IN X2 FOR ONE VALUE OF R,U AND ALL
C       VALUES OF A,T(T.GE.U IF ISQ.EQ.ISS)
C
C       SORT THESE INTEGRALS AFTER PAIR INDEX TU, IN CORE IF POSSIBLE
C       OTHERWISE USE LUHLF3 FOR TEMPORARY STORAGE (SAME POSITION AS FOR
C       INTEGRALS (TU/PQ)
C
        IF(IR.GT.LR) THEN
         IR=1
cvv         DO 24 I=1,NOTU
cvv          CALL dDAFILE(LUHLF3,1,TUPQ(1+LAR*(I-1)),LAR,IAD3)
cvv   24    CONTINUE
        CALL dDAFILE(LUHLF3,1,TUPQ,LAR*NOTU,IAD3)
        ENDIF
        NAT=0
        DO 26 NA=1,NOP
         NTM=1
         IF(ISQ.EQ.ISS) NTM=NU
        DO 27 NT=NTM,NOCQ
         ITU=NOCS*(NT-1)+NU-1
         IF(ISQ.LT.ISS) ITU=NOCQ*(NU-1)+NT-1
         IF(ISQ.EQ.ISS) ITU=(NT**2-NT)/2+NU-1
         NAT=NAT+1
         TUPQ(LAR*ITU+NOP*(IR-1)+NA)=X2(NAT)
   27   CONTINUE
   26   CONTINUE
   31  CONTINUE
   30  CONTINUE
C
C      EMPTY LAST BUFFER IF LR.LT.NBR
C
       IF(LR.LT.NBR) THEN
cvv        DO 32 I=1,NOTU
cvv         CALL dDAFILE(LUHLF3,1,TUPQ(1+LAR*(I-1)),LAR,IAD3)
cvv   32   CONTINUE
       CALL dDAFILE(LUHLF3,1,TUPQ,LAR*NOTU,IAD3)
       ENDIF
C
C      NOW TRANSFORM INDEX R TO B
C
C      FIRST COMPUTE AND SAVE START ADDRESS FOR THIS SYMMETRY BLOCK
C
       IF(ISQ.GE.ISS) THEN
        ISPQRS=((ISQ**2-ISQ)/2+ISS-1)*NSYMP+(ISP**2-ISP)/2+ISR
        IAD2M(2,ISPQRS)=IAD13
        NTMAX=NOCQ
        NUMAX=NOCS
       ELSE
        ISPQRS=((ISS**2-ISS)/2+ISQ-1)*NSYMP+(ISP**2-ISP)/2+ISR
        IAD2M(3,ISPQRS)=IAD13
        NTMAX=NOCS
        NUMAX=NOCQ
       ENDIF
       KKTU=0
       IST=1-NOP*NBR
       DO 40 NT=1,NTMAX
        NUM=NUMAX
        IF(ISQ.EQ.ISS) NUM=NT
       DO 41 NU=1,NUM
        KKTU=KKTU+1
        IST=IST+NOP*NBR
        IF(LR.LT.NBR)THEN
**sta0830
          Call RBuf_tra2(LUHLF3,TUPQ,NBR*NOP,LAR,NOTU,KKTU,IST,IAD3S)
**end0830
        ENDIF
        CALL DGEMM_('T','T',
     &              NOR,NOP,NBR,
     &              1.0d0,CMO(LMOR),NBR,
     &              TUPQ(IST),NOP,
     &              0.0d0,X2,NOR)
C
C       WRITE THESE BLOCK OF INTEGRALS ON LUINTM
C
        Call GADSum(X2,NOP*NOR)
        CALL dDAFILE(LUINTM,1,X2,NOP*NOR,IAD13)
   41  CONTINUE
   40  CONTINUE
      ENDIF
C
C     SECOND PARTIAL TRANSFORMATION FOR INTEGRALS (PQ/RU)-> (TA/BU)
C
      NOTU=NOCP*NOCS
      IF((ISP.NE.ISQ.AND.ISQ.GT.ISR).AND.NOTU.NE.0) THEN
       LAR=LTUPQ/NOTU
       LR=LAR/NOQ
       IF(LR.GT.NBR) LR=NBR
       LAR=NOQ*LR
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,TUPQ,LAR,IAD3S)
       IAD3=0
       IRU=0
       IR=0
       DO 50 NR=1,NBR
        IR=IR+1
       DO 51 NU=1,NOCS
        IRU=NBR*(NU-1)+NR
        IPQST=1+NBPQ*(IRU-1)
C
C       READ ONE BUFFER OF INTEGRALS BACK INTO CORE
C
        IF(IPQMX1.LT.NBPQ) THEN
**sta0830
          Call RBuf_tra2(LUHLF1,RUPQ,NBPQ,IPQMX1,NORU,IRU,IPQST,IAD1S)
**end0830
        ENDIF
        CALL DGEMM_('N','N',
     &              NBQ,NOCP,NBP,
     &              1.0d0,RUPQ(IPQST),NBQ,
     &              CMO(LMOP2),NBP,
     &              0.0d0,X1,NBQ)
        CALL DGEMM_('T','N',
     &              NOCP,NOQ,NBQ,
     &              1.0d0,X1,NBQ,
     &              CMO(LMOQ),NBQ,
     &              0.0d0,X2,NOCP)
C
C       INTEGRALS (TA/RU) ARE NOW IN X2 FOR ONE VALUE OF R,U AND ALL
C       VALUES OF T,A . NOTE THAT T AND U HERE ALWAYS ARE OF DIFFERENT
C       SYMMETRIES
C
C       SORT THESE INTEGRALS AFTER PAIR INDEX TU, IN CORE IF POSSIBLE
C       OTHERWISE USE LUHLF3 FOR TEMPORARY STORAGE (SAME POSITION AS FOR
C       INTEGRALS (TU/PQ)
C
        IF(IR.GT.LR) THEN
         IR=1
cvv         DO 44 I=1,NOTU
cvv          CALL dDAFILE(LUHLF3,1,TUPQ(1+LAR*(I-1)),LAR,IAD3)
cvv   44    CONTINUE
        CALL dDAFILE(LUHLF3,1,TUPQ,LAR*NOTU,IAD3)

        ENDIF
        NAT=0
        DO 46 NA=1,NOQ
        DO 47 NT=1,NOCP
         ITU=NOCS*(NT-1)+NU-1
         NAT=NAT+1
         TUPQ(LAR*ITU+NOQ*(IR-1)+NA)=X2(NAT)
   47   CONTINUE
   46   CONTINUE
   51  CONTINUE
   50  CONTINUE
C
C      EMPTY LAST BUFFER IF LR.LT.NBR
C
       IF(LR.LT.NBR) THEN
cvv        DO 52 I=1,NOTU
cvv         CALL dDAFILE(LUHLF3,1,TUPQ(1+LAR*(I-1)),LAR,IAD3)
cvv   52   CONTINUE
       CALL dDAFILE(LUHLF3,1,TUPQ,LAR*NOTU,IAD3)
       ENDIF
C
C      NOW TRANSFORM INDEX R TO B
C
C      FIRST COMPUTE AND SAVE START ADDRESS FOR THIS SYMMETRY BLOCK
C
       ISPQRS=((ISP**2-ISP)/2+ISS-1)*NSYMP+(ISQ**2-ISQ)/2+ISR
       IAD2M(2,ISPQRS)=IAD13
       KKTU=0
       IST=1-NOQ*NBR
       DO 60 NT=1,NOCP
       DO 61 NU=1,NOCS
        KKTU=KKTU+1
        IST=IST+NOQ*NBR
        IF(LR.LT.NBR)THEN
**sta0830
          Call RBuf_tra2(LUHLF3,TUPQ,NBR*NOQ,LAR,NOTU,KKTU,IST,IAD3S)
**end0830
        ENDIF
        CALL DGEMM_('T','T',
     &              NOR,NOQ,NBR,
     &              1.0d0,CMO(LMOR),NBR,
     &              TUPQ(IST),NOQ,
     &              0.0d0,X2,NOR)
C
C       WRITE THESE BLOCK OF INTEGRALS ON LUINTM
C
        Call GADSum(X2,NOR*NOQ)
        CALL dDAFILE(LUINTM,1,X2,NOR*NOQ,IAD13)
   61  CONTINUE
   60  CONTINUE
      ENDIF
C
C     SECOND PARTIAL TRANSFORMATION FOR INTEGRALS (PQ/UR)-> (AT/UB)
C
      NOTU=NOCQ*NOCR
      IF((ISP.NE.ISQ.AND.ISP.GT.ISS).AND.NOTU.NE.0) THEN
       LAR=(LRUPQ+LTUPQ)/NOTU
       LR=LAR/NOP
       IF(LR.GT.NBS) LR=NBS
       LAR=NOP*LR
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,RUPQ,LAR,IAD3S)
       IAD3=0
       IRU=0
       IR=0
       DO 70 NR=1,NBS
        IR=IR+1
       DO 71 NU=1,NOCR
        IRU=NBS*(NU-1)+NR
        IPQST=1+NBPQ*(IRU-1)
C
C       READ ONE BUFFER OF INTEGRALS BACK INTO CORE
C
        IF(IPQMX2.LT.NBPQ) THEN
**sta0830
          Call RBuf_tra2(LUHLF2,URPQ,NBPQ,IPQMX2,NOUR,IRU,IPQST,IAD2S)
**end0830
        ENDIF
        CALL DGEMM_('T','N',
     &              NBP,NOCQ,NBQ,
     &              1.0d0,URPQ(IPQST),NBQ,
     &              CMO(LMOQ2),NBQ,
     &              0.0d0,X1,NBP)
        CALL DGEMM_('T','N',
     &              NOCQ,NOP,NBP,
     &              1.0d0,X1,NBP,
     &              CMO(LMOP),NBP,
     &              0.0d0,X2,NOCQ)
C
C       INTEGRALS (AT/UR) ARE NOW IN X2 FOR ONE VALUE OF R,U AND ALL
C       VALUES OF A,T. NOTE THAT T AND U HAVE DIFFERENT SYMMETRIES.
C
C       SORT THESE INTEGRALS AFTER PAIR INDEX TU, IN CORE IF POSSIBLE
C       OTHERWISE USE LUHLF3 FOR TEMPORARY STORAGE (SAME POSITION AS FOR
C       INTEGRALS (TU/PQ)
C
        IF(IR.GT.LR) THEN
         IR=1
cvv         DO 64 I=1,NOTU
cvv          CALL dDAFILE(LUHLF3,1,RUPQ(1+LAR*(I-1)),LAR,IAD3)
cvv   64    CONTINUE
        CALL dDAFILE(LUHLF3,1,RUPQ,LAR*NOTU,IAD3)
        ENDIF
        NAT=0
        DO 66 NA=1,NOP
        DO 67 NT=1,NOCQ
         ITU=NOCR*(NT-1)+NU-1
         IF(ISQ.LT.ISR) ITU=NOCQ*(NU-1)+NT-1
         NAT=NAT+1
         RUPQ(LAR*ITU+NOP*(IR-1)+NA)=X2(NAT)
   67   CONTINUE
   66   CONTINUE
   71  CONTINUE
   70  CONTINUE
C
C      EMPTY LAST BUFFER IF LR.LT.NBS
C
       IF(LR.LT.NBS) THEN
cvv        DO 72 I=1,NOTU
cvv         CALL dDAFILE(LUHLF3,1,RUPQ(1+LAR*(I-1)),LAR,IAD3)
cvv   72   CONTINUE
       CALL dDAFILE(LUHLF3,1,RUPQ,LAR*NOTU,IAD3)
       ENDIF
C
C      NOW TRANSFORM INDEX R TO B
C
C      FIRST COMPUTE AND SAVE START ADDRESS FOR THIS SYMMETRY BLOCK
C
       IF(ISQ.GE.ISR) THEN
        ISPQRS=((ISQ**2-ISQ)/2+ISR-1)*NSYMP+(ISP**2-ISP)/2+ISS
        IAD2M(2,ISPQRS)=IAD13
        NTMAX=NOCQ
        NUMAX=NOCR
       ELSE
        ISPQRS=((ISR**2-ISR)/2+ISQ-1)*NSYMP+(ISP**2-ISP)/2+ISS
        IAD2M(3,ISPQRS)=IAD13
        NTMAX=NOCR
        NUMAX=NOCQ
       ENDIF
       KKTU=0
       IST=1-NBS*NOP
       DO 80 NT=1,NTMAX
       DO 81 NU=1,NUMAX
        KKTU=KKTU+1
        IST=IST+NBS*NOP
        IF(LR.LT.NBS)THEN
**sta0830
          Call RBuf_tra2(LUHLF3,RUPQ,NBS*NOP,LAR,NOTU,KKTU,IST,IAD3S)
**end0830
        ENDIF
        CALL DGEMM_('T','T',
     &              NOS,NOP,NBS,
     &              1.0d0,CMO(LMOS),NBS,
     &              RUPQ(IST),NOP,
     &              0.0d0,X2,NOS)
C
C       WRITE THESE BLOCK OF INTEGRALS ON LUINTM
C
        CAll GADSum(X2,NOS*NOP)
        CALL dDAFILE(LUINTM,1,X2,NOS*NOP,IAD13)
   81  CONTINUE
   80  CONTINUE
      ENDIF
C
C     SECOND PARTIAL TRANSFORMATION FOR INTEGRALS (PQ/UR)-> (TA/UB)
C
      NOTU=NOCP*NOCR
      IF((ISP.NE.ISQ.AND.ISQ.GE.ISS).AND.NOTU.NE.0) THEN
       IF(ISP.EQ.ISR) NOTU=(NOCP**2+NOCP)/2
       LAR=(LRUPQ+LTUPQ)/NOTU
       LR=LAR/NOQ
       IF(LR.GT.NBS) LR=NBS
       LAR=NOQ*LR
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,RUPQ,LAR,IAD3S)
       IAD3=0
       IRU=0
       IR=0
       DO 90 NR=1,NBS
        IR=IR+1
       DO 91 NU=1,NOCR
        IRU=NBS*(NU-1)+NR
        IPQST=1+NBPQ*(IRU-1)
C
C       READ ONE BUFFER OF INTEGRALS BACK INTO CORE
C
        IF(IPQMX2.LT.NBPQ) THEN
**sta0830
          Call RBuf_tra2(LUHLF2,URPQ,NBPQ,IPQMX2,NOUR,IRU,IPQST,IAD2S)
**end0830
        ENDIF
        IF(ISP.EQ.ISR) THEN
         CALL DGEMM_('N','N',
     &               NBQ,NOCP-NU+1,NBP,
     &               1.0d0,URPQ(IPQST),NBQ,
     &               CMO(LMOP2+NBP*(NU-1)),NBP,
     &               0.0d0,X1,NBQ)
         CALL DGEMM_('T','N',
     &               NOCP-NU+1,NOQ,NBQ,
     &               1.0d0,X1,NBQ,
     &               CMO(LMOQ),NBQ,
     &               0.0d0,X2,NOCP-NU+1)
        ELSE
         CALL DGEMM_('N','N',
     &               NBQ,NOCP,NBP,
     &               1.0d0,URPQ(IPQST),NBQ,
     &               CMO(LMOP2),NBP,
     &               0.0d0,X1,NBQ)
         CALL DGEMM_('T','N',
     &               NOCP,NOQ,NBQ,
     &               1.0d0,X1,NBQ,
     &               CMO(LMOQ),NBQ,
     &               0.0d0,X2,NOCP)
        ENDIF
C
C       INTEGRALS (TA/UR) ARE NOW IN X2 FOR ONE VALUE OF R,U AND ALL
C       VALUES OF A,T
C
C       SORT THESE INTEGRALS AFTER PAIR INDEX TU, IN CORE IF POSSIBLE
C       OTHERWISE USE LUHLF3 FOR TEMPORARY STORAGE (SAME POSITION AS FOR
C       INTEGRALS (TU/PQ)
C
        IF(IR.GT.LR) THEN
         IR=1
cvv         DO 84 I=1,NOTU
cvv          CALL dDAFILE(LUHLF3,1,RUPQ(1+LAR*(I-1)),LAR,IAD3)
cvv   84    CONTINUE
        CALL dDAFILE(LUHLF3,1,RUPQ,LAR*NOTU,IAD3)
        ENDIF
        NAT=0
        DO 86 NA=1,NOQ
         NTM=1
         IF(ISP.EQ.ISR) NTM=NU
        DO 87 NT=NTM,NOCP
         ITU=NOCR*(NT-1)+NU-1
         IF(ISP.LT.ISR) ITU=NOCP*(NU-1)+NT-1
         IF(ISP.EQ.ISR) ITU=(NT**2-NT)/2+NU-1
         NAT=NAT+1
         RUPQ(LAR*ITU+NOQ*(IR-1)+NA)=X2(NAT)
   87   CONTINUE
   86   CONTINUE
   91  CONTINUE
   90  CONTINUE
C
C      EMPTY LAST BUFFER IF LR.LT.NBS
C
       IF(LR.LT.NBS) THEN
cvv        DO 92 I=1,NOTU
cvv         CALL dDAFILE(LUHLF3,1,RUPQ(1+LAR*(I-1)),LAR,IAD3)
cvv   92   CONTINUE
       CALL dDAFILE(LUHLF3,1,RUPQ,LAR*NOTU,IAD3)
       ENDIF
C
C      NOW TRANSFORM INDEX R TO B
C
C       FIRST COMPUTE AND SAVE START ADDRESS FOR THIS SYMMETRY BLOCK
C
       IF(ISP.GE.ISR) THEN
        ISPQRS=((ISP**2-ISP)/2+ISR-1)*NSYMP+(ISQ**2-ISQ)/2+ISS
        IAD2M(2,ISPQRS)=IAD13
        NTMAX=NOCP
        NUMAX=NOCR
       ELSE
        ISPQRS=((ISR**2-ISR)/2+ISP-1)*NSYMP+(ISQ**2-ISQ)/2+ISS
        IAD2M(3,ISPQRS)=IAD13
        NTMAX=NOCR
        NUMAX=NOCP
       ENDIF
       KKTU=0
       IST=1-NOQ*NBS
       DO 100 NT=1,NTMAX
        NUM=NUMAX
        IF(ISP.EQ.ISR) NUM=NT
       DO 101 NU=1,NUM
        KKTU=KKTU+1
        IST=IST+NOQ*NBS
        IF(LR.LT.NBS)THEN
**sta0830
          Call RBuf_tra2(LUHLF3,RUPQ,NBS*NOQ,LAR,NOTU,KKTU,IST,IAD3S)
**end0830
        ENDIF
        CALL DGEMM_('T','T',
     &              NOS,NOQ,NBS,
     &              1.0d0,CMO(LMOS),NBS,
     &              RUPQ(IST),NOQ,
     &              0.0d0,X2,NOS)
C
C       WRITE THESE BLOCK OF INTEGRALS ON LUINTM
C
        Call GADSum(X2,NOS*NOQ)
        CALL dDAFILE(LUINTM,1,X2,NOS*NOQ,IAD13)
  101  CONTINUE
  100  CONTINUE
      ENDIF
C
C     END OF TRANSFORMATION FOR THIS SYMMETRY BLOCK
C
C     IAD2M CONTAINS START ADRESS FOR EACH TYPE OF INTEGRALS:
C     IAD2M(1,ISPQRS)   COULOMB INTEGRALS (AB|TU)
C     IAD2M(2,ISPQRS)   EXCHANGE INTEGRALS <AB|TU> FOR SYM T > SYM U
C     IAD2M(3,ISPQRS)     EXCHANGE INTEGRALS <AB|TU> FOR SYM T < SYM U
C     THE LAST ADRESS IS ZERO IF SYM T = SYM U
C     TO SEE HOW THE INTEGRALS ARE USED LOOK IN RDINT2
C


      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Roland Lindh                                     *
!***********************************************************************

subroutine rKappa_Zeta(rKappa,Zeta,nZeta)
!***********************************************************************
!                                                                      *
! Object: modify rkappa                                                *
!                                                                      *
! Called from:                                                         *
!                                                                      *
! Calling    :                                                         *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chemical Physics,                 *
!             University of Lund, SWEDEN                               *
!             September '00.                                           *
!***********************************************************************

use Constants, only: OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta
real(kind=wp), intent(inout) :: rKappa(nZeta)
real(kind=wp), intent(in) :: Zeta(nZeta)

rKappa(:) = rKappa(:)*Zeta(:)**(-OneHalf)

end subroutine rKappa_Zeta

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine coreB(iang,lb,ishll,nordop,TC,RB,Array,narr,
     &                 Beta,nbeta,fb1,fb2,jfgrad,jfhess,
     &                 ld,debug)
*
*
*  Calculates <core|B'> and <core|B">
*
* @parameter iang  Angular momenta for core
* @parameter lb    Angular momenta for ket
* @parameter ishll identification for core shell
* @parameter nordop order for operator
* @parameter TC   Cartesian coordinates for core
* @parameter  RB Cartesian coordinates for ket
* @parameter Array Scratch
* @parameter narr size for scratch
* @parameter Beta  Ket exponents
* @parameter nbeta  number of exponents
* @parameter FB1 First derivatives (out)
* @parameter FB2 2nd derivatives (out)
* @parameter jfgrad true for all 1-deriavtives that are needed
* @parameter jfhess true for all 2-deriavtives that are needed
* @parameter ld Order of derivatives
* @parameter debug guess
*
      Use Basis_Info
      use Her_RW
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "disp.fh"
      Logical ABeq(3),jfgrad(3),jfhess(4,3,4,3),debug
      Real*8 TC(3),RB(3),Array(*),fb1(*),fb2(*),beta(*)

      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nExpi=Shells(iShll)%nExp
      if (debug) then
        Write(6,*) 'Shell: ',ishll,' nBeta:',nbeta,' nExp:',nExpi,
     &             'Angular',lb,iang
      Endif
*
*
      ip=1
      ipP2 = ip
      ip = ip + 3 * nExpi*nBeta
      ipZ2 = ip
      ip = ip + nExpi*nBeta
      ipK2 = ip
      ip = ip + nExpi*nBeta
      ipZI2 = ip
      ip = ip + nExpi*nBeta
      If (ip-1.gt.nArr) Then
         Write (6,*) '  ip-1.gt.nArr*nZeta(2) in bcore (',ip,',',
     &    narr,')'
         Call Abend
      End If
*
*--------------Calculate Effective center and exponent for <core|B>
*
      Call ZXia(Array(ipZ2),Array(ipZI2),nExpi,nBeta,
     &                   Shells(iShll)%Exp,Beta)
      Call SetUp1(Shells(iShll)%Exp,nExpi,Beta,nBeta,
     &                    TC,RB,Array(ipK2),Array(ipP2),Array(ipZI2))
*
*--------------Calculate Overlap <core|B> and <core|B'>
*
CBS   nHer = (iAng+(lb+1)+2)/2
CBS   now it looks comparable to acore.f
      nHer = (lb+1+iAng+1+ld)/2
      ipCxyz = ip
      ip = ip + nBeta*nExpi*3*nHer*(iAng+1)
      ipBxyz = ip
      ip = ip + nBeta*nExpi*3*nHer*(lb+1+ld)
      ipRxyz = ip
      ip = ip + nBeta*nExpi*3*nHer*(nOrdOp+1)
      ipQ1 = ip
      ip = ip +
     &      nBeta*nExpi*3*(iAng+1)*(lb+1+ld)*(nOrdOp+1)
      ipB = ip
      ip = ip + nBeta*nExpi
      If (ip-1.gt.nArr) Then
         Write (6,*) '  ip-1.gt.nArr*nZeta(2b) in PrjGrd'
         Call Abend
      End If
      ABeq(1) = TC(1).eq.RB(1)
      ABeq(2) = TC(2).eq.RB(2)
      ABeq(3) = TC(3).eq.RB(3)
      if (debug)
     &write(6,*) 'shll=',ishll,' nExp=',nExpi,
     &            ' nBeta=',nBeta
      Call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,
     &            TC,Array(ipCxyz),iAng,HerR(iHerR(nHer)),
     &            nHer,ABeq)
      Call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,
     &            RB,Array(ipBxyz),lb+ld,HerR(iHerR(nHer)),
     &            nHer,ABeq)
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,
     &            TC,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),
     &            nHer,ABeq)
      If (debug) Then
            Write (6,*) ' nbeta  = ',nbeta ,' nExp(',ishll,')=',
     &              nExpi,' nHer=',nHer,' lb=',lb,' iAng=',
     &              iAng,' nOrdOp=',nOrdOp

                  Write (6,*) ' Array(ipCxyz)=',
     &             DNrm2_(nBeta*nExpi*3*nHer*(iAng+1),
     &             Array(ipCxyz),1)
                  Write (6,*) ' Array(ipBxyz)=',
     &             DNrm2_(nBeta*nExpi*3*nHer*(lb+2),
     &             Array(ipBxyz),1)
                  Write (6,*) ' Array(ipRxyz)=',
     &             DNrm2_(nBeta*nExpi*3*nHer*(nOrdOp+1),
     &             Array(ipRxyz),1)
      End If

      Call Assmbl(Array(ipQ1),
     &            Array(ipCxyz),iAng,
     &            Array(ipRxyz),nOrdOp,
     &            Array(ipBxyz),lb+ld,
     &            nExpi*nBeta,HerW(iHerW(nHer)),nHer)
      iStrt = ipB
      Do  iGamma = 1, nExpi
         call dcopy_(nBeta,Beta,1,Array(iStrt),nExpi)
         iStrt = iStrt + 1
      Enddo
      If (debug) Then
                  Write (6,*) ' Array(ipB)=',
     &            DNrm2_(nExpi*nBeta,Array(ipB),1)
      End If

      Call rKappa_Zeta(Array(ipK2),Array(ipZ2),
     &                 nExpi*nBeta)
      Call CmbnCB(Array(ipQ1),nExpi*nBeta,iAng,lb,
     &            Array(ipK2),FB1,
     &            Array(ipB),JfGrad,ld,nVecCB)
      If (debug) Then
         Write (6,*) ' Array(ipQ1)=',
     &        DNrm2_(
     &        nExpi*nBeta*3*(lb+1+ld+2)*(iAng+1)*(nOrdOp+1),
     &        Array(ipQ1),1)
         Write (6,*) ' Array(ipB)=',
     &            DNrm2_(nExpi*nBeta,Array(ipB),1)
      End If
      If (ld.ge.2) Then
        Call CmbnS2b(Array(ipQ1),nBeta *nExpi,iang,lb,
     &            Array(ipK2),FB2,
     &            Array(ipB),jfHess,ld)
        If (debug) Then
           Do i=1,6
              ipV=1
              n=nBeta*nExpi*nElem(lb)*nElem(iAng)
              Write(6,*)n,nBeta,nExpi,nElem(lb),nElem(iAng)

              Write(6,*) 'CmbnB2(',n,')=',DNrm2_(n,FB2(ipV),1)
              ipV=ipV+n
           End do
        End If
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine axesxb2_cvb(asonc,ddres2upd,vec,
     >  resthr_inp,ioptc,iter,fx_exp,
     >  c,axc,sxc,share,res,rhs,
     >  ap,rhsp,solp,solp_res)
      implicit real*8 (a-h,o-z)
      logical share
#include "direct_cvb.fh"
      external asonc,ddres2upd
      external axexbsol_cvb,axesxbres_cvb,ddrestart_cvb
      dimension c(nparm,maxd),axc(nparm,maxd),sxc(nparm,maxd)
      dimension vec(nparm),res(nparm),rhs(*)
      dimension ap(maxd,maxd),rhsp(maxd)
      dimension solp(maxd),solp_res(maxd)

c  If RESTHR_INP unset use default:
      if(resthr_inp.ne.0d0)then
        resthr_use=resthr_inp
      else
        resthr_use=resthr
      endif
c------------------------------------------
c      ASonC             ASonC10_CVB
c      AxExbSOL_CVB      DDSOL10_CVB
c      AxESxbRES_CVB     DDRES10_CVB
c      DDRES2UPD         DDRES2UPD10_CVB
c      DDRESTART_CVB     DDRESTART_CVB
c------------------------------------------
      call dirdiag_cvb(asonc,axexbsol_cvb,
     >  axesxbres_cvb,ddres2upd,ddrestart_cvb,
     >  c,axc,sxc,share,vec,res,rhs,
     >  ap,rhsp,solp,solp_res,
     >  .false.,.true.,.true.,maxd,nparm,nfrdim,
     >  nvguess,nvrestart,isaddle,ifollow,mxit,
     >  resthr_use,orththr,nortiter,corenrg,
     >  ioptc,iter,fx_exp,ip)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function loopcntr_iterate_cvb()

use casvb_global, only: icode, iopt2step, ioptim, ioptstep, ipos, istackrep, joptstep, loopstepmx, noptim, noptstep
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp) :: loopcntr_iterate_cvb
integer(kind=iwp) :: i, iend, ioptstep1, ioptstep2, italter, kk, kk2, ll, ll1, mxalter, nc_zeroed, nconvinone, nstep
logical(kind=iwp) :: done, done2, unmatched
logical(kind=iwp), external :: istkprobe_cvb

if (iopt2step(ioptim+1) == iopt2step(ioptim)) then
  ioptim = ioptim+1
else

  joptstep = 0
  do ll=1,loopstepmx
    if (joptstep == ioptstep) exit
    if ((icode(ll) == 1) .or. (icode(ll) == 3)) joptstep = joptstep+1
  end do
  ll1 = ll
  do
    ! First determine if end of multi-step optimization may have been reached:
    if (.not. istkprobe_cvb(istackrep)) exit
    call istkpop_cvb(istackrep,nc_zeroed)
    call istkpop_cvb(istackrep,nconvinone)
    call istkpop_cvb(istackrep,italter)
    call istkpop_cvb(istackrep,mxalter)
    call istkpop_cvb(istackrep,kk2)
    call istkpop_cvb(istackrep,ioptstep2)
    call istkpop_cvb(istackrep,ioptstep1)
    ! Number of steps is IOPTSTEP2-IOPTSTEP1+1
    if (nconvinone == ioptstep2-ioptstep1+1) then
      ioptstep = ioptstep2
      joptstep = ioptstep2
      ll1 = kk2+1
    else
      ! Restore loop information:
      call istkpush_cvb(istackrep,ioptstep1)
      call istkpush_cvb(istackrep,ioptstep2)
      call istkpush_cvb(istackrep,kk2)
      call istkpush_cvb(istackrep,mxalter)
      call istkpush_cvb(istackrep,italter)
      call istkpush_cvb(istackrep,nconvinone)
      call istkpush_cvb(istackrep,nc_zeroed)
      exit
    end if
  end do
  done2 = .false.
  do ll=ll1,loopstepmx
    if (joptstep == ioptstep) then
      ! Looking for next card after previous OPTIM/REPORT:
      if ((icode(ll) == 2) .or. (icode(ll) == 4)) then
        if (ll == 1) then
          unmatched = .true.
        else
          unmatched = (icode(ll)-icode(ll-1) /= 1)
        end if
        if (unmatched) then
          write(u6,'(a)') ' Unmatched END or closing bracket!'
          call abend_cvb()
        end if
      end if
      if ((icode(ll) == 1) .or. (icode(ll) == 3)) then
        ! OPTIM / REPORT:
        ioptstep = ioptstep+1
        done2 = .true.
        exit
      else if (icode(ll) == 5) then
        ! ALTERN:
        ! Scan rest of file for number of steps in this loop:
        iend = 0
        ioptstep2 = joptstep
        done = .false.
        do kk=ll+1,loopstepmx
          if ((icode(kk) == 1) .or. (icode(kk) == 3)) then
            ioptstep2 = ioptstep2+1
          else if (icode(kk) == 5) then
            iend = iend-1
          else if (icode(kk) == 6) then
            iend = iend+1
          end if
          if (iend == 1) then
            done = .true.
            exit
          end if
        end do
        if (.not. done) then
          write(u6,*) ' Run-away ENDALTERN or closing bracket!'
          call abend_cvb()
        end if

        italter = 1
        mxalter = ipos(ll)
        nconvinone = -1
        nc_zeroed = 0
        call istkpush_cvb(istackrep,ioptstep+1)
        call istkpush_cvb(istackrep,ioptstep2)
        call istkpush_cvb(istackrep,kk)
        call istkpush_cvb(istackrep,mxalter)
        call istkpush_cvb(istackrep,italter)
        call istkpush_cvb(istackrep,nconvinone)
        call istkpush_cvb(istackrep,nc_zeroed)
      else if (icode(ll) == 6) then
        ! ENDALTERN:
        call istkpop_cvb(istackrep,nc_zeroed)
        call istkpop_cvb(istackrep,nconvinone)
        call istkpop_cvb(istackrep,italter)
        call istkpop_cvb(istackrep,mxalter)
        call istkpop_cvb(istackrep,kk2)
        call istkpop_cvb(istackrep,ioptstep2)
        call istkpop_cvb(istackrep,ioptstep1)
        italter = italter+1
        nstep = ioptstep-ioptstep1+1
        if ((nstep > 0) .and. (italter <= mxalter)) then
          ! Next loop iteration:
          call istkpush_cvb(istackrep,ioptstep1)
          call istkpush_cvb(istackrep,ioptstep2)
          call istkpush_cvb(istackrep,kk2)
          call istkpush_cvb(istackrep,mxalter)
          call istkpush_cvb(istackrep,italter)
          call istkpush_cvb(istackrep,nconvinone)
          call istkpush_cvb(istackrep,nc_zeroed)
          ioptstep = ioptstep1
          done2 = .true.
          exit
        else if (nstep > 0) then
          write(u6,'(/,a,i4,a)') ' Exiting',nstep,'-step optimization.'
          write(u6,'(a,i4)') ' Maximum number of loop iterations reached :',mxalter
        end if
      end if
    end if
    if ((icode(ll) == 1) .or. (icode(ll) == 3)) joptstep = joptstep+1
  end do
  if (.not. done2) ioptstep = noptstep+1

  do i=1,noptim
    if (iopt2step(i) == ioptstep) exit
  end do
  ioptim = i

end if

loopcntr_iterate_cvb = (ioptim <= noptim)

return

end function loopcntr_iterate_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION GTH1EN(IORB,ITP,ISM,JORB,JTP,JSM)
      use Arrays, only: KAIN1, pInt1
*
* One-electron integral for active
* orbitals (IORB,ITP,ISM),(JORB,JTP,JSM)
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "detdim.fh"
#include "Input.fh"
#include "orbinp_mclr.fh"
      GTH1EN =
     &GTH1ES_MCLR(IREOTS(1),pInt1,KAIN1,IBSO,
     &            IBTSOB,IORB,ITP,ISM,JORB,JTP,JSM)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine sumabdistt(n,idtot)
! this routine distributes work for n records among
! nprocab processors with the frequency, corresponding
! to ideffab values
!
! n     - # of records to be distributed (I)
! idtot - distribution vector (O)
!         (idtot(i) -  # of records to be realized by i-th node)

use ccsd_global, only: ideffab, nprocab
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
integer(kind=iwp), intent(out) :: idtot(nprocab)
integer(kind=iwp) :: i, imax, max_, ntot
real(kind=wp) :: rsum

!1 distribute recordsc according to eff. coefficients

rsum = sum(ideffab(1:nprocab))

idtot(:) = int(((ideffab(1:nprocab)*n)/rsum)+Half)

!2 do corrections, if roundoff errors caused some differences

do
  ntot = sum(idtot(:))

  if (ntot > n) then
    ! ubrat treba (z najvacsieho dielu)
    max_ = idtot(1)
    imax = 1
    do i=1,nprocab
      if (max_ < idtot(i)) then
        max_ = idtot(i)
        imax = i
      end if
    end do
    idtot(imax) = idtot(imax)-1
  else if (ntot < n) then
    ! pridat treba (k najvacsiemu dielu)
    max_ = idtot(1)
    imax = 1
    do i=1,nprocab
      if (max_ < idtot(i)) then
        max_ = idtot(i)
        imax = i
      end if
    end do
    idtot(imax) = idtot(imax)+1
  else
    exit
  end if
end do

return

end subroutine sumabdistt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3dhlp4 (w,v,dimp,dimpqr,denijk,ec,
     & diagp,
     & dimdiagp,addp)
c
c     this routine realize following procedure
c     for symp=symq=symr
c
c     ec = sum(pqr) [ W(pqr) . V(pqr) / Dijkpqr ]
c
c     w      - W  matrix (I)
c     v      - V  matrix (I)
c     dimp   - dimension of p index (I)
c     dimpqr - dimension of q index (I)
c     denijk - sum of i,j,k diagonal (other) F parts (I)
c     ec     - energy contribution
c     diagp  - vector of diagonal parts of symmetry p (I)
c     dimdiagp - dimension of diagonal parts in symetry p (I)
c     addp   - additional constant to p (Nocc) (I)
c
       integer dimp,dimpqr
       integer dimdiagp,addp
       real*8 ec,denijk
       real*8 w(1:dimpqr)
       real*8 v(1:dimpqr)
       real*8 diagp(1:dimdiagp)
c
c     help variables
c
       integer p,q,r,pqr
       real*8 denijkp,denijkpq,denijkpqr
c
       ec=0.0d0
c
       pqr=0
       do 100 p=3,dimp
       denijkp=denijk-diagp(p+addp)
       do 101 q=2,p-1
       denijkpq=denijkp-diagp(q+addp)
       do 102 r=1,q-1
       denijkpqr=denijkpq-diagp(r+addp)
       pqr=pqr+1
       ec=ec+w(pqr)*v(pqr)/denijkpqr
 102    continue
 101    continue
 100    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PCM_Cav_Hss(ToAng,nAt,nAt3,nTs,nS,Eps,IAtm,AtmC,AtmChg,
     &           EF_n,EF_e,Sphere,ISphe,nOrd,Tessera,Q,Qtot,DM,HssPCM,
     &           DerMat,DerTes,DerPunt,DerRad,DerCentr,QDer,Der1,Der2,
     &           VDer)
      Implicit real*8 (a-h,o-z)
      Integer IAtm(nAt)
      Dimension EF_n(3,*),EF_e(3,*)
      Dimension AtmC(3,nAt),AtmChg(nAt)
      Dimension Sphere(4,*),ISphe(*),nOrd(*)
      Dimension Tessera(4,*),Q(2,*),DM(nTs,*),Qtot(*),QDer(3,nAt,*)
      Dimension HssPCM(nAt3,*),DerMat(nTs,*),Der1(*),Der2(*),VDer(nTs,*)
      Dimension DerTes(nTs,NAt,3),DerPunt(nTs,NAt,3,3)
      Dimension DerRad(nS,NAt,3),DerCentr(nS,NAt,3,3)
      Logical DoPot, DoFld
#include "real.fh"
*
************************************************************
*
*     Compute the PCM geometric contribution to gradients
*
************************************************************
*
      Call FZero(HssPCM,nAt3*nAt3)
*
*     Compute the electric field on tesserae
      DoPot = .False.
      DoFld = .True.
      Call V_EF_PCM(nAt,nTs,DoPot,DoFld,AtmC,Tessera,
     &     Der2,EF_n,EF_e)
*
*---- Compute the derivative of the potential integrals
*     (they should be passed to VDer_PCM below: presently
*      not working, this quantity is temporarily read
*      from a file in VDer_PCM).
*
      Call PotGrd(Der1,nAt3)
*
*---- Derivatives of the total electrostatic potential on tiles
*
      Call VDer_PCM(nAt,nTs,nS,AtmC,AtmChg,EF_n,EF_e,
     &     Tessera,iSphe,DerTes,DerPunt,DerRad,DerCentr,VDer)
*
*---- Derivatives of solvation charges
*
      Call DerChg(nAt,nAt3,nTs,nS,Eps,IAtm,AtmC,AtmChg,
     &  DM,DerMat,Tessera,Q,Qtot,QDer,
     &  DerTes,DerPunt,DerCentr,DerRad,Der1,Der2,VDer,Sphere,ISphe)
cpcm_solvent
c     write(6,'(''Charge derivative wrt. atom and coord.'')')
c     do 1123 iat = 1, nat
c       do 1123 ic = 1, 3
c         do 1123 its = 1, nts
c           write(6,'(3i5,f20.12)')iat,ic,its,QDer(ic,iat,its)
c1123 continue
cpcm_solvent end
*
*---- Derivative of the cavity term
*
      Call DerCav(ToAng,nTs,nAt,nS,nAt3,Eps,Tessera,Q,Qtot,Der1,
     $  Dertes,DerPunt,DerCentr,DerRad,QDer,Sphere,iSphe,
     $  nOrd)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Create_Grads
!
!> @brief Create an empty gradients file
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Creates an empty gradients file (GRADS), to contain all the computed
!> gradients and couplings for the different roots.
!>
!> Structure of the gradients file:
!>  - 0: \p TOC (5 integers, each a disk address)
!>  - \p TOC(1): \p nRoots
!>  - \p TOC(2): \p nGrad
!>  - \p TOC(3): \p i_grad (\p nRoots integers)
!>  - \p TOC(4): \p i_nac (max(1,\p nRoots * (\p nRoots - 1)/2) integers)
!>  - \p TOC(5): Next free address
!>  - \p i_grad(i): Gradient of state \p i (\p nGrad reals)
!>  - \p i_nac(m): Coupling between states \p i and \p j
!>                 (\p m = \p i * (\p i - 1)/2 + \p j, \p i > \p j) (\p nGrad reals)
!>
!> If \p i_grad(i) or \p i_nac(m) is 0, the vector is not present in the
!> file. If it is negative, the vector is not present and cannot be
!> computed (so it is pointless to ask for it again).
!>
!> @param[in] FN     Filename for the gradients file (prgm-translatable)
!> @param[in] nRoots Number of roots to include in the file
!> @param[in] nGrad  Length of each gradient vector
!***********************************************************************

subroutine Create_Grads(FN,nRoots,nGrad)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: FN
integer(kind=iwp), intent(in) :: nRoots, nGrad
integer(kind=iwp) :: iAd, iDum(1), Lu, nCoup, TOC(5)
integer(kind=iwp), allocatable :: i_grad(:), i_nac(:)

nCoup = max(1,nRoots*(nRoots-1)/2)
call mma_allocate(i_grad,nRoots)
call mma_allocate(i_nac,nCoup)
TOC(:) = 0
i_grad(:) = 0
i_nac(:) = 0

Lu = 20
call DaName(Lu,trim(FN))
iAd = 0
call iDaFile(Lu,1,TOC,size(TOC),iAd)
TOC(1) = iAd
iDum(1) = nRoots
call iDaFile(Lu,1,iDum,1,iAd)
TOC(2) = iAd
iDum(1) = nGrad
call iDaFile(Lu,1,iDum,1,iAd)
TOC(3) = iAd
call iDaFile(Lu,1,i_grad,nRoots,iAd)
TOC(4) = iAd
call iDaFile(Lu,1,i_nac,nCoup,iAd)
TOC(5) = iAd
iAd = 0
call iDaFile(Lu,1,TOC,size(TOC),iAd)
call DaClos(Lu)

call mma_deallocate(i_grad)
call mma_deallocate(i_nac)

end subroutine Create_Grads

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GSBBD2B(RHO2,RHO2S,RHO2A,IASM,IATP,IBSM,IBTP,NIA,NIB,JASM,JATP,JBSM,JBTP,NJA,NJB,IAGRP,IBGRP,NGAS,IAOC,IBOC,JAOC,JBOC, &
                   SB,CB,MXPNGAS,NOBPTS,IOBPTS,MAXK,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,X,NSMOB,IUSEAB,CJRES,SIRES,NORB,SCLFAC, &
                   S2_TERM1,IPACK)
! SUBROUTINE GSBBD2B --> 52
!
! alpha-beta contribution to two-particle density matrix
! from given c-block and s-block.
!
! S2_TERM1 = - <L!a+i alpha a+jbeta a i beta a j alpha !R>
! =====
! Input
! =====
!
! IASM,IATP : Symmetry and type of alpha  strings in sigma
! IBSM,IBTP : Symmetry and type of beta   strings in sigma
! JASM,JATP : Symmetry and type of alpha  strings in C
! JBSM,JBTP : Symmetry and type of beta   strings in C
! NIA,NIB : Number of alpha-(beta-) strings in sigma
! NJA,NJB : Number of alpha-(beta-) strings in C
! IAGRP : String group of alpha strings
! IBGRP : String group of beta strings
! IAEL1(3) : Number of electrons in RAS1(3) for alpha strings in sigma
! IBEL1(3) : Number of electrons in RAS1(3) for beta  strings in sigma
! JAEL1(3) : Number of electrons in RAS1(3) for alpha strings in C
! JBEL1(3) : Number of electrons in RAS1(3) for beta  strings in C
! CB   : Input C block
! NTSOB  : Number of orbitals per type and symmetry
! IBTSOB : base for orbitals of given type and symmetry
! IBORB  : Orbitals of given type and symmetry
! NSMOB  : Number of symmetries of orbitals
! MAXK   : Largest number of inner resolution strings treated at simult.
! IPACK  : Should we pack the density?
!
! ======
! Output
! ======
! SB : updated sigma block
!
! =======
! Scratch
! =======
!
! I1, XI1S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! I2, XI2S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! X : Space for block of two-electron integrals
!
! Jeppe Olsen, Fall of 1996

use Symmetry_Info, only: Mul
use Para_Info, only: MyRank, nProcs
use lucia_data, only: LOFFI
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: RHO2(*), RHO2S(*), RHO2A(*), S2_TERM1
integer(kind=iwp), intent(in) :: IASM, IATP, IBSM, IBTP, NIA, NIB, JASM, JATP, JBSM, JBTP, NJA, NJB, IAGRP, IBGRP, NGAS, IAOC(*), &
                                 IBOC(*), JAOC(*), JBOC(*), MXPNGAS, NOBPTS(MXPNGAS,*), IOBPTS(MXPNGAS,*), MAXK, NSMOB, IUSEAB, NORB
integer(kind=iwp), intent(_OUT_) :: I1(*), I2(*), I3(*), I4(*)
real(kind=wp), intent(in) :: SB(*), CB(*), SCLFAC
real(kind=wp), intent(_OUT_) :: XI1S(*), XI2S(*), XI3S(*), XI4S(*), X(*), CJRES(*), SIRES(*)
logical(kind=iwp), intent(in) :: IPACK
integer(kind=iwp) :: I, IDOCOMP, II, IJ, IJSM, IJTYP, IKABTC, IKORD, IOFF, ISM, ITP(20), ITYP, J, JI, JJ, JOFF, JSM, JTP(20), &
                     JTYP, KABOT, KATOP, KLSM, KLTYP, KOFF, KSM, KTP(20), KTYP, LKABTC, LOFF, LSM, LTP(20), LTYP, NI, NIJ, NIJTYP, &
                     NJ, NK, NKABTC, NKABTCSZ, NKAEFF, NKASTR, NKBSTR, NKLTYP, NL
real(kind=wp), allocatable :: OFFI(:)

#ifdef _DEBUGPRINT_
write(u6,*) ' ================'
write(u6,*) ' GSBBD2B speaking'
write(u6,*) ' ================'
!write(u6,*) ' NJAS NJB = ',NJA,NJB
!write(u6,*) ' IAGRP IBGRP = ',IAGRP,IBGRP
!write(u6,*) ' MXPNGAS = ',MXPNGAS
!write(u6,*) ' NSMOB = ',NSMOB
#endif

! Symmetry of allowed excitations
IJSM = Mul(IASM,JASM)
KLSM = Mul(IBSM,JBSM)
if ((IJSM == 0) .or. (KLSM == 0)) return
#ifdef _DEBUGPRINT_
write(u6,*) ' IASM JASM IJSM ',IASM,JASM,IJSM
write(u6,*) ' IBSM JBSM KLSM ',IBSM,JBSM,KLSM
#endif
! Types of SX that connects the two strings
call SXTYP_GAS(NKLTYP,KTP,LTP,NGAS,IBOC,JBOC)
call SXTYP_GAS(NIJTYP,ITP,JTP,NGAS,IAOC,JAOC)
if ((NIJTYP == 0) .or. (NKLTYP == 0)) return
! Repeated allocation/deallocation inside ADSTN_GAS has been
! outerlooped to here. OFFI added to call parameters of
! ADSTN_GAS. PAM March 2006.
call mma_allocate(OFFI,lOFFI,Label='OFFI')
OFFI(:) = Zero

do IJTYP=1,NIJTYP
  ITYP = ITP(IJTYP)
  JTYP = JTP(IJTYP)
  do ISM=1,NSMOB
    JSM = Mul(ISM,IJSM)
    if (JSM == 0) cycle
#   ifdef _DEBUGPRINT_
    write(u6,*) ' ISM JSM ',ISM,JSM
#   endif
    IOFF = IOBPTS(ITYP,ISM)
    JOFF = IOBPTS(JTYP,JSM)
    NI = NOBPTS(ITYP,ISM)
    NJ = NOBPTS(JTYP,JSM)
    if ((NI == 0) .or. (NJ == 0)) cycle
    ! Generate annihilation mappings for all Ka strings
    ! a+j!ka> = +/-/0 * !Ja>
    call ADSTN_GAS(OFFI,JSM,JTYP,JATP,JASM,IAGRP,I1,XI1S,NKASTR,SCLFAC)
    if (NKASTR == 0) cycle
    ! a+i!ka> = +/-/0 * !Ia>
    call ADSTN_GAS(OFFI,ISM,ITYP,IATP,IASM,IAGRP,I3,XI3S,NKASTR,One)
    if (NKASTR == 0) cycle
    ! Compress list to common nonvanishing elements
    IDOCOMP = 1
    if (IDOCOMP == 1) then
      !    COMPRS2LST(I1,XI1,N1,I2,XI2,N2,NKIN,NKOUT)
      call COMPRS2LST(I1,XI1S,NJ,I3,XI3S,NI,NKASTR,NKAEFF)
    else
      NKAEFF = NKASTR
    end if

    ! Loop over batches of KA strings
    NKABTC = 0
    do
      NKABTC = NKABTC+NPROCS
      NKABTCSZ = max(NKAEFF-1,0)/NKABTC+1
      if (NKABTCSZ <= MAXK) exit
    end do

    do IKABTC=1+MYRANK,NKABTC,NPROCS
      KABOT = (IKABTC-1)*NKABTCSZ+1
      KATOP = min(KABOT+NKABTCSZ-1,NKAEFF)
      LKABTC = KATOP-KABOT+1
      if (LKABTC <= 0) exit
      ! Obtain C(ka,J,JB) for Ka in batch
      do JJ=1,NJ
        call GET_CKAJJB(CB,NJ,NJA,CJRES,LKABTC,NJB,JJ,I1(KABOT+(JJ-1)*NKASTR),XI1S(KABOT+(JJ-1)*NKASTR))
      end do
      ! Obtain S(ka,i,Ib) for Ka in batch
      do II=1,NI
        call GET_CKAJJB(SB,NI,NIA,SIRES,LKABTC,NIB,II,I3(KABOT+(II-1)*NKASTR),XI3S(KABOT+(II-1)*NKASTR))
      end do

      do KLTYP=1,NKLTYP
        KTYP = KTP(KLTYP)
        LTYP = LTP(KLTYP)

        do KSM=1,NSMOB
          LSM = Mul(KSM,KLSM)
          if (LSM == 0) cycle
          KOFF = IOBPTS(KTYP,KSM)
          LOFF = IOBPTS(LTYP,LSM)
          NK = NOBPTS(KTYP,KSM)
          NL = NOBPTS(LTYP,LSM)
          ! If IUSEAB is used, only terms with i >= k will be generated so
          IKORD = 0
          if ((IUSEAB == 1) .and. (ISM > KSM)) cycle
          if ((IUSEAB == 1) .and. (ISM == KSM) .and. (ITYP < KTYP)) cycle
          if ((IUSEAB == 1) .and. (ISM == KSM) .and. (ITYP == KTYP)) IKORD = 1

          if ((NK == 0) .or. (NL == 0)) cycle
          ! Obtain all connections a+l!Kb> = +/-/0!Jb>
          call ADSTN_GAS(OFFI,LSM,LTYP,JBTP,JBSM,IBGRP,I2,XI2S,NKBSTR,One)
          if (NKBSTR == 0) cycle
          ! Obtain all connections a+k!Kb> = +/-/0!Ib>
          call ADSTN_GAS(OFFI,KSM,KTYP,IBTP,IBSM,IBGRP,I4,XI4S,NKBSTR,One)
          if (NKBSTR == 0) cycle

          ! Update two-electron density matrix
          ! Rho2b(ij,kl) =  Sum(ka)S(Ka,i,Ib)<Ib!Eb(kl)!Jb>C(Ka,j,Jb)

          X(1:NI*NJ*NK*NL) = Zero

          call ABTOR2(SIRES,CJRES,LKABTC,NKBSTR,X,NI,NJ,NK,NL,NKBSTR,I4,XI4S,I2,XI2S,IKORD)
          ! contributions to Rho2(ij,kl) has been obtained, scatter out
          !call wrtmat(x,ni*nj,nk*nl,ni*nj,nk*nl)
          ! Contribution to S2
          if ((KTYP == JTYP) .and. (KSM == JSM) .and. (ITYP == LTYP) .and. (ISM == LSM)) then
            do I=1,NI
              do J=1,NJ
                IJ = (J-1)*NI+I
                JI = (I-1)*NJ+J
                NIJ = NI*NJ
                S2_TERM1 = S2_TERM1-X((JI-1)*NIJ+IJ)
              end do
            end do
          end if

          call ADTOR2(RHO2,RHO2S,RHO2A,X,2,NI,IOFF,NJ,JOFF,NK,KOFF,NL,LOFF,NORB,IPACK)

          !write(u6,*) ' updated density matrix B ','norb = ',norb
          !write(u6,*) ' offset ','IOFF,JOFF,KOFF,LOFF',IOFF,JOFF,KOFF,LOFF
          !call prsym(rho2s,nTri_Elem(NORB))

        end do
      end do
    end do
    ! End of loop over partitioning of alpha strings
  end do
end do
! This 'flush' outerlooped here. Was previously inside ADSTN_GAS.
call mma_deallocate(OFFI)

end subroutine GSBBD2B

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Trns3(Win,Wout,na,nb,nvec,nc,Temp)
************************************************************************
*                                                                      *
* Object: utility routine to transform a AO batch in case of redun-    *
*         dancy of type aA=bB or cC=dD.                                *
*                                                                      *
* Called from: TwoEl                                                   *
*                                                                      *
* Calling    : Trns2                                                   *
*              DGeTMO  (ESSL)                                          *
*              DCopy   (ESSL)                                          *
*                                                                      *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             June '90                                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
c#include "print.fh"
      Real*8 Win(na,nb), Wout(nb,na),Temp(na,nb)
*
c     iRout = 71
c     iPrint = nPrint(iRout)
*     Write (*,*) ' In Trns1: na, nb, nVec, nc=',na,nb,nvec,nc
*     Call RecPrt(' Win',' ',Win,na,nb)
      If (nc.eq.1) Then
         call dcopy_(nvec,Win,1,Wout,1)
         Return
      End If
      If (na.eq.1 .or. nb.eq.1) Then
         Call Trns2(Win,Wout,nvec,nc)
      Else
         Call DGeTMO(Win,na,na,nb,Wout,nb)
*        Call RecPrt(' After first DGeTMO',' ',Wout,nb,na)
         Call Trns2(Wout,Temp,nvec,nc)
*        Call RecPrt(' After Trns2',' ',Temp,nb,na)
         Call DGeTMO(Temp,nb,nb,na,Wout,na)
*        Call RecPrt(' After second DGeTMO',' ',Wout,na,nb)
      End If
*     Call GetMem(' Exit Trns1','CHECK','REAL',iDum,iDum)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine APPRIM(EPP,EPB,TPQ,AP,ENP,T2,ICASE)

use cpf_global, only: IPRINT, IRC
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: EPP(*), EPB(*), ENP(*)
real(kind=wp), intent(_OUT_) :: TPQ(*), AP(*), T2(*)
integer(kind=iwp), intent(in) :: ICASE(*)
integer(kind=iwp) :: I, IP

IP = IRC(4)
do I=1,IP
  call TPQSET(ICASE,TPQ,I)
  T2(1:IP) = (EPP(1:IP)+EPB(1:IP))*TPQ(1:IP)/ENP(1:IP)
  call VECSUM_CPFMCPF(T2,AP(I),IP)
  AP(I) = AP(I)*ENP(I)
end do

if (IPRINT > 5) write(u6,999) (AP(I),I=1,IP)

return

999 format(6X,'AP ',5F10.6)

end subroutine APPRIM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Ortho_Orb(Xmo,Smat,nBas,nOrb2Loc,nPass,
     &                     Test)
C
C
C     Purpose: orthonormalization of orbitals according to
C
C              V = X^T*S*X
C              X <- X*V^(-1/2)
C
C              where S is the AO overlap matrix.
C              The orthonormalization is carried out nPass times.
C              After this routine, X will satisfy X^T*S*X=1.
C
C
      Implicit Real*8 (a-h,o-z)
      Real*8  Xmo(*), Smat(*)
      Integer nBas, nOrb2Loc
      Logical Test
#include "WrkSpc.fh"

      Character*9 SecNam
      Parameter (SecNam = 'Ortho_Orb')

      Parameter (Tol = 1.0d-10)

      external ddot_

C     Check for quick return.
C     -----------------------

      If (nPass .lt. 1) Return

C     Allocations.
C     ------------

      l_V = nOrb2Loc**2
      l_VSqrt = l_V
      l_VISqrt = l_V
      l_Scr = 2*(nBas**2) + nBas*(nBas+1)/2  ! needed in SqrtMt
      Call GetMem('V','Allo','Real',ip_V,l_V)
      Call GetMem('VSqrt','Allo','Real',ip_VSqrt,l_VSqrt)
      Call GetMem('VISqrt','Allo','Real',ip_VISqrt,l_VISqrt)
      Call GetMem('Scr','Allo','Real',ip_Scr,l_Scr)

C     Orthonormalization passes.
C     --------------------------

      Do iPass = 1,nPass

C        Compute V = X^T*S*X.
C        --------------------

         Call GetUmat_Localisation(Work(ip_V),
     &                             Xmo(1),Smat(1),Xmo(1),
     &                             Work(ip_Scr),l_Scr,
     &                             nBas,nOrb2Loc)

C        Compute V^(-1/2).
C        -----------------

         iTask = 2 ! compute sqrt as well as inverse sqrt
         Call SqrtMt(Work(ip_V),nOrb2Loc,iTask,
     &               Work(ip_VSqrt),Work(ip_VISqrt),Work(ip_Scr))

C        Compute orthonormal X <- X*V^(-1/2).
C        ------------------------------------

         nB = max(nBas,1)
         nO2L = max(nOrb2Loc,1)
         Call dCopy_(nBas*nOrb2Loc,Xmo(1),1,
     &                            Work(ip_Scr),1)
         Call DGEMM_('N','N',nBas,nOrb2Loc,nOrb2Loc,
     &                1.0d0,Work(ip_Scr),nB,Work(ip_VISqrt),nO2L,
     &                0.0d0,Xmo(1),nB)

      End Do

C     Test orthonormalization (i.e. V=1?).
C     ------------------------------------

      If (Test) Then
         nErr = 0
         Call GetUmat_Localisation(Work(ip_V),
     &                             Xmo(1),Smat(1),Xmo(1),
     &                             Work(ip_Scr),l_Scr,
     &                             nBas,nOrb2Loc)
         kOff = ip_V - 1
         Do i = 1,nOrb2Loc
            Work(kOff+nOrb2Loc*(i-1)+i) =
     &      Work(kOff+nOrb2Loc*(i-1)+i) - 1.0d0
         End Do
         xNrm = sqrt(dDot_(nOrb2Loc**2,Work(ip_V),1,Work(ip_V),1))
         If (xNrm .gt. Tol) Then
            Write(6,'(A,A,D16.8,A,I2,A)')
     &      SecNam,': ERROR: ||X^TSX - 1|| = ',xNrm
            nErr = nErr + 1
         End If
         If (nErr .ne. 0) Then
            Write(6,*) SecNam,': failure after ',nPass,' passes'
            Call SysAbendMsg(SecNam,'Orthonormalization failure!',' ')
         End If
      End If

C     De-allocations.
C     ---------------

      Call GetMem('Scr','Free','Real',ip_Scr,l_Scr)
      Call GetMem('VISqrt','Free','Real',ip_VISqrt,l_VISqrt)
      Call GetMem('VSqrt','Free','Real',ip_VSqrt,l_VSqrt)
      Call GetMem('V','Free','Real',ip_V,l_V)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function MorsSymm(IMORS,ISMARR)

use Symmetry_Info, only: MUL
use Cntrl, only: MORSBITS
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: MorsSymm
integer(kind=iwp), intent(in) :: IMORS, ISMARR(*)
integer(kind=iwp) :: I, IB, IBIT

MorsSymm = 1
if (IMORS < 0) then
  write(u6,*) ' MorsSymm: Bad IMORS=',IMORS
  call ABEND()
end if
IB = IMORS
do I=1,MORSBITS
  IBIT = mod(IB,2)
  IB = IB/2
  if (IBIT == 1) MorsSymm = MUL(MorsSymm,ISMARR(I))
end do

end function MorsSymm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine INT5(I,J,L)
! I < J < L   I == K

use guga_global, only: COUP, IJ, ILIM, IVF0, IWAY, J1, J2, JM, JM1, MXVERT
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: I, J, L
integer(kind=iwp) :: IFAI, ISTOP, IT1, IT2, ITT, ITURN, ITYP, KM, LJ, LJM, LJS
logical(kind=iwp) :: first1, first2, skip

ITYP = 0
LJS = IJ(L+1)+1
LJM = IJ(L)
do ITT=1,ILIM
  IT1 = (ITT-1)*MXVERT
  IT2 = IT1
  do LJ=LJS,LJM
    IWAY(L) = 1
    skip = .false.
    loop_1: do
      if (skip) then
        skip = .false.
      else
        KM = L
        J2(KM+1) = LJ
        J1(KM+1) = LJ
        call LOOP1(KM,ISTOP,IT1,IT2)
        if (ISTOP == 1) exit loop_1
      end if
      KM = KM-1
      IWAY(KM) = 1
      first1 = KM == J
      loop_2: do
        if (first1) then
          first1 = .false.
          ITURN = 0
          IWAY(J) = 1
          loop_3: do
            KM = J
            JM(KM) = IVF0+1
            JM1(KM) = IVF0+1
            if (ITURN == 0) then
              call LOOP10(KM,ISTOP,IT1,IT2)
            else if (ITURN == 1) then
              IFAI = 0
              call LOOP13(KM,ISTOP,IFAI,IT1,IT2)
            end if
            if (ISTOP /= 0) then
              if (ITURN /= 1) then
                ITURN = 1
                IWAY(J) = 1
                cycle loop_3
              else
                KM = KM+1
                if (KM == L) cycle loop_1
                cycle loop_2
              end if
            end if
            loop_4: do
              KM = KM-1
              IWAY(KM) = 1
              first2 = KM == I
              do
                if (first2) then
                  do
                    KM = I
                    if (ITURN == 0) then
                      call LOOP14(KM,ISTOP,IT1,IT2)
                    else if (ITURN == 1) then
                      call LOOP22(KM,ISTOP,IT1,IT2)
                    end if
                    if (ISTOP == 1) exit
                    if (abs(COUP(I)) < 1.0e-6_wp) cycle
                    call COMP(I,LJ,ITYP,I,IT1,IT2)
                  end do
                  first2 = .false.
                else
                  JM(KM) = IVF0+1
                  JM1(KM) = IVF0+1
                  if (ITURN == 0) then
                    call LOOP17(KM,ISTOP,IT1,IT2)
                  else if (ITURN == 1) then
                    IFAI = 0
                    call LOOP23(KM,ISTOP,IFAI,IT1,IT2)
                  end if
                  if (ISTOP == 0) cycle loop_4
                end if
                KM = KM+1
                if (KM == J) cycle loop_3
              end do
              if (.true.) exit loop_4
            end do loop_4
            if (.true.) exit loop_3
          end do loop_3
          exit loop_2
        else
          call LOOP5(KM,ISTOP,IT1,IT2)
          if (ISTOP == 0) then
            skip = .true.
            cycle loop_1
          end if
          KM = KM+1
          if (KM == L) cycle loop_1
        end if
      end do loop_2
      if (.true.) exit loop_1
    end do loop_1
  end do
end do

return

end subroutine INT5

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine divthelp2 (t2,dima,dimb,dimi,dimj,dpa,dpb,dpi,dpj,
     &                       shifta,shiftb)
c
c     this routine do
c     t2(a,b,i,j) = t2(a,b,i,j)/(dpi(i)+dpj(j)-dpa(a)-dpb(b))
c
c     t2        - T2 matrix (I/O)
c     dima    - 1 dimension of T2 (I)
c     dimb    - 2 dimension of T2 (I)
c     dimi    - 3 domension of T2 (I)
c     dimj    - 4 domension of T2 (I)
c     dpa     - diagonal part of Fok corresponding to irrep of a (I)
c     dpb     - diagonal part of Fok corresponding to irrep of b (I)
c     dpi     - diagonal part of Fok corresponding to irrep of i (I)
c     dpj     - diagonal part of Fok corresponding to irrep of j (I)
c     shifta        - number off occ orbitals in spin and symmetry of a (I)
c     shiftb        - number off occ orbitals in spin and symmetry of b (I)
c
c     N.B. Since for T1 i and a are of the same spin, there is no reason
c     to specify spin of dp. It must be automatically the same spin ad i and a.
c
       integer dima,dimb,dimi,dimj,shifta,shiftb
       real*8 t2(1:dima,1:dimb,1:dimi,1:dimj)
       real*8 dpa(*)
       real*8 dpb(*)
       real*8 dpi(*)
       real*8 dpj(*)
c
c     help variables
c
       integer i,j,a,b
       real*8 den,denj,denij,denijb
c
       do 100 j=1,dimj
       denj=dpj(j)
       do 101 i=1,dimi
       denij=denj+dpi(i)
       do 102 b=1,dimb
       denijb=denij-dpb(shiftb+b)
       do 103 a=1,dima
c     t2(a,b,i,j)=t2(a,b,i,j)/(denijb-dpa(shifta+a))
c
       den=denijb-dpa(shifta+a)
       if (abs(den).lt.1.0d-7) then
       if (abs(t2(a,b,i,j)).gt.1.0d-10) then
       t2(a,b,i,j)=t2(a,b,i,j)/den
       end if
       else
       t2(a,b,i,j)=t2(a,b,i,j)/den
       end if
c
 103    continue
 102    continue
 101    continue
 100    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
      SubRoutine BasFun_Atom(nBas_per_Atom,nBas_Start,Name,
     &                       nBas,nAtoms,DoPrint)
C
C     Author: Y. Carissan [put in separate subroutine by T.B. Pedersen]
C
      Implicit None
#include "Molcas.fh"
      Integer nBas, nAtoms
      Integer nBas_per_Atom(nAtoms), nBas_Start(nAtoms)
      Character*(LENIN8) Name(nBas)
      Logical DoPrint

      Character*11 SecNam
      Parameter (SecNam = 'BasFun_Atom')

      Integer iAt, iAt1, nBasAt, iBas, iCount

      Character*(LENIN)  Lbl, LblOld
      Character*80 Txt, Formt

C     Counters.
C     ---------

      iAt    = 1
      nBasAt = 1
      LblOld = Name(1)(1:LENIN)
      Do iBas = 2,nBas
         Lbl = Name(iBas)(1:LENIN)
         If (Lbl .ne. LblOld) Then
            nBas_per_Atom(iAt) = nBasAt
            iAt    = iAt + 1
            nBasAt = 0
            LblOld = Lbl
         End If
         nBasAt = nBasAt + 1
      End Do
      nBas_per_Atom(iAt) = nBasAt

      If (iAt .ne. nAtoms) Then ! centers without basis functions
         iAt1 = iAt + 1
         Do iAt = iAt1,nAtoms
            nBas_per_Atom(iAt) = 0
         End Do
      End If

C     Offsets.
C     --------

      iCount = 0
      Do iAt = 1,nAtoms
         nBas_Start(iAt) = iCount + 1
         iCount = iCount + nBas_per_Atom(iAt)
      End Do
      If (iCount .ne. nBas) Then
         Write(Txt,'(A,I9,A,I9)') 'iCount =',iCount,'  nBas =',nBas
         Call SysAbendMsg(SecNam,'iCount.NE.nBas',Txt)
      End If

C     Print.
C     ------

      If (DoPrint) Then
         Write(Formt,'(3(a6,i3,a5))') '(/,a6,',nAtoms,'i5,/,',
     &                                '   a6,',nAtoms,'i5,/,',
     &                                '   a6,',nAtoms,'i5)'
         Write(6,Formt) 'Atom  ',(iAt,iAt=1,nAtoms),
     &                  'Start ',(nBas_Start(iAt),iAt=1,nAtoms),
     &                  'nBas  ',(nBas_per_Atom(iAt),iAt=1,nAtoms)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************

module kriging_mod

use Definitions, only: wp, iwp

implicit none
private

! Define and initiate Kriging parameters.

logical(kind=iwp) :: Kriging = .false., &
                     anMd = .true., &
                     blAI = .false., &
                     mblAI = .false., &
                     blaAI = .true., &
                     set_l = .false., &
                     ordinary = .false., &
                     PGEK_On = .false.
integer(kind=iwp) :: nspAI = 1, pAI = 2, Max_MicroIterations = 50, nD_In = 0
real(kind=wp) :: lb(3) = [20.0_wp,20.0_wp,1.0_wp], &
                 Thr_MicroIterations = 1.0e-8_wp, &
                 blavAI = 10.0_wp, &
                 blvAI = 0.0_wp

! Memory for coordinates, value and gradients of the
! sample points.

real(kind=wp), allocatable, protected :: x(:,:), y(:), dy(:)

! Inter  : the dimension of the coordinate vector
! nPoints: the total number of sample points for which the value is
!          used or the gradient is used
! nD     : the total number of sample points less for which the
!          gradients are used
!
! We will assume that nD >= 0

integer(kind=iwp), protected :: nInter = 0, nPoints = 0, nD = 0
integer(kind=iwp) :: nInter_Eff = 0

real(kind=wp), allocatable :: rl(:,:), dl(:), full_Rinv(:,:), full_R(:,:), x0(:), Kv(:), cv(:,:,:), Rones(:), l(:), gpred(:), &
                              hpred(:,:), ll(:), cvMatFder(:), cvMatSder(:), cvMatTder(:)
integer(kind=iwp), allocatable :: Index_PGEK(:)
real(kind=wp) :: pred, sigma, var, sb, variance, detR, lh, sbO, sbmev
integer(kind=iwp) :: m_t
real(kind=wp), parameter :: h = 1e-5, eps = 1e-13, eps2 = 1e-10
! eps avoid to become singular in 1st der & eps2 in 2nd der

! Transformation matrix for kriging_layer routines

real(kind=wp), allocatable :: layer_U(:,:)

public :: anMd, blaAI, blAI, blavAI, blvAI, cv, cvMatFder, cvMatSder, cvMatTder, detR, dl, dy, eps, eps2, full_R, full_RInv, &
          gpred, h, hpred, Index_PGEK, Kriging, kv, l, layer_U, lb, lh, ll, Max_MicroIterations, m_t, mblAI, nD, nD_In, nInter, &
          nInter_Eff, nPoints, nspAI, ordinary, pAI, PGEK_On, pred, rl, Rones, sb, sbmev, sbO, set_l, sigma, Thr_MicroIterations, &
          var, variance, x, x0, y
public :: Deallocate_Protected, Prep_Kriging

contains

subroutine Prep_Kriging(nPoints_In,nInter_In,x_,dy_,y_)

  use stdalloc, only: mma_allocate

  integer(kind=iwp), intent(in) :: nPoints_In, nInter_In
  real(kind=wp), intent(in) :: x_(nInter_In,nPoints_In), y_(nPoints_In), dy_(nInter_In,nPoints_In)
  integer(kind=iwp) :: i, j

  nInter = nInter_In
  nInter_Eff = nInter
  nPoints = nPoints_In
  nD = max(0,min(nD_In,nPoints-nD_In))

  ! Allocate arrays for data or energies, coordinates, and gradients

  call mma_Allocate(x,nInter,nPoints,label='x')
  call mma_Allocate(y,nPoints,label='y')
  call mma_Allocate(dy,nInter*(nPoints-nD),label='dy')

  ! The code will use partial GEK with indirect addressing. However,
  ! here we defaults the index array so that it behaves as conventional GEK.

  call mma_Allocate(Index_PGEK,nInter,label='Index_PGEK')
  do i=1,nInter
    Index_PGEK(i) = i
  end do

  ! x is the n-dimensional internal coordinates
  x(:,:) = x_(:,:)
  !write(u6,*) 'x',x
  ! y is the energy
  y(:) = y_(:)
  !write(u6,*) 'y',y
  ! dy is a vector of Grad-y (eq. (5) ref. gradients of
  ! the energy with respect to the internal coordinates
  !
  ! Note the storage as subblocks of the same component of the
  ! gradient, each subblock running over all nPoints_g which
  ! contributes with gradient values.
  ! This will enable a somewhat simpler code later on in the PGEK case.
  !
  ! At this point we also skip those gradients which we will not use in
  ! the kriging.

  do i=1,nInter
    do j=1,nPoints-nD
      dy(j+(i-1)*(nPoints-nD)) = dy_(i,j+nD)
    end do
  end do

  return

end subroutine Prep_kriging

subroutine Deallocate_protected()

  use stdalloc, only: mma_deallocate

  call mma_Deallocate(x)
  call mma_Deallocate(y)
  call mma_Deallocate(dy)

end subroutine Deallocate_protected

end module kriging_mod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine transcon(contold,idim1,idim2,ovlp,contnew,nprim,ncont)
      implicit real*8 (a-h,o-z)
      dimension contold(idim1,idim2),contnew(nprim,ncont),
     *ovlp(idim1,idim1)
c     write(6,*) 'begin transcon nprim,ncont ',nprim,ncont
cbs   copy old contraction coefficients in dense form to common block
      do Jrun=1,ncont
      do Irun=1,nprim
      contnew(Irun,Jrun)=contold(Irun,Jrun)
      enddo
      enddo
cbs   ensure normalization
      do ICONT=1,ncont
              xnorm=0d0
              do Jrun=1,nprim
              do Irun=1,nprim
              xnorm=xnorm+contnew(Irun,ICONT)*contnew(Jrun,ICONT)
     *        *ovlp(Irun,Jrun)
c       write(6,*) 'Icont,jrun,irun,xnorm ',
c    *  icont,jrun,irun,xnorm
              enddo
              enddo
c       write(6,*) 'ICONT ',ICONT,xnorm
              xnorm=1d0/sqrt(xnorm)
cbs   scale with normalization factor
              do Irun=1,nprim
              contnew(Irun,ICONT)=xnorm*contnew(Irun,ICONT)
              enddo
      enddo
c     write(6,*) 'end transcon nprim,ncont ',nprim,ncont
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine page_out(KeyWord,nConf,Vector,LuDavid)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Save any vector for further use by the Davidson diagonalization  *
!     Labels identifying the vectors are kept in a stack and to        *
!     minimize a write through cache strategy is applied               *
!                                                                      *
!     calling arguments:                                               *
!     KeyWord : character(len=llab)                                    *
!               record identifier                                      *
!     nConf   : integer                                                *
!               length of the vector H_diag                            *
!     Vector  : array of real*8                                        *
!               any vector of length nConf                             *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use davctl_mod, only: disk_address, LblStk, llab, memory_vectors, mixed_mode_1, mixed_mode_2, mxDiskStk, mxMemStk, nDiskStk, &
                      nMemStk, save_in_memory, save_mode
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
character(len=llab), intent(in) :: KeyWord
integer(kind=iwp), intent(in) :: nConf, LuDavid
real(kind=wp), intent(_IN_) :: Vector(nConf)
integer(kind=iwp) :: iDisk, iStk, nStk
#include "rasdim.fh"

! check input arguments
if (nConf < 0) then
  write(u6,*) 'page_out: nConf less than 0'
  write(u6,*) 'nConf = ',nConf
  call Abend()
end if

! search for a matching record identifier
nStk = 0
do iStk=1,(mxMemStk+mxDiskStk)
  if (LblStk(iStk) == KeyWord) then
    nStk = iStk
    exit
  end if
end do

! there is a matching record identifier:
! overwrite the current record
if (nStk /= 0) then
  if (nStk <= mxMemStk) then
    memory_vectors(:,nStk) = Vector(:)
  else
    iDisk = disk_address(nStk-mxMemStk)
    call DDaFile(LuDavid,1,Vector,nConf,iDisk)
  end if
end if

! there is no matching record identifier:
! create a new record
if (nStk == 0) then
  if (save_mode == mixed_mode_1) then
    if (KeyWord(1:6) == 'CI_vec') then
      if (save_in_memory) then
        nMemStk = nMemStk+1
        memory_vectors(:,nMemStk) = Vector(:)
        LblStk(nMemStk) = KeyWord
        if (nMemStk == mxMemStk) save_in_memory = .false.
      else
        nMemStk = nMemStk+1
        if (nMemStk > mxMemStk) nMemStk = 1
        nDiskStk = nDiskStk+1
        if (nDiskStk > mxDiskStk) nDiskStk = 1
        iDisk = disk_address(nDiskStk)
        call DDaFile(LuDavid,1,memory_vectors(:,nMemStk),nConf,iDisk)
        memory_vectors(:,nMemStk) = Vector(:)
        LblStk(mxMemStk+nDiskStk) = LblStk(nMemStk)
        LblStk(nMemStk) = KeyWord
      end if
    else
      nDiskStk = nDiskStk+1
      if (nDiskStk > mxDiskStk) nDiskStk = 1
      iDisk = disk_address(nDiskStk)
      call DDaFile(LuDavid,1,Vector,nConf,iDisk)
      LblStk(mxMemStk+nDiskStk) = KeyWord
    end if
  end if
  if (save_mode == mixed_mode_2) then
    if (save_in_memory) then
      nMemStk = nMemStk+1
      memory_vectors(:,nMemStk) = Vector(:)
      LblStk(nMemStk) = KeyWord
      if (nMemStk == mxMemStk) save_in_memory = .false.
    else
      nMemStk = nMemStk+1
      if (nMemStk > mxMemStk) nMemStk = 1
      nDiskStk = nDiskStk+1
      if (nDiskStk > mxDiskStk) nDiskStk = 1
      iDisk = disk_address(nDiskStk)
      call DDaFile(LuDavid,1,memory_vectors(:,nMemStk),nConf,iDisk)
      memory_vectors(:,nMemStk) = Vector(:)
      LblStk(mxMemStk+nDiskStk) = LblStk(nMemStk)
      LblStk(nMemStk) = KeyWord
    end if
  end if
end if

return

end subroutine page_out

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Martin Schuetz                                         *
!               Roland Lindh                                           *
!               2015, Steven Vancoillie                                *
!               2017,2026, Ignacio Fdez. Galvan                        *
!***********************************************************************

!***********************************************************************
! Wrapper routines against the GA-ChemIO or MPI-IO package.            *
! (EAF = exclusive access file)                                        *
!                                                                      *
! If not an mpp installation the AIX-IO facility will be used.         *
!                                                                      *
! dEAFxxxx subroutines simply provides an interface for the EAF        *
! subroutines with real buffers instead of integers, note that nBuf is *
! still the length of the integer buffer.                              *
!***********************************************************************

module EAFmod

#ifdef ADD_
#define eaf_open eaf_open_
#define eaf_close eaf_close_
#define eaf_awrite eaf_awrite_
#define eaf_aread eaf_aread_
#define eaf_write eaf_write_
#define eaf_read eaf_read_
#define eaf_wait eaf_wait_
#endif

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use Definitions, only: u6, ItoB
#endif
use Definitions, only: wp, iwp

implicit none
private

#include "intent.fh"

#ifdef _MOLCAS_MPP_
#ifdef _HAVE_EXTRA_
integer(kind=iwp), external :: molcas_eaf_aread, molcas_eaf_awrite, molcas_eaf_close, molcas_eaf_open, molcas_eaf_read, &
                               molcas_eaf_wait molcas_eaf_write
#else
! Include file from GlobalArrays
#include "eaf.fh"
#endif
#endif

public :: dEAFARead, dEAFAWrite, dEAFRead, dEAFWrite, EAFARead, EAFAWrite, EAFClose, EAFOpen, EAFRead, EAFWait, EAFWrite

contains

subroutine EAFOpen(Lu,FName)

# ifdef _MOLCAS_MPP_
  use Para_Info, only: MyRank
# endif

  integer(kind=iwp), intent(out) :: Lu
  character(len=*), intent(in) :: FName
  integer(kind=iwp), external :: IsFreeUnit
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: iRC
  character(len=200) :: FN
# ifdef _HAVE_EXTRA_
  integer(kind=iwp) :: n
# endif
# endif

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
    write(FN,'(A,"_",I0)') trim(FName),MyRank
#   ifdef _HAVE_EXTRA_
    n = len_trim(FName)
    FN(n+1:n+1) = char(0)
    iRC = molcas_eaf_open(FN,Lu)
#   else
    iRC = eaf_open(FN,eaf_rw,Lu)
#   endif
    if (iRC /= 0) then
      write(u6,*) 'EAFOpen: Abort!'
      write(u6,*) 'iRC=',iRC
      write(u6,*) 'Lu=',Lu
      write(u6,*) 'Fname=',FName
      write(u6,*) 'EAF_Err_Code =',iRC
      call Abend()
    end if
  else
# endif
    Lu = IsFreeUnit(7)
    call DaName_MF(Lu,FName)
# ifdef _MOLCAS_MPP_
  end if
# endif
end subroutine EAFOpen

subroutine EAFClose(Lu)

  integer(kind=iwp), intent(in) :: Lu
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: iRC
# endif

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
#   ifdef _HAVE_EXTRA_
    iRC = molcas_eaf_close(Lu)
#   else
    iRC = eaf_close(Lu)
#   endif
    if (iRC /= 0) then
      write(u6,*) 'EAFClose: Abort!'
      write(u6,*) 'EAF_Err_Code =',iRC
      call Abend()
    end if
  else
# endif
    call DaClos(Lu)
# ifdef _MOLCAS_MPP_
  end if
# endif

end subroutine EAFClose

subroutine EAFAWrite(Lu,Buf,nBuf,Disk,id)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  integer(kind=iwp), intent(_IN_) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp), intent(out) :: id
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: iRC
# endif

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
#   ifdef _HAVE_EXTRA_
    iRC = molcas_eaf_awrite(Lu,Disk,Buf,nBuf*ItoB,id)
#   else
    iRC = eaf_awrite(Lu,Disk,Buf,nBuf*ItoB,id)
    Disk = Disk+real(nBuf*ItoB,kind=wp)
#   endif
    if (iRC /= 0) then
      write(u6,*) 'EAFAWrite: Abort!'
      write(u6,*) 'EAF_Err_Code =',iRC
      call Abend()
    end if
  else
# endif
    id = 0
    call EAFWrite(Lu,Buf,nBuf,Disk)
# ifdef _MOLCAS_MPP_
  end if
# endif

end subroutine EAFAWrite

subroutine EAFARead(Lu,Buf,nBuf,Disk,id)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  integer(kind=iwp), intent(out) :: Buf(nBuf), id
  real(kind=wp), intent(inout) :: Disk
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: iRC
# endif

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
#   ifdef _HAVE_EXTRA_
    iRC = molcas_eaf_aread(Lu,Disk,Buf,nBuf*ItoB,id)
#   else
    iRC = eaf_aread(Lu,Disk,Buf,nBuf*ItoB,id)
    Disk = Disk+real(nBuf*ItoB,kind=wp)
#   endif
    if (iRC /= 0) then
      write(u6,*) 'EAFARead: Abort!'
      write(u6,*) 'EAF_Err_Code =',iRC
      call Abend()
    end if
  else
# endif
    id = 0
    call EAFRead(Lu,Buf,nBuf,Disk)
# ifdef _MOLCAS_MPP_
  end if
# endif

end subroutine EAFARead

subroutine EAFWrite(Lu,Buf,nBuf,Disk)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  integer(kind=iwp), intent(_IN_) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp) :: iDisk
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: iRC
# endif

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
#   ifdef _HAVE_EXTRA_
    iRC = molcas_eaf_write(Lu,Disk,Buf,nBuf*ItoB)
#   else
    iRC = eaf_write(Lu,Disk,Buf,nBuf*ItoB)
    Disk = Disk+real(nBuf*ItoB,kind=wp)
#   endif
    if (iRC /= 0) then
      write(u6,*) 'EAFWrite: Abort!'
      write(u6,*) 'EAF_Err_Code =',iRC
      call Abend()
    end if
  else
# endif
    iDisk = int(Disk)
    call iDaFile(Lu,1,Buf,nBuf,iDisk)
    Disk = real(iDisk,kind=wp)
# ifdef _MOLCAS_MPP_
  end if
# endif

end subroutine EAFWrite

subroutine EAFRead(Lu,Buf,nBuf,Disk)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  integer(kind=iwp), intent(out) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp) :: iDisk
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: iRC
# endif

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
#   ifdef _HAVE_EXTRA_
    iRC = molcas_eaf_read(Lu,Disk,Buf,nBuf*ItoB)
#   else
    iRC = eaf_read(Lu,Disk,Buf,nBuf*ItoB)
    Disk = Disk+real(nBuf*ItoB,kind=wp)
#   endif
    if (iRC /= 0) then
      write(u6,*) 'EAFRead: Abort!'
      write(u6,*) 'EAF_Err_Code =',iRC
      call Abend()
    end if
  else
# endif
    iDisk = int(Disk)
    call iDaFile(Lu,2,Buf,nBuf,iDisk)
    Disk = real(iDisk,kind=wp)
# ifdef _MOLCAS_MPP_
  end if
# endif

end subroutine EAFRead

subroutine EAFWait(Lu,id)

  integer(kind=iwp), intent(in) :: Lu, id
# ifdef _MOLCAS_MPP_
  integer(kind=iwp) :: iRC
# endif

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) then
#   ifdef _HAVE_EXTRA_
    iRC = molcas_eaf_wait(Lu,id)
#   else
    iRC = eaf_wait(Lu,id)
#   endif
    if (iRC /= 0) then
      write(u6,*) 'EAFWait: Abort!'
      write(u6,*) 'EAF_Err_Code =',iRC
      call Abend()
    end if
  end if
# else
# include "macros.fh"
  unused_var(Lu)
  unused_var(id)
# endif

end subroutine EAFWait

subroutine dEAFARead(Lu,Buf,nBuf,Disk,id)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  real(kind=wp), target, intent(out) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp), intent(out) :: id
  integer(kind=iwp), pointer :: iBuf(:)

  call c_f_pointer(c_loc(Buf),iBuf,[nBuf])
  call EAFARead(Lu,iBuf,nBuf,Disk,id)
  nullify(iBuf)

end subroutine dEAFARead

subroutine dEAFAWrite(Lu,Buf,nBuf,Disk,id)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  real(kind=wp), target, intent(in) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp), intent(out) :: id
  integer(kind=iwp), pointer :: iBuf(:)

  call c_f_pointer(c_loc(Buf),iBuf,[nBuf])
  call EAFAWrite(Lu,iBuf,nBuf,Disk,id)
  nullify(iBuf)

end subroutine dEAFAWrite

subroutine dEAFRead(Lu,Buf,nBuf,Disk)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  real(kind=wp), target, intent(out) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp), pointer :: iBuf(:)

  call c_f_pointer(c_loc(Buf),iBuf,[nBuf])
  call EAFRead(Lu,iBuf,nBuf,Disk)
  nullify(iBuf)

end subroutine dEAFRead

subroutine dEAFWrite(Lu,Buf,nBuf,Disk)

  integer(kind=iwp), intent(in) :: Lu, nBuf
  real(kind=wp), target, intent(in) :: Buf(nBuf)
  real(kind=wp), intent(inout) :: Disk
  integer(kind=iwp), pointer :: iBuf(:)

  call c_f_pointer(c_loc(Buf),iBuf,[nBuf])
  call EAFWrite(Lu,iBuf,nBuf,Disk)
  nullify(iBuf)

end subroutine dEAFWrite

end module EAFmod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_DBGINT()
!
! Purpose: regenerate and check integrals as specified in input.

use Cholesky, only: CHO_MINCHK, ICHKQ, NCHKQ

implicit none

if (CHO_MINCHK) then ! minimal check
  call CHO_MCA_DBGINT_S(ICHKQ,NCHKQ,.true.)
else ! check all (or the number of col. from input)
  call CHO_MCA_DBGINT_A()
end if

end subroutine CHO_DBGINT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               1996, Hans-Joachim Werner                              *
!***********************************************************************

subroutine Assg1(Temp,PAO,nT,nRys,la,lb,lc,ld,xyz2D0,xyz2D1,IfGrad,Indx,mVec)
!***********************************************************************
!                                                                      *
! Object: to assemble the gradients of the ERI's.                      *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91; modified by H.-J. Werner, Mai 1996          *
!***********************************************************************

use Index_Functions, only: C_Ind3_Rev, nTri_Elem1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Temp(9)
integer(kind=iwp), intent(in) :: nT, nRys, la, lb, lc, ld, Indx(3,4)
real(kind=wp), intent(in) :: PAO(nT,nTri_Elem1(la),nTri_Elem1(lb),nTri_Elem1(lc),nTri_Elem1(ld)), &
                             xyz2D0(nRys,nT,0:la+1,0:lb+1,0:lc+1,0:ld+1,3), xyz2D1(nRys,nT,0:la,0:lb,0:lc,0:ld,9)
logical(kind=iwp), intent(in) :: IfGrad(3,4)
integer(kind=iwp), intent(out) :: mVec
#include "itmax.fh"
integer(kind=iwp) :: i, iCent, icir(3), Ind1(3,3), Ind2(3,3), ipa, ipb, ipc, ipd, ixa, ixabcd, ixb, ixbcd, ixc, ixcd, ixd, iya, &
                     iyabcd, iyb, iybcd, iyc, iycd, iyd, iza, izb, izc, izd, nVec(3)

Temp(:) = Zero

mVec = 0
nVec(:) = 0
do i=1,3       ! Cartesian directions
  do iCent=1,4 ! Centers of integral
    if (IfGrad(i,iCent)) then
      mVec = mVec+1
      nVec(i) = nVec(i)+1
      Ind1(nVec(i),i) = 3*(Indx(i,iCent)-1)+i
      Ind2(nVec(i),i) = mVec
    end if
  end do
end do

do ipd=1,nTri_Elem1(ld)
  icir(:) = C_Ind3_Rev(ipd,ld)
  ixd = icir(1)
  iyd = icir(2)
  izd = icir(3)

  do ipc=1,nTri_Elem1(lc)
    icir(:) = C_Ind3_Rev(ipc,lc)
    ixc = icir(1)
    iyc = icir(2)
    izc = icir(3)

    ixcd = ixc+ixd
    iycd = iyc+iyd

    do ipb=1,nTri_Elem1(lb)
      icir(:) = C_Ind3_Rev(ipb,lb)
      ixb = icir(1)
      iyb = icir(2)
      izb = icir(3)

      ixbcd = ixcd+ixb
      iybcd = iycd+iyb

      do ipa=1,nTri_Elem1(la)
        icir(:) = C_Ind3_Rev(ipa,la)
        ixa = icir(1)
        iya = icir(2)
        iza = icir(3)

        ixabcd = ixbcd+ixa
        iyabcd = iybcd+iya

        ! Compute all desired gradients with respect to an x-component.

        if (iyabcd /= 0) then

          select case (nVec(1))
            case (3)
              call ass3(xyz2D0(1,1,iya,iyb,iyc,iyd,2),xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)), &
                        xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(2,1)),xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(3,1)),PAO(1,ipa,ipb,ipc,ipd), &
                        Temp(Ind2(1,1)),Temp(Ind2(2,1)),Temp(Ind2(3,1)),nT,nRys)
            case (2)
              call ass2(xyz2D0(1,1,iya,iyb,iyc,iyd,2),xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)), &
                        xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(2,1)),PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,1)),Temp(Ind2(2,1)),nT,nRys)
            case (1)
              call ass1(xyz2D0(1,1,iya,iyb,iyc,iyd,2),xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)), &
                        PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,1)),nT,nRys)
          end select

        else

          select case (nVec(1))
            case (3)
              call ass3a(xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)), &
                         xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(2,1)),xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(3,1)),PAO(1,ipa,ipb,ipc,ipd), &
                         Temp(Ind2(1,1)),Temp(Ind2(2,1)),Temp(Ind2(3,1)),nT,nRys)
            case (2)
              call ass2a(xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)), &
                         xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(2,1)),PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,1)),Temp(Ind2(2,1)),nT,nRys)
            case (1)
              call ass1a(xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,ixa,ixb,ixc,ixd,Ind1(1,1)),PAO(1,ipa,ipb,ipc,ipd), &
                         Temp(Ind2(1,1)),nT,nRys)
          end select

        end if

        ! Compute all desired gradients with respect to a y-component.

        if (ixabcd /= 0) then

          select case (nVec(2))
            case (3)
              call ass3(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)), &
                        xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(2,2)),xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(3,2)),PAO(1,ipa,ipb,ipc,ipd), &
                        Temp(Ind2(1,2)),Temp(Ind2(2,2)),Temp(Ind2(3,2)),nT,nRys)
            case (2)
              call ass2(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)), &
                        xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(2,2)),PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,2)),Temp(Ind2(2,2)),nT,nRys)
            case (1)
              call ass1(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)), &
                        PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,2)),nT,nRys)
          end select

        else

          select case (nVec(2))
            case (3)
              call ass3a(xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)), &
                         xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(2,2)),xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(3,2)),PAO(1,ipa,ipb,ipc,ipd), &
                         Temp(Ind2(1,2)),Temp(Ind2(2,2)),Temp(Ind2(3,2)),nT,nRys)
            case (2)
              call ass2a(xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)), &
                         xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(2,2)),PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,2)),Temp(Ind2(2,2)),nT,nRys)
            case (1)
              call ass1a(xyz2D0(1,1,iza,izb,izc,izd,3),xyz2D1(1,1,iya,iyb,iyc,iyd,Ind1(1,2)),PAO(1,ipa,ipb,ipc,ipd), &
                         Temp(Ind2(1,2)),nT,nRys)
          end select

        end if

        ! Compute all desired gradients with respect to a z-component.

        if (ixabcd*iyabcd /= 0) then

          select case (nVec(3))
            case (3)
              call ass3(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),xyz2D0(1,1,iya,iyb,iyc,iyd,2),xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)), &
                        xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),xyz2D1(1,1,iza,izb,izc,izd,Ind1(3,3)),PAO(1,ipa,ipb,ipc,ipd), &
                        Temp(Ind2(1,3)),Temp(Ind2(2,3)),Temp(Ind2(3,3)),nT,nRys)
            case (2)
              call ass2(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),xyz2D0(1,1,iya,iyb,iyc,iyd,2),xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)), &
                        xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),Temp(Ind2(2,3)),nT,nRys)
            case (1)
              call ass1(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),xyz2D0(1,1,iya,iyb,iyc,iyd,2),xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)), &
                        PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),nT,nRys)
          end select

        else if ((ixabcd == 0) .and. (iyabcd /= 0)) then

          select case (nVec(3))
            case (3)
              call ass3a(xyz2D0(1,1,iya,iyb,iyc,iyd,2),xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)), &
                         xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),xyz2D1(1,1,iza,izb,izc,izd,Ind1(3,3)),PAO(1,ipa,ipb,ipc,ipd), &
                         Temp(Ind2(1,3)),Temp(Ind2(2,3)),Temp(Ind2(3,3)),nT,nRys)
            case (2)
              call ass2a(xyz2D0(1,1,iya,iyb,iyc,iyd,2),xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)), &
                         xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),Temp(Ind2(2,3)),nT,nRys)
            case (1)
              call ass1a(xyz2D0(1,1,iya,iyb,iyc,iyd,2),xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),PAO(1,ipa,ipb,ipc,ipd), &
                         Temp(Ind2(1,3)),nT,nRys)
          end select

        else if ((iyabcd == 0) .and. (ixabcd /= 0)) then

          select case (nVec(3))
            case (3)
              call ass3a(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)), &
                         xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),xyz2D1(1,1,iza,izb,izc,izd,Ind1(3,3)),PAO(1,ipa,ipb,ipc,ipd), &
                         Temp(Ind2(1,3)),Temp(Ind2(2,3)),Temp(Ind2(3,3)),nT,nRys)
            case (2)
              call ass2a(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)), &
                         xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),Temp(Ind2(2,3)),nT,nRys)
            case (1)
              call ass1a(xyz2D0(1,1,ixa,ixb,ixc,ixd,1),xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),PAO(1,ipa,ipb,ipc,ipd), &
                         Temp(Ind2(1,3)),nT,nRys)
          end select

        else

          select case (nVec(3))
            case (3)
              call ass3b(xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)), &
                         xyz2D1(1,1,iza,izb,izc,izd,Ind1(3,3)),PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),Temp(Ind2(2,3)), &
                         Temp(Ind2(3,3)),nT,nRys)
            case (2)
              call ass2b(xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),xyz2D1(1,1,iza,izb,izc,izd,Ind1(2,3)),PAO(1,ipa,ipb,ipc,ipd), &
                         Temp(Ind2(1,3)),Temp(Ind2(2,3)),nT,nRys)
            case (1)
              call ass1b(xyz2D1(1,1,iza,izb,izc,izd,Ind1(1,3)),PAO(1,ipa,ipb,ipc,ipd),Temp(Ind2(1,3)),nT,nRys)
          end select

        end if

      end do

    end do

  end do

end do

return

end subroutine Assg1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WelMem(nHer,MemWel,la,lb,lr)
*
      k = la+lb
      jsum = 1
      Do 10 i = 1, k
         jsum = jsum + 3**i
 10   Continue
      nHer=1
      MemWel = jsum +Max((k+1)*(k/2+1)*(k/4+1)+1,
     &                   9+3**k,
     &                   5)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lr)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE LINPUR(CMO)
      use stdalloc, only: mma_allocate, mma_deallocate
      use rasscf_global, only: BName, IXSYM
      use general_data, only: NSYM,NBAS,NORB
      use Molcas, only: LenIn

      IMPLICIT None
      Real*8 CMO(*)

      CHARACTER(LEN=2) LCHAR
      Real*8 WGTLMB(0:9)
      LOGICAL IFTEST
* Define mxsym etc.
      Integer, Allocatable:: LMB(:)
      Integer i, IB, IBAS, IBASES, ICMOES, IO, IORB, IORBES, ISSLAB,
     &        ISYM, L, LCOUNT, LEXIST, LMX, MNL, MXL, NB, NBTOT, NO,
     &        NONZ
      REAL*8 WGT, WMX

* Set IFTEST=.true. to get supsym input generated in the output
* for further use, or for testing.
      IFTEST=.false.

      IF(IFTEST) WRITE(6,*)'SUPSYM'

* Set up array with lambda for each basis function:
      NBTOT=0
      DO ISYM=1,NSYM
       NBTOT=NBTOT+NBAS(ISYM)
      END DO
      CALL mma_allocate(LMB,NBTOT,Label='LMB')
      DO IBAS=1,NBTOT
       LCHAR=BName(IBAS)(LenIn+4:LenIn+5)
       IF(LCHAR.EQ.'  ') THEN
         L=0
       ELSE IF(LCHAR.EQ.'x ') THEN
         L=1
       ELSE IF(LCHAR.EQ.'y ') THEN
         L=-1
       ELSE IF(LCHAR.EQ.'z ') THEN
         L=0
       ELSE
         READ(LCHAR,'(I2)') L
         IF (BName(IBAS)(LenIn+5:LenIn+5).EQ.'-') THEN
           L=-L
         END IF
       END IF
       LMB(IBAS)=ABS(L)
      END DO
      ICMOES=0
      IBASES=0
      IORBES=0
      DO ISYM=1,NSYM
       NB=NBAS(ISYM)
       NO=NORB(ISYM)
       IF(NO.EQ.0) GOTO 100
       DO IO=1,NO
        IORB=IORBES+IO
        DO L=0,9
         WGTLMB(L)=0.0D0
        END DO
        DO IB=1,NB
         IBAS=IBASES+IB
         L=LMB(IBAS)
         WGT=CMO(ICMOES+IB+NB*(IO-1))**2
         WGTLMB(L)=WGTLMB(L)+WGT
        END DO
        LMX=0
        WMX=WGTLMB(0)
        DO L=0,9
         IF(WGTLMB(L).GT.WMX) THEN
           LMX=L
           WMX=WGTLMB(L)
         END IF
        END DO
        IXSYM(IORB)=LMX
       END DO
* We have now a provisional IXSYM array. How many different
* L values appear in it?
       MNL=9
       MXL=0
       NONZ=0
       DO L=0,9
        LEXIST=0
        DO IO=1,NO
         IORB=IORBES+IO
         IF(L.EQ.IXSYM(IORB))THEN
          LEXIST=1
          MNL=MIN(L,MNL)
          MXL=MAX(L,MXL)
          GOTO 19
         END IF
        END DO
  19    CONTINUE
        NONZ=NONZ+LEXIST
       END DO
* There are NONZ different values, so we want NONZ-1 special supsym
* labels for this symmetry. Reuse LMB for orbital numbers:
* This will be the supsym label:
       IF (IFTEST) WRITE(6,*) NONZ-1
       ISSLAB=0
       DO L=MNL,MXL
        LCOUNT=0
        DO IO=1,NO
         IORB=IORBES+IO
         IF(L.EQ.IXSYM(IORB))THEN
          LCOUNT=LCOUNT+1
          LMB(LCOUNT)=IO
         END IF
        END DO
        IF(LCOUNT.GT.0) THEN
* Replace provisional IXSYM value with correct label:
          DO IO=1,NO
           IORB=IORBES+IO
           IF(IXSYM(IORB).eq.L) IXSYM(IORB)=ISSLAB
          END DO
* Lowest L = label zero = do not specify in input:
          IF (IFTEST.and.(ISSLAB.GT.0)) THEN
           WRITE(6,'(1x,I3,16I5,(/,5X,16I5))') LCOUNT,
     &         (LMB(i),i=1,LCOUNT)
          END IF
          ISSLAB=ISSLAB+1
        END IF
       END DO

       ICMOES=ICMOES+NO*NB
       IORBES=IORBES+NO
 100   CONTINUE
       IBASES=IBASES+NB
      END DO
      CALL mma_deallocate(LMB)

      END SUBROUTINE LINPUR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Pr2D(xyz2D,nT,nRys,la,lb,lc,ld,IfGrad,iPrint)
      Implicit Real*8 (a-h,o-z)
      Real*8 xyz2d(nT,nRys,0:la+1,0:lb+1,0:lc+1,0:ld+1,3)
      Logical IfGrad(3,4)
      Character Label*80, ch(3)*3
      Data ch/',x)',',y)',',z)'/
*
      Write (6,*)
      Write (6,*) ' Printing the 2d-integrals'
      Write (6,*)
*
      Label = ' '
      ja = 0
      If (IfGrad(1,1).or.IfGrad(2,1).or.IfGrad(3,1)) ja = 1
      jb = 0
      If (IfGrad(1,2).or.IfGrad(2,2).or.IfGrad(3,1)) jb = 1
      jc = 0
      If (IfGrad(1,3).or.IfGrad(2,3).or.IfGrad(3,3)) jc = 1
      jd = 0
      If (IfGrad(1,4).or.IfGrad(2,4).or.IfGrad(3,4)) jd = 1
      Do 10 ia = 0, la+ja
         kb = jb
         If (ia.gt.la) jb = 0
         Do 20 ib = 0, lb+jb
            kc = jc
            If (ia.gt.la.or.ib.gt.lb) jc = 0
            Do 30 ic = 0, lc+jc
               kd = jd
               If (ia.gt.la.or.ib.gt.lb.or.ic.gt.lc) kd = jd
               Do 40 id = 0, ld+jd
                  Do 50 iCar = 1, 3
                     If (ja.eq.1.and.ia.eq.la+ja.and.
     &                   .Not.IfGrad(iCar,1)) Go To 51
                     If (jb.eq.1.and.ib.eq.lb+jb.and.
     &                   .Not.IfGrad(iCar,2)) Go To 51
                     If (jc.eq.1.and.ic.eq.lc+jc.and.
     &                   .Not.IfGrad(iCar,3)) Go To 51
                     If (jd.eq.1.and.id.eq.ld+jd.and.
     &                   .Not.IfGrad(iCar,4)) Go To 51
                     Write (Label,'(A,4(I1,A))')
     &                ' xyz2D0(',ia,',',ib,',',ic,',',id,ch(iCar)
                     If (iPrint.ge.99) Then
                        Call RecPrt(Label,' ',
     &                  xyz2d(1,1,ia,ib,ic,id,iCar),nT,nRys)
                     Else
                        Write (6,'(A)') Label
                        Write (6,*) DDot_(nT*nRys,
     &                   xyz2d(1,1,ia,ib,ic,id,iCar),1,
     &                   xyz2d(1,1,ia,ib,ic,id,iCar),1)
                     End If
 51                  Continue
 50               Continue
 40            Continue
 30          Continue
 20       Continue
 10    Continue
*
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************

!----------------------------------------------------------------------*
! A function that will return the double factorial. We do not expect   *
! big numbers, so we do it brute-force. Observe that N must be odd, but*
! to skip the if-sentence, we assume that the one who calls this       *
! function has seen to that.                                           *
!----------------------------------------------------------------------*
function iDubFac(N)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iDubFac
integer(kind=iwp), intent(in) :: N
integer(kind=iwp) :: k

iDubFac = 1
do k=3,N,2
  iDubFac = iDubFac*k
end do

return

end function iDubFac

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RdInp_MCLR()
!***********************************************************************
!                                                                      *
!     Locate input stream and read commands                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use OneDat, only: sOpSiz
use Fock_util_global, only: Deco, dmpk, Estimate, Nscreen, Update
use MCLR_Data, only: DspVec, ESTERR, FANCY_PRECONDITIONER, ISMECIMSPD, ISNAC, ISTATE, lDisp, NACSTATES, NewPre, nexp_max, nGP, &
                     NoFile, NSSA, OVERRIDE, SA, SwLbl
use input_mclr, only: CasInt, Debug, double, Eps, iBreak, IsPop, kPrint, lCalc, lRoots, lSave, mTit, nAtoms, nDisp, NewCho, nIter, &
                      nsRot, nSym, ntPert, nUserPT, Omega, Page, RASSI, SpinPol, StepType, TimeDep, TitleIn, TwoStep, UserP, UserT
use PCM_grad, only: RFPERT
use cgs_mod, only: CGS
use Molcas, only: MxAtom
use RASDim, only: MxTit
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u5, u6

implicit none
integer(kind=iwp) :: I, ICOM, ICOMP, ID, iDum(1), iMass, IOPT, IP, IPP, IRC, IRRFNC, istatus, ISYLBL, ISYM, ITIT, J, JCOM, nDiff
logical(kind=iwp) :: DoRys, Epsilon_Undef, Skip
character(len=72) :: Line
character(len=8) :: Label, SewLab
character(len=4) :: Command
character(len=2) :: Element(MxAtom)
real(kind=wp), allocatable :: umass(:)
character(len=3), allocatable :: cmass(:)
integer(kind=iwp), parameter :: nCom = 38
character(len=*), parameter :: ComTab(nCom) = ['TITL','DEBU','ROOT','    ','CGS ','RFPE','ITER','THRE','END ','TIME', &
                                               '    ','NOFI','SEWA','NOCO','NOTW','SPIN','PRIN','PCGD','RESI','NOTO', &
                                               'EXPD','NEGP','LOWM','    ','SAVE','RASS','DISO','CASI','SALA','NODE', &
                                               'ESTE','    ','MASS','NAC ','    ','THER','CHOF','TWOS']

!----------------------------------------------------------------------*
!     Locate "start of input"                                          *
!----------------------------------------------------------------------*
call RdNLst(u5,'MCLR')
!----------------------------------------------------------------------*
!     Define default values                                            *
!----------------------------------------------------------------------*
debug = .false.
Epsilon_Undef = .true.
! Calling Basis_Info_Get(), Center_Info_Get(), and Get_info_Static() are replaced with IniSew below
nDiff = 0
DoRys = .true.
call IniSew(DoRys,nDiff)
istate = 1     ! State for which the Lagrangian is calc.
override = .false.
if (debug) write(u6,*) 'Got Basis_Info and Center_Info'
lRoots = -1
kprint = 0
ngp = .false.
NoFile = .false.
mTit = 0
Omega = Zero
TimeDep = .false.
Page = .false.
ibreak = 2
nIter = 200
RASSI = .false.
spinpol = .false.
SA = .false.
esterr = .false.
FANCY_PRECONDITIONER = .true.
lsave = .false.
lCalc(:) = .true.
DspVec(1:nDisp) = [(i,i=1,nDisp)]
CASINT = .true.
NACstates(1) = 0
NACstates(2) = 0
NSSA(1) = 0
NSSA(2) = 0
isNAC = .false.
isMECIMSPD = .false.
NewCho = .false.
! Cholesky. Cannot modify it in the input (yet?)
dmpk = 1.0e-2_wp
Nscreen = 10
Deco = .true.
Update = .true.
Estimate = .false.
TwoStep = .false.
StepType = 'xxxx'
CGS = .false.
RFPERT = .false.
!----------------------------------------------------------------------*
!     Read the input stream line by line and identify key command      *
!----------------------------------------------------------------------*
Skip = .false.
jCom = 0 ! dummy init
outer: do
  if (Skip) then
    Skip = .false.
  else
    read(u5,'(A)',iostat=istatus) Line
    if (istatus /= 0) call Error(istatus)
    Line = adjustl(Line)
    if ((Line(1:1) == ' ') .or. (Line(1:1) == '*')) cycle
    call StdFmt(Line,Command)
    jCom = 0
    do iCom=1,nCom
      if (Command == ComTab(iCom)) jCom = iCom
    end do
  end if
  if (jCom == 0) then
    write(u6,'(A,A)') 'RdInp: illegal command:',Command
    call Abend()
  end if
  !--------------------------------------------------------------------*
  !     Branch to the processing of the command sections               *
  !--------------------------------------------------------------------*
  select case (jCom)
    case (1)
      !---- TITL ------------------------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        Line = adjustl(Line)
        if (Line(1:1) == '*') cycle
        call StdFmt(Line,Command)
        jCom = 0
        do iCom=1,nCom
          if (Command == ComTab(iCom)) jCom = iCom
        end do
        if (jCom /= 0) then
          Skip = .true.
          exit
        end if
        mTit = mTit+1
        if (mTit > mxTit) exit
        read(Line,'(18A4)') (TitleIN(iTit),iTit=(mTit-1)*18+1,mTit*18)
      end do

    case (2)
      !---- DEBU ------------------------------------------------------*
      debug = .true.

    case (3)
      !---- ROOT ------------------------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        Line = adjustl(Line)
        if ((Line(1:1) /= ' ') .and. (Line(1:1) /= '*')) exit
      end do
      read(Line,*,iostat=istatus) lRoots
      if (istatus /= 0) call Error(istatus)
      if (debug) write(u6,*) 'LROOT'

    case (5)
      !---- CGS  ------------------------------------------------------*
      CGS = .true.

    case (6)
      !---- RFPErt ----------------------------------------------------*
      RFPERT = .true.

    case (7)
      !---- ITER ------------------------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        Line = adjustl(Line)
        if ((Line(1:1) /= ' ') .and. (Line(1:1) /= '*')) exit
      end do
      read(Line,*,iostat=istatus) nIter
      if (istatus /= 0) call Error(istatus)

    case (8)
      !---- THRE ------------------------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        Line = adjustl(Line)
        if ((Line(1:1) /= ' ') .and. (Line(1:1) /= '*')) exit
      end do
      read(Line,*,iostat=istatus) Eps
      if (istatus /= 0) call Error(istatus)
      Epsilon_Undef = .false.

    case (9)
      !---- END  ------------------------------------------------------*
      exit outer

    case (10)
      !---- TIME ------------------------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        Line = adjustl(Line)
        if ((Line(1:1) /= ' ') .and. (Line(1:1) /= '*')) exit
      end do
      read(Line,*,iostat=istatus) Omega
      if (istatus /= 0) call Error(istatus)
      TimeDep = .true.
      nIter = 100

    case (12)
      !---- NOFI ------------------------------------------------------*
      Nofile = .true.
      if (debug) write(u6,*) 'NOFILE'

    case (13)
      !---- SEWA ------------------------------------------------------*
      do
        do
          read(u5,'(A)',iostat=istatus) Line
          if (istatus /= 0) call Error(istatus)
          Line = adjustl(Line)
          call StdFmt(Line,Command)
          if ((Command(1:1) /= ' ') .and. (Line(1:1) /= '*')) exit
        end do
        if (debug) write(u6,*) 'SEWARD INPUT'
        if ((Command(1:4) == 'END ') .or. (Command(1:4) == 'ENDS')) exit
        read(Line,'(A8,I2,I2)',iostat=istatus) SewLab,isym,ip
        if (istatus /= 0) call Error(istatus)
        iRc = -1
        iOpt = ibset(0,sOpSiz)
        iComp = ip
        iSyLbl = ibset(0,isym)
        Label = SewLab
        call iRdOne(iRc,iOpt,Label,iComp,idum,iSyLbl)
        if (iRc /= 0) then
          write(u6,*) 'RdInp: Error reading ONEINT'
          write(u6,'(A,A)') 'Label=',Label
          call Abend()
        end if

        !---- read number of symm. species ----------------------------*

        ipp = sum(lDisp(isym+1:nsym))
        DspVec(nDisp-ipp+2:nDisp+1) = dspVec(nDisp-ipp+1:nDisp)
        ntpert(nDisp-ipp+2:nDisp+1) = ntpert(nDisp-ipp+1:nDisp)
        lcalc(nDisp-ipp+2:nDisp+1) = lcalc(nDisp-ipp+1:nDisp)
        id = ndisp-ipp+1
        DspVec(id) = ip
        ldisp(isym) = ldisp(isym)+1
        ndisp = ndisp+1
        ntpert(id) = 2
        lcalc(id) = .true.
        SwLbl(id) = SewLab
      end do

    case (14)
      !---- NOCO ------------------------------------------------------*
      do i=1,nDisp
        NTPert(i) = ibclr(nTPert(i),2)
      end do

    case (15)
      !---- NOTW ------------------------------------------------------*
      do i=1,nDisp
        NTPert(i) = ibclr(nTPert(i),3)
      end do

    case (16)
      !---- SPIN ------------------------------------------------------*
      SPINPOL = .true.
      ispop = 1
      if (debug) write(u6,*) 'RHF lagrangian, not supported'

    case (17)
      !---- PRIN ------------------------------------------------------*
      read(u5,*) kprint
      if (debug) write(u6,*) 'Print level: ',kprint

    case (18,19)
      !---- PCGD, RESI ------------------------------------------------*
      if (jCom == 18) then
        iBreak = 1
      else if (jCom == 19) then
        iBreak = 2
      end if
      read(u5,*) Eps
      Epsilon_Undef = .false.
      if (debug) write(u6,*) 'Threshold:',Eps

    case (20)
      !---- NOTO ------------------------------------------------------*
      newpre = .false.
      if (debug) write(u6,*) 'New conditioner'

    case (21)
      !---- EXPD ------------------------------------------------------*
      read(u5,*) nexp_max
      if (debug) write(u6,*) 'Maximum explicit preconditioner',nexp_max

    case (22)
      !---- NEGP ------------------------------------------------------*
      NGP = .true.
      if (debug) write(u6,*) 'NGP set to true'

    case (23)
      !---- LOWM ------------------------------------------------------*
      page = .true.
      if (debug) write(u6,*) 'Page memory'

    case (25)
      !---- SAVE ------------------------------------------------------*
      lSAVE = .true.
      if (debug) write(u6,*) 'old integrals, not supported'

    case (26)
      !---- RASS ------------------------------------------------------*
      RASSI = .true.
      if (debug) write(u6,*) 'Output for RASSI'

    case (27)
      !---- DISO ------------------------------------------------------*
      double = .true.    ! Make double isotope substitutions

    case (28)
      !---- CASI ------------------------------------------------------*
      CASINT = .true.
      if (debug) write(u6,*) 'CASPT2 integrals'

    case (29)
      !---- SALA ------------------------------------------------------*
      SA = .true.
      read(u5,*) istate
      override = .true.
      if (debug) write(u6,*) 'Lagrangian for state: ',istate

    case (30)
      !---- NODE ------------------------------------------------------*
      FANCY_PRECONDITIONER = .false.
      if (debug) write(u6,*) 'Turned of the fancy pcg'

    case (31)
      !---- ESTE ------------------------------------------------------*
      esterr = .true.

    case (33)
      !---- MASS ------------------------------------------------------*
      iMass = 0
      call Get_Name_All(Element)

      ! Find out how many different elements are present in the molecule.

      do i=1,nAtoms
        if (Element(i) /= '  ') iMass = iMass+1
        do j=i+1,nAtoms
          if (Element(j) == Element(i)) Element(j) = '  '
        end do
      end do
      call mma_allocate(cmass,iMass,label='cmass')
      call mma_allocate(umass,iMass,label='umass')
      do i=1,iMass
        read(u5,'(A3)') cmass(i)
        read(u5,'(F15.8)') umass(i)
      end do

      ! Put the Info on the run file.

      call Put_iScalar('iMass',iMass)
      call Put_cArray('cmass',cmass(1),3*iMass)
      call Put_dArray('umass',umass,iMass)
      call mma_deallocate(cmass)
      call mma_deallocate(umass)

    case (34)
      !---- NAC  ------------------------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        Line = adjustl(Line)
        if ((Line(1:1) /= ' ') .and. (Line(1:1) /= '*')) exit
      end do
      read(Line,*,iostat=istatus) NACstates(1),NACstates(2)
      if (istatus /= 0) call Error(istatus)
      isNAC = .true.
      override = .true.
      if (debug) write(u6,*) 'Non-adiabatic couplings for states: ',NACstates(1),NACstates(2)

    case (36)
      !---- THER ------------------------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        Line = adjustl(Line)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) nsRot
      if (istatus /= 0) call Error(istatus)
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        Line = adjustl(Line)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) UserP
      if (istatus /= 0) call Error(istatus)
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        Line = adjustl(Line)
        if (Line(1:1) == '*') cycle
        call UpCase(Line)
        if (Line(1:4) == 'END ') then
          if (nUserPT == 0) then
            nUserPT = 1
            UserT(1) = 298.15_wp
          end if
          exit
        end if
        nUserPT = nUserPT+1
        read(Line,*,iostat=istatus) UserT(nUserPT)
        if (istatus /= 0) call Error(istatus)
      end do

    case (37)
      !---- CHOF ------------------------------------------------------*
      NewCho = .true.

    case (38)
      !---- TWOS ------------------------------------------------------*
      do
        read(u5,'(A)',iostat=istatus) Line
        if (istatus /= 0) call Error(istatus)
        call UpCase(Line)
        Line = adjustl(Line)
        if (Line(1:1) /= '*') exit
      end do
      read(Line,*,iostat=istatus) StepType
      if (istatus /= 0) call Error(istatus)
      if (debug) write(u6,*) 'TWOSTEP kind: '//StepType
      if ((StepType(1:4) /= 'FIRS') .and. (StepType(1:4) /= 'SECO') .and. (StepType(1:4) /= 'RUN1') .and. &
          (StepType(1:4) /= 'RUN2')) then
        call WarningMessage(2,'TWOStep: input error!')
        call Quit_OnUserError()
      end if
      if (StepType(1:4) == 'FIRS') StepType(1:4) = 'RUN1'
      if (StepType(1:4) == 'SECO') StepType(1:4) = 'RUN2'
      TwoStep = .true.
      if (debug) write(u6,*) 'TWOSTEP kind: '//StepType

    case default
      jCom = 0
      Skip = .true.

  end select
end do outer

!----------------------------------------------------------------------*
!     "End of input"                                                   *
!----------------------------------------------------------------------*
do i=1,3
  isym = irrfnc(ibset(0,i-1))+1
  ipp = sum(lDisp(isym+1:nsym))
  DspVec(nDisp-ipp+2:nDisp+1) = dspVec(nDisp-ipp+1:nDisp)
  ntpert(nDisp-ipp+2:nDisp+1) = ntpert(nDisp-ipp+1:nDisp)
  !lcalc(nDisp-ipp+2:nDisp+1) = lcalc(nDisp-ipp+1:nDisp)
  Swlbl(nDisp-ipp+2:nDisp+1) = Swlbl(nDisp-ipp+1:nDisp)
  id = ndisp-ipp+1
  DspVec(id) = i
  ldisp(isym) = ldisp(isym)+1
  ndisp = ndisp+1
  ntpert(id) = 2
  !lcalc(id) = .true.
  write(Swlbl(id),'(a,i2)') 'MLTPL ',1
  iRc = -1
  iOpt = ibset(0,sOpSiz)
  call iRdOne(iRc,iOpt,swlbl(id),DspVec(id),idum,iSyLbl)
end do

if (Timedep) then
  do i=1,ndisp
    ntpert(i) = ibset(ntpert(i),5)
  end do
end if

if (Epsilon_Undef) then
  !if (SA) then
  !  Eps = 1.0e-6_wp
  !else
  Eps = 1.0e-4_wp
  ! This I need to change back
  !end if
end if

if (debug) write(u6,*) 'FINITO'
!----------------------------------------------------------------------*
!     Normal termination                                               *
!----------------------------------------------------------------------*

contains

!----------------------------------------------------------------------*
!     Error Exit                                                       *
!----------------------------------------------------------------------*
subroutine Error(rc)

  integer(kind=iwp), intent(in) :: rc

  if (rc > 0) then
    write(u6,*) 'RdInp: Error while reading input'
  else
    write(u6,*) 'RdInp: Premature end of input file'
  end if
  write(u6,'(A,A)') 'Last command:',Line
  call Abend()

end subroutine Error

end subroutine RdInp_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine replace_Sxxx (idum,poss,length,term,scrleng,
     *                         scrchar)
c
c*************************************************************************
c
c   This SR belongs to dkhparser_symbolic (dkhparser1).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 18.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer idum,poss,length,scrleng(maxsnumber),dummyleng,reslengl,
     *        reslengr,j
      character*(maxlength) term,rescharl,rescharr,dummychar
      character*(9) scrchar(maxsnumber)
c
      do 10 j=1,maxlength
        dummychar(j:j)=' '
  10  continue
c
      dummyleng=4
      call store_reschar (length,term,poss,dummyleng,reslengl,reslengr,
     *                    rescharl,rescharr)
c
      length=length-4+scrleng(idum)
      if (scrleng(idum).eq.6) then
        dummychar(1:6)=scrchar(idum)(1:6)
        dummyleng=6
      endif
      if (scrleng(idum).eq.9) then
        dummychar(1:9)=scrchar(idum)(1:9)
        dummyleng=9
      endif
c
      call concatenate (length,term,reslengl,rescharl,
     *                  dummyleng,dummychar,reslengr,rescharr)
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989,1993, Jeppe Olsen                                 *
!***********************************************************************

subroutine CNHCN2(ICNL,ITPL,ICNR,ITPR,CNHCNM,SCR,NEL,NAEL,NBEL,INTSPC,IPRODT,DTOC,NORB,ICOMBI,PSSIGN,NDIF0,NDIF1,NDIF2)
! Obtain Hamilton matrix over CSFs of configurations ICNL,ICNR
!
! Jeppe Olsen, Summer of 89
!
! Modified for LUCIA, September 1993

use MCLR_Data, only: IASTFI, IBSTFI, MINOP, NCPCNT, NDPCNT
use Str_Info, only: Str
use Constants, only: Zero
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICNL(*), ITPL, ICNR(*), ITPR, NEL, NAEL, NBEL, INTSPC, IPRODT(*), NORB, ICOMBI
real(kind=wp), intent(_OUT_) :: CNHCNM(*), SCR(*)
real(kind=wp), intent(in) :: DTOC(*), PSSIGN
integer(kind=iwp), intent(out) :: NDIF0, NDIF1, NDIF2
integer(kind=iwp) :: IAGRP, IBGRP, ICLL, ICLR, IOPL, IOPR, IPL, IPR, ISYM, KLCHD, KLDHD, KLFREE, KLISL, KLISR, LCNFST, NCSFL, &
                     NCSFR, NDETL, NDETR, NDIFF
real(kind=wp) :: ECOREP
integer(kind=iwp), allocatable :: iSCR(:), iSCRl(:,:), iSCRn(:,:), iSCRr(:,:), jWork(:,:)

! Length of SCR : 2 * NDET + NDET**2 + NDET*NCSF +
!                 (NDET*NEL) + 2*NEL
! where the last line arises from the local memory in CNFSTR respectively

IAGRP = IASTFI(INTSPC)
IBGRP = IBSTFI(INTSPC)

! 1: Obtain determinants corresponding to configurations

IOPL = ITPL-1+MINOP
IOPR = ITPR-1+MINOP

ICLL = (NEL-IOPL)/2
ICLR = (NEL-IOPR)/2

NDETL = NDPCNT(ITPL)
NDETR = NDPCNT(ITPR)

NCSFL = NCPCNT(ITPL)
NCSFR = NCPCNT(ITPR)

KLFREE = 1
! 2* Ndet for holding string numbers and signs
KLISL = KLFREE
KLFREE = KLFREE+NDETL

KLISR = KLFREE
KLFREE = KLFREE+NDETR
! for transforming to CSFs
KLDHD = KLFREE
KLFREE = KLFREE+NDETL*NDETR

KLCHD = KLFREE
KLFREE = KLFREE+NCSFL*NDETR

! Prescreen for CNFs that do not interact

LCNFST = max(NDETL,NDETR)*NEL+2*NEL
call mma_allocate(iSCR,LCNFST,Label='iSCR')
call mma_allocate(jWork,NORB,4,Label='jWork')

call CMP2CN(ICNL,ICLL,IOPL,ICNR,ICLR,IOPR,jWork,NORB,NDIFF)

if (NDIFF <= 2) then
  call mma_allocate(iSCRl,NDETL,2,Label='iSCRl')
  call mma_allocate(iSCRr,NDETR,2,Label='iSCRr')
  call mma_allocate(iSCRn,max(NAEL,NBEL),2,Label='iSCRn')
  ! Strings for determinants of these configurations
  call CNFSTR_MCLR(ICNL,ITPL,iSCRl(:,1),iSCRl(:,2),NORB,NAEL,NBEL,NDETL,IPRODT,IAGRP,IBGRP,iSCR,SCR(KLISL))
  call CNFSTR_MCLR(ICNR,ITPR,iSCRr(:,1),iSCRr(:,2),NORB,NAEL,NBEL,NDETR,IPRODT,IAGRP,IBGRP,iSCR,SCR(KLISR))

  ! Hamiltonian matrix over determinants of the configurations

  isym = 0      ! eaw
  ecorep = Zero ! eaw
  call DIHDJ2_MCLR(iSCRl(:,1),iSCRl(:,2),NDETL,iSCRr(:,1),iSCRr(:,2),NDETR,NAEL,NBEL,jWork,NORB,SCR(KLDHD),ISYM,ECOREP,ICOMBI, &
                   PSSIGN,Str(IAGRP)%OCSTR,Str(IBGRP)%OCSTR,Str(IAGRP)%OCSTR,Str(IBGRP)%OCSTR,iSCRn(:,1),iSCRn(:,2),NDIF0,NDIF1, &
                   NDIF2)

  ! Transform matrix to CSF basis

  ! sign changes
  call DGMM2(SCR(KLDHD),SCR(KLISL),1,NDETL,NDETR)
  call DGMM2(SCR(KLDHD),SCR(KLISR),2,NDETL,NDETR)
  IPL = 1+sum(NCPCNT(1:ITPL-1)*NDPCNT(1:ITPL-1))
  if (ITPR == ITPL) then
    IPR = IPL
  else
    IPR = 1+sum(NCPCNT(1:ITPR-1)*NDPCNT(1:ITPR-1))
  end if

  call MATML4(SCR(KLCHD),DTOC(IPL),SCR(KLDHD),NCSFL,NDETR,NDETL,NCSFL,NDETL,NDETR,1)
  call MATML4(CNHCNM,SCR(KLCHD),DTOC(IPR),NCSFL,NCSFR,NCSFL,NDETR,NDETR,NCSFR,0)

  call mma_deallocate(iSCRl)
  call mma_deallocate(iSCRr)
  call mma_deallocate(iSCRn)

else if (NDIFF > 2) then
  CNHCNM(1:NCSFL*NCSFR) = Zero
end if

call mma_deallocate(iSCR)
call mma_deallocate(jWork)

end subroutine CNHCN2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Nike Dattani                                     *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine level_rdinp(IAN1,IMN1,IAN2,IMN2,CHARGE,NUMPOT,RH,RMIN,PRV,ARV,EPS,NTP,LPPOT,IOMEG1,VLIM1,IPOTL,PPAR,QPAR,NSR,NLR,IBOB, &
                       DSCM,REQ,RREF,NCMM,IVSR,IDSTT,RHOAB,MMLR,CMM,PARM,NLEV1,AUTO1,LCDC,LXPCT,NJM,JDJR,IWR,LPRWF)

!***********************************************************************
!  Objective: Read input and construct default input parameters        *
!  written by Nike Dattani in November 2022                            *
!***********************************************************************

use spool, only: Spoolinp
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: IAN1, IMN1, IAN2, IMN2, CHARGE, NUMPOT, NTP, LPPOT, IOMEG1, IPOTL, PPAR, QPAR, NSR, NLR, IBOB, &
                                  NCMM, IVSR, IDSTT, MMLR(3), NLEV1, AUTO1, LCDC, LXPCT, NJM, JDJR, IWR, LPRWF
real(kind=wp), intent(out) :: RH, RMIN, PRV, ARV, EPS, VLIM1, DSCM, REQ, RREF, RHOAB, CMM(3), PARM(4)
integer(kind=iwp) :: LuIn
logical(kind=iwp) :: skip
character(len=180) :: Line
character(len=4) :: word
character(len=*), parameter :: tabinp(40) = ['IAN1','IMN1','IAN2','IMN2','CHAR','NUMP','RH  ','RMIN','PRV ','ARV ', &
                                             'EPS ','NTP ','LPPO','IOME','VLIM','IPOT','PPAR','QPAR','NSR ','NLR ', &
                                             'IBOB','DSCM','REQ ','RREF','NCMM','IVSR','IDST','RHOA','MMLR','CMM ', &
                                             'PARM','NLEV','AUTO','LCDC','LXPC','NJM ','JDJR','IWR ','LPRW','END ']
integer(kind=iwp), external :: IsFreeUnit
character(len=180), external :: Get_Ln

LuIn = IsFreeUnit(11)
call SpoolInp(LuIn)

! Set default values to input variables

IAN1 = 3                        ! Integer atomic number for atom 1
IMN1 = 6                        ! Integer mass number for atom 1
IAN2 = 3                        ! Integer atomic number for atom 2
IMN2 = 6                        ! Integer mass number for atom 2
CHARGE = 0                      ! Charge of the molecule
NUMPOT = 1

RH = 9.0e-4_wp                  ! Step size (Delta R) for numerical solution of the ODE
RMIN = 0.225_wp                 ! Minimum R for numerical solution of the ODE
PRV = 1                         ! Surkus parameter for the RV (radial variable) for numerical solution of the ODE
ARV = 5.0_wp                    ! Reference distance for the RV (radial variable) for numerical solution of the ODE
EPS = 2.0e-10_wp                ! Epsilon (convergence criterion for numerical solution of the ODE)

NTP = -1                        ! Number of turning points provided (set it to -1 for analytic potentials)
LPPOT = 0                       !
IOMEG1 = 0                      ! Integer Omega quantum number (angular momentum)
VLIM1 = 0                       ! Value of the potential (V) in the R -> infinity limit

IPOTL = 4                       ! Integer potential model switch. Set it to 4 for an MLR model
PPAR = 3                        ! p parameter in the MLR model
QPAR = 3                        ! q parameter in the MLR model
NSR = 3                         ! N_beta (polynomial order, 0 = constant, 1 = linear, etc.) for the short-range side of the potential
NLR = 3                         ! N_beta (polynomial order, 0 = constant, 1 = linear, etc.) for the long-range side of the potential
IBOB = -1

DSCM = 3.337678701485e2_wp      ! D_e (depth of the potential at equilibrium)
REQ = 4.170010583477_wp         ! R_e (equilibrium R value)
RREF = 8.0_wp                   ! R_ref parameter for the Surkus function

NCMM = 3                        ! Number of long-range constants included in u(r) for an MLR model.
IVSR = -2                       !
IDSTT = 1                       !
RHOAB = 0.54_wp                 ! Constant used for damping functions in the MLR model.

MMLR(1) = 6                     ! Inverse-power for the first long-range u(r) term for an MLR model
CMM(1) = 6.719e6_wp             ! Numerator for the first long-range u(r) term for an MLR model
MMLR(2) = 8                     ! Inverse-power for the second long-range u(r) term for an MLR model
CMM(2) = 1.12635e8_wp           ! Numerator for the second long-range u(r) term for an MLR model
MMLR(3) = 10                    ! Inverse-power for the third long-range u(r) term for an MLR model
CMM(3) = 2.78694e9_wp           ! Numerator for the third long-range u(r) term for an MLR model

PARM(1) = -5.156803528943e-1_wp ! Beta_0 for an MLR potential
PARM(2) = -9.585070416286e-2_wp ! Beta_1 for an MLR potential
PARM(3) = 1.170797201140e-1_wp  ! Beta_2 for an MLR potential
PARM(4) = -2.282814434665e-2_wp ! Beta_3 for an MLR potential

NLEV1 = -999
AUTO1 = 1
LCDC = 2
LXPCT = 0
NJM = 0
JDJR = 1
IWR = 3
LPRWF = 0

! Position input file

rewind(LuIn)
call RdNLst(LuIn,'LEVEL')

!ntit1 = 0
skip = .false.

! Read input data from input file

input: do
  if (skip) then
    skip = .false.
  else
    read(LuIn,'(a)') line
    call Upcase(line)
    if (line(1:1) == '*') cycle input
    word = line(1:4)
    if (Word == '') Word = 'END'
  end if

  select case (word)

    ! Read IAN1,IMN1,IAN2,IMN2,CHAR,NUMP
    case (tabinp(1))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IAN1)

    case (tabinp(2))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IMN1)

    case (tabinp(3))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IAN2)

    case (tabinp(4))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IMN2)

    case (tabinp(5))
      Line = Get_Ln(LuIn)
      call Get_I1(1,CHARGE)

    case (tabinp(6))
      Line = Get_Ln(LuIn)
      call Get_I1(1,NUMPOT)

    ! Read RH, RMIN, pRV, aRV, EPS
    case (tabinp(7))
      Line = Get_Ln(LuIn)
      call Get_F1(1,RH)

    case (tabinp(8))
      Line = Get_Ln(LuIn)
      call Get_F1(1,RMIN)

    case (tabinp(9))
      Line = Get_Ln(LuIn)
      call Get_F1(1,PRV)

    case (tabinp(10))
      Line = Get_Ln(LuIn)
      call Get_F1(1,ARV)

    case (tabinp(11))
      Line = Get_Ln(LuIn)
      call Get_F1(1,EPS)
      !write(u6,*) 'EPS=',EPS

    ! Read NTP, LPPOT, IOMEG, VLIM
    case (tabinp(12))
      Line = Get_Ln(LuIn)
      call Get_I1(1,NTP)
      !write(u6,*) 'NTP=',NTP

    case (tabinp(13))
      Line = Get_Ln(LuIn)
      call Get_I1(1,LPPOT)
      !write(u6,*) 'LPPOT=',LPPOT

    case (tabinp(14))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IOMEG1)
      !write(u6,*) 'IOMEG1=',IOMEG1

    case (tabinp(15))
      Line = Get_Ln(LuIn)
      call Get_F1(1,VLIM1)
      !write(u6,*) 'VLIM1=',VLIM1

    ! Read  IPOTL, PPAR, QPAR, NSR, NLR, IBOB
    case (tabinp(16))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IPOTL)
      !write(u6,*) 'IPOTL=',IPOTL

    case (tabinp(17))
      Line = Get_Ln(LuIn)
      call Get_I1(1,PPAR)
      !write(u6,*) 'PPAR=',PPAR

    case (tabinp(18))
      Line = Get_Ln(LuIn)
      call Get_I1(1,QPAR)
      !write(u6,*) 'QPAR=',QPAR

    case (tabinp(19))
      Line = Get_Ln(LuIn)
      call Get_I1(1,NSR)
      !write(u6,*) 'NSR=',NSR

    case (tabinp(20))
      Line = Get_Ln(LuIn)
      call Get_I1(1,NLR)
      !write(u6,*) 'NLR=',NLR

    case (tabinp(21))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IBOB)
      !write(u6,*) 'IBOB=',IBOB

    ! Read DSCM, REQ, Rref
    case (tabinp(22))
      Line = Get_Ln(LuIn)
      call Get_F1(1,DSCM)
      !write(u6,*) 'DSCM=',DSCM

    case (tabinp(23))
      Line = Get_Ln(LuIn)
      call Get_F1(1,REQ)
      !write(u6,*) 'REQ=',REQ

    case (tabinp(24))
      Line = Get_Ln(LuIn)
      call Get_F1(1,RREF)
      !write(u6,*) 'RREF=',RREF

    ! Read NCMM, IVSR, IDSTT, rhoAB
    case (tabinp(25))
      Line = Get_Ln(LuIn)
      call Get_I1(1,NCMM)
      !write(u6,*) 'NCMM=',NCMM

    case (tabinp(26))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IVSR)
      !write(u6,*) 'IVSR=',IVSR

    case (tabinp(27))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IDSTT)
      !write(u6,*) 'IDSTT=',IDSTT

    case (tabinp(28))
      Line = Get_Ln(LuIn)
      call Get_F1(1,RHOAB)
      !write(u6,*) 'RHOAB=',RHOAB
      !write(u6,*) ''

    ! Read MMLR(1), CMM(1), MMLR(2), CMM(2), MMLR(3), CMM(3)
    case (tabinp(29))
      Line = Get_Ln(LuIn)
      call Get_I(1,MMLR,3)
      !write(u6,*) 'MMLR=',MMLR

    case (tabinp(30))
      Line = Get_Ln(LuIn)
      call Get_F(1,CMM,3)
      !write(u6,*) 'CMM=',CMM

    ! Read PARM(1), PARM(2), PARM(3),PARM(4)
    case (tabinp(31))
      Line = Get_Ln(LuIn)
      call Get_F(1,PARM,4)
      !write(u6,*) 'PARM=',PARM

    ! Read NLEV1, AUTO1, LCDC, LXPCT, NJM, JDJR, IWR, LPRWF
    case (tabinp(32))
      Line = Get_Ln(LuIn)
      call Get_I1(1,NLEV1)
      !write(u6,*) 'NLEV1=',NLEV1

    case (tabinp(33))
      Line = Get_Ln(LuIn)
      call Get_I1(1,AUTO1)
      !write(u6,*) 'AUTO1=',AUTO1

    case (tabinp(34))
      Line = Get_Ln(LuIn)
      call Get_I1(1,LCDC)
      !write(u6,*) 'LCDC=',LCDC

    case (tabinp(35))
      Line = Get_Ln(LuIn)
      call Get_I1(1,LXPCT)
      !write(u6,*) 'LXPCT=',LXPCT

    case (tabinp(36))
      Line = Get_Ln(LuIn)
      call Get_I1(1,NJM)
      !write(u6,*) 'NJM=',NJM

    case (tabinp(37))
      Line = Get_Ln(LuIn)
      call Get_I1(1,JDJR)
      !write(u6,*) 'JDJR=',JDJR

    case (tabinp(38))
      Line = Get_Ln(LuIn)
      call Get_I1(1,IWR)
      !write(u6,*) 'IWR=',IWR

    case (tabinp(39))
      Line = Get_Ln(LuIn)
      call Get_I1(1,LPRWF)
      !write(u6,*) 'LPRWF=',LPRWF

    case (tabinp(40))
      exit input

    case default
      write(u6,*)
      write(u6,*) '******************************************'
      write(u6,*) ' LEVEL Error: Input line not recognized.'
      write(u6,*) ' Input line, in upper case:'
      write(u6,'(a)') line
      write(u6,*) ' Extracted keyword: ',word
      write(u6,*) '******************************************'
      call Quit_OnUserError()
  end select
end do input

close(LuIn)

return

end subroutine level_rdinp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine o10b_cvb(nparm,dxnrm,grdnrm,close2conv)
      implicit real*8 (a-h,o-z)
      logical close2conv
#include "WrkSpc.fh"
#include "opt_cvb.fh"
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

#include "opt2_cvb.fh"
      external asonc10_cvb,ddres2upd10_cvb

      if(.not.close2conv)then
        resthr_use=1d-5
      else
        resthr_use=5d-2*grdnrm
        resthr_use=min(1d-5,resthr_use)
        resthr_use=max(1d-9,resthr_use)
      endif
      call axexb_cvb(asonc10_cvb,ddres2upd10_cvb,work(ix(1)),
     >  resthr_use,ioptc2,iter2,fx_exp)
      have_solved_it=.true.

      if(ip.ge.2)write(6,'(2a,i4)')' Number of iterations for ',
     >  'direct diagonalization :',iter2

      if(ioptc2.ne.0)then
        write(6,*)' Direct diagonalization not converged!'
        call abend_cvb()
      endif

      dxnrm=dnrm2_(nparm,work(ix(1)),1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Manuela Merchan                                  *
!***********************************************************************

subroutine AutoCut()
!***********************************************************************
!                                                                      *
! Purpose:                                                             *
! This routine counts the number of orbitals that have an              *
! occupation number smaller than a given threshold and                 *
! marks them as deleted orbitals.                                      *
!                                                                      *
!**** M. Merchan, University of Valencia, Spain, 1991 ******************

use motra_global, only: CutThrs, nBas, nDel, nFro, nOrb, nOrbt, nOrbtt, nSym, Occ
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iBas, iDel, ipBas, iSym

! FIXME: Occ was never read or allocated
call Untested('AutoCut')

!----------------------------------------------------------------------*
! Start procedure                                                      *
!----------------------------------------------------------------------*
ipBas = 0
do iSym=1,nSym
  iDel = 0
  do iBas=1,nBas(iSym)
    if (Occ(ipBas+iBas) <= abs(CutThrs(iSym))) iDel = iDel+1
  end do
  ipBas = ipBas+nBas(iSym)
  if (nDel(iSym) < iDel) nDel(iSym) = iDel
  if ((nDel(iSym)+nFro(iSym)) > nBas(iSym)) then
    write(u6,*) 'AutoCut:nDel(iSym)+nFro(iSym)) > nBas(iSym)'
    write(u6,*) 'iSym=',iSym
    write(u6,*) 'nDel(iSym)=',nDel(iSym)
    write(u6,*) 'nFro(iSym)=',nFro(iSym)
    write(u6,*) 'nBas(iSym)=',nBas(iSym)
    call Abend()
  end if
end do
!----------------------------------------------------------------------*
! Normal termination                                                   *
!----------------------------------------------------------------------*
nOrbt = 0
nOrbtt = 0
do iSym=1,nSym
  nOrb(iSym) = nBas(iSym)-nFro(iSym)-nDel(iSym)
  nOrbt = nOrbt+nOrb(iSym)
  nOrbtt = nOrbtt+nOrb(iSym)*(nOrb(iSym)+1)/2
end do

return

end subroutine AutoCut

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine ang1(ang,dfac,nanb,lalb,mamb,lamu,lmf,lml,lmx,lmy,lmz,
     &  ltot1,xab,yab,zab,xk,yk,zk,zlm)
c
c  compute type 1 angular integrals
c
      implicit real*8 (a-h,o-z)
      parameter (a0=0.0d0, a1=1.0d0)
      dimension ang(ltot1,*), dfac(*), lmf(*), lml(*), lmx(*), lmy(*),
     &  lmz(*), xab(*), yab(*), zab(*), zlm(*)
c
      call wzero(ltot1*lamu,ang,1)
      do 96 n=1,nanb
      if(xab(n).eq.a0) go to 96
      do 94 l=1,lalb
      if(yab(l).eq.a0) go to 94
      do 92 m=1,mamb
      if(zab(m).eq.a0) go to 92
      nlm=((n-2)+l)+m
      lamlo=mod(nlm-1,2)+1
      lamhi=min(nlm,lamu)
      if(lamlo.gt.lamhi) go to 92
      do 90 lam=lamlo,lamhi,2
      l2=lam+lam-1
      angt=a0
      loc=(lam-1)**2
      do 80 mu1=1,l2
      istart=lmf(loc+mu1)
      if(mod(n,2).eq.mod(lmx(istart),2).or.
     1   mod(l,2).eq.mod(lmy(istart),2).or.
     2   mod(m,2).eq.mod(lmz(istart),2)) go to 80
      pre=a0
      aint=a0
      iend=lml(loc+mu1)
      do 70 i=istart,iend
        indx=lmx(i)
        indy=lmy(i)
        indz=lmz(i)
        if(indx.eq.0) then
          xkp=a1
        else
          xkp=xk**indx
        endif
        if(indy.eq.0) then
          ykp=a1
        else
          ykp=yk**indy
        endif
        if(indz.eq.0) then
          zkp=a1
        else
          zkp=zk**indz
        endif
        pre=pre+zlm(i)*xkp*ykp*zkp
        aint=aint+zlm(i) * dfac(n+indx) * dfac(l+indy) * dfac(m+indz)/
     1    dfac((n+indx)+(l+indy)+(m+indz))
   70 continue
      angt=angt+pre*aint
   80 continue
      ang(nlm,lam)=ang(nlm,lam)+((xab(n)*yab(l))*zab(m))*angt
   90 continue
   92 continue
   94 continue
   96 continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function IsStructure()
!  This function return 0 if module is running outside structure
!                       1 if module is running inside structure
!                      -1 if module is running outside structure but there has been a structure loop earlier

use UnixInfo, only: SuperName
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IsStructure
character(len=8) :: level, Val

Val = ' '
call GetEnvF('MOLCAS_STRUCTURE',Val)
IsStructure = 0
if (Val == '1') then
  IsStructure = -1
  call getenvf('EMIL_InLoop',level)
  if (level == '') level = '0'
  if (level(1:1) /= '0') IsStructure = 1
end if
if (SuperName == 'last_energy') IsStructure = 1

return

end function IsStructure

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Giovanni Ghigo                                   *
!***********************************************************************

subroutine MkVibWind2(nYes,iMaxYes,max_nOrd,lVec,VibWind2)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nYes, max_nOrd, lVec(0:max_nOrd)
integer(kind=iwp), intent(out) :: iMaxYes, VibWind2(nYes)
integer(kind=iwp) :: iOrd, iYes

iMaxYes = 0
iYes = 1
do iOrd=0,max_nOrd
  if (lVec(iOrd) == 1) then
    VibWind2(iYes) = iOrd
    iYes = iYes+1
    iMaxYes = max(iMaxYes,iOrd)
  end if
end do

return

end subroutine MkVibWind2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Bjorn O. Roos                                    *
*               1989, Per Ake Malmqvist                                *
*               1991,1993,1996, Markus P. Fuelscher                    *
************************************************************************
      Subroutine Fmat(CMO,PUVX,D,D1A,FI,FA)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Update the Fock matrix for the active orbitals and transform     *
*     it to MO basis as well as the matrix FI (Fock matrix) for        *
*     frozen and inactive orbitals).                                   *
*                                                                      *
*     calling arguments:                                               *
*     CMO     : array of real*8                                        *
*               MO-coefficients                                        *
*     PUVX    : array of real*8                                        *
*               two-electron integrals (pu!vx)                         *
*     D       : array of real*8                                        *
*               averaged one-body density matrix                       *
*     D1A     : array of real*8                                        *
*               active one body density matrix in AO-basis             *
*     FI      : array of real*8                                        *
*               inactive Fock matrix. In input is in AO basis.         *
*               In output in MO basis.                                 *
*     FA      : array of real*8                                        *
*               active Fock matrix. In input in AO Basis.              *
*               In output in MO basis. It is also modified by scaling  *
*               exchange part in ExFac .ne. 1.0d0                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     B.O. Roos and P.Aa. Malmqvist                                    *
*     University of Lund, Sweden, 1989                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     - updated for MOLCAS version 2                                   *
*       M.P. Fuelscher, University of Lund, Sweden, 1991               *
*     - updated for MOLCAS version 3                                   *
*       M.P. Fuelscher, University of Lund, Sweden, 1993               *
*     - updated for integral direct and reaction field calculations    *
*       M.P. Fuelscher, University of Lund, Sweden, 1996               *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='FMAT    ')
#include "WrkSpc.fh"

      Dimension CMO(*) , PUVX(*) , D(*) , D1A(*) , FI(*) , FA(*)
      logical l_casdft
C Local print level (if any)
      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE

        write(6,*) ('*',i=1,65)
        write(6,*) 'Entering FMAT routine called by SXCTL!'
        write(6,*) ('*',i=1,65)
        write(6,*) 'printing input matrices :'
        write(6,*) ('*',i=1,65)
        Write(LF,*)
        Write(LF,*) ' CMOs in FMAT'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
         iOff=1
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          if(iBas.ne.0) then
            write(6,*) 'Sym =', iSym
            do i= 1,iBas
              write(6,*)(CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
            end do
            iOff = iOff + (iBas*iBas)
          end if
         End Do

         Write(LF,*)
         Write(LF,*) ' PUVX in FMAT'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         call wrtmat(PUVX,1,nFint, 1, nFint)

         Write(LF,*)
         Write(LF,*) ' ---------------------'
        CALL TRIPRT('Averaged one-body density matrix D, in MO in FMAT',
     &              ' ',D,NAC)

         Write(LF,*)
         Write(LF,*) ' D1A in AO basis in FMAT'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         iOff = 1
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          call wrtmat(D1A(iOff),iBas,iBas, iBas, iBas)
          iOff = iOff + iBas*iBas
         End DO

         Write(LF,*)
         Write(LF,*) ' FI in AO-basis in FMAT'
         Write(LF,*) ' --------------'
         Write(LF,*)
         iOff = 1
         Do iSym = 1,nSym
           iOrb = nOrb(iSym)
           Call TriPrt(' ',' ',FI(iOff),iOrb)
           iOff = iOff + (iOrb*iOrb+iOrb)/2
         End Do

         Write(LF,*)
         Write(LF,*) ' FA in AO-basis in FMAT'
         Write(LF,*) ' --------------'
         Write(LF,*)
         iOff = 1
         Do iSym = 1,nSym
           iOrb = nOrb(iSym)
           Call TriPrt(' ',' ',FA(iOff),iOrb)
           iOff = iOff + (iOrb*iOrb+iOrb)/2
         End Do
       End If

*************************************************************
* Initialize global variable for mcpdft functionals
*************************************************************
       l_casdft = KSDFT(1:5).eq.'TLSDA'   .or.
     &            KSDFT(1:6).eq.'TLSDA5'  .or.
     &            KSDFT(1:5).eq.'TBLYP'   .or.
     &            KSDFT(1:6).eq.'TSSBSW'  .or.
     &            KSDFT(1:5).eq.'TSSBD'   .or.
     &            KSDFT(1:5).eq.'TS12G'   .or.
     &            KSDFT(1:4).eq.'TPBE'    .or.
     &            KSDFT(1:5).eq.'FTPBE'   .or.
     &            KSDFT(1:5).eq.'TOPBE'   .or.
     &            KSDFT(1:6).eq.'FTOPBE'  .or.
     &            KSDFT(1:7).eq.'TREVPBE' .or.
     &            KSDFT(1:8).eq.'FTREVPBE'.or.
     &            KSDFT(1:6).eq.'FTLSDA'  .or.
     &            KSDFT(1:6).eq.'FTBLYP'
*     create FA in AO basis
      Call GetMem('Scr1','Allo','Real',iTmp1,nTot1)
      Call Fold(nSym,nBas,D1A,Work(iTmp1))
      If(KSDFT.ne.'SCF') NewFock=0
c      If (NewFock.eq.0) Then
c         nBMX=0
c         Do iSym=1,nSym
c            nBMX=Max(nBMX,nBas(iSym))
c         End Do
c         Call FZero(FA,nTot1)
c         Call FTwo_Drv(nSym,nBas,nAsh,nSkipX,
c     &                    Work(iTmp1),D1A,FA,nTot1,
c     &                    ExFac,nTot2,nBMX,CMO)
c      End If

*     Inactive-active contribution to ECAS
      VIA=dDot_(nTot1,FI,1,Work(iTmp1),1)
      ECAS=EMY+VIA
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,*) ' Total core energy fmat:       ',EMY
        Write(LF,*) ' inactive-active interaction:  ',VIA
        Write(LF,*) ' CAS energy (core+interaction):',ECAS
      End If
      Call GetMem('Scr1','Free','Real',iTmp1,nTot1)

*     print FI and FA
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' FI in AO-basis in fmat'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FI(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
        Write(LF,*)
        Write(LF,*) ' FA in AO-basis in fmat'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FA(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
      End If

*     transform FI from AO to MO basis
      iOff1 = 1
      iOff2 = 1
      iOff3 = 1
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        iOrb = nOrb(iSym)
        iFro = nFro(iSym)
        Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
        Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
        Call Square(FI(iOff1),Work(iTmp1),1,iBas,iBas)
C        Call MXMA(Work(iTmp1),1,iBas,
C     &            CMO(iOff2+(iFro*iBas)),1,iBas,
C     &            Work(iTmp2),1,iBas,
C     &            iBas,iBas,iOrb)
        Call DGEMM_('N','N',iBas,iOrb,iBas,
     &               1.0d0,Work(iTmp1),iBas,
     &               CMO(iOff2+(iFro*iBas)),iBas,
     &               0.0d0,Work(iTmp2),iBas)
        Call MXMT(Work(iTmp2),iBas,1,
     &            CMO(iOff2+(iFro*iBas)),1,iBas,
     &            FI(iOff3),
     &            iOrb,iBas)
        Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
        Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
        iOff1 = iOff1 + (iBas*iBas+iBas)/2
        iOff2 = iOff2 + iBas*iBas
        iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
      End Do

*     transform FA from AO to MO basis
      iOff1 = 1
      iOff2 = 1
      iOff3 = 1
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        iOrb = nOrb(iSym)
        iFro = nFro(iSym)
        Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
        Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
        Call Square(FA(iOff1),Work(iTmp1),1,iBas,iBas)
C        Call MXMA(Work(iTmp1),1,iBas,
C     &            CMO(iOff2+(iFro*iBas)),1,iBas,
C     &            Work(iTmp2),1,iBas,
C     &            iBas,iBas,iOrb)
        Call DGEMM_('N','N',iBas,iOrb,iBas,
     &               1.0d0,Work(iTmp1),iBas,
     &               CMO(iOff2+(iFro*iBas)),iBas,
     &               0.0d0,Work(iTmp2),iBas)
        Call MXMT(Work(iTmp2),iBas,1,
     &            CMO(iOff2+(iFro*iBas)),1,iBas,
     &            FA(iOff3),
     &            iOrb,iBas)
        Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
        Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
        iOff1 = iOff1 + (iBas*iBas+iBas)/2
        iOff2 = iOff2 + iBas*iBas
        iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
      End Do

c**************************************************************************
c              Add DFT part to Fock matrix:                               *
c**************************************************************************
      If(KSDFT(1:3).ne.'SCF'.and.KSDFT(1:3).ne.'PAM'.and.
     &      .not. l_casdft ) Then
        ipTmpFckI=-99999
        ipTmpFckA=-99999
        Call Get_dExcdRa(ipTmpFck,nTmpFck)
        If(nTmpFck.eq.NTOT1) Then
           ipTmpFckI=ipTmpFck
        Else If(nTmpFck.eq.2*NTOT1) Then
           ipTmpFckI=ipTmpFck
           ipTmpFckA=ipTmpFck+nTot1
        Else
           Write(LF,*) ' Somethings wrong in dim. DFT',nTmpFck
           Call Abend()
        End If
        Call GetMem('ScrD1a','Allo','Real',iTmpD1A,nTot1)
        Call Fold(nSym,nBas,D1A,Work(iTmpD1A))
        VIA_DFT=dDot_(nTot1,Work(ipTmpFckI),1,Work(iTmpD1A),1)
        Call GetMem('ScrD1a','Free','Real',iTmpD1A,nTot1)
*
*          Transform alpha density from AO to MO
*
        iOff1 = 1
        iOff2 = 1
        iOff3 = 1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          iOrb = nOrb(iSym)
          iFro = nFro(iSym)
          Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
          Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
          Call Square(Work(ipTmpFckI+iOff1-1),
     &                Work(iTmp1),1,iBas,iBas)
C          Call MXMA(Work(iTmp1),1,iBas,
C     &              CMO(iOff2+(iFro*iBas)),1,iBas,
C     &              Work(iTmp2),1,iBas,
C     &              iBas,iBas,iOrb)
          Call DGEMM_('N','N',iBas,iOrb,iBas,
     &               1.0d0,Work(iTmp1),iBas,
     &               CMO(iOff2+(iFro*iBas)),iBas,
     &               0.0d0,Work(iTmp2),iBas)
          Call MXMT(Work(iTmp2),iBas,1,
     &              CMO(iOff2+(iFro*iBas)),1,iBas,
     &              Work(ipTmpFckI+iOff3-1),
     &              iOrb,iBas)
          Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
          Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
          iOff1 = iOff1 + (iBas*iBas+iBas)/2
          iOff2 = iOff2 + iBas*iBas
          iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
        End Do
*
*          Transform Active DFT Fock from AO to MO
*
        If(ipTmpFckA.ne.-99999) Then
        iOff1 = 1
        iOff2 = 1
        iOff3 = 1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          iOrb = nOrb(iSym)
          iFro = nFro(iSym)
          Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
          Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
          Call Square(Work(ipTmpFckA+iOff1-1),
     &                Work(iTmp1),1,iBas,iBas)
C          Call MXMA(Work(iTmp1),1,iBas,
C     &              CMO(iOff2+(iFro*iBas)),1,iBas,
C     &              Work(iTmp2),1,iBas,
C     &              iBas,iBas,iOrb)
          Call DGEMM_('N','N',iBas,iOrb,iBas,
     &               1.0d0,Work(iTmp1),iBas,
     &               CMO(iOff2+(iFro*iBas)),iBas,
     &               0.0d0,Work(iTmp2),iBas)
          Call MXMT(Work(iTmp2),iBas,1,
     &              CMO(iOff2+(iFro*iBas)),1,iBas,
     &              Work(ipTmpFckA+iOff3-1),
     &              iOrb,iBas)
          Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
          Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
          iOff1 = iOff1 + (iBas*iBas+iBas)/2
          iOff2 = iOff2 + iBas*iBas
          iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
        End Do
        End If
*
c        If(DFTFOCK(1:4).ne.'ROKS') Then
c          Write(LF,*) ' Just add a,b to FA,FI',DFTFOCK(1:4)
c        Else
c          Write(LF,*) ' ROKS formula',DFTFOCK(1:4)
c        End If
*
        If(DFTFOCK(1:4).ne.'ROKS') Then
          call daxpy_(NTOT1,1.0D0,Work(ipTmpFckI),1,FI,1)
          If(ipTmpFckA.ne.-99999)
     &    call daxpy_(NTOT1,1.0D0,Work(ipTmpFckA),1,FA,1)
        Else If (DFTFOCK(1:4).eq.'ROKS') Then
           iOff1 = 0
           Do iSym = 1,nSym
              Do iOrb=1,nOrb(iSym)
                 Do jOrb=1,iOrb
                    ij=iOff1+iOrb*(iOrb-1)/2+jOrb
                    If(iOrb.le.nIsh(iSym)) Then
                      FI(ij)=FI(ij)+0.5d0*
     &                  (Work(ipTmpFckI+ij-1)+Work(ipTmpFckA+ij-1))
                    End If
                    If (iOrb.gt.nIsh(iSym).and.
     &                  iOrb.le.nIsh(iSym)+nAsh(iSym)) Then
                       If (jOrb.le.nIsh(iSym)) Then
                          FI(ij)=FI(ij)+Work(ipTmpFckA+ij-1)
                       Else
                          FI(ij)=FI(ij)+0.5d0*(Work(ipTmpFckI+ij-1)+
     &                                         Work(ipTmpFckA+ij-1))
                       End If
                    End If
                    If (iOrb.gt.nIsh(iSym)+nAsh(iSym)) Then
                       If(jOrb.gt.nIsh(iSym).and.
     &                    jOrb.le.nIsh(iSym)+nAsh(iSym)) Then
                          FI(ij)=FI(ij)+Work(ipTmpFckI+ij-1)
                       Else
                          FI(ij)=FI(ij)+0.5d0*(Work(ipTmpFckI+ij-1)+
     &                                         Work(ipTmpFckA+ij-1))
                       End If

                    End If
                 End Do
              End Do
              iOff1 = iOff1 + (nOrb(iSym)*nOrb(iSym)+nOrb(iSym))/2
           End Do
        Else
           Write(LF,*) " Not implemented yet"
        End If
        Call Free_Work(ipTmpFck)
      End If
***************************************************************************
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' FA in MO-basis in fmat'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FA(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
      End If
*     update Fock matrix by rescaling exchange term...
      If (NewFock.eq.1) Call Upd_FA(PUVX,FA,D,ExFac)

*     print FI and FA
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' FI in MO-basis in fmat'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FI(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
      End If
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' FA in MO-basis in fmat after upd_FA'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FA(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
      End If


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine Do_Lebedev_Sym(L_Eff,mPt,ipR)
      Implicit None
#include "WrkSpc.fh"
      Integer, Intent(In) :: L_Eff
      Integer, Intent(Out) :: mPt, ipR
      Integer :: mPt_, ipR_, i, j, ii, jj
      Real*8, Parameter :: Thr = 1.0D-16
      Call Do_Lebedev(L_Eff,mPt_,ipR_)
      mPt=0
      outer: Do i=1,mPt_
        ii = ipR_+(i-1)*4
        Do j=1,i-1
          jj = ipR_+(j-1)*4
          If (All(Abs(Work(jj:jj+2)+Work(ii:ii+2)).lt.Thr)) Then
            Work(ii+3)=0.0D0
            Cycle outer
          End If
        End Do
        mPt=mPt+1
      End Do outer
      Call GetMem('AngRW','Allo','Real',ipR,4*mPt)
      j=1
      Do i=1,mPt_
        ii = ipR_+(i-1)*4
        If (Work(ii+3).ne.0.0D0) Then
          Call DCopy_(4,Work(ii),1,Work(ipR+(j-1)*4),1)
          j=j+1
        End if
      End Do
      Call GetMem('AngRW','Free','Real',ipR_,4*mPt_)
      End Subroutine Do_Lebedev_Sym

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function FC_Torsion(jSet,Coor,iTabAtoms,nMax,mAtoms)

use Slapaf_Info, only: Covalent_Bond
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: FC_Torsion
integer(kind=iwp), intent(in) :: jSet(4), nMax, mAtoms, iTabAtoms(2,0:nMax,mAtoms)
real(kind=wp), intent(in) :: Coor(3,4)
integer(kind=iwp) :: i, iAtom, iAtom_, iHit, ii, jAtom, jAtom_
real(kind=wp) :: Gij(3)
integer(kind=iwp), parameter :: iCase(2,3) = reshape([1,2,2,3,3,4],[2,3])

FC_Torsion = Zero
do ii=1,3
  iHit = 0
  iAtom = jSet(iCase(1,ii))
  jAtom = jSet(iCase(2,ii))

  ! Loop over the neighbor atoms of iAtom to see if jAtom is a neighbor. If
  ! it is check that the bond is classified as a covalent bond.

  do i=1,iTabAtoms(1,0,iAtom)
    if ((jAtom == iTabAtoms(1,i,iAtom)) .and. (iTabAtoms(2,i,iAtom) == Covalent_Bond)) then
      iHit = 1
      iAtom_ = iCase(1,ii)
      jAtom_ = iCase(2,ii)
      Gij(ii) = One/sqrt((Coor(1,iAtom_)-Coor(1,jAtom_))**2+(Coor(2,iAtom_)-Coor(2,jAtom_))**2+(Coor(3,iAtom_)-Coor(3,jAtom_))**2)
    end if
  end do
  if (iHit == 0) return
end do
FC_Torsion = Gij(1)*Gij(2)*Gij(3)

return

end function FC_Torsion

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_SetQ2(iQuAB2,LstSP,nSP,iSym,jLoc,iLoc)
C
C     Purpose: set mapping from qualified diagonals of symmetry iSym to
C              reduced set indexed by arrays at location iLoc>1,
C              counting only shell pairs that contain qualified
C              diagonals (in the order in which they were qualified).
C              The qualified index array iQuAB (pointer in choswp.f90)
C              is assumed to refer to index arrays at location jLoc>1.
C
      use ChoSwp, only: iQuAB, nnBstRSh, iiBstRSh, IndRSh, IndRed
      Implicit Real*8 (a-h,o-z)
      Integer iQuAB2(*)
      Integer LstSP(nSP)
#include "cholesky.fh"

      Integer  Cho_P_LocalSP, Cho_F2SP
      External Cho_P_LocalSP, Cho_F2SP

      iC = 0
      jShlAB_Ref = -1
      Do iQ = 1,nQual(iSym)
         jAB = iQuAB(iQ,iSym) ! addr in rs jLoc
         jAB1 = IndRed(jAB,jLoc) ! addr in 1st rs
         jShlAB = Cho_P_LocalSP(Cho_F2SP(IndRSh(jAB1))) ! local SP
         If (jShlAB .ne. jShlAB_Ref) Then
            iC = 0
            iSP = 0
            Do While (iSP .lt. nSP)
               iSP = iSP + 1
               kShlAB = Cho_P_LocalSP(LstSP(iSP)) ! local SP
               If (kShlAB .eq. jShlAB) Then
                  iSP = nSP ! break while loop
               Else
                  iC = iC + nnBstRSh(iSym,kShlAB,iLoc)
               End If
            End Do
            jShlAB_Ref = jShlAB
         End If
         iAB0 = iiBstR(iSym,iLoc) + iiBstRSh(iSym,jShlAB,iLoc)
         iAB = 0
         Do While (iAB .lt. nnBstRSh(iSym,jShlAB,iLoc))
            iAB = iAB + 1
            iAB1 = IndRed(iAB0+iAB,iLoc) ! addr in 1st rs
            If (iAB1 .eq. jAB1) Then
               iQuAB2(iQ) = iC + iAB
               iAB = nnBstRSh(iSym,jShlAB,iLoc) ! break while loop
            End If
         End Do
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Dresselhaus                                     *
!***********************************************************************

!***********************************************************************
! Returns the radial part of the value of a GTO with given exponent,   *
! centered at the origin.                                              *
!***********************************************************************
function gaussRad(alpha,r)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: gaussRad
real(kind=wp), intent(in) :: alpha, r(3)
integer(kind=iwp) :: i
real(kind=wp) :: rSquare

rSquare = Zero
do i=1,3
  rSquare = rSquare+r(i)**2
end do

! Radial part
gaussRad = exp(-alpha*rSquare)

return

end function gaussRad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SG_Print(SGS)

use sguga, only: SGStruct
use Definitions, only: iwp, u6

implicit none
type(SGStruct), intent(in) :: SGS
integer(kind=iwp) :: i, ic, iv

write(u6,*) ' Split-Graph UGA. Graph description:'
write(u6,*) ' Nr of levels:',SGS%nLev
write(u6,*) ' Orbital symmetry labels:'
write(u6,'(1x,30i2)') (SGS%ISm(i),i=1,SGS%nLev)
write(u6,*) ' Nr of vertices:',SGS%nVert
write(u6,*)
write(u6,*) ' Vertex    L  N    A  B  C      Downchain table        Upchain table'
write(u6,*)
do iv=1,SGS%nVert
  write(u6,'(1x,i4,5x,2i3,2x,3i3,5x,4i4,5x,4i4)') iv,(SGS%DRT(iv,i-1),i=1,5),(SGS%Down(iv,ic),ic=0,3),(SGS%Up(iv,ic),ic=0,3)
end do
write(u6,*)
write(u6,*) ' Mid Level:',SGS%MidLev
write(u6,*) ' Mid Vertices:',SGS%MVSta,'...',SGS%MVEnd
write(u6,*)
write(u6,*) ' Modified Arc Weight table:'
write(u6,*) '           Coupling case number'
write(u6,*) ' Vertex      0    1    2    3'
write(u6,*)
do iv=1,SGS%nVert
  write(u6,'(1x,i4,5x,4i5)') iv,(SGS%MAW(iv,ic),ic=0,3)
end do

end subroutine SG_Print

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_X_Init_Par_Cho(irc)
!
! Purpose: setup for parallel Cholesky.

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
#ifdef _DEBUGPRINT_
use Para_Info, only: MyRank
#endif
use Cholesky, only: InfVec, nSym, NumCho, NumChT
use stdalloc, only: mma_allocate, mma_deallocate
#endif
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(out) :: irc
character(len=*), parameter :: SecNam = 'Cho_X_Init_Par_Cho'
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: i, iSym, j, nV(8)
logical(kind=iwp) :: isSerial
integer(kind=iwp), allocatable :: IDV(:), myInfV(:)

irc = 0

! Return if serial.
! -----------------

isSerial = (nProcs == 1) .or. (.not. Is_Real_Par())
if (isSerial) then
# ifdef _DEBUGPRINT_
  write(u6,*) SecNam,': serial run, nothing to do...'
  write(u6,*) '#nodes: ',nProcs,'  myRank: ',myRank
# endif
  return
# ifdef _DEBUGPRINT_
else
  write(u6,*) SecNam,': parallel run...'
  write(u6,*) '#nodes: ',nProcs,'  myRank: ',myRank
# endif
end if

! Reset vector info to fit vectors stored on this node.
! -----------------------------------------------------

do iSym=1,nSym
  nV(iSym) = 0
  if (NumCho(iSym) > 0) then
    call mma_allocate(IDV,NumCho(iSym),Label='IDV')
    call Cho_Distrib_Vec(1,NumCho(iSym),IDV,nV(iSym))
    if (nV(iSym) > 0) then
      call mma_allocate(myInfV,nV(iSym),Label='myInfV')
      do j=1,size(InfVec,2)
        if (j /= 3) then
          do i=1,nV(iSym)
            myInfV(i) = InfVec(IDV(i),j,iSym)
          end do
          InfVec(:,j,iSym) = myInfV(:)
        end if
      end do
      call mma_deallocate(myInfV)
    end if
    call mma_deallocate(IDV)
  end if
end do

! Reset number of vectors.
! ------------------------

call iSwap(nSym,NumCho,1,nV,1)
NumChT = sum(NumCho(1:nSym))

#ifdef _DEBUGPRINT_
! Debug print.
! ------------

write(u6,*)
write(u6,*) 'Output from ',SecNam,':'
write(u6,*) 'NumCho before: ',(nV(iSym),iSym=1,nSym)
write(u6,*) 'NumCho after : ',(NumCho(iSym),iSym=1,nSym)
#endif

#else

irc = 0
#ifdef _DEBUGPRINT_
write(u6,*) SecNam,': serial run, nothing to do...'
#endif

#endif

end subroutine Cho_X_Init_Par_Cho

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Ignacio Fdez. Galvan                             *
************************************************************************

      subroutine Write_Data()
      use stdalloc
      use False_Global, only: Will_Print
      implicit none
      integer :: nAtoms,nCart,nHess,nRoots,nRelax,i,j,LU,EOF
      real*8, allocatable :: Energies(:),Gradient(:),NAC(:),Hessian(:),
     &                       Dipoles(:,:)
      integer, allocatable :: not_grad(:),not_nac(:,:)
      character(len=16) :: line
      logical :: Too_Late
      integer, external :: IsFreeUnit
#include "real.fh"

      call Get_nAtoms_All(nAtoms)
      nCart=3*nAtoms
      nHess=nCart*(nCart+1)/2
      if (Will_Print) write(6,*)

      ! read data from interface output file
      ! write to RUNFILE or GRADS as we read it
      LU=IsFreeUnit(11)
      call Molcas_Open(LU,'OUTPUT')
      Too_Late = .false.
      nRoots=0
      do
        read(LU,100,iostat=EOF) line
        if (EOF < 0) exit
        call UpCase(line)
        select case (line)
          case ('[ROOTS]')
            read(LU,*) nRoots
            nRelax = nRoots
            call Check_nRoots(nRoots)
            if (Will_Print) write(6,200) nRoots
            call Put_iScalar('Number of roots',nRoots)
            call Put_iScalar('Relax CASSCF root',nRelax)
            call mma_Allocate(not_grad,nRoots)
            call mma_Allocate(not_nac,nRoots,nRoots)
            not_grad(:)=1
            not_nac(:,:)=1
          case ('[RELAX ROOT]')
            call Check_Too_Late()
            call Check_nRoots()
            read(LU,*) nRelax
            call Check_Root_Number(nRelax)
            if (Will_Print) write(6,201) nRelax
            call Put_iScalar('Relax CASSCF root',nRelax)
          case ('[ENERGIES]')
            call Check_nRoots()
            Too_Late=.true.
            call mma_Allocate(Energies,nRoots,label='Energies')
            read(LU,*) Energies(:)
            if (Will_Print)
     &         call RecPrt('Root energies','',Energies,nRoots,1)
            call Put_cArray('Relax Method', 'EXTERNAL', 8)
            call Store_Energies(nRoots,Energies,nRelax)
            call mma_Deallocate(Energies)
          case ('[GRADIENT]')
            call Check_nRoots()
            read(LU,*) i
            Call Check_Root_Number(i)
            call mma_Allocate(Gradient,nCart,label='Gradient')
            read(LU,*) Gradient(:)
            if (Will_Print) write(6,202) i
            not_grad(i)=0
            call Store_Grad(Gradient,nCart,i,0,0)
            call mma_Deallocate(Gradient)
          case ('[NAC]')
            call Check_nRoots()
            read(LU,*) i,j
            Call Check_Root_Pair(i,j)
            call mma_Allocate(NAC,nCart,label='NAC')
            read(LU,*) NAC(:)
            if (Will_Print) write(6,203) i,j
            not_nac(i,j)=0
            not_nac(j,i)=0
            call Store_Grad(NAC,nCart,0,i,j)
            call mma_Deallocate(NAC)
          case ('[HESSIAN]')
            call Check_nRoots()
            Too_Late=.true.
            read(LU,*) i
            Call Check_Root_Number(i)
            if (i == nRelax) then
              call mma_Allocate(Hessian,nHess,label='Hessian')
              read(LU,*) Hessian(:)
              call Put_AnalHess(Hessian,nHess)
              call mma_Deallocate(Hessian)
            end if
            if (Will_Print) write(6,204) i
          case ('[DIPOLES]')
            call Check_nRoots()
            call mma_Allocate(Dipoles,3,nRoots,label='Dipoles')
            do i=1,nRoots
              read(LU,*) Dipoles(:,i)
            end do
            if (Will_Print) write(6,*) 'Found dipole moments'
            call Put_dArray('Last dipole moments',Dipoles,3*nRoots)
            call mma_Deallocate(Dipoles)
          case default
        end select
      end do
      close(LU)

      ! mark non-computable gradients
      if (allocated(not_grad)) then
        do j=1,nRoots
          if (not_grad(j) /= 0) call Store_Not_Grad(j,0,0)
          do i=j+1,nRoots
            if (not_nac(i,j) /= 0) call Store_Not_Grad(0,i,j)
          end do
        end do
        call mma_deallocate(not_grad)
        call mma_deallocate(not_nac)
      end if

      return

100   format(A)
200   format('Found data for ',I3,' roots')
201   format('Relaxing on root ',I3)
202   format('Found gradient for root ',I3)
203   format('Found coupling vector for roots ',I3,' and ',I3)
204   format('Found Hessian for root ',I3)

      contains

      subroutine Check_nRoots(n)
      integer, intent(in), optional :: n
      if (nRoots < 1) then
        if (present(n)) then
          call WarningMessage(2,'The number of roots must be positive.')
        else
          call WarningMessage(2,'[ROOTS] should be defined first.')
        end if
        call AbEnd()
      end if
      end subroutine Check_nRoots

      subroutine Check_Too_Late()
      if (Too_Late) then
        call WarningMessage(2,'[RELAX] should have been given earlier.')
        call AbEnd()
      end if
      end subroutine Check_Too_Late

      subroutine Check_Root_Number(n)
      integer, intent(in) :: n
      character(len=6) :: a,b
      call Check_nRoots()
      if ((n < 1) .or. (n > nRoots)) then
        write(a,'(I6)') n
        write(b,'(I6)') nRoots
        a=adjustl(a)
        b=adjustl(b)
        call WarningMessage(2,'Root number '//trim(a)//' must be '
     &     //'between 1 and '//trim(b)//'.')
        call AbEnd()
      end if
      end subroutine Check_Root_Number

      subroutine Check_Root_Pair(n,m)
      integer, intent(in) :: n,m
      character(len=6) :: a
      call Check_Root_Number(n)
      call Check_Root_Number(m)
      if (n == m) then
        write(a,'(I6)') n
        a=adjustl(a)
        call WarningMessage(2,'Roots in pair '//trim(a)//' '//
     &     trim(a)//' cannot be equal.')
        call AbEnd()
      end if
      end subroutine Check_Root_Pair

      end subroutine Write_Data

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
******************************************************************
*
* This subroutine substitutes the previous version of the RdOrd
* to allow the generation of two-electron integrals from a set
* of Cholesky vectors
*
*     Data declarations:
*
*        First  : logical variable for identifying the 1st call
*                 to this subroutine
*
*   F. Aquilante
*
******************************************************************

************************************************************************
*  RdOrd
*
*> @brief
*>   Driver for the actual ::RdOrd_ routines and the Cholesky vector integral generator
*> @author F. Aquilante
*>
*> @note
*> The integrals are returned in the order \f$ (lk|ji) \f$.
*>
*> @param[out]    rc   return code
*> @param[in,out] iOpt option code (= ``1``: start reading at first shell distribution
*>                     in the given product symmetry. = ``2``: continue reading)
*> @param[in]     iSym irred. representation of "first" symmetry label
*> @param[in]     jSym irred. representation of "second" symmetry label
*> @param[in]     kSym irred. representation of "third" symmetry label
*> @param[in]     lSym irred. representation of "fourth" symmetry label
*> @param[in,out] Buf  contains on output the integrals
*> @param[in]     lBuf length of the integral buffer
*> @param[out]    nMat number of submatrices read in
************************************************************************
      Subroutine RdOrd(rc,iOpt,iSym,jSym,kSym,lSym,Buf,lBuf,nMat)

      Implicit Real*8 (a-h,o-z)

      Integer rc
      Dimension Buf(*)

      Logical First,DoCholesky
      Common / DoCho / DoCholesky

      Data First /.true./
      Save First

#include "RdOrd.fh"

      If (First) Then
        CALL DecideOnCholesky(DoCholesky)
        If (DoCholesky) Then
c   initialize information
          CALL INIT_GETINT(rc)
        End If
        First=.false.
      End If

      If (DoCholesky) Then
       CALL Get_Int(rc,iOpt,iSym,jSym,kSym,lSym,Buf,lBuf,nMat)
      Else
       CALL RdOrd_(rc,iOpt,iSym,jSym,kSym,lSym,Buf,lBuf,nMat)
      end if

c --- Debug printing
c
c      call get_iscalar('nSym',nsym)
c      call get_iarray('nbas',nbas,nsym)
c      if (kSym .eq. lSym) then
c         Nkl = nBas(kSym)*(nBas(kSym)+1)/2
c      else
c         Nkl = nBas(kSym)*nBas(lSym)
c      end if
c      write(6,*)
c      write(6,*)'Integrals: symm(ij|kl), nMat ',iSym,jSym,kSym,lSym,nMat
c      write(6,*)'Nbask,Nbasl,Nkl= ',nBas(kSym),nBas(lSym),Nkl
c      xnrm = sqrt(ddot_(Nkl*nMat,Buf,1,Buf,1))
c      write(6,*)'norm= ',xnrm
c      call cho_output(Buf,1,nMat,1,Nkl,nMat,Nkl,1,6)
c      call xflush(6)
c ---

      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

subroutine CalcW(W,GDMat,PUVX,NPUVX,IndTUVX)

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: nNA
use input_mclr, only: nRoots, ntAsh
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: W(nTri_Elem(nRoots),nTri_Elem(nRoots))
integer(kind=iwp), intent(in) :: NPUVX, IndTUVX(ntAsh,ntAsh,ntAsh,ntAsh)
real(kind=wp), intent(in) :: GDMat(nTri_Elem(nRoots),nnA,nnA), PUVX(NPUVX)
integer(kind=iwp) :: IKL, IMN, it, iu, iv, ix, K, L, M, N

W(:,:) = Zero
do K=1,nRoots
  do L=1,K
    IKL = iTri(K,L)
    do M=1,nRoots
      do N=1,M
        IMN = iTri(M,N)
        do it=1,nnA
          do iu=1,nnA
            do iv=1,nnA
              do ix=1,nnA
                if (IndTUVX(it,iu,iv,ix) /= 0) W(IKL,IMN) = W(IKL,IMN)+GDMat(IKL,it,iu)*GDMat(IMN,iv,ix)*PUVX(IndTUVX(it,iu,iv,ix))
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end do

end subroutine CalcW

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Put_AnalHess
*
*> @brief
*>   Write the symmetry blocked nuclear Hessian in Cartesian coordinates on the runfile
*> @author R. Lindh
*>
*> @details
*> The utility will write the symmetry blocked nuclear Hessian in Cartesian coordinates on the runfile.
*>
*> @param[in] AnalHess  Array with the symmetry blocked nuclear Hessian in Cartesian coordinates
*> @param[in] nAnalHess Size of the array \p AnalHess
************************************************************************
      Subroutine Put_AnalHess(AnalHess,nAnalHess)
      Implicit Real*8 (a-h,o-z)
      Real*8 AnalHess(nAnalHess)
      Character Label*80
      Logical Found
      Integer iTmp, iSI1(7)

      Call Put_dArray('Analytic Hessian',AnalHess,nAnalHess)

*---- Add the iteration number corresponding to this Hessian
      iSI1(2)=0
      Call Qpg_iArray('Slapaf Info 1',Found,iTmp)
      If (Found) Call Get_iArray('Slapaf Info 1',iSI1,7)
      Call Getenvf("MOLCAS_ITER",Label)
      Read (Label,'(I80)') iTmp
      Call Getenvf("EMIL_InLoop",Label)
      Read (Label,*,IOStat=irderr) inLoop
      If (irderr.ne.0) inLoop=0
      If (inLoop.lt.1) iTmp=0
      If (iTmp.eq.0) Then
        Call Put_iScalar('HessIter',iTmp)
      Else
        Call Put_iScalar('HessIter',iSI1(2)+1)
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE REO_GASDET_S(   IREO,  NSSOA,  NSSOB, NOCTPA, NOCTPB,
     &                        MXPNGAS, IOCTPA, IOCTPB, NBLOCK, IBLOCK,
     &                           NAEL,   NBEL,  IASTR,  IBSTR,
     &                          NSMST,NELFSPGP,NOCCLS,  NGAS,IOCCLS,
     &                           NORB,NOBPT,DFTP,IB_CONF_OPEN,iconf_reo,
*
     &                        nconf_tot,
     &                        ib_conf_reo,
     &                          maxop,
     &                        nconf_per_open,
     &                        IB_SD_FOR_OPEN,IZSCR,IZ,IOCMIN,IOCMAX,
*
     &                        IDET_OC,IDET_MS,IDET_VC,  iWORK,KZ_PTDT,
     &                        KREO_PTDT,
     &                          MINOP,
     &                        IBCONF_ALL_SYM_FOR_OCCLS,
     &                         PSSIGN,
*
     &                        NPDTCNF)
*
* SUBROUTINE REO_GASDET_S --> 44
*
*
* Reorder determinants in GAS space from det to configuration order
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
      DIMENSION NSSOA(NSMST,*), NSSOB(NSMST,*)
      DIMENSION NELFSPGP(MXPNGAS,*)
      DIMENSION IOCCLS(NGAS,NOCCLS)
      INTEGER NOBPT(*)
      INTEGER DFTP(*)
      INTEGER IB_CONF_OPEN(*),iconf_reo(nconf_tot)
      integer ib_conf_reo(maxop+1),nconf_per_open(maxop+1)
      INTEGER IB_SD_FOR_OPEN(*)
      INTEGER NPDTCNF(*)
*. Offset to start of configurations of given occls in list containing all symmetries
      INTEGER IBCONF_ALL_SYM_FOR_OCCLS(NOCCLS)
*. iWORK(KZ_PTDT(IOPEN+1) gives Z  array for prototype dets with IOPEN
*. iWORK(KREO_PTDT(IOPEN+1) gives the corresponding reorder array
*. open orbitals
      INTEGER KZ_PTDT(*), KREO_PTDT(*)
*. The work array containing used for iWORK(KZ_PTDET()),iWORK(KREO_PTDT())
      DIMENSION iWORK(*)
*. Specific input
      DIMENSION IBLOCK(8,NBLOCK)
*. Scratch space
*PAM06 Note: NAEL and NBEL could legally be =0!
*PAM06      DIMENSION IASTR(NAEL,*),IBSTR(NBEL,*)
      DIMENSION IASTR(*),IBSTR(*)
      INTEGER IZSCR(*),IZ(*),IOCMIN(*),IOCMAX(*)
      INTEGER IDET_OC(*), IDET_MS(*) , IDET_VC(*)
*. Output
      INTEGER IREO(*)
C     DIMENSION SREO(*)
      DIMENSION IDUM(1)
*
      NTEST = 0
*
      IAGRP = 1
      IBGRP = 2
*
      NEL = NAEL + NBEL
*
      IDET = 0
      DO JBLOCK = 1, NBLOCK
        IATP = IBLOCK(1,JBLOCK)
        IBTP = IBLOCK(2,JBLOCK)
        IASM = IBLOCK(3,JBLOCK)
        IBSM = IBLOCK(4,JBLOCK)
C?      WRITE(6,*) ' REO_GASDET, IATP, IBTP = ', IATP, IBTP
*. Occupation class of this combination of string
        CALL IAIB_TO_OCCLS(IAGRP,IATP,IBGRP,IBTP,IOC)
C            IAIB_TO_OCCLS(IAGRP,IATP,IBGRP,IBTP,IOC)
*. Arcweights for this occupation class
        CALL MXMNOC_OCCLS(IOCMIN,IOCMAX,    NGAS,   NOBPT,IOCCLS(1,IOC),
     &                       MINOP,   NTEST)
C     MXMNOC_OCCLS(MINEL,MAXEL,NORBTP,NORBFTP,NELFTP,NTESTG)
*. the arcweights
         CALL CONF_GRAPH(  IOCMIN,  IOCMAX,    NORB,     NEL,      IZ,
     &                    NCONF_P,   IZSCR)
C             CONF_GRAPH(IOCC_MIN,IOCC_MAX,NORB,NEL,IARCW,NCONF,ISCR)
*. Obtain alpha strings of sym IASM and type IATP
        IDUM(1) = 0
        CALL GETSTR_TOTSM_SPGP(      1,   IATP,   IASM,   NAEL, NASTR1,
     &                           IASTR,   NORB,      0,   IDUM,   IDUM)
*. Obtain Beta  strings of sym IBSM and type IBTP
        IDUM(1) = 0
        CALL GETSTR_TOTSM_SPGP(      2,   IBTP,   IBSM,   NBEL, NBSTR1,
     &                           IBSTR,   NORB,      0,   IDUM,   IDUM)
*. Occupation class corresponding to this combination
C            IAIB_TO_OCCLS(IAGRP,IATP,IBGRP,IBTP,IOC)
* The following call should presumably use 'IOC' rather than 'IOCNUM'
* The variable name IOCNUM seems to be used nowhere... PAM 2009
*        CALL IAIB_TO_OCCLS(1,IATP,2,IBTP,IOCNUM)
        CALL IAIB_TO_OCCLS(1,IATP,2,IBTP,IOC)
*. Offset to this occupation class in occupation class ordered cnf list
        IB_OCCLS = IBCONF_ALL_SYM_FOR_OCCLS(IOC)
*. Info for this occupation class :
        IRESTR = 0
        IF(PSSIGN.EQ.1.0D0.AND.IASM.EQ.IBSM.AND.IATP.EQ.IBTP) THEN
         IRESTR = 1
        END IF
*
        NIA = NSSOA(IASM,IATP)
        NIB = NSSOB(IBSM,IBTP)
*
        DO  IB = 1,NIB
          IF(IRESTR.EQ.1) THEN
            MINIA = IB
          ELSE
            MINIA = 1
          END IF
          DO  IA = MINIA,NIA
            IDET = IDET + 1
C                ABSTR_TO_ORDSTR(IA_OC,IB_OC,NAEL,NBEL,IDET_OC,IDET_SP,ISIGN)
*PAM06       CALL ABSTR_TO_ORDSTR(IASTR(1,IA),IBSTR(1,IB),NAEL,NBEL,
            CALL ABSTR_TO_ORDSTR(IASTR(1+NAEL*(IA-1)),
     &                           IBSTR(1+NBEL*(IB-1)),
     &                             NAEL,  NBEL,IDET_OC,IDET_MS,ISIGN)
*. Number of open orbitals in this configuration
            NOPEN = NOP_FOR_CONF(IDET_OC,NEL)
C                   NOP_FOR_CONF(ICONF,NEL)
            NDOUBLE = (NEL-NOPEN)/2
            NOCOB = NOPEN + NDOUBLE
            NOPEN_AL = NAEL - NDOUBLE
C?          WRITE(6,*) ' NOPEN, NOPEN_AL = ', NOPEN,NOPEN_AL
CERRROR     NPTDT = IBION_LUCIA(NOPEN,NOPEN_AL)
            NPTDT = NPDTCNF(NOPEN+1)
*. Packed form of this configuration
C                REFORM_CONF_OCC(IOCC_EXP,IOCC_PCK,NEL,NOCOB,IWAY)
            CALL REFORM_CONF_OCC(IDET_OC,IDET_VC,NEL,NOCOB,1)
*. Address of this configuration
*. Offset to configurations with this number of open orbitals in
*. reordered cnf list
C                      ILEX_FOR_CONF(ICONF,NOCC_ORB,NORB,NEL,IARCW,IDOREO,IREO)
c           write(6,*)'iconf_reo_new array:'
c           call iwrtma(iconf_reo_new,1,nconf_tot,1,nconf_tot)
c.... Giovanni and Dongxia comment off the following 2 lines
c           ICNF_OUT = ILEX_FOR_CONF(IDET_VC,NOCOB,NORB,NEL,IZ,1,
c    &                 ICONF_REO(IB_OCCLS))
c..... end
c           write(6,*)'ib_conf_reo at line 2401, and maxop',maxop
c           call iwrtma(ib_conf_reo,1,maxop+1,1,maxop+1)
c           call iwrtma(nconf_per_open,1,maxop+1,1,maxop+1)
c          write(6,*)'before calling ilex_for_conf_new, in reogas_det_s'
c          write(6,*)'nopen =',nopen
c          write(6,*)'and nconf_per_open(nopen+1) =',
c    &          nconf_per_open(nopen+1)
c          write(6,*)'check iconf_reo array'
c          call iwrtma(iconf_reo,1,nconf_tot,1,nconf_tot)
            nconf_op = nconf_per_open(nopen+1)
c          call iwrtma(nconf_per_open,1,maxop+1,1,maxop+1)
            icnf_out=ilex_for_conf_new(idet_vc,nocob,norb,nel,iz,1,
     &          iconf_reo(ib_conf_reo(nopen+1)),nconf_op,ib_occls)
     &         +ib_conf_reo(nopen+1)-1
C?          WRITE(6,*) ' number of configuration in output list',
C?   &      ICNF_OUT
*. Spinprojections of open orbitals
            CALL EXTRT_MS_OPEN_OB(IDET_OC,IDET_MS,IDET_VC,NEL)
C                EXTRT_MS_OPEN_OB(IDET_OC,IDET_MS,IDET_OPEN_MS,NEL)

            ISIGN_2003 = 1
            IF(ABS(PSSIGN).EQ.1.0D0) THEN
*. If combinations are used, then the prototype determinants
*. are defined so the first open spin-orbital is having alpha spin.
*. In ab order, the included determinant is defined, by having
*. alpha-spin in the first singly occupied orbital. These definitions
*. may differ, so ensure that the included det obeys prototype constraint
*. Address of this spinprojection pattern
              IF(IDET_VC(1).LT.0) THEN
                DO I = 1, NOPEN
                  IDET_VC(I) = -1*IDET_VC(I)
                END DO
                IF(PSSIGN.EQ.-1.0D0) ISIGN_2003 = -1
*. Update sign AB => ordered list
*PAM06          CALL ABSTR_TO_ORDSTR(IBSTR(1,IB),IASTR(1,IA),NBEL,NAEL,
            CALL ABSTR_TO_ORDSTR(IBSTR(1+NBEL*(IB-1)),
     &                           IASTR(1+NAEL*(IA-1)),
     &                             NBEL,  NAEL,IDET_OC,IDET_MS,ISIGN)
              END IF
           END IF
C  IZNUM_PTDT(IAB,NOPEN,NALPHA,Z,NEWORD,IREORD)
            IPTDT = IZNUM_PTDT(IDET_VC,NOPEN,NOPEN_AL,
     &              iWORK(KZ_PTDT(NOPEN+1)),iWORK(KREO_PTDT(NOPEN+1)),
     &              1)
C?          WRITE(6,*) ' Number of det in list of PTDT ', IPTDT
C?          WRITE(6,*) ' IB_SD_FOR_OPEN(NOPEN+1) = ',
C?   &                   IB_SD_FOR_OPEN(NOPEN+1)
C?          WRITE(6,*) ' ICNF_OUT, NPTDT ', ICNF_OUT, NPTDT
            IBCNF_OUT = IB_CONF_OPEN(NOPEN+1)
C?          WRITE(6,*) ' IBCNF_OUT = ', IBCNF_OUT
            IADR_SD_CONF_ORDER = IB_SD_FOR_OPEN(NOPEN+1) - 1
     &                         + (ICNF_OUT-IBCNF_OUT)*NPTDT + IPTDT
            IF(IADR_SD_CONF_ORDER.LE.0) THEN
              WRITE(6,*) ' Problemo, IADR_SD_CONF_ORDER < 0 '
              WRITE(6,*) ' IADR_SD_CONF_ORDER = ', IADR_SD_CONF_ORDER
              CALL XFLUSH(6)
            END IF
C?          WRITE(6,*) ' IADR_SD_CONF_ORDER, ISIGN, IDET = ',
C?   &                   IADR_SD_CONF_ORDER, ISIGN, IDET
            IREO(IADR_SD_CONF_ORDER) = ISIGN*IDET*ISIGN_2003
*
          END DO
*         ^ End of loop over alpha strings
        END DO
*       ^ End of loop over beta strings
        END DO
*       ^ End of loop over blocks
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Reorder array, CONF order => string order '
        WRITE(6,*) ' ========================================== '
        CALL IWRTMA(IREO,1,IDET,1,IDET)
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NOCTPA)
        CALL Unused_integer(NOCTPB)
        CALL Unused_integer(IOCTPA)
        CALL Unused_integer(IOCTPB)
        CALL Unused_integer_array(NELFSPGP)
        CALL Unused_integer_array(DFTP)
      END IF
      END
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHO_FSCF(rc,nDen,FLT,nForb,nIorb,Porb,DLT,ExFac)
!*********************************************************************
!  Author : F. Aquilante
!
! *************** INACTIVE AO-BASIS FOCK MATRIX **********************
!
!   F(ab) = sum_J  Lab,J * V(J)  -  sum_Jk  Lka,J * Lkb,J
!
!*********************************************************************
!
!      V(J) = sum_gd  Lgd,J * Dtot(gd)
!
!      a,b,g,d:  AO-index
!      k:        MO-index   belonging to (Frozen+Inactive)
!
!*********************************************************************

use ChoArr, only: nDimRS
use ChoSwp, only: InfVec
use Symmetry_Info, only: Mul
use Data_structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, SBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp), intent(in) :: nDen, nForb(8,nDen), nIorb(8,nDen)
type(DSBA_Type), intent(inout) :: FLT(nDen)
type(DSBA_Type), intent(in) :: Porb(nDen), DLT(nDen)
real(kind=wp), intent(in) :: ExFac
#include "chotime.fh"
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: i, iBatch, iDen, iLoc, irc, IREDC, iSkip(8), iSwap, iSyma, iSymk, IVEC2, iVrs, jDen, JNUM, JRED, JRED1, &
                     JRED2, jSym, JVEC, k, kMOs, l, LREAD, LWORK, Mmax, mTvec, MUSED, nAux(8), nBatch, NK, nMat, nMOs, nRS, NUMV, &
                     nVec, nVrs
real(kind=wp) :: Fact, FactCI, FactXI, TCC1, TCC2, tcoul(2), TCR1, TCR2, TCR3, TCR4, TCX1, TCX2, texch(2), TOTCPU, TOTCPU1, &
                 TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, tread(2), TWC1, TWC2, TWR1, TWR2, TWR3, TWR4, TWX1, TWX2
logical(kind=iwp) :: add, DoRead
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: Debug
#endif
character(len=50) :: CFmt
type(SBA_Type) :: Laq(2)
real(kind=wp), allocatable :: Drs(:), Frs(:), Lrs(:,:), VJ(:)
character(len=*), parameter :: SECNAM = 'CHO_FSCF'

!***********************************************************************
#ifdef _DEBUGPRINT_
Debug = .false. ! to avoid double printing in CASSCF-debug
#endif

FactCI = One
FactXI = -ExFac

DoRead = .false.
IREDC = -1 ! unknown reduced set

if ((nDen /= 1) .and. (nDen /= 2)) then
  write(u6,*) SECNAM//'Invalid parameter nDen= ',nDen
  call abend()
end if

call CWTIME(TOTCPU1,TOTWALL1) ! start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = zero ! time read/transform vectors
tcoul(:) = zero ! time for computing Coulomb
texch(:) = zero ! time for computing Exchange

! ==================================================================

iLoc = 3 ! use scratch location in reduced index arrays

! *************** BIG LOOP OVER VECTORS SYMMETRY *******************
do jSym=1,nSym

  if (NumCho(jSym) < 1) cycle

  ! ****************     MEMORY MANAGEMENT SECTION    *****************
  ! --------------------------------------------------------------
  ! compute memory needed to store at least 1 vector of JSYM
  ! and do all the subsequent calculations
  ! --------------------------------------------------------------
  mTvec = 0  ! mem for storing the half-transformed vec

  do l=1,nSym
    k = Mul(l,JSYM)
    Mmax = 0
    do jDen=1,nDen
      Mmax = max(Mmax,nForb(k,jDen)+nIorb(k,jDen))
    end do
    mTvec = mTvec+nBas(l)*Mmax
  end do

  mTvec = max(mTvec,1)

  ! ------------------------------------------------------------------
  ! ------------------------------------------------------------------

  JRED1 = InfVec(1,2,jSym)            ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) ! red set of the last vec

  do JRED=JRED1,JRED2

    call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

    if (nVrs == 0) cycle ! no vectors in that (jred,jsym)

    if (nVrs < 0) then
      write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
      call abend()
    end if

    call Cho_X_SetRed(irc,iLoc,JRED) ! set index arrays at iLoc
    if (irc /= 0) then
      write(u6,*) SECNAM//'cho_X_setred non-zero return code.   rc= ',irc
      call abend()
    end if

    IREDC = JRED

    nRS = nDimRS(JSYM,JRED)

    if (JSYM == 1) then
      call mma_allocate(Drs,nRS,Label='Drs')
      call mma_allocate(Frs,nRS,Label='Frs')
      Drs(:) = Zero
      Frs(:) = Zero
    end if

    call mma_maxDBLE(LWORK)

    nVec = min(LWORK/(nRS+mTvec),nVrs)

    if (nVec < 1) then
      write(u6,*) SECNAM//': Insufficient memory for batch'
      write(u6,*) 'LWORK= ',LWORK
      write(u6,*) 'min. mem. need= ',nRS+mTvec
      write(u6,*) 'jsym= ',jsym
      rc = 33
      call Abend()
      nBatch = -9999 ! dummy assignment
    end if

    LREAD = nRS*nVec

    call mma_allocate(Lrs,nRS,nVec,Label='Lrs')

    if (JSYM == 1) then
      ! Transform the density to reduced storage
      add = .false.
      nMat = 1
      call Swap_full2rs(irc,iLoc,nRS,nMat,JSYM,DLT,Drs,add)
    end if

    ! BATCH over the vectors ----------------------------

    nBatch = (nVrs-1)/nVec+1

    do iBatch=1,nBatch

      if (iBatch == nBatch) then
        JNUM = nVrs-nVec*(nBatch-1)
      else
        JNUM = nVec
      end if

      JVEC = nVec*(iBatch-1)+iVrs
      IVEC2 = JVEC-1+JNUM

      call CWTIME(TCR1,TWR1)

      call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

      if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
        rc = 77
        return
      end if

      call CWTIME(TCR2,TWR2)
      tread(1) = tread(1)+(TCR2-TCR1)
      tread(2) = tread(2)+(TWR2-TWR1)

      if (JSYM == 1) then
        ! ************ (alpha+beta) COULOMB CONTRIBUTION  ****************
        !
        ! Contraction with the density matrix
        ! -----------------------------------
        ! V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * DI(rs)
        !==========================================================

        call CWTIME(TCC1,TWC1)

        call mma_allocate(VJ,JNUM,Label='VJ')

        call DGEMV_('T',nRS,JNUM,ONE,Lrs,nRS,Drs,1,ZERO,VJ,1)

        ! FI(rs){#J} <- FI(rs){#J} + FactCI * sum_J L(rs,{#J})*V{#J}
        !===============================================================

        Fact = real(min(jVec-iVrs,1),kind=wp)

        call DGEMV_('N',nRS,JNUM,FactCI,Lrs,nRS,VJ,1,Fact,Frs,1)

        call CWTIME(TCC2,TWC2)
        tcoul(1) = tcoul(1)+(TCC2-TCC1)
        tcoul(2) = tcoul(2)+(TWC2-TWC1)

        call mma_deallocate(VJ)

      end if ! Coulomb contribution

      iSwap = 2 ! LpJ,b are returned
      ! *************** EXCHANGE CONTRIBUTIONS  ***********************

      do jDen=1,nDen

        nAux(:) = nForb(:,jDen)+nIorb(:,jDen)
        call Allocate_DT(Laq(jDen),nAux,nBas,nVec,JSYM,nSym,iSwap)

        call CWTIME(TCR3,TWR3)

        kMOs = jDen ! 1--> alpha  2-->beta MOs
        nMOs = jDen

        ! Set up the skipping flags
        ! -------------------------------------------------------------
        do i=1,nSym

          k = Mul(i,JSYM)
          iSkip(k) = min(1,nBas(i)*(nForb(k,jDen)+nIorb(k,jDen)))

        end do
        ! -------------------------------------------------------------

        ! *********************** HALF-TRANSFORMATION  ****************

        call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,POrb,Laq,DoRead)

        call CWTIME(TCR4,TWR4)
        tread(1) = tread(1)+(TCR4-TCR3)
        tread(2) = tread(2)+(TWR4-TWR3)

        if (irc /= 0) then
          rc = irc
          return
        end if

        call CWTIME(TCX1,TWX1)

        do iSyma=1,nSym

          iSymk = Mul(JSYM,iSyma)

          ! ---------------------------------------------------------------------
          ! *** Compute only the LT part of the InActive exchange matrix ********
          !
          !     FI(ab) = FI(ab) + FactXI * sum_Jk  LkJ,a * LkJ,b
          ! ---------------------------------------------------------------------
          NK = nForb(iSymk,jDen)+nIorb(iSymk,jDen)

          if (iSkip(iSymk) /= 0) then

            call DGEMM_TRI('T','N',nBas(iSyma),nBas(iSyma),NK*JNUM,FactXI,Laq(jDen)%SB(iSymk)%A3,NK*JNUM,Laq(jDen)%SB(iSymk)%A3, &
                           NK*JNUM,One,FLT(jDen)%SB(iSyma)%A1,nBas(iSyma))

          end if

          ! --------------------------------------------------------------------
        end do  !loop over MOs symmetries

        call CWTIME(TCX2,TWX2)
        texch(1) = texch(1)+(TCX2-TCX1)
        texch(2) = texch(2)+(TWX2-TWX1)

        call Deallocate_DT(Laq(jDen))
      end do   ! loop over densities

      ! --------------------------------------------------------------------
      ! --------------------------------------------------------------------

    end do ! end batch loop

    if (JSYM == 1) then
      ! backtransform fock matrix to full storage
      add = .true.
      nMat = 1
      do iDen=1,nDen
        call swap_rs2full(irc,iLoc,nRS,nMat,JSYM,FLT(iDen),Frs,add)
      end do
    end if

    ! free memory
    call mma_deallocate(Lrs)

    if (JSYM == 1) then
      call mma_deallocate(Frs)
      call mma_deallocate(Drs)
    end if

  end do ! loop over red sets

end do ! loop over JSYM

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky SCF timing from '//SECNAM
  write(u6,CFmt) '------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Fock matrix construction        CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ/TRANSFORM VECTORS                    ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COULOMB                                   ',tcoul(1),tcoul(2)
  write(u6,'(2x,A26,2f10.2)') 'EXCHANGE                                  ',texch(1),texch(2)
  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

! Print the Fock-matrix
#ifdef _DEBUGPRINT_
if (Debug) then ! to avoid double printing in SCF-debug

  write(u6,'(6X,A)') 'TEST PRINT FROM '//SECNAM
  write(u6,'(6X,A)')
  write(u6,'(6X,A)') '***** FOCK MATRIX AO-BASIS ***** '
  do jDen=1,nDen
    if (nDen == 2) then
      if (jden == 1) write(u6,'(6X,A)') '******** ALPHA SPIN ******** '
      if (jden == 2) write(u6,'(6X,A)') '******** BETA SPIN ********* '
    end if
    do ISYM=1,NSYM
      if (NBAS(ISYM) > 0) then
        write(u6,'(6X,A)')
        write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
        call TRIPRT('','',FLT(jDen)%SB(ISYM)%A1,NBAS(ISYM))
      end if
    end do
  end do

end if
#endif

rc = 0

return

end subroutine CHO_FSCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ChkLbl(Lbl,List,nList)
      Character*(*) Lbl,List(nList)
      Character*72 Warning
*
      Do 10 iList = 1, nList
         If (Lbl.Eq.List(iList)) then
            Write (Warning,'(A,A)') 'ChkLbl: Duplicate label;'//
     &                 ' Lbl=',Lbl
            Call WarningMessage(2,Warning)
            Call Quit_OnUserError()
         End If
 10   Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine map31(a,b,dimp,dimq,dimr,p,q,r,nfact)
! mapping A(p1,q1,r1) -> nfact*B(p2,q2,r2)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: a(*)
real(kind=wp), intent(_OUT_) :: b(*)
integer(kind=iwp), intent(in) :: dimp, dimq, dimr, p, q, r, nfact
integer(kind=iwp) :: dim_(3)

dim_(p) = dimp
dim_(q) = dimq
dim_(r) = dimr
call map32(a,b,dimp,dimq,dimr,dim_(1),dim_(2),dim_(3),p,q,nfact)

return

end subroutine map31

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine VeInt( &
#                define _CALLING_
#                include "int_interface.fh"
                )
!***********************************************************************
!                                                                      *
! Object: to compute the velocity integrals with the Gauss-Hermite     *
!         quadrature.                                                  *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, Sweden, January '91                  *
!***********************************************************************

use Her_RW, only: HerR, HerW, iHerR, iHerW
use Index_Functions, only: nTri_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
#include "int_interface.fh"
#include "print.fh"
integer(kind=iwp) :: iBeta, iComp, iDCRT(0:7), ipAxyz, ipB, ipBOff, ipBxyz, ipQxyz, ipRes, iPrint, ipRxyz, ipVxyz, iRout, &
                     iStabO(0:7), lDCRT, llOper, LmbdT, nDCRT, nip, nOp, nStabO
logical(kind=iwp) :: ABeq(3)
integer(kind=iwp), external :: NrOpr

#include "macros.fh"
unused_var(Alpha)
unused_var(ZInv)
unused_var(nOrdOp)
unused_var(PtChrg)
unused_var(iAddPot)

iRout = 195
iPrint = nPrint(iRout)
ABeq(:) = A == RB

nip = 1
ipAxyz = nip
nip = nip+nZeta*3*nHer*(la+1)
ipBxyz = nip
nip = nip+nZeta*3*nHer*(lb+2)
ipRxyz = nip
nip = nip+nZeta*3*nHer
ipQxyz = nip
nip = nip+nZeta*3*(la+1)*(lb+2)
ipVxyz = nip
nip = nip+nZeta*3*(la+1)*(lb+1)
ipB = nip
nip = nip+nZeta
ipRes = nip
nip = nip+nZeta*nTri_Elem1(la)*nTri_Elem1(lb)*nComp
if (nip-1 > nArr*nZeta) then
  call WarningMessage(2,'VeInt: nip-1 > nArr*nZeta')
  write(u6,*) ' nArr is Wrong! ',nip-1,' > ',nArr*nZeta
  write(u6,*) ' Abend in VeInt'
  call Abend()
end if

if (iPrint >= 49) then
  call RecPrt(' In VeInt: A',' ',A,1,3)
  call RecPrt(' In VeInt: RB',' ',RB,1,3)
  call RecPrt(' In VeInt: Ccoor',' ',Ccoor,1,3)
  call RecPrt(' In VeInt: P',' ',P,nZeta,3)
  write(u6,*) ' In VeInt: la,lb=',la,lb
end if

rFinal(:,:,:,:) = Zero

! Compute the cartesian values of the basis functions angular part

call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),la,HerR(iHerR(nHer)),nHer,ABeq)
call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),lb+1,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the contribution from the multipole moment operator

ABeq(:) = .false.
call CrtCmp(Zeta,P,nZeta,Ccoor,Array(ipRxyz),0,HerR(iHerR(nHer)),nHer,ABeq)

! Compute the cartesian components for the multipole moment
! integrals. The integrals are factorized into components.

call Assmbl(Array(ipQxyz),Array(ipAxyz),la,Array(ipRxyz),0,Array(ipBxyz),lb+1,nZeta,HerW(iHerW(nHer)),nHer)

! Compute the cartesian components for the velocity integrals.
! The velocity components are linear combinations of overlap components.

ipBOff = ipB-1
do iBeta=1,nBeta
  Array(ipBOff+1:ipBOff+nAlpha) = Beta(iBeta)
  ipBOff = ipBOff+nAlpha
end do

call VelInt(Array(ipVxyz),Array(ipQxyz),la,lb,Array(ipB),nZeta)

! Combine the cartesian components to the full one electron integral.

call CmbnVe(Array(ipQxyz),nZeta,la,lb,0,Zeta,rKappa,Array(ipRes),nComp,Array(ipVxyz))

llOper = lOper(1)
do iComp=2,nComp
  llOper = ior(llOper,lOper(iComp))
end do
call SOS(iStabO,nStabO,llOper)
call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)

do lDCRT=0,nDCRT-1

  ! Accumulate contributions

  nOp = NrOpr(iDCRT(lDCRT))
  call SymAdO(Array(ipRes),nZeta,la,lb,nComp,rFinal,nIC,nOp,lOper,iChO,One)

end do

return

end subroutine VeInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LU2DESC(Lu,Desc)
      Implicit Integer (A-Z)
#include "ctl.fh"

      Integer handle,n

      handle=lu2handle(Lu)

      n=1
10    If(CtlBlk(pHndle,n).ne.handle) Then
        n=n+1
        If(n.gt.MxFile) Then
           Return
        End If
        Go To 10
      End If
      nFile=n
      Desc=CtlBlk(pDesc,nFile)

      Return
      End


      integer function lu2handle(lu)

#include "fio.fh"

      integer lu

      lu2handle=FSCB(lu)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine int_sort()

use gugaci_global, only: intind_abkk, intind_iaqq, intspace_abkk, LuCiInt, maxintseg, norb_dz, norb_ext, norb_frz, norb_inn, &
                         viasum_0, viasum_1, vijkk_0sum, vijkk_1sum, vint_ci
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: ia, ia0, idisk, idorbint, idum(1), idx(4), intpos, intposbase, intspace, ivalue, lra, lri, lrk, numb
real(kind=wp) :: etime, stime, time
real(kind=wp), external :: c_time

idx = 0
stime = c_time()

!estimate the largest block of integrals, notice we do not use symmetry
!here
if (norb_ext > norb_inn) then
  ! (ab|cd)
  numb = norb_ext*(norb_ext+1)/2
  numb = numb*(numb+1)/2+norb_ext*numb
else
  ! (ii|ab)
  numb = norb_inn*(norb_inn+1)/2
  numb = numb*norb_ext*(norb_ext+1)/2
end if
! (ia|bc)+(ij|ka)
lra = norb_inn*norb_ext*(norb_ext+1)*norb_ext/2+norb_inn*(norb_inn+1)*norb_inn*norb_ext/2
if (lra > numb) numb = lra

call mma_allocate(vint_ci,numb,label='vint_ci')
vint_ci(:) = Zero
numb = 0
write(u6,900)
call int_index(numb)
#ifdef MOLPRO
call intrd()
#else
call intrd_molcas()
#endif
! --------     vtint(*)-->vint_ci(*)    ------------
numb = 1
call int_sort_inn(numb)         !_ext_0  (ijkl,ijkk,iijj)
idisk = 0
call idafile(luciint,1,idx,4,idisk)
idx(1) = idisk
numb = numb-1
idum(1) = numb
call idafile(luciint,1,idum,1,idisk)
call ddafile(luciint,1,vint_ci,numb,idisk)
write(u6,902) numb
maxintseg = numb

vint_ci(:) = Zero
numb = 1
call int_sort_inn_1(numb)       !_ext_3_1  (iabc and iaqq)
call int_sort_inn_3(numb)       !_ext_1    (ijka)
idx(2) = idisk
numb = numb-1
idum(1) = numb
call idafile(luciint,1,idum,1,idisk)
call ddafile(luciint,1,vint_ci,numb,idisk)
write(u6,903) numb
if (numb > maxintseg) then
  maxintseg = numb
end if

! sum over iaqq
viasum_0(1:norb_inn,1:norb_ext) = Zero
viasum_1(1:norb_inn,1:norb_ext) = Zero
do lri=norb_frz+1,norb_inn
  ia0 = (lri-1)*norb_ext
  do lra=1,norb_ext
    ia = ia0+lra
    intposbase = intind_iaqq(ia)
    if (intposbase == 0) cycle
    do lrk=1,norb_dz
      idorbint = lrk*2-2
      intpos = intposbase+idorbint
      viasum_0(lri,lra) = viasum_0(lri,lra)+vint_ci(intpos)
      viasum_1(lri,lra) = viasum_1(lri,lra)+vint_ci(intpos+1)
    end do
  end do
end do

vint_ci(:) = Zero
numb = 1
call int_sort_inn_2(numb)   !_ext_2_1  (ijcc, ijab, abkk)
idx(3) = idisk
numb = numb-1
idum(1) = numb
call idafile(luciint,1,idum,1,idisk)
call ddafile(luciint,1,vint_ci,numb,idisk)
write(u6,904) numb
if (numb > maxintseg) then
  maxintseg = numb
end if

! sum over (abkk)
intspace = intspace_abkk(1)
intpos = intind_abkk(1)
vijkk_0sum(1:intspace) = Zero
vijkk_1sum(1:intspace) = Zero
do lrk=1,norb_dz
  do ivalue=1,intspace
    vijkk_0sum(ivalue) = vijkk_0sum(ivalue)+vint_ci(intpos)
    vijkk_1sum(ivalue) = vijkk_1sum(ivalue)+vint_ci(intpos+1)
    intpos = intpos+2
  end do
end do

vint_ci(:) = Zero
numb = 1
call int_sort_ext(numb)         !_ext_4_3_2  (abcd,abcc,aabb)
idx(4) = idisk
numb = numb-1
idum(1) = numb
call idafile(luciint,1,idum,1,idisk)
call ddafile(luciint,1,vint_ci,numb,idisk)
write(u6,905) numb
if (numb > maxintseg) then
  maxintseg = numb
end if

idisk = 0
call idafile(luciint,1,idx,4,idisk)

write(u6,910)
call mma_deallocate(vint_ci)

etime = c_time()
time = etime-stime
write(u6,912) time

return

900 format(1x,'start integral sorting',/,1x,'start reading integral file',/)
!901 format(1x,'end reading integral file',/)
902 format(1x,'number of integrals in internal space is ',i8)
903 format(1x,'number of integrals which have one or three indices in external space is ',i8)
904 format(1x,'number of integrals which have two indices in external space is ',i8)
905 format(1x,'number of integrals in external space is ',i8)
910 format(1x,/,1x,'end of integral sorting')
912 format(1x,'total wall clock time for integral sorting=',f8.2,' s',/)

end subroutine int_sort

!subroutine blocks()
!
!use gugaci_global, only: ng_sm, nlsm_all
!use Symmetry_Info, only: Mul
!use Definitions, only: iwp, u6
!
!implicit none
!integer(kind=iwp) :: i, iblktb(5,106), ip, ipq, iq, iqm, ir, irm, is, ism, ispq, ispqr, j, nblock, nint1, nint12, nint2, nintb, &
!                     npp, npq, nrr, nrs
!
!! ----- 1 - electron integrals -----
!nint1 = 0
!do ip=1,ng_sm
!  nint1 = nint1+((nlsm_all(ip)+1)*nlsm_all(ip))/2
!end do
!
!! ----- 2 - electron integrals -----
!nint2 = 0
!nblock = 0
!do ip=1,ng_sm
!  npp = (nlsm_all(ip)+1)*nlsm_all(ip)/2
!  nintb = npp*(npp-1)/2
!  nint2 = nint2+nintb
!  nblock = nblock+1
!  do i=1,4
!    iblktb(i,nblock) = ip
!  end do
!  iblktb(5,nblock) = nint2
!end do
!do ip=1,ng_sm
!  npp = (nlsm_all(ip)+1)*nlsm_all(ip)/2
!  irm = ip
!  do ir=1,irm-1
!    nrr = (nlsm_all(ir)+1)*nlsm_all(ir)/2
!    nintb = npp*nrr
!    nint2 = nint2+nintb
!    nblock = nblock+1
!    iblktb(1,nblock) = ip
!    iblktb(2,nblock) = ip
!    iblktb(3,nblock) = ir
!    iblktb(4,nblock) = ir
!    iblktb(5,nblock) = nint2
!  end do
!end do
!do ip=1,ng_sm
!  iqm = ip
!  do iq=1,iqm-1
!    ipq = nlsm_all(ip)*nlsm_all(iq)
!    nintb = ipq*(ipq-1)/2
!    nint2 = nint2+nintb
!    nblock = nblock+1
!    iblktb(1,nblock) = ip
!    iblktb(2,nblock) = iq
!    iblktb(3,nblock) = ip
!    iblktb(4,nblock) = iq
!    iblktb(5,nblock) = nint2
!  end do
!end do
!do ip=4,8
!  if (nlsm_all(ip) == 0) cycle
!  iqm = ip
!  do iq=1,iqm-1
!    if (nlsm_all(iq) == 0) cycle
!    npq = nlsm_all(ip)*nlsm_all(iq)
!    ispq = Mul(ip,iq)
!    irm = ip
!    do ir=1,irm-1
!      if (nlsm_all(ir) == 0) cycle
!      ispqr = Mul(ispq,ir)
!      ism = ir
!      if (ip == ir) ism = iq
!      do is=1,ism-1
!        if (nlsm_all(is) == 0) cycle
!        if (is /= ispqr) cycle
!        nrs = nlsm_all(ir)*nlsm_all(is)
!        nintb = npq*nrs
!        nint2 = nint2+nintb
!        nblock = nblock+1
!        iblktb(1,nblock) = ip
!        iblktb(2,nblock) = iq
!        iblktb(3,nblock) = ir
!        iblktb(4,nblock) = is
!        iblktb(5,nblock) = nint2
!      end do
!    end do
!  end do
!end do
!nint12 = nint1+nint2
!
!write(u6,100) nint1,nint2,nint12
!!write(12,100) nint1,nint2,nint12
!write(u6,200) nint1
!!write(12,200) nint1
!write(u6,300) (j,(iblktb(i,j),i=1,5),j=1,nblock)
!!write(12,300) (j,(iblktb(i,j),i=1,5),j=1,nblock)
!
!return
!
!100 format(' ',1x/2x,'number of 1-electron integrals  :',i9/2x,'number of 2-electron integrals  :',i9/2x, &
!           'total number of integrals       :',i9)
!200 format(' ',1x/2x,'1-electron blocks  :   1 to',i8/2x,29(1h*))
!300 format(' ',1x/2x,'2-electron block description  :'/2x,40(1h*)/2x,50(3('(',i3,')',4i2,i8,3x)/2x))
!
!end subroutine blocks

!subroutine ff(i,j)
!
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(out) :: i
!integer(kind=iwp), intent(in) :: j
!integer(kind=iwp) :: iq, j0
!
!i = 0
!do iq=1,j
!  j0 = iq*(iq-1)/2+iq
!  if (j0 == j) then
!    i = iq
!    exit
!  end if
!end do
!
!return
!
!end subroutine ff

subroutine int_sort_ext(ii)         !_ext_4_3_2

use gugaci_global, only: ibsm_ext, iesm_ext, ip2_aa_ext_base, ip2_dd_ext_base, ip3_abd_ext_base, ip4_abcd_ext_base, jp2, jp3, &
                         ng_sm, nlsm_ext, norb_ext, norb_number, np3_abd_ext, vint_ci, voint
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: ii
integer(kind=iwp) :: ia, iaend, iasta, ib, ibend, ibsta, ic, icend, icsta, id, idend, idsta, isma, ja, jb, lra, lrb, lrc, lrd, &
                     lsma, lsmb, lsmc, lsmcd, lsmd, lsmtmp(8), na
real(kind=wp), external :: vfutei

! _002_aa_
ip2_aa_ext_base = ii
do lsma=1,ng_sm
  iasta = ibsm_ext(lsma)
  ibsta = iasta+1
  ibend = iesm_ext(lsma)
  do ib=ibsta,ibend
    jb = norb_number(ib)
    do ia=iasta,ib-1
      ja = norb_number(ia)
      vint_ci(ii) = voint(jb,ja)          !(ja|jb)
      !write(10,'(2x,a20,i8,f16.8)') '  int_sort_002',ii,vint_ci(ii)
      ii = ii+1
    end do
  end do
end do
! _002_dd_
ip2_dd_ext_base = ii
!write(10,'(2x,a20,i8)') ' ip2_dd_ext_base=',ii
do ib=2,norb_ext
  jb = norb_number(ib)
  do ia=1,ib-1
    ja = norb_number(ia)
    vint_ci(ii) = voint(ja,jb)   !(ja,jb|ja,jb)
    !write(u6,'(i2,2x,i2)') ja,jb
    !write(u6,'(2x,a20,i8,f16.8)') '  int_sort_002',ii,vint_ci(ii)
    ii = ii+1
  end do
end do
!_003
ip3_abd_ext_base = ii
!write(10,'(2x,a20,i8)') ' ip3_abd_ext_base=',ii

do ic=1,norb_ext
  lrc = norb_number(ic)
  !ip3_abd_ext_base(ic) = ii
  do lsma=1,ng_sm
    iasta = ibsm_ext(lsma)
    !iaend = iesm_ext(lsma)-1
    ibsta = iasta+1
    ibend = iesm_ext(lsma)
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,ib-1
        lra = norb_number(ia)
        vint_ci(ii) = vfutei(lra,lrc,lrb,lrc)
        vint_ci(ii+1) = vfutei(lra,lrb,lrc,lrc)
        !write(10,'(2x,4i6,i8,2f16.8)') lra,lrb,lrc,lrc,ii,vint_ci(ii),vint_ci(ii+1)
        ii = ii+2
      end do
    end do
  end do
end do
np3_abd_ext = 0
do isma=1,ng_sm
  na = nlsm_ext(isma)
  if (na <= 0) cycle
  np3_abd_ext = np3_abd_ext+na*(na-1)
end do
!_004
!==================================
!    la<lb<lc<ld
!===================================
! 1. ext _abcd_
!ip4_abcd_ext_base = ii
do lsmd=1,ng_sm
  idsta = ibsm_ext(lsmd)
  idend = iesm_ext(lsmd)
  do lsmc=1,lsmd
    icsta = ibsm_ext(lsmc)
    icend = iesm_ext(lsmc)
    if (lsmc == lsmd) idsta = idsta+1
    lsmcd = Mul(lsmc,lsmd)
    do lsmb=1,lsmc
      lsma = Mul(lsmb,lsmcd)
      if (lsma > lsmb) cycle
      ibsta = ibsm_ext(lsmb)
      ibend = iesm_ext(lsmb)
      iasta = ibsm_ext(lsma)
      iaend = iesm_ext(lsma)
      if (lsmd == lsmb) idsta = idsta+1
      if (lsmc == lsmb) icsta = icsta+1
      if (lsmd == lsma) idsta = idsta+1
      if (lsmc == lsma) icsta = icsta+1
      if (lsmb == lsma) ibsta = ibsta+1
      lsmtmp = lsma+jp2(lsmb)+jp3(lsmc)
      ip4_abcd_ext_base(lsmtmp) = ii
      !write(10,'(2x,a20,2i8)') ' ip4_abcd_ext_base=',lsmtmp,ii
      do id=idsta,idend
        lrd = norb_number(id)
        do ic=icsta,min(id-1,icend)
          lrc = norb_number(ic)
          do ib=ibsta,min(ic-1,ibend)
            lrb = norb_number(ib)
            do ia=iasta,min(ib-1,iaend)
              lra = norb_number(ia)
              vint_ci(ii) = vfutei(lra,lrb,lrc,lrd)       !lra>lrb>lrc>lrd
              vint_ci(ii+1) = vfutei(lra,lrc,lrb,lrd)
              vint_ci(ii+2) = vfutei(lra,lrd,lrc,lrb)
              ii = ii+3
            end do
          end do
        end do
      end do

    end do
  end do
end do

end subroutine int_sort_ext

!===================== ext_2_1 sta =====================================

subroutine int_sort_inn_2(ii)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_abkk, intspace_abkk, lsm_inn, ng_sm, norb_frz, norb_inn, norb_number, vint_ci
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: ii
integer(kind=iwp) :: ibend, ibsta, ira, irb, ismab, lmb, lra, lrb, lri, lrj, lsmi, lsmij, lsmj
real(kind=wp), external :: vfutei

! (ijcc,ijab)
do ismab=1,ng_sm
  !ip2_ab_inn_base(ismab) = ii
  do lri=norb_frz+1,norb_inn-1
    lsmi = lsm_inn(lri)
    do lrj=lri+1,norb_inn
      lsmj = lsm_inn(lrj)
      lsmij = Mul(lsmi,lsmj)
      if (ismab /= lsmij) cycle
      call int_ext_2_1(lri,lrj,lsmij,ii)
    end do
  end do
end do

! (abkk)
do lri=1,norb_inn
  intind_abkk(lri) = ii
  intspace_abkk(lri) = 0
  do lmb=1,ng_sm
    ibsta = ibsm_ext(lmb)
    ibend = iesm_ext(lmb)
    do irb=ibsta,ibend
      lrb = norb_number(irb)
      do ira=ibsta,irb-1
        lra = norb_number(ira)
        intspace_abkk(lri) = intspace_abkk(lri)+1
        vint_ci(ii) = vfutei(lra,lri,lrb,lri)
        vint_ci(ii+1) = vint_ci(ii)-2*vfutei(lra,lrb,lri,lri)
        !write(u6,'(2x,4i6,i8,3f16.8)')lra,lrb,lri,lri,ii,vint_ci(ii),vint_ci(ii+1)
        ii = ii+2
      end do
    end do
  end do
end do

return

end subroutine int_sort_inn_2

subroutine int_ext_2_1(lri,lrj,lsmij,ii)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_ijab, intind_ijcc, intspace_ijab, intspace_ijcc, ng_sm, ngw2, norb_ext, &
                         norb_frz, norb_number, vint_ci
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, lsmij
integer(kind=iwp), intent(inout) :: ii
integer(kind=iwp) :: ic, icend, icsta, id, idend, idsta, ij, jc, jd, lrc, lsmc, lsmd
real(kind=wp), external :: vfutei

!write(10,*) '     start intind_ijab',lri,lrj,ii
ij = lri-norb_frz+ngw2(lrj-norb_frz)
if (lsmij == 1) then       !ijcc
  !write(10,*) '     start intind_ijcc',ii
  intind_ijcc(ij) = ii
  intspace_ijcc(ij) = 0
  do ic=1,norb_ext
    intspace_ijcc(ij) = intspace_ijcc(ij)+1
    lrc = norb_number(ic)
    vint_ci(ii) = vfutei(lrj,lrc,lri,lrc)
    vint_ci(ii+1) = vfutei(lrj,lri,lrc,lrc)
    !write(10,'(2x,4i6,i8,3f16.8)') lrj,lri,lrc,lrc,ii,vint_ci(ii),vint_ci(ii+1)
    ii = ii+2
  end do
end if
intind_ijab(ij) = ii
intspace_ijab(ij) = 0
do lsmc=1,ng_sm
  lsmd = Mul(lsmij,lsmc)
  if (lsmd > lsmc) cycle
  icsta = ibsm_ext(lsmc)
  icend = iesm_ext(lsmc)
  idsta = ibsm_ext(lsmd)
  idend = iesm_ext(lsmd)
  if (lsmc == lsmd) icsta = icsta+1
  do ic=icsta,icend
    jc = norb_number(ic)
    do id=idsta,min(idend,ic-1)
      intspace_ijab(ij) = intspace_ijab(ij)+1
      jd = norb_number(id)
      vint_ci(ii) = vfutei(jd,jc,lrj,lri)
      vint_ci(ii+1) = vfutei(jd,lrj,jc,lri)
      vint_ci(ii+2) = vfutei(jd,lri,lrj,jc)
      !write(10,'(2x,4i6,i8,3f16.8)') jd,jc,lrj,lri,ii,vint_ci(ii),vint_ci(ii+1),vint_ci(ii+2)
      ii = ii+3
    end do
  end do
end do

return

end subroutine int_ext_2_1

!===================== ext_2_1 end =====================================

!===================== ext_1 sta ========================================

subroutine int_sort_inn_3(ii)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_ijka, lsm_inn, ngw2, ngw3, norb_frz, norb_inn, norb_number, vint_ci
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: ii
integer(kind=iwp) :: ia, iaend, iasta, ijk, ja, lri, lrj, lrk, lsmd, lsmi, lsmij, lsmj, lsmk
real(kind=wp), external :: vfutei

!write(10,'(2x,a20,i8)') ' int_inn_3_base=',ii
!write(10,*) '     start intind_ijka',ii
do lri=norb_frz+1,norb_inn-2
  lsmi = lsm_inn(lri)
  do lrj=lri+1,norb_inn-1
    lsmj = lsm_inn(lrj)
    lsmij = Mul(lsmi,lsmj)
    do lrk=lrj+1,norb_inn
      lsmk = lsm_inn(lrk)
      lsmd = Mul(lsmij,lsmk)
      ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrk-norb_frz)
      intind_ijka(ijk) = ii
      iasta = ibsm_ext(lsmd)
      iaend = iesm_ext(lsmd)
      do ia=iasta,iaend
        ja = norb_number(ia)
        vint_ci(ii) = vfutei(ja,lrk,lrj,lri)
        vint_ci(ii+1) = vfutei(ja,lrj,lrk,lri)
        vint_ci(ii+2) = vfutei(ja,lri,lrk,lrj)
        !write(10,'(2x,4i6,i8,3f16.8)')ja,lrk,lrj,lri,ii,vint_ci(ii),vint_ci(ii+1),vint_ci(ii+2)
        ii = ii+3
      end do
    end do
  end do
end do

end subroutine int_sort_inn_3

!===================== _ext_1 end ======================================

subroutine int_ext_3_2_1(lri,lsmi,ii)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_iabc, intind_iaqq, nabc, ng_sm, ngw2, ngw3, norb_ext, norb_inn, norb_number, &
                         vint_ci
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lsmi
integer(kind=iwp), intent(inout) :: ii
integer(kind=iwp) :: iabc, iabc0, ib, ib0, ibend, ibsta, icend, icsta, idend, idsta, irb, irc, ird, lrb, lrc, lrd, lsmb, lsmbc, &
                     lsmc, lsmd, nb, nc, nd
real(kind=wp), external :: vfutei

!write(10,*) '   int_ext_3_2_1'
iabc0 = (lri-1)*nabc
!write(10,*) '     start intind_iabc',ii
do lsmd=1,ng_sm
  lsmbc = Mul(lsmi,lsmd)
  do lsmc=1,lsmd
    lsmb = Mul(lsmbc,lsmc)
    if (lsmb > lsmc) cycle
    idsta = ibsm_ext(lsmd)
    idend = iesm_ext(lsmd)
    icsta = ibsm_ext(lsmc)
    icend = iesm_ext(lsmc)
    ibsta = ibsm_ext(lsmb)
    ibend = iesm_ext(lsmb)
    if (lsmb == lsmc) icsta = icsta+1
    if (lsmc == lsmd) idsta = idsta+1
    if (lsmb == lsmd) idsta = idsta+1
    do ird=idsta,idend
      lrd = norb_number(ird)
      nd = ngw3(ird)
      do irc=icsta,min(icend,ird-1)
        lrc = norb_number(irc)
        nc = ngw2(irc)
        do irb=ibsta,min(ibend,irc-1)
          lrb = norb_number(irb)
          nb = irb
          iabc = iabc0+nb+nc+nd
          intind_iabc(iabc) = ii
          vint_ci(ii) = vfutei(lrb,lrc,lrd,lri)
          vint_ci(ii+1) = vfutei(lrb,lrd,lrc,lri)
          vint_ci(ii+2) = vfutei(lrb,lri,lrd,lrc)
          ii = ii+3
        end do
      end do
    end do
  end do
end do

!write(10,*) '     start intind_iaqq',ii
ib0 = (lri-1)*norb_ext
lsmb = lsmi                       !3_ibqq
ibsta = ibsm_ext(lsmb)
ibend = iesm_ext(lsmb)
do irb=ibsta,ibend
  lrb = norb_number(irb)
  ib = ib0+irb
  intind_iaqq(ib) = ii
  do lrc=1,norb_inn
    vint_ci(ii) = vfutei(lrb,lrc,lri,lrc)
    vint_ci(ii+1) = vfutei(lrb,lri,lrc,lrc)
    ii = ii+2
  end do
  do irc=norb_ext,1,-1
    lrc = norb_number(irc)
    vint_ci(ii) = vfutei(lrb,lrc,lri,lrc)
    vint_ci(ii+1) = vfutei(lrb,lri,lrc,lrc)
    !write(u6,'(2x,4i6,i8,3f16.8)')lrb,lri,lrc,lrc,ii,vint_ci(ii),vint_ci(ii+1)
    ii = ii+2
  end do
end do

end subroutine int_ext_3_2_1

subroutine int_sort_inn_1(ii)

use gugaci_global, only: lsm_inn, norb_frz, norb_inn
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: ii
integer(kind=iwp) :: lri, lsmi

call determine_para_array_for_int1ind()

do lri=norb_frz+1,norb_inn
  lsmi = lsm_inn(lri)
  call int_ext_3_2_1(lri,lsmi,ii)
end do

end subroutine int_sort_inn_1

!===================== ext_3_2_1 end ===================

function list3(i,j,k)

use gugaci_global, only: loij, ngw2
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: list3
integer(kind=iwp), intent(in) :: i, j, k
integer(kind=iwp) :: nij

nij = i+ngw2(j)
list3 = loij(nij)+2*(k-1)

return

end function list3

function list4(ld,lc,lb,la)

use gugaci_global, only: loijk, ncibl, ngw2, ngw3
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: list4
integer(kind=iwp), intent(in) :: ld, lc, lb, la
integer(kind=iwp) :: lra, njkl

lra = ncibl(la)
njkl = ld+ngw2(lc)+ngw3(lb)
list4 = loijk(njkl)+3*(lra-1)

return

end function list4

subroutine int_sort_inn(numb)

use gugaci_global, only: loij, loijk, lsm_inn, ncibl, ngw2, ngw3, norb_inn, vint_ci
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: numb
integer(kind=iwp) :: i, j, k, la, lb, lc, ld, lra, ms, msa, msb, msc, mscd, msd, msob(120), nij, njkl, nolra
real(kind=wp), external :: vfutei

msob = 0
do lra=norb_inn,1,-1
  ms = lsm_inn(lra)
  msob(ms) = msob(ms)+1
  ncibl(lra) = msob(ms)
end do
!=======================================================================
!write(u6,'(1x,14i3)') (ncibl(i),i=1,norb_inn)

numb = 1
do i=1,norb_inn-1
  do j=i+1,norb_inn
    if (lsm_inn(i) /= lsm_inn(j)) cycle

    nij = i+ngw2(j)
    loij(nij) = numb
    do k=1,norb_inn
      vint_ci(numb) = vfutei(j,k,i,k)
      vint_ci(numb+1) = vfutei(j,i,k,k)
      !write(u6,'(2x,4i6,i8,3f16.8)') i,j,k,k,numb,vint_ci(numb),vint_ci(numb+1)
      numb = numb+2
    end do
  end do
end do
!write(u6,*) 'num_inn',numb
!write(u6,*) loij(1:8)
!call abend()

!=======================================================================
! la<lb<lc<ld
do ld=1,norb_inn-3
  do lc=ld+1,norb_inn-2
    msd = lsm_inn(ld)
    msc = lsm_inn(lc)
    mscd = Mul(msd,msc)
    do lb=lc+1,norb_inn-1
      msb = lsm_inn(lb)
      msa = Mul(mscd,msb)

      njkl = ld+ngw2(lc)+ngw3(lb)
      loijk(njkl) = numb

      nolra = 0
      do la=norb_inn,lb+1,-1
        if (lsm_inn(la) /= msa) cycle
        nolra = nolra+1
        !list = loijk(njkl)+3*(nolra-1)

        !write(u6,'(2x,4i3,2i7)')  la,lb,lc,ld,list,numb

        vint_ci(numb) = vfutei(la,lc,lb,ld)        !tmp stop
        vint_ci(numb+1) = vfutei(la,lb,lc,ld)
        vint_ci(numb+2) = vfutei(la,ld,lc,lb)
        !write(10,'(2x,4i6,i8,3f16.8)')la,lb,lc,ld,numb,vint_ci(numb),vint_ci(numb+1),vint_ci(numb+2)
        numb = numb+3
      end do
    end do
  end do
end do

return
!=======================================================================

end subroutine int_sort_inn

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Create_Chunk(ip_iMap,ip_Chunk,LenVec,NumVec,IncVec)
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
#ifdef _MOLCAS_MPP_
#include "para_info.fh"
#include "mafdecls.fh"
      External  ga_create_irreg
      Logical   ga_create_irreg, ok
      Integer myMap(2)
*
      If (Is_Real_Par()) Then
         Call GetMem('iMap','Allo','Inte',ip_iMap,nProcs+1)
         Call IZero(iWork(ip_iMap),nProcs+1)
*
         FullSize=DBLE(LenVec*NumVec)
         Call GetMem('MemMax','Max','Real',iDummy,MaxMem)
         iWork(ip_iMap+MyRank) = MaxMem
         Call GAIGOP(iWork(ip_iMap),nProcs,'+')
         TotalMemory=0.0D0
         itmp=iWork(ip_iMap)
*
*        Find the smallest possible memory allocation!
*
         Do i = 1, nProcs-1
            itmp = Min(itmp,iWork(ip_iMap+i))
         End Do
         TotalMemory=DBLE(itmp)*DBLE(nProcs)
*
*        Compute the number of vectors to handle at the time
*
         If (TotalMemory.gt.FullSize) Then
*
            IncVec = NumVec
*
         Else
*
            IncVec = INT ( DBLE(NumVec) *(TotalMemory/FullSize))
*
         End If
         If (NumVec.le.0) Then
            Call WarningMessage(2,
     &                  'Create_Chunk: Failure NumVec.le.0')
            Write (6,*) 'NumVec=',NumVec
            Call Abend()
         End If
         If (IncVec.le.0) Then
            Call WarningMessage(2,
     &                  'Create_Chunk: Failure IncVec.le.0')
            Write (6,*) 'FullSize=',FullSize
            Write (6,*) 'NumVec=',NumVec
            Write (6,*) 'LenVec=',LenVec
            Write (6,*) 'TotalMemory=',TotalMemory
            Write (6,*) 'Local size of memory'
            Write (6,*) (iWork(ip_iMap+i),i=0,nProcs-1)
            Write (6,*) 'iTmp=',iTmp
            Call Abend()
         End If
*
*        Compute the number of vectors per node, This also defines
*        the Map array.
*
         iNode0=0
         iStart = 1
         Do iNode = 0, nProcs-1
            If (iStart.eq.1) iNode0=iNode
            iWork(ip_iMap+iNode) = iStart
            iStart = iStart + Max((IncVec+iNode)/nProcs,1)
         End Do
         iWork(ip_iMap+nProcs)=iStart
*
C        Call Put_iArray('DistVec',iWork(ip_iMap),nProcs+1)
*
         nBlocks=nProcs-iNode0
         myMap(1)=1
         Ok = GA_Create_Irreg(mt_dbl,LenVec,IncVec,'Chunk',
     &                        myMap,1,
     &                        iWork(ip_iMap+iNode0),nBlocks,
     &                        ip_Chunk)
         If (.Not. Ok) Then
            Call WarningMessage(2,'Error in GA_Create_Irreg')
            Call Abend()
         End If
      Else
         ip_iMap=ip_iDummy
         Call GetMem('MemMax','Max','Real',iDummy,MaxMem)
         IncVec=Min(NumVec,MaxMem/LenVec)
         Call GetMem('Chunk','Allo','Real',ip_Chunk,LenVec*IncVec)
      End If
*
*                                                                      *
************************************************************************
*                                                                      *
#else
*                                                                      *
************************************************************************
*                                                                      *
      ip_iMap=ip_iDummy
      Call GetMem('MemMax','Max','Real',iDummy,MaxMem)
      IncVec=Min(NumVec,MaxMem/LenVec)
      Call GetMem('Chunk','Allo','Real',ip_Chunk,LenVec*IncVec)
*
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ireorg2(symp,typp,pup,rc)
! this routine def. summation limits for given symp and typp
! i.e. number of indices for this symmetry and typ
!
! symp  - irrep of p index (I)
! typp  - typ of p index in v2 (I)
! pup   - summation limit
! rc    - return (error) code (O)

use ccsort_global, only: noa, nob, NORB, nva, nvb
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: symp, typp
integer(kind=iwp), intent(out) :: pup, rc

rc = 0

select case (typp)
  case (1)
    pup = noa(symp)
  case (2)
    pup = nob(symp)
  case (3)
    pup = nva(symp)
  case (4)
    pup = nvb(symp)
  case (5)
    pup = norb(symp)
  case default
    rc = 1
    ! RC=1 : bad typp (Stup)
end select

return

end subroutine ireorg2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine reads or writes a record from/to the runfile.           *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund university, Sweden                                     *
! Written: December 2009                                               *
!                                                                      *
!***********************************************************************

subroutine gzRWRun(Lu,icXX,cData,nData,iDisk,RecTyp)

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use RunFile_data, only: TypDbl, TypInt, TypLgl, TypStr
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lu, icXX, nData, RecTyp
integer(kind=iwp), intent(inout) :: iDisk
!TODO: No "intent" possible, since it depends on icXX
character :: cData(*)

!----------------------------------------------------------------------*
! Read/write data from/to runfile.                                     *
!----------------------------------------------------------------------*
select case (RecTyp)
  case (TypInt)
    call c_iDaFile(Lu,icXX,cData,nData,iDisk)
  case (TypDbl)
    call c_dDaFile(Lu,icXX,cData,nData,iDisk)
  case (TypStr)
    call cDaFile(Lu,icXX,cData,nData,iDisk)
  case (TypLgl)
    call SysAbendMsg('gzRWRun','Records of logical type not implemented','Aborting')
  case default
    call SysAbendMsg('gzRWRun','Argument RecTyp is of wrong type','Aborting')
end select
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

! This is to allow type punning without an explicit interface
contains

subroutine c_iDaFile(Lu,iOpt,Buf,lBuf_,iDisk_)

  integer(kind=iwp), intent(in) :: Lu, iOpt, lBuf_
  character, target :: Buf(*)
  integer(kind=iwp), intent(inout) :: iDisk_
  integer(kind=iwp), pointer :: pBuf(:)

  call c_f_pointer(c_loc(Buf(1)),pBuf,[lBuf_])
  call iDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
  nullify(pBuf)

end subroutine c_iDaFile

subroutine c_dDaFile(Lu,iOpt,Buf,lBuf_,iDisk_)

  integer(kind=iwp), intent(in) :: Lu, iOpt, lBuf_
  character, target :: Buf(*)
  integer(kind=iwp), intent(inout) :: iDisk_
  real(kind=wp), pointer :: pBuf(:)

  call c_f_pointer(c_loc(Buf(1)),pBuf,[lBuf_])
  call dDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
  nullify(pBuf)

end subroutine c_dDaFile

end subroutine gzRWRun

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************
!  CD_InCore_p
!
!> @brief
!>   Cholesky decompose the symmetric positive (semi-)definite matrix \p X
!> @author Francesco Aquilante
!>
!> @details
!> The \p n &times; \p n matrix \p X is Cholesky decomposed and the resulting
!> \p NumCho Cholesky vectors are returned in array \p Vec. Note that \p X
!> is modified in this routine! The array \p iD(k) on exit contains
!> the index of the diagonal from which the \p k -th Cholesky
!> vector was generated. A non-zero return code signals
!> that an error has occured (\p X might e.g. be non-positive
!> (semi-)definite) and the output is ill-defined.
!>
!> @param[in,out] X      Matrix to be Cholesky decomposed
!> @param[in]     n      Linear dimension of \p X
!> @param[out]    Vec    Storage array for Cholesky vectors
!> @param[in]     MxVec  Max. number of vectors allowed
!> @param[in,out] iD     Index array for parent diagonals
!> @param[out]    NumCho Number of Cholesky vectors
!> @param[in]     Thr    Decomposition threshold (precision)
!> @param[out]    irc    Return code
!***********************************************************************

subroutine CD_InCore_p(X,n,Vec,MxVec,iD,NumCho,Thr,irc)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, MxVec
real(kind=wp), intent(inout) :: X(n,n), Vec(n,MxVec)
integer(kind=iwp), intent(inout) :: iD(MxVec)
integer(kind=iwp), intent(out) :: NumCho, irc
real(kind=wp), intent(in) :: Thr
real(kind=wp) :: Thr_
real(kind=wp), parameter :: DefThr = 1.0e-6_wp, ThrFail = -1.0e-8_wp, ThrNeg = -1.0e-13_wp

irc = 0
NumCho = 0
if (n >= 1) then
  if (MxVec > 0) then
    Thr_ = Thr
    if (Thr_ < Zero) Thr_ = DefThr
    call CD_InCore_1p(X,n,Vec,MxVec,NumCho,Thr_,ThrNeg,ThrFail,iD,irc)
  else
    irc = -1
  end if
end if

end subroutine CD_InCore_p

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine DesymD(lOper,iAng,jAng,iCmp,jCmp,iShell,jShell,
     &                  iShll,jShll,iAO,jAO,DAO,
     &                  iBas,jBas,DSO,nDSO,nOp,FactNd)
************************************************************************
*                                                                      *
* Object: desymmetrize the first order density matrix.                 *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      Use Basis_Info
      use Symmetry_Info, only: nIrrep, iChTbl, iOper, iChBas
      use SOAO_Info, only: iAOtSO
      use Real_Spherical, only: iSphCr
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 DAO(iBas*jBas,iCmp,jCmp), DSO(iBas*jBas,nDSO), Prmt(0:7)
      Integer nOp(2)
      Data Prmt/1.d0,-1.d0,-1.d0,1.d0,-1.d0,1.d0,1.d0,-1.d0/
*
*     Statement Function
*
      xPrmt(i,j) = Prmt(iAnd(i,j))
*
      iRout = 133
      iPrint = nPrint(iRout)
      iQ=0
      If (iPrint.ge.99) Then
         Write (6,*) ' lOper=',lOper
         Call RecPrt(' In DesymD: DSO',' ',DSO,iBas*jBas,nDSO)
      End If
*
      call dcopy_(iBas*jBas*iCmp*jCmp,[Zero],0,DAO,1)
      lSO = 1
      ii = iAng*(iAng+1)*(iAng+2)/6
      jj = jAng*(jAng+1)*(jAng+2)/6
      Do 100 j1 = 0, nIrrep-1
         Xa= DBLE(iChTbl(j1,nOp(1)))
         Do 200 i1 = 1, iCmp
            If (iAOtSO(iAO+i1,j1)<0) Cycle
            iChBs = iChBas(ii+i1)
            If (Shells(iShll)%Transf) iChBs = iChBas(iSphCr(ii+i1))
            pa = xPrmt(iOper(nOp(1)),iChBs)
*
            Do 300 j2 = 0, j1
               j12 = iEor(j1,j2)
               If (iAnd(lOper,2**j12).eq.0) Go To 300
               Xb = DBLE(iChTbl(j2,nOp(2)))
               jMx = jCmp
               If (iShell.eq.jShell .and. j1.eq.j2) jMx = i1
               Do 400 i2 = 1, jMx
                  If (iAOtSO(jAO+i2,j2)<0) Cycle
                  jChBs = iChBas(jj+i2)
                  If (Shells(jShll)%Transf)
     &                jChBs = iChBas(iSphCr(jj+i2))
*
                  Deg=Two
                  If (j1.eq.j2 .and. iShell.eq.jShell .and.
     &                i1.eq.i2) Deg=One
*
*-----------------Parity factor due to symmetry operations applied to
*                 angular part of the basis function.
                  FactNs = pa * xPrmt(iOper(nOp(2)),jChBs)
                  Call DaXpY_(iBas*jBas,Deg*Xa*Xb*FactNs,
     &                       DSO(1,lSO),1,
     &                       DAO(1,i1,i2),1)
                  lSO = lSO + 1
 400           Continue
 300        Continue
*
 200     Continue
 100  Continue
*
      If (FactNd.ne.One) Call DScal_(iBas*jBas*iCmp*jCmp,FactNd,DAO,1)
      If (iPrint.ge.99) Then
         Call RecPrt(' In DesymD: DAO',' ',DAO,iBas*jBas,iCmp*jCmp)
      End If
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function qcomp(alpha,dfac,n,l,t,xk)
! Compute q(n,l) scaled by sqrt(pi)*exp(-t) to prevent overflows
! arguments are alpha, xk, and t=xk**2/(4*alpha)
! No restriction on the magnitude of t
! Increase dfac array to raise n, l restrictions

use Constants, only: Zero, One, Two, Four, Pi
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: qcomp
real(kind=wp), intent(in) :: alpha, dfac(*), t, xk
integer(kind=iwp), intent(in) :: n, l
integer(kind=iwp) :: num
real(kind=wp) :: dsum, fac1, fac2, fnum, prefac, term, xc, xden, xj, xkp, xnum
real(kind=wp), parameter :: accpow = 1.0e-14_wp, accasy = 1.0e-10_wp, a1rtpi = One/sqrt(Pi), &
                            tmin(0:8) = [31.0_wp,28.0_wp,25.0_wp,23.0_wp,22.0_wp,20.0_wp,19.0_wp,18.0_wp,15.0_wp]

if ((mod(n+l,2) == 0) .and. (n > l)) then

  ! use alternating series ((n+l <= 22) .and. (l <= 10))

  if (l == 0) then
    xkp = One
  else
    xkp = (xk/(alpha+alpha))**l
  end if
  prefac = xkp*dfac(n+l+1)/((alpha+alpha)**((n-l)/2)*sqrt(Four*alpha)*dfac(l+l+3))
  num = l-n+2
  xden = (l+l+3)
  term = One
  dsum = term
  xc = -One
  do
    if (num == 0) exit
    fnum = num
    term = term*fnum*t/(xden*xc)
    xc = xc-One
    dsum = dsum+term
    num = num+2
    xden = xden+Two
  end do

  qcomp = prefac*dsum

else if (t < tmin(min(n,8))) then

  ! use power series ((n+l <= 22) .and. (l <= 10))

  if (l == 0) then
    xkp = One
  else
    xkp = (xk/(alpha+alpha))**l
  end if
  prefac = exp(-t)*xkp/(alpha+alpha)**((n-l+1)/2)
  if (mod(n+l,2) == 0) then
    prefac = prefac/sqrt(Four*alpha)
  else
    prefac = a1rtpi*prefac
  end if
  xnum = (l+n-1)
  xden = (l+l+1)
  term = dfac(l+n+1)/dfac(l+l+3)
  dsum = term
  xj = Zero
  do
    xnum = xnum+Two
    xden = xden+Two
    xj = xj+One
    term = term*t*xnum/(xj*xden)
    dsum = dsum+term
    if ((term/dsum) <= accpow) exit
  end do
  qcomp = prefac*dsum

else

  ! use asymptotic series (arbitrary n, l)

  xkp = (xk/(alpha+alpha))**(n-2)
  prefac = xkp/((alpha+alpha)*sqrt(Four*alpha))
  dsum = One
  term = One
  fac1 = (l-n+2)
  fac2 = (1-l-n)
  xc = One
  do
    term = term*fac1*fac2/(Four*xc*t)
    if (term == Zero) exit
    dsum = dsum+term
    if (abs(term/dsum) < accasy) exit
    fac1 = fac1+Two
    fac2 = fac2+Two
    xc = xc+One
  end do
  qcomp = prefac*dsum

end if

return

end function qcomp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Get_nAtoms_All
*
*> @author R. Lindh
*>
*> @details
*> Get number of all atoms (not only symmetry unique) from RUNFILE.
*>
*> @param[out] nAtoms_All Number of all atoms in the molecule
************************************************************************
      Subroutine Get_nAtoms_All(nAtoms_All)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
*
      Call Get_iScalar('Unique atoms',nAtoms)
      Call Allocate_Work(ipCoord,3*nAtoms)
      Call Get_dArray('Unique Coordinates',Work(ipCoord),3*nAtoms)
      Call Get_nAtoms_All_(Work(ipCoord),nAtoms,nAtoms_all)
      Call Free_Work(ipCoord)
*
*     Write (*,*) 'nAtoms_All=',nAtoms_All
*     Write (*,*) 'Exit Get_nAtoms_All'
      Return
      End
      Subroutine Get_nAtoms_All_(Coord_Unique_Atoms,nUnique_Atoms,
     &                           nAll_Atoms)
************************************************************
      use Symmetry_Info, only: nIrrep, iOper, Symmetry_Info_Get
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Integer iGen(3), iCoSet(0:7)
      Real*8  Coord_Unique_Atoms(3,nUnique_Atoms)
      Integer, Save:: Active=0
*     Write (*,*) 'Enter Get_nAtoms_All_'
*                                                                      *
************************************************************************
*                                                                      *
      If (Active.eq.0) Then
         Call Symmetry_Info_Get()
         Active=1
      End If
*     Write (*,*) 'Get_nAtoms_All_: nIrrep',nIrrep
*     Write (*,*) 'Get_nAtoms_All_: iOper',(iOper(i),i=0,nIrrep-1)
*                                                                      *
************************************************************************
*                                                                      *
      nGen=0
      If (nIrrep.eq.2) nGen=1
      If (nIrrep.eq.4) nGen=2
      If (nIrrep.eq.8) nGen=3
      If (nGen.ge.1) iGen(1)=iOper(1)
      If (nGen.ge.2) iGen(2)=iOper(2)
      If (nGen.eq.3) iGen(3)=iOper(4)
*     Write (*,*) 'nGen=',nGen
*     Write (*,*) 'iGen=',iGen
*                                                                      *
************************************************************************
*                                                                      *
*     Compute total number of centers.
*
      iAll_Atom=0
      Do iUnique_Atom = 1, nUnique_Atoms
*        Write (*,*) 'iUnique_Atom=',iUnique_Atom
*
         iChAtom=iChxyz(Coord_Unique_Atoms(1,iUnique_Atom),iGen,nGen)
*        Write (*,*) 'iChAtom=',iChAtom
         Call CoSet(iCoSet,nCoSet,iChAtom)
*        Write (*,*) 'nCoSet=',nCoSet
*        Write (*,*) 'iCoSet=',(iCoSet(i),i=0,nCoset-1)
*
         iAll_Atom = iAll_Atom + nCoSet
*
      End Do
*
      nAll_Atoms=iAll_Atom
*                                                                      *
************************************************************************
*                                                                      *
*     Write (*,*) 'Exit Get_nAtoms_All_'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per Ake Malmqvist                                      *
!***********************************************************************

subroutine TRACHOSZ()

use Symmetry_Info, only: Mul
use CHOVEC_IO, only: IDGLB_CHOGROUP, IDLOC_CHOGROUP, NPQ_CHOTYPE, NVGLB_CHOBATCH, NVLOC_CHOBATCH, NVTOT_CHOSYM
use Para_Info, only: nProcs
use Cholesky, only: InfVec
use ChoCASPT2, only: MxCharR, MxNVC, nChSpc, nFtSpc, nHtSpc, nKsh, nPsh, NumCho_pt2
#ifdef _MOLCAS_MPP_
use ChoCASPT2, only: NFTSPC_TOT
#endif
use caspt2_global, only: do_grad, LUDRA, LUDRATOT
use caspt2_module, only: nAsh, nBas, nBasT, nBtch, nBtches, nFro, nIsh, nSym
use stdalloc, only: mma_allocate, mma_MaxDBLE
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IB, IBATCH_TOT, IBEND, IBSTA, ICASE, IDISK, ISYMA, ISYMB, ISYQ, JRED, JRED1, JRED2, JSTART, JSYM, MXFTARR, &
                     MXHTARR, MXSPC, NBATCH, NBATCH_TOT, NJSCT, NPB, NPQ, NV, NVACC, NVACT, NVECS_RED
real(kind=wp) :: Dummy(1)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: NJSCT_TOT
#endif

! ======================================================================
! Determine sectioning size to use for the full-transformed MO vectors
! using Francesco's method.
! Cholesky vectors, and half transformed vectors, need space for
! all symmetry blocks with a specified combined symmetry.
! Fully transformed symmetry blocks are handled individually.
MXHTARR = 0
MXFTARR = 0
do JSYM=1,NSYM
  NPB = 0
  do ISYMA=1,NSYM
    ISYMB = Mul(ISYMA,JSYM)
    NPB = NPB+max(NFRO(iSymA),NISH(iSymA),NASH(iSymA))*NBAS(ISYMB)
    MXFTARR = max(MXFTARR,NPSH(ISYMA)*NKSH(ISYMB))
  end do
  MXHTARR = max(MXHTARR,NPB)
end do
MXCHARR = NBAST**2
if (do_grad) MXHTARR = MXCHARR
! MXFTARR,MXHTARR: Largest single full-transformed, half-transformed vector.
! MXCHARR: Largest possible Cholesky vector.

! What is largest possible array that can now be allocated?
call mma_MaxDBLE(MXSPC)
! Subtract 7*MXCHARR (for vector V, etc, see below).
MXSPC = MXSPC-7*MXCHARR

! Use 80% of this:
MXSPC = int(real(MXSPC,kind=wp)*0.8_wp)
! Max number of vectors that will fit in memory:
!SVC: added space for 2x the collected chovecs
MXNVC = MXSPC/(MXCHARR+MXHTARR+MXFTARR+2*nProcs*MXFTARR)
!SVC: MPI workaround: collected chovecs should not exceed 2GB
if (MXFTARR /= 0) MXNVC = min(MXNVC,2147483647/(8*nProcs*MXFTARR))
! Max number of vectors actually used in one batch:
NJSCT = 0
IBATCH_TOT = 0

do JSYM=1,NSYM
  ! Nr of batches in earlier symmetries:
  NBTCHES(JSYM) = IBATCH_TOT
  NBTCH(JSYM) = 0
  select case (NUMCHO_PT2(JSYM))
    case (0)
      NBTCH(JSYM) = 0
    case Default
      JRED1 = InfVec(1,2,jSym)
      JRED2 = InfVec(NumCho_PT2(jSym),2,jSym)
      ! Loop over the reduced sets:
      do JRED=JRED1,JRED2
        call Cho_X_nVecRS(JRED,JSYM,JSTART,NVECS_RED)
        ! It happens that a reduced set is empty:
        if (NVECS_RED == 0) cycle
        ! Reduced set JRED contains NVECS_RED vectors
        ! Reduced set JRED must be divided up into NBATCH batches
        NBATCH = 1+(NVECS_RED-1)/MXNVC
        ! Necessary number of vectors in each batch is then:
        NV = 1+(NVECS_RED-1)/NBATCH
        NJSCT = max(NV,NJSCT)
        NBTCH(JSYM) = NBTCH(JSYM)+NBATCH
      end do
  end select
  ! take maximum number of batches for this symmetry over any
  ! process, such that all procs have the same number of batches
  call GAIGOP(NBTCH(JSYM),1,'max')
  IBATCH_TOT = IBATCH_TOT+NBTCH(JSYM)
  ! Nr of batches in this symmetry:
end do

NBATCH_TOT = IBATCH_TOT

#ifdef _MOLCAS_MPP_
!SVC: take the global sum of the individual maxima
NJSCT_TOT = NJSCT
call GAIGOP_SCAL(NJSCT_TOT,'+')
#endif

! Allocate space for the Cholesky vectors:
NCHSPC = NJSCT*MXCHARR
NHTSPC = NJSCT*MXHTARR
NFTSPC = NJSCT*MXFTARR
#ifdef _MOLCAS_MPP_
NFTSPC_TOT = NJSCT_TOT*MXFTARR
#endif

#ifdef _DEBUGPRINT_
write(u6,*) ' To be allocated for ...'
write(u6,'(A,1X,I12)') '   Chol. vectors: NCHSPC     =',NCHSPC
write(u6,'(A,1X,I12)') '   half-transf  : NHTSPC     =',NHTSPC
write(u6,'(A,1X,I12)') '   full-transf:   NFTSPC     =',NFTSPC
#ifdef _MOLCAS_MPP_
write(u6,'(A,1X,I12)') '   full-transf:   NFTSPC_TOT =',NFTSPC_TOT
#endif
write(u6,*) ' Cholesky vectors per symmetry:'
write(u6,'(1X,8I12)') (NUMCHO_PT2(JSYM),JSYM=1,NSYM)
#endif

! Set up tables with the number of cholesky vectors per batch and disk
! addresses for the beginning of each batch. These arrays are accessible
! through the CHOVEC_IO module.
call MMA_ALLOCATE(NVLOC_CHOBATCH,NBATCH_TOT,Label='NVLOC_CHOBATCH')
call MMA_ALLOCATE(IDLOC_CHOGROUP,4,8,8,NBATCH_TOT,Label='IDLOC_CHOGROUP')
NVLOC_CHOBATCH = 0
IDLOC_CHOGROUP = 0

IDISK = 0
IBATCH_TOT = 0
do JSYM=1,NSYM
  if (NUMCHO_PT2(JSYM) <= 0) cycle
  JRED1 = InfVec(1,2,jSym)
  JRED2 = InfVec(NumCho_PT2(jSym),2,jSym)

  do JRED=JRED1,JRED2
    call Cho_X_nVecRS(JRED,JSYM,JSTART,NVECS_RED)
    ! It happens that a reduced set is empty:
    if (NVECS_RED == 0) cycle

    NBATCH = 1+(NVECS_RED-1)/MXNVC
    NV = 1+(NVECS_RED-1)/NBATCH
    NVACC = 0
    do IB=1,NBATCH
      IBATCH_TOT = IBATCH_TOT+1
      ! number of vectors
      NVACT = min(NVECS_RED-NVACC,NV)
      NVLOC_CHOBATCH(IBATCH_TOT) = NVACT
      NVACC = NVACC+NVACT
      ! disk address offsets
      do ISYQ=1,NSYM
        do ICASE=1,4
          NPQ = NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
          IDLOC_CHOGROUP(ICASE,ISYQ,JSYM,IBATCH_TOT) = IDISK
          call DDAFILE(LUDRA,0,DUMMY,NPQ*NVACT,IDISK)
        end do
      end do
    end do
  end do
  ! set remaining batches to 0
  NBATCH = IBATCH_TOT-NBTCHES(JSYM)
  do IB=NBATCH+1,NBTCH(JSYM)
    IBATCH_TOT = IBATCH_TOT+1
    NVLOC_CHOBATCH(IBATCH_TOT) = 0
    do ISYQ=1,NSYM
      do ICASE=1,4
        IDLOC_CHOGROUP(ICASE,ISYQ,JSYM,IBATCH_TOT) = IDISK
      end do
    end do
    IDLOC_CHOGROUP(:,1:NSYM,JSYM,IBATCH_TOT) = IDISK
  end do
end do

! SVC: added workaround to get _all_ the fully transformed cholesky
! vectors onto every process. LUDRA has a counterpart LUDRATOT with
! indexing through the size NVGLB_CHOBATCH and offset IDGLB_CHOGROUP
! available from the CHOVEC_IO module.

call MMA_ALLOCATE(NVGLB_CHOBATCH,NBATCH_TOT,Label='NVGLB_CHOBATCH')
NVGLB_CHOBATCH(:) = NVLOC_CHOBATCH(:)
#ifdef _MOLCAS_MPP_
! for parrallel, sum over processes
call GAIGOP(NVGLB_CHOBATCH,NBATCH_TOT,'+')
#endif

! sum over same-symmetry batches
NVTOT_CHOSYM(:) = 0
do JSYM=1,NSYM
  IBSTA = NBTCHES(JSYM)+1
  IBEND = NBTCHES(JSYM)+NBTCH(JSYM)
  ! total size is sum over global batch sizes
  NVTOT_CHOSYM(JSYM) = sum(NVGLB_CHOBATCH(IBSTA:IBEND))
end do

call MMA_ALLOCATE(IDGLB_CHOGROUP,4,8,8,NBATCH_TOT,Label='IDGLB_CHOGROUP')

! compute offsets into all cholesky vectors
IDISK = 0
IDGLB_CHOGROUP = 0
do JSYM=1,NSYM
  IBSTA = NBTCHES(JSYM)+1
  IBEND = NBTCHES(JSYM)+NBTCH(JSYM)
  do IB=IBSTA,IBEND
    NV = NVGLB_CHOBATCH(IB)
    do ISYQ=1,NSYM
      do ICASE=1,4
        NPQ = NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
        IDGLB_CHOGROUP(ICASE,ISYQ,JSYM,IB) = IDISK
        call DDAFILE(LUDRATOT,0,DUMMY,NPQ*NV,IDISK)
      end do
    end do
  end do
end do

end subroutine TRACHOSZ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2006  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MKPREF_RPT2(N,G2,PREF)
      IMPLICIT NONE

      INTEGER, INTENT(IN) :: N
      REAL*8, INTENT(IN) ::  G2(N,N,N,N)
      REAL*8, INTENT(OUT) :: PREF(*)

      INTEGER I,J,K,L,IJ,JI,KL,LK
      INTEGER IJKL,IJLK,JIKL,JILK
      INTEGER IJT,KLT,IJKLT

      REAL*8 P1,P2

C Compute PREF(PQRS) = <0| 0.5*Epqrs |0>
C from G2(P,Q,R,S) = <0| Epqrs |0>
C Storage differs: PREF is triangular
C in the Fortran-like indices PQ, RS.

      IJT=0
      IJKLT=0
      DO I=1,N
        DO J=1,I
          IJT=IJT+1
          IJ=I+N*(J-1)
          JI=J+N*(I-1)
          KLT=0
          DO K=1,N
            DO L=1,K
              KLT=KLT+1
              IF(KLT.GT.IJT) GOTO 130
              IJKLT=IJKLT+1
              KL=K+N*(L-1)
              LK=L+N*(K-1)

              P1=0.5D0*G2(I,J,K,L)
              P2=0.5D0*G2(I,J,L,K)
              IF(J.GE.L) THEN
                IJKL=(IJ*(IJ-1))/2+KL
              ELSE
                IJKL=(KL*(KL-1))/2+IJ
              END IF
              IF(J.GE.K) THEN
                IJLK=(IJ*(IJ-1))/2+LK
              ELSE
                IJLK=(LK*(LK-1))/2+IJ
              END IF
              JIKL=(JI*(JI-1))/2+KL
              JILK=(JI*(JI-1))/2+LK
              PREF(IJKL)=P1
              PREF(IJLK)=P2
              PREF(JIKL)=P2
              PREF(JILK)=P1
            END DO
          END DO
 130    CONTINUE
        END DO
      END DO

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine EXCH(ISYP,ISYI,ISYQ,ISYJ,II,IJ,ERI,SCR)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ISYP, ISYI, ISYQ, ISYJ, II, IJ
real(kind=wp), intent(_OUT_) :: ERI(*), SCR(*)
integer(kind=iwp) :: I, I3, I4, IDISK, IREC, IS12, IS34, ISY1, ISY2, ISY3, ISY4, NBUF, NDIM2M, NO1, NO2
logical(kind=iwp) :: TRANSP
#include "intgrl.fh"

NDIM2M = (NSYMZ*(NSYMZ+1))/2
if (ISYP >= ISYQ) then
  ISY1 = ISYP
  ISY2 = ISYQ
  ISY3 = ISYI
  ISY4 = ISYJ
  I3 = II
  I4 = IJ
  TRANSP = .true.
else
  ISY1 = ISYQ
  ISY2 = ISYP
  ISY3 = ISYJ
  ISY4 = ISYI
  I3 = IJ
  I4 = II
  TRANSP = .false.
end if

! We are going for an EXCH1 or EXCH2 integral of symmetry
! block ISY1,ISY3,ISY2,ISY4.
! Disk address to symmetry block, and record nr:

IS12 = (ISY1*(ISY1-1))/2+ISY2
if (ISY3 > ISY4) then
  IS34 = (ISY3*(ISY3-1))/2+ISY4
  IDISK = IAD2M(2,IS12+NDIM2M*(IS34-1))
  IREC = I4+NOSHZ(ISY4)*(I3-1)
else if (ISY3 == ISY4) then
  IS34 = (ISY3*(ISY3-1))/2+ISY4
  if (I3 >= I4) then
    IDISK = IAD2M(2,IS12+NDIM2M*(IS34-1))
    IREC = (I3*(I3-1))/2+I4
  else
    IDISK = IAD2M(2,IS12+NDIM2M*(IS34-1))
    IREC = (I4*(I4-1))/2+I3
    TRANSP = .not. TRANSP
  end if
else
  IS34 = (ISY4*(ISY4-1))/2+ISY3
  IDISK = IAD2M(3,IS12+NDIM2M*(IS34-1))
  IREC = I3+NOSHZ(ISY3)*(I4-1)
end if

! Buffer size:
NO1 = NORBZ(ISY1)
NO2 = NORBZ(ISY2)
NBUF = NO1*NO2
if (NBUF == 0) return

! Address update for earlier records, then read:
! PAM07 * Eliminate unsafe IPOSFILE call
!IDISK = IDISK+iPosFile(NBUF)*(IREC-1)
! Replace with dummy i/o operations: Is this efficience issue??
do I=1,IREC-1
  call dDAFILE(LUINTMZ,0,SCR,NBUF,IDISK)
end do

if (TRANSP) then
  call dDAFILE(LUINTMZ,2,SCR,NBUF,IDISK)
  call TRNSPS(NO2,NO1,SCR,ERI)
else
  call dDAFILE(LUINTMZ,2,ERI,NBUF,IDISK)
end if

return

end subroutine EXCH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKWWOP(IVEC,JVEC,OP0,OP1,NOP2,OP2,NOP3,OP3)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

C Presently symmetry blocking is disregarded for OP2, OP3, but
C index pair C permutation symmetry is used.
C NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
C NOP3=(NASHT**2+2 over 3)  (Binomial coefficient)
      DIMENSION OP1(NASHT,NASHT),OP2(NOP2),OP3(NOP3)

C Given the coefficients for two excitation operators in the
C vectors numbered IVEC and C JVEC on file, construct the
C zero-, one-, two-, and three-body
C expansions of the product (Op in IVEC conjugated)(Op in JVEC)
C as operating on the CASSCF space.

      OP0=0.0D0
      CALL DCOPY_(NASHT**2,[0.0D0],0,OP1,1)
      CALL DCOPY_(NOP2,[0.0D0],0,OP2,1)
      CALL DCOPY_(NOP3,[0.0D0],0,OP3,1)
      CALL MKWWOPA(IVEC,JVEC,OP1,NOP2,OP2,NOP3,OP3)
      CALL MKWWOPB(IVEC,JVEC,OP0,OP1,NOP2,OP2)
      CALL MKWWOPC(IVEC,JVEC,OP1,NOP2,OP2,NOP3,OP3)
      CALL MKWWOPD(IVEC,JVEC,OP1,NOP2,OP2)
      CALL MKWWOPE(IVEC,JVEC,OP0,OP1)
      CALL MKWWOPF(IVEC,JVEC,NOP2,OP2)
      CALL MKWWOPG(IVEC,JVEC,OP1)
      CALL MKWWOPH(IVEC,JVEC,OP0)

      RETURN
      END
      SUBROUTINE MKWWOPA(IVEC,JVEC,OP1,NOP2,OP2,NOP3,OP3)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

C Presently symmetry blocking is disregarded, but index pair
C permutation symmetry is used.
C NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
C NOP3=(NASHT**2+2 over 3)  (Binomial coefficient)
      DIMENSION OP1(NASHT,NASHT),OP2(NOP2),OP3(NOP3)

C Given the coefficients for two excitation operators of the
C type VJTU = Case A, available in vectors numbered IVEC and
C JVEC on file, construct the zero-, one-, two-, and three-body
C expansions of the product (Op in IVEC conjugated)(Op in JVEC)
C as operating on the CASSCF space.
C Formula used:
C  W1(tuv,i)(conj)*W2(xyz,j) = dij * (  -Evuxtyz -dyu Evzxt
C                     - dyt Evuxz - dxu Evtyz - dxu dyt Evz
C                     + 2 dtx Evuyz + 2 dtx dyu Evz )
* ------------------------------------------------------------
* PAM 2008: Sectioning over non-active superindices added
* at Krapperup Labour Camp, May 2008. Some comments of changes
* only at this routine; similar changes in MKWWOPB--MKWWOPH.
* ------------------------------------------------------------

      ICASE=1
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
* PAM2008: Added sectioning over non-active superindex
* but this will obviously hardly affect this case.
        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 999
C Allocate space for this block of excitation amplitudes:
* Sectioning sizes instead. Replaced code:
*        CALL GETMEM('WWW1','ALLO','REAL',LW1,NW)
*        CALL GETMEM('WWW2','ALLO','REAL',LW2,NW)
* replace with:
C Allocate space for one section of excitation amplitudes:
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
C Pick up a symmetry block of W1 and W2
*        CALL RDBLKC(ISYM,ICASE,IVEC,WORK(LW1))
*        CALL RDBLKC(ISYM,ICASE,JVEC,WORK(LW2))
C Allocate space for the contraction:
        NWSCT=MIN(NAS,1000)
        NWPROD=NWSCT**2
        CALL GETMEM('WWPROD','ALLO','REAL',LWPROD,NWPROD)
* Sectioning loop added:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA-1+MDVEC,NIS)
         NCOL=1+IIEND-IISTA
         CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
         CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
* End of addition
C Loop over sections of WW1 and WW2:
        DO ITUVSTA=1,NAS,NWSCT
          LW1A=LW1-1+ITUVSTA
          ITUVEND=MIN(ITUVSTA-1+NWSCT,NAS)
          MWS1=ITUVEND+1-ITUVSTA
          DO IXYZSTA=1,NAS,NWSCT
            LW2A=LW2-1+IXYZSTA
            IXYZEND=MIN(IXYZSTA-1+NWSCT,NAS)
            MWS2=IXYZEND+1-IXYZSTA
C Multiply WProd = (W1 sect )*(W2 sect transpose)
*            CALL DGEMM_('N','T',
*     &                  MWS1,MWS2,NIS,
*     &                  1.0d0,WORK(LW1A),NAS,
*     &                  WORK(LW2A),NAS,
*     &                  0.0d0,WORK(LWPROD),NWSCT)
* Replaced, due to sectioning over inactives:
            CALL DCOPY_(NWPROD,[0.0D0],0,WORK(LWPROD),1)
            CALL DGEMM_('N','T',
     &                  MWS1,MWS2,NCOL,
     &                  1.0d0,WORK(LW1A),NAS,
     &                  WORK(LW2A),NAS,
     &                  1.0d0,WORK(LWPROD),NWSCT)
* End of replacement

C Loop over (TUV) in its section
          DO ITUV=ITUVSTA,ITUVEND
            IW1=ITUV+1-ITUVSTA
            ITUVABS=ITUV+NTUVES(ISYM)
            ITABS=MTUV(1,ITUVABS)
            IUABS=MTUV(2,ITUVABS)
            IVABS=MTUV(3,ITUVABS)
            IVU=IVABS+NASHT*(IUABS-1)
C Loop over (XYZ) in its section
          DO IXYZ=IXYZSTA,IXYZEND
            IW2=IXYZ+1-IXYZSTA
            IXYZABS=IXYZ+NTUVES(ISYM)
            IXABS=MTUV(1,IXYZABS)
            IYABS=MTUV(2,IXYZABS)
            IZABS=MTUV(3,IXYZABS)
            IXT=IXABS+NASHT*(ITABS-1)
            IYZ=IYABS+NASHT*(IZABS-1)
            IWPROD=IW1+NWSCT*(IW2-1)
            WPROD=WORK(LWPROD-1+IWPROD)
C Remember:
C  W1(tuv,i)(conj)*W2(xyz,j) = dij * (  -Evuxtyz -dyu Evzxt
C                     - dyt Evuxz - dxu Evtyz - dxu dyt Evz
C                     + 2 dtx Evuyz + 2 dtx dyu Evz )
C Contrib to 3-particle operator:
            IF(IVU.LT.IXT) THEN
              IF(IVU.GE.IYZ) THEN
                JVU=IXT
                JXT=IVU
                JYZ=IYZ
              ELSE IF(IXT.LT.IYZ) THEN
                  JVU=IYZ
                  JXT=IXT
                  JYZ=IVU
              ELSE
                  JVU=IXT
                  JXT=IYZ
                  JYZ=IVU
              END IF
            ELSE
              IF(IVU.LT.IYZ) THEN
                JVU=IYZ
                JXT=IVU
                JYZ=IXT
              ELSE IF (IXT.GE.IYZ) THEN
                JVU=IVU
                JXT=IXT
                JYZ=IYZ
              ELSE
                JVU=IVU
                JXT=IYZ
                JYZ=IXT
              END IF
            END IF
            JVUXTYZ=((JVU+1)*JVU*(JVU-1))/6+(JXT*(JXT-1))/2+JYZ
            OP3(JVUXTYZ)=OP3(JVUXTYZ)-WPROD
C Contrib to 2-particle operator, from -dyu Evzxt:
            IF(IYABS.EQ.IUABS) THEN
              IVZ=IVABS+NASHT*(IZABS-1)
              IXT=IXABS+NASHT*(ITABS-1)
              IF(IVZ.GE.IXT) THEN
                JVZXT=(IVZ*(IVZ-1))/2+IXT
              ELSE
                JVZXT=(IXT*(IXT-1))/2+IVZ
              END IF
              OP2(JVZXT)=OP2(JVZXT)-WPROD
            END IF
C Contrib to 2-particle operator, from -dyt Evuxz:
            IF(IYABS.EQ.ITABS) THEN
              IVU=IVABS+NASHT*(IUABS-1)
              IXZ=IXABS+NASHT*(IZABS-1)
              IF(IVU.GE.IXZ) THEN
                JVUXZ=(IVU*(IVU-1))/2+IXZ
              ELSE
                JVUXZ=(IXZ*(IXZ-1))/2+IVU
              END IF
              OP2(JVUXZ)=OP2(JVUXZ)-WPROD
C Contrib to 1-particle operator, from -dxu dyt Evz:
              IF(IXABS.EQ.IUABS) THEN
                OP1(IVABS,IZABS)=OP1(IVABS,IZABS)-WPROD
              END IF
            END IF
C Contrib to 2-particle operator, from -dxu Evtyz:
            IF(IXABS.EQ.IUABS) THEN
              IVT=IVABS+NASHT*(ITABS-1)
              IYZ=IYABS+NASHT*(IZABS-1)
              IF(IVT.GE.IYZ) THEN
                JVTYZ=(IVT*(IVT-1))/2+IYZ
              ELSE
                JVTYZ=(IYZ*(IYZ-1))/2+IVT
              END IF
              OP2(JVTYZ)=OP2(JVTYZ)-WPROD
            END IF
C Contrib to 2-particle operator, from +2 dtx Evuyz:
            IF(ITABS.EQ.IXABS) THEN
              IVU=IVABS+NASHT*(IUABS-1)
              IYZ=IYABS+NASHT*(IZABS-1)
              IF(IVU.GE.IYZ) THEN
                JVUYZ=(IVU*(IVU-1))/2+IYZ
              ELSE
                JVUYZ=(IYZ*(IYZ-1))/2+IVU
              END IF
              OP2(JVUYZ)=OP2(JVUYZ)+2.0D0*WPROD
C Contrib to 1-particle operator, from +2 dtx dyu Evz:
              IF(IYABS.EQ.IUABS) THEN
                OP1(IVABS,IZABS)=OP1(IVABS,IZABS)+2.0D0*WPROD
              END IF
            END IF
           END DO
          END DO
         END DO
        END DO
* PAM2008, an added sectioning loop
        END DO
C Deallocate temporary space:
*        CALL GETMEM('WWW1','FREE','REAL',LW1,NW)
*        CALL GETMEM('WWW2','FREE','REAL',LW2,NW)
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)
        CALL GETMEM('WWPROD','FREE','REAL',LWPROD,NWPROD)
 999    CONTINUE
      END DO
      RETURN
      END
      SUBROUTINE MKWWOPB(IVEC,JVEC,OP0,OP1,NOP2,OP2)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

C Presently symmetry blocking is disregarded, but index pair
C permutation symmetry is used.
C NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
      DIMENSION OP1(NASHT,NASHT),OP2(NOP2)

C Given the coefficients for two excitation operators, available in
C vectors numbered IVEC and JVEC on file, use the blocks for
C excitation cases VJTI(+) and VJTI(-), i.e. cases 2 and 3, to
C construct the zero-, one-, and two-body
C expansions of the product (Op in IVEC conjugated)(Op in JVEC)
C as operating on the CASSCF space.
C Formulae used:
C For the B+ case (i.e. case 2)
C W1(tu,ij)(conj)*W2(xy,kl) = (dik*djl)*(2 Extyu + 2 Eytxu -2dxt Eyu
C           -2dyu Ext -2dyt Exu -2dxu Eyt + 4 dxt dyu + 4 dxu dyt)
C For the B- case (i.e. case 3)
C W1(tu,ij)(conj)*W2(xy,kl) = (dik*djl)*(2 Extyu - 2 Eytxu -6dxt Eyu
C           -6dyu Ext +6dyt Exu +6dxu Eyt +12 dxt dyu -12 dxu dyt)

C FIRST THE B+ i.e. VJTI+ i.e. CASE 2 -----------------------------
      ICASE=2
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 888
C Allocate space for one section of excitation amplitudes:
C Pick up a symmetry block of W1 and W2
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        IF(IVEC.EQ.JVEC) THEN
          LW2=LW1
        ELSE
          CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
        END IF
        NWPROD=NAS**2
C Allocate space for the contraction:
        CALL GETMEM('WWPROD','ALLO','REAL',LWPROD,NWPROD)
        CALL DCOPY_(NWPROD,[0.0D0],0,WORK(LWPROD),1)
* Loop over sections:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA+MDVEC-1,MDVEC)
         NCOL=IIEND-IISTA+1
         NSCT=NAS*NCOL
        CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
        IF (IVEC.NE.JVEC) CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
C Multiply WProd = (W1 sect )*(W2 sect transpose)
        CALL DGEMM_('N','T',
     &              NAS,NAS,NCOL,
     &              1.0d0,WORK(LW1),NAS,
     &              WORK(LW2),NAS,
     &              1.0d0,WORK(LWPROD),NAS)
        END DO
C Deallocate W1 and W2
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        IF(IVEC.NE.JVEC) CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)

C Loop over (TU)
        DO ITU=1,NAS
          IW1=ITU
          ITUABS=ITU+NTGEUES(ISYM)
          ITABS=MTGEU(1,ITUABS)
          IUABS=MTGEU(2,ITUABS)
C Loop over (XY)
          DO IXY=1,NAS
            IW2=IXY
            IXYABS=IXY+NTGEUES(ISYM)
            IXABS=MTGEU(1,IXYABS)
            IYABS=MTGEU(2,IXYABS)
            IXT=IXABS+NASHT*(ITABS-1)
            IYU=IYABS+NASHT*(IUABS-1)
            IYT=IYABS+NASHT*(ITABS-1)
            IXU=IXABS+NASHT*(IUABS-1)
            IWPROD=IW1+NAS*(IW2-1)
            WPROD=WORK(LWPROD-1+IWPROD)
C Remember:
C W1(tu,ij)(conj)*W2(xy,kl) = (dik*djl)*(2 Extyu + 2 Eytxu -2dxt Eyu
C           -2dyu Ext -2dyt Exu -2dxu Eyt + 4 dxt dyu + 4 dxu dyt)
C Contrib to 2-particle operator, from 2 Extyu:
            IF(IXT.GE.IYU) THEN
              JXTYU=(IXT*(IXT-1))/2+IYU
            ELSE
              JXTYU=(IYU*(IYU-1))/2+IXT
            END IF
            OP2(JXTYU)=OP2(JXTYU)+2.0D0*WPROD
C Contrib to 1-particle operator, from -2dxt Eyu
            IF(IXABS.EQ.ITABS) THEN
              OP1(IYABS,IUABS)=OP1(IYABS,IUABS)-2.0D0*WPROD
            END IF
C Contrib to 1-particle operator, from -2dyu Ext
            IF(IYABS.EQ.IUABS) THEN
              OP1(IXABS,ITABS)=OP1(IXABS,ITABS)-2.0D0*WPROD
C Contrib to 0-particle operator, from +4 dxt dyu
              IF(IXABS.EQ.ITABS) OP0=OP0 + 4.0D0*WPROD
            END IF
C Contrib to 2-particle operator, from 2 Eytxu:
            IF(IYT.GT.IXU) THEN
              JYTXU=(IYT*(IYT-1))/2+IXU
            ELSE
              JYTXU=(IXU*(IXU-1))/2+IYT
            END IF
            OP2(JYTXU)=OP2(JYTXU)+2.0D0*WPROD
C Contrib to 1-particle operator, from -2dyt Exu
            IF(IYABS.EQ.ITABS) THEN
              OP1(IXABS,IUABS)=OP1(IXABS,IUABS)-2.0D0*WPROD
            END IF
C Contrib to 1-particle operator, from -2dxu Eyt
            IF(IXABS.EQ.IUABS) THEN
              OP1(IYABS,ITABS)=OP1(IYABS,ITABS)-2.0D0*WPROD
C Contrib to 0-particle operator, from +4 dyt dxu
              IF(IYABS.EQ.ITABS) OP0=OP0 + 4.0D0*WPROD
            END IF
          END DO
        END DO
C Deallocate matrix product:
        CALL GETMEM('WWPROD','FREE','REAL',LWPROD,NWPROD)
 888    CONTINUE
      END DO
C Then THE B- i.e. VJTI- i.e. CASE 3 -----------------------------
      ICASE=3
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 999
C Allocate space for one section of excitation amplitudes:
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
        NWPROD=NAS**2
C Allocate space for the contraction:
        CALL GETMEM('WWPROD','ALLO','REAL',LWPROD,NWPROD)
        CALL DCOPY_(NWPROD,[0.0D0],0,WORK(LWPROD),1)
* Sectioning loop added:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA-1+MDVEC,NIS)
         NCOL=1+IIEND-IISTA
         CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
         CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
C Multiply WProd = (W1 sect )*(W2 sect transpose)
        CALL DGEMM_('N','T',
     &              NAS,NAS,NCOL,
     &              1.0d0,WORK(LW1),NAS,
     &              WORK(LW2),NAS,
     &              1.0d0,WORK(LWPROD),NAS)
        END DO
C Deallocate W1, W2
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)

C Loop over (TU)
          DO ITU=1,NAS
            IW1=ITU
            ITUABS=ITU+NTGTUES(ISYM)
            ITABS=MTGTU(1,ITUABS)
            IUABS=MTGTU(2,ITUABS)
C Loop over (XY)
          DO IXY=1,NAS
            IW2=IXY
            IXYABS=IXY+NTGTUES(ISYM)
            IXABS=MTGTU(1,IXYABS)
            IYABS=MTGTU(2,IXYABS)
            IXT=IXABS+NASHT*(ITABS-1)
            IYU=IYABS+NASHT*(IUABS-1)
            IYT=IYABS+NASHT*(ITABS-1)
            IXU=IXABS+NASHT*(IUABS-1)
            IWPROD=IW1+NAS*(IW2-1)
            WPROD=WORK(LWPROD-1+IWPROD)
C Remember:
C W1(tu,ij)(conj)*W2(xy,kl) = (dik*djl)*(2 Extyu - 2 Eytxu -6dxt Eyu
C           -6dyu Ext +6dyt Exu +6dxu Eyt +12 dxt dyu -12 dxu dyt)
C Contrib to 2-particle operator, from 2 Extyu:
            IF(IXT.GE.IYU) THEN
              JXTYU=(IXT*(IXT-1))/2+IYU
            ELSE
              JXTYU=(IYU*(IYU-1))/2+IXT
            END IF
            OP2(JXTYU)=OP2(JXTYU)+2.0D0*WPROD
C Contrib to 1-particle operator, from -6dxt Eyu
            IF(IXABS.EQ.ITABS) THEN
              OP1(IYABS,IUABS)=OP1(IYABS,IUABS)-6.0D0*WPROD
            END IF
C Contrib to 1-particle operator, from -6dyu Ext
            IF(IYABS.EQ.IUABS) THEN
              OP1(IXABS,ITABS)=OP1(IXABS,ITABS)-6.0D0*WPROD
C Contrib to 0-particle operator, from +12 dxt dyu
              IF(IXABS.EQ.ITABS) OP0=OP0 + 12.0D0*WPROD
            END IF
C Contrib to 2-particle operator, from -2 Eytxu:
            IF(IYT.GE.IXU) THEN
              JYTXU=(IYT*(IYT-1))/2+IXU
            ELSE
              JYTXU=(IXU*(IXU-1))/2+IYT
            END IF
            OP2(JYTXU)=OP2(JYTXU)-2.0D0*WPROD
C Contrib to 1-particle operator, from +6dyt Exu
            IF(IYABS.EQ.ITABS) THEN
              OP1(IXABS,IUABS)=OP1(IXABS,IUABS)+6.0D0*WPROD
            END IF
C Contrib to 1-particle operator, from +6dxu Eyt
            IF(IXABS.EQ.IUABS) THEN
              OP1(IYABS,ITABS)=OP1(IYABS,ITABS)+6.0D0*WPROD
C Contrib to 0-particle operator, from -12 dyt dxu
              IF(IYABS.EQ.ITABS) OP0=OP0 -12.0D0*WPROD
            END IF
          END DO
        END DO
C Deallocate matrix product
        CALL GETMEM('WWPROD','FREE','REAL',LWPROD,NWPROD)
 999    CONTINUE
      END DO
      RETURN
      END
      SUBROUTINE MKWWOPC(IVEC,JVEC,OP1,NOP2,OP2,NOP3,OP3)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"

C Presently symmetry blocking is disregarded, but index pair
C permutation symmetry is used.
C NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
C NOP3=(NASHT**2+2 over 3)  (Binomial coefficient)
      DIMENSION OP1(NASHT,NASHT),OP2(NOP2),OP3(NOP3)

C Given the coefficients for two excitation operators of the
C type ATVX = Case C, available in vectors numbered IVEC and
C JVEC on file, construct the zero-, one-, two-, and three-body
C expansions of the product (Op in IVEC conjugated)(Op in JVEC)
C as operating on the CASSCF space.
C Formula used:
C  W1(tuv,a)(conj)*W2(xyz,b) = dab * ( Evutxyz +dyu Evztx
C                       + dyx Evutz + dtu Evxyz + dtu dyx Evz )

      ICASE=4
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 999
C Allocate space for one section of excitation amplitudes:
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
        NWSCT=MIN(NAS,1000)
        NWPROD=NWSCT**2
C Allocate space for the contraction:
        CALL GETMEM('WWPROD','ALLO','REAL',LWPROD,NWPROD)
* Sectioning loop added:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA-1+MDVEC,NIS)
         NCOL=1+IIEND-IISTA
         CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
         CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
C Loop over sections of WW1 and WW2:
        DO ITUVSTA=1,NAS,NWSCT
          LW1A=LW1-1+ITUVSTA
          ITUVEND=MIN(ITUVSTA-1+NWSCT,NAS)
          MWS1=ITUVEND+1-ITUVSTA
          DO IXYZSTA=1,NAS,NWSCT
            IXYZEND=MIN(IXYZSTA-1+NWSCT,NAS)
            LW2A=LW2-1+IXYZSTA
            MWS2=IXYZEND+1-IXYZSTA
C Multiply WProd = (W1 sect )*(W2 sect transpose)
            CALL DCOPY_(NWPROD,[0.0D0],0,WORK(LWPROD),1)
            CALL DGEMM_('N','T',
     &                  MWS1,MWS2,NCOL,
     &                  1.0d0,WORK(LW1A),NAS,
     &                  WORK(LW2A),NAS,
     &                  1.0d0,WORK(LWPROD),NWSCT)

C Loop over (TUV) in its section
          DO ITUV=ITUVSTA,ITUVEND
            IW1=ITUV+1-ITUVSTA
            ITUVABS=ITUV+NTUVES(ISYM)
            ITABS=MTUV(1,ITUVABS)
            IUABS=MTUV(2,ITUVABS)
            IVABS=MTUV(3,ITUVABS)
            IVU=IVABS+NASHT*(IUABS-1)
C Loop over (XYZ) in its section
          DO IXYZ=IXYZSTA,IXYZEND
            IW2=IXYZ+1-IXYZSTA
            IXYZABS=IXYZ+NTUVES(ISYM)
            IXABS=MTUV(1,IXYZABS)
            IYABS=MTUV(2,IXYZABS)
            IZABS=MTUV(3,IXYZABS)
            ITX=ITABS+NASHT*(IXABS-1)
            IYZ=IYABS+NASHT*(IZABS-1)
            IWPROD=IW1+NWSCT*(IW2-1)
            WPROD=WORK(LWPROD-1+IWPROD)
C Remember:
C  W1(tuv,a)(conj)*W2(xyz,b) = dab * ( Evutxyz +dyu Evztx
C                       + dyx Evutz + dtu Evxyz + dtu dyx Evz )
C Contrib to 3-particle operator:
            IF(IVU.LT.ITX) THEN
              IF(IVU.GE.IYZ) THEN
                JVU=ITX
                JTX=IVU
                JYZ=IYZ
              ELSE IF(ITX.LT.IYZ) THEN
                  JVU=IYZ
                  JTX=ITX
                  JYZ=IVU
              ELSE
                  JVU=ITX
                  JTX=IYZ
                  JYZ=IVU
              END IF
            ELSE
              IF(IVU.LT.IYZ) THEN
                JVU=IYZ
                JTX=IVU
                JYZ=ITX
              ELSE IF (ITX.GE.IYZ) THEN
                JVU=IVU
                JTX=ITX
                JYZ=IYZ
              ELSE
                JVU=IVU
                JTX=IYZ
                JYZ=ITX
              END IF
            END IF
            JVUTXYZ=((JVU+1)*JVU*(JVU-1))/6+(JTX*(JTX-1))/2+JYZ
            OP3(JVUTXYZ)=OP3(JVUTXYZ)+WORK(LWPROD-1+IWPROD)
C Contrib to 2-particle operator, from  dyu Evztx:
            IF(IYABS.EQ.IUABS) THEN
              IVZ=IVABS+NASHT*(IZABS-1)
              ITX=ITABS+NASHT*(IXABS-1)
              IF(IVZ.GE.ITX) THEN
                JVZTX=(IVZ*(IVZ-1))/2+ITX
              ELSE
                JVZTX=(ITX*(ITX-1))/2+IVZ
              END IF
              OP2(JVZTX)=OP2(JVZTX)+WPROD
            END IF
C Contrib to 2-particle operator, from  dyx Evutz:
            IF(IYABS.EQ.IXABS) THEN
              IVU=IVABS+NASHT*(IUABS-1)
              ITZ=ITABS+NASHT*(IZABS-1)
              IF(IVU.GE.ITZ) THEN
                JVUTZ=(IVU*(IVU-1))/2+ITZ
              ELSE
                JVUTZ=(ITZ*(ITZ-1))/2+IVU
              END IF
              OP2(JVUTZ)=OP2(JVUTZ)+WPROD
            END IF
C Contrib to 2-particle operator, from  dtu Evxyz:
            IF(ITABS.EQ.IUABS) THEN
              IVX=IVABS+NASHT*(IXABS-1)
              IYZ=IYABS+NASHT*(IZABS-1)
              IF(IVX.GE.IYZ) THEN
                JVXYZ=(IVX*(IVX-1))/2+IYZ
              ELSE
                JVXYZ=(IYZ*(IYZ-1))/2+IVX
              END IF
              OP2(JVXYZ)=OP2(JVXYZ)+WPROD
C Contrib to 1-particle operator, from  dtu dyx Evz:
              IF(IYABS.EQ.IXABS) THEN
                OP1(IVABS,IZABS)=OP1(IVABS,IZABS)+WPROD
              END IF
            END IF
           END DO
          END DO
         END DO
        END DO
* Extra sectioning loop added...
        END DO
C Deallocate temporary space:
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)
        CALL GETMEM('WWPROD','FREE','REAL',LWPROD,NWPROD)
 999    CONTINUE
      END DO
      RETURN
      END
      SUBROUTINE MKWWOPD(IVEC,JVEC,OP1,NOP2,OP2)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

C Presently symmetry blocking is disregarded, but index pair
C permutation symmetry is used.
C NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
      DIMENSION OP1(NASHT,NASHT),OP2(NOP2)

C Given the coefficients for two excitation operators, available in
C vectors numbered IVEC and JVEC on file, use the blocks for
C excitation case AIVX, i.e. case 5, to
C construct the zero-, one-, and two-body
C expansions of the product (Op in IVEC conjugated)(Op in JVEC)
C as operating on the CASSCF space.
C Formulae used:
C  (W1A(tu,ai) conj)*(W2A(tu,ai)) = 2*(Eutxy + dtx Euy)
C  (W1A(tu,ai) conj)*(W2B(tu,ai)) =  -(Eutxy + dtx Euy)
C  (W1B(tu,ai) conj)*(W2A(tu,ai)) =  -(Eutxy + dtx Euy)
C  (W1B(tu,ai) conj)*(W2B(tu,ai)) =  -Extuy + 2dtx Euy

      ICASE=5
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
        NAS=NASUP(ISYM,ICASE)
        NAS1=NAS/2
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 999
C Allocate space for one section of excitation amplitudes:
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
        NWPROD=NAS**2
C Allocate space for the contraction:
        CALL GETMEM('WWPROD','ALLO','REAL',LWPROD,NWPROD)
        CALL DCOPY_(NWPROD,[0.0D0],0,WORK(LWPROD),1)
* Sectioning loop added:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA-1+MDVEC,NIS)
         NCOL=1+IIEND-IISTA
         CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
         CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
C Multiply WProd = (W1)*(W2 transpose)
         CALL DGEMM_('N','T',
     &              NAS,NAS,NCOL,
     &              1.0d0,WORK(LW1),NAS,
     &              WORK(LW2),NAS,
     &              1.0d0,WORK(LWPROD),NAS)
        END DO
C Deallocate space for this block of excitation amplitudes:
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)

C Loop over (TU)
          DO JTU=1,NAS1
            IW1A=JTU
            IW1B=JTU+NAS1
            JTUABS=JTU+NTUES(ISYM)
            ITABS=MTU(1,JTUABS)
            IUABS=MTU(2,JTUABS)
C Loop over (XY)
          DO JXY=1,NAS1
            IW2A=JXY
            IW2B=JXY+NAS1
            JXYABS=JXY+NTUES(ISYM)
            IXABS=MTU(1,JXYABS)
            IYABS=MTU(2,JXYABS)
            IUT=IUABS+NASHT*(ITABS-1)
            IXY=IXABS+NASHT*(IYABS-1)
            IXT=IXABS+NASHT*(ITABS-1)
            IUY=IUABS+NASHT*(IYABS-1)
            IWPRAA=IW1A+NAS*(IW2A-1)
            IWPRAB=IW1A+NAS*(IW2B-1)
            IWPRBA=IW1B+NAS*(IW2A-1)
            IWPRBB=IW1B+NAS*(IW2B-1)
            WPRAA=WORK(LWPROD-1+IWPRAA)
            WPRAB=WORK(LWPROD-1+IWPRAB)
            WPRBA=WORK(LWPROD-1+IWPRBA)
            WPRBB=WORK(LWPROD-1+IWPRBB)
C Remember:
C (W1A(tu,ai) conj)*(W2A(tu,ai)) = 2*(Eutxy + dtx Euy)
C (W1A(tu,ai) conj)*(W2B(tu,ai)) =  -(Eutxy + dtx Euy)
C (W1B(tu,ai) conj)*(W2A(tu,ai)) =  -(Eutxy + dtx Euy)
C (W1B(tu,ai) conj)*(W2B(tu,ai)) =  -Extuy + 2dtx Euy
C Contrib to 2-particle operator, from Eutxy:
            IF(IUT.GE.IXY) THEN
              JUTXY=(IUT*(IUT-1))/2+IXY
            ELSE
              JUTXY=(IXY*(IXY-1))/2+IUT
            END IF
            OP2(JUTXY)=OP2(JUTXY)+(2.0D0*WPRAA-WPRAB-WPRBA)
C Contrib to 1-particle operator, from Euy:
            IF(ITABS.EQ.IXABS) THEN
              OP1(IUABS,IYABS)= OP1(IUABS,IYABS)
     &               +(2.0D0*WPRAA-WPRAB-WPRBA+2.0D0*WPRBB)
            END IF
C Contrib to 2-particle operator, from Extuy:
            IF(IXT.GE.IUY) THEN
              JXTUY=(IXT*(IXT-1))/2+IUY
            ELSE
              JXTUY=(IUY*(IUY-1))/2+IXT
            END IF
            OP2(JXTUY)=OP2(JXTUY)-WPRBB
          END DO
        END DO
C Deallocate matrix product:
        CALL GETMEM('WWPROD','FREE','REAL',LWPROD,NWPROD)
 999    CONTINUE
      END DO
      RETURN
      END
      SUBROUTINE MKWWOPE(IVEC,JVEC,OP0,OP1)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

C Presently symmetry blocking is disregarded.
      DIMENSION OP1(NASHT,NASHT)

C Given the coefficients for two excitation operators, available in
C vectors numbered IVEC and JVEC on file, use the blocks for
C excitation case VJAI, i.e. cases 6 and 7, to express the
C product (Op in IVEC conjugated)(Op in JVEC) as a one-body
C operator on the CASSCF space.
C Formula used:
C  (W1(t,aij) conj)*(W2(x,bkl)) = dik*djl*dab*(2*dtx - Etx)
C the same for both cases 6 and 7.

C Loop over cases
      DO ICASE=6,7
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 999
C Allocate space for one section of excitation amplitudes:
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
        NWPROD=NAS**2
C Allocate space for the contraction:
        CALL GETMEM('WWPROD','ALLO','REAL',LWPROD,NWPROD)
        CALL DCOPY_(NWPROD,[0.0D0],0,WORK(LWPROD),1)
* Sectioning loop added:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA-1+MDVEC,NIS)
         NCOL=1+IIEND-IISTA
         CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
         CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
C Multiply WProd = (W1)*(W2 transpose)
         CALL DGEMM_('N','T',
     &              NAS,NAS,NCOL,
     &              1.0d0,WORK(LW1),NAS,
     &              WORK(LW2),NAS,
     &              1.0d0,WORK(LWPROD),NAS)
         END DO
C Deallocate space for this block of excitation amplitudes:
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)

C Loop over (T)
          DO IT=1,NAS
            IW1=IT
            ITABS=IT+NAES(ISYM)
C Loop over (X)
          DO IX=1,NAS
            IW2=IX
            IXABS=IX+NAES(ISYM)
            IWPROD=IW1+NAS*(IW2-1)
            WPROD=WORK(LWPROD-1+IWPROD)
            OP1(ITABS,IXABS)=OP1(ITABS,IXABS)-WPROD
            IF(ITABS.EQ.IXABS) OP0=OP0+2.0D0*WPROD
          END DO
        END DO
C Deallocate matrix product
        CALL GETMEM('WWPROD','FREE','REAL',LWPROD,NWPROD)
 999    CONTINUE
      END DO
C End of loop over cases.
      END DO
      RETURN
      END
      SUBROUTINE MKWWOPF(IVEC,JVEC,NOP2,OP2)
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

C Presently symmetry blocking is disregarded, but index pair
C permutation symmetry is used.
C NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
      DIMENSION OP2(NOP2)
C Given the coefficients for two excitation operators, available in
C vectors numbered IVEC and JVEC on file, use the blocks for
C excitation cases BVAT(+) and BVAT(-), i.e. cases 8 and 9, to
C construct the zero-, one-, and two-body
C expansions of the product (Op in IVEC conjugated)(Op in JVEC)
C as operating on the CASSCF space.
C Formulae used:
C For the F+ case (i.e. case 8)
C W1(tu,ab)(conj)*W2(xy,cd) = (dac*dbd)*(2 Etxuy + 2 Etyux)
C For the F- case (i.e. case 9)
C W1(tu,ab)(conj)*W2(xy,cd) = (dac*dbd)*(2 Etxuy - 2 Etyux)

C FIRST THE F+ i.e. BVAT+ i.e. CASE 8 -----------------------------
      ICASE=8
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 888
C Allocate space for one section of excitation amplitudes:
C Pick up a symmetry block of W1 and W2
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        IF(JVEC.EQ.IVEC) THEN
          LW2=LW1
        ELSE
          CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
        END IF
        NWPROD=NAS**2
C Allocate space for the contraction:
        CALL GETMEM('WWPROD','ALLO','REAL',LWPROD,NWPROD)
        CALL DCOPY_(NWPROD,[0.0D0],0,WORK(LWPROD),1)
* Sectioning loop added:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA-1+MDVEC,NIS)
         NCOL=1+IIEND-IISTA
         CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
         CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
C Multiply WProd = (W1 sect )*(W2 sect transpose)
         CALL DGEMM_('N','T',
     &              NAS,NAS,NCOL,
     &              1.0d0,WORK(LW1),NAS,
     &              WORK(LW2),NAS,
     &              1.0d0,WORK(LWPROD),NAS)
         END DO
C Deallocate W1 and W2
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        IF(JVEC.NE.IVEC) CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)

C Loop over (TU)
        DO ITU=1,NAS
          IW1=ITU
          ITUABS=ITU+NTGEUES(ISYM)
          ITABS=MTGEU(1,ITUABS)
          IUABS=MTGEU(2,ITUABS)
C Loop over (XY)
          DO IXY=1,NAS
            IW2=IXY
            IXYABS=IXY+NTGEUES(ISYM)
            IXABS=MTGEU(1,IXYABS)
            IYABS=MTGEU(2,IXYABS)
            ITX=ITABS+NASHT*(IXABS-1)
            IUY=IUABS+NASHT*(IYABS-1)
            ITY=ITABS+NASHT*(IYABS-1)
            IUX=IUABS+NASHT*(IXABS-1)
            IWPROD=IW1+NAS*(IW2-1)
            WPROD=WORK(LWPROD-1+IWPROD)
C Remember: C For the F+ case (i.e. case 8)
C W1(tu,ij)(conj)*W2(xy,kl) = (dik*djl)*(2 Etxuy + 2 Etyux)
C Contrib to 2-particle operator, from 2 Etxuy:
            IF(ITX.GE.IUY) THEN
              JTXUY=(ITX*(ITX-1))/2+IUY
            ELSE
              JTXUY=(IUY*(IUY-1))/2+ITX
            END IF
            OP2(JTXUY)=OP2(JTXUY)+2.0D0*WPROD
C Contrib to 2-particle operator, from 2 Etyux:
            IF(ITY.GE.IUX) THEN
              JTYUX=(ITY*(ITY-1))/2+IUX
            ELSE
              JTYUX=(IUX*(IUX-1))/2+ITY
            END IF
            OP2(JTYUX)=OP2(JTYUX)+2.0D0*WPROD
          END DO
        END DO
C Deallocate matrix product:
        CALL GETMEM('WWPROD','FREE','REAL',LWPROD,NWPROD)
888     CONTINUE
      END DO
C THEN THE F- i.e. BVAT- i.e. CASE 9 -----------------------------
      ICASE=9
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 999
C Allocate space for one section of excitation amplitudes:
C Pick up a symmetry block of W1 and W2
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        IF(JVEC.EQ.IVEC) THEN
          LW2=LW1
        ELSE
          CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
        END IF
        NWPROD=NAS**2
C Allocate space for the contraction:
        CALL GETMEM('WWPROD','ALLO','REAL',LWPROD,NWPROD)
        CALL DCOPY_(NWPROD,[0.0D0],0,WORK(LWPROD),1)
* Sectioning loop added:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA-1+MDVEC,NIS)
         NCOL=1+IIEND-IISTA
         CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
         CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
C Multiply WProd = (W1 sect )*(W2 sect transpose)
         CALL DGEMM_('N','T',
     &              NAS,NAS,NCOL,
     &              1.0d0,WORK(LW1),NAS,
     &              WORK(LW2),NAS,
     &              1.0d0,WORK(LWPROD),NAS)
        END DO
C Deallocate W1 and W2
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        IF(JVEC.NE.IVEC) CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)

C Loop over (TU)
        DO ITU=1,NAS
          IW1=ITU
          ITUABS=ITU+NTGTUES(ISYM)
          ITABS=MTGTU(1,ITUABS)
          IUABS=MTGTU(2,ITUABS)
C Loop over (XY)
          DO IXY=1,NAS
            IW2=IXY
            IXYABS=IXY+NTGTUES(ISYM)
            IXABS=MTGTU(1,IXYABS)
            IYABS=MTGTU(2,IXYABS)
            ITX=ITABS+NASHT*(IXABS-1)
            IUY=IUABS+NASHT*(IYABS-1)
            ITY=ITABS+NASHT*(IYABS-1)
            IUX=IUABS+NASHT*(IXABS-1)
            IWPROD=IW1+NAS*(IW2-1)
            WPROD=WORK(LWPROD-1+IWPROD)
C Remember: C For the F- case (i.e. case 9)
C W1(tu,ij)(conj)*W2(xy,kl) = (dik*djl)*(2 Etxuy - 2 Etyux)
C Contrib to 2-particle operator, from 2 Etxuy:
            IF(ITX.GE.IUY) THEN
              JTXUY=(ITX*(ITX-1))/2+IUY
            ELSE
              JTXUY=(IUY*(IUY-1))/2+ITX
            END IF
            OP2(JTXUY)=OP2(JTXUY)+2.0D0*WPROD
C Contrib to 2-particle operator, from -2 Etyux:
            IF(ITY.GE.IUX) THEN
              JTYUX=(ITY*(ITY-1))/2+IUX
            ELSE
              JTYUX=(IUX*(IUX-1))/2+ITY
            END IF
            OP2(JTYUX)=OP2(JTYUX)-2.0D0*WPROD
          END DO
        END DO
C Deallocate matrix product:
        CALL GETMEM('WWPROD','FREE','REAL',LWPROD,NWPROD)
 999    CONTINUE
      END DO
      RETURN
      END
      SUBROUTINE MKWWOPG(IVEC,JVEC,OP1)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

C Presently symmetry blocking is disregarded.
      DIMENSION OP1(NASHT,NASHT)

C Given the coefficients for two excitation operators, available in
C vectors numbered IVEC and JVEC on file, use the blocks for
C excitation case BJAT, i.e. cases 10 and 11, to express the
C product (Op in IVEC conjugated)(Op in JVEC) as a one-body
C operator on the CASSCF space.
C Formula used:
C  (W1(t,aij) conj)*(W2(x,bkl)) = dik*djl*dab* Etx
C the same for both cases 10 and 11.

C Loop over cases
      DO ICASE=10,11
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 999
C Allocate space for one section of excitation amplitudes:
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
        NWPROD=NAS**2
C Allocate space for the contraction:
        CALL GETMEM('WWPROD','ALLO','REAL',LWPROD,NWPROD)
        CALL DCOPY_(NWPROD,[0.0D0],0,WORK(LWPROD),1)
* Sectioning loop added:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA-1+MDVEC,NIS)
         NCOL=1+IIEND-IISTA
         CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
         CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
C Multiply WProd = (W1)*(W2 transpose)
         CALL DGEMM_('N','T',
     &              NAS,NAS,NCOL,
     &              1.0d0,WORK(LW1),NAS,
     &              WORK(LW2),NAS,
     &              1.0d0,WORK(LWPROD),NAS)
        END DO
C Deallocate space for this block of excitation amplitudes:
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)

C Loop over (T)
          DO IT=1,NAS
            IW1=IT
            ITABS=IT+NAES(ISYM)
C Loop over (X)
          DO IX=1,NAS
            IW2=IX
            IXABS=IX+NAES(ISYM)
            IWPROD=IW1+NAS*(IW2-1)
            WPROD=WORK(LWPROD-1+IWPROD)
            OP1(ITABS,IXABS)=OP1(ITABS,IXABS)+WPROD
          END DO
        END DO
C Deallocate matrix product
        CALL GETMEM('WWPROD','FREE','REAL',LWPROD,NWPROD)
 999    CONTINUE
      END DO
C End of loop over cases.
      END DO
      RETURN
      END
      SUBROUTINE MKWWOPH(IVEC,JVEC,OP0)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"

#include "SysDef.fh"

C Given the coefficients for two excitation operators, available in
C vectors numbered IVEC and JVEC on file, use the blocks for
C excitation case BJAI, i.e. cases 12 and 13, to express the
C product (Op in IVEC conjugated)(Op in JVEC) as a zero-body
C operator, i.e. a scalar factor, in the CASSCF space.
C Formula used:
C  (W1(ij,ab) conj)*(W2(kl,cd)) = dik*djl*dac*dbd
C the same for both cases 10 and 11.

C Loop over cases
      DO ICASE=12,13
C Loop over symmetry ISYM
      DO ISYM=1,NSYM
        NAS=NASUP(ISYM,ICASE)
        NIS=NISUP(ISYM,ICASE)
        NW=NAS*NIS
        IF(NINDEP(ISYM,ICASE).EQ.0) GOTO 999
C Allocate space for one section of excitation amplitudes:
        MDVEC=MODVEC(ISYM,ICASE)
        CALL GETMEM('WWW1','ALLO','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','ALLO','REAL',LW2,NAS*MDVEC)
* Sectioning loop added:
        ISCT=0
        DO IISTA=1,NIS,MDVEC
         ISCT=ISCT+1
         IIEND=MIN(IISTA-1+MDVEC,NIS)
         NCOL=1+IIEND-IISTA
         NSCT=NAS*NCOL
         CALL RDSCTC(ISCT,ISYM,ICASE,IVEC,WORK(LW1))
         CALL RDSCTC(ISCT,ISYM,ICASE,JVEC,WORK(LW2))
C Pick up a symmetry block of W1 and W2
         OP0=OP0+DDOT_(NSCT,WORK(LW1),1,WORK(LW2),1)
        END DO
        CALL GETMEM('WWW1','FREE','REAL',LW1,NAS*MDVEC)
        CALL GETMEM('WWW2','FREE','REAL',LW2,NAS*MDVEC)
 999    CONTINUE
      END DO
C End of loop over cases.
      END DO
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!************************************
!** Routines involving CI and ORBS **
!************************************
!***********************************************************************
!*                                                                     *
!*  APPLYT := transform CI vector IVEC according to orbital            *
!*         := transformation in IGJORB (from GAUSSJ)                   *
!*                                                                     *
!*  :> IVEC:      starting CI vector                                   *
!*  :> IGJORB:    simple orbital updates                               *
!*  :> N_APPLYT   stats                                                *
!*  :> I1ALF:     string handling                                      *
!*  :> I1BET:           do.                                            *
!*  :> IATO:            do.                                            *
!*  :> IBTO:            do.                                            *
!*  :> PHATO:           do.                                            *
!*  :> PHBTO:           do.                                            *
!*                                                                     *
!*  :< IVEC:      transformed CI vector                                *
!*  :< N_APPLYT   stats                                                *
!*                                                                     *
!***********************************************************************
subroutine applyt_cvb(cvec,gjorb)

use casvb_global, only: gjorb_type, i1alf, i1bet, iato, ibto, icnt_ci, iform_ci, n_applyt, ndet, phato, phbto
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: cvec(0:ndet)
type(gjorb_type), intent(in) :: gjorb
integer(kind=iwp) :: ivec

ivec = nint(cvec(0))
n_applyt = n_applyt+1
if (iform_ci(ivec) == 0) then
  call permci_cvb(cvec,gjorb%i1)
  call applyt2_cvb(cvec(1:),gjorb%r,gjorb%i2,i1alf,i1bet,iato,ibto,phato,phbto)
else
  write(u6,*) ' Unsupported format in APPLYT :',iform_ci(ivec)
  call abend_cvb()
end if
icnt_ci(ivec) = 0

return

end subroutine applyt_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Martin Schuetz                                   *
*               1998, Roland Lindh                                     *
*               2000-2015, Steven Vancoillie                           *
************************************************************************
************************************************************************
* This Module contains subroutines and functions which interface calls *
* to the Global Array Tools (GA)                                       *
*  DISTRIBUTED DATA PARALLEL VERSION for SCF                           *
************************************************************************
* SubRoutine GAInit                                                    *
*  ->     initialize GA, returns rank of process and # of processes    *
* SubRoutine GATerminate                                               *
*  ->     finalize GA                                                  *
* SubRoutine GASync                                                    *
*  -> synchronize processes...                                         *
* Subroutine GABrdcst(dType,Buf,nByte,Root)                            *
*  -> broadcast message Buf of size nByte from Root                    *
* SubRoutine GAStp(msg,ierr)                                           *
*  -> terminate parallel application...                                *
*     msg:      message to be printed...                               *
*     ierr:     error code...                                          *
* SubRoutine GAIGOP(k,n,op)                                            *
*  -> integer global operation; stub routine to ga_igop...             *
*     k(n):     global vector                                          *
*     op:       global operation '+','*','max','min','absmax','absmin' *
* SubRoutine GADGOP(x,n,op)                                            *
*  -> double global operation; stub routine to ga_dgop...              *
*     x(n):     global vector                                          *
*     op:       global operation '+','*','max','min','absmax','absmin' *
* SubRoutine GAAccP(iGA,ilo,ihi,jlo,jhi,buf,ld,alpha)                  *
*  -> accumulate to GA patch; stub routine to ga_acc...                *
*     iGA:      GA handle                                              *
*     ilo,ihi,jlo,jhi: defines GA patch...                             *
*     buf:      local buffer, containing data to accumulate...         *
*     ld:       leading dimension of buf...                            *
*     alpha:    scaling factor...                                      *
* SubRoutine GADupl(iGA1,iGA2)                                         *
*  -> duplicate & copy a global array...                               *
*     iGA1,iGA2  :       GA handles...                                 *
* SubRoutine GAAdd(alpha,iGA1,beta,iGA2,iGA3)                          *
*  -> add to global arrays; stub routine to ga_dadd...                 *
*     iGA3 = alpha * iGA1 + beta * iGA2                                *
*----------------------------------------------------------------------*
*     written by:                                                      *
*     M. Schuetz, University of Lund, Sweden, 1995                     *
*                                                                      *
*     modified by:                                                     *
*     R. Lindh, University of Lund, Sweden, 1998                       *
*     S. Vancoillie, University of Lund, Sweden, 2010-2015             *
************************************************************************
      SubRoutine GAInit
************************************************************************
*     purpose: initialize DGA and set the global rank and number of    *
*              processes in mpp_procid and mpp_nprocs. Then also set   *
*              the (initial) local myRank and nProcs variables.        *
*     called from: DPMP2 (distributed parallel MP2)                    *
*     calls to: MPI-2/DGA routines                                     *
************************************************************************
      Use Para_Info, Only: MyRank, nProcs
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: mpp_procid, mpp_nprocs, mpp_workshare
#endif
      Implicit None
#ifdef _MOLCAS_MPP_
#  include "global.fh"
      Character(Len=8) :: molcas_nprocs_env
      Integer :: molcas_nprocs, iRC

C     SVC: bypass MPI initialization if only 1 process, this is needed for a
C     specific version of GEO (so that the serial tasks which are run by MPI
C     do not try to re-initialize MPI). This has the consequence that for any
C     calculation where the number of processes is 1, calls to MPI/GA will fail
C     at runtime (even though it will compile when inside _MOLCAS_MPP_!)
      Call getenvf('MOLCAS_NPROCS',molcas_nprocs_env)
      If(molcas_nprocs_env(1:1).eq.' ') Then
         molcas_nprocs=-1
      Else
         Read(molcas_nprocs_env,*) molcas_nprocs
      End If
      If(molcas_nprocs.ne.1) Then
#  ifdef _GA_
         Call mpi_init(iRC)
         Call ga_initialize()
         Call ga_replace_ma()
#  else
         Call ga_initialize()
#  endif
         mpp_procid=ga_nodeid()
         mpp_nprocs=ga_nnodes()
         mpp_workshare = .True.
C make each slave process go to its proper work directory
         Call slaveschdir (mpp_procid, iRC)
         IF (iRC.NE.0) CALL Abend()
      Else
         mpp_procid=0
         mpp_nprocs=1
         mpp_workshare = .False.
      End If
      MyRank = mpp_procid
      nProcs = mpp_nprocs
#else
      MyRank=0
      nProcs=1
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GATerminate
CSVC: This terminates the parallel runtime after which the processes
C     are no longer allowed to make ga/mpi calls. When called more than
C     once, the routine does nothing. This is to support early
C     termination of the parallel runtime without actually exiting.
C     In such a situation, when the process eventually finishes, it
C     will call this routine again, but then doing nothing. Such a use
C     case is e.g. when we want to terminate slave processes and only
C     continue to run the master process in serial mode.
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: mpp_nprocs
#endif
      Implicit None
#ifdef _MOLCAS_MPP_
#  include "global.fh"
      Logical, Save :: FirstCall = .true.
#ifdef _GA_
      Integer iErr
#endif

      if (FirstCall) then
        FirstCall=.false.
        if(mpp_nprocs.gt.1) then
          Call ga_terminate()
#  ifdef _GA_
          Call mpi_finalize(iErr)
#  endif
        endif
      endif
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GASync
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
#ifdef _MOLCAS_MPP_
#  include "global.fh"

      If (Is_Real_Par()) Then
         Call ga_sync()
      End If
#endif
      Return
      End
*----------------------------------------------------------------------*
      Subroutine GABrdcst(dType,Buf,nByte,Root)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer       dType,nByte,Root
      Character(Len=*)  buf
#ifdef _MOLCAS_MPP_
#  include "global.fh"
      Interface
        Subroutine GA_Brdcst(type,buf,lenbuf,root)
          Integer type,lenbuf,root
          Type(*) buf
        End Subroutine GA_Brdcst
      End Interface

      If (Is_Real_Par()) CALL GA_Brdcst(dType,Buf,nByte,Root)
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(dType)
         Call Unused_character(Buf)
         Call Unused_integer(nByte)
         Call Unused_integer(Root)
      End If
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GAStp(msg,ierr)
      Implicit None
      Character*(*) msg
      Integer ierr
#ifdef _MOLCAS_MPP_
#  include "global.fh"

      Call ga_error(msg,ierr)
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_character(msg)
         Call Unused_integer(ierr)
      End If
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GADGOP(x,n,op)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer n
      Real*8 x(n)
      Character*(*) op
#ifdef _MOLCAS_MPP_
#  include "global.fh"
#  include "mafdecls.fh"

      If (Is_Real_Par()) Then
         Call ga_dgop(MT_DBL,x,n,op)
      End If
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(x)
         Call Unused_character(op)
      End If
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GAdGOp_Scal(x,op)
      Implicit None
      Real*8 x
      Character(Len=*) op
      Real*8 x_arr(1)

      x_arr(1)=x
      Call GAdGOp(x_arr,1,op)
      x=x_arr(1)
      End
*----------------------------------------------------------------------*
      SubRoutine GADSUM(x,n)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer n
      Real*8 x(n)
#ifdef _MOLCAS_MPP_
#  include "global.fh"
#  include "mafdecls.fh"

      If (Is_Real_Par()) Then
         Call ga_dgop(MT_DBL,x,n,'+')
      End If
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(x)
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GAdSum_Scal(x)
      Implicit None
      Real*8 x
      Real*8 x_arr(1)
      x_arr(1)=x
      Call GAdSum(x_arr,1)
      x=x_arr(1)
      End
*----------------------------------------------------------------------*
      SubRoutine GAIGOP(k,n,op)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer n
      Integer k(n)
      Character*(*) op
#ifdef _MOLCAS_MPP_
#  include "global.fh"
#  include "mafdecls.fh"

      If (Is_Real_Par()) Then
         Call ga_igop(MT_INT,k,n,op)
      End If
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(k)
         Call Unused_character(op)
      End If
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GAiGOp_Scal(k,op)
      Implicit None
      Integer k
      Character(Len=*) op
      Integer k_arr(1)

      k_arr(1)=k
      Call GAiGOp(k_arr,1,op)
      k=k_arr(1)
      End
*----------------------------------------------------------------------*
      SubRoutine GAAccP(iGA,ilo,ihi,jlo,jhi,buf,ld,alpha)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer iGA,ilo,ihi,jlo,jhi,ld
      Real*8 buf(1:ld,1:*),alpha
#ifdef _MOLCAS_MPP_
#  include "global.fh"

      If (Is_Real_Par()) Then
         Call ga_acc(iGA,ilo,ihi,jlo,jhi,buf,ld,alpha)
      End IF
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iGA)
         Call Unused_integer(ilo)
         Call Unused_integer(ihi)
         Call Unused_integer(jlo)
         Call Unused_integer(jhi)
         Call Unused_real_array(buf)
         Call Unused_real(alpha)
      End If
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GADupl(iGA1,iGA2)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer iGA1,iGA2
#ifdef _MOLCAS_MPP_
#  include "global.fh"
      Character gaLbl*5,gaLbl2*6
      Logical ok

      If (.Not. Is_Real_Par()) Return
      If (iGA1.ge.0) Return
      Call ga_inquire_name(iGA1,gaLbl)
      Write(gaLbl2,'(A,I1)') gaLbl,2

      ok=ga_duplicate(iGA1,iGA2,gaLbl2)
      If (.NOT.ok) Then
        Write (6,*) 'GADupl: ga_duplicate not OK!'
        Call GAStp('GADupl',42)
        Call Abend()
      End If

      Call ga_copy(iGA1,iGA2)
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iGA1)
         Call Unused_integer(iGA2)
      End If
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GAAdd(alpha,iGA1,beta,iGA2,iGA3)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: Is_Real_Par
#endif
      Implicit None
      Integer iGA1,iGA2,iGA3
      Real*8 alpha,beta
#ifdef _MOLCAS_MPP_
#  include "global.fh"

      If (.Not. Is_Real_Par()) Return
      If ((iGA1.ge.0).OR.(iGA2.ge.0).OR.(iGA3.ge.0)) Return
      Call ga_dadd(alpha,iGA1,beta,iGA2,iGA3)
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(alpha)
         Call Unused_integer(iGA1)
         Call Unused_real(beta)
         Call Unused_integer(iGA2)
         Call Unused_integer(iGA3)
      End If
#endif
      Return
      End
*----------------------------------------------------------------------*
      Integer Function GANodeID()
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: mpp_procid
#endif
      Implicit None
#ifdef _MOLCAS_MPP_
      GANodeID = mpp_procid
#else
      GANodeID = 0
#endif
      Return
      End
*----------------------------------------------------------------------*
      Integer Function GAnNodes()
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: mpp_nprocs
#endif
      Implicit None
#ifdef _MOLCAS_MPP_
      GAnNodes = mpp_nprocs
#else
      GAnNodes = 1
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine QpVInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of velocity quadrupole    *
*         integrals.                                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, February '91                            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variables
      Real*8 TC(3)
      Integer iStabO(0:7), iDCRT(0:7)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 210
      iPrint = nPrint(iRout)
*
      nip = 1
      ipB = nip
      nip = nip + nZeta
      ipS1 = nip
      nip = nip + nZeta*nElem(la)*nElem(lb+1)*3
      ipS2 =  1
      If (lb.gt.0) Then
         ipS2 = nip
         nip = nip + nZeta*nElem(la)*nElem(lb-1)*3
      End If
      ipRes = nip
      nip = nip + nZeta*nElem(la)*nElem(lb)*nComp
      If (nip-1.gt.nZeta*nArr) Then
         Call WarningMessage(2,' QpVInt: nip-1.gt.nZeta*nArr')
         Call Abend()
      End If
      ipArr = nip
      mArr = (nArr*nZeta - (nip-1))/nZeta
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
      iComp=3
      llOper = lOper(1)
      Do 90 iComp = 2, nComp
         llOper = iOr(llOper,lOper(iComp))
 90   Continue
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
      ipOff = ipB
      Do 100 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipOff),nAlpha)
         ipOff = ipOff + 1
 100  Continue
*
      Do 102 lDCRT = 0, nDCRT-1
         Call OA(iDCRT(lDCRT),Ccoor,TC)
*
         nHer = (la + (lb+1) + (nOrdOp-1) + 2) / 2
         Call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,
     &             Array(ipS1),nZeta,iComp,la,lb+1,A,RB,nHer,
     &             Array(ipArr),mArr,TC,nOrdOp-1)
*
         If (lb.gt.0) Then
            nHer = (la + (lb-1) + (nOrdOp-1) + 2) / 2
            Call MltPrm(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,
     &                Array(ipS2),nZeta,iComp,la,lb-1,A,RB,nHer,
     &                Array(ipArr),mArr,TC,nOrdOp-1)
         End If
*
*        Combine derivatives and dipole integrals to generate the
*        velocity quadrupole integrals.
*
         Call Util5(Array(ipB),nZeta,Array(ipRes),la,lb,Array(ipS1),
     &                                           Array(ipS2))
*
*--------Accumulate contributions
*
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array(ipRes),nZeta,la,lb,nComp,Final,nIC,
     &               nOp         ,lOper,iChO,One)
*
 102  Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine faibj2(IFTA,IFTB,ICOUP1,ICOUP,INDA,INDB,MYSYM,INTSYM,NYSYM,NSIJ,MYL,NYL,FACS,IPOA,IPOB,INMY,INNY,INDX,iTYP)

use mrci_global, only: IRC, LSYM, NSYM, NVIR
use Symmetry_Info, only: Mul
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: IFTA, IFTB, INDA, INDB, MYSYM, NYSYM, MYL, NYL, IPOA(9), IPOB(9), INMY, INNY
integer(kind=iwp), intent(in) :: ICOUP1, ICOUP, INTSYM(*), NSIJ, INDX(*), iTYP
real(kind=wp) :: FACS
integer(kind=iwp), external :: JSUNP

IFTA = 0
IFTB = 0
select case (ITYP)
  case (1)
    INDA = IRC(2)+ICOUP1
    INDB = IRC(2)+ICOUP
    IFTA = 1
    IFTB = 1
  case (2)
    INDA = IRC(3)+ICOUP1
    INDB = IRC(3)+ICOUP
  case (3)
    INDA = IRC(2)+ICOUP1
    INDB = IRC(3)+ICOUP
    IFTA = 1
  case (4)
    INDA = IRC(3)+ICOUP1
    INDB = IRC(2)+ICOUP
    IFTB = 1
  case (5)
    INDA = IRC(1)+ICOUP1
    INDB = IRC(1)+ICOUP
end select
!vv : unroll inline function to make GCC compiler works proper..
MYSYM = JSUNP(INTSYM,INDA)
NYSYM = MUL(MYSYM,NSIJ)
MYL = MUL(MYSYM,LSYM)
NYL = MUL(NYSYM,LSYM)
FACS = One
call IPO(IPOA,NVIR,MUL,NSYM,MYL,IFTA)
call IPO(IPOB,NVIR,MUL,NSYM,NYL,IFTB)
INMY = INDX(INDA)+1
INNY = INDX(INDB)+1

return

end subroutine faibj2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine dkh_cofu_spec(n,a,m,c)
C
C Special combination coefficients
C
      implicit none
      integer n,m,i
      Real*8 a(n),c(m),b(200)
      c(1)=a(m-1)
      do i=2,m-1
        c(i)=a(i-1)*a(m-i)*(-1)**(i-1)
      end do
      c(m)=a(m-1)*(-1)**(m-1)
*
      b(1  )=a(m)
      do i=2,m
        b(i)=a(i-1)*a(m-i+1)*(-1)**(i-1)
      end do
      b(m+1)=a(m)*(-1)**m
*
      do i=1,m
        c(i)=c(i)-b(i)
        b(i+1)=b(i+1)+b(i)
      end do
      if(abs(b(m+1)).gt.1.d-12)then
        write(6,*) "Error in dkh_dkcof_sp",b(m+1)
        call Abend
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module ISO_C_UTILITIES

use, intrinsic :: iso_c_binding, only: c_associated, c_char, c_f_pointer, c_ptr, c_size_t

implicit none
private

character(kind=c_char), save, target :: dummy_string(1) = "?"

public :: C_F_STRING

contains

function C_F_STRING(CPTR) result(FPTR)
  ! Convert a null-terminated C string into a Fortran character array pointer

  interface ! strlen is a standard C function from <string.h>
    ! int strlen(char *string)
    function strlen(string) result(len) bind(C,name="strlen")
      import :: c_size_t, c_ptr
      type(c_ptr), value :: string ! A C pointer
      integer(kind=c_size_t) :: len
    end function
  end interface

  type(c_ptr), intent(in) :: CPTR ! The C address
  character(kind=c_char), pointer :: FPTR(:)

  if (c_associated(CPTR)) then
    call c_f_pointer(FPTR=FPTR,CPTR=CPTR,shape=[strlen(CPTR)])
  else
    ! To avoid segfaults, associate FPTR with a dummy target:
    FPTR => dummy_string
  end if

end function

end module ISO_C_UTILITIES

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SONATORB_PLOT(DENS,FILEBASE,CHARTYPE,ASS,BSS)

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use Symmetry_Info, only: nIrrep
use rassi_data, only: NBASF, NBMX, NBSQ, NBST, NBTRI
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: DENS(6,NBTRI)
character(len=*), intent(in) :: FILEBASE
character(len=8), intent(in) :: CHARTYPE
integer(kind=iwp), intent(in) :: ASS, BSS
integer(kind=iwp) :: I, I1, I2, ICMP, ID1, ID2, IDIR, iDummy(7,8), IEND, II, II2, IJ, INV, IOCC, IOPT, IRC, ISCR, ISTART, ISYLAB, &
                     ISYM, ITYPE, J, JI, LE, LE1, LS, LS1, LuXXVEC, LV, LV1, NB, NBMX2
real(kind=wp) :: Dummy(1)
character(len=25) :: FNAME
character(len=16) :: FNUM, KNUM, XNUM
character(len=8) :: LABEL
character :: CDIR
real(kind=wp), allocatable :: DMAT(:), EIG(:), OCC(:), SCR(:), SZZ(:), VEC(:), VEC2(:), VNAT(:)
integer(kind=iwp), external :: IsFreeUnit

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! PLOTTING SECTION
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! Get the proper type of the property
ITYPE = 0
if (CHARTYPE == 'HERMSING') ITYPE = 1
if (CHARTYPE == 'ANTISING') ITYPE = 2
if (CHARTYPE == 'HERMTRIP') ITYPE = 3
if (CHARTYPE == 'ANTITRIP') ITYPE = 4
if (ITYPE == 0) then
  write(u6,*) 'RASSI/SONATORB internal error.'
  write(u6,*) 'Erroneous property type:',CHARTYPE
  call ABEND()
end if

NBMX2 = NBMX**2

! SZZ  - AO Overlap integral
! VEC  - AO Overlap eigenvectors
! EIG  - AO Overlap eigenvalues
! VEC2 - Eigenvectors of density matrix
! SCR  - Temporary for matrix multiplication
! NOTE: SCR COULD PROBABLY BE SOMETHING LIKE nTri_Elem(NBMX)
!       ALTHOUGH IT PROBABLY DOESN'T SAVE MUCH
!       (JACOB TAKES A TRIANGULAR MATRIX LIKE ZHPEV DOES?)
call mma_allocate(SZZ,NBTRI,Label='SZZ')
call mma_allocate(VEC,NBSQ,Label='VEC')
call mma_allocate(VEC2,NBMX2,Label='VEC2')
call mma_allocate(SCR,NBMX2,Label='SCR')
call mma_allocate(EIG,NBST,Label='EIG')
SZZ(:) = Zero
VEC(:) = Zero
VEC2(:) = Zero
SCR(:) = Zero
EIG(:) = Zero

call mma_allocate(VNAT,NBSQ,Label='VNAT')
VNAT(:) = Zero
call mma_allocate(OCC,NBST,Label='OCC')
OCC(:) = Zero

! READ ORBITAL OVERLAP MATRIX.
IRC = -1

! IOPT=6, origin and nuclear contrib not read
IOPT = ibset(ibset(0,sNoOri),sNoNuc)
ICMP = 1
ISYLAB = 1
LABEL = 'MLTPL  0'
call RDONE(IRC,IOPT,LABEL,ICMP,SZZ,ISYLAB)
if (IRC /= 0) then
  write(u6,*)
  write(u6,*) '      *** ERROR IN SUBROUTINE  SONATORB ***'
  write(u6,*) '      OVERLAP INTEGRALS ARE NOT AVAILABLE'
  write(u6,*)
  call ABEND()
end if

! DIAGONALIZE EACH SYMMETRY BLOCK OF THE OVERLAP MATRIX.
LS = 1
LV = 1
LE = 1
do ISYM=1,nIrrep
  NB = NBASF(ISYM)
  call unitmat(VEC(LV:LV+NB**2-1),NB)
  call JACOB(SZZ(LS),VEC,NB,NB)
  ! SCALE EACH VECTOR TO OBTAIN AN ORTHONORMAL BASIS.
  LS1 = LS
  LV1 = LV
  LE1 = LE
  do I=1,NB
    EIG(LE1) = SZZ(LS1)
    VEC(LV1:LV1+NB-1) = VEC(LV1:LV1+NB-1)/sqrt(max(SZZ(LS1),1.0e-14_wp))
    LS1 = LS1+I+1
    LV1 = LV1+NB
    LE1 = LE1+1
  end do
  LS = LS+nTri_Elem(NB)
  LV = LV+NB**2
  LE = LE+NB
end do

call mma_deallocate(SZZ)

call mma_allocate(DMAT,NBMX2,Label='DMAT')

if (ITYPE <= 2) then
  ISTART = 3
  IEND = 3
else
  ISTART = 1
  IEND = 3
end if

do IDIR=ISTART,IEND

  CDIR = '?'
  if (IDIR == 1) CDIR = 'X'
  if (IDIR == 2) CDIR = 'Y'
  if (IDIR == 3) CDIR = 'Z'

  INV = 1
  II2 = 0
  IOCC = 0
  LV = 1
  LE = 1
  do ISYM=1,nIrrep
    NB = NBASF(ISYM)
    if (NB == 0) cycle

    ! TRANSFORM TO ORTHONORMAL BASIS. THIS REQUIRES THE CONJUGATE
    ! BASIS, BUT SINCE WE USE CANONICAL ON BASIS THIS AMOUNTS TO A
    ! SCALING WITH THE EIGENVALUES OF THE OVERLAP MATRIX:

    ! expand the triangular matrix for this symmetry to a square matrix
    DMAT(:) = Zero
    SCR(:) = Zero
    do J=1,NB
      do I=1,J
        II2 = II2+1
        IJ = NB*(J-1)+I
        JI = NB*(I-1)+J
        if (I /= J) then
          DMAT(IJ) = DENS(IDIR,II2)/Two
          DMAT(JI) = DENS(IDIR,II2)/Two
        else
          DMAT(IJ) = DENS(IDIR,II2)
        end if
      end do
    end do

    call DGEMM_('N','N',NB,NB,NB,One,DMAT,NB,VEC(LV),NB,Zero,SCR,NB)
    call DGEMM_('T','N',NB,NB,NB,One,VEC(LV),NB,SCR,NB,Zero,DMAT,NB)

    ID1 = 1
    ID2 = 1
    do I=1,NB
      call DSCAL_(NB,EIG(LE-1+I),DMAT(ID1),NB)
      DMAT(ID2:ID2+NB-1) = EIG(LE-1+I)*DMAT(ID2:ID2+NB-1)
      ID1 = ID1+1
      ID2 = ID2+NB
    end do

    ! SYMMETRIZE THIS BLOCK INTO SCRATCH AREA, TRIANGULAR STORAGE:
    SCR(:) = Zero
    ISCR = 1
    do I=1,NB
      do J=1,I
        IJ = I+NB*(J-1)
        JI = J+NB*(I-1)
        ! simple averaging
        SCR(ISCR) = (DMAT(IJ)+DMAT(JI))/Two

        ! add a factor of two to convert spin -> sigma
        if (ITYPE >= 3) SCR(ISCR) = SCR(ISCR)*Two
        ISCR = ISCR+1
      end do
    end do

    ! DIAGONALIZE THE DENSITY MATRIX BLOCK:
    call unitmat(VEC2,NB)

    call JACOB(SCR,VEC2,NB,NB)
    call JACORD(SCR,VEC2,NB,NB)

    ! JACORD ORDERS BY INCREASING EIGENVALUE. REVERSE THIS ORDER.
    II = 0
    do I=1,NB
      II = II+I
      OCC(IOCC+NB+1-I) = SCR(II)
    end do
    IOCC = IOCC+NB

    ! REEXPRESS THE EIGENVALUES IN AO BASIS FUNCTIONS. REVERSE ORDER.
    call DGEMM_('N','N',NB,NB,NB,One,VEC(LV),NB,VEC2,NB,Zero,SCR,NB)
    I1 = 1
    I2 = INV+NB**2
    do I=1,NB
      I2 = I2-NB
      VNAT(I2:I2+NB-1) = SCR(I1:I1+NB-1)
      I1 = I1+NB
    end do
    INV = INV+NB**2
    LV = LV+NB**2
    LE = LE+NB

  end do

  ! WRITE OUT THIS SET OF NATURAL SPIN ORBITALS
  if (ITYPE <= 2) then
    write(KNUM,'(I2.2,A,I2.2)') ASS,'.',BSS
  else
    write(KNUM,'(I2.2,A,I2.2,A,A)') ASS,'.',BSS,'.',CDIR
  end if
  write(FNUM,'(I8)') BSS
  FNUM = adjustl(FNUM)
  if (ASS /= BSS) then
    write(XNUM,'(I8,A)') ASS,'_'//trim(FNUM)
    FNUM = adjustl(XNUM)
  end if
  if (ITYPE > 2) FNUM = CDIR//trim(FNUM)

  FNAME = FILEBASE//'.'//trim(FNUM)
  if (ITYPE == 1) write(u6,'(A,A)') ' NATURAL ORBITALS FOR ',KNUM
  if (ITYPE == 2) write(u6,'(A,A)') ' ANTISING NATURAL ORBITALS FOR  ',KNUM
  if (ITYPE == 3) write(u6,'(A,A)') ' NATURAL SPIN ORBITALS FOR  ',KNUM
  if (ITYPE == 4) write(u6,'(A,A)') ' ANTITRIP NATURAL ORBITALS FOR  ',KNUM

  write(u6,'(A,A)') ' ORBITALS ARE WRITTEN ONTO FILE ',FNAME

  LuxxVec = isfreeunit(50)

  call WRVEC(FNAME,LUXXVEC,'CO',nIrrep,NBASF,NBASF,VNAT,OCC,Dummy,iDummy,'* DENSITY FOR PROPERTY TYPE '//CHARTYPE//KNUM)

  ! Test a few values
  !call ADD_INFO('SONATORB_PLOT',VNAT,1,4)

  ! ONLY FOR NATURAL ORBITALS
  if (ITYPE == 1) call ADD_INFO('SONATORB_NO_OCC',OCC,sum(NBASF),4)

end do

call mma_deallocate(DMAT)
call mma_deallocate(VEC)
call mma_deallocate(VEC2)
call mma_deallocate(SCR)
call mma_deallocate(EIG)
call mma_deallocate(VNAT)
call mma_deallocate(OCC)

end subroutine SONATORB_PLOT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ORTHO_MOTRA(nSym,nBas,nDel,Ovlp,CMO)
! Objective: Orthonormalize input vectors
!           (Gram-Schmidt orthogonaliztion)

use motra_global, only: N2MAX
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nDel(nSym)
real(kind=wp), intent(in) :: Ovlp(*)
real(kind=wp), intent(inout) :: CMO(*)
integer(kind=iwp) :: IJ, IM, ISYM, NORBI
real(kind=wp), allocatable :: W1(:), W2(:), W3(:)

! Allocate work space

call mma_allocate(W1,N2MAX,label='SCR1')
call mma_allocate(W2,N2MAX,label='SCR2')
call mma_allocate(W3,N2MAX,label='SCR3')

! Loop over symmetries and orthogonalize

IJ = 1
IM = 1
do ISYM=1,NSYM
  NORBI = NBAS(ISYM)-NDEL(ISYM)
  if (NORBI > 0) then
    call SQUARE(OVLP(IJ),W3,1,NBAS(ISYM),NBAS(ISYM))
    call DGEMM_('N','N',NBAS(ISYM),NORBI,NBAS(ISYM),One,W3,NBAS(ISYM),CMO(IM),NBAS(ISYM),Zero,W2,NBAS(ISYM))
    call DGEMM_('T','N',NORBI,NORBI,NBAS(ISYM),One,CMO(IM),NBAS(ISYM),W2,NBAS(ISYM),Zero,W1,NORBI)
    call ORTHOX_MOTRA(W1,CMO(IM),NORBI,NBAS(ISYM))
  end if
  IJ = IJ+NBAS(ISYM)*(NBAS(ISYM)+1)/2
  IM = IM+NBAS(ISYM)*NBAS(ISYM)
end do

! Deallocate work space and exit

call mma_deallocate(W1)
call mma_deallocate(W2)
call mma_deallocate(W3)

return

end subroutine ORTHO_MOTRA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Roland Lindh                                     *
************************************************************************
      SubRoutine IniBuf(nDisc,nCore)
!***********************************************************************
!                                                                      *
!  Object: Initiate I/O buffer for semi-direct SCF                     *
!                                                                      *
! Called from:                                                         *
!                                                                      *
! Calling    :                                                         *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chemical Physics,                 *
!             University of Lund, Sweden. October '98                  *
!***********************************************************************
      use IOBUF
      Implicit Real*8 (A-H,O-Z)
#include "stdalloc.fh"
      External AllocDisk
      Integer AllocDisk
*
*     Open file for semi-direct implementation
*     nDisc in units of MByte
*     nCore in units of kByte
*
*
*     The maximum number of bytes on disk. The file size limit times
*     the number of multi files.
*
      DiskMx_MByte=DBLE(AllocDisk())*10.0D0
      DiskMx_Byte=DBLE(AllocDisk())*10.0D0*2.00**20
*
      nBuf=-99
      If (nDisc.eq.0.and.nCore.eq.0) Then
         OnDisk=.False.
         Incore=.False.
      Else If (nDisc*1024.gt.nCore) Then
         OnDisk=.True.
         Incore=.False.
         LuTMp = 32
         Call EAFOpen(LuTmp,'SMDINT  ')
         nBuf=2
      Else
         OnDisk=.False.
         InCore=.True.
         nBuf=1
      End If
*
*---- Adjust buffer size and allocate memory for the buffer.
*
      If (OnDisk.or.InCore) Then
         MemMin_Seward=1024**2 ! Real*8
         Call mma_maxDBLE(MaxMem)
*        lBuf in units of Real*8 per buffer
         lBuf=(1024*nCore)/(8*nBuf)
         if(InCore) then
         MemReq=MemMin_Seward + lBuf*nBuf
*        Write (6,*) 'MemReq,MaxMem=',MemReq,MaxMem,'  lbuf=',lbuf
         If (MemReq.gt.MaxMem) Then
            lBuf=(MaxMem-MemMin_Seward)/nBuf
            If (lBuf.lt.0) Then
               nCore=(((MaxMem*3)/4)*8)/1024
            Else
               nCore=(lBuf*8)/1024
            End If
         Else
            nCore=(lBuf*8)/1024
         End If
         nCore=((nCore+7)/8)*8
         lBuf=(1024*nCore)/(8*nBuf)
         end if
C        Write (6,*) 'OnDisk=',OnDisk
C        Write (6,*) 'Incore=',Incore
C        Write (6,*) 'nBuf=',nBuf
C        Write (6,*) 'IniBuf: nDisc=',nDisc,'MByte'
C        Write (6,*) 'nCore=',nCore,'kByte'
C        Write (6,*) 'lBuf=',lBuf
*
*------- Allocate I/O Buffer
         Call mma_allocate(Buffer,lBuf,nBuf,Label='Buffer')
      End If
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WLBuf
      Use dEAF
      Use IOBUF
      Implicit Real*8 (a-h,o-z)
#include "SysDef.fh"
*
      If (iStatIO.eq.Mode_Read) Then
*        Write (6,*) 'In WLbuf'
         If (OnDisk) Call EAFWait(LuTmp,id)
         Return
      End If
c     Disk_Save=Disk
*     Write (6,*) 'Enter WLBuf: Disk,iPos,iBuf=',Disk,iPos,iBuf
      If (InCore.and.iBuf.eq.2) Then
         Call WarningMessage(2,
     &               'Error in in-core semi-direct implementation')
         Call Abend()
      End If
*
*---- If any data in buffer write buffer to disk.
*
      If (OnDisk) Then
*        Write (6,*) 'In WLbuf'
         Call EAFWait(LuTmp,id)
      End If
      If (iPos.ne.1) Then
         temp=Disk+DBLE(lBuf*RtoB)
*        Write (6,*) 'temp,DiskMx_Byte=',temp,DiskMx_Byte
         If (temp.le.DiskMx_Byte) Then
            Disk_2 = Disk_1
            Disk_1 = Disk
*           If (OnDisk) Write (*,*) 'Disk=',Disk,' lBuf*RtoI=',lBuf*RtoI
c           Write (6,*) 'WLBuf write on disk @',Disk,'iBuf=',iBuf
            If (OnDisk) Call dEAFWrite(LuTmp,Buffer(1,iBuf),
     &                                lBuf*RtoI,Disk)
*---------- Put a dummy record at the end
            temp=Disk+DBLE(lBuf*RtoB)
*           Write (6,*) 'temp,DiskMx_Byte=',temp,DiskMx_Byte
            If (temp.le.DiskMx_Byte.and.OnDisk) Then
c              Write (6,*) 'WLBuf write on disk @',Disk,'iBuf=',iBuf
               Zero=0.0D0
               Call dCopy_(lBuf,[Zero],0,Buffer(1,iBuf),1)
               Call dEAFWrite(LuTmp,Buffer(1,iBuf),lBuf*RtoI,Disk)
            End If
         Else
            Call WarningMessage(2,'WLBuf: Disc is full!')
            Write (6,*) 'temp           =',temp
            Write (6,*) 'DiskMx_Byte    =',DiskMx_Byte
            Call FastIO('STATUS')
            Call Abend()
         End If
      End If
      iPos = 1
*
c     If (Disk_save.ne.Disk) Then
c        Write (6,*) 'Enter WLBuf: Disk @:',Disk_Save
c        Write (6,*) 'Exit  WLBuf: Disk @:',Disk
c     End If
*     Write (*,*) 'Exit WLBuf: Disk,iPos,iBuf=',Disk,iPos,iBuf
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine xabort(rc)
C     this routine aborts the process(es) with rc
#ifdef _MOLCAS_MPP_
      use mpi
#endif
      implicit none
      integer :: rc
#ifdef _MOLCAS_MPP_
#include "para_info.fh"
      integer*4 :: rc4, ierr4
#endif

#ifdef _MOLCAS_MPP_
      if (is_real_par()) then
C     unlike abort, mpi_abort does not print a backtrace,
C     so we do it manually here
        call xbacktrace
        rc4 = int(rc,kind(rc4))
        call mpi_abort(MPI_COMM_WORLD,rc4,ierr4)
      else
#endif

#if defined (__GNUC__) || defined(__INTEL_COMPILER)
        call abort
#else
        stop 'Molcas aborted...'
#endif

#ifdef _MOLCAS_MPP_
      end if
#else
c Avoid unused argument warnings
      if (.false.) call Unused_integer(rc)
#endif
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
*               2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine PLF_LDF_2Indx_11(TInt,nTInt,
     &                            AOint,ijkl,
     &                            iCmp,jCmp,kCmp,lCmp,
     &                            iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*          Modified for Local DF, Thomas Bondo Pedersen, Oct. 2010     *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit None
      Integer nTInt
      Real*8  TInt(nTInt)
      Integer ijkl, iCmp, jCmp, kCmp, lCmp
      Real*8  AOInt(ijkl,iCmp,jCmp,kCmp,lCmp)
      Integer iAO(4), iAOst(4)
      Integer iBas, jBas, kBas, lBas
      Integer kOp(4)
#include "localdf_bas.fh"
#include "localdf_int3.fh"
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      Character*16 SecNam
      Parameter (SecNam='PLF_LDF_2Indx_11')
#endif

      Integer i1, i2, i3, i4
      Integer jSO, lSO
      Integer jSOj, lSOl
      Integer nijkl, ip0

      Integer i
      Integer iShlSO
#if defined (_DEBUGPRINT_)
      Integer iSOShl, nBasSh
      iSOShl(i)=iWork(ip_iSOShl-1+i)
      nBasSh(i)=iWork(ip_nBasSh-1+i)
#endif
      iShlSO(i)=iWork(ip_iShlSO-1+i)

#if defined (_DEBUGPRINT_)
      If (iSOShl(iAOtSO(iAO(1)+1,kOp(1))+iAOst(1)).ne.SHA) Then
         Call WarningMessage(2,SecNam//': Shell problem [1]')
         Call LDF_Quit(1)
      End If
      If (iSOShl(iAOtSO(iAO(2)+1,kOp(2))+iAOst(2)).ne.SHB) Then
         Call WarningMessage(2,SecNam//': Shell problem [2]')
         Call LDF_Quit(1)
      End If
      If (iSOShl(iAOtSO(iAO(3)+1,kOp(3))+iAOst(3)).ne.SHC) Then
         Call WarningMessage(2,SecNam//': Shell problem [3]')
         Call LDF_Quit(1)
      End If
      If (iSOShl(iAOtSO(iAO(4)+1,kOp(4))+iAOst(4)).ne.SHD) Then
         Call WarningMessage(2,SecNam//': Shell problem [4]')
         Call LDF_Quit(1)
      End If
      If (iCmp*iBas.ne.1) Then
         Call WarningMessage(2,SecNam//': Shell dimension problem [1]')
         Call LDF_Quit(1)
      End If
      If (jCmp*jBas.ne.nBasSh(SHB)) Then
         Call WarningMessage(2,SecNam//': Shell dimension problem [2]')
         Call LDF_Quit(1)
      End If
      If (kCmp*kBas.ne.1) Then
         Call WarningMessage(2,SecNam//': Shell dimension problem [3]')
         Call LDF_Quit(1)
      End If
      If (lCmp*lBas.ne.nBasSh(SHD)) Then
         Call WarningMessage(2,SecNam//': Shell dimension problem [4]')
         Call LDF_Quit(1)
      End If
#endif

      i1=1
      i3=1
      Do i4=1,lCmp
         lSO=iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
         Do i2=1,jCmp
            jSO=iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
            nijkl=0
            Do lSOl=lSO,lSO+lBas-1
               ip0=nRow*(iCol0+iShlSO(lSOl)-1)+iRow0
               Do jSOj=jSO,jSO+jBas-1
                  nijkl=nijkl+1
                  TInt(ip0+iShlSO(jSOj))=AOInt(nijkl,i1,i2,i3,i4)
               End Do
            End Do
         End Do
      End Do

#ifndef _DEBUGPRINT_
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iBas)
         Call Unused_integer(kBas)
      End If
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine coreB(iang,lb,ishll,nordop,TC,RB,Array,narr,Beta,nBeta,fb1,fb2,jfgrad,jfhess,ld,debug)
!  Calculates <core|B'> and <core|B">
!
! @parameter iang Angular momenta for core
! @parameter lb Angular momenta for ket
! @parameter ishll identification for core shell
! @parameter nordop order for operator
! @parameter TC Cartesian coordinates for core
! @parameter RB Cartesian coordinates for ket
! @parameter Array Scratch
! @parameter narr size for scratch
! @parameter Beta Ket exponents
! @parameter nBeta number of exponents
! @parameter FB1 First derivatives (out)
! @parameter FB2 2nd derivatives (out)
! @parameter jfgrad true for all 1-derivatives that are needed
! @parameter jfhess true for all 2-derivatives that are needed
! @parameter ld Order of derivatives
! @parameter debug guess

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: Shells
use Her_RW, only: HerR, HerW, iHerR, iHerW
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iang, lb, ishll, nordop, narr, nBeta, ld
real(kind=wp), intent(in) :: TC(3), RB(3), Beta(nBeta)
real(kind=wp), intent(inout) :: Array(*), fb2(*)
real(kind=wp), intent(_OUT_) :: fb1(*)
logical(kind=iwp), intent(in) :: jfgrad(3), jfhess(4,3,4,3), debug
integer(kind=iwp) :: i, iBeta, ip, ipB, ipBxyz, ipCxyz, ipK2, ipP2, ipQ1, ipRxyz, ipV, ipZ2, ipZI2, iStrt, n, nExpi, nHer, nVecCB
logical(kind=iwp) :: ABeq(3)
real(kind=r8), external :: DNrm2_

nExpi = Shells(iShll)%nExp
if (debug) write(u6,*) 'Shell: ',ishll,' nBeta:',nBeta,' nExp:',nExpi,'Angular',lb,iang

ip = 1
ipP2 = ip
ip = ip+3*nExpi*nBeta
ipZ2 = ip
ip = ip+nExpi*nBeta
ipK2 = ip
ip = ip+nExpi*nBeta
ipZI2 = ip
ip = ip+nExpi*nBeta
if (ip-1 > nArr) then
  write(u6,*) '  ip-1 > nArr*nZeta(2) in bcore (',ip,',',narr,')'
  call Abend()
end if

! Calculate Effective center and exponent for <core|B>

call ZXia(Array(ipZ2),Array(ipZI2),nExpi,nBeta,Shells(iShll)%Exp,Beta)
call SetUp1(Shells(iShll)%Exp,nExpi,Beta,nBeta,TC,RB,Array(ipK2),Array(ipP2),Array(ipZI2))

! Calculate Overlap <core|B> and <core|B'>

nHer = (lb+1+iAng+1+ld)/2
ipCxyz = ip
ip = ip+nBeta*nExpi*3*nHer*(iAng+1)
ipBxyz = ip
ip = ip+nBeta*nExpi*3*nHer*(lb+1+ld)
ipRxyz = ip
ip = ip+nBeta*nExpi*3*nHer*(nOrdOp+1)
ipQ1 = ip
ip = ip+nBeta*nExpi*3*(iAng+1)*(lb+1+ld)*(nOrdOp+1)
ipB = ip
ip = ip+nBeta*nExpi
if (ip-1 > nArr) then
  write(u6,*) '  ip-1 > nArr*nZeta(2b) in coreB'
  call Abend()
end if
ABeq(1) = TC(1) == RB(1)
ABeq(2) = TC(2) == RB(2)
ABeq(3) = TC(3) == RB(3)
if (debug) write(u6,*) 'shll=',ishll,' nExp=',nExpi,' nBeta=',nBeta
call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,TC,Array(ipCxyz),iAng,HerR(iHerR(nHer)),nHer,ABeq)
call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,RB,Array(ipBxyz),lb+ld,HerR(iHerR(nHer)),nHer,ABeq)
ABeq(1) = .false.
ABeq(2) = .false.
ABeq(3) = .false.
call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,TC,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)
if (debug) then
  write(u6,*) ' nBeta  = ',nBeta,' nExp(',ishll,')=',nExpi,' nHer=',nHer,' lb=',lb,' iAng=',iAng,' nOrdOp=',nOrdOp

  write(u6,*) ' Array(ipCxyz)=',DNrm2_(nBeta*nExpi*3*nHer*(iAng+1),Array(ipCxyz),1)
  write(u6,*) ' Array(ipBxyz)=',DNrm2_(nBeta*nExpi*3*nHer*(lb+2),Array(ipBxyz),1)
  write(u6,*) ' Array(ipRxyz)=',DNrm2_(nBeta*nExpi*3*nHer*(nOrdOp+1),Array(ipRxyz),1)
end if

call Assmbl(Array(ipQ1),Array(ipCxyz),iAng,Array(ipRxyz),nOrdOp,Array(ipBxyz),lb+ld,nExpi*nBeta,HerW(iHerW(nHer)),nHer)
iStrt = ipB
do iBeta=1,nBeta
  Array(iStrt:iStrt+nExpi-1) = Beta(iBeta)
  iStrt = iStrt+nExpi
end do
if (debug) then
  write(u6,*) ' Array(ipB)=',DNrm2_(nExpi*nBeta,Array(ipB),1)
end if

call rKappa_Zeta(Array(ipK2),Array(ipZ2),nExpi*nBeta)
call CmbnCB(Array(ipQ1),nExpi*nBeta,iAng,lb,Array(ipK2),FB1,Array(ipB),JfGrad,ld,nVecCB)
if (debug) then
  write(u6,*) ' Array(ipQ1)=',DNrm2_(nExpi*nBeta*3*(lb+1+ld+2)*(iAng+1)*(nOrdOp+1),Array(ipQ1),1)
  write(u6,*) ' Array(ipB)=',DNrm2_(nExpi*nBeta,Array(ipB),1)
end if
if (ld >= 2) then
  call CmbnS2b(Array(ipQ1),nBeta*nExpi,iang,lb,Array(ipK2),FB2,Array(ipB),jfHess,ld)
  if (debug) then
    do i=1,6
      ipV = 1
      n = nBeta*nExpi*nTri_Elem1(lb)*nTri_Elem1(iAng)
      write(u6,*) n,nBeta,nExpi,nTri_Elem1(lb),nTri_Elem1(iAng)

      write(u6,*) 'CmbnB2(',n,')=',DNrm2_(n,FB2(ipV),1)
      ipV = ipV+n
    end do
  end if
end if

return

end subroutine coreB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PotNuc_nad(nSym,nAtoms,ReCharge,ZRE_nad)
!***********************************************************************
!                                                                      *
!     purpose: Computes NAD part of the Nuclear Repulsion Energy.      *
!              An array of reference charges (ReCharge) is used to     *
!              identify which atoms were alternating as ghosts         *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Constants, only: Angstrom
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nSym, nAtoms
real(kind=wp), intent(in) :: ReCharge(nAtoms)
real(kind=wp), intent(out) :: ZRE_nad
integer(kind=iwp) :: iAll_Atom, iAt, iAtom, iChAtom, iCo, iCoSet(0:7,0:7), iGen(3), iOper(0:7), iStab(0:7), jAt, kAt, MaxDCR, &
                     nCoSet, nGen, nStab
real(kind=wp) :: Charge_, pCharge, pq_rep, qCharge, Rpq, Xpq, Ypq, Zpq
real(kind=wp), allocatable :: Coor(:,:), Charge(:)
integer(kind=iwp), external :: iChxyz

!----------------------------------------------------------------------*
! Prologue                                                             *
!----------------------------------------------------------------------*
!----------------------------------------------------------------------*
! Read symm. oper per symm. species                                    *
!----------------------------------------------------------------------*
call Get_iArray('Symmetry operations',iOper,nSym)
!----------------------------------------------------------------------*
! Read atom Charges                                                    *
!----------------------------------------------------------------------*
call mma_allocate(Charge,8*nAtoms,Label='Charge')
call Get_dArray('Effective nuclear Charge',Charge,nAtoms)
!----------------------------------------------------------------------*
! Read coordinates of atoms                                            *
!----------------------------------------------------------------------*
call mma_allocate(Coor,3,8*nAtoms,Label='Coor')
call Get_dArray('Unique Coordinates',Coor,3*nAtoms)
!----------------------------------------------------------------------*
! Apply the symmetry operations                                        *
!----------------------------------------------------------------------*
nGen = 0
if (nSym == 2) nGen = 1
if (nSym == 4) nGen = 2
if (nSym == 8) nGen = 3
if (nGen >= 1) iGen(1) = iOper(1)
if (nGen >= 2) iGen(2) = iOper(2)
if (nGen >= 3) iGen(3) = iOper(4)

iAll_Atom = 0
MaxDCR = 0
iAll_Atom = nAtoms
do iAtom=1,nAtoms
  iChAtom = iChxyz(Coor(:,iAtom),iGen,nGen)
  call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
  nCoSet = nSym/nStab
  Charge_ = Charge(iAtom)

  do iCo=1,nCoSet-1

    iAll_Atom = iAll_Atom+1
    Charge(iAll_Atom) = Charge_

    call OA(iCoSet(iCo,0),Coor(:,iAtom),Coor(:,iAll_Atom))

  end do

end do

!----------------------------------------------------------------------*
! Compute NAD part of the nuclear repulsion energy                     *
!----------------------------------------------------------------------*
ZRE_nad = Zero

if (ReCharge(1) > Zero) then

  do jAt=0,iAll_Atom-1
    pCharge = Charge(jAt+1)
    if (pCharge > Zero) then
      do iAt=0,jAt-1  ! loop downwards
        kAt = mod(iAt+1,nAtoms)
        if (kAt == 0) kAt = nAtoms
        qCharge = ReCharge(kAt)
        if (qCharge > Zero) then
          Xpq = Coor(1,iAt+1)-Coor(1,jAt+1)
          Ypq = Coor(2,iAt+1)-Coor(2,jAt+1)
          Zpq = Coor(3,iAt+1)-Coor(3,jAt+1)
          Rpq = sqrt(Xpq**2+Ypq**2+Zpq**2)
          pq_rep = pCharge*qCharge/Rpq
          ZRE_nad = ZRE_nad+pq_rep
        end if
      end do
    end if
  end do

else

  do jAt=0,iAll_Atom-1
    pCharge = Charge(jAt+1)
    if (pCharge > Zero) then
      do iAt=jAt+1,iAll_Atom-1   ! loop upwards
        kAt = mod(iAt+1,nAtoms)
        if (kAt == 0) kAt = nAtoms
        qCharge = ReCharge(kAt)
        if (qCharge > Zero) then
          Xpq = Coor(1,iAt+1)-Coor(1,jAt+1)
          Ypq = Coor(2,iAt+1)-Coor(2,jAt+1)
          Zpq = Coor(3,iAt+1)-Coor(3,jAt+1)
          Rpq = sqrt(Xpq**2+Ypq**2+Zpq**2)
          pq_rep = pCharge*qCharge/Rpq
          ZRE_nad = ZRE_nad+pq_rep
        end if
      end do
    end if
  end do

end if

#ifdef _DEBUGPRINT_
!----------------------------------------------------------------------*
! Print coordinates of the system  / ZRE_nad energy                    *
!----------------------------------------------------------------------*
write(u6,*)
write(u6,'(6X,A)') 'Atoms cartesian coordinates in angstrom:'
write(u6,'(6X,A)') '-----------------------------------------------'
write(u6,'(6X,A)') 'No.  Charge A/B      X         Y         Z     '
write(u6,'(6X,A)') '-----------------------------------------------'
do iAt=0,iAll_Atom-1
  kAt = mod(iAt+1,nAtoms)
  write(u6,'(4X,I4,2X,F4.0,1X,F4.0,2X,3F10.5)') iAt+1,Charge(1+iAt),ReCharge(kAt),Angstrom*Coor(:,iAt+1)
end do
write(u6,'(6X,A)') '-----------------------------------------------'
write(u6,'(6X,A,F12.6)') 'Nuclear repulsion energy (NAD) =',ZRE_nad
write(u6,*)
write(u6,*)
#endif
!----------------------------------------------------------------------*
! Normal exit                                                          *
!----------------------------------------------------------------------*
call mma_deallocate(Coor)
call mma_deallocate(Charge)

return

end subroutine PotNuc_nad

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Do_P2GLM(P2mo,np2act,D1mo,nd1mo,TabMO,mAO,mGrid,nMOs,
     &                   P2_ontop,nP2_ontop,RhoI,RhoA,mRho,Do_Grad)
************************************************************************
*                                                                      *
* Object: Calculation P2 ontop density and its derivatives             *
*                                                                      *
* Called from: Do_batch                                                *
*                                                                      *
* Calling    : FZero                                                   *
*                                                                      *
*    INPUT:                                                            *
*   P2mo     = two-body density matrix in MO basis                     *
*   np2act   = size of P2mo                                            *
*   D1mo     = one-body density matrix in MO basis                     *
*   nd1mo    = size of D1mo                                            *
*   TabMO    = MO values computed on grid                              *
*   nMOs     = number of MO basis                                      *
*   mAO      = number of derivatives of AO...                          *
*   mGrid    = number of grid points                                   *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "nq_info.fh"
#include "real.fh"
      Real*8 P2mo(np2act),D1mo(nd1mo),TabMO(mAO,mGrid,nMOs),
     &       P2_ontop(nP2_ontop,mGrid)
      Integer iOff_Ash(0:7), iOff_Bas(0:7), iOff_BasAct(0:7)
      Real*8 RhoI(mRho,mGrid)
      Real*8 RhoA(mRho,mGrid)
      Logical Do_Grad
************************************************************************
*                                                                      *
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
c          write(6,*) 'nP2_ontop =', nP2_ontop
c          write(6,*) 'np2act =', np2act
c          write(6,*) 'mAO       =', mAO
c          write(6,*) 'mRho      =', mRho
      If (nP2_ontop.eq.4) Then
         If (mAO.ne.4.or.mRho.ne.4) Then
           Call WarningMessage(2,' Somthings wrong in dim. in p2cs')
           Call Abend()
       End If
      Else If (nP2_ontop.eq.6) Then
         If (mAO.ne.10.or.mRho.ne.6) Then
           Call WarningMessage(2,' Somthings wrong in dim. in p2cs')
           Call Abend()
      End If
      End If
*
      Call FZero(P2_ontop,mGrid*nP2_ontop)
      jOffA_ = 0
      jOffB_ = 0
      Do iIrrep = 0, mIrrep-1
         iOff_Ash(iIrrep)=jOffA_
         iOff_Bas(iIrrep)=jOffB_
         iOff_BasAct(iIrrep)=jOffB_ + nIsh(iIrrep) + nFro(iIrrep)
         jOffA_=jOffA_+nAsh(iIrrep)
         jOffB_=jOffB_+mBas(iIrrep)
      End Do
************************************************************************
*                                                                      *
*   P(1,...) - P_2                                                     *
*   P(2,...), P(3,...), P(4,...) - grad P_2                            *
*   Not implemented:                                                   *
*   P(5,...) - grad^2 P_2                                              *
*   P(6,...) - additional part grad^2 P_2 for CS functional            *
*   P(5) and P(6) removed                                              *
************************************************************************

************************************************************************
*          Inactive part:                                              *
************************************************************************
      NumIsh = 0
      NumAsh = 0
      Do iIrrep=0, mIrrep-1
         NumIsh = NumIsh + nISh(iIrrep)
         NumAsh = NumAsh + nAsh(iIrrep)
      End Do
*
      Do iGrid = 1, mGrid
      Do iIrrep=0, mIrrep-1
*      Write(6,*) " Symm:",iIrrep
       Do i_=1,nISh(iIrrep) + nFro(iIrrep)
        i = iOff_Bas(iIrrep) + i_
c
c         Write(6,*)  " do_p2: Inact-Inact:", iIrrep,i,
c     &               TabMO(1,iGrid,i)
c
          RhoI(1,iGrid) = RhoI(1,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(1,iGrid,i)
c      write(6,'(A15,2I3,2G15.8)')'iGrid,i,MO,RhoI',
c     &   iGrid,i,TabMO(1,iGrid,i), RhoI(1,iGrid)
!        if (Functional_type.eq.GGA_type.or.Do_Grad) then
        if (Functional_type.eq.GGA_type) then
          RhoI(2,iGrid) = RhoI(2,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(2,iGrid,i)
          RhoI(3,iGrid) = RhoI(3,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(3,iGrid,i)
          RhoI(4,iGrid) = RhoI(4,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(4,iGrid,i)
        end if
*
       End Do         ! i_
      End Do         ! iIrrep
      End Do         ! iGrid
*
      If (NumIsh.ne.0) Then
      Do iGrid = 1, mGrid
         P2_ontop(1,iGrid) = RhoI(1,iGrid)*RhoI(1,iGrid)
c         Write(6,'(A15,I3,1G28.20)')'iGrid,P2(1)=',
c     *          iGrid,P2_ontop(1,iGrid)
*
!        if (Functional_type.eq.GGA_type.or.Do_Grad) then
        if (Functional_type.eq.GGA_type) then
            P2_ontop(2,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(2,iGrid)
C            Write(6,'(A,1f28.20)') 'P2(2)   =',P2_ontop(2,iGrid)
            P2_ontop(3,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(3,iGrid)
C            Write(6,'(A,1f28.20)') 'P2(3)   =',P2_ontop(3,iGrid)
            P2_ontop(4,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(4,iGrid)
C            Write(6,'(A,1f28.20)') 'P2(4)   =',P2_ontop(4,iGrid)
         end if
        if (Functional_type.eq.LDA_type.and.Do_Grad) then
!Here I must
!1. transform the 2-body density matrix to AO

!2. Loop over effective gradients
!3. Calculate P2_ontop_d(eff_Grad,iGrid)


        end if
      End Do
      End If

************************************************************************
*          Active-Inactive part:                                       *
************************************************************************
      If (NumIsh.ne.0.and.NumAsh.ne.0) Then
       Do kIrrep = 0, mIrrep-1
         Do k_ = 1, nASh(kIrrep)
            k= k_ + iOff_BasAct(kIrrep)
            Do lIrrep = 0, mIrrep-1
               Do l_ = 1, nAsh(lIrrep)
                  l= l_ + iOff_BasAct(lIrrep)
                  kl=iTri(k_ + iOff_Ash(kIrrep) ,
     *                    l_ + iOff_Ash(lIrrep) )
                  Do iGrid = 1, mGrid
                     RhoA(1,iGrid) = RhoA(1,iGrid) +
     *                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(1,iGrid,l)
c       Write(6,'(A35,3I3,3G15.8)') 'iGrid,k,l,D1mo(kl),Tab(k),Tab(l)=',
c     &    iGrid,k,l,D1mo(kl),TabMO(1,iGrid,k),TabMO(1,iGrid,l)
!                     if (Functional_type.eq.GGA_type.or.Do_Grad) Then
                     if (Functional_type.eq.GGA_type) Then
                     RhoA(2,iGrid) = RhoA(2,iGrid) +
     *                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(2,iGrid,l)
                     RhoA(3,iGrid) = RhoA(3,iGrid) +
     *                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(3,iGrid,l)
C        write(6,*) 'RhoA(4,iGrid) bf =', RhoA(4,iGrid)
                     RhoA(4,iGrid) = RhoA(4,iGrid) +
     *                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(4,iGrid,l)
*       Write(6,*) 'D1mo(kl),Tab(1,k),Tab(1,l)=',
*     &    D1mo(kl)*TabMO(1,iGrid,k)*TabMO(4,iGrid,l)
                     end if
                  End Do     ! iGrid
               End Do      ! l_
            End Do       ! lIrrep
         End Do        ! k_
       End Do        ! kIrrep
*
       Do iGrid = 1, mGrid
               P2_ontop(1,iGrid) = P2_ontop(1,iGrid) +
     *                           RhoI(1,iGrid)*RhoA(1,iGrid)
c       write(6,'(A20,I3,2G15.8)')'iGrid,RhoI,RhoA=',
c     *                           iGrid,RhoI(1,iGrid),RhoA(1,iGrid)
c       Write(6,'(A15,I3,1f28.20)') 'iGrid,P2(1) =',
c     *    iGrid,P2_ontop(1,iGrid)
!        if (Functional_type.eq.GGA_type.or.Do_Grad) Then
        if (Functional_type.eq.GGA_type) Then
               P2_ontop(2,iGrid) = P2_ontop(2,iGrid) +
     *                     2.0d0*RhoI(2,iGrid)*RhoA(1,iGrid) +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(2,iGrid)
C            Write(6,'(A,1f28.20)') 'P2(2)   =',P2_ontop(2,iGrid)
               P2_ontop(3,iGrid) = P2_ontop(3,iGrid) +
     *                     2.0d0*RhoI(3,iGrid)*RhoA(1,iGrid) +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(3,iGrid)
C            Write(6,'(A,1f28.20)') 'P2(3)   =',P2_ontop(3,iGrid)
               P2_ontop(4,iGrid) = P2_ontop(4,iGrid) +
     *                     2.0d0*RhoI(4,iGrid)*RhoA(1,iGrid) +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(4,iGrid)
C            Write(6,'(A,1f28.20)') 'P2(4)   =',P2_ontop(4,iGrid)
        end if
       End Do ! loop over grid points
      End If ! if Inactive
************************************************************************
*
*          Active-Active part:
*
************************************************************************
      If (NumAsh.ne.0) Then
      Do iIrrep = 0, mIrrep-1
         Do jIrrep = 0, mIrrep-1
         ijIrrep=iEor(iIrrep,jIrrep)
            Do kIrrep = 0, mIrrep-1
            ijkIrrep=iEor(ijIrrep,kIrrep)
*      Write(6,*) " do_p2:Irrep" ,iIrrep,jIrrep,kIrrep,ijkIrrep
               Do k_ = 1, nASh(kIrrep)
                  k = iOff_BasAct(kIrrep)+k_
                  Do l_ = 1, nASh(ijkIrrep)
                     l=iOff_BasAct(ijkIrrep)+l_
                     Do i_ = 1, nASh(iIrrep)
                        i=iOff_BasAct(iIrrep)+i_
                        Do j_ = 1, nASh(jIrrep)
                           j=iOff_BasAct(jIrrep)+j_
                           kl=iTri(k_ + iOff_Ash(  kIrrep) ,
     &                             l_ + iOff_Ash(ijkIrrep))
                           ij=iTri(i_ + iOff_Ash(iIrrep) ,
     &                             j_ + iOff_Ash(  jIrrep))
                           ijkl  = iTri(ij,kl)
c incorrect piece of code ....
c                             Fact=0.5d0
c                             if(iIrrep.eq.jIrrep) Then
c                                If(k.eq.l) Fact=1.0d0
c                             End If
c correct piece of code ....
                             Fact=0.5d0
                             if((ij.ge.kl).and.(k.eq.l)) Fact=1.0d0
                             if((kl.ge.ij).and.(i.eq.j)) Fact=1.0d0
c*****************************************************************************
c        write(6,'(4I2,F4.1,F8.5)')  i,j,k,l,Fact,P2mo(ijkl)
                           Do iGrid = 1, mGrid
c       write(6,'(I3,F5.2,4I2,5E15.8)') iGrid,Fact,i,j,k,l,
c     &  P2mo(ijkl),
c     &   TabMO(1,igrid,i),TabMO(1,igrid,j),
c     &  TabMO(1,igrid,k),TabMO(1,igrid,l)

                             P2_ontop(1,iGrid) = P2_ontop(1,iGrid)  +
     *                                    Fact*P2mo(ijkl)*
     *                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     *                             TabMO(1,igrid,i)*TabMO(1,igrid,j)
c         Write(6,'(A,1G28.20)') 'P2(1) =',P2_ontop(1,iGrid)
                             if (Functional_type.eq.GGA_type
     &                                     ) Then
!     &                                     .or.Do_Grad) Then
                              P2_ontop(2,iGrid) = P2_ontop(2,iGrid)  +
     &                                     Fact*P2mo(ijkl)*(
     &                             TabMO(2,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(2,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(2,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(2,igrid,j)
     &                             )
C            Write(6,'(A,1f28.20)') 'P2(2)   =',P2_ontop(2,iGrid)
                              P2_ontop(3,iGrid) = P2_ontop(3,iGrid) +
     &                                    Fact*P2mo(ijkl)*(
     &                             TabMO(3,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(3,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(3,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(3,igrid,j)
     &                             )
C            Write(6,'(A,1f28.20)') 'P2(3)   =',P2_ontop(3,iGrid)
                              P2_ontop(4,iGrid) = P2_ontop(4,iGrid) +
     &                                    Fact*P2mo(ijkl)*(
     &                             TabMO(4,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(4,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(4,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(4,igrid,j)
     &                             )
C            Write(6,'(A,1f28.20)') 'P2(4)   =',P2_ontop(4,iGrid)
                              end if
*
                           End Do ! iGrid
                        End Do ! j_
                     End Do ! i_
                  End Do ! l_
               End Do ! k_
            End Do ! kIrrep
         End Do ! jIrrep
      End Do ! iIrrep
      End If
*
      RETURN
      END



      Subroutine Do_P2GLM_grad(TabAO,nTabAO,mAO,mGrid,ipTabAO,
     &          P2_ontop,nP2_ontop,Do_Grad,nGrad_Eff,
     &          list_s,nlist_s,list_bas,Index,nIndex,
     &          P2mo,np2act,D1mo,nd1mo,TabMO,list_g,P2_ontop_d,
     &          RhoI,RhoA,mRho,nMOs,CMO,nAOs,nCMO,TabSO,nsym,ft)
************************************************************************
*                                                                      *
* Object: Calculation P2 ontop density and its derivatives             *
*                                                                      *
* Called from: Do_batch                                                *
*                                                                      *
* Calling    : FZero                                                   *
*                                                                      *
*    INPUT:                                                            *
*   P2mo     = two-body density matrix in MO basis                     *
*   np2act   = size of P2mo                                            *
*   D1mo     = one-body density matrix in MO basis                     *
*   nd1mo    = size of D1mo                                            *
*   TabMO    = MO values computed on grid                              *
*   nMOs     = number of MO basis                                      *
*   mAO      = number of derivatives of AO...                          *
*   mGrid    = number of grid points                                   *
*                                                                      *
************************************************************************
      use iSD_data
      use Center_Info
      use Basis_Info, only: nBas
      Implicit Real*8 (A-H,O-Z)
#include "SysDef.fh"
#include "nq_info.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
!Error could be TabAO...
      Integer iOff_Ash(0:7), iOff_Bas(0:7), iOff_BasAct(0:7),
     &        list_s(2,nlist_s),list_bas(2,nlist_s),Index(nIndex),
     &        list_g(3,nlist_s),ipTabAO(nlist_s,2),
     &        mAO,nAOs,mGrid,nP2_ontop,nGrad_Eff,np2act,nd1mo,nTabAO,
     &        mRho,nCMO,nsym
      Real*8 P2mo(np2act),D1mo(nd1mo),TabMO(mAO,mGrid,nMOs),
     &     P2_ontop(nP2_ontop,mGrid),TabAO(nTabAO),
     &     P2_ontop_d(np2_ontop,nGrad_Eff,mGrid),CMO(nCMO)
!      Real*8 P2AO(np2AO)
      logical ft
!      Real*8, allocatable, dimension(:,:,:) :: AO_vals
      Real*8, allocatable, dimension(:,:,:,:) :: dTabMO
!      Real*8, allocatable,dimension(:,:) :: CMO_u
!      Integer np2AO
      Real*8 RhoI(mRho,mGrid)
      Real*8 RhoA(mRho,mGrid)
      Real*8,dimension(1:mRho,1:mGrid,1:nGrad_Eff) :: dRhoI,dRhoA
!      Real*8 dRhoA(mRho,mGrid,nGrad_Eff)
!     Real*8 gf1(1:3)
      Logical Do_Grad
      integer g_eff,iGrid,CMO_OFF
      integer mo_i,ao_j
      Real*8 TabSO(mAO,mGrid,nMOs)
************************************************************************
*                                                                      *
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
      Call unused_logical(do_grad)
      Call unused_integer(naos)

!      write(*,*) 'CMO print'
!      do i=1,nMOs
!       write(*,*) 'MO number: ',i
!       do j=1,nAOs
!       write(*,*) j,CMO(j,i)
!       end do
!      end do

!unpack CMOs
!      nMO_IR = 0
!      nAO_IR = 0
!      Do iIrrep = 0, mIrrep-1
!        nMO_Ir = nMO_Ir + nIsh(iIrrep)+nAsh(iIrrep)
!        nAO_Ir = nAO_Ir + nBas(iIrrep)
!      End do
!      Allocate(CMO_u(1:nAO_IR,1:nMO_IR))
!        Call Fzero(CMO_u,nMO_IR*nAO_IR)



      if (.false.) then
      Do ilist_s=1,nlist_s
        write(6,*) 'INFO FOR SHELL',ilist_s
        iSkal=list_s(1,ilist_s)
        write(6,*) 'iskal',iskal
        iCmp  = iSD( 2,iSkal)
        write(6,*) 'icmp',icmp
        iBas  = iSD( 3,iSkal)
        write(6,*) 'ibas',ibas
        iBas_Eff = List_Bas(1,ilist_s)
        write(6,*) 'iBas_eff',ibas_eff
        mdci  = iSD(10,iSkal)
        iShell= iSD(11,iSkal)
        write(6,*) 'ishell',ishell
        index_i=list_bas(2,ilist_s)
        write(6,*) 'index_i',index_i
        nFunc_i=iBas*iCmp
        IndMap = Index(index_i)
        iR = list_s(2,ilist_s)
        write(6,*) 'iR',iR
!        isym = NrOpr(iR)
!        write(6,*) 'isym',isym
        iAO = iSD(7,iSkal)
      end do
      end if



      If (nP2_ontop.eq.4) Then
         If (mAO.ne.10.or.mRho.ne.4) Then
           Call WarningMessage(2,' Somthings wrong in dim. in p2cs')
           Call Abend()
       End If
      Else If (nP2_ontop.eq.6) Then
         If (mAO.ne.10.or.mRho.ne.6) Then
           Call WarningMessage(2,' Somthings wrong in dim. in p2cs')
           Call Abend()
        End If
      End If
*
      Call FZero(P2_ontop,mGrid*nP2_ontop)
      Call FZero(P2_ontop_d,nP2_ontop*nGrad_Eff*mGrid)
      dRhoI(1:mRho,1:mGrid,1:nGrad_Eff)=0.0d0
      dRhoA(1:mRho,1:mGrid,1:nGrad_Eff)=0.0d0
!      Call FZero(dRhoI,mRho*mGrid*nGrad_Eff)
!      Call FZero(dRhoA,mRho*mGrid*nGrad_Eff)
      jOffA_ = 0
      jOffB_ = 0
      Do iIrrep = 0, mIrrep-1
         iOff_Ash(iIrrep)=jOffA_
         iOff_Bas(iIrrep)=jOffB_
         iOff_BasAct(iIrrep)=jOffB_ + nIsh(iIrrep) + nFro(iIrrep)
         jOffA_=jOffA_+nAsh(iIrrep)
         jOffB_=jOffB_+mBas(iIrrep)
      End Do
************************************************************************
*                                                                      *
*   P(1,...) - P_2                                                     *
*   P(2,...), P(3,...), P(4,...) - grad P_2                            *
*   Not implemented:                                                   *
*   P(5,...) - grad^2 P_2                                              *
*   P(6,...) - additional part grad^2 P_2 for CS functional            *
*   P(5) and P(6) removed                                              *
************************************************************************

      !if(.true.) then
      !Assuming C1 symmetry right now.
      Allocate(dTabMO(1:nP2_ontop,1:nMOs,1:nGrad_eff,1:mgrid))
      dTabMO(1:nP2_ontop,1:nMOs,1:nGrad_eff,1:mGrid)=0.0d0

!      write(*,*) 'listbas 2'
!      do i=1,nlist_s
!      write(*,*) list_bas(2,i)
!      end do
!      write(*,*) 'nindex',nindex
!      do i=1,nindex
!      write(*,*) index(i)
!      end do
!      call xflush(6)
      ioff = 0

!      write(*,*) 'CMOs in p2glm'
!      do i=1,nCMO
!        write(*,*) CMO(i)
!      end do

!::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         Do ilist_s=1,nlist_s
            ish=list_s(1,ilist_s)
            iCmp  = iSD( 2,iSh)
            iBas  = iSD( 3,iSh)
            iBas_Eff = List_Bas(1,ilist_s)
            iPrim = iSD( 5,iSh)
            iAO   = iSD( 7,iSh)
            mdci  = iSD(10,iSh)
            iShell= iSD(11,iSh)

            kAO   = iCmp*iBas*mGrid
            nDeg  = nSym/dc(mdci)%nStab
            nSO   = kAO*nDeg*mAO
            ipSOs = ipMem

            Call FZero(Work(ipSOs),nSO)

            iR=list_s(2,ilist_s)
            iSym=NrOpr(iR)

            Call SOAdpt_NQ(TabAO(ipTabAO(iList_s,1)),mAO,mGrid,iBas,
     &                  iBas_Eff,iCmp,iSym,Work(ipSOs),nDeg,iAO)

            Call GetMem('TmpCM','Allo','Real',ipTmpCMO,nCMO)
            Call GetMem('TDoIt','Allo','Inte',ipTDoIt,nMOs)
           !nPrint(135) = 99
           !do i=1,mAO*mGrid*iCmp*ndeg
           !end do
           Call FZero(TabSO,mAO*mGrid*nMOs)

            Call  SODist2(Work(ipSOs),mAO,mGrid,iBas,
     &                   iCmp,nDeg,TabSO,
     &                   nMOs,iAO,Work(ipTmpCMO),
     &                   nCMO,iWork(ipTDoIt))
            Call GetMem('TmpCM','Free','Real',ipTmpCMO,nCMO)
            Call GetMem('TDoIt','Free','Inte',ipTDoIt,nMOs)

            !Now I think we have the AOs converted to a full set of
            !SOs...
            MO_off = 0
            CMO_off = 0
            Do iIrrep = 0, mIrrep-1
              do MO_i = 1, nIsh(iIrrep)+nAsh(iIrrep)
                i = MO_i + MO_off
                do AO_j = 1, nBas(iIrrep)
                  j = AO_j + MO_off
                  do iCoord=1,3
                    g_eff = list_g(iCoord,ilist_s)
                    do iGrid = 1,mGrid

                  dTabMO(1,i,g_eff,iGrid) = dTabMO(1,i,g_eff,iGrid) +
     &            CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &            *TabSO(iCoord+1,iGrid,j)

!******************ADD STUFF FOR FTPBE HERE***************
        if (Functional_type.eq.GGA_type.and.ft) then

          Select CASE (iCoord)
           CASE (1) !x-coord
                    dTabMO(2,i,g_eff,iGrid) = dTabMO(2,i,g_eff,iGrid) +
     &              CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &             *(TabSO(5,iGrid,j))

                    dTabMO(3,i,g_eff,iGrid) = dTabMO(3,i,g_eff,iGrid) +
     &              CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &             *(TabSO(6,iGrid,j))

                    dTabMO(4,i,g_eff,iGrid) = dTabMO(4,i,g_eff,iGrid) +
     &              CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &            *(TabSO(7,iGrid,j))

           CASE (2) !y-coord
                    dTabMO(2,i,g_eff,iGrid) = dTabMO(2,i,g_eff,iGrid) +
     &              CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &             *(TabSO(6,iGrid,j))

                    dTabMO(3,i,g_eff,iGrid) = dTabMO(3,i,g_eff,iGrid) +
     &              CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &             *(TabSO(8,iGrid,j))

                    dTabMO(4,i,g_eff,iGrid) = dTabMO(4,i,g_eff,iGrid) +
     &              CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &            *(TabSO(9,iGrid,j))

           CASE (3) !z-coord
                    dTabMO(2,i,g_eff,iGrid) = dTabMO(2,i,g_eff,iGrid) +
     &              CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &             *(TabSO(7,iGrid,j))

                    dTabMO(3,i,g_eff,iGrid) = dTabMO(3,i,g_eff,iGrid) +
     &              CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &             *(TabSO(9,iGrid,j))

                    dTabMO(4,i,g_eff,iGrid) = dTabMO(4,i,g_eff,iGrid) +
     &              CMO(CMO_OFF + AO_j + (MO_i-1)*nBas(iIrrep))
     &            *(TabSO(10,iGrid,j))

           End Select

      end if
!*********************************************************

                    end do !grid
                  end do !coord
                end do!AO
              end do!MO
              MO_off = MO_off + nBas(iIrrep)
              CMO_off = CMO_off + nBas(iIrrep)**2
            end do!Irrep

      end do

************************************************************************
*          Inactive part:                                              *
************************************************************************
      NumIsh = 0
      NumAsh = 0
      Do iIrrep=0, mIrrep-1
         NumIsh = NumIsh + nISh(iIrrep)
         NumAsh = NumAsh + nAsh(iIrrep)
      End Do
*
      Do iGrid = 1, mGrid
        Do iIrrep=0, mIrrep-1
          Do i_=1,nISh(iIrrep) + nFro(iIrrep)
            i = iOff_Bas(iIrrep) + i_
            RhoI(1,iGrid) = RhoI(1,iGrid) +
     &           TabMO(1,iGrid,i) * TabMO(1,iGrid,i)
        if (Functional_type.eq.GGA_type.and.ft) then
          RhoI(2,iGrid) = RhoI(2,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(2,iGrid,i)
          RhoI(3,iGrid) = RhoI(3,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(3,iGrid,i)
          RhoI(4,iGrid) = RhoI(4,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(4,iGrid,i)
        end if
*
      !Build dRhoI
        Do g_eff=1,nGrad_eff
              dRhoI(1,iGrid,g_eff) = dRhoI(1,iGrid,g_eff) +
     &        dTabMO(1,i,g_eff,iGrid)*TabMO(1,iGrid,i)!times 2 or not?

        if (Functional_type.eq.GGA_type.and.ft) then
            dRhoI(2,iGrid,g_eff) = dRhoI(2,iGrid,g_eff) +
     &      dTabMO(1,i,g_eff,iGrid)*TabMO(2,iGrid,i) +
     &      TabMO(1,iGrid,i)*dTabMO(2,i,g_eff,iGrid)

            dRhoI(3,iGrid,g_eff) = dRhoI(3,iGrid,g_eff) +
     &      dTabMO(1,i,g_eff,iGrid)*TabMO(3,iGrid,i) +
     &      TabMO(1,iGrid,i)*dTabMO(3,i,g_eff,iGrid)

            dRhoI(4,iGrid,g_eff) = dRhoI(4,iGrid,g_eff) +
     &      dTabMO(1,i,g_eff,iGrid)*TabMO(4,iGrid,i) +
     &      TabMO(1,iGrid,i)*dTabMO(4,i,g_eff,iGrid)

        end if !GGA
        end do !g_eff

          End Do         ! i_
        End Do         ! iIrrep
      End Do         ! iGrid
*
      If (NumIsh.ne.0) Then
      Do iGrid = 1, mGrid
         P2_ontop(1,iGrid) = RhoI(1,iGrid)*RhoI(1,iGrid)
*
        if (Functional_type.eq.GGA_type.and.ft) then
            P2_ontop(2,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(2,iGrid)
            P2_ontop(3,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(3,iGrid)
            P2_ontop(4,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(4,iGrid)
         end if
      do g_eff=1,nGrad_eff
        P2_ontop_d(1,g_eff,iGrid) = P2_ontop_d(1,g_eff,iGrid) +
     & 4.0d0*dRhoI(1,iGrid,g_eff)*RhoI(1,iGrid)

        if (Functional_type.eq.GGA_type.and.ft) then
!******************ADD STUFF FOR FTPBE HERE***************
        P2_ontop_d(2,g_eff,iGrid) = P2_ontop_d(2,g_eff,iGrid) +
     &  4.0d0*dRhoI(2,iGrid,g_eff)*RhoI(1,iGrid) +
     & 8.0d0*dRhoI(1,iGrid,g_eff)*RhoI(2,iGrid)
!     &  4.0d0*dRhoI(1,iGrid,g_eff)*RhoI(2,iGrid) +
!     &  4.0d0*RhoI(1,iGrid)*dRhoI(2,iGrid,g_eff)

        P2_ontop_d(3,g_eff,iGrid) = P2_ontop_d(3,g_eff,iGrid) +
     &  4.0d0*dRhoI(3,iGrid,g_eff)*RhoI(1,iGrid) +
     & 8.0d0*dRhoI(1,iGrid,g_eff)*RhoI(3,iGrid)
!     &  4.0d0*dRhoI(1,iGrid,g_eff)*RhoI(3,iGrid) +
!     &  4.0d0*RhoI(1,iGrid)*dRhoI(3,iGrid,g_eff)

        P2_ontop_d(4,g_eff,iGrid) = P2_ontop_d(4,g_eff,iGrid) +
     &  4.0d0*dRhoI(4,iGrid,g_eff)*RhoI(1,iGrid) +
     & 8.0d0*dRhoI(1,iGrid,g_eff)*RhoI(4,iGrid)
!     &  4.0d0*dRhoI(1,iGrid,g_eff)*RhoI(4,iGrid) +
!     &  4.0d0*RhoI(1,iGrid)*dRhoI(4,iGrid,g_eff)

        end if !GGA
      end do !ngrad


      End Do
      End If

************************************************************************
*          Active-Inactive part:                                       *
************************************************************************
      If (NumIsh.ne.0.and.NumAsh.ne.0) Then
       Do kIrrep = 0, mIrrep-1
         Do k_ = 1, nASh(kIrrep)
            k= k_ + iOff_BasAct(kIrrep)
            Do lIrrepx = 0, mIrrep-1
               Do l_ = 1, nAsh(lIrrepx)
                  l= l_ + iOff_BasAct(lIrrepx)
                  kl=iTri(k_ + iOff_Ash(kIrrep) ,
     &                    l_ + iOff_Ash(lIrrepx) )
                  Do iGrid = 1, mGrid
                     RhoA(1,iGrid) = RhoA(1,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(1,iGrid,l)
                     if (Functional_type.eq.GGA_type.and.ft) Then
                     RhoA(2,iGrid) = RhoA(2,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(2,iGrid,l)
                     RhoA(3,iGrid) = RhoA(3,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(3,iGrid,l)
                     RhoA(4,iGrid) = RhoA(4,iGrid) +
     &                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(4,iGrid,l)
                    end if

                    do g_eff=1,nGrad_eff
                      dRhoA(1,iGrid,g_eff) = dRhoA(1,iGrid,g_eff) +
     &                D1mo(kl)*dTabMO(1,k,g_eff,iGrid)*TabMO(1,iGrid,l)


!******************ADD STUFF FOR FTPBE HERE***************

                     if(Functional_type.eq.GGA_type.and.ft) Then
                       dRhoA(2,iGrid,g_eff) = dRhoA(2,iGrid,g_eff) +
     &               D1mo(kl)*dTabMO(1,k,g_eff,iGrid)*TabMO(2,iGrid,l) +
     &               D1mo(kl)*TabMO(1,iGrid,k)*dTabMO(2,l,g_eff,iGrid)

                       dRhoA(3,iGrid,g_eff) = dRhoA(3,iGrid,g_eff) +
     &               D1mo(kl)*dTabMO(1,k,g_eff,iGrid)*TabMO(3,iGrid,l) +
     &               D1mo(kl)*TabMO(1,iGrid,k)*dTabMO(3,l,g_eff,iGrid)

                       dRhoA(4,iGrid,g_eff) = dRhoA(4,iGrid,g_eff) +
     &               D1mo(kl)*dTabMO(1,k,g_eff,iGrid)*TabMO(4,iGrid,l) +
     &               D1mo(kl)*TabMO(1,iGrid,k)*dTabMO(4,l,g_eff,iGrid)
                     end if !GGA


                    end do
                  End Do     ! iGrid
               End Do      ! l_
            End Do       ! lIrrepx
         End Do        ! k_
       End Do        ! kIrrep
*
       Do iGrid = 1, mGrid
               P2_ontop(1,iGrid) = P2_ontop(1,iGrid) +
     *                           RhoI(1,iGrid)*RhoA(1,iGrid)
        if (Functional_type.eq.GGA_type.and.ft) Then
               P2_ontop(2,iGrid) = P2_ontop(2,iGrid) +
     *                     2.0d0*RhoI(2,iGrid)*RhoA(1,iGrid) +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(2,iGrid)
               P2_ontop(3,iGrid) = P2_ontop(3,iGrid) +
     *                     2.0d0*RhoI(3,iGrid)*RhoA(1,iGrid) +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(3,iGrid)
               P2_ontop(4,iGrid) = P2_ontop(4,iGrid) +
     *                     2.0d0*RhoI(4,iGrid)*RhoA(1,iGrid) +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(4,iGrid)
        end if !gga
        do g_eff=1,nGrad_Eff
          P2_ontop_d(1,g_eff,iGrid) = P2_ontop_d(1,g_eff,iGrid) +
     &                  2.0D0*RhoI(1,iGrid)*dRhoA(1,iGrid,g_eff) +
     &                  2.0D0*dRhoI(1,iGrid,g_eff)*RhoA(1,iGrid)
          if (Functional_type.eq.GGA_type.and.ft) Then

          P2_ontop_d(2,g_eff,iGrid) = P2_ontop_d(2,g_eff,iGrid) +
     &    2.0d0*dRhoI(2,iGrid,g_eff)*RhoA(1,iGrid) +
     &    4.0d0*RhoI(2,iGrid)*dRhoA(1,iGrid,g_eff) +
     &    4.0d0*dRhoI(1,iGrid,g_eff)*RhoA(2,iGrid) +
     &    2.0d0*RhoI(1,iGrid)*dRhoA(2,iGrid,g_eff)

          P2_ontop_d(3,g_eff,iGrid) = P2_ontop_d(3,g_eff,iGrid) +
     &    2.0d0*dRhoI(3,iGrid,g_eff)*RhoA(1,iGrid) +
     &    4.0d0*RhoI(3,iGrid)*dRhoA(1,iGrid,g_eff) +
     &    4.0d0*dRhoI(1,iGrid,g_eff)*RhoA(3,iGrid) +
     &    2.0d0*RhoI(1,iGrid)*dRhoA(3,iGrid,g_eff)
!     &    2.0d0*(dRhoI(3,iGrid,g_eff)*RhoA(1,iGrid) +
!     &           RhoI(3,iGrid)*dRhoA(1,iGrid,g_eff)) +
!     &    2.0d0*(dRhoI(1,iGrid,g_eff)*RhoA(3,iGrid) +
!     &           RhoI(1,iGrid)*dRhoA(3,iGrid,g_eff))

          P2_ontop_d(4,g_eff,iGrid) = P2_ontop_d(4,g_eff,iGrid) +
     &    2.0d0*dRhoI(4,iGrid,g_eff)*RhoA(1,iGrid) +
     &    4.0d0*RhoI(4,iGrid)*dRhoA(1,iGrid,g_eff) +
     &    4.0d0*dRhoI(1,iGrid,g_eff)*RhoA(4,iGrid) +
     &    2.0d0*RhoI(1,iGrid)*dRhoA(4,iGrid,g_eff)
!     &    2.0d0*(dRhoI(4,iGrid,g_eff)*RhoA(1,iGrid) +
!     &           RhoI(4,iGrid)*dRhoA(1,iGrid,g_eff)) +
!     &    2.0d0*(dRhoI(1,iGrid,g_eff)*RhoA(4,iGrid) +
!     &           RhoI(1,iGrid)*dRhoA(4,iGrid,g_eff))
          end if !GGA
        end do !g_eff

       End Do ! loop over grid points
      End If ! if Inactive
************************************************************************
*
*          Active-Active part:
*
************************************************************************

      If (NumAsh.ne.0) Then
      Do iIrrep = 0, mIrrep-1
         Do jIrrep = 0, mIrrep-1
         ijIrrep=iEor(iIrrep,jIrrep)
            Do kIrrep = 0, mIrrep-1
            ijkIrrep=iEor(ijIrrep,kIrrep)
*      Write(6,*) " do_p2:Irrep" ,iIrrep,jIrrep,kIrrep,ijkIrrep
               Do k_ = 1, nASh(kIrrep)
                  k = iOff_BasAct(kIrrep)+k_
                  Do l_ = 1, nASh(ijkIrrep)
                     l=iOff_BasAct(ijkIrrep)+l_
                     Do i_ = 1, nASh(iIrrep)
                        i=iOff_BasAct(iIrrep)+i_
                        Do j_ = 1, nASh(jIrrep)
                           j=iOff_BasAct(jIrrep)+j_
                           kl=iTri(k_ + iOff_Ash(  kIrrep) ,
     &                             l_ + iOff_Ash(ijkIrrep))
                           ij=iTri(i_ + iOff_Ash(iIrrep) ,
     &                             j_ + iOff_Ash(  jIrrep))
                           ijkl  = iTri(ij,kl)
                             Fact=0.5d0
                             if((ij.ge.kl).and.(k.eq.l)) Fact=1.0d0
                             if((kl.ge.ij).and.(i.eq.j)) Fact=1.0d0

                           Do iGrid = 1, mGrid
                             P2_ontop(1,iGrid) = P2_ontop(1,iGrid)  +
     *                                    Fact*P2mo(ijkl)*
     *                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     *                             TabMO(1,igrid,i)*TabMO(1,igrid,j)
                             if (Functional_type.eq.GGA_type.and.ft
     &                                     ) Then
                              P2_ontop(2,iGrid) = P2_ontop(2,iGrid)  +
     &                                     Fact*P2mo(ijkl)*(
     &                             TabMO(2,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
!c
     &                             TabMO(1,igrid,k)*TabMO(2,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
!c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(2,igrid,i)*TabMO(1,igrid,j) +
!c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(2,igrid,j)
     &                             )
                              P2_ontop(3,iGrid) = P2_ontop(3,iGrid) +
     &                                    Fact*P2mo(ijkl)*(
     &                             TabMO(3,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
!c
     &                             TabMO(1,igrid,k)*TabMO(3,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
!c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(3,igrid,i)*TabMO(1,igrid,j) +
!c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(3,igrid,j)
     &                             )
                              P2_ontop(4,iGrid) = P2_ontop(4,iGrid) +
     &                                    Fact*P2mo(ijkl)*(
     &                             TabMO(4,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
!c
     &                             TabMO(1,igrid,k)*TabMO(4,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
!c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(4,igrid,i)*TabMO(1,igrid,j) +
!c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(4,igrid,j)
     &                             )
                              end if
*
      do g_eff=1,nGrad_eff
        P2_ontop_d(1,g_eff,iGrid) = P2_ontop_d(1,g_eff,iGrid) +
     &    Fact*P2mo(ijkl)*dTabMO(1,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &    TabMO(1,igrid,k)*TabMO(1,iGrid,l)

        P2_ontop_d(1,g_eff,iGrid) = P2_ontop_d(1,g_eff,iGrid) +
     &    Fact*P2mo(ijkl)*dTabMO(1,j,g_eff,iGrid)*TabMO(1,igrid,i)*
     &    TabMO(1,igrid,k)*TabMO(1,iGrid,l)

        P2_ontop_d(1,g_eff,iGrid) = P2_ontop_d(1,g_eff,iGrid) +
     &    Fact*P2mo(ijkl)*dTabMO(1,k,g_eff,iGrid)*TabMO(1,igrid,i)*
     &    TabMO(1,igrid,j)*TabMO(1,iGrid,l)

        P2_ontop_d(1,g_eff,iGrid) = P2_ontop_d(1,g_eff,iGrid) +
     &    Fact*P2mo(ijkl)*dTabMO(1,l,g_eff,iGrid)*TabMO(1,igrid,i)*
     &    TabMO(1,igrid,j)*TabMO(1,iGrid,k)


         if (Functional_type.eq.GGA_type.and.ft) Then
           P2_ontop_d(2,g_eff,iGrid) = P2_ontop_d(2,g_eff,iGrid) +
     &     Fact*P2mo(ijkl)*
     &     (dTabMO(2,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &     TabMO(1,igrid,k)*TabMO(1,iGrid,l) +
     &     dTabMO(1,i,g_eff,iGrid)*TabMO(2,igrid,j)*
     &     TabMO(1,igrid,k)*TabMO(1,iGrid,l) +
     &     dTabMO(1,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &     TabMO(2,igrid,k)*TabMO(1,iGrid,l) +
     &     dTabMO(1,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &     TabMO(1,igrid,k)*TabMO(2,iGrid,l) +
     &
     &     TabMO(2,igrid,i)*dTabMO(1,j,g_eff,iGrid)*
     &     TabMO(1,iGrid,k)*TabMO(1,iGrid,l) +
     &     TabMO(1,igrid,i)*dTabMO(2,j,g_eff,iGrid)*
     &     TabMO(1,iGrid,k)*TabMO(1,iGrid,l) +
     &     TabMO(1,igrid,i)*dTabMO(1,j,g_eff,iGrid)*
     &     TabMO(2,iGrid,k)*TabMO(1,iGrid,l) +
     &     TabMO(1,igrid,i)*dTabMO(1,j,g_eff,iGrid)*
     &     TabMO(1,iGrid,k)*TabMO(2,iGrid,l) +
     &
     &     TabMO(2,iGrid,i)*TabMO(1,iGrid,j) *
     &     dTabMO(1,k,g_eff,iGrid)*TabMO(1,igrid,l) +
     &     TabMO(1,iGrid,i)*TabMO(2,iGrid,j) *
     &     dTabMO(1,k,g_eff,iGrid)*TabMO(1,igrid,l) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     dTabMO(2,k,g_eff,iGrid)*TabMO(1,igrid,l) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     dTabMO(1,k,g_eff,iGrid)*TabMO(2,igrid,l) +
     &
     &     TabMO(2,iGrid,i)*TabMO(1,iGrid,j) *
     &     TabMO(1,igrid,k)*dTabMO(1,l,g_eff,iGrid) +
     &     TabMO(1,iGrid,i)*TabMO(2,iGrid,j) *
     &     TabMO(1,igrid,k)*dTabMO(1,l,g_eff,iGrid) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     TabMO(2,igrid,k)*dTabMO(1,l,g_eff,iGrid) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     TabMO(1,igrid,k)*dTabMO(2,l,g_eff,iGrid))

           P2_ontop_d(3,g_eff,iGrid) = P2_ontop_d(3,g_eff,iGrid) +
     &     Fact*P2mo(ijkl)*
     &     (dTabMO(3,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &     TabMO(1,igrid,k)*TabMO(1,iGrid,l) +
     &     dTabMO(1,i,g_eff,iGrid)*TabMO(3,igrid,j)*
     &     TabMO(1,igrid,k)*TabMO(1,iGrid,l) +
     &     dTabMO(1,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &     TabMO(3,igrid,k)*TabMO(1,iGrid,l) +
     &     dTabMO(1,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &     TabMO(1,igrid,k)*TabMO(3,iGrid,l) +
     &
     &     TabMO(3,igrid,i)*dTabMO(1,j,g_eff,iGrid)*
     &     TabMO(1,iGrid,k)*TabMO(1,iGrid,l) +
     &     TabMO(1,igrid,i)*dTabMO(3,j,g_eff,iGrid)*
     &     TabMO(1,iGrid,k)*TabMO(1,iGrid,l) +
     &     TabMO(1,igrid,i)*dTabMO(1,j,g_eff,iGrid)*
     &     TabMO(3,iGrid,k)*TabMO(1,iGrid,l) +
     &     TabMO(1,igrid,i)*dTabMO(1,j,g_eff,iGrid)*
     &     TabMO(1,iGrid,k)*TabMO(3,iGrid,l) +
     &
     &     TabMO(3,iGrid,i)*TabMO(1,iGrid,j) *
     &     dTabMO(1,k,g_eff,iGrid)*TabMO(1,igrid,l) +
     &     TabMO(1,iGrid,i)*TabMO(3,iGrid,j) *
     &     dTabMO(1,k,g_eff,iGrid)*TabMO(1,igrid,l) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     dTabMO(3,k,g_eff,iGrid)*TabMO(1,igrid,l) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     dTabMO(1,k,g_eff,iGrid)*TabMO(3,igrid,l) +
     &
     &     TabMO(3,iGrid,i)*TabMO(1,iGrid,j) *
     &     TabMO(1,igrid,k)*dTabMO(1,l,g_eff,iGrid) +
     &     TabMO(1,iGrid,i)*TabMO(3,iGrid,j) *
     &     TabMO(1,igrid,k)*dTabMO(1,l,g_eff,iGrid) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     TabMO(3,igrid,k)*dTabMO(1,l,g_eff,iGrid) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     TabMO(1,igrid,k)*dTabMO(3,l,g_eff,iGrid))

           P2_ontop_d(4,g_eff,iGrid) = P2_ontop_d(4,g_eff,iGrid) +
     &     Fact*P2mo(ijkl)*
     &     (dTabMO(4,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &     TabMO(1,igrid,k)*TabMO(1,iGrid,l) +
     &     dTabMO(1,i,g_eff,iGrid)*TabMO(4,igrid,j)*
     &     TabMO(1,igrid,k)*TabMO(1,iGrid,l) +
     &     dTabMO(1,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &     TabMO(4,igrid,k)*TabMO(1,iGrid,l) +
     &     dTabMO(1,i,g_eff,iGrid)*TabMO(1,igrid,j)*
     &     TabMO(1,igrid,k)*TabMO(4,iGrid,l) +
     &
     &     TabMO(4,igrid,i)*dTabMO(1,j,g_eff,iGrid)*
     &     TabMO(1,iGrid,k)*TabMO(1,iGrid,l) +
     &     TabMO(1,igrid,i)*dTabMO(4,j,g_eff,iGrid)*
     &     TabMO(1,iGrid,k)*TabMO(1,iGrid,l) +
     &     TabMO(1,igrid,i)*dTabMO(1,j,g_eff,iGrid)*
     &     TabMO(4,iGrid,k)*TabMO(1,iGrid,l) +
     &     TabMO(1,igrid,i)*dTabMO(1,j,g_eff,iGrid)*
     &     TabMO(1,iGrid,k)*TabMO(4,iGrid,l) +
     &
     &     TabMO(4,iGrid,i)*TabMO(1,iGrid,j) *
     &     dTabMO(1,k,g_eff,iGrid)*TabMO(1,igrid,l) +
     &     TabMO(1,iGrid,i)*TabMO(4,iGrid,j) *
     &     dTabMO(1,k,g_eff,iGrid)*TabMO(1,igrid,l) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     dTabMO(4,k,g_eff,iGrid)*TabMO(1,igrid,l) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     dTabMO(1,k,g_eff,iGrid)*TabMO(4,igrid,l) +
     &
     &     TabMO(4,iGrid,i)*TabMO(1,iGrid,j) *
     &     TabMO(1,igrid,k)*dTabMO(1,l,g_eff,iGrid) +
     &     TabMO(1,iGrid,i)*TabMO(4,iGrid,j) *
     &     TabMO(1,igrid,k)*dTabMO(1,l,g_eff,iGrid) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     TabMO(4,igrid,k)*dTabMO(1,l,g_eff,iGrid) +
     &     TabMO(1,iGrid,i)*TabMO(1,iGrid,j) *
     &     TabMO(1,igrid,k)*dTabMO(4,l,g_eff,iGrid))
         end if !GGA

      end do!loop over nGrad_eff
!  299 Continue
*
                           End Do ! iGrid
                        End Do ! j_
                     End Do ! i_
                  End Do ! l_
               End Do ! k_
            End Do ! kIrrep
         End Do ! jIrrep
      End Do ! iIrrep
      End If
*
      !P2_ontop_d(1:nGrad_eff,1:mGrid) = 0


      !Do ilist_s=1,nlist_s !loop over AO shell lists
      !Do nGrad=1,3
      !  g_eff = list_g(nGrad,ilist_s)
      !end do
      !end do
      deAllocate(dTabMO)
      RETURN
      END subroutine

         Subroutine Get_AO_info(TabAO,mAO,mGrid,iBas_eff,iCmp,AO_vals)
         Real*8 TabAO(mAO,mGrid,iBas_eff*iCmp)
         Real*8 AO_vals(mAO,mGrid,iBas_eff*iCmp)
         integer mAO,mGrid,iBas_Eff,iCmp

         AO_vals = TabAO
         End Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Rotate_BP
!
!> @brief
!>   Rotate \p BP to match \p Ref
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Rotate the vectors in a branching plane (\p BP) such that the plane
!> matches the reference (\p Ref). Do so in an "optimal" manner, meaning
!> that the vectors change as little as possible. This is achieved by
!> the SVD. The output value \p Phi is the "total" cosine for the angle
!> between the planes.
!>
!> @param[in,out] BP    Branching plane to transform
!> @param[in]     Ref   Reference branching plane
!> @param[in]     nDim  Dimension of the vectors
!> @param[in]     nVec  Number of vectors defining the planes (usually 2)
!> @param[out]    Phi   Product of principal cosines (total cosine)
!***********************************************************************

subroutine Rotate_BP(BP,Ref,nDim,nVec,Phi)

use linalg_mod, only: Gram_Schmidt, mult
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, nVec
real(kind=wp), intent(inout) :: BP(nDim,nVec)
real(kind=wp), intent(in) :: Ref(nDim,nVec)
real(kind=wp), intent(out) :: Phi
integer(kind=iwp) :: m
real(kind=wp), allocatable :: Amat(:,:), Aux(:,:), OB1(:,:), OB2(:,:), Sing(:), Umat(:,:), Vmat(:,:)

! Get orthormal bases for the two planes

call mma_allocate(OB1,nDim,2,Label='OB1')
call mma_allocate(OB2,nDim,2,Label='OB2')
call Gram_Schmidt(BP,nVec,OB1,m)
if (m /= nVec) call WarningMessage(2,'Rotate_BP: Linear dependence in BP')
call Gram_Schmidt(Ref,nVec,OB2,m)
if (m /= nVec) call WarningMessage(2,'Rotate_BP: Linear dependence in Ref')

! Find principal angles and vectors

call mma_allocate(Amat,nVec,nVec,Label='Amat')
call mma_allocate(Umat,nVec,nVec,Label='Umat')
call mma_allocate(Vmat,nVec,nVec,Label='Vmat')
call mma_allocate(Sing,nVec,Label='Sing')
call mult(OB1,OB2,Amat,.true.,.false.)
call large_svd(nVec,nVec,Amat,Umat,Vmat,Sing)
Sing(:) = min(Sing,One)
Phi = product(Sing)

! Transform bases to principal vectors

call mma_allocate(Aux,nDim,nVec,Label='Aux')
call mult(OB1,Umat,Aux,.false.,.false.)
OB1(:,:) = Aux
call mult(OB2,Vmat,Aux,.false.,.true.)
OB2(:,:) = Aux
call mma_deallocate(Aux)

! Transform BP by replacing the OB1 basis with OB2
! (note that this is not a general transform, it is only valid for vectors within the BP)

call mult(OB1,BP,Amat,.true.,.false.)
call mult(OB2,Amat,BP,.false.,.false.)

call mma_deallocate(OB1)
call mma_deallocate(OB2)
call mma_deallocate(Amat)
call mma_deallocate(Umat)
call mma_deallocate(Vmat)
call mma_deallocate(Sing)

end subroutine Rotate_BP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Yan Zhao                                         *
************************************************************************
      Subroutine CM06(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                 CoeffA,iSpin,F_xc,T_X,ijzy)
************************************************************************
*                                                                      *
*  CM06 evaluates the correlation part of the M06 suite of             *
*  functionals on a grid.                                              *
*  !!! Second derivatives are not available yet.                       *
*                                                                      *
*  Ref: (a) Zhao, Y.  and Truhlar, D. G. J. Chem. Phys. 125,           *
*    194101 (2006).                                                    *
*       (b) Y. Zhao and D. G. Truhlar, J. Phys. Chem. A (2006),        *
*    110(49),13126-13130.                                              *
*                                                                      *
*       ijzy - 1 M06-L                                                 *
*       ijzy - 2 M06-HF                                                *
*       ijzy - 3 M06                                                   *
*       ijzy - 4 M06-2X                                                *
*                                                                      *
*  YZ (10/07)                                                          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
      Integer mGrid

      REAL*8 F6, F43, Pi34, F13,
     &RS,RSP,Zeta,dZdA,dZdB,PotLC,dLdS,dLdZ,d2LdSS,d2LdSZ,d2LdZZ,
     &  P, EUEG
      REAL*8 PA,GAA,TauA,FA,FPA,FGA,FTA,EUA,ChiA,EUPA,ChiAP,ChiAG
      REAL*8 PB,GBB,TauB,FB,FPB,FGB,FTB,EUB,ChiB,EUPB,ChiBP,ChiBG
      REAL*8 sopp0, sopp1,sopp2, sopp3, sopp4
      REAL*8 U, W, dUdChiA,dUdChiB,dUdPA,dUdPB,dUdGA,dUdGB,
     &dWdU,dWdPA,dWdPB, dWdGA,dWdGB,EUEGPA,EUEGPB

      REAL*8   F1, F2, F3, F4, COpp
      Data COpp/0.0031d0/,F1/1.0d0/,F2/2.0d0/,F3/3.0d0/,F4/4.0d0/

      INTEGER ijzy

      if (ijzy.eq.1) then
C     Parameters for M06-L Correlation
         sopp0= 6.042374D-01
         sopp1= 1.776783D+02
         sopp2= -2.513252D+02
         sopp3= 7.635173D+01
         sopp4= -1.255699D+01
      elseif (ijzy.eq.2) then
C     Parameters for M06-HF Correlation
         sopp0= 1.674634D+00
         sopp1= 5.732017D+01
         sopp2= 5.955416D+01
         sopp3= -2.311007D+02
         sopp4= 1.255199D+02
      elseif (ijzy.eq.3) then
C     Parameters for M06 Correlation
         sopp0= 3.741539D+00
         sopp1= 2.187098D+02
         sopp2= -4.531252D+02
         sopp3= 2.936479D+02
         sopp4= -6.287470D+01
C     elseif (ijzy.eq.4) then
      else
C     Parameters for M06-2X Correlation
         sopp0= 8.833596D-01
         sopp1= 3.357972D+01
         sopp2= -7.043548D+01
         sopp3= 4.978271D+01
         sopp4= -1.852891D+01
      endif
*
      F6=6.0d0
      F43 = F4 / F3
      Pi34 = F3 / (F4*Pi)
      F13 = F1 / F3
*
      Ta=0.5D0*T_X
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            PA=max(1.0D-24,Rho(ipR,iGrid))
            If (PA.lt.Ta) Go To 110
            grdrhoa_x=Rho(ipdRx,iGrid)
            grdrhoa_y=Rho(ipdRy,iGrid)
            grdrhoa_z=Rho(ipdRz,iGrid)
            GAA=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
            TauA = Rho(ipTau,iGrid)
            Call m06css(T_X,PA,GAA,TauA,FA,FPA,FGA,FTA,EUA,
     &                  ChiA,EUPA,ChiAP,ChiAG,ijzy)

            F_xc(iGrid)=F_xc(iGrid)+(2.0D0*FA)
*           dF/dRho
            dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+FPA
*           dF/dGamma, no Gamma_ab term
            dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+ FGA
*           dF/dTau
            dF_dRho(ipT,iGrid)=dF_dRho(ipT,iGrid)+FTA
*
            P=2.D0*PA
            RS = (Pi34/P) ** F13
            RSP = -RS/(F3*P)
            Zeta = 0.0D0
            dZdA = F1/P
            Call lsdac(RS,Zeta,PotLC,dLdS,dLdZ,d2LdSS,d2LdSZ,
     &                 d2LdZZ)
            EUEG = P*PotLC - 2.0D0*EUA
            U = COpp*(2.0D0*ChiA)/(F1 + COpp*(2.0D0*ChiA))
            W = sopp0+U*(sopp1+U*(sopp2+U*(sopp3+U*sopp4)))
            F_xc(igrid) = F_xc(iGrid) + EUEG*W
*
            dUdChiA =COpp/(F1 + COpp*(2.0D0*ChiA))**2
            dUdPA= dUdChiA*ChiAP
            dUdGA= dUdChiA*ChiAG
            dWdU =sopp1+U*(F2*sopp2+U*(F3*sopp3+U*F4*sopp4))
            dWdPA= dWdU*dUdPA
            dWdGA= dWdU*dUdGA
            EUEGPA = PotLC + P*dLdS*RSP + P*dLdZ*dZdA - EUPA
*           dF/dRho
            dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+EUEGPA*W
     &                                             +EUEG*dWdPA
*           dF/dGamma
            dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+EUEG*dWdGA
110         continue
         End Do
      Else
         Do iGrid = 1, mGrid
            PA=max(1.0D-24,Rho(ipRa,iGrid))
            If (PA.lt.Ta) Go To 100
            grdrhoa_x=Rho(ipdRxa,iGrid)
            grdrhoa_y=Rho(ipdRya,iGrid)
            grdrhoa_z=Rho(ipdRza,iGrid)
            GAA=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
            TauA = Rho(ipTaua,iGrid)
            Call m06css(T_X,PA,GAA,TauA,FA,FPA,FGA,FTA,EUA,
     &                  ChiA,EUPA,ChiAP,ChiAG,ijzy)
*
            F_xc(iGrid)=F_xc(iGrid)+FA
*           dF/dRhoa
            dF_dRho(ipRa,igrid)=dF_dRho(ipRa,igrid)+FPA
*           dF/dGammaaa
            dF_dRho(ipGaa,igrid)=dF_dRho(ipGaa,iGrid)+ FGA
*           dF/dTaua
            dF_dRho(ipTa,igrid)=dF_dRho(ipTa,iGrid)+FTA

100         continue
            PB=max(1.0D-24,Rho(ipRb,iGrid))
            if(PB.lt.Ta) goto 111
            grdrhob_x=Rho(ipdRxb,iGrid)
            grdrhob_y=Rho(ipdRyb,iGrid)
            grdrhob_z=Rho(ipdRzb,iGrid)
            GBB=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
            TauB = Rho(ipTaub,iGrid)
            call m06css(T_X,PB,GBB,TauB,FB,FPB,FGB,FTB,EUB,
     &                  ChiB,EUPB,ChiBP,ChiBG,ijzy)

            F_xc(iGrid)=F_xc(iGrid)+FB
*           dF/dRhob
            dF_dRho(ipRb,igrid)=dF_dRho(ipRb,igrid)+FPB
*           dF/dGammabb
            dF_dRho(ipGbb,igrid)=dF_dRho(ipGbb,iGrid)+ FGB
*           dF/dTaub
            dF_dRho(ipTb,igrid)=dF_dRho(ipTb,iGrid)+FTB
111         continue
*
            P=PA+PB
            IF (PB.lt.T_X.or.PA.lt.T_X) Go To 112
            RS = (Pi34/P) ** F13
            RSP = -RS/(F3*P)
            Zeta = (PA-PB)/P
            dZdA = (F1-Zeta)/P
            dZdB = (-F1-Zeta)/P
            Call lsdac(RS,Zeta,PotLC,dLdS,dLdZ,d2LdSS,d2LdSZ,
     $                 d2LdZZ)
            EUEG = P*PotLC - EUA - EUB
            U = COpp*(ChiA+ChiB)/(F1 + COpp*(ChiA+ChiB))
            W = sopp0+U*(sopp1+U*(sopp2+U*(sopp3+U*sopp4)))
            F_xc(iGrid) = F_xc(iGrid) + EUEG*W
            dUdChiA =COpp/(F1 + COpp*(ChiA+ChiB))**2
            dUdChiB =COpp/(F1 + COpp*(ChiA+ChiB))**2
            dUdPA= dUdChiA*ChiAP
            dUdPB= dUdChiB*ChiBP
            dUdGA= dUdChiA*ChiAG
            dUdGB= dUdChiB*ChiBG
            dWdU =sopp1+U*(F2*sopp2+U*(F3*sopp3+U*F4*sopp4))
            dWdPA= dWdU*dUdPA
            dWdPB= dWdU*dUdPB
            dWdGA= dWdU*dUdGA
            dWdGB= dWdU*dUdGB
            EUEGPA = PotLC + P*dLdS*RSP + P*dLdZ*dZdA - EUPA
            EUEGPB = PotLC + P*dLdS*RSP + P*dLdZ*dZdB - EUPB
*           dF/dRho
            dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+EUEGPA*W
     &                                             +EUEG*dWdPA
            dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+EUEGPB*W
     &                                             +EUEG*dWdPB
*           dF/dGamma
            dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+EUEG*dWdGA
            dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+EUEG*dWdGB
 112        Continue
         End Do
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(CoeffA)
      End
      Subroutine m06css(DTol,PX,GX,TX,F,FP,FG,FT,EUEG,Chi,EUEGP,
     &                   ChiP,ChiG,ijzy)
      Implicit none
C
C     Compute the same-spin part of the m06 correlation functional for one grid
C     point and one spin-case.
C
C
      integer ijzy
      REAL*8 PX, GX, TX, F, FP, FG, FT, DTol
      REAL*8 EUEG, Chi, EUEGP, ChiP, ChiG
      REAL*8 Zero, Pt25, F1, F2, F3, F4, F5, F6, F8, F11
      REAL*8 ss, sss0,sss1, sss2, sss3, sss4, Css
      REAL*8 Pi, Pi34, F13, F23, F43, F53, F83, F113
      REAL*8 RS, FDUEG, D, Fscc, RSP, dFsccP, dFsccG
      REAL*8 E, W, U, dFsccT, dUdChi, dWdU, dWdP, dWdG
      REAL*8 d2LdSS,d2LdSZ,d2LdZZ,PotLC,dLdS,dLdZ


      Data Zero/0.0d0/, Pt25/0.25d0/, F1/1.0d0/, F2/2.0d0/, F3/3.0d0/,
     $  F4/4.0d0/, F5/5.0d0/, F6/6.0d0/, F8/8.0d0/, F11/11.0d0/,
     $  Css/0.06d0/
C
c     DTol=1.0D-7
      ss=1.0D0
      sss0=0.0D0
      sss1=0.0D0
      sss2=0.0D0
      sss3=0.0D0
      sss4=0.0D0

      if (ijzy.eq.1) then
C     Parameters for M06-L Correlation
         sss0=  5.349466D-01
         sss1=  5.396620D-01
         sss2=  -3.161217D+01
         sss3=  5.149592D+01
         sss4=  -2.919613D+01
      elseif (ijzy.eq.2) then
C     Parameters for M06-HF Correlation
         sss0=  1.023254D-01
         sss1=  -2.453783D+00
         sss2=  2.913180D+01
         sss3=  -3.494358D+01
         sss4=  2.315955D+01
      elseif (ijzy.eq.3) then
C     Parameters for M06 Correlation
         sss0=  5.094055D-01
         sss1=  -1.491085D+00
         sss2=  1.723922D+01
         sss3=  -3.859018D+01
         sss4=  2.845044D+01
      elseif (ijzy.eq.4) then
C     Parameters for M06-2X Correlation
         sss0=  3.097855D-01
         sss1=  -5.528642D+00
         sss2=  1.347420D+01
         sss3=  -3.213623D+01
         sss4=  2.846742D+01
      endif

      If ((PX.le.DTol))  then
        EUEG = Zero
        Chi = Zero
        EUEGP = Zero
        ChiP = Zero
        ChiG = Zero
C       PX = Zero
C       GX = Zero
C       TX = Zero
        F  = Zero
        FP = Zero
        FG = Zero
        FT = Zero
      else
        Pi = F4*ATan(F1)
        Pi34 = F3 / (F4*Pi)
        F13 = F1 / F3
        F23 = F2 / F3
        F43 = F2 * F23
        F53 = F5 / F3
        F83 = F8 / F3
        F113 = F11 / F3
        FDUEG = (F3/F5)*(F6*Pi*Pi)**F23
        RS = (Pi34/PX) ** F13
        Call lsdac(RS,F1,PotLC,dLdS,dLdZ,d2LdSS,d2LdSZ,d2LdZZ)
        EUEG = PX*PotLC
        D = TX - Pt25*GX/PX
C        DUEG = FDUEG*PX**F53
        Chi = GX/PX**F83
        U = Css*Chi/(F1 + Css*Chi)
        W = sss0+U*(sss1+U*(sss2+U*(sss3+U*sss4)))
        Fscc=D/TX
        E = Fscc*W*EUEG
        F = E*ss
        RSP = -RS/(F3*Px)
        ChiG = F1/PX**F83
        ChiP = -F83*Chi/PX
        dFsccP=Pt25*GX/(TX*PX**2)
        dFsccG=-Pt25/(TX*PX)
        dFsccT=Pt25*GX/(PX*TX**2)
        dUdChi=Css/((F1+Css*Chi)**2)
        dWdU=sss1+U*(F2*sss2+U*(F3*sss3+U*F4*sss4))
        dWdP=dWdU*dUdChi*ChiP
        dWdG=dWdU*dUdChi*ChiG
        EUEGP = PotLC + PX*dLdS*RSP
        FP = ss*(dFsccP*W*EUEG
     $                 + Fscc*dWdP*EUEG
     $                 + Fscc*W*EUEGP)
        FG = ss*(dFsccG*W*EUEG
     $                 + Fscc*dWdG*EUEG)

        FT = ss*(dFsccT*W*EUEG)
       Endif

       Return
       End

c
c Perdew 91 local correlation functional at one grid point
c

      Subroutine lsdac(rs,zeta,PotLC,dLdS,dLdZ,d2LdSS,d2LdSZ,d2LdZZ)
     &
      Implicit Real*8 (A-H,O-Z)
C     Evaluate the Perdew 91 local correlation functional and its
C     derivatives at one point.

      REAL*8 rs
      REAL*8 PotLC,dLdS, dLdZ
      REAL*8 eps0c(6), eps1c(6), epsc(6)
      REAL*8 F1, F2, F3, F4, F6, F8, F9, F12
      REAL*8 GammaI,Zeta,FZeta,dfZdz,d2fZdz
      REAL*8 EU,dEUdRS,d2UdRS
      REAL*8 EP,dEPdRS,d2PdRS
      REAL*8 AlphaM,dAMdRS,d2AdRS
      REAL*8 GZ, HZ, dGZ, dHZ, d2GZ, d2HZ

      data eps0c/0.03109070D0,0.21370D0, 7.5957D0,3.5876D0,1.6382D0,
     &         0.49294D0/
      data eps1c/0.01554535D0,0.20548D0,14.1189D0,6.1977D0,3.3662D0,
     &         0.62517D0/
      data epsc/0.01688690D0,0.11125D0,10.3570D0,3.6231D0,0.88026D0,
     &         0.49671D0/
      data F1/1.0d0/, F2/2.0d0/, F3/3.0d0/, F4/4.0d0/, F6/6.0d0/,
     &  F8/8.0d0/, F9/9.0d0/, F12/12.0d0/

      Pi = F4*ATan(F1)
      Third = F1 / F3

      epsc(1) = F1 / (F6*Pi*Pi)
      FZZI = F9*(F2**Third-F1) / F4
      GammaI = F1 / (F2*F2**Third-F2)

      Call EvFZet(GammaI,Zeta,FZeta,dfZdz,d2fZdz)
      Call EvPWLC(eps0c(1),eps0c(2),eps0c(3),eps0c(4),eps0c(5),
     &            eps0c(6), RS,EU,dEUdRS,d2UdRS)
      Call EvPWLC(eps1c(1),eps1c(2),eps1c(3),eps1c(4),eps1c(5),
     &            eps1c(6),RS,EP,dEPdRS,d2PdRS)
      Call EvPWLC(epsc(1),epsc(2),epsc(3),epsc(4),epsc(5),
     &            epsc(6),RS,AlphaM,dAMdRS,d2AdRS)
      Z2 = Zeta*Zeta
      Z3 = Zeta*Z2
      Z4 = Zeta*Z3
      GZ = FZeta*Z4
      HZ = FZZI*(FZeta-GZ)
      PotLC = EU*(F1-GZ) + EP*GZ - AlphaM*HZ
      dLdS = dEUdRS*(F1-GZ) + dEPdRS*GZ - dAMdRS*HZ
      dGZ = dfZdz*Z4 + F4*FZeta*Z3
      dHZ = FZZI*(dFZdz-dGZ)
      dLdz = (EP-EU)*dGZ - AlphaM*dHZ
      d2GZ = d2fZdz*Z4 + F8*Z3*dfZdz + F12*FZeta*Z2
      d2HZ = FZZI*(d2FZdz-d2GZ)
      d2LdSS = d2UdRS*(F1-GZ) + d2PdRS*GZ - d2AdRS*HZ
      d2LdSZ = (dEPdRS-dEUdRS)*dGZ - dAMdRS*dHZ
      d2LdZZ = (EP-EU)*d2GZ - AlphaM*d2HZ
      Return
      End

c
c   f(zeta)
c
      Subroutine EvFZet(S,Zeta,FZeta,dfZdz,d2fZdz)
      Implicit Real*8(A-H,O-Z)
c
c     evaluate f(Zeta) and its derivatives for lsdac.
c
      REAL*8 Small
      REAL*8 S, Zeta, FZeta,dfZdz,d2fZdz
      REAL*8 Zero, One, Two, Three, Four, Nine, F8, F27
      REAL*8 OMZ, OPZ, OMZ2, OPZ2, OMZ3, OPZ3
      REAL*8 F13, F43, F49, F827
      data Zero/0.0d0/, One/1.0d0/, Two/2.0d0/, Three/3.0d0/,
     $  Four/4.0d0/, Nine/9.0d0/, F8/8.0D0/, F27/27.0D0/
C
      Small = 1.0d-14
      FZeta = -Two
      dfZdz = Zero
      d2fZdz = Zero
      OMZ = One - Zeta
      OPZ = One + Zeta
      OMZ2 = OMZ**2
      OPZ2 = OPZ**2
      F13 = One / Three
      F43 = Four / Three
      F49 = Four / Nine
      F827 = F8 / F27
      If(OMZ.gt.Small) then
        OMZ3 = OMZ ** F13
        fZeta = fZeta + OMZ*OMZ3
        dfZdz = dfZdz - OMZ3
        d2fZdz = d2fZdz + OMZ3/OMZ
        endIf
      If(OPZ.gt.Small) then
        OPZ3 = OPZ ** F13
        fZeta = fZeta + OPZ*OPZ3
        dfZdz = dfZdz + OPZ3
        d2fZdz = d2fZdz + OPZ3/OPZ
        endIf
      fZeta = fZeta * S
      dfZdz = dfZdz * F43 * S
      d2fZdz = d2fZdz * F49 * S
      Return
      End

c
c  pw91 local correlation
c
      Subroutine EvPWLC(A,A1,B1,B2,B3,B4,RS,V,dVdRS,d2VdRS)
      Implicit none
C
C     Evaluate the interpolation function for PW91 local correlation.
C
      REAL*8 A,A1,B1,B2,B3,B4,RS,V,dVdRS,d2VdRS
      REAL*8 F1,F2, F3, F4
      REAL*8 Q0, RS12, RS32,Q1,Q2
      REAL*8 dQ0dRS,dQ1dRS,dQ2dRS
      REAL*8 d2Q1dS, d2Q2dS
      data F1/1.0d0/, F2/2.0d0/, F3/3.0d0/, F4/4.0d0/
C
      Q0 = -F2*A*(F1+A1*RS)
      RS12 = Sqrt(RS)
      RS32 = RS*RS12
      Q1 = F2*A*(B1*RS12+B2*RS+B3*RS32+B4*RS*RS)
      Q2 = Log(F1+F1/Q1)
      V = Q0*Q2
C
      dQ0dRS = -F2*A*A1
      dQ1dRS = A*(B1/RS12+F2*B2+F3*B3*RS12+F4*B4*RS)
      dQ2dRS = -dQ1dRS/(Q1+Q1**2)
      dVdRS = dQ0dRS*Q2 + Q0*dQ2dRS
C
      d2Q1dS = A*(F3*B3/(RS12*F2)-B1/(RS32*F2)+F4*B4)
      d2Q2dS = (F2*Q1+F1)*(dQ1dRS/(Q1+Q1**2))**2 - d2Q1dS/(Q1+Q1**2)
      d2VdRS = F2*dQ0dRS*dQ2dRS + Q0*d2Q2dS
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine setretvals_cvb(esym,n_iter)
      implicit real*8 (a-h,o-z)
      dimension esym(*)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"

      if(nac.eq.0) then
        ener(1,iter)=emy
      else
        do 100 jroot=1,lroots
        ener(jroot,iter)=esym(lsym)
100     continue
      endif
      iterci=n_iter
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1995, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE GASDN2(I12,RHO1,RHO2,
     &           R,L,CB,SB,C2,ICOCOC,ISOCOC,ICSMOS,ISSMOS,
     &           ICBLTP,ISBLTP,NACOB,
     &           NSSOA,ISSOA,NSSOB,ISSOB,
     &           NAEL,IAGRP,NBEL,IBGRP,
     &           IOCTPA,IOCTPB,NOCTPA,NOCTPB,
     &           NSMST,NSMOB,NSMSX,NSMDX,
     &           MXPNGAS,NOBPTS,IOBPTS,
     &           MAXK,MAXI,LC,LS,
     &           CSCR,SSCR,SXSTSM,STSTSX,STSTDX,
     &           SXDXSX,ADSXA,ASXAD,
     &           NGAS,NELFSPGPA,NELFSPGPB,IDC,
     &           ISOOSC,NSOOSC,ISOOSE,NSOOSE,
     &           ICOOSC,NCOOSC,ICOOSE,NCOOSE,
     &           IASOOS,IACOOS,
     &           I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,X,
     &           MXPOBS,IPRNT,RHO1S,
     &           LUL,LUR,PSL,PSR,RHO1P,XNATO,ieaw,n1,n2 )
*
*
* Jeppe Olsen , Winter of 1991
* GAS modificatios, August 1995
*
* =====
* Input
* =====
*
* I12    : = 1 => calculate one-electron density matrix
*          = 2 => calculate one-and two-electron density matrix
* RHO1   : Initial one-electron density matrix
* RHO2   : Initial two-electron density matrix
*
* ICOCOC : Allowed type combinations for C
* ISOCOC : Allowed type combinations for S(igma)
* ICSMOS : Symmetry array for C
* ISSMOS : Symmetry array for S
* ICBLTP : Block types for C
* ISBLTP : Block types for S
*
* NACOB : Number of active orbitals
* NSSOA : Number of strings per type and symmetry for alpha strings
* ISSOA : Offset for strings if given type and symmetry, alpha strings
* NAEL  : Number of active alpha electrons
* NSSOB : Number of strings per type and symmetry for beta strings
* ISSOB : Offset for strings if given type and symmetry, beta strings
* NBEL  : Number of active beta electrons
*
* MAXIJ : Largest allowed number of orbital pairs treated simultaneously
* MAXK  : Largest number of N-2,N-1 strings treated simultaneously
* MAXI  : Max number of N strings treated simultaneously
*
*
* LC : Length of scratch array for C
* LS : Length of scratch array for S
* RHO1S: Scratch array for one body
* CSCR : Scratch array for C vector
* SSCR : Scratch array for S vector
*
* The L and R vectors are accessed through routines that
* either fetches/disposes symmetry blocks or
* Symmetry-occupation-occupation blocks
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER DXSTST(1),SXSTST(1)
*.General input
      INTEGER ICOCOC(NOCTPA,NOCTPB),ISOCOC(NOCTPA,NOCTPB)
      INTEGER ICSMOS(NSMST),ISSMOS(NSMST)
      INTEGER ICBLTP(*),ISBLTP(*)
      INTEGER NSSOA(NSMST,NOCTPA),ISSOA(NSMST,NOCTPA)
      INTEGER NSSOB(NSMST,NOCTPB),ISSOB(NSMST,NOCTPB)
      INTEGER SXSTSM(NSMSX,NSMST)
      INTEGER STSTSX(NSMST,NSMST)
      INTEGER STSTDX(NSMST,NSMST)
      INTEGER ADSXA(MXPOBS,2*MXPOBS),ASXAD(MXPOBS,2*MXPOBS)
      INTEGER SXDXSX(2*MXPOBS,4*MXPOBS)
      INTEGER NELFSPGPA(3,*)
      INTEGER NELFSPGPB(3,*)
*.Scratch
      DIMENSION SB(*),CB(*),C2(*)
      DIMENSION CSCR(*),SSCR(*)
      DIMENSION ISOOSC(NOCTPA,NOCTPB,NSMST),NSOOSC(NOCTPA,NOCTPB,NSMST)
      DIMENSION ISOOSE(NOCTPA,NOCTPB,NSMST),NSOOSE(NOCTPA,NOCTPB,NSMST)
      DIMENSION ICOOSC(NOCTPA,NOCTPB,NSMST),NCOOSC(NOCTPA,NOCTPB,NSMST)
      DIMENSION ICOOSE(NOCTPA,NOCTPB,NSMST),NCOOSE(NOCTPA,NOCTPB,NSMST)
      DIMENSION IASOOS(NOCTPA,NOCTPB,NSMST),IACOOS(NOCTPA,NOCTPB,NSMST)
      DIMENSION I1(*),I2(*),XI1S(*),XI2S(*),I3(*),XI3S(*),I4(*),XI4S(*)
      DIMENSION X(*)
      DIMENSION RHO1S(*)
      DIMENSION NOBPTS(*),IOBPTS(*)
*.
      INTEGER LASM(4),LBSM(4),LATP(4),LBTP(4),LSGN(5),LTRP(5)
      INTEGER RASM(4),RBSM(4),RATP(4),RBTP(4),RSGN(5),RTRP(5)
      REAL * 8 INPROD_MCLR,L
      DIMENSION L(*),R(*)
*.Output
      DIMENSION RHO1(*),RHO2(*)
      DIMENSION RHO1P(*),XNATO(*)
*
      DIMENSION ISTRFL(1)
*
      PLL=0.0D0
      PLR=0.0D0
*
* ================================
* 1 : Arrays for accessing L and R
* ================================
*.L Compact form
      NTEST=0
      CALL ZOOS(ISSMOS,ISBLTP,NSMST,ISOCOC,NSSOA,NSSOB,
     &          NOCTPA,NOCTPB,IDC,ISOOSC,NSOOSC,NSCMBC,0)
*.L Full determinant form
      CALL ZOOS(ISSMOS,ISBLTP,NSMST,ISOCOC,NSSOA,NSSOB,
     &          NOCTPA,NOCTPB,1  ,ISOOSE,NSOOSE,NSCMBE,1)
*.R compact form
      CALL ZOOS(ICSMOS,ICBLTP,NSMST,ICOCOC,NSSOA,NSSOB,
     &          NOCTPA,NOCTPB,IDC,ICOOSC,NCOOSC,NCCMBC,0)
*.R Full determinant form
      CALL ZOOS(ICSMOS,ICBLTP,NSMST,ICOCOC,NSSOA,NSSOB,
     &          NOCTPA,NOCTPB,1  ,ICOOSE,NCOOSE,NCCMBE,1)
*. Initialize loop over batches of L blocks
      ISENSM = 1
      ISENTA = 1
      ISENTB = 1
      IFRSTS = 1
* Loop over batches over L blocks
10001 CONTINUE
*. Next batch of L blocks
        ISSTSM = ISENSM
        ISSTTA = ISENTA
        ISSTTB = ISENTB
        CALL INCOOS(IDC,ISBLTP,NSOOSE,NOCTPA,NOCTPB,ISSTSM,ISSTTA,
     &              ISSTTB,NSMST,ISENSM,ISENTA,ISENTB,IASOOS,
     &              LS,ISFINI,NSBLK,IFRSTS,ISOCOC)
        IF(NSBLK.EQ.0.AND.ISFINI.NE.0) GOTO 10002
        IFRSTS = 0
*. Obtain L blocks
        IS1SM = ISSTSM
        IS1TA = ISSTTA
        IS1TB = ISSTTB
        ISOFF = 1
        DO 201 ISBLK = 1, NSBLK
          ISBSM = ISSMOS(IS1SM)
          IF(NTEST.GE.20)
     &    WRITE(6,*) ' ISBLK ISOFF ', ISBLK,ISOFF
          IF(ISOCOC(IS1TA,IS1TB).EQ.1)
     &    CALL GSTTBL_MCLR(L,SB(ISOFF),IS1TA,IS1SM,IS1TB,ISBSM,ISOCOC,
     &                NOCTPA,NOCTPB,NSSOA,NSSOB,PSL,ISOOSC,IDC,
     &                PLL,LUL,C2)
*    &                PSL,LUL,C2,NSMST)
          ISOFF = ISOFF + NSOOSE(IS1TA,IS1TB,IS1SM)
          IF(ISBLK.NE.NSBLK) THEN
            CALL NXTBLK_MCLR(IS1TA,IS1TB,IS1SM,NOCTPA,NOCTPB,NSMST,
     &      ISBLTP,IDC,NONEWS,ISOCOC)
          END IF
  201   CONTINUE
*. Initialize loop over blocks over L vector
        ICENSM = 1
        ICENTA = 1
        ICENTB = 1
*. Loop over blocks of R vector
        IFRSTC = 1
 9001   CONTINUE
        IF(NTEST.GE.20)
     &  write(6,*) ' >>> next batch of R blocks '
          ICSTSM = ICENSM
          ICSTTA = ICENTA
          ICSTTB = ICENTB
*
          CALL INCOOS(IDC,ICBLTP,NCOOSE,NOCTPA,NOCTPB,ICSTSM,ICSTTA,
     &         ICSTTB,NSMST,ICENSM,ICENTA,ICENTB,IACOOS,
     &         LC,IFINIC,NCBLK,IFRSTC,ICOCOC)
*. If no more R blocks goto next batch of L blocks
          IF(NCBLK.EQ.0.AND.IFINIC.NE.0) GOTO 10001
          IFRSTC = 0
*. Read L blocks into core
          IC1SM = ICSTSM
          IC1TA = ICSTTA
          IC1TB = ICSTTB
          ICOFF = 1
          DO 200 ICBLK = 1, NCBLK
            ICBSM = ICSMOS(IC1SM)
            IF(ICOCOC(IC1TA,IC1TB).EQ.1)
     &      CALL GSTTBL_MCLR(R,CB(ICOFF),IC1TA,IC1SM,IC1TB,ICBSM,ICOCOC,
     &                  NOCTPA,NOCTPB,NSSOA,NSSOB,PSR,ICOOSC,IDC,
     &                  PLR,LUR,C2)
*    &                  PCL,LUR,C2,NSMST)
            ICOFF = ICOFF + NCOOSE(IC1TA,IC1TB,IC1SM)
            IF(ICBLK.NE.NCBLK) THEN
              CALL NXTBLK_MCLR(IC1TA,IC1TB,IC1SM,NOCTPA,NOCTPB,NSMST,
     &        ICBLTP,IDC,NONEWC,ICOCOC)
            END IF
  200     CONTINUE
*. Loop over L and R blocks in core and obtain  contribution from
* given L and R blocks
          ISOFF = 1
          IASM = ISSTSM
          IATP = ISSTTA
          IBTP = ISSTTB
          DO 10000 ISBLK = 1, NSBLK
            IBSM = ISSMOS(IASM)
            NIA = NSSOA(IASM,IATP)
            NIB = NSSOB(IBSM,IBTP)
*. Possible permutations of L blocks
            CALL PRMBLK(IDC,ISTRFL,IASM,IBSM,IATP,IBTP,PSL,PLR,
     &           LATP,LBTP,LASM,LBSM,LSGN,LTRP,NLPERM)
            DO 9999 ILPERM = 1, NLPERM
              IIASM = LASM(ILPERM)
              IIBSM = LBSM(ILPERM)
              IIATP = LATP(ILPERM)
              IIBTP = LBTP(ILPERM)
              NIIA = NSSOA(IIASM,IIATP)
              NIIB = NSSOB(IIBSM,IIBTP)
*
              IF(LTRP(ILPERM).EQ.1) THEN
                LROW = NSSOA(LASM(ILPERM-1),LATP(ILPERM-1))
                LCOL = NSSOB(LBSM(ILPERM-1),LBTP(ILPERM-1))
                CALL TRPMT3(SB(ISOFF),LROW,LCOL,C2)
                CALL COPVEC(C2,SB(ISOFF),LROW*LCOL)
               END IF
               IF(LSGN(ILPERM).EQ.-1)
     &         CALL SCALVE(SB(ISOFF),-1.0D0,NIA*NIB)

               JASM = ICSTSM
               JATP = ICSTTA
               JBTP = ICSTTB
               ICOFF = 1
               DO 9000 ICBLK = 1, NCBLK
                 JBSM = ICSMOS(JASM)
                 NJA = NSSOA(JASM,JATP)
                 NJB = NSSOB(JBSM,JBTP)
                 XNORM2 =
     &           INPROD_MCLR(CB(ICOFF),CB(ICOFF),NJA*NJB)!,NJA*NJB)
                 IF(NIA*NIB*NJA*NJB.NE.0
     &             .AND.ISOCOC(IATP,IBTP).EQ.1
     &             .AND.ICOCOC(JATP,JBTP).EQ.1
     &             .AND.XNORM2.NE.0.0D0) THEN
*. Possible permutations of this block
                    CALL PRMBLK(IDC,ISTRFL,JASM,JBSM,JATP,JBTP,
     &                   PSR,PLR,RATP,RBTP,RASM,RBSM,RSGN,RTRP,
     &                   NRPERM)
                    DO 8999 IRPERM = 1, NRPERM
                      IF(RTRP(IRPERM).EQ.1) THEN
                        LROW = NSSOA(RASM(IRPERM-1),RATP(IRPERM-1))
                        LCOL = NSSOB(RBSM(IRPERM-1),RBTP(IRPERM-1))
                        CALL TRPMT3(CB(ICOFF),LROW,LCOL,C2)
                        CALL COPVEC(C2,CB(ICOFF),LROW*LCOL)
                      END IF
                      IF(RSGN(IRPERM).EQ.-1)
     &                CALL SCALVE(CB(ICOFF),-1.0D0,NJA*NJB)
                      JJASM = RASM(IRPERM)
                      JJBSM = RBSM(IRPERM)
                      JJATP = RATP(IRPERM)
                      JJBTP = RBTP(IRPERM)
                      NJJA = NSSOA(JJASM,JJATP)
                      NJJB = NSSOB(JJBSM,JJBTP)
                      CALL GSDNBB2(I12,RHO1,RHO2,
     &                     IIASM,IIATP,IIBSM,IIBTP,
     &                     JJASM,JJATP,JJBSM,JJBTP,NGAS,
     &                     NELFSPGPA(1,IOCTPA-1+IIATP),
     &                     NELFSPGPB(1,IOCTPB-1+IIBTP),
     &                     NELFSPGPA(1,IOCTPA-1+JJATP),
     &                     NELFSPGPB(1,IOCTPB-1+JJBTP),
     &                     NAEL,NBEL,IAGRP,IBGRP,
     &                     SB(ISOFF),CB(ICOFF),C2,
     &                     ADSXA,SXSTST,STSTSX,DXSTST,STSTDX,SXDXSX,
     &                     MXPNGAS,NOBPTS,IOBPTS,MAXI,MAXK,
     &                     SSCR,CSCR,
     &                     I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,
     &                     X,NSMOB,NSMST,NSMSX,NSMDX,
     &                     NIIA,NIIB,NJJA,NJJB,MXPOBS,
     &                     IPRNT,NACOB,RHO1S,ieaw,n1,n2)
 8999                   CONTINUE
*. Transpose or scale R block to restore order ??
                  IF(RTRP(NRPERM+1).EQ.1) THEN
                    CALL TRPMT3(CB(ICOFF),NJB,NJA,C2)
                    CALL COPVEC(C2,CB(ICOFF),NJA*NJB)
                  END IF
                  IF(RSGN(NRPERM+1).EQ.-1)
     &            CALL SCALVE(CB(ICOFF),-1.0D0,NJA*NJB)
*
              END IF
              ICOFF = ICOFF + NCOOSE(JATP,JBTP,JASM)
*. NeXt C block
              IF(ICBLK.NE.NCBLK) THEN
                CALL NXTBLK_MCLR(JATP,JBTP,JASM,NOCTPA,NOCTPB,NSMST,
     &          ICBLTP,IDC,NONEWC,ICOCOC)
              END IF
 9000       CONTINUE
*. End of loop over R blocks in Batch
 9999     CONTINUE
*. Transpose or scale L block to restore order ??
          IF(LTRP(NLPERM+1).EQ.1) THEN
            CALL TRPMT3(SB(ISOFF),NIB,NIA,C2)
            CALL COPVEC(C2,SB(ISOFF),NIA*NIB)
          END IF
          IF(LSGN(NLPERM+1).EQ.-1)
     &    CALL SCALVE(SB(ISOFF),-1.0D0,NIA*NIB)
*. NeXt L block
               ISOFF = ISOFF + NSOOSE(IATP,IBTP,IASM)
            IF(ISBLK.NE.NSBLK) THEN
               CALL NXTBLK_MCLR(IATP,IBTP,IASM,NOCTPA,NOCTPB,NSMST,
     &         ISBLTP,IDC,NONEWS,ISOCOC)
             END IF
10000     CONTINUE
*. End of loop over L blocks in batch
*. End of loop over batches of R blocks
        IF(IFINIC.EQ.0) GOTO 9001
      IF(ISFINI.EQ.0) GOTO 10001
*. End of loop over batches of L blocks
10002     CONTINUE
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer_array(ISSOA)
        CALL Unused_integer_array(ISSOB)
        CALL Unused_integer_array(SXSTSM)
        CALL Unused_integer_array(ASXAD)
        CALL Unused_real_array(RHO1P)
        CALL Unused_real_array(XNATO)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CONF_ARC_W(IOCC_MIN,IOCC_MAX,NORB,NEL,IVERTEXW,IARCW)
! Obtain arcweights for single and double occupied arcs
! from vertex weights
!
! Jeppe Olsen, October 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NORB, IOCC_MIN(NORB), IOCC_MAX(NORB), NEL, IVERTEXW(NORB+1,NEL+1)
integer(kind=iwp), intent(out) :: IARCW(NORB,NEL,2)
integer(kind=iwp) :: I, J, K

IARCW(:,:,:) = 0
! IARCW(I,J,K) is weight of arc with occupation K ending at (I,J)
! IARCW(I,J,K) = Sum(J-K < L <= J)   IVERTEXW(I-1,L)
do I=1,NORB
  do J=1,NEL
    if ((IOCC_MIN(I) <= J) .and. (J <= IOCC_MAX(I))) then
      do K=1,NEL
        if (K == 1) IARCW(I,J,K) = IVERTEXW(I-1+1,J+1)
        if ((K == 2) .and. (J >= 2)) IARCW(I,J,K) = IVERTEXW(I-1+1,J+1)+IVERTEXW(I-1+1,J-1+1)
      end do
    end if
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Arc weights for single occupied arcs'
call IWRTMA(IARCW(1,1,1),NORB,NEL,NORB,NEL)
write(u6,*) ' Arc weights for double occupied arcs'
call IWRTMA(IARCW(1,1,2),NORB,NEL,NORB,NEL)
#endif

end subroutine CONF_ARC_W

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c*****************************************************************
      subroutine complete_ext_loop()
c*****************************************************************
c     26 feb 2007 - revised
c
#include "drt_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

c     write(6,*) ' ext_test '
c      return
      do irot=1,mcroot
        irtidx=indx(irot)
        lwei=isegsta !+irtidx

        do iupwei=1,isegupwei
          ilpvalue=0
          mm0=lwei
          nn=lwei+icano_nnsta-1
          do nntmp=icano_nnsta,icano_nnend
            nn=nn+1
            mm=mm0
            vlptmp1=vector1(nn+irtidx)
            vlptmp=vector2(nn+irtidx)
            do mmtmp=1,nntmp-1
              ilpvalue=ilpvalue+1
              vetmp=value_lpext(ilpvalue)
              mm=mm+1
              vector2(mm+irtidx)=vector2(mm+irtidx)+vlptmp1*vetmp
              vlptmp=vlptmp+vector1(mm+irtidx)*vetmp
            enddo
            vector2(nn+irtidx)=vlptmp
          enddo
          lwei=lwei+isegdownwei
        enddo

      enddo
c...end of complete_ext_loop
      end

      subroutine complete_ext_loop_g()
#include "drt_h.fh"
#include "grad_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)

      lwei=isegsta
      do iupwei=1,isegupwei
        ilpvalue=0
        mm0=lwei
        nn=lwei+icano_nnsta-1
        do nntmp=icano_nnsta,icano_nnend
         nn=nn+1
         mm=mm0
         do mmtmp=1,nntmp-1
            ilpvalue=ilpvalue+1
            mm=mm+1
            indexlp=index_lpext(ilpvalue)
          if(indexlp.ne.0) then
            valuelp=value_lpext(ilpvalue)
            vector2(indexlp)=vector2(indexlp)
     :                   +vector1(mm)*vector1(nn)*valuelp
          end if
            indexlp1=index_lpext1(ilpvalue)
          if(indexlp1.ne.0) then
            valuelp1=value_lpext1(ilpvalue)
            vector2(indexlp1)=vector2(indexlp1)
     :                   +vector1(mm)*vector1(nn)*valuelp1
          end if
            indexlp2=index_lpext2(ilpvalue)
          if(indexlp2.ne.0) then
            valuelp2=value_lpext2(ilpvalue)
               dm1tmp(indexlp2)=dm1tmp(indexlp2)
     :                  +vector1(mm)*vector1(nn)*valuelp2
          endif
         enddo
        enddo
        lwei=lwei+isegdownwei
      enddo
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MOTRAC(CMO,F,X1,X2)
! RASSCF PROGRAM IBM-3090 VERSION: CI SECTION
! PURPOSE: TRANSFORMS A MATRIX F WITH THE TRANSFORMATION MATRIX CMO
!          NORMALLY FROM AO TO MO BASIS. THE RESULT OVERWRITES THE
!          INITIAL MATRIX. SYMMETRY BLOCKED.
!          THE MATRIX F IS TRANSFORMED FROM FULL AO BASIS TO
!          ACTIVE ORBITAL MO BASIS.
!          INPUT AND OUTPUT MATRICES IN LOWER TRIANGULAR FORM.
!          CALLED FROM FCIN
!
! ********** IBM-3090 RELEASE 86 12 05 **********

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(inout) :: F(*)
real(kind=wp), intent(out) :: X1(*), X2(*)
integer(kind=iwp) :: ISTFA, ISTFP, ISYM, LMOP, LMOP1, NA, NB
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"

LMOP = 1
ISTFA = 1
ISTFP = 1
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  NA = NASH(ISYM)
  LMOP1 = LMOP+NB*(NISH(ISYM)+NFRO(ISYM))
  if (NA /= 0) then
    call SQUARE(F(ISTFP),X1,1,NB,NB)
    call DGEMM_('N','N',NB,NA,NB,One,X1,NB,CMO(LMOP1),NB,Zero,X2,NB)
    call DGEMM_Tri('T','N',NA,NA,NB,One,X2,NB,CMO(LMOP1),NB,Zero,F(ISTFA),NA)

    ISTFA = ISTFA+ITRI(NA+1)
  end if
  LMOP = LMOP+NB**2
  ISTFP = ISTFP+ITRI(NB+1)
end do

return

end subroutine MOTRAC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C
C----------------------------------------------------------------------|
C
      subroutine dkh_ts1e(n,s,t,v,w,ul,us,clight,dkord,xord,dkparam)
C
C Evaluate the arbitrary order DKH Hamiltonian ( and transform matrices ul & us )
C
      implicit none
#include "WrkSpc.fh"
C Input
      integer n,dkord,xord,dkparam
      Real*8 s(n,n),t(n,n),v(n,n),w(n,n),clight
C Ouput
C     ! v : store the transformed relativistic one-electron Hamiltonian
      Real*8 ul(n,n),us(n,n)
C Temp
      integer i,nn,word,vord,nz,m,n2
      integer iTr,iBk,iEL,iES,iOL,iOS,iEp,iE0,iKC,iCo,iSco
      integer iM,iZ,iW,iXL,iXS
C
C Transform Hamiltonian matrix to the free-particle Foldy-Wouthuysen picture
C
      nn=n*n+4
      call getmem('Tr  ','ALLOC','REAL',iTr ,nn)
      call getmem('Back','ALLOC','REAL',iBk ,nn)
      call getmem('mEL ','ALLOC','REAL',iEL ,nn)
      call getmem('mES ','ALLOC','REAL',iES ,nn)
      call getmem('mOL ','ALLOC','REAL',iOL ,nn)
      call getmem('mOS ','ALLOC','REAL',iOS ,nn)
      call getmem('Ep  ','ALLOC','REAL',iEp ,n+4)
      call getmem('E0  ','ALLOC','REAL',iE0 ,n+4)
      call getmem('KC  ','ALLOC','REAL',iKC ,n*3+4)
      call XDR_fpFW(n,s,t,v,w,Work(iTr),Work(iBk),Work(iEL),Work(iES),
     &              Work(iOL),Work(iOS),Work(iEp),work(iE0),Work(iKC),
     &              Work(iKC+n),Work(iKC+2*n),clight)
C
C Call DKH transformation routines
C
C     ! number of W matrices needed
      word = max( dkord/2, xord )
C     ! order of DKH needed, since high Xorder may need more transformation than DKHorder (for Hamiltonian)
      vord = max( dkord, word*2 )
      m = n*n
      nz = m*vord
      call getmem('Wsav','ALLOC','REAL', iW, m*xord*2+4)
      call getmem('Cof ','ALLOC','REAL',iCo, vord+8)
C     ! calculate expansion coefficient of general unitary transformation ( in terms of anti-Hermitian W )
      call dkh_cofu(vord,dkparam,Work(iCo))
C
      if(dkparam.eq.2) then
C       ! special routine for EXP parameterization ( with fewer matrix multiplication than general routine )
        call GetMem('NWork ','ALLOC','REAL',iM,m*5+4)
        call GetMem('NNWork','ALLOC','REAL',iZ,nz*3+4)
        do i=0,m*5
          Work(iM+i) = 0.d0
        end do
        do i=0,nz*3
          Work(iZ+i) = 0.d0
        end do
        call AODKHEXP(n,vord,xord,dkord,Work(iEp),Work(iE0),
     &                Work(iEL),Work(iES),Work(iOL),
     &                Work(iM),Work(iM+m),Work(iM+m*2),
     &                Work(iM+m*3),Work(iM+m*4),
     &                Work(iZ),Work(iZ+nz),Work(iZ+nz*2),
     &                Work(iW) )
        call GetMem('NWork ','FREE','REAL',iM,m*5+4)
        call GetMem('NNWork','FREE','REAL',iZ,nz*3+4)
      else
C       ! general parameterization routine
        call getmem('Cof2','ALLOC','REAL',iSCo,vord+8)
        call getmem('Mat ','ALLOC','REAL', iM, m*6+4)
        call getmem('Mat2','ALLOC','REAL', iZ, nz*10+4)
        call dkh_ham(n,dkord,xord,vord,Work(iEL),Work(iES),Work(iOL),
     &               Work(iOS),Work(iEp),Work(iE0),Work(iCo),Work(iSco),
     &               Work(iM),Work(iM+m),Work(iM+m*2),Work(iM+m*3),
     &               Work(iM+m*4),Work(iM+m*5),
     &               Work(iZ),Work(iZ+nz),Work(iZ+nz*2),Work(iZ+nz*3),
     &               Work(iZ+nz*4),Work(iZ+nz*5),Work(iZ+nz*6),
     &               Work(iZ+nz*7),Work(iZ+nz*8),Work(iZ+nz*9),
     &               Work(iW) )
        call getmem('Cof2','FREE','REAL',iSCo,vord+8)
        call getmem('Mat ','FREE','REAL',iM, m*6+4)
        call getmem('Mat2','FREE','REAL',iZ, nz*10+4)
      end if
C
C Calculate the transform matrices
C
      if(xord.gt.0)then
        call getmem('fpUL','ALLOC','REAL',iXL ,nn)
        call getmem('fpUS','ALLOC','REAL',iXS ,nn)
        n2 = n+n
        call getmem('TmpZ','ALLOC','REAL',iZ,n2*n2*3+4)
C       ! obtain transform matrices ( XL and XS )in fpFW picture
        call dkh_geneu(n,n2,xord,Work(iCo),Work(iW),Work(iXL),Work(iXS),
     &                 Work(iZ),Work(iZ+n2*n2),Work(iZ+n2*n2*2) )
        call getmem('TmpZ','FREE','REAL',iZ,n2*n2*3+4)
C
        call getmem('TmpM','ALLOC','REAL',iM,m*4+4)
C       ! convert to original basis picture
        call XDR_mkutls(n,Work(iXL),Work(iXS),Work(iTr),Work(iBk),
     &     Work(iKC),Work(iKC+n),Work(iKC+2*n),ul,us,Work(iM),
     &     Work(iM+m),Work(iM+m*2),Work(iM+m*3) )
        call getmem('TmpM','FREE','REAL',iM,m*4+4)
        call getmem('fpUL','FREE','REAL',iXL ,nn)
        call getmem('fpUS','FREE','REAL',iXS ,nn)
      end if
C
C Back transform Hamiltonian matrix to original non-orthogonal basis picture
C
      call dmxma(n,'C','N',Work(iBk),Work(iEL),Work(iES),1.d0)
      call dmxma(n,'N','N',Work(iES),Work(iBk),v,1.d0)
C
C Free temp memories
C
      call getmem('Cof ','FREE','REAL',iCo, vord+8)
      call getmem('Wsav','FREE','REAL',iW, m*xord*2+4)
      call getmem('Tr  ','FREE','REAL',iTr ,nn)
      call getmem('Back','FREE','REAL',iBk ,nn)
      call getmem('mEL ','FREE','REAL',iEL ,nn)
      call getmem('mES ','FREE','REAL',iES ,nn)
      call getmem('mOL ','FREE','REAL',iOL ,nn)
      call getmem('mOS ','FREE','REAL',iOS ,nn)
      call getmem('Ep  ','FREE','REAL',iEP ,n+4)
      call getmem('E0  ','FREE','REAL',iE0 ,n+4)
      call getmem('KC  ','FREE','REAL',iKC ,n*3+4)
C
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************
!  Cho_X_GetTol
!
!> @brief
!>   Set tolerance integer for use with ::Add_Info (for verification).
!> @author Thomas Bondo Pedersen
!>
!> @details
!> The tolerance in verification might depend on the
!> threshold of the Cholesky decomposition. The integer
!> used to specify tolerance in ::Add_Info is computed
!> here according to the formula:
!>
!> \f[ \text{iTol} = -\log(\text{Thr}) \f]
!>
!> where \p Thr is the threshold and \f$ \log \f$ is the logarithm
!> (base 10).
!>
!> If the integrals have not been Cholesky decomposed
!> (or represented with DF), this function simply
!> returns \p iTolDef.
!>
!> @param[in] iTolDef Default tolerance
!>
!> @return Tolerance integer for use with ::Add_Info
!***********************************************************************

function Cho_X_GetTol(iTolDef)

use Cholesky, only: ChoIniCheck, ThrCom
use Constants, only: Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: Cho_X_GetTol
integer(kind=iwp), intent(in) :: iTolDef
integer(kind=iwp) :: ChoIsIni
real(kind=wp) :: d, ThrAbs
logical(kind=iwp) :: DidCholesky

call DecideOnCholesky(DidCholesky)
if (DidCholesky) then
  call Get_iScalar('ChoIni',ChoIsIni)
  if (ChoIsIni /= ChoIniCheck) call Get_dScalar('Cholesky Threshold',ThrCom) ! not initialized
  ThrAbs = abs(ThrCom)
  d = -log(ThrAbs)/log(Ten)
  Cho_X_GetTol = nint(d)
else
  Cho_X_GetTol = iTolDef
end if

end function Cho_X_GetTol

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mkfilemgrcom
c
c     this routine make names of temp files and define initial values
c     of filestatus
c
#include "filemgr.fh"
#include "ccsd1.fh"
c
c     help variable
c
       integer nhelp
c
c1    def filestatus
c
       do 100 nhelp=10,maxfiles
       filestatus(nhelp)=0
 100    continue
c
c2    def disk addresses
c
       do 200 nhelp=10,maxfiles
       daddr(nhelp)=0
 200    continue
c
c3    def filenames
c
       filename(10)='INTAB'
       filename(11)='INTA1'
       filename(12)='INTA2'
       filename(13)='INTA3'
       filename(14)='INTA4'
       filename(15)='INTSTA'
       filename(16)=filerst
       filename(17)='Temp17'
       filename(18)='Temp18'
       filename(19)='Temp19'
       filename(20)='Temp20'
       filename(21)='Temp21'
       filename(22)='Temp22'
       filename(23)='Temp23'
       filename(24)='Temp24'
       filename(25)='Temp25'
       filename(26)='Temp26'
       filename(27)='Temp27'
       filename(28)='Temp28'
       filename(29)='Temp29'
       filename(30)='Temp30'
       filename(31)='Temp31'
       filename(32)='Temp32'
       filename(33)='Temp33'
       filename(34)='Temp34'
       filename(35)='Temp35'
       filename(36)='Temp36'
       filename(37)='Temp37'
       filename(38)='Temp38'
       filename(39)='Temp39'
       filename(40)='Temp40'
       filename(41)='Temp41'
       filename(42)='Temp42'
       filename(43)='Temp43'
       filename(44)='Temp44'
       filename(45)='Temp45'
       filename(46)='Temp46'
       filename(47)='Temp47'
       filename(48)='Temp48'
       filename(49)='Temp49'
       filename(50)='Temp50'
c

       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine CHO_SCF_RDINP(DFonly,LuSpool)
************************************************************************
*
*  Purpose:   If DFonly, use defaults only.
*             Else, read and process input for Cholesky section in SCF
*
************************************************************************
      Use Fock_util_global, only: Deco, DensityCheck, Estimate, Update
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Character*180 KWord, Key, Get_Ln
      External Get_Ln
      Logical  DFonly
      character*13 SECNAM
      parameter (SECNAM = 'CHO_SCF_RDINP')
*
#include "choscf.fh"
#include "chotime.fh"
#include "chopar.fh"

*
      iRout=1
      iPrint=nPrint(iRout)
*                                                                      *
***** Algorithms for using Cholesky vectors in SCF *********************
*
*   ALGO:
*          0  --->  Integrals are regenerated on the fly
*                   from a set of Cholesky vectors resorted on disk
*                   (Used only for debugging! Amazingly slow!)
*
*          1  --->  The resorted Cholesky vectors are used directly
*                   by the Fock matrix builder routines and contracted
*                   with the proper density matrices. Uses
*                   vectors resorted either on disk or on the fly
*                   (Used only for debugging! Very slow!)
*
*          2  --->  As in option 1 but using the MO-basis transformed
*                   vectors for computing the exchange term
*
*          3  --->  As in option 2 but using the MO-basis vectors
*                   transformed directly in reduced sets
*
*          4  --->  Local-exchange (LK) algorithm for the exchange term
*
************************************************************************
*                                                                      *
*     Default  parameters

#if defined (_MOLCAS_MPP_)
      ChFracMem=0.3d0
#else
      ChFracMem=0.5d0
#endif

      IF (DFonly) THEN
         ALGO  = 4
         REORD =.false.
         DECO  =.true.
         DensityCheck=.false.
         timings=.false.
         NSCREEN = 10    ! default screening interval (# of red sets)
         dmpk = 0.1d0   ! default damping of the screening threshold
         Estimate = .false.
         Update = .true.
         goto 999  !return flag
      ENDIF
*
*    set some parameters if not specified in ChoInput section
         ALGO  = 4
         REORD =.false.
         DECO  =.true.
         DensityCheck=.false.
         timings=.false.
         NSCREEN = 10
         dmpk = 0.1d0
         Estimate = .false.
         Update = .true.

         dmpk_dfl = 0.1d0
************************************************************************
*                                                                      *
      iPrint=5
*                                                                      *
************************************************************************
*                                                                      *
*-----Process the input
*
*-------------------------------------------------------------------*
* The big turning point.                                            *
*-------------------------------------------------------------------*
1000  Continue
*-------------------------------------------------------------------*
* Use Get_Ln to read the lines.                                     *
*-------------------------------------------------------------------*
      Key=Get_Ln(LuSpool)
      Kword=Key
      Call UpCase(Kword)
*-------------------------------------------------------------------*
* The keywords and their labels.                                    *
*-------------------------------------------------------------------*

      If (KWord(1:1).eq.'*')    Go To 1000
      If (KWord.eq.'')       Go To 1000
      If (KWord(1:4).eq.'ALGO') Go To 900
      If (KWord(1:4).eq.'REOR') Go To 800
      If (KWord(1:4).eq.'NODE') Go To 810
      If (KWord(1:4).eq.'DCHK') Go To 820
      If (KWord(1:4).eq.'TIME') Go To 830
      If (KWord(1:4).eq.'SCRN') Go To 840
      If (KWord(1:4).eq.'DMPK') Go To 850
      If (KWord(1:4).eq.'UPDA') Go To 860
      If (KWord(1:4).eq.'ESTI') Go To 870
      If (KWord(1:4).eq.'LOCK') Go To 880
      If (KWord(1:4).eq.'LK  ') Go To 880
      If (KWord(1:4).eq.'NOLK') Go To 881
      If (KWord(1:4).eq.'MEMF') Go To 890
      If (KWord(1:4).eq.'PRIN') Go To 700
      If (KWord(1:4).eq.'ENDC') Go To 998
      If (KWord(1:4).eq.'END ') Go To 998
      If (KWord(1:4).eq.'ENDO') Go To 998

*-------------------------------------------------------------------*
* Control section
*-------------------------------------------------------------------*
      iChrct=Len(KWord)
      Last=iCLast(KWord,iChrct)
      Write (6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
      Call ErrTra
      Write (6,*) SECNAM, ' Error in keyword.'
      Call Quit_OnUserError()
*                                                                      *
****** ALGO ************************************************************
*                                                                      *
*-----Read Cholesky algorithm parameters
*
 900  Continue
*
       READ(LuSpool,*) ALGO
*
      if(ALGO.eq.0)then
      Write(6,*)
     &'Integral regeneration from Cholesky vectors reordered on disk'
      Write(6,*)
      elseif(ALGO.eq.1)then
      Write(6,*)
     &'Density-based Cholesky. Default reorder: on the fly'
      Write(6,*)
      elseif(ALGO.eq.2)then
      Write(6,*)
     &'MO-based-Exchange Cholesky. Default reorder: on the fly'
      Write(6,*)
      elseif(ALGO.eq.3)then
      Write(6,*)
     &'MO-based-Exchange Cholesky. MO-transformation in reduced sets'
      Write(6,*)
      elseif(ALGO.eq.4)then
      Write(6,*)
     &'Local-Exchange (LK) algorithm.'
      Write(6,*)
      endif

      Go To 1000
*                                                                      *
****** REOR ************************************************************
*                                                                      *
 800   Continue
       REORD=.true.
      Write(6,*)
     &'Vectors reordered on DISK'
      Write(6,*)
*
      Go To 1000
*                                                                      *
****** NODE ************************************************************
*                                                                      *
 810   Continue
       DECO=.false.
      Write(6,*)
     &'Not-Using Decomposed density matrix'
      Write(6,*)
*
      Go To 1000
*                                                                      *
****** DCHK ************************************************************
*                                                                      *
 820   Continue
       DensityCheck=.true.
*
      Go To 1000
*                                                                      *
****** TIME ************************************************************
*                                                                      *
 830   Continue
       timings=.true.
*
      Go To 1000
*                                                                      *
****** SCRN ************************************************************
*                                                                      *
 840   Continue
       READ(LuSpool,*) NSCREEN
*
      Go To 1000
****** DMPK ************************************************************
*                                                                      *
 850   Continue
       READ(LuSpool,*) dmpk
       If (dmpk .lt. 0.0d0) Then
        write(6,*)'OBS! Specified Negative DMPK value. Restore Defaults'
        dmpk=dmpk_dfl
       EndIf
*
      Go To 1000
*                                                                      *
****** UPDA ************************************************************
*                                                                      *
 860   Continue
       Update=.true.
      Write(6,*)
     &'Local-K with updating of the true diagonals'
      Write(6,*)
*
      Go To 1000
*                                                                      *
****** ESTI ************************************************************
*                                                                      *
 870   Continue
       Estimate=.true.
      Write(6,*)
     &'Local-K with evaluation of the diagonals from the current vec '
      Write(6,*)
*
      Go To 1000
*                                                                      *
****** LOCK or LK ******************************************************
*                                                                      *
 880   Continue
       algo=4
c      Write(6,*)
c     &'Local-Exchange (LK) algorithm.'
c      Write(6,*)
*
      Go To 1000
*                                                                      *
****** NoLK ************************************************************
*                                                                      *
 881   Continue
       algo=3
c      Write(6,*)
c     &'Local-Exchange (LK) screening turned off! '
c      Write(6,*)
*
      Go To 1000
*                                                                      *
****** MemF ************************************************************
*                                                                      *
 890   Continue
       READ(LuSpool,*) ChFracMem
*
      Go To 1000
*                                                                      *
****** PRIN ************************************************************
*                                                                      *
*-----Print level
*
 700  Key=Get_Ln(LuSpool)
      KWord=Key
      Call Get_I1(1,n)
      Do i = 1, n
         KWord=Get_Ln(LuSpool)
         Call Get_I1(1,jRout)
         Call Get_I1(2,iPrint)
         nPrint(jRout)=iPrint
      End Do
      Go To 1000
*                                                                      *
****** ENDOFchoinput  **************************************************
*                                                                      *
*-----EndofChoinput
*
 998  Continue
*                                                                      *
************************************************************************
*                                                                      *
999   Continue
      Return
*                                                                      *
************************************************************************
*                                                                      *
*-----Error handling
*
      Call ErrTra
      Write (6,*) SECNAM, ' Premature end of input file.'
      Call Quit_OnUserError()
      Call ErrTra
      Write (6,*) SECNAM, ' Error while reading input file.'
      Call Quit_OnUserError()
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine span2_cvb(c,nvec,s,n,metr)

use casvb_global, only: nvtot, span
use stdalloc, only: mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, metr
real(kind=wp), intent(inout) :: c(n,*)
integer(kind=iwp), intent(inout) :: nvec
real(kind=wp), intent(in) :: s(*)
integer(kind=iwp) :: nvtot_

if (nvtot /= 0) then
  call span_cvb(span,nvtot,nvtot_,s,n,metr)
  nvtot = nvtot_
  c(:,1:nvtot) = span(:,1:nvtot)
end if
nvec = nvtot
call mma_deallocate(span)

return

end subroutine span2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function AtSymb(I)
! ATSYMB(I) is the Atomic Symbol corresponding to the Atomic number I
! if I=0  Atsymb=Bq
! if I=-1 Atsymb=X

use Definitions, only: iwp

use isotopes, only: PTab

implicit none
character(len=2) :: AtSymb
integer(kind=iwp), intent(in) :: I

if (I > 0) then
  AtSymb = PTab(i)
  return
end if
if (I == -1) AtSymb = ' X'
if (I == 0) AtSymb = 'Bq'

return

end function AtSymb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*----------------------------------------------------------------------*
      Subroutine GiveMeInfo(nBB,nntyp,natyp,BasCoo,iCon,nPrim,nBA,nCBoA,
     &                      nBona,ipExpo,ipCont,nSh,nfSh,nSize,iPrint,
     &                      MxAtQ,MxPrCon,MxBasQ,MxAngqNr,ipAcc,
     &                      nACCSize)
      use Basis_Info
      use Center_Info
      use Her_RW
      use Real_Spherical
      Implicit Real*8 (a-h,o-z)

*------------------------------------------------------------------------*
* Include files that got to do with the info-file generated by seward.   *
*------------------------------------------------------------------------*
#include "numbers.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
*------------------------------------------------------------------------*
* Ordinary variables.                                                    *
*------------------------------------------------------------------------*
      Dimension BasCoo(3,MxBasQ),nBona(MxAtQ)
      Dimension nSh(MxAtQ),nFSh(MxAtQ,MxAngqNr),iCon(MxAtQ,MxPrCon)
      Dimension natyp(MxAtQ),nPrim(MxBasQ),nBA(MxAtQ)
      Dimension nCBoA(MxAtQ,MxAngqNr)
      Real*8, Allocatable:: TEMP1(:), TEMP2(:)
      Logical DoRys


*------------------------------------------------------------------------*
* Initialize in order to read properly from the info file.               *
*------------------------------------------------------------------------*
      Call Seward_Init()

*------------------------------------------------------------------------*
* GetInf reads everything in the info file and put it in variables       *
* in the info.fh include file. Look in the header of info.fh to see the  *
* plethora of numbers you can fetch there.                               *
*------------------------------------------------------------------------*
      nDiff=0
      DoRys=.false.
      Call GetInf(DoRys,nDiff)

*------------------------------------------------------------------------*
* Set nntyp.                                                             *
*------------------------------------------------------------------------*
      nntyp=nCnttp

*------------------------------------------------------------------------*
* Compute what we came here for. iBasAng will contain nBas elements with *
* integers, such that 1=s-orbitals, 2=p-orbitals, 3=d-orbitals, ...      *
*------------------------------------------------------------------------*
C     ii=0  !ii is number of basis sets.
C10   Continue
C       ii=ii+1
C     If(dbsc(ii)%nCntr.ne.0) Go To 10
C     ii=ii-1
C     If(ii.eq.0) then
C       Write(6,*)
C       Write(6,*)'ERROR in GiveMeInfo. No atoms?'
C     Endif
      ii=nCnttp
*
      kaunta=0
      kaunt=0
      kaunter=0
      krekna=0
      MaxAng=0
      Do 20, i=1,ii
        kauntSav=kaunt
        Do 25, ioio=1,dbsc(i)%nCntr
          krekna=krekna+1
          krekna2=0
          kaunt=kauntSav
          kaunterPrev=kaunter
          nBA(krekna)=dbsc(i)%nShells
          If(nBA(krekna).gt.MaxAng)MaxAng=nBA(krekna)
          Do 30, j=1,dbsc(i)%nShells
            kaunt=kaunt+1
            krekna2=krekna2+1
            nCBoA(krekna,krekna2)=Shells(kaunt)%nBasis
            Do 40, jj=1,Shells(kaunt)%nBasis
              kaunter=kaunter+1
40          Continue
30        Continue
          kaunta=kaunta+1
          nBonA(kaunta)=kaunter-kaunterPrev  !Number of bases on each,
25      Continue                         !atom used below.
20    Continue

*--------------------------------------------------------------------------*
* And now coordinates of each basis.                                       *
*--------------------------------------------------------------------------*
      kaunter=0
      kaunt=0
      Do 101, i=1,ii
        Do 111, j=1,dbsc(i)%nCntr
          kaunt=kaunt+1
          Do 121, kk=1,nBonA(kaunt)
            kaunter=kaunter+1
            Do 131, k=1,3
              BasCoo(k,kaunter)=dbsc(i)%Coor(k,j)
131         Continue
121       Continue
111     Continue
101   Continue

*--------------------------------------------------------------------------*
* Now get info regarding the contraction. Icon is an array that for each   *
* basis type contain n1+n2+...+nx elements where n1 is the number of       *
* contracted basis functions of s-type, n2 the same number for p-type etc. *
* The value of the first n1 elements is the number of primitive basis      *
* functions of s-type, etc. So a contraction 7s3p.4s1p generates the vector*
* 7,7,7,7,3. We also compute natyp and also collect all exponents and      *
* contraction coefficients. These are stored dynamically and then we return*
* the pointers only.                                                       *
*--------------------------------------------------------------------------*
      kaunt=0
      Do 201, i=1,ii
        kaunter=0
        Do 203, k=1,dbsc(i)%nShells
          kaunt=kaunt+1
          Do 205, ll=1,Shells(kaunt)%nBasis
            kaunter=kaunter+1
            Icon(i,kaunter)=Shells(kaunt)%nExp
205       Continue
203     Continue
201   Continue

      ndc=0
      iAngSav=1
      nSize=0
      kaunt=0
      Do 2101, kk=1,ii   !Just to get size of vector
        Do 2102, kkk=1,dbsc(kk)%nShells
          kaunt=kaunt+1
          nSize=nSize+Shells(kaunt)%nBasis*Shells(kaunt)%nExp
2102    Continue
2101  Continue
      Call GetMem('Exponents','Allo','Real',ipExpo,nSize*MxAtQ)
      Call GetMem('ContrCoef','Allo','Real',ipCont,nSize*MxAtQ)
      Call FZero(Work(ipExpo),nSize*MxAtQ)
      Call FZero(Work(ipCont),nSize*MxAtQ)

      Do 211, iCnttp=1,nCnttp  !Here we set NaTyp.
        jSum=0
        iTemp=0
        nVarv=dbsc(iCnttp)%nShells
        nSh(iCnttp)=nVarv
        M=iCnttp-1
        Do 212, iCnt=1,dbsc(iCnttp)%nCntr
          ndc=ndc+1
          iTemp=iTemp+dc(ndc)%nStab
212     Continue
        NaTyp(iCnttp)=iTemp
        Do 213, iAng=0,nVarv-1  !And in this loop we get hold of the
                          !contraction coefficients and the exponents.
          iCount=iAng+iAngSav
          iPrim=Shells(iCount)%nExp
          iBas=Shells(iCount)%nBasis
#ifdef _DEBUGPRINT_
          Call RecPrt('Exp',' ',Shells(iCount)%Exp,iPrim,1)
          Call RecPrt('Cff',' ',Shells(iCount)%pCff,iPrim,iBas)
#endif
          nfSh(iCnttp,iAng+1)=iBas
          Do 214, i=1,iBas
            Call dCopy_(iPrim,Shells(iCount)%Exp,1,
     &                        Work(ipExpo+jSum*MxAtQ+M),MxAtQ)
            Call dCopy_(iPrim,Shells(iCount)%pCff(1,i),1,
     &                        Work(ipCont+jSum*MxAtQ+M),MxAtQ)
            jSum=jSum+iPrim
214       Continue
213     Continue
        iAngSav=iAngSav+iAng
211   Continue
      If(iPrint.ge.30) then
        Write(6,*)'Exp.'
        Write(6,'(10G13.4)')(Work(ipExpo+k),k=0,nSize*MxAtQ-1)
        Write(6,*)'Contr.'
        Write(6,'(10G13.4)')(Work(ipCont+k),k=0,nSize*MxAtQ-1)
      Endif

*---------------------------------------------------------------------------*
* Contruct the nPrim vector.                                                *
*---------------------------------------------------------------------------*
      iBas=0
      Do 301, i=1,nntyp
        na=natyp(i)
        Do 302, j=1,na
          ind=0
          nshj=nsh(i)
          Do 303, k=1,nshj
            nnaa=nfsh(i,k)
            Do 304, l=1,nnaa
              iBas=iBas+1
              ind=ind+1
              nPrim(iBas)=iCon(i,ind)
304         Continue
303       Continue
302     Continue
301   Continue
*
*-- Then since overlap integrations are in cartesian coordinates while
*   the AO-basis is spherical, we need transformation matrix for this.
*   To our great joy, old reliable Seward computes this matrix of any
*   order (within Molcas limits). Due to conflicting order conventions,
*   some numbers gymnastics are required.
*
      MaxAng=MaxAng-1
      nSize=(2*MaxAng+1)*(MaxAng+1)*(MaxAng+2)/2
      nACCSize=0
      Do i=2,MaxAng
        nACCSize=nACCSize+(2*i+1)*(i+1)*(i+2)/2
      End Do
      nSumma=0
      Call mma_allocate(TEMP1,nSize,Label='TEMP1')
      Call mma_allocate(TEMP2,nSize,Label='TEMP2')
      Call GetMem('AccTransa','Allo','Real',ipAcc,nACCSize)
*
      Do i=2,MaxAng
         ind1=(i+1)*(i+2)/2
         ind2=2*i+1
         iHowMuch=ind1*ind2
         Call DCopy_(iHowMuch,RSph(ipSph(i)),iONE,TEMP1,iONE)
         ind3=1
         Do jj=1,ind1
            call dcopy_(ind2,TEMP1(jj),ind1,TEMP2(ind3),iONE)
            ind3=ind3+ind2
         End Do
*        Call recprt('FFF',' ',TEMP1,(i+1)*(i+2)/2,2*i+1)
*        Call recprt('GGG',' ',TEMP2,ind2,ind1)
         call dcopy_(iHowMuch,TEMP2,iONE,Work(ipAcc+nSumma),iONE)
         nSumma=nSumma+iHowMuch
      End Do
*
      Call mma_deallocate(TEMP1)
      Call mma_deallocate(TEMP2)
*----------------------------------------------------------------------*
* Make deallocations. They are necessary because of the getinf.        *
*----------------------------------------------------------------------*
      Call ClsSew()

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nBB)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mkq (wrk,wrksize,
     & mapdt2,mapit2,mapdt11,mapit11,mapdt12,mapit12,
     &                 fact,rc)
c
c     this routine do:
c     t2(a,b,i,j) = fact . t2(a,b,i,j) +t11(ai).t12(bj)
c     for T2aaaa, T2bbbb and T2abab but they must be expanded (typ=0)
c
c     mapdt2  - direct map of T2 (I)
c     mapit2        - inverse map of T2 (I)
c     mapdt11        - direct map of T1 (I)
c     mapit11        - inverse map of T1 (I)
c     mapdt12        - direct map of T11 (I)
c     mapit12        - inverse map of T12 (I)
c     fact    - numerical factor (I)
c     rc        - return (error) code
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer rc
       real*8 fact
c
       integer mapdt2(0:512,1:6)
       integer mapit2(1:8,1:8,1:8)
c
       integer mapdt11(0:512,1:6)
       integer mapit11(1:8,1:8,1:8)
c
       integer mapdt12(0:512,1:6)
       integer mapit12(1:8,1:8,1:8)
c
c     help variables
c
       integer posst2,posst11,posst12
       integer dimi,dimj,dima,dimb,syma,symb,symi,symj
       integer iit2,iit11,iit12
c
       rc=0
c
       if (mapdt2(0,6).eq.0) then
cI.1  typ of t2 is 0 (T2 is expanded)

       do 100 iit2=1,mapdt2(0,5)
c
       posst2=mapdt2(iit2,1)
       syma=mapdt2(iit2,3)
       symb=mapdt2(iit2,4)
       symi=mapdt2(iit2,5)
       symj=mapdt2(iit2,6)
       dima=dimm(mapdt2(0,1),syma)
       dimb=dimm(mapdt2(0,2),symb)
       dimi=dimm(mapdt2(0,3),symi)
       dimj=dimm(mapdt2(0,4),symj)
       iit11=mapit11(syma,1,1)
       iit12=mapit12(symb,1,1)
       posst11=mapdt11(iit11,1)
       posst12=mapdt12(iit12,1)
c
       if ((syma.eq.symi).and.(symb.eq.symj).and.(mapdt2(iit2,2).gt.0))
     & then
       call mkqhelp1 (wrk(posst2),wrk(posst11),wrk(posst12),
     & dima,dimb,dimi,dimj,noa(symi),nob(symj),fact)
       else if (mapdt2(iit2,2).gt.0) then
       call mkqhelp2 (wrk(posst2),mapdt2(iit2,2),mapdt2(iit2,2),fact)
       end if
c
 100    continue
c
c
       else
cI.4  RC=1 : typ of T2 is not 0
       rc=1
       return
       end if
c
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(mapit2)
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine plot_barrier(nBlock,nMult,nDIM,E,M)

      IMPLICIT NONE

      Integer, parameter    :: wp=SELECTED_REAL_KIND(p=15,r=307)
      INTEGER, INTENT(in)   :: nBlock, nMult
      INTEGER, INTENT(in)   :: nDIM(nMult)
      COMPLEX (wp), INTENT(in) :: M(3,nMult,10,nMult,10)
      REAL (wp), INTENT(in) :: E(nBlock)
      ! local variables
      REAL (wp)         :: xstart, xend, dlt, xmin, xmax, emin, emax,
     &                     fact, F, ystart, yend, X, Y, Z, RAVE,
     &                     RAVEMIN, RAVEMAX, color_step
      REAL (wp)         :: gnuplot_version
      INTEGER           :: file_number, istat, i, l, j, i1, j1, k
      INTEGER           :: LuPlt, LuData, file_size, StdOut, iErr
      LOGICAL           :: file_exist, is_file_open, execute_gnuplot_cmd
      CHARACTER(LEN=100):: line1, line2, fmtx, cdummy
      CHARACTER(LEN=100):: gnuplot_CMD, datafile, plotfile
      LOGICAL           :: dbg
      Integer, external :: IsFreeUnit, AixRm

      dbg=.false.
      StdOut = 6
      iErr=0

      xmin=        MINVAL(DBLE( M(3,1:nMult,:,1:nMult,:) )) -
     &     0.10_wp*MAXVAL(DBLE( M(3,1:nMult,:,1:nMult,:) ))
      xmax=        MAXVAL(DBLE( M(3,1:nMult,:,1:nMult,:) )) +
     &     0.10_wp*MAXVAL(DBLE( M(3,1:nMult,:,1:nMult,:) ))
      dlt=0.01_wp*(xmax-xmin)

      F=MAXVAL(E(1:nBlock))
      fact=1.0_wp
      IF (F.lt.10.0_wp) THEN
        fact=1.0_wp
      !ELSE IF ( (F.ge.10.0_wp) .AND. (F.lt.100.0_wp) ) THEN
      !  fact=10.0_wp
      !ELSE IF ( (F.ge.100.0_wp) .AND. (F.lt.1000.0_wp) ) THEN
      !  fact=100.0_wp
      !ELSE IF ( (F.ge.1000.0_wp) .AND. (F.lt.10000.0_wp) ) THEN
      !  fact=1000.0_wp
      ELSE IF ( (F.ge.10000.0_wp) .AND. (F.lt.100000.0_wp) ) THEN
        fact=10000.0_wp
      ELSE IF ( (F.ge.100000.0_wp) .AND. (F.lt.1000000.0_wp) ) THEN
        fact=100000.0_wp
      END IF
      Emin=MINVAL(E(1:nBlock))/fact - 0.05_wp*MAXVAL(E(1:nBlock))/fact
      Emax=MAXVAL(E(1:nBlock))/fact + 0.05_wp*MAXVAL(E(1:nBlock))/fact


      RAVEMIN= 9999999999999999.0_wp
      RAVEMAX=-9999999999999999.0_wp

      l=0
      DO i=1,nMult
        DO i1=1,ndim(i)
          l=l+1
          k=0
          DO j=1,nMult
            DO j1=1,ndim(j)
              k=k+1
              if ((i==j).and.(i1==j1)) cycle
              X=ABS(M(1,i,i1,j,j1))
              Y=ABS(M(2,i,i1,j,j1))
              Z=ABS(M(3,i,i1,j,j1))
              RAVE=(X+Y+Z)/3.0_wp
              IF(RAVE < RAVEMIN) RAVEMIN=RAVE
              IF(RAVE > RAVEMAX) RAVEMAX=RAVE
            END DO
          END DO
        END DO
      END DO

      color_step=(RAVEMAX-RAVEMIN)/256.0_wp

      ! generate the GNUPLOT script in the $WorkDir
      line1=' '
      line2=' '
      gnuplot_CMD=' '
      istat=0
      file_exist=.false.
      is_file_open=.false.
      file_size=0
      execute_gnuplot_cmd =.false.
      gnuplot_version=0.0_wp

      ! check if the file lineOUT exists
      INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open,
     &        NUMBER=file_number)

      IF (file_exist) then
         IF (dbg) WRITE (StdOut,'(A)') 'file "lineOUT" exists in '//
     &                                 'WorkDir'
         IF (is_file_open) then
           IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" is opened'
           ! close the file:
           CLOSE (UNIT=file_number,STATUS='DELETE')
         END IF
         ! delete the file
         IF (dbg) WRITE (StdOut,'(A)') 'deleting the file...'
         iErr=AixRm("lineOUT")
      ELSE
         IF (dbg) WRITE (StdOut,'(A)') 'file "lineOUT" does not exist'//
     &                                 ' in WorkDir'
      END IF


      ! find the gnuplot
      IF (dbg) WRITE (StdOut,'(A)') 'inquire which GNUPLOT'

      CALL systemf ( "which gnuplot >> lineOUT", iErr )

      INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open,
     &        NUMBER=file_number,SIZE=file_size)

      IF (dbg) WRITE (StdOut,*) 'File_number =',file_number
      IF (dbg) WRITE (StdOut,*) 'Is_file_open=',is_file_open
      IF (dbg) WRITE (StdOut,*) 'File_exist  =',file_exist
      IF (dbg) WRITE (StdOut,*) 'File_size   =',file_size

      IF (file_exist) then
        IF (file_size>0) then

          IF (dbg) WRITE (StdOut,'(A)') 'new file  "lineOUT"  exists'//
     &                                  ' in WorkDir'

          file_number=IsFreeUnit(453)
          Call molcas_open(file_number,'lineOUT')

          READ (file_number,'(A)') line1

          IF (dbg) WRITE (StdOut,*) 'line1=',line1
          IF (dbg) WRITE (StdOut,*) trim(line1)
          line2=trim(line1)
          IF (dbg) WRITE (StdOut,*) 'line2=',line2

          CLOSE(file_number)
          IF (dbg) WRITE (StdOut,*) 'Closing lineOUT file'
          FLUSH (StdOut)
          execute_gnuplot_cmd =.true.
        ELSE
          ! file_size =0
          WRITE (StdOut,'(A)') 'file  "lineOUT" has a size=0. '//
     &                         'gnuplot was not found on the system.'
          WRITE (StdOut,'(A)') 'plots will not be created.'
        END IF
      ELSE
         WRITE (StdOut,'(A)') 'file "lineOUT" does not exist in WorkDir'
      END IF
      ! remove file "lineOUT"
      iErr=AixRm("lineOUT")


!!!!! check the version of the gnuplot:
      IF ( execute_gnuplot_cmd ) Then
        IF (dbg) WRITE (StdOut,'(A)') 'inquire which version of '//
     &                                'GNUPLOT is installed'
        ! attempt to execute the script
        WRITE (gnuplot_CMD,'(2A)') trim(line2),' --version > lineOUT'
        IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
        CALL systemf ( gnuplot_CMD, iErr )

        file_number=IsFreeUnit(452)
        Call molcas_open(file_number,'lineOUT')
        READ (file_number,*) cdummy, gnuplot_version
        IF (dbg) WRITE (StdOut,'(A,F4.1)') 'gnuplot_version = ',
     &           gnuplot_version
        IF (abs(gnuplot_version)<0.1_wp) execute_gnuplot_cmd =.false.
        CLOSE (file_number)
        ! remove file "lineOUT"
        iErr=AixRm("lineOUT")
      END IF

!!!!! prepare the energy data file:
      WRITE(datafile,'(A)') 'BARRIER_ENE.dat'
      INQUIRE(FILE=datafile,EXIST=file_exist,OPENED=is_file_open,
     &        NUMBER=file_number)
      IF(file_exist)  iErr=AixRm(trim(datafile))
      LuData=IsFreeUnit(785)
      Call molcas_open(LuData,datafile)
      IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(datafile)//'" file'
      FLUSH(StdOut)
      ! write energies
      l=0
      DO i=1,nMult
        DO i1=1,ndim(i)
          l=l+1
          xstart =  dble(M(3,i,i1,i,i1))-dlt
          xend   =  dble(M(3,i,i1,i,i1))+dlt

          WRITE (LuData,'(3ES24.14)') xstart, E(l)/fact
          WRITE (LuData,'(3ES24.14)') xend  , E(l)/fact
          WRITE (LuData,'(A)') ' '
        END DO
      END DO
      IF (dbg) WRITE (StdOut,*) 'Writing into the "'//trim(datafile)
     &                           //'" file'
      CLOSE (LuData)
      IF (dbg) WRITE (StdOut,*) 'Closing the "'//trim(datafile)
     &                           //'" file'
      FLUSH (StdOut)

!!!!!================================================================
!!!!! prepare the transition matrix elements file:
      WRITE(datafile,'(A)') 'BARRIER_TME.dat'
      INQUIRE(FILE=datafile,EXIST=file_exist,OPENED=is_file_open,
     &        NUMBER=file_number)
      IF(file_exist)  iErr=AixRm(trim(datafile))
      LuData=IsFreeUnit(786)
      Call molcas_open(LuData,datafile)
      IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(datafile)//'" file'
      FLUSH(StdOut)
      ! write energies,
      l=0
      DO i=1,nMult
        DO i1=1,ndim(i)
          l=l+1
          k=0
          DO j=1,nMult
            DO j1=1,ndim(j)
              k=k+1

              if ((i==j).and.(i1==j1)) cycle

              X=ABS(M(1,i,i1,j,j1))
              Y=ABS(M(2,i,i1,j,j1))
              Z=ABS(M(3,i,i1,j,j1))
              RAVE=(X+Y+Z)/3.0_wp

              xstart = dble( M(3,i,i1,i,i1) )
              xend   = dble( M(3,j,j1,j,j1) )

              ystart = E(l)/fact
              yend   = E(k)/fact

              fmtx='(ES24.14,ES24.14,ES24.14)'
              IF(RAVE > RAVEMAX*0.005_wp) THEN
                 WRITE (LuData,fmtx) xstart,ystart,RAVE
                 WRITE (LuData,fmtx) xend  ,yend  ,RAVE
                 WRITE (LuData,'(A)') ' '
              END IF
            END DO
          END DO
        END DO
      END DO
      IF (dbg) WRITE (StdOut,*) 'Writing into the "'//trim(datafile)
     &                           //'" file'
      CLOSE (LuData)
      IF (dbg) WRITE (StdOut,*) 'Closing the "'//trim(datafile)
     &                           //'" file'
      FLUSH (StdOut)

!!!!!===============================================================
!!!!! generate the GNUPLOT script in the $WorkDir



      WRITE(plotfile,'(A)') 'BARRIER.plt'
      INQUIRE(FILE=plotfile,EXIST=file_exist,OPENED=is_file_open,
     &        NUMBER=file_number)
      IF(file_exist) iErr=AixRm(trim(plotfile))
      LuPlt=IsFreeUnit(855)
      Call molcas_open(LuPlt,plotfile)
      IF (dbg) WRITE (StdOut,*) 'Opening "'//trim(plotfile)//'" file'

      IF ( gnuplot_version < 5.0_wp ) Then
      !===  GNUPLOT VERSION 4 and below ==>>  generate EPS
         WRITE (LuPlt,'(A)') 'set terminal postscript eps enhanced '//
     &                       'color  size 3.0, 2.0 font "arial, 10"'
         WRITE (LuPlt,'(A)') 'set output "BARRIER.eps"'
         WRITE (LuPlt,'(A)') 'set grid'
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# Axes'
         WRITE (LuPlt,'(A)') '  set xlabel "Momentum / '//
     &                       '{/Symbol m}_{B}" font "Arial,12"'
         IF( nint(fact).eq.1) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy / '//
     &                         'cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.10) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x10) / '//
     &                         'cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.100) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x100) / '//
     &                         'cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.1000) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x1000)/ '//
     &                         'cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.10000) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x10000)/ '//
     &                         'cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.100000) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x100000) / '//
     &                         'cm^{-1}" font "Arial,12"'
         END IF
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A,F24.14,A,F24.14,A)')
     &                              '  set xrange[', xmin,':', xmax,']'
         WRITE (LuPlt,'(A,F24.14,A,F24.14,A)')
     &                              '  set yrange[', Emin,':', Emax,']'
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# Tics for axes'
         WRITE (LuPlt,'(A)') '  set xtics nomirror'
         WRITE (LuPlt,'(A)') '  set ytics nomirror'
         WRITE (LuPlt,'(A)') '  set mxtics'
         WRITE (LuPlt,'(A)') '  set mytics'
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# Margins'
         WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
         WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# legend'
         WRITE (LuPlt,'(A)') '  set key off' !right bottom'
         WRITE (LuPlt,'(A)')

         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A,ES24.14,A,ES24.14,A)')
     &                 'set palette defined ( ',RAVEMIN," '#FFF0F0', ",
     &                                          RAVEMAX," 'red' )"

         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# actual plotting'
         WRITE (LuPlt,'(A)') 'plot  "BARRIER_TME.dat" using 1:2:3'//
     &                       ' with lines lt 1  lw 1 lc palette , \'
         WRITE (LuPlt,'(A)') '      "BARRIER_ENE.dat" using 1:2  '//
     &                       ' with lines lt 1  lw 8 lc rgb "black" '
         WRITE (LuPlt,'(A)')


      ELSE IF ( (gnuplot_version >= 5.0_wp).AND.
     &          (gnuplot_version <  6.0_wp) ) Then
      !===  GNUPLOT VERSION 5 and above ==>>  generate PNG
         WRITE (LuPlt,'(A)') 'set terminal pngcairo transparent '//
     &         'enhanced font "arial,10" fontscale 4.0 size 1800, 1200'
         WRITE (LuPlt,'(A)') 'set output "BARRIER.png"'
         WRITE (LuPlt,'(A)') 'set grid'
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# Axes'
         WRITE (LuPlt,'(A)') '  set xlabel "Momentum / '//
     &                       '{/Symbol m}_{B}" font "Arial,12"'
         IF( nint(fact).eq.1) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy / '//
     &                         'cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.10) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x10) '//
     &                         '/ cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.100) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x100) '//
     &                         '/ cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.1000) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x1000)/ '//
     &                         'cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.10000) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x10000)/ '//
     &                         'cm^{-1}" font "Arial,12"'
         ELSE IF ( nint(fact).eq.100000) THEN
           WRITE (LuPlt,'(A)') '  set ylabel "Energy (x100000) / '//
     &                         'cm^{-1}" font "Arial,12"'
         END IF
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A,F24.14,A,F24.14,A)')
     &                              '  set xrange[', xmin,':', xmax,']'
         WRITE (LuPlt,'(A,F24.14,A,F24.14,A)')
     &                              '  set yrange[', Emin,':', Emax,']'
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# Tics for axes'
         WRITE (LuPlt,'(A)') '  set xtics nomirror'
         WRITE (LuPlt,'(A)') '  set ytics nomirror'
         WRITE (LuPlt,'(A)') '  set mxtics'
         WRITE (LuPlt,'(A)') '  set mytics'
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# Margins'
         WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
         WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# legend'
         WRITE (LuPlt,'(A)') '  set key off' !right bottom'
         WRITE (LuPlt,'(A)')

         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A,ES24.14,A,ES24.14,A)')
     &                  'set palette defined ( ',RAVEMIN," '#FFF0F0', ",
     &                                           RAVEMAX," 'red' )"

         WRITE (LuPlt,'(A)')
         WRITE (LuPlt,'(A)') '# actual plotting'
         WRITE (LuPlt,'(A)') 'plot  "BARRIER_TME.dat" using 1:2:3 '//
     &                       'with lines lt 1  lw 1 lc palette , \'
         WRITE (LuPlt,'(A)') '      "BARRIER_ENE.dat" using 1:2   '//
     &                       'with lines lt 1  lw 8 lc rgb "black" '
         WRITE (LuPlt,'(A)')
      ELSE
        WRITE (StdOut,*) 'GNUPLOT has version: ', gnuplot_version
        WRITE (StdOut,*) 'This version of GNUPLOT is not known and '//
     &                   'thus, unsupported.'
        execute_gnuplot_cmd=.false.
      END IF
      CLOSE (LuPlt)

      IF (execute_gnuplot_cmd) Then
        ! attempt to execute the script
        WRITE (gnuplot_CMD,'(5A)') trim(line2),' ',trim(plotfile)
        IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
        CALL systemf ( gnuplot_CMD, iErr )
        IF ( gnuplot_version < 5.0_wp ) Then
          WRITE (StdOut,'(A,i0,A)') 'File "BARRIER.eps" was created '//
     &                              'in Working directory.'
        ELSE
          WRITE (StdOut,'(A,i0,A)') 'File "BARRIER.png" was created '//
     &                              'in Working directory.'
        END IF
      END IF

      dbg=.false.

      RETURN
      END SUBROUTINE plot_barrier

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine XDR_Info_Local(n,indx,nb,ib,map)
! calculate information of Local blocks

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: n, indx(n)
integer(kind=iwp), intent(out) :: nb, ib(n), map(n)
integer(kind=iwp) :: i, j, k, m

ib(:) = 0
nb = 0
k = 0
do i=1,n
  if (ib(i) == 0) then
    nb = nb+1
    m = k
    k = k+1
    map(k) = i
    do j=i+1,n
      if ((ib(j) == 0) .and. (indx(j) == indx(i))) then
        k = k+1
        map(k) = j
        ib(j) = -1
      end if
    end do
    ib(nb) = k-m
  end if
end do
!DP write(u6,'(a,9i4)') ' nb,k,n : ',nb,k,n
!DP write(u6,'(a,9i5)') ' blocks : ',(ib(i),i=1,nb)
!DP write(u6,'(a,999i4)') ' map ; ',(map(i),i=1,n)
return

end subroutine XDR_Info_Local

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Francesco Aquilante                              *
************************************************************************

      Subroutine Charge_GRID_IT(nSym,nBas,CMO,nCMO,OCCN,iDoIt,
     &                          long_prt)

**********************************************************************
*
*  Author : F. Aquilante
*
C
C   Purpose: Compute Mulliken charges for each MO separately.
C            The analysis is performed ONLY for the occupied MOs
C            specified in GRID_IT input (this info is stored in iDoIt)
C
C   Note:  this functionality was requested by some Turbomole users
C          recently converted to MolCas. Its scientific value is not
C          too high in my opinion, therefore this subroutine is simply
C          a hack of the existing CHARGE_ and thus infinitely far from
C          efficient coding.
C
C                                            Toulouse, 28 Nov 2011
C
**********************************************************************

      Implicit Real*8 (a-h,o-z)
      Integer nSym, nBas(nSym), nCMO, iDoIt(*)
      Real*8  CMO(nCMO), OCCN(*)
      Logical long_prt
#include "Molcas.fh"
#include "WrkSpc.fh"
      CHARACTER*(LENIN8) NAME(MxBas)


      MXTYP=0
      nTot1=0
      Do iSym = 1, nSym
         MxTyp=MxTyp+nBas(iSym)
         nTot1=nTot1+nBas(iSym)*(nBas(iSym)+1)/2
      End Do
      Call Get_cArray('Unique Basis Names',Name,(LENIN8)*MxTyp)
      Call GetMem('XOCC','ALLO','REAL',ipXocc,MXTYP)
      Call Get_iScalar('Unique atoms',nNUC)
      Call GetMem('QQ','ALLO','REAL',ipQQ,MXTYP*nNuc)
      Call GetMem('Ovrlp','Allo','Real',ipS,nTot1)
      iRc=-1
      iOpt=2
      iComp=1
      iSyLbl=1
      Call RdOne(iRc,iOpt,'Mltpl  0',iComp,Work(ipS),iSyLbl)
      If ( iRc.ne.0 ) then
         Write(6,*) 'charge_grid_it: iRc from Call RdOne not 0'
c         Write(6,*) 'Label = ',Label
         Write(6,*) 'iRc = ',iRc
         Call Abend
      Endif
      Write (6,*)
      Write (6,*)
      Write (6,*)
      Write (6,'(A)')       '         **************************'
      Call CollapseOutput(1,'       Charges per occupied MO ')
      Write (6,'(A)')       '         **************************'
      Write (6,*)
      Write (6,*)
      Write (6,*)

      Call FZero(Work(ipXocc),MXTYP)

      iCase=2
      jOcc=1
      Do iSym=1,nSym
         Do iOrb=1,nBas(iSym)

            If(IdoIt(jOcc).eq.1 .and. OCCN(jOcc).gt.0.0d0) Then

              Write (6,'(A,I4,A,I1,A,F6.4)')'          MO:',iOrb,
     &                                '      Symm.: ',iSym,
     &                                '      Occ. No.: ',OCCN(jOcc)

              lOcc=ipXocc+jOcc-1
              Work(lOcc)=OCCN(jOcc)

              Call FZero(Work(ipQQ),MxTYP*nNuc)
              Call One_CHARGE(NSYM,NBAS,Name,CMO,Work(ipXocc),Work(ipS),
     &                        iCase,long_prt,
     &                        MXTYP,Work(ipQQ),nNuc)
              Work(lOcc)=0.0d0
            EndIf

            jOcc=jOcc+1
         End Do
      End Do

      Call GetMem('XOCC','FRee','REAL',ipXocc,MXTYP)
      Call GetMem('Ovrlp','Free','Real',ipS,nTot1)
      Call GetMem('QQ','FREE','REAL',ipQQ,MXTYP*nNuc)
*
      Return
      End

      SUBROUTINE One_CHARGE(NSYM,NBAS,NAME,CMO,OCCN,SMAT,iCase,FullMlk,
     &                       MXTYP,QQ,nNuc)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "angtp.fh"
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
*
      CHARACTER*(LENIN8) NAME(*)
      DIMENSION NBAS(NSYM),CMO(*),OCCN(*),SMAT(*)
*
      CHARACTER*(LENIN) CNAME(MXATOM)
      CHARACTER*8 TNAME(MXTYP),TMP
      Character*8 TSwap(MXTYP)
c      Character*4 TLbl(MXATOM)
      Character*3 AufBau(19)
      Integer ICNT(MXBAS),ITYP(MXBAS), nStab(MxAtom)
      Integer tNUC, NPBonds, AtomA, AtomB, nBas2
      Real*8 QQ(MXTYP,nNuc),QSUM(MXATOM)
      Real*8 Q2(MXATOM), QSUM_TOT(MXATOM)
      Logical FullMlk
      Character*(LENIN4) LblCnt4(MxAtom)
      Save ipqswap
      Save ipDSswap
      External Get_ProgName
      Character*100 ProgName, Get_ProgName
      Logical DoBond,Reduce_Prt
      External Reduce_Prt
      Character*(LENIN8) Clean_BName
      External Clean_BName
      Data AufBau/'01s',
     &            '02s',            '02p',
     &            '03s',            '03p',
     &            '04s',      '03d','04p',
     &            '05s',      '04d','05p',
     &            '06s','04f','05d','06p',
     &            '07s','05f','06d','07p'/
*                                                                      *
************************************************************************
*                                                                      *
*---- Statement function
*
      Fac(i) = DBLE(nStab(i))/DBLE(nSym)
*                                                                      *
************************************************************************
*                                                                      *
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0

*                                                                      *
************************************************************************
*                                                                      *
      Do i = 1, mxTyp
         TName(i)='        '
      End Do
*
*----------------------------------------------------------------------*
*     Get the name of the calling module.                              *
*     If CPFMCPF no bond analysis is done.                             *
*----------------------------------------------------------------------*
*
      ProgName=Get_ProgName()
      Call Upcase(ProgName)
      Call LeftAd(ProgName)
      iEnd = 1
 93   If (ProgName(iEnd:iEnd).ne.' ') Then
         iEnd=iEnd+1
         Go To 93
      End If

      DoBond = .False.
*
*----------------------------------------------------------------------*
*     Set the Mulliken Bond Order threshold for printout               *
*----------------------------------------------------------------------*
*
      BOThrs = 0.5D0
*
*----------------------------------------------------------------------*
*     GET THE TOTAL NUMBER OF BASIS FUNCTIONS AND CHECK LIMITS         *
*----------------------------------------------------------------------*
*
      NBAST=0
      Do I=1,NSYM
        NBAST=NBAST+NBAS(I)
      End Do
      IF(NBAST.GT.MXBAS) GOTO 991
*
*----------------------------------------------------------------------*
*     Find the list of unique center labels                            *
*----------------------------------------------------------------------*
*
      Call Get_cArray('Unique Atom Names',CNAME,LENIN*nNuc)
      Call Get_iArray('nStab',nStab,nNuc)
*
*----------------------------------------------------------------------*
*     Find the center label for each basis function                    *
*----------------------------------------------------------------------*
*
      Do I=1,NBAST
         ICNT(I)=-1
         Do J=1,NNUC
            If (NAME(I)(1:LENIN).EQ.CNAME(J)) ICNT(I)=J
         End Do
      End Do

*
*----------------------------------------------------------------------*
*     Find the type label for each basis function                      *
*----------------------------------------------------------------------*
*
      NXTYP=0
      Call ICopy(nBAST,[0],0,ITYP,1)
      Do I=1,NBAST
        If (ICNT(I).lt.0) Go To 99  ! skip pseudo center
        Do J=1,NXTYP
          If (J.gt.MxTyp) Then
             Write (6,*) 'Charge: J.gt.MxTyp'
             Write (6,*) 'J=',J
             Write (6,*) 'MxTyp=',MxTyp
             Write (6,*) 'Increase MxType and recompile!'
             Call Abend()
          End If
          If (NAME(I)(LENIN1:LENIN8).EQ.TNAME(J)) Then
            ITYP(I)=J
            Go To 99
          End If
        End Do
        NXTYP=NXTYP+1
        TNAME(NXTYP)=NAME(I)(LENIN1:LENIN8)

*
        ITYP(I)=NXTYP
 99     Continue
      End Do

       lqSwap=NNUC+NNUC*NXTYP

       if(iCase.eq.0) then
c instead of printing charges we dump everything into a memory
c same with DS matrix

         Call GetMem('CHRG_SWP','ALLO','REAL',ipqSwap,lqSwap)

         If (DoBond) Then
           Call Allocate_Work(ipDSswap, (NBAST*NBAST))
         End If

       endif
*
*----------------------------------------------------------------------*
*     Do some trivial sorting of the type labels                       *
*----------------------------------------------------------------------*
*
*     Sort with respect to radial index
*
      ix=0
      jx=0
      Do i = 1, NxTyp-1
         ix = iChar(TNAME(i)(1:1))-iChar('1')+1
         ix = 10*ix + iChar(TNAME(i)(2:2))-iChar('1')+1
*        Put polarization and diffuse functions last
         if (tName(i)(1:1).eq.'*') ix = 100
         Do j = i+1, NxTyp
            jx = iChar(TNAME(j)(1:1))-iChar('1')+1
            jx = 10*jx + iChar(TNAME(j)(2:2))-iChar('1')+1
            if (tName(j)(1:1).eq.'*') jx = 100
            If (ix.gt.jx) Then
               iSwap=ix
               ix=jx
               jx=iSwap
               TMP=TNAME(i)
               TNAME(i)=TNAME(j)
               TNAME(j)=TMP
            End If
         End Do
      End Do
*
*     Sort with respect to angular index
*
      iAng = 0
      jAng = 0
      ix = 1
 666  iix = iChar(tName(ix)(1:1))
      iixx = iChar(tName(ix)(2:2))
      jx = ix
      Do i = Min(ix+1,NxTyp), NxTyp
         If ((iChar(tName(i)(1:1)).eq.iix).and.
     &       (iChar(tName(i)(2:2)).eq.iixx)) jx = i
      End Do
*
      Do i = ix, jx-1
         Do k = 0, iTabMx
            If (AngTp(k).eq.tName(i)(3:3)) iAng=k
         End Do
         Do j = i+1, jx
            Do l = 0, iTabMx
               If (AngTp(l).eq.tName(j)(3:3)) jAng=l
            End Do
            If (iAng.gt.jAng) Then
               iSwap=iAng
               iAng=jAng
               jAng=iSwap
               TMP=TNAME(i)
               TNAME(i)=TNAME(j)
               TNAME(j)=TMP
            End If
         End Do
      End Do
c      Write (*,*) ' Sorted n subrange'
c      Do i = ix, jx
c         Write (*,*) TName(i)
c      End Do
*
*     Now sort with respect to the magnetic index
*
      iEnd = jx
      iStart = ix
 777  Do k = 0, iTabMx
         If (AngTp(k).eq.tName(iStart)(3:3)) iAng=k
      End Do
      jEnd = iStart
      Do i = Min(iStart+1,iEnd),iEnd
         If (tName(i)(3:3).eq.AngTp(iAng)) jEnd=i
      End Do
*
      i0 = iChar('1') - 1
*
      iM = 0
      jM = 0
      If (iAng.eq.1) Then
         Do i = iStart, jEnd-1
            If (tName(i)(4:4).eq.'x') iM = 1
            If (tName(i)(4:4).eq.'z') iM = 0
            If (tName(i)(4:4).eq.'y') iM =-1
            Do j = i+1, jEnd
               If (tName(j)(4:4).eq.'x') jM = 1
               If (tName(j)(4:4).eq.'z') jM = 0
               If (tName(j)(4:4).eq.'y') jM =-1
               If (jM.gt.iM) Then
                  iSwap=iM
                  iM=jM
                  jM=iSwap
                  TMP=TNAME(i)
                  TNAME(i)=TNAME(j)
                  TNAME(j)=TMP
               End If
            End Do
         End Do
      Else If (iAng.ge.2) Then
         Do i = iStart, jEnd-1
            iM = iChar(tName(i)(4:4)) - i0
            iM = 10*iM + iChar(tName(i)(5:5)) - i0
            If (tName(i)(6:6).eq.'-') iM = -iM
            Do j = i+1, jEnd
               jM = iChar(tName(j)(4:4)) - i0
               jM = 10*jM + iChar(tName(j)(5:5)) - i0
               If (tName(j)(6:6).eq.'-') jM = -jM
               If (jM.gt.iM) Then
                  iSwap=iM
                  iM=jM
                  jM=iSwap
                  TMP=TNAME(i)
                  TNAME(i)=TNAME(j)
                  TNAME(j)=TMP
               End If
            End Do
         End Do
      End If
*
      If (jEnd.ne.iEnd) Then
          iStart = jEnd + 1
          Go To 777
      End If
*
      If (jx.ne.NxTyp) Then
         ix = jx + 1
         Go To 666
      End If
*
*     Sort according to AufBau
*
      iStart = 1
      Do iAB = 1, 19
         Do i = 1, NxTyp
            If (TName(i)(1:3).eq.AufBau(iAB)) Then
               TSwap(iStart) = TName(i)
               TName(i)='        '
               iStart = iStart + 1
            End If
         End Do
      End Do
      Do i = 1, NxTyp
         If (TName(i).ne.'        ') Then
            TSwap(iStart) = TName(i)
            TName(i)='        '
            iStart = iStart + 1
         End If
      End Do
      Do i = 1, NxTyp
         TName(i) = TSwap(i)
      End Do

*
      Do I=1,NBAST
         If (ICNT(I).lt.0) Go To 98  ! skip pseudo center
         Do J=1,NXTYP
            If (NAME(I)(LENIN1:LENIN8).eq.TNAME(J)) Then
               ITYP(I)=J
               Go To 98
             End If
        End Do
 98     Continue
      End Do
*
*----------------------------------------------------------------------*
*     Get the total number of atoms tNUC, regardless of symmetry       *
*----------------------------------------------------------------------*
*
      Call Get_iScalar('LP_nCenter', tNUC)
*                                                                      *
*----------------------------------------------------------------------*
*     Bond analysis initialization                                     *
*----------------------------------------------------------------------*
*
      If (DoBond) Then
*                                                                      *
*----------------------------------------------------------------------*
*     In case of symmetry we need the desymmetrization matrix,         *
*     for the bond order calculation only.                             *
*----------------------------------------------------------------------*
*
      If (nSym.gt.1) then
*
         Call Allocate_Work(ipP,NBAST**2)
         Call Allocate_Work(ipPInv,NBAST**2)
         Call Get_dArray('SM',Work(ipP),NBAST**2)
#ifdef _DEBUGPRINT_
         Call RecPrt('SM',' ',Work(ipP),NBAST,NBAST)
#endif
         Call MINV(Work(ipP),Work(ipPInv),ISING,DET,NBAST)
#ifdef _DEBUGPRINT_
         Call RecPrt('SMInv',' ',Work(ipPInv),NBAST,NBAST)
#endif
         Call DGeTMi(Work(ipPInv),NBAST,NBAST)
      End If
*
*     Pick up index array of which center a basis function belongs to.
*     If no symmetry, it is the same as ICNT(I).
*
      Call Allocate_iWork(ip_center,NBAST)
      Call Get_iArray('Center Index',iWork(ip_center),NBAST)
*                                                                      *
************************************************************************
*
*----------------------------------------------------------------------*
*     Initialize symmetric density D_tmp and overlap S_tmp matrices,   *
*     block D_blo and S_blo matrices (if symmetry)                     *
*     plus asymmetric D, S and DS matrices                             *
*----------------------------------------------------------------------*
*
      Call Allocate_Work(ipD_tmp, (NBAST*NBAST))
      Call Allocate_Work(ipS_tmp, (NBAST*NBAST))
      Call Allocate_Work(ipD    , (NBAST*NBAST))
      Call Allocate_Work(ipS    , (NBAST*NBAST))
      Call Allocate_Work(ipDS   , (NBAST*NBAST))
      Do I=1,(NBAST*NBAST)
          Work(ipD_tmp +I-1)=Zero
          Work(ipS_tmp +I-1)=Zero
          Work(ipD     +I-1)=Zero
          Work(ipS     +I-1)=Zero
          Work(ipDS    +I-1)=Zero
      End Do

      If (nSym.gt.1) then
          nBas2=0
          Do I=1, nsym
              nBas2=nBas2+nBas(i)*nBas(i)
          End Do
          Call Allocate_Work(ipD_blo, nBas2)
          Call Allocate_Work(ipS_blo, nBas2)
          Do I =1, nBas2
              Work(ipD_blo + I -1) = Zero
              Work(ipS_blo + I -1) = Zero
          End Do
      End If

*
*----------------------------------------------------------------------*
*     Find the center label for each atom, regardless of symmetry      *
*----------------------------------------------------------------------*
*

*     Just atom label. It's a double of the next one,
*     but someone could find it usefull in future

c     Call Get_LblCnt_All(TLbl)

*     Atom labels plus symmetry generator

      Call Get_cArray('LP_L',LblCnt4,(LENIN4)*tNUC)
c      Do i=1,tNUC
c       LblCnt(i)(1:LENIN)=LblCnt4(i)(1:LENIN)
c      EndDo
*
*----------------------------------------------------------------------*
*     Initialize bond order vector                                     *
*----------------------------------------------------------------------*
*
      NPBonds = tNUC*(tNUC-1)/2
      Call Allocate_Work(ipBonds, NPBonds)
      Call FZero(Work(ipBonds),nPBonds)
*
*----------------------------------------------------------------------*
*     End of Bond analysis initialization                              *
*----------------------------------------------------------------------*
*
      End If
*                                                                      *
*
*----------------------------------------------------------------------*
*     Compute Mulliken atomic charges for each center and basis        *
*     function type                                                    *
*----------------------------------------------------------------------*
*

      NDIM=NXTYP*NNUC
      Call FZero(QQ,nDim)
      IB=0
      IS=0
      IMO=0
      Do ISYM=1,NSYM
        NB=NBAS(ISYM)
        IF ( NB.NE.0 ) THEN
          IMN=0
          Do MY=1,NB
            Do NY=1,MY
              IMN=IMN+1
              DMN=Zero
              ISMO=IMO
              Do IO=1,NB
                DMN=DMN+OCCN(IO+IB)*CMO(ISMO+MY)*CMO(ISMO+NY)
                ISMO=ISMO+NB
              End Do

              If (DoBond) then
*  Save the Density matrix element (my.ny) and (ny,my) in work(ipD_tmp)
*  Save the Overlap matrix element (my.ny) and (ny,my) in work(ipS_tmp)
               Work(ipD_tmp + (NY+IB-1) * NBAST + MY+IB -1)=DMN
               Work(ipD_tmp + (MY+IB-1) * NBAST + NY+IB -1)=DMN
               Work(ipS_tmp + (NY+IB-1) * NBAST + MY+IB -1)=SMAT(IMN+IS)
               Work(ipS_tmp + (MY+IB-1) * NBAST + NY+IB -1)=SMAT(IMN+IS)
              End If

              If ( MY.NE.NY ) DMN=Two*DMN
              MYNUC=ICNT(MY+IB)
              NYNUC=ICNT(NY+IB)
              MYTYP=ITYP(MY+IB)
              NYTYP=ITYP(NY+IB)
              If ( MY.EQ.NY ) Then
                TERM=SMAT(IMN+IS)*DMN
                If (MYNUC.gt.0) QQ(MYTYP,MYNUC)=QQ(MYTYP,MYNUC)+TERM
              Else
                TERM=Half*SMAT(IMN+IS)*DMN
                If (MYNUC.gt.0) QQ(MYTYP,MYNUC)=QQ(MYTYP,MYNUC)+TERM
                If (NYNUC.gt.0) QQ(NYTYP,NYNUC)=QQ(NYTYP,NYNUC)+TERM
              End If
           End Do
          End Do
          IB=IB+NB
          IS=IS+(NB+NB**2)/2
          IMO=IMO+NB**2
        End If
      End Do

*
*----------------------------------------------------------------------*
*     Density and overlap matrix handling for bond order               *
*----------------------------------------------------------------------*
*
      If (DoBond) Then

#ifdef _DEBUGPRINT_
      Call RecPrt('Density Matrix = ', ' ',Work(ipD_tmp), NBAST, NBAST)
      Call RecPrt('Overlap Matrix = ', ' ',Work(ipS_tmp), NBAST, NBAST)
      E=Zero
      Do I=1, NBAST
          Do J=1, NBAST
              E=E+ Work(ipD_tmp + (J-1) * NBAST + I - 1) *
     &             Work(ipS_tmp + (J-1) * NBAST + I - 1)
          End Do
      End Do
      Write(6,*)
      Write(6,*) 'Number of electrons as sum of D and S elements = ', E
#endif

*
*     In case of symmetry, we desymmetrize D and S through D_blo and S_blo
*
      If (nSym.gt.1) then
        iBlo = 0
        iSum = 0
        Do i = 1, NSYM
            If (nbas(i).ne.0) then
                Do j = 0, nbas(i) - 1
                    Do k = 0, nbas(i) - 1
                        Work(ipD_blo + iBlo) = Work(ipD_tmp +
     &                      (j+iSum)*NBAST + iSum + k)
                        Work(ipS_blo + iBlo) = Work(ipS_tmp +
     &                      (j+iSum)*NBAST + iSum + k)
                        iBlo = iBlo +1
                    End Do
                End Do
                iSum = iSum + nbas(i)
            End IF
        End Do

#ifdef _DEBUGPRINT_
        Write(6,*) 'D_blo = '
        Do i=1,nBas2
            Write(6,*) (Work(ipD_blo +I -1))
        End Do
        Write(6,*) 'S_blo = '
        Do i=1,nBas2
            Write(6,*) (Work(ipS_blo +I -1))
        End Do
#endif

        nScr=MXBAS*NBAST
        iSyLbl=1
        Call Allocate_Work(ipScr,nScr)
        Call Desymmetrize(Work(ipD_blo),nBas2,Work(ipScr),nScr,
     &                    Work(ipD),nBas,NBAST,Work(ipP),nSym,
     &                    iSyLbl)
        Call Free_Work(ipScr)

        Call Allocate_Work(ipScr,nScr)
        Call Desymmetrize(Work(ipS_blo),nBas2,Work(ipScr),nScr,
     &                    Work(ipS),nBas,NBAST,Work(ipPInv),nSym,
     &                    iSyLbl)
        Call Free_Work(ipScr)
*
*     Otherwise we simply copy D and S tmp into D and S
*
      Else
         call dcopy_(nBasT**2,Work(ipD_tmp),1,Work(ipD),1)
         call dcopy_(nBasT**2,Work(ipS_tmp),1,Work(ipS),1)
C        Do I=1,NBAST*NBAST
C           Work(ipD+I-1)=Work(ipD_tmp+I-1)
C           Work(ipS+I-1)=Work(ipS_tmp+I-1)
C        End Do
      End If

#ifdef _DEBUGPRINT_
      Write(6,*)'After Desymmetrization'
C     Call RecPrt('Density Matrix = ', ' ', Work(ipD), NBAST, NBAST)
C     Call RecPrt('Overlap Matrix = ', ' ', Work(ipS), NBAST, NBAST)
      Write (6,*) 'Dens=',DDot_(nBast**2,Work(ipD),1,Work(ipD),1),
     &                    DDot_(nBast**2,Work(ipD),1,[One],0)
      Write (6,*) 'Ovrl=',DDot_(nBast**2,Work(ipS),1,Work(ipS),1),
     &                    DDot_(nBast**2,Work(ipS),1,[One],0)
      Write (6,*) 'DO  =',DDot_(nBast**2,Work(ipS),1,Work(ipD),1)
      E=Zero
      Do I=1, NBAST
          Do J=1, NBAST
              E=E+ Work(ipD + (J-1) * NBAST + I - 1) *
     &             Work(ipS + (J-1) * NBAST + I - 1)
          End Do
      End Do
      Write(6,*)
      Write(6,*) 'Number of electrons as sum of D by S elements = ', E
#endif

*
*  Finally, we compute the DS matrix as product of D and S
*
      Call DGEMM_('N','N',
     &            NBAST,NBAST,NBAST,
     &            1.0d0,Work(ipD),NBAST,
     &            Work(ipS),NBAST,
     &            0.0d0,Work(ipDS),NBAST)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('DS Matrix = ',' ', Work(ipDS),    NBAST, NBAST)
      E=Zero
      Do I=1,NBAST
          E=E+Work(ipDS + (I-1) * NBAST + I -1)
      End Do
      Write(6,*)
      Write(6,*) 'Number of electrons as sum of the DS diagonal = ', E
#endif
*
* in case of first call for UHF we dump everything only
*
      If (iCase.eq.0) Then
         Do I=1,NBAST
           Work(ipDSswap + I - 1) = Work(ipDS + I - 1)
         End Do
      End If
*
* in case of second call for UHF we add what dumped before
* and release swap memory
*
      If (iCase.eq.1) Then
        Do I=1,NBAST
          Work(ipDS + I - 1) = Work(ipDS + I - 1) +
     &                         Work(ipDSswap + I - 1)
        End Do
        Call Free_Work(ipDSswap)
*
#ifdef _DEBUGPRINT_
         Call RecPrt('DS Matrix = ',' ', Work(ipDS),    NBAST, NBAST)
         E=Zero
         Do I=1,NBAST
            E=E+Work(ipDS + (I-1) * NBAST + I -1)
         End Do
         Write(6,*)
         Write(6,*)'Number of electrons as sum of the DS diagonal = ', E
#endif
*
         End If
*
      End If
*
*----------------------------------------------------------------------*
*     Compute gross atomic charges                                     *
*----------------------------------------------------------------------*
*
      Do I=1,NNUC
        QSUMI=Zero
        Do J=1,NXTYP
          QSUMI=QSUMI+QQ(J,I)
        End Do
        QSUM(I)=QSUMI
      End Do
c if iCase=0, or 1 we need to put/get QSUM
        Do i=1,NNUC
         if(iCase.eq.0) Work(ipqSwap+i-1)=QSUM(I)
         if(iCase.eq.1) QSUM_TOT(I)=QSUM(I)+Work(ipqSwap+i-1)
         if(iCase.ge.2) QSUM_TOT(I)=QSUM(I)
        Enddo

*
*----------------------------------------------------------------------*
*     Pick up the nuclear charge                                       *
*----------------------------------------------------------------------*
*
      If (iCase.ne.0) then
         Call Allocate_Work(ip_Charge,nNuc)
         Call Get_dArray('Effective nuclear charge',
     &      Work(ip_Charge),nNuc)
         Do iNuc = 0, nNuc-1
           Work(ip_Charge+iNuc) = Work(ip_Charge+iNuc)
     &                          * DBLE(nSym / nStab(iNuc+1))
         End Do
         Call DaXpY_(nNuc,-One,QSUM_TOT,1,Work(ip_Charge),1)
      End If
*
*----------------------------------------------------------------------*
*     Compute the 'Mulliken' Bond Order                                *
*----------------------------------------------------------------------*
*
      If ((DoBond) .AND. (tNUC.gt.1) .AND. (iCase.ge.1)) Then
*
#ifdef _DEBUGPRINT_
        Write (6,*) 'nPBonds,tNuc=',nPBonds,tNuc
        Do MY=1,NBAST
            AtomA=iWork(ip_center+MY-1)
            Write (6,*) 'AtomA,My=',AtomA,My
        End Do
#endif
        Do MY=1,NBAST
            AtomA=iWork(ip_center+MY-1)
            If (ICNT(MY).le.0) Go To 95    ! skip pseudo center
            Do NY=1,MY
              AtomB=iWork(ip_center+NY-1)
              If (ICNT(NY).le.0)      Go To 94  ! skip pseudo center
              If (AtomA.eq.AtomB)  Go To 94  ! same atom
*
              iPair = (Max(AtomA,AtomB)-1)
     &              * (Max(AtomA,AtomB)-2)/2
     &              +  Min(AtomA,AtomB)
              jPair=ipBonds-1+iPair
*
              Work(jPair)=Work(jPair) +
     &                    Work(ipDS+ (NY-1)*NBAST + MY-1) *
     &                    Work(ipDS+ (MY-1)*NBAST + NY-1)
*
#ifdef _DEBUGPRINT_
              Write(6,*)'Bond Number=',iPair
              Write(6,*)'Atom numbers = ',AtomA,AtomB
              Write(6,*)'Bond number = ', iPair,
     &                  'bond order = ',Work(jPair)
              Write(6,*) 'Work(ipDS+ (NY-1) * NBAST + MY-1) =',
     &                    Work(ipDS+ (NY-1) * NBAST + MY-1)
              Write(6,*) 'Work(ipDS+ (MY-1) * NBAST + NY-1) =',
     &                    Work(ipDS+ (MY-1) * NBAST + NY-1)
#endif
 94           Continue
           End Do
 95        Continue
        End Do

*     distant atoms could have negative bond order, set to zero

        Do I=1, NPBonds
            If (Work(ipBonds+I-1).lt.Zero) Work(ipBonds+I-1)=Zero
        End Do

#ifdef _DEBUGPRINT_
        Write(6,*)'Bond order vector'
        Call TriPrt('Bonds','(10F10.5)',Work(ipBonds),tNUC-1)
#endif

      End If
*
*----------------------------------------------------------------------*
*     Printout section                                                 *
*----------------------------------------------------------------------*
*
*
      If (iCase.eq.0) Then
c        first call for UHF, so just dump numbers to swap
         IEND=0
         ik=0
         Do IST=1,NNUC,6
            IEND=MIN(IEND+6,NNUC)
            Do IT=1,NXTYP
               Do j=IST,IEND
                  Work(ipqSwap+NNUC+ik)=QQ(IT,J)
                  ik=ik+1
               End Do
            End Do
         End Do
      End If
*
      If (iCase.eq.1.and.iPL.ge.2) Then
c second call, make a real print out
         If (FullMlk) Then
            Write(6,'(6X,A)')
     &      'Mulliken charges per centre and basis function type'
            Write(6,'(6X,A)')
     &      '---------------------------------------------------'
         Else
            Write(6,'(6X,A)')
     &      'Mulliken charges per centre'
            Write(6,'(6X,A)')
     &      '---------------------------'
         End If
         IEND=0
         ik=0
         ikk=0
         Do IST=1,nNuc,6
            Fact = DBLE(nStab(ist))/DBLE(nSym)
            IEND=MIN(IEND+6,nNuc)
            Write(6,*)
            Write(6,'(14X,6(14X,A,4X))')
     &         (CNAME(I),I=IST,IEND)
            Write(6,'(14X,6(A12,A12))')
     &         (' alpha','  beta',I=IST,IEND)
            Do IT=1,NXTYP
               Do J=IST,IEND
                  Q2(J)=Work(ipqSwap+NNUC+ik)
                  ik=ik+1
               End Do
               If (FullMlk) then
                  Write(6,'(5X,A8,12F12.4)')Clean_BName(TNAME(IT),0),
     &                 (Fac(j)*Q2(J),Fac(j)*QQ(IT,J), J=IST,IEND)
               End If
            End Do
*
            Do J=IST,IEND
               Q2(J)=Work(ipqSwap+ikk)
               ikk=ikk+1
            End Do
*
            Write(6,'(6X,A,12F12.4)')'Total  ',
     &         (Fac(i)*Q2(I),Fac(i)*QSUM(I),I=IST,IEND)
            Write(6,'(6X,A,6(6X,F12.4,6X))')'Total  ',
     &         (Fac(i)*(Q2(I)+QSUM(I)),I=IST,IEND)
            Write(6,*)
            Write(6,'(6X,A,6(5X,F12.4,7X))')'Charge ',
     &         (Fac(i)*Work(ip_Charge+I-1),I=IST,IEND)
         End Do
         Write(6,*)
c         Write(6,'(6X,A,F12.6)') 'Total electronic charge=',
c     &                 DDot_(nNuc,[One],0,QSum_TOT,1)
         Write(6,*)
c         Write(6,'(6X,A,F12.6)') 'Total            charge=',
c     &                 DDot_(nNuc,[One],0,Work(ip_Charge),1)
*
      End If
      If (iCase.eq.1) Then
         Call Free_Work(ip_Charge)
         Call GetMem('CHRG_SWP','FREE','REAL',ipqSwap,lqSwap)
      End If
*
      If ((iCase.eq.2.and.iPL.ge.2) .or. (iCase.eq.3.and.iPL.ge.2)) Then
c icase=2 for usual mulliken, =2 for spin population.
*
         If (FullMlk) Then
            If (iCase.eq.2) then
             Write(6,'(6X,A)')
     &   'Mulliken charges per centre and basis function type'
            else
             Write(6,'(6X,A)')
     &   'Mulliken spin population per centre and basis function type'
            end if
            Write(6,'(6X,A)')
     &         '---------------------------------------------------'
         Else
            If (iCase.eq.2) then
             Write(6,'(6X,A)')'Mulliken charges per centre'
            else
             Write(6,'(6X,A)')
     &         'Mulliken spin population per centre'
            end if
            Write(6,'(6X,A)')
     &         '---------------------------'
         End If
*
         IEND=0
         Do IST=1,nNuc,12
            Fact = DBLE(nStab(ist))/DBLE(nSym)
            IEND=MIN(IEND+12,nNuc)
            Write(6,*)
            Write(6,'(14X,12(2X,A))') (CNAME(I),I=IST,IEND)
            If (FullMlk) then
               Do IT=1,NXTYP
                  Write(6,'(5X,A8,12F8.4)')Clean_BName(TNAME(IT),0),
     &              (Fac(j)*QQ(IT,J),J=IST,IEND)
               End Do
            endIf
            Write(6,'(6X,A,12F8.4)')'Total  ',
     &             (Fac(i)*QSUM(I),I=IST,IEND)
            If (iCase.ne.3) Then
              Write(6,*)
c              Write(6,'(6X,A,12F8.4)')'N-E    ',
c     &             (Fac(i)*Work(ip_Charge+I-1),I=IST,IEND)
            End If
         End Do
         if(iCase.eq.3) then
           Write(6,*)
c           Write(6,'(6X,A,F12.6)') 'Total electronic spin=',
c     &                 DDot_(nNuc,[One],0,QSum,1)
         else
           Write(6,*)
c           Write(6,'(6X,A,F12.6)') 'Total electronic charge=',
c     &                 DDot_(nNuc,[One],0,QSum,1)
           Write(6,*)
           TCh=DDot_(nNuc,[One],0,Work(ip_Charge),1)
c           Write(6,'(6X,A,F12.6)') 'Total            charge=',
c     &                    DDot_(nNuc,[One],0,Work(ip_Charge),1)
c         Call xml_dDump('FormalCharge','Total charge','a.u',0,TCh,1,1)
         End If
      End If
      If (iCase.ge.2) Then
         Call Free_Work(ip_Charge)
      EndIf

*  Mulliken bond order print

      If (iPL.le.2) Go To 9999
      If((iCase.ge.1) .AND. (iCase.le.2) .AND. (tNUC.gt.1)
     &    .AND. (DoBond)) then
        Write(6,*)
        Write(6,'(6X,A)')
     &   'Mulliken Bond Order analysis'
        Write(6,'(6X,A)')
     &   '----------------------------'
        Write(6,'(6X,A,F5.3,A)')
     &   'Only bonds with order larger than ',BOThrs,' are printed'
        Write(6,*)
        If (nSym.gt.1) then
            Write(6,'(8X,A)')'Atom A:Gen.   Atom B:Gen.   Bond Order'
        Else
            Write(6,'(8X,A)')'Atom A        Atom B        Bond Order'
        End If
        Do I=1, tNUC-1
          Do J=I+1, tNUC
            iPair = (J-1)*(J-2)/2 + I
            BO = Work(ipBonds -1 + iPair)
            If (BO .ge. BOThrs) then
               Write(6,'(8X,2(A,4X),F7.3)')
     &          LblCnt4(I), LblCnt4(J), BO
            End If
          End Do
        End Do
        Write(6,*)
      End If

 9999 Continue
      If (DoBond) Then
         If (nSym.gt.1) then
            Call Free_Work(ipP)
            Call Free_Work(ipPInv)
            Call Free_Work(ipD_blo)
            Call Free_Work(ipS_blo)
         End If
         Call Free_iWork(ip_center)
         Call Free_Work(ipD_tmp)
         Call Free_Work(ipS_tmp)
         Call Free_Work(ipD)
         Call Free_Work(ipS)
         Call Free_Work(ipDS)
         Call Free_Work(ipBonds)
      End If
*
      Return
*
*----------------------------------------------------------------------*
*     Error Exits                                                      *
*----------------------------------------------------------------------*
*
991   Write(6,'(/6X,A)')
     &'The number of basis functions exceeds the present limit'
      Call Abend
*992   Write(6,'(/6X,A)')
*     &'The number of basis functions exceeds the present limit'
*      Call Abend
*993   Write(6,'(/6X,A)')
*     &'Warning: Total charge is not equal to number of electrons'
*      Call Abend

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine PPInt(Alpha,nAlpha,Beta, nBeta,Zeta,ZInv,rKappa,P,
     &                  Final,nZeta,nIC,nComp,la,lb,A,RB,nHer,
     &                  Array,nArr,Ccoor,nOrdOp,lOper,iChO,
     &                  iStabM,nStabM)
************************************************************************
*                                                                      *
* Object: to compute pseudo potential integrals.                       *
*                                                                      *
************************************************************************
      use Basis_Info
      use Center_Info
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
#include "oneswi.fh"
      Real*8 Final(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nIC),
     &       Zeta(nZeta), ZInv(nZeta), Alpha(nAlpha), Beta(nBeta),
     &       rKappa(nZeta), P(nZeta,3), A(3), RB(3), C(3),
     &       Array(nZeta*nArr), Ccoor(3), TC(3)
      Integer lOper(nComp), iStabM(0:nStabM-1),
     &          iDCRT(0:7), iChO(nComp)
*
      parameter(lproju=9)
      parameter (imax=100,kcrs=1)
      Real*8 ccr(imax),zcr(imax)
      Integer nkcrl(lproju+1,kcrs),nkcru(lproju+1,kcrs),lcr(kcrs),
     &        ncr(imax)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function for Cartesian index
*
      nElem(i) = (i+1)*(i+2)/2
*                                                                      *
************************************************************************
*                                                                      *
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*                                                                      *
************************************************************************
*                                                                      *
      nArray=0
      ipScr = 1
      intmax=Max(nElem(la),nElem(lb))
      intmax=intmax**2
      nArray=nArray+intmax
      ipA = ipScr + 2*intmax
      nArray=nArray+nZeta*nElem(la)*nElem(lb)
      If (nArray.gt.nZeta*nArr) Then
         Write (6,*) 'nArray.gt.nZeta*nArr'
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      kdc=-dbsc(1)%nCntr
      Do iCnttp = 1, nCnttp
         kdc = kdc + dbsc(iCnttp)%nCntr

         If (dbsc(iCnttp)%nPP.eq.0) Cycle
cAOM< Get the "true" (non SO) shells
         nPP_S=0
         do kSh = dbsc(iCnttp)%iPP,
     &            dbsc(iCnttp)%iPP + dbsc(iCnttp)%nPP-1
*           Skip if a cardholder shell
            If (Shells(kSh)%nExp.le.0) Cycle
            ncrr=Int(Shells(kSh)%Exp(1))
            if(ncrr.le.500) nPP_S=nPP_S+1
         enddo
         If (nPP_S.eq.0) Cycle
cAOM>
*
         npot = 0
         kShStr=dbsc(iCnttp)%iPP
         kShEnd = kShStr + nPP_S-1
         If (nPP_S-1.gt.lproju) Then
            Write (6,*) 'dbsc(iCnttp)%nPP-1.gt.lproju'
            Write (6,*) 'dbsc(iCnttp)%nPP=',nPP_S
            Write (6,*) 'lproju            =',lproju
            Call Abend()
         End If
         lcr(kcrs)=nPP_S-1
         iSh=0
         iOff = 1
         Do kSh = kShStr, kShEnd
            iSh = iSh + 1
            nkcrl(iSh,kcrs)=iOff
            nkcru(iSh,kcrs)=iOff+Shells(kSh)%nExp/3-1
            iOff = iOff + Shells(kSh)%nExp/3
            If (nPot.gt.imax) Then
               Write (6,*)' Pseudo: nPot.gt.imax'
               Write (6,*)'         nPot=',nPot
               Write (6,*)'         imax=',imax
               Call Abend()
            End If
            iStrt=1
            Do iExp = 1, Shells(kSh)%nExp/3
               npot = npot + 1
               ncr(npot)=Int(Shells(kSh)%Exp(iStrt  ))
               zcr(npot)=    Shells(kSh)%Exp(iStrt+1)
               ccr(npot)=    Shells(kSh)%Exp(iStrt+2)
               iStrt=iStrt+3
            End Do
         End Do
C        Write (*,*) 'ncr',(ncr(i),i=1,npot)
C        Write (*,*) 'zcr',(zcr(i),i=1,npot)
C        Write (*,*) 'ccr',(ccr(i),i=1,npot)
C        Write (*,*) 'nkcrl',(nkcrl(i,1),i=1,iSh)
C        Write (*,*) 'nkcru',(nkcru(i,1),i=1,iSh)
*
         Do iCntr = 1, dbsc(iCnttp)%nCntr
            C(1:3) = dbsc(iCnttp)%Coor(1:3,iCntr)
*
*
*-----------Find the DCR for M and S
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+iCntr)%iStab ,dc(kdc+iCntr)%nStab,
     &               iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
            Do lDCRT = 0, nDCRT-1
               Call OA(iDCRT(lDCRT),C,TC)
*                                                                      *
************************************************************************
*                                                                      *
               iZeta = 0
               Do iBeta = 1, nBeta
                  Do iAlpha = 1, nAlpha
                     iZeta = iZeta + 1
                     Call FZero(Array(ipScr),intmax)
                     Call Pseudo(Alpha(iAlpha),A(1),A(2),A(3),la+1,
     &                           Beta(iBeta),RB(1),RB(2),RB(3),lb+1,
     &                           Array(ipScr),intmax,Max(la+1,lb+1),
     &                           ccr,zcr,nkcrl,nkcru,lcr,ncr,
     &                           TC(1),TC(2),TC(3),npot)
*
                     Do iB = 1, nElem(lb)
                        Do iA = 1, nElem(la)
                           iAB = (iB-1)*nElem(la)+iA
                           iOff2 = (iB-1)*nElem(la)*nZeta
     &                           + (iA-1)*nZeta + iZeta + ipA - 1
                           Array(iOff2) = Array(iAB+ipScr-1)
                        End Do  ! iA
                     End Do     ! iB
*
                  End Do        ! iAlpha
               End Do           ! iBeta
*                                                                      *
************************************************************************
*                                                                      *
*              Symmetry Adapt
*
               nOp = NrOpr(iDCRT(lDCRT))
               Call SymAdO(Array(ipA),nZeta,la,lb,nComp,Final,nIC,
     &                     nOp,lOper,iChO,Fact)
            End Do        ! lDCRT
*                                                                      *
************************************************************************
*                                                                      *
         End Do           ! iCntr
      End Do              ! iCnttp
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Zeta)
         Call Unused_real_array(ZInv)
         Call Unused_real_array(rKappa)
         Call Unused_real_array(P)
         Call Unused_integer(nHer)
         Call Unused_real_array(Ccoor)
         Call Unused_integer(nOrdOp)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION NEWPRTTAB(NSYM,NFRO,NISH,NRAS1,NRAS2,NRAS3,
     &                           NSSH,NDEL)
      IMPLICIT NONE
      INTEGER LPART
      INTEGER NSYM,NFRO,NISH,NRAS1,NRAS2,NRAS3,NSSH,NDEL
      INTEGER NSIZE,ITYPE,NPART,ISYM,IPART,ISUM
      DIMENSION NFRO(NSYM),NISH(NSYM),NRAS1(NSYM),NRAS2(NSYM)
      DIMENSION NRAS3(NSYM),NSSH(NSYM),NDEL(NSYM)
#include "WrkSpc.fh"
C     INTEGER I

C Executable statements
      NPART=7
      NSIZE=4+(NSYM+1)*(NPART+1)
      ITYPE=93
      CALL GETMEM('PrtTab','Allo','Inte',LPART,NSIZE)
      IWORK(LPART+0)=NSIZE
      IWORK(LPART+1)=ITYPE
      IWORK(LPART+2)=NPART
      IWORK(LPART+3)=NSYM
      DO ISYM=1,NSYM
        IWORK(LPART+4+ISYM+(NSYM+1)*1)=NRAS1(ISYM)
        IWORK(LPART+4+ISYM+(NSYM+1)*2)=NRAS2(ISYM)
        IWORK(LPART+4+ISYM+(NSYM+1)*3)=NRAS3(ISYM)
        IWORK(LPART+4+ISYM+(NSYM+1)*4)=NISH(ISYM)
        IWORK(LPART+4+ISYM+(NSYM+1)*5)=NSSH(ISYM)
        IWORK(LPART+4+ISYM+(NSYM+1)*6)=NFRO(ISYM)
        IWORK(LPART+4+ISYM+(NSYM+1)*7)=NDEL(ISYM)
        ISUM=0
        IPART=1
10       CONTINUE
          ISUM=ISUM+IWORK(LPART+4+ISYM+(NSYM+1)*IPART)
         IPART=IPART+1
         IF(IPART.le.7) GO TO 10
c
c VV: original code was unrolled uncorrectly by GCC 3.0.4
c        DO IPART=1,7
c          ISUM=ISUM+IWORK(LPART+4+ISYM+(NSYM+1)*IPART)
c        END DO
c
        IWORK(LPART+4+ISYM+(NSYM+1)*0)=ISUM
      END DO
      DO IPART=0,7
        ISUM=0
        DO ISYM=1,NSYM
          ISUM=ISUM+IWORK(LPART+4+ISYM+(NSYM+1)*IPART)
        END DO
        IWORK(LPART+4+(NSYM+1)*IPART)=ISUM
      END DO
      NEWPRTTAB=LPART
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine InitB(nMult,natom,nAtQM,nGrdPt,Cord,Grid,T,TT,TTT,Ext,B,IsMM)
! Compute the electrostatic tensor matrix between QM atoms and grid points
! Then form the B = ExtPot[TtT^-1]Tt vector

use espf_global, only: MxExtPotComp
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nMult, natom, nAtQM, nGrdPt, IsMM(natom)
real(kind=wp), intent(in) :: Cord(3,natom), Grid(3,nGrdPt), Ext(MxExtPotComp,natom)
real(kind=wp), intent(out) :: T(nMult,nGrdPt), TT(nMult,nMult), TTT(nGrdPt,nMult), B(nGrdPt)
integer(kind=iwp) :: iMlt, iPL, iPnt, iQM, jAt, jMlt, jPnt, kMlt, kPnt, nOrd
real(kind=wp) :: Det, R, R3, X, Y, Z
real(kind=wp), allocatable :: Scr(:,:)
integer(kind=iwp), external :: iPL_espf

iPL = iPL_espf()
nOrd = nMult/nAtQM

! T

do iPnt=1,nGrdPt
  iQM = 0
  do jAt=1,natom
    if (IsMM(jAt) == 1) cycle
    iQM = iQM+1
    X = Grid(1,iPnt)-Cord(1,jAt)
    Y = Grid(2,iPnt)-Cord(2,jAt)
    Z = Grid(3,iPnt)-Cord(3,jAt)
    R = sqrt(X*X+Y*Y+Z*Z)
    T(nOrd*(iQM-1)+1,iPnt) = One/R
    if (nOrd > 1) then
      R3 = R*R*R
      T(nOrd*(iQM-1)+2,iPnt) = X/R3
      T(nOrd*(iQM-1)+3,iPnt) = Y/R3
      T(nOrd*(iQM-1)+4,iPnt) = Z/R3
    end if
  end do
end do
if (iQM /= nAtQM) then
  write(u6,'(A,I4,A4,I4)') ' Error in espf/initb: iQM != nAtQM ',iQM,' != ',nAtQM
  call Abend()
end if

!call RecPrt('T',' ',T,nMult,nGrdPt)
!nMax = Max(nGrdPt,nMult)
!call mma_allocate(U,nMult,nMax,label='U')
!call mma_allocate(W,nMult,label='W')
!call mma_allocate(V,nMult,nMax,label='V')
!call mma_allocate(Scr,nMult,1,label='Scr')
!call SVD(nMax,nGrdPt,nMult,T,W,.true.,U,.true.,V,iErr,Scr)
!write(u6,*) 'iErr=',iErr
!call RecPrt('U',' ',U,nMult,nMax)
!call RecPrt('w',' ',W,nMult,1)
!call RecPrt('V',' ',V,nMult,nMax)
!call mma_deallocate(U)
!call mma_deallocate(W)
!call mma_deallocate(V)
!call mma_deallocate(Scr)

! TtT

TT(:,:) = Zero
do iMlt=1,nMult
  do jMlt=1,nMult
    do kPnt=1,nGrdPt
      TT(jMlt,iMlt) = TT(jMlt,iMlt)+T(iMlt,kPnt)*T(jMlt,kPnt)
    end do
  end do
end do

! TtT^-1

call mma_allocate(Scr,nMult,nMult,label='Scr')
call minv(TT,Scr,Det,nMult)
TT(:,:) = Scr
call mma_deallocate(Scr)

! [TtT^-1]Tt

TTT(:,:) = Zero
do iMlt=1,nMult
  do jPnt=1,nGrdPt
    do kMlt=1,nMult
      TTT(jPnt,iMlt) = TTT(jPnt,iMlt)+TT(kMlt,iMlt)*T(kMlt,jPnt)
    end do
  end do
end do
if (iPL >= 4) call RecPrt('(TtT)^(-1)Tt matrix in InitB',' ',TTT,nGrdPt,nMult)

! B = ExtPot[TtT^-1]Tt

B(:) = Zero
do iPnt=1,nGrdPt
  iQM = 0
  do jAt=1,natom
    if (IsMM(jAt) == 1) cycle
    iQM = iQM+1
    B(iPnt) = B(iPnt)+Ext(1,jAt)*TTT(iPnt,nOrd*(iQM-1)+1)
#   include "compiler_features.h"
#   ifdef _BUGGY_INTEL_LLVM_
    ! dummy statement to work around compiler bug, will never be executed
    if (nOrd < 0) B(iPnt) = -B(iPnt)
#   endif
    if (nOrd > 1) &
      B(iPnt) = B(iPnt)+Ext(2,jAt)*TTT(iPnt,nOrd*(iQM-1)+2)+Ext(3,jAt)*TTT(iPnt,nOrd*(iQM-1)+3)+Ext(4,jAt)*TTT(iPnt,nOrd*(iQM-1)+4)
  end do
end do
if (iPL >= 4) then
  write(u6,'(A)') ' In InitB (grid coordinates, B value)'
  do iPnt=1,nGrdPt
    write(u6,1234) iPnt,Grid(:,iPnt),B(iPnt)
  end do
end if

return

1234 format(I4,4F12.6)

end subroutine InitB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Primo_RasScf(VecTit,Ene,Occ,CMO)
************************************************************************
* purpose:
* Print MO-coefficients
*
************************************************************************

      Implicit Real*8 (A-H,O-Z)

      Character*(*) VecTit
      Dimension     CMO(*),Occ(*),Ene(*)

#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
#include "rasscf.fh"
#include "WrkSpc.fh"

      DIMENSION NSLCT(8)
      Logical   PrOcc,PrEne
      Character*3 lIrrep(8)

      Character*8 Fmt1,Fmt2
      Character*132 Line,Blank
      Character*(LENIN8) Clean_BName
      External Clean_BName
* PAM Nov 05: Non-valence orbitals
      Dimension NVSH(8)

      Call Get_cArray('Irreps',lIrrep,24)

* set print format
      nCols=10
      lLine=120
      lPaper=132
      left=(lPaper-lLine)/2
      Write(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
      Blank = ' '
* PAM Krapperup Nov 05: For the moment, selection of orbitals to be
* printed is ultimately determined here on the basis of PRETHR (and
* PROTHR) thresholds. These have either been set by the user, or
* determined in the CHKINP subroutine, possibly then on basis of
* user specification of OutFmt1 flags.
* Exception: OutFmt2='NOCORE  ' will inhibit printing of non-valece orbs.


* PAM Nov 09: Output marked as collapsible.
* print header
      Write(LF,*)
      Call CollapseOutput(1,'   Molecular orbitals:')
      Write(LF,'(6X,A)') '-------------------'
      Write(LF,*)
      Write(LF,Fmt2//'A)') trim(VecTit)
      Write(LF,*)

* Flag ipt2 in common in src/Include/rasscf.fh
*   ipt2=0 means usual MO's, quasicanonical for
* inactives and virtuals, natural for active.
*   ipt2=1 means quasicanonical for actives also.
* PAM Apr 05: The rules for selecting orbitals for print
* appear a bit confused. I just follow the rules for now:
      If ( iPT2.eq.0 ) then
        PrOcc  = .true.
        PrEne  = .true.
      Else
        PrOcc  = .false.
        PrEne  = .true.
      End if

* Select orbitals to be printed.
* By default at least all occupied are printed.
* If iPT2==0 all orbitals with energy less than PrEThr
* and occupation bigger then PrOThr are also printed.
* If iPT2==1 all orbitals with occupations greater than
* PrOThr are also printed.

* Nr of orbitals=nr of basis functions
      NBTOT=0
      DO ISYM=1,NSYM
       NBTOT=NBTOT+NBAS(ISYM)
      END DO
*
* Put rasscf orbital energies on the runfile
      Call Put_darray('RASSCF OrbE',ENE,NBTOT)
*
* Initialize MARKIT.
      CALL GETMEM('MARKIT','ALLO','INTE',LMRKIT,NBTOT)
      IORB=0
      DO ISYM=1,NSYM
       NB=NBAS(ISYM)
       DO I=1,NB
        IORB=IORB+1
        IWORK(LMRKIT-1+IORB)=0
       END DO
      END DO
      IF (OutFmt2.ne.'NOCORE  ') THEN
* Mark MARKIT as selected for occupied orbitals.
       IORB=0
       DO ISYM=1,NSYM
        NFIA=NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
        DO I=1,NFIA
         IORB=IORB+1
         IWORK(LMRKIT-1+IORB)=1
        END DO
        IORB=IORB+NBAS(ISYM)-NFIA
       END DO
      ELSE
* Mark MARKIT as selected for valence or active orbitals.
       IORB=0
       Call Get_iArray('Non valence orbitals',NVSH,nSym)
       DO ISYM=1,NSYM
        NFIA=NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
        NSKIP=MIN(NFRO(ISYM)+NISH(ISYM),NVSH(ISYM))
        IORB=IORB+NSKIP
        DO I=NSKIP+1,NFIA
         IORB=IORB+1
         IWORK(LMRKIT-1+IORB)=1
        END DO
        IORB=IORB+NBAS(ISYM)-NFIA
       END DO
      END IF
* If PROCC, then only those orbitals that have occ no larger
* than or equal to PrOThr:
      IF (PROCC.and. PrOThr.ge.0.0D0) THEN
       IORB=0
       DO ISYM=1,NSYM
        NFIA=NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
        DO I=1,NFIA
         IORB=IORB+1
         IF(OCC(IORB).lt.PROTHR) IWORK(LMRKIT-1+IORB)=0
        END DO
        IORB=IORB+NBAS(ISYM)-NFIA
       END DO
      END IF
* But if PRENE, then also those orbitals that have energy less
* than or equal to PrEThr, skipping deleted orbitals of course.
      IF (PRENE) THEN
       IORB=0
       DO ISYM=1,NSYM
        NFIA=NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
        IORB=IORB+NFIA
        ND=NDEL(ISYM)
        DO I=NFIA+1,NBAS(ISYM)-ND
         IORB=IORB+1
         IF(ENE(IORB).le.PRETHR) IWORK(LMRKIT-1+IORB)=1
        END DO
        IORB=IORB+ND
       END DO
      END IF
* Let ISELECT enumerate the orbitals to be printed, rather than
* just marking them:
      NSLCTT=0
      NO=0
      DO ISYM=1,NSYM
       NS=0
       NB=NBAS(ISYM)
       DO IO=NO+1,NO+NB
         IF(IWORK(LMRKIT-1+IO).EQ.1) NS=NS+1
       END DO
       NO=NO+NB
       NSLCT(ISYM)=NS
       NSLCTT=NSLCTT+NS
      END DO
      CALL GETMEM('SELECT','ALLO','INTE',LSLCT,NSLCTT)
      IS=0
      NO=0
      DO ISYM=1,NSYM
       NB=NBAS(ISYM)
       DO IO=NO+1,NO+NB
        IF(IWORK(LMRKIT-1+IO).EQ.1) THEN
          IS=IS+1
          IWORK(LSLCT-1+IS)=IO
        END IF
       END DO
       NO=NO+NB
      END DO
* Get rid of MARKIT.
      CALL GETMEM('MARKIT','FREE','INTE',LMRKIT,NBTOT)

* finally, print, the MOs
      If ( OutFmt2.eq.'FULL    ' ) then

* print orbitals, using default format.
        ISOFF=0
        IBOFF=0
        ICOFF=0
        DO ISYM=1,NSYM
         NB=NBAS(ISYM)
         NS=NSLCT(ISYM)
         IF(NS.GT.0) THEN
          Write(LF,*)
          Write(LF,*)
          Write(LF,*)
          Write(LF,Fmt2//'A,I2,A,A)')
     &           'Molecular orbitals for symmetry species',iSym,
     &           ': ',lIrrep(iSym)
          DO ISSTART=1,NS,NCOLS
           ISEND=MIN(ISSTART+NCOLS-1,NS)
           Write(LF,*)
           Write(LF,*)
           Write(LF,Fmt2//'A,7X,10I10)')'Orbital ',
     &               (IWORK(LSLCT-1+ISOFF+I)-IBOFF,I=ISSTART,ISEND)
           IF (PRENE) THEN
             Write(LF,Fmt2//'A,7X,10F10.4)')'Energy  ',
     &               (ENE(IWORK(LSLCT-1+ISOFF+I)),I=ISSTART,ISEND)
           END IF
           IF (PROCC) THEN
             Write(LF,Fmt2//'A,7X,10F10.4)')'Occ. No.',
     &               (OCC(IWORK(LSLCT-1+ISOFF+I)),I=ISSTART,ISEND)
           END IF
           Write(LF,*)
           DO IB=1,NB
            Write(LF,'(2X,I4,1X,A,10F10.4)') IB,
     &        Clean_BName(NAME(IBOFF+IB),LENIN),
     &        (CMO(ICOFF+(IWORK(LSLCT-1+ISOFF+I)-1-IBOFF)*NB+IB),
     &        I=ISSTART,ISEND)
           END DO
          END DO
         END IF
         ISOFF=ISOFF+NS
         IBOFF=IBOFF+NB
         ICOFF=ICOFF+NB**2
        END DO

      Else If ( OutFmt2.eq.'COMPACT ' ) then

* print orbitals, using compact format.

        ISOFF=0
        IBOFF=0
        ICOFF=0
        DO ISYM=1,NSYM
          NB=NBAS(ISYM)
          IF ( NSLCT(ISYM).NE.0 ) THEN
            Write(LF,*)
            Write(LF,FMT2//'A,I2,A,A)')
     &           'MOLECULAR ORBITALS FOR SYMMETRY SPECIES',ISYM,
     &           ': ',LIRREP(ISYM)
            Write(LF,*)
            IF ( PROCC.AND.PRENE ) THEN
              Write(LF,FMT2//'A)')
     &          'INDEX  ENERGY  OCCUPATION COEFFICIENTS ...'
            ELSE IF ( PROCC ) THEN
              Write(LF,FMT2//'A)')
     &          'INDEX  ENERGY  COEFFICIENTS ...'
            ELSE IF ( PRENE ) THEN
              Write(LF,FMT2//'A)')
     &          'INDEX  OCCUPATION  COEFFICIENTS ...'
            ELSE
              Write(LF,FMT2//'A)')
     &          'INDEX  COEFFICIENTS ...'
            END IF
            DO IS = 1,NSLCT(ISYM)
              IORB=IWORK(LSLCT-1+ISOFF+IS)
              ICOL=IORB-IBOFF
              LINE = BLANK
              IST = 1
              Write(LINE(IST:132),'(I5)') ICOL
              IST = IST+5
              IF ( PRENE ) THEN
                Write(LINE(IST:132),'(F10.4)') ENE(IORB)
                 IST = IST+10
              END IF
              IF ( PROCC ) THEN
                Write(LINE(IST:132),'(F10.4)') OCC(IORB)
                IST = IST+10
              END IF
              Write(LF,FMT2//'A)') LINE
              LINE = BLANK
              IST = 9
              DO IBAS = 1,NB
                CC = CMO(ICOFF+(ICOL-1)*NB+IBAS)
                IF ( ABS(CC).GE.0.1D0 ) THEN
                  Write(LINE(IST:132),'(I4,1X,A,A,F7.4,A)')
     &              IBAS,Clean_BName(NAME(IBOFF+IBAS),LENIN),
     &              '(',CC,')'
                  IST = IST+28
                  IF ( IST.GT.(132-LEFT-28) ) THEN
                    Write(LF,FMT2//'A)') TRIM(LINE)
                    LINE = BLANK
                    IST = 9
                  END IF
                END IF
              END DO
              Write(LF,FMT2//'A)') TRIM(LINE)
              LINE = BLANK
              IST = 9
            END DO
          END IF
          ISOFF=ISOFF+NSLCT(ISYM)
          IBOFF=IBOFF+NB
          ICOFF=ICOFF+NB**2
        END DO

      End If

      CALL GETMEM('SELECT','FREE','INTE',LSLCT,NSLCTT)
* PAM 09: Reset to non-collapsible output before return.
      Call CollapseOutput(0,'   Molecular orbitals:')
      Write(6,*)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Drvel1(Grad)
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      Logical TF,tstfnc
      Real*8 Grad(*)
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)
      idisp=0
      do jIrrep=0,nirrep-1
       Do Jcar=1,3
        iirrep=irrfnc(2**(jcar-1))
        If (jirrep.eq.iirrep) Then
         mdc=0
         Do  iCnttp = 1, nCnttp
          ZA = dbsc(iCnttp)%Charge
          Do  iCnt = 1, dbsc(iCnttp)%nCntr
           mdc=mdc+1
           Do iCar=1,3
            iComp = 2**(iCar-1)
            If ( TF(mdc,jIrrep,iComp)) Then
              idisp=idisp+1
              If (icar.eq.jcar) Grad(idisp)=ZA
            End If
           End Do
          End Do
         End Do
        End If
       End Do
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Valera Veryazov                                  *
!***********************************************************************

subroutine XMatReader(iZMUnit,LuWr,nAtoms,nXAtoms,nBasis,nAskAtoms,nxbas,xb_label,xb_bas,iErr)
! nAtoms : Total number of real atoms. Include X dummy atoms: NAT(i)= 0
! nXAtoms: Total number of ghost (Z) atoms:                   NAT(i)=-1
! nBasis : Nummer of atom types requiring Basis Set
!  ***  nAskAtoms == -1  =>  Seward ZMAT input  => Use "End of"
!  ***  nAskAtoms /= -1  =>  GateWay ZMAT input => Use nAskAtoms

use ZMatConv_Mod, only: BasReq, NAT, Symbols, Zmat
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iZMUnit, LuWr, nAskAtoms
integer(kind=iwp), intent(out) :: nAtoms, nXAtoms, nBasis, nxbas, iErr
character(len=*), intent(inout) :: xb_label(*), xb_bas(*)
integer(kind=iwp) :: i, istatus, iXU, NA, NAtom, Nwords
logical(kind=iwp) :: IreadHere, Skip
real(kind=wp) :: Dist
character(len=80) :: Line
character(len=24) :: Words(7)
character(len=3) :: Command
integer(kind=iwp), external :: isFreeUnit

xb_label(1) = ' '
xb_bas(1) = ' '
nxbas = 1

iErr = 0
nAtoms = 0
nXAtoms = 0
nBasis = 0

! Read Line (or COMMAND)
Skip = .false.
do
  if ((nAtoms+nXAtoms) == nAskAtoms) then
    Skip = .true.
    exit
  end if
  read(iZMUnit,'(A)',iostat=istatus) Line
  if (istatus > 0) call error()
  if (istatus /= 0) return
  if (Line(1:1) /= '*') exit
end do
if (Line == ' ') Skip = .true.
Command = Line(1:3)
call UpCase(Command)
if (Command == 'END') Skip = .true.
if (.not. Skip) then
  NA = 0
  Dist = Zero

  ! Here we read number or a file.
  read(Line,*,iostat=istatus) NA
  if (istatus == 0) then
    IreadHere = .true.
  else
    IreadHere = .false.
    iXU = isFreeUnit(iZMUnit+1)
    call molcas_open(iXU,line)
    read(iXU,*) NA
  end if
  if (IreadHere) then
    read(iZMUnit,'(A)',iostat=istatus) Line
  else
    read(iXU,'(A)',iostat=istatus) Line
  end if
  if (istatus > 0) call error()
  if (istatus /= 0) return
  do i=1,NA
    if (IreadHere) then
      read(iZMUnit,'(A)',iostat=istatus) Line
    else
      read(iXU,'(A)',iostat=istatus) Line
    end if
    if (istatus > 0) call error()
    if (istatus /= 0) return
    call Pick_Words(Line,4,Nwords,Words)
    if (Nwords < 4) then
      iErr = 1
      write(LuWr,*) ' [XMatReader]: X-Matrix incomplete in line'
      write(LuWr,*) '               ',Line
      return
    end if
    call FoundAtomicNumber(LuWr,Words(1),NAtom,iErr)
    if (iErr /= 0) then
      iErr = 1
      write(LuWr,*) ' [XMatReader]: Error in line'
      write(LuWr,*) '               ',Line
      return
    end if
    if (NAtom >= 0) nAtoms = nAtoms+1
    if (NAtom == -1) nXAtoms = nXAtoms+1
    if (nAtoms+nXAtoms > size(NAT)) then
      iErr = 1
      write(LuWr,*) ' [XMatReader]: Too many atoms'
      write(LuWr,*) '               ',Line
      return
    end if
    NAT(nAtoms+nXAtoms) = NAtom
    Symbols(nAtoms+nXAtoms) = trim(Words(1))
    if (NAtom > 0) BasReq(NAtom) = .true.

    call Get_dNumber(Words(2),Dist,iErr)
    Zmat(1,nAtoms+nXAtoms) = Dist
    call Get_dNumber(Words(3),Dist,iErr)
    Zmat(2,nAtoms+nXAtoms) = Dist
    call Get_dNumber(Words(4),Dist,iErr)
    Zmat(3,nAtoms+nXAtoms) = Dist

  end do
  if (.not. IreadHere) close(iXU)
end if
! Pre-check Basis Set consistency  BasReq: Atom requiring Basis Set
nBasis = 0
do i=1,size(BasReq)
  if (BasReq(i)) nBasis = nBasis+1
end do

return

contains

subroutine error()
  iErr = 1
  write(LuWr,*) ' [XMatReader]: Unable to read x-matrix file !'
end subroutine error

end subroutine XMatReader

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!               2004, Takashi Tsuchiya                                 *
!***********************************************************************

subroutine AOEval(iAng,nCoor,Coor,xyz,RA,Transf,CffSph,nElem,nCmp,Angular,nTerm,nForm,Thr_Rad,nRad,mExp,nExp,Alpha,Radial,nBas, &
                  CffCnt,AOValue,mAO,px,py,pz,ipx,ipy,ipz)
!***********************************************************************
! Object: to compute the values of the AOs on a grid. The calculation  *
!         is sectioned in an angular part and a radial part. Due to the*
!         gradients we have 3 angular parts and 2 radial part.         *
!                                                                      *
!      Author:Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN. November '95                            *
!      Modified by: Takashi Tsuchiya, Dept. of Theoretical Chemistry,  *
!                   University of Lund, SWEDEN. February 2004          *
!***********************************************************************

use Index_Functions, only: C_Ind3, nTri_Elem1
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iAng, nCoor, nElem, nCmp, nTerm, nForm, nRad, mExp, nExp, nBas, mAO, ipx, ipy, ipz
real(kind=wp), intent(in) :: Coor(3,nCoor), RA(3), CffSph(nElem,nCmp), Thr_Rad, Alpha(nExp), CffCnt(mExp,nBas), px, py, pz
real(kind=wp), intent(out) :: xyz(nCoor,3,0:iAng+nRad-1), Radial(nCoor,nRad,nBas), AOValue(mAO,nCoor,nBas,nCmp)
logical(kind=iwp), intent(in) :: Transf
integer(kind=iwp), intent(out) :: Angular(nTerm,5,nForm)
integer(kind=iwp) :: iX, iY, iZ, nDrv, iExp, iCoor, iBas, iDrv, i, i_f, ip, jDrv, jX, jY, jZ, jF, kDrv, iCmp, kForm, mForm, mTerm, &
                     iTerm, iCoef, iRad, iForm
real(kind=wp) :: Cff, Coef, R2, ThrE, Tmp
#ifdef _DEBUGPRINT_
character(len=80) :: Label
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
!     Index for derivatives in AOValue
!
!     mAO =   1:    F
!             2:   dFdx
!             3:   dFdy
!             4:   dFdz
!             5:  d2Fdxdx
!             6:  d2Fdxdy
!             7:  d2Fdxdz
!             8:  d2Fdydy
!             9:  d2Fdydz
!            10:  d2Fdzdz
!            11:  d3Fdxdxdx
!            12:  d3Fdxdxdy
!            13:  d3Fdxdxdz
!            14:  d3Fdxdydy
!            15:  d3Fdxdydz
!            16:  d3Fdxdzdz
!            17:  d3Fdydydy
!            18:  d3Fdydydz
!            19:  d3Fdydzdz
!            20:  d3Fdzdzdz
!            ... and so on;
!                in the same order for the higher order derivatives.
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) '********** AOEval ***********'
write(u6,*) 'In AOEval'
call RecPrt('Coor',' ',Coor,3,nCoor)
call RecPrt('CffCnt',' ',CffCnt,mExp,nBas)
call RecPrt('CffSph',' ',CffSph,nElem,nCmp)
write(u6,*) 'RA=',RA
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize AOValue

AOValue(:,:,:,:) = Zero

!--- Set the order of derivation

nDrv = nRad-1
!write(u6,*) '----- nDrv = ', nDrv
!                                                                      *
!***********************************************************************
!                                                                      *
! Evaluate the radial part
!    Normal radial part and
!    premultiplied with (minus two times the exponent)**iDrv

#ifdef _DEBUGPRINT_
if ((nRad <= 0) .and. (nRad >= 5)) then
  write(u6,*) 'AOEval: illegal value of nRad!'
  call Abend()
end if
#endif

Thre = -99.0_wp
if (Thr_Rad > Zero) Thre = log(Thr_Rad)
Radial(:,:,:) = Zero
do iCoor=1,nCoor
  R2 = (Coor(1,iCoor)-RA(1))**2+(Coor(2,iCoor)-RA(2))**2+(Coor(3,iCoor)-RA(3))**2
  do iExp=1,nExp
    if (-Alpha(iExp)*R2 < Thre) exit
    Tmp = exp(-Alpha(iExp)*R2)
    Radial(iCoor,1,:) = Radial(iCoor,1,:)+CffCnt(iExp,:)*Tmp
    do iDrv=1,nDrv
      Tmp = -Two*Alpha(iExp)*Tmp
      Radial(iCoor,iDrv+1,:) = Radial(iCoor,iDrv+1,:)+CffCnt(iExp,:)*Tmp
    end do
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) mExp,nExp
write(Label,'(A)') 'Radial(nCoor*nRad,nBas)'
call RecPrt(Label,'(10G20.10)',Radial,nCoor*nRad,nBas)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Evaluate the angular part

if (iAng+nRad-1 >= 1) then
  xyz(:,:,0) = One
  xyz(:,1,1) = px*(Coor(1,:)-RA(1))
  xyz(:,2,1) = py*(Coor(2,:)-RA(2))
  xyz(:,3,1) = pz*(Coor(3,:)-RA(3))
  do i=2,iAng+nRad-1
    xyz(:,:,i) = xyz(:,:,i-1)*xyz(:,:,1)
  end do
else
  xyz(:,:,0) = One
end if
#ifdef _DEBUGPRINT_
do i=0,iAng+nRad-1
  write(Label,'(A,I2,A)') 'xyz(nCoor,nCar,',i,')'
  call RecPrt(Label,'(3ES13.6)',xyz(1,1,i),nCoor,3)
end do
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Calculate the angular components of the derivatives

Angular(:,:,:) = 0

do ix=iAng,0,-1

  do iy=iAng-ix,0,-1
    iz = iAng-ix-iy
    ip = C_Ind3(ix,iy,iz)

    ! Initial values for 0th-order derivative

    Angular(1,1,1) = ix
    Angular(1,2,1) = iy
    Angular(1,3,1) = iz
    Angular(1,4,1) = 0
    Angular(1,5,1) = 1

    ! Calculate derivatives of the angular components

    ! jf: Formula to be derivated
    ! i_f: New formula by way of derivation

    i_f = 1
    !call PrntA(nterm,nform,Angular,i_f,0)
    do jDrv=0,nDrv-1
      do jx=jDrv,0,-1
        do jy=jDrv-jx,0,-1
          jz = jDrv-jx-jy
          jf = C_Ind3(jx,jy,jz)

          do kDrv=0,jDrv-1
            jf = jf+nTri_Elem1(kDrv)
          end do

#         ifdef _DEBUGPRINT_
          write(u6,*) ' jx,jy,jz,jf=',jx,jy,jz,jf
#         endif

          if ((jy == 0) .and. (jz == 0)) then
            i_f = i_f+1
            call dFdxyz(nTerm,nForm,Angular,jf,i_f,1,ipx,jDrv)
            !call PrntA(nterm,nform,Angular,i_f,jdrv+1)
            i_f = i_f+1
            call dFdxyz(nTerm,nForm,Angular,jf,i_f,2,ipy,jDrv)
            !call PrntA(nterm,nform,Angular,i_f,jdrv+1)
            i_f = i_f+1
            call dFdxyz(nTerm,nForm,Angular,jf,i_f,3,ipz,jDrv)
            !call PrntA(nterm,nform,Angular,i_f,jdrv+1)
          else if (jz == 0) then
            i_f = i_f+1
            call dFdxyz(nTerm,nForm,Angular,jf,i_f,2,ipy,jDrv)
            !call PrntA(nterm,nform,Angular,i_f,jdrv+1)
            i_f = i_f+1
            call dFdxyz(nTerm,nForm,Angular,jf,i_f,3,ipz,jDrv)
            !call PrntA(nterm,nform,Angular,i_f,jdrv+1)
          else
            i_f = i_f+1
            call dFdxyz(nTerm,nForm,Angular,jf,i_f,3,ipz,jDrv)
            !call PrntA(nterm,nform,Angular,i_f,jdrv+1)
          end if
        end do
      end do
    end do

    ! Distribute contributions to the real spherical harmonics
    !            and combine with angular part
    !       to yield the values and the gradients

    if (Transf) then
      do iCmp=1,nCmp
        Cff = CffSph(ip,iCmp)
        if (Cff /= Zero) then
          kForm = 0
          do iDrv=0,nDrv
            mForm = nTri_Elem1(iDrv)
            do iForm=kForm+1,kForm+mForm
              mTerm = 2**(iDrv)
              do iTerm=1,mTerm
                iCoef = Angular(iTerm,5,iForm)
                if (iCoef /= 0) then
                  Coef = real(iCoef,kind=wp)
                  iRad = Angular(iTerm,4,iForm)+1
                  do iBas=1,nBas
                    AOValue(iForm,:,iBas,iCmp) = AOValue(iForm,:,iBas,iCmp)+xyz(:,1,Angular(iTerm,1,iForm))* &
                                                 xyz(:,2,Angular(iTerm,2,iForm))*xyz(:,3,Angular(iTerm,3,iForm))* &
                                                 Coef*Cff*Radial(:,iRad,iBas)
                  end do
                end if
              end do
            end do
            kForm = kForm+mForm
          end do
        end if
      end do
    else
      kForm = 0
      do iDrv=0,nDrv
        mForm = nTri_Elem1(iDrv)
        do iForm=kForm+1,kForm+mForm
          mTerm = 2**(iDrv)
          do iTerm=1,mTerm
            iCoef = Angular(iTerm,5,iForm)
            if (iCoef /= 0) then
              Coef = real(iCoef,kind=wp)
              iRad = Angular(iTerm,4,iForm)+1
              do iBas=1,nBas
                AOValue(iForm,:,iBas,ip) = AOValue(iForm,:,iBas,ip)+xyz(:,1,Angular(iTerm,1,iForm))* &
                                           xyz(:,2,Angular(iTerm,2,iForm))*xyz(:,3,Angular(iTerm,3,iForm))* &
                                           Coef*Radial(:,iRad,iBas)
              end do
            end if
          end do
        end do
        kForm = kForm+mForm
      end do
    end if

  end do

end do
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
write(u6,*) 'mAO,nCoor,nBas,nCmp',mAO,nCoor,nBas,nCmp
call RecPrt('AOValue','(10G20.10)',AOValue,mAO,nCoor*nBas*nCmp)
#endif

end subroutine AOEval

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrtCav(IOut,ITyp,NS,NOrd,Alpha,Rad)
! Print out sphere radii for Pauling or input cavitites

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IOut, ITyp, NS, NOrd(NS)
real(kind=wp) :: Alpha, Rad(NS)
integer(kind=iwp) :: IS

write(iOut,*)
write(iOut,*)
write(iOut,'(6X,A)') 'Polarized Continuum Model Cavity'
write(iOut,'(6X,A)') '================================'
if (ITyp == 2) write(iOut,'(6X,A)') 'Pauling radii'
if (ITyp == 3) write(iOut,'(6X,A)') 'Sphere radii from input'
write(iOut,*)
write(IOut,'(6X,A)') ' NOrd  Alpha  Radius'
do IS=1,NS
  write(IOut,'(6X,I5,2X,F5.2,2X,F6.3)') NOrd(IS),Alpha,Rad(IS)
end do
write(IOut,'(6X,1X,78("-"))')
write(IOut,*)

return

end subroutine PrtCav

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Anders Bernhardsson                              *
************************************************************************
      Subroutine CmbnACB2(Fa1,Fa2,Fb1,Fb2,Final,Fact,nalpha,nbeta,
     &     C,nC,la,lb,iang,jfhess,Tmp,lsro)
*******************************************************************************
*
*     Merges the second derivatives of ECP projection/SRO  integrals
*     for derivatives of components
*
*******************************************************************************
*
*     @parameter FA1   The first derivative of Left side , Includes no deriavtive
*     @parameter FA2   The second derivative of Left side
*     @parameter FB1   The first derivative of Right side . Includes no derivative
*     @parameter FB2   The second derivative of Right side
*     @parameter Final Result added up to (out)
*     @parameter Fact  Factor the reult is multiplied with bef. added up
*     @parameter C     Coefficients for SRO
*     @parameter nAlpha Number of exponents LS
*     @parameter nBeta  Number of exponents RS
*     @parameter nC     Number of exponents in SRO
*     @parameter la     Angular monenta LS
*     @parameter lb     Angular monenta RS
*     @parameter iAng   Angular monenta SRO
*     @parameter nBeta  Number of exponents RS
*     @parameter nC     Number of exponents in SRO
*     @parameter Tmp    Working Area nAlpha*nC (SRO case)
*     @parameter lSRO   true for SRO false projection operator
*
*******************************************************************************
      Implicit Real*8(a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"

      Logical jfhess(4,3,4,3),lsro

      Real*8 FA1(nAlpha,nC,(la+1)*(la+2)/2,(2*iang+1),*),
     &       FA2(nAlpha,nC,(la+1)*(la+2)/2,(2*iang+1),*),
     &       FB1(nC,nBeta,(2*iang+1),(lb+1)*(lb+2)/2,*),
     &       FB2(nC,nBeta,(2*iang+1),(lb+1)*(lb+2)/2,*),
     &       Tmp(*),c(*),
     &     Final(nAlpha*nbeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,21)
*                                                                      *
************************************************************************
*                                                                      *
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*     Merge integrals with one deriavtive on each center

      Do iCar = 1, 3
         Do jCar = 1, 3
            mvec=itri(iCar+3,jcar)
            If (jfHess(2,iCar,1,jcar)) Then
               Do  ib = 1, nElem(lb)
                  Do ia = 1, nElem(la)
                     Do  iC = 1, (2*iAng+1)

                        if (lsro) then
                           call mult_sro(FA1(1,1,ia,ic,icar+1),nAlpha,
     &                                   C,nC,
     &                                   FB1(1,1,ic,ib,jcar+1),nBeta,
     &                                   Fact,Final(1,ia,ib,mVec),
     &                                   Tmp)
                        else
                           Call DGEMM_('N','N',
     &                                nAlpha,nBeta,nC,
     &                                Fact,FA1(1,1,ia,ic,icar+1),nAlpha,
     &                                FB1(1,1,ic,ib,jcar+1),nC,
     &                                One,Final(1,ia,ib,mVec),nAlpha)
                        endif
                     End do
                  End do
               End do
            End If
         End do
      End do
*                                                                      *
************************************************************************
*                                                                      *
*     Merge integrals with both derivative on center A
      Do iCar = 1, 3
         Do jCar = 1, icar
            mvec=itri(iCar,jcar)
            If (jfHess(1,iCar,1,jcar)) Then
               Do  ib = 1, nElem(lb)
                  Do ia = 1, nElem(la)
                     Do  iC = 1, (2*iAng+1)
                        if (lsro) then
                           call mult_sro(FA2(1,1,ia,ic,mvec),nAlpha,
     &                                   C,nC,
     &                                   FB1(1,1,ic,ib,1),nBeta,
     &                                   Fact,Final(1,ia,ib,mVec),
     &                                   Tmp)
                        else
                           Call DGEMM_('N','N',
     &                          nAlpha,nBeta,nC,
     &                          Fact,FA2(1,1,ia,ic,mvec),nAlpha,
     &                          FB1(1,1,ic,ib,1),nC,
     &                          One,Final(1,ia,ib,mVec),nAlpha)
                        endif
                     End do
                  End do
               End do
            End If
         End do
      End do
*                                                                      *
************************************************************************
*                                                                      *
*     Merge integrals with both derivative on center B
      Do iCar = 1, 3
         Do jCar = 1, icar
            mvec=itri(3+icar,3+jcar)
            mvecB=itri(icar,jcar)
            If (jfHess(2,iCar,2,jcar)) Then

               Do  ib = 1, nElem(lb)
                  Do ia = 1, nElem(la)
*
                     Do  iC = 1, (2*iAng+1)
                        if (lsro) then
                           call mult_sro(FA1(1,1,ia,ic,1),nAlpha,
     &                                   C,nC,
     &                                   FB2(1,1,ic,ib,mvecb),nBeta,
     &                                   Fact,Final(1,ia,ib,mVec),
     &                                   Tmp)
                        else
                           Call DGEMM_('N','N',
     &                          nAlpha,nBeta,nC,
     &                          Fact,FA1(1,1,ia,ic,1),nAlpha,
     &                          FB2(1,1,ic,ib,mvecb),nC,
     &                          One,Final(1,ia,ib,mVec),nAlpha)
                        endif
                     End do
                  End do
               End do
            End If
         End do
      End do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_car_to_sph

use fmm_global_paras, only: INTK, REALK, Zero, One
use fmm_utils, only: fmm_quit
implicit none
private
! public procedures
public :: fmm_init_car_to_sph, &
          fmm_free_car_to_sph, &
          fmm_transform_car_to_sph

real(REALK), allocatable, save :: SphCoef(:,:,:)

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_car_to_sph(LMAX)

  implicit none
  integer(INTK), intent(in) :: LMAX

  if (allocated(SphCoef)) then
    call fmm_quit('mm_car_to_sph not freed correctly!')
  end if

  allocate(SphCoef(0:LMax*2+1,(LMax+1)*(LMax+2)/2,0:LMax))
  call fmm_build_sphcoef(LMAX)

end subroutine fmm_init_car_to_sph

!-------------------------------------------------------------------------------

subroutine fmm_free_car_to_sph()

  implicit none

  deallocate(SphCoef)

end subroutine fmm_free_car_to_sph

!-------------------------------------------------------------------------------

subroutine fmm_build_sphcoef(LMAX)

  implicit none
  integer(INTK), intent(in) :: LMAX

  integer(INTK) :: L, LL, I, M
  integer(INTK) :: IX, IY
  integer(INTK) :: IPX1, IPY1, IPZ1, IPY2, IPZ2, IPX2
  real(REALK) :: Denom, PreFac, Arg

  ! --- Initialization ---

  SphCoef(:,:,:) = Zero

  ! --- s coefficients ---

  SphCoef(1,1,0) = One
  if (LMax == 0) return

  ! --- p coefficients ---

  SphCoef(1,2,1) = One
  SphCoef(2,3,1) = One
  SphCoef(3,1,1) = One
  if (LMax /= 1) then

    !SphCoef(1,2,2) =  Sqrt3
    !SphCoef(2,5,2) =  Sqrt3
    !SphCoef(3,1,2) = -Half
    !SphCoef(3,4,2) = -Half
    !SphCoef(3,6,2) =  One
    !SphCoef(4,3,2) =  Sqrt3
    !SphCoef(5,1,2) =  Half * Sqrt3
    !SphCoef(5,4,2) = -Half * Sqrt3

    ! --- Higher than d ---

    do LL=2,LMax
      L = LL-1
      Arg = real(L+L+1,kind=REALK)/real(L+L+2,kind=REALK)
      PreFac = sqrt(Arg)

      I = 0
      do IX=L,0,-1
        do IY=L-IX,0,-1
          I = I+1
          IPX1 = I
          IPY1 = I+(L-IX+1)              ! Increase 1 Y
          IPZ1 = I+(L-IX+2)              ! Increase 1 Z

          ! --- Diagonal recurrence ---

          SphCoef(LL+LL+1,IPX1,LL) = SphCoef(LL+LL+1,IPX1,LL)+PreFac*SphCoef(L+L+1,I,L)
          SphCoef(LL+LL+1,IPY1,LL) = SphCoef(LL+LL+1,IPY1,LL)-PreFac*SphCoef(1,I,L)

          SphCoef(1,IPY1,LL) = SphCoef(1,IPY1,LL)+PreFac*SphCoef(L+L+1,I,L)
          SphCoef(1,IPX1,LL) = SphCoef(1,IPX1,LL)+PreFac*SphCoef(1,I,L)

          ! --- Vertical recurrence (1) ---

          do M=-LL+1,LL-1
            Denom = sqrt(real((L+M+1)*(L-M+1),kind=REALK))
            SphCoef(LL+M+1,IPZ1,LL) = SphCoef(LL+M+1,IPZ1,LL)+(real(L+L+1,kind=REALK)/Denom)*SphCoef(L+M+1,I,L)
          end do

        end do   ! IY
      end do   ! IX

      ! --- Vertical recurrence (2) ---

      I = 0
      do IX=L-1,0,-1
        do IY=L-1-IX,0,-1
          I = I+1
          IPX2 = I
          IPY2 = I+(L-1-IX+1)+(L-1-IX+2)   ! Increase 2 Y
          IPZ2 = I+(L-1-IX+2)+(L-1-IX+3)   ! Increase 2 Z

          do M=-LL+1,LL-1
            Arg = real((L+M)*(L-M),kind=REALK)/real((L+M+1)*(L-M+1),kind=REALK)
            PreFac = sqrt(Arg)
            SphCoef(LL+M+1,IPX2,LL) = SphCoef(LL+M+1,IPX2,LL)-PreFac*SphCoef(L+M,I,L-1)
            SphCoef(LL+M+1,IPY2,LL) = SphCoef(LL+M+1,IPY2,LL)-PreFac*SphCoef(L+M,I,L-1)
            SphCoef(LL+M+1,IPZ2,LL) = SphCoef(LL+M+1,IPZ2,LL)-PreFac*SphCoef(L+M,I,L-1)
          end do   ! M

        end do   ! IY
      end do   ! IX

    end do   ! LL

    ! o p-1, p0, p+1 -> px, py, pz

  end if
  SphCoef(:,:,1) = Zero
  SphCoef(1,1,1) = One
  SphCoef(2,2,1) = One
  SphCoef(3,3,1) = One

end subroutine fmm_build_sphcoef

!-------------------------------------------------------------------------------

subroutine fmm_transform_car_to_sph(CarMpole,SphMpole,ndim,LMAX)

  implicit none
  integer(INTK), intent(in) :: ndim, LMAX
  real(REALK), intent(in)   :: CarMpole(ndim,(LMAX+1)*(LMAX+2)/2,0:LMAX)
  real(REALK), intent(out)  :: SphMpole(ndim,2*LMAX+1,0:LMAX)

  integer(INTK) :: MType, IS, IC, IJAO
  real(REALK) :: Tmp, TempSphCoef, SphCoef_yzx(3,3)

  SphMpole(:,:,:) = Zero
  SphCoef_yzx(:,:) = Zero
  SphCoef_yzx(1,2) = One
  SphCoef_yzx(2,3) = One
  SphCoef_yzx(3,1) = One

  do MType=0,LMAX
    do IS=1,(MType+MType+1)
      do IC=1,(MType+1)*(MType+2)/2

        if (MType /= 1) then
          TempSphCoef = SphCoef(IS,IC,MType)
        else
          TempSphCoef = SphCoef_yzx(IS,IC)
        end if

        do IJAO=1,ndim
          Tmp = TempSphCoef*CarMpole(IJAO,IC,MType)
          SphMpole(IJAO,IS,MType) = SphMpole(IJAO,IS,MType)+Tmp
        end do

      end do
    end do
  end do

end subroutine fmm_transform_car_to_sph

!-------------------------------------------------------------------------------

end module fmm_car_to_sph

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               1995, Martin Schuetz                                   *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine NewOrb_SCF(AllowFlip)
!***********************************************************************
!                                                                      *
!     purpose: Diagonalize Fock matrix to get new orbitals             *
!                                                                      *
!     input:                                                           *
!       Fock    : Fock matrix of length nFock                          *
!       CMO     : orthonormal vectors from previous iteration of       *
!                 length nCMO                                          *
!                                                                      *
!     output:                                                          *
!       CMO     : orthonormal vectors in current iteration             *
!       FMOMax  : Max Element of occ/virt block in Fock Matrix,        *
!                 transformed into MO basis                            *
!       EOrb    : orbital energies of length nEOrb                     *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use SpinAV, only: Do_SpinAV
use InfSCF, only: Aufb, CMO, DoHLGap, EOrb, FCKAuf, FlipThr, FMOMax, FockAO, HLGap, Iter, MaxBas, MaxBOF, MaxOrf, MxConstr, nBas, &
                  nBB, nBO, nBT, nConstr, nD, nFro, nnB, nnFr, nOcc, nOrb, nSym, Ovrlp, RotFac, RotLev, RotMax, ScrFac, Scrmbl, &
                  TEEE, TimFld, WarnCFG
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
logical(kind=iwp), intent(in) :: AllowFlip
integer(kind=iwp) :: Fermion_Type, i, ia, iAddGap, iBas, iChk, iCMO, iConstr, iD, iDum, iErr, iFC, ii, iiBT, ij, ijBas, Ind, &
                     IndII, IndIJ, IndJJ, iOff, iOrb, iOvlpOff, iptr, iSeed = 13, iSym, j, jBas, jEOr, jj, jOff, jOrb, kCMO, &
                     kConstr, keOR, kk, kOff, kOrb, lConstr, Muon_I, Muon_J, nFound, nj, nOccmF, nOrbmF, nsDg, nVrt
real(kind=wp) :: CPU1, CPU2, Dummy, EHOMO, ELUMO, Fia, GapAdd, Q, Tim1, Tim2, Tim3, Tmp, Tmp0, Tmp1, Tmp2, WhatEver
logical(kind=iwp) :: em_On, Muons_Present, Scram
integer(kind=iwp), allocatable :: iFerm(:)
real(kind=wp), allocatable :: eConstr(:), FckM(:), FckS(:), HlfF(:), Scratch(:), Temp(:), TraF(:)
integer(kind=iwp), external :: iDAMax_
real(kind=wp), external :: DDot_, Random_Molcas

!                                                                      *
!***********************************************************************
!                                                                      *
call Timing(Cpu1,Tim1,Tim2,Tim3)
#ifdef _DEBUGPRINT_
call NrmClc(FockAO,size(FockAO),'NewOrb','FockAO')
#endif

Muons_Present = .false.
Scram = (Scrmbl .and. (iter == 1))
nSdg = 1
if (Do_SpinAV) nSdg = 2
if (MxConstr > 0) call mma_allocate(eConstr,nSdg*MxConstr,Label='eConstr')

if (.not. AllowFlip) then
  if (.not. DoHLgap) then
    DoHLgap = .true.
    HLgap = FlipThr
  end if
end if
! Allocate memory for orbital homeing
if (.not. FckAuf) then
  call mma_allocate(Scratch,MaxBas**2,Label='Scratch')
  call mma_allocate(Temp,MaxBas**2,Label='TempX')
end if
! Allocate memory for modified Fock matrix
call mma_allocate(FckM,nBT,Label='FckM')
! Allocate memory for squared Fock matrix
call mma_allocate(FckS,MaxBas**2,Label='FckSX')
! Allocate memory for half-transformed Fock matrix
call mma_allocate(HlfF,MaxBOF,Label='HlfF')
! Allocate memory for transformed Fock matrix (triangular)
call mma_allocate(TraF,nTri_Elem(MaxOrF),Label='TraF')
! Allocate memory for fermi index array
call mma_allocate(iFerm,nBB,Label='iFerm')
call Get_iArray('Fermion IDs',iFerm,nnB)
iChk = sum(iFerm(:))
em_On = ((iChk /= 0) .and. (iChk /= nnB))

FMOMax = Zero
WarnCfg = .false.
do iD=1,nD

  ! Modify Fock matrix
  FckM(:) = FockAO(:,iD)
  if (nnFr > 0) call ModFck(FckM,Ovrlp,nBT,CMO(1,iD),nBO,nOcc(1,iD))
  ! Prediagonalize Fock matrix
  iAddGap = 0
  GapAdd = Zero
  if ((.not. Aufb) .and. DoHLgap) then
    ij = 1
    iCMO = 1
    jEOr = 1
    Ehomo = -1.0e6_wp
    Elumo = 1.0e6_wp
    do iSym=1,nSym
      iiBT = nTri_Elem(nBas(iSym))
      nOrbmF = nOrb(iSym)-nFro(iSym)
      nOccmF = nOcc(iSym,iD)-nFro(iSym)
      nVrt = nOrb(iSym)-nOcc(iSym,iD)
      iCMO = iCMO+nBas(iSym)*nFro(iSym)
      jEOr = jEOr+nFro(iSym)
      call Square(FckM(ij),FckS,1,nBas(iSym),nBas(iSym))
      if (nOccmF > 0) then
        call DGEMM_('N','N',nBas(iSym),nOccmF,nBas(iSym), &
                    One,FckS,nBas(iSym), &
                    CMO(iCMO,iD),nBas(iSym), &
                    Zero,HlfF,nBas(iSym))
        call DGEMM_Tri('T','N',nOccmF,nOccmF,nBas(iSym), &
                       One,CMO(iCMO,iD),nBas(iSym), &
                       HlfF,nBas(iSym), &
                       Zero,TraF,nOccmF)
#       ifdef _DEBUGPRINT_
        call Triprt('Occupied Fock matrix in MO basis','(20F10.4)',TraF,nOccmF)
#       endif
        nOccmF = nOccmF-nConstr(iSym)
        call NIdiag(TraF,CMO(iCMO,iD),nOccmF,nBas(iSym))
        nOccmF = nOccmF+nConstr(iSym)
#       ifdef _DEBUGPRINT_
        call Triprt('Occupied Fock matrix in MO basis','(20F10.4)',TraF,nOccmF)
#       endif
        do iBas=1,nOccmF
          ind = nTri_Elem(iBas)
          Ehomo = max(Ehomo,TraF(ind))
        end do
      end if

      iCMO = iCMO+nOccmF*nBas(iSym)
      jEOr = jEOr+nOccmF
      if (Do_SpinAV) then
        nVrt = nVrt-nConstr(iSym)
        iCMO = iCMO+nConstr(iSym)*nBas(iSym)
        jEOr = jEOr+nConstr(iSym)
      end if
      if (nVrt > 0) then
        call DGEMM_('N','N',nBas(iSym),nVrt,nBas(iSym), &
                    One,FckS,nBas(iSym), &
                    CMO(iCMO,iD),nBas(iSym), &
                    Zero,HlfF,nBas(iSym))
        call DGEMM_Tri('T','N',nVrt,nVrt,nBas(iSym), &
                       One,CMO(iCMO,iD),nBas(iSym), &
                       HlfF,nBas(iSym), &
                       Zero,TraF,nVrt)
#       ifdef _DEBUGPRINT_
        call Triprt('Virtual Fock matrix in MO basis','(20F10.4)',TraF,nVrt)
#       endif
        call NIdiag(TraF,CMO(iCMO,iD),nVrt,nBas(iSym))
#       ifdef _DEBUGPRINT_
        call Triprt('Virtual Fock matrix in MO basis','(20F10.4)',TraF,nVrt)
#       endif
        do iBas=1,nVrt
          ind = nTri_Elem(iBas)
          Elumo = min(Elumo,TraF(ind))
        end do
      end if
      if (Do_SpinAV) then
        nVrt = nVrt+nConstr(iSym)
        iCMO = iCMO-nConstr(iSym)*nBas(iSym)
        jEOr = jEOr-nConstr(iSym)
      end if
      iCMO = iCMO+nVrt*nBas(iSym)
      jEOr = jEOr+nVrt
      ij = ij+iiBT
    end do
#   ifdef _DEBUGPRINT_
    write(u6,'(a,F12.6)') 'E(homo)   ',Ehomo
    write(u6,'(a,F12.6)') 'E(lumo)   ',Elumo
    write(u6,'(a,F12.6)') 'E(gap)    ',Elumo-Ehomo
#   endif
    WarnCfg = ((Elumo-Ehomo < Zero) .or. WarnCfg)
    if (Elumo-Ehomo < HLgap) then
      iAddGap = 1
      GapAdd = HLgap-Elumo+Ehomo
#     ifdef _DEBUGPRINT_
      write(u6,'(a,F12.6)') 'E(add)    ',GapAdd
#     endif
    end if
  end if
  ! Diagonalize Fock matrix in non-frozen molecular basis
  ij = 1
  iCMO = 1
  jEOr = 1
  iOvlpOff = 1
  do iSym=1,nSym
    iiBT = nTri_Elem(nBas(iSym))
    nOrbmF = nOrb(iSym)-nFro(iSym)
    nOccmF = nOcc(iSym,iD)-nFro(iSym)
    nVrt = nOrb(iSym)-nOcc(iSym,iD)
    ! Find the proper pointers to CMO and EOr
    iCMO = iCMO+nBas(iSym)*nFro(iSym)
    jEOr = jEOr+nFro(iSym)
    if (nOrbmF > 0) then
      call Square(FckM(ij),FckS,1,nBas(iSym),nBas(iSym))
      ! Transform Fock matrix to the basis from previous iteration
      call DGEMM_('N','N',nBas(iSym),nOrbmF,nBas(iSym), &
                  One,FckS,nBas(iSym), &
                  CMO(iCMO,iD),nBas(iSym), &
                  Zero,HlfF,nBas(iSym))
      call DGEMM_Tri('T','N',nOrbmF,nOrbmF,nBas(iSym), &
                     One,CMO(iCMO,iD),nBas(iSym), &
                     HlfF,nBas(iSym), &
                     Zero,TraF,nOrbmF)

      ! Constrained SCF section begins
      kConstr = 1
      do iConstr=nConstr(iSym),1,-1
        nj = nOccmF-iConstr
        ifc = 1+nTri_Elem(nj)
        eConstr(kConstr) = TraF(ifc+nj)
        TraF(ifc:ifc+nj-1) = Zero
        do j=nj+1,nOrbmF-1
          jj = 1+nTri_Elem(j)+nj
          Traf(jj) = Zero
        end do
        Traf(ifc+nj) = -0.666e6_wp*real(iConstr,kind=wp) ! for sorting
        kConstr = kConstr+1
      end do
      if (Do_SpinAV) then
        do iConstr=0,nConstr(iSym)-1
          nj = nOccmF+iConstr
          ifc = 1+nTri_Elem(nj)
          eConstr(kConstr) = TraF(ifc+nj)
          TraF(ifc:ifc+nj-1) = Zero
          do j=nj+1,nOrbmF-1
            jj = 1+nTri_Elem(j)+nj
            TraF(jj) = Zero
          end do
          TraF(ifc+nj) = 0.666e6_wp*real(kConstr,kind=wp) ! for sorting
          kConstr = kConstr+1
        end do
      end if
      ! Constrained SCF section ends

      ! get max element of Fock matrix
      !do iBas=2,nOrbmF
      !  do jBas=1,iBas-1
      !    ijBas = iTri(iBas,jBas)
      !    FMOMax = Max(Abs(TraF(ijBas)),FMOMax)
      !  end do
      !end do
      ! get max element of occ/virt Block of Fock matrix

      if (Teee) then
        do iBas=2,nOrbmF
          do jBas=1,iBas-1
            ijBas = iTri(iBas,jBas)
            FMOMax = max(abs(TraF(ijBas)),FMOMax)
          end do
        end do
      else if ((nOccmF > 0) .and. (nVrt > 0)) then
        iptr = 1+nTri_Elem(nOccmF)
        do ia=1,nVrt
          Fia = abs(TraF(iptr+IDAMAX_(nOccmF,TraF(iptr),1)-1))
          FMOMax = max(Fia,FMOMax)
          iptr = iptr+nOccmF+ia
        end do
      end if

      ! Modify Fock matrix to enhance convergence

      ! Add to homo lumo gap

      if (iAddGap == 1) then
        do iOrb=nOccmF+1,nOrbmF
          ind = nTri_Elem(iOrb)
          TraF(ind) = TraF(ind)+GapAdd
        end do
      end if
      ind = 1
      do iOrb=1,nOrbmF
        do jOrb=1,iOrb
          ! Scale OV elements of Fock matrix
          if ((iOrb > nOcc(iSym,iD)) .and. (jOrb <= nOcc(iSym,iD))) TraF(ind) = RotFac*TraF(ind)
          ! Levelshift virtual diagonal matrix elements
          if ((iOrb > nOcc(iSym,iD)) .and. (iOrb == jOrb)) TraF(ind) = TraF(ind)+RotLev
          ind = ind+1
        end do
      end do
      ! Add scrambling
      if (Scram) then
        ind = 1
        do iOrb=1,nOrbmF
          do jOrb=1,iOrb
            if (iOrb /= jOrb) then
              q = ScrFac*(Two*Random_Molcas(iSeed)-One)
              TraF(ind) = TraF(ind)+q
            end if
            ind = ind+1
          end do
        end do
      end if

      ! Scale OV elements if too big.
      indii = 1
      indij = 1
      do iOrb=1,nOrbmF
        indjj = 1
        do jOrb=1,iOrb
          if ((iOrb > nOcc(iSym,iD)) .and. (jOrb <= nOcc(iSym,iD))) then
            tmp1 = max(abs(TraF(indii)-TraF(indjj)),1.0e-3_wp)
            tmp2 = abs(TraF(indij)/tmp1)
            if ((tmp2 > RotMax) .and. (abs(TraF(indij)) > 0.001_wp)) TraF(indij) = TraF(indij)*RotMax/tmp2
          end if
          indij = indij+1
          indjj = indjj+jOrb+1
        end do
        indii = indii+iOrb+1
      end do

      ! Constrained SCF section begins
      kConstr = 1
      do iConstr=nConstr(iSym),1,-1
        nj = nOccmF-iConstr
        ifc = 1+nTri_Elem(nj)
        TraF(ifc:ifc+nj-1) = Zero
        do j=nj+1,nOrbmF-1
          jj = 1+nTri_Elem(j)+nj
          TraF(jj) = Zero
        end do
        TraF(ifc+nj) = -0.666e6_wp*real(iConstr,kind=wp) ! for sorting
        kConstr = kConstr+1
      end do
      if (Do_SpinAV) then
        do iConstr=0,nConstr(iSym)-1
          nj = nOccmF+iConstr
          ifc = 1+nTri_Elem(nj)
          TraF(ifc:ifc+nj-1) = Zero
          do j=nj+1,nOrbmF-1
            jj = 1+nTri_Elem(j)+nj
            TraF(jj) = Zero
          end do
          TraF(ifc+nj) = 0.666e6_wp*real(kConstr,kind=wp) ! for sorting
          kConstr = kConstr+1
        end do
      end if
      ! Constrained SCF section ends

#     ifdef _DEBUGPRINT_
      call Triprt('Fock matrix in MO basis after modification','(10F10.4)',TraF,nOrbmF)
#     endif

      ! Diagonalize and form orbital energies

      Dummy = Zero
      iDum = 0

      ! Store the original CMOs for root following.

      FckS(1:nBas(iSym)**2) = CMO(iCMO:iCMO+nBas(iSym)**2-1,iD)

      call Diag_Driver('V','A','L',nOrbmF,TraF,TraF,nOrbmF,Dummy,Dummy,iDum,iDum,EOrb(jEOr,iD),CMO(iCMO,iD),nBas(iSym),0,-1,'J', &
                       nFound,iErr)

      ! Fix standard phase of the orbitals

      do i=1,nBas(iSym)
        call VecPhase(CMO(iCMO+(i-1)*nBas(iSym),iD),nBas(iSym))
      end do
#     ifdef _DEBUGPRINT_
      call NrmClc(Fcks,nbas(iSym)*nOrb(iSym),'NewOrb','Old CMOs')
      call NrmClc(CMO(iCMO,iD),nbas(iSym)*nOrb(iSym),'NewOrb','New CMOs')
#     endif
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Reorder the orbitals to preserve e/m partition.

      if (em_On) then ! skip if all orbitals are of the same type.

        do iOrb=1,nOrb(iSym)-1    ! Loop over the old orbitals

          ! Compute a check sum which is not zero if the orbital
          ! is a muonic orbital.

          tmp = sum(real(iFerm(jEOr:jEOr+nBas(iSym)-1),kind=wp)*abs(FckS((iOrb-1)*nBas(iSym)+1:iOrb*nBas(iSym))))
          Muon_i = 0                  ! electronic
          if (tmp /= Zero) Muon_i = 1 ! muonic
          Muons_Present = (Muons_Present .or. (Muon_i == 1))
          !write(u6,*) 'iOrb,Muon_i,tmp=',iOrb,Muon_i,tmp

          ! Loop over the new orbitals and test if it is of the
          ! same type. i.e. fermionic or electronic.

          do jOrb=iOrb,nOrb(iSym)
            tmp = sum(real(iFerm(jEOr:jEOr+nBas(iSym)-1),kind=wp)*abs(CMO(iCMO+(jOrb-1)*nBas(iSym):iCMO+(jOrb)*nBas(iSym)-1,iD)))

            Muon_j = 0                  ! electronic
            if (tmp /= Zero) Muon_j = 1 ! muonic

            ! If orbital and fermion index are identical fine.

            if ((iOrb == jOrb) .and. (Muon_i == Muon_j)) exit

            ! If fermion index the same swap orbital and the
            ! corresponding orbital energy in the new list.

            if (Muon_i == Muon_j) then
              Tmp = EOrb(jEOr-1+iOrb,iD)
              EOrb(jEOr-1+iOrb,iD) = EOrb(jEOr-1+jOrb,iD)
              EOrb(jEOr-1+jOrb,iD) = Tmp
              call DSwap_(nBas(iSym),CMO(iCMO+(iOrb-1)*nBas(iSym),iD),1,CMO(iCMO+(jOrb-1)*nBas(iSym),iD),1)
              exit
            end if

          end do   !  jOrb

          ! Arrive at this point when the iOrb'th orbital in the
          ! new list is of the same type as in the old list.

        end do      !  iOrb
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Order the orbitals in the same way as previously, that is,
      ! do not populate according to the aufbau principle.

      if (.not. FckAuf) then
        !write(u6,*) 'Follow the orbitals'

        ! Form  C^+ S  C for the old orbitals

        Scratch(1:nOrb(iSym)*nBas(iSym)) = Zero
        call Square(Ovrlp(iOvlpOff),Temp,1,nBas(iSym),nBas(iSym))
        call DGEMM_('T','N',nOrb(iSym),nBas(iSym),nBas(iSym), &
                    One,FckS,nBas(iSym), &
                    Temp,nBas(iSym), &
                    Zero,Scratch,nOrb(iSym))

        Fermion_type = 1
        if (Muons_present) Fermion_type = 0
        do iOrb=1,nOrb(iSym)-1  ! Loop over the old orbitals

          ! Don't apply non-aufbau principle for the electrons!

          iOff = (iOrb-1)*nBas(iSym)+iCMO

          ! Identify orbital type.

          tmp = sum(real(iFerm(jEOr:jEOr+nBas(iSym)-1),kind=wp)*abs(FckS((iOrb-1)*nBas(iSym)+1:iOrb*nBas(iSym))))

          Muon_i = 0                  ! electronic
          if (tmp /= Zero) Muon_i = 1 ! muonic
          if (Muon_i == Fermion_Type) cycle

          !write(u6,*) 'iOrb,Muon_i=',iOrb,Muon_i

          kOrb = 0
          Tmp0 = Zero
          do jOrb=1,nOrb(iSym)   ! Loop over the new orbitals
            jOff = (jOrb-1)*nBas(iSym)+iCMO

            tmp = sum(real(iFerm(jEOr:jEOr+nBas(iSym)-1),kind=wp)*abs(FckS((jOrb-1)*nBas(iSym)+1:jOrb*nBas(iSym))))

            Muon_j = 0                  ! electronic
            if (tmp /= Zero) Muon_j = 1 ! muonic
            if (Muon_j /= Muon_i) cycle

            Tmp1 = abs(DDot_(nBas(iSym),Scratch(iOrb),nOrb(iSym),CMO(jOff,iD),1))
            if (Tmp1 > Tmp0) then
              Tmp0 = Tmp1
              kOrb = jOrb
            end if
          end do

          !write(u6,*) 'Fermion_Type=',Fermion_type
          !write(u6,*) 'kOrb,Tmp0=',kOrb,Tmp0
          !write(u6,*) 'Muon_i, Muon_j=',Muon_i, Muon_j

          if (iOrb /= kOrb) then
            ii = iOrb+jEOr-1
            kk = kOrb+jEOr-1
            tmp = EOrb(ii,iD)
            EOrb(ii,iD) = EOrb(kk,iD)
            EOrb(kk,iD) = tmp
            kOff = (kOrb-1)*nBas(iSym)+iCMO
            call DSwap_(nBas(iSym),CMO(iOff,iD),1,CMO(kOff,iD),1)
          end if
        end do
#       ifdef _DEBUGPRINT_
        call NrmClc(CMO(iCMO,iD),nbas(iSym)*nOrb(iSym),'NewOrb','New CMOs')
#       endif
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *

      ! Constrained SCF section begins

      if (nConstr(iSym) > 0) then
        do kConstr=1,nConstr(iSym)
          iConstr = jEOr-1+kConstr
          EOrb(iConstr,iD) = 0.666e6_wp*real(kConstr,kind=wp)
        end do
        call SortEig(EOrb(jEOr,iD),CMO(iCMO,iD),nOccmF,nBas(iSym),1,.true.)
        iConstr = 1
        do kConstr=nConstr(iSym),1,-1
          lConstr = jEOr+nOccmF-kConstr
          EOrb(lConstr,iD) = eConstr(iConstr)
          iConstr = iConstr+1
        end do
        if (Do_SpinAV) then
          do kConstr=nConstr(iSym),1,-1
            iConstr = jEOr+nOrbmF-kConstr
            EOrb(iConstr,iD) = -0.666e6_wp*real(kConstr,kind=wp)
          end do
          kCMO = iCMO+nOccmF*nBas(iSym)
          kEOr = jEOr+nOccmF
          call SortEig(EOrb(kEOr,iD),CMO(kCMO,iD),nVrt,nBas(iSym),1,.true.)
          iConstr = nConstr(iSym)+1
          do kConstr=1,nConstr(iSym)
            lConstr = kEOr+kConstr
            EOrb(lConstr,iD) = eConstr(iConstr)
            iConstr = iConstr+1
          end do
        end if
      end if
      ! Constrained SCF section ends
    end if
    ! Update pointers
    iCMO = iCMO+nOrbmF*nBas(iSym)
    jEOr = jEOr+nOrbmF
    ij = ij+iiBT
    iOvlpOff = iOvlpOff+nTri_Elem(nBas(iSym))
  end do

  ! Check orthogonality
  call ChkOrt(iD,Whatever)

end do

! Deallocate memory
call mma_deallocate(iFerm)
call mma_deallocate(TraF)
call mma_deallocate(HlfF)
call mma_deallocate(FckS)
call mma_deallocate(FckM)
if (.not. FckAuf) then
  call mma_deallocate(Scratch)
  call mma_deallocate(Temp)
end if
if (MxConstr > 0) call mma_deallocate(eConstr)

#ifdef _DEBUGPRINT_
do iD=1,nD
  iOff = 1
  jOff = 1
  do iSym=1,nSym
    call RecPrt('CMO',' ',CMO(jOff,iD),nBas(iSym),nOrb(iSym))
    iOff = iOff+nOrb(iSym)
    jOff = jOff+nBas(iSym)*nOrb(iSym)
  end do
end do
call RecPrt('NewOrb_scf: EOr',' ',EOrb,1,size(EOrb))
#endif

call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(8) = TimFld(8)+(Cpu2-Cpu1)

return

end subroutine NewOrb_SCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_PutRed(iPass,iLoc)
C
C     Purpose: write global and local reduced set index arrays
C              to disk and set
C              address for next write. iLoc specifies the location in
C              the index arrays to write, and iPass identifies the
C              reduced set (i.e. the integral pass).
C
      Implicit None
      Integer iPass, iLoc
#include "cho_para_info.fh"
#include "cholesky.fh"
#include "choglob.fh"

      Integer iTmp

      Real*8 c1, c2, w1, w2

      Call Cho_Timer(c1,w1)

      If (Cho_Real_Par) Then

C        Swap local and global reduced set indices and use original serial
C        routine to write global index arrays.
C        -----------------------------------------------------------------

         Call Cho_P_IndxSwp()
         iTmp = LuRed
         LuRed = LuRed_G
         Call Cho_PutRed(iPass,iLoc)
         LuRed = iTmp
         Call Cho_P_IndxSwp()

      End If

C     Write local index arrays.
C     -------------------------

      Call Cho_PutRed(iPass,iLoc)

      Call Cho_Timer(c2,w2)
      tMisc(1,2)=tMisc(1,2)+c2-c1
      tMisc(2,2)=tMisc(2,2)+w2-w1

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
SUBROUTINE kriging_model()
  use kriging_mod
  Implicit None
#include "stdalloc.fh"
  External DDOt_
  Real*8 DDOt_
  real*8, Allocatable:: B(:), A(:,:)
!
! Prediagonalize the part of the matrix corresponing to the value-value block

#define _PREDIAG_
#ifdef _PREDIAG_
  real*8, Allocatable:: U(:,:), HTri(:), UBIG(:,:), C(:,:), D(:)
  real*8 temp
  integer j,ij
#endif

  Integer, Allocatable:: IPIV(:)
  Integer i,INFO ! ipiv the pivot indices that define the permutation matrix
!
  Call mma_Allocate(B,m_t,Label="B")
  Call mma_Allocate(A,m_t,m_t,Label="A")
  Call mma_Allocate(IPIV,m_t,Label="IPIV")
!
! Initiate B according to Eq. (6) of ref.
  B(1:nPoints)=1.0D0
  B(nPoints+1:)=0.0D0
!
! Initiate A according to Eq. (2) of ref.
!
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
  Call RecPrt('f',' ',B,1,m_t)
#endif
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!      Code with prediagonalization of the value-value block

#ifdef _PREDIAG_

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! First diagonalize the value-value block
!
! U will contain the eigenvectors
!
  Call mma_allocate(U,nPoints,nPoints,Label='U')
  U(:,:) = 0.0D0
  do i=1,nPoints
    U(i,i)=1.0D0
  end do
  Call mma_allocate(HTri,nPoints*(nPoints+1)/2,Label='HTri')
  Do i = 1, nPoints
    Do j = 1, i
      ij=i*(i-1)/2 + j
      HTri(ij)=Full_R(i,j)
    End Do
  End Do
#ifdef _DEBUGPRINT_
  Call RecPrt('U',' ',U,nPoints,nPoints)
#endif
  Call nidiag_new(HTri,U,nPoints,nPoints,0)
  Call Jacord    (HTri,U,nPoints,nPoints)
!
! Introduce canonical phase factor
!
  Do i = 1, nPoints
    Temp=DDot_(nPoints,[1.0D0],0,U(1,i),1)
    U(1:nPoints,i)= U(1:nPoints,i) * Sign(1.0D0,Temp)
  End Do
#ifdef _DEBUGPRINT_
  Call RecPrt('U',' ',U,nPoints,nPoints)
  Call TriPrt('HTri',' ',HTri,nPoints)
#endif
!
! Now set up an eigenvector matrix for the whole space.
!
  Call mma_Allocate(UBIG,m_t,m_t,Label='UBig')
  UBIG(:,:)=0.0D0
  UBIG(1:nPoints,1:nPoints)=U(:,:)
  do i=nPoints+1,m_t
    UBIG(i,i)=1.0D0
  end do
!           Call RecPrt('UBIG',' ',UBig,m_t,m_t)
!
! Transform the covariance matrix to this basis
!
  Call mma_Allocate(C,m_t,m_t,Label='C')
  C=0.0D0
  Call dgemm_('N','N',m_t,m_t,m_t,    &
              1.0D0,Full_R,m_t,       &
                    UBIG,m_t,         &
              0.0D0,C,m_t)
  Call dgemm_('T','N',m_t,m_t,m_t,    &
              1.0D0,UBIG,m_t,         &
                    C,m_t,            &
              0.0D0,A,m_t)
!
! For safty measures set the value-value to zero and then reintroduce the
! eigenvalues from the previous diagonalization.
!
  A(1:nPoints,1:nPoints)=0.0D0
  do i=1,nPoints
    A(i,i)=HTri(i*(i+1)/2)
  end do
#ifdef _DEBUGPRINT_
  Call RecPrt('U^TAU',' ',A,m_t,m_t)
#endif
!
! Set up the F-vector with ones and zeros
!
  Call mma_allocate(D,m_t,Label='D')
  D(1:nPoints)=1.0D0
  D(nPoints+1:)=0.0D0
!
! Transform the vector to the new basus
!
  B(:)=0.0D0
  Call dgemm_('T','N',m_t,1,m_t,      &
              1.0D0,UBIG,m_t,         &
                    D,m_t,            &
              0.0D0,B,m_t)
#ifdef _DEBUGPRINT_
  Call RecPrt('U^TB',' ',B,1,m_t)
#endif
!
  Call mma_deallocate(HTri)
  Call mma_deAllocate(C)
  Call mma_deallocate(U)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#else

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! here we do the same stuff but without prediagonalization
!
  B(1:nPoints)=1.0D0
  B(nPoints+1:)=0.0D0
  A(:,:) = full_r(:,:)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  Now form A_1 B (to be used for the computation of the dispersion)
!
#define _DPOSV_
#ifdef _DPOSV_
  CALL DPOSV_('U',m_t,1,A,m_t,B,m_t,INFO )
#else
  CALL DGESV_(m_t,1,A,m_t,IPIV,B,m_t,INFO )
#endif
  If (INFO.ne.0) Then
    Write (6,*) 'k: INFO.ne.0'
    Write (6,*) 'k: INFO=',INFO
    Call Abend()
  End If
#ifdef _DEBUGPRINT_
  Write (6,*) 'Info=',Info
  Call RecPrt('PSI^{-1}',' ',A,m_t,m_t)
  Call RecPrt('X=PSI^{-1}f',' ',B,1,m_t)
  Call RecPrt('rones',' ',rones,1,m_t)
  Write (6,*) 'nPoints=',nPoints
#endif

!
! In case of prediagonalization backtransform to the original basis
!
#ifdef _PREDIAG_
! Call RecPrt('(U^TAU)^{-1}U^TB',' ',B,1,m_t)
  D(:)=B(:)
  B(:)=0.0D0
  Call DGEMM_('N','N',m_t,1,m_t,      &
              1.0D0,UBIG,m_t,         &
                    D,m_t,            &
              0.0D0,B,m_t)
! Call RecPrt('B',' ',B,1,m_t)
  Call mma_deallocate(D)
  Call mma_deAllocate(UBIG)
#endif

  rones(:)=B(:)     ! Move result over to storage for later use, R^-1F

!
! Compute contribution to the expression for the liklihood function.
!
! Now A contains the factors L and U from the factorization A = P*L*U as computed by DGESV
! Where L in the lower triangular matrix with 1 in the diagonal and U is the upper
! triangular matrix of A thus the determinant of A is giving by multipling its diagonal
!

  detR = 0.0d0
  do i=1,m_t
#ifdef _DPOSV_
    detR = detR + 2.0D0*log(A(i,i))
#else
    detR = detR + log(abs(A(i,i)))
#endif
  enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  Now work on the vector with the values and gradients, the generalized y vector
!
!Trend Function (baseline)
!
  if (blaAI) then
!
!   Make sure the base line is above any data point
!
    sb = -1.0D99
    Do i = 1, nPoints
      sb = Max( sb, y(i) + blavAI )
    End Do
  else if (mblAI) then
    sb = sbmev
  else if (blAI) Then
    sb = blvAI
  else
    ordinary = .True.
!
    B(:) = [y(:),dy(:)]
#ifdef _DEBUGPRINT_
    Write (6,*) DDot_(m_t,rones,1,B,1) , DDot_(nPoints,rones,1,[1.0D0],0)
#endif
!   sbO:  FR^-1y/(FR^-1F)
    sbO = DDot_(m_t,rones,1,B,1) / DDot_(nPoints,rones,1,[1.0D0],0)
    sb = sbO
  endif
!
!**********************************************************************
!
! form the actual value vector (y-b_0F)
!
  B(1:m_t) = [y(1:nPoints)-sb,dy(1:nInter*(nPoints-nD))]
!
#ifdef _DEBUGPRINT_
  Write (6,*) 'sb,ln(det|PSI|)=',sb,detR
  Call RecPrt('[y-sb,dy]',' ',B,1,m_t)
#endif

!#undef _PREDIAG_
#ifdef _PREDIAG_
!
! Diagonalize the energy block of Psi
!
  Call mma_allocate(U,nPoints,nPoints,Label='U')
  U(:,:) = 0.0D0
  do i=1,nPoints
    U(i,i)=1.0D0
  end do
  Call mma_allocate(HTri,nPoints*(nPoints+2)/2,Label='HTri')
  Do i = 1, nPoints
    Do j = 1, i
      ij=i*(i-1)/2 + j
      HTri(ij)=Full_R(i,j)
    End Do
  End Do
  Call nidiag_new(HTri,U,nPoints,nPoints,0)
  Call Jacord    (HTri,U,nPoints,nPoints)
! Standardized phase factor
  Do i = 1, nPoints
    Temp=DDot_(nPoints,[1.0D0],0,U(1,i),1)
    U(1:nPoints,i)= U(1:nPoints,i) * Sign(1.0D0,Temp)
  End Do
#ifdef _DEBUGPRINT_
  Call RecPrt('U',' ',U,nPoints,nPoints)
  Call TriPrt('HTri',' ',HTri,nPoints)
#endif
!
! Construct a transformation which will transform the
! covariance  matrix to this new basis.
!
  Call mma_Allocate(UBIG,m_t,m_t,Label='UBig')
  UBIG(:,:)=0.0D0
  UBIG(1:nPoints,1:nPoints)=U(:,:)
  do i=nPoints+1,m_t
    UBIG(i,i)=1.0D0
  end do
! Call RecPrt('UBIG',' ',UBig,m_t,m_t)
!
! Transform the covariance matrix to the new basis.
!
  Call mma_Allocate(C,m_t,m_t,Label='C')
  C(:,:)=0.0D0
  Call dgemm_('N','N',m_t,m_t,m_t,    &
              1.0D0,Full_R,m_t,       &
                    UBIG,m_t,         &
              0.0D0,C,m_t)
  Call dgemm_('T','N',m_t,m_t,m_t,    &
              1.0D0,UBIG,m_t,         &
                    C,m_t,            &
              0.0D0,A,m_t)
!
! Cleanup the first block - should be prefectly diagonal.
!
  A(1:nPoints,1:nPoints)=0.0D0
  do i=1,nPoints
    A(i,i)=HTri(i*(i+1)/2)
  end do
#ifdef _DEBUGPRINT_
  Call RecPrt('U^TAU',' ',A,m_t,m_t)
#endif
!
! transform Kv to the new basis (y-F)
!
  Call mma_allocate(D,m_t,Label='D')
  D(:)=B(:)
  Kv=0.0D0
  Call dgemm_('T','N',m_t,1,m_t,      &
              1.0D0,UBIG,m_t,         &
                    D,m_t,            &
              0.0D0,Kv,m_t)
#ifdef _DEBUGPRINT_
  Call RecPrt('U^TKv',' ',Kv,1,m_t)
#endif
!
  Call mma_deallocate(HTri)
  Call mma_deAllocate(C)
  Call mma_deallocate(U)
#else
  Kv(:)=B(:)
  A(:,:)=full_r(:,:)
#endif
!
#ifdef _DEBUGPRINT_
  Call RecPrt('A',' ',A,m_t,m_t)
  Call RecPrt('Kv',' ',Kv,1,m_t)
#endif
#ifdef _DPOSV_
  CALL DPOSV_('U',m_t,1,A,m_t,Kv,m_t,INFO)
#else
  CALL DGESV_(m_t,1,A,m_t,IPIV,Kv,m_t,INFO)
#endif
#ifdef _PREDIAG_
#ifdef _DEBUGPRINT_
  Call RecPrt('(U^TAU)^{-1}U^TKv',' ',Kv,1,m_t)
#endif
  D(:)=Kv(:)
  Kv(:)=0.0D0
  Call DGEMM_('N','N',m_t,1,m_t,      &
              1.0D0,UBIG,m_t,         &
                    D,m_t,            &
              0.0D0,Kv,m_t)
!           Call RecPrt('Kv',' ',Kv,1,m_t)
  Call mma_deallocate(D)
  Call mma_deAllocate(UBIG)
#endif
!
!Likelihood function
  variance = dot_product(B,Kv)/dble(m_t)
  lh = variance*exp(detR/dble(m_t))
#ifdef _DEBUGPRINT_
  Write (6,*) 'Variance=',Variance
  Write (6,*) 'Info=',Info
  Call RecPrt('X=A^{-1}Kv','(5(E15.7,2X))',Kv,1,m_t)
#endif
!
  Call mma_Deallocate(B)
  Call mma_Deallocate(A)
  Call mma_Deallocate(IPIV)
END SUBROUTINE kriging_model

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ComputeIntegrals_uvJ_2P(AB,CD,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, September 2010.
C
C     Compute integrals of type (uv|J) where (uv| belongs to atom pair
C     AB and |J) belongs to atom pair CD.
C
      Implicit None
      Integer AB, CD
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "localdf_mem.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"
#include "ldf_atom_pair_info.fh"

      Character*27 SecNam
      Parameter (SecNam='LDF_ComputeIntegrals_uvJ_2P')

      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      Integer  LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nBasAux_Pair

      Integer l_xInt
      Integer M
      Integer dShell
      Integer A, B, C, D
      Integer iS, jS, iShell, jShell, nShell_A, nShell_B
      Integer ipA, ipB, ipC, ipD
      Integer n, ip0
      Integer nnShl, ijS
      Integer K, ij, ji, ij0, ji0
      Integer ip_SewWrk, l_SewWrk

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_2CFunctions
      Integer i2CList
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      i2CList(i,j)=iWork(ip_2CList-1+l_2CList_1*(j-1)+i)

      ! Set index arrays for auxiliary functions on atom pair CD
      Call LDF_SetIndxG(CD)

      ! Set dummy shell
      dShell=nShell_Valence+nShell_Auxiliary+1

      ! Get atoms of atom pairs
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      C=AP_Atoms(1,CD)
      D=AP_Atoms(2,CD)

      ! Set row dimension
      nRow_uvJ=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      ! Set column dimension
      M=LDF_nBasAux_Pair(CD)
      ! Set integral dimension
      l_xInt=nRow_uvJ*M
      ! Check integral array dimension
      If (l_xInt_.lt.l_xInt) Then
         Call WarningMessage(2,SecNam//': integral dimension problem')
         Write(6,'(A,I9,1X,I9)')
     &   'AB,CD...............',AB,CD
         Write(6,'(A,I9,1X,I9,1X,I9,1X,I9)')
     &   'A,B,C,D.............',A,B,C,D
         Write(6,'(A,I9,1X,I9)')
     &   'nRow_uvJ,M..........',nRow_uvJ,M
         Write(6,'(A,I9,1X,I9)')
     &   'nRow_uvJ*M,l_xInt_..',l_xInt,l_xInt_
         Call LDF_Quit(1)
      End If
      ! Init integral array
      Call FZero(xInt,l_xInt)

      ! Set number of shells on atoms A and B
      nShell_A=LDF_nShell_Atom(A)
      nShell_B=LDF_nShell_Atom(B)

      ! Allocate offset array for rows of (uv|J)
      l_iOff=nShell_A*nShell_B
      Call GetMem('iOff','Allo','Inte',ip_iOff,l_iOff)

      ! Set row offset array
      ipA=LDF_lShell_Atom(A)-1
      ipB=LDF_lShell_Atom(B)-1
      n=0
      Do jS=1,nShell_B
         jShell=iWork(ipB+jS)
         ip0=ip_iOff-1+nShell_A*(jS-1)
         Do iS=1,nShell_A
            iWork(ip0+iS)=n
            iShell=iWork(ipA+iS)
            n=n+nBasSh(iShell)*nBasSh(jShell)
         End Do
      End Do
#if defined (_DEBUGPRINT_)
      If (n.ne.nRow_uvJ) Then
         Call WarningMessage(2,SecNam//': row dimension problem!')
         Call LDF_Quit(1)
      End If
#endif

      ! Allocate memory for Seward
      Call GetMem('GetMax','Max ','Real',ip_SewWrk,l_SewWrk)
      l_SewWrk = min(l_SewWrk,MaxLDFSew)
      Call xSetMem_Ints(l_SewWrk)

      ! Compute integrals (uv|J)
      ipC=LDF_lAuxShell_Atom(C)-1
      Do iS=1,LDF_nAuxShell_Atom(C)
         iShell=iWork(ipC+iS)
         Call LDF_CI_uvJ(A,B,dShell,iShell,l_xInt,xInt)
      End Do
      If (D.ne.C) Then
         ipD=LDF_lAuxShell_Atom(D)-1
         Do jS=1,LDF_nAuxShell_Atom(D)
            jShell=iWork(ipD+jS)
            Call LDF_CI_uvJ(A,B,dShell,jShell,l_xInt,xInt)
         End Do
      End If
      If (AP_2CFunctions(1,CD).gt.0) Then
         nnShl=l_2CList_2
         Do ijS=1,nnShl
            iShell=i2CList(1,ijS)
            jShell=i2CList(2,ijS)
            SPAB=i2CList(3,ijS) ! SPAB stored in localdf_int.fh
            Call LDF_CI_uvJ(A,B,iShell,jShell,l_xInt,xInt)
         End Do
      End If

      ! Release Seward memory
      Call xRlsMem_Ints()

      ! Postprocessing for A=B:
      ! Only lower (block) triangle computed => transpose to get upper
      If (A.eq.B) Then
         ipA=LDF_lShell_Atom(A)-1
         ipB=ipA
         Do K=1,M
            ip0=nRow_uvJ*(K-1)
            Do jS=2,nShell_B
               jShell=iWork(ipB+jS)
               Do iS=1,jS-1
                  iShell=iWork(ipA+iS)
                  ij0=ip0+iWork(ip_iOff-1+nShell_A*(jS-1)+iS)
                  ji0=ip0+iWork(ip_iOff-1+nShell_B*(iS-1)+jS)
                  Do j=1,nBasSh(jShell)
                     Do i=1,nBasSh(iShell)
                        ij=ij0+nBasSh(iShell)*(j-1)+i
                        ji=ji0+nBasSh(jShell)*(i-1)+j
                        xInt(ij)=xInt(ji)
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End If

      ! Deallocate offset array for columns of (uv|J)
      Call GetMem('iOff','Free','Inte',ip_iOff,l_iOff)
      l_iOff=0
      ip_iOff=0
      nRow_uvJ=0
      iOffuv=0

      ! Unset index arrays for auxiliary functions on atom pair CD
      Call LDF_UnsetIndxG()

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
!-----------------------------------------------------------------------
!list of subroutines in this file
!      subroutine gugadrt_mole_inf()
!      subroutine gugadrt_paras_calculate()
!      subroutine arrange_orbital_molcas()
!      subroutine read_ref_state(nf)
!      subroutine gugadrt_active_drt()
!      subroutine gugadrt_ext_downwalk()
!      subroutine gugadrt_dbl_upwalk()
!      subroutine gugadrt_rst(id,nndd)
!      subroutine gugadrt_ref_gfs(nel,ndj,locu,nm)
!      subroutine gugadrt_rcas(id,indd)
!      subroutine gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
!      subroutine gugadrt_dbl_downwalk()
!      subroutine gugadrt_ajphy(jp,in,jpihy)
!      subroutine gugadrt_njexcit(indjk,ljk,iextbit,nextbit,ivalid,jstep,kttmp,
!      subroutine packnod(ibuf,idx,ival,nin,nbit,lbuf)
!      subroutine packnod4(ibuf,idx1,idx2,ival,nin1,nbit1,
!      subroutine upacknod(ibuf,idx,ival,nin,nbit,lbuf)
!      subroutine redabkm(iabkm,labkm,nabcbit,iabcbit,
!      subroutine wrtabkm(iabkm,labkm,nabcbit,iabcbit,
!-----------------------------------------------------------------------
      subroutine gugainit()
! default value for performing ci calculation
#include "gendrt.fh"
#include "files_gugadrt.fh"
      parameter (maxmolcasorb=5000)
      dimension ncone(64),nbas(mxsym),norb(mxsym),nfro(mxsym),
     *          ndel(mxsym)
      dimension idx_idisk(64)
      dimension cmo(max_orb**2)
      character bsbl(2*4*maxmolcasorb)*1
      dimension dum(1),idum(1)

      fnonemo="TRAONE"
      fndrt="CIDRT"
      fncimo="CIMO"
      luonemo=30
      ludrt=31
      lucimo=32

      call daname(lucimo,fncimo)
      call daname(ludrt,fndrt)
c      call molcas_open(ludrt,fndrt)
! open file traone to read orbital informations
      call daname(luonemo,fnonemo)
c      call molcas_open(luonemo,fnonemo)
      idisk=0
      call idafile(luonemo,2,ncone,64,idisk)
      call ddafile(luonemo,2,dum,1,idisk)
      ecor=dum(1)
      call idafile(luonemo,2,idum,1,idisk)
      nsym=idum(1)
      call idafile(luonemo,2,nbas,8,idisk)
      call idafile(luonemo,2,norb,8,idisk)
      call idafile(luonemo,2,nfro,8,idisk)
      call idafile(luonemo,2,ndel,8,idisk)
      lenrd=2*4*maxmolcasorb
      call cdafile(luonemo,2,bsbl,lenrd,idisk)
      nc=0
      do i=1,nsym
        nc=nc+nbas(i)**2
      enddo
      call ddafile(luonemo,2,cmo,nc,idisk)

      idx=0
      call idafile(lucimo,1,idx_idisk,64,idx)
      idx_idisk(2)=idx
      call cdafile(lucimo,1,bsbl,lenrd,idx)
      idx_idisk(3)=idx
      call ddafile(lucimo,1,cmo,nc,idx)
      idx_idisk(4)=idx
      idx=0
      call idafile(lucimo,1,idx_idisk,64,idx)

      call daclos(lucimo)
      call daclos(luonemo)
      nlsm_bas(1:8)=nbas(1:8)
      nlsmddel(1:8)=nfro(1:8)
      nlsmedel(1:8)=ndel(1:8)
c#ifdef debug
c      write(6,"(a4,1x,8(2x,i8))") "ncon",ncone(1:8)
c      write(6,*) "idisk : ", idisk
c      write(6,"(a4,1x,f18.9)") "ecor",ecor
c      write(6,"(a4,1x,i8)") "nsym",nsym
c      write(6,"(a4,1x,8(2x,i8))") "nbas",nbas(1:8)
c      write(6,"(a4,1x,8(2x,i8))") "norb",norb(1:8)
c      write(6,"(a4,1x,8(2x,i8))") "nfro",nfro(1:8)
c      write(6,"(a4,1x,8(2x,i8))") "ndel",ndel(1:8)

      ng_sm=nsym
      nlsm_all(1:8)=norb(1:8)
      mroot=1
      cm_cri=0.03

      return
c...end of subroutine gugadefault
      end

      subroutine gugadrt_mole_inf()
#include "gendrt.fh"
#include "files_gugadrt.fh"
#include "Sysdrt.fh"
!#ifndef _I8_
!      parameter (max_ref=64)
!#else
!      parameter (max_ref=128)
!#endif
      common /mcorb/ lsmorb(max_orb),noidx(8)
      common /refstate/ iref_occ(max_innorb,max_ref)
      dimension lsmtmp(maxgdm)
      logical log_debug
      dimension  itmpstr(72)
! copy from molcas, bsuo, jun. 30, 2009
      parameter ( ncmd=18 )
      parameter ( mxtit=10 )
      character*4 command,cmd(ncmd)
      character*72  line,title(mxtit)
      character*132 modline
      Data Cmd /'TITL','ELEC','SPIN','SYMM','ACTI',
     &          'PRIN','REFE','FIRS','INAC','CIAL',
     &          'VALE','INTE','NOCO','ONEO','EXTR',
     &          'NONI','NACT','END '/
*

      n_electron=0
      nactel=0
      spin=0.d0
      ns_sm=1
      call rdnlst(5,"GUGADRT")
      ntit=0
10    read(5,'(a)',end=991) line
      command=line(1:8)
      call upcase(command)
      if ( command(1:1).eq.'*' ) goto 10
      if (command.eq.' ') goto 10
      jcmd=0
      do icmd=1,ncmd
         if ( command.eq.cmd(icmd) ) jcmd=icmd
      end do
20    goto ( 100, 200, 300, 400, 500, 600, 700 ,800, 900,1000,
     &      1100,1200,1300,1400,1500,1600,1700,1800           ) jcmd
      write (6,*) 'input: illegal keyword'
      write (6,'(a,a)') 'command=',command
      call abend()
*
*---  process title    command ----------------------------------------*
 100  continue
      read(5,'(a)',end=991) line
      command=line(1:8)
      call upcase(command)
      if ( command(1:1).eq.'*' ) goto 100
      jcmd=0
      do icmd=1,ncmd
         if ( command.eq.cmd(icmd) ) jcmd=icmd
      end do
      if ( jcmd.ne.0 ) goto 20
      ntit=ntit+1
      if ( ntit.le.mxtit ) title(ntit)=line
      goto 100
*
*---  process electron command ----------------------------------------*
 200  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 200
      read(line,*,err=992) n_electron
      goto 10
*
*---  process spin     command ----------------------------------------*
 300  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 300
      read(line,*,err=992) ispin
      spin=(ispin-1)/2.d0
      goto 10
*
*---  process symmetry command ----------------------------------------*
 400  continue
!      write (6,*)'input_guga: keyword symmetry is obsolete and ignored!
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 400
      read(line,*,err=992) ns_sm
      goto 10
*
*---  process active   command ----------------------------------------*
 500  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 500
      modline=line//' 0 0 0 0 0 0 0 0'
      read(modline,*,err=992) (nlsm_act(i),i=1,8)
      goto 10
*
*---  process print    command ----------------------------------------*
 600  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 600
      read(line,*,err=992) iprint
      goto 10
*
*---  process referenc command ----------------------------------------*
 700  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 700
      read(line,*,err=992) n_ref,ln1
      if(n_ref.gt.max_ref) then
        write(6,*) " Warnning! Program could not deal with so much",
     *             " reference states!"
        write(6,*) " Maximum number of reference states is",max_ref
        write(6,*) " Set number of reference states into ",max_ref
        n_ref=max_ref
      endif
      if ( ln1.eq.0 ) then
        logic_mr=.true.
        goto 10
      endif
      do i=1,n_ref
        read(5,'(80i1)',end=991,err=992) iref_occ(1:ln1,i)
      enddo
      logic_mr=.true.
      goto 10
*
*---  process first    command ----------------------------------------*
 800  continue
      ifirst=1
      ilim=2
      goto 10
*
*---  process inactive command ----------------------------------------*
 900  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 900
      modline=line//' 0 0 0 0 0 0 0 0'
      read(modline,*,err=992) (nlsm_dbl(i),i=1,8)
      goto 10
*
*---  process ciall    command ----------------------------------------*
1000  continue
!      read(5,'(a)',end=991) line
!      if ( line(1:1).eq.'*' ) goto 1000
!      read(line,*,err=992) ns_sm
      logic_mrelcas=.true.
      goto 10
*
*---  process valence  command ----------------------------------------*
1100  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 1100
      modline=line//' 0 0 0 0 0 0 0 0'
      read(modline,*,err=992) (nlsm_ext(i),i=1,8)
      goto 10
*
*---  process interact command ----------------------------------------*
1200  continue
      intnum=1
      goto 10
*
*---  process nocorr   command ----------------------------------------*
1300  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 1300
      modline=line//' 0 0 0 0 0 0 0 0'
      read(modline,*,err=992)  !(ncor(i),i=1,8)
cbsuo, jun. 30, 2009 - neglect them
      goto 10
*
*---  process oneocc   command ----------------------------------------*
1400  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 1400
      modline=line//' 0 0 0 0 0 0 0 0'
      read(modline,*,err=992) ! (ione(i),i=1,8)
cbsuo, jun. 30, 2009 - neglect them
      goto 10
*
*---  process extract  command ----------------------------------------*
1500  write (6,*) 'input: extract option is redundant and is ignored!'
      goto 10
*
*---  process non-interact command -------------------------------------
1600  continue
      write (6,*) 'input: non-interact option is redundant and is',
     *            ' ignored!'
      intnum=0
      goto 10
*
*---  process nactel       command -------------------------------------
1700  continue
      read(5,'(a)',end=991) line
      if ( line(1:1).eq.'*' ) goto 200
      read(line,*,err=992) nactel
      goto 10
*
*---  the end of the input is reached, print the title ----------------*
1800  continue

c frozen orbital(dbl, ext) have been delete in mo trans step, so we negl
c here.
      nlsm_frz(1:ng_sm)=0

      norb_frz=0
      norb_act=0
      norb_dz=0
      norb_all=0
      do i=1,ng_sm
        norb_frz=norb_frz+nlsm_frz(i)
        norb_dbl=norb_dbl+nlsm_dbl(i)
        norb_act=norb_act+nlsm_act(i)
        nlsm_inn(i)=nlsm_frz(i)+nlsm_dbl(i)+nlsm_act(i)
        nlsm_ext(i)=nlsm_all(i)-nlsm_inn(i)
        norb_all=norb_all+nlsm_all(i)
      enddo
      norb_inn=norb_frz+norb_dbl+norb_act
      norb_ext=norb_all-norb_inn
      norb_dz=norb_dbl+norb_frz

      nstart_act=norb_dz+1
      ngw1(1)=0
      ngw2(1)=0
      ngw2(2)=0
      ngw3(1)=0
      ngw3(2)=0
      ngw3(3)=0
      do i=1,norb_all
        ngw2(i+2) = ngw2(i+1)+i
        ngw3(i+3) = ngw3(i+2)+ngw2(i+2)
        ngw4(i+4) = ngw4(i+3)+ngw3(i+3)
      enddo
      nabc=norb_ext-2+ngw2(norb_ext-1)+ngw3(norb_ext)

      iorb=0
      do i=1,ng_sm
        do j=1,nlsm_frz(i)
          iorb=iorb+1
          lsm_inn(iorb)=i
        enddo
      enddo
      do i=1,ng_sm
        do j=1,nlsm_dbl(i)
          iorb=iorb+1
          lsm_inn(iorb)=i
        enddo
      enddo
      do i=1,ng_sm
        do j=1,nlsm_act(i)
          iorb=iorb+1
          lsm_inn(iorb)=i
        enddo
      enddo

      nact_sm=1
      do im=1,norb_inn
        if(lsm_inn(im).gt.nact_sm) nact_sm=lsm_inn(im)
      enddo

      norb_all_tmp=0
      do ngsm=1,ng_sm
        norb_all_tmp=norb_all_tmp+nlsm_all(ngsm)
      enddo
      if(norb_all_tmp.ne.norb_all) then
        write(6,*)'  input num.of orbital err! check again!'
        call abend
!        stop 777
      endif

      do l=1,norb_inn
        lr=norb_all-l+1
        lsm(lr)=lsm_inn(l)
      enddo

      lr=0
      int_dd_offset(1:8,1:8)=0
      do im=1,ng_sm
        im_lr_sta=0
        do iml=1,ng_sm
          imr=mul_tab(im,iml)
          if ( imr .gt. iml ) cycle
          int_dd_offset(iml,imr)=im_lr_sta
          int_dd_offset(imr,iml)=im_lr_sta
          if(iml.eq.imr)im_lr_sta=im_lr_sta+
     :           nlsm_ext(iml)*(nlsm_ext(iml)-1)/2
          if(iml.ne.imr)im_lr_sta=im_lr_sta+
     :           nlsm_ext(iml)*nlsm_ext(imr)
        enddo
        do l=1,nlsm_ext(im)
          lr=lr+1
          lsm(lr)=im
        enddo
      enddo
      lsm_inn(norb_inn+1)=lsm(norb_ext)

      lsmtmp(1:8)=0
      if (logic_mr) then
        do i=1,n_ref
          itmpstr(1:norb_act)=iref_occ(1:norb_act,i)
          do j=1,norb_dz
             iref_occ(j,i)=2
          enddo
          iref_occ(norb_dz+1:norb_dz+norb_act,i)=itmpstr(1:norb_act)
        enddo
      endif

      do i=1,ng_sm   !norb_inn
         lsmtmp(i)=0
      enddo
      do i=1,norb_inn
         lsmtmp(lsm_inn(i))=lsmtmp(lsm_inn(i))+1
      enddo

      itmp=0
      do i=1,ng_sm
         ibsm_ext(i)=itmp+1
         itmp=itmp+nlsm_ext(i)
         iesm_ext(i)=itmp
      enddo
!============ chck input data block ====================
      if(norb_frz.gt.norb_dz) then
        write(6,*)' check input data: norb_frz  error'
        call abend
!        stop 777
      endif
! check number of electrons
      if(nactel.ne.0) then
        if(n_electron.ne.0) then
          ne_act=n_electron-2*norb_dz
          if(nactel.ne.ne_act) then
            write(6,*) "Input error, Error in checking ELECtron",
     &                 " and NACTel!"
            call abend
          endif
        else
          ne_act=nactel
          n_electron=2*norb_dz+nactel
        endif
      else
        if(n_electron.ne.0) then
          ne_act=n_electron-2*norb_dz
          nactel=ne_act
        else
          ne_act=0
          write(6,*) "Input error, you must input ELECtron or NACTel!"
          call abend
        endif
      endif
      nde=2*norb_dz
      if(nde.gt.n_electron) then
        write(6,"(1x,42a)") 'check input date: number of elctrons error'
        write(6,"(1x,a20,1x,i4)") 'number of electrons ',n_electron
        write(6,"(1x,a36,1x,i4)") "number of doubly occupied electrons "
     *          ,nde
        call abend
!       stop 777
      endif

      norb1=norb_inn+norb_ext
      norb2=0
      do i=1,ng_sm
        norb2=norb2+nlsm_all(i)
      enddo
      if(norb1.ne.norb2) then
        write(6,*)' check input data: orb_number error'
        write(6,*) norb1,norb2
        call abend
!        stop 777
      endif

      if ( logic_mr) then
        write(6,*) " Refrence states"
!        ne_act=n_electron-2*norb_dz
        do i=1,n_ref
          write(6,"(80i1)") iref_occ(1:norb_inn,i)
          ms_ref=1
          neact=0
          do j=norb_dz+1,norb_inn
            if(iref_occ(j,i).eq.1) ms_ref=mul_tab(ms_ref,lsm_inn(j))
            if(iref_occ(j,i).eq.1) neact=neact+1
            if(iref_occ(j,i).eq.2) neact=neact+2
          enddo
          if(ms_ref.ne.ns_sm.or.neact.ne.ne_act) then
            write(6,*)'  input ref_conf  err! check again! ',i
            call abend
!           stop 777
          endif
        enddo
      endif
!============ block end =============================
c****************************************************
      log_debug=.false.
      if(log_debug) then
        write(6,1001)
        write(6,1002) norb_all,norb_frz,norb_dz,norb_inn,norb_ext
        write(6,1002) nlsm_all(1:ng_sm)
        write(6,1002) nlsm_frz(1:ng_sm)
        write(6,1002) nlsm_dbl(1:ng_sm)
        write(6,1002) nlsm_inn(1:ng_sm)
        write(6,*) "lsm inn"
        write(6,1002) lsm_inn(1:norb_inn)
        write(6,*) "lsm all",norb_all
        write(6,1002) (lsm(i),i=norb_all,1,-1)
      endif
c*****************************************************

! merge into molcas
c write date into cidrt for ci calculation
      noidx=0
      idisk=0
      call idafile(ludrt,1,noidx,2,idisk)
! group symmetry
      call idafile(ludrt,1,[ng_sm],1,idisk)
! state symmetry
      call idafile(ludrt,1,[ns_sm],1,idisk)
! number of roots to be cal
      call idafile(ludrt,1,[mroot],1,idisk)
! number of corelation electrons
      call idafile(ludrt,1,[n_electron],1,idisk)
! number of active electrons
      call idafile(ludrt,1,[nactel],1,idisk)
! spin symmetry of the state, 2s+1
      call idafile(ludrt,1,[ispin],1,idisk)
! dbl orb
      call idafile(ludrt,1,nlsm_dbl,8,idisk)
! act orb
      call idafile(ludrt,1,nlsm_act,8,idisk)
! all correlated orb
      call idafile(ludrt,1,nlsm_all,8,idisk)
! num. basis
      call idafile(ludrt,1,nlsm_bas,8,idisk)
! method to choose ref. state, 4 for cas, 2 for rst
      if(logic_mr) then
        call idafile(ludrt,1,[2],1,idisk)
        call idafile(ludrt,1,[n_ref],1,idisk)
! reference states
!       iref_occ(norb_dz+1:norb_dz+norb_act,i)=itmpstr(1:norb_act)
        do i=1,n_ref
           call idafile(ludrt,1,iref_occ(1,i),norb_inn,idisk)
        enddo
      endif
      if(logic_mrelcas) then
        call idafile(ludrt,1,[4],1,idisk)
      endif
! number of ref. states, if logic_mr = .true.
      noidx(2)=idisk
      idisk=0
      call idafile(ludrt,1,noidx,2,idisk)
      noidx=0
      do i=1,ng_sm
        noidx(i)=i
      enddo
      mul=nint(2*spin)+1
      write(6,*)'-----------------------------------------------'
      write(6,*)'    ci orbitals information'
      ndisk=0
      do i=1,8
        ndisk=ndisk+nlsm_bas(i)
      enddo
      write(6,*)'    num. of basis:          ',ndisk
      write(6,*)'    num. of orbitals:       ',norb_all
      write(6,*)'    num. of active-orbitals:',norb_act
      write(6,*)'    num. of electrons:      ',n_electron
      write(6,*)'    multiplicity:           ',mul
      write(6,*)'    symmetry:               ',ns_sm
      write(6,*)
      write(6,*)'    oribtials per-symmtry'
      write(6,1003) noidx(1:ng_sm)
      write(6,1004) nlsmddel(1:ng_sm)
      write(6,1005) nlsm_dbl(1:ng_sm)
      write(6,1006) nlsm_act(1:ng_sm)
      write(6,1007) nlsm_ext(1:ng_sm)
      write(6,1008) nlsmedel(1:ng_sm)
      write(6,*)'-----------------------------------------------'

      return
! following information will be drts
! notice we do not close file ludrt here, it will be close after drt
! information is written into this file
!      print*, "in subroutine gugadrt_mole_inf"
!      stop 1000
!---------------------------------------------------------------------
991   write (6,*) 'input: end of input file encountered'
      write (6,'(a,a)') 'last command: ',command
      call abend()
992   write (6,*) 'input: error while reading input!'
      write (6,'(a,a)') 'last command: ',command
      call abend()
1001  format(1x,"norb all group sm")
1002  format(8(1x,i3))
1003  format(16x,8(i4))
1004  format(8x,"frozen  ",8(i4))
1005  format(8x,"double  ",8(i4))
1006  format(8x,"active  ",8(i4))
1007  format(8x,"virtual ",8(i4))
1008  format(8x,"frz ext ",8(i4))
      end

      subroutine gugadrt_paras_calculate()
#include "gendrt.fh"
!      include "paraconstants_h.for"
!      include "intsort_h.for"
c      data inlptb_new/
!         1  2  3  4  5  6  7  8  9  10  11  12 13
c a^r=1
c     *    -1, 0, 0, 0, 0, 0,-7, 0,-9,-10,  0,-12, 0,
c a^l=2
c     *     0, 0, 0, 0, 0,-6, 0,-8, 0,  0,-11,  0, 0,
c b_r=3
c     *    4, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0, 0,
c b_l=4
c     *    5, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0, 0,
c b^r=5
c     *    0, 7, 8,10,11, 0, 0, 0, 0,  0,  0,  0, 0,
c b^l=6
c     *    0, 0, 9, 0,12, 0, 0, 0, 0,  0,  0,  0, 9,
c c^'=7
c     *    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 3,
c c^"=8
c     *    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12,13,
c d_l^r=9
c     *    6, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0, 0,
c d^r^r=10
c     *    0,-2, 0,-4, 0, 0, 0, 0, 0,  0,  0,  0, 0,
c d^r^l=11
c     *    0, 0,-3, 0,-5, 0, 0, 0, 0,  0,  0,  0, 0,
c c^'" =12
c     *    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 0/
!
!****************************************************************
!   ar      =1 (+a^r)     drr     =2 (+d^rr)   drl     =3 (+d^rl)
!   arbr    =4 (+d^rr)    arbl    =5 (+d^rl)   ard_l^r =6 (+a^l)
!   drrb^r  =7 (+a^r)     drlb^r  =8 (+a^l)    drlb^l  =9 (+a^r)
!   arbrb^r =10 (+a^r)    arblb^r =11 (+a^l)   arblb^l =12 (+a^r)
!   drl     =13 (*)
!****************************************************************

!     data inlptb_new
!    */ -1,  0,  4,  5,  0,  0,  1,  1,  6,  0,  0,  1,
!    *   0,  0,  0,  0,  7,  0,  2,  2,  0, -2,  0,  2,
!    *   0,  0,  0,  0,  8,  9,  3,  3,  0,  0, -3,  3,
!    *   0,  0,  0,  0, 10,  0,  4,  4,  0, -4,  0,  4,
!    *   0,  0,  0,  0, 11, 12,  5,  5,  0,  0, -5,  5,
!    *   0, -6,  0,  0,  0,  0,  6,  6,  0,  0,  0,  6,
!    *  -7,  0,  0,  0,  0,  0,  7,  7,  0,  0,  0,  7,
!    *   0, -8,  0,  0,  0,  0,  8,  8,  0,  0,  0,  8,
!    *  -9,  0,  0,  0,  0,  0,  9,  9,  0,  0,  0,  9,
!    * -10,  0,  0,  0,  0,  0, 10, 10,  0,  0,  0, 10,
!    *   0,-11,  0,  0,  0,  0, 11, 11,  0,  0,  0, 11,
!    * -12,  0,  0,  0,  0,  0, 12, 12,  0,  0,  0, 12,
!    *   0,  0,  0,  0,  0,  9,  3, 13,  0,  0,  0,  0/

!     data indord_plptype/0,0,0,1,1,3,3,1,1,2,2,2/   !severe_new_error_1
      ja_sys=int(n_electron*0.5d0-spin)-norb_dz
      jb_sys=int(spin+spin)
      jc_sys=norb_all-ja_sys-jb_sys
      jsm_sys=ns_sm

      if ( jb_sys .eq.0 ) jroute_sys=1
      if ( jb_sys .eq.1 ) jroute_sys=2
      if ( jb_sys .gt.1 ) jroute_sys=3

      return
      end

c****************************************************
      subroutine arrange_orbital_molcas()
c****************************************************
c  arrange orbital for ci calculation, in meld and
c  molcas program, the orbital are arranged as the symmetry
c  block. we transfer them to ci order
c -----
c map_order_orbital    ab ---> ci
c
#include "gendrt.fh"
!      include "intsort_h.for"
      common /mcorb/ lsmorb(max_orb),noidx(8)
      dimension lsmorbcount(ng_sm),map_tmp(max_orb)
      logical logi_norb_inn(norb_all)

      logi_norb_inn(1:norb_all)=.false.
      iorb=norb_all
      do la=1,norb_all
         norb_number(la)=iorb
         iorb=iorb-1
      enddo

      nim=0
      lsmorbcount(1)=nim
      do im=2,ng_sm
        nim=nim+nlsm_all(im-1)
        lsmorbcount(im)=nim
      enddo

      if ( logic_assign_actorb ) then
        do lr=1,norb_inn
          lr_scf=map_orb_order(lr)
          logi_norb_inn(lr_scf)=.true.
        enddo
        goto 200
      else
        do lr=1,norb_inn
          lsmr=lsm_inn(lr)
          lsmorbcount(lsmr)=lsmorbcount(lsmr)+1
          lr_scf=lsmorbcount(lsmr)
          map_orb_order(lr)=lr_scf
          logi_norb_inn(lr_scf)=.true.
        enddo
      endif
200   lr_scf0=norb_all
      la=norb_inn+1
      do ms=ng_sm,1,-1
        lr_scf0=lr_scf0-nlsm_all(ms)
        lr_scf=lr_scf0
        do lra=1,nlsm_all(ms)
          lr_scf=lr_scf+1
          if(logi_norb_inn(lr_scf)) cycle
          map_orb_order(la)=lr_scf
          la=la+1
        enddo
      enddo

      isum2=0
      isum3=0
      do i=1,ng_sm
        jp2(i)=isum2
        isum2=isum2+i
        jp3(i)=isum3
        isum3=isum3+isum2
      enddo

      iccount=1
      do lrd = 1,norb_inn
!        ipwt(lrd) = iccount
        iccount   = iccount+2
      enddo
      lsmorbcount =0
      do lrd=norb_dz,1,-1
        lsmid=lsm_inn(lrd)
        lsmorbcount(lsmid)=lsmorbcount(lsmid)+1
!        ipws(lrd)=(lsmorbcount(lsmid)-1)*3+1
      enddo

      map_tmp(1:norb_all)=map_orb_order(1:norb_all)
      do 40 i=1,norb_all
        do j=1,norb_all
          if(map_tmp(j).eq.i) then
            map_orb_order(i)=j
            goto 40
          endif
        enddo
40    continue

c      write(6,*) "map_order_orbit"
c      write(6,1001) map_orb_order(1:norb_all)
      return
c1001  format(20(1x,i3))
c...end of arrange_orbital_molcas
      end

      subroutine gugadrt_active_drt()
#include "gendrt.fh"
      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
     :    ,jv,jd(8),jt(8),js(8)
      dimension iin(0:max_node)
      nci_dim=0
      if(norb_act.ne.0) goto 100
!====================  norb_act=0 ========================
      iseg_sta(1)=0
      iseg_dim(1)=1
      do im=1,ng_sm
        jdim=nu_ae(1+im)
        jtim=nu_ae(9+im)
        jsim=nu_ae(17+im)
        jd(im)=jdim
        jt(im)=jtim
        js(im)=jsim
        iseg_dim(jdim)=iseg_downwei(jdim)*jpad_upwei(jdim)
        iseg_dim(jtim)=iseg_downwei(jtim)*jpad_upwei(jtim)
        iseg_dim(jsim)=iseg_downwei(jsim)*jpad_upwei(jsim)
        if(iseg_dim(jdim).eq.0) then
          jd(im)=0
          nu_ad(jdim)=0
          nu_ae(jdim)=0
        endif
        if(iseg_dim(jtim).eq.0) then
          jt(im)=0
          nu_ad(jtim)=0
          nu_ae(jtim)=0
        endif
        if(iseg_dim(jsim).eq.0) then
          js(im)=0
          nu_ad(jsim)=0
          nu_ae(jsim)=0
        endif
      enddo
      do jp=2,25
        iseg_sta(jp)=iseg_sta(jp-1)+iseg_dim(jp-1)
        enddo
      nci_dim=iseg_sta(25)+iseg_dim(25)
      iseg_sta(26)=nci_dim
      do jp=1,25
        if(iseg_downwei(jp).eq.0) cycle
        iseg_upwei(jp)=iseg_dim(jp)/iseg_downwei(jp)
      enddo
      goto 200
!====================  norb_act<>0 ========================
100   if(logic_mr)  call gugadrt_rst(ndd,indd)
      if(logic_mrelcas) call gugadrt_rcas(ndd,indd)   !npp=3

      nu_ae(1)=jv
      do im=1,ng_sm
        nu_ae(1+im)=jd(im)
        nu_ae(9+im)=jt(im)
        nu_ae(17+im)=js(im)
      enddo
      jds=1
      jde=mxnode
      jps=no(norb_inn)+1
      jpe=no(norb_inn+1)

      iin(1:max_node)=0
      jp=jv
      iin(1:jpe)=0
      iin(0)=0
      iin(jp)=1
      iseg_sta(1)=0       ! for node_ext
      iseg_dim(1)=0
      do jpn=jpe,1,-1
        do i=1,4
          jji=jj(i,jpn)
          if(iin(jji).eq.0) cycle
          iin(jpn)=iin(jpn)+iin(jji)
        enddo
      enddo

      do jdn=jds,jde
        if(nu_ad(jdn).eq.0) cycle
        ndi=iin(jdn)*iseg_downwei(1)*jpad_upwei(jdn)
        iseg_dim(1)=iseg_dim(1)+ndi
      enddo

      do im=1,ng_sm
        jp=jd(im)
        iseg_sta(1+im)=nci_dim       ! for node_d_ext
        iseg_dim(1+im)=0
        if(jp.eq.0) cycle
        iin(1:jpe)=0
        iin(0)=0
        iin(jp)=1
        do jpn=jpe,1,-1
          do i=1,4
            jji=jj(i,jpn)
            if(iin(jji).eq.0) cycle
            iin(jpn)=iin(jpn)+iin(jji)
          enddo
        enddo
        do jdn=jds,jde
          if(nu_ad(jdn).eq.0) cycle
          ndi=iin(jdn)*iseg_downwei(1+im)*jpad_upwei(jdn)
          iseg_dim(1+im)=iseg_dim(1+im)+ndi
        enddo
      enddo


      do im=1,ng_sm
        jp=jt(im)
        iseg_sta(9+im)=nci_dim       ! for node_t_ext
        iseg_dim(9+im)=0
        if(jp.eq.0) cycle
        iin(1:jpe)=0
        iin(0)=0
        iin(jp)=1
        do jpn=jpe,1,-1
          do i=1,4
            jji=jj(i,jpn)
            if(iin(jji).eq.0) cycle
            iin(jpn)=iin(jpn)+iin(jji)
          enddo
        enddo
        do jdn=jds,jde
          if(nu_ad(jdn).eq.0) cycle
          ndi=iin(jdn)*iseg_downwei(9+im)*jpad_upwei(jdn)
          iseg_dim(9+im)=iseg_dim(9+im)+ndi
        enddo
      enddo
      do im=1,ng_sm
        jp=js(im)
        iseg_sta(17+im)=nci_dim       ! for node_s_ext
        iseg_dim(17+im)=0
        if(jp.eq.0) cycle
        iin(1:jpe)=0
        iin(0)=0
        iin(jp)=1
        do jpn=jpe,1,-1
          do i=1,4
            jji=jj(i,jpn)
            if(iin(jji).eq.0) cycle
            iin(jpn)=iin(jpn)+iin(jji)
          enddo
        enddo
        do jdn=jds,jde
          if(nu_ad(jdn).eq.0) cycle
          ndi=iin(jdn)*iseg_downwei(17+im)*jpad_upwei(jdn)
          iseg_dim(17+im)=iseg_dim(17+im)+ndi
        enddo
      enddo
      do jp=2,25
        iseg_sta(jp)=iseg_sta(jp-1)+iseg_dim(jp-1)
      enddo
      nci_dim=iseg_sta(25)+iseg_dim(25)
      iseg_sta(26)=nci_dim
      do jp=1,25
        if(iseg_downwei(jp).eq.0) cycle
        iseg_upwei(jp)=iseg_dim(jp)/iseg_downwei(jp)
      enddo
! to the end of dbl,act,ext parts
200   call gugadrt_dbl_downwalk()
c      write(6,*)'  end of drt,nci_dim= ',nci_dim
c      write(6,*)'number of cfss: ',nci_dim
      mul=nint(2*spin)+1
      write(6,*)
      write(6,*)'-----------------------------------------------'
      write(6,*)'    csf information'
      write(6,*)'    num. of configurations:        ',nci_dim
      ndim=iseg_dim(1)
      write(6,*)'    num. of valence states:        ',ndim
      ndim=0
      do i=2,9
        ndim=ndim+iseg_dim(i)
      enddo
      write(6,"(5x,a32,1x,i12)")'num. of doublet couple singles: ',ndim
      ndim=0
      do i=10,17
        ndim=ndim+iseg_dim(i)
      enddo
      write(6,"(5x,a32,1x,i12)")'num. of triplet couple doubles: ',ndim
       ndim=0
      do i=18,25
        ndim=ndim+iseg_dim(i)
      enddo
      write(6,"(5x,a32,1x,i12)")'num. of singlet couple doubles: ',ndim

      write(6,*)'-----------------------------------------------'
      return
      end

      subroutine gugadrt_ext_downwalk()
#include "gendrt.fh"
      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
     :    ,jv,jd(8),jt(8),js(8)
      dimension iwmij(8)
      nu_ae(1)=1
      do im=1,ng_sm
        nu_ae(1+im)=1+im
        nu_ae(9+im)=9+im
        nu_ae(17+im)=17+im
      enddo

      iwmij=0
      iseg_downwei(nu_ae(1))=1
      do imi=1,ng_sm
        iseg_downwei(nu_ae(1+imi))=nlsm_ext(imi)
        do imj=imi,ng_sm
          imij=mul_tab(imi,imj)
          if(imij.ne.1) then
           iwmij(imij)=iwmij(imij)+nlsm_ext(imi)*nlsm_ext(imj)
             cycle
          endif
         iwmij(1)=iwmij(1)+nlsm_ext(imi)*(nlsm_ext(imi)-1)/2
        enddo
      enddo
      do im=1,ng_sm
        iseg_downwei(nu_ae(9+im))=iwmij(im)
        iseg_downwei(nu_ae(17+im))=iwmij(im)
      enddo
      iseg_downwei(nu_ae(18))=iseg_downwei(nu_ae(18))+norb_ext
      return
      end

      subroutine gugadrt_dbl_upwalk()
#include "gendrt.fh"
      if(norb_dbl.eq.1) then
c     v(1),d(2-9),s(18-25)           for s=0
c     v(1),d(2-9),s(18-25),d'(26-33)   for s<>0

        mxnode=17+ng_sm
        lri=norb_frz+1
        lsmi=lsm_inn(lri)
        lsmid=mul_tab(lsmi,ns_sm)
!for node_v
        nu_ad(1)=1
        jpad_upwei(1)=1
!for node_d
        nu_ad(1+lsmid)=1+lsmid
        jpad_upwei(1+lsmid)=1
!for node_s
        nu_ad(17+ns_sm)=17+ns_sm
        jpad_upwei(17+ns_sm)=1

        if(jroute_sys.eq.1) return
        mxnode=25+ng_sm
!for node_d'
        nu_ad(25+lsmid)=25+lsmid
        jpad_upwei(25+lsmid)=1
        return
      endif
      nu_ad=0
      jpad_upwei=0

      nu_ad(1)=1
      jpad_upwei(1)=1
      if(norb_dbl.eq.0) then
        mxnode=1
        return
      endif
      do lri=norb_frz+1,norb_dz
        lsmi=lsm_inn(lri)
        lsmid=mul_tab(lsmi,ns_sm)
        no_d=lsmid+1
        jpad_upwei(no_d)=jpad_upwei(no_d)+1
        do lrj=lri+1,norb_dz
          lsmj=lsm_inn(lrj)
           lsmij=mul_tab(lsmi,lsmj)
          lsmit=mul_tab(lsmij,ns_sm)
          no_t =lsmit+9
          jpad_upwei(no_t)=jpad_upwei(no_t)+1
        enddo
      enddo
c     v(1),d(2-9),t(10-17),s(18-25),d'(26-33),t'(34-41)
      select case (jroute_sys)
        case(1)
          goto 100
        case(2)
          goto 200
        case(3)
          goto 300
      end select
100     mxnode=25                     !v,d,t,s
        jpad_upwei(18:25)=jpad_upwei(10:17)
        jpad_upwei(17+ns_sm)=jpad_upwei(17+ns_sm)+norb_dbl
        goto 500
200     mxnode=25+8
        jpad_upwei(18:25)=jpad_upwei(10:17)+jpad_upwei(10:17)
        jpad_upwei(17+ns_sm)=jpad_upwei(17+ns_sm)+norb_dbl
        jpad_upwei(26:33)=jpad_upwei(2:9)
        goto 500
300     mxnode=25+8+8
        jpad_upwei(18:25)=jpad_upwei(10:17)+jpad_upwei(10:17)
        jpad_upwei(17+ns_sm)=jpad_upwei(17+ns_sm)+norb_dbl
        jpad_upwei(26:33)=jpad_upwei(2:9)
        jpad_upwei(34:41)=jpad_upwei(10:17)

500   do node=2,mxnode
        iw=jpad_upwei(node)
        if(iw.eq.0) cycle
        nu_ad(node)=node
      enddo
      return
      end

c*******************************************
      subroutine gugadrt_rst(id,nndd)
c*******************************************
c 10 may 2007 - revised by wyb
c
#include "gendrt.fh"
#include "Sysdrt.fh"
!#ifndef _I8_
!      parameter (iintbit=32,n32int=4,n16int=2)
!#else
!      parameter (iintbit=64,n32int=2,n16int=1)
!#endif
      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
     :    ,jv,jd(8),jt(8),js(8)
      common/ref/ndj,ndjgrop,ndjmod
      integer, pointer :: jabkm(:,:)
      integer, pointer :: ind(:,:)
      integer, pointer :: idjj(:,:)
      integer, pointer :: iwy(:,:)
      integer, pointer :: itm(:)
      dimension noh(max_innorb)
      dimension iextjj(n32int),iextii(n32int),jjabkm(1:n16int),
     *          jkabkm(1:n16int),iiabkm(1:n16int)
! estimate memory
      if(n_ref.gt.20) then
        if(norb_act.ge.10) then
          if(iintbit.eq.32) mxtnode=1000000
          if(iintbit.eq.64) mxtnode=10000000
        else
          mxtnode=1000000
        endif
      else
        if(norb_act.gt.10) then
          mxtnode=1000000
        else
          mxtnode=500000
        endif
      endif
      write(6,*)
      write(6,*) ' now generate distinct row tableau'
      allocate(jabkm(n16int,mxtnode))
      allocate(ind(n32int,0:mxtnode))
      allocate(idjj(4,0:mxtnode))
      allocate(iwy(4,0:mxtnode))
      allocate(itm(0:mxtnode))

      nel =n_electron
      nz  =ng_sm
      nm  =ns_sm
      ndj =n_ref
      no(1:norb_dz+1)=0
      jabkm(1:n16int,1:mxtnode)=0
      ind(1:n32int,0:mxtnode)=0
      idjj(1:4,0:mxtnode)=0
      iwy=0
      itm=0
      nrefbit=n32int
      jj(1:4,0:max_node)=0

c 8 bits
      iextbit=2
      nextbit=iintbit/iextbit
c 16 bits
      iabcbit=16
      nabcbit=iintbit/iabcbit
c 32 bits
      inodbit=32
      nnodbit=iintbit/inodbit

c v node
      j=0
      ja0=ja_sys
      jb0=jb_sys
      jc0=jc_sys
      write(6,"(4(1x,i4))") ja0,jb0,jc0
      kcm=min(ja0,jc0)
      kd=(ja0+1)*(jc0+1)*int(jb0+0.5d0*kcm+1)-kcm*(kcm+1)*(kcm+2)/6
!  v_node
      ja(1)=ja0
      jb(1)=jb0
      jm(1)=nm
      kk(1)=norb_dz
      jaj=ja(1)
      jbj=jb(1)
      jmj=jm(1)
      kkj=kk(1)

      jjabkm(1:n16int)=0
      call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
      jabkm(1:n16int,1)=jjabkm(1:n16int)
      ind(1:nrefbit,1)=0

!  d_node
      imd=0
      do node=2,9
        imd=imd+1
        if(nu_ad(node).eq.0) cycle
        ja(node)=ja(1)
        jb(node)=jb0+1
        jm(node)=imd
        kk(node)=norb_dz
        jaj=ja(node)
        jbj=jb(node)
        jmj=jm(node)
        kkj=kk(node)

        jjabkm(1:n16int)=0
        call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
        jabkm(1:n16int,node)=jjabkm(1:n16int)
        ind(1:nrefbit,node)=0
      enddo

!  t_node
      imt=0
      do node=10,17
        imt=imt+1
        if(nu_ad(node).eq.0) cycle
        ja(node)=ja(1)
        jb(node)=jb0+2
        jm(node)=imt
        kk(node)=norb_dz
        jaj=ja(node)
        jbj=jb(node)
        jmj=jm(node)
        kkj=kk(node)

        jjabkm(1:n16int)=0
        call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
        jabkm(1:n16int,node)=jjabkm(1:n16int)
        ind(1:nrefbit,node)=0
      enddo
!  s_node
      ims=0
      do node=18,25
        ims=ims+1
        if(nu_ad(node).eq.0) cycle
        ja(node)=ja(1)+1
        jb(node)=jb0
        jm(node)=ims
        kk(node)=norb_dz
        jaj=ja(node)
        jbj=jb(node)
        jmj=jm(node)
        kkj=kk(node)
        jjabkm(1:n16int)=0
        call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
        jabkm(1:n16int,node)=jjabkm(1:n16int)
        ind(1:nrefbit,node)=0
      enddo
      if(jroute_sys.gt.1) then
!  d'_node
        imd=0
        do node=26,33
          imd=imd+1
          if(nu_ad(node).eq.0) cycle
          ja(node)=ja(1)+1
          jb(node)=jb0-1
          jm(node)=imd
          kk(node)=norb_dz
          jaj=ja(node)
          jbj=jb(node)
          jmj=jm(node)
          kkj=kk(node)
          jjabkm(1:n16int)=0
          call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
          jabkm(1:n16int,node)=jjabkm(1:n16int)
          ind(1:nrefbit,node)=0
        enddo
      endif
      if(jroute_sys.gt.2) then
!  t'_node
        imt=0
        do node=34,41
          imt=imt+1
          if(nu_ad(node).eq.0) cycle
          ja(node)=ja(1)+2
          jb(node)=jb0-2
          jm(node)=imt
          kk(node)=norb_dz
          jaj=ja(node)
          jbj=jb(node)
          jmj=jm(node)
          kkj=kk(node)
          jjabkm(1:n16int)=0
          call wrtabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
          jabkm(1:n16int,node)=jjabkm(1:n16int)
          ind(1:nrefbit,node)=0
        enddo
      endif
      no(norb_dz)=mxnode

      j=0
      jk=mxnode
      kk(jk)=norb_dz
c      call packnod(idkk,jk,norb_dz,nabcbit,iabcbit,mxtnode)

c**********************************************************************
c
7     j=j+1
      if(j.le.mxnode) then
        if(nu_ad(j).eq.0) goto 7
      endif
      if(j.lt.mxnode) then
        jaj=ja(j)
        jbj=jb(j)
        jmj=jm(j)
        kkj=kk(j)
        k0=kkj
      else
        jjabkm(1:n16int)=jabkm(1:n16int,j)
        call redabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
        k0=kkj
      endif
      jkabkm(1:n16int)=jabkm(1:n16int,jk)
      call redabkm(jkabkm,n16int,nabcbit,iabcbit,jajk,jbjk,jmjk,kkjk)
      if(kkjk.ne.k0+1) no(k0)=jk
      jk=jk+1

      if(jk.gt.mxtnode) then
        write(6,*) ' the number of j exceeds max_node',mxtnode
        call abend
!       stop 777
!        call errexit(777)
      endif
c =========================================================
c                                            ***********
c                                            *   d=0   *
c                                            ***********

      jatmp=jaj
      jbtmp=jbj
      jmtmp=jmj
      kktmp=kkj+1


      iextjj(1:nrefbit)=ind(1:nrefbit,j)
      call gugadrt_njexcit(iextjj,nrefbit,iextbit,nextbit,ivalid,
     *                      0,kttmp,k0)
      if(ivalid.eq.0) then
        jk=jk-1
        goto 11
      endif

      if(k0.eq.norb_inn-1) then
!  act||ext
        if((jatmp.eq.1.or.jbtmp.eq.2).and.kttmp.ne.0) then
          jk=jk-1
          goto 11
        endif
        if(jbtmp.eq.1.and.kttmp.eq.2) then
          jk=jk-1
          goto 11
        endif
      end if

      call wrtabkm(jkabkm,n16int,nabcbit,iabcbit,jatmp,jbtmp,
     *             jmtmp,kktmp)
      do 18 ii=no(k0)+1,jk-1
        iiabkm(1:n16int)=jabkm(1:n16int,ii)
        do i=1,n16int
          if(iiabkm(i).ne.jkabkm(i)) goto 18
        enddo
        if(k0.eq.norb_inn-1) goto 601
        iextii(1:nrefbit)=ind(1:nrefbit,ii)
        do i=1,nrefbit
          if(iextii(i).ne.iextjj(i)) goto 18
        enddo
601     jk=jk-1
        idjj(1,j)=ii
        goto 11
18    continue

      ind(1:nrefbit,jk)=iextjj(1:nrefbit)
      idjj(1,j)=jk
      jabkm(1:n16int,jk)=jkabkm(1:n16int)

      iiabkm(1:n16int)=jabkm(1:n16int,jk-1)
      call upacknod(iiabkm,4,kj1,nabcbit,iabcbit,n16int)
      if(kktmp.ne.kj1) no(k0)=jk-1

11    continue
c =========================================================
      if(jbj.eq.0) goto 2
      jk=jk+1
c                                            ***********
c                                            *   d=1   *
c                                            ***********
      jatmp=jaj
      jbtmp=jbj-1
      jmtmp=mul_tab(lsm_inn(k0+1),jmj)
      kktmp=kkj+1

      iextjj(1:nrefbit)=ind(1:nrefbit,j)
      call gugadrt_njexcit(iextjj,nrefbit,iextbit,nextbit,ivalid,
     *                     1,kttmp,k0)

      if(ivalid.eq.0) then
        jk=jk-1
        goto 22
      endif

      if(k0.eq.norb_inn-1) then
!  act||ext
        if((jatmp.eq.1.or.jbtmp.eq.2).and.kttmp.ne.0) then
          jk=jk-1
          goto 22
        endif
        if(jbtmp.eq.1.and.kttmp.eq.2) then
          jk=jk-1
          goto 22
        endif
      end if

      call wrtabkm(jkabkm,n16int,nabcbit,iabcbit,jatmp,jbtmp,
     *             jmtmp,kktmp)
      do 28 ii=no(k0)+1,jk-1
        iiabkm(1:n16int)=jabkm(1:n16int,ii)
        do i=1,n16int
          if(iiabkm(i).ne.jkabkm(i)) goto 28
        enddo
        if(k0.eq.norb_inn-1) goto 602
        iextii(1:nrefbit)=ind(1:nrefbit,ii)
        do i=1,nrefbit
          if(iextii(i).ne.iextjj(i)) goto 28
        enddo
602     jk=jk-1
        idjj(2,j)=ii
        goto 22
28    continue

      ind(1:nrefbit,jk)=iextjj(1:nrefbit)
      idjj(2,j)=jk
      jabkm(1:n16int,jk)=jkabkm(1:n16int)

      iiabkm(1:n16int)=jabkm(1:n16int,jk-1)
      call upacknod(iiabkm,4,kj1,nabcbit,iabcbit,n16int)
      if(kktmp.ne.kj1) no(k0)=jk-1

22    continue
c =========================================================
2     jac=norb_all-jaj-jbj
      if(jaj.le.0) then
         goto 8
      else
         goto 5
      end if
5     if(jac.eq.0) goto 3
      jk=jk+1
c                                     *************
c                                     *    d=2    *
c                                     *************
      jatmp=jaj-1
      jbtmp=jbj+1
      jmtmp=mul_tab(lsm_inn(k0+1),jmj)
      kktmp=kkj+1

      iextjj(1:nrefbit)=ind(1:nrefbit,j)
      call gugadrt_njexcit(iextjj,nrefbit,iextbit,nextbit,ivalid,
     *                     2,kttmp,k0)
      if(ivalid.eq.0) then
        jk=jk-1
        goto 33
      endif

      if(k0.eq.norb_inn-1) then
!  act||ext
        if((jatmp.eq.1.or.jbtmp.eq.2).and.kttmp.ne.0) then
          jk=jk-1
          goto 33
        endif
        if(jbtmp.eq.1.and.kttmp.eq.2) then
          jk=jk-1
          goto 33
        endif
      end if

      call wrtabkm(jkabkm,n16int,nabcbit,iabcbit,jatmp,jbtmp,
     *             jmtmp,kktmp)
      do 38 ii=no(k0)+1,jk-1
        iiabkm(1:n16int)=jabkm(1:n16int,ii)
        do i=1,n16int
          if(iiabkm(i).ne.jkabkm(i)) goto 38
        enddo
        if(k0.eq.norb_inn-1) goto 603
        iextii(1:nrefbit)=ind(1:nrefbit,ii)
        do i=1,nrefbit
          if(iextii(i).ne.iextjj(i)) goto 38
        enddo
603     jk=jk-1
        idjj(3,j)=ii
        goto 33
38    continue

      ind(1:nrefbit,jk)=iextjj(1:nrefbit)
      idjj(3,j)=jk
      jabkm(1:n16int,jk)=jkabkm(1:n16int)

      iiabkm(1:n16int)=jabkm(1:n16int,jk-1)
      call upacknod(iiabkm,4,kj1,nabcbit,iabcbit,n16int)
      if(kktmp.ne.kj1) no(k0)=jk-1

33    continue
c =========================================================
c                                         ************
c                                         *    d=3   *
c                                         ************

3     jk=jk+1
      jatmp=jaj-1
      jbtmp=jbj
      jmtmp=jmj
      kktmp=kkj+1

      iextjj(1:nrefbit)=ind(1:nrefbit,j)
      call gugadrt_njexcit(iextjj,nrefbit,iextbit,nextbit,ivalid,
     *                     3,kttmp,k0)
      if(ivalid.eq.0) then
        jk=jk-1
        goto 44
      endif

      if(k0.eq.norb_inn-1) then
!  act||ext
        if((jatmp.eq.1.or.jbtmp.eq.2).and.kttmp.ne.0) then
          jk=jk-1
          goto 44
        endif
        if(jbtmp.eq.1.and.kttmp.eq.2) then
          jk=jk-1
          goto 44
        endif
      end if

      call wrtabkm(jkabkm,n16int,nabcbit,iabcbit,jatmp,jbtmp,
     *             jmtmp,kktmp)
      do 48 ii=no(k0)+1,jk-1
        iiabkm(1:n16int)=jabkm(1:n16int,ii)
        do i=1,n16int
          if(iiabkm(i).ne.jkabkm(i)) goto 48
        enddo
        if(k0.eq.norb_inn-1) goto 604
        iextii(1:nrefbit)=ind(1:nrefbit,ii)
        do i=1,nrefbit
          if(iextii(i).ne.iextjj(i)) goto 48
        enddo
604     jk=jk-1
        idjj(4,j)=ii
        goto 44
48    continue

      ind(1:nrefbit,jk)=iextjj(1:nrefbit)
      idjj(4,j)=jk
      jabkm(1:n16int,jk)=jkabkm(1:n16int)

      iiabkm(1:n16int)=jabkm(1:n16int,jk-1)
      call upacknod(iiabkm,4,kj1,nabcbit,iabcbit,n16int)
      if(kktmp.ne.kj1) no(k0)=jk-1

44    continue
c      if(k0.eq.7) goto 999
c===========================================================
8     if(k0.le.norb_inn-1) goto 7

c999   continue
!      if(iprint.eq.1) then
!        open(100,file="tmp.dat")
!        do i=1,jk
!          jkabkm(1:n16int)=jabkm(1:n16int,i)
!          call redabkm(jkabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
!          j1=idjj(1,i)
!          j2=idjj(2,i)
!          j3=idjj(3,i)
!          j4=idjj(4,i)
!          write(100,"(5(1x,i8))") i,j1,j2,j3,j4
!        enddo
!        close(100)
!      endif
c      write(6,"(10(1x,i5))") no(1:norb_all)
      write(6,*)
c  ************** external space  *************
      id=no(norb_inn)
c      write(6,508) 'befor,no=',(no(i),i=norb_dz,norb_inn)
      do idd=no(norb_inn-1)+1,id
        jjabkm(1:n16int)=jabkm(1:n16int,idd)
        call redabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
        if(jaj.eq.0.and.jbj.eq.0.and.jmj.eq.1) jv=idd
        if(jaj.eq.0.and.jbj.eq.1) then
          do i=1,ng_sm
            if(jmj.eq.i) then
              jd(i)=idd
            endif
          enddo
        endif
        if(jaj.eq.0.and.jbj.eq.2) then
          do i=1,ng_sm
            if(jmj.eq.i) then
              jt(i)=idd
            endif
          enddo
        endif
        if(jaj.eq.1.and.jbj.eq.0) then
          do i=1,ng_sm
            if(jmj.eq.i) then
              js(i)=idd
            endif
          enddo
        endif
      enddo

      iwy(1,jv)=1
      do im=1,ng_sm
        if(jd(im).ne.0.and.iseg_downwei(1+im).ne.0) then
          iwy(1,jd(im))=1
        endif
        if(jt(im).ne.0.and.iseg_downwei(9+im).ne.0) then
          iwy(1,jt(im))=1
        endif
        if(js(im).ne.0.and.iseg_downwei(17+im).ne.0) then
          iwy(1,js(im))=1
        endif
      enddo

      iwy(1:4,0)=0
      do 20 l=norb_inn-1,norb_dz,-1
        jps=no(l-1)+1
        jpe=no(l)
        do 21 jde=jps,jpe
          j1=idjj(1,jde)
          j2=idjj(2,jde)
          j3=idjj(3,jde)
          j4=idjj(4,jde)
          iwy(1,jde)=iwy(1,j1)+iwy(1,j2)+iwy(1,j3)+iwy(1,j4)
          if(iwy(1,jde).ne.0) goto 304
          do jp0=no(l-2)+1,no(l-1)
            if(idjj(1,jp0).eq.jde) idjj(1,jp0)=0
            if(idjj(2,jp0).eq.jde) idjj(2,jp0)=0
            if(idjj(3,jp0).eq.jde) idjj(3,jp0)=0
            if(idjj(4,jp0).eq.jde) idjj(4,jp0)=0
          enddo
          goto 21
304       if(j2.eq.0.or.iwy(1,j2).eq.0) goto 31
          iwy(2,jde)=iwy(1,j1)
31        if(j3.eq.0.or.iwy(1,j3).eq.0) goto 32
          iwy(3,jde)=iwy(1,j1)+iwy(1,j2)
32        if(j4.eq.0.or.iwy(1,j4).eq.0) goto 303
          iwy(4,jde)=iwy(1,jde)-iwy(1,j4)
303       if(jde.eq.1) goto 21
          do 302 jp=jps,jde-1
            if(iwy(1,jp).ne.iwy(1,jde)) goto 302
            jq1=idjj(1,jp)
            jq2=idjj(2,jp)
            jq3=idjj(3,jp)
            jq4=idjj(4,jp)
            if(j1.ne.jq1.or.j2.ne.jq2.or.j3.ne.jq3.or.j4.ne.jq4)
     *        goto 302
            iwy(1,jde)=0
            do jp0=no(l-2)+1,no(l-1)
              if(idjj(1,jp0).eq.jde) idjj(1,jp0)=jp
              if(idjj(2,jp0).eq.jde) idjj(2,jp0)=jp
              if(idjj(3,jp0).eq.jde) idjj(3,jp0)=jp
              if(idjj(4,jp0).eq.jde) idjj(4,jp0)=jp
            enddo
            goto 21
302       continue
21      continue
20    continue

      it=mxnode
      itm(1)=1
      noh=0
      noh(norb_dz)=mxnode
      do lr=norb_dz,norb_inn-1
        do jp=no(lr)+1,no(lr+1)
          itm(jp)=0
          if(iwy(1,jp).ne.0) then
            it=it+1
            itm(jp)=it
          endif
        enddo
        noh(lr+1)=it
      enddo

      do jpe=1,mxnode
        if(nu_ad(jpe).eq.0) cycle
        jj(1,jpe)=idjj(1,jpe)
        jj(2,jpe)=idjj(2,jpe)
        jj(3,jpe)=idjj(3,jpe)
        jj(4,jpe)=idjj(4,jpe)
      enddo

      do jpe=mxnode+1,id
        jp=itm(jpe)
        if(jp.eq.0) cycle
        j1=idjj(1,jpe)
        j2=idjj(2,jpe)
        j3=idjj(3,jpe)
        j4=idjj(4,jpe)
        jjabkm(1:n16int)=jabkm(1:n16int,jpe)
        call redabkm(jjabkm,n16int,nabcbit,iabcbit,jaj,jbj,jmj,kkj)
        l=kkj
        jds=noh(l-2)+1
        jde=noh(l-1)
        do jp0=jds,jde
          if(jj(1,jp0).eq.jpe) jj(1,jp0)=jp
          if(jj(2,jp0).eq.jpe) jj(2,jp0)=jp
          if(jj(3,jp0).eq.jpe) jj(3,jp0)=jp
          if(jj(4,jp0).eq.jpe) jj(4,jp0)=jp
        enddo
        ja(jp)=jaj
        jb(jp)=jbj
        jm(jp)=jmj
        kk(jp)=kkj
        do i=1,4
          iwy(i,jp)=iwy(i,jpe)
          ji=idjj(i,jpe)
          if(itm(ji).ne.0) then
            jj(i,jp)=ji
          endif
        enddo
      enddo

c      open(10,file='rst.out')
      no(norb_dz)=0
      no(norb_dz+1)=mxnode
c      write(6,*) '   end of rst, drt ..........'
c      write(6,'(2x,2i10)')norb_dz+1,no(norb_dz+1)
      do 706 lr=norb_dz+1,norb_inn
        no(lr+1)=noh(lr)
706   continue
      jv=itm(jv)
      itm(0)=0
      do im=1,8
        jd(im)=itm(jd(im))
        jt(im)=itm(jt(im))
        js(im)=itm(js(im))
      enddo
      iysum=0
      do j=1,mxnode
        iysum=iysum+iwy(1,j)
      enddo
      id=it
      if(it.ne.no(norb_inn+1))then
        write(6,*)'   rst id is wrong!!   no(norb_inn)=',no(norb_inn),it
        call abend
!       stop
      end if

      write(6,*)
!      iprint=1
      if(iprint.eq.1) then
        write(6,*) "guga drt"
        write(6,506)
      endif
506   format('       j    k   a  b  t jm    j0   j1   j2   j3       y1',
     :       '       y2      y3         x   ind')
      nndd=no(norb_inn)
      do 541 j=1,id
          kk(j)=kk(j)+1
        if(iprint.eq.1) then
          write(6,510)j,kk(j),ja(j),jb(j),jm(j),
     :             jj(1,j),jj(2,j),jj(3,j),jj(4,j)
        endif
541   continue
      write(6,*)
      write(6,*) 'end of rst, drt ..........'

      deallocate(jabkm)
      deallocate(ind)
      deallocate(idjj)
      deallocate(iwy)
      deallocate(itm)

c
c      open(21,file="fort.drt",form="unformatted")
c      write(21) id
c      write(21) ja(1:id),jb(1:id),jm(1:id)
c      write(21) jj(1:4,0:id)
c      write(21) kk(0:id)
c      write(21) no(0:norb_inn+1)
c      write(21) jv,jd(1:8),jt(1:8),js(1:8)
c      close(21)

      call writedrt(id)
      return
c508   format(3x,a10,1x,i5,1x,16i8)
510   format(3x,10(1x,i7))
      end

      subroutine gugadrt_ref_gfs(nel,ndj,locu,nm)
#include "gendrt.fh"
#include "Sysdrt.fh"
      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
     :    ,jv,jd(8),jt(8),js(8)
      dimension lhsm(8),locu(8,max_ref),lscu(0:8,max_ref)
      nl_act=norb_act
      ne_act=nel-2*norb_dz
      ne_s=nint(spin*2)
      lhs=nstart_act
      lhe=norb_inn
      lhsm(1:8)=0
      do lh=lhs,lhe
          lm=lsm_inn(lh)
        lhsm(lm)=lhsm(lm)+1
      enddo
      mdj=0
      do 500 nes=ne_s,ne_act,2
        do 100 l1=0,lhsm(1)
          do 101 l2=0,lhsm(2)
            do 102 l3=0,lhsm(3)
              do 103 l4=0,lhsm(4)
                do 104 l5=0,lhsm(5)
                  do 105 l6=0,lhsm(6)
                    do 106 l7=0,lhsm(7)
                      do 107 l8=0,lhsm(8)
                        lpsum=l1+l2+l3+l4+l5+l6+l7+l8
                        if(lpsum.ne.nes) goto 107
                        mys=1
                        if(mod(l1,2).eq.1)mys=mul_tab(mys,1)
                        if(mod(l2,2).eq.1)mys=mul_tab(mys,2)
                        if(mod(l3,2).eq.1)mys=mul_tab(mys,3)
                        if(mod(l4,2).eq.1)mys=mul_tab(mys,4)
                        if(mod(l5,2).eq.1)mys=mul_tab(mys,5)
                        if(mod(l6,2).eq.1)mys=mul_tab(mys,6)
                        if(mod(l7,2).eq.1)mys=mul_tab(mys,7)
                        if(mod(l8,2).eq.1)mys=mul_tab(mys,8)
                        if(mys.ne.nm) goto 107
                        mdj=mdj+1
                        lscu(0,mdj)=lpsum
                        lscu(1,mdj)=l1
                        lscu(2,mdj)=l2
                        lscu(3,mdj)=l3
                        lscu(4,mdj)=l4
                        lscu(5,mdj)=l5
                        lscu(6,mdj)=l6
                        lscu(7,mdj)=l7
                        lscu(8,mdj)=l8
107                   continue
106                 continue
105               continue
104             continue
103           continue
102         continue
101       continue
100     continue
500   continue
      ndj=0
      do 300 m=1,mdj
        npair=(ne_act-lscu(0,m))/2
        do 200 l1=0,lhsm(1)-lscu(1,m)
          do 201 l2=0,lhsm(2)-lscu(2,m)
            do 202 l3=0,lhsm(3)-lscu(3,m)
              do 203 l4=0,lhsm(4)-lscu(4,m)
                do 204 l5=0,lhsm(5)-lscu(5,m)
                  do 205 l6=0,lhsm(6)-lscu(6,m)
                    do 206 l7=0,lhsm(7)-lscu(7,m)
                      do 207 l8=0,lhsm(8)-lscu(8,m)
                        lpsum=l1+l2+l3+l4+l5+l6+l7+l8
                        if(lpsum.eq.npair) then
                          m1=l1*2+lscu(1,m)
                          m2=l2*2+lscu(2,m)
                          m3=l3*2+lscu(3,m)
                          m4=l4*2+lscu(4,m)
                          m5=l5*2+lscu(5,m)
                          m6=l6*2+lscu(6,m)
                          m7=l7*2+lscu(7,m)
                          m8=l8*2+lscu(8,m)
                          do 600 ldj=1,ndj
                            if(m1.ne.locu(1,ldj)) goto 600
                            if(m2.ne.locu(2,ldj)) goto 600
                            if(m3.ne.locu(3,ldj)) goto 600
                            if(m4.ne.locu(4,ldj)) goto 600
                            if(m5.ne.locu(5,ldj)) goto 600
                            if(m6.ne.locu(6,ldj)) goto 600
                            if(m7.ne.locu(7,ldj)) goto 600
                            if(m8.ne.locu(8,ldj)) goto 600
                            goto 207
600                       continue
                          ndj=ndj+1
                          locu(1,ndj)=m1
                          locu(2,ndj)=m2
                          locu(3,ndj)=m3
                          locu(4,ndj)=m4
                          locu(5,ndj)=m5
                          locu(6,ndj)=m6
                          locu(7,ndj)=m7
                          locu(8,ndj)=m8
                        endif
207                   continue
206                 continue
205               continue
204             continue
203           continue
202         continue
201       continue
200     continue
300   continue

      do nre=1,ndj
      write(6,'(5x,i6,8i3)')nre,(locu(i,nre),i=1,8)
      enddo
      return
      end

      subroutine gugadrt_rcas(id,indd)
#include "gendrt.fh"
#include "Sysdrt.fh"
#include "stdalloc.fh"
      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
     :    ,jv,jd(8),jt(8),js(8)
      dimension locu(8,max_ref),jc(max_node)
      dimension noh(max_innorb),itm(0:max_node)
      allocatable :: ind(:,:),iwy(:,:)
      call mma_allocate(ind,8,max_node,label='ind')
      call mma_allocate(iwy,[1,4],[0,max_node],label='iwy')
      write(6,*)' '
      write(6,*) 'now generate distinct row tableau'
      noh=0
      itm=0
      iwy=0
      ind=0
      locu=0
      jc=0

      nel =n_electron
      nz  =ng_sm
      nm  =ns_sm
      no(1:norb_dz-1)=0
      j=0
      ja0=ja_sys
      jb0=jb_sys
      jc0=jc_sys
      kcm=min(ja0,jc0)
      kd=(ja0+1)*(jc0+1)*int(jb0+0.5d0*kcm+1)-kcm*(kcm+1)*(kcm+2)/6
!  v_node
      ja(1)=ja0
      jb(1)=jb0
      jc(1)=jc0
      kk(1)=norb_dz
      do i=1,8
        ind(i,1)=0
        enddo
        jm(1)=nm
!  d_node
      imd=0
      do node=2,9
        imd=imd+1
        if(nu_ad(node).eq.0) cycle
        ja(node)=ja(1)
        jb(node)=jb0+1
        jc(node)=jc0-1
        kk(node)=norb_dz
        do i=1,8
          ind(i,node)=0
        enddo
        jm(node)=imd
      enddo
!  t_node
      imt=0
      do node=10,17
        imt=imt+1
        if(nu_ad(node).eq.0) cycle
        ja(node)=ja(1)
        jb(node)=jb0+2
        jc(node)=jc0-2
        kk(node)=norb_dz
        do i=1,8
          ind(i,node)=0
        enddo
        jm(node)=imt
      enddo
!  s_node
      ims=0
      do node=18,25
        ims=ims+1
        if(nu_ad(node).eq.0) cycle
        ja(node)=ja(1)+1
        jb(node)=jb0
        jc(node)=jc0-1
        kk(node)=norb_dz
        do i=1,8
          ind(i,node)=0
        enddo
        jm(node)=ims
      enddo
      if(jroute_sys.gt.1) then
!  d'_node
        imd=0
        do node=26,33
          imd=imd+1
          if(nu_ad(node).eq.0) cycle
          ja(node)=ja(1)+1
          jb(node)=jb0-1
          jc(node)=jc0
          kk(node)=norb_dz
          do i=1,8
           ind(i,node)=0
          enddo
          jm(node)=imd
        enddo
      endif
      if(jroute_sys.gt.2) then
!  t'_node
        imt=0
        do node=34,41
          imt=imt+1
          if(nu_ad(node).eq.0) cycle
          ja(node)=ja(1)+2
          jb(node)=jb0-2
          jc(node)=jc0
          kk(node)=norb_dz
          do i=1,8
           ind(i,node)=0
          enddo
          jm(node)=imt
        enddo
      endif
      no(norb_dz)=mxnode

      call gugadrt_ref_gfs(nel,ndj,locu,nm)


      j=0
      jk=mxnode
7     j=j+1
      if(j.le.mxnode) then
        if(nu_ad(j).eq.0) goto 7
      endif
!      if(j.le.mxnode.and.nu_ad(j).eq.0) goto 7
      k0=kk(j)
      if(jc(j).eq.0) goto 1
      jk=jk+1
c                                            ***********
c                                            *   d=0   *
c                                            ***********
      ja(jk)=ja(j)
      jb(jk)=jb(j)
      jc(jk)=jc(j)-1
      jm(jk)=jm(j)
      do i=1,8
        ind(i,jk)=ind(i,j)
      enddo
      inb=0
      if(kk(j).eq.norb_inn-1) then
      call gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
      endif
      if(inb.gt.2) then
        jk=jk-1
        jj(1,j)=0
        goto 11
      endif

      do 18 ii=no(k0)+1,jk-1
         if(ja(jk).ne.ja(ii)) goto 18
         if(jb(jk).ne.jb(ii)) goto 18
         if(jc(jk).ne.jc(ii)) goto 18
         if(jm(jk).ne.jm(ii)) goto 18
         if(kk(j).eq.norb_inn-1) goto 601
         do i=1,8
          if(ind(i,jk).ne.ind(i,ii)) goto 18
         enddo
 601     jk=jk-1
         jj(1,j)=ii
         goto 11
18       continue
      jj(1,j)=jk
      kk(jk)=kk(j)+1
      if(kk(jk).ne.kk(jk-1)) then
      no(k0)=jk-1
      end if
11    continue
c      v=0
1     if(jb(j).eq.0) goto 2
      jk=jk+1
c                                            ***********
c                                            *   d=1   *
c                                            ***********
      ja(jk)=ja(j)
      jb(jk)=jb(j)-1
      jc(jk)=jc(j)
      jm(jk)=mul_tab(lsm_inn(kk(j)+1),jm(j))
      do i=1,8
        ind(i,jk)=ind(i,j)
      enddo
      ind(lsm_inn(kk(j)+1),jk)=ind(lsm_inn(kk(j)+1),j)+1
      inb=0
      if(kk(j).eq.norb_inn-1) then
      call gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
      endif
      if(inb.gt.2) then
        jk=jk-1
        jj(2,j)=0
        goto 22
      endif
      do 119 ii=no(k0)+1,jk-1
         if(ja(jk).ne.ja(ii)) goto 119
         if(jb(jk).ne.jb(ii)) goto 119
         if(jc(jk).ne.jc(ii)) goto 119
         if(jm(jk).ne.jm(ii)) goto 119
         if(kk(j).eq.norb_inn-1) goto 607
           do i=1,8
            if(ind(i,jk).ne.ind(i,ii)) goto 119
          enddo
607      jk=jk-1
         jj(2,j)=ii
         goto 22
119   continue
      jj(2,j)=jk
      kk(jk)=kk(j)+1
      if(kk(jk).ne.kk(jk-1)) then
      no(k0)=jk-1
      end if
22    continue
c      v=0
2     if(ja(j).le.0) then
         goto 8
      else
         goto 5
      end if
5     if(jc(j).eq.0) goto 3
      jk=jk+1
c                                     *************
c                                     *    d=2    *
c                                     *************
      ja(jk)=ja(j)-1
      jb(jk)=jb(j)+1
      jc(jk)=jc(j)-1
c-----------------------------------------------------------------------
      jm(jk)=mul_tab(lsm_inn(kk(j)+1),jm(j))
      do i=1,8
        ind(i,jk)=ind(i,j)
      enddo
      ind(lsm_inn(kk(j)+1),jk)=ind(lsm_inn(kk(j)+1),j)+1
      inb=0
      if(kk(j).eq.norb_inn-1) then
      call gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
      endif
      if(inb.gt.2) then
        jk=jk-1
        jj(3,j)=0
        goto 44
      endif
      do 181 ii=no(k0)+1,jk-1
         if(ja(jk).ne.ja(ii)) goto 181
         if(jb(jk).ne.jb(ii)) goto 181
         if(jc(jk).ne.jc(ii)) goto 181
         if(jm(jk).ne.jm(ii)) goto 181
         if(kk(j).eq.norb_inn-1) goto 603
         do i=1,8
           if(ind(i,jk).ne.ind(i,ii)) goto 181
         enddo
603      jk=jk-1
         jj(3,j)=ii
         goto 44
181   continue
      jj(3,j)=jk
      kk(jk)=kk(j)+1
      if(kk(jk).ne.kk(jk-1)) then
      no(k0)=jk-1
      end if
44    continue
c      v=0
c                                         ************
c                                         *    d=3   *
c                                         ************

3     jk=jk+1
      ja(jk)=ja(j)-1
      jb(jk)=jb(j)
      jc(jk)=jc(j)
      jm(jk)=jm(j)
      do i=1,8
        ind(i,jk)=ind(i,j)
      enddo
      ind(lsm_inn(kk(j)+1),jk)=ind(lsm_inn(kk(j)+1),j)+2
         inb=0
      if(kk(j).eq.norb_inn-1) then
      call gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
      endif
      if(inb.gt.2) then
        jk=jk-1
        jj(4,j)=0
        goto 88
      endif
      do 118 ii=no(k0)+1,jk-1
         if(ja(jk).ne.ja(ii)) goto 118
         if(jb(jk).ne.jb(ii)) goto 118
         if(jc(jk).ne.jc(ii)) goto 118
         if(jm(jk).ne.jm(ii)) goto 118
         if(kk(j).eq.norb_inn-1) goto 605
         do 606 i=1,8
           if(ind(i,jk).ne.ind(i,ii)) goto 118
606      continue
605      jk=jk-1
         jj(4,j)=ii
         go to 88
118   continue
      jj(4,j)=jk
      kk(jk)=kk(j)+1
      if(kk(jk).ne.kk(jk-1)) then
      no(k0)=jk-1
      end if
88    continue
c      v=0
      if(jk.gt.max_node) then
        write(6,*) '    the nomber of j exceeds max_node',max_node
        call abend
!       stop 777
      endif
8     if(kk(j).le.norb_inn-1)goto 7
c  ************** external space  *************

      id=no(norb_inn)
      write(6,*)
      write(6,*)'    id=no(norb_inn)',id
      do 43 idd=no(norb_inn-1)+1,id
         if(ja(idd).eq.0.and.jb(idd).eq.0.and.jm(idd).eq.1) jv=idd
         if(ja(idd).eq.0.and.jb(idd).eq.1) then
           if(jm(idd).eq.1) jd(1)=idd
           if(jm(idd).eq.2) jd(2)=idd
           if(jm(idd).eq.3) jd(3)=idd
           if(jm(idd).eq.4) jd(4)=idd
           if(jm(idd).eq.5) jd(5)=idd
           if(jm(idd).eq.6) jd(6)=idd
           if(jm(idd).eq.7) jd(7)=idd
           if(jm(idd).eq.8) jd(8)=idd
         endif
         if(ja(idd).eq.0.and.jb(idd).eq.2) then
           if(jm(idd).eq.1) jt(1)=idd
           if(jm(idd).eq.2) jt(2)=idd
           if(jm(idd).eq.3) jt(3)=idd
           if(jm(idd).eq.4) jt(4)=idd
           if(jm(idd).eq.5) jt(5)=idd
           if(jm(idd).eq.6) jt(6)=idd
           if(jm(idd).eq.7) jt(7)=idd
           if(jm(idd).eq.8) jt(8)=idd
         endif
         if(ja(idd).eq.1.and.jb(idd).eq.0) then
           if(jm(idd).eq.1) js(1)=idd
           if(jm(idd).eq.2) js(2)=idd
           if(jm(idd).eq.3) js(3)=idd
           if(jm(idd).eq.4) js(4)=idd
           if(jm(idd).eq.5) js(5)=idd
           if(jm(idd).eq.6) js(6)=idd
           if(jm(idd).eq.7) js(7)=idd
           if(jm(idd).eq.8) js(8)=idd
      endif
43    continue

      iwy(1,jv)=1
      do im=1,ng_sm
        if(jd(im).ne.0.and.iseg_downwei(1+im).ne.0) iwy(1,jd(im))=1
        if(jt(im).ne.0.and.iseg_downwei(9+im).ne.0) iwy(1,jt(im))=1
        if(js(im).ne.0.and.iseg_downwei(17+im).ne.0) iwy(1,js(im))=1
      enddo

      do 21 i=1,4
      iwy(i,0)=0
21    continue
      do 20 l=norb_inn-1,norb_dz,-1
         jps=no(l-1)+1
         jpe=no(l)
      do 19 jde=jps,jpe
         j1=jj(1,jde)
         j2=jj(2,jde)
         j3=jj(3,jde)
         j4=jj(4,jde)
         iwy(1,jde)=iwy(1,j1)+iwy(1,j2)+iwy(1,j3)+iwy(1,j4)
         if(iwy(1,jde).ne.0) goto 304
           if(l.eq.norb_dz) then
             nc=0
           else
             nc=no(l-2)
           endif
           do jp0=nc+1,no(l-1)
             if(jj(1,jp0).eq.jde) jj(1,jp0)=0
             if(jj(2,jp0).eq.jde) jj(2,jp0)=0
             if(jj(3,jp0).eq.jde) jj(3,jp0)=0
             if(jj(4,jp0).eq.jde) jj(4,jp0)=0
           enddo
         goto 19
304      if(j2.eq.0.or.iwy(1,j2).eq.0) goto 31
         iwy(2,jde)=iwy(1,j1)
31       if(j3.eq.0.or.iwy(1,j3).eq.0) goto 32
         iwy(3,jde)=iwy(1,j1)+iwy(1,j2)
32       if(j4.eq.0.or.iwy(1,j4).eq.0) goto 303
         iwy(4,jde)=iwy(1,jde)-iwy(1,j4)
303      if(jde.eq.1) goto 19
         do 302 jp=jps,jde-1
           if(iwy(1,jp).ne.iwy(1,jde)) goto 302
           jq1=jj(1,jp)
           jq2=jj(2,jp)
           jq3=jj(3,jp)
           jq4=jj(4,jp)
         if(j1.ne.jq1.or.j2.ne.jq2.or.j3.ne.jq3.or.j4.ne.jq4) goto 302
           iwy(1,jde)=0
           do   jp0=no(l-2)+1,no(l-1)
             if(jj(1,jp0).eq.jde) jj(1,jp0)=jp
             if(jj(2,jp0).eq.jde) jj(2,jp0)=jp
             if(jj(3,jp0).eq.jde) jj(3,jp0)=jp
             if(jj(4,jp0).eq.jde) jj(4,jp0)=jp
           enddo
           goto 19
302      continue
19     continue
20    continue
        it=mxnode
      itm(1)=1
        noh(norb_dz)=mxnode
      do 405 lr=norb_dz,norb_inn-1
        do 200 jp=no(lr)+1,no(lr+1)
          itm(jp)=0
          if(iwy(1,jp).ne.0) then
          it=it+1
          itm(jp)=it
          endif
200     continue
      noh(lr+1)=it
405   continue

      do 206 jpe=mxnode+1,id
        jp=itm(jpe)
      if(jp.eq.jpe) goto 206
      if(jp.eq.0) goto 206
        l=kk(jpe)
        jds=noh(l-2)+1
        jde=noh(l-1)
        do jp0=jds,jde
          if(jj(1,jp0).eq.jpe) jj(1,jp0)=jp
          if(jj(2,jp0).eq.jpe) jj(2,jp0)=jp
          if(jj(3,jp0).eq.jpe) jj(3,jp0)=jp
          if(jj(4,jp0).eq.jpe) jj(4,jp0)=jp
        enddo
      ja(jp)=ja(jpe)
      jb(jp)=jb(jpe)
      jc(jp)=jc(jpe)
      jm(jp)=jm(jpe)
      kk(jp)=kk(jpe)
      do 704 i=1,4
         iwy(i,jp)=iwy(i,jpe)
         jj(i,jp)=jj(i,jpe)
         ind(i,jp)=ind(i,jpe)
704   continue
      do i=5,8
      ind(i,jp)=ind(i,jpe)
      enddo
206   continue

c      open(10,file='rcas.out')
      no(norb_dz)=0
      no(norb_dz+1)=mxnode

c      write(nf10,'(2x,2i10)')norb_dz+1,no(norb_dz+1)
      do 706 lr=norb_dz,norb_inn
        no(lr+1)=noh(lr)
        write(6,'(2x,2i10)')lr+1,no(lr+1)
706   continue

      itm(0)=0
      jv=itm(jv)
      do im=1,8
          jd(im)=itm(jd(im))
          jt(im)=itm(jt(im))
          js(im)=itm(js(im))
      enddo
      id=it
      if(it.ne.no(norb_inn+1))then
       write(6,*)'   rcas id is wrong!!   no(norb_inn)=',no(norb_inn),it
       call abend
!      stop
      end if
      iysum=0
      do j=1,mxnode
        iysum=iysum+iwy(1,j)
      enddo
c        write(6,*)'    end of rcas , node=',id,'  dimension=',iysum
      write(6,*)
      indd=no(norb_inn)
!      iprint=1
      if(iprint.eq.1) then
        write(6,*) "guga drt"
        write(6,506)
      endif
506   format('       j    k   a  b  t jm    j0   j1   j2   j3       y1',
     :       '    y2      y3         x   ind')

      do 541 j=1,id
        kk(j)=kk(j)+1
        if(iprint.eq.1) then
           write(6,507)j,kk(j),ja(j),jb(j),jm(j),
     :             jj(1,j),jj(2,j),jj(3,j),jj(4,j),
     :             iwy(2,j),iwy(3,j),iwy(4,j),iwy(1,j),(ind(i,j),i=1,8)
        endif
541   continue
      write(6,*) 'end of rcas, drt ..........'
      write(6,*)

c      open(21,file="fort.drt",form="unformatted")
c      write(21) id
c      write(21) ja(1:id),jb(1:id),jm(1:id)
c      write(21) jj(1:4,0:id)
c      write(21) kk(0:id)
c      write(21) no(0:norb_inn+1)
c      write(21) jv,jd(1:8),jt(1:8),js(1:8)
c      close(21)

      call writedrt(id)
      call mma_deallocate(ind)
      call mma_deallocate(iwy)
507   format(3x,2i5,1x,3i3,1x,4i5,1x,4i10,1x,8i2)
      end

      subroutine gugadrt_check_rcas3(jk,ind,inb,ndj,locu)
#include "gendrt.fh"
      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
     :    ,jv,jd(8),jt(8),js(8)
      dimension ind(8,max_node),lsym(8),iexcit(ndj),locu(8,ndj)
      inb=0
      nsumel=0
      do i=1,8
        lsym(i)=ind(i,jk)
        nsumel=nsumel+lsym(i)
      enddo
      do i=1,ndj
        iexcit(i)=0
        do m=1,8
          iex=lsym(m)-locu(m,i)
         if(iex.gt.0) then
           iexcit(i)=iexcit(i)+iex
          endif
        enddo
      enddo
      inb=iexcit(1)
      do i=2,ndj
         inb=min(inb,iexcit(i))
      enddo
      inb=inb+ja(jk)*2+jb(jk)
      return
      end

c     juv,just(nost,nost),jud(nost)
c     |  \  1         |
c     | d,dd,s(i=i)   |
c     |    \ s,t,tt(i<j)|
c     |     \       1 2 |     deal with inner of dbl_space
c     |ss(i>j)\       |
c     |  2 1  \       |
      subroutine gugadrt_dbl_downwalk()
#include "gendrt.fh"
c     integer lsml(10,10)       !to del
      if(norb_dbl.ne.0) goto 200
c----------- norb_dbl=0 ------------------------------------------------
      do im=1,ng_sm
        nnd=iseg_sta(1+im)
        nnt=iseg_sta(9+im)
        nns=iseg_sta(17+im)
        do lri=norb_dz,norb_frz+1,-1
          ismi=lsm_inn(lri)
         if(ismi.ne.im) cycle
          jud(lri)=nnd
          nnd=nnd+iseg_downwei(1+im)
        enddo
        do lrj=norb_dz,norb_frz+1,-1
         ismj=lsm_inn(lrj)
          do lri=lrj,1,-1
           ismi=lsm_inn(lri)
           ismij=mul_tab(ismi,ismj)
            if(ismij.ne.im) cycle
            just(lri,lrj)=nns
            nns=nns+iseg_downwei(17+im)
            if(lri.eq.lrj) cycle
           just(lrj,lri)=nnt
            nnt=nnt+iseg_downwei(9+im)
           enddo
        enddo
      enddo
c----------- norb_dbl=0 ------------------------------------------------
c----------- norb_dbl<>0 -----------------------------------------------
200   iwdownv=0
      do im=1,ng_sm
        nnd=0
        nns=0
        do lri=norb_frz+1,norb_dz
          ismi=mul_tab(lsm_inn(lri),ns_sm)
         if(ismi.ne.im) cycle
          jud(lri)=nnd
          nnd=nnd+1
        enddo
        do lri=norb_frz+1,norb_dz-1
          ismi=mul_tab(lsm_inn(lri),ns_sm)
          do lrj=lri+1,norb_dz      !tmp
           ismj=lsm_inn(lrj)
           ismij=mul_tab(ismi,ismj)
            if(ismij.ne.im) cycle
            just(lri,lrj)=nns
            nns=nns+1
         enddo
        enddo
        if(im.eq.ns_sm) then
          do lr0=norb_frz+1,norb_dz
            just(lr0,lr0)=nns
            nns=nns+1
          enddo
        endif
        do lri=norb_frz+1,norb_dz-1
          ismi=mul_tab(lsm_inn(lri),ns_sm)
          do lrj=lri+1,norb_dz      !tmp
           ismj=lsm_inn(lrj)
           ismij=mul_tab(ismi,ismj)
            if(ismij.ne.im) cycle
            just(lrj,lri)=nns
            nns=nns+1
         enddo
        enddo
      enddo

      return
      end

      function gugadrt_iwalk_ad(jdbl,jext,iwa,iwd)
#include "gendrt.fh"
      iwup=jpad_upwei(jdbl)
      isegdown=iseg_downwei(jext)
      gugadrt_iwalk_ad=(iwa*iwup+iwd)*isegdown+iw_sta(jdbl,jext)
      return
      end

      subroutine gugadrt_ajphy(jp,in,jpihy)
#include "gendrt.fh"
      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
     :    ,jv,jd(8),jt(8),js(8)
      common/sub_drt/jpad,jpae,ipae,ndim,nohy,ihy(max_wei),
     :     jj_sub(4,0:max_node),iy(4,0:max_node),jphy(max_node)
      dimension iin(0:max_node),jpihy(max_wei)

      iin(0)=0
      if(jp.eq.jpad) then
      in=1
      jpihy(1)=0
      return
      endif
      lr=kk(jp)
c     write(6,*)'  ajphy,jp,start,end',jp,no(nst-lr)+1,no(nst-lr+1)
      jpe=no(lr+1)
      iin(jpad:jpe)=0
      iin(jp)=1
      do 10 jpn=no(lr-1),jpad,-1
      iin(jpn)=iin(jj_sub(1,jpn))+iin(jj_sub(2,jpn))+iin(jj_sub(3,jpn))
     :        +iin(jj_sub(4,jpn))
10    continue
      in=iin(jpad)

      do 30 l=1,in
        jpihy(l)=0
        jy=l
        nn=jpad
        do 349 i=norb_dz+1,lr-1
          idr=0
          do 40 j=1,4
            if(jj(j,nn).eq.0) goto 40
            if(jy.gt.iin(jj_sub(j,nn))) goto 353
            idr=j
            goto 350
353         jy=jy-iin(jj_sub(j,nn))
40        continue
350       if(idr.ne.1)jpihy(l)=jpihy(l)+iy(idr,nn)
          nn=jj_sub(idr,nn)
349     continue
30    continue
      return
      end

      subroutine gugadrt_njexcit(indjk,ljk,iextbit,nextbit,ivalid,
     *                           jstep,kttmp,k0)
#include "gendrt.fh"
#include "Sysdrt.fh"
      common /refstate/ iref_occ(max_innorb,max_ref)
      common/ref/ndj,ndjgrop,ndjmod
      dimension indjk(ljk),itexcit(n_ref)

      kp=k0
      do idxref=1,n_ref
        call upacknod(indjk,idxref,ival,nextbit,iextbit,ljk)
        if(jstep.eq.1.or.jstep.eq.2) then
          if(iref_occ(kp+1,idxref).eq.0) ival=ival+1
        endif
        if(jstep.eq.3) then
          if(iref_occ(kp+1,idxref).eq.0) ival=ival+2
          if(iref_occ(kp+1,idxref).eq.1) ival=ival+1
        endif
        if(ival.gt.2) ival=3
        itexcit(idxref)=ival
      enddo
      inm=itexcit(1)
      do idxref=2,n_ref
        inm=min(inm,itexcit(idxref))
      enddo

      if(inm.gt.2) then
        ivalid=0
      else
        kttmp=inm
        ivalid=1
        if(jstep.ne.0) then
          do i=1,n_ref
            ival=itexcit(i)
            call packnod(indjk,i,ival,nextbit,iextbit,ljk)
          enddo
        endif
      endif

      return
      end

c**************************************************
      subroutine packnod(ibuf,idx,ival,nin,nbit,lbuf)
c**************************************************
c  pack integral ival into ibuf on bit mode
c  ibuf() integral buffer array
c  idx    index
c  nin    number of integrals in one integral
c  lbuf   length of ibuf
      implicit real*8 (a-h,o-z)
      dimension ibuf(lbuf)
      integer*4, parameter :: one4=1
      integer, parameter :: i4=kind(one4)

      inv=ival
      nimod=mod(idx,nin)
      if(nimod.eq.0) then
        ngrp=idx/nin
        nidbit=0
      else
        ngrp=idx/nin+1
        nidbit=(nin-nimod)*nbit
      endif

c      write(6,"(b64.64)") inv
#ifdef _AIX_
      call abend
#else
c IFG: changed to avoid compiler warnings, although it is
c      probably the compiler's fault
c     call mvbits(inv,0,nbit,ibuf(ngrp),nidbit)
      call mvbits(inv,0,int(nbit,i4),ibuf(ngrp),int(nidbit,i4))
#endif
c      write(6,"(b64.64)") ibuf(ngrp)

      return
c...end of packnod
      end

c**************************************************
      subroutine packnod4(ibuf,idx1,idx2,ival,nin1,nbit1,
     *                    lbuf1,lbuf2)
c**************************************************
c  pack integral ival into ibuf on bit mode
c  ibuf() integral buffer array
c  idx1   index of the ibuf(i,*)
c  idx2   index of the ibuf(*,i)
c  ival   the value will packed
c  nin1   number of integrals in one integral in ibuf(i,*)
c  nbit1  number of bits packed in ibuf(i,*)
c  nin2   number of integrals in one integral in ibuf(*,i)
c  nbit2  number of bits packed in ibuf(*,i)
c  lbuf   length of ibuf
      implicit real*8 (a-h,o-z)
      dimension ibuf(lbuf1,0:lbuf2)
      integer*4, parameter :: one4=1
      integer, parameter :: i4=kind(one4)

      inv=ival
      nimod1=mod(idx1,nin1)
      if(nimod1.eq.0) then
        ngrp1=idx1/nin1
        nidbit1=0
      else
        ngrp1=idx1/nin1+1
        nidbit1=(nin1-nimod1)*nbit1
      endif
#ifdef _AIX_
      call abend
#else

c IFG: changed to avoid compiler warnings, although it is
c      probably the compiler's fault
c     call mvbits(inv,0,nbit1,ibuf(ngrp1,idx2),nidbit1)
      call mvbits(inv,0,int(nbit1,i4),ibuf(ngrp1,idx2),int(nidbit1,i4))
#endif
      return
c...end of packnod4
      end

c**************************************************
      subroutine upacknod(ibuf,idx,ival,nin,nbit,lbuf)
c**************************************************
c  pack integral ival into ibuf on bit mode
c  ibuf() integral buffer array
c  idx    index
c  nin    number of integrals in one integral
c  lbuf   length of ibuf
      implicit real*8 (a-h,o-z)
      dimension ibuf(lbuf)
      integer*4, parameter :: one4=1
      integer, parameter :: i4=kind(one4)

      nimod=mod(idx,nin)
      if(nimod.eq.0) then
        ngrp=idx/nin
        nidbit=0
      else
        ngrp=idx/nin+1
        nidbit=(nin-nimod)*nbit
      endif

      isp=nidbit
c      inv=ibuf(ngrp)
c      ival=ibits(inv,isp,nbit-1)
      ival=0
#ifdef _AIX_
      call abend
#else

c IFG: changed to avoid compiler warnings, although it is
c      probably the compiler's fault
c     call mvbits(ibuf(ngrp),isp,nbit,ival,0)
      call mvbits(ibuf(ngrp),int(isp,i4),int(nbit,i4),ival,0)
#endif
c      write(6,*) isp,nbit-1
c      write(6,"(b64.64)") ival

      return
c...end of upacknod
      end


      subroutine redabkm(iabkm,labkm,nabcbit,iabcbit,
     *                   jatmp,jbtmp,jmtmp,kktmp)
c this subroutine unpack ja jb jm kt from compress arrays
      implicit real*8 (a-h,o-z)
      dimension iabkm(1:labkm)

      call upacknod(iabkm,1,jatmp,nabcbit,iabcbit,labkm)
      call upacknod(iabkm,2,jbtmp,nabcbit,iabcbit,labkm)
      call upacknod(iabkm,3,jmtmp,nabcbit,iabcbit,labkm)
      call upacknod(iabkm,4,kktmp,nabcbit,iabcbit,labkm)

      return
c...end of reabtm
      end

      subroutine wrtabkm(iabkm,labkm,nabcbit,iabcbit,
     *                   jatmp,jbtmp,jmtmp,kktmp)
c this subroutine unpack ja jb jm kt from compress arrays
      implicit real*8 (a-h,o-z)
      dimension iabkm(1:labkm)

      call packnod(iabkm,1,jatmp,nabcbit,iabcbit,labkm)
      call packnod(iabkm,2,jbtmp,nabcbit,iabcbit,labkm)
      call packnod(iabkm,3,jmtmp,nabcbit,iabcbit,labkm)
      call packnod(iabkm,4,kktmp,nabcbit,iabcbit,labkm)

      return
c...end of reabtm
      end

      subroutine writedrt(id)
#include "gendrt.fh"
#include "files_gugadrt.fh"
      common/casrst/ja(max_node),jb(max_node),jm(0:max_node)
     :    ,jj(4,0:max_node),kk(0:max_node),no(0:max_innorb)
     :    ,jv,jd(8),jt(8),js(8)
      dimension jbuf(4*(id+1)),idx(2)

      nc=1
      do i=0,id
        jbuf(nc:nc+3)=jj(1:4,i)
        nc=nc+4
      enddo
      idisk=0
!  number of nodes
      call idafile(ludrt,2,idx,2,idisk)
      idisk=idx(2)
      call idafile(ludrt,1,[id],1,idisk)
      call idafile(ludrt,1,ja,id,idisk)
      call idafile(ludrt,1,jb,id,idisk)
      call idafile(ludrt,1,jm,id,idisk)
      call idafile(ludrt,1,jbuf,4*(id+1),idisk)
      call idafile(ludrt,1,kk(0),1+id,idisk)
      call idafile(ludrt,1,no(0),norb_inn+2,idisk)
      call idafile(ludrt,1,[jv],1,idisk)
      call idafile(ludrt,1,jd,8,idisk)
      call idafile(ludrt,1,jt,8,idisk)
      call idafile(ludrt,1,js,8,idisk)

      return
      end

      subroutine gugadrt_gugafinalize()
! default value for performing ci calculation
#include "gendrt.fh"
#include "files_gugadrt.fh"

      call daclos(ludrt)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE LOOP17(KM,ISTOP,IT1,IT2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      ISTOP=0
      KM1=KM+1
      IDIF=IA(J1(KM1))-IA(J2(KM1))
      IF(IDIF.LT.0.OR.IDIF.GT.2)GO TO 55
      IF (IDIF-1.LT.0) THEN
        GO TO 51
      ELSE IF (IDIF-1.EQ.0) THEN
        GO TO 52
      ELSE
        GO TO 53
      END IF
51    IWAYKM=IWAY(KM)
      GO TO (39,41,42,43,44,55),IWAYKM
39    IWAY(KM)=2
C     (NR,RO)
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 41
      IF(K1F(JM(KM1)).EQ.0)GO TO 141
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP1(KM)=COUP(KM1)/(IB(J2(KM1))+2)
      JM1(KM)=K1F(JM(KM1))
      IF(K2F(JM(KM1)).EQ.0)GO TO 40
      GO TO 241
141   IF(K2F(JM(KM1)).EQ.0)GO TO 41
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
241   COUP(KM)=-BL2(IB(J2(KM1))+1)*COUP(KM1)/(IB(J2(KM1))+3)
      JM(KM)=K2F(JM(KM1))
      GO TO 40
C     MM
41    IWAY(KM)=3
      IF(K0(IT1+J1(KM1)).EQ.0.OR.K0(IT2+J2(KM1)).EQ.0)GO TO 42
      IF(K0F(JM(KM1)).EQ.0)GO TO 42
      J1(KM)=K0(IT1+J1(KM1))
      J2(KM)=K0(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)
      ICOUP(KM)=ICOUP(KM1)
      COUP(KM)=COUP(KM1)
      JM(KM)=K0F(JM(KM1))
      GO TO 40
C     NN
42    IWAY(KM)=4
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 43
      IF(K1F(JM(KM1)).EQ.0)GO TO 43
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM)=COUP(KM1)
      JM(KM)=K1F(JM(KM1))
      GO TO 40
C     OO
43    IWAY(KM)=5
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 44
      IF(K2F(JM(KM1)).EQ.0)GO TO 44
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM)=BL2(IB(J2(KM1))+2)*BL2(IB(J2(KM1))+1)*COUP(KM1)
      JM(KM)=K2F(JM(KM1))
      GO TO 40
C     PP
44    IWAY(KM)=6
      IF(K3(IT1+J1(KM1)).EQ.0.OR.K3(IT2+J2(KM1)).EQ.0)GO TO 55
      IF(K3F(JM(KM1)).EQ.0)GO TO 55
      J1(KM)=K3(IT1+J1(KM1))
      J2(KM)=K3(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP(KM)=COUP(KM1)
      JM(KM)=K3F(JM(KM1))
      GO TO 40
52    IWAYKM=IWAY(KM)
      GO TO (59,61,62,63,64,65,55),IWAYKM
59    IWAY(KM)=2
C     (NJ,RQ,JN)
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 61
      WMP=D0
      WPP=D0
      IF(K1F(JM1(KM1)).EQ.0)GO TO 161
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM)=-BL1(IB(J2(KM1))+1)*COUP1(KM1)
      JM1(KM)=K1F(JM1(KM1))
      IF(K2F(JM1(KM1)).NE.0)GO TO 162
      IF(K1F(JM(KM1)).NE.0)GO TO 163
      GO TO 40
161   IF(K2F(JM1(KM1)).EQ.0)GO TO 164
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
162   WMP=-D1/((IB(J2(KM1))+1)*IB(J2(KM1)))
      JM(KM)=K2F(JM1(KM1))
      IF(K1F(JM(KM1)).EQ.0)GO TO 165
      GO TO 163
164   IF(K1F(JM(KM1)).EQ.0)GO TO 61
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
163   WPP=-BL1(IB(J2(KM1))+2)
      JM(KM)=K1F(JM(KM1))
165   COUP(KM)=WMP*COUP1(KM1)+WPP*COUP(KM1)
      GO TO 40
C     (KO,OK,QR)
61    IWAY(KM)=3
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 62
      WMM=D0
      WPM=D0
      IF(K2F(JM(KM1)).EQ.0)GO TO 261
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM)=-BL2(IB(J2(KM1))+1)*COUP(KM1)
      JM(KM)=K2F(JM(KM1))
      IF(K2F(JM1(KM1)).NE.0)GO TO 262
      IF(K1F(JM(KM1)).NE.0)GO TO 263
      GO TO 40
261   IF(K2F(JM1(KM1)).EQ.0)GO TO 264
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
262   WMM=-BL2(IB(J2(KM1)))
      JM1(KM)=K2F(JM1(KM1))
      IF(K1F(JM(KM1)).EQ.0)GO TO 265
      GO TO 263
264   IF(K1F(JM(KM1)).EQ.0)GO TO 62
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
263   WPM=-D1/((IB(J2(KM1))+1)*(IB(J2(KM1))+2))
      JM1(KM)=K1F(JM(KM1))
265   COUP1(KM)=WMM*COUP1(KM1)+WPM*COUP(KM1)
      GO TO 40
C     (MI,IM)
62    IWAY(KM)=4
      IF(K0(IT1+J1(KM1)).EQ.0.OR.K0(IT2+J2(KM1)).EQ.0)GO TO 63
      IF(K0F(JM1(KM1)).EQ.0)GO TO 361
      J1(KM)=K0(IT1+J1(KM1))
      J2(KM)=K0(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)
      ICOUP(KM)=ICOUP(KM1)
      COUP1(KM)=COUP1(KM1)
      JM1(KM)=K0F(JM1(KM1))
      IF(K0F(JM(KM1)).EQ.0)GO TO 40
      GO TO 362
361   IF(K0F(JM(KM1)).EQ.0)GO TO 63
      J1(KM)=K0(IT1+J1(KM1))
      J2(KM)=K0(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)
      ICOUP(KM)=ICOUP(KM1)
362   COUP(KM)=COUP(KM1)
      JM(KM)=K0F(JM(KM1))
      GO TO 40
C     (PL,LP)
63    IWAY(KM)=5
      IF(K3(IT1+J1(KM1)).EQ.0.OR.K3(IT2+J2(KM1)).EQ.0)GO TO 64
      IF(K3F(JM1(KM1)).EQ.0)GO TO 461
      J1(KM)=K3(IT1+J1(KM1))
      J2(KM)=K3(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP1(KM)=COUP1(KM1)
      JM1(KM)=K3F(JM1(KM1))
      IF(K3F(JM(KM1)).EQ.0)GO TO 40
      GO TO 462
461   IF(K3F(JM(KM1)).EQ.0)GO TO 64
      J1(KM)=K3(IT1+J1(KM1))
      J2(KM)=K3(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),3)
462   COUP(KM)=COUP(KM1)
      JM(KM)=K3F(JM(KM1))
      GO TO 40
C     (OQ,QN)
64    IWAY(KM)=6
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 65
      WMP=D0
      WPP=D0
      IF(K2F(JM1(KM1)).EQ.0)GO TO 561
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      WMP=BL2(IB(J2(KM1)))/IB(J2(KM1))
      JM(KM)=K2F(JM1(KM1))
      IF(K1F(JM(KM1)).EQ.0)GO TO 562
      GO TO 563
561   IF(K1F(JM(KM1)).EQ.0)GO TO 65
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
563   WPP=-D1/(IB(J2(KM1))+1)
      JM(KM)=K1F(JM(KM1))
562   COUP(KM)=WMP*COUP1(KM1)+WPP*COUP(KM1)
      GO TO 40
C     (RK,JR)
65    IWAY(KM)=7
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 55
      WMM=D0
      WPM=D0
      IF(K2F(JM1(KM1)).EQ.0)GO TO 661
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      WMM=D1/(IB(J2(KM1))+1)
      JM1(KM)=K2F(JM1(KM1))
      IF(K1F(JM(KM1)).EQ.0)GO TO 662
      GO TO 663
661   IF(K1F(JM(KM1)).EQ.0)GO TO 55
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
663   WPM=-BL1(IB(J2(KM1))+2)/(IB(J2(KM1))+2)
      JM1(KM)=K1F(JM(KM1))
662   COUP1(KM)=WMM*COUP1(KM1)+WPM*COUP(KM1)
      GO TO 40
53    IWAYKM=IWAY(KM)
      GO TO (69,71,72,73,74,55),IWAYKM
69    IWAY(KM)=2
C     (QJ,KQ)
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 71
      IF(K1F(JM1(KM1)).EQ.0)GO TO 171
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM)=BL1(IB(J2(KM1))+1)*COUP1(KM1)/(IB(J2(KM1))-1)
      JM1(KM)=K1F(JM1(KM1))
      IF(K2F(JM1(KM1)).EQ.0)GO TO 40
      GO TO 172
171   IF(K2F(JM1(KM1)).EQ.0)GO TO 71
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
172   COUP(KM)=-COUP1(KM1)/IB(J2(KM1))
      JM(KM)=K2F(JM1(KM1))
      GO TO 40
C     II
71    IWAY(KM)=3
      IF(K0(IT1+J1(KM1)).EQ.0.OR.K0(IT2+J2(KM1)).EQ.0)GO TO 72
      IF(K0F(JM1(KM1)).EQ.0)GO TO 72
      J1(KM)=K0(IT1+J1(KM1))
      J2(KM)=K0(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)
      ICOUP(KM)=ICOUP(KM1)
      COUP1(KM)=COUP1(KM1)
      JM1(KM)=K0F(JM1(KM1))
      GO TO 40
C     JJ
72    IWAY(KM)=4
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 73
      IF(K1F(JM1(KM1)).EQ.0)GO TO 73
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP1(KM)=BL1(IB(J2(KM1)))*BL1(IB(J2(KM1))+1)*COUP1(KM1)
      JM1(KM)=K1F(JM1(KM1))
      GO TO 40
C     KK
73    IWAY(KM)=5
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 74
      IF(K2F(JM1(KM1)).EQ.0)GO TO 74
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP1(KM)=COUP1(KM1)
      JM1(KM)=K2F(JM1(KM1))
      GO TO 40
C     LL
74    IWAY(KM)=6
      IF(K3(IT1+J1(KM1)).EQ.0.OR.K3(IT2+J2(KM1)).EQ.0)GO TO 55
      IF(K3F(JM1(KM1)).EQ.0)GO TO 55
      J1(KM)=K3(IT1+J1(KM1))
      J2(KM)=K3(IT2+J2(KM1))
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),3)
      COUP1(KM)=COUP1(KM1)
      JM1(KM)=K3F(JM1(KM1))
      GO TO 40
55    ISTOP=1
40      Continue
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "macros.fh"

subroutine Unused_real(r)

use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: r

unused_var(r)

end subroutine Unused_real

!***********************************************************************

subroutine Unused_real_array(r)

use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: r(*)

unused_var(r(1))

end subroutine Unused_real_array

!***********************************************************************

subroutine Unused_integer(i)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: i

unused_var(i)

end subroutine Unused_integer

!***********************************************************************

subroutine Unused_integer_array(i)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: i(*)

unused_var(i(1))

end subroutine Unused_integer_array

!***********************************************************************

subroutine Unused_logical(l)

use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: l

unused_var(l)

end subroutine Unused_logical

!***********************************************************************

subroutine Unused_character(c)

implicit none
character, intent(in) :: c(*)

unused_var(c(1))

end subroutine Unused_character

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SIGMA_1(ISGSTRUCT,ICISTRUCT,IXSTRUCT,
     &                 NMIDV,MXEO,NVTAB,NICOUP,ISM,
     &                 IP,IQ,CPQ,ISYCI,CI,SGM,NOCSF,IOCSF,NOW,
     &                 IOW,NOCP,IOCP,ICOUP,VTAB,MVL,MVR)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='SIGMA_1')
      DIMENSION ISM(*)
      DIMENSION NOCSF(NSYM,NMIDV,NSYM),IOCSF(NSYM,NMIDV,NSYM)
      DIMENSION NOW(2,NSYM,NMIDV),IOW(2,NSYM,NMIDV)
      DIMENSION NOCP(MXEO,NSYM,NMIDV),IOCP(MXEO,NSYM,NMIDV)
      DIMENSION VTAB(NVTAB)
      DIMENSION ICOUP(3,NICOUP)
      DIMENSION MVL(NMIDV,2),MVR(NMIDV,2)
      DIMENSION CI(*),SGM(*)
#include "Struct.fh"
#include "symmul.fh"
      Dimension iSGStruct(nSGSize)
      Dimension iCIStruct(nCISize)
      Dimension iXStruct (nXSize)
#include "WrkSpc.fh"
      SAVE ICALL
      DATA ICALL /0/




      NLEV  =ISGSTRUCT(2)
      MIDLEV=ISGSTRUCT(8)
      NIPWLK=ICISTRUCT(2)
      LICASE=ICISTRUCT(9)
      NT1MX =IXSTRUCT(10)
      NT2MX =IXSTRUCT(11)
      NT3MX =IXSTRUCT(12)
      NT4MX =IXSTRUCT(13)

      IF(ABS(CPQ).LT.1.0D-12) GOTO 999
      ICALL=ICALL+1
C SYMMETRY OF ORBITALS:
      ISYP=ISM(IP)
      ISYQ=ISM(IQ)
      ISYPQ=MUL(ISYP,ISYQ)
C SYMMETRY OF SIGMA ARRAY:
      ISYSGM=MUL(ISYPQ,ISYCI)
      IF(IP.GT.IQ) THEN
C THEN THIS IS AN EXCITING OPERATOR.
        IF(IP.LE.MIDLEV) GOTO 1600
        IF(IQ.GT.MIDLEV) GOTO 1700
        GOTO 1800
      ELSE IF(IQ.GT.IP) THEN
C THEN THIS IS A DEEXCITING OPERATOR.
        IF(IQ.LE.MIDLEV) GOTO 1300
        IF(IP.GT.MIDLEV) GOTO 1400
        GOTO 1500
      END IF
      IF(IP.GT.MIDLEV) GOTO 1200
C SPECIAL CASE: WEIGHT OPERATOR, IP=IQ.
C IP=IQ < MIDLEV.
      DO 100 MVSGM=1,NMIDV
        DO 101 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 101
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          NDWNSG=NOW(2,ISYDSG,MVSGM)
          IOLW=IOW(2,ISYDSG,MVSGM)
          IPSHFT=2*(IP-1)
          LLW=LICASE+IOLW-NIPWLK+IPSHFT/30
          IPSHFT=MOD(IPSHFT,30)
          IPPOW=2**IPSHFT
          DO 102 J=1,NDWNSG
            JC=IWORK(LLW+J*NIPWLK)
CPAM96            ICS=IAND(ISHFT(JC,-IPSHFT),3)
            ICS=MOD(JC/IPPOW,4)
            IF(ICS.EQ.0) GOTO 102
            X=CPQ*DBLE((1+ICS)/2)
            JSTA=ISGSTA+NUPSG*(J-1)
            CALL DAXPY_(NUPSG,X,CI(JSTA),1,SGM(JSTA),1)
102       CONTINUE
101     CONTINUE
100   CONTINUE
      GOTO 999
1200  CONTINUE
C SPECIAL CASE: WEIGHT OPERATOR, IP=IQ.
C IP=IQ>MIDLEV
      DO 200 MVSGM=1,NMIDV
        DO 201 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 201
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          NDWNSG=NOW(2,ISYDSG,MVSGM)
          IOUW=IOW(1,ISYUSG,MVSGM)
          IPSHFT=2*(IP-1-MIDLEV)
          LUW=LICASE+IOUW-NIPWLK+IPSHFT/30
          IPSHFT=MOD(IPSHFT,30)
          IPPOW=2**IPSHFT
          DO 202 I=1,NUPSG
            IC=IWORK(LUW+I*NIPWLK)
CPAM96            ICS=IAND(ISHFT(IC,-IPSHFT),3)
            ICS=MOD(IC/IPPOW,4)
            IF(ICS.EQ.0) GOTO 202
            X=CPQ*DBLE((1+ICS)/2)
            ISTA=ISGSTA-1+I
            CALL DAXPY_(NDWNSG,X,CI(ISTA),NUPSG,SGM(ISTA),NUPSG)
202       CONTINUE
201     CONTINUE
200   CONTINUE
      GOTO 999
1300  CONTINUE
C DEEXCITING OPERATOR, IP<IQ<=MIDLEV.
      DO 300 MVSGM=1,NMIDV
        DO 301 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 301
          ISYDSG=MUL(ISYUSG,ISYSGM)
          ISYDC=MUL(ISYPQ,ISYDSG)
          NDWNC=NOW(2,ISYDC,MVSGM)
          IF(NDWNC.EQ.0) GOTO 301
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          IOC=IOCSF(ISYUSG,MVSGM,ISYCI)
          INDEO=2*NLEV+(IQ*(IQ-1))/2+IP
          NCP=NOCP(INDEO,ISYDSG,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYDSG,MVSGM)
C CASE IS: LOWER HALF, DEEXCITE:
            CALL DEX1 (CPQ,NUPSG,CI(IOC+1),SGM(ISGSTA),
     *             NCP,ICOUP(1,LICP),VTAB)
          END IF
301     CONTINUE
300   CONTINUE
      GOTO 999
1400  CONTINUE
C DEEXCITING OPERATOR, MIDLEV<IP<IQ
      DO 400 MVSGM=1,NMIDV
        DO 401 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 401
          ISYUC=MUL(ISYPQ,ISYUSG)
          NUPC=NOW(1,ISYUC,MVSGM)
          IF (NUPC.EQ.0) GOTO 401
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          NDWNSG=NOW(2,ISYDSG,MVSGM)
          IOC=IOCSF(ISYUC,MVSGM,ISYCI)
          INDEO=2*NLEV+(IQ*(IQ-1))/2+IP
          NCP=NOCP(INDEO,ISYUSG,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYUSG,MVSGM)
C CASE IS: UPPER HALF, DEEXCITE:
            CALL DEX2 (CPQ,NDWNSG,NUPC,CI(IOC+1),NUPSG,SGM(ISGSTA),
     *             NCP,ICOUP(1,LICP),VTAB)
          END IF
401     CONTINUE
400   CONTINUE
      GOTO 999
1500  CONTINUE
C DEEXCITING CASE, IP<=MIDLEV<IQ.
C ALLOCATE TEMPORARY WORK AREA:
        NTMPMX=MAX(NT1MX,NT2MX)
        CALL GETMEM('TMP   ','ALLO','REAL',LTMP,NTMPMX)
      DO 500 MVSGM=1,NMIDV
        MV4=MVR(MVSGM,1)
        MV5=MVR(MVSGM,2)
        DO 501 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 501
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          ISYUC=MUL(ISYQ,ISYUSG)
          ISYDC=MUL(ISYP,ISYDSG)
          IF(MV4.EQ.0) GOTO 499
          NUPC=NOW(1,ISYUC,MV4)
          IF(NUPC.EQ.0) GOTO 499
          NDWNC=NOW(2,ISYDC,MV4)
          IF(NDWNC.EQ.0) GOTO 499
          INDEO=IQ
          NCP=NOCP(INDEO,ISYUSG,MVSGM)
          IF(NCP.EQ.0) GOTO 499
          NTMP=NUPSG*NDWNC
          CALL FZERO(WORK(LTMP),NTMP)
          LICP=1+IOCP(INDEO,ISYUSG,MVSGM)
          IOC=IOCSF(ISYUC,MV4,ISYCI)
C CASE IS: UPPER HALF, DEEXCITE:
          CALL DEX2 (CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,WORK(LTMP),
     *             NCP,ICOUP(1,LICP),VTAB)
          INDEO=IP
          NCP=NOCP(INDEO,ISYDSG,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYDSG,MVSGM)
C CASE IS: LOWER HALF, DEEXCITE:
            X=1.0D00
            CALL DEX1 (X,NUPSG,WORK(LTMP),SGM(ISGSTA),
     *               NCP,ICOUP(1,LICP),VTAB)
          END IF
499       CONTINUE
          IF(MV5.EQ.0) GOTO 501
          NUPC=NOW(1,ISYUC,MV5)
          IF(NUPC.EQ.0) GOTO 501
          NDWNC=NOW(2,ISYDC,MV5)
          IF(NDWNC.EQ.0) GOTO 501
          INDEO=NLEV+IQ
          NCP=NOCP(INDEO,ISYUSG,MVSGM)
          IF(NCP.EQ.0) GOTO 501
          NTMP=NUPSG*NDWNC
          CALL FZERO(WORK(LTMP),NTMP)
          LICP=1+IOCP(INDEO,ISYUSG,MVSGM)
          IOC=IOCSF(ISYUC,MV5,ISYCI)
C CASE IS: UPPER HALF, DEEXCITE:
          CALL DEX2 (CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,WORK(LTMP),
     *             NCP,ICOUP(1,LICP),VTAB)
          INDEO=NLEV+IP
          NCP=NOCP(INDEO,ISYDSG,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYDSG,MVSGM)
C CASE IS: LOWER HALF, DEEXCITE:
            X=1.0D00
            CALL DEX1 (X,NUPSG,WORK(LTMP),SGM(ISGSTA),
     *               NCP,ICOUP(1,LICP),VTAB)
          END IF
501     CONTINUE
500   CONTINUE
      CALL GETMEM('TMP   ','FREE','REAL',LTMP,NTMPMX)
      GOTO 999
1600  CONTINUE
C EXCITING CASE, IQ<IP<=MIDLEV.
      DO 600 MVSGM=1,NMIDV
        DO 601 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 601
          ISYDSG=MUL(ISYUSG,ISYSGM)
          ISYDC=MUL(ISYPQ,ISYDSG)
          NDWNC=NOW(2,ISYDC,MVSGM)
          IF(NDWNC.EQ.0) GOTO 601
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          IOC=IOCSF(ISYUSG,MVSGM,ISYCI)
          INDEO=2*NLEV+(IP*(IP-1))/2+IQ
          NCP=NOCP(INDEO,ISYDC,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYDC,MVSGM)
C CASE IS: LOWER HALF, EXCITE:
            CALL EXC1 (CPQ,NUPSG,CI(IOC+1),SGM(ISGSTA),
     *             NCP,ICOUP(1,LICP),VTAB)
          END IF
601     CONTINUE
600   CONTINUE
      GOTO 999
1700  CONTINUE
C EXCITING CASE, MIDLEV<IQ<IP
      DO 700 MVSGM=1,NMIDV
        DO 701 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 701
          ISYUC=MUL(ISYPQ,ISYUSG)
          NUPC=NOW(1,ISYUC,MVSGM)
          IF (NUPC.EQ.0) GOTO 701
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          NDWNSG=NOW(2,ISYDSG,MVSGM)
          IOC=IOCSF(ISYUC,MVSGM,ISYCI)
          INDEO=2*NLEV+(IP*(IP-1))/2+IQ
          NCP=NOCP(INDEO,ISYUC,MVSGM)
          IF(NCP.GT.0) THEN
            LICP=1+IOCP(INDEO,ISYUC,MVSGM)
C CASE IS: UPPER HALF, EXCITE:
            CALL EXC2 (CPQ,NDWNSG,NUPC,CI(IOC+1),NUPSG,SGM(ISGSTA),
     *             NCP,ICOUP(1,LICP),VTAB)
          END IF
701     CONTINUE
700   CONTINUE
      GOTO 999
1800  CONTINUE
C EXCITING CASE, IQ<=MIDLEV<IP
C ALLOCATE TEMPORARY WORK AREAS:
      NTMPMX=MAX(NT3MX,NT4MX)
      CALL GETMEM('TMP   ','ALLO','REAL',LTMP,NTMPMX)
      DO 800 MVSGM=1,NMIDV
        MV1=MVL(MVSGM,2)
        MV2=MVL(MVSGM,1)
        IF((MV1.EQ.0).AND.(MV2.EQ.0)) GOTO 800
        DO 801 ISYUSG=1,NSYM
          NS1=NOCSF(ISYUSG,MVSGM,ISYSGM)
          IF(NS1.EQ.0) GOTO 801
          ISGSTA=1+IOCSF(ISYUSG,MVSGM,ISYSGM)
          NUPSG=NOW(1,ISYUSG,MVSGM)
          ISYDSG=MUL(ISYUSG,ISYSGM)
          ISYUC=MUL(ISYP,ISYUSG)
          ISYDC=MUL(ISYQ,ISYDSG)
          IF(MV2.EQ.0) GOTO 799
          NUPC=NOW(1,ISYUC,MV2)
          IF(NUPC.EQ.0) GOTO 799
          NDWNC=NOW(2,ISYDC,MV2)
          IF(NDWNC.EQ.0) GOTO 799
          INDEO=IP
          NCP=NOCP(INDEO,ISYUC,MV2)
          IF(NCP.EQ.0) GOTO 799
          NTMP=NUPSG*NDWNC
          CALL FZERO(WORK(LTMP),NTMP)
          LICP=1+IOCP(INDEO,ISYUC,MV2)
          IOC=IOCSF(ISYUC,MV2,ISYCI)
C CASE IS: UPPER HALF, EXCITE:
          CALL EXC2 (CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,WORK(LTMP),
     *             NCP,ICOUP(1,LICP),VTAB)
          INDEO=IQ
          NCP=NOCP(INDEO,ISYDC,MV2)
          IF(NCP.EQ.0) GOTO 799
          LICP=1+IOCP(INDEO,ISYDC,MV2)
C CASE IS: LOWER HALF, EXCITE:
          X=1.0D00
          CALL EXC1 (X,NUPSG,WORK(LTMP),SGM(ISGSTA),
     *               NCP,ICOUP(1,LICP),VTAB)
799       CONTINUE
          IF(MV1.EQ.0) GOTO 801
          NUPC=NOW(1,ISYUC,MV1)
          IF(NUPC.EQ.0) GOTO 801
          NDWNC=NOW(2,ISYDC,MV1)
          IF(NDWNC.EQ.0) GOTO 801
          INDEO=NLEV+IP
          NCP=NOCP(INDEO,ISYUC,MV1)
          IF(NCP.EQ.0) GOTO 801
          NTMP=NUPSG*NDWNC
          CALL FZERO(WORK(LTMP),NTMP)
          LICP=1+IOCP(INDEO,ISYUC,MV1)
          IOC=IOCSF(ISYUC,MV1,ISYCI)
C CASE IS: UPPER HALF, EXCITE:
          CALL EXC2 (CPQ,NDWNC,NUPC,CI(IOC+1),NUPSG,WORK(LTMP),
     *             NCP,ICOUP(1,LICP),VTAB)
          INDEO=NLEV+IQ
          NCP=NOCP(INDEO,ISYDC,MV1)
          IF(NCP.EQ.0) GOTO 801
          LICP=1+IOCP(INDEO,ISYDC,MV1)
C CASE IS: LOWER HALF, EXCITE:
          X=1.0D00
          CALL EXC1 (X,NUPSG,WORK(LTMP),SGM(ISGSTA),
     *               NCP,ICOUP(1,LICP),VTAB)
801   CONTINUE
800   CONTINUE
      CALL GETMEM('TMP   ','FREE','REAL',LTMP,NTMPMX)

999   CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Francesco Aquilante                              *
************************************************************************
      SubRoutine DrvEMBg(Grad,Temp,nGrad)
************************************************************************
*                                                                      *
* Object: driver for computation of gradient with respect to the OFE   *
*         energy (DFT-type contribution only)                          *
*                                                                      *
*                                                                      *
*         int{ [Vxc^nad(r) + Ts^nad(r) + Vnuc^B(r)] (drhoA/dRk) dr }   *
*                                                                      *
*                                                                      *
* Note:  rho=rho_A+rho_B  where the dmat elements of rho_B on the bsfs *
*                         of A have been annihilated. This also gives  *
*                         drhoA/dRk=drho/dRk (for Rk in A)             *
*                                                                      *
* Called from: Alaska                                                  *
*                                                                      *
*                                                                      *
*     Author: F. Aquilante, Dept. of Phys. Chem.                       *
*             University of Geneva, Switzerland                        *
************************************************************************
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
#include "disp.fh"
#include "nq_info.fh"
      Character*16  OFE_KSDFT
      COMMON  / OFembed_C / OFE_KSDFT
      Character Label*80
      Real*8 Grad(nGrad), Temp(nGrad)
      Logical Do_Grad, King
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu1,TWall1)
*                                                                      *
************************************************************************
*                                                                      *
*...  Prologue
      iRout = 131
      iPrint = nPrint(iRout)
      LuWr=6
*
      Call StatusLine(' Alaska:',' Computing OFembedding gradients')
*
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
      nDens = 0
      Do iIrrep = 0, nIrrep - 1
         nDens = nDens + nBas(iIrrep)*(nBas(iIrrep)+1)/2
      End Do
*
*     DFT-OFE    gradient                                              *
************************************************************************
*                                                                      *
      Do_Grad=.True.
      Call DrvEMB_(nDens,OFE_KSDFT,Do_Grad,Temp,nGrad,'SCF ')
*
      iEnd=1
 99   Continue
      If (OFE_KSDFT(iEnd:iEnd).eq.' ') Then
         iEnd = iEnd - 1
      Else
         iEnd = iEnd + 1
         Go To 99
      End If
      Label='DFT-OFE('//OFE_KSDFT(1:iEnd)//') contribution'
      jPrint=nPrint(112)
      If (jPrint.ge.15) Call PrGrad(Label,Temp,nGrad,ChDisp,5)
      If (king()) Call DaXpY_(nGrad,One,Temp,1,Grad,1)
      If (iPrint.lt.6) Go To 777
      Write (LuWr,*)
      If (Grid_Type.eq.Moving_Grid) Then
         Write(LuWr,*)'DFT-OFE contribution computed for a moving grid.'
      Else
         Write(LuWr,*)'DFT-OFE contribution computed for a fixed grid.'
      End If
      Write (LuWr,*)
 777  Continue
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_iSD()
      Call CWTime(TCpu2,TWall2)
      Call SavTim(5,TCpu2-TCpu1,TWall2-TWall1)
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine DrvEMB_(nh1,KSDFT,Do_Grad,Grad,nGrad,DFTFOCK)
************************************************************************
************************************************************************
*** Orbital-Free Embedding calculation (gradients)                   ***
***                                                                  ***
***                                                                  ***
*** Author: F. Aquilante, Geneva Nov  2010                           ***
***                                                                  ***
************************************************************************
************************************************************************
      Implicit Real*8 (a-h,o-z)
      External LSDA_emb, Checker
#include "real.fh"
#include "stdalloc.fh"
#include "debug.fh"
      Real*8 Grad(nGrad)
      Logical Do_Grad
      Character*(*) KSDFT
      Character*4 DFTFOCK
      Character*16 NamRfil
      Real*8, Allocatable:: Grad_A(:), F_DFT(:,:), D_DS(:,:)
      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_R1/ Xsigma
      COMMON  / OFembed_R2/ dFMD
      Real*8, Allocatable:: Fcorr(:,:)
*
      Debug=.False.
*                                                                      *
************************************************************************
*                                                                      *
      If (.not.Do_Grad) Then
         Call WarningMessage(2,'DrvEMB_: Do_Grad must be .true.')
         Call Abend()
      EndIf
      Call FZero(Grad,nGrad)
      Call mma_allocate(Grad_A,nGrad,Label='Grad_A')
      Grad_A(:)=Zero
************************************************************************
*                                                                      *
*     Setup of density matrices for subsys B (environment)             *
*                                                                      *
************************************************************************
      Call Get_NameRun(NamRfil) ! save the old RUNFILE name
      Call NameRun('AUXRFIL')   ! switch RUNFILE name
*                                                                      *
************************************************************************
*                                                                      *
      nD=4
      Call mma_allocate(F_DFT,nh1,nD,Label='F_DFT')
      Call mma_allocate(D_DS,nh1,nD,Label='D_DS')
*
*---- Get the density matrix of the environment (rho_B)
*
      Call Get_iScalar('Multiplicity',kSpin)
      Call Get_D1ao(D_DS(1,1),nh1)
*     Call RecPrt('D_DS(1,1)',' ',D_DS(1,1),nh1,1)
*
*
*---- Get the spin density matrix of the environment
*
      If (kSpin.ne.1) Then
         Call Get_D1Sao(D_DS(1,2),nh1)
*        Call RecPrt('D1Sao',' ',D_DS(1,2),nh1,1)
      End If
*
*---- Compute alpha and beta density matrices of the environment
*
      nFckDim=2
      If (kSpin.eq.1) Then
         call dscal_(nh1,Half,D_DS(1,1),1)
         call dcopy_(nh1,D_DS(1,1),1,D_DS(1,2),1)
         nFckDim=1
      Else
         Do i = 1, nh1
            DTot=D_DS(i,1)
            DSpn=D_DS(i,2)
            d_Alpha=Half*(DTot+DSpn)
            d_Beta =Half*(DTot-DSpn)
            D_DS(i,1)=d_Alpha
            D_DS(i,2)=d_Beta
         End Do
*      Call RecPrt('Da',' ',D_DS(1,1),nh1,1)
*      Call RecPrt('Db',' ',D_DS(1,2),nh1,1)
      End If
*

      If (KSDFT(1:4).eq.'NDSD') Then

         Call wrap_DrvNQ(KSDFT,F_DFT,nFckDim,Func_B,
     &                   D_DS,nh1,nFckDim,
     &                   Do_Grad,
     &                   Grad,nGrad,DFTFOCK)

         KSDFT(1:4)='LDTF' !set to Thomas-Fermi for subsequent calls
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
*     Setup of density matrices for subsys A                           *
*                                                                      *
************************************************************************
      Call NameRun(NamRfil)    ! switch back RUNFILE name
*
*---- Get the density matrix for rho_A
*
      Call Get_D1ao(D_DS(1,3),nh1)
*     Call RecPrt('D_DS(1,3)',' ',D_DS(1,3),nh1,1)
*
      Call Get_iScalar('Multiplicity',iSpin)
      If (iSpin.eq.1 .and. kSpin.ne.1) Then
         Call WarningMessage(0,
     &     ' Non-singlet environment perturbation on singlet state!'//
     &     '  Spin-components of the OFE potential will be averaged. ' )
      EndIf
*
*---- Get the spin density matrix of A
*
      If (iSpin.ne.1) Then
         Call Get_D1Sao(D_DS(1,4),nh1)
*        Call RecPrt('D1Sao',' ',D_DS(1,4),nh1,1)
      End If
*
*---- Compute alpha and beta density matrices of subsystem A
*
      nFckDim=2
      If (iSpin.eq.1) Then
         call dscal_(nh1,Half,D_DS(1,3),1)
         call dcopy_(nh1,D_DS(1,3),1,D_DS(1,4),1)
         If (kSpin.eq.1) nFckDim=1
      Else
         Do i = 1, nh1
            DTot=D_DS(i,3)
            DSpn=D_DS(i,4)
            d_Alpha=Half*(DTot+DSpn)
            d_Beta =Half*(DTot-DSpn)
            D_DS(i,3)=d_Alpha
            D_DS(i,4)=d_Beta
         End Do
*      Call RecPrt('Da',' ',D_DS(1,3),nh1,1)
*      Call RecPrt('Db',' ',D_DS(1,4),nh1,1)
      End If
*
      Call wrap_DrvNQ(KSDFT,F_DFT(1,3),nFckDim,Func_A,
     &                D_DS(1,3),nh1,nFckDim,
     &                Do_Grad,
     &                Grad_A,nGrad,DFTFOCK)

      Call daxpy_(nGrad,-1.0d0,Grad_A,1,Grad,1)
*
*  Fraction of correlation potential from A (cases: HF or Trunc. CI)
      If (dFMD.gt.0.0d0) Then
*
         Grad_A(:)=Zero
         Call mma_allocate(Fcorr,nh1,nFckDim,Label='Fcorr')

         Call cwrap_DrvNQ(KSDFT,F_DFT(1,3),nFckDim,Func_A,
     &                    D_DS(1,3),nh1,nFckDim,
     &                    Do_Grad,
     &                    Grad_A,nGrad,DFTFOCK,Fcorr)

         Call get_dScalar('NAD dft energy',Energy_NAD)
         Fakt_ = Xlambda(abs(Energy_NAD),Xsigma)
         Call daxpy_(nGrad,Fakt_,Grad_A,1,Grad,1)

         Call mma_deallocate(Fcorr)
      End If
*
      Call mma_deallocate(Grad_A)
*
      Call Get_NameRun(NamRfil) ! save the old RUNFILE name
      Call NameRun('AUXRFIL')   ! switch RUNFILE name
*
      Call wrap_DrvNQ('NUCATT_EMB',F_DFT,nFckDim,Func_X,
     &                D_DS(1,3),nh1,nFckDim,
     &                Do_Grad,
     &                Grad,nGrad,DFTFOCK)
*
      Call NameRun(NamRfil)   ! switch back RUNFILE name
*
************************************************************************
*                                                                      *
*     Calculation on the supermolecule                                 *
*                                                                      *
************************************************************************
      nFckDim=2
      If (iSpin.eq.1 .and. kSpin.eq.1) Then
         nFckDim=1
         Call daxpy_(nh1,One,D_DS(1,3),1,D_DS(1,1),1)
      Else
         Call daxpy_(nh1,One,D_DS(1,3),1,D_DS(1,1),1)
         Call daxpy_(nh1,One,D_DS(1,4),1,D_DS(1,2),1)
      EndIf

      Call wrap_DrvNQ(KSDFT,F_DFT,nFckDim,Func_AB,
     &                D_DS,nh1,nFckDim,
     &                Do_Grad,
     &                Grad,nGrad,DFTFOCK)
*
      Call mma_deallocate(F_DFT)
      Call mma_deallocate(D_DS)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_XCV_WrVec(irc,Vec,l_Vec,NVT,l_NVT,myRankSP,l_myRankSP,SP)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: write partial Cholesky vectors to disk.
!          (Parallel two-step algorithm)

use Cholesky, only: Cho_Real_Par
#ifdef _DEBUGPRINT_
use Cholesky, only: nnBstRSh, nnShl, nSym, NumCho
#endif
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: l_Vec, l_NVT, NVT(l_NVT), l_myRankSP, myRankSP(l_myRankSP), SP
real(kind=wp), intent(_IN_) :: Vec(l_Vec)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iSP, iSym, n

if ((l_NVT < nSym) .or. (l_myRankSP < nnShl)) then
  irc = -1
  return
end if
if ((SP < 1) .or. (SP > nnShl)) then
  irc = -2
  return
end if
iSP = myRankSP(SP)
n = nnBstRSh(1,iSP,2)*NVT(1)
do iSym=2,nSym
  n = n+nnBstRSh(iSym,iSP,2)*NVT(iSym)
end do
if (l_Vec < n) then
  irc = -3
  return
end if

if (.not. Cho_Real_Par) then
  n = 0
  do iSym=1,nSym
    if (NVT(iSym) /= NumCho(iSym)) n = n+1
  end do
  if (n /= 0) then
    irc = -4
    return
  end if
  if (SP /= myRankSP(SP)) then
    irc = -5
    return
  end if
end if
#endif

if (Cho_Real_Par) then
  ! Parallel: block write to temp files
  call Cho_XCV_WrVec_Par(irc,Vec,NVT,myRankSP,SP)
else
  ! Serial: write directly to vector files
  call Cho_XCV_WrVec_Ser(irc,Vec,SP)
end if

end subroutine Cho_XCV_WrVec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETDIAG1(DIAG,BUF,IBUF,LENBUF,NDUMP)
!
! Purpose: read diagonal in first reduced set.

use Cholesky, only: IndRed, IndRSh, INF_DIAG, IPRINT, mmBstRT, nnBstRT, nSym, RstDia
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: LENBUF, NDUMP
real(kind=wp), intent(_OUT_) :: Diag(*)
real(kind=wp), intent(out) :: BUF(LENBUF)
integer(kind=iwp), intent(out) :: IBUF(4,LENBUF)
integer(kind=iwp) :: IOPT, IRED, IRS, ISYLST(8), ISYM, NSYLST
logical(kind=iwp), parameter :: LOCDBG = .false.

! Read diagonal from file.
! ------------------------

if (RSTDIA) then
  IOPT = 2
  call CHO_IODIAG(DIAG,IOPT)
else
  DIAG(1:NNBSTRT(1)) = Zero
  INDRSH(1:NNBSTRT(1)) = 0
  INDRED(1:NNBSTRT(1),1) = 0
  call CHO_RDDBUF(DIAG,BUF,IBUF,INDRSH,INDRED,LENBUF,MMBSTRT,NDUMP)
  call CHO_GADGOP(DIAG,NNBSTRT(1),'+')
  call CHO_GAIGOP(INDRSH,NNBSTRT(1),'+')
  call CHO_GAIGOP(INDRED,NNBSTRT(1),'+')
end if

! Copy info to current reduced set (IRED=2).
! Also set up IRED=3 (although it should be redundant).
! -----------------------------------------------------

do IRS=2,3
  call CHO_RSCOPY(1,IRS)
end do

! Print.
! ------

if (LOCDBG .or. (IPRINT >= INF_DIAG)) then
  do ISYM=1,NSYM
    ISYLST(ISYM) = ISYM
  end do
  NSYLST = NSYM
  IRED = 1
  call CHO_PRTDIA(DIAG,ISYLST,NSYLST,IRED)
  if (LOCDBG) then
    IRED = 2
    call CHO_PRTDIA(DIAG,ISYLST,NSYLST,IRED)
  end if
end if

end subroutine CHO_GETDIAG1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine INDMAT_CPF(JSY,INDX,ISAB,ISMAX,JREFX)

use cpf_global, only: IFIRST, ILIM, IPRINT, IRC, IREF0, ISC, JJS, JSC, LN, LSYM, NDIAG, NNS, NSM, NSYM, NSYS, NVIR, NVIRT
use Symmetry_Info, only: Mul
use Definitions, only: iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: JSY(*), JREFX(*)
integer(kind=iwp), intent(_OUT_) :: INDX(*), ISAB(*), ISMAX
integer(kind=iwp) :: I, ICOUS(8), II, IIN, IN0, IN2, IND, IR, IR1, IR2, IX1, IX2, IX3, IX4, JCONF, JJM, JSCI, NA, NB, NSAB, NSS
integer(kind=iwp), external :: JSUNP

! DETERMINE REFERENCE STATE
JCONF = ISC(1)
do IR=1,JCONF
  if (JREFX(IR) == 1) IREF0 = IR
end do
if (IPRINT > 5) write(u6,999) IREF0,(JREFX(IR),IR=1,JCONF)

NSYS(1) = 0
do I=2,NSYM
  NSYS(I) = NSYS(I-1)+NVIR(I-1)
end do
NSYS(NSYM+1) = NVIRT
do I=1,NSYM
  ICOUS(I) = 0
  NNS(I) = 0
end do
ISMAX = 0
IN0 = -NVIRT
do NA=1,NVIRT
  IN0 = IN0+NVIRT
  IIN = IN0
  IN2 = -NVIRT+NA
  do NB=1,NA
    IIN = IIN+1
    IN2 = IN2+NVIRT
    NSAB = MUL(NSM(LN+NA),NSM(LN+NB))
    ICOUS(NSAB) = ICOUS(NSAB)+1
    ISAB(IIN) = ICOUS(NSAB)
    if (ISMAX < ISAB(IIN)) ISMAX = ISAB(IIN)
    ISAB(IN2) = ISAB(IIN)
    if (ISAB(IIN) > NNS(NSAB)) NNS(NSAB) = ISAB(IIN)
  end do
  NDIAG(NA) = ISAB(IIN)
end do
IND = 0
IR = IRC(1)
do II=1,IR
  IND = IND+1
  INDX(II) = IND
end do
JSC(1) = IND
IR1 = IR+1
IR2 = IRC(2)
do II=IR1,IR2
  INDX(II) = IND
  NSS = MUL(JSUNP(JSY,II),LSYM)
  IND = IND+NVIR(NSS)
end do
JSC(2) = IND
if (IFIRST == 0) then
  IR1 = IR2+1
  IR2 = IRC(4)
  JSC(3) = IND
  do II=IR1,IR2
    INDX(II) = IND
    NSS = MUL(JSUNP(JSY,II),LSYM)
    IND = IND+ICOUS(NSS)
    if (II == IRC(3)) JSC(3) = IND
  end do
  JSC(4) = IND
end if
IX1 = JSC(1)
IX2 = JSC(2)-JSC(1)
write(u6,213)
if (IFIRST == 0) then
  JJM = (JJS(LSYM+1)-JJS(LSYM))*NVIRT
  IX3 = JSC(3)-JSC(2)-JJM
  IX4 = JSC(4)-JSC(3)
  write(u6,215) IX1,IX2,IX3,IX4
else
  write(u6,216) IX1,IX2
  JJM = 0
end if
JSCI = JSC(ILIM)-JJM
write(u6,50) ISC(ILIM),JSCI

return

50 format(//6X,'FORMAL NUMBER OF CONFIGURATIONS',I8,/8X,'REAL NUMBER OF CONFIGURATIONS',I8)
213 format(//,6X,'FULL-SPACE CONFIGURATIONS (REAL)')
215 format(/,6X,'NUMBER OF VALENCE STATES',I16,/,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7, &
           /,6X,'NUMBER OF TRIPLET COUPLED DOUBLES',I7,/,6X,'NUMBER OF SINGLET COUPLED DOUBLES',I7)
216 format(/,6X,'NUMBER OF VALENCE STATES',I14,/,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7)
999 format(2X,I3,2X,'JREFX',10I5)

end subroutine INDMAT_CPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE THETSET(ICASE,THE,NII)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION THE(NII,NII),IOCR(100)
      DIMENSION ICASE(*)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      LOGICAL LWSP
      COMMON /SPIN/ LWSP
      JO(L)=ICUNP(ICASE,L)
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CPAM97      JO(L)=UNPACK(QOCC((L+29)/30), 2*L-(2*L-1)/60*60, 2)
*PAM06 This routine is called from SDCI if this is an MCPF calculation
C
      IOR=0
      II1=(IREF0-1)*LN
      DO 35 I=1,LN
         JOJ=JO(II1+I)
         IOR=IOR+1
         IOCR(IOR)=JOJ
35    CONTINUE
      IF(IPRINT.GT.5)WRITE(6,888)IREF0,(IOCR(I),I=1,LN)
888   FORMAT(5X,'IREF0=',I3/5X,'IOCR=',10I5)
C
      IINT=IRC(4)
      DO 8 IP=1,IINT
         DO 7 IQ=1,IINT
            THE(IQ,IP)=D1
7        CONTINUE
8     CONTINUE
C
      DO 6 IP=1,IINT
         DO 5 IQ=1,IINT
            THE(IQ,IP)=0.0D0
5        CONTINUE
6     CONTINUE
      DO 10 IP=1,IINT
         II=0
         IJ=0
         DO 15 I=1,LN
            JJ=(IP-1)*LN+I
            IF(JO(JJ).EQ.IOCR(I).OR.JO(JJ).EQ.3)GO TO 15
            IF(LWSP.AND.JO(JJ)*IOCR(I).EQ.2) GO TO 15
            IF(II.NE.0)GO TO 16
            II=I
16          IJ=I
15       CONTINUE
*PAM06 BUG: What if we come down here with II.eq.0 still??
* the IOCR will be accessed below first element. Provisional fix:
         IF(II.EQ.0) GOTO 10
         NI=IOCR(II)
         IF(NI.GT.1)NI=NI-1
         NJ=IOCR(IJ)
         IF(NJ.GT.1)NJ=NJ-1
         DO 20 IQ=1,IINT
            IK=0
            IL=0
            DO 25 I=1,LN
               JJ=(IQ-1)*LN+I
               IF(JO(JJ).EQ.IOCR(I).OR.JO(JJ).EQ.3)GO TO 25
               IF(LWSP.AND.JO(JJ)*IOCR(I).EQ.2) GO TO 25
               IF(IK.NE.0)GO TO 26
               IK=I
26             IL=I
25          CONTINUE
            IF(II.EQ.IK.AND.IJ.EQ.IL)THE(IQ,IP)=1.0D0
20       CONTINUE
10    CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
************************************************************************
      Subroutine Update_sl(iter,MaxItr,NmIter,iInt,nFix,nInter,qInt,
     &                     Shift,
     &                     Grad,iOptC,Beta,Beta_Disp,Lbl,GNrm,
     &                     Energy,UpMeth,ed,Line_Search,Step_Trunc,
     &                     nLambda,iRow_c,nsAtom,AtomLbl,
     &                     mxdc,jStab,nStab,BMx,Smmtrc,nDimBC,
     &                     rLambda,Cx,GrdMax,StpMax,GrdLbl,StpLbl,
     &                     iNeg,nLbl,Labels,nLabels,FindTS,TSC,nRowH,
     &                     nWndw,Mode,MF,
     &                     iOptH,HUpMet,kIter,GNrm_Threshold,IRC,
     &                     dMass,HrmFrq_Show,CnstWght,Curvilinear,
     &                     Degen)
************************************************************************
*                                                                      *
*     Object: to update coordinates                                    *
*                                                                      *
*    Input:                                                            *
*      iter           : iteration counter                              *
*      MaxItr         : max number of iterations                       *
*      NmIter         : number of iteration in numerical approach      *
*      iInt           : number of internal coordinates to vary         *
*      nFix           : number of frozen internal coordinates          *
*      nInter         : total number of internal coordinates           *
*      qInt(*,iter )  : the internal coordinates                       *
*      Grad(*,iter )  : the gradient in the internal coordinates       *
*      iOptC          : option flag for update methods                 *
*      Beta           : damping factor                                 *
*      Lbl            : character labels for internal coordinates      *
*      nLbl           : length of Lbl                                  *
*      GNrm           : the norm of the gradient in each iteration     *
*      Energy         : the energy of each iteration                   *
*      Line_Search    : logical flag for line search                   *
*      nLambda        : number of contraints                           *
*      iRow_c         : number of lines on the UDC file                *
*      nsAtom         : number of symmetry unique atoms                *
*      AtomLbl        : character string with atom labels              *
*      mxdc           : max number of nsAtom                           *
*      jStab          : integer list of stabilizers                    *
*      nStab          : number of stabilizers                          *
*      BMx            : the so-called Wilson B matrix                  *
*      Smmtrc         : logical flag for symmetry properties           *
*      nDimBC         : dimension of redundant coordinates(?)          *
*      rLambda        : vector for Lagrange multipliers                *
*      Cx             : pointer to cartesian coordinates               *
*      iNeg           : Hessian index                                  *
*      Labels         : character string of primitive int. coord.      *
*      nLabels        : length of Labels                               *
*      CnstWght       : constraints weight                             *
*                                                                      *
*    OutPut:                                                           *
*      Shift(*,iter ) : the shift of the internal coordinates          *
*      qInt(*,iter +1): the internal coordinates to be used in the     *
*                       next iteration                                 *
*      UpMeth         : character label with update method abrivation  *
*      ed             : estimated energy change to the next point      *
*      Step_Trunc     : character label to denote truncation type      *
*      GrdMax         : largest gradient component                     *
*      StpMax         : largest step component                         *
*      GrdLbl         : character label of component with GrdMax       *
*      StpLbl         : character label of component with StpLbl       *
*                                                                      *
*                                                                      *
*     Author: Roland Lindh                                             *
*             2000                                                     *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "Molcas.fh"
      Real*8 qInt(nInter,MaxItr), Shift(nInter,MaxItr),
     &       Grad(nInter,MaxItr), GNrm(MaxItr), Energy(MaxItr),
     &       BMx(3*nsAtom,3*nsAtom), rLambda(nLambda,MaxItr),
     &       dMass(nsAtom), Degen(3*nsAtom), MF(3*nsAtom),
     &       Cx(3*nsAtom,MaxItr+1)
      Integer jStab(0:7,nsAtom), nStab(nsAtom), iNeg(2)
      Logical Line_Search, Smmtrc(3*nsAtom),
     &        FindTS, TSC, HrmFrq_Show, Curvilinear
      Character Lbl(nLbl)*8, GrdLbl*8, StpLbl*8, Step_Trunc,
     &          Labels(nLabels)*8, AtomLbl(nsAtom)*(LENIN), UpMeth*6,
     &          HUpMet*6
      Real*8 Dummy(1)
      Real*8, Allocatable:: t_Shift(:,:), t_qInt(:,:)
*
      Logical Kriging_Hessian
*
      iRout=153
      iPrint=nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt('Update: qInt',' ',qInt,nInter,Iter)
         Call RecPrt('Update: Energy',' ',Energy,1,Iter)
         Call RecPrt('Update: Grad',' ',Grad,nInter,Iter)
*        Call RecPrt('Update: Shift',' ',Shift,nInter,Iter-1)
*        Call RecPrt('Update: GNrm',' ',GNrm,Iter,1)
      End If
*
      iOpt_RS=0
      Kriging_Hessian =.FALSE.
      qBeta=Beta
      qBeta_Disp=Beta_Disp
*                                                                      *
************************************************************************
*                                                                      *
*     Select between numerical evaluation of the Hessian or a molcular
*     geometry optimization.
*
      Step_Trunc=' '
      If (iter.eq.NmIter.and.NmIter.ne.1) Then
*                                                                      *
************************************************************************
*                                                                      *
*------- On the first iteration after a numerical evaluation of the
*        Hessian we like the step to be relative to the initial
*        structure.
*
         If (iPrint.ge.99) Write(6,*)'UpDate_SL: first iteration'
         iter_=1
         Call mma_Allocate(t_Shift,nInter,iter_,Label='t_Shift')
         Call mma_Allocate(t_qInt,nInter,iter_+1,Label='t_qInt')
*
         t_qInt(:,1)=qInt(:,1)
*
         Call Update_sl_(iter_,iInt,nFix,nInter,t_qInt,
     &                   t_Shift,Grad,iOptC,Beta,Beta_Disp,
     &                   Lbl,GNrm,Energy,UpMeth,ed,Line_Search,
     &                   Step_Trunc,nLambda,iRow_c,nsAtom,AtomLbl,
     &                   mxdc,jStab,nStab,BMx,Smmtrc,nDimBC,
     &                   rLambda,Cx,GrdMax,StpMax,GrdLbl,StpLbl,
     &                   iNeg,nLbl,Labels,nLabels,FindTS,TSC,nRowH,
     &                   nWndw,Mode,MF,
     &                   iOptH,HUpMet,kIter,GNrm_Threshold,IRC,dMass,
     &                   HrmFrq_Show,CnstWght,Curvilinear,Degen,
     &                   Kriging_Hessian,qBeta,iOpt_RS,.True.,iter_,
     &                   qBeta_Disp)
*                                                                      *
************************************************************************
*                                                                      *
*------- Move new coordinates to the correct position and compute the
*        corresponding shift.
*
         qInt(:,iter+1)=t_qInt(:,2)
         Shift(:,iter)=t_qInt(:,2)-qInt(:,iter)
*
         Call mma_deallocate(t_qInt)
         Call mma_deallocate(t_Shift)
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
*        Conventional optimization.
*
         Call Update_sl_(iter,iInt,nFix,nInter,qInt,Shift,
     &                Grad,iOptC,Beta,Beta_Disp,Lbl,GNrm,Energy,
     &                UpMeth,ed,Line_Search,Step_Trunc,nLambda,
     &                iRow_c,nsAtom,AtomLbl,mxdc,jStab,
     &                nStab,BMx,Smmtrc,nDimBC,rLambda,Cx,
     &                GrdMax,StpMax,GrdLbl,StpLbl,iNeg,nLbl,
     &                Labels,nLabels,FindTS,TSC,nRowH,
     &                nWndw,Mode,MF,
     &                iOptH,HUpMet,kIter,GNrm_Threshold,IRC,dMass,
     &                HrmFrq_Show,CnstWght,Curvilinear,Degen,
     &                Kriging_Hessian,qBeta,iOpt_RS,.True.,iter,
     &                qBeta_Disp)
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Write out the shift in internal coordinates basis.
*
      If (iPrint.ge.99) Then
         Call RecPrt(
     &      'Shifts in internal coordinate basis / au or rad',
     &      ' ',Shift,nInter,Iter)
         Call RecPrt(
     &      'qInt in internal coordinate basis / au or rad',
     &      ' ',qInt,nInter,Iter+1)
      End If
*
*---- Remove unneeded fields from the runfile
      Dummy(1)=-Zero
      Call Put_dArray('BMxOld',Dummy(1),0)
      Call Put_dArray('TROld',Dummy(1),0)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_x_Loc(irc,Thrs,nSym,nBas,nFro,nIsh,nAsh,nSsh,CMO,nCMO)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: Thrs
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nFro(nSym), nIsh(nSym), nAsh(nSym), nSsh(nSym), nCMO
real(kind=wp), intent(inout) :: CMO(nCMO)
integer(kind=iwp) :: iSym, kOff1, kOffC, l_Dens
real(kind=wp) :: yNrm
real(kind=wp), allocatable :: Dens(:)

irc = 0
l_Dens = maxval(nBas(1:nSym)**2)
call mma_allocate(Dens,l_Dens,Label='Dens')
kOffC = 0
do iSym=1,nSym
  if (nIsh(iSym) > 0) then
    kOff1 = 1+kOffC+nBas(iSym)*nFro(iSym)
    call GetDens_Localisation(Dens,CMO(kOff1),nBas(iSym),nIsh(iSym))
    CMO(kOff1:kOff1+nBas(iSym)*nIsh(iSym)-1) = Zero
    call ChoLoc(irc,Dens,CMO(kOff1),Thrs,yNrm,nBas(iSym),nIsh(iSym))
    if (irc /= 0) then
      call mma_deallocate(Dens)
      irc = 1
      return
    end if
  end if
  if (nSsh(iSym) > 0) then
    kOff1 = 1+kOffC+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
    call GetDens_Localisation(Dens,CMO(kOff1),nBas(iSym),nSsh(iSym))
    CMO(kOff1:kOff1+nBas(iSym)*nSsh(iSym)-1) = Zero
    call ChoLoc(irc,Dens,CMO(kOff1),Thrs,yNrm,nBas(iSym),nSsh(iSym))
    if (irc /= 0) then
      call mma_deallocate(Dens)
      irc = 1
      return
    end if
  end if
  kOffC = kOffC+nBas(iSym)**2
end do

call mma_deallocate(Dens)

end subroutine Cho_x_Loc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_getGV(numV,nSym)

use Cholesky, only: Cho_Real_Par, NumCho, NumCho_G
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nSym
integer(kind=iwp), intent(out) :: numV(nSym)

if (Cho_Real_Par) then
  numV(1:nSym) = numCho_G(1:nSym)
else
  numV(1:nSym) = numCho(1:nSym)
end if

end subroutine Cho_P_getGV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gugadrt_check_rcas3(jk,ind,inb,ndj,locu)

use gugadrt_global, only: ja, jb, max_node
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: jk, ind(8,max_node), ndj, locu(8,ndj)
integer(kind=iwp), intent(out) :: inb
integer(kind=iwp) :: i, iex, iexcit(ndj), lsym(8), m, nsumel

inb = 0
nsumel = 0
do i=1,8
  lsym(i) = ind(i,jk)
  nsumel = nsumel+lsym(i)
end do
do i=1,ndj
  iexcit(i) = 0
  do m=1,8
    iex = lsym(m)-locu(m,i)
    if (iex > 0) then
      iexcit(i) = iexcit(i)+iex
    end if
  end do
end do
inb = minval(iexcit)+ja(jk)*2+jb(jk)

return

end subroutine gugadrt_check_rcas3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c  ********************************************************
c  ** Public-domain library routines used by casvb only. **
c  ********************************************************
c  **********************
c  ** EISPACK ROUTINES **
c  **********************
      subroutine svd(nm,m,n,a,w,matu,u,matv,v,ierr,rv1)
c  TESTING FOR EQUALITY OR ZERO NOW DONE USING THRESHOLD, TT, 110100.
c
      integer i,j,k,l,m,n,ii,i1,kk,k1,ll,l1,mn,nm,its,ierr
      real*8 a(nm,n),w(n),u(nm,n),v(nm,n),rv1(n)
      real*8 c,f,g,h,s,x,y,z,tst1,tst2,scale,casvb_pythag,thresh
      logical matu,matv
      save thresh
      data thresh/1d-16/
c
c     this subroutine is a translation of the algol procedure svd,
c     num. math. 14, 403-420(1970) by golub and reinsch.
c     handbook for auto. comp., vol ii-linear algebra, 134-151(1971).
c
c     this subroutine determines the singular value decomposition
c          t
c     a=usv  of a real m by n rectangular matrix.  householder
c     bidiagonalization and a variant of the qr algorithm are used.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.  note that nm must be at least
c          as large as the maximum of m and n.
c
c        m is the number of rows of a (and u).
c
c        n is the number of columns of a (and u) and the order of v.
c
c        a contains the rectangular input matrix to be decomposed.
c
c        matu should be set to .true. if the u matrix in the
c          decomposition is desired, and to .false. otherwise.
c
c        matv should be set to .true. if the v matrix in the
c          decomposition is desired, and to .false. otherwise.
c
c     on output
c
c        a is unaltered (unless overwritten by u or v).
c
c        w contains the n (non-negative) singular values of a (the
c          diagonal elements of s).  they are unordered.  if an
c          error exit is made, the singular values should be correct
c          for indices ierr+1,ierr+2,...,n.
c
c        u contains the matrix u (orthogonal column vectors) of the
c          decomposition if matu has been set to .true.  otherwise
c          u is used as a temporary array.  u may coincide with a.
c          if an error exit is made, the columns of u corresponding
c          to indices of correct singular values should be correct.
c
c        v contains the matrix v (orthogonal) of the decomposition if
c          matv has been set to .true.  otherwise v is not referenced.
c          v may also coincide with a if u is not needed.  if an error
c          exit is made, the columns of v corresponding to indices of
c          correct singular values should be correct.
c
c        ierr is set to
c          zero       for normal return,
c          k          if the k-th singular value has not been
c                     determined after 30 iterations.
c
c        rv1 is a temporary storage array.
c
c     calls pythag for  sqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c

c The next two initializations are to appease a compiler
      f = 0.0d0
      h = 0.0d0

      ierr = 0
      l  = 0 ! dummy initialize
      l1 = 0 ! dummy initialize
c
      do 100 i = 1, m
c
         do 101 j = 1, n
            u(i,j) = a(i,j)
  101    continue
  100 continue
c     .......... householder reduction to bidiagonal form ..........
      g = 0.0d0
      scale = 0.0d0
      x = 0.0d0
c
      do 300 i = 1, n
         l = i + 1
         rv1(i) = scale * g
         g = 0.0d0
         s = 0.0d0
         scale = 0.0d0
         if (i .gt. m) go to 210
c
         do 120 k = i, m
         scale = scale + abs(u(k,i))
  120    continue
c
         if (abs(scale) .lt. thresh) go to 210
c
         do 130 k = i, m
            u(k,i) = u(k,i) / scale
            s = s + u(k,i)**2
  130    continue
c
         f = u(i,i)
         g = -sign(sqrt(s),f)
         h = f * g - s
         u(i,i) = f - g
         if (i .eq. n) go to 190
c
         do 150 j = l, n
            s = 0.0d0
c
            do 140 k = i, m
            s = s + u(k,i) * u(k,j)
  140       continue
c
            f = s / h
c
            do 160 k = i, m
               u(k,j) = u(k,j) + f * u(k,i)
  160       continue
  150    continue
c
  190    do 200 k = i, m
         u(k,i) = scale * u(k,i)
  200    continue
c
  210    w(i) = scale * g
         g = 0.0d0
         s = 0.0d0
         scale = 0.0d0
         if (i .gt. m .or. i .eq. n) go to 290
c
         do 220 k = l, n
         scale = scale + abs(u(i,k))
  220    continue
c
         if (abs(scale) .lt. thresh) go to 290
c
         do 230 k = l, n
            u(i,k) = u(i,k) / scale
            s = s + u(i,k)**2
  230    continue
c
         f = u(i,l)
         g = -sign(sqrt(s),f)
         h = f * g - s
         u(i,l) = f - g
c
         do 240 k = l, n
         rv1(k) = u(i,k) / h
  240    continue
c
         if (i .eq. m) go to 270
c
         do 260 j = l, m
            s = 0.0d0
c
            do 250 k = l, n
            s = s + u(j,k) * u(i,k)
  250       continue
c
            do 255 k = l, n
               u(j,k) = u(j,k) + s * rv1(k)
  255       continue
  260    continue
c
  270    do 280 k = l, n
         u(i,k) = scale * u(i,k)
  280    continue
c
  290    x = max(x,abs(w(i))+abs(rv1(i)))
  300 continue
c     .......... accumulation of right-hand transformations ..........
      if (.not. matv) go to 410
c     .......... for i=n step -1 until 1 do -- ..........
      do 400 ii = 1, n
         i = n + 1 - ii
         if (i .eq. n) go to 390
         if (abs(g) .lt. thresh) go to 360
c
         do 320 j = l, n
c     .......... double division avoids possible underflow ..........
         v(j,i) = (u(i,j) / u(i,l)) / g
  320    continue
c
         do 350 j = l, n
            s = 0.0d0
c
            do 340 k = l, n
            s = s + u(i,k) * v(k,j)
  340       continue
c
            do 355 k = l, n
               v(k,j) = v(k,j) + s * v(k,i)
  355       continue
  350    continue
c
  360    do 380 j = l, n
            v(i,j) = 0.0d0
            v(j,i) = 0.0d0
  380    continue
c
  390    v(i,i) = 1.0d0
         g = rv1(i)
         l = i
  400 continue
c     .......... accumulation of left-hand transformations ..........
  410 if (.not. matu) go to 510
c     ..........for i=min(m,n) step -1 until 1 do -- ..........
      mn = n
      if (m .lt. n) mn = m
c
      do 500 ii = 1, mn
         i = mn + 1 - ii
         l = i + 1
         g = w(i)
         if (i .eq. n) go to 430
c
         do 420 j = l, n
         u(i,j) = 0.0d0
  420    continue
c
  430    if (abs(g) .lt. thresh) go to 475
         if (i .eq. mn) go to 460
c
         do 450 j = l, n
            s = 0.0d0
c
            do 440 k = l, m
            s = s + u(k,i) * u(k,j)
  440       continue
c     .......... double division avoids possible underflow ..........
            f = (s / u(i,i)) / g
c
            do 455 k = i, m
               u(k,j) = u(k,j) + f * u(k,i)
  455       continue
  450    continue
c
  460    do 470 j = i, m
         u(j,i) = u(j,i) / g
  470    continue
c
         go to 490
c
  475    do 480 j = i, m
         u(j,i) = 0.0d0
  480    continue
c
  490    u(i,i) = u(i,i) + 1.0d0
  500 continue
c     .......... diagonalization of the bidiagonal form ..........
  510 tst1 = x
c     .......... for k=n step -1 until 1 do -- ..........
      do 700 kk = 1, n
         k1 = n - kk
         k = k1 + 1
         its = 0
c     .......... test for splitting.
c                for l=k step -1 until 1 do -- ..........
  520    do 530 ll = 1, k
            l1 = k - ll
            l = l1 + 1
            tst2 = tst1 + abs(rv1(l))
            if (abs(tst2-tst1) .lt. thresh) go to 565
c     .......... rv1(1) is always zero, so there is no exit
c                through the bottom of the loop ..........
            tst2 = tst1 + abs(w(l1))
            if (abs(tst2-tst1) .lt. thresh) go to 540
  530    continue
c     .......... cancellation of rv1(l) if l greater than 1 ..........
  540    c = 0.0d0
         s = 1.0d0
c
         do 560 i = l, k
            f = s * rv1(i)
            rv1(i) = c * rv1(i)
            tst2 = tst1 + abs(f)
            if (abs(tst2-tst1) .lt. thresh) go to 565
            g = w(i)
            h = casvb_pythag(f,g)
            w(i) = h
            c = g / h
            s = -f / h
            if (.not. matu) go to 560
c
            do 550 j = 1, m
               y = u(j,l1)
               z = u(j,i)
               u(j,l1) = y * c + z * s
               u(j,i) = -y * s + z * c
  550       continue
c
  560    continue
c     .......... test for convergence ..........
  565    z = w(k)
         if (l .eq. k) go to 650
c     .......... shift from bottom 2 by 2 minor ..........
         if (its .eq. 30) go to 1000
         its = its + 1
         x = w(l)
         y = w(k1)
         g = rv1(k1)
         h = rv1(k)
         f = 0.5d0 * (((g + z) / h) * ((g - z) / y) + y / h - h / y)
         g = casvb_pythag(f,1.0d0)
         f = x - (z / x) * z + (h / x) * (y / (f + sign(g,f)) - h)
c     .......... next qr transformation ..........
         c = 1.0d0
         s = 1.0d0
c
         do 600 i1 = l, k1
            i = i1 + 1
            g = rv1(i)
            y = w(i)
            h = s * g
            g = c * g
            z = casvb_pythag(f,h)
            rv1(i1) = z
            c = f / z
            s = h / z
            f = x * c + g * s
            g = -x * s + g * c
            h = y * s
            y = y * c
            if (.not. matv) go to 575
c
            do 570 j = 1, n
               x = v(j,i1)
               z = v(j,i)
               v(j,i1) = x * c + z * s
               v(j,i) = -x * s + z * c
  570       continue
c
  575       z = casvb_pythag(f,h)
            w(i1) = z
c     .......... rotation can be arbitrary if z is zero ..........
            if (abs(z) .lt. thresh) go to 580
            c = f / z
            s = h / z
  580       f = c * g + s * y
            x = -s * g + c * y
            if (.not. matu) go to 600
c
            do 590 j = 1, m
               y = u(j,i1)
               z = u(j,i)
               u(j,i1) = y * c + z * s
               u(j,i) = -y * s + z * c
  590       continue
c
  600    continue
c
         rv1(l) = 0.0d0
         rv1(k) = f
         w(k) = x
         go to 520
c     .......... convergence ..........
  650    if (z .ge. 0.0d0) go to 700
c     .......... w(k) is made non-negative ..........
         w(k) = -z
         if (.not. matv) go to 700
c
         do 690 j = 1, n
         v(j,k) = -v(j,k)
  690    continue
c
  700 continue
c
      go to 1001
c     .......... set error -- no convergence to a
c                singular value after 30 iterations ..........
 1000 ierr = k
 1001 return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine fetch_data_RunFile_all(nss,nstate,multiplicity,eso,esfs,U,MM,MS,ML,DM,angmom,eDmom,amfi,HSO,eso_au,esfs_au)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero, cOne, Onei, auTocm, gElectron
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nss, nstate
integer(kind=iwp), intent(out) :: multiplicity(nstate)
real(kind=wp), intent(out) :: eso(nss), esfs(nstate), angmom(3,nstate,nstate), eDmom(3,nstate,nstate), amfi(3,nstate,nstate), &
                              eso_au(nss), esfs_au(nstate)
complex(kind=wp), intent(out) :: U(nss,nss), MM(3,nss,nss), MS(3,nss,nss), ML(3,nss,nss), DM(3,nss,nss)
complex(kind=wp), intent(inout) :: HSO(nss,nss)
integer(kind=iwp) :: i, i1, info, ipar, iss, ist, j, j1, jst, l, mult, multI, multJ, mxjob, ndata, njob
real(kind=wp) :: diff
logical(kind=iwp) :: found_amfi, found_edmom, found_hsoi, found_hsor
integer(kind=iwp), allocatable :: ibas(:,:), jbnum(:), mltplt(:), nstat(:)
real(kind=wp), allocatable :: tmpI(:,:), tmpR(:,:), W(:)
complex(kind=wp), allocatable :: M_tmp(:,:), tmp(:,:), u1(:,:)
complex(kind=wp), external :: Spin
real(kind=wp), parameter :: g_e = -gElectron, thr_deg = 0.2e-13_wp ! a.u. = 0.2e-13*auTocm = 4.38949263e-9 cm-1

! get basic sizes:
njob = 0
mxjob = 0
call get_iScalar('NJOB_SINGLE',njob)
call get_iScalar('MXJOB_SINGLE',mxjob)
! allocate temporary memory:
call mma_allocate(jbnum,nstate,'jbnum')
call mma_allocate(mltplt,mxjob,'mltplt')
call mma_allocate(nstat,mxjob,'nstat')
! get the information from RUNFILE:
mltplt = 0
jbnum = 0
nstat = 0
call get_iArray('MLTP_SINGLE',MLTPLT,MXJOB)
call get_iArray('JBNUM_SINGLE',JBNUM,NSTATE)
call get_iArray('NSTAT_SINGLE',NSTAT,MXJOB)
! computing the multiplicity of each state:
do i=1,nstate
  multiplicity(i) = mltplt(jbnum(i))
end do
call mma_deallocate(jbnum)
call mma_deallocate(mltplt)
call mma_deallocate(nstat)

! fetch the spin-orbit energies:
call get_dArray('ESO_SINGLE',eso,nss)
call get_dArray('ESO_LOW',eso_au,nss)

! fetch the spin-free energies:
call get_dArray('ESFS_SINGLE',esfs,nstate)
call get_dArray('ESFS_SINGLEAU',esfs_au,nstate)

! fetch the U matrix:
call mma_allocate(tmpR,nss,nss,'tmpR')
call mma_allocate(tmpI,nss,nss,'tmpI')

call get_dArray('UMATR_SINGLE',tmpR,nss*nss)
call get_dArray('UMATI_SINGLE',tmpI,nss*nss)
U(:,:) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)

! fetch the angular momentum integrals:
call get_dArray('ANGM_SINGLE',angmom,3*nstate*nstate)

! fetch the electric dipole moment integrals:
call qpg_dArray('DIP1_SINGLE',FOUND_EDMOM,NDATA)
if (found_edmom) then
  call get_dArray('DIP1_SINGLE',edmom,3*nstate*nstate)
else
  edmom(:,:,:) = Zero
end if

! fetch the amfi integrals:
call qpg_dArray('AMFI_SINGLE',FOUND_AMFI,NDATA)
if (found_amfi) then
  call get_dArray('AMFI_SINGLE',amfi,3*nstate*nstate)
else
  amfi(:,:,:) = Zero
end if

! fetch the spin-orbit hamiltonian
call qpg_dArray('HAMSOR_SINGLE',FOUND_HSOR,NDATA)
call qpg_dArray('HAMSOI_SINGLE',FOUND_HSOI,NDATA)
if (FOUND_HSOR .and. FOUND_HSOI) then
  call get_dArray('HAMSOR_SINGLE',tmpR,nss*nss)
  call get_dArray('HAMSOI_SINGLE',tmpI,nss*nss)
  HSO(:,:) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)
  !---------------------------------------------------------------------
  ! if HSO is found, proceed to diagonalize it
  call mma_allocate(W,nss,'W')
  call mma_allocate(U1,nss,nss,'U1')
  info = 0
  call diag_c2(hso,nss,info,W,U1)
  ! correct for numerical degeneracies:
  do i=1,nss-1
    !wtmp = W(i)
    do j=i+1,nss
      diff = abs(w(i)-w(j))
      if (diff < thr_deg) w(j) = w(i)
    end do
  end do

  ESO(:) = (W(:)-W(1))*auTocm

  call mma_deallocate(W)
  call mma_deallocate(U1)
  !---------------------------------------------------------------------
end if
call mma_deallocate(tmpR)
call mma_deallocate(tmpI)

!-----
! generate a local indexing table:
call mma_allocate(ibas,[1,nstate],[-50,50],label='ibas')
iss = 0
ibas(:,:) = 0
ipar = mod(multiplicity(1),2)
do Ist=1,nstate
  Mult = Multiplicity(Ist)
  do I=-(Mult-Ipar)/2,(Mult-Ipar)/2
    if ((Ipar == 0) .and. (I == 0)) cycle
    Iss = Iss+1
    Ibas(Ist,I) = Iss
  end do ! i
end do ! Ist

!-----
! expand the spin free basis to the spin-orbit basis:
MM(:,:,:) = cZero
ML(:,:,:) = cZero
MS(:,:,:) = cZero
DM(:,:,:) = cZero
do Ist=1,nstate
  Mult = Multiplicity(Ist)
  do I=-(Mult-Ipar)/2,(Mult-Ipar)/2
    if ((Ipar == 0) .and. (I == 0)) cycle
    do J=-(Mult-Ipar)/2,(Mult-Ipar)/2
      if ((Ipar == 0) .and. (J == 0)) cycle
      i1 = Ibas(Ist,I)
      j1 = Ibas(Ist,J)
      do l=1,3
        MM(l,i1,j1) = -Spin(l,Mult,I,J)*g_e
        MS(l,i1,j1) = Spin(l,Mult,I,J)
      end do ! l
    end do ! J
  end do ! I
end do ! Ist

do Ist=1,nstate
  MultI = Multiplicity(Ist)
  do Jst=1,nstate
    MultJ = Multiplicity(Jst)
    if (MultI == MultJ) then
      do I=-(MultI-Ipar)/2,(MultI-Ipar)/2
        if ((Ipar == 0) .and. (I == 0)) cycle
        i1 = Ibas(Ist,I)
        j1 = Ibas(Jst,I)
        MM(:,i1,j1) = MM(:,i1,j1)-Angmom(:,Ist,Jst)*Onei
        ML(:,i1,j1) = ML(:,i1,j1)+Angmom(:,Ist,Jst)*Onei
        DM(:,i1,j1) = DM(:,i1,j1)+eDmom(:,Ist,Jst)*cOne
      end do ! I
    end if
  end do ! Jst
end do ! Ist

call mma_deallocate(ibas)

! calculate the matrix elements of the spin and magnetic moment
! in the spin-orbit basis:
call mma_allocate(M_tmp,nss,nss,'M_tmp')
call mma_allocate(tmp,nss,nss,'tmp')
do L=1,3
  ! spin moment
  M_tmp(:,:) = MS(L,:,:)
  call ZGEMM_('C','N',nss,nss,nss,cOne,U,nss,M_tmp,nss,cZero,TMP,nss)
  call ZGEMM_('N','N',nss,nss,nss,cOne,TMP,nss,U,nss,cZero,M_tmp,nss)
  MS(L,:,:) = M_tmp(:,:)
  ! orbital moment
  M_tmp(:,:) = ML(L,:,:)
  call ZGEMM_('C','N',nss,nss,nss,cOne,U,nss,M_tmp,nss,cZero,TMP,nss)
  call ZGEMM_('N','N',nss,nss,nss,cOne,TMP,nss,U,nss,cZero,M_tmp,nss)
  ML(L,:,:) = M_tmp(:,:)
  ! magnetic moment
  M_tmp(:,:) = MM(L,:,:)
  call ZGEMM_('C','N',nss,nss,nss,cOne,U,nss,M_tmp,nss,cZero,TMP,nss)
  call ZGEMM_('N','N',nss,nss,nss,cOne,TMP,nss,U,nss,cZero,M_tmp,nss)
  MM(L,:,:) = M_tmp(:,:)

  if (found_EDMOM) then
    ! electric dipole moment
    M_tmp(:,:) = DM(L,:,:)
    call ZGEMM_('C','N',nss,nss,nss,cOne,U,nss,M_tmp,nss,cZero,TMP,nss)
    call ZGEMM_('N','N',nss,nss,nss,cOne,TMP,nss,U,nss,cZero,M_tmp,nss)
    DM(L,:,:) = M_tmp(:,:)
  end if
end do ! L
call mma_deallocate(M_tmp)
call mma_deallocate(tmp)

! check the commutation rules of spin:
call check_commutation(nss,MS,.false.)

return

end subroutine fetch_data_RunFile_all

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Niclas Forsberg                                  *
!***********************************************************************

!module FCMod

!  Contains:
!    FCval     (C1,W1,det1,r01,C2,W2,det2,r02,FC,max_mOrd,max_nOrd,max_nOrd2,max_mInc,max_nInc,max_nInc2,mMat,nMat,mInc,nInc,mDec,
!               nDec,C,W,det0,L,U,FC00,alpha1,alpha2,beta)
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

!contains

subroutine FCval(C1,W1,det1,r01,C2,W2,det2,r02,FC,max_mOrd,max_nOrd,max_nOrd2,max_mInc,max_nInc,max_nInc2,mMat,nMat,mInc,nInc, &
                 mDec,nDec,C,W,det0,L,U,FC00,alpha1,alpha2,beta,nOsc)
!  Purpose:
!    Calculate multidimensional Franck Condon factors.
!
!  Input:
!    W1,W2      : Real two dimensional arrays - eigenvectors scaled by the square root of the eigenvalues.
!    C1,C2      : Real two dimensional arrays - inverses of W1 and W2.
!    det1,det2  : Real variables - determinants of C1 and C2.
!    r01,r02    : Real arrays - coordinates of the two oscillators.
!    max_mOrd,
!    max_nOrd,
!    max_nOrd2
!    max_mInc,
!    max_nInc,
!    max_nInc2  : Integer variables
!    mMat,nMat,
!    mInc,nInc,
!    mDec,nDec  : Two dimensional integer arrays
!
!  Output:
!    W          : Real two dimensional array - eigenvectors of intermediate oscillator scaled by the square root of the eigenvalues.
!    C          : Real two dimensional array - inverse of W.
!    det0       : Real variable - determinant of C.
!    L,U        : Real two dimensional arrays
!    FC00       : Real variable - zero-zero overlap.
!    FC         : Real
!    alpha1     : Real two dimensional array - 0.5*C1(T)*C1.
!    alpha2     : Real two dimensional array - 0.5*C2(T)*C2.
!    beta       : Real two dimensional array - 0.5*alpha1*alpha^(-1)*alpha2
!
!  Calls:
!    Dool_MULA
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use mula_global, only: mdim1, mdim2, ndim1, ndim2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: max_mOrd, max_nOrd, max_nOrd2, max_mInc, max_nInc, max_nInc2, mMat(0:mdim1,mdim2), &
                                 nMat(0:ndim1,ndim2), mInc(0:mdim1,mdim2), nInc(0:ndim1,ndim2), mDec(0:mdim1,mdim2), &
                                 nDec(0:ndim1,ndim2), nOsc
real(kind=wp), intent(in) :: C1(nOsc,nOsc), W1(nOsc,nOsc), det1, r01(nOsc), C2(nOsc,nOsc), W2(nOsc,nOsc), det2, r02(nOsc), &
                             C(nOsc,nOsc), W(nOsc,nOsc), det0
real(kind=wp), intent(out) :: FC(0:max_mord,0:max_nord), L(0:max_mord,0:max_ninc2), U(0:max_nord,0:max_nord2), FC00, &
                              alpha1(nOsc,nOsc), alpha2(nOsc,nOsc), beta(nOsc,nOsc)
integer(kind=iwp) :: i, iOrd, j, jOrd, kOrd, kOsc, kOsc_start, lOsc, nMaxMat, nTabDim
real(kind=wp) :: const, det, FC00_exp, rsum
real(kind=wp), allocatable :: A1(:,:), A1B1T(:,:), A2(:,:), A2B2T(:,:), alpha(:,:), B1(:,:), B2(:,:), d1(:), d2(:), r_temp1(:), &
                              r_temp2(:), sqr(:), temp(:,:), temp1(:,:), temp2(:,:)
real(kind=wp), external :: Ddot_

! Initialize.
nMaxMat = max(max_mord+1,max_nord+1)
nTabDim = max(nMaxMat,8)
call mma_allocate(temp,nOsc,nOsc,label='temp')
call mma_allocate(temp1,nOsc,nOsc,label='temp1')
call mma_allocate(temp2,nOsc,nOsc,label='temp2')

! Setup sqr table.
call mma_allocate(sqr,[0,nTabDim+1],label='sqr')
do i=0,nTabDim+1
  sqr(i) = sqrt(real(i,kind=wp))
end do

! Calculate alpha1, alpha2 and alpha.
call mma_allocate(alpha,nOsc,nOsc,label='alpha')
call DGEMM_('T','N',nOsc,nOsc,nOsc,Half,C1,nOsc,C1,nOsc,Zero,alpha1,nOsc)
call DGEMM_('T','N',nOsc,nOsc,nOsc,Half,C2,nOsc,C2,nOsc,Zero,alpha2,nOsc)
temp(:,:) = alpha1+alpha2
alpha(:,:) = Half*temp

!call xxDgemul(C,nOsc,'T',C,nOsc,'N',alpha,nOsc,nOsc,nOsc,nOsc)
!alpha(:,:) = Half*alpha

! Calculate C using a Cholesky factorization of 2*alpha.
!call Cholesky(temp,C)

! Calculate W.
!W(:,:) = Zero
!do i=1,nOsc
!  W(i,i) = One
!end do
!temp(:,:) = C
!call Dool_MULA(temp,W,det0)

! Calculate r00.
call mma_allocate(r_temp1,nOsc,label='r_temp1')
call mma_allocate(r_temp2,nOsc,label='r_temp2')

! Calculate beta.
do i=1,nOsc
  do j=1,nOsc
    temp(j,i) = C1(i,j)
  end do
end do
temp1(:,:) = alpha1
temp(:,:) = Two*alpha

call Dool_MULA(temp,nOsc,nOsc,temp1,nOsc,nOsc,det)
call DGEMM_('N','N',nOsc,nOsc,nOsc,One,alpha2,nOsc,temp1,nOsc,Zero,beta,nOsc)

! Calculate FC00.
!r_temp1(:) = r02-r01
r_temp1(:) = r01-r02

call DGEMM_('N','N',nOsc,1,nOsc,One,beta,nOsc,r_temp1,nOsc,Zero,r_temp2,nOsc)
FC00_exp = Ddot_(nOsc,r_temp1,1,r_temp2,1)
FC00 = (sqrt(det1)*sqrt(det2)/det0)*exp(-FC00_exp)

! Calculate A, B and d matrices.
call mma_allocate(A1,nOsc,nOsc,label='A1')
call mma_allocate(B1,nOsc,nOsc,label='B1')
call mma_allocate(A2,nOsc,nOsc,label='A2')
call mma_allocate(B2,nOsc,nOsc,label='B2')
call mma_allocate(d1,nOsc,label='d1')
call mma_allocate(d2,nOsc,label='d2')
call DGEMM_('N','N',nOsc,nOsc,nOsc,One,C1,nOsc,W,nOsc,Zero,A1,nOsc)
call DGEMM_('T','T',nOsc,nOsc,nOsc,One,W1,nOsc,C,nOsc,Zero,temp,nOsc)
B1(:,:) = A1-temp

const = sqr(8)
call DGEMM_('T','N',nOsc,1,nOsc,const,W1,nOsc,r_temp2,nOsc,Zero,d1,nOsc)
call DGEMM_('N','N',nOsc,nOsc,nOsc,One,C2,nOsc,W,nOsc,Zero,A2,nOsc)
call DGEMM_('T','T',nOsc,nOsc,nOsc,One,W2,nOsc,C,nOsc,Zero,temp,nOsc)
B2(:,:) = A2-temp

const = -sqr(8)
call DGEMM_('T','N',nOsc,1,nOsc,const,W2,nOsc,r_temp2,nOsc,Zero,d2,nOsc)

! Calculate A1B1T and A2B2T.
call mma_allocate(A1B1T,nOsc,nOsc,label='A1B1T')
call mma_allocate(A2B2T,nOsc,nOsc,label='A2B2T')

call DGEMM_('N','T',nOsc,nOsc,nOsc,One,A1,nOsc,B1,nOsc,Zero,A1B1T,nOsc)
call DGEMM_('N','T',nOsc,nOsc,nOsc,One,A2,nOsc,B2,nOsc,Zero,A2B2T,nOsc)

call mma_deallocate(temp)
call mma_deallocate(temp1)
call mma_deallocate(temp2)
call mma_deallocate(alpha)
call mma_deallocate(r_temp1)
call mma_deallocate(r_temp2)

! Initialize L matrix.
L(:,:) = Zero
L(0,0) = One

! If max_mOrd > 0 then set up L(m,0).
if (max_mOrd > 0) then
  do kOsc=1,nOsc
    L(mInc(0,kOsc),0) = d1(kOsc)
  end do
  if (max_mInc > 0) then
    do iOrd=1,max_mInc
      kOsc_start = nOsc
      do while ((mMat(iOrd,kOsc_start) == 0) .and. (kOsc_start > 1))
        kOsc_start = kOsc_start-1
      end do
      do kOsc=kOsc_start,nOsc
        do lOsc=1,nOsc
          if (mMat(iOrd,lOsc) > 0) then
            L(mInc(iOrd,kOsc),0) = L(mInc(iOrd,kOsc),0)+sqr(mMat(iOrd,lOsc))*A1B1T(kOsc,lOsc)*L(mDec(iOrd,lOsc),0)
          end if
        end do
        L(mInc(iOrd,kOsc),0) = (L(mInc(iOrd,kOsc),0)+d1(kOsc)*L(iOrd,0))/sqr(mMat(mInc(iOrd,kOsc),kOsc))
      end do
    end do
  end if

  ! Use recursion formula to obtain the rest of L.
  write(u6,*) 'FCVAL Test prints:'
  write(u6,*) 'In this loop, indices jOrd and iOrd will vary.'
  write(u6,*) 'They are used to address L(iOrd,jOrd).'
  write(u6,'(1x,a,2i8)') '(1) jOrd goes from 1, up to max_mord=',max_mord
  write(u6,'(1x,a,2i8)') '(2) iOrd goes from 1, up to max_mord=',max_mord
  !vv stop
  !do jOrd=1,max_nInc2
  do jOrd=1,max_mOrd
    write(u6,'(1x,a,2i8)') ' jOrd=',jOrd
    lOsc = nOsc
    do while ((mMat(jOrd,lOsc) == 0) .and. (lOsc > 1))
      lOsc = lOsc-1
    end do
    do iOrd=0,max_mOrd
      do kOsc=1,nOsc
        if (mMat(iOrd,kOsc) > 0) then
          L(iOrd,jOrd) = L(iOrd,jOrd)+sqr(mMat(iOrd,kOsc))/sqr(mMat(jOrd,lOsc))*A1(kOsc,lOsc)*L(mDec(iOrd,kOsc),mDec(jOrd,lOsc))
        end if
      end do
    end do
  end do
end if

! Initialize U matrix.
U(:,:) = Zero
U(0,0) = One

! If max_nOrd > 0 then set up U(n,0).
if (max_nOrd > 0) then
  do kOsc=1,nOsc
    U(nInc(0,kOsc),0) = d2(kOsc)
  end do
  if (max_nInc > 0) then
    do iOrd=1,max_nInc
      kOsc_start = nOsc
      do while ((nMat(iOrd,kOsc_start) == 0) .and. (kOsc_start > 1))
        kOsc_start = kOsc_start-1
      end do
      do kOsc=kOsc_start,nOsc
        do lOsc=1,nOsc
          if (nMat(iOrd,lOsc) > 0) then

            U(nInc(iOrd,kOsc),0) = U(nInc(iOrd,kOsc),0)+sqr(nMat(iOrd,lOsc))*A2B2T(kOsc,lOsc)*U(nDec(iOrd,lOsc),0)
          end if
        end do

        U(nInc(iOrd,kOsc),0) = (U(nInc(iOrd,kOsc),0)+d2(kOsc)*U(iOrd,0))/sqr(nMat(nInc(iOrd,kOsc),kOsc))
      end do
    end do
  end if

  ! Use recursion formula to obtain the rest of U.
  do jOrd=1,max_nOrd2
    lOsc = nOsc
    do while ((nMat(jOrd,lOsc) == 0) .and. (lOsc > 1))
      lOsc = lOsc-1
    end do
    do iOrd=0,max_nOrd
      do kOsc=1,nOsc
        if (nMat(iOrd,kOsc) > 0) then
          U(iOrd,jOrd) = U(iOrd,jOrd)+sqr(nMat(iOrd,kOsc))/sqr(nMat(jOrd,lOsc))*A2(kOsc,lOsc)*U(nDec(iOrd,kOsc),nDec(jOrd,lOsc))
        end if
      end do
    end do
  end do
end if

call mma_deallocate(A1)
call mma_deallocate(B1)
call mma_deallocate(A2)
call mma_deallocate(B2)
call mma_deallocate(A1B1T)
call mma_deallocate(A2B2T)
call mma_deallocate(d1)
call mma_deallocate(d2)

! Calculate Franck-Condon factors.
FC(:,:) = Zero
do jOrd=0,max_nOrd
  do iOrd=0,max_mOrd
    rsum = Zero
    do kOrd=0,min(max_mOrd,max_nOrd)
      rsum = rsum+L(iOrd,kOrd)*U(jOrd,kOrd)
    end do
    FC(iOrd,jOrd) = FC00*rsum
  end do
end do

call mma_deallocate(sqr)

end subroutine FCval

!end module FCMod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine MOAcc(AOInt,Temp1,Temp2,nTemp,ishell,Ck,nCk,Cl,nCl,moip,nACO,pert,nOp,iBasa,iCmpa,icar,icnt,indgrd,fact,iaost,Buffer, &
                 nij,nkl,nbasi,nbasj,icmp,jcmp)
!***********************************************************************
!                                                                      *
!     Transforms a batch of unsymmetrized integrals to                 *
!     active integral batches and FM                                   *
!     All MO combinations are constructed                              *
!     They will be needed with unsymmetric perurbations                *
!                                                                      *
!     Author: Anders Bernhardsson, Dept. of Theoretical Chemistry,     *
!             University of Lund, Sweden. Januar '96                   *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: iChTbl, iOper, nIrrep, Prmt
use Gateway_Info, only: CutInt
use Constants, only: Zero
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nTemp, ishell(4), nCk, nCl, moip(0:7), nACO, nOp(4), ibasa(4), icmpa(4), icar, icnt, &
                                 indgrd(3,4,0:7), iAOST(4), nij, nkl, nbasi, nbasj, icmp, jcmp
real(kind=wp), intent(in) :: AOInt(nkl,nij), fact
real(kind=wp), intent(out) :: Temp1(nTemp), Temp2(naco,naco)
real(kind=wp), intent(inout) :: Ck(nCk), Cl(nCl), Buffer(nbasi,icmp,nbasj,jcmp,0:nirrep-1,nTri_Elem(naco),*)
logical(kind=iwp), intent(in) :: pert(0:7)
#include "etwas.fh"
integer(kind=iwp) :: i, ib, iBas, ic, iCB, iirr, ij, il, ipC, ipM, irest, iSPert, j, jb, jBas, jc, jIrr, k, kAsh, kBas, kCmp, &
                     kIrr, kIrrep, kk, kMax, l, lAsh, lBas, lCmp, lIrr, ll, nt
real(kind=wp) :: rFact, rFact2, rk, rl, rPij, rPj, sfact, vij
integer(kind=iwp), external :: NrOpr
real(kind=r8), external :: DNrm2_

iCB = 2**(icar-1)
rFact = Prmt(ioper(nOp(icnt)),icb)*fact

iBas = iBasa(1)
jBas = iBasa(2)
kBas = iBasa(3)
lBas = iBasa(4)

kCmp = iCmpa(3)
lCmp = iCmpa(4)
kk = 0
do kIrrep=0,nIrrep-1
  sfact = real(ichtbl(kirrep,nop(3)),kind=wp)
  Ck(kk+1:kk+nAsh(kIrrep)*kcmp*kbas) = Ck(kk+1:kk+nAsh(kIrrep)*kcmp*kbas)*sFact
  kk = kk+nAsh(kIrrep)*kcmp*kbas
end do
kk = 0
do kIrrep=0,nIrrep-1
  sfact = real(ichtbl(kirrep,nop(4)),kind=wp)
  Cl(kk+1:kk+nAsh(kIrrep)*lcmp*lbas) = Cl(kk+1:kk+nAsh(kIrrep)*lcmp*lbas)*sFact
  kk = kk+nAsh(kIrrep)*lcmp*lbas
end do
rk = DNrm2_(nck,ck,1)
rl = DNrm2_(ncl,cl,1)
ij = 0
nt = lBas*lCmp*kcmp*kbas
do jc=1,jcmp
  do jb=1+iaost(2),iaost(2)+jbas
    do ic=1,icmp
      do ib=1+iaost(1),iaost(1)+ibas

        ij = ij+1
        vij = DNrm2_(nt,AOInt(1,ij),1)
        if (abs(vij*rk*rl) < cutint) cycle
        ipC = 0
        Temp1(1:nAco*lbas*lcmp) = Zero
        do kAsh=1,nAco
          ipM = (kAsh-1)*lbas*lcmp
          il = 0
          do i=1,lbas*lcmp
            do k=1,kCmp*kBas
              il = il+1
              Temp1(ipM+i) = Temp1(ipM+i)+Ck(ipC+k)*AOINT(il,ij)
            end do
          end do
          ipC = ipC+kBas*kCmp
        end do
        ipC = 0
        Temp2(:,:) = Zero
        do lAsh=1,naco
          il = 0
          do kash=1,naco
            do l=1,lbas*lcmp
              il = il+1
              Temp2(kash,lash) = Temp2(kash,lash)+Cl(ipC+l)*Temp1(il)
            end do
          end do
          ipC = ipC+lBas*lCmp
        end do

        if (iShell(3) /= ishell(4)) then

          do iSPert=0,nIrrep-1
            if (pert(isPert)) then
              rFact2 = rFact*real(iChtbl(ispert,nop(icnt)),kind=wp)
              k = abs(indgrd(icar,icnt,ispert))
              j = 0
              do lIrr=0,nIrrep-1
                do lAsh=1,nAsh(lIrr)
                  do kIrr=0,lIrr
                    irest = ieor(ieor(ioper(ispert),ioper(kirr)),ioper(lirr))
                    kMax = nAsh(kIrr)
                    if (kIrr == lIrr) kMax = lAsh
                    do kAsh=1,kMax
                      kk = kash+moip(kirr)
                      ll = lash+moip(lirr)
                      j = j+1
                      do jIrr=0,nIrrep-1
                        rPj = real(iChTbl(jIrr,nop(2)),kind=wp)
                        iirr = nropr(ieor(iOPER(jirr),irest))
                        rPij = rPj*real(iChTbl(iIrr,nop(1)),kind=wp)*rfact2
                        buffer(ib,ic,jb,jc,iirr,j,k) = buffer(ib,ic,jb,jc,iirr,j,k)+rpij*Temp2(kk,ll)+rpij*Temp2(ll,kk)
                      end do
                    end do
                  end do
                end do
              end do
            end if
          end do
        else

          do iSPert=0,nIrrep-1
            if (pert(isPert)) then
              rFact2 = rFact*real(iChtbl(ispert,nop(icnt)),kind=wp)
              k = abs(indgrd(icar,icnt,ispert))
              j = 0
              do lIrr=0,nIrrep-1
                do lAsh=1,nAsh(lIrr)
                  do kIrr=0,lIrr
                    irest = ieor(ieor(ioper(ispert),ioper(kirr)),ioper(lirr))
                    kMax = nAsh(kIrr)
                    if (kIrr == lIrr) kMax = lAsh
                    do kAsh=1,kMax
                      kk = kash+moip(kirr)
                      ll = lash+moip(lirr)
                      j = j+1
                      do jIrr=0,nIrrep-1
                        rPj = real(iChTbl(jIrr,nop(2)),kind=wp)
                        iirr = nropr(ieor(iOPER(jirr),irest))
                        rPij = rPj*real(iChTbl(iIrr,nop(1)),kind=wp)*rfact2
                        buffer(ib,ic,jb,jc,iirr,j,k) = buffer(ib,ic,jb,jc,iirr,j,k)+rpij*Temp2(kk,ll)
                      end do
                    end do
                  end do
                end do
              end do
            end if
          end do
        end if
      end do
    end do
  end do
end do

kk = 0
do kIrrep=0,nIrrep-1
  sfact = real(ichtbl(kirrep,nop(3)),kind=wp)
  Ck(kk+1:kk+nAsh(kIrrep)*kcmp*kbas) = Ck(kk+1:kk+nAsh(kIrrep)*kcmp*kbas)*sFact
  kk = kk+nAsh(kIrrep)*kcmp*kbas
end do
kk = 0
do kIrrep=0,nIrrep-1
  sfact = real(ichtbl(kirrep,nop(4)),kind=wp)
  Cl(kk+1:kk+nAsh(kIrrep)*lcmp*lbas) = Cl(kk+1:kk+nAsh(kIrrep)*lcmp*lbas)*sFact
  kk = kk+nAsh(kIrrep)*lcmp*lbas
end do

return

end subroutine MOAcc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
*               2017, Ignacio Fdez. Galvan                             *
************************************************************************
*  LinEqSolv
*
*> @brief
*>   Solve linear equations \f$ Ax=B \f$ or \f$ A^\text{T}x=B \f$ where
*>   \f$ A \f$ is a general nonsingular matrix
*> @author Thomas Bondo Pedersen
*> @modified_by Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> For \p TransA(1:1) = ``'N'`` or ``'n'``,
*> this routine solves the equations \f$ Ax = B \f$ for any number of
*> righthand sides stored as columns of the matrix \f$ B \f$. For
*> \p TransA(1:1) = ``'T'`` or ``'t'``, the equations \f$ A^\text{T}x = B \f$ are
*> solved.
*>
*> The solution vectors are stored as columns of \p B on exit. Note
*> that array \p A will be destroyed during the solution (the matrix
*> is replaced by its factors obtained by Gaussian elimination).
*>
*> Return codes are:
*>
*> - \p irc = ``-1``: input error(s) detected and nothing has been done.
*> - \p irc =  ``0``: successful completion.
*> - \p irc =  ``1``: \p A is estimated to be singular and no solution vectors have been computed.
*>
*> @note
*> 4 * \p nDim real*8 and 2 * \p nDim integer words of memory must be available
*> on entry.
*>
*> @param[out]    irc    Return code
*> @param[in]     TransA Transposition of \p A
*> @param[in,out] A      Array containing the nonsingular matrix \p A on entry and the factorized matrix (Gaussian elimination) on exit
*> @param[in]     ldA    Leading dimension of \p A
*> @param[in,out] B      Array containing righthand sides of equations on entry and solution vectors on exit
*> @param[in]     ldB    Leading dimension of \p B
*> @param[in]     nDim   Column dimension of \p A
*> @param[in]     nEq    Number of equations, i.e. column dimension of \p B
************************************************************************
      SubRoutine LinEqSolv(irc,TransA,A,ldA,B,ldB,nDim,nEq)
      Implicit None
      Character*(*) TransA
      Integer irc, ldA, ldB, nDim, nEq
      Real*8  A(ldA,nDim), B(ldB,nEq)
#include "WrkSpc.fh"

      Integer ip_iPivot, l_iPivot
      Integer ip_Scr, l_Scr
      Integer ip_iScr, l_iScr
      Integer iErr, lTransA
      Real*8  RC,AN
      Character*1 myTransA
      Real*8  DLANGE
      External DLANGE

C     Test input.
C     -----------

      irc = 0
      If (nEq.lt.1 .or. nDim.lt.1) Return
      If (ldA.lt.nDim .or. ldB.lt.nDim) Then
         irc = -1 ! dimension error
         Return
      End If

C     Translate TransA to integer Job to be used by DGESL.
C     ----------------------------------------------------

      lTransA = len(TransA)
      If (lTransA .gt. 0) Then
         myTransA = TransA(1:1)
      Else
         irc = -1 ! TransA error
         Return
      End If

      If (myTransA.ne.'N' .and. myTransA.ne.'n' .and.
     &    myTransA.ne.'T' .and. myTransA.ne.'t') Then
         irc = -1 ! TransA error
         Return
      End If

C     Allocate pivot array and scratch space
C     --------------------------------------

      l_iPivot = nDim
      l_Scr = 4*nDim
      l_iScr = nDim
      Call GetMem('LES_Pivot','Allo','Inte',ip_iPivot,l_iPivot)
      Call GetMem('LES_Scr','Allo','Real',ip_Scr,l_Scr)
      Call GetMem('LES_iScr','Allo','Inte',ip_iScr,l_iScr)

C     Factor A by Gaussian elimination and estimate reciprocal condition
C     number (RC). Check for singularity.
C     ------------------------------------------------------------------

      RC = 0.0d0
      AN = DLANGE('1',nDim,nDim,A,ldA,Work(ip_Scr))
      Call DGETRF_(nDim,nDim,A,ldA,iWork(ip_iPivot),iErr)
      Call DGECON('1',nDim,A,ldA,AN,RC,Work(ip_Scr),iWork(ip_iScr),iErr)
      If (((1.0d0+RC) .eq. 1.0d0) .or. (iErr .gt. 0)) Then
         irc = 1 ! error: A is (probably) singular
         Go To 1 ! exit after deallocations
      End If

C     Solve equations.
C     ----------------

      Call DGETRS_(myTransA,nDim,nEq,A,ldA,iWork(ip_iPivot),B,ldB,iErr)
      If (iErr .gt. 0) Then
         irc = 1 ! error: A is (probably) singular
         Go To 1 ! exit after deallocations
      End If

C     Deallocations.
C     --------------

    1 Call GetMem('LES_Pivot','Free','Inte',ip_iPivot,l_iPivot)
      Call GetMem('LES_Scr','Free','Real',ip_Scr,l_Scr)
      Call GetMem('LES_iScr','Free','Inte',ip_iScr,l_iScr)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

function Is_First_Iter()

use Definitions, only: iwp

implicit none
logical(kind=iwp) :: Is_First_Iter
integer(kind=iwp) :: Iter, Iter_S, Tmp(7)
character(len=80) :: EnvStr
logical(kind=iwp) :: Found

! If this is the first iteration in a "saddle" branch
call qpg_iScalar('Saddle Iter',Found)
if (Found) then
  call Get_iScalar('Saddle Iter',Iter_S)
  if (Iter_S == 0) then
    Is_First_Iter = .true.
    return
  else
    Is_First_Iter = .false.
    return
  end if
end if

! If Slapaf information has been stripped out (e.g. IRC restart)
call qpg_iArray('Slapaf Info 1',Found,Tmp(1))
if (Found) then
  call Get_iArray('Slapaf Info 1',Tmp,7)
  if (Tmp(1) == -99) then
    Is_First_Iter = .true.
    return
  end if
end if

! If MOLCAS_ITER <= 1
call Getenvf('MOLCAS_ITER',EnvStr)
read(EnvStr,*) Iter
if (Iter <= 1) then
  Is_First_Iter = .true.
  return
end if

Is_First_Iter = .false.

end function Is_First_Iter

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETSH2(ISHLSO,ISOSHL,NBSTSH,NBAST,NSHELL)
      IMPLICIT NONE
      INTEGER NBAST, NSHELL
      INTEGER ISHLSO(NBAST), ISOSHL(NBAST), NBSTSH(NSHELL)

      INTEGER I, ICOUNT, ISHL

      DO ISHL = 1,NSHELL
         ICOUNT = 0
         I      = 0
         DO WHILE ((I.LT.NBAST) .AND. (ICOUNT.LT.NBSTSH(ISHL)))
            I = I + 1
            IF (ISOSHL(I) .EQ. ISHL) THEN
               ICOUNT = ICOUNT + 1
               ISHLSO(I) = ICOUNT
            END IF
         END DO
      END DO

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine bikset_cvb(aikcof,bikcof,nel,nalf,i2s,ndet,ifns,kbasis,share,iprint)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nel, nalf, i2s, ndet, ifns, kbasis, iprint
real(kind=wp), intent(inout) :: aikcof(ndet,ifns)
real(kind=wp), intent(out) :: bikcof(ndet,ifns)
logical(kind=iwp), intent(in) :: share
integer(kind=iwp) :: nalf_use, ndet_use
real(kind=wp), allocatable :: atmp(:,:), btmp(:,:)

if (i2s /= 2*nalf-nel) then
  nalf_use = (i2s+nel)/2
  call icomb_cvb(nel,nalf_use,ndet_use)
  call mma_allocate(atmp,ndet_use,ifns,label='atmp')
  call mma_allocate(btmp,ndet_use,ifns,label='btmp')
  call biksmain_cvb(atmp,btmp,nel,nalf_use,ndet_use,ifns,kbasis,.false.,iprint)
  call sminus_cvb(atmp,bikcof,nel,nalf_use,nalf,ifns)
  if (.not. share) call sminus_cvb(btmp,aikcof,nel,nalf_use,nalf,ifns)
  call mma_deallocate(atmp)
  call mma_deallocate(btmp)
else
  call biksmain_cvb(aikcof,bikcof,nel,nalf,ndet,ifns,kbasis,share,iprint)
end if

return

end subroutine bikset_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2009, Bingbing Suo                                     *
************************************************************************
C Jul. 3, 2009 -BSUO- External space loops
      subroutine dd_ext_plpmode(ilnodesm,irnodesm)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      ilrsm=mul_tab(ilnodesm,irnodesm)
      logic_g36a=.false.
      logic_g36b=.false.
      logic_g1415=.false.
      logic_g13=.false.
      if (ilnodesm.lt.irnodesm) then
         logic_g36a=.true.
      elseif ( ilnodesm.eq.irnodesm) then
         logic_g36a=.true.
         logic_g36b=.true.
         logic_g1415=.true.
         logic_g13=.true.
      else
         logic_g36b=.true.
      endif
      end

      subroutine external_space_plpmode_value_dv()
#include "drt_h.fh"
#include "paraconstants_h.fh"
#include "lpextmode_h.fh"
!     sd   lpmode_value
      w0g25=-1.d0
      w0g25a=-1.d0
      w1g25a=-1.d0
      end

      subroutine external_space_plpmode_value_vd()
#include "drt_h.fh"
#include "paraconstants_h.fh"
#include "lpextmode_h.fh"
!     sd   lpmode_value
      w0g25=-v_sqtwo
      w0g25a=-v_sqtwo
      w1g25a=-v_sqtwo
      end

      subroutine g12_t_diffsym(isma,ismb,ismc)
#include "drt_h.fh"
#include "intsort_h.fh"

      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      if ( isma .lt. ismb ) then
      ip3smabc=isma+jp2(ismb)+jp3(ismc)
      ip2cd=m_jc+(m_jd-1)*nlsm_ext(ismc)   !severe_new_error_1206
      num_smab=nlsm_ext(isma)*nlsm_ext(ismb)  !need checking
      ipos_intbasetmp=ip4_abcd_ext_base(ip3smabc)+
     *            (ip2cd-1)*num_smab*3
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      iposint=ipos_intbasetmp
      do ib=ibsta,ibend
      do ia=iasta,iaend
         value_lpext(ilwei)=vint_ci(iposint+1)-vint_ci(iposint+2)
         ilwei=ilwei+1
         iposint=iposint+3
      enddo
      enddo
      else
      ip3smabc=isma+jp2(ismb)+jp3(ismc)
      ip2cd=m_jc+NGW2(m_jd)
      nsma=nlsm_ext(isma)
      num_smab=nsma*(nsma-1)/2   !need checking
      ipos_intbasetmp=ip4_abcd_ext_base(ip3smabc)+
     *            (ip2cd-1)*num_smab*3
      ibsta=ibsm_ext(ismb)+1
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      iposint=ipos_intbasetmp
      do ib=ibsta,ibend
      do ia=iasta,ib-1
         value_lpext(ilwei)=vint_ci(iposint+1)-vint_ci(iposint+2)
         ilwei=ilwei+1
         iposint=iposint+3
      enddo
      enddo
      endif
      end

      subroutine g11a_t_diffsym(isma,ismb,ismc)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipsmabc=isma+jp2(ismc)+jp3(ismb)
      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
      jdoffset=(m_jd-1)*nlsm_ext(ismb)
      jcoffset=(m_jc-1)*nlsm_ext(isma)
      num_smab=nlsm_ext(isma)*nlsm_ext(ismc)*3
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      ipos_intbasetmp=ipos_intbasetmp+jdoffset*num_smab+jcoffset*3
      do ib=ibsta,ibend
         iposint=ipos_intbasetmp
      do ia=iasta,iaend
         value_lpext(ilwei)=vint_ci(iposint)-vint_ci(iposint+2)
         iposint=iposint+3
         ilwei=ilwei+1
      enddo
         ipos_intbasetmp=ipos_intbasetmp+num_smab
      enddo
      end

      subroutine g11b_t_diffsym(isma,ismb,ismc)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipsmabc=ismc+jp2(isma)+jp3(ismb)
      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
      jdoffset=(m_jd-1)*nlsm_ext(ismb)
      jcoffset=m_jc-1
      num_smab=nlsm_ext(isma)*nlsm_ext(ismc)*3
      numint_jc=nlsm_ext(ismc)*3
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      ipos_intbasetmp=ipos_intbasetmp+jdoffset*num_smab+jcoffset*3
      do ib=ibsta,ibend
         iposint=ipos_intbasetmp      !+jcoffset*3
      do ia=iasta,iaend
         value_lpext(ilwei)=vint_ci(iposint)-vint_ci(iposint+1)
         ilwei=ilwei+1
         iposint=iposint+numint_jc
      enddo
         ipos_intbasetmp=ipos_intbasetmp+num_smab
      enddo
      end

      subroutine g1112_t_symaaaa(isma,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipsmabc=isma+jp2(isma)+jp3(isma)
      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
!
      icdpos_12=NGW4(m_jd)+NGW3(m_jc)
      iasta=ibsm_ext(isma)
      ibsta=iasta+1
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      iposint=ipos_intbasetmp+icdpos_12*3         !-3 unnecessary ?
      do   ib=ibsta,ic-1
         do ia=iasta,ib-1
            value_lpext(ilwei)=vint_ci(iposint+1)-vint_ci(iposint+2)
            ilwei=ilwei+1
            iposint=iposint+3
         enddo
      enddo

      icdpos_11a=NGW4(m_jd)+NGW2(m_jc)
      jb=m_jc
      do ib=ic+1,id-1
         jb=jb+1
         ibcdpos_11a=icdpos_11a+NGW3(jb)
         iposint=ipos_intbasetmp+ibcdpos_11a*3
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
         do ia=iasta,ic-1
            value_lpext(ilwei)=vint_ci(iposint)-vint_ci(iposint+2)
            ilwei=ilwei+1
            iposint=iposint+3
         enddo
      enddo

      icdpos_11b=NGW4(m_jd)+m_jc
      jb=m_jc+1
      do ib=ic+2,id-1
         jb=jb+1
         ibcdpos_11b=icdpos_11b+NGW3(jb)
         ja=m_jc
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
         do ia=ic+1,ib-1
            ja=ja+1
            iabcdpos_11b=ibcdpos_11b+NGW2(ja)
            iposint=ipos_intbasetmp+iabcdpos_11b*3-3
            value_lpext(ilwei)=vint_ci(iposint)-vint_ci(iposint+1)
            ilwei=ilwei+1
         enddo
      enddo
      end

      subroutine g11a11b_t_symaacc(isma,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipsmabc=isma+jp2(isma)+jp3(ismc)
      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
      num_smab=nlsm_ext(isma)
      num_smab=(num_smab*(num_smab-1))/2*3
      ibsta=ibsm_ext(ismc)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)

      jb=0
      ibdpos=NGW2(m_jd)
      ipos_intbasetmp=ipos_intbasetmp+
     *            ibdpos*num_smab+NGW2(m_jc)*3
      do ib=ibsta,id-1
         iposint=ipos_intbasetmp
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
         do ia=iasta,ic-1
            value_lpext(ilwei)=vint_ci(iposint)-vint_ci(iposint+2)
            ilwei=ilwei+1
            iposint=iposint+3
         enddo
         ipos_intbasetmp=ipos_intbasetmp+num_smab
      enddo

      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
      ibdpos=NGW2(m_jd)
      ipos_intbasetmp=ipos_intbasetmp+
     *            ibdpos*num_smab+m_jc*3
      do ib=ibsta,id-1
         iposint=ipos_intbasetmp
         ja=m_jc
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
         do ia=ic+1,iaend
            ja=ja+1
            iposint=ipos_intbasetmp+NGW2(ja)*3-3
            value_lpext(ilwei)=vint_ci(iposint)-vint_ci(iposint+1)
            ilwei=ilwei+1
         enddo
         ipos_intbasetmp=ipos_intbasetmp+num_smab
      enddo
      end

      subroutine g36_t_ext(ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipos_intbasetmp=ip3_abd_ext_base+(id-1)*np3_abd_ext   !severe_new_
      iasta=ibsm_ext(ismc)
      ilwei=icnt_base+iwt_orb_ext(iasta,id)
      do ia=iasta,ic-1
         ipos_g36=iwt_orb_ext(ia,ic)-1
         iposint=ipos_intbasetmp+ipos_g36*2         !severe_new_error
         value_lpext(ilwei)=vint_ci(iposint+1)-vint_ci(iposint)
     *            +vint_ci(ip2_aa_ext_base+ipos_g36)
         ilwei=ilwei+1
      enddo
      end

      subroutine g5_t_ext(ismd,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipos_intbasetmp=ip3_abd_ext_base+(ic-1)*np3_abd_ext
      ibsta=ibsm_ext(ismd)
      do ib=max(ic+1,ibsta),id-1
         ipos_g5=iwt_orb_ext(ib,id)-1            !severe_new_error
         iposint=ipos_intbasetmp+ipos_g5*2         !severe_new_error
         ilwei=icnt_base+iwt_orb_ext(ic,ib)
         value_lpext(ilwei)=vint_ci(iposint+1)-vint_ci(iposint)
     *            +vint_ci(ip2_aa_ext_base+ipos_g5)
      enddo
      end

      subroutine   g9_t_ext(ismd,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipos_intbasetmp=ip3_abd_ext_base+(ic-1)*np3_abd_ext
      iasta=ibsm_ext(ismd)
      ilwei=icnt_base+iwt_orb_ext(iasta,ic)
      do ia=iasta,ic-1                     !severe_new_error
         ipos_g9=iwt_orb_ext(ia,id)-1
         iposint=ipos_intbasetmp+ipos_g9*2      !severe_new_error
         value_lpext(ilwei)=vint_ci(iposint)-vint_ci(iposint+1)
     *            -vint_ci(ip2_aa_ext_base+ipos_g9)         !severe_new_
         ilwei=ilwei+1
      enddo
      end

      subroutine gsd_determine_extarmode_paras(
     *                           ismnodes,ismnoded,logic_sd)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      logical logic_sd
      ismnodesd=mul_tab(ismnodes,ismnoded)
      numsmd=nlsm_ext(ismnoded)
      numsmsd=nlsm_ext(ismnodesd)
      iorbid=ibsm_ext(ismnoded)
      iorbisd=ibsm_ext(ismnodesd)

      logic_g25a=.false.
      logic_g25b=.false.
      logic_g28a=.false.
      logic_g26=.false.
      if ( ismnoded .gt.ismnodesd ) then
         logic_g28a=.true.
         iweista_g28=iwt_orb_ext(iorbisd,iorbid)
         nwei_g28=numsmd
         nint_g28=numsmsd
      elseif ( ismnoded .eq. ismnodesd ) then
         logic_g25b=.true.
         iweista_g25=iwt_orb_ext(iorbisd,iorbisd+1)
         nwei_g25=numsmd
         nint_g25=numsmsd
         iweista_g28=iwt_orb_ext(iorbisd,iorbisd+1)
         nwei_g28=numsmd
         nint_g28=numsmsd
      else
         logic_g25a=.true.
         iweista_g25=iwt_orb_ext(iorbid,iorbisd)
         nwei_g25=numsmd
         nint_g25=numsmsd
      endif
      if ( ismnodes .eq. 1 .and. logic_sd ) then
         logic_g26=.true.
         iweista_g26=iwt_sm_s_ext+iorbid
         nwei_g26=numsmd
         ivaluesta_g26=0
      endif
      end

      subroutine g_dd_ext_sequence(ism)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      IPAE=1+ISM
      icano_nnsta=2
      icnt_base=0
      iasta=ibsm_ext(ism)
      ibsta=iasta+1
      ibend=iesm_ext(ism)
      ilwei=0
      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,ib-1
           lra=norb_number(ia)
           ilwei=ilwei+1
          value_lpext(ilwei)=voint(lrb,lra)
         enddo
      enddo
      icano_nnend=ibend-iasta+1
      call complete_ext_loop()
      end


      subroutine g_ss_ext_sequence(ism,itype)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      IF(itype.eq.3) IPAE= 9+ism
      IF(itype.eq.4) IPAE=17  +ism
      icano_nnsta=2
      icnt_base=0
      do ismd=1,ng_sm
         ismc=mul_tab(ism,ismd)
         if ( ismc .gt. ismd ) cycle
         id_sta=ibsm_ext(ismd)
         idsta=id_sta
         idend=iesm_ext(ismd)
         ic_sta=ibsm_ext(ismc)
         icsta=ic_sta
         icend=iesm_ext(ismc)
         if ( ismd.eq.ismc ) idsta=idsta+1
         do id=idsta,idend
            m_jd=id-id_sta+1
         do ic=ic_sta,min(icend,id-1)
            m_jc=ic-ic_sta+1
            icano_nn=iwt_orb_ext(ic,id)
            if ( icnt_base+icano_nn-1.gt. max_tmpvalue ) then
               call complete_ext_loop()
               icnt_base=0
               icano_nnsta=icano_nn
            endif
            icano_nnend=icano_nn
            do ismb=1,ismd-1
               isma=mul_tab(ism,ismb)
               if ( isma .gt. ismb ) cycle
               if ( ismc .gt. ismb ) then
                  call g12_diffsym(isma,ismb,ismc)
               elseif ( ismc .gt. isma ) then
                  call g11a_diffsym(isma,ismb,ismc)
               else
                  call g11b_diffsym(isma,ismb,ismc)
               endif
            enddo
            if ( ism.eq.1 )   then
               isma=ismd
               call g1112_symaaaa(isma,ic,id)
            else
               isma=mul_tab(ism,ismd)
               call g11a11b_symaacc(isma,ismd,ic,id)
            endif
            ib=id
            call g10_ext(ismc,ic,id)
            ia=ic
            call g5_ext(ismd,ic,id)
            if ( ism.eq.1 ) call g9_ext(ismd,ic,id)
            icnt_base=icnt_base+icano_nn-1
         enddo
         enddo
      enddo
      if ( ism.eq.1 .and. itype.eq.4 ) then
      do id=1,norb_ext
         icano_nn=id+iwt_sm_s_ext
            if ( icnt_base+icano_nn-1.gt. max_tmpvalue ) then
               call complete_ext_loop()
               icnt_base=0
               icano_nnsta=icano_nn
            endif
            icano_nnend=icano_nn
            call ext_lp_ab_s1(id)
            icnt_base=icnt_base+icano_nn-1
      enddo
      endif
      call complete_ext_loop()
      end

      subroutine g12_diffsym(isma,ismb,ismc)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      if ( isma .lt. ismb ) then
      ip3smabc=isma+jp2(ismb)+jp3(ismc)
      ip2cd=m_jc+(m_jd-1)*nlsm_ext(ismc)      !severe_new_error_1206
      num_smab=nlsm_ext(isma)*nlsm_ext(ismb)  !need checking
      ipos_intbasetmp=ip4_abcd_ext_base(ip3smabc)+
     *            (ip2cd-1)*num_smab*3
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      iposint=ipos_intbasetmp
      do ib=ibsta,ibend
      do ia=iasta,iaend
         value_lpext(ilwei)=vint_ci(iposint+1)+vint_ci(iposint+2)
         ilwei=ilwei+1
         iposint=iposint+3
      enddo
      enddo
      else
      ip3smabc=isma+jp2(ismb)+jp3(ismc)
      ip2cd=m_jc+NGW2(m_jd)
      nsma=nlsm_ext(isma)
      num_smab=nsma*(nsma-1)/2   !need checking
      ipos_intbasetmp=ip4_abcd_ext_base(ip3smabc)+
     *            (ip2cd-1)*num_smab*3
      ibsta=ibsm_ext(ismb)+1
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      iposint=ipos_intbasetmp
      do ib=ibsta,ibend
      do ia=iasta,ib-1
         value_lpext(ilwei)=vint_ci(iposint+1)+vint_ci(iposint+2)
         ilwei=ilwei+1
         iposint=iposint+3
      enddo
      enddo
      endif
      end

      subroutine g11a_diffsym(isma,ismb,ismc)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipsmabc=isma+jp2(ismc)+jp3(ismb)
      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
      jdoffset=(m_jd-1)*nlsm_ext(ismb)
      jcoffset=(m_jc-1)*nlsm_ext(isma)
      num_smab=nlsm_ext(isma)*nlsm_ext(ismc)*3
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      ipos_intbasetmp=ipos_intbasetmp+jdoffset*num_smab+jcoffset*3
      do ib=ibsta,ibend
         iposint=ipos_intbasetmp
      do ia=iasta,iaend
         value_lpext(ilwei)=vint_ci(iposint)+vint_ci(iposint+2)
         iposint=iposint+3
         ilwei=ilwei+1
      enddo
         ipos_intbasetmp=ipos_intbasetmp+num_smab
      enddo
      end

      subroutine g11b_diffsym(isma,ismb,ismc)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipsmabc=ismc+jp2(isma)+jp3(ismb)
      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
      jdoffset=(m_jd-1)*nlsm_ext(ismb)
      jcoffset=m_jc-1
      num_smab=nlsm_ext(isma)*nlsm_ext(ismc)*3
      numint_jc=nlsm_ext(ismc)*3
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      ipos_intbasetmp=ipos_intbasetmp+jdoffset*num_smab+jcoffset*3
      do ib=ibsta,ibend
         iposint=ipos_intbasetmp      !+jcoffset*3
      do ia=iasta,iaend
         value_lpext(ilwei)=vint_ci(iposint)+vint_ci(iposint+1)
         ilwei=ilwei+1
         iposint=iposint+numint_jc
      enddo
         ipos_intbasetmp=ipos_intbasetmp+num_smab
      enddo
      end

      subroutine g1112_symaaaa(isma,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipsmabc=isma+jp2(isma)+jp3(isma)
      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
!
      icdpos_12=NGW4(m_jd)+NGW3(m_jc)
      iasta=ibsm_ext(isma)
      ibsta=iasta+1
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      iposint=ipos_intbasetmp+icdpos_12*3         !-3 unnecessary ?
      do   ib=ibsta,ic-1
!        jb=jb+1
         do ia=iasta,ib-1
            value_lpext(ilwei)=vint_ci(iposint+1)+vint_ci(iposint+2)
            ilwei=ilwei+1
            iposint=iposint+3
         enddo
      enddo

      icdpos_11a=NGW4(m_jd)+NGW2(m_jc)
      jb=m_jc
      do ib=ic+1,id-1
         jb=jb+1
         ibcdpos_11a=icdpos_11a+NGW3(jb)
         iposint=ipos_intbasetmp+ibcdpos_11a*3
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
         do ia=iasta,ic-1
            value_lpext(ilwei)=vint_ci(iposint)+vint_ci(iposint+2)
            ilwei=ilwei+1
            iposint=iposint+3
         enddo
      enddo

      icdpos_11b=NGW4(m_jd)+m_jc
      jb=m_jc+1
      do ib=ic+2,id-1
         jb=jb+1
         ibcdpos_11b=icdpos_11b+NGW3(jb)
         ja=m_jc
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
         do ia=ic+1,ib-1
            ja=ja+1
            iabcdpos_11b=ibcdpos_11b+NGW2(ja)
            iposint=ipos_intbasetmp+iabcdpos_11b*3-3
            value_lpext(ilwei)=vint_ci(iposint)+vint_ci(iposint+1)
            ilwei=ilwei+1
         enddo
      enddo
      end

      subroutine g11a11b_symaacc(isma,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipsmabc=isma+jp2(isma)+jp3(ismc)
      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
      num_smab=nlsm_ext(isma)
      num_smab=(num_smab*(num_smab-1))/2*3
      ibsta=ibsm_ext(ismc)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)

      jb=0
      ibdpos=NGW2(m_jd)
      ipos_intbasetmp=ipos_intbasetmp+
     *            ibdpos*num_smab+NGW2(m_jc)*3
      do ib=ibsta,id-1
         iposint=ipos_intbasetmp
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
         do ia=iasta,ic-1
            value_lpext(ilwei)=vint_ci(iposint)+vint_ci(iposint+2)
            ilwei=ilwei+1
            iposint=iposint+3
         enddo
         ipos_intbasetmp=ipos_intbasetmp+num_smab
      enddo

      ipos_intbasetmp=ip4_abcd_ext_base(ipsmabc)
      ibdpos=NGW2(m_jd)
      ipos_intbasetmp=ipos_intbasetmp+
     *            ibdpos*num_smab+m_jc*3
      do ib=ibsta,id-1
         iposint=ipos_intbasetmp
         ja=m_jc
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
         do ia=ic+1,iaend
            ja=ja+1
            iposint=ipos_intbasetmp+NGW2(ja)*3-3
            value_lpext(ilwei)=vint_ci(iposint)+vint_ci(iposint+1)
            ilwei=ilwei+1
         enddo
         ipos_intbasetmp=ipos_intbasetmp+num_smab
      enddo
      end

      subroutine g10_ext(ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipos_intbasetmp=ip3_abd_ext_base+(id-1)*np3_abd_ext   !severe_new_
      iasta=ibsm_ext(ismc)
      ilwei=icnt_base+iwt_orb_ext(iasta,id)
      do ia=iasta,ic-1
         ipos_g10=iwt_orb_ext(ia,ic)-1
         iposint=ipos_intbasetmp+ipos_g10*2
         value_lpext(ilwei)=vint_ci(iposint+1)+vint_ci(iposint)
     *            +vint_ci(ip2_aa_ext_base+ipos_g10)
         ilwei=ilwei+1
      enddo
      end

      subroutine g5_ext(ismd,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipos_intbasetmp=ip3_abd_ext_base+(ic-1)*np3_abd_ext
      ibsta=ibsm_ext(ismd)
      do ib=max(ic+1,ibsta),id-1
         ipos_g5=iwt_orb_ext(ib,id)-1            !severe_new_error
         iposint=ipos_intbasetmp+ipos_g5*2         !severe_new_error
         ilwei=icnt_base+iwt_orb_ext(ic,ib)
         value_lpext(ilwei)=vint_ci(iposint+1)+vint_ci(iposint)
     *            +vint_ci(ip2_aa_ext_base+ipos_g5)
      enddo
      end

      subroutine   g9_ext(ismd,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ipos_intbasetmp=ip3_abd_ext_base+(ic-1)*np3_abd_ext
      iasta=ibsm_ext(ismd)
      ilwei=icnt_base+iwt_orb_ext(iasta,ic)
      do ia=iasta,ic-1                     !severe_new_error
         ipos_g9=iwt_orb_ext(ia,id)-1
         iposint=ipos_intbasetmp+ipos_g9*2      !severe_new_error
         value_lpext(ilwei)=vint_ci(iposint+1)+vint_ci(iposint)
     *            +vint_ci(ip2_aa_ext_base+ipos_g9)
         ilwei=ilwei+1
      enddo
      end

      subroutine   ext_lp_ab_s1(id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      parameter (   v_sqtwo=1.414213562373095d0 )
      ipos_intbasetmp=ip3_abd_ext_base+(id-1)*np3_abd_ext
      ilwei=icnt_base
      iposintaa=ip2_aa_ext_base-1
      iposint=ipos_intbasetmp
      do ismb=1,ng_sm
         iasta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         ibsta=iasta+1
         do ib=ibsta,ibend
         do ia=iasta,ib-1
            iposintaa=iposintaa+1
            if ( ib .eq. id .or. ia .eq. id ) then
!              g2   arar+ar(head)ar
               ilwei=ilwei+1
               value_lpext(ilwei)=
     *         v_sqtwo*(vint_ci(iposintaa)+vint_ci(iposint))
            else
!              g6g7g8
               ilwei=ilwei+1
               value_lpext(ilwei)=v_sqtwo*vint_ci(iposint)
            endif
            iposint=iposint+2
         enddo
         enddo
      enddo
!           g1
!     lw=lw0
      iposint=ip2_dd_ext_base+NGW2(id)
      do ic=1,id-1
         ilwei=ilwei+1
         value_lpext(ilwei)=vint_ci(iposint)
         iposint=iposint+1
      enddo
      end

      subroutine g31_diffsym(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      iabc0=(lri-1)*nabc
      ic=m_jd
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      if ( isma .eq. ismb ) ibsta=ibsta+1
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)
      do ib=ibsta,ibend
        if ( isma .eq. ismb ) iaend=ib-1
        do ia=iasta,iaend
!     g31   type_12 arbrb^ra^r
          iabc=iabc0+ia+ngw2(ib)+ngw3(ic)
          iposint=intind_iabc(iabc)
         value_lpext(ilwei)=vint_ci(iposint+1)*w0plp31
     *               +vint_ci(iposint+2)*w1plp31
         ilwei=ilwei+1
        enddo
      enddo
      end

      subroutine g32a_diffsym(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      iabc0=(lri-1)*nabc

      ic=m_jd

      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)
      do ib=ibsta,ibend
        do ia=iasta,iaend
          iabc=iabc0+ia+ngw2(ic)+ngw3(ib)
          iposint=intind_iabc(iabc)
         value_lpext(ilwei)=vint_ci(iposint+2)*w0plp32
     *                  -vint_ci(iposint)*w1plp32
         ilwei=ilwei+1
        enddo
      enddo
      end

      subroutine g32b_diffsym(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      iabc0=(lri-1)*nabc

      ic=m_jd

      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      if ( ismb.eq.isma ) ibsta=ibsta+1         !severe_new_error
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      do ib=ibsta,ibend
        do ia=iasta,min(iaend,ib-1)
      !g32b
          iabc=iabc0+ic+ngw2(ia)+ngw3(ib)
          iposint=intind_iabc(iabc)
         value_lpext(ilwei)=vint_ci(iposint+1)*w0plp32   !severe_new_err
     *                  -vint_ci(iposint)*w1plp32
         ilwei=ilwei+1
        enddo
      enddo
      end


      subroutine assign_segmode_paras(indl,indr,ilrdivnodesm)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"
      ilsegdownwei=iseg_downwei(indl)
      irsegdownwei=iseg_downwei(indr)
      ilsegstawei=iseg_sta(indl)
      irsegstawei=iseg_sta(indr)
      ip2_intbase=ip2_ab_inn_base(ilrdivnodesm)
      ip2_intspace=int2ind_space_extsmab(ilrdivnodesm)
      ip2_intsymspace=int2ind_numijkl_extsmab(ilrdivnodesm)
      end

      subroutine external_space_plpmode_value_st()   !tt
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "paraconstants_h.fh"
      w0g36a=0.d0
      w0g36b=0.d0
      w0g34a=0.d0
      w0g34b=0.d0
      w0g35a=0.d0
      w0g35b=0.d0
      w0g2a=0.d0
      w0g2b=0.d0
      w0g4a=0.d0
      w0g4b=0.d0
      w0g14a=0.d0
      w0g15a=0.d0
!     w0g13a=0.d0

      !st
      w1g36a=v_sqthreevsqtwo
      w1g36b=v_sqthreevsqtwo
      w1g34a=-w1g36a
      w1g34b=-w1g36a
      w1g35a=w1g36a
      w1g35b=-w1g36a
      w1g2a=0.d0      !g2a   ab_d
      w1g2b=-v_sqthree   !severe_error
      w1g4a=0.d0
      w1g4b=v_sqthree
      w1g14a=w1g36a
      w1g15a=-w1g36a
      end

      subroutine external_space_plpmode_value_ts()   !tt
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "paraconstants_h.fh"
      w0g36a=0.d0
      w0g36b=0.d0
      w0g34a=0.d0
      w0g34b=0.d0
      w0g35a=0.d0
      w0g35b=0.d0
      w0g2a=0.d0
      w0g2b=0.d0
      w0g4a=0.d0
      w0g4b=0.d0
      w0g14a=0.d0
      w0g15a=0.d0
      !ts
      w1g36a=-v_onevsqtwo
      w1g36b=-v_onevsqtwo
      w1g34a=-w1g36a
      w1g34b=-w1g36a
      w1g35a=-w1g36a   !severe_error
      w1g35b=w1g36a
      w1g2a=1.d0      !g2a   ab_d
      w1g2b=0.d0
      w1g4a=-1.d0
      w1g4b=0.d0
      w1g14a=w1g36a
      w1g15a=-w1g36a
      end

      subroutine external_space_plpmode_value_ss()   !ss
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "paraconstants_h.fh"
      w0g36a=-v_onevsqtwo
      w0g36b=-v_onevsqtwo
      w0g34a=w0g36a
      w0g34b=w0g36a
      w0g35a=w0g36a
      w0g35b=w0g36a
      w0g2a=-1.d0
      w0g2b=-1.d0
      w0g4a=-1.d0
      w0g4b=-1.d0
      w0g14a=w0g36a
      w0g15a=w0g36a
      w0g13a=-v_sqtwo
      w1g36a=0.d0
      w1g36b=0.d0
      w1g34a=0.d0
      w1g34b=0.d0
      w1g35a=0.d0
      w1g35b=0.d0
      w1g2a=0.d0
      w1g2b=0.d0
      w1g4a=0.d0
      w1g4b=0.d0
      w1g14a=0.d0
      w1g15a=0.d0
      end

      subroutine external_space_plpmode_value_tt()   !tt
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "paraconstants_h.fh"
      w0g36a=-v_onevsqtwo
      w0g36b=-v_onevsqtwo
      w0g34a=w0g36a
      w0g34b=w0g36a
      w0g35a=-w0g36a
      w0g35b=-w0g36a
      w0g2a=0.d0
      w0g2b=0.d0
      w0g4a=0.d0
      w0g4b=0.d0
      w0g14a=w0g36a
      w0g15a=w0g36a
!     w0g13a=-v_sqtwo

      w1g36a=1.d0
      w1g36b=1.d0
      w1g34a=w1g36a
      w1g34b=w1g36a
      w1g35a=-w1g36a
      w1g35b=-w1g36a
      w1g2a=0.d0      !g2a   ab_d
      w1g2b=0.d0
      w1g4a=0.d0
      w1g4b=0.d0
      w1g14a=w1g36a
      w1g15a=w1g36a
      end

      subroutine external_space_plpmode_value_sd()
#include "drt_h.fh"
#include "paraconstants_h.fh"
#include "lpextmode_h.fh"
!     sd   lpmode_value
      w0g29=v_sqtwo
      w0g30=v_sqtwo
      w0g26a=v_sqtwo
      w1g26a=v_sqtwo
      w0g25=1.d0
      w0g25a=1.d0
      w1g25a=1.d0
      w0g27=1.d0
      w1g27=-1.d0
      w0g28a=1.d0
      w1g28a=1.d0
      w0g31=1.d0
      w1g31=1.d0
      w0g32=1.d0
      w1g32=-1.d0

      w0plp25=w0g25a
      w0plp26=w0g26a
      w0plp27=w0g27
      w1plp27=w1g27
      w0plp28=w0g28a
      w0plp29=w0g29
      w0plp30=w0g30
      w0plp31=w0g31
      w1plp31=w1g31
      w0plp32=w0g32
      w1plp32=w1g32

      end

      subroutine external_space_plpmode_value_td()
#include "drt_h.fh"
#include "paraconstants_h.fh"
#include "lpextmode_h.fh"
!     td   lpmode_value
      w0g29=0.d0
      w0g30=0.d0
      w0g26a=0.d0
      w1g26a=0.d0
      w0g25=1.d0
      w0g25a=1.d0
      w1g25a=1.d0
      w0g27=-1.d0
      w1g27=-1.d0
      w0g28a=-1.d0
      w1g28a=-1.d0
      w0g31=1.d0
      w1g31=-1.d0
      w0g32=-1.d0
      w1g32=-1.d0

      w0plp25=w0g25a
      w0plp26=w0g26a
      w0plp27=w0g27
      w1plp27=w1g27
      w0plp28=w0g28a
      w0plp31=w0g31
      w1plp31=w1g31
      w0plp32=w0g32
      w1plp32=w1g32

      end

      subroutine external_space_plpmode_value_ds()
#include "drt_h.fh"
#include "paraconstants_h.fh"
#include "lpextmode_h.fh"
!     ds   lpmode_value
      w0g25=-v_onevsqtwo
      w0g25b=-v_onevsqtwo
      w1g25b=-v_onevsqtwo
      w0g28b=-v_onevsqtwo
      w1g28b=-v_onevsqtwo
      w0g26b=-1.d0
      w1g26b=-1.d0

      w0plp25=w0g25
      w0plp25b=w0g25b
      w1plp25b=w1g25b
      w0plp28=w0g28b
      w1plp28=w1g28b
      w0plp26=w0g26b
      w1plp26=w1g26b

      end

      subroutine external_space_plpmode_value_dt()
#include "drt_h.fh"
#include "paraconstants_h.fh"
#include "lpextmode_h.fh"
!     dt   lpmode_value
      w0g25=v_sqthreevsqtwo   !v_onevsqtwo      !severe_new_error
      w0g25b=v_sqthreevsqtwo
      w1g25b=v_sqthreevsqtwo
      w0g28b=-v_sqthreevsqtwo
      w1g28b=-v_sqthreevsqtwo
      w0g26b=0.d0
      w1g26b=0.d0
      end

      subroutine ss_ext_plpmode(ilnodesm,irnodesm,iltype,irtype,lptype)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      ilrsm=mul_tab(ilnodesm,irnodesm)
      iii=1   !index to determine lwei rwei iposint and nlinkorb
!G2G4a G2G4b G1415 G13
      logic_g36a=.false.
      logic_g36b=.false.
      logic_g35a=.false.
      logic_g35b=.false.
      logic_g34a=.false.
      logic_g34b=.false.
!     if ( ilnodesm.eq.1 .and. irnodesm.eq.3 ) then
!        write(6,*)
!     endif

!G36b
      lpsta36a=iii
      call do_g36mode(ilrsm,ilnodesm,iii)
      lpend36a=iii-4
      if ( lpend36a .ge. lpsta36a ) logic_g36a=.true.   !severe_new_erro
      lpsta35a=iii
      call do_g35mode(ilrsm,ilnodesm,iii)
      lpend35a=iii-4
      if ( lpend35a .ge. lpsta35a ) logic_g35a=.true.
      lpsta34a=iii
      call do_g34mode(ilrsm,ilnodesm,iii)
      lpend34a=iii-4
      if ( lpend34a .ge. lpsta34a ) logic_g34a=.true.
      if ( ilrsm .ne. 1 ) then
         lpsta36b=iii
         call do_g36mode(ilrsm,irnodesm,iii)
         lpend36b=iii-4
         if ( lpend36b .ge. lpsta36b ) logic_g36b=.true.
         lpsta35b=iii
         call do_g35mode(ilrsm,irnodesm,iii)
         lpend35b=iii-4
         if ( lpend35b .ge. lpsta35b ) logic_g35b=.true.
         lpsta34b=iii
         call do_g34mode(ilrsm,irnodesm,iii)
         lpend34b=iii-4
         if ( lpend34b .ge. lpsta34b ) logic_g34b=.true.
      else
         logic_g36b=logic_g36a
         lpsta36b=lpsta36a
         lpend36b=lpend36a
         logic_g35b=logic_g35a
         lpsta35b=lpsta35a
         lpend35b=lpend35a
         logic_g34b=logic_g34a
         lpsta34b=lpsta34a
         lpend34b=lpend34a
      endif

!     G2G4a G2G4b G1415 G13
      logic_g2g4a=.false.
      logic_g2g4b=.false.
      logic_g1415=.false.
      logic_g13=.false.

      if ( irnodesm .eq. 1 .and. irtype .eq. 4 ) then
         logic_g2g4a=.true.
         ism_g2g4=ilnodesm
      endif
      if ( ilnodesm .eq. 1 .and. iltype .eq. 4 ) then
         logic_g2g4b=.true.
         ism_g2g4=irnodesm
      endif

      if ( lptype .ne. 2 .and. ilrsm .eq. 1 ) then
         logic_g1415=.true.
         ism_g1415=ilnodesm
         if ( ilnodesm .eq. 1 .and. iltype .eq. 4
     *      .and.irtype .eq. 4 ) then
            logic_g13=.true.
         endif
         if ( iltype.eq.4 ) then          !severe_error
            idownwei_g131415=irsegdownwei
         else
            idownwei_g131415=ilsegdownwei
         endif
      endif

      nvalue_space_ss=ip2_intsymspace/3

      end

      subroutine do_g36mode(ilrsm,ilnodesm,iii)
#include "drt_h.fh"
      do ismb=1,ng_sm
         isma=mul_tab(ismb,ilrsm)
         if (isma .gt. ismb ) cycle
         ismlink=mul_tab(isma,ilnodesm)
         if ( ismlink .gt. isma ) cycle
         call g36_form(isma,ismb,ismlink,iii)
      enddo
      end
      subroutine do_g34mode(ilrsm,ilnodesm,iii)
#include "drt_h.fh"
      do ismb=1,ng_sm
         isma=mul_tab(ismb,ilrsm)
         if (isma .gt. ismb ) cycle
         ismlink=mul_tab(isma,ilnodesm)
         if ( ismlink .lt. ismb ) cycle
         call g34_form(isma,ismb,ismlink,iii)
      enddo
      end
      subroutine do_g35mode(ilrsm,ilnodesm,iii)
#include "drt_h.fh"
      do ismb=1,ng_sm
         isma=mul_tab(ismb,ilrsm)
         if (isma .gt. ismb ) cycle
         ismlink=mul_tab(isma,ilnodesm)
         if ( ismlink .gt. ismb .or. ismlink .lt. isma ) cycle
         call g35_form(isma,ismb,ismlink,iii)
      enddo
      end

      subroutine g36_form(isma,ismb,ismlink,iii)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilinksta=ibsm_ext(ismlink)
      ilinkend=iesm_ext(ismlink)
      if ( isma .eq. ismlink ) iasta=iasta+1
      if ( ismb .eq. isma )    ibsta=ibsta+1
      if ( ismb .eq. ismlink ) ibsta=ibsta+1

      do ib=ibsta,ibend
         do ia=iasta,min(iaend,ib-1)
         icsta=ilinksta
         nlinkorb=min(ilinkend,ia-1)-ilinksta+1
         if ( nlinkorb .le. 0 ) cycle
         lpext_wei(iii)=iwt_orb_ext(icsta,ia)
         lpext_wei(iii+1)=iwt_orb_ext(icsta,ib)
         lpext_wei(iii+2)=iwt_orb_ext(ia,ib)
         lpext_wei(iii+3)=nlinkorb
         iii=iii+4
         enddo
      enddo
      end

      subroutine g34_form(isma,ismb,ismlink,iii)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilinksta=ibsm_ext(ismlink)
      ilinkend=iesm_ext(ismlink)
      if ( ismlink .eq. ismb ) ilinksta=ilinksta+1
      if ( ismlink .eq. isma ) ilinksta=ilinksta+1
      if ( ismb .eq. isma ) ibsta=ibsta+1

      do ilink=ilinksta,ilinkend
         do ib=ibsta,min(ibend,ilink-1)
         naorb=min(iaend,ib-1)-iasta+1
         if ( naorb .le. 0 ) cycle
         lpext_wei(iii)=iwt_orb_ext(iasta,ilink)
         lpext_wei(iii+1)=iwt_orb_ext(ib,ilink)
         lpext_wei(iii+2)=iwt_orb_ext(iasta,ib)
         lpext_wei(iii+3)=naorb
         iii=iii+4
         enddo
      enddo
      end

      subroutine g35_form(isma,ismb,ismlink,iii)
#include "drt_h.fh"
#include "lpextmode_h.fh"
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilinksta=ibsm_ext(ismlink)
      ilinkend=iesm_ext(ismlink)
      if ( ismb .eq. ismlink ) ibsta=ibsta+1
      if ( ismb .eq. isma ) ibsta=ibsta+1
      if ( ismlink .eq. isma ) ilinksta=ilinksta+1

      do ib=ibsta,ibend
         do ilink=ilinksta,min(ilinkend,ib-1)
         naorb=min(iaend,ilink-1)-iasta+1
         if ( naorb .le. 0 ) cycle
         lpext_wei(iii)=iwt_orb_ext(iasta,ilink)
         lpext_wei(iii+1)=iwt_orb_ext(ilink,ib)
         lpext_wei(iii+2)=iwt_orb_ext(iasta,ib)
         lpext_wei(iii+3)=naorb
         iii=iii+4
         enddo
      enddo
      end
      function ibfunction(ib,istep)
      SELECT CASE (istep)
         CASE (2)
            ibfunction=ib-1
         CASE (3)
            ibfunction=ib+1
         CASE DEFAULT
            ibfunction=ib
      END SELECT
      if ( ibfunction .lt. 0 ) then
         write(6,*) "error"
      endif
      end

      subroutine determine_para_array_for_int1ind()
#include "drt_h.fh"
#include "intsort_h.fh"
      do ismabc=1,ng_sm
        nintcount=0
        do ismc=1,ng_sm
          ismab=mul_tab(ismabc,ismc)
          numc=nlsm_ext(ismc)
          do ismb=1,ismc
            isma=mul_tab(ismab,ismb)
            if ( isma .gt. ismb ) cycle
            numb=nlsm_ext(ismb)
            numa=nlsm_ext(isma)
            numint=0
            if ( isma .eq. ismc ) then         !aaa
C              numint=numa-2+ip2(numb-1)+ip3(numc)
              if(numb.gt.1) then
                numint=numa-2+ngw2(numb-1)+ngw3(numc)
              endif
            elseif ( isma .eq. ismb ) then      !aac
C              numint=(numa-1+ip2(numb))*numc
              if(numb.gt.0) then
                if((numa-1+ngw2(numb)).gt.0) then
                  numint=(numa-1+ngw2(numb))*numc
                endif
              endif
            elseif ( ismb .eq. ismc ) then      !acc
C              numint=(numb-1+ip2(numc))*numa
              if(numc.gt.0) then
                if((numb-1+ngw2(numc)).gt.0) then
                  numint=(numb-1+ngw2(numc))*numa
                endif
              endif
            else                        !abc
              numint=numa*numb*numc
            endif
            if ( numint .le. 0 ) cycle            !severe_new_error
            numint=numint*3
            jpsmabc=isma+jp2(ismb)+jp3(ismc)
            intoset_of_ext_jpsmabc(jpsmabc)=nintcount
            nintcount=nintcount+numint
          enddo
        enddo
        intoset_of_aad_isma(ismabc)=nintcount
        numint=nlsm_ext(ismabc)*norb_ext*2
        nintcount=nintcount+numint
        numint=nlsm_ext(ismabc)
        intnum_of_innext_isma(ismabc)=nintcount+numint
      enddo
      end

      subroutine g_dd_ext_sequence_G(ism)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      COMMON /IAIB/ ICAN_A(MAX_ORB),ICAN_B(MTMP+MAX_ORB)
      IPAE=1+ISM
      icano_nnsta=2
      icnt_base=0
      iasta=ibsm_ext(ism)
      ibsta=iasta+1
      ibend=iesm_ext(ism)
      ilwei=0
      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,ib-1
            lra=norb_number(ia)
            ilwei=ilwei+1
            index_lpext(ilwei)=0
            index_lpext1(ilwei)=0

            NAC=ICAN_A(LRA)+LRB
            index_lpext2(ilwei)=NAC
            value_lpext2(ilwei)=1.0D+00
         enddo
      enddo
      icano_nnend=ibend-iasta+1
      call complete_ext_loop_G()
      end

      subroutine g_tt_ext_sequence_G(ism)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *      m_jc,m_jd, isegsta,isegupwei,isegdownwei
      IPAE=9+ism
      icano_nnsta=2
      icnt_base=0
      do ismd=1,ng_sm
            ismc=mul_tab(ism,ismd)
            if ( ismc .gt. ismd ) cycle
            id_sta=ibsm_ext(ismd)
            idsta=id_sta
            idend=iesm_ext(ismd)
            ic_sta=ibsm_ext(ismc)
            icsta=ic_sta
            icend=iesm_ext(ismc)
            if ( ismd.eq.ismc ) idsta=idsta+1
            do id=idsta,idend
                  m_jd=id-id_sta+1
            do ic=ic_sta,min(icend,id-1)
                  m_jc=ic-ic_sta+1
                  icano_nn=iwt_orb_ext(ic,id)
                  if ( icnt_base+icano_nn-1.gt. max_tmpvalue ) then
                        call complete_ext_loop_G()
                        icnt_base=0
                        icano_nnsta=icano_nn
                  endif
                  icano_nnend=icano_nn
                  do ismb=1,ismd-1
                        isma=mul_tab(ism,ismb)
                        if ( isma .gt. ismb ) cycle
                        if ( ismc .gt. ismb ) then
                          call g12_t_diffsym_G(isma,ismb,ismc,ic,id)
                        elseif ( ismc .gt. isma ) then
                          call g11a_t_diffsym_G(isma,ismb,ismc,ic,id)
                        else
                          call g11b_t_diffsym_G(isma,ismb,ismc,ic,id)
                        endif
                  enddo
                  if ( ism.eq.1 ) then
                        isma=ismd
                        call g1112_t_symaaaa_G(isma,ic,id)
                  else
                        isma=mul_tab(ism,ismd)
                        call g11a11b_t_symaacc_G(isma,ismd,ic,id)
                  endif
                  ib=id
                  call g36_t_ext_G(ismc,ic,id)
                  ia=ic
                  call g5_t_ext_G(ismd,ic,id)
                  if ( ism.eq.1 ) call g9_t_ext_G(ismd,ic,id)
                  icnt_base=icnt_base+icano_nn-1
            enddo
            enddo
      enddo
      call complete_ext_loop_G()
      end

      subroutine g_ss_ext_sequence_G(ism,itype)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      IF(itype.eq.3) IPAE= 9+ism
      IF(itype.eq.4) IPAE=17  +ism
      icano_nnsta=2
      icnt_base=0
      do ismd=1,ng_sm
         ismc=mul_tab(ism,ismd)
         if ( ismc .gt. ismd ) cycle
         id_sta=ibsm_ext(ismd)
         idsta=id_sta
         idend=iesm_ext(ismd)
         ic_sta=ibsm_ext(ismc)
         icsta=ic_sta
         icend=iesm_ext(ismc)
         if ( ismd.eq.ismc ) idsta=idsta+1
         do id=idsta,idend
            m_jd=id-id_sta+1
         do ic=ic_sta,min(icend,id-1)
            m_jc=ic-ic_sta+1
            icano_nn=iwt_orb_ext(ic,id)
            if ( icnt_base+icano_nn-1.gt. max_tmpvalue ) then
               call complete_ext_loop_G()
               icnt_base=0
               icano_nnsta=icano_nn
            endif
            icano_nnend=icano_nn
            do ismb=1,ismd-1
               isma=mul_tab(ism,ismb)
               if ( isma .gt. ismb ) cycle
               if ( ismc .gt. ismb ) then
                  call g12_diffsym_G(isma,ismb,ismc,ic,id)
               elseif ( ismc .gt. isma ) then
                  call g11a_diffsym_G(isma,ismb,ismc,ic,id)
               else
                  call g11b_diffsym_G(isma,ismb,ismc,ic,id)
               endif
            enddo
            if ( ism.eq.1 ) then
               isma=ismd
               call g1112_symaaaa_G(isma,ic,id)
            else
               isma=mul_tab(ism,ismd)
               call g11a11b_symaacc_G(isma,ismd,ic,id)
            endif
            ib=id
            call g10_ext_G(ismc,ic,id)
            ia=ic
            call g5_ext_G(ismd,ic,id)
            if ( ism.eq.1 ) then
               call g9_ext_G(ismd,ic,id)
            endif
            icnt_base=icnt_base+icano_nn-1
         enddo
         enddo
      enddo
      if ( ism.eq.1 .and. itype.eq.4 ) then
      do id=1,norb_ext
         icano_nn=id+iwt_sm_s_ext
            if ( icnt_base+icano_nn-1.gt. max_tmpvalue ) then
               call complete_ext_loop_G()
               icnt_base=0
               icano_nnsta=icano_nn
            endif
            icano_nnend=icano_nn
            call ext_lp_ab_s1_G(id)
            icnt_base=icnt_base+icano_nn-1
      enddo
      endif
      call complete_ext_loop_G()
      end

      subroutine g12_diffsym_G(isma,ismb,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
!       write(nf2,*) 'g12_diff'
      lrc=norb_number(ic)
      lrd=norb_number(id)

      if ( isma .lt. ismb ) then
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)

      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,iaend
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1

         enddo
      enddo
      else

      ibsta=ibsm_ext(ismb)+1
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)

      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,ib-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
      endif

c Avoid unused argument warnings
      if (.false.) call Unused_integer(ismc)
      end

      subroutine g11a_diffsym_G(isma,ismb,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

!       write(nf2,*) 'g11a_diff'
      lrc=norb_number(ic)
      lrd=norb_number(id)

      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)

      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,iaend
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
c Avoid unused argument warnings
      if (.false.) call Unused_integer(ismc)
      end

      subroutine g11b_diffsym_G(isma,ismb,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
!       write(nf2,*) 'g11b_diff'
      lrc=norb_number(ic)
      lrd=norb_number(id)

      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,iaend
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
c Avoid unused argument warnings
      if (.false.) call Unused_integer(ismc)
      end

      subroutine g1112_symaaaa_G(isma,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
!       write(nf2,*) 'g1112_symaaaa'
      lrc=norb_number(ic)
      lrd=norb_number(id)

      iasta=ibsm_ext(isma)
      ibsta=iasta+1
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)

      do ib=ibsta,ic-1
         lrb=norb_number(ib)
         do ia=iasta,ib-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo


      do ib=ic+1,id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
         do ia=iasta,ic-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo

      do ib=ic+2,id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
         do ia=ic+1,ib-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
      end

      subroutine g11a11b_symaacc_G(isma,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

!       write(nf2,*) 'g11a11b_symaacc'
      lrc=norb_number(ic)
      lrd=norb_number(id)

      ibsta=ibsm_ext(ismc)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)

      do ib=ibsta,id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
         do ia=iasta,ic-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo

      do ib=ibsta,id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
         do ia=ic+1,iaend
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
      end

      subroutine g10_ext_G(ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      COMMON /IAIB/ ICAN_A(MAX_ORB),ICAN_B(MTMP+MAX_ORB)
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
!        write(nf2,*) 'g10_ext'
      lrc=norb_number(ic)
      lrd=norb_number(id)
      iasta=ibsm_ext(ismc)
      ilwei=icnt_base+iwt_orb_ext(iasta,id)
      do ia=iasta,ic-1
         lra=norb_number(ia)
         CALL TRANS_IJKL_INTPOS(lra,lrc,lrd,lrd,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=1.0d+00
         CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrd,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=1.0d+00
         NAC=ICAN_A(LRA)+LRC
         index_lpext2(ilwei)=NAC
         value_lpext2(ilwei)=1.0d+00
         ilwei=ilwei+1
      enddo
      end

      subroutine g5_ext_G(ismd,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      COMMON /IAIB/ ICAN_A(MAX_ORB),ICAN_B(MTMP+MAX_ORB)
!        write(nf2,*) 'g5_ext'
      lrc=norb_number(ic)
      lrd=norb_number(id)
      ibsta=ibsm_ext(ismd)
      do ib=max(ic+1,ibsta),id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(ic,ib)
         CALL TRANS_IJKL_INTPOS(lrb,lrd,lrc,lrc,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=1.0d+00
         CALL TRANS_IJKL_INTPOS(lrb,lrc,lrd,lrc,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=1.0d+00
         NAC=ICAN_A(LRB)+LRD
         index_lpext2(ilwei)=NAC
         value_lpext2(ilwei)=1.0d+00
      enddo
      end

      subroutine g9_ext_G(ismd,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      COMMON /IAIB/ ICAN_A(MAX_ORB),ICAN_B(MTMP+MAX_ORB)
!         write(nf2,*) 'g9_ext'
      lrc=norb_number(ic)
      lrd=norb_number(id)
      iasta=ibsm_ext(ismd)
      ilwei=icnt_base+iwt_orb_ext(iasta,ic)
      do ia=iasta,ic-1
         lra=norb_number(ia)
         CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrc,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=1.0d+00
         CALL TRANS_IJKL_INTPOS(lra,lrc,lrd,lrc,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=1.0d+00
         NAC=ICAN_A(LRA)+LRD
         index_lpext2(ilwei)=NAC
         value_lpext2(ilwei)=1.0d+00
         ilwei=ilwei+1
      enddo
      end

      subroutine ext_lp_ab_s1_G(id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      COMMON /IAIB/ ICAN_A(MAX_ORB),ICAN_B(MTMP+MAX_ORB)
      parameter (   v_sqtwo=1.414213562373095d0 )
!         write(nf2,*) 'ext_lp_ab_s1'
      lrd=norb_number(id)
      ilwei=icnt_base

      do ismb=1,ng_sm
         iasta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         ibsta=iasta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
         do ia=iasta,ib-1
            lra=norb_number(ia)
            if ( ib .eq. id .or. ia .eq. id ) then
!              g2   arar+ar(head)ar
               ilwei=ilwei+1
               CALL TRANS_IJKL_INTPOS(lra,lrd,lrb,lrd,NXO)
               index_lpext(ilwei)=NXO
               value_lpext(ilwei)=v_sqtwo
               index_lpext1(ilwei)=0
               NAC=ICAN_A(LRA)+LRB
               index_lpext2(ilwei)=NAC
               value_lpext2(ilwei)=v_sqtwo
            else
!              g6g7g8
               ilwei=ilwei+1
               CALL TRANS_IJKL_INTPOS(lra,lrd,lrb,lrd,NXO)
               index_lpext(ilwei)=NXO
               value_lpext(ilwei)=v_sqtwo
               index_lpext1(ilwei)=0
               index_lpext2(ilwei)=0
            endif
         enddo
         enddo
      enddo
!           g1
C===================================
C  Drr-DRR
C  WL=2.0D0 but not 1.0D0 is based on that the non-diagonal just uses th
C  non-triangle <Ci|H|Cj> which designates that I > J.

      do ic=1,id-1
         lrc=norb_number(ic)
         ilwei=ilwei+1
         CALL TRANS_IJKL_INTPOS(lrc,lrd,lrc,lrd,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=2.0D+00
         index_lpext1(ilwei)=0
         index_lpext2(ilwei)=0
      enddo
      end

      subroutine g12_t_diffsym_G(isma,ismb,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      lrc=norb_number(ic)
      lrd=norb_number(id)

      if ( isma .lt. ismb ) then
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)

      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,iaend
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=-1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1

         enddo
      enddo
      else

      ibsta=ibsm_ext(ismb)+1
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)

      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,ib-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=-1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
      endif
c Avoid unused argument warnings
      if (.false.) call Unused_integer(ismc)
      end

      subroutine g11a_t_diffsym_G(isma,ismb,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      lrc=norb_number(ic)
      lrd=norb_number(id)

      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)

      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,iaend
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=-1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
c Avoid unused argument warnings
      if (.false.) call Unused_integer(ismc)
      end
      subroutine g11b_t_diffsym_G(isma,ismb,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      lrc=norb_number(ic)
      lrd=norb_number(id)

      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)    !need checking
      do ib=ibsta,ibend
         lrb=norb_number(ib)
         do ia=iasta,iaend
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=-1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
c Avoid unused argument warnings
      if (.false.) call Unused_integer(ismc)
      end


      subroutine g1112_t_symaaaa_G(isma,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      lrc=norb_number(ic)
      lrd=norb_number(id)

      iasta=ibsm_ext(isma)
      ibsta=iasta+1
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)

      do ib=ibsta,ic-1
         lrb=norb_number(ib)
         do ia=iasta,ib-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrb,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=-1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo


      do ib=ic+1,id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
         do ia=iasta,ic-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=-1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo

      do ib=ic+2,id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
         do ia=ic+1,ib-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=-1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
      end

      subroutine g11a11b_t_symaacc_G(isma,ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      lrc=norb_number(ic)
      lrd=norb_number(id)

      ibsta=ibsm_ext(ismc)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)

      do ib=ibsta,id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
         do ia=iasta,ic-1
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lra,lrc,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lra,lrd,lrb,lrc,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=-1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo

      do ib=ibsta,id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
         do ia=ic+1,iaend
            lra=norb_number(ia)
            CALL TRANS_IJKL_INTPOS(lrc,lra,lrb,lrd,NXO)
            index_lpext(ilwei)=NXO
            value_lpext(ilwei)=1.0d+00
            CALL TRANS_IJKL_INTPOS(lrc,lrb,lra,lrd,NXO)
            index_lpext1(ilwei)=NXO
            value_lpext1(ilwei)=-1.0d+00
            index_lpext2(ilwei)=0
            ilwei=ilwei+1
         enddo
      enddo
      end

      subroutine g36_t_ext_G(ismc,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      COMMON /IAIB/ ICAN_A(MAX_ORB),ICAN_B(MTMP+MAX_ORB)
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      lrc=norb_number(ic)
      lrd=norb_number(id)
      iasta=ibsm_ext(ismc)
      ilwei=icnt_base+iwt_orb_ext(iasta,id)
      do ia=iasta,ic-1
         lra=norb_number(ia)
         CALL TRANS_IJKL_INTPOS(lra,lrc,lrd,lrd,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=1.0d+00
         CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrd,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=-1.0d+00
         NAC=ICAN_A(LRA)+LRC
         index_lpext2(ilwei)=NAC
         value_lpext2(ilwei)=1.0d+00
         ilwei=ilwei+1
      enddo
      end

      subroutine g5_t_ext_G(ismd,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      COMMON /IAIB/ ICAN_A(MAX_ORB),ICAN_B(MTMP+MAX_ORB)
      lrc=norb_number(ic)
      lrd=norb_number(id)
      ibsta=ibsm_ext(ismd)
      do ib=max(ic+1,ibsta),id-1
         lrb=norb_number(ib)
         ilwei=icnt_base+iwt_orb_ext(ic,ib)
         CALL TRANS_IJKL_INTPOS(lrb,lrd,lrc,lrc,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=1.0d+00
         CALL TRANS_IJKL_INTPOS(lrb,lrc,lrd,lrc,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=-1.0d+00
         NAC=ICAN_A(LRB)+LRD
         index_lpext2(ilwei)=NAC
         value_lpext2(ilwei)=1.0d+00
      enddo
      end

      subroutine g9_t_ext_G(ismd,ic,id)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei
      COMMON /IAIB/ ICAN_A(MAX_ORB),ICAN_B(MTMP+MAX_ORB)
      lrc=norb_number(ic)
      lrd=norb_number(id)
      iasta=ibsm_ext(ismd)
      ilwei=icnt_base+iwt_orb_ext(iasta,ic)
      do ia=iasta,ic-1
         lra=norb_number(ia)
         CALL TRANS_IJKL_INTPOS(lra,lrd,lrc,lrc,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=-1.0d+00
         CALL TRANS_IJKL_INTPOS(lra,lrc,lrd,lrc,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=1.0d+00
         NAC=ICAN_A(LRA)+LRD
         index_lpext2(ilwei)=NAC
         value_lpext2(ilwei)=-1.0d+00
         ilwei=ilwei+1
      enddo
      end


      subroutine g31_diffsym_G(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ic=m_jd
      LRC=norb_number(m_jd)

      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      if ( isma .eq. ismb ) ibsta=ibsta+1
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)
      do ib=ibsta,ibend
         LRB=norb_number(IB)
         if ( isma .eq. ismb ) iaend=ib-1
         do ia=iasta,iaend
            LRA=norb_number(IA)
!     g31   type_12 arbrb^ra^r

         CALL TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp31
         CALL TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRB,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=w1plp31

         ilwei=ilwei+1
        enddo
      enddo
      end

      subroutine g32a_diffsym_G(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ic=m_jd
      LRC=norb_number(m_jd)
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)
      do ib=ibsta,ibend
         LRB=norb_number(IB)
        do ia=iasta,iaend
           LRA=norb_number(IA)
           CALL TRANS_IJKL_INTPOS(LRA,LRI,LRB,LRC,NXO)
           index_lpext(ilwei)=NXO
           value_lpext(ilwei)=w0plp32
           CALL TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
           index_lpext1(ilwei)=NXO
           value_lpext1(ilwei)=-w1plp32

         ilwei=ilwei+1
        enddo
      enddo
      end

      subroutine g32b_diffsym_G(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ic=m_jd
      LRC=norb_number(m_jd)
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      if ( ismb.eq.isma ) ibsta=ibsta+1
      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)
      do ib=ibsta,ibend
         LRB=norb_number(IB)
        do ia=iasta,min(iaend,ib-1)
           LRA=norb_number(IA)
      !g32b
           CALL TRANS_IJKL_INTPOS(LRC,LRB,LRA,LRI,NXO)
           index_lpext(ilwei)=NXO
           value_lpext(ilwei)=w0plp32
           CALL TRANS_IJKL_INTPOS(LRC,LRA,LRB,LRI,NXO)
           index_lpext1(ilwei)=NXO
           value_lpext1(ilwei)=-w1plp32

         ilwei=ilwei+1
        enddo
      enddo
      end

      subroutine gsd_samesym_aaa_G(lri,isma)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ic=m_jd
      lrc=norb_number(ic)

      iasta=ibsm_ext(isma)
      ibend=iesm_ext(isma)
      ibsta=iasta+1

      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)
      do ib=ibsta,ic-1
         LRB=norb_number(IB)
        do ia=iasta,ib-1
           LRA=norb_number(IA)
!     g31   type_12 arbrb^ra^r
         CALL TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp31
         CALL TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRB,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=w1plp31

         ilwei=ilwei+1
      enddo
      enddo

      ib=ic
      ilwei=icnt_base+iwt_orb_ext(iasta,ib)
      do ia=iasta,ib-1
         LRA=norb_number(IA)
!        g28     Cw-Ar                    330
         CALL TRANS_IJKL_INTPOS(LRA,LRC,LRI,LRC,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp28/w0g28a
         CALL TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRC,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=w0plp28

         ilwei=ilwei+1
      enddo

      ia=ic
      do ib=ic+1,ibend
         LRB=norb_number(IB)
!        g25,g27: Bl(20)-Drl(11)         220

         ilwei=icnt_base+iwt_orb_ext(ic,ib)

         CALL TRANS_IJKL_INTPOS(LRB,LRC,LRI,LRC,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp27
         CALL TRANS_IJKL_INTPOS(LRB,LRI,LRC,LRC,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=-w1plp27

      enddo

      do ib=ic+1,ibend
         LRB=norb_number(IB)

        ilwei=icnt_base+iwt_orb_ext(iasta,ib)
        do ia=iasta,ic-1
           LRA=norb_number(IA)

!     g32a   type g12
           CALL TRANS_IJKL_INTPOS(LRA,LRI,LRB,LRC,NXO)
           index_lpext(ilwei)=NXO
           value_lpext(ilwei)=w0plp32
           CALL TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
           index_lpext1(ilwei)=NXO
           value_lpext1(ilwei)=-w1plp32

          ilwei=ilwei+1
        enddo
      enddo

      do ib=ic+2,ibend
         LRB=norb_number(IB)

        ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
        do ia=ic+1,ib-1
           LRA=norb_number(IA)

!     g32b  type 11
           CALL TRANS_IJKL_INTPOS(LRC,LRB,LRA,LRI,NXO)
           index_lpext(ilwei)=NXO
           value_lpext(ilwei)=w0plp32
           CALL TRANS_IJKL_INTPOS(LRC,LRA,LRB,LRI,NXO)
           index_lpext1(ilwei)=NXO
           value_lpext1(ilwei)=-w1plp32

         ilwei=ilwei+1
        enddo
      enddo
      end

      subroutine gsd_diffsamesym_abb_G(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei


      ic=m_jd
      lrc=norb_number(ic)

      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)

      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)
      do ib=ibsta,ic-1
         LRB=norb_number(IB)
        do ia=iasta,iaend
           LRA=norb_number(IA)

!     g31   type_12 arbrb^ra^r
         CALL TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp31
         CALL TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRB,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=w1plp31

         ilwei=ilwei+1
        enddo
      enddo

      ilwei=icnt_base+iwt_orb_ext(iasta,ic+1)
      jb=m_jc
      do ib=ic+1,ibend
         LRB=norb_number(IB)
         jb=jb+1
        do ia=iasta,iaend
           LRA=norb_number(IA)
         !g32a
           CALL TRANS_IJKL_INTPOS(LRA,LRI,LRB,LRC,NXO)
           index_lpext(ilwei)=NXO
           value_lpext(ilwei)=w0plp32
           CALL TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
           index_lpext1(ilwei)=NXO
           value_lpext1(ilwei)=-w1plp32

         ilwei=ilwei+1
        enddo
      enddo

      ib=ic
      ilwei=icnt_base+iwt_orb_ext(iasta,ib)
      do ia=iasta,iaend      !ib-1      !severe_error_1020
         LRA=norb_number(IA)

!        g28
         CALL TRANS_IJKL_INTPOS(LRA,LRC,LRI,LRC,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp28/w0g28a
         CALL TRANS_IJKL_INTPOS(LRA,LRI,LRC,LRC,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=w0plp28

         ilwei=ilwei+1
      enddo
      end

      subroutine gsd_diffsamesym_aab_G(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ic=m_jd
      lrc=norb_number(ic)

      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)

      do ib=ibsta,ibend
         LRB=norb_number(IB)
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
        do ia=iasta,ic-1
         LRA=norb_number(IA)
         !g32a
           CALL TRANS_IJKL_INTPOS(LRA,LRI,LRB,LRC,NXO)
           index_lpext(ilwei)=NXO
           value_lpext(ilwei)=w0plp32
           CALL TRANS_IJKL_INTPOS(LRA,LRC,LRB,LRI,NXO)
           index_lpext1(ilwei)=NXO
           value_lpext1(ilwei)=-w1plp32

         ilwei=ilwei+1
        enddo
      enddo

      do ib=ibsta,ibend
         LRB=norb_number(IB)
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
        do ia=ic+1,iaend
           LRA=norb_number(IA)
         !g32b
           CALL TRANS_IJKL_INTPOS(LRC,LRB,LRA,LRI,NXO)
           index_lpext(ilwei)=NXO
           value_lpext(ilwei)=w0plp32
           CALL TRANS_IJKL_INTPOS(LRC,LRA,LRB,LRI,NXO)
           index_lpext1(ilwei)=NXO
           value_lpext1(ilwei)=-w1plp32

         ilwei=ilwei+1
        enddo
      enddo

      ia=ic
      do ib=ibsta,ibend
         LRB=norb_number(IB)
!        g25
         ilwei=icnt_base+iwt_orb_ext(ic,ib)

         CALL TRANS_IJKL_INTPOS(LRB,LRC,LRI,LRC,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp27
         CALL TRANS_IJKL_INTPOS(LRB,LRI,LRC,LRC,NXO)
         index_lpext1(ilwei)=NXO
         value_lpext1(ilwei)=-w1plp27

      enddo
      end

      subroutine gsd_arlp_s1_G(lri)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ic=m_jd
      lrc=norb_number(ic)

      ilwei=icnt_base+isegdownwei-norb_ext+1
      do is1orb=1,ic-1
!g30 -B^rD^rr
         lrk=norb_number(is1orb)
         CALL TRANS_IJKL_INTPOS(LRC,LRK,LRI,LRK,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp30
         index_lpext1(ilwei)=0

         ilwei=ilwei+1
      enddo

!g26 -A^r     610
         lrk=norb_number(ic)
         CALL TRANS_IJKL_INTPOS(LRC,LRK,LRI,LRK,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp26
         index_lpext1(ilwei)=0

      ilwei=ilwei+1

!g29 -Dl^rA^l
      do is1orb=ic+1,norb_ext
         lrk=norb_number(is1orb)
         CALL TRANS_IJKL_INTPOS(LRC,LRK,LRI,LRK,NXO)
         index_lpext(ilwei)=NXO
         value_lpext(ilwei)=w0plp29
         index_lpext1(ilwei)=0

        ilwei=ilwei+1
      enddo
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               1991, Anders Bernhardsson                              *
!***********************************************************************

subroutine CmbnT1_mck(Rnxyz,nZeta,la,lb,Zeta,rKappa,rFinal,Txyz,Alpha,Beta,IfGrad)
!***********************************************************************
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!             Anders Bernhardsson, Dept. of Theoretical Chemistry,     *
!             University of Lund, SWEDEN                               *
!             October '91                                              *
!***********************************************************************

use Index_Functions, only: C_Ind, nTri_Elem1
use Constants, only: Two, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb
real(kind=wp), intent(in) :: Rnxyz(nZeta,3,0:la+2,0:lb+2), Zeta(nZeta), Txyz(nZeta,3,0:la+1,0:lb+1), Alpha(nZeta), Beta(nZeta)
real(kind=wp), intent(inout) :: rKappa(nZeta), rFinal(nZeta,nTri_Elem1(la),nTri_Elem1(lb),1)
logical(kind=iwp), intent(in) :: IfGrad(3,2)
integer(kind=iwp) :: ipa, ipb, ixa, ixb, iya, iyaMax, iyb, iybMax, iza, izb
real(kind=wp) :: xa, xb, ya, yb, za, zb

!iRout = 134
!iPrint = nPrint(iRout)

!ii = nTri3_Elem(la)
!jj = nTri3_Elem(lb)
rKappa(:) = rKappa*Zeta**(-OneHalf)
do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind(la,ixa,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind(lb,ixb,izb)

        ! Combine integrals

        if (IfGrad(1,1)) then
          if (ixa > 0) then
            xa = real(-ixa,kind=wp)
            rFinal(:,ipa,ipb,1) = rKappa(:)*((Two*Txyz(:,1,ixa+1,ixb)*Alpha(:)+xa*Txyz(:,1,ixa-1,ixb))* &
                                             Rnxyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)+ &
                                             (Two*Rnxyz(:,1,ixa+1,ixb)*Alpha(:)+xa*Rnxyz(:,1,ixa-1,ixb))* &
                                             Txyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)+ &
                                             (Two*Rnxyz(:,1,ixa+1,ixb)*Alpha(:)+xa*Rnxyz(:,1,ixa-1,ixb))* &
                                             Rnxyz(:,2,iya,iyb)*Txyz(:,3,iza,izb))
          else
            rFinal(:,ipa,ipb,1) = rKappa(:)*Two*Alpha(:)*(Txyz(:,1,ixa+1,ixb)*Rnxyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)+ &
                                                          Rnxyz(:,1,ixa+1,ixb)*Txyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)+ &
                                                          Rnxyz(:,1,ixa+1,ixb)*Rnxyz(:,2,iya,iyb)*Txyz(:,3,iza,izb))
          end if
        end if
        if (IfGrad(1,2)) then
          if (ixb > 0) then
            xb = real(-ixb,kind=wp)
            rFinal(:,ipa,ipb,1) = rKappa(:)*((Two*Txyz(:,1,ixa,ixb+1)*Beta(:)+xb*Txyz(:,1,ixa,ixb-1))* &
                                             Rnxyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)+ &
                                             (Two*Rnxyz(:,1,ixa,ixb+1)*Beta(:)+xb*Rnxyz(:,1,ixa,ixb-1))* &
                                             Txyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)+ &
                                             (Two*Rnxyz(:,1,ixa,ixb+1)*Beta(:)+xb*Rnxyz(:,1,ixa,ixb-1))* &
                                             Rnxyz(:,2,iya,iyb)*Txyz(:,3,iza,izb))
          else
            rFinal(:,ipa,ipb,1) = rKappa(:)*Two*Beta(:)*(Txyz(:,1,ixa,ixb+1)*Rnxyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)+ &
                                                         Rnxyz(:,1,ixa,ixb+1)*Txyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb)+ &
                                                         Rnxyz(:,1,ixa,ixb+1)*Rnxyz(:,2,iya,iyb)*Txyz(:,3,iza,izb))
          end if
        end if
        if (IfGrad(2,1)) then
          if (iya > 0) then
            ya = real(-iya,kind=wp)
            rFinal(:,ipa,ipb,1) = rKappa(:)*(Txyz(:,1,ixa,ixb)*(Two*Rnxyz(:,2,iya+1,iyb)*Alpha(:)+ya*Rnxyz(:,2,iya-1,iyb))* &
                                             Rnxyz(:,3,iza,izb)+ &
                                             Rnxyz(:,1,ixa,ixb)*(Two*Txyz(:,2,iya+1,iyb)*Alpha(:)+ya*Txyz(:,2,iya-1,iyb))* &
                                             Rnxyz(:,3,iza,izb)+ &
                                             Rnxyz(:,1,ixa,ixb)*(Two*Rnxyz(:,2,iya+1,iyb)*Alpha(:)+ya*Rnxyz(:,2,iya-1,iyb))* &
                                             Txyz(:,3,iza,izb))
          else
            rFinal(:,ipa,ipb,1) = rKappa(:)*Two*Alpha(:)*(Txyz(:,1,ixa,ixb)*Rnxyz(:,2,iya+1,iyb)*Rnxyz(:,3,iza,izb)+ &
                                                          Rnxyz(:,1,ixa,ixb)*Txyz(:,2,iya+1,iyb)*Rnxyz(:,3,iza,izb)+ &
                                                          Rnxyz(:,1,ixa,ixb)*Rnxyz(:,2,iya+1,iyb)*Txyz(:,3,iza,izb))
          end if
        end if
        if (IfGrad(2,2)) then
          if (iyb > 0) then
            yb = real(-iyb,kind=wp)
            rFinal(:,ipa,ipb,1) = rKappa(:)*(Txyz(:,1,ixa,ixb)*(Two*Rnxyz(:,2,iya,iyb+1)*Beta(:)+yb*Rnxyz(:,2,iya,iyb-1))* &
                                             Rnxyz(:,3,iza,izb)+ &
                                             Rnxyz(:,1,ixa,ixb)*(Two*Txyz(:,2,iya,iyb+1)*Beta(:)+yb*Txyz(:,2,iya,iyb-1))* &
                                             Rnxyz(:,3,iza,izb)+ &
                                             Rnxyz(:,1,ixa,ixb)*(Two*Rnxyz(:,2,iya,iyb+1)*Beta(:)+yb*Rnxyz(:,2,iya,iyb-1))* &
                                             Txyz(:,3,iza,izb))
          else
            rFinal(:,ipa,ipb,1) = rKappa(:)*Two*Beta(:)*(Txyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb+1)*Rnxyz(:,3,iza,izb)+ &
                                                         Rnxyz(:,1,ixa,ixb)*Txyz(:,2,iya,iyb+1)*Rnxyz(:,3,iza,izb)+ &
                                                         Rnxyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb+1)*Txyz(:,3,iza,izb))
          end if
        end if
        if (IfGrad(3,1)) then
          if (iza > 0) then
            za = real(-iza,kind=wp)
            rFinal(:,ipa,ipb,1) = rKappa(:)*(Txyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)* &
                                             (Two*Rnxyz(:,3,iza+1,izb)*Alpha(:)+za*Rnxyz(:,3,iza-1,izb))+ &
                                             Rnxyz(:,1,ixa,ixb)*Txyz(:,2,iya,iyb)* &
                                             (Two*Rnxyz(:,3,iza+1,izb)*Alpha(:)+za*Rnxyz(:,3,iza-1,izb))+ &
                                             Rnxyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)* &
                                             (Two*Txyz(:,3,iza+1,izb)*Alpha(:)+za*Txyz(:,3,iza-1,izb)))
          else
            rFinal(:,ipa,ipb,1) = rKappa(:)*Two*Alpha(:)*(Txyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)*Rnxyz(:,3,iza+1,izb)+ &
                                                          Rnxyz(:,1,ixa,ixb)*Txyz(:,2,iya,iyb)*Rnxyz(:,3,iza+1,izb)+ &
                                                          Rnxyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)*Txyz(:,3,iza+1,izb))
          end if
        end if
        if (IfGrad(3,2)) then
          if (izb > 0) then
            zb = real(-izb,kind=wp)
            rFinal(:,ipa,ipb,1) = rKappa(:)*(Txyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)* &
                                             (Two*Rnxyz(:,3,iza,izb+1)*Beta(:)+zb*Rnxyz(:,3,iza,izb-1))+ &
                                             Rnxyz(:,1,ixa,ixb)*Txyz(:,2,iya,iyb)* &
                                             (Two*Rnxyz(:,3,iza,izb+1)*Beta(:)+zb*Rnxyz(:,3,iza,izb-1))+ &
                                             Rnxyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)* &
                                             (Two*Txyz(:,3,iza,izb+1)*Beta(:)+zb*Txyz(:,3,iza,izb-1)))
          else
            rFinal(:,ipa,ipb,1) = rKappa(:)*Two*Beta(:)*(Txyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb+1)+ &
                                                         Rnxyz(:,1,ixa,ixb)*Txyz(:,2,iya,iyb)*Rnxyz(:,3,iza,izb+1)+ &
                                                         Rnxyz(:,1,ixa,ixb)*Rnxyz(:,2,iya,iyb)*Txyz(:,3,iza,izb+1))
          end if
        end if

      end do
    end do
  end do
end do

return

end subroutine CmbnT1_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MMSort2(A,B,P,iel)
      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "disp_mclr.fh"
      Real*8 A(*),B(*),P(*)
      integer iel(3)
      logical geomi,geomj
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      ijD=0
      iG=0
      ijG=0
      ijP=0
      iii=0
      Call icopy(3,[0],0,iel,1)
      Do iSym=1,nsym
       Do idisp=1,ldisp(isym)
        geomi=iand(ntpert(idisp+iii),16).eq.16
        if (.not.geomi) Then
         iG=iG+1
         iel(ig)=isym
         Do jdisp=1,ldisp(isym)
          geomj=iand(ntpert(jdisp+iii),16).eq.16
          if (geomj) Then
           ijg=ijg+1
           ijd1=ijD+itri(idisp,jdisp)
           B(ijG)=A(ijD1)
           Else if (idisp.le.jdisp) Then
            ijP=itri(dspvec(jdisp+iii),dspvec(idisp+iii))
            P(ijP)=A(ijD+itri(idisp,jdisp))
          End If
         End do
        End If
       End do
       ijD=ijD+ldisp(isym)*(ldisp(isym)+1)/2
       iii=iii+ldisp(isym)
      End do
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c DefParReord_t3
c DefParReordHlp1
c DefParReordHlp2
c IniReord_t3
c GetX_t3
c cht3_rea
c gather_t2
c grow_t2eq
c grow_t2neq
c grow_l1
c calc_MP2
c generate_juzekOE
c defcommon
c
c
c
c
c
c
c
c
c       ------------------------------------
c
        subroutine DefParReord_t3 (NaGrpR,maxdim)

c
c       This routine do:
c       define parameters in cht3_reord.fh using NaGrpR,maxdim
c
c       I/O parameter description:
c       NxGrpR   - # of groups in a (=b) set (I)
c       maxdim   - # maximal dimension of a (=b) Groups(O)
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "files.fh"
c
        integer NaGrpR,maxdim
c
c       help variables
c
        real*8 rdim
        integer i,j
        integer Up(1:MaxGrp),Low(1:MaxGrp)
c
c
c1      define parameters of Groups of a set
c
        rdim=1.0d0*nv/(1.0d0*NaGrpR)
c
        do i=1,NaGrpR
c
           if (i.eq.1) then
             Up(i)=int(rdim*i)
             Low(i)=1
           else if (i.eq.NaGrpR) then
             Up(i)=nv
             Low(i)=Up(i-1)+1
           else
             Up(i)=int(rdim*i)
             Low(i)=Up(i-1)+1
           end if
c
           DimGrpaR(i)=(Up(i)-Low(i))+1
c
        end do
c
c
c2      find maximal dimensions of a'
c
        maxdim=DimGrpaR(1)
        do i=1,NaGrpR
          if (DimGrpaR(i).gt.maxdim) then
          maxdim=DimGrpaR(i)
          end if
        end do
c
c
c3.1    def L2Name, T2Name, I2Name,I3Name
c
        do i=1,MaxGrp
        do j=1,MaxGrp
          call DefParReordHlp1(i,j,'L2',L2Name(i,j))
          call DefParReordHlp1(i,j,'T2',T2Name(i,j))
          call DefParReordHlp1(i,j,'I2',I2Name(i,j))
          call DefParReordHlp1(i,j,'I3',I3Name(i,j))
        end do
        end do
c
c3.2    def L1Name,I1Name
c
        do i=1,MaxGrp
          call DefParReordHlp2 (i,'L1vc',L1Name(i))
          call DefParReordHlp2 (i,'I1in',I1Name(i))
        end do
c
c3.3    def L0Name,I0Name
c
        L0Name='L0vctr'
        I0Name='I0intg'
c
        return
        end
c
c       ---------------------
c
        subroutine DefParReordHlp1 (i,j,Schem,Nomen)
c
c       help routine to DefPar..., producing names of Disc files
c       ex: Schem='XY', i=1, j=3  ->  Nomen='XY0103'
c        N.B. suspendovana rutina
c
        implicit none
        integer i,j
        character*2 Schem
        character*6 Nomen
c
c       help variables
        character*1 Chr(1:6)
        character*2 digit(1:64)
        character*2 ichr,jchr
        character*2 baza
        character*6 meno
c
        equivalence (Chr(1),meno)
        equivalence (Chr(1),baza)
        equivalence (Chr(3),ichr)
        equivalence (Chr(5),jchr)
c
c
c        quite a porno this piece
        digit(1)='01'
        digit(2)='02'
        digit(3)='03'
        digit(4)='04'
        digit(5)='05'
        digit(6)='06'
        digit(7)='07'
        digit(8)='08'
        digit(9)='09'
        digit(10)='10'
        digit(11)='11'
        digit(12)='12'
        digit(13)='13'
        digit(14)='14'
        digit(15)='15'
        digit(16)='16'
        digit(17)='17'
        digit(18)='18'
        digit(19)='19'
        digit(20)='20'
        digit(21)='21'
        digit(22)='22'
        digit(23)='23'
        digit(24)='24'
        digit(25)='25'
        digit(26)='26'
        digit(27)='27'
        digit(28)='28'
        digit(29)='29'
        digit(30)='30'
        digit(31)='31'
        digit(32)='32'
        digit(33)='33'
        digit(34)='34'
        digit(35)='35'
        digit(36)='36'
        digit(37)='37'
        digit(38)='38'
        digit(39)='39'
        digit(40)='40'
        digit(41)='41'
        digit(42)='42'
        digit(43)='43'
        digit(44)='44'
        digit(45)='45'
        digit(46)='46'
        digit(47)='47'
        digit(48)='48'
        digit(49)='49'
        digit(50)='50'
        digit(51)='51'
        digit(52)='52'
        digit(53)='53'
        digit(54)='54'
        digit(55)='55'
        digit(56)='56'
        digit(57)='57'
        digit(58)='58'
        digit(59)='59'
        digit(60)='60'
        digit(61)='61'
        digit(62)='62'
        digit(63)='63'
        digit(64)='64'
c
c
        baza=Schem
        ichr=digit(i)
        jchr=digit(j)
        Nomen=meno
c
        return
        end
c
c       ---------------------
c
        subroutine DefParReordHlp2 (i,Schem,Nomen)
c
c       help routine to DefParo2v4, producing names of Disc files
c       ex: Schem='XYZQ', i=1  ->  Nomen='XYZQ01'
c
        implicit none
        integer i
        character*4 Schem
        character*6 Nomen
c
c       help variables
        character*1 Chr(1:6)
        character*2 digit(1:64)
        character*2 ichr
        character*4 baza
        character*6 meno
c
        equivalence (Chr(1),meno)
        equivalence (Chr(1),baza)
        equivalence (Chr(5),ichr)
c
c
        digit(1)='01'
        digit(2)='02'
        digit(3)='03'
        digit(4)='04'
        digit(5)='05'
        digit(6)='06'
        digit(7)='07'
        digit(8)='08'
        digit(9)='09'
        digit(10)='10'
        digit(11)='11'
        digit(12)='12'
        digit(13)='13'
        digit(14)='14'
        digit(15)='15'
        digit(16)='16'
        digit(17)='17'
        digit(18)='18'
        digit(19)='19'
        digit(20)='20'
        digit(21)='21'
        digit(22)='22'
        digit(23)='23'
        digit(24)='24'
        digit(25)='25'
        digit(26)='26'
        digit(27)='27'
        digit(28)='28'
        digit(29)='29'
        digit(30)='30'
        digit(31)='31'
        digit(32)='32'
        digit(33)='33'
        digit(34)='34'
        digit(35)='35'
        digit(36)='36'
        digit(37)='37'
        digit(38)='38'
        digit(39)='39'
        digit(40)='40'
        digit(41)='41'
        digit(42)='42'
        digit(43)='43'
        digit(44)='44'
        digit(45)='45'
        digit(46)='46'
        digit(47)='47'
        digit(48)='48'
        digit(49)='49'
        digit(50)='50'
        digit(51)='51'
        digit(52)='52'
        digit(53)='53'
        digit(54)='54'
        digit(55)='55'
        digit(56)='56'
        digit(57)='57'
        digit(58)='58'
        digit(59)='59'
        digit(60)='60'
        digit(61)='61'
        digit(62)='62'
        digit(63)='63'
        digit(64)='64'
c
        baza=Schem
        ichr=digit(i)
        Nomen=meno
c
        return
        end
c
c       ----------------
c
        subroutine IniReord_t3(NaGrp,wrksize)
c
c       nacitanie vsupu a inicializacia premnennych
c       a tlac primitivnej hlavicky pre Reord procesz
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
cmp
#include "cholesky.fh"
#include "para_info.fh"
#include "ccsd_t3compat.fh"
cmp
c
        integer NaGrp
        integer wrksize
cmp!
        integer nOrb(8),nOcc(8)
        integer ndelvirt

        integer LuSpool
        character*80 LINE
        character*80 TITLE
cmp
        integer rc
        real*8 FracMem
        character*3 msg

#ifdef _MOLCAS_MPP_
        integer jal1, jal2
#endif
cmp

c setup defaults

        Call Get_iArray('nOrb',nOrb,1)
        Call Get_iArray('nIsh',nOcc,1)

c
        no = nOcc(1)
        nv = nOrb(1) - nOcc(1)
c
        FracMem=0.0d0
        Call Cho_X_init(rc,FracMem) ! initialize cholesky info
c
c       take local # of Cholesky Vectors on this node
#ifdef _MOLCAS_MPP_
c
        do jal1=0,Nprocs-1
          NChLoc(jal1)=0
        end do
c
        NChLoc(MyRank)=NumCho(1)

        call gaigop (NChLoc(0),NProcs,'+')
c
        jal2=0
        do jal1=0,NProcs-1
          jal2=jal2+NChLoc(jal1)
        end do

        nc = jal2
#else
        nc = NumCho(1)
#endif

        Call Cho_X_final(rc)

        ndelvirt = 0
        LunAux = 13
        mhkey = 1
        generkey = 1
cmp!        NaGrp = 1
        Call get_iScalar('CHCCLarge',NaGrp)
        restkey = 0
        printkey = 1

c t3 specific keywords

        gen_files   = .True.
        run_triples = .True.
        t3_starta   = -1
        t3_stopa    = -1
        t3_startb   = -1
        t3_stopb    = -1
c
cmp!    read input file
c
      LuSpool = 17
      Call SpoolInp(LuSpool)
      Rewind(LuSpool)
 5      Read(LuSpool,'(A80)') LINE
       CALL UPCASE(LINE)
       IF( INDEX(LINE,'&CHT3') .EQ. 0 ) GOTO 5
       TITLE=' '
 6     Read(LuSpool,'(A80)') LINE
       IF(LINE(1:1).EQ.'*') GOTO 6
       CALL UPCASE(LINE)
c
       IF (LINE(1:4).EQ.'TITL') THEN
       Read(LuSpool,'(A72)') TITLE

       ELSE IF (LINE(1:4).EQ.'FROZ') THEN ! FROZen
       Read(LuSpool,*) nfr
             if ((nfr.lt.0).or.(nfr.ge.no)) then
               write (6,*)
               write (6,*) 'Ilegal value for FROZen keyword : ',
     &                      nfr
               call abend()
             end if
             no = no - nfr

       ELSE IF (LINE(1:4).EQ.'DELE') THEN ! DELEted
       Read(LuSpool,*) ndelvirt
             if ((ndelvirt.lt.0).or.(ndelvirt.ge.nv)) then
               write (6,*)
               write (6,*) 'Ilegal value for DELEted keyword : ',
     &                      ndelvirt
               call abend()
             end if
             nv = nv - ndelvirt

cmp!       ELSE IF (LINE(1:4).EQ.'LARG') THEN ! LARGegroup
cmp!       Read(LuSpool,*) NaGrp
cmp!        if ((NaGrp.lt.1).or.(NaGrp.gt.32)) then
cmp!         write (6,*)
cmp!         write (6,*) 'Ilegal value for LARGegroup keyword : ',
cmp!     &                NaGrp
cmp!         write (6,*) 'Large segmentation must be -le 32'
cmp!         call abend()
cmp!        end if

cmp!       ELSE IF (LINE(1:4).EQ.'LUNA') THEN  ... toto sa nikdy nevyuzivalo
cmp!       Read(LuSpool,*) LunAux

       ELSE IF (LINE(1:4).EQ.'MHKE') THEN ! MHKEy
       Read(LuSpool,*) mhkey
           if ((mhkey.lt.0).or.(mhkey.gt.2)) then
              mhkey=1
              write(6,*)
              write(6,*) ' Warning!!! ',
     &                   ' MHKEy out of range, changed to 1'
           end if

       ELSE IF (LINE(1:4).EQ.'REST') THEN ! RESTart
            restkey = 1
            write (6,*)
            write (6,*) 'RESTart option is temporary disabled'
            write (6,*) 'No Restart possible (... yet).'
            call abend()

       ELSE IF (LINE(1:4).EQ.'PRIN') THEN ! PRINtkey
       Read(LuSpool,*) printkey
          if (((printkey.lt.0).or.(printkey.gt.10)).or.
     & ((printkey.gt.2).and.(printkey.lt.10))) then

            write (6,*)
            write (6,*) 'Ilegal value of the PRINtkey keyword: ',
     &                   printkey
            write (6,*) ' Use: 1  (Minimal) '
            write (6,*) '      2  (Minimal + Timings)'
            write (6,*) '      10 (Debug) '
            call abend()
          end if

       ELSE IF (LINE(1:4).EQ.'NOGE') THEN ! NOGEnerate
            gen_files = .False.

       ELSE IF (LINE(1:4).EQ.'NOTR') THEN ! NOTRiples
            run_triples = .False.

       ELSE IF (LINE(1:4).EQ.'ALOO') THEN ! ALOOp
       Read(LuSpool,*) t3_starta, t3_stopa
            if ((t3_starta.lt.-1).or.(t3_stopa.lt.-1)) then
               write (6,*) 'ALOOp values can be either: '
               write (6,*) '"-1" : indicating normal run, or'
               write (6,*) 'positive numbers!'
               call abend()
            end if

       ELSE IF (LINE(1:4).EQ.'BLOO') THEN ! BLOOp
       Read(LuSpool,*) t3_startb, t3_stopb
            if ((t3_startb.lt.-1).or.(t3_stopb.lt.-1)) then
               write (6,*) 'BLOOp values can be either: '
               write (6,*) '"-1" : indicating normal run, or'
               write (6,*) 'positive numbers!'
               call abend()
            end if

       ELSE IF (LINE(1:4).EQ.'END ') THEN
       GOTO 7
       END IF
       GOTO 6
7      CONTINUE

       Call Close_LuSpool(LuSpool)

c! take care of the cholesky vectors segmentation
c! to lead to < 100 blocks

cmp checks
        if (t3_starta.gt.t3_stopa) then
          write (6,*) 'Mismatch in input : '
          write (6,*) 'T3_STARTA = ',t3_starta
          write (6,*) 'T3_STOPA = ',t3_stopa
          call abend()
        end if
c
        if (t3_startb.gt.t3_stopb) then
          write (6,*) 'Mismatch in input : '
          write (6,*) 'T3_STARTB = ',t3_startb
          write (6,*) 'T3_STOPB = ',t3_stopb
          call abend()
        end if
c
        if ((t3_starta.lt.0).and.(t3_stopa.gt.0)) then
          write (6,*) 'Mismatch in input : '
          write (6,*) 'T3_STARTA = ',t3_starta
          write (6,*) 'T3_STOPA = ',t3_stopa
          call abend()
        end if
c
        if ((t3_startb.lt.0).and.(t3_stopb.gt.0)) then
          write (6,*) 'Mismatch in input : '
          write (6,*) 'T3_STARTB = ',t3_startb
          write (6,*) 'T3_STOPB = ',t3_stopb
          call abend()
        end if
c
cmp!        if ((t3_starta.gt.0).and.(t3_startb.lt.0)) then
cmp!          write (6,*) 'This restart combination not implemented'
cmp!          write (6,*) 'T3_STARTA = ',t3_starta
cmp!          write (6,*) 'T3_STARTB = ',t3_startb
cmp!          call abend
cmp!        end if
c
c2      tlac hlavicky
        write (6,*)
        write (6,*) '    Cholesky Based Closed-Shell (T) code'
        write (6,*)
      write (6,*) '--------------------------------------------------'

        write (6,'(A,i9)') ' Frozen Orbitals                   : ',
     & nfr
        write (6,'(A,i9)') ' Occupied Orbitals                 : ',
     & no
        write (6,'(A,i9)') ' Virtual Orbitals                  : ',
     & nv
        write (6,'(A,i9)') ' Total number of Cholesky Vectors  : ',
     & nc

      write (6,*) '--------------------------------------------------'

        write (6,'(A,i9)') ' Large Virtual Segmentation        : ',
     & NaGrp

      write (6,*) '--------------------------------------------------'

        msg = 'No'
        if (gen_files) msg = 'Yes'

        write (6,'(A,A5)') ' Generate Triples Scratch Files?        : ',
     & msg

        msg = 'No'
        if (.not.run_triples) msg = 'Yes'

        write (6,'(A,A5)') ' Stop after Scratch Files generation?   : ',
     & msg

      write (6,*) '--------------------------------------------------'

        if (t3_starta.eq.-1) then
          write (6,'(A,i4)') ' Calculating full loop A                '
        else
           write (6,'(A,i4)')
     & ' VO index triplet to start with in loop A : ',t3_starta
           write (6,'(A,i4)')
     & ' VO index triplet to stop  at   in loop A : ',t3_stopa
        end if

        if (t3_starta.eq.-1) then
          write (6,'(A,i4)') ' Calculating full loop B                '
        else
           write (6,'(A,i4)')
     & ' VO index triplet to start with in loop B : ',t3_startb
           write (6,'(A,i4)')
     & ' VO index triplet to stop  at   in loop B : ',t3_stopb
        end if

      write (6,*) '--------------------------------------------------'

        write (6,'(A,i9)') ' Lun Number for Aux. Matrixes      : ',
     & LunAux
        write (6,'(A,i9)') ' BLAS/FTN Matrix Handling          : ',
     & mhkey

        msg = 'No'
        if (restkey.eq.1) msg = 'Yes'

        write (6,'(A,A10)') ' Start from RstFil ?               : ',
     & msg
        write (6,'(A,i9)') ' Print level                       : ',
     & printkey

      write (6,*) '--------------------------------------------------'
        write (6,*)
c
        return
c Avoid unused argument warnings
        if (.false.) call Unused_integer(wrksize)
        end
c
c       -----------
c
        subroutine GetX_t3 (X,length,Lun,LunName,keyopen,keyclose)
c
c       this routine do
c       1) keyopen = 0 - nothing (i.e) file is opened
c                    1 - open LunName file with Lun
c                    2 - rewind Lun file
c                    3 - open LunName file with Lun with ACCESS='append'
c       2) read X  of dimension length
c       3) keyclose= 0 - nothing
c                    1 - close Lun file
c
c
        implicit none
        integer length,Lun,keyopen,keyclose
        real*8 X(1)
        character*6 LunName
c
c1
        if (keyopen.eq.1) then
*         open (unit=Lun,file=LunName,form='unformatted')
          Call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
        else if (keyopen.eq.2) then
          rewind(Lun)
        else if (keyopen.eq.3) then
cmp!          open (unit=Lun,file=LunName,form='unformatted',
cmp!     c          ACCESS='append')

          Call MOLCAS_BinaryOpen_Vanilla(Lun,LunName)
          call append_file_u(Lun)

        end if
c
c2
        call cht3_rea (Lun,length,X(1))
c
c3
        if (keyclose.eq.1) then
          close (Lun)
        end if
c
        return
        end
c
c       ----------------
c
        subroutine cht3_rea (lun,length,A)
c
c       nacitane bloku dat
c
        implicit none
        integer lun,length
        real*8 A(1:length)
c
        read (lun) A
c
        return
        end
c
c       -----------
c

        subroutine gather_t2(t2,t2_tmp,tmp)
c
c temporary routine. In future T2 block structure will be merged
c                    with the block structure of the (T) code
c
c this routine do :
c
c cycle through T2XY files and gather them into on T2 array
c T2(nv_beta,nv_alpha,no_beta,no_alpha)
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "files.fh"
#include "ccsd_t3compat.fh"
c
        integer a,b,dima,dimb
cmp        integer lenght
        integer lenght
        integer lasta,lastb
c
        real*8 t2(*),tmp(*),t2_tmp(*)
        integer a_tmp,b_tmp
c
cmp        write (6,*)
cmp        write (6,*) '------ DimGrpaR ------'
cmp        write (6,'(8(i5,2x))') (DimGrpaR(a_tmp),a_tmp=1,NvGrp)
cmp        write (6,*)
c
        do a=1,NvGrp
        do b=1,a
c
cmp@@        dima=nv/NvGrp
        dima=DimGrpaR(a)
        dimb=DimGrpaR(b)
c
cmp        write (6,'(A,i3,i3,2x,A6)') 'a,b,T2Name(a,b) ',a,b,T2Name(a,b)
c
         if (a.eq.b) then  ! a=b
c open the pertinent file
c
cmp@@         if (a.eq.NvGrp) dima=nv-((NvGrp-1)*dima)
        dimb=dima
c
cmp         write (6,*) 'dima = ',dima
         lenght=(dima*(dima+1)*no*no)/2
cmp         write (6,*) 'lenght = ',lenght
cmp!         write (6,*) 'file size (g77) = ',16+lenght*8
cmp         write (6,*) 'file size (ifort) = ',8+lenght*8
c
        call GetX_t3 (tmp,lenght,LunAux,T2Name(a,b),1,1)
c
         else ! a>b
c open the pertinent file
c
cmp@@         if (a.eq.NvGrp) dima=nv-((NvGrp-1)*dima)
cmp@@         if (b.eq.NvGrp) dimb=nv-((NvGrp-1)*dimb)
c
cmp         write (6,*) 'dima = ',dima
cmp         write (6,*) 'dimb = ',dimb
         lenght=dima*dimb*no*no
cmp         write (6,*) 'lenght = ',lenght
cmp!         write (6,*) 'file size (g77) = ',16+lenght*8
cmp         write (6,*) 'file size (ifort) = ',8+lenght*8
c
        call GetX_t3 (tmp,lenght,LunAux,T2Name(a,b),1,1)
c
         end if
c
c add its contents to the t2 array
c
cmp@@        lasta=(a-1)*(nv/NvGrp)
cmp@@        lastb=(b-1)*(nv/NvGrp)
cmp@@
          lasta=0
        if (a.gt.1) then
          do a_tmp=1,a-1
          lasta=lasta+DimGrpaR(a_tmp)
          end do
        end if
c
          lastb=0
        if (b.gt.1) then
          do b_tmp=1,b-1
          lastb=lastb+DimGrpaR(b_tmp)
          end do
        end if
cmp@@
c
cmp        write (6,'(A,2(i5,2x),2(i3,x))') 'lasta, lastb, a, b = ',
cmp     & lasta,lastb,a,b
c
        if (a.eq.b) then ! expand and map
c expand and map l2_1 (a',b',m) <- tmp (m,ab')
        call expand4_12 (tmp,t2_tmp,dima,no,no)
        call grow_t2neq(t2,t2_tmp,dima,dimb,nv,no,
     & lasta,lastb)
        else
        call grow_t2neq(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb)
        end if
c
        end do
        end do
c
        return
        end
c
c ---------------
c
        subroutine grow_t2neq(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb)
c
c this routine do :
c
c grow amplitude file t2(a,b,i,j) by the segment in tmp
c for case sa != sb
c
        implicit none
        integer a,b,dima,dimb,nv,no,i,j
        integer lasta,lastb
        real*8 t2(1:nv,1:nv,1:no,1:no)
        real*8 tmp(1:dima,1:dimb,1:no,1:no)
c
cmp        write (6,*) 'grow_t2neq dima , dimb  ',dima,dimb
cmp        write (6,*) 'grow_t2neq lasta, lastb ',lasta,lastb
cmp        write (6,*) 'grow_t2neq no           ',no
c
c?        if (lasta.eq.lastb) then
c?        do j=1,no
c?        do i=1,no
c?        do a=1,dima
c?        do b=1,a
c?        t2(lasta+a,lastb+b,i,j)=1.0d0*tmp(a,b,i,j)
c?cmp        if (a.ne.b) t2(lastb+b,lasta+a,j,i)=-1.0d0*tmp(a,b,j,i)
c?        if (a.ne.b) t2(lastb+b,lasta+a,j,i)=1.0d0*tmp(a,b,i,j)
c?        end do
c?        end do
c?        end do
c?        end do
c
c?        else
c
        do j=1,no
        do i=1,no
        do b=1,dimb
        do a=1,dima
        t2(lasta+a,lastb+b,i,j)=1.0d0*tmp(a,b,i,j)
cmp        t2(lastb+b,lasta+a,j,i)=-1.0d0*tmp(b,a,j,i)
        t2(lastb+b,lasta+a,j,i)=1.0d0*tmp(a,b,i,j)
        end do
        end do
        end do
        end do
c
c?        end if
c
        return
        end
c
c ---------------
c
        subroutine grow_l1(l1,tmp,dima,nc,no,nv,last)
c
c this routine do :
c
c grow Cholesky vectors L1(m,i,a) by the segment in tmp
c
        implicit none
        integer a,dima,nc,nv,no,i,m,last
        real*8 l1(1:nc,1:no,1:nv)
        real*8 tmp(1:nc,1:no,1:dima)
c
cmp        write (6,*) 'grow_l1i ',dima
c
        do a=1,dima
        do i=1,no
        do m=1,nc
        l1(m,i,last+a)=tmp(m,i,a)
        end do
        end do
        end do
c
c
        return
        end
c
c --------------------
c
        subroutine calc_MP2 (w,e,no,nv)
c
c this is primitive checking routine to calculate 2nd order energy
c
        implicit none
        integer i,j,a,b,no,nv
        real*8 e(1:(no+nv)),w(1:nv,1:no,1:nv,1:no)
        real*8 e2,integral,denom
c
        e2=0.0d0
c
        do j=1,no
        do i=1,no
        do b=1,nv
        do a=1,nv
c
        denom=e(no+a)+e(no+b)-e(i)-e(j)
cmp!        write (6,'(4(i3,2x),A,3(f17.10,2x))') a,i,b,j,'w1, w2, denom ',
cmp!     & w(a,i,b,j),w(a,j,b,i),denom

        integral=(-1.0d0)*w(a,i,b,j)*(2.0d0*w(a,i,b,j)+
     & (-1.0d0)*w(a,j,b,i))

c!      write (6,*) integral

        e2=e2+(integral/denom)
c
        end do
        end do
        end do
        end do
c
        write (6,*) 'Druhy rad je asi = ',e2
c
        return
        end
c
c ---------
c
        subroutine generate_juzekOE (oe,oeh,oep,no,nv)
c
c this routine do :
c
c modifies standar oe record to one used by DIRCC
c
c oeh = ( oe_occ(alpha) ... oe_occ(beta) )   (alpha=beta for this
c                                             implementation)
c
c oep = ( oe_virt(alpha) ... oe_virt(beta) ) (alpha=beta for this
c                                             implementation)
        implicit none
        integer i,no,nv
c
        real*8 oe(*),oeh(*),oep(*)
c
c
        do i=1,no
        oeh(i)=oe(i)
        oeh(i+no)=oe(i)
        end do
c
        do i=1,nv
        oep(i)=oe(no+i)
        oep(i+nv)=oe(no+i)
        end do
c
        return
        end
c
c ---------------
c
        subroutine defcommon (nfr,no,nv)
c
c this routine do :
c
c define commons needed in DIRCC routines
c
        implicit none
        integer nfr,nv,no
        integer NOAB(2),NNOAB(3),NUAB(2),NNUAB(3)
        character*1 ich(3)
        integer IT,ITLAST,NBF,NOMX,NU,NOO,MX2,NNO,NNU,NUO,NSO
        integer me,nprocs
c
        COMMON/UHF/NOAB,NNOAB,NUAB,NNUAB,ICH
        COMMON/PARAM/IT,ITLAST,NBF,NOMX,NU,MX2,NNO,NNU,NUO,NSO
        common /my_mpi_world_com/ me, nprocs
c
cmp!        include 'task_info_inc'
cmp!        include 'ws_conn_inc'
c
c       logical llmpi
c
        integer IOPT
        COMMON/IOIND/IOPT(96)
c
c ----  UHF -----
c
        noab(1)=no
        noab(2)=no
c
        nnoab(1)=noab(1)*(noab(1)-1)/2
        nnoab(2)=noab(2)*(noab(2)-1)/2
        nnoab(3)=noab(1)*noab(2)
c
        nuab(1)=nv
        nuab(2)=nv
c
        nnuab(1)=(nuab(1)*(nuab(1)-1))/2
        nnuab(2)=(nuab(2)*(nuab(2)-1))/2
        nnuab(3)=nuab(1)*nuab(2)
c
        ich(1)="A"
        ich(2)="B"
        ich(3)="C"
c
c ----  PARAM ----
c
        nso=0
c??????????????????
        it=1
        itlast=1
        nbf=nfr+no+nv
        nomx=nbf
        noo=no
        nu=nv
        mx2=(nbf*(nbf+1))/2
        nno=(no*(no+1))/2
        nnu=(nu*(nu+1))/2
        nuo=no*nu
c
c ------ my_mpi_world_com --------
c
c zatial pre sekvencny chod
c
cmp!      me=0
cmp!      nprocs=1
cmp!      llmpi=.false.
cmp!      nws=1
cmp!      iws(1)=1
cmp!      lws(1)=.true.
c
c ------ pre Get3DM -----------
c
c ------    IOPT    -----------
c
        IOPT(14)=6
        IOPT(30)=0
        IOPT(76)=0
        IOPT(93)=0
        IOPT(93)=64
        IOPT(95)=0
c
C  sets IOPT(27) to an extreme number to force one file - temporary !!!  preskumat !!!
C  in prder to be compatible with RHF i=2^31-1
      iopt(27)=2147483647
c
c
c
c zatial tolko
c
        return
        end
c
c ---------------
c
        subroutine gen_vvvo(occ_ind,w3,l1_1,l2_1,tmp)
c
c this routine do
c
c regenerate VVVo integrals from cholesky vectors
c
c -------------------
c
c structure of the cholesky vector files :
c
c       L1(m,I ,A') L1vcxx xx - Group of A'
c
c       L2(m,A'B')  L2xxyy xx - Group of A', A'>=B'
c                          yy - Group of B'
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "files.fh"
#include "ccsd_t3compat.fh"
c
        integer a,b,c,dima,dimb,dimc,occ_ind
        integer lenght
        integer lasta,lastb,lastc
c
        real*8 w3(1:(nv*(nv+1))/2,1:nv)
        real*8 tmp(*),l1_1(*),l2_1(*)
c
        integer a_tmp,b_tmp,c_tmp
c
c algoritmus je dobry ak maxdim > no
c inak treba vymenit citanie L1 za L2
c
c dalo by sa to urobit podstatne lepsie, kedby
c dircc nevyzadoval VVV ako (ab,c) ale ako (a,b,c)
c
c mozno urob sort L1i (m,c') <- L1(m,i,c')
c ---
c
c1         loop over a'
c
        do a=1,NvGrp
c
c2        loop over b'
c
        do b=1,a
c
c2.1        read L2(m,a',b')
c
         if (a.eq.b) then  ! a=b
c open the pertinent file
c
cmp@        dima=nv/NvGrp
cmp@         if (a.eq.NvGrp) dima=nv-((NvGrp-1)*dima)
        dima=DimGrpaR(a)
c
cmp!         write (6,*) 'dima = ',dima
         dimb=dima
         lenght=(dima*(dima+1)*nc)/2
cmp!         write (6,*) 'lenght L2Name(a,b) = ',L2Name(a,b),lenght
cmp!     write (6,*) 'file size (g77) = ',16+lenght*8
cmp!         write (6,*) 'file size L2Name(a,b) (ifort) = ',
cmp!     & L2Name(a,b),8+lenght*8
c
        call GetX_t3 (tmp,lenght,LunAux,L2Name(a,b),1,1)
c
         else ! a>b
c open the pertinent file
c
cmp@@        dima=nv/NvGrp
cmp@@        dimb=nv/NvGrp
cmp@@         if (a.eq.NvGrp) dima=nv-((NvGrp-1)*dima)
cmp@@         if (b.eq.NvGrp) dimb=nv-((NvGrp-1)*dimb)
        dima=DimGrpaR(a)
        dimb=DimGrpaR(b)
c
cmp!         write (6,*) 'dima, dimb = ',dima,dimb
         lenght=dima*dimb*nc
cmp!         write (6,*) 'lenght L2Name(a,b) = ',L2Name(a,b),lenght
cmp!     write (6,*) 'file size (g77) = ',16+lenght*8
cmp!         write (6,*) 'file size L2Name(a,b) (ifort) = ',
cmp!     & L2Name(a,b),8+lenght*8
c
        call GetX_t3 (tmp,lenght,LunAux,L2Name(a,b),1,1)
        end if
c
c2.2        map  L2_1(a',b',m) <- tmp(m,a',b')
c
        if (a.eq.b) then ! expand and map
c expand and map l2_1 (a',b',m) <- tmp (m,ab')
        call exMap3_231 (tmp,l2_1,nc,dima)
        else
        call Map3_231_t3 (tmp,l2_1,nc,dima,dimb)
        end if
c
c3         loop over c'
c
        do c=1,NvGrp
c
c3.1        read L1(m,i,c')
c
cmp@@        dimc=nv/NvGrp
cmp@@         if (c.eq.NvGrp) dimc=nv-((NvGrp-1)*dimc)
        dimc=DimGrpaR(c)
c
cmp!         write (6,*) 'dimc = ',dimc
         lenght=nc*no*dimc
cmp!         write (6,*) 'lenght L1Name(c) = ',L1Name(c),lenght
cmp!         write (6,*) 'file size L1Name(c) (ifort) = ',
cmp!     & L1Name(c),8+8*lenght
c
        call GetX_t3 (tmp,lenght,LunAux,L1Name(c),1,1)
c
c3.2        extract l1_1 (m,c')_i <- tmp (m,i,c')
c toto by sa dalo nahradit mapovanim
c
        call ext_o_32 (tmp,l1_1,nc,no,dimc,occ_ind)
c
c3.2.1        zero tmp
c
        call zeroma(tmp,1,dima*dimb*dimc)
c
c3.3         mult tmp (a',b',c') <- L2_1 (a',b',m) l1_1 (m,c')
c
               call mc0c1a3b
     & (dima*dimb,nc,nc,dimc,dima*dimb,dimc,
     & dima*dimb,nc,dimc,l2_1,l1_1,tmp)
C
c3.4        add W(ab,c) <- tmp (a'b'c')
c
cmp@@        lasta=(a-1)*(nv/NvGrp)
cmp@@        lastb=(b-1)*(nv/NvGrp)
cmp@@        lastc=(c-1)*(nv/NvGrp)
c
          lasta=0
        if (a.gt.1) then
          do a_tmp=1,a-1
          lasta=lasta+DimGrpaR(a_tmp)
          end do
        end if
c
          lastb=0
        if (b.gt.1) then
          do b_tmp=1,b-1
          lastb=lastb+DimGrpaR(b_tmp)
          end do
        end if
c
          lastc=0
        if (c.gt.1) then
          do c_tmp=1,c-1
          lastc=lastc+DimGrpaR(c_tmp)
          end do
        end if
c
cmp!        write (6,'(A,3(i4),2x,3(i4))') 'lasta, lastb, lastc = ',
cmp!     & lasta,lastb,lastc,a,b,c

c sme v gen_vvvo
        call grow_w3 (w3,tmp,
     & nv,nv,dima,dimb,dimc,lasta,lastb,lastc)
c
c3.5        end loop over c'
        end do
c4        end loop over b'
        end do
c5        end loop over a'
        end do
c
        return
        end
c
c --------------------
c
        subroutine pack32_23 (AA,BB,d1,d2)
c
c this routine do :
c
c A(a,b,c) -> B(a,bc)  bc : b>=c,  dimb must eq dimc
c
        implicit none
        integer d1,d2,a,b,c,bc
        real*8 AA(d1,d2,d2),BB(d1,(d2*(d2+1)/2))
c
        bc=0
        do b=1,d2
        do c=1,b
        do a=1,d1
c
        bc=bc+1
        BB(a,bc)=AA(a,b,c)
        end do
        end do
        end do
c
        return
        end
c
c
c --------------------
c
        subroutine pack23_23 (AA,BB,d1,d2)
c
c this routine do :
c
c A(a,bc) -> B(a,b,c)  bc : b>=c,  dimb must eq dimc
c
        implicit none
        integer d1,d2,a,b,c,bc
        real*8 BB(d1,d2,d2),AA(d1,(d2*(d2+1)/2))
c
        bc=0
        do b=1,d2
        do c=1,b
        do a=1,d1
c
        bc=bc+1
        BB(a,b,c)=AA(a,bc)
        BB(a,c,b)=AA(a,bc)
        end do
        end do
        end do
c
        return
        end
c
c -----------------------
c
        subroutine exMap3_231 (A,B,d1,d2)
c
c this routine do :
c
c A (a,bc) -> B(b,c,a)
c
        implicit none
        integer d1,d2,i1,i2,i3,i23
        real*8 A(1:d1,1:(d2*(d2+1))/2)
        real*8 B(1:d2,1:d2,1:d1)
c
        i23=0
        do i2=1,d2
        do i3=1,i2
        i23=i23+1
        do i1=1,d1
c
        B(i2,i3,i1)=A(i1,i23)
        B(i3,i2,i1)=A(i1,i23)
c
        end do
        end do
        end do
c
        return
        end
c
c -------------------------
c
c3.2        extract l1_1 (m,c')_i <- tmp (m,i,c')
c
        subroutine ext_o_32 (A,B,nc,no,dima,occ_ind)
c
c this routine do :
c
c extract B (m,a')_i <- A (m,i,a')
c
        implicit none
        integer i1,i2,occ_ind,dima,nc,no
        real*8 A(1:nc,1:no,1:dima),B(1:nc,1:dima)
c
        do i2=1,dima
        do i1=1,nc
c
        B(i1,i2)=A(i1,occ_ind,i2)
c
        end do
        end do
c
        return
        end
c
c -----------------------------
c
        subroutine grow_w3_old (w3,AA,nv,d2,dima,dimb,dimc,
     & lasta,lastb,lastc)
c
c this routine do :
c
c add the block contribution AA(a',b',c') to w3(a>=b,c)
c
        implicit none
c
        integer a,b,c,dima,dimb,dimc,lasta,lastb,lastc,ab,nv
        integer a_point,b_point
        integer d2
        real*8 w3(1:(nv*(nv+1))/2,1:d2)
        real*8 AA(1:dima,1:dimb,1:dimc)
        integer a_old,b_old
c
        if ((dima.eq.0).or.(dimb.eq.0)) then
        write (6,*) 'dima, dimb = ',dima,dimb
        write (6,*) 'zle je'
        call abend()
        end if
c
        a_point=0
        b_point=0
        ab=0
        write (6,'(A,3(i5))') 'lasta, lastb, lastc = ',lasta,lastb,lastc
        write (6,'(A,2(i5))') 'dima, dimb          = ',dima,dimb
c
        a_old=0
        b_old=0
c
        do a=1,nv
        b_point=0
        do b=1,a
        ab=ab+1
        if ((a.ge.(lasta+1)).and.(a.le.(lasta+dima))) then
c
        if (a.ne.a_old) then
        a_point=a_point+1
        a_old=a
        end if
c
        if ((b.ge.max(1,lastb+1)).and.
     & (b.le.min(a,lastb+dimb))) then
c
!        write (6,*) 'b, b_old = ',b,b_old
        if ((b.ne.b_old).or.(b.eq.max(1,lastb+1))) then
!        write (6,*) 'wft'
        b_point=b_point+1
        b_old=b
        end if
c
c!        if (lastc.eq.0) write (6,'(A,5(i5))') 'ab, a, b, a_point, b_point = ',
c!     & ab,a,b,a_point,b_point
        do c=1,dimc
        w3(ab,lastc+c)=AA(a_point,b_point,c)
        end do
c
        end if
        end if
c
        end do
        end do
c
        return
        end
c
c -----------------------------
c
        subroutine grow_w3 (w3,AA,nv,d2,dima,dimb,dimc,
     & lasta,lastb,lastc)
c
c this routine do :
c
c add the block contribution AA(a',b',c') to w3(a>=b,c)
c
        implicit none
c
        integer a,b,c,dima,dimb,dimc,lasta,lastb,lastc,ab,nv
        integer a_point,b_point
        integer d2
        real*8 w3(1:(nv*(nv+1))/2,1:d2)
        real*8 AA(1:dima,1:dimb,1:dimc)
        integer a_old,b_old
c
        if ((dima.eq.0).or.(dimb.eq.0)) then
        write (6,*) 'dima, dimb = ',dima,dimb
        write (6,*) 'zle je'
        call abend()
        end if
c
        a_point=0
        b_point=0
        ab=0
cmp        write (6,'(A,3(i5))') 'lasta, lastb, lastc = ',lasta,lastb,lastc
cmp        write (6,'(A,2(i5))') 'dima, dimb          = ',dima,dimb
c
        a_old=0
        b_old=0
c
        do a=1,nv
        b_point=0
        do b=1,a
        ab=ab+1
        if ((a.ge.(lasta+1)).and.(a.le.(lasta+dima))) then
c
        if (a.ne.a_old) then
        a_point=a_point+1
        a_old=a
        end if
c
        if ((b.ge.max(1,lastb+1)).and.
     & (b.le.min(a,lastb+dimb))) then
c
!        write (6,*) 'b, b_old = ',b,b_old
        if ((b.ne.b_old).or.(b.eq.max(1,lastb+1))) then
!        write (6,*) 'wft'
        b_point=b_point+1
        b_old=b
        end if
c
cmp        if (lastc.eq.0) write (6,'(A,5(i5))') 'ab, a, b, a_point, b_point = ',
cmp     & ab,a,b,a_point,b_point
        do c=1,dimc
        w3(ab,lastc+c)=AA(a_point,b_point,c)
        end do
c
        end if
        end if
c
        end do
        end do
c
        return
        end
c
c --------------------
c
        subroutine pack32_12 (AA,BB,d1,d2)
c
c this routine do :
c
c A(a,b,c) -> B(ab,c)  bc : b>=c,  dimb must eq dimc
c
        implicit none
        integer d1,d2,a,b,c,ab
        real*8 AA(d1,d1,d2),BB(1:(d1*(d1+1)/2),1:d2)
c
        do c=1,d2
        ab=0
        do a=1,d1
        do b=1,a
        ab=ab+0
c
        BB(ab,c)=AA(a,b,c)
        end do
        end do
        end do
c
        return
        end
c
c --------------------
c
        subroutine pack43_34 (AA,BB,d1,d2,d3)
c
c this routine do :
c
c A(a,b,c,d) -> B(a,b,cd)  c>=d
c
        implicit none
        integer d1,d2,d3,a,b,c,d,cd
        real*8 AA(d1,d2,d3,d3),BB(d1,d2,(d3*(d3+1)/2))
c
        cd=0
        do c=1,d3
        do d=1,c
        cd=cd+1
        do b=1,d2
        do a=1,d1
c
        BB(a,b,cd)=AA(a,b,c,d)
        end do
        end do
        end do
        end do
c
        return
        end
c
c -------------------
c
        subroutine gen_oovo (w,l0,l1,tmp)
c
c this routine genetates (ij,a,k) integrals from
c blocked MO cholesky vectors
c
c --------
c
c       L0(m,IJ)    L0vctr  I>=J
c       L1(m,I ,A') L1vcxx xx - Group of A'
c

        implicit none
c
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "files.fh"
#include "ccsd_t3compat.fh"
c
        real*8 tmp(*),l0(*),l1(*),w(*)
        integer a,dima,lenght,last
c
        integer a_tmp
c
c1        read tmp(m,IJ)
c
        lenght=nc*(no*(no+1))/2
c
cmp!        write (6,'(A,A6)') 'L0vcrt ','L0vcrt'
cmp!        write (6,*) 'lenght = ',lenght
cmp!        write (6,*) 'file size (ifort) = ',8+8*lenght
c
        call GetX_t3 (tmp,lenght,LunAux,'L0vctr',1,1)
c2        map l0(IJ,m)   <- tmp(m,IJ)
c
        call Map2_21_t3 (tmp,l0,nc,(no*(no+1)/2))
c
c3        loop over A'
c
        do a=1,NvGrp
cmp@@        dima=nv/NvGrp
        dima=DimGrpaR(a)
c
c4        read tmp(m,I,A')
c
cmp!        write (6,'(A,i3,2x,A6)') 'a,L1Name(a) ',a,L1Name(a)
c
cmp@@         if (a.eq.NvGrp) dima=nv-((NvGrp-1)*dima)
c
cmp!         write (6,*) 'dima = ',dima
         lenght=nc*no*dima
cmp!         write (6,*) 'lenght = ',lenght
cmp!         write (6,*) 'file size (ifort) = ',8+8*lenght
c
        call GetX_t3 (tmp,lenght,LunAux,L1Name(a),1,1)
c
c5        grow l1(m,I,A)
c
cmp        last=(a-1)*(nv/NvGrp)
c
          last=0
        if (a.gt.1) then
          do a_tmp=1,a-1
          last=last+DimGrpaR(a_tmp)
          end do
        end if
c
        call grow_l1(l1,tmp,dima,nc,no,nv,last)
c
c6        end loop over A'
c
        end do
c
c7        map tmp(m,A,I) <- l1(m,I,A)
c
        call Map3_132_t3 (l1,tmp,nc,no,nv)
c
c7.1        zero w
c
        call zeroma (w,1,((no*(no+1))/2)*nv*no)
c
c8        mult w(IJ,A,I)  <- l0(IJ,m) . tmp(m,A,I)
c
        call mc0c1a3b (
     & (no*(no+1))/2,nc,
     &  nc,nv*no,
     & (no*(no+1))/2,nv*no,
     & (no*(no+1))/2,nc,nv*no,l0,tmp,w)
c
        return
        end
c
c ----------------------
c
        subroutine grow_l2(A,B,nc,nv,dima,dimb,lasta,lastb)
c
c this routine do :
c
c grow A(A,B,m) from the blocked cholesky vectors
c B(a',b',m)
c
        implicit none
        integer i1,i2,i3,dima,dimb,nc,nv
        integer lasta,lastb
        real*8 A(nv,nv,nc),B(dima,dimb,nc)
c
        do i3=1,nc
        do i1=1,dima
        do i2=1,dimb
        A(lasta+i1,lastb+i2,i3)=B(i1,i2,i3)
        A(lastb+i2,lasta+i1,i3)=B(i1,i2,i3)
        end do
        end do
        end do
c
        return
        end

c
c ----------------------
c
        subroutine expand4_12 (AA,BB,d1,d2,d3)
c
c this routine do :
c
c A(ab,i,j) -> A(a,b,i,j)
c
        implicit none
        integer d1,d2,d3,a,b,i,j,ab
        real*8 AA(1:(d1*(d1+1))/2,d2,d3),BB(1:d1,1:d1,1:d2,1:d3)
c
        ab=0
        do a=1,d1
        do b=1,a
        ab=ab+1
        do i=1,d2
        do j=1,d3
        BB(a,b,i,j)=AA(ab,i,j)
        if (a.ne.b) BB(b,a,j,i)=AA(ab,i,j)
        end do
        end do
        end do
        end do
c
        return
        end
c
c       -----------
c
        subroutine GetRest_t3 (t1,t1_tmp,E2old)
c
c        this file read 1) T1o
c                      2) E1old,E2old,niter
c        from RstFil file
c
        implicit none
#include "cht3_ccsd1.fh"
#include "ccsd_t3compat.fh"
        integer niter
        real*8 E1old,E2old
        real*8 t1(*),t1_tmp(*)
c
c        help variables
        integer length,i
c
*       open (unit=LunAux,File='RstFil',form='unformatted')
        Call MOLCAS_BinaryOpen_Vanilla(LunAux,'RstFil')
        length=nv*no
cmp        write (*,*) 'no, nv, length = ',no,nv,length
        call cht3_rea (LunAux,length,t1)
c
        call transp (t1,t1_tmp,nv,no)
c
        do i=1,length
        t1(i+length)=t1_tmp(i)
        t1(i)=t1_tmp(i)
        end do
c
c
        read (LunAux) E1old,E2old,niter

        if (printkey.gt.1) then
        write (6,'(A,2(f15.12,1x))') 'Results from CCSD : E1, E2 ',
     & E1old,E2old
        end if

        close (LunAux)
c
c
        return
        end
c
c ----------------------
c
        subroutine expand3_23 (A,B,dim1,dim2)
c
c this routine do :
c
c AA(a,bc), b>=c -> BB(a,b,c)
c

        implicit none
        integer a,b,c,bc,dim1,dim2
        real*8 AA(1:dim1,1:(dim2*(dim2+1))/2)
        real*8 BB(1:dim1,1:dim2,1:dim2)
c
        bc=0
        do b=1,dim2
        do c=1,b
        bc=bc+1
        do a=1,dim1
c
        BB(a,b,c)=AA(a,bc)
        BB(a,c,b)=AA(a,bc)
c
        end do
        end do
        end do
c
        return
        end
c
c --------------
c
        subroutine transp (AA,BB, dim1,dim2)
c
c this routine do :
c
c AA(a,b) => BB(b,a)
c
        implicit none
        integer dim1,dim2,i,j
        real*8 AA(1:dim1,1:dim2),BB(1:dim2,1:dim1)
c
        do i=1,dim1
        do j=1,dim2
        BB(j,i)=AA(i,j)
        end do
        end do
c
        return
        end
c
c ----------------------
c
        subroutine gen_vvoo (w,l1,tmp,l2)
c
c this routine do
c
c regenerate (ab,ij) integrals from blocked
c MO cholesky vectors
c
c <vv|oo> = (vo|vo)
c
c --------
c
c       L1(m,I,A')
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "files.fh"
#include "ccsd_t3compat.fh"
c
        real*8 tmp(*),l1(*),w(*),l2(*)
        integer a,b,dima,dimb,lenght,lasta,lastb
        integer a_tmp,b_tmp
c
        do a=1,NvGrp
c
c1        read tmp(m,I,A')
c
        dima=DimGrpaR(a)
         lenght=nc*no*dima
         call GetX_t3 (tmp,lenght,LunAux,L1Name(a),1,1)
c
c5        map l1 (A',I,m) <- tmp (m,I,A')
c
         call Map3_321_t3 (tmp,l1,nc,no,dima)
c
c  ----- read tmp(m,I,B')
c
        do b=1,a
c
        dimb=DimGrpaR(b)
         lenght=nc*no*dimb
         call GetX_t3 (tmp,lenght,LunAux,L1Name(b),1,1)
c
c4        map l2 (m,B',I) <- tmp (m,I,B')
c
        call Map3_132_t3 (tmp,l2,nc,no,dimb)
c
c        zero tmp
c
        call zeroma (tmp,1,dima*no*dimb*no)
c
c7      mult tmp(A',I,B',J) <- l1 (A',I,m) . l2(m,B',J)
c
        call mc0c1a3b (
     & dima*no,nc,nc,dimb*no,
     & dima*no,dimb*no,
     & dima*no,nc,dimb*no,l1,l2,tmp)
c
          lasta=0
        if (a.gt.1) then
          do a_tmp=1,a-1
          lasta=lasta+DimGrpaR(a_tmp)
          end do
        end if
c
          lastb=0
        if (b.gt.1) then
          do b_tmp=1,b-1
          lastb=lastb+DimGrpaR(b_tmp)
          end do
        end if
c
c        write (6,'(A,4(i4,x))') 'BB1 dima, dimb, lasta, lastb ',
c     & dima,dimb,lasta,lastb
        call grow_vvoo(w,tmp,no,nv,dima,dimb,lasta,lastb)
c
        if (a.ne.b) then
c
        call Map4_3412_t3 (tmp,l2,dima,no,dimb,no)
c
c        write (6,'(A,4(i4,x))') 'BB2 dima, dimb, lasta, lastb ',
c     & dimb,dima,lastb,lasta
        call grow_vvoo(w,l2,no,nv,dimb,dima,lastb,lasta)
c
        end if
c
c3        end loop over B'
c
        end do
c
c3        end loop over A'
c
        end do
c
        return
        end
c
c -----------------------
c
        subroutine grow_vvoo(A,B,no,nv,dima,dimb,lasta,lastb)
c
c this routine do :
c
c grow A(1324)/(vvoo) from the blocked cholesky vectors
c B(1234)/(vovo)
c
        implicit none
        integer i1,i2,i3,i4,dima,dimb,no,nv
        integer lasta,lastb
        real*8 A(1:nv,1:nv,1:no,1:no),B(1:dima,1:no,1:dimb,1:no)
c
c!        write (6,'(A,4(i3,x))') 'AA lasta, lastb, dima, dimb ',
c!     & lasta,lastb,dima,dimb
c
        do i4=1,no
        do i3=1,no
        do i1=1,dima
        do i2=1,dimb
        A(lasta+i1,lastb+i2,i3,i4)=B(i1,i3,i2,i4)
        end do
        end do
        end do
        end do
c
        return
        end

c
c ----------------------
c

        subroutine block_interf(
     &   ind1f,ind1l,
     &   ind2f,ind2l,
     &   b1f,b1l,nind_b1f,nind_b1l,
     &   b2f,b2l,nind_b2f,nind_b2l)
c
c this routine do :
c
c Interface between Palo and Juzek virtual orbitals blocking structure
c
c ind1f,ind1l,ind2f,ind2l - first and last absolute of the VO indexes of interess
c
c b1f,b1l   - first and last Palo's block which contain ind1
c b2f,b2l   - first and last Palo's block which contain ind2
c
c nind_b1f  - sum of VOs in blocks 1,2, ..., b1f-1
c nind_b2f  - sum of VOs in blocks 1,2, ..., b2f-1
c
c nind_b1l  - # of VOs in b1f before ind1
c nind_b2l  - # of VOs in b2f before ind2
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "ccsd_t3compat.fh"
c
        integer i,sum
        integer ind1f,ind1l,ind2f,ind2l
        integer b1f,b2f,b1l,b2l
        integer nind_b1f,nind_b2f,nind_b1l,nind_b2l
        logical found1,found2,found3,found4
c
c set b1f, b2f, b1l, b2l
c
          sum=0
          found1=.false.
          found2=.false.
          found3=.false.
          found4=.false.
c
        do i=1,NvGrp
          sum=sum+DimGrpaR(i)
c
          if ((ind1f.le.sum).and.(.not.found1)) then
            b1f=i
            found1=.true.
          end if
c
          if ((ind1l.le.sum).and.(.not.found2)) then
            b1l=i
            found2=.true.
          end if
c
          if ((ind2f.le.sum).and.(.not.found3)) then
            b2f=i
            found3=.true.
          end if
c
          if ((ind2l.le.sum).and.(.not.found4)) then
            b2l=i
            found4=.true.
          end if
c
        end do
c
cmp        write (*,*) 'b1f, b1l, b2f, b2l ',b1f,b1l,b2f,b2l
c
c set nind_b1f, nind_b1l
c
        if (b1f.gt.1) then
            sum=0
          do i=1,b1f-1
            sum=sum+DimGrpaR(i)
          end do
            nind_b1f=sum
        else
            nind_b1f=0
        end if
            nind_b1l=ind1f-nind_b1f-1
c
c set nind_b1f, nind_b1l
c
        if (b2f.gt.1) then
            sum=0
          do i=1,b2f-1
            sum=sum+DimGrpaR(i)
          end do
            nind_b2f=sum
        else
            nind_b2f=0
        end if
            nind_b2l=ind2f-nind_b2f-1
c
        return
        end
c
c       -----------
c
        subroutine gather_t2_blocked(
     & length1,length2,
     & ngaf,ngal,ngbf,ngbl,
     & t2,t2_tmp,tmp,switch)
c
c length1 = length of the 1st VO index (=< vblock)
c length2 = length of the 2nd VO index (=< vblock)
c
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "files.fh"
#include "ccsd_t3compat.fh"
c
        integer ngaf,ngal,ngbf,ngbl
        integer a,b,dima,dimb
cmp        integer lenght
        integer lenght
        integer lasta,lastb
        integer length1,length2
c
        real*8 t2(1:(length1*length2*no*no))
        real*8 tmp(1:(maxdim*maxdim*no*no))
        real*8 t2_tmp(1:(maxdim*maxdim*no*no))
        integer a_tmp,b_tmp
c
        logical sym
        logical switch
c
        sym=.false.
c
cmp        if (ngaf.eq.ngbf) sym=.true.
        if ((ngaf.eq.ngbf).and.(ngal.eq.ngbl)) sym=.true.
c
cmp        write (6,*)
cmp        write (6,*) '------ DimGrpaR ------'
cmp        write (6,'(8(i5,2x))') (DimGrpaR(a_tmp),a_tmp=1,NvGrp)
cmp        write (6,*)
c
        do a=ngaf,ngal
        do b=ngbf,min0(a,ngbl)
c
        dima=DimGrpaR(a)
        dimb=DimGrpaR(b)
c
         if (a.eq.b) then  ! a=b
          lenght=(dima*(dima+1)*no*no)/2
          call GetX_t3 (tmp,lenght,LunAux,T2Name(a,b),1,1)
         else ! a>b
          lenght=dima*dimb*no*no
          call GetX_t3 (tmp,lenght,LunAux,T2Name(a,b),1,1)
         end if
c
          lasta=0
        if (a.gt.ngaf) then
          do a_tmp=ngaf,a-1
          lasta=lasta+DimGrpaR(a_tmp)
          end do
        end if
c
          lastb=0
        if (b.gt.ngbf) then
          do b_tmp=ngbf,b-1
          lastb=lastb+DimGrpaR(b_tmp)
          end do
        end if
c
cmp        write (6,'(A,2(i5,2x),2(i3,x))') 'lasta, lastb, a, b = ',
cmp     & lasta,lastb,a,b
c
        if (a.eq.b) then ! expand and map
        call expand4_12 (tmp,t2_tmp,dima,no,no)
        call grow_t2_blocked(t2,t2_tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,a,b,sym,switch)
        else
        call grow_t2_blocked(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,a,b,sym,switch)
        end if
c
        end do
        end do
c
        return
        end
c
c --------------------
c
        subroutine grow_t2_blocked(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,grpa,grpb,sym,switch)
c
c this routine do :
c
c
        implicit none
        integer a,b,dima,dimb,nv,no,i,j
        integer lasta,lastb
        integer grpa,grpb
        integer length1,length2
cmp        real*8 t2(1:nv,1:nv,1:no,1:no)
        real*8 t2(1:length1,1:length2,1:no,1:no)
        real*8 tmp(1:dima,1:dimb,1:no,1:no)
        logical sym
        logical switch
c
cmp        write (6,*) 'grow_t2neq dima , dimb  ',dima,dimb
cmp        write (6,*) 'grow_t2neq lasta, lastb ',lasta,lastb
cmp        write (6,*) 'grow_t2neq no           ',no
c
cmp        if (lasta.eq.lastb) then
c?        if (grpa.eq.grpb) then
c?        do j=1,no
c?        do i=1,no
c?        do a=1,dima
c?        do b=1,a
c?        t2(lasta+a,lastb+b,i,j)=1.0d0*tmp(a,b,i,j)
c?        if (a.ne.b) t2(lastb+b,lasta+a,j,i)=1.0d0*tmp(a,b,i,j)
c?        end do
c?        end do
c?        end do
c?        end do
c
c?        else
c
        do j=1,no
        do i=1,no
        do b=1,dimb
        do a=1,dima
          if (.not.switch) then
        t2(lasta+a,lastb+b,i,j)=1.0d0*tmp(a,b,i,j)
          else
cmp!        t2(lasta+a,lastb+b,i,j)=1.0d0*tmp(a,b,j,i)
        t2(lasta+a,lastb+b,i,j)=1.0d0*tmp(a,b,i,j)
          end if
cmpn        t2(lastb+b,lasta+a,j,i)=1.0d0*tmp(a,b,i,j)
c
        if (sym) then
        t2(lastb+b,lasta+a,j,i)=1.0d0*tmp(a,b,i,j)
        end if
c
        end do
        end do
        end do
        end do
c
c?        end if
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(nv)
        call Unused_integer(grpa)
        call Unused_integer(grpb)
      end if
        end
c
c ---------------
c
        subroutine gather_t2anti_blocked(
     & length1,length2,
     & ngaf,ngal,ngbf,ngbl,
     & t2,t2_tmp,tmp)
c
c length1 = length of the 1st VO index (nv)
c length2 = length of the 2nd VO index (=< vblock)
c
c This routine generates T2 amplitudes in this form :
c
c T2 = t2(a,b,j<i) - t2(b,a,j<i) finaly : <a,b,(i<j) >  ;  a in nv, b in vblock
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "files.fh"
#include "ccsd_t3compat.fh"
c
        integer ngaf,ngal,ngbf,ngbl
        integer a,b,dima,dimb
        integer lenght
        integer lasta,lastb
        integer length1,length2
c
        real*8 t2(*),tmp(*),t2_tmp(*)
        integer a_tmp,b_tmp
c
        logical switch
        integer aa,bb
c
cmp        write (6,*)
cmp        write (6,*) '------ DimGrpaR ------'
cmp        write (6,'(8(i5,2x))') (DimGrpaR(a_tmp),a_tmp=1,NvGrp)
cmp        write (6,*)
c
        do a=1,NvGrp
        do b=ngbf,ngbl
c
          switch=.false.
        if (a.ge.b) then
          aa=a
          bb=b
        else
          aa=b
          bb=a
          switch=.true.
        end if
c
        dima=DimGrpaR(aa)
        dimb=DimGrpaR(bb)
c
         if (aa.eq.bb) then  ! aa=bb
          lenght=(dima*(dima+1)*no*no)/2
          call GetX_t3 (tmp,lenght,LunAux,T2Name(aa,bb),1,1)
         else ! aa>bb
          lenght=dima*dimb*no*no
          call GetX_t3 (tmp,lenght,LunAux,T2Name(aa,bb),1,1)
         end if
c
          lasta=0
        if (a.gt.1) then
          do a_tmp=1,a-1
          lasta=lasta+DimGrpaR(a_tmp)
          end do
        end if
c
          lastb=0
        if (b.gt.ngbf) then
          do b_tmp=ngbf,b-1
          lastb=lastb+DimGrpaR(b_tmp)
          end do
        end if
c
cmp        write (6,'(A,2(i5,2x),L,2(i3,x))') 'lasta, lastb, switch, a, b = ',
cmp     & lasta,lastb,switch,a,b
c
        if (aa.eq.bb) then ! expand tmp
        call expand4_12 (tmp,t2_tmp,dima,no,no)
        call grow_t2anti_blocked1(t2,t2_tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,a,b)
        else
         if (.not.switch) then
        call grow_t2anti_blocked1(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,a,b)
         else
        call grow_t2anti_blocked2(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,a,b)
        end if
        end if
c
        end do
        end do
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(ngaf)
        call Unused_integer(ngal)
      end if
        end
c
c --------------------
c
        subroutine grow_t2anti_blocked1(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,grpa,grpb)
c
c this routine do :
c
c
        implicit none
        integer a,b,dima,dimb,nv,no,i,j,ij
        integer lasta,lastb
        integer grpa,grpb
        integer length1,length2
cmp        real*8 t2(1:nv,1:nv,1:no,1:no)
        real*8 t2(1:length1,1:length2,1:(((no-1)*no)/2))
        real*8 tmp(1:dima,1:dimb,1:no,1:no)
c
cmp        write (6,*) 'lasta+dima, length1 ',lasta+dima, length1
cmp        write (6,*) 'lastb+dimb, length2 ',lastb+dimb, length2
c
cmp        write (6,'(A,2(i10,x),i3)') 'length1, length2, no ',length1, length2, no
cmp        write (6,'(A,4(i3,x))') 'dima, dimb, lasta, lastb',
cmp     & dima,dimb,lasta,lastb
c
        ij=0
        do i=2,no
        do j=1,i-1
        ij=ij+1
        do b=1,dimb
        do a=1,dima
c
        t2(lasta+a,lastb+b,ij)=tmp(a,b,i,j)+(-1.0d0*tmp(a,b,j,i))
c
        end do
        end do
        end do
        end do
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(nv)
        call Unused_integer(grpa)
        call Unused_integer(grpb)
      end if
        end
c
c ---------------
c
        subroutine grow_t2anti_blocked2(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,grpa,grpb)
c
c this routine do :
c
c
        implicit none
        integer a,b,dima,dimb,nv,no,i,j,ij
        integer lasta,lastb
        integer grpa,grpb
        integer length1,length2
cmp        real*8 t2(1:nv,1:nv,1:no,1:no)
        real*8 t2(1:length1,1:length2,1:(((no-1)*no)/2))
        real*8 tmp(1:dima,1:dimb,1:no,1:no)
c
cmp        write (6,*) 'lasta+dima, length1 ',lasta+dima, length1
cmp        write (6,*) 'lastb+dimb, length2 ',lastb+dimb, length2
cmp        write (6,*) 'lasta, lastb ',lasta,lastb
cmp        write (6,*) 'dima, dimb ',dima,dimb
c
        ij=0
        do i=2,no
        do j=1,i-1
        ij=ij+1
        do b=1,dima
        do a=1,dimb
c
        t2(lasta+a,lastb+b,ij)=tmp(b,a,j,i)+(-1.0d0*tmp(b,a,i,j))
c
        end do
        end do
        end do
        end do
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(nv)
        call Unused_integer(grpa)
        call Unused_integer(grpb)
      end if
        end
c
c ----------------------
c
        subroutine gen_vvoo_blocked (w,l1,tmp,l2,
     & length1,length2,ngaf,ngal,ngbf,ngbl)
c
c this routine do
c
c regenerate (ab,ij) integrals from blocked
c MO cholesky vectors
c
c <vv|oo>
c
c --------
c
c       L1(m,I,A')
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "files.fh"
#include "ccsd_t3compat.fh"
c
        real*8 tmp(*),l1(*),w(*),l2(*)
        integer a,b,dima,dimb,lenght,lasta,lastb
        integer a_tmp,b_tmp
c
        integer ngaf,ngal,ngbf,ngbl
        integer length1,length2
        logical sym
c
        sym=.false.
c
        if ((ngaf.eq.ngbf).and.(ngal.eq.ngbl)) sym=.true.
c
        do a=ngaf,ngal
c
c1        read tmp(m,I,A')
c
        dima=DimGrpaR(a)
        lenght=nc*no*dima
        call GetX_t3 (tmp,lenght,LunAux,L1Name(a),1,1)
c
c5        map l1 (A',I,m) <- tmp (m,I,A')
c
        call Map3_321_t3 (tmp,l1,nc,no,dima)
c
c  ----- read tmp(m,I,B')
c
        do b=ngbf,min0(a,ngbl)
c
        dimb=DimGrpaR(b)
        lenght=nc*no*dimb
        call GetX_t3 (tmp,lenght,LunAux,L1Name(b),1,1)
c
c4        map l2 (m,B',I) <- tmp (m,I,B')
c
        call Map3_132_t3 (tmp,l2,nc,no,dimb)
c
c        zero tmp
c
        call zeroma (tmp,1,dima*no*dimb*no)
c
c7      mult tmp(A',I,B',J) <- l1 (A',I,m) . l2(m,B',J)
c
        call mc0c1a3b (
     & dima*no,nc,nc,dimb*no,
     & dima*no,dimb*no,
     & dima*no,nc,dimb*no,l1,l2,tmp)
c
          lasta=0
        if (a.gt.ngaf) then
          do a_tmp=ngaf,a-1
          lasta=lasta+DimGrpaR(a_tmp)
          end do
        end if
c
          lastb=0
        if (b.gt.ngbf) then
          do b_tmp=ngbf,b-1
          lastb=lastb+DimGrpaR(b_tmp)
          end do
        end if
c
c8        grow w(A',B',I,J) <- tmp(A',I,B',J)
c
cmp        write (6,'(A,6(i4,x))') 'BB1 dima, dimb, lasta, lastb ',
cmp     & dima,dimb,lasta,lastb,a,b
        call grow_vvoo_blocked(w,tmp,no,nv,dima,dimb,lasta,lastb,
     & length1,length2,a,b,sym)
c
c?        if (a.ne.b) then
c?c
c?        call Map4_3412_t3 (tmp,l2,dima,no,dimb,no)
c?c
c?c        write (6,'(A,4(i4,x))') 'BB2 dima, dimb, lasta, lastb ',
c?c     & dimb,dima,lastb,lasta
c?        call grow_vvoo_blocked(w,l2,no,nv,dimb,dima,lastb,lasta,
c?     & length1,length2,a,b)
c?c
c?        end if
c
c3        end loop over B'
c
        end do
c
c3        end loop over A'
c
        end do
c
        return
        end
c
c -----------------------
c
        subroutine grow_vvoo_blocked(AA,BB,no,nv,dima,dimb,lasta,lastb,
     & length1,length2,a,b,sym)
c
c this routine do :
c
c grow A(1324)/(vvoo) from the blocked cholesky vectors
c B(1234)/(vovo)
c
        implicit none
        integer i1,i2,i3,i4,dima,dimb,no,nv
        integer lasta,lastb
        integer length1,length2,a,b
        real*8 AA(1:length1,1:length2,1:no,1:no)
        real*8 BB(1:dima,1:no,1:dimb,1:no)
        logical sym
c
cmp        write (6,'(A,4(i3,x))') 'AA lasta, lastb, dima, dimb ',
cmp     & lasta,lastb,dima,dimb
cmp        write (6,'(A,2(i9,x))') 'chk_a ',lasta+dima,length1
cmp        write (6,'(A,2(i9,x))') 'chk_b ',lastb+dimb,length2
c
        do i4=1,no
        do i3=1,no
        do i1=1,dima
        do i2=1,dimb
        AA(lasta+i1,lastb+i2,i3,i4)=BB(i1,i3,i2,i4)
c
        if (sym) AA(lastb+i2,lasta+i1,i4,i3)=BB(i1,i3,i2,i4)
c
        end do
        end do
        end do
        end do
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(nv)
        call Unused_integer(a)
        call Unused_integer(b)
      end if
        end

c
c ----------------------
c
        subroutine gather_t2_fblocked(
     & length1,length2,
     & ngaf,ngal,ngbf,ngbl,
     & t2,t2_tmp,tmp)
c
c length1 = length of the 1st VO index (nv)
c length2 = length of the 2nd VO index (=< vblock)
c
c This routine generates T2 amplitudes in this form :
c
c T2 = t2(a,b,j<i) - t2(b,a,j<i) finaly : <a,b,(i<j) >  ;  a in nv, b in vblock
c
        implicit none
#include "cht3_ccsd1.fh"
#include "cht3_reord.fh"
#include "files.fh"
#include "ccsd_t3compat.fh"
c
        integer ngaf,ngal,ngbf,ngbl
        integer a,b,dima,dimb
        integer lenght
        integer lasta,lastb
        integer length1,length2
c
        real*8 t2(*),tmp(*),t2_tmp(*)
        integer a_tmp,b_tmp
c
        logical switch
        integer aa,bb
c
cmp        write (6,*)
cmp        write (6,*) '------ DimGrpaR ------'
cmp        write (6,'(8(i5,2x))') (DimGrpaR(a_tmp),a_tmp=1,NvGrp)
cmp        write (6,*)
c
        do a=1,NvGrp
        do b=ngbf,ngbl
c
          switch=.false.
        if (a.ge.b) then
          aa=a
          bb=b
        else
          aa=b
          bb=a
          switch=.true.
        end if
c
        dima=DimGrpaR(aa)
        dimb=DimGrpaR(bb)
c
         if (aa.eq.bb) then  ! aa=bb
          lenght=(dima*(dima+1)*no*no)/2
          call GetX_t3 (tmp,lenght,LunAux,T2Name(aa,bb),1,1)
         else ! aa>bb
          lenght=dima*dimb*no*no
          call GetX_t3 (tmp,lenght,LunAux,T2Name(aa,bb),1,1)
         end if
c
          lasta=0
        if (a.gt.1) then
          do a_tmp=1,a-1
          lasta=lasta+DimGrpaR(a_tmp)
          end do
        end if
c
          lastb=0
        if (b.gt.ngbf) then
          do b_tmp=ngbf,b-1
          lastb=lastb+DimGrpaR(b_tmp)
          end do
        end if
c
cmp        write (6,'(A,2(i5,2x),L,2(i3,x))') 'lasta, lastb, switch, a, b = ',
cmp     & lasta,lastb,switch,a,b
c
        if (aa.eq.bb) then ! expand tmp
        call expand4_12 (tmp,t2_tmp,dima,no,no)
        call grow_t2_fblocked1(t2,t2_tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,a,b)
        else
         if (.not.switch) then
        call grow_t2_fblocked1(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,a,b)
         else
        call grow_t2_fblocked2(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,a,b)
        end if
        end if
c
        end do
        end do
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(ngaf)
        call Unused_integer(ngal)
      end if
        end
c
c --------------------
c
        subroutine grow_t2_fblocked1(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,grpa,grpb)
c
c this routine do :
c
c
        implicit none
        integer a,b,dima,dimb,nv,no,i,j
c       integer ij
        integer lasta,lastb
        integer grpa,grpb
        integer length1,length2
cmp        real*8 t2(1:nv,1:nv,1:no,1:no)
        real*8 t2(1:length1,1:length2,1:no,1:no)
        real*8 tmp(1:dima,1:dimb,1:no,1:no)
c
cmp        write (6,*) 'lasta+dima, length1 ',lasta+dima, length1
cmp        write (6,*) 'lastb+dimb, length2 ',lastb+dimb, length2
c
cmp        write (6,'(A,2(i10,x),i3)') 'length1, length2, no ',length1, length2, no
cmp        write (6,'(A,4(i3,x))') 'dima, dimb, lasta, lastb',
cmp     & dima,dimb,lasta,lastb
c
cmp        ij=0
cmp        do i=2,no
cmp        do j=1,i-1
cmp        ij=ij+1
        do i=1,no
        do j=1,no
        do b=1,dimb
        do a=1,dima
c
cmp        t2(lasta+a,lastb+b,ij)=tmp(a,b,i,j)+(-1.0d0*tmp(a,b,j,i))
        t2(lasta+a,lastb+b,i,j)=tmp(a,b,i,j)
c
        end do
        end do
        end do
        end do
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(nv)
        call Unused_integer(grpa)
        call Unused_integer(grpb)
      end if
        end
c
c ---------------
c
c
        subroutine grow_t2_fblocked2(t2,tmp,dima,dimb,nv,no,
     & lasta,lastb,length1,length2,grpa,grpb)
c
c this routine do :
c
c
        implicit none
        integer a,b,dima,dimb,nv,no,i,j
c       integer ij
        integer lasta,lastb
        integer grpa,grpb
        integer length1,length2
cmp     real*8 t2(1:nv,1:nv,1:no,1:no)
        real*8 t2(1:length1,1:length2,1:no,1:no)
        real*8 tmp(1:dima,1:dimb,1:no,1:no)
c
cmp     write (6,*) 'lasta+dima, length1 ',lasta+dima, length1
cmp     write (6,*) 'lastb+dimb, length2 ',lastb+dimb, length2
cmp     write (6,*) 'lasta, lastb ',lasta,lastb
cmp     write (6,*) 'dima, dimb ',dima,dimb
c
cmp        ij=0
cmp        do i=2,no
cmp        do j=1,i-1
cmp        ij=ij+1
        do i=1,no
        do j=1,no
        do b=1,dima
        do a=1,dimb
c
cmp        t2(lasta+a,lastb+b,ij)=tmp(b,a,j,i)+(-1.0d0*tmp(b,a,i,j))
        t2(lasta+a,lastb+b,i,j)=tmp(b,a,j,i)
c
        end do
        end do
        end do
        end do
c
        return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_integer(nv)
        call Unused_integer(grpa)
        call Unused_integer(grpb)
      end if
        end
c
c ---------------
c
        subroutine check_create_klvab_t3_mem (vblock)
c
c this routine finds the upper estimate of the memory
c requirements of the most demanding step in create_klvab_t3
c
        implicit none
c
#include "cht3_ccsd1.fh"
#include "ccsd_t3compat.fh"
        integer vblock,vblock_my
        integer mem,mem_trial,mem_avail
c
c.0 - calculate vblock_my
c
        call my_block (vblock,vblock_my)
c
        if (printkey.ge.10) then
        write (6,*)
        write (6,*) 'check_create_klvab_t3_mem '
        write (6,*)
        write (6,'(A,3(i5,1x))') 'nc,no,nv',nc,no,nv
        write (6,'(A,3(i5,1x))') 'maxdim,vblock,vblock_my',
     & maxdim,vblock,vblock_my
        end if
c
c.1 !create
        mem=vblock*vblock*(no+nv)+
     & nv*((nv*(nv+1))/2)+nv*nv+nc*maxdim+nc*maxdim*maxdim+
     & max(nc*maxdim*maxdim,nc*no*maxdim,maxdim*maxdim*maxdim)
c.2 !klvaa_vvvo
        mem_trial=vblock*vblock*(no+nv)+
     & (nv*(nv*(nv+1))/2)+nv*nv+vblock_my*vblock_my*no*no+
     & 2*maxdim*maxdim*no*no
c
        if (mem_trial.gt.mem) mem=mem_trial
c.3 !create
        mem_trial=vblock*vblock*(no+nv)+
     & (nv*(nv*(nv+1))/2)+nv*nv+vblock_my*vblock_my*no*no+
     & 2*maxdim*maxdim*no*no
c
        if (mem_trial.gt.mem) mem=mem_trial
c.4 !create
        mem_trial=no*no*vblock*(no+nv)+
     & no*nv*(no*(no+1)/2)+vblock*no*no+nc*(no*(no+1)/2)+
     & nc*no*nv+max(nc*((no*(no+1))/2),nc*no*maxdim,nc*no*nv)
c
        if (mem_trial.gt.mem) mem=mem_trial
c.5 !create
        mem_trial=no*no*vblock*(no+nv)+
     & no*nv*(no*(no+1)/2)+vblock*no*no+nv*vblock_my*no*no+
     & 2*maxdim*maxdim*no*no
c
        if (mem_trial.gt.mem) mem=mem_trial
c.6 !klvaa_oovo
        mem_trial=no*no*vblock*(no+nv)+
     & no*nv*(no*(no+1)/2)+vblock*no*no+
     & nv*vblock_my*(((no-1)*no)/2)+2*maxdim*maxdim*no*no
c
        if (mem_trial.gt.mem) mem=mem_trial
c.7 !klvaa_oovo
        mem_trial=(((no-1)*no)/2)*vblock*vblock+
     & vblock_my*vblock_my*no*no+nc*no*maxdim+
     & 2*max(nc*no*maxdim,maxdim*maxdim*no*no)
c
        if (mem_trial.gt.mem) mem=mem_trial
c.8 !klvaa_oovo
        mem_trial=no*no*vblock*vblock+
     & vblock_my*vblock_my*no*no+nc*no*maxdim+
     & 2*max(nc*no*maxdim,maxdim*maxdim*no*no)
c
        if (mem_trial.gt.mem) mem=mem_trial
c
           if (printkey.ge.10) then
              write (6,*)
              write (6,'(A,f10.1,A,f7.1,A,f3.1,A)')
     &       'Memory required for the reorg. step = ',
     &        (8.0d0*mem)/(1024),' kb ',
     &        (8.0d0*mem)/(1024*1024),' Mb ',
     &        (8.0d0*mem)/(1024*1024*1024),' Gb '
           end if
c
c - calculate available free memory
c
        Call GetMem('(T)','Max','Real',mem_avail,mem_avail)
c
           if (printkey.ge.10) then
              write (6,'(A,f10.1,A,f7.1,A,f3.1,A)')
     &       'Available memory                    = ',
     &        (8.0d0*mem_avail)/(1024),' kb ',
     &        (8.0d0*mem_avail)/(1024*1024),' Mb ',
     &        (8.0d0*mem_avail)/(1024*1024*1024),' Gb '
              write (6,*)
           end if
c
c - check, if mem fits
c
        if (mem_avail.lt.mem) then
          write (6,*) 'Not enough memory for the transformation step '
          call Abend()
        end if
c
        return
        end
c
c ----------------
c
        subroutine my_block (vblock,vblock_my)
c
c this subroutine calculates maximum overlap between juzek's
c vblock segmentation and palo's dimgrp
c
        implicit none
c
#include "cht3_ccsd1.fh"
#include "ccsd_t3compat.fh"
#include "cht3_reord.fh"
c
        integer i,j,i_tmp,i_f,i_l,poss
        integer vblock,vblock_my,vblock_my_tmp
        logical found
c
        vblock_my=0
        i_l=0
        i_f=0
c
        do i=1,nv,vblock
c
c - find initial possition of the i-th juzek's block
c
          poss=0
          found=.false.
        do j=1,NvGrp
          poss=poss+DimGrpaR(j)
          if ((i.le.poss).and.(.not.found)) then
            i_f=j
            found=.true.
cmp        write (6,'(A,3(i5,x))') 'i,i_f,poss     = ',
cmp     & i,i_f,poss
          end if
        end do
c
        if ((i+vblock-1).le.nv) then
          i_tmp=i+vblock-1
        else
          i_tmp=nv
        end if
cmp        write (6,'(A,2(i5,x))') 'i,i_tmp        = ',
cmp     & i,i_tmp
c
c - find terminal possition of the i-th juzek's block
c
          poss=0
          found=.false.
        do j=1,NvGrp
          poss=poss+DimGrpaR(j)
          if ((i_tmp.le.poss).and.(.not.found)) then
            i_l=j
            found=.true.
cmp        write (6,'(A,3(i5,x))') 'i_tmp,i_l,poss = ',
cmp     & i_tmp,i_l,poss
          end if
        end do
c
        vblock_my_tmp=0
        do j=i_f,i_l
        vblock_my_tmp=vblock_my_tmp+DimGrpaR(j)
        end do
c
        if (vblock_my_tmp.gt.vblock_my)
     & vblock_my=vblock_my_tmp
c
cmp        write (6,'(A,2(i5,x))') 'vblock_my_tmp, vblock_my',
cmp     & vblock_my_tmp, vblock_my
cmp        write (6,*)
        end do
c
        return
        end
c
c ----------------
c
        subroutine check_loops(nv,vblock,nla,nlb)
c
        integer nv,vblock,nla,nlb
        integer nuga,nga,ngb,ngc

        nuga=nv/vblock
cmp! pridavok
        if((nuga*vblock).lt.nv)nuga=nuga+1
c
        nla=0
        do nga=1,nuga
        do ngb=1,nga
        do ngc=1,ngb
        nla=nla+1
        end do
        end do
        end do
c
        nlb=0
        do nga=1,nuga
        do ngb=1,nga
        do ngc=1,nuga
        nlb=nlb+1
        end do
        end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine NAMem( &
#                define _CALLING_
#                include "mem_interface.fh"
                )

use Basis_Info, only: mGaussian_Type, Nuclear_Model
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: iAngV(4), labcd, MemNA2, nFlop, nMem

!                                                                      *
!***********************************************************************
!                                                                      *
call mHrr(la,lb,nFlop,nMem)

iAngV(1) = la
iAngV(2) = lb
iAngV(3) = lr
iAngV(4) = 0
call MemRys(iAngV,Mem)
nHer = (la+lb+lr+2)/2
if (Nuclear_Model == mGaussian_Type) then

  labcd = (la+1)*(la+2)/2*(lb+1)*(lb+2)/2

  iAngV(3) = lr+2
  call MemRys(iAngV,MemNA2)
  Mem = max(Mem,MemNA2)
  nHer = (la+lb+lr+4)/2
  Mem = Mem+labcd
end if

Mem = max(nMem,Mem)

return

end subroutine NAMem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine OptRMS_Slapaf(x,y,nAt,RMS,RMSMax)
      Use Symmetry_Info, only: VarR, VarT
      Implicit Real*8 (a-h,o-z)
#include "print.fh"
#include "real.fh"
      Real*8 x(3,nAt), y(3,nAt)
*
*---- Only align if energy is rotational and translational invariant.
*     (no weighting)
*
      If (.not.(VarR.or.VarT)) Then
         Call Superpose(x,y,nAt,RMS,RMSMax)
      Else
*
*---- Otherwise, just compute RMS
*
         RMS = Zero
         RMSMax = Zero
         Do i = 1, nAt
            disp = Zero
            Do ixyz = 1, 3
               diff = x(ixyz,i)-y(ixyz,i)
               RMS = RMS + diff**2
               disp = disp + diff**2
            End Do
            If (Sqrt(disp).gt.RMSMax) RMSMax=Sqrt(disp)
         End Do
         RMS = Sqrt( RMS/DBLE(nAt) )
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine vbgenabdet2_cvb(
     >  idetavb,idetbvb,
     >  iconfs,nconf,nconfion,
     >  ndetvb,nel,noe,
     >  nalf,nbet,norb,
     >  xalf,xbet,mingrph,maxgrph,
     >  inewocc,iaccm)
      implicit real*8 (a-h,o-w,y-z),integer(x)
#include "WrkSpc.fh"
      dimension idetavb(ndetvb),idetbvb(ndetvb)
      dimension iconfs(noe,nconf),nconfion(0:nel)
      integer xalf,xbet
      dimension xalf(0:norb,0:nalf),xbet(0:norb,0:nbet)
      dimension mingrph(0:norb),maxgrph(0:norb)
      dimension inewocc(norb),iaccm(norb)
      logical debug
      data debug/.false./

c Set xalf and xbet for indget :
      do 100 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nalf,0)
      maxgrph(iorb)=min(iorb,nalf)
100   continue
      call weight_cvb(xalf,mingrph,maxgrph,nalf,norb)
      do 200 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nbet,0)
      maxgrph(iorb)=min(iorb,nbet)
200   continue
      call weight_cvb(xbet,mingrph,maxgrph,nbet,norb)

c  Transformation matrix VB structures  <->  determinants
      incrdet=0
      ioff_nconf=0
      do 1000 ion=0,nel/2
      nelsing=nel-2*ion
      nalfsing=nalf-ion
      nbetsing=nbet-ion
c  Skip if configurations are incompatible with Ms :
      if(nalfsing.lt.0.or.nbetsing.lt.0.or.nelsing.lt.0)goto 1001

c  Generate alpha/beta strings for singly occupied electrons :
      call icomb_cvb(nelsing,nalfsing,nstring)
      iastr = mstacki_cvb(nalfsing*nstring)
      ibstr = mstacki_cvb(nbetsing*nstring)
      call stringen_cvb(nelsing,nalfsing,iwork(iastr),iwork(ibstr),
     >                  nstring)
      if(debug)then
        write(6,*)' ionicity=',ion,' nconf=',nconfion(ion)
        write(6,*)' check alpha strings :'
        do i=1,nstring
        write(6,*)i,' => ',(iwork(ii+iastr-1+(i-1)*nalfsing),ii=1,
     >                      nalfsing)
        enddo
        write(6,*)' check beta strings :'
        do i=1,nstring
        write(6,*)i,' => ',(iwork(ii+ibstr-1+(i-1)*nbetsing),ii=1,
     >                      nbetsing)
        enddo
      endif

      do 1100 iconf=ioff_nconf+1,ioff_nconf+nconfion(ion)
      call imove_cvb(iconfs(1,iconf),inewocc,norb)
      incr=0
      do 1200 iorb=1,norb
      if(inewocc(iorb).eq.1)then
        incr=incr+1
        iaccm(incr)=iorb
      endif
      inewocc(iorb)=max(0,inewocc(iorb)-1)
1200  continue

c  Spin string loop :
      do 1300 index=1,nstring

c  Alpha index in full string space ...
      do 1400 i=1,nalfsing
      iaocc=iaccm(iwork(i+(index-1)*nalfsing+iastr-1))
      inewocc(iaocc)=inewocc(iaocc)+1
1400  continue
      iaind=indget_cvb(inewocc,nalf,norb,xalf)
      do 1500 i=1,nalfsing
      iaocc=iaccm(iwork(i+(index-1)*nalfsing+iastr-1))
      inewocc(iaocc)=inewocc(iaocc)-1
1500  continue

c  Beta index in full string space ...
      do 1600 i=1,nbetsing
      ibocc=iaccm(iwork(i+(index-1)*nbetsing+ibstr-1))
      inewocc(ibocc)=inewocc(ibocc)+1
1600  continue
      ibind=indget_cvb(inewocc,nbet,norb,xbet)
      do 1700 i=1,nbetsing
      ibocc=iaccm(iwork(i+(index-1)*nbetsing+ibstr-1))
      inewocc(ibocc)=inewocc(ibocc)-1
1700  continue

      incrdet=incrdet+1
      idetavb(incrdet)=iaind
      idetbvb(incrdet)=ibind
1300  continue
1100  continue
      call mfreei_cvb(iastr)
1001  ioff_nconf=ioff_nconf+nconfion(ion)
1000  continue
      if(debug)then
        write(6,*)' idetavb='
        write(6,'(10i6)')idetavb
        write(6,*)' idetbvb='
        write(6,'(10i6)')idetbvb
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This procedure classify the atomic orbitals of atoms into 6 classes  *
* and return the count. Which shells that are returned are specified   *
* by the the option switch opt:                                        *
*                                                                      *
*  1 DeepCore                                                          *
*  2 Core                                                              *
*  4 SoftCore                                                          *
*  8 DeepValence                                                       *
* 16 Valence                                                           *
* 32 ExtraValence                                                      *
*                                                                      *
* The numbers are added up to get more than one shell reported.        *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: May 2003                                                    *
*                                                                      *
************************************************************************
      Subroutine OrbType(Z,List,opt)
      Implicit None
*----------------------------------------------------------------------*
* Dummy arguments                                                      *
*----------------------------------------------------------------------*
      Integer Z,List,opt
      Dimension List(4)
*----------------------------------------------------------------------*
* Type declare local variables                                         *
*----------------------------------------------------------------------*
      Integer DeepCore,Core,SoftCore
      Integer DeepValence,Valence,ExtraValence
      Integer i
*----------------------------------------------------------------------*
* Dimension local variables                                            *
*----------------------------------------------------------------------*
      Dimension DeepCore(4)
      Dimension Core(4)
      Dimension SoftCore(4)
      Dimension DeepValence(4)
      Dimension Valence(4)
      Dimension ExtraValence(4)
*----------------------------------------------------------------------*
* Is this a legal element?                                             *
*----------------------------------------------------------------------*
CNIKO If(Z.lt.1 .or. Z.gt.112) Then
CNIKO
      If(Z.lt.0 .or. Z.gt.112) Then
CNIKO
         Write(6,*) 'orbtype: do only know elements 1-112'
         Call Abend()
      End If
*----------------------------------------------------------------------*
* Initialize                                                           *
*----------------------------------------------------------------------*
      Do i=1,4
         DeepCore(i)=0
         Core(i)=0
         SoftCore(i)=0
         DeepValence(i)=0
         Valence(i)=0
         ExtraValence(i)=0
         List(i)=0
      End Do
*----------------------------------------------------------------------*
* How many shells are there for this atom                              *
*----------------------------------------------------------------------*
*
* Dummy
      If (Z.eq.0) Then
         Valence(1)=0 ! this is a redundant operation.
* H-He
      Else If(Z.le.2) Then
         Valence(1)=1
* Li-Be
      Else If(Z.le.4) Then
         Core(1)=1
         Valence(1)=1
         ExtraValence(2)=1
* B-Ne
      Else If(Z.le.10) Then
         Core(1)=1
         Valence(1)=1
         Valence(2)=1
* Na-Mg
      Else If(Z.le.12) Then
         DeepCore(1)=1
         SoftCore(1)=1
         SoftCore(2)=1
         Valence(1)=1
         ExtraValence(2)=1
* Al-Ar
      Else If(Z.le.18) Then
         DeepCore(1)=1
         Core(1)=1
         Core(2)=1
         Valence(1)=1
         Valence(2)=1
* K-Ca
      Else If(Z.le.20) Then
         DeepCore(1)=2
         DeepCore(2)=1
         SoftCore(1)=1
         SoftCore(2)=1
         Valence(1)=1
         ExtraValence(2)=1
* Sc-Zn
      Else If(Z.le.30) Then
         DeepCore(1)=2
         DeepCore(2)=1
         Core(1)=1
         Core(2)=1
         Valence(1)=1
         Valence(3)=1
         ExtraValence(2)=1
* Ga-Kr
      Else If(Z.le.36) Then
         DeepCore(1)=2
         DeepCore(2)=1
         Core(1)=1
         Core(2)=1
         Core(3)=1
         Valence(1)=1
         Valence(2)=1
* Rb-Sr
      Else If(Z.le.38) Then
         DeepCore(1)=3
         DeepCore(2)=2
         DeepCore(3)=1
         SoftCore(1)=1
         SoftCore(2)=1
         Valence(1)=1
         ExtraValence(2)=1
* Y-Cd
      Else If(Z.le.48) Then
         DeepCore(1)=3
         DeepCore(2)=2
         DeepCore(3)=1
         Core(1)=1
         Core(2)=1
         Valence(1)=1
         Valence(3)=1
         ExtraValence(2)=1
* In-Xe
      Else If(Z.le.54) Then
         DeepCore(1)=3
         DeepCore(2)=2
         DeepCore(3)=1
         Core(1)=1
         Core(2)=1
         Core(3)=1
         Valence(1)=1
         Valence(2)=1
* Cs-Ba
      Else If(Z.le.56) Then
         DeepCore(1)=4
         DeepCore(2)=3
         DeepCore(3)=2
         SoftCore(1)=1
         SoftCore(2)=1
         Valence(1)=1
         ExtraValence(1)=1
* La-Yb
      Else If(Z.le.70) Then
         DeepCore(1)=4
         DeepCore(2)=3
         DeepCore(3)=2
         Core(1)=1
         Core(2)=1
         Valence(1)=1
         Valence(4)=1
         ExtraValence(2)=1
* Lu-Hg
      Else If(Z.le.80) Then
         DeepCore(1)=4
         DeepCore(2)=3
         DeepCore(3)=2
         Core(1)=1
         Core(2)=1
         SoftCore(4)=1
         Valence(1)=1
         Valence(3)=1
         ExtraValence(2)=1
* Tl-Rn
      Else If(Z.le.86) Then
         DeepCore(1)=4
         DeepCore(2)=3
         DeepCore(3)=2
         Core(1)=1
         Core(2)=1
         Core(4)=1
         SoftCore(3)=1
         Valence(1)=1
         Valence(2)=1
* Fr-Ra
      Else If(Z.le.88) Then
         DeepCore(1)=5
         DeepCore(2)=4
         DeepCore(3)=3
         DeepCore(4)=1
         SoftCore(1)=1
         SoftCore(2)=1
         Valence(1)=1
         ExtraValence(2)=1
* Ac-No
      Else If(Z.le.102) Then
         DeepCore(1)=5
         DeepCore(2)=4
         DeepCore(3)=3
         DeepCore(4)=1
         Core(1)=1
         Core(2)=1
         Valence(1)=1
         Valence(4)=1
         ExtraValence(2)=1
* Lr-Cn
      Else If(Z.le.112) Then
         DeepCore(1)=5
         DeepCore(2)=4
         DeepCore(3)=3
         DeepCore(4)=1
         Core(1)=1
         Core(2)=1
         SoftCore(4)=1
         Valence(1)=1
         Valence(3)=1
         ExtraValence(2)=1
      Else
         Write(6,*) 'orbtype: element',Z,' not yet implemented'
         Call Abend()
      End If
*----------------------------------------------------------------------*
* Fill up the list to be returned                                      *
*----------------------------------------------------------------------*
      if(iAnd(opt,1).ne.0) Then
         Do i=1,4
            List(i)=List(i)+DeepCore(i)
         End Do
      End If
      if(iAnd(opt,2).ne.0) Then
         Do i=1,4
            List(i)=List(i)+Core(i)
         End Do
      End If
      if(iAnd(opt,4).ne.0) Then
         Do i=1,4
            List(i)=List(i)+SoftCore(i)
         End Do
      End If
      if(iAnd(opt,8).ne.0) Then
         Do i=1,4
            List(i)=List(i)+DeepValence(i)
         End Do
      End If
      if(iAnd(opt,16).ne.0) Then
         Do i=1,4
            List(i)=List(i)+Valence(i)
         End Do
      End If
      if(iAnd(opt,32).ne.0) Then
         Do i=1,4
            List(i)=List(i)+ExtraValence(i)
         End Do
      End If
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine span0_cvb(nvecmx1,n)
      implicit real*8 (a-h,o-z)
#include "span_comcvb.fh"
      save nmult
      data nmult/5/

      nvecmx=min(nmult*nvecmx1,mavailr_cvb()/n)
      if(nvecmx.le.0)then
        write(6,*)' Not enough vectors in SPAN0_CVB!',nvecmx
        write(6,*)' Remaining memory :',mavailr_cvb()
        write(6,*)' Max number of vectors :',nvecmx1
        call abend_cvb()
      endif
      iaddr = mstackr_cvb(n*nvecmx)
      nvtot=0
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Yoshio Nishimoto                                 *
************************************************************************
      Subroutine GrdIni()

      use caspt2_global, only: LuPT2,LuGAMMA,LuCMOPT2,LuAPT2,
     &                         do_nac,do_lindep,LUGRAD,LUSTD,iStpGrd,
     &                         idBoriMat,TraFro,
     &                         CLag,CLagFull,OLag,OLagFull,SLag,WLag,
     &                         nCLag,nOLag,nWLag,
     &                         DPT2_tot,DPT2C_tot,DPT2_AO_tot,
     &                         DPT2C_AO_tot,DPT2Canti_tot,
     &                         FIMO_all,FIFA_all,FIFASA_all,idSDMat,
     &                         OMGDER,iTasks_grad
      use stdalloc, only: mma_allocate,mma_deallocate
      use Constants, only: Zero
      use definitions, only: wp, iwp
      use caspt2_module, only: IfChol, IFXMS, IFRMS, IFDW, MAXIT, NSYM,
     &                         NCONF, NFROT, NISH, NASH, NASHT, NBAS,
     &                         NBTRI, NBSQT, NSTATE, ZETA, NASUP

      implicit none

      character(len=128) :: FileName
      character(len=4096) :: RealName

      real(kind=wp),allocatable :: WRK(:)

      Logical(kind=iwp) :: is_error, Exists
      integer(kind=iwp) :: LENGTH, iost, iCase, iSym, idSD, idSD_,
     &                     idSDer, nAS, NS, MaxLen, lRealName
      integer(kind=iwp), external :: isFreeUnit

      iStpGrd = 1

      ! Define (initial) logical unit numbers for gradients files
      LUPT2    = 17 ! MCLR
      LUGAMMA  = 65 ! ERI derivatives ALASKA or 3-center RI/CD
      LUCMOPT2 = 66 ! Back-transform ALASKA
      LUSTD    = 67 ! S and T derivatives in CASPT2
      LUAPT2   = 68 ! A_PT2, 2-center derivatives for RI/CD
      LUGRAD   = 69 ! CASPT2 gradient and property

      Call PrgmTranslate('GAMMA',RealName,lRealName)
      LuGAMMA  = isFreeUnit(LuGAMMA)
      If (IfChol) Then
        LENGTH = nBas(1)
      Else
        LENGTH = nIsh(1) + nAsh(1)
      End If
      Call MOLCAS_Open_Ext2(LuGamma,RealName(1:lRealName),
     &                     'DIRECT','UNFORMATTED',
     &                      iost,.TRUE.,
     &                      LENGTH**2*8,'REPLACE',is_error)
      Close (LuGAMMA)

      If (.not.IfChol) Then
        Call PrgmTranslate('CMOPT2',RealName,lRealName)
        LuCMOPT2 = isFreeUnit(LuCMOPT2)
        Call MOLCAS_Open_Ext2(LuCMOPT2,RealName(1:lRealName),'DIRECT',
     &                       'UNFORMATTED',iost,.FALSE.,1,'REPLACE',
     &                        is_error)
        Close (LuCMOPT2)
      End If

      CALL DANAME_MF_wa(LUSTD,'LUSTD')
      If (IfChol) CALL DANAME_MF_wa(LUAPT2,'LUAPT2')

      !! Check if this is not the first (MS-)CASPT2 call
      !! If this is the first call, compute CASPT2 energies;
      !! otherwise read many things from the PT2GRD file.
      !! PT2GRD file is always deleted when a RASSCF is finished
      !! This is written in Driver/rasscf.prgm.src, but I'm not sure
      !! this is the right way to manipulate files...
      FileName = 'PT2GRD'
      Call f_inquire(FileName,Exists)
      If (Exists) iStpGrd = 0
      ! Not sure none/mf/mf_wa
      CALL DANAME_MF_wa(LUGRAD,'LUPT2GRD')

      !! Allocate lagrangian terms
      ! CLag and SLag should allocate for nRoots and not nState,
      ! but for the time being we only support the case nState=nRoots
      nCLag = nconf*nState
      nOLag = NBSQT
      nWLag = NBTRI

      call mma_allocate(DPT2_tot    ,NBSQT,Label='DPT2_tot')
      call mma_allocate(DPT2C_tot   ,NBSQT,Label='DPT2C_tot')
      call mma_allocate(DPT2_AO_tot ,NBSQT,Label='DPT2_AO_tot')
      call mma_allocate(DPT2C_AO_tot,NBSQT,Label='DPT2C_AO_tot')
      DPT2_tot(:)     = Zero
      DPT2C_tot(:)    = Zero
      DPT2_AO_tot(:)  = Zero
      DPT2C_AO_tot(:) = Zero

      !! Some Lagrangians for each state are constructed in CLag or
      !! OLag. The full (sum over all states, in particular for
      !! MS-CASPT2) configuration and orbital Lagrangians are then
      !! constructed in OLagFull. For SS-CASPT2, CLag and
      !! CLagFull, for instance, will be identical.
      call mma_allocate(CLag    ,nconf,nState,Label='CLAG')
      call mma_allocate(CLagFull,nconf,nState,Label='CLAGFULL')
      call mma_allocate(OLag    ,nOLag,Label='OLAG')
      call mma_allocate(OLagFull,nOLag,Label='OLAGFULL')
      call mma_allocate(SLag    ,nState,nState,Label='SLAG')
      call mma_allocate(WLag    ,nWLag,Label='WLAG')
      CLag(:,:)     = Zero
      CLagFull(:,:) = Zero
      OLag(:)       = Zero
      OLagFull(:)   = Zero
      SLag(:,:)     = Zero
      WLag(:)       = Zero
!     write(6,*) 'nclag,nolag'
!     write(6,*)  nclag, nolag

      call mma_allocate(FIMO_all,NBSQT,Label='FIMO_all')
      call mma_allocate(FIFA_all,NBSQT,Label='FIFA_all')
      FIMO_all(:) = Zero
      FIFA_all(:) = Zero

      !! FIFASA is constructed with state-averaged density always
      !! FIFA   can be state-specific or dynamically weighted
      !! FIMO   is uniquely determined, but the basis can be
      !!        either natural or quasi-canonical
      If (IFXMS .or. IFRMS) Then
        call mma_allocate(FIFASA_all,NBSQT,Label='FIFASA_all')
        FIFASA_all(:) = Zero
        ! norbi=norb(1)
      End If

      If (IFDW .and. zeta >= Zero) Then
        call mma_allocate(OMGDER,nState,nState,Label='OMGDER')
        OMGDER(:,:) = Zero
      End If

      If (do_nac) Then
        call mma_allocate(DPT2Canti_tot,NBSQT,Label='DPT2Canti_tot')
        DPT2Canti_tot(:) = Zero
      End If

      MaxLen = 0
      Do iCase = 1, 11
        Do iSym = 1, nSym
          nAS = nASUP(iSym,iCase)
          MaxLen = Max(MaxLen,nAS*nAS)
        End Do
      End Do

      call mma_allocate(WRK,MaxLen,Label='WRK')
      WRK(:) = Zero

      idSD = 1
!     write (*,*) 'iflindep = ', iflindeplag
      If (do_lindep) Then
        Do iCase = 1, 11
          DO iSym = 1, nSym
            idBoriMat(iSym,iCase) = idSD
            NAS=NASUP(ISYM,ICASE)
            NS=(NAS*(NAS+1))/2
            CALL DDAFILE(LuSTD,0,WRK,NS,idSD)
            idSD_ = idBoriMat(iSym,iCase)
            CALL DDAFILE(LuSTD,1,WRK,NS,idSD_)
          End Do
        End Do
      End If

      If (MAXIT /= 0) Then
        Do iCase = 1, 11
          Do iSym = 1, nSym
            idSDMat(iSym,iCase) = idSD
            nAS = nASUP(iSym,iCase)
            CALL DDAFILE(LuSTD,0,WRK,nAS*nAS,idSD)
            idSDer = idSDMat(iSym,iCase)
            ! idSDMat(iSym,iCase))
            CALL DDAFILE(LuSTD,1,WRK,nAS*nAS,idSDer)
          End Do
        End Do
      End If
      call mma_deallocate(WRK)

      if (nFroT /= 0) call mma_allocate(TraFro,nFroT**2,Label='TraFro')
      call mma_allocate(iTasks_grad,nAshT**2,Label='Tasks_grad')
      iTasks_grad(:) = 0

      Return

      End Subroutine GrdIni
!
!-----------------------------------------------------------------------
!
      Subroutine GrdCls(IRETURN,UEFF,U0,H0)

      use caspt2_global, only: iPrGlb
      use caspt2_global, only: LuPT2,LuAPT2,
     &                           do_nac,do_csf,iRoot1,iRoot2,LUGRAD,
     &                           LUSTD,TraFro,
     &                           CLag,CLagFull,OLag,OLagFull,SLag,WLag,
     &                           nOLag,nWLag,
     &                           DPT2_tot,DPT2C_tot,DPT2_AO_tot,
     &                           DPT2C_AO_tot,DPT2Canti_tot,
     &                           FIMO_all,FIFA_all,FIFASA_all,OMGDER,
     &                           iTasks_grad
      use PrintLevel, only: VERBOSE
      use stdalloc, only: mma_allocate,mma_deallocate
      use Constants, only: Zero, One, Half, Two
      use definitions, only: wp, iwp, u6
      use caspt2_module, only: REFENE, RFPERT, IfChol, IFMSCOUP, IFXMS,
     &                         IFRMS, IFDW, NCONF, nState, nFroT, NBAST,
     &                         NBTRI, NBSQT, iRlxRoot, DWTYPE, Zeta
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par, King
#endif

      implicit none

      integer(kind=iwp), intent(in) :: IRETURN
      real(kind=wp), intent(in) :: H0(nState,nState)
      real(kind=wp), intent(inout) :: UEFF(nState,nState),
     &                                U0(nState,nState)

      Character(Len=16) :: mstate1
      logical(kind=iwp) :: DEB,Found
      logical(kind=iwp), external :: RF_On

      real(kind=wp), allocatable :: HEFF1(:,:),WRK1(:,:),WRK2(:,:),
     &                             CI1(:,:)
      integer(kind=iwp) :: i, iGo, ilStat, j, jlStat
      integer(kind=iwp), external :: isFreeUnit
      real(kind=wp) :: Scal
      real(kind=wp) :: CPUT, WALLT, CPE, CPTF0, CPTF10, TIOE, TIOTF0,
     &                 TIOTF10

      !! In case convergence of CASPT2 equation failed
      !! Call this subroutine just deallocate memory
      If (IRETURN == 0) then

        call mma_allocate(HEFF1,nState,nState,Label='HEFF1')
        call mma_allocate(WRK1,nState,nState,Label='WRK1')
        call mma_allocate(WRK2,nState,nState,Label='WRK2')

        !! Add XMS specific terms
        !! Note that CLagFull is in natural CSF basis,
        !! so everything in this subroutine has to be done in natural
        SLag(:,:) = Zero
        WRK2(:,:) = Zero
        If (IFDW .and. zeta >= Zero) Then
          !! Construct Heff[1] in XMS basis
          HEFF1(:,:) = Zero
          Do ilStat = 1, nState
           HEFF1(ilStat,ilStat) = REFENE(ilStat)
          End Do
          Call DGEMM_('T','N',nState,nState,nState,
     &                One,U0,nState,HEFF1,nState,
     &                Zero,WRK1,nState)
          Call DGEMM_('N','N',nState,nState,nState,
     &                One,WRK1,nState,U0,nState,
     &                Zero,HEFF1,nState)

          !! Derivative of Heff[1] in XMS basis
          !! It is transformed with U0, so the contribution has to be
          !! considered when we construct the auxiliary density in the
          !! XMS-specific term
          call DWDER(OMGDER,HEFF1,SLag)
          Call DGEMM_('N','N',nState,nState,nState,
     &                One,U0,nState,SLag,nState,
     &                Zero,WRK2,nState)
          Call DGEMM_('N','T',nState,nState,nState,
     &                One,WRK2,nState,U0,nState,
     &                Zero,WRK1,nState)

          WRK2(:,:) = Zero
          Do ilStat = 1, nState
            If (DWTYPE == 1) Then
              WRK2(ilStat,ilStat) = SLag(ilStat,ilStat)
            Else If (DWTYPE == 2 .OR. DWTYPE == 3) Then
              Do jlStat = 1, nState
                WRK2(ilStat,jlStat) = SLag(ilStat,jlStat)
              End Do
            End If
            If (.not.do_nac) Then
              Do jlStat = 1, ilStat-1
                WRK1(ilStat,jlStat) =
     &            WRK1(ilStat,jlStat)+WRK1(jlStat,ilStat)
                WRK1(jlStat,ilStat) = Zero
              End Do
            End If
          End Do
          SLag(:,:) = WRK1(:,:)
        End If

        IF (IFXMS .or. IFRMS .or.
     &     (IFMSCOUP .and. do_nac .and. do_csf)) Then
          If (.not.IFXMS .and. .not.IFRMS) Then
            !! For MS-CASPT2, only the second term in eq.(68)
            U0(:,:) = Zero
            Call DCopy_(nState,[One],0,U0,nState+1)
          End If

          CALL TIMING(CPTF0,CPE,TIOTF0,TIOE)
          CALL XMS_Grad(H0,U0,UEFF,WRK2)
          CALL TIMING(CPTF10,CPE,TIOTF10,TIOE)
          CPUT =CPTF10-CPTF0
          WALLT=TIOTF10-TIOTF0
          If (IPRGLB >= VERBOSE) Then
           write(u6,'(a,2f10.2)')' XMS_Grad: CPU/WALL TIME=', cput,wallt
          End If
        End If

        !! Now, compute the state Lagrangian and do some projections
        !! If PCM, we have to obtain internal state rotation parameters
        !! self-consistently, so we should not call this subroutine
        If (.not.RF_On()) Call CLagFinal(CLagFull,SLag)

        !! Add MS-CASPT2 contributions
        If (IFMSCOUP) Then
          Do ilStat = 1, nState
            Do jlStat = 1, ilStat
              If (do_nac) Then
                If (.not.IFXMS .and. .not.IFRMS .and. ilstat /= jlstat)
     &            Cycle

                Scal = UEFF(ilStat,iRoot1)*UEFF(jlStat,iRoot2)
     &               + UEFF(jlStat,iRoot1)*UEFF(ilStat,iRoot2)
                Scal = Scal*Half
                SLag(ilStat,jlStat) = SLag(ilStat,jlStat) + Scal

                If (ilStat /= jlStat) Then
                  SLag(jlStat,ilStat) = SLag(jlStat,ilStat) + Scal
                End If
              Else
                IF (IFXMS .or. IFRMS) Then
                  Scal = UEFF(ilStat,iRoot1)*UEFF(jlStat,iRoot2)
                  If (ilStat /= jlStat) Scal = Scal*Two
                  SLag(ilStat,jlStat) = SLag(ilStat,jlStat) + Scal
                Else
                  If (ilStat == jlStat) Then
                    Scal = UEFF(ilStat,iRoot1)*UEFF(jlStat,iRoot2)
                    SLag(ilStat,jlStat) = SLag(ilStat,jlStat) + Scal
                  End If
                End If
              End If
            End Do
          End Do
        End If

        !! Subtract the original rhs_sa.f or rhs_nac.f contribution
        !! For MS-type CASPT2, CASSCF part has to be determined by UEFF
        If (IFMSCOUP .and. iRoot1 == iRoot2) Then
          ilStat = MAX(iRoot1,iRoot2)
          jlStat = MIN(iRoot1,iRoot2)
          SLag(ilStat,jlStat) = SLag(ilStat,jlStat) - One
        End If

        !! Finalize the first-order transition(-like) density matrix
        !! for the CSF derivative term
        If (do_nac) Then
          If (do_csf) Then
            Call CnstAntiC(DPT2Canti_tot,UEFF,U0)
          Else
            !! Clear just in case
            DPT2Canti_tot(:) = Zero
          End If
        End If

        !! Back-transform the CI Lagrangian
        !! It is in the XMS basis, so it has to be transformed to
        !! CASSCF basis to be used in Z-vector
        !! No need to do this for SLag.
        If (IFXMS .or. IFRMS) Then
          call mma_allocate(CI1,nConf,nState,Label='CI1')
          Call DGEMM_('N','T',nConf,nState,nState,
     &                One,CLagFull,nConf,U0,nState,
     &                Zero,CI1,nConf)
          CLagFull(:,:) = CI1(:,:)
          call mma_deallocate(CI1)
        End If

        !! Compute true unrelaxed properties for MS-CASPT2
        if (.not.do_nac .and. ifmscoup) CALL PRPCTL(1,UEFF,U0)

        LuPT2 = isFreeUnit(LuPT2)
        Call Molcas_Open(LuPT2,'PT2_Lag')

        DEB = .false.
        !! configuration Lagrangian (read in RHS_PT2)
        If (DEB) call RecPrt('CLagFull','',CLagFull,nConf,nState)
        Do j = 1, nState
          Do i = 1, nConf
            Write (LuPT2,*) CLagFull(i,j)
          End Do
        End do

        !! orbital Lagrangian (read in RHS_PT2)
#ifdef _MOLCAS_MPP_
        if (is_real_par()) then
          If (.not.King()) OLagFull(:) = Zero
          CALL GADSUM (OLagFull,nOLag)
        end if
#endif
        If (DEB) call RecPrt('OLagFull','',OLagFull,nBasT,nBasT)
        Do i = 1, nOLag
          Write (LuPT2,*) OLagFull(i)
        End Do

        !! state Lagrangian (read in RHS_PT2)
        If (DEB) call RecPrt('SLag', '', SLag, nState, nState)
        Do j = 1, nState
          Do i = 1, nState
            Write (LuPT2,*) SLag(i,j)
          End Do
        End Do

        !! renormalization contributions (read in OUT_PT2)
#ifdef _MOLCAS_MPP_
        if (is_real_par()) then
          If (.not.King()) WLag(:) = Zero
          CALL GADSUM (WLag,nWLag)
        end if
#endif
        If (DEB) call TriPrt('WLag', '', WLag, nBast)
        Do i = 1, nWLag ! = NBTRI
          Write (LuPT2,*) WLag(i)
        End Do

        !! D^PT2 in MO (read in OUT_PT2)
#ifdef _MOLCAS_MPP_
        if (is_real_par()) then
          If (.not.King()) DPT2_tot(:) = Zero
          CALL GADSUM (DPT2_tot,NBSQT)
        end if
#endif
        If (DEB) call RecPrt('DPT2', '', DPT2_tot, nBast, nBast)
        Do i = 1, NBSQT
          Write (LuPT2,*) DPT2_tot(i)
        End Do

        !! D^PT2(C) in MO (read in OUT_PT2)
#ifdef _MOLCAS_MPP_
        if (is_real_par()) then
          If (.not.King()) DPT2C_tot(:) = Zero
          CALL GADSUM (DPT2C_tot,NBSQT)
        end if
#endif
        If (DEB) call RecPrt('DPT2C', '', DPT2C_tot, nBast, nBast)
        Do i = 1, NBSQT
          Write (LuPT2,*) DPT2C_tot(i)
        End Do

        !! NAC
        If (do_nac) Then
          Do i = 1, NBSQT
            Write (LuPT2,*) DPT2Canti_tot(i)
          End Do
        End If

        !! D^PT2 in AO (not used?)
        if (RFpert .and. IFMSCOUP) then
          !! Recompute DPT2AO and DPT2AO for PCM
          Call Recompute_DPT2AO(DPT2_tot,DPT2C_tot,
     &                          DPT2_AO_tot,DPT2C_AO_tot)
        end if
        If (DEB) call TriPrt('DPT2_AO_tot', '', DPT2_AO_tot, nBast)
        Do i = 1, NBSQT
          Write (LuPT2,*) DPT2_AO_tot(i)
        End Do

        !! D^PT2(C) in AO (not used?)
        If (DEB) call TriPrt('DPT2C_AO', '', DPT2C_AO_tot, nBast)
        Do i = 1, NBSQT
          Write (LuPT2,*) DPT2C_AO_tot(i)
        End Do

        if (RFpert) then
          !! For CASPT2/PCM gradient
          !! The implicit derivative contributions have not been
          !! considered in the CASPT2 module
          if (ifmscoup) then
            ! I do not remember why this should be halved
            call daxpy_(NBTRI,Half,DPT2C_AO_tot,1,DPT2_AO_tot,1)
          else
            call daxpy_(NBTRI,One,DPT2C_AO_tot,1,DPT2_AO_tot,1)
          end if
          Call Put_dArray('D1aoVar',DPT2_AO_tot,NBTRI)
        else
          !! not sure this is OK
          Call Put_dArray('D1aoVar',DPT2_AO_tot,0)
        end if

        ! close gradient files
        Close (LuPT2)

        call mma_deallocate(HEFF1)
        call mma_deallocate(WRK1)
        call mma_deallocate(WRK2)
      end if

      call mma_deallocate(DPT2_tot)
      call mma_deallocate(DPT2C_tot)
      call mma_deallocate(DPT2_AO_tot)
      call mma_deallocate(DPT2C_AO_tot)

      call mma_deallocate(CLag)
      call mma_deallocate(CLagFull)
      call mma_deallocate(OLag)
      call mma_deallocate(OLagFull)
      call mma_deallocate(SLag)
      call mma_deallocate(WLag)

      call mma_deallocate(FIMO_all)
      call mma_deallocate(FIFA_all)

      If (IFXMS .or. IFRMS)        call mma_deallocate(FIFASA_all)
      If (IFDW .and. zeta >= Zero) call mma_deallocate(OMGDER)
      If (do_nac)                  call mma_deallocate(DPT2Canti_tot)

      !! Prepare for MCLR
      iGo = 3
      Call Put_iScalar('SA ready',iGo)
      ! overwrites whatever was set in CASSCF with the relax
      ! root that was chosen in CASPT2
      if (do_nac) then
!       write (*,*) 'NAC'
!       write (*,*) 'CASSCF/Original = ', iRoot1,iRoot2
        Call Put_iScalar('Relax CASSCF root',iRoot1)
        Call Put_iScalar('Relax Original root',iRoot2)
        call Qpg_cArray('MCLR Root',Found,I)
        if (Found) then
          Call Get_cArray('MCLR Root',mstate1,16)
          if (mstate1(8:8) == '0' .and. mstate1(16:16) == '0') then
            !! NAC states have not been specified
            write (mstate1,'(1X,I7,1X,I7)') iRoot1,iRoot2
            Call Put_cArray('MCLR Root',mstate1,16)
          end if
        else
          mstate1 = '****************'
          Call Put_cArray('MCLR Root',mstate1,16)
        end if
      else
!       write (*,*) 'GRD'
!       write (*,*) 'CASSCF/Original = ', irlxroot,irlxroot
        Call Put_iScalar('Relax CASSCF root',irlxroot)
        Call Put_iScalar('Relax Original root',irlxroot)
        mstate1 = '****************'
        Call Put_cArray('MCLR Root',mstate1,16)
      end if

      !! Close files
      Call DaClos(LUSTD)
      If (IfChol) Call DaClos(LUAPT2)
      Call DaClos(LUGRAD)

      if (nFroT /= 0) call mma_deallocate(TraFro)
      call mma_deallocate(iTasks_grad)

      Return

      End Subroutine GrdCls
!
!-----------------------------------------------------------------------
!
      Subroutine ModDip()

      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: LROOTS, NROOTS, ROOT2STATE

      implicit none

      real(kind=wp), allocatable :: DMs1(:,:), DMs2(:,:)
      integer(kind=iwp) :: i, j

      call mma_allocate(DMs1,3,nRoots,Label='DMs1')
      call mma_allocate(DMs2,3,lRoots,Label='DMs2')
      Call Get_dArray('Last Dipole Moments',DMs2,3*LROOTS)
      Do i = 1, lRoots
        j = Root2State(i)
        If (j == 0) Cycle
        DMs1(:,j) = DMs2(:,i)
      End Do
      Call Put_dArray('Last Dipole Moments',DMs1,3*nROOTS)
      call mma_deallocate(DMs1)
      call mma_deallocate(DMs2)

      Return

      End Subroutine ModDip
!
!-----------------------------------------------------------------------
!
      Subroutine GradPrep(UEFF,VECROT)

      use caspt2_global, only: iRoot1, iRoot2, jStLag
      use caspt2_module, only: IFMSCOUP, NSTATE, JSTATE
      use Constants, only: One, Half
      use definitions, only: wp, iwp

      implicit none

      real(kind=wp), intent(in) :: UEFF(nState,nState)
      real(kind=wp), intent(inout) :: VECROT(nState)

      real(kind=wp) :: TMP
      integer(kind=iwp) :: iState

!     If i  = j, UIi*dHij/dx*UJj
!     If i \= j, (UIi*UJj+UJi*UIj)*dHij/dx*0.5

      !! Construct the rotation vector
      If (IFMSCOUP) Then
        Do iState = 1, nState
          TMP = UEFF(iState,iRoot1)*UEFF(jState,iRoot2)
     &        + UEFF(iState,iRoot2)*UEFF(jState,iRoot1)
          VECROT(iState) = TMP*Half
        End Do
      Else
!       write(6,*) 'jState in gradprep: ',jstate
        VECROT(jState) = One
      End If
      jStLag = jState

      End Subroutine GradPrep
!
!-----------------------------------------------------------------------
!
      Subroutine OLagFinal(OLagLoc,Trf)

      use caspt2_global, only: CMOPT2
      use caspt2_global, only: OLagFull,WLag,nOLag
      use stdalloc, only: mma_allocate,mma_deallocate
      use Constants, only: Zero, One, Half
      use definitions, only: wp, iwp
      use caspt2_module, only: IFMSCOUP, NSYM, NBAS, NBAST, NBTRI,
     &                         NBSQT, JSTATE, iRlxRoot

      implicit none

      real(kind=wp), intent(inout) :: OLagLoc(1:nOLag)
      real(kind=wp), intent(in) :: Trf(1:NBSQT)

      real(kind=wp), allocatable :: WRK(:), WLagLoc(:)
      integer(kind=iwp) :: iBasTr, iBasSq, iSym, nBasI, liBasTr,
     &                     liBasSq, iBasI, jBasI, liBasSq2

      call mma_allocate(WRK,NBSQT,Label='WRK')
      call mma_allocate(WLagLoc,NBSQT,Label='WLagLoc')

      WLagLoc(1:NBSQT) = Half*OLagLoc(1:NBSQT)
!     write(6,*) 'Wlag square'
!     call sqprt(wlag,nbast)

      !! W(MO) -> W(AO) using the quasi-canonical orbitals
      !! No need to back transform to natural orbital basis
      Call DGemm_('N','N',nBasT,nBasT,nBasT,
     &            One,CMOPT2,nBasT,WLagLoc,nBasT,
     &            Zero,WRK,nBasT)
      Call DGemm_('N','T',nBasT,nBasT,nBasT,
     &            One,WRK,nBasT,CMOPT2,nBasT,
     &            Zero,WLagLoc,nBasT)

      !! square -> triangle for WLag(AO)
      WRK(:) = WLagLoc(:)
      iBasTr = 1
      iBasSq = 1
      Do iSym = 1, nSym
        nBasI = nBas(iSym)
        liBasTr = iBasTr
        liBasSq = iBasSq
        Do iBasI = 1, nBasI
          Do jBasI = 1, iBasI
            liBasSq = iBasSq + iBasI-1 + nBasI*(jBasI-1)
            If (iBasI == jBasI) Then
              WLagLoc(liBasTr) = WRK(liBasSq)
            Else
            liBasSq2 = iBasSq + jBasI-1 + nBasI*(iBasI-1)
            WLagLoc(liBasTr) = WRK(liBasSq)+WRK(liBasSq2)
            End If
            liBasTr = liBasTr + 1
          End Do
        End Do
        iBasTr = iBasTr + nBasI*(nBasI+1)/2
        iBasSq = iBasSq + nBasI*nBasI
      End Do
      ! accumulate W Lagrangian only for MS,XMS,XDW,RMS,
      ! but not for SS-CASPT2
      if (jState == iRlxRoot .or. IFMSCOUP) then
        WLag(1:NBTRI) = WLag(1:NBTRI) + WLagLoc(1:NBTRI)
      end if
      call mma_deallocate(WLagLoc)



      !! Transform quasi-canonical -> natural MO basis
      !! orbital Lagrangian
      Call DGemm_('N','N',nBasT,nBasT,nBasT,
     &            One,Trf,nBasT,OLagLoc,nBasT,
     &            Zero,WRK,nBasT)
      Call DGemm_('N','T',nBasT,nBasT,nBasT,
     &            One,WRK,nBasT,Trf,nBasT,
     &            Zero,OLagLoc,nBasT)
      !! sufficient only for active
      nBasI = nBas(1)
      WRK(1:nBasI**2) = OLagLoc(1:nBasI**2)
      Call DGeSub(WRK,nBas(1),'N',
     &            WRK,nBas(1),'T',
     &            OLagLoc,nBas(1),
     &            nBas(1),nBas(1))
      ! accumulate orbital Lagrangian only for MS,XMS,XDW,RMS,
      ! but not for SS-CASPT2
      if (jState == iRlxRoot .or. IFMSCOUP)
     &  OLagFull(1:nOLag) = OLagFull(1:nOLag) + OLagLoc(1:nOLag)

      call mma_deallocate(WRK)

      End Subroutine OLagFinal
!
!-----------------------------------------------------------------------
!
      Subroutine CnstFIFAFIMO(MODE)

      use caspt2_global, only: TraFro, OLag,
     &                           FIMO_all, FIFA_all, FIFASA_all
      use caspt2_global, only: FIMO, FIFA, CMOPT2
      use stdalloc, only: mma_allocate,mma_deallocate
      use definitions, only: wp, iwp
      use Constants, only: Zero
      use caspt2_module, only: IfChol, IFXMS, IFRMS, IFDW, NSYM, NFRO,
     &                         NFROT, NBAS, NBSQT

      implicit none

      integer(kind=iwp), intent(in) :: MODE

      real(kind=wp),allocatable :: WRK1(:), WRK2(:)
      integer(kind=iwp) :: iSQ, iTr, iSym, nBasI

      If (IfChol) Then
        !! For DF or CD, we already have FIFA and FIMO in AO,
        !! so just do AO -> MO transformation
        call mma_allocate(WRK1,NBSQT,Label='WRK1')
        call mma_allocate(WRK2,NBSQT,Label='WRK2')
        WRK1(:) = Zero
        WRK2(:) = Zero

        iSQ = 0
        iTR = 0
        Do iSym = 1, nSym
          ! nOrbI = nOrb(iSym)
          nBasI = nBas(iSym)
          !! FIFA
          If (nFroT == 0) Then
            If (MODE == 0 .and. (IFDW .or. IFRMS)) Then
              Call SQUARE(FIFA(1+iTr),FIFASA_all(1+iSQ),1,nBasI,nBasI)
            Else If (MODE == 1) Then
              Call SQUARE(FIFA(1+iTr),FIFA_all(1+iSQ),1,nBasI,nBasI)
!             write (*,*) 'fifa in MO'
!             call sqprt(fifa_all(1+isq),nbasi)
            End If
          Else
            Call SQUARE(FIFA_all(1+iTr),WRK1,1,nBasI,nBasI)
!             write (*,*) 'fifasa in AO'
!             call sqprt(wrk1,nbasi)
            If (MODE == 0 .and. (IFDW .or. IFRMS)) Then
              !! with the state-average
              !! FIFASA_all will be natural basis
              Call OLagTrf(2,iSym,CMOPT2,FIFASA_all(1+iSQ),WRK1,WRK2)
!             write (*,*) 'fifasa in MO'
!             call sqprt(fifasa_all(1+isq),nbasi)
            Else If (MODE == 1) Then
              !! with the state-specific or dynamically weighted
              !! FIFA will be quasi-canonical basis
              Call OLagTrf(2,iSym,CMOPT2,FIFA_all(1+iSQ),WRK1,WRK2)
!             write (*,*) 'fifa in MO'
!             call sqprt(fifa_all(1+isq),nbasi)
              !! canonicalize frozen orbitals
              !! still under investigation, but this is something we
              !! should do to obtain "better" orbital enegies for
              !! methods using state-dependent Fock operators.
              !! We actually need to canonicalize frozen and inactive
              !! orbitals simultaneously?
              If (nFroT /= 0) Then
                WRK2(1:nBasI*nBasI) = WRK1(1:nBasI*nBasI)
                CALL DIAFCK(NBAS(ISYM),FIFA_all,1,NFRO(ISYM),
     &                      TraFro,NBAS(ISYM),CMOPT2,WRK2)
                CMOPT2(1:NBAS(ISYM)*NFRO(ISYM))
     &            = WRK2(1:NBAS(ISYM)*NFRO(ISYM))
                Call OLagTrf(2,iSym,CMOPT2,FIFA_all(1+iSQ),WRK1,WRK2)
              End If
            End If
          End If

          !! FIMO
!         If (MODE == 0) Then
            If (nFroT == 0) Then
              Call SQUARE(FIMO(1+iTr),FIMO_all(1+iSQ),1,nBasI,nBasI)
            Else
              Call SQUARE(FIMO_all(1+iTr),WRK1,1,nBasI,nBasI)
              Call OLagTrf(2,iSym,CMOPT2,FIMO_all(1+iSQ),WRK1,OLag)
!             write (*,*) 'fimo in MO'
!             call sqprt(fimo_all(1+isq),nbasi)
            End If
!         End If
          iSQ = iSQ + nBasI*nBasI
          iTR = iTR + nBasI*(nBasI+1)/2
        End Do
        call mma_deallocate(WRK1)
        call mma_deallocate(WRK2)

        If (IFXMS .and. .not.IFDW)
     &    FIFASA_all(1:NBSQT) = FIFA_all(1:NBSQT)
      Else
        If (nFroT /= 0) Then
        Else
          iSQ = 0
          iTR = 0
          Do iSym = 1, nSym
            ! nOrbI = nOrb(iSym)
            nBasI = nBas(iSym)
            Call SQUARE(FIFA(1+iTr),FIFA_all(1+iSQ),1,nBasI,nBasI)
            Call SQUARE(FIMO(1+iTr),FIMO_all(1+iSQ),1,nBasI,nBasI)
            iSQ = iSQ + nBasI*nBasI
            iTR = iTR + nBasI*(nBasI+1)/2
          End Do
          If (IFXMS .and. .not.IFDW)
     &      FIFASA_all(1:NBSQT) = FIFA_all(1:NBSQT)
        End If

      !! XDW or RMS case: call after XDWINI
      ! If (MODE == 0) Then
      ! End If

      !! XMS case: call after GRPINI
      ! If (MODE == 1) Then
      ! End If

!     !! SS or MS case: call in dens.f
!     If (MODE == 2) Then
!       If (IFSADREF) Then
!       Else
!       End If
!     End If
      End If

      Return

      End Subroutine CnstFIFAFIMO
!
!-----------------------------------------------------------------------
!
      Subroutine Recompute_DPT2AO(DPT2,DPT2C,DPT2AO,DPT2CAO)

      use definitions, only: wp, iwp
      use stdalloc, only: mma_allocate,mma_deallocate
      use caspt2_global, only: LUONEM
      use caspt2_module, only: NSYM, NBAS, NBSQT, IAD1M
      use Constants, only: Zero

      implicit none

      real(kind=wp), intent(inout) :: DPT2(NBSQT), DPT2C(NBSQT),
     &  DPT2AO(NBSQT), DPT2CAO(NBSQT)

      real(kind=wp), allocatable :: WRK1(:), WRK2(:), WRK3(:), WRK4(:)

      real(kind=wp) :: val
      integer(kind=iwp) :: IDISK, iBasTr, iBasSq, iSym, nBasI, liBasTr,
     &                     liBasSq, ljBasSq, iBasI, jBasI

      call mma_allocate(WRK1,NBSQT,Label='WRK1')
      call mma_allocate(WRK2,NBSQT,Label='WRK2')
      call mma_allocate(WRK3,NBSQT,Label='WRK3')
      call mma_allocate(WRK4,NBSQT,Label='WRK4')
      IDISK=IAD1M(1)
      CALL DDAFILE(LUONEM,2,WRK1,NBSQT,IDISK)

      DPT2AO(1:NBSQT) = Zero
      DPT2CAO(1:NBSQT) = Zero

      iBasTr = 1
      iBasSq = 1
      Do iSym = 1, nSym
        call OLagTrf(1,iSym,WRK1,DPT2 ,WRK3,WRK2)
        call OLagTrf(1,iSym,WRK1,DPT2C,WRK4,WRK2)
        nBasI = nBas(iSym)
        liBasTr = iBasTr
        liBasSq = iBasSq
        ljBasSq = iBasSq
        Do iBasI = 1, nBasI
          Do jBasI = 1, iBasI
            liBasSq = iBasSq + iBasI-1 + nBasI*(jBasI-1)
            ljBasSq = iBasSq + jBasI-1 + nBasI*(iBasI-1)
            If (iBasI == jBasI) Then
              DPT2AO (liBasTr) = WRK3(liBasSq)
              DPT2CAO(liBasTr) = WRK4(liBasSq)
            Else
              val = WRK3(liBasSq)+WRK3(ljBasSq)
              DPT2AO (liBasTr) = val
              val = WRK4(liBasSq)+WRK4(ljBasSq)
              DPT2CAO(liBasTr) = val
            End If
            liBasTr = liBasTr + 1
          End Do
        End Do
        iBasTr = iBasTr + nBasI*(nBasI+1)/2
      End Do

      call mma_deallocate(WRK1)
      call mma_deallocate(WRK2)
      call mma_deallocate(WRK3)
      call mma_deallocate(WRK4)

      End Subroutine Recompute_DPT2AO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#include "compiler_features.h"
#ifdef _IN_MODULE_
      Subroutine DeDe_SCF(Dens,TwoHam,nDens,mDens)
      use k2_arrays
      use Basis_Info, only: nBas
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "stdalloc.fh"
#include "setup.fh"
      Integer nDens, mDens
      Real*8, Target:: Dens(nDens), TwoHam(nDens)
      Logical Special_NoSym, DFT_Storage
*
      nr_of_Densities=1  ! Hardwired option
*
      nIndij=S%nShlls*(S%nShlls+1)/2
      nField=2+nr_of_Densities
      Call mma_allocate(ipOffD,nField,nIndij,label='ipOffD')
*
*     The array with desymmetrized densities contain two additional
*     fields.
*     ipD00 is a null matrix, which should simplify the logic.
*     ipDijS is an auxiliary memory if not the whole set of a
*      desymmetrized density could be used.
*
      nDeDe_tot = nDeDe + MaxDe*nIrrep + MxDij
      Call mma_allocate(DeDe,nDeDe_tot,Label='DeDe')
      ipDeDe = 1
      ipD00 = ipDeDe + nDeDe
      ipDijS= ipD00  + MaxDe*nIrrep
      DeDe(:)=Zero
*
      Special_NoSym=.True.
      DFT_Storage=.False.
      Call mk_DeDe(Dens,nDens,nr_of_Densities,ipOffD,nIndij,ipDeDe,
     &             ipD00,MaxDe,mDeDe,mIndij,Special_NoSym,DFT_Storage,
     &             DeDe,nDeDe)
*                                                                      *
************************************************************************
*                                                                      *
*     In case of no symmetry do a temporary square copy of the
*     density matrix.
*
*---- Change the folded density to pure triangular form,
*     i.e. off-diagonal elements are divided by two.
*
      If (nIrrep.eq.1) Then
         Call DScal_(nDens,Half,Dens,1)
         ij=0
         Do i = 1, nBas(0)
            ij = ij + i
            Dens(ij)=Two*Dens(ij)
         End Do
         mDens=nbas(0)*nbas(0)
         Call mma_allocate(Dq,mDens,Label='Dq')
         Call Square(Dens,Dq,1,nbas(0),nbas(0))
         pDq => Dq(:)
*
         Call mma_allocate(Fq,mDens,Label='Fq')
         Fq(:)=Zero
         pFq => Fq(:)
      Else
         mDens=nDens
         pDq => Dens(:)
         pFq => Twoham(:)
      End If

      End Subroutine DeDe_SCF

#elif !defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
      dummy_empty_procedure(DeDe_SCF)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_SubScr_Final()
!
! Purpose: finalize (de-allocate memory) screening in vector
!          subtraction.

use Cholesky, only: DSPNm, DSubScr
use stdalloc, only: mma_deallocate

implicit none

call mma_deallocate(DSPNm,safe='*')

call mma_deallocate(DSubScr,safe='*')

end subroutine Cho_SubScr_Final

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Mickael G. Delcey                                      *
************************************************************************
      SUBROUTINE CHO_Prec_MCLR(ipCMO,nIsh,nAsh,LuAChoVec,LuChoInt)
************************************************************************
*                                                                      *
*  Author : M. G. Delcey                                               *
*                                                                      *
*  Purpose: form 2-electron integrals needed for the preconditioner    *
*           those are (ii|pq) and (ip|iq) with i inactive              *
*           and p, q active+virtual                                    *
*           as well as (tu|pq) and (tp|uq) with t, u active            *
*           and p, q all molecular orbitals                            *
*                                                                      *
*           For small active spaces, this is much less than            *
*           the full list of integrals!                                *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "warnings.fh"
      Character*13 SECNAM
      Parameter (SECNAM = 'CHO_PREC_MCLR')
      Integer   ISTLT(8),ISTSQ(8),ISSQ(8,8),ipLpq(8)
      Integer   LuAChoVec(8),ipCMOt(8),LuChoInt(2)
      Integer  nAsh(8),nIsh(8),nIshb(8),nIshe(8),iSkip(8),
     &        nAshb(8),nAshe(8)
      Real*8    tread(2),ttran(2),tform(2) ,tform2(2) ,
     &                            tforma(2),tforma2(2),tMO(2)
      Logical timings
#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
      Character*50 CFmt
      parameter ( N2 = InfVec_N2 )
      parameter (zero = 0.0D0, one = 1.0D0, xone=-1.0D0)
      Character*6 mode
      Logical DoRead,taskleft
      parameter (DoRead = .false. )
      Integer   Cho_LK_MaxVecPerBatch
      External  Cho_LK_MaxVecPerBatch
************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
************************************************************************
      timings=.false.
      CALL CWTIME(TCstart1,TWstart1)
      do i=1,2            ! 1 --> CPU   2 --> Wall
         tread(i) = zero  !time read vectors
         ttran(i) = zero  !time transform vectors
         tform(i) = zero  !time form integrals
         tform2(i) = zero  !time form integrals
         tforma(i) = zero  !time form integrals
         tforma2(i) = zero  !time form integrals
         tMO(i)     = zero  !time for final MO transform
      end do
      MaxVecPerBatch=Cho_LK_MaxVecPerBatch()
      iLoc = 3
*
      ISTLT(1)=0
      ISTSQ(1)=0
      DO ISYM=2,NSYM
        NBB=NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NBB
        ISTSQ(iSYM)=ISTSQ(iSYM-1)+NBAS(ISYM-1)**2
      END DO
*
**    Start with big loop over symmetries
*
      Do jsym=1,nsym
        iAdr=0
*
**      Compute some sizes
*
        nip=0
        ntp=0
        npq=0
        maxpq=0
        maxtpq=0
        ntoti=0
        ntota=0
        Do isymb=1,nsym
          iSyma=MulD2h(iSymb,jsym)

          npq  = npq + nBas(iSymb)**2
          maxpq  =max(npq,nBas(iSymb)**2)
          maxtpq  =max(maxtpq,nAsh(iSyma)*nBas(iSymb)**2)

!         For inactive half-transformed Cho vector + Lii^J
          nip  =nip + nIsh(iSyma)*(nBas(isymb)+1)
!         For active half-transformed Cho vector + Lij^J
          ntp  =ntp + nAsh(iSyma)*(nBas(isymb)+nAsh(iSyma))

          ntoti=ntoti+nIsh(isymb)
          ntota=ntota+nAsh(isymb)
        End Do
*
        NumCV=NumCho(jSym)
        Call GAIGOP_SCAL(NumCV,'max')
        If (NumCV .lt. 1) GOTO 999
*
*
        maxRS=0
        JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
        JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec
        Call GAIGOP_SCAL(JRED1,'min')
        Call GAIGOP_SCAL(JRED2,'max')
        Do Jred=JRED1,JRED2
          maxRS = max(maxRS,nDimRS(JSYM,JRED))
        End Do
*
**      Check for maxmem to see if integrals would fit in memory
**      or if batching is required
*
        Call GetMem('MaxM','Max','Real',KDUM,LWORK)
        Call GAIGOP_SCAL(LWORK,'min')
*
        Do i=1,nsym
          nIshb(i)=0
          nAshb(i)=0
        EndDo
*
**      Loop over i and t batches
**      each batch will increase the i/o, therefore we preferably want to
**      have the whole iiab and tupq in-core!
*
*
**      First, do we have enough memory at all!
*
        memneeded=maxRS+max(nip,ntp)                  ! for 1 Jbatch
        memneeded=max(memneeded,maxpq)                ! for MO transform
        If (ntota.gt.0) Then
           memneeded=memneeded+ maxtpq                ! for 1 (ta|ub)
!          for 1 (tu|ab) and 1 reduced set
           If (jsym.eq.1)
     &        memneeded=memneeded+ ntota*(maxpq+maxRS)
        ElseIf (ntoti.gt.0) Then
           memneeded=memneeded+ maxpq                 ! for 1 (ia|ib)
!          for 1 (ii|ab) and 1 reduced set
           If (jsym.eq.1) memneeded=memneeded+npq+maxRS
        EndIf
*
        If (memneeded.gt.lWork) Then
          WRITE(6,*) SECNAM//': Insufficient memory for I/T batch'
          WRITE(6,*) 'LWORK= ',LWORK
          WRITE(6,*) 'min. mem. need= ',memneeded
          WRITE(6,*) 'maxRS+nip/ntp= ',maxRS+max(nip,ntp)
          WRITE(6,*) 'maxpq        = ',maxpq
          If (ntota.gt.0) Then
            WRITE(6,*) 'maxtpq       = ',maxtpq
            If (jsym.eq.1)
     &       WRITE(6,*) 'ntota*(maxpq,maxRS) = ',ntota*maxpq,ntota*maxRS
          Else
            If (jsym.eq.1)
     &        WRITE(6,*) 'npq,maxRS = ',npq,maxRS
          EndIf
          CALL Quit(_RC_MEMORY_ERROR_)
        EndIf
        lWork=lWork-max(maxpq,maxRS+max(nip,ntp))
*
**      How many nab + nrs can be stored in memory while stil having place for
**      at least 1 nRS, 1 maxpq and 1 nIP
**      (actually nIP will be smaller but that does not matter very much)
**
**      nIshe is the number of inactive orbitals dealt in the batch
**      nIshb is inactive dealt with after the previous batches
*
 50     Continue
        lWorke=lWork
        Do i=1,nsym
          nIshe(i)=0
          nAshe(i)=0
        End Do
        taskleft=.false.
        Libatch=0
        Do i=1,nsym
          k=MulD2h(i,jsym)
*
          nab=0
          nRS=0
          If (jsym.eq.1) Then
            nab=npq
            nRS=maxRS
          EndIf
          nab2=nBas(k)**2
          nileft=nIsh(i)-nIshb(i)
          If ((nab+nab2)*nileft.gt.0) Then
            nIshe(i)=min(lWorke/(nrs+nab+nab2),nileft)
            lWorke=lWorke-(nrs+nab+nab2)*nIshe(i)
            libatch=libatch+(nrs+nab+nab2)*nIshe(i)
            If (nIshe(i).ne.nileft)  Then
              taskleft=.true.
              Go to 10
            EndIf
          EndIf
*
        End Do
 10     Continue
*
**      Update nip and compute sum(nIshe)
*
        nip=0
        ntotie=0
        Do i=1,nsym
          k=MulD2h(i,jsym)
          nip=nip+nIshe(i)*nBas(k)
          ntotie=ntotie+nIshe(i)
        End Do
        nip=nip+ntotie ! for Lii^J
*
        Call GetMem('iiab','Allo','Real',ipiiab,libatch)
        nab=0
        If ((jsym.eq.1).and.(ntotie.gt.0)) Then
          nab=npq
          Call GetMem('iirs','Allo','Real',ipiirs,ntotie*maxRS)
        EndIf
        ipiaib=ipiiab+nab*ntotie
        Call dcopy_(libatch,[0.0d0],0,Work(ipiiab),1)

*init for compilers
        iptupq=ip_Dummy
        iptpuq=iptupq
*
        If (taskleft) Then
           ntotae=0
           ntue=0
           ntp=0      ! do not allocate those
           labatch=0
           write(6,*) 'Batching loop i'
        Else
*
**        Batching T loop
*
           labatch=0
           Do i=1,nsym
             k=MulD2h(i,jsym)
             nab=0
             nRS=0
             If (jsym.eq.1) Then
               nab=ntota*npq
               nRS=ntota*maxRS
             EndIf
             nab2=nAsh(i)*nBas(k)**2
             naleft=nAsh(i)-nAshb(i)
             If ((nab+nab2)*naleft.gt.0) Then
               nAshe(i)=min(lWorke/(nrs+nab+nab2),naleft)
               lWorke=lWorke-(nrs+nab+nab2)*nAshe(i)
               labatch=labatch+(nrs+nab+nab2)*nAshe(i)
               If (nAshe(i).ne.naleft)  Then
                 taskleft=.true.
                 Go to 11
               EndIf
             EndIf
           End Do
 11        Continue
*
           ntotae=0
           ntue=0
           ntp=0
           Do i=1,nsym
             k=MulD2h(i,jsym)
             ntotae=ntotae+nAshe(i)
             ntue=ntue+nAshe(i)*nAsh(i)
             ntp  =ntp + nAsh(i)*(nBas(k)+nAshe(i))
           End Do

           If (ntotae.gt.0)
     &        Call GetMem('tupq','Allo','Real',iptupq,labatch)
           nab=0
           If (jsym.eq.1) Then
             nab=npq
             If (ntue.gt.0)
     &          Call GetMem('turs','Allo','Real',ipturs,ntue*maxRS)
           EndIf
           iptpuq=iptupq+nab*ntue
           call dcopy_(labatch,[0.0d0],0,Work(iptupq),1)
           If (taskleft) Then
              write(6,*) 'Batching loop a'
           EndIf
        EndIf
*FIXME: can iptpuq be uninitialized?
*
**    Transpose CMO
*
        nCMO=0
        Do i=1,nsym
          nCMO=nCMO+nIshe(i)*nBas(i)
        End Do
        Call GetMem('CMOt','Allo','Real',ipCMOt(1),nCMO)
        ioff =0
        ioff2=0
        Do iSym=1,nsym
          ipCMOt(iSym)=ipCMOt(1)+ioff2
          Do j=1,nIshe(iSym)
            ioff3=ioff+nBas(iSym)*(nIshb(iSym)+j-1)
            call dcopy_(nBas(iSym),Work(ipCMO+ioff3),1,
     &                 Work(ipCMOt(isym)+j-1),nIshe(iSym))
          End Do
          ioff =ioff +nBas(iSym)**2
          ioff2=ioff2+nBas(iSym)*nIshe(iSym)
        End Do
*
**      Loop over reduced sets
*
        Do JRED=JRED1,JRED2
          CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

          If (nVrs.eq.0) GOTO 998  ! no vectors in that (jred,isym)

          if (nVrs.lt.0) then
            Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
            call Abend
          endif

          Call Cho_X_SetRed(irc,iLoc,JRED)
c         !set index arrays at iLoc
          if(irc.ne.0)then
            Write(6,*)SECNAM//' cho_X_setred non-zero return code.'//
     &                        ' rc= ',irc
            call Abend
          endif

          IREDC=JRED

          nRS = nDimRS(JSYM,JRED)

          If (jSym.eq.1) Then
            If (ntotie.gt.0)
     &         call dcopy_(ntotie*nRS,[0.0d0],0,Work(ipiirs),1)
            If (ntue.gt.0)
     &         call dcopy_(ntue*nRS,[0.0d0],0,Work(ipturs),1)
          EndIf

          Call GetMem('MaxM','Max','Real',KDUM,LWORKe)
          nVec= min(LWORKE/(nRS+max(nip,ntp)),min(nVrs,MaxVecPerBatch))
          If (nVec.lt.1) Then
            WRITE(6,*) SECNAM//': Insufficient memory for J batch'
            WRITE(6,*) 'That should not happen here'
            WRITE(6,*) 'Contact the developers'
            CALL Quit(_RC_MEMORY_ERROR_)
            nBatch = -9999  ! dummy assignment
          EndIf
          LREAD = nRS*nVec
*
          Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
          Call GetMem('ChoT','Allo','Real',ipChoT,max(nIP,ntp)*nVec)
*
          nBatch = (nVrs-1)/nVec + 1
*
**        Loop over batches of Cholesky vectors
*
          DO jBatch=1,nBatch

            If (jBatch.eq.nBatch) Then
               JNUM = nVrs - nVec*(nBatch-1)
            else
               JNUM = nVec
            endif
            JVEC = nVec*(jBatch-1) + iVrs
            IVEC2 = JVEC - 1 + JNUM
************************************************************************
*                                                                      *
*                Let's start the real work                             *
*                                                                      *
************************************************************************
*
**          Read Cholesky vectors
*
            CALL CWTIME(TCR1,TWR1)

            CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                     NUMV,IREDC,MUSED)

            If (NUMV.le.0 .or.NUMV.ne.JNUM ) then
               rc=77
               RETURN
            End If

            CALL CWTIME(TCR2,TWR2)
            tread(1) = tread(1) + (TCR2 - TCR1)
            tread(2) = tread(2) + (TWR2 - TWR1)
*
************************************************************************
**          MO Half-transformation
**          Liq^J= sum_p Lpq^J Xip
*
            lChoI=0
            Do i=1,nSym

               k = Muld2h(i,JSYM)
               iSkip(k) = Min(1,
     &              nBas(k)*nIshe(i))

               ipLpq(k) = ipChoT + lChoI       ! Lvb,J

               lChoI= lChoI + nIshe(i)*nBas(k)*JNUM

            End Do

            iSwap = 1 ! Lqi,J are returned
            kMOs = 1  !
            nMOs = 1  ! Active MOs (1st set)
*
            CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                        JSYM,iSwap,IREDC,nMOs,kMOs,ipCMOt,
     &                        nIshe,ipLpq,iSkip,DoRead)

            if (irc.ne.0) then
               rc = irc
               RETURN
            endif

            CALL CWTIME(TCR1,TWR1)
            ttran(1) = ttran(1) + (TCR1 - TCR2)
            ttran(2) = ttran(2) + (TWR1 - TWR2)
*
************************************************************************
**          Integral formation
**          (i p | i q ) = sum_J Lip^J  Liq^J
*
            ip1=ipiaib
            Do isym=1,nsym
              ksym=MulD2h(iSym,jsym)
              Do ii=1,nIshe(isym)
*                 ipLip=ipLpq(isym)+nBas(kSym)*(ii-1)
                 ipLip=ipLpq(ksym)+nBas(kSym)*(ii-1)
*
                 Call DGEMM_('N','T',nBas(kSym),nBas(kSym),JNUM,
     &                        1.0d0,Work(ipLip),nBas(kSym)*nIshe(iSym),
     &                              Work(ipLip),nBas(kSym)*nIshe(iSym),
     &                        1.0d0,Work(ip1)  ,nBas(kSym))
                 ip1=ip1+nBas(kSym)**2
              End Do
            End Do
            CALL CWTIME(TCR2,TWR2)
            tform(1) = tform(1) + (TCR2 - TCR1)
            tform(2) = tform(2) + (TWR2 - TWR1)
*
************************************************************************
**          Second MO transformation
**          Lii^J = sum_q Liq^J Xiq
*
            If (jSym.eq.1) Then
*             The end of ipChoT is allocated for Lii^J
              ipLii=ipChoT+(nIP-ntotie)*nVec
              ipMO=ipCMO
              Do isym=1,nsym
                Do ii=1,nIshe(iSym)
                  ipMO=ipMO+ISTSQ(iSym)
                  ipLip=ipLpq(iSym)+nBas(iSym)*(ii-1)
                  ipMOi=ipMO+(nIshb(isym)+ii-1)*nBas(iSym)
                  ipLiii=ipLii+(ii-1)*JNUM
                  Call dGeMV_('T',nBas(iSym),JNUM,
     &                       1.0d0,Work(ipLip),nBas(iSym)*nIshe(iSym),
     &                             Work(ipMOi),1,
     &                       0.0d0,Work(ipLiii),1)
                End Do
*                ipMO=ipMO+nIsh(iSym)*nBas(iSym)
                ipLii=ipLii+JNUM*nIshe(iSym)
              End Do
            CALL CWTIME(TCR1,TWR1)
            ttran(1) = ttran(1) + (TCR1 - TCR2)
            ttran(2) = ttran(2) + (TWR1 - TWR2)
*
************************************************************************
**            Integral formation
**            (i i | p q ) = sum_J Lii^J  Lpq^J
*
              ipLii=ipChoT+(nIP-ntotie)*nVec
              Call DGEMM_('N','N',nRS,ntotie,JNUM,
     &                    1.0d0,Work(ipLrs),nRS,
     &                          Work(ipLii),JNUM,
     &                    1.0d0,Work(ipiirs),nRS)
            CALL CWTIME(TCR2,TWR2)
            tform2(1) = tform2(1) + (TCR2 - TCR1)
            tform2(2) = tform2(2) + (TWR2 - TWR1)

            EndIf
*
************************************************************************
**          Read half-transformed active vectors
*
            lChoA=0
            Do i=1,nSym
               k = Muld2h(i,JSYM)
               ipLpq(k) = ipChoT + lChoA       ! Lvb,J
               lChoA= lChoA + nAsh(k)*nBas(i)*JNUM
            End Do
*
            ioff=0
            Do i=1,nSym
              k = Muld2h(i,JSYM)
              lvec=nAsh(k)*nBas(i)*JNUM
              iAdr2=(JVEC-1)*nAsh(k)*nBas(i)+ioff
              call DDAFILE(LuAChoVec(Jsym),2,Work(ipLpq(k)),
     &                     lvec,iAdr2)
            End Do
*
************************************************************************
**          Form (tp|uq) integrals
*
            Do j=1,JNUM
              ioff=0
              Do i=1,nsym
                k = Muld2h(i,JSYM)
                Do it=0,nAshe(k)-1
                  ipLtp=ipLpq(k)+nAshb(k)+it+nAsh(k)*nBas(i)*(j-1)
                  Do iu=0,nAshb(k)+it
                    itu=it*(2*nAshb(k)+it+1)/2+iu
                    ipLuq=ipLpq(k)+iu+nAsh(k)*nBas(i)*(j-1)
                    ipInt=iptpuq+ioff+itu*nBas(i)**2
                    Call DGER(nBas(i),nBas(i),
     &                        1.0d0,Work(ipLtp),nAsh(k),
     &                              Work(ipLuq),nAsh(k),
     &                              Work(ipInt),nBas(i))
                  End Do
                End Do
                ioff=ioff+nAshe(k)*(2*nAshb(k)+nAshe(k)+1)/2*
     &               nBas(i)**2
              End Do
            End Do
            CALL CWTIME(TCR1,TWR1)
            tforma(1) = tforma(1) + (TCR1 - TCR2)
            tforma(2) = tforma(2) + (TWR1 - TWR2)
*
************************************************************************
**          Second MO transformation
*
           If (jsym.eq.1) Then
             ipLtu=ipChoT+(ntp-ntue)*nVec
             ioff=0
             Do i=1,nsym
               Do j=1,JNUM
                 ipLtp=ipLpq(i)+(j-1)*(nBas(i)*nAsh(i))
                 ipMO=ipCMO+ioff+nBas(i)*(nIsh(i)+nAshb(i))
                 Do k=0,nAshe(i)-1
                   Call dGeMV_('N',nAshb(i)+k+1,nBas(i),
     &                         1.0d0,Work(ipLtp),nAsh(i),
     &                               Work(ipMO+k*nBas(i)),1,
     &                         0.0d0,Work(ipLtu),1)
                   ipLtu=ipLtu+(nAshb(i)+k+1)
                 EndDo
               End Do
               ioff=ioff+nBas(i)**2
             End Do
            CALL CWTIME(TCR2,TWR2)
*
************************************************************************
**           Formation of the (tu|rs) integral
*
             ipInt=ipturs
             ipLtu=ipChoT+(ntp-ntue)*nVec
             Do i=1,nsym
               na2=nAshe(i)*nAshb(i)+nAshe(i)*(nAshe(i)+1)/2
               If (na2.gt.0) Then
                 Call DGEMM_('N','T',nRS,na2,JNUM,
     &                       1.0d0,Work(ipLrs),nRS,
     &                             Work(ipLtu),na2,
     &                       1.0d0,Work(ipInt),nRS)
                 ipLtu=ipLtu+na2*JNUM
                 ipInt=ipInt+nRS*na2
               End If
             End Do
            CALL CWTIME(TCR1,TWR1)
            tforma2(1) = tforma2(1) + (TCR1 - TCR2)
            tforma2(2) = tforma2(2) + (TWR1 - TWR2)
           EndIf
************************************************************************
*                                                                      *
*                Cholesky loop is over!                                *
*                                                                      *
************************************************************************

          End Do ! J batch
*
**        Transform to full storage, use Lrs as temp storage
*
          If (jsym.eq.1) Then
            Do i=1,ntotie
              ip1=ipiiab+nab*(i-1)
              ipRS1=ipiirs+nRS*(i-1)
              mode = 'tofull'
              Call play_rassi_sto(irc,iLoc,JSYM,ISTSQ,ISSQ,
     &                                   ip1,ipRS1,mode)
            End Do
            Do i=1,ntue
              ip1=iptupq+npq*(i-1)
              ipRS1=ipturs+nrs*(i-1)
              mode = 'tofull'
*              Call play_rassi_sto(irc,iLoc,JSYM,ISTLT,ISSQ,
              Call play_rassi_sto(irc,iLoc,JSYM,ISTSQ,ISSQ,
     &                                   ip1,ipRS1,mode)
            End Do
          EndIf
*
          Call GetMem('rsL','Free','Real',ipLrs,LREAD)
          Call GetMem('ChoT','Free','Real',ipChoT,max(nIP,ntp)*nVec)
 998      Continue
        End Do ! reduced set JRED
*
        If (jsym.eq.1) Then
          If (ntotie.gt.0)
     &      Call GetMem('iirs','Free','Real',ipiirs,ntotie*maxRS)
          If (ntue.gt.0)
     &      Call GetMem('turs','Free','Real',ipturs,ntue*maxRS)
        EndIf
*
** MGD  Gather integrals from parallel runs
*

*
        CALL CWTIME(TCR1,TWR1)
        Call GetMem('MOt-int','Allo','Real',ipInt,maxpq)
        ip1=ipiaib
        ip3=iptpuq
        isum=0
        isum2=0
        Do isym=1,nSym
          ksym=MulD2h(iSym,jsym)
          nvirt=nBas(kSym)-nIsh(kSym)
          ipMO=ipCMO+ISTSQ(kSym)+nBas(kSym)*nIsh(kSym)
          Do ii=1,nIshe(isym)
*
**          MO transform ( i i | p q)
*
            If (jsym.eq.1) Then
              isum=isum+1
              ip2=ipiiab+nab*(isum-1)
              ioff2=0
              Do ksym2=1,nsym
                ipMO2=ipCMO+ioff2+nBas(kSym2)*nIsh(kSym2)
                nvirt2=nBas(kSym2)-nIsh(kSym2)
                Do j=1,nvirt2
                  ipMOj=ipMO2+(j-1)*nBas(kSym2)
                  ipIntj=ipInt+(j-1)*nBas(kSym2)
                  Call DSPMV_('U',nBas(kSym2),1.0d0,Work(ip2),
     &                       Work(ipMOj),1,0.0d0,Work(ipIntj),1)
                End Do
                Call DGEMM_('T','N',nvirt2,nvirt2,nBas(kSym2),
     &                      1.0d0,Work(ipInt),nBas(kSym2),
     &                            Work(ipMO2),nBas(kSym2),
     &                      0.0d0,Work(ip2)  ,nvirt2)
*
                call DDAFILE(LuChoInt(1),1,Work(ip2),nvirt2**2,iAdr)
*
                ip2=ip2+nBas(kSym2)**2
                ioff2 =ioff2 +nBas(kSym2)**2
              End Do
            Else
              Do i=1,nsym
                iAdr=iAdr+(nBas(i)-nIsh(i))**2
              End Do
            EndIf
*
**      MO transform ( i p | i q)
*
            Call DGEMM_('N','N',nBas(kSym),nvirt,nBas(kSym),
     &                  1.0d0,Work(ip1)  ,nBas(kSym),
     &                        Work(ipMO),nBas(kSym),
     &                  0.0d0,Work(ipInt),nBas(kSym))
            Call DGEMM_('T','N',nvirt,nvirt,nBas(kSym),
     &                  1.0d0,Work(ipInt),nBas(kSym),
     &                        Work(ipMO),nBas(kSym),
     &                  0.0d0,Work(ip1)  ,nvirt)
*
            Do i=1,ksym-1
                iAdr=iAdr+(nBas(i)-nIsh(i))**2
            End Do
            call DDAFILE(LuChoInt(1),1,Work(ip1),nvirt**2,iAdr)
            Do i=ksym+1,nsym
                iAdr=iAdr+(nBas(i)-nIsh(i))**2
            End Do
*
            ip1=ip1+nBas(kSym)**2
          End Do
*
**        MO transform ( t u | p q)
*
*compute address
          iAdrtu=0
          Do i=1,ksym-1
            na2=nAshe(i)*nAshb(i)+nAshe(i)*(nAshe(i)+1)/2
            Do j=1,na2
              iAdrtu=iAdrtu+npq
              Do k=1,nsym
                iAdrtu=iAdrtu+nBas(k)**2
              End Do
            End Do
          End Do
*
          ipMO=ipCMO+ISTSQ(iSym)
          na2=nAshe(ksym)*nAshb(ksym)+nAshe(ksym)*(nAshe(ksym)+1)/2
          Do itu=1,na2
            If (jsym.eq.1) Then
              isum2=isum2+1
              ip2=iptupq+npq*(isum2-1)
              ioff2=0
              Do ksym2=1,nsym
                ipMO2=ipCMO+ioff2
                Do j=1,nBas(ksym2)
                  ipMOj=ipMO2+(j-1)*nBas(kSym2)
                  ipIntj=ipInt+(j-1)*nBas(kSym2)
                  Call DSPMV_('U',nBas(kSym2),1.0d0,Work(ip2),
     &                       Work(ipMOj),1,0.0d0,Work(ipIntj),1)
                End Do
                If (nBas(ksym2).gt.0) Then
                  Call DGEMM_('T','N',nBas(ksym2),nBas(kSym2),
     &                              nBas(kSym2),1.0d0,
     &                              Work(ipInt),nBas(kSym2),
     &                              Work(ipMO2),nBas(kSym2),
     &                        0.0d0,Work(ip2)  ,nBas(kSym2))
                  call DDAFILE(LuChoInt(2),1,Work(ip2),nBas(kSym2)**2,
     &            iAdrtu)
*
                  ip2=ip2+nBas(kSym2)**2
                  ioff2 =ioff2 +nBas(kSym2)**2
                EndIf
              EndDo
            Else
              iAdrtu=iAdrtu+npq
            EndIf
*
**        MO transform ( t p | u q)
*
            Call DGEMM_('N','N',nBas(iSym),nBas(iSym),nBas(iSym),
     &                  1.0d0,Work(ip3)  ,nBas(iSym),
     &                        Work(ipMO),nBas(iSym),
     &                  0.0d0,Work(ipInt),nBas(iSym))
            Call DGEMM_('T','N',nBas(iSym),nBas(iSym),nBas(iSym),
     &                  1.0d0,Work(ipInt),nBas(iSym),
     &                        Work(ipMO),nBas(iSym),
     &                  0.0d0,Work(ip3) ,nBas(iSym))
            Do i=1,isym-1
                iAdrtu=iAdrtu+nBas(i)**2
            End Do

            call DDAFILE(LuChoInt(2),1,Work(ip3),nBas(iSym)**2,iAdrtu)

            Do i=isym+1,nsym
*               j=MulD2h(i,jsym)
                iAdrtu=iAdrtu+nBas(i)**2
            End Do
            ip3=ip3+nBas(iSym)**2
*
*            Do i=1,nsym
*              iAdrtu=iAdrtu+nBas(i)**2
*            enddo
          End Do

        End Do
        CALL CWTIME(TCR2,TWR2)
        tMO(1) = tMO(1) + (TCR2 - TCR1)
        tMO(2) = tMO(2) + (TWR2 - TWR1)
*
        Call GetMem('MOt-int','Free','Real',ipInt,maxpq)
*
        Do i=1,nsym
          nIshb(i)=nIshb(i)+nIshe(i)  ! now those are done!
          nAshb(i)=nAshb(i)+nAshe(i)  ! now those are done!
        EndDo
        Call GetMem('CMOt','Free','Real',ipCMOt(1),nCMO)
        Call GetMem('iiab','Free','Real',ipiiab,libatch)
        If (ntotae.gt.0)
     &     Call GetMem('tupq','Free','Real',iptupq,labatch)
        If (taskleft) Go to 50  ! loop over i/t batches
*
 999    Continue
*
      End Do ! jsym
*
      CALL CWTIME(TCstart2,TWstart2)
      TOTCPU=TCstart2-TCstart1
      TOTWALL=TWstart2-TWstart1
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky MCLR timing from '//SECNAM
      Write(6,CFmt)'----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Integral construction           CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ VECTORS                     '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'TRANSFORMATION                   '
     &                           //'         ',ttran(1),ttran(2)
         Write(6,'(2x,A26,2f10.2)')'(IA|IB) FORMATION                '
     &                           //'         ',tform(1),tform(2)
         Write(6,'(2x,A26,2f10.2)')'(II|AB) FORMATION                '
     &                           //'         ',tform2(1),tform2(2)
         Write(6,'(2x,A26,2f10.2)')'(TP|UQ) FORMATION                '
     &                           //'         ',tforma(1),tforma(2)
         Write(6,'(2x,A26,2f10.2)')'(TU|PQ) FORMATION                '
     &                           //'         ',tforma2(1),tforma2(2)
         Write(6,'(2x,A26,2f10.2)')'MO TRANSFORMATION                '
     &                           //'         ',tMO(1),tMO(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif

      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine diisra(wrk,wrksize,diispoint,num,v1,v2,v3,v4)
! this routine reads num vectors of amplitudes
! from prepaired diispoint(1) - diispoint(num) files
!
! diispoint - stack of lun numbers (I)
! num       - number of vectors to be read (1-4) (I)
! v1        - map type of vector 1 (I)
! v2        - map type of vector 1 (I)
! v3        - map type of vector 1 (I)
! v4        - map type of vector 1 (I)
! if there is less than 4 vectors required use any map type

use ccsd_global, only: Map_Type
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, diispoint(4), num
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(inout) :: v1, v2, v3, v4
integer(kind=iwp) :: lun, rc

if (num == 1) then
  lun = diispoint(1)
  call getmediate(wrk,wrksize,lun,v1,rc)
else if (num == 2) then
  lun = diispoint(1)
  call getmediate(wrk,wrksize,lun,v1,rc)
  lun = diispoint(2)
  call getmediate(wrk,wrksize,lun,v2,rc)
else if (num == 3) then
  lun = diispoint(1)
  call getmediate(wrk,wrksize,lun,v1,rc)
  lun = diispoint(2)
  call getmediate(wrk,wrksize,lun,v2,rc)
  lun = diispoint(3)
  call getmediate(wrk,wrksize,lun,v3,rc)
else if (num == 4) then
  lun = diispoint(1)
  call getmediate(wrk,wrksize,lun,v1,rc)
  lun = diispoint(2)
  call getmediate(wrk,wrksize,lun,v2,rc)
  lun = diispoint(3)
  call getmediate(wrk,wrksize,lun,v3,rc)
  lun = diispoint(4)
  call getmediate(wrk,wrksize,lun,v4,rc)
end if

return

end subroutine diisra

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************

module Fockof

use Data_Structures, only: V1
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: IOFFIT(8), IOFFIA(8), IOFFTA(8)
type(V1) :: FAI(8), FAT(8), FIA(8), FIT(8), FTA(8), FTI(8)
real(kind=wp), allocatable, target :: FAI_Full(:), FAT_Full(:), FIA_Full(:), FIT_Full(:), FTA_Full(:), FTI_Full(:)

public :: FAI, FAI_Full, FAT, FAT_Full, FIA, FIA_Full, FIT, FIT_Full, FTA, FTA_Full, FTI, FTI_Full, IOFFIA, IOFFIT, IOFFTA

end module Fockof

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine IndSft_RI_3(iCmp,iShell,iBas,jBas,kBas,lBas,
     &                       Shijij, iAO, iAOst, ijkl,SOint,nSOint,
     &                       iSOSym,nSOs,
     &                       TInt,nTInt,iOff,iShlSO,nBasSh,
     &                       iSOShl,nSO,nShell,nSym,iSSOff)
************************************************************************
*  object: to sift and index the SO integrals.                         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          april '90                                                   *
*                                                                      *
************************************************************************
      use Basis_Info, only: nBas
      use SOAO_Info, only: iAOtSO
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "srt0.fh"
#include "srt1.fh"
#include "WrkSpc.fh"
*
      Real*8 SOint(ijkl,nSOint), TInt(nTInt)
      Integer iSOShl(nSO), iShlSO(nSO), nBasSh(0:nSym-1,nShell),
     &        iSSOff(0:nIrrep-1,0:nIrrep-1)
      Integer iCmp(4), iShell(4), iAO(4),
     &        iAOst(4), iSOSym(2,nSOs), jOffSO(0:7)
      Logical Shijij, Shkl, qkl
*     local array
      Integer jSym(0:7), kSym(0:7), lSym(0:7), iOff(3,0:7)
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      jOffSO(0)=0
      Do iIrrep = 1, nIrrep-1
         jOffSO(iIrrep)=jOffSO(iIrrep-1)+nBas(iIrrep-1)
      End Do
      memSO2 = 0
*
*
*     quadruple loop over elements of the basis functions angular
*     description. loops are reduced to just produce unique SO integrals
*     observe that we will walk through the memory in AOint in a
*     sequential way.
*
      Shkl = iShell(3).eq.iShell(4)
      If (iShell(4).gt.iShell(3)) Then
         Call WarningMessage(2,'Error in IndSft_RI_3')
         Write (6,*) 'iShell(4).gt.iShell(3)'
         Call Abend()
      End If
*
      i1=1
      j1=0
      Do i2 = 1, iCmp(2)
         Do 201 j = 0, nIrrep-1
            ix = 0
            If (iAOtSO(iAO(2)+i2,j)>0) ix = 2**j
            jSym(j) = ix
201      Continue
         If (iShell(2).gt.iShell(1)) then
            i12 = iCmp(2)*(i1-1) + i2
         else
            i12 = iCmp(1)*(i2-1) + i1
         End If
         Do i3 = 1, iCmp(3)
            Do 301 j = 0, nIrrep-1
               ix = 0
               If (iAOtSO(iAO(3)+i3,j)>0) ix = 2**j
               kSym(j) = ix
301         Continue
            lCmpMx = iCmp(4)
            If (Shkl) lCmpMx = i3
            Do 400 i4 = 1, lCmpMx
               Do 401 j = 0, nIrrep-1
                  ix = 0
                  If (iAOtSO(iAO(4)+i4,j)>0) ix = 2**j
                  lSym(j) = ix
401            Continue
               qkl = i3.eq.i4
               If (iShell(4).gt.iShell(3)) then
                  i34 = iCmp(4)*(i3-1) + i4
               else
                  i34 = iCmp(3)*(i4-1) + i3
               End If
*
*      loop over Irreps which are spanned by the basis function.
*      again, the loop structure is restricted to ensure unique
*      integrals.
*
       Do 210 j2 = 0, nIrrep-1
          If (jSym(j2).eq.0) go to 210
          j12 = iEor(j1,j2)
*
          Do 310 j3 = 0, nIrrep-1
             If (kSym(j3).eq.0) go to 310
             j4 = iEor(j12,j3)
             If (lSym(j4).eq.0) go to 310
             If (Shkl .and. qkl .and. j4.gt.j3) go to 310
*
             memSO2 = memSO2 + 1
             If ( (nSkip(j2+1)+
     &             nSkip(j3+1)+nSkip(j4+1) ).ne.0 ) GoTo 310
*                                                                      *
************************************************************************
*                                                                      *
*            Number of auxiliary basis functions in this symmetry block.
             mm       = iOff(1,j12)
             If (mm.eq.0) Go  To 310
*            Offset to J12 symmetry block.
             iOff_J12 = iOff(2,j12)
*            Effective number of valence basis products in this symmetry
*            block.
             n3C      = iOff(3,j12)
             If (n3C.eq.0) Go To 310
*            Offset to the symmetry block of this shell pair.
             iOff_L   = iSSOff(j3,j4)
*                                                                      *
************************************************************************
*                                                                      *
*            Compute index within the irrep. Keep the indexation
*            of the two basis set sets apart.
*
             jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)-nBas(j2)
             kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+jOffSO(j3)
             lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+jOffSO(j4)
*
                nijkl = 0
                Do lSOl = lSO, lSO+lBas-1
                   iD = iShlSO(lSOl)
                   iShD = iSOShl(lSOl)
                   nD = nBasSh(j4,iShD)
                   Do kSOk = kSO, kSO+kBas-1
                      iC = iShlSO(kSOk)
                      iShC = iSOShl(kSOk)
                      nC = nBasSh(j3,iShC)
*
                      If (iShC.eq.iShD) Then
                         If (j12.eq.0) Then
                            kl=iTri(iC,iD)
                         Else If (j3.gt.j4) Then
                            kl = (iC-1)*nD + iD
                         Else
                            kl = (iD-1)*nC + iC
                         End If
                      Else
                         If (iShC.ge.iShD) Then
                            kl = (iD-1)*nC + iC
                         Else
                            kl = (iC-1)*nD + iD
                         End If
                      End If
*
                      Do jSOj = jSO, jSO+jBas-1
                         iAux= jSOj
                         nijkl = nijkl + 1
                         AInt=SOint(nijkl,memSO2)
*                                                                      *
************************************************************************
*                                                                      *
                         If (j12.eq.0) Then
                            If (kSOk.ge.lSOl) Then
                               kl_B=(iAux-1)*n3C+kl + iOff_L
                               TInt(kl_B)=AInt
                            End If
                         Else
                            kl_B=(iAux-1)*n3C+kl + iOff_L
                            TInt(kl_B)=AInt
                         End If
*                                                                      *
************************************************************************
*                                                                      *
                      End Do
                   End Do
                End Do
*
310       Continue
210    Continue
*
400         Continue
         End Do
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iBas)
         Call Unused_logical(Shijij)
         Call Unused_integer_array(iSOSym)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Add2CenterFunctions(iAtomPair,ip_CBar,l_CBar,
     &                                   ip_Z,l_Z,Modified,irc)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: Add two-center functions to the auxiliary basis of atom
C     pair iAtomPair (if needed), and update CBar and Z matrices
C     (reallocated and computed here). Note that the atoms constituting
C     atom pair iAtomPair need not be different. In this case, the
C     functions added are not two-center functions, of course, but taken
C     from the AO product space on the atom in question. For aCD/acCD
C     sets, there should be no need for this, but predefined sets may
C     need additional functions to achieve the required accuracy.
C
C     The addition of two-center functions is based on the updated
C     diagonal stored along with the atom pair info.
C
C     If the auxiliary basis was modified (i.e. if 2C functions were
C     added), Modified=.True. on exit.
C
      Implicit None
      Integer iAtomPair
      Integer ip_CBar, l_CBar
      Integer ip_Z, l_Z
      Logical Modified
      Integer irc
#include "localdf_print.fh"

      Integer n2CF_Added

      ! Init return code
      irc=0

      ! Set list of potential two-center functions from diagonals.
      ! Diagonals larger than the required threshold are included.
      n2CF_Added=0
      Call LDF_Set2CL(iAtomPair,n2CF_Added)
      If (iPrint.ge.Inf_AuxBas) Then
         Call Cho_Head('Auxiliary Basis Info after Initial 2C Addition',
     &                 '-',80,6)
         Call LDF_PrintAuxBasInfo(iAtomPair)
      End If

      ! Set Modified
      Modified=n2CF_Added.gt.0

      If (Modified) Then
         ! Cholesky decompose residual matrix to get minimal set of
         ! two-center functions
         Call LDF_ResidualCD(iAtomPair,ip_CBar,l_CBar,irc)
         If (irc.ne.0) Then
            Write(6,'(A,I8)')
     &      'LDF_Add2CenterFunctions: LDF_ResidualCD returned code',irc
            irc=1
            Return
         End If
         If (iPrint.ge.Inf_AuxBas) Then
            Call Cho_Head('Auxiliary Basis Info after Residual CD',
     &                    '-',80,6)
            Call LDF_PrintAuxBasInfo(iAtomPair)
         End If
         ! Deallocate CBar and Z
         Call GetMem('CBar','Free','Real',ip_CBar,l_CBar)
         ip_CBar=0
         l_CBar=0
         Call GetMem('ZVec','Free','Real',ip_Z,l_Z)
         ip_Z=0
         l_Z=0
         ! Compute new CBar and Z
         Call LDF_ComputeCBar(iAtomPair,ip_CBar,l_CBar,ip_Z,l_Z,irc)
         If (irc.ne.0) Then
            Write(6,'(A,I8)')
     &      'LDF_Add2CenterFunctions: LDF_ComputeCBar returned code',irc
            irc=1
            Return
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Start_Last_Energy()

use RunFile_procedures, only: Get_Coord_New
use PrintLevel, only: nPrint
use stdalloc, only: mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: iGO, lengthlast, LuInput, nCoord, nSaddle
logical(kind=iwp) :: FoundLastEn, Saddle
character(len=16) :: StdIn
character(len=8) :: Method
real(kind=wp), allocatable :: CN(:,:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
if (nPrint(1) >= 6) then
  write(u6,*)
  write(u6,*) ' Slapaf requests the last energy to be computed!'
  write(u6,*)
end if

LuInput = 11
LuInput = IsFreeUnit(LuInput)
call StdIn_Name(StdIn)
call Molcas_Open(LuInput,StdIn)

call Get_iScalar('Grad ready',iGO)

write(LuInput,'(A)') '>ECHO OFF'
write(LuInput,'(A)') '>export SL_OLD_TRAP=$MOLCAS_TRAP'
write(LuInput,'(A)') '>export MOLCAS_TRAP=ON'

call qpg_dArray('Saddle',Saddle,nSaddle)
if (Saddle) then

  ! Clean up among the runfiles, etc.

  write(LuInput,'(A)') '>COPY $Project$SubProject.RunFile $Project.RunFile'

  call qpg_cArray('LastEnergyMethod',FoundLastEn,lengthlast)
  if (FoundLastEn) then
    call Get_cArray('LastEnergyMethod',Method,8)
  else
    call Get_cArray('Relax Method',Method,8)
  end if

  if ((Method == 'CASSCF') .or. (Method == 'RASSCF') .or. (Method == 'CASSCFSA') .or. (Method == 'RASSCFSA') .or. &
      (Method == 'CASPT2') .or. (Method == 'RASPT2')) then

    write(LuInput,'(A)') '>COPY $Project$SubProject.JobIph $Project.JobIph'
    write(LuInput,'(A)') '>RM $Project.Reac.JobIph'
    write(LuInput,'(A)') '>RM $Project.Prod.JobIph'
  end if
  write(LuInput,'(A)') '>RM $Project.Reac.RunFile'
  write(LuInput,'(A)') '>RM $Project.Prod.RunFile'
  write(LuInput,'(A)') '>export SubProject='
  write(LuInput,'(A)') '>export MOLCAS_SADDLE=0'

  ! Put the final structure as the reference structure

  call Get_Coord_New(CN,nCoord)
  call NameRun('RUNREAC')
  call Put_dArray('Ref_Geom',CN,3*nCoord)
  call NameRun('#Pop')
  call NameRun('RUNPROD')
  call Put_dArray('Ref_Geom',CN,3*nCoord)
  call NameRun('#Pop')
  call mma_deallocate(CN)
end if

if (iGo <= 1) then

  ! Normal behaviour

  write(LuInput,'(A)') ' &Last_Energy &End'
  write(LuInput,'(A)') 'End of Input'

else

  ! A CI ISC search has been performed. For the moment I care only
  ! for the ISC. Once the rest is done I will take care of that as well.

  write(LuInput,'(A)') '>COPY $OldProject.Seward.Input State1.Seward.Input'
  write(LuInput,'(A)') '>COPY $OldProject.Seward.Input State2.Seward.Input'
  write(LuInput,'(A)') '>COPY $OldProject.RunFile State1.RunFile'
  write(LuInput,'(A)') '>COPY $OldProject.RunFile State2.RunFile'
  write(LuInput,'(A)') '>RM molcas.env'
  write(LuInput,'(A)') '>export Project=State1'
  write(LuInput,'(A)') ' &Last_Energy &End'
  write(LuInput,'(A)') 'End of Input'
  write(LuInput,'(A)') '>RM molcas.env'
  write(LuInput,'(A)') '>export Project=State2'
  write(LuInput,'(A)') ' &Last_Energy &End'
  write(LuInput,'(A)') 'End of Input'
end if
write(LuInput,'(A)') '>export MOLCAS_TRAP=$SL_OLD_TRAP'

write(LuInput,'(A)') '>ECHO ON'

close(LuInput)

end subroutine Start_Last_Energy

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1992,2008, Roland Lindh                           *
************************************************************************
      SubRoutine Mk_ChDisp()
************************************************************************
*                                                                      *
* Object: To generate the displacement labels
*                                                                      *
* Called from: Gateway
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             September '91                                            *
*                                                                      *
*             Modified to complement GetInf, January '92.              *
************************************************************************
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
      Integer nDisp(0:7), DegDisp(MxAtom*3)
      Character ChDisp(MxAtom*3)*(LENIN6)
      Logical TstFnc
      Character*1 xyz(0:2)
      Data xyz/'x','y','z'/
*                                                                      *
************************************************************************
*                                                                      *
      LuWr=6
*
      nCnttp_Valence=0
      Do iCnttp = 1, nCnttp
         If (dbsc(iCnttp)%Aux) Exit
         nCnttp_Valence = nCnttp_Valence+1
      End Do
*
      mDisp = 0
      mdc = 0
      Do 10 iCnttp = 1, nCnttp_Valence
         If (dbsc(iCnttp)%pChrg) Then
             mdc = mdc + dbsc(iCnttp)%nCntr
             Go To 10
         End If
         Do iCnt = 1, dbsc(iCnttp)%nCntr
            mdc = mdc + 1
            mDisp = mDisp + 3*(nIrrep/dc(mdc)%nStab)
         End Do
 10   Continue
*                                                                      *
************************************************************************
*                                                                      *
      iDisp = 0
      Do iIrrep = 0, nIrrep-1
*        Loop over basis function definitions
         mdc = 0
         mc = 1
         nDisp(iIrrep)=0
         Do iCnttp = 1, nCnttp_Valence
*           Loop over unique centers associated with this basis set.
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = mdc + 1
*              Loop over the cartesian components
               Do iCar = 0, 2
                  iComp = 2**iCar
                  If ( TstFnc(dc(mdc)%iCoSet,
     &                       iIrrep,iComp,dc(mdc)%nStab) .and.
     &                .Not.dbsc(iCnttp)%pChrg ) Then
                     iDisp = iDisp + 1
                     ChDisp(iDisp)=' '
                     Write (ChDisp(iDisp)(1:(LENIN6)),'(A,1X,A1)')
     &                     dc(mdc)%LblCnt(1:LENIN4),xyz(iCar)
                     DegDisp(iDisp)=nIrrep/dc(mdc)%nStab
                     nDisp(iIrrep)=nDisp(iIrrep)+1
                  End If
*
               End Do
               mc = mc + nIrrep/dc(mdc)%nStab
            End Do
         End Do
*
      End Do
*
      If (iDisp.ne.mDisp) Then
         Call WarningMessage(2,
     &              ' Wrong number of symmetry adapted displacements')
         Write (6,*) iDisp,'=/=',mDisp
         Call Abend()
      End If
*
      Call Put_iScalar('nChDisp',iDisp)
      Call Put_cArray('ChDisp',ChDisp(1),(LENIN6)*iDisp)
      Call Put_iArray('nDisp',nDisp,nIrrep)
      Call Put_iArray('DegDisp',DegDisp,iDisp)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine inter1(Label,iBas_Lab,Coor,ZNUC,N_Cent)

use Basis_Info, only: DBSC, nCnttp
use Center_Info, only: DC
use Symmetry_Info, only: nIrrep
use Molcas, only: LenIn
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
character(len=LenIn), intent(_OUT_) :: Label(*)
integer(kind=iwp), intent(_OUT_) :: Ibas_Lab(*)
real(kind=wp), intent(_OUT_) :: Coor(3,*), ZNUC(*)
integer(kind=iwp), intent(out) :: n_Cent
integer(kind=iwp) :: iCnt, iCnttp, iCo, kOp, mdc, ndc, nDiff
real(kind=wp) :: A(3)
logical(kind=iwp) :: DSCF
character(len=LenIn) :: Lbl

DSCF = .false.
nDiff = 0
call IniSew(DSCF,nDiff)

mdc = 0
ndc = 0
do iCnttp=1,nCnttp
  if (dbsc(iCnttp)%Aux .or. dbsc(iCnttp)%Frag .or. dbsc(iCnttp)%pChrg) then
    mdc = mdc+dbsc(iCnttp)%nCntr
    cycle
  end if
  do iCnt=1,dbsc(iCnttp)%nCntr
    mdc = mdc+1
    Lbl = dc(mdc)%LblCnt(1:LenIn)
    A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
    do iCo=0,nIrrep/dc(mdc)%nStab-1
      ndc = ndc+1
      kop = dc(mdc)%iCoSet(iCo,0)
      call OA(kOp,A,Coor(:,ndc))
      Label(ndc) = Lbl(1:LenIn)
      iBas_Lab(ndc) = iCnttp
      ZNUC(ndc) = real(dbsc(iCnttp)%AtmNr,kind=wp)
    end do
  end do
end do
n_cent = ndc

return

end subroutine inter1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
! Module_calcu  Completed LOOP multiply MOs and partly complete DM1 and

! SUBROUTINE lp10_arbrbr_ext_calcuvalue_G
! SUBROUTINE lp11_arblbr_ext_calcuvalue_G
! SUBROUTINE lp12_arblbl_ext_calcuvalue_G
! SUBROUTINE lp9_drlbl_ext_calcuvalue_wyb_G
! SUBROUTINE lp_ar_coe_sd_calcuvalue_wyb_G
! SUBROUTINE lp_ar_coe_td_calcuvalue_wyb_G
! SUBROUTINE lp_ar_coe_dv_calcuvalue_wyb_G
! SUBROUTINE lp_arbr_ext_svtv_calcuvalue_wyb_G
! SUBROUTINE lp_drr_ext_svtv_calcuvalue_wyb_G
! SUBROUTINE lp_arbl_ext_ss_calcuvalue_G
! SUBROUTINE lp_arbl_ext_st_calcuvalue_G
! SUBROUTINE lp_arbl_ext_ts_calcuvalue_G
! SUBROUTINE lp_arbl_ext_tt_calcuvalue_G
! SUBROUTINE lp_arbl_ext_dd_calcuvalue_G
! SUBROUTINE lp_drl_ext_SS_calcuvalue_G
! SUBROUTINE lp_drl_ext_ST_calcuvalue_G
! SUBROUTINE lp_drl_ext_TS_calcuvalue_G
! SUBROUTINE lp_drl_ext_TT_calcuvalue_G
! SUBROUTINE lp_drl_ext_dd_calcuvalue_wyb_G
! SUBROUTINE lp678_ext_wyb_calcuvalue_G_1
! SUBROUTINE lp678_ext_wyb_calcuvalue_G_2
! SUBROUTINE lp_drl_sum_SS_calcuvalue_G
! SUBROUTINE lp_drl_sum_TT_calcuvalue_G
! SUBROUTINE lp8_drlbr_sum_calcuvalue_wyb_G
! SUBROUTINE lp9_drlbl_sum_calcuvalue_wyb_G
! SUBROUTINE gsd_ext_sequence_G


      subroutine lp_drl_ext_SS_calcuvalue_G(lri,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      intpos=intind_abkk(lri)
      intspace=intspace_abkk(lri)
      ivalue=0

!G2G4b
      if ( logic_g2g4a ) then
        w0lp=w0_plp*w0g2a
        w1lp=w1_plp*w1g2a
        ww0lp=w0_plp*w0g4a
        ww1lp=w1_plp*w1g4a


      do lmb=1,ng_sm
         ibsta=ibsm_ext(lmb)
         ibend=iesm_ext(lmb)
         do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
               lra=norb_number(ira)

         ivalue=ivalue+2
!        Drl -- B^lA^r =4_3
         CALL TRANS_IJKL_INTPOS(lra,lrb,lri,lri,NXO)
         index_lpext(ivalue)=NXO
         value_lpext(ivalue)=-2.0D0*w0lp

         CALL TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
         index_lpext1(ivalue)=NXO
         value_lpext1(ivalue)=(w0lp-w1lp)

               enddo
            enddo
        enddo
      endif


      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a

      do lmb=1,ng_sm
         ibsta=ibsm_ext(lmb)
         ibend=iesm_ext(lmb)
         do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
               lra=norb_number(ira)
               ivalue=ivalue+1

               CALL TRANS_IJKL_INTPOS(lra,lrb,lri,lri,NXO)
               index_lpext(ivalue)=NXO
               value_lpext(ivalue)=-2.0D0*w0lp

               CALL TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
               index_lpext1(ivalue)=NXO
               value_lpext1(ivalue)=(w0lp-w1lp)

            enddo
         enddo
      enddo
      nlp_value=ivalue
      end


      subroutine lp_drl_ext_ST_calcuvalue_G(lri,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ivalue=0
!G1415
      if ( logic_g1415 ) then

      w1lp=w1_plp*w1g14a
C=========================lyb====================
C THE W1LP SHOULD BE MULTIPLED BY TWO,BECAUSE WE JUST USE HALF OF THEM
C IS H*C CALCULATIONS, ???

      w1lp=w1lp*2.0D+00

      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
            do ia=iasta,min(iaend,ib-1)
              lra=norb_number(ia)

            ivalue=ivalue+1
            CALL TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
            index_lpext(ivalue)=NXO
            value_lpext(ivalue)=w1lp

            CALL TRANS_IJKL_INTPOS(lrb,LRI,lrb,LRI,NXO)

           index_lpext1(ivalue)=NXO
           value_lpext1(ivalue)=-w1lp

            enddo
         enddo
      enddo
      endif

!G2G4b
      if ( logic_g2g4b ) then
        w1lp=w1_plp*w1g4b
      do lmb=1,ng_sm
         ibsta=ibsm_ext(lmb)
         ibend=iesm_ext(lmb)
         do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
               lra=norb_number(ira)

           ivalue=ivalue+1
           CALL TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
          index_lpext(ivalue)=NXO
          value_lpext(ivalue)=-w1lp

           ivalue=ivalue+1
          index_lpext(ivalue)=NXO
          value_lpext(ivalue)=w1lp

            enddo
         enddo
      enddo
      endif

      w1lp=w1_plp*w1g36a
      do lmb=1,ng_sm
         ibsta=ibsm_ext(lmb)
         ibend=iesm_ext(lmb)
         do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
               lra=norb_number(ira)
              ivalue=ivalue+1
              CALL TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
              index_lpext(ivalue)=NXO
              value_lpext(ivalue)=-w1lp
            enddo
         enddo
      enddo
      nlp_value=ivalue

      end

      subroutine lp_drl_ext_TT_calcuvalue_G
     :                           (lri,n1415_value,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ivalue=0
!G1415
      if ( logic_g1415 ) then

      w014=w0_plp*w0g14a
      w114=w1_plp*w1g14a
      w015=w0_plp*w0g15a
      w115=w1_plp*w1g15a

      w14lp=w014-w114
      w15lp=w015-w115
C=========================lyb====================
C THE W1LP SHOULD BE MULTIPLED BY TWO,BECAUSE WE JUST USE HALF OF THEM
C IS H*C CALCULATIONS, ???
C

      w14lp=w14lp*2.0D+00
      w15lp=w15lp*2.0D+00

      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
            do ia=iasta,min(iaend,ib-1)
              lra=norb_number(ia)
              ivalue=ivalue+1
              CALL TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
              index_lpext(ivalue)=NXO
              value_lpext(ivalue)=w15lp
              CALL TRANS_IJKL_INTPOS(lrb,LRI,lrb,LRI,NXO)
              index_lpext1(ivalue)=NXO
              value_lpext1(ivalue)=w14lp
            enddo
         enddo
      enddo
      endif

      n1415_value=ivalue

      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a

      do lmb=1,ng_sm
         ibsta=ibsm_ext(lmb)
         ibend=iesm_ext(lmb)
         do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
               lra=norb_number(ira)
               ivalue=ivalue+1

               CALL TRANS_IJKL_INTPOS(lra,lrb,lri,lri,NXO)
               index_lpext(ivalue)=NXO
               value_lpext(ivalue)=-2.0D0*w0lp

               CALL TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
               index_lpext1(ivalue)=NXO
               value_lpext1(ivalue)=(w0lp-w1lp)

            enddo
         enddo
      enddo
      nlp_value=ivalue
      end

      subroutine lp_drl_SUM_TT_calcuvalue_G
     :                           (lri,n1415_value,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ivalue=0
!G1415
      if ( logic_g1415 ) then

      w014=w0_plp*w0g14a
      w114=w1_plp*w1g14a
      w015=w0_plp*w0g15a
      w115=w1_plp*w1g15a

      w14lp=w014-w114
      w15lp=w015-w115
C=========================lyb====================
C THE W1LP SHOULD BE MULTIPLED BY TWO,BECAUSE WE JUST USE HALF OF THEM
C IS H*C CALCULATIONS, ???
C
      w14lp=w14lp*2.0D+00
      w15lp=w15lp*2.0D+00
      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
            do ia=iasta,min(iaend,ib-1)
              lra=norb_number(ia)
            ivalue=ivalue+1
            CALL TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
            index_lpext(ivalue)=NXO
            value_lpext(ivalue)=w15lp
            CALL TRANS_IJKL_INTPOS(lrb,LRI,lrb,LRI,NXO)
           index_lpext1(ivalue)=NXO
           value_lpext1(ivalue)=w14lp
         enddo
         enddo
      enddo
      endif

      n1415_value=ivalue

      w0lp=w0_plp*w0g36a

      do lmb=1,ng_sm
         ibsta=ibsm_ext(lmb)
         ibend=iesm_ext(lmb)
         do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
               lra=norb_number(ira)
               ivalue=ivalue+1
               CALL TRANS_IJKL_INTPOS(lra,lrb,lri,lri,NXO)
               index_lpext(ivalue)=NXO
               value_lpext(ivalue)=-2.0D0*w0lp
               CALL TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
               index_lpext1(ivalue)=NXO
               value_lpext1(ivalue)=w0lp
            enddo
         enddo
      enddo
      nlp_value=ivalue
      end
      subroutine lp_drl_ext_TS_calcuvalue_G(lri,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      intpos=intind_abkk(lri)
      intspace=intspace_abkk(lri)
      ivalue=0
!G1415
      if ( logic_g1415 ) then

      w1lp=w1_plp*w1g14a
C=========================lyb====================
C THE W1LP SHOULD BE MULTIPLED BY TWO,BECAUSE WE JUST USE HALF OF THEM
C IS H*C CALCULATIONS, ???

      w1lp=w1lp*2.0D+00
      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
            do ia=iasta,min(iaend,ib-1)
              lra=norb_number(ia)
              ivalue=ivalue+1
              CALL TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
              index_lpext(ivalue)=NXO
              value_lpext(ivalue)=w1lp
              CALL TRANS_IJKL_INTPOS(lrb,LRI,lrb,LRI,NXO)
              index_lpext1(ivalue)=NXO
              value_lpext1(ivalue)=-w1lp
           enddo
         enddo
      enddo
      endif

!G2G4b
      if ( logic_g2g4a ) then
        w0lp=w0_plp*w0g2a
        w1lp=w1_plp*w1g2a

C       valuelptmp1=w0lp
C       w0lp=w0lp-w1lp
C       w1lp=-valuelptmp1*2.d0
C       valuelptmp1=ww0lp
C       ww0lp=ww0lp-ww1lp
C       ww1lp=-valuelptmp1*2.d0


      do lmb=1,ng_sm
         ibsta=ibsm_ext(lmb)
         ibend=iesm_ext(lmb)
         do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
               lra=norb_number(ira)

           ivalue=ivalue+1
           CALL TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
          index_lpext(ivalue)=NXO
          value_lpext(ivalue)=-w1lp

           ivalue=ivalue+1
          index_lpext(ivalue)=NXO
          value_lpext(ivalue)=w1lp
             enddo
           enddo
        enddo
      endif


      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a

      do lmb=1,ng_sm
         ibsta=ibsm_ext(lmb)
         ibend=iesm_ext(lmb)
         do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
               lra=norb_number(ira)
               ivalue=ivalue+1
               CALL TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
               index_lpext(ivalue)=NXO
               value_lpext(ivalue)=-w1lp
            enddo
         enddo
      enddo
      nlp_value=ivalue
      end

      subroutine lp_arbl_ext_st_calcuvalue_G(lri,lrj,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ivalue=0
!G1415
      if ( logic_g1415 ) then

      w0lp=w0_plp*w0g14a
      w1lp=w1_plp*w1g14a
      ww0lp=w0_plp*w0g15a
      ww1lp=w1_plp*w1g15a

      valuelptmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=-valuelptmp1*2.d0
      valuelptmp1=ww0lp
      ww0lp=ww0lp-ww1lp
      ww1lp=-valuelptmp1*2.d0

      do ismb=1,ng_sm
         isma=mul_tab(ismb,ism_g1415)
         if ( isma .gt. ismb ) cycle
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( ismb .eq. isma )    ibsta=ibsta+1
         do ib=ibsta,ibend
            lrb=norb_number(ib)
            do ia=iasta,min(iaend,ib-1)
               lra=norb_number(ia)

               ivalue=ivalue+1
               CALL TRANS_IJKL_INTPOS(LRJ,lrb,LRI,lrb,NXO)
               index_lpext(ivalue)=NXO
               value_lpext(ivalue)=w0lp
               CALL TRANS_IJKL_INTPOS(LRJ,LRI,lrb,lrb,NXO)
               index_lpext1(ivalue)=NXO
               value_lpext1(ivalue)=w1lp

               ivalue=ivalue+1
               CALL TRANS_IJKL_INTPOS(LRJ,lra,LRI,lra,NXO)
               index_lpext(ivalue)=NXO
               value_lpext(ivalue)=ww0lp
               CALL TRANS_IJKL_INTPOS(LRJ,LRI,lra,lra,NXO)
               index_lpext1(ivalue)=NXO
               value_lpext1(ivalue)=ww1lp
            enddo
         enddo
      enddo
      endif
!G13
      if ( logic_g13 ) then
         w0lp=w0g13a*w0_plp
         do ia=1,norb_ext
            lra=norb_number(ia)

            ivalue=ivalue+1
            CALL TRANS_IJKL_INTPOS(LRJ,lra,LRI,lra,NXO)
            index_lpext(ivalue)=NXO
           value_lpext(ivalue)=w0lp
            CALL TRANS_IJKL_INTPOS(LRJ,LRI,lra,lra,NXO)
            index_lpext1(ivalue)=NXO
           value_lpext1(ivalue)=-w0lp*2.d0

            ivalue=ivalue+1
            index_lpext(ivalue)=0
            index_lpext1(ivalue)=0

         enddo
      endif

      lsmi=lsm_inn(lri)
      lsmj=lsm_inn(lrj)
      lsmij=mul_tab(lsmi,lsmj)

!G2G4a
      if ( logic_g2g4a ) then

        w0lp=w0_plp*w0g2a
        w1lp=w1_plp*w1g2a
        ww0lp=w0_plp*w0g4a
        ww1lp=w1_plp*w1g4a

        valuelptmp1=w0lp
        w0lp=w0lp-w1lp
        w1lp=-valuelptmp1*2.d0
        valuelptmp1=ww0lp
        ww0lp=ww0lp-ww1lp
        ww1lp=-valuelptmp1*2.d0

      do lsmb=1,ng_sm
        lsma=mul_tab(lsmij,lsmb)
        if ( lsma .gt. lsmb ) cycle
        ibsta=ibsm_ext(lsmb)
        ibend=iesm_ext(lsmb)
        iasta=ibsm_ext(lsma)
        iaend=iesm_ext(lsma)
        if ( lsmb .eq. lsma ) ibsta=ibsta+1
        do ib=ibsta,ibend
          LRB=norb_number(ib)
          do ia=iasta,min(iaend,ib-1)
            LRA=norb_number(ia)
!        ArBl -- B^lA^r =12
            ivalue=ivalue+1
            CALL TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
            index_lpext(ivalue)=NXO
            value_lpext(ivalue)=w0lp
            CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
            index_lpext1(ivalue)=NXO
            value_lpext1(ivalue)=w1lp
!        ArBl -- B^rA^l =11
            ivalue=ivalue+1
            CALL TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
            index_lpext(ivalue)=NXO
            value_lpext(ivalue)=ww0lp
            CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
            index_lpext1(ivalue)=NXO
            value_lpext1(ivalue)=ww1lp
                  enddo
              enddo
         enddo
      else

!G2G4b
      if ( logic_g2g4b ) then

        w0lp=w0_plp*w0g2b
        w1lp=w1_plp*w1g2b
        ww0lp=w0_plp*w0g4b
        ww1lp=w1_plp*w1g4b

        valuelptmp1=w0lp
        w0lp=w0lp-w1lp
        w1lp=-valuelptmp1*2.d0
        valuelptmp1=ww0lp
        ww0lp=ww0lp-ww1lp
        ww1lp=-valuelptmp1*2.d0

      do lsmb=1,ng_sm
        lsma=mul_tab(lsmij,lsmb)
        if ( lsma .gt. lsmb ) cycle
        ibsta=ibsm_ext(lsmb)
        ibend=iesm_ext(lsmb)
        iasta=ibsm_ext(lsma)
        iaend=iesm_ext(lsma)
        if ( lsmb .eq. lsma ) ibsta=ibsta+1
        do ib=ibsta,ibend
          LRB=norb_number(ib)
          do ia=iasta,min(iaend,ib-1)
            LRA=norb_number(ia)
!        ArBl -- B^lA^r =12
            ivalue=ivalue+1
            CALL TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
            index_lpext(ivalue)=NXO
            value_lpext(ivalue)=ww0lp
            CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
            index_lpext1(ivalue)=NXO
            value_lpext1(ivalue)=ww1lp
!        ArBl -- B^rA^l =11
            ivalue=ivalue+1
            CALL TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
            index_lpext(ivalue)=NXO
            value_lpext(ivalue)=w0lp
            CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
            index_lpext1(ivalue)=NXO
            value_lpext1(ivalue)=w1lp
                  enddo
              enddo
         enddo

      endif

      endif
!G36a

      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a
      valuelptmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=-valuelptmp1*2.d0
      do lsmb=1,ng_sm
        lsma=mul_tab(lsmij,lsmb)
        if ( lsma .gt. lsmb ) cycle
        ibsta=ibsm_ext(lsmb)
        ibend=iesm_ext(lsmb)
        iasta=ibsm_ext(lsma)
        iaend=iesm_ext(lsma)
        if ( lsmb .eq. lsma ) ibsta=ibsta+1
        do ib=ibsta,ibend
          LRB=norb_number(ib)
          do ia=iasta,min(iaend,ib-1)
            LRA=norb_number(ia)
!        ArBl -- B^lA^r =12
            ivalue=ivalue+1
            CALL TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
            index_lpext(ivalue)=NXO
            value_lpext(ivalue)=w0lp
            CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
            index_lpext1(ivalue)=NXO
            value_lpext1(ivalue)=w1lp
          enddo
        enddo
      enddo
!G36b

      w0lp=w0_plp*w0g36b
      w1lp=w1_plp*w1g36b
      valuelptmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=-valuelptmp1*2.d0
      do lsmb=1,ng_sm
        lsma=mul_tab(lsmij,lsmb)
        if ( lsma .gt. lsmb ) cycle
        ibsta=ibsm_ext(lsmb)
        ibend=iesm_ext(lsmb)
        iasta=ibsm_ext(lsma)
        iaend=iesm_ext(lsma)
        if ( lsmb .eq. lsma ) ibsta=ibsta+1
        do ib=ibsta,ibend
          LRB=norb_number(ib)
          do ia=iasta,min(iaend,ib-1)
            LRA=norb_number(ia)
            ivalue=ivalue+1
!        ArBl -- B^rA^l =11
            CALL TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
            index_lpext(ivalue)=NXO
            value_lpext(ivalue)=w0lp
            CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
            index_lpext1(ivalue)=NXO
            value_lpext1(ivalue)=w1lp
          enddo
        enddo
      enddo
      nlp_value=ivalue
      end

      subroutine lp10_arbrbr_ext_calcuvalue_G(intentry,
     :                                      isma,nlp_value)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      w0_sdplp25=(w0_sdplp-w1_sdplp)*w0g25
      w1_sdplp25=(w0_sdplp+w1_sdplp)*w0g25

      DO LRITMP=NORB_FRZ+1,norb_inn-2
         lsmi=lsm_inn(LRITMP)
         DO LRJTMP=LRITMP+1,norb_inn-1
            lsmj=lsm_inn(LRJTMP)
            lsmij=mul_tab(lsmi,lsmj)
            DO LRKTMP=LRJTMP+1,norb_inn
              lsmk=lsm_inn(LRKTMP)
               IF(mul_tab(lsmij,lsmk).NE.isma) CYCLE
               IJK=LRITMP-NORB_FRZ+NGW2(LRJTMP-NORB_FRZ)
     :                          +NGW3(LRKTMP-NORB_FRZ)
               IF(INTIND_IJKA(IJK).EQ.intentry) THEN
                  LRI=LRITMP
                  LRJ=LRJTMP
                  LRK=LRKTMP
                  GOTO 100
             ENDIF
           ENDDO
         ENDDO
      ENDDO

100   next_sta=ibsm_ext(isma)-1

      ivalue=0
      do m_ia=1,nlsm_ext(isma)
         ira=m_ia+next_sta
         LRA=norb_number(ira)
         ivalue=ivalue+1
         CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRJ,NXO)
         index_lpext(ivalue)=NXO
         value_lpext(ivalue)=w0_sdplp25
         CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRK,LRI,NXO)
         index_lpext1(ivalue)=NXO
         value_lpext1(ivalue)=w1_sdplp25
      enddo
      nlp_value=ivalue
      end

      subroutine lp11_arblbr_ext_calcuvalue_G(intentry,isma,
     :                                                nlp_value)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"


      w0_sdplp25=(w0_sdplp-w1_sdplp)*w0g25
      w1_sdplp25=-2.d0*w0_sdplp*w0g25

      DO LRITMP=NORB_FRZ+1,norb_inn-2
         lsmi=lsm_inn(LRITMP)
         DO LRJTMP=LRITMP+1,norb_inn-1
            lsmj=lsm_inn(LRJTMP)
            lsmij=mul_tab(lsmi,lsmj)
            DO LRKTMP=LRJTMP+1,norb_inn
              lsmk=lsm_inn(LRKTMP)
               IF(mul_tab(lsmij,lsmk).NE.isma) CYCLE
               IJK=LRITMP-NORB_FRZ+NGW2(LRJTMP-NORB_FRZ)
     :                          +NGW3(LRKTMP-NORB_FRZ)
               IF(INTIND_IJKA(IJK).EQ.intentry) THEN
                  LRI=LRITMP
                  LRJ=LRJTMP
                  LRK=LRKTMP
                  GOTO 100
             ENDIF
           ENDDO
         ENDDO
      ENDDO
100   next_sta=ibsm_ext(isma)-1

      ivalue=0
      do m_ia=1,nlsm_ext(isma)
         ira=m_ia+next_sta
         LRA=norb_number(ira)
         ivalue=ivalue+1
         CALL TRANS_IJKL_INTPOS(LRA,LRJ,LRK,LRI,NXO)
         index_lpext(ivalue)=NXO
         value_lpext(ivalue)=w0_sdplp25
         CALL TRANS_IJKL_INTPOS(LRA,LRK,LRJ,LRI,NXO)
         index_lpext1(ivalue)=NXO
         value_lpext1(ivalue)=w1_sdplp25
      enddo
      nlp_value=ivalue
      end

      subroutine lp12_arblbl_ext_calcuvalue_G(intentry,isma,
     :                                                nlp_value)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      w0_sdplp25=(w0_sdplp-w1_sdplp)*w0g25
      w1_sdplp25=-2.d0*w0_sdplp*w0g25

      DO LRITMP=NORB_FRZ+1,norb_inn-2
         lsmi=lsm_inn(LRITMP)
         DO LRJTMP=LRITMP+1,norb_inn-1
            lsmj=lsm_inn(LRJTMP)
            lsmij=mul_tab(lsmi,lsmj)
            DO LRKTMP=LRJTMP+1,norb_inn
              lsmk=lsm_inn(LRKTMP)
               IF(mul_tab(lsmij,lsmk).NE.isma) CYCLE
               IJK=LRITMP-NORB_FRZ+NGW2(LRJTMP-NORB_FRZ)
     :                          +NGW3(LRKTMP-NORB_FRZ)
               IF(INTIND_IJKA(IJK).EQ.intentry) THEN
                  LRI=LRITMP
                  LRJ=LRJTMP
                  LRK=LRKTMP
                  GOTO 100
             ENDIF
           ENDDO
         ENDDO
      ENDDO

100   next_sta=ibsm_ext(isma)-1

      ivalue=0
      do m_ia=1,nlsm_ext(isma)
         ira=m_ia+next_sta
         LRA=norb_number(ira)
         ivalue=ivalue+1
         CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRJ,NXO)
         index_lpext(ivalue)=NXO
         value_lpext(ivalue)=w0_sdplp25
         CALL TRANS_IJKL_INTPOS(LRA,LRK,LRJ,LRI,NXO)
         index_lpext1(ivalue)=NXO
         value_lpext1(ivalue)=w1_sdplp25
      enddo
      nlp_value=ivalue
      end

      subroutine lp9_drlbl_ext_calcuvalue_G(lri,lrk,isma)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      next_sta=ibsm_ext(isma)-1
      w0_sdplp25=(w0_sdplp-w1_sdplp)*w0g25
      w1_sdplp25=-2.d0*w0_sdplp*w0g25

      ivalue=0

      do m_ia=1,nlsm_ext(isma)
          ira=m_ia+next_sta
          LRA=norb_number(ira)
          ivalue=ivalue+1
          CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          index_lpext(ivalue)=NXO
          value_lpext(ivalue)=w0_sdplp25
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          index_lpext1(ivalue)=NXO
          value_lpext1(ivalue)=w1_sdplp25
      enddo
      end

      subroutine lp8_drlbr_sum_calcuvalue_G(lri,LRK,isma,nv)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      next_sta=ibsm_ext(isma)-1

      w0_sdplp25=w0_sdplp*w0g25
      w1_sdplp25=2*w0_sdplp*w0g25

      ivalue=0
      do m_ia=1,nlsm_ext(isma)
          ira=m_ia+next_sta
          LRA=norb_number(ira)
          ivalue=ivalue+1
          CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          index_lpext(ivalue)=NXO
          value_lpext(ivalue)=w0_sdplp25
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          index_lpext1(ivalue)=NXO
          value_lpext1(ivalue)=-w1_sdplp25
      enddo
      nv=ivalue
      end

      subroutine lp9_drlbl_sum_calcuvalue_G(lri,LRK,isma,nv)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      next_sta=ibsm_ext(isma)-1
      w0_sdplp25=w0_sdplp*w0g25
      w1_sdplp25=-2.d0*w0_sdplp*w0g25

      ivalue=0
      do m_ia=1,nlsm_ext(isma)
          ira=m_ia+next_sta
          LRA=norb_number(ira)
          ivalue=ivalue+1
          CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
          index_lpext(ivalue)=NXO
          value_lpext(ivalue)=w0_sdplp25
          CALL TRANS_IJKL_INTPOS(LRA,LRI,LRK,LRK,NXO)
          index_lpext1(ivalue)=NXO
          value_lpext1(ivalue)=w1_sdplp25
      enddo
      nv=ivalue
      end


      subroutine gsd_ext_sequence_G(iltype,ilsm,irsm,lri)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *      m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ismnodes=ilsm
      ismnoded=irsm
      ismsd=mul_tab(ismnodes,ismnoded)
      indl=0 !?
      if(iltype.eq.2)indl= 1+ismnodes
      if(iltype.eq.3)indl= 9+ismnodes
      if(iltype.eq.4)indl=17+ismnodes
      ilnodedownwei=iseg_downwei(indl)
      isegdownwei  =ilnodedownwei
      icano_nnsta=1
      icnt_base=0
      icsta=ibsm_ext(ismnoded)
      icend=iesm_ext(ismnoded)
      m_jc=0

      do ic=icsta,icend
            m_jd=ic
            m_jc=ic-icsta+1
            icano_nn=m_jc
            icano_nnend=icano_nn
            do ismb=1,ismnoded-1
                  isma=mul_tab(ismnodes,ismb)
                  if ( isma .gt. ismb ) cycle
                  call g31_diffsym_G(lri,isma,ismb)
            enddo

            ismb=ismnoded
            isma=mul_tab(ismnodes,ismb)
            if ( isma .eq. ismb ) then
               call gsd_samesym_aaa_G(lri,isma)
            elseif ( isma .lt. ismb ) then
               call gsd_diffsamesym_abb_G(lri,isma,ismb)
            endif

            do ismb=ismnoded+1,ng_sm
                  isma=mul_tab(ismnodes,ismb)
                  if ( isma .gt. ismb ) cycle
                  if ( ismnoded .gt. isma ) then
                     call g32a_diffsym_G(lri,isma,ismb)
                  elseif ( ismnoded .eq. isma ) then
                    call gsd_diffsamesym_aab_G(lri,isma,ismb)
                  else
                     call g32b_diffsym_G(lri,isma,ismb)
                  endif
            enddo

            if ( ismnodes.eq.1 .and. iltype.eq.4 ) then
                  call gsd_arlp_s1_G(lri)
            endif
            icnt_base=icnt_base+ilnodedownwei
      enddo
      end


      subroutine lp678_ext_calcuvalue_G(lri,lrk,isma,nlp_value)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"

      w0_sdplp25=w0_sdplp*w0g25
      ilpvalue=0
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      do ia=iasta,iaend
         LRA=norb_number(ia)
         ilpvalue=ilpvalue+1
         CALL TRANS_IJKL_INTPOS(LRA,LRK,LRI,LRK,NXO)
         index_lpext(ilpvalue)=NXO
         value_lpext(ilpvalue)=w0_sdplp25
         index_lpext1(ilpvalue)=0
      enddo
      nlp_value=nlsm_ext(isma)
      end


      subroutine lp_ar_coe_calcuvalue_G
     *          (idtu,isma,lri,lrj,nlp_value,lpcoe,nlp_value1)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      COMMON /IAIB/ ICAN_A(MAX_ORB),ICAN_B(MTMP+MAX_ORB)
      dimension lpcoe(norb_dz+1:norb_inn)

      next_sta=ibsm_ext(isma)-1
      w0_sdplp25=w0_sdplp*w0g25
      ilpvalue=0

      if(idtu.eq.100) then
        lsta=lri
        lend=norb_inn
        ilpvalue1=0
        do m_ia=1,nlsm_ext(isma)
          ira=m_ia+next_sta
          lra=norb_number(ira)
          NIA=ICAN_A(LRA)+LRI
          ilpvalue=ilpvalue+1
          index_lpext5(ilpvalue)=NIA
          value_lpext5(ilpvalue)=w0_sdplp25

          ilpvalue1=0
          do iorb=lsta,lend
            KCOE=lpcoe(iorb)
            CALL NEOC(KCOE,NOCC,TCOE)

            ilpvalue1=ilpvalue1+1
            CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
            index_lpext3(ilpvalue,ilpvalue1)=NXO
            value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25*nocc*tcoe
            CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
            index_lpext4(ilpvalue,ilpvalue1)=NXO
            value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*nocc

          enddo
        enddo
        nlp_value=nlsm_ext(isma)
        nlp_value1=ilpvalue1
        return
      endif

      if(idtu.eq.51) then
         lsta=lri
         lend=norb_DZ
         ilpvalue1=0
      do m_ia=1,nlsm_ext(isma)
          ira=m_ia+next_sta
            lra=norb_number(ira)
            NIA=ICAN_A(LRA)+LRI
            ilpvalue=ilpvalue+1
            index_lpext5(ilpvalue)=NIA
            value_lpext5(ilpvalue)=w0_sdplp25

           ilpvalue1=0
            if(LOGIC_DH) then
            ilpvalue1=ilpvalue1+1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
            index_lpext3(ilpvalue,ilpvalue1)=NXO
            value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25
            index_lpext4(ilpvalue,ilpvalue1)=0

              do idorb=lsta+1,lend
                 ilpvalue1=ilpvalue1+1
                 CALL TRANS_IJKL_INTPOS(LRA,idorb,LRI,idorb,NXO)
                 index_lpext3(ilpvalue,ilpvalue1)=NXO
                 value_lpext3(ilpvalue,ilpvalue1)=-w0_sdplp25
                 CALL TRANS_IJKL_INTPOS(LRA,LRI,idorb,idorb,NXO)
                 index_lpext4(ilpvalue,ilpvalue1)=NXO
                 value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*2.D0

              enddo
            endif
            iorbs=max(norb_dz+1,lri)
            do iorb=iorbs,norb_inn
              Kcoe=lpcoe(iorb)
              CALL NEOC(KCOE,NOCC,TCOE)
              ilpvalue1=ilpvalue1+1
              CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
              index_lpext3(ilpvalue,ilpvalue1)=NXO
              value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25*nocc*tcoe
              CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
              index_lpext4(ilpvalue,ilpvalue1)=NXO
              value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*nocc
            enddo
        enddo
        nlp_value=nlsm_ext(isma)
        nlp_value1=ilpvalue1
        return
      endif

      if(idtu.eq.25.or.idtu.eq.43) then
      ilpvalue1=0
      do m_ia=1,nlsm_ext(isma)
         ira=m_ia+next_sta
         lra=norb_number(ira)
         NIA=ICAN_A(LRA)+LRI
         ilpvalue=ilpvalue+1
         index_lpext5(ilpvalue)=NIA
         value_lpext5(ilpvalue)=w0_sdplp25

         ilpvalue1=0

         ilpvalue1=ilpvalue1+1
         CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
         index_lpext3(ilpvalue,ilpvalue1)=NXO
         value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25
         index_lpext4(ilpvalue,ilpvalue1)=0

        do idorb=lri+1,norb_dz
           ilpvalue1=ilpvalue1+1
           CALL TRANS_IJKL_INTPOS(LRA,idorb,LRI,idorb,NXO)
           index_lpext3(ilpvalue,ilpvalue1)=NXO
           value_lpext3(ilpvalue,ilpvalue1)=-w0_sdplp25
           CALL TRANS_IJKL_INTPOS(LRA,LRI,idorb,idorb,NXO)
           index_lpext4(ilpvalue,ilpvalue1)=NXO
           value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*2.D0
        enddo
        iorbs=max(norb_dz+1,lri)
        do iorb=iorbs,norb_inn
          Kcoe=lpcoe(iorb)
          CALL NEOC(KCOE,NOCC,TCOE)
          ilpvalue1=ilpvalue1+1
          CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
          index_lpext3(ilpvalue,ilpvalue1)=NXO
          value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25*nocc*tcoe
          CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
          index_lpext4(ilpvalue,ilpvalue1)=NXO
          value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*nocc
        enddo
      enddo
      nlp_value=nlsm_ext(isma)
      nlp_value1=ilpvalue1
      return
      endif

      if(idtu.eq.26) then
         lsta=lri
         lend=norb_DZ
         ilpvalue1=0
        do m_ia=1,nlsm_ext(isma)
          ira=m_ia+next_sta
          lra=norb_number(ira)
          NIA=ICAN_A(LRA)+LRI
          ilpvalue=ilpvalue+1
          index_lpext5(ilpvalue)=NIA
          value_lpext5(ilpvalue)=w0_sdplp25

         ilpvalue1=0

          if(LOGIC_DH) then
            do idorb=lsta+1,lend
               ilpvalue1=ilpvalue1+1
               CALL TRANS_IJKL_INTPOS(LRA,idorb,LRI,idorb,NXO)
               index_lpext3(ilpvalue,ilpvalue1)=NXO
               value_lpext3(ilpvalue,ilpvalue1)=-w0_sdplp25
               CALL TRANS_IJKL_INTPOS(LRA,LRI,idorb,idorb,NXO)
               index_lpext4(ilpvalue,ilpvalue1)=NXO
               value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*2.D0
            enddo
          endif
          do iorb=norb_dz+1,norb_inn
              Kcoe=lpcoe(iorb)
              CALL NEOC(KCOE,NOCC,TCOE)
              ilpvalue1=ilpvalue1+1
              CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
              index_lpext3(ilpvalue,ilpvalue1)=NXO
              value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25*nocc*tcoe
              CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
              index_lpext4(ilpvalue,ilpvalue1)=NXO
              value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*nocc
          enddo
        enddo
        nlp_value=nlsm_ext(isma)
        nlp_value1=ilpvalue1
      return
      endif
      if(idtu.eq.28.OR.idtu.eq.46) then
      nsorb=1
      ndorb=norb_DZ-lri-1
        icoe=0
        if(ndorb.gt.0) nsorb=1
        if(idtu.eq.28) icoe=-(JB_SYS+2)
        if(idtu.eq.46) icoe=0
        ilpvalue1=0
        do m_ia=1,nlsm_ext(isma)
            ira=m_ia+next_sta
            lra=norb_number(ira)
            NIA=ICAN_A(LRA)+LRI
            ilpvalue=ilpvalue+1
            index_lpext5(ilpvalue)=NIA
            value_lpext5(ilpvalue)=w0_sdplp25

              ilpvalue1=0

            ilpvalue1=ilpvalue1+1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
            index_lpext3(ilpvalue,ilpvalue1)=NXO
            value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25
            index_lpext4(ilpvalue,ilpvalue1)=0

            if(nsorb.gt.0) then
              do iorb=lri+1,norb_dz
                 if(iorb.eq.lrj) THEN
                    ilpvalue1=ilpvalue1+1
                    CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
                    index_lpext3(ilpvalue,ilpvalue1)=NXO
                    value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25*icoe
                    CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
                    index_lpext4(ilpvalue,ilpvalue1)=NXO
                    value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25
                ENDIF
                 if(iorb.ne.lrj) THEN
                    ilpvalue1=ilpvalue1+1
                    CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
                    index_lpext3(ilpvalue,ilpvalue1)=NXO
                    value_lpext3(ilpvalue,ilpvalue1)=-w0_sdplp25
                    CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
                    index_lpext4(ilpvalue,ilpvalue1)=NXO
                    value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*2.D0
                 ENDIF
              enddo
            endif
            do iorb=norb_dz+1,norb_inn
              Kcoe=lpcoe(iorb)
              CALL NEOC(KCOE,NOCC,TCOE)
              ilpvalue1=ilpvalue1+1
              CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
              index_lpext3(ilpvalue,ilpvalue1)=NXO
              value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25*nocc*tcoe
              CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
              index_lpext4(ilpvalue,ilpvalue1)=NXO
              value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*nocc
            enddo
        enddo
        nlp_value=nlsm_ext(isma)
        nlp_value1=ilpvalue1
      return
      endif
      if(idtu.eq.57.or.idtu.eq.29) then
      nsorb=1
      ndorb=norb_DZ-lri-1
        if(ndorb.gt.0) nsorb=1
        if(idtu.eq.29) then
          icoe=JB_SYS
        else ! if(idtu.eq.57)
          icoe=-1
        endif
        ilpvalue1=0
        do m_ia=1,nlsm_ext(isma)
            ira=m_ia+next_sta
            lra=norb_number(ira)
            NIA=ICAN_A(LRA)+LRI
            ilpvalue=ilpvalue+1
            index_lpext5(ilpvalue)=NIA
            value_lpext5(ilpvalue)=w0_sdplp25

              ilpvalue1=0

            ilpvalue1=ilpvalue1+1
            CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
            index_lpext3(ilpvalue,ilpvalue1)=NXO
            value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25
            index_lpext4(ilpvalue,ilpvalue1)=0

            if(nsorb.gt.0) then
              do iorb=lri+1,norb_dz
                 if(iorb.eq.lrj) THEN
                    ilpvalue1=ilpvalue1+1
                    CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
                    index_lpext3(ilpvalue,ilpvalue1)=NXO
                    value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25*icoe
                    CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
                    index_lpext4(ilpvalue,ilpvalue1)=NXO
                    value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25
                ENDIF
                 if(iorb.ne.lrj) THEN
                    ilpvalue1=ilpvalue1+1
                    CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
                    index_lpext3(ilpvalue,ilpvalue1)=NXO
                    value_lpext3(ilpvalue,ilpvalue1)=-w0_sdplp25
                    CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
                    index_lpext4(ilpvalue,ilpvalue1)=NXO
                    value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*2.D0
                 ENDIF
              enddo
            endif

            do iorb=norb_dz+1,norb_inn
              Kcoe=lpcoe(iorb)
              CALL NEOC(KCOE,NOCC,TCOE)
              ilpvalue1=ilpvalue1+1
              CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
              index_lpext3(ilpvalue,ilpvalue1)=NXO
              value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25*nocc*tcoe
              CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
              index_lpext4(ilpvalue,ilpvalue1)=NXO
              value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*nocc
            enddo
        enddo
        nlp_value=nlsm_ext(isma)
        nlp_value1=ilpvalue1
      return
      endif
!=====================
      if(idtu.eq.55.or.idtu.eq.73) then    !(11)(23)=55 (11)(13)=75
      ilpvalue1=0
      do m_ia=1,nlsm_ext(isma)
         ira=m_ia+next_sta
         lra=norb_number(ira)
         NIA=ICAN_A(LRA)+LRI
         ilpvalue=ilpvalue+1
         index_lpext5(ilpvalue)=NIA
         value_lpext5(ilpvalue)=w0_sdplp25

         ilpvalue1=0

         ilpvalue1=ilpvalue1+1
         CALL TRANS_IJKL_INTPOS(LRA,LRI,LRI,LRI,NXO)
         index_lpext3(ilpvalue,ilpvalue1)=NXO
         value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25
         index_lpext4(ilpvalue,ilpvalue1)=0
        do idorb=lri+1,norb_dz
           ilpvalue1=ilpvalue1+1
           CALL TRANS_IJKL_INTPOS(LRA,idorb,LRI,idorb,NXO)
           index_lpext3(ilpvalue,ilpvalue1)=NXO
           value_lpext3(ilpvalue,ilpvalue1)=-w0_sdplp25
           CALL TRANS_IJKL_INTPOS(LRA,LRI,idorb,idorb,NXO)
           index_lpext4(ilpvalue,ilpvalue1)=NXO
           value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*2.D0
        enddo
        iorbs=max(norb_dz+1,lri)
        do iorb=iorbs,norb_inn
          Kcoe=lpcoe(iorb)
          CALL NEOC(KCOE,NOCC,TCOE)
          ilpvalue1=ilpvalue1+1
          CALL TRANS_IJKL_INTPOS(LRA,iorb,LRI,iorb,NXO)
          index_lpext3(ilpvalue,ilpvalue1)=NXO
          value_lpext3(ilpvalue,ilpvalue1)=w0_sdplp25*nocc*tcoe
          CALL TRANS_IJKL_INTPOS(LRA,LRI,iorb,iorb,NXO)
          index_lpext4(ilpvalue,ilpvalue1)=NXO
          value_lpext4(ilpvalue,ilpvalue1)=w0_sdplp25*nocc
        enddo
      enddo
      nlp_value=nlsm_ext(isma)
      nlp_value1=ilpvalue1
      return
      endif

      end


      subroutine lp_arbl_ext_dd_calcuvalue_G(lri,lrj,
     :                                 iml,imr,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      nlbf=ibsm_ext(iml)
      nlef=iesm_ext(iml)
      nrbf=ibsm_ext(imr)
      nref=iesm_ext(imr)

      w0lp=w0_plp*w0gdd
      w1lp=w1_plp*w1gdd
      valuetmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=-valuetmp1*2.d0
      ivalue=0
!G50
      if ( logic_g50 ) then
       if ( logic_g49b) then

         do ira=nlbf,nlef
           lra=norb_number(ira)
         ivalue=ivalue+1
         CALL TRANS_IJKL_INTPOS(lrj,lra,lri,lra,NXO)
         index_lpext(ivalue)=NXO
         value_lpext(ivalue)=w0lp
         CALL TRANS_IJKL_INTPOS(lrj,lri,lra,lra,NXO)
         index_lpext1(ivalue)=NXO
         value_lpext1(ivalue)=w1lp
        enddo
       endif


      ivalue=ivalue+int_dd_drl

       do irb=nlbf,nlef
          lrb=norb_number(irb)
C            lsmb=lsm(irb)
          do ira=nlbf,irb-1
             lra=norb_number(ira)
C             lsma=lsm(ira)
C             lsmba=mul_tab(lsmb,lsma)
             ivalue=ivalue+1
             CALL TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
             index_lpext(ivalue)=NXO
             value_lpext(ivalue)=w0lp
             CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
             index_lpext1(ivalue)=NXO
             value_lpext1(ivalue)=w1lp
          enddo
       enddo
       do irb=nlbf,nlef
          lrb=norb_number(irb)
C          lsmb=lsm(irb)
          do ira=nlbf,irb-1
             lra=norb_number(ira)
C             lsma=lsm(ira)
C             lsmba=mul_tab(lsmb,lsma)
             ivalue=ivalue+1
             CALL TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
             index_lpext(ivalue)=NXO
             value_lpext(ivalue)=w0lp
             CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
             index_lpext1(ivalue)=NXO
             value_lpext1(ivalue)=w1lp
          enddo
       enddo

      else
       ivalue=ivalue+int_dd_drl
       if (logic_g49a ) then
!G49a:Bl_Ar  line=12
       do irb=nrbf,nref
          lrb=norb_number(irb)
          do ira=nlbf,nlef
             lra=norb_number(ira)

             ivalue=ivalue+1
             CALL TRANS_IJKL_INTPOS(lra,lri,lrj,lrb,NXO)
             index_lpext(ivalue)=NXO
             value_lpext(ivalue)=w0lp
             CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
             index_lpext1(ivalue)=NXO
             value_lpext1(ivalue)=w1lp
          enddo
       enddo
       else
!G49b:Br_Al  line=11
       do irb=nlbf,nlef
          lrb=norb_number(irb)
          do ira=nrbf,nref
             lra=norb_number(ira)

             ivalue=ivalue+1
             CALL TRANS_IJKL_INTPOS(lra,lrj,lrb,lri,NXO)
             index_lpext(ivalue)=NXO
             value_lpext(ivalue)=w0lp
             CALL TRANS_IJKL_INTPOS(lra,lrb,lrj,lri,NXO)
             index_lpext1(ivalue)=NXO
             value_lpext1(ivalue)=w1lp
          enddo
       enddo
       endif
      endif
      nlp_value=ivalue
      end


      subroutine lp_drl_ext_dd_calcuvalue_G(lri,iml,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      w0lp=w0_plp*w0gdd
      w1lp=w1_plp*w1gdd
      nliml=nlsm_ext(iml)
      iasta=ibsm_ext(iml)
      iaend=iesm_ext(iml)

      ivalue=0
      if(.not.logic_g49b) goto 100
      DO ira=iasta,iaend
         lra=norb_number(ira)
         ivalue=ivalue+1
         CALL TRANS_IJKL_INTPOS(lra,LRI,lra,LRI,NXO)
         index_lpext(ivalue)=NXO
         value_lpext(ivalue)=-w1lp*2.0D0
         index_lpext1(ivalue)=0
      ENDDO
100   mloop=nliml*(nliml-1)/2

      ivalue=ivalue+int_dd_drl
      jvalue=0
      do irb=iasta,iaend
         lrb=norb_number(irb)
         do ira=iasta,irb-1
            lra=norb_number(ira)
            ivalue=ivalue+1
            jvalue=ivalue+mloop
            CALL TRANS_IJKL_INTPOS(lra,LRI,lrb,LRI,NXO)
            index_lpext(ivalue)=NXO
            value_lpext(ivalue)=w0lp-w1lp
            index_lpext(jvalue)=index_lpext(ivalue)
            value_lpext(jvalue)=value_lpext(ivalue)

            CALL TRANS_IJKL_INTPOS(lra,lrb,LRI,LRI,NXO)
            index_lpext1(ivalue)=NXO
            value_lpext1(ivalue)=-2.0D0*w0lp
            index_lpext1(jvalue)=index_lpext1(ivalue)
            value_lpext1(jvalue)=value_lpext1(ivalue)
         enddo
      enddo
      nlp_value=jvalue
      end

      subroutine lp_arbr_ext_svtv_calcuvalue_G(LRI,LRJ,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ivalue=0
      lsmi=lsm_inn(lri)
      lsmj=lsm_inn(lrj)
      lsmij=mul_tab(lsmi,lsmj)
!G36a
      w0lp=w0_plp*w0g36a
      w1lp=w1_plp*w1g36a
      valuelptmp1=w0lp
      w0lp=w0lp-w1lp
      w1lp=valuelptmp1+w1lp
!        ArBr -- B^rA^r =10
      do lsmc=1,ng_sm
        lsmd=mul_tab(lsmij,lsmc)
        if ( lsmd .gt. lsmc ) cycle
        icsta=ibsm_ext(lsmc)
        icend=iesm_ext(lsmc)
        idsta=ibsm_ext(lsmd)
        idend=iesm_ext(lsmd)
        if ( lsmc .eq. lsmd ) icsta=icsta+1
        do ic=icsta,icend
          jc=norb_number(ic)
          do id=idsta,min(idend,ic-1)
             jd=norb_number(id)
             ivalue=ivalue+1
             CALL TRANS_IJKL_INTPOS(jd,lri,lrj,jc,NXO)
             index_lpext(ivalue)=NXO
             value_lpext(ivalue)=w0lp
             CALL TRANS_IJKL_INTPOS(jd,lrj,jc,lri,NXO)
             index_lpext1(ivalue)=NXO
             value_lpext1(ivalue)=w1lp
          enddo
        enddo
      enddo
!G36b
!G1415
      if ( logic_g13 ) then

      w0lp=w0g13a*(w0_plp+w1_plp)
      do ic=1,norb_ext
         lrc=norb_number(ic)
         ivalue=ivalue+1
         CALL TRANS_IJKL_INTPOS(lrj,lrc,lri,lrc,NXO)
         index_lpext(ivalue)=NXO
         value_lpext(ivalue)=w0lp
         index_lpext1(ivalue)=0
      enddo
      endif
      nlp_value=ivalue
      end

      subroutine lp_drr_ext_svtv_calcuvalue_G(lri,nlp_value)
#include "drt_h.fh"
#include "lpextmode_h.fh"
#include "intsort_h.fh"

      ivalue=0
!G36a
      w0lp=(w0_plp+w1_plp)*w0g36a
      do lmb=1,ng_sm
         ibsta=ibsm_ext(lmb)
         ibend=iesm_ext(lmb)
         do irb=ibsta,ibend
            lrb=norb_number(irb)
            do ira=ibsta,irb-1
              lra=norb_number(ira)
              ivalue=ivalue+1
              CALL TRANS_IJKL_INTPOS(lra,lri,lrb,lri,NXO)
              index_lpext(ivalue)=NXO
              value_lpext(ivalue)=w0lp
              index_lpext1(ivalue)=0
            enddo
         enddo
      enddo

      if ( logic_g13 ) then
C===================================
C  Drr-DRR
C  w0lp=2.0D0*w0lp but not 1.0D0*w0lp is based on that the non-diagonal
C  just uses the non-triangle <Ci|H|Cj> which designates that I > J.

        w0lp=0.5d0*w0_plp*w0g13a
        w0lp=2.0d0*w0lp
        do LRA=NORB_ALL,NORB_INN+1,-1
           ivalue=ivalue+1
           CALL TRANS_IJKL_INTPOS(LRA,lri,LRA,lri,NXO)
           index_lpext(ivalue)=NXO
           value_lpext(ivalue)=w0lp
           index_lpext1(ivalue)=0
        enddo
      endif
      nlp_value=ivalue
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  Geogen
*
*> @brief
*>   Generate the new configuration in typical random manner
*> @author A. Ohrn
*>
*> @details
*> The creator of random geometries in typical Monte-Carlo fashion.
*> The changes made are:
*>
*> 1. The dielectric radius is modified
*> 2. Each coordinate *except* the \c iSta-1 -th molecule is changed
*> 3. All molecules (with the above exception) are rotated around the oxygen (which approximately equals the CM)
*> 4. Every molecule except the fixed ones are rotated slightly around one of the global \f$ x \f$-, \f$ y \f$- or \f$ z \f$-axes;
*>    the purpose of this is to emulate a rotation of the central molecule and therefore make the system more dynamic.
*>
*> @param[in,out] Ract  The dielectric radius on input and the slightly perturbed radius on output
*> @param[out]    Rold  Stores the input dielectric radius
*> @param[in]     iCNum How many solvent places that are taken up by the QM-molecule
************************************************************************
      Subroutine Geogen(Ract,Rold,iCNum,iQ_Atoms)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qmcom.fh"
#include "qminp.fh"

      Dimension Dq(3)
      External Ranf
*------------------------------------------------------------------------*
* Store old configuration.                                               *
*------------------------------------------------------------------------*
      Do 12,i=1,nPart*nCent
        Do 13,j=1,3
          OldGeo(i,j)=Cordst(i,j)
13      Continue
12    Continue
*------------------------------------------------------------------------*
* Query which type of simulation this is, and if quantum then change     *
* the quantum molecule.                                                  *
*------------------------------------------------------------------------*
      If(Qmeq.or.QmProd) then !Which coordinates to keep fixed.
        iSta=iCNum+1  !This sees to that the QM-molecule is excluded
                    !from the moves below.
        Dq(1)=delX*(ranf(iseed)-0.5)
        Dq(2)=delX*(ranf(iseed)-0.5)
        Dq(3)=delX*(ranf(iseed)-0.5)
        Do 21,iAt=1,iQ_Atoms
          Do 22,ii=1,3
            Cordst(iAt,ii)=Cordst(iAt,ii)+Dq(ii) !Move QM-mol.
22        Continue
21      Continue
      Endif
*-----------------------------------------------------------------------*
* Obtain the random-stuff and make small geometry change.               *
*-----------------------------------------------------------------------*
      Rold=Ract
      Ract=Ract+(ranf(iseed)-0.5)*DelR !Change in cavity radius
      Do 100, i=iSta,nPart !Which molecules to give new coordinates.
        ij=(i-1)*nCent
        Do 101, j=1,3
          Dx=DelX*(ranf(iseed)-0.5)
          Do 102, k=1,nCent
            ii=ij+k
            Cordst(ii,j)=Cordst(ii,j)+Dx  !Make translation
102       Continue
101     Continue
        Cx=Cordst(ij+1,1)  !The oxygen, around which we rotate
        Cy=Cordst(ij+1,2)
        Cz=Cordst(ij+1,3)
        B=(ranf(iseed)-0.5)*DelFi
        CB=Cos(B)
        SB=Sin(B)
        Do 111, k=2,nCent !Rotate around the oxygen in yz-plane, i.e.
          y=Cordst(ij+k,2)-Cy   !around x-axis.
          z=Cordst(ij+k,3)-Cz
          yNy=y*CB+z*SB  !This is a rotation matrix
          zNy=z*CB-y*SB
          Cordst(ij+k,2)=yNy+Cy
          Cordst(ij+k,3)=zNy+Cz
111     Continue
        B=(ranf(iseed)-0.5)*DelFi
        CB=Cos(B)
        SB=Sin(B)
        Do 112, k=2,nCent !And now rotate in xz-plane
          x=Cordst(ij+k,1)-Cx
          z=Cordst(ij+k,3)-Cz
          xNy=x*CB+z*SB
          zNy=z*CB-x*SB
          Cordst(ij+k,1)=xNy+Cx
          Cordst(ij+k,3)=zNy+Cz
112     Continue
        B=(ranf(iseed)-0.5)*DelFi
        CB=Cos(B)
        SB=Sin(B)
        Do 113, k=2,nCent  !To your surprise, here we rotate in the
          x=Cordst(ij+k,1)-Cx !xy-plane.
          y=Cordst(ij+k,2)-Cy
          xNy=x*CB+y*SB
          yNy=y*CB-x*SB
          Cordst(ij+k,1)=xNy+Cx
          Cordst(ij+k,2)=yNy+Cy
113     Continue
100   Continue
*Here all other water molecules rotate around one of the three axes,
*except the ones we fix, which in a qm-simulation is the
*quantum particle.
      A=ranf(iseed)
      B=(ranf(iseed)-0.5)*DelFi*0.1
      CB=Cos(B)
      SB=Sin(B)
      If(A.le.0.33333333) then  !make it random whether we rotate around
                                !x, y or z.
        Do 201, i=iSta,nPart
          ij=(i-1)*nCent
          Do 202, k=1,nCent
            ii=ij+k
            Cy=Cordst(ii,2)
            Cz=Cordst(ii,3)
            Cordst(ii,2)=Cy*CB+Cz*SB
            Cordst(ii,3)=Cz*CB-Cy*SB
202       Continue
201     Continue
      Else
        If(A.le.0.66666667) then
          Do 211, i=iSta,nPart
            ij=(i-1)*nCent
            Do 212, k=1,nCent
              ii=ij+k
              Cx=Cordst(ii,1)
              Cz=Cordst(ii,3)
              Cordst(ii,1)=Cx*CB+Cz*SB
              Cordst(ii,3)=CB*Cz-SB*Cx
212         Continue
211       Continue
        Else
          Do 221, i=iSta,nPart
            ij=(i-1)*nCent
            Do 222, k=1,nCent
              ii=ij+k
              Cx=Cordst(ii,1)
              Cy=Cordst(ii,2)
              Cordst(ii,1)=Cx*CB+Cy*SB
              Cordst(ii,2)=CB*Cy-SB*Cx
222         Continue
221       Continue
        Endif
      Endif
*---------------------------------------------------------------------*
* Generate the image points that correspond with the new coordinates. *
* We follow Friedman. Since no image is created here for the qm-      *
* molecule, start with query.                                         *
*---------------------------------------------------------------------*
      Ind=0    !The SM-defaults.
      iImage=1
      If(Qmeq.or.QmProd) then
        Ind=iCNum*nCent  !Makes sure that the first slots in CordIm
                         !are empty
        iImage=iSta
      Endif
      iQsta=nCent-nCha+1
      A2=Ract**2
      DiFac=-(DiEl-1.0)/(DiEl+1.0)
      Do 301, i=1,3
        xyzMyp(i)=0
301   Continue
      Do 302, i=iImage,nPart
        Do 303, j=1,nCent
          Ind=Ind+1
          S2=0
          Do 304, k=1,3
            S2=S2+Cordst(Ind,k)**2
304       Continue
          S2=A2/S2
          Sqrts2=Sqrt(S2)
          Sqrs(Ind)=Sqrts2
          If(j.le.nPol) then
            QImp(Ind)=0
            Do 305, k=1,3
              Dim(Ind,k)=0
305         Continue
          Endif
          If(j.ge.iQsta) then
            qq=Qsta(j-nCent+nCha)
            q=DiFac*Sqrts2*qq
            Qim(Ind)=q
          Else
            qq=0
            Qim(Ind)=0
          Endif
          Do 306, k=1,3
            xyzMyp(k)=xyzMyp(k)-qq*Cordst(Ind,k) !Total dipole of
                              !the cavity; used in polink.f.
            CordIm(Ind,k)=Cordst(Ind,k)*S2
306       Continue
303     Continue
302   Continue
*-----------------------------------------------------------------------*
* Exit.                                                                 *
*-----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine read_formatted_aniso(input_file_name,nss,nstate,multiplicity,eso,esfs,U,MM,MS,ML,DM,ANGMOM,EDMOM,AMFI,HSO)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero, gElectron
use Definitions, only: wp, iwp, u6

implicit none
character(len=180), intent(in) :: input_file_name
integer(kind=iwp), intent(inout) :: nss, nstate
integer(kind=iwp), intent(out) :: multiplicity(nstate)
real(kind=wp), intent(out) :: eso(nss), esfs(nstate), angmom(3,nstate,nstate), edmom(3,nstate,nstate), amfi(3,nstate,nstate)
complex(kind=wp), intent(out) :: U(nss,nss), MM(3,nss,nss), MS(3,nss,nss), ML(3,nss,nss), DM(3,nss,nss), HSO(nss,nss)
integer(kind=iwp) :: j, j1, j2, l, LuAniso
real(kind=wp), allocatable :: tmpI(:,:), tmpR(:,:)
real(kind=wp), parameter :: g_e = -gElectron
integer(kind=iwp), external :: IsFreeUnit

#ifdef _DEBUGPRINT_
write(u6,'(A)') 'Entering read_formatted_aniso'
call xFlush(u6)
#endif
! set to zero all arrays:
multiplicity(:) = 0
eso(:) = Zero
esfs(:) = Zero
angmom(:,:,:) = Zero
edmom(:,:,:) = Zero
amfi(:,:,:) = Zero
U(:,:) = cZero
MM(:,:,:) = cZero
MS(:,:,:) = cZero
ML(:,:,:) = cZero
DM(:,:,:) = cZero
HSO(:,:) = cZero
! read the file "aniso.input":
LuAniso = IsFreeUnit(81)
call molcas_open(LuAniso,trim(input_file_name))
! compatibility with the present version: of aniso_i.input file
read(LuAniso,*) nstate,nss
#ifdef _DEBUGPRINT_
write(u6,'(A,2I6)') 'nstate, nss:',nstate,nss
call xFlush(u6)
#endif
read(LuAniso,*) (eso(j),j=1,nss)
#ifdef _DEBUGPRINT_
write(u6,'(A)') 'ESO:'
write(u6,'(5ES24.14)') (eso(j),j=1,nss)
#endif
read(LuAniso,*) (multiplicity(j),j=1,nstate)
#ifdef _DEBUGPRINT_
write(u6,'(A)') '(multiplicity(j),j=1,nstate)'
write(u6,'(50I3)') (multiplicity(j),j=1,nstate)
call xFlush(u6)
#endif

call mma_allocate(tmpR,nss,nss,'tmpR')
call mma_allocate(tmpI,nss,nss,'tmpI')
! magnetic moment
do l=1,3
  do j1=1,nss
    read(LuAniso,*) (tmpR(j1,j2),tmpI(j1,j2),j2=1,nss)
  end do
  MM(l,1:nss,1:nss) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)
  call xFlush(u6)
end do

! spin moment
do l=1,3
  do j1=1,nss
    read(LuAniso,*) (tmpR(j1,j2),tmpI(j1,j2),j2=1,nss)
  end do
  MS(l,1:nss,1:nss) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)
end do

! spin-free energies
read(LuAniso,*) (esfs(j),j=1,nstate)
#ifdef _DEBUGPRINT_
write(u6,'(A)') 'ESFS:'
write(u6,'(5ES24.14)') (esfs(j),j=1,nstate)
#endif

! U matrix
do j1=1,nss
  read(LuAniso,*) (tmpR(j1,j2),tmpI(j1,j2),j2=1,nss)
end do

U(1:nss,1:nss) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)

! angmom
do l=1,3
  do j1=1,nstate
    read(LuAniso,*) (angmom(l,j1,j2),j2=1,nstate)
  end do
end do

! compute the orbital moment
ML(:,1:nss,1:nss) = -MM(:,1:nss,1:nss)-g_e*MS(:,1:nss,1:nss)

! DMmom
do l=1,3
  do j1=1,nss
    read(LuAniso,*) (tmpR(j1,j2),tmpI(j1,j2),j2=1,nss)
  end do
  DM(l,1:nss,1:nss) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)
end do

! edmom
do l=1,3
  do j1=1,nstate
    read(LuAniso,*) (edmom(l,j1,j2),j2=1,nstate)
  end do
end do

! amfi
do l=1,3
  do j1=1,nstate
    read(LuAniso,*) (amfi(l,j1,j2),j2=1,nstate)
  end do
end do

! HSO matrix
do j1=1,nss
  read(LuAniso,*) (tmpR(j1,j2),tmpI(j1,j2),j2=1,nss)
end do

HSO(1:nss,1:nss) = cmplx(tmpR(:,:),tmpI(:,:),kind=wp)

call mma_deallocate(tmpR)
call mma_deallocate(tmpI)

close(LuAniso)

return

end subroutine read_formatted_aniso

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Ortho_Orb(Xmo,Smat,nBas,nOrb2Loc,nPass,Test)
! Purpose: orthonormalization of orbitals according to
!
!          V = X^T*S*X
!          X <- X*V^(-1/2)
!
!          where S is the AO overlap matrix.
!          The orthonormalization is carried out nPass times.
!          After this routine, X will satisfy X^T*S*X=1.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: Xmo(*)
real(kind=wp), intent(in) :: Smat(*)
integer(kind=iwp), intent(in) :: nBas, nOrb2Loc, nPass
logical(kind=iwp), intent(in) :: Test
integer(kind=iwp) :: i, iPass, iTask, l_Scr, nB, nErr, nO2L
real(kind=wp) :: xNrm
real(kind=wp), allocatable :: Scr(:), V(:,:), VISqrt(:,:), VSqrt(:,:)
real(kind=wp), parameter :: Tol = 1.0e-10_wp
character(len=*), parameter :: SecNam = 'Ortho_Orb'
real(kind=wp), external :: ddot_

! Check for quick return.
! -----------------------

if (nPass < 1) return

! Allocations.
! ------------

l_Scr = 2*(nBas**2)+nBas*(nBas+1)/2 ! needed in SqrtMt
call mma_allocate(V,nOrb2Loc,nOrb2Loc,label='V')
call mma_allocate(VSqrt,nOrb2Loc,nOrb2Loc,label='VSqrt')
call mma_allocate(VISqrt,nOrb2Loc,nOrb2Loc,label='VISqrt')
call mma_allocate(Scr,l_Scr,label='Scr')

! Orthonormalization passes.
! --------------------------

do iPass=1,nPass

  ! Compute V = X^T*S*X.
  ! --------------------

  call GetUmat_Localisation(V,Xmo,Smat,Xmo,Scr,nBas,nOrb2Loc)

  ! Compute V^(-1/2).
  ! -----------------

  iTask = 2 ! compute sqrt as well as inverse sqrt
  call SqrtMt(V,nOrb2Loc,iTask,VSqrt,VISqrt,Scr)

  ! Compute orthonormal X <- X*V^(-1/2).
  ! ------------------------------------

  nB = max(nBas,1)
  nO2L = max(nOrb2Loc,1)
  l_Scr = nBas*nOrb2Loc
  Scr(1:l_Scr) = Xmo(1:l_Scr)
  call DGEMM_('N','N',nBas,nOrb2Loc,nOrb2Loc,One,Scr,nB,VISqrt,nO2L,Zero,Xmo,nB)

end do

! Test orthonormalization (i.e. V=1?).
! ------------------------------------

if (Test) then
  nErr = 0
  call GetUmat_Localisation(V,Xmo,Smat,Xmo,Scr,nBas,nOrb2Loc)
  do i=1,nOrb2Loc
    V(i,i) = V(i,i)-One
  end do
  xNrm = sqrt(dDot_(nOrb2Loc**2,V,1,V,1))
  if (xNrm > Tol) then
    write(u6,'(A,A,D16.8,A,I2,A)') SecNam,': ERROR: ||X^TSX - 1|| = ',xNrm
    nErr = nErr+1
  end if
  if (nErr /= 0) then
    write(u6,*) SecNam,': failure after ',nPass,' passes'
    call SysAbendMsg(SecNam,'Orthonormalization failure!',' ')
  end if
end if

! De-allocations.
! ---------------

call mma_deallocate(V)
call mma_deallocate(VSqrt)
call mma_deallocate(VISqrt)
call mma_deallocate(Scr)

return

end subroutine Ortho_Orb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
c  **************************************************************
c  ** Transformation between VB structures and VB determinants **
c  ** Also generation of spin-function to determinant transf.  **
c  ** and of perfect-pairing guess.                            **
c  **************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  Transformation between VB structures (VB CSFs) and determinants. *
c  *                                                                   *
c  *  The VB structures are ordered according to spatial               *
c  *  configurations, and are normally defined in terms of spin        *
c  *  eigenfunctions.                                                  *
c  *  VB determinants are ordered with alpha & beta indices in         *
c  *  increasing order, with alpha being the slower index.             *
c  *                                                                   *
c  *  STR2VB[CFG] : Structure-to-determinant transformation.           *
c  *  VB2STR[CFG] : Determinant-to-structure transformation.           *
c  *                                                                   *
c  *  [C] : Transforms coefficients.                                   *
c  *  [F] : Transforms a first-order change of the coefficients.       *
c  *  [G] : Transforms a gradient-type quantity.                       *
c  *                                                                   *
c  *  At present there is no actual difference between [C] and [F].    *
c  *                                                                   *
c  *  The difference between [CF] and [G] is mainly important when     *
c  *  non-orthogonal spin functions are used (Rumer/Project.)          *
c  *                                                                   *
c **********************************************************************
      subroutine str2vbc_cvb(cvb,cvbdet)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvb(nvb),cvbdet(ndetvb)

      kab=2

      kbs=nint(work(lb(kab)))
      if(kbs.ne.kbasiscvb)then
        call mkbiks_cvb()
        kbs=kbasiscvb
      endif
      ioffs_cvb=1
      ioffs_cvbdet=1
      idetvb_add=ll(17)
      ifnss_add=lb(4)
      if(kbasiscvb.eq.6)ifnss_add=lb(5)
      ndetvbs_add=lb(6)
      do 200 ifrag=1,nfrag
      iwrk=mstackr_cvb(max(ndetvb_fr(ifrag),nvb_fr(ifrag)))
      call str2vb2_cvb(work(lb(kab)+1),iwork(lb(3)),cvb(ioffs_cvb),
     >  cvbdet(ioffs_cvbdet),2,
     >  iwork(idetvb_add),
     >  i2s_fr(1,ifrag),nS_fr(ifrag),nalf_fr(1,ifrag),nMs_fr(ifrag),
     >  iwork(ifnss_add),iwork(ndetvbs_add),
     >  absym(1),
     >  mnion_fr(ifrag),mxion_fr(ifrag),nconf_fr(ifrag),
     >  ndetvb_fr(ifrag),nvb_fr(ifrag),kbs,
     >  nel_fr(ifrag),nalf_fr(1,ifrag),nel,
     >  work(iwrk),nconfion_fr(0,ifrag))
      call mfreer_cvb(iwrk)
      idetvb_add=idetvb_add+ndetvb_fr(ifrag)
      ioffs_cvb=ioffs_cvb+nvb_fr(ifrag)
      ioffs_cvbdet=ioffs_cvbdet+ndetvb_fr(ifrag)
200   continue
      return

      end
c
      subroutine vb2strg_cvb(cvbdet,cvb)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvb(nvb),cvbdet(ndetvb)
      kab=2
      kbs=nint(work(lb(kab)))
      if(kbs.ne.kbasiscvb)then
        call mkbiks_cvb()
        kbs=kbasiscvb
      endif
      ioffs_cvb=1
      ioffs_cvbdet=1
      idetvb_add=ll(17)
      ifnss_add=lb(4)
      if(kbasiscvb.eq.6)ifnss_add=lb(5)
      ndetvbs_add=lb(6)
      do 400 ifrag=1,nfrag
      iwrk=mstackr_cvb(max(ndetvb_fr(ifrag),nvb_fr(ifrag)))
      call str2vb2_cvb(work(lb(kab)+1),iwork(lb(3)),cvb(ioffs_cvb),
     >  cvbdet(ioffs_cvbdet),1,
     >  iwork(idetvb_add),
     >  i2s_fr(1,ifrag),nS_fr(ifrag),nalf_fr(1,ifrag),nMs_fr(ifrag),
     >  iwork(ifnss_add),iwork(ndetvbs_add),
     >  absym(1),
     >  mnion_fr(ifrag),mxion_fr(ifrag),nconf_fr(ifrag),
     >  ndetvb_fr(ifrag),nvb_fr(ifrag),kbs,
     >  nel_fr(ifrag),nalf_fr(1,ifrag),nel,
     >  work(iwrk),nconfion_fr(0,ifrag))
      call mfreer_cvb(iwrk)
      idetvb_add=idetvb_add+ndetvb_fr(ifrag)
      ioffs_cvb=ioffs_cvb+nvb_fr(ifrag)
      ioffs_cvbdet=ioffs_cvbdet+ndetvb_fr(ifrag)
400   continue
      return
      end


      subroutine vb2strc_cvb(cvbdet,cvb)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvb(nvb),cvbdet(ndetvb)

      kab=1

      kbs=nint(work(lb(kab)))
      if(kbs.ne.kbasiscvb)then
        call mkbiks_cvb()
        kbs=kbasiscvb
      endif
      ioffs_cvb=1
      ioffs_cvbdet=1
      idetvb_add=ll(17)
      ifnss_add=lb(4)
      if(kbasiscvb.eq.6)ifnss_add=lb(5)
      ndetvbs_add=lb(6)
      do 400 ifrag=1,nfrag
      iwrk=mstackr_cvb(max(ndetvb_fr(ifrag),nvb_fr(ifrag)))
      call str2vb2_cvb(work(lb(kab)+1),iwork(lb(3)),cvb(ioffs_cvb),
     >  cvbdet(ioffs_cvbdet),1,
     >  iwork(idetvb_add),
     >  i2s_fr(1,ifrag),nS_fr(ifrag),nalf_fr(1,ifrag),nMs_fr(ifrag),
     >  iwork(ifnss_add),iwork(ndetvbs_add),
     >  absym(1),
     >  mnion_fr(ifrag),mxion_fr(ifrag),nconf_fr(ifrag),
     >  ndetvb_fr(ifrag),nvb_fr(ifrag),kbs,
     >  nel_fr(ifrag),nalf_fr(1,ifrag),nel,
     >  work(iwrk),nconfion_fr(0,ifrag))
      call mfreer_cvb(iwrk)
      idetvb_add=idetvb_add+ndetvb_fr(ifrag)
      ioffs_cvb=ioffs_cvb+nvb_fr(ifrag)
      ioffs_cvbdet=ioffs_cvbdet+ndetvb_fr(ifrag)
400   continue
      return
      end

      subroutine str2vbg_cvb(cvb,cvbdet)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvb(nvb),cvbdet(ndetvb)

      kab=1

      kbs=nint(work(lb(kab)))
      if(kbs.ne.kbasiscvb)then
        call mkbiks_cvb()
        kbs=kbasiscvb
      endif
      ioffs_cvb=1
      ioffs_cvbdet=1
      idetvb_add=ll(17)
      ifnss_add=lb(4)
      if(kbasiscvb.eq.6)ifnss_add=lb(5)
      ndetvbs_add=lb(6)
      do 200 ifrag=1,nfrag
      iwrk=mstackr_cvb(max(ndetvb_fr(ifrag),nvb_fr(ifrag)))
      call str2vb2_cvb(work(lb(kab)+1),iwork(lb(3)),cvb(ioffs_cvb),
     >  cvbdet(ioffs_cvbdet),2,
     >  iwork(idetvb_add),
     >  i2s_fr(1,ifrag),nS_fr(ifrag),nalf_fr(1,ifrag),nMs_fr(ifrag),
     >  iwork(ifnss_add),iwork(ndetvbs_add),
     >  absym(1),
     >  mnion_fr(ifrag),mxion_fr(ifrag),nconf_fr(ifrag),
     >  ndetvb_fr(ifrag),nvb_fr(ifrag),kbs,
     >  nel_fr(ifrag),nalf_fr(1,ifrag),nel,
     >  work(iwrk),nconfion_fr(0,ifrag))
      call mfreer_cvb(iwrk)
      idetvb_add=idetvb_add+ndetvb_fr(ifrag)
      ioffs_cvb=ioffs_cvb+nvb_fr(ifrag)
      ioffs_cvbdet=ioffs_cvbdet+ndetvb_fr(ifrag)
200   continue
      return

      end

      subroutine str2vbf_cvb(cvb,cvbdet)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvb(nvb),cvbdet(ndetvb)

      kab=2

      kbs=nint(work(lb(kab)))
      if(kbs.ne.kbasiscvb)then
        call mkbiks_cvb()
        kbs=kbasiscvb
      endif
      ioffs_cvb=1
      ioffs_cvbdet=1
      idetvb_add=ll(17)
      ifnss_add=lb(4)
      if(kbasiscvb.eq.6)ifnss_add=lb(5)
      ndetvbs_add=lb(6)
      do 200 ifrag=1,nfrag
      iwrk=mstackr_cvb(max(ndetvb_fr(ifrag),nvb_fr(ifrag)))
      call str2vb2_cvb(work(lb(kab)+1),iwork(lb(3)),cvb(ioffs_cvb),
     >  cvbdet(ioffs_cvbdet),2,
     >  iwork(idetvb_add),
     >  i2s_fr(1,ifrag),nS_fr(ifrag),nalf_fr(1,ifrag),nMs_fr(ifrag),
     >  iwork(ifnss_add),iwork(ndetvbs_add),
     >  absym(1),
     >  mnion_fr(ifrag),mxion_fr(ifrag),nconf_fr(ifrag),
     >  ndetvb_fr(ifrag),nvb_fr(ifrag),kbs,
     >  nel_fr(ifrag),nalf_fr(1,ifrag),nel,
     >  work(iwrk),nconfion_fr(0,ifrag))
      call mfreer_cvb(iwrk)
      idetvb_add=idetvb_add+ndetvb_fr(ifrag)
      ioffs_cvb=ioffs_cvb+nvb_fr(ifrag)
      ioffs_cvbdet=ioffs_cvbdet+ndetvb_fr(ifrag)
200   continue
      return

      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Jonna Stalring                                   *
************************************************************************
*
      Subroutine rddj(G1r,G1Q,G2r,iestate)
*
* Jonna 000411
*
* Reads the one and two electron densities for estate
* and returns them in rectangular and single triangular storage
*
*
      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "glbbas_mclr.fh"
#include "Files_mclr.fh"
#include "sa.fh"
      Real*8 G1r(*), G1Q(*),G2r(*)
      Dimension rdum(1)
*
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

*
      ng1=itri(ntash,ntash)
      ng2=itri(ng1,ng1)
*
      Call Getmem('G2Q ','ALLO','REAL',ipG2Q,ng2)
c
c     Read one and two el dens for state iestate
c
      iR=iestate
      jdisk=itoc(3)
      Do i=1,iR-1
         Call dDaFile(LUJOB ,0,rdum,ng1,jDisk)
         Call dDaFile(LUJOB ,0,rdum,ng1,jDisk)
         Call dDaFile(LUJOB ,0,rdum,Ng2,jDisk)
         Call dDaFile(LUJOB ,0,rdum,Ng2,jDisk)
      End Do
      Call dDaFile(LUJOB ,2,G1q,ng1,jDisk)
      Call dDaFile(LUJOB ,0,rdum,ng1,jDisk)
      Call dDaFile(LUJOB ,2,Work(ipG2Q),Ng2,jDisk)
      Call dDaFile(LUJOB ,0,rdum,Ng2,jDisk)
c
c Make one el rectangular and two el singel triang.
c
      Do iB=1,ntash
         Do jB=1,ntash
            iDij=iTri(ib,jB)
            iRij=jb+(ib-1)*ntash
            Do kB=1,ntash
               Do lB=1,ntash
                  iDkl=iTri(kB,lB)
                  iRkl=lb+(kb-1)*ntash
                  fact=1.0d00
                  If(iDij.ge.iDkl .and. kB.eq.lB) fact=2.0d00
                  If(iDij.lt.iDkl .and. iB.eq.jB) fact=2.0d00
                  iijkl=itri(iDij,iDkl)
                  iRijkl=itri(iRij,iRkl)
                  G2R(iRijkl)=Fact*Work(ipG2Q+iijkl-1)
               End Do
            End Do
         End Do
      End Do
      Do iB=1,ntash
         Do jB=1,ntash
            G1R(+ib+(jb-1)*ntash)= g1q(+itri(ib,jb))
         End Do
      End Do
*
      Call Getmem('G2Q ','FREE','REAL',ipG2Q,ng2)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2002, Roland Lindh                                     *
************************************************************************
      Subroutine dRho_dR_GGA(Dens,nDens,nD,dRho_dR,ndRho_dR,mGrid,
     &                       list_s,nlist_s,TabAO,ipTabAO,mAO,nTabAO,
     &                       nSym,nGrad_Eff,list_g,Maps2p,nShell,
     &                       Grid_Type,Fixed_Grid,Fact,ndc,TabAOMax,T_X,
     &                       list_bas,Index,nIndex)
************************************************************************
*      Author:Roland Lindh, Department of Chemical Physics, University *
*             of Lund, SWEDEN.  2002 (at Todai)                        *
************************************************************************
      use iSD_data
      use k2_arrays, only: DeDe, ipDijS
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "disp.fh"
#include "real.fh"
#include "print.fh"
#include "debug.fh"
#include "nsd.fh"
#include "setup.fh"
      Integer On, Off
      Parameter (On=1, Off=0)
      Integer list_s(2,nlist_s), list_g(3,nlist_s),
     &        ipTabAO(nlist_s), Maps2p(nShell,0:nSym-1),
     &        list_bas(2,nlist_s), Index(nIndex)
      Integer Grid_Type, Fixed_Grid
      Real*8 Dens(nDens,nD), dRho_dR(ndRho_dR,mGrid,nGrad_Eff),
     &       TabAO(nTabAO), Fact(ndc**2), TabAOMax(nlist_s)
      Integer IndGrd_Eff(3,2)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (Debug) Then
         Call RecPrt('dRho_dR_GGA:Dens',' ',Dens,nDens,nD)
         Write (6,*) 'mAO=',mAO
         Write (6,*) 'mGrid=',mGrid
         Write (6,*) 'nTabAO=',nTabAO
         Write (6,*) 'nlist_s=',nlist_s
         Do iList_s = 1, nList_s
            Write (6,*) 'iList_s=',iList_s
            iS = list_s(1,ilist_s)
            iCmp  = iSD( 2,iS)
            iBas  = iSD( 3,iS)
            iBas_Eff = list_bas(1,ilist_s)
            mTabAO=iBas_Eff*iCmp
            mdci  = iSD(10,iS)
            Call RecPrt('dRho_dR_GGA: TabAO',' ',
     &                  TabAO(ipTabAO(iList_s)),mAO,mGrid*mTabAO)
         End Do
      End If
#endif
*
      Call FZero(dRho_dR,ndRho_dR*mGrid*nGrad_Eff)
*                                                                      *
************************************************************************
*                                                                      *
      Do ilist_s=1,nlist_s
         iS    = list_s(1,ilist_s)
         kDCRE = list_s(2,ilist_s)
         iCmp  = iSD( 2,iS)
         iBas_Eff=list_bas(1,ilist_s)
         ix = iDAMax_(mAO*mGrid*iBas_Eff*iCmp,TabAO(ipTabAO(iList_s)),1)
         TabAOMax(ilist_s)=Abs(TabAO(ipTabAO(ilist_s)-1+ix))
         TMax_i=TabAOMax(ilist_s)
         If (TMax_i.le.T_X) Go To 999
         iBas  = iSD( 3,iS)
         iPrim = iSD( 5,iS)
         mdci  = iSD(10,iS)
         iShell= iSD(11,iS)
         index_i=list_bas(2,ilist_s)
*
         lDCRE=NrOpr(kDCRE)
*
         jNQ=Maps2p(iS,lDCRE)
         Call ICopy(3,list_g(1,ilist_s),1,IndGrd_Eff(1,1),1)
         n1 = IndGrd_Eff(1,1) + IndGrd_Eff(2,1) + IndGrd_Eff(3,1)
*
         Do jlist_s=1,ilist_s
            TMax_j=TabAOMax(jlist_s)
            If (TMax_j.le.T_X) Go To 98
            If (TMax_i*TMax_j.lt.T_X) Go To 98
            jS    = list_s(1,jlist_s)
            kDCRR = list_s(2,jlist_s)
            jCmp  = iSD( 2,jS)
            jBas  = iSD( 3,jS)
            jPrim = iSD( 5,jS)
            mdcj  = iSD(10,jS)
            jShell= iSD(11,jS)
            jBas_Eff=list_bas(1,jlist_s)
            index_j =list_bas(2,jlist_s)
*
            lDCRR=NrOpr(kDCRR)
*
            kNQ=Maps2p(jS,lDCRR)
            Call ICopy(3,list_g(1,jlist_s),1,IndGrd_Eff(1,2),1)
            n2 = IndGrd_Eff(1,2) + IndGrd_Eff(2,2) + IndGrd_Eff(3,2)
            If (n1+n2.eq.0) Go To 98
*
            mDij=iBas*jBas*iCmp*jCmp
*
*---------- Get the Density
*
            ijS=iTri(iShell,jShell)
            ipTmp=ipDijs
            Call Dens_Info(ijS,ipDij,ipDSij,mDCRij,ipDDij,ipTmp,nD)
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*)
               Write (6,*) 'iS,jS=',iS,jS
               Write (6,*) 'mDCRij,mDij=',mDCRij,mDij
               Write (6,*) 'ipDij,ipDSij,ipDDij=',ipDij,ipDSij,ipDDij
            End If
#endif
*
            ij = (mdcj-1)*ndc + mdci
*
            Deg=Two
            If (ilist_s.eq.jlist_s) Deg=One
*
            iER=iEOr(kDCRE,kDCRR)
            lDCRER=NrOpr(iER)
*
            ip_D_a=ipDij+lDCRER*mDij
            ip_D_b=ip_D_a
            If (nD.ne.1) ip_D_b=ipDSij+lDCRER*mDij
*
            If (nD.ne.1) Then
               ix=iDAMax_(mDij,DeDe(ip_D_a),1)
               iy=iDAMax_(mDij,DeDe(ip_D_b),1)
               DMax_ij=Half*( Abs(DeDe(ip_D_a-1+ix))
     &                       +Abs(DeDe(ip_D_b-1+iy)) )
            Else
               ix=iDAMax_(mDij,DeDe(ip_D_a),1)
               DMax_ij=Abs(DeDe(ip_D_a-1+ix))
            End If
            DMax_ij=DMax_ij*Fact(ij)
            If (TMax_i*TMax_j*DMax_ij.lt.T_X) Go To 98
#ifdef _DEBUGPRINT_
            If (Debug) Then
               Write (6,*) 'dRho_dR_GGA'
               nBB = iBas*jBas
               nCC = iCmp*jCmp
               Write (6,*) 'iER,lDCRER=',iER,lDCRER
               Call RecPrt('DAij',' ',DeDe(ip_D_a),nBB,nCC)
               If (nD.ne.1)
     &            Call RecPrt('DBij',' ',DeDe(ip_D_b),nBB,nCC)
            End If
#endif
*
            If (iShell.lt.jShell) Then
               itmp=IndGrd_Eff(1,1)
               IndGrd_Eff(1,1)=IndGrd_Eff(1,2)
               IndGrd_Eff(1,2)=itmp
               itmp=IndGrd_Eff(2,1)
               IndGrd_Eff(2,1)=IndGrd_Eff(2,2)
               IndGrd_Eff(2,2)=itmp
               itmp=IndGrd_Eff(3,1)
               IndGrd_Eff(3,1)=IndGrd_Eff(3,2)
               IndGrd_Eff(3,2)=itmp
            End If
            If (nD.eq.1) Then
               If (iShell.ge.jShell) Then
               Call Do_Rho8da(dRho_dR,    mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),                  mAO,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               Else
               Call Do_Rho8da(dRho_dR,    mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),                  mAO,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               End If
            Else
               If (iShell.ge.jShell) Then
               Call Do_Rho8d_(dRho_dR,    mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),DeDe(ip_D_b),     mAO,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               Else
               Call Do_Rho8d_(dRho_dR,    mGrid,nGrad_Eff,
     &                       DeDe(ip_D_a),DeDe(ip_D_b),     mAO,
     &                       TabAO(ipTabAO(jList_s)),jBas,jBas_Eff,jCmp,
     &                       TabAO(ipTabAO(iList_s)),iBas,iBas_Eff,iCmp,
     &                       Fact(ij)*Deg,IndGrd_Eff,
     &                       T_X,TMax_i*TMax_j,
     &                       Index(index_i),Index(index_j))
               End If
            End If
*
 98         Continue
         End Do                      ! jlist_s
 999     Continue
      End Do                         ! ilist_s
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (Debug) Call RecPrt('dRho_dR_GGA: dRho_dR',' ',dRho_dR,
     &                        ndRho_dR*mGrid,nGrad_Eff)
*
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Dens)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(Grid_Type)
         Call Unused_integer(Fixed_Grid)
      End If
      End
      Subroutine Do_Rho8da(dRho_dR,     mGrid,nGrad_Eff,
     &                     DAij,          mAO,
     &                     TabAO1,iBas,iBas_Eff,iCmp,
     &                     TabAO2,jBas,jBas_Eff,jCmp,
     &                     Fact,IndGrd_Eff,T_X,TMax_ij,
     &                     Index_i,Index_j)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 dRho_dR(  4,mGrid,nGrad_Eff), DAij(iBas*iCmp,jBas*jCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp),
     &       TabAO2(mAO,mGrid,jBas_Eff*jCmp)
      Integer IndGrd_Eff(3,2), Index_i(iBas_Eff*iCmp),
     &                         Index_j(jBas_Eff*jCmp)
*                                                                      *
************************************************************************
*                                                                      *
*     Rather than to use integers directly we set up a symbolic way of
*     doing the indexation.
*
      Integer F,
     &        dFdx, dFdy, dFdz,
     &        d2Fdx2, d2Fdxdy, d2Fdxdz, d2Fdy2, d2Fdydz, d2Fdz2,
     &                d2Fdydx, d2Fdzdx,         d2Fdzdy
      Parameter(F=1,
     &          dFdx=2, dFdy=3, dFdz=4,
     &          d2Fdx2=5, d2Fdxdy=6, d2Fdxdz=7, d2Fdy2=8, d2Fdydz=9,
     &                    d2Fdydx=6, d2Fdzdx=7,           d2Fdzdy=9,
     &          d2Fdz2=10)
*                                                                      *
************************************************************************
*                                                                      *
      Do jCB_Eff = 1, jBas_Eff*jCmp
         jCB = Index_j(jCB_Eff)
*
         Do iCB_Eff = 1, iBas_Eff*iCmp
            iCB = Index_i(iCB_Eff)
*
            DAij_=DAij(iCB,jCB)*Fact
            If (TMax_ij*Abs(DAij_).lt.T_X) Go To 99
*                                                                      *
************************************************************************
*                                                                      *
*---------- x component
*
            Ind_x1=IndGrd_Eff(1,1)
            Ind_x2=IndGrd_Eff(1,2)
            If (Ind_x1.ne.0.and.Ind_x2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_x1 =TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_xx1=TabAO1(d2Fdx2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xy1=TabAO1(d2Fdxdy,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_xz1=TabAO1(d2Fdxdz,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_x2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdx2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdxdy,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdxdz,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_x1)=dRho_dR(1,iGrid,Ind_x1)
     &                                   +Rho_x1 *DAij_
                  dRho_dR(2,iGrid,Ind_x1)=dRho_dR(2,iGrid,Ind_x1)
     &                                   +Rho_xx1*DAij_
                  dRho_dR(3,iGrid,Ind_x1)=dRho_dR(3,iGrid,Ind_x1)
     &                                   +Rho_xy1*DAij_
                  dRho_dR(4,iGrid,Ind_x1)=dRho_dR(4,iGrid,Ind_x1)
     &                                   +Rho_xz1*DAij_
                  dRho_dR(1,iGrid,Ind_x2)=dRho_dR(1,iGrid,Ind_x2)
     &                                   +Rho_x2 *DAij_
                  dRho_dR(2,iGrid,Ind_x2)=dRho_dR(2,iGrid,Ind_x2)
     &                                   +Rho_xx2*DAij_
                  dRho_dR(3,iGrid,Ind_x2)=dRho_dR(3,iGrid,Ind_x2)
     &                                   +Rho_xy2*DAij_
                  dRho_dR(4,iGrid,Ind_x2)=dRho_dR(4,iGrid,Ind_x2)
     &                                   +Rho_xz2*DAij_
               End Do ! iGrid
            Else If (Ind_x1.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_x1 =TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_xx1=TabAO1(d2Fdx2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xy1=TabAO1(d2Fdxdy,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_xz1=TabAO1(d2Fdxdz,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_x1)=dRho_dR(1,iGrid,Ind_x1)
     &                                   +Rho_x1 *DAij_
                  dRho_dR(2,iGrid,Ind_x1)=dRho_dR(2,iGrid,Ind_x1)
     &                                   +Rho_xx1*DAij_
                  dRho_dR(3,iGrid,Ind_x1)=dRho_dR(3,iGrid,Ind_x1)
     &                                   +Rho_xy1*DAij_
                  dRho_dR(4,iGrid,Ind_x1)=dRho_dR(4,iGrid,Ind_x1)
     &                                   +Rho_xz1*DAij_
               End Do ! iGrid
            Else If (Ind_x2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_x2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdx2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdxdy,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdxdz,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_x2)=dRho_dR(1,iGrid,Ind_x2)
     &                                   +Rho_x2 *DAij_
                  dRho_dR(2,iGrid,Ind_x2)=dRho_dR(2,iGrid,Ind_x2)
     &                                   +Rho_xx2*DAij_
                  dRho_dR(3,iGrid,Ind_x2)=dRho_dR(3,iGrid,Ind_x2)
     &                                   +Rho_xy2*DAij_
                  dRho_dR(4,iGrid,Ind_x2)=dRho_dR(4,iGrid,Ind_x2)
     &                                   +Rho_xz2*DAij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*---------- y component
*
            Ind_y1=IndGrd_Eff(2,1)
            Ind_y2=IndGrd_Eff(2,2)
            If (Ind_y1.ne.0.and.Ind_y2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_y1 =TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_yx1=TabAO1(d2Fdydx,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_yy1=TabAO1(d2Fdy2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yz1=TabAO1(d2Fdydz,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_y2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdydx,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdy2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdydz,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_y1)=dRho_dR(1,iGrid,Ind_y1)
     &                                   +Rho_y1 *DAij_
                  dRho_dR(2,iGrid,Ind_y1)=dRho_dR(2,iGrid,Ind_y1)
     &                                   +Rho_yx1*DAij_
                  dRho_dR(3,iGrid,Ind_y1)=dRho_dR(3,iGrid,Ind_y1)
     &                                   +Rho_yy1*DAij_
                  dRho_dR(4,iGrid,Ind_y1)=dRho_dR(4,iGrid,Ind_y1)
     &                                   +Rho_yz1*DAij_
                  dRho_dR(1,iGrid,Ind_y2)=dRho_dR(1,iGrid,Ind_y2)
     &                                   +Rho_y2 *DAij_
                  dRho_dR(2,iGrid,Ind_y2)=dRho_dR(2,iGrid,Ind_y2)
     &                                   +Rho_yx2*DAij_
                  dRho_dR(3,iGrid,Ind_y2)=dRho_dR(3,iGrid,Ind_y2)
     &                                   +Rho_yy2*DAij_
                  dRho_dR(4,iGrid,Ind_y2)=dRho_dR(4,iGrid,Ind_y2)
     &                                   +Rho_yz2*DAij_
               End Do ! iGrid
            Else If (Ind_y1.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_y1 =TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_yx1=TabAO1(d2Fdydx,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_yy1=TabAO1(d2Fdy2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yz1=TabAO1(d2Fdydz,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_y1)=dRho_dR(1,iGrid,Ind_y1)
     &                                   +Rho_y1 *DAij_
                  dRho_dR(2,iGrid,Ind_y1)=dRho_dR(2,iGrid,Ind_y1)
     &                                   +Rho_yx1*DAij_
                  dRho_dR(3,iGrid,Ind_y1)=dRho_dR(3,iGrid,Ind_y1)
     &                                   +Rho_yy1*DAij_
                  dRho_dR(4,iGrid,Ind_y1)=dRho_dR(4,iGrid,Ind_y1)
     &                                   +Rho_yz1*DAij_
               End Do ! iGrid
            Else If (Ind_y2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_y2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdydx,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdy2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdydz,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_y2)=dRho_dR(1,iGrid,Ind_y2)
     &                                   +Rho_y2 *DAij_
                  dRho_dR(2,iGrid,Ind_y2)=dRho_dR(2,iGrid,Ind_y2)
     &                                   +Rho_yx2*DAij_
                  dRho_dR(3,iGrid,Ind_y2)=dRho_dR(3,iGrid,Ind_y2)
     &                                   +Rho_yy2*DAij_
                  dRho_dR(4,iGrid,Ind_y2)=dRho_dR(4,iGrid,Ind_y2)
     &                                   +Rho_yz2*DAij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*---------- z component
*
            Ind_z1=IndGrd_Eff(3,1)
            Ind_z2=IndGrd_Eff(3,2)
            If (Ind_z1.ne.0.and.Ind_z2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_z1 =TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_zx1=TabAO1(d2Fdzdx,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_zy1=TabAO1(d2Fdzdy,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_zz1=TabAO1(d2Fdz2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_z2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdzdx,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdzdy,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdz2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_z1)=dRho_dR(1,iGrid,Ind_z1)
     &                                   +Rho_z1 *DAij_
                  dRho_dR(2,iGrid,Ind_z1)=dRho_dR(2,iGrid,Ind_z1)
     &                                   +Rho_zx1*DAij_
                  dRho_dR(3,iGrid,Ind_z1)=dRho_dR(3,iGrid,Ind_z1)
     &                                   +Rho_zy1*DAij_
                  dRho_dR(4,iGrid,Ind_z1)=dRho_dR(4,iGrid,Ind_z1)
     &                                   +Rho_zz1*DAij_
                  dRho_dR(1,iGrid,Ind_z2)=dRho_dR(1,iGrid,Ind_z2)
     &                                   +Rho_z2 *DAij_
                  dRho_dR(2,iGrid,Ind_z2)=dRho_dR(2,iGrid,Ind_z2)
     &                                   +Rho_zx2*DAij_
                  dRho_dR(3,iGrid,Ind_z2)=dRho_dR(3,iGrid,Ind_z2)
     &                                   +Rho_zy2*DAij_
                  dRho_dR(4,iGrid,Ind_z2)=dRho_dR(4,iGrid,Ind_z2)
     &                                   +Rho_zz2*DAij_
               End Do ! iGrid
            Else If (Ind_z1.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_z1 =TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_zx1=TabAO1(d2Fdzdx,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_zy1=TabAO1(d2Fdzdy,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_zz1=TabAO1(d2Fdz2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_z1)=dRho_dR(1,iGrid,Ind_z1)
     &                                   +Rho_z1 *DAij_
                  dRho_dR(2,iGrid,Ind_z1)=dRho_dR(2,iGrid,Ind_z1)
     &                                   +Rho_zx1*DAij_
                  dRho_dR(3,iGrid,Ind_z1)=dRho_dR(3,iGrid,Ind_z1)
     &                                   +Rho_zy1*DAij_
                  dRho_dR(4,iGrid,Ind_z1)=dRho_dR(4,iGrid,Ind_z1)
     &                                   +Rho_zz1*DAij_
               End Do ! iGrid
            Else If (Ind_z2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_z2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdzdx,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdzdy,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdz2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_z2)=dRho_dR(1,iGrid,Ind_z2)
     &                                   +Rho_z2 *DAij_
                  dRho_dR(2,iGrid,Ind_z2)=dRho_dR(2,iGrid,Ind_z2)
     &                                   +Rho_zx2*DAij_
                  dRho_dR(3,iGrid,Ind_z2)=dRho_dR(3,iGrid,Ind_z2)
     &                                   +Rho_zy2*DAij_
                  dRho_dR(4,iGrid,Ind_z2)=dRho_dR(4,iGrid,Ind_z2)
     &                                   +Rho_zz2*DAij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
      Return
      End
      Subroutine Do_Rho8d_(dRho_dR,     mGrid,nGrad_Eff,
     &                     DAij,DBij,     mAO,
     &                     TabAO1,iBas,iBas_Eff,iCmp,
     &                     TabAO2,jBas,jBas_Eff,jCmp,
     &                     Fact,IndGrd_Eff,T_X,TMax_ij,
     &                     Index_i,Index_j)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 dRho_dR(   8,mGrid,nGrad_Eff),
     &       DAij(iBas*iCmp,jBas*jCmp), DBij(iBas*iCmp,jBas*jCmp),
     &       TabAO1(mAO,mGrid,iBas_Eff*iCmp),
     &       TabAO2(mAO,mGrid,jBas_Eff*jCmp)
      Integer IndGrd_Eff(3,2), Index_i(iBas_Eff*iCmp),
     &                         Index_j(jBas_Eff*jCmp)
*                                                                      *
************************************************************************
*                                                                      *
*     Rather than to use integers directly we set up a symbolic way of
*     doing the indexation.
*
      Integer F,
     &        dFdx, dFdy, dFdz,
     &        d2Fdx2, d2Fdxdy, d2Fdxdz, d2Fdy2, d2Fdydz, d2Fdz2,
     &                d2Fdydx, d2Fdzdx,         d2Fdzdy
      Parameter(F=1,
     &          dFdx=2, dFdy=3, dFdz=4,
     &          d2Fdx2=5, d2Fdxdy=6, d2Fdxdz=7, d2Fdy2=8, d2Fdydz=9,
     &                    d2Fdydx=6, d2Fdzdx=7,           d2Fdzdy=9,
     &          d2Fdz2=10)
*                                                                      *
************************************************************************
*                                                                      *
      Do jCB_Eff = 1, jBas_Eff*jCmp
         jCB = Index_j(jCB_Eff)
*
         Do iCB_Eff = 1, iBas_Eff*iCmp
            iCB = Index_i(iCB_Eff)
*
            DAij_=DAij(iCB,jCB)*Fact
            DBij_=DBij(iCB,jCB)*Fact
            Dij_ =Half*(Abs(DAij_)+Abs(DBij_))
            If (TMax_ij*Abs(Dij_).lt.T_X) Go To 99
*                                                                      *
************************************************************************
*                                                                      *
*---------- x component
*
            Ind_x1=IndGrd_Eff(1,1)
            Ind_x2=IndGrd_Eff(1,2)
            If (Ind_x1.ne.0.and.Ind_x2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_x1 =TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_xx1=TabAO1(d2Fdx2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xy1=TabAO1(d2Fdxdy,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_xz1=TabAO1(d2Fdxdz,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_x2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdx2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdxdy,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdxdz,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_x1)=dRho_dR(1,iGrid,Ind_x1)
     &                              +Rho_x1 *DAij_
                  dRho_dR(2,iGrid,Ind_x1)=dRho_dR(2,iGrid,Ind_x1)
     &                              +Rho_x1 *DBij_
                  dRho_dR(3,iGrid,Ind_x1)=dRho_dR(3,iGrid,Ind_x1)
     &                              +Rho_xx1*DAij_
                  dRho_dR(4,iGrid,Ind_x1)=dRho_dR(4,iGrid,Ind_x1)
     &                              +Rho_xy1*DAij_
                  dRho_dR(5,iGrid,Ind_x1)=dRho_dR(5,iGrid,Ind_x1)
     &                              +Rho_xz1*DAij_
                  dRho_dR(6,iGrid,Ind_x1)=dRho_dR(6,iGrid,Ind_x1)
     &                              +Rho_xx1*DBij_
                  dRho_dR(7,iGrid,Ind_x1)=dRho_dR(7,iGrid,Ind_x1)
     &                              +Rho_xy1*DBij_
                  dRho_dR(8,iGrid,Ind_x1)=dRho_dR(8,iGrid,Ind_x1)
     &                              +Rho_xz1*DBij_
                  dRho_dR(1,iGrid,Ind_x2)=dRho_dR(1,iGrid,Ind_x2)
     &                              +Rho_x2 *DAij_
                  dRho_dR(2,iGrid,Ind_x2)=dRho_dR(2,iGrid,Ind_x2)
     &                              +Rho_x2 *DBij_
                  dRho_dR(3,iGrid,Ind_x2)=dRho_dR(3,iGrid,Ind_x2)
     &                              +Rho_xx2*DAij_
                  dRho_dR(4,iGrid,Ind_x2)=dRho_dR(4,iGrid,Ind_x2)
     &                              +Rho_xy2*DAij_
                  dRho_dR(5,iGrid,Ind_x2)=dRho_dR(5,iGrid,Ind_x2)
     &                              +Rho_xz2*DAij_
                  dRho_dR(6,iGrid,Ind_x2)=dRho_dR(6,iGrid,Ind_x2)
     &                              +Rho_xx2*DBij_
                  dRho_dR(7,iGrid,Ind_x2)=dRho_dR(7,iGrid,Ind_x2)
     &                              +Rho_xy2*DBij_
                  dRho_dR(8,iGrid,Ind_x2)=dRho_dR(8,iGrid,Ind_x2)
     &                              +Rho_xz2*DBij_
               End Do ! iGrid
            Else If (Ind_x1.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_x1 =TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_xx1=TabAO1(d2Fdx2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xy1=TabAO1(d2Fdxdy,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_xz1=TabAO1(d2Fdxdz,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_x1)=dRho_dR(1,iGrid,Ind_x1)
     &                              +Rho_x1 *DAij_
                  dRho_dR(2,iGrid,Ind_x1)=dRho_dR(2,iGrid,Ind_x1)
     &                              +Rho_x1 *DBij_
                  dRho_dR(3,iGrid,Ind_x1)=dRho_dR(3,iGrid,Ind_x1)
     &                              +Rho_xx1*DAij_
                  dRho_dR(4,iGrid,Ind_x1)=dRho_dR(4,iGrid,Ind_x1)
     &                              +Rho_xy1*DAij_
                  dRho_dR(5,iGrid,Ind_x1)=dRho_dR(5,iGrid,Ind_x1)
     &                              +Rho_xz1*DAij_
                  dRho_dR(6,iGrid,Ind_x1)=dRho_dR(6,iGrid,Ind_x1)
     &                              +Rho_xx1*DBij_
                  dRho_dR(7,iGrid,Ind_x1)=dRho_dR(7,iGrid,Ind_x1)
     &                              +Rho_xy1*DBij_
                  dRho_dR(8,iGrid,Ind_x1)=dRho_dR(8,iGrid,Ind_x1)
     &                              +Rho_xz1*DBij_
               End Do ! iGrid
            Else If (Ind_x2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_x2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdx2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdxdy,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_xz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdxdz,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_x2)=dRho_dR(1,iGrid,Ind_x2)
     &                              +Rho_x2 *DAij_
                  dRho_dR(2,iGrid,Ind_x2)=dRho_dR(2,iGrid,Ind_x2)
     &                              +Rho_x2 *DBij_
                  dRho_dR(3,iGrid,Ind_x2)=dRho_dR(3,iGrid,Ind_x2)
     &                              +Rho_xx2*DAij_
                  dRho_dR(4,iGrid,Ind_x2)=dRho_dR(4,iGrid,Ind_x2)
     &                              +Rho_xy2*DAij_
                  dRho_dR(5,iGrid,Ind_x2)=dRho_dR(5,iGrid,Ind_x2)
     &                              +Rho_xz2*DAij_
                  dRho_dR(6,iGrid,Ind_x2)=dRho_dR(6,iGrid,Ind_x2)
     &                              +Rho_xx2*DBij_
                  dRho_dR(7,iGrid,Ind_x2)=dRho_dR(7,iGrid,Ind_x2)
     &                              +Rho_xy2*DBij_
                  dRho_dR(8,iGrid,Ind_x2)=dRho_dR(8,iGrid,Ind_x2)
     &                              +Rho_xz2*DBij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*---------- y component
*
            Ind_y1=IndGrd_Eff(2,1)
            Ind_y2=IndGrd_Eff(2,2)
            If (Ind_y1.ne.0.and.Ind_y2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_y1 =TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_yx1=TabAO1(d2Fdydx,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_yy1=TabAO1(d2Fdy2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yz1=TabAO1(d2Fdydz,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_y2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdydx,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdy2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdydz,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_y1)=dRho_dR(1,iGrid,Ind_y1)
     &                              +Rho_y1 *DAij_
                  dRho_dR(2,iGrid,Ind_y1)=dRho_dR(2,iGrid,Ind_y1)
     &                              +Rho_y1 *DBij_
                  dRho_dR(3,iGrid,Ind_y1)=dRho_dR(3,iGrid,Ind_y1)
     &                              +Rho_yx1*DAij_
                  dRho_dR(4,iGrid,Ind_y1)=dRho_dR(4,iGrid,Ind_y1)
     &                              +Rho_yy1*DAij_
                  dRho_dR(5,iGrid,Ind_y1)=dRho_dR(5,iGrid,Ind_y1)
     &                              +Rho_yz1*DAij_
                  dRho_dR(6,iGrid,Ind_y1)=dRho_dR(6,iGrid,Ind_y1)
     &                              +Rho_yx1*DBij_
                  dRho_dR(7,iGrid,Ind_y1)=dRho_dR(7,iGrid,Ind_y1)
     &                              +Rho_yy1*DBij_
                  dRho_dR(8,iGrid,Ind_y1)=dRho_dR(8,iGrid,Ind_y1)
     &                              +Rho_yz1*DBij_
                  dRho_dR(1,iGrid,Ind_y2)=dRho_dR(1,iGrid,Ind_y2)
     &                              +Rho_y2 *DAij_
                  dRho_dR(2,iGrid,Ind_y2)=dRho_dR(2,iGrid,Ind_y2)
     &                              +Rho_y2 *DBij_
                  dRho_dR(3,iGrid,Ind_y2)=dRho_dR(3,iGrid,Ind_y2)
     &                              +Rho_yx2*DAij_
                  dRho_dR(4,iGrid,Ind_y2)=dRho_dR(4,iGrid,Ind_y2)
     &                              +Rho_yy2*DAij_
                  dRho_dR(5,iGrid,Ind_y2)=dRho_dR(5,iGrid,Ind_y2)
     &                              +Rho_yz2*DAij_
                  dRho_dR(6,iGrid,Ind_y2)=dRho_dR(6,iGrid,Ind_y2)
     &                              +Rho_yx2*DBij_
                  dRho_dR(7,iGrid,Ind_y2)=dRho_dR(7,iGrid,Ind_y2)
     &                              +Rho_yy2*DBij_
                  dRho_dR(8,iGrid,Ind_y2)=dRho_dR(8,iGrid,Ind_y2)
     &                              +Rho_yz2*DBij_
               End Do ! iGrid
            Else If (Ind_y1.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_y1 =TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_yx1=TabAO1(d2Fdydx,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_yy1=TabAO1(d2Fdy2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yz1=TabAO1(d2Fdydz,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_y1)=dRho_dR(1,iGrid,Ind_y1)
     &                              +Rho_y1 *DAij_
                  dRho_dR(2,iGrid,Ind_y1)=dRho_dR(2,iGrid,Ind_y1)
     &                              +Rho_y1 *DBij_
                  dRho_dR(3,iGrid,Ind_y1)=dRho_dR(3,iGrid,Ind_y1)
     &                              +Rho_yx1*DAij_
                  dRho_dR(4,iGrid,Ind_y1)=dRho_dR(4,iGrid,Ind_y1)
     &                              +Rho_yy1*DAij_
                  dRho_dR(5,iGrid,Ind_y1)=dRho_dR(5,iGrid,Ind_y1)
     &                              +Rho_yz1*DAij_
                  dRho_dR(6,iGrid,Ind_y1)=dRho_dR(6,iGrid,Ind_y1)
     &                              +Rho_yx1*DBij_
                  dRho_dR(7,iGrid,Ind_y1)=dRho_dR(7,iGrid,Ind_y1)
     &                              +Rho_yy1*DBij_
                  dRho_dR(8,iGrid,Ind_y1)=dRho_dR(8,iGrid,Ind_y1)
     &                              +Rho_yz1*DBij_
               End Do ! iGrid
            Else If (Ind_y2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_y2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdydx,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdy2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_yz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdydz,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_y2)=dRho_dR(1,iGrid,Ind_y2)
     &                              +Rho_y2 *DAij_
                  dRho_dR(2,iGrid,Ind_y2)=dRho_dR(2,iGrid,Ind_y2)
     &                              +Rho_y2 *DBij_
                  dRho_dR(3,iGrid,Ind_y2)=dRho_dR(3,iGrid,Ind_y2)
     &                              +Rho_yx2*DAij_
                  dRho_dR(4,iGrid,Ind_y2)=dRho_dR(4,iGrid,Ind_y2)
     &                              +Rho_yy2*DAij_
                  dRho_dR(5,iGrid,Ind_y2)=dRho_dR(5,iGrid,Ind_y2)
     &                              +Rho_yz2*DAij_
                  dRho_dR(6,iGrid,Ind_y2)=dRho_dR(6,iGrid,Ind_y2)
     &                              +Rho_yx2*DBij_
                  dRho_dR(7,iGrid,Ind_y2)=dRho_dR(7,iGrid,Ind_y2)
     &                              +Rho_yy2*DBij_
                  dRho_dR(8,iGrid,Ind_y2)=dRho_dR(8,iGrid,Ind_y2)
     &                              +Rho_yz2*DBij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*---------- z component
*
            Ind_z1=IndGrd_Eff(3,1)
            Ind_z2=IndGrd_Eff(3,2)
            If (Ind_z1.ne.0.and.Ind_z2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_z1 =TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_zx1=TabAO1(d2Fdzdx,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_zy1=TabAO1(d2Fdzdy,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_zz1=TabAO1(d2Fdz2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_z2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdzdx,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdzdy,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdz2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_z1)=dRho_dR(1,iGrid,Ind_z1)
     &                              +Rho_z1 *DAij_
                  dRho_dR(2,iGrid,Ind_z1)=dRho_dR(2,iGrid,Ind_z1)
     &                              +Rho_z1 *DBij_
                  dRho_dR(3,iGrid,Ind_z1)=dRho_dR(3,iGrid,Ind_z1)
     &                              +Rho_zx1*DAij_
                  dRho_dR(4,iGrid,Ind_z1)=dRho_dR(4,iGrid,Ind_z1)
     &                              +Rho_zy1*DAij_
                  dRho_dR(5,iGrid,Ind_z1)=dRho_dR(5,iGrid,Ind_z1)
     &                              +Rho_zz1*DAij_
                  dRho_dR(6,iGrid,Ind_z1)=dRho_dR(6,iGrid,Ind_z1)
     &                              +Rho_zx1*DBij_
                  dRho_dR(7,iGrid,Ind_z1)=dRho_dR(7,iGrid,Ind_z1)
     &                              +Rho_zy1*DBij_
                  dRho_dR(8,iGrid,Ind_z1)=dRho_dR(8,iGrid,Ind_z1)
     &                              +Rho_zz1*DBij_
                  dRho_dR(1,iGrid,Ind_z2)=dRho_dR(1,iGrid,Ind_z2)
     &                              +Rho_z2 *DAij_
                  dRho_dR(2,iGrid,Ind_z2)=dRho_dR(2,iGrid,Ind_z2)
     &                              +Rho_z2 *DBij_
                  dRho_dR(3,iGrid,Ind_z2)=dRho_dR(3,iGrid,Ind_z2)
     &                              +Rho_zx2*DAij_
                  dRho_dR(4,iGrid,Ind_z2)=dRho_dR(4,iGrid,Ind_z2)
     &                              +Rho_zy2*DAij_
                  dRho_dR(5,iGrid,Ind_z2)=dRho_dR(5,iGrid,Ind_z2)
     &                              +Rho_zz2*DAij_
                  dRho_dR(6,iGrid,Ind_z2)=dRho_dR(6,iGrid,Ind_z2)
     &                              +Rho_zx2*DBij_
                  dRho_dR(7,iGrid,Ind_z2)=dRho_dR(7,iGrid,Ind_z2)
     &                              +Rho_zy2*DBij_
                  dRho_dR(8,iGrid,Ind_z2)=dRho_dR(8,iGrid,Ind_z2)
     &                              +Rho_zz2*DBij_
               End Do ! iGrid
            Else If (Ind_z1.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_z1 =TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
                  Rho_zx1=TabAO1(d2Fdzdx,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdx   ,iGrid,jCB_Eff)
                  Rho_zy1=TabAO1(d2Fdzdy,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdy   ,iGrid,jCB_Eff)
                  Rho_zz1=TabAO1(d2Fdz2 ,iGrid,iCB_Eff)*
     &                    TabAO2(F      ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_z1)=dRho_dR(1,iGrid,Ind_z1)
     &                              +Rho_z1 *DAij_
                  dRho_dR(2,iGrid,Ind_z1)=dRho_dR(2,iGrid,Ind_z1)
     &                              +Rho_z1 *DBij_
                  dRho_dR(3,iGrid,Ind_z1)=dRho_dR(3,iGrid,Ind_z1)
     &                              +Rho_zx1*DAij_
                  dRho_dR(4,iGrid,Ind_z1)=dRho_dR(4,iGrid,Ind_z1)
     &                              +Rho_zy1*DAij_
                  dRho_dR(5,iGrid,Ind_z1)=dRho_dR(5,iGrid,Ind_z1)
     &                              +Rho_zz1*DAij_
                  dRho_dR(6,iGrid,Ind_z1)=dRho_dR(6,iGrid,Ind_z1)
     &                              +Rho_zx1*DBij_
                  dRho_dR(7,iGrid,Ind_z1)=dRho_dR(7,iGrid,Ind_z1)
     &                              +Rho_zy1*DBij_
                  dRho_dR(8,iGrid,Ind_z1)=dRho_dR(8,iGrid,Ind_z1)
     &                              +Rho_zz1*DBij_
               End Do ! iGrid
            Else If (Ind_z2.ne.0) Then
               Do iGrid = 1, mGrid
                  Rho_z2 =TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zx2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdzdx,iGrid,jCB_Eff)
     &                   +TabAO1(dFdx   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zy2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdzdy,iGrid,jCB_Eff)
     &                   +TabAO1(dFdy   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  Rho_zz2=TabAO1(F      ,iGrid,iCB_Eff)*
     &                    TabAO2(d2Fdz2 ,iGrid,jCB_Eff)
     &                   +TabAO1(dFdz   ,iGrid,iCB_Eff)*
     &                    TabAO2(dFdz   ,iGrid,jCB_Eff)
                  dRho_dR(1,iGrid,Ind_z2)=dRho_dR(1,iGrid,Ind_z2)
     &                              +Rho_z2 *DAij_
                  dRho_dR(2,iGrid,Ind_z2)=dRho_dR(2,iGrid,Ind_z2)
     &                              +Rho_z2 *DBij_
                  dRho_dR(3,iGrid,Ind_z2)=dRho_dR(3,iGrid,Ind_z2)
     &                              +Rho_zx2*DAij_
                  dRho_dR(4,iGrid,Ind_z2)=dRho_dR(4,iGrid,Ind_z2)
     &                              +Rho_zy2*DAij_
                  dRho_dR(5,iGrid,Ind_z2)=dRho_dR(5,iGrid,Ind_z2)
     &                              +Rho_zz2*DAij_
                  dRho_dR(6,iGrid,Ind_z2)=dRho_dR(6,iGrid,Ind_z2)
     &                              +Rho_zx2*DBij_
                  dRho_dR(7,iGrid,Ind_z2)=dRho_dR(7,iGrid,Ind_z2)
     &                              +Rho_zy2*DBij_
                  dRho_dR(8,iGrid,Ind_z2)=dRho_dR(8,iGrid,Ind_z2)
     &                              +Rho_zz2*DBij_
               End Do ! iGrid
            End If
*                                                                      *
************************************************************************
*                                                                      *
*
 99         Continue
*
         End Do          ! iCB
      End Do             ! jCB
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine multdot (wrk,wrksize,
     & nind,mapda,mapia,ssa,mapdb,mapib,ssb,scalar,
     &                     rc)
c
c     this routine do dot product
c     scalar = A(ind)*B(ind)
c
c     nind        - number of indices in both A B (I)
c     mapda        - direct map of A (I)
c     mapia        - inverse map of A (I)
c     ssa        - symmetry state of A (I)
c     mapdb        - direct map of A (I)
c     mapib        - inverse map of A (I)
c     ssb        - symmetry state of B (I)
c     scalar        - final dot product (O)
c     rc        - return (error) code (O)
c
c     N.B. A and B must have same ordering of indexes
c
c     indA     indB     Implemented
c     1        1         Not yet
c     2        2           Yes
c     3        3           Yes
c     4        4           Yes
c     more              No
c
c
#include "wrk.fh"
c
       integer nind,ssa,ssb,rc
       real*8 scalar
c
       integer mapda(0:512,1:6)
       integer mapia(1:8,1:8,1:8)
c
       integer mapdb(0:512,1:6)
       integer mapib(1:8,1:8,1:8)
c
c     help variables
c
       integer symp,symq,symr,iia,iib,possa,possb,nhelp,length
       real*8 scal
c
       rc=0
c
cT    some tests
c
       do 10 nhelp=1,nind
       if (mapda(0,nhelp).ne.mapdb(0,nhelp)) then
c     RC =1 : nonidentical types of indices (NCI/Stup)
       rc=1
       return
       end if
 10     continue
c
       if (mapda(0,5).ne.mapdb(0,5)) then
c     RC =2 : nonidentical number of symmtry blocks in A and B (Stup)
       rc=2
       return
       end if
c
       if (mapda(0,6).ne.mapdb(0,6)) then
c     RC =3 : nonidentical type of A and B (Stup)
       rc=3
       return
       end if
c
       if (ssa.ne.ssb) then
c     RC =4 : nonidentical symmetry state of A and B (Stup)
       rc=4
       return
       end if
c

       if (nind.eq.4) then
c
cI    4 index matrices
c
       scalar=0.0d0
       do 100 iia=1,mapda(0,5)
c
cI.1  def parameters of A
       symp=mapda(iia,3)
       symq=mapda(iia,4)
       symr=mapda(iia,5)
c     syms is redundant
       possa=mapda(iia,1)
c
cI.2  def parameters of B
       iib=mapib(symp,symq,symr)
       possb=mapdb(iib,1)
c
cI.3  length must be common for both A and B
       length=mapda(iia,2)
c
       if (length.gt.0) then
       call mr0u3wt (length,length,length,1,1,wrk(possa),wrk(possb),
     &               scal)
       scalar=scalar+scal
       end if
c
 100    continue
c
       else if (nind.eq.3) then
c
cII   3 index matrices
c
       scalar=0.0d0
       do 200 iia=1,mapda(0,5)
c
cII.1 def parameters of A
       symp=mapda(iia,3)
       symq=mapda(iia,4)
c     symr is redundant
       possa=mapda(iia,1)
c
cII.2 def parameters of B
       iib=mapib(symp,symq,1)
       possb=mapdb(iib,1)
c
cII.3 length must be common for both A and B
       length=mapda(iia,2)
c
       if (length.gt.0) then
       call mr0u3wt (length,length,length,1,1,wrk(possa),wrk(possb),
     &               scal)
       scalar=scalar+scal
       end if
c
 200    continue
c
       else if (nind.eq.2) then
c
cIII  2 index matrices
c
       scalar=0.0d0
       do 300 iia=1,mapda(0,5)
c
cIII.1def parameters of A
       symp=mapda(iia,3)
c     symq is redundant
       possa=mapda(iia,1)
c
cIII.2def parameters of B
       iib=mapib(symp,1,1)
       possb=mapdb(iib,1)
c
cIII.3length must be common for both A and B
       length=mapda(iia,2)
c
       if (length.gt.0) then
       call mr0u3wt (length,length,length,1,1,wrk(possa),wrk(possb),
     &               scal)
       scalar=scalar+scal
       end if
c
 300    continue
c
       else if (nind.eq.1) then
c
cIV   1 index matrices
c     RC=5 : 1 index matrices (NCI)
       rc=5
       return
c
       else
cV    more than 4 index matrices
c     RC=6 : more than 4 index matrices (NCI)
       rc=6
       return
       end if
c
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(mapia)
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine DENS_CPF(C,D,ICASE,AA)

use cpf_global, only: IREF0, LN, NCONF, NORBT
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: C(*)
real(kind=wp), intent(_OUT_) :: D(*)
integer(kind=iwp), intent(in) :: ICASE(*)
real(kind=wp), intent(out) :: AA
integer(kind=iwp) :: I, II, II1, ILIM, JOJ
real(kind=wp) :: EMA
integer(kind=iwp), external :: ICUNP
real(kind=r8), external :: DDOT_

ILIM = NORBT*(NORBT+1)/2
D(1:ILIM) = Zero
C(IREF0) = Zero
AA = DDOT_(NCONF,C,1,C,1)
write(u6,20) AA
C(IREF0) = One
EMA = One-AA
II1 = (IREF0-1)*LN
do I=1,LN
  JOJ = ICUNP(ICASE,II1+I)
  if (JOJ >= 2) JOJ = JOJ-1
  II = I*(I+1)/2
  D(II) = JOJ*EMA
end do

return

20 format(5X,'SUM OF SQUARED CPX(BAR)',F10.4)

end subroutine DENS_CPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Oskar Weser                                      *
!***********************************************************************

module index_symmetry

use Index_Functions, only: iTri, nTri_Elem
use Constants, only: Two, Half
use Definitions, only: iwp

implicit none
private

public :: one_el_idx, one_el_idx_flatten, two_el_idx, two_el_idx_flatten

interface one_el_idx
  module procedure :: array_one_el_idx, tuple_one_el_idx
end interface

interface two_el_idx
  module procedure :: array_two_el_idx, tuple_two_el_idx
end interface

interface one_el_idx_flatten
  module procedure :: array_1el_idx_flatten, tuple_1el_idx_flatten
end interface

interface two_el_idx_flatten
  module procedure :: array_2el_idx_flatten, tuple_2el_idx_flatten, tuple_2el_idx_flatten_2
end interface

contains

pure subroutine tuple_one_el_idx(n,i,j)

  integer(kind=iwp), intent(in) :: n
  integer(kind=iwp), intent(out) :: i, j

  i = ceiling(-Half+sqrt(Two*n))
  j = n-nTri_Elem(i-1)

end subroutine tuple_one_el_idx

pure subroutine array_one_el_idx(n,idx)

  integer(kind=iwp), intent(in) :: n
  integer(kind=iwp), intent(out) :: idx(2)

  idx(1) = ceiling(-Half+sqrt(Two*n))
  idx(2) = n-nTri_Elem(idx(1)-1)

end subroutine array_one_el_idx

pure function array_1el_idx_flatten(idx) result(n)

  integer(kind=iwp), intent(in) :: idx(2)
  integer(kind=iwp) :: n

  n = tuple_1el_idx_flatten(idx(1),idx(2))

end function array_1el_idx_flatten

pure function tuple_1el_idx_flatten(i,j) result(n)

  integer(kind=iwp) :: n
  integer(kind=iwp), intent(in) :: i, j

  n = iTri(i,j)

end function tuple_1el_idx_flatten

pure subroutine tuple_two_el_idx(n,iorb,jorb,korb,lorb)

  integer(kind=iwp), intent(in) :: n
  integer(kind=iwp), intent(out) :: iorb, jorb, korb, lorb
  integer(kind=iwp) :: ijidx, klidx

  ijidx = ceiling(-Half+sqrt(Two*n))
  klidx = n-nTri_Elem(ijidx-1)

  iorb = ceiling(-Half+sqrt(Two*ijidx))
  jorb = ijidx-nTri_Elem(iorb-1)
  korb = ceiling(-Half+sqrt(Two*klidx))
  lorb = klidx-nTri_Elem(korb-1)

end subroutine tuple_two_el_idx

pure subroutine array_two_el_idx(n,idx)

  integer(kind=iwp), intent(in) :: n
  integer(kind=iwp), intent(out) :: idx(4)
  integer(kind=iwp) :: ijidx, klidx

  ijidx = ceiling(-Half+sqrt(Two*n))
  klidx = n-nTri_Elem(ijidx-1)

  idx(1) = ceiling(-Half+sqrt(Two*ijidx))
  idx(2) = ijidx-nTri_Elem(idx(1)-1)
  idx(3) = ceiling(-Half+sqrt(Two*klidx))
  idx(4) = klidx-nTri_Elem(idx(3)-1)

end subroutine array_two_el_idx

function array_2el_idx_flatten(idx) result(n)

  integer(kind=iwp) :: n
  integer(kind=iwp), intent(in) :: idx(4)

  n = tuple_2el_idx_flatten(idx(1),idx(2),idx(3),idx(4))

end function array_2el_idx_flatten

function tuple_2el_idx_flatten(p,q,r,s) result(pqrs)

  integer(kind=iwp) :: pqrs
  integer(kind=iwp), intent(in) :: p, q, r, s
  integer(kind=iwp) :: pq, rs

  pqrs = tuple_2el_idx_flatten_2(p,q,r,s,pq,rs)

end function tuple_2el_idx_flatten

function tuple_2el_idx_flatten_2(p,q,r,s,pq,rs) result(pqrs)

  integer(kind=iwp) :: pqrs
  integer(kind=iwp), intent(in) :: p, q, r, s
  integer(kind=iwp), intent(out) :: pq, rs

  pq = iTri(p,q)
  rs = iTri(r,s)
  pqrs = iTri(pq,rs)

end function tuple_2el_idx_flatten_2

end module index_symmetry

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Anders Bernhardsson                              *
!***********************************************************************

subroutine RHS_PT2(rkappa,CLag,SLag)
! The RHS array for CASPT2 has been already calculated in the
! CASPT2 module, so here we only need to read it from file

use MCLR_Data, only: LuPT2, nDens
use input_mclr, only: nCSF, nOrb, nRoots, nSym
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: rKappa(nDens)
real(kind=wp), intent(_OUT_) :: CLag(*)
real(kind=wp), intent(out) :: SLag(nRoots,nRoots)
integer(kind=iwp) :: i, istatus, j, nCLag, nOLag
real(kind=wp) :: Tmp

! Read in a and b part of effective gradient from CASPT2

nOLag = sum(nOrb(1:nSym)**2)
nCLag = nRoots*sum(nCSF(1:nSym))

do i=1,nCLag
  read(LUPT2,*,iostat=istatus) CLag(i)
  if (istatus < 0) call Error()
end do
do i=1,nOLag
  read(LUPT2,*,iostat=istatus) tmp ! rKappa(i)
  if (istatus < 0) call Error()
  rKappa(i) = rKappa(i)+tmp
end do
do j=1,nRoots
  do i=1,nRoots
    read(LUPT2,*,iostat=istatus) SLag(i,j)
    if (istatus < 0) call Error()
  end do
end do

return

contains

subroutine Error()

  use Definitions, only: u6

  write(u6,*)
  write(u6,'(1x,A)') 'The file which has to be written in CASPT2 module does not exist in RHS_PT2.'
  write(u6,'(1x,A)') 'For single-point gradient calculation, you need GRAD or GRDT keyword in &CASPT2.'
  write(u6,'(1x,A)') 'For geometry optimization, you do not need anything, so something is wrong with the code.'
  write(u6,*)
  call abend()

end subroutine Error

end subroutine RHS_PT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE INPCTL_RASSI()
      use rassi_global_arrays, only: HAM, ESHFT, HDIAG, JBNUM, LROOT
#ifdef _DMRG_
      use rasscf_global, only: doDMRG
      use qcmaquis_interface_cfg
      use qcmaquis_info, only: qcmaquis_info_init, qcm_prefixes
      use qcmaquis_interface_mpssi, only: qcmaquis_mpssi_init
      use cntrl, only: NACTE
      use rassi_data, only: NASH
#endif
      use mspt2_eigenvectors
      use stdalloc, only: mma_allocate, mma_deallocate
      use cntrl, only: RefEne, HEff
      use Cntrl, only:  NSTATE, NJOB, IFHEXT, IFShft, IfHDia, ISTAT,
     &                  MLTPLT, NSTAT, MXJOB, NATO, BINA, NRNATO, NBINA,
     &                  IBINA
      use cntrl, only: ATLBL, IGROUP, nAtoms, nGroup
      use Symmetry_Info, only: nSym=>nIrrep
      use rassi_data, only: ENUC,NBASF
      IMPLICIT NONE

      LOGICAL READ_STATES
      INTEGER JOB, i


* get basic info from runfile
      Call Get_iArray('nBas',nBasF,nSym)
      Call Get_dscalar('PotNuc',ENUC)

C Read data from the ONEINT file:
      CALL GETCNT(NGROUP,IGROUP,NATOMS,ATLBL)

      NSTATE=0
C Read (and do some checking) the standard input.
      CALL READIN_RASSI()
* if there have been no states selected at this point, we need to read
* the states later from the job files.
      IF(NSTATE.EQ.0) THEN
        READ_STATES=.TRUE.
        DO JOB=1,NJOB
          call rdjob_nstates(JOB)
        END DO
* store the root IDs of each state
        Call mma_allocate(JBNUM,nState,Label='JBNUM')
        Call mma_allocate(LROOT,nState,Label='LROOT')
        LROOT(:)=0
        Do JOB=1,NJOB
          DO I=0,NSTAT(JOB)-1
            JBNUM(ISTAT(JOB)+I)=JOB
          End Do
        End Do
      ELSE
        READ_STATES=.FALSE.
      END IF

      IF (NATO) THEN
        IF (NRNATO > NSTATE) NRNATO=NSTATE
      END IF
      IF (BINA) THEN
        DO I=1,NBINA
          IF (MAXVAL(IBINA(:,I)) > NSTATE) THEN
            CALL WarningMessage(2,'State number too high in NBINA')
            CALL Quit_OnUserError()
          END IF
        END DO
      END IF

#ifdef _DMRG_
      !> initialize DMRG interface
      if (doDMRG) then
        !> initialize only the qcm file name array (one for each job) and initialize the DMRG interface later
        call qcmaquis_info_init(njob,-1,0)
      endif
#endif

      !> initialize eigenvector array for mspt2 hamiltonians
      call init_mspt2_eigenvectors(njob,-1,0)
* Allocate a bunch of stuff
      Call mma_allocate(REFENE,NSTATE,Label='RefEne')
      Call mma_allocate(HEFF,NSTATE,NSTATE,Label='HEff')
      HEff(:,:)=0.0D0
      If (.not.IFHEXT) Then
        Call mma_allocate(HAM,nState,nState,Label='HAM')
        HAM(:,:)=0.0D0
      EndIf
      If (.not.IFSHFT) Then
        Call mma_allocate(ESHFT,nSTATE,Label='ESHFT')
        ESHFT(:)=0.0D0
      EndIf
      If (.not.IFHDIA) Call mma_Allocate(HDIAG,nState,Label='HDIAG')

C Read information on the job files and check for consistency
      DO JOB=1,NJOB
        CALL RDJOB(JOB,READ_STATES)
      END DO

C Number of active orbitals is taken from the first JobIph. MPS-SI cannot
C handle different active spaces per JobIph, but this is checked elsewhere
#ifdef _DMRG_
      if (doDMRG)then
        !> stupid info.h defines "sum", so I cannot use the intrinsic sum function here...
        qcmaquis_param%L = 0; do i = 1, nsym; qcmaquis_param%L =
     &  qcmaquis_param%L + nash(i); end do

        ! Initialise the new MPSSI interface
        call qcmaquis_mpssi_init(qcm_prefixes,
     &                           LROOT,NSTAT(1),NJOB)

      ! Check if number of active electrons is the same for all job files
      ! Otherwise, quit on error, as Dyson orbitals are not supported yet with DMRG
      if (NJOB.gt.1) then
        JOB=NACTE(1)
        do i=2,NJOB
          if (NACTE(i).ne.JOB) then
            Call WarningMessage(2,'Number of active electrons')
            Write(6,*)' is not the same in different JOBIPH files'
            Write(6,*)' Dyson orbitals are not yet supported in MPSSI.'
            Call Quit_OnUserError()
          end if
        end do
      end if

      end if
#endif

* set orbital partitioning data
      CALL WFNSIZES_RASSI()

C Added by Ungur Liviu on 04.11.2009
C Addition of NJOB,MSJOB and MLTPLT on RunFile.

      CALL Put_iscalar('NJOB_SINGLE',NJOB)
      CALL Put_iscalar('MXJOB_SINGLE',MXJOB)
      CALL Put_iArray('MLTP_SINGLE',MLTPLT,MXJOB)

      CALL Put_iArray('NSTAT_SINGLE',NSTAT,MXJOB)
!     CALL Put_iArray('ISTAT_SINGLE',ISTAT,MXJOB)
C
C .. and print it out

C Additional input processing. Start writing report.
      CALL INPPRC()
*
      Call mma_deallocate(REFENE)
      Call mma_deallocate(HEff)
C
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine chi( M1, M2, E, N, T, Z, X)
!     computes the chi  of one site
! definition of the variables:
!     N -- number of states included in the calculation of chi, Integer, input
!    M1 -- moment 1, Complex*16, (3,N,N) array, input
!    M2 -- moment 2, Complex*16, (3,N,N) array, input
!     E -- energy of the N states, Real(kind=8) ::, (N) array, input
!     T -- temperature at which the chi is computed, Real(kind=8) ::, input
!     Z -- statistical sum according to Boltzmann distribution law, Real(kind=8) ::, output
!     X -- susceptibility tensor, Real(kind=8) ::, (3,3) array, output
!--------
!  temporary (local) variables:
! iS,jS -- denote states over which the chi is computed
!    pB   -- partial Boltzmann population of a given state, Real(kind=8) ::
!    dE -- energy diference E(i)-E(j)

      Implicit None
      Integer, parameter           :: wp=kind(0.d0)
      Integer, intent(in)          :: N
      Real(kind=8), intent(in)    :: E(N), T
      Complex(kind=8), intent(in) :: M1(3,N,N), M2(3,N,N)
      Real(kind=8), intent(out)   :: Z, X(3,3)
! local variables
      Integer                      :: i,j,iS,jS
      Real(kind=8)                :: pB, dE, c2(3,3), R, F
      Real(kind=8)                :: boltz_k

      boltz_k=0.6950356_wp !   in cm^-1*k-1

      pB=0.0_wp
      dE=0.0_wp
      Z =0.0_wp
      Call dcopy_(3*3,[0.0_wp],0,X,1)

      Do iS=1,N
      ! first loop over all states
         Call dcopy_(3*3,[0.0_wp],0,c2,1)
         ! pB = statistical sum for state iS at temperature T
         pB = exp( -E(iS)/ boltz_k / T )
         ! accumulate the total statistical sum Z
         Z =  Z + pB
         Do jS=1,N
         ! second loop over all states
            dE=E(iS)-E(jS)
            ! set the multiplication factor:
            If(abs(dE) < 0.001_wp) Then
               F= 1.0_wp
            Else
               F=-2.0_wp*boltz_k * T / dE
            End If
            ! accumulate the contributions to the X tensor:
            Do i=1,3
               Do j=1,3
                  R=dble( M1(i,iS,jS)* conjg(M2(j,iS,jS)) )
                  c2(i,j) = c2(i,j) + F*R
               End Do ! j
            End Do ! i
         End Do ! jS

         ! add the (iS) contribution to the X tensor, according to its
         ! Boltzmann distribution:
         Call daxpy_(3*3,pB,c2,1,X,1)
      End Do ! iS

      ! scale the total tensor by the total statistical sum Z:
      Call dscal_(3*3, 1.0_wp/Z, X, 1)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Merge_Constraints(FileIn1,FileIn2,FileOut,
     &                             nLambda,iRow_c)
      Implicit None
      Character(Len=*), Intent(in) :: FileIn1, FileIn2, FileOut
      Integer, Intent(inout) :: nLambda, iRow_c
      Integer :: Lu1, Lu2, Lu3, isFreeUnit, AixRm
      Character(Len=180) :: Line, Get_Ln
      Character(Len=6) :: Tag
      Logical :: Found, AuxFile
      External :: Get_Ln, isFreeUnit, AixRm
      Integer :: i, j, Lu, iErr

* Open the input files if they exist
      Lu1=0
      If (FileIn1.ne.'') Then
        Call f_Inquire(FileIn1,Found)
        If (Found) Then
          Lu1=isFreeUnit(30)
          Call Molcas_Open(Lu1,FileIn1)
        End If
      End If

      Lu2=0
      If ((FileIn2.ne.'').and.(FileIn2.ne.FileIn1)) Then
        Call f_Inquire(FileIn2,Found)
        If (Found) Then
          Lu2=isFreeUnit(30)
          Call Molcas_Open(Lu2,FileIn2)
        End If
      End If

* Set the output file as a third file, or a temporary one
      If (((FileOut.eq.FileIn1).and.(Lu1.ne.0)).or.
     &    ((FileOut.eq.FileIn2).and.(Lu2.ne.0))) Then
        AuxFile=.True.
      Else
        AuxFile=.False.
      End If

      nLambda=0
      iRow_c=0

* If there are no input files, only delete the output file if it exists
      If ((Lu1.eq.0).and.(Lu2.eq.0)) Then
        If (.not.AuxFile) Then
          Call f_Inquire(FileOut,Found)
          If (Found) iErr = AixRm(FileOut)
        End If
        Return
* Otherwise, open it
      Else
        Lu3=isFreeUnit(30)
        If (AuxFile) Then
          Call Molcas_Open(Lu3,'purge')
        Else
          Call Molcas_Open(Lu3,FileOut)
        End If
      End If

* Copy the constraints to the output file, counting the lines
* Copy only from existing files
      Do i=1,2
        If (i.eq.1) Tag='VALUES'
        If (i.eq.2) Tag='END'

        Do j=1,2
          If (j.eq.1) Lu=Lu1
          If (j.eq.2) Lu=Lu2
          If (Lu.eq.0) Cycle
          Line=AdjustL(Get_Ln(Lu))
          Call UpCase(Line)
          Do While (Line(1:4).ne.Tag(1:4))
            If (Index(Line,'&').eq.0) Then
              iRow_c=iRow_c+1
              If (i.eq.2) nLambda=nLambda+1
              If (Index(Line,'=').eq.0) Call FixEqualSign(Line,Lu)
            End If
            Write(Lu3,100) Trim(Line)
            Line=AdjustL(Get_Ln(Lu))
            Call UpCase(Line)
          End Do
        End Do

        Write(Lu3,100) Trim(Tag)
      End Do
      iRow_c=iRow_c+1

* Close files, and copy temporary if used
      If (Lu1.ne.0) Close (Lu1)
      If (Lu2.ne.0) Close (Lu2)
      If (Lu3.ne.0) Close (Lu3)
      If (AuxFile) Call fCopy('purge',FileOut,iErr)

100   Format (A)
      End Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Roland Lindh                                     *
!***********************************************************************

subroutine Start6(FName,LuOrb,CMO,mBB,nD,EOrb,OccNo,mmB)
!***********************************************************************
!                                                                      *
!     purpose: Generate constrained orbitals from INPORB               *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use SpinAV, only: Do_SpinAV, DSC
use InfSCF, only: DoCholesky, E_nondyn, Erest_xc, FileOrb_id, IndxC, isHDF5, MaxBas, MxConstr, nBas, nBB, nBT, nConstr, nDel, &
                  nFro, nnB, nOcc, nOrb, nSym, s2CNO, VTitle
use Cholesky, only: ChFracMem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: FName
integer(kind=iwp), intent(in) :: LuOrb, mBB, nD, mmB
real(kind=wp), intent(out) :: CMO(mBB,nD), EOrb(mmB,nD), OccNo(mmB,nD)
integer(kind=iwp) :: i, ibas, ic1, ic2, iCMO, iComp, iDaa, iDbb, iDSc, iDummy(1), iErr, Indx, iOcc, iOff, iOpt, ipDaa, ipDbb, &
                     ipDScc, ipMK, ipML, iRC, iSym, iSymLbl, iWFType, j, jc, ji, jOcc, jOff, k, kc, kc1, kc2, kDSc, kk, kkc, kks, &
                     l, lc, lc1, lc2, llc, lls, lOcc, lOff, lsq, ltri, Lu_, mAdCMOO, mOff, nBD(8), nDiff_ab, nHoles(8), nIF(8), &
                     nRASO(8), nSsh(8), nSsh_ab(8), nTmp(8), nZero(8)
real(kind=wp) :: Dummy(1), ThrD, xNorm, xOkk, yOkk
character(len=62) :: Line
character(len=8) :: Label
integer(kind=iwp), allocatable :: ID_vir(:), IndT(:), Match(:,:)
real(kind=wp), allocatable :: Corb(:), Da(:,:), SAV(:), SLT(:), SQ(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

Erest_xc = Zero

if (.not. DoCholesky) then
  write(u6,*)
  write(u6,*) ' ERROR in Constrained SCF: problem in start6.'
  write(u6,*) '*** Constrained NOs implemented only with CD or RI.'
  write(u6,*) '*** Use Cholesky or RICD in Seward and rerun! *****'
  call Abend()
end if

do iSym=1,nSym
  nDiff_ab = nOcc(iSym,1)-nOcc(iSym,2)
  if (nDiff_ab < 0) then
    write(u6,*)
    write(u6,*) ' ERROR in Constrained SCF: problem in start6.'
    write(u6,*) '*** #alpha < #beta not permitted in CNOs    ***'
    write(u6,*) '*** Change SCF input accordingly and rerun! ***'
    call Abend()
  end if
  nHoles(iSym) = nDiff_ab
end do

write(u6,*) ' -------------------------------------------------'
if (Do_SpinAV) then
  write(u6,*) ' Spin-averaged wavelets (+/-) '
else
  write(u6,*) ' Configuration of the constrained spins (up/down) '
end if
write(u6,*) ' -------------------------------------------------'
do iSym=1,nSym
  write(u6,'(1X,A,I1)') ' sym: ',iSym
  Line(1:14) = '         (+) '
  k = 15
  do j=1,nConstr(iSym)
    if (indxC(j,1,iSym) == 1) then
      if (Do_SpinAV) then
        Line(k:k+2) = ' + '
      else
        Line(k:k+2) = ' u '
      end if
    else if (indxC(j,1,iSym) == 2) then
      if (Do_SpinAV) then
        Line(k:k+2) = ' - '
      else
        Line(k:k+2) = ' d '
      end if
    else
      Line(k:k+2) = '   '
    end if
    k = k+3
  end do
  write(u6,*) Line(1:k-1)
  Line(1:14) = '         (-) '
  k = 15
  do j=1,nConstr(iSym)
    if (indxC(j,2,iSym) == 1) then
      if (Do_SpinAV) then
        Line(k:k+2) = ' + '
      else
        Line(k:k+2) = ' u '
      end if
    else if (indxC(j,2,iSym) == 2) then
      if (Do_SpinAV) then
        Line(k:k+2) = ' - '
      else
        Line(k:k+2) = ' d '
      end if
    else
      Line(k:k+2) = '   '
    end if
    k = k+3
  end do
  write(u6,*) Line(1:k-1)
end do
write(u6,*) ' -------------------------------------------------'

Lu_ = LuOrb
call mma_Allocate(IndT,nnB,Label='IndT')
if (isHDF5) then
  call RdVec_HDF5(fileorb_id,'COEI',nSym,nBas,CMO,OccNo,EOrb,IndT)
else
  call RdVec_(FName,Lu_,'COEI',0,nSym,nBas,nOrb,CMO,Dummy,OccNo,Dummy,EOrb,Dummy,IndT,VTitle,1,iErr,iWFtype)
end if
call RdTwoEnrg(Lu_,E_nondyn)
call VecSort(nSym,nBas,nBas,CMO,OccNo,IndT,0,iDummy,iErr)
indx = 1
nZero(1:nSym) = 0
nTmp(1:nSym) = 0
nIF(1:nSym) = 0
nRASO(1:nSym) = 0
do iSym=1,nSym
  nDiff_ab = 0
  do iBas=1,nBas(iSym)
    select case (IndT(indx))
      case (1,2)
        nIF(iSym) = nIF(iSym)+1 ! froz + inac orbitals
      case (3)
        nIF(iSym) = nIF(iSym)+1  ! electrons (place them in RAS1)
        nDiff_ab = nDiff_ab+1
      case (4,5)
        nRASO(iSym) = nRASO(iSym)+1
      case (7)
        nTmp(iSym) = nTmp(iSym)+1
    end select
    indx = indx+1
  end do
  if (nRASO(iSym) /= 2*nConstr(iSym)) then
    write(u6,*) ' ERROR in Constrained SCF: problem in start6.'
    write(u6,*) ' Detected inconsistency between # of partially occupied orbitals and # of constraints. Sym: ',iSym
    call Abend()
  end if
  if (nHoles(iSym) /= nDiff_ab) then
    write(u6,*) ' ERROR in Constrained SCF: problem in start6.'
    write(u6,*) ' Detected inconsistency between # of excess alpha orbitals and # of RAS1 orbitals. Sym: ',iSym
    call Abend()
  end if
  if (nOrb(iSym) > nBas(iSym)-nTmp(iSym)) then
    nOrb(iSym) = nBas(iSym)-nTmp(iSym)
    nDel(iSym) = nTmp(iSym)
  end if
end do

call TrimCMO(CMO,nSym,nBas,nOrb)
call TrimEor(EOrb,nSym,nBas,nOrb)
call mma_deallocate(IndT)

call Setup_SCF()

nBD(1) = 0
do iSym=2,nSym
  nBD(iSym) = nBD(iSym-1)+nTri_Elem(nBas(iSym-1))
end do
call mma_allocate(Da,nBT,2,Label='Da')
Da(:,:) = Zero
call mma_allocate(Match,2,MxConstr,Label='Match')
call mma_allocate(Corb,MaxBas,Label='Corb')

if (Do_SpinAV) call mma_allocate(SAV,2*MaxBas**2,Label='SAV')

iOff = 1
jOff = 0
do iSym=1,nSym
  CMO(iOff:iOff+nBas(iSym)*nOrb(iSym)-1,2) = CMO(iOff:iOff+nBas(iSym)*nOrb(iSym)-1,1)
  EOrb(jOff+1:jOff+nOrb(iSym),2) = EOrb(jOff+1:jOff+nOrb(iSym),1)
  lOcc = 1+jOff+nIF(iSym)
  OccNo(1:nRASO(iSym),2) = OccNo(lOcc:lOcc+nRASO(iSym)-1,1)
  call BestMatch(nConstr(iSym),nRASO(iSym),OccNo(1,2),Match,MxConstr)
  do i=1,nConstr(iSym)
    k = Match(1,i) ! (+) wavelet
    jOcc = jOff+nIF(iSym)+k
    xOkk = OccNo(jOcc,1)/Two
    kc = iOff+nBas(iSym)*(nIF(iSym)+k-1)
    l = Match(2,i)  ! (-) wavelet
    iOcc = jOff+nIF(iSym)+l
    yOkk = OccNo(iOcc,1)/Two
    xnorm = sqrt(abs(xOkk)+abs(yOkk)) ! ensures correct normaliz
    lc = iOff+nBas(iSym)*(nIF(iSym)+l-1)
    xOkk = sqrt(abs(xOkk))/xnorm
    yOkk = sqrt(abs(yOkk))/xnorm
    if (Do_SpinAV) then
      kkc = 1+nBas(iSym)*(k-1)
      llc = 1+nBas(iSym)*(nConstr(iSym)+l-1)
      SAV(kkc:kkc+nBas(iSym)-1) = CMO(kc:kc+nBas(iSym)-1,1)-xOkk*CMO(lc:lc+nBas(iSym)-1,1)
      SAV(llc:llc+nBas(iSym)-1) = xOkk*CMO(lc:lc+nBas(iSym)-1,1)+yOkk*CMO(kc:kc+nBas(iSym)-1,1)
    end if
    Corb(1:nBas(iSym)) = xOkk*CMO(kc:kc+nBas(iSym)-1,1)
    CMO(kc:kc+nBas(iSym)-1,1) = Corb(1:nBas(iSym))+yOkk*CMO(lc:lc+nBas(iSym)-1,1)
    CMO(lc:lc+nBas(iSym)-1,1) = Corb(1:nBas(iSym))-yOkk*CMO(lc:lc+nBas(iSym)-1,1)
  end do
  jc = 1
  kc = nConstr(iSym)+1
  do i=1,nConstr(iSym)
    l = Match(indxC(i,2,iSym),i)
    lc1 = iOff+nBas(iSym)*(nIF(iSym)+l-1)
    lc2 = iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym)+jc-1)
    CMO(lc2:lc2+nBas(iSym)-1,2) = CMO(lc1:lc1+nBas(iSym)-1,1)
    k = Match(indxC(i,1,iSym),i)
    kc1 = iOff+nBas(iSym)*(nIF(iSym)+k-1)
    kc2 = iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym)+kc-1)
    CMO(kc2:kc2+nBas(iSym)-1,2) = CMO(kc1:kc1+nBas(iSym)-1,1)
    jc = jc+1
    kc = kc+1
  end do
  kc = nConstr(iSym)+1
  do i=1,nConstr(iSym)
    ic1 = iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym)+i-1)
    ic2 = iOff+nBas(iSym)*(nIF(iSym)+kc-1)
    CMO(ic2:ic2+nBas(iSym)-1,1) = CMO(ic1:ic1+nBas(iSym)-1,2)
    kc1 = iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym)+kc-1)
    kc2 = iOff+nBas(iSym)*(nIF(iSym)+i-1)
    CMO(kc2:kc2+nBas(iSym)-1,1) = CMO(kc1:kc1+nBas(iSym)-1,2)
    kc = kc+1
  end do
  kc = nConstr(iSym)+1  ! wavelets in virt space
  if (Do_SpinAV) then
    do i=1,nConstr(iSym)
      k = Match(1,i)
      kks = 1+nBas(iSym)*(k-1)
      l = Match(2,i)
      lls = 1+nBas(iSym)*(nConstr(iSym)+l-1)
      mOff = iOff+nBas(iSym)*(nIF(iSym)+kc-1)
      kk = indxC(i,1,iSym)
      if (kk == 1) then ! => (+) wavelet is in alpha
        ipMK = mOff
        ipML = mOff-nBas(iSym)*nHoles(iSym)
        CMO(ipMK:ipMK+nBas(iSym)-1,1) = SAV(kks:kks+nBas(iSym)-1)
        CMO(ipML:ipML+nBas(iSym)-1,2) = SAV(lls:lls+nBas(iSym)-1)
      else if (kk == 2) then
        ipMK = mOff-nBas(iSym)*nHoles(iSym)
        ipML = mOff
        CMO(ipMK:ipMK+nBas(iSym)-1,2) = SAV(kks:kks+nBas(iSym)-1)
        CMO(ipML:ipML+nBas(iSym)-1,1) = SAV(lls:lls+nBas(iSym)-1)
      else
        ipMK = 666666  ! avoid compiler wrngs
        ipML = 666666
        write(u6,*) ' Start6: wrong indxC value: ',kk
        call Abend()
      end if
      kc = kc+1
    end do
  end if
  iOff = iOff+nBas(iSym)*nOrb(iSym)
  jOff = jOff+nOrb(iSym)
end do

if (Do_SpinAV) then
  call mma_deallocate(SAV)
  call mma_Allocate(DSc,nBB,Label='DSc')
  DSC(:) = Zero
end if

iOff = 1
lOff = 0
do iSym=1,nSym
  ipDaa = 1+nBD(iSym)
  mAdCMOO = iOff+nBas(iSym)*nIF(iSym)
  call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nConstr(iSym), &
                 One,CMO(mAdCMOO,1),nBas(iSym), &
                 CMO(mAdCMOO,1),nBas(iSym), &
                 Zero,Da(ipDaa,1),nBas(iSym))
  ipDbb = 1+nBD(iSym)
  mAdCMOO = iOff+nBas(iSym)*(nIF(iSym)-nHoles(iSym))
  call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nConstr(iSym), &
                 One,CMO(mAdCMOO,2),nBas(iSym), &
                 CMO(mAdCMOO,2),nBas(iSym), &
                 Zero,Da(ipDbb,2),nBas(iSym))

  if (Do_SpinAV) then
    ipDScc = lOff
    do j=1,nBas(iSym)
      do i=1,j
        ji = iTri(j,i)
        iDaa = ipDaa-1+ji
        iDbb = ipDbb-1+ji
        iDSc = ipDScc+nBas(iSym)*(j-1)+i
        DSc(iDSc) = Half*(Da(iDaa,1)-Da(iDbb,2))
        kDSc = ipDScc+nBas(iSym)*(i-1)+j
        DSc(kDSc) = DSc(iDSc)
      end do
    end do
    lOff = lOff+nBas(iSym)**2
  end if

  do j=1,nBas(iSym)
    do i=1,j-1
      ji = iTri(j,i)
      iDaa = ipDaa-1+ji
      Da(iDaa,1) = Two*Da(iDaa,1)
      iDbb = ipDbb-1+ji
      Da(iDbb,2) = Two*Da(iDbb,2)
    end do
  end do
  iOff = iOff+nBas(iSym)*nOrb(iSym)
end do

call Cho_X_init(irc,ChFracMem)
if (irc /= 0) then
  call WarningMessage(2,'Start6. Non-zero rc in Cho_X_init.')
  call Abend()
end if
!----------------------------------------------------------------------*
call Get_Fmat_nondyn(Da(:,1),Da(:,2),nBT,.false.)
!----------------------------------------------------------------------*

call Cho_X_Final(irc)
if (irc /= 0) then
  call WarningMessage(2,'Start6. Non-zero rc in Cho_X_Final.')
  call Abend()
end if

call mma_deallocate(Da)
call mma_deallocate(Corb)
call mma_deallocate(Match)

iOff = 0
jOff = 0
do iSym=1,nSym
  OccNo(iOff+1:iOff+nOcc(iSym,1),1) = One
  OccNo(iOff+nOcc(iSym,1)+1:iOff+nOrb(iSym),1) = Zero
  OccNo(iOff+1:iOff+nOcc(iSym,2),2) = One
  OccNo(iOff+nOcc(iSym,2)+1:iOff+nOrb(iSym),2) = Zero
  iOff = iOff+nOrb(iSym)
end do

call mma_allocate(SLT,nBT,Label='SLT')
isymlbl = 1
iOpt = ibset(ibset(0,sNoOri),sNoNuc)
Label = 'Mltpl  0'
iComp = 1
call RdOne(irc,iOpt,Label,iComp,SLT,isymlbl)
if (irc /= 0) then
  write(u6,*) ' Start6 : error in getting overlap matrix '
  call Abend()
end if
call s2calc(CMO(:,1),CMO(:,2),SLT,nOcc(:,1),nOcc(:,2),nBas,nOrb,nSym,s2CNO)

if (.not. Do_SpinAV) then
  write(u6,'(A,f9.6)') '  Initial value of Total Spin, S(S+1): ',s2CNO
  write(u6,*) ' -------------------------------------------------'
end if
write(u6,*)

!----------------------------------------------------------------------*
!  Virtual space must be orthogonal to the occupied space              *
!----------------------------------------------------------------------*
if (Do_SpinAV) then
  nOcc(1:nSym,1) = nOcc(1:nSym,1)+nConstr(1:nSym)
  nOcc(1:nSym,2) = nOcc(1:nSym,2)+nConstr(1:nSym)
end if

Thrd = 1.0e-6_wp
nSsh(1:nSym) = nOrb(1:nSym)-nOcc(1:nSym,1)-nFro(1:nSym)
nSsh_ab(1:nSym) = nOrb(1:nSym)-nOcc(1:nSym,2)-nFro(1:nSym)

call mma_allocate(SQ,nBB,Label='SQ')
ltri = 1
lsq = 1
do iSym=1,nSym
  call Square(SLT(ltri),SQ(lsq),1,nBas(iSym),nBas(iSym))
  ltri = ltri+nTri_Elem(nBas(iSym))
  lsq = lsq+nBas(iSym)**2
end do
call mma_allocate(ID_vir,nnB,Label='ID_vir')
call Cho_ov_Loc(irc,Thrd,nSym,nBas,nOcc(:,1),nZero,nZero,nSsh,CMO(:,1),SQ,ID_vir)

if (irc /= 0) then
  write(u6,*) ' Start6 : error in getting alpha virt MOs '
  call Abend()
end if

iOff = 1
do iSym=1,nSym
  iCMO = iOff+nBas(iSym)*(nFro(iSym)+nOcc(iSym,1))
  call Ortho_Orb(CMO(iCMO:,1),SQ,nBas(iSym),nSsh(iSym),2,.true.)
  iOff = iOff+nBas(iSym)*nOrb(iSym)
end do
!call ChkOrt(1,Whatever) ! silent

call Cho_ov_Loc(irc,Thrd,nSym,nBas,nOcc(1,2),nZero,nZero,nSsh_ab,CMO(:,2),SQ,iD_vir)

if (irc /= 0) then
  write(u6,*) ' Start6 : error in getting beta virt MOs '
  call Abend()
end if

iOff = 1
do iSym=1,nSym
  iCMO = iOff+nBas(iSym)*(nFro(iSym)+nOcc(iSym,2))
  call Ortho_Orb(CMO(iCMO:,2),SQ,nBas(iSym),nSsh_ab(iSym),2,.true.)
  iOff = iOff+nBas(iSym)*nOrb(iSym)
end do
!call ChkOrt(2,Whatever) ! silent

if (Do_SpinAV) then ! reset # of occupied
  nOcc(1:nSym,1) = nOcc(1:nSym,1)-nConstr(1:nSym)
  nOcc(1:nSym,2) = nOcc(1:nSym,2)-nConstr(1:nSym)
end if

call mma_deallocate(ID_vir)
call mma_deallocate(SQ)
call mma_deallocate(SLT)

return

end subroutine Start6

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 2005  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine EQCTL1()
! On return, the following data sets will be defined and stored
! on LUSOLV.
! At position IVEC=IRHS, the RHS array, in SR representation.
! At position IVEC=IVECX, the solution array, in SR representation.
! At position IVEC=IVECR, the residual array, in SR representation.
! At position IVEC=IVECC, the solution array, in contravariant rep.
! At position IVEC=IVECC2, the solution array, in covariant repr.
! At position IVEC=IVECW, the RHS array, in contravariant repr.

use EQSOLV, only: iRHS, iVecc, iVecc2, iVecR, iVecW, iVecX, MxSct, ModVec, IDSMat, IDBMat, IDTMat, IDSTMat
use caspt2_global, only: do_grad, IDSCT, LUSBT, LUSOLV
use caspt2_module, only: HZERO, MxCase, nASup, nCases, nG2, nG3Tot, nInDep, nISup, nSym
use SC_NEVPT2, only: IDBMAT_NEVPT2
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u6, ItoB, RtoI

implicit none
integer(kind=iwp) :: ICASE, IDS, IDS1, IDS2, IDUM(1), IDV, iPad, iPARDIV, ISCT, ISYM, IVEC, LADDR, LENGTH, LSTA, MXWRT, NAS, NB, &
                     NBD, NCOEF, NG3MAX, NID, NIDSCT, NIN, NIS, NISCT, NS, NT
real(kind=wp) :: DUMMY(1)
integer(kind=iwp), parameter :: MXBLK = 40*256*256, MXVEC = 6

IRHS = 1
IVECX = 2
IVECR = 3
IVECC = 4
IVECC2 = 5
IVECW = 6

!SVC: MODVEC isn't used in the Cholesky version, and neither in the
! sigma routines any more. Probably only in MKRHS...
MXSCT = 1
do ICASE=1,NCASES
  do ISYM=1,NSYM
    MODVEC(ISYM,ICASE) = 0
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    NCOEF = NAS*NIS
    if (NCOEF > 0) then
      ! Module lengths for reading/writing:
      MODVEC(ISYM,ICASE) = max(1,min(MXBLK/NAS,NIS))
      MXSCT = max(MXSCT,1+(NIS-1)/MODVEC(ISYM,ICASE))
    end if
  end do
end do
NIDSCT = MXSCT*8*MXCASE*MXVEC
call mma_allocate(IDSCT,NIDSCT,Label='IDSCT')

#ifdef _DEBUG
!SVC: when using Cholesky decomposition, the actual use of the RHS
! vector sizes is automatically controlled in RHSALL2. Furthermore, the
! sigma routines now use the full RHS size.
if (.not. IFCHOL) then
  write(u6,*)
  write(u6,*) ' Size of vector buffers for coefficient arrays.'
  write(u6,*) ' ICASE ISYM    NROW     NCOL     NBLK       Size'
  NVCMX = 0
  do ICASE=1,NCASES
    do ISYM=1,NSYM
      NROW = NASUP(ISYM,ICASE)
      NCOL = MODVEC(ISYM,ICASE)
      NVC = NROW*NCOL
      NVCMX = max(NVCMX,NVC)
      NBLK = 0
      if (NVC > 0) NBLK = 1+(NISUP(ISYM,ICASE)-1)/NCOL
      write(u6,'(2x,I2,3x,I2,3x,I16,3X,I16,3X,I16,3x,I16)') ICASE,ISYM,NROW,NCOL,NBLK,NVC
    end do
  end do
  write(u6,*)
  write(u6,*) ' Largest vector buffer size:',NVCMX
  write(u6,*)
else
  write(u6,*)
  write(u6,*) ' Sizes of the coefficient arrays.'
  write(u6,'(2X,A4,2X,A4,2X,5X,A4,5X,2X,5X,A4,5X,2X,5X,A4,5X)') 'CASE','SYM','NROW','NCOL','SIZE'
  NVCMX = 0
  do ICASE=1,NCASES
    do ISYM=1,NSYM
      NROW = NASUP(ISYM,ICASE)
      NCOL = NISUP(ISYM,ICASE)
      NVC = NROW*NCOL
      NVCMX = max(NVCMX,NVC)
      write(u6,'(2x,I4,2x,I4,2x,I16,2X,I16,2X,I16)') ICASE,ISYM,NROW,NCOL,NVC
    end do
  end do
  write(u6,*)
  write(u6,'(A,I14)') ' Largest vector size: ',NVCMX
  write(u6,*)
end if
#endif

IDV = 0
if (do_grad) then
  !! idxG3 matrix is needed for computing Lagrangian. Here, the
  !! shift avoids the matrix overwritten in PCOLLVEC -> SOLV2DRA
  NG3MAX = iPARDIV(NG3TOT,NG2)
  iPad = ItoB-mod(6*NG3MAX,ItoB)
  IDV = 6*NG3MAX+iPad
end if
do IVEC=1,MXVEC
  do ICASE=1,NCASES
    do ISYM=1,NSYM
      NAS = NASUP(ISYM,ICASE)
      NIS = NISUP(ISYM,ICASE)
      ! NINDEP() IS HERE SET PROVISIONALLY. IT WILL
      ! BE ADJUSTED FOR LINEAR DEPENDENCE LATER.
      NCOEF = NAS*NIS
      MXWRT = max(1,NAS*MODVEC(ISYM,ICASE))
      NISCT = NCOEF/MXWRT+min(1,mod(NCOEF,MXWRT))
      LADDR = 1+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1)))
      if (NISCT == 0) IDSCT(LADDR) = IDV
      if (NISCT > MXSCT) then
        write(u6,*) 'EQCTL1 : NISCT= ',NISCT,' > MXSCT= ',MXSCT
        write(u6,*) 'Please, increase MXSCT in eqsolv'
        write(u6,*) 'Do not forget to recompile Molcas afterwards.'
        call Abend()
      end if
      do ISCT=1,NISCT
        LSTA = MXWRT*(ISCT-1)
        LENGTH = RtoI*min(NCOEF-LSTA,MXWRT)
        LADDR = ISCT+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1)))
        IDSCT(LADDR) = IDV
        call IDAFILE(LUSOLV,0,IDUM,LENGTH,IDV)
      end do
    end do
  end do
end do

! IDSCT(ISCT,ISYM,ICASE,IVEC) now gives the disk address, on LUSOLV,
! to the ISCT section of the (ISYM,ICASE) block of a vector
! containing expansion C coefficients of excitation operators.
! IVEC=1..MXVEC enumerates the different vectors needed to solve
! the equations.
IDSMAT(:,:) = -1
IDS = 0
do ICASE=1,NCASES
  do ISYM=1,NSYM
    NIN = NINDEP(ISYM,ICASE)
    if (NIN > 0) then
      IDSMAT(ISYM,ICASE) = IDS
      NAS = NASUP(ISYM,ICASE)
      !NS = nTri_Elem(NAS)
      NS = NAS**2
      if (ICASE == 12) NS = 1
      if (ICASE == 13) NS = 1
      call DDAFILE(LUSBT,0,DUMMY,NS,IDS)
    end if
  end do
end do

! IDSMAT(ISYM,ICASE) gives the disk address on LUSBT to the
! (ISYM,ICASE) section of the overlap matrix for the basis
! of excitation wave function terms: those that result from
! the basic excitation operators acting on Psi0.
do ICASE=1,NCASES
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    !NB = nTri_Elem(NAS)
    NB = NAS**2
    if (ICASE == 12) NB = 1
    if (ICASE == 13) NB = 1
    IDBMAT(ISYM,ICASE) = IDS
    NBD = NAS
    NID = NIS
    NT = NAS**2
    if (ICASE == 12) NT = 1
    if (ICASE == 13) NT = 1
    IDS1 = IDS
    if (NB > 0) call DDAFILE(LUSBT,0,DUMMY,NB,IDS1)
    IDS2 = IDS
    if (NBD > 0) call DDAFILE(LUSBT,0,DUMMY,NBD,IDS2)
    if (NID > 0) call DDAFILE(LUSBT,0,DUMMY,NID,IDS2)
    if (NBD > 0) call DDAFILE(LUSBT,0,DUMMY,NBD,IDS2)
    if (NID > 0) call DDAFILE(LUSBT,0,DUMMY,NID,IDS2)
    IDTMAT(ISYM,ICASE) = IDS2
    if (NT > 0) call DDAFILE(LUSBT,0,DUMMY,NT,IDS2)
    IDSTMAT(ISYM,ICASE) = IDS2
    if (NT > 0) call DDAFILE(LUSBT,0,DUMMY,NT,IDS2)
    IDS = max(IDS1,IDS2)
    if (HZERO == 'DYALL') then
      IDBMAT_NEVPT2(ISYM,ICASE,1) = IDS
      if (NT > 0) call DDAFILE(LUSBT,0,DUMMY,NT,IDS)
      IDBMAT_NEVPT2(ISYM,ICASE,2) = IDS
      if (NID > 0) call DDAFILE(LUSBT,0,DUMMY,NID,IDS)
    end if
  end do
end do

! IDBMAT(ISYM,ICASE) is similar to IDSMAT() but gives disk address
! to the (ISYM,ICASE) diagonal block of matrix elements of H0
! over the excitation wave function terms.
! IDTMAT() similarly addresses transformation matrices that
! orthonormalize the S matrix blocks.

end subroutine EQCTL1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Bruno Tenorio                                    *
!***********************************************************************

! Print the reduced 2-e TDM in ASCII format.
! Code adapted from trd_print written by P. A. Malmqvist.
! -------------------------------------------------------------
! The spin coupling matrix elements have the following index-code:
!             SPIN=1 means  K2V (AAB+BBB)
!             SPIN=-1 means SDA (AAA+BBA)
! Notice, SPIN here has nothing to do with the spin quantum number. It
! is just a printing code.
! ------------------------------------------------------------
subroutine RTDM2_PRINT(ISTATE,JSTATE,EIJ,NDYSAB,DYSAB,NRT2MAB,RT2M,CMO1,CMO2,AUGSPIN)

use Cntrl, only: LSYM1, LSYM2, OCAA, OCAN
use Symmetry_Info, only: MUL, nIrrep
use rassi_data, only: NASH, NASHT, NBASF, NFRO, NISH, NOSH
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ISTATE, JSTATE, NDYSAB, NRT2MAB, AUGSPIN
real(kind=wp), intent(in) :: EIJ, CMO1(*), CMO2(*)
real(kind=wp), intent(inout) :: DYSAB(*), RT2M(*)
integer(kind=iwp) :: I, IA, IO, IOFFA(8), IOFFO(8), IOFFTD, ISYI, ISYJ, ISYL, ISYM, J, JA, JO, KPOS, L, LA, LO, LPOS, LU, NAI, &
                     NAJ, NAL, NB, NII, NIJ, NIL, NO, NOI, NOJ, NOL, NORBSYM, SYM12
character(len=16) :: FNM
character(len=3) :: NUM1, NUM2
integer(kind=iwp), external :: IsFreeUnit

! IOFFA=NR OF ACTIVE ORBITALS IN PREVIOUS SYMMETRY BLOCKS.
IOFFA(1) = 0
do I=1,nIrrep-1
  IOFFA(I+1) = IOFFA(I)+NASH(I)
end do
! IOFFO=NR OF OCC ORBITALS IN PREVIOUS SYMMETRY BLOCKS.
IOFFO(1) = 0
do J=1,nIrrep-1
  IOFFO(J+1) = IOFFO(J)+NOSH(J)
end do
! Subroutine starts
LU = IsFreeUnit(51)
write(NUM1,'(I3.3)') ISTATE
write(NUM2,'(I3.3)') JSTATE
! AUGSPIN
if (AUGSPIN == 1) then
  FNM = 'r2TM_K2V_'//NUM1//'_'//NUM2
else if (AUGSPIN == -1) then
  FNM = 'r2TM_SDA_'//NUM1//'_'//NUM2
!else if (aab) then ! if AAB (all spin) true
!  select case (AUGSPIN)
!    case (2)
!      FNM = 'r2TM_BBB_'//NUM1//'_'//NUM2
!    case (3)
!      FNM = 'r2TM_AAA_'//NUM1//'_'//NUM2
!    case (4)
!      FNM = 'r2TM_AAB_'//NUM1//'_'//NUM2
!    case (5)
!      FNM = 'r2TM_BBA_'//NUM1//'_'//NUM2
!    case (6)
!      FNM = 'r2TM_ABA_'//NUM1//'_'//NUM2
!    case (7)
!      FNM = 'r2TM_BAB_'//NUM1//'_'//NUM2
!  end select
end if
call Molcas_Open(LU,FNM)
write(LU,*) '# Auger Densities: CMO1, CMO2, 1-e Dyson, 2-e Dyson'
if (AUGSPIN == 1) then
  write(LU,*) '# Spin Matrix (K-2V) for RAES and NAES'
else if (AUGSPIN == -1) then
  write(LU,*) '# Spin matrix SDA for NAES.'
!else if (aab) then ! if AAB (all spin) true
!  select case (AUGSPIN)
!    case (2)
!      write(LU,*) '# Spin BBB 2-el rTDM density matrix.'
!    case (3)
!      write(LU,*) '# Spin AAA 2-el rTDM density matrix.'
!    case (4)
!      write(LU,*) '# Spin AAB 2-el rTDM density matrix.'
!    case (5)
!      write(LU,*) '# Spin BBA 2-el rTDM density matrix.'
!    case (6)
!      write(LU,*) '# Spin ABA 2-el rTDM density matrix.'
!    case (7)
!      write(LU,*) '# Spin BAB 2-el rTDM density matrix.'
!  end select
end if

write(LU,*) '# OCA for scattering atom:'
write(LU,*) OCAN
do I=1,OCAN
  write(LU,*) OCAA(I)
end do
write(LU,*) '# Binding energy (eV)'
write(LU,'(5ES19.12)') EIJ

SYM12 = MUL(LSYM1,LSYM2)
write(LU,*) '# Total Symmetry of the WF product (<N-1,N>):'
write(LU,*) SYM12
write(LU,*) '# States:',ISTATE,JSTATE
write(LU,*) '# Nr of irreps:',nIrrep
write(LU,*) nIrrep
write(LU,'(A17,8I5)') ' # Basis func   :',(NBASF(ISYM),ISYM=1,nIrrep)
write(LU,'(8I5)') (NBASF(ISYM),ISYM=1,nIrrep)
write(LU,'(A17,8I5)') ' # Frozen  orb   :',(NFRO(ISYM),ISYM=1,nIrrep)
write(LU,'(A17,8I5)') ' # Inactive orb  :',(NISH(ISYM),ISYM=1,nIrrep)
write(LU,'(A17,8I5)') ' # Active orb    :',(NASH(ISYM),ISYM=1,nIrrep)
write(LU,'(8I5)') (NASH(ISYM),ISYM=1,nIrrep)
write(LU,'(A17,8I5)') ' # Total num orb :',(NOSH(ISYM),ISYM=1,nIrrep)
write(LU,'(8I5)') (NOSH(ISYM),ISYM=1,nIrrep)
write(LU,*) '# CMO1 Molecular orbitals'
LPOS = 1
do ISYM=1,nIrrep
  NO = NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
  NB = NBASF(ISYM)
  do IO=1,NO
    write(LU,*) '# Symm ',ISYM,'   Orbital ',IO
    do i=0,NB-1
      write(LU,'(5ES19.12)') CMO1(LPOS+NB*(IO-1)+i)
    end do
  end do
  LPOS = LPOS+NB*NO
end do
write(LU,*) '# CMO2 Molecular orbitals'
LPOS = 1
do ISYM=1,nIrrep
  NO = NFRO(ISYM)+NISH(ISYM)+NASH(ISYM)
  NB = NBASF(ISYM)
  do IO=1,NO
    write(LU,*) '# Symm ',ISYM,'   Orbital ',IO
    do i=0,NB-1
      write(LU,'(5ES19.12)') CMO2(LPOS+NB*(IO-1)+i)
    end do
  end do
  LPOS = LPOS+NB*NO
end do
! Write Dyson orbitals in CI basis
write(LU,*) '# 1-e Dyson orbital for CI coeff. in MO biorth. basis'
write(LU,*) '# Symmetry Block elements:',NDYSAB
write(LU,*) '# sub-Block info:Sym(I), NumOrb in SymmBlock'
IOFFTD = 0
do ISYI=1,nIrrep
  NOI = NOSH(ISYI)
  NII = NISH(ISYI)
  if (NOI /= 0) then
    write(LU,'(A10,8I7)') ' # sub-Block:',ISYI,NOI
    do I=1,NOI
      IA = I+IOFFTD
      ! eliminate small numbers
      if (abs(DYSAB(IA)) < 1.0e-29_wp) DYSAB(IA) = Zero
      write(LU,'(I7,ES22.12)') IA,DYSAB(IA)
    end do
  end if
  NORBSYM = NOI
  IOFFTD = IOFFTD+NORBSYM
end do
! Write reduced 2-e TDM in CI basis.
IOFFTD = 0
write(LU,*) '# 2-e reduced TDM for CI coeff. in MO biorth. basis'
write(LU,*) '# Symmetry Block elements:',NRT2MAB
write(LU,*) NRT2MAB
write(LU,*) '# sub-Block info:Sym(I,J,L), NumOrb in SymmBlock'
do ISYI=1,nIrrep
  NOI = NOSH(ISYI)
  NAI = NASH(ISYI)
  NII = NISH(ISYI)
  if (NOI == 0) cycle
  do ISYJ=1,nIrrep
    NOJ = NOSH(ISYJ)
    NAJ = NASH(ISYJ)
    NIJ = NISH(ISYJ)
    if (NOJ == 0) cycle
    do ISYL=1,nIrrep
      NOL = NOSH(ISYL)
      NAL = NASH(ISYL)
      NIL = NISH(ISYL)
      if (NOL == 0) cycle
      if (MUL(ISYI,MUL(ISYJ,ISYL)) == SYM12) then
        if (NAI == 0) cycle
        if (NAJ == 0) cycle
        if (NAL == 0) cycle
        write(LU,'(A10,8I7,8I7,8I7,8I7)') ' # sub-Block:',ISYI,ISYJ,ISYL,NOI*NOJ*NOL
        do I=1,NOI
          IA = IOFFA(ISYI)+I-NII
          IO = IOFFO(ISYI)+I
          do J=1,NOJ
            JA = IOFFA(ISYJ)+J-NIJ
            JO = IOFFO(ISYJ)+J
            do L=1,NOL
              LA = IOFFA(ISYL)+L-NIL
              LO = IOFFO(ISYL)+L
              if ((IA <= 0) .or. (JA <= 0) .or. (LA <= 0)) then
                write(LU,'(I7,I7,I7,ES26.12)') IO,JO,LO,Zero
              else
                KPOS = IA+NASHT*((LA+NASHT*(JA-1))-1)
                if (abs(RT2M(KPOS)) < 1.0e-39_wp) RT2M(KPOS) = Zero
                write(LU,'(I7,I7,I7,ES26.12)') IO,JO,LO,RT2M(KPOS)
              end if
            end do
          end do
        end do
      end if
    end do
  end do
end do
close(LU)

end subroutine RTDM2_PRINT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MakeWwdHlp1 (Ww,W1,
     c                          dima,dimbe,dimbega)
c
c       this routine do:
c       Make  Ww(+)((aa)",(bega)") from W1(a",be",b",ga")
c       for the case beSGrp=gaSGrp
c       N.B. algoritmus nieje prilis vymakany
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       dimx   - dimension of a",ga",bega" (I)
c
        implicit none
        integer dima,dimbe,dimbega
        real*8 Ww(1:dima,1:dimbega)
        real*8 W1(1:dima,1:dimbe,1:dima,1:dimbe)
c
c       help variables
        integer a,be,ga,bega
c
c
          bega=0
          do be=1,dimbe
          do ga=1,be
          bega=bega+1
          do a=1,dima
            Ww(a,bega)=W1(a,be,a,ga)
          end do
          end do
          end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MATCAS(CIN,COUT,NROWI,NROWO,IROWO1,NGCOL,ISCA,SCASGN)
! COUT(IR+IROWO1-1,ISCA(IC)) =
! COUT(IR+IROWO1-1,ISCA(IC)) + CIN(IR,IC)*SCASGN(IC)
! (if IGAT(IC) /= 0)

use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NROWI, NROWO, IROWO1, NGCOL, ISCA(NGCOL)
real(kind=wp), intent(in) :: CIN(NROWI,*), SCASGN(*)
real(kind=wp), intent(inout) :: COUT(NROWO,*)
integer(kind=iwp) :: IC, ICEXP, MAXCOL
real(kind=wp) :: SGN

MAXCOL = 0
do IC=1,NGCOL
  if (ISCA(IC) /= 0) then
    ICEXP = ISCA(IC)
    MAXCOL = max(MAXCOL,ICEXP)
    SGN = SCASGN(IC)
    COUT(IROWO1:IROWO1+NROWI-1,ICEXP) = COUT(IROWO1:IROWO1+NROWI-1,ICEXP)+SGN*CIN(1:NROWI,IC)
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from MATCAS'
call WRTMAT(COUT,NROWO,MAXCOL,NROWO,MAXCOL)
#endif

end subroutine MATCAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1998,2006,2007, Roland Lindh            *
!               1990, IBM                                              *
!***********************************************************************

subroutine Drv2El_3Center_RI(Integral_WrOut,ThrAO)
!***********************************************************************
!                                                                      *
!  Object: driver for the 3 center integrals in the RI approach.       *
!                                                                      *
!          This code has three sections                                *
!          1) a 2-center section to generate the Q-vectors             *
!          2) a 3-center section to generate the R-vectors             *
!          3) a partial transpose section to generate the RI vectors   *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             Modified for k2 loop. August '91                         *
!             Modified to minimize overhead for calculations with      *
!             small basis sets and large molecules. Sept. '93          *
!             Modified driver. Jan. '98                                *
!             Modified to 3-center ERIs for RI Jan '06                 *
!             Modified to out-of-core version Feb '07                  *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use RI_procedures, only: Drv2El_2Center_RI
use iSD_data, only: iSD
use Basis_Info, only: dbsc, nBas, nBas_Aux
use Gateway_global, only: force_out_of_core
use Gateway_Info, only: CutInt
use RICD_Info, only: LDF
use Symmetry_Info, only: nIrrep
use RI_glob, only: iShij, iSSOff, klS, Lu_Q, nBasSh, nChV, nSkal_Valence, nSO, ShlSO, SOShl
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
external :: Integral_WrOut
real(kind=wp), intent(in) :: ThrAO
#include "Molcas.fh"
#include "print.fh"
#include "lRI.fh"
#include "iTOffs.fh"
integer(kind=iwp) :: i, iAddr, iAddr_R(0:7), iAdr_AB, iCase, iCenter, iChoVec, id, iIrrep, iLB, iLO, iMax_R(2,0:7), IncVec, &
                     iOff_3C(3,0:7), iOff_Rv(0:7), ip_R, iPass, iPL, iPrint, irc, iRed, iRout, iS, iS_, iSeed, iSO_Aux, iSym, &
                     iTask, iTtmp(0:7), iVec, j_e, j_s, jCenter, jS, jS_, kCenter, kCnttp, klCenter, klS_, kQv, kS, lCenter, &
                     lCnttp, LenVec, LenVec_Red, lJ, lS, Lu_AB, Lu_R(0:7), m3C, MaxCntr, MaxMem, MemLow, MemSew, mMuNu, mQv, &
                     MuNu_e, MuNu_s, n3C, n3CMax, n_Rv, nB_Aux, nCase, nDiag, nMuNu, NoChoVec(0:7), nQv, nRv, nRvMax, nSkal, &
                     nSkal2, nSkal_Auxiliary, nTask, NumVec, NumVec_
real(kind=wp) :: A_int, A_int_kl, TC0, TC1, TCpu1, TCpu2, TMax_all, TW0, TW1, TWall1, Twall2
character(len=6) :: Name_R
logical(kind=iwp) :: DoFock, DoGrad, FreeK2, Indexation, Out_of_Core, Skip, Verbose
integer(kind=iwp), allocatable :: AB(:,:), Addr(:), iRv(:), LBList(:), NuMu(:,:), SO2C(:), TmpList(:)
real(kind=wp), allocatable :: A_Diag(:), Arr_3C(:), Diag(:), Local_A(:,:), Qv(:), Rv(:), TMax_Auxiliary(:), TMax_Valence(:,:), &
                              Tmp(:,:)
integer(kind=iwp), external :: iPrintLevel, IsFreeUnit, nSize_3C, nSize_Rv
logical(kind=iwp), external :: Reduce_Prt, Rsv_Tsk
interface
  subroutine Post_2Center_LDF(A_Diag,AB,MaxCntr,Lu_AB,Local_A,SO2C,nSO_Aux)
    real*8 :: A_Diag(*)
    real*8, allocatable :: Local_A(:,:)
    integer, allocatable :: SO2C(:), AB(:,:)
    integer MaxCntr, Lu_AB, nSO_Aux
  end subroutine Post_2Center_LDF
end interface

!                                                                      *
!***********************************************************************
!                                                                      *
!define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
iRout = 9

! Get global print level

iPL = iPrintLevel(-1)
if (iPL == 2) then
  iPL = 5
else if (iPL == 3) then
  iPL = 6
else if (iPL == 4) then
  iPL = 99
else if (iPL == 5) then
  iPL = 99
end if
nPrint(iRout) = iPL

! Reduce print level if iterating

if (Reduce_Prt() .and. (iPL <= 5)) then
  nPrint(iRout) = 4
end if
iPrint = nPrint(iRout)

if (iPrint >= 6) call CWTime(TC0,TW0)
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     2 - C E N T E R   S E C T I O N                                  *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Compute the two-center integrals over the auxiliary basis

call Drv2El_2Center_RI(ThrAO,A_Diag,nSO_Aux,MaxCntr,SO2C)

! Post processing to generate the Q-vectors.

if (LDF) then

  ! Local RI

  call Post_2Center_LDF(A_Diag,AB,MaxCntr,Lu_AB,Local_A,SO2C,nSO_Aux)

else

  ! Standard RI

  call Post_2Center_RI(A_Diag)

end if

call mma_deallocate(A_Diag)

call Set_Basis_Mode('Auxiliary')
call Nr_Shells(nSkal_Auxiliary)

if (iPrint >= 6) then
  write(u6,'(A)') ' 2-center integrals:'
  call CWTime(TC1,TW1)
  write(u6,'(A,F8.2,A,/,A,F8.2,A)') '      CPU time :',TC1-TC0,' sec.','      Wall time:',TW1-TW0,' sec.'
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     3 - C E N T E R   S E C T I O N                                  *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *

call StatusLine(' Seward:',' Computing 3-center RI integrals')

! Handle both the valence and the auxiliary basis set

call Set_Basis_Mode('WithAuxiliary')
call SetUp_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize for 2-electron integral evaluation. Do not generate
! tables for indexation.

Indexation = .false.
DoGrad = .false.
DoFock = .false.
call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
nSkal_Valence = nSkal-nSkal_Auxiliary
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute entities for prescreening at shell level

call mma_allocate(TMax_Valence,nSkal_Valence,nSkal_Valence,Label='TMax_Valence')
call mma_allocate(TMax_Auxiliary,nSkal_Auxiliary,Label='TMax_Auxiliary')

call mma_allocate(Tmp,nSkal,nSkal,Label='Tmp')
call Shell_MxSchwz(nSkal,Tmp)
TMax_all = Zero
do iS=1,nSkal_Valence
  do jS=1,iS
    TMax_Valence(iS,jS) = Tmp(iS,jS)
    TMax_Valence(jS,iS) = Tmp(iS,jS)
    TMax_all = max(TMax_all,Tmp(iS,jS))
  end do
end do
do iS=1,nSkal_Auxiliary-1
  iS_ = iS+nSkal_Valence
  jS_ = nSkal_Valence+nSkal_Auxiliary
  TMax_Auxiliary(iS) = Tmp(jS_,iS_)
  TMax_all = max(TMax_all,Tmp(jS_,iS_))
end do

call mma_deallocate(Tmp)
!                                                                      *
!***********************************************************************
!                                                                      *
! Set up indexation for Gaussian pairs.

! Generate some offsets and dimensions for the J12 matrix and
! the RI vectors.

call Setup_Aux(nIrrep,nBas,nSkal_Valence,nSkal_Auxiliary,nSO,TMax_Valence,CutInt,nSkal2,nBas_Aux,nChV,iTOffs)

call mma_Allocate(iRv,nSkal2,Label='iRv')
iRv(:) = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Let us now decide on the memory partitioning

!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Preallocate some core for Seward!

call mma_maxDBLE(MemSew)
MemLow = min(MemSew/2,1024*128)
MemSew = max(MemSew/10,MemLow)
call xSetMem_Ints(MemSew)

!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! During this phase we will have three memory sections
!
! 1) the three center integrals for a fixed {kl}
! 2) a similar block for the R-vectors
! 3) a buffer to contain subsets of the Q-vectors

! Compute the max size of 1 and 2

n3CMax = 0
nRvMax = 0
iMax_R(:,0:nIrrep-1) = 0
do klS_=1,nSkal2
  kS = iShij(1,klS_)
  lS = iShij(2,klS_)
  nRv = nSize_Rv(kS,lS,nBasSh,nSkal-1,nIrrep,iOff_Rv,nChV)
  nRvMax = max(nRvMax,nRv)
  n3C = nSize_3C(kS,lS,nBasSh,nSkal-1,nIrrep,iOff_3C,nBas_Aux)
  n3CMax = max(n3CMax,n3C)
  iMax_R(1,0:nIrrep-1) = max(iMax_R(1,0:nIrrep-1),iOff_3C(1,0:nIrrep-1))
  iMax_R(2,0:nIrrep-1) = iMax_R(2,0:nIrrep-1)+iOff_3C(1,0:nIrrep-1)
end do

call mma_allocate(Arr_3C,n3CMax,Label='Arr_3C')
call mma_allocate(Rv,nRvMax,Label='Rv')

call mma_maxDBLE(MaxMem)
nQv = 0
do iIrrep=0,nIrrep-1
  lJ = nBas_Aux(iIrrep)
  if (iIrrep == 0) lJ = lJ-1 ! remove dummy basis function
  nQv = nQv+lJ*nChV(iIrrep)
end do

! The Q-vectors can be read in a single whole block or in chunks.

if (Force_Out_of_Core) MaxMem = (8*nQv)/10
Out_of_Core = nQv > MaxMem
nQv = min(nQv,MaxMem)  ! note that nQv is effectively reset here
call mma_allocate(Qv,nQv,Label='Qv')
!                                                                      *
!***********************************************************************
!                                                                      *
! In case of in-core mode read Q-vectors only once!

if (.not. Out_of_Core) then
  mQv = 1
  do iIrrep=0,nIrrep-1
    lJ = nBas_Aux(iIrrep)
    if (iIrrep == 0) lJ = lJ-1 ! remove dummy basis function

    if (lJ > 0) then
      iAddr = 0
      kQv = lJ*nChV(iIrrep)
      call dDaFile(Lu_Q(iIrrep),2,Qv(mQv),kQv,iAddr)
      mQv = mQv+kQv
    end if
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Open files for the R-vectors.

do iIrrep=0,nIrrep-1
  nB_Aux = nBas_Aux(iIrrep)
  if (iIrrep == 0) nB_Aux = nB_Aux-1
  if (nB_Aux /= 0) then
    iSeed = 55+iIrrep
    Lu_R(iIrrep) = IsFreeUnit(iSeed)
    write(Name_R,'(A4,I2.2)') 'RVec',iIrrep
    call DaName_MF_WA(Lu_R(iIrrep),Name_R)
  end if
  iAddr_R(iIrrep) = 0
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call CWTime(TCpu1,TWall1)

kCenter = 0  ! dummy initialize
lCenter = 0  ! dummy initialize
iS = nSkal ! point to dummy shell
! Save this field for the time being!
iTtmp(0:nIrrep-1) = iTOffs(3:3*nIrrep:3)

call Init_Tsk(id,nSkal2)

klS = 0
iTask = 0
!do klS=1,nSkal2
do while (Rsv_Tsk(id,klS))
  !write(u6,*) 'Processing shell-pair:',klS
  iTask = iTask+1

  iRv(iTask) = klS
  kS = iShij(1,klS)
  lS = iShij(2,klS)

  ! Logic to avoid integrals with mixed muonic and electronic basis.

  kCnttp = iSD(13,kS)
  lCnttp = iSD(13,lS)

  if (LDF) then

    ! Pick up the corresponding (K|L)^{-1} block

    kCenter = iSD(10,kS)
    lCenter = iSD(10,lS)
    !write(u6,*) 'kCenter, lCenter=',kCenter, lCenter
    klCenter = nTri_Elem(kCenter-1)+lCenter
    iAdr_AB = AB(1,klCenter)
    nAB = AB(2,klCenter)
    call dDaFile(Lu_AB,2,Local_A(:,2),nAB**2,iAdr_AB)
    !call RecPrt('A^-1',' ',Local_A,nAB,nAB)

    ! Now I need some lookup tables to be used below. I need to
    ! go from SO index to lO index and from a given lO index
    ! back to the SO index.

    ISO2LO(:,:) = 0
    iLO = 0
    nCase = 1
    if (kCenter /= lCenter) nCase = 2
    do iCase=1,nCase
      if (iCase == 1) then
        jCenter = kCenter
      else
        jCenter = lCenter
      end if
      do iSO_Aux=1,nSO_Aux
        iCenter = SO2C(iSO_Aux)
        !write(u6,*) 'iCenter=',iCenter
        if (iCenter == jCenter) then
          iLO = iLO+1
          !write(u6,*) 'iLO,iSO_Aux=',iLO,iSO_Aux
          iSO2LO(1,iSO_Aux) = iLO
          iSO2LO(2,iLO) = iSO_Aux
        end if
      end do
    end do
  end if

  A_int_kl = TMax_Valence(kS,lS)
  if (dbsc(kCnttp)%fMass /= dbsc(lCnttp)%fMass) A_int_kl = Zero

  nRv = nSize_Rv(kS,lS,nBasSh,nSkal-1,nIrrep,iOff_Rv,nChV)
  n3C = nSize_3C(kS,lS,nBasSh,nSkal-1,nIrrep,iOff_3C,nBas_Aux)
  Arr_3C(1:n3C) = Zero
  Rv(1:nRv) = Zero

  iTOffs(3:3*nIrrep:3) = iOff_3C(1,0:nIrrep-1)

  ! Loop over the auxiliary basis set

  do jS=nSkal_Valence+1,nSkal-1
    !write(u6,*) 'jS,kS,lS=',jS,kS,lS
    Skip = .false.
    if (LDF) then
      jCenter = iSD(10,jS)
      if ((jCenter /= kCenter) .and. (jCenter /= lCenter)) Skip = .true.
      !write(u6,*) 'jCenter=',jCenter
    end if

    if (.not. Skip) then
      A_int = A_int_kl*TMax_Auxiliary(jS-nSkal_Valence)

#     ifdef _DEBUGPRINT_
      write(u6,*)
      write(u6,*) 'iS,jS,kS,lS=',iS,jS,kS,lS
      write(u6,*) 'A_Int,CutInt=',A_Int,CutInt
      write(u6,*)
#     endif
      if (A_Int >= CutInt) call Eval_IJKL(iS,jS,kS,lS,Arr_3C,n3C,Integral_WrOut)
    end if

    ! Use a time slot to save the number of tasks and shell
    ! quadruplets processed by an individual node
    call SavStat(1,One,'+')
    call SavStat(2,One,'+')

  end do    ! jS
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Multiply the 3-center integrals with the Q-vectors

  ! Compute HQ

  call Mult_3C_Qv_S(Arr_3C,n3C,Qv,nQv,Rv,nRv,nChV,iOff_3C,nIrrep,Out_of_Core,Lu_Q,'N')
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Write the R-vectors to disk. These will be retrieved and sort
  ! afterwards in step 3.

  do iIrrep=0,nIrrep-1
    ip_R = 1+iOff_Rv(iIrrep)
    nRv = iOff_3C(1,iIrrep)*nChV(iIrrep)
    !write(u6,*) 'iAddr_R(iIrrep)=',iAddr_R(iIrrep)
    if (nRv > 0) call dDaFile(Lu_R(iIrrep),1,Rv(ip_R),nRv,iAddr_R(iIrrep))
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !end do    ! klS

end do
nTask = iTask

! Restore iTOffs(3,*)
iTOffs(3:3*nIrrep:3) = iTtmp(0:nIrrep-1)

call CWTime(TCpu2,TWall2)
call SavTim(1,TCpu2-TCpu1,TWall2-TWall1)
!                                                                      *
!***********************************************************************
!                                                                      *
!                         E P I L O G U E                              *
!                                                                      *
!***********************************************************************
!                                                                      *
call Free_Tsk(id)

! Set up array to store the load balance if this might be needed in
! a gradient calculation.

call mma_allocate(TmpList,nSkal2,Label='TmpList')
TmpList(:) = 0
call mma_allocate(LBList,nSkal2,Label='LBList')
LBList(:) = -1
do iTask=1,nTask
  klS_ = iRv(iTask)
  TmpList(klS_) = 1
end do

iLB = 1
do klS_=1,nSkal2
  if (TmpList(klS_) == 1) then
    LBList(iLB) = klS_
    iLB = iLB+1
  end if
end do

call Put_iArray('LBList',LBList,nSkal2)

call mma_deallocate(LBList)
call mma_deallocate(TmpList)

call mma_deallocate(Rv)
call mma_deallocate(Arr_3C)
call mma_deallocate(Qv)
call xRlsMem_Ints()
call mma_deallocate(TMax_Auxiliary)
call mma_deallocate(TMax_Valence)
if (LDF) then
  call mma_deallocate(SO2C)
  call mma_deallocate(AB)
  call mma_deallocate(Local_A)
  call DaClos(Lu_AB)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Each node does now have an incomplete set of R-vectors!
!                                                                      *
!***********************************************************************
!                                                                      *
! Terminate integral environment.

Verbose = .false.
FreeK2 = .true.
call Term_Ints(Verbose,FreeK2)

call mma_deallocate(iSSOff)
call mma_deallocate(ShlSO)
call mma_deallocate(SOShl)
call Free_iSD()

! Let go off the Q-vectors for now!

do iIrrep=0,nIrrep-1
  nB_Aux = nBas_Aux(iIrrep)
  if (iIrrep == 0) nB_Aux = nB_Aux-1
  if (nB_Aux /= 0) call DaClos(Lu_Q(iIrrep))
end do

if (iPrint >= 6) then
  write(u6,'(A)') ' 3-center integrals:'
  call CWTime(TC0,TW0)
  write(u6,'(A,F8.2,A,/,A,F8.2,A)') '      CPU time :',TC0-TC1,' sec.','      Wall time:',TW0-TW1,' sec.'
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     P A R T I A L   T R A N S P O S E   S E C T I O N                *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! For the interface to work fix the tables of Seward

call Set_Basis_Mode('Valence')
call SetUp_iSD()
!                                                                      *
!***********************************************************************
!                                                                      *
! Initialize for 2-electron integral evaluation. Do generate
! tables for indexation.

Indexation = .true.
call Setup_Ints(nSkal_Valence,Indexation,ThrAO,DoFock,DoGrad)

! Initiate stuff for Cholesky style storage.

call IniCho_RI(nSkal_Valence,nChV,nIrrep,iTOffs,iShij,nSkal2)

call mma_allocate(Addr,nSkal2,Label='Addr') ! addr for read
call mma_allocate(NuMu,2,nSkal2,Label='NuMu')
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out the RI vectors in Cholesky format

! Here we will read one chuck from the R-vector file, while we will
! store an as large part of the RI vectors in Cholesky format.

LenVec = 0
do iIrrep=0,nIrrep-1
  iChoVec = 0

  nB_Aux = nBas_Aux(iIrrep)
  if (iIrrep == 0) nB_Aux = nB_Aux-1
  if (nB_Aux /= 0) then

    iSym = iIrrep+1

    ! NumVec: is no longer equal to the # of auxiliary functions

    NumVec = iTOffs(3*iIrrep+1)
    if (NumVec /= 0) then

      Addr(1) = 0
      do i=2,nTask  ! init the addr for reading vectors
        klS_ = iRv(i-1)
        kS = iShij(1,klS_)
        lS = iShij(2,klS_)
        n3C = nSize_3C(kS,lS,nBasSh,nSkal-1,nIrrep,iOff_3C,nBas_Aux)
        nMuNu = iOff_3C(1,iIrrep)
        Addr(i) = Addr(i-1)+nMuNu*NumVec
      end do

      LenVec_Red = iMax_R(1,iIrrep)
      n_Rv = NumVec*LenVec_Red
      call mma_allocate(Rv,n_Rv,Label='Rv')

      ! LenVec: # of valence Gaussian products in this irrep

      LenVec = iMax_R(2,iIrrep)
      call Create_Chunk(LenVec,NumVec,IncVec)

      do iVec=1,NumVec,IncVec
        NumVec_ = min(NumVec-iVec+1,IncVec)
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Read now the R-vectors for a fixed shell-pair and
        ! irrep, but for all auxiliary functions.

        mMuNu = 0
        do klS_=1,nSkal2
          kS = iShij(1,klS_)
          lS = iShij(2,klS_)
          n3C = nSize_3C(kS,lS,nBasSh,nSkal-1,nIrrep,iOff_3C,nBas_Aux)
          nMuNu = iOff_3C(1,iIrrep)
          m3C = nMuNu*NumVec_

          if (m3C > 0) then
            MuNu_s = mMuNu+1
            MuNu_e = mMuNu+nMuNu

            NuMu(1,klS_) = MuNu_s
            NuMu(2,klS_) = MuNu_e
          end if

          mMuNu = mMuNu+nMuNu
        end do

        do i=1,nTask
          klS_ = iRv(i)
          kS = iShij(1,klS_)
          lS = iShij(2,klS_)

          n3C = nSize_3C(kS,lS,nBasSh,nSkal-1,nIrrep,iOff_3C,nBas_Aux)
          nMuNu = iOff_3C(1,iIrrep)
          m3C = nMuNu*NumVec_

          if (m3C <= 0) cycle

          call dDaFile(Lu_R(iIrrep),2,Rv,m3C,Addr(i))

          ! Copy the appropriate section into the RI vectors in Cholesky format.

          MuNu_s = NuMu(1,klS_)
          MuNu_e = NuMu(2,klS_)
          j_s = 1
          j_e = NumVec_
          call Put_Chunk(MuNu_s,MuNu_e,j_s,j_e,Rv,nMuNu,LenVec)

        end do
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Now transfer the RI vectors to disk

        call Get_Chunk(LenVec,NumVec_,iChoVec,iSym,iVec)

      end do   ! iVec = 1, NumVec, IncVec

      call Destroy_Chunk()
      call mma_deallocate(Rv)

    end if

    ! Let go of the R-vectors for good!

    call DaClos(Lu_R(iIrrep))
  end if
  NoChoVec(iIrrep) = iChoVec

end do    ! iIrrep
call mma_deallocate(NuMu)
call mma_deallocate(Addr)
call mma_deallocate(iRv)
call mma_deallocate(nBasSh)
call mma_deallocate(iShij)
!                                                                      *
!***********************************************************************
!                                                                      *
iPass = 1
iRed = 1
call Cho_RI_PutInfo(iPass,iRed)
!                                                                      *
!***********************************************************************
!                                                                      *
! Terminate integral environment.

Verbose = .false.
FreeK2 = .true.
call Term_Ints(Verbose,FreeK2)
!
if (iPrint >= 6) then
  write(u6,'(A)') ' Block-transpose:'
  call CWTime(TC1,TW1)
  write(u6,'(A,F8.2,A,/,A,F8.2,A)') '      CPU time :',TC1-TC0,' sec.','      Wall time:',TW1-TW0,' sec.'
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
!     D I A G O N A L   S E C T I O N                                  *
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
nDiag = 0
do iIrrep=0,nIrrep-1
  nDiag = nDiag+nBas(iIrrep)
end do
nDiag = nTri_Elem(nDiag)
call mma_allocate(Diag,nDiag,Label='Diag')
Diag(:) = Zero

call Drv2El_RI_Diag(ThrAO,Diag,nDiag)

! Write the diagonal to disk

call Cho_IODiag(Diag,1)

call mma_deallocate(Diag)

if (iPrint >= 6) then
  write(u6,*) 'Diagonal vector:'
  call CWTime(TC0,TW0)
  write(u6,'(A,F8.2,A,/,A,F8.2,A)') '      CPU time :',TC0-TC1,' sec.','      Wall time:',TW0-TW1,' sec.'
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Terminate Cholesky stuff here.

irc = 0
call TermCho_RI(irc,NoChoVec,8)
if (irc /= 0) then
  write(u6,*) 'TermCho_RI returned ',irc
  call SysAbendMsg('Drv2El_3Center_RI','Cholesky termination failed!',' ')
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Drv2El_3Center_RI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

subroutine REO_GASDET(IBLOCK,NBLOCK,ISYM,IREO)
! Create reorder array for determinants : configuration order => Ab order
!
! Jeppe Olsen, November 2001, from GASANA

use lucia_data, only: CONF_REO, IB_CONF_REO, IB_SD_FOR_OPEN, IBCONF_ALL_SYM_FOR_OCCLS, IOCLS, MAXOP, MINOP, MXNSTR, &
                      NCONF_PER_OPEN, NCONF_TOT, NELEC, NGAS, NIRREP, NMXOCCLS, NOBPT, NOCOB, NPDTCNF, NSTSO, NTOOB, PSSIGN
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NBLOCK, IBLOCK(8,NBLOCK), ISYM
integer(kind=iwp), intent(_OUT_) :: IREO(*)
integer(kind=iwp) :: IATP, IBTP, NAEL, NBEL, NEL
integer(kind=iwp), allocatable :: DET_MS(:), DET_OC(:), DET_VC(:), LASTR(:), LBSTR(:), LOCMAX(:), LOCMIN(:), Z(:), ZSCR(:)

!write(u6,*) 'nconf_per_open in reo_gasdet'
!call iwrtma(nconf_per_open,1,4,1,4)

! Specifications of internal space

! Type of alpha and beta strings
IATP = 1
IBTP = 2

NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)
NEL = NAEL+NBEL

! Info on block structure of space

! Space for alpha and beta strings
call mma_allocate(LASTR,MXNSTR*NAEL,Label='LASTR')
call mma_allocate(LBSTR,MXNSTR*NBEL,Label='LBSTR')
! Space for constructing arc weights for configurations
call mma_allocate(ZSCR,(NOCOB+1)*(NEL+1),Label='ZSCR')
call mma_allocate(Z,NOCOB*NEL*2,Label='Z')
call mma_allocate(LOCMIN,NOCOB,Label='LOCMIN')
call mma_allocate(LOCMAX,NOCOB,Label='LOCMAX')
! Occupation and projections of a given determinant
call mma_allocate(DET_OC,NAEL+NBEL,Label='DET_OC')
call mma_allocate(DET_MS,NAEL+NBEL,Label='DET_MS')
call mma_allocate(DET_VC,NOCOB,Label='DET_VC')

!/ Jesper Wisborg Krogh, 2005-06-22
call REO_GASDET_S(IREO,NSTSO(IATP)%A,NSTSO(IBTP)%A,NBLOCK,IBLOCK,NAEL,NBEL,LASTR,LBSTR,NIRREP,NMXOCCLS,NGAS,IOCLS,NTOOB,NOBPT, &
                  IB_CONF_REO,CONF_REO(ISYM)%A,nconf_tot,ib_conf_reo,maxop,nconf_per_open(:,isym),IB_SD_FOR_OPEN,ZSCR,Z,LOCMIN, &
                  LOCMAX,DET_OC,DET_MS,DET_VC,MINOP,IBCONF_ALL_SYM_FOR_OCCLS,PSSIGN,NPDTCNF)

call mma_deallocate(LASTR)
call mma_deallocate(LBSTR)
call mma_deallocate(ZSCR)
call mma_deallocate(Z)
call mma_deallocate(LOCMIN)
call mma_deallocate(LOCMAX)
call mma_deallocate(DET_OC)
call mma_deallocate(DET_MS)
call mma_deallocate(DET_VC)

end subroutine REO_GASDET

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2019, Liviu Ungur                                      *
************************************************************************
      SubRoutine IvoGen_rasscf(nSym,nBas,nFro,nIsh,nAsh,nCMO,nEOrb,
     &                         CMO,EOrb)
************************************************************************
*                                                                      *
*     purpose: Generate improved virtual orbitals by diagonalization   *
*              of the one-electron hamiltonian in the subspace spanned *
*              by the virtual orbitals                                 *
*                                                                      *
*     input:                                                           *
*       CMO     : molecular orbital coefficients of length nCMO=NTOT2  *
*       EOrb    : on input contain orbital energies as obtained in the *
*                 NATORB_RASSCF, energies  of the virtual orbitals     *
*                 are non-zero, length nEOrb=NTOT                      *
*                                                                      *
*     output:                                                          *
*       CMO     : molecular orbital coefficients with virtual orbitals *
*                 modified                                             *
*       EOrb    : orbital energies (set to zero for virtual orbitals)  *
*                                                                      *
*     called from: OutCtl, only when IVO is used in the input          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Original MOLCAS/scf/ivogen.f written by:                         *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*                                                                      *
*     written by:                                                      *
*     L. Ungur  using the MOLCAS/scf/ivogen.f as start                 *
*     National University of Singapore,  Feb 2019                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit None
#include "real.fh"
#include "stdalloc.fh"
#include "warnings.h"
#include "output_ras.fh"
*
      Integer  nCMO, nEOrb, nSym
      Integer  nBas(nSym), nFro(nSym), nIsh(nSym), nAsh(nSym)
      Real*8   CMO(nCMO),EOrb(nEOrb)
*
      Real*8, Dimension(:), Allocatable:: FckS, FckH, FckT, OneHam,
     &                                    Scratch
*
      ! clocal variables:
      Integer  iSym, ij, nOrbi, iCMO, iEOr, iDum, nFound, iErr
      Integer  nOcc(nSym)
      Integer  MaxBas, MaxBOO, MaxOrO, nBT
      Integer  iRc, iOpt, iComp, iSyLbl
      Real*8   Dummy
#ifdef _DEBUGPRINT_
      Integer  iOff, iBas
#endif

      nBT=0
      MaxBas=0
      MaxOrO=0
      MaxBOO=0
      nOcc(1:nSym)=0
      Do iSym=1, nSym
         nOcc(iSym) =  nFro(iSym) + nIsh(iSym) + nAsh(iSym)
         nBT    = nBT  + nBas(iSym)*(nBas(iSym) + 1)/2
         MaxBas = Max(MaxBas,nBas(iSym))
         MaxOrO = Max(MaxOrO,nBas(iSym) - nOcc(iSym))
         MaxBOO = Max(MaxBOO,nBas(iSym)*(nBas(iSym)-nOcc(iSym)))
      End Do
#ifdef _DEBUGPRINT_
      Do iSym=1, nSym
         Call RecPrt('IvoGen: CMO(in)',' ',CMO(iCMO),nBas(iSym),
     &                                               nBas(iSym) )
      End Do
#endif
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*---- Allocate memory for the core Hamiltonian
      Call mma_allocate(OneHam, nBT ,Label='OneHam')
      Call dcopy_(nBT,[Zero],0,OneHam,1)
*---- Load bare nuclei Hamiltonian

      iRc    = -1
      iOpt   =  6
      iComp  =  1
      iSyLbl =  1
      Call RdOne(iRc,iOpt,'OneHam  ',iComp,OneHam,iSyLbl)
      If ( iRc.ne.0 ) Then
        Write(LF,*)' RASSCF tried to construct compact virtual orbitals'
        Write(LF,*)' by diagonalization of core Hamiltonian, but ran   '
        Write(LF,*)' into a severe error: Failed to read the           '
        Write(LF,*)' Hamiltonian from the ONEINT file. Something may be'
        Write(LF,*)' wrong with the file.'
        Call Quit(_RC_IO_ERROR_READ_)
      End If
#ifdef _DEBUGPRINT_
      Write(LF,*)
      Write(LF,*) ' OneHam in AO basis in RASSCF'
      Write(LF,*) ' ---------------------'
      Write(LF,*)
      iOff=0
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        Call TriPrt('IvoGen: OneHam:','(5G17.11)',OneHam(1+iOff),iBas)
        iOff = iOff + (iBas*iBas+iBas)/2
      End Do
#endif
*
*---- Allocate memory for squared modified Fock matrix
      Call mma_allocate(FckS,MaxBas**2,Label='FckS')
*
*---- Allocate memory for half transformed Fock matrix
      Call mma_allocate(FckH,MaxBOO,Label='FckH')
*
*---- Allocate memory for transformed Fock matrix
      Call mma_allocate(FckT,MaxOrO*(MaxOrO + 1)/2,Label='FckT')
*
      ij   = 1
      iCMO = 1
      iEOr = 1
      Do iSym = 1, nSym
         nOrbi = nBas(iSym) - nOcc(iSym)
*
*------- If nOrbi.eq.0 - no virtual orbitals; iCMO and iEOr must be
*        updated anyway (occupied orbitals may exist)
         iCMO = iCMO + nBas(iSym)*nOcc(iSym)
         iEOr = iEOr + nOcc(iSym)
*
         If (nOrbi.gt.0) Then
*
*---------- Transform OneHam to space spanned by virtual orbitals
            Call Square(OneHam(ij),FckS,1,nBas(iSym),nBas(iSym))
            ! multiply FckH = OneHam x CMO
            Call DGEMM_('N','N',
     &                  nBas(iSym),nOrbi,nBas(iSym),
     &                  1.0d0,FckS,nBas(iSym),
     &                        CMO(iCMO),nBas(iSym),
     &                  0.0d0,FckH,nBas(iSym))
            ! multiply FckT =  CMO x FckH
            Call DGEMM_Tri('T','N',nOrbi,nOrbi,nBas(iSym),
     &                     One,CMO(iCMO), nBas(iSym),
     &                         FckH,nBas(iSym),
     &                     Zero,FckT,nOrbi)
*
*---------- Diagonalize OneHam within virtual space and form orbital energies
            Call mma_allocate(Scratch,nOrbi**2,Label='Scratch')
            Dummy=0.0D0
            iDum=0
            Call Diag_Driver('V','A','L',nOrbi,FckT,
     &                       Scratch,nOrbi,Dummy,Dummy,iDum,iDum,
     &                       EOrb(iEOr),CMO(iCMO),nBas(iSym),0,-1,'J',
     &                       nFound,iErr)
            Call mma_deallocate(Scratch)
*
*---------- Orbital energies are now meaningless; set them to zero
            call dcopy_(nOrbi,[Zero],0,EOrb(iEOr),1)
*
         End If
*
*------- Update pointers
         iCMO = iCMO + nOrbi*nBas(iSym)
         iEOr = iEOr + nOrbi
         ij   = ij   + nBas(iSym)*(nBas(iSym) + 1)/2
*
      End Do
*
*---- Deallocate memory
      Call mma_deallocate(FckS)
      Call mma_deallocate(FckH)
      Call mma_deallocate(FckT)
      Call mma_deallocate(OneHam)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Mickael G. Delcey                                *
************************************************************************
      SubRoutine Preci_cho(iB,iS,jS,nd,rOut,nbai,nbaj,
     &                   fockii,fockai,fockti,
     &                   focki,focka,fock,sign,
     &                   A_J,A_K,Scr,nScr,iAdr)
************************************************************************
*                                                                      *
*     This routine remplaces preciaa, preciba and precibb              *
*     in case the new Cholesky alrgorithm is used,                     *
*     that is if only (ii|ab) and (ia|ib) integrals were computed      *
*                                                                      *
*     The code should be slightly more efficient as the integrals      *
*     are only read once and not for each distinct element             *
*                                                                      *
*     Written by M.G. Delcey, November 2014                            *
*                                                                      *
************************************************************************
      use Arrays, only: G1t, G2t
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
#include "standard_iounits.fh"
      Real*8 focki(nbaj,nbaj),fock(nbaj,nbaj),focka(nbaj,nbaj),
     &       rout(*), A_J(nScr), A_K(nScr), Scr(nScr)
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      itri1(i,j)=nTri-itri(nd-Min(i,j)+1,nd-Min(i,j)+1)
     &          +Max(i,j)-Min(i,j)+1
*                                                                      *
************************************************************************
*                                                                      *
      nTri=itri(nd,nd)
      nO=nAsh(jS)+nIsh(jS)
      jVert=nOrb(jS)-nAsh(jS)-nIsh(jS)
      nvirt=nOrb(jS)-nIsh(jS)
      i1=nD-jVert+1
*                                                                      *
************************************************************************
*     Integral contribution                                            *
*
      Do iJK=1,2 ! 1=coulomb, 2=exchange
        factor=-1.0d0
        If (ijK.eq.2) factor=3.0d0
*
**    Read integrals
*
        Do isym=1,nsym
          nvirt2=nBas(isym)-nIsh(isym)
          call DDAFILE(LuChoInt(1),2,A_J,nvirt2**2,iAdr)

*
**        iaa
*
          Do jC=1,nAsh(isym)
            jjC=JC+nA(iSym)
            Do jD=1,nAsh(isym)
              jjD=JD+nA(iSym)
              ip1=(jD-1)*nvirt2+jC
              aabb=A_J(ip1) ! abab if exchange
              Do jA=1,nAsh(jS)
                jjA=jA+nA(jS)
                Do jB=1,jA
                  jjB=jB+nA(jS)
                  i=itri1(jA,jB)
                  If (iJK.eq.1) Then
                    rDens1=2.0d0*sign*G2t(
     &                          itri(itri(jjC,jjD),itri(jjB,jjA)))
                  Else
                   rDens1=4.0d0*sign*G2t(
     &                          (itri(itri(jjB,jjD),itri(jjC,jjA))))
                  EndIf
                  rout(i)=rout(i)+rDens1*aabb
                End Do
              End Do
            End Do
          End Do
*
          If (iSym.eq.jS) Then
            Do jA=1,nAsh(jS)
              jAA=jA+nA(jS)
              Do jB=1,jA
                jBB=jB+nA(jS)
                i=itri1(jA,jB)
                Do jC=1,nAsh(jS)
                  jCC=jC+nA(jS)
                  iBC=(jC-1)*nvirt+jB
                  BCbb=A_J(iBC) ! BbCb if exchange
                  iAC=(jC-1)*nvirt+jA
                  ACbb=A_J(iAC) ! AbCb if exchange
                  rDens1=-sign*G1t(itri(jAA,jCC))
                  rDens2=-sign*G1t(itri(jBB,jCC))
                  If (jAA.eq.jCC) rDens1=rdens1+sign
                  If (jBB.eq.jCC) rDens2=rdens2+sign
                  rout(i)=rout(i)
     &                   +2.0d0*rdens1*factor*BCbb
     &                   +2.0d0*rdens2*factor*ACbb

                End Do
              End Do
            End Do
*
**          iba
*
            Do jA=1,nAsh(jS)
              ip=itri1(ja,nd-jVert+1)
              Do jB=1,nAsh(jS)
                rDens=-sign*G1t(iTri(jA+nA(jS),jB+nA(jS)))
                If (jA.eq.jB) rDens=rdens+sign*2.0d0
*
                ivB=(jB-1)*nvirt + nAsh(jS) + 1
                Call DaXpY_(jVert,2.0d0*factor*rDens,
     &                     A_J(ivB),1,
     &                     rOut(ip),1)
              End Do
            End Do
*
**    ibb
*
            i=itri1(i1,i1)
            Do kB=nAsh(jS),nvirt-1
              nlB=nvirt-kb
              ilB=kB+1+nvirt*kb
              call daxpy_(nlB,sign*4.0d0*factor,A_J(ilB),
     &                   nvirt,rout(i),1)
              i=i+nlB
            End Do
          EndIf
        End Do
      End Do
*                                                                      *
************************************************************************
*    Fock matrix contribution                                          *
*
      rFock=sign*(Fockii+FockAi)
*MGD tmp
*      Go to 10
      Do jA=1,nAsh(jS)
*
**       iaa
*
         jAA=jA+nA(jS)
         jjA=jA+nIsh(js)
         Do jB=1,JA
            jBB=jB+nA(jS)
            jjB=jB+nIsh(js)
            i=itri1(jA,jB)
            rDens=G1t(itri(jbb,jAA))
            rout(i)=rout(i)+Sign*(2.0d0*rdens*Fockii + ! (ib,ib)+
     &              2.0d0*(2.0d0*Focki(jjA,jjB)+
     &              2.0d0*FockA(jjA,jjB)-Fock(jjB,jjA)))
         End Do
         rout(i) = rout(i) - 4.0d0*rFock
*
**       iba
*
         ip=iTri1(ja,nAsh(js)+1)
         Call DaXpY_(jVert,sign*4.0d0,Focki(nO+1,ja+nIsh(js)),1,
     &               rout(ip),1)
         Call DaXpY_(jVert,sign*4.0d0,FockA(nO+1,ja+nIsh(js)),1,
     &               rout(ip),1)
         Call DaXpY_(jVert,-sign,     Fock (nO+1,ja+nIsh(js)),1,
     &               rout(ip),1)
      End Do
*
**       ibb
*
      i=itri1(i1,i1)-1
      Do kB=nIsh(jS)+nAsh(jS),nOrb(jS)-1
         rOut(i+1)=rout(i+1)-4.0d0*rFock
         Do lB=kb,nOrb(JS)-1
            i=i+1
            rOut(i)=rout(i)+
     &              sign*4.0d0*Focki(kb+1,lb+1)+
     &              sign*4.0d0*Focka(kb+1,lb+1)
         End Do
      End Do
* 10   Continue
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(iB)
        Call Unused_integer(iS)
        Call Unused_integer(nbai)
        Call Unused_real(fockti)
        Call Unused_real_array(A_K)
        Call Unused_real_array(Scr)
      End If
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Mk_List2(List2,nTheta_All,mData,nSO_Tot,iCnttp,nTest,
     &                    ijS_req)
      Use Basis_Info, only: dbsc, Shells
#include "WrkSpc.fh"
      Integer List2(2*mData,nTheta_All)
      Logical Only_DB
*
      Call GetMem('iList','Allo','Inte',ip_iList,nSO_Tot*mData)
*
      Only_DB=ijS_req.ne.0
*
*     Generate intermediate list
*     Generate list2, shell blocked!
*
      ijSO=0
      iiSO=0
      iSO_= 0
      Do iAng = 0, nTest
         iShll = dbsc(iCnttp)%iVal + iAng
         nCmp = (iAng+1)*(iAng+2)/2
         If (Shells(iShll)%Prjct) nCmp = 2*iAng+1
         nSO=nCmp*Shells(iShll)%nBasis
         Do iCmp = 1, nCmp
            nCont = Shells(iShll)%nBasis
            Do iCont = 1, nCont
                iSO_= iSO_+ 1
                iWork(ip_iList+(iSO_-1)*mData  )=iAng
                iWork(ip_iList+(iSO_-1)*mData+1)=iCmp
                iWork(ip_iList+(iSO_-1)*mData+2)=iCont
                iWork(ip_iList+(iSO_-1)*mData+3)=iShll
            End Do
         End Do
C        Write (6,*) 'iSO_=',iSO_
*
         jjSO=0
         Do jAng = 0, iAng
C           Write (6,*) 'iAng,jAng=',iAng,jAng
            jShll = dbsc(iCnttp)%iVal + jAng
            mCmp = (jAng+1)*(jAng+2)/2
            If (Shells(jShll)%Prjct) mCmp = 2*jAng+1
*
            mSO=mCmp*Shells(jShll)%nBasis
*
            ijS=(iAng+1)*iAng/2+jAng+1
*
            If (.NOT.Only_DB .or. ijS.eq.ijS_req) Then
               Do iSO = iiSO+1, iiSO+nSO
                  iAng_ =iWork(ip_iList+(iSO-1)*mData  )
                  iCmp_ =iWork(ip_iList+(iSO-1)*mData+1)
                  iCont_=iWork(ip_iList+(iSO-1)*mData+2)
                  iShll_=iWork(ip_iList+(iSO-1)*mData+3)
*
                  jSO_Max=jjSO+mSO
                  If (jAng.eq.iAng) jSO_Max=iSO
                  Do jSO = jjSO+1, jSO_Max
                     ijSO=ijSO+1
                     jAng_ =iWork(ip_iList+(jSO-1)*mData  )
                     jCmp_ =iWork(ip_iList+(jSO-1)*mData+1)
                     jCont_=iWork(ip_iList+(jSO-1)*mData+2)
                     jShll_=iWork(ip_iList+(jSO-1)*mData+3)
*
C                    Write (*,*) 'iSO,jSO,ijSO=',iSO,jSO,ijSO
                     List2(1,ijSO)=iAng_
                     List2(2,ijSO)=jAng_
                     List2(3,ijSO)=iCmp_
                     List2(4,ijSO)=jCmp_
                     List2(5,ijSO)=iCont_
                     List2(6,ijSO)=jCont_
                     List2(7,ijSO)=iShll_
                     List2(8,ijSO)=jShll_
                  End Do            ! jSO
               End Do               ! iSO
*
            End If
*
            jjSO=jjSO+mSO
         End Do                  ! jAng
*
         iiSO=iiSO+nSO
      End Do                     ! iAng
*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
         Write (6,*) 'List2'
         Write (6,*) '  iAng,  jAng,  iCmp,  jCmp, iCont, '
     &             //'jCont, iShll, jShll'
         Do ijSO = 1, nTheta_All
            Write (6,'(8I7)') (List2(i,ijSO),i=1,8)
         End Do
#endif
*
      Call Free_iWork(ip_iList)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine o12sb2_cvb(orbs,cvb,nparm1,nvb,
     >  nfrorb,
     >  gjorb,gjorb2,gjorb3,
     >  dx,
     >  dxnrm,grdnrm,close2conv,strucopt)
      implicit real*8 (a-h,o-z)
      logical strucopt,skip
      logical close2conv
      external asonc12s_cvb,ddres2upd10_cvb
#include "malloc_cvb.fh"
#include "opt_cvb.fh"
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

#include "davtune_cvb.fh"
#include "opt2_cvb.fh"
      dimension orbs(*),cvb(nvb)
      dimension gjorb(*),gjorb2(*),gjorb3(*)
      dimension dx(nparm1)
      save resthr_old,one
      data one/1d0/

      if(.not.close2conv)then
        resthr_use=1d-5
      else
        resthr_use=5d-2*grdnrm
        resthr_use=min(1d-5,resthr_use)
        resthr_use=max(1d-9,resthr_use)
      endif
      skip=(resthr_use.eq.resthr_old.and.have_solved_it)
      resthr_old=resthr_use
      if(skip)goto 100

      call makegjorbs_cvb(orbs,gjorb,gjorb2,gjorb3)

      call axb_cvb(asonc12s_cvb,ddres2upd10_cvb,dx,
     >  resthr_use,ioptc,iter,fx_exp)
      exp=fx_exp-fxbest
      have_solved_it=.true.

      if(ip.ge.2)write(6,'(2a,i4)')' Number of iterations for ',
     >  'direct diagonalization :',iter

      if(strucopt)then
        cnrm2=ddot_(nvb,cvb,1,dx(nfrorb+1),1)
c  "Orthogonalize" on CVB to get smallest possible update norm :
        call daxpy_(nvb,-cnrm2,cvb,1,dx(nfrorb+1),1)
c  Scale variables according to overlap with CVB :
        call dscal_(nparm1,one/cnrm2,dx,1)
      else
c  We are doing "Augmented" calc:
        fac=one/dx(1)
c  Scale variables according to overlap with CVB :
        do 50 i=1,nparm1-1
        dx(i)=fac*dx(i+1)
50      continue
      endif

100   dxnrm=dnrm2_(nparm1,dx,1)
      if(.not.close2conv)then
        ipu=1
      else
        ipu=2
      endif
      if(dxnrm.gt.hh.or.scalesmall(ipu))then
        call dscal_(nparm1,hh/dxnrm,dx,1)
        dxnrm=hh
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Giovanni Li Manni                                *
!               2019, Oskar Weser                                      *
!***********************************************************************
module fcidump_transformations
  use general_data, only : nActEl, nAsh, ntot1, ntot2, nBas, nSym
  use rasscf_data, only : nAcPar, core_energy => Emy, nAc
  use index_symmetry, only : one_el_idx_flatten
  implicit none
  private
  public :: get_orbital_E, fold_Fock
contains

!>  @brief
!>    Get the orbital energies.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  If it is the 1A or 1B iteration (0 <= actual_iter <= 1), the one electron
!>  energies are read from the InpOrb.
!>  Otherwise orbital_energies is a copy of DIAF.
!>
!>  @param[in] actual_iter
!>  @param[in] DIAF
!>  @param[out] orbital_energies
  subroutine get_orbital_E(actual_iter, DIAF, orbital_energies)
    integer, intent(in) :: actual_iter
    real*8, intent(in) :: DIAF(:)
    real*8, intent(out) :: orbital_energies(:)

    orbital_energies = 0.d0
    if (0 <= actual_iter .or. actual_iter <= 1) then
      call read_orbital_energies(nSym, nBas, orbital_energies)
    else
      orbital_energies(:) = DIAF(:)
    end if
  contains
    subroutine read_orbital_energies(nSym, nBas, orbital_energies)
      integer, intent(in) :: nSym, nBas(:)
      real*8, intent(inout) :: orbital_energies(:)
      real*8 :: Dummy(1)
      integer :: LuInpOrb = 10, iDummy(1), err
      character(len=*), parameter ::  FnInpOrb = 'INPORB'
      character(len=80) :: VecTit
      logical :: okay
      call f_Inquire(FnInpOrb, okay)
      if (okay) then
        call RdVec(FnInpOrb,LuInpOrb,'E',nSym,nBas,nBas, &
          Dummy, Dummy, orbital_energies, iDummy, &
          VecTit, 0, err)
      else
        Write (6,*) 'RdCMO: Error finding MO file'
        call Abend()
      end if
    end subroutine read_orbital_energies
  end subroutine get_orbital_E


!>  @brief
!>    Generate inactive Fock-matrix in active MO space
!>
!>  @author Oskar Weser
!>
!>  @details
!>  Generate the Fock-matrix for the frozen and inactive orbitals.
!>  in the basis of the active MOs as obtained from ::SGFCIN.
!>  Has the sideeffect of setting \p EMY to the core energy.
!>
!>  @param[in] CMO The MO coefficients.
!>  @param[in] D1I_AO The inactive one-body density matrix in AO-space
!>    \f[D^{\text{AO}, I} = 2 C (C^I)^\dagger \f]
!>    See ::get_D1I_rasscf.
!>  @param[in] D1A_AO The active one-body density matrix in AO-space
!>    \f[ D^{\text{AO}, A} = C^A D^A (C^A)^\dagger \f]
!>    See ::get_D1A_rasscf.
!>  @param[in] D1S_MO The active spin density matrix in MO-space
!>    \f[ D^A_\alpha - D^A_\beta \f]
!>  @param[in,out] F_In The inactive Fock matrix in AO-space
!>    \f[\sum_{\sigma\rho} D^I_{\sigma\rho}(g_{\mu\nu\sigma\rho} - \frac{1}{2} g_{\mu\sigma\rho\nu})\f]
!>    In output FI contains also the core energy added to
!>    the diagonal elements.
!>    \f[\sum_{\sigma\rho} D^I_{\sigma\rho}(g_{\mu\nu\sigma\rho} -
!>      \frac{1}{2} g_{\mu\sigma\rho\nu}) + \frac{E^{(0)}}{n_el} \delta_{\mu\nu} \f]
!>  @param[out] folded_Fock The inactive Fock matrix
!>    in the basis of the active MOs as obtained from ::SGFCIN.
  subroutine fold_Fock(CMO, D1I_AO, D1A_AO, D1S_MO, F_In, folded_Fock)
    real*8, intent(in) :: CMO(nTot2), D1A_AO(nTot2), D1I_AO(nTot2), D1S_MO(nAcPar)
    real*8, intent(inout) :: F_In(nTot1)
    real*8, intent(out) :: folded_Fock(nAcPar)
    integer :: i, n
    real*8 :: core_E_per_act_el,&
! one-body spin density matrix in AO-space
        D1S_AO(nTot2),&
! blocked one-body spin density matrix in MO-space
        D1S_MO_blocked(nAcPar)

    D1S_MO_blocked(:nAcPar) = D1S_MO(:nAcPar)
    IF (nAsh(1) /= nAc) call DBlock(D1S_MO_blocked)
    call get_D1A_RASSCF(CMO, D1S_MO_blocked, D1S_AO)
! SGFCIN has side effects and EMY/core_energy is set in this routine.
! Besides F_In will contain the one electron contribution afterwards.
    call SGFCIN(CMO, folded_fock, F_In, D1I_AO, D1A_AO, D1S_AO)

! Remove the core energy in the diagonal elements.
    if (nActEl /= 0) then
      core_E_per_act_el = core_energy / dble(nActEl)
    else
      core_E_per_act_el = 0.0d0
    end if

    do i = 1, sum(nAsh)
      n = one_el_idx_flatten(i, i)
      folded_Fock(n) = folded_Fock(n) - core_E_per_act_el
    end do
  end subroutine fold_Fock

end module fcidump_transformations

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_RASSI_RDINP(DFonly,LuSpool)
!***********************************************************************
!
!  Purpose:   If DFonly, use defaults only.
!             Else, read and process input for Cholesky section
!             in RASSI
!
!***********************************************************************

use Fock_util_global, only: Deco, Estimate, PseudoChoMOs, Update
use Cholesky, only: timings
use Cntrl, only: ALGO, dmpk, Nscreen
use rassi_data, only: CHFRACMEM
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: DFonly
integer(kind=iwp), intent(in) :: LuSpool
integer(kind=iwp) :: iChrct, last
real(kind=wp) :: dmpk_dfl
character(len=180) :: Key, KWord
integer(kind=iwp), external :: iCLast
character(len=180), external :: Get_Ln

!**** Algorithms for using Cholesky vectors in RASSI ******************
!
!   ALGO:
!
!          1  --->  compute fock matrices in AO-basis from vectors
!                   read in reduced sets and transformed on the fly.
!                   (TU|VX) integrals are also returned
!
!          2  --->  compute fock matrices in AO-basis from vectors
!                   read in reduced sets and transformed on the fly
!                   (TU|VX) integrals are also returned.
!                   Exchange contributions are computed using the
!                   "Local K" scheme
!                                                                      *
!***********************************************************************
!                                                                      *
! Default  parameters
#ifdef _MOLCAS_MPP_
ChFracMem = 0.3_wp
#else
ChFracMem = Zero
#endif
ALGO = 2
timings = .false.
dmpk = 0.1_wp
Nscreen = 10  ! to be reset to 0 if doing RI calculation
Deco = .true.
Update = .true.
Estimate = .false.

if (.not. DFonly) then

  ! set some parameters if not specified in ChoInput section
  PseudoChoMOs = .false.
  dmpk_dfl = 0.1_wp
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Process the input

  !--------------------------------------------------------------------*
  do
    !------------------------------------------------------------------*
    ! Use Get_Ln to read the lines.                                    *
    !------------------------------------------------------------------*
    Key = Get_Ln(LuSpool)
    Kword = Key
    call UpCase(Kword)
    !------------------------------------------------------------------*
    ! The keywords and their labels.                                   *
    !------------------------------------------------------------------*
    if (KWord(1:1) == '*') cycle
    if (KWord == '') cycle
    select case (Kword(1:4))

      case ('ALGO')
        !                                                              *
        !***** ALGO ****************************************************
        !                                                              *
        ! Read Cholesky algorithm parameters

        ! call Get_F1(1,Eps)
        ! call Get_F1(2,rds)
        ! call Get_I1(1,ALGO)
        ! if (nToken(KWord) > 1) call abend()

        read(LuSpool,*) ALGO
        if (ALGO == 1) then
          write(u6,*) 'Default CD-RASSI algorithm reset to  ',ALGO
          write(u6,*)
        else if (ALGO == 2) then
          write(u6,*) 'Default CD-RASSI algorithm reset to  ',ALGO
          write(u6,*)
        else
          write(u6,*) 'The specified algorithm is not implemented.'
          write(u6,*) 'Option Ignored'
          write(u6,*)
        end if

      case ('LOCK')
        algo = 2
        write(u6,*) 'Default CD-RASSI algorithm reset to  ',ALGO
        write(u6,*) 'Using Local K scheme for Exchange matrices'

      case ('NOLK')
        algo = 1
        write(u6,*) 'Default CD-RASSI algorithm reset to  ',ALGO
        write(u6,*) 'Local K scheme for Exchange matrices turned off !'

      case ('SCRN')
        read(LuSpool,*) Nscreen

      case ('DMPK')
        read(LuSpool,*) DMPK
        if (dmpk < Zero) then
          write(u6,*) 'OBS! Specified Negative DMPK value. Restore Defaults'
          dmpk = dmpk_dfl
        end if

      case ('TIME')
        timings = .true.

      case ('UPDA')
        Update = .true.
        write(u6,*) 'Local-K with updating of the true diagonals'
        write(u6,*)

      case ('ESTI')
        Estimate = .true.
        write(u6,*) 'Local-K with evaluation of the diagonals from the current vec'
        write(u6,*)

      case ('MEMF')
        read(LuSpool,*) ChFracMem

      case ('NODE')
        if (PseudoChoMOs) then
          write(u6,*) ' The keyword NODEcompose is incompatible with the previously specified keyword PSEUdo. '// &
                      'NODEcompose will be ignored'
        else
          Deco = .false.
          write(u6,*) 'Canonical inactive orbitals used in LK CD-RASSI.'
        end if
        write(u6,*)

      case ('PSEU')
        if (.not. Deco) then
          write(u6,*) ' The keyword PSEUdo is incompatible with the previously specified keyword NODEcompose. PSEUdo will be '// &
                      'ignored'
        else
          PseudoChoMOs = .true.
          write(u6,*) 'Pseudo Cholesky orbitals used in LK CD-RASSI.'
        end if
        write(u6,*)

      case ('ENDC','END ','ENDO')
        exit

      case default
        iChrct = len(KWord)
        Last = iCLast(KWord,iChrct)
        write(u6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
        write(u6,*) 'CHO_RASSI_RDINP: Error in keyword.'
        call AbEnd()

    end select

  end do

end if

end subroutine CHO_RASSI_RDINP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine MATCG(CIN,COUT,NROWI,NROWO,IROWI1,NGCOL,IGAT,GATSGN)
! Gather columns of CIN with phase
!
! COUT(IR,IC) = GATSGN(IC)*CIN(IR+IROWI1-1,IGAT(IC)) if IGAT(IC) /= 0
! COUT(IR,IC) = 0                                    if IGAT(IC) /= 0

use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NROWI, NROWO, IROWI1, NGCOL, IGAT(NGCOL)
real(kind=wp), intent(in) :: CIN(NROWI,*), GATSGN(NGCOL)
real(kind=wp), intent(out) :: COUT(NROWO,NGCOL)
integer(kind=iwp) :: IG, IGFRM
real(kind=wp) :: SGN

!write(u6,*) ' MATCG NROWI,NROWO,IROWI1,NGCOL'
!write(u6,*) NROWI,NROWO,IROWI1,NGCOL
do IG=1,NGCOL
  !write(u6,*) ' igat,sign ',IGAT(IG),GATSGN(IG)
  if (IGAT(IG) == 0) then
    COUT(:,IG) = Zero
  else
    IGFRM = IGAT(IG)
    SGN = GATSGN(IG)
    COUT(:,IG) = SGN*CIN(IROWI1:IROWI1+NROWO-1,IGFRM)
  end if
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Column gathered matrix'
call WRTMAT(COUT,NROWO,NGCOL,NROWO,NGCOL)
#endif

end subroutine MATCG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Francesco Aquilante                              *
************************************************************************
      SubRoutine ChoMP2_fno_Fll(irc,Delete,P_ab,P_ii,EOcc,EVir,Wrk,lWrk)
C
C      F. Aquilante, Geneva May 2008  (snick to Pedersen's code)
C
C
#include "implicit.fh"
      Logical Delete
      Real*8  EOcc(*), EVir(*), Wrk(lWrk), P_ab(*), P_ii(*)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"
      Real*8  DeMP2
      Logical MP2_small
      Common / ChFNOPT/ DeMP2, MP2_small

      Character*7  ThisNm
      Character*14 SecNam
      Parameter (SecNam = 'ChoMP2_fno_Fll', ThisNm = 'fno_Fll')

      Integer nEnrVec(8), LnT2am, LiT2am(8), kP(8), lP(8)
      Integer nVaJi, iVaJi(8)

      LiMatij(i,j,k)=iWork(ip_LiMatij-1+nSym*nSym*(k-1)+nSym*(j-1)+i)
      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      If (nBatch .ne. 1) Then
         irc = -1
         Return
      End If

      irc = 0

      kP(1)=1
      lP(1)=0
      Do iS=2,nSym
         kP(iS)=kP(iS-1)+nVir(iS-1)**2
         lP(iS)=lP(iS-1)+nOcc(iS-1)
      End Do

C     Determine if vector files are to be deleted after use.
C     ------------------------------------------------------

      If (Delete) Then
         iClos = 3
      Else
         iClos = 2
      End If

C     Set number and type of vectors.
C     -------------------------------

      If (DecoMP2) Then
         iTyp = 2
         Call iCopy(nSym,nMP2Vec,1,nEnrVec,1)
      Else
         iTyp = 1
         Call iCopy(nSym,NumCho,1,nEnrVec,1)
      End If

C     Set (ai|bj) indices.
C     --------------------

      Call ChoMP2_Energy_GetInd(LnT2am,LiT2am,1,1)

C     Allocate memory for integrals.
C     ------------------------------

      kXaibj = 1
      kEnd0  = kXaibj + LnT2am
      lWrk0  = lWrk   - kEnd0 + 1
      If (lWrk0 .lt. 0) Then
         Call ChoMP2_Quit(SecNam,'insufficient memory','[0]')
      End If

      If (ChoAlg.eq.2 .and. MP2_small) Then ! level 3 BLAS algorithm

         kMabij = kXaibj ! rename pointer
         Call Cho_dZero(Wrk(kMabij),LnT2am) ! initialize

C        Loop over Cholesky symmetries.
C        ------------------------------

         Do iSym = 1,nSym

            Nai = nT1am(iSym)
            If (Nai.gt.0 .and. nEnrVec(iSym).gt.0) Then

C              Reserve memory for reading a single vector.
C              -------------------------------------------

               kVecai = kEnd0
               kEnd1  = kVecai + Nai
               lWrk1  = lWrk   - kEnd1 + 1

               If (lWrk1 .lt. Nai) Then
                  Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                             '[ChoAlg.2.1]')
               End If

C              Set up batch over Cholesky vectors.
C              -----------------------------------

               nVec = min(lWrk1/Nai,nEnrVec(iSym))
               If (nVec .lt. 1) Then ! should not happen
                  Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                             '[ChoAlg.2.2]')
               End If
               nBat = (nEnrVec(iSym)-1)/nVec + 1

C              Open Cholesky vector files.
C              ---------------------------

               Call ChoMP2_OpenF(1,iTyp,iSym)

C              Start vector batch loop.
C              ------------------------

               Do iBat = 1,nBat

                  If (iBat .eq. nBat) Then
                     NumVec = nEnrVec(iSym) - nVec*(nBat-1)
                  Else
                     NumVec = nVec
                  End If
                  iVec1 = nVec*(iBat-1) + 1

C                 Set up index arrays for reordered vectors.
C                 ------------------------------------------

                  nVaJi = 0
                  Do iSymi = 1,nSym
                     iSyma = MulD2h(iSymi,iSym)
                     iVaJi(iSymi) = nVaJi
                     nVaJi = nVaJi
     &                    + nVir(iSyma)*NumVec*nOcc(iSymi)
                  End Do

C                 Pointer to reordered vectors: kVec.
C                 -----------------------------------

                  kVec  = kEnd1
                  kEnd2 = kVec  + nVaJi
                  lWrk2 = lWrk  - kEnd2 + 1
                  If (lWrk2 .lt. 0) Then ! should not happen
                     Call ChoMP2_Quit(SecNam,
     &                                'Insufficient memory',
     &                                '[ChoAlg.2.3]')
                  End If

C                 Read one vector at a time and reorder.
C                 --------------------------------------

                  iVec0 = iVec1 - 1
                  Do iVec = 1,NumVec

                     iOpt = 2
                     lTot = nT1am(iSym)
                     iAdr = nT1am(iSym)*(iVec0+iVec-1) + 1
                     Call ddaFile(lUnit_F(iSym,iTyp),iOpt,
     &                            Wrk(kVecai),lTot,iAdr)

                     Do iSymi = 1,nSym
                        iSyma = MulD2h(iSymi,iSym)
                        Do i = 1,nOcc(iSymi)
                           kOff1 = kVecai
     &                           + iT1am(iSyma,iSymi)
     &                           + nVir(iSyma)*(i-1)
                           kOff2 = kVec + iVaJi(iSymi)
     &                           + nVir(iSyma)*NumVec*(i-1)
     &                           + nVir(iSyma)*(iVec-1)
                           Call dCopy_(nVir(iSyma),Wrk(kOff1),1,
     &                                Wrk(kOff2),1)
                        End Do
                     End Do

                  End Do

C                 Compute M(ab,ii) .
C                 ---------------------------------------

                  Do iSymj = 1,nSym

                     iSymb = MulD2h(iSymj,iSym)

                     If (nVir(iSymb) .gt. 0) Then

                        Do j = 1,nOcc(iSymj)

                           i = j

                           ij = LiMatij(iSymj,iSymj,1)
     &                        + iTri(i,j)

                           kOffi = kVec + iVaJi(iSymj)
     &                           + nVir(iSymb)*NumVec*(i-1)
                           kOffj = kVec + iVaJi(iSymj)
     &                              + nVir(iSymb)*NumVec*(j-1)
                           kOffM = kMabij + LiT2am(1)
     &                           + nMatab(1)*(ij-1)
     &                           + iMatab(iSymb,iSymb)

                           Call dGeMM_('N','T',
     &                          nVir(iSymb),nVir(iSymb),NumVec,
     &                          1.0d0,Wrk(kOffi),nVir(iSymb),
     &                                Wrk(kOffj),nVir(iSymb),
     &                          1.0D0,Wrk(kOffM),nVir(iSymb))

                        End Do

                     End If

                  End Do

               End Do

               Call Cho_GAdGOp(Wrk(kMabij),LnT2am,'+')

C              Close (and possibly delete) Cholesky vector files.
C              --------------------------------------------------

               Call ChoMP2_OpenF(iClos,iTyp,iSym)


C              Compute Energy contribution.
C              -------------------------------------

               Do iSymj = 1,nSym

                  iSymb = MulD2h(iSymj,iSym)

                  If (nVir(iSymb) .gt. 0) Then

                     Do j = 1,nOcc(iSymj)

                        i = j

                        ij = LiMatij(iSymj,iSymj,1)
     &                     + iTri(i,j)

                        kOffM = kMabij + LiT2am(1)
     &                        + nMatab(1)*(ij-1)
     &                        + iMatab(iSymb,iSymb)

                        Do jb=1,nVir(iSymb)
                           Do ja=1,nVir(iSymb)
                              Dnom = EVir(iVir(iSymb)+ja)
     &                             + EVir(iVir(iSymb)+jb)
     &                             - 2.0d0*EOcc(iOcc(iSymj)+j)
                              kOffMM = kOffM
     &                               + nVir(iSymb)*(jb-1) +ja-1
                              DeMP2 = DeMP2
     &                              + Wrk(kOffMM)**2/Dnom
                           End Do
                        End Do

                     End Do

                  End If

               End Do

            End If

         End Do ! iSym

      ElseIf (ChoAlg .eq. 2) Then ! level 3 BLAS algorithm

         kMabij = kXaibj ! rename pointer
         Call Cho_dZero(Wrk(kMabij),LnT2am) ! initialize

C        Loop over Cholesky symmetries.
C        ------------------------------

         Do iSym = 1,nSym

            Nai = nT1am(iSym)
            If (Nai.gt.0 .and. nEnrVec(iSym).gt.0) Then

C              Reserve memory for reading a single vector.
C              -------------------------------------------

               kVecai = kEnd0
               kEnd1  = kVecai + Nai
               lWrk1  = lWrk   - kEnd1 + 1

               If (lWrk1 .lt. Nai) Then
                  Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                             '[ChoAlg.2.1]')
               End If

C              Set up batch over Cholesky vectors.
C              -----------------------------------

               nVec = min(lWrk1/Nai,nEnrVec(iSym))
               If (nVec .lt. 1) Then ! should not happen
                  Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                             '[ChoAlg.2.2]')
               End If
               nBat = (nEnrVec(iSym)-1)/nVec + 1

C              Open Cholesky vector files.
C              ---------------------------

               Call ChoMP2_OpenF(1,iTyp,iSym)

C              Start vector batch loop.
C              ------------------------

               Do iBat = 1,nBat

                  If (iBat .eq. nBat) Then
                     NumVec = nEnrVec(iSym) - nVec*(nBat-1)
                  Else
                     NumVec = nVec
                  End If
                  iVec1 = nVec*(iBat-1) + 1

C                 Set up index arrays for reordered vectors.
C                 ------------------------------------------

                  nVaJi = 0
                  Do iSymi = 1,nSym
                     iSyma = MulD2h(iSymi,iSym)
                     iVaJi(iSymi) = nVaJi
                     nVaJi = nVaJi
     &                    + nVir(iSyma)*NumVec*nOcc(iSymi)
                  End Do

C                 Pointer to reordered vectors: kVec.
C                 -----------------------------------

                  kVec  = kEnd1
                  kEnd2 = kVec  + nVaJi
                  lWrk2 = lWrk  - kEnd2 + 1
                  If (lWrk2 .lt. 0) Then ! should not happen
                     Call ChoMP2_Quit(SecNam,
     &                                'Insufficient memory',
     &                                '[ChoAlg.2.3]')
                  End If

C                 Read one vector at a time and reorder.
C                 --------------------------------------

                  iVec0 = iVec1 - 1
                  Do iVec = 1,NumVec

                     iOpt = 2
                     lTot = nT1am(iSym)
                     iAdr = nT1am(iSym)*(iVec0+iVec-1) + 1
                     Call ddaFile(lUnit_F(iSym,iTyp),iOpt,
     &                            Wrk(kVecai),lTot,iAdr)

                     Do iSymi = 1,nSym
                        iSyma = MulD2h(iSymi,iSym)
                        Do i = 1,nOcc(iSymi)
                           kOff1 = kVecai
     &                           + iT1am(iSyma,iSymi)
     &                           + nVir(iSyma)*(i-1)
                           kOff2 = kVec + iVaJi(iSymi)
     &                           + nVir(iSyma)*NumVec*(i-1)
     &                           + nVir(iSyma)*(iVec-1)
                           Call dCopy_(nVir(iSyma),Wrk(kOff1),1,
     &                                Wrk(kOff2),1)
                        End Do
                     End Do

                  End Do

C                 Compute M(ab,ii) .
C                 ---------------------------------------

                  Do iSymj = 1,nSym

                     iSymb = MulD2h(iSymj,iSym)

                     If (nVir(iSymb) .gt. 0) Then

                        Do j = 1,nOcc(iSymj)

                           i = j

                           ij = LiMatij(iSymj,iSymj,1)
     &                        + iTri(i,j)

                           kOffi = kVec + iVaJi(iSymj)
     &                           + nVir(iSymb)*NumVec*(i-1)
                           kOffj = kVec + iVaJi(iSymj)
     &                              + nVir(iSymb)*NumVec*(j-1)
                           kOffM = kMabij + LiT2am(1)
     &                           + nMatab(1)*(ij-1)
     &                           + iMatab(iSymb,iSymb)

                           Call dGeMM_('N','T',
     &                          nVir(iSymb),nVir(iSymb),NumVec,
     &                          1.0d0,Wrk(kOffi),nVir(iSymb),
     &                                Wrk(kOffj),nVir(iSymb),
     &                          1.0D0,Wrk(kOffM),nVir(iSymb))

                        End Do

                     End If

                  End Do

               End Do

               Call Cho_GAdGOp(Wrk(kMabij),LnT2am,'+')

C              Close (and possibly delete) Cholesky vector files.
C              --------------------------------------------------

               Call ChoMP2_OpenF(iClos,iTyp,iSym)

C
               Do iSymj = 1,nSym

                  iSymb = MulD2h(iSymj,iSym)

                  If (nVir(iSymb) .gt. 0) Then

                     Do j = 1,nOcc(iSymj)

                        i = j

                        ij = LiMatij(iSymj,iSymj,1)
     &                     + iTri(i,j)

                        kOffM = kMabij + LiT2am(1)
     &                        + nMatab(1)*(ij-1)
     &                        + iMatab(iSymb,iSymb)

C                       Compute T(a,b)[i] and energy contrib.
C                       -------------------------------------
                        Do jb=1,nVir(iSymb)
                           Do ja=1,nVir(iSymb)
                              Dnom = EVir(iVir(iSymb)+ja)
     &                             + EVir(iVir(iSymb)+jb)
     &                             - 2.0d0*EOcc(iOcc(iSymj)+j)
                              kOffMM = kOffM
     &                               + nVir(iSymb)*(jb-1) +ja-1
                              DeMP2 = DeMP2
     &                              + Wrk(kOffMM)**2/Dnom
                              Wrk(kOffMM) = Wrk(kOffMM)/Dnom
                           End Do
                        End Do

                        P_ii(lP(iSymj)+i) = P_ii(lP(iSymj)+i)
     &                                    + ddot_(nVir(iSymb)**2,
     &                                             Wrk(kOffM),1,
     &                                             Wrk(kOffM),1)

C                       Compute P(a,b) += sum_c T(a,c)*T(c,b)
C                       -------------------------------------
                        Call dGeMM_('N','N',nVir(iSymb),
     &                             nVir(iSymb),nVir(iSymb),
     &                       1.0d0,Wrk(kOffM),nVir(iSymb),
     &                             Wrk(kOffM),nVir(iSymb),
     &                       1.0D0,P_ab(kP(iSymb)),nVir(iSymb))

                     End Do

                  End If

               End Do

            End If

         End Do ! iSym

      End If ! ChoAlg

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_grc42y(a,b,c,mvec,ssa,ssb,ix)

use CCT3_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
type(Map_Type), intent(in) :: a, b
type(Map_Type), intent(inout) :: c
integer(kind=iwp), intent(out) :: mvec(4096,7), ix
integer(kind=iwp), intent(in) :: ssa, ssb
integer(kind=iwp) :: ia, ib, iy, nhelp1, nhelp2, nhelp21, nhelp22, nhelp4, nhelp41, nhelp42, ntest1, ntest2, posct, sa1, sa134, &
                     sa2, sa3, sa34, sa4, sb1, sb2

! structure A(pq,rs)*B(rs)=YC(pq)

!1.0 prepare c%d,c%i

if ((a%d(0,6) == 1) .or. (a%d(0,6) == 4)) then
  ntest1 = 1
else
  ntest1 = 0
end if

call cct3_grc0(2,ntest1,a%d(0,1),a%d(0,2),0,0,mmul(ssa,ssb),c,posct)

!1.1 define limitations - p>q,r,s must be tested - ntest1
!                       - p,q,r>s must be tested - ntest2

if ((a%d(0,6) == 1) .or. (a%d(0,6) == 4)) then
  ntest1 = 1
else
  ntest1 = 0
end if

if ((a%d(0,6) == 3) .or. (a%d(0,6) == 4)) then
  ntest2 = 1
else
  ntest2 = 0
end if

!1.2 def symm states and test the limitations

ix = 0
do sb1=1,nsym
  sa3 = sb1

  sb2 = mmul(ssb,sb1)
  sa4 = sb2
  sa34 = mmul(sa3,sa4)
  ! Meggie out
  if ((ntest2 == 1) .and. (sb1 < sb2)) cycle

  do sa1=1,nsym
    sa134 = mmul(sa1,sa34)

    sa2 = mmul(ssa,sa134)
    ! Meggie out
    if ((ntest1 == 1) .and. (sa1 < sa2)) cycle

    !1.3 def mvec,c%d and c%i

    ia = a%i(sa1,sa2,sa3)
    ib = a%i(sb1,1,1)
    iy = c%i(sa1,1,1)

    ! yes/no
    if ((a%d(ia,2) > 0) .and. (b%d(ib,2) > 0)) then
      nhelp1 = 1
    else
      cycle
    end if

    ! rowA
    nhelp21 = dimm(a%d(0,1),sa1)
    nhelp22 = dimm(a%d(0,2),sa2)
    if ((ntest1 == 1) .and. (sa1 == sa2)) then
      nhelp2 = nhelp21*(nhelp21-1)/2
    else
      nhelp2 = nhelp21*nhelp22
    end if

    ! sum
    nhelp41 = dimm(a%d(0,3),sa3)
    nhelp42 = dimm(a%d(0,4),sa4)
    if ((ntest2 == 1) .and. (sa3 == sa4)) then
      nhelp4 = nhelp41*(nhelp41-1)/2
    else
      nhelp4 = nhelp41*nhelp42
    end if

    ix = ix+1
    mvec(ix,1) = nhelp1
    mvec(ix,2) = a%d(ia,1)
    mvec(ix,3) = b%d(ib,1)
    mvec(ix,4) = c%d(iy,1)
    mvec(ix,5) = nhelp2
    mvec(ix,6) = nhelp4
    mvec(ix,7) = 0

  end do
end do

return

end subroutine cct3_grc42y

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************

      SUBROUTINE CHO_FMCSCF(rc,ipFA,ipFI,nForb,nIorb,nAorb,FactXI,
     &                      ipPorb,ipDI,ipDA1,DoActive,ipChM,nChM,ipInt,
     &                      ExFac)

**********************************************************************
*  Author : F. Aquilante
*
C *************** INACTIVE AO-BASIS FOCK MATRIX **********************
C
C   FI(ab) = 2 * sum_J  Lab,J * V(J)  -  sum_Jk  Lka,J * Lkb,J
C
C ***************   ACTIVE AO-BASIS FOCK MATRIX **********************
C
C   FA(ab) = sum_J  Lab,J * U(J)  -  0.5 * sum_Jw  Lwa,J * Lwb,J
C
C ***************   (WA|XY) integrals     ****************************
C
C   (WA|XY) = sum_J  L(wa,J) * L(xy,J)
C
**********************************************************************
C
C      V(J) = sum_gd  Lgd,J * DI(gd)
C      U(J) = sum_gd  Lgd,J * DA(gd)
C
C      a,b,g,d:  AO-index
C      k:        MO-index   belonging to (Frozen+Inactive)
C      u,w,x,y:  MO-indeces belonging to (Active)
C
**********************************************************************

      Implicit Real*8 (a-h,o-z)

      Integer   rc,ipLab(8,3),ipLxy(8),ipScr(8,8)
      Integer   ipOrb(8,3),nOrb(8,3)
      Integer   ISTAQ(8),iSkip(8)
      Integer   ISTLT(8),ISTCH(8)
      Real*8    tread(2),tcoul(2),texch(2),tintg(2), ExFac
      Integer   ipDA1,ipDI
      Integer   ipPorb,ipFA,ipFI
      Integer   ipDLT(2),ipFLT(2),ipDab(2),ipFab(2)
      Integer   nForb(8),nIorb(8),nAorb(8),nPorb(8),nnA(8,8),nChM(8)
      Logical   Debug,timings,DoRead,DoTraInt,DoActive
      Character*50 CFmt
      Character*10 SECNAM
      Parameter (SECNAM = 'CHO_FMCSCF')
      COMMON    /CHOTIME /timings

      parameter (FactCI = 1.0D0)
      parameter (FactCA = 1.0D0, FactXA = -0.5D0)
      parameter (zero = 0.0D0, one = 1.0D0)

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )
      Logical add
      Character*6 mode

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
************************************************************************

#ifdef _DEBUGPRINT_
c      Debug=.true.
      Debug=.false.! to avoid double printing in CASSCF-debug
#else
      Debug=.false.
#endif


      if(ExFac.ne.1.0d0) then
          write(6,*) 'WARNING: if you are running MCPDFT calculations'
          write(6,*) 'and end up with this message, you are in trouble.'
          write(6,*) 'Tweaks are needed!! Please contact'
          write(6,*) 'Giovanni Li Manni'
          write(6,*) 'giovannilimanni@gmail.com'
      end if
      DoRead  = .false.
      DoTraInt = .false.
      IREDC = -1  ! unknown reduced set in core

      ipDLT(1) = ipDI    ! some definitions
      ipDLT(2) = ipDA1
      ipFLT(1) = ipFI
      ipFLT(2) = ipFA

      nDen = 1
      if (DoActive) nDen=2

        CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        do i=1,2            ! 1 --> CPU   2 --> Wall
           tread(i) = zero  !time read/transform vectors
           tcoul(i) = zero  !time for computing Coulomb
           texch(i) = zero  !time for computing Exchange
           tintg(i) = zero  !time for computing (pu|vx) integrals
        end do

c --- Define MOs in the Primary space
c --- ( Frozen + Inactive + Active )
c -----------------------------------
        do i=1,nSym
           nPorb(i) = nForb(i) + nIorb(i) + nAorb(i)
        end do

      Call set_nnA(nSym,nAorb,nnA)

C ==================================================================

c --- Various offsets
c --------------------
        ISTAQ(1)=0
        ISTLT(1)=0
        ISTCH(1)=0
      DO ISYM=2,NSYM
        NB=NBAS(ISYM-1)
        NBB=NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
        NP=NPORB(ISYM-1)
        NP2=NB*NP
        NCH=NB*NCHM(ISYM-1)
        ISTLT(ISYM)=ISTLT(ISYM-1)+NBB
! Inactive and Active D and F matrices
        ISTAQ(ISYM)=ISTAQ(ISYM-1)+NP2 ! MOs coefficients
        ISTCH(ISYM)=ISTCH(ISYM-1)+NCH ! "Cholesky MOs"
      END DO

      Do iSym=1,nSym        ! MOs to feed in cho_x_getvtra

         ipOrb(iSym,1) = ipPorb + ISTAQ(iSym)
         nOrb(iSym,1)  = nForb(iSym)+nIorb(iSym)

         ipOrb(iSym,2) = ipChM + ISTCH(iSym)
         nOrb(iSym,2)  = nChM(iSym)

         ipOrb(iSym,3) = ipPorb + ISTAQ(iSym)
     &                 + nOrb(iSym,1)*nBas(iSym)
         nOrb(iSym,3)  = nAorb(iSym)

      End Do

      iLoc = 3 ! use scratch location in reduced index arrays

C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
      DO jSym=1,nSym

         If (NumCho(jSym).lt.1) GOTO 1000

C *** memory for the (wa|xy) integrals --- temporary array
         Mwaxy = 0
         Do iSymy=1,nSym
            iSymx=MulD2h(iSymy,JSYM)
            If (iSymx.le.iSymy) then
               Do iSyma=1,nSym
                  iSymw=MulD2h(iSyma,JSYM)
                  Mwaxy = Mwaxy + nAorb(iSymw)*nBas(iSyma)
     &                                        *nnA(iSymx,iSymy)
               End Do
             End If
         End Do

         Call GetMem('Mtmp','ALLO','REAL',ipItmp,Mwaxy)
         Call Fzero(Work(ipItmp),Mwaxy)

C *** setup pointers to the symmetry blocks of (wa|xy)
         Do i=1,nSym
            Do j=1,nSym
               ipScr(j,i) = ipItmp
            End Do
         End Do

         kScr=ipItmp
         Do iSymy=1,nSym
            iSymx=MulD2h(iSymy,JSYM)
            If (iSymx.le.iSymy) then
               Do iSyma=1,nSym
                  iSymw=MulD2h(iSyma,JSYM)
                  ipScr(iSymw,iSymx) = kScr
                  kScr = kScr + nAorb(iSymw)*nBas(iSyma)
     &                                      *nnA(iSymx,iSymy)
               End Do
             End If
         End Do

C --- Set up the skipping flags + some initializations --------
C -------------------------------------------------------------
         Do i=1,nSym

            k = Muld2h(i,JSYM)
            iSkip(i) = Min(1,nBas(i)*nBas(k)) ! skip Lik vector
            iSkip(i) = iSkip(i)*(nPorb(i)+nChM(i))

            ipLab(i,1) = -6666  ! pointers to Lk,Jb
            ipLab(i,2) = -6666  ! pointers to "cholesky MOs vectors"
            ipLab(i,3) = -6666  ! pointers to Lvb,J
            ipLxy(i) = -6666  ! pointers to Lxy,J

         End Do
C -------------------------------------------------------------


C ****************     MEMORY MANAGEMENT SECTION    *****************
C ------------------------------------------------------------------
C --- compute memory needed to store at least 1 vector of JSYM
C --- and do all the subsequent calculations
C ------------------------------------------------------------------
         mTvec  = 0  ! mem for storing the half-transformed vec

         do l=1,nSym
            k=Muld2h(l,JSYM)
            mTvec = mTvec + nBas(l)*Max((nForb(k)+nIorb(k)),
     &              nAorb(k),nChM(k)) + nnA(k,l)
         end do

         mTvec = Max(mTvec,1)

C ------------------------------------------------------------------
C ------------------------------------------------------------------

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

         Do JRED=JRED1,JRED2

            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               call abend()
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.',
     &                       '    rc= ',irc
              call abend()
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            If(JSYM.eq.1)Then

               Call GetMem('rsDI','Allo','Real',ipDab(1),nRS)
               Call GetMem('rsFI','Allo','Real',ipFab(1),nRS)

               if(DoActive)then
                 Call GetMem('rsDA1','Allo','Real',ipDab(2),nRS)
                 Call GetMem('rsFA','Allo','Real',ipFab(2),nRS)
               endif

            EndIf

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec  = Min(LWORK/(nRS+mTvec),nVrs)

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) 'LWORK= ',LWORK
               WRITE(6,*) 'min. mem. need= ',nRS+mTvec
               WRITE(6,*) 'reading ',nRS,' and transforming to ',mTvec
               WRITE(6,*) 'of jsym= ',jsym,' and JRED= ',JRED
               rc = 33
               CALL Abend()
               nBatch = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
            Call GetMem('ChoT','Allo','Real',ipChoT,mTvec*nVec)

            If(JSYM.eq.1)Then
C --- Transform the density to reduced storage
               mode = 'toreds'
               add  = .false.
               Call change_sto(irc,iLoc,nDen,ipDLT,ipDab,mode,add)
            EndIf

C --- BATCH over the vectors ----------------------------

            nBatch = (nVrs-1)/nVec + 1

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM) then
                  rc=77
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

               IF(JSYM.eq.1)THEN

C ************ INACTIVE COULOMB CONTRIBUTION  ****************
C
C --- Contraction with the density matrix
C ---------------------------------------
C --- V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * DI(rs)
C==========================================================

                  CALL CWTIME(TCC1,TWC1)

                  ipVJ = ipChoT

                  CALL DGEMV_('T',nRS,JNUM,
     &                 ONE,Work(ipLrs),nRS,
     &                 Work(ipDab(1)),1,ZERO,Work(ipVJ),1)

C --- FI(rs){#J} <- FI(rs){#J} + FactCI * sum_J L(rs,{#J})*V{#J}
C===============================================================

                  xfac = dble(min(jVec-iVrs,1))

                  CALL DGEMV_('N',nRS,JNUM,
     &                 FactCI,Work(ipLrs),nRS,
     &                 Work(ipVJ),1,xfac,Work(ipFab(1)),1)


                  If (DoActive) Then
C ************ ACTIVE COULOMB CONTRIBUTION  ****************
C
C---- Computing the intermediate vector V(J)
C ---------------------------------------
C --- U{#J} <- U{#J}  +  sum_rs  L(rs,{#J}) * DA(rs)
C==========================================================
C
                     CALL DGEMV_('T',nRS,JNUM,
     &                          ONE,Work(ipLrs),nRS,
     &                          Work(ipDab(2)),1,ZERO,Work(ipVJ),1)

C --- FA(rs){#J} <- FA(rs){#J} + FactCA * sum_J L(rs,{#J})*U{#J}
C===============================================================

                     xfac = dble(min(jVec-iVrs,1))

                     CALL DGEMV_('N',nRS,JNUM,
     &                          FactCA,Work(ipLrs),nRS,
     &                          Work(ipVJ),1,xfac,Work(ipFab(2)),1)

                  EndIf


                  CALL CWTIME(TCC2,TWC2)
                  tcoul(1) = tcoul(1) + (TCC2 - TCC1)
                  tcoul(2) = tcoul(2) + (TWC2 - TWC1)


               ENDIf  ! Coulomb (jsym=1)

C ************ BEGIN EXCHANGE CONTRIBUTIONS  ****************

C --- Set pointers to the half-transformed Cholesky vectors
               lChoT=0
               Do iSymb=1,nSym

                  iSymp = MulD2h(JSYM,iSymb)

                  ipLab(iSymp,1) = ipChoT + lChoT  ! LkJ,b
                  ipLab(iSymp,2) = ipLab(iSymp,1)  ! LxJ,b

                  ipLab(iSymp,3) = ipLab(iSymp,1)  ! Lvb,J
                  ipLxy(iSymp) = ipLab(iSymp,3)    ! Lvw,J
     &                         + nAorb(iSymp)*nBas(iSymb)*JNUM

                  lChoT = lChoT + nBas(iSymb)*
     &                    Max((nForb(iSymp)+nIorb(iSymp)),
     &                         nAorb(iSymp),nChM(iSymp))*JNUM
     &                  + nnA(iSymp,iSymb)*JNUM

#ifdef _DEBUGPRINT_
            write(6,*)'JRED,iBatch,nBatch= ',jred,iBatch,nBatch
            write(6,*)'JSYM,iSymp,iSymb,lChot= ',JSYM,iSymp,iSymb,lChot
            write(6,*)'Lxb starts in= ',ipLab(iSymp,3)
            write(6,*)'and occupies ',nAorb(iSymp)*nBas(iSymb)*JNUM
            write(6,*)'Lxy starts in= ',ipLxy(iSymp)
            write(6,*)'and occupies ',nnA(iSymp,iSymb)*JNUM
#endif

               End Do

               iSwap = 2  ! LpJ,b are returned

C *********************** INACTIVE HALF-TRANSFORMATION  ****************

               kMOs = 1  ! inactive MOs
               nMOs = 1

               CALL CWTIME(TCR3,TWR3)

               CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                         JSYM,iSwap,IREDC,nMOs,kMOs,ipOrb,nOrb,
     &                         ipLab,iSkip,DoRead)


               CALL CWTIME(TCR4,TWR4)
               tread(1) = tread(1) + (TCR4 - TCR3)
               tread(2) = tread(2) + (TWR4 - TWR3)

#ifdef _DEBUGPRINT_
       write(6,*) 'Half-transformation in the Inactive space'
       write(6,*) 'Total allocated :     ',mTvec*nVec,' at ',ipChoT
       write(6,*) 'Mem pointers ipLab :  ',(ipLab(i,1),i=1,nSym)
       write(6,*) 'ipLxy :  ',(ipLxy(i),i=1,nSym)
       write(6,*) 'iSkip :        ',(iSkip(i),i=1,nSym)
       write(6,*) 'LREAD: ',LREAD,' allocated at ',ipLrs
       write(6,*) 'JRED :        ',JRED
       write(6,*) 'JSYM :        ',JSYM
       write(6,*) 'JNUM :        ',JNUM
#endif

               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif


               CALL CWTIME(TCX1,TWX1)

               Do iSyma=1,nSym

                  iSymk = MulD2h(JSYM,iSyma)

C ---------------------------------------------------------------------
c *** Compute only the LT part of the InActive exchange matrix ********
C
C     FI(ab) = FI(ab) + FactXI * sum_Jk  LkJ,a * LkJ,b
C ---------------------------------------------------------------------
                  NK = nForb(iSymk) + nIorb(iSymk)

                  If (iSkip(iSymk)*NK.ne.0) Then

                     ISFI = ipFI + ISTLT(iSyma)

                     CALL DGEMM_TRI('T','N',nBas(iSyma),nBas(iSyma),
     &                         NK*JNUM,FactXI,Work(ipLab(iSymk,1)),
     &                         NK*JNUM,Work(ipLab(iSymk,1)),NK*JNUM,
     &                         One,Work(ISFI),nBas(iSyma))


c          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYMA
c          CALL TRIPRT('FI: ',' ',Work(ISFI),nBas(iSyma))

                  EndIf

C --------------------------------------------------------------------
               End Do  !loop over MOs symmetries

               CALL CWTIME(TCX2,TWX2)
               texch(1) = texch(1) + (TCX2 - TCX1)
               texch(2) = texch(2) + (TWX2 - TWX1)


               IF(DoActive)THEN
C *********************** "CHOLESKY" HALF-TRANSFORMATION  ****************
C --------------------------------------------------------------------
c --- Using "Cholesky MOs" obtained by cholesky decomposing DA
C --------------------------------------------------------------------

                  CALL CWTIME(TCR5,TWR5)

                  kMOs = 2  ! Cholesky MOs
                  nMOs = 2

                  CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                            JSYM,iSwap,IREDC,nMOs,kMOs,ipOrb,nOrb,
     &                            ipLab,iSkip,DoRead)


                  CALL CWTIME(TCR6,TWR6)
                  tread(1) = tread(1) + (TCR6 - TCR5)
                  tread(2) = tread(2) + (TWR6 - TWR5)


                  if (irc.ne.0) then
                     rc = irc
                     RETURN
                  endif

                  CALL CWTIME(TCX3,TWX3)

C ---------------------------------------------------------------------
c *** Compute only the LT part of the Active exchange matrix **********
C
C     FA(ab) = FA(ab) + FactXA * sum_wJ  LwJ,a * LwJ,b
C ---------------------------------------------------------------------
                    Do iSyma=1,nSym

                     iSymw = MulD2h(JSYM,iSyma)

                     NAch= nChM(iSymw)

                     If (iSkip(iSymw)*NAch.ne.0) Then

                        ISFA = ipFA + ISTLT(iSyma)

                        CALL DGEMM_TRI('T','N',nBas(iSyma),nBas(iSyma),
     &                         NAch*JNUM,FactXA,Work(ipLab(iSymw,2)),
     &                         NAch*JNUM,Work(ipLab(iSymw,2)),NAch*JNUM,
     &                         One,Work(ISFA),nBas(iSyma))


c          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYMA
c          CALL TRIPRT('FA: ',' ',Work(ISFA),nBas(iSyma))

                     EndIf

C --------------------------------------------------------------------
                    End Do  !loop over MOs symmetries

                  CALL CWTIME(TCX4,TWX4)
                  texch(1) = texch(1) + (TCX4 - TCX3)
                  texch(2) = texch(2) + (TWX4 - TWX3)

               ENDIF   ! Do Active Exchange


C ************  END EXCHANGE CONTRIBUTIONS  ****************


C --------------------------------------------------------------------
C --- First half Active transformation  Lvb,J = sum_a  C(v,a) * Lab,J
C --------------------------------------------------------------------

               CALL CWTIME(TCR7,TWR7)

               iSwap = 0  ! Lvb,J are returned
               kMOs = 3  ! Active MOs
               nMOs = 3  ! Active MOs

               CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                            JSYM,iSwap,IREDC,nMOs,kMOs,ipOrb,nOrb,
     &                            ipLab,iSkip,DoRead)


               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif

C --------------------------------------------------------------------
C --- Active-Active transformation  Lvw,J = sum_b  Lvb,J * C(w,b)
C --------------------------------------------------------------------
               IF (JSYM.eq.1) THEN   !  Lvw,J in LT-storage

                  Do iSyma=1,nSym

                     NAv = nAorb(iSyma)

                     If(NAv.ne.0)Then

                      NK   = nForb(iSyma) + nIorb(iSyma)
                      ISMO = ipPorb + ISTAQ(iSyma) + NK*nBas(iSyma)

                      Do JVC=1,JNUM

                       ipLvb = ipLab(iSyma,3) + NAv*nBas(iSyma)*(JVC-1)
                       ipLvw = ipLxy(iSyma) + nnA(iSyma,iSyma)*(JVC-1)

                       CALL DGEMM_Tri('N','T',NAv,NAv,nBas(iSyma),
     &                                One,Work(ipLvb),NAv,
     &                                    Work(ISMO),NAv,
     &                               Zero,Work(ipLvw),NAv)

                      End Do

                     EndIf

                  End Do


               ELSE

C --------------------------------------------------------------------
C --- Active-Active transformation  Lvw,J = sum_b  Lvb,J * C(w,b)
C --------------------------------------------------------------------
                  Do iSymb=1,nSym

                     iSymv = MulD2h(JSYM,iSymb)
                     NAv = nAorb(iSymv)
                     NAw = nAorb(iSymb) ! iSymb=iSymw

                     If(NAv*NAw.ne.0.and.iSymv.lt.iSymb)Then

                      NK = nForb(iSymb) + nIorb(iSymb)
                      ISMO = ipPorb + ISTAQ(iSymb) + NK*nBas(iSymb)

                      Do JVC=1,JNUM

                       ipLvb = ipLab(iSymv,3) + NAv*nBas(iSymb)*(JVC-1)
                       ipLvw = ipLxy(iSymv) + nnA(iSymv,iSymb)*(JVC-1)

                       CALL DGEMM_('N','T',NAv,NAw,nBas(iSymb),
     &                            One,Work(ipLvb),NAv,
     &                                Work(ISMO),NAw,
     &                           Zero,Work(ipLvw),NAv)

                      End Do

                     EndIf

                  End Do


               ENDIF   ! jSym >=< 1

               CALL CWTIME(TCR8,TWR8)
               tread(1) = tread(1) + (TCR8 - TCR7)
               tread(2) = tread(2) + (TWR8 - TWR7)


C *************** EVALUATION OF THE (WA|XY) INTEGRALS ***********

               CALL CWTIME(TCINT1,TWINT1)

               DoTraInt = JRED.eq.JRED2.and.iBatch.eq.nBatch

               CALL CHO_eval_waxy(irc,ipScr,ipLab,ipLxy,ipInt,nAorb,
     &                            JSYM,JNUM,DoTraInt)

               CALL CWTIME(TCINT2,TWINT2)
               tintg(1) = tintg(1) + (TCINT2 - TCINT1)
               tintg(2) = tintg(2) + (TWINT2 - TWINT1)

               if (irc.ne.0) then
                  rc = irc
                  RETURN
               endif

C --------------------------------------------------------------------
C --------------------------------------------------------------------

            END DO  ! end batch loop


            if (JSYM.eq.1) then
c --- backtransform fock matrix in full storage
               mode = 'tofull'
               add  = .true.
               Call change_sto(irc,iLoc,nDen,ipFLT,ipFab,mode,add)
            endif

C --- free memory
            Call GetMem('ChoT','Free','Real',ipChoT,mTvec*nVec)
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

            if (JSYM.eq.1) then
               if(DoActive)then
                 Call GetMem('rsFA','Free','Real',ipFab(2),nRS)
                 Call GetMem('rsDA1','Free','Real',ipDab(2),nRS)
               endif
               Call GetMem('rsFI','Free','Real',ipFab(1),nRS)
               Call GetMem('rsDI','Free','Real',ipDab(1),nRS)
            endif


999         CONTINUE

         END DO   ! loop over red sets

         Call GetMem('Mtmp','Free','REAL',ipItmp,Mwaxy)

1000     CONTINUE


      END DO   !loop over JSYM


      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1


*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky CASSCF timing from '//SECNAM
      Write(6,CFmt)'----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ/TRANSFORM VECTORS           '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB                          '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'EXCHANGE                         '
     &                           //'         ',texch(1),texch(2)
         Write(6,'(2x,A26,2f10.2)')'(WA|XY) INTEGRALS                '
     &                           //'         ',tintg(1),tintg(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


c Print the Fock-matrix
#ifdef _DEBUGPRINT_

      if(Debug) then !to avoid double printing in CASSCF-debug

      WRITE(6,'(6X,A)')'TEST PRINT FROM '//SECNAM
      WRITE(6,'(6X,A)')
      WRITE(6,'(6X,A)')'***** INACTIVE FOCK MATRIX ***** '
      DO ISYM=1,NSYM
        ISFI=ipFI+ISTLT(ISYM)
        IF( NBAS(ISYM).GT.0 ) THEN
          WRITE(6,'(6X,A)')
          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
          call TRIPRT('','',Work(ISFI),NBAS(ISYM))
        ENDIF
      END DO
      IF(DoActive)THEN
        WRITE(6,'(6X,A)')
        WRITE(6,'(6X,A)')'***** ACTIVE FOCK MATRIX ***** '
        DO ISYM=1,NSYM
         IF( NBAS(ISYM).GT.0 ) THEN
           ISFA=ipFA+ISTLT(ISYM)
           WRITE(6,'(6X,A)')
           WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
           call TRIPRT('','',Work(ISFA),NBAS(ISYM))
         ENDIF
        END DO
      END IF

      endif

#endif

      rc  = 0


      Return
      END

**************************************************************
**************************************************************



      SUBROUTINE change_sto(irc,iLoc,nDen,ipXLT,ipXab,mode,add)

      Implicit Real*8 (a-h,o-z)
      Integer  ISLT(8),cho_isao,nDen
      External cho_isao
      Integer ipXLT(nDen),ipXab(nDen)
      Logical add
      Character*6 mode

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

************************************************************************
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      iRS2F(i,j)  = iWork(ip_iRS2F-1+2*(j-1)+i)
************************************************************************


c Offsets to symmetry block in the LT matrix
      ISLT(1)=0
      DO ISYM=2,NSYM
         ISLT(ISYM) = ISLT(ISYM-1)
     &              + NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
      END DO

**************************************************

      jSym = 1 ! only total symmetric density

* PAM06
*      xf=0.0d0
*      if (add) xf=1.0d0 !accumulate contributions

      If (mode.eq.'toreds') then
* PAM06 Inactivated lines above replaced by this insert:
         If (.not.add) then
          Do jDen=1,nDen
           Do jRab=1,nnBstR(jSym,iLoc)
            Work(ipXab(jDen)+jRab-1) = 0.0D0
           End Do
          End Do
         End If
* PAM06 End of insert

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            Do jDen=1,nDen

               kfrom = ipXLT(jDen) + isLT(iSyma) + iab - 1

* PAM06 These two lines...
*               Work(ipXab(jDen)+jRab-1) = xf*Work(ipXab(jDen)+jRab-1)
*     &                                  +    Work(kfrom)
* PAM06 ...replaced by:
               Work(ipXab(jDen)+jRab-1) = Work(ipXab(jDen)+jRab-1)
     &                                  +    Work(kfrom)
* PAM06 End of replacement
* PAM06 These two lines...
* PAM06 ...replaced by:
* PAM06 End of replacement
            End Do

         End Do  ! jRab loop

      ElseIf (mode.eq.'tofull') then
* PAM06 Similar with this insert:
         If (.not.add) then
          Do jRab=1,nnBstR(jSym,iLoc)
           kRab = iiBstr(jSym,iLoc) + jRab
           iRab = IndRed(kRab,iLoc)
           iag   = iRS2F(1,iRab)  !global address
           ibg   = iRS2F(2,iRab)
           iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)
           ias   = iag - ibas(iSyma)  !address within that symm block
           ibs   = ibg - ibas(iSyma)
           iab   = iTri(ias,ibs)
           Do jDen=1,nDen
            kto = ipXLT(jDen) + isLT(iSyma) + iab - 1
            Work(kto) = 0.0D0
           End Do
          End Do
         End If
* PAM06 End of insert

         Do jRab=1,nnBstR(jSym,iLoc)

            kRab = iiBstr(jSym,iLoc) + jRab
            iRab = IndRed(kRab,iLoc)

            iag   = iRS2F(1,iRab)  !global address
            ibg   = iRS2F(2,iRab)

            iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

            ias   = iag - ibas(iSyma)  !address within that symm block
            ibs   = ibg - ibas(iSyma)
            iab   = iTri(ias,ibs)

            Do jDen=1,nDen

               kto = ipXLT(jDen) + isLT(iSyma) + iab - 1

* PAM06 These two lines...
*               Work(kto) = xf*Work(kto)
*     &                   +    Work(ipXab(jDen)+jRab-1)
* PAM06 ...replaced by:
               Work(kto) = Work(kto)
     &                   +    Work(ipXab(jDen)+jRab-1)
* PAM06 End of replacement

            End Do


         End Do  ! jRab loop

      Else

         write(6,*)'Wrong input parameter. mode = ',mode
         irc = 66
         Call abend()

      EndIf

      irc = 0

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
SUBROUTINE set_l_kriging(lv,nInter_In)
  use kriging_mod
  integer nInter_In
  real*8 lv(nInter_In)
!
! Set the characteristic length of all the components of the coordintes.
!
  If (nInter_In.eq.nInter) Then
    l(:)=lv(:)
  Else If (nInter.eq.1) Then
    l(:)=lv(1)
  Else
    Write (6,*) "setlkriging: illegal nInter value."
    Call Abend()
  End If
!
! Generate the covariance matrix
!
  call covarMatrix()
!
! Form the inverse of the covariance matrix times the generalized value vector.
!
  call kriging_model()

END SUBROUTINE set_l_kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
*               2017, Roland Lindh                                     *
************************************************************************
      Subroutine VecFind(OccSet,FermSet,CharSet,SpinSet)
************************************************************************
*                                                                      *
* This routine figure out which set of starting orbitals are used.     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University, Sweden                                     *
*                                                                      *
*          R. Lindh                                                    *
*          Uppsala University, Sweden, Feb 2017                        *
*          Remove Work                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* Input vector mappings                                                *
*                                                                      *
* LstVec              InVec                                            *
* -1 Die               0 Core                                          *
*  0 Old SCF           1 NDDO (not used)                               *
*  1 Guessorb          2 Lumorb                                        *
*  2 Lumorb            3 Old density                                   *
*  3 Old Density       4 Restart (not used)                            *
*  4 Core              8 Old SCF                                       *
*  5 NDDO (use not)    9 Guessorb                                      *
*                                                                      *
************************************************************************
#ifdef _HDF5_
      Use mh5, Only: mh5_fetch_attr
#endif
      Implicit Real*8 (A-H,O-Z)
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*----------------------------------------------------------------------*
* Dummy arguments                                                      *
*----------------------------------------------------------------------*
      Logical OccSet
      Logical FermSet
      Logical CharSet
      Logical SpinSet
*----------------------------------------------------------------------*
* Local variables                                                      *
*----------------------------------------------------------------------*
      Character*80 cList
      Logical Found
      Integer mynSym
      Integer mynBas(8)
      Integer mynOrb(8)
      Character*10 infoLbl
      Real*8, Dimension(:), Allocatable:: EOrb
*----------------------------------------------------------------------*
* Setup                                                                *
*----------------------------------------------------------------------*
      nSqrSum=0
      Do iSym = 1, nSym
         nSqrSum=nSqrSum+nBas(iSym)*nBas(iSym)
      End Do
*----------------------------------------------------------------------*
* Check start orbital priority list                                    *
*----------------------------------------------------------------------*
*     Write(6,*) 'LstVec',LstVec
      Do i=1,nStOpt
         Found=.false.
         If(LstVec(i).eq.0) Then
*           Write(6,'(2i5,a)') i,LstVec(i),' Old scf orbitals'
            Call qpg_darray('SCF orbitals',Found,nData)
            If(Found .and. nData.eq.nSqrSum) Then
*              Write(6,*) 'Found orbitals'
               Call qpg_darray('OrbE',Found,nData)
               If(Found) Then
*                 Write(6,*) 'Found energies'
                  InVec=8
                  GoTo 101
               End If
            End If
         Else If(LstVec(i).eq.1) Then
*           Write(6,'(2i5,a)') i,LstVec(i),' Guessorb orbitals'
            Call qpg_darray('Guessorb',Found,nData)
            If(Found .and. nData.eq.nSqrSum) Then
               Call qpg_darray('Guessorb energies',Found,nData)
               If(Found) Then
                  InVec=9
                  GoTo 101
               End If
            End If
         Else If(LstVec(i).eq.2) Then
*           Write(6,'(2i5,a)') i,LstVec(i),' Lumorb orbitals'
            Call F_Inquire(SCF_FileOrb,Found)
            If(Found) Then
               If (isHDF5) Then
#ifdef _HDF5_
                 iVer=-1
                 Call mh5_fetch_attr(fileorb_id,'NSYM',mynSym)
                 Call mh5_fetch_attr(fileorb_id,'NBAS',mynBas)
#endif
               Else
                 Call ChkVec(SCF_FileOrb,
     $                  iVer,mynSym,mynBas,mynOrb,InfoLbl,iRc)
               End If
               If(iVer.eq.0) Found=.false.
               If(mynSym.ne.nSym) Found=.false.
               Do j=1,nSym
                 If(mynBas(j).ne.nBas(j)) Found=.false.
               End Do
            End If
            If(Found) Then
*              Write(6,*) 'Found INPORB'
               InVec=2
               GoTo 101
            End If
         Else If(LstVec(i).eq.3) Then
*           Write(6,'(2i5,a)') i,LstVec(i),' Density'
            InVec=0
         Else If(LstVec(i).eq.4) Then
*           Write(6,'(2i5,a)') i,LstVec(i),' Core orbitals'
            InVec=0
            Found=.true.
            GoTo 101
         Else
*           Write(6,'(2i5,a)') i,LstVec(i),' Die'
            InVec=0
            Found=.false.
            GoTo 101
         End If
*        Write(6,*) 'LstVec(i),Found:',LstVec(i),Found
      End Do
      Found=.false.
101   Continue
*     Write(6,*) 'VecFind: InVec=',InVec
*----------------------------------------------------------------------*
* Did we find the requested orbitals?                                  *
*----------------------------------------------------------------------*
      If(.not.Found) Then
         cList=''
         n2=0
         Do i=1,nStOpt
            If(LstVec(i).eq.0) Then
               n1=n2+1
               n2=n1+9
               Write(cList(n1:n2),'(a)') 'Old Scf, '
            Else If (LstVec(i).eq.1) Then
               n1=n2+1
               n2=n1+10
               Write(cList(n1:n2),'(a)') 'Guessorb, '
            Else If (LstVec(i).eq.2) Then
               n1=n2+1
               n2=n1+8
               If (isHDF5) Then
                  Write(cList(n1:n2),'(a)') 'HDF5, '
               Else
                  Write(cList(n1:n2),'(a)') 'Lumorb, '
               End If
            Else If (LstVec(i).eq.3) Then
               n1=n2+1
               n2=n1+13
               Write(cList(n1:n2),'(a)') 'Old density, '
            Else If (LstVec(i).eq.4) Then
               n1=n2+1
               n2=n1+6
               Write(cList(n1:n2),'(a)') 'Core, '
            Else If (LstVec(i).eq.5) Then
               n1=n2+1
               n2=n1+6
               Write(cList(n1:n2),'(a)') 'NDDO, '
            Else If (LstVec(i).eq.-1) Then
               GoTo 290
            Else
               n1=n2+1
               n2=n1+9
               Write(cList(n1:n2),'(a)') 'Unknown, '
            End If
         End Do
290      Continue
         Call SysAbendMsg('SCF:',
     &      'Can not find start orbitals according to list:',
     &      cList)
      End If
*----------------------------------------------------------------------*
* What are the defaults for the different cases?                       *
*----------------------------------------------------------------------*
      Call Get_dScalar('Total Nuclear Charge',Tot_Nuc_Charge)
      Tot_El_Charge=Tot_Charge-Tot_Nuc_Charge
      If(InVec.eq.0) Then
*
* We will use core diagonalization
*
*        Write(6,*) 'Using core diagonalization'
         OccSet=.false.
         FermSet=.true.
      Else If(Invec.eq.1) Then
*
* We will use NDDO orbitals, should not be used!
*
*        Write(6,*) 'Using NDDO orbitals'
      Else If(Invec.eq.2) Then
*
* We will use Lumorb orbitals
*
*        Write(6,*) 'Using Lumorb orbitals'
         Call ChkLumo(OccSet,FermSet,SpinSet)
      Else If(Invec.eq.3) Then
*
* We will use density as start, does it even work?
*
*        Write(6,*) 'Using density'
      Else If(Invec.eq.4) Then
*
* This is a restart case
*
*        Write(6,*) 'Using Restart'
      Else If(Invec.eq.8) Then
*
* We will use old SCF orbitals
*
*        Write(6,*) 'Using SCF orbitals'
*        Write(6,*) 'tot_charge',tot_charge
*        Write(6,*) 'tot_el_charge',tot_el_charge
*        Write(6,*) 'tot_nuc_charge',tot_nuc_charge
         Call qpg_iarray('SCF nOcc',Found,nData)
         idspin=0
         If(Found) Then
*           Write(6,*) 'vecfind: Allright, old scf orbitals it is'
            nEle=0
            If(iUHF.eq.0) Then
               Call Get_iarray('SCF nOcc',nOcc(1,1),nSym)
               Call Get_iScalar('SCF mode',iTmp)
               If(iTmp.eq.0) Then
*                 Write(6,*) 'Starting RHF with RHF orbitals'
                  Do iSym=1,nSym
                     nEle=nEle+2*nOcc(iSym,1)
                  End Do
               Else
*                 Write(6,*) 'Starting RHF with UHF orbitals'
                  Call Get_iarray('SCF nOcc_ab',nOcc(1,2),nSym)
                  nEle1=0
                  nEle2=0
                  Do iSym=1,nSym
                     nEle1=nEle1+2*nOcc(iSym,1)
                     nEle2=nEle2+nOcc(iSym,1)+nOcc(iSym,2)
                     idspin=idspin+nOcc(iSym,1)-nOcc(iSym,2)
                  End Do
                  If(nEle1.ne.nEle2) Then
*                    Tot_Charge=Tot_Nuc_Charge-nEle1
*                    Tot_El_Charge=-nEle1
                     CharSet=.true.
                  End If
                  nEle=nEle2
*                 Write(6,*) 'After strange code'
*                 Write(6,*) 'tot_charge',tot_charge
*                 Write(6,*) 'tot_el_charge',tot_el_charge
*                 Write(6,*) 'tot_nuc_charge',tot_nuc_charge
               End If
            Else
*              Write(6,*) 'Starting UHF with RHF/UHF orbitals'
               Call Get_iarray('SCF nOcc',nOcc(1,1),nSym)
               Call qpg_iarray('SCF nOcc_ab',Found,nData)
               If(Found) Then
                  Call Get_iarray('SCF nOcc_ab',nOcc(1,2),nSym)
               Else
                  Call Get_iarray('SCF nOcc',nOcc(1,2),nSym)
               End If
               Do iSym=1,nSym
                  nEle=nEle+nOcc(iSym,1)+nOcc(iSym,2)
                  idspin=idspin+nOcc(iSym,1)-nOcc(iSym,2)
               End Do
            End If
*           Write(6,*) 'idspin',idspin
*           Write(6,*) 'iAu_ab',iAu_ab
            idspin=idspin-iAu_ab
            If(Abs(Tot_El_Charge+nEle).gt.0.5d0.or.idspin.ne.0) Then
               If(Abs(Tot_El_Charge+nEle).gt.0.5d0) Then
*                 Write(6,*) 'System have changed charge!'
               End If
               If(idspin.ne.0) Then
*                 Write(6,*) 'System have changed spin!'
               End If
               If(CharSet.or.idspin.ne.0) Then
                  OccSet=.false.
                  FermSet=.true.
               Else
                  OccSet=.true.
                  FermSet=.false.
*                 Tot_Charge=Tot_Nuc_Charge-nEle
*                 Tot_El_Charge=-nEle
               End If
            Else
*              Write(6,*) 'System have same spin and charge'
               OccSet=.true.
               FermSet=.false.
            End If
*           Write(6,*) 'OccSet  ',OccSet
*           Write(6,*) 'FermSet ',FermSet
*           Write(6,*) 'CharSet ',CharSet
*           Write(6,*) 'SpinSet ',SpinSet
*           Write(6,*) 'nOcc',nOcc
         Else
            OccSet=.false.
            FermSet=.true.
         End If
      Else If(Invec.eq.9) Then
*
* We will use Guessorb orbitals
*
*        Write(6,*) 'Using Guessorb orbitals'
         If(OccSet) Then
*           Write(6,*) 'Occupation is set'
            !continue
         Else If(FermSet) Then
*           Write(6,*) 'Fermi is set'
            !continue
         Else
*           Write(6,*) 'Must decide if to use Fermi'
            If(nAufb(1).eq.-1) Then
               mtmp=Int(-Tot_El_Charge+0.1D0)
               If(iUHF.eq.0) Then
                  If(Mod(mtmp,2).ne.0) Then
                     Write(6,*) 'VecFind: Error in number of electrons'
                     Write(6,*) '         An even number of electrons ',
     &                          '         are required by RHF, use UHF'
                     Write(6,*)
                     Call Abend()
                  End If
                  nAufb(1)=mtmp/2
               Else
                  nAufb(2)=(mtmp-iAu_ab)/2
                  nAufb(1)=Int(-Tot_El_Charge-nAufb(2))
               End If
            End If
*           Write(6,*) 'nAufb',nAufb
*           Write(6,*) 'Now figure out homo-lumo gap'
            Call qpg_darray('Guessorb energies',Found,nData)
            Call mma_allocate(EOrb,nData,Label='EOrb')
            Call get_darray('Guessorb energies',Eorb,nData)
            If(iUHF.eq.0) Then
               Call GetGap(Eorb,nData,nAufb(1),Gap,Ealpha)
            Else
               Call GetGap(Eorb,nData,nAufb(1),tmp,Ealpha)
               Call GetGap(Eorb,nData,nAufb(2),Gap,Ebeta)
               Gap=Min(tmp,Gap)
            End If
            Call get_darray('Guessorb energies',Eorb,nData)
            If(Gap.ge.0.5d0) Then
               If(iUHF.eq.0) Then
                  iOff=0
                  Do iSym=1,nSym
                     n=0
                     Do iBas=1,nBas(iSym)
                        If(EOrb(iOff+iBas).lt.Ealpha) n=n+1
                     End Do
                     nOcc(iSym,1)=n
                     iOff=iOff+nBas(iSym)
                  End Do
               Else
                  iOff=0
                  Do iSym=1,nSym
                     n=0
                     Do iBas=1,nBas(iSym)
                        If(EOrb(iOff+iBas).lt.Ealpha) n=n+1
                     End Do
                     nOcc(iSym,1)=n
                     iOff=iOff+nBas(iSym)
                  End Do
                  iOff=0
                  Do iSym=1,nSym
                     n=0
                     Do iBas=1,nBas(iSym)
                        If(EOrb(iOff+iBas).lt.Ebeta) n=n+1
                     End Do
                     nOcc(iSym,2)=n
                     iOff=iOff+nBas(iSym)
                  End Do
               End If
               OccSet=.true.
               FermSet=.false.
*              Write(6,*) 'Decided on occupation list'
            Else
               OccSet=.false.
               FermSet=.true.
*              Write(6,*) 'Decided on Fermi aufbau'
            End If
            Call mma_deallocate(EOrb)
*           Write(6,*) 'Gap is',Gap
         End If
      Else
*
* This case should not appear
*
         Call SysAbendMsg('SCF:',
     &      'Internal error in VecFind!',
     &      'InVec have illegal value')
      End If
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
*     Write(6,'(a,i2)') 'VecFind: InVec=',InVec
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DrvPCM(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq)

use Basis_Info, only: DBSC, nBas, nCnttp
use Center_Info, only: DC
use PCM_arrays, only: C_Tessera, DiagScale, nTiles, PCMDM, PCMTess, Q_Tessera
use Symmetry_Info, only: iChBas, nIrrep
use rctfld_module, only: Eps, EpsInf, nTs
use Gateway_global, only: PrPrt
use Integral_Interfaces, only: int_kernel, int_mem, OneEl_Integrals
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nh1
real(kind=wp), intent(inout) :: h1(nh1), TwoHam(nh1), RepNuc
real(kind=wp), intent(in) :: D(nh1)
logical(kind=iwp), intent(in) :: First, Dff, NonEq
integer(kind=iwp) :: i, ip(1), iTile, jCnt, jCnttp, jTile, kOper, lOper, MaxAto, mCnt, n_Int, nC, nComp, nDC, nOrdOp
real(kind=wp) :: Dij, ENN, Fact, Origin(3), QInf, rHrmt, Rij, W_0_or_El, W_0_or_Inf, W_or_El, W_or_Inf, W_or_InfNuc, W_or_Nuc, Xi, &
                 Xj, Yi, Yj, Z, Zi, Zj
logical(kind=iwp) :: Save_tmp
character(len=8) :: Label
integer(kind=iwp), allocatable :: lOper2(:)
real(kind=wp), allocatable :: Chrg(:), Cord(:,:), FactOp(:), Integrals(:), PCM_charge(:,:), Q_Slow(:), V_Save(:,:), V_Slow(:), &
                              V_Tile(:,:)
procedure(int_kernel) :: PCMInt
procedure(int_mem) :: NaMem
integer(kind=iwp), external :: n2Tri

#include "macros.fh"
unused_var(Dff)

!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of all atoms

! Cord: list of all atoms

call Get_nAtoms_All(MaxAto)

call mma_allocate(Cord,3,MaxAto,Label='Cord')
call mma_allocate(Chrg,MaxAto,Label='Chrg')

ndc = 0
nc = 1
do jCnttp=1,nCnttp
  Z = dbsc(jCnttp)%Charge
  mCnt = dbsc(jCnttp)%nCntr
  if (dbsc(jCnttp)%Aux) mCnt = 0
  do jCnt=1,mCnt
    ndc = ndc+1
    do i=0,nIrrep/dc(ndc)%nStab-1
      call OA(dc(ndc)%iCoSet(i,0),dbsc(jCnttp)%Coor(1:3,jCnt),Cord(1:3,nc))
      Chrg(nc) = Z
      nc = nc+1
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(PCM_Charge,2,nTS,Label='PCM_Charge')
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(V_Tile,2,nTs,Label='V_Tile')
call mma_allocate(V_Save,2,nTs,Label='V_Save')
call mma_allocate(Q_Slow,nTs,Label='Q_Slow')
call mma_allocate(V_Slow,nTs,Label='V_Slow')

!                                                                      *
!***********************************************************************
!                                                                      *
! Reaction field a la PCM

! Set up some parameters.

rHrmt = One
nOrdOp = 0
nComp = 1
lOper = 255
kOper = iChBas(1)
Origin(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! Pick up slow charges and W's. These are present if we are doing
! the final state.

if (NonEq) then

  ! Read slow components originating from the initial state

  !write(u6,*) 'Rd:',Q_Slow(1)
  call Get_dArray('RCTFLD',Q_Slow,nTs)
  call Get_dScalar('W_or_el',W_0_or_el)
  call Get_dScalar('W_or_Inf',W_0_or_Inf)

  ! Compute the electrostatic potential due to slow charges

  V_Slow(:) = Zero
  do iTile=1,nTs
    XI = PCMTess(1,iTile)
    YI = PCMTess(2,iTile)
    ZI = PCMTess(3,iTile)
    do jTile=1,nTs
      if (jTile == iTile) then
        Dij = DiagScale*Two*sqrt(Pi/PCMTess(4,iTile))
      else
        XJ = PCMTess(1,jTile)
        YJ = PCMTess(2,jTile)
        ZJ = PCMTess(3,jTile)
        RIJ = sqrt((XI-XJ)**2+(YI-YJ)**2+(ZI-ZJ)**2)
        Dij = One/RIJ
      end if
      V_Slow(iTile) = V_Slow(iTile)+Dij*Q_Slow(jTile)
    end do
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Evaluate the potential field on the tiles.

Save_tmp = PrPrt
PrPrt = .true.

! Do the nuclear contribution

do iTile=1,nTs
  call EFNuc(PCMTess(1,iTile),Chrg,Cord,MaxAto,V_Tile(1,iTile),nOrdOp)
  V_Tile(2,iTile) = Zero
end do

! Do the electronic contribution

call mma_allocate(FactOp,nTs,Label='FactOp')
call mma_allocate(lOper2,nTs,Label='lOper2')
FactOp(:) = One
lOper2(:) = 255

call Drv1_PCM(FactOp,nTs,D,nh1,PCMTess,lOper2,V_Tile,nOrdOp)

call mma_deallocate(lOper2)
call mma_deallocate(FactOp)

! Save the electrostatic potential

V_Save(:,:) = V_Tile(:,:)

! Add the slow charge contribution to the nuclear potential

if (NonEq) V_Tile(1,:) = V_Tile(1,:)+V_Slow(:)
!                                                                      *
!***********************************************************************
!                                                                      *
! Evaluate the charges on the cavity boundary, nuclear and
! electronic.

call PCM_Driver(PCMDM,V_Tile,PCM_Charge,nTs)

! Make the slow charges (also called orientational charges or
! frozen charges). This is always done regardless if they ever
! will be used.  The charges can be used in non-equilibrium
! calculations.

if ((EpsInf > Zero) .and. (.not. NonEq)) then
  Fact = (Eps-EpsInf)/(Eps-One)
  Q_Slow(:) = Fact*(PCM_Charge(1,:)+PCM_Charge(2,:))

  ! Compute the electrostatic potential due to slow charges

  V_Slow(:) = Zero
  do iTile=1,nTs
    XI = PCMTess(1,iTile)
    YI = PCMTess(2,iTile)
    ZI = PCMTess(3,iTile)
    do jTile=1,nTs
      if (jTile == iTile) then
        Dij = DiagScale*Two*sqrt(Pi/PCMTess(4,iTile))
      else
        XJ = PCMTess(1,jTile)
        YJ = PCMTess(2,jTile)
        ZJ = PCMTess(3,jTile)
        RIJ = sqrt((XI-XJ)**2+(YI-YJ)**2+(ZI-ZJ)**2)
        Dij = One/RIJ
      end if
      V_Slow(iTile) = V_Slow(iTile)+Dij*Q_Slow(jTile)
    end do
  end do

end if

! Recover the nuclear potential (discarding the possible variations
! due to slow charges)

V_Tile(1,:) = V_Save(1,:)

W_or_el = Zero
W_or_nuc = Zero
W_or_Inf = Zero
W_or_InfNuc = zero
do iTile=1,nTs
  W_or_el = W_or_el+Q_Slow(iTile)*V_Tile(2,iTile)
  W_or_nuc = W_or_nuc+Q_Slow(iTile)*V_Tile(1,iTile)
  if (NonEq) then
    QInf = PCM_Charge(1,iTile)+PCM_Charge(2,iTile)
  else
    Fact = (Eps-Epsinf)/(Eps-One)
    QInf = (PCM_Charge(1,iTile)+PCM_Charge(2,iTile))*(One-Fact)
  end if
  W_or_Inf = W_or_Inf+QInf*V_Slow(iTile)
  W_or_InfNuc = W_or_InfNuc+PCM_Charge(1,iTile)*V_Slow(iTile)
end do

! Write out the slow charges and constants if this is an
! equilibrium calculations.

if ((EpsInf > Zero) .and. (.not. NonEq)) then
  !write(u6,*) 'Wr:',Q_Slow(1)
  call Put_dArray('RCTFLD',Q_Slow,nTs)
  call Put_dScalar('W_or_el',W_or_el)
  call Put_dScalar('W_or_Inf',W_or_Inf)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Now add terms to RepNuc

! Interaction terms:
! nuclei-nuclear solvation charge       (ENN)
! nuclei-electronic solvation charge    (ENE)
! electrons-nuclear solvation charge    (EEN)
! electrons-electronic solvation charge (EEE)

ENN = sum(PCM_Charge(1,:)*V_Tile(1,:))
!ENE = sum(PCM_Charge(1,:)*V_Tile(2,:))
!EEN = sum(PCM_Charge(2,:)*V_Tile(1,:))
!EEE = sum(PCM_Charge(2,:)*V_Tile(2,:))
if (First) then
  RepNuc = RepNuc+Half*ENN
  if (NonEq) RepNuc = RepNuc+Half*W_or_nuc+Half*W_or_InfNuc-Half*W_0_or_el-Half*W_0_or_Inf
  Label = 'PotNuc00'
  call Put_Temp(Label,[RepNuc],1)
end if

!                                                                    *
!*********************************************************************
!                                                                    *
! Now add terms to h1 and TwoHam!

call mma_allocate(C_Tessera,3,nTs,Label='C_Tessera')
nTiles = nTs
C_Tessera(:,:) = PCMTess(1:3,:)
call mma_allocate(Q_Tessera,nTs,Label='Q_Tessera')
Label = '<Q|V>'

if (First) then

  ! PCM-integrals weighted by Q(1)
  ! h1 + correction

  if (NonEq) then
    Q_Tessera(:) = PCM_Charge(1,:)+Q_Slow(:)
  else
    Q_Tessera(:) = PCM_Charge(1,:)
  end if
  call OneEl_Integrals(PCMInt,NaMem,Label,ip,[lOper],nComp,Origin,nOrdOp,rHrmt,[kOper],Integrals)
  n_Int = n2Tri(lOper)
  call CmpInt(Integrals(ip(1)),n_Int,nBas,nIrrep,lOper)
  h1(1:n_Int) = h1(1:n_Int)+Integrals(ip(1):ip(1)+n_Int-1)
  call mma_deallocate(Integrals)

  ! Save the modified h1 matrix

  Label = 'h1_raw  '
  call Put_Temp(Label,h1,nh1)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! PCM-integrals weighted by Q(2)
! TwoHam + correction

Q_Tessera(:) = PCM_Charge(2,:)
call OneEl_Integrals(PCMInt,NaMem,Label,ip,[lOper],nComp,Origin,nOrdOp,rHrmt,[kOper],Integrals)
n_Int = n2Tri(lOper)
call CmpInt(Integrals(ip(1)),n_Int,nBas,nIrrep,lOper)
TwoHam(1:n_Int) = TwoHam(1:n_Int)+Integrals(ip(1):ip(1)+n_Int-1)
call mma_deallocate(Integrals)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Q_Tessera)
call mma_deallocate(C_Tessera)
PrPrt = Save_tmp
!                                                                      *
!***********************************************************************
!                                                                      *

call mma_deallocate(V_Slow)
call mma_deallocate(Q_Slow)
call mma_deallocate(V_Save)
call mma_deallocate(V_Tile)
!                                                                      *
!***********************************************************************
!                                                                      *
! Put the current set of PCM charges on the run file.

call Put_dArray('PCM Charges',PCM_Charge,2*nTs)
call mma_deallocate(PCM_Charge)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Chrg)
call mma_deallocate(Cord)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine DrvPCM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKDAW(IDOWN,IDAW,IPRINT)
C     PURPOSE: CONSTRUCT DIRECT ARC WEIGHTS TABLE
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "gugx.fh"
#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='MKDAW   ')
C
      DIMENSION IDOWN(NVERT,0:3),IDAW(NVERT,0:4)
C
C     BEGIN TO CONSTRUCT DOWN CHAIN TABLE
C
      DO IC=0,3
       IDAW(NVERT,IC)=0
      END DO
      IDAW(NVERT,4)=1
      DO IV=NVERT-1,1,-1
        ISUM=0
        DO IC=0,3
          IDAW(IV,IC)=0
          IDWN=IDOWN(IV,IC)
          IF(IDWN.EQ.0) GOTO 20
          IDAW(IV,IC)=ISUM
          ISUM=ISUM+IDAW(IDWN,4)
  20      CONTINUE
        END DO
        IDAW(IV,4)=ISUM
      END DO
C
      IF(IPRINT.GT.5) THEN
        Write(LF,*)
        Write(LF,*)' DIRECT ARC WEIGHTS:'
        DO IV=1,NVERT
          Write(LF,'(1X,I4,5X,5(1X,I6))') IV,(IDAW(IV,IC),IC=0,4)
        END DO
        Write(LF,*)
      ENDIF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Roland Lindh                                     *
************************************************************************
      Module k2_arrays
!
!     DeDe is an array with desymmetrized 1-particle densities used
!     in the integral direct construction of the Fock matrix. In this
!     the array contain the subblocks with their associatated base
!     pointer.
!     ipDeDe: the set of densities to be used sorted according to the
!      integral shell pairs they contribute. Pointers to the individual
!      matrices are stored in ipOffD.
!     ipD00: some of the pointers in ipOffD point to an "empty" slot
!      and this pointer is to this part of DeDe.
!     ipDijS: points to an auxiliary pice of memory which is used in
!      case that used a subset of the elements of a matrix is used. In
!      this case picky_ will extract those elements and put them into
!      this part of DeDe on the fly.
!
      Integer, Dimension(:,:), Allocatable :: ipOffD
      Real*8, Allocatable:: FT(:), DeDe(:)
      Integer  ipDeDe, ipD00, ipDijS
      Integer  nDeDe, nDeDe_DFT, MaxDe, MxDij, MxFT, nFT
      Logical  DoGrad_, DoHess_
      Real*8, Target, Allocatable:: Fq(:), Dq(:)
      Real*8, Pointer:: pFq(:), pDq(:)
      Integer MemR, MemI, ipZeta, ipiZet
      Real*8, Allocatable:: Mem_DBLE(:)
      Integer, Allocatable:: Mem_INT(:)
      Real*8, Allocatable:: Aux(:), Sew_Scr(:)
      Integer, Allocatable:: iSOSym(:,:)

      End Module

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine optize9_cvb(fx1,nparm,ioptc,
     >  hessdx,grad,dx)
      implicit real*8 (a-h,o-z)
#include "formats_cvb.fh"
      dimension hessdx(nparm),grad(nparm),dx(nparm)
      dimension dum(1)
      save zero,tenth,half,one
      data zero/0d0/,tenth/1d-1/,half/.5d0/,one/1d0/

      call grad_cvb(grad)

      dum(1)=rand_cvb(.777d0)
      do 100 iparm=1,nparm
      dx(iparm)=rand_cvb(zero)-half
100   continue
      call nize_cvb(dx,1,dum,nparm,0,0)
      call fmove_cvb(dx,hessdx,nparm)
      call hess_cvb(hessdx)

      write(6,'(2a)')' Simple check of gradient and Hessian using ',
     >  'a random update vector :'
      e1=ddot_(nparm,dx,1,grad,1)
      e2=ddot_(nparm,dx,1,hessdx,1)
      write(6,'(a)')' '
      write(6,formChk1)' First-order change  :',e1
      write(6,formChk1)' Second-order change :',e2
      write(6,'(a)')' '

      write(6,formChk2)'Norm     ','DFX(act) ','DFX(pred)','Ratio    ',
     >  'F2(act)'
      cn=one
      do 200 it=1,10
      call fxdx_cvb(fx,.false.,dx)
      write(6,formChk3)cn,fx-fx1,cn*e1+cn*cn*half*e2,
     >  (fx-fx1)/(cn*e1+cn*cn*half*e2),(fx-fx1-cn*e1)/(cn*cn*half)
      call dscal_(nparm,tenth,dx,1)
      cn=tenth*cn
200   continue

      ioptc=0
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine NewCar_Kriging(kIter,SaveBMx,Error)

use Slapaf_Info, only: BMx, BMx_kriging, Cx, Force_dB, mTtAtm, Numerical, PrQ
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: kIter
logical(kind=iwp), intent(in) :: SaveBMx
logical(kind=iwp), intent(inout) :: Error
logical(kind=iwp) :: Numerical_Save, PrQ_Save
real(kind=wp), allocatable :: BMx_Tmp(:,:), Coor(:,:)

call mma_allocate(Coor,3,size(Cx,2),Label='Coor')
Coor(:,:) = Cx(:,:,kIter)

call mma_allocate(BMx_tmp,size(BMx,1),size(BMx,2),Label='BMx_tmp')
BMx_tmp(:,:) = BMx(:,:)

Numerical_Save = Numerical
PrQ_Save = PrQ
Numerical = .false.
PrQ_Save = PrQ
PrQ = .false.

Force_dB = SaveBMx

call NewCar(kIter,size(Coor,2),Coor,mTtAtm,Error)

Numerical = Numerical_Save
PrQ = PrQ_Save
Force_dB = .false.
call mma_deallocate(Coor)

! Stash away this B-matrix for later us with EDiff constraints

call mma_deallocate(BMx_kriging,safe='*')
call mma_allocate(BMx_kriging,size(BMx,1),size(BMx,2),Label='BMx_kriging')
BMx_kriging(:,:) = BMx(:,:)

if (.not. SaveBMx) BMx(:,:) = BMx_tmp(:,:)

call mma_deallocate(BMx_tmp)

end subroutine NewCar_Kriging

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKBF(DREF,NDREF,PREF,NPREF,FP)

use Index_Functions, only: iTri, nTri_Elem
use SUPERINDEX, only: KTGTU, KTU, MTGEU, MTU
use EQSOLV, only: IDBMAT, IDSMAT
use caspt2_global, only: ipea_shift, LUSBT
use caspt2_module, only: EASUM, NASHT, NINDEP, NSYM, NTGEU, NTGEUES, NTGTU, NTGTUES, NTU, NTUES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Four, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF
real(kind=wp), intent(in) :: DREF(NDREF), PREF(NPREF), FP(NPREF)
integer(kind=iwp) :: I, IBADR, IBMADR, IBPADR, IDIAG, IDISK, IDSM, IDSP, IDT, IDU, INSM, IP, ISYM, ITABS, ITGEU, ITGEUABS, ITGTU, &
                     ITU, ITUABS, ITX, IUABS, IUY, IXABS, IXGEY, IXGEYABS, IXGTY, IXY, IXYABS, IYABS, IYX, NAS, NASM, NASP, NBF, &
                     NBFM, NBFP, NINP
real(kind=wp) :: BTUXY, BTUYX
real(kind=wp), allocatable :: BF(:), BFM(:), BFP(:), SDM(:), SDP(:), SM(:), SP(:)

! Set up the matrices BFP(tu,xy) and BFM(tu,xy)
! Formulae used:
!    BF(tu,xy)= 2*(Ftxuy - EASUM*Gtxuy)
!    BFP(tu,xy)=BF(tu,xy)+BF(tu,yx)
!    BFM(tu,xy)=BF(tu,xy)-BF(tu,yx)

! Loop over superindex symmetry.
do ISYM=1,NSYM
  NINP = NINDEP(ISYM,8)
  if (NINP == 0) cycle
  NAS = NTU(ISYM)
  NBF = nTri_Elem(NAS)
  if (NBF > 0) call mma_allocate(BF,NBF,LABEL='BF')
  do ITU=1,NAS
    ITUABS = ITU+NTUES(ISYM)
    ITABS = MTU(1,ITUABS)
    IUABS = MTU(2,ITUABS)
    do IXY=1,ITU
      IXYABS = IXY+NTUES(ISYM)
      IXABS = MTU(1,IXYABS)
      IYABS = MTU(2,IXYABS)
      IBADR = iTri(ITU,IXY)
      ITX = ITABS+NASHT*(IXABS-1)
      IUY = IUABS+NASHT*(IYABS-1)
      IP = iTri(ITX,IUY)
      BF(IBADR) = Four*(FP(IP)-EASUM*PREF(IP))
    end do
  end do
  NASP = NTGEU(ISYM)
  NBFP = nTri_Elem(NASP)
  if (NBFP > 0) then
    call mma_allocate(BFP,NBFP,Label='BFP')
    !GG.Nov03  Load in SDP the diagonal elements of SFP matrix:
    call mma_allocate(SP,NBFP,Label='SP')
    call mma_allocate(SDP,NASP,Label='SDP')
    IDSP = IDSMAT(ISYM,8)
    call DDAFILE(LUSBT,2,SP,NBFP,IDSP)
    IDIAG = 0
    do I=1,NASP
      IDIAG = IDIAG+I
      SDP(I) = SP(IDIAG)
    end do
    call mma_deallocate(SP)
    !GG End
  end if
  NASM = NTGTU(ISYM)
  NBFM = nTri_Elem(NASM)
  if (NBFM > 0) then
    call mma_allocate(BFM,NBFM,Label='BFM')
    !GG.Nov03  Load in SDM the diagonal elements of SFM matrix:
    call mma_allocate(SM,NBFM,Label='SM')
    call mma_allocate(SDM,NASM,Label='SDM')
    IDSM = IDSMAT(ISYM,9)
    call DDAFILE(LUSBT,2,SM,NBFM,IDSM)
    IDIAG = 0
    do I=1,NASM
      IDIAG = IDIAG+I
      SDM(I) = SM(IDIAG)
    end do
    call mma_deallocate(SM)
    !GG End
  end if
  INSM = 1
  do ITGEU=1,NASP
    ITGEUABS = ITGEU+NTGEUES(ISYM)
    ITABS = MTGEU(1,ITGEUABS)
    IUABS = MTGEU(2,ITGEUABS)
    ITU = KTU(ITABS,IUABS)-NTUES(ISYM)
    do IXGEY=1,ITGEU
      IXGEYABS = IXGEY+NTGEUES(ISYM)
      IXABS = MTGEU(1,IXGEYABS)
      IYABS = MTGEU(2,IXGEYABS)
      IXY = KTU(IXABS,IYABS)-NTUES(ISYM)
      IYX = KTU(IYABS,IXABS)-NTUES(ISYM)
      IBADR = iTri(ITU,IXY)
      BTUXY = BF(IBADR)
      IBADR = iTri(ITU,IYX)
      BTUYX = BF(IBADR)
      IBPADR = iTri(ITGEU,IXGEY)
      BFP(IBPADR) = BTUXY+BTUYX
      !GG.Nov03
      if (ITGEU == IXGEY) then
        IDT = nTri_Elem(ITABS)
        IDU = nTri_Elem(IUABS)
        BFP(IBPADR) = BFP(IBPADR)+ipea_shift*Half*(Four-DREF(IDT)-DREF(IDU))*SDP(ITGEU)
      end if
      !GG End
      if (ITABS == IUABS) cycle
      if (IXABS == IYABS) cycle
      ITGTU = KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
      IXGTY = KTGTU(IXABS,IYABS)-NTGTUES(ISYM)
      IBMADR = iTri(ITGTU,IXGTY)
      BFM(IBMADR) = BTUXY-BTUYX
      !GG.Nov03
      if (ITGEU == IXGEY) then
        IDT = nTri_Elem(ITABS)
        IDU = nTri_Elem(IUABS)
        BFM(IBMADR) = BFM(IBMADR)+ipea_shift*Half*(Four-DREF(IDT)-DREF(IDU))*SDM(INSM)
        INSM = INSM+1
      end if

    end do
  end do
  if (NBF > 0) call mma_deallocate(BF)

  ! Write to disk
  if ((NBFP > 0) .and. (NINDEP(ISYM,8) > 0)) then
    IDISK = IDBMAT(ISYM,8)
    call DDAFILE(LUSBT,1,BFP,NBFP,IDISK)
    call mma_deallocate(BFP)
    !GG.Nov03 DisAlloc SDP
    call mma_deallocate(SDP)
    !GG End
  end if
  if (NBFM > 0) then
    if (NINDEP(ISYM,9) > 0) then
      IDISK = IDBMAT(ISYM,9)
      call DDAFILE(LUSBT,1,BFM,NBFM,IDISK)
    end if
    call mma_deallocate(BFM)
    !GG.Nov03 DisAlloc SDM
    call mma_deallocate(SDM)
    !GG End
  end if
end do

end subroutine MKBF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      Subroutine Mult_3C_Qv_s(A_3C,nA_3C,Qv,nQv,Rv,n_Rv,nVec,iOff_3C,
     &                        nIrrep,Out_of_Core,Lu_Q,QMode)
************************************************************************
*     Author:   F. Aquilante                                           *
*                                                                      *
*     Qv: is a symmetry blocked square matrix                          *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
      Real*8 A_3C(nA_3C), Qv(nQv), Rv(n_Rv)
      Integer iOff_3C(3,0:nIrrep-1), nVec(0:7), Lu_Q(0:nIrrep-1)
      Logical Out_of_Core
      Character*1 QMode
*                                                                      *
************************************************************************
*                                                                      *
      lstepA=0
      lstepR=1
      If (Qmode.eq.'T') Then
         Call FZero(Rv,n_Rv)
         lstepA=1
         lstepR=0
      End If
*
      iOffA=1
      iOffR=1

      If (Out_of_Core) Then
*                                                                      *
************************************************************************
*                                                                      *
         Do iIrrep = 0, nIrrep-1
            nI     = iOff_3C(2,iIrrep)
            nMuNu  = iOff_3C(1,iIrrep)
            If (nMuNu.le.0 .or. nI.le.0) Go To 999
*
            iOffR2=iOffR
            iOffA2=iOffA
            mQv = nI*nVec(iIrrep)
            iAddr=0
            Do While (mQv.ge.nI)
*
               nK=Min(mQv,nQv)/nI
               lQv=nI*nK
               Call dDaFile(Lu_Q(iIrrep),2,Qv,lQv,iAddr)
*
               Call A_3C_Qv_s(A_3C(iOffA2),
     &                        Qv,
     &                        Rv(iOffR2),nMuNu,nI,nK,QMode)
               mQv = mQv - lQv
               iOffR2 = iOffR2 + lstepR*nMuNu*nK
               iOffA2 = iOffA2 + lstepA*nMuNu*nK
            End Do
*
            iOffA = iOffA + nMuNu*nI
            iOffR = iOffR + nMuNu*nVec(iIrrep)
 999        Continue
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      Else  ! In-Core
*                                                                      *
************************************************************************
*                                                                      *
         iOffQ=1
         Do iIrrep = 0, nIrrep-1
            nI     = iOff_3C(2,iIrrep)
            nMuNu  = iOff_3C(1,iIrrep)
            If (nMuNu.le.0 .or. nI.le.0) Go To 998
*
            Call A_3C_Qv_s(A_3C(iOffA),
     &                     Qv(iOffQ),
     &                     Rv(iOffR),nMuNu,nI,nVec(iIrrep),QMode)
 998        Continue
            iOffA = iOffA + nMuNu*nI
            iOffR = iOffR + nMuNu*nVec(iIrrep)
            iOffQ = iOffQ + nI*nVec(iIrrep)
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Per-Olof Widmark                                 *
!               2010, John Burkardt                                    *
!               2017, Morgane Vacher                                   *
!***********************************************************************

function Random_Molcas(iSeed)
!***********************************************************************
!                                                                      *
!     Generate a random number z, where 0<z<0.5**31                    *
!                                                                      *
!     calling arguments:                                               *
!     iSeed  : Type integer, input/output                              *
!              initial value of new chain                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark                                                     *
!     University of Lund, Sweden, 1993                                 *
!     M. Vacher, Uppsala 2017                                          *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Definitions, only: wp, iwp
use, intrinsic :: iso_fortran_env, only: real64

implicit none
real(kind=wp) :: Random_Molcas
integer(kind=iwp), intent(inout) :: iSeed
integer(kind=iwp) :: i, IX0, IX1, IX2, IX3
real(kind=real64) :: a1 = 0.0_real64, a2 = 0.0_real64, r23 = 1.0_real64, r46 = 1.0_real64, t1, t2, t23 = 1.0_real64, t3, t4, &
                     t46 = 1.0_real64, x, x1, x2, z
logical(kind=iwp) :: ks = .true.
character(len=8) :: rand_info
integer(kind=iwp), parameter :: IA1 = 8121, IA2 = 4561, IA3 = 7141, IC1 = 28411, IC2 = 51349, IC3 = 54773, IM1 = 134456, &
                                IM2 = 243000, IM3 = 259200
real(kind=real64), parameter :: a = 1220703125.0_real64, x0 = 314159265.0_real64

call GetEnvf('MOLCAS_RANDOM',rand_info)
call UpCase(rand_info)
if (rand_info(1:3) == 'OLD') then
  IX0 = iSeed
  IX1 = mod(IA1*IX0+IC1,IM1)
  IX2 = mod(IA2*IX1+IC2,IM2)
  IX3 = mod(IA3*IX2+IC3,IM3)
  Random_Molcas = (real(IX1,kind=wp)+real(IX2,kind=wp)/real(IM2,kind=wp))/real(IM1,kind=wp)
  iSeed = IX3
else
  !*********************************************************************
  ! RANDLC                                                             *
  ! The number returned is a uniform pseudorandom value in the range   *
  ! (0,1). The algorithm uses the linear congruential generator:       *
  !   X(K+1) = A * X(K)  mod 2^46                                      *
  ! This scheme generates 2^44 numbers before repeating.               *
  !--------------------------------------------------------------------*
  ! Author: John Burkardt                                              *
  ! Modified: 08 March 2010                                            *
  !--------------------------------------------------------------------*
  ! References:                                                        *
  ! * David Bailey, Eric Barszcz, John Barton, D Browning, Robert      *
  ! Carter, Leonardo Dagum, Rod Fatoohi, Samuel Fineberg, Paul         *
  ! Frederickson, Thomas Lasinski, Robert Schreiber, Horst Simon, V    *
  ! Venkatakrishnan, Sisira Weeratunga, The NAS Parallel Benchmarks,   *
  ! RNR Technical Report RNR-94-007, March 1994.                       *
  ! * Donald Knuth, The Art of Computer Programming, Volume 2,         *
  ! Seminumerical Algorithms, Third Edition, Addison Wesley, 1997,     *
  ! ISBN: 0201896842, LC: QA76.6.K64.                                  *
  !--------------------------------------------------------------------*
  ! Parameters:                                                        *
  ! Input/output, real(kind=real64) X, the seed.  X should be an odd   *
  ! integer such that 1 <= X <= 2^46.                                  *
  ! Output, real(kind=wp), the next pseudorandom value.                *
  !*********************************************************************
  ! Should we ensure X is odd?
  x = real(iseed,kind=real64)
  ! If this is the first call, compute
  !   R23 = 2 ^ -23,
  !   R46 = 2 ^ -46,
  !   T23 = 2 ^ 23,
  !   T46 = 2 ^ 46.
  ! These are computed in loops, rather than by merely using the power operator,
  ! in order to insure that the results are exact on all systems.
  if (ks) then
    do i=1,46
      r46 = 0.5_real64*r46
      t46 = 2.0_real64*t46
      if (i == 23) then
        r23 = r46
        t23 = t46
      end if
    end do
    ! Break A into two parts such that A = 2^23 * A1 + A2.
    t1 = r23*a
    a1 = real(int(t1),kind=real64)
    a2 = a-t23*a1
    ks = .false.
  end if
  ! Deal with a 0 input value of X.
  if (x == 0.0_real64) x = x0
  ! Deal somewhat arbitrarily with negative input X.
  if (x < 0.0_real64) x = -x
  ! Break X into two parts X1 and X2 such that:
  !   X = 2^23 * X1 + X2,
  ! then compute
  !   Z = A1 * X2 + A2 * X1  (mod 2^23)
  !   X = 2^23 * Z + A2 * X2  (mod 2^46).
  t1 = r23*x
  x1 = real(int(t1),kind=real64)
  x2 = x-t23*x1
  t1 = a1*x2+a2*x1
  t2 = real(int(r23*t1),kind=real64)
  z = t1-t23*t2
  t3 = t23*z+a2*x2
  t4 = real(int(r46*t3),kind=real64)
  x = t3-t46*t4
  Random_Molcas = real(r46*x,kind=wp)
  ! Should we ensure iseed is odd?
  iseed = int(x,kind=iwp)
end if

!----------------------------------------------------------------------*
! exit                                                                 *
!----------------------------------------------------------------------*
return

end function Random_Molcas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Chk_Unitary(irc,U,n,Thr)
C
C     Thomas Bondo Pedersen, November 2005.
C
C     Purpose: check that U is unitary.
C
      Implicit None
      Integer irc, n
      Real*8  U(n,n), Thr
#include "WrkSpc.fh"

      Integer n2, ipUTU, lUTU, i, ip0
      Real*8  RMS, x2

      real*8 ddot_
      external ddot_

      If (n .lt. 1) Then
         irc = 0
         Return
      End If

      n2 = n**2
      lUTU = n2
      Call GetMem('UTU','Allo','Real',ipUTU,lUTU)

      Call dCopy_(n2,[0.0d0],0,Work(ipUTU),1)
      ip0 = ipUTU - 1
      Do i = 1,n
         Work(ip0+n*(i-1)+i) = 1.0d0
      End Do
      Call DGEMM_('T','N',n,n,n,-1.0d0,U,n,U,n,1.0d0,Work(ipUTU),n)

      x2 = dble(n2)
      RMS = sqrt(dDot_(n2,Work(ipUTU),1,Work(ipUTU),1)/x2)
      If (RMS .gt. Thr) Then
         irc = 1
      Else
         irc = 0
      End If

      Call GetMem('UTU','Free','Real',ipUTU,lUTU)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine DoZ   (Alpha,nAlpha,Beta,nBeta,A,B,P,Zeta,ZInv,
     &                  rKappa,IndZt,IncZet,SkipZt,Data,IndZ,
     &                  iphX,iphY,iphZ)
************************************************************************
*                                                                      *
* Object : to compute zeta, P and kappa.                               *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*             May '90 (modified for integral cutoff)                   *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden. Modified to pick up precomputed entities*
*             rather than to compute them. July '91.                   *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "ndarray.fh"
#include "real.fh"
#include "print.fh"
      Real*8 Alpha(nAlpha), Beta(nBeta), Zeta(nAlpha*nBeta),
     &       A(3),          B(3),        P(nAlpha*nBeta,3),
     &       Data(nAlpha*nBeta*(nDarray-1)), rKappa(nAlpha*nBeta),
     &       ZInv(nAlpha*nBeta)
      Integer IndZt(nAlpha*nBeta), IndZ(nAlpha*nBeta)
      Logical SkipZt
*
      iRout = 68
      iPrint = nPrint(iRout)
*
*     Transfer precomputer data
*
      nZeta=nAlpha*nBeta
      mZeta = IndZ(nAlpha*nBeta)
      SkipZt = mZeta.eq.0
      Call ICopy(mZeta,IndZ,1,IndZt,1)
      IndZt(nAlpha*nBeta)=mZeta
      call dcopy_(mZeta,Data(ip_Z    (1,nZeta)),1,Zeta,1)
      call dcopy_(mZeta,Data(ip_Kappa(1,nZeta)),1,rKappa,1)
      call dcopy_(mZeta,Data(ip_Pcoor(1,nZeta)),1,P(1,1),1)
      iOff=1+nZeta
      call dcopy_(mZeta,Data(ip_Pcoor(iOff,nZeta)),1,P(1,2),1)
      iOff=1+2*nZeta
      call dcopy_(mZeta,Data(ip_Pcoor(iOff,nZeta)),1,P(1,3),1)
      call dcopy_(mZeta,Data(ip_ZInv(1,nZeta)),1,ZInv,1)
*     Fix the phase due to operations on the whole charge density.
      If (iphY.ne.1) Call DScal_(mZeta,One*DBLE(iphY),P(1,2),1)
      If (iphX.ne.1) Call DScal_(mZeta,One*DBLE(iphX),P(1,1),1)
      If (iphZ.ne.1) Call DScal_(mZeta,One*DBLE(iphZ),P(1,3),1)
*
      If (iPrint.ge.99) Then
         Write (6,*) ' In DoZ'
         Call RecPrt(' Zeta',' ',Zeta,mZeta,1)
         Call RecPrt(' ZInv',' ',ZInv,mZeta,1)
         Call RecPrt(' Kappa',' ',rKappa,mZeta,1)
         Call RecPrt(' Px',' ',P(1,1),mZeta,1)
         Call RecPrt(' Py',' ',P(1,2),mZeta,1)
         Call RecPrt(' Pz',' ',P(1,3),mZeta,1)
         Write (6,*) ' phase factors=',iphX, iphY, iphZ
         Write (6,*) ' IndZt=',IndZt
         Call RecPrt(' Data',' ',Data,nAlpha*nBeta,nDArray)
         Write (6,*) ' Exit DoZ'
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_real_array(A)
         Call Unused_real_array(B)
         Call Unused_integer(IncZet)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine PickPoints(nPick,ipPick,ipDPick,nEPP,ipEPCo,Coo
     &                     ,dLimmo,BS)
      Implicit real*8(a-h,o-z)

#include "WrkSpc.fh"

      Dimension Coo(3),dLimmo(2)

      nPick=0
      Do iP=1,nEPP
        xtwo=(Work(ipEPCo+(iP-1)*3+0)-Coo(1))**2
        ytwo=(Work(ipEPCo+(iP-1)*3+1)-Coo(2))**2
        ztwo=(Work(ipEPCo+(iP-1)*3+2)-Coo(3))**2
        Distad=sqrt(xtwo+ytwo+ztwo)
        If(Distad.lt.dLimmo(2)*BS.and.Distad.gt.dLimmo(1)*BS) then
          iWork(ipPick+nPick)=iP
          Work(ipDPick+nPick)=Distad
          nPick=nPick+1
        Endif
      Enddo

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*----------------------------------------------------------------------*
* This subroutine reads from the formatted file DIFFPR coming from     *
* generated by MpProp the Slater Exponents, Factors and Nuclear Charges*
*----------------------------------------------------------------------*
      Subroutine Get_Slater(SlExpQ,LMltSlQ,outxyz,nAt)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "files_qmstat.fh"
#include "warnings.fh"

      Dimension CoordTest(3),SlFactQ(6)
      Dimension SlExpQ(MxMltp+1,MxQCen),outxyz(MxQCen,3)
      Character*13 TheLine
      Logical Exist,lCheck


*Open the file
      Lu=40
      Lu=IsFreeUnit(40)
      Call Opnfl('DIFFPR',Lu,Exist)
      If(.not.Exist) then
        Write(6,*)
        Write(6,*)' Can not locate output file DiffPr. '
        Call Quit(_RC_IO_ERROR_READ_)
      Endif
      Rewind(Lu)

*-- Read Number of centers and angular momentums.
*
      Read(Lu,101)nSlCentQ
      Read(Lu,101)LMltSlQ

* A first test
        nTestjhr=nAt*(nAt+1)/2
        If(nSlCentQ.ne.nTestjhr) then
        Write(6,*)'ERROR! Number of centers in DiffPr file',nSlCentQ
     &  ,' is different from number of centers obtained from RUNFILE'
     &  ,nTestjhr,' Check your files.'
        Call Quit(_RC_GENERAL_ERROR_)
        Endif

*-- Read Exponentials for the Centers
      Do iC=1,nSlCentQ
        lCheck=.false.
        Read(Lu,103)(CoordTest(k),k=1,3)
        ind=0
        Do jhr=1,nSlCentQ
          If(abs(CoordTest(1)-outxyz(jhr,1)).lt.1.0d-4) then
            If(abs(CoordTest(2)-outxyz(jhr,2)).lt.1.0d-4) then
              If(abs(CoordTest(3)-outxyz(jhr,3)).lt.1.0d-4) then
                lCheck=.true.
                ind=jhr
              Endif
            Endif
          Endif
        Enddo
        If(.not.lCheck) then
          write(6,*)'ERROR. Something is very wrong, coordinates'
     &//' of DiffPr and MpProp files do not match.'
     &//' DiffPr center',iC
        Endif
        Do l=0,LMltSlQ
          nS=l*(l+1)*(l+2)/6
          nT=(l+1)*(l+2)*(l+3)/6
          Read(Lu,104)SlExpQ(l+1,ind)
          Read(Lu,105)(SlFactQ(kk),kk=nS+1,nT)
*         Read(Lu,105)(SlFactQ(kk,ind),kk=nS+1,nT)
        End do
*Jose. No read nuclear charge
*       Read(Lu,104)PointP(ind)
        Read(Lu,'(A)') TheLine
      End do

      Close(Lu)

101   Format(I5)
103   Format(3(F20.14))
104   Format(F20.14)
105   Format(3(F20.14))

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine DSQ2(C,S,MUL,INDX,JSY,NDIAG,INUM,IRC3,LSYM,NVIRT,SQ2)

use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: C(*), S(*)
integer(kind=iwp), intent(in) :: MUL(8,8), INDX(*), JSY(*), NDIAG(*), INUM, IRC3, LSYM, NVIRT
real(kind=wp), intent(in) :: SQ2
integer(kind=iwp) :: I, II1, MA, NA, NS1, NS1L
integer(kind=iwp), external :: JSUNP

do I=1,INUM
  II1 = IRC3+I
  NS1 = JSUNP(JSY,II1)
  NS1L = MUL(NS1,LSYM)
  if (NS1L /= 1) cycle
  NA = INDX(II1)
  do MA=1,NVIRT
    C(NA+NDIAG(MA)) = C(NA+NDIAG(MA))/SQ2
    S(NA+NDIAG(MA)) = SQ2*S(NA+NDIAG(MA))
  end do
end do

return

end subroutine DSQ2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CIDens(response,iLS,iRS,iL,iR,rP,rD)

use Index_Functions, only: iTri, nTri_Elem
use ipPage, only: ipin, ipin1, ipnout, opout, W
use MCLR_Data, only: n1Dens, n2Dens, nConf1, nNA, NOCSF, XISPSM
use CandS, only: ICSM, ISSM
use input_mclr, only: nCSF, TimeDep
use dmrginfo, only: DoDMRG, LRRAS2, RGRAS2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
logical(kind=iwp), intent(in) :: Response
integer(kind=iwp), intent(in) :: iLS, iRS, iL, iR
real(kind=wp), intent(_OUT_) :: rP(*), rD(*)
integer(kind=iwp) :: IA, ij1, ij2, JA, KA, kl1, kl2, LA, nConfL, nConfR, nDim
real(kind=wp), allocatable :: CIL(:), CIR(:), De(:), Pe(:)

! LS = CI
!
! Ok, we once more want to hide Jeppe's routines from
! the eyes of the world, so everyone believes that I have done
! all the work.
! If we have spin dependent Hamiltonian we will work with
! SD in all parts of the program, no CSF is necessary,
! otherwise we will do the optimization in CSF's to increase
! convergence.
!
! Input:
!
! response: true if the density should be used for response calculations
! iLS: CI Coeff for left state
! iRS: CI Coeff for right state
! iL : Symmetry of left state
! iR : Symmetry of right state
!
!           +       +
! iS=1 E  =a  a  + a  a
!       pq  ap aq   Bp Bq
!
!            +       +
! iS=-1 T  =a  a  - a a
!        pq  ap aq   Bp Bq
!
! Output:
!
!  rP : Two Electron Density
!  rD : One Electron Density

if (nconf1 == 0) return

if (doDMRG) then  !yma
  call dmrg_dim_change_mclr(LRras2,ndim,0)
  call dmrg_dim_change_mclr(LRras2,nna,0)
  n1Dens = ndim**2
  n2Dens = nTri_Elem(n1Dens)
end if

call mma_allocate(De,n1Dens,Label='De')
call mma_allocate(Pe,n2Dens,Label='Pe')
De(:) = Zero
Pe(:) = Zero

if (nocsf == 0) then
  nConfL = max(ncsf(il),nint(xispsm(il,1)))
  nConfR = max(ncsf(iR),nint(xispsm(iR,1)))
  call mma_allocate(CIL,nConfL,Label='CIL')
  call ipin1(iLS,nconfL)
  call CSF2SD(W(iLS)%A,CIL,iL)
  call opout(iLs)
  call mma_allocate(CIR,nConfR,Label='CIR')
  call ipin1(iRS,nconfR)
  call CSF2SD(W(iRS)%A,CIR,iR)
  call opout(irs)
  call ipnout(-1)
  icsm = iR
  issm = iL
  call Densi2_mclr(2,De,Pe,CIL,CIR,0,0,0,n1Dens,n2Dens)

  if (.not. timedep) then
    if (response) then
      do iA=1,nnA
        do jA=1,nnA
          do kA=1,nnA
            do la=1,nnA
              ij1 = nnA*(iA-1)+ja
              ij2 = nna*(ja-1)+ia
              kl1 = nnA*(ka-1)+la
              kl2 = nna*(la-1)+ka
              rp(iTri(ij1,kl1)) = Pe(iTri(ij1,kl1))+Pe(iTri(ij2,kl2))
            end do
          end do
        end do
      end do
      do iA=1,nnA
        do jA=1,nnA
          ij1 = nnA*(iA-1)+ja
          ij2 = nna*(ja-1)+ia
          rD(ij1) = De(ij1)+De(ij2)
        end do
      end do

    else
      rp(1:n2Dens) = Pe(:)
      rD(1:n1Dens) = De(:)
    end if
  else
    rp(1:n2Dens) = Pe(:)
    rD(1:n1Dens) = De(:)
    iCSM = iL
    iSSM = iR
    call Densi2_mclr(2,De,Pe,CIR,CIL,0,0,0,n1Dens,n2Dens)
    rp(1:n2Dens) = rp(1:n2Dens)-Pe(:)
    rD(1:n1Dens) = rD(1:n1Dens)-De(:)
  end if
  call mma_deallocate(CIL)
  call mma_deallocate(CIR)
else
  issm = iL
  icsm = iR
  call ipin(iLS)
  call ipin(iRS)
  call Densi2_mclr(2,De,Pe,W(iLS)%A,W(iRS)%A,0,0,0,n1Dens,n2Dens)
  if (.not. timedep) then
    if (response) then
      do iA=1,nnA
        do jA=1,nnA
          do kA=1,nnA
            do la=1,nnA
              ij1 = nnA*(iA-1)+ja
              ij2 = nna*(ja-1)+ia
              kl1 = nnA*(ka-1)+la
              kl2 = nna*(la-1)+ka
              rp(iTri(ij1,kl1)) = Pe(iTri(ij1,kl1))+Pe(iTri(ij2,kl2))
            end do
          end do
        end do
      end do
      do iA=1,nnA
        do jA=1,nnA
          ij1 = nnA*(iA-1)+ja
          ij2 = nna*(ja-1)+ia
          rD(ij1) = De(ij1)+De(ij2)
        end do
      end do
    else
      rp(1:n2Dens) = Pe(:)
      rD(1:n1Dens) = De(:)
    end if
  else
    rp(1:n2Dens) = Pe(:)
    rD(1:n1Dens) = De(:)
    iCSM = iL
    iSSM = iR
    call ipin(iRS)
    call ipin(iLS)
    call Densi2_mclr(2,De,Pe,W(iRS)%A,W(iLS)%A,0,0,0,n1Dens,n2Dens)
    rp(1:n2Dens) = rp(1:n2Dens)-Pe(:)
    rD(1:n1Dens) = rD(1:n1Dens)-De(:)
  end if
end if
call mma_deallocate(Pe)
call mma_deallocate(De)

if (doDMRG) then  ! yma
  call dmrg_dim_change_mclr(RGras2,ndim,0)
  call dmrg_dim_change_mclr(RGras2,nna,0)
  n1Dens = ndim**2
  n2Dens = nTri_Elem(n1dens)
end if

end subroutine CIDens

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c        this package contains following files
c        (mainly for parallel stuff)
c
c        set0
c        joinamplitudes
c        reajalovy
c        distnodes
c       sumabdistt
c       redef
c
c        ----------------------------------------------
c
        subroutine set0 (wrk,wrksize,
     c                   mapd,mapi)
c
c        this routine vanish given mediate
c
        implicit none
c
#include "wrk.fh"
#include "paralell.fh"
c
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c        help variables
c
       integer poss0,lenght,ii
c
c1        def poss0, legth
        poss0=mapd(1,1)
        ii=mapd(0,5)
        lenght=mapd(ii,1)+mapd(ii,2)-poss0
c
c2        set appropriate wrk = 0
        call mv0zero (lenght,lenght,wrk(poss0))
c
        return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(mapi)
        end
c
c        ----------------------------------------------
c
        subroutine joinamplitudes (wrk,wrksize)
c
c        this routine join contributions to amplitudes (Tn) from all
c        processors. Sum will be placed back to Tn on all machines
c
c        N.B. FREE ZONE in purpose of this routine is the space of
c       free working files V1-V4, .....
c        (free zone is not used in GA)
c        Since T2 amplitudes are no more then oovv, at most V1-V3 space
c        will be demaged. (acutally V1 and V2 only)
c
        implicit none
c
#include "wrk.fh"
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "paralell.fh"
c
c        help variables
c
        integer ii,lenght
CLD        integer ii,lenght,rc,i
c
        if (nProcs.eq.1) return
c
c1        join t13,t14
c
c1.1    calc overall length of t13 and t14 (they must be one after the other)
        ii=mapdt14(0,5)
        lenght=mapdt14(ii,1)+mapdt14(ii,2)-posst130
c
c1.2        vanish required part in free zone
c        call mv0zero (lenght,lenght,wrk(possv10))
c
c1.3        allreduce t13 and t14 into free zone
c        call MPI_ALLREDUCE (wrk(posst130),wrk(possv10),lenght,
c    c  MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,rc)
c
c1.4        put joined t13,t14 back to t13,t14 place from free zone
c        do i=0,lenght-1
c        wrk(posst130+i)=wrk(possv10+i)
c        end do
c
c1.om   allreduge t13,t14 together
        call gadgop (wrk(posst130),lenght,'+')
c
c
c2        join t21,t22,t23
c
c2.1    calc overall length of t21-t23 (they must be one after the other)
        ii=mapdt23(0,5)
        lenght=mapdt23(ii,1)+mapdt23(ii,2)-posst210
c
c2.2        vanish required part in free zone
c        call mv0zero (lenght,lenght,wrk(possv10))
c
c2.3        allreduce t13 and t14 into free zone
c        call MPI_ALLREDUCE (wrk(posst210),wrk(possv10),lenght,
c    c  MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,rc)
c
c2.4        put joined t21-t23 back to t21-t23 place from free zone
c        do i=0,lenght-1
c        wrk(posst210+i)=wrk(possv10+i)
c        end do
c
c2.om   allreduge t21-t23 together
        call gadgop (wrk(posst210),lenght,'+')
c
        return
        end
c
c        ----------------------------------------------
c
       subroutine reajalovy (lun,lenght,vector)
c
c     this routine read blank card
c     with number lun form the given possition and update pointers
c
c     lun    - Logical unit number of file, where mediate is stored (Input)
c     lenght - # of R8 numbers to be read  (Input)
c     vector - space, where numbers are stored after reading  (Output)

c
#include "filemgr.fh"
#include "ccsd1.fh"

#include "SysDef.fh"
c
       integer lun,lenght
       real*8 vector(1:1)
c
       if (iokey.eq.1) then
c      Fortran IO
       read (lun)
c
       else
c      MOLCAS IO
       call ddafile (lun,0,vector,lenght,daddr(lun))
       end if
c
       return
       end
c
c     ----------------------------
c
        subroutine distnodes
c
c        this routine distribute nodes to different parts
c
        implicit none
#include "paralell.fh"
c
        integer i
        REAL*8 efftot
c
ctmp ta zatial takto
        if (nProcs.eq.1) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=0
        idbbaa=0
        idbbbb=0
        idaabb=0
        idabba=0
c
cIII        def node for finale
        idfin=0
c
c
        else if (nProcs.eq.2) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=1
        idbbaa=1
        idbbbb=1
        idaabb=1
        idabba=1
c
cIII        def node for finale
        idfin=1
c
c
        else if (nProcs.eq.3) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=1
        idbbaa=1
        idbbbb=2
        idaabb=2
        idabba=2
c
cIII        def node for finale
        idfin=1
c
c
        else if (nProcs.eq.4) then
c
cI        def nodes for sumoverab
        nprocab=4
        idab(1)=0
        idab(2)=1
        idab(3)=2
        idab(4)=3
        ideffab(1)=0.25
        ideffab(2)=0.25
        ideffab(3)=0.25
        ideffab(4)=0.25
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=1
        idbbaa=1
        idbbbb=2
        idaabb=2
        idabba=3
c
cIII        def node for finale
        idfin=3
c
c
        else if (nProcs.eq.5) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=1
        idbbaa=2
        idbbbb=3
        idaabb=3
        idabba=4
c
cIII        def node for finale
        idfin=2
c
c
        else if (nProcs.eq.6) then
c
cI        def nodes for sumoverab
        nprocab=6
        idab(1)=0
        idab(2)=1
        idab(3)=2
        idab(4)=3
        idab(5)=4
        idab(6)=5
        ideffab(1)=1.0
        ideffab(2)=1.0
        ideffab(3)=1.0
        ideffab(4)=1.0
        ideffab(5)=1.0
        ideffab(6)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=1
        idbbaa=2
        idbbbb=3
        idaabb=4
        idabba=5
c
cIII        def node for finale
        idfin=3
c
        else if (nProcs.eq.10) then
c
cI        def nodes for sumoverab
        nprocab=4
          idab(1)=0
          idab(2)=1
          idab(3)=2
          idab(4)=3
          ideffab(1)=1.0
          ideffab(2)=1.0
          ideffab(3)=1.0
          ideffab(4)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=4
        idbaab=5
        idbbaa=6
        idbbbb=7
        idaabb=8
        idabba=9
c
cIII        def node for finale
        idfin=5
c
        else
c
cI        def nodes for sumoverab
        nprocab=nProcs
        do i=1,nprocab
          idab(i)=i-1
          ideffab(i)=1.0
        end do
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=1
        idbbaa=2
        idbbbb=3
        idaabb=4
        idabba=5
c
cIII        def node for finale
        idfin=6

        end if
c
         return
c
ctmp         koniec tmp riesenia
c
c
c
        if (nProcs.eq.1) then
c
cI        def nodes for sumoverab
        nprocab=1
        idab(1)=0
        ideffab(1)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=0
        idbbaa=0
        idbbbb=0
        idaabb=0
        idabba=0
c
cIII        def node for finale
        idfin=0
c
c
        else if (nProcs.eq.2) then
c
cI        def nodes for sumoverab
        nprocab=2
        idab(1)=0
        idab(2)=1
        ideffab(1)=0.5
        ideffab(2)=0.5
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=0
        idbbaa=0
        idbbbb=1
        idaabb=1
        idabba=1
c
cIII        def node for finale
        idfin=0
c
c
        else if (nProcs.eq.3) then
c
cI        def nodes for sumoverab
        nprocab=3
        idab(1)=0
        idab(2)=1
        idab(3)=2
        ideffab(1)=0.333
        ideffab(2)=0.333
        ideffab(3)=0.333
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=1
        idbbaa=1
        idbbbb=2
        idaabb=2
        idabba=2
c
cIII        def node for finale
        idfin=0
c
c
        else if (nProcs.eq.4) then
c
cI        def nodes for sumoverab
        nprocab=2
        idab(1)=2
        idab(2)=3
        ideffab(1)=1.0
        ideffab(2)=1.0
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=0
        idbaab=0
        idbbaa=0
        idbbbb=1
        idaabb=1
        idabba=1
c
cIII        def node for finale
        idfin=0
c
c
        else
c
cI        def nodes for sumoverab
c
        nprocab=nProcs-2
        idab(1)=1
        idab(2)=2
        idab(3)=4
        idab(4)=5
        idab(5)=6
        idab(6)=7
        do i=1,nprocab
        ideffab(i)=1.0d0/nprocab
        end do
        ideffab(1)=ideffab(1)/2
        ideffab(2)=ideffab(2)/2
c
cII        def nodes for sumoverb and intmezzo
        idaaaa=1
        idbaab=0
        idbbaa=0
        idbbbb=2
        idaabb=3
        idabba=3
c
cIII        def node for finale
        idfin=1
c
        end if
c
c        renormalize ideffab
c
        efftot=0.0d0
        do i=1,nprocab
        efftot=efftot+ideffab(i)
        end do
c
        do i=1,nprocab
        ideffab(i)=ideffab(i)/efftot
        end do

c
        return
        end
c
c     ----------------------------
c
        subroutine redef
c
c        this routine redefine ideffab vector using infromation about
c        idle time on each nodes selected for sumoverab process
c
        implicit none
#include "paralell.fh"
c
c        help variables
c
        integer i,ii
CLD        integer i,ii,rc
        REAL*8 tmin,eff,tabtot,tdisp,tdisptot,tidletot
        REAL*8 tminab,tdole
c
c0        escape, if nprocab=1, there is nothing to redistribute
c
        if (nprocab.eq.1) return
c
c1        distribute idtmab and ididle to all nodes
c
ctmp        do i=1,nProcs
ctmp    call MPI_BCAST (idtmab(i),1,
ctmp c  MPI_DOUBLE_PRECISION,(i-1),MPI_COMM_WORLD,rc)
ctmp    call MPI_BCAST (ididle(i),1,
ctmp c  MPI_DOUBLE_PRECISION,(i-1),MPI_COMM_WORLD,rc)
ctmp    end do
c        prepis pomocou GA, bcast ekvivalent nevieme
        call gadgop (idtmab(1),nProcs,'+')
        call gadgop (ididle(1),nProcs,'+')
c
c2        def real idle time for all nodes
c
        tmin=ididle(1)
        tminab=0.0d0
c
        do i=2,nProcs
        if (tmin.gt.ididle(i)) then
          tmin=ididle(i)
        end if
        end do
c
        do i=1,nProcs
          ididle(i)=ididle(i)-tmin
          if (tminab.lt.idtmab(i)) then
            tminab=idtmab(i)
          end if
        end do
c
c3        calc total time, used in prev. iteration for sumoverab process
c       + total idle time in prev. iter. (on nodes dedicated to ab
c         process)
c
        tabtot=0.0d0
        tidletot=0.0d0
        do ii=1,nprocab
        i=idab(ii)+1
          if (ideffab(ii).gt.0.0d0) then
            tabtot=tabtot+idtmab(i)
            tidletot=tidletot+ididle(i)
            if (tminab.gt.idtmab(i)) then
              tminab=idtmab(i)
            end if
          else
            tidletot=tidletot+ididle(i)
          end if
        end do
c
        tdole=tidletot/nprocab
c?      if (tdole.gt.tminab) tdole=tminab
c
c4        calc new redistribution
c
        tdisptot=0.0d0
        do ii=1,nprocab
        i=idab(ii)+1
          tdisp=idtmab(i)+ididle(i)-tdole
          if (tdisp.lt.0.0d0) tdisp=0.0d0
          if (ideffab(ii).eq.0.0d0) then
            eff=1.0d0
          else
            eff=ideffab(ii)/(idtmab(i)/tabtot)
          end if
cStare    tdisp=tdisp*eff
          tdisptot=tdisptot+tdisp
        end do
        write (6,*) 'Tab   ',tabtot
        write (6,*) 'Tidle ',tidletot
        write (6,*) 'Tdisp ',tdisptot
        write (6,*) 'Tddole',tdole
        write (6,*) 'Tminab',tminab
c
        do ii=1,nprocab
        i=idab(ii)+1
          tdisp=idtmab(i)+ididle(i)-tdole
          if (tdisp.lt.0.0d0) tdisp=0.0d0
          if (ideffab(ii).eq.0.0d0) then
            eff=1.0d0
          else
            eff=ideffab(ii)/(idtmab(i)/tabtot)
          end if
          write (6,*) ii,idtmab(i),ideffab(ii)
          write (6,*) eff,tdisp
c
cStare    tdisp=tdisp*eff
          ideffab(ii)=tdisp/tdisptot
c
           if (ideffab(ii).le.0.02) then
            ideffab(ii)=0.0d0
           end if
c
        end do
c
c5        renormalization of ideffab
c
        tabtot=0.0d0
        do ii=1,nprocab
             tabtot=tabtot+ideffab(ii)
        end do
        do ii=1,nprocab
             ideffab(ii)=ideffab(ii)/tabtot
          write (6,*) ii,ideffab(ii)
        end do
c

        ideffab(1)=0.116904633172297
        ideffab(2)=0.129270185505803
        ideffab(3)=0.140060191767431
        ideffab(4)=0.120813846670906
        ideffab(5)=0.086763031703814
        ideffab(6)=0.173676115414579
        ideffab(7)=0.232511995765169
c
        return
        end
c
c     ----------------------------
c
        subroutine sumabdistt (n,idtot)
c
c        this routine distribute work for n records among
c        nprocab processors with the frequency, corresponding
c        to ideffab values
c
c        n - # of records to be distributed (I)
c        idtot - distribution vector (O)
c               (idtot(i) -  # of records to be realized by i-th node)
c
        implicit none
#include "paralell.fh"
c
        integer n
        integer idtot(1)
c
c        help parameters
c
        integer i,ntot,max,imax
CLD        integer i,j,ntot,max,imax
        real*8 sum
c
c
c1        distribute recordsc according to eff. coeficients
c
        sum=0.0d0
        do i=1,nprocab
        sum=sum+ideffab(i)
        end do
c
        do i=1,nprocab
        idtot(i)=int(((ideffab(i)*n)/sum)+0.5d0)
        end do
c
c2        do corrections, if roundoff errors caused some diferences
c
1        ntot=0
        do i=1,nprocab
        ntot=ntot+idtot(i)
        end do

        if (ntot.gt.n) then
c        ubrat treba (z najvacsieho dielu)
          max=idtot(1)
          imax=1
          do i=1,nprocab
          if (max.lt.idtot(i)) then
          max=idtot(i)
          imax=i
          end if
          end do
          idtot(imax)=idtot(imax)-1
          goto 1
        else if (ntot.lt.n) then
c        pridat treba (k najvacsiemu dielu)
          max=idtot(1)
          imax=1
          do i=1,nprocab
          if (max.lt.idtot(i)) then
          max=idtot(i)
          imax=i
          end if
          end do
          idtot(imax)=idtot(imax)+1
          goto 1
        end if
c
        return
        end
c
c     ----------------------------
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine power(c,n,ipower)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, ipower
real(kind=wp), intent(inout) :: c(n)
integer(kind=iwp) :: i

if (ipower == 1) then
  return
else if (ipower == 2) then
  do i=1,n
    c(i) = c(i)*c(i)
  end do
else if (ipower == -2) then
  do i=1,n
    c(i) = sign(c(i)*c(i),c(i))
  end do
end if

return

end subroutine power

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1992, Roland Lindh                                *
************************************************************************
      SubRoutine Hrr2Db_mck(Arr1,nVec,ncdMax,
     &                 Arr2,C,D,la,lb,lc,ld,IfHss,
     &                 IfGrd ,nt,nrys)
************************************************************************
*                                                                      *
* Object: to apply the transfer equation to the 2D-integrals.          *
*         The transformation is in place and the recursion             *
*         is replaced with the indentity when applicable.              *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             September '91                                            *
*             Modified to recurrence algorithm, February '92           *
*             Improved algorithm, June '92.                            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
c#include "print.fh"
#include "real.fh"
      Real*8 C(3), D(3),
     &                   Arr1(nVec,0:la+2,0:lb+2,0:ncdMax,3),
     &                   Arr2(nVec,0:la+2,0:lb+2,0:lc+2,0:ld+2,3)
      Logical IfHss(4,3,4,3),ifgrd(3,4)
*
c     iRout = 233
c     iPrint = nPrint(iRout)
*
      Do 10 iCar = 1, 3
         llc = 0
         lld = 0
         lla = 0
         llb = 0
         If(IfGrd(iCar,3)) llc = Max(llc,1)
         If(IfHss(3,iCar,3,iCar)) llc = 2
         If(IfGrd(iCar,4)) lld = Max(1,lld)
         If(IfHss(4,iCar,4,iCar)) lld = 2
         If(IfGrd(iCar,1)) lla = Max(1,lla)
         If(IfHss(1,iCar,1,iCar)) lla = 2
         If(IfGrd(iCar,2)) llb = Max(llb,1)
         If(IfHss(2,iCar,2,iCar)) llb = 2
         CD = C(iCar)-D(iCar)
         If (CD.eq.Zero) Then
            Do 100 ia = 0, la+lla
            Do 101 ib = 0, lb+llb
               If (ia+ib.gt.la+lb+Max(lla,llb)) Go To 101
*--------------Using the identity
               Do 200 ic = 0, lc+llc
                  Do 210 id = 0, ld+lld
                  icd = ic + id
                  If (icd.gt.lc+ld+Max(llc,lld)) Go To 210
                  do i=1,nVec
                  Arr2(i,ia,ib,ic,id,iCar)=Arr1(i,ia,ib,icd,iCar)
                  enddo
210               Continue
200            Continue
101         Continue
100         Continue
         Else
            If (lc.ge.ld) Then
               Do 102 ia = 0, la+lla
               Do 103 ib = 0, lb+llb
                  If (ia+ib.gt.la+lb+Max(lla,llb)) Go To 103
*-----------------Move the first row I(ic,0)
                  Do 20 ic = 0, lc+ld+Max(llc,lld)
                     jc = ic
                     jd = 0
                     If (jc.gt.lc+2) Then
                        jc = jc - (lc+3)
                        jd = 1
                     End If
                     do i=1,nVec
                     Arr2(i,ia,ib,jc,jd,iCar)=Arr1(i,ia,ib,ic,iCar)
                     enddo
 20               Continue
*-----------------Generate I(ic,id) for fixed id
                  Do 30 id = 1, ld + lld
                     Do 31 ic = lc+ld+Max(llc,lld)-id, 0, -1
                        jc = ic
                        jd = id
                        md = id-1
                        If (jc.gt.lc+2) Then
                           jc = jc - (lc+3)
                           jd = jd + 1
                           md = md + 1
                        End If
                        mc = jc
                        kc = ic+1
                        kd = id-1
                        If (kc.gt.lc+2) Then
                           kc = kc - (lc+3)
                           kd = kd + 1
                        End If
                        Call DZaXpY(nVec,CD,Arr2(1,ia,ib,mc,md,iCar),1,
     &                                      Arr2(1,ia,ib,kc,kd,iCar),1,
     &                                      Arr2(1,ia,ib,jc,jd,iCar),1)
 31                  Continue
 30               Continue
 103           Continue
 102           Continue
            Else
               CD = -CD
               Do 104 ia = 0, la+lla
               Do 105 ib = 0, lb+llb
                  If (ia+ib.gt.la+lb+Max(lla,llb)) Go To 105
*-----------------Move the first row I(0,id)
                  Do 40 id = 0, lc+ld+Max(llc,lld)
                     jd = id
                     jc = 0
                     If (jd.gt.ld+2) Then
                        jd = jd - (ld+3)
                        jc = 1
                     End If
                     do i=1,nVec
                     Arr2(i,ia,ib,jc,jd,iCar)=Arr1(i,ia,ib,id,iCar)
                     enddo
 40               Continue
*-----------------Generate I(ic,id) for fixed ic
                  Do 50 ic = 1, lc + llc
                     Do 51 id = lc+ld+Max(llc,lld)-ic, 0, -1
                        jd = id
                        jc = ic
                        mc = ic-1
                        If (jd.gt.ld+2) Then
                           jd = jd - (ld+3)
                           jc = jc + 1
                           mc = mc + 1
                        End If
                        md = jd
                        kd = id+1
                        kc = ic-1
                        If (kd.gt.ld+2) Then
                           kd = kd - (ld+3)
                           kc = kc + 1
                        End If
                        Call DZaXpY(nVec,CD,Arr2(1,ia,ib,mc,md,iCar),1,
     &                                      Arr2(1,ia,ib,kc,kd,iCar),1,
     &                                      Arr2(1,ia,ib,jc,jd,iCar),1)
 51                  Continue
 50               Continue
 105           Continue
 104           Continue
            End If
         End If
 10   Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nt)
         Call Unused_integer(nrys)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2003, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This procedure classifies the atomic orbitals of atoms into 6 classes*
! and returns the count. Which shells that are returned are specified  *
! by the the option switch opt:                                        *
!                                                                      *
!  1 DeepCore                                                          *
!  2 Core                                                              *
!  4 SoftCore                                                          *
!  8 DeepValence                                                       *
! 16 Valence                                                           *
! 32 ExtraValence                                                      *
!                                                                      *
! The numbers are added up to get more than one shell reported.        *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University                                             *
!          Sweden                                                      *
! Written: May 2003                                                    *
!                                                                      *
!***********************************************************************

subroutine OrbType(Z,List,opt)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Z, opt
integer(kind=iwp), intent(out) :: List(0:3)
integer(kind=iwp) :: DeepCore(0:3), Core(0:3), SoftCore(0:3), DeepValence(0:3), Valence(0:3), ExtraValence(0:3)
integer(kind=iwp), parameter :: s = 0, p = 1, d = 2, f = 3

!----------------------------------------------------------------------*
! Initialize                                                           *
!----------------------------------------------------------------------*
DeepCore(:) = 0
Core(:) = 0
SoftCore(:) = 0
DeepValence(:) = 0
Valence(:) = 0
ExtraValence(:) = 0
List(:) = 0

!----------------------------------------------------------------------*
! How many shells are there for this atom                              *
!----------------------------------------------------------------------*
select case (Z)
  case (0) ! Dummy
  case (1:2) ! H-He
    Valence(s) = 1
  case (3:4) ! Li-Be
    Core(s) = 1
    Valence(s) = 1
    ExtraValence(p) = 1
  case (5:10) ! B-Ne
    Core(s) = 1
    Valence(s) = 1
    Valence(p) = 1
  case (11:12) ! Na-Mg
    DeepCore(s) = 1
    SoftCore(s) = 1
    SoftCore(p) = 1
    Valence(s) = 1
    ExtraValence(p) = 1
  case (13:18) ! Al-Ar
    DeepCore(s) = 1
    Core(s) = 1
    Core(p) = 1
    Valence(s) = 1
    Valence(p) = 1
  case (19:20) ! K-Ca
    DeepCore(s) = 2
    DeepCore(p) = 1
    SoftCore(s) = 1
    SoftCore(p) = 1
    Valence(s) = 1
    ExtraValence(p) = 1
  case (21:30) ! Sc-Zn
    DeepCore(s) = 2
    DeepCore(p) = 1
    Core(s) = 1
    Core(p) = 1
    Valence(s) = 1
    Valence(d) = 1
    ExtraValence(p) = 1
  case (31:36) ! Ga-Kr
    DeepCore(s) = 2
    DeepCore(p) = 1
    Core(s) = 1
    Core(p) = 1
    Core(d) = 1
    Valence(s) = 1
    Valence(p) = 1
  case (37:38) ! Rb-Sr
    DeepCore(s) = 3
    DeepCore(p) = 2
    DeepCore(d) = 1
    SoftCore(s) = 1
    SoftCore(p) = 1
    Valence(s) = 1
    ExtraValence(p) = 1
  case (39:48) ! Y-Cd
    DeepCore(s) = 3
    DeepCore(p) = 2
    DeepCore(d) = 1
    Core(s) = 1
    Core(p) = 1
    Valence(s) = 1
    Valence(d) = 1
    ExtraValence(p) = 1
  case (49:54) ! In-Xe
    DeepCore(s) = 3
    DeepCore(p) = 2
    DeepCore(d) = 1
    Core(s) = 1
    Core(p) = 1
    Core(d) = 1
    Valence(s) = 1
    Valence(p) = 1
  case (55:56) ! Cs-Ba
    DeepCore(s) = 4
    DeepCore(p) = 3
    DeepCore(d) = 2
    SoftCore(s) = 1
    SoftCore(p) = 1
    Valence(s) = 1
    ExtraValence(p) = 1
  case (57:70) ! La-Yb
    DeepCore(s) = 4
    DeepCore(p) = 3
    DeepCore(d) = 2
    Core(s) = 1
    Core(p) = 1
    Valence(s) = 1
    Valence(f) = 1
    ExtraValence(p) = 1
  case (71:80) ! Lu-Hg
    DeepCore(s) = 4
    DeepCore(p) = 3
    DeepCore(d) = 2
    Core(s) = 1
    Core(p) = 1
    SoftCore(f) = 1
    Valence(s) = 1
    Valence(d) = 1
    ExtraValence(p) = 1
  case (81:86) ! Tl-Rn
    DeepCore(s) = 4
    DeepCore(p) = 3
    DeepCore(d) = 2
    Core(s) = 1
    Core(p) = 1
    Core(f) = 1
    SoftCore(d) = 1
    Valence(s) = 1
    Valence(p) = 1
  case (87:88) ! Fr-Ra
    DeepCore(s) = 5
    DeepCore(p) = 4
    DeepCore(d) = 3
    DeepCore(f) = 1
    SoftCore(s) = 1
    SoftCore(p) = 1
    Valence(s) = 1
    ExtraValence(p) = 1
  case (89:102) ! Ac-No
    DeepCore(s) = 5
    DeepCore(p) = 4
    DeepCore(d) = 3
    DeepCore(f) = 1
    Core(s) = 1
    Core(p) = 1
    Valence(s) = 1
    Valence(f) = 1
    ExtraValence(p) = 1
  case (103:112) ! Lr-Cn
    DeepCore(s) = 5
    DeepCore(p) = 4
    DeepCore(d) = 3
    DeepCore(f) = 1
    Core(s) = 1
    Core(p) = 1
    SoftCore(f) = 1
    Valence(s) = 1
    Valence(d) = 1
    ExtraValence(p) = 1
  case default
    write(u6,*) 'orbtype: element ',Z,' not yet implemented'
    call Abend()
end select
!----------------------------------------------------------------------*
! Fill up the list to be returned                                      *
!----------------------------------------------------------------------*
if (btest(opt,0)) List(:) = List(:)+DeepCore(:)
if (btest(opt,1)) List(:) = List(:)+Core(:)
if (btest(opt,2)) List(:) = List(:)+SoftCore(:)
if (btest(opt,3)) List(:) = List(:)+DeepValence(:)
if (btest(opt,4)) List(:) = List(:)+Valence(:)
if (btest(opt,5)) List(:) = List(:)+ExtraValence(:)
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine OrbType

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE REFORM_CONF_FOR_GAS(ICONF_GAS,ICONF,IBORB, IBEL,MXPORB,
     &                                  NEL,  IWAY)
C    &                                NORB,NEL,IWAY)
*
* Reform between local and global numbering of
* configuration for given GAS space
*
* IWAY = 1 : Global => Local
* IWAY = 2 : Local => GLobal
*
* Jeppe Olsen, November 2001
*
#include "implicit.fh"
*
      INTEGER ICONF_GAS(MXPORB)
      INTEGER ICONF(*)
*
      IF(IWAY.EQ.1) THEN
        DO IEL = 1, NEL
          ICONF_GAS(IEL) = ICONF(IBEL-1+IEL)  - IBORB + 1
        END DO
      ELSE IF (IWAY.EQ.2) THEN
        DO IEL = 1, NEL
          ICONF(IBEL-1+IEL) = ICONF_GAS(IEL) + IBORB - 1
        END DO
      ELSE
        WRITE(6,*) ' Problem in REFORM_CONF ... , IWAY = ', IWAY
*        STOP       ' Problem in REFORM_CONF ... , IWAY = '
         CALL SYSABENDMSG('lucia_util/reform_conv',
     &                    'Internal error',' ')
      END IF
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        IF(IWAY.EQ.1) THEN
          WRITE(6,*) ' Global => Local reform of conf '
        ELSE
          WRITE(6,*) ' Local => Global reform of conf '
        END IF
        WRITE(6,*) ' ICONF_GAS : '
        CALL IWRTMA(ICONF_GAS,1,NEL,1,NEL)
        WRITE(6,*) ' Accessed part of ICONF '
        CALL IWRTMA(ICONF,1,IBEL-1+NEL,1,IBEL-1+NEL)
      END IF
*
      RETURN
      END
C       NOP_FOR_CONF(JCONF,NEL)

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SORTA(BUFS,INDS,ISAB,BUFBI,BIAC,BICA,NINTGR)
! SORTS INTEGRALS (AB/CI)
! FOR FIXED B,I ALL A,C
! FIRST CHAIN FOR IJKL

use mrci_global, only: IADABCI, ICH, IFIRST, INDSRT, IPRINT, IROW, ISMAX, KBUFF1, LASTAD, Lu_60, Lu_70, LUSYMB, LUTRA, LN, MCHAIN, &
                       NBITM1, NCHN1, NORB, NSM, NSRTMX, NSYM, NTIBUF, NVIRT, NVPAIR, TIBUF, VALSRT
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: BUFS(NBITM1,NCHN1), BUFBI(KBUFF1), BIAC(ISMAX), BICA(ISMAX)
integer(kind=iwp), intent(out) :: INDS(NBITM1+2,NCHN1), NINTGR
integer(kind=iwp), intent(in) :: ISAB(*)
#include "tratoc.fh"
#include "warnings.h"
integer(kind=iwp) :: I, IACS, IAD15, IAD50, IADD10, IADR, IBUFIJ, ICHK, IDISK, IIJ, IIN, IJ, IJKL, ILEN, ILOOP, INB, INND, INS, &
                     INSB, INSOUT, INUMB, IOUT, IPOS, ISRTAD, IST, JDISK, KK, KL, LENGTH, M, NA, NAT, NB, NC, NI, NIB, NJ, NK, NL, &
                     NOP, NOQ, NOR, NORB0(9), NORBP, NOS, NSAVE, NSIB, NSP, NSPQ, NSPQR, NSQ, NSR, NSRTCN, NSS, NSSM, NT, NTM, NU, &
                     NUMAX, NUMIN, NV, NX, NXM
real(kind=wp) :: FINI
logical(kind=iwp) :: Skip

call COUNT_MRCI(NINTGR,NSYM,NORB,MUL)
if (IPRINT >= 6) write(u6,1234) NINTGR

IAD50 = 0
call iDAFILE(LUTRA,2,iTraToc,nTraToc,IAD50)

IDISK = 0
ICHK = 0
INDS(NBITM1+1,:) = 0
INDS(NBITM1+2,:) = -1
NORB0(1) = 0
do I=1,NSYM
  NORB0(I+1) = NORB0(I)+NORB(I)
end do

! TWO-ELECTRON INTEGRALS

do NSP=1,NSYM
  NOP = NORB(NSP)
  do NSQ=1,NSP
    NSPQ = MUL(NSP,NSQ)
    NOQ = NORB(NSQ)
    do NSR=1,NSP
      NSPQR = MUL(NSPQ,NSR)
      NOR = NORB(NSR)
      NSSM = NSR
      if (NSR == NSP) NSSM = NSQ
      do NSS=1,NSSM
        if (NSS /= NSPQR) cycle
        NOS = NORB(NSS)
        NORBP = NOP*NOQ*NOR*NOS
        if (NORBP == 0) cycle
        call dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
        IOUT = 0
        do NV=1,NOR
          NXM = NOS
          if (NSR == NSS) NXM = NV
          do NX=1,NXM
            NTM = 1
            if (NSP == NSR) NTM = NV
            do NT=NTM,NOP
              NUMIN = 1
              if ((NSP == NSR) .and. (NT == NV)) NUMIN = NX
              NUMAX = NOQ
              if (NSP == NSQ) NUMAX = NT
              do NU=NUMIN,NUMAX
                IOUT = IOUT+1
                if (IOUT > NTIBUF) then
                  call dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
                  IOUT = 1
                end if
                FINI = TIBUF(IOUT)
                NI = ICH(NORB0(NSP)+NT)
                if (NI <= 0) cycle
                NJ = ICH(NORB0(NSQ)+NU)
                if (NJ <= 0) cycle
                NK = ICH(NORB0(NSR)+NV)
                if (NK <= 0) cycle
                NL = ICH(NORB0(NSS)+NX)
                if (NL <= 0) cycle
                ! ORDER THESE INDICES CANONICALLY
                if (NI < NJ) then
                  M = NI
                  NI = NJ
                  NJ = M
                end if
                if (NK < NL) then
                  M = NK
                  NK = NL
                  NL = M
                end if
                if (NI < NK) then
                  M = NK
                  NK = NI
                  NI = M
                  M = NL
                  NL = NJ
                  NJ = M
                else if ((NI == NK) .and. (NJ < NL)) then
                  M = NL
                  NL = NJ
                  NJ = M
                end if
                if (NI > LN) then
                  if (NK <= LN) cycle
                  if (IFIRST /= 0) cycle
                  if (NJ > LN) then
                    if (NL > LN) cycle
                    ! ABCI
                    NA = NI-LN
                    NB = NJ-LN
                    NC = NK-LN
                    NI = NL
                  else
                    if (NL <= LN) cycle
                    ! CIAB
                    NA = NK-LN
                    NB = NL-LN
                    NC = NI-LN
                    NI = NJ
                  end if
                  NIB = (NI-1)*NVIRT+NB+1
                  IPOS = INDS(NBITM1+1,NIB)+1
                  INDS(NBITM1+1,NIB) = IPOS
                  BUFS(IPOS,NIB) = FINI
                  INDS(IPOS,NIB) = (NA-1)*NVIRT+NC
                  if (IPOS >= NBITM1) then
                    JDISK = IDISK
                    call iDAFILE(Lu_60,1,INDS(:,NIB),NBITM1+2,IDISK)
                    call dDAFILE(Lu_60,1,BUFS(:,NIB),NBITM1,IDISK)
                    INDS(NBITM1+1,NIB) = 0
                    INDS(NBITM1+2,NIB) = JDISK
                  end if
                  if (NA /= NB) then
                    NAT = NA
                    NA = NB
                    NB = NAT
                    NIB = (NI-1)*NVIRT+NB+1
                    IPOS = INDS(NBITM1+1,NIB)+1
                    INDS(NBITM1+1,NIB) = IPOS
                    BUFS(IPOS,NIB) = FINI
                    INDS(IPOS,NIB) = (NA-1)*NVIRT+NC
                    if (IPOS >= NBITM1) then
                      JDISK = IDISK
                      call iDAFILE(Lu_60,1,INDS(:,NIB),NBITM1+2,IDISK)
                      call dDAFILE(Lu_60,1,BUFS(:,NIB),NBITM1,IDISK)
                      INDS(NBITM1+1,NIB) = 0
                      INDS(NBITM1+2,NIB) = JDISK
                    end if
                  end if
                else
                  ! IJKL
                  IIJ = IROW(NI)+NJ
                  KL = IROW(NK)+NL
                  IJKL = IIJ*(IIJ-1)/2+KL
                  IJ = 1
                  IPOS = INDS(NBITM1+1,IJ)+1
                  INDS(NBITM1+1,IJ) = IPOS
                  BUFS(IPOS,IJ) = FINI
                  INDS(IPOS,IJ) = IJKL
                  if (IPOS == NBITM1) then
                    JDISK = IDISK
                    call iDAFILE(Lu_60,1,INDS(:,IJ),NBITM1+2,IDISK)
                    call dDAFILE(Lu_60,1,BUFS(:,IJ),NBITM1,IDISK)
                    INDS(NBITM1+1,IJ) = 0
                    INDS(NBITM1+2,IJ) = JDISK
                  end if
                end if
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end do
! EMPTY LAST BUFFERS
if (NCHN1 > MCHAIN) then
  write(u6,*) 'SORTA Error: NCHN1 > MCHAIN (See code).'
  call QUIT(_RC_GENERAL_ERROR_)
end if
do I=1,NCHN1
  JDISK = IDISK
  call iDAFILE(Lu_60,1,INDS(:,I),NBITM1+2,IDISK)
  call dDAFILE(Lu_60,1,BUFS(:,I),NBITM1,IDISK)
  LASTAD(I) = JDISK
end do
! IJKL
IDISK = 0
IBUFIJ = 0
ISRTAD = -1
IADR = LASTAD(1)
do
  call iDAFILE(Lu_60,2,INDS,NBITM1+2,IADR)
  call dDAFILE(Lu_60,2,BUFS,NBITM1,IADR)
  LENGTH = INDS(NBITM1+1,1)
  IADR = INDS(NBITM1+2,1)
  do I=1,LENGTH
    IBUFIJ = IBUFIJ+1
    VALSRT(IBUFIJ) = BUFS(I,1)
    INDSRT(IBUFIJ) = INDS(I,1)
    if (IBUFIJ < NSRTMX) cycle
    NSRTCN = NSRTMX
    JDISK = IDISK

    INDSRT(NSRTMX+1) = NSRTCN
    INDSRT(NSRTMX+2) = ISRTAD
    call dDAFILE(Lu_70,1,VALSRT,NSRTMX,IDISK)
    call iDAFILE(Lu_70,1,INDSRT,NSRTMX+2,IDISK)

    ISRTAD = JDISK
    IBUFIJ = 0
  end do
  if (IADR == -1) exit
end do
! EMPTY LAST BUFFER
NSRTCN = IBUFIJ
JDISK = IDISK
!
INDSRT(NSRTMX+1) = NSRTCN
INDSRT(NSRTMX+2) = ISRTAD
call dDAFILE(Lu_70,1,VALSRT,NSRTMX,IDISK)
call iDAFILE(Lu_70,1,INDSRT,NSRTMX+2,IDISK)

LASTAD(1) = JDISK
! ABCI
IAD15 = IDISK
IADABCI = IAD15
INSOUT = 0
IADD10 = IAD10(4)
call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
ILEN = ICOP1(nCOP+1)
IIN = 2
NSAVE = ICOP1(IIN)
do
  NI = NSAVE
  IOUT = 0
  Skip = .false.
  do
    IIN = IIN+1
    if (IIN > ILEN) then
      call dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      call iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      ILEN = ICOP1(nCOP+1)
      if (ILEN <= 0) then
        Skip = .true.
        exit
      end if
      IIN = 1
    end if
    if (ICHK /= 0) exit
    if (ICOP1(IIN) == 0) then
      ICHK = 1
    else
      IOUT = IOUT+1
    end if
  end do
  if (.not. Skip) then
    ICHK = 0
    NSAVE = ICOP1(IIN)
  end if
  NIB = 1+(NI-1)*NVIRT
  ! LOOP OVER VIRTUAL ORBITAL INDEX B:
  do NB=1,NVIRT
    NSIB = MUL(NSM(LN+NB),NSM(NI))
    INS = NVPAIR(NSIB)
    if (INS /= 0) then
      BIAC(1:INS) = Zero
      BICA(1:INS) = Zero
    end if
    NIB = NIB+1
    ! READ & PROCESS INTEGRAL BUFFERS ON UNIT 14:
    IADR = LASTAD(NIB)
    do
      call iDAFILE(Lu_60,2,INDS,NBITM1+2,IADR)
      call dDAFILE(Lu_60,2,BUFS,NBITM1,IADR)
      LENGTH = INDS(NBITM1+1,1)
      IADR = INDS(NBITM1+2,1)
      do KK=1,LENGTH
        INND = INDS(KK,1)
        NA = (INND-1)/NVIRT+1
        NC = INND-(NA-1)*NVIRT
        IACS = ISAB(NA+(NC-1)*NVIRT)
        BIAC(IACS) = BIAC(IACS)+BUFS(KK,1)
        if (NA > NC) BICA(IACS) = BICA(IACS)-BUFS(KK,1)
        if (NA < NC) BICA(IACS) = BICA(IACS)+BUFS(KK,1)
      end do
      if (IADR == -1) exit
    end do
    do ILOOP=0,1
      INSB = INS
      do
        INB = KBUFF1-INSOUT
        INUMB = INSB
        if (INSB > INB) INUMB = INB
        IST = INS-INSB+1
        if (ILOOP == 0) call DCOPY_(INUMB,BIAC(IST),1,BUFBI(INSOUT+1),1)
        if (ILOOP == 1) call DCOPY_(INUMB,BICA(IST),1,BUFBI(INSOUT+1),1)
        INSOUT = INSOUT+INUMB
        if (INSOUT > KBUFF1) then
          write(u6,*) 'SortA: INSOUT > KBUFF1'
          write(u6,*) 'INSOUT=',INSOUT
          write(u6,*) 'KBUFF1=',KBUFF1
          call ABEND()
        end if
        if (INSOUT == KBUFF1) then
          call dDAFILE(Lu_70,1,BUFBI,KBUFF1,IAD15)
          INSOUT = 0
        end if
        INSB = INSB-INUMB
        if (INSB <= 0) exit
      end do
    end do
  end do
  if (ILEN < 0) exit
end do
! EMPTY LAST BUFFER IF NOT EMPTY
if (INSOUT > 0) call dDAFILE(Lu_70,1,BUFBI,KBUFF1,IAD15)

return

1234 format(//6X,'NUMBER OF TWO-ELECTRON INTEGRALS',I10)

end subroutine SORTA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NEWORB_RASSCF(CMOO,CMON,FP,FTR,VEC,WO,SQ,CMOX,D,OCCN)
! RASSCF program, version IBM-3090: SX section
!
! Purpose: To diagonalize the inactive,
!          and external parts of the Fock matrix FP=(FI+FA)
!          and order the eigenvalues and eigenvectors after energy.
!          The active orbitals are obtained by diagonalising the
!          corresponding RAS subspaces.
!          The new MO's are written onto JOBIPH
!          in address IADR15(2), and are used to produce the final
!          wave function. These are the orbitals printed in the
!          output section.
! Called from SXCTL if IFINAL=1 (after last MC iteration)
!
!      ********** IBM-3090 MOLCAS Release: 90 02 22 **********
!
! Calling arguments:
! D       : array of real, input
!           one body density matrix in MO-space
! FP      : array of real, input
!           MCSCF-Fock matrix
! FTR     : array of real
!           scratch array (local copy of FP, one sym. block only)
! SQ      : array of real
!           scratch array (keep in sym block of Fock)
! WO      : array of real
!           scratch array (keep in sym block of Fock)
! VEC     : array of real
!           scratch array (eigenvectors of FTR)
! CMOX    : array of real, input
!           scratch array (local copy of CMOO)
! CMOO    : array of real, input
!           old MO-coefficients
! CMON    : array of real, output
!           new MO-coefficients
! OCNN    : array of real, input/output
!           MO occupation numbers

use Index_Functions, only: iTri, nTri_Elem
use gas_data, only: NGAS, NGSSH
use PrintLevel, only: DEBUG
use output_ras, only: IPRLOC
use general_data, only: JOBIPH, NASH, NBAS, NDEL, NFRO, NISH, NSSH, NSYM, NTOT, NTOT2
use rasscf_global, only: FDIAG, iADR15, iFORDE, iOrbTyp, iOrdEM, iSupSM, ixSym
#ifdef _DMRG_
use rasscf_global, only: DoDMRG
#else
use rasscf_global, only: DoBLOCKDMRG
#endif
#ifdef _HDF5_
use mh5, only: mh5_put_dset
use RASWfn, only: wfn_mocoef, wfn_occnum, wfn_orbene
#endif
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: CMOO(*), FP(*), D(*)
real(kind=wp), intent(_OUT_) :: CMON(*), FTR(*), VEC(*), WO(*), SQ(*), CMOX(*), OCCN(*)
integer(kind=iwp) :: i, iAd15, iB, iBas, iGas, ii, iOff, iOrd, iPrLev, iST, iSTD, iSTFCK, iSTI, iSTM, iSTMO, iSTMO1, iSTMOA, iSYM, &
                     ixSymT, j, jSel, k, M_IN, N_OT, NA, NA1, NAB, NABT, NAO, NAT, NB, NBF, NBT, NDNB, NDO, NEO, NEO1, NFI_, NFNB, &
                     NFO, NI, NI1, NIJ, NIO, NIO1, NJ, NO1, NOO, NT, NTTR, NTU, NTUD, NU, NUT
real(kind=wp) :: AVij, AVMx, Fact, FMin, Swap, VIJ

! Local print level (if any)
IPRLEV = IPRLOC(4)
if (IPRLEV >= DEBUG) write(u6,*) ' Entering NEWORB_RASSCF'

! IORD = 1 Ordering of inactive and secondary orbitals

if ((ISUPSM == 1) .and. (IORDEM == 0)) IFORDE = 0
IORD = IFORDE

IB = 0
ISTMO1 = 1
ISTFCK = 0
ISTD = 0

! A long loop over symmetry:
do ISYM=1,NSYM
  NBF = NBAS(ISYM)
  NFO = NFRO(ISYM)
  NIO = NISH(ISYM)
  NAO = NASH(ISYM)
  NEO = NSSH(ISYM)
  NOO = NFO+NIO+NAO
  N_OT = NIO+NAO+NEO
  ISTMO = ISTMO1+NFO*NBF
  !*********************************************************************
  !      Frozen orbitals (move MO's to CMON, and set zero to FDIAG)
  !*********************************************************************
  if (NFO /= 0) then
    NFNB = NBF*NFO
    CMON(ISTMO1:ISTMO1+NFNB-1) = CMOO(ISTMO1:ISTMO1+NFNB-1)
    FDIAG(IB+1:IB+NFO) = Zero
    OCCN(IB+1:IB+NFO) = Two
  end if
  !*********************************************************************
  !      Inactive part of the Fock matrix
  !*********************************************************************
  if (NIO /= 0) then
    ! MOVE FP TO TRIANGULAR FORM
    NIJ = 0
    do NI=1,NIO
      do NJ=1,NI
        NIJ = NIJ+1
        FTR(NIJ) = FP(NIJ+ISTFCK)
        if (IXSYM(IB+NFO+NI) /= IXSYM(IB+NFO+NJ)) FTR(NIJ) = Zero
      end do
    end do
    ! DIAGONALIZE
    call unitmat(VEC,NIO)
    call JACOB(FTR,VEC,NIO,NIO)

    ! Transform molecular orbitals

    call DGEMM_('N','N',NBF,NIO,NIO,One,CMOO(ISTMO),NBF,VEC,NIO,Zero,CMON(ISTMO),NBF)

    ! Sort eigenvalues and orbitals after energy

    ! Move eigenvalues to FDIAG and set occupation numbers to 2.

    II = 0
    NO1 = IB+NFO
    do NI=1,NIO
      II = II+NI
      FDIAG(NO1+NI) = FTR(II)
    end do
    OCCN(NO1+1:NO1+NIO) = Two
    if ((NIO > 1) .and. (IORD /= 0)) then
      NIO1 = NIO-1
      do NI=1,NIO1
        NI1 = NI+1
        M_IN = NI
        do NJ=NI1,NIO
          if (FDIAG(NO1+NJ) < FDIAG(NO1+M_IN)) M_IN = NJ
        end do
        if (M_IN /= NI) then
          FMIN = FDIAG(NO1+M_IN)
          FDIAG(NO1+M_IN) = FDIAG(NO1+NI)
          FDIAG(NO1+NI) = FMIN
          ! (SVC) added: extra nodig voor verandering ordening met supsym
          IXSYMT = IXSYM(NO1+M_IN)
          IXSYM(NO1+M_IN) = IXSYM(NO1+NI)
          IXSYM(NO1+NI) = IXSYMT

          ISTI = ISTMO+NBF*(NI-1)
          ISTM = ISTMO+NBF*(M_IN-1)
          call DSWAP_(NBF,CMON(ISTI),1,CMON(ISTM),1)
        end if
      end do
    end if
  end if
  !*********************************************************************
  !      Active orbitals. Diagonalize corresponding diagonal block of D
  !*********************************************************************
  ! dongxia make a loop for all active spaces

  ioff = 0
  do igas=1,ngas
    if (igas > 1) ioff = ioff+ngssh(igas-1,isym)
    if (ngssh(igas,isym) /= 0) then
      ! MOVE D TO TRIANGULAR FORM
      NTU = 0
      ntud = istd+nTri_Elem(ioff)
      do NT=1,ngssh(igas,isym)
        ntud = ntud+ioff
        nttr = nt+nio+ioff
        do NU=1,NT
          nut = nu+nio+ioff
          NTU = NTU+1
          ntud = ntud+1
          FTR(NTU) = D(ntud)
          if (IXSYM(IB+NFO+nttr) /= IXSYM(IB+NFO+nut)) ftr(ntu) = Zero
        end do
      end do

#     ifdef _DMRG_
      ! YM:   If lRF, use Canonical instead of Natural, otherwise the energy expression will be
      !       mismatch due to the FI matrix still in Canonical form.
      ! YM:   The lRF flag can be removed if "TRACI" utility has MPS version
      !if ((.not. lRF) .or. (iOrbTyp == 2)) then
      ! YM:   Just use the same way as Block did, the NOs will be added later
      if ((.not. doDMRG) .or. (iOrbTyp == 2)) then
#     else
      ! NN.14 Skip making new orbitals for DMRG-CASSCF except for the case OutOrb = Canonical
      !       because the DMRG is orbital variant.
      if ((.not. DoBlockDMRG) .or. (iOrbTyp == 2)) then
#     endif

        ! DIAGONALIZE
        call unitmat(VEC,ngssh(igas,isym))
        call JACOB(FTR,VEC,ngssh(igas,isym),ngssh(igas,isym))
        !PAM01 Reorder to max-overlap agreement with input orbitals.
        !PAM01 This prevents numerical difficulty with the subsequent transformation
        !PAM01 of the CI vector, see TRAMAT routine.
        !PAM01 Similar later, with RAS2, RAS3.
        do I=1,ngssh(igas,isym)-1
          JSEL = I
          AVMX = abs(VEC(I+ngssh(igas,isym)*(I-1)))
          do J=I+1,ngssh(igas,isym)
            AVIJ = abs(VEC(I+ngssh(igas,isym)*(J-1)))
            if (AVIJ > AVMX) then
              JSEL = J
              AVMX = AVIJ
            end if
          end do
          !PAM01 Swap if necessary. Note phase control!!
          if (JSEL > I) then
            VIJ = VEC(I+ngssh(igas,isym)*(JSEL-1))
            if (VIJ > Zero) then
              do K=1,ngssh(igas,isym)
                SWAP = VEC(K+ngssh(igas,isym)*(JSEL-1))
                VEC(K+ngssh(igas,isym)*(JSEL-1)) = -VEC(K+ngssh(igas,isym)*(I-1))
                VEC(K+ngssh(igas,isym)*(I-1)) = SWAP
              end do
            else
              do K=1,ngssh(igas,isym)
                SWAP = VEC(K+ngssh(igas,isym)*(JSEL-1))
                VEC(K+ngssh(igas,isym)*(JSEL-1)) = +VEC(K+ngssh(igas,isym)*(I-1))
                VEC(K+ngssh(igas,isym)*(I-1)) = -SWAP
              end do
            end if
            ! Also swap eigenvalues:
            SWAP = FTR(nTri_Elem(JSEL))
            FTR(nTri_Elem(JSEL)) = FTR(nTri_Elem(I))
            FTR(nTri_Elem(I)) = SWAP
          else
            !PAM01 If swap is not needed, still apply phase control!!
            if (VEC(I+ngssh(igas,isym)*(I-1)) < Zero) then
              do K=1,ngssh(igas,isym)
                VEC(K+ngssh(igas,isym)*(I-1)) = -VEC(K+ngssh(igas,isym)*(I-1))
                VEC(K+ngssh(igas,isym)*I) = -VEC(K+ngssh(igas,isym)*I)
              end do
            end if
          end if
        end do
        !PAM01 We now have a MINIMAL pure rotation. This means that all
        !PAM01 upper-left subdeterminants are >0 and as big as possible.
        !PAM01 This eliminates numerical trouble in TRAMAT.

        ! Transform molecular orbitals
        ISTMOA = ISTMO+NBF*(NIO+ioff)
        call DGEMM_('N','N',NBF,ngssh(igas,isym),ngssh(igas,isym),One,CMOO(ISTMOA),NBF,VEC,ngssh(igas,isym),Zero,CMON(ISTMOA),NBF)
      else ! if ((.not. DoDMRG) .or. (iOrbTyp == 2))
        ! NN.14 Just copy CMO(Old) to CMO(new)
        ISTMOA = ISTMO+NBF*(NIO+ioff)
        CMON(ISTMOA:ISTMOA+NBF*ngssh(igas,isym)-1) = CMOO(ISTMOA:ISTMOA+NBF*ngssh(igas,isym)-1)
      end if

      ! Move eigenvalues to OCCN

      II = 0
      NO1 = IB+NFO+NIO+ioff
      do NT=1,ngssh(igas,isym)
        II = II+NT
        OCCN(NO1+NT) = FTR(II)
      end do
      FDIAG(NO1+1:NO1+ngssh(igas,isym)) = Zero

      ! FA:  no longer setting energies to 0 (though in principle ill-def).

      ! IFG: Pick the diagonal elements of the transformed Fock matrix
      NFI_ = nTri_Elem(NFO+NIO+ioff)
      NO1 = IB+NFO+NIO+ioff
      do NT=1,ngssh(igas,isym)
        NFI_ = NFI_+NFO+NIO+ioff
        do NU=1,NT
          if (NU == NT) then
            FACT = FP(NU+NFI_+ISTFCK)
          else
            FACT = Two*FP(NU+NFI_+ISTFCK)
          end if
          do II=1,ngssh(igas,isym)
            FDIAG(NO1+II) = FDIAG(NO1+II)+FACT*VEC(NT+(II-1)*ngssh(igas,isym))*VEC(NU+(II-1)*ngssh(igas,isym))
          end do
        end do
        NFI_ = NFI_+NT
      end do

    end if  ! end of if (NGAS(1) /= 0)
  end do ! end loop over GAS spaces

  !*********************************************************************
  !      external part of the Fock matrix
  !*********************************************************************

  if (NEO /= 0) then
    ! Move fp to triangular form
    NAB = 0
    do NA=1,NEO
      do NB=1,NA
        NAB = NAB+1
        NAT = NA+NIO+NAO
        NBT = NB+NIO+NAO
        NABT = ISTFCK+iTri(NAT,NBT)
        FTR(NAB) = FP(NABT)
        if (IXSYM(IB+NFO+NAT) /= IXSYM(IB+NFO+NBT)) FTR(NAB) = Zero
      end do
    end do
    ! DIAGONALIZE
    call unitmat(VEC,NEO)
    call JACOB(FTR,VEC,NEO,NEO)

    ! Move eigenvalues to FDIAG and set occupation numbers to zero.

    II = 0
    NO1 = IB+NFO+NIO+NAO
    do NA=1,NEO
      II = II+NA
      FDIAG(NO1+NA) = FTR(II)
    end do
    OCCN(NO1+1:NO1+NEO) = Zero

    ! Transform molecular orbitals

    ISTMOA = ISTMO+NBF*(NIO+NAO)
    call DGEMM_('N','N',NBF,NEO,NEO,One,CMOO(ISTMOA),NBF,VEC,NEO,Zero,CMON(ISTMOA),NBF)

    ! Sort eigenvalues and orbitals after energy

    if ((NEO > 1) .and. (IORD /= 0)) then
      NEO1 = NEO-1
      do NA=1,NEO1
        NA1 = NA+1
        M_IN = NA
        do NB=NA1,NEO
          if (FDIAG(NO1+NB) < FDIAG(NO1+M_IN)) M_IN = NB
        end do
        if (M_IN /= NA) then
          FMIN = FDIAG(NO1+M_IN)
          FDIAG(NO1+M_IN) = FDIAG(NO1+NA)
          FDIAG(NO1+NA) = FMIN
          ! (SVC) added: extra nodig voor verandering ordening met supsym
          IXSYMT = IXSYM(NO1+M_IN)
          IXSYM(NO1+M_IN) = IXSYM(NO1+NA)
          IXSYM(NO1+NA) = IXSYMT

          ISTI = ISTMOA+NBF*(NA-1)
          ISTM = ISTMOA+NBF*(M_IN-1)
          call DSWAP_(NBF,CMON(ISTI),1,CMON(ISTM),1)
        end if
      end do
    end if
  end if

  !*********************************************************************
  !      Deleted orbitals (move MO's and set zero to FDIAG and OCCN)
  !*********************************************************************
  NDO = NDEL(ISYM)
  if (NDO /= 0) then
    NDNB = NDO*NBF
    IST = ISTMO1+NBF*(NOO+NEO)
    CMON(IST:IST+NDNB-1) = CMOO(IST:IST+NDNB-1)
    FDIAG(IB+NBF-NDO+1:IB+NBF) = Zero
    OCCN(IB+NBF-NDO+1:IB+NBF) = Zero
  end if

  IB = IB+NBF
  ISTFCK = ISTFCK+nTri_Elem(N_OT)
  ISTMO1 = ISTMO1+NBF**2
  ISTD = ISTD+nTri_Elem(NAO)
  ! End of a long loop over symmetry.
end do

if (IPRLEV >= DEBUG) then
  write(u6,*) ' Diagonal elements of the FOCK matrix in NEWORB:'
  write(u6,'(1X,10F11.6)') (FDIAG(I),I=1,NTOT)
end if

!***********************************************************************
!     Orthogonalise new orbitals
!***********************************************************************
call ORTHO_RASSCF(WO,CMOX,CMON,SQ)
if (IPRLEV >= DEBUG) then
  write(u6,*)
  write(u6,*) ' CMO in NEWORB_RASSCF after diag and orthog'
  write(u6,*) ' ---------------------'
  write(u6,*)
  ioff = 0
  do iSym=1,nSym
    iBas = nBas(iSym)
    if (iBas /= 0) then
      write(u6,*) 'Sym =',iSym
      do i=1,iBas
        write(u6,*) (CMON(ioff+iBas*(i-1)+j),j=1,iBas)
      end do
      iOff = iOff+(iBas*iBas)
    end if
  end do
end if

! Save new CMOs on the JOBIPH

IAD15 = IADR15(2)
call dDAFILE(JOBIPH,1,CMON,NTOT2,IAD15)
call dDAFILE(JOBIPH,1,OCCN,NTOT,IAD15)

#ifdef _HDF5_
call mh5_put_dset(wfn_mocoef,CMON)
call mh5_put_dset(wfn_occnum,OCCN)
call mh5_put_dset(wfn_orbene,FDIAG)
#endif

return

end subroutine NEWORB_RASSCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module EFP_Module

use, intrinsic :: iso_c_binding, only: c_int, c_ptr
use Definitions, only: wp, iwp

implicit none
private

integer(c_int), parameter :: XYZABC_Type = 0, Points_Type = 1, RotMat_Type = 2
integer(kind=iwp) :: nEFP_Coor, nEFP_fragments
integer(c_int) :: Coor_Type
logical(kind=iwp) :: lEFP
type(c_ptr) :: efp_instance
real(kind=wp), allocatable, target :: EFP_COORS(:,:)
character(len=180), allocatable :: ABC(:,:), FRAG_Type(:)

public :: ABC, Coor_Type, EFP_COORS, efp_instance, FRAG_Type, lEFP, nEFP_Coor, nEFP_fragments, Points_Type, RotMat_Type, XYZABC_Type

end module EFP_Module

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ORDSTR_MCLR(IINST,IOUTST,NELMNT,ISGN)
! ORDER A STRING OF INTEGERS TO ASCENDING ORDER
!
! IINST  : INPUT STRING IS IINST
! IOUTST : OUTPUT STRING IS IOUTST
! NELMNT : NUMBER OF INTEGERS IN STRING
! ISGN   : SIGN OF PERMUTATION : + 1 : EVEN PERMUTATIONN
!                                - 1 : ODD  PERMUTATION
!
! THIS CODE CONTAINS THE OLD ORDER CODE OF JOE GOLAB
! (HE IS HEREBY AKNOWLEDGED, AND I AM EXCUSED)
!
! IMPLEMENTED MORE TRANSPARENT BUBBLE SORTING INSTEAD
!               JR NOV 2006

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: NELMNT
integer(kind=iwp), intent(inout) :: IINST(NELMNT)
integer(kind=iwp), intent(out) :: IOUTST(NELMNT), ISGN
integer(kind=iwp) :: I, iPass, iTemp

ISGN = 1
if (NELMNT == 0) return

iTEMP = 0

iPass = 1
do while (iPass /= 0)
  iPass = 0
  do I=1,NELMNT-1
    if (IINST(I) > IINST(I+1)) then
      iTEMP = IINST(I)
      IINST(I) = IINST(I+1)
      IINST(I+1) = iTEMP
      ISGN = -1*ISGN
      iPass = 1
    end if
  end do
end do

IOUTST(:) = IINST(:)

!ISGN = 1

!JOE = 1
!I = JOE
!do
!  if (I == NELMNT) exit
!  if (IOUTST(I) > IOUTST(I+1)) then
!    JOE = I+1
!    do
!      iSWAP = IOUTST(I)
!      ISGN = -ISGN
!      IOUTST(I) = IOUTST(I+1)
!      IOUTST(I+1) = iSWAP
!      if (I == 1) exit
!      I = I-1
!      if (IOUTST(I) <= IOUTST(I+1)) exit
!    end do
!    I = JOE
!  else
!    I = I+1
!  end if
!end do
!
! END ORDER
!
!#ifdef _DEBUGPRINT_
!write(u6,*) ' INPUT STRING ORDERED STRING ISGN ',NELMNT
!call IWRTMA(IINST,1,NELMNT,1,NELMNT)
!call IWRTMA(IOUTST,1,NELMNT,1,NELMNT)
!write(u6,*) ' ISGN : ',ISGN
!#endif

end subroutine ORDSTR_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HSHGET(KEY,KEYDIM,NCOMP,ITEM,NSIZE,ITAB,ITEMID)

use rassi_aux, only: MULT, NHASH
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: KEYDIM, KEY(KEYDIM), NCOMP, ITEM(NCOMP,*), NSIZE, ITAB(NSIZE,2)
integer(kind=iwp), intent(out) :: ITEMID
integer(kind=iwp) :: I, IND, INULL, LOOKAT
logical(kind=iwp) :: FAILED_ID

if (NSIZE < NHASH) then
  write(u6,*) ' HSHGET: Table size must be at least as'
  write(u6,*) '         big as NHASH, presently =',NHASH
  call ABEND()
end if
INULL = ITAB(NSIZE,1)
! Evaluate hash index:
IND = mod(KEY(1),NHASH)
do I=2,KEYDIM
  IND = mod(KEY(I)+MULT*IND,NHASH)
end do
IND = IND+1
! IND is a hashed index in interval 1..NHASH < NSIZE
! Find the item with this key:

LOOKAT = IND

Outer: do

  ! Are there (more) items with that hash signature?
  if (ITAB(LOOKAT,1) == INULL) then
    ! Here, if we have failed to find such an item.
    ITEMID = 0
    return
  end if

  ! Try to identify an item which has the given key:
  ITEMID = ITAB(LOOKAT,2)
  FAILED_ID = .false.
  do I=1,KEYDIM
    if (ITEM(I,ITEMID) /= KEY(I)) then
      FAILED_ID = .true.
      exit
    end if
  end do

  if (FAILED_ID) then
    ! Here, if we have not yet identified the item.
    LOOKAT = ITAB(LOOKAT,1)
  else
    ! Here, if we have identified the item.
    exit
  end if

end do Outer

end subroutine HSHGET

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*--------------------------------------------------------------------------*
* Compute rotation matrix for this specific solvent.                       *
*--------------------------------------------------------------------------*
      Subroutine TransRot(Cordst,i,Rot,xt,yt,zt,Ax,Ay,Az)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "warnings.fh"

      Dimension Rot(3,3),Cordst(MxPut*MxCen,3)

      XO=CORDST(I,1)-AX
      YO=CORDST(I,2)-AY
      ZO=CORDST(I,3)-AZ
      XH=CORDST(I+1,1)-AX
      YH=CORDST(I+1,2)-AY
      ZH=CORDST(I+1,3)-AZ
      XA=CORDST(I+2,1)-AX
      YA=CORDST(I+2,2)-AY
      ZA=CORDST(I+2,3)-AZ
      DELX=(XH+XA)/2.-XO
      DELY=(YH+YA)/2.-YO
      DELZ=(ZH+ZA)/2.-ZO
      DELR=DELX*DELX+DELY*DELY+DELZ*DELZ
      DELR=DELR-1.225449d0
      IF(ABS(DELR).GT..0001)THEN !This is a check of the water geometry.
        Write(6,*)'Molecule',((i-1)/5)+1  !If we enter here, something
        WRITE(6,*)' WARNING IN TRANSROT ', 'delr',delr  !is wrong.
        WRITE(6,*)' O',XO,YO,ZO
        WRITE(6,*)' H',XH,YH,ZH
        WRITE(6,*)' A',XA,YA,ZA
        Call Quit(_RC_GENERAL_ERROR_)
      ENDIF
      XT=XO+.3d0/1.107d0*DELX
      YT=YO+.3d0/1.107d0*DELY
      ZT=ZO+.3d0/1.107d0*DELZ
      ROT(1,3)=(XO-XT)/.3d0
      ROT(2,3)=(YO-YT)/.3d0
      ROT(3,3)=(ZO-ZT)/.3d0
      ROT(1,2)=(XH-XA)/2.86d0
      ROT(2,2)=(YH-YA)/2.86d0
      ROT(3,2)=(ZH-ZA)/2.86d0
      ANORM=1./SQRT(ROT(1,3)**2+ROT(2,3)**2+ROT(3,3)**2)
      ROT(1,3)=ROT(1,3)*ANORM
      ROT(2,3)=ROT(2,3)*ANORM
      ROT(3,3)=ROT(3,3)*ANORM
      ANORM=1./SQRT(ROT(1,2)**2+ROT(2,2)**2+ROT(3,2)**2)
      ROT(1,2)=ROT(1,2)*ANORM
      ROT(2,2)=ROT(2,2)*ANORM
      ROT(3,2)=ROT(3,2)*ANORM
      ROT(1,1)=1.-ROT(1,3)**2-ROT(1,2)**2
      IF(ROT(1,1).LT.0.)ROT(1,1)=0d0
      ROT(1,1)=SQRT(ROT(1,1))
      ROT(2,1)=1.-ROT(2,2)**2-ROT(2,3)**2
      IF(ROT(2,1).LT.0.)ROT(2,1)=0d0
      ROT(2,1)=SQRT(ROT(2,1))
      ROT(3,1)=1.-ROT(3,3)**2-ROT(3,2)**2
      IF(ROT(3,1).LT.0.)ROT(3,1)=0d0
      ROT(3,1)=SQRT(ROT(3,1))

      IFLAG=0
732   Continue
        TAL=ROT(1,1)*ROT(1,2)+ROT(2,1)*ROT(2,2)+ROT(3,1)*ROT(3,2)
        ROT(1,1)=ROT(1,1)-TAL*ROT(1,2)
        ROT(2,1)=ROT(2,1)-TAL*ROT(2,2)
        ROT(3,1)=ROT(3,1)-TAL*ROT(3,2)
        TAL=ROT(1,1)*ROT(1,3)+ROT(2,1)*ROT(2,3)+ROT(3,1)*ROT(3,3)
        ROT(1,1)=ROT(1,1)-TAL*ROT(1,3)
        ROT(2,1)=ROT(2,1)-TAL*ROT(2,3)
        ROT(3,1)=ROT(3,1)-TAL*ROT(3,3)
        A=1d0/SQRT(ROT(1,1)**2+ROT(2,1)**2+ROT(3,1)**2)
        ROT(1,1)=ROT(1,1)*A
        ROT(2,1)=ROT(2,1)*A
        ROT(3,1)=ROT(3,1)*A
        IFLAG=IFLAG+1
        IF(IFLAG.GT.3) THEN
          WRITE(6,*) ' STOP IN TRANSROT'
          Call Quit(_RC_GENERAL_ERROR_)
        ENDIF
      IF(A.GT.10.) GO TO 732

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_MaxDX(Diag,Dmax)
C
C     Purpose: get max. diagonal elements in each sym. block,
C              qualified diagonals excluded.
C
      use ChoSwp, only: iQuAB, IndRed
      Implicit Real*8 (a-h,o-z)
      Real*8 Diag(*), Dmax(*)
#include "cholesky.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: ExQ(:)

      MxQ = nQual(1)
      Do jSym = 2,nSym
         MxQ = max(MxQ,nQual(jSym))
      End Do
      Call mma_allocate(ExQ,MxQ,Label='ExQ')

      Do jSym=1,nSym

         Dmax(jSym) = 0.0d0
         If (nQual(jSym) .lt. 1) goto 10  ! next symm

         Do iQ=1,nQual(jSym)
            iab=IndRed(iQuAB(iQ,jSym),2) ! addr in 1st red set
            ExQ(iQ) = Diag(iab)
            Diag(iab) = 0.0d0
         End Do

         jRab1 = iiBstr(jSym,2) + 1
         jRab2 = jRab1 + nnBstR(jSym,2) - 1
         Do jRab=jRab1,jRab2
            iRab = IndRed(jRab,2) ! addr in 1st red set
            Dmax(jSym) = Max(Dmax(jSym),Diag(iRab))
         End Do

C --- Restore the qualified
         Do iQ=1,nQual(jSym)
            iab=IndRed(iQuAB(iQ,jSym),2) ! addr in 1st red set
            Diag(iab) = ExQ(iQ)
         End Do

10       Continue

      End Do

      Call mma_deallocate(ExQ)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Martin Schuetz                                   *
!               1998, Roland Lindh                                     *
!               2000-2015, Steven Vancoillie                           *
!***********************************************************************

! double global operation; stub routine to ga_dgop...
! x(n):     global vector
! op:       global operation '+','*','max','min','absmax','absmin'
subroutine GADGOP(x,n,op)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: MT_DBL
#endif
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: x(n)
character(len=*), intent(in) :: op

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) call ga_dgop(MT_DBL,x,n,op)
#else
#include "macros.fh"
unused_var(x)
unused_var(_str(op))
#endif

end subroutine GADGOP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine optize9_cvb(fx1,nparm,ioptc)

use casvb_global, only: formChk1, formChk2, formChk3
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: fx1
integer(kind=iwp), intent(in) :: nparm
integer(kind=iwp), intent(out) :: ioptc
integer(kind=iwp) :: ierr, iparm, it
real(kind=wp) :: cn, dum(1), e1, e2, fx
real(kind=wp), allocatable :: dx(:), grad(:), hessdx(:)
real(kind=wp), parameter :: tenth = 0.1_wp
real(kind=wp), external :: ddot_, rand_cvb

call mma_allocate(dx,nparm,label='dx')
call mma_allocate(grad,nparm,label='grad')
call mma_allocate(hessdx,nparm,label='hessdx')

call grad_cvb(grad)

dum(1) = rand_cvb(0.777_wp)
do iparm=1,nparm
  dx(iparm) = rand_cvb(Zero)-Half
end do
ierr = 0
call nize_cvb(dx,1,dum,nparm,0,ierr)
hessdx(:) = dx(:)
call hess_cvb(hessdx)

write(u6,'(a)') ' Simple check of gradient and Hessian using a random update vector :'
e1 = ddot_(nparm,dx,1,grad,1)
e2 = ddot_(nparm,dx,1,hessdx,1)
write(u6,'(a)') ' '
write(u6,formChk1) ' First-order change  :',e1
write(u6,formChk1) ' Second-order change :',e2
write(u6,'(a)') ' '

write(u6,formChk2) 'Norm     ','DFX(act) ','DFX(pred)','Ratio    ','F2(act)'
cn = One
do it=1,10
  call fxdx_cvb(fx,.false.,dx)
  write(u6,formChk3) cn,fx-fx1,cn*e1+cn*cn*Half*e2,(fx-fx1)/(cn*e1+cn*cn*Half*e2),(fx-fx1-cn*e1)/(cn*cn*Half)
  dx(:) = tenth*dx(:)
  cn = tenth*cn
end do

call mma_deallocate(dx)
call mma_deallocate(grad)
call mma_deallocate(hessdx)

ioptc = 0

return

end subroutine optize9_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine V_EF_PCM(nAt,nTs,DoPot,DoFld,AtmC,Tessera,V,EF_n,EF_e)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAt, nTs
logical(kind=iwp), intent(in) :: DoPot, DoFld
real(kind=wp), intent(in) :: AtmC(3,nAt), Tessera(4,nTs)
real(kind=wp), intent(out) :: V(nTs), EF_n(3,nTs), EF_e(3,nTs)
integer(kind=iwp) :: nOrdOp

! Compute potential on tesserae

if (DoPot) then
  V(:) = Zero
  nOrdOp = 0
  call Mlt_PCM(nAt,nTs,nOrdOp,Tessera,AtmC,V,EF_n,EF_e)
end if

! Compute electric field on tesserae

if (DoFld) then
  EF_n(:,:) = Zero
  EF_e(:,:) = Zero
  nOrdOp = 1
  call Mlt_PCM(nAt,nTs,nOrdOp,Tessera,AtmC,V,EF_n,EF_e)
end if

return

end subroutine V_EF_PCM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995,2000, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE ORBINH1(IORBINH1,IORBINH1_NOCCSYM,NTOOBS,NTOOB,NSMOB)
*
* Obtain array of 2 orbital indeces,
* for symmetry packed matrices
*
* IORBINH1 : Lower half packed
* IORBINH1_NOCCSYM : Complete blocks
*
* resulting indeces are with respect to start of given symmetry block
* while input orbital indeces are absolute and in symmetry order
*
* Jeppe Olsen, March 1995
*              ORBINH1_NOCCSYM added August 2000
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION NTOOBS(NSMOB)
*. output
      DIMENSION IORBINH1(NTOOB,NTOOB), IORBINH1_NOCCSYM(NTOOB,NTOOB)
*
C?    WRITE(6,*) ' ORBINH1 speaking '
C?    WRITE(6,*) ' NSMOB NTOOB ',NSMOB,NTOOB
C?    WRITE(6,*) ' NTOOBS '
C?    CALL IWRTMA(NTOOBS,1,NSMOB,1,NSMOB)
*. To eliminate annoying and incorrect compiler warnings
      IOFF = 0
      JOFF = 0
      INDEX = 0

*. Loop over symmetries of orbitals

      DO ISM = 1, NSMOB
        IF(ISM.EQ.1) THEN
          IOFF = 1
        ELSE
          IOFF = IOFF + NTOOBS(ISM-1)
        END IF
        DO JSM = 1, NSMOB
          IF(JSM.EQ.1) THEN
            JOFF = 1
          ELSE
            JOFF = JOFF + NTOOBS(JSM-1)
          END IF
C?        WRITE(6,*) ' ISM JSM IOFF JOFF', ISM,JSM,IOFF,JOFF
          DO IORB = 1, NTOOBS(ISM)
            IABS = IOFF -1 + IORB
            DO JORB = 1, NTOOBS(JSM)
              JABS = JOFF -1 + JORB
C?            write(6,*) ' IORB JORB IABS JABS ',IORB,JORB,IABS,JABS
              IF(ISM.GT.JSM) THEN
                INDEX = (IORB-1)*NTOOBS(JSM) + JORB
              ELSE IF(ISM.EQ.JSM) THEN
                IF(IORB.GE.JORB) THEN
                  INDEX = IORB*(IORB-1)/2 + JORB
                ELSE
                  INDEX = JORB*(JORB-1)/2 + IORB
                END IF
              ELSE IF(ISM.LT.JSM) THEN
                INDEX = (JORB-1)*NTOOBS(ISM) + IORB
              END IF
              INDEX_NOCCSYM = (IORB-1)*NTOOBS(JSM) + JORB
              IORBINH1(IABS,JABS) = INDEX
              IORBINH1_NOCCSYM(IABS,JABS) = INDEX_NOCCSYM
            END DO
          END DO
*. End of loops over orbital indeces
        END DO
      END DO
*. End of loop over orbital symmetries
*
      NTEST = 000
      IF(NTEST .GE. 100 ) THEN
        WRITE(6,*) ' IORBINH1 matrix delivered from ORBINH1'
        CALL IWRTMA(IORBINH1,NTOOB,NTOOB,NTOOB,NTOOB)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoMP2_BackTra(iTyp,COcc,CVir,BaseName_AO,DoDiag,Diag)
!
! Thomas Bondo Pedersen, Dec. 2007.
!
! Purpose: Backtransform MO vectors to AO basis.
!          The result vectors are stored in lower triangular
!          storage.
!
! Note: do not call this routine directly; use ChoMP2_VectorMO2AO()
!       instead !!

use Symmetry_Info, only: Mul
use Cholesky, only: nBas, nSym
use ChoMP2, only: iAOVir, iT1am, iT1AOT, lUnit_F, nMP2Vec, nOcc, nT1am, nT1AOT, nVir
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iTyp
real(kind=wp), intent(in) :: COcc(*), CVir(*)
character(len=3), intent(in) :: BaseName_AO
logical(kind=iwp), intent(in) :: DoDiag
real(kind=wp), intent(_OUT_) :: Diag(*)
integer(kind=iwp) :: AlBe, iAB(8,8), iAdr, iOpt, iSym, iSyma, iSymAl, iSymb, iSymBe, iSymi, iVec, kAOVec, kCOcc, kCVir, kD, kDiag, &
                     kMOVec, kTemp, l_Buf, lU_AO, lVec, MaxInCore, na, nAB(8), nAB_Tot, nAl, ni, nVecInCore, nVecOnDisk
character(len=4) :: FullName_AO
real(kind=wp), allocatable :: AOVec(:), Buf(:), MOVec(:), Temp(:)
character(len=*), parameter :: SecNam = 'ChoMP2_BackTra'

! Set up index arrays.
! --------------------

iAB(:,:) = 0
nAB_Tot = 0
do iSym=1,nSym
  nAB(iSym) = 0
  do iSymb=1,nSym
    iSyma = Mul(iSymb,iSym)
    iAB(iSyma,iSymb) = nAB(iSym)
    nAB(iSym) = nAB(iSym)+nBas(iSyma)*nBas(iSymb)
  end do
  nAB_Tot = nAB_Tot+nAB(iSym)
end do

! Backtransform.
! --------------

if (DoDiag) Diag(1:nAB_Tot) = Zero

kDiag = 0
do iSym=1,nSym

  if ((nAB(iSym) >= 1) .and. (nMP2Vec(iSym) >= 1)) then

    iOpt = 1
    call ChoMP2_OpenF(iOpt,iTyp,iSym)
    write(FullName_AO,'(A3,I1)') BaseName_AO,iSym
    lU_AO = 7
    call daName_MF_WA(lU_AO,FullName_AO)

    call mma_allocate(AOVec,nAB(iSym),Label='AOVec')
    call mma_allocate(Temp,nT1AOT(iSym),Label='Temp')
    call mma_allocate(MOVec,nT1Am(iSym),Label='MOVec')

    call mma_maxDBLE(l_Buf)
    if (l_Buf < nAB(iSym)) then
      call SysAbendMsg(SecNam,'Insufficient memory!',' ')
    else
      call mma_allocate(Buf,l_Buf,Label='Buf')
    end if
    MaxInCore = min(l_Buf/nAB(iSym),nMP2Vec(iSym))

    nVecOnDisk = 0
    nVecInCore = 0
    do iVec=1,nMP2Vec(iSym)

      iOpt = 2
      iAdr = nT1Am(iSym)*(iVec-1)+1
      lVec = nT1Am(iSym)
      call ddaFile(lUnit_F(iSym,iTyp),iOpt,MOVec,lVec,iAdr)

      do iSymi=1,nSym
        iSyma = Mul(iSymi,iSym)
        iSymAl = iSyma
        kCVir = iAOVir(iSymAl,iSyma)+1
        kMOVec = 1+iT1Am(iSyma,iSymi)
        kTemp = 1+iT1AOT(iSymi,iSymAl)
        na = max(nVir(iSyma),1)
        nAl = max(nBas(iSymAl),1)
        ni = max(nOcc(iSymi),1)
        call DGEMM_('T','T',nOcc(iSymi),nBas(iSymAl),nVir(iSyma),One,MOVec(kMOVec),na,CVir(kCVir),nAl,Zero,Temp(kTemp),ni)
      end do

      do iSymBe=1,nSym
        iSymAl = Mul(iSymBe,iSym)
        iSymi = iSymBe
        kTemp = 1+iT1AOT(iSymi,iSymAl)
        kCOcc = iT1AOT(iSymi,iSymBe)+1
        kAOVec = 1+iAB(iSymAl,iSymBe)
        ni = max(nOcc(iSymi),1)
        nAl = max(nBas(iSymAl),1)
        call DGEMM_('T','N',nBas(iSymAl),nBas(iSymBe),nOcc(iSymi),One,Temp(kTemp),ni,COcc(kCOcc),ni,Zero,AOVec(kAOVec),nAl)
      end do

      if (DoDiag) then
        do AlBe=1,nAB(iSym)
          kD = kDiag+AlBe
          Diag(kD) = Diag(kD)+AOVec(AlBe)**2
        end do
      end if

      call dCopy_(nAB(iSym),AOVec,1,Buf(1+nVecInCore),MaxInCore)
      nVecInCore = nVecInCore+1

      if ((nVecInCore == MaxInCore) .or. (iVec == nMP2Vec(iSym))) then
        do AlBe=1,nAB(iSym)
          iOpt = 1
          iAdr = nMP2Vec(iSym)*(AlBe-1)+nVecOnDisk+1
          lVec = nVecInCore
          call ddaFile(lU_AO,iOpt,Buf(1+MaxInCore*(AlBe-1)),lVec,iAdr)
        end do
        nVecOnDisk = nVecOnDisk+nVecInCore
        nVecInCore = 0
      end if

    end do
#   ifdef _DEBUGPRINT_
    if ((nVecOnDisk /= nMP2Vec(iSym)) .or. (nVecInCore /= 0)) call SysAbendMsg(SecNam,'Logical bug detected!',' [1]')
#   endif

    call mma_deallocate(Buf)
    call mma_deallocate(MOVec)
    call mma_deallocate(Temp)
    call mma_deallocate(AOVec)

    call daClos(lU_AO)
    iOpt = 2
    call ChoMP2_OpenF(iOpt,iTyp,iSym)

  end if

  ! cycle loop point

  if (DoDiag) kDiag = kDiag+nAB(iSym)

end do

end subroutine ChoMP2_BackTra

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

#include "compiler_features.h"
#ifdef _MOLCAS_MPP_

subroutine CLagDXC_FG3_MPP(ISYM,NASHT,NG3,lg_BDER,lg_SDER,DG1,DG2,DG3,DF1,DF2,DF3,DEPSA,G2,idxG3)

use Symmetry_Info, only: Mul
use SUPERINDEX, only: KTUV
use Para_Info, only: Is_Real_Par, nProcs
use caspt2_module, only: EPSA, IASYM, NTUVES
use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp, byte, RtoB

implicit none
integer(kind=iwp), intent(in) :: ISYM, NASHT, NG3, lg_BDER, lg_SDER
real(kind=wp), intent(inout) :: DG1(NASHT,NASHT), DG2(NASHT,NASHT,NASHT,NASHT), DG3(NG3), DF1(NASHT,NASHT), &
                                DF2(NASHT,NASHT,NASHT,NASHT), DF3(NG3), DEPSA(NASHT,NASHT)
real(kind=wp), intent(in) :: G2(NASHT,NASHT,NASHT,NASHT)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: IBLOCK, ICOL, iG3, IG3END, IG3STA, IROW, iscal, iST, iSU, iSV, iSX, iSY, iSZ, iT, iTU, ituvs, iU, iV, iVX, &
                     iX, ixyzs, iY, iYZ, iZ, jSym, MAXBUF, MAXMEM, NBLOCKS, NBUF, NELB, NELS, NG3B, NG3MAX, NtotELB, NtotELS
real(kind=wp) :: F3VAL, G3VAL
integer(kind=iwp), allocatable :: INDI(:), INDJ(:), NELBsav(:), NELSsav(:)
real(kind=wp), allocatable :: BUFFB(:), BUFFS(:)

! Since we are stuck with collective calls to MPI_Alltoallv in
! order to gather the elements, each process needs to loop over
! the same number of blocks.
NG3MAX = NG3
call GAIGOP_SCAL(NG3MAX,'max')
if (NG3MAX == 0) return

! The global SC matrix has already been allocated, so we need to
! find out how much memory is left for buffering (4 equally sized
! buffers for sending and receiving values and indices)
call mma_MaxDBLE(MAXMEM)
! we need two real and two integer values per element
iscal = (iwp*2+wp*2)/RtoB
!MAXBUF = min(nint(0.95_wp*MAXMEM)/4,2000000000/8)
MAXBUF = min(nint(0.95_wp*MAXMEM,kind=iwp)/iscal,2000000000/8)
MAXBUF = MAXBUF-2*NG3 !! for NELBsav and NELSsav

! Loop over blocks NG3B of NG3, so that 12*NG3B < MAXBUF/NPROCS.
! This guarantees that e.g. if all processes send all their data
! to one other, that process receives NPROCS*NG3B*12 elements
! in the receive buffer.
NG3B = MAXBUF/(NPROCS*16) !! originally 12, but not sure why
NG3B = min(NG3B,NG3MAX)
call GAIGOP_SCAL(NG3B,'min')
NBUF = 16*NG3B

call mma_allocate(BUFFB,NBUF,Label='BUFFB')
call mma_allocate(BUFFS,NBUF,Label='BUFFS')
call mma_allocate(INDI,NBUF,Label='INDI')
call mma_allocate(INDJ,NBUF,Label='INDJ')

NBLOCKS = (NG3MAX-1)/NG3B+1
do IBLOCK=1,NBLOCKS
  IG3STA = 1+(IBLOCK-1)*NG3B
  IG3END = min(IG3STA+NG3B-1,NG3)
  call mma_allocate(NELBsav,IG3END-IG3STA+1,Label='NELBsav')
  call mma_allocate(NELSsav,IG3END-IG3STA+1,Label='NELSsav')

  ! Second pass fills the buffers with values and indices
  NtotELB = 0 ! Number of total elements of BDER
  NtotELS = 0 ! Number of total elements of SDER
  do iG3=IG3STA,IG3END
    NELB = 0 ! Number of elements of BDER for iG3
    NELS = 0 ! Number of elements of SDER for iG3
    iT = idxG3(1,iG3)
    iU = idxG3(2,iG3)
    iV = idxG3(3,iG3)
    iX = idxG3(4,iG3)
    iY = idxG3(5,iG3)
    iZ = idxG3(6,iG3)
    iST = IASYM(iT)
    iSU = IASYM(iU)
    iSV = IASYM(iV)
    iSX = IASYM(iX)
    iSY = IASYM(iY)
    iSZ = IASYM(iZ)
    ituvs = Mul(IST,Mul(ISU,ISV))
    ixyzs = Mul(ISX,Mul(ISY,ISZ))
    if (ituvs == ixyzs) then
      iTU = iT+NASHT*(iU-1)
      iVX = iV+NASHT*(iX-1)
      iYZ = iY+NASHT*(iZ-1)
      !F3VAL = F3(iG3)
      !-SVC20100829: 12 equivalent cases, of which the second
      !  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
      !  - F(tuvxyz) -> BC(vut,xyz)
      jSYM = Mul(IASYM(iV),Mul(IASYM(iU),IASYM(iT)))
      if (jSYM == iSYM) then
        IROW = KTUV(iV,iU,iT)-nTUVES(jSYM)
        ICOL = KTUV(iX,iY,iZ)-nTUVES(jSYM)
        NELB = NELB+1
        NtotELB = NtotELB+1
        INDI(NtotELB) = IROW
        INDJ(NtotELB) = ICOL
      end if
      if ((iTU /= iVX) .or. (iVX /= iYZ)) then
        if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
          !  - F(vxtuyz) -> BC(txv,uyz)
          jSYM = Mul(IASYM(iT),Mul(IASYM(iX),IASYM(iV)))
          if (jSYM == iSYM) then
            IROW = KTUV(iT,iX,iV)-nTUVES(jSYM)
            ICOL = KTUV(iU,iY,iZ)-nTUVES(jSYM)
            NELB = NELB+1
            NtotELB = NtotELB+1
            INDI(NtotELB) = IROW
            INDJ(NtotELB) = ICOL
          end if
          !  - F(yzvxtu) -> BC(vzy,xtu)
          jSYM = Mul(IASYM(iV),Mul(IASYM(iZ),IASYM(iY)))
          if (jSYM == iSYM) then
            IROW = KTUV(iV,iZ,iY)-nTUVES(jSYM)
            ICOL = KTUV(iX,iT,iU)-nTUVES(jSYM)
            NELB = NELB+1
            NtotELB = NtotELB+1
            INDI(NtotELB) = IROW
            INDJ(NtotELB) = ICOL
          end if
          !  - F(tuyzvx) -> BC(yut,zvx)
          jSYM = Mul(IASYM(iY),Mul(IASYM(iU),IASYM(iT)))
          if (jSYM == iSYM) then
            IROW = KTUV(iY,iU,iT)-nTUVES(jSYM)
            ICOL = KTUV(iZ,iV,iX)-nTUVES(jSYM)
            NELB = NELB+1
            NtotELB = NtotELB+1
            INDI(NtotELB) = IROW
            INDJ(NtotELB) = ICOL
          end if
        end if
        !  - F(yztuvx) -> BC(tzy,uvx)
        jSYM = Mul(IASYM(iT),Mul(IASYM(iZ),IASYM(iY)))
        if (jSYM == iSYM) then
          IROW = KTUV(iT,iZ,iY)-nTUVES(jSYM)
          ICOL = KTUV(iU,iV,iX)-nTUVES(jSYM)
          NELB = NELB+1
          NtotELB = NtotELB+1
          INDI(NtotELB) = IROW
          INDJ(NtotELB) = ICOL
        end if
        !  - F(vxyztu) -> BC(yxv,ztu)
        jSYM = Mul(IASYM(iY),Mul(IASYM(iX),IASYM(iV)))
        if (jSYM == iSYM) then
          IROW = KTUV(iY,iX,iV)-nTUVES(jSYM)
          ICOL = KTUV(iZ,iT,iU)-nTUVES(jSYM)
          NELB = NELB+1
          NtotELB = NtotELB+1
          INDI(NtotELB) = IROW
          INDJ(NtotELB) = ICOL
        end if
      end if
      if (((iT /= iU) .or. (iV /= iX) .or. (iY /= iZ)) .and. ((iT /= iU) .or. (iV /= iZ) .or. (iX /= iY)) .and. &
          ((iX /= iV) .or. (iT /= iZ) .or. (iU /= iY)) .and. ((iZ /= iY) .or. (iV /= iU) .or. (iX /= iT))) then
        !  - F(utxvzy) -> BC(xtu,vzy)
        jSYM = Mul(IASYM(iX),Mul(IASYM(iT),IASYM(iU)))
        if (jSYM == iSYM) then
          IROW = KTUV(iX,iT,iU)-nTUVES(jSYM)
          ICOL = KTUV(iV,iZ,iY)-nTUVES(jSYM)
          NELB = NELB+1
          NtotELB = NtotELB+1
          INDI(NtotELB) = IROW
          INDJ(NtotELB) = ICOL
        end if
        if ((iTU /= iVX) .or. (iVX /= iYZ)) then
          if ((iTU /= iVX) .and. (iTU /= iYZ) .and. (iVX /= iYZ)) then
            !  - F(xvutzy) -> BC(uvx,tzy)
            jSYM = Mul(IASYM(iU),Mul(IASYM(iV),IASYM(iX)))
            if (jSYM == iSYM) then
              IROW = KTUV(iU,iV,iX)-nTUVES(jSYM)
              ICOL = KTUV(iT,iZ,iY)-nTUVES(jSYM)
              NELB = NELB+1
              NtotELB = NtotELB+1
              INDI(NtotELB) = IROW
              INDJ(NtotELB) = ICOL
            end if
            !  - F(zyxvut) -> BC(xyz,vut)
            jSYM = Mul(IASYM(iX),Mul(IASYM(iY),IASYM(iZ)))
            if (jSYM == iSYM) then
              IROW = KTUV(iX,iY,iZ)-nTUVES(jSYM)
              ICOL = KTUV(iV,iU,iT)-nTUVES(jSYM)
              NELB = NELB+1
              NtotELB = NtotELB+1
              INDI(NtotELB) = IROW
              INDJ(NtotELB) = ICOL
            end if
            !  - F(utzyxv) -> BC(ztu,yxv)
            jSYM = Mul(IASYM(iZ),Mul(IASYM(iT),IASYM(iU)))
            if (jSYM == iSYM) then
              IROW = KTUV(iZ,iT,iU)-nTUVES(jSYM)
              ICOL = KTUV(iY,iX,iV)-nTUVES(jSYM)
              NELB = NELB+1
              NtotELB = NtotELB+1
              INDI(NtotELB) = IROW
              INDJ(NtotELB) = ICOL
            end if
          end if
          !  - F(zyutxv) -> BC(uyz,txv)
          jSYM = Mul(IASYM(iU),Mul(IASYM(iY),IASYM(iZ)))
          if (jSYM == iSYM) then
            IROW = KTUV(iU,iY,iZ)-nTUVES(jSYM)
            ICOL = KTUV(iT,iX,iV)-nTUVES(jSYM)
            NELB = NELB+1
            NtotELB = NtotELB+1
            INDI(NtotELB) = IROW
            INDJ(NtotELB) = ICOL
          end if
          !  - F(xvzyut) -> BC(zvx,yut)
          jSYM = Mul(IASYM(iZ),Mul(IASYM(iV),IASYM(iX)))
          if (jSYM == iSYM) then
            IROW = KTUV(iZ,iV,iX)-nTUVES(jSYM)
            ICOL = KTUV(iY,iU,iT)-nTUVES(jSYM)
            NELB = NELB+1
            NtotELB = NtotELB+1
            INDI(NtotELB) = IROW
            INDJ(NtotELB) = ICOL
          end if
        end if
      end if
    end if
    nels = nelb
    NELBsav(iG3-IG3STA+1) = NELB
    NELSsav(iG3-IG3STA+1) = NELS
  end do
  ntotels = ntotelb

  call GA_GATHER(lg_BDER,BUFFB,INDI,INDJ,NtotELB)
  call GA_GATHER(lg_SDER,BUFFS,INDI,INDJ,NtotELS)

  ! Finally, fill the local chunk of the SC matrix (block of rows)
  ! with the received values at their appropriate place.
  NtotELB = 0
  NtotELS = 0
  do iG3=IG3STA,IG3END
    iT = idxG3(1,iG3)
    iU = idxG3(2,iG3)
    iV = idxG3(3,iG3)
    iX = idxG3(4,iG3)
    iY = idxG3(5,iG3)
    iZ = idxG3(6,iG3)
    NELB = NELBsav(iG3-IG3STA+1)
    NELS = NELSsav(iG3-IG3STA+1)

    F3VAL = sum(BUFFB(NtotELB+1:NtotELB+NELB))
    NtotELB = NtotELB+NELB
    !BUFFB(iG3-IG3STA+1) = F3VAL

    G3VAL = sum(BUFFS(NtotELS+1:NtotELS+NELS))-(EPSA(iU)+EPSA(iY))*F3VAL
    NtotELS = NtotELS+NELS

    DF3(iG3) = DF3(iG3)+F3VAL
    DG3(iG3) = DG3(iG3)+G3VAL

    !! do depsa
    !ISUP = KTUV(iV,iU,iT)-nTUVES(iSYM)
    !if ((ISUP >= iLo) .and. (ISUP <= iHi)) then
    !  do iW=1,nAshT
    !    JSUP = KTUV(iX,iW,iZ)-nTUVES(iSYM)
    !    NSEQ = 1+ISUP-iLo+LDA*(JSUP-jLo)
    !    DEPSA(iW,iY) = DEPSA(iW,iY)-F3VAL*SC(ISUP-iLo,JSUP)
    !  end do
    !end if

     !! remaining F3 and G3 transformation in mkfg3
    if (iY == iX) then
      DF2(iT,iU,iV,iZ) = DF2(iT,iU,iV,iZ)-F3VAL
      DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ)-EPSA(iU)*F3VAL
      DEPSA(iU,:) = DEPSA(iU,:)-F3VAL*G2(iT,:,iV,iZ)
      DG2(iT,iU,iV,iZ) = DG2(iT,iU,iV,iZ)-G3VAL
    end if
    if (iV == iU) then
      DF2(iT,iX,iY,iZ) = DF2(iT,iX,iY,iZ)-F3VAL
      DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ)-EPSA(iY)*F3VAL
      DEPSA(:,iY) = DEPSA(:,iY)-F3VAL*G2(iT,iX,:,iZ)
      DG2(iT,iX,iY,iZ) = DG2(iT,iX,iY,iZ)-G3VAL
    end if
    if (iY == iU) then
      DF2(iV,iX,iT,iZ) = DF2(iV,iX,iT,iZ)-F3VAL
      DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ)-EPSA(iU)*F3VAL
      DG2(iV,iX,iT,iZ) = DG2(iV,iX,iT,iZ)-G3VAL
    end if
    DEPSA(iY,iU) = DEPSA(iY,iU)-F3VAL*G2(iV,iX,iT,iZ)
    if ((iY == iX) .and. (iV == iU)) then
      DF1(iT,iZ) = DF1(iT,iZ)-F3VAL
      DG1(iT,iZ) = DG1(iT,iZ)-G3VAL
    end if
  end do

  call mma_deallocate(NELBsav)
  call mma_deallocate(NELSsav)
end do ! end loop over blocks of G3 values

call mma_deallocate(BUFFB)
call mma_deallocate(BUFFS)
call mma_deallocate(INDI)
call mma_deallocate(INDJ)

return

end subroutine CLagDXC_FG3_MPP

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(CLagDXC_FG3_MPP)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MakeWw (Ww,W1,W2,aSGrp,bSGrp,beSGrp,gaSGrp,key)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c                                     and W2(b",be",a",ga")
c        where index ab" is always a">b" (not a"=b")
c        and   index bega" is be">=ga" for W+ and be">ga" for W-
c       for all cases aSGrp >= bSGrp
c       N.B. for a"=b" W2 is not used (although it is passed through
c            the header (because of uniform shape) but no matter what
c            is there)
c       N.B. rutinky MakeWwHlpx niesu prilis vymakane @
c
c       parameter description:
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       W2     - array for W1(b",be",a",ga") (I)
c       xSGrp  - SubGroup of a",b",be",ga" (I)
c       key    - 1 - calc Ww+, 2 - calc Ww- (I)
c
        implicit none
#include "chcc1.fh"
#include "o2v4.fh"
c
        real*8 Ww(1)
        real*8 W1(1)
        real*8 W2(1)
        integer aSGrp,bSGrp,beSGrp,gaSGrp,key
c
c       help variables
        integer dimbe,dimga,dimbega,dima,dimb,dimab
c
c
c1      def dimensions
c
        dimbe=DimSGrpbe(beSGrp)
        dimga=DimSGrpbe(gaSGrp)
        dima=DimSGrpa(aSGrp)
        dimb=DimSGrpa(bSGrp)
c
        if (beSGrp.eq.gaSGrp) then
          if (key.eq.1) then
            dimbega=dimbe*(dimbe+1)/2
          else
            dimbega=dimbe*(dimbe-1)/2
          end if
        else
          dimbega=dimbe*dimga
        end if
c
        if (aSGrp.eq.bSGrp) then
          dimab=dima*(dima-1)/2
        else
          dimab=dima*dimb
        end if
c
c
c2      Make Ww matrix
c
        if (aSGrp.eq.bSGrp) then
          if (beSGrp.eq.gaSGrp) then
            call MakeWwHlp1 (Ww(1),W1(1),
     c                       dima,dimb,dimab,dimbe,dimga,dimbega,key)
          else
            call MakeWwHlp2 (Ww(1),W1(1),
     c                       dima,dimb,dimab,dimbe,dimga,key)
          end if
        else
          if (beSGrp.eq.gaSGrp) then
            call MakeWwHlp3 (Ww(1),W1(1),W2(1),
     c                       dima,dimb,dimbe,dimga,dimbega,key)
          else
            call MakeWwHlp4 (Ww(1),W1(1),W2(1),
     c                       dima,dimb,dimbe,dimga,key)
          end if
        end if
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
function IOFF_SYM_DIST(ISYM,NGASL,IOFF,MXVAL,MNVAL)
! A ts block of string is given and the individual
! symmetrydisrtributions has been obtained (for example
! by TS_SYM_PNT)
!
! Obtain offset for symmetrycombination defined by ISYM

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IOFF_SYM_DIST
integer(kind=iwp), intent(in) :: NGASL, ISYM(NGASL), IOFF(*), MXVAL(NGASL), MNVAL(NGASL)
integer(kind=iwp) :: I, IGAS, IMULT
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: J
#endif

! Address in IOFF is
!     1
!     +  (ISM1-MNVAL(1))
!     +  (ISM2-MNVAL(2))*(MXVAL(1)-MNVAL(1)+1)
!     +  (ISM3-MNVAL(3))*(MXVAL(1)-MNVAL(1)+1)*(MXVAL(2)-MNVAL(2)+1)
!     +  ...
!     +  (ISM L-1-MNVAL(L-1))*Prod(i=1,L-2)(MXVAL(i)-MNVAL(i)+1)

#ifdef _DEBUGPRINT_
write(u6,*) ' Isym, mnval, ioff:'
call iwrtma(isym,1,ngasl,1,ngasl)
call iwrtma(MNVAL,1,ngasl,1,ngasl)
call iwrtma(ioff,1,ngasl,1,ngasl)
#endif
! Offset for this symmetry distribution in IOFFI
I = 1
IMULT = 1
do IGAS=1,NGASL-1
  I = I+(ISYM(IGAS)-MNVAL(IGAS))*IMULT
  IMULT = IMULT*(MXVAL(IGAS)-MNVAL(IGAS)+1)
  !write(u6,*) ' igas,i,imult ',igas,i,imult
end do
! The following IF block is needed for avoinging going outside the IOFF bounds.
! This is possible for certain GAS setups. Test 897 helped in finding this issue.
if (I <= 0) then
  IOFF_SYM_DIST = 0
else
  IOFF_SYM_DIST = IOFF(I)
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Info from IOFF_SYM_DIST'
write(u6,*) ' ======================='
write(u6,*)
write(u6,*) ' Address and offset ',I,IOFF_SYM_DIST
write(u6,*) ' Symmetry distribution : ',(ISYM(J),J=1,NGASL)
#endif

end function IOFF_SYM_DIST

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993,2000, Markus P. Fuelscher                         *
************************************************************************
      Subroutine R8LEN(iOpt,nData,Buf,iLen)
************************************************************************
*                                                                      *
*     Subroutine R8Len                                                 *
*                                                                      *
*     purpose: compute the packed size of a double precision           *
*              floating point number                                   *
*                                                                      *
*    Calling parameters:                                               *
*    iOpt  : Bit switch                                                *
*            bits 0-3 used for packing algorithm                       *
*    nData : number of data elements                                   *
*    Buf   : buffer containing the data                                *
*    iLen  : buffer containing the packed length                       *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    PkCtl : Packing table                                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and P. O. Widmark                                 *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     replacement of packing routines                                  *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 2000                                 *
*                                                                      *
************************************************************************
#include "PkCtl.fh"

#include "SysDef.fh"
*
      Integer nData
      Integer iLen(*)
      Real*8  Buf(*)
*
*----------------------------------------------------------------------*
*
      If (.not.Pack) Then
         Call ICOPY(nData,[RtoB],0,iLen,1)
      Else
*        Call ERIlen(nData,PkThrs,Buf,iLen)
         Kase=iAnd(iOpt,15)
         If(Kase.eq.0) Then
            Call tcl_r8(Buf,nData, iLen, PkThrs,Init_do_setup_l)
            Init_do_setup_l=0
         Else
            iZero=8
            call iCopy(nData,[8],0,iLen,1)
            Do i=1,nData
               If(Abs(Buf(i)).lt.PkThrs) Then
                  iLen(i)=iZero
                  iZero=0
               Else
c                  iLen(i)=8
                  iZero=8
               End If
            End Do
         End If
      End If
*
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************

*>  @brief
*>  Transform the inactive one-body density from MO to AO basis
*>
*>  @author
*>  Markus P. Fuelscher
*>
*>  @details
*>  The underlying equation is the basis transformatin:
*>  \f[ D^{\text{AO}} = C D C^\dagger \f]
*>  For inactive orbitals it simplifies to:
*>  \f[D^{\text{AO}, I} = C^I D^I (C^I)^\dagger = 2 C^I \mathbf{1} (C^I)^\dagger = 2 C (C^I)^\dagger \f]
*>  Where (\f$ C^I, D^I \f$) are the coefficients and densities of the inactive MOs.
*>
*>  @param[in] CMO The MO-coefficients
*>  @param[out] D1I_AO The inactive one-body density matrix in AO-space
      Subroutine Get_D1I_RASSCF(CMO, D1I_AO)
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      use general_data, only : nBas, nSym, nFro, nIsh
      implicit none
      real*8, intent(in) :: CMO(*)
      real*8, intent(out) :: D1I_AO(*)
      real*8, parameter :: Zero = 0.0d0, Two = 2.0d0
      integer :: ista, iSym, nb, nbsq, nfi


      ista=1
      do isym=1,nsym
        nb=nbas(isym)
        nbsq=nb**2
        nfi=nfro(isym)+nish(isym)
        if(nb.gt.0) then
          call dcopy_(nbsq,[0.0d0],0,d1i_AO(ista),1)
          if(nfi.gt.0) then
            call DGEMM_('n','t',nb,nb,nfi,two,
     &           cmo(ista),nb,cmo(ista),nb,zero,d1i_AO(ista),nb)
          end if
          ista=ista+nbsq
        end if
      end do


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Diff_Aux

! This module contains a single function, to avoid explicit interfaces

implicit none
private

public :: Diff_Aux1

contains

subroutine Diff_Aux1(nEPotPoints,EPCo,nB,OneFile)

  use Index_Functions, only: nTri_Elem
  use OneDat, only: sOpSiz
  use stdalloc, only: mma_allocate, mma_deallocate
  use Definitions, only: wp, iwp, u6

  integer(kind=iwp), intent(out) :: nEPotPoints
  real(kind=wp), allocatable, intent(out) :: EPCo(:,:)
  integer(kind=iwp), intent(in) :: nB
  character(len=10), intent(in) :: OneFile
  character(len=10) :: Label
  integer(kind=iwp) :: i, iComp, iopt, irc, iSmLbl, Lu_One, maxCen, n_int(1)
  real(kind=wp), allocatable :: idiot(:), Tmp(:,:)
  integer(kind=iwp), external :: IsFreeUnit

# include "warnings.h"

  ! Open One-electron file.

  irc = -1
  Lu_One = IsFreeUnit(49)
  iopt = 0
  call OpnOne(irc,iopt,OneFile,Lu_One)
  if (irc /= 0) then
    write(u6,*)
    write(u6,*) 'ERROR! Could not open one-electron integral file.'
    call Quit(_RC_IO_ERROR_READ_)
  end if

  ! Loop over all EF0, terminate when return-code is non-zero.

  nEPotPoints = 0
  maxCen = 99999
  call mma_allocate(Tmp,3,maxCen,label='Temporary')
  call mma_allocate(idiot,nTri_Elem(nB)+4,label='Idiot')
  do i=1,maxCen
    write(Label,'(A3,I5)') 'EF0',i
    irc = -1
    iopt = ibset(0,sOpSiz)
    iSmLbl = 0
    iComp = 1
    call iRdOne(irc,iopt,label,iComp,n_Int,iSmLbl)
    if (irc /= 0) exit
    irc = -1
    iopt = 0
    iSmLbl = 0
    call RdOne(irc,iopt,label,iComp,idiot,iSmLbl)
    Tmp(:,i) = idiot(n_int(1)+1:n_int(1)+3)
    nEPotPoints = nEPotPoints+1
  end do

  ! Put the coordinates and nuclear part in nice and tight vectors.

  call mma_allocate(EPCo,3,nEPotPoints,label='PotPointCoord')
  EPCo(:,:) = Tmp(:,1:nEPotPoints)

  ! Deallocate.

  call mma_deallocate(Tmp)
  call mma_deallocate(idiot)

  return

end subroutine Diff_Aux1

end module Diff_Aux

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

function irAmax(n,a,inc)
! Finds the index of element having max. absolute value.
!
! Author:  F. Aquilante

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: irAmax
integer(kind=iwp), intent(in) :: n, inc
real(kind=wp), intent(in) :: a(*)
integer(kind=iwp) :: i, ix
real(kind=wp) :: smax

iramax = 0
if ((n < 1) .or. (inc <= 0)) return
iramax = 1
if (n == 1) return

if (inc /= 1) then

  ! code for increment not equal to 1

  ix = 1
  smax = abs(a(1))
  ix = ix+inc
  do i=2,n
    if (abs(a(ix)) > smax) then
      iramax = i
      smax = abs(a(ix))
    end if
    ix = ix+inc
  end do

else

  ! code for increment equal to 1

  smax = abs(a(1))
  do i=2,n
    if (abs(a(i)) > smax) then
      iramax = i
      smax = abs(a(i))
    end if
  end do

end if

return

end function irAmax

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3addpck(wrk,wrksize,nind,typap,a,b,ns,szkey,rc)
! nind  - # of indices in matrices A,B (Input)
! typap - typ of operation (see Table) (Input)
! a     - A (Input)
! b     - B (Input)
! ns    - signum of the operation (+-1) (Input)
! szkey - zet zero key (I)
!         = 0 no vanishing
!         = 1 set B=0 at the beginning
! rc    - return (error) code (Output)
!
! this routine is an addition to CCSD add/pack routine. It does not
! realize operations which are done there (add/pack), but only
! additional ones, required in T3 code, namely:
!
! Operation                                   Nind TypA TypB typap
! B(pqr)  = B + ns*(A(qr,p)-A(pr,q)+A(pq,r))    3    1    5    1
! B(pq,r) = B + ns*(A(q,r,p)-A(p,r,q))          3    1    1    2
! B(p,qr) = B + ns*(     -A(p,r,q)+A(p,q,r))    3    1    2    3
!
! N.B. typab is redundant, it can be determined from mapd's

use CCT3_global, only: dimm, Map_Type
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, nind, typap, ns, szkey
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: a, b
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp) :: dima, dimb, dimc, ia1, ia2, ia3, ib, nhelp1, nhelp2, posa1, posa2, posa3, posb, syma, symb, symc

!0 some tests

if (nind /= 3) then
  ! RC=1 : nind is not 3 (NCI)
  rc = 1
  return
end if

if ((typap == 1) .and. ((a%d(0,6) /= 1) .and. (b%d(0,6) /= 5))) then
  ! RC=2 : typap=1, typA=1, and typB is not 5 (Stup)
  rc = 2
  return
end if

if ((typap == 2) .and. ((a%d(0,6) /= 0) .and. (b%d(0,6) /= 1))) then
  ! RC=3 : typap=2, typA=0, and typB is not 1 (Stup)
  rc = 3
  return
end if

if ((typap == 3) .and. ((a%d(0,6) /= 0) .and. (b%d(0,6) /= 2))) then
  ! RC=4 : typap=3, typA=0, and typB is not 2 (Stup)
  rc = 4
  return
end if

if (typap == 1) then
  !1 case B(pqr) = B(pqr) + ns*(A(qr,p)-A(pr,q)+A(pq,r))

  do ib=1,b%d(0,5)

    !1.* def position of b
    posb = b%d(ib,1)

    !1.* def symmetry status
    syma = b%d(ib,3)
    symb = b%d(ib,4)
    symc = b%d(ib,5)

    !1.* def dimensions
    dima = dimm(b%d(0,1),syma)
    dimb = dimm(b%d(0,2),symb)
    dimc = dimm(b%d(0,3),symc)

    !1.* realize packing

    if (syma == symc) then
      !1.a case syma=symb=symc

      !1.a.* find address for a1,2,3 (the same one)
      ia1 = a%i(symb,symc,1)

      !1.a.* def position of a1,2,3 (the same one)
      posa1 = a%d(ia1,1)

      !1.a.* def additional dimensions ab,abc
      nhelp1 = dima*(dima-1)/2
      nhelp2 = dima*(dima-1)*(dima-2)/6

      !1.a.* do packing
      call t3aphlp4(wrk(posa1),wrk(posb),dima,nhelp1,nhelp2,ns,szkey)

    else if (syma == symb) then
      !1.b case syma=symb/=symc

      !1.b.* find address for a1,2,3
      ia1 = a%i(symb,symc,1)
      ia2 = a%i(syma,symc,1)
      ia3 = a%i(syma,symb,1)

      !1.b.* def position of a1,2,3
      posa1 = a%d(ia1,1)
      posa2 = a%d(ia2,1)
      posa3 = a%d(ia3,1)

      !1.b.* def additional dimensions ab
      nhelp1 = dima*(dima-1)/2

      !1.b.* do packing
      call t3aphlp2(wrk(posa1),wrk(posa2),wrk(posa3),wrk(posb),dima,dimb,dimc,nhelp1,ns,szkey)

    else if (symb == symc) then
      !1.c case syma/=symb=symc

      !1.c.* find address for a1,2,3
      ia1 = a%i(symb,symc,1)
      ia2 = a%i(syma,symc,1)
      ia3 = a%i(syma,symb,1)

      !1.c.* def position of a1,2,3
      posa1 = a%d(ia1,1)
      posa2 = a%d(ia2,1)
      posa3 = a%d(ia3,1)

      !1.c.* def additional dimensions bc
      nhelp1 = dimb*(dimb-1)/2

      !1.c.* do packing
      call t3aphlp3(wrk(posa1),wrk(posa2),wrk(posa3),wrk(posb),dima,dimb,dimc,nhelp1,ns,szkey)

    else
      !1.d case syma/=symb/=symc

      !1.d.* find address for a1,2,3
      ia1 = a%i(symb,symc,1)
      ia2 = a%i(syma,symc,1)
      ia3 = a%i(syma,symb,1)

      !1.d.* def position of a1,2,3
      posa1 = a%d(ia1,1)
      posa2 = a%d(ia2,1)
      posa3 = a%d(ia3,1)

      !1.d.* do packing
      call t3aphlp1(wrk(posa1),wrk(posa2),wrk(posa3),wrk(posb),dima,dimb,dimc,ns,szkey)

    end if

  end do

else if (typap == 2) then
  !2 case B(pq,r) = B(pq,r) + ns*(A(q,r,p)-A(p,r,q))

  do ib=1,b%d(0,5)

    !2.* def position of b
    posb = b%d(ib,1)

    !2.* def symmetry status
    syma = b%d(ib,3)
    symb = b%d(ib,4)
    symc = b%d(ib,5)

    !2.* def dimensions
    dima = dimm(b%d(0,1),syma)
    dimb = dimm(b%d(0,2),symb)
    dimc = dimm(b%d(0,3),symc)

    !2.* realize packing

    if (syma == symb) then
      !2.a case syma=symb,symc

      !2.a.* find address for a1,2
      ia1 = a%i(symb,symc,1)
      ia2 = a%i(syma,symc,1)

      !2.a.* def position of a1,2,3
      posa1 = a%d(ia1,1)
      posa2 = a%d(ia2,1)

      !2.a.* def additional dimensions ab
      nhelp1 = dima*(dima-1)/2

      !2.a.* do packing
      call t3aphlp6(wrk(posa1),wrk(posa2),wrk(posb),dima,dimb,dimc,nhelp1,ns,szkey)

    else
      !2.b case syma/=symb,symc

      !2.b.* find address for a1,2
      ia1 = a%i(symb,symc,1)
      ia2 = a%i(syma,symc,1)

      !2.b.* def position of a1,2,3
      posa1 = a%d(ia1,1)
      posa2 = a%d(ia2,1)

      !2.b.* do packing
      call t3aphlp5(wrk(posa1),wrk(posa2),wrk(posb),dima,dimb,dimc,ns,szkey)

    end if

  end do

else if (typap == 3) then
  !3 case B(p,qr) = B(p,qr) + ns*(-A(p,r,q)+A(p,q,r))

  do ib=1,b%d(0,5)

    !3.* def position of b
    posb = b%d(ib,1)

    !3.* def symmetry status
    syma = b%d(ib,3)
    symb = b%d(ib,4)
    symc = b%d(ib,5)

    !3.* def dimensions
    dima = dimm(b%d(0,1),syma)
    dimb = dimm(b%d(0,2),symb)
    dimc = dimm(b%d(0,3),symc)

    !3.* realize packing

    if (symb == symc) then
      !3.a case syma,symb=symc

      !3.a.* find address for a2,3
      ia2 = a%i(syma,symc,1)
      ia3 = a%i(syma,symb,1)

      !3.a.* def position of a2,3
      posa2 = a%d(ia2,1)
      posa3 = a%d(ia3,1)

      !3.a.* def additional dimensions bc
      nhelp1 = dimb*(dimb-1)/2

      !3.a.* do packing
      call t3aphlp8(wrk(posa2),wrk(posb),dima,dimb,nhelp1,ns,szkey)

    else
      !3.b case syma,symb/=symc

      !3.b.* find address for a2,3
      ia2 = a%i(syma,symc,1)
      ia3 = a%i(syma,symb,1)

      !3.b.* def position of a2,3
      posa2 = a%d(ia2,1)
      posa3 = a%d(ia3,1)

      !3.b.* do packing
      call t3aphlp7(wrk(posa2),wrk(posa3),wrk(posb),dima,dimb,dimc,ns,szkey)

    end if

  end do

else
  ! RC=5 , typap is not 1,2,3 (NCI)
  rc = 5
  return

end if

return

end subroutine t3addpck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DISKUN2
      IMPLICIT REAL*8           (A-H,O-Z)
*
* Assign logical unit numbers for LUCIA:
*
* All file with some kind of input information  :  10 - 19
* All files containing final results            :  90 - 99
* Scratch files                                 :  40 - 59
* Internal files (retained through job)         :  60 - 69
*
#include "clunit.fh"
#include "io_util.fh"
* =========================
* Standard input and output
* =========================
*. Input file
*     LUIN = 5
*. Output file
*     LUOUT = 6
* =================
* Input information
* =================
* Input file containing MO-AO transformation matrix
      LUMOIN = 12
*. Input file for CI-vectors
*. restart from file 21 is assumed
*. Input , two electron integrals - MOLCAS
      LU2INT = 13
*. Input , one electron integrals - MOLCAS
      LU1INT = 14
*. Input , property one-electron integral files
      LUPRP  = 15
*. File containing additional states for transition densities
      LUEXC = 17
* =================
* Internal files
* =================
*. CI diagonal
      LUDIA = IsFreeUnit(18)
      CALL DANAME_WA(LUDIA,'CIDIA')
*
*. CI vector
      LUC = IsFreeUnit(Ludia)
      CALL DANAME_WA(LUC,'LUCVECT')
*
*. Sigma vector file
      LUHC = IsFreeUnit(LuC)
      CALL DANAME_WA(LUHC,'HCFILE')
*
*. File collecting CC correction vectors, used for DIIS etc
C-jwk      LU_CCVEC = 23
*. File containing approximations to the CC solutions
C-jwk      LU_CCVECT = 24
*. File containing CC vector functions for the CC vectors on LU_CCVECT
C-jwk      LU_CCVECF = 25
*. File containing Last CC coefficients
C-jwk      LU_CCVECL = 26
*. File containing Last CC vector function
C-jwk      LU_CCVECFL = 27
* =================
* Scratch files
* =================
      LUSC1 = IsFreeUnit(LuHC)
      CALL DANAME_WA(LUSC1,'LUSC1')
*
      LUSC2 = IsFreeUnit(Lusc1)
      CALL DANAME_WA(LUSC2,'LUSC2')
*
      LUSC3 = IsFreeUnit(Lusc2)
      CALL DANAME_WA(LUSC3,'LUSC3')
*
*. Scratch space for subspace handling
      LUSC34 = IsFreeUnit(Lusc3)
      CALL DANAME_WA(LUSC34,'LUSC34')
*
      LUSC35 = IsFreeUnit(Lusc34)
      CALL DANAME_WA(LUSC35,'LUSC35')
*
      LUSC36 = IsFreeUnit(Lusc35)
      CALL DANAME_WA(LUSC36,'LUSC36')
*
      LUSC37 = IsFreeUnit(Lusc36)
      CALL DANAME_WA(LUSC37,'LUSC37')
*
      LUSC38 = IsFreeUnit(Lusc37)
      CALL DANAME_WA(LUSC38,'LUSC38')
*
      LUSC39 = IsFreeUnit(Lusc38)
      CALL DANAME_WA(LUSC39,'LUSC39')
*
      LUSC40 = IsFreeUnit(Lusc39)
      CALL DANAME_WA(LUSC40,'LUSC40')
*
*.
      LUSC51 = 51
      LUSC52 = 52
      LUSC53 = 53

* =================
* Output files
* =================
*. output file for CI-vectors
*. Not in use
      LUCIVO = 98
*. Natural orbitals in terms of input orbitals
*.
      LUMOUT = IsFreeUnit(Lusc40)
      CALL DANAME_WA(LUMOUT,'LUMOUT')
*

*. Dumping 1- and 2- electron integrals in formatted form
* ( LU90 just defined here, it is not exported )
c     LU90  = 90
*. Dumping symmmetry info, MO-AO expansion matrix and property integrals
c     LU91 = 91
*. CC amplitudes in formatted form
c      LU_CCAMP = 92
*. Result of CI=> CC conversion
c      LU_CC_FROM_CI = 93
*. Excitation operators, all symmetries
c      LU_CCEXC_OP = 94
      IDISK=0
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!               Francesco Aquilante                                    *
!***********************************************************************

subroutine OneCenter_ChkDiag(Diag,l_D,Stat,DoPrint)

use Cholesky, only: iRS2F, nBasT, nnBstRT
use Molcas, only: LenIn, MaxBfn
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: l_D
real(kind=wp), intent(inout) :: Diag(l_D)
real(kind=wp), intent(out) :: Stat(7)
logical(kind=iwp), intent(in) :: DoPrint
integer(kind=iwp) :: ia, ib, krs
real(kind=wp) :: Err(4)
character(len=LenIn+8) :: BName(maxbfn)
character(len=LenIn) :: ctmp1, ctmp2
real(kind=wp), external :: dDot_

call Get_cArray('Unique Basis Names',BName,(LenIn+8)*nBasT)

do krs=1,nnBstRT(1)
  ia = iRS2F(1,krs)
  ctmp1 = BName(ia)(1:LENIN)
  ib = iRS2F(2,krs)
  ctmp2 = BName(ib)(1:LENIN)
  if (ctmp1 /= ctmp2) Diag(krs) = Zero
end do

if (DoPrint) call Cho_Head('Analysis of Difference (1-Center only)','=',80,u6)
call Statistics(Diag,l_D,Stat,1,2,3,4,5,6,7)
if (DoPrint) call Cho_PrtSt(Diag,l_D,Stat)

! Set Err array.
! --------------

Err(1) = Stat(3)
Err(2) = Stat(4)
Err(3) = Stat(1)
Err(4) = sqrt(dDot_(nnBstRT(1),Diag,1,Diag,1)/real(nnBstRT(1),kind=wp))

if (DoPrint) then
  write(u6,'(/,1X,A,ES15.6)') 'Minimum error   : ',Err(1)
  write(u6,'(1X,A,ES15.6)') 'Maximum error   : ',Err(2)
  write(u6,'(1X,A,ES15.6)') 'Average error   : ',Err(3)
  write(u6,'(1X,A,ES15.6)') 'RMS error       : ',Err(4)
end if

return

end subroutine OneCenter_ChkDiag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Print_Input(Title,nSym,nBas,wSet,nSet)

use Definitions, only: wp, iwp, u6

implicit none
character(len=72), intent(in) :: Title
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nSet
real(kind=wp), intent(in) :: wSet(nSet)
integer(kind=iwp) :: iS, iSym
integer(kind=iwp), parameter :: lPaper = 132

call Banner(Title,1,lPaper-7)
write(u6,*)
write(u6,*)
write(u6,*) 'Number of symmetries:',nSym
write(u6,*) 'Basis functions:',(nBas(iSym),iSym=1,nSym)
write(u6,*) 'Normalized weights:',(wSet(iS),iS=1,nSet)

return

end subroutine Print_Input

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKDAO(CNO,OCC,DAO)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION CNO(NCMO),OCC(NBAST),DAO(NBAST,NBAST)
      CALL FZERO(DAO,NBAST**2)
      IB=1
      ICNO=1
      DO 100 ISYM=1,NSYM
        IB1=IB
        NB=NBAS(ISYM)
        DO 10 I=1,NB
          X=OCC(IB)
          CALL DGER(NB,NB,X,CNO(ICNO),1,CNO(ICNO),1,DAO(IB1,IB1),NBAST)
          IB=IB+1
          ICNO=ICNO+NB
10      CONTINUE
100   CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Roland Lindh                                     *
************************************************************************
      Subroutine DrvNQ(Kernel,FckInt,nFckDim,Func,
     &                 Density,nFckInt,nD,
     &                 Do_Grad,Grad,nGrad,
     &                 Do_MO,Do_TwoEl,DFTFOCK)
************************************************************************
*                                                                      *
*     Predriver for numerical integration utility.                     *
*                                                                      *
*     Author: Roland Lindh,                                            *
*             Dept of Chemical Physics,                                *
*             University of Lund, Sweden                               *
*             December 2001                                            *
************************************************************************
      use iSD_data
      use Symmetry_Info, only: nIrrep
      use KSDFT_Info, only: KSDFA
      use nq_Grid
      Implicit Real*8 (A-H,O-Z)
      External Kernel
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "itmax.fh"
#include "nq_info.fh"
#include "setup.fh"
#include "nsd.fh"
#include "debug.fh"
#include "grid_on_disk.fh"
#include "status.fh"
#include "ksdft.fh"
      Real*8 FckInt(nFckInt,nFckDim),Density(nFckInt,nD), Grad(nGrad)
      Logical Do_Grad, Do_MO,Do_TwoEl,PMode
      Logical l_XHol, l_casdft
      Character*4 DFTFOCK
      Integer nBas(8), nOrb(8)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
#include "nq_structure.fh"
      declare_ip_r_quad
      declare_ip_angular
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
      RMx=0.0D0
      RNx=0.0D0

      If (Functional_Type.eq.CASDFT_Type) Then
      Do_TwoEl        =.True.
      End If
*
      If (Do_TwoEl) Then
      Do_MO           =.True.
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*-- Additions for Xhole. DFTFOCK is here reset to SCF, but we
*   define a new logical variable. This is no DFT-integrations,
*   just dummy-stuff for getting the numerical LoProp-
*   integrations. (A.Ohrn)
*
      If (DFTFOCK(1:4).eq.'XHOL') then
      Write(DFTFOCK,'(A)')'SCF '
      l_Xhol=.true.
      Else
      l_Xhol=.false.
      Endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Allocate enough memory for Maps2p
*
      Call Set_Basis_Mode('Valence')
      Call Nr_Shells(nShell)
      Call GetMem('s2p','Allo','Inte',ips2p,nShell*nIrrep)
      Call GetMem('R_Min','Allo','Real',ipR_Min,LMax_NQ+1)
*
        NQ_Status=Inactive
      Call Setup_NQ(iWork(ips2p),nShell,nIrrep,nNQ,Do_Grad,Do_MO,nD,
     &              PThr,PMode,Work(ipR_Min),LMax_NQ)
*
      Call GetMem('R_Min','Free','Real',ipR_Min,LMax_NQ)
*                                                                      *
************************************************************************
*                                                                      *
*---- Allocate scratch memory for the temporary AO matrix
*     elements
*
      nAOInt=0
      Do iShell = 1, nShell
         iBas = iSD(3,iShell)
         iCmp = iSD(2,iShell)
         nAOInt=Max(nAOInt,iBas*iCmp)
      End Do
*
      Call GetMem('AOInt','Allo','Real',ipAOInt,nD*nAOInt**2)
*                                                                      *
************************************************************************
*                                                                      *
*---- Allocate scratch memory for the temporary SO matrix
*     elements
*
      iSmLbl=1
      nSOTemp=0
      Do iSkal = 1, nShell
         iCmp  = iSD( 2,iSkal)
         iBas  = iSD( 3,iSkal)
         iAO   = iSD( 7,iSkal)
         iShell= iSD(11,iSkal)
         Do jSkal = 1, iSkal
            jCmp  = iSD( 2,jSkal)
            jBas  = iSD( 3,jSkal)
            jAO   = iSD( 7,jSkal)
            jShell= iSD(11,jSkal)
            nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            nSOTemp=Max(nSOTemp,iBas*jBas*nSO)
         End Do
      End Do
      Call GetMem('SO_Temp','Allo','Real',ipSOTemp,nSOTemp*nD)
*                                                                      *
************************************************************************
*                                                                      *
*-----Allocate memory sufficiently large to store all grid points
*     and associated weights.
*
      Call mma_Allocate(Grid,3,nGridMax,Label='Grid')
*                                                                      *
************************************************************************
*                                                                      *
*     CASDFT stuff:
*
      l_casdft=.false.
      nP2=1
      nCmo=1
      nD1mo=1
      nMos=1
      nTmpTUVX=1
      nTmpPUVX=1
      ipP2mo=ip_Dummy
      ipCmo=ip_Dummy
      ipD1mo=ip_Dummy
      ipDoIt=ip_iDummy
      ipTmpPUVX=ip_Dummy
      ipTmpTUVX=ip_Dummy
*
      NQNAC=0
      If (DFTFOCK.ne.'SCF ') Then
         Do iIrrep = 0, mIrrep - 1
            NQNAC = NQNAC + nAsh(iIrrep)
         End Do
      End If
*
      LuGridFile=31
      LuGridFile=IsFreeUnit(LuGridFile)
      Call Molcas_Open(LuGridFile,'GRIDFILE')
************************************************************************
*
************************************************************************
*                                                                      *
*     Definition of resources needed for the functionals.              *
*                                                                      *
*     mAO: the number of derivatives needed of an basis function.      *
*          Depending of the functional type and if gradients will be   *
*          computed. Numbers will be 1, 4, 10, 20, 35, etc.            *
*     nRho:the number of parameters of the functional. Note that this  *
*          is different for the same functional depending on if it is  *
*          a closed or open-shell case.                                *
*     mdRho_dR: number of derivatives of the parameters with respect   *
*          to the nuclear coordinates. The true number is of course    *
*          three (x,y,z) times this.                                   *
*     nF_drho: the number of derivatives of the functional wrt the     *
*          parameters. Note that grad rho is not a direct parameter    *
*          but that we use gamma.                                      *
************************************************************************
************************************************************************
*                                                                      *
      If (Functional_type.eq.LDA_type) Then
*                                                                      *
************************************************************************
*                                                                      *
*        We need the AOs, for gradients we need the derivatives too.
*
         mAO=1
         If (Do_Grad) mAO=4
*
*        We need rho.
*        For gradients we need derivatives of rho wrt the coordinates
*
         nRho=1*nD
         mdRho_dr=0
         If (Do_Grad) mdRho_dr=nRho
*
*        We need derivatives of the functional with respect to
*        rho(alpha). In case of open-shell calculations we also
*        need rho(beta).
*
         If (nD.eq.1) Then
            ndF_dRho=1
         Else
            ndF_dRho=2
         End If
         nP2_ontop=1
         ndF_dP2ontop=1
*                                                                      *
************************************************************************
*                                                                      *
      Else If ( Functional_type.eq.GGA_type) Then
*                                                                      *
************************************************************************
*                                                                      *
*        We need the AOs and their derivatives, for  gradients we need
*        the second derivatives too.
*
         mAO=4
         If (Do_Grad) mAO=10
*
*        We need rho and grad rho
*        For gradients we need the derrivatives wrt the coordinates
*
         nRho=4*nD
         mdRho_dR=0
         If (Do_Grad) mdRho_dR=nRho
*
*        We need derivatives of the functional with respect to
*        rho(alpha), gamma(alpha,alpha) and gamma(alpha,beta).
*        In case of open-shell calculations we also
*        need rho(beta) and gamma(beta,beta).
*
         If (nD.eq.1) Then
            ndF_dRho=3
         Else
            ndF_dRho=5
         End If
         nP2_ontop=4
         ndF_dP2ontop=4
*                                                                      *
************************************************************************
*                                                                      *
      Else If ( Functional_type.eq.meta_GGA_type1) Then
*                                                                      *
************************************************************************
*                                                                      *
*        We need the AOs and their derivatives, for  gradients we need
*        the second derivatives too.
*
         mAO=4
         If (Do_Grad) mAO=10
*
*        We need rho, grad rho and tau.
*        For gradients we need the derrivatives wrt the coordinates
*
         nRho=5*nD
         mdRho_dR=0
         If (Do_Grad) mdRho_dR=nRho
*
*        We need derivatives of the functional with respect to
*        rho(alpha), gamma(alpha,alpha), gamma(alpha,beta) and
*        tau(alpha). In case of open-shell calculations we also
*        need rho(beta), gamma(beta,beta) and tau(beta).
*
         If (nD.eq.1) Then
            ndF_dRho=4
         Else
            ndF_dRho=7
         End If
         nP2_ontop=4
         ndF_dP2ontop=4
*                                                                      *
************************************************************************
*                                                                      *
      Else If ( Functional_type.eq.meta_GGA_type2) Then
*                                                                      *
************************************************************************
*                                                                      *
*        Not debugged yet!
*        We need the AOs and their 1st and 2nd derivatives, for
*        gradients we need the 3rd order derivatives too.
*
         mAO=10
         If (Do_Grad) mAO=20
*
*        We need rho, grad rho, tau, and the Laplacian
*        For gradients we need the derrivatives wrt the coordinates
*
         nRho=6*nD
         mdRho_dR=0
         If (Do_Grad) mdRho_dR=nRho
*
*        We need derivatives of the functional with respect to
*        rho(alpha), gamma(alpha,alpha), gamma(alpha,beta),
*        tau(alpha) and laplacian(alpha). In case of open-shell
*        calculations we also need rho(beta), gamma(beta,beta),
*        tau(beta) and laplacian(beta).
*
         If (nD.eq.1) Then
            ndF_dRho=5
         Else
            ndF_dRho=9
         End If
         nP2_ontop=4
         ndF_dP2ontop=4
c         Call WarningMessage(2,
c     &        'Meta-GGA functional type 2 not fully DEBUGGED yet!')
*                                                                      *
************************************************************************
*                                                                      *
      Else If ( Functional_type.eq.PAM_type) Then
*                                                                      *
************************************************************************
*                                                                      *
         mAO=5
         nRho=4*nD
         mdRho_dR=0
         If (nD.eq.1) Then
            ndF_dRho=3
         Else
            ndF_dRho=5
         Endif
         nP2_ontop=4
         ndF_dP2ontop=4
         Call WarningMessage(2,'PAM functionals not implemented yet!')
         Call Abend()
*                                                                      *
************************************************************************
*                                                                      *
      Else If ( Functional_type.eq.CS_type) Then
*                                                                      *
************************************************************************
*                                                                      *
         mAO=5
         nRho=4*nD
         mdRho_dR=0
         If (nD.eq.1) Then
            ndF_dRho=3
         Else
            ndF_dRho=5
         Endif
         nP2_ontop=4
         ndF_dP2ontop=4
         Call WarningMessage(2,'CS functionals not implemented yet!')
         Call Abend()
*                                                                      *
************************************************************************
*                                                                      *
      Else If ( Functional_type.eq.CASDFT_type) Then
*
*        nD's definition is not consistent with the use here!
*        This needs to be restructured.
*
         mAO=10
         mdRho_dR=0
         If (Do_Grad) Then
             Call WarningMessage(2,'CASDFT: Gradient not available.')
             Call Abend()
         End If
         nRho=4*nD
*
         If (nD.eq.1) Then
            ndF_dRho=3 ! could be 2?
         Else
            ndF_dRho=5
         Endif
         nP2_ontop=6
         ndF_dP2ontop=6
*                                                                      *
************************************************************************
*                                                                      *
      Else
         Functional_type=Other_type
         Call WarningMessage(2,'DrvNQ: Invalid Functional_type!')
         Call Abend()
         nRho=0
         ndF_dRho=0
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('F_xc','Allo','Real',ip_F_xc,nGridMax)
      Call GetMem('Rho','Allo','Real',ip_Rho,nRho*nGridMax)
      Call GetMem('dF_dRho','Allo','Real',ip_dFdRho,ndF_dRho*nGridMax)
*
      Call GetMem('Weights','Allo','Real',ip_Weights,nGridMax)
      Call GetMem('list_s','Allo','Inte',iplist_s,2*nIrrep*nShell)
      Call GetMem('list_exp','Allo','Inte',iplist_exp,3*nIrrep*nShell)
      iplist_bas=iplist_exp+nIrrep*nShell
      Call GetMem('list_p','Allo','Inte',iplist_p,nNQ)
      Call GetMem('R2_trail','Allo','Real',ipR2_trail,nNQ)
c      Call GetMem('tmpB','Allo','Real',ip_tmpB,nGridMax)
*                                                                      *
************************************************************************
* Global variable for MCPDFT functionals                               *
      l_casdft = KSDFA.eq.'TLSDA'   .or.
     &           KSDFA.eq.'TLSDA5'  .or.
     &           KSDFA.eq.'TBLYP'   .or.
     &           KSDFA.eq.'TSSBSW'  .or.
     &           KSDFA.eq.'TSSBD'   .or.
     &           KSDFA.eq.'TS12G'   .or.
     &           KSDFA.eq.'TPBE'    .or.
     &           KSDFA.eq.'FTPBE'   .or.
     &           KSDFA.eq.'TOPBE'   .or.
     &           KSDFA.eq.'FTOPBE'  .or.
     &           KSDFA.eq.'TREVPBE' .or.
     &           KSDFA.eq.'FTREVPBE'.or.
     &           KSDFA.eq.'FTLSDA'  .or.
     &           KSDFA.eq.'FTBLYP'
      if(Debug) write(6,*) 'l_casdft value at drvnq.f:',l_casdft
      if(Debug.and.l_casdft) write(6,*) 'MCPDFT with functional:', KSDFA
************************************************************************
      If (Do_MO) Then
         If (NQNAC.ne.0) Then
           If(.not.l_casdft) Then
             NQNACPAR = ( NQNAC**2 + NQNAC )/2
             nd1mo=NQNACPAR
             Call GetMem('D1MO','Allo','Real',ipD1MO,nd1mo)
             Call Get_D1MO(Work(ipD1mo),nd1mo)
             NQNACPR2 = ( NQNACPAR**2 + NQNACPAR )/2
             Call GetMem('P2MO','Allo','Real',ipP2MO,nP2)
             Call Get_P2mo(Work(ipP2mo),nP2)

           End If
         End If
         Call Get_iArray('nBas',nBas,mIrrep)
         Call Get_iArray('nOrb',nOrb,mIrrep)
         nCMO=0
         Do i = 1, mIrrep
            nCMO = nCMO + nBas(i)*nOrb(i)
         End Do
         Call GetMem('CMO','Allo','Real',ipCMO,nCMO)
         Call Get_CMO(Work(ipCMO),nCMO)
         Call Get_iArray('nAsh',nAsh,mIrrep)
         nMOs=0
         Do iIrrep = 0, mIrrep-1
            nMOs=nMOs+mBas(iIrrep)
         End Do
         Call GetMem('DoIt','Allo','Inte',ipDoIt,nMOs)
         iMO=ipDoIt-1
         Do iIrrep = 0, mIrrep-1
            Do jMO = 1, nISh(iIrrep)+nASh(iIrrep)
               iMO=iMO+1
               iWork(iMO)=1
            End Do
            Do jMO = 1, mBas(iIrrep)-nISh(iIrrep)-nASh(iIrrep)
               iMO=iMO+1
               iWork(iMO)=1
            End Do
         End Do
      End If
***
*     Prepare memory for two-electron integrals:
*     nPUVX, nTUVX
*
      If (Do_TwoEl) Then
         If (.not.Do_MO) Then
            Call WarningMessage(2,
     &              ' Can''t produce 2 el dft integrals without MO')
            Call Abend()
         End If
         NQNACPAR = ( NQNAC**2 + NQNAC )/2
         NQNACPR2 = ( NQNACPAR**2 + NQNACPAR )/2
         nTmpTUVX = NQNACPR2
*
         iStack = 0
         Do iIrrep = 0, mIrrep-1
           iOrb = mBas(iIrrep) - nFro(iIrrep)
           Do jIrrep = 0, mIrrep-1
             jAsh = nAsh(jIrrep)
             ijIrrep=iEor(iIrrep,jIrrep)
             Do kIrrep = 0, mIrrep-1
               kAsh = nAsh(kIrrep)
               ijkIrrep=iEor(ijIrrep,kIrrep)
               If (ijkIrrep.le.kIrrep) Then
                 lAsh = nAsh(ijkIrrep)
                 kl_Orb_pairs = kAsh*lAsh
                 If ( kIrrep.eq.ijkIrrep )
     &                  kl_Orb_pairs = (kAsh*kAsh+kAsh)/2
                 iStack = iStack + iOrb*jAsh*kl_Orb_pairs
               End If
             End Do
           End Do
         End Do
         nTmpPUVX=iStack
*
         Call GetMem('TmpPUVX','Allo','Real',ipTmpPUVX,nTmpPUVX)
         Call dCopy_(nTmpPUVX,[0.0d0],0,Work(ipTmpPUVX),1)
      End If
*
      If (Functional_Type.eq.CASDFT_Type) Then
         Call GetMem('P2_ontop','Allo','Real',ipp2_ontop,
     &               nP2_ontop*nGridMax)
         Call GetMem('dF_dP2ontop','Allo','Real',ipdF_dP2ontop,
     &               ndF_dP2ontop*nGridMax)
      Else
         ipP2_ontop=ip_Dummy
         ipdF_dp2ontop=ip_Dummy
      Endif
*
      If (Do_Grad) Then
         Call GetMem('list_g','Allo','Inte',iplist_g,3*nShell*nIrrep)
         mGrad=3*nAtoms
         Call GetMem('IndGrd','Allo','Inte',ipIndGrd,mGrad)
         Call GetMem('iTab','Allo','Inte',ipiTab,4*mGrad)
         Call GetMem('Temp','Allo','Real',ipTemp,mGrad)
      Else
         iplist_g=ip_iDummy
         ipIndGrd=ip_iDummy
         ipiTab  =ip_iDummy
         ipTemp  =ip_Dummy
      End If

      If (.Not.Do_Grad) Call FZero(FckInt,nFckInt*nFckDim)
*                                                                      *
************************************************************************
*                                                                      *
      Thr=Threshold
      if(Debug) write(6,*) 'l_casdft value at drvnq.f:',l_casdft
      if(Debug.and.l_casdft) write(6,*) 'MCPDFT with functional:', KSDFA
      If(l_casdft) then
        NQNAC=0
        Call Get_iArray('nAsh',nAsh,mIrrep)
        Do iIrrep = 0, mIrrep - 1
          NQNAC = NQNAC + nAsh(iIrrep)
        End Do
        IF(NQNAC.ne.0) then
          NQNACPAR = ( NQNAC**2 + NQNAC )/2
          NQNACPR2 = ( NQNACPAR**2 + NQNACPAR )/2
          nd1mo = NQNACPAR
          Call GetMem('D1MO','Allo','Real',ipD1MO,nd1mo)
          Call Get_D1MO(Work(ipD1mo),nd1mo)
cGLM          write(6,*) 'D1MO in drvNQ routine'
cGLM          write(6,*) (Work(ipD1mo+i), i=0,NQNACPAR-1)
          nP2 = NQNACPR2
          Call GetMEM('P2MO','Allo','Real',ipP2MO,nP2)
          call Get_P2mo(Work(ipP2mo),nP2)
cGLM          write(6,*) 'P2MO in drvNQ routine'
cGLM          write(6,*) (Work(ipP2mo+i), i=0,NQNACPR2-1)
        END IF
         Call GetMem('P2_ontop','Allo','Real',ipp2_ontop,
     &               nP2_ontop*nGridMax)
         Call GetMem('dF_dP2ontop','Allo','Real',ipdF_dP2ontop,
     &               ndF_dP2ontop*nGridMax)
        Call dCopy_(nP2_ontop*nGridMax,[0.0d0],0,Work(ipp2_ontop),1)
        Call dCopy_(ndF_dP2ontop*nGridMax,[0.0d0],0,
     &                                    Work(ipdF_dP2ontop),1)

      end if

      Call DrvNQ_Internal(
     &            Kernel,Func,
     &            iWork(ips2p),nIrrep,
     &            iWork(iplist_s),iWork(iplist_exp),iWork(iplist_bas),
     &            nShell,iWork(iplist_p),Work(ipR2_trail),nNQ,
     &            Work(ipAOInt),nAOInt,FckInt,nFckDim,
     &            Density,nFckInt,nD,
     &            Work(ipSOTemp),nSOTemp,
     &            Grid,Work(ip_Weights),Work(ip_Rho),
     &            nGridMax,nRho,
     &            ndF_dRho,nP2_ontop,ndF_dP2ontop,
     &            Do_Mo,Do_TwoEl,l_Xhol,
     &            Work(ipTmpPUVX),nTmpPUVX,
     &            nMOs,Work(ipCMO),nCMO,
     &            iWork(ipDoIt),
     &            Work(ipP2mo),nP2,Work(ipD1mo),nd1mo,Work(ipp2_ontop),
     &            Do_Grad,Grad,nGrad,iWork(iplist_g),
     &            iWork(ipIndGrd),iWork(ipiTab),Work(ipTemp),mGrad,
     &            Work(ip_F_xc),
cGLM     &        Work(ip_F_xca),Work(ip_F_xcb),
     &            Work(ip_dFdRho),work(ipdF_dP2ontop),
     &            DFTFOCK,mAO,mdRho_dR)
*                                                                      *
************************************************************************
*                                                                      *
*-----Deallocate the memory
*
      Call GetMem('O','Free','Real',ip_O,3*3)
      If (Do_Grad) Then
         Call GetMem('Temp','Free','Real',ipTemp,mGrad)
         Call GetMem('iTab','Free','Inte',ipiTab,4*mGrad)
         Call GetMem('IndGrd','Free','Inte',ipIndGrd,mGrad)
         Call GetMem('list_g','Free','Inte',iplist_g,3*nShell*nIrrep)
      End If
      Call GetMem('R2_trail','Free','Real',ipR2_trail,nNQ)
      Call GetMem('list_p','Free','Inte',iplist_p,nNQ)
      Call GetMem('list_exp','Free','Inte',iplist_exp,3*nIrrep*nShell)
      Call GetMem('list_s','Free','Inte',iplist_s,2*nIrrep*nShell)
      Call GetMem('Weights','Free','Real',ip_Weights,nGridMax)
      Call GetMem('dF_dRho','Free','Real',ip_dFdRho,ndF_dRho*nGridMax)
*Do_TwoEl
      If(ipP2mo.ne.ip_Dummy) Call Free_Work(ipP2mo)
      If(ipD1MO.ne.ip_Dummy) Call Free_Work(ipD1MO)
      If(ipCMO.ne.ip_Dummy)  Call Free_Work(ipCMO)
      If(ipDoIt.ne.ip_iDummy) Call GetMem('DoIt','Free','Inte',
     &                                    ipDoIt,nMOs)
      If(ipTmpPUVX.ne.ip_Dummy) Then
         Call Put_dArray('DFT_TwoEl',Work(ipTmpPUVX),nTmpPUVX)
         Call GetMem('TmpPUVX','Free','Real',ipTmpPUVX,nTmpPUVX)
      End If
*
      Call GetMem('Rho','Free','Real',ip_Rho,nRho*nGridMax)
      Call GetMem('F_xc','Free','Real',ip_F_xc,nGridMax)
      Call mma_deallocate(Grid)
c      Call GetMem('tmpB','Free','Real',ip_tmpB,nGridMax)

      if(Debug) write(6,*) 'l_casdft value at drvnq.f:',l_casdft
      if(Debug.and.l_casdft) write(6,*) 'MCPDFT with functional:', KSDFA
      If (Functional_type.eq.CASDFT_Type.or.l_casdft) Then
         Call GetMem('P2_ontop','Free','Real',ipP2_ontop,
     &               nP2_ontop*nGridMax)
         Call GetMem('dF_dP2ontop','Free','Real',ipdF_dP2ontop,
     &               ndF_dP2ontop*nGridMax)
      End If
*
      Do iNQ = 1, nNQ
         ip_iRx=ip_of_iWork_d(Work(ip_R_Quad(iNQ)))
         ip_Rx=iWork(ip_iRx)
         Call GetMem('Radial','Free','Real',ip_Rx,iDum)
         ip_iA=ip_of_iWork_d(Work(ip_Angular(iNQ)))
         ip_A=iWork(ip_iA)
         Call GetMem('ip_Angular','Free','Inte',ip_A,iDum)
      End Do
      Call GetMem('NumRadEff','Free','Inte',ip_nR_eff,nNQ)
      Call GetMem('Coor','FREE','REAL',ipCoor,3*8*nAtoms)

      Call GetMem('SO_Temp','Free','Real',ipSOTemp,nSOTemp)
      Call GetMem('AOInt','Free','Real',ipAOInt,nD*nAOInt**2)
      Call GetMem('nq_centers','Free','Real',ipNQ,nShell*l_NQ)
      Call GetMem('nMem','Free','Real',ipMem,nMem)
      Call GetMem('Tmp','Free','Real',ipTmp,nTmp)
      Call Free_Work(ip_Fact)
      Call GetMem('s2p','Free','Inte',ips2p,nshell)
      NQ_Status=Inactive
*                                                                      *
************************************************************************
*                                                                      *
*---- Write the status flag and TOC.
*
      If (iGrid_Set.eq.Intermediate .and.
     &     Grid_Status.eq.Regenerate) iDisk_Set(Final)=iDisk_Grid
      G_S(iGrid_Set)=Use_Old
*
      iDisk_Grid=0
      Call iDaFile(Lu_Grid,1,G_S,5,iDisk_Grid)
      iDisk_Grid=iDisk_Set(iGrid_Set)
      Call iDaFile(Lu_Grid,1,iWork(ip_GridInfo),
     &             2*number_of_subblocks,iDisk_Grid)
*
      Call DaClos(Lu_Grid)
*
      Call Free_iWork(ip_GridInfo)
*                                                                      *
************************************************************************
*                                                                      *
      Call IniPkR8(PThr,PMode)
*
      Call xFlush(LuGridFile)
      Close(LuGridFile)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016-2017, Stefan Knecht                               *
!***********************************************************************
  subroutine prepMPS(            &
                     trorb,      &
                     istate,     &
                     lsym,       &
                     mplet,      &
                     mspro,      &
                     nacte,      &
                     tra,        &
                     ntra,       &
                     nish,       &
                     nash,       &
                     nosh,       &
                     nsym,       &
                     lupri,      &
! Leon 8/12/2016 -- "real" state index across all JobIphs, needed when we read checkpoint file names
                     istatereal, &
                     job,        &
                     ist         &
                     )

  ! module dependencies
#ifdef _DMRG_
  use qcmaquis_interface_cfg
  use qcmaquis_info
  use qcmaquis_interface_mpssi
  use fortran_strings, only : str
#endif

  implicit none
!-------------------------------------------------------------------------------
!
!    driver routine for the MPS rotation wrt the orbital transformation matrix
!    given in TRA.
!    --> rotate MPS state ISTATE
!    NOTE: TRA contains square matrices, one per symmetry
!
!-------------------------------------------------------------------------------

  integer,intent(in)    :: istate
  integer,intent(in)    :: istatereal
  integer,intent(in)    :: job
  integer,intent(in)    :: ist
  integer,intent(in)    :: lsym
  integer,intent(in)    :: mplet
  integer,intent(in)    :: mspro
  integer,intent(in)    :: nacte
  integer,intent(in)    :: nsym
  integer,intent(in)    :: ntra
  integer,intent(in)    :: lupri
  integer,intent(in)    :: nish(nsym)
  integer,intent(in)    :: nash(nsym)
  integer,intent(in)    :: nosh(nsym)
  real*8, intent(inout) :: tra(ntra)
  logical,intent(in)    :: trorb
!-------------------------------------------------------------------------------
#ifdef _DMRG_
  integer               :: i, isym, no, ii, ista, jorb, ni
  real*8                :: fac(1,1), ckk
  logical               :: debug_dmrg_rassi_code = .false.
  real*8, allocatable   :: tmat(:,:) ! active-active rotation matrix

  if(.not.trorb)then
    write(lupri,'(a,a)') ' prepMPS: no MPS rotation requested for state ', &
    trim(qcm_group_names(job)%states(ist))//' jobiph: '//str(job)//', root: '//str(istate)
    return
  else
    write(lupri,'(a,a)') ' prepMPS:    MPS rotation requested for state ', trim(qcm_group_names(job)%states(ist))// &
         ' jobiph: '//str(job)//', root: '//str(istate)
  end if

  dmrg_orbital_space%nash(1:nsym) = nash(1:nsym)
  dmrg_symmetry%nirrep            = nsym
  dmrg_state%nactel               = nacte
  dmrg_state%ms2                  = mplet
  dmrg_state%irefsm               = lsym

  if(debug_dmrg_rassi_code)then
    write(lupri,*)' Entering prepMPS. TRA='
    write(lupri,'(1x,5f16.8)')(TRA(I),I=1,NTRA)
  end if

  !> find first the scaling factor to transform wrt the inactive orbitals
  fac(1,1) = 1.0d0
  ista     = 1
  do isym = 1, nsym
    no = nosh(isym)
    do i = 1, nish(isym)
      ii  = ista + (no+1)*(i-1)
      ckk = tra(ii)
      fac(1,1) = fac(1,1)*ckk
    end do
    ista = ista + no**2
  end do
  fac(1,1) = fac(1,1)**2
  if(debug_dmrg_rassi_code)then
    write(lupri,*) ' scaling factor for MPS (inactive orbital rotations)',fac
  end if

  dmrg_state%ms2                  = mspro

  if (nsym.gt.1) stop "MPS rotation not supported with symmetry"


!   call mma_allocate(tmat,nash(1),nash(1))
  ! Leon: I get a maybe-uninitialized error if I use mma_allocate on tmat
  allocate(tmat(nash(1),nash(1)))
  tmat = 0.0d0
  ista = 1
  jorb = 0
  do isym = 1, nsym
    ni = nish(isym)
    no = nosh(isym)
    do i = 1, nash(isym)
      ! copy the active-active part of the rotation matrix into tmat
      tmat(i,:) = tra(1+(no+i)*ni+nash(isym)*(i-1):(no+i)*ni+nash(isym)*i)
    end do
    ista = ista + no**2
  end do

  ! rotate MPS
  call qcmaquis_mpssi_rotate(qcm_prefixes(job), &
                             istate,            &
                             tmat, &
                             nash(1)**2, &
                             fac(1,1), &
                             mspro)

  if (allocated(tmat)) deallocate(tmat)
  ! call mma_deallocate(tmat)

  ! Avoid unused variable warnings
  if (.false.) then
    call unused_integer(istatereal)
    call unused_integer(ist)
  end if
#else
  write(lupri,*) ' calling prepMPS w/o DMRG interface - foolish!'
  write(lupri,*) ' ... no actual task is performed.            '
! Avoid unused variable warnings if DMRG is disabled
  if (.false.) then
    call unused_real_array(tra)
    call unused_integer(istate)
    call unused_integer(istatereal)
    call unused_integer(job)
    call unused_integer(ist)
    call unused_integer(lsym)
    call unused_integer(mplet)
    call unused_integer(mspro)
    call unused_integer(nacte)
    call unused_integer(nsym)
    call unused_integer(ntra)
    call unused_integer(lupri)
    call unused_integer_array(nish)
    call unused_integer_array(nash)
    call unused_integer_array(nosh)
    call unused_logical(trorb)
  end if
#endif
  end subroutine prepMPS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FREESTR_GAS()

use lucia_data, only: IOCLS, ISMDFGP, ISMSCR, ISTSGP, ISTSO, NACTSYM, NGRP, NSTSGP, NSTSO, NSTTP, OCCSTR, SPGPAN, SPGPCR, STREO, &
                      STSTM, ZMAT
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IGRP, ITP

! Offsets for occupation and reorder array of strings

do IGRP=1,NGRP
  call mma_deallocate(OCCSTR(IGRP)%A)
  call mma_deallocate(STREO(IGRP)%A)
end do

! Number of strings per symmetry and offset for strings of given sym
! for groups

call mma_deallocate(NSTSGP)
call mma_deallocate(ISTSGP)

! Number of strings per symmetry and offset for strings of given sym
! for types

do ITP=1,NSTTP
  call mma_deallocate(NSTSO(ITP)%A)
  call mma_deallocate(ISTSO(ITP)%A)
end do

! Lexical addressing of arrays : use array indices for complete active space

! Not in use so
do IGRP=1,NGRP
  call mma_deallocate(Zmat(IGRP)%A)
end do

! Mappings between different groups

do IGRP=1,NGRP
  ! IF creation is involve : Use full orbital notation
  ! If only annihilation is involved, compact form will be used
  call mma_deallocate(STSTM(IGRP,1)%A)
  call mma_deallocate(STSTM(IGRP,2)%A)
end do

! Occupation classes

call mma_deallocate(IOCLS)
! Annihilation/Creation map of supergroup types
call mma_deallocate(SPGPAN)
call mma_deallocate(SPGPCR)

! Allocated during strinf_gas call
call mma_deallocate(ISMDFGP)
call mma_deallocate(NACTSYM)
call mma_deallocate(ISMSCR)

end subroutine FREESTR_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION NEWSSTAB(LORBTAB)
      IMPLICIT NONE
      INTEGER LORBTAB
      INTEGER NTAB,ITYPE,NSSTP,NSBSTOT,KSBSMRS,KMRSSBS
      INTEGER KSBSANN,KSBSCRE
#include "symmul.fh"
#include "Morsel.fh"
#include "WrkSpc.fh"
      INTEGER I,IKMS2,IKSCR,IKSYM
      INTEGER IMS2,IPOP,ISBS,ISCR
      INTEGER ISGN,ISORB,ISPART,ISSTP
      INTEGER ISYM,J,KMS2,KOINFO,KSSTANN
      INTEGER KSSTCRE,KSSTP,KSYM,LNOSUB
      INTEGER LOINFO,LOSPN,LOSYM,LPOS,LSCR,LSCR2
      INTEGER LTAB,MORSANN,MORSCRE,MORSPOP
      INTEGER MORSSPIN,MORSSYMM,MRS,MS2
      INTEGER MXMS2,MXPOP,N
      INTEGER NEWMRS,NEWSBS,NEWSST,NO
      INTEGER NSBS,NSCR,NASPO,NASPRT
C     INTEGER NTEST,iscrmx
      INTEGER IERR,ISBS1,ISBS2,ISBS3,ISBS4,ISBS5,ISBS6,ISBS7,ISBS8
C     CHARACTER*8 STRING8
      EXTERNAL MORSANN,MORSCRE,MORSPOP,MORSSPIN,MORSSYMM

C Table type ID:
      ITYPE=19
C Pick up some data from the orbital table:
      NASPO =IWORK(LORBTAB+3)
      NSYM  =IWORK(LORBTAB+4)
      NASPRT=IWORK(LORBTAB+8)
      KOINFO=19
      LOINFO=LORBTAB-1+KOINFO
C Make temporary arrays for spin label and symmetry of each orbital
      CALL GETMEM('OrbSpn','Allo','Inte',LOSPN,NASPO)
      CALL GETMEM('OrbSym','Allo','Inte',LOSYM,NASPO)
C Make a temporary array, which gives the number of spin orbitals in
C each subpartition:
      CALL GETMEM('NOSub','Allo','Inte',LNOSUB,NASPRT)
      DO ISPART=1,NASPRT
        IWORK(LNOSUB-1+ISPART)=0
      END DO
      DO ISORB=1,NASPO
        ISYM  = IWORK(LOINFO+ 1+(ISORB-1)*8)
        IWORK(LOSYM-1+ISORB)=ISYM
        MS2   = IWORK(LOINFO+ 3+(ISORB-1)*8)
        IWORK(LOSPN-1+ISORB)=MS2
        ISPART= IWORK(LOINFO+ 6+(ISORB-1)*8)
        N=1+IWORK(LNOSUB-1+ISPART)
        IWORK(LNOSUB-1+ISPART)=N
      END DO
C We need a temporary array, NSBSSCR(NSYM,0:NPOP,-MXMS2:MXMS2,NASPRT),
C to keep the number of substrings of different kind:
      MXPOP=MORSBITS
      MXMS2=MORSBITS
      NSCR=NSYM*(1+MXPOP)*(2*MXMS2+1)*NASPRT
      CALL GETMEM('SSTScr','Allo','Inte',LSCR,NSCR)
C Addressing will be through the cumbersome formula
C ISCR=ISYM+NSYM*(IPOP+(1+MXPOP)*(MXMS2+MS2+(2*MXMS2+1)*(ISPART-1)))
C Initialize counter of substrings:
      DO ISPART=1,NASPRT
        DO IMS2=-MXMS2,MXMS2
         DO IPOP=0,MXPOP
          DO ISYM=1,NSYM
C NSBSSCR(ISYM,IPOP,IMS2,ISPART)=0:
           ISCR=ISYM+NSYM*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*
     &                     (ISPART-1)))
           IWORK(LSCR-1+ISCR)=0
          END DO
         END DO
        END DO
C NSBSSCR(ISYM=1,IPOP=0,IMS2=0,ISPART)=1:
        ISCR=1+NSYM*(0+(1+MXPOP)*(MXMS2+0+(2*MXMS2+1)*(ISPART-1)))
        IWORK(LSCR-1+ISCR)=1
      END DO
C Compute number of substrings:
      ISORB=0
      DO ISPART=1,NASPRT
        NO=IWORK(LNOSUB-1+ISPART)
        DO I=1,NO
          ISORB=ISORB+1
          KSYM=IWORK(LOSYM-1+ISORB)
          KMS2=IWORK(LOSPN-1+ISORB)
          DO IPOP=I,1,-1
           DO IMS2=-IPOP,IPOP
            IKMS2=IMS2-KMS2
            IF(ABS(IKMS2).LE.IPOP-1) THEN
            DO ISYM=1,NSYM
             IKSYM=MUL(ISYM,KSYM)
             ISCR=ISYM+NSYM*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*
     &                      (ISPART-1)))
             N=IWORK(LSCR-1+ISCR)
             IKSCR=IKSYM+NSYM*(IPOP-1+(1+MXPOP)*(MXMS2+IKMS2+
     &                          (2*MXMS2+1)*(ISPART-1)))
             N=N+IWORK(LSCR-1+IKSCR)
             IWORK(LSCR-1+ISCR)=N
            END DO
            END IF
           END DO
          END DO
        END DO
      END DO
      NSSTP=0
      NSBSTOT=0
      DO ISPART=1,NASPRT
        NO=IWORK(LNOSUB-1+ISPART)
        DO IPOP=0,NO
         DO ISYM=1,NSYM
          DO IMS2=-NO,NO
           ISCR=ISYM+NSYM*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*
     &                     (ISPART-1)))
           N=IWORK(LSCR-1+ISCR)
           IF(N.GT.0) THEN
             NSSTP=NSSTP+1
             NSBSTOT=NSBSTOT+N
           END IF
          END DO
         END DO
        END DO
      END DO
C We finally know the number of substring types and the number of
C substrings. Transfer non-zero entries to the final table.

C Size of table, and offsets:
      KSSTP  =15
      KSSTANN=KSSTP   + 5*NSSTP
      KSSTCRE=KSSTANN + MORSBITS*NSSTP
      KSBSMRS=KSSTCRE + MORSBITS*NSSTP
      KMRSSBS=KSBSMRS + 2*NSBSTOT
      KSBSANN=KMRSSBS + 2*(2**MORSBITS)*NASPRT
      KSBSCRE=KSBSANN + NSBSTOT*MORSBITS
      NTAB   =KSBSCRE + NSBSTOT*MORSBITS -1
      CALL GETMEM('SbStrTab','Allo','Inte',LTAB,NTAB)
      CALL ICOPY(NTAB,[0],0,IWORK(LTAB),1)
C The header data
      IWORK(LTAB+ 0)=NTAB
      IWORK(LTAB+ 1)=ITYPE
      IWORK(LTAB+ 2)=LORBTAB
      IWORK(LTAB+ 3)=NSYM
      IWORK(LTAB+ 4)=NASPRT
      IWORK(LTAB+ 5)=MORSBITS
      IWORK(LTAB+ 6)=NSSTP
      IWORK(LTAB+ 7)=NSBSTOT
      IWORK(LTAB+ 8)=KSSTANN
      IWORK(LTAB+ 9)=KSSTCRE
      IWORK(LTAB+10)=KSBSMRS
      IWORK(LTAB+11)=KMRSSBS
      IWORK(LTAB+12)=KSBSANN
      IWORK(LTAB+13)=KSBSCRE
C Fill in the Substring Type table
C Change the counter array into an array of offsets. Also allocate
C a translation table (POP,MS2,ISYM) to Substring Type.
      CALL GETMEM('SSTScr2','Allo','Inte',LSCR2,NSCR)
      ISSTP=0
      ISBS=0
      DO ISPART=1,NASPRT
        NO=IWORK(LNOSUB-1+ISPART)
        DO IPOP=0,NO
         DO ISYM=1,NSYM
          DO IMS2=-NO,NO
           ISCR=ISYM+NSYM*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*
     &                      (ISPART-1)))
           NSBS=IWORK(LSCR-1+ISCR)
           IWORK(LSCR-1+ISCR)=-1
           IWORK(LSCR2-1+ISCR)=-1
           IF(NSBS.GT.0) THEN
             ISSTP=ISSTP+1
             IWORK(LSCR-1+ISCR)=ISBS
             IWORK(LSCR2-1+ISCR)=ISSTP
             ISBS=ISBS+NSBS
             IWORK(LTAB-1+KSSTP+ 0+5*(ISSTP-1))=NSBS
             IWORK(LTAB-1+KSSTP+ 1+5*(ISSTP-1))=IPOP
             IWORK(LTAB-1+KSSTP+ 2+5*(ISSTP-1))=ISYM
             IWORK(LTAB-1+KSSTP+ 3+5*(ISSTP-1))=IMS2
             IWORK(LTAB-1+KSSTP+ 4+5*(ISSTP-1))=ISPART
           END IF
          END DO
         END DO
        END DO
      END DO

C Now produce all possible substrings:
CTEST      write(*,*)' Test in NEWSSTAB, producing substrings.'
CTEST      write(*,'(1x,a,8i5)')'IWORK(LOSYM-1+ISORB):',
CTEST     &                           (IWORK(LOSYM-1+ISORB),ISORB=1,NASPO)
CTEST      write(*,'(1x,a,8i5)')'IWORK(LOSPN-1+ISORB):',
CTEST     &                           (IWORK(LOSPN-1+ISORB),ISORB=1,NASPO)
      ISORB=1
      DO ISPART=1,NASPRT
        NO=IWORK(LNOSUB-1+ISPART)
        DO MRS=0,2**NO-1
          IPOP=MorsPop(MRS)
          ISYM=MorsSymm(MRS,IWORK(LOSYM-1+ISORB))
          IMS2=MorsSpin(MRS,IWORK(LOSPN-1+ISORB))
C Which substring is this?
          ISCR=ISYM+NSYM*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*
     &                     (ISPART-1)))
          ISBS=1+IWORK(LSCR-1+ISCR)
CTEST      write(*,'(1x,a,8i5)')'MRS,IPOP,IMS2,ISYM,ISBS:',
CTEST     &                      MRS,IPOP,IMS2,ISYM,ISBS
          IWORK(LSCR-1+ISCR)=ISBS
          ISSTP=IWORK(LSCR2-1+ISCR)
C Fill in the Substring/Morsel translation arrays:
          LPOS=LTAB-1+KSBSMRS+2*(ISBS-1)
          IWORK(LPOS)=MRS
          IWORK(LPOS+1)=ISSTP
          LPOS=LTAB-1+KMRSSBS+2*(MRS+(2**MORSBITS)*(ISPART-1))
          IWORK(LPOS)=ISBS
          IWORK(LPOS+1)=ISSTP
        END DO
        ISORB=ISORB+NO
      END DO
      CALL GETMEM('SSTScr','Free','Inte',LSCR,NSCR)
      CALL GETMEM('SSTScr2','Free','Inte',LSCR2,NSCR)
      CALL GETMEM('OrbSpn','Free','Inte',LOSPN,NASPO)
      CALL GETMEM('OrbSym','Free','Inte',LOSYM,NASPO)
      DO ISPART=1,NASPRT
       NO=IWORK(LNOSUB-1+ISPART)
       DO MRS=0,2**NO-1
        LPOS=LTAB-1+KMRSSBS+2*(MRS+(2**MORSBITS)*(ISPART-1))
        ISBS=IWORK(LPOS)
        ISSTP=IWORK(LPOS+1)
       END DO
      END DO

C Create the Substring Annihilator and Creator arrays, and
C also Substring Type Ann/Cre arrays.
CTEST      write(*,*)' Making annih and creat arrays:'
      DO ISPART=1,NASPRT
       NO=IWORK(LNOSUB-1+ISPART)
       DO MRS=0,2**NO-1
        LPOS=LTAB-1+KMRSSBS+2*(MRS+(2**MORSBITS)*(ISPART-1))
        ISBS=IWORK(LPOS)
        ISSTP=IWORK(LPOS+1)
        DO I=1,NO
         NEWMRS=MORSANN(MRS,I)
         IF(NEWMRS.NE.999999) THEN
          ISGN=1
          IF(NEWMRS.LT.0) ISGN=-1
          NEWMRS=ISGN*NEWMRS
C Position in Morsel-to-Substring Table
          LPOS=LTAB-1+KMRSSBS+2*(NEWMRS+(2**MORSBITS)*(ISPART-1))
C New substring times sign factor
          NEWSBS=ISGN*IWORK(LPOS)
          NEWSST=IWORK(LPOS+1)
C Put new substring in the table
          LPOS=LTAB-1+KSBSANN-1+I+MORSBITS*(ISBS-1)
          IWORK(LPOS)=NEWSBS
C Put new substring type in the Substring Type Annihil Table
          LPOS=LTAB-1+KSSTANN-1+I+MORSBITS*(ISSTP-1)
          IWORK(LPOS)=NEWSST
         END IF
        END DO
C Create: Very similar to the Annihilate code above.
        DO I=1,NO
         NEWMRS=MORSCRE(MRS,I)
         IF(NEWMRS.NE.999999) THEN
          ISGN=1
          IF(NEWMRS.LT.0) ISGN=-1
          NEWMRS=ISGN*NEWMRS
C Position in Morsel-to-Substring Table
          LPOS=LTAB-1+KMRSSBS+2*(NEWMRS+(2**MORSBITS)*(ISPART-1))
C New substring times sign factor
          NEWSBS=ISGN*IWORK(LPOS)
          NEWSST=IWORK(LPOS+1)
C Put new substring in the table
          LPOS=LTAB-1+KSBSCRE-1+I+MORSBITS*(ISBS-1)
          IWORK(LPOS)=NEWSBS
C Put new substring type in the Substring Type Creat Table
          LPOS=LTAB-1+KSSTCRE-1+I+MORSBITS*(ISSTP-1)
          IWORK(LPOS)=NEWSST
         END IF
        END DO
       END DO
      END DO

C Test section, may be removed later..
      IF(.FALSE.) THEN
C For all strings, check the anticommutation rules.
      IERR=0
      DO ISBS=1,NSBSTOT
C Its substring type
       LPOS=LTAB-1+KSBSMRS+2*(ISBS-1)
       ISSTP=IWORK(LPOS+1)
C Its subpartition
       ISPART=IWORK(LTAB-1+KSSTP+ 4+5*(ISSTP-1))
       NO=IWORK(LNOSUB-1+ISPART)
       DO I=1,NO
C Annihilate orbital nr I in the subpartition.
        LPOS=LTAB-1+KSBSANN-1+I+MORSBITS*(ISBS-1)
        ISBS1=IWORK(LPOS)
C Create orbital nr I in the subpartition.
        LPOS=LTAB-1+KSBSCRE-1+I+MORSBITS*(ISBS-1)
        ISBS2=IWORK(LPOS)
        IF(ISBS1.NE.0 .AND. ISBS2.NE.0) IERR=IERR+1
        IF(ISBS1.EQ.0 .AND. ISBS2.EQ.0) IERR=IERR+1
        DO J=1,I
C Same, for orbital J instead.
         LPOS=LTAB-1+KSBSANN-1+J+MORSBITS*(ISBS-1)
         ISBS3=IWORK(LPOS)
         LPOS=LTAB-1+KSBSCRE-1+J+MORSBITS*(ISBS-1)
         ISBS4=IWORK(LPOS)
C SBS5=A(I-)*SBS4:
         ISBS5=0
         IF(ISBS4.NE.0) THEN
           ISGN=1
           IF(ISBS4.LT.0) ISGN=-1
           LPOS=LTAB-1+KSBSANN-1+I+MORSBITS*(ABS(ISBS4)-1)
           ISBS5=ISGN*IWORK(LPOS)
         END IF
C SBS6=A(J+)*SBS1:
         ISBS6=0
         IF(ISBS1.NE.0) THEN
           ISGN=1
           IF(ISBS1.LT.0) ISGN=-1
           LPOS=LTAB-1+KSBSCRE-1+J+MORSBITS*(ABS(ISBS1)-1)
           ISBS6=ISGN*IWORK(LPOS)
         END IF
C SBS7=A(I+)*SBS3:
         ISBS7=0
         IF(ISBS3.NE.0) THEN
           ISGN=1
           IF(ISBS3.LT.0) ISGN=-1
           LPOS=LTAB-1+KSBSCRE-1+I+MORSBITS*(ABS(ISBS3)-1)
           ISBS7=ISGN*IWORK(LPOS)
         END IF
C SBS8=A(J-)*SBS2:
         ISBS8=0
         IF(ISBS2.NE.0) THEN
           ISGN=1
           IF(ISBS2.LT.0) ISGN=-1
           LPOS=LTAB-1+KSBSANN-1+J+MORSBITS*(ABS(ISBS2)-1)
           ISBS8=ISGN*IWORK(LPOS)
         END IF
C Now check:
         IF(I.NE.J) THEN
           IF(ISBS5+ISBS6.NE.0) IERR=IERR+1
           IF(ISBS7+ISBS8.NE.0) IERR=IERR+1
         ELSE
           IF(ISBS5+ISBS6.NE.ISBS) IERR=IERR+1
           IF(ISBS7+ISBS8.NE.ISBS) IERR=IERR+1
         END IF
        END DO
       END DO
      END DO
      WRITE(6,*)' NEWSSTAB: Nr of test errors IERR=',IERR
      END IF


      NEWSSTAB=LTAB
      CALL GETMEM('NOSub','Free','Inte',LNOSUB,NASPRT)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_Drv(irc,EMP2,CMO,EOcc,EVir)
C
C     Thomas Bondo Pedersen, October 2004.
C
C     Purpose: driver for computing the MP2 energy correction EMP2
C              using Cholesky decomposed two-electron integrals.
C              Input must have been processed and MO coefficients
C              and orbital energies must be passed as arguments.
C
C     Notes:
C
C       - all MO Cholesky vector files generated here are deleted before
C         exit, except for error terminations (i.e. no cleanup actions
C         are taken!)
C
      use ChoMP2, only: EFrozT, EOccuT, EVirtT
#include "implicit.fh"
      Dimension CMO(*), EOcc(*), EVir(*)
#include "cholesky.fh"
#include "chomp2.fh"
#include "chomp2g.fh"
#include "chomp2_cfg.fh"
#include "choorb.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"

      Character*3  ThisNm
      Character*10 SecNam
      Parameter (SecNam = 'ChoMP2_Drv', ThisNm = 'Drx')

      Real*8, Parameter:: Chk_Mem_ChoMP2 = 0.123456789D0, Tol = 1.0D-15
      Integer, Parameter:: iFmt = 0

      Logical DoSort, Delete
      Logical, Parameter:: Delete_def = .true.

      Real*8, Allocatable:: Check(:), Diag(:)

#if defined (_DEBUGPRINT_)
      Verbose = .true.
#endif
      If (Verbose) Then
         Call CWTime(CPUTot1,WallTot1)
      End If

C     Initializations.
C     ----------------

      irc = 0

      EMP2 = 0.0d0
      If(DoDens) Then
         EMP2_dens = 0.0d0
      End If

      If (Verbose) Then
         Call CWTime(CPUIni1,WallIni1)
      End If

      Call mma_allocate(Check,1,Label='Check')
      Check(1) = Chk_Mem_ChoMP2

      FracMem = 0.0d0 ! no buffer allocated
      Call Cho_X_Init(irc,FracMem)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_X_Init returned ',irc
         Call ChoMP2_Quit(SecNam,'Cholesky initialization error',' ')
      End If

      Call ChoMP2_Setup(irc)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': ChoMP2_Setup returned ',irc
         Go To 1  ! exit
      End If

      If(DoDens) Then
C        Write(6,*) 'Run ChoMP2g_setup'
         Call ChoMP2g_Setup(irc, EOcc, EVir)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2g_Setup returned ',irc
            Go To 1             ! exit
         End If
      End If

      If (Verbose) Then
         Call ChoMP2_Setup_Prt(irc)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_Setup_Prt returned ',irc
            Go To 1  ! exit
         End If
         Call CWTime(CPUIni2,WallIni2)
         Call Cho_PrtTim('Cholesky MP2 initialization',CPUIni2,CPUIni1,
     &                   WallIni2,WallIni1,iFmt)
      End If

C     Transform Cholesky vectors directly from reduced set to MO
C     representation. Result vectors are stored on disk.
C     If decomposition of (ai|bj) is requested, compute also the
C     (ai|ai) diagonal here.
C     ----------------------------------------------------------

      If (Verbose) Then
         Call CWTime(CPUTra1,WallTra1)
      End If
      If (DecoMP2) Then
         lDiag = nT1am(1)
         Do iSym = 2,nSym
            lDiag = lDiag + nT1am(iSym)
         End Do
      Else If(DoDens) Then
         lDiag = nMoMo(1,6)
         Do iSym = 2, nSym
            lDiag = lDiag + nMoMo(iSym,6)
         End Do
      Else
         lDiag = 1
      End If
      Call mma_allocate(Diag,lDiag,Label='Diag')
*
      If(.not.DoDens) Then
         Call ChoMP2_TraDrv(irc,CMO,Diag,DecoMP2)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_TraDrv returned ',irc
            Go To 1             ! exit
         End If
         If (Verbose) Then
            Call CWTime(CPUTra2,WallTra2)
            Call Cho_PrtTim('Cholesky MP2 transformation',CPUTra2,
     &                       CPUTra1,WallTra2,WallTra1,iFmt)
         End If
      Else If(DoDens) Then
         Call ChoMP2g_TraDrv(irc,CMO,Diag,DecoMP2)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2g_TraDrv returned ',irc
            Go To 1             ! exit
         End If
         If (Verbose) Then
            Call CWTime(CPUTra2,WallTra2)
            Call Cho_PrtTim('Cholesky MP2 transformation',CPUTra2,
     &                       CPUTra1,WallTra2,WallTra1,iFmt)
         End If
      End If

C     Finalize Cholesky info (to release memory).
C     Retain essential info: LuPri, nSym, and NumCho(*).
C     --------------------------------------------------

      nSym_Sav = nSym
      Call iCopy(nSym,NumCho,1,nMP2Vec,1)

      Call Cho_X_Final(irc)
      If (irc .ne. 0) Then
         Write(6,*) SecNam,': Cho_X_Final returned ',irc
         Go To 1 ! exit
      End If

      LuPri = 6
      nSym  = nSym_Sav
      Call iCopy(nSym,nMP2Vec,1,NumCho,1)

C     Decompose (ai|bj) integrals, if requested.
C     Set number of vectors to be used in energy calculation.
C     -------------------------------------------------------

      If (DecoMP2) Then
         If (Verbose) Then
            Call CWTime(CPUDec1,WallDec1)
         End If
         Delete = Delete_def ! delete transf. vector files after dec.
         Call ChoMP2_DecDrv(irc,Delete,Diag,'Integrals')
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_DecDrv returned ',irc
            Call ChoMP2_Quit(SecNam,'MP2 decomposition failed!',' ')
         End If
         If (Verbose) Then
            Call CWTime(CPUDec2,WallDec2)
            Call Cho_PrtTim('Cholesky MP2 decomposition',
     &                      CPUDec2,CPUDec1,
     &                      WallDec2,WallDec1,iFmt)
         End If
      Else If(DoDens) Then
         If (Verbose) Then
            Call CWTime(CPUDec1,WallDec1)
         End If
         Call ChoMP2g_AmpDiag(irc,Diag,EOcc,EVir)
         Delete = .false.    ! do not delete transf. vectors.
         Call ChoMP2_DecDrv(irc,Delete,Diag,'Amplitudes')
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_DecDrv returned ',irc
            Call ChoMP2_Quit(SecNam,'MP2 decomposition failed!',' ')
         End If
         If (Verbose) Then
            Call CWTime(CPUDec2,WallDec2)
            Call Cho_PrtTim('Cholesky MP2 decomposition',
     &                      CPUDec2,CPUDec1,
     &                      WallDec2,WallDec1,iFmt)
         End If
      Else
         Call iCopy(nSym,NumCho,1,nMP2Vec,1)
      End If
      Call mma_deallocate(Diag)

C     Presort Cholesky vectors if needed.
C     -----------------------------------

      DoSort = nBatch .gt. 1
      If (DoSort.and. (.not.DoDens)) Then
         If (Verbose) Then
            Call CWTime(CPUSrt1,WallSrt1)
         End If
         Delete = Delete_def
         Call ChoMP2_SrtDrv(irc,Delete)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_SrtDrv returned ',irc
            If (Delete) Then ! full vectors not available
               Call ChoMP2_Quit(SecNam,'MP2 presort failed!',' ')
            Else
               Write(6,*) SecNam,
     &                    ': trying to use full vectors instead...'
            End If
            DoSort = .false.
         End If
         If (Verbose) Then
            Call CWTime(CPUSrt2,WallSrt2)
            Call Cho_PrtTim('Cholesky MP2 presort',
     &                      CPUSrt2,CPUSrt1,
     &                      WallSrt2,WallSrt1,iFmt)
         End If
      End If

C     FNO section: MP2 pseudodensity
C     ------------------------------

      If (DoFNO.and.(.not.DoDens)) Then
         If (Verbose) Then
            Call CWTime(CPUDab1,WallDab1)
         End If
         Delete = Delete_def
         Call ChoMP2_FNO(irc,Work(ip_Dab),Work(ip_Dii),
     &                       EOcc,EVir,DoSort,Delete)
         call dscal_(l_Dii,-1.0d0,Work(ip_Dii),1)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_FNO returned ',irc
            Go To 1 ! exit
         End If
         If (Verbose) Then
            Call CWTime(CPUDab2,WallDab2)
            Call Cho_PrtTim('Cholesky MP2 FNO section ',
     &                      CPUDab2,CPUDab1,
     &                      WallDab2,WallDab1,iFmt)
         End If
         Go To 1 ! exit
      End If

*     Compute MP2 Density and energy correction.
*     ------------------------------------------
      If (DoDens) Then
         If (Verbose) Then
            Call CWTime(CPUEnr1,WallEnr1)
         End If
         Delete = .false.
         Call ChoMP2g_DensDrv(irc,EOccuT,EVirtT,EFrozT,CMO)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2g_DensDrv returned ',irc
            Go To 1             ! exit
         End If
      End If

*     Compute some matrices for Mp2-gradients
*     ---------------------------------------
      If(DoGrdt) Then
         If (Verbose) Then
            Call CWTime(CPUEnr1,WallEnr1)
         End If
         Call ChoMP2g_GradSetup(irc,CMO)
         If(irc .ne. 0) Then
            Write(6,*) SecNam, ':ChoMP2g_GradSetup returned ', irc
            Go To 1 ! exit
         End If
         If (Verbose) Then
            Call CWTime(CPUEnr2,WallEnr2)
            Call Cho_PrtTim('Cholesky Grad setup',
     &                      CPUEnr2,CPUEnr1,
     &                      WallEnr2,WallEnr1,iFmt)
         End If
      End If


C     Compute MP2 energy correction.
C     ------------------------------

      If (Verbose) Then
         Call CWTime(CPUEnr1,WallEnr1)
      End If
      Delete = Delete_def
      If (Laplace .and. SOS_MP2) Then
         Call ChoLSOSMP2_Energy(irc,EMP2,EOcc,EVir,DoSort,Delete)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoLSOSMP2_Energy returned ',irc
            Go To 1 ! exit
         End If
      Else
         Call ChoMP2_Energy(irc,EMP2,EOcc,EVir,DoSort,Delete)
         If (irc .ne. 0) Then
            Write(6,*) SecNam,': ChoMP2_Energy returned ',irc
            Go To 1 ! exit
         End If
      End If
      If (Verbose) Then
         Call CWTime(CPUEnr2,WallEnr2)
         Call Cho_PrtTim('Cholesky MP2 energy',
     &                   CPUEnr2,CPUEnr1,
     &                   WallEnr2,WallEnr1,iFmt)
      End If

C     Exit.
C     -----

    1 Diff = abs(Check(1)-Chk_Mem_ChoMP2)
      If (Diff .gt. Tol) Then
         Write(6,*) SecNam,': Memory Boundary Error!'
         If (irc .eq. 0) irc = -9999
      End If
      If (Verbose) Then
         Call CWTime(CPUTot2,WallTot2)
         Call Cho_PrtTim('Cholesky MP2',CPUTot2,CPUTot1,
     &                   WallTot2,WallTot1,iFmt)
      End If
      Call ChoMP2_deallocate(irc)
      Call mma_deallocate(Check)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LA_Morok(nAtom,CorG,iMode)
      Implicit Real*8 (a-h,o-z)
      Real*8 CorG(3,nAtom)
c
c     Morokuma's scaling scheme:
c       k = (q_LA - q_QM)/(q_MM - q_QM), k = constant
c
c     iMode = 1 => the LA gradient is distributed
c     on the frontier QM and MM atoms according to:
c     dE/dq_QM = dE/dq_QM + dE/dq_LA * dq_LA/dq_QM
c     dE/dq_MM = dE/dq_MM + dE/dq_LA * dq_LA/dq_MM
c
c     iMode = 2 => the LA position is updated
c     q_LA = q_QM + k * (q_MM - q_QM)
c
#include "espf.fh"
      Include 'stdalloc.fh'
*
      Logical Exist,Exist2,isOkLA,isOkMM,isOkQM,lMorok
      Logical DoTinker,DoGromacs
      Character*10 ESPFKey
      Character*180 Line
      Character*180 Get_Ln
      Character*256 Message
      External Get_Ln
*
      Integer, Dimension(:), Allocatable :: AT,GroToMol
      Integer, Dimension(:,:), Allocatable :: DefLA
      Real*8, Dimension(:), Allocatable :: FactLA
*
      iPL = iPL_espf()
      lMorok = .False.
      DoTinker = .False.
      DoGromacs = .False.
      Call F_Inquire('ESPF.DATA',Exist)
      If (Exist) Then
         IPotFl = IsFreeUnit(1)
         Call Molcas_Open(IPotFl,'ESPF.DATA')
10       Line = Get_Ln(IPotFl)
         ESPFKey = Line(1:10)
         If (ESPFKey.eq.'LA_MOROK  ') Then
            lMorok = .True.
         Else If (ESPFKey.eq.'TINKER    ') Then
            DoTinker = .True.
         Else If (ESPFKey.eq.'GROMACS   ') Then
            DoGromacs = .True.
         Else If (ESPFKey.eq.'ENDOFESPF ') Then
            Goto 11
         EndIf
         Goto 10
11       Close (IPotFl)
      End If
      If (.not.lMorok) Return
#ifdef _DEBUGPRINT_
      iPL = 4
      Call RecPrt('LA_Morok: coord or grad:',' ',CorG,3,nAtom)
#endif
c
c Tinker part
c
      Exist = .False.
      If (DoTinker) Then
         Call F_Inquire('QMMM',Exist)
      End If
      If(Exist) Then
         ITkQMMM=IsFreeUnit(25)
         Call Molcas_Open(ITkQMMM,'QMMM')
         Line = ' '
         Do While (Index(Line,'TheEnd ') .eq. 0)
            Line=Get_Ln(ITkQMMM)
            If (Index(Line,'LAH').ne.0) Then
               Call Get_I1(2,iLA)
               Call Get_I1(3,iMM)
               Call Get_I1(4,iQM)
               Call Get_F1(5,Fact)
               If (iMM.lt.1 .or. iQM.lt.1) Then
                  Write (6,*) 'LA_Morok: link atoms badly defined'
                  Write (6,*) '          check each LA connectivity'
                  Call Quit_OnUserError()
               End If
#ifdef _DEBUGPRINT_
               Write(6,*)
               Write(6,*) 'LA_Morok: LAH ',iLA,' between ',iQM,
     &                                             ' and ',iMM
               Write(6,*) '          scaling factor : ',Fact
#endif
               If (iMode .eq. 1) Then
                  If (iPL.ge.2) Write(6,*) 'LA_Morok: scaling gradients'
                  Do iXYZ = 1, 3
                     CorG(iXYZ,iQM)=CorG(iXYZ,iQM)+
     &                              CorG(iXYZ,iLA)*(One-Fact)
                     CorG(iXYZ,iMM)=CorG(iXYZ,iMM)+
     &                              CorG(iXYZ,iLA)*Fact
                     CorG(iXYZ,iLA)=Zero
                  End Do
               Else If (iMode .eq. 2) Then
                  If (iPL.ge.2) Write(6,*)'LA_Morok: updating positions'
                  Do iXYZ = 1, 3
                     CorG(iXYZ,iLA) = CorG(iXYZ,iQM) + (CorG(iXYZ,iMM)
     &                              - Corg(iXYZ,iQM))*Fact
                  End Do
               Else
                  Write (6,*) 'LA_Morok: wrong iMode'
                  Call Quit_OnUserError()
               End If
            End If
         End Do
         Close (ITkQMMM)
      End If
*
* Gromacs part
*
      Exist = .False.
      If (DoGromacs) Then
         Call Qpg_iArray('LA Def',Exist,nLink)
      End If
      If (Exist) Then
         nLink = nLink/3
         Call mma_allocate(DefLA,3,nLink)
         Call mma_allocate(FactLA,nLink)
         Call Get_iArray('LA Def',DefLA,3*nLink)
         Call Get_dArray('LA Fact',FactLA,nLink)
* Check for consistency
         Call Qpg_iArray('Atom Types',Exist2,nTot)
         If (.Not.Exist2) Then
            Message = 'LA_Morok: no atom type info on runfile'
            Call WarningMessage(2,Message)
            Call Abend
         End If
         Call mma_allocate(AT,nTot)
         Call Get_iArray('Atom Types',AT,nTot)
         Do iLink = 1,nLink
            isOkLA = AT(DefLA(1,iLink)).Eq.QM
            isOkQM = AT(DefLA(2,iLink)).Eq.QM
            isOkMM = AT(DefLA(3,iLink)).Eq.MMI
            If (.Not.(isOkLa.And.isOkQM.And.isOkMM)) Then
               Message = 'Link atoms badly defined. Check input!'
               Call WarningMessage(2,Message)
               Call Abend()
            End If
         End Do
* Generate vector for translating from Gromacs to Molcas numbering
         Call mma_allocate(GroToMol,nTot)
         iAtIn = 1
         iAtOut = 1
         Do iAt = 1,nTot
            If (AT(iAt).Eq.QM.Or.AT(iAt).Eq.MMI) Then
               GroToMol(iAt) = iAtIn
               iAtIn = iAtIn+1
            Else If (AT(iAt).Eq.MMO) Then
               GroToMol(iAt) = iAtOut
               iAtOut = iAtOut+1
            Else
               Message = 'LA_Morok: unknown atom type'
               Call WarningMessage(2,Message)
               Call Abend()
            End If
         End Do
* Apply Morokuma scheme to gradient...
         If (iMode.Eq.1) Then
            If (iPL.GE.2) Then
               Write(6,*) 'Applying Morokuma scheme to gradient'
            End If
            Do iLink = 1,nLink
               iLA = GroToMol(DefLA(1,iLink))
               iQM = GroToMol(DefLA(2,iLink))
               iMM = GroToMol(DefLA(3,iLink))
               Fact = FactLA(iLink)
               Do ixyz = 1,3
                  CorG(ixyz,iQM) = CorG(ixyz,iQM)
     &                           + CorG(ixyz,iLA)*(1-Fact)
                  CorG(ixyz,iMM) = CorG(ixyz,iMM)
     &                           + CorG(ixyz,iLA)*Fact
                  CorG(ixyz,iLA) = Zero
               End Do
            End Do
* ...or to position
         Else If (iMode.Eq.2) Then
            If (iPL.GE.2) Then
               Write(6,*) 'Applying Morokuma scheme to positions'
            End If
            Do iLink = 1,nLink
               iLA = GroToMol(DefLA(1,iLink))
               iQM = GroToMol(DefLA(2,iLink))
               iMM = GroToMol(DefLA(3,iLink))
               Fact = FactLA(iLink)
               Do ixyz = 1,3
                  CorG(ixyz,iLA) = CorG(ixyz,iQM)
     &                           +(CorG(ixyz,iMM) - CorG(ixyz,iQM))*Fact
               End Do
            End Do
         Else
            Message = 'LA_Morok: wrong iMode'
            Call WarningMessage(2,Message)
            Call Abend()
         End If
         Call mma_deallocate(DefLA)
         Call mma_deallocate(FactLA)
         Call mma_deallocate(AT)
         Call mma_deallocate(GroToMol)
      End If
c
#ifdef _DEBUGPRINT_
      Call RecPrt('LA_Morok: coord or grad:',' ',CorG,3,nAtom)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_SetRed(Diag,Sync)
C
C     Purpose: set next reduced set after synchronizing the global
C              diagonal (if requested through flag Sync).
C              Global as well as local reduced sets are set.
C              Diag is the local diagonal, whereas Diag_G (defined in
C              choswp.f90) points to the global diagonal.
C              Note that Diag is not referenced if Sync=.False.
C
      use ChoSwp, only: Diag_G
      Implicit None
      Real*8  Diag(*)
      Logical Sync
#include "cholesky.fh"
#include "choglob.fh"
#include "cho_para_info.fh"

      Integer iLoc

      If (Cho_Real_Par) Then

C        Sync global diagonal.
C        ---------------------

         If (Sync) Then
            iLoc = 2
            Call Cho_P_SyncDiag(Diag,iLoc)
         End If

C        Set next global reduced set. The original serial routines
C        are used and so we must trick them by first swapping global
C        and local index arrays (and then swap back, of course).
C        -----------------------------------------------------------

         Call Cho_P_IndxSwp()
         Call Cho_SetRed(Diag_G)
         Call Cho_P_IndxSwp()

C        Set next local reduced set.
C        ---------------------------

         Call Cho_P_SetRed_L()

      Else

         Call Cho_SetRed(Diag)

      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function D_Cart(Ind,nSym)

use Slapaf_Info, only: nStab
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: D_Cart
integer(kind=iwp), intent(in) :: Ind, nSym
integer(kind=iwp) :: iAtom, iDeg, nU_A

!                                                                      *
!***********************************************************************
!                                                                      *
! Cartesian coordinate  (iAtom)

D_Cart = Zero

iAtom = Ind

nU_A = nStab(iAtom)

! Now evaluate the degeneracy of the cartesian

iDeg = nSym/nU_A
d_cart = real(iDeg,kind=wp)

!write(u6,*) ' d_cart=',d_cart

return

end function D_Cart

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Numerical_Gradient(ireturn)
#ifndef _HAVE_EXTRA_
      Use Prgm
#endif
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "standard_iounits.fh"
#include "WrkSpc.fh"
#include "timtra.fh"
#include "real.fh"
#include "warnings.fh"
#include "constants2.fh"
#include "stdalloc.fh"
      Real*8 Energy_Ref
      Integer iOper(0:7), iChCar(3), jStab(0:7), iCoSet(0:7,0:7),
     &        iDispXYZ(3)
      Character*8 Method
      Character AtomLbl(MxAtom)*(LENIN)
      Character Namei*(LENIN)
      Character*10 ESPFKey
      Character*180 Line,Get_Ln
      External Get_Ln
      External Rsv_Tsk
#if defined (_MOLCAS_MPP_) && !defined(_GA_)
      Character*80  SSTMNGR
      Integer  SSTMODE
      Logical  Rsv_Tsk_Even,King
      External Rsv_Tsk_Even,King
#endif
      Logical DispX, DispY, DispZ,Rsv_Tsk, Is_Roots_Set, Found,
     &        External_Coor_List, Do_ESPF, StandAlone, Exist, DoTinker,
     &        NMCart, DynExtPot, DoDirect, KeepOld, Reduce_Prt
      External Reduce_Prt
      Real*8 FX(3)
      Real*8, Allocatable, Dimension(:,:) :: EnergyArray, GradArray,
     &                                       OldGrads
      Real*8, Allocatable, Dimension(:) :: Grad, GNew
      Integer rc, Read_Grad
      External Read_Grad
      Parameter (ToHartree = CONV_CAL_TO_J_ /
     &           CONV_AU_TO_KJ_PER_MOLE_)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     Get the print level.
*
      iPL_Save=iPrintLevel(-1)
      iPL=iPL_Save

      If (Reduce_Prt().and.iPL.lt.3) iPL=0
*                                                                      *
************************************************************************
*                                                                      *
      ireturn=_RC_ALL_IS_WELL_
*
*     Get information regarding the last method used
*
      Call Get_cArray('Relax Method',Method,8)
      Call DecideOnESPF(Do_ESPF)
      Is_Roots_Set = .False.
      Call Qpg_iScalar('Number of roots',Is_Roots_Set)
      If (Is_Roots_Set) Then
         Call Get_iScalar('Number of roots',nRoots)
         If (nRoots.eq.1) Then
            iRoot=1
         Else
            Call qpg_iScalar('NumGradRoot',Found)
            If (Found) Then
               Call Get_iScalar('NumGradRoot',iRoot)
            Else
               iRoot=1
            End If
         End If
      Else
         nRoots = 1
         iRoot  = 1
      End If
      Call Allocate_Work(ipEnergies_Ref,nRoots)
C     Print *,'Is_Roots_Set, nRoots, iRoot = ',Is_Roots_Set,nRoots,iRoot
      If (iRoot .gt. nRoots) Then
         Write(LuWr,*)
         Write(LuWr,*) '****************** ERROR ******************'
         Write(LuWr,*) 'It was selected to run numerical gradient'
         Write(LuWr,*) 'using energies for root/state number ',iRoot
         Write(LuWr,*) 'but only ',nRoots,' exists.'
         Write(LuWr,*) '*******************************************'
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (nRoots .gt. 1) Then
         Call Get_dArray('Last energies',Work(ipEnergies_Ref),nRoots)
      Else
         Call Get_dScalar('Last energy',Work(ipEnergies_Ref+iRoot-1))
      End If
      Call Get_iScalar('Unique atoms',nAtoms)
      Call Allocate_Work(ipCoor,3*nAtoms)
      Call Get_cArray('Unique Atom Names',AtomLbl,LENIN*nAtoms)
      Call Get_dArray('Unique Coordinates',Work(ipCoor),3*nAtoms)
      If (iPL_Save.ge.3)
     &     Call RecPrt('Original coordinates',' ',Work(ipCoor),3,nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
*     If this is a QM/MM calculation, the gradient on the MM atoms
*     is analytical (using the ESPF method for the QM/MM electrostatics)
*     Accordingly, no need to loop over the MM atoms
*
      DoTinker = .False.
      DoDirect = .False.
      ipMltp = ip_Dummy
      Call F_Inquire('ESPF.DATA',Exist)
      If (Exist) Then
         IPotFl = IsFreeUnit(15)
         Call Molcas_Open(IPotFl,'ESPF.DATA')
         Line = ' '
         Do While (Index(Line,'ENDOFESPF ') .eq. 0)
            Line = Get_Ln(IPotFl)
            If (Index(Line,'TINKER ') .ne. 0) Then
              DoTinker = .True.
            Else If (Index(Line,'DIRECT ') .ne. 0) Then
              DoDirect = .True.
            Else If (Index(Line,'MLTORD ') .ne. 0) Then
              Call Get_I1(2,MltOrd)
              ibla = 0
              Do ii = 0, MltOrd
                 ibla = ibla + (ii+2)*(ii+1)/2
              End Do
              MltOrd = ibla
            Else If (Index(Line,'MULTIPOLE ') .ne. 0) Then
              Call Get_I1(2,nMult)
              Call Allocate_Work(ipMltp,nMult)
              Do iMlt = 1, nMult, MltOrd
                Line = Get_Ln(IPotFl)
                Call Get_I1(1,iAt)
                Call Get_F(2,Work(ipMltp+iMlt-1),MltOrd)
              End Do
            End If
         End Do
         Close (IPotFl)
      End If
*
      nAtMM = 0
      If (DoTinker) Then
         Call MMCount(nAtoms,nAtMM,ipIsMM)
         If (nAtMM .gt. 0) Then
            iQMChg = 0
            StandAlone = .False.
            Call RunTinker(nAtoms,ipCoor,ipMltp,ipIsMM,MltOrd,
     &               DynExtPot,iQMchg,iBlabla,StandAlone,DoDirect)
            Call Allocate_Work(ipMMGrd,3*nAtoms)
            Call FZero(Work(ipMMGrd),3*nAtoms)
            ITkQMMM=IsFreeUnit(15)
            Call Molcas_Open(ITkQMMM,'QMMM')
            Line = ' '
            Do While (Index(Line,'TheEnd') .eq. 0)
               Line = Get_Ln(ITkQMMM)
               If (Index(Line,'MMGradient') .ne. 0) Then
                  Call Get_I1(2,iAtom)
                  Call Get_F(3,FX,3)
                  If (iWork(ipIsMM+iAtom-1) .eq. 1)
     &                Call dCopy_(3,FX,1,Work(ipMMGrd+3*(iAtom-1)),1)
               End If
            End Do
            Call DScal_(3*nAtoms,Angstrom*ToHartree,Work(ipMMGrd),1)
            Close(ITkQMMM)
            If (iPL_Save .ge. 3) Call RecPrt('MM Grad:',' ',
     &                                      Work(ipMMGrd),3,nAtoms)
         End If
         If (ipMltp .ne. ip_Dummy) Call Free_Work(ipMltp)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Pick up rDelta from the runfile
      Call Get_dScalar('Numerical Gradient rDelta',rDelta)
*                                                                      *
************************************************************************
*                                                                      *
*     Check if there is a coordinate list from Slapaf on the run file.
*     Read the B-matrix and T-matrix. To be used in case of
*     differentiation in internal coordinates according to Slapaf.
*
      If (nAtMM .eq. 0) Call GenCxCTL(iRC,NMCart,rDelta)
*
      Call qpg_dArray('CList',Found,nCList)
      If (Found) Then
         External_Coor_List=.True.
         Call Get_iScalar('No of Internal Coordinates',mInt)
         Call Get_iScalar('nLambda',nLambda)
         nBMtrx=(3*nAtoms)*mInt
         Call GetMem('BMtrx','Allo','Real',ip_BMtrx,nBMtrx)
         Call GetMem('TMtrx','Allo','Real',ip_TMtrx,mInt**2)
         Call Get_dArray('BMtrx',Work(ip_BMtrx),nBMtrx)
         Call Get_dArray('T-Matrix',Work(ip_TMtrx),mInt**2)
      Else
         NMCart=.FALSE.
         External_Coor_List=.False.
         mInt=3*nAtoms
         nLambda=0
         nBMtrx=(3*nAtoms)**2
         Call GetMem('BMtrx','Allo','Real',ip_BMtrx,nBMtrx)
         Call GetMem('TMtrx','Allo','Real',ip_TMtrx,mInt**2)
         Call FZero(Work(ip_BMtrx),nBMtrx)
         call dcopy_(3*nAtoms,[One],0,Work(ip_BMtrx),3*nAtoms+1)
         Call FZero(Work(ip_TMtrx),mInt**2)
         call dcopy_(mInt,[One],0,Work(ip_TMtrx),mInt+1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (Method(5:7) .eq. 'SCF'    .OR.
     &    Method(1:6) .eq. 'KS-DFT' .OR.
     &    Method(1:6) .eq. 'CASSCF' .OR.
     &    Method(1:6) .eq. 'RASSCF' .OR.
     &    Method(1:6) .eq. 'GASSCF' .OR.
     &    Method(1:6) .eq. 'CASPT2' .OR.
     &    Method(1:5) .eq. 'MBPT2'  .OR.
     &    Method(1:5) .eq. 'CCSDT'  .OR.
     &    Method(1:4) .eq. 'CHCC'   .OR.
     &    Method(1:6) .eq. 'MCPDFT' .OR.
     &    Method(1:4) .eq. 'CHT3'   .OR.
     &    Method(1:8) .eq. 'EXTERNAL') Then
         If (iPL_Save.ge.3) Then
            Write (LuWr,*)
            Write (LuWr,'(A,A,A)')
     &    ' Numerical_Gradient: Original ',Method,' Energies:'
            Write (LuWr,'(G21.14)')
     &    (Work(ipEnergies_Ref+i-1),i=1,nRoots)
            Write (LuWr,*)
         End If
      Else
         Write (LuWr,'(A,A,A)') 'Numerical gradient for ',Method,
     &                    ' is not implemented yet.'
         Call Abend()
      End If
*
      nDisp2 = 2*3*nAtoms
      Call mma_Allocate(EnergyArray,nRoots,nDisp2)
      Call FZero(EnergyArray,nRoots*nDisp2)
*                                                                      *
************************************************************************
*                                                                      *
*     Pick up symmetry information
*
      Call Get_iScalar('nSym',nSym)
      nIrrep=nSym
      Call Get_iArray('Symmetry operations',iOper,nSym)
      iSymX = 0
      iSymY = 0
      iSymZ = 0
      Do i = 0, nSym-1
         If (iAnd(iOper(i),1).ne.0) iSymX = 1
         If (iAnd(iOper(i),2).ne.0) iSymY = 2
         If (iAnd(iOper(i),4).ne.0) iSymZ = 4
      End Do
      iChCar(1) = iSymX
      iChCar(2) = iSymY
      iChCar(3) = iSymZ
      MaxDCR = nIrrep
*                                                                      *
************************************************************************
*                                                                      *
*     Set up displacement vector
*
      Call Get_nAtoms_All(nAll)
      Call Allocate_Work(ipAll,3*nAll)
      Call Get_Coord_All(Work(ipAll),nAll)
*                                                                      *
************************************************************************
*                                                                      *
      If (External_Coor_List) Then
*
*        Externally define displacement list
*
         nDisp=mInt
         Call Allocate_Work(ipDisp,mInt)
         Call Get_dArray('DList',Work(ipDisp),mInt)
*        Call RecPrt('Dlist',' ',Work(ipDisp),1,mInt)
*
      Else
*
*        Cartesian displacement list
*
         nDisp=3*nAtoms
         Call Allocate_Work(ipDisp,nDisp)
         Call FZero(Work(ipDisp),nDisp)
*
         Do i = 1, nAtoms
*
*           Find the stabilizer of this center
*
            iChxyz=iChAtm(Work(ipCoor+(i-1)*3))
            Call Stblz(iChxyz,nStab,jStab,MaxDCR,iCoSet)
*
            Call IZero(iDispXYZ,3)
            Do j = 0, nStab-1
               If (iAnd(jStab(j),1).ne.0) Then
                  iDispXYZ(1)=iDispXYZ(1)-1
               Else
                  iDispXYZ(1)=iDispXYZ(1)+1
               End If
               If (iAnd(jStab(j),2).ne.0) Then
                  iDispXYZ(2)=iDispXYZ(2)-1
               Else
                  iDispXYZ(2)=iDispXYZ(2)+1
               End If
               If (iAnd(jStab(j),4).ne.0) Then
                  iDispXYZ(3)=iDispXYZ(3)-1
               Else
                  iDispXYZ(3)=iDispXYZ(3)+1
               End If
            End Do
*
*           If this is a MM atom, don't make displacements
*
            If (DoTinker .and. iWork(ipIsMM+i-1) .eq. 1)
     &        Call IZero(iDispXYZ,3)
            DispX=iDispXYZ(1).ne.0
            DispY=iDispXYZ(2).ne.0
            DispZ=iDispXYZ(3).ne.0
            x0= Work(ipCoor+(i-1)*3  )
            y0= Work(ipCoor+(i-1)*3+1)
            z0= Work(ipCoor+(i-1)*3+2)
*
*           Find the shortest distance to another atom!
*
            rMax=1.0D19
            Do j = 1, nAll
               x = Work(ipAll+(j-1)*3  )
               y = Work(ipAll+(j-1)*3+1)
               z = Work(ipAll+(j-1)*3+2)
               rTest=Sqrt((x-x0)**2+(y-y0)**2+(z-z0)**2)
               If (rTest.eq.Zero) rTest=1.0D19
               rMax=Min(rMax,rTest)
            End Do
            If (DispX) Work(ipDisp+(i-1)*3  )=rDelta*rMax
            If (DispY) Work(ipDisp+(i-1)*3+1)=rDelta*rMax
            If (DispZ) Work(ipDisp+(i-1)*3+2)=rDelta*rMax
         End Do
*        Call RecPrt('Work(ipDisp)',' ',Work(ipDisp),1,nDisp)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Allocate_Work(ipDeg,3*nAtoms)
      Call FZero(Work(ipDeg),3*nAtoms)
      Do i = 1, nAtoms
         rDeg=DBLE(iDeg(Work(ipCoor+(i-1)*3)))
         Work(ipDeg+(i-1)*3  )=rDeg
         Work(ipDeg+(i-1)*3+1)=rDeg
         Work(ipDeg+(i-1)*3+2)=rDeg
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('XYZ','Allo','Real',ipXYZ,3*nAtoms*2*nDisp)
      Call FZero(Work(ipXYZ),3*nAtoms*2*nDisp)
      If (External_Coor_List) Then
         mDisp=nDisp*2
         Call Get_dArray('CList',Work(ipXYZ),3*nAtoms*mDisp)
      Else
         mDisp=0
         Do iDisp = 1, nDisp2
            icoor=(iDisp+1)/2
            If (Work(ipDisp+icoor-1).eq.Zero) Go To 101
            mDisp=mDisp+1
*
*--------   Modify the geometry
*
            jpXYZ = ipXYZ + (mDisp-1)*3*nAtoms
            call dcopy_(3*nAtoms,Work(ipCoor),1,Work(jpXYZ),1)
            Sign=One
            If (Mod(iDisp,2).eq.0) Sign=-One
            Work(jpXYZ+icoor-1) = Work(jpXYZ+icoor-1)
     &                          + Sign*Work(ipDisp+icoor-1)
 101        Continue
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Save the "new geometry" field from the RunFile, if any
*
      Call qpg_dArray('GeoNew',Found,nGNew)
      If (.not.Found) nGNew=0
      If (nGNew.gt.0) Then
        Call mma_allocate(GNew,nGNew)
        Call Get_dArray('GeoNew',GNew,nGNew)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Save global print level
*
      iPL_Save=iPrintLevel(-1)
      iPL_Base=0
      If (iPL_Save.ge.3) iPl_Base=iPL_Save
*
#ifdef _DEBUGPRINT_
      Call RecPrt('BMtrx',' ',Work(ip_BMtrx),3*nAtoms,mInt)
      Call RecPrt('TMtrx',' ',Work(ip_TMtrx),mInt,mInt)
      Call RecPrt('Degeneracy vector',' ',Work(ipDeg),3,nAtoms)
      Call RecPrt('Coordinate List',' ',Work(ipXYZ),3*nAtoms,mDisp)
#endif

*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Loop over displacements
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      If (iPL.ge.2) Then
         Write (LuWr,*) 'Root to use: ',iRoot
         Write (LuWr,*) 'Number of internal degrees            ', nDisp
         Write (LuWr,*) 'Number of constraints                 ',
     &                  nLambda
         Write (LuWr,*) 'Number of displacements               ',
     &                   nDisp*2
         If (nAtMM.ne.0 .and. DoTinker .and. .not.DoDirect) Then
            Write(LuWr,*) 'Number of MM degrees (analytical grad)',
     &                    nAtMM*3
         End If
         Write (LuWr,*) 'Effective number of displacements     ',
     &                   2*(nDisp-nLambda-3*nAtMM)
         Write (LuWr,*) 'Relative displacements                ',
     &                   rDelta
         Write (LuWr,*)
      End If
*
*     This printout is disabled since it means different things for
*     externally defined coordinates or not.
*
      If (iPL.ge.3) Then
#ifdef _HIDE_
         Write (LuWr,'(1x,A)')
     &                 '---------------------------------------------'
         Write (LuWr,'(1x,A)')
     &                 '               X           Y           Z     '
         Write (LuWr,'(1x,A)')
     &                 '---------------------------------------------'
         Do iAtom = 1, nAtoms
            TempX = Work(ipDisp+3*(iAtom-1)+0)
            TempY = Work(ipDisp+3*(iAtom-1)+1)
            TempZ = Work(ipDisp+3*(iAtom-1)+2)
            Namei = AtomLbl(iAtom)
            Write (LuWr,'(2X,A,3X,3F12.6)') Namei, TempX, TempY, TempZ
         End Do
#endif
         Write (LuWr,'(1x,A)')
     &              '---------------------------------------------'
         Write (LuWr,*)
         Write (LuWr,*) 'Here we go ...'
         Write (LuWr,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Change output unit
*
      Call Get_MyRank(MyRank)
      Call Get_nProcs(nProcs)
      LuWr_save=LuWr
      If (MyRank.ne.0) Then
         LuWr=55
         LuWr=isFreeUnit(LuWr)
         call molcas_open(luwr,'Temp_OutPut')
      End If
*
* FM 16/4/2013
* ESPF charges are set to zero so that no microiterations will be
* performed during numerical gradient
* IFG: swap files, as now NG uses a subdirectory
*
      iSave=15
      If (Do_ESPF) Then
         iSave = IsFreeUnit(iSave)
         Call Molcas_Open(iSave,'ESPF.SAV')
         iData = IsFreeUnit(iSave)
         Call Molcas_Open(iData,'ESPF.DATA')
96       Line = Get_Ln(iData)
         ESPFKey = Line(1:10)
         If (ESPFKey.eq.'ENDOFESPF ') Then
            Write(iSave,'(A132)') Line
            Goto 98
         End If
         If (ESPFKey.ne.'MULTIPOLE ') Then
            Write(iSave,'(A132)') Line
         Else
            Call Get_I1(2,nMult)
            Do iMlt = 1, nMult
               Line = Get_Ln(iData)
            End Do
         End If
         Goto 96
98       Close (iSave)
         Close (iData)
      EndIf
* FM End
*                                                                      *
************************************************************************
*                                                                      *
* Parallel loop over the nDisp displacements.
* Reserve task on global task list and get task range in return.
* Function will be false if no more tasks to execute.
#if !defined(_GA_) && defined(_MOLCAS_MPP_)
      Call getenvf('MOLCAS_SSTMNGR',SSTMNGR)
      If (SSTMNGR(1:1).eq.'Y') Then
          SSTMODE=1
      Else
          SSTMODE=0
      End If
      If (SSTMODE.eq.1) Then
         Call Init_Tsk(id_Tsk,mDisp-2*nLambda)
      Else
         Call Init_Tsk_Even(id_Tsk,mDisp-2*nLambda)
      End If
#else
      Call Init_Tsk(id_Tsk,mDisp-2*nLambda)
#endif
      Call Allocate_Work(ipC,3*nAtoms)
   10 Continue
#if defined (_MOLCAS_MPP_) && !defined(_GA_)
         If (SSTMODE.eq.1) Then
           If (.Not. Rsv_Tsk(id_Tsk,iDisp)) Goto 11
         Else
           If (.Not. Rsv_Tsk_Even(id_Tsk,iDisp)) Goto 11
         End If
#else
         If (.Not. Rsv_Tsk(id_Tsk,iDisp)) Goto 11
#endif
*
*        Offset for the constraints
*
         iDisp = iDisp + 2*nLambda
*
*------- Get the displaced geometry
*
         jpXYZ = ipXYZ + (iDisp-1)*3*nAtoms
         call dcopy_(3*nAtoms,Work(jpxyz),1,Work(ipC),1)
*        Call RecPrt('Work(ipC)',' ',Work(ipC),3*nAtoms,1)
         Call Put_Coord_New(Work(ipC),nAtoms)
*
*        Compute integrals
*
*        jPL     =iPrintLevel(Max(iPL_Base,0)) ! Silent
         Call Set_Do_Parallel(.False.)
*
*        Switch to a new directory
*        WARNING WARNING WARNING WARNING WARNING
*          ugly hack, do not try this at home
         Call SubWorkDir()
*        WARNING WARNING WARNING WARNING WARNING
*
         Call StartLight('seward')
         Call init_run_use()
         Call init_ppu(.True.)
         Call Disable_Spool()
         Call Seward(ireturn)
         Call ReClose()
         If (iReturn .ne. 0) Then
            Write(LuWr,*) 'Numerical_Gradient failed ...'
            Write(LuWr,*)'Seward returned with return code, rc = ',
     &                    iReturn
            Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
            Call Abend()
         End If
*
*        Compute the ESPF stuff
*
         If (Do_ESPF) Then
            Call StartLight('espf')
            Call init_run_use()
            Call Disable_Spool()
            StandAlone=.True.
            Call ESPF(ireturn,StandAlone)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*)'ESPF returned with return code, rc = ',
     &                       iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         End If
*
*        Compute the wave function
*
         If (Method(5:7) .eq. 'SCF' .OR.
     &       Method(1:6) .eq. 'KS-DFT' .OR.
     &       Method(1:5) .eq. 'MBPT2' .OR.
     &       Method(1:4) .eq. 'CHCC' .OR.
     &       Method(1:4) .eq. 'CHT3') Then
            Call StartLight('scf')
            Call init_run_use()
            Call Disable_Spool()
            Call xml_open('module',' ',' ',0,'scf')
            Call SCF(iReturn)
            Call xml_close('module')
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'SCF returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         Else If (Method(1:6) .eq. 'RASSCF' .OR.
     &            Method(1:6) .eq. 'GASSCF' .OR.
     &            Method(1:6) .eq. 'CASSCF' .OR.
     &            Method(1:6) .eq. 'MCPDFT' .OR.
     &            Method(1:6) .eq. 'CASPT2' .OR.
     &            Method(1:5) .eq. 'CCSDT') Then
            Call StartLight('rasscf')
            Call init_run_use()
            Call Disable_Spool()
            Call RASSCF(ireturn)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'RASSCF returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         Else If (Method(1:8) .eq. 'EXTERNAL') Then
            Call StartLight('false')
            Call init_run_use()
            Call Disable_Spool()
            Call False_program(ireturn)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'FALSE returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         End If
*
         If (Method(1:5) .eq. 'MBPT2') Then
            Call StartLight('mbpt2')
            Call init_run_use()
            Call Disable_Spool()
            Call MP2_Driver(ireturn)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'MBPT2 returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         End If
*
         If (Method(1:5) .eq. 'CCSDT') Then
            Call StartLight('motra')
            Call init_run_use()
            Call Disable_Spool()
            Call Motra(ireturn)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'Motra returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
*
            Call StartLight('ccsdt')
            Call init_run_use()
            Call Disable_Spool()
            Call CCSDT(ireturn)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'CCSDT returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         End If
*
         If (Method(1:4) .eq. 'CHCC' .OR.
     &       Method(1:4) .eq. 'CHT3') Then
            Call StartLight('chcc')
            Call init_run_use()
            Call Disable_Spool()
            Call CHCC(ireturn)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'CHCC returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         End If
*
         If (Method(1:4) .eq. 'CHT3') Then
            Call StartLight('cht3')
            Call init_run_use()
            Call Disable_Spool()
            Call CHT3(ireturn)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'CHT3 returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         End If
*
         If (Method(1:6) .eq. 'CASPT2') Then
            Call StartLight('caspt2')
            Call init_run_use()
            Call Disable_Spool()
            Call CASPT2(ireturn)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'CASPT2 returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         End If

         If (Method(1:6) .eq. 'MCPDFT') Then
            Call StartLight('mcpdft')
            Call init_run_use()
            Call Disable_Spool()
            Call MCPDFT(ireturn)
            Call ReClose()
            If (iReturn .ne. 0) Then
               Write(LuWr,*) 'Numerical_Gradient failed ...'
               Write(LuWr,*) 'MCPDFT returned with return code, rc = ',
     &                     iReturn
               Write(LuWr,*) 'for the perturbation iDisp = ',iDisp
               Call Abend()
            End If
         End If
*
*        Call Get_Energy(EnergyArray(iRoot,iDisp))
         If (nRoots .gt. 1) Then
            Call Get_dArray('Last energies',EnergyArray(1,iDisp),nRoots)
         Else
            Call Get_dScalar('Last energy',EnergyArray(iRoot,iDisp))
         End If
*
*        Restore directory and prgm database
*
         Call ParentWorkDir()
         Call prgmfree()
         Call prgminit('numerical_gradient')
*
         Call Set_Do_Parallel(.True.)

         If (iPL.ge.2) Then
            Write (LuWr,200)'   * Point #',iDisp-2*nLambda,' of ',
     &                                2*(nDisp-nLambda-3*nAtMM),' done.'
            Write (LuWr,200)'    (Perturbation ',iDisp,')'
         End If
 200     Format(A,I4,A,I4,A)
*                                                                      *
************************************************************************
*                                                                      *
#if defined (_MOLCAS_MPP_) && !defined(_GA_)
         If(King().and.nProcs.gt.1.and.SSTMODE.eq.1) Go To 11
#endif
         Go To 10
  11  Continue
C_MPP End Do
#if !defined(_GA_) && defined(_MOLCAS_MPP_)
      If (SSTMODE.eq.1) Then
         Call Free_Tsk(id_Tsk)
      Else
         Call Free_Tsk_Even(id_Tsk)
      End If
#else
      Call Free_Tsk(id_Tsk)
#endif
      Call GADSum(EnergyArray,nRoots*mDisp)
      Call Free_Work(ipC)
      Call GetMem('XYZ','Free','Real',ipXYZ,nDisp*3*nAtoms)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     End of Loop                                                      *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Flush the output from the other nodes.
*
      Do iRank = 1, nProcs-1
         Call GASync()
         If (iRank.eq.MyRank) Then
            ReWind(LuWr)
 777        Read(LuWr,'(A)',END=778) Line
            Write (LuWr_Save,*) Line
            Go To 777
 778        Continue
         End If
         Call GASync()
      End Do
      If (MyRank.ne.0) Then
         Close(LuWr)
         LuWr=LuWr_save
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Restore the "new geometry" field to the RunFile, if any
*
      If (nGNew.eq.0) Then
        Call Put_Coord_New([Zero],0)
      Else
        Call Put_Coord_New(GNew,nGNew/3)
        Call mma_deallocate(GNew)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If(nProcs.ge.2. and. iPL.ge.2) Then
         Write (LuWr,*)
         Write (LuWr,*) ' Points were printed only by master node'
         Write (LuWr,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Read old gradient(s) and convert to internal coordinates
*
      Call mma_Allocate(OldGrads,3*nAtoms,nRoots)
      Call FZero(OldGrads,3*nAtoms*nRoots)
      Call Get_lScalar('Keep old gradient',KeepOld)
      If (KeepOld) Then
        Call Query_Grads(Found,i,j)
        If (Found.and.(i.ge.nRoots).and.(j.eq.3*nAtoms)) Then
*         If there is a valid GRADS file, read each gradient
          Do iR=1,nRoots
            rc=Read_Grad(OldGrads(1,iR),3*nAtoms,iR,0,0)
            If (rc.le.0) Then
              Write(LuWr,*)
              Write(LuWr,'(2X,A,I4,A)') 'No gradient found for root ',
     &                                  iR,', using 0'
              Write(LuWr,*)
            End If
          End Do
        Else
*         If the GRADS file does not exist or has the wrong sizes,
*         read a single gradient from the runfile
          Call qpg_dArray('GRAD',Found,nGrad)
          If (Found) Then
            Call Get_dArray('GRAD',OldGrads(1,1),nGrad)
            Do iR=2,nRoots
              Call dCopy_(nGrad,OldGrads(1,1),1,OldGrads(1,iR),1)
            End Do
            If (nRoots.gt.1) Then
              Write(LuWr,*)
              Write(LuWr,'(2X,A)') 'Using stored gradient for all roots'
              Write(LuWr,*)
            End If
          Else
            Write(LuWr,*)
            Write(LuWr,'(2X,A)') 'No gradient found, using 0'
            Write(LuWr,*)
          End If
        End If
      End If
      Call Allocate_Work(ipTmp2,nDisp)
      Do iR=1,nRoots
        Call Eq_Solver('N',3*nAtoms,nDisp,1,Work(ip_BMtrx),.True.,
     &                 Work(ip_Dummy),OldGrads(1,iR),Work(ipTmp2))
        Call FZero(OldGrads(1,iR),3*nAtoms)
        Call Eq_Solver('N',nDisp,nDisp,1,Work(ip_TMtrx),.True.,
     &                 Work(ip_Dummy),Work(ipTmp2),OldGrads(1,iR))
      End Do
      Call Free_Work(ipTmp2)
*                                                                      *
************************************************************************
*                                                                      *
      jPL=iPrintLevel(iPL_Save)
      If (iPL_Save.ge.3)
     &    Call RecPrt('Energies','(8G16.10)',EnergyArray,nRoots,mDisp)
      Call mma_Allocate(GradArray,nDisp,nRoots)
      Call FZero(GradArray,nDisp*nRoots)
      Call mma_Allocate(Grad,nRoots)
*
      iDisp = nLambda
      Do i = 1, nDisp
*
         If (Work(ipDisp+i-1).eq.Zero) then
            If (iPL_Save .ge. 3) Then
               If (KeepOld) Then
                  Write(6,*) 'gradient set to old value'
               Else
                  Write(6,*) 'gradient set to zero'
               End If
            End If
            Do iR = 1, nRoots
               Grad(iR) = OldGrads(i,iR)
            End Do
         Else
            iDisp = iDisp + 1
            Do iR = 1, nRoots
               iEp = iDisp*2-1
               Eplus=EnergyArray(iR,iEp)
               iEm = iDisp*2
               EMinus=EnergyArray(iR,iEm)
               Disp=Work(ipDisp+i-1)
               Grad(iR) = (Eplus-EMinus)/(Two*Disp)
*
*              If the gradient is not close to zero check that it is
*              consistent. For CASPT2/CASSCF sometimes the active space
*              breaks down and the computed gradient is rubbish. If we
*              are lucky this happens only in one of the displacement
*              directions. In that case compute the gradient with the
*              one-point equation. The one with the lowest gradient is
*              the one which is most likely to be correct.
*
               If (Abs(Grad(iR)).gt.1.0D-1) Then
                  Energy_Ref=Work(ipEnergies_Ref+iR-1)
                  Grada= (Eplus-Energy_Ref)/Disp
                  Gradb= (Energy_Ref-EMinus)/Disp
                  If (Abs(Grad(iR)/Grada).gt.1.5D0 .or.
     &                Abs(Grad(iR)/Gradb).gt.1.5D0 ) Then
                     If (Abs(Grada).le.Abs(Gradb)) Then
                        Grad(iR)=Grada
                     Else
                        Grad(iR)=Gradb
                     End If
                  End If
               End If
            End Do
         End If
*
         call dCopy_(nRoots,Grad,1,GradArray(i,1),nDisp)
*
      End Do
*     Call RecPrt('Grads (old)',' ',OldGrads,3*nAtoms,nRoots)
*     Call RecPrt('BMtrx',' ',Work(ip_BMtrx),3*nAtoms,nDisp)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the gradient in Cartesian coordinates
*
      Call Allocate_Work(ipTmp2,nDisp)
      Call Allocate_Work(ipTmp,3*nAtoms)
      Do iR = 1, nRoots
         Call FZero(Work(ipTmp2),nDisp)
         Call FZero(Work(ipTmp),3*nAtoms)
*
*        Transform the gradient in PCO basis to the internal coordinate
*        format.
*
         Call DGEMM_('N','N',nDisp,1,nDisp,
     &               1.0D0,Work(ip_TMtrx),nDisp,
     &                     GradArray(1,iR),nDisp,
     &               0.0D0,Work(ipTmp2),nDisp)
*
*        Transform internal coordinates to Cartesian.
*
         Call DGEMM_('N','N',3*nAtoms,1,nDisp,
     &               1.0d0,Work(ip_BMtrx),3*nAtoms,
     &                     Work(ipTmp2),nDisp,
     &               0.0d0,Work(ipTmp),3*nAtoms)
*        Call RecPrt('Tmp',' ',Work(ipTmp),3,nAtoms)
*
*        Modify with degeneracy factors.
*
         If (.NOT.NMCart) Then
            Do i = 1, 3*nAtoms
               Work(ipTmp+i-1) = Work(ipTmp+i-1)/Work(ipDeg+i-1)
            End Do
         End If
*
*        Add the MM contribution for MM atoms
*
         If (nAtMM .ne. 0) Then
            call daxpy_(3*nAtoms,One,Work(ipMMGrd),1,Work(ipTmp),1)
         End If
*
*        Apply Morokuma's scheme if needed
*
         Call F_Inquire('QMMM',Exist)
         If (Exist .and. DoTinker) Then
            Call LA_Morok(nAtoms,Work(ipTmp),1)
         End If
*
         If (iR.eq.iRoot) Call Put_Grad(Work(ipTmp),3*nAtoms)
         Call Add_Info('Grad',Work(ipTmp),3*nAtoms,6)
         Call Store_grad(Work(ipTmp),3*nAtoms,iR,0,0)
*
         If (iPL.ge.2) Then
            Write (LuWr,*)
            Write (LuWr,'(1x,A,I5)') 'Numerical gradient, root ',iR
            Write (LuWr,'(2x,A)')
     &                  '---------------------------------------------'
            Write (LuWr,'(2x,A)')
     &                  '               X           Y           Z'
            Write (LuWr,'(2x,A)')
     &                  '---------------------------------------------'
            Do iAtom = 1, nAtoms
               TempX = Work(ipTmp+3*(iAtom-1)+0)
               TempY = Work(ipTmp+3*(iAtom-1)+1)
               TempZ = Work(ipTmp+3*(iAtom-1)+2)
               Namei = AtomLbl(iAtom)
               Write (LuWr,'(2X,A,3X,3F12.6)')
     &               Namei, TempX, TempY, TempZ
            End Do
            Write (LuWr,'(2x,A)')
     &                  '---------------------------------------------'
         End If
      End Do
      Call Free_Work(ipTmp2)
      Call Free_Work(ipTmp)
*                                                                      *
************************************************************************
*                                                                      *
*     Deallocate
*
      Call Free_Work(ipDeg)
      Call Free_Work(ipDisp)
      Call Free_Work(ipAll)
      Call GetMem('TMtrx','Free','Real',ip_TMtrx,nDisp**2)
      Call GetMem('BMtrx','Free','Real',ip_BMtrx,nBMtrx)
      Call mma_Deallocate(EnergyArray)
      Call mma_Deallocate(GradArray)
      Call mma_Deallocate(OldGrads)
      Call mma_Deallocate(Grad)
      Call Free_Work(ipCoor)
      Call Free_Work(ipEnergies_Ref)
      If (DoTinker) Call Free_Work(ipIsMM)
      If (nAtMM.gt.0) Call Free_Work(ipMMGrd)
*
*     Since Numerical_Gradient itself cleans up after the modules
*     then it's necessary to force nfld_tim and nfld_stat to zero,
*     or finish will scream.
*
      nfld_tim  = 0
      nfld_stat = 0
*
*     Restore iRlxRoot if changed as set by the RASSCF module.
*
      If (Method(1:6) .eq. 'CASSCF' .OR.
     &    Method(1:6) .eq. 'RASSCF' ) Then
         Call Get_iScalar('Relax CASSCF root',irlxroot1)
         Call Get_iScalar('Relax Original root',irlxroot2)
         If (iRlxRoot1.ne.iRlxRoot2) Then
            Call Put_iScalar('Relax CASSCF root',irlxroot2)
            Call Put_iScalar('NumGradRoot',irlxroot2)
         End If
      End If

*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
*  CD_InCore_p_w
*
*> @brief
*>   Cholesky decompose the symmetric positive (semi-)definite matrix \p X
*> @author Francesco Aquilante
*>
*> @details
*> The \p n &times; \p n matrix \p X is Cholesky decomposed and the resulting
*> \p NumCho Cholesky vectors are returned in array \p Vec. Note that \p X
*> is modified in this routine! Pivoting/convergence determined by means
*> of weighted diagonal elements. The array \p iD(k) on exit contains
*> the index of the diagonal from which the \p k -th Cholesky
*> vector was generated. A non-zero return code signals
*> that an error has occured (\p X might e.g. be non-positive
*> (semi-)definite) and the output is ill-defined.
*>
*> @param[in,out] X      Matrix to be Cholesky decomposed
*> @param[in]     n      Linear dimension of \p X
*> @param[in]     Wg     Array of diagonal elements weights
*> @param[out]    Vec    Storage array for Cholesky vectors
*> @param[in]     MxVec  Max. number of vectors allowed
*> @param[in,out] iD     Index array for parent diagonals
*> @param[out]    NumCho Number of Cholesky vectors
*> @param[in]     Thr    Decomposition threshold (precision)
*> @param[out]    irc    Return code
************************************************************************
      SubRoutine CD_InCore_p_w(X,n,Wg,Vec,MxVec,iD,NumCho,Thr,irc)
      Implicit None
      Integer n, MxVec, NumCho, irc
      Real*8  X(n,n), Wg(n)
      Real*8  Vec(n,MxVec)
      Real*8  Thr
      Integer k, iD(MxVec)

      Character*13 SecNam
      Parameter (SecNam = 'CD_InCore_p_w')

      Real*8 DefThr
      Parameter (DefThr = 1.0d-6)
      Real*8 ThrNeg, ThrFail
      Parameter (ThrNeg = -1.0d-13, ThrFail = -1.0d-8)


      irc = 0
      NumCho = 0
      If (n .lt. 1) Go To 1 ! exit (nothing to do)
      If (Thr .lt. 0.0d0) Thr = DefThr

      Do k=1,n
         If (Wg(k).lt.0.0d0) Then
            write(6,*) SecNam//': negative weights!'
            Call Abend()
         EndIf
      End Do

      If (MxVec .gt. 0) Then
         Call CD_InCore_1p_w(X,n,Wg,Vec,MxVec,NumCho,Thr,ThrNeg,ThrFail,
     &                       iD,irc)
      Else
         irc = -1
      End If

    1   Continue
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!               2011, Francesco Aquilante                              *
!***********************************************************************

subroutine PriMO_Localisation(Header,PrOcc,PrEne,ThrOcc,ThrEne,nSym,nBas,nOrb,Nme,Ene,Occ,CMO,iPrForm,IndxT)
! Thomas Bondo Pedersen, July 2010.
!
! Print MOs.
! This is a work-around to fix bugs when orbitals are deleted.
!
! F. Aquilante, Nov 2011   (Print only non-deleted orbitals)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: Header
logical(kind=iwp), intent(in) :: PrOcc, PrEne
real(kind=wp), intent(in) :: ThrOcc, ThrEne, Ene(*), Occ(*), CMO(*)
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym), iPrForm, IndxT(*)
character(len=*), intent(in) :: Nme(*)
integer(kind=iwp) :: ik, iSym, k, k1, k2, kk, l_CMO, nOrb_(8), nOrbT
real(kind=wp), allocatable :: CMO_(:), EOr_(:), Occ_(:)

nOrb_(1:nSym) = nOrb(:)
kk = 0
do iSym=1,nSym
  do k=1,nBas(iSym)
    ik = kk+k
    if (IndxT(ik) == 7) nOrb_(iSym) = nOrb_(iSym)-1
  end do
  kk = kk+nBas(iSym)
end do

nOrbT = 0
do iSym=1,nSym
  nOrbT = nOrbT+nOrb_(iSym)
end do

l_CMO = 0
do iSym=1,nSym
  l_CMO = l_CMO+nBas(iSym)*nOrb_(iSym)
end do

call mma_allocate(CMO_,l_CMO,label='CMO_')
call mma_allocate(Occ_,nOrbT,label='Occ_')
call mma_allocate(EOr_,nOrbT,label='Eor_')

k1 = 1
k2 = 1
do iSym=1,nSym
  call dCopy_(nBas(iSym)*nOrb_(iSym),CMO(k1),1,CMO_(k2),1)
  k1 = k1+nBas(iSym)*nBas(iSym)
  k2 = k2+nBas(iSym)*nOrb_(iSym)
end do

k1 = 1
k2 = 1
do iSym=1,nSym
  call dCopy_(nOrb_(iSym),Occ(k1),1,Occ_(k2),1)
  k1 = k1+nBas(iSym)
  k2 = k2+nOrb_(iSym)
end do

k1 = 1
k2 = 1
do iSym=1,nSym
  call dCopy_(nOrb_(iSym),Ene(k1),1,EOr_(k2),1)
  k1 = k1+nBas(iSym)
  k2 = k2+nOrb_(iSym)
end do

call PriMO(Header,PrOcc,PrEne,ThrOcc,ThrEne,nSym,nBas,nOrb_,Nme,EOr_,Occ_,CMO_,iPrForm)

call mma_deallocate(CMO_)
call mma_deallocate(Occ_)
call mma_deallocate(EOr_)

end subroutine PriMO_Localisation

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine zasun(i1,length,valn,jn,kn,ln)
! control routine over zasun process
!
! i1 - number of pivot index (I)
! length - number of valid integrals in block (I)

use ccsort_global, only: mbas, nsize, zrkey
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: i1, length, jn(nsize,mbas), kn(nsize,mbas), ln(nsize,mbas)
real(kind=wp), intent(_IN_) :: valn(nsize,mbas)

if (zrkey == 1) then
  call zasun_zr(i1,length,valn,jn,kn,ln)
else
  call zasun_pck(i1,length,valn,jn,kn,ln)
end if

return

end subroutine zasun

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3aphlp8 (a2,a3,b,dimp,dimq,dimqr,ns,szkey)
c
c     this routine realize following procedure
c     for symp.ne.symq=symr
c
c     B(p,qr)=B(p,qr)+ns*(-A2(p,r,q)+A3(p,q,r))
c
c     a2     - A2 matrix (I)
c     a3     - A3 matrix (I)
c     b      - B  matrix (I/O)
c     dimp   - dimension of p index (I)
c     dimq   - dimension of q index (I)
c     dimqr  - dimension of qr (I)
c     ns     - singum of the permutation (+-1) (I)
c     szkey  - set zero key (I)
c     = 0 no vanishing
c     = 1 set B=0 at the beggining
c
#include "t31.fh"
       integer dimp,dimq,dimqr,ns,szkey
       real*8 a2(1:dimp,1:dimq,1:dimq)
       real*8 a3(1:dimp,1:dimq,1:dimq)
       real*8 b(1:dimp,1:dimqr)
c
c     help variables
c
       integer p,q,r,qr0,qr
       integer nhelp
c
c
       if (szkey.eq.1) then
       nhelp=dimp*dimqr
       call cct3_mv0zero (nhelp,nhelp,b)
       end if
c
       if (ns.eq.1) then
c     phase +1
c
       do 102 q=2,dimq
       qr0=nshf(q)
       do 1020 r=1,q-1
       qr=qr0+r
       do 1021 p=1,dimp
       b(p,qr)=b(p,qr)+a2(p,q,r)
 1021   continue
 1020   continue
 102    continue
c
       do 104 q=2,dimq
       qr0=nshf(q)
       do 1040 r=1,q-1
       qr=qr0+r
       do 1041 p=1,dimp
       b(p,qr)=b(p,qr)-a2(p,r,q)
 1041   continue
 1040   continue
 104    continue
c
       else
c     phase -1
c
       do 202 q=2,dimq
       qr0=nshf(q)
       do 2020 r=1,q-1
       qr=qr0+r
       do 2021 p=1,dimp
       b(p,qr)=b(p,qr)-a2(p,q,r)
 2021   continue
 2020   continue
 202    continue
c
       do 204 q=2,dimq
       qr0=nshf(q)
       do 2040 r=1,q-1
       qr=qr0+r
       do 2041 p=1,dimp
       b(p,qr)=b(p,qr)+a2(p,r,q)
 2041   continue
 2040   continue
 204    continue
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_real_array(a3)
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ShfANM(nInter,nIter,rInt,Shift)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nInter, nIter
real(kind=wp), intent(in) :: rInt(nInter,nIter)
real(kind=wp), intent(inout) :: Shift(nInter,nIter)
integer(kind=iwp) :: Iter

if (nIter == 1) return

#ifdef _DEBUGPRINT_
call RecPrt(' ShfANM: rInt',' ',rInt,nInter,nIter)
#endif

! Shifts: dq = q   -q
!           n   n+1  n

do Iter=1,nIter-1
  Shift(:,Iter) = rInt(:,Iter+1)-rInt(:,Iter)
end do

#ifdef _DEBUGPRINT_
call RecPrt(' In ShfANM: New Shifts',' ',Shift,nInter,nIter-1)
#endif

return

end subroutine ShfANM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine kinemat(L,ndim,evtkin,type1,type2,Energy)
      implicit real*8 (a-h,o-z)
      parameter (fine=7.29735308D-03) !TO_BE_CHECKED
cbs   at least it's identical with Odd's valuE
      parameter (speed=1d0/fine)
      parameter (speed2=speed*speed)
      parameter (speed4=speed2*speed2)
cbs   this routine generates the kinematic A-factors=sqrt((E+mc^2)/(2E))
cbs   (type1) and   c*A/(E+mc^2) (type2)
cbs   The c in the second kinematic factor comes from Jan Almloef and
cbs   Odd Gropen in Rev in Comp.Chem. 8(1996)
      dimension evtkin(*),type1(*),type2(*),Energy(*)
c     E= sqrt(p**2 c**2 + m**2 c**4)
c     p**2= 2*m*TKIN
c     with m = 1
      do Irun=1,ndim
      if (evtkin(Irun).lt.0.0D0) call SysAbendMsg('kinemat',
     & 'strange kinetic energy ',' ')
      Energy(Irun)=(evtkin(Irun)+evtkin(Irun))*speed2+speed4
      enddo
      do Irun=1,ndim
      Energy(Irun)=sqrt(energy(irun))
      enddo
      do Irun=1,ndim
!     sqrt((E+mc^2)/(2E)):
      type1(Irun)=sqrt(0.5d0*(1d0+speed2/Energy(Irun)))
      enddo
!      c*A/(E+mc^2)
      do Irun=1,ndim
      type2(Irun)=speed*type1(Irun)/(Energy(Irun)+speed2)
      enddo
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(L)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine pseudospin(M,dim,z,iDir,iOpt,iprint)
c dim - dimension (input)
c moment(l,dim,dim) (input)
c z - pseuDospin eigenfunctions (output)
      Implicit None
#include "stdalloc.fh"
      Integer, parameter        :: wp=kind(0.d0)
      Integer, intent(in)           :: dim, iprint
      Integer, intent(in)           :: iDir, iOpt
      Complex(kind=8), intent(in)  :: M(3,dim,dim)
      Complex(kind=8), intent(out) :: z(dim,dim)
      ! local variables:
      Integer                       :: info, i
      Real(kind=8), allocatable    :: w(:)
      Complex(kind=8), allocatable :: z1(:,:)
      Real(kind=8)                 :: dznrm2_
      External                      :: dznrm2_
      Logical                       :: dbg
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      Call mma_allocate(W,dim,'W')
      Call mma_allocate(Z1,dim,dim,'Z1')
      dbg=iprint.ge.3
      Call dcopy_(dim,[0.0_wp],0,W,1)
      Call zcopy_(dim*dim,[(0.0_wp,0.0_wp)],0,Z,1)
      Call zcopy_(dim*dim,[(0.0_wp,0.0_wp)],0,Z1,1)
      info=0
      Call diag_c2(M(iDir,1:dim,1:dim),dim,info,w,z1)
      If(dbg) Then
        Do i=1,dim
          Write(6,'(A,i3,A,F24.14)') 'i=',i,' eigenvalue=',w(i)
        End Do
      End If
      If (info.ne.0) Then
        Write(6,'(5x,a)') 'PSEUDO::  diagonalization of the '//
     &                    'zeeman hamiltonian failed.'
        Go To 199
      End If
      If(dbg) Write(6,*) "PSEUDO:  norm of  M is:",
     &                                            dznrm2_(3*dim*dim,M,1)
      If(dbg) Write(6,*) "PSEUDO:  norm of Z1 is:",dznrm2_(dim*dim,Z1,1)
      If(iDir==3) Then
         If(iOpt==1) Then
            Call spin_phase(M,dim,z1,z)
         Else
            Call zcopy_(dim*dim,z1,1,z,1)
            Write(6,*) 'PSEUDOSPIN:  iOpt = ',iOpt
            Call WarningMessage(2,'PSEUDOSPIN: iOpt '//
     &                            'is not understood.')
         End If
      Else
         Call zcopy_(dim*dim,z1,1,z,1)
      End If

 199  Continue
      Call mma_deallocate(W)
      Call mma_deallocate(Z1)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LNM(Cart,mTtAtm,Hess,Scrt1,Scrt2,Vctrs,nsAtom,nDim,iAnr,nIter,iTabBonds,iTabAtoms,nBonds,nMax,nHidden)

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: nIrrep
use Slapaf_Info, only: Analytic_Hessian, Degen, iOptH, Smmtrc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mTtAtm, nsAtom, nDim, nHidden, iANr(mTtAtm+nHidden), nIter, nBonds, iTabBonds(3,nBonds), nMax, &
                                 iTabAtoms(2,0:nMax,mTtAtm+nHidden)
real(kind=wp), intent(in) :: Cart(3,mTtAtm+nHidden), Vctrs(3*mTtAtm,nDim)
real(kind=wp), intent(out) :: Hess(nTri_Elem(3*mTtAtm)), Scrt1((3*mTtAtm)**2), Scrt2((3*mTtAtm)**2)
integer(kind=iwp) :: i, iAtom, ii, ij, ijTri, IterHess, ix, ixyz, j, jAtom, ji, jj, jxyz, Len3, Length, nRP
real(kind=wp) :: eigen, Tmp
logical(kind=iwp) :: Found, RunOld
real(kind=wp), allocatable :: HTanVec(:), TanVec(:)

!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt('In LNM: Cart',' ',Cart,3,mTtAtm)
if (nHidden /= 0) call RecPrt('In LNM: Cart(hidden atoms)',' ',Cart(1,mTtAtm+1),3,nHidden)
call RecPrt('In LNM: Vctrs',' ',Vctrs,3*mTtAtm,nDim)
write(u6,*) 'iAnr=',iANr
write(u6,*) 'Analytic Hessian=',Analytic_Hessian
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! CARTESIAN HESSIAN is generated approximately here or the analytic    *
! is read from file.                                                   *
!                                                                      *
! Retrieve the analytic Hessian or compute the Hessian in cartesians
! from the Hessian model function.

!                                                                      *
!***********************************************************************
!                                                                      *
if (Analytic_Hessian) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! The Hessian matrix is read in the basis of the symmetric displacements.

  Len3 = ndim
  Len3 = nTri_Elem(Len3)

  call qpg_dArray('Analytic Hessian',Found,Length)
  if (Found) then
    call Get_dArray_chk('Analytic Hessian',Hess,Len3)
    RunOld = .false.
  else
    call NameRun('RUNOLD')
    call qpg_dArray('Analytic Hessian',Found,Length)
    if (.not. Found) then
      call WarningMessage(2,' Error in LNM: Analytic Hessian not found')
      call Abend()
    end if
    call Get_dArray_chk('Analytic Hessian',Hess,Len3)
    call NameRun('#Pop')
    RunOld = .true.
  end if
# ifdef _DEBUGPRINT_
  call TriPrt('LNM: Analytic Hessian',' ',Hess,nDim)
  call RecPrt('LNM: Degen',' ',Degen,size(Degen,1),size(Degen,2))
# endif

  ! Modify matrix with degeneracy factors and square the matrix.

  Scrt1(1:nDim**2) = Zero
  ii = 0
  do i=1,3*nsAtom
    iAtom = (i+2)/3
    ixyz = i-(iAtom-1)*3
    if (Smmtrc(ixyz,iAtom)) then
      ii = ii+1
      jj = 0
      do j=1,i
        jAtom = (j+2)/3
        jxyz = j-(jAtom-1)*3
        if (Smmtrc(jxyz,jAtom)) then
          jj = jj+1
          ijTri = nTri_Elem(ii-1)+jj
          ij = (jj-1)*ndim+ii
          ji = (ii-1)*ndim+jj
          Tmp = Hess(ijTri)*sqrt(degen(ixyz,iAtom)*degen(jxyz,jAtom))
          Scrt1(ij) = Tmp
          Scrt1(ji) = Tmp
        end if
      end do
    end if
  end do
# ifdef _DEBUGPRINT_
  call TriPrt('Hessian(anal.)',' ',Hess,nDim)
  write(u6,*) 'nDim,mTtAtm,nsAtom=',nDim,mTtAtm,nsAtom
  call RecPrt('Hessian(anal.)',' ',Scrt1,nDim,nDim)
# endif

  ! If the analytic Hessian corresponds to the current iteration,
  ! disable Hessian updating

  if (RunOld) call NameRun('RUNOLD')
  call Get_iScalar('HessIter',IterHess)
  if (RunOld) call NameRun('#Pop')
  if (IterHess == nIter) iOptH = ibset(0,3)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else   ! Use the Hessian Model Function
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call ddV(Cart,mTtAtm,Hess,iANr,iTabBonds,iTabAtoms,nBonds,nMax,nHidden)
# ifdef _DEBUGPRINT_
  call TriPrt(' The Model Hessian','(12f9.5)',Hess,3*mTtAtm)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Square the matrix

  do i=1,3*mTtAtm
    do j=1,i
      ijTri = nTri_Elem(i-1)+j
      ij = (j-1)*(3*mTtAtm)+i
      ji = (i-1)*(3*mTtAtm)+j
      Scrt1(ij) = Hess(ijTri)
      Scrt1(ji) = Hess(ijTri)
    end do
  end do
  !call RecPrt('Scrt1',' ',Scrt1,3*mTtAtm,3*mTtAtm)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
# ifdef _DEBUGPRINT_
  call RecPrt(' Scrt1',' ',Scrt1,3*mTtAtm,3*mTtAtm)
# endif
  if (nIrrep /= 1) then

    ! Now project out the total symmetric part of the Hessian

    call DGEMM_('N','N',3*mTtAtm,nDim,3*mTtAtm,One,Scrt1,3*mTtAtm,Vctrs,3*mTtAtm,Zero,Scrt2,3*mTtAtm)
#   ifdef _DEBUGPRINT_
    call RecPrt(' Scrt2',' ',Scrt2,3*mTtAtm,nDim)
#   endif
    call DGEMM_('T','N',nDim,nDim,3*mTtAtm,One,Vctrs,3*mTtAtm,Scrt2,3*mTtAtm,Zero,Scrt1,nDim)
#   ifdef _DEBUGPRINT_
    call RecPrt(' The Symmetrized Hessian',' ',Scrt1,nDim,nDim)
#   endif
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Now project hessian using reaction path vector if TS search

  call qpg_darray('TanVec',Found,nRP)
  if (Found) then
    if (nRP /= 3*nsAtom) then
      call WarningMessage(2,' Error in LNM: nRP /= 3*nsAtom')
      write(u6,*) 'nRP,3*nsAtom=',nRP,nsAtom
      call Abend()
    end if

    call mma_allocate(TanVec,nRP,Label='TanVec')
    call mma_allocate(HTanVec,nRP**2,Label='HTanVec')
    TanVec(:) = Zero
    HTanVec(:) = Zero

    call Get_dArray('TanVec',TanVec,nRP)

    !call RecPrt('TanVec',' ',TanVec,nRP,1)
    i = 0
    do ix=1,nRP
      iAtom = (ix+2)/3
      ixyz = ix-(iAtom-1)*3
      if (Smmtrc(ixyz,iAtom)) then
        i = i+1
        TanVec(i) = TanVec(ix)
      end if
    end do
    nRP = nDim
    !call RecPrt('TanVec',' ',TanVec,nRP,1)

    ! Compute H|i>

    call dGeMV_('N',nRP,nRP,One,scrt1,nRP,TanVec,1,Zero,HTanVec,1)

    ! Compute <i|H|i>

    eigen = Zero
    do i=1,nRP
      eigen = eigen+HTanVec(i)*TanVec(i)
    end do
    !write(u6,*) 'Eigen=',eigen
    if (eigen >= Zero) then

      ! Form H - H|i><i| - |i><i|H

      do i=1,nRP
        scrt1((i-1)*nRP+1:i*nRP) = scrt1((i-1)*nRP+1:i*nRP)-HTanVec(i)*TanVec(1:nRP)-TanVec(i)*HTanVec(1:nRP)
      end do
    end if

    call mma_deallocate(HTanVec)
    call mma_deallocate(TanVec)
  end if
  !call RecPrt('Scrt1(final)',' ',Scrt1,nDim,nDim)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
do j=1,nDim
  do i=1,j
    ij = (j-1)*nDim+i
    ijTri = nTri_Elem(i-1)+j
    Hess(ijTri) = Scrt1(ij)
  end do
end do
!call RecPrt('Scrt1(final)',' ',Scrt1,nDim,nDim)
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine LNM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine copy_dkoperators(i,carray1,j,carray2)
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      character carray1(*),carray2(*)
      call copy_dkoperators_internal(carray1,carray2)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine copy_dkoperators_internal(carray1,carray2)
      use iso_c_binding
      character, target :: carray1(*),carray2(*)
      integer, pointer :: iarray1(:),iarray2(:)
      call c_f_pointer(c_loc(carray1(1)),iarray1,[1])
      call c_f_pointer(c_loc(carray2(1)),iarray2,[1])
      call copy_dkoperators_i(i,iarray1,j,iarray2)
      nullify(iarray1,iarray2)
      end subroutine copy_dkoperators_internal
*
      end
*
      subroutine copy_dkoperators_ic(i,iarray1,j,carray2)
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      dimension iarray1(*)
      character carray2(*)
      call copy_dkoperators_ic_internal(carray2)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine copy_dkoperators_ic_internal(carray2)
      use iso_c_binding
      character, target :: carray2(*)
      integer, pointer :: iarray2(:)
      call c_f_pointer(c_loc(carray2(1)),iarray2,[1])
      call copy_dkoperators_i(i,iarray1,j,iarray2)
      nullify(iarray2)
      end subroutine copy_dkoperators_ic_internal
*
      end
*
      subroutine copy_dkoperators_ci(i,carray1,j,iarray2)
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      character carray1(*)
      dimension iarray2(*)
      call copy_dkoperators_ci_internal(carray1)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine copy_dkoperators_ci_internal(carray1)
      use iso_c_binding
      character, target :: carray1(*)
      integer, pointer :: iarray1(:)
      call c_f_pointer(c_loc(carray1(1)),iarray1,[1])
      call copy_dkoperators_i(i,iarray1,j,iarray2)
      nullify(iarray1)
      end subroutine copy_dkoperators_ci_internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Dresselhaus                                     *
!***********************************************************************

! Actually the incoming densities are in an AO basis and treated as such...
subroutine embPotOutputMODensities(nAtoms,nSym,densInact,densAct,nBasPerSym,nBasTotSquare)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nSym, nBasPerSym(nSym), nBasTotSquare
real(kind=wp), intent(in) :: densInact(nBasTotSquare), densAct(nBasTotSquare)
integer(kind=iwp) :: i, iCnt, iCnt2, iCol, iDensDimPck, iRow
real(kind=wp), allocatable :: totDens(:), totDensP(:)

iDensDimPck = 0
do i=1,nSym
  iDensDimPck = iDensDimPck+((nBasPerSym(i)*(nBasPerSym(i)+1))/2)
end do

call mma_allocate(totDens,nBasTotSquare,label='TotD')
call mma_allocate(totDensP,iDensDimPck,label='TotDp')

call dcopy_(nBasTotSquare,densInact,1,totDens,1)
call daxpy_(nBasTotSquare,One,densAct,1,totDens,1)
!Pack density
iCnt = 0
iCnt2 = 0
do i=1,nSym
  do iRow=1,nBasPerSym(i)
    do iCol=1,iRow
      iCnt = iCnt+1
      if (iRow == iCol) then
        totDensP(iCnt) = totDens((iRow-1)*nBasPerSym(i)+iCol+iCnt2)
      else
        totDensP(iCnt) = Two*totDens((iRow-1)*nBasPerSym(i)+iCol+iCnt2)
      end if
    end do
  end do
  iCnt2 = iCnt2+nBasPerSym(i)*nBasPerSym(i)
end do

call embPotOutput(nAtoms,totDensP)

call mma_deallocate(totDens)
call mma_deallocate(totDensP)

end subroutine embPotOutputMODensities

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010,2012,2017, Francesco Aquilante                    *
!               2015,2017, Alexander Zech                              *
!***********************************************************************

subroutine VEMB_Exc_states(Vemb,nVemb,xKSDFT,Func_Bx)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nVemb
real(kind=wp), intent(inout) :: Vemb(nVemb)
character(len=*), intent(in) :: xKSDFT
real(kind=wp), intent(in) :: Func_Bx
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
integer(kind=iwp) :: IAD12, KROOT, nDummy
real(kind=wp) :: DFT_NAD, Dummy(1), Func_A, Func_AB, Vemb_Xstate
character(len=16) :: MyNamRfil
real(kind=wp), allocatable :: D1ao_b(:), DState(:), F_DFT(:), xxCMO(:), xxOCCN(:)
real(kind=r8), external :: ddot_

nDummy = 1
Dummy(1) = Zero

IAD12 = IADR15(12)

call mma_allocate(xxCMO,NTOT2,Label='xxCMO')
call mma_allocate(xxOCCN,NTOT,Label='xxOCCN')
call mma_allocate(DState,NTOT1,Label='DState')
call mma_allocate(F_DFT,nVemb,Label='F_DFT')
call mma_allocate(D1ao_b,nVemb,Label='D1ao_b')

do KROOT=1,LROOTS

  ! Read natural orbitals
  if (NAC > 0) then
    call DDAFILE(JOBIPH,2,xxCMO,NTOT2,IAD12)
    call DDAFILE(JOBIPH,2,xxOCCN,NTOT,IAD12)
  end if
  ! Get GS and excited state densities:
  ! Fill allocated mem with zeroes.
  DSTATE(:) = Zero

  call DONE_RASSCF(xxCMO,xxOCCN,DState) ! computes D=CnC'
  ! Nonelectr. Vemb with GS and excited state density
  Vemb_Xstate = ddot_(nVemb,Vemb,1,DState,1)
  !write(u6,*) 'Kroot, Vemb_K ',KROOT,Vemb_Xstate
  write(u6,'(A,F19.10,3X,A,I3)') 'Nonelectr. Vemb w. rhoA_emb =',Vemb_Xstate,'root = ',KROOT
  ! E_xc,T[rhoA]
  Func_A = Zero
  F_DFT(:) = Zero
  DState(1:nVemb) = Half*DState(1:nVemb)
  call wrap_DrvNQ(xKSDFT,F_DFT,1,Func_A,DState,nVemb,1,.false.,Dummy,nDummy,'SCF ')
  !write(u6,*) 'Kroot, Func_A ',KROOT,Func_A
  ! E_xc,T[rhoA+rhoB]
  call Get_NameRun(MyNamRfil) ! save current Runfile name
  call NameRun('AUXRFIL') ! switch RUNFILE name
  call Get_D1ao(D1ao_b,nVemb)
  DState(1:nVemb) = DState(1:nVemb)+Half*D1ao_b(:)

  Func_AB = Zero
  F_DFT(:) = Zero
  call wrap_DrvNQ(xKSDFT,F_DFT,1,Func_AB,DState,nVemb,1,.false.,Dummy,nDummy,'SCF ')
  !write(u6,*) 'Kroot, Func_AB',KROOT,Func_AB
  !write(u6,*) 'Kroot, Func_Bx',KROOT,Func_Bx
  ! Calculate DFT NAD for all densities:
  DFT_NAD = Func_AB-Func_A-Func_Bx
  write(u6,'(A,F19.10,3X,A,I3)') 'DFT energy (NAD) =           ',DFT_NAD,'root = ',KROOT
  call NameRun(MyNamRfil) ! go back to MyNamRfil
end do
call mma_deallocate(D1ao_b)
call mma_deallocate(F_DFT)
call mma_deallocate(DState)
call mma_deallocate(xxCMO)
call mma_deallocate(xxOCCN)

return

end subroutine VEMB_Exc_states

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ZSTINF_MCLR(IPRNT)
*
* Set up common block /STINF/ from information in /STINP/
*
*=========
* Input
*=========
* Information in /STINP/ and /ORBINP/
*
*======================
* Output ( in /STINF/ )
*======================
* ISTAC (MXPSTT,2) : string type obtained by creating (ISTAC(ITYP,2))
*                    or annihilating (ISTAC(ITYP,1)) an electron
*                    from a string of type  ITYP . A zero indicates
*                    that this mapping is not included
*                    Only strings having the same ISTTP index are
*                    mapped
* NOCTYP(ITYP) : Number of occupation classes for given type
*
*
* NSTFTP(ITYP) : Number of strings of this type
*
* INUMAP(ITYP) : Mapping of string type to next more general type
* INDMAP(ITYP) : Mapping of string type to next more restricted type
*
*   / \           Zero order space                         !
*    !            Double excitations from reference space  !  Down
* Up !            single excitation from reference space   !
*    !            reference space                         \ /
*
#include "detdim.fh"
#include "orbinp_mclr.fh"
#include "strinp_mclr.fh"
#include "stinf_mclr.fh"
*
*
      NTEST = 0000
      NTEST = MAX(NTEST,IPRNT)
* ******************************************************************
* Mappings between strings with the same type ISTTP index , +/- 1 el
* ******************************************************************
      Call iCopy(2*MXPSTT,[0],0,ISTAC,1)
      DO 90 ITYP = 1, NSTTYP-1
        IF(NELEC(ITYP+1).EQ.NELEC(ITYP)-1) THEN
          ISTAC(ITYP,1) = ITYP+1
          ISTAC(ITYP+1,2) = ITYP
        END IF
90    CONTINUE
*
      IF(NTEST .NE. 0 ) THEN
        WRITE(6,*) ' Type - type mapping array ISTAC '
        WRITE(6,*) ' =============================== '
        CALL IWRTMA(ISTAC,NSTTYP,2,MXPSTT,2)
      END IF
* **************************************************
*. Number of occupation classes and strings per type
* **************************************************
      DO 200 ITYP = 1,NSTTYP
        NOCTYP(ITYP) = (MXRS1(ITYP)-MNRS1(ITYP)+1)
     *               * (MXRS3(ITYP)-MNRS3(ITYP)+1)
200   CONTINUE
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' Number of occupation classes per type '
        WRITE(6,*) ' ===================================== '
        CALL IWRTMA(NOCTYP,1,NSTTYP,1,NSTTYP)
      END IF
*
      DO 300 ITYP = 1, NSTTYP
        NSTFTP(ITYP) = NUMST3(NELEC(ITYP),NORB1,MNRS1(ITYP),MXRS1(ITYP),
     *                        NORB2,NORB3,MNRS3(ITYP),MXRS3(ITYP))
300   CONTINUE
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' Number of strings per  type '
        WRITE(6,*) ' =========================== '
        CALL IWRTMA(NSTFTP,1,NSTTYP,1,NSTTYP)
      END IF
* *****************************************************************
*. Mappings between strings containing the same number of electrons
* *****************************************************************
      Call iCopy(MXPSTT,[0],0,INUMAP,1)
      Call iCopy(MXPSTT,[0],0,INDMAP,1)
*. Mapping to and from zero order space
*     Note: some lines are commented out here since IARTP and IBRTP
*           have never been defined. (R. Lindh 2006)
C     INUMAP(IARTP(3,5)) = IAZTP
C     IF(IARTP(3,4).NE.0)  INUMAP(IARTP(3,4)) = IAZTP+1
C     IF(IARTP(3,3).NE.0)  INUMAP(IARTP(3,3)) = IAZTP+2
*
C     INUMAP(IBRTP(3,5)) = IBZTP
C     IF(IBRTP(3,4).NE.0)  INUMAP(IBRTP(3,4)) = IBZTP+1
C     IF(IBRTP(3,3).NE.0)  INUMAP(IBRTP(3,3)) = IBZTP+2
*
      NAEL = NELEC(IAZTP)
C     INDMAP(IAZTP) = IARTP(3,5)
C     IF(NAEL.GE.1) INDMAP(IAZTP+1) = IARTP(3,4)
C     IF(NAEL.GE.2) INDMAP(IAZTP+2) = IARTP(3,3)
*
      NBEL = NELEC(IBZTP)
C     INDMAP(IBZTP) = IBRTP(3,5)
C     IF(NBEL.GE.1) INDMAP(IBZTP+1) = IBRTP(3,4)
C     IF(NBEL.GE.2) INDMAP(IBZTP+2) = IBRTP(3,3)
*.Number of electrons compared to reference
      DO 450 IDEL = -4,2
      DO 430 IEX = 1,2
* Up mappings
C       IF(IARTP(IEX,IDEL+5).NE.0) THEN
C         INUMAP(IARTP(IEX,IDEL+5)) = IARTP(IEX+1,IDEL+5)
C       END IF
C       IF(IBRTP(IEX,IDEL+5).NE.0) THEN
C         INUMAP(IBRTP(IEX,IDEL+5)) = IBRTP(IEX+1,IDEL+5)
C       END IF
* Down mappings
C       IF(IARTP(IEX+1,IDEL+5).NE.0) THEN
C         INDMAP(IARTP(IEX+1,IDEL+5)) = IARTP(IEX,IDEL+5)
C       END IF
C       IF(IBRTP(IEX+1,IDEL+5).NE.0) THEN
C         INDMAP(IBRTP(IEX+1,IDEL+5)) = IBRTP(IEX,IDEL+5)
C       END IF
430   CONTINUE
450   CONTINUE
*
      IF(NTEST .NE. 0 ) THEN
        WRITE(6,*) ' Up mappings of string types '
        CALL IWRTMA(INUMAP,1,NSTTYP,1,NSTTYP)
        WRITE(6,*) ' Down mappings of string types '
        CALL IWRTMA(INDMAP,1,NSTTYP,1,NSTTYP)
      END IF
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013,2018, Ignacio Fdez. Galvan                        *
!***********************************************************************
!  Find_RFO_Root
!
!> @brief
!>   Find the \f$ \alpha \f$ value for the RS-RFO family of algorithms.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Find the \f$ \alpha \f$ value that produces a given step length in the
!> RS-RFO family of algorithms. \cite Bes1998-TCA-100-265
!> This routine assumes that a larger \f$ \alpha \f$ produces a smaller step.
!>
!> Use a *regula falsi*-like method, instead of diagonalization as in eqs.
!> (16) and (20). This subroutine is designed to be used in an iterative loop.
!>
!> (\p x1, \p y1) and (\p x2, \p y2) are two \f$ \alpha \f$ and step length
!> values bracketing the desired root. If \p x2 = `0.0`, an appropriate value
!> for \p x2 will first be searched. (\p x3, \p y3) is another point between
!> \p x1 and \p x2. On output a new value for \p x3 will be suggested (and
!> the bracketing points will be updated), the surrounding loop must calculate
!> the new \p y3 value.
!>
!> @param[in,out] x1,y1     Smaller \f$ \alpha \f$ and larger step length
!> @param[in,out] x2,y2     Larger \f$ \alpha \f$ and smaller step length
!> @param[in,out] x3        Middle \f$ \alpha \f$, new value on output
!> @param[in]     y3        Step length at \p x3
!> @param[in]     Val       Desired step length value
!>
!> @see ::RS_RFO
!> @see ::RS_I_RFO
!> @see ::RS_P_RFO
!***********************************************************************

subroutine Find_RFO_Root(x1,y1,x2,y2,x3,y3,Val)

use Constants, only: Zero, One, Two, Four, Half, OneHalf
use Definitions, only: wp

implicit none
real(kind=wp), intent(inout) :: x1, y1, x2, y2, x3
real(kind=wp), intent(in) :: y3, Val
real(kind=wp) :: coefA, coefB, coefC, delta, denom, discr, new, nnew, xx1, xx2, yy1, yy2
real(kind=wp), parameter :: Thr = 1.0e-16_wp

! First, we must find a value of alpha that gives a small enough step

if (y2 > Val) then
  y2 = y3

  if (x2 == Zero) then
    ! In the first iteration, simply try with alpha+1
    new = x1+One
    x2 = new

  else if (y3 < Val) then
    ! If the step is below the threshold, a bracketing pair has been found.
    ! Suggest an intermediate point (with secant method, or midpoint)
    new = x1+(Val-y1)/(y2-y1)*(x2-x1)
    if ((new <= x1) .or. (new >= x2)) new = Half*(x1+x2)

  else
    ! If it is not there yet, extrapolate using a straight line (times an
    ! arbitrary factor of 1.5, to overcome systematic undershooting), and
    ! update the other end point
    if (y1-y2 > Thr) then
      ! Don't get too ambitious -- thus the min function.
      delta = min(x2,(Val-y2)*(x1-x2)/(y1-y2))
      new = x2+OneHalf*delta
    else
      ! If y2 is very close to y1, or actually lower, just double the step.
      new = x2+Two*(x2-x1)
    end if
    x1 = x2
    y1 = y2
    x2 = new
  end if

else

  ! Once a bracketing pair has been found, we arrive here with two end points
  ! (long and short), and a middle point, for which the step length has just
  ! been computed

  ! Use the midpoint (bisection) or secant (regula falsi) as safety net
  ! Do this in the subinterval where the root should be
  xx1 = x1
  yy1 = y1
  xx2 = x2
  yy2 = y2
  if (y3 < Val) then
    xx2 = x3
    yy2 = y3
  else
    xx1 = x3
    yy1 = y3
  end if
  ! If the middle point is shorter than the "short" step, something went
  ! wrong, start again from 1 (signal with -1),
  ! maybe now we will get a better eigenvalue to start with
  if ((y3 < y2) .and. (y3 > Val)) then
    x3 = -One
    return
  end if
  new = xx1+(Val-yy1)/(yy2-yy1)*(xx2-xx1)
  if ((new <= xx1) .or. (new >= xx2)) new = Half*(xx1+xx2)
  nnew = new

  ! Define a quadratic fitting for the 3 points
  denom = (x1-x2)*(x1-x3)*(x2-x3)
  if (abs(denom) > Thr) then
    coefA = (x3*(y2-y1)+x2*(y1-y3)+x1*(y3-y2))/denom
    coefB = (x3**2*(y1-y2)+x2**2*(y3-y1)+x1**2*(y2-y3))/denom
    coefC = (x2*x3*(x2-x3)*y1+x3*x1*(x3-x1)*y2+x1*x2*(x1-x2)*y3)/denom
    discr = coefB**2-Four*coefA*(coefC-Val)
  else
    discr = Zero
  end if

  ! Find the point between x1 and x2 where the step would be exactly Val
  if (discr > Zero) then
    ! Choose root depending on sign of y1-y2
    if (y1-y2 > Zero) then
      nnew = (-coefB-sqrt(discr))/(Two*coefA)
    else if (y1-y2 < Zero) then
      nnew = (-coefB+sqrt(discr))/(Two*coefA)
    end if
  end if
  ! Last check: make sure the new point is in the correct interval
  if ((nnew > xx1) .and. (nnew < xx2)) new = nnew

  ! Update the end points
  x1 = xx1
  y1 = yy1
  x2 = xx2
  y2 = yy2
end if

! Update the suggested value
x3 = new

return

end subroutine Find_RFO_Root

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_0 (dim,A)
c
c        check zero
c
        implicit none
        integer dim
        real*8 A(1:dim)
c
c        help var
        integer i,bad
c
        bad=0
        do i=1,dim
          if (abs(A(i)).gt.1.0d-10) then
          bad=bad+1
          end if
        end do
c
        write (6,*) ' Nonzero elements ',bad,dim
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RasRasTrans(nB,nStatePrim,iEig2,iPrint)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "files_qmstat.fh"
#include "qm2.fh"
#include "numbers.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension iTocBig(MxStOT)

      Character*30 OutLine

*
*--- Guten Tag.
*
      Write(6,*)'     ----- Transform from non-orthogonal RASSCF states'
     &//' to orthogonal RASSI states.'

*
*--- Set zeros and decide if transformation is at all possible.
*
      LuIn=66
      kaunt=0
      iSkutt=0
      iDisk=0
      Call DaName(LuIn,RassiM)
      nTriSP=nStatePrim*(nStatePrim+1)/2
      Call iDaFile(LuIn,2,iTocBig,nTriSP,iDisk)
      nSize=nB*(nB+1)/2
      nTriS=nState*(nState+1)/2
      nSizeBig=nSize*nTriS
      nSizeBigPrim=nSize*nTriSP
      Call GetMem('HOWMUCH','Max','Real',ipMAX,MEMMAX)
*
*-- This means that we do not have memory enough for TDM in contracted
*   form. Then there is no use to proceed at all.
*
      If(MEMMAX.le.nSizeBig) then
        Write(6,*)
        Write(6,*)'The transition density matrix is too big to put in m'
     &//'emory!'
        Write(6,*)'Either,'
        Write(6,*)'       (1) increase MOLCAS_MEM,'
        Write(6,*)'       (2) contract number of states further.'
        Call Quit(_RC_GENERAL_ERROR_)
*
*-- Here we go if there is enough memory for an in core transformation.
*
      Elseif(MEMMAX.ge.(nSizeBig+nSizeBigPrim+nTriSP+nTriS+nStatePrim**2
     &                 +nState*nStatePrim+nState**2)) then
        Call GetMem('ALLES','Allo','Real',iBigT,nSizeBig)
        Call GetMem('ALLESin','Allo','Real',iBigV,nSizeBigPrim)
        Call GetMem('Int1','Allo','Real',iInt1,nTriSP)
        Call GetMem('Int2','Allo','Real',iInt2,nTriS)
        Call GetMem('Square1','Allo','Real',iSnt1,nStatePrim**2)
        Call GetMem('Square2','Allo','Real',iSnt2,nState*nStatePrim)
        Call GetMem('Square3','Allo','Real',iSnt3,nState**2)
        call dcopy_(nSizeBig,[ZERO],iZERO,Work(iBigT),iONE)
        kaunt=0
        Do 78, i=1,nStatePrim
          Do 79, j=1,i
            kaunt=kaunt+1
            iDisk=iTocBig(kaunt)
            Call dDaFile(LuIn,2,Work(iBigV+(kaunt-1)*nSize),nSize,iDisk)
79        Continue
78      Continue
*
*---- A lot of printing of TDM if requested.
*
        If(iPrint.ge.25) then
          kaunt=0
          Do 17, i=1,nStatePrim
            Do 18, j=1,i
              Write(OutLine,'(A,I3,I3)')'TDM, Piece ',i,j
              Call TriPrt(OutLine,' ',Work(iBigV+kaunt),nB)
              kaunt=kaunt+nSize
18          Continue
17        Continue
        Endif
*
*---- Proceed with transformation.
*
        kaunt=0
        Do 10001, iBas=1,nB
          Do 10002, jBas=1,iBas
            call dcopy_(nTriSP,Work(iBigV+kaunt),nSize,Work(iInt1),iONE)
            Call Square(Work(iInt1),Work(iSnt1),iONE,nStatePrim
     &                                              ,nStatePrim)
            Call Dgemm_('T','N',nState,nStatePrim,nStatePrim,ONE
     &                ,Work(iEig2),nStatePrim,Work(iSnt1),nStatePrim
     &                ,ZERO,Work(iSnt2),nState)
            Call Dgemm_('N','N',nState,nState,nStatePrim,ONE,Work(iSnt2)
     &                ,nState,Work(iEig2),nStatePrim,ZERO,Work(iSnt3)
     &                ,nState)
            Call SqToTri_Q(Work(iSnt3),Work(iInt2),nState)
            call dcopy_(nTriS,Work(iInt2),iONE,Work(iBigT+kaunt),nSize)
            kaunt=kaunt+1
10002     Continue
10001   Continue
        Call GetMem('ALLESin','Free','Real',iBigV,nSizeBigPrim)
        Call GetMem('Int1','Free','Real',iInt1,nTriSP)
        Call GetMem('Int2','Free','Real',iInt2,nTriS)
        Call GetMem('Square1','Free','Real',iSnt1,nStatePrim**2)
        Call GetMem('Square2','Free','Real',iSnt2,nState*nStatePrim)
        Call GetMem('Square3','Free','Real',iSnt3,nState**2)
*
*-- Here we go if both TDM's can not be put in memory. Might be a bit
*   slow due to its nested nature with repeated IO.
*
      Else
        Call GetMem('ALLES','Allo','Real',iBigT,nSizeBig)
        Call GetMem('AOGamma','Allo','Real',ipAOG,nSize)
        call dcopy_(nSizeBig,[ZERO],iZERO,Work(iBigT),iONE)
        Do 11001, iiS=1,nStatePrim
          Do 11002, jjS=1,nStatePrim
            If(iiS.le.jjS) then
              indypop=jjS*(jjS+1)/2-jjS+iiS
            Else
              indypop=iiS*(iiS+1)/2-iiS+jjS
            Endif
            iDisk=iTocBig(indypop)
            Call dDaFile(LuIn,2,Work(ipAOG),nSize,iDisk)
            kaunter=0
            Do 11003, iB=1,nB
              Do 11004, jB=1,iB
                Do 11005, iS=1,nState
                  Do 11006, jS=1,iS
                    index=(iS*(iS-1)/2+jS-1)*nSize
                    index=index+kaunter
                    Work(iBigT+index)=Work(iBigT+index)
     &                +Work(iEig2+iiS-1+(iS-1)*nStatePrim)
     &                *Work(iEig2+jjS-1+(jS-1)*nStatePrim)
     &                *Work(ipAOG+kaunter)
11006             Continue
11005           Continue
                kaunter=kaunter+1
11004         Continue
11003       Continue
11002     Continue
11001   Continue
        Call GetMem('AOGamma','Free','Real',ipAOG,nSize)
      Endif

*
*--- Deallocations and finish up.
*
      Call GetMem('RedEigV1','Free','Real',iEig2,nStatePrim**2)
      Call DaClos(LuIn)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine prsq(idbg,label,a,n)
      IMPLICIT REAL*8 (A-H,O-Z)
      dimension a(n,n)
      character*8 label
      write(idbg,1001) label
      write(idbg,1002) (j,j=1,n)
      do 10 i=1,n
         write(idbg,1003) i,(a(i,j),j=1,n)
 10   continue
 1001 FORMAT(' MATRIX PRINTED:',2X,A8)
 1002 FORMAT(' ',4X,4(6X,I4,6X),/)
 1003 FORMAT(' ',I4,4D16.8)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Roland Lindh                                     *
!***********************************************************************

subroutine CmbnW1(Welp0,Welm0,Wel0p,Wel0m,nZeta,la,lb,Zeta,rKappa,rFinal,Alpha,Beta,Grad,nGrad,DAO,IfGrad,IndGrd,iStab,jStab,kOp)
!***********************************************************************
!                                                                      *
! Object: compute the gradient of the Spherical Well integrals         *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             May '95.                                                 *
!***********************************************************************

use Symmetry_Info, only: nIrrep, iChBas
use Index_Functions, only: C_Ind3
use Constants, only: Two
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nGrad, IndGrd(3,2), iStab, jStab, kOp(2)
real(kind=wp), intent(in) :: Welp0(nZeta,(la+2)*(la+3)/2,(lb+1)*(lb+2)/2), Welm0(nZeta,la*(la+1)/2,(lb+1)*(lb+2)/2), &
                             Wel0p(nZeta,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2), Wel0m(nZeta,(la+1)*(la+2)/2,lb*(lb+1)/2), Zeta(nZeta), &
                             rKappa(nZeta), Alpha(nZeta), Beta(nZeta), DAO(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2)
real(kind=wp), intent(out) :: rFinal(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6)
real(kind=wp), intent(inout) :: Grad(nGrad)
logical(kind=iwp) :: IfGrad(3,2)
integer(kind=iwp) :: i1, i2, iCar, iCn, iGrad, ip0m, ip0p, ipa, ipb, ipm0, ipp0, iPrint, iRout, ixa, ixb, iya, iyaMax, iyb, &
                     iybMax, iza, izb, iZeta, n0m, n0p, nDAO, nm0, np0
real(kind=wp) :: Fact, ps, xa, xb, ya, yb, za, zb
integer(kind=iwp), external :: iPrmt
real(kind=r8), external :: DDot_
#include "print.fh"

iRout = 134
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  call RecPrt(' In CmbnW1: Zeta  ',' ',Zeta,1,nZeta)
  call RecPrt(' In CmbnW1: rKappa',' ',rKappa,1,nZeta)
  call RecPrt(' In CmbnW1: Alpha ',' ',Alpha,1,nZeta)
  call RecPrt(' In CmbnW1: Beta  ',' ',Beta,1,nZeta)
  np0 = (la+2)*(la+3)/2*(lb+1)*(lb+2)/2
  nm0 = la*(la+1)/2*(lb+1)*(lb+2)/2
  n0p = (la+1)*(la+2)/2*(lb+2)*(lb+3)/2
  n0m = (la+1)*(la+2)/2*lb*(lb+1)/2
  call RecPrt(' In CmbnW1: Welp0',' ',Welp0,nZeta,np0)
  if (la >= 1) call RecPrt(' In CmbnW1: Welm0',' ',Welm0,nZeta,nm0)
  call RecPrt(' In CmbnW1: Wel0p',' ',Wel0p,nZeta,n0p)
  if (lb >= 1) call RecPrt(' In CmbnW1: Wel0m',' ',Wel0m,nZeta,n0m)
end if

nDAO = nZeta*(la+1)*(la+2)/2*(lb+1)*(lb+2)/2
do ixa=0,la
  iyaMax = la-ixa
  do ixb=0,lb
    iybMax = lb-ixb
    do iya=0,iyaMax
      iza = la-ixa-iya
      ipa = C_Ind3(ixa,iya,iza)
      do iyb=0,iybMax
        izb = lb-ixb-iyb
        ipb = C_Ind3(ixb,iyb,izb)

        ! Combine Spherical Well integrals

        if (IfGrad(1,1)) then
          ipp0 = C_Ind3(ixa+1,iya,iza)
          if (ixa > 0) then
            xa = -ixa
            ipm0 = C_Ind3(ixa-1,iya,iza)
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,1) = (Two*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb)+ &
                                                       xa*Welm0(iZeta,ipm0,ipb))
            end do
          else
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,1) = (Two*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb))
            end do
          end if
        end if
        if (IfGrad(1,2)) then
          ip0p = C_Ind3(ixb+1,iyb,izb)
          if (ixb > 0) then
            xb = -ixb
            ip0m = C_Ind3(ixb-1,iyb,izb)
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,4) = (Two*Beta(iZeta)*Wel0p(iZeta,ipa,ip0p)+ &
                                                      xb*Wel0m(iZeta,ipa,ip0m))
            end do
          else
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,4) = (Two*Beta(iZeta)*Wel0p(iZeta,ipa,ip0p))
            end do
          end if
        end if
        if (IfGrad(2,1)) then
          ipp0 = C_Ind3(ixa,iya+1,iza)
          if (iya > 0) then
            ya = -iya
            ipm0 = C_Ind3(ixa,iya-1,iza)
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,2) = (Two*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb)+ &
                                                       ya*Welm0(iZeta,ipm0,ipb))
            end do
          else
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,2) = (Two*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb))
            end do
          end if
        end if
        if (IfGrad(2,2)) then
          ip0p = C_Ind3(ixb,iyb+1,izb)
          if (iyb > 0) then
            yb = -iyb
            ip0m = C_Ind3(ixb,iyb-1,izb)
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,5) = (Two*Beta(iZeta)*Wel0p(iZeta,ipa,ip0p)+ &
                                                      yb*Wel0m(iZeta,ipa,ip0m))
            end do
          else
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,5) = (Two*Beta(iZeta)*Wel0p(iZeta,ipa,ip0p))
            end do
          end if
        end if
        if (IfGrad(3,1)) then
          ipp0 = C_Ind3(ixa,iya,iza+1)
          if (iza > 0) then
            za = -iza
            ipm0 = C_Ind3(ixa,iya,iza-1)
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,3) = (Two*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb)+ &
                                                       za*Welm0(iZeta,ipm0,ipb))
            end do
          else
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,3) = (Two*Alpha(iZeta)*Welp0(iZeta,ipp0,ipb))
            end do
          end if
        end if
        if (IfGrad(3,2)) then
          ip0p = C_Ind3(ixb,iyb,izb+1)
          if (izb > 0) then
            zb = -izb
            ip0m = C_Ind3(ixb,iyb,izb-1)
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,6) = (Two*Beta(iZeta)*Wel0p(iZeta,ipa,ip0p)+ &
                                                      zb*Wel0m(iZeta,ipa,ip0m))
            end do
          else
            do iZeta=1,nZeta
              rFinal(iZeta,ipa,ipb,6) = (Two*Beta(iZeta)*Wel0p(iZeta,ipa,ip0p))
            end do
          end if
        end if

      end do
    end do
  end do
end do

! Trace the gradient integrals

if (iPrint >= 99) then
  call RecPrt(' W(1)',' ',rFinal,nDAO,6)
  call RecPrt('   D ',' ',DAO,nDAO,1)
end if
do iCn=1,2
  do iCar=1,3
    if (IndGrd(iCar,iCn) /= 0) then
      ! Accumulate contribution to the gradient
      iGrad = abs(IndGrd(iCar,iCn))
      if (iCn == 1) then
        i1 = iCar
        i2 = iCar+3
        ps = real(iPrmt(kOp(1),iChBas(1+iCar)),kind=wp)
        Fact = real(iStab,kind=wp)/real(nIrrep,kind=wp)
      else
        i1 = iCar+3
        i2 = iCar
        ps = real(iPrmt(kOp(2),iChBas(1+iCar)),kind=wp)
        Fact = ps*real(jStab,kind=wp)/real(nIrrep,kind=wp)
      end if
      !write(u6,*) ' Fact=',Fact,ps
      if (IndGrd(iCar,iCn) < 0) then
        ! Gradient via translational invariance.
        Grad(iGrad) = Grad(iGrad)-Fact*DDot_(nDAO,DAO,1,rFinal(1,1,1,i2),1)
      else
        Grad(iGrad) = Grad(iGrad)+Fact*DDot_(nDAO,DAO,1,rFinal(1,1,1,i1),1)
      end if
    end if
  end do
end do

return

end subroutine CmbnW1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Merge_Constraints(FileIn1,FileIn2,FileOut,nLambda,iRow_c)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: FileIn1, FileIn2, FileOut
integer(kind=iwp), intent(inout) :: nLambda, iRow_c
integer(kind=iwp) :: i, iErr, j, Lu, Lu1, Lu2, Lu3
logical(kind=iwp) :: Found, AuxFile
character(len=180) :: Line
character(len=6) :: Tag
integer(kind=iwp), external :: AixRm, isFreeUnit
character(len=180), external :: Get_Ln

! Open the input files if they exist
Lu1 = 0
if (FileIn1 /= '') then
  call f_Inquire(FileIn1,Found)
  if (Found) then
    Lu1 = isFreeUnit(30)
    call Molcas_Open(Lu1,FileIn1)
  end if
end if

Lu2 = 0
if ((FileIn2 /= '') .and. (FileIn2 /= FileIn1)) then
  call f_Inquire(FileIn2,Found)
  if (Found) then
    Lu2 = isFreeUnit(30)
    call Molcas_Open(Lu2,FileIn2)
  end if
end if

! Set the output file as a third file, or a temporary one
if (((FileOut == FileIn1) .and. (Lu1 /= 0)) .or. ((FileOut == FileIn2) .and. (Lu2 /= 0))) then
  AuxFile = .true.
else
  AuxFile = .false.
end if

nLambda = 0
iRow_c = 0

! If there are no input files, only delete the output file if it exists
if ((Lu1 == 0) .and. (Lu2 == 0)) then
  if (.not. AuxFile) then
    call f_Inquire(FileOut,Found)
    if (Found) iErr = AixRm(FileOut)
  end if
  return
! Otherwise, open it
else
  Lu3 = isFreeUnit(30)
  if (AuxFile) then
    call Molcas_Open(Lu3,'purge')
  else
    call Molcas_Open(Lu3,FileOut)
  end if
end if

! Copy the constraints to the output file, counting the lines
! Copy only from existing files
do i=1,2
  if (i == 1) Tag = 'VALUES'
  if (i == 2) Tag = 'END'

  do j=1,2
    if (j == 1) Lu = Lu1
    if (j == 2) Lu = Lu2
    if (Lu == 0) cycle
    Line = adjustl(Get_Ln(Lu))
    call UpCase(Line)
    do while (Line(1:4) /= Tag(1:4))
      if (index(Line,'&') == 0) then
        iRow_c = iRow_c+1
        if (i == 2) nLambda = nLambda+1
        if (index(Line,'=') == 0) call FixEqualSign(Line,Lu)
      end if
      write(Lu3,100) trim(Line)
      Line = adjustl(Get_Ln(Lu))
      call UpCase(Line)
    end do
  end do

  write(Lu3,100) trim(Tag)
end do
iRow_c = iRow_c+1

! Close files, and copy temporary if used
if (Lu1 /= 0) close(Lu1)
if (Lu2 /= 0) close(Lu2)
if (Lu3 /= 0) close(Lu3)
if (AuxFile) call fCopy('purge',FileOut,iErr)

return

100 format(A)

end subroutine Merge_Constraints

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_TrcIdl_Final()
C
C     Thomas Bondo Pedersen, May 2010.
C
C     Deallocate array for tracing idle processors
C
      Implicit None
#include "choptr2.fh"

      If (l_Idle.gt.0) Then
         Call GetMem('TrcIdl','Free','Inte',ip_Idle,l_Idle)
         l_Idle=0
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine grow_l2(A,B,nc,nv,dima,dimb,lasta,lastb)
! this routine does:
!
! grow A(A,B,m) from the blocked cholesky vectors B(a',b',m)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nc, nv, dima, dimb, lasta, lastb
real(kind=wp), intent(inout) :: A(nv,nv,nc)
real(kind=wp), intent(in) :: B(dima,dimb,nc)
integer(kind=iwp) :: i2, i3

do i3=1,nc
  do i2=1,dimb
    A(lasta+1:lasta+dima,lastb+i2,i3) = B(:,i2,i3)
    A(lastb+i2,lasta+1:lasta+dima,i3) = B(:,i2,i3)
  end do
end do

return

end subroutine grow_l2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION MorsPop(IMORS)
      IMPLICIT NONE
      DIMENSION NUM(0:15)
      INTEGER I1,I2,I3,IMORS
      INTEGER J,NUM
      DATA NUM / 0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4 /
      MorsPop=0 ! dummy initialize
      IF(IMORS.LT.0) GOTO 99
      I1=IMORS/16
      J=IMORS-16*I1
      MorsPop=NUM(J)
      IF(I1.EQ.0) RETURN
      I2=I1/16
      J=I1-16*I2
      MorsPop=MorsPop+NUM(J)
      IF(I2.EQ.0) RETURN
      I3=I2/16
      J=I2-16*I3
      MorsPop=MorsPop+NUM(J)
      IF(I3.EQ.0) RETURN
  99  CONTINUE
      WRITE(6,*)' MorsPop: Bad IMORS=',IMORS
      CALL ABEND()
      END
      INTEGER FUNCTION MorsParity(IMORS)
      IMPLICIT NONE
      DIMENSION ISG(0:15)
      INTEGER I1,I2,I3,IMORS
      INTEGER J,ISG
      DATA ISG / 1,-1,-1,1,-1,1,1,-1,-1,1,1,-1,1,-1,-1,1 /
      MorsParity=0 ! dummy initialize
      IF(IMORS.LT.0) GOTO 99
      I1=IMORS/16
      J=IMORS-16*I1
      MorsParity=ISG(J)
      IF(I1.EQ.0) RETURN
      I2=I1/16
      J=I1-16*I2
      MorsParity=MorsParity*ISG(J)
      IF(I2.EQ.0) RETURN
      I3=I2/16
      J=I2-16*I3
      MorsParity=MorsParity*ISG(J)
      IF(I3.EQ.0) RETURN
  99  CONTINUE
      WRITE(6,*)' MorsParity: Bad IMORS=',IMORS
      CALL ABEND()
      END
      INTEGER FUNCTION MorsSpin(IMORS,MS2ARR)
      IMPLICIT NONE
      INTEGER MORSBITS
      PARAMETER (MORSBITS=8)
      DIMENSION MS2ARR(*)
      INTEGER I,IB,IBIT,IMORS,MS2ARR
      MorsSpin=0
      IF(IMORS.LT.0) GOTO 99
      IB=IMORS
      DO I=1,MORSBITS
        IBIT=MOD(IB,2)
        IB=IB/2
        IF(IBIT.EQ.1) MorsSpin=MorsSpin+MS2ARR(I)
      END DO
      RETURN
  99  CONTINUE
      WRITE(6,*)' MorsSpin: Bad IMORS=',IMORS
      CALL ABEND()
      END
      INTEGER FUNCTION MorsSymm(IMORS,ISMARR)
      IMPLICIT NONE
      INTEGER MORSBITS
      PARAMETER (MORSBITS=8)
      DIMENSION ISMARR(*)
      INTEGER I,IB,IBIT,IMORS,ISMARR
#include "symmul.fh"
      MorsSymm=1
      IF(IMORS.LT.0) GOTO 99
      IB=IMORS
      DO I=1,MORSBITS
        IBIT=MOD(IB,2)
        IB=IB/2
        IF(IBIT.EQ.1) MorsSymm=MUL(MorsSymm,ISMARR(I))
      END DO
      RETURN
  99  CONTINUE
      WRITE(6,*)' MorsSymm: Bad IMORS=',IMORS
      CALL ABEND()
      END
      SUBROUTINE MorsWrite(IMORS,STRING)
      IMPLICIT NONE
      CHARACTER*(*) STRING
      INTEGER I,IB,IBIT,IMORS
      IF(IMORS.LT.0) GOTO 99
      IB=IMORS
      DO I=1,LEN(STRING)
        STRING(I:I)='0'
        IBIT=MOD(IB,2)
        IB=IB/2
        IF(IBIT.EQ.1) STRING(I:I)='1'
      END DO
      IF(IB.GT.0) THEN
       DO I=1,LEN(STRING)
        STRING(I:I)='*'
       END DO
      END IF
      RETURN
  99  CONTINUE
      WRITE(6,*)' MorsWrite: Bad IMORS=',IMORS
      CALL ABEND()
      END
*      SUBROUTINE MorsRead(IMORS,STRING)
*      IMPLICIT NONE
*      CHARACTER*(*) STRING
*      INTEGER I,POW2,IMORS
*      IMORS=0
*      POW2=1
*      DO I=1,LEN(STRING)
*        IF(STRING(I:I).EQ.'1') IMORS=IMORS+POW2
*        POW2=2*POW2
*      END DO
*      RETURN
*      END
      INTEGER FUNCTION Occ2Mrs(NO,IARRAY)
      IMPLICIT NONE
      INTEGER NO
      INTEGER IARRAY(NO)
      INTEGER I,POW2
      OCC2MRS=0
      POW2=1
      DO I=1,NO
        IF(IARRAY(I).NE.0) OCC2MRS=OCC2MRS+POW2
        POW2=2*POW2
      END DO
      RETURN
      END
      INTEGER FUNCTION MorsCre(IMORS,IPOS)
      IMPLICIT NONE
      INTEGER MorsParity
      EXTERNAL MorsParity
      INTEGER IMORS,IPOS,ISGN,MASK
      MorsCre=999999
      MASK=2**(IPOS-1)
      IF(IAND(MASK,IMORS).NE.0) RETURN
      ISGN=MorsParity(IMORS/MASK)
      MorsCre=ISGN*(IMORS+MASK)
      RETURN
      END
      INTEGER FUNCTION MorsAnn(IMORS,IPOS)
      IMPLICIT NONE
      INTEGER MorsParity
      EXTERNAL MorsParity
      INTEGER IMORS,IPOS,ISGN,MASK
      MorsAnn=999999
      MASK=2**(IPOS-1)
      IF(IAND(MASK,IMORS).EQ.0) RETURN
      MorsAnn=IMORS-MASK
      ISGN=MorsParity(MorsAnn/MASK)
      MorsAnn=ISGN*MorsAnn
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine OpnFls_SCF()
!***********************************************************************
!                                                                      *
!     purpose: Open files needed by SCF                                *
!                                                                      *
!***********************************************************************

use InfSCF, only: DoCholesky, DSCF
use SCFFiles, only: FnDel, FnDGd, FnDst, FnGrd, FnOrd, FnOSt, FnTSt, Fnx, Fny, LuDel, LuDGd, LuDst, LuGrd, LuOrd, LuOSt, LuTSt, &
                    Lux, Luy
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: iOpt, iRC
logical(kind=iwp) :: test

!---  open two-electron integral file ---------------------------------*
call f_Inquire(FnOrd,test)
call DecideOnDirect(.true.,test,DSCF,DoCholesky)
if ((.not. DSCF) .and. (.not. DoCholesky)) then
  !InVec = 0
  iRc = -1
  iOpt = 0
  call OpnOrd(iRC,iOpt,FnOrd,LuOrd)
  if (iRc /= 0) then
    write(u6,*) 'OpnFls: Error opening ORDINT'
    call Abend()
  end if
end if

!---  open DNSMAT, dVxcdR, TWOHAM and GRADIENT ------------------------*
call DAName(LuDSt,FnDSt)
call DAName(LuOSt,FnOSt)
call DAName(LuTSt,FnTSt)
call DAName(LuGrd,FnGrd)

!---  open 2nd order update files      --------------------------------*
call DAName(LuDGd,FnDGd)
call DAName(Lux,Fnx)
call DAName(LuDel,FnDel)
call DAName(Luy,Fny)

end subroutine OpnFls_SCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
*               1993, Per Boussard                                     *
************************************************************************
      SubRoutine PrjGrd(
#define _CALLING_
#include "grd_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of ECP integrals.         *
*                                                                      *
*      Alpha : exponents of bra gaussians                              *
*      nAlpha: number of primitives (exponents) of bra gaussians       *
*      Beta  : as Alpha but for ket gaussians                          *
*      nBeta : as nAlpha but for the ket gaussians                     *
*      Zeta  : sum of exponents (nAlpha x nBeta)                       *
*      ZInv  : inverse of Zeta                                         *
*      rKappa: gaussian prefactor for the products of bra and ket      *
*              gaussians.                                              *
*      P     : center of new gaussian from the products of bra and ket *
*              gaussians.                                              *
*      Final : array for computed integrals                            *
*      nZeta : nAlpha x nBeta                                          *
*      nComp : number of components in the operator (e.g. dipolmoment  *
*              operator has three components)                          *
*      la    : total angular momentum of bra gaussian                  *
*      lb    : total angular momentum of ket gaussian                  *
*      A     : center of bra gaussian                                  *
*      B     : center of ket gaussian                                  *
*      nRys  : order of Rys- or Hermite-Gauss polynomial               *
*      Array : Auxiliary memory as requested by ECPMem                 *
*      nArr  : length of Array                                         *
*      Ccoor : coordinates of the operator, zero for symmetric oper.   *
*      NOrdOp: Order of the operator                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, and Per Boussard, Dept. of Theoretical  *
*             Physics, University of Stockholm, Sweden, October '93.   *
************************************************************************
      use Basis_Info
      use Center_Info
      use Her_RW
      use Real_Spherical
      use Symmetry_Info, only: iOper
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "print.fh"
#include "disp.fh"

#include "grd_interface.fh"

*     Local variables
      Real*8 C(3), TC(3)
      Integer iDCRT(0:7), iuvwx(4), lOp(4), JndGrd(3,4)
      Character*80 Label
      Logical JfGrad(3,4), TstFnc, TF, ABeq(3), EQ
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)

*
      iRout = 192
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In PrjGrd: Grad',' ',Grad,1,nGrad)
         Call RecPrt(' In PrjGrd: A',' ',A,1,3)
         Call RecPrt(' In PrjGrd: RB',' ',RB,1,3)
         Call RecPrt(' In PrjGrd: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In PrjGrd: P',' ',P,nZeta,3)
         Call RecPrt(' In PrjGrd: Alpha',' ',Alpha,nAlpha,1)
         Call RecPrt(' In PrjGrd: Beta',' ',Beta,nBeta,1)
         Write (6,*) ' In PrjGrd: la,lb=',' ',la,lb
      End If
*
      nRys=nHer
*
      nDAO = nElem(la)*nElem(lb)
      iIrrep = 0
      iuvwx(1) = dc(mdc)%nStab
      iuvwx(2) = dc(ndc)%nStab
      lOp(1) = iOper(kOp(1))
      lOp(2) = iOper(kOp(2))
*
      iComp = 1
      kdc = 0
      Do 1960 kCnttp = 1, nCnttp
         If (.Not.dbsc(kCnttp)%ECP) Go To 1961
         Do 1965 kCnt = 1,dbsc(kCnttp)%nCntr
            C(1:3)=dbsc(kCnttp)%Coor(1:3,kCnt)
            If (iPrint.ge.49) Call RecPrt(' In PrjGrd: C',' ',C,1,3)
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
            Fact = DBLE(nStabM) / DBLE(LmbdT)
*
            iuvwx(3) = dc(kdc+kCnt)%nStab
            iuvwx(4) = dc(kdc+kCnt)%nStab
            Call ICopy(6,IndGrd,1,JndGrd,1)
            Do 10 i = 1, 3
               Do 11 j = 1, 2
                  JfGrad(i,j) = IfGrad(i,j)
 11            Continue
 10         Continue
*
            nDisp = IndDsp(kdc+kCnt,iIrrep)
            Do 220 iCar = 0, 2
               JfGrad(iCar+1,3) = .False.
               iCmp = 2**iCar
               If ( TF(kdc+kCnt,iIrrep,iCmp) .and.
     &              .Not.dbsc(kCnttp)%pChrg ) Then
                  nDisp = nDisp + 1
                  If (Direct(nDisp)) Then
                     JndGrd(iCar+1,1) = Abs(JndGrd(iCar+1,1))
                     JndGrd(iCar+1,2) = Abs(JndGrd(iCar+1,2))
                     JndGrd(iCar+1,3) = -nDisp
                     JfGrad(iCar+1,1) = .True.
                     JfGrad(iCar+1,2) = .True.
                  Else
                     JndGrd(iCar+1,3) = 0
                  End If
               Else
                  JndGrd(iCar+1,3) = 0
               End If
 220        Continue
            Call ICopy(3,[0],0,JndGrd(1,4),1)
            JfGrad(1,4) = .False.
            JfGrad(2,4) = .False.
            JfGrad(3,4) = .False.
            mGrad = 0
            Do 231 iCar = 1, 3
               Do 232 i = 1, 2
                  If (JfGrad(iCar,i)) mGrad = mGrad + 1
 232           Continue
 231        Continue
            If (iPrint.ge.99) Write (6,*) ' mGrad=',mGrad
            If (mGrad.eq.0) Go To 1965
*
         Do 1967 lDCRT = 0, nDCRT-1
            lOp(3) = iDCRT(lDCRT)
            lOp(4) = lOp(3)
            Call OA(iDCRT(lDCRT),C,TC)
            If (EQ(A,RB).and.EQ(A,TC)) Go To 1967
            Do 1966 iAng = 0, dbsc(kCnttp)%nPrj-1
               iShll = dbsc(kCnttp)%iPrj + iAng
               nExpi=Shells(iShll)%nExp
               nBasisi=Shells(iShll)%nBasis
               If (iPrint.ge.49) Then
                  Write (6,*) 'nExpi=',nExpi
                  Write (6,*) 'nBasisi=',nBasisi
                  Write (6,*) ' iAng=',iAng
                  Call RecPrt('TC',' ',TC,1,3)
               End If
               If (nExpi.eq.0 .or. nBasisi.eq.0) Go To 1966
*
               ip = 1
               ipF1 = ip
               nac = nElem(la)*nElem(iAng)*4
               ip = ip + nAlpha*nExpi*nac
               ipP1 = ip
               ip = ip + 3 * nAlpha*nExpi
               ipZ1 = ip
               ip = ip + nAlpha*nExpi
               ipK1 = ip
               ip = ip + nAlpha*nExpi
               ipZI1 = ip
               ip = ip + nAlpha*nExpi
               If (ip-1.gt.nArr*nZeta) Then
                  Write (6,*) '  ip-1.gt.nArr*nZeta(1) in PrjGrd'
                  Call Abend()
               End If
*
*--------------Calculate Effective center and exponent for <A|core>
*
               Call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,nExpi,
     &                   Alpha,Shells(iShll)%Exp)
               Call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,
     &                     A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))
*
*--------------Calculate Overlap <A|core> and derivative <A'|core>
*
               nHer = ((la+1)+iAng+2)/2
               ipAxyz = ip
               ip = ip + nAlpha*nExpi*3*nHer*(la+2)
               ipCxyz = ip
               ip = ip + nAlpha*nExpi*3*nHer*(iAng+1)
               ipRxyz = ip
               ip = ip + nAlpha*nExpi*3*nHer*(nOrdOp+1)
               ipQ1 = ip
               ip = ip +
     &               nAlpha*nExpi*3*(la+2)*(iAng+1)*(nOrdOp+1)
               ipA = ip
               ip = ip + nAlpha*nExpi
               If (ip-1.gt.nArr*nZeta) Then
                  Write (6,*) '  ip-1.gt.nArr*nZeta(1b) in PrjGrd'
                  Call Abend()
               End If
               ABeq(1) = A(1).eq.TC(1)
               ABeq(2) = A(2).eq.TC(2)
               ABeq(3) = A(3).eq.TC(3)
               Call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,
     &                     A,Array(ipAxyz),la+1,HerR(iHerR(nHer)),
     &                     nHer,ABeq)
               Call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,
     &                     TC,Array(ipCxyz),iAng,HerR(iHerR(nHer)),
     &                     nHer,ABeq)
               ABeq(1) = .False.
               ABeq(2) = .False.
               ABeq(3) = .False.
               Call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,
     &                     Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),
     &                     nHer,ABeq)
               If (iPrint.ge.49) Then
                  Write (6,*) ' Array(ipAxyz)=',
     &             DNrm2_(nAlpha*nExpi*3*nHer*(la+2),
     &             Array(ipAxyz),1)
                  Write (6,*) ' Array(ipCxyz)=',
     &             DNrm2_(nAlpha*nExpi*3*nHer*(iAng+1),
     &             Array(ipCxyz),1)
                  Write (6,*) ' Array(ipRxyz)=',
     &             DNrm2_(nAlpha*nExpi*3*nHer*(nOrdOp+1),
     &             Array(ipRxyz),1)
               End If
               Call Assmbl(Array(ipQ1),
     &                     Array(ipAxyz),la+1,
     &                     Array(ipRxyz),nOrdOp,
     &                     Array(ipCxyz),iAng,
     &                     nAlpha*nExpi,HerW(iHerW(nHer)),nHer)
               iStrt = ipA
               Do 20 iGamma = 1, nExpi
                  call dcopy_(nAlpha,Alpha,1,Array(iStrt),1)
                  iStrt = iStrt + nAlpha
 20            Continue
               If (iPrint.ge.49) Then
                  Write (6,*) ' Array(ipA)=',
     &            DNrm2_(nAlpha*nExpi,Array(ipA),1)
               End If
               Call rKappa_Zeta(Array(ipK1),Array(ipZ1),
     &                          nExpi*nAlpha)
               ld=1
               Call CmbnAC(Array(ipQ1),nAlpha*nExpi,la,iAng,
     &                     Array(ipK1),Array(ipF1),
     &                     Array(ipA),JfGrad(1,1),ld,nVecAC)
               If (iPrint.ge.49) Then
                Write (6,*) ' Array(ipQ1)=',
     &          DNrm2_(nAlpha*nExpi*3*(la+2)*(iAng+1)*(nOrdOp+1),
     &          Array(ipQ1),1)
                Write (6,*) ' Array(ipA)=',
     &          DNrm2_(nAlpha*nExpi,Array(ipA),1)
               End If
               ip = ip - nAlpha*nExpi
     &            * ( 6 + 3*nHer*(la+2) + 3*nHer*(iAng+1)
     &            + 3*nHer*(nOrdOp+1) + 3*(la+2)*(iAng+1)*(nOrdOp+1) +1)
*
               ipF2 = ip
               ncb = nElem(iAng)*nElem(lb)*4
               ip = ip + nExpi*nBeta*ncb
               ipP2 = ip
               ip = ip + 3 * nExpi*nBeta
               ipZ2 = ip
               ip = ip + nExpi*nBeta
               ipK2 = ip
               ip = ip + nExpi*nBeta
               ipZI2 = ip
               ip = ip + nExpi*nBeta
               If (ip-1.gt.nArr*nZeta) Then
                  Write (6,*) '  ip-1.gt.nArr*nZeta(2) in PrjGrd'
                  Call Abend()
               End If
*
*--------------Calculate Effective center and exponent for <core|B>
*
               Call ZXia(Array(ipZ2),Array(ipZI2),nExpi,nBeta,
     &                   Shells(iShll)%Exp,Beta)
               Call SetUp1(Shells(iShll)%Exp,nExpi,Beta,nBeta,
     &                    TC,RB,Array(ipK2),Array(ipP2),Array(ipZI2))
*
*--------------Calculate Overlap <core|B> and <core|B'>
*
               nHer = (iAng+(lb+1)+2)/2
               ipCxyz = ip
               ip = ip + nBeta*nExpi*3*nHer*(iAng+1)
               ipBxyz = ip
               ip = ip + nBeta*nExpi*3*nHer*(lb+2)
               ipRxyz = ip
               ip = ip + nBeta*nExpi*3*nHer*(nOrdOp+1)
               ipQ1 = ip
               ip = ip +
     &               nBeta*nExpi*3*(iAng+1)*(lb+2)*(nOrdOp+1)
               ipB = ip
               ip = ip + nBeta*nExpi
               If (ip-1.gt.nArr*nZeta) Then
                  Write (6,*) '  ip-1.gt.nArr*nZeta(2b) in PrjGrd'
                  Call Abend()
               End If
               ABeq(1) = TC(1).eq.RB(1)
               ABeq(2) = TC(2).eq.RB(2)
               ABeq(3) = TC(3).eq.RB(3)
               Call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,
     &                     TC,Array(ipCxyz),iAng,HerR(iHerR(nHer)),
     &                     nHer,ABeq)
               Call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,
     &                     RB,Array(ipBxyz),lb+1,HerR(iHerR(nHer)),
     &                     nHer,ABeq)
               ABeq(1) = .False.
               ABeq(2) = .False.
               ABeq(3) = .False.
               Call CrtCmp(Array(ipZ2),Array(ipP2),nExpi*nBeta,
     &                     Ccoor,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),
     &                     nHer,ABeq)
               If (iPrint.ge.49) Then
                  Write (6,*) ' Array(ipCxyz)=',
     &             DNrm2_(nBeta*nExpi*3*nHer*(iAng+1),
     &             Array(ipCxyz),1)
                  Write (6,*) ' Array(ipBxyz)=',
     &             DNrm2_(nBeta*nExpi*3*nHer*(lb+2),
     &             Array(ipBxyz),1)
                  Write (6,*) ' Array(ipRxyz)=',
     &             DNrm2_(nBeta*nExpi*3*nHer*(nOrdOp+1),
     &             Array(ipRxyz),1)
               End If
               Call Assmbl(Array(ipQ1),
     &                     Array(ipCxyz),iAng,
     &                     Array(ipRxyz),nOrdOp,
     &                     Array(ipBxyz),lb+1,
     &                     nExpi*nBeta,HerW(iHerW(nHer)),nHer)
               iStrt = ipB
               Do 21 iGamma = 1, nExpi
                  call dcopy_(nBeta,Beta,1,Array(iStrt),nExpi)
                  iStrt = iStrt + 1
 21            Continue
               If (iPrint.ge.49) Then
                  Write (6,*) ' Array(ipB)=',
     &            DNrm2_(nExpi*nBeta,Array(ipB),1)
               End If
               Call rKappa_Zeta(Array(ipK2),Array(ipZ2),
     &                          nExpi*nBeta)
               ld=1
               Call CmbnCB(Array(ipQ1),nExpi*nBeta,iAng,lb,
     &                     Array(ipK2),Array(ipF2),
     &                     Array(ipB),JfGrad(1,2),ld,nVecCB)
               If (iPrint.ge.49) Then
                 Write (6,*) ' Array(ipQ1)=',
     &           DNrm2_(nExpi*nBeta*3*(la+2)*(iAng+1)*(nOrdOp+1),
     &           Array(ipQ1),1)
                 Write (6,*) ' Array(ipB)=',
     &           DNrm2_(nExpi*nBeta,Array(ipB),1)
               End If
               ip = ip - nBeta*nExpi
     &            * ( 6 + 3*nHer*(lb+2) + 3*nHer*(iAng+1)
     &            + 3*nHer*(nOrdOp+1) + 3*(lb+2)*(iAng+1)*(nOrdOp+1) +1)
               nac = nElem(la)*nElem(iAng)*nVecAC
               ncb = nElem(iAng)*nElem(lb)*nVecCB
               ipTmp = ip
               ip = ip +
     &              Max(nAlpha*nExpi*nac,nBeta*ncb*nBasisi)
               If (ip-1.gt.nArr*nZeta) Then
                  Write (6,*) '  ip-1.gt.nArr*nZeta(3) in PrjGrd'
                  Call Abend()
               End If
               nac = nElem(la)*nElem(iAng)
               ncb = nElem(iAng)*nElem(lb)
*
*--------------Calculate Contraction over components of the core
*              orbitals of type <A|core>Bc<core|B> where we now have in
*              Array(ipF1) the cartesian components of <A|core>, and
*              similarily, in Array(ipF2), we have stored the cartesian
*              components of <core|B>. Observe that the core orbitals
*              orthonomal atomic orbitals. Hence, the transformation
*              to the spherical harmonics has to be for normilized
*              spherical harminics.
*
*--------------From the lefthandside overlap, form iKaC from ikac by
*              1) i,kac -> k,aci
*
               Call DgeTMo(Array(ipF1),nAlpha,nAlpha,
     &                     nExpi*nac*nVecAC,Array(ipTmp),
     &                     nExpi*nac*nVecAC)
*
*--------------2) aciK =  k,aci * k,K (Contract over core orbital)
*
               Call DGEMM_('T','N',
     &                     nac*nVecAC*nAlpha,nBasisi,nExpi,
     &                     1.0d0,Array(ipTmp),nExpi,
     &                     Shells(iShll)%pCff,nExpi,
     &                     0.0d0,Array(ipF1),nac*nVecAC*nAlpha)
*
*--------------3) Mult by shiftoperators aci,K -> Bk(K) * aci,K
*
               Do 1955 iBk = 1, nBasisi
                  Call DYaX(nac*nVecAC*nAlpha,Shells(iShll)%Bk(iBk),
     &                       Array((iBk-1)*nac*nVecAC*nAlpha+ipF1),1,
     &                       Array((iBk-1)*nac*nVecAC*nAlpha+ipTmp),1)
 1955          Continue
*
*--------------4) a,ciK -> ciKa
*
               Call DgeTMo(Array(ipTmp),nElem(la),nElem(la),
     &                     nElem(iAng)*nVecAC*nAlpha*nBasisi,
     &                     Array(ipF1),
     &                     nElem(iAng)*nVecAC*nAlpha*nBasisi)
*
*--------------5) iKa,C = c,iKa * c,C
*
               Call DGEMM_('T','N',
     &              nVecAC*nAlpha*nBasisi*nElem(la),
     &              (2*iAng+1),nElem(iAng),
     &              1.0d0,Array(ipF1),nElem(iAng),
     &              RSph(ipSph(iAng)),nElem(iAng),
     &              0.0d0,Array(ipTmp),
     &              nVecAC*nAlpha*nBasisi*nElem(la))
*
               Call DgeTMo(Array(ipTmp),nVecAC,nVecAC,
     &                     nAlpha*nBasisi*nElem(la)*(2*iAng+1),
     &                     Array(ipF1),
     &                     nAlpha*nBasisi*nElem(la)*(2*iAng+1))
*
*--------------And (almost) the same thing for the righthand side, form
*              KjCb from kjcb
*              1) jcb,K = k,jcb * k,K
*
               Call DGEMM_('T','N',
     &                     nBeta*ncb*nVecCB,nBasisi,nExpi,
     &                     1.0d0,Array(ipF2),nExpi,
     &                     Shells(iShll)%pCff,nExpi,
     &                     0.0d0,Array(ipTmp),nBeta*ncb*nVecCB)
*
*--------------2)  j,cbK -> cbK,j
*
               Call DgeTMo(Array(ipTmp),nBeta,nBeta,
     &                     ncb*nVecCB*nBasisi,Array(ipF2),
     &                     ncb*nVecCB*nBasisi)
*
*--------------3) bKj,C = c,bKj * c,C
*
               Call DGEMM_('T','N',
     &                     nElem(lb)*nVecCB*nBasisi*nBeta,
     &                     (2*iAng+1),nElem(iAng),
     &                     1.0d0,Array(ipF2),nElem(iAng),
     &                     RSph(ipSph(iAng)),nElem(iAng),
     &                     0.0d0,Array(ipTmp),
     &                     nElem(lb)*nVecCB*nBasisi*nBeta)
*
*--------------4) b,KjC -> KjC,b
*
               Call DgeTMo(Array(ipTmp),nElem(lb)*nVecCB,
     &                     nElem(lb)*nVecCB,
     &                     nBasisi*nBeta*(2*iAng+1),Array(ipF2),
     &                     nBasisi*nBeta*(2*iAng+1))
*
*--------------Next Contract (iKaC)*(KjCb) over K and C, producing ijab,
*              by the following procedure:
*              Loop over a and b
*                Loop over C
*                  Contract iK(aC)*Kj(Cb), over K producing ij(aCb),
*                    accumulate to ij(ab)
*                End loop C
*              End Loop b and a
*
               call dcopy_(nZeta*nElem(la)*nElem(lb)*6,[Zero],0,Final,1)
*
               mVec = 0
               mVecAC = 1
               mVecCB = 1
               Do 900 iCar = 1, 3
                  Do 901 iCent = 1, 2
                     If (JfGrad(iCar,iCent)) Then
                        mVec = mVec + 1
                        If (iCent.eq.1) Then
                           mVecAC = mVecAC+1
                           ipF1a = ipF1 + (mVecAC-1) *
     &                        nAlpha*nBasisi*nElem(la)*(2*iAng+1)
                           ipF2a = ipF2
                        Else
                           ipF1a = ipF1
                           mVecCB = mVecCB+1
                           ipF2a = ipF2 + (mVecCB-1) *
     &                       nBasisi*nBeta*(2*iAng+1)*nElem(lb)
                        End If
*
               Do 1030 ib = 1, nElem(lb)
                  Do 1031 ia = 1, nElem(la)
*
                     Do 1032 iC = 1, (2*iAng+1)
                        iaC = (iC-1)*nElem(la) + ia
                        ipaC = (iaC-1)*nAlpha*nBasisi + ipF1a
                        iCb = (ib-1)*(2*iAng+1) + iC
                        ipCb = (iCb-1)*nBasisi*nBeta  + ipF2a
*
                        Call DGEMM_('N','N',
     &                             nAlpha,nBeta,nBasisi,
     &                             Fact,Array(ipaC),nAlpha,
     &                                 Array(ipCb),nBasisi,
     &                             One,Final(1,ia,ib,mVec),nAlpha)
*
 1032                Continue
 1031             Continue
 1030          Continue
*
                     End If
 901              Continue
 900           Continue
*
               If (iPrint.ge.49) Then
                  Do 1111 iVec = 1, mVec
                     Write (6,*) iVec,
     &                  Sqrt(DNrm2_(nZeta*nElem(la)*nElem(lb),
     &                  Final(1,1,1,iVec),1))
 1111             Continue
               End If
               If (iPrint.ge.99) Then
                  Write (6,*) ' Result in PrjGrd'
                  Do 100 ia = 1, nElem(la)
                     Do 200 ib = 1, nElem(lb)
                        Do 300 iVec = 1, mVec
                           Write (Label,'(A,I2,A,I2,A)')
     &                           ' Final(',ia,',',ib,')'
                           Call RecPrt(Label,' ',Final(1,ia,ib,iVec),
     &                                 nAlpha,nBeta)
 300                    Continue
 200                 Continue
 100              Continue
               End If
*
*--------------Distribute contributions to the gradient
*
               Call Distg1X(Final,DAO,nZeta,nDAO,mVec,Grad,nGrad,
     &                      JfGrad,JndGrd,iuvwx,lOp)
*
 1966       Continue
 1967    Continue
 1965    Continue
 1961    Continue
         kdc = kdc + dbsc(kCnttp)%nCntr
 1960 Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Zeta)
         Call Unused_real_array(ZInv)
         Call Unused_real_array(rKappa)
         Call Unused_integer(nRys)
         Call Unused_integer_array(lOper)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine diis (wrk,wrksize,
     & diispointt,diispointr,key)
c
c     1) increment key
c     2) if key >=firstext do:
c     Tn = DIIS (previous cycext)
c     Tn=(T21,T22,T23,T13,T14)
c     if key < firstext
c     Tn=Tn(prev)
c
c     diispointt - pointer of T stack (I)
c     diispointr - pointer of R stack (I)
c     key        - manipulation key (I/O)
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
c
       integer diispointt(1:4)
       integer diispointr(1:4)
       integer key
c
c     help variables
c
       real*8 rdiis1(1:4,1:4)
       real*8 cdiis(1:4)
       integer rc,lun1,nhelp
culf
      do i=1,4
         cdiis(i)=0.0
         do j=1,4
            rdiis1(i,j)=0.0
         enddo
      enddo
c1    increment key
       key=key+1
c
       if (key.lt.firstext) then
c
c     get Tn from last possition
c
c     get lun number
       lun1=diispointt(1)
c     rewind lun1
       call filemanager (2,lun1,rc)
c     T2aaaa
       call getmediate (wrk,wrksize,
     & lun1,posst210,mapdt21,mapit21,rc)
c     T2bbbb
       call getmediate (wrk,wrksize,
     & lun1,posst220,mapdt22,mapit22,rc)
c     T2abab
       call getmediate (wrk,wrksize,
     & lun1,posst230,mapdt23,mapit23,rc)
c     T1aa
       call getmediate (wrk,wrksize,
     & lun1,posst130,mapdt13,mapit13,rc)
c     T1bb
       call getmediate (wrk,wrksize,
     & lun1,posst140,mapdt14,mapit14,rc)
c     rewind lun1
       call filemanager (2,lun1,rc)
c
       return
       end if
c
c2.1  make overlap matrix
c
c2.1.1rewind R-files
       call diisrf (diispointr,cycext)
c
c2.1.2.1  read R-T21
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.2.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 4,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,1)
c
c
c2.1.3.1  read R-T22
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.3.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 4,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,0)
c
c
c2.1.4.1  read R-T23
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.4.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 4,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,0)
c
c
c2.1.5.1  read R-T13
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.5.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 2,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,0)
c
c
c2.1.6.1  read R-T14
       call diisra (wrk,wrksize,
     & diispointr,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.1.6.2  add overlap mtx
       call diish1 (wrk,wrksize,
     & 2,rdiis1,mapdv1,mapdv2,mapdv3,mapdv4,
     & mapiv1,mapiv2,mapiv3,mapiv4,cycext,0)
c
c
c2.2.1calc DIIS coeficients
c
       call diish2 (rdiis1,cycext,cdiis,rc)
c2.2.2write DIIS coeficients
       if (fullprint.gt.1) then
       write(6,'(6X,A,4(F9.5,2X))') 'DIIS coeficients    :',
     & (cdiis(nhelp),nhelp=1,cycext)
       end if
c
c
c2.3  make new vector
c
c2.3.1rewind T-files
       call diisrf (diispointt,cycext)
c
c2.3.2.1  read T21
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.2.2  make new T21
       call diish3 (wrk,wrksize,
     & mapdt21,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
c2.3.3.1  read T22
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.3.2  make new T22
       call diish3 (wrk,wrksize,
     & mapdt22,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
c2.3.4.1  read T23
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.4.2  make new T23
       call diish3 (wrk,wrksize,
     & mapdt23,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
c2.3.5.1  read T13
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.5.2  make new T13
       call diish3 (wrk,wrksize,
     & mapdt13,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
c2.3.6.1  read T14
       call diisra (wrk,wrksize,
     & diispointt,cycext,
     & mapdv1,mapiv1,possv10,mapdv2,mapiv2,possv20,
     & mapdv3,mapiv3,possv30,mapdv4,mapiv4,possv40)
c
c2.3.6.2  make new T14
       call diish3 (wrk,wrksize,
     & mapdt14,mapdv1,mapdv2,mapdv3,mapdv4,cdiis,cycext)
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE TRIMUL(N,M,ALPHA,ASYM,X,LDX,Y,LDY)
      IMPLICIT NONE
      INTEGER N,M,LDX,LDY
      REAL*8 ALPHA,ASYM((N*(N+1))/2),X(LDX,M),Y(LDY,M)
      INTEGER I
C Multiply symmetric matrix ASYM with matrix X.
C Scale result with ALPHA and add it to matrix Y.
      DO 10 I=1,M
*        CALL DSLMX(N,ALPHA,ASYM,X(1,I),1,Y(1,I),1)
        CALL DSPMV_('U',N,ALPHA,ASYM,X(1,I),1,1.0D0,Y(1,I),1)
  10  CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MpProp(iReturn)

use MPProp_globals, only: AtBoMltPl, AtBoMltPlCopy, AtMltPl, AtPol, AtBoPol, BondMat, Cor, CordMltPl, EneV, Frac, iAtomType, &
                          iAtomPar, iAtPrTab, Labe, Method, MltPl, nAtomPBas, Qnuc
use Data_Structures, only: Allocate_DT, Deallocate_DT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6, RtoB

implicit none
integer(kind=iwp), intent(out) :: iReturn
integer(kind=iwp) :: i, iComp, iDum(1), iErr, iMltpl, iOff1, iOff2, iopt, iPol, iPrint, irc, iSmLbl, iSym, iWarn, iWFtype, Lu_, &
                     LuYou, nAtoms, nBas(8), nCenters, nComp, n_Int, nIrrep, nMltPl, nOcc, NOCOB, nOcOb_b, nOrbi, nPrim(8), nSize, &
                     nSum, nSym, nThrs, nTM, nVec, nVec_p
real(kind=wp) :: dLimmo(2), Thrs1, Thrs2, ThrsMul
character(len=6) :: FName
character(len=8) :: Label, MemLabel
character(len=80) :: VTitle
logical(kind=iwp) :: LNearestAtom, LAllCenters, AveOrb, Diffuse(3), LFirstRun, LLumOrb, Exists
integer(kind=iwp), allocatable :: ANr(:)
real(kind=wp), allocatable :: Atype(:), CenX(:), CenY(:), CenZ(:), Coor(:,:), D(:), D_p(:), D_p_b(:), EC(:,:), Ene(:,:), MP(:,:), &
                              Occ(:,:), Ocen(:,:), Ocen_b(:,:), Ocof(:), Ocof_b(:), TM(:), TP(:), Ttot(:,:), Ttot_Inv(:,:), &
                              Vec(:,:), Vec_p(:), Vec_p_b(:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
! Set some zeroes
nPrim(:) = 0
nBas(:) = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Set some defaults
!iPol = 1
LNearestAtom = .true.
LAllCenters = .false.
AveOrb = .false.
LLumOrb = .false.
Diffuse(1) = .false.
Diffuse(2) = .false.
Diffuse(3) = .false.
dLimmo(1) = 0.65_wp
dLimmo(2) = Two
Thrs1 = 1.0e-5_wp
Thrs2 = 1.0e-4_wp
nThrs = 3
ThrsMul = 1.0e-2_wp
iPrint = 1
!                                                                      *
!***********************************************************************
!                                                                      *
! Get some coords, nuc. charges and labels

! Memory debugging
!call Setmem('TRACE=ON')
!
! IO check
!call fastio('TRACE=ON')
!
!call Bnnr()
call Get_cArray('Relax Method',Method,8)
if (Method == 'RHF-SCF') then
  iPol = 1
else if (Method == 'UHF-SCF') then
  iPol = 1
else if (Method == 'MBPT2') then
  iPol = 0
end if
! Runfile update
!call Get_nAtoms(nAtoms)
call Get_iScalar('Unique atoms',nAtoms)

call mma_allocate(Labe,nAtoms,label='Labe')
call mma_allocate(iAtomType,nAtoms,label='iAtomType')
call mma_allocate(iAtomPar,nAtoms,label='iAtomPar')
call mma_allocate(Cor,3,nAtoms,nAtoms,label='Cor')
call mma_allocate(Frac,nAtoms,nAtoms,label='Frac')
call mma_allocate(BondMat,nAtoms,nAtoms,label='BondMat')
call mma_allocate(nAtomPBas,nAtoms,label='nAtomPBas')
call mma_allocate(Qnuc,nAtoms,label='Qnuc')
iAtomPar(:) = 1
BondMat(:,:) = .false.

call mma_allocate(Coor,3,nAtoms,label='Coor')
call mma_allocate(Atype,nAtoms,label='Atype')
nSum = nAtoms*4

! Runfile update
!call Get_Coord(Coor,nAtoms)
call Get_dArray('Unique Coordinates',Coor,nAtoms*3)
! Runfile update
!call Get_AtomLabel(Labe,nAtoms)
call Get_cArray('Unique Atom Names',Labe,nAtoms*len(Labe))
! Runfile update
!call Get_Charge(Atype,nAtoms)
call Get_dArray('Nuclear charge',Atype,nAtoms)

! Runfile update
!call Get_Charge_Eff(Qnuc,nAtoms)
call Get_dArray('Effective nuclear Charge',Qnuc,nAtoms)

do i=1,nAtoms
  iAtomType(i) = int(Atype(i))
  Cor(:,i,i) = Coor(:,i)
end do
call Wr_Cord(nAtoms)
call mma_deallocate(Atype)
nCenters = nAtoms*(nAtoms+1)/2
!                                                                      *
!***********************************************************************
!                                                                      *
! Get information from input

call Get_Mpprop_input(nAtoms,iPol,LNearestAtom,LAllCenters,AveOrb,LLumOrb,Diffuse,dLimmo,Thrs1,Thrs2,nThrs,ThrsMul,iPrint)
!                                                                      *
!***********************************************************************
!                                                                      *
! Read first the size of the contracted basis using the default file
! ONEINT and COMFILE

! Runfile update
!call Get_nSym(nSym)
call Get_iScalar('nSym',nSym)
!
! Runfile update
!call Get_nBas(nBas)
nIrrep = 1
call Get_iArray('nBas',nBas,1)

nVec = 0
nOcc = 0
do iSym=1,nSym
  nVec = nVec+nBas(iSym)**2
  nOcc = nOcc+nBas(iSym)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Read first the size of the primitive basis using ONEREL and COMREL

! Runfile update
!call Get_nBas(nPrim)
call Get_iArray('nBas_Prim',nPrim,1)

nSize = 0
do iSym=1,nSym
  nSize = nSize+nPrim(iSym)*(nPrim(iSym)+1)/2
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Do a dirty trick since the one-integral file is not explicitly opened.
call Put_iArray('nBas',nPrim,1)
!call OneBas('PRIM')
!                                                                      *
!***********************************************************************
!                                                                      *
! Read overlap, dipole moment and quadrupole moment integrals

! Count multipoles

iMltpl = 0
do
  write(label,'(a,i2)') 'PLTPL ',iMltpl
  irc = -1
  iopt = 1
  call iRdOne(irc,iopt,label,1,iDum,iSmLbl)
  if (irc /= 0) exit
  iMltpl = iMltpl+1
end do
nMltpl = max(0,iMltpl-1)

call Allocate_DT(MltPl,[0,nMltPl],'MltPl')
call mma_allocate(CordMltPl,[1,3],[0,nMltPl],label='CordMltPl')
nSum = nSum+3*(nMltPl+1)

! Do it general

do iMltpl=0,nMltPl
  write(label,'(a,i2)') 'PLTPL ',iMltpl
  nComp = (iMltpl+1)*(iMltpl+2)/2
  write(MemLabel,'(A5,i3.3)') 'MltPl',iMltpl
  do iComp=1,nComp
    irc = -1
    iopt = 1
    !EB call RdOne(irc,iopt,label,iComp,n_Int,iSmLbl)
    call iRdOne(irc,iopt,label,iComp,iDum,iSmLbl)
    if (irc /= 0) then
      write(u6,'(2A)') 'MPProp: Error reading label=',label
      call Abend()
    end if
    if (iComp == 1) then
      n_Int = iDum(1)
      call mma_allocate(MltPl(iMltPl)%A,n_Int+4,nComp,label=MemLabel)
      nSum = nSum+nComp*(n_Int+4)
    else if (iDum(1) /= n_Int) then
      write(u6,'(2A)') 'MPProp: Error reading iComp /= 1 label=',label
      call Abend()
    end if
    if (n_Int == 0) then
      write(u6,'(2A)') 'MPProp: Error reading n_Int=0 label=',label
      call Abend()
    end if
    irc = -1
    iopt = 0
    call RdOne(irc,iopt,label,iComp,MltPl(iMltpl)%A(:,iComp),iSmLbl)
    if (irc /= 0) then
      write(u6,'(2A)') '2 MPProp: Error reading ',label
      call Abend()
    end if
    !???????????????????????
    call CmpInt(MltPl(iMltpl)%A(:,iComp),n_Int,nPrim,nIrrep,iSmLbl)
    do i=1,3
      CordMltPl(i,iMltpl) = MltPl(iMltpl)%A(n_Int+i,1)
    end do
  end do
end do

!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate Memory For Multipoles on Atoms + Atoms and Bonds

call Allocate_DT(AtMltPl,[0,nMltPl],'AtMltPl')
call Allocate_DT(AtBoMltPl,[0,nMltPl],'AtBoMltPl')
call Allocate_DT(AtBoMltPlCopy,[0,nMltPl],'AtBoMltPlCopy')
do iMltpl=0,nMltPl
  nComp = (iMltpl+1)*(iMltpl+2)/2
  write(MemLabel,'(A5,i3.3)') 'AMtPl',iMltpl
  call mma_allocate(AtMltPl(iMltpl)%A,nComp,nCenters,label=MemLabel)
  write(MemLabel,'(A5,i3.3)') 'ABMtP',iMltpl
  call mma_allocate(AtBoMltPl(iMltpl)%A,nComp,nCenters,label=MemLabel)
  write(MemLabel,'(A5,i3.3)') 'MtPCp',iMltpl
  call mma_allocate(AtBoMltPlCopy(iMltpl)%A,nComp,nCenters,label=MemLabel)
  nSum = nSum+3*nComp*nCenters
  AtMltPl(iMltpl)%A(:,:) = Zero
  AtBoMltPl(iMltpl)%A(:,:) = Zero
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Read the P-matrix

Label = 'P_matrix'
irc = -1
iopt = 1
iComp = 1
!EB call RdOne(irc,iopt,label,iComp,n_Int,iSmLbl)
call iRdOne(irc,iopt,label,iComp,iDum,iSmLbl)
n_Int = iDum(1)
if (irc /= 0) then
  write(u6,'(2A)') 'MPProp: Error getting length of ',label
  write(u6,*) 'Length of the vector',n_Int,iSmLbl
  write(u6,*) 'irc=',irc
  call Abend()
end if
if (n_Int /= nSize) then
  write(u6,*) 'MPProp: n_Int.ne.nSize'
  write(u6,*) 'n_Int=',n_Int
  write(u6,*) 'nSize=',nSize
  call Abend()
end if
irc = -1
iopt = 0

call mma_allocate(CenX,n_Int+4,label='CenX')
call mma_allocate(CenY,n_Int+4,label='CenY')
call mma_allocate(CenZ,n_Int+4,label='CenZ')
nSum = nSum+3*(n_Int+4)

iComp = 1
call RdOne(irc,iopt,label,iComp,CenX,iSmLbl)
iComp = 2
call RdOne(irc,iopt,label,iComp,CenY,iSmLbl)
iComp = 3
call RdOne(irc,iopt,label,iComp,CenZ,iSmLbl)
!                                                                      *
!***********************************************************************
!                                                                      *
! Restore

call Put_iArray('nBas',nBas,1)
!call OneBas('CONT')
!                                                                      *
!***********************************************************************
!                                                                      *
! READ TRANSFORMATION MATRIX  nPrim(i)*nBas(i)

! The TM vectors holds the contraction coefficients of each
! basisset in the primitive base. This means that the columns in the
! TM are composed of the coefficients for each atomic basefunction
! and there are nBas(iSym) of them. The coefficients found in each
! column are exactly the same as in the basisset shifted to the
! right position in the matrix column. For a hydrogen molecule
! calculated with 2s function on each atom the first column will
! look like (c11,c21,...,0,0,...) where the zeros are to delete the
! primitive gaussians on the "second" hydrogen atom.
! The second column looks like (c12,c22,...,0,0,...) and the third
! (0,0,...,c11,c21,...) where in the third column the coefficients
! are shifted to zero out the "first" hydrogen atom.

nTM = 0
do iSym=1,nSym
  nTM = nTM+nBas(iSym)*nPrim(iSym)
end do
call mma_allocate(TM,nTM,label='TM')
nSum = nSum+nTM
! Runfile update
!call Get_TPC(TM,nTM)
call Get_dArray('NEMO TPC',TM,nTM)
!                                                                      *
!***********************************************************************
!                                                                      *
! Read the CMO's and occupation numbers

! CMO's stored as nBas(iSym)*nSO(iSym)

NOCOB = 0
nOcOb_b = 0
if (LLumOrb) then
  if (Method == 'UHF-SCF') then
    call mma_allocate(Vec,nVec,2,label='Vec')
    call mma_allocate(Occ,nOcc,2,label='Occ')
    call mma_allocate(Ene,nOcc,2,label='Ene')
    nSum = nSum+4*nOcc+2*nVec
  else
    call mma_allocate(Vec,nVec,1,label='Vec')
    call mma_allocate(Occ,nOcc,1,label='Occ')
    call mma_allocate(Ene,nOcc,2,label='Ene') ! because Ene(:,2) is later used for all cases
    ! The 3* is for technical reason
    nSum = nSum+3*nOcc+nVec
  end if
  Lu_ = 11
  FName = 'INPORB'
  if (Method == 'UHF-SCF') then
    call RdVec_(FName,Lu_,'COE',1,nSym,nBas,nBas,Vec(:,1),Vec(:,2),Occ(:,1),Occ(:,2),Ene(:,1),Ene(:,2),iDum,VTitle,iWarn,iErr, &
                iWFtype)
  else
    call RdVec(FName,Lu_,'COE',nSym,nBas,nBas,Vec,Occ,Ene,iDum,VTitle,iWarn,iErr)
  end if
  if (index(VTitle,'IVO') /= 0) then
    write(u6,*) ' MpProp not implemented for IVO orbitals!'
    call Abend()
  end if
  !if (iPol == 2) then
  !  call LauraPol()
  !end if
  do i=1,nOcc
    if (Occ(i,1) /= Zero) then
      nOcOb = nOcOb+1
    end if
  end do
  if (Method == 'UHF-SCF') then
    do i=1,nOcc
      if (Occ(i,2) /= Zero) then
        nOcOb_b = nOcOb_b+1
      end if
    end do
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Project the MO's on the primitive basis
  !
  nVec_p = 0
  do iSym=1,nSym
    nVec_p = nVec_p+nPrim(iSym)*nBas(iSym)
  end do
  call mma_allocate(Vec_p,nVec_p,label='Vec_p')
  nSum = nSum+nVec_p
  iOff1 = 1
  iOff2 = 1
  do iSym=1,nSym
    if (nPrim(iSym) > 0) then
      call DGEMM_('N','N',nPrim(iSym),nBas(iSym),nBas(iSym),One,TM(iOff2),nPrim(iSym),Vec(iOff1,1),nBas(iSym),Zero,Vec_p(iOff2), &
                  nPrim(iSym))
      iOff1 = iOff1+nBas(iSym)**2
      iOff2 = iOff2+nPrim(iSym)*nBas(iSym)
    end if
  end do

  if (Method == 'UHF-SCF') then
    call mma_allocate(Vec_p_b,nVec_p,label='Vec_p_b')
    nSum = nSum+nVec_p
    iOff1 = 1
    iOff2 = 1
    do iSym=1,nSym
      if (nPrim(iSym) > 0) then
        call DGEMM_('N','N',nPrim(iSym),nBas(iSym),nBas(iSym),One,TM(iOff2),nPrim(iSym),Vec(iOff1,2),nBas(iSym),Zero, &
                    Vec_p_b(iOff2),nPrim(iSym))
        iOff1 = iOff1+nBas(iSym)**2
        iOff2 = iOff2+nPrim(iSym)*nBas(iSym)
      end if
    end do
  end if

  call mma_allocate(Ocof,nVec_p,label='Ocof')
  nSum = nSum+nVec_p
  call Get_OCOF(nPrim(1),nBas(1),Vec_p,nVec_p,Ocof)
  if (Method == 'UHF-SCF') then
    call mma_allocate(Ocof_b,nVec_p,label='Ocofb')
    nSum = nSum+nVec_p
    call Get_OCOF(nPrim(1),nBas(1),Vec_p_b,nVec_p,Ocof_b)
  end if

  call mma_allocate(D_p,nPrim(1)*(nPrim(1)+1)/2,label='D_p')
  nSum = nSum+size(D_p)
  call Gen_Prim_Density_Matrix(nBas(1),nPrim(1),D_p,nOcOb,Occ,Ocof)
  if (Method == 'UHF-SCF') then
    call mma_allocate(D_p_b,nPrim(1)*(nPrim(1)+1)/2,label='D_p_b')
    nSum = nSum+size(D_p_b)
    call Gen_Prim_Density_Matrix(nBas(1),nPrim(1),D_p_b,nOcOb_b,Occ(:,2),Ocof_b)
  end if
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! If the densities are used for expansion then
  ! Project the densities on the primitive basis

  ! Get the orbital energy and allocate double memory due to UHF calculations
  call mma_allocate(Ene,nOcc,2,label='OrbE')
  nsum = nSum+2*nOcc
  if (Method == 'RHF-SCF') then
    call Get_OrbE(Ene,nOcc)
  else
    Ene(:,:) = Zero
  end if
  call mma_allocate(D,nBas(1)*(nBas(1)+1)/2,label='D1ao')
  call Get_Density_Matrix_mpprop(D,nBas(1),nSym)
  write(u6,*) 'No polarizability will be calculated'
  iPol = 0
  call mma_allocate(D_p,nPrim(1)*(nPrim(1)+1)/2,label='D_p')
  nSum = nSum+size(D_p)
  call Get_Prim_Density_Matrix(D,nBas(1),D_p,nPrim(1),TM)
  call mma_deallocate(D)
end if

!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(iAtPrTab,nPrim(1),nAtoms,label='iAtPrTab')
call Get_Prim_Atom_Tab(nAtoms,nPrim(1),Coor,CenX,CenY,CenZ)
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the SCF or RASSCF energy
! Runfile update
!call Get_Energy(EneV)
call Get_dScalar('Last energy',EneV)

write(u6,*)
write(u6,'(a,f16.8)') ' Total SCF energy ',EneV
write(u6,*)
nOrbi = nBas(1)

! If multipoles and polarizability of the bonds should go to
! the atoms they belong to or to the nearest atom
if (.not. LNearestAtom) then
  write(u6,*)
  write(u6,*) ' I will not move bonds and polarizabilities'
  write(u6,*) ' to the nearest atom, just to the bonding pair'
  write(u6,*)
else
  write(u6,*)
  write(u6,*) ' I WILL move bonds and polarizabilities'
  write(u6,*) ' to the nearest atom'
  write(u6,*)
end if

! Get multipole properties
LFirstRun = .true.

call Get_MpProp(nPrim(1),nAtoms,nMltPl,D_p,CenX,CenY,CenZ,LNearestAtom,LFirstRun,LLumOrb)
! nOcOb,nMltPl,Occ,nOcc,Ocof,

if (Method == 'UHF-SCF') then
  LFirstRun = .false.
  call Get_MpProp(nPrim(1),nAtoms,nMltPl,D_p_b,CenX,CenY,CenZ,LNearestAtom,LFirstRun,LLumOrb)
  ! nOcOb_b,nMltPl,Occ(:,2),nOcc,Ocof_b,
  LFirstRun = .true.
end if

! If the esteemed user wants to obtain diffuse local distributions,
! then proceed here. Much of the code is common with LoProp, hence
! there is first a call to a routine to order some quantities from
! MpProp in the same say as in LoProp, then Mother Goose is called.

if (Diffuse(1)) then
  call mma_allocate(ANr,nAtoms,label='ANr')
  call mma_allocate(Ttot,nBas(1),nBas(1),label='T')
  call mma_allocate(Ttot_Inv,nBas(1),nBas(1),label='Tinv')
  call mma_allocate(MP,nCenters,(nMltPl+1)*(nMltPl+2)*(nMltPl+3)/6,label='MultMom')
  call mma_allocate(EC,3,nCenters,label='ExpCent')
  call StoreMpAsLop(nAtoms,ANr,nBas(1),Ttot,Ttot_Inv,MP,nMltPl,EC)
  call mma_allocate(TP,nAtoms,label='ToPoint')
  call CoreToPoint(nAtoms,MP,TP)
  LuYou = IsFreeUnit(81)
  call OpnFl('DIFFPR',LuYou,Exists)
  call Diff_MotherGoose(Diffuse,nAtoms,nBas(1),MP,nCenters,EC,ANr,Ttot,Ttot_Inv,nMltPl,TP,dLimmo,Thrs1,Thrs2,nThrs,iPrint,ThrsMul, &
                        LuYou)
  close(LuYou)
  call mma_deallocate(ANr)
  call mma_deallocate(Ttot)
  call mma_deallocate(Ttot_Inv)
  call mma_deallocate(MP)
  call mma_deallocate(EC)
  call mma_deallocate(TP)
end if

! End of Diffuse.

if (LLumOrb) then
  ! Get center of charge for each molecular orbital
  call mma_allocate(Ocen,3,nOrbi,label='Ocen')
  nSum = nSum+3*nOrbi
  if (Method == 'UHF-SCF') then
    call mma_allocate(Ocen_b,3,nOrbi,label='Ocen_b')
    nSum = nSum+3*nOrbi
  end if
end if
! Get polarizabillities if iPol
call mma_allocate(AtPol,6,nAtoms,label='AtPol')
call mma_allocate(AtBoPol,6,nCenters,label='AtBoPol')
nSum = nSum+6*(nCenters+nAtoms)
AtPol(:,:) = Zero
AtBoPol(:,:) = Zero
if (iPol > 0) then
  !EB call Get_OrbCen(nPrim(1),nBas(1),NORBI,MltPl(0)%A(:,:))
  call Get_OrbCen(nPrim(1),NORBI,MltPl(0)%A(:,1),Ocen,CenX,CenY,CenZ,Ocof)
  if (Method == 'UHF-SCF') call Get_OrbCen(nPrim(1),NORBI,MltPl(0)%A(:,1),Ocen_b,CenX,CenY,CenZ,Ocof_b)
  if (iPol == 1) then
    if (nOcOb < nOcc) then
      call Get_Polar(nPrim(1),nBas(1),nAtoms,nOcOb,Ene,nOcc,Ocof,Ocen,LNearestAtom,LFirstRun)
      !EB  Ene,Occ,nOcc,Ocof,Ocen,
      if (Method == 'UHF-SCF') then
        LFirstRun = .false.
        call Get_Polar(nPrim(1),nBas(1),nAtoms,nOcOb_b,Ene(:,2),nOcc,Ocof_b,Ocen_b,LNearestAtom,LFirstRun)
      end if
    else
      write(u6,*)
      write(u6,*) 'I will not do an analysis of the polarizability'
      write(u6,*) 'no. of occupied orb. is to large'
      write(u6,*)
      if (Method == 'UHF-SCF') then
        write(u6,*) ' nOcOb nOcOb_b nOcc ',nOcOb,nOcOb_b,nOcc
      else
        write(u6,*) ' nOcOb nOcc ',nOcOb,nOcc
      end if
      write(u6,*)
      iPol = 0
    end if
  else if (iPol == 2) then
    call LauraPol()
  end if
end if

! Write output, the properties
call Wr_Prop(nAtoms,nCenters,nBas(1),nMltPl,NOCOB,NOCOB_b,Ene,Ene(:,2),iPol,LAllCenters)
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate

write(u6,*)
write(u6,*) 'Number of allocated real numbers',nsum
write(u6,'(a,f6.2,a)') ' That is ',real(nsum*RtoB,kind=wp)/(1024.0_wp**2),' MBytes'
write(u6,*)
call mma_deallocate(D_p)
!if (iPol == 0) then
call mma_deallocate(AtPol)
call mma_deallocate(AtBoPol)
!end if
if (LLumorb) then
  if (Method == 'UHF-SCF') then
    call mma_deallocate(D_p_b)
    call mma_deallocate(Ocen_b)
    call mma_deallocate(Ocof_b)
    call mma_deallocate(Vec_p_b)
  end if
  call mma_deallocate(Ocen)
  call mma_deallocate(Ocof)
  call mma_deallocate(Vec_p)
  call mma_deallocate(Occ)
  call mma_deallocate(Vec)
end if
call mma_deallocate(Ene)
call mma_deallocate(TM)
call mma_deallocate(CenX)
call mma_deallocate(CenY)
call mma_deallocate(CenZ)
call Deallocate_DT(AtMltPl)
call Deallocate_DT(AtBoMltPl)
call Deallocate_DT(AtBoMltPlCopy)
call Deallocate_DT(MltPl)
call mma_deallocate(CordMltPl)
call mma_deallocate(Coor)
call mma_deallocate(Labe)
call mma_deallocate(iAtomType)
call mma_deallocate(iAtomPar)
call mma_deallocate(Cor)
call mma_deallocate(Frac)
call mma_deallocate(BondMat)
call mma_deallocate(nAtomPBas)
call mma_deallocate(Qnuc)
call mma_deallocate(iAtPrTab)
!                                                                      *
!***********************************************************************
!                                                                      *
iReturn = 0

return

end subroutine MpProp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CompareFullAndBlocked(Tol,PackedF,F,ip_FBlocks,irc)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: compare two block matrices.
C
      Implicit None
      Real*8  Tol
      Logical PackedF
      Real*8  F(*)
      Integer ip_FBlocks
      Integer irc
#include "WrkSpc.fh"
#include "localdf_bas.fh"

      Logical  BlockMatricesAreIdentical
      External BlockMatricesAreIdentical

      Integer ip_XBlocks
      Integer ip, l
      Integer iCount, i

      ! Init return code
      irc=0

C----------------------------------------------------------------
C     Check that the block matrix obtained from F is identical to
C     ip_FBlocks.
C----------------------------------------------------------------

      Call LDF_AllocateBlockMatrix('_F_',ip_XBlocks)
      Call LDF_Full2Blocked(F,PackedF,ip_XBlocks)
      If (.not.BlockMatricesAreIdentical(ip_XBlocks,ip_FBlocks,Tol))
     & Then
         irc=irc+1
      End If
      Call LDF_DeallocateBlockMatrix('_F_',ip_XBlocks)

C---------------------------------------------------------------------
C     Check that the full matrix obtained from ip_FBlocks is identical
C     to F.
C---------------------------------------------------------------------

      If (PackedF) Then
         l=nBas_Valence*(nBas_Valence+1)/2
      Else
         l=nBas_Valence**2
      End IF
      Call GetMem('F__','Allo','Real',ip,l)
      Call FZero(Work(ip),l)
      Call LDF_Blocked2Full(ip_FBlocks,PackedF,Work(ip))
      iCount=0
      Do i=1,l
         If (abs(F(i)-Work(ip-1+i)).gt.Tol) Then
            iCount=iCount+1
         End If
      End Do
      If (iCount.gt.0) Then
         irc=irc+2
      End If
      Call GetMem('F__','Free','Real',ip,l)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine axesxbres_cvb( &
#                        define _CALLING_
#                        include "ddres_interface.fh"
                        )

use casvb_global, only: ifollow, nroot
use Definitions, only: wp, iwp, u6

implicit none
#include "ddres_interface.fh"
real(kind=wp) :: alfa
integer(kind=iwp) :: i, nnegeig, nposeig

if (ifollow == 1) then
  nposeig = nroot-1
  nnegeig = itdav-nposeig
else if (ifollow == 2) then
  nnegeig = nroot-1
  nposeig = itdav-nnegeig
else
  nnegeig = 0
  nposeig = 0
  write(u6,*) ' Error in IFOLLOW with direct Fletcher!',ifollow
  call abend_cvb()
end if
res(:) = rhs(:)
do i=1,itdav
  if (i <= nnegeig) then
    alfa = eig_res
  else
    alfa = -eig_res
  end if
  res(:) = res(:)+(axc(:,i)-alfa*sxc(:,i))*solp_res(i)
end do

is_converged = .true.

return

end subroutine axesxbres_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Stefan Knecht                                    *
************************************************************************
      module mspt2_eigenvectors

        implicit none

        type mspt2evc
          real*8, allocatable :: pc(:,:)
          real*8, allocatable :: sc(:,:)
        end Type

        type(mspt2evc), public, allocatable :: Heff_evc(:)

        save

        contains

        subroutine init_mspt2_eigenvectors(ijob,nstates,tag)
          integer, intent(in) :: ijob, nstates, tag
          if(tag == 0)then
            allocate(Heff_evc(ijob))
          else if(tag == 1)then
            allocate(Heff_evc(ijob)%pc(nstates,nstates))
            Heff_evc(ijob)%pc = 0
          else if(tag == 2)then
            allocate(Heff_evc(ijob)%sc(nstates,nstates))
            Heff_evc(ijob)%sc = 0
          else
            write(6,*) 'unknown tag in init_mspt2_eigenvectors'
            call Abend()
          end if
        end subroutine init_mspt2_eigenvectors

        subroutine deinit_mspt2_eigenvectors()
          integer             :: i
          do i = 1, size(Heff_evc)
            if(allocated(Heff_evc(i)%pc)) deallocate(Heff_evc(i)%pc)
            if(allocated(Heff_evc(i)%sc)) deallocate(Heff_evc(i)%sc)
          end do
          deallocate(Heff_evc)
        end subroutine deinit_mspt2_eigenvectors

        subroutine prpdata_mspt2_eigenvectors(
     &                                         rtdm,
     &                                         stdm,
     &                                         wetdm,
     &                                         prop,
     &                                         nprop,
     &                                         nstate,
     &                                         istate,
     &                                         jstate,
     &                                         ntdmzz,
     &                                         addr,
     &                                         iempty,
     &                                         lu,
     &                                         put_so_data,
     &                                         put_h5_data
     &                                       )

        integer, intent(in)    :: nprop
        integer, intent(in)    :: nstate
        integer, intent(in)    :: istate
        integer, intent(in)    :: jstate
        integer, intent(in)    :: ntdmzz
        integer, intent(in)    :: addr
        integer, intent(in)    :: iempty
        integer, intent(in)    :: lu
        logical, intent(in)    :: put_so_data
        logical, intent(in)    :: put_h5_data
        real*8,  intent(inout) :: rtdm(ntdmzz)
        real*8,  intent(inout) :: stdm(ntdmzz)
        real*8,  intent(inout) :: wetdm(ntdmzz)
        real*8,  intent(inout) :: prop(nstate,nstate,nprop)
        integer                   iOpt
        integer                   iGo
        integer                   iaddr
#include "rassiwfn.fh"


          !> calculate property matrix elements
          call proper(prop,istate,jstate,rtdm,wetdm)

          !> put data to file
          if(put_so_data)then
            iOpt=1
            iGo=7
            iaddr=addr
            call dens2file(
     &                     rtdm,
     &                     stdm,
     &                     wetdm,
     &                     ntdmzz,
     &                     lu,
     &                     iaddr,
     &                     iempty,
     &                     iOpt,
     &                     iGo,
     &                     iState,
     &                     jState
     &                     )
          end if

          if(put_h5_data.or.put_so_data)then
#ifdef _HDF5_
            call mh5_put_dset_array_real(wfn_sfs_tdm,
     &                                   rtdm, [NTDMZZ,1,1],
     &                                   [0,ISTATE-1,JSTATE-1])
            call mh5_put_dset_array_real(wfn_sfs_tsdm,
     &                                   stdm, [NTDMZZ,1,1],
     &                                   [0,ISTATE-1,JSTATE-1])
            if(put_so_data)then
              call mh5_put_dset_array_real(wfn_sfs_wetdm,
     &                                     wetdm, [NTDMZZ,1,1],
     &                                     [0,ISTATE-1,JSTATE-1])
            end if
#endif

          end if
        end subroutine prpdata_mspt2_eigenvectors

      end module mspt2_eigenvectors

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Per-Olof Widmark                                 *
!               1993,1996,1997, Markus P. Fuelscher                    *
!               1996, Luis Serrano-Andres                              *
!               2012, Victor P. Vysotskiy                              *
!***********************************************************************

subroutine DaClos(Lu)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Close unit Lu                                                    *
!                                                                      *
!     calling arguments:                                               *
!     Lu      : integer, input                                         *
!               logical unit number                                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, IBM Sweden, 1991                                   *
!     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
!     L. Serrano-Andres, University of Lund, Sweden, 1996              *
!     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
!                                                                      *
!***********************************************************************

use Fast_IO, only: FlsSize, FSCB, isOpen, LuName, LuNameProf, MaxFileSize, MaxSplitFile, MBL, MPUnit, Multi_File, MxFile, &
                   NProfFiles, Trace
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
use Fast_IO, only: isFiM
#endif
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Lu
integer(kind=iwp) :: i, iRc, Lu_, LuP
character(len=80) :: Text
character(len=*), parameter :: TheName = 'DaClos'
integer(kind=iwp), external :: AixCls, AixErr, AixFsz

if (Trace) then
  write(u6,*) ' >>> Enter DaClos <<<'
  write(u6,*) ' unit :',Lu
  write(u6,*) ' name :',LuName(Lu)
end if
LuP = 0
do i=1,NProfFiles
  if (LuNameProf(i) == LuName(Lu)) then
    LuP = i
  end if
end do
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
if (isFiM(Lu) == 0) then
#endif
  FlsSize(LuP) = AixFsz(FSCB(Lu))
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
else
  FlsSize(LuP) = FimFsz(FSCB(Lu))
end if
#endif

if ((Lu <= 0) .or. (Lu > MxFile)) call SysFileMsg(TheName,'MSG: unit',Lu,' ')
if (isOpen(Lu) == 0) call SysFileMsg(TheName,'MSG: notopened',Lu,' ')
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
if (isFiM(Lu) == 0) then
#endif
  iRc = AixCls(FSCB(Lu))
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
else
  iRc = FimCls(FSCB(Lu))
  isFiM(Lu) = 0
end if
#endif
if (iRc /= 0) then
  iRc = AixErr(Text)
  call SysFileMsg(TheName,'MSG: close',Lu,Text)
end if
isOpen(Lu) = 0
MBL(Lu) = 0
if (Multi_File(Lu)) then
  if (MaxFileSize /= 0) then
    if (Trace) write(u6,*) ' This is a partitioned data set'
    do i=1,MaxSplitFile-1
      Lu_ = MPUnit(i,Lu)
      if (Lu_ >= 1) then
        irc = 0
        if (isOpen(Lu_) /= 0) iRc = AixCls(FSCB(Lu_))
        if (iRc /= 0) then
          iRc = AixErr(Text)
          call SysFileMsg(TheName,'MSG: close',Lu_,Text)
        end if
        isOpen(Lu_) = 0
        MPUnit(i,Lu) = -99
        Multi_File(Lu_) = .false.
        MBL(Lu_) = 0
      end if
    end do
  end if
  MPUnit(0,Lu) = 0
  Multi_File(Lu) = .false.
end if

if (Trace) then
  write(u6,*) ' >>> Exit DaClos <<<'
end if

return

end subroutine DaClos

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MXMT(A,ICA,IRA, B,ICB,IRB, C, NROW,NSUM)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*),B(*),C(*)
      IND=0
      DO 100 IROW=0,NROW-1
      DO 101 ICOL=0,IROW
         SUM=0.0D0
         DO 110 ISUM=0,NSUM-1
            AB=A(1+IROW*ICA+ISUM*IRA) *
     &         B(1+ISUM*ICB+ICOL*IRB)
            SUM=SUM+AB
110      CONTINUE
         IND=IND+1
         C(IND)=SUM
101   CONTINUE
100   CONTINUE
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GASSPC
*
*
* Divide orbital spaces into
*
*  Inactive spaces : Orbitals that are doubly occupied in all CI spaces
*  Active orbitals : Orbitals that have variable occ in atleast some spaces.
*  Secondary spaces: Orbitals that are unoccupied in all spaces
*
* I_IAD : Division based upon occupation in Compound CI spaces IGSOCC
* I_IADX: Division based upon occupation in First CI space
*
* Jeppe Olsen, Summer of 98 ( not much of an summer !)
*
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "mxpdim.fh"
#include "cgas.fh"
#include "strinp.fh"
#include "orbinp.fh"
*
* Some dummy initializtions
      NEL_MAX = 0 ! jwk-cleanup
*
      NEL_REF = NELEC(1) + NELEC(2)
*
* For compound space
*
      DO IGAS = 1, NGAS
*
       IF(IGAS.EQ.1) THEN
         NEL_MAX = 2*NGSOBT(IGAS)
       ELSE
         NEL_MAX = NEL_MAX + 2*NGSOBT(IGAS)
       END IF
*
       IF(IGSOCC(IGAS,1) .EQ. NEL_MAX  .AND.
     &    IGSOCC(IGAS,2) .EQ. NEL_MAX       ) THEN
*. Inactive  space
          I_IAD(IGAS) = 1
       ELSE IF(IGAS.GT.1.AND.IGSOCC(IGAS-1,1) .EQ. NEL_REF ) THEN
*. Delete space
          I_IAD(IGAS) = 3
       ELSE
*. Active space
          I_IAD(IGAS) = 2
       END IF
*
      END DO
*
* For First CI space
*
      DO IGAS = 1, NGAS
*
       IF(IGAS.EQ.1) THEN
         NEL_MAX = 2*NGSOBT(IGAS)
       ELSE
         NEL_MAX = NEL_MAX + 2*NGSOBT(IGAS)
       END IF
*
       IF(IGSOCCX(IGAS,1,1) .EQ. NEL_MAX  .AND.
     &    IGSOCCX(IGAS,2,1) .EQ. NEL_MAX       ) THEN
*. Inactive  space
          I_IADX(IGAS) = 1
       ELSE IF(IGAS.GT.1.AND.IGSOCCX(IGAS-1,1,1) .EQ. NEL_REF ) THEN
*. Delete space
          I_IADX(IGAS) = 3
       ELSE
*. Active space
          I_IADX(IGAS) = 2
       END IF
*
      END DO
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
     &  ' Division of orbitals according to compound CI space'
        WRITE(6,*)
     &  ' ================================================== '
        WRITE(6,*)
        WRITE(6,*) ' Inactive = 1, Active = 2, Delete = 3 '
        WRITE(6,*)
        CALL IWRTMA(I_IAD,1,NGAS,1,NGAS)
        WRITE(6,*)
        WRITE(6,*)
     &  ' Division of orbitals according to first CI space'
        WRITE(6,*)
     &  ' ================================================== '
        WRITE(6,*)
        WRITE(6,*) ' Inactive = 1, Active = 2, Delete = 3 '
        WRITE(6,*)
        CALL IWRTMA(I_IADX,1,NGAS,1,NGAS)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Per Ake Malmqvist                                *
!***********************************************************************

subroutine PROTOT(NPORB,NPSDSZ,IPSDMS,NPCSFSZ,IPCSFCP,PCSFTOSD)
! Expand csf's in terms of determinants by the Grabenstetter method
!  (I.J.Q.C. 10, P142 (1976))
! Recoded by PAM 1999, after Jeppe Olsen.
!
! Input :
!         NPORB    : NUMBER OF OPEN ORBITALS
!         IPSDMS  : OCCUPATION OF PROTO-SDs
!         NPSDSZ   : NUMBER OF PROTOSD's
!         NPCSFSZ  : NUMBER OF PROTOCSF's
!         IPCSFCP  : SPIN COUPLINGS IN PROTO-CSFs
! Output :
!         PCSFTOSD :  NPSDSZ X NPCSFSZ MATRIX
!                GIVING EXPANSION FROM P-SD'S TO P-CSF'S

use rassi_aux, only: ipglob
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NPORB, NPSDSZ, IPSDMS(NPORB,NPSDSZ), NPCSFSZ, IPCSFCP(NPORB,NPCSFSZ)
real(kind=wp), intent(inout) :: PCSFTOSD(NPSDSZ,NPCSFSZ)
integer(kind=iwp) :: IC, IM, INDSMM, INDSPM, IOPEN, JCSF, JDET
real(kind=wp) :: COEF1, COEF2
integer(kind=iwp), parameter :: ASPIN = 1, BSPIN = 0, DWNCPL = 0, UPCPL = 1

do JCSF=1,NPCSFSZ
  if (IPGLOB >= 5) write(u6,*) ' ....Output for P-CSF ',JCSF
  do JDET=1,NPSDSZ
    ! EXPANSION COEFFICIENT OF DETERMINANT JDET FOR P-CSF JCSF
    COEF1 = One
    COEF2 = One
    INDSMM = 0
    INDSPM = 0
    do IOPEN=1,NPORB
      IC = 0
      if (IPCSFCP(IOPEN,JCSF) == UPCPL) IC = 1
      IM = 0
      if (IPSDMS(IOPEN,JDET) == ASPIN) IM = 1
      if (IC == 0) then
        if (IM == 0) then
          INDSPM = INDSPM-1
          COEF1 = COEF1*sqrt(real(INDSPM+1,kind=wp))
          ! If COEF1 has gone down to 0 exactly.
          if (INDSPM+1 == 0) exit
        else
          INDSMM = INDSMM-1
          COEF1 = -COEF1*sqrt(real(INDSMM+1,kind=wp))
          ! If COEF1 has gone down to 0 exactly.
          if (INDSMM+1 == 0) exit
        end if
        COEF2 = COEF2*sqrt(real(INDSPM+INDSMM+2,kind=wp))
      else
        if (IM == 0) then
          INDSMM = INDSMM+1
          COEF1 = COEF1*sqrt(real(INDSMM,kind=wp))
        else
          INDSPM = INDSPM+1
          COEF1 = COEF1*sqrt(real(INDSPM,kind=wp))
        end if
        COEF2 = COEF2*sqrt(real(INDSPM+INDSMM,kind=wp))
      end if
    end do

    PCSFTOSD(JDET,JCSF) = COEF1/COEF2

  end do
end do

end subroutine PROTOT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Reset_NQ_Grid
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "itmax.fh"
#include "nq_info.fh"
#include "grid_on_disk.fh"
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     Reset the size and the accuracy of the grid to the requested
*     values.
*
      L_Quad=L_Quad_Save
      If (Quadrature(1:3).eq.'LMG') Then
         Threshold=Threshold_Save
      Else
         nR=nR_save
      End If
*
      Crowding     =ThrC
*
      Write (6,*)
      Write (6,*) 'Reset the NQ grid!'
      Write (6,*)
      Call Funi_Print()
*                                                                      *
************************************************************************
*                                                                      *
*     Change the Grid set index
*
      iGrid_Set=Final
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************

*>  @brief
*>    Transform the active one-body density from MO to AO basis
*>
*>  @author
*>    Markus P. Fuelscher
*>
*>  @details
*>  The underlying equation is the basis transformatin:
*>  \f[ D^{\text{AO}} = C D C^\dagger \f]
*>  For the aktive orbitals this becomes:
*>  \f[ D^{\text{AO}, A} = C^A D^A (C^A)^\dagger \f]
*>  Where (\f$ C^A, D^A \f$) are the coefficients and densities of the active MOs.
*>
*>  @param[in] CMO The MO-coefficients
*>  @param[in] D1A_MO The active one-body density matrix in MO-space
*>  @param[out] D1A_AO The active one-body density matrix in AO-space
      subroutine Get_D1A_RASSCF(CMO,D1A_MO,D1A_AO)
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      use general_data, only : nBas, nSym, nFro, nIsh, nAsh
      implicit none
#include "WrkSpc.fh"
      real*8, intent(in) :: CMO(*) , D1A_MO(*)
      real*8, intent(out) :: D1A_AO(*)
      real*8, parameter :: Zero = 0.0d0
      integer :: iOff1, iOff2, iOff3, iSym, iBas, iAsh, iIsh, iFro,
     &    iTmp1, iTmp2


      iOff1 = 1
      iOff2 = 1
      iOff3 = 1
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        iAsh = nAsh(iSym)
        iIsh = nIsh(iSym)
        iFro = nFro(iSym)
        Call dCopy_(iBas*iBas,[Zero],0,D1A_AO(iOff3),1)
        If ( iAsh.ne.0 ) then
          Call GetMem('Scr1','Allo','Real',iTmp1,iAsh*iAsh)
          Call GetMem('Scr2','Allo','Real',iTmp2,iAsh*iBas)
          Call Square(D1A_MO(iOff1),Work(iTmp1),1,iAsh,iAsh)
          Call DGEMM_('N','T',
     &                iBas,iAsh,iAsh,
     &                1.0d0,CMO(iOff2+(iFro+iIsh)*iBas),iBas,
     &                Work(iTmp1),iAsh,
     &                0.0d0,Work(iTmp2),iBas)
          Call DGEMM_('N','T',
     &                iBas,iBas,iAsh,
     &                1.0d0,Work(iTmp2),iBas,
     &                CMO(iOff2+(iFro+iIsh)*iBas),iBas,
     &                0.0d0,D1A_AO(iOff3),iBas)
          Call GetMem('Scr2','Free','Real',iTmp2,iAsh*iBas)
          Call GetMem('Scr1','Free','Real',iTmp1,iAsh*iAsh)
        End If
        iOff1 = iOff1 + (iAsh*iAsh+iAsh)/2
        iOff2 = iOff2 + iBas*iBas
        iOff3 = iOff3 + iBas*iBas
      End Do


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_INIT(SKIP_PRESCREEN,ALLOCATE_BOOKMARKS)
!
! Purpose: initializations.
!
! IF (SKIP_PRESCREEN): skip prescreening of diagonal.
! In this case, NNSHL and array iSP2F must be set
! externally (the allocation is checked here).
!
! IF (ALLOCATE_BOOKMARKS): allocate arrays needed to
! record bookmarks during Cholesky decomposition.

use Symmetry_Info, only: Mul
use Cholesky, only: BkmThr, BkmVec, CHKONLY, CHO_1CENTER, CHO_DECALG, CHO_NO2CENTER, CHO_PRESCREEN, Cho_SScreen, DIAMNZ, &
                    DID_DECDRV, IABMNZ, iAtomShl, iBas, iBasSh, ICHKQ, iiBstRSh, iiBstRSh_Hidden, INF_INIT, InfRed, InfRed_Hidden, &
                    InfVec, InfVec_Hidden, INFVEC_N2, IntMap, IPRINT, iQuAB, iQuAB_Hidden, iShlSO, iSOShl, LuCho, LuMap, LuPri, &
                    LuRed, LuRst, MaxQual, MaxRed, MaxVec, MODE_SCREEN, MX2SH, MXORSH, MySP, nBas, nBasSh, nBasT, nBstSh, &
                    nCol_BkmThr, nCol_BkmVec, nDGM_call, nDimRS, nnBstRSh, nnBstRSh_Hidden, nnShl, nnShl_SP, nnShl_tot, NNZTOT, &
                    nRow_BkmThr, nRow_BkmVec, nShell, nSym, nSys_call, nVecRS1, RstCho, SSTau, TDECDRV, TDECOM, Thr_PreScreen, &
                    ThrCom, TINTEG, TMISC, Trace_Idle
use stdalloc, only: mma_allocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: SKIP_PRESCREEN, ALLOCATE_BOOKMARKS
integer(kind=iwp) :: I, IA, IRC, ISHL, ISYM, ISYMA, ISYMB, nBsMax, nConfl, nnBMx, nnBT
real(kind=wp) :: XA, XB, XXB(8), XXBMx, XXBT
real(kind=wp), parameter :: GBLIM = 2.147483648e9_wp
character(len=*), parameter :: LINE = '=', SECNAM = 'CHO_INIT', STRING = 'Information from '

! Check settings for parallel runs.
! Return code: 3 will cause verification to accept this as a passed
! test (certain options are not available in parallel runs).
!     -----------------------------------------------------------------

IRC = -1
call CHO_P_CHECK(IRC)
if (IRC /= 0) then
  write(LUPRI,*) SECNAM,': CHO_P_CHECK returned ',irc
  !call CHO_QUIT('Error in '//SECNAM,102)
  call CHO_QUIT('Parallel option conflicts in '//SECNAM,3)
end if

! Allocate array for tracing idle procs.
! --------------------------------------

if (TRACE_IDLE) call CHO_TRCIDL_INIT()

! Set diagonal prescreening threshold.
! ------------------------------------

if (SKIP_PRESCREEN) CHO_PRESCREEN = .false.
if (CHO_PRESCREEN) then
  if (THR_PRESCREEN < Zero) THR_PRESCREEN = min(1.0e-14_wp,THRCOM)
end if

! Get info from Seward.
! ---------------------

call CHO_MCA_INIT(SKIP_PRESCREEN)

! Initialize nnShl_SP (enabling use of function CHO_F2SP).
! --------------------------------------------------------

NNSHL_SP = NNSHL

! Set damping.
! ------------

call CHO_SETDAMP()

! Allocate memory for reduced set index arrays.
! ---------------------------------------------

call mma_allocate(iiBstRSh_Hidden,nSym,nnShl,3,Label='iiBstRSh_Hidden')
iiBstRSh => iiBstRSh_Hidden
call mma_allocate(nnBstRSh_Hidden,nSym,nnShl,3,Label='nnBstRSh_Hidden')
nnBstRSh => nnBstRSh_Hidden
call mma_allocate(IntMap,nnShl,Label='IntMap')
call mma_allocate(MySP,nnShl,Label='MySP')

! Initialize timings etc.
! -----------------------

TDECDRV(:) = Zero
TINTEG(:,:) = Zero
TDECOM(:,:) = Zero
TMISC(:,:) = Zero
ICHKQ(:,:) = 0
NVECRS1(1:NSYM) = 0

DID_DECDRV = .false.

DIAMNZ = Zero
IABMNZ = 0
NNZTOT = 0

NSYS_CALL = 0
NDGM_CALL = 0

! Open files for vector and reduced set storage.
! Open restart files.
! ----------------------------------------------

LURED = 0
LUCHO(1:NSYM) = 0
LURST = 0
LUMAP = 0
call CHO_P_OPENVR(1)

! Initialize integral SP counter.
! -------------------------------

call CHO_INIMAP()

! Allocate memory for INFRED and INFVEC arrays.
! In so doing, determine the max. #vectors and #reduced sets.
! -----------------------------------------------------------

if ((MAXRED < 1) .or. (MAXVEC < 1)) then
  XXBMX = -1.0e8_wp
  XXBT = Zero
  do ISYM=1,NSYM
    XXB(ISYM) = Zero
    do ISYMB=1,NSYM
      ISYMA = MUL(ISYMB,ISYM)
      if (ISYMA == ISYMB) then
        XA = real(NBAS(ISYMA),kind=wp)
        XXB(ISYM) = XXB(ISYM)+XA*(XA+One)*Half
      else if (ISYMA > ISYMB) then
        XA = real(NBAS(ISYMA),kind=wp)
        XB = real(NBAS(ISYMB),kind=wp)
        XXB(ISYM) = XXB(ISYM)+XA*XB
      end if
    end do
    XXBT = XXBT+XXB(ISYM)     ! total diag. dim.
    XXBMX = max(XXBMX,XXB(ISYM)) ! max. diag. block
  end do
  if (MAXVEC < 1) then
    NBSMAX = NBAS(1)
    do ISYM=2,NSYM
      NBSMAX = max(NBSMAX,NBAS(ISYM))
    end do
    MAXVEC = 20*NBSMAX ! default max. #vectors
    if (XXBMX < GBLIM) then
      NNBMX = int(XXBMX)
      MAXVEC = min(MAXVEC,NNBMX) ! reset if less than default
    end if
  end if
  if (MAXRED < 1) then
    MAXRED = NSYM*MAXVEC ! default max. #red. sets
    if (XXBT < GBLIM) then
      NNBT = int(XXBT)
      MAXRED = min(MAXRED,NNBT) ! reset if less than default
    end if
  end if
end if

if ((MAXRED < 1) .or. (MAXVEC < 1)) then
  write(LUPRI,*) SECNAM,': MAXRED = ',MAXRED
  write(LUPRI,*) SECNAM,': MAXVEC = ',MAXVEC
  call CHO_QUIT('MAXRED/MAXVEC error in '//SECNAM,103)
else
  call mma_allocate(InfRed_Hidden,MaxRed,Label='InfRed_Hidden')
  InfRed => InfRed_Hidden
  call mma_allocate(InfVec_Hidden,MaxVec,INFVEC_N2,nSym,Label='InfVec_Hidden')
  InfVec => InfVec_Hidden
  call mma_allocate(nDimRS,NSYM,MAXRED,Label='nDimRS')
end if

! Allocate bookmarks (accuracy and number of Cholesky vectors).
! Not available with restart.
! -------------------------------------------------------------

if (Allocate_Bookmarks) then
  if (RSTCHO) then
    nRow_BkmVec = 0
    nCol_BkmVec = 0
    nRow_BkmThr = 0
    nCol_BkmThr = 0
  else
    call mma_allocate(BkmVec,nSym,MaxRed,Label='BkmVec')
    nRow_BkmVec = nSym
    nCol_BkmVec = 0
    call mma_allocate(BkmThr,nSym,MaxRed,Label='BkmThr')
    nRow_BkmThr = nSym
    nCol_BkmThr = 0
  end if
else
  nRow_BkmVec = 0
  nCol_BkmVec = 0
  nRow_BkmThr = 0
  nCol_BkmThr = 0
end if

! Initialize INFRED, INFVEC, vector counter, etc.
! Special handling depending on Cholesky restart.
! -----------------------------------------------

call CHO_INIT1()

! Set threshold for screening in vector subtraction.
! --------------------------------------------------

if (CHO_SSCREEN) then
  if (SSTAU < Zero) SSTAU = THRCOM*1.0e-6_wp
end if

! Print header and configuration.
! -------------------------------

if (IPRINT >= 1) then
  call CHO_PRTHEAD(.false.)
  call XFLUSH(LUPRI)
end if

! Check configuration.
! --------------------

NCONFL = 0
call CHO_CHKCONF(NCONFL,.true.)
if (CHKONLY) then
  write(LUPRI,'(A,A,I4,A)') SECNAM,':',NCONFL,' conflicts detected in Cholesky config'
  call CHO_QUIT('End of configuration check in '//SECNAM,100)
else if (NCONFL /= 0) then
  write(LUPRI,'(A,A,I4,A)') SECNAM,':',NCONFL,' conflicts detected in Cholesky config'
  call CHO_QUIT('Configuration conflicts in '//SECNAM,105)
end if

! Allocate and set shell-to-center mapping for 1-center decomposition.
! --------------------------------------------------------------------

if (CHO_1CENTER) then
  call mma_allocate(iAtomShl,nShell,Label='iAtomShl')

  IRC = -1
  call CHO_SETATOMSHL(IRC,IATOMSHL,size(IATOMSHL))
  if (IRC /= 0) then
    write(LUPRI,*) SECNAM,': CHO_SETATOMSHL returned ',IRC
    call CHO_QUIT(SECNAM//': shell-to-atom init failed!',102)
  end if
end if

! Allocate IQUAB array for qualification.
! Allocate IQUAB_L array for parallel runs.
! -----------------------------------------

call mma_allocate(iQuAB_Hidden,MaxQual,nSym,Label='iQuAB_Hidden')
iQuAB => iQuAB_Hidden
call CHO_P_INILQ(MAXQUAL,NSYM)

! Set screening mode.
! -------------------

if ((CHO_DECALG == 2) .or. (CHO_DECALG == 3) .or. (CHO_DECALG == 5) .or. (CHO_DECALG == 6)) then
  if (CHO_1CENTER) then
    if (CHO_NO2CENTER) then ! 2-c removed at diag. calc.
      MODE_SCREEN = 2 ! remove diagonals < THRCOM
    else
      MODE_SCREEN = 3 ! remove 2-c diags and diags < THRCOM
    end if
  else
    MODE_SCREEN = 2 ! remove diagonals < THRCOM
  end if
else
  MODE_SCREEN = 1 ! damped screening
end if

! Print section.
! --------------

if (IPRINT >= INF_INIT) then

  call CHO_HEAD(STRING//SECNAM,LINE,80,LUPRI)

  write(LUPRI,'(/,2X,A,I10)') 'Number of irreps        : ',NSYM
  write(LUPRI,'(2X,A,I10)') 'Number of SOs           : ',NBAST
  write(LUPRI,'(2X,A,I10)') 'Number of shells        : ',NSHELL
  write(LUPRI,'(2X,A,I10)') 'Number of shell pairs   : ',NNSHL_TOT
  write(LUPRI,'(2X,A,I10)') 'Contributing shell pairs: ',NNSHL
  write(LUPRI,'(2X,A,I10)') 'Max. shell dimension    : ',MXORSH
  write(LUPRI,'(2X,A,I10)') 'Max. shell pair dim.    : ',MX2SH

  if (IPRINT >= 4) then ! debug print

    ! Basis size info.
    ! ----------------

    write(LUPRI,'(/,2X,A,/,2X,A)') '  Symmetry        NBAS        IBAS','----------------------------------'
    do ISYM=1,NSYM
      write(LUPRI,'(2X,I10,2X,I10,2X,I10)') ISYM,NBAS(ISYM),IBAS(ISYM)
    end do
    write(LUPRI,'(2X,A)') '----------------------------------'

    ! Shell info.
    ! -----------

    write(LUPRI,'(/,2X,A,/,2X,A,/,2X,A)') '     Shell   Dimension    Symmetry   Dimension      Offset', &
                                          '             (NBSTSH)                (NBASSH)     (IBASSH)', &
                                          '----------------------------------------------------------'
    do ISHL=1,NSHELL
      do ISYM=1,NSYM
        if (ISYM == 1) then
          write(LUPRI,'(2X,I10,2X,I10,2X,I10,2X,I10,2X,I10)') ISHL,NBSTSH(ISHL),ISYM,NBASSH(ISYM,ISHL),IBASSH(ISYM,ISHL)
        else
          write(LUPRI,'(26X,I10,2X,I10,2X,I10)') ISYM,NBASSH(ISYM,ISHL),IBASSH(ISYM,ISHL)
        end if
      end do
    end do
    write(LUPRI,'(2X,A)') '----------------------------------------------------------'

    write(LUPRI,'(/,2X,A,/,2X,A,/,2X,A)') '    SO        SO    sym    Shell     Index ', &
                                          ' (global) (reduced)      (ISOSHL)  (ISHLSO)', &
                                          '-------------------------------------------'
    do ISYM=1,NSYM
      do I=1,NBAS(ISYM)
        IA = IBAS(ISYM)+I
        write(LUPRI,'(2X,I9,1X,I9,1X,I3,1X,I9,1X,I9)') IA,I,ISYM,ISOSHL(IA),ISHLSO(IA)
      end do
    end do
    write(LUPRI,'(2X,A)') '-------------------------------------------'

  end if

end if

end subroutine CHO_INIT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 2000  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine GETSGM2(ILEV,JLEV,ISYCI,CI,nCI,SGM,MSGM)
! GIVEN CI COUPLING LEVELS ILEV, JLEV, COMPUTE SGM=E(ILEV,JLEV)*CI
! ILEV,JLEV ARE IN PRINCIPLE ACTIVE ORBITAL NUMBERS, BUT POSSIBLY
! IN ANOTHER ORDER THAN THE USUAL ONE -- HERE WE USE THE ORDER
! FOLLOWED BY THE GUGA COUPLING SCHEME.
!
! THIS ROUTINE REPLACES EARLIER GETSGM, TO GET RID OF THE PACKING AND
! STORING USED EARLIER.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! NOTE!! THE EARLIER CALL GETSGM(ILEV,JLEV,IDARR,SGM) IS REPLACED BY
! GETSGM2(ILEV,JLEV,CI,SGM)!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

use Symmetry_Info, only: Mul
use sguga, only: CIS, EXS, SGS
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ILEV, JLEV, ISYCI, nCI, MSGM
real(kind=wp), intent(in) :: CI(nCI)
real(kind=wp), intent(inout) :: SGM(MSGM)
integer(kind=iwp) :: IJS, IS, ISSG, JS, NSGM

SGM(1:MSGM) = Zero
IS = SGS%ISM(ILEV)
JS = SGS%ISM(JLEV)
IJS = Mul(IS,JS)
ISSG = Mul(IJS,ISYCI)
NSGM = CIS%NCSF(ISSG)
if (NSGM > MSGM) then
  write(u6,*) 'GETSGM2: NSGM>MSGM'
  call Abend()
end if
if (NSGM == 0) return

call SG_Epq_Psi(SGS,CIS,EXS,ILEV,JLEV,One,ISYCI,CI,SGM)

end subroutine GETSGM2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine chngcont(coeffs,coeffst1,coeffst1a,coeffst2,coeffst2a,ncont,nprims,evec,type1,type2,work,work2,work3,MxprimL,rootOVLP, &
                    OVLPinv,exponents)
!#######################################################################
!bs purpose: makes out of old contraction coefficients(in normalized functions)
!bs new coefficients including the kinematical factors
!bs using the diagonal matrices on type1 and type2 (see subroutine kinemat)
!bs coeffst1a and coeffst2a additionally include the exponents alpha
!bs (that is why ....a). So the exponents in the integrals are moved
!bs to the contraction coefficients and not in some way into the primitive
!bs integrals.
!bs
!bs the different cases for contracted integrals differ later on in the
!bs choice of different sets of contraction coefficients.
!#######################################################################
!coeffs    : original contraction coefficients
!coeffst1  : A * cont coeff
!coeffst1a : A * alpha*cont coeff
!coeffst2a : c*A/(E+m) * cont coeff
!coeffst2  : c*A/(E+m) * alpha *cont coeff

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ncont, nprims, MxprimL
real(kind=wp), intent(in) :: coeffs(nprims,ncont), evec(nprims,nprims), type1(*), type2(*), rootOVLP(MxprimL,*), &
                             OVLPinv(MxprimL,*), exponents(*)
real(kind=wp), intent(out) :: coeffst1(nprims,ncont), coeffst1a(nprims,ncont), coeffst2(nprims,ncont), coeffst2a(nprims,ncont), &
                              work(nprims,nprims), work2(nprims,nprims), work3(nprims,nprims)
integer(kind=iwp) :: K

!bs first new coefficients for type1 (A)
!bs generate a transformation matrix on work

!bs build up the transformation matrix
do K=1,nprims
  work2(:,K) = type1(K)*evec(:,K)
end do
call dgemm_('N','T',nprims,nprims,nprims,One,work2,nprims,evec,nprims,Zero,work,nprims)
call dgemm_('N','N',nprims,nprims,nprims,One,work,nprims,rootOVLP,MxprimL,Zero,work2,nprims)
call dgemm_('N','N',nprims,nprims,nprims,One,rootOVLP,MxprimL,work2,nprims,Zero,work3,nprims)
call dgemm_('N','N',nprims,nprims,nprims,One,OVLPinv,MxprimL,work3,nprims,Zero,work,nprims)
!bs now transform the vectors
call dgemm_('N','N',nprims,ncont,nprims,One,work,nprims,coeffs,nprims,Zero,coeffst1,nprims)

!bs now with exponent

do K=1,ncont
  coeffst1a(:,K) = exponents(1:nprims)*coeffst1(:,K)
end do

!bs and now the same for the other type  A/(E+m)

!bs build up the transformation matrix
do K=1,nprims
  work2(:,K) = type2(K)*evec(:,K)
end do
call dgemm_('N','T',nprims,nprims,nprims,One,work2,nprims,evec,nprims,Zero,work,nprims)
call dgemm_('N','N',nprims,nprims,nprims,One,work,nprims,rootOVLP,MxprimL,Zero,work2,nprims)
call dgemm_('N','N',nprims,nprims,nprims,One,rootOVLP,MxprimL,work2,nprims,Zero,work3,nprims)
call dgemm_('N','N',nprims,nprims,nprims,One,OVLPinv,MxprimL,work3,nprims,Zero,work,nprims)
!bs now transform the vectors
call dgemm_('N','N',nprims,ncont,nprims,One,work,nprims,coeffs,nprims,Zero,coeffst2,nprims)

!bs now with exponent

do K=1,ncont
  coeffst2a(:,K) = exponents(1:nprims)*coeffst2(:,K)
end do

return

end subroutine chngcont

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Move_Polar(Polar,EC,nAtoms,nij,iANr,Bond_Threshold)

! Distributes the contributions from the bonds that doesn't fullfill the requiremen
! Bond_Length <= Bond_Threshold*(Bragg_Slater(iAtom)+Bragg_Slater(jAtom)) to the
! two atoms involved in the bond.
!
! Multipole moments are moved in the Move_Prop subroutine!

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nij, iANr(nAtoms)
real(kind=wp), intent(inout) :: Polar(6,nij)
real(kind=wp), intent(in) :: EC(3,nij), Bond_Threshold
integer(kind=iwp) :: iAtom, ii, ij, jAtom, jj
logical(kind=iwp) :: Bond_Ok
logical(kind=iwp), external :: Check_Bond

do iAtom=2,nAtoms
  ii = iAtom*(iAtom+1)/2
  do jAtom=1,iAtom-1
    jj = jAtom*(jAtom+1)/2
    Bond_Ok = Check_Bond(EC(1,ii),EC(1,jj),iANr(iAtom),iANr(jAtom),Bond_Threshold)
    ij = iAtom*(iAtom-1)/2+jAtom
    if (.not. Bond_Ok) then

      ! Move half of the bond polarizabilities to each atom

      Polar(:,ii) = Polar(:,ii)+Half*Polar(:,ij)
      Polar(:,jj) = Polar(:,jj)+Half*Polar(:,ij)
      Polar(:,ij) = Zero
    end if
  end do
end do

return

end subroutine Move_Polar

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CVE2(V,oe,dima,dimb,adda,addb,no,e2,e2os)
! this routine does:
! e2  =e2   + sum(a',b',i,j)[(a'i|b'j).{2(a'i|b'j)-(a'j|b'i)}]/Dija'b'
! e2os=e2os + sum(a',b',i,j)[(a'i|b'j).{ (a'i|b'j)          }]/Dija'b'
! N.B. Cierny Vypocet E2
! N.B.2 qvajt odflaknute

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, adda, addb, no
real(kind=wp), intent(in) :: V(dima,no,dimb,no), oe(*)
real(kind=wp), intent(inout) :: e2, e2os
integer(kind=iwp) :: a, b, i, j
real(kind=wp) :: dijab

do j=1,no
  do b=1,dimb
    do i=1,no
      do a=1,dima
        dijab = oe(i)+oe(j)-oe(adda+a)-oe(addb+b)
        e2 = e2+V(a,i,b,j)*(Two*V(a,i,b,j)-V(a,j,b,i))/dijab
        e2os = e2os+V(a,i,b,j)*(V(a,i,b,j))/dijab
      end do
    end do
  end do
end do

return

end subroutine CVE2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! MP2 density correction.
subroutine DCorrCorr(Dens,DenCorr,Trace_Diff,iOrb,iOcc)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iOrb, iOcc
real(kind=wp), intent(inout) :: Dens(nTri_Elem(iOrb))
real(kind=wp), intent(in) :: DenCorr(nTri_Elem(iOrb)), Trace_Diff
real(kind=wp) :: T, Trace_HF

Trace_HF = real(iOcc*2,kind=wp)
T = Trace_HF/(Trace_HF-Trace_Diff)
Dens(:) = T*(Dens(:)-DenCorr(:))
!Trace = Zero
!kaunt = 0
!do i=1,iOrb
!  Trace = Trace+Dens(nTri_Elem(i))
!end do
!call triprt('KKK',' ',Dens,iorb)
!write(u6,*) 'QQQ:',Trace
return

end subroutine DCorrCorr

************************************************************************
************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,1997, Roland Lindh                                *
*               2014, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine RS_P_RFO(H,g,nInter,dq,UpMeth,dqHdq,StepMax,
     &                    Step_Trunc)
************************************************************************
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             December '94                                             *
*                                                                      *
*                                                                      *
*             Solve      | H    g | | d |     | 1 0 | | d |            *
*                        |  T     | |   | = e |     | |   |            *
*                        | g    0 | | 1 |     | 0 1 | | 1 |            *
*                                                                      *
*             this corresponds to                                      *
*                                                                      *
*             H d + g = e d                                            *
*                                                                      *
*             and                                                      *
*                                                                      *
*               T                                                      *
*             g  d = e                                                 *
*                                                                      *
*             Modified from single negative eigenvalue to an arbitrary *
*             number, June '97, R. Lindh                               *
*                                                                      *
*             Removed full diagonalizations, April '14, I. Fdez. Galvan*
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
      Real*8 H(nInter,nInter), g(nInter), dq(nInter), Lambda
*
      Character*6 UpMeth
      Character*1 Step_Trunc
      Logical Found,Iterate
*
      iRout = 215
      Lu =6
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In RS_P_RFO: H','(10f10.6)',H,nInter,nInter)
         Call RecPrt(' In RS_P_RFO: g','(10f10.6)', g,nInter,1)
         Call RecPrt(' In RS_P_RFO:dq','(10f10.6)',dq,nInter,1)
      End If
*
      UpMeth='RSPRFO'
*
      NumVal=Min(2,nInter)
      nVStep=2
      Found=.False.
      Thr=1.0D-6
      Call GetMem('Vector','Allo','Real',ipVec,nInter*NumVal)
      Call GetMem('Values','Allo','Real',ipVal,NumVal)
      Call GetMem('Matrix','Allo','Real',ipMat,nInter*(nInter+1)/2)
      Call DZero(Work(ipVec),NumVal*nInter)
      Do i = 1, nInter
         Do j = 1, i
            ij = i*(i-1)/2+j-1
            Work(ipMat+ij)=H(i,j)
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Find the negative eigenvalue(s)
*     Stop when the highest eigenvalue found is larger than Thr
      Do While (.Not.Found)
        Call Davidson(Work(ipMat),nInter,NumVal,
     &                Work(ipVal),Work(ipVec),iStatus)
        If (iStatus.gt.0) Then
          Call SysWarnMsg('RS_P_RFO',
     &      'Davidson procedure did not converge','')
        End If
        If ((Work(ipVal+NumVal-1).gt.Thr).or.(NumVal.ge.nInter)) Then
          Found=.True.
        Else
*----     Increase the number of eigenpairs to compute
          Call Allocate_Work(ipTmp,NumVal*nInter)
          call dcopy_(NumVal*nInter,Work(ipVec),1,Work(ipTmp),1)
          Call GetMem('Vector','Free','Real',ipVec,nInter*NumVal)
          Call GetMem('Values','Free','Real',ipVal,NumVal)
          NumVal=Min(NumVal+nVStep,nInter)
          Call GetMem('Vector','Allo','Real',ipVec,nInter*NumVal)
          Call GetMem('Values','Allo','Real',ipVal,NumVal)
         call dcopy_((NumVal-nVStep)*nInter,Work(ipTmp),1,Work(ipVec),1)
          Call DZero(Work(ipVec+(NumVal-nVStep)*nInter),nVStep*nInter)
          Call DZero(Work(ipVal),NumVal)
          Call Free_Work(ipTmp)
        End If
      End Do
      Call GetMem('Matrix','Free','Real',ipMat,nInter*(nInter+1)/2)
*
      nNeg=0
      i=NumVal
      Do While ((i.ge.0).and.(nNeg.eq.0))
         i=i-1
         If (Work(ipVal+i).lt.Zero) nNeg=i+1
      End Do
      If (iPrint.ge.99) Then
         Call RecPrt(' In RS_P_RFO: Eigenvalues',' ',Work(ipVal),
     &               1,NumVal)
         Call RecPrt(' In RS_P_RFO: Eigenvectors',' ',Work(ipVec),
     &               nInter,NumVal)
         Write (Lu,*) ' nNeg=',nNeg
      End If
*
      If (iPrint.ge.6) Then
         Write (Lu,*)
         Write (Lu,*) 'RS-P-RF Optimization'
         Write (Lu,*) ' Iter   alpha        dqdq  StepMax'//
     &                '   EigVal_r  EigVal_t'
      End If
*
*     Write (Lu,*) 'Trust radius=',StepMax
      A_RFO=One   ! Initial seed of alpha
      IterMx=25
      Iter=0
      Iterate=.False.
      Thr=1.0D-7
      If (nNeg.gt.0) Then
         mInter=nNeg+1
         Call GetMem('StepN','Allo','Real',ipNStep,nInter)
         Call GetMem('GradN','Allo','Real',ipNGrad,nInter)
         Call GetMem('VectorN','Allo','Real',ipNVec,mInter)
         Call GetMem('ValuesN','Allo','Real',ipNVal,1)
         Call GetMem('MatrixN','Allo','Real',ipNMat,mInter*(mInter+1)/2)
         Call Allocate_Work(ipNTmp,mInter)
         Call DZero(Work(ipNTmp),mInter)
      End If
      mInter=nInter+1
      Call GetMem('StepP','Allo','Real',ipPStep,nInter)
      Call GetMem('GradP','Allo','Real',ipPGrad,nInter)
      Call GetMem('VectorP','Allo','Real',ipPVec,mInter)
      Call GetMem('ValuesP','Allo','Real',ipPVal,1)
      Call GetMem('MatrixP','Allo','Real',ipPMat,mInter*(mInter+1)/2)
      Call Allocate_Work(ipPTmp,mInter)
      Call DZero(Work(ipPTmp),mInter)
 998  Continue
         Iter=Iter+1
*        Write (Lu,*) 'Iter=',Iter
*        Write (Lu,*) 'A_RFO=',A_RFO
         Call DZero(dq,nInter)
         If (nNeg.gt.0) Then
*           write(Lu,*)
*           write(Lu,*) 'Process negative eigenvalues.'
*           write(Lu,*)
            mInter=nNeg+1
*                                                                      *
************************************************************************
*                                                                      *
*--------   Build the augmented matrix of the "negative" subspace
*            diagonal: negative eigenvalues (divided by alpha)
*            last row/column: components of the gradient along the
*                     negative eigenvectors (divided by sqrt(alpha))
*           Project the gradient in the negative subspace (but expressed
*           in the full space)
*           (Note that, since we are interested in the largest eigenvalue,
*            the whole matrix is multiplied by -1, so we actually find the
*            smallest eigenvalue and change its sign)
            Call DZero(Work(ipNGrad),nInter)
            Call DZero(Work(ipNMat),mInter*(mInter+1)/2)
            j=mInter*(mInter-1)/2
            Do i=1,nNeg
               Work(ipNMat+i*(i+1)/2-1)=-Work(ipVal+i-1)/A_RFO
               gv=DDot_(nInter,g,1,Work(ipVec+(i-1)*nInter),1)
               Work(ipNMat+j+i-1)=gv/Sqrt(A_RFO)
               Call DaXpY_(nInter,gv,Work(ipVec+(i-1)*nInter),1,
     &                              Work(ipNGrad),1)
            End Do
*
*--------   Solve the partial RFO system for the negative subspace
            call dcopy_(mInter,Work(ipNTmp),1,Work(ipNVec),1)
            Call Davidson(Work(ipNMat),mInter,1,Work(ipNVal),
     &                                          Work(ipNVec),iStatus)
            call dcopy_(mInter,Work(ipNVec),1,Work(ipNTmp),1)
            If (iStatus.gt.0) Then
               Call SysWarnMsg('RS_P_RFO',
     &              'Davidson procedure did not converge','')
            End If
            Call DScal_(1,-One,Work(ipNVal),1)
*
*--------   Scale the eigenvector (combines eqs. (5) and (23))
*           Convert to full space and add to complete step
            Call DScal_(nNeg,One/(Sqrt(A_RFO)*Work(ipNVec+nNeg)),
     &                      Work(ipNVec),1)
            Call dGeMV_('N',nInter,nNeg,One,Work(ipVec),nInter,
     &                                     Work(ipNVec),1,
     &                                 Zero,Work(ipNStep),1)
            Call DaXpY_(nInter,One,Work(ipNStep),1,dq,1)
            dqdq_max=Sqrt(DDot_(nInter,Work(ipNStep),1,Work(ipNStep),1))
*           write (Lu,*) 'dqdq_max=',dqdq_max
!           Sign
            EigVal_r=-DDot_(nInter,Work(ipNStep),1,Work(ipNGrad),1)
            If (iPrint.ge.99) Then
               Call RecPrt('dq_r',' ',Work(ipNStep),1,nInter)
               Call RecPrt(' g_r',' ',Work(ipNGrad),1,nInter)
               Write (Lu,*) 'Lambda=',EigVal_r
            End If
            If (EigVal_r.lt.-Thr) Then
               Write (Lu,*)
               Write (Lu,*) 'W A R N I N G !'
               Write (Lu,*) 'EigVal_r.lt.Zero',EigVal_r
               Write (Lu,*)
            End If
         Else
            EigVal_r=Zero
            dqdq_max=Zero
         End If
*
*        write(Lu,*)
*        write(Lu,*) 'Process positive eigenvalues.'
*        write(Lu,*)
         mInter=nInter+1
*                                                                      *
************************************************************************
*                                                                      *
*----    Build the augmented matrix of the "positive" subspace
*        Instead of reducing the dimensions, the negative eigenvectors
*        are simply projected out from the gradient and the eigenvalues
*        are shifted to a large positive arbitrary value (10), to avoid
*        interferences
         call dcopy_(nInter,g,1,Work(ipPGrad),1)
         Do i=1,nNeg
           gv=DDot_(nInter,Work(ipPGrad),1,Work(ipVec+(i-1)*nInter),1)
           Call DaXpY_(nInter,-gv,Work(ipVec+(i-1)*nInter),1,
     &                           Work(ipPGrad),1)
         End Do
         Do j=1,nInter
           call dcopy_(j,H(1,j),1,Work(ipPMat+j*(j-1)/2),1)
           Do i=1,nNeg
             ii=(i-1)*nInter-1
             Do k=1,j
               jk=j*(j-1)/2+k-1
               Work(ipPMat+jk)=Work(ipPMat+jk)-(Work(ipVal+i-1)-Ten)*
     &                           Work(ipVec+ii+j)*Work(ipVec+ii+k)
             End Do
           End Do
           Call DScal_(j,One/A_RFO,Work(ipPMat+j*(j-1)/2),1)
         End Do
         Call DZero(Work(ipPMat+mInter*(mInter-1)/2),mInter)
         Call DaXpY_(nInter,-One/Sqrt(A_RFO),Work(ipPGrad),1,
     &                     Work(ipPMat+mInter*(mInter-1)/2),1)
*
*----    Solve the partial RFO system for the positive subspace
         call dcopy_(mInter,Work(ipPTmp),1,Work(ipPVec),1)
         Call Davidson(Work(ipPMat),mInter,1,Work(ipPVal),Work(ipPVec),
     &                 iStatus)
         If (iStatus.gt.0) Then
           Call SysWarnMsg('RS_P_RFO',
     &          'Davidson procedure did not converge','')
         End If
         call dcopy_(mInter,Work(ipPVec),1,Work(ipPTmp),1)
         call dcopy_(nInter,Work(ipPVec),1,Work(ipPStep),1)
*
*----    Scale the eigenvector (combines eqs. (5) and (23))
*        Add to complete step
         Call DScal_(nInter,One/(Sqrt(A_RFO)*Work(ipPVec+nInter)),
     &                     Work(ipPStep),1)
         Call DaXpY_(nInter,One,Work(ipPStep),1,dq,1)
         dqdq_min=Sqrt(DDot_(nInter,Work(ipPStep),1,Work(ipPStep),1))
*        write (Lu,*) 'dqdq_min=',dqdq_min
         EigVal_t=-DDot_(nInter,Work(ipPStep),1,Work(ipPGrad),1) ! Sign
         If (iPrint.ge.99) Then
           Call RecPrt('dq_t',' ',Work(ipPStep),1,nInter)
           Call RecPrt(' g_t',' ',Work(ipPGrad),1,nInter)
           Write (Lu,*) 'Lambda=',EigVal_t
         End If
         If (EigVal_t.gt.Thr) Then
           Write (Lu,*)
           Write (Lu,*) 'W A R N I N G !'
           Write (Lu,*) 'EigVal_t.gt.Zero',EigVal_t
           Write (Lu,*)
         End If
*
      Lambda = EigVal_t + EigVal_r
      dqdq=Sqrt(DDot_(nInter,dq,1,dq,1))
*
      If (iPrint.ge.6)
     &  Write (Lu,'(I5,5F10.5)') Iter,A_RFO,dqdq,StepMax,
     &                           EigVal_r,EigVal_t
*                                                                      *
************************************************************************
*                                                                      *
*------- Initialize data for iterative scheme (only at first iteration)
*
         If (.Not.Iterate) Then
            A_RFO_long=A_RFO
            dqdq_long=dqdq
            A_RFO_short=Zero
            dqdq_short=dqdq_long+One
         End If
*                                                                      *
************************************************************************
*                                                                      *
*------- RF with constraints. Start iteration scheme if computed step
*        is too long.
*
         If (Iter.eq.1.and.dqdq.gt.StepMax) Iterate=.True.
*                                                                      *
************************************************************************
*                                                                      *
*        Procedure if the step length is not equal to the trust radius
*
         If (Iterate.and.Abs(StepMax-dqdq).gt.Thr) Then
            Step_Trunc='*'
*           Write (Lu,*) 'StepMax-dqdq=',StepMax-dqdq
            Call Find_RFO_Root(A_RFO_long,dqdq_long,
     &                         A_RFO_short,dqdq_short,
     &                         A_RFO,dqdq,StepMax)
            If (Iter.gt.IterMx) Then
               Write (Lu,*) ' Too many iterations in RF'
               Go To 997
            End If
            Go To 998
         End If
*
 997  Continue
      Call GetMem('Vector','Free','Real',ipVec,nInter*NumVal)
      Call GetMem('Values','Free','Real',ipVal,NumVal)
      If (nNeg.gt.0) Then
         mInter=nNeg+1
         Call GetMem('StepN','Free','Real',ipNStep,nInter)
         Call GetMem('GradN','Free','Real',ipNGrad,nInter)
         Call GetMem('VectorN','Free','Real',ipNVec,mInter)
         Call GetMem('ValuesN','Free','Real',ipNVal,1)
         Call GetMem('MatrixN','Free','Real',ipNMat,mInter*(mInter+1)/2)
         Call Free_Work(ipNTmp)
      End If
      mInter=nInter+1
      Call GetMem('StepP','Free','Real',ipPStep,nInter)
      Call GetMem('GradP','Free','Real',ipPGrad,nInter)
      Call GetMem('VectorP','Free','Real',ipPVec,mInter)
      Call GetMem('ValuesP','Free','Real',ipPVal,1)
      Call GetMem('MatrixP','Free','Real',ipPMat,mInter*(mInter+1)/2)
      Call Free_Work(ipPTmp)
*
      If (iPrint.ge.6) Then
         Write (Lu,*)
         Write (Lu,*)
         Write (Lu,*) 'Rational Function Optimization: Lambda=',Lambda
         Write (Lu,*)
      End If
      dqHdq=dqHdq+Lambda*Half
*
      If (iPrint.ge.99) Then
         Write (Lu,*) 'EigVal,dqHdq=',Lambda,dqHdq
         Call RecPrt(' In RS_P_RFO: g','(10f10.6)', g,nInter,1)
         Call RecPrt(' In RS_P_RFO:dq','(10f10.6)',dq,nInter,1)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Giovanni Ghigo                                   *
!***********************************************************************
!***********************************************************************
! This routine checks if -string- is a Real*8 number. If it is a number*
! NaN=.False. and -Number- contains the number, otherwise, NaN=.True.  *
!----------------------------------------------------------------------*
! Author:   Giovanni Ghigo - November 2004 - Lund(SE)                  *
! Author:   Giovanni Ghigo                                             *
!***********************************************************************

subroutine Get_dNumber(string,dNumber,iErr)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: string
real(kind=wp), intent(out) :: dNumber
integer(kind=iwp), intent(out) :: iErr
integer(kind=iwp) :: i, j
logical(kind=iwp) :: NaN
character(len=*), parameter :: Chars = ' +-1234567890.'

iErr = 0
dNumber = Zero
NaN = .true.
do i=1,len(string)
  NaN = .true.
  do j=1,len(Chars)
    if (string(i:i) == Chars(j:j)) NaN = .false.
  end do
  if (NaN) exit
end do
if (NaN) then
  iErr = 1
else
  read(string,*) dNumber
end if

return

end subroutine Get_dNumber

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function ifcasci_cvb()

use casvb_global, only: invec_cvb, nmcscf, variat
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: ifcasci_cvb

call f_inquire('JOBOLD',ifcasci_cvb)
! In variational calculations, CI vectors will be of no use
! unless they correspond to MOs identical to the present ones:
if (variat .and. ((invec_cvb /= 3) .or. (nmcscf > 1))) ifcasci_cvb = .false.

return

end function ifcasci_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module RandomMod

! Description:
!   This random number generator originally appeared in "Toward a Universal
!   Random Number Generator" by George Marsaglia and Arif Zaman.
!   Florida State University Report: FSU-SCRI-87-50 (1987)
!
!   It was later modified by F. James and published in "A Review of Pseudo-
!   random Number Generators"
!
!   THIS IS THE BEST KNOWN RANDOM NUMBER GENERATOR AVAILABLE.
!         (However, a newly discovered technique can yield
!           a period of 10^600. But that is still in the development stage.)
!
!   It passes ALL of the tests for random number generators and has a period
!   of 2^144, is completely portable (gives bit identical results on all
!   machines with at least 24-bit mantissas in the floating point
!   representation).
!
!   The algorithm is a combination of a Fibonacci sequence (with lags of 97
!   and 33, and operation "subtraction plus one, modulo one") and an
!   "arithmetic sequence" (using subtraction).
!
!   On a Vax 11/780, this random number generator can produce a number in
!   13 microseconds.

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: i97, j97
real(kind=wp) :: c, cd, cm, U(97)
logical(kind=iwp) :: test = .false.

public :: Ranmar, Rmarin

contains

subroutine Rmarin(ij,kl)
! This is the initialization routine for the random number generator RANMAR()
! NOTE: The seed variables can have values between:    0 <= IJ <= 31328
!                                                      0 <= KL <= 30081
! The random number sequences created by these two seeds are of sufficient
! length to complete an entire calculation with. For example, if sveral
! different groups are working on different parts of the same calculation,
! each group could be assigned its own IJ seed. This would leave each group
! with 30000 choices for the second seed. That is to say, this random
! number generator can create 900 million different subsequences -- with
! each subsequence having a length of approximately 10^30.
!
! Use IJ = 1802 & KL = 9373 to test the random number generator. The
! subroutine RANMAR should be used to generate 20000 random numbers.
! Then display the next six random numbers generated multiplied by 4096*4096
! If the random number generator is working properly, the random numbers
! should be:
!           6533892.0  14220222.0  7275067.0
!           6172232.0  8354498.0   10633180.0

  use Constants, only: Zero, Half
  use Definitions, only: u6

  integer(kind=iwp), intent(in) :: ij, kl
  integer(kind=iwp) :: i, ii, j, jj, k, l, m
  real(kind=wp) :: s, t

  test = .false.

  if ((ij < 0) .or. (ij > 31328) .or. (kl < 0) .or. (kl > 30081)) then
    write(u6,'(a)') 'The first random number seed must have a value between 0 and 31328'
    write(u6,'(a)') 'The second seed must have a value between 0 and 30081'
    call abend()
  end if

  i = mod(ij/177,177)+2
  j = mod(ij,177)+2
  k = mod(kl/169,178)+1
  l = mod(kl,169)

  do ii=1,97
    s = Zero
    t = Half
    do jj=1,24
      m = mod(mod(i*j,179)*k,179)
      i = j
      j = k
      k = m
      l = mod(53*l+1,169)
      if (mod(l*m,64) >= 32) then
        s = s+t
      end if
      t = Half*t
    end do
    U(ii) = s
  end do

  c = 362436.0_wp/16777216.0_wp
  cd = 7654321.0_wp/16777216.0_wp
  cm = 16777213.0_wp/16777216.0_wp

  i97 = 97
  j97 = 33

  test = .true.

end subroutine Rmarin

subroutine Ranmar(rvec,len)
! This is the random number generator proposed by George Marsaglia in
! Florida State University Report: FSU-SCRI-87-50
! It was slightly modified by F. James to produce an array of pseudorandom
! numbers.

  use Constants, only: Zero, One
  use Definitions, only: u6

  integer(kind=iwp), intent(in) :: len
  real(kind=wp), intent(out) :: rvec(len)
  integer(kind=iwp) :: ivec
  real(kind=wp) :: uni

  if (.not. test) then
    write(u6,'(a)') ' Call the init routine (RMARIN) before calling RANMAR'
    call abend()
  end if

  do ivec=1,len
    uni = u(i97)-u(j97)
    if (uni < Zero) uni = uni+One
    u(i97) = uni
    i97 = i97-1
    if (i97 == 0) i97 = 97
    j97 = j97-1
    if (j97 == 0) j97 = 97
    c = c-cd
    if (c < Zero) c = c+cm
    uni = uni-c
    if (uni < Zero) uni = uni+One
    rvec(ivec) = uni
  end do

end subroutine Ranmar

end module RandomMod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ORBORD_GAS(  NSMOB, MXPOBS,MXPNGAS,   NGAS,  NGSOB,
     &                       NGSOBT, NOCOBS, NTOOBS,  NTOOB, IREOST,
     &                       IREOTS,  ISFTO,  ITFSO,   IBSO, NOBPTS,
     &                       IOBPTS,  ISFSO,  ITFTO,  NOBPT,  IPRNT)
*
*
* Obtain Reordering arrays for orbitals
* ( See note below for assumed ordering )
*
*
* GAS version
*
* =====
* Input
* =====
*  NSMOB  : Number of orbital symmetries
*  MXPOBS : Max number of orbital symmetries allowed by program
*  MXPNGAS: Max number of GAS spaces allowed by program
*  NGAS   : Number of GAS spaces
*  NGSOB  : Number of GAS orbitals per symmetry and space
*  NGSOBT : Number of GAS orbitals per space
*  NOCOBS : Number of occupied orbitals per symmetry
*  NTOOBS : Number of orbitals per symmetry,all types
*
* ======
* Output
* ======
*  IREOST : Reordering array symmetry => type
*  IREOTS : Reordering array type     => symmetry
*  ISFTO  : Symmetry array for type ordered orbitals
*  ITFSO  : Type array for symmetry ordered orbitals( not activated )
*  IBSO   : First orbital of given symmetry ( symmetry ordered )
*  NOBPTS : Number of orbitals per subtype and symmetry
*  IOBPTS : Off sets for orbitals of given subtype and symmetry
*           ordered according to input integrals
*
* ISFSO  : Symmetry of orbitals, symmetry ordereing
* ITFTO  : Type of orbital, type ordering
*
* Jeppe Olsen, Winter 1994
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION NGSOB(MXPOBS,MXPNGAS),NOCOBS(*),NTOOBS(*)
      DIMENSION NGSOBT(MXPNGAS)
*. Output
      DIMENSION IREOST(*),IREOTS(*),ISFTO(*),ITFSO(*),IBSO(*)
      DIMENSION ISFSO(*),ITFTO(*)
      DIMENSION NOBPTS(MXPNGAS ,*),IOBPTS(MXPNGAS ,*)
      DIMENSION NOBPT(MXPNGAS )

* ==========================
* Note on order of orbitals
* ==========================
*
* The orbitals are supposed to be imported ordered symmetry-type
* ordered as
*
* Loop over symmetries of orbitals
*  Loop over GAS spaces
*   Loop over orbitals of this sym and GAS
*   End of Loop over orbitals
*  End of Loop over Gas spaces
* End of loop over symmetries
*
* Internally the orbitals are reordered to type symmetry order
* where the outer loop is over types and the inner loop is
* over symmetries, i.e.
*
* Loop over GAS spaces
*  Loop over symmetries of orbitals
*   Loop over orbitals of this sym and GAS
*   End of Loop over orbitals
*  End of loop over symmetries
* End of Loop over Gas spaces
*
*. 1:  Construct ISFTO, ITFTO, IREOST,IREOTS,NOBPTS,IOBPTS
*
*. To get rid of annoying and incorrect compiler warnings
      IBSSM = 0
*
      ITSOFF = 1
      DO IGAS = 1, NGAS
        DO ISYM = 1, NSMOB
          IF(ISYM.EQ.1) THEN
            IBSSM = 1
          ELSE
            IBSSM = IBSSM + NTOOBS(ISYM-1)
          END IF
          NPREV = 0
          DO JGAS = 1, IGAS-1
            NPREV = NPREV + NGSOB(ISYM,JGAS)
          END DO
          IADD = 0
          NOBPTS(IGAS,ISYM) = NGSOB(ISYM,IGAS)
          IOBPTS(IGAS,ISYM) = ITSOFF
C         NOBPTS(ISYM,IGAS) = NGSOB(ISYM,IGAS)
C         IOBPTS(ISYM,IGAS) = ITSOFF
          DO IORB = ITSOFF,ITSOFF+NGSOB(ISYM,IGAS)-1
            IADD = IADD + 1
            IREOTS(IORB) = IBSSM-1+NPREV+IADD
            IREOST(IBSSM-1+NPREV+IADD) = IORB
            ITFTO(IORB) = IGAS
            ISFTO(IORB) = ISYM
          END DO
          ITSOFF = ITSOFF + NGSOB(ISYM,IGAS)
        END DO
      END DO
*
* 2 : ISFSO,ITFSO
*
      ISTOFF = 1
      DO ISYM = 1, NSMOB
        DO IGAS = 1, NGAS
          DO IORB = ISTOFF,ISTOFF+NGSOB(ISYM,IGAS)-1
            ISFSO(IORB) = ISYM
            ITFSO(IORB) = IGAS
          END DO
          ISTOFF = ISTOFF + NGSOB(ISYM,IGAS)
        END DO
      END DO
*
* 3 IBSO, NOBPT
*
      IOFF = 1
      DO ISM = 1, NSMOB
       IBSO(ISM) = IOFF
       IOFF = IOFF + NTOOBS(ISM)
      END DO
      DO IGAS = 1, NGAS
        NOBPT(IGAS) = NGSOBT(IGAS)
      END DO
*
      NTEST = 0
      NTEST = MAX(IPRNT,NTEST)
      IF( NTEST .NE. 0 ) THEN
        WRITE(6,*)
        WRITE(6,*) ' ==================='
        WRITE(6,*) ' Output from ORBORD '
        WRITE(6,*) ' ==================='
        WRITE(6,*)
        WRITE(6,*) ' Symmetry of orbitals , type ordered '
        CALL IWRTMA(ISFTO,1,NTOOB,1,NTOOB)
        WRITE(6,*) ' Symmetry => type reordering array '
        CALL IWRTMA(IREOST,1,NTOOB,1,NTOOB)
        WRITE(6,*) ' Type => symmetry reordering array '
        CALL IWRTMA(IREOTS,1,NTOOB,1,NTOOB)
        WRITE(6,*) ' IBSO array '
        CALL IWRTMA(IBSO,1,NSMOB,1,NSMOB)
*
        WRITE(6,*) ' NOBPTS '
        CALL IWRTMA(NOBPTS,NGAS,NSMOB,MXPNGAS,MXPOBS)
        WRITE(6,*) ' NOBPT '
        CALL IWRTMA(NOBPT,NGAS,1,MXPNGAS,1)
        WRITE(6,*) ' IOBPTS '
        CALL IWRTMA(IOBPTS,NGAS,NSMOB,MXPNGAS,MXPOBS)
*
        WRITE(6,*) ' ISFTO array : '
        CALL IWRTMA(ISFTO,1,NTOOB,1,NTOOB)
        WRITE(6,*) ' ITFSO array : '
        CALL IWRTMA(ITFSO,1,NTOOB,1,NTOOB)
*
        WRITE(6,*) ' ISFSO array : '
        CALL IWRTMA(ISFSO,1,NTOOB,1,NTOOB)
        WRITE(6,*) ' ITFTO array : '
        CALL IWRTMA(ITFTO,1,NTOOB,1,NTOOB)
      END IF
*

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer_array(NOCOBS)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine ReadIn_SCF(SIntTh)
************************************************************************
*                                                                      *
*     purpose: Read input to SCF: one-electron integrals, informations *
*              about basis set and molecule and options to SCF.        *
*                                                                      *
*     called from: Scf                                                 *
*                                                                      *
*     calls to: R1IBas, RdInp,         IniSew, R1IntA, Rd2Int, SetUp,  *
*               PrRF                                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*     modified by M.Schuetz @teokem.lu.se, 1995                        *
*     output: computed prescreening level, based on                    *
*             convergence threshold                                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      use InfSO
      Implicit Real*8 (a-h,o-z)
*
#include "mxdm.fh"
#include "infscf.fh"
*
      Real*8 SIntTh
      Logical PkMode
*
      Call Timing(Cpu1,Tim1,Tim2,Tim3)
*                                                                      *
************************************************************************
*                                                                      *
*     read one electron integral file header
*
      Call R1IBas()
*                                                                      *
************************************************************************
*                                                                      *
*     read input
*
      Call RdInp_SCF()
*                                                                      *
************************************************************************
*                                                                      *
*---- Allocate memory for SCF procedure
*
      Call MemAlo()
*                                                                      *
************************************************************************
*                                                                      *
*     read one-electron integrals
*
      Call R1IntA()
*                                                                      *
************************************************************************
*                                                                      *
*     Initialize seward
*
      Call IniSew_scf(DSCF,EThr,DThr,FThr,DltNTh,SIntTh,KSDFT)
*                                                                      *
************************************************************************
*                                                                      *
*     setup for direct or conventional integral calculations
*
      If (DSCF) Then
         Call Set_Basis_Mode('Valence')
         Call Setup_iSD()
         Call AlloK2()
         Call Free_iSD()
*
*------- Initiate integral packing for semi-direct implementation
*
         If (nDisc.ne.0) Then
            PkMode=.True.
            Call Ini_PkR8(PkMode)
         End If
*
*------- Allocate buffers for semi-direct SCF
*
         Call IniBuf(nDisc,nCore)
*
      Else
*
*------ Read the header of the two-electron integral file
*
        Call Rd2Int_SCF()
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Timing(Cpu2,Tim1,Tim2,Tim3)
      TimFld( 1) = TimFld( 1) + (Cpu2 - Cpu1)
      End subroutine ReadIn_SCF



      Subroutine Ini_PkR8(PkMode)
      use Gateway_Info, only: PkAcc
      Logical PkMode
*
      Call inipkr8(PkAcc,PkMode)
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Per Ake Malmqvist                                *
!***********************************************************************
!****************************************************************
!  PROGRAM RASSI        PER-AAKE MALMQVIST
!  SUBROUTINE TRACR     IBM-3090 RELEASE 89 01 30
!  TRANSFORM ONE SPECIFIC SYMMETRY BLOCK OF TWO-ELECTRON
!  INTEGRALS. THIS ROUTINE IS CALLED FROM TRAINT.
!****************************************************************

subroutine TRACR(LBUF,CMO1,CMO2,NGAM2,TUVX,X1,X2,X3,VXPQ)

use Index_Functions, only: iTri
use TRNSFRM, only: IAPR, ISP, ISQ, ISR, ISS, LMOP1, LMOQ1, LMOR1, LMOS1, NAP, NAQ, NAR, NAS, NAVX, NBP, NBPQ, NBQ, NBR, NBRS, NBS, &
                   NVXPQ, NX1MX, NX2MX, NX3MX
use rassi_data, only: NASHT, NCMO
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LBUF, NGAM2
real(kind=wp), intent(in) :: CMO1(NCMO), CMO2(NCMO)
real(kind=wp), intent(inout) :: TUVX(NGAM2)
real(kind=wp), intent(out) :: X1(NX1MX), X2(NX2MX), X3(NX3MX), VXPQ(NVXPQ)
integer(kind=iwp) :: II, IOPT, IPQ, IPQST, IRC, IRSST, IT, ITF, ITU, IU, IUF, IUM, IV, IVF, IVX, IX, IXF, LPQ, NP, NPQ, NQ, NQM

! START LOOP OVER ORDERED AO-INTEGRALS: NPQ PQ-PAIRS IN EACH BUFFER.
! FOR EACH PQ PAIR, THERE IS A MATRIX CONTAINING THE (PQ,RS)
! INTEGRALS. INDEX S RUNS FASTEST, SO BY FORTRAN RULES, IF REGARDED
! AS A MATRIX JPQ(R,S), THEN THE MATRIX IS TRANSPOSED. IF ISR=ISS,
! THE MATRIX IS STORED IN ROW-MAJOR UNDERTRIANGULAR FORMAT.
! IN THE COMMENTS, NOTE THAT T,U, ETC DENOTES ACTUAL ORBITAL
! INDICES, WHILE IT,IU ETC ARE COUNTERS WITHIN THE SYMMETRY BLOCKS.
IRC = 0
IOPT = 1
IPQ = 0
LPQ = 0
NPQ = 0
IRSST = 1-NBRS
do NP=1,NBP
  NQM = NBQ
  if (ISP == ISQ) NQM = NP
  do NQ=1,NQM
    IPQ = IPQ+1
    ! IF NECESSARY, READ IN A FRESH INTEGRAL BUFFER OF NPQ MATRICES:
    if (LPQ == NPQ) then
      call RDORD(IRC,IOPT,ISP,ISQ,ISR,ISS,X1,LBUF,NPQ)
      IOPT = 2
      LPQ = 0
      IRSST = 1-NBRS
    end if
    LPQ = LPQ+1
    IRSST = IRSST+NBRS
    ! START TRANSFORMATION OF THIS PQ=PAIR
    if (ISR == ISS) then
      call SQUARE(X1(IRSST),X2,1,NBR,NBR)
    else
      X2(1:NBR*NBS) = X1(IRSST:IRSST+NBR*NBS-1)
    end if
    ! X2 CONTAINS THE MATRIX JPQ TRANSPOSED, X2(IS,IR)=JPQ(R,S)=(PQ/RS).
    call DGEMM_('T','N',NBR,NAS,NBS,One,X2,NBS,CMO2(LMOS1),NBS,Zero,X3,NBR)
    call DGEMM_('T','N',NAS,NAR,NBR,One,X3,NBR,CMO1(LMOR1),NBR,Zero,X2,NAS)
    ! X2 IS TRANSFORMED JPQ MATRIX, TRANSPOSED: X2(IX,IV)=(PQ/VX).
    ! SORT THE MATRIX X2 INTO VXPQ (SORT AFTER PQ INSTEAD OF VX).
    call DCOPY_(NAVX,X2,1,VXPQ(IPQ),NBPQ)
  end do
end do
! FIRST HALF TRANSFORMATION IS NOW DONE.VXPQ CONTAINS HALF TRANS-
! FORMED INTEGRALS FOR THIS SYMMETRY BLOCK: VXPQ(IPQ,IX,IV)=(PQ/VX).
! NOTE: V IS FIRST ORBITAL SET, X SECOND
! NOW TRANSFORM INDICES PQ TO TU FOR ALL (TU) >= (VX)
! FORTRAN ORDER IMPLIES THEN THAT U>=X AND, IF U=X, THEN T>=V.
IPQST = 1-NBPQ
do IV=1,NAR
  IVF = IV+IAPR(ISR)
  do IX=1,NAS
    IXF = IX+IAPR(ISS)
    IVX = IVF+NASHT*(IXF-1)
    IPQST = IPQST+NBPQ
    if (ISP == ISQ) then
      call SQUARE(VXPQ(IPQST),X3,1,NBP,NBP)
    else
      X3(1:NBPQ) = VXPQ(IPQST:IPQST+NBPQ-1)
    end if
    ! X3 IS HALF-TRANSFORMED JVX MATRIX, TRANSPOSED. X3(IQ,IP)=(PQ/VX).
    ! WHEN TRANSFORMING, SKIP INDICES U=1..IUM.
    IUM = 0
    if (ISQ == ISS) IUM = IX-1
    call DGEMM_('T','N',NBP,NAQ-IUM,NBQ,One,X3,NBQ,CMO2(LMOQ1+IUM*NBQ),NBQ,Zero,X1,NBP)
    ! X1(IU,IP) = (PU/VX) FOR THE GIVEN VX, ALL P, AND U>=X, WHERE P
    ! IS BASIS FUNCTIONS IN SYMMETRY ISP, U AND X ARE ACTIVE ORBITALS
    ! OF STATE 2 IN SYMMETRIES ISQ AND ISS, RESP., AND V IS ACTIVE ORB
    ! OF STATE 1 AND HAS SYMMETRY ISR.
    call DGEMM_('T','N',NAQ-IUM,NAP,NBP,One,X1,NBP,CMO1(LMOP1),NBP,Zero,X2,NAQ-IUM)
    ! X2 NOW CONTAINS THE TRANSFORMED JVX MATRIX TRANSPOSED, I.E.,
    ! X2(IU-IUM,IT)=JVX(T,U)=(TU/VX), IU=IUM+1,..,NAQ,  IT=1,..,NAP.
    II = 0
    do IT=1,NAP
      ITF = IT+IAPR(ISP)
      do IU=IUM+1,NAQ
        IUF = IU+IAPR(ISQ)
        II = II+1
        ITU = ITF+NASHT*(IUF-1)
        TUVX(iTri(ITU,IVX)) = X2(II)
      end do
    end do
    if (ISP == ISQ) cycle
    ! X3 STILL CONTAINS THE JVX MATRIX, TRANSPOSED. X3(IQ,IP)=(PQ/VX).
    ! PERM SYMMETRY OF P AND Q MEANS WE CAN LET THEM SWITCH IDENTITY.
    ! FOR REMAINDER OF THE LOOP, IF ISP /= ISQ, THEN REGARD X3 AS
    ! CONTAINING X3(IQ,IP)=(QP/VX) AND TRANSFORM AS BEFORE.
    ! WHEN TRANSFORMING, SKIP INDICES U=1..IUM.
    IUM = 0
    if (ISP == ISS) IUM = IX-1
    call DGEMM_('N','N',NBQ,NAP-IUM,NBP,One,X3,NBQ,CMO2(LMOP1+IUM*NBP),NBP,Zero,X1,NBQ)
    ! X1(IQ,IU) = (QU/VX) FOR THE GIVEN VX, ALL Q, AND U>=X, WHERE Q
    ! IS BASIS FUNCTIONS IN SYMMETRY ISQ, U AND X ARE ACTIVE ORBITALS
    ! OF STATE 2 IN SYMMETRIES ISP AND ISS, RESP., AND V IS ACTIVE ORB
    ! OF STATE 1 AND HAS SYMMETRY ISR.
    call DGEMM_('T','N',NAP-IUM,NAQ,NBQ,One,X1,NBQ,CMO1(LMOQ1),NBQ,Zero,X2,NAP-IUM)
    ! X2 NOW CONTAINS THE TRANSFORMED JVX MATRIX TRANSPOSED, I.E.,
    ! X2(IU-IUM,IT)=JVX(T,U)=(TU/VX), IU=IUM+1,..,NAP,  IT=1,..,NAQ.
    II = 0
    do IT=1,NAQ
      ITF = IT+IAPR(ISQ)
      do IU=IUM+1,NAP
        IUF = IU+IAPR(ISP)
        II = II+1
        ITU = ITF+NASHT*(IUF-1)
        TUVX(iTri(ITU,IVX)) = X2(II)
      end do
    end do
  end do
end do
if (ISR /= ISS) then
  ! NOW REPEAT IT ALL OVER AGAIN. THIS TIME, USE PERMUTATION
  ! SYMMETRY TO SWITCH IDENTITY OF BASIS INDICES R AND S.
  IRC = 0
  IOPT = 1
  IPQ = 0
  LPQ = 0
  NPQ = 0
  IRSST = 1-NBRS
  do NP=1,NBP
    NQM = NBQ
    if (ISP == ISQ) NQM = NP
    do NQ=1,NQM
      IPQ = IPQ+1
      ! IF NECESSARY, READ IN A FRESH INTEGRAL BUFFER OF NPQ MATRICES:
      if (LPQ == NPQ) then
        call RDORD(IRC,IOPT,ISP,ISQ,ISR,ISS,X1,LBUF,NPQ)
        IOPT = 2
        LPQ = 0
        IRSST = 1-NBRS
      end if
      LPQ = LPQ+1
      IRSST = IRSST+NBRS
      X2(1:NBR*NBS) = X1(IRSST:IRSST+NBR*NBS-1)
      ! X2 CONTAINS THE MATRIX JPQ , X2(IS,IR)=JPQ(S,R)=(PQ/SR).
      ! NOTE THAT SYMMETRY OF R IS ISS AND SYMMETRY OF S IS ISR NOW.
      call DGEMM_('N','N',NBS,NAR,NBR,One,X2,NBS,CMO2(LMOR1),NBR,Zero,X3,NBS)
      call DGEMM_('T','N',NAR,NAS,NBS,One,X3,NBS,CMO1(LMOS1),NBS,Zero,X2,NAR)
      ! X2 IS TRANSFORMED JPQ MATRIX, TRANSPOSED: X2(IX,IV)=(PQ/VX).
      ! SORT THE MATRIX X2 INTO VXPQ (SORT AFTER PQ INSTEAD OF VX).
      call DCOPY_(NAVX,X2,1,VXPQ(IPQ),NBPQ)
    end do
  end do
  ! AS BEFORE, EXCEPT THAT SYMMETRY OF V IS ISS, SYMMETRY OF X IS ISR.
  ! NOW TRANSFORM INDICES PQ TO TU FOR ALL (TU) >= (VX)
  ! FORTRAN ORDER IMPLIES THEN THAT U>=X AND, IF U=X, THEN T>=V.
  IPQST = 1-NBPQ
  do IV=1,NAS
    IVF = IV+IAPR(ISS)
    do IX=1,NAR
      IXF = IX+IAPR(ISR)
      IVX = IVF+NASHT*(IXF-1)
      IPQST = IPQST+NBPQ
      if (ISP == ISQ) then
        call SQUARE(VXPQ(IPQST),X3,1,NBP,NBP)
      else
        X3(1:NBPQ) = VXPQ(IPQST:IPQST+NBPQ-1)
      end if
      ! X3 IS HALF-TRANSFORMED JVX MATRIX, TRANSPOSED. X3(IQ,IP)=(PQ/VX).
      ! WHEN TRANSFORMING, SKIP INDICES U=1..IUM.
      IUM = 0
      if (ISQ == ISR) IUM = IX-1
      call DGEMM_('T','N',NBP,NAQ-IUM,NBQ,One,X3,NBQ,CMO2(LMOQ1+IUM*NBQ),NBQ,Zero,X1,NBP)
      ! X1(IU,IP) = (PU/VX) FOR THE GIVEN VX, ALL P, AND U>=X, WHERE P
      ! IS BASIS FUNCTIONS IN SYMMETRY ISP, U AND X ARE ACTIVE ORBITALS
      ! OF STATE 2 IN SYMMETRIES ISQ AND ISR, RESP., AND V IS ACTIVE ORB
      ! OF STATE 1 AND HAS SYMMETRY ISS.
      call DGEMM_('T','N',NAQ-IUM,NAP,NBP,One,X1,NBP,CMO1(LMOP1),NBP,Zero,X2,NAQ-IUM)
      ! X2 NOW CONTAINS THE TRANSFORMED JVX MATRIX TRANSPOSED, I.E.,
      ! X2(IU,IT)=JVX(T,U)=(TU/VX), IU=IUM+1,..,NAQ,  IT=1,..,NAP.
      II = 0
      do IT=1,NAP
        ITF = IT+IAPR(ISP)
        do IU=IUM+1,NAQ
          IUF = IU+IAPR(ISQ)
          II = II+1
          ITU = ITF+NASHT*(IUF-1)
          TUVX(iTri(ITU,IVX)) = X2(II)
        end do
      end do
      if (ISP == ISQ) cycle
      ! X3 STILL CONTAINS THE JVX MATRIX, TRANSPOSED. X3(IQ,IP)=(PQ/VX).
      ! PERM SYMMETRY OF P AND Q MEANS WE CAN LET THEM SWITCH IDENTITY.
      ! FOR REMAINDER OF THE LOOP, IF ISP /= ISQ, THEN REGARD X3 AS
      ! CONTAINING X3(IQ,IP)=(QP/VX) AND TRANSFORM AS BEFORE.
      ! WHEN TRANSFORMING, SKIP INDICES U=1..IUM.
      IUM = 0
      if (ISP == ISR) IUM = IX-1
      call DGEMM_('N','N',NBQ,NAP-IUM,NBP,One,X3,NBQ,CMO2(LMOP1+IUM*NBP),NBP,Zero,X1,NBQ)
      ! X1(IQ,IU) = (QU/VX) FOR THE GIVEN VX, ALL Q, AND U>=X, WHERE Q
      ! IS BASIS FUNCTIONS IN SYMMETRY ISQ, U AND X ARE ACTIVE ORBITALS
      ! OF STATE 2 IN SYMMETRIES ISP AND ISR, RESP., AND V IS ACTIVE ORB
      ! OF STATE 1 AND HAS SYMMETRY ISS.
      call DGEMM_('T','N',NAP-IUM,NAQ,NBQ,One,X1,NBQ,CMO1(LMOQ1),NBQ,Zero,X2,NAP-IUM)
      ! X2 NOW CONTAINS THE TRANSFORMED JVX MATRIX TRANSPOSED, I.E.,
      ! X2(IU,IT)=JVX(T,U)=(TU/VX), IU=IUM+1,..,NAP,  IT=1,..,NAQ.
      II = 0
      do IT=1,NAQ
        ITF = IT+IAPR(ISQ)
        do IU=IUM+1,NAP
          IUF = IU+IAPR(ISP)
          II = II+1
          ITU = ITF+NASHT*(IUF-1)
          TUVX(iTri(ITU,IVX)) = X2(II)
        end do
      end do
    end do
  end do
end if

end subroutine TRACR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010-2012, Jonas Bostrom                               *
!               2013, Roland Lindh                                     *
!***********************************************************************

subroutine ChoMP2g_GradSetup(irc,CMO)
!***********************************************************************
!                                                                      *
!     Author: Jonas Bostrom (2010-2012)                                *
!             Roland Lindh, Implementation of symmetry (some while in  *
!                           New Orleans during the 245th National ACS  *
!                           meeting, 7-11 April 2013).                 *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use Cholesky, only: nBas, nSym, NumCho
use ChoMP2, only: iAdrOff, lUnit_F, nFro, nMoMo, nMP2Vec, nOcc, nOrb, nVir
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Eight, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
real(kind=wp), intent(in) :: CMO(*)
integer(kind=iwp) :: i, iAdr, iAdr1, iAdr2, iAdrB(8), iAdrR(8), iB3, iClos, iCMOo, iComp, iiJ, iiK, iJ, iK, indx, iOff, iOff0, &
                     iOff1, iOff2, iOff3, iOff_A, iOff_A2, iOff_JL, iOff_Ria, iOff_Rin, iOff_Rmn, iOff_WJL(8), iOffA, iOffB, &
                     iOffB1, iOffB2, iOffB3(8,8), iOffBB, iOffCInv(8), iOffCMOo(8), iOffD(8), iOffFF, iOffFO, iOffFV, iOffL, &
                     iOffLRb(8,8), iOffLRo(8,8), iOffOF, iOffOO, iOffOV, iOffR, iOffVF, iOffVO, iOffVV, iOffZ, iOpt, iRd, iSeed, &
                     iSym, iSymlbl, iTypL, iTypR, iVecFF, iVecFO, iVecFV, iVecOF, iVecOO, iVecOV, iVecVF, iVecVO, iVecVV, iWr, j, &
                     jAdr, jSym, k, k_o, k_v, kl, kl_s, kSym, l, lA1, lA2, lB1kl, lB2kl, lB3jl, lB3kl, lB3kl_s, lCab, lCai, lCaK, &
                     lCia, lCij, lCiK, lCJK, lCKa, lCKi, lCmn, lCpn, lCpq, lk, lRecDens, lRia, lRin, lRmn, lSym, lTot, lTriDens, &
                     LuA(2), LuB(2), LuBTmp, lUkn, LuLVec, LuRVec, LuXVec, LuYVec, lVkn, lWJL, lWmjKJ, maxvalue, mSym, mSym2, &
                     nB3(8), nBas2, nBB, nJ, nK, nLRb(8), nLRo(8), nOccAll(8), nOccBas, nOO, nOrbBas, nVec, nVirBas
real(kind=wp) :: Fac, Fact
character(len=8) :: label
character(len=6) :: fname2
character(len=5) :: fname
real(kind=wp), allocatable :: A1(:), A2(:), B1kl(:), B2kl(:), B3jl(:), B3kl(:), B3kl_s(:), Cab(:), Cai(:), CaK(:), Cia(:), Cij(:), &
                              CiK(:), CJK(:), CKa(:), CKi(:), Cmn(:), CMO_Inv(:), CMO_o(:), CMO_v(:), Cpn(:), Cpq(:), &
                              MP2Density(:), MP2TDensity(:), MP2TTotDensity(:), Ria(:), Rin(:), Rmn(:), SCFDensity(:), &
                              SCFTDensity(:), SMat(:), STMat(:), Ukn(:), Vkn(:), WJL(:), WmjKJ(:)
character(len=*), parameter :: SecNam = 'ChoMP2g_GradSetup'
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
iWr = 1
iRd = 2
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute some sizes of some arrays

nBas2 = 0
lTriDens = 0
lRecDens = 0
nOrbBas = 0
nOccBas = 0
nVirBas = 0
iAdr = 1
jAdr = 1
iOff_JL = 0
iCMOo = 0
do iSym=1,nSym
  iOffCMOo(iSym) = iCMOo
  iCMOo = iCMOo+nBas(iSym)*nOcc(iSym)
  iOff_WJL(iSym) = iOff_JL
  iOff_JL = iOff_JL+nMP2Vec(iSym)*NumCho(iSym)
  iAdrR(iSym) = iAdr
  iAdrB(iSym) = jAdr
  iOffD(iSym) = nBas2
  nBas2 = nBas2+nBas(iSym)*nBas(iSym)
  lTriDens = lTriDens+nTri_Elem(nBas(iSym))
  lRecDens = lRecDens+nBas(iSym)*nBas(iSym)
  nOccAll(iSym) = nFro(iSym)+nOcc(iSym)
  iOffCInv(iSym) = nOrbBas
  nOrbBas = nOrbBas+nOrb(iSym)*nBas(iSym)
  nOccBas = nOccBas+nOcc(iSym)*nBas(iSym)
  nVirBas = nVirBas+nVir(iSym)*nBas(iSym)
  nOO = 0
  nBB = 0
  iB3 = 0
  do jSym=1,nSym
    kSym = ieor(iSym-1,jSym-1)+1

    iOffLRo(iSym,jSym) = nOO
    iOffLRb(iSym,jSym) = nBB
    nOO = nOO+nOrb(jSym)*nOrb(kSym)
    nBB = nBB+nBas(jSym)*nBas(kSym)
    iOffB3(iSym,jSym) = iB3
    iB3 = iB3+nBas(jSym)*nOcc(kSym)
  end do
  nB3(iSym) = iB3
  nLRo(iSym) = nOO
  nLRb(iSym) = nBB
  iAdr = iAdr+nBB*nMP2Vec(iSym)
  jAdr = jAdr+nBB*NumCho(iSym)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(CMO_inv,nOrbBas,Label='CMO_Inv')
CMO_inv(:) = Zero
call mma_allocate(CMO_o,nOccBas,Label='CMO_o')
call mma_allocate(CMO_v,nVirBas,Label='CMO_v')
!                                                                      *
!***********************************************************************
!                                                                      *
! Get memory for density matricies and overlap matrix

call mma_allocate(MP2Density,lRecDens,Label='MP2Density')
call mma_allocate(SCFDensity,lRecDens,Label='SCFDensity')
call mma_allocate(SMat,lRecDens,Label='SMat')

call mma_allocate(MP2TTotDensity,lTriDens,Label='MP2TTotDensity')
call mma_allocate(MP2TDensity,lTriDens,Label='MP2TDensity')
call mma_allocate(SCFTDensity,lTriDens,Label='SCFTDensity')
call mma_allocate(STMat,lTriDens,Label='STMat')
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the Variational MP2 Density and the HF density

call Get_D1ao_Var(MP2TTotDensity,lTriDens)
call Get_dArray_chk('D1ao',SCFTDensity,lTriDens)
!                                                                      *
!***********************************************************************
!                                                                      *
! Get the overlap matrix

iSymlbl = 1
iOpt = ibset(ibset(0,sNoOri),sNoNuc)
Label = 'Mltpl  0'
iComp = 1
call RdOne(irc,iOpt,Label,iComp,STmat,iSymlbl)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the differential MP2 density
MP2TDensity(:) = Two*(MP2TTotDensity(:)-SCFTDensity(:))
!                                                                      *
!***********************************************************************
!                                                                      *
! Modified for triangular storage to quadratic storage. Some of the
! triangular storage is folded, i.e off diagonal element are
! multiplied with 2.

indx = 0
iOff = 0
do iSym=1,nSym
  do i=1,nBas(iSym)
    do j=1,i-1
      indx = indx+1
      MP2Density(j+nBas(iSym)*(i-1)+iOff) = MP2TDensity(indx)*Half
      MP2Density(i+nBas(iSym)*(j-1)+iOff) = MP2TDensity(indx)*Half
      SCFDensity(j+nBas(iSym)*(i-1)+iOff) = SCFTDensity(indx)*Half
      SCFDensity(i+nBas(iSym)*(j-1)+iOff) = SCFTDensity(indx)*Half
      Smat(j+nBas(iSym)*(i-1)+iOff) = STmat(indx)
      Smat(i+nBas(iSym)*(j-1)+iOff) = STmat(indx)

    end do
    indx = indx+1
    MP2Density(i+nBas(iSym)*(i-1)+iOff) = MP2TDensity(indx)
    SCFDensity(i+nBas(iSym)*(i-1)+iOff) = SCFTDensity(indx)
    Smat(i+nBas(iSym)*(i-1)+iOff) = STmat(indx)

  end do
  iOff = iOff+nBas(iSym)**2
end do

! Deallocate temporary memory

call mma_deallocate(MP2TTotDensity)
call mma_deallocate(MP2TDensity)
call mma_deallocate(SCFTDensity)
call mma_deallocate(STMat)
!                                                                      *
!***********************************************************************
!                                                                      *
! Calculate inverse CMO-matrix as C^-1 = C^T*S
! --------------------------------------------

iOff1 = 1
iOff2 = 1
do iSym=1,nSym
  call dGemm_('T','N',nOrb(iSym),nBas(iSym),nBas(iSym),One,CMO(iOff2),nBas(iSym),Smat(iOff1),nBas(iSym),Zero,CMO_inv(iOff2), &
              nOrb(iSym))

  iOff1 = iOff1+nBas(iSym)**2
  iOff2 = iOff2+nOrb(iSym)*nBas(iSym)
end do

call mma_deallocate(SMat)
!                                                                      *
!***********************************************************************
!                                                                      *
! Calculate occupied and virtual inverse CMO-matrices
! ---------------------------------------------------

k_v = 1
k_o = 1
iOff2 = 0
do iSym=1,nSym
  do i=1,nOrb(iSym)
    do j=1,nBas(iSym)
      if (i > nFro(iSym) .and. (i <= nOccAll(iSym))) then
        CMO_o(k_o) = CMO((i-1)*nBas(iSym)+j+iOff2)
        k_o = k_o+1
      else if (i > nOccAll(iSym)) then
        CMO_v(k_v) = CMO((i-1)*nBas(iSym)+j+iOff2)
        k_v = k_v+1
      end if
    end do
  end do
  iOff2 = iOff2+nOrb(iSym)*nBas(iSym)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Open Cholesky vector files.
! ---------------------------

iTypL = 1
iTypR = 2

do iSym=1,nSym
  call ChoMP2_OpenF(1,iTypL,iSym)
  call ChoMP2_OpenF(1,iTypR,iSym)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Open some temporary files

iSeed = 7
LuXVec = IsFreeUnit(iSeed)
FName = 'TMPV1'
call DaName_MF_WA(LuXVec,Fname)

iSeed = 7
LuYVec = isFreeUnit(iSeed)
FName = 'TMPV2'
call DaName_MF_WA(LuYVec,Fname)

iSeed = 7
LuRVec = isFreeUnit(iSeed)
FName = 'TMPV3'
call DaName_MF_WA(LuRVec,Fname)

LuLVec = isFreeUnit(iSeed)
FName = 'TMPV4'
call DaName_MF_WA(LuLVec,Fname)

iSeed = 7
LuBTmp = isFreeUnit(iSeed)
FName = 'TMPV6'
call DaName_MF_WA(LuBTmp,Fname)
!                                                                      *
!***********************************************************************
!                                                                      *
! Open files for the terms in Eqs. 35, 36, 40, and 41.
! i=1 Coulombic and i=2 Exchange contributions.
! This can be merged into singel 2-center and 3-center
! contributions

do i=1,2

  iSeed = 7
  LuA(i) = isFreeUnit(iSeed)
  write(Fname2,'(A5,I1)') 'AMP2V',i
  call DaName_MF_WA(LuA(i),Fname2)

  iSeed = 7
  LuB(i) = isFreeUnit(iSeed)
  write(Fname2,'(A5,I1)') 'BMP2V',i
  call DaName_MF_WA(LuB(i),Fname2)

end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Max number of vectors in one batch. This is not foolproof, if you
! run the code with too little ram you might get problems
! ------------------------------------------------------------------
!
! This has to be recoded to be dynamic. To be done after the
! symmetry has been implemented in the code.

maxvalue = 10
!                                                                      *
!***********************************************************************
!                                                                      *
nVec = 0
do iSym=1,nSym
  nVec = min(max(NumCho(iSym),nMP2Vec(iSym),nVec),maxvalue)
  if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[1]')
end do
iSym = 1  ! Here we are!

! Allocate memory for L-vectors
! -----------------------------

iVecFF = 1
iVecOF = 2
iVecVF = 3
iVecFO = 4
iVecOO = 5
iVecVO = 6
iVecFV = 7
iVecOV = 8
iVecVV = 9

lCJK = nMoMo(iSym,iVecFF)*nVec
call mma_allocate(CJK,lCJK,Label='CJK')

lCKi = nMoMo(iSym,iVecOF)*nVec
call mma_allocate(CKi,lCKi,Label='CKi')

lCKa = nMoMo(iSym,iVecVF)*nVec
call mma_allocate(CKa,lCKa,Label='CKa')

lCiK = nMoMo(iSYm,iVecFO)*nVec
call mma_allocate(CiK,lCiK,Label='CiK')

lCij = nMoMo(iSym,iVecOO)*nVec
call mma_allocate(Cij,lCij,Label='Cij')

lCia = nMoMo(iSym,iVecVO)*nVec
call mma_allocate(Cia,lCia,Label='Cia')

lCaK = nMoMo(iSym,iVecFV)*nVec
call mma_allocate(CaK,lCaK,Label='CaK')

lCai = nMoMo(iSym,iVecOV)*nVec
call mma_allocate(Cai,lCai,Label='Cai')

lCab = nMoMo(iSym,iVecVV)*nVec
call mma_allocate(Cab,lCab,Label='Cab')

lCpq = nOrb(iSym)*nOrb(iSym)*nVec
call mma_allocate(Cpq,lCpq,Label='Cpq')

! The Cholesky vectors of the MP2 amplitudes,
! see Eq. 26.

lRia = nOcc(iSym)*nVir(iSym)*nVec
call mma_allocate(Ria,lRia,Label='Ria')

lCpn = nOrb(iSym)*nBas(iSym)*nVec
call mma_allocate(Cpn,lCpn,Label='Cpn')

lRin = nOcc(iSym)*nBas(iSym)*nVec
call mma_allocate(Rin,lRin,Label='Rin')

lCmn = nBas(iSym)*nBas(iSym)*nVec
call mma_allocate(Cmn,lCmn,Label='Cmn')

lRmn = nBas(iSym)*nBas(iSym)*nVec
call mma_allocate(Rmn,lRmn,Label='Rmn')

lUkn = nBas(iSym)*nBas(iSym)*nVec
call mma_allocate(Ukn,lUkn,Label='Ukn')

lVkn = nBas(iSym)*nBas(iSym)*nVec
call mma_allocate(Vkn,lVkn,Label='Vkn')

lWJL = NumCho(iSym)*nMP2Vec(iSym)
call mma_allocate(WJL,lWJL,Label='WJL')
WJL(:) = Zero

lWmjKJ = nVec*nVec*nOcc(iSym)*nBas(iSym)
call mma_allocate(WmjKJ,lWmjKJ,Label='WmjKJ')

lB3jl = nBas(iSym)*nOcc(iSym)*nVec
call mma_allocate(B3jl,lB3jl,Label='B3jl')

lB3kl = nBas(iSym)*nBas(iSym)*nVec
call mma_allocate(B3kl,lB3kl,Label='B3kl')
!                                                                      *
!***********************************************************************
!                                                                      *
! Start loop over batches of C_pq^J vectors

do iSym=1,nSym
  do iiJ=1,NumCho(iSym),nVec
    nJ = min(nVec,NumCho(iSym)-(iiJ-1))

    ! Read C_pq^J-vectors from disk
    ! -----------------------------

    lTot = nMoMo(iSym,iVecFF)*nJ
    iAdr = 1+nMoMo(iSym,iVecFF)*(iiJ-1)+iAdrOff(iSym,iVecFF)
    call dDaFile(lUnit_F(iSym,iTypL),iRd,CJK,lTot,iAdr)

    lTot = nMoMo(iSym,iVecOF)*nJ
    iAdr = 1+nMoMo(iSym,iVecOF)*(iiJ-1)+iAdrOff(iSym,iVecOF)
    call dDaFile(lUnit_F(iSym,iTypL),iRd,CKi,lTot,iAdr)

    lTot = nMoMo(iSym,iVecVF)*nJ
    iAdr = 1+nMoMo(iSym,iVecVF)*(iiJ-1)+iAdrOff(iSym,iVecVF)
    call dDaFile(lUnit_F(iSym,iTypL),iRd,CKa,lTot,iAdr)

    lTot = nMoMo(iSym,iVecFO)*nJ
    iAdr = 1+nMoMo(iSym,iVecFO)*(iiJ-1)+iAdrOff(iSym,iVecFO)
    call dDaFile(lUnit_F(iSym,iTypL),iRd,CiK,lTot,iAdr)

    lTot = nMoMo(iSym,iVecOO)*nJ
    iAdr = 1+nMoMo(iSym,iVecOO)*(iiJ-1)+iAdrOff(iSym,iVecOO)
    call dDaFile(lUnit_F(iSym,iTypL),iRd,Cij,lTot,iAdr)

    lTot = nMoMo(iSym,iVecVO)*nJ
    iAdr = 1+nMoMo(iSym,iVecVO)*(iiJ-1)+iAdrOff(iSym,iVecVO)
    call dDaFile(lUnit_F(iSym,iTypL),iRd,Cia,lTot,iAdr)

    lTot = nMoMo(iSym,iVecFV)*nJ
    iAdr = 1+nMoMo(iSym,iVecFV)*(iiJ-1)+iAdrOff(iSym,iVecFV)
    call dDaFile(lUnit_F(iSym,iTypL),iRd,CaK,lTot,iAdr)

    lTot = nMoMo(iSym,iVecOV)*nJ
    iAdr = 1+nMoMo(iSym,iVecOV)*(iiJ-1)+iAdrOff(iSym,iVecOV)
    call dDaFile(lUnit_F(iSym,iTypL),iRd,Cai,lTot,iAdr)

    lTot = nMoMo(iSym,iVecVV)*nJ
    iAdr = 1+nMoMo(iSym,iVecVV)*(iiJ-1)+iAdrOff(iSym,iVecVV)
    call dDaFile(lUnit_F(iSym,iTypL),iRd,Cab,lTot,iAdr)

    ! Put the C_pq^J-vectors together to one large vector
    ! ------------------------------------------------

    iOff3 = 0
    do iJ=1,nJ

      iOffFF = 0
      iOffOF = 0
      iOffFO = 0
      iOffOO = 0
      iOffVF = 0
      iOffFV = 0
      iOffVO = 0
      iOffOV = 0
      iOffVV = 0
      iOffBB = 0
      do jSym=1,nSym
        kSym = ieor(iSym-1,jSym-1)+1
        do i=1,nFro(kSym)
          iOff1 = iOffFF+nMoMo(iSym,iVecFF)*(iJ-1)+(i-1)*nFro(jSym)
          Cpq(iOff3+iOffBB+1:iOff3+iOffBB+nFro(jSym)) = CJK(iOff1+1:iOff1+nFro(jSym))
          iOff3 = iOff3+nFro(jSym)
          iOff1 = iOffOF+nMoMo(iSym,iVecOF)*(iJ-1)+(i-1)*nOcc(jSym)
          Cpq(iOff3+iOffBB+1:iOff3+iOffBB+nOcc(jSym)) = Cki(iOff1+1:iOff1+nOcc(jSym))
          iOff3 = iOff3+nOcc(jSym)
          iOff1 = iOffVF+nMoMo(iSym,iVecVF)*(iJ-1)+(i-1)*nVir(jSym)
          Cpq(iOff3+iOffBB+1:iOff3+iOffBB+nVir(jSym)) = Cka(iOff1+1:iOff1+nVir(jSym))
          iOff3 = iOff3+nVir(jSym)
        end do

        do i=1,nOcc(kSym)
          iOff1 = iOffFO+nMoMo(iSym,iVecFO)*(iJ-1)+(i-1)*nFro(jSym)
          Cpq(iOff3+iOffBB+1:iOff3+iOffBB+nFro(jSym)) = CiK(iOff1+1:iOff1+nFro(jSym))
          iOff3 = iOff3+nFro(jSym)
          iOff1 = iOffOO+nMoMo(iSym,iVecOO)*(iJ-1)+(i-1)*nOcc(jSym)
          Cpq(iOff3+iOffBB+1:iOff3+iOffBB+nOcc(jSym)) = Cij(iOff1+1:iOff1+nOcc(jSym))
          iOff3 = iOff3+nOcc(jSym)
          iOff1 = iOffVO+nMoMo(iSym,iVecVO)*(iJ-1)+(i-1)*nVir(jSym)
          Cpq(iOff3+iOffBB+1:iOff3+iOffBB+nVir(jSym)) = Cia(iOff1+1:iOff1+nVir(jSym))
          iOff3 = iOff3+nVir(jSym)
        end do

        do i=1,nVir(kSym)
          iOff1 = iOffFV+nMoMo(iSym,iVecFV)*(iJ-1)+(i-1)*nFro(jSym)
          Cpq(iOff3+iOffBB+1:iOff3+iOffBB+nFro(jSym)) = CaK(iOff1+1:iOff1+nFro(jSym))
          iOff3 = iOff3+nFro(jSym)
          iOff1 = iOffOV+nMoMo(iSym,iVecOV)*(iJ-1)+(i-1)*nOcc(jSym)
          Cpq(iOff3+iOffBB+1:iOff3+iOffBB+nOcc(jSym)) = Cai(iOff1+1:iOff1+nOcc(jSym))
          iOff3 = iOff3+nOcc(jSym)
          iOff1 = iOffVV+nMoMo(iSym,iVecVV)*(iJ-1)+(i-1)*nVir(jSym)
          Cpq(iOff3+iOffBB+1:iOff3+iOffBB+nVir(jSym)) = Cab(iOff1+1:iOff1+nVir(jSym))
          iOff3 = iOff3+nVir(jSym)
        end do

        iOffFF = iOffFF+nFro(jSym)*nFro(kSym)
        iOffOF = iOffOF+nOcc(jSym)*nFro(kSym)
        iOffFO = iOffFO+nFro(jSym)*nOcc(kSym)
        iOffOO = iOffFO+nOcc(jSym)*nOcc(kSym)
        iOffVF = iOffVF+nVir(jSym)*nFro(kSym)
        iOffFV = iOffFV+nFro(jSym)*nVir(kSym)
        iOffVO = iOffVO+nVir(jSym)*nOcc(kSym)
        iOffOV = iOffOV+nOcc(jSym)*nVir(kSym)
        iOffVV = iOffVV+nVir(jSym)*nVir(kSym)
        iOffBB = iOffBB+nBas(jSym)*nBas(kSym)
      end do
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
      do jSym=1,nSym
        kSym = ieor(iSym-1,jSym-1)+1

        ! Do backtransformations of the Cholesky-vectors to get C_mn.
        ! ----------------------------------------------------------
        !
        ! (C^-1)^T x C_pq^J = C_nq^J

        iOff1 = nLRo(iSym)*(iJ-1)+iOffLRo(iSym,jSym)
        call dGemm_('T','N',nBas(jSym),nOrb(kSym),nOrb(jSym),One,CMO_inv(1+iOffCInv(jSym)),nOrb(jSym),Cpq(1+iOff1),nOrb(jSym), &
                    Zero,Cpn,nBas(jSym))

        ! C_nq^J x  (C^-1) = C_nm^J

        iOff2 = nLRb(iSym)*(iJ-1)+iOffLRb(iSym,jSym)
        call dGemm_('N','N',nBas(jSym),nBas(kSym),nOrb(kSym),One,Cpn,nBas(jSym),CMO_inv(1+iOffCInv(kSym)),nOrb(kSym),Zero, &
                    Cmn(1+iOff2),nBas(jSym))

      end do
      !                                                                *
      !*****************************************************************
      !*****************************************************************
      !                                                                *
      do jSym=1,nSym
        kSym = ieor(iSym-1,jSym-1)+1

        ! C_nm^J x D(MP2)_mk = U_nk^J, Eq. (43)

        iOff = nLRb(iSym)*(iJ-1)+iOffLRb(iSym,jSym)
        iOff0 = iOffD(kSym)
        call dGemm_('N','N',nBas(jSym),nBas(kSym),nBas(kSym),One,Cmn(1+iOff),nBas(jSym),MP2Density(1+iOff0),nBas(kSym),Zero, &
                    Ukn(1+iOff),nBas(jSym))

        ! D(HF)_kn x C_nm^J = V_km^J, Eq. (42)

        iOff0 = iOffD(jSym)
        call dGemm_('N','N',nBas(jSym),nBas(kSym),nBas(jSym),One,SCFDensity(1+iOff0),nBas(jSym),Cmn(1+iOff),nBas(jSym),Zero, &
                    Vkn(1+iOff),nBas(jSym))

      end do
    end do ! iJ
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Write C_nm^J, U_nk^J, and V_km^J to disk.

    lTot = nLRb(iSym)*nJ

    iAdr = iAdrB(iSym)+nLRb(iSym)*(iiJ-1)
    call dDaFile(LuLVec,iWr,Cmn,lTot,iAdr)
    iAdr = iAdrB(iSym)+nLRb(iSym)*(iiJ-1)
    call dDaFile(LuXVec,iWr,Ukn,lTot,iAdr)
    iAdr = iAdrB(iSym)+nLRb(iSym)*(iiJ-1)
    call dDaFile(LuYVec,iWr,Vkn,lTot,iAdr)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    do lSym=1,nSym
      do iiK=1,nMP2Vec(lSym),nVec
        nK = min(nVec,nMP2Vec(lSym)-(iiK-1))

        ! Read the R-Vectors

        lTot = nMoMo(lSym,iVecOV)*nK
        iAdr = nMoMo(lSym,iVecOV)*(iiK-1)+1
        call dDaFile(lUnit_F(lSym,iTypR),iRd,Ria,lTot,iAdr)

        ! Do backtransformations of the Amplitude-vectors to get Rmnx.
        ! ------------------------------------------------------------
        ! See Eq. (39).

        iOff_Ria = 0
        iOff_Rin = 0
        iOff_Rmn = 0
        do iK=1,nK

          do jSym=1,nSym
            kSym = ieor(lSym-1,jSym-1)+1

            ! C_na x R_ai^K = R_ni^K  (Temporary storage)

            iOff1 = iOff_Ria
            iOff_Ria = iOff_Ria+nVir(jSym)*nOcc(kSym)
            iOff2 = iOff_Rin
            iOff_Rin = iOff_Rin+nBas(jSym)*nOcc(kSym)
            call dGemm_('N','N',nBas(jSym),nOcc(kSym),nVir(jSym),One,CMO_v,nBas(jSym),Ria(1+iOff1),nVir(jSym),Zero,Rin(1+iOff2), &
                        nBas(jSym))

            ! R_ni^K x C_mi^T = R_nm^K

            iOff3 = iOff_Rmn
            iOff_Rmn = iOff_Rmn+nBas(jSym)*nBas(kSym)
            call dGemm_('N','T',nBas(jSym),nBas(kSym),nOcc(kSym),One,Rin(1+iOff2),nBas(jSym),CMO_o,nBas(kSym),Zero,Rmn(1+iOff3), &
                        nBas(jSym))

          end do ! jSym
        end do   ! iK

        ! Write  R_mn^K to disk

        lTot = nLRb(iSym)*nK
        iAdr = iAdrR(iSym)+nLRb(iSym)*(iiK-1)
        call dDaFile(LuRVec,iWr,Rmn,lTot,iAdr)
        !                                                              *
        !***************************************************************
        !                                                              *
        ! Sum_mn (R_mn^K)^T x C_mn^J = W_KJ  (Eq. 38)

        if (iSym == lSym) then
          iOffZ = iOff_WJL(iSym)+nMP2Vec(iSym)*(iiJ-1)+iiK-1
          call dGemm_('T','N',nK,nJ,nLRb(iSym),One,Rmn,nLRb(iSym),Cmn,nLRb(iSym),Zero,WJL(1+iOffZ),nMP2Vec(iSym))
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        do iJ=1,nJ
          iOff_Rin = 0
          do iK=1,nK

            do jSym=1,nSym
              kSym = ieor(iSym-1,jSym-1)+1
              mSym = ieor(lSym-1,kSym-1)+1

              iOffL = nLRb(iSym)*(iJ-1)+iOffLRb(iSym,jSym)
              iOffR = iOff_Rin
              iOff_Rin = iOff_Rin+nBas(kSym)*nOcc(mSym)

              ! C_mn^J x R_ni^K = W_mi^JK, see Eq. (44)

              call dGemm_('N','N',nBas(jSym),nOcc(mSym),nBas(kSym),One,Cmn(1+iOffL),nBas(jSym),Rin(1+iOffR),nBas(kSym),Zero,WmjKJ, &
                          nBas(jSym))

              Fac = One
              if ((iK == 1) .and. (iiK == 1)) Fac = Zero

              ! R_nm^K x W_mi^JK, last two summation in Eqs. 40 and 41

              mSym2 = ieor(lSym-1,jSym-1)+1
              iOffB = nB3(iSym)*(iJ-1)+iOffB3(iSym,mSym2)
              iOffR = nLRb(lSym)*(iK-1)+iOffLRb(lSym,mSym2)
              call dGemm_('N','N',nBas(mSym2),nOcc(mSym),nBas(jSym),One,Rmn(1+iOffR),nBas(mSym2),WmjKJ,nBas(jSym),Fac, &
                          B3jl(1+iOffB),nBas(mSym2))

            end do ! jSym

          end do ! iK
        end do   ! iJ

      end do ! iiK
    end do ! lSym

    do iJ=1,nJ

      do jSym=1,nSym
        kSym = ieor(iSym-1,jSym-1)+1

        iOffB1 = nB3(iSym)*(iJ-1)+iOffB3(iSym,jSym)
        iOffB2 = nLRb(iSym)*(iJ-1)+iOffLRb(iSym,jSym)
        iOff = iOffCMOo(kSym)

        ! Complete the 3rd RHS term in Eq. 40

        call dGemm_('N','T',nBas(jSym),nBas(kSym),nOcc(kSym),-Eight,B3jl(1+iOffB1),nBas(jSym),CMO_o(1+iOff),nBas(kSym),Zero, &
                    B3kl(1+iOffB2),nBas(jSym))

      end do ! jSym
    end do   ! iJ

    ! Write matrix to file. Note that it has the same structure as
    ! the R and L matrices.

    lTot = nLRb(iSym)*nJ
    iAdr = iAdrB(iSym)+nLRb(iSym)*(iiJ-1)
    call dDaFile(LuBTmp,iWr,B3kl,lTot,iAdr)
    !                                                                  *
    !*******************************************************************
    !*******************************************************************
    !                                                                  *
  end do ! iiJ
end do ! iSym

call mma_deallocate(B3jl)
call mma_deallocate(Rin)
call mma_deallocate(Cpn)
call mma_deallocate(Ria)

call mma_deallocate(Cpq)
call mma_deallocate(Cab)
call mma_deallocate(Cai)
call mma_deallocate(CaK)
call mma_deallocate(Cia)
call mma_deallocate(Cij)
call mma_deallocate(CiK)
call mma_deallocate(CKa)
call mma_deallocate(CKi)
call mma_deallocate(CJK)

call mma_deallocate(SCFDensity)

iSym = 1

lB1kl = nBas(iSym)*nBas(iSym)*nVec
call mma_allocate(B1kl,lB1kl,Label='B1kl')

lB3kl_s = nBas(iSym)*nBas(iSym)*nVec
call mma_allocate(B3kl_s,lB3kl_s,Label='B3kl_s')

lA1 = NumCho(iSym)*NumCho(iSym)
call mma_allocate(A1,lA1,Label='A1')
A1(:) = Zero

lA2 = NumCho(iSym)*NumCho(iSym)
call mma_allocate(A2,lA2,Label='A2')
A2(:) = Zero

lB2kl = nBas(iSym)*nBas(iSym)*nVec
call mma_allocate(B2kl,lB2kl,Label='B2kl')

!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Start loop over batches of J

iOff_A = 0
do iSym=1,nSym
  do iiJ=1,NumCho(iSym),nVec
    nJ = min(nVec,NumCho(iSym)-(iiJ-1))

    ! Read V_km^J

    lTot = nLRb(iSym)*nJ
    iAdr = iAdrB(iSym)+nLRb(iSym)*(iiJ-1)
    call dDaFile(LuYVec,iRd,Vkn,lTot,iAdr)

    do iiK=1,NumCho(iSym),nVec
      nK = min(nVec,NumCho(iSym)-(iiK-1))

      ! Read U_km_K

      lTot = nLRb(iSym)*nK
      iAdr = iAdrB(iSym)+nLRb(iSym)*(iiK-1)
      call dDaFile(LuXVec,iRd,Ukn,lTot,iAdr)

      ! U_km^K x V_km^J, 1st term RHS eq. 41

      iOffA = iiK-1+(iiJ-1)*NumCho(iSym)+iOff_A
      Fact = One
      call dGemm_('T','N',nK,nJ,nLRb(iSym),Fact,Ukn,nLRb(iSym),Vkn,nLRb(iSym),Zero,A1(1+iOffA),NumCho(iSym))

    end do
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    do iiK=1,nMP2Vec(iSym),nVec
      nK = min(nVec,nMP2Vec(iSym)-(iiK-1))

      ! Read R_mn^K

      lTot = nLRb(iSym)*nK
      iAdr = iAdrR(iSym)+nLRb(iSym)*(iiK-1)
      call dDaFile(LuRVec,iRd,Rmn,lTot,iAdr)

      ! R_mn_K x W_JK, 2nd RHS term Eq. 35

      Fac = One
      if (iiK == 1) Fac = Zero
      iOffZ = iOff_WJL(iSym)+iiK-1+(iiJ-1)*nMp2Vec(iSym)
      call dGemm_('N','N',nLRb(iSym),nJ,nK,-Eight,Rmn,nLRb(iSym),WJL(1+iOffZ),nMP2Vec(iSym),Fac,B2kl,nLRb(iSym))
    end do

    ! Write to disk

    lTot = nLRb(iSym)*nJ
    iAdr = iAdrB(iSym)+nLRb(iSym)*(iiJ-1)
    call dDaFile(LuB(2),iWr,B2kl,lTot,iAdr)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read 3rd RHS term in Eq. 40

    lTot = nLRb(iSym)*nJ
    iAdr = iAdrB(iSym)+nLRb(iSym)*(iiJ-1)
    call dDaFile(LuBTmp,iRd,B3kl,lTot,iAdr)

    ! Symmetrize

    do iJ=1,nJ
      iOffL = nLRb(iSym)*(iJ-1)
      do jSym=1,nSym
        kSym = ieor(iSym-1,jSym-1)+1

        do k=1,nBas(jSym)
          do l=1,nBas(kSym)
            kl = k+nBas(jSym)*(l-1)+iOffLRb(iSym,jSym)
            kl_s = kl
            lk = l+nBas(kSym)*(k-1)+iOffLRb(iSym,kSym)
            B3kl_s(1+iOffL+kl_s-1) = (B3kl(1+iOffL+kl-1)+B3kl(1+iOffL+lk-1))*Half
          end do
        end do

      end do ! jSym
    end do

    ! Write the symmetrized 3rd term to disk

    lTot = nLRb(iSym)*nJ
    iAdr = iAdrB(iSym)+nLRb(iSym)*(iiJ-1)
    call dDaFile(LuBTmp,iWr,B3kl_s,lTot,iAdr)
    !                                                                  *
    !*******************************************************************
    !                                                                  *

    do iJ=1,nJ
      iOff = nLRb(iSym)*(iJ-1)

      ! V_kn^J x D(MP2)_kn, 2nd RHS term Eq. 40

      do jSym=1,nSym
        kSym = ieor(iSym-1,jSym-1)+1

        iOff1 = iOff+iOffLRb(iSym,jSym)
        iOff2 = iOffD(kSym)
        call dGemm_('N','N',nBas(jSym),nBas(kSym),nBas(kSym),One,Vkn(1+iOff1),nBas(jSym),MP2Density(1+iOff2),nBas(kSym),Zero, &
                    B1kl(1+iOff1),nBas(jSym))
      end do
    end do

    ! Compound 2nd and 3rd RHS term in Eq. 40.

    B1kl(1:nLRb(iSym)*nJ) = B1kl(1:nLRb(iSym)*nJ)+B3kl(1:nLRb(iSym)*nJ)

    ! Write compounded terms to disk

    lTot = nLRb(iSym)*nJ
    iAdr = iAdrB(iSym)+nLRb(iSym)*(iiJ-1)
    call dDaFile(LuB(1),iWr,B1kl,lTot,iAdr)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
  end do ! iiJ
  iOff_A = iOff_A+NumCho(iSym)**2
end do ! iSym
!
call mma_deallocate(MP2Density)
iSym = 1
!                                                                      *
!***********************************************************************
!                                                                      *
! Add nonseparable coulombic terms to A matrix
! --------------------------------------------
!
! -4 W_MJ x W_MK    (don't ask me why the code say 8!)
!
! Second term RHS Eq. 36, note the different order of the indices.

iOff_A2 = 0
do iSym=1,nSym
  iOff1 = iOff_WJL(iSym)
  Fact = -Eight
  call dGemm_('T','N',NumCho(iSym),NumCho(iSym),nMP2Vec(iSym),Fact,WJL(1+iOff1),nMP2Vec(iSym),WJL(1+iOff1),nMP2Vec(iSym),Zero, &
              A2(1+iOff_A2),NumCho(iSym))

  iOff_A2 = iOff_A2+NumCho(iSym)**2
end do

iSym = 1
!                                                                      *
!***********************************************************************
!                                                                      *
! Start loop over batches of L

! Nonseparable exchange, third loop, transformation and

iOff_A = 0
do iSym=1,nSym
  do iiJ=1,NumCho(iSym),nVec
    nJ = min(nVec,NumCho(iSym)-(iiJ-1))

    lTot = nLRb(iSym)*nJ
    iAdr = iAdrB(iSym)+nlRb(iSym)*(iiJ-1)
    call dDaFile(LuBTmp,iRd,B3kl_s,lTot,iAdr)

    do iiK=1,NumCho(iSym),nVec
      nK = min(nVec,NumCho(iSym)-(iiK-1))

      lTot = nLRb(iSym)*nK
      iAdr = iAdrB(iSym)+nLRb(iSym)*(iiK-1)
      call dDaFile(LuLVec,iRd,Cmn,lTot,iAdr)

      ! B_nm^L x C_nm^K
      !
      ! This is the second term of the RHS of Eq. (41)

      iOffA = iiJ-1+(iiK-1)*NumCho(iSym)+iOff_A
      Fact = One
      call dGemm_('T','N',nJ,nK,nLRb(iSym),Fact,B3kl_s,nLRb(iSym),Cmn,nLRb(iSym),One,A1(1+iOffA),NumCho(iSym))

    end do

  end do
  iOff_A = iOff_A+NumCho(iSym)**2
end do ! iSym
!                                                                      *
!***********************************************************************
!                                                                      *
! Write the Coulomic and Exchange contributions to the 2-center
! integrals to disk. These terms could be merged to just one.

iAdr1 = 1
iAdr2 = 1
iOff = 0
do iSym=1,nSym
  lTot = NumCho(iSym)*NumCho(iSym)
  call dDaFile(LuA(1),iWr,A1(1+iOff),lTot,iAdr1)
  call dDaFile(LuA(2),iWr,A2(1+iOff),lTot,iAdr2)
  iOff = iOff+lTot
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Close some files

call DaClos(LuXVec)
call DaClos(LuYVec)
call DaClos(LuRVec)
call DaClos(LuLVec)
call DaClos(LuBTmp)
do i=1,2
  call DaClos(LuA(i))
  call DaClos(LuB(i))
end do

iClos = 2
do iSym=1,nSym
  call ChoMP2_OpenF(iClos,iTypR,iSym)
  call ChoMP2_OpenF(iClos,iTypL,iSym)
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate memory

call mma_deallocate(Cmn)
call mma_deallocate(Rmn)
call mma_deallocate(Ukn)
call mma_deallocate(Vkn)

call mma_deallocate(B1kl)
call mma_deallocate(A1)
call mma_deallocate(B2kl)
call mma_deallocate(A2)
call mma_deallocate(B3kl)
call mma_deallocate(B3kl_s)
call mma_deallocate(WmjKJ)
call mma_deallocate(WJL)
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(CMO_v)
call mma_deallocate(CMO_o)
call mma_deallocate(CMO_Inv)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine ChoMP2g_GradSetup

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETSTOR(VCSTOR)
C
C     Purpose: get total vector storage (in words).
C
#include "implicit.fh"
      DIMENSION VCSTOR(*)
#include "cholesky.fh"

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_GETSTOR')

      DO ISYM = 1,NSYM
         IF (NUMCHO(ISYM) .GT. MAXVEC) THEN
            WRITE(LUPRI,*) SECNAM,': too many Cholesky vectors ',
     &                     'in symmetry ',ISYM,': ',NUMCHO(ISYM)
            CALL CHO_QUIT('Error in '//SECNAM,103)
            VCSTOR(ISYM) = 0.0D0
         ELSE IF (NUMCHO(ISYM) .LT. 0) THEN
            WRITE(LUPRI,*) SECNAM,': negative #Cholesky vectors ',
     &                     'in symmetry ',ISYM,': ',NUMCHO(ISYM)
            CALL CHO_QUIT('Error in '//SECNAM,103)
            VCSTOR(ISYM) = 0.0D0
         ELSE
            CALL CHO_GETSTOR_S(VCSTOR(ISYM),ISYM)
         END IF
      END DO

      END
      SUBROUTINE CHO_GETSTOR_S(VCSTOR,ISYM)
C
C     Purpose: get total vector storage (in words), symmetry ISYM.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      PARAMETER (N2 = INFVEC_N2)

      INFVEC(I,J,K)=IWORK(ip_INFVEC-1+MAXVEC*N2*(K-1)+MAXVEC*(J-1)+I)
      NDIMRS(I,J)=IWORK(ip_NDIMRS-1+NSYM*(J-1)+I)

      IF (NUMCHO(ISYM) .LT. 1) THEN
         VCSTOR = 0.0D0
      ELSE
         IF (l_NDIMRS .LT. 1) THEN
            IRED = INFVEC(NUMCHO(ISYM),2,ISYM)
            JRED = 3
            KOFF1 = ip_NNBSTRSH + NSYM*NNSHL*(JRED - 1)
            KOFF2 = ip_INDRED   + MMBSTRT*(JRED - 1)
            CALL CHO_GETRED(IWORK(ip_INFRED),IWORK(KOFF1),
     &                      IWORK(KOFF2),IWORK(ip_INDRSH),
     &                      IWORK(ip_iSP2F),
     &                      MAXRED,NSYM,NNSHL,MMBSTRT,IRED,.FALSE.)
            CALL CHO_SETREDIND(IWORK(ip_IIBSTRSH),IWORK(ip_NNBSTRSH),
     &                         NSYM,NNSHL,JRED)
            VCSTOR = DBLE(INFVEC(NUMCHO(ISYM),4,ISYM))
     &             + DBLE(NNBSTR(ISYM,JRED))
         ELSE
            IRED = INFVEC(NUMCHO(ISYM),2,ISYM)
            VCSTOR = DBLE(INFVEC(NUMCHO(ISYM),4,ISYM))
     &             + DBLE(NDIMRS(ISYM,IRED))
         END IF
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_X_RSSwap
!
!> @brief
!>   Swap reduced set index arrays
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Swap index arrays at locations \p iRS (``1``,``2``,``3``) and \p jRS (``1``,``2``,``3``).
!> If \p iRS and/or \p jRS are out of bounds, \p irc = ``1`` on exit and nothing
!> has been done!
!>
!> @warning
!> No special action is taken to redefine the \c IndRed array for first reduced set.
!>
!> @note
!> The CHolesky module must have been initialized.
!>
!> @param[out] irc return code
!> @param[in]  iRS location of reduced set
!> @param[in]  jRS location of reduced set
!***********************************************************************

subroutine Cho_X_RSSwap(irc,iRS,jRS)

use Cholesky, only: iiBstR, iiBstRSh, IndRed, nnBstR, nnBstRSh, nnBstRT, nnShl, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iRS, jRS
integer(kind=iwp) :: N, iTemp

if ((iRS < 1) .or. (iRS > 3) .or. (jRS < 1) .or. (jRS > 3)) then
  irc = 1
else
  if (iRS /= jRS) then
    N = nSym*nnShl
    call iSwap(N,iiBstRSh(:,:,iRS),1,iiBstRSh(:,:,jRS),1)
    call iSwap(N,nnBstRSh(:,:,iRS),1,nnBstRSh(:,:,jRS),1)
    call iSwap(nSym,iiBstR(1,iRS),1,iiBstR(1,jRS),1)
    call iSwap(nSym,nnBstR(1,iRS),1,nnBstR(1,jRS),1)
    call iSwap(nnBstRT(1),IndRed(:,iRs),1,IndRed(:,jRs),1)
    iTemp = nnBstRT(iRS)
    nnBstRT(iRS) = nnBstRT(jRS)
    nnBstRT(jRS) = iTemp
  end if
  irc = 0
end if

end subroutine Cho_X_RSSwap

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CutOff_Error(l,lMax,rMP,xrMP,nij,EC,C_o_C,nElem,Scratch_New,Scratch_Org,nAtoms,iPrint,Cut_Off_Error)

use Real_Spherical, only: ipSph, RSph
use Index_Functions, only: nTri3_Elem1
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8, u6

implicit none
integer(kind=iwp), intent(in) :: l, lMax, nij, nElem, nAtoms, iPrint
real(kind=wp), intent(in) :: rMP(nij,nElem), EC(3,nij), C_o_C(3)
real(kind=wp), intent(inout) :: xrMP(nij,nElem)
real(kind=wp), intent(out) :: Scratch_New(nij*(2+lMax+1)), Scratch_Org(nij*(2+lMax+1)), Cut_Off_Error
integer(kind=iwp) :: iAtom, iElem, iEnd, ij, iOff, iStrt, jAtom, k, kDim, m
real(kind=wp) :: Error, Estimated, Original, Percent, rms, rSum
character(len=80) :: Banner_Line
real(kind=r8) :: DDot_

iEnd = nTri3_Elem1(lMax)
iStrt = nTri3_Elem1(l)+1
ij = 0
do iAtom=1,nAtoms
  do jAtom=1,iAtom
    ij = ij+1
    call ReExpand(xrMP,nij,nElem,C_o_C,EC(1,ij),ij,lMax)

    ! Set all elements corresponding to l+1 = 0
    do iElem=iStrt,iEnd
      xrMP(ij,iElem) = Zero
    end do

    call ReExpand(xrMP,nij,nElem,EC(1,ij),C_o_C,ij,lMax)
  end do
end do

if (iPrint >= 1) then
  write(u6,*)
  write(Banner_Line,'(A,I2)') 'Errors introduced by zeroing multipole moments greater than l = ',l
  call Banner(Banner_Line,1,80)
end if
rSum = Zero
iElem = nTri3_Elem1(l)+1
do k=l+1,lMax
  if (iPrint >= 1) then
    write(u6,*)
    write(u6,'(A,I1)') 'l=',k
    write(u6,*)
    write(u6,*) ' m     Original       New            Error            Percent'
    write(u6,*)
  end if

  kDim = (k+1)*(k+2)/2
  call DGEMM_('N','N',nij,2*k+1,kDim,One,xrMP(1,iElem),nij,RSph(ipSph(k)),kDim,Zero,Scratch_New,nij)
  call DGEMM_('N','N',nij,2*k+1,kDim,One,rMP(1,iElem),nij,RSph(ipSph(k)),kDim,Zero,Scratch_Org,nij)

  iOff = 1
  rms = Zero
  do m=-k,k
    Original = DDot_(nij,[One],0,Scratch_Org(iOff),1)
    Estimated = DDot_(nij,[One],0,Scratch_New(iOff),1)
    Error = Original-Estimated

    rSum = rSum+Error*Error
    rms = rms+Error*Error
    Percent = Zero
    if (abs(Error) < 1.0e-8_wp) then
      Percent = Zero
    else if (abs(Original) > 1.0e-13_wp) then
      Percent = abs(Error/Original)*100.0_wp
    else
      Percent = -huge(Percent)
    end if

    if (iPrint >= 1) then
      if (Percent >= Zero) then
        write(u6,'(I3,3F16.8,4X,F6.2)') m,Original,Estimated,Error,Percent
      else
        write(u6,'(I3,3F16.8,4X,A)') m,Original,Estimated,Error,'Infinite'
      end if
    end if

    iOff = iOff+nij
  end do
  if (iPrint >= 1) then
    rms = sqrt(rms/real(2*k+1,kind=wp))
    write(u6,*)
    write(u6,'(A,F16.8)') 'Root mean square = ',rms
  end if

  iElem = iElem+(k+1)*(k+2)/2
end do

Cut_Off_Error = rSum

return

end subroutine CutOff_Error

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DIAFCK(NO,FOCK,IOSTA,IOEND,TSCT,NB,CMO1SCT,CMO2SCT)
! Use orbital rotations on a subblock of active orbitals
! in order to diagonalize that block of a Fock matrix, and
! in addition apply a counterrotation to the CI array that
! keeps the wave function invariant to the rotation.

! FOCK is the Fock matrix of this symmetry, in square form.
! to be tranformed. TSCT is a corresponding section of the
! transformation matrix, CMO1SCT is a section of the CMO array (in)
! and CMO2SCT the same, transformed.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NO, IOSTA, IOEND, NB
real(kind=wp), intent(inout) :: FOCK(NO,NO)
real(kind=wp), intent(out) :: TSCT(IOSTA:IOEND,IOSTA:IOEND), CMO2SCT(NB,*)
real(kind=wp), intent(in) :: CMO1SCT(NB,*)
integer(kind=iwp) :: I, IJ, J, JMX, K, NSCT
real(kind=wp) :: SWAP, V, VMX
real(kind=wp), allocatable :: TMP(:)

! Size of orbital section to process:
NSCT = IOEND+1-IOSTA
! Local scratch area:
call mma_allocate(TMP,NO*NSCT,Label='TMP')
! Put part of FOCK to be diagonalized into triangular scratch area:
IJ = 0
do I=IOSTA,IOEND
  TMP(IJ+1:IJ+I-IOSTA+1) = FOCK(I,IOSTA:I)
  IJ = IJ+I-IOSTA+1
end do
! Put unit matrix into TSCT:
call unitmat(TSCT,NSCT)
! Diagonalize, and order for best submatrix condition:
call Jacob(TMP,TSCT,NSCT,NSCT)

do I=IOSTA,IOEND
  JMX = I
  VMX = abs(TSCT(I,JMX))

  do J=I+1,IOEND
    V = abs(TSCT(I,J))
    if (V > VMX) then
      JMX = J
      VMX = V
    end if
  end do

  if (JMX > I) then
    do K=IOSTA,IOEND
      SWAP = TSCT(K,I)
      TSCT(K,I) = TSCT(K,JMX)
      TSCT(K,JMX) = SWAP
    end do
  end if

  if (TSCT(I,I) < Zero) TSCT(IOSTA:IOEND,I) = -TSCT(IOSTA:IOEND,I)
end do

! Transform the Fock matrix:
call DGEMM_('N','N',NO,NSCT,NSCT,One,FOCK(1,IOSTA),NO,TSCT,NSCT,Zero,TMP,NO)
FOCK(:,IOSTA:IOEND) = reshape(TMP(:),[NO,NSCT])

do I=IOSTA,IOEND
  FOCK(I,1:NO) = TMP(NO*(I-IOSTA)+1:NO*(I-IOSTA+1))
end do

call DGEMM_('T','N',NSCT,NSCT,NSCT,One,TSCT,NSCT,TMP(IOSTA),NO,Zero,FOCK(IOSTA,IOSTA),NO)

! Then transform the CMO coeffs:
call DGEMM_('N','N',NB,NSCT,NSCT,One,CMO1SCT,NB,TSCT,NSCT,Zero,CMO2SCT,NB)

call mma_deallocate(TMP)

end subroutine DIAFCK

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE DSQ2(C,S,MUL,INDEX,JSY,NDIAG,INUM,IRC3,LSYM,
     *NVIRT,SQ2)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(*),S(*),MUL(8,8),INDEX(*),JSY(*),NDIAG(*)
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CRL   JSYM(L)=IAND(ISHFT(JSY((L+19)/20),-3*((L+19)/20*20-L)),7)+1
CPAM96      JSYM(L)=UNPACK(JSY((L+9)/10),3*MOD(L-1,10)+1,3)+1
      JSYM(L)=JSUNP_CPF(JSY,L)
      DO 10 I=1,INUM
      II1=IRC3+I
      NS1=JSYM(II1)
      NS1L=MUL(NS1,LSYM)
      IF(NS1L.NE.1)GO TO 10
      NA=INDEX(II1)
      DO 20 MA=1,NVIRT
      C(NA+NDIAG(MA))=C(NA+NDIAG(MA))/SQ2
      S(NA+NDIAG(MA))=SQ2*S(NA+NDIAG(MA))
20    CONTINUE
10    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine pvbcopy_cvb(cfrom,cto)

use casvb_global, only: iapr, icnt_ci, iform_ci, ixapr, ndet
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: cfrom(0:ndet)
real(kind=wp), intent(inout) :: cto(0:ndet)
integer(kind=iwp) :: icfrom, icto
real(kind=wp) :: dum

icfrom = nint(cfrom(0))
icto = nint(cto(0))
if ((iform_ci(icfrom) /= 0) .or. (iform_ci(icto) /= 0)) then
  write(u6,*) ' Unsupported format in PVBCOPY'
  call abend_cvb()
end if
call pvbcopy2_cvb(cfrom(1:),cto(1:),iapr,ixapr,dum,0)
icnt_ci(icto) = 0

return

end subroutine pvbcopy_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Roland Lindh                                     *
!***********************************************************************

subroutine ReacQ(V_X,nX,V_Q,nQ)
!***********************************************************************
!                                                                      *
!     Objective: Transform the "reaction vector" from cartesian        *
!                coordinates to Internal.                              *
!                                                                      *
!     Roland Lindh, Dept. of Theor. Chem., Lund University, Sweden     *
!     2009                                                             *
!***********************************************************************

use Slapaf_Info, only: BMx, Degen
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nX, nQ
real(kind=wp), intent(in) :: V_X(nX)
real(kind=wp), intent(out) :: V_Q(nQ)

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('BMx',' ',BMx,nX,nQ)
call RecPrt('V_X',' ',V_X,nX,1)
#endif

call Eq_Solver('T',nX,nQ,1,BMx,.false.,Degen,V_X,V_Q)

#ifdef _DEBUGPRINT_
call RecPrt('V_Q',' ',V_Q,nQ,1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine ReacQ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2007, Roland Lindh                                *
!               2009, Francesco Aquilante                              *
!***********************************************************************

subroutine PGet1_CD2(PAO,ijkl,nPAO,iCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp,ExFac,CoulFac,PMax,V_k,U_k,mV_k,Z_p_K,nnP1)
!***********************************************************************
!  Object: to assemble the 2nd order density matrix of a SCF wave      *
!          function from the 1st order density.                        *
!                                                                      *
!          The indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!             January '92.                                             *
!                                                                      *
!             Modified for Cholesky 1-center gradients May 2007 by     *
!             R. Lindh                                                 *
!                                                                      *
!             Modified for RI-HF/CAS, Dec 2009 (F. Aquilante)          *
!***********************************************************************

use Index_Functions, only: iTri
use pso_stuff, only: ij2K, iOff_ij2K
use SOAO_Info, only: iAOtSO
use RI_glob, only: CijK, iAdrCVec, iMP2prpt, LuCVector, nAuxVe, nIJ1, tavec
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: ijkl, nPAO, iCmp(4), iAO(4), iAOst(4), iBas, jBas, kBas, lBas, kOp(4), mV_k, nnP1
real(kind=wp), intent(out) :: PAO(ijkl,nPAO), PMax
real(kind=wp), intent(in) :: ExFac, CoulFac, V_k(mV_k), U_K(mV_K), Z_p_K(nnP1,mV_K)
integer(kind=iwp) :: i1, i2, i3, i4, iAdrJ, iAdrL, iAOi, iE, ijVec, Indij, Indkl, iPAO, iS, iSO, iSOi, iSym, jAOj, jp, jSO, jSOj, &
                     jSym, kAOk, klVec, kSO, kSOk, lAOl, lSO, lSOl, lSym, nijkl, NumIK
real(kind=wp) :: Cpu, Cpu1, Cpu2, Fac, Fac_ij, Fac_kl, temp, tempJ_mp2, tempK, tempK_mp2, Wall, Wall1, Wall2
real(kind=wp), pointer :: CiKj(:,:), V2(:)
real(kind=r8), external :: dDot_

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('PGet1_CD2: V_k',' ',V_k,1,mV_k)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Quadruple loop over elements of the basis functions angular description.
! Observe that we will walk through the memory in PAO in a sequential way.
!
!Fac = Quart

call CWTime(Cpu1,Wall1)

Fac = One
PMax = Zero
iPAO = 0

iSym = 1
jSym = 1
lSym = 1
iSO = 1

if (ExFac == Zero) then

  do i1=1,iCmp(1)
    do i2=1,iCmp(2)
      do i3=1,iCmp(3)
        do i4=1,iCmp(4)

          ! Unfold the way the eight indicies have been reordered.
          iSO = iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
          jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
          kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
          lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

          iPAO = iPAO+1
          nijkl = 0

          do lAOl=0,lBas-1
            lSOl = lSO+lAOl
            do kAOk=0,kBas-1
              kSOk = kSO+kAOk
              do jAOj=0,jBas-1
                jSOj = jSO+jAOj
                do iAOi=0,iBas-1
                  iSOi = iSO+iAOi
                  nijkl = nijkl+1

                  ! V_k(ij)*V_k(kl)

                  Indij = iTri(iSOi,jSOj)
                  Indkl = iTri(kSOk,lSOl)
                  temp = V_k(Indij)*V_k(Indkl)*CoulFac
                  ! Active space contribution (any factor?)
                  ijVec = ij2K(iOff_ij2K(1)+Indij)
                  klVec = ij2K(iOff_ij2K(1)+Indkl)
                  if ((ijVec /= 0) .and. (klVec /= 0)) then
                    do jp=1,nnP1
                      temp = temp+Z_p_K(jp,ijVec)*Z_p_K(jp,klVec)
                    end do
                  end if

                  PMax = max(PMax,abs(temp))
                  PAO(nijkl,iPAO) = Fac*temp

                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end do
else if (iMP2prpt /= 2) then
  NumIK = nIJ1(iSym,lSym,iSO)
  if (NumIK == 0) return

  iS = 1
  iE = NumIK*2
  CiKj(1:NumIK,1:2) => CijK(iS:iE)

  do i1=1,iCmp(1)
    do i2=1,iCmp(2)
      iSO = iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
      jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)

      do i3=1,iCmp(3)
        do i4=1,iCmp(4)
          kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
          lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

          iPAO = iPAO+1
          nijkl = 0

          do lAOl=0,lBas-1
            lSOl = lSO+lAOl
            do kAOk=0,kBas-1
              kSOk = kSO+kAOk
              Indkl = iTri(kSOk,lSOl)
              klVec = ij2K(iOff_ij2K(1)+Indkl)

              if (klvec /= 0) then
                iAdrL = NumIK*(klVec-1)+iAdrCVec(jSym,iSym,iSO)
                call dDaFile(LuCVector(jSym,iSO),2,CiKj(:,1),NumIK,iAdrL)
              end if

              do jAOj=0,jBas-1
                jSOj = jSO+jAOj
                do iAOi=0,iBas-1
                  iSOi = iSO+iAOi
                  nijkl = nijkl+1

                  Indij = iTri(iSOi,jSOj)
                  ijVec = ij2K(iOff_ij2K(1)+Indij)

                  if ((ijVec /= klVec) .and. (ijvec /= 0)) then
                    iAdrJ = NumIK*(ijVec-1)+iAdrCVec(jSym,iSym,iSO)
                    call dDaFile(LuCVector(jSym,iSO),2,CiKj(:,2),NumIK,iAdrJ)
                    V2(1:) => CiKj(1:,2)
                  else
                    V2(1:) => CiKj(1:,1)
                  end if

                  temp = V_k(Indij)*V_k(Indkl)*CoulFac

                  if ((ijVec /= 0) .and. (klVec /= 0)) then
                    if (iSOi == jSOj) then
                      Fac_ij = One
                    else
                      Fac_ij = Half
                    end if
                    if (kSOk == lSOl) then
                      Fac_kl = One
                    else
                      Fac_kl = Half
                    end if

                    ! Exchange contribution

                    temp = temp-ExFac*Fac_ij*Fac_kl*dDot_(NumIK,CiKJ(:,1),1,V2,1)
                    ! Active space contribution (any factor?)
                    do jp=1,nnP1
                      temp = temp+Z_p_K(jp,ijVec)*Z_p_K(jp,klVec)
                    end do
                  end if

                  PMax = max(PMax,abs(temp))
                  PAO(nijkl,iPAO) = Fac*temp

                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end do
else
  NumIK = nIJ1(iSym,lSym,iSO)
  if (NumIK == 0) return

  iS = 1
  iE = NumIK*2
  CiKj(1:NumIK,1:2) => CijK(iS:iE)

  do i1=1,iCmp(1)
    do i2=1,iCmp(2)
      iSO = iAOtSO(iAO(1)+i1,kOp(1))+iAOst(1)
      jSO = iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
      do i3=1,iCmp(3)
        do i4=1,iCmp(4)
          kSO = iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
          lSO = iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)

          iPAO = iPAO+1
          nijkl = 0

          do lAOl=0,lBas-1
            lSOl = lSO+lAOl
            do kAOk=0,kBas-1
              kSOk = kSO+kAOk
              Indkl = iTri(kSOk,lSOl)
              klVec = ij2K(iOff_ij2K(1)+Indkl)
              if (klvec /= 0) then
                iAdrL = NumIK*(klVec-1)+iAdrCVec(jSym,iSym,iSO)
                call dDaFile(LuCVector(jSym,iSO),2,CiKj(:,1),NumIK,iAdrL)
              end if

              do jAOj=0,jBas-1
                jSOj = jSO+jAOj
                do iAOi=0,iBas-1
                  iSOi = iSO+iAOi
                  nijkl = nijkl+1

                  Indij = iTri(iSOi,jSOj)
                  ijVec = ij2K(iOff_ij2K(1)+Indij)

                  if ((ijVec /= klVec) .and. (ijvec /= 0)) then
                    iAdrJ = NumIK*(ijVec-1)+iAdrCVec(jSym,iSym,iSO)
                    call dDaFile(LuCVector(jSym,iSO),2,CiKj(:,2),NumIK,iAdrJ)
                    V2(1:) => CiKj(:,2)
                  else
                    V2(1:) => CiKj(:,1)
                  end if

                  temp = V_k(Indij)*V_k(Indkl)*CoulFac+V_K(Indij)*U_K(Indkl)*CoulFac+U_K(Indij)*V_K(Indkl)*CoulFac

                  if ((ijVec /= 0) .and. (klVec /= 0)) then
                    if (iSOi == jSOj) then
                      Fac_ij = One
                    else
                      Fac_ij = Half
                    end if
                    if (kSOk == lSOl) then
                      Fac_kl = One
                    else
                      Fac_kl = Half
                    end if

                    ! MP2 contribution
                    call Compute_A_jk_Mp2(ijVec,klVec,tempJ_mp2,Fac_ij,Fac_kl,nAuxVe,2)
                    temp = temp+tempJ_mp2*CoulFac

                    ! Exchange contribution

                    tempK = Two*Fac_ij*Fac_kl*dDot_(NumIK,CiKj(:,1),1,V2,1)
                    call compute_A_jk_Mp2(ijVec,klVec,tempK_mp2,fac_ij,fac_kl,nAuxVe,1)

                    tempK = tempK+tempK_mp2

                    temp = temp-ExFac*tempK*Half
                    ! Active space contribution (any factor?)
                    do jp=1,nnP1
                      temp = temp+Z_p_K(jp,ijVec)*Z_p_K(jp,klVec)
                    end do
                  end if

                  PMax = max(PMax,abs(temp))
                  PAO(nijkl,iPAO) = Fac*temp

                end do
              end do
            end do
          end do
        end do
      end do
    end do
  end do
end if

nullify(CiKj,V2)

if (iPAO /= nPAO) then
  write(u6,*) ' Error in PGet1_CD2!'
  call Abend()
end if

#ifdef _DEBUGPRINT_
call RecPrt(' In PGet1_CD2:PAO ',' ',PAO,ijkl,nPAO)
#endif

call CWTime(Cpu2,Wall2)
Cpu = Cpu2-Cpu1
Wall = Wall2-Wall1
tavec(1) = tavec(1)+Cpu
tavec(2) = tavec(2)+Wall

return

end subroutine PGet1_CD2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE EXC2 (CPQ,NDWN,NUPA,A,NUPB,B,NCP,ICOUP,VTAB)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NUPA,NDWN),B(NUPB,NDWN),
     *          VTAB(*)
      INTEGER   ICOUP(3,NCP)
C CASE: ADD EPQ*A TO B, WHERE MIDLEV<Q<P AND A AND B ARE SINGLE
C MATRIX BLOCKS.
C ONLY UPPER WALKS AFFECTED =>    ROW OPERATION.
C Q<P, EXCITING OPERATOR  => A IS  LEFTHAND WALK.
      IF(NDWN.GT.15) THEN
        DO ICP=1,NCP
          ILFT=ICOUP(1,ICP)
          IRGT=ICOUP(2,ICP)
          X=CPQ*VTAB(ICOUP(3,ICP))
          CALL DAXPY_(NDWN,X,A(ILFT,1),NUPA,B(IRGT,1),NUPB)
        END DO
      ELSE
        DO ICP=1,NCP
          ILFT=ICOUP(1,ICP)
          IRGT=ICOUP(2,ICP)
          X=CPQ*VTAB(ICOUP(3,ICP))
          DO J=1,NDWN
            B(IRGT,J)=B(IRGT,J)+X*A(ILFT,J)
          END DO
        END DO
      END IF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1988, H. Rieger                                        *
************************************************************************
C**********************************************************************
C
C        PROGRAMMBIBLIOTHEK RHRZ BONN        23/11/88       DCOPIV
C                                            FORTRAN 77     IBM 3081
C
C
C NAME:    DCOPIV
C
C PURPOSE:
C
C This program calculates the solution of the system of linear
C equations  A*X = B  for several right-hand sides. The method used is
C complete pivoting which is generally considered a stable method,
C even if the matrix A is ill-conditioned.
C A is decomposed into the product of a lower triangular matrx L
C with main diagonal elements equal to 1 and an upper triangular
C matrix U such that:  L*U = A. While L is not saved, U is over-
C written on A.
C If the matrix A is nonsingular, the solutions are stored in B.
C
C USAGE:   CALL DCOPIV(A,B,N,M,D,EPS,DET,EX,CTR,S)
C
C PARAMETERS:
C
C N,M:     INTEGER, are the order of the matrix A (N) and the
C          number of right-hand sides (M).
C
C D:       INTEGER, is the actual dimension of the arrays as they
C          are declared in the main program. D >= N is necessary.
C
C A:       REAL*8, declared as DIMENSION A(1:D,1:N), is the coefficient
C          matrix. On return it will be over-written by U.
C
C B:       REAL*8, declared as DIMENSION B(1:D,1:M), contains the right
C          hand sides (columnwise). On return each column occupies the
C          corresponding solution.
C
C EPS:     REAL*8, is the tolerance: if a pivotal element is
C          (absolutely) smaller than EPS, matrix A is considered
C          to be singular.
C
C DET:     REAL*8, will contain the determinant (DET = 0 is set,
C          if A is singular). It is scaled such that
C          1.0D-10 <= ABS(DET) <= 1.0D10 .
C
C EX:      INTEGER, is the scale factor for DET. The determinant
C          of A can be obtained from  DET*10**EX .
C
C CTR:     INTEGER, is a control variable with the following
C          meaning on input:
C          CTR < 0: evaluation of just the determinant. Parameter
C                   B is not used at all.
C          CTR = 0: solution of the system of equations and evaluation
C                   of the determinant.
C          CTR > 0: solution of the system of equations only. EX = 0
C                   and DET = 0 (1) will be set, if A is singular
C                   (regular).
C          On return it contains the error code:
C          CTR = -1: parameter fault (see REMARK 1).
C          CTR =  0: program worked.
C          CTR =  1: matrix A is singular.
C
C S:       INTEGER, declared as DIMENSION S(1:N), is used for
C          auxiliary storage only and has no meaning otherwise.
C
C REMARKS: (1) If N < 1 or M < 1, CTR = -1 is set and control is
C              returned to the calling program.
C          (2) The original contents of matrices A and B are
C              destroyed on return.
C          (3) Choosing B = I (unit matrix) with M = N will
C              generate the inverse matrix of A in B.
C          (4) This program makes no use of any special forms or
C              properties of the coefficient matrix (Hessenberg or
C              tridiagonal form, band matrices, symmetric or sparse
C              matrices). Special algorithms should be used in
C              that case, if the order is sufficiently high.
C
C REF.:    J.H. Wilkinson,
C          The Algebraic Eigenvalue Problem,
C          Oxford University Press, pp 212-214, 1965.
C
C AUTHOR:        H. RIEGER, RHRZ
C INSTALLATION:  IBM 3081, VS FORTRAN V2 (OPT=3)
C
C ACCESS:
C                --- MVS ---              --- VM/CMS ---
C LOAD MODULE:   SYS3.FORTLIB(DCOPIV)     FORTLIB  TXTLIB P (DCOPIV)
C DESCRIPTION:   SYS3.INFOLIB(DCOPIV)     INFOLIB  MACLIB P (DCOPIV)
C SOURCE MODULE: SYS3.SYMLIB.FORTRAN(DCOPIV)
C
C**********************************************************************
C
      SUBROUTINE   DCOPIV(A,B,N,M,iD,EPS,DET,iEX,iCTR,S)
      implicit real*8(a-h,o-z)
      DIMENSION    A(iD,N),B(iD,M),S(N)
C
      CALL DCOPIV_INTERNAL(S)
*
*     This is to allow type punning without an explicit interface
      CONTAINS
      SUBROUTINE DCOPIV_INTERNAL(S)
      USE ISO_C_BINDING
      REAL*8, TARGET :: S(*)
      INTEGER, POINTER :: iS(:)
      CALL C_F_POINTER(C_LOC(S(1)),iS,[N])
      IF (N .LT. 1 .OR. M .LT. 1) GO TO 7
      iEX = 0
      DET = 1.0D0
      IF (N .EQ. 1) GO TO 4
      DO 9 I=1,N-1
         C = ABS(A(I,I))
         iRI = I
         iCI = I
         DO 10 J=I,N
            DO 11 K=I,N
               IF (ABS(A(J,K)) .GT. C) THEN
                  C = ABS(A(J,K))
                  iRI = J
                  iCI = K
               END IF
   11       CONTINUE
   10    CONTINUE
         IF (iRI .NE. I) THEN
            DET = -DET
            DO 13 J=1,N
               C = A(I,J)
               A(I,J) = A(iRI,J)
               A(iRI,J) = C
   13       CONTINUE
            IF (iCTR .GE. 0) THEN
               DO 14 J=1,M
                  C = B(I,J)
                  B(I,J) = B(iRI,J)
                  B(iRI,J) = C
   14          CONTINUE
            END IF
         END IF
         IF (iCI .NE. I) THEN
            DET = -DET
            DO 16 J=1,N
               C = A(J,I)
               A(J,I) = A(J,iCI)
               A(J,iCI) = C
   16       CONTINUE
         END IF
         iS(I) = iCI
         SUM = A(I,I)
         IF (ABS(SUM) .LE. EPS) then
            write(6,*) ' case 1. i,sum,eps', i,sum,eps
            GO TO 1
         endif
         DO 17 J=I+1,N
            C = A(J,I)/SUM
            DO 18 K=I+1,N
               A(J,K) = A(J,K)-C*A(I,K)
   18       CONTINUE
            IF (iCTR .GE. 0) THEN
               DO 19 K=1,M
                  B(J,K) = B(J,K)-C*B(I,K)
   19          CONTINUE
            END IF
   17    CONTINUE
    9 CONTINUE
    4 SUM = A(N,N)
      IF (ABS(SUM) .LE. EPS) then
            write(6,*) ' case 2. n,sum,eps', n,sum,eps
         GO TO 1
      endif
      IF (iCTR .GT. 0) GO TO 6
      DO 20 K=1,N
         DET = DET*A(K,K)
    2    IF (ABS(DET) .GT. 1.0D10) THEN
            DET = DET*1.0D-20
            iEX = iEX+20
            GO TO 2
         END IF
    3    IF (ABS(DET) .LE. 1.0D-10) THEN
            DET = DET*1.0D20
            iEX = iEX-20
            GO TO 3
         END IF
   20 CONTINUE
      IF (iCTR .LT. 0) GO TO 5
    6 DO 21 K=1,M
         B(N,K) = B(N,K)/SUM
   21 CONTINUE
      IF (N .EQ. 1) GO TO 5
      DO 22 I=N-1,1,-1
         C = A(I,I)
         DO 23 J=1,M
            SUM = B(I,J)
            DO 24 K=I+1,N
               SUM = SUM-A(I,K)*B(K,J)
   24       CONTINUE
            B(I,J) = SUM/C
   23    CONTINUE
   22 CONTINUE
      DO 25 K=N-1,1,-1
         I = iS(K)
         IF (I .NE. K) THEN
            DO 26 J=1,M
               C = B(I,J)
               B(I,J) = B(K,J)
               B(K,J) = C
   26       CONTINUE
         END IF
   25 CONTINUE
    5 iCTR = 0
      NULLIFY(iS)
      RETURN
    1 DET = 0.0D0
      iCTR = 1
      NULLIFY(iS)
      RETURN
    7 iCTR = -1
      NULLIFY(iS)
      RETURN
      END SUBROUTINE DCOPIV_INTERNAL
*
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************

      SUBROUTINE CHO_X_GET_PARDIAG(jSym,iSO_ab)

************************************************************************
*      Returns an array of the "a" and "b" indices that give rise to the
*      parent diagonal from which a given J-index has been originated
*      by the (molecular) Cholesky decomposition procedure
*
*        ia=iSO_ab(1,numcho(jSym))  contains the index of the basis "a"
*                                   within its symm. block.
*                                   (Note: there is an integer function
*                                   "cho_isao(ia)" that returns the
*                                   irrep to which "a" belongs)
*
*        "Location 2" of iSO_ab returns the same kind of info for "b"
*
*
*  Author: F. Aquilante
*
************************************************************************
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: MyRank, nProcs
#endif
      use ChoArr, only: iRS2F
      use ChoSwp, only: InfVec
      Implicit Real*8 (a-h,o-z)
      Integer iSO_ab(2,*)

#include "cholesky.fh"
#ifdef _MOLCAS_MPP_
#include "stdalloc.fh"
      Integer, Allocatable:: ip_List(:), ip_Aux(:,:)
#endif

      iOff=0

#ifdef _MOLCAS_MPP_
      Call mma_allocate(ip_List,[0,nProcs-1],Label='ip_List')
      ip_List(:)=0
      ip_List(MyRank)=NumCho(jSym)
      Call Cho_GAIGOP(ip_List,nProcs,'+')
      nTot=0
      Do iRank=1,nProcs
         nTot = nTot + ip_List(iRank-1)
         If (iRank.eq.MyRank) iOff = nTot
      End Do
      Call mma_deallocate(ip_List)
#endif

      Do jv=1,NumCho(jSym)

         jRab = InfVec(jv,1,jSym) ! addr. 1st red set within jSym

         kRab = iiBstr(jSym,1) + jRab ! global addr. 1st red set

         iSO_ab(1,jv+iOff)=iRS2F(1,kRab) !global addr. of a in SO list
         iSO_ab(2,jv+iOff)=iRS2F(2,kRab) !same for b, always (a .ge. b)
      End Do

#ifdef _MOLCAS_MPP_
      Call mma_allocate(ip_Aux,2,nTot,Label='ip_Aux')
      ip_Aux(:,:)=0
      Do jv=1,NumCho(jSym)
         kv=InfVec(jv,5,jSym)
         ip_Aux(1,kv) = iSO_ab(1,jv+iOff)
         ip_Aux(2,kv) = iSO_ab(2,jv+iOff)
      End Do
      iSO_ab(:,1:nTot)=ip_Aux(:,1:nTot)
      Call mma_deallocate(ip_Aux)
      Call Cho_GAIGOP(iSO_ab,2*nTot,'+')
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Stefan Knecht                                    *
!***********************************************************************

subroutine dmrgscf(iReturn)

use rasscf_data, only: doDMRG
use Definitions, only: iwp

implicit none

integer(kind=iwp), intent(inout) :: iReturn
! ----------------------------------------------------------------------

!> set DMRG driver as active space solver
call set_as_solver()

!> read DMRG settings (driver-specific input)
call set_dmrg_settings()

!> call wave function optimizer
iReturn = 0
call rasscf(iReturn)

#ifdef _DMRG_
!> reset in case we call RASSCF (or RASSI or CASPT2) afterwards requesting a CI driver
if (doDMRG) doDMRG = .false.
#endif

end subroutine dmrgscf
! ----------------------------------------------------------------------

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_QUALIFY_2(DIAG,ISYM,ISHLAB,MEM,MEM0,LEFT)
!
! Purpose: qualify diagonals ("qualify until full, then largest").

use Cholesky, only: DiaMin, iiBstR, iiBstRSh, IndRed, iOffq, iQuAB, MaxQual, nnBstR, nnBstRSh, nQual
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Diag(*)
integer(kind=iwp), intent(in) :: ISYM, ISHLAB, MEM
integer(kind=iwp), intent(inout) :: MEM0, LEFT
integer(kind=iwp) :: I, I1, I2, II, II1, IMAX, J, JJ, JJ1, K, K1, K2, KKMN, MAXQ, NDIM, NUMQ
real(kind=wp) :: XMAX, XMIN
character(len=*), parameter :: SECNAM = 'CHO_QUALIFY_2'

NDIM = NNBSTRSH(ISYM,ISHLAB,2)
if (NDIM > 0) then
  MAXQ = min(MAXQUAL-NQUAL(ISYM),LEFT/NNBSTR(ISYM,2))
  NUMQ = 0
  if (MAXQ > 0) then
    I1 = IIBSTR(ISYM,2)+IIBSTRSH(ISYM,ISHLAB,2)+1
    I2 = I1+NDIM-1
    if (MAXQ == 1) then ! qualify the largest > DIAMIN
      XMAX = DIAMIN(ISYM)
      IMAX = -1
      do I=I1,I2
        J = INDRED(I,2)
        if (DIAG(J) >= XMAX) then
          XMAX = DIAG(J)
          IMAX = I
        end if
      end do
      if (IMAX > 0) then
        NUMQ = NUMQ+1
        iQuAB(IOFFQ(ISYM)+NUMQ,ISYM) = IMAX
      end if
    else ! full search
      do I=I1,I2
        J = INDRED(I,2)
        if (DIAG(J) >= DIAMIN(ISYM)) then
          if (NUMQ < MAXQ) then
            NUMQ = NUMQ+1
            iQuAB(IOFFQ(ISYM)+NUMQ,ISYM) = I
          else if (NUMQ == MAXQ) then
            K1 = IOFFQ(ISYM)+1
            K2 = K1+NUMQ-1
            II1 = IQUAB(K1,ISYM)
            JJ1 = INDRED(II1,2)
            XMIN = DIAG(JJ1)
            KKMN = K1
            do K=K1+1,K2 ! find min. among qualified
              II = IQUAB(K,ISYM)
              JJ = INDRED(II,2)
              if (DIAG(JJ) < XMIN) then
                XMIN = DIAG(JJ)
                KKMN = K
              end if
            end do
            if (DIAG(J) > XMIN) iQuAB(KKMN,ISYM) = I ! replace
          else
            call CHO_QUIT('Logical error in '//SECNAM,104)
          end if
        end if
      end do
    end if
  end if
  NQUAL(ISYM) = NQUAL(ISYM)+NUMQ
  MEM0 = MEM0+NUMQ*NNBSTR(ISYM,2)
  LEFT = MEM-MEM0
end if

end subroutine CHO_QUALIFY_2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Stefano Battaglia                                *
!***********************************************************************

subroutine prettyprint(A,N,M)
! This subroutine pretty prints the NxM matrix A

use caspt2_module, only: mState
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, M
real(kind=wp), intent(in) :: A(N,M)
integer(kind=iwp) :: i, j, jEnd, jStart

do jStart=1,N,5
  jEnd = min(jStart+4,N)
  write(u6,'(1x,5i16)') (mstate(j),j=jStart,jEnd)
  do i=1,N
    write(u6,'(1x,i3,2x,5f16.8)') mstate(i),(A(i,j),j=jStart,jEnd)
  end do
  write(u6,*)
end do

end subroutine prettyprint

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Fill_rInfo1()

use Basis_Info, only: dbsc, nCnttp, Shells
use Definitions, only: iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp) :: iAng, icnt, iCnttp, jSh, kCof, kExp, krBas, krCnt, krCof, krExp, nExpj
#include "rinfo.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
! Generate stuff for rinfo.fh

krExp = 0
krCof = 0
krBas = 0
krCnt = 0

! Loop over basis sets
do iCnttp=1,nCnttp
  ! Loop over distinct centers
  do icnt=1,dbsc(iCnttp)%nCntr
    krCnt = krCnt+1
    nAngr(krCnt) = dbsc(iCnttp)%nVal-1

    ! Start with s type shells
    jSh = dbsc(iCnttp)%iVal
    do iAng=0,dbsc(iCnttp)%nVal-1

      krBas = krBas+1
      if (krBas > MxAO) then
        call WarningMessage(2,'Too many shells')
        write(u6,*) 'MORE THAN ',MxAO,' SHELLS'
        write(u6,*) 'Increase MxAO in maxbfn.fh and recompile the code!'
        call Abend()
      end if
      nExpj = Shells(jSh)%nExp
      nPrimr(krBas) = nExpj
      nBasisr(krBas) = Shells(jSh)%nBasis_C

      if (krExp+nExpj > MxPrim) then
        call WarningMessage(2,'Too many primitives')
        write(u6,*) 'MORE THAN ',MxPrim,' PRIMITIVES'
        write(u6,*) 'Increase MxPrim in rinfo.fh and recompile the code!'
        call Abend()
      end if
      do kExp=1,nExpj
        krExp = krExp+1
        rExp(krExp) = Shells(jSh)%Exp(kExp)
      end do

      ! Pointer to the untouched contraction matrix as after input.

      if (krCof+nExpj*Shells(jSh)%nBasis > MxrCof) then
        call WarningMessage(2,'Too many contraction coefficients')
        write(u6,*) 'MORE THAN ',MxrCof,' CONTRACTION COEFFICIENTS'
        write(u6,*) 'Increase MxrCof in rinfo.fh and recompile the code!'
        call Abend()
      end if
      do kCof=1,Shells(jSh)%nBasis_C
        do kExp=1,nExpj
          krCof = krCof+1
          rCof(krCof) = Shells(jSh)%Cff_c(kExp,kCof,2)
        end do
      end do

      jSh = jSh+1
    end do
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Fill_rInfo1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine SOLVE(NN,UL,B,X)

use cpf_global, only: IPS
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: NN
real(kind=wp), intent(in) :: UL(NN,NN), B(*)
real(kind=wp), intent(_OUT_) :: X(*)
integer(kind=iwp) :: I, IBACK, IM1, IP, IP1, J, N, NP1
real(kind=wp) :: RSUM

N = NN
NP1 = N+1

IP = IPS(1)
X(1) = B(IP)
do I=2,N
  IP = IPS(I)
  IM1 = I-1
  RSUM = Zero
  do J=1,IM1
    RSUM = RSUM+UL(IP,J)*X(J)
  end do
  X(I) = B(IP)-RSUM
end do
IP = IPS(N)
X(N) = X(N)/UL(IP,N)
do IBACK=2,N
  I = NP1-IBACK
  ! I GOES (N-1),...,1
  IP = IPS(I)
  IP1 = I+1
  RSUM = Zero
  do J=IP1,N
    RSUM = RSUM+UL(IP,J)*X(J)
  end do
  X(I) = (X(I)-RSUM)/UL(IP,I)
end do

return

end subroutine SOLVE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per-Olof Widmark                                 *
*               1986, Bjorn O. Roos                                    *
************************************************************************
************************************************************************
*                                                                      *
* WRITTEN IN 1986 BY                                                   *
* PER-OLOF WIDMARK AND BJOERN O. ROOS                                  *
* DEPARTMENT OF THEORETICAL CHEMISTRY                                  *
* UNIVERSITY OF LUND                                                   *
* SWEDEN                                                               *
*                                                                      *
************************************************************************
      subroutine vibrotmain(ireturn)
      Implicit real*8 (A-H,O-Z)
#include "dimensions.fh"
#include "intinp.fh"
#include "observ.fh"
      Dimension R(npoint+4),PotR(npoint+4)
C
C
C  Logical units
C  Vibwvs can be saved for later Transition moment calculations
C  where it will be redefined as Vibwvs1 or Vibwvs2:
      Vibwvs=12
      Vibwvs1=Vibwvs+1
      Vibwvs2=Vibwvs+2
      Call Daname(Vibwvs,'VIBWVS')
      Call Daname(Vibwvs1,'VIBWVS1')
      Call Daname(Vibwvs2,'VIBWVS2')
      ncase=0
      Call Vibinp(ncase,ngrid,nvib,Umin,Umax,R,PotR,E0,dE0,Redm,
     *            Teas,Req,scale,temp)
      If ( ncase.eq.1 ) then
        Call Vibrot(ngrid,nvib,Umin,Umax,R,PotR,E0,dE0,
     *              Redm,Req,scale,temp)
        If(IfPrWf.gt.0) then
          Call PrWf_VibRot(ngrid,R)
        End If
      Else If ( ncase.eq.2 ) then
        Write(6,*) iallrot
        Do 10 i=1,iobs
          Call Vibtrm(ngrid,Umin,Umax,Teas,R,EoutO(1,i),Titobs(i))
10      Continue
      Else
        Write(6,1000)
1000    Format(/1x,'No ROVIbrational or TRANsition keywords'//
     & 'specified in input.')
      End If
      Call Daclos(Vibwvs)
      Call Daclos(Vibwvs1)
      Call Daclos(Vibwvs2)
      ireturn=0
      return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1999, Roland Lindh                                     *
!***********************************************************************

subroutine Subblock(iNQ,x_NQ,y_NQ,z_NQ,InBox,x_min_,x_max_,y_min_,y_max_,z_min_,z_max_,list_p,nlist_p,Grid,Weights,mGrid,Process, &
                    number_of_grid_points,R_box_min,R_box_max,ilist_p,xyz0,iAngular_Grid,nR_Eff)
!***********************************************************************
!                                                                      *
! Object:                                                              *
!                                                                      *
!     Author: Roland Lindh,                                            *
!             Dept of Chemical Physics,                                *
!             University of Lund, Sweden                               *
!             August 1999                                              *
!***********************************************************************

use NQ_structure, only: Info_Ang, NQ_Data
use nq_Info, only: Angular_Pruning, iOpt_Angular, ntotgp, On
use Grid_On_Disk, only: ExpandBatchInfo, iBatchInfo, iDisk_Grid, Lu_Grid, nBatch
use Constants, only: One, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iNQ, nlist_p, list_p(nlist_p), mGrid, ilist_p, nR_Eff, iAngular_Grid(nR_Eff)
real(kind=wp), intent(in) :: x_NQ, y_NQ, z_NQ, x_min_, x_max_, y_min_, y_max_, z_min_, z_max_, R_box_min, R_box_max, xyz0(3,2)
logical(kind=iwp), intent(in) :: InBox, Process
real(kind=wp), intent(inout) :: Grid(3,mGrid), Weights(mGrid)
integer(kind=iwp), intent(inout) :: number_of_grid_points
integer(kind=iwp) :: iEnd_R, iPoint, iR, iR_End, iR_Start, iSet, iStart_R, iStrt, kSet, mGrid_, nGrid, nRemoved
real(kind=wp) :: Fact, R_Value, Radius, w_g, weight, x, xpt, y, ypt, z, zpt

!                                                                      *
!***********************************************************************
!                                                                      *
nGrid = (9*mGrid)/10
iStrt = number_of_grid_points+1
!                                                                      *
!***********************************************************************
!                                                                      *
! Start loop over the atomic grid

#ifdef _DEBUGPRINT_
write(u6,*) ' x_NQ=',x_NQ
write(u6,*) ' y_NQ=',y_NQ
write(u6,*) ' z_NQ=',z_NQ
write(u6,*) ' Process=',Process
write(u6,*) ' number_of_grid_points=',number_of_grid_points
write(u6,*) 'x:',x_min_,x_max_
write(u6,*) 'y:',y_min_,y_max_
write(u6,*) 'z:',z_min_,z_max_
write(u6,*)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
iStart_R = nR_Eff
iEnd_R = 1
!write(u6,*)
!write(u6,*) 'Start range:',iEnd_R,iStart_R
if (.not. btest(iOpt_Angular,1)) then
  !write(u6,*) 'Find R subrange!'

  ! Compute valid subrange for R

  iR_End = iEnd_R
  do iR=iEnd_R,iStart_R
    R_Value = NQ_Data(iNQ)%R_Quad(1,iR)
    if (R_Value > R_box_Min) exit
    iR_End = iR
  end do

  iR_Start = iStart_R
  do iR=iStart_R,iR_End,-1
    R_Value = NQ_Data(iNQ)%R_Quad(1,iR)
    if (R_Value < R_Box_Max) exit
    iR_Start = iR
  end do

else
  !write(u6,*) 'Do whole R range!'

  ! Scan the whole range

  iR_Start = iStart_R
  iR_End = iEnd_R

end if

! Reset iStart_R and iEnd_R, these are not to be modified again!

iStart_R = iR_Start
iEnd_R = iR_End
iSet = -1
!write(u6,*) 'Actual range:',iEnd_R,iStart_R
!                                                                      *
!***********************************************************************
!                                                                      *
! Outer loop over angular grids

do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Determine a range (iStart_R,iEnd_R) where we will use a
  ! specific angular grid. As we get closer to the nuclei we will
  ! reduce the order of the angular grid.

  ! Start loop at the outermost point and iterate towards the
  ! nuclei.

  iR_End = iR_Start+1
  do iR=iR_Start,iEnd_R,-1
    kSet = iAngular_Grid(iR)

    ! Save new iSet for the first point of this subrange.

    if (iR == iR_Start) iSet = kSet

    ! Branch out if we hit on a range where we can reduce the
    ! angular grid further.

    if (kSet /= iSet) exit

    ! Update inner index

    iR_End = iR
  end do

  ! Branch out if subrange is outside the box

  if ((NQ_Data(iNQ)%R_Quad(1,iR_End) <= R_box_Max) .and. (NQ_Data(iNQ)%R_Quad(1,iR_Start) >= R_box_Min)) then

    !write(u6,*) 'Selected range:',iR_End,iR_Start
    !write(u6,*) 'l_max=',Info_Ang(iSet)%L_Eff
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Angular loop

    do iPoint=1,Info_Ang(iSet)%nPoints
#     ifdef _DEBUGPRINT_
      write(u6,*) 'X,Y,Z*',Info_Ang(iSet)%R(1,iPoint),Info_Ang(iSet)%R(2,iPoint),Info_Ang(iSet)%R(3,iPoint)
#     endif

      if ((.not. InBox) .and. (.not. btest(iOpt_Angular,1))) then
        !write(u6,*) 'Select angular points!'
        if ((Info_Ang(iSet)%R(1,iPoint) < xyz0(1,1)) .or. (Info_Ang(iSet)%R(1,iPoint) > xyz0(1,2)) .or. &
            (Info_Ang(iSet)%R(2,iPoint) < xyz0(2,1)) .or. (Info_Ang(iSet)%R(2,iPoint) > xyz0(2,2)) .or. &
            (Info_Ang(iSet)%R(3,iPoint) < xyz0(3,1)) .or. (Info_Ang(iSet)%R(3,iPoint) > xyz0(3,2))) cycle
      end if
      !                                                                *
      !*****************************************************************
      !                                                                *
      ! Radial loop over the reduced range

      do iR=iR_End,iR_Start
        Radius = NQ_Data(iNQ)%R_Quad(1,iR)
        ! In the atomic referential
        xpt = Radius*Info_Ang(iSet)%R(1,iPoint)
        ypt = Radius*Info_Ang(iSet)%R(2,iPoint)
        zpt = Radius*Info_Ang(iSet)%R(3,iPoint)
        ! In the system referential
        x = xpt+x_NQ
        y = ypt+y_NQ
        z = zpt+z_NQ
#       ifdef _DEBUGPRINT_
        write(u6,*) 'Radius=',Radius
        write(u6,*) ' x,y,z:',x,y,z
        write(u6,*) x_NQ,y_NQ,z_NQ
#       endif

        ! Check if the point is inside the box.
        ! Points on the border of boxes are shared.

        if ((x >= x_min_) .and. (x <= x_max_) .and. (y >= y_min_) .and. (y <= y_max_) .and. (z >= z_min_) .and. (z <= z_max_)) then

          ! For shared points modify the weight.

          Fact = One
          if (x == x_min_) Fact = Fact*Half
          if (y == y_min_) Fact = Fact*Half
          if (z == z_min_) Fact = Fact*Half
          if (x == x_max_) Fact = Fact*Half
          if (y == y_max_) Fact = Fact*Half
          if (z == z_max_) Fact = Fact*Half
#         ifdef _DEBUGPRINT_
          write(u6,*) Info_Ang(iSet)%R(1,iPoint),Info_Ang(iSet)%R(2,iPoint),Info_Ang(iSet)%R(3,iPoint)
          write(u6,*) 'x:',xyz0(1,1),xyz0(1,2)
          write(u6,*) 'y:',xyz0(2,1),xyz0(2,2)
          write(u6,*) 'z:',xyz0(3,1),xyz0(3,2)
          write(u6,*) ' Inside:',x,y,z
#         endif

          ! Radial weight
          weight = NQ_Data(iNQ)%R_Quad(2,iR)
          ! Combine the radial and angular weight
          w_g = weight*Info_Ang(iSet)%R(4,iPoint)
          if (w_g*Fact >= 1.0e-15_wp) then
            number_of_grid_points = number_of_grid_points+1
            Grid(1,number_of_grid_points) = x
            Grid(2,number_of_grid_points) = y
            Grid(3,number_of_grid_points) = z
            ! Compute the partitioning weight
            Weights(number_of_grid_points) = w_g*Fact
          end if
        end if
        !                                                              *
        !***************************************************************
        !                                                              *
        ! The call of Do_Batch is done if the buffer is full:
        ! (number_of_grid_points > nGrid)
        !                                                              *
        !***************************************************************
        !                                                              *
        if (number_of_grid_points > mGrid) then
          call WarningMessage(2,'Subblock: Buffer overflowed!;Try a larger buffer size!')
          call Abend()
        end if
        if (number_of_grid_points > nGrid) then

          ! Dump grid information to disk
          nBatch = nBatch+1
          if (nBatch > size(iBatchInfo,2)) call ExpandBatchInfo()

          ! Generate weights

          mGrid_ = number_of_grid_points-iStrt+1
          call W(Grid(1,iStrt),ilist_p,Weights(iStrt),list_p,nList_p,mGrid_,nRemoved)
          number_of_grid_points = number_of_grid_points-nRemoved

          iBatchInfo(1,nBatch) = iDisk_Grid
          iBatchInfo(3,nBatch) = iNQ
          iBatchInfo(2,nBatch) = number_of_grid_points

          call dDaFile(Lu_Grid,1,Grid,3*number_of_grid_points,iDisk_Grid)
          call dDaFile(Lu_Grid,1,Weights,number_of_grid_points,iDisk_Grid)

          ntotgp = ntotgp+number_of_grid_points
          !write(u6,*) 'ntotgp=',ntotgp
          number_of_grid_points = 0
          iStrt = number_of_grid_points+1
        end if

      end do ! iR, Radial loop
    end do   ! iPoint
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  iR_Start = iR_End-1
  if ((Angular_Pruning /= On) .or. (iR_End == iEnd_R)) exit
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate weights
!
!write(u6,*) 'number_of_grid_points=',number_of_grid_points
!write(u6,*) 'iStrt=',iStrt
if (number_of_grid_points-iStrt+1 > 0) then
  mGrid_ = number_of_grid_points-iStrt+1
  call W(Grid(1,iStrt),ilist_p,Weights(iStrt),list_p,nList_p,mGrid_,nRemoved)
  number_of_grid_points = number_of_grid_points-nRemoved
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Process batch if not processed yet.

if (Process .and. (number_of_grid_points > 0)) then

  ! Dump grid information to disk
  nBatch = nBatch+1
  if (nBatch > size(iBatchInfo,2)) call ExpandBatchInfo()
  iBatchInfo(1,nBatch) = iDisk_Grid
  iBatchInfo(2,nBatch) = number_of_grid_points
  iBatchInfo(3,nBatch) = iNQ
  call dDaFile(Lu_Grid,1,Grid,3*number_of_grid_points,iDisk_Grid)
  call dDaFile(Lu_Grid,1,Weights,number_of_grid_points,iDisk_Grid)

  ntotgp = ntotgp+number_of_grid_points
  !write(u6,*) 'ntotgp=',ntotgp
  number_of_grid_points = 0
end if
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Subblock

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetMltplCenters(MltplOrder)
C
C     Thomas Bondo Pedersen, July 2012.
C
C     Set multipole centers.
C
      use Sizes_of_Seward, only: S
      use Real_Info, only: CoM
      Implicit Real*8 (a-h,o-z)

      If (MltplOrder.ge.0) Then
         S%nMltpl=MltplOrder
         Call Get_dArray('Center of Mass',CoM,3)
         Call SetMltplCenters()
      End If

      End
      Subroutine LDF_UnsetMltplCenters(MltplOrder)
C
C     Thomas Bondo Pedersen, July 2012.
C
C     Unset multipole centers.
C
      use MpmC
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"

      If (MltplOrder.ge.0) Call mma_deallocate(Coor_MPM)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_TrcIdl_Update(IAmIdle)
!
! Thomas Bondo Pedersen, May 2010.
!
! Update array for tracing idle processors

use Para_Info, only: MyRank
use Cholesky, only: Cho_Real_Par, Idle
#ifdef _DEBUGPRINT_
use Cholesky, only: LuPri, Trace_Idle
#endif
use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(in) :: IAmIdle

#ifdef _DEBUGPRINT_
if ((.not. allocated(Idle)) .or. (.not. Trace_Idle)) then
  write(LuPri,'(A)') 'Cho_TrcIdl_Update should not be called in this run!'
  write(LuPri,*) 'Trace_Idle=',Trace_Idle
  call Cho_Quit('Illegal call to Cho_TrcIdl_Update',103)
end if
#endif

if (IAmIdle) then
  if (Cho_Real_Par) then
    Idle(1+myRank) = Idle(1+myRank)+1
  else
    Idle(1) = Idle(1)+1
  end if
end if

end subroutine Cho_TrcIdl_Update

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Etwo_act(Dma,Dmb,nBDT,nBas,nSym,Etwo)

use Fock_util_global, only: Estimate, Update
use Data_structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nBDT, nBas(8), nSym
real(kind=wp), intent(in) :: Dma(nBDT), Dmb(nBDT)
real(kind=wp), intent(out) :: Etwo
#include "chotime.fh"
integer(kind=iwp) :: i, iOff, irc, nBB, nForb(8,2), nIorb(8,2), NSCREEN
real(kind=wp) :: ChFracMem, dFmat, dmpk, FactXI
!character(len=80) :: KSDFT
real(kind=wp), allocatable :: Dm1(:), Dm2(:)
real(kind=r8), external :: ddot_ !, Get_ExFac
type (DSBA_Type) :: FLT(2), KLT(2), POrb(2), PLT(2)

timings = .false.
Estimate = .false.

Update = .true.
dmpk = One
NSCREEN = 10

nForb(:,:) = 0
nBB = 0
do i=1,nSym
  nBB = nBB+nBas(i)**2
end do
!call Get_cArray('DFT functional',KSDFT,80)
!ExFac = Get_ExFac(KSDFT)
!FactXI = ExFac
FactXI = One  ! always HF energy
Call Allocate_DT(PLT(1),nBas,nBas,nSym,aCase='TRI')
PLT(1)%A0(:) = Dma(:)+Dmb(:)

Call Allocate_DT(POrb(1),nBas,nBas,nSym)
Call Allocate_DT(POrb(2),nBas,nBas,nSym)
call mma_allocate(Dm1,nBB,label='Dm1')
call mma_allocate(Dm2,nBB,label='Dm2')
call UnFold(Dma,nBDT,Dm1,nBB,nSym,nBas)
call UnFold(Dmb,nBDT,Dm2,nBB,nSym,nBas)
iOff = 1
do i=1,nSym
  call CD_InCore(Dm1(iOff),nBas(i),Porb(1)%SB(i)%A2,nBas(i),nIorb(i,1),1.0e-12_wp,irc)
  if (irc /= 0) then
    write(u6,*) ' Alpha density. Sym= ',i,'   rc= ',irc
    call Abend()
  end if
  call CD_InCore(Dm2(iOff),nBas(i),Porb(2)%SB(i)%A2,nBas(i),nIorb(i,2),1.0e-12_wp,irc)
  if (irc /= 0) then
    write(u6,*) ' Beta density. Sym= ',i,'   rc= ',irc
    call Abend()
  end if
  iOff = iOff+nBas(i)**2
end do

Call Allocate_DT(FLT(1),nBas,nBas,nSym,aCase='TRI')
Call Allocate_DT(FLT(2),nBas,nBas,nSym,aCase='TRI')
FLT(1)%A0(:)=Zero
FLT(2)%A0(:)=Zero

Call Allocate_DT(KLT(1),nBas,nBas,nSym,aCase='TRI')
Call Allocate_DT(KLT(2),nBas,nBas,nSym,aCase='TRI')
KLT(1)%A0(:)=Zero
KLT(2)%A0(:)=Zero

call Cho_X_init(irc,ChFracMem)
if (irc /= 0) then
  call WarningMessage(2,'Get_CNOs. Non-zero rc in Cho_X_init.')
  call Abend()
end if


call CHO_LK_SCF(irc,2,FLT,KLT,nForb,nIorb,Porb,PLT,FactXI,nSCReen,dmpk,dFmat)

if (irc /= 0) then
  call WarningMessage(2,'Get_CNOs. Non-zero rc in Cho_LK_scf.')
  call Abend()
end if

call Cho_X_Final(irc)
if (irc /= 0) then
  call WarningMessage(2,'Get_CNOs. Non-zero rc in Cho_X_Final.')
  call Abend()
end if

Etwo = Half*(ddot_(nBDT,Dma,1,FLT(1)%A0,1)+ddot_(nBDT,Dmb,1,FLT(2)%A0,1))

call Deallocate_DT(PLT(1))
call Deallocate_DT(Porb(2))
call Deallocate_DT(Porb(1))
call mma_deallocate(Dm1)
call mma_deallocate(Dm2)
call Deallocate_DT(FLT(2))
call Deallocate_DT(FLT(1))
call Deallocate_DT(KLT(2))
call Deallocate_DT(KLT(1))

return

end subroutine Get_Etwo_act

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine PRPCTL(MODE,UEFF,U0,nState)

use Index_Functions, only: nTri_Elem
use PT2WFN, only: PT2WFN_DENSSTORE
use OneDat, only: sNoNuc, sNoOri
use PrintLevel, only: USUAL, VERBOSE
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use caspt2_global, only: do_grad
#endif
use EQSOLV, only: IVECX, NLSTOT
use caspt2_global, only: CMO, CMO_Internal, CMOPT2, do_nac, DPT2_tot, DPT2C_tot, iPrGlb, iRoot1, iRoot2, LISTS, LUONEM, NCMO, &
                         SLag, TORB
use caspt2_module, only: BNAME, CPT2Method, Energy, IAD1M, IFMSCOUP, IFPROP, irlxroot, ISCF, JSTATE, MSTATE, MSTATE, NASH, NASHT, &
                         NBAS, NBAST, NCONF, NDEL, NFRO, NISH, NORB, NRAS1, NRAS2, NRAS3, NSYM, OUTFMT, PRORB, THRENE, THROCC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Five, Half, Quart
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Mode, nState
real(kind=wp), intent(in) :: UEFF(NSTATE,NSTATE), U0(nState,nState)
integer(kind=iwp) :: iComp, IDISK, IDMAT, IDMOFF, IERR, II, II2, IJ, IJ2, IndType(7,8), iOpt, iRc, ISTATE, iSyLbl, ISYM, iUHF, &
                     KSTATE, LUTMP, N, nDens, NDMAT, NFROSAV(NSYM), NO, NOCC, NORBSAV(NSYM)
real(kind=wp) :: Dummy(2), DUM(1), SCAL
logical(kind=iwp) :: Do_ESPF, FullMlk, lSave
character(len=128) :: FILENAME, MDNAME
character(len=80) :: Note
character(len=8) :: Label
real(kind=wp), allocatable :: CI1(:), CI2(:), CNAT(:), DMAT(:), OCC(:), Scr(:), SGM(:), TG1(:,:)
integer(kind=iwp), external :: IsFreeUnit

if (IPRGLB >= USUAL) then
  write(u6,*)
  write(u6,'(A)') repeat('*',80)
  write(u6,'(2X,A)') trim(CPT2Method)//' PROPERTY SECTION'
end if

#ifdef _MOLCAS_MPP_
if (Is_Real_Par() .and. (IPRGLB >= USUAL) .and. (.not. do_grad)) then
  write(u6,'(1X,A)') ' ====================================='
  write(u6,'(1X,A)') ' CASPT2 properties were requested, but'
  write(u6,'(1X,A)') ' these are not efficiently implemented'
  write(u6,'(1X,A)') ' in parallel. If you do not need them,'
  write(u6,'(1X,A)') ' not using the PROP keyword could lead'
  write(u6,'(1X,A)') ' to a significant speed up.'
  write(u6,'(1X,A)') ' ====================================='
end if
#endif

! PAM2008 When this subroutine is called, theMSTATE calculation has been done
! for the (individual) state nr JSTATE in 1,2,..,NSTATE.
! The corresponding CI-root from rasscf, the root state for this PT2,
! is number MSTATE(JSTATE) on the input JOBIPH file.
! JSTATE,NSTATE and MSTATE() are in the caspt2_module file.
IERR = 0
if (NSTATE > 1) then
  N = MSTATE(JSTATE)
  if ((N <= 0) .or. (N > 999)) then
    write(u6,*) ' Subroutine PRPCTL fails -- It seems to get data'
    write(u6,*) ' computed for a root nr ',N
    write(u6,*) ' which is surely wrong.'
    write(u6,*) ' PRPCTL gives up, there will be no calculations'
    write(u6,*) ' done of orbitals, properties, etc for this state.'
    write(u6,*) ' This was state nr JSTATE=',JSTATE
    write(u6,*) ' in the MS-CASPT2 calculation.'
    IERR = 1
  end if
end if
if (IERR > 0) return

FullMlk = .true.
if (.not. PRORB) FullMlk = .false.

if (IPRGLB >= USUAL) write(u6,'(A)') repeat('-',80)

! Compute density matrix, output orbitals, and properties.

! Compute density matrix of CASPT2 wave function, in MO basis,
! to produce output orbitals.
! This density matrix may be approximated in several ways, see DENS.
NDMAT = 0
NOCC = sum(NBAS(1:NSYM))
if (MODE == 0) then
  !! Density matrix for each state (single-state)
  NDMAT = sum(nTri_Elem(NORB(1:NSYM)))
  call mma_allocate(DMAT,NDMAT,Label='DMAT')
  DMAT(:) = Zero
  call mma_allocate(LISTS,NLSTOT,LABEL='LISTS')
  call MKLIST(LISTS,NLSTOT)
  call DENS(IVECX,NDMAT,NSTATE,DMAT,UEFF,U0)
  call mma_deallocate(LISTS)
else
  !! Density matrix for the target adiabatic state
  !! MODE = 1 is called after gradient stuff only for MS, so
  !! the density computed here is what we call a correct unrelaxed
  !! correlated CASPT2 density
  !! Called after gradient calculations, only, from GrdCls
  NDMAT = sum(nTri_Elem(NBAS(1:NSYM)))
  call mma_allocate(DMAT,NDMAT,Label='DMAT')
  DMAT(:) = Zero
  !! Copy the unrelaxed density matrix to triangular
  !! The basis of DPT2_tot is natural (CASSCF)
  IDMAT = 0
  IDMOFF = 0
  do ISYM=1,NSYM
    NO = NBAS(ISYM)
    do II=1,NO
      do IJ=1,II
        !! second-order (DPT2) and first-order (DPT2C)
        DMAT(1+IDMAT) = DPT2_TOT(IDMOFF+II+NO*(IJ-1))+DPT2C_TOT(IDMOFF+II+NO*(IJ-1))*Quart
        if (.not. DO_NAC) then
          !! Add the reference density matrix (inactive)
          if ((II == IJ) .and. (II <= NFRO(ISYM)+NISH(ISYM))) DMAT(1+IDMAT) = DMAT(1+IDMAT)+Two
        end if
        IDMAT = IDMAT+1
      end do
    end do
    IDMOFF = IDMOFF+NO*NO
  end do
  !! Add the reference density matrix (active)
  call mma_allocate(CI1,NCONF,Label='CI1')
  call mma_allocate(CI2,NCONF,Label='CI2')
  call mma_allocate(SGM,NCONF,Label='SGM')
  call mma_allocate(TG1,NASHT,NASHT,Label='TG1')
  do ISTATE=1,NSTATE
    if (ISCF /= 0) then
      CI1(1) = One
    else
      call LOADCI_XMS('N',1,NCONF,NSTATE,CI1,ISTATE,U0)
    end if
    do KSTATE=1,NSTATE
      SCAL = SLag(ISTATE,KSTATE)
      if (.not. DO_NAC) then
        if ((ISTATE == IROOT1) .and. (KSTATE == IROOT2)) SCAL = SCAL+One
      end if
      if (abs(SCAL) <= 1.0e-9_wp) cycle
      if (ISCF /= 0) then
        CI2(1) = One
      else
        call LOADCI_XMS('N',1,NCONF,NSTATE,CI2,KSTATE,U0)
      end if
      call Dens1T_RPT2(CI1,CI2,SGM,TG1,nAshT)
      TG1(:,:) = SCAL*TG1(:,:)
      do II=1,NASH(1)
        II2 = II+NFRO(1)+NISH(1)
        IJ2 = nTri_Elem(II2-1)+NFRO(1)+NISH(1)
        DMAT(IJ2+1:IJ2+II) = DMAT(IJ2+1:IJ2+II)+(TG1(II,1:II)+TG1(1:II,II))*Half
      end do
    end do
  end do
  call mma_deallocate(CI1)
  call mma_deallocate(CI2)
  call mma_deallocate(SGM)
  call mma_deallocate(TG1)

  !! The density matrix above has frozen orbitals.
  !! Accordingly, the natural orbitals should be generated
  !! by diagonalizing all orbitals (including frozen), so
  !! make the number of frozen orbitals zero for the moment.
  NFROSAV(1:NSYM) = NFRO(1:NSYM)
  NORBSAV(1:NSYM) = NORB(1:NSYM)
  NFRO(1:NSYM) = 0
  NORB(1:NSYM) = NBAS(1:NSYM)
end if

! Compute natural orbitals of CASPT2 wave function.
call mma_allocate(CMO_Internal,NCMO,Label='CMO_Internal')
CMO => CMO_Internal
CMO(:) = CMOPT2(:)
if (MODE == 1) then
  !! Read the CASSCF orbital (really?)
  IDISK = IAD1M(1)
  call ddafile(LUONEM,2,CMO,NCMO,IDISK)
end if
call mma_allocate(CNAT,NCMO,Label='CNAT')
call mma_allocate(OCC,NOCC,Label='OCC')
call NATORB_CASPT2(DMAT,nDMAT,CMO,nCMO,OCC,nOCC,CNAT,nCMO)
call mma_deallocate(CMO_Internal)
nullify(CMO)
! Backtransform density matrix to original MO basis before storing
call TRANSFOCK(TORB,size(TORB),DMAT,NDMAT,-1)
call PT2WFN_DENSSTORE(DMAT,NDMAT)
call mma_deallocate(DMAT)
if (MODE == 1) then
  !! Restore with frozen orbitals
  NFRO(1:NSYM) = NFROSAV(1:NSYM)
  NORB(1:NSYM) = NORBSAV(1:NSYM)
end if

if (IFMSCOUP .and. (MODE == 0) .and. (.not. IFPROP)) then
  !! Do not show properties, if PROP calculation is not requested
  call mma_deallocate(CNAT)
  call mma_deallocate(OCC)
  return
end if

! Write natural orbitals as standard orbital file on PT2ORB
! PAM2008: Separate PT2ORB files for each state:
FILENAME = 'PT2ORB'
MDNAME = 'MD_PT2'
if ((NSTATE > 1) .and. (MODE == 0)) then
  FILENAME = 'PT2ORB.x'
  MDNAME = 'MD_PT2.x'
  N = MSTATE(JSTATE)
  if (N <= 9) then
    write(FILENAME(8:8),'(I1)') N
    write(MDNAME(8:8),'(I1)') N
  else if (N <= 99) then
    write(FILENAME(8:9),'(I2)') N
    write(MDNAME(8:9),'(I2)') N
  else if (N <= 999) then
    write(FILENAME(8:10),'(I3)') N
    write(MDNAME(8:10),'(I3)') N
  end if
end if
! PAM2008: For MS-CASPT2 with more than one state, orbital files will
! now be numbered PT2ORB.1 ... PT2ORB.999
! depending on which CI-root of the rasscf calculation that was
! the root state of the PT2.
LUTMP = 19
LUTMP = ISFREEUNIT(LUTMP)
! PAM 2008: Add typeindex information:
!----------------------------------------------------------------------*
!     Make typeindex information                                       *
!----------------------------------------------------------------------*
IndType(1,1:NSYM) = NFRO(1:NSYM)
IndType(2,1:NSYM) = NISH(1:NSYM)
IndType(3,1:NSYM) = NRAS1(1:NSYM)
IndType(4,1:NSYM) = NRAS2(1:NSYM)
IndType(5,1:NSYM) = NRAS3(1:NSYM)
IndType(6,1:NSYM) = NDEL(1:NSYM)
IndType(7,1:NSYM) = NBAS(1:NSYM)-sum(IndType(1:6,1:NSYM),dim=1)
if (NSTATE > 1) then
  write(Note,'(A41,I3,A3,f22.12)') '* CASPT2 natural orbitals for root number',N,' E=',Energy(JSTATE)
else
  Note = '* CASPT2 natural orbitals'
end if

call WRVEC(FILENAME,LUTMP,'COI',NSYM,NBAS,NBAS,CNAT,OCC,Dummy,IndType,Note)
iUHF = 0
call Molden_Interface(iUHF,FILENAME,MDNAME)

! Write natural orbitals to standard output.
if (IPRGLB >= VERBOSE) then
  write(u6,*)
  write(u6,'(A)') '  The CASPT2 orbitals are computed as natural orbitals of a density matrix'
  write(u6,'(A)') '  defined as:'
  write(u6,'(A)') '   D = (D0 + D1 + D2)/<PSI|PSI>'
  write(u6,'(A)') ' where D0..D2 are zeroth..2nd order contributions'
  write(u6,'(A)') ' and |PSI> is the total wave function.'
  write(u6,'(A)') ' A new RasOrb file named PT2ORB is prepared.'
  if (PRORB) then
    if (OUTFMT == 'LONG') then
      THRENE = Two**31
      THROCC = -Two**31
    else if (OUTFMT == 'DEFAULT ') then
      THRENE = Five
      THROCC = 5.0e-4_wp
    end if
    call PRIMO('Output orbitals from CASPT2',.true.,.false.,THROCC,THRENE,NSYM,NBAS,NBAS,BNAME,DUM,OCC,CNAT,-1)
  end if
end if

! compute Mulliken's orbital populations

if (IPRGLB >= USUAL) then
  write(u6,*)
  write(u6,*)
  write(u6,'(6X,A)') 'Mulliken population Analysis:'
  write(u6,'(6X,A)') '-----------------------------'

  call mma_allocate(Scr,NBAST**2,Label='Scr')
  iRc = -1
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  iComp = 1
  iSyLbl = 1
  Label = 'Mltpl  0'
  call RdOne(iRc,iOpt,Label,iComp,Scr,iSyLbl)
  if (iRc == 0) then
    lSave = MSTATE(JSTATE) == irlxroot
    call Charge(nSym,nBas,bName,CNAT,OCC,Scr,2,FullMlk,lSave)
  end if
  call mma_deallocate(Scr)
end if

! compute one-electron properties

if (IPRGLB >= USUAL) then
  write(u6,*)
  write(u6,'(6X,A)') 'Expectation values of various properties:'
  write(u6,'(6X,A)') '-----------------------------------------'
end if

nDens = sum(nTri_Elem(nBas(1:nSym)))
call mma_allocate(Scr,NDENS,Label='Scr')

call DOne_Caspt2(CNAT,nCMO,OCC,nOcc,Scr,nDENS)
call Put_dArray('D1ao',Scr,nDens)

Note = 'Temporary orbital file used by prpt.'
if (mode == 1) Note = 'var'
LuTmp = 50
LuTmp = IsFreeUnit(LuTmp)
call WrVec('TMPORB',LuTmp,'CO',nSym,nBas,nBas,CNAT,OCC,Dummy,IndType,Note)
call Prpt()

!nf
!------- ESPF analysis
call DecideOnESPF(Do_ESPF)
lSave = MSTATE(JSTATE) == irlxroot
if (Do_ESPF) call espf_analysis(lSave)
!nf

! On return from PrPt the 1-particle matrix is stored
! in the beginning of the scratch array.

call mma_deallocate(Scr)
call mma_deallocate(CNAT)
call mma_deallocate(OCC)

end subroutine PRPCTL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine genstar(Lhigh)
      implicit real*8 (a-h,o-z)
cbs   purpose: generate start adresses of contraction coeffs on
cbs   contrarray for the different L-Blocks
#include "para.fh"
#include "param.fh"
      istart=1
      do L=0,Lhigh
      inc=nprimit(L)*ncontrac(L)
      iaddori(L)=istart
      istart=istart+inc
      iaddtyp1(L)=istart
      istart=istart+inc
      iaddtyp2(L)=istart
      istart=istart+inc
      iaddtyp3(L)=istart
      istart=istart+inc
      iaddtyp4(L)=istart
      istart=istart+inc
      enddo
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine StdSewInput(LuRd,ifnr,mdc,iShll,BasisTypes,
     &                       STDINP,lSTDINP,iErr)
************************************************************************
* This is a simplified copy of the BASI section of RdCtl_Seward that   *
* reads the string vector STDINP with the standard seward input        *
* generated by ZMatrixConverter.                                       *
************************************************************************
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only: S
      use Logical_Info, only: UnNorm, Do_FckInt
      Implicit Real*8 (a-h,o-z)
*
#include "Molcas.fh"
#include "SysDef.fh"
#include "rctfld.fh"
#include "real.fh"
#include "print.fh"
#include "gateway.fh"
#include "stdalloc.fh"
c
c     IRELAE = 0  .... DKH
c            = 1  .... DK1
c            = 2  .... DK2
c            = 3  .... DK3
c            = 4  .... DK3full
c            = 11 .... RESC
c            = 21 .... ZORA
c            = 22 .... ZORA(FP)
c            = 23 .... IORA
CAWMR
c     NB: The IRELAE flag has been extended to account for
c         arbitrary-order DKH with different parametrizations!
c         IMPORTANT: new arbitrary-order DKH routines are only
c                    called for IRELAE values LARGER than 1000.
CAWMR
c
#include "relae.fh"
      Integer, Parameter:: nBuff=10000
      Real*8, Allocatable:: Buffer(:)
      Common /AMFn/ iAMFn
*
      Character Key*180, KWord*180,            BSLbl*80, Fname*256,
     &          DefNm*13, Ref(2)*80, dbas*4
      Integer StayAlone,  BasisTypes(4)
*
      Character*180 Line, STDINP(mxAtom*2) ! CGGn
      Character*256 Basis_lib ! CGGd , INT2CHAR, CHAR4
      Character*5  Symbol                 ! CGGn
*
CGGd      Data WellRad/-1.22D0,-3.20D0,-6.20D0/
      Data StayAlone/0/
*
#include "angstr.fh"
      Data DefNm/'basis_library'/ ! CGGd,
*                                                                      *
************************************************************************
*                                                                      *
      Interface
#include "getbs_interface.fh"
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(Buffer,nBuff,Label='Buffer')
      iErr=0
      iRout=3
*                                                                      *
************************************************************************
*                                                                      *
      LuWr=6
*
      imix=0
      itype=0
*
      BasisTypes(:)=0
*                                                                      *
****** BASI ************************************************************
*                                                                      *
      iSTDINP = 2

10    nCnttp = nCnttp + 1
      If (nCnttp.gt.Mxdbsc) Then
         Write (LuWr,*) ' Increase Mxdbsc'
         iErr=1
         Return
      End If
*
*     Read the basis set label
*
      Key = STDINP(iSTDINP)
      BSLbl = Key(1:80)
*     Call UpCase(BSLbl)
      LenBSL=Len(BSLbl)
      Last=iCLast(BSLbl,LenBSL)
      Indx=Index(BSLbl,'/')
      If (Indx.eq.0) Then
       call WhichMolcas(Basis_lib)
       if(Basis_lib(1:1).ne.' ') then
         StayAlone=1
         ib=index(Basis_lib,' ')-1
         if(ib.lt.1)
     *    Call SysAbendMsg('rdCtl','Too long PATH to MOLCAS',' ')
         Fname=Basis_lib(1:ib)//'/basis_library'
       else
         Fname=DefNm
       endif
       Indx = Last+1
       dbsc(nCnttp)%Bsl=BSLbl
      Else
         Fname= BSLbl(Indx+2:Last)
         If (Fname.eq.' ') Then
            Call WarningMessage(2,
     &                     ' No basis set library specified for'
     &                   //';BSLbl='//BSLbl//';Fname='//Fname)
            Call Quit_OnUserError()
         End If
 1919    If (Fname(1:1).eq.' ') Then
            Fname(1:79)=Fname(2:80)
            Fname(80:80) = ' '
            Go To 1919
         End If
         dbsc(nCnttp)%Bsl=BSLbl(1:Indx-1)
      End If
*
      n=INDEX(dbsc(nCnttp)%Bsl,' ')
      dbsc(nCnttp)%Bsl(n:n+5)='.....'
*
      If (Show.and.nPrint(2).ge.6) Then
         Write (LuWr,*)
         Write (LuWr,*)
         Write(LuWr,'(1X,A,I5,A,A)')
     &           'Basis Set ',nCnttp,' Label: ', BSLbl(1:Indx-1)
         Write(LuWr,'(1X,A,A)') 'Basis set is read from library:',
     *         Fname(1:index(Fname,' '))
      End if
*
      jShll = iShll
      dbsc(nCnttp)%Bsl_old=dbsc(nCnttp)%Bsl
      dbsc(nCnttp)%mdci=mdc
      Call GetBS(Fname,dbsc(nCnttp)%Bsl,iShll,Ref,UnNorm,
     &           LuRd,BasisTypes,STDINP,iSTDINP,.True.,.true.,' ')
*
      Do_FckInt = Do_FckInt .and. dbsc(nCnttp)%FOp
      If (itype.eq.0) Then
         If (BasisTypes(3).eq.1 .or. BasisTypes(3).eq.2)
     &       iType=BasisTypes(3)
      Else
         If (BasisTypes(3).eq.1 .or. BasisTypes(3).eq.2) Then
            If (BasisTypes(3).ne.iType) Then
               imix=1
               BasisTypes(3)=-1
            End If
            iType=BasisTypes(3)
         End If
      End If
      If (itype.eq.1) ifnr=1
      If (itype.eq.2) ifnr=0
*
      If (Show.and.nPrint(2).ge.6 .and.
     &   Ref(1).ne.'' .and. Ref(2).ne.'') Then
         Write (LuWr,'(1x,a)')  'Basis Set Reference(s):'
         If (Ref(1).ne.'') Write (LuWr,'(5x,a)') Ref(1)
         If (Ref(2).ne.'') Write (LuWr,'(5x,a)') Ref(2)
         Write (LuWr,*)
         Write (LuWr,*)
      End If
      dbsc(nCnttp)%ECP=(dbsc(nCnttp)%nPrj
     &                + dbsc(nCnttp)%nSRO
     &                + dbsc(nCnttp)%nSOC
     &                + dbsc(nCnttp)%nPP
     &                + dbsc(nCnttp)%nM1
     &                + dbsc(nCnttp)%nM2) .NE.0
      dbsc(nCnttp)%nShells = dbsc(nCnttp)%nVal
     &                     + dbsc(nCnttp)%nPrj
     &                     + dbsc(nCnttp)%nSRO
     &                     + dbsc(nCnttp)%nSOC
     &                     + dbsc(nCnttp)%nPP
*
      lAng=Max(dbsc(nCnttp)%nVal,
     &         dbsc(nCnttp)%nSRO,
     &         dbsc(nCnttp)%nPrj)-1
      S%iAngMx=Max(S%iAngMx,lAng)
*     No transformation needed for s and p shells
      Shells(jShll+1)%Transf=.False.
      Shells(jShll+1)%Prjct =.False.
      Shells(jShll+2)%Transf=.False.
      Shells(jShll+2)%Prjct =.False.
      nCnt = 0
      If (dbsc(nCnttp)%Aux) Then
         Do iSh = jShll+1, iShll
            Shells(iSh)%Aux=.True.
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Here we will have to fix that the 6-31G family of basis sets
*     should by default be used with 6 d-functions rather than 5.
*
      KWord=BSLbl(1:Indx-1)
      Call UpCase(KWord)
      If (INDEX(KWord,'6-31G').ne.0) Then
         Do iSh = jShll+3, iShll
            Shells(iSh)%Transf=.False.
            Shells(iSh)%Prjct =.False.
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
100   iSTDINP = iSTDINP + 1
      Line = STDINP(iSTDINP)
      KWord = Line
      Call UpCase(KWord)
      If (KWord(1:4).eq.'END ') Then
         If (nCnt.eq.0) Then
            Call WarningMessage(2,' Input error, no center specified!')
            Call Quit_OnUserError()
         End If
         dbsc(nCnttp)%nCntr = nCnt
         call mma_allocate(dbsc(nCnttp)%Coor_Hidden,3,nCnt,
     &                     Label='dbsc:C')
         dbsc(nCnttp)%Coor => dbsc(nCnttp)%Coor_Hidden(:,:)
         Call DCopy_(3*nCnt,Buffer,1,dbsc(nCnttp)%Coor,1)
         mdc = mdc + nCnt
         Go To 900
      End If
*
*     Read Coordinates
*
      nCnt = nCnt + 1
      n_dc=max(mdc+nCnt,n_dc)
      If (mdc+nCnt.gt.MxAtom) Then
         Call WarningMessage(2,' RdCtl: Increase MxAtom')
         Write (LuWr,*) '        MxAtom=',MxAtom
         Call Quit_OnUserError()
      End If
      iend=Index(KWord,' ')
      If (iEnd.gt.LENIN+1) Then
         Write (6,*) 'Warning: the label ', KWord(1:iEnd),
     &               ' will be truncated to ',LENIN,' characters!'
      End If
      dc(mdc+nCnt)%LblCnt = KWord(1:Min(LENIN,iend-1))
      dbas=Trim(dc(mdc+nCnt)%LblCnt(1:LENIN))
      Call Upcase(dbas)
      If (dbas.eq.'DBAS') Then
         Call WarningMessage(2,' RdCtl: ZMAT does not work with DBAS')
         Call Quit_OnUserError()
      End If
      If (mdc+nCnt.gt.1)
     &   Call Chk_LblCnt(dc(mdc+nCnt)%LblCnt,mdc+nCnt-1)
      iOff=1+(nCnt-1)*3
C      print *,line
      Read (Line,'(A5)') Symbol
      Read (Line(6:),*) (Buffer(iOff+i),i=0,2) ! CGGn
      If (Index(KWord,'ANGSTROM').ne.0) Then
         Do i = 0, 2
            Buffer(iOff+i) = Buffer(iOff+i)/angstr
         End Do
      End If
*
      GoTo 100

900   iSTDINP = iSTDINP + 2
      If (iSTDINP.LT.lSTDINP) Go to 10

      If (S%iAngMx.lt.0) Then
         Write (6,*) ' There is an error somewhere in the input!'
         Write (6,*) 'S%iAngMx.lt.'
         iErr=1
         Return
      End If
      Call mma_deallocate(Buffer)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  setMatrix
!
!> @brief
!>   Computes the rotation matrix of the rotation stored in the input quaternion
!> @author Y. Carissan
!>
!> @details
!> Computes the rotation matrix of the rotation stored in the input quaternion.
!>
!> @param[in] Q Input Quaternion
!***********************************************************************

subroutine setMatrix(Q)

use Quater_globals, only: debug, RotMatrix, matrixSet
use Constants, only: One, Two
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: Q(0:3)

RotMatrix(1,1) = Two*(Q(0)*Q(0)+Q(1)*Q(1))-One
RotMatrix(1,2) = Two*(Q(1)*Q(2)+Q(0)*Q(3))
RotMatrix(1,3) = Two*(Q(1)*Q(3)-Q(0)*Q(2))

RotMatrix(2,1) = Two*(Q(1)*Q(2)-Q(0)*Q(3))
RotMatrix(2,2) = Two*(Q(0)*Q(0)+Q(2)*Q(2))-One
RotMatrix(2,3) = Two*(Q(2)*Q(3)+Q(0)*Q(1))

RotMatrix(3,1) = Two*(Q(1)*Q(3)+Q(0)*Q(2))
RotMatrix(3,2) = Two*(Q(2)*Q(3)-Q(0)*Q(1))
RotMatrix(3,3) = Two*(Q(0)*Q(0)+Q(3)*Q(3))-One

matrixSet = .true.
if (debug) call RecPrt('Rotation Matrix',' ',RotMatrix,3,3)

return

end subroutine setMatrix

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine paras_calculate()
#include "drt_h.fh"
#include "paraconstants_h.fh"
#include "intsort_h.fh"
c      data inlptb_new/
!         1  2  3  4  5  6  7  8  9  10  11  12 13
c a^r=1
c     *    -1, 0, 0, 0, 0, 0,-7, 0,-9,-10,  0,-12, 0,
c a^l=2
c     *     0, 0, 0, 0, 0,-6, 0,-8, 0,  0,-11,  0, 0,
c b_r=3
c     *    4, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0, 0,
c b_l=4
c     *    5, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0, 0,
c b^r=5
c     *    0, 7, 8,10,11, 0, 0, 0, 0,  0,  0,  0, 0,
c b^l=6
c     *    0, 0, 9, 0,12, 0, 0, 0, 0,  0,  0,  0, 9,
c c^'=7
c     *    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 3,
c c^"=8
c     *    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12,13,
c d_l^r=9
c     *    6, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0, 0,
c d^r^r=10
c     *    0,-2, 0,-4, 0, 0, 0, 0, 0,  0,  0,  0, 0,
c d^r^l=11
c     *    0, 0,-3, 0,-5, 0, 0, 0, 0,  0,  0,  0, 0,
c c^'" =12
c     *    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 0/
!
!****************************************************************
!   ar      =1 (+a^r)     drr     =2 (+d^rr)   drl     =3 (+d^rl)
!   arbr    =4 (+d^rr)    arbl    =5 (+d^rl)   ard_l^r =6 (+a^l)
!   drrb^r  =7 (+a^r)     drlb^r  =8 (+a^l)    drlb^l  =9 (+a^r)
!   arbrb^r =10 (+a^r)    arblb^r =11 (+a^l)   arblb^l =12 (+a^r)
!   drl     =13 (*)
!****************************************************************

!     data inlptb_new
!    */ -1,  0,  4,  5,  0,  0,  1,  1,  6,  0,  0,  1,
!    *   0,  0,  0,  0,  7,  0,  2,  2,  0, -2,  0,  2,
!    *   0,  0,  0,  0,  8,  9,  3,  3,  0,  0, -3,  3,
!    *   0,  0,  0,  0, 10,  0,  4,  4,  0, -4,  0,  4,
!    *   0,  0,  0,  0, 11, 12,  5,  5,  0,  0, -5,  5,
!    *   0, -6,  0,  0,  0,  0,  6,  6,  0,  0,  0,  6,
!    *  -7,  0,  0,  0,  0,  0,  7,  7,  0,  0,  0,  7,
!    *   0, -8,  0,  0,  0,  0,  8,  8,  0,  0,  0,  8,
!    *  -9,  0,  0,  0,  0,  0,  9,  9,  0,  0,  0,  9,
!    * -10,  0,  0,  0,  0,  0, 10, 10,  0,  0,  0, 10,
!    *   0,-11,  0,  0,  0,  0, 11, 11,  0,  0,  0, 11,
!    * -12,  0,  0,  0,  0,  0, 12, 12,  0,  0,  0, 12,
!    *   0,  0,  0,  0,  0,  9,  3, 13,  0,  0,  0,  0/

!     data indord_plptype/0,0,0,1,1,3,3,1,1,2,2,2/   !severe_new_error_1
      dimension iwtsmsabtmp(maxgdm)
      ja_sys=int(n_electron*0.5d0-spin)-norb_dz
      jb_sys=int(spin+spin)
      jc_sys=norb_all-ja_sys-jb_sys
      jsm_sys=ns_sm
c      write(6,'(a9,3(1x,i3))') "ja,jb,jc ",ja_sys,jb_sys,jc_sys
!     if ( jb_sys.eq.jb_sys/2*2 ) then    ????? 11.2
!        w0_drl2_44=v_sqtwo
!        w0_drl2_1122=v_onevsqtwo
!     else
!        w0_drl2_44=-v_sqtwo
!        w0_drl2_1122=v_onevsqtwo
!     endif

      if ( jb_sys .eq.0 ) jroute_sys=1
      if ( jb_sys .eq.1 ) jroute_sys=2
      if ( jb_sys .gt.1 ) jroute_sys=3

      do i=1,ng_sm
      iwt_ext(i,1)=0
      iwt_ext(i,2)=nlsm_ext(i)
      enddo
      iwt_ext(1,1)=1
!
      do i=1,ng_sm
         ni=nlsm_ext(i)
      do j=i,ng_sm
         nj=nlsm_ext(j)
         if ( i.eq.j) then
            nij=ni*(ni-1)/2
         else
            nij=ni*nj
         endif
         ijsm=mul_tab(i,j)
         iwt_ext(ijsm,3)=iwt_ext(ijsm,3)+nij
         iwt_ext(ijsm,4)=iwt_ext(ijsm,4)+nij
      enddo
      enddo
      iwt_ext(1,4)=iwt_ext(1,4)+norb_ext

      do i=1,ng_sm
      iwt_dbl(i,1)=0
      iwt_dbl(i,2)=nlsm_dbl(mul_tab(i,jsm_sys))
      if ( jroute_sys .gt. 1 ) then
         iwt_dbl(i,3)=nlsm_dbl(mul_tab(i,jsm_sys))
      endif
      enddo
      iwt_dbl(ns_sm,1)=1
!
      do i=1,ng_sm
         ni=nlsm_dbl(i)
      do j=i,ng_sm
         nj=nlsm_dbl(j)
         if ( i.eq.j) then
            nij=ni*(ni-1)/2
         else
            nij=ni*nj
         endif
         ijsm=mul_tab(mul_tab(i,j),ns_sm)
         iwt_dbl(ijsm,4)=iwt_dbl(ijsm,4)+nij
      if ( jroute_sys .gt. 2 ) then
         iwt_dbl(ijsm,5)=iwt_dbl(ijsm,5)+nij
      endif
         iwt_dbl(ijsm,6)=iwt_dbl(ijsm,6)+nij
      if ( jroute_sys .gt. 1 ) then
         iwt_dbl(ijsm,6)=iwt_dbl(ijsm,6)+nij
      endif
      enddo
      enddo
      iwt_dbl(ns_sm,6)=iwt_dbl(ns_sm,6)+norb_dbl

!
      do ismb=1,ng_sm
         iwt_sm_sab(ismb)=0
      enddo
      do ismb=1,ng_sm
         ni=nlsm_ext(ismb)
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
         do isma=1,ismb
            nj=nlsm_ext(isma)
            if ( isma.eq.ismb) then
               nij=ni*(ni-1)/2
            else
               nij=ni*nj
            endif
            ijsm=mul_tab(isma,ismb)
!           iwt_sm_sab(ijsm)=iwt_sm_sab(ijsm)+nij
!           iwt_sm_sab fuction as a tmp array
            iwt_sm_ext(isma,ismb)=iwt_sm_sab(ijsm)

            iasta=ibsm_ext(isma)
            iaend=iesm_ext(isma)
            if ( ismb .eq. isma ) then
               ibsta=iasta+1
            endif
            iwttmp=iwt_sm_sab(ijsm)
            do iborb=ibsta,ibend
         do iaorb=iasta,min(iaend,iborb-1)
            iwttmp=iwttmp+1
!     if ( iaorb.le.0.or.iaorb.gt.max_extorb ) then
!     write(6,*)
!     endif
!     if ( iborb.le.0.or.iborb.gt.max_extorb ) then
!     write(6,*)
!     endif
            iwt_orb_ext(iaorb,iborb)=iwttmp
         enddo
         enddo

         iwt_sm_sab(ijsm)=iwt_sm_sab(ijsm)+nij
      enddo
      enddo
      iwt_sm_s_ext=iwt_sm_sab(1)

      isumtmp=0
      do ismb=1,ng_sm
         icnttmp=iwt_sm_sab(ismb)
         iwt_sm_sab(ismb)=isumtmp
         isumtmp=isumtmp+icnttmp
      enddo
!     imap_revorbtoorb_ext()
      do ismb=1,ng_sm
         ibsta=ibsm_ext(ismb)
         ibend=iesm_ext(ismb)
      do isma=1,ismb
         iasta=ibsm_ext(isma)
         iaend=iesm_ext(isma)
         if ( isma .eq. ismb ) iaend=iaend-1

         ismab=mul_tab(isma,ismb)
         iwttmp=iwt_sm_ext(isma,ismb)+iwt_sm_sab(ismab)
         do iaorb=iasta,iaend
         do iborb=max(iaorb+1,ibsta),ibend
            iwttmp=iwttmp+1
            iwt_revorb_ext(iaorb,iborb)=iwttmp
            imap_revorbtoorb_ext(iwttmp)=iwt_orb_ext(iaorb,iborb)
         enddo
         enddo
      enddo
      enddo

      do ismb=1,ng_sm
         iwt_sm_sab(ismb)=0
      enddo
      do ismb=1,ng_sm
         ni=nlsm_dbl(ismb)
         ibsta=ibsm_dbl(ismb)
         ibend=iesm_dbl(ismb)
      do isma=1,ismb
         nj=nlsm_dbl(isma)
         if ( isma.eq.ismb) then
            nij=ni*(ni-1)/2
         else
            nij=ni*nj
         endif
         ijsm=mul_tab(isma,ismb)
         iwt_sm_dbl(isma,ismb)=iwt_sm_sab(ijsm)

         iasta=ibsm_dbl(isma)
         iaend=iesm_dbl(isma)
         if ( ismb .eq. isma ) then
            ibsta=iasta+1
         endif
         iwttmp=iwt_sm_sab(ijsm)
         do iborb=ibsta,ibend
         do iaorb=iasta,min(iaend,iborb-1)
            iwttmp=iwttmp+1
            iwt_orb_dbl(iaorb,iborb)=iwttmp
         enddo
         enddo

         iwt_sm_sab(ijsm)=iwt_sm_sab(ijsm)+nij
      enddo
      enddo

      isumtmp=0
      do ismb=1,ng_sm
         icnttmp=iwt_sm_sab(ismb)
         iwtsmsabtmp(ismb)=isumtmp
         isumtmp=isumtmp+icnttmp
      enddo
!     imap_revorbtoorb_dbl()
      do ismb=1,ng_sm
         ibsta=ibsm_dbl(ismb)
         ibend=iesm_dbl(ismb)
      do isma=1,ismb
         iasta=ibsm_dbl(isma)
         iaend=iesm_dbl(isma)
         if ( isma .eq. ismb ) iaend=iaend-1
         ismab=mul_tab(isma,ismb)
         iwttmp=iwt_sm_dbl(isma,ismb)+iwtsmsabtmp(ismab)
         do iaorb=iasta,iaend
         do iborb=max(iaorb+1,ibsta),ibend
            iwttmp=iwttmp+1
            iwt_revorb_dbl(iaorb,iborb)=iwttmp
            imap_revorbtoorb_dbl(iwttmp)=iwt_orb_dbl(iaorb,iborb)
         enddo
         enddo
      enddo
      enddo

      do ism=1,ng_sm
         jsm=mul_tab(ism,ns_sm)
         if ( ism .lt. jsm ) then
            itmp=iwt_sm_sab(jsm)
            iwt_sm_sab(jsm)=iwt_sm_sab(ism)
            iwt_sm_sab(ism)=itmp
         endif
      enddo

      iwt_sm_s_dbl=iwt_sm_sab(ns_sm)
      if ( jroute_sys .gt. 2 ) then
         iwt_sm_s_dbl=iwt_sm_s_dbl*2
      endif
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine input_cvb()

use Index_Functions, only: nTri_Elem
use casvb_global, only: absym, confsinp, gsinp, i2s_fr, iciweights, icrit, imethod, initial, inputmode, iorbprm, ipr, iprec, &
                        isaddle, ishstruc, isympr, isymv, ityp, ivbweights, iwidth, kbasis, lfxvb, lzrvb, mnion, mnion_fr, mxaobf, &
                        mxion, mxion_fr, mxirrep, mxiter, mxorb_cvb, mxops, mxsyme, nalf, nalf_fr, nbet, nbet_fr, nconf, nconf_fr, &
                        nconfion_fr, ndetvb, ndetvb_fr, ndetvb2_fr, ndimrel, ndrot, nel, nel_fr, nfrag, nfxorb, nfxvb, nijrel, &
                        nMs_fr, noe, norb, norbrel, nort, npcf, nS_fr, nspinb, nsyme, nvb, nvbinp, nvbr_fr, nzrvb, ploc, projcas, &
                        projsym, recinp, recinp_old, recn_tmp01, recn_tmp02, savvb, savvbci, sc, service, sij, spinbkw, strtci, &
                        strtint, strtmo, strtvb, tags
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxINT
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, RtoI

implicit none
integer(kind=iwp) :: i, i2s_min, iconf_add, idum(1), ifrag, ifrom, ifsc, igroup, io, ioffs, iorb, ip_from, ip_to, iS, istr, istr2, &
                     isyme, isymput, itag, ito, jorb, kbasis_old, kbasiscvb_inp, ltmp, mxalter, mxdimrel, mxortl, mxpair, mxread, &
                     nelcheck, nfrorb1, nfxorb1, nmov, nops, nread
real(kind=wp) :: swap
logical(kind=iwp) :: DoCholesky
character(len=50) :: inpstr
integer(kind=iwp), allocatable :: idelstr(:), ifxorb(:), ifxstr(:), iorbrel(:), iorts(:,:), irdorbs(:), irots(:,:), izeta(:), &
                                  itmp(:), itmp2(:), itmp3(:,:)
real(kind=wp), allocatable :: orbs(:,:), symelm(:), tmp(:)
integer(kind=iwp), parameter :: nbuf = 50, ncmp = 4, ncrit = 2, nendvb = 3, nglob = 5, nmeth = 12, nspec = 3, nstrin = 51, nwkw = 5
character(len=*), parameter :: crit(ncrit) = ['OVERLAP ','ENERGY  '], &
                               endvb(nendvb) = ['ENDVB   ','ENDCASVB','END     '], &
                               glbl(nglob) = ['XXXXxxxx','START   ','GUESS   ','PRINT   ','PREC    '], &
                               methkw(nmeth) = ['FLETCHER','TRIM    ','TRUSTOPT','DAVIDSON','STEEP   ','VB2CAS  ','AUGHESS ', &
                                                'AUG2    ','CHECK   ','DFLETCH ','NONE    ','SUPER   '], &
                               specl(nspec) = ['SERVICE ','MOSCOW  ','PERFLOC '], &
                               string(nstrin) = ['XXXXxxxx','XXXXxxxx','SAVE    ','XXXXxxxx','ORBPERM ','COUPLE  ','MAXITER ', &
                                                 'CRIT    ','CASPROJ ','PROJCAS ','NOCASPRO','NOPROJCA','XXXXxxxx','XXXXxxxx', &
                                                 'SYMELM  ','ORBREL  ','XXXXxxxx','SYMPROJ ','NOSYMPRO','FIXORB  ','FIXSTRUC', &
                                                 'DELSTRUC','FREORB  ','FRESTRUC','ORTHCON ','SADDLE  ','SHSTRUC ','VBWEIGHT', &
                                                 'CIWEIGHT','SCORR   ','NOSCORR ','METHOD  ','OPTIM   ','OPT     ','ENDOPTIM', &
                                                 'REPORT  ','ENDREPOR','XXXXxxxx','TUNE    ','XXXXxxxx','OPPOSITE','XXXXxxxx', &
                                                 'XXXXxxxx','STAT    ','INIT    ','NOINIT  ','TIDY    ','PLOC    ','NOPLOC  ', &
                                                 'ALTERNAT','ENDALTER'], &
                               weightkw(nwkw) = ['CHIRGWIN','LOWDIN  ','INVERSE ','NONE    ','ALL     ']
integer(kind=iwp), external :: nvb_cvb
logical(kind=iwp), external :: firsttime_cvb, valid_cvb ! ... Files/Hamiltonian available ...

call mma_allocate(ifxorb,mxorb_cvb,label='ifxorb')
call mma_allocate(izeta,mxsyme,label='izeta')

noe = 2*mxorb_cvb
mxpair = nTri_Elem(mxorb_cvb)
mxdimrel = mxpair*(3+mxops)

call hini_cvb()

call defs_cvb()
call casinfodef_cvb()

! Counters
nconf = 0
nvbinp = 0
nsyme = 0
norbrel = 0
ndimrel = 0
nijrel = 0
nfxorb = 0
nfxvb = 0
nzrvb = 0
nort = 0
ndrot = 0
lfxvb = 0
lzrvb = 0
call maxdims0_cvb()
ifxorb(:) = 0
izeta(:) = 0
nfrag = 0

call mma_allocate(iorbrel,mxdimrel,label='iorbrel')
call mma_allocate(iorts,2,mxpair,label='iorts')
call mma_allocate(irots,2,mxpair,label='irots')
call mma_allocate(irdorbs,mxorb_cvb,label='irdorbs')
call mma_allocate(orbs,mxaobf,mxorb_cvb,label='orbs')
irdorbs(:) = 0
orbs(:,:) = Zero

call DecideOnCholesky(DoCholesky)
if (DoCholesky) then
  write(u6,*) '** Cholesky or RI/DF not yet implemented in CASVB **'
  call abend_cvb()
end if

call fstring_cvb(specl,nspec,istr,ncmp,2)
if (istr == 1) then
  ! 'SERVICE'
  service = .true.
  write(u6,'(1x,a,/)') '**** Service mode **** '
  !call service_cvb()
  write(u6,*) ' Casvb dummy routine called : SERV'
else if (istr == 2) then
  ! 'MOSCOW'
  service = .true.
  write(u6,'(1x,a,/)') '**** MOSCOW mode **** '
  !call moscow_cvb()
  write(u6,*) ' Casvb dummy routine called : MOSCOW'
else if (istr == 3) then
  service = .true.
  write(u6,'(1x,a,/)') '**** PERFLOC mode **** '
  !call perfloc_plc(3)
  write(u6,*) ' Molint dummy routine called : perfloc_plc'
else

  do

    ! CASSCF wavefunction information:
    call casinfoinp_cvb()
    ! VB wavefunction information:
    call fraginp_cvb()

    igroup = 0
    call fstring_cvb(glbl,nglob,istr,ncmp,2)
    if (istr /= 0) then
      igroup = 1
    else
      call fstring_cvb(string,nstrin,istr,ncmp,2)
      if (istr /= 0) then
        igroup = 2
      else
        call fstring_cvb(endvb,nendvb,istr,ncmp,2)
        if (istr /= 0) igroup = 3
      end if
    end if
    if (igroup == 3) then
      ! 'ENDVB', 'ENDCASVB' or 'END'
      istr = 0
    end if

    if (igroup /= 2) then
      if (istr == 2) then
        ! 'START'
        strtvb = Zero
        do
          call string_cvb(inpstr,1,nread,1)
          if (nread /= 1) exit
          if (inpstr(1:3) == 'CI=') then
            call setfn_cvb(strtci,inpstr(4:50))
          else if (inpstr(1:3) == 'VB=') then
            call setfn_cvb(strtvb,inpstr(4:50))
          else if (inpstr(1:3) == 'MO=') then
            call setfn_cvb(strtmo,inpstr(4:50))
          else if (inpstr(1:4) == 'INT=') then
            call setfn_cvb(strtint,inpstr(5:50))
          else
            exit
          end if
        end do
        if (valid_cvb(strtvb) .and. firsttime_cvb()) call touch_cvb('STRTGS')
      else if (istr == 3) then
        ! 'GUESS'
        call gsinp_cvb(orbs,irdorbs,nvbinp,kbasiscvb_inp,mxaobf,mxorb_cvb,kbasis,strtvb)
      else if (istr == 4) then
        ! 'PRINT'
        call int_cvb(ipr,10,nread,1)
      else if (istr == 5) then
        ! 'PREC'
        call int_cvb(idum,1,nread,1)
        iprec = idum(1)
        if (iprec < 0) then
          write(u6,*) ' Illegal precision :',iprec
          call abend_cvb()
        end if
        call int_cvb(idum,1,nread,1)
        iwidth = idum(1)
        call formats_cvb()
      end if

      ! 'ENDVB', 'ENDCASVB', 'END' or unrecognized keyword -- end of input:
      if (istr /= 0) cycle
    end if

    if (istr == 1) then
    else if (istr == 2) then
    else if (istr == 3) then
      ! 'SAVE'
      do
        call string_cvb(inpstr,1,nread,1)
        if (nread /= 1) exit
        if (inpstr(1:5) == 'VBCI=') then
          call setfn_cvb(savvbci,inpstr(6:50))
        else if (inpstr(1:3) == 'VB=') then
          call setfn_cvb(savvb,inpstr(4:50))
        else
          exit
        end if
      end do
    else if (istr == 4) then
    else if (istr == 5) then
      ! 'ORBPERM'
      if (firsttime_cvb()) call touch_cvb('ORBPERM')
      call int_cvb(iorbprm,mxorb_cvb,nread,0)
      if (nread > mxorb_cvb) then
        write(u6,*) ' Too many orbitals in ORBPERM keyword!'
        call abend_cvb()
      end if
      do iorb=1,nread
        if ((abs(iorbprm(iorb)) < 1) .or. (abs(iorbprm(iorb)) > mxorb_cvb)) then
          write(u6,'(a,40i3)') ' Illegal orbital label(s) in ORBPERM:',(iorbprm(io),io=1,nread)
          call abend_cvb()
        end if
      end do
    else if (istr == 6) then
      ! 'COUPLE'
      kbasis_old = kbasis
      call fstring_cvb(spinbkw,nspinb,kbasis,ncmp,1)
      if (kbasis == 0) kbasis = kbasis_old
      if (kbasis == 7) kbasis = 6
    else if (istr == 7) then
      ! 'MAXITER'
      call int_cvb(idum,1,nread,0)
      mxiter = idum(1)
    else if (istr == 8) then
      ! 'CRIT'
      call fstring_cvb(crit,ncrit,icrit,ncmp,1)
      if ((icrit /= 1) .and. (icrit /= 2)) then
        write(u6,*) ' Unrecognized CRIT keyword!'
        call abend_cvb()
      end if
    else if ((istr == 9) .or. (istr == 10)) then
      ! 'CASPROJ' or 'PROJCAS'
      projcas = .true.
    else if ((istr == 11) .or. (istr == 12)) then
      ! 'NOCASPROJ' or 'NOPROJCAS'
      projcas = .false.
    else if (istr == 15) then
      ! 'SYMELM'
      nsyme = nsyme+1
      if (nsyme > mxsyme) then
        write(u6,*) ' Too many symmetry elements found :',nsyme,mxsyme
        call abend_cvb()
      end if
      call mma_allocate(tmp,mxorb_cvb*mxorb_cvb*nsyme,label='symelm')
      if (allocated(symelm)) then
        tmp(1:mxorb_cvb*mxorb_cvb*(nsyme-1)) = symelm(:)
        call mma_deallocate(symelm)
      end if
      call move_alloc(tmp,symelm)
      call symelminp_cvb(symelm,nsyme,tags,izeta,mxirrep,mxorb_cvb,mxsyme,ityp)
    else if (istr == 16) then
      ! 'ORBREL'
      iorb = 0
      jorb = 0
      call int_cvb(idum,1,nread,1)
      iorb = idum(1)
      call int_cvb(idum,1,nread,1)
      jorb = idum(1)
      if ((iorb < 1) .or. (iorb > mxorb_cvb) .or. (jorb < 1) .or. (jorb > mxorb_cvb)) then
        write(u6,*) ' Illegal orbital number(s) in ORBREL:',iorb,jorb
        call abend_cvb()
      end if
      iorbrel(1+ndimrel) = iorb
      iorbrel(2+ndimrel) = jorb
      nops = 0
      do
        call fstring_cvb(tags,nsyme,itag,3,1)
        if (itag == 0) exit
        nops = nops+1
        if (ndimrel+3+nops > mxdimrel) then
          write(u6,*) ' Too many symmetry elements in ORBREL keyword!'
          call abend_cvb()
        end if
        iorbrel(nops+3+ndimrel) = itag
      end do
      iorbrel(3+ndimrel) = nops
      norbrel = norbrel+1
      ndimrel = ndimrel+3+nops
    else if (istr == 18) then
      ! 'SYMPROJ'
      projsym = .true.
      isympr(:) = 0
      call int_cvb(idum,1,nread,1)
      isymput = idum(1)
      if (nread == 1) then
        isympr(isymput) = 1
        do
          call int_cvb(idum,1,nread,1)
          isymput = idum(1)
          if (nread /= 1) exit
          isympr(isymput) = 1
        end do
      else
        isympr(:) = isymv(:)
      end if
    else if (istr == 19) then
      ! 'NOSYMPROJ'
      projsym = .false.
    else if (istr == 20) then
      ! 'FIXORB'
      call mma_allocate(itmp,mxorb_cvb,label='itmp')
      ltmp = -1
      call intchk_cvb(itmp,mxorb_cvb,nfxorb,0,'FIXORB',ltmp)
      ifxorb(:) = 0
      do i=1,nfxorb
        ifxorb(itmp(i)) = 1
      end do
      call mma_deallocate(itmp)
    else if (istr == 21) then
      ! 'FIXSTRUC'
      lfxvb = 0
      call mma_maxINT(mxread)
      mxread = mxread/2
      call mma_allocate(itmp,mxread,label='itmp')
      call intchk_cvb(itmp,mxread,nfxvb,0,'FIXSTRUC',lfxvb)
      call mma_allocate(ifxstr,nfxvb,label='ifxstr')
      ifxstr(:) = itmp(1:nfxvb)
      call mma_deallocate(itmp)
    else if (istr == 22) then
      ! 'DELSTRUC'
      lzrvb = 0
      call mma_maxINT(mxread)
      mxread = mxread/2
      call mma_allocate(itmp,mxread,label='itmp')
      call intchk_cvb(itmp,mxread,nzrvb,0,'DELSTRUC',lzrvb)
      call mma_allocate(idelstr,nzrvb,label='idelstr')
      idelstr(:) = itmp(1:nzrvb)
      call mma_deallocate(itmp)
    else if (istr == 23) then
      ! 'FREORB' - not implemented
      call mma_allocate(itmp,mxorb_cvb,label='itmp')
      ltmp = -1
      call intchk_cvb(itmp,mxorb_cvb,nfrorb1,0,'FREORB',ltmp)
      call mma_allocate(itmp2,mxorb_cvb,label='itmp2')
      itmp2(:) = 0
      do i=1,nfrorb1
        itmp2(itmp(i)) = 1
      end do
      nfxorb1 = 0
      do i=1,mxorb_cvb
        if (itmp2(i) == 1) then
          nfxorb1 = nfxorb1+1
          itmp(nfxorb1) = i
        end if
      end do
      call mma_deallocate(itmp)
      nfxorb = max(nfxorb,nfxorb1)
    else if (istr == 24) then
      ! 'FRESTRUC' - not implemented (and code incomplete)
      lfxvb = 1
      call mma_maxINT(mxread)
      mxread = mxread/2
      call mma_allocate(itmp,mxread,label='itmp')
      call intchk_cvb(itmp,mxread,nfxvb,0,'FRESTRUC',lfxvb)
      call mma_allocate(ifxstr,nfxvb,label='ifxstr')
      ifxstr(:) = itmp(1:nfxvb)
      call mma_deallocate(itmp)
    else if (istr == 25) then
      ! 'ORTHCON'
      mxortl = 40
      call orthcon_cvb(iorts,mxortl,mxpair)
    else if (istr == 26) then
      ! 'SADDLE'
      call int_cvb(idum,1,nread,1)
      isaddle = idum(1)
    else if (istr == 27) then
      ! 'SHSTRUC'
      ishstruc = 1
    else if (istr == 28) then
      ! 'VBWEIGHT'
      ivbweights = 0
      do
        call fstring_cvb(weightkw,nwkw,istr2,ncmp,1)
        if (istr2 == 1) then
          if (mod(ivbweights,2) == 0) ivbweights = ivbweights+1
        else if (istr2 == 2) then
          if (mod(ivbweights,4) <= 1) ivbweights = ivbweights+2
        else if (istr2 == 3) then
          if (mod(ivbweights,8) <= 3) ivbweights = ivbweights+4
        else if (istr2 == 4) then
          ivbweights = 0
        else if (istr2 == 5) then
          ivbweights = 7
        end if
        if (istr2 <= 0) exit
      end do
    else if (istr == 29) then
      ! 'CIWEIGHT'
      npcf = 10
      iciweights = 0
      do
        call fstring_cvb(weightkw,nwkw,istr2,ncmp,1)
        if (istr2 == 1) then
          iciweights = ibset(iciweights,0)
        else if (istr2 == 2) then
          iciweights = ibset(iciweights,1)
        else if (istr2 == 3) then
          iciweights = ibset(iciweights,2)
        else if (istr2 == 4) then
          iciweights = 0
        else if (istr2 == 5) then
          iciweights = ibset(ibset(ibset(0,0),1),2)
        end if
        if (istr2 <= 0) exit
      end do
      call int_cvb(idum,1,nread,1)
      npcf = idum(1)
    else if (istr == 30) then
      ! 'SCORR'
      sij = .true.
    else if (istr == 31) then
      ! 'NOSCORR'
      sij = .false.
    else if (istr == 32) then
      ! 'METHOD'
      call fstring_cvb(methkw,nmeth,istr2,ncmp,1)
      if (istr2 /= 0) imethod = istr2
    else if ((istr == 33) .or. (istr == 34)) then
      ! 'OPTIM' or 'OPT'
      call maxdims_cvb()
      call loopcntr_cvb(1)
    else if (istr == 35) then
      ! 'ENDOPTIM'
      call maxdims_cvb()
      call loopcntr_cvb(2)
    else if (istr == 36) then
      ! 'REPORT '
      call maxdims_cvb()
      call loopcntr_cvb(3)
    else if (istr == 37) then
      ! 'ENDREPOR'
      call maxdims_cvb()
      call loopcntr_cvb(4)
    else if (istr == 39) then
      ! 'TUNE'
      call tuneinp_cvb()
    else if (istr == 41) then
      ! 'OPPOSITE'
      ! very good, but useless because this variable is unused
      !opposite = .true.
    else if (istr == 44) then
      ! 'STAT'
      if (firsttime_cvb()) call touch_cvb('STAT')
    else if (istr == 45) then
      ! 'INIT'
      initial = 1
    else if (istr == 46) then
      ! 'NOINIT'
      initial = 0
    else if (istr == 47) then
      ! 'TIDY'
    else if (istr == 48) then
      ! 'PLOC'
      ploc = .true.
    else if (istr == 49) then
      ! 'NOPLOC'
      ploc = .false.
    else if (istr == 50) then
      ! 'ALTERN'
      mxalter = 50
      call int_cvb(idum,1,nread,1)
      mxalter = idum(1)
      call loopcntr2_cvb(5,mxalter)
    else if (istr == 51) then
      ! 'ENDALTER'
      call loopcntr_cvb(6)
    end if

    ! 'ENDVB', 'ENDCASVB', 'END' or unrecognized keyword -- end of input:
    if (istr == 0) exit

  end do

end if

call mma_allocate(ifxstr,0,label='ifxstr',safe='*')
call mma_allocate(idelstr,0,label='ifxstr',safe='*')
call mma_allocate(symelm,0,label='symelm',safe='*')
call mma_allocate(gsinp,0,label='gsinp',safe='*')
call mma_allocate(confsinp,0,0,label='confsinp',safe='*')

if (inputmode == 2) then
  ! Input parsing complete for this step ...
  ! ... Work out NORB, NEL, S ...
  call casinfoset_cvb()
  ! ... Do ICONFS before others to get NVB and related info ...
  if (nconf > 0) then
    call mma_allocate(itmp3,noe,nconf,label='confsinp')
    itmp3(:,:) = confsinp(1:noe,:)
    call mma_deallocate(confsinp)
    call move_alloc(itmp3,confsinp)
  end if

  if (nfrag <= 1) then
    nMs_fr(1) = 1
    nalf_fr(1,1) = nalf
    nbet_fr(1,1) = nbet
  else
    nMs_fr(1:nfrag) = 1
    nalf_fr(1,1:nfrag) = (nel_fr(1:nfrag)+i2s_fr(1,1:nfrag))/2
    nbet_fr(1,1:nfrag) = nel_fr(1:nfrag)-nalf_fr(1,1:nfrag)
  end if
  if (nfrag == 0) then
    nfrag = 1
    nel_fr(1) = nel
    nconf_fr(1) = nconf
    nS_fr(1) = 1
    i2s_fr(1,1) = nalf-nbet
  end if
  do ifrag=1,nfrag
    if (nS_fr(ifrag) == 0) then
      nS_fr(ifrag) = 1
      i2s_fr(1,ifrag) = nalf-nbet
    end if
  end do
  iconf_add = 0
  do ifrag=1,nfrag
    if (nel_fr(ifrag) == 0) then
      nel_fr(ifrag) = nel
      nalf_fr(1,ifrag) = nalf
      nbet_fr(1,ifrag) = nbet
    end if
    if (nS_fr(ifrag) == 0) then
      nS_fr(ifrag) = 1
      i2s_fr(1,ifrag) = nalf-nbet
    end if
    if (nconf_fr(ifrag) == 0) then
      nconf = nconf+1
      nconf_fr(ifrag) = 1
      call mma_allocate(itmp3,noe,nconf,label='confsinp')
      if (nconf > 1) itmp3(:,1:nconf-1) = confsinp(:,:)
      call mma_deallocate(confsinp)
      call move_alloc(itmp3,confsinp)
      confsinp(:,iconf_add+2:) = confsinp(:,iconf_add+1:nconf-1)
      confsinp(:,iconf_add+1) = 0
      confsinp(1:min(nel_fr(ifrag),norb),iconf_add+1) = 1
      confsinp(1:nel_fr(ifrag)-norb,iconf_add+1) = 2
    end if
    call cnfcheck_cvb(confsinp(:,iconf_add+1),nconf_fr(ifrag),nel_fr(ifrag))
    call cnfini_cvb(confsinp(:,iconf_add+1),nconf_fr(ifrag),nel_fr(ifrag),nS_fr(ifrag),i2s_fr(1,ifrag),nMs_fr(ifrag), &
                    nalf_fr(1,ifrag),nvbr_fr(ifrag),ndetvb_fr(ifrag),ndetvb2_fr(ifrag),mnion_fr(ifrag),mxion_fr(ifrag), &
                    nconfion_fr(0,ifrag),ifsc)
    iconf_add = iconf_add+nconf_fr(ifrag)
  end do
  ndetvb = 0
  nelcheck = 0
  do i=1,nfrag
    ndetvb = ndetvb+ndetvb_fr(i)
    nelcheck = nelcheck+nel_fr(i)
  end do
  if (nelcheck /= nel) then
    write(u6,*) ' Error: total number of electrons in fragment wavefunctions :',nelcheck,' not equal to number of electrons ',nel
    call abend_cvb()
  end if
  sc = (nfrag == 1) .and. (ifsc == 1)
  ! Set absym and use just lowest spin value if spinbas=determinants:
  absym(1) = (nalf == nbet)
  do ifrag=1,nfrag
    i2s_min = nel_fr(ifrag)
    do iS=1,nS_fr(ifrag)
      if (i2s_fr(iS,ifrag) /= 0) then
        absym(1) = .false.
        exit
      end if
    end do
    if (kbasis == 6) then
      nS_fr(ifrag) = 1
      i2s_fr(1,ifrag) = i2s_min
    end if
  end do
  absym(2:5) = absym(1)
  nvb = nvb_cvb(kbasis)
  mnion = mnion_fr(1)
  mxion = mxion_fr(1)
  do i=2,nfrag
    mnion = min(mnion,mnion_fr(i))
    mxion = max(mxion,mxion_fr(i))
  end do
  ! ... Now remaining quantities that depend on NORB or NVB ...
  ! SYMELM
  ip_from = 1
  ip_to = 1
  do isyme=1,nsyme
    do iorb=1,norb
      if (ip_from /= ip_to) symelm(ip_to:ip_to+norb-1) = symelm(ip_from:ip_from+norb-1)
      ip_from = ip_from+mxorb_cvb
      ip_to = ip_to+norb
    end do
    ip_from = ip_from+(mxorb_cvb-norb)*mxorb_cvb
  end do
  ! IORBREL
  ifrom = 1
  ito = 1
  do while (ifrom <= ndimrel)
    iorb = iorbrel(ifrom)
    jorb = iorbrel(ifrom+1)
    nmov = 3+iorbrel(ifrom+2)
    if ((iorb <= norb) .and. (jorb <= norb)) then
      if (ifrom /= ito) iorbrel(ito:ito+nmov-1) = iorbrel(ifrom:ifrom+nmov-1)
      ito = ito+nmov
    end if
    ifrom = ifrom+nmov
  end do
  ndimrel = ito-1
  ! IFXSTR
  ito = 0
  do ifrom=1,nfxvb
    if (ifxstr(ifrom) <= nvb) then
      ito = ito+1
      ifxstr(ito) = ifxstr(ifrom)
    end if
  end do
  nfxvb = ito
  ! IDELSTR
  ito = 0
  do ifrom=1,nzrvb
    if (idelstr(ifrom) <= nvb) then
      ito = ito+1
      idelstr(ito) = idelstr(ifrom)
    end if
  end do
  nzrvb = ito
  ! IORTS
  ito = 0
  do ifrom=1,nort
    if ((iorts(1,ifrom) <= norb) .and. (iorts(2,ifrom) <= norb)) then
      ito = ito+1
      iorts(1,ito) = iorts(1,ifrom)
      iorts(2,ito) = iorts(2,ifrom)
    end if
  end do
  nort = ito
  ! IROTS
  ! (bug? irots is not initialized!)
  ito = 0
  do ifrom=1,ndrot
    if ((irots(1,ifrom) <= norb) .and. (irots(2,ifrom) <= norb)) then
      ito = ito+1
      irots(1,ito) = irots(1,ifrom)
      irots(2,ito) = irots(2,ifrom)
    end if
  end do
  ndrot = ito
  ! Calling DEFS2 before INITOPT is required in order to set things such as ICRIT:
  call defs2_cvb(ifxorb)
  call initopt_cvb(icrit,lfxvb,nfxvb,iorts,nort,norb)

  call defs2_cvb(ifxorb)

  ! Try for new record
  !need = ihlf_cvb(nbuf)
  !need = need+3*ihlf_cvb(1)+ihlf_cvb(noe*nconf)+mxaobf*norb+ihlf_cvb(norb)+nvbinp+nsyme*norb*norb+ihlf_cvb(ndimrel)+ &
  !       ihlf_cvb(norb)+ihlf_cvb(nfxvb)+ihlf_cvb(nzrvb)+ihlf_cvb(2*nort)+ihlf_cvb(2*ndrot)+ihlf_cvb(2*ndrot)+ihlf_cvb(nsyme)
  if (recinp == Zero) then
    recinp = recn_tmp01
  else if (recinp_old == Zero) then
    recinp_old = recn_tmp01
    recinp = recn_tmp02
  else
    swap = recinp_old
    recinp_old = recinp
    recinp = swap
  end if
  !call reserv_cvb(need,recinp)
  ioffs = (nbuf+RtoI-1)/RtoI
  call wrioff_cvb(1,recinp,ioffs)
  call wris_cvb([noe],1,recinp,ioffs)
  call wrioff_cvb(2,recinp,ioffs)
  call wris_cvb([nconf],1,recinp,ioffs)
  call wrioff_cvb(3,recinp,ioffs)
  call wris_cvb([kbasiscvb_inp],1,recinp,ioffs)
  call wrioff_cvb(4,recinp,ioffs)
  call wris_cvb(confsinp,noe*nconf,recinp,ioffs)
  call wrioff_cvb(5,recinp,ioffs)
  call wrrs_cvb(orbs,mxaobf*norb,recinp,ioffs)
  call wrioff_cvb(6,recinp,ioffs)
  call wris_cvb(irdorbs,norb,recinp,ioffs)
  call wrioff_cvb(7,recinp,ioffs)
  call wrrs_cvb(gsinp,nvbinp,recinp,ioffs)
  call wrioff_cvb(8,recinp,ioffs)
  call wrrs_cvb(symelm,nsyme*norb*norb,recinp,ioffs)
  call wrioff_cvb(9,recinp,ioffs)

  call dset_cvb(iorbrel,ifxorb,ifxstr,idelstr,iorts,irots,izeta)
else
  call maxdims_cvb()
end if
call bufio_end_cvb()

call mma_deallocate(iorbrel)
call mma_deallocate(ifxorb)
call mma_deallocate(iorts)
call mma_deallocate(irots)
call mma_deallocate(izeta)
call mma_deallocate(irdorbs)
call mma_deallocate(orbs)

call mma_deallocate(ifxstr)
call mma_deallocate(idelstr)
call mma_deallocate(symelm)
call mma_deallocate(gsinp)
call mma_deallocate(confsinp)

return

end subroutine input_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996,1999, Niclas Forsberg                             *
!               1996,1999, Anders Bernhardsson                         *
!***********************************************************************

!module MatElMod

!  Contains:
!    MatrixElements (L,U,FC00,Hmat,C,W,r_diff,mMat,nMat,max_nOrd,energy,grad,Hess,D3,D4,G,Gprime,Gdbleprime,alpha1,alpha2,beta,
!                    max_term)
!    LSPotFit       (r01,energy1,grad1,Hess1,D3_1,D4_1,r02,energy2,grad2,Hess2,D3_2,D4_2,r00,energy0,r_min,FitCoef,mMat,stand_dev,
!                    max_err,use_weight,max_term,pot)
!    SetUpHmat      (energy0,r_min,ipow,var,yin,coef,r00,trfName,max_term,C1,W1,det1,r01,C2,W2,det2,r02,max_mOrd,max_nOrd,max_nOrd2,
!                    max_mInc,max_nInc,max_nInc2,mMat,nMat,mInc,nInc,mDec,nDec,L,U,H,S,G1,G2,G0,Gprime1,Gprime2,Gprime0,Gdbleprime1,
!                    Gdbleprime2,Gdbleprime0,C0,W0,det0,Mass,rOrigin)
!
!  Written by:
!    Niclas Forsberg & Anders Bernhardsson,
!    Dept. of Theoretical Chemistry, Lund University, 1996.
!    Dept. of Theoretical Chemistry, Lund University, 1999.

!contains

subroutine MatrixElements(L,U,FC00,Hmat,C,W,r_diff,nMat,iCre,iann,max_nOrd,max_mOrd,nOsc,energy,grad,Hess,D3,D4,G,Gprime, &
                          Gdbleprime,alpha1,alpha2,beta,max_term,Base)
!  Purpose:
!    Set up Hamilton matrix at a given center.
!
!  Input:
!
!  Output:
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use mula_global, only: ndim1, ndim2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nMat(0:ndim1,ndim2), icre(0:ndim1,ndim2), iann(0:ndim1,ndim2), max_nOrd, max_mOrd, nOsc, max_term
real(kind=wp), intent(out) :: Hmat(0:max_mOrd,0:max_nOrd)
real(kind=wp), intent(in) :: L(0:max_mOrd,0:max_mOrd), U(0:max_nOrd,0:max_nOrd), FC00, C(nOsc,nOsc), W(nOsc,nOsc), r_diff(nOsc), &
                             energy, grad(nOsc), Hess(nOsc,nOsc), D3(nOsc,nOsc,nOsc), D4(nOsc,nOsc,nOsc,nOsc), G(nOsc,nOsc), &
                             Gprime(nOsc,nOsc,nOsc), Gdbleprime(nOsc,nOsc,nOsc,nOsc), alpha1(nOsc,nOsc), alpha2(nOsc,nOsc), &
                             beta(nOsc,nOsc), Base(nOsc,nOsc)
integer(kind=iwp) :: i, mPlus, nOscOld, nPlus
real(kind=wp) :: det
real(kind=wp), allocatable :: A(:,:), Ctemp(:,:), rtemp1(:), temp(:,:), Wtemp(:,:)

! Initialize.
nOscOld = nOsc
mPlus = max_mOrd+1
nPlus = max_nOrd+1
call mma_allocate(A,[0,max_mOrd],[0,max_nOrd],label='A')
A(:,:) = Zero

call mma_allocate(Wtemp,nOscOld,nOsc,label='Wtemp')
call mma_allocate(Ctemp,nOsc,nOsc,label='Ctemp')
call mma_allocate(temp,nOsc,nOsc,label='temp')

call DGEMM_('N','N',nOscold,nOsc,nOsc,One,Base,nOscOld,W,nOsc,Zero,Wtemp,nOscold)
Ctemp(:,:) = Zero
do i=1,nOsc
  Ctemp(i,i) = One
end do
temp(:,:) = W
call Dool_MULA(temp,nOsc,nOsc,Ctemp,nOsc,nOsc,det)
call mma_deallocate(temp)

call mma_allocate(rtemp1,nOsc,label='rtemp1')
call DGEMM_('N','N',nOsc,1,nOsc,One,Ctemp,nOsc,r_diff,nOsc,Zero,rtemp1,nOsc)

call PotEnergy(A,nMat,iCre,iAnn,energy,grad,Hess,D3,D4,max_term,Wtemp,ndim1,ndim2,nOscOld)
!l_nMat_1 = ndim1
!l_nMat_2 = ndim2
call KinEnergy(A,nMat,iCre,iAnn,G,Gprime,Gdbleprime,max_term,C,W,alpha1,alpha2,beta,rtemp1,ndim1,ndim2,nOscOld)

! Calculate Hamilton matrix.
call mma_allocate(temp,[0,max_mOrd],[0,max_nOrd],label='temp')
call DGEMM_('N','T',mPlus,nPlus,nPlus,One,A,mPlus,U,nPlus,Zero,Temp,mPlus)
call DGEMM_('N','N',mPlus,nPlus,mPlus,FC00,L,mPlus,Temp,mPlus,Zero,Hmat,mPlus)

call mma_deallocate(A)
call mma_deallocate(Ctemp)
call mma_deallocate(Wtemp)
call mma_deallocate(temp)
call mma_deallocate(rtemp1)

end subroutine MatrixElements

subroutine LSPotFit(r01,energy1,grad1,Hess1,D3_1,D4_1,r02,energy2,grad2,Hess2,D3_2,D4_2,r00,energy0,r_min,FitCoef,mMat,max_term, &
                    pot,nOsc,numcoef)
!  Purpose:
!    Perform a least squares fit of the potential at two different centers, r01 and r02.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1996.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Ten, Pi, auTocm
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOsc, numcoef, max_term
integer(kind=iwp), intent(out) :: mMat(0:numcoef-1,nOsc)
real(kind=wp), intent(in) :: r01(nOsc), energy1, grad1(nOsc), Hess1(nOsc,nOsc), D3_1(nOsc,nOsc,nOsc), D4_1(nOsc,nOsc,nOsc,nOsc), &
                             r02(nOsc), energy2, grad2(nOsc), Hess2(nOsc,nOsc), D3_2(nOsc,nOsc,nOsc), D4_2(nOsc,nOsc,nOsc,nOsc), &
                             r00(nOsc), energy0, r_min(nOsc)
real(kind=wp), intent(out) :: FitCoef(numcoef,1)
logical(kind=iwp), intent(in) :: pot
integer(kind=iwp) :: i, ip, irow, iterm, ivar, j, jrow, jterm, jvar, k, krow, kvar, l, l_mMat, lrow, lvar, m, max_mInc, max_mOrd, &
                     mrow, mTabDim, mvar, n, nDim, nrow, nTabDim, nterm, nvar
real(kind=wp) :: det, pow, t
integer(kind=iwp), allocatable :: mDec(:,:), mInc(:,:)
real(kind=wp), allocatable :: Equmat(:,:), rhs(:), Temp(:,:), Tmat(:,:), vpow(:,:), weight(:,:), x(:)
integer(kind=iwp), parameter :: mxdeg = 6

! Initialize.
nvar = nOsc
mTabDim = numcoef-1
call TabDim(max_term,nOsc,nTabDim)
max_mOrd = nTabDim-1
call TabDim(max_term-1,nOsc,nTabDim)
max_mInc = nTabDim-1
call mma_allocate(mDec,[0,mTabDim],[1,nvar],label='mDec')
call mma_allocate(mInc,[0,mTabDim],[1,nvar],label='mInc')
l_mMat = nOsc
call MakeTab(max_term,max_mOrd,max_mInc,mMat,mInc,mDec,l_mMat)
nterm = max_mOrd+1

! Set up weight matrix and right hand side.
nDim = 2*nterm
!nDim = nVar*nterm !!!!
if (pot) nDim = nDim+1
call mma_allocate(rhs,nDim,label='rhs')

call mma_allocate(weight,nDim,nDim,label='weight')

weight(:,:) = Zero
n = 1
weight(n,n) = 1.0e4_wp
weight(n+nterm,n+nterm) = 1.0e4_wp
rhs(n) = energy1
rhs(n+nterm) = energy2
n = n+1
if (max_term > 0) then
  do i=1,nvar
    weight(n,n) = 1.0e3_wp
    weight(n+nterm,n+nterm) = 1.0e3_wp
    rhs(n) = grad1(i)
    rhs(n+nterm) = grad2(i)
    n = n+1
  end do
  if (max_term > 1) then
    do i=1,nvar
      do j=i,nvar
        weight(n,n) = 1.0e2_wp
        weight(n+nterm,n+nterm) = 1.0e2_wp
        rhs(n) = Hess1(i,j)
        rhs(n+nterm) = Hess2(i,j)
        n = n+1
      end do
    end do
    if (max_term > 2) then
      do i=1,nvar
        do j=i,nvar
          do k=j,nvar
            weight(n,n) = Ten
            weight(n+nterm,n+nterm) = Ten
            rhs(n) = D3_1(i,j,k)
            rhs(n+nterm) = D3_2(i,j,k)
            n = n+1
          end do
        end do
      end do
      if (max_term > 3) then
        do i=1,nvar
          do j=i,nvar
            do k=j,nvar
              do l=k,nvar
                weight(n,n) = One
                weight(n+nterm,n+nterm) = One
                rhs(n) = D4_1(i,j,k,l)
                rhs(n+nterm) = D4_2(i,j,k,l)
                n = n+1
              end do
            end do
          end do
        end do
      end if
    end if
  end if
end if
if (pot) then
  rhs(nDim) = energy0+2.0e4_wp/auTocm
  weight(nDim,nDim) = 1.0e4_wp
end if

call mma_allocate(vpow,[0,mxdeg],[1,nvar],label='vpow')
call mma_allocate(Tmat,nDim,nterm,label='Tmat')
Tmat(:,:) = Zero
call mma_allocate(x,nvar,label='x')

nrow = 1
do m=1,2
  mrow = 1
  if (m == 1) then
    x(:) = r01-r00
  else
    x(:) = r02-r00
  end if

  ! Calculate powers of individual variable values.
  do ivar=1,nvar
    pow = One
    vpow(0,ivar) = One
    do i=1,mxdeg
      pow = pow*x(ivar)
      vpow(i,ivar) = pow
    end do
  end do

  ! Calculate value of each polynomial term at this point.
  do iterm=1,nterm
    ip = mMat(iterm-1,1)
    t = vpow(ip,1)
    do ivar=2,nvar
      ip = mMat(iterm-1,ivar)
      t = t*vpow(ip,ivar)
    end do
    Tmat(nrow,iterm) = t
  end do
  mrow = mrow+1
  nrow = nrow+1

  ! First derivatives.
  if (max_term > 0) then
    do ivar=1,nvar
      do iterm=2,nterm
        irow = mDec(mrow-1,ivar)+1+((m-1)*(nDim/2))
        jvar = nvar
        do while ((mMat(iterm-1,jvar) == 0) .and. (jvar > 1))
          jvar = jvar-1
        end do
        jterm = mDec(iterm-1,jvar)+1
        Tmat(nrow,iterm) = x(jvar)*Tmat(nrow,jterm)
        if (ivar == jvar) then
          Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(irow,jterm)
        end if
      end do
      mrow = mrow+1
      nrow = nrow+1
    end do
  end if

  ! Second derivatives.
  if (max_term > 1) then
    do ivar=1,nvar
      do jvar=ivar,nvar
        do iterm=2,nterm
          irow = mDec(mrow-1,ivar)+1+((m-1)*(nDim/2))
          jrow = mDec(mrow-1,jvar)+1+((m-1)*(nDim/2))
          kvar = nvar
          do while ((mMat(iterm-1,kvar) == 0) .and. (kvar > 1))
            kvar = kvar-1
          end do
          jterm = mDec(iterm-1,kvar)+1
          Tmat(nrow,iterm) = x(kvar)*Tmat(nrow,jterm)
          if (ivar == kvar) then
            Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(irow,jterm)
          end if
          if (jvar == kvar) then
            Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(jrow,jterm)
          end if
        end do
        mrow = mrow+1
        nrow = nrow+1
      end do
    end do
  end if

  ! Third derivatives.
  if (max_term > 2) then
    do ivar=1,nvar
      do jvar=ivar,nvar
        do kvar=jvar,nvar
          do iterm=2,nterm
            irow = mDec(mrow-1,ivar)+1+((m-1)*(nDim/2))
            jrow = mDec(mrow-1,jvar)+1+((m-1)*(nDim/2))
            krow = mDec(mrow-1,kvar)+1+((m-1)*(nDim/2))
            lvar = nvar
            do while ((mMat(iterm-1,lvar) == 0) .and. (lvar > 1))
              lvar = lvar-1
            end do
            jterm = mDec(iterm-1,lvar)+1
            Tmat(nrow,iterm) = x(lvar)*Tmat(nrow,jterm)
            if (ivar == lvar) then
              Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(irow,jterm)
            end if
            if (jvar == lvar) then
              Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(jrow,jterm)
            end if
            if (kvar == lvar) then
              Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(krow,jterm)
            end if
          end do
          mrow = mrow+1
          nrow = nrow+1
        end do
      end do
    end do
  end if

  ! Fourth derivatives.
  if (max_term > 3) then
    do ivar=1,nvar
      do jvar=ivar,nvar
        do kvar=jvar,nvar
          do lvar=kvar,nvar
            do iterm=2,nterm
              irow = mDec(mrow-1,ivar)+1+((m-1)*(nDim/2))
              jrow = mDec(mrow-1,jvar)+1+((m-1)*(nDim/2))
              krow = mDec(mrow-1,kvar)+1+((m-1)*(nDim/2))
              lrow = mDec(mrow-1,lvar)+1+((m-1)*(nDim/2))
              mvar = nvar
              do while ((mMat(iterm-1,mvar) == 0) .and. (mvar > 1))
                mvar = mvar-1
              end do
              jterm = mDec(iterm-1,mvar)+1
              Tmat(nrow,iterm) = x(mvar)*Tmat(nrow,jterm)
              if (ivar == mvar) then
                Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(irow,jterm)
              end if
              if (jvar == mvar) then
                Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(jrow,jterm)
              end if
              if (kvar == mvar) then
                Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(krow,jterm)
              end if
              if (lvar == mvar) then
                Tmat(nrow,iterm) = Tmat(nrow,iterm)+Tmat(lrow,jterm)
              end if
            end do
            mrow = mrow+1
            nrow = nrow+1
          end do
        end do
      end do
    end do
  end if
end do

if (pot) then
  x(1) = r_min(1)-r00(1)
  x(2) = r_min(2)-r00(2)
  x(3) = Two*Pi-r_min(3)-r00(3)

  ! Calculate powers of individual variable values.
  do ivar=1,nvar
    pow = One
    vpow(0,ivar) = One
    do i=1,mxdeg
      pow = pow*x(ivar)
      vpow(i,ivar) = pow
    end do
  end do

  ! Calculate value of each polynomial term at this point.
  do iterm=1,nterm
    ip = mMat(iterm-1,1)
    t = vpow(ip,1)
    do ivar=2,nvar
      ip = mMat(iterm-1,ivar)
      t = t*vpow(ip,ivar)
    end do
    Tmat(nrow,iterm) = t
  end do
end if

! Calculate equation matrix, T(t)*weight*T, and T(t)*weight*rhs.
call mma_allocate(Temp,nterm,nDim,label='Temp')
call mma_allocate(Equmat,nterm,nterm,label='Equmat')

call DGEMM_('T','N',nterm,nDim,nDim,One,Tmat,nDim,weight,nDim,Zero,Temp,nterm)
call DGEMM_('N','N',nterm,nterm,nDim,One,Temp,nterm,Tmat,nDim,Zero,Equmat,nterm)

n = 2
if (max_term > 0) then
  do i=1,nvar
    n = n+1
  end do
  if (max_term > 1) then
    do i=1,nvar
      do j=i,nvar
        n = n+1
      end do
    end do
    if (max_term > 2) then
      do i=1,nvar
        do j=i,nvar
          do k=j,nvar
            Equmat(n,n) = Equmat(n,n)+0.1_wp
            n = n+1
          end do
        end do
      end do
      if (max_term > 3) then
        do i=1,nvar
          do j=i,nvar
            do k=j,nvar
              do l=k,nvar
                Equmat(n,n) = Equmat(n,n)+0.1_wp
                n = n+1
              end do
            end do
          end do
        end do
      end if
    end if
  end if
end if

call DGEMM_('N','N',nterm,1,nDim,One,Temp,nterm,rhs,nDim,Zero,FitCoef,nterm)

! Solve the resulting equation system.
call Dool_MULA(Equmat,nterm,nterm,FitCoef,nterm,nterm,det)

call mma_deallocate(weight)
call mma_deallocate(mDec)
call mma_deallocate(mInc)
call mma_deallocate(vpow)
call mma_deallocate(x)
call mma_deallocate(Tmat)
call mma_deallocate(rhs)
call mma_deallocate(Equmat)
call mma_deallocate(Temp)

end subroutine LSPotFit

subroutine SetUpHmat(energy0,r_min,ipow,var,yin,trfName,max_term,C1,W1,det1,r01,C2,W2,det2,r02,max_mOrd,max_nOrd,max_nOrd2, &
                     max_mInc,max_nInc,max_nInc2,mMat,nMat,mInc,nInc,mDec,nDec,H,S,G1,G2,G0,Gprime1,Gprime2,Gprime0,Gdbleprime1, &
                     Gdbleprime2,Gdbleprime0,det0,Base,r0,r1,r2,nterm,nvar,ndata,nOsc,nDimTot)
!  Purpose:
!    Set up Hamilton matrix.
!
!  Input:
!    Energy
!    r_min
!    ipow
!    var
!    yin
!    coeff
!    trfname
!    Max_term
!    C1,W1,det1,r01
!    C2,W2,det2,r02
!    H S
!    G1 G2 G0 1' G2' g0' g0'' g1'' g2''
!    det0
!
!  The expansion point for lspotfit is r00!!!!!

use mula_global, only: mdim1, mdim2, ndim1, ndim2, ngdim, nPolyTerm
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nterm, nvar, ipow(nterm,nvar), max_term, max_mOrd, max_nOrd, max_nOrd2, max_mInc, max_nInc, &
                                 max_nInc2, mMat(0:mdim1,mdim2), nMat(0:ndim1,ndim2), mInc(0:mdim1,mdim2), nInc(0:ndim1,ndim2), &
                                 mDec(0:mdim1,mdim2), nDec(0:ndim1,ndim2), ndata, nOsc, nDimTot
real(kind=wp), intent(in) :: energy0, r_min(nOsc), var(ndata,nvar), yin(ndata), C1(nOsc,nOsc), W1(nOsc,nOsc), det1, r01(nOsc), &
                             C2(nOsc,nOsc), W2(nOsc,nOsc), det2, r02(nOsc), G1(nOsc,nOsc), G2(nOsc,nOsc), G0(nOsc,nOsc), &
                             Gprime1(ngdim,ngdim,ngdim), Gprime2(ngdim,ngdim,ngdim), Gprime0(ngdim,ngdim,ngdim), &
                             Gdbleprime1(ngdim,ngdim,ngdim,ngdim), Gdbleprime2(ngdim,ngdim,ngdim,ngdim), &
                             Gdbleprime0(ngdim,ngdim,ngdim,ngdim), Base(nOsc,nOsc), r0(nOsc)
real(kind=wp), intent(out) :: H(nDimTot,nDimTot), S(nDimTot,nDimTot), det0, r1(nOsc), r2(nOsc)
character(len=80), intent(in) :: trfName(nvar)
integer(kind=iwp) :: i, j, l_C1, l_C2, l_r2, nOscOld, numCoef
real(kind=wp) :: energy, energy1, energy2, FC00, max_err, stand_dev
logical(kind=iwp) :: find_minimum, pot, use_weight
integer(kind=iwp), allocatable :: jPow(:,:)
real(kind=wp), allocatable :: alpha1(:,:), alpha2(:,:), beta(:,:), C(:,:), Coef(:), D3(:,:,:), D3_1(:,:,:), D3_2(:,:,:), &
                              D4(:,:,:,:), D4_1(:,:,:,:), D4_2(:,:,:,:), FitCoef(:), grad(:), grad1(:), grad2(:), &
                              Gdbleprimetemp(:,:,:,:), Gprimetemp(:,:,:), Gtemp(:,:), Hess(:,:), Hess1(:,:), Hess2(:,:), Hij(:,:), &
                              HijTrans(:,:), L(:,:), r_diff(:), r0vec(:), Sij(:,:), SijTrans(:,:), U(:,:), W(:,:)

! Initialize.
l_r2 = nOsc
find_minimum = .false.
use_weight = .false.
nOscOld = nOsc

call mma_allocate(Coef,nPolyTerm,label='Coef')
call mma_allocate(grad1,nOscOld,label='grad1')
call mma_allocate(grad2,nOscOld,label='grad2')
call mma_allocate(Hess1,nOscOld,nOscOld,label='Hess1')
call mma_allocate(Hess2,nOscOld,nOscOld,label='Hess2')
call mma_allocate(D3_1,nOscOld,nOscOld,nOscOld,label='D3_1')
call mma_allocate(D3_1,nOscOld,nOscOld,nOscOld,label='D3_1')
call mma_allocate(D4_2,nOscOld,nOscOld,nOscOld,nOscOld,label='D4_2')
call mma_allocate(D4_2,nOscOld,nOscOld,nOscOld,nOscOld,label='D4_2')

! Fit polynomial and calculate energy, gradient, Hessian and third
! and fourth order force constants around r01 and r02.
call PotFit(nterm,nvar,ndata,ipow,var,yin,Coef,r1,nOscOld,energy1,grad1,Hess1,D3_1,D4_1,trfName,stand_dev,max_err,find_minimum, &
            max_term,use_weight,nOscOld,nOscOld,nOscOld)
call PotFit(nterm,nvar,ndata,ipow,var,yin,Coef,r2,l_r2,energy2,grad2,Hess2,D3_2,D4_2,trfName,stand_dev,max_err,find_minimum, &
            max_term,use_weight,nOscOld,nOscOld,nOscOld)
call mma_deallocate(Coef)

! Perform a least squares fit.
call TabDim(max_term,nOsc,numCoef)
call mma_allocate(FitCoef,numCoef,label='FitCoef')

call mma_allocate(jPow,numCoef,nOsc,label='jPow')
pot = .true.
call LSPotFit(r1,energy1,grad1,Hess1,D3_1,D4_1,r2,energy2,grad2,Hess2,D3_2,D4_2,r0,energy0,r_min,FitCoef,jPow,max_term,pot,nOsc, &
              numcoef)

call mma_deallocate(grad1)
call mma_deallocate(grad2)
call mma_deallocate(Hess1)
call mma_deallocate(Hess2)
call mma_deallocate(D3_1)
call mma_deallocate(D3_2)
call mma_deallocate(D4_1)
call mma_deallocate(D4_2)

! For each of the centers:
! - Call Franck-Condon routine.
! - Calculate matrix elements.

call mma_allocate(Hij,[0,max_mOrd],[0,max_nOrd],label='Hij')
call mma_allocate(Sij,[0,max_mOrd],[0,max_nOrd],label='Sij')
call mma_allocate(r0vec,nOscOld,label='r0vec')
call mma_allocate(r_diff,nOscOld,label='r_diff')
call mma_allocate(C,nOsc,nOsc,label='C')
call mma_allocate(W,nOsc,nOsc,label='W')
call mma_allocate(grad,nOscOld,label='grad')
call mma_allocate(D3,nOscOld,nOscOld,nOscOld,label='D3')
call mma_allocate(D4,nOscOld,nOscOld,nOscOld,nOscOld,label='D4')
call mma_allocate(Gtemp,nOsc,nOsc,label='Gtemp')
call mma_allocate(Gprimetemp,nOsc,nOsc,nOsc,label='Gprimetemp')
call mma_allocate(Gdbleprimetemp,nOsc,nOsc,nOsc,nOsc,label='Gdbleprimetemp')
call mma_allocate(alpha1,nOsc,nOsc,label='alpha1')
call mma_allocate(alpha2,nOsc,nOsc,label='alpha2')
call mma_allocate(beta,nOsc,nOsc,label='beta')
call mma_allocate(L,[0,max_mOrd],[0,max_mOrd],label='L')
call mma_allocate(U,[0,max_nOrd],[0,max_nOrd],label='U')

! Block 11.
l_C1 = nOsc
call Calc_r00(C1,C1,C,W,alpha1,alpha2,r0vec,r01,r01,det0,det1,det1,FC00,l_C1)
call FCval(C1,W1,det1,r01,C1,W1,det1,r01,Sij,max_mOrd,max_nOrd,max_nOrd2,max_mInc,max_nInc,max_nInc2,mMat,nMat,mInc,nInc,mDec, &
           nDec,C,W,det1,L,U,FC00,alpha1,alpha2,beta,l_C1)
r0vec(1:nOsc) = r1-r0
call funcval(r0vec,FitCoef,jPow,energy,nterm,nvar)
call gradient(r0vec,FitCoef,jPow,grad,nterm,nvar)
call Hessian(r0vec,FitCoef,jPow,Hess,nterm,nvar)
call thirdDer(r0vec,FitCoef,jPow,D3,nterm,nvar)
call fourthDer(r0vec,FitCoef,jPow,D4,nterm,nvar)
energy = energy-energy0
r0vec(:) = Zero
r_diff(:) = Zero
Gtemp(:,:) = G1
GprimeTemp(:,:,:) = Gprime1
GdbleprimeTemp(:,:,:,:) = Gdbleprime1
call MatrixElements(L,U,FC00,Hij,C,W,r_diff,nMat,ninc,ndec,max_nOrd,max_mOrd,nOsc,energy,grad,Hess,D3,D4,Gtemp,GprimeTemp, &
                    GdbleprimeTemp,alpha1,alpha2,beta,max_term,Base)

H(1:max_mOrd+1,1:max_nOrd+1) = Hij
S(1:max_mOrd+1,1:max_nOrd+1) = Sij

! Block 22.
l_C2 = nOsc
call Calc_r00(C2,C2,C,W,alpha1,alpha2,r0vec,r02,r02,det0,det2,det2,FC00,l_C2)
call FCval(C2,W2,det2,r02,C2,W2,det2,r02,Sij,max_mOrd,max_nOrd,max_nOrd2,max_mInc,max_nInc,max_nInc2,mMat,nMat,mInc,nInc,mDec, &
           nDec,C,W,det2,L,U,FC00,alpha1,alpha2,beta,l_C2)
r0vec(1:nOsc) = r2-r0
call funcval(r0vec,FitCoef,jPow,energy,nterm,nvar)
call gradient(r0vec,FitCoef,jPow,grad,nterm,nvar)
call Hessian(r0vec,FitCoef,jPow,Hess,nterm,nvar)
call thirdDer(r0vec,FitCoef,jPow,D3,nterm,nvar)
call fourthDer(r0vec,FitCoef,jPow,D4,nterm,nvar)
energy = energy-energy0
r0vec(:) = Zero
r_diff(:) = Zero
Gtemp(:,:) = G2
GprimeTemp(:,:,:) = Gprime2
GdbleprimeTemp(:,:,:,:) = Gdbleprime2
call MatrixElements(L,U,FC00,Hij,C,W,r_diff,nMat,ninc,ndec,max_nOrd,max_mOrd,nOsc,energy,grad,Hess,D3,D4,Gtemp,GprimeTemp, &
                    GdbleprimeTemp,alpha1,alpha2,beta,max_term,Base)
H(max_mOrd+2:2*max_mOrd+2,max_nOrd+2:2*max_nOrd+2) = Hij
S(max_mOrd+2:2*max_mOrd+2,max_nOrd+2:2*max_nOrd+2) = Sij

! Block 12 and 21.
l_C1 = nOsc
call Calc_r00(C1,C2,C,W,alpha1,alpha2,r0vec,r01,r02,det0,det1,det2,FC00,l_C1)
call FCval(C1,W1,det1,r01,C2,W2,det2,r02,Sij,max_mOrd,max_nOrd,max_nOrd2,max_mInc,max_nInc,max_nInc2,mMat,nMat,mInc,nInc,mDec, &
           nDec,C,W,det0,L,U,FC00,alpha1,alpha2,beta,l_C1)
r0vec(:) = Zero
call funcval(r0vec,FitCoef,jPow,energy,nterm,nvar)
call gradient(r0vec,FitCoef,jPow,grad,nterm,nvar)
call Hessian(r0vec,FitCoef,jPow,Hess,nterm,nvar)
call thirdDer(r0vec,FitCoef,jPow,D3,nterm,nvar)
call fourthDer(r0vec,FitCoef,jPow,D4,nterm,nvar)
energy = energy-energy0
r0vec(:) = Zero
r_diff(1:nOsc) = r01-r02
Gtemp(:,:) = G0
GprimeTemp(:,:,:) = Gprime0
GdbleprimeTemp(:,:,:,:) = Gdbleprime0
call MatrixElements(L,U,FC00,Hij,C,W,r_diff,nMat,nInc,nDec,max_nOrd,max_mOrd,nOsc,energy,grad,Hess,D3,D4,Gtemp,GprimeTemp, &
                    GdbleprimeTemp,alpha1,alpha2,beta,max_term,Base)
H(1:max_mOrd+1,max_nOrd+2:2*max_nOrd+2) = Hij
S(1:max_mOrd+1,max_nOrd+2:2*max_nOrd+2) = Sij

call mma_allocate(HijTrans,[0,max_nOrd],[0,max_mOrd],label='HijTrans')
call mma_allocate(SijTrans,[0,max_nOrd],[0,max_mOrd],label='SijTrans')
do i=0,max_mOrd
  do j=0,max_nOrd
    HijTrans(j,i) = Hij(i,j)
    SijTrans(j,i) = Sij(i,j)
  end do
end do
H(max_mOrd+2:2*max_mOrd+2,1:max_nOrd+1) = HijTrans
S(max_mOrd+2:2*max_mOrd+2,1:max_nOrd+1) = SijTrans

call mma_deallocate(jPow)
call mma_deallocate(FitCoef)
call mma_deallocate(Hij)
call mma_deallocate(Sij)
call mma_deallocate(HijTrans)
call mma_deallocate(SijTrans)
call mma_deallocate(r0vec)
call mma_deallocate(r_diff)
call mma_deallocate(C)
call mma_deallocate(W)
call mma_deallocate(grad)
call mma_deallocate(Hess)
call mma_deallocate(D3)
call mma_deallocate(D4)
call mma_deallocate(Gtemp)
call mma_deallocate(Gprimetemp)
call mma_deallocate(Gdbleprimetemp)
call mma_deallocate(alpha1)
call mma_deallocate(alpha2)
call mma_deallocate(beta)
call mma_deallocate(L)
call mma_deallocate(U)

end subroutine SetUpHmat

!end module MatElMod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
C
      SUBROUTINE SOLVE(NN,UL,B,X)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION UL(NN,NN),B(*),X(*)
      COMMON /IPS/IPS(200)
      N=NN
      NP1=N+1
C
      IP=IPS(1)
      X(1)=B(IP)
      DO 2 I=2,N
       IP=IPS(I)
       IM1=I-1
       SUM=0.0D00
       DO 1 J=1,IM1
        SUM=SUM+UL(IP,J)*X(J)
1      CONTINUE
       X(I)=B(IP)-SUM
2     CONTINUE
      IP=IPS(N)
      X(N)=X(N)/UL(IP,N)
      DO 4 IBACK=2,N
       I=NP1-IBACK
C****  I GOES (N-1),...,1
       IP=IPS(I)
       IP1=I+1
       SUM=0.0D00
       DO 3 J=IP1,N
        SUM=SUM+UL(IP,J)*X(J)
3      CONTINUE
       X(I)=(X(I)-SUM)/UL(IP,I)
4     CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 11, 2022, created this file.               *
!*****************************************************************

! Subroutine relating to generalized 1-e density matrix (GD) called
! in CMSNewton
!     calculating GD with lucia.
subroutine CalcGD(GD,nGD)

use lucia_data, only: Dtmp, DStmp
use Lucia_Interface, only: Lucia_Util
use rasscf_global, only: iADR15, lRoots, NAC
use general_data, only: JOBIPH, NCONF
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nGD
real(kind=wp), intent(out) :: GD(nGD)
integer(kind=iwp) :: CIDisk1, CIDisk2, IOffNIJ1, IOffNIJ2, ipq, iqp, jRoot, kRoot, NAC2, p, q
real(kind=wp), allocatable :: SDtmp(:), TmpD(:)
real(kind=wp), allocatable, target :: VecL(:), VecR(:)

NAC2 = NAC**2
call mma_allocate(VecL,NConf,Label='VecL')
call mma_allocate(VecR,NConf,Label='VecR')
call mma_allocate(TmpD,NAC**2,Label='TmpD')
call mma_allocate(SDtmp,NAC**2,Label='SDtmp')
SDtmp(:) = DStmp(:)
TmpD(:) = DTmp(:)
CIDisk1 = IADR15(4)
do jRoot=1,lRoots
  call DDafile(JOBIPH,2,VecL,nConf,CIDisk1)
  CIDisk2 = IADR15(4)
  do kRoot=1,jRoot-1
    call DDafile(JOBIPH,2,VecR,nConf,CIDisk2)
    call Lucia_Util('Densi',CI_Vector=VecL(:),RVec=VecR(:))
    IOffNIJ1 = (lRoots*(jRoot-1)+kRoot-1)*NAC2
    IOffNIJ2 = (lRoots*(kRoot-1)+jRoot-1)*NAC2
    !write(u6,*) 'GD matrix',jRoot,kRoot
    !call RecPrt(' ',' ',Dtmp,NAC,NAC)
    GD(IOffNIJ1+1:IOffNIJ1+NAC2) = Dtmp(1:NAC2)
    do q=1,NAC
      do p=1,NAC
        ipq = (q-1)*NAC+p
        iqp = (p-1)*NAC+q
        GD(IOffNIJ2+iqp) = Dtmp(ipq)
        !GDMat(NIJ2,q,p) = Dtmp(q+(p-1)*NAC)
      end do
    end do
  end do
  kRoot = jRoot
  call DDafile(JOBIPH,2,VecR,nConf,CIDisk2)
  call Lucia_Util('Densi',CI_Vector=VecL(:),RVec=VecR(:))
  IOffNIJ1 = (lRoots+1)*(jRoot-1)*NAC2
  !write(u6,*) 'GD matrix',jRoot,kRoot
  !call RecPrt(' ',' ',Dtmp,NAC,NAC)
  GD(IOffNIJ1+1:IOffNIJ1+NAC2) = Dtmp(1:NAC2)
end do
DStmp(:) = SDtmp(:)
Dtmp(:) = TmpD(:)
call mma_deallocate(SDtmp)
call mma_deallocate(TmpD)
call mma_deallocate(VecL)
call mma_deallocate(VecR)

end subroutine CalcGD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT_T17(Ta,T,dimb,dimbe,no)
! this routine does:
! Ta(i,b',be',u) <- 2 T(be',b',u,i) - T(be',b',i,u)
!
! N.B. Qvajt odflaknute

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimb, dimbe, no
real(kind=wp), intent(out) :: Ta(no,dimb,dimbe,no)
real(kind=wp), intent(in) :: T(dimbe,dimb,no,no)
integer(kind=iwp) :: b, be, u

do u=1,no
  do be=1,dimbe
    do b=1,dimb
      Ta(:,b,be,u) = Two*T(be,b,u,:)-T(be,b,:,u)
    end do
  end do
end do

return

end subroutine MkT_T17

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Francesco Aquilante                              *
************************************************************************
      SUBROUTINE FNO_CASPT2(irc,nSym,nBas,nFro,nIsh,nAsh,nSsh,nDel,
     &                          vfrac,IFQCAN,DoMP2,EMP2,CMO,NCMO)
*****************************************************************************
*                                                                           *
*     Purpose:  setup of Frozen Natural Orbitals CASPT2 (FNO-CASPT2).       *
*                                                                           *
*     Author:   F. Aquilante  (Geneva, May  2008)                           *
*                                                                           *
*****************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "itmax.fh"
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
*
      Integer nBas(nSym),nFro(nSym),nIsh(nSym),nAsh(nSym),nSsh(nSym),
     &        nDel(nSym)
      Integer irc,IFQCAN
      Real*8  EMP2, vfrac
      Logical DoMP2
#include "chfnopt.fh"
*
      Integer ns_V(8), nAct(8)
      Integer lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
      Real*8  TrDP(8), TrDF(8)
*
      Real*8 CMO(*)
*
      irc=0
      MP2_small=.false.
*
*----------------------------------------------------------------------*
*     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
*----------------------------------------------------------------------*
*
      nBasT=0
      ntri=0
      nSQ=0
      nBmx=0
      mAsh=0
      nOrb=0
      nVV=0
      Do i=1,nSym
        nAct(i)=0
        ns_V(i)=0
        nBasT=nBasT+nBas(i)
        nOrb=nOrb+nFro(i)+nIsh(i)+nAsh(i)+nSsh(i)+nDel(i)
        ntri=ntri+nBas(i)*(nBas(i)+1)/2
        nSQ=nSQ+nBas(i)**2
        nVV=nVV+nSsh(i)**2
        nBmx=Max(nBmx,nBas(i))
        mAsh=Max(mAsh,nAsh(i))
      End Do
      IF(nBasT.GT.mxBas) then
       Write(6,'(/6X,A)')
     & 'The number of basis functions exceeds the present limit'
       Call Abend
      Endif
*
*
*----------------------------------------------------------------------*
*     Read the molecular orbitals from JobIph                          *
*----------------------------------------------------------------------*
      IF (IFQCAN.EQ.0) Then
         Write(6,'(/6X,A)')
     &   'Need pseudocanonical RASSCF orbitals. See OUTOrbitals keyword'
     & //' in RASSCF input section.'
         Call Abend
      EndIf
      CALL GETMEM('LCMO','ALLO','REAL',LCMO,2*NCMO)
      iCMO=LCMO+NCMO
* This is not the best solution, but I wanted to avoid having to rewrite
* the indexing code below just to use the CMO array directly
      call dcopy_(NCMO,CMO,1,WORK(LCMO),1)
      Call GetMem('Eorb','Allo','Real',ipOrbE,4*nOrb)
      Call Get_darray('RASSCF OrbE',Work(ipOrbE),nOrb)
      iAoff=0
      Do iSym=1,nSym
         ipOrbE_=ipOrbE+iAoff+nFro(iSym)+nIsh(iSym)
         Do k=0,nAsh(iSym)-1
            If (Work(ipOrbE_+k).lt.0.0d0) nAct(iSym)=nAct(iSym)+1
         End Do
         iAoff=iAoff+nBas(iSym)
      End Do
*
      nOA=0
      Do iSym=1,nSym  ! setup info
         lnOrb(iSym)=nBas(iSym)
         lnFro(iSym)=nFro(iSym)
         lnOcc(iSym)=nIsh(iSym)+nAct(iSym)
         nOA=nOA+lnOcc(iSym)
         lnVir(iSym)=nSsh(iSym)
         lnDel(iSym)=nDel(iSym)
      End Do
*
      ip_ZZ=ipOrbE
      ipEorb=ipOrbE+nOrb
      ip_Z=ipEorb
      kEOcc=ipEorb+nOrb
      kEVir=kEOcc+nOrb
      ioff=0
      joff=0
      koff=0
      Do iSym=1,nSym
         ifr=ipOrbE+ioff+nFro(iSym)
         ito=kEOcc+joff
         call dcopy_(lnOcc(iSym),Work(ifr),1,Work(ito),1)
         ifr=ipOrbE+ioff+nFro(iSym)+nIsh(iSym)+nAsh(iSym)
         ito=kEVir+koff
         call dcopy_(nSsh(iSym),Work(ifr),1,Work(ito),1)
         ioff=ioff+nBas(iSym)
         joff=joff+lnOcc(iSym)
         koff=koff+nSsh(iSym)
      End Do
      Call GetMem('Dmat','Allo','Real',ip_X,nVV+nOA)
      Call FZero(Work(ip_X),nVV+nOA)
      ip_Y = ip_X + nVV
*
      Call FnoCASPT2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,
     &                      ip_X,ip_Y)
      Call FZero(Work(iCMO),NCMO)
      iOff=0
      Do iSym=1,nSym
         kfr=LCMO+iOff+nBas(iSym)*nFro(iSym)
         kto=iCMO+iOff+nBas(iSym)*lnFro(iSym)
         call dcopy_(nBas(iSym)*lnOcc(iSym),Work(kfr),1,Work(kto),1)
         kfr=LCMO+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
         kto=kto+nBas(iSym)*lnOcc(iSym)
         call dcopy_(nBas(iSym)*lnVir(iSym),Work(kfr),1,Work(kto),1)
         iOff=iOff+nBas(iSym)**2
      End Do
      Call Check_Amp(nSym,lnOcc,lnVir,iSkip)
      If (iSkip.gt.0) Then
         Call ChoMP2_Drv(irc,Dummy,Work(iCMO),Work(kEOcc),Work(kEVir))
         If(irc.ne.0) then
           write(6,*) 'MP2 pseudodensity calculation failed !'
           Call Abend
         Endif
      Else
         write(6,*)
         write(6,*)'There are ZERO amplitudes T(ai,bj) with the given '
         write(6,*)'combinations of inactive and virtual orbitals !! '
         write(6,*)'Check your input and rerun the calculation! Bye!!'
         Call Abend
      Endif
*
*     Diagonalize the pseudodensity to get natural virtual orbitals
*     -------------------------------------------------------------
      iOff=0
      jOff=0
      Do iSym=1,nSym
         if (nSsh(iSym).gt.0) then
           jD=ip_X+iOff
*     Eigenvectors will be in increasing order of eigenvalues
           Call Eigen_Molcas(nSsh(iSym),Work(jD),Work(ip_Z),Work(ip_ZZ))
*     Reorder to get relevant eigenpairs first
           Do j=1,nSsh(iSym)/2
              Do i=1,nSsh(iSym)
                 lij=jD-1+nSsh(iSym)*(j-1)+i
                 kij=jD-1+nSsh(iSym)**2-(nSsh(iSym)*j-i)
                 tmp=Work(lij)
                 Work(lij)=Work(kij)
                 Work(kij)=tmp
              End Do
              tmp=Work(ip_Z-1+j)
              Work(ip_Z-1+j)=Work(ip_Z+nSsh(iSym)-j)
              Work(ip_Z+nSsh(iSym)-j)=tmp
           End Do
*
*     Compute new MO coeff. : X=C*U
           kfr=iCMO+jOff+nBas(iSym)*(nFro(iSym)+lnOcc(iSym))
           kto=LCMO+jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
           Call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym),
     &                        1.0d0,Work(kfr),nBas(iSym),
     &                              Work(jD),nSsh(iSym),
     &                        0.0d0,Work(kto),nBas(iSym))
           iOff=iOff+nSsh(iSym)**2
           TrDF(iSym)=ddot_(nSsh(iSym),Work(ip_Z),1,[1.0d0],0)
           ns_V(iSym)=int(vfrac*dble(nSsh(iSym)))
           TrDP(iSym)=ddot_(ns_V(iSym),Work(ip_Z),1,[1.0d0],0)
         endif
         jOff=jOff+nBas(iSym)**2
      End Do
      write(6,*)'------------------------------------------------------'
      write(6,*)'   Symm.     Trace     (Full Dmat)     (Partial Dmat) '
      write(6,*)'------------------------------------------------------'
      STrDF=0.0d0
      STrDP=0.0d0
      Do iSym=1,nSym
        write(6,'(4X,I4,15X,G13.6,4X,G13.6)') iSym,TrDF(iSym),TrDP(iSym)
        STrDF=STrDF+TrDF(iSym)
        STrDP=STrDP+TrDP(iSym)
      End Do
      write(6,*)'------------------------------------------------------'
      write(6,'(A,G13.6,4X,G13.6)')'   Sum :               ',STrDF,STrDP
      write(6,*)'------------------------------------------------------'
*
*     Update the nSsh, nDel for FNO-CASPT2
      Do iSym=1,nSym
         nDel(iSym)=nDel(iSym)+nSsh(iSym)-ns_V(iSym)
         nSsh(iSym)=ns_V(iSym)
      End Do
*
*     Write the resorted MOs back to JobIph
*
      IFQCAN=0 ! MOs need to be recanonicalized on exit
      call dcopy_(NCMO,WORK(LCMO),1,CMO,1)
*
*     Reset MP2_small for this new call to ChoMP2_Drv
      Call Check_Amp(nSym,lnOcc,nSsh,iSkip)
      MP2_small = DoMP2 .and. iSkip.gt.0
      If (MP2_small) Then
*
         Call FnoCASPT2_putInf(nSym,lnOrb,lnOcc,lnFro,nDel,nSsh,
     &                         ip_X,ip_Y)
*
         Call GetMem('iD_orb','Allo','Inte',ip_iD,nOrb)
         Do k=1,nOrb
            iWork(ip_iD-1+k) = k
         End Do
         lOff=0
         kOff=0
         jOff=0
         iOff=0
         Do iSym=1,nSym  ! canonical orb. in the reduced virtual space
            jD=ip_X+iOff
            Call Get_Can_Lorb(Work(kEVir+lOff),Work(ipOrbE+jOff),
     &                        nSsh(iSym),lnVir(iSym),
     &                        iWork(ip_iD),Work(jD))

            kfr=LCMO+kOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym)+nAsh(iSym))
            kto=iCMO+kOff+nBas(iSym)*(nFro(iSym)+lnOcc(iSym))
            nBx=Max(1,nBas(iSym))
            nSx=Max(1,nSsh(iSym))
            Call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym),
     &                         1.0d0,Work(kfr),nBx,
     &                               Work(jD),nSx,
     &                         0.0d0,Work(kto),nBx)

            lOff=lOff+lnVir(iSym)
            kOff=kOff+nBas(iSym)**2
            jOff=jOff+nSsh(iSym)
            iOff=iOff+lnVir(iSym)**2
         End Do
         Call GetMem('iD_orb','Free','Inte',ip_iD,nOrb)
         kEVir=ipOrbE
*
         EMP2=DeMP2
         DeMP2=0.0d0
         Call ChoMP2_Drv(irc,Dummy,Work(iCMO),Work(kEOcc),Work(kEVir))
         If(irc.ne.0) then
           write(6,*) 'MP2 in truncated virtual space failed !'
           Call Abend
         Endif
         EMP2 = -1.0d0*(EMP2-DeMP2)
      EndIf
      Call GetMem('Dmat','Free','Real',ip_X,nVV+nOA)
      Call GetMem('Eorb','Free','Real',ipOrbE,4*nOrb)
*
      CALL GETMEM('LCMO','FREE','REAL',LCMO,2*NCMO)
*
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      SubRoutine FnoCASPT2_putInf(mSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,
     &                            ip_X,ip_Y)
C
C     Purpose: put info in MP2 common blocks.
C
#include "implicit.fh"
      Integer lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
      Integer ip_X, ip_Y
C
#include "corbinf.fh"
#include "chomp2_cfg.fh"
C
C
      nSym = mSym
C
      Do iSym = 1,nSym
         nOrb(iSym) = lnOrb(iSym)
         nOcc(iSym) = lnOcc(iSym)
         nFro(iSym) = lnFro(iSym)
         nDel(iSym) = lnDel(iSym)
         nExt(iSym) = lnVir(iSym)
      End Do
C
      ChoAlg=2
      DecoMP2=Decom_Def
      ThrMP2=-9.9D9
      SpanMP2=Span_Def
      MxQualMP2=MxQual_Def
      ChkDecoMP2=.false.
      ForceBatch=.false.
      Verbose=.false.
      SOS_mp2=.false.
      set_cd_thr=.true.
      OED_Thr=1.0d-8
      C_os=1.3d0
      EOSMP2=0.0d0
C
      DoFNO=.true.
      ip_Dab=ip_X
      ip_Dii=ip_Y
      l_Dab=nExt(1)
      l_Dii=nOcc(1)
      Do iSym=2,nSym
         l_Dab=l_Dab+nExt(iSym)**2
         l_Dii=l_Dii+nOcc(iSym)
      End Do
C
      Return
      End

************************************************************************
*                                                                      *
************************************************************************
      Subroutine Check_Amp(nSym,nOcc,nVir,iSkip)

      Implicit Real*8 (a-h,o-z)
      Integer nSym, nOcc(nSym), nVir(nSym), iSkip
      Integer nT1amTot, nT1am(8)

      MulD2h(i,j)=iEor(i-1,j-1) + 1

      iSkip=0
      nT1amTot=0
      Do iSym = 1,nSym
         nT1am(iSym) = 0
         Do iSymi = 1,nSym
            iSyma = MulD2h(iSymi,iSym)
            nT1am(iSym) = nT1am(iSym)
     &                  + nVir(iSyma)*nOcc(iSymi)
         End Do
         nT1amTot = nT1amTot + nT1am(iSym)
      End Do

      If (nT1amTot .gt. 0) iSkip=1
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004, Thomas Bondo Pedersen                            *
!               2006, Francesco Aquilante                              *
!***********************************************************************

subroutine CD_InCore_1p(X,n,Vec,MxVec,NumCho,Thr,ThrNeg,ThrFail,iD,irc)
!
! Author:   F. Aquilante, March 2006
!
! Snicked from CD_InCore_1 :
!
! Thomas Bondo Pedersen, October 2004.
!
! Purpose: Cholesky decompose the n-by-n matrix X.
!          Vectors are returned in Vec array.
!
! Return code (irc):
!
!    0 -- decomposition success.
!  101 -- negative diagonal encountered (i.e. < ThrFail)
!  102 -- number of vectors needed exceeds max. allowed (MxVec)
!
! Note: the algorithm is designed for incomplete Cholesky
! decomposition, i.e. for semi-definite matrices, and thus makes
! use of level-1 BLAS only.
!
! Feature: In/Out argument iD(MxVec).
!          iD(k) on exit contains the index of the diagonal
!                from which the k-th Cholesky vector was generated

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, MxVec
real(kind=wp), intent(inout) :: X(n,n), Vec(n,MxVec)
integer(kind=iwp), intent(out) :: NumCho, iD(MxVec), irc
real(kind=wp), intent(in) :: Thr, ThrNeg, ThrFail
integer(kind=iwp) :: i, imax, iPass, j
real(kind=wp) :: Acc, xFac, Xmax

irc = 0

NumCho = 0
Acc = min(1.0e-12_wp,Thr*1.0e-2_wp)
xFac = Zero  ! dummy set
do iPass=1,n

  if (X(1,1) < ThrNeg) then
    if (X(1,1) < ThrFail) then
      irc = 101
      return
    else
      X(1:n,1) = Zero
      X(1,1:n) = Zero
    end if
  end if
  Xmax = Zero
  imax = 0
  do i=1,n
    if (X(i,i) < ThrNeg) then
      if (X(i,i) < ThrFail) then
        irc = 101
        return
      else
        X(1:n,i) = Zero
        X(i,1:n) = Zero
      end if
    end if
    if (X(i,i) > Xmax+Acc) then
      Xmax = X(i,i)
      imax = i
    end if
  end do

  if (Xmax <= Thr) return ! converged
  xFac = One/sqrt(abs(Xmax))

  if (NumCho == MxVec) then ! too many vectors
    irc = 102
    return
  end if

  do j=1,NumCho
    X(:,imax) = X(:,imax)-Vec(imax,j)*Vec(:,j)
  end do
  X(imax,imax) = Xmax

  NumCho = NumCho+1
  do i=1,n
    if (X(i,i) == Zero) then
      Vec(i,NumCho) = Zero
    else
      Vec(i,NumCho) = xFac*X(i,imax)
    end if
  end do

  do i=1,n
    X(i,i) = X(i,i)-Vec(i,NumCho)**2
  end do
  X(imax,imax) = Zero
  iD(NumCho) = imax

end do

end subroutine CD_InCore_1p

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Per-Olof Widmark                                 *
*               1993,1996,1997, Markus P. Fuelscher                    *
*               1996, Luis Serrano-Andres                              *
************************************************************************
      Subroutine DaName_WA(Lu,String)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Open unit Lu for direct access I/O and link the data stream to   *
*     the logical file name Name.                                      *
*                                                                      *
*     calling arguments:                                               *
*     Lu      : integer, input                                         *
*               logical unit number                                    *
*     Name    : character string, input                                *
*               logical file name                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, IBM Sweden, 1991                                   *
*     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
*     L. Serrano-Andres, University of Lund, Sweden, 1996              *
*                                                                      *
************************************************************************

      Character*(*) String
      Integer Lu
      Logical mf,wa
      mf=.false.
      wa=.true.
      Call Daname_Main(Lu, String, mf, wa)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Yan Zhao                                         *
************************************************************************
      Subroutine CVS98(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                 CoeffA,iSpin,F_xc,T_X,ijzy)
************************************************************************
*                                                                      *
*  CVS98 evaluates the correlation part of the VS98 and M06 suite of   *
*  functionals on a grid.                                              *
*  !!! Second derivatives are not available yet.                       *
*                                                                      *
*  Ref:  T. V. Voorhis and G. E. Scuseria, J. Chem. Phys. 109,         *
*        400 (1998).                                                   *
*       Y. Zhao and D. G. Truhlar, J. Chem. Phys. 125,                 *
*        194101 (2006).                                                *
*                                                                      *
*                                                                      *
*       ijzy - 1 correlation functional in VS98                        *
*       ijzy - 2 correlation functional in M06-L                       *
*       ijzy - 3 correlation functional in M06-HF                      *
*       ijzy - 4 correlation functional in M06                         *
*       ijzy - 5 correlation functional in M06-2X                      *
*                                                                      *
*  YZ (10/07)                                                          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
      Integer mGrid

      REAL*8 F6, F43, Pi34, F13,
     &RS,RSP,Zeta,dZdA,dZdB,PotLC,dLdS,dLdZ,d2LdSS,d2LdSZ,d2LdZZ,
     &  P, EUEG, EUEGPA,EUEGPB
      REAL*8 PA,GAA,TauA,FA,FPA,FGA,FTA,EUA,ChiA,EUPA,ChiAP,
     &ChiAG,ZA,ZAP,ZAT
      REAL*8 PB,GBB,TauB,FB,FPB,FGB,FTB,EUB,ChiB,EUPB,ChiBP,
     &ChiBG,ZB,ZBP,ZBT
      REAL*8 ZAB, XAB, kab, xk, zk
      REAL*8 dgdx,dgdz,dgdPA,dgdGA,dgdTA,dgdPB,dgdGB,dgdTB
      REAL*8 gcab,gab
      REAL*8 r7, r8, r9, r10, r11, r12


      REAL*8  DTol,F1, F3, F4
      Data F1/1.0d0/,F3/3.0d0/,F4/4.0d0/
     $,gab/0.00304966d0/

C     Parameters for VS98
      if (ijzy.eq.1) then
              r7=   7.035010d-01
              r8=   7.694574d-03
              r9=   5.152765d-02
              r10=   3.394308d-05
              r11=  -1.269420d-03
              r12=   1.296118d-03
C     Parameters for M06-L
      elseif (ijzy.eq.2) then
              r7=      3.957626D-01
              r8=      -5.614546D-01
              r9=      1.403963D-02
              r10=     9.831442D-04
              r11=     -3.577176D-03
              r12=     0.000000D+00
C     Parameters for M06-HF
      elseif (ijzy.eq.3) then
              r7=    -6.746338D-01
              r8=    -1.534002D-01
              r9=    -9.021521D-02
              r10=   -1.292037D-03
              r11=   -2.352983D-04
              r12=   0.000000D+00

C     Parameters for M06
      elseif (ijzy.eq.4) then
               r7= -2.741539D+00
               r8= -6.720113D-01
               r9= -7.932688D-02
               r10=1.918681D-03
               r11=-2.032902D-03
               r12=0.000000D+00

C     Parameters for M06-2X
      elseif (ijzy.eq.5) then
              r7=  1.166404D-01
              r8=  -9.120847D-02
              r9=  -6.726189D-02
              r10= 6.720580D-05
              r11= 8.448011D-04
              r12= 0.000000D+00
      endif

      F6=6.0d0
      F43 = F4 / F3
      Pi34 = F3 / (F4*Pi)
      F13 = F1 / F3
      DTol = T_X
      Ta=0.5D0*T_X
*                                                                      *
************************************************************************
*                                                                      *
      If (iSpin.eq.1) Then
*
         Do iGrid = 1, mGrid
            PA=max(1.0D-24,Rho(ipR,iGrid),Ta)
            If (Rho(ipR,iGrid).lt.Ta) goto 110
            grdrhoa_x=Rho(ipdRx,iGrid)
            grdrhoa_y=Rho(ipdRy,iGrid)
            grdrhoa_z=Rho(ipdRz,iGrid)
            GAA=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
            GammaA=sqrt(GAA)
            TauA = Rho(ipTau,iGrid)
            Call vs98ss(PA,GAA,TauA,FA,FPA,FGA,FTA,EUA,ZA,
     &                  ChiA,EUPA,ChiAP,ChiAG,ZAP,ZAT,ijzy)

            F_xc(iGrid)=F_xc(iGrid)+(2.0D0*FA)
*           dF/dRho
            dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+FPA
*           dF/dGamma, no Gamma_ab term
            dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+ FGA
*           dF/dTau
            dF_dRho(ipT,iGrid)=dF_dRho(ipT,iGrid)+FTA
110         Continue
*
            P=2.0D0*PA
            IF (PA.gt.DTol) THEN
               RS = (Pi34/P) ** F13
               RSP = -RS/(F3*P)
               Zeta = 0.0D0
               dZdA = F1/P
               Call lsdac(RS,Zeta,PotLC,dLdS,dLdZ,d2LdSS,d2LdSZ,
     $                    d2LdZZ)
               EUEG = P*PotLC - 2.0D0*EUA
               ZAB = 2.0D0*ZA
               XAB = 2.0D0*ChiA
               kab = F1 + gab*(XAB+ZAB)
               xk = XAB/kab
               zk = ZAB/kab
               call gvt4(gcab,dgdx,dgdz,xk,zk,kab,gab,gab,r7,r8,r9,r10,
     &                   r11,r12)
               F_xc(iGrid)=F_xc(iGrid)+gcab*EUEG
               dgdPA = dgdx*ChiAP + dgdz*ZAP
               dgdGA = dgdx*ChiAG
               dgdTA = dgdz*ZAT
               EUEGPA = PotLC + P*dLdS*RSP + P*dLdZ*dZdA - EUPA
               EUEGPB = PotLC + P*dLdS*RSP - P*dLdZ*dZdA - EUPA
*              dF/dRho
               dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)
     &                           +(EUEGPA*gcab+EUEG*dgdPA)
*              dF/dGamma
               dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+EUEG*dgdGA
*              dF/dTau
               dF_dRho(ipT,iGrid)=dF_dRho(ipT,iGrid)+EUEG*dgdTA
            ENDIF
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      Else
         Do iGrid = 1, mGrid
            PA=max(1.0D-24,Rho(ipRa,iGrid),Ta)
            If(Rho(ipRa,iGrid).lt.Ta) goto 100
            grdrhoa_x=Rho(ipdRxa,iGrid)
            grdrhoa_y=Rho(ipdRya,iGrid)
            grdrhoa_z=Rho(ipdRza,iGrid)
            GAA=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
            GammaA=sqrt(GAA)
            TauA = Rho(ipTaua,iGrid)
            Call vs98ss(PA,GAA,TauA,FA,FPA,FGA,FTA,EUA,ZA,
     &                  ChiA,EUPA,ChiAP,ChiAG,ZAP,ZAT,ijzy)

            F_xc(iGrid)=F_xc(iGrid)+FA
*           dF/dRhoa
            dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+FPA
*           dF/dGammma_aa
            dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+ FGA
*           dF/dTaua
            dF_dRho(ipTa,iGrid)=dF_dRho(ipTa,iGrid)+FTA
100         Continue
*
            PB=max(1.0D-24,Rho(ipRb,iGrid),Ta)
            if(Rho(ipRb,iGrid).lt.Ta) goto 111
            grdrhob_x=Rho(ipdRxb,iGrid)
            grdrhob_y=Rho(ipdRyb,iGrid)
            grdrhob_z=Rho(ipdRzb,iGrid)
            GBB=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
            GammaB=sqrt(GBB)
            TauB = Rho(ipTaub,iGrid)
            Call vs98ss(PB,GBB,TauB,FB,FPB,FGB,FTB,EUB,ZB,
     &                  ChiB,EUPB,ChiBP,ChiBG,ZBP,ZBT,ijzy)

            F_xc(iGrid)=F_xc(iGrid)+FB
*           dF/dRhob
            dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+FPB
*           dF/dGammma_bb
            dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+ FGB
*           dF/dTaub
            dF_dRho(ipTb,iGrid)=dF_dRho(ipTb,iGrid)+FTB
111         Continue

            P=PA+PB
            IF (PB.gt.DTol.and.PA.gt.DTol) THEN
               RS = (Pi34/P) ** F13
               RSP = -RS/(F3*P)
               Zeta = (PA-PB)/P
               dZdA = (F1-Zeta)/P
               dZdB = (-F1-Zeta)/P
               Call lsdac(RS,Zeta,PotLC,dLdS,dLdZ,d2LdSS,d2LdSZ,
     $                    d2LdZZ)
               EUEG = P*PotLC - EUA - EUB
               ZAB = ZA + ZB
               XAB = ChiA+ChiB
               kab = F1 + gab*(XAB+ZAB)
               xk = XAB/kab
               zk = ZAB/kab
               call gvt4(gcab,dgdx,dgdz,xk,zk,kab,gab,gab,r7,r8,r9,r10,
     &                   r11,r12)
               F_xc(iGrid)=F_xc(iGrid)+gcab*EUEG
               dgdPA = dgdx*ChiAP + dgdz*ZAP
               dgdGA = dgdx*ChiAG
               dgdTA = dgdz*ZAT
               dgdPB = dgdx*ChiBP + dgdz*ZBP
               dgdGB = dgdx*ChiBG
               dgdTB = dgdz*ZBT
               EUEGPA = PotLC + P*dLdS*RSP + P*dLdZ*dZdA - EUPA
               EUEGPB = PotLC + P*dLdS*RSP + P*dLdZ*dZdB - EUPB
*              dF/dRho
               dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)
     &                            +(EUEGPA*gcab+EUEG*dgdPA)
               dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)
     &                            +(EUEGPB*gcab+EUEG*dgdPB)
*              dF/dGamma
               dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+EUEG*dgdGA
               dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+EUEG*dgdGB
*              dF/dTau
               dF_dRho(ipTa,iGrid)=dF_dRho(ipTa,iGrid)+EUEG*dgdTA
               dF_dRho(ipTb,iGrid)=dF_dRho(ipTb,iGrid)+EUEG*dgdTB
            END IF
         End Do
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(CoeffA)
      End

      Subroutine vs98ss(PX,GX,TX,F,FP,FG,FT,EUEG,Z,Chi,EUEGP,
     &                   ChiP,ChiG,ZP,ZT,ijzy)
      Implicit none
C
C     Compute the same-spin part of the vs98 correlation functional for one grid
C     point and one spin-case.
C

      integer ijzy
      REAL*8 r13, r14, r15, r16, r17, r18
      REAL*8 PX, GX, TX, F, FP, FG, FT, DTol, Z, ZP, ZT
      REAL*8 EUEG, Chi, EUEGP, ChiP, ChiG, cf, gcc
      REAL*8 Zero, F1, F2, F3, F4, F5, F8, F11
      REAL*8 Pi, Pi34, F13, F23, F43, F53, F83, F113
      REAL*8 RS, D, RSP, PotLC, DX, DZ, dgdP, dgdG, dgdT
      REAL*8 E,DP, DG, DT, rhoo, rho43, rho53, rho83
      REAL*8 rrho, F4o3, rho13, kc, xk, zk, gc, dgdx, dgdz
      REAL*8 d2LdSS, d2LdSZ, d2LdZZ, dLdS, dLdZ

      Data Zero/0.0d0/, F1/1.0d0/, F2/2.0d0/, F3/3.0d0/,
     $  F4/4.0d0/, F5/5.0d0/, F8/8.0d0/, F11/11.0d0/,
     $  gcc/0.00515088d0/,cf/9.115599720d0/


      F4o3 = 4.0d0/3.0d0
C     Parameters for VS98
      if (ijzy.eq.1) then
              r13=   3.270912d-01
              r14=  -3.228915d-02
              r15=  -2.942406d-02
              r16=   2.134222d-03
              r17=  -5.451559d-03
              r18=   1.577575d-02
C     Parameters for M06-L
      elseif (ijzy.eq.2) then
              r13=   4.650534D-01
              r14=   1.617589D-01
              r15=   1.833657D-01
              r16=   4.692100D-04
              r17=  -4.990573D-03
              r18=   0.000000D+00
C     Parameters for M06-HF
      elseif (ijzy.eq.3) then
              r13=   8.976746D-01
              r14=  -2.345830D-01
              r15=   2.368173D-01
              r16=  -9.913890D-04
              r17=  -1.146165D-02
              r18=   0.000000D+00
C     Parameters for M06
      elseif (ijzy.eq.4) then
               r13=  4.905945D-01
               r14= -1.437348D-01
               r15=  2.357824D-01
               r16=  1.871015D-03
               r17= -3.788963D-03
               r18=  0.000000D+00
C     Parameters for M06-2X
      elseif (ijzy.eq.5) then
              r13=  6.902145D-01
              r14=  9.847204D-02
              r15=  2.214797D-01
              r16= -1.968264D-03
              r17= -6.775479D-03
              r18=  0.000000D+00
      endif

      DTol =1.0d-8
      If(PX.le.DTol) then
        EUEG = Zero
        Chi = Zero
        EUEGP = Zero
        ChiP = Zero
        ChiG = Zero
        PX = Zero
        GX = Zero
        TX = Zero
        F  = Zero
        FP = Zero
        FG = Zero
        FT = Zero
        Z  = Zero
        ZP = Zero
        ZT = Zero
      else
        Pi = F4*ATan(F1)
        Pi34 = F3 / (F4*Pi)
        F13 = F1 / F3
        F23 = F2 / F3
        F43 = F2 * F23
        F53 = F5 / F3
        F83 = F8 / F3
        F113 = F11 / F3
        rhoo = PX
        rrho = 1.0D0/rhoo
        rho43 = rhoo**F4o3
        rho13 = rho43*rrho
        rho53 = rhoo**F53
        rho83 = rho53*rhoo

        RS = (Pi34/PX) ** F13
        Call lsdac(RS,F1,PotLC,dLdS,dLdZ,d2LdSS,d2LdSZ,d2LdZZ)
        EUEG = PX*PotLC
        Chi = GX/rho83
        Z = (TX/rho53) - cf
        kc = F1 + gcc*(Chi + Z)
        xk = Chi/kc
        zk = Z/kc
*       D = F1 - Chi/(F4*(Z + cf))
        D = F1 - Chi*rho53/(F4*TX)
        call gvt4(gc,dgdx,dgdz,xk,zk,kc,gcc,gcc,r13,r14,r15,r16,r17,r18)
        E = D*EUEG*gc
c         write (*,*) "Chi, Z, gc", CHi, Z, gc
        F = E
c
        RSP = -RS/(F3*Px)
        ChiG = F1/PX**F83
        ChiP = -F83*Chi/PX
        ZP = -F53 * TX/rho83
        ZT =  F1/rho53
*       DZ = Chi/(F4*(Z + cf)*(Z + cf))
        DZ = Chi*rho53**2/(F4*TX**2)
*       DX = -F1/(F4*(Z + cf))
        DX = -F1*rho53/(F4*TX)
        DP = DZ*ZP + DX*ChiP
        DG = DX*ChiG
        DT = DZ*ZT
        dgdP = dgdx*ChiP + dgdz*ZP
        dgdG = dgdx*ChiG
        dgdT = dgdz*ZT
        EUEGP = PotLC + PX*dLdS*RSP
        FP = DP*EUEG*gc + D*EUEGP*gc + D*EUEG*dgdP
        FG = DG*EUEG*gc + D*EUEG*dgdG
        FT = DT*EUEG*gc + D*EUEG*dgdT
       Endif
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine ChoLSOSMP2_Energy_Fll(N,w,t,EOcc,EVir,Delete,EMP2,irc)
!
! Thomas Bondo Pedersen, December 2012.
!
! Compute Laplace-SOS-MP2 energy correction from full Cholesky
! vectors (i.e., not batched).

use Cholesky, only: NumCho, nSym
use ChoMP2, only: DecoMP2, Laplace_BlockSize, nMP2Vec, nT1am
use stdalloc, only: mma_maxDBLE
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: w(N), t(N), EOcc(*), EVir(*)
logical(kind=iwp), intent(in) :: Delete
real(kind=wp), intent(out) :: EMP2
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: iSym, l, l_V, l_X, Nai, need, nEnrVec(8)
character(len=*), parameter :: SecNam = 'ChoLSOSMP2_Energy_Fll'

! check if there is enough memory to read through vector files
! only once
if (DecoMP2) then
  nEnrVec(1:nSym) = nMP2Vec(1:nSym)
else
  nEnrVec(1:nSym) = NumCho(1:nSym)
end if
l_X = 0
l_V = 0
do iSym=1,nSym
  Nai = nT1am(iSym)
  if ((Nai > 0) .and. (nEnrVec(iSym) > 0)) then
    l_X = max(l_X,min(Laplace_BlockSize,nEnrVec(iSym)))
    l_V = max(l_V,Nai*nEnrVec(iSym))
  end if
end do
need = l_X+2*l_V
call mma_maxDBLE(l)
l = l-100
if ((l < 1) .or. (need >= l)) then ! not enough memory for one read
  call ChoLSOSMP2_Energy_Fll2(N,w,t,EOcc,EVir,Delete,EMP2,irc)
  if (irc /= 0) write(u6,'(A,A,I10)') SecNam,': Cho_LSOSMP2_Energy_Fll2 returned',irc
else ! enough memory for one read through vector files
  call ChoLSOSMP2_Energy_Fll1(N,w,t,EOcc,EVir,Delete,EMP2,irc)
  if (irc /= 0) write(u6,'(A,A,I10)') SecNam,': Cho_LSOSMP2_Energy_Fll1 returned',irc
end if

end subroutine ChoLSOSMP2_Energy_Fll

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine TAB2(NREF,IOCR,nIOCR,L0,L1,L2,L3,INTNUM,LV,LSYM,ICIALL,IFCORE,ICOR,NONE_,JONE)

use guga_global, only: BL1, BL2, BS1, BS2, BS3, BS4, COUP, COUP1, IA, IAF, IB, IBF, IFIRST, IJ, IJF, ILIM, IPO, IPRINT, IRC, IV0, &
                       IX, IY, JNDX, K0, K1, K2, K3, LN, MXVERT, N, NIORB, S
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nIOCR, INTNUM, LV, LSYM, ICIALL, IFCORE, ICOR(*), NONE_, JONE(*)
integer(kind=iwp), intent(inout) :: NREF, IOCR(nIOCR)
integer(kind=iwp), intent(_OUT_) :: L0(*), L1(*), L2(*), L3(*)
integer(kind=iwp) :: I, I0, I1, IA1, IAC, IAT, IB1, IBMAX, IBS, IBT, IEL, II, IIJ, IIJF, IIM, IIM2, IJD, IJFL, IJFS, IJL, IJR, &
                     IJRL, IJS, IJS1, IL, IN_, INUM, ISTA, ISTOP, ISUM, ITTT, IUT, IUT1, J, J11, J3, J4, JJ, JJ1, JJ2, JL, JMAX, &
                     K, LN1, NAC, NACU, NIJ, NIJ1
real(kind=wp) :: FB, FBB
logical(kind=iwp) :: skip
integer(kind=iwp), allocatable :: IORB(:), K00(:), K11(:), K22(:), K33(:), L00(:), L11(:), L22(:), L33(:)

IEL = 2
if (IFIRST /= 0) IEL = 1

! NUMBER OF ACTIVE ELECTRONS
NAC = N-2*NIORB

! UPPER LIMIT FOR NUMBER OF ELECTRONS IN ACTIVE SPACE
NACU = NAC+IEL

IUT = 0
IB(1) = int(2*S)
IA(1) = int(N-2*S)/2
IJ(LN+1) = 0
IJ(LN) = 1
NIJ = 1
IJR = 1
IJS = 2
IJRL = IJR
call mma_allocate(IORB,MXVERT,label='IORB')
IORB(1) = 0
do II=1,LN
  IIM = LN-II+1-LV
  IAC = IIM-NIORB-1
  IIM2 = (IIM-1)*2

  do

    ! S=0

    INUM = N-2*IA(IJR)-IB(IJR)
    skip = .false.
    if ((INTNUM /= 0) .and. (IIM > 0)) then
      if (IAC < 0) then
        if ((IB(IJR) /= 0) .and. (INUM+IIM2 == N-2)) skip = .true.
      else
        if (IB(IJR) > IAC+3) skip = .true.
      end if
    end if
    if (.not. skip) then
      NIJ = NIJ+1
      IA(NIJ) = IA(IJR)
      IB(NIJ) = IB(IJR)
      IORB(NIJ) = IORB(IJR)+2
      if (IIM > 0) then
        call CHEL(IA(NIJ),IB(NIJ),IIM,IEL,ISTOP)
        if (ISTOP == 1) NIJ = NIJ-1
      end if
    end if

    ! S=1

    if (IB(IJR) /= 0) then
      skip = .false.
      if ((INTNUM /= 0) .and. (IIM > 0)) then
        if (IAC >= 0) then
          if (INUM+1 > NACU) then
            skip = .true.
          else if (INUM+1 == NACU) then
            IBS = IB(IJR)-1
            if ((IBS /= 0) .and. (IBS /= 2)) skip = .true.
          end if
        end if
      end if
      if (.not. skip) then
        NIJ = NIJ+1
        IA(NIJ) = IA(IJR)
        IB(NIJ) = IB(IJR)-1
        IORB(NIJ) = IORB(IJR)+1
        if (IIM > 0) then
          call CHEL(IA(NIJ),IB(NIJ),IIM,IEL,ISTOP)
          if (ISTOP == 1) NIJ = NIJ-1
        end if
      end if
    end if

    ! S=2

    if (IA(IJR) /= 0) then
      skip = .false.
      if ((INTNUM /= 0) .and. (IIM > 0)) then
        if (IAC < 0) then
          if (IB(IJR) >= 2) skip = .true.
        else
          if ((IB(IJR)+1 > IAC+3) .or. (INUM+1 > NACU)) then
            skip = .true.
          else if (INUM+1 == NACU) then
            IBS = IB(IJR)+1
            if ((IBS /= 0) .and. (IBS /= 2)) skip = .true.
          end if
        end if
      end if
      if (.not. skip) then
        NIJ = NIJ+1
        IA(NIJ) = IA(IJR)-1
        IB(NIJ) = IB(IJR)+1
        IORB(NIJ) = IORB(IJR)+1
        if (IIM > 0) then
          call CHEL(IA(NIJ),IB(NIJ),IIM,IEL,ISTOP)
          if (ISTOP == 1) NIJ = NIJ-1
        end if
      end if
    end if

    ! S=3

    if (IA(IJR) /= 0) then
      skip = .false.
      if ((INTNUM /= 0) .and. (IAC >= 0)) then
        if ((IB(IJR) > IAC+3) .or. (INUM+2 > NACU)) then
          skip = .true.
        else if (INUM+2 == NACU) then
          IBS = IB(IJR)
          if ((IBS /= 0) .and. (IBS /= 2)) skip = .true.
        end if
      end if
      if (.not. skip) then
        NIJ = NIJ+1
        IA(NIJ) = IA(IJR)-1
        IB(NIJ) = IB(IJR)
        IORB(NIJ) = IORB(IJR)
        if (IIM > 0) then
          call CHEL(IA(NIJ),IB(NIJ),IIM,IEL,ISTOP)
          if (ISTOP == 1) NIJ = NIJ-1
        end if
      end if
    end if

    if (IJR == IJRL) exit
    IJR = IJR+1
  end do

  ! DELETE VERTICES
  NIJ1 = NIJ-1
  IN_ = IJS
  IUT = IJS
  do IJD=IJS,NIJ1
    JJ1 = NIJ-IJD+IJS-1
    J = JJ1+1
    do K=IJS,JJ1
      if ((IA(J) == IA(K)) .and. (IB(J) == IB(K))) then
        IA(J) = -1
        IB(J) = -1
        exit
      end if
    end do
  end do
  ! PACK VERTICES
  IJS1 = IJS+1
  do J=IJS1,NIJ
    if ((IA(J) == -1) .and. (IB(J) == -1)) then
      IN_ = IN_+1
    else
      IN_ = IN_+1
      IUT = IUT+1
      IA(IUT) = IA(IN_)
      IB(IUT) = IB(IN_)
      IORB(IUT) = IORB(IN_)
    end if
  end do
  ! ORDER VERTICES
  IUT1 = IUT-1
  do J=IJS,IUT1
    J11 = J+1
    do K=J11,IUT
      if (IA(J)-IA(K) <= 0) then
        if ((IA(J)-IA(K) < 0) .or. (IB(J) <= IB(K))) then
          IAT = IA(J)
          IBT = IB(J)
          IA(J) = IA(K)
          IB(J) = IB(K)
          IA(K) = IAT
          IB(K) = IBT
        end if
      end if
    end do
  end do
  if (II /= LN) IJ(LN-II) = IUT
  IJR = IJS
  IJS = IUT+1
  IJRL = IUT
  NIJ = IUT
end do
call mma_deallocate(IORB)
if (N == 2) then
  IUT = IUT+1
  IA(IUT) = 0
  IB(IUT) = 0
  IA(IUT-1) = 0
  IB(IUT-1) = 1
  IA(IUT-2) = 0
  IB(IUT-2) = 2
end if
JJ2 = 0
call mma_allocate(K00,MXVERT,label='K00')
call mma_allocate(K11,MXVERT,label='K11')
call mma_allocate(K22,MXVERT,label='K22')
call mma_allocate(K33,MXVERT,label='K33')
call mma_allocate(L00,MXVERT,label='L00')
call mma_allocate(L11,MXVERT,label='L11')
call mma_allocate(L22,MXVERT,label='L22')
call mma_allocate(L33,MXVERT,label='L33')
do II=1,LN
  I = LN-II+1-LV
  IIM2 = (I-1)*2
  I0 = I+LV
  JJ1 = IJ(I0+1)+1
  JJ2 = IJ(I0)
  J3 = JJ2+1
  if (I0 /= 1) J4 = IJ(I0-1)
  if (I0 == 1) J4 = IUT
  ! DETERMINE CASE DOWN
  do J=JJ1,JJ2
    IA1 = IA(J)
    IB1 = IB(J)
    INUM = 2*IA1+IB1
    K00(J) = 0
    K11(J) = 0
    K22(J) = 0
    K33(J) = 0
    do JJ=J3,J4
      if (IA1 /= IA(JJ)) then
        if ((IA1-IA(JJ)) == 1) then
          if (IB1 /= IB(JJ)) then
            if ((IB(JJ)-IB1) == 1) then
              if ((I > NIORB) .or. (INTNUM == 0) .or. (I <= 0) .or. (IB1 < 2)) K22(J) = JJ
            end if
          else
            K33(J) = JJ
          end if
        end if
      else if (IB1 /= IB(JJ)) then
        if ((IB1-IB(JJ)) == 1) K11(J) = JJ
      else
        if ((I <= NIORB) .and. (INTNUM /= 0) .and. (I > 0) .and. (IB1 /= 0)) then
          if ((INUM-IIM2 == 2) .or. (IA1 < I-1)) cycle
        end if
        K00(J) = JJ
      end if
    end do
  end do
  ! DETERMINE CASE UP
  do J=J3,J4
    IA1 = IA(J)
    IB1 = IB(J)
    INUM = 2*IA1+IB1
    L00(J) = 0
    L11(J) = 0
    L22(J) = 0
    L33(J) = 0
    do JJ=JJ1,JJ2
      if (IA(JJ) /= IA1) then
        if ((IA(JJ)-IA1) == 1) then
          if (IB(JJ) /= IB1) then
            if ((IB1-IB(JJ)) == 1) then
              if ((I > NIORB) .or. (INTNUM == 0) .or. (I <= 0) .or. (IB1 < 3)) L22(J) = JJ
            end if
          else
            L33(J) = JJ
          end if
        end if
      else if (IB(JJ) /= IB1) then
        if ((IB(JJ)-IB1) == 1) L11(J) = JJ
      else
        if ((I <= NIORB) .and. (INTNUM /= 0) .and. (I > 0) .and. (IB1 /= 0)) then
          if ((INUM-IIM2 == 2) .or. (IA1 < I-1)) cycle
        end if
        L00(J) = JJ
      end if
    end do
  end do
end do
IV0 = IUT
K00(IUT) = 0
K11(IUT) = 0
K22(IUT) = 0
K33(IUT) = 0
K00(IUT+1) = 0
K11(IUT+1) = 0
K22(IUT+1) = 0
K33(IUT+1) = 0
if (ICIALL /= 0) call CIALL(LSYM,NREF,IOCR,nIOCR,L00,L11,L22,L33,LV)
call DELTAB(NREF,IOCR,L0,L1,L2,L3,INTNUM,LV,IFCORE,ICOR,NONE_,JONE,K00,K11,K22,K33,L00,L11,L22,L33)
call mma_deallocate(K00)
call mma_deallocate(K11)
call mma_deallocate(K22)
call mma_deallocate(K33)
call mma_deallocate(L00)
call mma_deallocate(L11)
call mma_deallocate(L22)
call mma_deallocate(L33)
do I=1,ILIM
  ISTA = (I-1)*MXVERT
  if (IPRINT >= 5) write(u6,101)
  if (IPRINT >= 5) write(u6,100) (J,IA(J),IB(J),K0(ISTA+J),K1(ISTA+J),K2(ISTA+J),K3(ISTA+J),L0(ISTA+J),L1(ISTA+J),L2(ISTA+J), &
                                  L3(ISTA+J),J=1,IUT)
end do
IBMAX = 0
do J=1,IUT
  if (IB(J) > IBMAX) IBMAX = IB(J)
end do
call mma_allocate(BS1,IBMAX+3,label='BS1')
call mma_allocate(BS2,IBMAX+3,label='BS2')
call mma_allocate(BS3,IBMAX+3,label='BS3')
call mma_allocate(BS4,IBMAX+3,label='BS4')
call mma_allocate(BL1,IBMAX+3,label='BL1')
call mma_allocate(BL2,IBMAX+3,label='BL2')
IUT1 = IUT-1
do IL=1,ILIM
  ISTA = (IL-1)*MXVERT
  IX(ISTA+1) = 1
  do II=1,LN
    if (II /= LN) then
      I = LN-II
      IJL = IJ(I)
      IJS = IJ(I+1)+1
    else
      IJL = IUT
      IJS = IUT-3
      if (IFIRST /= 0) IJS = IUT-1
    end if
    do J=IJS,IJL
      ISUM = 0
      if (L0(ISTA+J) /= 0) ISUM = ISUM+IX(ISTA+L0(ISTA+J))
      if (L1(ISTA+J) /= 0) then
        IY(ISTA+L1(ISTA+J),1) = ISUM
        ISUM = ISUM+IX(ISTA+L1(ISTA+J))
      end if
      if (L2(ISTA+J) /= 0) then
        IY(ISTA+L2(ISTA+J),2) = ISUM
        ISUM = ISUM+IX(ISTA+L2(ISTA+J))
      end if
      if (L3(ISTA+J) /= 0) then
        IY(ISTA+L3(ISTA+J),3) = ISUM
        ISUM = ISUM+IX(ISTA+L3(ISTA+J))
      end if
      IX(ISTA+J) = ISUM
    end do
  end do
end do
do I=1,ILIM
  ISTA = (I-1)*MXVERT
  if (IPRINT >= 5) write(u6,102)
  if (IPRINT >= 5) write(u6,200) (J,IY(ISTA+J,1),IY(ISTA+J,2),IY(ISTA+J,3),IX(ISTA+J),J=1,IUT)
end do
if (IPRINT >= 2) write(u6,210) IUT
write(u6,214)

if (IFIRST == 0) then
! This is a normal calculation, both singles and doubles included.
  write(u6,215) (IX(IUT+1-ITTT+MXVERT*(ITTT-1)),ITTT=1,4)
else
  ! "FIRST" keyword has been given. Then this is just a so-called
  ! first-order CI, i.e., singles only.
  write(u6,215) (IX(IUT+1-ITTT+MXVERT*(ITTT-1)),ITTT=1,2)
end if

IRC(1) = IX(IUT)
do I=2,ILIM
  ISTA = (I-1)*MXVERT
  IRC(I) = IX(ISTA+IUT+1-I)+IRC(I-1)
end do
ISUM = IRC(ILIM)
call mma_allocate(JNDX,ISUM,label='JNDX')
do I=1,IBMAX+3
  FBB = real(I-1,kind=wp)
  FB = FBB/(FBB+1)
  BS1(I) = sqrt(FB)
  FB = (FBB+2)/(FBB+1)
  BS2(I) = sqrt(FB)
  if (I > 1) BS3(I) = One/BS1(I)
  BS4(I) = One/BS2(I)
  FB = FBB*FBB-1
  if (I > 1) BL1(I) = sqrt(FB)/FBB
  FB = (FBB+2)**2-1
  BL2(I) = sqrt(FB)/(FBB+2)
end do
! PUT ZEROS IN VECTORS
COUP(1:LN) = Zero
COUP1(1:LN) = Zero
IN_ = 0
do I=1,LN
  II = LN-I+1
  IJS = IJ(II+1)+1
  IJL = IJ(II)
  IJFS = IJF(II+1)+1
  IJFL = IJF(II)
  do IIJ=IJS,IJL
    do IIJF=IJFS,IJFL
      if ((IA(IIJ) == IAF(IIJF)) .and. (IB(IIJ) == IBF(IIJF))) then
        IPO(IIJ) = IIJF
        exit
      end if
    end do
  end do
end do
IPO(IUT) = IJF(1)+1
if (IPRINT >= 10) write(u6,350) (IPO(J),J=1,IUT)
JMAX = 0
LN1 = LN+1
do I=2,LN1
  I1 = I-1
  JL = IJ(I1)-IJ(I)
  if (JL >= JMAX) JMAX = JL
end do

if (IPRINT >= 2) then
  write(u6,411) JMAX
  write(u6,412) IBMAX
  if (JMAX > 31) call Abend()
end if

return

100 format(6X,I3,5X,2I4,5X,8I4)
101 format(///,6X,'TAB2',//,8X,'J',8X,'A',3X,'B',7X,'K0',2X,'K1',2X,'K2',2X,'K3',2X,'L0',2X,'L1',2X,'L2',2X,'L3',/)
102 format(///,6X,'INDEX TABLE',//,8X,'J',8X,'Y1',3X,'Y2',3X,'Y3',9X,'X',/)
200 format(6X,I3,5X,3I5,5X,I5)
210 format(/,6X,'NUMBER OF VERTICES',I10)
214 format(///,6X,'INTERNAL CONFIGURATIONS (FORMAL)')
215 format(/,6X,'NUMBER OF VALENCE STATES',I16,/,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7,/,6X, &
           'NUMBER OF TRIPLET COUPLED DOUBLES',I7,/,6X,'NUMBER OF SINGLET COUPLED DOUBLES',I7)
!216 format(/,6X,'NUMBER OF VALENCE STATES',I16,/,6X,'NUMBER OF DOUBLET COUPLED SINGLES',I7)
350 format(/,6X,5I5)
411 format(/,6X,'NUMBER OF VERTICES IN ONE ROW',I6,6X,'(PRESENT LIMIT 31)')
412 format(6X,'MAXIMUM B VALUE',I20,6X)

end subroutine TAB2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Markus P. Fuelscher                              *
!               1991, Per Ake Malmqvist                                *
!***********************************************************************

subroutine MkSrt1()
!***********************************************************************
!                                                                      *
!     Purpose: Determine the splitting of the integrals into           *
!              submatrices (slices) and hence determine the            *
!              number of bins. Also construct the offsets              *
!              which allow to reduce an integral symmetry block        *
!              number into a relative bin number with respect to       *
!              the bin number of the first integral in a given         *
!              symmetry block.                                         *
!                                                                      *
!     Called from: Sort0                                               *
!                                                                      *
!     Calls to : none                                                  *
!                                                                      *
!     Calling parameters: none                                         *
!                                                                      *
!*** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****

use sort_data, only: iDIBin, iDVBin, iStBin, lBin, lSll, mInt, mSyBlk, mxSyP, n_Int, nBin, nBs, nSkip, nSln, nSyOp, nRec, Square
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6, RtoI

implicit none
#include "print.fh"
#include "warnings.h"
integer(kind=iwp) :: ib, ibj, ij, iOff, iPrint, iRout, iSkip, iSyblj, iSyBlk, iSymi, iSymj, jb, jSkip, jSymj, kb, kbl, kSkip, &
                     kSybll, kSymk, kSyml, kSymMx, lb, lSkip, lSlice, lSrtA, lSyml, lSymMx, MaxMem, mnBin, MxSrtA1, MxSrtA2, nij, &
                     nSlice, nSym
#ifndef _I8_
integer(kind=iwp) :: ix
integer(kind=iwp), parameter :: lim_32 = 2**30
#endif
logical(kind=iwp), external:: Reduce_Prt

iRout = 80
iPrint = nPrint(iRout)
if (iPrint > 10) write(u6,*) ' >>> Enter MKSRT1 <<<'
!----------------------------------------------------------------------*
!                                                                      *
!     grab memory                                                      *
!                                                                      *
!     The available memory should not be smaller than the number       *
!     of unique symmetry blocks times the size of a bin.               *
!     If nSyOp=1 mnBin=  1 and If Square=.true. mnBin=  1              *
!        nSyOp=2 mnBin=  4                      mnBin=  5              *
!        nSyOp=4 mnBin= 19                      mnBin= 28              *
!        nSyOp=8 mnBin=106                      mnBin=176              *
!                                                                      *
!----------------------------------------------------------------------*

select case (nSyOp)
  case (2)
    mnBin = 4
    if (Square) mnBin = 5
  case (4)
    mnBin = 19
    if (Square) mnBin = 28
  case (8)
    mnBin = 106
    if (Square) mnBin = 176
  case default
    mnBin = 1
end select
lSrtA = mnBin*lBin
lSrtA = ((1+RtoI)*lSrtA)/RtoI
call mma_MaxDBLE(MaxMem)
lSrtA = max(lSrtA,MaxMem/2)

!----------------------------------------------------------------------*
!     determine the partitioning of the 2el integrals into             *
!     submatrices by dividing the symmetry blocks into slices that     *
!     fit into the available memory.                                   *
!----------------------------------------------------------------------*

mSyBlk = mxSyP**2
call mma_allocate(iStBin,mSyBlk,label='iStBin')
call mma_allocate(nSln,mSyBlk,label='nSln')
call mma_allocate(lSll,mSyBlk,label='lSll')

nSln(:) = 0
lSll(:) = 0

nSym = nSyOp
do iSymi=1,nSym
  ib = nBs(iSymi)
  iSkip = nSkip(iSymi)
  if ((ib == 0) .or. (iSkip == 1)) cycle
  do jSymj=1,iSymi
    iSymj = 1+ieor(iSymi-1,jSymj-1)
    iSyblj = jSymj+iSymi*(iSymi-1)/2
    jb = nBs(jSymj)
    ibj = ib*jb
    if (iSymi == jSymj) ibj = ib*(ib+1)/2
    jSkip = nSkip(jSymj)
    if ((jb == 0) .or. (jSkip == 1)) cycle
    kSymMx = iSymi
    if (Square) kSymMx = nSym
    do kSymk=1,kSymMx
      kb = nBs(kSymk)
      kSkip = nSkip(kSymk)
      if ((kb == 0) .or. (kSkip == 1)) cycle
      lSymMx = jSymj
      if ((kSymk /= iSymi) .or. Square) lSymMx = kSymk
      do lSyml=1,lSymMx
        kSyml = 1+ieor(kSymk-1,lSyml-1)
        kSybll = lSyml+kSymk*(kSymk-1)/2
        if (ieor(iSymj-1,kSyml-1) /= 0) cycle

        !write(u6,*) 'i,j,k,l=',iSymi,jSymj,kSymk,lSyml
        lb = nBs(lSyml)
        lSkip = nSkip(lSyml)
        if ((lb == 0) .or. (lSkip == 1)) cycle
        kbl = kb*lb
#       ifndef _I8_
        ix = lim_32/kbl
#       endif
        if (kSymk == lSyml) kbl = kb*(kb+1)/2
        iSyBlk = kSybll+mxSyP*(iSyblj-1)
        nij = 0
        do ij=1,ibj
#         ifndef _I8_
          if (ij <= ix) then
#         endif
            if ((ij*kbl) < lSrtA) nij = ij
#         ifndef _I8_
          end if
#         endif
        end do
        if (nij == 0) then
          write(u6,*)
          write(u6,'(2X,A,I3.3,A)') '*** Error in MKSRT1 ***'
          write(u6,'(2X,A)') 'Insufficient memory'
          write(u6,'(2X,A)') 'Increase the value of the MOLCAS_MEM environement variable'
          write(u6,*)
          call Quit(_RC_MEMORY_ERROR_)
        end if
        nSlice = 1+(ibj-1)/nij
        do ij=nij,1,-1
          if ((ij*nSlice) >= ibj) nij = ij
        end do
        nSln(iSyBlk) = nSlice
        lSll(iSyBlk) = nij*kbl
        !write(u6,*) 'iSyBlk=',iSyBlk
        !write(u6,*) 'nSln(iSyBlk)=',nSln(iSyBlk)
        !write(u6,*) 'lSll(iSyBlk)=',lSll(iSyBlk)
      end do
    end do
  end do
end do

!----------------------------------------------------------------------*
!     Determine the final amount of memory and bins that will be used. *
!     Check again for consistency                                      *
!----------------------------------------------------------------------*

nBin = 0
MxSrtA2 = 0
do iSyBlk=1,mSyBlk
  nSlice = nSln(iSyBlk)
  lSlice = lSll(iSyBlk)
  nBin = nBin+nSlice
  MxSrtA2 = max(MxSrtA2,lSlice)
end do
MxSrtA1 = ((1+RtoI)*nBin*lBin)/RtoI

if ((.not. Reduce_Prt()) .and. (iPrint > 5)) then
  write(u6,*)
  write(u6,'(A,I12,A,I4,A)') '  SEWARD will use a sorting area of',MxSrtA1,' Words(Real*8) in the first phase (=',nBin,' bins).'
  write(u6,'(A,I12,A)') '  SEWARD will use a sorting area of',MxSrtA2,' Words(Real*8) in the second phase.'
  write(u6,*)
end if

call mma_allocate(iDIBin,3,max(mnBin,nBin),label='iDIBin')
call mma_allocate(iDVBin,4,max(mnBin,nBin),label='iDVBin')
call mma_allocate(mInt,3,max(mnBin,nBin),label='mInt')
call mma_allocate(nRec,max(mnBin,nBin),label='nRec')
call mma_allocate(n_Int,max(mnBin,nBin),label='n_Int')
iDIBin(:,:) = 0
iDVBin(:,:) = 0
mInt(:,:) = 0
nRec(:) = 0
n_Int(:) = 0

if (MxSrtA1 > lSrtA) then
  write(u6,*)
  write(u6,'(2X,A,I3.3,A)') '*** Error in MKSRT1 ***'
  write(u6,'(2X,A)') 'Insufficient memory'
  write(u6,'(2X,A)') 'MxSrtA1>lSrtA'
  write(u6,*)
  write(u6,*) 'MxSrtA1=',MxSrtA1
  write(u6,*) 'lSrtA=',lSrtA
  write(u6,*)
  write(u6,*) 'Increase MOLCAS_MEM and try again!'
  write(u6,*)
  call Quit(_RC_MEMORY_ERROR_)
end if

!----------------------------------------------------------------------*
!     compute offsets                                                  *
!----------------------------------------------------------------------*

iOff = 1
do iSyBlk=1,mSyBlk
  nSlice = nSln(iSyBlk)
  iStBin(iSyBlk) = iOff
  iOff = iOff+nSlice
end do

return

end subroutine MkSrt1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Francesco Aquilante                              *
************************************************************************
      SubRoutine ChoMP2_fno_Org(irc,Delete,P_ab,P_ii,EOcc,EVir,Wrk,lWrk)
C
C      F. Aquilante, Geneva May 2008  (snick to Pedersen's code)
C
C
#include "implicit.fh"
      Logical Delete
      Real*8  P_ab(*), P_ii(*)
      Real*8  EOcc(*), EVir(*), Wrk(lWrk)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"
      Real*8  DeMP2
      Logical MP2_small
      Common / ChFNOPT/ DeMP2, MP2_small

      Character*7  ThisNm
      Character*14 SecNam
      Parameter (SecNam = 'ChoMP2_fno_Org', ThisNm = 'fno_Org')

      Integer nEnrVec(8), LnT2am, LiT2am(8), kP(8), lP(8)
      Integer nVaJi, iVaJi(8)

      Integer iDummy
      Parameter (iDummy = -999999)

      iFirstS(i,j)=iWork(ip_FirstS-1+nSym*(j-1)+i)
      LnT1am(i,j)=iWork(ip_LnT1am-1+nSym*(j-1)+i)
      LiMatij(i,j,k)=iWork(ip_LiMatij-1+nSym*nSym*(k-1)+nSym*(j-1)+i)
      LnOcc(i,j)=iWork(ip_LnOcc-1+nSym*(j-1)+i)
      MulD2h(i,j)=iEor(i-1,j-1)+1
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      irc = 0

      kP(1)=1
      lP(1)=0
      Do iS=2,nSym
         kP(iS)=kP(iS-1)+nVir(iS-1)**2
         lP(iS)=lP(iS-1)+nOcc(iS-1)
      End Do

C     Set number and type of vectors.
C     -------------------------------

      If (DecoMP2) Then
         iTyp = 2
         Call iCopy(nSym,nMP2Vec,1,nEnrVec,1)
      Else
         iTyp = 1
         Call iCopy(nSym,NumCho,1,nEnrVec,1)
      End If

      If (MP2_small) Then

C        Loop over occupied orbital batches.
C        -----------------------------------

         Do iBatch = 1,nBatch

            jBatch = iBatch

            Call ChoMP2_Energy_GetInd(LnT2am,LiT2am,iBatch,jBatch)

            kXaibj = 1
            kEnd0  = kXaibj + LnT2am
            lWrk0  = lWrk   - kEnd0 + 1
            If (lWrk0 .lt. 1) Then
               Call ChoMP2_Quit(SecNam,'insufficient memory','[0]')
            End If

            If (ChoAlg.eq.2) Then

               kMabij = kXaibj  ! rename pointer
               Call Cho_dZero(Wrk(kMabij),LnT2am) ! initialize

C              Loop over Cholesky vector symmetries.
C              -------------------------------------

               Do iSym = 1,nSym

                  Nai = LnT1am(iSym,iBatch)
                  If (Nai.gt.0 .and. nEnrVec(iSym).gt.0) Then

C                    Reserve memory for reading a single vector.
C                    -------------------------------------------

                     kVecai = kEnd0
                     kEnd1  = kVecai + nT1am(iSym)
                     lWrk1  = lWrk   - kEnd1 + 1

                     If (lWrk1 .lt. Nai) Then
                        Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                                   '[ChoAlg.2.1]')
                     End If

C                    Set up batch over Cholesky vectors.
C                    -----------------------------------

                     nVec = min(lWrk1/Nai,nEnrVec(iSym))
                     If (nVec .lt. 1) Then ! should not happen
                        Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                                   '[ChoAlg.2.2]')
                     End If
                     nBat = (nEnrVec(iSym)-1)/nVec + 1

C                    Open Cholesky vector files.
C                    ---------------------------

                     Call ChoMP2_OpenF(1,iTyp,iSym)

C                    Start vector batch loop.
C                    ------------------------

                     Do iBat = 1,nBat

                        If (iBat .eq. nBat) Then
                           NumVec = nEnrVec(iSym) - nVec*(nBat-1)
                        Else
                           NumVec = nVec
                        End If
                        iVec1 = nVec*(iBat-1) + 1

C                       Set up index arrays for reordered vectors.
C                       ------------------------------------------

                        nVaJi = 0
                        Do iSymi = 1,nSym
                           iSyma = MulD2h(iSymi,iSym)
                           iVaJi(iSymi) = nVaJi
                           nVaJi = nVaJi
     &                          + nVir(iSyma)*NumVec*LnOcc(iSymi,iBatch)
                        End Do

C                       Pointer to reordered vectors: kVec.
C                       -----------------------------------

                        kVec  = kEnd1
                        kEnd2 = kVec  + nVaJi
                        lWrk2 = lWrk  - kEnd2 + 1
                        If (lWrk2 .lt. 0) Then ! should not happen
                           Call ChoMP2_Quit(SecNam,
     &                                      'Insufficient memory',
     &                                      '[ChoAlg.2.3]')
                        End If

C                       Read one vector at a time and reorder.
C                       --------------------------------------

                        iVec0 = iVec1 - 1
                        Do iVec = 1,NumVec

                           iOpt = 2
                           lTot = nT1am(iSym)
                           iAdr = nT1am(iSym)*(iVec0+iVec-1) + 1
                           Call ddaFile(lUnit_F(iSym,iTyp),iOpt,
     &                                  Wrk(kVecai),lTot,iAdr)

                           Do iSymi = 1,nSym
                              iSyma = MulD2h(iSymi,iSym)
                              i0 = iFirstS(iSymi,iBatch) - 1
                              Do i = 1,LnOcc(iSymi,iBatch)
                                 kOff1 = kVecai
     &                                 + iT1am(iSyma,iSymi)
     &                                 + nVir(iSyma)*(i0+i-1)
                                 kOff2 = kVec + iVaJi(iSymi)
     &                                 + nVir(iSyma)*NumVec*(i-1)
     &                                 + nVir(iSyma)*(iVec-1)
                                 Call dCopy_(nVir(iSyma),Wrk(kOff1),1,
     &                                      Wrk(kOff2),1)
                              End Do
                           End Do

                        End Do

C                       Compute M(ab,ii) .
C                       ---------------------------------------

                        Do iSymj = 1,nSym

                           iSymb = MulD2h(iSymj,iSym)

                           If (nVir(iSymb) .gt. 0) Then

                              Do j = 1,LnOcc(iSymj,iBatch)

                                 i = j

                                 ij = LiMatij(iSymj,iSymj,iBatch)
     &                              + iTri(i,j)

                                 kOffi = kVec + iVaJi(iSymj)
     &                                 + nVir(iSymb)*NumVec*(i-1)
                                 kOffj = kVec + iVaJi(iSymj)
     &                                 + nVir(iSymb)*NumVec*(j-1)
                                 kOffM = kMabij + LiT2am(1)
     &                                 + nMatab(1)*(ij-1)
     &                                 + iMatab(iSymb,iSymb)

                                 Call dGeMM_('N','T',
     &                                nVir(iSymb),nVir(iSymb),NumVec,
     &                                1.0d0,Wrk(kOffi),nVir(iSymb),
     &                                      Wrk(kOffj),nVir(iSymb),
     &                                1.0D0,Wrk(kOffM),nVir(iSymb))

                              End Do

                           End If

                        End Do

                     End Do

                     Call Cho_GAdGOp(Wrk(kMabij),LnT2am,'+')

C                    Close Cholesky vector files.
C                    ----------------------------

                     Call ChoMP2_OpenF(2,iTyp,iSym)


C                    Compute energy contribution
C                    ---------------------------------------

                     Do iSymj = 1,nSym

                        iSymb = MulD2h(iSymj,iSym)

                        If (nVir(iSymb) .gt. 0) Then

                           Do j = 1,LnOcc(iSymj,iBatch)

                              i = j

                              ij = LiMatij(iSymj,iSymj,iBatch)
     &                           + iTri(i,j)

                              kOffM = kMabij + LiT2am(1)
     &                              + nMatab(1)*(ij-1)
     &                              + iMatab(iSymb,iSymb)

C                             Compute Energy contribution
C                             -------------------------------------
                              Do jb=1,nVir(iSymb)
                                 Do ja=1,nVir(iSymb)
                                    Dnom = EVir(iVir(iSymb)+ja)
     &                                   + EVir(iVir(iSymb)+jb)
     &                                   - 2.0d0*EOcc(iOcc(iSymj)+j)
                                    kOffMM = kOffM
     &                                     + nVir(iSymb)*(jb-1) +ja-1
                                    DeMP2 = DeMP2
     &                                    + Wrk(kOffMM)**2/Dnom
                                 End Do
                              End Do

                           End Do

                        End If

                     End Do

                  End If

               End Do ! iSym

            End If

         End Do ! iBatch

C        If requested, delete vector files.
C        ----------------------------------

         If (Delete) Then
            Do iSym = 1,nSym
               Call ChoMP2_OpenF(1,iTyp,iSym)
               Call ChoMP2_OpenF(3,iTyp,iSym)
            End Do
         End If

         Return

      EndIf   !  MP2_small run

C     Loop over occupied orbital batches.
C     -----------------------------------

      Do iBatch = 1,nBatch

         jBatch = iBatch

         Call ChoMP2_Energy_GetInd(LnT2am,LiT2am,iBatch,jBatch)

         kXaibj = 1
         kEnd0  = kXaibj + LnT2am
         lWrk0  = lWrk   - kEnd0 + 1
         If (lWrk0 .lt. 1) Then
            Call ChoMP2_Quit(SecNam,'insufficient memory','[0]')
         End If

         If (ChoAlg.eq.2) Then

            kMabij = kXaibj  ! rename pointer
            Call Cho_dZero(Wrk(kMabij),LnT2am) ! initialize

C           Loop over Cholesky vector symmetries.
C           -------------------------------------

            Do iSym = 1,nSym

               Nai = LnT1am(iSym,iBatch)
               If (Nai.gt.0 .and. nEnrVec(iSym).gt.0) Then

C                 Reserve memory for reading a single vector.
C                 -------------------------------------------

                  kVecai = kEnd0
                  kEnd1  = kVecai + nT1am(iSym)
                  lWrk1  = lWrk   - kEnd1 + 1

                  If (lWrk1 .lt. Nai) Then
                     Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                                '[ChoAlg.2.1]')
                  End If

C                 Set up batch over Cholesky vectors.
C                 -----------------------------------

                  nVec = min(lWrk1/Nai,nEnrVec(iSym))
                  If (nVec .lt. 1) Then ! should not happen
                     Call ChoMP2_Quit(SecNam,'Insufficient memory',
     &                                '[ChoAlg.2.2]')
                  End If
                  nBat = (nEnrVec(iSym)-1)/nVec + 1

C                 Open Cholesky vector files.
C                 ---------------------------

                  Call ChoMP2_OpenF(1,iTyp,iSym)

C                 Start vector batch loop.
C                 ------------------------

                  Do iBat = 1,nBat

                     If (iBat .eq. nBat) Then
                        NumVec = nEnrVec(iSym) - nVec*(nBat-1)
                     Else
                        NumVec = nVec
                     End If
                     iVec1 = nVec*(iBat-1) + 1

C                    Set up index arrays for reordered vectors.
C                    ------------------------------------------

                     nVaJi = 0
                     Do iSymi = 1,nSym
                        iSyma = MulD2h(iSymi,iSym)
                        iVaJi(iSymi) = nVaJi
                        nVaJi = nVaJi
     &                       + nVir(iSyma)*NumVec*LnOcc(iSymi,iBatch)
                     End Do

C                    Pointer to reordered vectors: kVec.
C                    -----------------------------------

                     kVec  = kEnd1
                     kEnd2 = kVec  + nVaJi
                     lWrk2 = lWrk  - kEnd2 + 1
                     If (lWrk2 .lt. 0) Then ! should not happen
                        Call ChoMP2_Quit(SecNam,
     &                                   'Insufficient memory',
     &                                   '[ChoAlg.2.3]')
                     End If

C                    Read one vector at a time and reorder.
C                    --------------------------------------

                     iVec0 = iVec1 - 1
                     Do iVec = 1,NumVec

                        iOpt = 2
                        lTot = nT1am(iSym)
                        iAdr = nT1am(iSym)*(iVec0+iVec-1) + 1
                        Call ddaFile(lUnit_F(iSym,iTyp),iOpt,
     &                               Wrk(kVecai),lTot,iAdr)

                        Do iSymi = 1,nSym
                           iSyma = MulD2h(iSymi,iSym)
                           i0 = iFirstS(iSymi,iBatch) - 1
                           Do i = 1,LnOcc(iSymi,iBatch)
                              kOff1 = kVecai
     &                              + iT1am(iSyma,iSymi)
     &                              + nVir(iSyma)*(i0+i-1)
                              kOff2 = kVec + iVaJi(iSymi)
     &                              + nVir(iSyma)*NumVec*(i-1)
     &                              + nVir(iSyma)*(iVec-1)
                              Call dCopy_(nVir(iSyma),Wrk(kOff1),1,
     &                                   Wrk(kOff2),1)
                           End Do
                        End Do

                     End Do

C                    Compute M(ab,ii) .
C                    ---------------------------------------

                     Do iSymj = 1,nSym

                        iSymb = MulD2h(iSymj,iSym)

                        If (nVir(iSymb) .gt. 0) Then

                           Do j = 1,LnOcc(iSymj,iBatch)

                              i = j

                              ij = LiMatij(iSymj,iSymj,iBatch)
     &                           + iTri(i,j)

                              kOffi = kVec + iVaJi(iSymj)
     &                              + nVir(iSymb)*NumVec*(i-1)
                              kOffj = kVec + iVaJi(iSymj)
     &                              + nVir(iSymb)*NumVec*(j-1)
                              kOffM = kMabij + LiT2am(1)
     &                              + nMatab(1)*(ij-1)
     &                              + iMatab(iSymb,iSymb)

                              Call dGeMM_('N','T',
     &                             nVir(iSymb),nVir(iSymb),NumVec,
     &                             1.0d0,Wrk(kOffi),nVir(iSymb),
     &                                   Wrk(kOffj),nVir(iSymb),
     &                             1.0D0,Wrk(kOffM),nVir(iSymb))

                           End Do

                        End If

                     End Do

                  End Do

                  Call Cho_GAdGOp(Wrk(kMabij),LnT2am,'+')

C                 Close Cholesky vector files.
C                 ----------------------------

                  Call ChoMP2_OpenF(2,iTyp,iSym)


                  Do iSymj = 1,nSym

                     iSymb = MulD2h(iSymj,iSym)

                     If (nVir(iSymb) .gt. 0) Then

                        Do j = 1,LnOcc(iSymj,iBatch)

                           i = j

                           ij = LiMatij(iSymj,iSymj,iBatch)
     &                        + iTri(i,j)

                           kOffM = kMabij + LiT2am(1)
     &                           + nMatab(1)*(ij-1)
     &                           + iMatab(iSymb,iSymb)

C                          Compute T(a,b)[i] and energy contrib.
C                          -------------------------------------
                           Do jb=1,nVir(iSymb)
                              Do ja=1,nVir(iSymb)
                                 Dnom = EVir(iVir(iSymb)+ja)
     &                                + EVir(iVir(iSymb)+jb)
     &                                - 2.0d0*EOcc(iOcc(iSymj)+j)
                                 kOffMM = kOffM
     &                                  + nVir(iSymb)*(jb-1) +ja-1
                                 DeMP2 = DeMP2
     &                                 + Wrk(kOffMM)**2/Dnom
                                 Wrk(kOffMM) = Wrk(kOffMM)/Dnom
                              End Do
                           End Do

                           P_ii(lP(iSymj)+i) = P_ii(lP(iSymj)+i)
     &                                       + ddot_(nVir(iSymb)**2,
     &                                                Wrk(kOffM),1,
     &                                                Wrk(kOffM),1)

C                          Compute P(a,b) += sum_c T(a,c)*T(c,b)
C                          -------------------------------------
                           Call dGeMM_('N','N',nVir(iSymb),
     &                                nVir(iSymb),nVir(iSymb),
     &                          1.0d0,Wrk(kOffM),nVir(iSymb),
     &                                Wrk(kOffM),nVir(iSymb),
     &                          1.0D0,P_ab(kP(iSymb)),nVir(iSymb))

                        End Do

                     End If

                  End Do

               End If

            End Do ! iSym

         End If

      End Do ! iBatch

C     If requested, delete vector files.
C     ----------------------------------

      If (Delete) Then
         Do iSym = 1,nSym
            Call ChoMP2_OpenF(1,iTyp,iSym)
            Call ChoMP2_OpenF(3,iTyp,iSym)
         End Do
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MATINV(A,B,N,L,I_DIM)
! IF L=0 RETURNS INVERSE OF A IN A, IF L=1 SOLUTION OF AX=B IN B

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N, L, I_DIM
real(kind=wp), intent(inout) :: A(I_DIM,I_DIM), B(I_DIM)
integer(kind=iwp) :: I, IC, IR, J, K
real(kind=wp) :: AMAX, D
integer(kind=iwp), allocatable :: I_N(:,:), IP(:)

call mma_allocate(I_N,I_DIM,2,label='I_N')
call mma_allocate(IP,I_DIM,label='IP')

IR = 0
IC = 0
D = One
do I=1,N
  IP(I) = 0
end do
do I=1,N
  AMAX = Zero
  do J=1,N
    if (IP(J) > 0) cycle
    if (IP(J) < 0) then
      write(u6,105)
      call Abend()
    end if
    do K=1,N
      if (IP(K) == 1) cycle
      if (IP(K) > 1) then
        write(u6,105)
        call Abend()
      end if
      if (abs(A(J,K)) <= AMAX) cycle
      IR = J
      IC = K
      AMAX = abs(A(J,K))
    end do
  end do
  IP(IC) = IP(IC)+1
  if (AMAX <= 1.0e-30_wp) then
    write(u6,105)
    call Abend()
  end if
  if (IR /= IC) then
    D = -D
    do K=1,N
      AMAX = A(IR,K)
      A(IR,K) = A(IC,K)
      A(IC,K) = AMAX
    end do
    if (L /= 0) then
      AMAX = B(IR)
      B(IR) = B(IC)
      B(IC) = AMAX
    end if
  end if
  I_N(I,1) = IR
  I_N(I,2) = IC
  AMAX = A(IC,IC)
  D = D*AMAX
  A(IC,IC) = One
  do K=1,N
    A(IC,K) = A(IC,K)/AMAX
  end do
  if (L /= 0) B(IC) = B(IC)/AMAX
  do J=1,N
    if (J == IC) cycle
    AMAX = A(J,IC)
    A(J,IC) = Zero
    do K=1,N
      A(J,K) = A(J,K)-A(IC,K)*AMAX
    end do
    if (L /= 0) B(J) = B(J)-B(IC)*AMAX
  end do
end do
if (L /= 1) then
  do I=1,N
    J = N+1-I
    if (I_N(J,1) == I_N(J,2)) cycle
    IR = I_N(J,1)
    IC = I_N(J,2)
    do K=1,N
      AMAX = A(K,IR)
      A(K,IR) = A(K,IC)
      A(K,IC) = AMAX
    end do
  end do
end if

call mma_deallocate(I_N)
call mma_deallocate(IP)

return

105 format(' * '/' *  SINGULAR MATRIX')

end subroutine MATINV

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine PotIntd(Zeta,ZInv,rKappa,P,nZeta,la,lb,A,RB,Array,nArr,rFinal,lFinal,nDAO,CCoor,pot,ngrid,ncmp,DAO,nOrdOp)
!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of potential (nordop=0)   *
!         or electric field (nordop > 0) on a grid                     *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, Sweden, January '91                             *
!***********************************************************************

use Index_Functions, only: nTri_Elem1, nTri3_Elem1
use Rys_interfaces, only: cff2d_kernel, modu2_kernel, rys2d_kernel, tval_kernel
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, la, lb, nArr, lFinal, nDAO, ngrid, ncmp, nOrdOp
real(kind=wp), intent(in) :: Zeta(nZeta), ZInv(nZeta), rKappa(nZeta), P(nZeta,3), A(3), RB(3), CCoor(3,*), DAO(*)
real(kind=wp), intent(inout) :: Array(nZeta*nArr), pot(ncmp,ngrid)
real(kind=wp), intent(out) :: rFinal(lFinal)
integer(kind=iwp) :: i, iAnga(4), icmp, igeo, ip1, ipc, ipIn, kab, lab, labcd, lcd, mabMax, mabMin, mArr, mcdMax, mcdMin, nComp, &
                     nFLOP, nMem, nT
real(kind=wp) :: CoorAC(3,2), Coori(3,4), TC(3)
logical(kind=iwp) :: NoSpecial
procedure(cff2d_kernel) :: XCff2D
procedure(modu2_kernel) :: Fake
procedure(rys2d_kernel) :: XRys2D
procedure(tval_kernel) :: TNAI
real(kind=wp), external :: ddot_
logical(kind=iwp), external :: EQ

nComp = nTri_Elem1(nOrdOp)

iAnga(1) = la
iAnga(2) = lb
iAnga(3) = nOrdOp
iAnga(4) = 0
Coori(:,1) = A
Coori(:,2) = RB
mabMin = nTri3_Elem1(max(la,lb)-1)
mabMax = nTri3_Elem1(la+lb)-1
if (EQ(A,RB)) mabMin = nTri3_Elem1(la+lb-1)
mcdMin = nTri3_Elem1(nOrdOp-1)
mcdMax = nTri3_Elem1(nOrdOp)-1
lab = (mabMax-mabMin+1)
kab = nTri_Elem1(la)*nTri_Elem1(lb)
lcd = (mcdMax-mcdMin+1)
labcd = lab*lcd

! Compute FLOP's and size of work array which Hrr will use.

call mHrr(la,lb,nFLOP,nMem)

! Distribute the work array

ip1 = 1+nZeta*max(labcd,lcd*nMem)
mArr = nArr-max(labcd,lcd*nMem)

! Find center to accumulate angular momentum on. (HRR)

if (la >= lb) then
  CoorAC(:,1) = A
else
  CoorAC(:,1) = RB
end if

nT = nZeta
NoSpecial = .true.

do igeo=1,ngrid
  do i=1,3
    TC(i) = CCoor(i,igeo)
    CoorAC(i,2) = TC(i)
    Coori(i,3) = TC(i)
    Coori(i,4) = TC(i)
  end do

  ! Compute integrals with the Rys quadrature.

  call Rys(iAnga,nT,Zeta,ZInv,nZeta,[One],[One],1,P,nZeta,TC,1,rKappa,[One],Coori,Coori,CoorAC,mabMin,mabMax,mcdMin,mcdMax, &
           Array(ip1),mArr*nZeta,TNAI,Fake,XCff2D,XRys2D,NoSpecial)

  if (nOrdOp == 0) then

    ! Use the HRR to compute the required primitive integrals.

    call HRR(la,lb,A,RB,Array(ip1),nZeta,nMem,ipIn)
    ipc = ip1-1+ipin

    ! Trace primitive integrals with density

    pot(1,igeo) = pot(1,igeo)-ddot_(nDAO,Array(ipc),1,DAO,1)
  else
    call DGetMO(Array(ip1),nZeta*lab,nZeta*lab,lcd,Array,lcd)
    call HRR(la,lb,A,RB,Array,lcd*nZeta,nMem,ipIn)
    call DGetMO(Array(ipIn),lcd,lcd,nZeta*kab,rFinal,nZeta*kab)
    ipc = 1
    do icmp=1,ncomp
      pot(icmp,igeo) = pot(icmp,igeo)+ddot_(nDAO,rFinal(ipc),1,DAO,1)
      ipc = ipc+nDAO
    end do
  end if
end do

return

end subroutine PotIntd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Yoshio Nishimoto                                 *
************************************************************************
      SUBROUTINE OLagNS2(iSym,DPT2C,T2AO)

      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use caspt2_module, only: NSYM, NACTEL, NFRO, NISH, NASH, NSSH,
     &                         NDEL, NBAS, NBSQT

      implicit none

      integer(kind=iwp), intent(in) :: iSym
      real(kind=wp), intent(inout) :: DPT2C(*), T2AO(*)

      real(kind=wp), allocatable :: Int1(:), Scr1(:), Amp1(:)
      integer(kind=iwp) :: nMaxOrb, jSym, lInt, iSymI, iSymJ, iSymIJ,
     &  iSymA, iSymB, iSymAB, iSymIJAB, iCase

      !! orbital Lagrangian from the T-amplitude
      !! See the loop structure in rhs_mp2.f
      !! and the helper subroutine in rhs_mp2_help1/2

      nMaxOrb=0
      Do jSym = 1, nSym
        nMaxOrb = Max(nMaxOrb,nBas(jSym))
      End Do
      lInt = nMaxOrb*nMaxOrb

      call mma_allocate(Int1,lInt,Label='Int1') !! for (ia|jb)
      call mma_allocate(Scr1,lInt,Label='Scr1') !! work space
      call mma_allocate(Amp1,lInt,Label='Amp1') !! for amplitude

      !! (ia|jb)
      Do iSymI = 1, nSym !! Symmetry of occupied (docc+act) orbitals
        !! Check, in particular nFro
        If (nFro(iSymI)+nIsh(iSymI)+nAsh(iSymI) == 0) Cycle
        Do iSymJ = 1, iSymI
          If (nFro(iSymJ)+nIsh(iSymJ)+nAsh(iSymJ) == 0) Cycle
          iSymIJ = 1 + iEor(iSymI-1,iSymJ-1)
          Do iSymA = 1, nSym !! Symmetry of non-filled (act+virt) orbs
            If (nAsh(iSymA)+nSsh(iSymA)+nDel(iSymA) == 0) Cycle
            Do iSymB = 1, iSymA
              If (nAsh(iSymB)+nSsh(iSymB)+nDel(iSymB) == 0) Cycle
              iSymAB = 1 + iEor(iSymA-1,iSymB-1)
              iSymIJAB = 1 + iEor(iSymIJ-1,iSymAB-1)
              If (iSym /= iSymIJAB) Cycle
              Do iCase = 1, 13
                Call OLagNs_Hel2(iCase,iSym,iSymA,iSymB,iSymI,iSymJ,
     &                           nMaxOrb,Int1,Amp1,Scr1,DPT2C,T2AO)
              End Do
            End Do
          End Do
        End Do
      End Do

      DPT2C(1:NBSQT) = DPT2C(1:NBSQT)/real(max(1,NACTEL),kind=wp)

      call mma_deallocate(Int1)
      call mma_deallocate(Scr1)
      call mma_deallocate(Amp1)

      END SUBROUTINE OLagNS2
!
!-----------------------------------------------------------------------
!
      SUBROUTINE OLagNS_Hel2(iCase,iSym,iSymA,iSymB,iSymI,iSymJ,nMaxOrb,
     &                       ERI1,Amp1,Scr,DPT2C,T2AO)

      use Symmetry_Info, only: Mul
      USE SUPERINDEX, only: KTU, KTUV, KTGEU, KTGTU, KAGEB, KAGTB,
     &                      KIGEJ, KIGTJ
      use caspt2_global, only: OLag
      use EQSOLV, only: IVECC2
      use stdalloc, only: mma_allocate, mma_deallocate
      use definitions, only: wp, iwp
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: NACTEL, NSYM, NFRO, NISH, NIES, NASH,
     &                         NAES, NSSH, NSES, NBAS, NBAST, NTU,
     &                         NAGEB, NAGTB, NTUVES, NTUES, NTGEUES,
     &                         NTGTUES, NIGEJES, NIGTJES, NAGEBES,
     &                         NAGTBES, NASUP, NISUP
      use Constants, only: Zero, One, Half, Two, Three

      implicit none

#include "intent.fh"

      integer(kind=iwp), intent(in) :: iCase, iSym, iSymA, iSymB, iSymI,
     &  iSymJ, nMaxOrb
      real(kind=wp), intent(_OUT_) :: ERI1(*)
      real(kind=wp), intent(out) :: Amp1(nMaxOrb,nMaxOrb),
     &  Scr(nMaxOrb,nMaxOrb)
      real(kind=wp), intent(inout) :: DPT2C(*), T2AO(*)

      real(kind=wp), allocatable :: WRK1(:), WRK2(:)

      logical(kind=iwp) :: PM
      integer(kind=iwp) :: IOFF1(8), IOFF2(8), IO1, IO2, iSymK, iSymAB,
     &  nASP, nISP, nASM, nISM, ipTCP, ipTCM, nAS, nIS, ipTC, nFroI,
     &  nFroJ, nFroA, nFroB, nIshI, nIshJ, nIshA, nIshB, nAshI, nAshJ,
     &  nAshA, nAshB, nSshA, nSshB, nBasI, nBasJ, nBasA, nBasB,
     &  nCorI, nCorJ, nCorA, nCorB, nOccA, nOccB, nOccA2, nOccB2,
     &  nOrbA
      integer(kind=iwp) :: iIabs, iJabs, iJtot, iAabs,
     &  iBabs, iBtot, iTabs, iUabs, iVabs, IW1, iIS, iAS, nJ,
     &  iViP, iVaP, iViM, iVaM, iAtot, iItot, IgeJ, IgtJ, iASP,
     &  iISP, iASM, iISM, iAgeB, iVjP, iAgtB, iVjM, iViHP0, iViHP,
     &  iViHM0, iViHM, iVaHP, iVHP, iVaHM, iVHM
      real(kind=wp) :: SQ2, SQI2, SQ3, Fac
      real(kind=wp) :: ValA, ValBP, ValBM, ValC1, ValC2, ONEADD, ValD1,
     &  ValD2, ValEP, ValEM, ValFP, ValFM, ValGP, ValGM, ValHP, ValHM
!
!     DMNS_{ijkl}*d(ij|kl)/dx -> (pj|kl)*D_{qjkl} + (ip|kl)*D_{iqkl}
!                              + (ij|pl)*D_{ijql} + (ij|kp)*D_{ijkq}

!     Integrals needed:
!     (OO|OO), (VO|OO), (VV|OO), (VO|VO), (VV|VO)
!     -> <OO|OO>, <VO|OO>, <VO|VO>, <VV|OO>, <VV|VO>
!     Here, O is occupied (doubly and partially) orbitals
!           V is not filled (partially and virtual) orbitals
!
!     <**|VV> and <**|OO> are fetched by Exch
!     <V*|V*> and <O*|O*> are fetched by Exch
!
!     However, (*O|*O) is split into (*C|*C), (*C|*A), (*A|*A)
!              (V*|V*) is split into (A*|A*), (A*|V*), (V*|V*)
!              (*O|V*) is split into (*A|A*), (*A|V*)
!
!     EXCH(ISYP,ISYI,ISYQ,ISYJ,II,IJ,ERI,SCR)
!
!     rhs_mp2_help1.f
!
      !! The amplitude is in the IC (internally contracted) basis, so
      !! the active orbital index (indices) must be transformed to the
      !! (quasi-)canonical MO (or contravatiant) basis.
      !! IC = SR (why?), contravariant = C
!     write(u6,*) 'icase = ', icase

      PM = .false.
      If (iCase == 2 .or. iCase == 6 .or .iCase == 8 .or.
     &    iCase == 10 .or. iCase == 12) PM = .true.
      If (iCase == 3 .or. iCase == 7 .or .iCase == 9 .or.
     &    iCase == 11 .or. iCase == 13) Return

      SQ2    = SQRT(Two)
      SQI2   = One/SQ2
      SQ3    = SQRT(Three)
      ! iVec   = iVecX
      IO1=0
      IO2=0
      DO iSymK = 1, nSym
        IOFF1(iSymK) = IO1
        IOFF2(iSymK) = IO2
        iSymAB       = Mul(iSymK,iSym)
        IO1          = IO1+nIsh(iSymK)*nAgeB(iSymAB)
        IO2          = IO2+nIsh(iSymK)*nAgtB(iSymAB)
      END DO

      !! Some setup
      !! Read T-amplitude, hopefully in contravariant form
!     nINP = 0
!     nINM = 0
!     nIN  = 0
      If (PM) Then
!       nINP = nINDEP(iSym,iCase)
        nASP = nASup(iSym,iCase)
        nISP = nISup(iSym,iCase)
        ! If (nINP /= 0) Then
        !   nVec = nINP*nISP
        ! End If
!       nINM = nINDEP(iSym,iCase+1)
        nASM = nASup(iSym,iCase+1)
        nISM = nISup(iSym,iCase+1)
        ! If (nINM /= 0) Then
        !   nVec = nINM*nISM
        ! End If
        If (nASP*nISP /= 0) Then
          Call RHS_ALLO(nASP,nISP,ipTCP)
          CALL RHS_READ_C(ipTCP,iCase,iSym,iVecC2)
        End If
        If (nASM*nISM /= 0) Then
          Call RHS_ALLO(nASM,nISM,ipTCM)
          CALL RHS_READ_C(ipTCM,iCase+1,iSym,iVecC2)
        End If
      Else
!       nIN = nINDEP(iSym,iCase)
        nAS = nASup(iSym,iCase)
        nIS = nISup(iSym,iCase)
        ! If (nIN /= 0) Then
        !   nVec = nIN*nIS
        ! End If
        If (nAS*nIS /= 0) Then
          Call RHS_ALLO(nAS,nIS,ipTC)
          CALL RHS_READ_C(ipTC,iCase,iSym,iVecC2)
        End If
      End If

      ! finish if no contributions
      ! should we use the number of independent vectors?
      if (PM) then
        if (nASP*nISP == 0 .and. nASM*nISM == 0) return
      else
        if (nAS*nIS == 0) return
      end if

      call mma_allocate(WRK1,nBasT*nBasT,Label='WRK1')
      call mma_allocate(WRK2,nBasT*nBasT,Label='WRK2')

      nFroI = nFro(iSymI)
      nFroJ = nFro(iSymJ)
      nFroA = nFro(iSymA)
      nFroB = nFro(iSymB)
      nIshI = nIsh(iSymI)
      nIshJ = nIsh(iSymJ)
      nIshA = nIsh(iSymA)
      nIshB = nIsh(iSymB)
      nAshI = nAsh(iSymI)
      nAshJ = nAsh(iSymJ)
      nAshA = nAsh(iSymA)
      nAshB = nAsh(iSymB)
      nSshA = nSsh(iSymA)
      nSshB = nSsh(iSymB)
      nBasI = nBas(iSymI)
      nBasJ = nBas(iSymJ)
      nBasA = nBas(iSymA)
      nBasB = nBas(iSymB)

      nCorI = nFroI+nIshI
      nCorJ = nFroJ+nIshJ
      nCorA = nFroA+nIshA
      nCorB = nFroB+nIshB
      nOccA = nCorA+nAshA
      nOccB = nCorB+nAshB
      nOccA2= nOccA-nFroA
      nOccB2= nOccB-nFroB
      nOrbA = nOccA+nSshA

      ! nOcc  = nFro(iSym)+nIsh(iSym)+nAsh(iSym)

      !! active+virtual part for the right index
!     nJ = nFro(iSymJ)+nIsh(iSymJ)+nAsh(iSymJ)

      If (iCase == 1) Then
        Call OLagNS_A(Amp1)
      Else If (iCase == 2.or.iCase == 3) Then
        Call OLagNS_B(Amp1)
      Else If (iCase == 4) Then
        Call OLagNS_C(Amp1)
      Else If (iCase == 5) Then
        Call OLagNS_D(Amp1)
      Else If (iCase == 6.or.iCase == 7) Then
        Call OLagNS_E(Amp1)
      Else If (iCase == 8.or.iCase == 9) Then
        Call OLagNS_F(Amp1)
      Else If (iCase == 10.or.iCase == 11) Then
        Call OLagNS_G(Amp1)
      Else If (iCase == 12.or.iCase == 13) Then
        Call OLagNS_H(Amp1)
      End If

      call mma_deallocate(WRK1)
      call mma_deallocate(WRK2)

      If (PM) Then
        If (nASP*nISP /= 0) Call RHS_FREE(ipTCP)
        If (nASM*nISM /= 0) Call RHS_FREE(ipTCM)
      Else
        If (nAS*nIS /= 0) Call RHS_FREE(ipTC)
      End If

      Return

      Contains
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_A(AmpL1)

      implicit none

      real(kind=wp), intent(out) :: AmpL1(nAshA,nAshB)
      integer(kind=iwp) :: iI, iJ, iA, iB

      if (nAshI*nIshJ*nAshA*nAshB == 0) return

      ! nJ = nIshJ
      Do iI = 1, nAshI
        iIabs = iI + nIshI + nAes(iSymI)
        ! iItot = iI + nCorI
!       If (iSymI == iSymJ) nJ = iI
        Do iJ = 1, nIshJ
          iJabs = iJ + nIes(iSymJ)
          iJtot = iJ + nFroJ
!         If (iIabs < iJabs) Cycle
          Fac = One
!         If ((iI /= iJ).and.(iSymI == iSymJ)) Fac = Two
          If (iSymI /= iSymJ) Fac = Two

          Call Exch(iSymA,iSymI,iSymB,iSymJ,
     &              iI+nCorI,iJ+nFroJ,
     &              ERI1,Scr)

          AmpL1(:,:) = Zero

          Do iA = 1, nAshA
            iAabs = iA + nAes(iSymA)
            ! iAtot = iA + nCorA
            Do iB = 1, nAshB
              iBabs = iB + nAes(iSymB)
              iBtot = iB + nCorB

              iTabs = iBabs
              iUabs = iI + nAes(iSymI)
              iVabs = iAabs
              IW1 = kTUV(iTabs,iUabs,iVabs) - nTUVes(iSym)
!             ValA = Zero
!             Do iICB = 1, nIN
!               iVA  = iICB + nIN*(iJabs-1)
!               ValA  = ValA
!    *        + Work(ipT+iVA-1)*Work(LST+IW1-1+nAS*(iICB-1))
!             End Do
!             ValA = ValA*Two
              iIS = iJabs
              iAS = IW1
              ValA = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two

              If (iUabs == iVabs) Then
                !! For FIMO derivative
                DPT2C(iBtot+nOrbA*(iJtot-1))
     &            = DPT2C(iBtot+nOrbA*(iJtot-1)) + ValA
              End If

              AmpL1(iA,iB) = AmpL1(iA,iB) + ValA
            End Do
          End Do

          AmpL1(:,:) = AmpL1(:,:)*Fac

          !! Calculate the actual contributions
          !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
          Call OLagNS_post1(1,1,ERI1,AmpL1)

          !! Prepare for implicit (VV|VO) integrals
          !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
          !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
          Call OLagNS_post2(nAshA,nAshB,nCorA,nCorB,AmpL1,WRK2)
          !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
          Call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
        End Do
      End Do

      End Subroutine OLagNS_A
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_B(AmpL1)

      implicit none

      real(kind=wp), intent(out) :: AmpL1(nAshA,nAshB)
      integer(kind=iwp) :: iI, iJ, iA, iB

      if (nIshI*nIshJ*nAshA*nAshB == 0) return

      nJ = nIshJ
      Do iI = 1, nIshI
        iIabs = iI + nIes(iSymI)
        ! iItot = iI + nFroI
        If (iSymI == iSymJ) nJ = iI
        Do iJ = 1, nJ
          iJabs = iJ + nIes(iSymJ)
          ! iJtot = iJ + nFroJ
          If (iIabs < iJabs) Cycle
          Fac = One
!         If ((iI /= iJ).and.(iSymI == iSymJ)) Fac = Two
          If (iSymI /= iSymJ) Fac = Two

          Call Exch(iSymA,iSymI,iSymB,iSymJ,
     &              iI+nFroI,iJ+nFroJ,
     &              ERI1,Scr)

          AmpL1(:,:) = Zero

          Do iA = 1, nAshA
            iAabs = iA + nAes(iSymA)
            ! iAtot = iA + nCorA
            Do iB = 1, nAshB
              iBabs = iB + nAes(iSymB)
              ! iBtot = iB + nCorB

              if (iaabs > ibabs) then
                iTabs = iAabs
                iUabs = iBabs
              else
                iTabs = iBabs
                iUabs = iAabs
              end if
              iViP  = kIgeJ(iIabs,iJabs)-nIgeJes(iSym) ! inactive
              iVaP  = kTgeU(iTabs,iUabs)-nTgeUes(iSym) !   active
              iViM  = kIgtJ(iIabs,iJabs)-nIgtJes(iSym)
              iVaM  = kTgtU(iTabs,iUabs)-nTgtUes(iSym)
              !! transform internally contracted (SR)
              !!        to contravariant (C)
              ValBP = Zero
              ValBM = Zero
!             Do iICB = 1, nINP
!               iVP  = iICB + nINP*(iViP-1)
!               ValBP = ValBP
!    *        + Work(ipTP+iVP-1)*Work(LSTP+iVaP-1+nASP*(iICB-1))
!             End Do
              iIS = iViP
              iAS = iVaP
              ValBP = GA_Arrays(ipTCP)%A(iAS+nASP*(iIS-1))
              If (iAabs /= iBabs .and. iIabs /= iJabs) Then
                If (iIabs /= iJabs) Then
!                 Do iICB = 1, nINM
!                   iVM  = iICB + nINM*(iViM-1)
!                   ValBM = ValBM
!    *          + Work(ipTM+iVM-1)*Work(LSTM+iVaM-1+nASM*(iICB-1))
!                 End Do
                  iIS = iViM
                  iAS = iVaM
                  ValBM = GA_Arrays(ipTCM)%A(iAS+nASM*(iIS-1))
                End If
                !! permutated
                If (iAabs < iBabs) ValBM = -ValBM
              End If
              If (iIabs == iJabs) ValBP = ValBP*SQI2
!
              AmpL1(iA,iB) = AmpL1(iA,iB) + ValBP + ValBM
            End Do
          End Do

          AmpL1(:,:) = AmpL1(:,:)*Fac

          !! Calculate the actual contributions
          !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
          Call OLagNS_post1(1,1,ERI1,AmpL1)

          !! Prepare for implicit (VV|VO) integrals
          !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
          !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
          Call OLagNS_post2(nAshA,nAshB,nCorA,nCorB,AmpL1,WRK2)
          !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
          Call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
        End Do
      End Do

      End Subroutine OLagNS_B
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_C(AmpL1)

      implicit none

      real(kind=wp), intent(out) :: AmpL1(nAshA+nSshA,nAshB+nSshB)
      integer(kind=iwp) :: iI, iJ, iA, iB, iXabs

      if (nAshI*nAshJ*nSshA*nAshB == 0) return

      ! nJ = nIshJ
      Do iI = 1, nAshI
        iIabs = iI + nIshI + nAes(iSymI)
        ! iItot = iI + nCorI
!       If (iSymI == iSymJ) nJ = iI
        Do iJ = 1, nAshJ
          iJabs = iJ + nIshJ + nAes(iSymJ)
          ! iJtot = iJ + nCorJ
          If (iIabs < iJabs) Cycle
          Fac = One
!         If ((iI /= iJ).and.(iSymI == iSymJ)) Fac = Two
          If (iSymI /= iSymJ) Fac = Two

          Call Exch(iSymA,iSymI,iSymB,iSymJ,
     &              iI+nCorI,iJ+nCorJ,
     &              ERI1,Scr)

          AmpL1(:,:) = Zero

          Do iA = 1, nSshA
            iAabs = iA + nSes(iSymA)
            iAtot = iA + nFroA + nIshA + nAshA
            Do iB = 1, nAshB
              iBabs = iB + nAes(iSymB)
              iBtot = iB + nCorB

              iTabs = iI + nAes(iSymI)
              iUabs = iBabs
              iVabs = iJ + nAes(iSymJ)
!             write(u6,*) itabs,iuabs,ivabs
              !! (at|uv) -> (ai|bj) -> (at|uv)
              ! IW1 = kTUV(iTabs,iUabs,iVabs) - nTUVes(iSym)
              ValC1 = Zero
              ValC2 = Zero
!             Do iICB = 1, nIN
!               iV  = iICB + nIN*(iAabs-1)
!               ValC1 = ValC1
!    *        + Work(ipT+iV-1)*Work(LST+IW1-1+nAS*(iICB-1))
!             End Do
!             If (iIabs /= iJabs) Then
!               IW1 = kTUV(iVabs,iUabs,iTabs) - nTUVes(iSym)
!               Do iICB = 1, nIN
!                 iV  = iICB + nIN*(iAabs-1)
!                 ValC2 = ValC2
!    *          + Work(ipT+iV-1)*Work(LST+IW1-1+nAS*(iICB-1))
!               End Do
!             End If
!
!             ValC1 = ValC1*Two
!             ValC2 = ValC2*Two
!
              iIS = iAabs
              iAS = kTUV(iTabs,iUabs,iVabs) - nTUVes(iSym)
              ValC1 = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two
              If (iIabs /= iJabs) Then
                iAS = kTUV(iVabs,iUabs,iTabs) - nTUVes(iSym)
                ValC2 = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two
              End If

              iTabs = iBabs
              iUabs = iI + nAes(iSymI)
              iVabs = iJ + nAes(iSymJ)
              If (iUabs == iVabs) Then
                !! For FIMO derivative
                ONEADD = Zero
!               IW1 = kTUV(iTabs,iUabs,iVabs) - nTUVes(iSym)
!               Do iICB = 1, nIN
!                 iV  = iICB + nIN*(iAabs-1)
!                 ONEADD = ONEADD
!    *          + Work(ipT+iV-1)*Work(LST+IW1-1+nAS*(iICB-1))
!               End Do
!               ONEADD = ONEADD*Two
                iAS = kTUV(iTabs,iUabs,iVabs) - nTUVes(iSym)
                ONEADD = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two
                DPT2C(iAtot+nOrbA*(iBtot-1))
     &            = DPT2C(iAtot+nOrbA*(iBtot-1)) + ONEADD

                !! For -sum(y)(ay,yt) -> (ay,ty) derivative
                !! It is correct, but should be rewritten
!               ONEADD = Zero
!               Do iXabs = 1, nAshI !?
!                 IW1 = kTUV(iTabs,iXabs,iXabs) - nTUVes(iSym)
!                 Do iICB = 1, nIN
!                   iV  = iICB + nIN*(iAabs-1)
!                   ONEADD = ONEADD
!    *            + Work(ipT+iV-1)*Work(LST+IW1-1+nAS*(iICB-1))
!                 End Do
!               End Do
!               ONEADD = Two*ONEADD/DBLE(MAX(1,NACTEL))
                ONEADD = Zero
                Do iXabs = 1, nAshI !?
                  iAS = kTUV(iTabs,iXabs,iXabs) - nTUVes(iSym)
                  ONEADD = ONEADD
     &                   + GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))
                End Do
                ONEADD = Two*ONEADD/real(MAX(1,NACTEL),kind=wp)
                AmpL1(iAtot-nCorA,iBtot-nCorA)
     &            = AmpL1(iAtot-nCorA,iBtot-nCorA) - ONEADD
              End If
              AmpL1(iAtot-nCorA,iBtot-nCorB)
     &          = AmpL1(iAtot-nCorA,iBtot-nCorB) + ValC1
              AmpL1(iBtot-nCorB,iAtot-nCorA)
     &          = AmpL1(iBtot-nCorB,iAtot-nCorA) + ValC2
            End Do
          End Do

          AmpL1(:,:) = AmpL1(:,:)*Fac

          !! Calculate the actual contributions
          !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
          Call OLagNS_post1(3,3,ERI1,AmpL1)

          !! Prepare for implicit (VV|VO) integrals
          !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
          !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
          Call OLagNS_post2(nAshA+nSshA,nAshB+nSshB,nCorA,nCorB,
     &                      AmpL1,WRK2)
          !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
          Call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
        End Do
      End Do

      End Subroutine OLagNS_C
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_D(AmpL1)

      implicit none

      real(kind=wp), intent(out) :: AmpL1(nAshA+nSshA,nAshB+nSshB)
      integer(kind=iwp) :: iI, iJ, iA, iB

      if (nAshI*nIshJ*nSshA*nAshB == 0) return

      ! nJ = nIshJ
      Do iI = 1, nAshI
        iIabs = iI + nIshI + nAes(iSymI)
        iItot = iI + nCorI
!       If (iSymI == iSymJ) nJ = iI
        Do iJ = 1, nIshJ
          iJabs = iJ + nIes(iSymJ)
          iJtot = iJ + nFroJ
!         If (iIabs < iJabs) Cycle
          Fac = One
!         If ((iI /= iJ).and.(iSymI == iSymJ)) Fac = Two
          If (iSymI /= iSymJ) Fac = Two

          Call Exch(iSymA,iSymI,iSymB,iSymJ,
     &              iI+nCorI,iJ+nFroJ,
     &              ERI1,Scr)

          AmpL1(:,:) = Zero

          Do iA = 1, nSshA
            iAabs = iA + nSes(iSymA)
            iAtot = iA + nFroA + nIshA + nAshA
            Do iB = 1, nAshB
              ! iBabs = iB + nAes(iSymB)
              iBtot = iB + nCorB
!
!             iVi   = iJabs + nIshA*(iAabs-1)+IOFF1(iSymA)
!             iVa1  = iB + nAshB*(iI+nAes(iSymI)-1)+IOFF1(iSymB)
!             iVa2  = iB + nAshB*(iI+nAes(iSymI)-1)+IOFF1(iSymB)
!    *                   + nAshT*nAshT
!             !! transform internally contracted (SR)
!             !!        to contravariant (C)
!             ValD1 = Zero
!             ValD2 = Zero
!             Do iICB = 1, nIN
!               iVD   = iICB + nIN*(iVi-1)
!               ValD1 = ValD1
!    *        + Work(ipT+iVD-1)*Work(LST+iVa1-1+nAS*(iICB-1))
!               ValD2 = ValD2
!    *        + Work(ipT+iVD-1)*Work(LST+iVa2-1+nAS*(iICB-1))
!             End Do
!             ValD1 = ValD1*Two
!             ValD2 = ValD2*Two
              iIS = iJabs + nIshA*(iAabs-1)+iOFF1(iSymA)
              iAS = kTU(iB,iI)-nTUes(iSymA)
              ValD1 = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two
              iAS = iAS + nTU(iSymA)
              ValD2 = GA_Arrays(ipTC)%A(iAS+nAS*(iIS-1))*Two

              !! Fock contributions from the inactive density
              If (iItot == iBtot) Then
                DPT2C(iAtot+nOrbA*(iJtot-1))
     &            = DPT2C(iAtot+nOrbA*(iJtot-1)) + ValD1
              End If

              AmpL1(iA+nAshA,iB) = AmpL1(iA+nAshA,iB) + ValD2
              AmpL1(iB,iA+nAshB) = AmpL1(iB,iA+nAshB) + ValD1
            End Do
          End Do

          AmpL1(:,:) = AmpL1(:,:)*Fac

          !! Calculate the actual contributions
          !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
          Call OLagNS_post1(3,3,ERI1,AmpL1)

          !! Prepare for implicit (VV|VO) integrals
          !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
          !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
          Call OLagNS_post2(nAshA+nSshA,nAshB+nSshB,nCorA,nCorB,
     &                      AmpL1,WRK2)
          !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
          Call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
        End Do
      End Do

      End Subroutine OLagNS_D
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_E(AmpL1)

      implicit none

      real(kind=wp), intent(out) :: AmpL1(nAshA+nSshA,nAshB+nSshB)
      integer(kind=iwp) :: iI, iJ, iA, iB

      if (nIshI*nIshJ*nSshA*nAshB == 0) return

      nJ = nIshJ
      Do iI = 1, nIshI
        iIabs = iI + nIes(iSymI)
        ! iItot = iI
        If (iSymI == iSymJ) nJ = iI
        Do iJ = 1, nJ
          iJabs = iJ + nIes(iSymJ)
          ! iJtot = iJ
          If (iIabs < iJabs) Cycle
          Fac = One
!         If ((iI /= iJ).and.(iSymI == iSymJ)) Fac = Two
          If (iSymI /= iSymJ) Fac = Two

          Call Exch(iSymA,iSymI,iSymB,iSymJ,
     &              iI+nFroI,iJ+nFroJ,
     &              ERI1,Scr)

          AmpL1(:,:) = Zero

          IgeJ  = kIgeJ(iIabs,iJabs) - nIgeJes(iSym) ! iSymIJ
          IgtJ  = kIgtJ(iIabs,iJabs) - nIgtJes(iSym) ! iSymIJ
          Do iA = 1, nSshA
            iAabs = iA + nSes(iSymA)
            ! iAtot = iA + nIshA + nAshA
            Do iB = 1, nAshB
              iBabs = iB + nAes(iSymB)
              ! iBtot = iB + nIshB

              iASP  = iBabs
              iISP  = iAabs + nSshA*(IgeJ-1)+iOFF1(iSymA)
              ValEP = GA_Arrays(ipTCP)%A(iASP+nASP*(iISP-1))
              ValEM = Zero
              If (iIabs > iJabs) Then
                ValEP = ValEP * SQ2
                iASM  = iBabs
                iISM  = iAabs + nSshA*(IgtJ-1)+iOFF1(iSymA)
                ValEM = GA_Arrays(ipTCM)%A(iASM+nASM*(iISM-1))
     &                *SQ2*SQ3
              Else
              End If

              AmpL1(iA+nAshA,iB) = AmpL1(iA+nAshA,iB) + ValEP + ValEM
              AmpL1(iB,iA+nAshB) = AmpL1(iB,iA+nAshB) + ValEP - ValEM
            End Do
          End Do

          AmpL1(:,:) = AmpL1(:,:)*Fac

          !! Calculate the actual contributions
          !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
          Call OLagNS_post1(3,3,ERI1,AmpL1)

          !! Prepare for implicit (VV|VO) integrals
          !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
          !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
          Call OLagNS_post2(nAshA+nSshA,nAshB+nSshB,nCorA,nCorB,
     &                      AmpL1,WRK2)
          !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
          Call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
        End Do
      End Do

      End Subroutine OLagNS_E
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_F(AmpL1)

      implicit none

      real(kind=wp), intent(out) :: AmpL1(nSshA,nSshB)
      integer(kind=iwp) :: iI, iJ, iA, iB

      if (nAshI*nAshJ*nSshA*nSshB == 0) return

      ! nJ = nIshJ
      Do iI = 1, nAshI
        iIabs = iI + nIshI + nAes(iSymI)
        ! iItot = iI + nCorI
!       If (iSymI == iSymJ) nJ = iI
        Do iJ = 1, nAshI
          iJabs = iJ + nIshJ + nIes(iSymJ)
          ! iJtot = iJ + nCorJ
          If (iIabs < iJabs) Cycle
          Fac = One
!         If ((iI /= iJ).and.(iSymI == iSymJ)) Fac = Two
          If (iSymI /= iSymJ) Fac = Two

          Call Exch(iSymA,iSymI,iSymB,iSymJ,
     &              iI+nCorI,iJ+nCorJ,
     &              ERI1,Scr)

          AmpL1(:,:) = Zero

          iTabs = iI + nAes(iSymI)
          iUabs = iJ + nAes(iSymJ)
          Do iA = 1, nSshA
            iAabs = iA + nSes(iSymA)
            ! iAtot = iA + nIsh(iSymA) + nAsh(iSymA)
            Do iB = 1, nSshB
              iBabs = iB + nSes(iSymB)
              If (iAabs < iBabs) Cycle
              ! iBtot = iB + nIsh(iSymB) + nAsh(iSymB)

              iASP  = kTgeU(iTabs,iUabs)-nTgeUes(iSym)
              iISP  = kAgeB(iAabs,iBabs)-nAgeBes(iSym)
              ValFP = GA_Arrays(ipTCP)%A(iASP+nASP*(iISP-1))
              If (iIabs == iJabs) ValFP = ValFP*Half
              ValFM = Zero
              If (iAabs /= iBabs) Then
                If (iTabs /= iUabs) Then
                  iASM  = kTgtU(iTabs,iUabs)-nTgtUes(iSym)
                  iISM  = kAgtB(iAabs,iBabs)-nAgtBes(iSym)
                  ValFM = GA_Arrays(ipTCM)%A(iASM+nASM*(iISM-1))
                End If
              Else
                ValFP = ValFP * SQI2
              End If
              VALFM = -VALFM !! why?

              AmpL1(iA,iB) = AmpL1(iA,iB) + ValFP + ValFM
              AmpL1(iB,iA) = AmpL1(iB,iA) + ValFP - ValFM
            End Do
          End Do

          AmpL1(:,:) = AmpL1(:,:)*Fac

          !! Calculate the actual contributions
          !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
          Call OLagNS_post1(2,2,ERI1,AmpL1)

          !! Prepare for implicit (VV|VO) integrals
          !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
          !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu}
          Call OLagNS_post2(nSshA,nSshB,nOccA,nOccB,AmpL1,WRK2)
          !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
          Call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
        End Do
      End Do

      End Subroutine OLagNS_F
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_G(AmpL1)

      implicit none

      real(kind=wp), intent(out) :: AmpL1(nSshA,nSshB)
      integer(kind=iwp) :: iI, iJ, iA, iB

      if (nAshI*nIshJ*nSshA*nSshB == 0) return

      ! nJ = nIshJ
      Do iI = 1, nAshI
        iIabs = iI + nIshI + nAes(iSymI)
        ! iItot = iI + nCorI
!       If (iSymI == iSymJ) nJ = iI
        Do iJ = 1, nIshI
          iJabs = iJ + nIes(iSymJ)
          ! iJtot = iJ
!         If (iIabs < iJabs) Cycle
          Fac = One
!         If ((iI /= iJ).and.(iSymI == iSymJ)) Fac = Two
          If (iSymI /= iSymJ) Fac = Two

          Call Exch(iSymA,iSymI,iSymB,iSymJ,
     &              iI+nCorI,iJ+nFroJ,
     &              ERI1,Scr)

          AmpL1(:,:) = Zero

          Do iA = 1, nSshA
            iAabs = iA + nSes(iSymA)
            ! iAtot = iA + nIsh(iSymA) + nAsh(iSymA)
            Do iB = 1, nSshB
              iBabs = iB + nSes(iSymB)
              If (iAabs < iBabs) Cycle
              ! iBtot = iB + nIsh(iSymB) + nAsh(iSymB)

              iAgeB = kAgeB(iAabs,iBabs)-nAgeBes(iSym) !! iSymAB
              iVjP  = iJ + nIsh(iSymJ)*(iAgeB-1)+IOFF1(iSymJ)
              ValGP = GA_Arrays(ipTCP)%A(iI+nASP*(iVjP-1))
              ValGM = Zero
              If (iAabs /= iBabs) Then
                ValGP = ValGP * SQ2
                iAgtB = kAgtB(iAabs,iBabs) - nAgtBes(iSym) !! iSymAB
                iVjM  = iJ + nIsh(iSymJ)*(iAgtB-1)+IOFF2(iSymJ)
                ValGM = GA_Arrays(ipTCM)%A(iI+nASM*(iVjM-1))*SQ2*SQ3
              End If

              AmpL1(iA,iB) = AmpL1(iA,iB) + ValGP + ValGM
              AmpL1(iB,iA) = AmpL1(iB,iA) + ValGP - ValGM
            End Do
          End Do

          AmpL1(:,:) = AmpL1(:,:)*Fac

          !! Calculate the actual contributions
          !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
          Call OLagNS_post1(2,2,ERI1,AmpL1)
!         Call DGEMM_('N','T',nOrbA,nSshA,nSshB,
!    *                One,ERI1(1+nOrbA*nOccB),nOrbA,
!    *                        AmpL1,nSshA,
!    *                One,OLAG(nOrbA*nOccB+1),nOrbA)
!         Call DGEMM_('T','N',nOrbA,nSshA,nSshB,
!    *                One,ERI1(nOccA+1),nOrbA,
!    *                        AmpL1,nSshA,
!    *                One,OLAG(nOrbA*nOccB+1),nOrbA)

          !! Prepare for implicit (VV|VO) integrals
          !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
          !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu} for all ij
          Call OLagNS_post2(nSshA,nSshB,nOccA,nOccB,AmpL1,WRK2)
          !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
          Call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
        End Do
      End Do

      End Subroutine OLagNS_G
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_H(AmpL1)

      implicit none

      real(kind=wp), intent(out) :: AmpL1(nSshA,nSshB)
      integer(kind=iwp) :: iI, iJ, iA, iB

      if (nIshI*nIshJ*nSshA*nSshB == 0) return

      nJ = nIshJ
      Do iI = 1, nIshI
        iIabs = iI + nIes(iSymI)
        ! iItot = iI
        If (iSymI == iSymJ) nJ = iI
        Do iJ = 1, nJ
          iJabs = iJ + nIes(iSymJ)
          ! iJtot = iJ
          If (iIabs < iJabs) Cycle
          Fac = One
!         If ((iI /= iJ).and.(iSymI == iSymJ)) Fac = Two
          If (iSymI /= iSymJ) Fac = Two

          Call Exch(iSymA,iSymI,iSymB,iSymJ,
     &              iI+nFroI,iJ+nFroJ,
     &              ERI1,Scr)

          AmpL1(:,:) = Zero

          iViHP0= kIgeJ(iIabs,iJabs) - nIgeJes(iSym)
          iViHP = nAgeB(iSym)*(iViHP0-1)
          iViHM0= kIgtJ(iIabs,iJabs) - nIgtJes(iSym)
          iViHM = nAgtB(iSym)*(iViHM0-1)
          Do iA = 1, nSshA
            iAabs = iA + nSes(iSymA)
            ! iAtot = iA + nIsh(iSymA) + nAsh(iSymA)
            Do iB = 1, nSshB
              iBabs = iB + nSes(iSymB)
              If (iAabs < iBabs) Cycle
              ! iBtot = iB + nIsh(iSymB) + nAsh(iSymB)
              iVaHP = kAgeB(iAabs,iBabs) - nAgeBes(iSym)
              iVHP  = iVaHP + iViHP !! nAgeB(iSym)*(iViP-1)

              ValHP = GA_Arrays(ipTCP)%A(iVHP)
              ValHM = Zero
              If (iIabs /= iJabs) Then
                If (iAabs /= iBabs) Then
                  ValHP = ValHP * Two
                  iVaHM = kAgtB(iAabs,iBabs) - nAgtBes(iSym)
                  iVHM  = iVaHM + iViHM !! nAgtB(iSym)*(iViM-1)
                  ValHM = GA_Arrays(ipTCM)%A(iVHM) * Two*SQ3
                Else
                  ValHP = ValHP * SQ2
                End If
              Else
                If (iAabs /= iBabs) ValHP = ValHP * SQ2
              End If

!     write(u6,'(2i3,2f20.10)')ia,ib,valhp,valhm
              AmpL1(iA,iB) = AmpL1(iA,iB) + ValHP + ValHM
              AmpL1(iB,iA) = AmpL1(iB,iA) + ValHP - ValHM
            End Do
          End Do

          AmpL1(:,:) = AmpL1(:,:)*Fac

          !! Calculate the actual contributions
          !! L_{pq} = sum_{j,ab} (pa|jb) * T_{qj}^{ab}
          Call OLagNS_post1(2,2,ERI1,AmpL1)
!         Call DGEMM_('N','T',nOrbA,nSshA,nSshB,
!    *                One,ERI1(1+nOrbA*nOccB),nOrbA,
!    *                        AmpL1,nSshA,
!    *                One,OLAG(nOrbA*nOccB+1),nOrbA)
!         Call DGEMM_('T','N',nOrbA,nSshA,nSshB,
!    *                One,ERI1(nOccA+1),nOrbA,
!    *                        AmpL1,nSshA,
!    *                One,OLAG(nOrbA*nOccB+1),nOrbA)
!
          !! Prepare for implicit (VV|VO) integrals
          !! T_{ij}^{ab} -> T_{ij}^{mu nu} back-transformation
          !! 1) T_{ij}^{ab} -> T_{ij}^{mu nu} for all ij
          Call OLagNS_post2(nSshA,nSshB,nOccA,nOccB,AmpL1,WRK2)
!         Call DGEMM_('N','N',nBasT,nSshA,nSshB,
!    *                One,CMOPT2(1+nBasT*nOccB),nBasT,
!    *                        AmpL1,nSshA,
!    *                Zero,WRK1,nBasT)
!         Call DGEMM_('N','T',nBasT,nBasT,nSshB,
!    *                One,WRK1,nBasT,
!    *                        CMOPT2(1+nBasT*nOccA),nBasT,
!    *                Zero,WRK2,nBasT)
          !! Reorder T_{ij}^{rho sigma} to T2AO(j,sigma,i,rho)
          Call OLagNS_post3(iIabs,iJabs,T2AO,WRK2)
!         Do iBas = 1, nBasT
!           Do jBas = 1, nBasT
!             loc1 = iJ-1 + (jBas-1)*nOccA2
!    *             + (iI-1)*nOccA2*nBasT + (iBas-1)*nOccA2*nBasT*nOccA2
!             loc2 = iI-1 + (jBas-1)*nOccA2
!    *             + (iJ-1)*nOccA2*nBasT + (iBas-1)*nOccA2*nBasT*nOccA2
!             loc3 = iBas-1 + (jBas-1)*nBasT
!             loc4 = jBas-1 + (iBas-1)*nBasT
!             T2AO(1+loc1) = T2AO(1+loc1) + WRK2(1+loc3)
!             T2AO(1+loc2) = T2AO(1+loc2) + WRK2(1+loc4)
!           End Do
!         End Do
        End Do
      End Do

      End Subroutine OLagNS_H
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_post1(iLeft,iRight,ERI,AmpMO)

      implicit none

      integer(kind=iwp), intent(in) :: iLeft, iRight
      real(kind=wp), intent(in) :: ERI(*), AmpMO(*)

      integer(kind=iwp) :: nSkpA, nSkpB, nDimA, nDimB

      nSkpA = 0
      nSkpB = 0
      nDimA = 0
      nDimB = 0
      If (iLeft == 1) Then
        nDimA = nAshA
        nSkpA = nCorA
      Else If (iLeft == 2) Then
        nDimA = nSshA
        nSkpA = nOccA
      Else If (iLeft == 3) Then
        nDimA = nAshA+nSshA
        nSkpA = nCorA
      End If
      If (iRight == 1) Then
        nDimB = nAshB
        nSkpB = nCorB
      Else If (iRight == 2) Then
        nDimB = nSshB
        nSkpB = nOccB
      Else If (iRight == 3) Then
        nDimB = nAshB+nSshB
        nSkpB = nCorB
      End If

      Call DGEMM_('N','T',nOrbA,nDimA,nDimB,
     &            One,ERI(1+nOrbA*nSkpB),nOrbA,AmpMO,nDimA,
     &            One,OLAG(nOrbA*nSkpB+1),nOrbA)
      Call DGEMM_('T','N',nOrbA,nDimA,nDimB,
     &            One,ERI(nSkpA+1),nOrbA,AmpMO,nDimA,
     &            One,OLAG(nOrbA*nSkpB+1),nOrbA)

      End Subroutine OLagNS_post1
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_post2(nDimA,nDimB,nSkpA,nSkpB,AmpMO,AmpAO)

      use caspt2_global, only: CMOPT2

      implicit none

      integer(kind=iwp), intent(in) :: nDimA, nDimB, nSkpA, nSkpB
      real(kind=wp), intent(in) :: AmpMO(nDimA,nDimB)
      real(kind=wp), intent(out) :: AmpAO(nBasA,nBasB)

       Call DGEMM_('N','N',nBasA,nDimB,nDimA,
     &             One,CMOPT2(1+nBasA*nSkpA),nBasA,AmpMO,nDimA,
     &             Zero,WRK1,nBasA)
       Call DGEMM_('N','T',nBasA,nBasB,nDimB,
     &             One,WRK1,nBasA,CMOPT2(1+nBasB*nSkpB),nBasA,
     &             Zero,AmpAO,nBasA)

      End Subroutine OLagNS_post2
!
!-----------------------------------------------------------------------
!
      Subroutine OLagNS_post3(iIabs,iJabs,TampAO,TampIJ)

      implicit none

      integer(kind=iwp), intent(in) :: iIabs, iJabs
      real(kind=wp), intent(inout) :: TampAO(nOccA2,nBasI,nOccB2,nBasJ)
      real(kind=wp), intent(in) :: TampIJ(nBasI,nBasJ)

      integer(kind=iwp) :: iBas, jBas

      Do iBas = 1, nBasI
        Do jBas = 1, nBasJ
          TampAO(iJabs,jBas,iIabs,iBas)
     &      = TampAO(iJabs,jBas,iIabs,iBas) + TampIJ(iBas,jBas)
          TampAO(iIabs,jBas,iJabs,iBas)
     &      = TampAO(iIabs,jBas,iJabs,iBas) + TampIJ(jBas,iBas)
        End Do
      End Do

      End Subroutine OLagNS_post3

      END SUBROUTINE OLagNS_Hel2
!
!-----------------------------------------------------------------------
!
! MO->AO or AO->MO transformation of 1-RDM
      Subroutine OLagTrf(mode,iSym,CMO,DPT2,DPT2AO,WRK)

      use caspt2_module, only: NFRO, NORB, NDEL, NBAS
      use Constants, only: Zero, One, Half
      use definitions, only: wp, iwp

      implicit none

#include "intent.fh"

      integer(kind=iwp), intent(in) :: mode, iSym
      real(kind=wp), intent(in) :: CMO(*)
      real(kind=wp), intent(inout) :: DPT2(*), DPT2AO(*)
      real(kind=wp), intent(_OUT_) :: WRK(*)

      real(kind=wp) :: Val
      integer(kind=iwp) :: iCMO, iAO, iMO, jSym, nBasI, nOrbI, iBas,
     &  jBas

      !! Mode = 1: MO -> AO transformation
      !! Mode = 2: AO -> MO transformation
      iCMO =1
      iAO = 1
      iMO = 1
      Do jSym = 1, iSym-1
        iCMO = iCMO + nBas(jSym)**2 !! ??
        iAO  = iAO  + nBas(jSym)**2
        iMO  = iMO  + (nOrb(jSym)+nFro(jSym))**2
      End Do

      If (nOrb(iSym)+nFro(iSym) > 0) Then
        nBasI = nBas(iSym)
        nOrbI = nBas(iSym)-nDel(iSym)
        If (Mode == 1) Then
          !! MO -> AO
          CALL DGEMM_('N','N',nBasI,nOrbI,nOrbI,
     &                One,CMO(iCMO),nBasI,DPT2(iMO),nOrbI,
     &                Zero,WRK,nBasI)
          CALL DGEMM_('N','T',nBasI,nBasI,nOrbI,
     &                One,WRK,nBasI,CMO(iCMO),nBasI,
     &                Zero,DPT2AO(iAO),nBasI)
          !! Symmetrize, just in case
          Do iBas = 1, nBasI
            Do jBas = 1, iBas-1
              Val =(DPT2AO(iAO+iBas-1+nBasI*(jBas-1))
     &            + DPT2AO(iAO+jBas-1+nBasI*(iBas-1)))*Half
              DPT2AO(iAO+iBas-1+nBasI*(jBas-1)) = Val
              DPT2AO(iAO+jBas-1+nBasI*(iBas-1)) = Val
            End Do
          End Do
        Else If (Mode == 2) Then
          !! AO -> MO
          CALL DGEMM_('T','N',nOrbI,nBasI,nBasI,
     &                One,CMO(iCMO),nBasI,DPT2AO(iAO),nBasI,
     &                Zero,WRK,nOrbI)
          CALL DGEMM_('N','N',nOrbI,nOrbI,nBasI,
     &                One,WRK,nOrbI,CMO(iCMO),nBasI,
     &                Zero,DPT2(iMO),nOrbI)
        End If
      END IF

      Return

      End Subroutine OLagTrf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! NOT TESTED (used for OFEmbed below)
!#define _OFEmbed_
subroutine ADD1HAM(H1EFF,nH1Eff)
! ----------------------------------------------------------------
! Purpose: Reads and adds one-electron naked Hamiltonian into H1EFF.
! Dress it with reaction field (if any).
! Also get POTNUC at the same time.

use Index_Functions, only: nTri_Elem
#ifdef _OFEmbed_
use RunFile_procedures, only: Get_dExcdRa
use OFembed, only: Do_OFemb, FMAux, OFE_First
#endif
use OneDat, only: sNoNuc, sNoOri
use caspt2_module, only: ERFSelf, nBas, NBTRI, nSym, PotNuc, RFpert
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nH1EFF
real(kind=wp), intent(inout) :: H1EFF(nH1Eff)
integer(kind=iwp) :: ICOMP, IOPT, IRC, ISYLBL, nTemp
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ISTLT, iSym
#endif
logical(kind=iwp) :: Found
character(len=8) :: Label
real(kind=wp), allocatable :: ONEHAM(:), Temp(:)
#ifdef _OFEmbed_
real(kind=wp), allocatable :: Coul(:)
#endif

! Add naked one-el Hamiltonian in AO basis to H1EFF:
call mma_allocate(ONEHAM,NBTRI,Label='OneHam')
IRC = -1
IOPT = ibset(ibset(0,sNoOri),sNoNuc)
ICOMP = 1
ISYLBL = 1
Label = 'OneHam'
call RDONE(IRC,IOPT,Label,ICOMP,ONEHAM,ISYLBL)
H1EFF(1:NBTRI) = H1EFF(1:NBTRI)+ONEHAM(:)
call mma_deallocate(ONEHAM)

! Read nuclear repulsion energy:
IRC = -1
IOPT = 0
ICOMP = 0
ISYLBL = 1
call Get_dScalar('PotNuc',PotNuc)

! If this is a perturbative reaction field calculation then
! modify the one-electron Hamiltonian by the reaction field and
! the nuclear attraction by the cavity self-energy
if (RFpert) then
  nTemp = sum(nTri_Elem(nBas(1:nSym)))
  call f_Inquire('RUNOLD',Found)
  if (Found) call NameRun('RUNOLD')
  call mma_allocate(Temp,nTemp,Label='Temp')
  call Get_dScalar('RF Self Energy',ERFSelf)
  call Get_dArray('Reaction field',Temp,nTemp)
  if (Found) call NameRun('#Pop')
  PotNuc = PotNuc+ERFself
  H1EFF(1:nTemp) = H1EFF(1:nTemp)+Temp(:)
  call mma_deallocate(Temp)
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' 1-EL HAMILTONIAN (MAY INCLUDE REACTION FIELD)'
ISTLT = 0
do ISYM=1,NSYM
  if (NBAS(ISYM) > 0) then
    write(u6,'(6X,A,I2)') ' SYMMETRY SPECIES:',ISYM
    call TRIPRT(' ',' ',H1EFF(1+ISTLT),NBAS(ISYM))
    ISTLT = ISTLT+nTri_Elem(NBAS(ISYM))
  end if
end do
#endif

#ifdef _OFEmbed_
! If this is a perturbative Orbital-Free Embedding (OFE) calculation
! then modify the one-electron Hamiltonian by the OFE potential and
! the nuclear attraction by the Rep_EN
if (Do_OFEmb) then
  nTemp = sum(nTri_Elem(nBas(1:nSym)))
  call mma_allocate(Coul,nTemp,Label='Coul')
  Coul(:) = Zero
  if (OFE_First) then
    call mma_allocate(FMaux,nTemp,Label='FMaux')
    call Coul_DMB(.true.,1,Rep_EN,FMaux,Coul,Coul,nTemp)
  end if
  H1EFF(1:nTemp) = H1EFF(1:nTemp)+FMaux(:)
  call mma_deallocate(Coul)
  OFE_First = .false.

  call NameRun('AUXRFIL') ! switch the RUNFILE name
  call Get_dExcdRa(Vxc,nVxc)
  H1EFF(1:nTemp) = H1EFF(1:nTemp)+Vxc(1:nTemp)
  if (nVxc == 2*nTemp) then ! but fix for Nuc Attr added twice
    H1EFF(1:nTemp) = H1EFF(1:nTemp)+Vxc(1+nTemp:2*nTemp)
    call Get_dArray('Nuc Potential',Vxc,nTemp)
    H1EFF(1:nTemp) = H1EFF(1:nTemp)-Vxc(1:nTemp)
  end if
  call mma_deallocate(Vxc)
  call NameRun('#Pop')    ! switch back to old RUNFILE
# ifdef _DEBUGPRINT_
  write(u6,*) ' 1-EL HAMILTONIAN INCLUDING OFE POTENTIAL'
  ISTLT = 0
  do ISYM=1,NSYM
    if (NBAS(ISYM) > 0) then
      write(u6,'(6X,A,I2)') ' SYMMETRY SPECIES:',ISYM
      call TRIPRT(' ',' ',H1EFF(1+ISTLT),NBAS(ISYM))
      ISTLT = ISTLT+nTri_Elem(NBAS(ISYM))
    end if
  end do
# endif
end if
#endif

end subroutine ADD1HAM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Niclas Forsberg                                  *
!               2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

!module InOutMod

!  Contains:
!    ReadInp
!    WriteLog
!    WriteDip
!    IntCalcHeader
!    ExpPointHeader
!    ISCHeader
!    WriteHeader
!    WrMold
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

!contains

subroutine ReadInp(Title,AtomLbl,Mass,InterVec,Bond,nBond,NumInt,NumOfAt,trfName1,trfName2,m_max,n_max,max_dip,max_term,MatEl, &
                   ForceField,Cartesian,lExpan,lISC,iCode,dMinWind)
!  Purpose:
!    Read the input file.
!
!  Output:
!    Title    : String - title of the project.
!    AtomLbl  : Array of character - contains the labels for the atoms.
!    Mass     : Real array - contains the mass of the atoms.
!    InterVec : Integer array - containis the atoms that are used in the calculations of each internal coordinate.
!    Bond     : Integer array - contains atom pairs that are to be bonded together in a plot.
!    nBond    : Integer - dim of Bond, i.e. 2*(number of bonds).
!    NumInt   : Integer - the total number of internal coordinates.
!    NumOfAt  : Integer - the number of atoms.
!    trfName  : Character array - type of transformation of variables.
!    m_max    : Integer - maximum level for the first state.
!    n_max    : Integer - maximum level for the second state.
!    m_plot   : Integer array - level(s) to plot for the first state.
!    n_plot   : Integer array - level(s) to plot for the second state.
!    max_dip  : Integer - highest order of term in transition dipole.
!    max_term : Integer - highest power of a term in polynomial fitted to energy values.
!    MatEl    : Logical
!    lISC     : Logical to calculate InterSystem Crossing
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.
!
!  Modified to use isotopes module
!    Ignacio Fdez. Galvan, 2017

use mula_global, only: AtCoord1, AtCoord2, broadplot, cmstart, cmend, energy1, energy2, hbarcm, Hess1, Hess2, Huge_Print, inpUnit, &
                       ipow, LifeTime, m_plot, MaxNumAt, n_plot, ndata, NormModes, nPolyTerm, nvar, OscStr, plotwindow, t_dipin1, &
                       t_dipin2, TranDip, TranDipGrad, Use_cm, Use_nm, var, VibModPlot, WriteVibLevels, yin1, yin2
use Isotopes, only: Isotope
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Eight, Quart, Angstrom, auTocm, auToeV, deg2rad, uToau
use Definitions, only: wp, iwp, u6

implicit none
character(len=80), intent(out) :: Title, trfName1(MaxNumAt), trfName2(MaxNumAt)
character(len=4), intent(out) :: AtomLbl(MaxNumAt)
real(kind=wp), intent(out) :: Mass(MaxNumAt), dMinWind
integer(kind=iwp), intent(out) :: InterVec(MaxNumAt*15), Bond(MaxNumAt*2), nBond, NumInt, NumOfAt, m_max, n_max, max_dip, max_term
logical(kind=iwp), intent(out) :: MatEl, ForceField, Cartesian, lExpan, lISC
integer(kind=iwp), intent(inout) :: iCode
integer(kind=iwp), parameter :: max_len_xvec = 150, max_plot_temp = 100
integer(kind=iwp) :: i, iAtom, icoord, idata, iend, ierror, ii, iInt, inpUnit1, inpUnit2, IntVal, iPrint, iStart, istatus, iStop, &
                     iterm, j, jvar, k, l, l_a, l_n, Length, m, modeTemp, n, nAtom, nFcart, nsum, Num, plot_temp(max_plot_temp)
                     !, AtData(120,4)
real(kind=wp) :: const, coord(1000,10), error, FWHM, GrdVal(1000,10), m1, m12, m2, m23, m3, r1, r2, rfact, sign1_1, sign1_2, &
                 sign2_1, sign2_2, theta, TmpCoord(3), xvec(max_len_xvec) !, MassData(400)
logical(kind=iwp) :: exists, XnotFound, YnotFound, ZnotFound
character(len=80) :: InLine, OutLine
character(len=9) :: CoordType
character(len=7) :: AtInp
character(len=6) :: PlUnit
character(len=4) :: Atom, Atom1, Atom2, Atom3, Atom4
character(len=3) :: DegOrRad
character(len=2) :: AAOrAu, AtName, Eunit !, AtList(0:120)
character :: c
integer(kind=iwp), allocatable :: GeoVec(:), tempmodes(:)
real(kind=wp), allocatable :: Fcart(:,:), ScaleParam(:), Sinv(:,:), SS(:,:), Temp(:,:)
character(len=*), parameter :: frmt = '(A80)'
! User-defined functions called:
integer(kind=iwp), external :: iPrintLevel, isfreeunit, iStrToInt
real(kind=wp), external :: StrToDble

! Read from MassFile:
! - name of atoms into array of string - AtList.
! - atomic number, default mass number, smallest mass number and
!   table offset into two dimensional array - AtData.
! - masses of all isotopes into array - MassData.

!i = 0
!call Molcas_Open(massUnit,'MASSUNIT')
!read(massUnit,frmt) InLine
! Read sequential lines from atomic data file.
!call Normalize(InLine,OutLine)
!do while (OutLine(1:4) /= 'END ')
!  l = Index(OutLine,'*')
!  if (l == 0) then
!    i = i+1
!    AtList(i) = OutLine(1:2)
!    read(OutLine(3:80),*) (AtData(i,j),j=1,4)
!  end if
!  read(massUnit,frmt) InLine
!  call Normalize(InLine,OutLine)
!end do
!iAtList = i

!i = 0
!read(massUnit,frmt) InLine
!call Normalize(InLine,OutLine)
!do while (OutLine(1:4) /= 'END ')
!  l = Index(OutLine,'*')
!  if (l == 0) then
!    i = i+1
!    read(OutLine,*) MassData(i)
!  end if
!  read(massUnit,frmt) InLine
!  call Normalize(InLine,OutLine)
!end do
!close(massUnit)
iPrint = iPrintLevel(-1)

! ----------------------------------------------------------------------
! TITLe: Read the title into a string - Title

Title = ' '
call KeyWord(inpUnit,'TITL',.true.,exists)
if (exists) read(inpUnit,frmt) Title

! TITLe: End -----------------------------------------------------------

! ----------------------------------------------------------------------
! ATOMs:  Process ATOMS

call KeyWord(inpUnit,'ATOM',.true.,exists)
NumOfAt = 0
read(inpUnit,frmt) InLine
call Normalize(InLine,OutLine)
do while (OutLine(1:4) /= 'END ')
  NumOfAt = NumOfAt+1
  read(inpUnit,frmt) InLine
  call Normalize(InLine,OutLine)
end do

! Read the labels of atoms into an array - AtomLbl.

call KeyWord(inpUnit,'ATOM',.true.,exists)
do nAtom=1,NumOfAt
  read(inpUnit,frmt) InLine
  call Normalize(InLine,OutLine)
  k = 1
  call WordPos(k,OutLine,iStart,iStop)
  k = iStop+1
  AtInp = ' '
  AtInp = OutLine(iStart:iStop)
  !- Check if a massnumber is given.
  Num = 0
  do i=1,7
    c = AtInp(i:i)
    IntVal = index('0123456789',c)-1
    if (IntVal >= 0) then
      Num = 10*Num+IntVal
    else
      exit
    end if
  end do
  if ((iStart+i-1) > iStop) then
    call WordPos(k,OutLine,iStart,iStop)
    AtInp = ' '
    AtInp = OutLine(iStart:iStop)
    i = 1
    c = AtInp(i:i)
  end if
  ! Extract atomic name and possible label.
  AtName = ' '
  AtomLbl(nAtom) = ' '
  j = 1
  do ii=i,7
    IntVal = index('0123456789',c)-1
    if ((IntVal < 0) .and. (c /= ' ')) then
      AtName(j:j) = c
      AtomLbl(nAtom)(j:j) = c
      j = j+1
      i = i+1
      c = AtInp(i:i)
    end if
  end do
  do ii=i,7
    IntVal = index('0123456789',c)-1
    if (((iStart+i-1) <= iStop) .and. (IntVal >= 0)) then
      AtomLbl(nAtom)(j:j) = c
      j = j+1
      i = i+1
      c = AtInp(i:i)
    end if
  end do
  ! Remove massnumber, atom and label from OutLine.
  Length = len(OutLine)
  OutLine = OutLine(iStop+1:Length)

  ! If mass is given in input, then read mass, else use MassData.
  k = 1
  call WordPos(k,OutLine,iStart,iStop)
  k = iStop
  if (k /= Length) then
    read(OutLine,*) Mass(nAtom)
  else
    !do i=1,iAtList
    !  if (AtList(i) == AtName ) exit
    !end do
    !if (Num == 0) then
    !  Num = AtData(i,2)
    !end if
    !Mass(nAtom) = MassData(AtData(i,4)+Num+1-AtData(i,3))
    call Isotope(Num,AtName,Mass(nAtom))
    Mass(nAtom) = Mass(nAtom)/uToau
    ! Print error message if the isotope is not listed in MassFile.
    !nOffset = AtData(i+1,4)
    !if ((Num > nOffset) .or. (Mass(nAtom) == -One)) then
    !  write(u6,*)
    !  write(u6,*) ' *************** ERROR *****************'
    !  write(u6,'(A,A2,A,I3,A)') ' The isotope of ',AtName,' with mass number ',Num
    !  write(u6,*) ' is not listed in MassFile.'
    !  write(u6,*) '****************************************'
    !  call Quit_OnUserError()
    !end if
  end if
end do

! ATOMs: End -----------------------------------------------------------

! ----------------------------------------------------------------------
! INTErnal: Resolve the different internal coordinates specified in the input.

call KeyWord(inpUnit,'INTE',.true.,exists)
j = 1
NumInt = 0
nBond = 0
read(inpUnit,frmt) InLine
call Normalize(InLine,OutLine)

do while (OutLine(1:4) /= 'END ')

  ! Bond Stretching.
  l = index(OutLine,'BOND')
  if (l /= 0) then
    k = l+len('BOND')
    call WordPos(k,OutLine,iStart,iStop)
    Atom1 = OutLine(iStart:iStop)
    k = iStop+1
    call WordPos(k,OutLine,iStart,iStop)
    Atom2 = OutLine(iStart:iStop)
    InterVec(j) = 1
    do i=1,NumOfAt
      if (Atom1 == AtomLbl(i)) then
        InterVec(j+1) = i
      else if (Atom2 == AtomLbl(i)) then
        InterVec(j+2) = i
      end if
    end do
    Bond(nBond+1) = InterVec(j+1)
    Bond(nBond+2) = InterVec(j+2)
    nBond = nBond+2
    j = j+3
    NumInt = NumInt+1
  end if
  ! Valence Angle Bending.
  l = index(OutLine,'ANGLE')
  if (l /= 0) then
    k = l+len('ANGLE')
    call WordPos(k,OutLine,iStart,iStop)
    Atom1 = OutLine(iStart:iStop)
    k = iStop+1
    call WordPos(k,OutLine,iStart,iStop)
    Atom2 = OutLine(iStart:iStop)
    k = iStop+1
    call WordPos(k,OutLine,iStart,iStop)
    Atom3 = OutLine(iStart:iStop)
    InterVec(j) = 2
    do i=1,NumOfAt
      if (Atom1 == AtomLbl(i)) then
        InterVec(j+1) = i
      else if (Atom2 == AtomLbl(i)) then
        InterVec(j+2) = i
      else if (Atom3 == AtomLbl(i)) then
        InterVec(j+3) = i
      end if
    end do
    j = j+4
    NumInt = NumInt+1
  end if
  ! Linear Valence Angle.
  l = index(OutLine,'LINANG')
  if (l /= 0) then
    k = l+len('LINANG')
    call WordPos(k,OutLine,iStart,iStop)
    Atom1 = OutLine(iStart:iStop)
    k = iStop+1
    call WordPos(k,OutLine,iStart,iStop)
    Atom2 = OutLine(iStart:iStop)
    k = iStop+1
    call WordPos(k,OutLine,iStart,iStop)
    Atom3 = OutLine(iStart:iStop)
    InterVec(j) = 3
    do i=1,NumOfAt
      if (Atom1 == AtomLbl(i)) then
        InterVec(j+1) = i
      else if (Atom2 == AtomLbl(i)) then
        InterVec(j+2) = i
      else if (Atom3 == AtomLbl(i)) then
        InterVec(j+3) = i
      end if
    end do
    j = j+4
    NumInt = NumInt+2
  end if
  ! Torsion.
  l = index(OutLine,'TORSION')
  if (l /= 0) then
    k = l+len('TORSION')
    call WordPos(k,OutLine,iStart,iStop)
    Atom1 = OutLine(iStart:iStop)
    call WordPos(k,OutLine,iStart,iStop)
    Atom2 = OutLine(iStart:iStop)
    call WordPos(k,OutLine,iStart,iStop)
    Atom3 = OutLine(iStart:iStop)
    call WordPos(k,OutLine,iStart,iStop)
    Atom4 = OutLine(iStart:iStop)
    InterVec(j) = 4
    do i=1,NumOfAt
      if (Atom1 == AtomLbl(i)) then
        InterVec(j+1) = i
      else if (Atom2 == AtomLbl(i)) then
        InterVec(j+2) = i
      else if (Atom3 == AtomLbl(i)) then
        InterVec(j+3) = i
      else if (Atom4 == AtomLbl(i)) then
        InterVec(j+4) = i
      end if
    end do
    j = j+5
    NumInt = NumInt+1
  end if
  ! Out of Plane Angle.
  l = index(OutLine,'OUTOFPL')
  if (l /= 0) then
    k = l+len('OUTOFPL')
    call WordPos(k,OutLine,iStart,iStop)
    Atom1 = OutLine(iStart:iStop)
    call WordPos(k,OutLine,iStart,iStop)
    Atom2 = OutLine(iStart:iStop)
    call WordPos(k,OutLine,iStart,iStop)
    Atom3 = OutLine(iStart:iStop)
    call WordPos(k,OutLine,iStart,iStop)
    Atom4 = OutLine(iStart:iStop)
    InterVec(j) = 5
    do i=1,NumOfAt
      if (Atom1 == AtomLbl(i)) then
        InterVec(j+1) = i
      else if (Atom2 == AtomLbl(i)) then
        InterVec(j+2) = i
      else if (Atom3 == AtomLbl(i)) then
        InterVec(j+3) = i
      else if (Atom4 == AtomLbl(i)) then
        InterVec(j+4) = i
      end if
    end do
    j = j+5
    NumInt = NumInt+1
  end if

  read(inpUnit,frmt) InLine
  call Normalize(InLine,OutLine)
end do

call mma_allocate(AtCoord1,3,NumOfAt,label='AtCoord1')
call mma_allocate(AtCoord2,3,NumOfAt,label='AtCoord2')
call mma_allocate(Hess1,NumInt,NumInt,label='Hess1')
call mma_allocate(Hess2,NumInt,NumInt,label='Hess2')
n = 3*NumOfAt
call mma_allocate(TranDipGrad,3,n,label='TranDipGrad')

! INTErnal: End --------------------------------------------------------

! ----------------------------------------------------------------------
! ISC: InterSystem Crossing. GG-30-Dec-08

lISC = .false.
dMinWind = Zero
call KeyWord(inpUnit,'ISC ',.true.,lISC)
if (lISC) then
  call KeyWord(inpUnit,'EXPF',.true.,exists)
  if (exists) then
    read(InpUnit,frmt) InLine
    call Normalize(InLine,Outline)
    read(OutLine,*) dMinWind
  end if
  call KeyWord(inpUnit,'OLDC',.true.,exists)
  if (exists) iCode = iCode+1
  call KeyWord(inpUnit,'DISK',.true.,exists)
  if (exists) iCode = iCode+10
end if

! ISC: End -------------------------------------------------------------

! ----------------------------------------------------------------------
! MODEs: Chose which modes to use in intensity calculations.

call KeyWord(inpUnit,'MODE',.true.,exists)
if (exists) then
  call mma_allocate(tempmodes,NumInt,label='tempmodes')
  read(inpUnit,frmt) InLine
  call Normalize(InLine,OutLine)
  i = 1
  do while (OutLine(1:4) /= 'END ')
    k = 1
    call WordPos(k,OutLine,iStart,iStop)
    do while (iStop < len(OutLine))
      tempModes(i) = iStrToInt(OutLine(iStart:iStop))
      if (tempModes(i) > NumInt) then
        write(u6,*)
        write(u6,*) ' *********** ERROR *************'
        write(u6,*) ' Too many normal modes specified'
        write(u6,*) ' *******************************'
        call Quit_OnUserError()
      end if
      i = i+1
      call WordPos(k,OutLine,iStart,iStop)
    end do
    read(inpUnit,frmt) InLine
    call Normalize(InLine,OutLine)
  end do
  n = i-1
  call mma_allocate(NormModes,n,label='NormModes')
  NormModes(:) = tempModes(1:n)
  call mma_deallocate(tempmodes)
  do i=1,n-1
    do j=i+1,n
      if (NormModes(j) < NormModes(i)) then
        modeTemp = NormModes(i)
        NormModes(i) = NormModes(j)
        NormModes(j) = modeTemp
      end if
    end do
  end do
else
  ! No MODEs specified
  call mma_allocate(NormModes,NumInt,label='NormModes')
  do i=1,NumInt
    NormModes(i) = i
  end do
  if (iPrint >= 1) then
    write(u6,*) ' *** Warning: MODEs not specified !'
    write(u6,*) '     All ',NumInt,' will be calculated.'
    write(u6,*)
  end if
end if

! MODEs: End -----------------------------------------------------------

! ----------------------------------------------------------------------
! MXLEvels: Maximun number of vibr. quanta in first and second state

call KeyWord(inpUnit,'MXLE',.true.,exists)
m_max = 0 ! Default
n_max = 1 ! Default
if (.not. exists) then
  if (iPrint >= 1) then
    write(u6,*) ' *** Warning: MXLEvels not specified !'
    write(u6,*) '     Default values are 0 and 1.'
    write(u6,*)
  end if
else
  read(inpUnit,*) m_max,n_max
end if

! MXLEvels: End --------------------------------------------------------

! ----------------------------------------------------------------------
! VARIational: Check if a full matrix element calculation or a
!              simpler harmonic approximation is wanted.

MatEl = .false.
call KeyWord(inpUnit,'VARI',.true.,MatEl)

! VARIational: End -----------------------------------------------------

! ----------------------------------------------------------------------
! TRANsitions: Check which transitions that are wanted in the output.

call KeyWord(inpUnit,'TRAN',.true.,exists)
if (.not. exists) then
  if (.not. lISC) then
    write(u6,*) ' *** Warning: TRANsitions not specified!'
    write(u6,*) '     All Levels will be printed.'
    write(u6,*)
  end if
  n = m_max+1
  do i=1,n
    plot_temp(i) = i-1
  end do
else
  call KeyWord(inpUnit,'FIRS',.false.,exists)
  read(inpUnit,frmt) InLine
  call Normalize(InLine,OutLine)
  k = 1
  i = 1
  call WordPos(k,OutLine,iStart,iStop)
  do while (iStop < len(OutLine))
    if (i > max_plot_temp) then
      write(u6,*)
      write(u6,*) ' ************ ERROR *************'
      write(u6,*) ' TRANsitions: i  >  max_plot_temp'
      write(u6,*) ' ********************************'
      call Quit_OnUserError()
    end if
    plot_temp(i) = iStrToInt(OutLine(iStart:iStop))
    if (plot_temp(i) > m_max) then
      write(u6,*)
      write(u6,*) ' ************* ERROR **************'
      write(u6,*) ' A quantum specified for the output'
      write(u6,*) ' is larger than max quantum.'
      write(u6,*) ' **********************************'
      call Quit_OnUserError()
    end if
    i = i+1
    call WordPos(k,OutLine,iStart,iStop)
  end do
  n = i-1
end if
call mma_allocate(m_plot,n,label='m_plot')
m_plot(:) = plot_temp(1:n)

call KeyWord(inpUnit,'TRAN',.true.,exists)
if (.not. exists) then
  n = n_max+1
  do i=1,n
    plot_temp(i) = i-1
  end do
else
  call KeyWord(inpUnit,'SECO',.false.,exists)
  read(inpUnit,frmt) InLine
  call Normalize(InLine,OutLine)
  k = 1
  i = 1
  call WordPos(k,OutLine,iStart,iStop)
  do while (iStop < len(OutLine))
    if (i > max_plot_temp) then
      write(u6,*)
      write(u6,*) ' *********** ERROR ************'
      write(u6,*) ' TRANsitions: i > max_plot_temp'
      write(u6,*) ' ******************************'
      call Quit_OnUserError()
    end if
    plot_temp(i) = iStrToInt(OutLine(iStart:iStop))
    if (plot_temp(i) > n_max) then
      write(u6,*)
      write(u6,*) ' ************* ERROR **************'
      write(u6,*) ' A quantum specified for the output'
      write(u6,*) ' is larger than max quantum.'
      write(u6,*) ' **********************************'
      call Quit_OnUserError()
    end if
    i = i+1
    call WordPos(k,OutLine,iStart,iStop)
  end do
  n = i-1
end if
call mma_allocate(n_plot,n,label='n_plot')
n_plot(:) = plot_temp(1:n)

! TRANsitions: End -----------------------------------------------------

call KeyWord(inpUnit,'FORC',.true.,Forcefield)
if (Forcefield) then

  !--------------------------------------------------------------------!
  !
  !                              Forcefield part
  !
  !--------------------------------------------------------------------!

  ! --------------------------------------------------------------------
  ! ENERgy: Read minimum energies for the two surfaces.

  call KeyWord(inpUnit,'ENER',.true.,exists)
  if (.not. exists) then
    write(u6,*)
    write(u6,*) ' ************** ERROR *************'
    write(u6,*) ' Electronic T_e energies not given.'
    write(u6,*) ' **********************************'
    call Quit_OnUserError()
  end if
  call KeyWord(inpUnit,'FIRS',.false.,exists)
  if (.not. exists) then
    write(u6,*)
    write(u6,*) ' ******************** ERROR *********************'
    write(u6,*) ' Electronic T_e energy for first state not given.'
    write(u6,*) ' ************************************************'
    call Quit_OnUserError()
  end if
  !read(inpUnit,*) energy1,Eunit
  !call Upcase(Eunit)
  ! Replace above two lines with:
  read(InpUnit,frmt) InLine
  call Normalize(InLine,Outline)
  read(OutLine,*) Energy1
  EUnit = 'AU'
  if (index(OutLine,'EV') > 0) EUnit = 'EV'
  if (index(OutLine,'CM') > 0) EUnit = 'CM'
  ! End of replacement.

  rfact = One
  if (Eunit == 'AU') rfact = One
  if (Eunit == 'EV') rfact = One/auToeV
  if (Eunit == 'CM') rfact = One/auTocm
  energy1 = energy1*rfact
  call KeyWord(inpUnit,'SECO',.false.,exists)
  if (.not. exists) then
    write(u6,*)
    write(u6,*) ' ******************** ERROR **********************'
    write(u6,*) ' Electronic T_e energy for second state not given.'
    write(u6,*) ' *************************************************'
    call Quit_OnUserError()
  end if
  !read(inpUnit,*) energy2,Eunit
  !call Upcase(Eunit)
  ! Replace above two lines with:
  read(InpUnit,frmt) InLine
  call Normalize(InLine,Outline)
  read(OutLine,*) Energy2
  EUnit = 'AU'
  if (index(OutLine,'EV') > 0) EUnit = 'EV'
  if (index(OutLine,'CM') > 0) EUnit = 'CM'
  ! End of replacement.
  if (Eunit == 'AU') rfact = One
  if (Eunit == 'EV') rfact = One/auToeV
  if (Eunit == 'CM') rfact = One/auTocm
  energy2 = energy2*rfact

  ! ENERgy: : End ------------------------------------------------------

  ! --------------------------------------------------------------------
  ! GEOMetries: Read geometries for the two surfaces.

  call KeyWord(inpUnit,'GEOM',.true.,exists)
  if (.not. exists) then
    write(u6,*)
    write(u6,*) ' ***** ERROR *******'
    write(u6,*) ' GEOMetry not found.'
    write(u6,*) ' *******************'
    call Quit_OnUserError()
  end if
  !D write(u6,*) ' READINP: Read geometry ("GEOMETRY").'
  !read(inpUnit,*) CoordType
  !call UpCase(CoordType)
  ! Replace above two lines with:
  read(InpUnit,frmt) InLine
  call Normalize(InLine,Outline)
  iend = index(OutLine,' ')
  CoordType = OutLine(1:iend-1)
  ! End of replacement.

  if (CoordType == 'FILE') then
    Coordtype = 'CARTESIAN'
    inpUnit1 = isfreeunit(31)
    inpUnit2 = isfreeunit(32)
    call molcas_open(inpUnit1,'UNSYM1')
    !open(31,'UNSYM1')
    call KeyWord(inpUnit1,'*LABEL COORDINATES CHARGE',.false.,exists)
    call molcas_open(inpUnit2,'UNSYM2')
    !open(32,'UNSYM2')
    call KeyWord(inpUnit2,'*LABEL COORDINATES CHARGE',.false.,exists)
  else
    inpUnit1 = inpUnit
    inpUnit2 = inpUnit
  end if

  if (CoordType == 'CARTESIAN') then
    Cartesian = .true.
    !D write(u6,*) ' READINP: Read cartesian coordinates for first state.'
    call KeyWord(inpUnit,'FIRS',.false.,exists)
    if (.not. exists) then
      write(u6,*)
      write(u6,*) ' ****** ERROR ********'
      write(u6,*) ' Wrong geometry input.'
      write(u6,*) ' *********************'
      call Quit_OnUserError()
    end if
    ierror = 0
    do iAtom=1,NumOfAt
      read(inpUnit1,frmt) InLine
      call UpCase(InLine)
      Atom = InLine(1:4)
      read(InLine(5:80),*) (TmpCoord(i),i=1,3)
      j = 10000000
      do i=1,NumOfAt
        if (Atom == AtomLbl(i)) j = i
      end do
      if (j > NumOfAt) then
        write(u6,*)
        write(u6,*) '*********** ERROR ***********'
        write(u6,*) ' Unrecognized atom label "'//Atom//'"'
        write(u6,*) '*****************************'
        ierror = ierror+1
      else
        AtCoord1(:,j) = TmpCoord(:)
      end if
    end do
    !D write(u6,*) ' READINP: Read cartesian coordinates for second state.'
    call KeyWord(inpUnit,'SECO',.false.,exists)
    if (.not. exists) then
      write(u6,*)
      write(u6,*) ' ****** ERROR ********'
      write(u6,*) ' Wrong geometry input.'
      write(u6,*) ' *********************'
      call Quit_OnUserError()
    end if
    do iAtom=1,NumOfAt
      read(inpUnit2,frmt) InLine
      call UpCase(InLine)
      Atom = InLine(1:4)
      read(InLine(5:80),*) (TmpCoord(i),i=1,3)
      j = 1
      do while (Atom /= AtomLbl(j))
        j = j+1
      end do
      if (j > NumOfAt) then
        write(u6,*)
        write(u6,*) '*********** ERROR ***********'
        write(u6,*) ' Unrecognized atom label "'//Atom//'"'
        write(u6,*) '*****************************'
        ierror = ierror+1
      else
        AtCoord2(:,j) = TmpCoord(:)
      end if
    end do

  else if (CoordType == 'INTERNAL') then

    Cartesian = .false.
    call KeyWord(inpUnit,'FIRS',.false.,exists)
    !D write(u6,*) ' READINP: Read internal coordinates for first state.'
    n = 5*(3*NumOfAt-5)
    ! Largest possible necessary GeoVec
    call mma_allocate(GeoVec,n,label='GeoVec')
    iInt = 1
    j = 1
    read(inpUnit,frmt) InLine
    call Normalize(InLine,OutLine)
    do while (OutLine(1:4) /= 'END ')
      ! Bond distance.
      l = index(OutLine,'BOND')
      if (l /= 0) then
        k = l+len('BOND')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        GeoVec(j) = 1
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        AAOrAu = OutLine(iStart:iStop)
        if (AAOrAu == 'AA') then
          xvec(iInt) = xvec(iInt)/Angstrom
        end if
        j = j+3
      end if
      ! Valence Angle.
      l = index(OutLine,'ANGLE')
      if (l /= 0) then
        k = l+len('ANGLE')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom3 = OutLine(iStart:iStop)
        GeoVec(j) = 2
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          else if (Atom3 == AtomLbl(i)) then
            GeoVec(j+3) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        DegOrRad = OutLine(iStart:iStop)
        if (DegOrRad == 'DEG') then
          xvec(iInt) = xvec(iInt)*deg2rad
        end if
        j = j+4
      end if
      ! Linear Valence Angle.
      l = index(OutLine,'LINANG')
      if (l /= 0) then
        k = l+len('LINANG')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom3 = OutLine(iStart:iStop)
        GeoVec(j) = 3
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          else if (Atom3 == AtomLbl(i)) then
            GeoVec(j+3) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        DegOrRad = OutLine(iStart:iStop)
        if (DegOrRad == 'DEG') then
          xvec(iInt) = xvec(iInt)*deg2rad
        end if
        j = j+4
      end if
      ! Dihedral angle.
      l = index(OutLine,'TORSION')
      if (l /= 0) then
        k = l+len('TORSION')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom3 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom4 = OutLine(iStart:iStop)
        GeoVec(j) = 4
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          else if (Atom3 == AtomLbl(i)) then
            GeoVec(j+3) = i
          else if (Atom4 == AtomLbl(i)) then
            GeoVec(j+4) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        DegOrRad = OutLine(iStart:iStop)
        if (DegOrRad == 'DEG') then
          xvec(iInt) = xvec(iInt)*deg2rad
        end if
        j = j+5
      end if
      ! Out of Plane Angle.
      l = index(OutLine,'OUTOFPL')
      if (l /= 0) then
        k = l+len('OUTOFPL')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom3 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom4 = OutLine(iStart:iStop)
        GeoVec(j) = 5
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          else if (Atom3 == AtomLbl(i)) then
            GeoVec(j+3) = i
          else if (Atom4 == AtomLbl(i)) then
            GeoVec(j+4) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        DegOrRad = OutLine(iStart:iStop)
        if (DegOrRad == 'DEG') then
          xvec(iInt) = xvec(iInt)*deg2rad
        end if
        j = j+5
      end if
      iInt = iInt+1
      read(inpUnit,frmt) InLine
      call Normalize(InLine,OutLine)
    end do
    iInt = iInt-1
    !call Int_to_Cart(GeoVec,xvec,AtCoord1,NumOfAt,iInt,Mass)
    l_a = NumOfAt
    l_n = max_len_xvec
    call Int_to_Cart1(GeoVec,xvec,AtCoord1,l_a,l_n)

    call mma_deallocate(GeoVec)

    call KeyWord(inpUnit,'SECO',.false.,exists)
    !D write(u6,*) ' READINP: Read internal coordinates for second state.'
    n = 5*(3*NumOfAt-5)
    call mma_allocate(GeoVec,n,label='GeoVec')
    iInt = 1
    j = 1
    read(inpUnit,frmt) InLine
    call Normalize(InLine,OutLine)
    do while (OutLine(1:4) /= 'END ')
      ! Bond distance.
      l = index(OutLine,'BOND')
      if (l /= 0) then
        k = l+len('BOND')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        GeoVec(j) = 1
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        AAOrAu = OutLine(iStart:iStop)
        if (AAOrAu == 'AA') then
          xvec(iInt) = xvec(iInt)/Angstrom
        end if
        j = j+3
      end if
      ! Valence Angle.
      l = index(OutLine,'ANGLE')
      if (l /= 0) then
        k = l+len('ANGLE')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom3 = OutLine(iStart:iStop)
        GeoVec(j) = 2
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          else if (Atom3 == AtomLbl(i)) then
            GeoVec(j+3) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        DegOrRad = OutLine(iStart:iStop)
        if (DegOrRad == 'DEG') then
          xvec(iInt) = xvec(iInt)*deg2rad
        end if
        j = j+4
      end if
      ! Linear Valence Angle.
      l = index(OutLine,'LINANG')
      if (l /= 0) then
        k = l+len('LINANG')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        Atom3 = OutLine(iStart:iStop)
        GeoVec(j) = 3
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          else if (Atom3 == AtomLbl(i)) then
            GeoVec(j+3) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        DegOrRad = OutLine(iStart:iStop)
        if (DegOrRad == 'DEG') then
          xvec(iInt) = xvec(iInt)*deg2rad
        end if
        j = j+4
      end if
      ! Dihedral angle.
      l = index(OutLine,'TORSION')
      if (l /= 0) then
        k = l+len('TORSION')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom3 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom4 = OutLine(iStart:iStop)
        GeoVec(j) = 4
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          else if (Atom3 == AtomLbl(i)) then
            GeoVec(j+3) = i
          else if (Atom4 == AtomLbl(i)) then
            GeoVec(j+4) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        DegOrRad = OutLine(iStart:iStop)
        if (DegOrRad == 'DEG') then
          xvec(iInt) = xvec(iInt)*deg2rad
        end if
        j = j+5
      end if
      ! Out of Plane Angle.
      l = index(OutLine,'OUTOFPL')
      if (l /= 0) then
        k = l+len('OUTOFPL')
        call WordPos(k,OutLine,iStart,iStop)
        Atom1 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom2 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom3 = OutLine(iStart:iStop)
        call WordPos(k,OutLine,iStart,iStop)
        Atom4 = OutLine(iStart:iStop)
        GeoVec(j) = 5
        do i=1,NumOfAt
          if (Atom1 == AtomLbl(i)) then
            GeoVec(j+1) = i
          else if (Atom2 == AtomLbl(i)) then
            GeoVec(j+2) = i
          else if (Atom3 == AtomLbl(i)) then
            GeoVec(j+3) = i
          else if (Atom4 == AtomLbl(i)) then
            GeoVec(j+4) = i
          end if
        end do
        call WordPos(k,OutLine,iStart,iStop)
        xvec(iInt) = StrToDble(OutLine(iStart:iStop))
        k = iStop+1
        call WordPos(k,OutLine,iStart,iStop)
        DegOrRad = OutLine(iStart:iStop)
        if (DegOrRad == 'DEG') then
          xvec(iInt) = xvec(iInt)*deg2rad
        end if
        j = j+5
      end if
      iInt = iInt+1
      read(inpUnit,frmt) InLine
      call Normalize(InLine,OutLine)
    end do
    iInt = iInt-1
    !call Int_to_Cart(GeoVec,xvec,AtCoord2,NumOfAt,iInt,Mass)
    l_a = NumOfAt
    l_n = max_len_xvec
    call Int_to_Cart1(GeoVec,xvec,AtCoord2,l_a,l_n)
    call mma_deallocate(GeoVec)
  end if

  if (inpUnit1 /= inpUnit) close(inpUnit1)
  if (inpUnit2 /= inpUnit) close(inpUnit2)

  ! GEOMetries: End ----------------------------------------------------

  ! --------------------------------------------------------------------
  ! MXORder: Read maximum order for the transition dipole moment.

  call KeyWord(inpUnit,'MXOR',.true.,exists)
  if (.not. exists) then
    if (.not. lISC) then
      write(u6,*) ' *** Warning: MXORder not specified !'
      write(u6,*) '     Transition Dipole is assumed as constant.'
      write(u6,*)
    end if
    max_dip = 0
  else
    read(inpUnit,*) max_dip
  end if

  ! MXORder: End -------------------------------------------------------

  ! --------------------------------------------------------------------
  ! OSCStr: Determines if you get the oscillator strength
  ! or the transition intensity in the output.

  OscStr = .false.
  if (.not. lISC) then
    call KeyWord(inpUnit,'OSCS',.true.,OscStr)
    if (OscStr) then
      write(u6,*) '     The Oscillator Strength will be calculated.'
      write(u6,*)
    else
      write(u6,*) '     The Intensity will be calculated.'
      write(u6,*)
    end if
  end if

  ! OSCStr: End --------------------------------------------------------

  ! --------------------------------------------------------------------
  ! NANOmeters: Generate plot file in nanometers.

  Use_nm = .false.
  if (.not. lISC) call KeyWord(inpUnit,'NANO',.true.,Use_nm)

  ! NANOmeters: End ----------------------------------------------------

  ! --------------------------------------------------------------------
  ! CM-1: Generate plot file in cm-1.

  Use_cm = .false.
  if (.not. lISC) call KeyWord(inpUnit,'CM-1',.true.,Use_cm)

  ! CM-1: End ----------------------------------------------------------

  ! --------------------------------------------------------------------
  ! PLOT: Enter the limits (in eV, cm-1 or in nm) for the plot file.

  cmstart = Zero
  cmend = Zero
  plotwindow = .false.
  if (.not. lISC) then
    call KeyWord(inpUnit,'PLOT',.true.,plotwindow)
    if (plotwindow) then
      read(inpUnit,*) cmstart,cmend
    end if
  end if

  ! PLOT : End ---------------------------------------------------------

  PlUnit = ' '
  broadplot = .false.
  LifeTime = 130.0e-15_wp
  if (.not. lISC) then
    if (Use_nm .and. Use_cm) then
      write(u6,*)
      write(u6,*) ' ***************** ERROR *******************'
      write(u6,*) ' NANOmeters and CM-1 are mutually exclusive.'
      write(u6,*) ' *******************************************'
      call Quit_OnUserError()
    end if
    if (Use_nm) then
      PlUnit = ' nm.'
      write(u6,*) '     The plot file will be in nanometers and the'
    else if (Use_cm) then
      PlUnit = ' cm-1.'
      write(u6,*) '     The plot file will be in cm-1 and the'
    else
      PlUnit = ' eV.'
      write(u6,*) '     The plot file will be in eV and the'
    end if
    if (plotwindow) then
      write(u6,*) '     interval is from ',cmstart,' to ',cmend,PlUnit
    else
      write(u6,*) '     interval automatically defined.'
    end if
    write(u6,*)

    ! --------------------------------------------------------------------
    ! BROAplot: Gives the peaks in the spectrum an artificial halfwidth.

    call KeyWord(inpUnit,'BROA',.true.,broadplot)
    call KeyWord(inpUnit,'LIFE',.true.,exists)
    if (exists) read(inpUnit,*) LifeTime
    write(u6,*) '     Life time : ',LifeTime,' sec'
    FWHM = hbarcm/(Two*LifeTime)
    write(u6,'(1X,A,F8.1,A,F9.6,A)') '     FWHM : ',FWHM,' cm-1 /',FWHM*auToeV/auTocm,' eV'

    ! BROAplot: End ------------------------------------------------------
  end if

  ! --------------------------------------------------------------------
  ! VIBWrite: Writes vibrational levels to logfile.

  WriteVibLevels = .false.
  call KeyWord(inpUnit,'VIBW',.true.,WriteVibLevels)

  ! VIBWrite: End ------------------------------------------------------

  ! --------------------------------------------------------------------
  ! VibPlot: Check for keyword VibPlot.

  VibModPlot = .false.
  call KeyWord(inpUnit,'VIBP',.true.,VibModPlot)
  if (VibModPlot) then
    call KeyWord(inpUnit,'CYCL',.false.,exists)
    if (exists) then
      call KeyWord(inpUnit,'VIBP',.true.,exists)
      read(inpUnit,frmt) InLine
      call Normalize(InLine,OutLine)
      k = 1
      call WordPos(k,OutLine,iStart,iStop)
      call WordPos(k,OutLine,iStart,iStop)
      Bond(nBond+1) = iStrToInt(OutLine(iStart:iStop))
      call WordPos(k,OutLine,iStart,iStop)
      Bond(nBond+2) = iStrToInt(OutLine(iStart:iStop))
      nBond = nBond+2
    end if
  end if

  ! VibPlot: End -------------------------------------------------------

  ! --------------------------------------------------------------------
  ! HUGElog: If exists, then the logfile will be more detailed.

  Huge_Print = .false.
  call KeyWord(inpUnit,'HUGE',.true.,Huge_Print)

  ! HUGElog: End -------------------------------------------------------

  ! --------------------------------------------------------------------
  ! EXPAnsion: Program will be aborted after expansion point geometry
  !            is calculated.

  lExpan = .false.
  call KeyWord(inpUnit,'EXPA',.true.,lExpan)

  ! HUGElog: End -------------------------------------------------------

  ! --------------------------------------------------------------------
  ! FORCe: Here really read force constants.

  call KeyWord(inpUnit,'FORC',.true.,exists)
  max_term = 2
  call KeyWord(inpUnit,'FIRS',.false.,exists)
  !D write(u6,*) ' READINP: Read force constants for first state.'
  read(InpUnit,frmt) InLine
  call Normalize(InLine,Outline)
  iend = index(OutLine,' ')
  CoordType = OutLine(1:iend-1)
  !D write(u6,*) ' READINP: CoordType=',CoordType

  ! Read Hessian. If Hessian is given in cartesian coordinates,
  ! first remove total translation and total rotation and then
  ! transform it to internal coordinates.
  if (CoordType == 'FILE') then
    Coordtype = 'CARTESIAN'
    inpUnit1 = isfreeunit(31)
    call molcas_open(inpUnit1,'UNSYM1')
    !open(31,'UNSYM1')
    call KeyWord(inpUnit1,'UNSYMMETRIZED HESSIAN',.false.,exists)
    read(inpUnit1,'(a17)') Inline
    read(inpUnit1,'(a17)') Inline
  else
    inpUnit1 = inpUnit
  end if

  if (CoordType == 'INTERNAL') then
    do i=1,NumInt
      read(inpUnit,*) Hess1(i,:)
    end do
  else if (CoordType == 'CARTESIAN') then
    call mma_allocate(SS,3*NumOfAt,NumInt,label='SS')
    SS(:,:) = Zero
    call CalcS(AtCoord1,InterVec,SS,NumInt,NumOfAt)

    ! Invert S matrix and remove total translation and total rotation.
    call mma_allocate(Sinv,3*NumOfAt,NumInt,label='Sinv')

    call RotTranRem(Sinv,SS,Mass,AtCoord1,NumOfAt,NumInt)
    call mma_deallocate(SS)

    ! Read cartesian force constant matrix.
    n = 3*NumOfAt
    nFcart = n
    call mma_allocate(Fcart,nFcart,nFcart,label='Fcart')

    do m=1,3*NumOfAt
      read(inpUnit1,'(a17)',iostat=istatus) Inline
      if (istatus <= 0) read(inpUnit1,*,iostat=istatus) (Fcart(m,n),n=1,3*NumOfAt)
      if (istatus > 0) then
        write(u6,*)
        write(u6,*) ' ***************** ERROR *******************'
        write(u6,*) ' Error trying to read cartesian force cnsts.'
        write(u6,*) ' for the first state. Probably wrong input'
        write(u6,*) ' structure, perhaps too few values.'
        write(u6,*) ' *******************************************'
        call Quit_OnUserError()
      end if
    end do

    ! Check if Hessian is symmetric.
    error = Zero
    do m=1,(3*NumOfAt)
      do n=1,(3*NumOfAt)
        error = error+(Fcart(m,n)-Fcart(n,m))**2
      end do
    end do
    if (error > 1.0e-10_wp) then
      write(u6,*)
      write(u6,*) ' ******************** ERROR **********************'
      write(u6,*) ' Non-symmetric error in cartesian Hessian:',error
      write(u6,*) ' *************************************************'
      call Quit_OnUserError()
    end if

    ! Transform cartesian F matrix to internal coordinates.
    !PAM01: Here follows an n**4-scaling 2-index transformation
    !       It has been replaced by two n**3 matrix multiplies
    !do j=1,NumInt
    !  do i=1,NumInt
    !    Fsum = Zero
    !    do n=1,(3*NumOfAt)
    !      do m=1,(3*NumOfAt)
    !        Fsum = Fsum+Fcart(m,n)*Sinv(1+Mod((m+2),3),Int((m+2)/3),i)*Sinv(1+Mod((n+2),3),Int((n+2)/3),j)
    !      end do
    !    end do
    !    Hess1(i,j) = Fsum
    !  end do
    !end do
    !PAM01 Here follows replacement code:
    call mma_allocate(Temp,3*NumOfAt,NumInt,label='Temp')
    call DGEMM_('N','N',3*NumOfAt,NumInt,3*NumOfAt,One,FCart,3*NumOfAt,SInv,3*NumOfAt,Zero,Temp,3*NumOfAt)
    call DGEMM_('T','N',NumInt,NumInt,3*NumOfAt,One,SInv,3*NumOfAt,Temp,3*NumOfAt,Zero,Hess1,NumInt)
    call mma_deallocate(Temp)
    call mma_deallocate(Sinv)
    call mma_deallocate(Fcart)

  end if

  ! Scale Hessian if scaling factors were given.
  call KeyWord(inpUnit,'SCAL',.true.,exists)
  if (exists) then
    call mma_allocate(ScaleParam,NumInt,label='Scale1')

    call KeyWord(inpUnit,'FIRS',.false.,exists)
    do i=1,NumInt
      read(inpUnit,*) ScaleParam(i)
      ScaleParam(i) = sqrt(ScaleParam(i))
    end do
    do j=1,Numint
      Hess1(:,j) = Hess1(:,j)*ScaleParam*ScaleParam(j)
    end do
    call mma_deallocate(ScaleParam)
  end if
  !D write(u6,*) ' Scaled.'

  ! Hessian for second surface.
  call KeyWord(inpUnit,'FORC',.true.,exists)
  call KeyWord(inpUnit,'SECO',.false.,exists)
  !D write(u6,*) ' READINP: Read force constants for second state.'
  !read(inpUnit,*) CoordType
  !call UpCase(CoordType)
  ! Replace above two lines with:
  read(InpUnit,frmt) InLine
  call Normalize(InLine,Outline)
  iend = index(OutLine,' ')
  CoordType = OutLine(1:iend-1)
  ! End of replacement
  if (CoordType == 'FILE') then
    Coordtype = 'CARTESIAN'
    inpUnit2 = isfreeunit(32)
    call molcas_open(inpUnit2,'UNSYM2')
    !open (32,'UNSYM2')
    call KeyWord(inpUnit2,'UNSYMMETRIZED HESSIAN',.false.,exists)
    read(inpUnit2,'(a17)') Inline
    read(inpUnit2,'(a17)') Inline
  else
    inpUnit2 = inpUnit
  end if

  if (CoordType == 'INTERNAL') then
    do i=1,NumInt
      read(inpUnit,*) Hess2(i,:)
    end do
  else if (CoordType == 'CARTESIAN') then
    call mma_allocate(SS,3*NumOfAt,NumInt,label='SS')
    SS(:,:) = Zero
    call CalcS(AtCoord2,InterVec,SS,NumInt,NumofAt)

    ! Invert S matrix and remove total translation and total rotation.
    call mma_allocate(Sinv,3*NumOfAt,NumInt,label='Sinv')

    call RotTranRem(Sinv,SS,Mass,AtCoord2,NumOfAt,NumInt)
    call mma_deallocate(SS)

    ! Read cartesian force constant matrix.
    n = 3*NumOfAt
    nFcart = n
    call mma_allocate(Fcart,nFcart,nFcart,label='Fcart')

    do m=1,3*NumOfAt
      read(inpUnit2,'(a17)',iostat=istatus) Inline
      if (istatus <= 0) read(inpUnit2,*,iostat=istatus) (Fcart(m,n),n=1,3*NumOfAt)
      if (istatus > 0) then
        write(u6,*)
        write(u6,*) ' ***************** ERROR *******************'
        write(u6,*) ' Error trying to read cartesian force cnsts.'
        write(u6,*) ' for the second state. Probably wrong input'
        write(u6,*) ' structure, perhaps too few values.'
        write(u6,*) ' *******************************************'
        call Quit_OnUserError()
      end if
    end do

    ! Check if Hessian is symmetric.
    error = Zero
    do n=1,(3*NumOfAt)
      do m=1,(3*NumOfAt)
        error = error+(Fcart(m,n)-Fcart(n,m))**2
      end do
    end do
    if (error > 1.0e-2_wp) then
      write(u6,*)
      write(u6,*) ' ******************** ERROR **********************'
      write(u6,*) ' Non-symmetric error in cartesian Hessian:',error
      write(u6,*) ' *************************************************'
      call Quit_OnUserError()
    end if

    ! Transform cartesian F matrix to internal coordinates.
    !PAM01: Here follows an n**4-scaling 2-index transformation
    !       It has been replaced by two n**3 matrix multiplies
    !do j=1,NumInt
    !  do i=1,NumInt
    !    Fsum = Zero
    !    do n=1,(3*NumOfAt)
    !      do m=1,(3*NumOfAt)
    !        Fsum = Fsum+Fcart(m,n)*Sinv(1+Mod((m+2),3),Int((m+2)/3),i)*Sinv(1+Mod((n+2),3),Int((n+2)/3),j)
    !      end do
    !    end do
    !    Hess2(i,j) = Fsum
    !  end do
    !end do
    !PAM01 Here follows replacement code:
    call mma_allocate(Temp,3*NumOfAt,NumInt,label='Temp')
    call DGEMM_('N','N',3*NumOfAt,NumInt,3*NumOfAt,One,FCart,3*NumOfAt,SInv,3*NumOfAt,Zero,Temp,3*NumOfAt)
    call DGEMM_('T','N',NumInt,NumInt,3*NumOfAt,One,SInv,3*NumOfAt,Temp,3*NumOfAt,Zero,Hess2,NumInt)
    call mma_deallocate(Temp)
    call mma_deallocate(Sinv)
    call mma_deallocate(Fcart)

  end if

  if (inpUnit1 /= inpUnit) close(inpUnit1)
  if (inpUnit2 /= inpUnit) close(inpUnit2)

  ! FORCe: End ---------------------------------------------------------

  ! --------------------------------------------------------------------
  ! SCALe: Scale Hessian if scaling factors were given.

  call KeyWord(inpUnit,'SCAL',.true.,exists)
  if (exists) then
    call mma_allocate(ScaleParam,NumInt,label='ScaleParam')

    call KeyWord(inpUnit,'SECO',.false.,exists)
    do i=1,NumInt
      read(inpUnit,*) ScaleParam(i)
      ScaleParam(i) = sqrt(ScaleParam(i))
    end do
    do j=1,NumInt
      Hess2(:,j) = Hess2(:,j)*ScaleParam*ScaleParam(j)
    end do
    call mma_deallocate(ScaleParam)
  end if

  ! SCALe: End ---------------------------------------------------------

  ! --------------------------------------------------------------------
  ! DIPOles: Read Transition Dipoles or Spin-Orbit Coupling.

  call KeyWord(inpUnit,'DIPO',.true.,exists)
  if (.not. exists) call KeyWord(inpUnit,'SOC ',.true.,exists)
  if (.not. exists) then
    write(u6,*)
    write(u6,*) ' ************ ERROR ****************'
    write(u6,*) ' The DIPOLES/SOC keyword is missing.'
    write(u6,*) ' ***********************************'
    call Quit_OnUserError()
  end if
  !D write(u6,*) ' READINP: Read dipoles ("DIPOLES").'
  read(inpUnit,frmt) Inline
  call Normalize(InLine,OutLine)
  if (OutLine(1:4) == 'FILE') then
    !D write(u6,*) ' Read trans dips from file UNSYM21'
    call molcas_open(31,'UNSYM21')
    !open(31,'UNSYM21')
    if (max_dip == 1) then
      call KeyWord(31,'*BEGIN TRANSDIPDER FOR COMPONENT X',.false.,exists)
      read(31,*) TranDipGrad(1,:)
      call KeyWord(31,'*BEGIN TRANSDIPDER FOR COMPONENT Y',.false.,exists)
      read(31,*) TranDipGrad(2,:)
      call KeyWord(31,'*BEGIN TRANSDIPDER FOR COMPONENT Z',.false.,exists)
      read(31,*) TranDipGrad(3,:)
    end if
    XnotFound = .true.
    YnotFound = .true.
    ZnotFound = .true.
    call KeyWord(31,'*BEGIN TRANSITION PROPERTIES',.false.,exists)
    do while (XnotFound .or. YnotFound .or. ZnotFound)
      read(31,'(A37)') InLine
      if (InLine(1:20) == 'MLTPL  1 COMPONENT1 ') then
        XnotFound = .false.
        read(InLine(22:37),*) TranDip(1)
      end if
      if (InLine(1:20) == 'MLTPL  1 COMPONENT2 ') then
        YnotFound = .false.
        read(InLine(22:37),*) TranDip(2)
      end if
      if (InLine(1:20) == 'MLTPL  1 COMPONENT3 ') then
        ZnotFound = .false.
        read(InLine(22:37),*) TranDip(3)
      end if
    end do
    close(31)
  else
    call KeyWord(inpUnit,'DIPO',.true.,exists)
    !D write(u6,*) ' READINP: Read dipoles ("DIPOLES").'
    read(inpUnit,*) TranDip(:)
    if (max_dip == 1) then
      read(inpUnit,*) TranDipGrad(1,:)
      read(inpUnit,*) TranDipGrad(2,:)
      read(inpUnit,*) TranDipGrad(3,:)
    end if
  end if

  !                         End of Forcefield part
  ! --------------------------------------------------------------------

else
  write(u6,*) ' Forcefield not found. Will use Energy Surface.'

  !--------------------------------------------------------------------!
  !
  !                       Energy surface input part
  !
  !--------------------------------------------------------------------!

  ! Read transformations.
  call KeyWord(inpUnit,'NONL',.true.,exists)
  if (.not. exists) then
    write(u6,*)
    write(u6,*) ' *********** ERROR **************'
    write(u6,*) ' Cannot find keyword  NONLINEAR !'
    write(u6,*) ' ********************************'
    call Quit_OnUserError()
  end if
  do icoord=1,NumInt
    read(inpUnit,frmt) InLine
    call Normalize(InLine,OutLine)
    trfName1(icoord) = OutLine
  end do
  do icoord=1,NumInt
    read(inpUnit,frmt) InLine
    call Normalize(InLine,OutLine)
    trfName2(icoord) = OutLine
  end do

  ! Read terms in polynomial.
  call KeyWord(inpUnit,'POLY',.true.,exists)
  if (.not. exists) then
    write(u6,*)
    write(u6,*) ' ************ ERROR **************'
    write(u6,*) ' Cannot find keyword  POLYNOMIAL !'
    write(u6,*) ' *********************************'
    call Quit_OnUserError()
  end if
  !D write(u6,*) ' READINP: Read polynomial.'
  k = 1
  nvar = 0
  read(inpUnit,frmt) InLine
  call WordPos(k,InLine,iStart,iStop)
  do while (iStop < len(Inline))
    k = iStop+1
    nvar = nvar+1
    call WordPos(k,InLine,iStart,iStop)
  end do
  nPolyTerm = 1
  read(inpUnit,frmt) InLine
  call Normalize(InLine,OutLine)
  do while (OutLine(1:4) /= 'END ')
    nPolyTerm = nPolyTerm+1
    read(inpUnit,frmt) InLine
    call Normalize(InLine,OutLine)
  end do
  call KeyWord(inpUnit,'POLY',.true.,exists)
  if (.not. exists) then
    write(u6,*)
    write(u6,*) ' ************ ERROR **************'
    write(u6,*) ' Cannot find keyword  POLYNOMIAL !'
    write(u6,*) ' *********************************'
    call Quit_OnUserError()
  end if

  call mma_allocate(ipow,nPolyTerm,nvar,label='ipow')
  do iterm=1,nPolyTerm
    read(inpUnit,*) ipow(iterm,:)
  end do

  ! Find highest power of term in polynomial.
  max_term = 0
  do iterm=1,nPolyTerm
    nsum = 0
    do jvar=1,nvar
      nsum = nsum+ipow(iterm,jvar)
      if (nsum > max_term) max_term = nsum
    end do
  end do

  ! Read grid points and energies.
  CoordType = 'INTERNAL'
  call KeyWord(inpUnit,'DATA',.true.,exists)
  if (.not. exists) then
    write(u6,*)
    write(u6,*) ' ********* ERROR ***********'
    write(u6,*) ' Cannot find keyword  DATA !'
    write(u6,*) ' ***************************'
    call Quit_OnUserError()
  end if
  !D write(u6,*) ' READINP: Read grid points (Key word "DATA").'
  idata = 0
  do while (.true.)
    idata = idata+1
    read(inpUnit,*,iostat=istatus) (coord(idata,jvar),jvar=1,nvar),(GrdVal(idata,j),j=1,10)
    if (istatus < 0) exit
  end do

  ndata = idata-1
  call mma_allocate(var,ndata,nvar,label='var')
  var(:,:) = coord(1:idata,1:nvar)

  ! CASPT2 energies for ground state.
  call mma_allocate(yin1,ndata,label='yin1')
  yin1(:) = GrdVal(1:ndata,2)

  ! CASPT2 energies for excited state.
  call mma_allocate(yin2,ndata,label='yin2')
  yin2(:) = GrdVal(1:ndata,6)

  ! If three atomic molecule, add Watson correction to energy values.
  if (NumOfAt == 3) then
    m1 = Mass(1)*uToAu
    m2 = Mass(2)*uToAu
    m3 = Mass(3)*uToAu
    m12 = (m1*m2)/(m1+m2)
    m23 = (m2*m3)/(m2+m3)
    do i=1,ndata
      r1 = var(i,1)
      r2 = var(i,2)
      theta = var(i,3)*deg2rad
      const = -(One/Eight)*(One/(m12*r1**2)+One/(m23*r2**2))*(One+(One/(sin(theta)**2)))
      const = const+Quart*(cos(theta)/(m2*r1*r2))*(cos(theta)/sin(theta))**2
      yin1(i) = yin1(i)+const
      yin2(i) = yin2(i)+const
    end do
  end if

  call mma_allocate(t_dipin1,ndata,label='t_dipin1')
  t_dipin1(:) = GrdVal(1:ndata,9)

  call mma_allocate(t_dipin2,ndata,label='t_dipin2')
  t_dipin2(:) = GrdVal(:,10)

  ! Make sure that all transition dipole values have the same sign.
  sign1_1 = sign(One,t_dipin1(1))
  sign2_1 = sign(One,t_dipin2(1))
  do idata=2,ndata
    sign1_2 = sign(One,t_dipin1(idata))
    sign2_2 = sign(One,t_dipin2(idata))
    if (int(sign1_1*sign2_1) /= int(sign1_2*sign2_2)) then
      write(u6,*) 'Sign shift in transition dipole data:',idata
    end if
    t_dipin1(idata) = sign1_1*sign1_2*t_dipin1(idata)
    t_dipin2(idata) = sign2_1*sign2_2*t_dipin2(idata)
  end do
  !D write(u6,*) ' READINP: Transition dipoles finished.'

  !                   End of Energy surface input part
  ! --------------------------------------------------------------------

end if

!D write(u6,*) ' Ending READINP.'

end subroutine ReadInp

subroutine WriteLog(PotCoef,AtomLbl,AtCoord,Mass,InterVec,stand_dev,max_err,energy,Hess,G,V,harmfreq,qMat,Bond,nBond,xvec,D3,D4, &
                    PED,x_anharm,anharmfreq,max_term,nState,ForceField,NumOfAt,nOsc)
!  Purpose:
!    Write results to log file.
!
!  Input:
!    AtomLbl    : Array of character - contains the labels for the atoms.
!    AtCoord    : Two dimensional Real array - contains the cartesian coordinates of the atoms.
!    Mass       : Real array - contains the mass of the atoms.
!    InterVec   : Integer array - contains the atoms that are used in the calculations of each internal coordinate.
!    ipow       : Two dimesional integer array - terms of polynomial.
!    PotCoef    : Real two dimensional array - coefficients of terms given in ipow.
!    stand_dev  : Real variable - standard deviation of fitted values of polynomial.
!    max_err    : Real variable - maximum error of fitted values of polynomial.
!    energy     : Real variable - energy in minimum.
!    Hess       : Real array -  contains the force constants expressed in internal coordinates.
!    G          : Real array.
!    V          : Real array - contains the eigenvectors of G*F as columns.
!    harmfreq   : Real array - harmonic frequencies.
!    qMat       : Real array - contains the cartesian displacements of the atoms.
!    Bond       : Integer array - contains atom pairs that are to be bonded together in a plot.
!    nBond      : Integer - dim of Bond, i.e. 2*(number of bonds).
!    xvec       : Real array - contains the internal coordinates at equilibrium.
!    D3         : Real array - contains the third derivatives.
!    D4         : Real array - contains the fourth derivatives.
!    PED        : Real three dimensional array - potential energy distribution.
!    x_anharm   : Real two dimensional array - anharmonicity constants.
!    anharmfreq : Real array - anharmonic frequencies.
!    max_term   : Integer - highest power of term in fitted polynomial.
!    nState     : Integer - 1 or 2, depending upon which state it is.
!
!  Output:
!    Log file
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use mula_global, only: Huge_Print, ipow, MaxNumAt, nPolyTerm, VibModPlot
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: auTocm
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: InterVec(MaxNumAt*15), Bond(MaxNumAt*2), nBond, max_term, nState, NumOfAt, nOsc
real(kind=wp), intent(in) :: PotCoef(nPolyTerm,1), AtCoord(3,NumOfAt), Mass(MaxNumAt), stand_dev, max_err, energy, &
                             Hess(nOsc,nOsc), G(nOsc,nOsc), V(nOsc,nOsc), harmfreq(nOsc), qMat(3*NumOfAt,nOsc), xvec(nOsc), &
                             D3(nOsc,nOsc,nOsc), D4(nOsc,nOsc,nOsc,nOsc), PED(nOsc,nOsc,nOsc), x_anharm(nOsc,nOsc), anharmfreq(nOsc)
character(len=4), intent(in) :: AtomLbl(MaxNumAt)
logical(kind=iwp), intent(in) :: ForceField
integer(kind=iwp) :: i, iBond, iInt, imode, j, k, l, m1, m2, maxCol, mInt, nAtom, nCol, n_Int, nRow, NumInt, VibPlotUnit
real(kind=wp) :: vLength, vMax, x1, x2, x3
logical(kind=iwp) :: cont
character(len=11) :: VibPlotFile
character(len=8) :: BondString
integer(kind=iwp), allocatable :: aNormModes(:)
integer(kind=iwp), external :: isfreeunit
real(kind=wp), external :: Dnrm2_

NumInt = nOsc
call mma_allocate(aNormModes,NumInt,label='aNormModes')
do i=1,NumInt
  aNormModes(i) = i
end do

if (nState == 1) then
  write(u6,*)
  write(u6,*)
  write(u6,'(a27,a)') ' ',' ================================================='
  write(u6,'(a27,a)') ' ','|                                                 |'
  write(u6,'(a27,a)') ' ','|           Results for the first state           |'
  write(u6,'(a27,a)') ' ','|                                                 |'
  write(u6,'(a27,a)') ' ',' ================================================='
  write(u6,*)
end if
if (nState == 2) then
  write(u6,*)
  write(u6,*)
  write(u6,*)
  write(u6,'(a27,a)') ' ',' ================================================='
  write(u6,'(a27,a)') ' ','|                                                 |'
  write(u6,'(a27,a)') ' ','|           Results for the second state          |'
  write(u6,'(a27,a)') ' ','|                                                 |'
  write(u6,'(a27,a)') ' ',' ================================================='
  write(u6,*)
end if

! Write coefficients of polynomial fit, standard deviation and
! maximum error to log.
if (.not. ForceField) then
  write(u6,*)
  write(u6,'(A)') '  Coefficients of different terms in polynomial:'
  write(u6,'(A)') '  ----------------------------------------------'
  do i=1,nPolyTerm
    write(u6,'(1x,f18.12,10(3x,i2))') PotCoef(i,1),ipow(i,:)
  end do
  write(u6,*)
  write(u6,*)
  write(u6,'(A,es14.6)') '  Standard deviation of fitted values:',stand_dev
  write(u6,'(A)') '  ------------------------------------'
  write(u6,*)
  write(u6,'(A,es14.6)') '  Maximum error of fitted values:     ',max_err
  write(u6,'(A)') '  -------------------------------'

  ! Write energy in minimum.
  write(u6,*)
  write(u6,*)
  write(u6,'(A,F15.8,A)') '  Energy in minimum:',energy
  write(u6,'(A)') '  ------------------'
end if

! Write force constant matrix to log file.
if (Huge_Print) then
  write(u6,*)
  write(u6,*)
  write(u6,*) ' ','Force Constant Matrix:'
  write(u6,*) ' ','======================'
  write(u6,*)
  maxCol = 10
  nRow = NumInt/maxCol+1
  nCol = mod(NumInt,maxCol)
  m1 = 1
  m2 = 1
  cont = .true.
  do i=1,nRow
    if ((i == nRow) .or. ((i == 1) .and. (NumInt < maxCol))) then
      if (i == 1) then
        m2 = m2+nCol-1
      else
        m2 = m2+nCol
      end if
    else
      if (i == 1) then
        m2 = m2+maxCol-1
      else
        m2 = m2+maxCol
      end if
    end if
    if ((nCol == 0) .and. (i == nRow)) cont = .false.
    if (cont) then
      write(u6,'(10I12)') (n_Int,n_Int=m1,m2)
      do mInt=1,NumInt
        write(u6,'(10F12.6)') (Hess(mInt,n_Int),n_Int=m1,m2)
      end do
      write(u6,*)
      write(u6,*)
      m1 = m2+1
    end if
  end do

  ! Write matrix G to log file.
  write(u6,*)
  write(u6,*)
  write(u6,*) ' ','Inverse Mass Tensor :'
  write(u6,*) ' ','====================='
  write(u6,*)
  maxCol = 10
  nRow = NumInt/maxCol+1
  nCol = mod(NumInt,maxCol)
  m1 = 1
  m2 = 1
  cont = .true.
  do i=1,nRow
    if ((i == nRow) .or. ((i == 1) .and. (NumInt < maxCol))) then
      if (i == 1) then
        m2 = m2+nCol-1
      else
        m2 = m2+nCol
      end if
    else
      if (i == 1) then
        m2 = m2+maxCol-1
      else
        m2 = m2+maxCol
      end if
    end if
    if ((nCol == 0) .and. (i == nRow)) cont = .false.
    if (cont) then
      write(u6,'(10I12)') (n_Int,n_Int=m1,m2)
      do mInt=1,NumInt
        write(u6,'(10F12.6)') (G(mInt,n_Int),n_Int=m1,m2)
      end do
      write(u6,*)
      write(u6,*)
      m1 = m2+1
    end if
  end do
  write(u6,*)

  ! Eigenvectors.
  write(u6,*)
  write(u6,*)
  write(u6,*) ' ','Eigenvectors :'
  write(u6,*) ' ','=============='
  write(u6,*)
  maxCol = 10
  nRow = NumInt/maxCol+1
  nCol = mod(NumInt,maxCol)
  m1 = 1
  m2 = 1
  cont = .true.
  do i=1,nRow
    if ((i == nRow) .or. ((i == 1) .and. (NumInt < maxCol))) then
      if (i == 1) then
        m2 = m2+nCol-1
      else
        m2 = m2+nCol
      end if
    else
      if (i == 1) then
        m2 = m2+maxCol-1
      else
        m2 = m2+maxCol
      end if
    end if
    if ((nCol == 0) .and. (i == nRow)) cont = .false.
    if (cont) then
      write(u6,'(10I12)') (n_Int,n_Int=m1,m2)
      do mInt=1,NumInt
        write(u6,'(10F12.6)') (V(mInt,n_Int),n_Int=m1,m2)
      end do
      write(u6,*)
      write(u6,*)
      m1 = m2+1
    end if
  end do
  write(u6,*)
end if

! Third derivatives.
if (max_term > 2) then
  write(u6,*)
  write(u6,*)
  write(u6,'(A)') '  Cubic force constants:'
  write(u6,'(A)') '  ----------------------'
  do i=1,NumInt
    do j=i,NumInt
      do k=j,NumInt
        write(u6,'(a,i2,i2,i2,f15.8)') '  ',i,j,k,D3(i,j,k)
      end do
    end do
  end do
end if

! Fourth derivatives.
if (max_term > 3) then
  write(u6,*)
  write(u6,*)
  write(u6,'(A)') '  Quartic force constants:'
  write(u6,'(A)') '  ------------------------'
  do i=1,NumInt
    do j=i,NumInt
      do k=j,NumInt
        do l=k,NumInt
          write(u6,'(a,i2,i2,i2,i2,f15.8)') '  ',i,j,k,l,D4(i,j,k,l)
        end do
      end do
    end do
  end do
end if

! Anharmonicity constants.
if (max_term > 2) then
  write(u6,*)
  write(u6,*)
  write(u6,'(A)') '  Anharmonicity constants:'
  write(u6,'(A)') '  ------------------------'
  do i=1,NumInt
    write(u6,'(a,20f15.8)') ' ',(auTocm*x_anharm(i,j),j=1,i)
  end do
end if

! Write labels, coordinates and masses to log file.
call WriteCartCoord(AtomLbl,AtCoord,Mass,NumOfAt)

! Write internal coordinates to log file.
call WriteIntCoord(InterVec,AtomLbl,xvec,NumInt)

! Harmonic frequencies in reciprocal cm, GHz and hartrees.
call WriteFreq(harmfreq,aNormModes,NumInt,'Harmonic frequencies')

! Fundamental frequencies in reciprocal cm, GHz and hartrees.
if (max_term > 2) call WriteFreq(anharmfreq,aNormModes,NumInt,'Anharmonic frequencies')

! Write Potential Energy Distribution for each mode to log
! if the molecule is not too large.
if (Huge_Print .and. (NumInt <= 10)) then
  write(u6,*)
  write(u6,*)
  write(u6,*) ' ','Potential Energy Distribution :'
  write(u6,*) ' ','==============================='
  do imode=1,NumInt
    write(u6,*)
    write(u6,*) ' ','Mode',imode
    write(u6,*) ' ','-------'
    do k=1,NumInt
      if (NumInt < 21) then
        write(u6,'(60F6.2)') (PED(k,l,imode),l=1,NumInt)
      else
        write(u6,'(60F5.2)') (PED(k,l,imode),l=1,NumInt)
      end if
    end do
  end do
end if

! Find length of longest displacement vector.
vMax = Dnrm2_(3,qMat(1,1),1)
do nAtom=1,NumOfAt
  do j=1,NumInt
    vLength = Dnrm2_(3,qMat((nAtom-1)*3+1,j),1)
    if (vLength > vMax) then
      vMax = vLength
    end if
  end do
end do

! Print displacement vectors scaled with length of longest vector
! if the molecule is not too large.
if (Huge_Print .and. (NumInt <= 10)) then
  write(u6,*)
  write(u6,*)
  write(u6,*) ' ','Scaled displacement vectors :'
  write(u6,*) ' ','============================='
  write(u6,*) ' ','(length of longest vector set equal to one)'
  write(u6,*)
  maxCol = 10
  do nAtom=1,NumOfAt
    write(u6,*) ' ',' Atom: ',AtomLbl(nAtom)
    write(u6,*) ' ',' ---------'
    nRow = NumInt/maxCol
    nCol = mod(NumInt,maxCol)
    m1 = 1
    m2 = 0
    do i=0,nRow
      if (i == nRow) then
        m2 = m2+nCol
      else
        m2 = m2+maxCol
      end if
      if (m2 /= 0) then
        write(u6,'(10I12)') (j,j=m1,m2)
        write(u6,'(A4,10F12.8)') '  x ',(qMat((nAtom-1)*3+1,j)/vMax,j=m1,m2)
        write(u6,'(A4,10F12.8)') '  y ',(qMat((nAtom-1)*3+2,j)/vMax,j=m1,m2)
        write(u6,'(A4,10F12.8)') '  z ',(qMat((nAtom-1)*3+3,j)/vMax,j=m1,m2)
        write(u6,*)
        m1 = m2+1
      end if
    end do
  end do
  write(u6,*)
  write(u6,*)
end if

! Generate MOLDEN input:

if (nState == 1) then
  call WrMold('MOLDEN-1',NumOfAt,AtomLbl,AtCoord,NumInt,HarmFreq,QMat)
else
  call WrMold('MOLDEN-2',NumOfAt,AtomLbl,AtCoord,NumInt,HarmFreq,QMat)
end if

! Print geometry of molecule, together with cartesian displacements,
! in a file.
if (VibModPlot) then
  VibPlotUnit = isfreeunit(21)
  if (nState == 1) then
    VibPlotFile = 'plot.modes1'
  end if
  if (nState == 2) then
    VibPlotFile = 'plot.modes2'
  end if
  call molcas_Open(vibplotunit,vibplotfile)
  !open(VibPlotUnit,VibPlotFile)
  write(VibPlotUnit,*) 2*NumOfAt
  write(VibPlotUnit,*) nBond/2
  write(VibPlotUnit,*) '1'
  write(VibPlotUnit,*) NumInt
  iBond = 1
  do while (iBond+1 <= nBond)
    write(BondString,'(i4,i4)') Bond(iBond),Bond(iBond+1)
    write(VibPlotUnit,'(a8)') BondString
    iBond = iBond+2
  end do
  do nAtom=1,NumOfAt
    x1 = AtCoord(1,nAtom)
    x2 = AtCoord(2,nAtom)
    x3 = AtCoord(3,nAtom)
    write(VibPlotUnit,'(a,3f12.3)') '>',x2,x3,x1
  end do
  do iInt=1,NumInt
    do nAtom=1,NumOfAt
      x1 = AtCoord(1,nAtom)
      x2 = AtCoord(2,nAtom)
      x3 = AtCoord(3,nAtom)
      write(VibPlotUnit,'(a,3f12.3)') AtomLbl(nAtom),x2+qMat((nAtom-1)*3+2,iInt)/vMax,x3+qMat((nAtom-1)*3+3,iInt)/vMax, &
                                      x1+qMat((nAtom-1)*3+1,iInt)/vMax
    end do
  end do
  close(VibPlotUnit)
end if

call mma_deallocate(aNormModes)

end subroutine WriteLog

subroutine WriteDip(DipGrad,Modes,Title,nOsc)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nOsc, Modes(nOsc)
real(kind=wp), intent(in) :: DipGrad(3,nOsc)
character(len=*), intent(in) :: Title
integer(kind=iwp) :: i

write(u6,*)
write(u6,*)
write(u6,'(a2,a)') ' ',Title
write(u6,'(a2,a)') ' ','=============================================='
write(u6,'(a2,a)') ' ',' mode          X           Y           Z'
write(u6,'(a2,a)') ' ','----------------------------------------------'
do i=1,nOsc
  write(u6,'(a3,i2,a1,a3,3f12.5)') ' ',Modes(i),'.',' ',DipGrad(:,i)
end do
write(u6,'(a2,a)') ' ','=============================================='
write(u6,*)

end subroutine WriteDip

subroutine IntCalcHeader()

use Definitions, only: u6

implicit none

write(u6,*)
write(u6,*)
write(u6,'(a27,a)') ' ',' ================================================='
write(u6,'(a27,a)') ' ','|                                                 |'
write(u6,'(a27,a)') ' ','|             Intensity calculation               |'
write(u6,'(a27,a)') ' ','|                                                 |'
write(u6,'(a27,a)') ' ',' ================================================='
write(u6,*)

end subroutine IntCalcHeader

subroutine ExpPointHeader()

use Definitions, only: u6

implicit none

write(u6,*)
write(u6,*)
write(u6,'(a27,a)') ' ',' ================================================='
write(u6,'(a27,a)') ' ','|                                                 |'
write(u6,'(a27,a)') ' ','|            Expansion point geometry             |'
write(u6,'(a27,a)') ' ','|                                                 |'
write(u6,'(a27,a)') ' ',' ================================================='
write(u6,*)

end subroutine ExpPointHeader

subroutine ISCHeader()

use Definitions, only: u6

implicit none

write(u6,*)
write(u6,*)
write(u6,'(a27,a)') ' ',' ================================================='
write(u6,'(a27,a)') ' ','|                                                 |'
write(u6,'(a27,a)') ' ','|      InterSystem Crossing rate calculation      |'
write(u6,'(a27,a)') ' ','|                                                 |'
write(u6,'(a27,a)') ' ',' ================================================='
write(u6,*)

end subroutine ISCHeader

subroutine WriteHeader(Title)
!  Purpose:
!    Write header and title to logfile.
!
!  Written by:
!    Niclas Forsberg,
!    Dept. of Theoretical Chemistry, Lund University, 1995.

use Definitions, only: u6

implicit none
character(len=80), intent(in) :: Title

write(u6,*)

! Write title of project.
write(u6,*)
write(u6,*)
write(u6,*)
write(u6,'(A,A)') '  Title : ',Title
write(u6,'(A)') '  -------'
write(u6,*)

end subroutine WriteHeader

subroutine WrMold(FName,NumOfAt,AtomLbl,AtCoord,NumInt,HarmFreq,QMat)
! Open file named FName, and create a MOLDEN input file.

use Constants, only: Zero, auTocm
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NumOfAt, NumInt
character(len=*), intent(in) :: FName, AtomLbl(NumOfAt)
real(kind=wp), intent(in) :: AtCoord(3,NumOfAt), HarmFreq(NumInt), QMat(3,NumOfAt,NumInt)
integer(kind=iwp) :: i, iAtom, iInt
real(kind=wp) :: D2, DispMx, DMax, Factor
character(len=2) :: AtName

call molcas_open(9,Fname)
!open(9,FName,status='UNKNOWN')
write(9,*) '[MOLDEN FORMAT]'

! Harmonic frequencies:
write(9,*) '[N_FREQ]'
write(9,*) NumInt
write(9,*) '[FREQ]'
do iInt=1,NumInt
  write(9,'(1X,F10.3)') auTocm*HarmFreq(iInt)
end do
! VV: Not implemented???
write(9,*) '[INT]'
do iInt=1,NumInt
  write(9,'(1X,F10.3)') Zero
end do
! Atom coordinates:
write(9,*) '[NATOM]'
write(9,*) NumOfAt
write(9,*) '[FR-COORD]'
do iAtom=1,NumOfAt
  AtName = AtomLbl(iAtom)(1:2)
  if ((ichar('0') <= ichar(AtName(2:2))) .and. (ichar(AtName(2:2)) <= ichar('9'))) then
    AtName(2:2) = ' '
  end if
  write(9,'(1x,A2,3F16.8)') AtName,(AtCoord(i,iAtom),i=1,3)
end do

! Cartesian displacement coordinates:
! Scale such that max displacement is 0.2 A.U.
DMax = 0.2_wp
write(9,*) '[FR-NORM-COORD]'
do iInt=1,NumInt
  write(9,*) 'vibration ',iInt
  DispMx = Zero
  do iAtom=1,NumOfAt
    D2 = Zero
    do i=1,3
      D2 = D2+QMat(i,iAtom,iInt)**2
    end do
    DispMx = max(DispMx,sqrt(D2))
  end do
  Factor = DMax/DispMx
  do iAtom=1,NumOfAt
    write(9,'(1X,3F16.8)') (Factor*QMat(i,iAtom,iInt),i=1,3)
  end do
end do

close(9)

end subroutine WrMold

!end module InOutMod

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_AA(A)
! check T(a,b,i,j)

use Index_Functions, only: nTri_Elem
use chcc_global, only: Ac, no
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: A(nTri_Elem(no),no,no)
integer(kind=iwp) :: bad, i, ij, j, u, v
real(kind=wp) :: s

bad = 0
do v=1,no
  do u=1,no
    ij = 0
    do i=1,no
      do j=1,i
        ij = ij+1

        s = Ac(i,j,u,v)

        if (abs(A(ij,u,v)-s) > 1.0e-10_wp) then
          bad = bad+1
          !A(ij,u,v) = s
        end if

      end do
    end do
  end do
end do

write(u6,*) ' Chck AA :',bad

return

end subroutine Chck_AA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_expand(wrk,wrksize,nind,exptyp,a,ssa,b,rc)
! this routine realizes expansion
!
! A(pqrs) -> B(pqrs)
!
! nind   - # of indices in matrix A  (Input)
! exptyp - type of expansion :  (Input)
!          1 - pq,r,s -> p,q,r,s  pq,r -> p,q,r  pq -> p,q
!          2 - p,qr,s -> p,q,r,s  p,qr -> p,q,r
!          3 - p,q,rs -> p,q,r,s
!          4 - pq,rs  -> p,q,r,s
!          5 - pq,rs  -> p,q,rs
!          6 - pq,rs  -> pq,r,s
! a     - A  (Input)
! ssa   - overall symmetry state of matrix A  (Input)
! b     - B  (Input/Output)
! rc    - return (error) code  (Output)
!
! Table of expansions
!
! nind  exptyp          Operation             Implementation
!
! 4       0     A(p,q,r,s) -> B(p,q,r,s)     Realized in map
! 4       1     A(pq,r,s)  -> B(p,q,r,s)           Yes
! 4       2     A(p,qr,s)  -> B(p,q,r,s)           Yes
! 4       3     A(p,q,rs)  -> B(p,q,r,s)           Yes
! 4       4     A(pq,rs)   -> B(p,q,r,s)           Yes
! 4       5     A(pq,rs)   -> B(p,q,rs)            Yes
! 4       6     A(pq,rs)   -> B(pq,r,s)            Yes
!
! 3       0     A(p,q,r)   -> B(p,q,r)       Realized in map
! 3       1     A(pq,r)    -> B(p,q,r)             Yes
! 3       2     A(p,qr)    -> B(p,q,r)             Yes
!
! 2       0     A(p,q)     -> B(p,q)         Realized in map
! 2       1     A(pq)      -> B(p,q)               Yes
!
! 1       0     A(p)       -> B(p)           Realized in map

use CCT3_global, only: dimm, Map_Type
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, nind, exptyp, ssa
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: a
type(Map_Type), intent(inout) :: b
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: ia, ib1, ib2, ib3, ib4, na, nhelp1, nhelp2, nhelp3, nhelp4, nhelp5, nhelp6, post, sa1, sa2, sa3, sa4, typa

rc = 0
na = a%d(0,5)
typa = a%d(0,6)

! general tests

if (exptyp == 0) then
  ! RC=1  : exptyp=0 (for exptyp=0, there is no sophistical expansion, NCI)
  rc = 1
  return
end if

! get b%d,b%i

if ((nind == 4) .and. (exptyp == 5)) then
  nhelp1 = 3
else if ((nind == 4) .and. (exptyp == 6)) then
  nhelp1 = 1
else
  nhelp1 = 0
end if

call cct3_grc0(nind,nhelp1,a%d(0,1),a%d(0,2),a%d(0,3),a%d(0,4),ssa,b,post)

if (nind < 2) then
  ! RC=2 - number of indices < 2 (NCI)
  rc = 2
end if

if (nind == 2) then

  ! ********** 2 index *********

  if (exptyp == 1) then

    !2.1 expand A(pq) -> B(p,q)

    ! tests

    if (typa /= 1) then
      ! RC=3 : nind=2, exptyp=1 (typA is not 1, Stup)
      rc = 3
      return
    end if

    do ia=1,na

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)

      ib1 = b%i(sa1,1,1)
      ib2 = b%i(sa2,1,1)

      if (sa1 > sa2) then

        ! map A(p,q) -> B(p,q)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map11(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),1)

        ! map A(p,q) -> - B(q,p)

        ! posB2
        nhelp2 = b%d(ib2,1)
        ! dimp,dimq
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,2),sa2)

        call cct3_map21(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,2,1,-1)

      else
        ! sa1=sa2

        ! expand A(pq) -> B(p,q)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB
        nhelp2 = b%d(ib1,1)
        ! dimp
        nhelp3 = dimm(a%d(0,1),sa1)

        call cct3_expand0(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),nhelp3)

      end if

    end do

  else
    ! RC=4 : nind=2, exptyp=@ (Inproper exptyp, Stup)
    rc = 4
    return
  end if

else if (nind == 3) then

  ! ********** 3 index *********

  if (exptyp == 1) then

    !3.1 expand A(pq,r) -> B(p,q,r)

    ! tests

    if (typa /= 1) then
      ! RC=5 : nind=3, exptyp=1 (typA is not 1, Stup)
      rc = 5
      return
    end if

    do ia=1,na

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)

      ib1 = b%i(sa1,sa2,1)
      ib2 = b%i(sa2,sa1,1)

      if (sa1 > sa2) then

        ! map A(p,q,r) -> B(p,q,r)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map11(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),1)

        ! map A(p,q,r) -> - B(q,p,r)

        ! posB2
        nhelp2 = b%d(ib2,1)
        ! dimp,dimq,dimr
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,2),sa2)
        nhelp5 = dimm(a%d(0,3),sa3)

        call cct3_map31(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,2,1,3,-1)

      else
        ! sa1=sa2

        ! expand A(pq,r) -> B(p,q,r)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB
        nhelp2 = b%d(ib1,1)
        ! dimpq
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp3 = nhelp3*(nhelp3-1)/2
        ! dimp,dimr
        nhelp4 = dimm(a%d(0,1),sa1)
        nhelp5 = dimm(a%d(0,3),sa3)

        call cct3_expand1(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5)

      end if

    end do

  else if (exptyp == 2) then

    !3.2 expand A(p,qr) -> B(p,q,r)

    ! tests

    if (typa /= 2) then
      ! RC=6 : nind=3, exptyp=2 (typA is not 2, Stup)
      rc = 6
      return
    end if

    do ia=1,na

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)

      ib1 = b%i(sa1,sa2,1)
      ib2 = b%i(sa1,sa3,1)

      if (sa2 > sa3) then

        ! map A(p,q,r) -> B(p,q,r)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map11(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),1)

        ! map A(p,q,r) -> - B(q,p,r)

        ! posB2
        nhelp2 = b%d(ib2,1)
        ! dimp,dimq,dimr
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,2),sa2)
        nhelp5 = dimm(a%d(0,3),sa3)

        call cct3_map31(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,1,3,2,-1)

      else
        ! sa2=sa3

        ! expand A(p,qr) -> B(p,q,r)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB
        nhelp2 = b%d(ib1,1)
        ! dimqr
        nhelp3 = dimm(a%d(0,2),sa1)
        nhelp3 = nhelp3*(nhelp3-1)/2
        ! dimp,dimq
        nhelp4 = dimm(a%d(0,1),sa1)
        nhelp5 = dimm(a%d(0,2),sa2)

        call cct3_expand3(wrk(nhelp1),wrk(nhelp2),nhelp4,nhelp3,nhelp5)

      end if

    end do

  else
    ! RC=7 : nind=3, exptyp=@ (Inproper exptyp, Stup)
    rc = 7
    return
  end if

else if (nind == 4) then

  ! ********** 4 index *********

  if (exptyp == 1) then

    !4.1 expand A(pq,r,s) -> B(p,q,r,s)

    ! tests

    if (typa /= 1) then
      ! RC=8 : nind=4, exptyp=1 (typA is not 1, Stup)
      rc = 8
      return
    end if

    do ia=1,na

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)
      sa4 = a%d(ia,6)

      ib1 = b%i(sa1,sa2,sa3)
      ib2 = b%i(sa2,sa1,sa3)

      if (sa1 > sa2) then

        ! map A(p,q,r,s) -> B(p,q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map11(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),1)

        ! map A(p,q,r,s) -> - B(q,p,r,s)

        ! posB2
        nhelp2 = b%d(ib2,1)
        ! dimp,dimq,dimr,dims
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,2),sa2)
        nhelp5 = dimm(a%d(0,3),sa3)
        nhelp6 = dimm(a%d(0,4),sa4)

        call cct3_map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,2,1,3,4,-1)

      else
        ! sa1=sa2

        ! expand A(pq,r_s) -> B(p,q,r_s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB
        nhelp2 = b%d(ib1,1)
        ! dimpq
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp3 = nhelp3*(nhelp3-1)/2
        ! dimp,dimr_s
        nhelp4 = dimm(a%d(0,1),sa1)
        nhelp5 = dimm(a%d(0,3),sa3)*dimm(a%d(0,4),sa4)

        call cct3_expand1(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5)

      end if

    end do

  else if (exptyp == 2) then

    !4.2 expand A(p,qr,s) -> B(p,q,r,s)

    ! tests

    if (typa /= 2) then
      ! RC=9 : nind=4, exptyp=2 (typA is not 2, Stup)
      rc = 9
      return
    end if

    do ia=1,na

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)
      sa4 = a%d(ia,6)

      ib1 = b%i(sa1,sa2,sa3)
      ib2 = b%i(sa1,sa3,sa2)

      if (sa2 > sa3) then

        ! map A(p,q,r,s) -> B(p,q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map11(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),1)

        ! map A(p,q,r,s) -> - B(p,r,q,s)

        ! posB2
        nhelp2 = b%d(ib2,1)
        ! dimp,dimq,dimr,dims
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,2),sa2)
        nhelp5 = dimm(a%d(0,3),sa3)
        nhelp6 = dimm(a%d(0,4),sa4)

        call cct3_map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,1,3,2,4,-1)

      else
        ! sa2=sa3

        ! expand A(p,qr,s) -> B(p,q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB
        nhelp2 = b%d(ib1,1)
        ! dimqr
        nhelp3 = dimm(a%d(0,2),sa1)
        nhelp3 = nhelp3*(nhelp3-1)/2
        ! dimp,dims,dimq
        nhelp4 = dimm(a%d(0,1),sa1)
        nhelp5 = dimm(a%d(0,4),sa4)
        nhelp5 = dimm(a%d(0,2),sa2)

        call cct3_expand2(wrk(nhelp1),wrk(nhelp2),nhelp4,nhelp3,nhelp5,nhelp6)

      end if

    end do

  else if (exptyp == 3) then

    !4.3 expand A(p,q,rs) -> B(p,q,r,s)

    ! tests

    if (typa /= 3) then
      ! RC=10: nind=4, exptyp=3 (typA is not 3, Stup)
      rc = 10
      return
    end if

    do ia=1,na

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)
      sa4 = a%d(ia,6)

      ib1 = b%i(sa1,sa2,sa3)
      ib2 = b%i(sa1,sa2,sa4)

      if (sa3 > sa4) then

        ! map A(p,q,r,s) -> B(p,q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map11(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),1)

        ! map A(p,q,r,s) -> - B(q,p,r,s)

        ! posB2
        nhelp2 = b%d(ib2,1)
        ! dimp,dimq,dimr,dims
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,2),sa2)
        nhelp5 = dimm(a%d(0,3),sa3)
        nhelp6 = dimm(a%d(0,4),sa4)

        call cct3_map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,1,2,4,3,-1)

      else
        ! sa1=sa2

        ! expand A(p_q,rs) -> B(p_q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB
        nhelp2 = b%d(ib1,1)
        ! dimrs
        nhelp3 = dimm(a%d(0,3),sa3)
        nhelp3 = nhelp3*(nhelp3-1)/2
        ! dimr,dimp_q
        nhelp4 = dimm(a%d(0,3),sa3)
        nhelp5 = dimm(a%d(0,1),sa1)*dimm(a%d(0,2),sa2)

        call cct3_expand3(wrk(nhelp1),wrk(nhelp2),nhelp5,nhelp3,nhelp4)

      end if

    end do

  else if (exptyp == 4) then

    !4.4 expand A(pq,rs) -> B(p,q,r,s)

    ! tests

    if (typa /= 4) then
      ! RC=11: nind=4, exptyp=4 (typA is not 4, Stup)
      rc = 11
      return
    end if

    do ia=1,na

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)
      sa4 = a%d(ia,6)

      ib1 = b%i(sa1,sa2,sa3)
      ib2 = b%i(sa2,sa1,sa3)
      ib3 = b%i(sa1,sa2,sa4)
      ib4 = b%i(sa2,sa1,sa4)

      if ((sa1 > sa2) .and. (sa3 > sa4)) then

        ! map A(p,q,r,s) -> B(p,q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map11(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),1)

        ! map A(p,q,r,s) -> - B(q,p,r,s)
        ! map A(p,q,r,s) -> - B(p,q,s,r)
        ! map A(p,q,r,s) -> + B(q,p,s,r)

        ! dimp,dimq,dimr,dims
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,2),sa2)
        nhelp5 = dimm(a%d(0,3),sa3)
        nhelp6 = dimm(a%d(0,4),sa4)

        ! posB2
        nhelp2 = b%d(ib2,1)
        call cct3_map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,2,1,3,4,-1)

        ! posB3
        nhelp2 = b%d(ib3,1)
        call cct3_map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,1,2,4,3,-1)

        ! posB4
        nhelp2 = b%d(ib4,1)
        call cct3_map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,2,1,4,3,1)

      else if ((sa1 == sa2) .and. (sa3 == sa4)) then

        ! expand A(pq,rs) -> B(p,q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB
        nhelp2 = b%d(ib1,1)
        ! dimp,dimq
        nhelp5 = dimm(a%d(0,1),sa1)
        nhelp6 = dimm(a%d(0,3),sa3)
        ! dimpq,dimrs
        nhelp3 = nhelp5*(nhelp5-1)/2
        nhelp4 = nhelp6*(nhelp6-1)/2

        call cct3_expand40(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6)

      else if (sa1 == sa2) then

        ! expand A(pq,r_s) -> B(p,q,r_s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! dimr,dims
        nhelp5 = dimm(a%d(0,3),sa3)
        nhelp6 = dimm(a%d(0,4),sa4)
        ! dimpq
        nhelp4 = dimm(a%d(0,1),sa1)
        nhelp3 = nhelp4*(nhelp4-1)/2

        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_expand1(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5*nhelp6,nhelp4)

        ! expand A(pq,r,s) -> - B(p,q,s,r)

        ! posB3
        nhelp2 = b%d(ib3,1)
        call cct3_expand41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5,nhelp6,nhelp4)

      else if (sa3 == sa4) then

        ! expand A(p_q,rs) -> B(p_q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! dimp,dimq
        nhelp5 = dimm(a%d(0,1),sa1)
        nhelp6 = dimm(a%d(0,2),sa2)
        ! dimrs
        nhelp4 = dimm(a%d(0,3),sa3)
        nhelp3 = nhelp4*(nhelp4-1)/2

        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_expand3(wrk(nhelp1),wrk(nhelp2),nhelp5*nhelp6,nhelp3,nhelp4)

        ! expand A(p,q,rs) -> - B(q,p,r,s)

        ! posB4
        nhelp2 = b%d(ib2,1)
        call cct3_expand41(wrk(nhelp1),wrk(nhelp2),nhelp5,nhelp6,nhelp3,nhelp4)

      end if

    end do

  else if (exptyp == 5) then

    !4.5 expand A(pq,rs) -> B(p,q,rs)

    ! tests

    if (typa /= 4) then
      ! RC=12: nind=4, exptyp=5 (typA is not 4, Stup)
      rc = 12
      return
    end if

    do ia=1,na

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)
      sa4 = a%d(ia,6)

      ib1 = b%i(sa1,sa2,sa3)
      ib2 = b%i(sa2,sa1,sa3)

      if (sa3 > sa4) then

        ! map A(p,q,r,s) -> B(p,q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map11(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),1)

        ! map A(p,q,r,s) -> - B(q,p,r,s)

        ! dimp,dimq,dimr,dims
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,2),sa2)
        nhelp5 = dimm(a%d(0,3),sa3)
        nhelp6 = dimm(a%d(0,4),sa4)

        ! posB2
        nhelp2 = b%d(ib2,1)
        call cct3_map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,2,1,3,4,-1)

      else if ((sa1 == sa2) .and. (sa3 == sa4)) then

        ! expand A(pq,rs) -> B(p,q,rs)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB
        nhelp2 = b%d(ib1,1)
        ! dimp,dimr
        nhelp5 = dimm(a%d(0,1),sa1)
        nhelp6 = dimm(a%d(0,3),sa3)
        ! dimpq,dimrs
        nhelp3 = nhelp5*(nhelp5-1)/2
        nhelp4 = nhelp6*(nhelp6-1)/2

        call cct3_expand1(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5)

      else if (sa1 == sa2) then

        ! expand A(pq,r_s) -> B(p,q,r_s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! dimr,dims
        nhelp5 = dimm(a%d(0,3),sa3)
        nhelp6 = dimm(a%d(0,4),sa4)
        ! dimpq
        nhelp4 = dimm(a%d(0,1),sa1)
        nhelp3 = nhelp4*(nhelp4-1)/2

        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_expand1(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp5*nhelp6,nhelp4)

      else if (sa3 == sa4) then

        ! map A(p,q,rs) -> B(p,q,rs)

        ! posA
        nhelp1 = a%d(ia,1)
        ! dimp,dimq
        nhelp5 = dimm(a%d(0,1),sa1)
        nhelp6 = dimm(a%d(0,2),sa2)
        ! dimrs
        nhelp4 = dimm(a%d(0,3),sa3)
        nhelp3 = nhelp4*(nhelp4-1)/2

        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map31(wrk(nhelp1),wrk(nhelp2),nhelp5,nhelp6,nhelp3,1,2,3,1)

        ! map A(p,q,rs) -> - B(q,p,rs)

        ! posB4
        nhelp2 = b%d(ib2,1)
        call cct3_map31(wrk(nhelp1),wrk(nhelp2),nhelp5,nhelp6,nhelp3,2,1,3,-1)

      end if

    end do

  else if (exptyp == 6) then

    !4.6 expand A(pq,rs) -> B(pq,r,s)

    ! tests

    if (typa /= 4) then
      ! RC=13: nind=4, exptyp=6 (typA is not 4, Stup)
      rc = 13
      return
    end if

    do ia=1,na

      sa1 = a%d(ia,3)
      sa2 = a%d(ia,4)
      sa3 = a%d(ia,5)
      sa4 = a%d(ia,6)

      ib1 = b%i(sa1,sa2,sa3)
      ib3 = b%i(sa1,sa2,sa4)

      if ((sa1 > sa2) .and. (sa3 > sa4)) then

        ! map A(p,q,r,s) -> B(p,q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map11(wrk(nhelp1),wrk(nhelp2),a%d(ia,2),1)

        ! map A(p,q,r,s) -> - B(q,p,r,s)
        ! map A(p,q,r,s) -> - B(p,q,s,r)
        ! map A(p,q,r,s) -> + B(q,p,s,r)

        ! dimp,dimq,dimr,dims
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,2),sa2)
        nhelp5 = dimm(a%d(0,3),sa3)
        nhelp6 = dimm(a%d(0,4),sa4)

        ! posB3
        nhelp2 = b%d(ib3,1)
        call cct3_map41(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6,1,2,4,3,-1)

      else if ((sa1 == sa2) .and. (sa3 == sa4)) then

        ! expand A(pq,rs) -> B(pq,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! posB
        nhelp2 = b%d(ib1,1)
        ! dimp,dimq
        nhelp5 = dimm(a%d(0,1),sa1)
        nhelp6 = dimm(a%d(0,3),sa3)
        ! dimpq,dimrs
        nhelp3 = nhelp5*(nhelp5-1)/2
        nhelp4 = nhelp6*(nhelp6-1)/2

        !@@? call cct3_expand4 (wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp5,nhelp6)
        call cct3_expand3(wrk(nhelp1),wrk(nhelp2),nhelp3,nhelp4,nhelp6)

      else if (sa1 == sa2) then

        ! map A(pq,r,s) -> B(pq,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! dimp,dimr,dims
        nhelp3 = dimm(a%d(0,1),sa1)
        nhelp4 = dimm(a%d(0,3),sa3)
        nhelp5 = dimm(a%d(0,4),sa4)
        ! dimpq
        nhelp6 = nhelp3*(nhelp3-1)/2

        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_map31(wrk(nhelp1),wrk(nhelp2),nhelp6,nhelp4,nhelp5,1,2,3,1)

        ! map A(pq,r,s) -> - B(pq,s,r)

        ! posB3
        nhelp2 = b%d(ib3,1)
        call cct3_map31(wrk(nhelp1),wrk(nhelp2),nhelp6,nhelp4,nhelp5,1,3,2,-1)

      else if (sa3 == sa4) then

        ! expand A(p,q,rs) -> B(p,q,r,s)

        ! posA
        nhelp1 = a%d(ia,1)
        ! dimp,dimq
        nhelp5 = dimm(a%d(0,1),sa1)
        nhelp6 = dimm(a%d(0,2),sa2)
        ! dimrs
        nhelp4 = dimm(a%d(0,3),sa3)
        nhelp3 = nhelp4*(nhelp4-1)/2

        ! posB1
        nhelp2 = b%d(ib1,1)
        call cct3_expand3(wrk(nhelp1),wrk(nhelp2),nhelp5*nhelp6,nhelp3,nhelp4)

      end if

    end do

  else
    ! RC=14: nind=4, exptyp=@ (Inproper exptyp, Stup)
    rc = 14
  end if

else
  ! RC=15- nind=@ (number of indices >4, NCI)
  rc = 15
end if

return

end subroutine cct3_expand

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jonas Bostrom                                          *
************************************************************************
      subroutine Finish_WDensity()
*********************************************
*
*     Author: Jonas Bostrom
*
*     Purpose: Add the terms labeled [II] and [III] to the energy-weighted
*              MP2 Density
*
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "files_mbpt2.fh"
#include "trafo.fh"
#include "mp2grad.fh"
#include "corbinf.fh"
      iOccAOcc(i,j,k) =   j-1 + (nOrb(k)+nDel(k)) *
     &                              (nFro(k) + i-1)
      iOccOcc(i,j,k) = j-1 + (nOrb(k) + nDel(k)) * (i-1)
      iVirVir(i,j,k) = j-1 + nFro(k) + nOcc(k) +
     &                      (nOrb(k) + nDel(k))*(i-1+nFro(k) + nOcc(k))
      iVirOcc(i,j,k) = j-1 + nFro(k) + nOcc(k) + (nOrb(k) + nDel(k))
     &                                *(i-1)
*
*     Get rid of silly compiler warning.
      iJ = 0
*     Start with the II-terms
      Do iSym = 1, nSym
         Do iI = 1, nOcc(iSym)
            Eps_i = Work(mAdOcc(iSym)+iI-1)
            Do iJ = 1, nFro(iSym) + nOcc(iSym)
               If(iJ.le.nFro(iSym)) Then
                  Eps_j = Work(mAdFro(iSym)+iJ-1)
                  Fac = 2.0d0
               Else
                  Eps_j = Work(mAdOcc(iSym)+iJ-nFro(iSym)-1)
                  Fac = 1.0d0
               End If
*     Fac is because both core-occ and occ-core contributions should be
*     added, they can both be added to IJ since we symmetrize W later and
*     the term is symmetric
               Work(ip_WDensity(iSym) + iOccAOcc(iI,iJ,iSym)) =
     &              Work(ip_WDensity(iSym) + iOccAOcc(iI,iJ,iSym)) -
     &              Fac*Work(ip_Density(iSym) + iOccAOcc(iI,iJ,iSym))*
     &                  0.5d0*(Eps_i + Eps_j)
             End Do
         End Do
         Do iA = 1, nExt(iSym)
            Eps_a = Work(mAdVir(iSym) + iA-1)
            Do iB = 1, nExt(iSym) + nDel(iSym)
               If(iB.gt.nExt(iSym)) Then
                  Eps_b = Work(mAdDel(iSym) + iB-1-nExt(iSym))
               Else
                  Eps_b = Work(mAdVir(iSym) + iB-1)
               End If
               Work(ip_WDensity(iSym) + iVirVir(iB,iA,iSym)) =
     &              Work(ip_WDensity(iSym) + iVirVir(iB,iA,iSym)) -
     &              Work(ip_Density(iSym) + iVirVir(iB,iA,iSym))*
     &              0.5d0*(Eps_a + Eps_b)
            End Do
         End Do

         Do iI = 1, nFro(iSym) + nOcc(iSym)
            If(iI.le.nFro(iSym)) Then
               Eps_i = Work(mAdFro(iSym)+iI-1)
            Else
               Eps_i = Work(mAdOcc(iSym)+iI-nFro(iSym)-1)
            End If
            Do iA = 1, nExt(iSym) + nDel(iSym)
               Work(ip_WDensity(iSym) + iVirOcc(iI,iA,iSym)) =
     &              Work(ip_WDensity(iSym) + iVirOcc(iI,iA,iSym)) -
     &              Work(ip_Density(iSym) + iVirOcc(iI,iA,iSym))*
     &              2.0d0*(Eps_i)
            End Do
         End Do
      End Do
*     And now the [III]-terms
      nMaxOrb=0
      Do iSym1 = 1,nSym
         Do iSym2 = 1,nSym
            nMaxOrb = Max(nMaxOrb,(nOrb(iSym1)+nDel(iSym1))
     &              *(nOrb(iSym2)+nDel(iSym2)))
         End Do
      End Do
      lint = nMaxOrb
      Call GetMem('Int1','Allo','Real',ipInt1,lInt)
      Call GetMem('Int2','Allo','Real',ipInt2,lInt)
      Call GetMem('IntC','Allo','Real',ipIntC,lInt)
      Call GetMem('Scr1','Allo','Real',ipScr1,lInt)
      Do iSymIJ = 1, nSym
         Do iSymPQ = 1, nSym
            Do iI = 1, nFro(iSymIJ) + nOcc(iSymIJ)
               Do iJ = 1, iI
                  Call Exch(iSymPQ,iSymIJ,iSymPQ,iSymIJ,
     &                 iJ,
     &                 iI,
     &                 Work(ipInt1), Work(ipScr1))
                  Call Coul(iSymPQ,iSymPQ,iSymIJ,iSymIJ,
     &                 iJ,
     &                 iI,
     &                 Work(ipIntC), Work(ipScr1))

*                  Write(6,*) 'Finish'
*                  Write(6,*) ' *  i,j = ',iI, iJ
*               Call RecPrt('Int1:','(8F10.6)',Work(ipInt1),
*     &              nOrb(iSymPQ)+nDel(iSymPQ),
*     &              nOrb(iSymPQ)+nDel(iSymPQ))
*               Call RecPrt('IntC:','(8F10.6)',Work(ipIntC),
*     &              nOrb(iSymPQ)+nDel(iSymPQ),
*     &              nOrb(iSymPQ)+nDel(iSymPQ))
                  Do iP = 1, nOrb(iSymPQ) + nDel(iSymPQ)
                     Do iQ = 1, nOrb(iSymPQ)+nDel(iSymPQ)
                        xipjq = Work(ipInt1 + (iP-1) +
     &                         (iQ-1)*(nOrb(iSymPQ) + nDel(iSymPQ)))
                        xijpq = Work(ipIntC + (iP-1) +
     &                         (iQ-1)*(nOrb(iSymPQ) + nDel(iSymPQ)))
                        Work(ip_WDensity(iSymIJ)+iOccOcc(iI,iJ,iSymIJ))=
     &                  Work(ip_WDensity(iSymIJ)+iOccOcc(iI,iJ,iSymIJ))-
     &                  Work(ip_Density(iSymPQ)+iOccOcc(iP,iQ,iSymPQ))*
     &                   (2.0d0*xijpq - xipjq)
                        If(iJ.ne.iI) Then
                           Work(ip_WDensity(iSymIJ)
     &                         +iOccOcc(iJ,iI,iSymIJ))=
     &                          Work(ip_WDensity(iSymIJ)
     &                          +iOccOcc(iJ,iI,iSymIJ))-
     &                          Work(ip_Density(iSymPQ)
     &                          +iOccOcc(iP,iQ,iSymPQ))*
     &                          (2.0d0*xijpq - xipjq)
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do
*     Do the symmetrization of the energy weighted density and add the
*     SCF-energyweighted density. Also changes sign on W since the formulas
*     in the used article yields -W
      Do iSym = 1, nSym
         Do iP=1, nOrb(iSym) + nDel(iSym)
            Do iQ =1,iP
               If(iQ.ne.iP) Then
                  Work(ip_WDensity(iSym)+iOccOcc(iP,iQ,iSym)) = -
     &             (Work(ip_WDensity(iSym)+iOccOcc(iP,iQ,iSym)) +
     &              Work(ip_WDensity(iSym)+iOccOcc(iQ,iP,iSym)))/2.0d0
                  Work(ip_WDensity(iSym)+iOccOcc(iQ,iP,iSym)) =
     &                Work(ip_WDensity(iSym)+iOccOcc(iP,iQ,iSym))
               Else If(iQ.le.nFro(iSym)) Then
                  Work(ip_WDensity(iSym)+iOccOcc(iP,iQ,iSym)) = -
     &              Work(ip_WDensity(iSym)+iOccOcc(iP,iQ,iSym)) +
     &              2.0d0*Work(mAdFro(iSym)+iQ-1)
               Else If(iQ.le.nFro(iSym)+nOcc(iSym)) Then
                  Work(ip_WDensity(iSym)+iOccOcc(iP,iQ,iSym)) = -
     &              Work(ip_WDensity(iSym)+iOccOcc(iP,iQ,iSym)) +
     &              2.0d0*Work(mAdOcc(iSym)+iQ-nFro(iSym)-1)
               Else
                  Work(ip_WDensity(iSym)+iOccOcc(iP,iQ,iSym)) = -
     &              Work(ip_WDensity(iSym)+iOccOcc(iP,iQ,iSym))
               End If
            End Do
         End Do
      End Do

*
      Call GetMem('Int1','Free','Real',ipInt1,lInt)
      Call GetMem('Int2','Free','Real',ipInt2,lInt)
      Call GetMem('IntC','Free','Real',ipIntC,lInt)
      Call GetMem('Scr1','Free','Real',ipScr1,lInt)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine ext (wrk,wrksize,
     & nind,exttyp,u,v,x,ssu,ssv,ssx,mapda,mapia,ssa,
     & possb0,mapdb,mapib,ssb,rc)
c
c     thsi routine realize extraction
c
c     A(indA) -> B_u(indB) for given u
c
c     nind   - # of indexex in matrix A  (Input)
c     exttyp - type of extraction :  (Input)
c     1 - A(pqrs) -> B_p (qrs); A(pqr) -> B_p(qr) ; A(pq) -> B_p(q)
c     2 - A(pqrs) -> B_q (prs); A(pqr) -> B_q(p,r); A(pq) -> B_q(p)
c     3 - A(pqrs) -> B_r (pqs); A(pqr) -> B_r(pq)
c     4 - A(pqrs) -> B_s (pqr)
c     5 - A(pqrs) -< A_pq(rs) ; A(pqr) -> B_pq(r)
c     6 - A(pqrs) -> B_qr(p,s); A(pqr) -> B_pq(r)
c     7 - A(pqrs) -> B_rs(pq)
c     8 - A(pqrs) -> B_pqr(s)
c     9 - A(pqrs) -> B_qrs(p)
c
c     u      - value of 1.st fix index (I)
c     v      - value of 2.nd fix index (I)
c     x      - value of 3.rd fix index (I)
c     ssu    - symmetry of 1.st fix index (I)
c     ssv    - symmetry of 2.nd fix index (I)
c     ssx    - symmetry of 3.rd fix index (I)
c     mapda  - direct map matrix corresponding to A  (Input)
c     mapia  - inverse map matrix corresponding to A  (Input)
c     ssa    - overall symetry state  of matrix A  (Input)
c     possb0 - initial possition of matrix B in WRK  (Input)
c     mapdb  - direct map matrix corresponding to B  (Output)
c     mapib  - inverse map matrix corresponding to B  (Output)
c     ssb    - overall symetry state  of matrix B  (Output)
c     rc     - return (error) code  (Output)
c
c     Table of extractions
c
c     nind  exttyp          Operation             Implementation
c     4       1     A(p,q,r,s) -> B _p(q,r,s)          Yes
c     A(pq,r,s)  -> B _p(q,r,s)          Yes
c     A(p,qr,s)  -> B _p(qr,s)           NCI
c     A(p,q,rs)  -> B _p(q,rs)           Yes
c     B(pq,rs)   -> B _p(q,rs)           Yes
c
c     4       2     A(p,q,r,s) -> B _q(p,r,s)          Yes
c     A(pq,r,s)  -> B _q(p,r,s)     No (use 4,1)
c     A(p,qr,s)  -> B _q(p,r,s)          NCI
c     A(p,q,rs)  -> B _q(p,rs)           Yes
c     B(pq,rs)   -> B _q(p,rs)      No (use 4,1)
c
c     4       3     A(p,q,r,s) -> B _r(p,q,s)          Yes
c     A(pq,r,s)  -> B _r(pq,s)           Yes
c     A(p,qr,s)  -> B _r(p,q,s)     No (use 4.2 - NCI)
c     A(p,q,rs)  -> B _r(p,q,s)          Yes
c     B(pq,rs)   -> B _r(pq,s)           Yes
c
c     4       4     A(p,q,r,s) -> B _s(p,q,r)          Yes
c     A(pq,r,s)  -> B _s(pq,r)           Yes
c     A(p,qr,s)  -> B _s(p,qr)           NCI
c     A(p,q,rs)  -> B _s(p,q,r)     No (use 4,3)
c     B(pq,rs)   -> B _s(pq,r)      No (use 4,3)
c
c     4       5     A(p,q,r,s) -> B _p_q (r,s)         Yes
c     A(pq,r,s)  -> B _pq (r,s)          NCI
c     A(p,qr,s)  -> B _p_q (r,s)         NCI
c     A(p,q,rs)  -> B _p_q (rs)          NCI
c     A(pq,rs)   -> B _pq (rs)           Yes
c
c     4       6     any case                           NCI
c
c     4       7     A(p,q,r,s) -> B _r_s (p,q)         Yes
c     A(pq,r,s)  -> B _r_s (pq)          NCI
c     A(p,qr,s)  -> B _r_s (p,q)         NCI
c     A(p,q,rs)  -> B _r_s (rs)          Yes
c     A(pq,rs)   -> B _pq (rs)           Yes
c
c     4      8,9    any case                           NCI
c
c     3   any case  any case                           NCI
c
c     2       1     A(p,q)     -> B _p (q)             Yes
c     A(pq)      -> B _p (q)             NCI
c
c     2       2     A(p,q)     -> B _q (p)             Yes
c     A(pq)      -> B _q (p)             NCI
c
c
#include "t31.fh"
#include "wrk.fh"
c
       integer nind,exttyp,ssa,u,v,x,ssu,ssv,ssx,possb0,ssb,rc
       integer mapda(0:512,1:6),mapdb(0:512,1:6)
       integer mapia(1:8,1:8,1:8),mapib(1:8,1:8,1:8)
c
c     help variables
       integer typa,typb,possa,possb,symp,symq,symr,syms
       integer ia,ib,key,posst
       integer nhelp1,nhelp2,jjind,signum
       integer dimp,dimq,dimr,dims
c
c     To fix some warnings
      symr=0
c0.*  some general tests
c
       if (mapda(0,6).eq.2) then
c     RC=2  : nind=4, typA=2 (NCI)
       rc=2
       return
       end if

c
c0.*  def typa and ssB
c
       typa=mapda(0,6)
       if (exttyp.le.4) then
c     one extetnal index
       ssb=mmul(ssa,ssu)
       else if (exttyp.le.7) then
c     two extetnal indexes
       nhelp1=mmul(ssu,ssv)
       ssb=mmul(ssa,nhelp1)
       else
c     3 external indeses
       nhelp1=mmul(ssu,ssv)
       nhelp2=mmul(nhelp1,ssx)
       ssb=mmul(nhelp2,ssa)
       end if
c
c
c
       if (nind.eq.4) then
c
c4    A(pqrs) -> B(stv)
c
       if (exttyp.eq.1) then
c
c4.1  A(pqrs) -> B_p(qrs)
c
c
       if (typa.eq.0) then
c
c4.1.0**** case A(p,q,r,s) -> B_p(q,r,s) ****
c
c4.1.0.*    get mapdb,mapib
       typb=0
       call cct3_grc0 (3,typb,mapda(0,2),mapda(0,3),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 410 ib=1,mapdb(0,5)
c
c4.1.0.*      def symmetry of all indices
       symq=mapdb(ib,3)
       symr=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.1.0.*      find porper A
       ia=mapia(ssu,symq,symr)
c
c4.1.0.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.1.0.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
       nhelp1=dimq*dimr*dims
c
c4.1.0.*      realize extraction
       call exth1 (wrk(possa),wrk(possb),dimp,nhelp1,u,1)
c
 410    continue
c
c
       else if (typa.eq.1) then
c
c4.1.1**** case A(pq,r,s) -> B_p(q,r,s) ****
c
       typb=0
       call cct3_grc0 (3,typb,mapda(0,2),mapda(0,3),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 411 ib=1,mapdb(0,5)
c
c4.1.1.*      def symmetry of all indices
       symq=mapdb(ib,3)
       symr=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.1.1.*      def key su>sq - 1 ; su=sq - 2 ; su<sq - 3
       if (ssu.gt.symq) then
       key=1
       else if (ssu.eq.symq) then
       key=2
       else
       key=3
       end if
c
c4.1.1.*      find porper A
       if (key.lt.3) then
       ia=mapia(ssu,symq,symr)
       else
       ia=mapia(symq,ssu,symr)
       end if
c
c4.1.1.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.1.1.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
c4.1.1.*      realize extraction
       if (key.eq.1) then
       nhelp1=dimq*dimr*dims
       call exth1 (wrk(possa),wrk(possb),dimp,nhelp1,u,1)
       else if (key.eq.2) then
       nhelp1=dimp*(dimp-1)/2
       nhelp2=dimr*dims
       call exth4 (wrk(possa),wrk(possb),dimp,nhelp1,nhelp2,u)
       else
c     key=3
       nhelp1=dimr*dims
       call exth3 (wrk(possa),wrk(possb),dimq,dimp,nhelp1,u,-1)
       end if
c
 411    continue
c
c
       else if (typa.eq.2) then
c
c4.1.2**** case A(p,qr,s) -> B_p(qr,s) ****
c     NCI
c
c
       else if (typa.eq.3) then
c
c4.1.3**** case A(p,q,rs) -> B_p(q,rs) ****
c
       typb=2
       call cct3_grc0 (3,typb,mapda(0,2),mapda(0,3),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 413 ib=1,mapdb(0,5)
c
c4.1.3.*      def symmetry of all indices
       symq=mapdb(ib,3)
       symr=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.1.3.*      find porper A
       ia=mapia(ssu,symq,symr)
c
c4.1.3.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.1.3.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
       if (symr.eq.syms) then
       nhelp1=dimq*dimr*(dimr-1)/2
       else
       nhelp1=dimq*dimr*dims
       end if
c
c4.1.3.*      realize extraction
       call exth1 (wrk(possa),wrk(possb),dimp,nhelp1,u,1)
c
 413    continue
c
c
       else if (typa.eq.4) then
c
c4.1.4**** case A(pq,rs) -> B_p(q,rs) ****
c
       typb=2
       call cct3_grc0 (3,typb,mapda(0,2),mapda(0,3),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 414 ib=1,mapdb(0,5)
c
c4.1.4.*      def symmetry of all indices
       symq=mapdb(ib,3)
       symr=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.1.4.*      def key su>sq - 1 ; su=sq - 2 ; su<sq - 3
       if (ssu.gt.symq) then
       key=1
       else if (ssu.eq.symq) then
       key=2
       else
       key=3
       end if
c
c4.1.4.*      find porper A
       if (key.lt.3) then
       ia=mapia(ssu,symq,symr)
       else
       ia=mapia(symq,ssu,symr)
       end if
c
c4.1.4.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.1.4.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
c4.1.4.*      realize extraction
c
       if (key.eq.1) then
       if (symr.eq.syms) then
       nhelp1=dimq*dimr*(dimr-1)/2
       else
       nhelp1=dimq*dimr*dims
       end if
       call exth1 (wrk(possa),wrk(possb),dimp,nhelp1,u,1)
c
       else if (key.eq.2) then
       nhelp1=dimp*(dimp-1)/2
       if (symr.eq.syms) then
       nhelp2=dimr*(dimr-1)/2
       else
       nhelp2=dimr*dims
       end if
       call exth4 (wrk(possa),wrk(possb),dimp,nhelp1,nhelp2,u)
c
       else
c     key=3
       if (symr.eq.syms) then
       nhelp1=dimr*(dimr-1)/2
       else
       nhelp1=dimr*dims
       end if
       call exth3 (wrk(possa),wrk(possb),dimq,dimp,nhelp1,u,-1)
       end if
c
 414    continue
c
c
       end if
c
c
c
       else if (exttyp.eq.2) then
c
c4.2  A(pqrs) -> B_q(prs)
c
c
       if ((typa.eq.0).or.(typa.eq.3)) then
c
c4.2.0case A(p,q,r,s) -> B_q(p,r,s)
c
       typb=0
       call cct3_grc0 (3,typb,mapda(0,1),mapda(0,3),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 420 ib=1,mapdb(0,5)
c
c4.2.0.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symr=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.2.0.*      find porper A
       ia=mapia(symp,ssu,symr)
c
c4.2.0.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.2.0.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
       nhelp1=dimr*dims
c
c4.2.0.*      realize extraction
       call exth3 (wrk(possa),wrk(possb),dimp,dimq,nhelp1,u,1)
c
 420    continue
c
c
       else if (typa.eq.1) then
c
c4.2.1case A(pq,r,s) -> B_q(p,r,s)
c
c     RC=3 : nind=4, typA=1, exttyp=2 (NI - Use exttyp 1)
       rc=3
       return
c
c
       else if (typa.eq.2) then
c
c4.2.2case A(p,qr,s) -> B_q(p,r,s)
c
c     RC=4 : nind=4, typA=2 (NCI)
       rc=4
       return
c
c
       else if (typa.eq.3) then
c
c4.2.3case A(p,q,rs) -> B_q(p,rs)
c
       typb=2
       call cct3_grc0 (3,typb,mapda(0,1),mapda(0,3),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 423 ib=1,mapdb(0,5)
c
c4.2.3.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symr=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.2.3.*      find porper A
       ia=mapia(symp,ssu,symr)
c
c4.2.3.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.2.3.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
       if (symr.eq.syms) then
       nhelp1=dimr*(dimr-1)/2
       else
       nhelp1=dimr*dims
       end if
c
c4.2.3.*      realize extraction
       call exth3 (wrk(possa),wrk(possb),dimp,dimq,nhelp1,u,1)
c
 423    continue
c
c
       else if (typa.eq.4) then
c
c4.2.4case A(pq,r,s) -> B_q(p,r,s)
c
c     RC=5 : nind=4, typA=4, exttyp=2 (NI - Use exttyp 1)
       rc=5
       return
c
c
       end if
c
c
c
       else if (exttyp.eq.3) then
c
c4.3  A(pqrs) -> B_r(pqs)
c
c
       if (typa.eq.0) then
c
c4.3.0case A(p,q,r,s) -> B_r(p,q,s)
c
       typb=0
       call cct3_grc0 (3,typb,mapda(0,1),mapda(0,2),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 430 ib=1,mapdb(0,5)
c
c4.3.0.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.3.0.*      find porper A
       ia=mapia(symp,symq,ssu)
c
c4.3.0.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.3.0.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
       nhelp1=dimp*dimq
c
c4.3.0.*      realize extraction
       call exth3 (wrk(possa),wrk(possb),nhelp1,dimr,dims,u,1)
c
 430    continue
c
c
       else if (typa.eq.1) then
c
c4.3.1case A(pq,r,s) -> B_r(pq,s)
c
       typb=1
       call cct3_grc0 (3,typb,mapda(0,1),mapda(0,2),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 431 ib=1,mapdb(0,5)
c
c4.3.1.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.3.1.*      find porper A
       ia=mapia(symp,symq,ssu)
c
c4.3.1.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.3.1.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
       if (symp.eq.symq) then
       nhelp1=dimp*(dimp-1)/2
       else
       nhelp1=dimp*dimq
       end if
c
c4.3.1.*      realize extraction
       call exth3 (wrk(possa),wrk(possb),nhelp1,dimr,dims,u,1)
c
 431    continue
c
c
       else if (typa.eq.2) then
c
c4.3.2case A(p,qr,s) -> B_r(p,q,s)
c
c     RC=6 : nind=4, typA=2 (NCI)
       rc=6
       return
c
c
       else if (typa.eq.3) then
c
c4.3.3case A(p,q,rs) -> B_r(p,q,s)
c
       typb=0
       call cct3_grc0 (3,typb,mapda(0,1),mapda(0,2),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 433 ib=1,mapdb(0,5)
c
c4.3.3.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.3.3.*      def key su>ss - 1 ; su=ss - 2 ; su<ss - 3
       if (ssu.gt.syms) then
       key=1
       else if (ssu.eq.syms) then
       key=2
       else
       key=3
       end if
c
c4.3.3.*      find porper A
       if (key.lt.3) then
       ia=mapia(symp,symq,ssu)
       else
       ia=mapia(symp,symq,symr)
       end if
c
c4.3.3.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.3.3.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
c4.3.3.*      realize extraction
       if (key.eq.1) then
       nhelp1=dimp*dimq
       call exth3 (wrk(possa),wrk(possb),nhelp1,dimr,dims,u,1)
       else if (key.eq.2) then
       nhelp1=dimp*dimq
       nhelp2=dimr*(dimr-1)/2
       call exth5 (wrk(possa),wrk(possb),nhelp1,dimr,nhelp2,u)
       else
c     key=3
       nhelp1=dimp*dimq
       call exth3 (wrk(possa),wrk(possb),nhelp1,dims,dimr,u,-1)
       end if
c
 433    continue
c
c
       else if (typa.eq.4) then
c
c4.3.4case A(pq,rs) -> B_r(pq,s)
c
       typb=1
       call cct3_grc0 (3,typb,mapda(0,1),mapda(0,2),mapda(0,4),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 434 ib=1,mapdb(0,5)
c
c4.3.4.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
       syms=mapdb(ib,5)
c
c4.3.4.*      def key su>ss - 1 ; su=ss - 2 ; su<ss - 3
       if (ssu.gt.syms) then
       key=1
       else if (ssu.eq.syms) then
       key=2
       else
       key=3
       end if
c
c4.3.4.*      find porper A
       if (key.lt.3) then
       ia=mapia(symp,symq,ssu)
       else
       ia=mapia(symp,symq,syms)
       end if
c
c4.3.4.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.3.4.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
c4.3.4.*      realize extraction
       if (key.eq.1) then
       if (symp.eq.symq) then
       nhelp1=dimp*(dimq-1)/2
       else
       nhelp1=dimp*dimq
       end if
       call exth3 (wrk(possa),wrk(possb),nhelp1,dimr,dims,u,1)
       else if (key.eq.2) then
       if (symp.eq.symq) then
       nhelp1=dimp*(dimq-1)/2
       else
       nhelp1=dimp*dimq
       end if
       nhelp2=dimr*(dimr-1)/2
       call exth5 (wrk(possa),wrk(possb),nhelp1,dimr,nhelp2,u)
       else
c     key=3
       if (symp.eq.symq) then
       nhelp1=dimp*(dimq-1)/2
       else
       nhelp1=dimp*dimq
       end if
       nhelp1=nhelp1*dimr
       call exth2 (wrk(possa),wrk(possb),nhelp1,dims,u,-1)
       end if
c
 434    continue
c
c
       end if
c
c
c
       else if (exttyp.eq.4) then
c
c4.4  case A(pqrs) -> B_s(pqr)
c
c
       if (typa.eq.0) then
c
c4.4.0case A(p,q,r,s) -> B_s(p,q,r)
c
       typb=0
       call cct3_grc0 (3,typb,mapda(0,1),mapda(0,2),mapda(0,3),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 440 ib=1,mapdb(0,5)
c
c4.4.0.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
       symr=mapdb(ib,5)
c
c4.4.0.*      find porper A
       ia=mapia(symp,symq,symr)
c
c4.4.0.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.4.0.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
       nhelp1=dimp*dimq*dimr
c
c4.4.0.*      realize extraction
       call exth2 (wrk(possa),wrk(possb),nhelp1,dims,u,1)
c
 440    continue
c
c
       else if (typa.eq.1) then
c
c4.4.1case A(pq,r,s) -> B_s(pq,r)
c
       typb=1
       call cct3_grc0 (3,typb,mapda(0,1),mapda(0,2),mapda(0,3),0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 441 ib=1,mapdb(0,5)
c
c4.4.1.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
       symr=mapdb(ib,5)
c
c4.4.1.*      find porper A
       ia=mapia(symp,symq,symr)
c
c4.4.1.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.4.1.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
c4.4.1.*      realize extraction
       if (symp.eq.symq) then
       nhelp1=dimp*(dimq-1)*dimr/2
       else
       nhelp1=dimp*dimq*dimr
       end if
       call exth2 (wrk(possa),wrk(possb),nhelp1,dims,u,1)
c
 441    continue
c
c
       else if (typa.eq.2) then
c
c4.4.2case A(p,qr,s) -> B_s(p,qr)
c
c     RC=7 : nind=4, typA=2  (NCI)
       rc=7
       return
c
c
       else if (typa.eq.3) then
c
c4.4.3case A(p,q,rs) -> B_s(p,q,r)
c
c     RC=8 : nind=4, typA=3, exttyp=4 (NI - Use exttyp 3)
       rc=8
       return
c
c
       else if (typa.eq.4) then
c
c4.4.4case A(pq,rs) -> B_s(pq,r)
c
c     RC=9 : nind=4, typA=4, exttyp=4 (NI - Use exttyp 3)
       rc=9
       return
c
c
       end if
c
       else if (exttyp.eq.5) then
c
c4.5  case A(pqrs) -> B_pq(rs)
c
       if (typa.eq.0) then
c
c4.5.0case A(p,q,r,s) -> B_p_q(r,s)
c
       typb=0
       call cct3_grc0 (2,typb,mapda(0,3),mapda(0,4),0,0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 450 ib=1,mapdb(0,5)
c
c4.5.0.*      def symmetry of all indices
       symr=mapdb(ib,3)
       syms=mapdb(ib,4)
c
c4.5.0.*      find porper A
       ia=mapia(ssu,ssv,symr)
c
c4.5.0.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.5.0.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
       nhelp1=dimp*dimq
       nhelp2=dimr*dims
       jjind=(v-1)*dimp+u
c
c4.5.0.*      realize extraction
       call exth1 (wrk(possa),wrk(possb),nhelp1,nhelp2,jjind,1)
c
 450    continue
c
       else if (typa.eq.4) then
c
c4.5.4case A(pq,rs) -> B_pq(rs)
c
       typb=1
       call cct3_grc0 (2,typb,mapda(0,3),mapda(0,4),0,0,ssb,
     & possb0,posst,mapdb,mapib)
c
       if (ssu.ge.ssv) then
c4.5.4.1      case symp >= symq
c
       do 4541 ib=1,mapdb(0,5)
c
c4.5.4.1.*      def symmetry of all indices
       symr=mapdb(ib,3)
       syms=mapdb(ib,4)
c
c4.5.4.1.*      find porper A
       ia=mapia(ssu,ssv,symr)
c
c4.5.4.1.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.5.4.1.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
       if (ssu.eq.ssv) then
       nhelp1=dimp*(dimp-1)/2
       else
       nhelp1=dimp*dimq
       end if
c
       if (symr.eq.syms) then
       nhelp2=dimr*(dimr-1)/2
       else
       nhelp2=dimr*dims
       end if
c
c4.5.4.1.*        def joined index and signum
       signum=1
       if (ssu.eq.ssv)then
       if (u.gt.v) then
       jjind=nshf(u)+v
       else if (u.eq.v) then
       jjind=0
       signum=0
       else
       jjind=nshf(v)+u
       signum=-1
       end if
       else
       jjind=(v-1)*dimp+u
       end if
c
c4.5.4.1.*      realize extraction
       call exth1 (wrk(possa),wrk(possb),nhelp1,nhelp2,jjind,
     & signum)
c
 4541   continue
c
       else
c4.5.4.2      case symp < symq
c
       do 4542 ib=1,mapdb(0,5)
c
c4.5.4.2.*      def symmetry of all indices
       symr=mapdb(ib,3)
       syms=mapdb(ib,4)
c
c4.5.4.2.*      find porper A
       ia=mapia(ssv,ssu,symr)
c
c4.5.4.2.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.5.4.2.*      def dimensions
       dimq=dimm(mapda(0,1),mapda(ia,3))
       dimp=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
       nhelp1=dimp*dimq
c
       if (symr.eq.syms) then
       nhelp2=dimr*(dimr-1)/2
       else
       nhelp2=dimr*dims
       end if
c
c4.5.4.2.*        def joined index and signum
       signum=-1
       jjind=(u-1)*dimp+v
c
c4.5.4.2.*      realize extraction
       call exth1 (wrk(possa),wrk(possb),nhelp1,nhelp2,jjind,
     & signum)
c
 4542   continue
c
       end if
c
       else
c     RC=10 , nindA=4, exttyp=5, typa is nou 0,4 (NCI)
       rc=10
       return
       end if
c
       else if (exttyp.eq.7) then
c
c4.7  case         A(pqrs) -> B_rs(pq)
c
       if (typa.eq.0) then
c
c4.7.0case A(p,q,r,s) -> B_r_s(p,q)
c
       typb=0
       call cct3_grc0 (2,typb,mapda(0,1),mapda(0,2),0,0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 470 ib=1,mapdb(0,5)
c
c4.7.0.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
c
c4.7.0.*      find porper A
       ia=mapia(symp,symq,ssu)
c
c4.7.0.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.7.0.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
       nhelp1=dimp*dimq
       nhelp2=dimr*dims
       jjind=(v-1)*dimr+u
c
c4.7.0.*      realize extraction
       call exth2 (wrk(possa),wrk(possb),nhelp1,nhelp2,jjind,1)
c
 470    continue
c
       else if (typa.eq.3) then
c
c4.7.3case A(p,q,rs) -> B_rs(p,q)
c
       typb=2
       call cct3_grc0 (2,typb,mapda(0,1),mapda(0,2),0,0,ssb,
     & possb0,posst,mapdb,mapib)
c
       if (ssu.ge.ssv) then
c4.7.3.1      case symr >= syms
c
       do 4731 ib=1,mapdb(0,5)
c
c4.7.3.1.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
c
c4.7.3.1.*      find porper A
       ia=mapia(symp,symq,ssu)
c
c4.7.3.1.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.7.3.1.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
       if (ssu.eq.ssv) then
       nhelp1=dimr*(dimr-1)/2
       else
       nhelp1=dimr*dims
       end if
c
       nhelp2=dimp*dimq
c
c4.7.3.1.*        def joined index and signum
       signum=1
       if (ssu.eq.ssv)then
       if (u.gt.v) then
       jjind=nshf(u)+v
       else if (u.eq.v) then
       jjind=0
       signum=0
       else
       jjind=nshf(v)+u
       signum=-1
       end if
       else
       jjind=(v-1)*dimr+u
       end if
c
c4.7.3.1.*      realize extraction
       call exth2 (wrk(possa),wrk(possb),nhelp2,nhelp1,jjind,
     & signum)
c
 4731   continue
c
       else
c4.7.3.2      case symp < symq
c
       do 4732 ib=1,mapdb(0,5)
c
c4.7.3.2.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
c
c4.7.3.2.*      find porper A
       ia=mapia(symp,symq,ssv)
c
c4.7.3.2.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.7.3.2.*      def dimensions
       dimq=dimm(mapda(0,1),mapda(ia,3))
       dimp=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
       nhelp1=dimr*dims
c
       nhelp2=dimp*dimq
c
c4.7.3.2.*        def joined index and signum
       signum=-1
       jjind=(u-1)*dimr+v
c
c4.7.3.2.*      realize extraction
       call exth2 (wrk(possa),wrk(possb),nhelp2,nhelp1,jjind,
     & signum)
c
 4732   continue
c
       end if
c
c
       else if (typa.eq.4) then
c
c4.7.4case A(pq,rs) -> B_rs(pq)
c
       typb=1
       call cct3_grc0 (2,typb,mapda(0,1),mapda(0,2),0,0,ssb,
     & possb0,posst,mapdb,mapib)
c
       if (ssu.ge.ssv) then
c4.7.4.1      case symr >= syms
c
       do 4741 ib=1,mapdb(0,5)
c
c4.7.4.1.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
c
c4.7.4.1.*      find porper A
       ia=mapia(symp,symq,ssu)
c
c4.7.4.1.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.7.4.1.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
       if (ssu.eq.ssv) then
       nhelp1=dimr*(dimr-1)/2
       else
       nhelp1=dimr*dims
       end if
c
       if (symp.eq.symq) then
       nhelp2=dimp*(dimp-1)/2
       else
       nhelp2=dimp*dimq
       end if
c
c4.7.4.1.*        def joined index and signum
       signum=1
       if (ssu.eq.ssv)then
       if (u.gt.v) then
       jjind=nshf(u)+v
       else if (u.eq.v) then
       jjind=0
       signum=0
       else
       jjind=nshf(v)+u
       signum=-1
       end if
       else
       jjind=(v-1)*dimr+u
       end if
c
c4.7.4.1.*      realize extraction
       call exth2 (wrk(possa),wrk(possb),nhelp2,nhelp1,jjind,
     & signum)
c
 4741   continue
c
       else
c4.7.4.2      case symp < symq
c
       do 4742 ib=1,mapdb(0,5)
c
c4.7.4.2.*      def symmetry of all indices
       symp=mapdb(ib,3)
       symq=mapdb(ib,4)
c
c4.7.4.2.*      find porper A
       ia=mapia(symp,symq,ssv)
c
c4.7.4.2.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c4.7.4.2.*      def dimensions
       dimq=dimm(mapda(0,1),mapda(ia,3))
       dimp=dimm(mapda(0,2),mapda(ia,4))
       dimr=dimm(mapda(0,3),mapda(ia,5))
       dims=dimm(mapda(0,4),mapda(ia,6))
c
       nhelp1=dimr*dims
c
       if (symp.eq.symq) then
       nhelp2=dimp*(dimp-1)/2
       else
       nhelp2=dimp*dimq
       end if
c
c4.7.4.2.*        def joined index and signum
       signum=-1
       jjind=(u-1)*dimr+v
c
c4.7.4.2.*      realize extraction
       call exth2 (wrk(possa),wrk(possb),nhelp2,nhelp1,jjind,
     & signum)
c
 4742   continue
c
       end if
c
       else
c     RC=11 , nindA=4, exttyp=7, typa is nou 0,4 (NCI)
       rc=11
       return
       end if
c
       else
c     RC=12  nindA=4, exttyp 1,2,3,4,5 or 7 (Stup/NCI)
       rc=12
       return
c
       end if
c
       else if (nind.eq.2) then
c
       if (exttyp.eq.1) then
c
c2.1  case A(p q) -> A _p(q)
c
       if (typa.eq.0) then
c
c2.1.0case A(p,q) -> B _p(q)
c
       typb=0
       call cct3_grc0 (1,typb,mapda(0,2),0,0,0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 210 ib=1,mapdb(0,5)
c
c2.1.0.*      def symmetry of all indices
       symq=mapdb(ib,3)
c
c2.1.0.*      find porper A
       ia=mapia(ssu,1,1)
c
c2.1.0.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c2.1.0.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
c
c2.1.0.*      realize extraction
       call exth1 (wrk(possa),wrk(possb),dimp,dimq,u,1)
c
 210    continue
c
       else
c     RC=13  : nindA=2, exttyp=1, typa is not 0 (NCI)
       rc=13
       return
       end if
c
       else if (exttyp.eq.2) then
c
c2.2  case A(p q) -> A _q(p)
c
       if (typa.eq.0) then
c
c2.2.0case A(p,q) -> B _q(p)
c
       typb=0
       call cct3_grc0 (1,typb,mapda(0,1),0,0,0,ssb,
     & possb0,posst,mapdb,mapib)
c
       do 220 ib=1,mapdb(0,5)
c
c2.2.0.*      def symmetry of all indices
       symp=mapdb(ib,3)
c
c2.2.0.*      find porper A
       ia=mapia(symp,1,1)
c
c2.2.0.*      def possitions of A and B
       possa=mapda(ia,1)
       possb=mapdb(ib,1)
c
c2.2.0.*      def dimensions
       dimp=dimm(mapda(0,1),mapda(ia,3))
       dimq=dimm(mapda(0,2),mapda(ia,4))
c
c2.2.0.*      realize extraction
       call exth2 (wrk(possa),wrk(possb),dimp,dimq,u,1)
c
 220    continue
c
c
       else
c     RC=14  : nindA=2, exttyp=2, typa is not 0 (NCI)
       rc=14
       return
       end if
c
       else
c     RC=15  : nindA=2, exttyp is not 1,2 (Stup)
       rc=15
       return
c
       end if
c
       else
c     RC=16  nindA is not 2 or 4 (NCI)
       rc=16
       return
c
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(x)
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Conj_Grad(Done,lVector,Prec,X,XTemp,R,RTemp,P,PTemp,Z,ZTemp,AP,Tolerance,res)
!***********************************************************************
!
! Purpose: Takes one step in a PCG algorithm. The preconditioner has
!          to be diagonal at the moment.
!
! Algorithm: (Ref: Kolla upp referensen)
!
! Initial values:         suggestions to make it work:
! x1 = x1                 x1 = 0
! r1 = b-A*x_1            r1 = b
! p1 = p1                 p1 = r1
! z1 = (A_pre)^-1 * r1    z1 = (diag(A))^-1 * r1
!
! CG-iterations
! alfa  = (r_k * z_k) / (p_k * [A * p_k])
! x_k+1 = x_k + alfa * p_k
! r_k+1 =  r_k - alfa * [A * p_k]
! beta  = (r_k+1 * z_k+1) / (r_k * z_k)
! p_k+1 =  z_k+1 + Beta * p_k
!
! Apart from a check for convergence, that is all of it.
!
!***********************************************************************
!
! Parameters:
!
! Done:      A logical parameter that decides if there is convergence
!
! X:         A vector with a value for x_k which will be overwritten
!            with x_k+1.
!
! Xtemp:     A temporary scratch vector which will be used to replace X.
!            If its defined outside the routine a lot of allocating and
!            deallocating is avoided.
!
! R:         A vector with a value for r_k which will be overwritten
!            with r_k+1.
!
! Xtemp:     A temporary scratch vector which will be used to replace R.
!
! P:         A vector with a value for p_k which will be overwritten
!            with p_k+1.
!
! Ptemp:     A temporary scratch vector which will be used to replace P.
!
! lVector:   The vectorial dimension of the problem.
!            A is assumed to be a square matrix.
!
! Prec:      A diagonal preconditioner.
!
! AP:        A vector containing the product of A and P.
!            The reason for not specifying A is that the dimension may
!            be too big to keep in the workspace.
!
! Res:       Returns the norm of the residual. Can be useful for the
!            user to make a judgement call if the procedure does not
!            converge below the tolerance.
!
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: Done
integer(kind=iwp) :: lVector
real(kind=wp) :: AP(lVector), P(lVector), Prec(lVector), PTemp(lVector), R(lVector), res, RTemp(lVector), Tolerance, X(lVector), &
                 XTemp(lVector), Z(lVector), ZTemp(lVector)
real(kind=wp) :: Alfa, Beta
real(kind=wp), external :: ddot_

! Copy the vectors into the temporary ones. ipXTemp, ipRTemp etc. will
! then contain x_k, r_k etc.
XTemp(:) = X(:)
RTemp(:) = R(:)
PTemp(:) = P(:)
ZTemp(:) = Z(:)

! Now we calculate Alfa = (r_k * z_k) / (p_k * [A * p_k])
Alfa = ddot_(lVector,RTemp,1,ZTemp,1)/ddot_(lVector,PTemp,1,AP,1)

! Now we calculate x_k+1 = x_k + alfa * p_k

X(:) = X(:)+Alfa*PTemp(:)

! Now we calculate r_k+1 = r_k - alfa * [A * p_k]
R(:) = R(:)-Alfa*AP(:)

! At this point we can both see if we are done and
Res = sqrt(ddot_(lVector,R,1,R,1))
if (Res < Tolerance) then
  Done = .true.
else

  ! Now we calculate z_k+1 =
  Z(:) = R(:)*Prec(:)

  ! Now we calculate beta = (r_k+1 * z_k+1) / (r_k * z_k)
  Beta = ddot_(lVector,R,1,Z,1)/ddot_(lVector,RTemp,1,ZTemp,1)

  ! Now we calculate P_k+1
  P(:) = Z(:)+Beta*PTemp(:)

end if

end subroutine Conj_Grad

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine TwoDns(ianga,iCmp,shijij,ishll,ishell,iAO,
     &           nop,iBasi,jBasj,kBask,lBasl,
     &           Aux,nAux,Work2,nWork2,Work3,nWork3,work4,
     &           nWork4,PSO,nPSO,Fact)
*
      use Basis_Info
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "disp.fh"
#include "disp2.fh"
      Logical Shijij
      Integer nOp(4),iAnga(4),iCmp(4),iShell(4),iShll(4),iAO(4)
      Real*8  PSO(nPSO),Aux(nAux),Work2(nWork2),Work3(nWork3),
     &        Work4(nWork4)
*
*     Statement function
*
      nElem(i) = (i+1)*(i+2)/2
*
      nijkl=iBasi*jBasj*kBask*lBasl
      iShlla = iShll(1)
      jShllb = iShll(2)
      kShllc = iShll(3)
      lShlld = iShll(4)
      la=iAnga(1)
      lb=iAnga(2)
      lc=iAnga(3)
      ld=iAnga(4)
      iCmpa = iCmp(1)
      jCmpb = iCmp(2)
      kCmpc = iCmp(3)
      lCmpd = iCmp(4)
      mab = nElem(la)*nElem(lb)
      mcd = nElem(lc)*nElem(ld)

*
*----------------------------------------------------------------*
*
*              Fix the second order density matrix
*
*----------------------------------------------------------------*
*
*--------------Desymmetrize the second order density matrix
*
*--------------(faA fbR(B) | fcT(C) fdTS(D))ijkl
*     PSO->Work2
*
               Call DesymP(iAnga,iCmp(1),iCmp(2),
     &                     iCmp(3),iCmp(4),
     &                     Shijij,iShll,iShell,iAO,nOp,nijkl,
     &                     Aux,nAux,Work2,PSO,nPSO)
*
*
               If (Fact.ne.One) Call DScal_(nijkl*
     &             iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4),
     &             Fact,Work2,1)
*
*--------------Backtransform 2nd order density matrix from spherical
*              harmonic gaussians to cartesian gaussians.
*
               ijklab = nijkl * iCmp(1)*iCmp(2)
*  Work2->Work2  (Work3:Scratch)
               Call SphCr1(Work2,ijklab,
     &                     Work3,nWork3,
     &                     RSph(ipSph(lc)),nElem(lc),kCmpc,
     &                     Shells(kShllc)%Transf,
     &                     Shells(kShllc)%Prjct,
     &                     RSph(ipSph(ld)),nElem(ld),lCmpd,
     &                     Shells(lShlld)%Transf,
     &                     Shells(lShlld)%Prjct,
     &                     Work2,mcd)
*  Work2->Work4  (Work3:Scratch)
               Call SphCr2(Work2,nijkl,mcd,
     &                     Work3,nWork3,
     &                     RSph(ipSph(la)),nElem(la),iCmpa,
     &                     Shells(iShlla)%Transf,
     &                     Shells(iShlla)%Prjct,
     &                     RSph(ipSph(lb)),nElem(lb),jCmpb,
     &                     Shells(jShllb)%Transf,
     &                     Shells(jShllb)%Prjct,
     &                     Work4,mab)
*
*----------------------------------------------------------------*
*
*   P is now in cartisan AO base
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PRORB(CNO,OCC)

use mrci_global, only: BNAME, NBAS, NBAST, NCMO, NSYM, THRORB
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: CNO(NCMO), OCC(NBAST)
#include "Molcas.fh"
integer(kind=iwp) :: I, IEB, IEM, IEND, IST, ISYM, J, JEMO, JSMO, NB, NDIV, NPRT
character(len=LenIn8), external :: CLEAN_BNAME

write(u6,*)
write(u6,*) 'NATURAL ORBITALS IN AO BASIS. IN EACH SYMMETRY,'
write(u6,*) 'THE ORBITALS PRINTED ARE THOSE UP TO AND INCLUDING'
write(u6,*) 'THE LAST ORBITAL WITH OCCUPATION NUMBER LARGER'
write(u6,'(A,F10.7)') ' THAN THRORB = ',THRORB
IEB = 0
IEM = 0
NDIV = 10
do ISYM=1,NSYM
  NB = NBAS(ISYM)
  if (NB == 0) cycle
  NPRT = 0
  do I=1,NB
    if (OCC(IEB+I) >= THRORB) NPRT = I
  end do
  if (NPRT /= 0) then
    write(u6,'(/28X,''SYMMETRY LABEL'',I3)') ISYM
    do IST=1,NPRT,NDIV
      IEND = min(NPRT,IST-1+NDIV)
      write(u6,'(/5X,''ORBITAL'',6X,10I8)') (I,I=IST,IEND)
      write(u6,'( 5X,''OCC.NO.'',8X,10F8.5)') (OCC(IEB+I),I=IST,IEND)
      write(u6,*)
      do I=1,NB
        JSMO = IEM+I+NB*(IST-1)
        JEMO = IEM+I+NB*(IEND-1)
        write(u6,'(1X,I3,2X,A,10F8.4)') I,CLEAN_BNAME(BNAME(IEB+I),LenIn),(CNO(J),J=JSMO,JEMO,NB)
      end do
    end do
  end if
  IEB = IEB+NB
  IEM = IEM+NB*NB
end do

return

end subroutine PRORB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_RSTOF(IRS2F,N,LRDIM,IRED)
      use ChoArr, only: iSOShl, iShlSO, nBstSh
C
C     Purpose: set up mapping between reduced set and SO indices
C              (i.e., full storage).
C
C     IRS2F(1,irs) = alpha (SO index, not symmmetry reduced)
C     IRS2F(2,irs) = beta  (SO index, not symmmetry reduced)
C
#include "implicit.fh"
      INTEGER IRS2F(N,LRDIM)
#include "cholesky.fh"
#include "choorb.fh"

      CHARACTER*9 SECNAM
      PARAMETER (SECNAM = 'CHO_RSTOF')

      INTEGER  CHO_RS2F
      EXTERNAL CHO_RS2F
      INTEGER  CHO_F2SP
      EXTERNAL CHO_F2SP

      MULD2H(I,J)=IEOR(I-1,J-1)+1
      ITRI(I,J) = MAX(I,J)*(MAX(I,J)-3)/2 + I + J

      IF (N .LT. 2) THEN
         CALL CHO_QUIT('Dimension error [1] in '//SECNAM,104)
      END IF
      IF (LRDIM .NE. MMBSTRT) THEN
         CALL CHO_QUIT('Dimension error [2] in '//SECNAM,104)
      END IF
      CALL IZERO(IRS2F,N*MMBSTRT)

      DO ISYMA = 1,NSYM
         IF (NBAS(ISYMA) .GT. 0) THEN
            DO ISYMB = 1,ISYMA-1
               ISYMAB = MULD2H(ISYMA,ISYMB)
               DO KB = 1,NBAS(ISYMB)
                  IB = IBAS(ISYMB) + KB
                  LB = ISHLSO(IB)
                  ISHLB = ISOSHL(IB)
                  DO KA = 1,NBAS(ISYMA)
                     IA = IBAS(ISYMA) + KA
                     LA = ISHLSO(IA)
                     ISHLA  = ISOSHL(IA)
                     IF (ISHLA .LT. ISHLB) THEN
                        LAB = NBSTSH(ISHLB)*(LA - 1) + LB
                     ELSE IF (ISHLA .EQ. ISHLB) THEN
                        LAB = ITRI(LA,LB)
                     ELSE
                        LAB = NBSTSH(ISHLA)*(LB - 1) + LA
                     END IF
                     ISHLAB = CHO_F2SP(ITRI(ISHLA,ISHLB))
                     IF (ISHLAB .GT. 0) THEN
                        IRS = CHO_RS2F(LAB,ISHLAB,ISYMAB,IRED)
                        IF (IRS .GT. 0) THEN
                           IRS2F(1,IRS) = IA
                           IRS2F(2,IRS) = IB
                        END IF
                     END IF
                  END DO
               END DO
            END DO
            ISYMB  = ISYMA
            ISYMAB = 1
            DO KA = 1,NBAS(ISYMA)
               IA = IBAS(ISYMA) + KA
               LA = ISHLSO(IA)
               ISHLA  = ISOSHL(IA)
               DO KB = 1,KA
                  IB = IBAS(ISYMB) + KB
                  LB = ISHLSO(IB)
                  ISHLB = ISOSHL(IB)
                  IF (ISHLA .LT. ISHLB) THEN
                     LAB = NBSTSH(ISHLB)*(LA - 1) + LB
                  ELSE IF (ISHLA .EQ. ISHLB) THEN
                     LAB = ITRI(LA,LB)
                  ELSE
                     LAB = NBSTSH(ISHLA)*(LB - 1) + LA
                  END IF
                  ISHLAB = CHO_F2SP(ITRI(ISHLA,ISHLB))
                  IF (ISHLAB .GT. 0) THEN
                     IRS = CHO_RS2F(LAB,ISHLAB,ISYMAB,IRED)
                     IF (IRS .GT. 0) THEN
                        IRS2F(1,IRS) = IA
                        IRS2F(2,IRS) = IB
                     END IF
                  END IF
               END DO
            END DO
         END IF
      END DO

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine intchk_cvb(iarr,nmax,nread,ifc,a,lflag)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: iarr(*), lflag
integer(kind=iwp), intent(in) :: nmax, ifc
integer(kind=iwp), intent(out) :: nread
character(len=*), intent(in) :: a
integer(kind=iwp) :: i, ifrom, istr, ito(1), lf, ncnt, nr
integer(kind=iwp), parameter :: ncmp = 4, nkeyw = 3
character(len=*), parameter :: keyword(nkeyw) = ['NONE    ','ALL     ','TO      ']

nread = 0
lf = lflag
do
  call fstring_cvb(keyword,nkeyw,istr,ncmp,1)
  if (istr > 0) lf = lflag
  if (istr == 1) then
    ! 'NONE'
    nread = 0
  else if (istr == 2) then
    ! 'ALL'
    if (lflag == -1) then
      nread = nmax
      do i=1,nmax
        iarr(i) = i
      end do
    else
      nread = 0
      lf = 1-lflag
    end if
  else if (istr == 3) then
    ! 'TO'
    if (nread == nmax) then
      write(u6,'(3a)') ' Too many numbers specified in ',a,' keyword!'
      call abend_cvb()
    else if (nread == 0) then
      write(u6,'(3a)') ' No number before ',a,' -- TO keyword!'
      call abend_cvb()
    end if
    call int_cvb(ito,1,nr,ifc)
    if (nr == -1) then
      write(u6,'(3a)') ' No number after ',a,' -- TO keyword!'
      call abend_cvb()
    end if
    ifrom = iarr(nread)
    if (ifrom > ito(1)) then
      write(u6,*) ' From greater than to:',ifrom,ito(1)
      call abend_cvb()
    else if (nread+ito(1)-ifrom > nmax) then
      write(u6,'(3a)') ' Too many numbers specified in ',a,' keyword!'
      call abend_cvb()
    end if
    do i=ifrom+1,ito(1)
      nread = nread+1
      iarr(nread) = i
    end do
  else
    call int_cvb(iarr(1+nread),nmax-nread,nr,ifc)
    if (nread > 0) lf = lflag
    if (nr == -1) then
      write(u6,'(3a)') ' Too many numbers specified in ',a,' keyword!'
      call abend_cvb()
    end if
    nread = nread+nr
  end if
  if ((istr <= 0) .and. (nr <= 0)) exit
end do

if (lflag /= -1) lflag = lf

do i=1,nread
  if ((iarr(i) < 1) .or. (iarr(i) > nmax)) then
    write(u6,'(3a,i5)') ' Illegal ',a,' number read!',iarr(i)
    write(u6,'(a,i3)') ' Must be in the range 1 --',nmax
    call abend_cvb()
  end if
end do

! Sort numbers and ensure uniqueness:
call sorti_cvb(nread,iarr)
ncnt = 1
do i=2,nread
  if (iarr(i) /= iarr(ncnt)) then
    ncnt = ncnt+1
    iarr(ncnt) = iarr(i)
  end if
end do
nread = min(ncnt,nread)

return

end subroutine intchk_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_PUTRED(IPASS,IRED)
C
C     Purpose: write reduced set indices to disk and set address for
C              next write.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_PUTRED')

      IF (IPASS .GT. MAXRED) THEN
         WRITE(LUPRI,*) SECNAM,': integral pass ',IPASS
         WRITE(LUPRI,*) SECNAM,': max. allowed is ',MAXRED
         WRITE(LUPRI,*) SECNAM,': please increase max. allowed!'
         CALL CHO_QUIT('Too many integral passes in '//SECNAM,104)
      ELSE IF (IPASS .EQ. 1) THEN
         KOFF1 = ip_NNBSTRSH
         KOFF2 = ip_INDRED
         CALL CHO_PUTRED1(IWORK(ip_INFRED),IWORK(KOFF1),IWORK(KOFF2),
     &                    IWORK(ip_INDRSH),IWORK(ip_iSP2F),
     &                    MAXRED,NSYM,NNSHL,MMBSTRT,IPASS,1)
         IF (MAXRED .GT. 1) THEN
            IWORK(ip_INFRED+IPASS) = IWORK(ip_INFRED-1+IPASS)
     &                             + NSYM*NNSHL + 2*NNBSTRT(1) + NNSHL
         END IF
      ELSE IF (IPASS .EQ. MAXRED) THEN
         KOFF1 = ip_NNBSTRSH + NSYM*NNSHL*(IRED - 1)
         KOFF2 = ip_INDRED   + MMBSTRT*(IRED - 1)
         CALL CHO_PUTRED1(IWORK(ip_INFRED),IWORK(KOFF1),IWORK(KOFF2),
     &                    IWORK(ip_INDRSH),IWORK(ip_iSP2F),
     &                    MAXRED,NSYM,NNSHL,MMBSTRT,IPASS,IRED)
      ELSE
         KOFF1 = ip_NNBSTRSH + NSYM*NNSHL*(IRED - 1)
         KOFF2 = ip_INDRED   + MMBSTRT*(IRED - 1)
         CALL CHO_PUTRED1(IWORK(ip_INFRED),IWORK(KOFF1),IWORK(KOFF2),
     &                    IWORK(ip_INDRSH),IWORK(ip_iSP2F),
     &                    MAXRED,NSYM,NNSHL,MMBSTRT,IPASS,IRED)
         IWORK(ip_INFRED+IPASS) = IWORK(ip_INFRED-1+IPASS)
     &                          + NSYM*NNSHL + NNBSTRT(IRED)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SetPrLev(LF_IN,IPRGLB_IN,IPRLOC_IN)
      Implicit Real*8 (A-H,O-Z)
#include "warnings.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='SETPRLEV')
      Dimension IPRLOC_IN(7)
*
      Logical REDUCE_PRT
      External REDUCE_PRT
      Intrinsic MAX
      External GETENVF

* The local print levels are the maximum of the requested global and
* local ones, except that if any of IPRGLB or IPRLOC(I) is zero
*  (meaning silence), then IPRLOC(I) is set to zero.
      IPRGLB=IPRGLB_IN
      IF (IPRGLB_IN.EQ.0) THEN
       DO I=1,7
        IPRLOC(I)=0
       END DO
      ELSE
       DO I=1,7
        IPRLOC(I)=0
        IF(IPRLOC_IN(I).GT.0) IPRLOC(I)=MAX(IPRGLB_IN,IPRLOC_IN(I))
       END DO
      END IF
* If inside an optimization loop, set down the print
* level unless we *really* want a lot of output.
      IF (REDUCE_PRT()) THEN
       IPRGLB=MAX(IPRGLB-USUAL,SILENT)
       DO I=1,7
        IPRLOC(I)=MAX(IPRLOC(I)-USUAL,SILENT)
       END DO
      END IF

      IF (IPRLOC(1).GE.DEBUG) THEN
       WRITE(6,*)' SetPrLev: Print levels have been set to'
       write(6,*)'  Global print level IPRGLB=',IPRGLB
       write(6,*)'  Individual sections print levels, IPRLOC:'
       write(6,'(1x,7I5)')(IPRLOC(I),I=1,7)
      END IF

      RETURN
c Avoid unused argument warnings
#ifdef _WARNING_WORKAROUND_
      IF (.FALSE.) CALL Unused_integer(LF_IN)
#endif
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!                                                                      C
!  THIS ROUTINE PERFORMS A SPLINE FIT TO A SET OF POINTS (XFIT,YFIT).  C
!  IT INTERPOLATES A SET OF POINTS (XINT,YINT), AND LOCATES ALL        C
!  EXTREME VALUES (XEXT,YEXT) AND DETERMINES THE TYPE (IEXT).          C
!  VARIOUS TYPES OF BOUNDARY CONDITIONS CAN BE CHOOSEN (IBOUND),       C
!  AT PRESENT IBOUND=1 AND 2 ARE IMPLEMENTED.                          C
!                                                                      C
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

!IFG IBOUND=2 implemented, but never used or tested, so disabling it
#undef _IBOUND2_

subroutine SPLINE(XFIT,YFIT,NFIT,XINT,YINT,NIN,XEXT,YEXT,IEXT,NEXT,IBOUND)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three
use Definitions, only: wp, iwp, u6

implicit none
! NFIT, NIN ARE INPUT ONLY
integer(kind=iwp), intent(in) :: NFIT, NIN, IBOUND
! NEXT IS INPUT (DIMENSION BOUND) AND OUTPUT (NR OF EXTREMA).
integer(kind=iwp), intent(inout) :: NEXT
real(kind=wp), intent(in) :: XFIT(NFIT), YFIT(NFIT), XINT(NIN)
real(kind=wp), intent(out) :: YINT(NIN), XEXT(NEXT), YEXT(NEXT)
integer(kind=iwp), intent(out) :: IEXT(NEXT)
real(kind=wp) :: VSUM, T0(2), A0, A1, A2, B0, B1, P, Q, S, SE, T, T1, X, Y
real(kind=wp), allocatable :: MatA(:,:), VecB(:), VecC(:), VecD(:), VecH(:)
integer(kind=iwp) :: NOS, NS, I, J, IT, IP
#ifdef _IBOUND2_
real(kind=wp) :: C0, C1, C2, S1, S2
#endif

NOS = NFIT-1
call mma_allocate(MatA,NFIT,NFIT,label='MatA')
call mma_allocate(VecB,NFIT,label='VecB')
call mma_allocate(VecC,NFIT,label='VecC')
call mma_allocate(VecD,NOS,label='VecD')
call mma_allocate(VecH,NOS,label='VecH')
MatA(:,:) = Zero
do I=1,NOS
  VecH(I) = XFIT(I+1)-XFIT(I)
  VecD(I) = (YFIT(I+1)-YFIT(I))/VecH(I)
end do
select case (IBOUND)
  case (1)
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    !                                                                  C
    !  IBOUND=1:                                                       C
    !  BOTH END POINTS ARE EXTRAPOLATED WITH STRAIGHT LINES.           C
    !                                                                  C
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    MatA(1,1) = Two*VecH(1)
    MatA(1,2) = VecH(1)
    VecB(1) = Three*VecH(1)*VecD(1)
    MatA(NFIT,NFIT-1) = VecH(NOS)
    MatA(NFIT,NFIT) = Two*VecH(NOS)
    VecB(NFIT) = Three*VecH(NOS)*VecD(NOS)
    do I=2,NOS
      MatA(I,I-1) = VecH(I)
      MatA(I,I) = Two*(VecH(I)+VecH(I-1))
      MatA(I,I+1) = VecH(I-1)
      VecB(I) = Three*(VecH(I-1)*VecD(I)+VecH(I)*VecD(I-1))
    end do
    call dminv(NFIT,NFIT,MatA)
    do I=1,NFIT
      VSUM = Zero
      do J=1,NFIT
        VSUM = VSUM+MatA(I,J)*VecB(J)
      end do
      VecC(I) = VSUM
    end do
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    !                                                                  C
    !  PERFORM INTERPOLATION (EXTRAPOLATION).                          C
    !                                                                  C
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    do IP=1,NIN
      if (XINT(IP) < XFIT(1)) then
        YINT(IP) = YFIT(1)+VecC(1)*(XINT(IP)-XFIT(1))
      else if (XINT(IP) > XFIT(NFIT)) then
        YINT(IP) = YFIT(NFIT)+VecC(NFIT)*(XINT(IP)-XFIT(NFIT))
      else
        NS = 1
        do while (XINT(IP) > XFIT(NS+1))
          NS = NS+1
        end do
        T = (XINT(IP)-XFIT(NS))/VecH(NS)
        T1 = One-T
        YINT(IP) = T*YFIT(NS+1)+T1*YFIT(NS)+VecH(NS)*T*T1*(T1*(VecC(NS)-VecD(NS))-T*(VecC(NS+1)-VecD(NS)))
      end if
    end do
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    !                                                                  C
    !  LOCATE ALL EXTREMUM POINTS.                                     C
    !                                                                  C
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    NEXT = 0
    do NS=1,NOS
      A2 = Three*(VecC(NS)+VecC(NS+1)-Two*VecD(NS))
      A1 = Two*(Three*VecD(NS)-Two*VecC(NS)-VecC(NS+1))
      A0 = VecC(NS)
      B1 = Two*A2
      B0 = A1
      if (abs(A2) > (abs(A1)+abs(A0))*1.0e-3_wp) then
        !***** A2 LARGE *****
        P = -A1/A2/Two
        Q = A0/A2
        S = P*P-Q
        if (abs(S) < 1.0e-10_wp) then
          !***** DOUBLE ROOT *****
          IT = 2
          T = P
          if ((T >= Zero) .and. (T <= One)) then
            X = XFIT(NS)+T*VecH(NS)
            Y = YFIT(NS)+VecH(NS)*T*(A0+T*(A1/Two+T*A2/Three))
            !write(u6,2001) TEXT(IT),X,Y
            NEXT = NEXT+1
            XEXT(NEXT) = X
            YEXT(NEXT) = Y
            IEXT(NEXT) = IT
          end if
        else if (S > Zero) then
          !***** TWO ROOTS *****
          T0(1) = P+sqrt(S)
          T0(2) = P-sqrt(S)
          do I=1,2
            T = T0(I)
            if ((T >= Zero) .and. (T <= One)) then
              SE = B0+T*B1
              X = XFIT(NS)+T*VecH(NS)
              Y = YFIT(NS)+VecH(NS)*T*(A0+T*(A1/Two+T*A2/Three))
              IT = 1
              if (SE > Zero) IT = 3
              !write(u6,2001) TEXT(IT),X,Y
              NEXT = NEXT+1
              XEXT(NEXT) = X
              YEXT(NEXT) = Y
              IEXT(NEXT) = IT
            end if
          end do
        end if
      else if (abs(A1) >= 0.9_wp*abs(A0)) then
        !***** A2 SMALL *****
        T = -A0/A1
        T = -(A0+A2*T*T)/A1
        T = -(A0+A2*T*T)/A1
        T = -(A0+A2*T*T)/A1
        if ((T >= Zero) .and. (T <= One)) then
          IT = 1
          if (B0 > Zero) IT = 3
          X = XFIT(NS)+T*VecH(NS)
          Y = YFIT(NS)+VecH(NS)*T*(A0+T*(A1/Two+T*A2/Three))
          !write(u6,2001) TEXT(IT),X,Y
          NEXT = NEXT+1
          XEXT(NEXT) = X
          YEXT(NEXT) = Y
          IEXT(NEXT) = IT
        end if
      end if
    end do

# ifdef _IBOUND2_
  case (2)
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    !                                                                  C
    !  IBOUND=2:                                                       C
    !  EXTRAPOLATION TO PLUS INFINITY IS DONE WITH A STRAIGHT          C
    !  HORIZONTAL LINE.                                                C
    !                                                                  C
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    MatA(NFIT,NFIT) = ONe
    VecB(NFIT) = Zero
    MatA(NOS,NOS) = Two
    MatA(NOS,NFIT) = One
    VecB(NOS) = Three*VecD(NOS)
    do I=2,NOS
      MatA(I-1,I-1) = VecH(I)
      MatA(I-1,I) = Two*(VecH(I)+VecH(I-1))
      MatA(I-1,I+1) = VecH(I-1)
      VecB(I-1) = Three*(VecH(I-1)*VecD(I)+VecH(I)*VecD(I-1))
    end do
    call dminv(NFIT,NFIT,MatA)
    do I=1,NFIT
      VSUM = Zero
      do J=1,NFIT
        VSUM = VSUM+MatA(I,J)*VecB(J)
      end do
      VecC(I) = VSUM
    end do
    S1 = VecC(1)
    S2 = (VecC(1)+Two*VecC(2)-Three*VecD(1))/VecH(1)
    C2 = -S2/S1
    C1 = S2/C2/C2/exp(-C2*XFIT(1))
    C0 = YFIT(1)-C1*exp(-C2*XFIT(1))
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    !                                                                  C
    !  PERFORM INTERPOLATION (EXTRAPOLATION).                          C
    !                                                                  C
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    do IP=1,NIN
      if (XINT(IP) < XFIT(1)) then
        YINT(IP) = C0+C1*exp(-C2*XINT(IP))
      else if (XINT(IP) > XFIT(NFIT)) then
        YINT(IP) = YFIT(NFIT)+VecC(NFIT)*(XINT(IP)-XFIT(NFIT))
      else
        NS = 1
        do while (XINT(IP) > XFIT(NS+1))
          NS = NS+1
        end do
        T = (XINT(IP)-XFIT(NS))/VecH(NS)
        T1 = One-T
        YINT(IP) = T*YFIT(NS+1)+T1*YFIT(NS)+VecH(NS)*T*T1*(T1*(VecC(NS)-VecD(NS))-T*(VecC(NS+1)-VecD(NS)))
      end if
    end do
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    !                                                                  C
    !  LOCATE ALL EXTREMUM POINTS.                                     C
    !                                                                  C
    !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    NEXT = 0
    do NS=1,NOS
      A2 = Three*(VecC(NS)+VecC(NS+1)-Two*VecD(NS))
      A1 = Two*(Three*VecD(NS)-Two*VecC(NS)-VecC(NS+1))
      A0 = VecC(NS)
      B1 = Two*A2
      B0 = A1
      if (abs(A2) > (abs(A1)+abs(A0))*1.0e-3_wp) then
        !***** A2 LARGE *****
        P = -A1/A2/Two
        Q = A0/A2
        S = P*P-Q
        if (abs(S) < 1.0e-10_wp) then
          !***** DOUBLE ROOT *****
          IT = 2
          T = P
          if ((T >= Zero) .and. (T <= One)) then
            X = XFIT(NS)+T*VecH(NS)
            Y = YFIT(NS)+VecH(NS)*T*(A0+T*(A1/Two+T*A2/Three))
            !write(u6,2001) TEXT(IT),X,Y
            NEXT = NEXT+1
            XEXT(NEXT) = X
            YEXT(NEXT) = Y
            IEXT(NEXT) = IT
          end if
        else if (S > Zero) then
          !***** TWO ROOTS *****
          T0(1) = P+sqrt(S)
          T0(2) = P-sqrt(S)
          do I=1,2
            T = T0(I)
            if ((T >= Zero) .and. (T <= One)) then
              SE = B0+T*B1
              X = XFIT(NS)+T*VecH(NS)
              Y = YFIT(NS)+VecH(NS)*T*(A0+T*(A1/Two+T*A2/Three))
              IT = 1
              if (SE > Zero) IT = 3
              !write(u6,2001) TEXT(IT),X,Y
              NEXT = NEXT+1
              XEXT(NEXT) = X
              YEXT(NEXT) = Y
              IEXT(NEXT) = IT
            end if
          end do
        end if
      else if (abs(A1) >= 0.9_wp*abs(A0)) then
        !***** A2 SMALL *****
        T = -A0/A1
        T = -(A0+A2*T*T)/A1
        T = -(A0+A2*T*T)/A1
        T = -(A0+A2*T*T)/A1
        if ((T >= Zero) .and. (T <= One)) then
          IT = 1
          if (B0 > Zero) IT = 3
          X = XFIT(NS)+T*VecH(NS)
          Y = YFIT(NS)+VecH(NS)*T*(A0+T*(A1/Two+T*A2/Three))
          !write(u6,2001) TEXT(IT),X,Y
          NEXT = NEXT+1
          XEXT(NEXT) = X
          YEXT(NEXT) = Y
          IEXT(NEXT) = IT
        end if
      end if
    end do
# endif

  case default
    write(u6,*) 'SPLINE Error: IBOUND should be 1 or 2.'
    write(u6,'(1x,a,2i8)') 'But IBOUND=',IBOUND
    call Abend()
end select

call mma_deallocate(MatA)
call mma_deallocate(VecB)
call mma_deallocate(VecC)
call mma_deallocate(VecD)
call mma_deallocate(VecH)

return

!2001 format(1x,a,'  X=',E12.5,' ,  Y=',E12.5)

end subroutine SPLINE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
          Subroutine Find_Basis_Set(DirName,ExtBasDir,type)
************************************************************************
* Object: make a guess for a file                                      *
* Author: Valera Veryazov, Theoretical Chemistry, Chemical Centre      *
*         University of Lund, Lund, Sweden                             *
************************************************************************

          Character*(*) DirName,ExtBasDir,type
          Character*512 tmp
          character Molcas*256, CurrDir*256
          integer iNeedExtra
          integer iAbsName
          logical Exist
          iNeedExtra=0
          if(ExtBasDir.ne.' ') then
             iNeedExtra=1
             i=index(ExtBasDir,' ')
             iAbsName=0
             if(ExtBasDir(1:1).ne.'/') then
              iAbsName=1
              CurrDir=' '
              call getenvf('CurrDir',CurrDir)
             endif
             if(iAbsName.eq.0) then
             tmp=ExtBasDir(1:i-1)//'/'//type
             else
             tmp=CurrDir(1:index(CurrDir,' ')-1)//
     &             '/'//ExtBasDir(1:i-1)//'/'//type
             endif
c             print *,tmp
          Call f_Inquire(tmp,Exist)
          if (Exist) then
             if(iAbsName.eq.0) then
             tmp=ExtBasDir(1:i-1)
             else
             tmp=CurrDir(1:index(CurrDir,' ')-1)//
     &             '/'//ExtBasDir(1:i-1)
             endif
             i=index(tmp,' ')
             DirName=tmp(1:i-1)
c          Print *,'>',DirName(1:i-1),'<'
             return
          endif
          endif
          if(DirName(1:13).ne.'basis_library') return

          Molcas=' '
          call getenvf('MOLCAS_BASIS',Molcas)
          If (Molcas.eq.' ') Then
             call getenvf('MOLCAS',Molcas)
             i=index(Molcas,' ')
             DirName=Molcas(1:i-1)//'/basis_library'
          Else
             i=index(Molcas,' ')
             DirName=Molcas(1:i-1)
          End If
          i=index(DirName,' ')
          if(i.eq.0) then
             Call WarningMessage(2,'Too long path to Molcas')
             Call Abend()
          endif
          Return
          End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************

function DCLEBS(XJ1,XJ2,XJ3,XM1,XM2,XM3)
! DCLEBS: real Clebsch-Gordan coefficients
! From a modification of Racah''s formula. Coded: Malmqvist 1998
! Note carefully: The input values XJ1..XM3 are REAL, not integers. Half-integer spins are allowed
! Half-integers are assumed exactly represented

use Definitions, only: wp, iwp
use Constants, only: Zero, One

implicit none
real(kind=wp) :: DCLEBS
real(kind=wp), intent(in) :: XJ1,XJ2,XJ3,XM1,XM2,XM3
integer, parameter :: MAXJ=10, MAXF=3*MAXJ+1
integer(kind=iwp), save :: icall = 0
real(kind=wp), save :: DFACT(0:MAXF)
real(kind=wp) :: DF, den, PRE, PRE2, SUMMA, TERM, XJSUM
integer(kind=iwp) :: i, IA1, IA2, IA3, IB1, IB2, IB3, IX, IX1, IX2, IY, IY0, JSUM

if (icall == 0) then
  icall = icall+1
  DF = One
  DFACT(0) = DF
  do i=1,MAXF
    DF = DBLE(i)*DF
    DFACT(i) = DF
  end do
end if

DCLEBS = Zero

XJSUM = XJ1+XJ2+XJ3
JSUM = NINT(XJSUM)
if (XJSUM /= DBLE(JSUM)) return
if (XM1+XM2 /= XM3) return

IA1 = nint(XJ1+XM1)
if (IA1 < 0) return
IB1 = nint(XJ1-XM1)
if (IB1 < 0) return
IA2 = nint(XJ2+XM2)
if (IA2 < 0) return
IB2 = nint(XJ2-XM2)
if (IB2 < 0) return
IA3 = nint(XJ3-XM3)
if (IA3 < 0) return
IB3 = nint(XJ3+XM3)
if (IB3 < 0) return
if (JSUM-IA1-IB1 < 0) return
if (JSUM-IA2-IB2 < 0) return
if (JSUM-IA3-IB3 < 0) return

PRE2 = real(1+IA3+IB3)*DFACT(JSUM-IA1-IB1) &
       *DFACT(JSUM-IA2-IB2)*DFACT(JSUM-IA3-IB3) &
       *DFACT(IA1)*DFACT(IA2)*DFACT(IA3) &
       *DFACT(IB1)*DFACT(IB2)*DFACT(IB3) &
       /DFACT(JSUM+1)
PRE = sqrt(PRE2)

IY0 = (JSUM-IA3-IB3)
IX1 = (IA2+IB1-JSUM)+IB2
IX2 = (IA2+IB1-JSUM)+IA1
IX = MAX(0,IX1,IX2)
IY = MIN(IY0,IB1,IA2)

SUMMA = Zero
do I=IX,IY
  DEN = DFACT(I)*DFACT(I-IX1)*DFACT(I-IX2)*DFACT(IY0-I)*DFACT(IB1-I)*DFACT(IA2-I)
  TERM = One/DEN
  SUMMA = SUMMA+real((-1)**I)*TERM
end do

DCLEBS = PRE*SUMMA

end function DCLEBS

!u**********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Per Ake Malmqvist                                *
!               2021, Yoshio Nishimoto                                 *
!***********************************************************************
!--------------------------------------------*
! 2006  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine DERSPE(NLEV,NG3,DF1,DF2,DF3,idxG3,DEPSA,G1,G2,G3)
! SPECIAL-CASE ROUTINE. DELIVERS G AND F MATRICES FOR A HIGH-SPIN
! OR CLOSED-SHELL SCF CASE.

use Task_Manager, only: Free_Tsk, Init_Tsk, Rsv_Tsk
use sguga, only: LEVEL
use caspt2_module, only: ISCF, NACTEL
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, byte, u6

implicit none
integer(kind=iwp), intent(in) :: NLEV, NG3
real(kind=wp), intent(in) :: DF1(NLEV,NLEV), DF2(NLEV,NLEV,NLEV,NLEV), DF3(NG3), G1(NLEV,NLEV), G2(NLEV,NLEV,NLEV,NLEV), G3(NG3)
integer(kind=byte), intent(inout) :: idxG3(6,NG3)
real(kind=wp), intent(inout) :: DEPSA(NLEV,NLEV)
integer(kind=iwp) :: ID, iG3, IND1, IND2, IND3, IT, IT1, IT2, IT3, iTask, IU, IU1, IU2, IU3, IV, LT, LU, LU1, LU2, LU3, LV, NLEV2, &
                     NLEV4, nTask
real(kind=wp) :: DESUM, OCC

!ESUM = sum(ETA(1:NLEV))
DESUM = Zero
! ISCF=1 for closed-shell, =2 for hispin
OCC = Two
if (ISCF == 2) OCC = One

!if ((NACTEL == 1) .or. (NACTEL == 2)) NG3 = 0
if (NACTEL /= 1) then
  if (NACTEL /= 2) then
    write(u6,*) 'I have not implemented for non-standard Psi0, when A and C subspaces contribute to the energy, in particular'
    write(u6,*) 'I cannot debug, because I do not know when it happens'
    !call abend()

    NLEV2 = NLEV**2
    NLEV4 = NLEV**4

    iG3 = 0
    nTask = NLEV4
    ! SVC20100908 initialize the series of tasks
    call Init_Tsk(ID,nTask)

    do
#     ifdef _MOLCAS_MPP_
      if ((NG3-iG3) < NLEV2) exit
#     endif
      if (.not. Rsv_Tsk(ID,iTask)) exit

      IND1 = mod(iTask-1,NLEV2)+1
      IND2 = ((iTask-IND1)/(NLEV2))+1
      if (IND2 > IND1) cycle

      IT1 = mod(IND1-1,NLEV)+1
      IU1 = (IND1-IT1)/NLEV+1
      LU1 = LEVEL(IU1)
      IT2 = mod(IND2-1,NLEV)+1
      IU2 = (IND2-IT2)/NLEV+1
      LU2 = LEVEL(IU2)

      do IT3=1,NLEV
        do IU3=1,NLEV
          IND3 = IT3+NLEV*(IU3-1)
          if (IND3 > IND2) cycle
          LU3 = LEVEL(IU3)
          !VAL = G1(IT1,IU1)*G1(IT2,IU2)*G1(IT3,IU3)

          ! Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
          ! Add here the necessary Kronecker deltas times 2-body matrix
          ! elements and lower, so we get a true normal-ordered density matrix
          ! element.

          ! <PSI1|E(T1,U1,T2,U2,T3,U3)|PSI2>
          ! = <PSI1|E(T1,U1)E(T2,U2)E(T3,U3)|PSI2>
          ! -D(T3,U2)*(G2(T1,U1,T2,U3)+D(T2,U1)*G1(T1,U3))
          ! -D(T2,U1)*G2(T1,U2,T3,U3)
          ! -D(T3,U1)*G2(T2,U2,T1,U3)

          !if (IT3 == IU2) then
          !  VAL = VAL-G2(IT1,IU1,IT2,IU3)
          !  if (IT2 == IU1) VAL = VAL-G1(IT1,IU3)
          !end if
          !if (IT2 == IU1) VAL = VAL-G2(IT1,IU2,IT3,IU3)
          !if (IT3 == IU1) VAL = VAL-G2(IT2,IU2,IT1,IU3)

          ! VAL is now =<PSI1|E(IT1,IU1,IT2,IU2,IT3,IU3)|PSI2>
          iG3 = iG3+1
          idxG3(1,iG3) = int(iT1,kind=byte)
          idxG3(2,iG3) = int(iU1,kind=byte)
          idxG3(3,iG3) = int(iT2,kind=byte)
          idxG3(4,iG3) = int(iU2,kind=byte)
          idxG3(5,iG3) = int(iT3,kind=byte)
          idxG3(6,iG3) = int(iU3,kind=byte)
          !G3(iG3) = VAL
          !F3(iG3) = (ESUM*OCC-ETA(LU1)-ETA(LU2)-ETA(LU3))*VAL
          DESUM = DESUM+OCC*G3(iG3)*DF3(iG3)
          DEPSA(LU1,LU1) = DEPSA(LU1,LU1)-OCC*G3(iG3)*DF3(iG3)
          DEPSA(LU2,LU2) = DEPSA(LU2,LU2)-OCC*G3(iG3)*DF3(iG3)
          DEPSA(LU3,LU3) = DEPSA(LU3,LU3)-OCC*G3(iG3)*DF3(iG3)
        end do
      end do

      !SVC: The master node now continues to only handle task scheduling,
      !     needed to achieve better load balancing. So it exits from the task
      !     list.  It has to do it here since each process gets at least one
      !     task.
    end do

    ! SVC2010: no more tasks, wait here for the others.
    call Free_Tsk(ID)
  end if
  do IT=1,NLEV
    LT = LEVEL(IT)
    do IU=1,NLEV
      LU = LEVEL(IU)
      !G2(IT,IT,IU,IU) = G1(IT,IT)*G1(IU,IU)
      !if (IU == IT) then
      ! G2(IT,IT,IU,IU) = G2(IT,IT,IU,IU)-G1(IT,IU)
      !else
      ! G2(IT,IU,IU,IT) = -G1(IT,IT)
      !end if
      !F2(IT,IT,IU,IU) = (ESUM*OCC-ETA(LT)-ETA(LU))*G2(IT,IT,IU,IU)
      !F2(IT,IU,IU,IT) = (ESUM*OCC-ETA(LT)-ETA(LU))*G2(IT,IU,IU,IT)
      DESUM = DESUM+OCC*G2(IT,IT,IU,IU)*DF2(IT,IT,IU,IU)
      DESUM = DESUM+OCC*G2(IT,IU,IU,IT)*DF2(IT,IU,IU,IT)
      do IV=1,NLEV
        LV = LEVEL(IV)
        DEPSA(LT,LV) = DEPSA(LT,LV)-OCC*G2(IT,IT,IU,IU)*DF2(IT,IV,IU,IU)
        DEPSA(LU,LV) = DEPSA(LU,LV)-OCC*G2(IT,IT,IU,IU)*DF2(IT,IT,IU,IV)
        DEPSA(LT,LV) = DEPSA(LT,LV)-OCC*G2(IT,IU,IU,IT)*DF2(IT,IU,IU,IV)
        DEPSA(LU,LV) = DEPSA(LU,LV)-OCC*G2(IT,IU,IU,IT)*DF2(IT,IU,IV,IT)
      end do
    end do
  end do
end if

do IT=1,NLEV
  !G1(IT,IT) = OCC
  LT = LEVEL(IT)
  !F1(IT,IT) = (ESUM*OCC-ETA(LT))*G1(IT,IT)
  DESUM = DESUM+OCC*G1(IT,IT)*DF1(IT,IT)
  do IU=1,NLEV
    LU = LEVEL(IU)
    DEPSA(LT,LU) = DEPSA(LT,LU)-OCC*G1(IT,IT)*DF1(IT,IU)
  end do
end do

end subroutine DERSPE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Integer Function MemSO2_P(iCmp,jCmp,kCmp,lCmp,iAO,jAO,kAO,lAO)
************************************************************************
*  Object: to compile the number of SO block which will be generated   *
*          by the current shell quadruplet.                            *
*                                                                      *
*          Observe that the indices are canonically ordered at the     *
*          time of calling this routine!                               *
*                                                                      *
* Called from: Drv2El                                                  *
*                                                                      *
* Calling    : None                                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             February '90                                             *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
*
      MemSO2_P = 0
*
*     Quadruple loop over elements of the basis functions angular
*     description. Loops are reduced to just produce unique SO integrals
*     Observe that we will walk through the memory in AOInt in a
*     sequential way.
*
      If (nIrrep.eq.1) Then
*
         MemSO2_P=iCmp*jCmp*kCmp*lCmp
*
      Else
*
         Do i1 = 1, iCmp
            Do i2 = 1, jCmp
               Do i3 = 1, kCmp
                  Do i4 = 1, lCmp
*
*         Loop over irreps which are spanned by the basis function.
*         Again, the loop structure is restricted to ensure unique
*         integrals.
*
          Do 110 j1 = 0, nIrrep-1
             If (iAOtSO(iAO+i1,j1)<0) Cycle
             Do 210 j2 = 0, nIrrep-1
                If (iAOtSO(jAO+i2,j2)<0) Cycle
                j12 = iEor(j1,j2)
                Do 310 j3 = 0, nIrrep-1
                   If (iAOtSO(kAO+i3,j3)<0) Cycle
                   j4 = iEor(j12,j3)
                   If (iAOtSO(lAO+i4,j4)<0) Cycle
                   MemSO2_P = MemSO2_P + 1
*
 310            Continue
 210         Continue
 110      Continue
*
                  End Do
               End Do
            End Do
         End Do
*
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine Exp_1(Vector,n1,n2,Array,Fact)
************************************************************************
*                                                                      *
* Object: expand an array.                                             *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Real*8 Vector(n1,n2), Array(n1)
*
*
      Do 10 i2 = 1, n2
         Do 20 i1 = 1, n1
            Vector(i1,i2) = Array(i1)*Fact
 20      Continue
 10   Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine DrvPCM_(h1,TwoHam,D,RepNuc,nh1,First,NonEq,
     &                   Z_Nuc,Cord,MaxAto,Tessera,DMat,VTessera,
     &                   VSave,QTessera,QTessera_Slow,VSlow,nTs,Eps,
     &                   EpsInf)
      use Basis_Info, only: nBas
      use PCM_arrays
      use Symmetry_Info, only: nIrrep, iChBas
      use Temporary_Parameters, only: PrPrt
      Implicit Real*8 (A-H,O-Z)
      External PCMInt, NaMem
      Real*8 h1(nh1), TwoHam(nh1), D(nh1), Z_Nuc(MaxAto),
     &       Cord(3,MaxAto), Tessera(4,nTs), DMat(nTs,nTs),
     &       VTessera(2,nTs), VSave(2,Nts), QTessera(2,nTs),
     &       QTessera_Slow(nTs),VSlow(nTs), Origin(3)
#include "SysDef.fh"
#include "print.fh"
#include "real.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: FactOp(:), Integrals(:)
      Integer, Allocatable:: lOper2(:)
      Logical First
      Character*8 Label
      Logical Save_tmp, NonEq
      Real*8 RepNuc_Save
      Common /RF/RepNuc_Save
      Dimension ip(1)
#include "oneel_interface.fh"
*                                                                      *
************************************************************************
*                                                                      *
*-----Reaction field a la PCM
*
*     Set up some parameters.
*
      rHrmt=One
      nOrdOp=0
      nComp=1
      lOper=255
      kOper=iChBas(1)
      Origin(1)=Zero
      Origin(2)=Zero
      Origin(3)=Zero
*                                                                      *
************************************************************************
*                                                                      *
*---- Pick up slow charges and W's. These are present if we are doing
*     the final state.
*
      If (NonEq) Then
*
*------- Read slow components originating from the initial state
*
*        Write (*,*) 'Rd:',QTessera_Slow(1)
         Call Get_dArray('RCTFLD',QTessera_Slow,nTs)
         Call Get_dScalar('W_or_el',W_0_or_el)
         Call Get_dScalar('W_or_Inf',W_0_or_Inf)
*
*       Compute the electrostatic potential due to slow charges
*
        VSlow(1:nTs)=Zero
        Do iTile = 1, nTs
          XI=Tessera(1,iTile)
          YI=Tessera(2,iTile)
          ZI=Tessera(3,iTile)
          Do jTile = 1, nTs
            If (jTile.eq.iTile) Then
              Dij = 1.0694D0 * Two*Sqrt(Pi/Tessera(4,iTile))
            Else
              XJ=Tessera(1,jTile)
              YJ=Tessera(2,jTile)
              ZJ=Tessera(3,jTile)
              RIJ = Sqrt((XI-XJ)**2+(YI-YJ)**2+(ZI-ZJ)**2)
              Dij = One / RIJ
            End If
            VSlow(iTile) = VSlow(iTile) + Dij * QTessera_Slow(jTile)
          End Do
        End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Evaluate the potential field on the tiles.
*
      Save_tmp=PrPrt
      PrPrt=.True.
*
*---- Do the nuclear contribution
*
      Do iTile = 1, nTs
         Call EFNuc(Tessera(1,iTile),Z_Nuc,Cord,MaxAto,
     &             VTessera(1,iTile),nOrdOp)
         VTessera(2,iTile)=Zero
      End Do
*
*---- Do the electronic contribution
*
      call mma_allocate(FactOp,nTs,Label='FactOp')
      call mma_allocate(lOper2,nTs,Label='lOper2')
      FactOp(:)=One
      lOper2(:)=255
*
      Call Drv1_PCM(FactOp,nTs,D,nh1,Tessera,lOper2,VTessera,nOrdOp)
*
      Call mma_deallocate(lOper2)
      Call mma_deallocate(FactOp)
*
*     Save the electrostatic potential
*
      call dcopy_(2*nTs,VTessera,1,VSave,1)
*
*     Add the slow charge contribution to the nuclear potential
*
      If (NonEq) Call DaXpY_(nTs,One,VSlow,1,VTessera(1,1),2)
*                                                                      *
************************************************************************
*                                                                      *
*---- Evaluate the charges on the cavity boundary, nuclear and
*     electronic.
*
      Call PCM_Driver(iPrint,DMat,VTessera,QTessera,nTs)
*
*---- Make the slow charges (also called orientational charges or
*     frozen charges). This is always done regardless if they ever
*     will be used.  The charges can be used in non-equilibrium
*     calculations.
*
      If (EpsInf.gt.Zero.and..Not.NonEq) Then
        Fact=(Eps-EpsInf)/(Eps-One)
        call dcopy_(nTs,    QTessera(1,1),2,QTessera_Slow,1)
        Call DaXpY_(nTs,One,QTessera(2,1),2,QTessera_Slow,1)
        Call DScal_(nTs,Fact,QTessera_Slow,1)
*
*      Compute the electrostatic potential due to slow charges
*
       call dcopy_(nTs,[Zero],0,VSlow,1)
       Do iTile = 1, nTs
         XI=Tessera(1,iTile)
         YI=Tessera(2,iTile)
         ZI=Tessera(3,iTile)
         Do jTile = 1, nTs
           If (jTile.eq.iTile) Then
             Dij = 1.0694D0 * Two*Sqrt(Pi/Tessera(4,iTile))
           Else
             XJ=Tessera(1,jTile)
             YJ=Tessera(2,jTile)
             ZJ=Tessera(3,jTile)
             RIJ = Sqrt((XI-XJ)**2+(YI-YJ)**2+(ZI-ZJ)**2)
             Dij = One / RIJ
           End If
           VSlow(iTile) = VSlow(iTile) + Dij * QTessera_Slow(jTile)
         End Do
       End Do

      End If
*
*     Recover the nuclear potential (discarding the possible variations
*     due to slow charges)
*
      call dcopy_(nTs,VSave(1,1),2,VTessera(1,1),2)
*
      W_or_el     = Zero
      W_or_nuc    = Zero
      W_or_Inf    = Zero
      W_or_InfNuc = zero
      Do iTile = 1, nTs
        W_or_el  = W_or_el  + QTessera_Slow(iTile)*VTessera(2,iTile)
        W_or_nuc = W_or_nuc + QTessera_Slow(iTile)*VTessera(1,iTile)
        If(NonEq) then
          QInf = QTessera(1,iTile) + QTessera(2,iTile)
        Else
          Fact = (Eps - Epsinf) / (Eps - One)
          QInf = (QTessera(1,iTile) + QTessera(2,iTile)) * (One - Fact)
        EndIf
        W_or_Inf = W_or_Inf + QInf * VSlow(iTile)
        W_or_InfNuc = W_or_InfNuc + QTessera(1,iTile) * VSlow(iTile)
      End Do
*
*---- Write out the slow charges and constants if this is an
*     equilibrium calculations.
*
      If (EpsInf.gt.Zero.and..Not.NonEq) Then
*        Write (*,*) 'Wr:',QTessera_Slow(1)
         Call Put_dArray('RCTFLD',QTessera_Slow,nTs)
         Call Put_dScalar('W_or_el',W_or_el)
         Call Put_dScalar('W_or_Inf',W_or_Inf)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Now add terms to RepNuc
*
*     Interaction terms:
*     nuclei-nuclear solvation charge       (ENN)
*     nuclei-electronic solvation charge    (ENE)
*     electrons-nuclear solvation charge    (EEN)
*     electrons-electronic solvation charge (EEE)
*
      ENN = Zero
      ENE = Zero
      EEN = Zero
      EEE = Zero
      Do iTile = 1, nTs
        ENN = ENN + QTessera(1,iTile) * VTessera(1,iTile)
        ENE = ENE + QTessera(1,iTile) * VTessera(2,iTile)
        EEN = EEN + QTessera(2,iTile) * VTessera(1,iTile)
        EEE = EEE + QTessera(2,iTile) * VTessera(2,iTile)
      End Do
      If (First) then
         RepNuc = RepNuc + Half * ENN
         If(NonEq)
     &     RepNuc = RepNuc
     &            + Half * W_or_nuc
     &            + Half * W_or_InfNuc
     &            - Half * W_0_or_el
     &            - Half * W_0_or_Inf
         RepNuc_Save=RepNuc
         Label='PotNuc00'
         Call Put_Temp(Label,[RepNuc],1)
      End If

*                                                                      *
************************************************************************
*                                                                      *
*     Now add terms to h1 and TwoHam!
*
      Call mma_allocate(C_Tessera,3,nTs,Label='C_Tessera')
      nTiles=nTs
      C_Tessera(:,:)=Tessera(1:3,:)
      Call mma_allocate(Q_Tessera,nTs,Label='Q_Tessera')
      Label='<Q|V>'
*
*
      If (First) then
*
*------- PCM-integrals weighted by Q(1)
*        h1 + correction
*
         Q_Tessera(:)=QTessera(1,:)
         If (NonEq) Call DaXpY_(nTs,One,QTessera_Slow,1,Q_Tessera,1)
         Call OneEl_Integrals(PCMInt,NaMem,Label,ip,[lOper],nComp,
     &                        Origin,nOrdOp,rHrmt,[kOper],Integrals)
         nInt=n2Tri(lOper)
         Call CmpInt(Integrals(ip(1)),nInt,nBas,nIrrep,lOper)
         Alpha=One
         Call DaXpY_(nInt,Alpha,Integrals(ip(1)),1,h1,1)
         Call mma_deallocate(Integrals)
*
*------  Save the modified h1 matrix
*
         Label='h1_raw  '
         Call Put_Temp(Label,h1,nh1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- PCM-integrals weighted by Q(2)
*     TwoHam + correction
*
      Q_Tessera(:)=QTessera(2,:)
      Call OneEl_Integrals(PCMInt,NaMem,Label,ip,[lOper],nComp,Origin,
     &                     nOrdOp,rHrmt,[kOper],Integrals)
      nInt=n2Tri(lOper)
      Call CmpInt(Integrals(ip(1)),nInt,nBas,nIrrep,lOper)
      Alpha=One
      Call DaXpY_(nInt,Alpha,Integrals(ip(1)),1,TwoHam,1)
      Call mma_deallocate(Integrals)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Q_Tessera)
      Call mma_deallocate(C_Tessera)
      PrPrt=Save_tmp
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine cnfprint_cvb()
      implicit real*8 (a-h,o-z)
c ... Make: up to date? ...
      logical, external :: up2date_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "inpmod_cvb.fh"
#include "frag_cvb.fh"
#include "WrkSpc.fh"
      logical recinpcmp_cvb
      dimension idum(1)

      if(recinpcmp_cvb(4))call touch_cvb('CNFPRINT')

      if(ip(1).ge.0.and.(.not.up2date_cvb('CNFPRINT')))then
        i1 = mstacki_cvb(max(noe,noe*nconf))
        call rdioff_cvb(1,recinp,ioffs)
        call rdis_cvb(idum,1,recinp,ioffs)
        !noe1=idum(1)
        call rdis_cvb(idum,1,recinp,ioffs)
        !nconf1=idum(1)
        call rdis_cvb(idum,1,recinp,ioffs)
        !kbasiscvb1=idum(1)
        call rdis_cvb(iwork(i1),noe*nconf,recinp,ioffs)
        if(nconf.eq.0)then
          do 225 i=1,min(nel,norb)
          iwork(i+i1-1)=1
225       continue
          do 250 i=1,nel-norb
          iwork(i+i1-1)=2
250       continue
        endif
        nconf_off=0
        do 300 ifrag=1,nfrag
        if(nfrag.gt.1)write(6,'(/,a,i3)')
     >    ' Configuration list for wavefunction fragment',ifrag
        write(6,'(/,a)')' Spatial VB configurations'
        write(6,'(a)')' -------------------------'
        write(6,'(a)')'     Conf. =>   Orbitals'
        call cnfprt_cvb(iwork(noe*nconf_off+i1),
     >    nconf_fr(ifrag),nel_fr(ifrag))
        write(6,'(/,a,i6)')' Number of VB configurations :',
     >    nconf_fr(ifrag)
        write(6,'(a,i6)')  '           VB structures     :',
     >    nvbr_fr(ifrag)
        write(6,'(a,i6)')  '           VB determinants   :',
     >    ndetvb_fr(ifrag)
        nconf_off=nconf_off+nconf_fr(ifrag)
300     continue
        call mfreei_cvb(i1)
        call make_cvb('CNFPRINT')
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE EXC2_CP2 (CPQ,NDWN,NUPA,A,NUPB,B,NCP,ICOUP,VTAB)
      IMPLICIT NONE
      INTEGER NDWN,NUPA,NUPB,NCP,ICOUP(3,NCP)
      REAL*8 CPQ,A(NUPA,NDWN),B(NUPB,NDWN),VTAB(*)
      INTEGER ICP,ILFT,IRGT
      REAL*8 X
C CASE: ADD EPQ*A TO B, WHERE MIDLEV<Q<P AND A AND B ARE SINGLE
C MATRIX BLOCKS.
C ONLY UPPER WALKS AFFECTED =>    ROW OPERATION.
C Q<P, EXCITING OPERATOR  => A IS  LEFTHAND WALK.
      DO ICP=1,NCP
        ILFT=ICOUP(1,ICP)
        IRGT=ICOUP(2,ICP)
        X=CPQ*VTAB(ICOUP(3,ICP))
        CALL DAXPY_(NDWN,X,A(ILFT,1),NUPA,B(IRGT,1),NUPB)
      END DO
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Init_ave(Title,iPrint,Wset,Wsum,PrOcc,PrEne,
     &     DensityBased,ThrOcc,Dummy,iDummy)
      Implicit Real*8 (a-h,o-z)
*
*-- Initializations and defaults.
*
#include "mxdm.fh"
#include "real.fh"
#include "mxave.fh"

      Dimension Wset(MxSets)
      Logical PrOcc,PrEne,DensityBased
      Character Title*72

      iPrint=2
      Do 10, i=1,MxSets
        Wset(i)=0.0d0
10    Continue
      Wsum=0.0d0
      PrOcc=.True.
      PrEne=.False.
      DensityBased=.true.
      ThrOcc=1.0d-5
      Dummy=1.0
      iDummy=1
      Title=' Untitled job. '

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#include "compiler_features.h"
#ifdef _HDF5_

subroutine read_hdf5_all(file_h5,nss,nstate,multiplicity,eso,esfs,U,MM,MS,ML,DM,ANGMOM,EDMOM,amfi,HSO)

use mh5, only: mh5_open_file_r, mh5_fetch_attr, mh5_exists_dset, mh5_fetch_dset, mh5_close_file
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero, cOne, Onei, auTocm, gElectron
use Definitions, only: wp, iwp, u6

implicit none
character(len=180), intent(in) :: file_h5
integer(kind=iwp), intent(in) :: nss, nstate
integer(kind=iwp), intent(out) :: multiplicity(nstate)
real(kind=wp), intent(out) :: eso(nss), esfs(nstate), angmom(3,nstate,nstate), edmom(3,nstate,nstate), amfi(3,nstate,nstate)
complex(kind=wp), intent(out) :: U(nss,nss), MM(3,nss,nss), MS(3,nss,nss), ML(3,nss,nss), DM(3,nss,nss), HSO(nss,nss)
integer(kind=iwp) :: fileid, i, i1, INRM, ipar, iss, ist, j, j1, jst, l, mult, multI, multJ
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: jend
#endif
real(kind=wp) :: RNRM
logical(kind=iwp) :: found_edmom !, found_amfi, found_angmom, found_esfs, found_eso, found_hso, found_mult, found_sos_coeff
integer(kind=iwp), allocatable :: ibas(:,:)
real(kind=wp), allocatable :: AL(:,:,:), etmp(:), RI(:,:), RR(:,:)
complex(kind=wp), allocatable :: tmp(:,:), tmp2(:,:)
real(kind=wp), parameter :: g_e = -gElectron
real(kind=wp), external :: dnrm2_, dznrm2_
complex(kind=wp), external :: spin

found_edmom = .false.
!found_angmom = .false.
!found_hso = .false.
!found_amfi = .false.
!found_sos_coeff = .false.
!found_eso = .false.
!found_esfs = .false.
!found_mult = .false.

write(u6,'(A,A)') 'Read data from rassi.h5 file ',trim(file_h5)

! the presence of the RASSI-HDF5 has already been made in
! read_hdf5_init subroutine, executed earlier
! nss, nstate are already known
!----------------------------------------------------------------------|
! open the file
fileid = mh5_open_file_r(trim(file_h5))
#ifdef _DEBUGPRINT_
write(u6,'(A,I24)') 'read_hdf5_all:: fileid=',fileid
#endif
!----------------------------------------------------------------------|
! read spin multiplicity of each state:
!if (mh5_exists_dset(fileid,'STATE_SPINMULT')) then
!  found_mult = .true.
call mh5_fetch_attr(fileid,'STATE_SPINMULT',multiplicity)
#ifdef _DEBUGPRINT_
write(u6,'(A)') 'read_hdf5_all:: multiplicity'
write(u6,'(20I4)') (multiplicity(i),i=1,nstate)
#endif
INRM = sum(multiplicity(:))
if (INRM == 0) then
  call WarningMessage(2,'STATE_SPINMULT array read from HDF5 file has norm = zero')
  write(u6,*) 'Norm=',INRM
end if
!else
!  call WarningMessage(2,'State multiplicity array was not found on HDF5 file')
!end if

!----------------------------------------------------------------------|
! read the spin free energies (cm-1)
call mma_allocate(etmp,nstate,'etmp)')
if (mh5_exists_dset(fileid,'SFS_ENERGIES')) then
  !found_esfs = .true.
  call mh5_fetch_dset(fileid,'SFS_ENERGIES',etmp)
  RNRM = dnrm2_(nstate,etmp,1)
  if (RNRM < 1.0e-50_wp) then
    call WarningMessage(2,'ESFS read from HDF5 file  has norm = zero')
    write(u6,*) 'Norm=',RNRM
  end if
  ! compute the energeis in cm-1:
  esfs(:) = (etmp(:)-etmp(1))*auTocm
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'read_hdf5_all:: esfs'
  do i=1,nstate,4
    jEND = min(nstate,i+3)
    write(u6,'(4ES24.14)') (esfs(j),j=i,jEnd)
  end do
# endif
else
  call WarningMessage(2,'Spin-free energies were not found on HDF5 file')
end if
call mma_deallocate(etmp)

!----------------------------------------------------------------------|
! read the spin-orbit energies (cm-1)
call mma_allocate(etmp,nss,'tmp)')
etmp(:) = Zero
if (mh5_exists_dset(fileid,'SOS_ENERGIES')) then
  !found_eso = .true.
  call mh5_fetch_dset(fileid,'SOS_ENERGIES',etmp)
  RNRM = dnrm2_(nss,etmp,1)
  if (RNRM < 1.0e-50_wp) then
    call WarningMessage(2,'ESO read from HDF5 file  has norm = zero')
    write(u6,*) 'Norm=',RNRM
  end if
  ! compute the energies in cm-1:
  eso(:) = (etmp(:)-etmp(1))*auTocm
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'read_hdf5_all:: eso'
  do i=1,nss,4
    jEnd = min(nss,i+3)
    write(u6,'(4ES24.14)') (eso(j),j=i,jEnd)
  end do
# endif
else
  call WarningMessage(2,'Spin-orbit energies were not found on HDF5 file')
end if
call mma_deallocate(etmp)

!----------------------------------------------------------------------|
! read the spin-orbit mixing coefficient matrix:
call mma_allocate(RR,nss,nss,'RR')
call mma_allocate(RI,nss,nss,'RI')
U(:,:) = Zero
if (mh5_exists_dset(fileid,'SOS_COEFFICIENTS_REAL') .and. mh5_exists_dset(fileid,'SOS_COEFFICIENTS_IMAG')) then
  !found_sos_coeff = .true.
  call mh5_fetch_dset(fileid,'SOS_COEFFICIENTS_REAL',RR)
  call mh5_fetch_dset(fileid,'SOS_COEFFICIENTS_IMAG',RI)
  ! assemble the complex matrix U:
  U(:,:) = cmplx(RR(:,:),RI(:,:),kind=wp)
  RNRM = dznrm2_(nss*nss,U,1)
  if (RNRM < 1.0e-50_wp) then
    call WarningMessage(2,'SOS-U matrix read from HDF5 file  has norm = zero')
    write(u6,*) 'Norm=',RNRM
  end if
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'read_hdf5_all:: U'
  do i=1,nss
    do j=1,nss
      write(u6,'(2i4,A,2ES24.14)') i,j,' |',U(i,j)
    end do
  end do
# endif
else
  call WarningMessage(2,'SO mixing coefficeints were not found on HDF5 file')
end if
call mma_deallocate(RR)
call mma_deallocate(RI)

!----------------------------------------------------------------------|
! read the angular momentum integrals (L):
call mma_allocate(AL,nstate,nstate,3,'AL')
if (mh5_exists_dset(fileid,'SFS_ANGMOM')) then
  !found_angmom = .true.
  call mh5_fetch_dset(fileid,'SFS_ANGMOM',AL)
  do i=1,nstate
    do j=1,nstate
      ANGMOM(:,i,j) = AL(i,j,:)
    end do
  end do
  RNRM = dnrm2_(nstate*nstate*3,AL,1)
  if (RNRM < 1.0e-50_wp) then
    call WarningMessage(2,'SFS_ANGMOM read from HDF5 file  has norm = zero')
    write(u6,*) 'Norm=',RNRM
  end if
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'read_hdf5_all:: ANGMOM (x,y,z)'
  do i=1,nstate
    do j=1,nstate
      write(u6,'(2i4,A,3ES24.14)') i,j,' |',(ANGMOM(l,i,j),l=1,3)
    end do
  end do
# endif
else
  call WarningMessage(2,'ANGMOM integrals were not found on HDF5 file')
end if
call mma_deallocate(AL)

!----------------------------------------------------------------------|
! read the electric dipole momentum integrals (EDMOM):
call mma_allocate(AL,nstate,nstate,3,'AL')
if (mh5_exists_dset(fileid,'SFS_EDIPMOM')) then
  found_edmom = .true.
  call mh5_fetch_dset(fileid,'SFS_EDIPMOM',AL)
  do i=1,nstate
    do j=1,nstate
      EDMOM(:,i,j) = AL(i,j,:)
    end do
  end do
  RNRM = dnrm2_(nstate*nstate*3,AL,1)
  if (RNRM < 1.0e-50_wp) then
    call WarningMessage(2,'SFS_EDIPMOM read from HDF5 file  has norm = zero')
    write(u6,*) 'Norm=',RNRM
  end if
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'read_hdf5_all:: SFS_EDIPMOM(x,y,z)'
  do i=1,nstate
    do j=1,nstate
      write(u6,'(2i4,A,3ES24.14)') i,j,' |',(EDMOM(l,i,j),l=1,3)
    end do
  end do
# endif
else
  call WarningMessage(2,'EDMOM integrals were not found on HDF5 file')
end if
call mma_deallocate(AL)

!----------------------------------------------------------------------|
! read the spin-orbit integrals (AMFI):
call mma_allocate(AL,nstate,nstate,3,'AL')
if (mh5_exists_dset(fileid,'SFS_AMFIINT')) then
  !found_amfi = .true.
  call mh5_fetch_dset(fileid,'SFS_AMFIINT',AL)
  do i=1,nstate
    do j=1,nstate
      AMFI(:,i,j) = AL(i,j,:)
    end do
  end do
  RNRM = dnrm2_(nstate*nstate*3,AL,1)
  if (RNRM < 1.0e-50_wp) then
    call WarningMessage(2,'SFS_AMFIINT read from HDF5 file  has norm = zero')
    write(u6,*) 'Norm=',RNRM
  end if
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'read_hdf5_all:: SFS_AMFIINT(x,y,z)'
  do i=1,nstate
    do j=1,nstate
      write(u6,'(2i4,A,3ES24.14)') i,j,' |',(AMFI(l,i,j),l=1,3)
    end do
  end do
# endif
else
  call WarningMessage(2,'AMFI integrals were not found on HDF5 file')
end if
call mma_deallocate(AL)

!----------------------------------------------------------------------|
! read the RASSI SFS Hamiltonian (SFS_HAM):

!----------------------------------------------------------------------|
! read the RASSI SOS Hamiltonian (SOS_HAM):
call mma_allocate(RR,nss,nss,'RR')
call mma_allocate(RI,nss,nss,'RI')
if (mh5_exists_dset(fileid,'HSO_MATRIX_REAL') .and. mh5_exists_dset(fileid,'HSO_MATRIX_IMAG')) then
  !found_hso = .true.
  call mh5_fetch_dset(fileid,'HSO_MATRIX_REAL',RR)
  call mh5_fetch_dset(fileid,'HSO_MATRIX_IMAG',RI)
  ! assemble the complex matrix U:
  HSO(:,:) = cmplx(RR(:,:),RI(:,:),kind=wp)
  RNRM = dznrm2_(nss*nss,HSO,1)
  if (RNRM < 1.0e-50_wp) then
    call WarningMessage(2,'HSO matrix read from HDF5 file  has norm = zero')
    write(u6,*) 'Norm=',RNRM
  end if
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'read_hdf5_all:: HSO'
  do i=1,nss
    do j=1,nss
      write(u6,'(2i4,A,2ES24.14)') i,j,' |',HSO(i,j)
    end do
  end do
# endif
else
  call WarningMessage(2,'HSO matrix was not found on HDF5 file')
end if
call mma_deallocate(RR)
call mma_deallocate(RI)

!----------------------------------------------------------------------|
! All info has been read
! transform the SFS data to the SO basis
!----------------------------------------------------------------------|
! generate a local indexing table:
call mma_allocate(Ibas,[1,nstate],[-50,50],label='Ibas')
iss = 0
ibas = 0
ipar = mod(multiplicity(1),2)
do Ist=1,nstate
  Mult = Multiplicity(Ist)
  do I=-(Mult-Ipar)/2,(Mult-Ipar)/2
    if ((Ipar == 0) .and. (I == 0)) cycle
    Iss = Iss+1
    Ibas(Ist,I) = Iss
  end do ! i
end do ! ist

! expand the spin free basis to the spin-orbit basis:
MM(:,:,:) = cZero
ML(:,:,:) = cZero
MS(:,:,:) = cZero
do Ist=1,nstate
  Mult = Multiplicity(Ist)
  do I=-(Mult-Ipar)/2,(Mult-Ipar)/2
    if ((Ipar == 0) .and. (I == 0)) cycle
    do J=-(Mult-Ipar)/2,(Mult-Ipar)/2
      if ((Ipar == 0) .and. (J == 0)) cycle
      do l=1,3
        i1 = Ibas(Ist,I)
        j1 = Ibas(Ist,J)
        MM(l,i1,j1) = -Spin(l,Mult,I,J)*g_e
        MS(l,i1,j1) = Spin(l,Mult,I,J)
      end do ! l
    end do ! J
  end do ! I
end do ! Ist

do Ist=1,nstate
  MultI = Multiplicity(Ist)
  do Jst=1,nstate
    MultJ = Multiplicity(Jst)
    if (MultI == MultJ) then
      do I=-(MultI-Ipar)/2,(MultI-Ipar)/2
        if ((Ipar == 0) .and. (I == 0)) cycle
        i1 = Ibas(Ist,I)
        j1 = Ibas(Jst,I)
        MM(:,i1,j1) = MM(:,i1,j1)-Angmom(:,Ist,Jst)*Onei
        ML(:,i1,j1) = ML(:,i1,j1)+Angmom(:,Ist,Jst)*Onei
        DM(:,i1,j1) = DM(:,i1,j1)+eDmom(:,Ist,Jst)*cOne
      end do   ! I
    end if
  end do   ! Jst
end do   ! Ist

call mma_deallocate(Ibas)

! calculate the matrix elements of the spin and magnetic moment
! in the spin-orbit basis:
call mma_allocate(tmp,nss,nss,'tmp')
call mma_allocate(tmp2,nss,nss,'tmp2')
do L=1,3
  ! spin moment
  tmp2(:,:) = MS(L,:,:)
  call ZGEMM_('C','N',nss,nss,nss,cOne,U,nss,tmp2,nss,cZero,TMP,nss)
  call ZGEMM_('N','N',nss,nss,nss,cOne,TMP,nss,U,nss,cZero,tmp2,nss)
  MS(L,:,:) = tmp2(:,:)
  ! orbital moment
  tmp2(:,:) = ML(L,:,:)
  call ZGEMM_('C','N',nss,nss,nss,cOne,U,nss,tmp2,nss,cZero,TMP,nss)
  call ZGEMM_('N','N',nss,nss,nss,cOne,TMP,nss,U,nss,cZero,tmp2,nss)
  ML(L,:,:) = tmp2(:,:)
  ! magnetic moment
  tmp2(:,:) = MM(L,:,:)
  call ZGEMM_('C','N',nss,nss,nss,cOne,U,nss,tmp2,nss,cZero,TMP,nss)
  call ZGEMM_('N','N',nss,nss,nss,cOne,TMP,nss,U,nss,cZero,tmp2,nss)
  MM(L,:,:) = tmp2(:,:)

  if (found_EDMOM) then
    ! electric dipole moment
    tmp2(:,:) = DM(L,:,:)
    call ZGEMM_('C','N',nss,nss,nss,cOne,U,nss,tmp2,nss,cZero,TMP,nss)
    call ZGEMM_('N','N',nss,nss,nss,cOne,TMP,nss,U,nss,cZero,tmp2,nss)
    DM(L,:,:) = tmp2(:,:)
  end if
end do !L
call mma_deallocate(tmp)
call mma_deallocate(tmp2)

! close the file
call mh5_close_file(fileid)

return

end subroutine read_hdf5_all

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(read_hdf5_all)

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MP2Ap(iSymIA,iSymJB,AP,P)
! A subroutine that calculates A*p_k in the PCG-algorithm

use MBPT2_Global, only: EOcc, EVir, iPoVec, mAdDel, mAdFro, mAdOcc, mAdVir
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Four, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSymIA, iSymJB
real(kind=wp), intent(inout) :: AP(*)
real(kind=wp), intent(in) :: P(*)
integer(kind=iwp) :: iA, iB, iI, iJ, index1, index2, iSym1, iSym2, nB, nJ, nMaxOrb
real(kind=wp) :: E_a, E_i, Ediff, Fac, xiajb, xibja, xijab
real(kind=wp), allocatable :: Int1(:), Int2(:), IntC(:), Scr1(:)
#include "corbinf.fh"

nMaxOrb = 0
do iSym1=1,nSym
  do iSym2=1,nSym
    nMaxOrb = max(nMaxOrb,(nOrb(iSym1)+nDel(iSym1))*(nOrb(iSym2)+nDel(iSym2)))
  end do
end do
call mma_allocate(Int1,nMaxOrb,label='Int1')
call mma_allocate(Int2,nMaxOrb,label='Int2')
call mma_allocate(IntC,nMaxOrb,label='IntC')
call mma_allocate(Scr1,nMaxOrb,label='Scr1')

nB = nExt(iSymJB)+nDel(iSymJB)
do iA=1,nExt(iSymIA)+nDel(iSymIA)
  if (iSymIA == iSymJB) nB = iA
  do iB=1,nB
    call Exch(iSymIA,iSymIA,iSymJB,iSymJB,iA+nFro(iSymIA)+nOcc(iSymIA),iB+nFro(iSymJB)+nOcc(iSymJB),Int1,Scr1)
    if (iSymIA /= iSymJB) then
      call Exch(iSymJB,iSymIA,iSymIA,iSymJB,iA+nFro(iSymIA)+nOcc(iSymIA),iB+nFro(iSymJB)+nOcc(iSymJB),Int2,Scr1)
    end if
    call Coul(iSymIA,iSymJB,iSymIA,iSymJB,iA+nFro(iSymIA)+nOcc(iSymIA),iB+nFro(iSymJB)+nOcc(iSymJB),IntC,Scr1)
    !write(u6,*)
    !write(u6,*) ' *  A,B = ',iA,iB
    !call RecPrt('Int1:','(8F10.6)',Int1,nOrb(iSymIA)+nDel(iSymIA),nOrb(iSymJB)+nDel(iSymJB))
    !if (iSymIA /= iSymJB) then
    !  call RecPrt('Int2:','(8F10.6)',Int2,nOrb(iSymJB)+nDel(iSymJB),nOrb(iSymIA)+nDel(iSymIA))
    !end if
    !call RecPrt('IntC:','(8F10.6)',IntC,nOrb(iSymIA)+nDel(iSymIA),nOrb(iSymJB)+nDel(iSymJB))

    ! This loop will traverse an triangular AIxBJ-matrix
    do iI=1,nFro(iSymIA)+nOcc(iSymIA)
      nJ = nFro(iSymJB)+nOcc(iSymJB)
      if ((iA == iB) .and. (iSymIA == iSymJB)) nJ = iI
      do iJ=1,nJ
        Fac = One
        ! We will count the diagonal twice so the factor half will get it right
        if ((iA == iB) .and. (iI == iJ) .and. (iSymIA == iSymJB)) then
          Fac = Half
        end if
        ! For multiplication with the BJ element of P
        index1 = iPoVec(iSymJB)+iJ+(nFro(iSymJB)+nOcc(iSymJB))*(iB-1)
        index2 = iPoVec(iSymIA)+iI+(nFro(iSymIA)+nOcc(iSymIA))*(iA-1)
        xiajb = Int1(iI+(iJ-1)*(nOrb(iSymIA)+nDel(iSymIA)))
        xijab = IntC(iI+(iJ-1)*(nOrb(iSymIA)+nDel(iSymIA)))
        if (iSymIA == iSymJB) then
          xibja = Int1(iJ+(iI-1)*(nOrb(iSymJB)+nDel(iSymJB)))

        else
          xibja = Int2(iJ+(iI-1)*(nOrb(iSymJB)+nDel(iSymJB)))
        end if

        AP(index1) = AP(index1)+Fac*(Four*xiajb-xibja-xijab)*P(iPoVec(iSymIA)+iI+(nFro(iSymIA)+nOcc(iSymIA))*(iA-1))
        !---- Debug comments -------------------------------------------
        !write(u6,*) 'Symm A B',iSymIA,iSymJB
        !write(u6,*) 'IAJB',iI,iA,iJ,iB
        !write(u6,*) 'jiba',xijab
        !write(u6,*) 'adress AP',iPoVec(iSymJB)+iJ-1+(nFro(iSymJB)+nOcc(iSymJB))*(iB-1)
        !write(u6,*) 'Contr coul',Fac*(xijab)*P(iPoVec(iSymIA)+iI+(nFro(iSymIA)+nOcc(iSymIA))*(iA-1))
        !---------------------------------------------------------------
        !write(u6,*) 'IA JB',iOrbI,iVirA,iOrbJ,iVirB
        !write(u6,*) 'Index1:',index1
        !write(u6,*) 'A-elementet',Fac*(Four*xijab-xijba-xibja)
        !write(u6,*) 'P-vector',P(iPoVec(JB)+iOrbJ+nOcc(JB)*(iVirB-1))
        !write(u6,*) 'Index2:',index2
        !write(u6,*) 'A-elementet',Fac*(Four*xijab-xijba-xibja)
        !write(u6,*) 'P-vector',P(iPoVec(IA)+iOrbI+nOcc(IA)*(iVirA-1))

        AP(index2) = AP(index2)+Fac*(Four*xiajb-xibja-xijab)*P(iPoVec(iSymJB)+iJ+(nFro(iSymJB)+nOcc(iSymJB))*(iB-1))
        if ((iA == iB) .and. (iI == iJ) .and. (iSymIA == iSymJB)) then
          if (iA <= nExt(iSymIA)) then
            E_a = EVir(mAdVir(iSymIA)+iA-1)
          else
            E_a = EVir(mAdDel(iSymIA)+iA-nExt(iSymIA)-1)
          end if
          if (iI > nFro(iSymIA)) then
            E_i = EOcc(mAdOcc(iSymIA)+iI-nFro(iSymIA)-1)
          else
            E_i = EOcc(mAdFro(iSymIA)+iI-1)
          end if
          Ediff = E_a-E_i
          AP(index1) = AP(index1)+EDiff*P(iPoVec(iSymJB)+iJ+(nFro(iSymJB)+nOcc(iSymJB))*(iB-1))

        end if
      end do !iOrbJ
    end do   !iOrbI

  end do     !iOrbB
end do       !iOrbA

call mma_deallocate(Int1)
call mma_deallocate(Int2)
call mma_deallocate(IntC)
call mma_deallocate(Scr1)

return

end subroutine MP2Ap

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Bernhardsson                                    *
!***********************************************************************

function Clebsch_Gordan_mclr(j1,m1,j2,m2,j,m)
! Calculates the Clebsch-Gordan coefficients

use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp) :: Clebsch_Gordan_mclr
real(kind=wp), intent(in) :: j1, m1, j2, m2, j, m
integer(kind=iwp) :: z, zmax, zmin
real(kind=wp) :: dz, Fct, Fct1, Fct2, N, r, rsum, T
real(kind=wp), external :: Fact

if ((j1 < Zero) .or. (j2 < Zero) .or. (j < Zero)) then
  write(u6,*) 'Error J is lower than 0'
  call Abend()
end if
r = abs(Two*j1-int(Two*j1))+abs(Two*j2-int(Two*j2))+abs(Two*j-int(Two*j))+abs(Two*m1-int(Two*m1))+abs(Two*m2-int(Two*m2))+ &
    abs(Two*m-int(Two*m))
if (r > 1.0e-6_wp) then
  write(u6,*) 'CG provided with not half integer'
  call Abend()
end if
if (m1+m2 == m) then
  Fct1 = (Two*j+One)*Fact(j1+j2-j)*Fact(j1-j2+j)*Fact(-j1+j2+j)
  Fct2 = Fact(j1+j2+j+One)
  Fct = sqrt(Fct1/fct2)*sqrt(Fact(j1+m1)*Fact(j1-m1)*Fact(j2+m2)*Fact(j2-m2)*Fact(j+m)*Fact(j-m))
  zmax = nint(min(j1+j2-j,j1-m1,j2+m2))
  zmin = -nint(min(j-j2+m1,j-j1-m2))
  rsum = Zero
  zmin = max(0,zmin)
  do z=zmin,zmax
    dz = real(z,kind=wp)
    T = (-One)**z
    N = Fact(dz)*Fact(j1+j2-j-dz)*Fact(j1-m1-dz)*Fact(j2+m2-dz)*Fact(j-j2+m1+dz)*Fact(j-j1-m2+dz)
    rsum = rsum+T/N
  end do
  Clebsch_Gordan_mclr = rsum*Fct
else
  Clebsch_Gordan_mclr = Zero
end if

return

end function Clebsch_Gordan_mclr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine UTMU( EXCH, N, Z, M1, M2 )
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      Integer, intent(in)           :: EXCH, N
      Complex(kind=8), intent(in)  :: M1(3,EXCH,EXCH)
      Complex(kind=8), intent(in)  ::  Z(N,N)
      Complex(kind=8), intent(out) :: M2(3,EXCH,EXCH)
c  local variables:
      Integer          :: L, I,J
      Logical          :: DBG
      Real(kind=8)    :: dznrm2_,R1,R2
      External         :: dznrm2_
      Complex(kind=8), allocatable :: TMP(:,:)


      DBG=.false.

      If((N<=0).OR.(EXCH<=0)) Then
         Write(6,'(A)') 'in UTMU:   EXCH or N<=0 !!!'
         Write(6,*) 'EXCH=', EXCH
         Write(6,*) 'N   =', N
         Call xFlush(6)
         Call xquit(128)
      End If

      If(N>EXCH)  Then
         Write(6,'(A)') 'in UTMU:   EXCH < N !!!'
         Write(6,*) 'EXCH=', EXCH
         Write(6,*) 'N   =', N
         Write(6,'(A)') 'Nothing is to be done >> Return'
         Call xFlush(6)
         Call xquit(128)
      End If

      R1=dznrm2_(3*EXCH*EXCH,M1,1)
      R2=dznrm2_(  N*N,Z,1)
      If((R1<1.0e-25_wp).or.(R2<1.0e-25_wp)) Then
         Write(6,'(A)') 'in UTMU:   M1 or Z are empty!!!'
         Write(6,*) 'norm(M1)=', R1
         Write(6,*) 'norm(Z )=', R2
        Return
      End If

      If (DBG) Then
         Write(6,'(A)') 'UTMU :: input moment'
         Do i=1,EXCH
            Do j=1,EXCH
               Write(6,'(A,i3,A,i3,A,3(2E16.8,2x))')
     &                         '<',i,'|M1_l|',j,'>',(M1(l,i,j),l=1,3)
            End Do
         End Do
      End If




      Call mma_allocate(TMP,EXCH,EXCH,'TMP')
      Call zcopy_(3*EXCH*EXCH,[(0.0_wp,0.0_wp)],0,M2,1)

      If(N.eq.EXCH) Then

         Do L=1,3
            Call zcopy_( EXCH*EXCH,[(0.0_wp,0.0_wp)],0,TMP,1)
            Call ZGEMM_('C', 'N', EXCH, EXCH, EXCH, (1.0_wp,0.0_wp),
     &                        Z, EXCH,
     &                M1(L,:,:), EXCH,             (0.0_wp,0.0_wp),
     &                      TMP, EXCH )
            Call ZGEMM_('N', 'N', EXCH, EXCH, EXCH, (1.0_wp,0.0_wp),
     &                      TMP, EXCH,
     &                        Z, EXCH,             (0.0_wp,0.0_wp),
     &                M2(L,:,:), EXCH )
         End Do !L

      Else

         Do L=1,3
           Call zcopy_( EXCH*EXCH,[(0.0_wp,0.0_wp)],0,TMP,1)
           Call ZGEMM_('C', 'N',   N,   N,   N, (1.0_wp,0.0_wp),
     &              Z(1:N,1:N),   N,
     &           M1(L,1:N,1:N),   N,            (0.0_wp,0.0_wp),
     &                     TMP,   N )
           Call ZGEMM_('N', 'N',   N,    N,   N, (1.0_wp,0.0_wp),
     &                     TMP,   N,
     &              Z(1:N,1:N),   N,            (0.0_wp,0.0_wp),
     &           M2(L,1:N,1:N),   N )

           Call zcopy_( EXCH*EXCH,[(0.0_wp,0.0_wp)],0,TMP,1)
           Call ZGEMM_('C', 'N',   N, EXCH,   N, (1.0_wp,0.0_wp),
     &              Z(1:N,1:N),   N,
     &        M1(L,1:N,1:EXCH),   N,            (0.0_wp,0.0_wp),
     &       TMP(  1:N,1:EXCH),   N )

           Do I=1,N
              Do J=N+1,EXCH
                 M2(L,I,J)=TMP(I,J)
                 M2(L,J,I)=CONJG(TMP(I,J))
              End Do
           End Do
           Do i=N+1,EXCH
              Do j=N+1,EXCH
                 M2(L,i,j)=M1(L,i,j)
              End Do
           End Do
         End Do !L

      End If !N.eq.exch

      If (DBG) Then
         Write(6,'(A)') 'UTMU :: input moment'
         Do i=1,EXCH
            Do j=1,EXCH
               Write(6,'(A,i3,A,i3,A,3(2E16.8,2x))')
     &                         '<',i,'|M_l|',j,'>',(M1(l,i,j),l=1,3)
            End Do
         End Do
         Write(6,'(A)') 'UTMU :: unitary transformtion matrix'
         Do i=1,N
            Do j=1,N
               Write(6,'(A,i3,A,i3,A,3(2E16.8,2x))')
     &                         '<',i,'| U |',j,'>',(Z(i,j),l=1,3)
            End Do
         End Do
         Write(6,'(A)') 'UTMU :: output moment'
         Do i=1,EXCH
            Do j=1,EXCH
               Write(6,'(A,i3,A,i3,A,3(2E16.8,2x))')
     &                         '<',i,'|M_l|',j,'>',(M2(l,i,j),l=1,3)
            End Do
         End Do
      End If
      Call mma_deallocate(TMP)

      Return
      End Subroutine utmu







      subroutine utmu2( exch, n, z, m )
      ! the same as utmu, except being that the input m is
      ! being transformed.
      implicit none
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      integer, intent(in)            :: exch, n
      complex(kind=8), intent(inout):: m(3,exch,exch)
      complex(kind=8), intent(in)   ::  z(n,n)
c  local variables:
      integer          :: l, i,j, i1, j1
      logical          :: dbg
      real(kind=8)    :: dznrm2_,r1,r2
      external         :: dznrm2_
      complex(kind=8), allocatable :: tmp(:,:), mtmp(:,:,:)


      dbg=.false.

      if((n<=0).or.(exch<=0)) then
         write(6,'(a)') 'in utmu2:   exch or n<=0 !!!'
         write(6,*) 'exch=', exch
         write(6,*) 'n   =', n
         Call xflush(6)
         Call xquit(128)
      end if

      if(n>exch)  then
         write(6,'(a)') 'in utmu2:   exch < n !!!'
         write(6,*) 'exch=', exch
         write(6,*) 'n   =', n
         write(6,'(a)') 'nothing is to be done >> return'
         Call xflush(6)
         Call xquit(128)
      end if

      r1=dznrm2_(3*exch*exch,m,1)
      r2=dznrm2_(  n*n,z,1)
      if((r1<1.0e-25_wp).or.(r2<1.0e-25_wp)) then
         write(6,'(a)') 'in utmu2:   m or z are empty!!!'
         write(6,*) 'norm(m)=', r1
         write(6,*) 'norm(z)=', r2
         Return
      end if

      if (dbg) then
         write(6,'(a)') 'utmu2 :: input moment'
         do i=1,exch
            do j=1,exch
               write(6,'(a,i3,a,i3,a,3(2e16.8,2x))')
     &                         '<',i,'|m_l|',j,'>',(m(l,i,j),l=1,3)
            end do
         end do
      end if


      call mma_allocate(tmp,exch,exch,'tmp')
      if(n<exch) then
         call mma_allocate(mtmp,3,(exch-n),(exch-n),'mtmp')
         ! save the part which is not altered
         do i=n+1,exch
            do j=n+1,exch
               i1=i-n
               j1=j-n
               do l=1,3
                  mtmp(l,i1,j1)=m(l,i,j)
               end do
            end do
         end do
      end if


      if(n==exch) then

         do l=1,3
            call zcopy_( exch*exch,[(0.0_wp,0.0_wp)],0,tmp,1)
            call zgemm_('c', 'n', exch, exch, exch, (1.0_wp,0.0_wp),
     &                        z, exch,
     &                 m(l,:,:), exch,             (0.0_wp,0.0_wp),
     &                      tmp, exch )
            call zcopy_(exch*exch,[(0.0_wp,0.0_wp)],0,m(l,:,:),1)
            call zgemm_('n', 'n', exch, exch, exch, (1.0_wp,0.0_wp),
     &                      tmp, exch,
     &                        z, exch,             (0.0_wp,0.0_wp),
     &                m(l,:,:), exch )
         end do !l

      else

         do l=1,3
           call zcopy_( exch*exch,[(0.0_wp,0.0_wp)],0,tmp,1)
           call zgemm_('c', 'n',   n,   n,   n, (1.0_wp,0.0_wp),
     &              z(1:n,1:n),   n,
     &            m(l,1:n,1:n),   n,            (0.0_wp,0.0_wp),
     &                     tmp,   n )
            call zcopy_(n*n,[(0.0_wp,0.0_wp)],0,m(l,1:n,1:n),1)

           call zgemm_('n', 'n',   n,    n,   n, (1.0_wp,0.0_wp),
     &                     tmp,   n,
     &              z(1:n,1:n),   n,            (0.0_wp,0.0_wp),
     &            m(l,1:n,1:n),   n )

           call zcopy_( exch*exch,[(0.0_wp,0.0_wp)],0,tmp,1)
           call zgemm_('c', 'n',   n, exch,   n, (1.0_wp,0.0_wp),
     &              z(1:n,1:n),   n,
     &         m(l,1:n,1:exch),   n,            (0.0_wp,0.0_wp),
     &       tmp(  1:n,1:exch),   n )

           do i=1,n
              do j=n+1,exch
                  m(l,i,j)=tmp(i,j)
                  m(l,j,i)=conjg(tmp(i,j))
              end do
           end do
           do i=n+1,exch
              do j=n+1,exch
                 i1=i-n
                 j1=j-n
                 m(l,i,j)=mtmp(l,i1,j1)
              end do
           end do
         end do !l
      end if !n.eq.exch

      if (dbg) then
         write(6,'(a)') 'utmu2 :: unitary transformtion matrix'
         do i=1,n
            do j=1,n
               write(6,'(a,i3,a,i3,a,3(2e16.8,2x))')
     &                         '<',i,'| u |',j,'>',z(i,j)
            end do
         end do
         write(6,'(a)') 'utmu2 :: output moment'
         do i=1,exch
            do j=1,exch
               write(6,'(a,i3,a,i3,a,3(2e16.8,2x))')
     &                         '<',i,'|m_l|',j,'>',(m(l,i,j),l=1,3)
            end do
         end do
      end if

      if(n<exch) call mma_deallocate(mtmp)
      call mma_deallocate(tmp)

      if(dbg) write(6,*) 'at the end of utmu2'
      if(dbg) call prmom('utmu2, moment',m,n)

      return
      end subroutine utmu2






      Subroutine UTMUL( EXCH, N, Z, ML )
      ! the same as UTMU, except being that the input M is
      ! being transformed and only one projection is done at a time.
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
#include "stdalloc.fh"
      Integer, intent(in)            :: EXCH, N
!     one projection is done
      Complex(kind=8), intent(inout):: ML(EXCH,EXCH)
      Complex(kind=8), intent(in)   ::  Z(N,N)
c  local variables:
      Integer          :: I,J,i1,j1
      Logical          :: DBG
      Real(kind=8)    :: dznrm2_,R1,R2
      External         :: dznrm2_
      Complex(kind=8), allocatable :: TMP(:,:), MTMP(:,:)


      DBG=.false.

      If((N<=0).OR.(EXCH<=0)) Then
         Write(6,'(A)') 'in UTMU2:   EXCH or N<=0 !!!'
         Write(6,*) 'EXCH=', EXCH
         Write(6,*) 'N   =', N
         Call xquit(128)
      End If


      If(N>EXCH)  Then
         Write(6,'(A)') 'in UTMU2:   EXCH < N !!!'
         Write(6,*) 'EXCH=', EXCH
         Write(6,*) 'N   =', N
         Write(6,'(A)') 'Nothing is to be done >> Return'
         Call xquit(128)
      End If

      R1=dznrm2_(EXCH*EXCH,ML,1)
      R2=dznrm2_(N*N,Z,1)
      If((R1<1.0e-25_wp).or.(R2<1.0e-25_wp)) Then
         Write(6,'(A)') 'in UTMU2:   M or Z are empty!!!'
         Write(6,*) 'norm(M)=', R1
         Write(6,*) 'norm(Z)=', R2
         Call xquit(128)
      End If

      If (DBG) Then
         Write(6,'(A)') 'UTMU :: input moment'
         Do i=1,EXCH
            Do j=1,EXCH
               Write(6,'(A,i3,A,i3,A,3(2E16.8,2x))')
     &                         '<',i,'|ML|',j,'>',ML(i,j)
            End Do
         End Do
      End If


      Call mma_allocate(TMP,EXCH,EXCH,'TMP')
      If(N<EXCH) Then
         Call mma_allocate(MTMP,(EXCH-N),(EXCH-N),'MTMP')
         ! save the part which is not altered
         Do i=N+1,EXCH
            Do j=N+1,EXCH
               i1=i-N
               j1=j-N
               MTMP(i1,j1)=ML(i,j)
            End Do
         End Do
      End If


      If(N==EXCH) Then
         Call zcopy_( EXCH*EXCH,[(0.0_wp,0.0_wp)],0,TMP,1)
         Call zgemm_('C', 'N', EXCH, EXCH, EXCH, (1.0_wp,0.0_wp),
     &                     Z, EXCH,
     &                    ML, EXCH,             (0.0_wp,0.0_wp),
     &                   TMP, EXCH )
         Call zcopy_(EXCH*EXCH,[(0.0_wp,0.0_wp)],0,ML(:,:),1)
         Call zgemm_('N', 'N', EXCH, EXCH, EXCH, (1.0_wp,0.0_wp),
     &                   TMP, EXCH,
     &                     Z, EXCH,             (0.0_wp,0.0_wp),
     &                    ML, EXCH )

      Else

         Call zcopy_( EXCH*EXCH,[(0.0_wp,0.0_wp)],0,TMP,1)
         Call ZGEMM_('C', 'N',   N,   N,   N, (1.0_wp,0.0_wp),
     &            Z(1:N,1:N),   N,
     &           ML(1:N,1:N),   N,            (0.0_wp,0.0_wp),
     &                   TMP,   N )
         Call zcopy_(N*N,[(0.0_wp,0.0_wp)],0,ML(1:N,1:N),1)

         Call ZGEMM_('N', 'N',   N,    N,   N, (1.0_wp,0.0_wp),
     &                   TMP,   N,
     &            Z(1:N,1:N),   N,            (0.0_wp,0.0_wp),
     &          ML(1:N,1:N),   N )

         Call zcopy_( EXCH*EXCH,[(0.0_wp,0.0_wp)],0,TMP,1)
         Call ZGEMM_('C', 'N',   N, EXCH,   N, (1.0_wp,0.0_wp),
     &            Z(1:N,1:N),   N,
     &        ML(1:N,1:EXCH),   N,            (0.0_wp,0.0_wp),
     &     TMP(  1:N,1:EXCH),   N )

         Do I=1,N
            Do J=N+1,EXCH
                ML(I,J)=TMP(I,J)
                ML(J,I)=CONJG(TMP(I,J))
            End Do
         End Do
         Do i=N+1,EXCH
            Do j=N+1,EXCH
               i1=i-N
               j1=j-N
               ML(i,j)=MTMP(i1,j1)
            End Do
         End Do

      End If !N.eq.exch

      If (DBG) Then
         Write(6,'(A)') 'UTMU :: unitary transformtion matrix'
         Do i=1,N
            Do j=1,N
               Write(6,'(A,i3,A,i3,A,3(2E16.8,2x))')
     &                         '<',i,'| U |',j,'>',Z(i,j)
            End Do
         End Do
         Write(6,'(A)') 'UTMU :: output moment'
         Do i=1,EXCH
            Do j=1,EXCH
               Write(6,'(A,i3,A,i3,A,3(2E16.8,2x))')
     &                         '<',i,'|ML|',j,'>',ML(i,j)
            End Do
         End Do
      End If

      If(N<EXCH) Call mma_deallocate(MTMP)
      Call mma_deallocate(TMP)

      Return
      End Subroutine utmul

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1998  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MKBMAT()
      use definitions, only: iwp, wp, Byte, u6
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG, VERBOSE
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_global, only: DREF, PREF
      use caspt2_global, only: LUSOLV, LUSBT
      use caspt2_module, only: NASHT
      use pt2_guga, only: NG1, NG2, NG3
      IMPLICIT NONE
C Set up B matrices for cases 1..13.

      INTEGER(kind=Byte), ALLOCATABLE :: idxG3(:,:)
      real(kind=wp), ALLOCATABLE:: F1(:), F2(:), F3(:), FD(:), FP(:)
      INTEGER(kind=iwp) NFD, NFP, iLUID

      IF(IPRGLB.GE.VERBOSE) THEN
        WRITE(6,*)
        WRITE(6,*)' Construct B matrices'
      END IF

      IF(NASHT/=0) THEN

      CALL mma_allocate(F1,NG1,Label='F1')
      NFD=SIZE(PREF)
      CALL mma_allocate(FD,NFD,Label='FD')

      CALL PT2_GET(NG1,'DELTA1',F1)
      CALL MKDREF_RPT2(NASHT,F1,FD)

      CALL mma_deallocate(F1)
      CALL mma_allocate(F2,NG2,Label='F2')

      CALL PT2_GET(NG2,'DELTA2',F2)

      NFP=SIZE(PREF)
      CALL mma_allocate(FP,NFP,Label='FP')

      CALL MKPREF_RPT2(NASHT,F2,FP)

      CALL mma_deallocate(F2)
      CALL mma_allocate(F3,NG3,Label='F3')

      CALL PT2_GET(NG3,'DELTA3',F3)

      IF(IPRGLB.GE.DEBUG) THEN
        WRITE(u6,'("DEBUG> ",A)') 'CASE SYM B-MATRIX NORM'
        WRITE(u6,'("DEBUG> ",A)') '==== === ============='
      END IF

      CALL mma_allocate(idxG3,6,NG3,label='idxG3')
      iLUID=0
      CALL I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)

      CALL MKBA(DREF,SIZE(DREF),PREF,SIZE(PREF),FD,FP,NG3,F3,idxG3)
      CALL MKBC(DREF,SIZE(DREF),PREF,SIZE(PREF),FD,FP,NG3,F3,idxG3)

      CALL mma_deallocate(F3)
      CALL mma_deallocate(idxG3)

      CALL MKBB(DREF,SIZE(DREF),PREF,SIZE(PREF),FD,FP)
      CALL MKBD(DREF,SIZE(DREF),PREF,SIZE(PREF),FD,FP)
      CALL MKBE(DREF,SIZE(DREF),FD)
      CALL MKBF(DREF,SIZE(DREF),PREF,SIZE(PREF),FP)
      CALL MKBG(DREF,SIZE(DREF),FD)
      CALL mma_deallocate(FP)
      CALL mma_deallocate(FD)

      END IF

      CALL MKBH()

      CONTAINS

      SUBROUTINE MKBH()
C For completeness, even case H has formally S and B
C matrices. This costs nothing, and saves conditional
C looping, etc in the rest of the routines.
      use constants, only: Zero
      use EQSOLV, only: IDBMAT
      use caspt2_module, only: NSYM, NINDEP
      implicit None
      real(kind=wp) DUM(1)
      integer(kind=iwp) ISYM, ICASE, NIN, IDISK

      DUM(1)=Zero
      DO ISYM=1,NSYM
        DO ICASE=12,13
          NIN=NINDEP(ISYM,ICASE)
          IF(NIN.GT.0) THEN
            IDISK=IDBMAT(ISYM,ICASE)
            CALL DDAFILE(LUSBT,1,DUM,1,IDISK)
          END IF
        END DO

      END DO
      END SUBROUTINE MKBH

      END SUBROUTINE MKBMAT

********************************************************************************
* Case A (ICASE=1)
********************************************************************************
      SUBROUTINE MKBA(DREF,NDREF,PREF,NPREF,FD,FP,NG3,F3,idxG3)
      use definitions, only: iwp, wp, Byte
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: NSYM, NINDEP, NTUV
      IMPLICIT NONE
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif
      INTEGER(KIND=IWP), INTENT(IN):: NDREF,NPREF, NG3
      Real(KIND=WP), INTENT(IN):: DREF(NDREF),PREF(NPREF),F3(NG3)
      Real(KIND=WP), INTENT(IN):: FD(NDREF),FP(NPREF)
      INTEGER(KIND=Byte), INTENT(IN):: idxG3(6,NG3)
#ifdef _MOLCAS_MPP_
      Real(KIND=WP) Dummy(1)
      INTEGER(KIND=IWP) MYRANK,ILO,IHI,JLO,JHI,MA,LDA
#endif
      INTEGER(KIND=IWP) ICASE,ISYM,NIN,NAS,NBA,lg_BA
      Real(KIND=WP) DBA
      Real(KIND=WP), EXTERNAL:: PSBMAT_FPRINT

      ICASE=1
C LONG loop over superindex symmetry.
      DO ISYM=1,NSYM
        NIN=NINDEP(ISYM,ICASE)
        IF(NIN.EQ.0) CYCLE
        NAS=NTUV(ISYM)
        NBA=(NAS*(NAS+1))/2
        IF(NBA.LE.0) CYCLE

C Set up the matrix BA(tuv,xyz) defined by the expression
C <ituv|H0-E0|kxyz> = dik ( alpha(a) SA(tuv,xyz) + BA(tuv,xyz) )
C Formula used:
C BA(tuv,xyz) = (Ey+Eu+Ex+Et-EASUM)*SA(tuv,xyz) - Fvuxtyz
C - dyu ( Fvzxt - Eu Gvzxt ) - dyt ( Fvuxz - Et Gvuxz )
C - dxu ( Fvtyz - Eu Gvtyz ) - dxu dyt ( Fvz - (Et+Eu) Gvz )
C + 2dxt ( Fvuyz - Et Gvuyz ) + 2dxt dyu ( Fvz - (Et+Eu) Gvz )

C where dyu = Kronecker(y,u) etc. Gvutxyz=<Evutxyz>, etc.
C Similarly, Fvutxyz= Sum(w)(EPSA(w)<Evutxyzww>, etc.

        CALL PSBMAT_GETMEM('BA',lg_BA,NAS)
        CALL PSBMAT_READ('S',iCase,iSym,lg_BA,NAS)

        ! fill in the 3-el parts
#ifdef _MOLCAS_MPP_
        IF (IS_REAL_PAR()) THEN
          MYRANK = GA_NODEID()
          CALL GA_DISTRIBUTION (LG_BA,MYRANK,ILO,IHI,JLO,JHI)
          IF (JLO.NE.0 .AND. (JHI-JLO+1).NE.NAS) THEN
            WRITE(6,*) 'MKBA: MISMATCH IN RANGE OF THE SUPERINDICES'
            CALL ABEND()
          END IF
          IF (ILO.GT.0 .AND. JLO.GT.0) THEN
            CALL GA_ACCESS (LG_BA,ILO,IHI,JLO,JHI,MA,LDA)
            CALL MKBA_DP(DREF,NDREF,PREF,NPREF,FD,FP,iSYM,
     &                   DBL_MB(MA),ILO,IHI,JLO,JHI,LDA)
            CALL MKBA_F3_MPP(ISYM,DBL_MB(MA),ILO,IHI,JLO,JHI,LDA,
     &                       NG3,F3,IDXG3)
            CALL GA_RELEASE_UPDATE (LG_BA,ILO,IHI,JLO,JHI)
          ELSE
            CALL MKBA_F3_MPP(ISYM,DUMMY,ILO,IHI,JLO,JHI,LDA,
     &                       NG3,F3,IDXG3)
          END IF
        ELSE
#endif
          CALL MKBA_DP(DREF,NDREF,PREF,NPREF,FD,FP,
     &                 ISYM,GA_Arrays(lg_BA)%A(:),1,NAS,1,NAS,0)
          CALL MKBA_F3(ISYM,GA_Arrays(lg_BA)%A(:),NG3,F3,IDXG3)
#ifdef _MOLCAS_MPP_
        END IF
#endif

        CALL PSBMAT_WRITE('B',iCase,iSYM,lg_BA,NAS)

        IF(IPRGLB.GE.DEBUG) THEN
          DBA=PSBMAT_FPRINT(lg_BA,NAS)
          WRITE(6,'("DEBUG> ",A4,1X,I3,1X,ES21.14)') 'A', ISYM, DBA
        END IF

        CALL PSBMAT_FREEMEM(lg_BA)
      END DO

      END SUBROUTINE MKBA

      SUBROUTINE MKBA_DP (DREF,NDREF,PREF,NPREF,FD,FP,iSYM,
     &                    BA,iLo,iHi,jLo,jHi,LDA)
      use definitions, only: iwp, wp
      use constants, only: Half, Two, Four
      USE SUPERINDEX, only: MTUV
      use caspt2_global, only:ipea_shift
      use caspt2_module, only: EASUM,NASHT,NTUVES,EPSA,NTUVES
      IMPLICIT None
      INTEGER(KIND=IWP), INTENT(IN):: NDREF, NPREF, iSYM,
     &                                iLo, iHi, jLo, jHi, LDA
      REAL(KIND=WP), INTENT(IN):: DREF(NDREF),PREF(NPREF)
      REAL(KIND=WP), INTENT(IN):: FD(NDREF),FP(NPREF)
      REAL(KIND=WP), INTENT(OUT):: BA(*)

      INTEGER(KIND=IWP) IXYZ,IXYZABS,IXABS,IYABS,IZABS,ITUVABS,ITABS,
     &                  IUABS,IVABS,ISADR,IVZ,IXT,IP1,IP2,IP,ID,ID1,
     &                  ID2,IDT,IDU,IDV,ITUV,IVT,IVU,IXZ,IYZ
      REAL(KIND=WP)EX,EY,ET,EU,ETU,FACT,VALUE
CSV.20100831: fill in the F2 and F1 corrections for this BA block
C on entry, BA should contain SA!!
      DO IXYZ=jLo,jHi
        IXYZABS=IXYZ+NTUVES(ISYM)
        IXABS=MTUV(1,IXYZABS)
        IYABS=MTUV(2,IXYZABS)
        IZABS=MTUV(3,IXYZABS)
        EX=EPSA(IXABS)
        EY=EPSA(IYABS)
        DO ITUV=iLo,iHi
          ITUVABS=ITUV+NTUVES(ISYM)
          ITABS=MTUV(1,ITUVABS)
          IUABS=MTUV(2,ITUVABS)
          IVABS=MTUV(3,ITUVABS)
          ET=EPSA(ITABS)
          EU=EPSA(IUABS)
          ETU=ET+EU
          FACT=EY+EU+EX+ET-EASUM
          ISADR=1+iTUV-iLo+LDA*(iXYZ-jLo)
          IF (LDA.EQ.0) THEN
            IF (iXYZ.LE.iTUV) THEN
              ISADR=(ITUV*(ITUV-1))/2+IXYZ
            ELSE
              CYCLE
            END IF
          END IF
          VALUE=FACT*BA(ISADR)
          IF(IYABS.EQ.IUABS) THEN
            IVZ=IVABS+NASHT*(IZABS-1)
            IXT=IXABS+NASHT*(ITABS-1)
            IP1=MAX(IVZ,IXT)
            IP2=MIN(IVZ,IXT)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE-Two*(FP(IP)-EU*PREF(IP))
            IF(IXABS.EQ.ITABS) THEN
              ID1=MAX(IVABS,IZABS)
              ID2=MIN(IVABS,IZABS)
              ID=(ID1*(ID1-1))/2+ID2
              VALUE=VALUE+Two*(FD(ID)-ETU*DREF(ID))
            END IF
          END IF
C Add  dyt ( -Fvuxz + Et*Gvuxz +dxu (-Fvz+(Et+Eu)*Gvz))
          IF(IYABS.EQ.ITABS) THEN
            IVU=IVABS+NASHT*(IUABS-1)
            IXZ=IXABS+NASHT*(IZABS-1)
            IP1=MAX(IVU,IXZ)
            IP2=MIN(IVU,IXZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE-Two*(FP(IP)-ET*PREF(IP))
            IF(IXABS.EQ.IUABS) THEN
              ID1=MAX(IVABS,IZABS)
              ID2=MIN(IVABS,IZABS)
              ID=(ID1*(ID1-1))/2+ID2
              VALUE=VALUE - (FD(ID)-ETU*DREF(ID))
            END IF
          END IF
C Add  dxu ( -Fvtyz + Eu*Gvtyz )
          IF(IXABS.EQ.IUABS) THEN
            IVT=IVABS+NASHT*(ITABS-1)
            IYZ=IYABS+NASHT*(IZABS-1)
            IP1=MAX(IVT,IYZ)
            IP2=MIN(IVT,IYZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE-Two*(FP(IP)-EU*PREF(IP))
          END IF
C Add  2dtx ( Fvuyz-Et*Gvuyz )
          IF(ITABS.EQ.IXABS) THEN
            IVU=IVABS+NASHT*(IUABS-1)
            IYZ=IYABS+NASHT*(IZABS-1)
            IP1=MAX(IVU,IYZ)
            IP2=MIN(IVU,IYZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE+Four*(FP(IP)-ET*PREF(IP))
          END IF
CGG.Nov03
          IF (ITUV.eq.IXYZ) THEN
            IDT=(ITABS*(ITABS+1))/2
            IDU=(IUABS*(IUABS+1))/2
            IDV=(IVABS*(IVABS+1))/2
            VALUE=VALUE+ipea_shift*Half*BA(ISADR)*
     &                  (Two-DREF(IDV)+DREF(IDT)+DREF(IDU))
          ENDIF
CGG End
          BA(ISADR)=VALUE
        END DO
      END DO
      END SUBROUTINE MKBA_DP

      SUBROUTINE MKBA_F3(ISYM,BA,NG3,F3,idxG3)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp, Byte
      USE SUPERINDEX, only: KTUV
      use caspt2_module, only: NASHT,IASYM,nTUVES
      IMPLICIT NONE

      INTEGER(KIND=IWP), INTENT(IN):: ISYM, NG3
      REAL(KIND=WP), INTENT(INOUT):: BA(*)
      REAL(KIND=WP), INTENT(IN):: F3(NG3)
      INTEGER(KIND=Byte), INTENT(IN):: idxG3(6,NG3)

      INTEGER(KIND=IWP) iG3,iT,iU,iV,iX,iY,iZ,iST,iSU,iSV,iSX,iSY,iSZ,
     &                  ituvs,ixyzs,iTU,iVX,iYZ,jSYM,ISUP,JSUP,ISADR
      REAL(KIND=WP) F3VAL

C-SVC20100831: determine indices in SA where a certain F3 value will end up
      DO iG3=1,NG3
        iT=idxG3(1,iG3)
        iU=idxG3(2,iG3)
        iV=idxG3(3,iG3)
        iX=idxG3(4,iG3)
        iY=idxG3(5,iG3)
        iZ=idxG3(6,iG3)
        iST=IASYM(iT)
        iSU=IASYM(iU)
        iSV=IASYM(iV)
        iSX=IASYM(iX)
        iSY=IASYM(iY)
        iSZ=IASYM(iZ)
        ituvs=Mul(IST,Mul(ISU,ISV))
        ixyzs=Mul(ISX,Mul(ISY,ISZ))
        if(ituvs.ne.ixyzs) CYCLE
        iTU=iT+NASHT*(iU-1)
        iVX=iV+NASHT*(iX-1)
        iYZ=iY+NASHT*(iZ-1)
        F3VAL=-F3(iG3)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
C  - F(tuvxyz) -> BA(xut,vyz)
        jSYM=Mul(IASYM(iX),Mul(IASYM(iU),IASYM(iT)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iX,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iV,iY,iZ)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
        if (.NOT.(iTU.eq.iVX.and.iVX.eq.iYZ)) THEN
        if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(vxtuyz) -> BA(uxv,tyz)
        jSYM=Mul(IASYM(iU),Mul(IASYM(iX),IASYM(iV)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iU,iX,iV)-nTUVES(jSYM)
          JSUP=KTUV(iT,iY,iZ)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(yzvxtu) -> BA(xzy,vtu)
        jSYM=Mul(IASYM(iX),Mul(IASYM(iZ),IASYM(iY)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iX,iZ,iY)-nTUVES(jSYM)
          JSUP=KTUV(iV,iT,iU)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(tuyzvx) -> BA(zut,yvx)
        jSYM=Mul(IASYM(iZ),Mul(IASYM(iU),IASYM(iT)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iZ,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iY,iV,iX)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
       ENDIF
C  - F(yztuvx) -> BA(uzy,tvx)
        jSYM=Mul(IASYM(iU),Mul(IASYM(iZ),IASYM(iY)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iU,iZ,iY)-nTUVES(jSYM)
          JSUP=KTUV(iT,iV,iX)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(vxyztu) -> BA(zxv,ytu)
        jSYM=Mul(IASYM(iZ),Mul(IASYM(iX),IASYM(iV)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iZ,iX,iV)-nTUVES(jSYM)
          JSUP=KTUV(iY,iT,iU)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
       ENDIF
        if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) CYCLE
        if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) CYCLE
        if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) CYCLE
        if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) CYCLE
C  - F(utxvzy) -> BA(vtu,xzy)
        jSYM=Mul(IASYM(iV),Mul(IASYM(iT),IASYM(iU)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iV,iT,iU)-nTUVES(jSYM)
          JSUP=KTUV(iX,iZ,iY)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
        if (iTU.eq.iVX.and.iVX.eq.iYZ) CYCLE
        if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(xvutzy) -> BA(tvx,uzy)
        jSYM=Mul(IASYM(iT),Mul(IASYM(iV),IASYM(iX)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iT,iV,iX)-nTUVES(jSYM)
          JSUP=KTUV(iU,iZ,iY)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(zyxvut) -> BA(vyz,xut)
        jSYM=Mul(IASYM(iV),Mul(IASYM(iY),IASYM(iZ)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iV,iY,iZ)-nTUVES(jSYM)
          JSUP=KTUV(iX,iU,iT)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(utzyxv) -> BA(ytu,zxv)
        jSYM=Mul(IASYM(iY),Mul(IASYM(iT),IASYM(iU)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iY,iT,iU)-nTUVES(jSYM)
          JSUP=KTUV(iZ,iX,iV)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
       ENDIF
C  - F(zyutxv) -> BA(tyz,uxv)
        jSYM=Mul(IASYM(iT),Mul(IASYM(iY),IASYM(iZ)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iT,iY,iZ)-nTUVES(jSYM)
          JSUP=KTUV(iU,iX,iV)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(xvzyut) -> BA(yvx,zut)
        jSYM=Mul(IASYM(iY),Mul(IASYM(iV),IASYM(iX)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iY,iV,iX)-nTUVES(jSYM)
          JSUP=KTUV(iZ,iU,iT)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BA(ISADR)=BA(ISADR)+F3VAL
          END IF
        ENDIF
      END DO

      END SUBROUTINE MKBA_F3

#ifdef _MOLCAS_MPP_
      SUBROUTINE MKBA_F3_MPP(ISYM,BA,iLo,iHi,jLo,jHi,LDA,
     &                       NG3,F3,idxG3)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp, Byte
      USE MPI
      USE SUPERINDEX, only: KTUV
      use stdalloc, only: mma_MaxDBLE
      use definitions, only: MPIInt,RtoB,wp
      use caspt2_module, only: IASYM,NASHT,NTUVES
      IMPLICIT NONE

#include "global.fh"
#include "mafdecls.fh"

      INTEGER(KIND=IWP), INTENT(IN):: ISYM,iLo,iHi,jLo,jHi,LDA,NG3
      REAL(KIND=WP), INTENT(INOUT):: BA(LDA,*)
      REAL(KIND=WP),INTENT(IN):: F3(NG3)
      INTEGER(KIND=Byte),INTENT(IN):: idxG3(6,NG3)

      integer(kind=MPIInt), ALLOCATABLE :: SCOUNTS(:), RCOUNTS(:)
      integer(kind=MPIInt), ALLOCATABLE :: SCOUNTS2(:), RCOUNTS2(:)
      integer(kind=MPIInt), ALLOCATABLE :: SDISPLS(:), RDISPLS(:)
      integer(kind=MPIInt), ALLOCATABLE :: SDISPLS2(:), RDISPLS2(:)

      integer(kind=MPIInt), ALLOCATABLE :: SENDIDX(:), RECVIDX(:)
      REAL(KIND=WP),    ALLOCATABLE :: SENDVAL(:), RECVVAL(:)

      integer(kind=MPIInt), PARAMETER :: ONE4=1, TWO4=2
      integer(kind=MPIInt) :: IERROR4
      INTEGER(KIND=IWP), PARAMETER :: I4=KIND(ONE4)

      INTEGER(KIND=IWP), ALLOCATABLE :: IBUF(:)
      INTEGER(KIND=IWP) NG3MAX,NPROCS,MYRANK,iscal,MAXBUF,NG3B,NBUF,NAS,
     &                  NQOT,NREM,NBLOCKS,IBLOCK,IG3STA,IG3END,MAXMEM,
     &                  IG3,IT,IU,IV,IX,IY,IZ,IST,ISU,ISV,ISX,ISY,ISZ,
     &                  ITUVS,IXYZS,ITU,IVX,IYZ,JSYM,IROW,IP,IOFFSET,I,
     &                  ICOL,NRECV,ISUP,JSUP
      REAL(KIND=WP) F3VAL

#include "mpi_interfaces.fh"

      ! Since we are stuck with collective calls to MPI_Alltoallv in
      ! order to gather the elements, each process needs to loop over
      ! the same number of blocks.
      NG3MAX=NG3
      CALL GAIGOP_SCAL(NG3MAX,'max')
      IF (NG3MAX.EQ.0) RETURN

      ! basic information
      NPROCS=GA_NNODES()
      MYRANK=GA_NODEID()

      ALLOCATE(SCOUNTS(NPROCS))
      ALLOCATE(RCOUNTS(NPROCS))
      ALLOCATE(SCOUNTS2(NPROCS))
      ALLOCATE(RCOUNTS2(NPROCS))
      ALLOCATE(SDISPLS(NPROCS))
      ALLOCATE(RDISPLS(NPROCS))
      ALLOCATE(SDISPLS2(NPROCS))
      ALLOCATE(RDISPLS2(NPROCS))

      ALLOCATE(IBUF(NPROCS))

      ! The global SA matrix has already been allocated, so we need to
      ! find out how much memory is left for buffering (4 equally sized
      ! buffers for sending and receiving values and indices)
      CALL mma_MaxDBLE(MAXMEM)
      iscal = (MPIInt*4 + wp*2)/RtoB
      MAXBUF=MIN(NINT(0.95D0*MAXMEM)/iscal,2000000000/8)

      ! Loop over blocks NG3B of NG3, so that 12*NG3B < MAXBUF/NPROCS.
      ! This guarantees that e.g. if all processes send all their data
      ! to one other, that process receives NPROCS*NG3B*12 elements
      ! in the receive buffer.
      NG3B=MAXBUF/(NPROCS*12)
      NG3B=MIN(NG3B,NG3MAX)
      CALL GAIGOP_SCAL(NG3B,'min')
      NBUF=12*NG3B

      ALLOCATE(SENDVAL(NBUF))
      ALLOCATE(SENDIDX(2*NBUF))

      ! Finally, we need some info on the layout of the global array in
      ! order to compute the process row of the row index.
      NAS=jHi-jLo+1
      NQOT=NAS/NPROCS
      NREM=NAS-NPROCS*NQOT

      NBLOCKS=(NG3MAX-1)/NG3B+1
      DO IBLOCK=1,NBLOCKS
        IG3STA=1+(IBLOCK-1)*NG3B
        IG3END=MIN(IG3STA+NG3B-1,NG3)

        SCOUNTS=0
        ! First pass to determine how many values will need to be sent
        ! to other processes. This is necessary to be able to allocate
        ! the buffer size and offsets.
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=Mul(IST,Mul(ISU,ISV))
          ixyzs=Mul(ISX,Mul(ISY,ISZ))
          if(ituvs.ne.ixyzs) CYCLE
          iTU=iT+NASHT*(iU-1)
          iVX=iV+NASHT*(iX-1)
          iYZ=iY+NASHT*(iZ-1)
          ! There are 12 equivalent cases, of which the second half
          ! reflects the S(tuv,xyz)=S(xyz,tuv) symmetry.

          ! - F(tuvxyz) -> BA(xut,vyz)
          jSYM=Mul(iSX,Mul(iSU,iST))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          if (.NOT.(iTU.eq.iVX.and.iVX.eq.iYZ)) THEN
          if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
          ! - F(vxtuyz) -> BA(uxv,tyz)
          jSYM=Mul(iSU,Mul(iSX,iSV))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - F(yzvxtu) -> BA(xzy,vtu)
          jSYM=Mul(iSX,Mul(iSZ,iSY))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - F(tuyzvx) -> BA(zut,yvx)
          jSYM=Mul(iSZ,Mul(iSU,iST))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ENDIF
          ! - F(yztuvx) -> BA(uzy,tvx)
          jSYM=Mul(iSU,Mul(iSZ,iSY))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - F(vxyztu) -> BA(zxv,ytu)
          jSYM=Mul(iSZ,Mul(iSX,iSV))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ENDIF
          if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) CYCLE
          if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) CYCLE
          if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) CYCLE
          if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) CYCLE
          ! - F(utxvzy) -> BA(vtu,xzy)
          jSYM=Mul(iSV,Mul(iST,iSU))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) CYCLE
          if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
          ! - F(xvutzy) -> BA(tvx,uzy)
          jSYM=Mul(iST,Mul(iSV,iSX))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - F(zyxvut) -> BA(vyz,xut)
          jSYM=Mul(iSV,Mul(iSY,iSZ))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - F(utzyxv) -> BA(ytu,zxv)
          jSYM=Mul(iSY,Mul(iST,iSU))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ENDIF
          ! - F(zyutxv) -> BA(tyz,uxv)
          jSYM=Mul(iST,Mul(iSY,iSZ))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          ! - F(xvzyut) -> BA(yvx,zut)
          jSYM=Mul(iSY,Mul(iSV,iSX))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
        END DO

        ! At this point, SCOUNTS contains the number of values generated
        ! for each process. Use them to determine the send offsets.
        IOFFSET=0
        DO I=1,NPROCS
          SDISPLS(I)=INT(IOFFSET,I4)
          IBUF(I)=IOFFSET
          IOFFSET=IOFFSET+SCOUNTS(I)
        END DO

        ! Second pass fills the buffers with values and indices
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=Mul(IST,Mul(ISU,ISV))
          ixyzs=Mul(ISX,Mul(ISY,ISZ))
          if(ituvs.ne.ixyzs) CYCLE
          iTU=iT+NASHT*(iU-1)
          iVX=iV+NASHT*(iX-1)
          iYZ=iY+NASHT*(iZ-1)
          F3VAL=-F3(iG3)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
C  - F(tuvxyz) -> BA(xut,vyz)
          jSYM=Mul(IASYM(iX),Mul(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iU,iT)-nTUVES(jSYM)
            ICOL=KTUV(iV,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          if (.NOT.(iTU.eq.iVX.and.iVX.eq.iYZ)) THEN
          if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(vxtuyz) -> BA(uxv,tyz)
          jSYM=Mul(IASYM(iU),Mul(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iX,iV)-nTUVES(jSYM)
            ICOL=KTUV(iT,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(yzvxtu) -> BA(xzy,vtu)
          jSYM=Mul(IASYM(iX),Mul(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iZ,iY)-nTUVES(jSYM)
            ICOL=KTUV(iV,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(tuyzvx) -> BA(zut,yvx)
          jSYM=Mul(IASYM(iZ),Mul(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iU,iT)-nTUVES(jSYM)
            ICOL=KTUV(iY,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          ENDIF
C  - F(yztuvx) -> BA(uzy,tvx)
          jSYM=Mul(IASYM(iU),Mul(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iZ,iY)-nTUVES(jSYM)
            ICOL=KTUV(iT,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(vxyztu) -> BA(zxv,ytu)
          jSYM=Mul(IASYM(iZ),Mul(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iX,iV)-nTUVES(jSYM)
            ICOL=KTUV(iY,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          ENDIF
          if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) CYCLE
          if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) CYCLE
          if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) CYCLE
          if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) CYCLE
C  - F(utxvzy) -> BA(vtu,xzy)
          jSYM=Mul(IASYM(iV),Mul(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iT,iU)-nTUVES(jSYM)
            ICOL=KTUV(iX,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) CYCLE
          if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(xvutzy) -> BA(tvx,uzy)
          jSYM=Mul(IASYM(iT),Mul(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iV,iX)-nTUVES(jSYM)
            ICOL=KTUV(iU,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(zyxvut) -> BA(vyz,xut)
          jSYM=Mul(IASYM(iV),Mul(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iY,iZ)-nTUVES(jSYM)
            ICOL=KTUV(iX,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(utzyxv) -> BA(ytu,zxv)
          jSYM=Mul(IASYM(iY),Mul(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iT,iU)-nTUVES(jSYM)
            ICOL=KTUV(iZ,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          ENDIF
C  - F(zyutxv) -> BA(tyz,uxv)
          jSYM=Mul(IASYM(iT),Mul(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iY,iZ)-nTUVES(jSYM)
            ICOL=KTUV(iU,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(xvzyut) -> BA(yvx,zut)
          jSYM=Mul(IASYM(iY),Mul(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iV,iX)-nTUVES(jSYM)
            ICOL=KTUV(iZ,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
        END DO

        ! Now we need to determine the receive counts.
        CALL MPI_ALLTOALL(SCOUNTS, ONE4, MPI_INTEGER,
     &                    RCOUNTS, ONE4, MPI_INTEGER,
     &                    MPI_COMM_WORLD, IERROR4)

        IOFFSET=0
        DO I=1,NPROCS
          RDISPLS(I)=INT(IOFFSET,I4)
          IOFFSET=IOFFSET+RCOUNTS(I)
          SCOUNTS2(I)=TWO4*SCOUNTS(I)
          RCOUNTS2(I)=TWO4*RCOUNTS(I)
          SDISPLS2(I)=TWO4*SDISPLS(I)
          RDISPLS2(I)=TWO4*RDISPLS(I)
        END DO
        NRECV=IOFFSET

        ALLOCATE(RECVVAL(NRECV))
        ALLOCATE(RECVIDX(2*NRECV))

        ! Now, it is time to collect the appropriate values and indices
        ! in their respective receive buffers.
        CALL MPI_ALLTOALLV(SENDVAL, SCOUNTS, SDISPLS, MPI_REAL8,
     &                     RECVVAL, RCOUNTS, RDISPLS, MPI_REAL8,
     &                     MPI_COMM_WORLD, IERROR4)
        CALL MPI_ALLTOALLV(SENDIDX, SCOUNTS2, SDISPLS2, MPI_INTEGER,
     &                     RECVIDX, RCOUNTS2, RDISPLS2, MPI_INTEGER,
     &                     MPI_COMM_WORLD, IERROR4)

        ! Finally, fill the local chunk of the SA matrix (block of rows)
        ! with the received values at their appropriate place.
        DO I=1,NRECV
          ISUP=RECVIDX(2*I-1)
          JSUP=RECVIDX(2*I)
          BA(ISUP-ILO+1,JSUP-JLO+1)=
     &      BA(ISUP-ILO+1,JSUP-JLO+1)+RECVVAL(I)
        END DO

        DEALLOCATE(RECVVAL)
        DEALLOCATE(RECVIDX)

      END DO ! end loop over blocks of F3 values

      DEALLOCATE(SENDVAL)
      DEALLOCATE(SENDIDX)

      DEALLOCATE(SCOUNTS)
      DEALLOCATE(RCOUNTS)
      DEALLOCATE(SCOUNTS2)
      DEALLOCATE(RCOUNTS2)
      DEALLOCATE(SDISPLS)
      DEALLOCATE(RDISPLS)
      DEALLOCATE(SDISPLS2)
      DEALLOCATE(RDISPLS2)

      DEALLOCATE(IBUF)

c Avoid unused argument warnings
      IF (.FALSE.) CALL UNUSED_INTEGER(iHi)

      CONTAINS

      PURE FUNCTION IPROW(IROW,NQOT,NREM)
      use definitions, only: iwp
      IMPLICIT NONE
      INTEGER(KIND=IWP) :: IPROW
      INTEGER(KIND=IWP), INTENT(IN) :: IROW, NQOT, NREM
      INTEGER(KIND=IWP) :: TMP
      TMP=IROW-NREM*(NQOT+1)
      IF (TMP.GT.0) THEN
        IPROW=(TMP-1)/NQOT+NREM+1
      ELSE
        IPROW=(IROW-1)/(NQOT+1)+1
      END IF
      END FUNCTION

      END SUBROUTINE MKBA_F3_MPP
#endif

********************************************************************************
* Case C (ICASE=4)
********************************************************************************
      SUBROUTINE MKBC(DREF,NDREF,PREF,NPREF,FD,FP,NG3,F3,idxG3)
      use definitions, only: iwp, wp, Byte
      use caspt2_global, only:iPrGlb
      use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      use fake_GA, only: GA_Arrays
      use caspt2_module, only: NSYM,NINDEP,NTUV
      IMPLICIT NONE
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif
      INTEGER(KIND=IWP), INTENT(IN):: NDREF, NPREF, NG3
      Real(KIND=WP), INTENT(IN):: DREF(NDREF),PREF(NPREF),F3(NG3)
      Real(KIND=WP), INTENT(IN):: FD(NDREF),FP(NPREF)
      INTEGER(KIND=Byte), INTENT(IN):: idxG3(6,NG3)
#ifdef _MOLCAS_MPP_
      Real(KIND=WP) Dummy(1)
      INTEGER(KIND=IWP) MYRANK,ILO,IHI,JLO,JHI,MA,LDA
#endif
      INTEGER(KIND=IWP) ICASE,ISYM,NIN,NAS,NBC,lg_BC
      Real(KIND=WP) DBC
      Real(KIND=WP), EXTERNAL:: PSBMAT_FPRINT

      ICASE=4
C LONG loop over superindex symmetry.
      DO ISYM=1,NSYM
        NIN=NINDEP(ISYM,ICASE)
        IF(NIN.EQ.0) CYCLE
        NAS=NTUV(ISYM)
        NBC=(NAS*(NAS+1))/2
        IF(NBC.LE.0) CYCLE

C Set up the matrix BC(tuv,xyz) defined by the expression
C <atuv|H0-E0|cxyz> = dac ( alpha(a) SC(tuv,xyz) + BC(tuv,xyz) )
C Formula used:
C    BC(tuv,xyz)
C    = Fvutxyz +dyu Fvztx + dyx Fvutz + dtu Fvxyz + dtu dyx Fvz
C    +(Ey+Eu-EASUM)*SC(tuv,xyz)
C    -Eu*( dyu Gvztx + dtu Gvxyz )
C    -Ey dyx Gvutz
C    -(Eu+Ey)*( dtu dyx Gvz )

C where dyu = Kronecker(y,u) etc. Gvutxyz=<Evutxyz>, etc.
C Similarly, Fvutxyz= Sum(w)(EPSA(w)<Evutxyzww>, etc.

        CALL PSBMAT_GETMEM('BC',lg_BC,NAS)
        CALL PSBMAT_READ('S',iCase,iSym,lg_BC,NAS)

        ! fill in the 3-el parts
#ifdef _MOLCAS_MPP_
        IF (IS_REAL_PAR()) THEN
          MYRANK = GA_NODEID()
          CALL GA_DISTRIBUTION (LG_BC,MYRANK,ILO,IHI,JLO,JHI)
          IF (JLO.NE.0 .AND. (JHI-JLO+1).NE.NAS) THEN
            WRITE(6,*) 'MKBC: MISMATCH IN RANGE OF THE SUPERINDICES'
            CALL ABEND()
          END IF
          IF (ILO.GT.0 .AND. JLO.GT.0) THEN
            CALL GA_ACCESS (LG_BC,ILO,IHI,JLO,JHI,MA,LDA)
            CALL MKBC_DP(DREF,NDREF,PREF,NPREF,FD,FP,iSYM,
     &                   DBL_MB(MA),ILO,IHI,JLO,JHI,LDA)
            CALL MKBC_F3_MPP(ISYM,DBL_MB(MA),ILO,IHI,JLO,JHI,LDA,
     &                       NG3,F3,IDXG3)
            CALL GA_RELEASE_UPDATE (LG_BC,ILO,IHI,JLO,JHI)
          ELSE
            CALL MKBC_F3_MPP(ISYM,DUMMY,ILO,IHI,JLO,JHI,LDA,
     &                       NG3,F3,IDXG3)
          END IF
        ELSE
#endif
          CALL MKBC_DP(DREF,NDREF,PREF,NPREF,FD,FP,
     &                 ISYM,GA_Arrays(lg_BC)%A(:),1,NAS,1,NAS,0)
          CALL MKBC_F3(ISYM,GA_Arrays(lg_BC)%A(:),NG3,F3,IDXG3)

#ifdef _MOLCAS_MPP_
        END IF
#endif

        CALL PSBMAT_WRITE('B',iCase,iSYM,lg_BC,NAS)

        IF(IPRGLB.GE.DEBUG) THEN
          DBC=PSBMAT_FPRINT(lg_BC,NAS)
          WRITE(6,'("DEBUG> ",A4,1X,I3,1X,ES21.14)') 'C', ISYM, DBC
        END IF

        CALL PSBMAT_FREEMEM(lg_BC)
      END DO

      END SUBROUTINE MKBC

      SUBROUTINE MKBC_DP (DREF,NDREF,PREF,NPREF,FD,FP,iSYM,
     &                    BC,iLo,iHi,jLo,jHi,LDC)
      use definitions, only: iwp, wp
      use constants, only: Half, Two, Four
      USE SUPERINDEX, only: MTUV
      use caspt2_global, only:ipea_shift
      use caspt2_module, only: EASUM,NASHT,NTUVES,EPSA
      IMPLICIT NONE
      INTEGER(KIND=IWP), intent(in):: NDREF,NPREF, iSYM,
     &                                iLo,iHi,jLo,jHi,LDC
      REAL(KIND=WP), intent(in):: DREF(NDREF),PREF(NPREF)
      REAL(KIND=WP), intent(in):: FD(NDREF),FP(NPREF)
      REAL(KIND=WP), intent(inout):: BC(*)

      INTEGER(KIND=IWP) IXYZ,IXYZABS,IXABS,IYABS,IZABS,ITUV,ITUVABS,
     &                  ITABS,IUABS,IVABS,ISADR,IVZ,ITX,IVU,ITZ,IP1,
     &                  IP2,IP,ID1,ID2,ID,IDT,IDU,IDV,IVX,IYZ
      REAL(KIND=WP) EY,EU, EYU, FACT, VALUE

      DO IXYZ=jLo,jHi
        IXYZABS=IXYZ+NTUVES(ISYM)
        IXABS=MTUV(1,IXYZABS)
        IYABS=MTUV(2,IXYZABS)
        IZABS=MTUV(3,IXYZABS)
        EY=EPSA(IYABS)
        DO ITUV=iLo,iHi
          ITUVABS=ITUV+NTUVES(ISYM)
          ITABS=MTUV(1,ITUVABS)
          IUABS=MTUV(2,ITUVABS)
          IVABS=MTUV(3,ITUVABS)
          EU=EPSA(IUABS)
          EYU=EY + EU
          FACT=EYU-EASUM
          ISADR=1+iTUV-iLo+LDC*(iXYZ-jLo)
          IF (LDC.EQ.0) THEN
            IF (iXYZ.LE.iTUV) THEN
              ISADR=(ITUV*(ITUV-1))/2+IXYZ
            ELSE
              CYCLE
            END IF
          END IF
          VALUE=FACT*BC(ISADR)
C VALUE= Fvutxyz + (EPSA(y)+EPSA(u))*SC(tuv,xyz)
C Add  dyu ( Fvztx - EPSA(u)*Gvztx )
          IF(IYABS.EQ.IUABS) THEN
            IVZ=IVABS+NASHT*(IZABS-1)
            ITX=ITABS+NASHT*(IXABS-1)
            IP1=MAX(IVZ,ITX)
            IP2=MIN(IVZ,ITX)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE+Two*(FP(IP)-EU*PREF(IP))
          END IF
C Add  dyx ( Fvutz - EPSA(y)*Gvutz )
          IF(IYABS.EQ.IXABS) THEN
            IVU=IVABS+NASHT*(IUABS-1)
            ITZ=ITABS+NASHT*(IZABS-1)
            IP1=MAX(IVU,ITZ)
            IP2=MIN(IVU,ITZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE+Two*(FP(IP)-EY*PREF(IP))
          END IF
C Add  dtu ( Fvxyz - EPSA(u)*Gvxyz + dyx Fvz -
C             (EPSA(u)+EPSA(y)*dyz Gvz)
          IF(ITABS.EQ.IUABS) THEN
            IVX=IVABS+NASHT*(IXABS-1)
            IYZ=IYABS+NASHT*(IZABS-1)
            IP1=MAX(IVX,IYZ)
            IP2=MIN(IVX,IYZ)
            IP=(IP1*(IP1-1))/2+IP2
            VALUE=VALUE+Two*(FP(IP)-EU*PREF(IP))
            IF(IYABS.EQ.IXABS) THEN
              ID1=MAX(IVABS,IZABS)
              ID2=MIN(IVABS,IZABS)
              ID=(ID1*(ID1-1))/2+ID2
              VALUE=VALUE+FD(ID)-EYU*DREF(ID)
            END IF
          END IF
CGG.Nov03
          IF (ITUV.eq.IXYZ) THEN
            IDT=(ITABS*(ITABS+1))/2
            IDU=(IUABS*(IUABS+1))/2
            IDV=(IVABS*(IVABS+1))/2
            VALUE=VALUE+ipea_shift*Half*BC(ISADR)*
     &                    (Four-DREF(IDT)-DREF(IDV)+DREF(IDU))
          ENDIF
CGG End
          BC(ISADR)=VALUE
        END DO
      END DO
      END SUBROUTINE MKBC_DP

      SUBROUTINE MKBC_F3(ISYM,BC,NG3,F3,idxG3)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp, Byte
      USE SUPERINDEX, only: KTUV
      use caspt2_module, only: NASHT,IASYM,nTUVES
      IMPLICIT NONE

      INTEGER(KIND=IWP), INTENT(IN):: ISYM, NG3
      REAL(KIND=WP), INTENT(INOUT):: BC(*)
      REAL(KIND=WP), INTENT(IN):: F3(NG3)
      INTEGER(KIND=BYTE), INTENT(IN):: idxG3(6,NG3)

      INTEGER(KIND=IWP) iG3,iT,iU,iV,iX,iY,iZ,iST,iSU,iSV,iSX,iSY,iSZ,
     &                  ituvs,ixyzs,iTU,iVX,iYZ,jSYM,ISUP,JSUP,ISADR
      REAL(KIND=WP) F3VAL

C-SVC20100831: determine indices in BC where a certain G3 value will end up
      DO iG3=1,NG3
        iT=idxG3(1,iG3)
        iU=idxG3(2,iG3)
        iV=idxG3(3,iG3)
        iX=idxG3(4,iG3)
        iY=idxG3(5,iG3)
        iZ=idxG3(6,iG3)
        iST=IASYM(iT)
        iSU=IASYM(iU)
        iSV=IASYM(iV)
        iSX=IASYM(iX)
        iSY=IASYM(iY)
        iSZ=IASYM(iZ)
        ituvs=Mul(IST,Mul(ISU,ISV))
        ixyzs=Mul(ISX,Mul(ISY,ISZ))
        if(ituvs.ne.ixyzs) CYCLE
        iTU=iT+NASHT*(iU-1)
        iVX=iV+NASHT*(iX-1)
        iYZ=iY+NASHT*(iZ-1)
        F3VAL=F3(iG3)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
C  - F(tuvxyz) -> BC(vut,xyz)
        jSYM=Mul(IASYM(iV),Mul(IASYM(iU),IASYM(iT)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iV,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iX,iY,iZ)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
        if (.NOT.(iTU.eq.iVX.and.iVX.eq.iYZ)) THEN
        if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(vxtuyz) -> BC(txv,uyz)
        jSYM=Mul(IASYM(iT),Mul(IASYM(iX),IASYM(iV)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iT,iX,iV)-nTUVES(jSYM)
          JSUP=KTUV(iU,iY,iZ)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(yzvxtu) -> BC(vzy,xtu)
        jSYM=Mul(IASYM(iV),Mul(IASYM(iZ),IASYM(iY)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iV,iZ,iY)-nTUVES(jSYM)
          JSUP=KTUV(iX,iT,iU)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(tuyzvx) -> BC(yut,zvx)
        jSYM=Mul(IASYM(iY),Mul(IASYM(iU),IASYM(iT)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iY,iU,iT)-nTUVES(jSYM)
          JSUP=KTUV(iZ,iV,iX)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
       ENDIF
C  - F(yztuvx) -> BC(tzy,uvx)
        jSYM=Mul(IASYM(iT),Mul(IASYM(iZ),IASYM(iY)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iT,iZ,iY)-nTUVES(jSYM)
          JSUP=KTUV(iU,iV,iX)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(vxyztu) -> BC(yxv,ztu)
        jSYM=Mul(IASYM(iY),Mul(IASYM(iX),IASYM(iV)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iY,iX,iV)-nTUVES(jSYM)
          JSUP=KTUV(iZ,iT,iU)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
       ENDIF
        if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) CYCLE
        if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) CYCLE
        if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) CYCLE
        if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) CYCLE
C  - F(utxvzy) -> BC(xtu,vzy)
        jSYM=Mul(IASYM(iX),Mul(IASYM(iT),IASYM(iU)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iX,iT,iU)-nTUVES(jSYM)
          JSUP=KTUV(iV,iZ,iY)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
        if (iTU.eq.iVX.and.iVX.eq.iYZ) CYCLE
        if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(xvutzy) -> BC(uvx,tzy)
        jSYM=Mul(IASYM(iU),Mul(IASYM(iV),IASYM(iX)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iU,iV,iX)-nTUVES(jSYM)
          JSUP=KTUV(iT,iZ,iY)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(zyxvut) -> BC(xyz,vut)
        jSYM=Mul(IASYM(iX),Mul(IASYM(iY),IASYM(iZ)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iX,iY,iZ)-nTUVES(jSYM)
          JSUP=KTUV(iV,iU,iT)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(utzyxv) -> BC(ztu,yxv)
        jSYM=Mul(IASYM(iZ),Mul(IASYM(iT),IASYM(iU)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iZ,iT,iU)-nTUVES(jSYM)
          JSUP=KTUV(iY,iX,iV)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
       ENDIF
C  - F(zyutxv) -> BC(uyz,txv)
        jSYM=Mul(IASYM(iU),Mul(IASYM(iY),IASYM(iZ)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iU,iY,iZ)-nTUVES(jSYM)
          JSUP=KTUV(iT,iX,iV)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
C  - F(xvzyut) -> BC(zvx,yut)
        jSYM=Mul(IASYM(iZ),Mul(IASYM(iV),IASYM(iX)))
        IF (jSYM.EQ.iSYM) THEN
          ISUP=KTUV(iZ,iV,iX)-nTUVES(jSYM)
          JSUP=KTUV(iY,iU,iT)-nTUVES(jSYM)
          IF (JSUP.LE.ISUP) THEN
            ISADR=(ISUP*(ISUP-1))/2+JSUP
            BC(ISADR)=BC(ISADR)+F3VAL
          END IF
        ENDIF
      END DO

      END SUBROUTINE MKBC_F3

#ifdef _MOLCAS_MPP_
      SUBROUTINE MKBC_F3_MPP(ISYM,BC,iLo,iHi,jLo,jHi,LDC,
     &                       NG3,F3,idxG3)
      use Symmetry_Info, only: Mul
      use definitions, only: iwp, wp, Byte
      USE MPI
      USE SUPERINDEX, only: KTUV
      use stdalloc, only: mma_MaxDBLE
      use definitions, only: MPIInt,RtoB,wp
      use caspt2_module, only: IASYM,NASHT,NTUVES
      IMPLICIT NONE

#include "global.fh"
#include "mafdecls.fh"

      INTEGER(KIND=IWP), INTENT(IN):: ISYM,iLo,iHi,jLo,jHi,LDC,NG3
      REAL(KIND=WP), INTENT(INOUT):: BC(LDC,*)
      REAL(KIND=WP), INTENT(IN):: F3(NG3)
      INTEGER(kind=Byte),INTENT(IN):: idxG3(6,NG3)

      integer(kind=MPIInt), ALLOCATABLE :: SCOUNTS(:), RCOUNTS(:)
      integer(kind=MPIInt), ALLOCATABLE :: SCOUNTS2(:), RCOUNTS2(:)
      integer(kind=MPIInt), ALLOCATABLE :: SDISPLS(:), RDISPLS(:)
      integer(kind=MPIInt), ALLOCATABLE :: SDISPLS2(:), RDISPLS2(:)

      integer(kind=MPIInt), ALLOCATABLE :: SENDIDX(:), RECVIDX(:)
      real(kind=wp),    ALLOCATABLE :: SENDVAL(:), RECVVAL(:)

      integer(kind=MPIInt), PARAMETER :: ONE4=1, TWO4=2
      integer(kind=MPIInt) :: IERROR4
      INTEGER(KIND=IWP), PARAMETER :: I4=KIND(ONE4)

      INTEGER(KIND=IWP), ALLOCATABLE :: IBUF(:)
      INTEGER(KIND=IWP) NG3MAX,NPROCS,MYRANK,iscal,MAXBUF,NG3B,NBUF,NAS,
     &                  NQOT,NREM,NBLOCKS,IBLOCK,IG3STA,IG3END,MAXMEM,
     &                  IT,IG3,IU,IV,IX,IY,IZ,IST,ISU,ISV,ISX,ISY,ISZ,
     &                  ITUVS,IXYZS,ITU,IVX,IYZ,JSYM,IROW,IP,IOFFSET,I,
     &                  ICOL,NRECV,ISUP,JSUP
      real(kind=wp) F3VAL

#include "mpi_interfaces.fh"

      ! Since we are stuck with collective calls to MPI_Alltoallv in
      ! order to gather the elements, each process needs to loop over
      ! the same number of blocks.
      NG3MAX=NG3
      CALL GAIGOP_SCAL(NG3MAX,'max')
      IF (NG3MAX.EQ.0) RETURN

      ! basic information
      NPROCS=GA_NNODES()
      MYRANK=GA_NODEID()

      ALLOCATE(SCOUNTS(NPROCS))
      ALLOCATE(RCOUNTS(NPROCS))
      ALLOCATE(SCOUNTS2(NPROCS))
      ALLOCATE(RCOUNTS2(NPROCS))
      ALLOCATE(SDISPLS(NPROCS))
      ALLOCATE(RDISPLS(NPROCS))
      ALLOCATE(SDISPLS2(NPROCS))
      ALLOCATE(RDISPLS2(NPROCS))

      ALLOCATE(IBUF(NPROCS))

      ! The global SC matrix has already been allocated, so we need to
      ! find out how much memory is left for buffering (4 equally sized
      ! buffers for sending and receiving values and indices)
      CALL mma_MaxDBLE(MAXMEM)
      iscal = (MPIInt*4 + wp*2)/RtoB
      MAXBUF=MIN(NINT(0.95D0*MAXMEM)/iscal,2000000000/8)

      ! Loop over blocks NG3B of NG3, so that 12*NG3B < MAXBUF/NPROCS.
      ! This guarantees that e.g. if all processes send all their data
      ! to one other, that process receives NPROCS*NG3B*12 elements
      ! in the receive buffer.
      NG3B=MAXBUF/(NPROCS*12)
      NG3B=MIN(NG3B,NG3MAX)
      CALL GAIGOP_SCAL(NG3B,'min')
      NBUF=12*NG3B

      ALLOCATE(SENDVAL(NBUF))
      ALLOCATE(SENDIDX(2*NBUF))

      ! Finally, we need some info on the layout of the global array in
      ! order to compute the process row of the row index.
      NAS=jHi-jLo+1
      NQOT=NAS/NPROCS
      NREM=NAS-NPROCS*NQOT

      NBLOCKS=(NG3MAX-1)/NG3B+1
      DO IBLOCK=1,NBLOCKS
        IG3STA=1+(IBLOCK-1)*NG3B
        IG3END=MIN(IG3STA+NG3B-1,NG3)

        SCOUNTS=0
        ! First pass to determine how many values will need to be sent
        ! to other processes. This is necessary to be able to allocate
        ! the buffer size and offsets.
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=Mul(IST,Mul(ISU,ISV))
          ixyzs=Mul(ISX,Mul(ISY,ISZ))
          if(ituvs.ne.ixyzs) CYCLE
          iTU=iT+NASHT*(iU-1)
          iVX=iV+NASHT*(iX-1)
          iYZ=iY+NASHT*(iZ-1)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the B(tuv,xyz)=B(xyz,tuv) symmetry:
C  - F(tuvxyz) -> BC(vut,xyz)
          jSYM=Mul(IASYM(iV),Mul(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          if (.NOT.(iTU.eq.iVX.and.iVX.eq.iYZ)) THEN
          if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(vxtuyz) -> BC(txv,uyz)
          jSYM=Mul(IASYM(iT),Mul(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - F(yzvxtu) -> BC(vzy,xtu)
          jSYM=Mul(IASYM(iV),Mul(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - F(tuyzvx) -> BC(yut,zvx)
          jSYM=Mul(IASYM(iY),Mul(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
       ENDIF
C  - F(yztuvx) -> BC(tzy,uvx)
          jSYM=Mul(IASYM(iT),Mul(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - F(vxyztu) -> BC(yxv,ztu)
          jSYM=Mul(IASYM(iY),Mul(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
       ENDIF
          if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) CYCLE
          if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) CYCLE
          if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) CYCLE
          if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) CYCLE
C  - F(utxvzy) -> BC(xtu,vzy)
          jSYM=Mul(IASYM(iX),Mul(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) CYCLE
          if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(xvutzy) -> BC(uvx,tzy)
          jSYM=Mul(IASYM(iU),Mul(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - F(zyxvut) -> BC(xyz,vut)
          jSYM=Mul(IASYM(iX),Mul(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - F(utzyxv) -> BC(ztu,yxv)
          jSYM=Mul(IASYM(iZ),Mul(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
       ENDIF
C  - F(zyutxv) -> BC(uyz,txv)
          jSYM=Mul(IASYM(iU),Mul(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
C  - F(xvzyut) -> BC(zvx,yut)
          jSYM=Mul(IASYM(iZ),Mul(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            SCOUNTS(IP)=SCOUNTS(IP)+ONE4
          ENDIF
        END DO

        ! At this point, SCOUNTS contains the number of values generated
        ! for each process. Use them to determine the send offsets.
        IOFFSET=0
        DO I=1,NPROCS
          SDISPLS(I)=INT(IOFFSET,I4)
          IBUF(I)=IOFFSET
          IOFFSET=IOFFSET+SCOUNTS(I)
        END DO

        ! Second pass fills the buffers with values and indices
        DO iG3=IG3STA,IG3END
          iT=idxG3(1,iG3)
          iU=idxG3(2,iG3)
          iV=idxG3(3,iG3)
          iX=idxG3(4,iG3)
          iY=idxG3(5,iG3)
          iZ=idxG3(6,iG3)
          iST=IASYM(iT)
          iSU=IASYM(iU)
          iSV=IASYM(iV)
          iSX=IASYM(iX)
          iSY=IASYM(iY)
          iSZ=IASYM(iZ)
          ituvs=Mul(IST,Mul(ISU,ISV))
          ixyzs=Mul(ISX,Mul(ISY,ISZ))
          if(ituvs.ne.ixyzs) CYCLE
          iTU=iT+NASHT*(iU-1)
          iVX=iV+NASHT*(iX-1)
          iYZ=iY+NASHT*(iZ-1)
          F3VAL=F3(iG3)
C-SVC20100829: 12 equivalent cases, of which the second
C  half reflects the S(tuv,xyz)=S(xyz,tuv) symmetry:
C  - F(tuvxyz) -> BC(vut,xyz)
          jSYM=Mul(IASYM(iV),Mul(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iU,iT)-nTUVES(jSYM)
            ICOL=KTUV(iX,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          if (.NOT.(iTU.eq.iVX.and.iVX.eq.iYZ)) THEN
          if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(vxtuyz) -> BC(txv,uyz)
          jSYM=Mul(IASYM(iT),Mul(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iX,iV)-nTUVES(jSYM)
            ICOL=KTUV(iU,iY,iZ)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(yzvxtu) -> BC(vzy,xtu)
          jSYM=Mul(IASYM(iV),Mul(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iV,iZ,iY)-nTUVES(jSYM)
            ICOL=KTUV(iX,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(tuyzvx) -> BC(yut,zvx)
          jSYM=Mul(IASYM(iY),Mul(IASYM(iU),IASYM(iT)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iU,iT)-nTUVES(jSYM)
            ICOL=KTUV(iZ,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
       ENDIF
C  - F(yztuvx) -> BC(tzy,uvx)
          jSYM=Mul(IASYM(iT),Mul(IASYM(iZ),IASYM(iY)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iT,iZ,iY)-nTUVES(jSYM)
            ICOL=KTUV(iU,iV,iX)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(vxyztu) -> BC(yxv,ztu)
          jSYM=Mul(IASYM(iY),Mul(IASYM(iX),IASYM(iV)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iY,iX,iV)-nTUVES(jSYM)
            ICOL=KTUV(iZ,iT,iU)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
       ENDIF
          if (iT.eq.iU.and.iV.eq.iX.and.iY.eq.iZ) CYCLE
          if (iT.eq.iU.and.iV.eq.iZ.and.iX.eq.iY) CYCLE
          if (iX.eq.iV.and.iT.eq.iZ.and.iU.eq.iY) CYCLE
          if (iZ.eq.iY.and.iV.eq.iU.and.iX.eq.iT) CYCLE
C  - F(utxvzy) -> BC(xtu,vzy)
          jSYM=Mul(IASYM(iX),Mul(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iT,iU)-nTUVES(jSYM)
            ICOL=KTUV(iV,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
          if (iTU.eq.iVX.and.iVX.eq.iYZ) CYCLE
          if (.NOT.(iTU.eq.iVX.or.iTU.eq.iYZ.or.iVX.eq.iYZ)) THEN
C  - F(xvutzy) -> BC(uvx,tzy)
          jSYM=Mul(IASYM(iU),Mul(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iV,iX)-nTUVES(jSYM)
            ICOL=KTUV(iT,iZ,iY)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(zyxvut) -> BC(xyz,vut)
          jSYM=Mul(IASYM(iX),Mul(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iX,iY,iZ)-nTUVES(jSYM)
            ICOL=KTUV(iV,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(utzyxv) -> BC(ztu,yxv)
          jSYM=Mul(IASYM(iZ),Mul(IASYM(iT),IASYM(iU)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iT,iU)-nTUVES(jSYM)
            ICOL=KTUV(iY,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
       ENDIF
C  - F(zyutxv) -> BC(uyz,txv)
          jSYM=Mul(IASYM(iU),Mul(IASYM(iY),IASYM(iZ)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iU,iY,iZ)-nTUVES(jSYM)
            ICOL=KTUV(iT,iX,iV)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
C  - F(xvzyut) -> BC(zvx,yut)
          jSYM=Mul(IASYM(iZ),Mul(IASYM(iV),IASYM(iX)))
          IF (jSYM.EQ.iSYM) THEN
            IROW=KTUV(iZ,iV,iX)-nTUVES(jSYM)
            ICOL=KTUV(iY,iU,iT)-nTUVES(jSYM)
            IP=IPROW(IROW,NQOT,NREM)
            IBUF(IP)=IBUF(IP)+1
            SENDVAL(IBUF(IP))=F3VAL
            SENDIDX(2*IBUF(IP)-1)=INT(IROW,I4)
            SENDIDX(2*IBUF(IP))=INT(ICOL,I4)
          ENDIF
        END DO

        ! Now we need to determine the receive counts.
        CALL MPI_ALLTOALL(SCOUNTS, ONE4, MPI_INTEGER,
     &                    RCOUNTS, ONE4, MPI_INTEGER,
     &                    MPI_COMM_WORLD, IERROR4)

        IOFFSET=0
        DO I=1,NPROCS
          RDISPLS(I)=INT(IOFFSET,I4)
          IOFFSET=IOFFSET+RCOUNTS(I)
          SCOUNTS2(I)=TWO4*SCOUNTS(I)
          RCOUNTS2(I)=TWO4*RCOUNTS(I)
          SDISPLS2(I)=TWO4*SDISPLS(I)
          RDISPLS2(I)=TWO4*RDISPLS(I)
        END DO
        NRECV=IOFFSET

        ALLOCATE(RECVVAL(NRECV))
        ALLOCATE(RECVIDX(2*NRECV))

        ! Now, it is time to collect the appropriate values and indices
        ! in their respective receive buffers.
        CALL MPI_ALLTOALLV(SENDVAL, SCOUNTS, SDISPLS, MPI_REAL8,
     &                     RECVVAL, RCOUNTS, RDISPLS, MPI_REAL8,
     &                     MPI_COMM_WORLD, IERROR4)
        CALL MPI_ALLTOALLV(SENDIDX, SCOUNTS2, SDISPLS2, MPI_INTEGER,
     &                     RECVIDX, RCOUNTS2, RDISPLS2, MPI_INTEGER,
     &                     MPI_COMM_WORLD, IERROR4)

        ! Finally, fill the local chunk of the SC matrix (block of rows)
        ! with the received values at their appropriate place.
        DO I=1,NRECV
          ISUP=RECVIDX(2*I-1)
          JSUP=RECVIDX(2*I)
          BC(ISUP-ILO+1,JSUP-JLO+1)=
     &      BC(ISUP-ILO+1,JSUP-JLO+1)+RECVVAL(I)
        END DO

        DEALLOCATE(RECVVAL)
        DEALLOCATE(RECVIDX)

      END DO ! end loop over blocks of G3 values

      DEALLOCATE(SENDVAL)
      DEALLOCATE(SENDIDX)

      DEALLOCATE(SCOUNTS)
      DEALLOCATE(RCOUNTS)
      DEALLOCATE(SCOUNTS2)
      DEALLOCATE(RCOUNTS2)
      DEALLOCATE(SDISPLS)
      DEALLOCATE(RDISPLS)
      DEALLOCATE(SDISPLS2)
      DEALLOCATE(RDISPLS2)

      DEALLOCATE(IBUF)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL UNUSED_INTEGER(iHi)

      CONTAINS

      PURE FUNCTION IPROW(IROW,NQOT,NREM)
      use definitions, only: iwp
      INTEGER(KIND=IWP) IPROW
      INTEGER(KIND=IWP), INTENT(IN) :: IROW, NQOT, NREM
      INTEGER(KIND=IWP) :: TMP
      TMP=IROW-NREM*(NQOT+1)
      IF (TMP.GT.0) THEN
        IPROW=(TMP-1)/NQOT+NREM+1
      ELSE
        IPROW=(IROW-1)/(NQOT+1)+1
      END IF
      END FUNCTION

      END SUBROUTINE MKBC_F3_MPP
#endif

      SUBROUTINE MKBB(DREF,NDREF,PREF,NPREF,FD,FP)
      use definitions, only: iwp, wp
      use constants, only: Half, Two, Four, Eight
      USE SUPERINDEX, only: MTU, MTGEU, KTU, KTGTU
      use caspt2_global, only:ipea_shift
      use caspt2_global, only: LUSBT
      use EQSOLV, only: IDSMAT,IDBMAT
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM,NINDEP,NTU,NTUES,NASHT,EASUM,
     &                         EPSA,NTGEU,NTGEUES,NTGTU,NTGTUES
      IMPLICIT None

      INTEGER(KIND=IWP), INTENT(IN):: NDREF,NPREF
      REAL(KIND=WP), INTENT(IN):: DREF(NDREF),PREF(NPREF)
      REAL(KIND=WP), INTENT(IN):: FD(NDREF),FP(NPREF)

      REAL(KIND=WP), ALLOCATABLE:: BB(:), BBP(:), SP(:), SDP(:),
     &                             BBM(:), SM(:), SDM(:)

      INTEGER(KIND=IWP) ISYM,NINP,NAS,NBB,ITU,ITUABS,ITABS,IUABS,IXY,
     &                  IXYABS,IXABS,IYABS,IBADR,IXT,IYU,IP1,IP2,IP,I,
     &                  IBMADR,IBPADR,ID,ID1,ID2,IDIAG,IDISK,IDSM,IDSP,
     &                  IDT,IDU,INSM,ITGEU,ITGEUABS,ITGTU,IXGEY,
     &                  IXGEYABS,IXGTY,IYX,NASM,NASP,NBBM,NBBP,NSM,NSP
      REAL(KIND=WP) ET,EU,EX,EY,ATUXY,ATUX,ATYU,ATUY,ATYX,BTUYX,
     &              BTUXY,VALUE
C Set up the matrices BBP(tu,xy) and BBM(tu,xy)
C Formulae used:
C    BB(tu,xy)= 2*( Fyuxt - (A-Et-Eu-Ex-Ey)*Gyuxt )
C      + 4*dxt ( (A-Et-Ey-Eu)*Dyu - Fyu)
C      + 4*dyu ( (A-Et-Ey-Ex)*Dxt - Fxt)
C      - 2*dyt ( (A-Et-Eu-Ex)*Dxu - Fxu)
C      - 2*dxu ( (A-Et-Eu-Ey)*Dyt - Fyt)
C      + 8*dxt*dyu (Et+Ey)
C      - 4*dxu*dyt (Et+Ex)
C where A= EASUM= sum over active w of (Ew*Dww).
C    BBP(tu,xy)=BB(tu,xy)+BB(tu,yx)
C    BBM(tu,xy)=BB(tu,xy)-BB(tu,yx)


C Loop over superindex symmetry.
      DO ISYM=1,NSYM
        NINP=NINDEP(ISYM,2)
        IF(NINP.EQ.0) CYCLE
        NAS=NTU(ISYM)
        NBB=(NAS*(NAS+1))/2
        IF(NBB.GT.0) THEN
          CALL mma_allocate(BB,NBB,Label='BB')
        END IF
        DO ITU=1,NAS
          ITUABS=ITU+NTUES(ISYM)
          ITABS=MTU(1,ITUABS)
          IUABS=MTU(2,ITUABS)
          ET=EPSA(ITABS)
          EU=EPSA(IUABS)
          DO IXY=1,ITU
            IXYABS=IXY+NTUES(ISYM)
            IXABS=MTU(1,IXYABS)
            IYABS=MTU(2,IXYABS)
            EX=EPSA(IXABS)
            EY=EPSA(IYABS)
            IBADR=(ITU*(ITU-1))/2+IXY
            IXT=IXABS+NASHT*(ITABS-1)
            IYU=IYABS+NASHT*(IUABS-1)
            IP1=MAX(IXT,IYU)
            IP2=MIN(IXT,IYU)
            IP=(IP1*(IP1-1))/2+IP2
            ATUXY=EASUM-ET-EU-EX-EY
            VALUE=Four*(FP(IP)-ATUXY*PREF(IP))
C Add  + 4*dxt ( (A-Et-Ey-Eu)*Dyu - Fyu)
            IF(IXABS.EQ.ITABS) THEN
              ID1=MAX(IYABS,IUABS)
              ID2=MIN(IYABS,IUABS)
              ID=(ID1*(ID1-1))/2+ID2
              ATYU=EASUM-ET-EY-EU
              VALUE=VALUE+Four*(ATYU*DREF(ID)-FD(ID))
C Add  + 8*dxt*dyu (Et+Ey)
              IF(IYABS.EQ.IUABS) THEN
                VALUE=VALUE+Eight*(ET+EY)
              END IF
            END IF
C Add  + 4*dyu ( (A-Et-Ey-Ex)*Dxt - Fxt)
            IF(IYABS.EQ.IUABS) THEN
              ID1=MAX(IXABS,ITABS)
              ID2=MIN(IXABS,ITABS)
              ID=(ID1*(ID1-1))/2+ID2
              ATYX=EASUM-ET-EY-EX
              VALUE=VALUE+Four*(ATYX*DREF(ID)-FD(ID))
            END IF
C Add  - 2*dyt ( (A-Et-Eu-Ex)*Dxu - Fxu)
            IF(IYABS.EQ.ITABS) THEN
              ID1=MAX(IXABS,IUABS)
              ID2=MIN(IXABS,IUABS)
              ID=(ID1*(ID1-1))/2+ID2
              ATUX=EASUM-ET-EU-EX
              VALUE=VALUE-Two*(ATUX*DREF(ID)-FD(ID))
C Add  - 4*dxu*dyt (Et+Ex)
              IF(IXABS.EQ.IUABS) THEN
                VALUE=VALUE-Four*(ET+EX)
              END IF
            END IF
C Add  - 2*dxu ( (A-Et-Eu-Ey)*Dyt - Fyt)
            IF(IXABS.EQ.IUABS) THEN
              ID1=MAX(IYABS,ITABS)
              ID2=MIN(IYABS,ITABS)
              ID=(ID1*(ID1-1))/2+ID2
              ATUY=EASUM-ET-EU-EY
              VALUE=VALUE-Two*(ATUY*DREF(ID)-FD(ID))
            END IF
            BB(IBADR)=VALUE
          END DO
        END DO
        NASP=NTGEU(ISYM)
        NBBP=(NASP*(NASP+1))/2
        IF(NBBP.GT.0) THEN
          CALL mma_allocate(BBP,NBBP,Label='BBP')
CGG.Nov03  Load in SDP the diagonal elements of SBP matrix:
          NSP=(NASP*(NASP+1))/2
          CALL mma_allocate(SP,NSP,Label='SP')
          CALL mma_allocate(SDP,NASP,Label='SDP')
          IDSP=IDSMAT(ISYM,2)
          CALL DDAFILE(LUSBT,2,SP,NSP,IDSP)
          IDIAG=0
          DO I=1,NASP
            IDIAG=IDIAG+I
            SDP(I)=SP(IDIAG)
          END DO
          CALL mma_deallocate(SP)
CGG End
        END IF
        NASM=NTGTU(ISYM)
        NBBM=(NASM*(NASM+1))/2
        IF(NBBM.GT.0) THEN
          CALL mma_allocate(BBM,NBBM,Label='BBM')
CGG.Nov03  Load in SDM the diagonal elements of SBM matrix:
          NSM=(NASM*(NASM+1))/2
          CALL mma_allocate(SM,NSM,Label='SM')
          CALL mma_allocate(SDM,NASM,Label='SDM')
          IDSM=IDSMAT(ISYM,3)
          CALL DDAFILE(LUSBT,2,SM,NSM,IDSM)
          IDIAG=0
          DO I=1,NASM
            IDIAG=IDIAG+I
            SDM(I)=SM(IDIAG)
          END DO
          CALL mma_deallocate(SM)
CGG End
        END IF
        INSM=1
        DO ITGEU=1,NASP
          ITGEUABS=ITGEU+NTGEUES(ISYM)
          ITABS=MTGEU(1,ITGEUABS)
          IUABS=MTGEU(2,ITGEUABS)
          ITU=KTU(ITABS,IUABS)-NTUES(ISYM)
          DO IXGEY=1,ITGEU
            IXGEYABS=IXGEY+NTGEUES(ISYM)
            IXABS=MTGEU(1,IXGEYABS)
            IYABS=MTGEU(2,IXGEYABS)
            IXY=KTU(IXABS,IYABS)-NTUES(ISYM)
            IYX=KTU(IYABS,IXABS)-NTUES(ISYM)
            IF(ITU.GE.IXY) THEN
              IBADR=(ITU*(ITU-1))/2+IXY
            ELSE
              IBADR=(IXY*(IXY-1))/2+ITU
            END IF
            BTUXY=BB(IBADR)
            IF(ITU.GE.IYX) THEN
              IBADR=(ITU*(ITU-1))/2+IYX
            ELSE
              IBADR=(IYX*(IYX-1))/2+ITU
            END IF
            BTUYX=BB(IBADR)
            IBPADR=(ITGEU*(ITGEU-1))/2+IXGEY
            BBP(IBPADR)=BTUXY+BTUYX
CGG.Nov03
            IF (ITGEU.eq.IXGEY) THEN
              IDT=(ITABS*(ITABS+1))/2
              IDU=(IUABS*(IUABS+1))/2
              BBP(IBPADR)=BBP(IBPADR)+ipea_shift*half*
     &                          (DREF(IDT)+DREF(IDU))*SDP(ITGEU)
            ENDIF
CGG End
            IF(ITABS.EQ.IUABS) CYCLE
            IF(IXABS.EQ.IYABS) CYCLE
            ITGTU=KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
            IXGTY=KTGTU(IXABS,IYABS)-NTGTUES(ISYM)
            IBMADR=(ITGTU*(ITGTU-1))/2+IXGTY
            BBM(IBMADR)=BTUXY-BTUYX
CGG.Nov03
            IF (ITGEU.eq.IXGEY) THEN
              IDT=(ITABS*(ITABS+1))/2
              IDU=(IUABS*(IUABS+1))/2
              BBM(IBMADR)=BBM(IBMADR)+ipea_shift*half*
     &                           (DREF(IDT)+DREF(IDU))*SDM(INSM)
              INSM=INSM+1
            ENDIF
CGG.End
          END DO
        END DO
        IF(NBB.GT.0) CALL mma_deallocate(BB)

C Write to disk, and save size and address.
        IF(NBBP.GT.0.and.NINDEP(ISYM,2).GT.0) THEN
          IDISK=IDBMAT(ISYM,2)
          CALL DDAFILE(LUSBT,1,BBP,NBBP,IDISK)
          CALL mma_deallocate(BBP)
CGG.Nov03 DisAlloc SDP
          CALL mma_deallocate(SDP)
CGG End
        END IF
        IF(NBBM.GT.0) THEN
          IF(NINDEP(ISYM,3).GT.0) THEN
            IDISK=IDBMAT(ISYM,3)
            CALL DDAFILE(LUSBT,1,BBM,NBBM,IDISK)
          END IF
          CALL mma_deallocate(BBM)
CGG.Nov03 DisAlloc SDM
          CALL mma_deallocate(SDM)
CGG End
        END IF
      END DO

      END SUBROUTINE MKBB

      SUBROUTINE MKBD(DREF,NDREF,PREF,NPREF,FD,FP)
      use definitions, only: iwp, wp
      use constants, only: Half, Two, Four
      USE SUPERINDEX, only: MTU
      use caspt2_global, only:ipea_shift
      use caspt2_global, only:LUSBT
      use EQSOLV, only: IDSMAT, IDBMAT
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM,NINDEP,NTU,EASUM,NASHT,NTUES,EPSA
      IMPLICIT NONE

      INTEGER(KIND=IWP), INTENT(IN):: NDREF,NPREF
      REAL(KIND=WP), INTENT(IN):: DREF(NDREF),PREF(NPREF)
      REAL(KIND=WP), INTENT(IN):: FD(NDREF),FP(NPREF)

      REAL(KIND=WP), ALLOCATABLE:: BD(:), S(:), SD(:)
      INTEGER(KIND=IWP) ISYM,NIN,NAS,NBD,NS2,NAS2,IDS,IDIAG,I,ITU,ITU2,
     &                  ITUABS,ITABS,IUABS,IXY,IXY2,IXYABS,IXABS,IYABS,
     &                  IB11,IB21,IB12,IB22,IUTP,IXYP,IP1,IP2,IP,ID,ID1,
     &                  ID2,IDISK,IDT,IDU,IUYP,IXTP
      REAL(KIND=WP) ET,EX,B11,B22,ETX,FUY,DUY

C Set up the matrix BD(tuP,xyQ),P and Q are 1 or 2,
C Formulae used:
C    BD(tu1,xy1)=
C      2*Futxy + 2*(Ex+Et-A)*Gutxy + 2*dxt (Fuy + (Et-A)*Duy)
C    BD(tu2,xy1)= -BD(tu1,xy1)/2
C    BD(tu2,xy2)=
C       -Fxtuy - (Ex+Et-A)*Gxtuy + 2*dxt (Fuy + (Ex-A)*Duy)
C where A=EASUM=Sum(w) of (Ew*Dww)


C Loop over superindex symmetry.
      DO ISYM=1,NSYM
        NIN=NINDEP(ISYM,5)
        IF(NIN.EQ.0) CYCLE
        NAS=NTU(ISYM)
        NBD=(2*NAS*(2*NAS+1))/2
        IF(NBD.GT.0) THEN
          CALL mma_allocate(BD,NBD,Label='BD')
CGG.Nov03  Load in SD the diagonal elements of SD matrix:
          NS2=(2*NAS*(2*NAS+1))/2
          NAS2=2*NAS
          CALL mma_allocate(S,NS2,Label='S')
          CALL mma_allocate(SD,NAS2,Label='SD')
          IDS=IDSMAT(ISYM,5)
          CALL DDAFILE(LUSBT,2,S,NS2,IDS)
          IDIAG=0
          DO I=1,NAS2
            IDIAG=IDIAG+I
            SD(I)=S(IDIAG)
          END DO
          CALL mma_deallocate(S)
CGG End
        END IF
        DO ITU=1,NAS
          ITU2=ITU+NAS
          ITUABS=ITU+NTUES(ISYM)
          ITABS=MTU(1,ITUABS)
          IUABS=MTU(2,ITUABS)
          ET=EPSA(ITABS)
          DO IXY=1,ITU
            IXY2=IXY+NAS
            IXYABS=IXY+NTUES(ISYM)
            IXABS=MTU(1,IXYABS)
            IYABS=MTU(2,IXYABS)
            EX=EPSA(IXABS)
            IB11=(ITU*(ITU-1))/2+IXY
            IB21=(ITU2*(ITU2-1))/2+IXY
            IB12=(IXY2*(IXY2-1))/2+ITU
            IB22=(ITU2*(ITU2-1))/2+IXY2
            IUTP=IUABS+NASHT*(ITABS-1)
            IXYP=IXABS+NASHT*(IYABS-1)
            IP1=MAX(IUTP,IXYP)
            IP2=MIN(IUTP,IXYP)
            IP=(IP1*(IP1-1))/2+IP2
            ETX=ET+EX
            B11=Four*(FP(IP)+(ETX-EASUM)*PREF(IP))
            IXTP=IXABS+NASHT*(ITABS-1)
            IUYP=IUABS+NASHT*(IYABS-1)
            IP1=MAX(IXTP,IUYP)
            IP2=MIN(IXTP,IUYP)
            IP=(IP1*(IP1-1))/2+IP2
            B22=-Two*(FP(IP)+(ETX-EASUM)*PREF(IP))
            IF(IXABS.EQ.ITABS) THEN
              ID1=MAX(IUABS,IYABS)
              ID2=MIN(IUABS,IYABS)
              ID=(ID1*(ID1-1))/2+ID2
              FUY=FD(ID)
              DUY=DREF(ID)
              B11=B11+Two*(FUY+(ET-EASUM)*DUY)
              B22=B22+Two*(FUY+(EX-EASUM)*DUY)
            END IF
            BD(IB11)= B11
            BD(IB21)=-Half*B11
            BD(IB12)=-Half*B11
            BD(IB22)= B22
CGG.Nov03
            IF (ITU.eq.IXY) THEN
              IDT=(ITABS*(ITABS+1))/2
              IDU=(IUABS*(IUABS+1))/2
              BD(IB11)=BD(IB11)+ipea_shift*Half*
     &                       (Two-DREF(IDU)+DREF(IDT))*SD(ITU)
              BD(IB22)=BD(IB22)+ipea_shift*Half*
     &                   (Two-DREF(IDU)+DREF(IDT))*SD(ITU+NAS)
            ENDIF
CGG End
          END DO
        END DO

C Write to disk
        IF(NBD.GT.0.and.NINDEP(ISYM,5).GT.0) THEN
          IDISK=IDBMAT(ISYM,5)
          CALL DDAFILE(LUSBT,1,BD,NBD,IDISK)
          CALL mma_deallocate(BD)
CGG.Nov03 DisAlloc SD
          CALL mma_deallocate(SD)
CGG End
        END IF
      END DO


      END SUBROUTINE MKBD

      SUBROUTINE MKBE(DREF,NDREF,FD)
      use definitions, only: iwp, wp
      use constants, only: Half, Two
      use caspt2_global, only:ipea_shift
      use caspt2_global, only:LUSBT
      use EQSOLV, only: IDBMAT, IDSMAT
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM,NINDEP,NASH,NAES,EPSA,EASUM
      IMPLICIT NONE

      INTEGER(KIND=IWP), INTENT(IN):: NDREF
      REAL(KIND=WP), INTENT(IN):: DREF(NDREF),FD(NDREF)

      Real(KIND=WP), ALLOCATABLE:: BE(:), S(:), SD(:)
      INTEGER(KIND=IWP) ISYM,NINP,NINM,NAS,NBE,NS,IDS,IDIAG,I,IT,ITABS,
     &                  IX,IXABS,IBE,ID,IDISK,IDT
      Real(KIND=WP) VALUE,ET,EX

C Set up the matrix BE(t,x)
C Formula used:
C    BE(t,x)=-Ftx + (EASUM-Ex-Et)*Dtx
C            + 2dtx Ex


      DO ISYM=1,NSYM
        NINP=NINDEP(ISYM,6)
        IF(NINP.EQ.0) CYCLE
        NINM=NINDEP(ISYM,7)
        NAS=NASH(ISYM)
        NBE=(NAS*(NAS+1))/2
        IF(NBE.GT.0) THEN
          CALL mma_allocate(BE,NBE,LABEL='BE')
CGG.Nov03  Load in SD the diagonal elements of SE matrix:
          NS=(NAS*(NAS+1))/2
          CALL mma_allocate(S,NS,Label='S')
          CALL mma_allocate(SD,NAS,Label='SD')
          IDS=IDSMAT(ISYM,6)
          CALL DDAFILE(LUSBT,2,S,NS,IDS)
          IDIAG=0
          DO I=1,NAS
            IDIAG=IDIAG+I
            SD(I)=S(IDIAG)
          END DO
          CALL mma_deallocate(S)
        ENDIF
CGG End
        DO IT=1,NAS
          ITABS=IT+NAES(ISYM)
          ET=EPSA(ITABS)
          DO IX=1,IT
            IXABS=IX+NAES(ISYM)
            EX=EPSA(IXABS)
            IBE=(IT*(IT-1))/2+IX
            ID=(ITABS*(ITABS-1))/2+IXABS
            VALUE=-FD(ID)+(EASUM-EX-ET)*DREF(ID)
            IF(ITABS.EQ.IXABS) THEN
              VALUE=VALUE+Two*EX
            END IF
CGG.Nov03
            IF (IT.eq.IX) THEN
              IDT=(ITABS*(ITABS+1))/2
              VALUE=VALUE+ipea_shift*Half*DREF(IDT)*SD(IT)
            ENDIF
CGG End
            BE(IBE)=VALUE
          END DO
        END DO

C Write to disk
        IF(NBE.GT.0.and.NINDEP(ISYM,6).GT.0) THEN
          IDISK=IDBMAT(ISYM,6)
          CALL DDAFILE(LUSBT,1,BE,NBE,IDISK)
          IF(NINM.GT.0.and.NINDEP(ISYM,7).GT.0) THEN
            IDISK=IDBMAT(ISYM,7)
            CALL DDAFILE(LUSBT,1,BE,NBE,IDISK)
          END IF
          CALL mma_deallocate(BE)
CGG.Nov03 DisAlloc SD
          CALL mma_deallocate(SD)
CGG End
        END IF
      END DO

      END SUBROUTINE MKBE

      SUBROUTINE MKBF(DREF,NDREF,PREF,NPREF,FP)
      use definitions, only: iwp, wp
      use constants, only: Half, Four
      USE SUPERINDEX, only: MTU, MTGEU,KTU,KTGTU
      use caspt2_global, only:ipea_shift
      use caspt2_global, only:LUSBT
      use EQSOLV, only: IDSMAT,IDBMAT
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM,NINDEP,NTU,NTUES,NASHT,NTGEU,EASUM,
     &                         NTGTU,NTGEUES,NTGTUES
      IMPLICIT NONE

      integer(kind=iwp), intent(in):: NDREF,NPREF
      REAL(KIND=WP) PREF(NPREF),FP(NPREF),DREF(NDREF)

      REAL(KIND=WP), ALLOCATABLE:: BF(:), BFP(:), SDP(:),
     &                             SP(:), BFM(:), SDM(:),
     &                             SM(:)
      INTEGER(KIND=IWP) ISYM,NINP,NAS,NBF,ITU,ITUABS,ITABS,IUABS,IXY,
     &                  IXYABS,IXABS,IYABS,IBADR,ITX,IUY,IP1,IP2,IP,
     &                  NASP,NBFP,NSP,IDSP,IDIAG,I,NASM,NBFM,NSM,IDSM,
     &                  IBMADR,IBPADR,IDISK,IDT,IDU,INSM,ITGEU,ITGEUABS,
     &                  ITGTU,IXGEY,IXGEYABS,IXGTY,IYX
      REAL(KIND=WP) BTUXY,BTUYX

C Set up the matrices BFP(tu,xy) and BFM(tu,xy)
C Formulae used:
C    BF(tu,xy)= 2*(Ftxuy - EASUM*Gtxuy)
C    BFP(tu,xy)=BF(tu,xy)+BF(tu,yx)
C    BFM(tu,xy)=BF(tu,xy)-BF(tu,yx)


C Loop over superindex symmetry.
      DO ISYM=1,NSYM
        NINP=NINDEP(ISYM,8)
        IF(NINP.EQ.0) CYCLE
        NAS=NTU(ISYM)
        NBF=(NAS*(NAS+1))/2
        IF(NBF.GT.0) THEN
          CALL mma_allocate(BF,NBF,LABEL='BF')
        END IF
        DO ITU=1,NAS
          ITUABS=ITU+NTUES(ISYM)
          ITABS=MTU(1,ITUABS)
          IUABS=MTU(2,ITUABS)
          DO IXY=1,ITU
            IXYABS=IXY+NTUES(ISYM)
            IXABS=MTU(1,IXYABS)
            IYABS=MTU(2,IXYABS)
            IBADR=(ITU*(ITU-1))/2+IXY
            ITX=ITABS+NASHT*(IXABS-1)
            IUY=IUABS+NASHT*(IYABS-1)
            IP1=MAX(ITX,IUY)
            IP2=MIN(ITX,IUY)
            IP=(IP1*(IP1-1))/2+IP2
            BF(IBADR)=Four*(FP(IP)-EASUM*PREF(IP))
          END DO
        END DO
        NASP=NTGEU(ISYM)
        NBFP=(NASP*(NASP+1))/2
        IF(NBFP.GT.0) THEN
          CALL mma_allocate(BFP,NBFP,Label='BFP')
CGG.Nov03  Load in SDP the diagonal elements of SFP matrix:
          NSP=(NASP*(NASP+1))/2
          CALL mma_allocate(SP,NSP,Label='SP')
          CALL mma_allocate(SDP,NASP,Label='SDP')
          IDSP=IDSMAT(ISYM,8)
          CALL DDAFILE(LUSBT,2,SP,NSP,IDSP)
          IDIAG=0
          DO I=1,NASP
            IDIAG=IDIAG+I
            SDP(I)=SP(IDIAG)
          END DO
          CALL mma_deallocate(SP)
CGG End
        END IF
        NASM=NTGTU(ISYM)
        NBFM=(NASM*(NASM+1))/2
        IF(NBFM.GT.0) THEN
          CALL mma_allocate(BFM,NBFM,Label='BFM')
CGG.Nov03  Load in SDM the diagonal elements of SFM matrix:
          NSM=(NASM*(NASM+1))/2
          CALL mma_allocate(SM,NSM,Label='SM')
          CALL mma_allocate(SDM,NASM,Label='SDM')
          IDSM=IDSMAT(ISYM,9)
          CALL DDAFILE(LUSBT,2,SM,NSM,IDSM)
          IDIAG=0
          DO I=1,NASM
            IDIAG=IDIAG+I
            SDM(I)=SM(IDIAG)
          END DO
          CALL mma_deallocate(SM)
CGG End
        END IF
        INSM=1
        DO ITGEU=1,NASP
          ITGEUABS=ITGEU+NTGEUES(ISYM)
          ITABS=MTGEU(1,ITGEUABS)
          IUABS=MTGEU(2,ITGEUABS)
          ITU=KTU(ITABS,IUABS)-NTUES(ISYM)
          DO IXGEY=1,ITGEU
            IXGEYABS=IXGEY+NTGEUES(ISYM)
            IXABS=MTGEU(1,IXGEYABS)
            IYABS=MTGEU(2,IXGEYABS)
            IXY=KTU(IXABS,IYABS)-NTUES(ISYM)
            IYX=KTU(IYABS,IXABS)-NTUES(ISYM)
            IF(ITU.GE.IXY) THEN
              IBADR=(ITU*(ITU-1))/2+IXY
            ELSE
              IBADR=(IXY*(IXY-1))/2+ITU
            END IF
            BTUXY=BF(IBADR)
            IF(ITU.GE.IYX) THEN
              IBADR=(ITU*(ITU-1))/2+IYX
            ELSE
              IBADR=(IYX*(IYX-1))/2+ITU
            END IF
            BTUYX=BF(IBADR)
            IBPADR=(ITGEU*(ITGEU-1))/2+IXGEY
            BFP(IBPADR)=BTUXY+BTUYX
CGG.Nov03
            IF (ITGEU.eq.IXGEY) THEN
              IDT=(ITABS*(ITABS+1))/2
              IDU=(IUABS*(IUABS+1))/2
              BFP(IBPADR)=BFP(IBPADR)+ipea_shift*Half*
     &                    (Four-DREF(IDT)-DREF(IDU))*SDP(ITGEU)
            ENDIF
CGG End
            IF(ITABS.EQ.IUABS) CYCLE
            IF(IXABS.EQ.IYABS) CYCLE
            ITGTU=KTGTU(ITABS,IUABS)-NTGTUES(ISYM)
            IXGTY=KTGTU(IXABS,IYABS)-NTGTUES(ISYM)
            IBMADR=(ITGTU*(ITGTU-1))/2+IXGTY
            BFM(IBMADR)=BTUXY-BTUYX
CGG.Nov03
            IF (ITGEU.eq.IXGEY) THEN
              IDT=(ITABS*(ITABS+1))/2
              IDU=(IUABS*(IUABS+1))/2
              BFM(IBMADR)=BFM(IBMADR)+ipea_shift*Half*
     &                    (Four-DREF(IDT)-DREF(IDU))*SDM(INSM)
              INSM=INSM+1
            ENDIF

          END DO
        END DO
        IF(NBF.GT.0) CALL mma_deallocate(BF)

C Write to disk
        IF(NBFP.GT.0.and.NINDEP(ISYM,8).GT.0) THEN
          IDISK=IDBMAT(ISYM,8)
          CALL DDAFILE(LUSBT,1,BFP,NBFP,IDISK)
          CALL mma_deallocate(BFP)
CGG.Nov03 DisAlloc SDP
          CALL mma_deallocate(SDP)
CGG End
        END IF
        IF(NBFM.GT.0) THEN
         IF(NINDEP(ISYM,9).GT.0) THEN
          IDISK=IDBMAT(ISYM,9)
          CALL DDAFILE(LUSBT,1,BFM,NBFM,IDISK)
         END IF
         CALL mma_deallocate(BFM)
CGG.Nov03 DisAlloc SDM
         CALL mma_deallocate(SDM)
CGG End
        END IF
      END DO

      END SUBROUTINE MKBF

      SUBROUTINE MKBG(DREF,NDREF,FD)
      use definitions, only: iwp, wp
      use constants, only: half, two
      use caspt2_global, only:ipea_shift
      use caspt2_global, only:LUSBT
      use EQSOLV, only: IDSMAT,IDBMAT
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM,NINDEP,NASH,NAES,EASUM
      IMPLICIT NONE

      INTEGER(KIND=IWP), INTENT(IN):: NDREF
      REAL(KIND=WP), INTENT(IN):: DREF(NDREF),FD(NDREF)

      REAL(KIND=WP), ALLOCATABLE:: BG(:), S(:), SD(:)
      INTEGER(KIND=IWP) ISYM,NINP,NINM,NAS,NBG,NS,IDS,IDIAG,I,IT,ITABS,
     &                  IX,IXABS,IBG,ID,IDISK,IDT
      REAL(KIND=WP) VALUE

C     Set up the matrix BG(t,x)
C     Formula used:
C     BG(t,x)= Ftx -EASUM*Dtx


      DO ISYM=1,NSYM
        NINP=NINDEP(ISYM,10)
        IF(NINP.EQ.0) CYCLE
        NINM=NINDEP(ISYM,11)
        NAS=NASH(ISYM)
        NBG=(NAS*(NAS+1))/2
        IF(NBG.GT.0) THEN
          CALL mma_Allocate(BG,NBG,LABEL='BG')
CGG.Nov03  Load in SD the diagonal elements of SG matrix:
          NS=(NAS*(NAS+1))/2
          CALL mma_allocate(S,NS,Label='S')
          CALL mma_allocate(SD,NAS,Label='SD')
          IDS=IDSMAT(ISYM,10)
          CALL DDAFILE(LUSBT,2,S,NS,IDS)
          IDIAG=0
          DO I=1,NAS
            IDIAG=IDIAG+I
            SD(I)=S(IDIAG)
          END DO
          CALL mma_deallocate(S)
        ENDIF
CGG End
        DO IT=1,NAS
          ITABS=IT+NAES(ISYM)
          DO IX=1,IT
            IXABS=IX+NAES(ISYM)
            IBG=(IT*(IT-1))/2+IX
            ID=(ITABS*(ITABS-1))/2+IXABS
CGG.Nov03
            VALUE=FD(ID)-EASUM*DREF(ID)
            IF (IT.eq.IX) THEN
              IDT=(ITABS*(ITABS+1))/2
              VALUE = VALUE +
     &                ipea_shift*half*(two-DREF(IDT))*SD(IT)
            ENDIF
            BG(IBG)=VALUE
C           BG(BG)=FD(ID)-EASUM*DREF(ID)
CGG End
          END DO
        END DO

C Write to disk, and save size and address.
        IF(NBG.GT.0) THEN
         IF(NINDEP(ISYM,10).GT.0) THEN
          IDISK=IDBMAT(ISYM,10)
          CALL DDAFILE(LUSBT,1,BG,NBG,IDISK)
         END IF
         IF(NINM.GT.0.and.NINDEP(ISYM,11).GT.0) THEN
           IDISK=IDBMAT(ISYM,11)
           CALL DDAFILE(LUSBT,1,BG,NBG,IDISK)
         END IF
CGG.Nov03 DisAlloc SD
         CALL mma_deallocate(SD)
CGG End
         CALL mma_deallocate(BG)
        END IF
      END DO

      END SUBROUTINE MKBG

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Aug. 06, 2020, created this file.               *
! ****************************************************************

subroutine QaaP2MO(G2q,ng2,GDMat,IKL,IKK,ILL)

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: nNA
use input_mclr, only: nRoots
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two, Half, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nG2, IKL, IKK, ILL
real(kind=wp), intent(out) :: G2q(nG2)
real(kind=wp), intent(in) :: GDMat(nTri_Elem(nRoots),nnA,nnA)
integer(kind=iwp) :: i, ij, ijkl, j, k, kl, l, lMax, nD
real(kind=wp) :: Fact
real(kind=wp), allocatable :: Ddif(:), Dsum(:)

! Calculating dQ_aa/dX_KL, original purpose of this subroutine
nD = nTri_Elem(nnA)
call mma_allocate(Dsum,nD)
call mma_allocate(Ddif,nD)
do i=1,nnA
  do j=1,i
    ij = iTri(i,j)
    Dsum(ij) = GDMat(IKL,i,j)+GDMat(IKL,j,i)
    Ddif(ij) = GDMat(IKK,i,j)-GDMat(ILL,i,j)
  end do
end do
ijkl = 0
do i=1,nna
  do j=1,i
    ij = iTri(i,j)
    do k=1,i
      if (i == k) then
        lmax = j
      else
        lmax = k
      end if
      do l=1,lmax
        kl = iTri(k,l)
        ijkl = ijkl+1
        fact = Half
        if (k == l) fact = Quart
        G2q(ijkl) = fact*(Dsum(ij)*Ddif(kl)+Dsum(kl)*Ddif(ij))*Two
      end do
    end do
  end do
end do
call mma_deallocate(Dsum)
call mma_deallocate(Ddif)

end subroutine QaaP2MO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Logical Function LDF_IntegralPrescreeningInfoIsSet()
      Implicit None
#include "ldf_integral_prescreening_info.fh"
      LDF_IntegralPrescreeningInfoIsSet=
     &    l_GDiag_1C.gt.0 .or. l_GDiag_1C_Mx.gt.0 .or.
     &    l_GDiag_2C.gt.0 .or. l_GDiag_2C_Mx.gt.0 .or.
     &    l_IDiag.gt.0    .or. l_IDiag_Mx.gt.0
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DEX1_CP2 (CPQ,NUP,A,B,NCP,ICOUP,VTAB)
      IMPLICIT NONE
      INTEGER NUP,NCP,ICOUP(3,NCP)
      REAL*8 CPQ,A(NUP,*),B(NUP,*),VTAB(*)
      INTEGER ICP,JLFT,JRGT
      REAL*8 X
C CASE: ADD EPQ*A TO B, WHERE P<Q<=MIDLEV AND A AND B ARE SINGLE
C MATRIX BLOCKS.
C ONLY LOWER WALKS AFFECTED => COLUMN OPERATION.
C P<Q, DEEXCITING OPERATOR  => A IS RIGHTHAND WALK.
C CHOSE DAXPY IF LARGE VECTOR LENGTH:
      DO ICP=1,NCP
        JLFT=ICOUP(1,ICP)
        JRGT=ICOUP(2,ICP)
        X=CPQ*VTAB(ICOUP(3,ICP))
        CALL DAXPY_(NUP,X,A(1,JRGT),1,B(1,JLFT),1)
      END DO
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETDIAG1(DIAG,BUF,IBUF,LENBUF,NDUMP)
C
C     Purpose: read diagonal in first reduced set.
C
#include "implicit.fh"
      DIMENSION DIAG(*), BUF(LENBUF)
      INTEGER   IBUF(4,LENBUF)
#include "cholesky.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*12 SECNAM
      PARAMETER (SECNAM = 'CHO_GETDIAG1')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

      INTEGER ISYLST(8)

      PARAMETER (INFOD = INF_DIAG)
      PARAMETER (TINY  = 1.0D-14)

C     Read diagonal from file.
C     ------------------------

      IF (RSTDIA) THEN
         IOPT = 2
         CALL CHO_IODIAG(DIAG,IOPT)
      ELSE
         CALL CHO_DZERO(DIAG,NNBSTRT(1))
         CALL CHO_IZERO(IWORK(ip_INDRSH),NNBSTRT(1))
         CALL CHO_IZERO(IWORK(ip_INDRED),NNBSTRT(1))
         CALL CHO_RDDBUF(DIAG,BUF,IBUF,
     &                   IWORK(ip_INDRSH),IWORK(ip_INDRED),
     &                   LENBUF,MMBSTRT,NDUMP)
         CALL CHO_GADGOP(DIAG,NNBSTRT(1),'+')
         CALL CHO_GAIGOP(IWORK(ip_INDRSH),NNBSTRT(1),'+')
         CALL CHO_GAIGOP(IWORK(ip_INDRED),NNBSTRT(1),'+')
      END IF

C     Copy info to current reduced set (IRED=2).
C     Also set up IRED=3 (although it should be redundant).
C     -----------------------------------------------------

      DO IRS = 2,3
         CALL CHO_RSCOPY(IWORK(ip_IIBSTRSH),IWORK(ip_NNBSTRSH),
     &                   IWORK(ip_INDRED),1,IRS,NSYM,NNSHL,NNBSTRT(1),3)
      END DO

C     Print.
C     ------

      IF (LOCDBG .OR. (IPRINT.GE.INFOD)) THEN
         DO ISYM = 1,NSYM
            ISYLST(ISYM) = ISYM
         END DO
         NSYLST = NSYM
         IRED = 1
         CALL CHO_PRTDIA(DIAG,ISYLST,NSYLST,IRED)
         IF (LOCDBG) THEN
            IRED = 2
            CALL CHO_PRTDIA(DIAG,ISYLST,NSYLST,IRED)
         END IF
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Giovanni Ghigo                                         *
!***********************************************************************

subroutine LenInt(iSymI,iSymJ,iSymA,iSymB,nProdIJ,nProdAB,nProdE1,nProdE2)
!***********************************************************************
! Author  :  Giovanni Ghigo                                            *
!            Lund University, Sweden                                   *
!----------------------------------------------------------------------*
! Return the Length of Coulomb (nProdAB), Exchanges (nProdE1 and       *
! nProdE2) matrices for each i,j and the length (nProdIJ) of the i,j   *
! matrix for each Symmetry Block (iSymI,iSymJ,iSymA,iSymB)             *
!***********************************************************************

use Cho_Tra, only: DoTCVA, nOrb, nOsh, nSsh
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iSymI, iSymJ, iSymA, iSymB
integer(kind=iwp), intent(out) :: nProdIJ, nProdAB, nProdE1, nProdE2
integer(kind=iwp) :: nExtA, nExtB, nOccI, nOccJ, nOrbA, nOrbB

nProdIJ = 0
nProdAB = 0
nProdE1 = 0
nProdE2 = 0
nOccI = nOsh(iSymI)
nOccJ = nOsh(iSymJ)
nOrbA = nOrb(iSymA)
nOrbB = nOrb(iSymB)
nExtA = nSsh(iSymA)
nExtB = nSsh(iSymB)
if (iSymI == iSymJ) then
  nProdIJ = nOccI*(nOccJ+1)/2
else
  nProdIJ = nOccI*nOccJ
end if
if (iSymA == iSymB) then
  nProdAB = nOrbA*(nOrbB+1)/2
else
  if (iSymA > iSymB) then
    nProdAB = nOrbA*nOrbB
  else
    nProdAB = 0
  end if
end if
if (iSymA >= iSymB) then
  if (DoTCVA) then
    nProdE1 = nOrbA*nOrbB
  else
    nProdE1 = nExtA*nExtB
  end if
  nProdE2 = 0
else
  nProdE1 = 0
  if (DoTCVA) then
    nProdE2 = nOrbA*nOrbB
  else
    nProdE2 = nExtA*nExtB
  end if
end if

return

end subroutine LenInt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_Decom_A4(Diag,LstQSP,NumSP,iPass)
!
! Purpose: decompose qualified columns ("parallel" algorithm).

use Cholesky, only: Cho_Real_Par, INF_PASS, INF_PROGRESS, IPRINT, LQ_Tot, LQ, LuPri, LuSel, nnBstR, nQual, nSym, NumCho, NumChT, &
                    nVec_in_Buf, TDECOM
use Cholesky_procedures, only: Cho_P_GetLQ
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Diag(*)
integer(kind=iwp), intent(in) :: NumSP, LstQSP(NumSP), iPass
integer(kind=iwp) :: iEn, iK, iRed, iSt, iSym, iVec1, Jfi, Jin, jK, jVec, kI, kID, kK1, kK2, kK_1, kK_2, kQD, kV, l_IDKVec, &
                     l_KVec, l_LQ, l_Wrk1, l_xInt, lK, MxQ, nkVec(8), nQual_Old(8), NumCho_Old(8), NumV(8)
real(kind=wp) :: C1, C2, W1, W2
integer(kind=iwp), allocatable :: IDKVec(:), iQScr(:)
real(kind=wp), allocatable :: KVec(:), KVScr(:), MQ(:), QDiag(:), Wrk1(:), xInt(:)
character(len=*), parameter :: SecNam = 'Cho_Decom_A4'

! Print header.
! -------------

if (iPrint >= Inf_Progress) then
  call Cho_Head(SecNam//': Decomposition of Qualified Diagonals','=',80,LUPRI)
  write(Lupri,'(/,A,I5,A,I4,A)') 'Integral pass number',iPass,' (',NumSP,' shell pair distributions calculated)'
  write(Lupri,'(A,8I8)') '#Cholesky vec.: ',(NumCho(iSym),iSym=1,nSym)
  write(Lupri,'(A,8I8)') '#vec. in buff.: ',(nVec_in_Buf(iSym),iSym=1,nSym)
  write(Lupri,'(A,8I8)') '#qualified    : ',(nQual(iSym),iSym=1,nSym)
  write(Lupri,'(A,8I8)') 'Current  dim. : ',(nnBstr(iSym,2),iSym=1,nSym)
  write(Lupri,'(A,8I8)') 'Original dim. : ',(nnBstr(iSym,1),iSym=1,nSym)
  write(Lupri,'(/,A,/,A)') '           #Vectors             Treated Diagonal', &
                           'Sym.     Sym.     Total     Index     Before      After   Conv. Neg.   New Max'
  write(Lupri,'(A)') repeat('-',79)
  call XFlush(Lupri)
  NumCho_Old(1:nSym) = NumCho(1:nSym)
else if (iPrint >= Inf_Pass) then
  write(Lupri,'(/,A,I4)') 'Number of shell pair distributions calculated:',NumSP
  write(Lupri,'(A,8I8)') '#Cholesky vec.: ',(NumCho(iSym),iSym=1,nSym)
  write(Lupri,'(A,8I8)') '#vec. in buff.: ',(nVec_in_Buf(iSym),iSym=1,nSym)
  write(Lupri,'(A,8I8)') '#qualified    : ',(nQual(iSym),iSym=1,nSym)
  call XFlush(Lupri)
  NumCho_Old(1:nSym) = NumCho(1:nSym)
end if

! Allocations.
! ------------

call Cho_P_GetGV(numV,nSym)

l_KVec = nQual(1)**2
l_IDKVec = nQual(1)
l_LQ = nQual(1)*NumV(1)
do iSym=2,nSym
  l_KVec = l_KVec+nQual(iSym)**2
  l_IDKVec = l_IDKVec+nQual(iSym)
  l_LQ = l_LQ+nQual(iSym)*NumV(iSym)
end do
l_LQ = max(l_LQ,1) ! because there might not be any prev. vecs.
call mma_allocate(KVec,l_KVec,Label='KVec')
call mma_allocate(IDKVec,l_IDKVec,Label='IDKVec')
call mma_allocate(QDiag,l_IDKVec,Label='QDiag')

! Extract elements corresponding to qualified diagonals from
! previous Cholesky vectors (if any).
! ----------------------------------------------------------

call CWTime(C1,W1)
call mma_allocate(LQ_Tot,l_LQ,Label='LQ_Tot')

iEn = 0
iSt = 1
do iSym=1,nSym
  if (nQual(iSym)*NumV(iSym) > 0) then
    iEn = iEn+nQual(iSym)*NumV(iSym)
    LQ(iSym)%A(1:nQual(iSym),1:NumV(iSym)) => LQ_Tot(iSt:iEn)
    iSt = iEn+1
  else
    nullify(LQ(iSym)%A)
  end if
end do

call Cho_P_GetLQ(LQ_Tot,l_LQ,LstQSP,NumSP)
call CWTime(C2,W2)
tDecom(1,2) = tDecom(1,2)+C2-C1
tDecom(2,2) = tDecom(2,2)+W2-W1

! Extract qualified diagonal integral block.
! ------------------------------------------

call CWTime(C1,W1)

call mma_allocate(MQ,l_KVec,Label='MQ')
call Cho_P_GetMQ(MQ,size(MQ),LstQSP,NumSP)

! Decompose qualified diagonal block.
! The qualified diagonals are returned in QDiag.
! ----------------------------------------------

call Cho_Dec_Qual(Diag,LQ_Tot,MQ,KVec,IDKVec,nKVec,QDiag)

! Deallocate MQ.
! --------------

call mma_deallocate(MQ)

! Reorder the elements of the K-vectors according to IDK ordering.
! ----------------------------------------------------------------

MxQ = nQual(1)
do iSym=2,nSym
  MxQ = max(MxQ,nQual(iSym))
end do

call mma_allocate(KVScr,MxQ,Label='KVScr')

kK1 = 0
kK2 = kK1
kID = 0
do iSym=1,nSym
  do iK=1,nKVec(iSym)
    kK_1 = kK1+nQual(iSym)*(iK-1)
    KVScr(1:nQual(iSym)) = KVec(kK_1+1:kK_1+nQual(iSym))
    kK_2 = kK2+nKVec(iSym)*(iK-1)
    do jK=1,nKVec(iSym)
      lK = IDKVec(kID+jK)
      KVec(kK_2+jK) = KVScr(lK)
    end do
  end do
  kK1 = kK1+nQual(iSym)**2
  kK2 = kK2+nKVec(iSym)**2
  kID = kID+nQual(iSym)
end do

! Reorder QDiag to IDK ordering.
! ------------------------------

kID = 0
kQD = 0
do iSym=1,nSym
  KVScr(1:nQual(iSym)) = QDiag(kQD+1:kQD+nQual(iSym))
  do iK=1,nKVec(iSym)
    lK = IDKVec(kID+iK)
    QDiag(kQD+iK) = KVScr(lK)
  end do
  kQD = kQD+nQual(iSym)
  kID = kID+nQual(iSym)
end do

! Reorder elements of LQ vectors to IDK ordering.
! -----------------------------------------------

kID = 0
do iSym=1,nSym
  if (nQual(iSym) < 1) cycle
  do jVec=1,NumV(iSym)
    KVScr(1:nQual(iSym)) = LQ(iSym)%A(:,jVec)
    do iK=1,nKVec(iSym)
      lK = IDKVec(kID+iK)
      LQ(iSym)%A(iK,jVec) = KVScr(lK)
    end do
  end do
  kID = kID+nQual(iSym)
end do

call mma_deallocate(KVScr)

! Reset qualification index arrays to IDK ordering.
! Local as well as global are reordered.
! -------------------------------------------------

nQual_Old(1:nSym) = nQual(1:nSym)
call mma_allocate(iQScr,MxQ,Label='iQScr')

call Cho_P_ReoQual(iQScr,IDKVec,nKVec)

call mma_deallocate(iQScr)
nQual(1:nSym) = nKVec(1:nSym)

call CWTime(C2,W2)
tDecom(1,4) = tDecom(1,4)+C2-C1
tDecom(2,4) = tDecom(2,4)+W2-W1

! Compute vectors in each symmetry block.
! ---------------------------------------

kV = 1
kI = 1
kQD = 1
do iSym=1,nSym

  ! Cycle loop if nothing to do in this symmetry.
  ! ---------------------------------------------

  if (nQual(iSym) >= 1) then

    ! Set vector information.
    ! -----------------------

    call Cho_P_SetVecInf(nQual(iSym),iSym,iPass)

    ! Allocate memory for integrals/vectors.
    ! --------------------------------------

    l_xInt = max(nnBstR(iSym,2)*nQual(iSym),1)
    call mma_allocate(xInt,l_xInt,Label='xInt')

    if (nnBstR(iSym,2) > 0) then

      ! Read integral columns from disk, ordered according to IDK.
      ! ----------------------------------------------------------

      call CWTime(C1,W1)
      call Cho_RdQCol_Indx(xInt,IDKVec(kI),nnBstR(iSym,2),nQual(iSym),LuSel(iSym))
      call CWTime(C2,W2)
      tDecom(1,1) = tDecom(1,1)+C2-C1
      tDecom(2,1) = tDecom(2,1)+W2-W1

      ! Compute vectors.
      ! ----------------

      call mma_maxDBLE(l_Wrk1)
      call mma_allocate(Wrk1,l_Wrk1,Label='Wrk1')

      call Cho_CompVec(Diag,xInt,KVec(kV),QDiag(kQD),Wrk1,l_Wrk1,iSym,iPass)

      call mma_deallocate(Wrk1)

      ! Write vectors to disk and update vector counters.
      ! -------------------------------------------------

      call CWTime(C1,W1)
      iVec1 = NumCho(iSym)+1
      call Cho_PutVec(xInt,nnBstR(iSym,2),nQual(iSym),iVec1,iSym)
      call Cho_VecBuf_Copy(xInt,nQual(iSym),iSym)
      NumCho(iSym) = NumCho(iSym)+nQual(iSym)
      NumChT = NumChT+nQual(iSym)
      call CWTime(C2,W2)
      tDecom(1,2) = tDecom(1,2)+C2-C1
      tDecom(2,2) = tDecom(2,2)+W2-W1

    end if

    ! Transpose vectors on disk (parallel only).
    ! ------------------------------------------

    call CWTime(C1,W1)
    iRed = 2
    Jin = NumV(iSym)+1
    Jfi = NumV(iSym)+nQual(iSym)
    if (Cho_Real_Par) call Cho_VecTransp(xInt,Jin,Jfi,iSym,iRed,iPass)
    call CWTime(C2,W2)
    tDecom(1,2) = tDecom(1,2)+C2-C1
    tDecom(2,2) = tDecom(2,2)+W2-W1

    ! Deallocate memory for integrals/vectors.
    ! ----------------------------------------

    call mma_deallocate(xInt)

  end if

  ! Empty symmetry blocks jump here.
  ! --------------------------------

  kV = kV+nQual(iSym)**2
  kI = kI+nQual_Old(iSym)
  kQD = kQD+nQual_Old(iSym)

end do

! Deallocations.
! --------------

call mma_deallocate(LQ_Tot)
call mma_deallocate(QDiag)
call mma_deallocate(IDKVec)
call mma_deallocate(KVec)

! Print.
! ------

if (iPrint >= Inf_Progress) then
  NumCho_Old(1:nSym) = NumCho(1:nSym)-NumCho_Old(1:nSym)
  write(Lupri,'(A)') repeat('-',79)
  write(Lupri,'(A,8I8)') '#vec. gener.  : ',(NumCho_OLD(iSym),iSym=1,nSym)
else if (iPrint >= Inf_Pass) then
  NumCho_Old(1:nSym) = NumCho(1:nSym)-NumCho_Old(1:nSym)
  write(Lupri,'(A,8I8)') '#vec. gener.  : ',(NumCho_OLD(iSym),iSym=1,nSym)
end if

end subroutine Cho_Decom_A4

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine svd_cvb(ainp,val,vec,vmat,n1,n2)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n1, n2
real(kind=wp), intent(in) :: ainp(n1,n2)
real(kind=wp), intent(out) :: val(n2), vec(n1,n2), vmat(n2,n2)
integer(kind=iwp) :: i, ierr, n12
integer(kind=iwp), allocatable :: indx(:)
real(kind=wp), allocatable :: a(:,:), rv1(:), u(:,:), v(:,:), w(:)
real(kind=wp), external :: dnrm2_

n12 = max(n1,n2)
call mma_allocate(a,n12,n2,label='a')
call mma_allocate(w,n2,label='w')
call mma_allocate(u,n12,n2,label='u')
call mma_allocate(v,n12,n2,label='v')
call mma_allocate(rv1,n2,label='rv1')
call mma_allocate(indx,n2,label='indx')

if (n12 == n1) then
  a(:,:) = ainp(:,:)
else
  a(1:n1,:) = ainp(:,:)
  a(n1+1:,:) = Zero
end if
ierr = 0
call svd(n12,n1,n2,a,w,.true.,u,.true.,v,ierr,rv1)

call mma_deallocate(rv1)

if (ierr /= 0) then
  write(u6,*) ' Fatal error in SVD_CVB!',ierr
  call abend_cvb()
end if

! Eispack code is broken, in the following u is generated from v:

! First recreate a:
if (n12 == n1) then
  a(:,:) = ainp(:,:)
else
  a(1:n1,:) = ainp(:,:)
  a(n1+1:,:) = Zero
end if

do i=1,n2
  call mxatb_cvb(a,v(:,i),n12,n2,1,u(:,i))
  u(:,i) = u(:,i)/dnrm2_(n12,u(:,i),1)
end do

call mma_deallocate(a)
call mma_allocate(indx,n2,label='indx')

! Sort singular values in ascending order:
call sortindxr_cvb(n2,w,indx)
do i=1,n2
  val(i) = w(indx(i))
  vmat(:,i) = v(1:n2,indx(i))
  vec(:,i) = u(1:n1,indx(i))
end do

call mma_deallocate(a)
call mma_deallocate(w)
call mma_deallocate(u)
call mma_deallocate(v)
call mma_deallocate(indx)

return

end subroutine svd_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2006,2007, Markus Reiher                          *
*               2004,2006, Alexander Wolf                              *
************************************************************************
      subroutine dkhparser_numeric (s,h,v,pvp,x,pxp,dkhorder,xorder,
     *               paramtype,dkhscfflg,nbas,isize,clight,vv,nn,dd,yy,
     *               ff,gg,xx,ii,jj,kk,ll,mm,revt,tran,sinv,aa,rr,
     *               tt,pp,e,ew,snumber,tnumber,unumber,scrno1,scrno2,
     *               scr1,scr2,scr3,scr5,scr8,no_hamil,no_prop,nbasp,
     *               nbaso,LDKroll,indx2,nAtom,maxsiz,nblock)
c
c*****************************************************************************************
c
c                  Implementation of the scalar-relativistic
c
c                       I N F I N I T E - O R D E R
c
c      G E N E R A L I Z E D   D O U G L A S - K R O L L - H E S S  (DKH)
c
c                         T R A N S F O R M A T I O N
c
c                                    F O R
c
c             H A M I L T O N I A N   A N D   P R O P E R T Y
c
c                 2006 Markus Reiher and Alexander Wolf, ETH Zurich
c                      Infinite-order DKH
c                      {markus.reiher,alexander.wolf}@phys.chem.ethz.ch
c
c
c   Reference to the infinite-order DKH method:
c
c     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 2037   part I   [Theory]
c     M. Reiher, A. Wolf, J.Chem.Phys. 121 (2004) 10945  part II  [Algorithm]
c     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064102 part III (Properties-Theory)
c     A. Wolf, M. Reiher, J.Chem.Phys. 124 (2006) 064103 part IV  (Properties-Implem.
c
c   Reference to the generalized higher-order DKH method:
c
c     A. Wolf, M. Reiher, B.A. Hess, J. Chem. Phys. 117 (2002) 9215
c
c-----------------------------------------------------------------------------------------
c
c
c   This SR belongs to dkhparser_numeric (dkhparser2)
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena / ETH Zurich)
c
c   note: the package uses MOLCAS specific routines for
c           a) dynamical memory allocation via GetMem() in evalstring
c           b) IO to disk (ddafile etc.)
c         both may be replaced by a more general interface.
c
c   version:  2.2.0
c
c   last modified: 13.03.2007  M. Reiher (ETH Zurich)
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*******************************************************************************
c
      implicit none
#include "dkhparameters.fh"
#include "WrkSpc.fh"
c
      logical dkhscfflg,no_hamil,no_prop,LDKroll
      integer dkhorder,xorder,nbas,isize,snumber,tnumber,nbasp,nbaso,
     *        unumber,scrno1,scrno2,nAtom,indx2(nAtom,4),maxsiz,nblock
      REAL*8 clight,s(isize),h(isize),v(isize),pvp(isize),
     *                 x(isize),pxp(isize)
c
      REAL*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp)
c
      REAL*8 revt(nbas,nbas),tran(nbas,nbas),sinv(nbas,nbas),
     *                 aa(nbas),rr(nbas),tt(nbas),pp(nbas),e(nbas),
     *                 ew(nbas)
      REAL*8 scr1(nbaso,nbaso,snumber),
     *                 scr2(nbaso,nbaso,tnumber),
     *                 scr3(nbaso,nbaso,unumber),scr5(nbas,nbas,scrno1),
     *                 scr8(isize,scrno2)
c
      character*(3) paramtype
C     REAL*8 DBLE
c
      integer poss(maxsnumber),post(maxsnumber),posu(maxunumber)
c
      integer i,iex,icontr
      REAL*8 det
c
*** addresses for matrices to disk in case of nbaso=1
***   ( isfreeunit() is an integer function of MOLCAS)
      integer adrmem,isfreeunit,dkh_48,adrnext
      parameter (adrmem=4000)
      integer dkhadr(adrmem)
#ifdef MOLPRO
      character*32 filnam
#endif
      dkh_48=0
c
c*******************************************************************************
      if (out_of_core) then
        dkh_48=48
#ifdef _MOLCAS_
        dkh_48=isfreeunit(dkh_48)
        call daname_mf(dkh_48,'DKHMX')
#else
        filnam='DKHMX'
        call tmp_filename(filnam)
        call daname_nolib(dkh_48,filnam)
#endif
      endif
c
      if (dkhorder.gt.maxorder) then
        write(stdout,1010) dkhorder,maxorder,maxorder
1010    format (/,'Warning: dkhorder = ',I2,', but maxorder = ',I2,'.',
     *          /'--> dkhorder will be reduced to maxorder = ',I2,'.'/)
        dkhorder=maxorder
      endif
c
CMR150107      call initialize2 (nbas,isize,vv,nn,dd,yy,ff,gg,xx,ii,jj,kk,
CMR150107     *                  ll,mm,revt,tran,sinv,aa,rr,tt,pp,e,ew,snumber,
CMR150107     *                  tnumber,unumber,scrno1,scrno2,nbasp,
CMR150107     *                  scr1,scr2,scr3,scr5,scr8,dkhorder,xorder)
CMR260207 "nbaso" has not yet been included in initialize2
      do 10 i=1,maxsnumber
        poss(i)=0
        post(i)=0
  10  continue
      do 11 i=1,maxunumber
        posu(i)=0
  11  continue
c
c     Verify that the overlap matrix is not singular
c
c  scr5(,,1) : overlap matrix (rectangular)
      call mat_sq_from_t (scr5(1,1,1),nbas,s)
      icontr=-1
      call mat_copy (scr5(1,1,2),nbas,nbas,scr5(1,1,1))
      call dcopiv (scr5(1,1,2),scr5(1,1,2),nbas,1,nbas,dkhzero,
     *             det,iex,icontr,scr8(1,3))
      if (icontr.ne.0) then
        write (stdout,1020) dkhzero
1020    format('  D K H |****** '/,
     *  '        |****** WARNING - OVERLAP MATRIX SINGULAR '/,
     *  '        |****** PIVOTAL ELEMENT LESS THAN ',D20.4,' FOUND'/,
     *  '        |******'//)
        call errex_rel(' D K H | singular overlap matrix')
      endif
*
*                                                                      *
************************************************************************
*     Local Douglas-Kroll with 2nd order perturbation                  *
*
      If (LDKroll) Then
         Call diag_ldkh(nAtom,nblock,nbas,isize,maxsiz,indx2,
     *                  scr5(1,1,1),scr8(1,1),s,h,scr5(1,1,2),e,
     *                  scr5(1,1,3),ew,tran,v,scr8(1,2),revt,scr8(1,3))
         Call ldkhpert(nbas,isize,h,s,sinv,scr5,scr8,nblock,
     *                 indx2,tran,ew,nAtom,revt)
         call mat_sq_from_t (scr5(1,1,1),nbas,s)
      Else
         Do i=1,isize
           scr8(i,1)=s(i)
         End Do
*** note: x is used as scratch in the following
      call sog(nbas,scr8(1,1),sinv,scr8(1,scrno2),scr8(1,2),scr5(1,1,3))
*** vorsicht: der vorhergehende Aufruf macht was falsch, wil da stand:
*** weshalb scrno2=10 verwendet wurde
***      call sog(nbas,scr8(1,1),sinv,scr8(1,scrno2),scr8(1,3),scr5(1,1,3scr5(1,1,3)))
*
         call diag_dkh(h,nbas,tran,ew,sinv,scr5(1,1,2),1)
      End If
      call calc_prefactors (nbas,isize,clight,aa,rr,tt,pp,e,ew)
c
c   e) Calculate reverse transformation 'revt'
c
      call calc_revt (nbas,revt,tran,sinv,scr5(1,1,1),scr5(1,1,2))
c
      call calc_E0 (nbas,isize,h,revt,ew)
      call calc_E1 (nbas,isize,xorder,dkhscfflg,h,v,pvp,x,pxp,vv,dd,xx,
     *              jj,revt,tran,sinv,aa,rr,tt,scrno1,scrno2,scr5,
     *              scr8,no_prop,nbasp,nbaso,dkhadr,adrmem,dkh_48,
     *              adrnext)
      call setup_matrices (nbas,isize,vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,
     *                     kk,ll,mm,aa,rr,e,scrno2,scr8,no_prop,
     *                     nbasp,nbaso,dkhadr,adrmem,dkh_48,adrnext)
c
c      call trunc_dkh (nbas,isize,znuc,maxexp,minexp,dkhorder,
c     *                clight,scrno1,scrno2,scrno3,vv,nn,e,scr5,
c     *                scr8,scr9,tran,sinv)
c
      call calc_Uxxx (nbas,dkhorder,xorder,dkhscfflg,posu,post,poss,vv,
     *                nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,snumber,
     *                tnumber,unumber,scrno1,scr1,scr2,scr3,scr5,nbasp,
     *                nbaso,dkhadr,adrmem,dkh_48,adrnext)
c
      call calc_Txxx (nbas,dkhorder,xorder,dkhscfflg,posu,post,poss,vv,
     *                nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,snumber,
     *                tnumber,unumber,scrno1,scr1,scr2,scr3,scr5,nbasp,
     *                nbaso,dkhadr,adrmem,dkh_48,adrnext)
c
      call calc_Sxxx (nbas,dkhorder,xorder,dkhscfflg,posu,post,poss,vv,
     *                nn,dd,yy,ff,gg,pp,xx,ii,jj,kk,ll,mm,e,snumber,
     *                tnumber,unumber,scrno1,scr1,scr2,scr3,scr5,nbasp,
     *                nbaso,dkhadr,adrmem,dkh_48,adrnext)
c
      if (.not.no_hamil)
     *  call calc_operators(nbas,isize,dkhorder,xorder,dkhscfflg,posu,
     *                      post,poss,vv,nn,dd,yy,ff,gg,pp,xx,ii,jj,
     *                      kk,ll,mm,e,snumber,tnumber,unumber,
     *                      scrno1,scrno2,scr1,scr2,scr3,scr5,scr8,
     *                      revt,h,nbasp,nbaso,dkhadr,adrmem,dkh_48,
     *                      adrnext)
c
      if (.not.dkhscfflg.and..not.no_prop)
     *  call calc_xoperators(nbas,isize,dkhorder,xorder,
     *                       dkhscfflg,posu,post,poss,vv,nn,dd,yy,
     *                       ff,gg,pp,xx,ii,jj,kk,ll,mm,e,snumber,
     *                       tnumber,unumber,scrno1,scrno2,scr1,
     *                       scr2,scr3,scr5,scr8,revt,x,nbasp,nbaso,
     *                       dkhadr,adrmem,dkh_48,adrnext)
c
      if (Out_Of_Core) then
#ifdef _MOLCAS_
        call DaEras(dkh_48)
#else
        call daclos(dkh_48)
#endif
      endif
c
CMR The following routine does not work any longer since all individual
CMR   operator contributions formerly stored in scr6 for H and scr7 for X
CMR   were removed.
CMR      call write_operators (nbas,isize,dkhorder,xorder,dkhscfflg,scrno2,
CMR     *                      scr6,scr7,scr8,paramtype,clight)
c
CMR      write (stdout,1150)
CMR1150  format ('Numeric parser routines "dkhparser2" successfully ',
CMR     *        'completed.',//90('-'),/2X)
c
      return
c Avoid unuser argument warnings
      if (.false.) Call Unused_character(paramtype)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine IPO_CPF(IPOA,NVIR,MUL,NSYM,KLS,IFT)

use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: IPOA(*)
integer(kind=iwp), intent(in) :: NVIR(*), MUL(8,8), NSYM, KLS, IFT
integer(kind=iwp) :: M, N, NSUM

NSUM = 0
do N=1,NSYM
  IPOA(N) = NSUM
  M = MUL(N,KLS)
  if (IFT < 0) then
    NSUM = NSUM+NVIR(N)*NVIR(M)
  else if (N == M) then
    NSUM = NSUM+NVIR(N)*(NVIR(N)+1)/2
  else if (N > M) then
    NSUM = NSUM+NVIR(N)*NVIR(M)
  end if
end do
IPOA(NSYM+1) = NSUM

return

end subroutine IPO_CPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Sebastian Wouters                                *
!***********************************************************************
! Subroutine to convert character table in Molcas, Molpro and psi4
! Written by Sebastian Wouters, Leuven, Aug 2016

!  MOLCAS conventions (counting starts from 1)
!
!  'c1 '  ag
!  'ci '  ag  au
!  'c2 '  a   b
!  'cs '  a'  a"
!  'd2 '  a   b2  b1  b3
!  'c2v'  a1  b1  a2  b2
!  'c2h'  ag  bg  au  bu
!  'd2h'  ag  b2g b1g b3g au  b2u b1u b3u
!
!  MOLPRO conventions (counting starts from 1)
!
!  'c1 '  ag
!  'ci '  ag  au
!  'c2 '  a   b
!  'cs '  a'  a"
!  'd2 '  a   b3  b2  b1
!  'c2v'  a1  b1  b2  a2
!  'c2h'  ag  au  bu  bg
!  'd2h'  ag  b3u b2u b1g b1u b2g b3g au
!
!  PSI4 conventions (counting starts from 0)
!
!  'c1 '  ag
!  'ci '  ag  au
!  'c2 '  a   b
!  'cs '  a'  a"
!  'd2 '  a   b1  b2  b3
!  'c2v'  a1  a2  b1  b2
!  'c2h'  ag  bg  au  bu
!  'd2h'  ag  b1g b2g b3g au  b1u b2u b3u
!
subroutine group_psi4number( groupname, psi4number )

  implicit none
  character(len=3), intent(in)  :: groupname
  integer,      intent(out) :: psi4number

  psi4number = -1 ! Error output

  if ( groupname .eq. 'c1 ' ) psi4number = 0
  if ( groupname .eq. 'ci ' ) psi4number = 1
  if ( groupname .eq. 'c2 ' ) psi4number = 2
  if ( groupname .eq. 'cs ' ) psi4number = 3
  if ( groupname .eq. 'd2 ' ) psi4number = 4
  if ( groupname .eq. 'c2v' ) psi4number = 5
  if ( groupname .eq. 'c2h' ) psi4number = 6
  if ( groupname .eq. 'd2h' ) psi4number = 7

end subroutine

subroutine molpro2psi( groupname, conversion )

  implicit none
  character(len=3), intent(in)  :: groupname
  integer,      intent(out) :: conversion(8)
  integer,      parameter   :: X = -1

  conversion(1:8) = (/ X, X, X, X, X, X, X, X /) ! Error output

  if ( groupname .eq. 'c1 ' ) conversion(1:8) = (/ 1, X, X, X, X, X, X, X /)
  if ( groupname .eq. 'ci ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'c2 ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'cs ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'd2 ' ) conversion(1:8) = (/ 1, 4, 3, 2, X, X, X, X /)
  if ( groupname .eq. 'c2v' ) conversion(1:8) = (/ 1, 3, 4, 2, X, X, X, X /)
  if ( groupname .eq. 'c2h' ) conversion(1:8) = (/ 1, 3, 4, 2, X, X, X, X /)
  if ( groupname .eq. 'd2h' ) conversion(1:8) = (/ 1, 8, 7, 2, 6, 3, 4, 5 /)

end subroutine

subroutine psi2molpro( groupname, conversion )

  implicit none
  character(len=3), intent(in)  :: groupname
  integer,      intent(out) :: conversion(8)
  integer,      parameter   :: X = -1

  conversion(1:8) = (/ X, X, X, X, X, X, X, X /) ! Error output

  if ( groupname .eq. 'c1 ' ) conversion(1:8) = (/ 1, X, X, X, X, X, X, X /)
  if ( groupname .eq. 'ci ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'c2 ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'cs ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'd2 ' ) conversion(1:8) = (/ 1, 4, 3, 2, X, X, X, X /)
  if ( groupname .eq. 'c2v' ) conversion(1:8) = (/ 1, 4, 2, 3, X, X, X, X /)
  if ( groupname .eq. 'c2h' ) conversion(1:8) = (/ 1, 4, 2, 3, X, X, X, X /)
  if ( groupname .eq. 'd2h' ) conversion(1:8) = (/ 1, 4, 6, 7, 8, 5, 3, 2 /)

end subroutine

subroutine molcas2molpro( groupname, conversion )

  implicit none
  character(len=3), intent(in)  :: groupname
  integer,      intent(out) :: conversion(8)
  integer,      parameter   :: X = -1

  conversion(1:8) = (/ X, X, X, X, X, X, X, X /) ! Error output

  if ( groupname .eq. 'c1 ' ) conversion(1:8) = (/ 1, X, X, X, X, X, X, X /)
  if ( groupname .eq. 'ci ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'c2 ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'cs ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'd2 ' ) conversion(1:8) = (/ 1, 3, 4, 2, X, X, X, X /)
  if ( groupname .eq. 'c2v' ) conversion(1:8) = (/ 1, 2, 4, 3, X, X, X, X /)
  if ( groupname .eq. 'c2h' ) conversion(1:8) = (/ 1, 4, 2, 3, X, X, X, X /)
  if ( groupname .eq. 'd2h' ) conversion(1:8) = (/ 1, 6, 4, 7, 8, 3, 5, 2 /)

end subroutine

subroutine molpro2molcas( groupname, conversion )

  implicit none
  character(len=3), intent(in)  :: groupname
  integer,      intent(out) :: conversion(8)
  integer,      parameter   :: X = -1

  conversion(1:8) = (/ X, X, X, X, X, X, X, X /) ! Error output

  if ( groupname .eq. 'c1 ' ) conversion(1:8) = (/ 1, X, X, X, X, X, X, X /)
  if ( groupname .eq. 'ci ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'c2 ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'cs ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'd2 ' ) conversion(1:8) = (/ 1, 4, 2, 3, X, X, X, X /)
  if ( groupname .eq. 'c2v' ) conversion(1:8) = (/ 1, 2, 4, 3, X, X, X, X /)
  if ( groupname .eq. 'c2h' ) conversion(1:8) = (/ 1, 3, 4, 2, X, X, X, X /)
  if ( groupname .eq. 'd2h' ) conversion(1:8) = (/ 1, 8, 6, 3, 7, 2, 4, 5 /)

end subroutine

subroutine molcas2psi( groupname, conversion )

  implicit none
  character(len=3), intent(in)  :: groupname
  integer,      intent(out) :: conversion(8)
  integer,      parameter   :: X = -1

  conversion(1:8) = (/ X, X, X, X, X, X, X, X /) ! Error output

  if ( groupname .eq. 'c1 ' ) conversion(1:8) = (/ 1, X, X, X, X, X, X, X /)
  if ( groupname .eq. 'ci ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'c2 ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'cs ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'd2 ' ) conversion(1:8) = (/ 1, 3, 2, 4, X, X, X, X /)
  if ( groupname .eq. 'c2v' ) conversion(1:8) = (/ 1, 3, 2, 4, X, X, X, X /)
  if ( groupname .eq. 'c2h' ) conversion(1:8) = (/ 1, 2, 3, 4, X, X, X, X /)
  if ( groupname .eq. 'd2h' ) conversion(1:8) = (/ 1, 3, 2, 4, 5, 7, 6, 8 /)

end subroutine

subroutine psi2molcas( groupname, conversion )

  implicit none
  character(len=3), intent(in)  :: groupname
  integer,      intent(out) :: conversion(8)
  integer,      parameter   :: X = -1

  conversion(1:8) = (/ X, X, X, X, X, X, X, X /) ! Error output

  if ( groupname .eq. 'c1 ' ) conversion(1:8) = (/ 1, X, X, X, X, X, X, X /)
  if ( groupname .eq. 'ci ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'c2 ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'cs ' ) conversion(1:8) = (/ 1, 2, X, X, X, X, X, X /)
  if ( groupname .eq. 'd2 ' ) conversion(1:8) = (/ 1, 3, 2, 4, X, X, X, X /)
  if ( groupname .eq. 'c2v' ) conversion(1:8) = (/ 1, 3, 2, 4, X, X, X, X /)
  if ( groupname .eq. 'c2h' ) conversion(1:8) = (/ 1, 2, 3, 4, X, X, X, X /)
  if ( groupname .eq. 'd2h' ) conversion(1:8) = (/ 1, 3, 2, 4, 5, 7, 6, 8 /)

end subroutine

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Per-Olof Widmark                                 *
************************************************************************
************************************************************************
*                                                                      *
* This routine put scalar double data to the runfile.                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: August 2003                                                 *
*                                                                      *
************************************************************************
*  Put_dScalar
*
*> @brief
*>   To add/update scalar data in runfile
*> @author Per-Olof Widmark
*>
*> @details
*> This routine is used to put scalar data of type
*> ``Real*8`` into the runfile. The data items are
*> identified by the \p label. Below is a list of the
*> data items that are recognized. The labels are
*> case insensitive and significant to 16 characters.
*>
*> For development purposes you can use an unsupported
*> label. Whenever such a field is accessed a warning
*> message is printed in the output, to remind the
*> developer to update this routine.
*>
*> List of known labels:
*>
*> - '``CASDFT energy``'  Energy for the last CASDFT calculation.
*> - '``CASPT2 energy``'  Energy for the last CASPT2 calculation.
*> - '``CASSCF energy``'  Energy for the last CASSCF calculation.
*> - '``Ener_ab``'
*> - '``KSDFT energy``'   Energy for the last KS-DFT calculation.
*> - '``Last energy``'    Last energy computed.
*> - '``PC Self Energy``' Self energy for point charges.
*> - '``PotNuc``'         Nuclear repusion energy.
*> - '``RF Self Energy``' Self energy in the Kirkwood model.
*> - '``SCF energy``'     Energy for the last SCF calculation.
*> - '``EThr``'           Energy convergence threshold.
*> - '``Thrs``'
*> - '``UHF energy``'
*> - '``DFT exch coeff``' Scaling factor for exchange terms of a density
*>   functional
*> - '``DFT corr coeff``' Scaling factor for correlation terms of a
*>   density functional
*>
*> @param[in] Label Name of field
*> @param[in] Data  Data to put on runfile
************************************************************************
      Subroutine Put_dScalar(Label,Data)
      Implicit None
#include "pg_ds_info.fh"
*----------------------------------------------------------------------*
* Arguments                                                            *
*----------------------------------------------------------------------*
      Character*(*) Label
      Real*8        Data
*----------------------------------------------------------------------*
* Define local variables                                               *
*----------------------------------------------------------------------*
      Real*8       RecVal(nTocDS)
      Character*16 RecLab(nTocDS)
      Integer      RecIdx(nTocDS)
      Save         RecVal
      Save         RecLab
      Save         RecIdx
*
      Character*16 CmpLab1
      Character*16 CmpLab2
      Integer      nData
      Integer      item
      Integer      iTmp
      Integer      i
*----------------------------------------------------------------------*
* Initialize local variables                                           *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
* Do setup if this is the first call.                                  *
*----------------------------------------------------------------------*
*--- start pow mod ---
*     Write(6,'(3a)') 'Runfile: put_dscalar field "',Label,'"'
*--- end pow mod ---
      Call ffRun('dScalar labels',nData,iTmp)
      If(nData.eq.0) Then
         Do i=1,nTocDS
            RecLab(i)=' '
            RecVal(i)=0.0d0
            RecIdx(i)=sNotUsed
         End Do
*
*        Observe that label is at most 16 characters!
*
*                     1234567890123456
         RecLab(  1)='CASDFT energy   '
         RecLab(  2)='CASPT2 energy   '
         RecLab(  3)='CASSCF energy   '
         RecLab(  4)='Ener_ab         '
         RecLab(  5)='KSDFT energy    '
         RecLab(  6)='Last energy     '
         RecLab(  7)='PC Self Energy  '
         RecLab(  8)='PotNuc          '
         RecLab(  9)='RF Self Energy  '
         RecLab( 10)='SCF energy      '
         RecLab( 11)='Thrs            '
         RecLab( 12)='UHF energy      '
         RecLab( 13)='E_0_NN          '
         RecLab( 14)='W_or_el         '
         RecLab( 15)='W_or_Inf        '
         RecLab( 16)='EThr            '
         RecLab( 17)='Cholesky Thresho' !ld
         RecLab( 18)='Total Nuclear Ch' !arge
         RecLab( 19)='Numerical Gradie' !nt rDelta
         RecLab( 20)='MpProp Energy   '
         RecLab( 21)='UHFSPIN         '
         RecLab( 22)='S delete thr    '
         RecLab( 23)='T delete thr    '
         RecLab( 24)='MD_Etot0        '
         RecLab( 25)='MD_Time         '
         RecLab( 26)='LDF Accuracy    '
         RecLab( 27)='NAD dft energy  '
         RecLab( 28)='GradLim         '
         RecLab( 29)='StepFactor      '
         RecLab( 30)='Average energy  '
         RecLab( 31)='Timestep        '
         RecLab( 32)='MD_Etot         '
         RecLab( 33)='Max error       '
         RecLab( 34)='Total Charge    ' ! total number of electrons
         RecLab( 35)='DFT exch coeff  '
         RecLab( 36)='DFT corr coeff  '
         RecLab( 37)='Value_l         '
*                     1234567890123456
*
*        If u go beyond 64: update pg_ds_info.fh and this line!
         Call cWrRun('dScalar labels',RecLab,16*nTocDS)
         Call dWrRun('dScalar values',RecVal,nTocDS)
         Call iWrRun('dScalar indices',RecIdx,nTocDS)
      Else
         Call cRdRun('dScalar labels',RecLab,16*nTocDS)
         Call dRdRun('dScalar values',RecVal,nTocDS)
         Call iRdRun('dScalar indices',RecIdx,nTocDS)
      End If
*----------------------------------------------------------------------*
* Locate item                                                          *
*----------------------------------------------------------------------*
      item=-1
      CmpLab1=Label
      Call UpCase(CmpLab1)
      Do i=1,nTocDS
         CmpLab2=RecLab(i)
         Call UpCase(CmpLab2)
         If(CmpLab1.eq.CmpLab2) item=i
      End Do
*
* Do we create a new temporary field?
*
      If(item.eq.-1) Then
         Do i=1,nTocDS
            If(RecLab(i).eq.' ') item=i
         End Do
         If(item.ne.-1) Then
            RecLab(item)=Label
            RecIdx(item)=sSpecialField
            Call cWrRun('dScalar labels',RecLab,16*nTocDS)
            Call iWrRun('dScalar indices',RecIdx,nTocDS)
         End If
      End If
*
* Is this a temporary field?
*
      If(item.ne.-1) Then
         If(Recidx(item).eq.sSpecialField) Then
            Write(6,*) '***'
            Write(6,*) '*** Warning, writing temporary dScalar field'
            Write(6,*) '***   Field: ',Label
            Write(6,*) '***'
#ifndef _DEVEL_
            Call AbEnd()
#endif
         End If
      End If
*----------------------------------------------------------------------*
* Write data to disk.                                                  *
*----------------------------------------------------------------------*
      If(item.eq.-1) Then
         Call SysAbendMsg('put_dScalar','Could not locate',Label)
      End If
      RecVal(item)=Data
      Call dWrRun('dScalar values',RecVal,nTocDS)
      If(RecIdx(item).eq.0) Then
         RecIdx(item)=sRegularField
         Call iWrRun('dScalar indices',RecIdx,nTocDS)
      End If
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Do i=1,num_DS_init
         If(iLbl_DS_inmem(i).eq.CmpLab1) then
             i_DS_inmem(i)=Data
             DS_init(i)=1
             return
         End If
      End Do

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE DIATERMS_GAS(   NAEL,  IASTR,   NBEL,  IBSTR,   NORB,
     &                            VEC,  NSMST,      H,    IDC,
     &                             XB,             RJ,     RK,  NSSOA,
     &                          NSSOB,  ECORE,   LUIN,  LUOUT,  IPRNT,
     &                          NTOOB,  RJKAA,    I12, IBLOCK, NBLOCK,
*
     &                          ITASK, FACTOR,  I0CHK,  I0BLK)
*
* Terms from diagonal to specific blocks
*
* Obtain VEC = (DIAGONAL + FACTOR) ** -1 VEC (ITASK = 1)
* Obtain VEC = (DIAGONAL + FACTOR)       VEC (ITASK = 2)
*
* Calculate determinant diagonal
*
* ========================
* General symmetry version
* ========================
*
* Jeppe Olsen, July 1995, GAS version
*
* I12 = 1 => only one-body part
*     = 2 =>      one+two-body part
*
      IMPLICIT REAL*8           (A-H,O-Z)
#include "io_util.fh"
*.General input
      DIMENSION NSSOA(NSMST,*), NSSOB(NSMST,*)
      DIMENSION H(NORB)
      DIMENSION IBLOCK(8,*)
*.
      INTEGER I0BLK(*)
*. Scratch
      DIMENSION RJ(NTOOB,NTOOB),RK(NTOOB,NTOOB)
      DIMENSION XB(NORB)
      DIMENSION IASTR(NAEL,*),IBSTR(NBEL,*)
      DIMENSION RJKAA(*)
*. Output
      DIMENSION VEC (*)

      INTEGER IDUM_ARR(1)
*
      NTEST =  00
      NTEST = MAX(NTEST,IPRNT)
C?    WRITE(6,*) ' NTEST = ',NTEST
*
      IF(LUIN.GT.0) IDISK(LUIN)=0
      IF(LUOUT.GT.0) IDISK(LUOUT)=0

      IF( NTEST .GE. 20 ) THEN
        WRITE(6,*) ' ======================= '
        WRITE(6,*) ' DIATERMS_GAS in action '
        WRITE(6,*) ' ======================= '
        WRITE(6,*)
        WRITE(6,*) ' LUIN,LUOUT = ', LUIN,LUOUT
        WRITE(6,*) ' NBLOCK =', NBLOCK
        WRITE(6,*) ' I0CHK = ', I0CHK
      END IF
*
      IF(NTEST.GE.1000) THEN
        WRITE(6,*) ' Diagonal one electron integrals'
        CALL WRTMAT(H,1,NORB,1,NORB)
        IF(I12.EQ.2) THEN
          WRITE(6,*) ' Coulomb and exchange integrals '
          CALL WRTMAT(RJ,NORB,NORB,NTOOB,NTOOB)
          WRITE(6,*)
          CALL WRTMAT(RK,NORB,NORB,NTOOB,NTOOB)
          WRITE(6,*) ' I12 and ITASK = ', I12,ITASK
        END IF
      WRITE(6,*) ' FACTOR = ',FACTOR
      END IF
*
**3 Diagonal elements according to Handys formulae
*   (corrected for error)
*
*   DIAG(IDET) = HII*(NIA+NIB)
*              + 0.5 * ( J(I,J)-K(I,J) ) * NIA*NJA
*              + 0.5 * ( J(I,J)-K(I,J) ) * NIB*NJB
*              +         J(I,J) * NIA*NJB
*
*. K goes to J - K
      IF(I12.EQ.2)
     &CALL VECSUM(RK,RK,RJ,-1.0D0,+1.0D0,NTOOB **2)
*
      ITDET = 0
      IDET = 0
      DO JBLOCK = 1, NBLOCK
        IF(IBLOCK(1,JBLOCK).GT.0) THEN
        IATP = IBLOCK(1,JBLOCK)
        IBTP = IBLOCK(2,JBLOCK)
        IASM = IBLOCK(3,JBLOCK)
        IBSM = IBLOCK(4,JBLOCK)
        IOFF = IBLOCK(6,JBLOCK)
        IF(NTEST.GE.20) THEN
         WRITE(6,*) ' Block in action : IATP IBTP IASM IBSM ',
     &               IATP,IBTP,IASM,IBSM
        END IF
*
        IF(IDC.EQ.2.AND.IASM.EQ.IBSM.AND.IATP.EQ.IBTP) THEN
          IPACK = 1
        ELSE
          IPACK = 0
        END IF
*
*
*. Construct array RJKAA(*) =   SUM(I) H(I)*N(I) +
*                           0.5*SUM(I,J) ( J(I,J) - K(I,J))*N(I)*N(J)
*
*. Obtain alpha strings of sym IASM and type IATP
        IDUM_ARR = 0
        CALL GETSTR_TOTSM_SPGP(      1,   IATP,   IASM,   NAEL, NASTR1,
     &                           IASTR,   NORB,     0,IDUM_ARR,IDUM_ARR)
        IF(NTEST.GE.1000) THEN
          write(6,*) ' After GETSTR for A strings '
          WRITE(6,*) ' alpha strings obtained '
          NAST = NSSOA(IASM,IATP)
          CALL IWRTMA(IASTR,NAEL,NAST,NAEL,NAST)
        END IF
*
        IOFF =  1
        NIA = NSSOA(IASM,IATP)
        DO IA = 1 ,NSSOA(IASM,IATP)
          EAA = 0.0D0
          DO IEL = 1, NAEL
            IAEL = IASTR(IEL,IA)
            EAA = EAA + H(IAEL)
            IF(I12.EQ.2) THEN
              DO JEL = 1, NAEL
                EAA =   EAA + 0.5D0*RK(IASTR(JEL,IA),IAEL )
              END DO
            END IF
          END DO
          RJKAA(IA-IOFF+1) = EAA
        END DO
*. Obtain alpha strings of sym IBSM and type IBTP
        CALL GETSTR_TOTSM_SPGP(      2,   IBTP,   IBSM,   NBEL, NBSTR1,
     &                           IBSTR,   NORB,     0,IDUM_ARR,IDUM_ARR)
        NIB =  NSSOB(IBSM,IBTP)
*
        IMZERO=0
        IF(LUIN.GT.0) THEN
          CALL IDAFILE(LUIN,2,IDUM_ARR,1,IDISK(LUIN))
          LDET=IDUM_ARR(1)
          CALL IDAFILE(LUIN,2,IDUM_ARR,1,IDISK(LUIN))
          IDET = 0
          CALL FRMDSC(   VEC(1),     LDET,       -1,     LUIN,   IMZERO,
     &                  IAMPACK)
        END IF
*
        IF(I0CHK.EQ.1) THEN
          IMZERO = I0BLK(JBLOCK)
          IF(IMZERO.EQ.1) THEN
*.Update offset to next block
            IF(IPACK.EQ.1.AND.IATP.EQ.IBTP) THEN
              IDET = IDET + NIA*(NIA+1)/2
            ELSE
              IDET = IDET + NIA*NIB
            END IF
          END IF
        END IF
C?      WRITE(6,*) ' DIATERMS_GAS : I0CHK,JBLOCK IMZERO',
C?   &  I0CHK,JBLOCK,IMZERO
*
        IF(IMZERO.NE.1) THEN
*. Calculate ...
*
        DO IB = 1 ,NIB
*
*. Terms depending only on IB
*
          HB = 0.0D0
          RJBB = 0.0D0
          CALL SETVEC(XB,0.0D0,NORB)

          DO IEL = 1, NBEL
            IBEL = IBSTR(IEL,IB)
            HB = HB + H(IBEL )
*
            IF(I12.EQ.2) THEN
              DO JEL = 1, NBEL
                RJBB = RJBB + RK(IBSTR(JEL,IB),IBEL )
              END DO
*
              DO IORB = 1, NORB
                XB(IORB) = XB(IORB) + RJ(IORB,IBEL)
              END DO
            END IF
          END DO
          EB = HB + 0.5D0*RJBB + ECORE
*
          IF(IPACK.EQ.1.AND.IATP.EQ.IBTP) THEN
            IASTRT =  IB
          ELSE
            IASTRT = 1
          END IF
*
          IASTOP = NSSOA(IASM,IATP)
          DO IA = IASTRT,IASTOP
            IDET = IDET + 1
            ITDET = ITDET + 1
            X = EB + RJKAA(IA-IOFF+1)
            DO IEL = 1, NAEL
              X = X +XB(IASTR(IEL,IA))
            END DO
* Obtain VEC = (DIAGONAL + FACTOR) ** -1 VEC (ITASK = 1)
* Obtain VEC = (DIAGONAL + FACTOR)       VEC (ITASK = 2)
            IF(ITASK.EQ.1) THEN
              IF(ABS(X+FACTOR) .GT. 1.0D-10) THEN
                VEC(IDET) = VEC(IDET)/(X+FACTOR)
              ELSE
                VEC(IDET) = 0.0D0
              END IF
            ELSE
              VEC(IDET) = VEC(IDET)*(X+FACTOR)
            END IF
C?         write(6,*) ' IDET,X,VEC(IDET) ', IDET,X,VEC(IDET)
          END DO
        END DO
        END IF
*
        IF(LUOUT.GT.0) THEN
          CALL ITODS([LDET],1,-1,LUOUT)
          CALL TODSC(VEC,LDET,-1,LUOUT)
C?        WRITE(6,*) ' Number of elements transferred to DISC ',
C?   &    LDET
          IDET = 0
        END IF
*
      END IF
      END DO
*
      IF(LUOUT.GT.0) THEN
       CALL ITODS([-1],1,-1,LUOUT)
      END IF
*
C?    WRITE(6,*) ' Mission DIATERMS finished '
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine span_cvb(a,nvec,nlin,s,n,metr)
! Creates span of a vector set.
! On entry : A is NVEC by N
! On exit  : NLIN is the number of linearly independent vectors
!            A contains set of NLIN linearly independent vectors
!              spanning the same set as the NVEC input vectors
!              Vectors will be orthonormal on exit

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nvec, n, metr
real(kind=wp), intent(inout) :: a(n,nvec)
integer(kind=iwp), intent(out) :: nlin
real(kind=wp), intent(in) :: s(*)
integer(kind=iwp) :: i, ierr, nvect
real(kind=wp) :: cnrm
real(kind=wp), parameter :: thresh = 1.0e-10_wp
real(kind=wp), external :: dnrm2_

nvect = nvec
ierr = 1
call nize_cvb(a,nvect,s,n,metr,ierr)
call schmidt_cvb(a,nvect,s,n,metr)
nlin = 0
do i=1,nvect
  cnrm = dnrm2_(n,a(:,i),1)
  if (cnrm > thresh) then
    nlin = nlin+1
    a(:,nlin) = a(:,i)
  end if
end do
ierr = 1
call nize_cvb(a,nlin,s,n,metr,ierr)

return

end subroutine span_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKTG3(LSYM1,LSYM2,CI1,CI2,OVL,TG1,TG2,NTG3,TG3)
! Procedure for computing 1-body, 2-body, and 3-body transition
! density elements with active indices only.

! In: Wave functions CI1, with symmetry LSYM1, and CI2, with
!  symmetry LSYM2.
!
! Out: Transition density matrices, denoted here TG1, TG2 and TG3.
! Storage: TG1 and TG2 are simple two- and four-index arrays, and
! includes also such zeroes that are implied by symmetry.
! But TG3 is quite large, and while it is stored with zeroes, it
! is made more compact by the following addressing:

! <Psi1|E_tuvxyz|Psi2> is stored in TG3(ITG3) where
!    ITG3= nTri3_Elem(i-1) + nTri_Elem(j-1) + k
!     i  = max(tu,vx,yz)
!     j  = mid(tu,vx,yz)
!     k  = min(tu,vx,yz)
! tu stands for the pair index tu= t + NASHT*(u-1), etc., and t is
! the usual active orbital number, when they are enumerated across
! all the symmetries (The "absolute" active index).

use Index_Functions, only: nTri_Elem, nTri3_Elem
use Symmetry_Info, only: Mul
use sguga, only: CIS, EXS, L2ACT, SGS
use caspt2_module, only: IASYM, ISCF, NACTEL, NASHT
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs, MyRank
#endif
use caspt2_module, only: MxCI
use stdalloc, only: mma_allocate, mma_deallocate, mma_MaxDBLE
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LSYM1, LSYM2, NTG3
real(kind=wp), intent(in) :: CI1(MXCI), CI2(MXCI)
real(kind=wp), intent(out) :: OVL, TG1(NASHT,NASHT), TG2(NASHT,NASHT,NASHT,NASHT), TG3(NTG3)
integer(kind=iwp) :: IL, IND1, IND2, IND3, IP, IP1, IP1END, IP1STA, IP2, IP3, IP3END, IP3STA, IS1, IS2, IS3, ISSG1, ISSG2, ISTAU, &
                     IT, IT1, IT2, IT3, ITG3, ITS, IU, IU1, IU2, IU3, IUS, IV, IVS, IX, IXS, IY, IYS, IZ, IZS, JL, jtuvxyz, L, &
                     LFROM, LSGM1, LSGM2, LTAU, LTO, NCI1, nLev, NTAU, NTG3WRK, NTUBUF, NVECS, NYZBUF
real(kind=wp) :: OCC, VAL
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iTask
logical(kind=iwp) :: Poor_Par
#endif
integer(kind=iwp), allocatable :: P2LEV(:,:)
real(kind=wp), allocatable :: TG3WRK(:)
real(kind=wp), external :: DDot_

nLev = SGS%nLev

! Put in zeroes. Recognize special cases:
OVL = One
if (NASHT == 0) return
if (LSYM1 /= LSYM2) OVL = Zero
TG1(:,:) = Zero
TG2(:,:,:,:) = Zero
TG3(:) = Zero

if (NACTEL == 0) return

if (ISCF == 0) then

  ! Here, for regular CAS or RAS cases.

  ! Special pair index allows true RAS cases to be handled:
  call mma_allocate(P2LEV,2,NASHT**2,Label='P2LEV')
  IP = 0
  ! First, IL < JL pairs.
  do IL=1,NLEV-1
    P2LEV(1,IP+1:IP+NLEV-IL) = IL
    P2LEV(2,IP+1:IP+NLEV-IL) = [(JL,JL=IL+1,NLEV)]
    IP = IP+NLEV-IL
  end do
  ! Then, IL = JL pairs.
  P2LEV(1,IP+1:IP+NLEV) = [(IL,IL=1,NLEV)]
  P2LEV(2,IP+1:IP+NLEV) = [(IL,IL=1,NLEV)]
  IP = IP+NLEV
  ! Last, IL > JL pairs.
  do IL=2,NLEV
    P2LEV(1,IP+1:IP+IL-1) = IL
    P2LEV(2,IP+1:IP+IL-1) = [(JL,JL=1,IL-1)]
    IP = IP+IL-1
  end do
  ! If now any matrix element E(t1u1)E(t2u2)..E(tnun) is arranged
  ! such that the pair indices are non-decreasing, then the matrix
  ! element can be correctly computed by performing explicit
  ! excitations within the RAS space.
  ! But we also need the 'usual' pair index in order to use the
  ! packed addressing.

  NCI1 = CIS%NCSF(LSYM1)
  ! Overlap:
  if (LSYM1 == LSYM2) OVL = DDOT_(NCI1,CI1,1,CI2,1)
  ! Allocate as many vectors as possible:
  ! Wishful thinking:
  NVECS = 2*NASHT**2+1
  ! But what is really available?
  call mma_MaxDBLE(NTG3WRK)
  NTG3WRK = min(MXCI*NVECS,NTG3WRK)
  NVECS = NTG3WRK/MXCI
  NTG3WRK = NVECS*MXCI
  ! Find optimal subdivision of available vectors:
  NYZBUF = nint(real(NVECS-1,kind=wp)/real(NASHT,kind=wp))
  NYZBUF = max(1,NYZBUF)
  NTUBUF = min(NASHT**2,NVECS-1-NYZBUF)
  NYZBUF = NVECS-1-NTUBUF
  ! Insufficient memory?
  if (NTUBUF <= 0) then
    write(u6,*) ' Too little memory left for MKTG3.'
    write(u6,*) ' Need at least 3 vectors of length MXCI=',MXCI
    call ABEND()
  end if
  if (NTUBUF <= (NASHT**2)/5) then
    write(u6,*) ' WARNING: MKTG3 will be inefficient owing to'
    write(u6,*) ' small memory.'
  end if
  call mma_allocate(TG3WRK,NTG3WRK,Label='TG#WRK')
  ! And divide it up:
  LSGM1 = 1
  LTAU = LSGM1+NTUBUF*MXCI
  LSGM2 = LTAU+MXCI

# ifdef _MOLCAS_MPP_
  !! enable poor parallelization, if applicable
  if (Is_Real_Par()) then
    POOR_PAR = .false.
    iTask = 0
    !if ((NTUBUF == NYZBUF) .and. (NTUBUF == NASHT**2)) POOR_PAR = .true.
  end if
# endif
  ! Sectioning loops over pair indices IP3 (ket side):
  do IP3STA=1,NASHT**2,NYZBUF
    IP3END = min(NASHT**2,IP3STA-1+NYZBUF)
    ! Compute a section of sigma vectors E(YZ)*PSI2 to memory:
    LTO = LSGM2
    do IP3=IP3STA,IP3END
      ! Translate to levels in the SGUGA coupling order:
      IL = P2LEV(1,IP3)
      JL = P2LEV(2,IP3)
      IY = L2ACT(IL)
      IZ = L2ACT(JL)
      IYS = IASYM(IY)
      IZS = IASYM(IZ)
      ISSG2 = Mul(Mul(IYS,IZS),LSYM2)
      TG3WRK(LTO:LTO+MXCI-1) = Zero
      ! LTO is first element of Sigma2 = E(YZ) Psi2
      call SG_Epq_Psi(SGS,CIS,EXS,IL,JL,One,LSYM2,CI2,TG3WRK(LTO))
      if (ISSG2 == LSYM1) TG1(IY,IZ) = DDOT_(NCI1,CI1,1,TG3WRK(LTO),1)
      LTO = LTO+MXCI
    end do
    ! Sectioning loops over pair indices IP1 (bra side):
    do IP1STA=IP3STA,NASHT**2,NTUBUF
      IP1END = min(NASHT**2,IP1STA-1+NTUBUF)
      ! Compute a section of sigma vectors E(UT)*PSI1 to memory:
      LTO = LSGM1
      do IP1=IP1STA,IP1END
        ! Translate to levels:
        JL = P2LEV(1,IP1)
        IL = P2LEV(2,IP1)
        IT = L2ACT(IL)
        IU = L2ACT(JL)
        ITS = IASYM(IT)
        IUS = IASYM(IU)
        ISSG1 = Mul(Mul(ITS,IUS),LSYM1)
        TG3WRK(LTO:LTO+MXCI-1) = Zero
        call SG_Epq_Psi(SGS,CIS,EXS,IL,JL,One,LSYM1,CI1,TG3WRK(LTO))
        LTO = LTO+MXCI
      end do
      ! Now compute as many elements as possible:
      LFROM = LSGM2
      do IP3=IP3STA,IP3END
#       ifdef _MOLCAS_MPP_
        if (Is_Real_Par()) then
          iTask = iTask+1
          if (POOR_PAR .and. (mod(iTask,nProcs) /= MyRank)) then
            LFROM = LFROM+MXCI
            cycle
          end if
        end if
#       endif
        IY = L2ACT(P2LEV(1,IP3))
        IZ = L2ACT(P2LEV(2,IP3))
        ! LFROM will be start element of Sigma2=E(YZ) Psi2
        IYS = IASYM(IY)
        IZS = IASYM(IZ)
        ISSG2 = Mul(Mul(IYS,IZS),LSYM2)
        do IP2=IP3,IP1END
          IL = P2LEV(1,IP2)
          JL = P2LEV(2,IP2)
          IV = L2ACT(IL)
          IX = L2ACT(JL)
          IVS = IASYM(IV)
          IXS = IASYM(IX)
          ISTAU = Mul(Mul(IVS,IXS),ISSG2)
          NTAU = CIS%NCSF(ISTAU)
          TG3WRK(LTAU:LTAU+MXCI-1) = Zero
          ! LTAU  will be start element of Tau=E(VX) Sigma2=E(VX) E(YZ) Psi2
          call SG_Epq_Psi(SGS,CIS,EXS,IL,JL,One,ISSG2,TG3WRK(LFROM),TG3WRK(LTAU))
          if (ISTAU == LSYM1) TG2(IV,IX,IY,IZ) = DDOT_(NTAU,TG3WRK(LTAU),1,CI1,1)
          do IP1=max(IP2,IP1STA),IP1END
            IT = L2ACT(P2LEV(1,IP1))
            IU = L2ACT(P2LEV(2,IP1))
            ITS = IASYM(IT)
            IUS = IASYM(IU)
            ISSG1 = Mul(Mul(ITS,IUS),LSYM1)
            if (ISSG1 == ISTAU) then
              L = LSGM1+MXCI*(IP1-IP1STA)
              VAL = DDOT_(NTAU,TG3WRK(LTAU),1,TG3WRK(L),1)
              ! Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
              ! Code to put it in correct place:
              call get_tg3_index(IT,IU,IV,IX,IY,IZ,NASHT,jtuvxyz)
              TG3(JTUVXYZ) = VAL

              ! End of symmetry requirement IF-clause:
            end if
            ! End of IP1 loop.
          end do
          ! End of IP2 loop.
        end do
        LFROM = LFROM+MXCI
        ! End of IP3 loop.
      end do
      ! End of IP1STA sectioning loop
    end do
    ! End of IP3STA sectioning loop
  end do
  call mma_deallocate(TG3WRK)
  ! Now the computed elements of TG2 contain <PSI1|E(IT1,IU1)E(IT2,IU2)|PSI2>
  ! and TG3 contains <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
  ! Add here the necessary Kronecker deltas times 2-body matrix
  ! elements and lower, so we get a true normal-ordered density matrix
  ! element.

# ifdef _MOLCAS_MPP_
  if (Is_Real_Par() .and. POOR_PAR) then
    call GADGOP(TG2,NASHT**4,'+')
    call GADGOP(TG3,NTG3,'+')
  end if
# endif

  ! First, the 2-particle density matrix:
  ! <PSI1|E(T,U,V,X)|PSI2>  = <PSI1|E(TU)E(VX)|PSI2> - D(V,U)*TG2(T,U,V,X)
  do IP1=1,NASHT**2
    IT = L2ACT(P2LEV(1,IP1))
    IU = L2ACT(P2LEV(2,IP1))
    do IP2=1,IP1
      IV = L2ACT(P2LEV(1,IP2))
      IX = L2ACT(P2LEV(2,IP2))
      if (IV == IU) TG2(IT,IU,IV,IX) = TG2(IT,IU,IV,IX)-TG1(IT,IX)
      TG2(IV,IX,IT,IU) = TG2(IT,IU,IV,IX)
    end do
  end do
  ! and then the 3-particle density matrix:
  ! <PSI1|E(T,U,V,X,Y,Z)|PSI2>  = <PSI1|E(TU)E(VX)E(YZ)|PSI2>
  ! -D(Y,X)*(TG2(T,U,V,Z)+D(V,U)*TG1(T,Z))
  ! -D(V,U)*TG2(T,X,Y,Z) C -D(Y,U)*TG2(V,X,T,Z)
  do IP1=1,NASHT**2
    IT = L2ACT(P2LEV(1,IP1))
    IU = L2ACT(P2LEV(2,IP1))
    ITS = IASYM(IT)
    IUS = IASYM(IU)
    IS1 = Mul(Mul(ITS,IUS),LSYM1)
    do IP2=1,IP1
      IV = L2ACT(P2LEV(1,IP2))
      IX = L2ACT(P2LEV(2,IP2))
      IVS = IASYM(IV)
      IXS = IASYM(IX)
      IS2 = Mul(Mul(IVS,IXS),IS1)
      do IP3=1,IP2
        IY = L2ACT(P2LEV(1,IP3))
        IZ = L2ACT(P2LEV(2,IP3))
        IYS = IASYM(IY)
        IZS = IASYM(IZ)
        IS3 = Mul(Mul(IYS,IZS),IS2)
        if (IS3 == LSYM2) then
          call get_tg3_index(IT,IU,IV,IX,IY,IZ,NASHT,jtuvxyz)
          VAL = TG3(JTUVXYZ)
          if (IY == IX) then
            VAL = VAL-TG2(IT,IU,IV,IZ)
            if (IV == IU) VAL = VAL-TG1(IT,IZ)
          end if
          if (IV == IU) VAL = VAL-TG2(IT,IX,IY,IZ)
          if (IY == IU) VAL = VAL-TG2(IV,IX,IT,IZ)
          TG3(JTUVXYZ) = VAL
        end if
      end do
    end do
  end do
  call mma_deallocate(P2LEV)

else

  ! -Special code for the closed-shell or hi-spin cases:
  ! ISCF=1 for closed-shell, =2 for hispin
  OCC = Two
  if (ISCF == 2) OCC = One
  do IT=1,NASHT
    TG1(IT,IT) = OCC
  end do
  if (NACTEL == 1) return
  do IT=1,NASHT
    do IU=1,NASHT
      TG2(IT,IT,IU,IU) = TG1(IT,IT)*TG1(IU,IU)
      if (IU == IT) then
        TG2(IT,IT,IU,IU) = TG2(IT,IT,IU,IU)-TG1(IT,IU)
      else
        TG2(IT,IU,IU,IT) = -TG1(IT,IT)
      end if
    end do
  end do
  if (NACTEL == 2) return
  do IT1=1,NLEV
    do IU1=1,NLEV
      IND1 = IT1+NASHT*(IU1-1)
      do IT2=1,NLEV
        do IU2=1,IU1
          IND2 = IT2+NASHT*(IU2-1)
          if (IND2 > IND1) cycle
          do IT3=1,NLEV
            do IU3=1,IU2
              IND3 = IT3+NASHT*(IU3-1)
              if (IND3 > IND2) cycle
              VAL = TG1(IT1,IU1)*TG1(IT2,IU2)*TG1(IT3,IU3)

              ! Here VAL is the value <PSI1|E(IT1,IU1)E(IT2,IU2)E(IT3,IU3)|PSI2>
              ! Add here the necessary Kronecker deltas times 2-body matrix
              ! elements and lower, so we get a true normal-ordered density matrix
              ! element.

              ! <PSI1|E(T1,U1,T2,U2,T3,U3)|PSI2>
              ! = <PSI1|E(T1,U1)E(T2,U2)E(T3,U3)|PSI2>
              ! -D(T3,U2)*(TG2(T1,U1,T2,U3)+D(T2,U1)*TG1(T1,U3))
              ! -D(T2,U1)*TG2(T1,U2,T3,U3)
              ! -D(T3,U1)*TG2(T2,U2,T1,U3)

              if (IT3 == IU2) then
                VAL = VAL-TG2(IT1,IU1,IT2,IU3)
                if (IT2 == IU1) VAL = VAL-TG1(IT1,IU3)
              end if
              if (IT2 == IU1) VAL = VAL-TG2(IT1,IU2,IT3,IU3)
              if (IT3 == IU1) VAL = VAL-TG2(IT2,IU2,IT1,IU3)

              ! VAL is now =<PSI1|E(IT1,IU1,IT2,IU2,IT3,IU3)|PSI2>
              ITG3 = nTri3_Elem(IND1-1)+nTri_Elem(IND2-1)+IND3
              TG3(ITG3) = VAL

            end do
          end do
        end do
      end do
    end do
  end do

end if

end subroutine MKTG3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine MltNuc(CoOP,Chrg,Coor,nAtm,rNucMm,ir,nComp)
************************************************************************
*                                                                      *
* Object: to compute the multipole moments for the nuclei.             *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 Chrg(nAtm), Coor(3,nAtm), rNucMm((ir+1)*(ir+2)/2), CoOp(3)
*
      iRout = 124
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In MltNuc:Coor',' ',Coor,3,nAtm)
         Call RecPrt(' In MltNuc:Chrg',' ',Chrg,nAtm,1)
         Call RecPrt(' In MltNuc:CoOp',' ',CoOp,1,3)
      End If
*
*     Compute the nuclear contribution to the multipole moments
*
      ip = 0
      Do 71 ix = ir, 0, -1
         Do 72 iy = ir-ix, 0, -1
            ip = ip + 1
            iz = ir-ix-iy
            temp = Zero
*           Write (*,*) ' ix,iy,iz=',ix,iy,iz
            Do 73 iAtom = 1, nAtm
               If (ix.eq.0) Then
                  CCoMx=One
               Else
                  CCoMx=(Coor(1,iAtom)-CoOp(1))**ix
               End If
               If (iy.eq.0) Then
                  CCoMy=One
               Else
                  CCoMy=(Coor(2,iAtom)-CoOp(2))**iy
               End If
               If (iz.eq.0) Then
                  CCoMz=One
               Else
                  CCoMz=(Coor(3,iAtom)-CoOp(3))**iz
               End If
*              Write (*,*) CCoMx, CCoMy, CCoMz, temp
               temp = temp + Chrg(iAtom) * CCoMx * CCoMy * CCoMz
 73         Continue
            rNucMm(ip) = temp
 72      Continue
 71   Continue
*
      If (iPrint.ge.99) Call RecPrt(' Nuclear Multipole Moments',
     &                              ' ',rNucMm,ip,1)
      Return
      If (.False.) Call Unused_integer(nComp)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine transp_cvb(a,b,n1,n2)
c  Transposes matrix A; A and B may share memory.
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension a(n1,n2),b(n2,n1)

      i1 = mstackr_cvb(n2*n1)
      iskip=-n2+i1-1
      do 100 i=1,n1
      iskip=iskip+n2
      do 101 j=1,n2
      w(j+iskip)=a(i,j)
101   continue
100   continue
      call fmove_cvb(w(i1),b,n2*n1)
      call mfreer_cvb(i1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Ignacio Fdez. Galvan                             *
************************************************************************
      Logical Function Is_First_Iter()
      Implicit None
      Character(Len=80) :: EnvStr
      Integer :: Iter, Iter_S
      Logical :: Found
      Integer, Dimension(7) :: Tmp

      ! If this is the first iteration in a "saddle" branch
      Call qpg_iScalar('Saddle Iter',Found)
      If (Found) Then
        Call Get_iScalar('Saddle Iter',Iter_S)
        If (Iter_S .eq. 0) Then
          Is_First_Iter = .True.
          Return
        Else
          Is_First_Iter = .False.
          Return
        End If
      End If

      ! If Slapaf information has been stripped out (e.g. IRC restart)
      Call qpg_iArray('Slapaf Info 1',Found,Tmp(1))
      If (Found) Then
        Call Get_iArray('Slapaf Info 1',Tmp,7)
        If (Tmp(1) .eq. -99) Then
          Is_First_Iter = .True.
          Return
        End If
      End If

      ! If MOLCAS_ITER <= 1
      Call Getenvf("MOLCAS_ITER",EnvStr)
      Read (EnvStr,*) Iter
      If (Iter .le. 1) Then
        Is_First_Iter = .True.
        Return
      End If

      Is_First_Iter = .False.

      End Function Is_First_Iter

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Ex_spin(rD,Fock,Temp1,ntemp,Temp2)
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
      Real*8 rD(*),Fock(*),Temp1(*),Temp2(*)
*
*
      call dcopy_(ndens2,[0.0d0],0,Temp2,1)
      Do jS=1,nSym
         Call FZero(Fock(ipCm(js)),nbas(js)**2)
         Do kS=1,nsym
*
*...To be debugged!
*
            If (nBas(js)*nash(ks).gt.0) Then
*
               Do llB = 1, nAsh(kS)
                  lB=nIsh(kS)+llB
                  Do jjB = 1, nAsh(kS)
                     jB=nIsh(kS)+jjB
*
                     Call Exch(jS,kS,jS,kS,lB,jB,Temp2,Temp2)
                     rDens=-0.5d0*rD(nna*(jjB-1)+llB)
                     Call DaXpY_(nBas(jS)**2,rDens,Temp1,1,
     &                          Fock(ipCM(jS)),1)

*
                  End Do
               End Do
*
            End If
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(ntemp)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_TestBookmark(irc,verbose,is1CCD)

use Cholesky, only: Cho_1Center, DiaMax, DiaMaxT, iAtomShl, nnBstRT, nSym, NumCho, NumChT, ThrCom
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
logical(kind=iwp), intent(in) :: verbose, is1CCD
logical(kind=iwp) :: Cho_1Center_Bak, dealloc
integer(kind=iwp) :: iSym, jrc, NumChoBak(8), NumChTBak, nVec(8)
real(kind=wp) :: delta(8), ErrMx, Thr, ThrComBak
real(kind=wp), allocatable :: BkmDia(:), BkmDiaX(:)
character(len=*), parameter :: SecNam = 'Cho_TestBookmark'

irc = 0

if (verbose) call Cho_Head('Output from '//SecNam,'=',80,u6)

! test 1: asking for accuracy below decomposition threshold
!         should result in failure (return code 1)
Thr = ThrCom*1.0e-1_wp
call Cho_X_Bookmark(Thr,nSym,nVec,delta,jrc)
if (jrc == -1) then ! bookmarks not available
  irc = -1
  if (verbose) write(u6,'(A)') 'Cho_X_Bookmark returned -1 [not available]. No further testing performed!'
  return
end if
if (jrc == 1) then
  if (verbose) call Cho_TestBookmark_Prt(1,'passed')
else
  irc = irc+1
  if (verbose) call Cho_TestBookmark_Prt(1,'failed')
end if

! test 2: asking for negative accuracy
!         should result in failure (return code 1)
Thr = -1.0e-12_wp
call Cho_X_Bookmark(Thr,nSym,nVec,delta,jrc)
if (jrc == 1) then
  if (verbose) call Cho_TestBookmark_Prt(2,'passed')
else
  irc = irc+1
  if (verbose) call Cho_TestBookmark_Prt(2,'failed')
end if

! test 3: asking for decomposition threshold should
!         give the total number of vectors.
Thr = ThrCom
call Cho_X_Bookmark(Thr,nSym,nVec,delta,jrc)
if (jrc == 0) then
  do iSym=1,nSym
    if (nVec(iSym) /= NumCho(iSym)) jrc = jrc+1
    if (delta(iSym) > ThrCom) jrc = jrc+1
  end do
  if (jrc == 0) then
    if (verbose) call Cho_TestBookmark_Prt(3,'passed')
  else
    irc = irc+1
    if (verbose) call Cho_TestBookmark_Prt(3,'failed')
  end if
else
  irc = irc+1
  if (verbose) call Cho_TestBookmark_Prt(3,'failed')
end if

! test 4: a threshold above the decomposition threshold
!         should result in fewer vectors and less accuracy.
if (ThrCom < 1.0e-4_wp) then
  Thr = max(ThrCom*1.0e3_wp,1.0e-14_wp)
else
  Thr = max(ThrCom*1.0e2_wp,1.0e-14_wp)
end if
call Cho_X_Bookmark(Thr,nSym,nVec,delta,jrc)
if (jrc == 0) then
  do iSym=1,nSym
    if (delta(iSym) > Thr) jrc = jrc+1
    if (nVec(iSym) > NumCho(iSym)) then
      jrc = jrc+1
    else if (nVec(iSym) == NumCho(iSym)) then
      if (delta(iSym) > ThrCom) jrc = jrc+1
    end if
  end do
  if (jrc == 0) then
    if (verbose) call Cho_TestBookmark_Prt(4,'passed')
  else
    irc = irc+1
    if (verbose) call Cho_TestBookmark_Prt(4,'failed')
  end if
else
  irc = irc+1
  if (verbose) call Cho_TestBookmark_Prt(4,'failed')
end if

! Test 5: check diagonal (only if previous tests passed).
if (irc /= 0) then
  if (verbose) call Cho_TestBookmark_Prt(5,'not executed')
else
  Cho_1Center_Bak = Cho_1Center
  Cho_1Center = is1CCD
  NumChoBak(1:nSym) = NumCho(1:nSym)
  NumChTBak = NumChT
  ThrComBak = ThrCom
  NumCho(1:nSym) = nVec(1:nSym)
  NumChT = sum(NumCho(1:nSym))
  ThrCom = Zero
  do iSym=1,nSym
    ThrCom = max(ThrCom,delta(iSym))
  end do
  call mma_allocate(BkmDia,nnBstRT(1),Label='BkmDia')
  call Cho_X_CalcChoDiag(jrc,BkmDia)
  if (jrc == 0) then
    call mma_allocate(BkmDiaX,nnBstRT(1),Label='BkmDiaX')
    call Cho_IODiag(BkmDiaX,2)
    BkmDiaX(:) = BkmDiaX(:)-BkmDia(:)
    if (Cho_1Center) then
      call Cho_TestBookmark_1CInit(dealloc)
      call Cho_MaxAbsDiag(BkmDiaX,1,ErrMx)
      if (dealloc) call mma_deallocate(iAtomShl,safe='*')
    else
      call Cho_MaxAbsDiag(BkmDiaX,1,ErrMx)
    end if
    DiaMax(1:nSym) = Zero
    DiaMaxT(1:nSym) = Zero
    call mma_deallocate(BkmDiaX)
    if (abs(ErrMx-ThrCom) > 1.0e-12_wp) then
      irc = irc+1
      if (verbose) call Cho_TestBookmark_Prt(5,'failed')
    else
      if (verbose) call Cho_TestBookmark_Prt(5,'passed')
    end if
  else
    irc = irc+1
    if (verbose) call Cho_TestBookmark_Prt(5,'failed')
  end if
  call mma_deallocate(BkmDia)
  NumCho(1:nSym) = NumChoBak(1:nSym)
  NumChT = NumChTBak
  ThrCom = ThrComBak
  Cho_1Center = Cho_1Center_Bak
end if

end subroutine Cho_TestBookmark

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine Sort_genano(eval,evec,n,nb)
      Implicit Real*8 (a-h,o-z)
      Dimension eval(n),evec(nb,n)
      Do 100 i=1,n-1
         k=i
         Do 110 j=i+1,n
            If(eval(j).gt.eval(k)) k=j
110      Continue
         If(k.ne.i) Then
            swap    = eval(k)
            eval(k) = eval(i)
            eval(i) = swap
            Do 120 l=1,nb
               swap      = evec(l,k)
               evec(l,k) =-evec(l,i)
               evec(l,i) = swap
120         Continue
         End If
100   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_OpenR(iOpt)
!
! Purpose: open (iOpt=1) or close (iOpt=2) files for storing global
!          reduced set indices.

use Cholesky, only: LuRed_G
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iOpt
character(len=5) :: FNRed
character(len=*), parameter :: SecNam = 'Cho_P_OpenR'

if (iOpt == 1) then
  LuRed_G = 7
  FNRed = 'CHRED'
  call DAName_MF_WA(LuRed_G,FNRed)
else if (iOpt == 2) then
  if (LuRed_G > 0) call DAClos(LuRed_G)
else
  call Cho_Quit('iOpt error in '//SecNam,104)
end if

end subroutine Cho_P_OpenR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989,1998, Per Ake Malmqvist                           *
!***********************************************************************
!  PROGRAM RASSI        PER-AAKE MALMQVIST
!  SUBROUTINE CITRA     IBM-3090 RELEASE 89 01 31
!  USE THE COEFFICIENTS FOR A SEQUENCE OF SINGLE-ORBITAL TRANSFOR-
!  MATION, TRA, TO TRANSFORM THE CI EXPANSION COEFFICIENTS
!  IN-PLACE TO A NEW NON-ON ORBITAL BASIS.
!  NEW VERSION 981122, using user define types SGS,CIS,XS.
!***********************************************************************
!  CITRA
!
!> @brief
!>   Recompute a CI coefficient array to use another orbital basis
!> @author P. &Aring;. Malmqvist
!>
!> @details
!> For a given linear transformation of the orbitals, and a
!> CI array where the CSF basis is built from the old
!> orbitals, compute the CI array using the new orbitals
!> instead. The orbitals are transformed sequentially, and
!> for each active orbital, a call to ::SSOTRA performs the
!> single-orbital transformation.
!>
!> @param[in]     WFTP Wave function Type Name
!> @param[in]     SGS Split Graph Structure user defined type
!> @param[in]     CIS CI Structure user define type
!> @param[in,out] EXS  Excitation operator Structure user defined type
!> @param[in]     LSM  Wave function Symmetry Label
!> @param[in]     TRA  Transformation Matrix
!> @param[in]     NCO  Number of Configuration Functions
!> @param[in,out] CI   CI Array
!***********************************************************************

!ifdef _DEBUGPRINT_
subroutine CITRA(WFTP,SGS,CIS,EXS,LSM,TRA,NCO,CI)

use sguga, only: CIStruct, SGStruct, EXStruct
use Symmetry_Info, only: nIrrep
use rassi_data, only: NTRA, NOSH, NISH, NASH
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
character(len=8), intent(in) :: WFTP
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(in) :: CIS
type(EXStruct), intent(inout) :: EXS
integer(kind=iwp), intent(in) :: LSM, NCO
real(kind=wp), intent(in) :: TRA(NTRA)
real(kind=wp), intent(inout) :: CI(NCO)
integer(kind=iwp) :: I, II, ISTA, ISYM, NA, NI, NO
real(kind=wp) :: CKK, FAC
real(kind=wp), allocatable :: TMP(:)
#ifdef _DEBUGPRINT_
real(kind=wp), external :: ddot_
#endif

#ifdef _DEBUGPRINT_
write(u6,*) ' Entering CITRA. norm=',ddot_(NCO,CI,1,CI,1)
#endif
!write(u6,*) ' Entering CITRA. TRA='
!write(u6,'(1x,5f16.8)') (TRA(I),I=1,NTRA)
!write(u6,*) ' Entering CITRA. CI='
!write(u6,'(1x,5f16.8)') (CI(I),I=1,NCO)
! TRA contains square matrices, one per symmetry
!  FIRST TRANSFORM THE INACTIVE ORBITALS:
FAC = One
ISTA = 1
do ISYM=1,nIrrep
  NO = NOSH(ISYM)
  do I=1,NISH(ISYM)
    II = ISTA+(NO+1)*(I-1)
    CKK = TRA(II)
    FAC = FAC*CKK
  end do
  ISTA = ISTA+NO**2
end do
!write(u6,*) 'FAC, FAC**2 ... ',FAC,FAC**2
FAC = FAC**2
CI(:) = FAC*CI(:)
!write(u6,*) ' CITRA. inactive done CI='
!write(u6,'(1x,5f16.8)') (CI(I),I=1,NCO)
! THEN THE ACTIVE ONES:
if (WFTP /= 'EMPTY') then
  if ((WFTP == 'HISPIN') .or. (WFTP == 'CLOSED')) then
    ! The HISPIN case may be buggy and is not presently used.
    ISTA = 1
    do ISYM=1,nIrrep
      NI = NISH(ISYM)
      NA = NASH(ISYM)
      NO = NOSH(ISYM)
      do I=NI+1,NI+NA
        II = ISTA+(NO+1)*(I-1)
        CKK = TRA(II)
        FAC = FAC*CKK
      end do
      ISTA = ISTA+NO**2
    end do
    if (WFTP == 'CLOSED') FAC = FAC**2
    CI(:) = FAC*CI(:)
  else
    ! The general case:
    call mma_allocate(TMP,NCO,Label='TMP')
    ISTA = 1
    do ISYM=1,nIrrep
      NA = NASH(ISYM)
      NO = NOSH(ISYM)
      if (NA /= 0) call SSOTRA(SGS,CIS,EXS,ISYM,LSM,NA,NO,TRA(ISTA),NCO,CI,TMP)
      ISTA = ISTA+NO**2
    end do
    call mma_deallocate(TMP)
  end if
# ifdef _DEBUGPRINT_
  write(u6,*) ' DONE in  CITRA. norm=',ddot_(NCO,CI,1,CI,1)
# endif
  !write(u6,*) ' CITRA completely done. CI='
  !write(u6,'(1x,5f16.8)') (CI(I),I=1,NCO)

end if

end subroutine CITRA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine David5(nDet,mxItr,nItr,CI_Conv,ThrEne,iSel,ExplE,ExplV,HTUTRI,GTUVXTRI)

use citrans, only: citrans_csf2sd, citrans_sd2csf, citrans_sort

use csfbas, only: CONF, CTS, KCFTP, KDTOC
use faroald, only: my_norb, ndeta, ndetb, sigma_update
use davctl_mod, only: istart, n_Roots, nkeep, nvec
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
#include "rasdim.fh"
#include "rasrc.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "timers.fh"
#include "rasscf_lucia.fh"
#include "output_ras.fh"
! lroots, maxjt in rasscf.fh
! nsel in general.fh
integer(kind=iwp), intent(in) :: nDet, iSel(nSel)
integer(kind=iwp), intent(inout) :: mxItr
integer(kind=iwp), intent(out) :: nItr
real(kind=wp), intent(out) :: CI_Conv(2,lRoots,MAXJT)
real(kind=wp), intent(in) :: ThrEne, ExplE(nSel), ExplV(nSel,nSel), HTUTRI(*), GTUVXTRI(*)
integer(kind=iwp) :: i, iConf, iConv, idelta, iDummy, ij, IPRLEV, iskipconv, it, it_ci, itu, ituvx, iu, iv, ix, ixmax, jRoot, &
                     kRoot, l1, l2, l3, lPrint, mRoot, nBasVec, nconverged, nleft, nnew, ntrial
real(kind=wp) :: Alpha(mxRoot), Beta(mxRoot), Cik, Dummy(1), E0, E1, ECORE_HEX, FP, Hji, ovl, R, RR, scl, Sji, ThrRes, updsiz, Z
logical(kind=iwp) :: Skip
integer(kind=iwp), allocatable :: vkcnf(:)
real(kind=wp), allocatable :: Cs(:), ctemp(:), Es(:), gtuvx(:,:,:,:), Hs(:), htu(:,:), psi(:,:), Scr1(:,:), Scr2(:,:), Scr3(:,:), &
                              sigtemp(:), sgm(:,:), Ss(:), Vec1(:), Vec3(:), VECSVC(:)
real(kind=wp), allocatable, target :: Tmp(:)
real(kind=wp), pointer, contiguous :: Vec2(:)
integer(kind=iwp), external :: ip_of_Work
real(kind=r8), external :: dDot_, dnrm2_, GET_ECORE

!-----------------------------------------------------------------------
! MGD dec 2017 : When optimizing many states, the lowest ones tend to
! converge much faster than the rest. Changed the code so that the converged states
! are not optimize further, saving potentially a lot of time.

if (DoFaro) then
  ! fill in the integrals from their triangular storage
  call mma_allocate(htu,my_norb,my_norb,label='htu')
  call mma_allocate(gtuvx,my_norb,my_norb,my_norb,my_norb,label='gtuvx')
  htu(:,:) = Zero
  gtuvx(:,:,:,:) = Zero
  itu = 0
  ituvx = 0
  do it=1,my_norb
    do iu=1,it
      itu = itu+1
      !write(u6,'(1x,3I4,F21.14)') it,iu,itu,htutri(itu)
      htu(iu,it) = htutri(itu)
      htu(it,iu) = htutri(itu)
      do iv=1,it
        ixmax = iv
        if (it == iv) ixmax = iu
        do ix=1,ixmax
          ituvx = ituvx+1
          !write(u6,'(1x,5I4,F21.14)') it,iu,iv,ix,ituvx,gtuvxtri(ituvx)
          GTUVX(IT,IU,IV,IX) = GTUVXTRI(ITUVX)
          GTUVX(IU,IT,IV,IX) = GTUVXTRI(ITUVX)
          GTUVX(IT,IU,IX,IV) = GTUVXTRI(ITUVX)
          GTUVX(IU,IT,IX,IV) = GTUVXTRI(ITUVX)
          GTUVX(IV,IX,IT,IU) = GTUVXTRI(ITUVX)
          GTUVX(IX,IV,IT,IU) = GTUVXTRI(ITUVX)
          GTUVX(IV,IX,IU,IT) = GTUVXTRI(ITUVX)
          GTUVX(IX,IV,IU,IT) = GTUVXTRI(ITUVX)
        end do
      end do
    end do
  end do
  ! Euhm, stuff needed for awkward conversions from a
  ! non-specified SYG to GUGA format befor converting to
  ! determinants. This is because for Lucia, CSFs have been
  ! converted to SYG format somewhere up in cistart.
  call mma_allocate(VECSVC,nconf,label='CIVEC')
  call mma_allocate(vkcnf,nactel,label='kcnf')
end if

call Timing(Alfex_1,Swatch,Swatch,Swatch)
Rc_CI = 0
IPRLEV = IPRLOC(3)

! allocate space for CI-vectors
l1 = nKeep
l2 = l1*l1
l3 = (l2+l1)/2
! Trying to avoid writing out of bounds in CSDTVC :::: JESPER :::: CHEAT
call mma_allocate(Vec1,nConf,label='Vector1')
call mma_allocate(Tmp,ndet,label='Vector2')
Vec2(1:nConf) => Tmp(1:nConf)
call mma_allocate(Vec3,nConf,label='Vector3')
call mma_allocate(Es,l1,label='Esmall')
call mma_allocate(Hs,l3,label='Hsmall')
call mma_allocate(Ss,l3,label='Ssmall')
call mma_allocate(Cs,l2,label='Csmall')
call mma_allocate(Scr1,nSel,lRoots,label='Scr1')
call mma_allocate(Scr2,nSel,lRoots,label='Scr2')
call mma_allocate(Scr3,nSel,lRoots,label='Scr3')
if (.not. DoFaro) then
  call mma_allocate(ctemp,ndet,label='CTEMP')
  call mma_allocate(sigtemp,ndet,label='SIGTEM')
end if
!-----------------------------------------------------------------------

! Print convergence thresholds in ITERFILE
ThrRes = max(0.2e-6_wp,sqrt(ThrEne))
write(IterFile,'(19X,A,F18.10)') '- Threshold for energy   ...:',ThrEne
write(IterFile,'(19X,A,F18.10)') '- Threshold for Residual ...:',ThrRes
write(IterFile,'(20A4)') ('****',i=1,20)
write(IterFile,*)
write(IterFile,'(1X,A4,4X,A4,4X,A18,4X,A14,4X,A14)') 'Iter','Root','Energy','dE','Residual'
write(IterFile,'(72A1)') ('=',i=1,72)
call xFlush(IterFile)
!=======================================================================
! start long loop over iterations
Skip = .false.
nconverged = 0
iskipconv = 1
nnew = 0
nvec = lRoots
do it_ci=1,mxItr
  !---------------------------------------------------------------------
  ! MGD for stability purposes recompute sigma vec from time to time
  idelta = 1
  if ((mod(it_ci-1,24) == 0)) idelta = 0
  do mRoot=lRoots*idelta+1,lRoots+nnew
    ! New CI vectors (it_ci,mroot) are available.
    ! compute new sigma vectors
    call Load_CI_vec(mRoot,nConf,Vec1,LuDavid)
    if (iprlev >= DEBUG) then
      lPrint = min(nConf,200)
      write(u6,'(1X,A,I2,A,I2)') 'CI vector, iter =',it_ci,' mRoot =',mRoot
      write(u6,'(1X,A)') '(max. 200 elements)'
      write(u6,'(1X,A)') '-----------------------------'
      call dVcPrt(' ',' ',Vec1,lPrint)
    end if

    call Timing(Rolex_1,Swatch,Swatch,Swatch)
    if (DOFARO) then
      ! determinant wavefunctions
      call mma_allocate(sgm,ndeta,ndetb,label='sgm')
      call mma_allocate(psi,ndeta,ndetb,label='psi')

      VECSVC(:) = Zero
      call REORD2(MY_NORB,NACTEL,1,0,CONF,IWORK(KCFTP),VEC1,VECSVC,VKCNF)
      call CITRANS_SORT('C',VECSVC,VEC2)
      PSI = Zero
      call CITRANS_CSF2SD(VEC2,PSI)
      SGM = Zero
      call SIGMA_UPDATE(HTU,GTUVX,SGM,PSI)
      call CITRANS_SD2CSF(SGM,VEC2)
      call CITRANS_SORT('O',VEC2,VECSVC)
      call Reord2(my_norb,NACTEL,1,1,CONF,iWork(KCFTP),VECSVC,VEC2,VKCNF)

      if (iprlev >= DEBUG) then
        FP = DNRM2_(NCONF,VEC2,1)
        write(u6,'(1X,A,F21.14)') 'sigma dnrm2_(faroald): ',FP
      end if

      ! free the arrays
      call mma_deallocate(sgm)
      call mma_deallocate(psi)
    else
      ! Convert the CI-vector from CSF to Det. basis
      ctemp(1:nConf) = Vec1(:)
      sigtemp(:) = Zero
      call csdtvc(ctemp,sigtemp,1,work(kdtoc),cts,stSym,1)
      c_pointer = ip_of_Work(ctemp(1))
      ! Calling Lucia to determine the sigma vector
      call Lucia_Util('Sigma',iDummy,iDummy,Dummy)
      ! Set mark so densi_master knows that the Sigma-vector exists on disk.
      iSigma_on_disk = 1
      call CSDTVC(Tmp,ctemp,2,work(kdtoc),cts,stSym,1)

      if (iprlev >= DEBUG) then
        FP = DNRM2_(NCONF,VEC2,1)
        write(u6,'(1X,A,F21.14)') 'sigma dnrm2_(lucia):   ',FP
      end if
    end if

    ! Add ECORE_HEX (different from zero when particle-hole formalism used)
    ECORE_HEX = GET_ECORE()
    Vec1(:) = Vec1(:)+ecore_hex*Vec2(:)
    ! Timings on generation of the sigma vector
    call Timing(Rolex_2,Swatch,Swatch,Swatch)
    Rolex_2 = Rolex_2-Rolex_1
    Rolex_3 = Rolex_3+Rolex_2

    if (iprlev >= DEBUG) then
      lPrint = min(nConf,200)
      write(u6,*)
      write(u6,'(1X,A,I2,A,I2)') 'sigma vector, iter =',it_ci,' mRoot =',mRoot
      write(u6,'(1X,A)') '(max. 200 elements)'
      write(u6,'(1X,A)') '--------------------------------'
      call dVcPrt(' ',' ',Vec2,lPrint)
    end if
    call Save_Sig_vec(mRoot,nConf,Vec2,LuDavid)
  end do
  ! Sigma vectors (it_ci,mroot) have been computed, for mroot=1..lroots
  !---------------------------------------------------------------------
  ! compute Hsmall and Ssmall
  ! These are Hsmall(jtrial,ktrial), where jtrial is (jter,jroot), and
  ! ktrial is (kter,kroot), and similar Ssmall.
  ! jtrial=1..mxKeep*lroots correspond to jter=it_ci-mxKeep+1..it_ci
  ! (Fewer, at the beginning)

  do jRoot=1,nvec
    call Load_CI_vec(jRoot,nConf,Vec1,LuDavid)
    call Load_Sig_vec(jRoot,nConf,Vec2,LuDavid)
    do kRoot=1,jRoot
      call Load_CI_vec(kRoot,nConf,Vec3,LuDavid)
      ij = kRoot+(jRoot*jRoot-jRoot)/2
      Sji = dDot_(nConf,Vec1,1,Vec3,1)
      Hji = dDot_(nConf,Vec2,1,Vec3,1)
      Ss(ij) = Sji
      Hs(ij) = Hji
    end do
  end do
  ntrial = nvec
  if (iprlev >= DEBUG) then
    call TriPrt('Hsmall',' ',Hs,ntrial)
    call TriPrt('Ssmall',' ',Ss,ntrial)
  end if
  ! Hsmall and Ssmall have been computed (ntrial x ntrial, in triangular
  ! storage.)
  !---------------------------------------------------------------------

  ! solve secular equation HC=SCE.

  ! PAM2009 nBasVec on input = min(ntrial,nconf)
  ! nBasVec returned as nr of orthonormal solutions to HC=SCE
  nBasVec = nConf
  call HCSCE(ntrial,Hs,Ss,Cs,Es,nBasVec)
  if (nBasVec < lRoots) then
    write(u6,*) 'David: nBasVec less than lRoots'
    write(u6,*) 'nBasvec, lRoots = ',nBasVec,lRoots
    if (ICIRST == 1) write(u6,*) 'CIREstart was used. Check the number of roots in the previous calculation'
    call Abend()
  end if
  if (iprlev >= DEBUG) then
    call dVcPrt('Eigenvalues of Hsmall',' ',Es,ntrial)
    call RecPrt('Eigenvectors of Hsmall',' ',Cs,ntrial,ntrial)
  end if
  !---------------------------------------------------------------------
  ! compute the current 'best' CI, sigma and residual vector

  ! CI vector is Vec1
  ! sigma vector is saved in Vec2
  ! residual vector is saved in Vec3
  do mRoot=1,lRoots
    ! initialize 'best' CI and sigma vector
    Vec1(:) = Zero
    Vec2(:) = Zero
    ! accumulate contributions
    do jRoot=1,nvec
      Cik = Cs(jRoot+(mRoot-1)*ntrial)
      call Load_CI_vec(jRoot,nConf,Vec3,LuDavid)
      Vec1(:) = Vec1(:)+Cik*Vec3(:)
      call Load_Sig_vec(jRoot,nConf,Vec3,LuDavid)
      Vec2(:) = Vec2(:)+Cik*Vec3(:)
    end do
    RR = dDot_(nConf,Vec1,1,Vec1,1)
    scl = One/sqrt(RR)
    Vec1(:) = scl*Vec1(:)
    Vec2(:) = scl*Vec2(:)
    call Save_tmp_CI_vec(mRoot,nConf,Vec1,LuDavid)
    call Save_tmp_Sig_vec(mRoot,nConf,Vec2,LuDavid)
    ! compute residual vector
    E0 = Es(mRoot)
    Vec3(:) = Vec2(:)-E0*Vec1(:)
    ! save current best energy and residual
    RR = dDot_(nConf,Vec3,1,Vec3,1)
    CI_conv(1,mroot,it_ci) = E0
    CI_conv(2,mroot,it_ci) = sqrt(RR)
    ! print vectors
    if (iprlev >= DEBUG) then
      lPrint = min(nConf,200)
      write(u6,'(1X,A,I2,A,I2)') 'new best CI vector, iter =',it_ci,' mRoot =',mRoot
      write(u6,'(1X,A)') '(max. 200 elements)'
      write(u6,'(1X,A)') '--------------------------------------'
      call dVcPrt(' ',' ',Vec1,lPrint)
      write(u6,'(1X,A,I2,A,I2)') 'new best sigma vector, iter =',it_ci,' mRoot =',mRoot
      write(u6,'(1X,A)') '(max. 200 elements)'
      write(u6,'(1X,A)') '-----------------------------------------'
      call dVcPrt(' ',' ',Vec2,lPrint)
      write(u6,'(1X,A,I2,A,I2)') 'new residual vector, iter =',it_ci,' mRoot =',mRoot
      write(u6,'(1X,A)') '(max. 200 elements)'
      write(u6,'(1X,A)') '-----------------------------------------'
      call dVcPrt(' ',' ',Vec3,lPrint)
    end if
    ! to improve the preconditioner select all elements in the
    ! subspace of the explicit Hamiltonian
    if (nSel > 1) then
      do i=1,nSel
        iConf = iSel(i)
        Scr1(i,mRoot) = Vec3(iConf)
        Scr2(i,mRoot) = Vec1(iConf)
      end do
    end if
  end do
  ! Current best CI & Sigma vectors have been stored in a temporary place
  ! for mroot=1..lroots.
  ! Also, the selected elements of the CI and Sigma vectors have been
  ! saved at Scr1 (Sigma) and Scr2 (CI)
  !---------------------------------------------------------------------

  ! check for convergence
  nItr = it_ci
  if (it_ci > 1) then
    dE = CI_conv(1,1,it_ci-1)-CI_conv(1,1,it_ci)
  else
    dE = Zero
  end if
  write(IterFile,'(1X,I4,4X,I4,4X,F18.10,4X,F14.10,4X,F14.10)') it_ci,1,CI_conv(1,1,it_ci),dE,CI_conv(2,1,it_ci)
  do jRoot=2,lRoots
    if (it_ci > 1) then
      dE = CI_conv(1,jroot,it_ci-1)-CI_conv(1,jroot,it_ci)
    end if
    write(IterFile,'(9X,I4,4X,F18.10,4X,F14.10,4X,F14.10)') jRoot,CI_conv(1,jroot,it_ci),dE,CI_conv(2,jroot,it_ci)
  end do
  if (lRoots > 1) write(IterFile,*)
  call xFlush(IterFile)
  if (iprlev > DEBUG) then
    write(u6,*)
    write(u6,'(1X,120A1)') ('*',i=1,120)
    write(u6,'(1X,A,I2)') 'CI iteration ',it_ci
    ThrRes = max(0.2e-6_wp,sqrt(ThrEne))
    write(u6,'(1X,A,2F18.10)') 'ThrEne,ThrRes=',ThrEne,ThrRes
    do jRoot=1,lRoots
      if (it_ci > 1) then
        dE = CI_conv(1,jroot,it_ci-1)-CI_conv(1,jroot,it_ci)
      else
        dE = Zero
      end if
      write(u6,'(1X,A,I2,A,F18.10,2(A,F14.10))') ' root ',jRoot,' energy =',CI_conv(1,jroot,it_ci),' dE =',dE,' residual =', &
                                                 CI_conv(2,jroot,it_ci)
    end do
    write(u6,'(1X,120A1)') ('*',i=1,120)
    write(u6,*)
  end if
  ThrRes = max(0.2e-6_wp,sqrt(ThrEne))
  iConv = 0
  nconverged = 0
  ! Do not check for convergence of hidden roots
  do jRoot=1,lRoots-hroots
    if (it_ci > 1) then
      dE = CI_conv(1,jroot,it_ci-1)-CI_conv(1,jroot,it_ci)
    else
      dE = Zero
    end if
    dE = abs(dE)
    R = CI_conv(2,jroot,it_ci)
    if ((dE < ThrEne) .and. (R < ThrRes)) then
      iConv = iConv+1
      if (jRoot == nconverged+1) nconverged = nconverged+1
    end if
  end do
  if (iskipconv == 0) nconverged = 0
  if (iConv >= lRoots-hroots) then
    Skip = .true.
    exit
  end if
  !---------------------------------------------------------------------
  ! compute correction vectors q1 = r/(E0-H) and q2 = c/(E0-H)

  nleft = lRoots-nconverged
  if (nSel > 1) then
    call DGEMM_('T','N',nSel,nleft,nSel,One,ExplV,nSel,Scr1(:,nconverged+1),nSel,Zero,Scr3,nSel)
    do mRoot=nconverged+1,lRoots
      E0 = Es(mRoot)
      do i=1,nSel
        Z = E0-ExplE(i)
        if (abs(Z) < 0.001_wp) Z = 0.001_wp
        Scr3(i,mRoot-nconverged) = Scr3(i,mRoot-nconverged)/Z
      end do
    end do
    call DGEMM_('N','N',nSel,nleft,nSel,One,ExplV,nSel,Scr3,nSel,Zero,Scr1,nSel)
    call DGEMM_('T','N',nSel,nleft,nSel,One,ExplV,nSel,Scr2(:,nconverged+1),nSel,Zero,Scr3,nSel)
    do mRoot=nconverged+1,lRoots
      E0 = Es(mRoot)
      do i=1,nSel
        Z = E0-ExplE(i)
        if (abs(Z) < 0.001_wp) Z = 0.001_wp
        Scr3(i,mRoot-nconverged) = Scr3(i,mRoot-nconverged)/Z
      end do
    end do
    call DGEMM_('N','N',nSel,nleft,nSel,One,ExplV,nSel,Scr3,nSel,Zero,Scr2,nSel)
  end if
  !---------------------------------------------------------------------
  do mRoot=nconverged+1,lRoots
    E0 = -Es(mRoot)
    call Load_tmp_Sig_vec(mRoot,nConf,Vec1,LuDavid)
    call Load_tmp_CI_vec(mRoot,nConf,Vec2,LuDavid)
    Vec1(:) = Vec1(:)+E0*Vec2(:)
    call Load_H_diag(nConf,Vec3,LuDavid)
    E0 = Es(mRoot)
    do i=1,nConf
      Z = E0-Vec3(i)
      if (abs(Z) < 1.0e-4_wp) Z = 1.0e-4_wp
      Vec3(i) = Vec1(i)/Z
    end do
    if (nSel > 1) then
      do i=1,nSel
        iConf = iSel(i)
        Vec3(iConf) = Scr1(i,mRoot-nconverged)
      end do
    end if
    Alpha(mRoot) = dDot_(nConf,Vec3,1,Vec2,1)
    call Load_H_diag(nConf,Vec3,LuDavid)
    E0 = Es(mRoot)
    do i=1,nConf
      Z = E0-Vec3(i)
      if (abs(Z) < 1.0e-4_wp) Z = 1.0e-4_wp
      Vec3(i) = Vec2(i)/Z
    end do
    if (nSel > 1) then
      do i=1,nSel
        iConf = iSel(i)
        Vec3(iConf) = Scr2(i,mRoot-nconverged)
      end do
    end if
    Beta(mRoot) = dDot_(nConf,Vec3,1,Vec2,1)
  end do
  !---------------------------------------------------------------------

  ! compute correction vectors q3 = (r-E1*q2)/(E0-H)
  if (nSel > 1) then
    do mRoot=nconverged+1,lRoots
      call Load_tmp_Sig_vec(mRoot,nConf,Vec1,LuDavid)
      call Load_tmp_CI_vec(mRoot,nConf,Vec2,LuDavid)
      E0 = -Es(mRoot)
      E1 = -Alpha(mRoot)/Beta(mRoot)
      Vec1(:) = Vec1(:)+(E0+E1)*Vec2(:)
      do i=1,nSel
        iConf = iSel(i)
        Scr1(i,mRoot-nconverged) = Vec1(iConf)
      end do
    end do
    call DGEMM_('T','N',nSel,nleft,nSel,One,ExplV,nSel,Scr1,nSel,Zero,Scr3,nSel)
    do mRoot=nconverged+1,lRoots
      E0 = Es(mRoot)
      do i=1,nSel
        Z = E0-ExplE(i)
        if (abs(Z) < 0.001_wp) Z = 0.001_wp
        Scr3(i,mRoot-nconverged) = Scr3(i,mRoot-nconverged)/Z
      end do
    end do
    call DGEMM_('N','N',nSel,nleft,nSel,One,ExplV,nSel,Scr3,nSel,Zero,Scr1,nSel)
  end if
  ! move the index of CI_vec
  istart = istart+nnew
  istart = mod(istart,nkeep-n_Roots)

  nnew = 0
  do mRoot=nconverged+1,lRoots
    call Load_tmp_Sig_vec(mRoot,nConf,Vec1,LuDavid)
    call Load_tmp_CI_vec(mRoot,nConf,Vec2,LuDavid)
    E0 = -Es(mRoot)
    E1 = -Alpha(mRoot)/Beta(mRoot)
    Vec1(:) = Vec1(:)+(E0+E1)*Vec2(:)
    call Load_H_diag(nConf,Vec3,LuDavid)
    E0 = Es(mRoot)
    do i=1,nConf
      Z = E0-Vec3(i)
      if (abs(Z) < 1.0e-4_wp) Z = 1.0e-4_wp
      Vec3(i) = Vec1(i)/Z
    end do
    if (nSel > 1) then
      do i=1,nSel
        iConf = iSel(i)
        Vec3(iConf) = Scr1(i,mRoot-nconverged)
      end do
    end if
    ! Orthonormalize wrt previous vectors
    updsiz = dnrm2_(nconf,Vec3,1)
    Vec3(:) = Vec3(:)/updsiz
    do jRoot=lRoots+1,min(nvec,nkeep-nconverged)
      call Load_CI_vec(jRoot,nConf,Vec2,LuDavid)
      ovl = dDot_(nConf,Vec3,1,Vec2,1)
      Vec3(:) = Vec3(:)-ovl*Vec2(:)
    end do
    updsiz = dnrm2_(nconf,Vec3,1)
    if (updsiz > 1.0e-6_wp) then
      Vec3(:) = Vec3(:)/updsiz
      nnew = nnew+1
      nvec = nvec+1
      nvec = min(nvec,nkeep)
      call Save_CI_vec(lRoots+mRoot-nconverged,nConf,Vec3,LuDavid)
    end if
  end do
  !---------------------------------------------------------------------
  ! move the current best CI and sigma vectors to the first place
  ! in the list of retained CI vectors
  do mRoot=1,lRoots
    call Load_tmp_CI_vec(mRoot,nConf,Vec1,LuDavid)
    call Save_CI_vec(mRoot,nConf,Vec1,LuDavid)
    call Load_tmp_Sig_vec(mRoot,nConf,Vec1,LuDavid)
    call Save_Sig_vec(mRoot,nConf,Vec1,LuDavid)
  end do

! end of the long loop over iterations
end do
!=======================================================================

if (.not. Skip) then
  mxItr = min(mxCiIt,mxItr+12)
  if (IPRLEV >= USUAL) then
    write(u6,*) '       No convergence in the CI section: MAXJT will be increased to ',mxItr
  end if
  Rc_CI = 16
  nItr = nItr-1
end if

! deallocate local temporary vectors
call mma_deallocate(Vec1)
nullify(Vec2)
call mma_deallocate(Tmp)
call mma_deallocate(Vec3)
call mma_deallocate(Es)
call mma_deallocate(Hs)
call mma_deallocate(Ss)
call mma_deallocate(Cs)
call mma_deallocate(Scr1)
call mma_deallocate(Scr2)
call mma_deallocate(Scr3)
if (DoFaro) then
  call mma_deallocate(htu)
  call mma_deallocate(gtuvx)
  call mma_deallocate(VECSVC)
  call mma_deallocate(vkcnf)
else
  call mma_deallocate(ctemp)
  call mma_deallocate(sigtemp)
end if

call Timing(Alfex_2,Swatch,Swatch,Swatch)
Alfex_2 = Alfex_2-Alfex_1
Alfex_3 = Alfex_3+Alfex_2

return

end subroutine David5

! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!               2002, Thomas Bondo Pedersen                            *
!***********************************************************************
!  CHO_GET_ORD_bj
!
!> @brief
!>   Computes the decomposition pattern of the 2nd-rank orbital energy denominators according to Eq. (6) of \cite Koc2000-JCP-113-508
!> @author F. Aquilante
!> @modified_by Thomas Bondo Pedersen, December 2012: code restructured, fix of minor bug
!>
!> @details
!> Computes the decomposition pattern of the 2nd-rank orbital energy denominators
!> according to Eq. (6) of \cite Koc2000-JCP-113-508
!>
!> The decomposition is considered converged when
!> either of the two criteria (\p MaxNVec or \p thr) is fulfilled.
!> Therefore these two arguments should have appropriate
!> values depending on what the user expects:
!>
!> - \p MaxNVec = \p nOV if the user specifies a meaningful \p thr
!> - \p thr = ``0.0``    if the user requires a given number of vectors (or percentage of \p nOV)
!>
!> @param[in]  nOV     Number of (occ,vir) pairs matching a given compound symmetry
!> @param[in]  MaxNVec Max number of Cholesky vectors
!> @param[in]  thr     Threshold for the Cholesky decomposition
!> @param[in]  W       Array (\p nOV) of the orbital energy differences \p W(bj) = ``e(b)-e(j)``
!> @param[out] ID_bj   Index array (\p MaxNVec) of the decomposition pattern
!> @param[out] nVec    Number of resulting Cholesky vectors
!> @param[out] Dmax    Max value of the remainder after the decomposition
!***********************************************************************

subroutine CHO_GET_ORD_bj(nOV,MaxNVec,thr,W,ID_bj,nVec,Dmax)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nOV, MaxNVec
real(kind=wp), intent(in) :: thr, W(*)
integer(kind=iwp), intent(_OUT_) :: ID_bj(*)
integer(kind=iwp), intent(out) :: NVec
real(kind=wp), intent(out) :: Dmax
integer(kind=iwp) :: ip, Jm
real(kind=wp), allocatable :: Diag(:)

! Initialize
! ----------
nVec = 0
if (nOV < 1) then
  Dmax = -9.987654321_wp ! dummy value
  return
end if

! Allocate diagonal
! -----------------
call mma_allocate(Diag,NOV,Label='Diag')

! Compute diagonals
! -----------------
do ip=1,nOV
  if (W(ip) > Zero) then
    Diag(ip) = Half/W(ip)
  else ! tbp: perhaps we should stop it here (matrix not PSD)
    Diag(ip) = Zero
  end if
end do

! Find ID (Jm) of max diagonal
! ----------------------------
Jm = 1
do ip=2,NOV
  if (Diag(ip) > Diag(Jm)) Jm = ip
end do

! Find CD pattern using the diagonal update:
!   Diag(p)[k] = Diag(p)[k-1] * ((W(p) - W(J[k-1]))/(W(p) + W(J[k-1])))^2
! -----------------------------------------------------------------
do while ((nVec < MaxNVec) .and. (Diag(Jm) > thr))
  ! update vector counter
  nVec = nVec+1
  ! save ID of vector = ID of current max diagonal
  ID_bj(nVec) = Jm
  ! update diagonals
  Diag(1:nOV) = Diag(1:nOV)*((W(1:nOV)-W(Jm))/(W(1:nOV)+W(Jm)))**2
  ! find ID (Jm) of max updated diagonal
  Jm = 1
  do ip=2,nOV
    if (Diag(ip) > Diag(Jm)) Jm = ip
  end do
end do

! Set max diagonal (Dmax) to return to caller
! -------------------------------------------
Dmax = Diag(Jm)

! Deallocate diagonal
! -------------------
call mma_deallocate(Diag)

return

end subroutine CHO_GET_ORD_bj

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cre_rassiwfn
*     SVC: Create a wavefunction file. If another .wfn file already
*     exists, it will be overwritten.
      use kVectors
#ifdef _HDF5_
      use rassi_global_arrays, only: JBNUM
#endif
#ifdef _DMRG_
      use qcmaquis_interface_cfg
#endif
      implicit none
#ifdef _HDF5_
#  include "Molcas.fh"
#  include "cntrl.fh"
#  include "rassi.fh"
#  include "symmul.fh"
#  include "WrkSpc.fh"
#  include "stdalloc.fh"
#  include "rassiwfn.fh"
#  include "lebedev.fh"

      integer :: ISTATE, NSS
      integer :: nData, nIJ
      integer, allocatable :: state_irreps(:), state_mult(:)
      integer :: nbast

      nbast = sum(nbasf(1:nsym)**2)

*     create a new wavefunction file!
      wfn_fileid = mh5_create_file('RASSIWFN')

*     set module type
#ifdef _DMRG_
      if(doDMRG)then
        call mh5_init_attr (wfn_fileid,'MOLCAS_MODULE', 'MPSSI')
      else
#endif
      call mh5_init_attr (wfn_fileid,'MOLCAS_MODULE', 'RASSI')
#ifdef _DMRG_
      end if
#endif

*     copy basic molecular information to the HDF5 file
      call run2h5_molinfo(wfn_fileid)
      call one2h5_ovlmat(wfn_fileid, nsym, nbasf)
      call one2h5_crtmom(wfn_fileid, nsym, nbasf)

*     general wavefunction attributes
      call mh5_init_attr (wfn_fileid,'NSTATE', NSTATE)

      NSS=0
      DO ISTATE=1,NSTATE
        NSS=NSS+MLTPLT(JBNUM(ISTATE))
      END DO

*     irrep per state
      call mma_allocate(state_irreps, NSTATE)
      do istate=1,nstate
        state_irreps(istate) = IRREP(JBNUM(ISTATE))
      end do
      call mh5_init_attr (wfn_fileid,
     $        'STATE_IRREPS', 1, [NSTATE], state_irreps)
      call mma_deallocate(state_irreps)

*     multiplicity per state
      call mma_allocate(state_mult, NSTATE)
      do istate=1,nstate
        state_mult(istate) = MLTPLT(JBNUM(ISTATE))
      end do
      call mh5_init_attr (wfn_fileid,
     $        'STATE_SPINMULT', 1, [NSTATE], state_mult)
      call mma_deallocate(state_mult)

*     overlaps of the input states
      wfn_overlap = mh5_create_dset_real(wfn_fileid,
     $        'ORIGINAL_OVERLAPS', 2, [NSTATE,NSTATE])
      call mh5_init_attr(wfn_overlap, 'description',
     $        'Overlaps between the original (input) states, '//
     $        'a symmetric matrix of size [NSTATE,NSTATE]')

*     energies of the orthogonal (output) spin free states (SFS)
      wfn_sfs_energy = mh5_create_dset_real (wfn_fileid,
     $        'SFS_ENERGIES', 1, [NSTATE])
      call mh5_init_attr(wfn_sfs_energy, 'description',
     $        'Energy for each spin-free state, '//
     $        'arranged as array of size [NSTATE]')

*     SFS coefficients
      wfn_sfs_coef = mh5_create_dset_real(wfn_fileid,
     $        'SFS_COEFFICIENTS', 2, [NSTATE,NSTATE])
      call mh5_init_attr(wfn_sfs_coef, 'description',
     $        'Eigenstates of the input Hamiltonian, '//
     $        'expressed as linear combinations of the input '//
     $        'states, as a matrix of size [NSTATE,NSTATE], '//
     $        'fast index corresponds to input states.')

*     SFS properties
      wfn_sfs_angmom = mh5_create_dset_real(wfn_fileid,
     $        'SFS_ANGMOM', 3, [NSTATE,NSTATE,3])
      call mh5_init_attr(wfn_sfs_angmom, 'description',
     $        'Angular momentum components between the spin-free '//
     $        'states stored as <SFS1|iL(x,y,z)|SFS2> in'//
     $        ' [3,NSTATE,NSTATE]')

      wfn_sfs_edipmom = mh5_create_dset_real(wfn_fileid,
     $        'SFS_EDIPMOM', 3, [NSTATE,NSTATE,3])
      call mh5_init_attr(wfn_sfs_edipmom, 'description',
     $        'Electric dipole momentum components between the '//
     $        'spin-free states stored as <SFS1|ED(x,y,z)|SFS2> in'//
     $        ' [3,NSTATE,NSTATE]')

      wfn_sfs_amfi = mh5_create_dset_real(wfn_fileid,
     $        'SFS_AMFIINT', 3, [NSTATE,NSTATE,3])
      call mh5_init_attr(wfn_sfs_amfi, 'description',
     $        'Components of the spin-orbit integrals between the '//
     $        'spin-free states stored as '//
     $        '<SFS1|spin-orbit-operator|SFS2> in'//
     $        ' [3,NSTATE,NSTATE]')

*     SFS transition density
      wfn_sfs_tdm = mh5_create_dset_real(wfn_fileid,
     $        'SFS_TRANSITION_DENSITIES', 3, [NBAST,NSTATE,NSTATE])
      call mh5_init_attr(wfn_sfs_tdm, 'description',
     $        'Transition density matrices for each pair of spin-'//
     $        'free states, matrix of size [NSTATE,NSTATE,NBAST], '//
     $        'where NBAST is the sum of NBAS(I)**2 for I=1,NSYM.'//
     $        'Only contributing symmetry blocks are stored')

*     SFS spin transition density
      wfn_sfs_tsdm = mh5_create_dset_real(wfn_fileid,
     $        'SFS_TRANSITION_SPIN_DENSITIES', 3, [NBAST,NSTATE,NSTATE])
      call mh5_init_attr(wfn_sfs_tsdm, 'description',
     $        'Transition spin density matrices for each pair of spin'//
     $        '-free states, matrix of size [NSTATE,NSTATE,NBAST], '//
     $        'where NBAST is the sum of NBAS(I)**2 for I=1,NSYM.'//
     $        'Only contributing symmetry blocks are stored')

      if (do_tmom) then
*     SFS intermediate transition vectors
      nIJ=NSTATE*(NSTATE-1)/2
      nData= 1 + 3 + 2*3
      wfn_sfs_tm = mh5_create_dset_real(wfn_fileid,
     $        'SFS_TRANSITION_VECTORS', 4, [nData,nQuad,nIJ,nk_Vector])
      call mh5_init_attr(wfn_sfs_tm, 'description',
     $        'SFS intermediate transition vectors '//
     $        'for nVec specific k-vectors, '//
     $        'nIJ unique pairs of SF states, '//
     $        'and nQuad quadrature k-vectors; '//
     $        'stored as weight, k-vector (3 components), '//
     $        'real transition vector (3 components), '//
     $        'and imaginary transition vector (3 components), '//
     $        'giving a matrix of size [nVec,nIJ,nQuad,nData]')
      end if

      if (ifso) then

*     SFS WE-reduced TDMs of triplet type
      wfn_sfs_wetdm = mh5_create_dset_real(wfn_fileid,
     $        'SFS_WE_TRANSITION_DENSITIES', 3, [NBAST,NSTATE,NSTATE])
      call mh5_init_attr(wfn_sfs_wetdm, 'description',
     $        'WE-reduced TDMs for each pair of spin-free states,'//
     $        'matrix of size [NSTATE,NSTATE,NBAST], where NBAST '//
     $        'is the sum of NBAS(I)**2 for I=1,NSYM.'//
     $        'Only contributing symmetry blocks are stored')

*     energies of the spin orbit states (SOS)
      wfn_sos_energy = mh5_create_dset_real (wfn_fileid,
     $        'SOS_ENERGIES', 1, [NSS])
      call mh5_init_attr(wfn_sos_energy, 'description',
     $        'Energy for each spin-orbit state, '//
     $        'arranged as array of [NSS]')

*     SO complex Hamiltonian
      wfn_sos_hsor = mh5_create_dset_real(wfn_fileid,
     $        'HSO_MATRIX_REAL', 2, [NSS,NSS])
      call mh5_init_attr(wfn_sos_hsor, 'description',
     $        'The spin-orbit Hamiltonian, '//
     $        '2D-array, real part as [NSS,NSS]')
      wfn_sos_hsoi = mh5_create_dset_real(wfn_fileid,
     $        'HSO_MATRIX_IMAG', 2, [NSS,NSS])
      call mh5_init_attr(wfn_sos_hsoi, 'description',
     $        'The spin-orbit Hamiltonian, '//
     $        '2D-array, imaginary part as [NSS,NSS]')

*     SOS coefficients
      wfn_sos_coefr = mh5_create_dset_real(wfn_fileid,
     $        'SOS_COEFFICIENTS_REAL', 2, [NSS,NSS])
      call mh5_init_attr(wfn_sos_coefr, 'description',
     $        'Eigenstates of the spin-orbit Hamiltonian, '//
     $        'expressed as linear combinations of the spin-free '//
     $        'states, 2D-array of real part as [NSS,NSS], '//
     $        'fast index corresponds to spin-free states.')
      wfn_sos_coefi = mh5_create_dset_real(wfn_fileid,
     $        'SOS_COEFFICIENTS_IMAG', 2, [NSS,NSS])
      call mh5_init_attr(wfn_sos_coefi, 'description',
     $        'Eigenstates of the spin-orbit Hamiltonian, '//
     $        'expressed as linear combinations of the spin-free '//
     $        'states, 2D-array of imaginary part as [NSS,NSS], '//
     $        'fast index corresponds to spin-free states.')

*     SOS properties
      wfn_sos_angmomr = mh5_create_dset_real(wfn_fileid,
     $        'SOS_ANGMOM_REAL', 3, [NSS,NSS,3])
      call mh5_init_attr(wfn_sos_angmomr, 'description',
     $        'Angular momentum components between the spin-orbit '//
     $        'states stored as <SOS1|iL(x,y,z)|SOS2> in'//
     $        ' [3,NSS,NSS], real part')

      wfn_sos_angmomi = mh5_create_dset_real(wfn_fileid,
     $        'SOS_ANGMOM_IMAG', 3, [NSS,NSS,3])
      call mh5_init_attr(wfn_sos_angmomi, 'description',
     $        'Angular momentum components between the spin-orbit '//
     $        'states stored as <SOS1|iL(x,y,z)|SOS2> in'//
     $        ' [3,NSS,NSS], imaginary part')

      wfn_sos_spinr = mh5_create_dset_real(wfn_fileid,
     $        'SOS_SPIN_REAL', 3, [NSS,NSS,3])
      call mh5_init_attr(wfn_sos_spinr, 'description',
     $        'Spin momentum components between the spin-orbit '//
     $        'states stored as <SOS1|SPIN(x,y,z)|SOS2> in'//
     $        ' [3,NSS,NSS], real part')

      wfn_sos_spini = mh5_create_dset_real(wfn_fileid,
     $        'SOS_SPIN_IMAG', 3, [NSS,NSS,3])
      call mh5_init_attr(wfn_sos_spini, 'description',
     $        'Spin momentum components between the spin-orbit '//
     $        'states stored as <SOS1|SPIN(x,y,z)|SOS2> in'//
     $        ' [3,NSS,NSS], imaginary part')

      wfn_sos_edipmomr = mh5_create_dset_real(wfn_fileid,
     $        'SOS_EDIPMOM_REAL', 3, [NSS,NSS,3])
      call mh5_init_attr(wfn_sos_edipmomr, 'description',
     $        'Electric dipole momentum components between the '//
     $        'spin-orbit states stored as <SOS1|ED(x,y,z)|SOS2> in'//
     $        ' [3,NSS,NSS], real part')

      wfn_sos_edipmomi = mh5_create_dset_real(wfn_fileid,
     $        'SOS_EDIPMOM_IMAG', 3, [NSS,NSS,3])
      call mh5_init_attr(wfn_sos_edipmomi, 'description',
     $        'Electric dipole momentum components between the '//
     $        'spin-orbit states stored as <SOS1|ED(x,y,z)|SOS2> in'//
     $        ' [3,NSS,NSS], imaginary part')

      if (do_tmom) then
      nIJ=NSS*(NSS-1)/2
      nData= 1 + 3 + 2*3
      wfn_sos_tm = mh5_create_dset_real(wfn_fileid,
     $        'SOS_TRANSITION_VECTORS', 4,
     $        [nData,2*nQuad,nIJ,nk_Vector])
      call mh5_init_attr(wfn_sos_tm, 'description',
     $        'SOS intermediate transition vectors '//
     $        'for nVec specific k-vectors, '//
     $        'nIJ unique pairs of SF states, '//
     $        'and nQuad quadrature k-vectors; '//
     $        'stored as weight, k-vector (3 components), '//
     $        'real transition vector (3 components), '//
     $        'and imaginary transition vector (3 components), '//
     $        'giving a matrix of size [nVec,nIJ,nQuad,nData]')
      end if

      end if
#endif
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Jeppe Olsen                                      *
************************************************************************
* Some GAS routines
*
* Nomenclature
*
*. Group of strings : set of strings with a given number of orbitals
*                    in a given GASspace
*
*. Supergroup of strings  : product of NGAS groups, i.e. a string with a
*                    given numb er of electrons in each GAS space
*
*. Type of string : Type is defined by the total number of electrons
*                   in the string. A type will therefore in general
*                   consists of several supergroups
*
      SUBROUTINE SPGP_AC( INSPGRP,NINSPGRP,IOUTSPGRP,NOUTSPGRP,  NGAS,
     &                    MXPNGAS,     IAC,ISPGRP_AC,IBASEIN,IBASEOUT)
*
* Annihilation/Creation mapping of strings
*
* Jeppe Olsen, April 1, 1997
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input : Number of electrons in each gasspace
      INTEGER INSPGRP(MXPNGAS,*),IOUTSPGRP(MXPNGAS,*)
*. Output
      INTEGER ISPGRP_AC(NGAS,*)
*. Check first that supergroups + IAC information is consistent
      NELIN = 0
      NELOUT = 0
      DO IGAS = 1, NGAS
        NELIN  = NELIN + INSPGRP(IGAS,IBASEIN)
        NELOUT = NELOUT + IOUTSPGRP(IGAS,IBASEOUT)
      END DO
      IF(.NOT.((IAC.EQ.1.AND.NELIN.EQ.NELOUT+1).OR.
     &         (IAC.EQ.2.AND.NELIN.EQ.NELOUT-1))) THEN
        WRITE(6,*) ' Inconsistent data provided to SPGP_AC'
        WRITE(6,*) ' NELIN NELOUT IAC=',NELIN,NELOUT,IAC
*        STOP' Inconsistent data provided to SPGRP_AC'
        CALL SYSABENDMSG('lucia_util/spgp_ac','Internal error',' ')
      END IF
*
      DO ISPGRP = IBASEIN, IBASEIN+NINSPGRP-1
        DO IGAS = 1, NGAS
          IF(IAC.EQ.1) THEN
            INSPGRP(IGAS,ISPGRP) = INSPGRP(IGAS,ISPGRP) - 1
          ELSE IF (IAC.EQ.2) THEN
             INSPGRP(IGAS,ISPGRP) = INSPGRP(IGAS,ISPGRP) + 1
          END IF
*. Find corresponding supergroup
          ITO = 0
          DO JSPGRP = IBASEOUT, IBASEOUT+NOUTSPGRP-1
            IAMOKAY = 1
            DO JGAS = 1, NGAS
              IF( INSPGRP(JGAS,ISPGRP).NE.IOUTSPGRP(JGAS,JSPGRP))
     &        IAMOKAY=0
            END DO
            IF(IAMOKAY.EQ.1) ITO = JSPGRP
          END DO
          ISPGRP_AC(IGAS,ISPGRP) = ITO
*. And clean up
          IF(IAC.EQ.1) THEN
            INSPGRP(IGAS,ISPGRP) = INSPGRP(IGAS,ISPGRP) + 1
          ELSE IF (IAC.EQ.2) THEN
             INSPGRP(IGAS,ISPGRP) = INSPGRP(IGAS,ISPGRP) - 1
          END IF
        END DO
      END DO
*
      NTEST = 000
      IF(NTEST.GE.1000) THEN
        WRITE(6,*) ' Input supergroups '
        CALL IWRTMA(INSPGRP(1,IBASEIN),NGAS,NINSPGRP,
     &  MXPNGAS,NINSPGRP)
        WRITE(6,*) ' Output supergroups '
        CALL IWRTMA(IOUTSPGRP(1,IBASEOUT),NGAS,NOUTSPGRP,
     &  MXPNGAS,NOUTSPGRP)
      END IF
*
      IF(NTEST.GE.100) THEN
       WRITE(6,*) ' Output from SPGP_AC '
       WRITE(6,*) ' ===================='
       WRITE(6,*)
       WRITE(6,*) ' IAC = ', IAC
       WRITE(6,*) ' Mapping : '
       CALL IWRTMA(ISPGRP_AC(1,IBASEIN),NGAS,NINSPGRP,NGAS,NINSPGRP)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ZMatConv(LuWr,iAtom,iErr)

use ZMatConv_Mod, only: iZmat, Coords, Zmat
use Constants, only: Zero, One, deg2rad
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LuWR, iAtom
integer(kind=iwp), intent(out) :: iErr
integer(kind=iwp) :: i
real(kind=wp) :: arg, dCBiAtom, dCTiAtom, dSBiAtom, dSTiAtom, r, u1(3), u2(3), u3(3), u4(3), vj(3), vp(3)

iErr = 0

dCBiAtom = cos(Zmat(2,iAtom)*deg2rad)
dSBiAtom = sin(Zmat(2,iAtom)*deg2rad)
dCTiAtom = cos(Zmat(3,iAtom)*deg2rad)
dSTiAtom = sin(Zmat(3,iAtom)*deg2rad)
if (abs(dCBiAtom) < 1.0e-10_wp) dCBiAtom = Zero
if (abs(dSBiAtom) < 1.0e-10_wp) dSBiAtom = Zero
if (abs(dCTiAtom) < 1.0e-10_wp) dCTiAtom = Zero
if (abs(dSTiAtom) < 1.0e-10_wp) dSTiAtom = Zero

call vec(1.0e-6_wp,u1,iZmat(2,iAtom),iZmat(3,iAtom),iErr)
! Vet. u1(NB-NT)
if (iErr /= 0) then ! Vettore u1 nullo
  iErr = 1
  write(LuWr,*) ' [Z-Mat_Conv] Incipient floating point error detected for atom ',iAtom
  return
end if
call vec(1.0e-6_wp,u2,iZmat(1,iAtom),iZmat(2,iAtom),iErr)
! Vet. u2(NA,NB)
if (iErr /= 0) then ! Vettore u2 nullo
  iErr = 1
  write(LuWr,*) ' [Z-Mat_Conv] Incipient floating point error detected for atom ',iAtom
  return
end if
arg = One-(u1(1)*u2(1)+u1(2)*u2(2)+u1(3)*u2(3))**2
if (arg < Zero) then ! u1 e u2 allineati
  iErr = 1
  write(LuWr,*) ' [Z-Mat_Conv] Incipient floating point error detected for atom ',iAtom
  return
end if
r = sqrt(arg) ! (u1.u2)^0.5
if (r < 1.0e-6_wp) then ! r piccolo
  iErr = 1
  write(LuWr,*) ' [Z-Mat_Conv] Incipient floating point error detected for atom ',iAtom
  return
end if

call crprod(u1,u2,vp) ! Vettore piano perpendicolare u1 x u2
do i=1,3
  u3(i) = vp(i)/r
end do
call crprod(u3,u2,u4)
do i=1,3
  vj(i) = Zmat(1,iAtom)*(-u2(i)*dCBiAtom+u4(i)*dSBiAtom*dCTiAtom+u3(i)*dSBiAtom*dSTiAtom)
  Coords(i,iAtom) = Coords(i,iZmat(1,iAtom))+vj(i)
end do

return

end subroutine ZMatConv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ComputeAuxInt(ip_ABV)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: compute integrals over the auxiliary functions (incl. 2C
C              functions, if present):
C
C                 \int J(r)dr
C
C              Argument ip_ABV (input) must point to an auxiliary basis
C              vector allocated with subroutine LDF_AllocateAuxBasVector
C              such that
C                 iWork(ip_ABV-1+A)
C              points to the block of integrals for functions centered
C              on atom A and
C                 iWork(ip_ABV-1+LDF_nAtom()+AB)
C              points to the block of integrals for 2C functions on atom
C              pair AB.
C
      Implicit None
      Integer ip_ABV
#include "WrkSpc.fh"
#include "localdf.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nAtom, LDF_nBasAux_Atom
      External LDF_nAtom, LDF_nBasAux_Atom

      Character*8 Label

      Integer A, AB
      Integer ip, l
      Integer ip_ABV0

      Integer i, j
      Integer AP_2CFunctions
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

      ! Set up one-electron integral info
      Label='Mltpl  0'
      Call LDF_SetOneEl(Label)

      ! Compute one-center integrals
      ip_ABV0=ip_ABV-1
      Do A=1,LDF_nAtom()
         l=LDF_nBasAux_Atom(A)
         ip=iWork(ip_ABV0+A)
         Call LDF_ComputeAuxInt_1(A,l,Work(ip))
      End Do

      ! Compute two-center integrals
      If (LDF2) Then
         ip_ABV0=ip_ABV0+LDF_nAtom()
         Do AB=1,NumberOfAtomPairs
            l=AP_2CFunctions(1,AB)
            If (l.gt.0) Then
               ip=iWork(ip_ABV0+AB)
               Call LDF_ComputeAuxInt_2(AB,l,Work(ip))
            End If
         End Do
      End If

      ! Unset one-electron integral info
      Call LDF_UnsetOneEl(Label)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_ComputeAuxInt_1(A,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: compute \int J(r)dr for auxiliary functions J(r) on atom
C              A.
C
      use iSD_data
      Implicit None
      Integer A
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
*
      Integer iPrim, jPrim, iAng, jAng, nOrder, lFinal, lScrt1,
     &        lScrt2, MemKrn, ixyz, iBas, MemKer, nElem, mFinal,
     &        mScrt1, mScrt2
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "localdf_bas.fh"
#include "rmat_option.fh"
#include "ldf_oneel.fh"
#include "nsd.fh"
#include "setup.fh"
#include "property_label.fh"
      Real*8, Dimension(:), Allocatable :: Final, Scrtch,
     &                                     ScrSph, Kern
      Character*19 SecNam
      Parameter (SecNam='LDF_ComputeAuxInt_1')

      External MltInt, MltMem

      Integer  LDF_nBasAux_Atom, LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nBasAux_Atom, LDF_nAuxShell_Atom, LDF_lAuxShell_Atom

      Character*8 Label

      Logical Do_PGamma

      Integer l_xInt
      Integer ipInt
      Integer jS, ipS
      Integer iShell, jShell
      Integer iPrint
      Integer nGrid
      Integer iAddPot
      Integer nOrdOp
      Integer ip_SOInt, l_SOInt
      Integer jBas, jCmp, jAO

      Real*8  PtChrg(1)

      Integer i
      Integer nBasSh
*
*     Statement functions
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nBasSh(i)=iWork(ip_nBasSh-1+i)
*                                                                      *
************************************************************************
*                                                                      *
      ! Check operator label
      If (OperatorLabel.ne.'Mltpl  0') Then
         Call WarningMessage(2,SecNam//': illegal operator label')
         Call LDF_Quit(1)
      End If

      ! Check dimension
      l_xInt=LDF_nBasAux_Atom(A)
      If (l_xInt.lt.1) Return
      If (l_xInt.gt.l_xInt_) Then
         Call WarningMessage(2,
     &                SecNam//': insufficient integral array dimension')
         Call LDF_Quit(1)
      End If

      ! Set arguments for call to OneEl_IJ
      RMat_type_integrals=.False. ! stored in common block...
      Do_PGamma=.True.
      Label=OperatorLabel
      PLabel=' '
      iPrint=0
      nGrid=1
      PtChrg(1)=0.0d0
      iAddPot=0
      nOrdOp=0

      ! Allocate temporary integral array
      l_SOInt=0
      ipS=LDF_lAuxShell_Atom(A)-1
      Do jS=1,LDF_nAuxShell_Atom(A)
         jShell=iWork(ipS+jS)
         l_SOInt=max(l_SOInt,nBasSh(jShell))
      End Do
      Call GetMem(' SO ','Allo','Real',ip_SOInt,l_SOInt)
*
      iShell=nShell_Valence+nShell_Auxiliary+1
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate scratch for the evaluation of the integrals             *
*                                                                      *
      lFinal=1
      lScrt1=1
      lScrt2=1
      MemKrn=1
      Do jS=1,LDF_nAuxShell_Atom(A)
         jShell=iWork(ipS+jS)
*
         iPrim=iSD(5,iShell)
         jPrim=iSD(5,jShell)
         iBas=iSD(3,iShell)
         jBas=iSD(3,jShell)
         iAng=iSD(1,iShell)
         jAng=iSD(1,jShell)
*
         mFinal=nIC*iPrim*jPrim*nElem(iAng)*nElem(jAng)
         lFinal=Max(lFinal,mFinal)
*
         mScrt1=nIC*Max(iPrim,jBas)*Max(iBas,jPrim)
     &         *nElem(iAng)*nElem(jAng)
         lScrt1=Max(mScrt1,lScrt1)
*
         mScrt2=nIC*iBas*jBas*nElem(iAng)*nElem(jAng)
         lScrt2=Max(mScrt2,lScrt2)
*
         Call MltMem(nOrder,MemKer,iAng,jAng,nOrdOp)
         MemKrn=Max(MemKer*iPrim*jPrim,MemKrn)

      End Do
*
      Call mma_allocate(Final,lFinal,label='Final')
      Call mma_allocate(Scrtch,lScrt1,label='Scrtch')
      Call mma_allocate(ScrSph,lScrt2,label='ScrSph')
      Call mma_allocate(Kern,MemKrn,label='Kern')
*                                                                      *
************************************************************************
*                                                                      *

      ! Compute integrals
      Call FZero(xInt,l_xInt)
      ipInt=1
      Do jS=1,LDF_nAuxShell_Atom(A)
         jShell=iWork(ipS+jS)
         Call FZero(Work(ip_SOInt),nBasSh(jShell))
         Call OneEl_IJ(iShell,jShell,iPrint,Do_PGamma,
     &                 Work(ip_xZeta),Work(ip_xZI),Work(ip_xKappa),
     &                 Work(ip_xPCoor),
     &                 MltInt,MltMem,Label,iWork(ip_lOper),nComp,
     &                 Work(ip_CCoor),
     &                 nOrdOp,iWork(ip_kOper),
     &                 iStabO,nStabO,nIC,
     &                 PtChrg,nGrid,iAddPot,Work(ip_SOInt),l_SOInt,
     &                 Final,lFinal,Scrtch,lScrt1,
     &                 ScrSph,lScrt2,Kern,MemKrn)
         jCmp=iSD(2,jShell)
         jBas=iSD(3,jShell)
         jAO=iSD(7,jShell)
#if defined (_DEBUGPRINT_)
         If (jBas*jCmp.ne.nBasSh(jShell)) Then
            Call WarningMessage(2,SecNam//': jBas*jCmp != nBasSh')
            Write(6,'(A,5(1X,I10))')
     &      'A,jBas,jCmp,jShell,nBasSh(jShell)=',
     &      A,jBas,jCmp,jShell,nBasSh(jShell)
            Call LDF_Quit(1)
         End If
#endif
         Call LDF_SortAuxInt_1(Work(ip_SOInt),jBas,jCmp,jAO,
     &                         xInt(ipInt),nBasSh(jShell))
         ipInt=ipInt+nBasSh(jShell)
      End Do
*
      Call mma_deallocate(Final)
      Call mma_deallocate(Scrtch)
      Call mma_deallocate(ScrSph)
      Call mma_deallocate(Kern)
*
#if defined (_DEBUGPRINT_)
      If ((ipInt-1).ne.l_xInt) Then
         Call WarningMessage(2,
     &                    SecNam//': integral array dimension problem!')
         Call LDF_Quit(1)
      End If
#endif
      Call GetMem(' SO ','Free','Real',ip_SOInt,l_SOInt)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_SortAuxInt_1(SOInt,jBas,jCmp,jAO,PrpInt,nPrp)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: sort the integrals of auxiliary functions.
C
C     NOTE: symmetry not implemented!
C
      use SOAO_Info, only: iAOtSO
      Implicit Real*8 (a-h,o-z)
      Integer jBas
      Integer jCmp
      Real*8  SOInt(jBas,jCmp)
      Integer jAO
      Integer nPrp
      Real*8  PrpInt(nPrp)
#include "WrkSpc.fh"
#include "localdf_bas.fh"

#if defined (_DEBUGPRINT_)
      Character*16 SecNam
      Parameter (SecNam='LDF_SortAuxInt_1')
#endif

      Integer jComp, jSO0, j

      Integer i
      Integer iShlSO
      iShlSO(i)=iWork(ip_iShlSO-1+i)

      Do jComp=1,jCmp
         jSO0=iAOtSO(jAO+jComp,0)-1
         Do j=1,jBas
#if defined (_DEBUGPRINT_)
            If (iShlSO(jSO0+j).lt.1 .or. iShlSO(jSO0+j).gt.nPrp) Then
               Call WarningMessage(2,
     &                          SecNam//': PrpInt index out of bounds!')
               Call LDF_Quit(1)
            End If
#endif
            PrpInt(iShlSO(jSO0+j))=SOInt(j,jComp)
         End Do
      End Do

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_ComputeAuxInt_2(AB,l_xInt_,xInt)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: compute \int J(r)dr for 2C auxiliary functions J(r) on
C              atom pair AB.
C
      use iSD_data
      Implicit None
      Integer AB
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
      Integer iPrim, jPrim, iAng, jAng, nOrder, lFinal, lScrt1,
     &        lScrt2, MemKrn, ixyz, MemKer, nElem, mFinal, mScrt1,
     &        mScrt2
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"
#include "ldf_oneel.fh"
#include "rmat_option.fh"
#include "nsd.fh"
#include "setup.fh"
#include "property_label.fh"
      Real*8, Dimension(:), Allocatable :: Final, Scrtch,
     &                                     ScrSph, Kern
      Character*19 SecNam
      Parameter (SecNam='LDF_ComputeAuxInt_2')

      External MltInt, MltMem

      Integer  LDF_nBasAux_Pair
      External LDF_nBasAux_Pair

      Character*8 Label

      Logical Do_PGamma

      Integer l_xInt
      Integer ijS
      Integer iShell, jShell
      Integer iPrint
      Integer nGrid
      Integer iAddPot
      Integer nOrdOp
      Integer ip_SOInt, l_SOInt
      Integer iBas, iCmp, iAO
      Integer jBas, jCmp, jAO
      Integer iCount, jCount

      Real*8 PtChrg(1)

      Integer i, j
      Integer nBasSh
      Integer AP_2CFunctions
      Integer AP_2CList
*
*     Statement functions
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      AP_2CList(i,j)=iWork(ip_2CList-1+l_2CList_1*(j-1)+i)
*                                                                      *
************************************************************************
*                                                                      *

      ! Check operator label
      If (OperatorLabel.ne.'Mltpl  0') Then
         Call WarningMessage(2,SecNam//': illegal operator label')
         Call LDF_Quit(1)
      End If

      ! Check integral array dimension
      l_xInt=AP_2CFunctions(1,AB)
      If (l_xInt.lt.1) Return
      If (l_xInt.gt.l_xInt_) Then
         Call WarningMessage(2,
     &                SecNam//': insufficient integral array dimension')
         Call LDF_Quit(1)
      End If

      ! Set arguments for call to OneEl_IJ
      RMat_type_integrals=.False. ! stored in common block...
      Do_PGamma=.True.
      Label=OperatorLabel
      PLabel=' '
      iPrint=0
      nGrid=1
      PtChrg(1)=0.0d0
      iAddPot=0
      nOrdOp=0

      ! Set info for 2C functions
      Call LDF_SetIndxG(AB)
      Call LDF_ColMod(LDF_nBasAux_Pair(AB)-AP_2CFunctions(1,AB))

      ! Allocate temporary integral array
      l_SOInt=0
      Do ijS=1,l_2CList_2
         iShell=AP_2CList(1,ijS)
         jShell=AP_2CList(2,ijS)
         l_SOInt=max(l_SOInt,nBasSh(iShell)*nBasSh(jShell))
      End Do
      Call GetMem(' SO ','Allo','Real',ip_SOInt,l_SOInt)
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate scratch for the evaluation of the integrals             *
*                                                                      *
      lFinal=1
      lScrt1=1
      lScrt2=1
      MemKrn=1
      Do ijS=1,l_2CList_2
         iShell=AP_2CList(1,ijS)
         jShell=AP_2CList(2,ijS)
*
         iPrim=iSD(5,iShell)
         jPrim=iSD(5,jShell)
         iBas=iSD(3,iShell)
         jBas=iSD(3,jShell)
         iAng=iSD(1,iShell)
         jAng=iSD(1,jShell)
*
         mFinal=nIC*iPrim*jPrim*nElem(iAng)*nElem(jAng)
         lFinal=Max(lFinal,mFinal)
*
         mScrt1=nIC*Max(iPrim,jBas)*Max(iBas,jPrim)
     &         *nElem(iAng)*nElem(jAng)
         lScrt1=Max(mScrt1,lScrt1)
*
         mScrt2=nIC*iBas*jBas*nElem(iAng)*nElem(jAng)
         lScrt2=Max(mScrt2,lScrt2)
*
         Call MltMem(nOrder,MemKer,iAng,jAng,nOrdOp)
         MemKrn=Max(MemKer*iPrim*jPrim,MemKrn)
      End Do
*
      Call mma_Allocate(Final,lFinal,label='Final')
      Call mma_allocate(Scrtch,lScrt1,label='Scrtch')
      Call mma_allocate(ScrSph,lScrt2,label='ScrSph')
      Call mma_allocate(Kern,MemKrn,label='Kern')
*                                                                      *
************************************************************************
*                                                                      *

      ! Compute integrals
      Call FZero(xInt,l_xInt)
      iCount=0
      Do ijS=1,l_2CList_2
         iShell=AP_2CList(1,ijS)
         jShell=AP_2CList(2,ijS)
         SPAB=AP_2CList(3,ijS)
         SHA=iShell
         SHB=jShell
         Call FZero(Work(ip_SOInt),nBasSh(iShell)*nBasSh(jShell))
         Call OneEl_IJ(iShell,jShell,iPrint,Do_PGamma,
     &                 Work(ip_xZeta),Work(ip_xZI),Work(ip_xKappa),
     &                 Work(ip_xPCoor),
     &                 MltInt,MltMem,Label,iWork(ip_lOper),nComp,
     &                 Work(ip_CCoor),
     &                 nOrdOp,iWork(ip_kOper),
     &                 iStabO,nStabO,nIC,
     &                 PtChrg,nGrid,iAddPot,Work(ip_SOInt),l_SOInt,
     &                 Final,lFinal,Scrtch,lScrt1,
     &                 ScrSph,lScrt2,Kern,MemKrn)
         iCmp=iSD(2,iShell)
         iBas=iSD(3,iShell)
         iAO=iSD(7,iShell)
         jCmp=iSD(2,jShell)
         jBas=iSD(3,jShell)
         jAO=iSD(7,jShell)
         jCount=0
         Call LDF_SortAuxInt_2(Work(ip_SOInt),iBas,jBas,iCmp,jCmp,
     &                         iAO,jAO,jCount,xInt,l_xInt)
         iCount=iCount+jCount
      End Do
*
      Call mma_deallocate(Final)
      Call mma_deallocate(Scrtch)
      Call mma_deallocate(ScrSph)
      Call mma_deallocate(Kern)
*
      If (iCount.ne.l_xInt) Then
         Call WarningMessage(2,SecNam//': missing integrals!!')
         Call LDF_Quit(1)
      End If

      ! Deallocate temp int array
      Call GetMem(' SO ','Free','Real',ip_SOInt,l_SOInt)

      ! Unset info for 2C functions
      Call LDF_UnsetIndxG()

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_SortAuxInt_2(SOInt,iBas,jBas,iCmp,jCmp,
     &                            iAO,jAO,iCount,PrpInt,nPrp)
C
C     Thomas Bondo Pedersen, February 2011.
C     - based on SOSctt by R. Lindh.
C
C     Purpose: sort the integrals of 2C auxiliary functions.
C
C     NOTE: symmetry not implemented!
C
      use SOAO_Info, only: iAOtSO
      Implicit Real*8 (a-h,o-z)
      Integer iBas, jBas
      Real*8  SOInt(iBas*jBas,*)
      Integer iCmp, jCmp
      Integer iAO, jAO
      Integer iCount
      Integer nPrp
      Real*8  PrpInt(nPrp)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"

#if defined (_DEBUGPRINT_)
      Character*16 SecNam
      Parameter (SecNam='LDF_SortAuxInt_2')
      Character*53 Str
      Parameter (Str=
     &          ': extracting to the same array position several times')
      iSOShl(i)=iWork(ip_iSOShl-1+i)
#endif
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iShlSO(i)=iWork(ip_iShlSO-1+i)
      IndxG2(i,j)=iWork(ip_IndxG2-1+l_IndxG2_1*(j-1)+i)

#if defined (_DEBUGPRINT_)
      nErr=0
      Do iComp=1,iCmp
         Do ii=0,iBas-1
            If (iSOShl(iAOtSO(iAO+iComp,0)+ii).ne.SHA) Then
               nErr=nErr+1
            End If
         End Do
      End Do
      If (nErr.ne.0) Then
         Call WarningMessage(2,SecNam//': shell problem [SHA]')
         Call LDF_Quit(1)
      End If
      nErr=0
      Do jComp=1,jCmp
         Do jj=0,jBas-1
            If (iSOShl(iAOtSO(jAO+jComp,0)+jj).ne.SHB) Then
               nErr=nErr+1
            End If
         End Do
      End Do
      If (nErr.ne.0) Then
         Call WarningMessage(2,SecNam//': shell problem [SHB]')
         Call LDF_Quit(1)
      End If
      If (SHA.eq.SHB) Then
         If (iBas.ne.jBas .or. iCmp.ne.jCmp .or. iAO.ne.jAO) Then
            Call WarningMessage(2,SecNam//': shell problem [SHA=SHB]')
            Call LDF_Quit(1)
         End If
      End If
      lPrpInt=max(nPrp,1)
      Call GetMem('PrpSav','Allo','Real',ipPrpInt,lPrpInt)
      Call dCopy_(nPrp,PrpInt,1,Work(ipPrpInt),1)
#endif

      iCount=0
      lSO=0
      If (SHA.eq.SHB) Then
         Do iComp=1,iCmp
            iSO0=iAOtSO(iAO+iComp,0)-1
            Do jComp=1,iComp-1
               jSO0=iAOtSO(jAO+jComp,0)-1
               lSO=lSO+1
               Do jj=1,jBas
                  jSOj=iShlSO(jSO0+jj)
                  i_j_0=nBasSh(SHA)*(jSOj-1)
                  Do ii=1,iBas
                     iSOi=iShlSO(iSO0+ii)
                     i_j=i_j_0+iSOi
                     If (IndxG2(i_j,SPAB).gt.0) Then
#if defined (_DEBUGPRINT_)
                        If (IndxG2(i_j,SPAB).gt.nPrp) Then
                           Call WarningMessage(2,
     &                              SecNam//': index out of bounds [1]')
                           Call LDF_Quit(1)
                        End If
                        Tst=PrpInt(IndxG2(i_j,SPAB))
     &                     -Work(ipPrpInt-1+IndxG2(i_j,SPAB))
                        If (abs(Tst).gt.1.0d-14) Then
                           Call WarningMessage(2,SecNam//Str//' [1]')
                           Call LDF_Quit(1)
                        End If
#endif
                        ij=iBas*(jj-1)+ii
                        PrpInt(IndxG2(i_j,SPAB))=SOInt(ij,lSO)
                        iCount=iCount+1
                     End If
                  End Do
               End Do
            End Do
            jSO0=iSO0
            lSO=lSO+1
            Do jj=1,jBas
               jSOj=iShlSO(jSO0+jj)
               i_j_0=nBasSh(SHA)*(jSOj-1)
               Do ii=jj,iBas
                  iSOi=iShlSO(iSO0+ii)
                  i_j=i_j_0+iSOi
                  If (IndxG2(i_j,SPAB).gt.0) Then
#if defined (_DEBUGPRINT_)
                     If (IndxG2(i_j,SPAB).gt.nPrp) Then
                        Call WarningMessage(2,
     &                            SecNam//': index out of bounds [1.2]')
                        Call LDF_Quit(1)
                     End If
                     Tst=PrpInt(IndxG2(i_j,SPAB))
     &                  -Work(ipPrpInt-1+IndxG2(i_j,SPAB))
                     If (abs(Tst).gt.1.0d-14) Then
                        Call WarningMessage(2,SecNam//Str//' [1.2]')
                        Call LDF_Quit(1)
                     End If
#endif
                     ij=iBas*(jj-1)+ii
                     PrpInt(IndxG2(i_j,SPAB))=SOInt(ij,lSO)
                     iCount=iCount+1
                  End If
               End Do
            End Do
         End Do
      Else
         Do iComp=1,iCmp
            iSO0=iAOtSO(iAO+iComp,0)-1
            Do jComp=1,jCmp
               jSO0=iAOtSO(jAO+jComp,0)-1
               lSO=lSO+1
               Do jj=1,jBas
                  jSOj=iShlSO(jSO0+jj)
                  i_j_0=nBasSh(SHA)*(jSOj-1)
                  Do ii=1,iBas
                     iSOi=iShlSO(iSO0+ii)
                     i_j=i_j_0+iSOi
                     If (IndxG2(i_j,SPAB).gt.0) Then
#if defined (_DEBUGPRINT_)
                        If (IndxG2(i_j,SPAB).gt.nPrp) Then
                           Call WarningMessage(2,
     &                              SecNam//': index out of bounds [2]')
                           Call LDF_Quit(1)
                        End If
                        Tst=PrpInt(IndxG2(i_j,SPAB))
     &                     -Work(ipPrpInt-1+IndxG2(i_j,SPAB))
                        If (abs(Tst).gt.1.0d-14) Then
                           Call WarningMessage(2,SecNam//Str//' [2]')
                           Call LDF_Quit(1)
                        End If
#endif
                        ij=iBas*(jj-1)+ii
                        PrpInt(IndxG2(i_j,SPAB))=SOInt(ij,lSO)
                        iCount=iCount+1
                     End If
                  End Do
               End Do
            End Do
         End Do
      End If

#if defined (_DEBUGPRINT_)
      Call GetMem('PrpSav','Free','Real',ipPrpInt,lPrpInt)
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Integral_ijij( &
#                        define _CALLING_
#                        include "int_wrout_interface.fh"
                        )
! calls the proper routines IndSft/PLF
! if IntOrd_jikl == .true. integral order within symblk: jikl
!                    else  integral order within symblk: ijkl

use Definitions, only: wp, iwp

implicit none
#include "int_wrout_interface.fh"
integer(kind=iwp) :: iCmp(4), iMax
integer(kind=iwp), parameter :: inc = 1
integer(kind=iwp), external :: iDAMax_

#include "macros.fh"
unused_var(iSOSym)

iCmp(:) = iSD4(2,:)

if (mSym == 1) then
  ! AOInt(ijkl*iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4))
  iMax = iDAMax_(ijkl*iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4),AOInt,inc)
  TInt(1) = AOInt(iMax)
else
  ! SOInt(ijkl*nSOInt)
  iMax = iDAMax_(ijkl*nSOInt,SOInt,inc)
  TInt(1) = SOInt(iMax)
end if

end subroutine Integral_ijij

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
      SUBROUTINE PROTOCSF(NPEL,MLTPL,NPCSFSZ,IPCSFCP)
      DIMENSION IPCSFCP(NPEL,NPCSFSZ)
      INTEGER UPCPL,DWNCPL
      PARAMETER (UPCPL=1,DWNCPL=0)
C Return a table with all possible CSF's with NPEL electrons
C coupled to give a total spin multiplicity MLTPL.
C The order of the resulting CSF's is consistent with the
C index function,
C  Index=1+Sum(j) NGENE(j-1,2*S_j+2)
C where the sum is over only the up-coupled orbitals j,
C S_j is the accumulated spin, summed over orbitals <= j,
C and NGENE(N,2*S+1) is in general the number of genealogical
C couplings of N electrons to obtain spin S.

      IF(NPEL.EQ.0) RETURN
      ISP2=MLTPL-1
      IF(ISP2.LT.0) RETURN
      IF(ISP2.GT.NPEL) RETURN
      NPELU=(NPEL+ISP2)/2
      NPELD=(NPEL-ISP2)/2
      IF(NPELU.LT.NPELD) RETURN
      IF(NPELU+NPELD.NE.NPEL) RETURN
      DO N=1,NPELU
        IPCSFCP(N,1)=UPCPL
      END DO
      IF(NPELU.EQ.NPEL) RETURN
      DO N=NPELU+1,NPEL
        IPCSFCP(N,1)=DWNCPL
      END DO

      NPCSF=NGENE(NPEL,MLTPL)
      IF(NPCSF.GT.NPCSFSZ) GOTO 998

      NPCSF=1
      IF(NPEL.LE.2) RETURN
  10  CONTINUE
      N=0
      NU=0
  20  CONTINUE
      N=N+1
      IF(N.GT.NPEL) GOTO 30
      IF(IPCSFCP(N,NPCSF).EQ.UPCPL) NU=NU+1
      ND=N-NU
      IF(IPCSFCP(N,NPCSF).EQ.UPCPL .OR. NU.EQ.ND) GOTO 20
      DO L=1,NU-1
       IPCSFCP(L,NPCSF+1)=UPCPL
      END DO
      DO L=NU,N-1
       IPCSFCP(L,NPCSF+1)=DWNCPL
      END DO
      IPCSFCP(N,NPCSF+1)=UPCPL
      DO L=N+1,NPEL
       IPCSFCP(L,NPCSF+1)=IPCSFCP(L,NPCSF)
      END DO
      NPCSF=NPCSF+1
      GOTO 10

  30  CONTINUE
      RETURN
 998  CONTINUE
      WRITE(6,*)' Too small space allocated in PROTOCSF. Input:'
      WRITE(6,'(1x,a,3i6)')' NPEL,MLTPL,NPCSFSZ:',NPEL,MLTPL,NPCSFSZ
      WRITE(6,'(1x,a,i12)')' Required NPCSFSZ is',NPCSF
      CALL ABEND()
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Roland Lindh                                     *
************************************************************************
      SubRoutine EFNuc(CoOP,Chrg,Coor,nAtm,ESIT,nOrdOp)
************************************************************************
*                                                                      *
* Object: to compute the electricstatic interaction tensor contribution*
*         from the nuclei. In the case that the test charge coincide   *
*         with a nucleau we will remove that center.                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, April '95.                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
#include "stdalloc.fh"
      Real*8 Chrg(nAtm), Coor(3,nAtm), ESIT((nOrdOp+1)*(nOrdOp+2)/2),
     &       CoOp(3)
      Integer, Allocatable:: C_ESIT(:)
*
*---- Statement function
*
      nElem(n)=(n+1)*(n+2)/2
*
      iRout = 185
      iPrint = nPrint(iRout)
*
*     Compute the nuclear contribution to the electrostatic interation
*     tensor, ESIT.
*
      nComp=nElem(nOrdOp)
      call dcopy_(nComp,[Zero],0,ESIT,1)
*
      nTot=(nOrdOp+1)**6
      Call mma_allocate(C_ESIT,nTot,Label='ESIT')
      Call InitIA(C_ESIT,nOrdOp)
*
      iPowR=2*nOrdOp+1
      Fact=One
      If (nOrdOp.ge.1) Fact=-One
      Do iAtom = 1, nAtm
         x = CoOp(1) - Coor(1,iAtom)
         y = CoOp(2) - Coor(2,iAtom)
         z = CoOp(3) - Coor(3,iAtom)
         r2 = x**2 + y**2 + z**2
         Thr=1.0D-12
         If (r2.gt.Thr) Then
            r  = Chrg(iAtom)/Sqrt(r2)**iPowR
            Do ix = nOrdOp, 0, -1
               Do iy = nOrdOp-ix, 0, -1
                  iz = nOrdOp - ix - iy
                  If (ix.eq.0) Then
                     EIx=One
                  Else
                     EIx=x**ix
                  End If
                  If (iy.eq.0) Then
                     EIy=One
                  Else
                     EIy=y**iy
                  End If
                  If (iz.eq.0) Then
                     EIz=One
                  Else
                     EIz=z**iz
                  End If
                  temp=Fact*EIx*EIy*EIz*r
*
                  Call ContEI(C_ESIT,nOrdOp,ESIT,ix,iy,iz,temp)
*
               End Do
            End Do       ! End loop over cartesian combinations
         End If
      End Do             ! End loop over atoms
*
      Call mma_deallocate(C_ESIT)
*
      If (iPrint.ge.99) Call RecPrt(' The Electrostatic Interaction'
     &                 //' Tensor',' ',ESIT,nElem(nOrdOp),1)
      Return
      End
      Subroutine InitIA(I,mDeg)
      implicit integer (a-z)
      dimension I(0:mDeg,0:mDeg,0:mDeg,0:mDeg,0:mDeg,0:mDeg)
c
c Purpose: Express the interaction tensor, defined by the
c quantities T(a,b,c) as functions of the vector R=(x,y,z),
c where a,b, and c are nonnegative integers and
c T(a,b,c)=((d/dx)**a)((d/dy)**b)((d/dz)**c) 1/R, in terms
c of a polynomial:
c T(a,b,c)=
c  (sum over p,q,r of I(a,b,c,p,q,r) x**p y**q z**r)/(R**(2*n+1)),
c where n=a+b+c.
c The polynomial coefficients are integers, and are 0 unless
c p+q+r=n.
c Author: PAM
*
*----- Statement function
*
c      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
c initialize:
      do 10 a=0,mDeg
      do 11 b=0,mDeg
      do 12 c=0,mDeg
      do 13 p=0,mDeg
      do 14 q=0,mDeg
      do 15 r=0,mDeg
       I(a,b,c,p,q,r)=0
  15  continue
  14  continue
  13  continue
  12  continue
  11  continue
  10  continue
      I(0,0,0,0,0,0)=1
      If (mDeg.gt.0) Then
         I(1,0,0,1,0,0)=-1
         I(0,1,0,0,1,0)=-1
         I(0,0,1,0,0,1)=-1
      End If
      do 100 n=2,mDeg
      do 101 a=0,n
      do 102 b=0,n-a
      c=n-a-b
      do 103 p=0,n
      do 104 q=0,n-p
      r=n-p-q
      new=0
      if(a.gt.0) then
        if(p.gt.0) new=(p-(2*n))*I(a-1,b,c,p-1,q,r)
        if(q.gt.1) new=new+(p+1)*I(a-1,b,c,p+1,q-2,r)
        if(r.gt.1) new=new+(p+1)*I(a-1,b,c,p+1,q,r-2)
      else if(b.gt.0) then
        if(q.gt.0) new=(q-(2*n))*I(a,b-1,c,p,q-1,r)
        if(r.gt.1) new=new+(q+1)*I(a,b-1,c,p,q+1,r-2)
        if(p.gt.1) new=new+(q+1)*I(a,b-1,c,p-2,q+1,r)
      else
        if(r.gt.0) new=(r-(2*n))*I(a,b,c-1,p,q,r-1)
        if(p.gt.1) new=new+(r+1)*I(a,b,c-1,p-2,q,r+1)
        if(q.gt.1) new=new+(r+1)*I(a,b,c-1,p,q-2,r+1)
      end if
      I(a,b,c,p,q,r)=new
 104  continue
 103  continue
 102  continue
 101  continue
 100  continue
c
c write out only elements with a>=b>=c. The others are obtained
c by index permutation.
c This restriction has been removed! (Roland Lindh)
*     n=mDeg
*     do 200 a=n,0,-1
*     do 200 b=n-a,0,-1
*     c=n-a-b
*     write(*,'(5x,''T('',i1,'','',i1,'','',i1,'')='',i5)')a,b,c,
*    &     Ind(n,a,c)
*     do 150 p=n,0,-1
*     do 150 q=n-p,0,-1
*     r=n-p-q
*     coef=I(a,b,c,p,q,r)
*     if(coef.eq.0) goto 150
*     write(*,'(10x,i8,''*x**'',i1,'' *y**'',i1,'' *z**'',i1,i5)')
*    &  coef,p,q,r,Ind(n,p,r)
*150  continue
*200  continue
*
      Return
      End
      Subroutine ContEI(I,mDeg,ESIT,ix,iy,iz,temp)
      implicit integer (a-z)
      dimension I(0:mDeg,0:mDeg,0:mDeg,0:mDeg,0:mDeg,0:mDeg)
      Real*8 ESIT((mDeg+1)*(mDeg+2)/2), Temp
c
c Purpose: Express the interaction tensor, defined by the
c quantities T(a,b,c) as functions of the vector R=(x,y,z),
c where a,b, and c are nonnegative integers and
c T(a,b,c)=((d/dx)**a)((d/dy)**b)((d/dz)**c) 1/R, in terms
c of a polynomial:
c T(a,b,c)=
c  (sum over p,q,r of I(a,b,c,p,q,r) x**p y**q z**r)/(R**(2*n+1)),
c where n=a+b+c.
c The polynomial coefficients are integers, and are 0 unless
c p+q+r=n.
c
*
*----- Statement function
*
c      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
c
c write out only elements with a>=b>=c. The others are obtained
c by index permutation.
c This restriction has been removed! (Roland Lindh)
*     n=mDeg
*     do 200 a=n,0,-1
*     do 200 b=n-a,0,-1
*     c=n-a-b
*     write(*,'(5x,''T('',i1,'','',i1,'','',i1,'')='',i5)')a,b,c,
*    &     Ind(n,a,c)
*     do 150 p=n,0,-1
*     do 150 q=n-p,0,-1
*     r=n-p-q
*     coef=I(a,b,c,p,q,r)
*     if(coef.eq.0) goto 150
*     write(*,'(10x,i8,''*x**'',i1,'' *y**'',i1,'' *z**'',i1,i5)')
*    &  coef,p,q,r,Ind(n,p,r)
*150  continue
*200  continue
*
*     Write (*,*) ' Temp,ix,iy,iz=',temp,ix,iy,iz
      n=mDeg
      ip = 0
      Do a=n,0,-1
         Do b=n-a,0,-1
            c=n-a-b
            ip = ip + 1
*           Write (*,*) ip, I(a,b,c,ix,iy,iz)
            If (I(a,b,c,ix,iy,iz).ne.0)
     &      ESIT(ip)=ESIT(ip)+DBLE(I(a,b,c,ix,iy,iz))*temp
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c        this file contains following routines:
c
c        T1_div
c        T2d_div
c        T2od_div
c        MkTau_chcc
c        ExpT2
c        GetRest
c        SaveRest
c        VanishT1
c
c        ----------------------------
c
        subroutine T1_div (T1n,OE,no,nv)
c
c        this routine do:
c        T1n(a,i) = T1n(a,i)/(e(i)-e(a))
c
c        divison of T1n amplitides by denominator
c
        implicit none
        integer no,nv
        real*8 T1n(1:nv,1:no)
        real*8 OE(1:no+nv)
c
c        help variables
        integer i,a
        real*8 ei
c
        do i=1,no
        ei=OE(i)
          do a=1,nv
            t1n(a,i)=t1n(a,i)/(ei-OE(no+a))
          end do
        end do
c
c
        return
        end
c
c        ----------------------------
c
        subroutine T2d_div (T2,OE,dima,dimb,adda,addb,no,nv)
c
c        this routine do:
c        T2(a',b',i,j) = T2(a',b',i,j/(e(i)+e(j)-e(a)-e(b))
c        for aGrp=beGrp, where only a'>=b',i,j are valid,
c        and completed also cases a'<b',i,j
c
c        divison of T2n amplitides by denominator
c
        implicit none
        integer dima,dimb,adda,addb,no,nv
        real*8 T2(1:dima,1:dimb,1:no,1:no)
        real*8 OE(1:no+nv)
c
c        help variables
        integer i,j,a,av,b,bv
        real*8 eija
c
        av=no+adda
        bv=no+addb
c
c1        divison by denominators
c
        do j=1,no
        do i=1,no
          do a=1,dima
          eija=OE(i)+OE(j)-OE(av+a)
          do b=1,a
            T2(a,b,i,j)=T2(a,b,i,j)/(eija-OE(bv+b))
          end do
        end do
        end do
        end do
c
c2        completing upper triangle
c
        do j=1,no
        do i=1,no
          do b=2,dima
          do a=1,b-1
             T2(a,b,i,j)=T2(b,a,j,i)
          end do
        end do
        end do
        end do
c
c
        return
        end
c
c        ----------------------------
c
        subroutine T2od_div (T2,OE,dima,dimb,adda,addb,no,nv)
c
c        this routine do:
c        T2(a',b',i,j) = T2(a',b',i,j/(e(i)+e(j)-e(a)-e(b))
c
c        divison of T1n amplitides by denominator
c
        implicit none
        integer dima,dimb,adda,addb,no,nv
        real*8 T2(1:dima,1:dimb,1:no,1:no)
        real*8 OE(1:no+nv)
c
c        help variables
        integer i,j,a,av,b,bv
        real*8 eijb
c
        av=no+adda
        bv=no+addb
c
        do j=1,no
        do i=1,no
        do b=1,dimb
          eijb=OE(i)+OE(j)-OE(bv+b)
          do a=1,dima
            T2(a,b,i,j)=T2(a,b,i,j)/(eijb-OE(av+a))
          end do
        end do
        end do
        end do
c
        return
        end
c
c        ----------------------------
c
        subroutine MkTau_chcc (T2,T11,T12,dima,dimb,no,f1,f2)
c
c        this routine do:
c        T2(a',b',i,j) = f1 . T2(a',b',i,j) + f2 . T11(a',i) . T12(b',j)
c
c        N.B. Kvajt odflaknute
c
        implicit none
        integer dima,dimb,no
        real*8 f1,f2
        real*8 T2(1:dima,1:dimb,1:no,1:no)
        real*8 T11(1:dima,1:no)
        real*8 T12(1:dimb,1:no)
c
c        help variables
        integer i,j,a,b
        real*8 c
c
c
        do j=1,no
          do i=1,no
            do b=1,dimb
              c=t12(b,j)*f2
              do a=1,dima
                t2(a,b,i,j)=f1*t2(a,b,i,j)+c*t11(a,i)
              end do
            end do
          end do
        end do
c
c
        return
        end
c
c        ----------------------------
c
        subroutine ExpT2 (T2p,T2u,dima,dimab,no)
c
c        this routine do:
c        Make T2u(a',b',i,j) from T2p(a'b',i,j)
c
c        N.B. Kvajt odflaknute, vypocet ab sa da dat zefektivnit
c
        implicit none
        integer dima,dimab,no
        real*8 T2p(1:dimab,1:no,1:no)
        real*8 T2u(1:dima,1:dima,1:no,1:no)
c
c        help variables
        integer i,j,a,b,ab,ba0
c
c
        do j=1,no
        do i=1,no
          do b=1,dima
            ba0=b*(b-1)/2
            do a=1,b
              T2u(a,b,i,j)=T2p(ba0+a,j,i)
            end do
            do a=1+b,dima
              ab=a*(a-1)/2+b
              T2u(a,b,i,j)=T2p(ab,i,j)
            end do
          end do
        end do
        end do
c
c
        return
        end
c
c        ----------------------------
c
        subroutine GetRest (wrk,wrksize,LunAux,niter,E1old,E2old)
c
c        this file read 1) T1o
c                      2) E1old,E2old,niter
c        from RstFil file
c
        implicit none
#include "chcc1.fh"
#include "wrk.fh"
        integer LunAux,niter
        real*8 E1old,E2old
c
c        help variables
        integer len
c
*       open (unit=LunAux,File='RstFil',form='unformatted')
        Call MOLCAS_BinaryOpen_Vanilla(LunAux,'RstFil')
        len=no*nv
        call rea_chcc (LunAux,len,wrk(PossT1o))
        read (LunAux) E1old,E2old,niter
        close (LunAux)
c
c
        return
        end
c
c        ----------------------------
c
        subroutine SaveRest (wrk,wrksize,LunAux,niter,E1old,E2old)
c
c        this file save 1) T1o,OE
c                      2) E1old,E2old,niter
c        into RstFil file
c
        implicit none
#include "chcc1.fh"
#include "wrk.fh"
        integer LunAux,niter
        real*8 E1old,E2old
c
c        help variables
        integer len
c
*       open (unit=LunAux,File='RstFil',form='unformatted')
        Call MOLCAS_BinaryOpen_Vanilla(LunAux,'RstFil')
        len=no*nv
        call wri_chcc (LunAux,len,wrk(PossT1o))
        write (LunAux) E1old,E2old,niter
        close (LunAux)
c
c
        return
        end
c
c        ----------------------------
c
        subroutine VanishT1 (wrk,wrksize)
c
c        this routine do:
c        Vanish T1o
c
        implicit none
#include "chcc1.fh"
#include "wrk.fh"
c
c        help variables
        integer len
c
        len=no*nv
        call mv0zero (len,len,wrk(PossT1o))
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_dDipM(dDipM,DipM,nDoF,nInter)
!***********************************************************************
!                                                                      *
!     Objective: to compute the dipole moment derivative in Cartesians *
!                                                                      *
!***********************************************************************

use Slapaf_Info, only: Coor, Cx, Degen, mTR => mTROld, Smmtrc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nDoF, nInter
real(kind=wp), intent(inout) :: dDipM(3,nDoF)
real(kind=wp), intent(in) :: DipM(3)
integer(kind=iwp) :: i, iAtom, ij, iTR, iX, jAtom, jj, jjj, jx, k, nAtom, nBMx, nTR, nX
real(kind=wp) :: CM(3), rNorm, Rx, Ry, Rz, tmp_ij, Tx, Ty, Tz
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: BMtrx(:,:), Tmp2(:), TRVec(:,:)
real(kind=wp), parameter :: thr = 1.0e-12_wp

!                                                                      *
!***********************************************************************
!                                                                      *
nAtom = size(Coor,2)
nX = 3*nAtom

call mma_allocate(Tmp2,nX**2,Label='Tmp2')
call mma_allocate(BMtrx,nX,nInter,Label='BMtrx')
call Qpg_dArray('BMxOld',Found,nBMx)
if (Found .and. (nBMx == nX*nInter)) then
  call Get_dArray('BMxOld',BMtrx,nX*nInter)
else
  call Get_dArray('BMtrx',BMtrx,nX*nInter)
end if
if (mTR > 0) then
  call mma_allocate(TRVec,nX,mTR,Label='TRVec')
  call Qpg_dArray('TROld',Found,nTR)
  if (Found .and. (nTR == nX*mTR)) then
    call Get_dArray('TROld',TRVec,nX*mTR)
  else
    call Get_dArray('TR',TRVec,nX*mTR)
  end if
else
  call mma_allocate(TRVec,1,0,Label='TRVec')
end if

#ifdef _DEBUGPRINT_
call RecPrt('TRVec',' ',TRVec,nX,mTR)
call RecPrt('BMtrx',' ',BMtrx,nX,nInter)
call RecPrt('dDipM',' ',dDipM,3,nInter+mTR)
call RecPrt('DipM',' ',DipM,3,1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Analysis of the translational and rotational modes.
! Compute the dipole moment derivative with respect to the
! translational and rotational modes.

do i=1,3
  CM(i) = Zero
  rNorm = Zero
  do iAtom=1,nAtom
    rNorm = rNorm+Degen(i,iAtom)
    if (Smmtrc(i,iAtom)) CM(i) = CM(i)+Degen(i,iAtom)*Cx(i,iAtom,1)
  end do
  CM(i) = CM(i)/rNorm
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over the rotations and translations

iTR = nInter+mTR
do iX=mTR,1,-1
  Tx = Zero
  Ty = Zero
  Tz = Zero
  Rx = Zero
  Ry = Zero
  Rz = Zero
  do i=1,nAtom
    Tx = Tx+TRVec((i-1)*3+1,iX)*Degen(1,i)
    Ty = Ty+TRVec((i-1)*3+2,iX)*Degen(2,i)
    Tz = Tz+TRVec((i-1)*3+3,iX)*Degen(3,i)
    Rx = Rx+(TRVec((i-1)*3+2,iX)*(Cx(3,i,1)-CM(3))-TRVec((i-1)*3+3,iX)*(Cx(2,i,1)-CM(2)))*Degen(1,i)
    Ry = Ry+(TRVec((i-1)*3+3,iX)*(Cx(1,i,1)-CM(1))-TRVec((i-1)*3+1,iX)*(Cx(3,i,1)-CM(3)))*Degen(2,i)
    Rz = Rz+(TRVec((i-1)*3+1,iX)*(Cx(2,i,1)-CM(2))-TRVec((i-1)*3+2,iX)*(Cx(1,i,1)-CM(1)))*Degen(3,i)
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) 'Tx,Ty,Tz=',Tx,Ty,Tz
  write(u6,*) 'Rx,Ry,Rz=',Rx,Ry,Rz
# endif

  if ((Rx**2+Ry**2+Rz**2 < thr) .and. (Tx**2+Ty**2+Tz**2 > thr)) then

    ! Translation, dipole moment invariant to translation

#   ifdef _DEBUGPRINT_
    write(u6,*) 'Translation'
#   endif
    dDipM(:,iTR) = Zero

  else if ((Tx**2+Ty**2+Tz**2 < thr) .and. (Rx**2+Ry**2+Rz**2 > thr)) then
    rNorm = (Rx**2+Ry**2+Rz**2)

    ! Rotation, dipole moment variant to rotation

    if (rNorm > thr) then

      ! General axis

      dDipM(1,iTR) = (DipM(2)*Rz-DipM(3)*Ry)/rNorm
      dDipM(2,iTR) = (DipM(3)*Rx-DipM(1)*Rz)/rNorm
      dDipM(3,iTR) = (DipM(1)*Ry-DipM(2)*Rx)/rNorm
    else
      call WarningMessage(2,' GF: too small rNorm!')
      call Abend()

    end if
  end if
  iTR = iTR-1
end do
#ifdef _DEBUGPRINT_
call RecPrt('dDipM(Original)',' ',dDipM,3,nInter+mTR)
#endif
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Now backtransform to cartesian coordinates.
!
! dmu/dx = dq/dx  dmu/dq

do ix=1,3

  jj = 0
  jjj = 0
  do jAtom=1,nAtom
    do jx=1,3
      jjj = jjj+1
      if (Smmtrc(jx,jAtom)) then
        jj = jj+1
        ij = (jj-1)*3+ix

        tmp_ij = Zero
        do k=1,nInter
          tmp_ij = tmp_ij+dDipM(ix,k)*BMtrx(jjj,k)
        end do
        do k=1,mTR
          tmp_ij = tmp_ij+dDipM(ix,nInter+k)*TRVec(jjj,k)
        end do
        Tmp2(ij) = tmp_ij

      end if
    end do
  end do

end do
dDipM(:,:) = reshape(Tmp2(1:3*nDoF),[3,nDoF])
#ifdef _DEBUGPRINT_
call RecPrt('dDipM(cartesian)',' ',dDipM,3,nDoF)
#endif

call mma_deallocate(TRVec)
call mma_deallocate(BMtrx)
call mma_deallocate(Tmp2)

!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Get_dDipM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  Get_Coord_All
*
*> @brief
*>   Get coordinates from RUNFILE
*> @author R. Lindh
*>
*> @details
*> Place Cartesian coordinates (in a.u.) into array \p Coord_All(3,*).
*>
*> @param[out] Coord_All  Array of coordinates
*> @param[in]  nAtoms_All Number of atoms
************************************************************************
      Subroutine Get_Coord_All(Coord_All,nAtoms_All)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 Coord_All(3,nAtoms_All)
      Real*8, Dimension (:,:), Allocatable :: CU

      Call Get_nAtoms_All(nAtoms_Allx)
      If (nAtoms_All.ne.nAtoms_Allx) Then
         Write (6,*) 'Get_Coord_All: nAtoms_All.ne.nAtoms_Allx'
         Write (6,*) 'nAtoms_All=',nAtoms_All
         Write (6,*) 'nAtoms_Allx=',nAtoms_Allx
         Call Abend
      End If
      Call Get_iScalar('Unique atoms',nAtoms)
      Call mma_allocate(CU,3,nAtoms)
      Call Get_dArray('Unique Coordinates',CU,3*nAtoms)
      Call Get_Coord_All_(CU,nAtoms,Coord_All,nAtoms_All)
      Call mma_deallocate(CU)
*
      Return
      End
      Subroutine Get_Coord_All_(Coord_Unique,nUnique_Atoms,
     &                          Coord_All,nAll_Atoms)
      use Symmetry_Info, only: nIrrep, iOper, Symmetry_Info_Get
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Integer iGen(3), iCoSet(0:7,0:7), iStab(0:7)
      Real*8  Coord_Unique(3,nUnique_Atoms),
     &        Coord_All(3,nAll_Atoms)
      integer, Save:: Active=0
*     Write (*,*) 'Enter Get_Coord_All_'
*                                                                      *
************************************************************************
*                                                                      *
      if(Active.eq.0) then
       Call Symmetry_Info_Get()
       Active=1
      endif
*     Write (*,*) 'Get_Coord_All_: nIrrep=',nIrrep
*     Write (*,*) 'Get_Coord_All_: iOper=',(iOper(i),i=0,nIrrep-1)
*                                                                      *
************************************************************************
*                                                                      *
      nGen=0
      If (nIrrep.eq.2) nGen=1
      If (nIrrep.eq.4) nGen=2
      If (nIrrep.eq.8) nGen=3
      If (nGen.ge.1) iGen(1)=iOper(1)
      If (nGen.ge.2) iGen(2)=iOper(2)
      If (nGen.eq.3) iGen(3)=iOper(4)
*                                                                      *
************************************************************************
*                                                                      *
*     Generate list of all coordinates, index arrays, etc.
*
      iAll_Atom=0
      MaxDCR=0
      Do iUnique_Atom = 1, nUnique_Atoms
*        Write (*,*) 'iUnique_Atom=',iUnique_Atom
*
         iChAtom=iChxyz(Coord_Unique(1,iUnique_Atom),iGen,nGen)
*        Write (*,*) 'iChAtom=',iChAtom
         Call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
         nCoSet=nIrrep/nStab
*        Write (*,*) 'In Get_Coord_All'
*        Write (*,*) 'nCoset=',nCoset
*        Write (*,*) 'iCoset=',(iCoset(i,0),i=0,nCoset-1)
*
         Do iCo = 0, nCoSet-1
*           Write (*,*) 'In Get_Coord_All'
*           Write (*,*) 'iCo,iCoSet(iCo,0)=',iCo,iCoSet(iCo,0)
            iAll_Atom = iAll_Atom + 1
            Call OA(iCoSet(iCo,0),Coord_Unique(1:3,iUnique_Atom),
     &              Coord_All(1:3,iAll_Atom))
         End Do
*
      End Do
*
*     Call RecPrt('Coord_Unique',' ',Coord_Unique,3,nUnique_Atoms)
*     Call RecPrt('Coord_All',' ',Coord_All,3,nAll_Atoms)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!               1995, Martin Schuetz                                   *
!***********************************************************************

subroutine AlloK2_Funi(nr_of_Densities)
!***********************************************************************
!                                                                      *
!  Object: Allocate space for K2 entities.                             *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, Sweden. November '92                 *
!             Martin Schuetz, Dept. of Theoretical Chemistry,          *
!             University of Lund, Sweden. Jun '95                      *
!***********************************************************************

use iSD_data, only: iSD
use k2_arrays, only: MaxDe, nDeDe_DFT
use Symmetry_Info, only: nIrrep
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nr_of_Densities
integer(kind=iwp) :: iAO, iBas, iCmp, iDeSiz, iS, iShell, iSmLbl, jAO, jBas, jCmp, jS, jShell, nSkal, nSO
integer(kind=iwp), external :: MemSO1

call Nr_Shells(nSkal)

! determine memory size nDeDe, MaxDe, and MaxDRC
nDeDe_DFT = 0
MaxDe = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Double loop over shells. These loops decide the integral type

do iS=1,nSkal
  !iAng = iSD(1,iS)
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  !iPrim = iSD(5,iS)
  iAO = iSD(7,iS)
  !mdci = iSD(10,iS)
  iShell = iSD(11,iS)

  do jS=1,iS
    !jAng = iSD(1,jS)
    jCmp = iSD(2,jS)
    jBas = iSD(3,jS)
    !jPrim = iSD(5,jS)
    jAO = iSD(7,jS)
    !mdcj = iSD(10,jS)
    jShell = iSD(11,jS)

    !iDeSiz = 1+iPrim*jPrim+(iBas*jBas+1)*iCmp*jCmp
    iDeSiz = iBas*jBas*iCmp*jCmp
    MaxDe = max(MaxDe,iDeSiz)
    iSmLbl = 1
    nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
    if (nSO > 0) nDeDe_DFT = nDeDe_DFT+nr_of_Densities*iDeSiz*nIrrep

  end do
end do

return

end subroutine AlloK2_Funi

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine PLF_Cho_2(TInt,lInt,AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
!***********************************************************************
!                                                                      *
!  object: to sift and index the petite list format integrals.         *
!                                                                      *
!          the indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          May '90                                                     *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri
use SOAO_Info, only: iAOtSO
use Cholesky, only: iShlSO, iShP2Q, iShP2RS, iSOShl, LuPri, nBstSh, nnBstR, ShA, ShAB, ShB, ShC, ShCD, ShD
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Constants, only: One
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: lInt, ijkl, iCmp, jCmp, kCmp, lCmp, iAO(4), iAOst(4), iBas, jBas, kBas, lBas, kOp(4)
real(kind=wp), intent(inout) :: TInt(lInt)
real(kind=wp), intent(in) :: AOint(ijkl,iCmp,jCmp,kCmp,lCmp)
integer(kind=iwp) :: A, AB, ABCD, B, C, CD, CDAB, D, i1, i2, i3, i4, IAB, iAOi, iAOj, iAOk, iAOl, iAOsti, iAOstj, iAOstk, iAOstl, &
                     ICD, ISHLAB, ISHLCD, ISHLI, ISHLJ, ISHLK, ISHLL, iSO, iSOi, iSOs(4), jSO, jSOj, kSO, kSOk, lSO, lSOl, nijkl, &
                     NTELM, NUMA, NUMB, NUMC, NUMD
#ifdef _DEBUGPRINT_
real(kind=wp) :: r1, r2
real(kind=wp), external :: ddot_

r1 = DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,[One],0)
r2 = DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1)
write(u6,*) ' Sum=',r1
write(u6,*) ' Dot=',r2
call RecPrt(' In Plf_Cho_2: AOInt',' ',AOInt,ijkl,iCmp*jCmp*kCmp*lCmp)
#endif

NUMC = NBSTSH(SHC)
NUMD = NBSTSH(SHD)
NUMA = NBSTSH(SHA)
NUMB = NBSTSH(SHB)

ISHLCD = SHCD
ISHLAB = SHAB

! to avoid stupid compiler warnings:

C = 0
D = 0
A = 0
B = 0

NTELM = 0

! Allocate space to store integrals to gether with their
! Symmetry batch and sequence number.
! To avoid conflicts in using memory this is done in the
! subroutine PSOAO

! quadruple loop over elements of the basis functions angular
! description. loops are reduced to just produce unique SO integrals
! observe that we will walk through the memory in AOint in a
! sequential way.

iAOsti = iAOst(1)
iAOstj = iAOst(2)
iAOstk = iAOst(3)
iAOstl = iAOst(4)
iAOi = iAO(1)
iAOj = iAO(2)
iAOk = iAO(3)
iAOl = iAO(4)

do i1=1,iCmp
  iSOs(1) = iAOtSO(iAOi+i1,kOp(1))+iAOsti
  do i2=1,jCmp
    iSOs(2) = iAOtSO(iAOj+i2,kOp(2))+iAOstj
    do i3=1,kCmp
      iSOs(3) = iAOtSO(iAOk+i3,kOp(3))+iAOstk
      do i4=1,lCmp
        iSOs(4) = iAOtSO(iAOl+i4,kOp(4))+iAOstl

        iSO = iSOs(1)
        jSO = iSOs(2)
        kSO = iSOs(3)
        lSO = iSOs(4)

        nijkl = 0
        do lSOl=lSO,lSO+lBas-1
          do kSOk=kSO,kSO+kBas-1
            do jSOj=jSO,jSO+jBas-1
              do iSOi=iSO,iSO+iBas-1

                nijkl = nijkl+1
                NTELM = NTELM+1

                ISHLI = ISOSHL(ISOI)
                ISHLJ = ISOSHL(JSOJ)
                ISHLK = ISOSHL(KSOK)
                ISHLL = ISOSHL(LSOL)

                if ((ISHLI == SHC) .and. (ISHLJ == SHD) .and. (ISHLK == SHA) .and. (ISHLL == SHB)) then
                  C = ISHLSO(ISOI)
                  D = ISHLSO(JSOJ)
                  A = ISHLSO(KSOK)
                  B = ISHLSO(LSOL)
                else if ((ISHLJ == SHC) .and. (ISHLI == SHD) .and. (ISHLK == SHA) .and. (ISHLL == SHB)) then
                  C = ISHLSO(JSOJ)
                  D = ISHLSO(ISOI)
                  A = ISHLSO(KSOK)
                  B = ISHLSO(LSOL)
                else if ((ISHLI == SHC) .and. (ISHLJ == SHD) .and. (ISHLL == SHA) .and. (ISHLK == SHB)) then
                  C = ISHLSO(ISOI)
                  D = ISHLSO(JSOJ)
                  A = ISHLSO(LSOL)
                  B = ISHLSO(KSOK)
                else if ((ISHLJ == SHC) .and. (ISHLI == SHD) .and. (ISHLL == SHA) .and. (ISHLK == SHB)) then
                  C = ISHLSO(JSOJ)
                  D = ISHLSO(ISOI)
                  A = ISHLSO(LSOL)
                  B = ISHLSO(KSOK)
                else if ((ISHLK == SHC) .and. (ISHLL == SHD) .and. (ISHLI == SHA) .and. (ISHLJ == SHB)) then
                  C = ISHLSO(KSOK)
                  D = ISHLSO(LSOL)
                  A = ISHLSO(ISOI)
                  B = ISHLSO(JSOJ)
                else if ((ISHLL == SHC) .and. (ISHLK == SHD) .and. (ISHLI == SHA) .and. (ISHLJ == SHB)) then
                  C = ISHLSO(LSOL)
                  D = ISHLSO(KSOK)
                  A = ISHLSO(ISOI)
                  B = ISHLSO(JSOJ)
                else if ((ISHLK == SHC) .and. (ISHLL == SHD) .and. (ISHLJ == SHA) .and. (ISHLI == SHB)) then
                  C = ISHLSO(KSOK)
                  D = ISHLSO(LSOL)
                  A = ISHLSO(JSOJ)
                  B = ISHLSO(ISOI)
                else if ((ISHLL == SHC) .and. (ISHLK == SHD) .and. (ISHLJ == SHA) .and. (ISHLI == SHB)) then
                  C = ISHLSO(LSOL)
                  D = ISHLSO(KSOK)
                  A = ISHLSO(JSOJ)
                  B = ISHLSO(ISOI)
                else
                  write(LUPRI,*) 'Shell quadruple requested: ',SHC,SHD,SHA,SHB
                  write(LUPRI,*) 'Shell quadruple of element ',NTELM,':',ISHLI,ISHLJ,ISHLK,ISHLL
                  call CHO_QUIT('Logical error in PLF_Cho_2',103)
                end if

                if (SHA == SHB) then
                  AB = ITRI(A,B)
                else
                  AB = NUMA*(B-1)+A
                end if
                if (SHC == SHD) then
                  CD = ITRI(C,D)
                else
                  CD = NUMC*(D-1)+C
                end if

                ICD = ISHP2RS(1,CD)
                IAB = ISHP2Q(1,AB)
                if ((ICD > 0) .and. (IAB > 0)) then
                  CDAB = nnBstR(1,2)*(IAB-1)+ICD
                  TINT(CDAB) = AOint(nijkl,i1,i2,i3,i4)
                end if

                if (ISHLCD == ISHLAB) then
                  if ((SHC == SHD) .or. (SHC == SHA)) then
                    IAB = ISHP2RS(1,AB)
                    ICD = ISHP2Q(1,CD)
                    if ((ICD > 0) .and. (IAB > 0)) then
                      ABCD = nnBstR(1,2)*(ICD-1)+IAB
                      TINT(ABCD) = AOint(nijkl,i1,i2,i3,i4)
                    end if
                  else if (SHC == SHB) then
                    AB = NUMB*(A-1)+B
                    CD = NUMD*(C-1)+D
                    IAB = ISHP2RS(1,AB)
                    ICD = ISHP2Q(1,CD)
                    if ((ICD > 0) .and. (IAB > 0)) then
                      ABCD = nnBstR(1,2)*(ICD-1)+IAB
                      TINT(ABCD) = AOint(nijkl,i1,i2,i3,i4)
                    end if
                  end if
                end if

              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do

return

end subroutine PLF_Cho_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine copy_dkoperators_i(i,iarray1,j,iarray2)
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
#include "dkhparameters.fh"
      parameter(maxscr=int(dble(maxlength-1)/4+1))
      dimension iarray1(*),iarray2(*)
      dimension iscr(maxscr)
      lwop=8/intrea()
      nwop=(maxlength-1)/lwop+1
      koff=(i-1)*nwop
      loff=(j-1)*nwop
      do k=1,nwop
        iscr(k)=iarray1(koff+k)
      end do
      do k=1,nwop
       iarray2(loff+k)=iscr(k)
      end do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       SubRoutine MP2Dens_drv(E2BJAI,REFC)
************************************************************************
*                                                                      *
*                                                                      *
*     called from: Mp2_driver                                          *
*                                                                      *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
#include "WrkSpc.fh"
#include "mp2grad.fh"
#include "corbinf.fh"
*
      Logical Done
      Integer iVecOff(8), nOccAll(8),nOrbAll(8)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement functions
*
      iMult(i,j,k) = ip_mult + iVecOff(k) +
     &                         j-1 + (nFro(k)+nOcc(k))*(i-1)
      iDensVirOcc(i,j,k) = ip_Density(k) +
     &                          j-1 +
     &                        (nOrb(k) + nDel(k))
     &                      * (i + nFro(k) + nOcc(k) - 1)
*                                                                      *
************************************************************************
*                                                                      *
*     Start                                                            *
*
      Eps = 1.0D-8
      Done=.false.
      nIter=100
*                                                                      *
************************************************************************
*                                                                      *
      Call MP2gDens_setup()
      Call rhs_mp2()
      Call Mp2Diag()
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Do iSym = 1,nSym
         write (6,*) 'Symmetry nr', iSym
         Call RecPrt('InvDia','',
     &        Work(ip_DiaA(iSym)),
     &             nFro(iSym) + nOcc(iSym),
     &             nExt(iSym) + nDel(iSym))
      EndDo
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Now we are going to solve Ax = b using the pcg-method
*     Reference here to the PCG-paper with the right symbols.
*     We need an initial guess for x, we will use 0
*     this will give r_1 = b - A*x_1 = b so r_1 is our
*     rhs, that is the MP2-lagrangian.
*
*     Since we are using a preconditioner we need also a
*     vector z_1 = inv(A~)*r_1 where A~ is our preconditioner.
*     We use the diagonal of A as preconditioner and we have
*     what we need to calculate z
*     We also need a vector p that is chosen to r_0 in the first
*     iteration
*
*     All vectors we use are separated into one block for each symmetry.
*     To know where a certain symmetry begins iPoVec(iSym) is added to
*     the vectors memory adress. nVec is the total length of the vector.
*
      iAdr = 1
      iPoVec(1) = 0
      lVec = l_Mp2Lagr
      Do iSym = 1 , nSym
         iPoVec(iAdr+1) = iPoVec(iAdr) + (nFro(iSym) +nOcc(iSym))*
     &                                   (nExt(iSym) +nDel(iSym))
         iAdr = iAdr+1
      EndDo
*
*     Allocate the vectors needed for the PCG
*
      call GetMem('z_vector','Allo','Real',ip_Z,lVec)
      call GetMem('z-next','Allo','Real',ip_ZN,lVec)
      call GetMem('r_vector','Allo','Real',ip_R,lVec)
      call GetMem('r_next','Allo','Real',ip_RN,lVec)
      call GetMem('p_vector','Allo','Real',ip_P,lVec)
      call GetMem('p_next','Allo','Real',ip_PN,lVec)
      call GetMem('Ap_vector','Allo','Real',ip_AP,lVec)
      call GetMem('LagrMult','Allo','Real',ip_Mult,lVec)
      call GetMem('LagrMult_next','Allo','Real',ip_MultN,lVec)
*
*     Initiate all vectors to zero.
*
      Call FZero(Work(ip_Z),lVec)
      Call FZero(Work(ip_ZN),lVec)
      Call FZero(Work(ip_P),lVec)
      Call FZero(Work(ip_PN),lVec)
      Call FZero(Work(ip_R),lVec)
      Call FZero(Work(ip_RN),lVec)
      Call FZero(Work(ip_Mult),lVec)
      Call FZero(Work(ip_MultN),lVec)
*
      iVecOff(1) = 0
      Do iSym = 2, nSym
         iVecOff(iSym) = iVecOff(iSym-1) + (nFro(iSym-1)+nOcc(iSym-1))
     &                                   * (nExt(iSym-1)+nDel(iSym-1))
      End Do
*
*     Calculate initial values for some of the vectors
*
      Do iSym = 1, nSym
         nI=nFro(iSym)+nOcc(iSym)
         nA=nExt(iSym)+nDel(iSym)
#ifdef _DEBUGPRINT_
         Call RecPrt('(ia|ia)',' ',Work(ip_DiaA(iSym)),
     &               nI,nA)
         Call RecPrt('MP2Lagr',' ',Work(ip_Mp2Lagr(iSym)),
     &               nI,nA)
#endif
         Do i = 1, nI*nA
            Work(ip_Z + iVecOff(iSym) + i-1) =
     &       + Work(ip_Mp2Lagr(iSym) + i-1)*
     &         Work(ip_DiaA(iSym) + i-1)
            Work(ip_P + iVecOff(iSym) + i-1) =
     &        + Work(ip_Z + iVecOff(iSym) + i-1)
            Work(ip_R + iVecOff(iSym) + i-1) =
     &        + Work(ip_Mp2Lagr(iSym) + i-1)
         EndDo
      EndDo
*
*     Check if the mp2-lagrangian is zero, in that case the cphf-solution
*     is trivial and P_ia = 0 for all i and a, in either case
*     MP2Lagr should be deallocated.
*
      TotLagr = 0.0d0
      Do iSym = 1, nSym
         Do i = 1, (nFro(iSym)+nOcc(iSym))*(nExt(iSym)+nDel(iSym))
            TotLagr = TotLagr + Work(ip_Mp2Lagr(iSym) + i-1)
         End Do
      End Do
      If(abs(TotLagr) .lt. 1.0d-12) Then
         Call GetMem('MP2Lagr','Free','Real',
     &            ip_First_Mp2Lagr, l_Mp2Lagr)
         Go To 100
      Else
         Call GetMem('MP2Lagr','Free','Real',
     &               ip_First_Mp2Lagr, l_Mp2Lagr)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Now we have all the initial stuff and should make the PCG-loop.
*     The maximum number of iterations are the one defined globally
*     in MCLR and not MP2-specific.
      Do Iter = 1, nIter
*
#ifdef _DEBUGPRINT_
         Write(6,*) 'P ITER:', Iter
          Do i = 0,lVec-1
             Write(6,*) Work(ip_P+i)
          End Do
#endif
*
*        The reason for not doing the whole CG to a black box routine
*        is that the quantity A*p is method dependent since A is too
*        big to store on disk so we calculate this outside for each
*        iteration.
*
         Call FZero(Work(ip_AP),lVec)
         Do iSymIA = 1,nSym
            Do iSymJB =1,iSymIA
               if((nOrb(iSymIA)+nDel(iSymIA))
     &           *(nOrb(iSymJB)+nDel(iSymJB)).ne.0) then
                  Call MP2Ap(iSymIA,iSymJB,ip_AP,ip_P)
               EndIf
            EndDo
         EndDo
*#ifdef _DEBUGPRINT_
*         Write(6,*) 'MP2Ap'
*         Do i = 0, lVec-1
*            Write(6,*) Work(ip_Ap+i)
*         End Do
*#endif
*        Makes a call to a routine that makes one CG-update and checks
*        convergence.
         Call Conj_Grad(Done,lVec,Work(ip_DiaA(1)),Work(ip_Mult),
     &                  Work(ip_MultN),Work(ip_R),Work(ip_RN),
     &                  Work(ip_P),
     &                  Work(ip_PN),Work(ip_Z),Work(ip_ZN),Work(ip_AP),
     &                  Eps,res)
         If(Done) goto 100
      End Do
*
      Write(6,*) '***************WARNING************************'
      Write(6,*) ''
      write(6,*) 'Too many iterations, this is what you get after 50'
      write(6,*) 'The residual is', res, 'and not', Eps
      Write(6,*) '**********************************************'
*
*     The PCG is done and we now have the Lagrange multipliers we sought.
*     This is a good time to release all the memory related to PCG.
*
 100  Continue
      Do iSym = 1, nSym
         Do iI = 1, nFro(iSym) + nOcc(iSym)
            Do iA = 1, nExt(iSym) + nDel(iSym)
               Work(iDensVirOcc(iA,iI,iSym)) = Work(iMult(iA,iI,iSym))
            End Do
         End Do
      End Do
*
*     Now we have the upper half of the one particle density matrix and only need
*     to copy down off diagonal terms

      Do iSym =1, nSym
         Do i = 1, nOrb(iSym) + nDel(iSym)
            Do j = 1, i-1
               Work(ip_Density(iSym) + i-1 +
     &              (j-1)*(nOrb(iSym) + nDel(iSym))) =
     &         Work(ip_Density(iSym) + j-1 +
     &              (i-1)*(nOrb(iSym) + nDel(iSym)))
            End Do
         End Do
      End Do
*
#ifdef _DEBUGPRINT_
      Do iSym = 1, nSym
         Write(6,*) 'Density matrix for Symm:', iSym
         Call RecPrt('MP2Density','',Work(ip_Density(iSym)),
     &               nOrb(iSym) + nDel(iSym), nOrb(iSym) + nDel(iSym))
         Call RecPrt('MP2WDensity','',Work(ip_WDensity(iSym)),
     &               nOrb(iSym) + nDel(iSym), nOrb(iSym) + nDel(iSym))
      End Do
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('z_vector','Free','Real',ip_Z,lVec)
      Call GetMem('z-next','Free','Real',ip_ZN,lVec)
      Call GetMem('r_vector','Free','Real',ip_R,lVec)
      Call GetMem('r_next','Free','Real',ip_RN,lVec)
      Call GetMem('p_vector','Free','Real',ip_P,lVec)
      Call GetMem('p_next','Free','Real',ip_PN,lVec)
      Call GetMem('Ap_vector','Free','Real',ip_AP,lVec)
      Call GetMem('LagrMult_next','Free','Real',ip_MultN,lVec)
      Call GetMem('LagrMult','Free','Real',ip_Mult,lVec)
*
*     Set up Density matrices for MO and AO and one for triangular
*     stored AO.
*
      l_TriDens = 0
      Do iSym = 1, nSym
         l_TriDens = l_TriDens + (nOrb(iSym) + nDel(iSym))
     &                         * (nOrb(iSym) + nDel(iSym) + 1) / 2
      End Do
*
      Call GetMem('AOTriDens','Allo','Real',ip_AOTriDens, l_TriDens)
      Call GetMem('AOWTriDens','Allo','Real',ip_WAOTriDens,l_TriDens)
      Do iSym = 1, 8
         nOrbAll(iSym) = nOrb(iSym) + nDel(iSym)
         nOccAll(iSym) = nFro(iSym) + nOcc(iSym)
      End Do
*
      Call Finish_WDensity()
*
      Do iSym = 1, nSym
         Do i = 1, nOccAll(iSym)
            Work(ip_density(iSym) + i-1
     &           + (nOrbAll(iSym))
     &           * (i-1)) =
     &           Work(ip_density(iSym) + i-1
     &           + (nOrbAll(iSym))
     &           * (i-1)) + 2.0d0
         End Do
      End Do
*
      Call Build_Mp2Dens(ip_AOTriDens,ip_Density,
     &                   Work(ipCMO),nSym,nOrbAll,nOccAll,.true.)
      Call Build_Mp2Dens(ip_WAOTriDens, ip_WDensity,
     &                   Work(ipCMO),nSym,nOrbAll,nOccAll,.false.)
*
#ifdef _DEBUGPRINT_
      Write(6,*) 'Normal Dens'
      Do i = 0, l_TriDens - 1
         Write(6,*) Work(ip_AOTriDens+i)
      End Do
      Write(6,*) 'WDens'
      Do i = 0, l_TriDens - 1
         Write(6,*) Work(ip_WAOTriDens+i)
      End Do
#endif
*
      Call Put_D1ao_Var(Work(ip_AOTriDens),l_TriDens)
*      Call Put_D1ao(Work(ip_AOTriDens),l_TriDens)
      Call Put_Fock_Occ(Work(ip_WAOTriDens),l_TriDens)

      Call GetMem('AOTriDens','Free','Real',
     &            ip_AOTriDens, l_TriDens)
      Call GetMem('AOWTriDens','Free','Real',
     &            ip_WAOTriDens, l_TriDens)
*     We now have the density matrix for both the MO-basis and the AO-basis in the
*     compact form it is supposed to have on the runfile so what is left is to write
*     it to the runfile.
*
*     Overwrite nonvariational density to fool LoProp. (should not be done
*     this way)
#ifdef _DEBUGPRINT_
      write (6,*) 'EMP2 is ', EMP2
      write (6,*) ' '
      Do iSym = 1, nSym
         Write(6,*) 'Density matrix for Symm:', iSym
         Call RecPrt('MP2Density','',Work(ip_Density(iSym)),
     &               nOrb(iSym) + nDel(iSym), nOrb(iSym) + nDel(iSym))
      End Do
      Do iSym = 1, nSym
         Write(6,*) 'WDensity matrix for Symm:', iSym
         Call RecPrt('MP2WDensity','',Work(ip_WDensity(iSym)),
     &               nOrb(iSym) + nDel(iSym), nOrb(iSym) + nDel(iSym))
      End Do
#endif
       Call GetMem('MP2Density','Free','Real',ip_First_Density,
     &            l_Density)
       Call GetMem('MP2WDensity','Free','Real',ip_First_WDensity,
     &              l_Density)
      Call GetMem('MP2DiaA','Free','Real',
     &            ip_First_DiaA, l_DiaA)
*
      E2BJAI=EMP2
      REFC=VECL2
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! Data shared for an embedding potential on a grid

module Embedding_Global

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp) :: nEmbGridPoints
! The energy coming from the embedding potential
real(kind=wp) :: Eemb

!****** Arrays
! Coordinates of the grid points, stored as x1, y1, z1, x2, y2...
real(kind=wp), allocatable :: embGridCoord(:,:)
! The actual value of the embedding potential at grid point i
real(kind=wp), allocatable :: embPotVal(:)
! The corresponding weighting factor of grid point i
real(kind=wp), allocatable :: embWeight(:)
! The integrals in form <a|embPot|b>
real(kind=wp), allocatable :: embInt(:)

!****** Flags
! Flag whether an embedding potential is used
logical(kind=iwp) :: embPot
! Flag whether the potential is given in a basis representation
logical(kind=iwp) :: embPotInBasis
! Flag whether a path to an output grid has been specified,
! i.e. whether the output grid is different from the input grid
logical(kind=iwp) :: outGridPathGiven
! What output is requested
logical(kind=iwp) :: embWriteDens, embWriteEsp, embWriteGrad, embWriteHess
logical(kind=iwp) :: embDebug

!****** File paths
! The path to the file containing grid and embedding potential
character(len=256) :: embPotPath
! The output grid (if different from input)
character(len=256) :: outGridPath
! The output data, for density, electrostatic potential and its gradient
character(len=256) :: embOutDensPath, embOutEspPath, embOutGradPath, embOutHessPath

public :: nEmbGridPoints, Eemb, embGridCoord, embPotVal, embWeight, embInt, embPot, embPotInBasis, outGridPathGiven, embWriteDens, &
          embWriteEsp, embWriteGrad, embWriteHess, embDebug, embPotPath, outGridPath, embOutDensPath, embOutEspPath, &
          embOutGradPath, embOutHessPath

end module Embedding_Global

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dds_drlbr_act_c_sgt0(lin)
!=======================================================================
! dds(9-4) drl(12)-br(31)-
!=======================================================================

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, w1_d1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w1ds
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if ((lmij /= jmr) .or. (lmi /= jml)) cycle
    iwdr = just(lri,lrj)
    iwdl = jud(lri)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    w1ds = w1_d1s(4)
    ni = mod(norb_dz-lrj,2)
    if (ni == 1) w1ds = -w1ds
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w0(mpl)*w1ds
    end do
    call drl_br_ext_al_new(lin,lri,lrj)
  end do
end do

return

end subroutine dds_drlbr_act_c_sgt0

subroutine dds_ardlr_act_c_sgt0(lin)
!=======================================================================
! dds(9-1) ar(13)-drl(30)-
!=======================================================================

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, w0_d1s
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmd, lrd, lri, mpl, ni
real(kind=wp) :: w0ds1
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  do lrd=norb_frz+1,lri-1
    lmd = lsm_inn(lrd)
    if (lmd /= jml) cycle
    iwdr = just(lri,lri)
    iwdl = jud(lrd)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    w0ds1 = w0_d1s(1)
    ni = mod(norb_dz-lrd,2)
    if (ni == 0) w0ds1 = -w0ds1
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ds1
      vplp_w1(mpl) = Zero
    end do
    call ar_drl_ext_al_new(lin,lrd,lri)
  end do
end do

return

end subroutine dds_ardlr_act_c_sgt0

subroutine dds_arblbr_act_c_sgt0(lin)
!=======================================================================
! d1s(9-2)    ar(13)-bl(31)-br(32)-
! d1s(9-3)    ar(13)-bl(32)-br(31)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_d1s, w1_d1s
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmd, lmi, lmij, lmj, lrd, lri, lrj, mpl, ni
real(kind=wp) :: w0ds2, w0ds3, w1ds2, w1ds3
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmr) cycle
    do lrd=norb_frz+1,lri-1
      lmd = lsm_inn(lrd)
      if (lmd /= jml) cycle
      ijk = lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
      intpos = intind_ijka(ijk)
      w0ds2 = w0_d1s(2)
      w1ds2 = w1_d1s(2)
      w0ds3 = w0_d1s(3)
      w1ds3 = w1_d1s(3)
      ni = mod(norb_dz-lrj+lri-lrd,2)
      if (ni == 0) then
        w0ds2 = -w0ds2
        w1ds2 = -w1ds2
        w0ds3 = -w0ds3
        w1ds3 = -w1ds3
      end if
      ! d1s(9-2)    ar(13)-bl(31)-br(32)-
      iwdr = just(lrj,lri)
      iwdl = jud(lrd)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ds2
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ds2
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
      ! d1s(9-3)    ar(13)-bl(32)-br(31)-
      iwdr = just(lri,lrj)
      iwdl = jud(lrd)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ds3
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ds3
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    end do
  end do
end do

return

end subroutine dds_arblbr_act_c_sgt0

subroutine tttt_drl_act_br_sgt1(lin,lra)
! t1t1(12-2)  drl(11)-
! t1t1(12-2)  drl(11)-c"(11)-
! t1t1(12-3)  drl(33)-
! t1t1(12-3)  drl(33)-c"(11)-
! t1t1(12-3)  drl(33)-c"(11)-c"(11)-
! tt(11-2) (22)drl(22)-
! tt(11-2) drl(22)-c"(22)-
! tt(11-3) (22)(22)drl(33)-
! tt(11-3) (22)drl(33)-c"(22)-
! tt(11-3) drl(33)-c"(22)-c"(22)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1t1, w1_t1t1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_t1t1(2)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_t1t1(2)
    end do
    ! t1t1(12-2)  drl(11)-
    ! t1t1(12-2)  drl(11)-c"(11)-
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call drl_br_ext_al_new(lin,lri,lra)
    call drl_br_ext_al_new(lin,lrj,lra)
    ! t1t1(12-3)  drl(33)-
    ! t1t1(12-3)  drl(33)-c"(11)-
    ! t1t1(12-3)  drl(33)-c"(11)-c"(11)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_t1t1(3)
      vplp_w1(mpl) = Zero
    end do
    if (lra > norb_dz) then
      call drl_br_sum_al_new(lin,lri,lrj,lra)
    else
      do lrk=1,norb_dz
        if (lrk == lri) cycle
        if (lrk == lrj) cycle
        call drl_br_ext_al_new(lin,lrk,lra)
      end do
    end if
  end do
end do

return

end subroutine tttt_drl_act_br_sgt1

subroutine tttt_arbl_act_br_sgt1(lin,lra)
!=======================================================================
! t1t1(12-1)  (22)ar(13)-bl(31)-
! t1t1(12-1)  ar(13)-c'(11)-bl(31)-
! t1t1(12-1)  ar(13)-bl(31)-c"(11)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_t1t1, w1_t1t1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0tt1, w1tt1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    w0tt1 = w0_t1t1(1)
    w1tt1 = w1_t1t1(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0tt1 = -w0tt1
      w1tt1 = -w1tt1
    end if
    !-------------------------------------------------------------------
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0tt1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1tt1
    end do
    ! t1t1(12-1)  (22)ar(13)-bl(31)-
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      if (Mul(lmk,lmi) /= jml) cycle
      iwdl = just(lrk,lri)
      iwdr = just(lrk,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    end do
    ! t1t1(12-1)  ar(13)-bl(31)-c"(11)-
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      if (Mul(lmk,lmi) /= jml) cycle
      iwdl = just(lri,lrk)
      iwdr = just(lrj,lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    end do
    ! t1t1(12-1)  ar(13)-c'(11)-bl(31)-
    do mpl=1,mtype
      vplp_w0(mpl) = -vplp_w0(mpl)
      vplp_w1(mpl) = -vplp_w1(mpl)
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      if (Mul(lmk,lmi) /= jml) cycle
      iwdl = just(lri,lrk)
      iwdr = just(lrk,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    end do
  end do
end do

return

end subroutine tttt_arbl_act_br_sgt1

subroutine ttdd_ar_act_dlr_sgt1(lin,lra)
! t1d1(15-1) (11)a(13)
! t1d1(15-1) a(13)c'(11)

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_t1d1(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1
  !---------------------------------------------------------------------
  ! t1d1(15-1) (11)a(13)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if ((lmk /= jmr) .and. (Mul(lmk,lmi) /= jml)) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end do
  !---------------------------------------------------------------------
  ! t1d1(15-1) a(13)c'(11)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if ((lmk /= jmr) .and. (Mul(lmk,lmi) /= jml)) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end do
end do

return

end subroutine ttdd_ar_act_dlr_sgt1

subroutine ttdd_ar_act_blbr_sgt1(lin,jk)
! t1d1(15-1) (11)a(13)
! t1d1(15-1) a(13)c'(11)

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_t1d1(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  !---------------------------------------------------------------------
  ! t1d1(15-1) (11)a(13)
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end do
  !---------------------------------------------------------------------
  ! t1d1(15-1) a(13)c'(11)
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end do
end do

return

end subroutine ttdd_ar_act_blbr_sgt1

subroutine ddtt_arblbr_act_c1_sgt1(lin)
!=======================================================================
! d1t1(16) ar(13)-bl(31)-br(31)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_d1t1, w1_d1t1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmd, lmi, lmij, lmj, lrd, lri, lrj, mpl, ni
real(kind=wp) :: w0dt, w1dt
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmr) cycle
    ! d1t1(16) ar(13)-bl(31)-br(31)-
    do lrd=norb_frz+1,lri-1
      lmd = lsm_inn(lrd)
      if (lmd /= jml) cycle
      ijk = lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
      intpos = intind_ijka(ijk)
      w0dt = w0_d1t1
      w1dt = w1_d1t1
      ni = mod(norb_dz-lrj+lri-lrd,2)
      if (ni == 0) w0dt = -w0dt
      if (ni == 0) w1dt = -w1dt

      iwdr = just(lri,lrj)
      iwdl = jud(lrd)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0dt
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1dt
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    end do
  end do
end do

return

end subroutine ddtt_arblbr_act_c1_sgt1

subroutine dddd_drl_act_br_sgt0(lin,lra)
! d1d1(20-2) drl(11)-
! d1d1(20-3) drl(33)-c"(11)-
! d1d1(20-3) (11)drl(33)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d1, w1_d1d1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lml, lrk, lrl, mpl
real(kind=wp) :: w0, w1
integer(kind=iwp), external :: iwalk_ad

do lrl=norb_frz+1,norb_dz
  lml = lsm_inn(lrl)
  if (lml /= jml) cycle
  !---------------------------------------------------------------------
  iwdl = jud(lrl)
  iwdr = iwdl
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  w0 = w0_d1d1(2)
  w1 = w1_d1d1(2)
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1
  end do
  call drl_br_ext_al_new(lin,lrl,lra)

  w0 = w0_d1d1(3)
  w1 = Zero
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1
  end do
  do lrk=1,norb_dz
    if (lrk == lrl) cycle
    call drl_br_ext_al_new(lin,lrk,lra)
  end do
end do

return

end subroutine dddd_drl_act_br_sgt0

subroutine dddd_arbl_act_br_sgt0(lin,lra)
! d1d1(20-1) a&r(13)-b&l(31)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d1, &
                         w1_d1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lml, lmr, lrl, lrr, mpl, ni
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lrl=norb_frz+1,norb_dz-1
  lml = lsm_inn(lrl)
  if (lml /= jml) cycle
  do lrr=lrl+1,norb_dz
    lmr = lsm_inn(lrr)
    if (lmr /= jmr) cycle
    ijk = lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    w0dd1 = w0_d1d1(1)
    w1dd1 = w1_d1d1(1)
    ni = mod(lrr-lrl,2)
    if (ni == 0) w0dd1 = -w0dd1
    if (ni == 0) w1dd1 = -w1dd1
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
    end do

    iwdl = jud(lrl)
    iwdr = jud(lrr)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    !-------------------------------------------------------------------
  end do
end do

return

end subroutine dddd_arbl_act_br_sgt0

subroutine ddv_ar_act_blbr_sgt0(lin,jk)
!=======================================================================
! dv(24-1) ar(13)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1v
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lri, mpl, ni
real(kind=wp) :: w0dv1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jml) cycle
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)

  w0dv1 = w0_d1v(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0dv1 = -w0dv1
  iwdl = jud(lri)
  iwdr = 0
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0dv1
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0dv1
  end do
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  call ar_bl_br_ext_al_new(lin,intpos,isma,1)
end do

return

end subroutine ddv_ar_act_blbr_sgt0

subroutine ddv_ar_act_dlr_sgt0(lin,lra)
!=======================================================================
! d1v(24-1) ar(13)-
!=======================================================================

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1v
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lri, mpl, ni
real(kind=wp) :: w0dv1
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jml) cycle

  w0dv1 = w0_d1v(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0dv1 = -w0dv1
  iwdl = jud(lri)
  iwdr = 0
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0dv1
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0dv1
  end do
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  call ar_drl_ext_al_new(lin,lri,lra)
end do

return

end subroutine ddv_ar_act_dlr_sgt0

subroutine dd1_arbl_act_br_sgt0(lin,lra)
! dd1(21-1) a&r(23)-b&l(31)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_dd1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lml, lmr, lrl, lrr, mpl, ni
real(kind=wp) :: w1dd1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lrl=norb_frz+1,norb_dz-1
  lml = lsm_inn(lrl)
  if (lml /= jml) cycle
  do lrr=lrl+1,norb_dz
    lmr = lsm_inn(lrr)
    if (lmr /= jmr) cycle
    ijk = lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    !w0dd1 = Zero
    w1dd1 = w1_dd1
    ni = mod(lrr-lrl,2)
    if (ni == 0) w1dd1 = -w1_dd1
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
    end do

    iwdl = jud(lrl)
    iwdr = jud(lrr)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    !-------------------------------------------------------------------
  end do
end do

return

end subroutine dd1_arbl_act_br_sgt0

subroutine d1d_arbl_act_br_sgt0(lin,lra)
! d1d(22-1) a&r(13)-b&l(32)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_d1d
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lml, lmr, lrl, lrr, mpl, ni
real(kind=wp) :: w1dd1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lrl=norb_frz+1,norb_dz-1
  lml = lsm_inn(lrl)
  if (lml /= jml) cycle
  do lrr=lrl+1,norb_dz
    lmr = lsm_inn(lrr)
    if (lmr /= jmr) cycle
    ijk = lrl-norb_frz+ngw2(lrr-norb_frz)+ngw3(lra-norb_frz)
    intpos = intind_ijka(ijk)
    !w0dd1 = Zero
    w1dd1 = w1_d1d(1)
    ni = mod(lrr-lrl,2)
    if (ni == 0) w1dd1 = -w1dd1
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
    end do

    iwdl = jud(lrl)
    iwdr = jud(lrr)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    !-------------------------------------------------------------------
  end do
end do

return

end subroutine d1d_arbl_act_br_sgt0

subroutine d1d_drl_act_br_sgt0(lin,lra)
! d1d(22-2) drl(12)-

use gugaci_global, only: ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_d1d
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lml, lrl, mpl
real(kind=wp) :: w1
integer(kind=iwp), external :: iwalk_ad

do lrl=norb_frz+1,norb_dz
  lml = lsm_inn(lrl)
  if (lml /= jml) cycle
  !---------------------------------------------------------------------
  iwdl = jud(lrl)
  iwdr = iwdl
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  w1 = w1_d1d(2)
  do mpl=1,mtype
    vplp_w0(mpl) = Zero
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1
  end do
  call drl_br_ext_al_new(lin,lrl,lra)
end do

return

end subroutine d1d_drl_act_br_sgt0

!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! end of vd, next dd
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

subroutine ss_arbr_act_c_dd_ext_sgt0()
! ss(1-1)  ar(01)-bl(32)-        act -c"-
! ss(1-3)  ar(13)-bl(20)-        act -c"-
! ss(1-6)  (11)-ar(23)-bl(32)-   act -c"-
! ss(1-7)  ar(13)-c'(21)-bl(32)- act -c"-
! ss(1-8)  ar(13)-c'(22)-bl(31)- act -c"-
! ss(1-9)  ar(23)-c'(11)-bl(32)- act -c"-
! ss(1-11) ar(13)-bl(31)-c"(22)- act -c"-
! ss(1-12) ar(13)-bl(32)-c"(21)- act -c"-
! ss(1-13) ar(23)-bl(31)-c"(12)- act -c"-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0ss1, w0ss11, w0ss12, w0ss13, w0ss3, w0ss6, w0ss7, w0ss8, w0ss9, w1ss1, w1ss11, w1ss12, w1ss13, w1ss3, w1ss6, &
                 w1ss7, w1ss8, w1ss9
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    w0ss1 = w0_ss(1)
    w1ss1 = w1_ss(1)
    w0ss3 = w0_ss(3)
    w1ss3 = w1_ss(3)
    w0ss6 = w0_ss(6)
    w1ss6 = w1_ss(6)
    w0ss7 = w0_ss(7)
    w1ss7 = w1_ss(7)
    w0ss8 = w0_ss(8)
    w1ss8 = w1_ss(8)
    w0ss9 = w0_ss(9)
    w1ss9 = w1_ss(9)
    w0ss11 = w0_ss(11)
    w1ss11 = w1_ss(11)
    w0ss12 = w0_ss(12)
    w1ss12 = w1_ss(12)
    w0ss13 = w0_ss(13)
    w1ss13 = w1_ss(13)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0ss1 = -w0ss1
      w1ss1 = -w1ss1
      w0ss3 = -w0ss3
      w1ss3 = -w1ss3
      w0ss6 = -w0ss6
      w1ss6 = -w1ss6
      w0ss7 = -w0ss7
      w1ss7 = -w1ss7
      w0ss8 = -w0ss8
      w1ss8 = -w1ss8
      w0ss9 = -w0ss9
      w1ss9 = -w1ss9
      w0ss11 = -w0ss11
      w1ss11 = -w1ss11
      w0ss12 = -w0ss12
      w1ss12 = -w1ss12
      w0ss13 = -w0ss13
      w1ss13 = -w1ss13
    end if
    ! ss(1-1)  ar(01)-bl(32)-        act -c"-
    if ((jml == 1) .and. (lmij == jmr)) then
      iwdl = just(lri,lri)
      iwdr = just(lrj,lri)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss1
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss1
      end do
      call ar_bl_dd_ext(lri,lrj,1)
    end if
    ! ss(1-3)  ar(13)-bl(20)-        act -c"-
    if ((jmr == 1) .and. (lmij == jml)) then
      iwdl = just(lrj,lri)
      iwdr = just(lrj,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss3
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss3
      end do
      call ar_bl_dd_ext(lri,lrj,1)
    end if
    ! ss(1-6)  (11)-ar(23)-bl(32)-   act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss6
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss6
    end do
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! ss(1-7)  ar(13)-c'(21)-bl(32)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0ss7
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ss7
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! ss(1-8)  ar(13)-c'(22)-bl(31)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0ss8
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ss8
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! ss(1-9)  ar(23)-c'(11)-bl(32)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0ss9
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ss9
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! ss(1-11) ar(13)-bl(31)-c"(22)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss11
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss11
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! ss(1-12) ar(13)-bl(32)-c"(21)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss12
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss12
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! ss(1-13) ar(23)-bl(31)-c"(12)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss13
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss13
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
  end do
end do

return

end subroutine ss_arbr_act_c_dd_ext_sgt0

!subroutine ss_arbr_act_c_dd_ext()
!
!use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
!                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
!use Symmetry_Info, only: Mul
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
!real(kind=wp) :: w0ss10, w0ss14, w0ss2, w0ss4, w0ss5, w1ss10, w1ss14, w1ss2, w1ss4, w1ss5
!integer(kind=iwp), external :: iwalk_ad
!
!do lri=norb_frz+1,norb_dz-1
!  lmi = lsm_inn(lri)
!  do lrj=lri+1,norb_dz
!    lmj = lsm_inn(lrj)
!    lmij = Mul(lmi,lmj)
!    w0ss2 = w0_ss(2)
!    w1ss2 = w1_ss(2)
!    w0ss4 = w0_ss(4)
!    w1ss4 = w1_ss(4)
!    w0ss5 = w0_ss(5)
!    w1ss5 = w1_ss(5)
!    w0ss10 = -w0_ss(10)
!    w1ss10 = -w1_ss(10)
!    w0ss14 = w0_ss(14)
!    w1ss14 = w1_ss(14)
!    ni = mod(lrj-lri,2)
!    if (ni == 0) then
!      w0ss2 = -w0ss2
!      w1ss2 = -w1ss2
!      w0ss4 = -w0ss4
!      w1ss4 = -w1ss4
!      w0ss5 = -w0ss5
!      w1ss5 = -w1ss5
!      w0ss10 = -w0ss10
!      w1ss10 = -w1ss10
!      w0ss14 = -w0ss14
!      w1ss14 = -w1ss14
!    end if
!    if ((jml == 1) .and. (lmij == jmr)) then
!      ! ss(1-2)  ar(02)-bl(31)-        act -c"-
!      iwdl = just(lri,lri)
!      iwdr = just(lri,lrj)
!      do mpl=1,mhlp
!        iwal = lpnew_lwei(mpl)
!        iwar = lpnew_rwei(mpl)
!        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!      end do
!      do mpl=1,mtype
!        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss2
!        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss2
!      end do
!      call ar_bl_dd_ext(lri,lrj,1)
!    end if
!    if ((jmr == 1) .and. (lmij == jml)) then
!      !ss(1-4)  ar(23)-bl(10)-        act -c"-                   ! iprad
!      iwdl = just(lri,lrj)
!      iwdr = just(lrj,lrj)
!      do mpl=1,mhlp
!        iwal = lpnew_lwei(mpl)
!        iwar = lpnew_rwei(mpl)
!        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!      end do
!      do mpl=1,mtype
!        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss4
!        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss4
!      end do
!      call ar_bl_dd_ext(lri,lrj,1)
!    end if
!    ! ss(1-5)  (22)-ar(13)-bl(31)-   act -c"-
!    do mpl=1,mtype
!      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss5
!      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss5
!    end do
!    do lrk=norb_frz+1,lri-1
!      lmk = lsm_inn(lrk)
!      lmki = Mul(lmk,lmi)
!      lmkj = Mul(lmk,lmj)
!      if ((lmki == jml) .and. (lmkj == jmr)) then
!        iwdl = just(lrk,lri)
!        iwdr = just(lrk,lrj)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        call ar_bl_dd_ext(lri,lrj,1)
!      end if
!    end do
!    ! ss(1-10) ar(23)-c'(12)-bl(31)- act -c"-
!    do mpl=1,mtype
!      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss10
!      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss10
!    end do
!    do lrk=lri+1,lrj-1
!      lmk = lsm_inn(lrk)
!      lmki = Mul(lmk,lmi)
!      lmkj = Mul(lmk,lmj)
!      if ((lmki == jml) .and. (lmkj == jmr)) then
!        iwdl = just(lri,lrk)
!        iwdr = just(lrk,lrj)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        call ar_bl_dd_ext(lri,lrj,1)
!      end if
!    end do
!    ! ss(1-14) ar(23)-bl(32)-c"(11)- act -c"-
!    do mpl=1,mtype
!      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss14
!      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss14
!    end do
!    do lrk=lrj+1,norb_dz
!      lmk = lsm_inn(lrk)
!      lmki = Mul(lmk,lmi)
!      lmkj = Mul(lmk,lmj)
!      if ((lmki == jml) .and. (lmkj == jmr)) then
!        iwdl = just(lri,lrk)
!        iwdr = just(lrj,lrk)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        call ar_bl_dd_ext(lri,lrj,1)
!      end if
!    end do
!  end do
!end do
!
!return
!
!end subroutine ss_arbr_act_c_dd_ext

subroutine ss_drl_act_c_dd_ext_sgt0()
! ss(1-18) drl(11)-c"(22)-       act -c"-
! ss(1-19) drl(12)-c"(21)-       act -c"-
! ss(1-20) (11)-drl(33)-c"(22)-  act -c"-
! ss(1-20) drl(33)-c"(11)-c"(22)-act -c"-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

if (jml /= jmr) return
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    iwdl = just(lrj,lri)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    ! ss(1-16) (11)-drl(22)-         act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(16)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(16)
    end do
    call drl_dd_ext(lrj)
    ! ss(1-18) drl(11)-c"(22)-       act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(18)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(18)
    end do
    call drl_dd_ext(lri)
    ! ss(1-20) (11)(22)drl(33)-  act -c"-
    ! ss(1-20) (11)-drl(33)-c"(22)-  act -c"-
    ! ss(1-20) drl(33)-c"(11)-c"(22)-act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(20)
      vplp_w1(mpl) = Zero
    end do
    do lrk=1,norb_dz
      if (lrk == lri) cycle
      if (lrk == lrj) cycle
      call drl_dd_ext(lrk)
    end do
  end do
end do

return

end subroutine ss_drl_act_c_dd_ext_sgt0

subroutine ss_s_drl_act_c_dd_ext_sgt0()
! ss(1-19) drl(12)-c"(21)-       act -c"-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_ss
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

if (jml /= jmr) return
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    ! ss(1-19) drl(12)-c"(21)-       act -c"-
    iwdl = just(lrj,lri)
    iwdr = just(lri,lrj)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(19)
    end do
    call drl_dd_ext(lri)
  end do
end do

return

end subroutine ss_s_drl_act_c_dd_ext_sgt0

!subroutine ss_drl_act_c_dd_ext()
!
!use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
!                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
!use Symmetry_Info, only: Mul
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lr0, lri, lrj, lrk, mpl
!real(kind=wp) :: w0ss15, w0ss17, w0ss20, w1ss15, w1ss17
!integer(kind=iwp), external :: iwalk_ad
!
!w0ss15 = w0_ss(15)
!w1ss15 = w1_ss(15)
!w0ss17 = w0_ss(17)
!w1ss17 = w1_ss(17)
!w0ss20 = w0_ss(20)
!if ((jml == 1) .and. (jmr == 1)) then
!  ! ss(1-20) drl(33)-c"(00)-       act -c"-                  ! ipl(r)ad=
!  do lr0=norb_frz+1,norb_dz
!    iwdl = just(lr0,lr0)
!    iwdr = iwdl
!    do mpl=1,mhlp
!      iwal = lpnew_lwei(mpl)
!      iwar = lpnew_rwei(mpl)
!      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!    end do
!    do lrk=1,norb_dz
!      if (lrk == lr0) cycle
!      do mpl=1,mtype
!        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss20
!        vplp_w1(mpl) = Zero
!      end do
!      call drl_dd_ext(lrk)
!    end do
!  end do
!end if
!do lri=norb_frz+1,norb_dz-1
!  lmi = lsm_inn(lri)
!  do lrj=lri+1,norb_dz
!    lmj = lsm_inn(lrj)
!    lmij = Mul(lmi,lmj)
!    if ((lmij /= jml) .or. (lmij /= jmr)) cycle
!    iwdl = just(lri,lrj)
!    iwdr = iwdl
!    do mpl=1,mhlp
!      iwal = lpnew_lwei(mpl)
!      iwar = lpnew_rwei(mpl)
!      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!    end do
!    ! ss(1-15) (22)-drl(11)-         act -c"-
!    do mpl=1,mtype
!      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss15
!      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss15
!    end do
!    call drl_dd_ext(lrj)
!    ! ss(1-17) drl(22)-c"(11)-       act -c"-
!    do mpl=1,mtype
!      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss17
!      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss17
!    end do
!    call drl_dd_ext(lri)
!    ! ss(1-20) (22)(11)drl(33)-      act -c"-
!    ! ss(1-20) (22)drl(33)-c"(11)-   act -c"-
!    ! ss(1-20) drl(33)-c"(22)-c"(11)-act -c"-
!    do mpl=1,mtype
!      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss20
!      vplp_w1(mpl) = Zero
!    end do
!    do lrk=1,norb_dz
!      if (lrk == lri) cycle
!      if (lrk == lrj) cycle
!      call drl_dd_ext(lrk)
!    end do
!  end do
!end do
!
!return
!
!end subroutine ss_drl_act_c_dd_ext

subroutine st_arbl_act_c_dd_ext_sgt0()
! st(2-3) ar(13)-c'(22)-bl(32)-   act -c"-
! st(2-3) ar(13)-bl(32)-c'(22)-   act -c"-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1st3
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    w1st3 = w1_st(3)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1st3 = -w1st3
    end if
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! st(2-3) ar(13)-c'(22)-bl(32)-   act -c"-
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = -vplpnew_w1(mpl)*w1st3
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! st(2-3) ar(13)-bl(32)-c'(22)-   act -c"-
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1st3
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
  end do
end do

return

end subroutine st_arbl_act_c_dd_ext_sgt0

!subroutine st_arbl_act_c_dd_ext()
!
!use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
!                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
!use Symmetry_Info, only: Mul
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
!real(kind=wp) :: w1st1, w1st2, w1st4
!integer(kind=iwp), external :: iwalk_ad
!
!do lri=norb_frz+1,norb_dz-1
!  lmi = lsm_inn(lri)
!  do lrj=lri+1,norb_dz
!    lmj = lsm_inn(lrj)
!    lmij = Mul(lmi,lmj)
!    w1st1 = w1_st(1)
!    w1st2 = w1_st(2)
!    w1st4 = w1_st(4)
!    ni = mod(lrj-lri,2)
!    if (ni == 0) then
!      w1st1 = -w1st1
!      w1st2 = -w1st2
!      w1st4 = -w1st4
!    end if
!    if ((jml == 1) .and. (lmij == jmr)) then
!      ! st(2-1) ar(02)-bl(32)-          act -c"-
!      iwdl = just(lri,lri)
!      iwdr = just(lri,lrj)
!      do mpl=1,mhlp
!        iwal = lpnew_lwei(mpl)
!        iwar = lpnew_rwei(mpl)
!        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!      end do
!      do mpl=1,mtype
!        vplp_w0(mpl) = Zero
!        vplp_w1(mpl) = vplpnew_w1(mpl)*w1st1
!      end do
!      call ar_bl_dd_ext(lri,lrj,1)
!    end if
!    do lrk=norb_frz+1,lri-1
!      lmk = lsm_inn(lrk)
!      lmki = Mul(lmk,lmi)
!      lmkj = Mul(lmk,lmj)
!      if ((lmki == jml) .and. (lmkj == jmr)) then
!        ! st(2-2) (22)ar(13)-bl(32)-      act -c"-
!        iwdl = just(lrk,lri)
!        iwdr = just(lrk,lrj)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        do mpl=1,mtype
!          vplp_w0(mpl) = Zero
!          vplp_w1(mpl) = vplpnew_w1(mpl)*w1st2
!        end do
!        call ar_bl_dd_ext(lri,lrj,1)
!      end if
!    end do
!    do lrk=lri+1,lrj-1
!      lmk = lsm_inn(lrk)
!      lmki = Mul(lmk,lmi)
!      lmkj = Mul(lmk,lmj)
!      if ((lmki == jml) .and. (lmkj == jmr)) then
!        ! st(2-4) ar(23)-c'(12)-bl(32)-   act -c"-
!        iwdl = just(lri,lrk)
!        iwdr = just(lrk,lrj)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        do mpl=1,mtype
!          vplp_w0(mpl) = Zero
!          vplp_w1(mpl) = vplpnew_w1(mpl)*w1st4
!        end do
!        call ar_bl_dd_ext(lri,lrj,1)
!      end if
!    end do
!    do lrk=lrj+1,norb_dz
!      lmk = lsm_inn(lrk)
!      lmki = Mul(lmk,lmi)
!      lmkj = Mul(lmk,lmj)
!      if ((lmki == jml) .and. (lmkj == jmr)) then
!        ! st(2-4) ar(23)-bl(32)-c'(12)-   act -c"-
!        iwdl = just(lri,lrk)
!        iwdr = just(lrj,lrk)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        do mpl=1,mtype
!          vplp_w0(mpl) = Zero
!          vplp_w1(mpl) = vplpnew_w1(mpl)*w1st4
!        end do
!        call ar_bl_dd_ext(lri,lrj,1)
!      end if
!    end do
!  end do
!end do
!
!return
!
!end subroutine st_arbl_act_c_dd_ext

subroutine st_drl_act_c_dd_ext_sgt0()
!-----------------------------------------------------------------------
! st(2-7) drl(12)-c"(22)-         act -c"-
!-----------------------------------------------------------------------

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    ! st(2-7) drl(12)-c"(22)-         act -c"-
    if ((lmij /= jml) .or. (lmij /= jmr)) cycle
    iwdl = just(lrj,lri)
    iwdr = just(lri,lrj)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_st(7)
    end do
    call drl_dd_ext(lri)
  end do
end do

return

end subroutine st_drl_act_c_dd_ext_sgt0

!subroutine st_drl_act_c_dd_ext()
!
!use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
!                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
!use Symmetry_Info, only: Mul
!use Constants, only: Zero
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
!integer(kind=iwp), external :: iwalk_ad
!
!do lri=norb_frz+1,norb_dz-1
!  lmi = lsm_inn(lri)
!  do lrj=lri+1,norb_dz
!    lmj = lsm_inn(lrj)
!    lmij = Mul(lmi,lmj)
!    if ((lmij /= jml) .or. (lmij /= jmr)) cycle
!    ! st(2-5) (22)drl(12)-          act -c"-
!    iwdl = just(lri,lrj)
!    iwdr = just(lrj,lri)
!    do mpl=1,mhlp
!      iwal = lpnew_lwei(mpl)
!      iwar = lpnew_rwei(mpl)
!      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!    end do
!    do mpl=1,mtype
!      vplp_w0(mpl) = Zero
!      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_st(5)
!    end do
!    call drl_dd_ext(lrj)
!    ! st(2-6) drl(22)-c"(12)-       act -c"-
!    do mpl=1,mtype
!      vplp_w0(mpl) = Zero
!      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_st(6)
!    end do
!    call drl_dd_ext(lri)
!  end do
!end do
!
!return
!
!end subroutine st_drl_act_c_dd_ext

subroutine ts_arbl_act_c_dd_exe_sgt0()

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_ts
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1ts3
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    w1ts3 = w1_ts(3)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1ts3 = -w1ts3
    end if
    ! ts(3-3) ar(23)-bl(31)-c"(22)-   act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts3
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
  end do
end do

return

end subroutine ts_arbl_act_c_dd_exe_sgt0

subroutine stt_arbl_act_c_dd_ext_sgt1()
! st1(4-1) ar(01)-bl(31)-
! st1(4-2) ar(23)-bl(31)-
! st1(4-3) ar(13)-c'(21)-bl(31)-
! st1(4-3) ar(13)-bl(31)-c"(21)-
! st1(4-4) ar(23)-c'(11)-bl(31)-
! st1(4-4) ar(23)-bl(31)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1ts1, w1ts2, w1ts3, w1ts4
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    w1ts1 = w1_st1(1)
    w1ts2 = w1_st1(2)
    w1ts3 = w1_st1(3)
    w1ts4 = w1_st1(4)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1ts1 = -w1ts1
      w1ts2 = -w1ts2
      w1ts3 = -w1ts3
      w1ts4 = -w1ts4
    end if
    if ((jml == 1) .and. (lmij == jmr)) then
      ! st1(4-1) ar(01)-bl(31)-
      iwdl = just(lri,lri)
      iwdr = just(lri,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = Zero
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts1
      end do
      call ar_bl_dd_ext(lri,lrj,1)
    end if
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! st1(4-2) (11)ar(23)-bl(31)-
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts2
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! st1(4-3) ar(13)-c'(21)-bl(31)-
        ! st1(4-4) ar(23)-c'(11)-bl(31)-
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ts3
        end do
        call ar_bl_dd_ext(lri,lrj,1)
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ts4
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! st1(4-3) ar(13)-bl(31)-c"(21)-
    ! st1(4-4) ar(23)-bl(31)-c"(11)-
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts3
        end do
        call ar_bl_dd_ext(lri,lrj,1)
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts4
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
  end do
end do

return

end subroutine stt_arbl_act_c_dd_ext_sgt1

subroutine tts_arbl_act_c_dd_ext_sgt1()
! t1s(5-1)   ar(13)-bl(10)-
! t1s(5-2)   ar(13)-bl(32)-
! t1s(5-2)   ar(13)-c'(11)-bl(32)-
! t1s(5-3)   ar(13)-bl(31)-c"(12)-
! t1s(5-4)   ar(13)-bl(32)-c"(11)-
! t1s(5-5)   drl(12)-
! t1s(5-6)   drl(12)-c"(12)-
! t1s(5-7)   drl(12)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1ts1, w1ts2, w1ts3, w1ts4
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    w1ts1 = w1_t1s(1)
    w1ts2 = w1_t1s(2)
    w1ts3 = w1_t1s(3)
    w1ts4 = w1_t1s(4)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1ts1 = -w1ts1
      w1ts2 = -w1ts2
      w1ts3 = -w1ts3
      w1ts4 = -w1ts4
    end if
    if ((jmr == 1) .and. (lmij == jml)) then
      ! t1s(5-1)   ar(13)-bl(10)-
      iwdl = just(lri,lrj)
      iwdr = just(lrj,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = Zero
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts1
      end do
      call ar_bl_dd_ext(lri,lrj,1)
    end if
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! t1s(5-2)   (11)ar(13)-bl(32)-
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts2
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! t1s(5-2)   ar(13)-c'(11)-bl(32)-
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ts2
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! t1s(5-3)   ar(13)-bl(31)-c"(12)-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts3
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! t1s(5-4)   ar(13)-bl(32)-c"(11)-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts4
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
  end do
end do

return

end subroutine tts_arbl_act_c_dd_ext_sgt1

subroutine tts_drl_act_c_dd_ext_sgt1()
! t1s(5-5)   (11)drl(12)-
! t1s(5-6)   drl(12)-c"(12)-
! t1s(5-7)   drl(12)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

if (jml /= jmr) return
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=norb_frz+1,lri-1
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (jml /= lmij) cycle
    ! t1s(5-5)   (11)drl(12)-
    ! t1s(5-6)   drl(11)-c"(12)-
    iwdl = just(lrj,lri)
    iwdr = just(lri,lrj)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_t1s(5)
    end do
    call drl_dd_ext(lri)
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_t1s(6)
    end do
    call drl_dd_ext(lrj)
    ! t1s(5-7)   drl(12)-c"(11)-
    iwdl = just(lrj,lri)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_t1s(7)
    end do
    call drl_dd_ext(lrj)
  end do
end do

return

end subroutine tts_drl_act_c_dd_ext_sgt1

subroutine sd_ar_act_bl_dd_ext_sgt0(lra)
! sd(6-3) a&r(13)c'(22)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lmki, lri, lrk, mpl, ni
real(kind=wp) :: w0sd3
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd3 = w0_sd(3)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0sd3 = -w0sd3
  ! sd(6-3) a&r(13)-c'(22)-
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    lmki = Mul(lmk,lmi)
    if ((lmki == jml) .and. (lmk == jmr)) then
      iwdl = just(lrk,lri)
      iwdr = jud(lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd3
        vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd3
      end do
      call ar_bl_dd_ext(lri,lra,1)
    end if
  end do
end do

return

end subroutine sd_ar_act_bl_dd_ext_sgt0

subroutine sdd_ar_act_bl_dd_ext_sgt0(lra)
! sd1(8-1)    ar(01)-
! sd1(8-2)    (11)ar(23)-
! sd1(8-3)    ar(13)-c'(21)-
! sd1(8-4)    ar(23)-c'(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lmki, lri, lrk, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd3, w0sd4
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd1 = w0_sd1(1)
  w0sd2 = w0_sd1(2)
  w0sd3 = w0_sd1(3)
  w0sd4 = w0_sd1(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0sd1 = -w0sd1
  if (ni == 1) w0sd2 = -w0sd2
  if (ni == 1) w0sd3 = -w0sd3
  if (ni == 1) w0sd4 = -w0sd4
  if ((jml == 1) .and. (lmi == jmr)) then
    ! sd1(8-1)    ar(01)-
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
    end do
    call ar_bl_dd_ext(lri,lra,1)
  end if
  ! sd1(8-2)    (11)ar(23)-
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    lmki = Mul(lmk,lmi)
    if ((lmki == jml) .and. (lmk == jmr)) then
      iwdl = just(lri,lrk)
      iwdr = jud(lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
        vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
      end do
      call ar_bl_dd_ext(lri,lra,1)
    end if
  end do
  ! sd1(8-3)    ar(13)-c'(21)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd3           ! - ????
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd3           ! - ????
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    lmki = Mul(lmk,lmi)
    if ((lmki == jml) .and. (lmk == jmr)) then
      iwdl = just(lrk,lri)
      iwdr = jud(lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call ar_bl_dd_ext(lri,lra,1)
    end if
  end do
  ! sd1(8-4)    ar(23)-c'(11)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4           ! - ????
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd4           ! - ????
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    lmki = Mul(lmk,lmi)
    if ((lmki == jml) .and. (lmk == jmr)) then
      iwdl = just(lri,lrk)
      iwdr = jud(lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call ar_bl_dd_ext(lri,lra,1)
    end if
  end do
end do

return

end subroutine sdd_ar_act_bl_dd_ext_sgt0

subroutine tttt_arbl_act_c_dd_ext_sgt1()
! t1t1(12-1)  ar(13)-bl(31)-
! t1t1(12-1)  ar(13)-c'(11)-bl(31)-
! t1t1(12-1)  ar(13)-bl(31)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1t1, w1_t1t1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0tt1, w1tt1
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    w0tt1 = w0_t1t1(1)
    w1tt1 = w1_t1t1(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0tt1 = -w0tt1
      w1tt1 = -w1tt1
    end if
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0tt1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1tt1
    end do
    ! t1t1(12-1)  (11)ar(13)-bl(31)-
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    ! t1t1(12-1)  ar(13)-bl(31)-c"(11)-
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = -vplp_w0(mpl)
      vplp_w1(mpl) = -vplp_w1(mpl)
    end do
    ! t1t1(12-1)  ar(13)-c'(11)-bl(31)-
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call ar_bl_dd_ext(lri,lrj,1)
      end if
    end do
  end do
end do

return

end subroutine tttt_arbl_act_c_dd_ext_sgt1

subroutine tttt_drl_act_c_dd_ext_sgt1()
! t1t1(12-2)  drl(11)-
! t1t1(12-2)  drl(11)-c"(11)-
! t1t1(12-3)  drl(33)-
! t1t1(12-3)  drl(33)-c"(11)-
! t1t1(12-3)  drl(33)-c"(11)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1t1, w1_t1t1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if ((lmij /= jml) .or. (lmij /= jmr)) cycle
    ! t1t1(12-2)  drl(11)-
    ! t1t1(12-2)  drl(11)-c"(11)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_t1t1(2)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_t1t1(2)
    end do
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call drl_dd_ext(lri)
    call drl_dd_ext(lrj)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_t1t1(3)
      vplp_w1(mpl) = Zero
    end do
    do lrk=1,norb_dz
      if (lrk == lri) cycle
      if (lrk == lrj) cycle
      ! t1t1(12-3)  drl(33)-
      ! t1t1(12-3)  drl(33)-c"(11)-
      ! t1t1(12-3)  drl(33)-c"(11)-c"(11)-
      call drl_dd_ext(lrk)
    end do
  end do
end do

return

end subroutine tttt_drl_act_c_dd_ext_sgt1

subroutine ttdd_ar_act_bl_dd_ext_sgt1(lra)
! t1d1(15-1)  (11)ar(13)-
! t1d1(15-1)  ar(13)-c'(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_t1d1(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1

  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk == jmr) then
      ! t1d1(15-1)  (11)ar(13)-
      iwdl = just(lrk,lri)
      iwdr = jud(lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
        vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
      end do
      call ar_bl_dd_ext(lri,lra,1)
    end if
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk == jmr) then
      ! t1d1(15-1)  ar(13)-c'(11)-
      iwdl = just(lri,lrk)
      iwdr = jud(lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
        vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
      end do
      call ar_bl_dd_ext(lri,lra,1)
    end if
  end do
end do

return

end subroutine ttdd_ar_act_bl_dd_ext_sgt1

subroutine dddd_arbl_act_c_dd_ext_sgt0()
! d1d1(20-1) ar(13)-bl(31)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d1, w1_d1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    w0dd1 = w0_d1d1(1)
    w1dd1 = w1_d1d1(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0dd1 = -w0dd1
      w1dd1 = -w1dd1
    end if
    if ((lmi == jml) .and. (lmj == jmr)) then
      ! d1d1(20-1) ar(13)-bl(31)-
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd1
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
      end do
      iwdl = jud(lri)
      iwdr = jud(lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call ar_bl_dd_ext(lri,lrj,1)
    end if
  end do
end do

return

end subroutine dddd_arbl_act_c_dd_ext_sgt0

subroutine dddd_drl_act_c_dd_ext_sgt0()
! d1d1(20-2) drl(11)-
! d1d1(20-3) drl(33)-
! d1d1(20-3) drl(33)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d1, w1_d1d1
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lri, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

if (jmr /= jml) return
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jml) cycle
  ! d1d1(20-2) drl(11)-
  iwdl = jud(lri)
  iwdr = iwdl
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0_d1d1(2)
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1_d1d1(2)
  end do
  call drl_dd_ext(lri)
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0_d1d1(3)
    vplp_w1(mpl) = Zero
  end do
  ! d1d1(20-3) drl(33)-
  ! d1d1(20-3) drl(33)-c"(11)-
  do lrk=1,norb_dz
    if (lrk == lri) cycle
    call drl_dd_ext(lrk)
  end do
end do

return

end subroutine dddd_drl_act_c_dd_ext_sgt0

subroutine dd1_arbl_act_c_dd_ext_sgt0()
! dd1(21)ar(23)-bl(31)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dd1, w1_dd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    w0dd1 = w0_dd1
    w1dd1 = w1_dd1
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0dd1 = -w0dd1
      w1dd1 = -w1dd1
    end if
    if ((lmi == jml) .and. (lmj == jmr)) then
      ! dd1(21)ar(23)-bl(31)-
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd1
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
      end do
      iwdl = jud(lri)
      iwdr = jud(lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call ar_bl_dd_ext(lri,lrj,1)
    end if
  end do
end do

return

end subroutine dd1_arbl_act_c_dd_ext_sgt0

subroutine d1d_arbl_act_c_dd_ext_sgt0()
! d1d(22-1)   ar(13)-bl(32)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d, w1_d1d
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    w0dd1 = w0_d1d(1)
    w1dd1 = w1_d1d(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0dd1 = -w0dd1
      w1dd1 = -w1dd1
    end if
    if ((lmi == jml) .and. (lmj == jmr)) then
      ! d1d(22-1)   ar(13)-bl(32)-
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd1
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
      end do
      iwdl = jud(lri)
      iwdr = jud(lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call ar_bl_dd_ext(lri,lrj,1)
    end if
  end do
end do

return

end subroutine d1d_arbl_act_c_dd_ext_sgt0

subroutine d1d_drl_act_c_dd_ext_sgt0()
! d1d(22-2)   drl(12)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_d1d
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lri, mpl
integer(kind=iwp), external :: iwalk_ad

if (jml /= jmr) return
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jml) cycle
  ! d1d(22-2)   drl(12)-
  do mpl=1,mtype
    vplp_w0(mpl) = Zero
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1_d1d(2)
  end do
  iwdl = jud(lri)
  iwdr = iwdl
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  call drl_dd_ext(lri)
end do

return

end subroutine d1d_drl_act_c_dd_ext_sgt0

subroutine d1v_ar_act_bl_dd_ext_sgt0(lra)
! d1v(24-1)  ar(13)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1v
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lri, mpl, ni
real(kind=wp) :: w0dv1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0dv1 = w0_d1v(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0dv1 = -w0dv1
  ! d1v(24-1)  ar(13)-
  iwdl = jud(lri)
  iwdr = 0
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0dv1
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0dv1
  end do
  call ar_bl_dd_ext(lri,lra,1)
end do

return

end subroutine d1v_ar_act_bl_dd_ext_sgt0

subroutine sd_adb_act_c_ext_ar(lin)
! sd(6-3) a&r(13)c'(22)-
! sd(6-10) d&r&l(12)b^l(23)
! sd(6-15) d&r&l(33)b^l(13)c'(22)

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_sd, w1_sd
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmd, lmi, lmij, lmj, lrd, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0sd10, w0sd15, w0sd3, w0sd6, w0sd7, w1sd10, w1sd15, w1sd3, w1sd6, w1sd7
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    if (lmi == jmr) then
      iwdl = just(lrj,lri)
      iwdr = jud(lri)
      w0sd10 = w0_sd(10)
      w1sd10 = w1_sd(10)
      ni = mod(norb_dz-lrj,2)
      if (ni == 1) then
        w0sd10 = -w0sd10
        w1sd10 = -w1sd10
      end if
      ! sd(6-10) d&r&l(12)b^l(23)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd10
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd10
      end do
      call drl_bl_ext_ar_new(lin,lri,lrj)
    end if
    ! sd(6-3) a&r(13)c'(22)-
    w0sd3 = w0_sd(3)
    w1sd3 = w1_sd(3)
    w0sd15 = w0_sd(15)
    w1sd15 = w1_sd(15)
    ni = mod(norb_dz-lri,2)
    if (ni == 0) then
      w0sd3 = -w0sd3
      w1sd3 = -w1sd3
      w0sd15 = -w0sd15
      w1sd15 = -w1sd15
    end if
    if (lmj == jmr) then
      iwdl = just(lrj,lri)
      iwdr = jud(lrj)
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd3
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd3
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      if (lin == 13) then
        call ar_td_ext_ar(57,lri,lrj,isma)
        call ar_td_ext_rest(lri)
      end if
      if (lin == 6) then
        call ar_sd_ext_ar(57,lri,lrj,isma)
        call ar_sd_ext_rest(lri)
      end if
      if (lin == 23) then
        call ar_dv_ext_ar(57,isma,lri,lrj) !ar_dv
      end if
      ! sd(6-15) d&r&l(33)b^l(13)c'(22)
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd15
        vplp_w1(mpl) = Zero
      end do
      do lrk=1,lri-1
        call drl_bl_ext_ar_new(lin,lrk,lri)
      end do
    end if
    ! sd(6-6) a&r(13)b&r(23)b^r(32)
    do lrd=lrj+1,norb_dz
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle

      w0sd6 = w0_sd(6)
      w1sd6 = w1_sd(6)
      ni = mod(lrj-lri+norb_dz-lrd,2)
      if (ni == 0) then
        w0sd6 = -w0sd6
        w1sd6 = -w1sd6
      end if
      iwdl = just(lrj,lri)
      iwdr = jud(lrd)
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd6
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd6
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
      intpos = intind_ijka(ijk)
      call ar_br_br_ext_ar_new(lin,intpos,isma)
    end do
    ! sd(6-7) a&r(13)b&l(32)b^l(23)
    do lrd=lri+1,lrj-1
      lmd = lsm_inn(lrd)
      if (lmd /= jmr) cycle
      iwdl = just(lrj,lri)
      iwdr = jud(lrd)
      w0sd7 = w0_sd(7)
      w1sd7 = w1_sd(7)
      ni = mod(lrj-lri+norb_dz-lrd,2)
      if (ni == 0) then
        w0sd7 = -w0sd7
        w1sd7 = -w1sd7
      end if
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd7
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd7
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      ijk = lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
      intpos = intind_ijka(ijk)
      call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
    end do
  end do
end do

return

end subroutine sd_adb_act_c_ext_ar

subroutine sd_ar_act_brbr_sgt0(lin,jk)
! sd(6-3) a&r(13)c'(22)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jb_sys, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, &
                         lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd3
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  w0sd3 = w0_sd(3)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd3 = -w0sd3
  end if
  !---------------------------------------------------------------------
  ! sd(6-3) a&r(13)c'(22)-
  if (jb_sys > 0) then
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd3
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd3
    end do
    do lrk=lri+1,norb_dz
      lmk = lsm_inn(lrk)
      if (lmk /= jmr) cycle
      iwdl = just(lrk,lri)
      iwdr = jud(lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call ar_br_br_ext_ar_new(lin,intpos,isma)
    end do
  end if
end do

return

end subroutine sd_ar_act_brbr_sgt0

subroutine sd_ar_act_blbl_sgt0(lin,jk)
! sd(6-3) a&r(13)c'(22)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd3
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  w0sd3 = w0_sd(3)
  ni = mod(norb_dz-lri,2)
  if (ni == 0) then
    w0sd3 = -w0sd3
  end if
  ! sd(6-3) a&r(13)c'(22)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd3
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd3
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
  end do
end do

return

end subroutine sd_ar_act_blbl_sgt0

subroutine sv_arbr_act_br_sgt0(lin,lra)

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jb_sys, jml, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, &
                         vplpnew_w1, w0_sv, w1_sv
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0sv1, w1sv1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    w0sv1 = w0_sv(1)
    w1sv1 = w1_sv(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0sv1 = -w0sv1
      w1sv1 = -w1sv1
    end if
    !-------------------------------------------------------------------
    if (lri /= lrj) then
      ! sv(10-1) ar(13)-br(23)-
      if (jb_sys > 0) then
        iwdl = just(lrj,lri)
        iwdr = 0
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = vplpnew_w0(mpl)*w0sv1
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1sv1
        end do
        ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
        intpos = intind_ijka(ijk)
        call ar_br_br_ext_ar_new(lin,intpos,isma)
      end if
    end if
  end do
end do

return

end subroutine sv_arbr_act_br_sgt0

subroutine d1v_ar_act_c_ext(lin)
! d1v(24-1)  ar(13)-
! d1v(24-2)  drl(33)-bl(13)-

use gugaci_global, only: iml, imr, ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, w0_d1v
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: isma, iwal, iwar, iwdl, iwdr, lmd, lrd, lrk, mpl, ni
real(kind=wp) :: w0
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lrd=norb_frz+1,norb_dz
  lmd = lsm_inn(lrd)
  if (lmd /= jml) cycle
  ni = mod(norb_dz-lrd,2)

  ! d1v(24-1)  ar(13)-
  w0 = w0_d1v(1)
  if (ni == 1) w0 = -w0_d1v(1)
  iwdl = jud(lrd)
  iwdr = 0
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
  end do
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  if (lin == 6) then
    call ar_sd_ext_ar(51,lrd,0,isma)
    call ar_sd_ext_rest(lrd)
  end if
  if (lin == 13) then
    call ar_td_ext_ar(51,lrd,0,isma)
    call ar_td_ext_rest(lrd)
  end if
  ! d1v(24-2)  drl(33)-bl(13)-
  w0 = w0_d1v(2)
  if (ni == 1) w0 = -w0_d1v(2)
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
    vplp_w1(mpl) = Zero
  end do
  do lrk=1,lrd-1
    call drl_bl_ext_ar_new(lin,lrk,lrd)
  end do
end do

return

end subroutine d1v_ar_act_c_ext

subroutine d1v_ar_act_brbr_ext(lin,jk)
! d1v(24-1)  ar(13)-
! d1v(24-2)  drl(33)-bl(13)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1v
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmd, lrd, mpl, ni
real(kind=wp) :: w0
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lrd=norb_frz+1,norb_dz
  lmd = lsm_inn(lrd)
  if (lmd /= jml) cycle
  ni = mod(norb_dz-lrd,2)
  w0 = w0_d1v(1)
  if (ni == 1) w0 = -w0_d1v(1)
  !.....................................................................
  ! d1v(24-1) ar(13)-
  iwdl = jud(lrd)
  iwdr = 0
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0
  end do
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  ijk = lrd-norb_frz+jk
  intpos = intind_ijka(ijk)
  call ar_br_br_ext_ar_new(lin,intpos,isma)
end do

return

end subroutine d1v_ar_act_brbr_ext

subroutine d1v_ar_act_blbl_ext(lin,jk)
! d1v(24-1)  ar(13)-
! d1v(24-2)  drl(33)-bl(13)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1v
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmd, lrd, mpl, ni
real(kind=wp) :: w0
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lrd=norb_frz+1,norb_dz
  lmd = lsm_inn(lrd)
  if (lmd /= jml) cycle
  ni = mod(norb_dz-lrd,2)
  w0 = w0_d1v(1)
  if (ni == 1) w0 = -w0_d1v(1)
  ! dv(23-1) ar(23)-
  iwdl = jud(lrd)
  iwdr = 0
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0
  end do
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  ijk = lrd-norb_frz+jk
  intpos = intind_ijka(ijk)
  call ar_bl_bl_ext_ar_new(lin,intpos,isma,1)
end do

return

end subroutine d1v_ar_act_blbl_ext

subroutine ts_arbl_act_c_ext_ab_sgt0(lin)
! ts(3-3) ar(23)-bl(31)-c"(22)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_ts
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1ts3
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    w1ts3 = w1_ts(3)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1ts3 = -w1ts3
    end if
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! ts(3-3) ar(23)-bl(31)-c"(22)-
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts3
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
  end do
end do

return

end subroutine ts_arbl_act_c_ext_ab_sgt0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!define _DEBUGPRINT_
subroutine Track_State(OVLP)

use rassi_aux, only: ipglob
use Cntrl, only: NJOB, NSTAT, NSTATE
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: ovlp(nstate,nstate)
integer(kind=iwp) :: initState, iState, newState
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: j
#endif
real(kind=wp) :: MaxOv, ThisOv

! Check that there are 2 JOB files, with the same number of states
if (nJob /= 2) call SysAbendMsg('Track_State','The number of JOB files should be 2.','')
if (nStat(2) /= nStat(1)) call SysAbendMsg('Track_State','The number of states in the JOB files should be the same.','')

! Get the root to track
call Get_iScalar('Relax CASSCF root',initState)

! Find the root in the first JOB (current states) that has maximum
! overlap with the tracked root in the second JOB (previous states)
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'OVERLAP MATRIX FOR THE ORIGINAL STATES:'
write(u6,*)
do iState=1,nState
  write(u6,'(5(1X,F15.8))') (Ovlp(iState,j),j=1,iState)
end do
#endif
if (IPGLOB >= 2) then
  write(u6,*)
  write(u6,*) 'Initial root: ',initState
  write(u6,*) 'Overlaps with current states:'
end if
MaxOv = Zero
newState = 0
do iState=1,nStat(1)
  ThisOv = Ovlp(iState,initState+nStat(1))
  if (IPGLOB >= 2) write(u6,'(I5,1X,F15.8)') iState,ThisOv
  if (abs(ThisOv) > MaxOv) then
    MaxOv = abs(ThisOv)
    newState = iState
  end if
end do
if (IPGLOB >= 2) write(u6,*) 'New root: ',newState

! If no state is found, something wrong has happened
if (newState == 0) call SysAbendMsg('Track_State','No overlaps!','')

! Store the new state for geometry optimization
if (newState /= initState) then
  call Put_iScalar('Relax CASSCF root',newState)
  call Put_iScalar('Relax Original root',newState)
  call Put_iScalar('NumGradRoot',newState)
end if

end subroutine Track_State

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE RESTR_RPT2(LV1RAS,LM1RAS,LV3RAS,LM3RAS,
     &                        IDRT0,IDOWN0,IVER)
*
* PURPOSE: PUT THE RAS CONSTRAINT TO THE DRT TABLE BY
*          CREATING A MASK
*
      IMPLICIT REAL*8 (A-H,O-Z)
*
#include "rasdim.fh"

#include "pt2_guga.fh"
*
      DIMENSION IDRT0(NVERT0,5),IDOWN0(NVERT0,0:3),IVER(NVERT0)
*
      PARAMETER (LTAB=1,NTAB=2)
      DIMENSION IOR(0:3,0:3)
      DIMENSION IAND(0:3,0:3)
      DATA IOR  / 0,1,2,3,1,1,3,3,2,3,2,3,3,3,3,3 /
      DATA IAND / 0,0,0,0,0,1,0,1,0,0,2,2,0,1,2,3 /

*
* LOOP OVER ALL VERTICES AND CHECK ON RAS CONDITIONS
* CREATE MASK
*
      DO 10 IV=1,NVERT0
        LEV=IDRT0(IV,LTAB)
        N=IDRT0(IV,NTAB)
        IVER(IV)=0
        IF((LEV.EQ.LV1RAS).AND.(N.GE.LM1RAS)) IVER(IV)=1
        IF((LEV.EQ.LV3RAS).AND.(N.GE.LM3RAS)) IVER(IV)=IVER(IV)+2
10    CONTINUE
*
* NOW LOOP FORWARDS, MARKING THOSE VERTICES CONNECTED FROM ABOVE.
* SINCE IVER WAS INITIALIZED TO ZERO, NO CHECKING IS NEEDED.
*
      DO 20 IV=1,NVERT0-1
        IVV=IVER(IV)
        DO 21 IC=0,3
          ID=IDOWN0(IV,IC)
          IF(ID.EQ.0) GOTO 21
          IVER(ID)=IOR(IVER(ID),IVV)
21      CONTINUE
20    CONTINUE
*
* THEN LOOP BACKWARDS. SAME RULES, EXCEPT THAT CONNECTIVITY
* SHOULD BE PROPAGATED ONLY ABOVE THE RESTRICTION LEVELS.
*
      DO 40 IV=NVERT0-1,1,-1
        LEV=IDRT0(IV,LTAB)
        MASK=0
        IF(LEV.GT.LV1RAS) MASK=1
        IF(LEV.GT.LV3RAS) MASK=MASK+2
        IVV=IVER(IV)
        DO 30 IC=0,3
          ID=IDOWN0(IV,IC)
          IF(ID.EQ.0) GOTO 30
          IVD=IVER(ID)
          IVV=IOR(IVV,IAND(MASK,IVD))
30      CONTINUE
        IVER(IV)=IVV
40    CONTINUE
*
* WE ARE NOW INTERESTED ONLY IN VERTICES CONNECTED BOTH TO
* ALLOWED VERTICES FOR RAS-SPACE 1 AND RAS-SPACE 3.
* THOSE ARE NUMBERED IN ASCENDING ORDER, THE REST ARE ZEROED.
*
      NVERT=0
      DO 50 IV=1,NVERT0
        IF(IVER(IV).EQ.3) THEN
          NVERT=NVERT+1
          IVER(IV)=NVERT
        ELSE
          IVER(IV)=0
        ENDIF
50    CONTINUE
      IF (NVERT.eq.0) THEN
        Call SysAbendMsg('Restr','No configuration was found\n',
     &                'Check NACTEL, RAS1, RAS2, RAS3 values')
      END IF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine dumps orbital energies on the runfile, expands them if  *
! necessary.                                                           *
!                                                                      *
!***********************************************************************

subroutine DumpEor(Label,E_or,nSym,nBas,nOrb)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
character(len=*), intent(in) :: Label
real(kind=wp), intent(in) :: E_or(*)
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym)
integer(kind=iwp) :: iFrom(8), iSym, iTo(8), ndata, npDump
real(kind=wp), allocatable :: Dump(:)

!----------------------------------------------------------------------*
! Preliminaries                                                        *
!----------------------------------------------------------------------*
npDump = sum(nBas(:))
call mma_allocate(Dump,npDump,Label='DumpOE')
!----------------------------------------------------------------------*
! Dump orbital energies                                                *
!----------------------------------------------------------------------*
iFrom(1) = 1
iTo(1) = 1
do iSym=1,nSym-1
  iFrom(iSym+1) = iFrom(iSym)+nOrb(iSym)
  iTo(iSym+1) = iTo(iSym)+nBas(iSym)
end do
do iSym=nSym,1,-1
  ndata = nOrb(iSym)
  Dump(iTo(iSym):iTo(iSym)+ndata-1) = E_or(iFrom(iSym):iFrom(iSym)+ndata-1)
end do
call Put_dArray(Label,Dump,npDump)
!----------------------------------------------------------------------*
! Finish                                                               *
!----------------------------------------------------------------------*
call mma_deallocate(Dump)

return

end subroutine DumpEor

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Reorder_GW(A,B,k,l,n,m)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: k, l, n, m
real(kind=wp), intent(in) :: A(k,l,n,m)
real(kind=wp), intent(out) :: B(k,n,l,m)
integer(kind=iwp) :: l_, n_, m_

do m_=1,m
  do n_=1,n
    do l_=1,l
      B(:,n_,l_,m_) = A(:,l_,n_,m_)
    end do
  end do
end do

return

end subroutine Reorder_GW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Warnings_lp(iCode,Warning,iLength)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCode, iLength
character(len=*), intent(out) :: Warning

! Binary codes:
! 1: Multiple minima found
! 2: Minima not within range
! 3: Ran out of iterations
! 4: No minima found

if (iLength < 25) then
  write(u6,*) 'Length of warning string must be at least 25 characters'
  call Abend()
end if

select case (iCode)
  case (1)
    Warning = 'Multiple minima found'
  case (2)
    Warning = 'Minima not within range'
  case (3)
    Warning = 'Ran out of iterations'
  case (4)
    Warning = 'No minima found'
  case default
    Warning = ''
end select

return

end subroutine Warnings_lp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_W_pair_builder

   USE fmm_global_paras
   USE fmm_stats
   USE fmm_W_contractors, ONLY: fmm_select_W_con

   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_translate_raw_moments,          &
             fmm_translate_boxed_moments,        &
             fmm_translate_parents_Vff,          &
             fmm_get_raw_Vff_from_boxed_Vff

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_W_pair_builder(scheme)

      USE fmm_W_buffer, ONLY: fmm_open_W_buffer
      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      CALL fmm_open_W_buffer(scheme)

   END SUBROUTINE fmm_init_W_pair_builder

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_free_W_pair_builder(scheme)

      USE fmm_W_buffer, ONLY: fmm_close_W_buffer
      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN) :: scheme
      CALL fmm_close_W_buffer(scheme)

   END SUBROUTINE fmm_free_W_pair_builder

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_W_pair(addr,r_ab,new_LMAX,old_LMAX,object,W_pair)

      IMPLICIT NONE
      TYPE(old_new),       INTENT(IN)  :: addr
      REAL(REALK),         INTENT(IN)  :: r_ab(3)
      INTEGER(INTK),       INTENT(IN)  :: new_LMAX, old_LMAX
      CHARACTER(LEN=3),    INTENT(IN)  :: object
      TYPE(T_pair_single), INTENT(OUT) :: W_pair

      W_pair%paras%ratio = one ! i.e. W_pair%r_ab is the actual vector

      ! indices to map back to actual moments in separate array
      W_pair%paras%LHS_id = addr%new
      W_pair%paras%RHS_id = addr%old
      ! orders of contraction with T-matrix
      W_pair%paras%LHS_LMAX = new_LMAX
      W_pair%paras%RHS_LMAX = old_LMAX

      ! (see fmm_W_worker)
      SELECT CASE (object)
      CASE ('qlm')
         W_pair%r_ab(:) = r_ab(:)
         W_pair%N_or_T  = 'N'
      CASE ('Vff')
         ! For Vff translations, we require W'(-r_ab)
         W_pair%r_ab(:) = -r_ab(:)
         ! Use 'T' (transpose) for W_matrix contraction with DTRMV
         W_pair%N_or_T  = 'T'
      CASE DEFAULT
         CALL fmm_quit('cannot resolve translation object in fmm_get_W_pair!')
      END SELECT

      W_pair%LMAX   = MAX(W_pair%paras%LHS_LMAX,W_pair%paras%RHS_LMAX)
      W_pair%lm_max = (1+W_pair%LMAX)**2

   END SUBROUTINE fmm_get_W_pair

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_translate_raw_moments(scheme,mms_in,mms_out)

      USE fmm_W_contractors, ONLY: fmm_set_W_con_ptrs
      USE fmm_W_buffer,      ONLY: fmm_add_to_W_buffer
      USE fmm_qlm_utils,     ONLY: fmm_get_T_sym_qlm

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)    :: scheme
!FIXME: do not need to pass all this in! (just the moments)
      TYPE(raw_mm_data),  INTENT(IN)    :: mms_in
      TYPE(box_mm_data),  INTENT(INOUT) :: mms_out

      TYPE(T_pair_single) :: W_pair
      TYPE(old_new)       :: addr
      INTEGER(INTK)       :: i, new_LMAX, old_LMAX
      REAL(REALK)         :: new_centre(3), old_centre(3), trans_vec(3)

      CALL fmm_select_W_con(scheme%W_con%ID)
      old_LMAX = scheme%raw_LMAX
      new_LMAX = scheme%trans_LMAX
      ! set pointers in W_contractor
      CALL fmm_set_W_con_ptrs(mms_in%qlm_W,mms_out%qlm_W)

      ! generate W_pairs and pass them to the W_buffer
      CALL fmm_init_buffer_stats('W','RAW_BOX')
      CALL fmm_init_matrix_stats('W','RAW_BOX')
      CALL fmm_init_W_pair_builder(scheme)
      DO i = 1, SIZE(mms_in%paras)
         ! indices to actual moments to translate from and to
         addr%old = mms_in%paras(i)%id
         addr%new = mms_in%paras(i)%map_up
         IF (addr%new == 0) CALL fmm_quit ('parameter mappings incomplete! 1')
         old_centre = mms_in%paras(i)%cntr
         new_centre = mms_in%paras(i)%box_cntr
         ! make W_pair and throw into W-buffer
         trans_vec = new_centre - old_centre
         CALL fmm_get_W_pair(addr,trans_vec,new_LMAX,old_LMAX,'qlm',W_pair)
         CALL fmm_add_to_W_buffer(W_pair)
      END DO

      ! scale new translated moments for T_matrix symmetry
      ! but first ensure W_buffer is empty
      CALL fmm_free_W_pair_builder(scheme)
      CALL fmm_get_T_sym_qlm(new_LMAX,mms_out%qlm_W,mms_out%qlm_T)

   END SUBROUTINE fmm_translate_raw_moments

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_translate_boxed_moments(scheme,mms_in,mms_out)

      USE fmm_W_contractors, ONLY: fmm_set_W_con_ptrs
      USE fmm_W_buffer,      ONLY: fmm_add_to_W_buffer
      USE fmm_qlm_utils,     ONLY: fmm_get_T_sym_qlm

      IMPLICIT NONE
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      TYPE(box_mm_data),  INTENT(IN)    :: mms_in
      TYPE(box_mm_data),  INTENT(INOUT) :: mms_out

      TYPE(T_pair_single) :: W_pair
      TYPE(old_new)       :: addr
      INTEGER(INTK)       :: i, new_LMAX, old_LMAX
      REAL(REALK)         :: new_centre(3), old_centre(3), trans_vec(3)

      CALL fmm_select_W_con(scheme%W_con%ID)
      old_LMAX = scheme%trans_LMAX
      new_LMAX = scheme%trans_LMAX
      ! set pointers in W_contractor
      CALL fmm_set_W_con_ptrs(mms_in%qlm_W,mms_out%qlm_W)

      ! generate W_pairs and pass them to the W_buffer
      CALL fmm_init_buffer_stats('W','BOX_BOX')
      CALL fmm_init_matrix_stats('W','BOX_BOX')
      CALL fmm_init_W_pair_builder(scheme)
      DO i = 1, SIZE(mms_in%RHS_paras)
         ! indices to actual moments to translate from and to
         addr%old = mms_in%RHS_paras(i)%id
         addr%new = mms_in%RHS_paras(i)%map_up
         IF (addr%new == 0) CALL fmm_quit ('parameter mappings incomplete! 2')
         old_centre = mms_in%RHS_paras(i)%cntr
         new_centre = mms_in%RHS_paras(i)%cntr_up
         ! make W_pair and throw into W-buffer
         trans_vec = new_centre - old_centre
         CALL fmm_get_W_pair(addr,trans_vec,new_LMAX,old_LMAX,'qlm',W_pair)
         CALL fmm_add_to_W_buffer(W_pair)
      END DO

      ! scale new translated moments for T_matrix symmetry
      ! but first ensure W_buffer is empty
      CALL fmm_free_W_pair_builder(scheme)
      CALL fmm_get_T_sym_qlm(new_LMAX,mms_out%qlm_W,mms_out%qlm_T)

   END SUBROUTINE fmm_translate_boxed_moments

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_translate_parents_Vff(level,scheme,Vff_p,Vff_c,c_box_paras)

      USE fmm_W_contractors, ONLY: fmm_set_W_con_ptrs
      USE fmm_W_buffer,      ONLY: fmm_add_to_W_buffer

      IMPLICIT NONE
      INTEGER(INTK),      INTENT(IN)    :: level
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      REAL(REALK),        INTENT(IN)    :: Vff_p(:,:)
      REAL(REALK),        INTENT(INOUT) :: Vff_c(:,:)
      TYPE(box_mm_paras), INTENT(IN)    :: c_box_paras(:)   ! child

      TYPE(T_pair_single) :: W_pair
      TYPE(old_new)       :: addr
      INTEGER(INTK)       :: i, new_LMAX, old_LMAX
      REAL(REALK)         :: new_centre(3), old_centre(3), trans_vec(3)

      IF (level <= 2) RETURN

      new_LMAX = scheme%trans_LMAX
      old_LMAX = scheme%trans_LMAX

      CALL fmm_select_W_con(scheme%W_con%ID)
      CALL fmm_set_W_con_ptrs(Vff_p,Vff_c)
      CALL fmm_init_buffer_stats('W','BOX_BOX')
      CALL fmm_init_matrix_stats('W','BOX_BOX')
      CALL fmm_init_W_pair_builder(scheme)
      DO i = 1, SIZE(Vff_c,2)
         addr%new = c_box_paras(i)%id
         addr%old = c_box_paras(i)%map_up
         IF (addr%old == 0) CALL fmm_quit ('parameter mappings incomplete! 3')
         new_centre = c_box_paras(i)%cntr
         old_centre = c_box_paras(i)%cntr_up
         trans_vec  = new_centre - old_centre
         CALL fmm_get_W_pair(addr,trans_vec,new_LMAX,old_LMAX,'Vff',W_pair)
         CALL fmm_add_to_W_buffer(W_pair)
      END DO
      CALL fmm_free_W_pair_builder(scheme)

   END SUBROUTINE fmm_translate_parents_Vff

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_get_raw_Vff_from_boxed_Vff(raw_paras,scheme,boxed_Vff,Vff)

      USE fmm_W_contractors, ONLY: fmm_set_W_con_ptrs
      USE fmm_W_buffer,      ONLY: fmm_add_to_W_buffer

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(IN)    :: raw_paras(:)
      TYPE(scheme_paras), INTENT(IN)    :: scheme
      REAL(REALK),        INTENT(IN)    :: boxed_Vff(:,:)
      REAL(REALK),        INTENT(INOUT) :: Vff(:,:)

      TYPE(T_pair_single) :: W_pair
      TYPE(old_new)       :: addr
      INTEGER(INTK)       :: i, new_LMAX, old_LMAX
      REAL(REALK)         :: new_centre(3), old_centre(3), trans_vec(3)

      new_LMAX = scheme%raw_LMAX
      old_LMAX = scheme%trans_LMAX

      CALL fmm_select_W_con(scheme%W_con%BR_ID)
      CALL fmm_set_W_con_ptrs(boxed_Vff,Vff)
      CALL fmm_init_buffer_stats('W','BOX_RAW')
      CALL fmm_init_matrix_stats('W','BOX_RAW')
      CALL fmm_init_W_pair_builder(scheme)
      DO i = 1, SIZE(raw_paras)
         addr%new = raw_paras(i)%id
         addr%old = raw_paras(i)%map_up
         IF (addr%old == 0) CALL fmm_quit ('parameter mappings incomplete! 4')
         new_centre = raw_paras(i)%cntr
         old_centre = raw_paras(i)%box_cntr
         trans_vec = new_centre - old_centre
         CALL fmm_get_W_pair(addr,trans_vec,new_LMAX,old_LMAX,'Vff',W_pair)
         CALL fmm_add_to_W_buffer(W_pair)
      END DO
      CALL fmm_free_W_pair_builder(scheme)

   END SUBROUTINE fmm_get_raw_Vff_from_boxed_Vff

!-------------------------------------------------------------------------------

END MODULE fmm_W_pair_builder

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkQ4(V)
! Q4(a,b,c,d) <- V(ab,cd)

use Index_Functions, only: nTri_Elem
use chcc_global, only: nv, Q4
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: V(nTri_Elem(nv),nTri_Elem(nv))
integer(kind=iwp) :: a, ab, c, cd

call mma_allocate(Q4,nv,nv,nv,nv,label='Q4')

cd = 0
do c=1,nv
  ab = 0
  do a=1,nv
    Q4(a,1:a-1,c,1:c-1) = V(ab+1:ab+a-1,cd+1:cd+c-1)
    Q4(a,1:a-1,1:c,c) = V(ab+1:ab+a-1,cd+1:cd+c)
    Q4(1:a,a,c,1:c-1) = V(ab+1:ab+a,cd+1:cd+c-1)
    Q4(1:a,a,1:c,c) = V(ab+1:ab+a,cd+1:cd+c)
    ab = ab+a
  end do
  cd = cd+c
end do

return

end subroutine MkQ4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  quaterFinish
*
*> @brief
*>   Clean the quater environment
*> @author Y. Carissan
*>
*> @details
*> Release the memory used by the quater program.
************************************************************************
      subroutine quaterFinish()
      implicit none
#include "WrkSpc.fh"
#include "geoms.fh"
      character*6 cName
      integer ig

      do ig=1,ngeoms+2
        if (ig.lt.100) Write(cName,'(a4,i2)') "GEOM",ig
        if (ig.lt.10) Write(cName,'(a5,i1)') "GEOM0",ig
          Call Getmem(cName,"Free",'Real',ipgeo(ig),0)
      end do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_LblCnt_All(xLblCnt)
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"
#include "Molcas.fh"
      Real*8, Allocatable:: Coord(:,:)
      Character*(LENIN) xLblCnt(*), xLblCnt_Unique(MxAtom)
*
      Call Get_iScalar('Unique atoms',nAtoms)
      Call mma_allocate(Coord,3,nAtoms,Label='Coord')
      Call Get_dArray('Unique Coordinates',Coord,3*nAtoms)
      Call Get_Name(xLblCnt_Unique)
      Call Get_cArray('Unique Atom Names',xLblCnt_Unique,LENIN*nAtoms)
      Call Get_Name_All_(Coord,nAtoms,nAtoms_all,xLblCnt_Unique,xLblCnt)
      Call mma_deallocate(Coord)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_box_utils

use fmm_global_paras, only: INTK, REALK, scheme_paras, gen_mm_paras, LHS_RHS_TYPE, box_mm_paras, MAX_LEVEL, TOP_LEVEL, WS_MIN, &
                            Two, Half
use fmm_stats, only: stat_level_saturation, stat_max_branch, stat_min_branch
use fmm_utils, only: fmm_quit
implicit none
private
! Public procedures
public :: fmm_box, &
          fmm_box_centre, &
          fmm_branch, &
          fmm_grain, &
          fmm_parent_box, &
          fmm_parent_bra, &
          fmm_deepest_level, &
          fmm_def_WS_NF, &
          fmm_def_WS_RFF, &
          fmm_same_box, &
          fmm_RFF_boxes, &
          fmm_NF_boxes, &
          fmm_translate_to_common_grid

contains

!-------------------------------------------------------------------------------

function fmm_parent_box(box)

  implicit none
  integer(INTK), intent(in) :: box(3)
  integer(INTK) :: fmm_parent_box(3)

  fmm_parent_box = 1+((box-1)/2)    ! get largest integer after /2

end function fmm_parent_box

!-------------------------------------------------------------------------------

function fmm_parent_bra(branch)

# include "macros.fh"

  implicit none
  integer(INTK), intent(in) :: branch
  integer(INTK) :: fmm_parent_bra

  unused_var(branch)

  !fmm_parent_bra = (((branch-1)/2)/2)*2 +2
  !fmm_parent_bra = max(WS_MIN,fmm_parent_bra)
  fmm_parent_bra = WS_MIN

end function fmm_parent_bra

!-------------------------------------------------------------------------------
! We use the coordinate shift to ensure all the box indices are positive

function fmm_box(centre,grain_inv)

  use fmm_qlm_builder, only: fmm_coord_shift

  implicit none
  real(REALK), intent(in) :: centre(3)
  real(REALK), intent(in) :: grain_inv
  integer(INTK) :: fmm_box(3)

  !fmm_box(:) = 1+int(centre(:)*grain_inv)
  fmm_box(:) = 1+int((centre(:)-fmm_coord_shift(:))*grain_inv)

end function fmm_box

!-------------------------------------------------------------------------------
! We take account of the coordinate shift used in fmm_box

function fmm_box_centre(box,grain)

  use fmm_qlm_builder, only: fmm_coord_shift

  implicit none
  integer(INTK), intent(in) :: box(3)
  real(REALK), intent(in)   :: grain
  real(REALK) :: fmm_box_centre(3)

  !fmm_box_centre(:) = grain*(box(:)-half)
  fmm_box_centre(:) = grain*(box(:)-half)+fmm_coord_shift(:)

end function fmm_box_centre

!-------------------------------------------------------------------------------

function fmm_branch(extent,grain_inv)

# include "macros.fh"

  implicit none
  !type(scheme_paras), intent(in) :: scheme
  real(REALK), intent(in) :: extent, grain_inv
  integer(INTK) :: fmm_branch

  unused_var(extent)
  unused_var(grain_inv)

  ! Note branches are always even in CFMM algorithm
  !if (scheme%branch_free) then
  !  fmm_branch = WS_MIN
  !else
  !  fmm_branch = 2*ceiling(extent*grain_inv)
  !end IF

  !fmm_branch = 2*ceiling(extent*grain_inv)
  !fmm_branch = max(WS_MIN, fmm_branch)

  fmm_branch = WS_MIN

  stat_max_branch = max(stat_max_branch,fmm_branch)
  stat_min_branch = min(stat_min_branch,fmm_branch)

end function fmm_branch

!-------------------------------------------------------------------------------

function fmm_deepest_level(scheme)

  use fmm_qlm_builder, only: fmm_system_size
  implicit none
  type(scheme_paras), intent(in) :: scheme
  integer(INTK) :: fmm_deepest_level
  real(REALK) :: x

  x = fmm_system_size/scheme%grain
  ! Note we round UP the integer
  fmm_deepest_level = max(TOP_LEVEL,(1+int(log(x)/log(two))))

  if (fmm_deepest_level > MAX_LEVEL) then
    stat_level_saturation = fmm_deepest_level
    fmm_deepest_level = MAX_LEVEL
  end if

end function fmm_deepest_level

!-------------------------------------------------------------------------------
! Return the box size at a given level, based on the smallest box size.

function fmm_grain(scheme,level)

  implicit none
  type(scheme_paras), intent(in) :: scheme
  integer(INTK), intent(in)      :: level
  real(REALK) :: fmm_grain
  integer(INTK) :: deepest_level

  deepest_level = fmm_deepest_level(scheme)
  fmm_grain = (scheme%grain)*(2**(deepest_level-level))

end function fmm_grain

!-------------------------------------------------------------------------------
! Routine to define the separation parameter for NF interactions
! i.e. boxes closer than this separation are treated as near field.
! only designed for cases where boxes are at the same level (same size)

subroutine fmm_def_WS_NF(LHS,RHS,id,WS_para)

  implicit none
  type(gen_mm_paras), intent(in) :: LHS, RHS
  type(LHS_RHS_type), intent(in) :: id
  integer(INTK), intent(out)     :: WS_para

  WS_para = (LHS%box_paras(id%LHS)%bra+RHS%box_paras(id%RHS)%bra)/2

end subroutine fmm_def_WS_NF

!-------------------------------------------------------------------------------
! Routine to define local space that contains both LFF and NF space;
! i.e. boxes further apart than this separation are RFF boxes;
! note that this routine is generalised for cases where the boxes are
! at different levels (of different sizes) as is needed for the NlogN
! contraction scheme; in this case, we must choose which box size to express
! WS_para in terms of; by default we take the box size at highest level

subroutine fmm_def_WS_RFF(LHS_in,RHS_in,id,WS_para)

  implicit none
  type(gen_mm_paras), intent(in) :: LHS_in, RHS_in
  type(LHS_RHS_type), intent(in) :: id
  integer(INTK), intent(out)     :: WS_para
  type(box_mm_paras) :: LHS, RHS

  LHS = LHS_in%box_paras(id%LHS)
  RHS = RHS_in%box_paras(id%RHS)

  ! we define WS_para in terms of the highest common grid
  call fmm_translate_to_common_grid(LHS,RHS)

  ! LFF is related to the parent's NF space
  LHS%bra = fmm_parent_bra(LHS%bra)
  RHS%bra = fmm_parent_bra(RHS%bra)

  ! hence NF-space for _parents_ of common grid
  WS_para = (LHS%bra+RHS%bra)/2
  ! hence LFF-space in common grid itself is
  WS_para = 1+2*WS_para
  ! +1 because of asymmetry in LFF space, and we are conservative.

end subroutine fmm_def_WS_RFF

!-------------------------------------------------------------------------------
! Are 2 boxes within their near-field space (hence too close to be
! treated by boxed multipole expansions exactly)?
! If number of boxes between A and B < ((Br(A)+Br(B))/2) they are NF

function fmm_NF_boxes(LHS,RHS)

  implicit none
  type(box_mm_paras), intent(in) :: LHS, RHS
  logical :: fmm_NF_boxes
  integer(INTK) :: WS_NF
  integer(INTK) :: space

  ! test only valid if box grids are at the same level depth
  if (LHS%level /= RHS%level) call fmm_quit('levels not equal in NF_boxes')

  WS_NF = (LHS%bra+RHS%bra)/2

  fmm_NF_boxes = .false.
  space = abs(LHS%box(3)-RHS%box(3))
  if (space <= WS_NF) then
    space = abs(LHS%box(2)-RHS%box(2))
    if (space <= WS_NF) then
      space = abs(LHS%box(1)-RHS%box(1))
      if (space <= WS_NF) then
        ! pair are in near field
        fmm_NF_boxes = .true.
      end if
    end if
  end if

end function fmm_NF_boxes

!-------------------------------------------------------------------------------
! Logical function to test if two boxes are in each others "Remote Far Field"
! based on separation.  Used by FMM and NlogN algorithms.

function fmm_RFF_boxes(LHS,RHS)

  implicit none
  type(box_mm_paras), intent(in) :: LHS, RHS
  logical :: fmm_RFF_boxes

  type(box_mm_paras) :: LHS_up, RHS_up

  ! test only valid if box grids are at the same level depth
  if (LHS%level /= RHS%level) call fmm_quit('levels in fmm_RFF_boxes')

  LHS_up = LHS
  RHS_up = RHS
  LHS_up%box = fmm_parent_box(LHS%box)
  LHS_up%bra = fmm_parent_bra(LHS%bra)
  RHS_up%box = fmm_parent_box(RHS%box)
  RHS_up%bra = fmm_parent_bra(RHS%bra)

  fmm_RFF_boxes = .not. (fmm_NF_boxes(LHS_up,RHS_up))

end function fmm_RFF_boxes

!-------------------------------------------------------------------------------

function fmm_same_box(LHS,RHS)

  implicit none
  type(box_mm_paras), intent(in) :: LHS, RHS
  logical :: fmm_same_box

  if (LHS%level /= RHS%level) call fmm_quit('levels not equal in same_box')
  fmm_same_box = .false.
  if (LHS%box(1) == RHS%box(1) .and. &
      LHS%box(2) == RHS%box(2) .and. &
      LHS%box(3) == RHS%box(3)) then
    fmm_same_box = .true.
  end if

end function fmm_same_box

!-------------------------------------------------------------------------------
! Routine to generate a temporary set of box parameters at a common grid
! level.  Parameters at the deeper level are translated to their parent's
! grid until the levels match.

subroutine fmm_translate_to_common_grid(LHS,RHS)

  implicit none
  type(box_mm_paras), intent(inout) :: LHS, RHS

  if (LHS%level == RHS%level) return
  if (LHS%level > RHS%level) then
    do while (LHS%level > RHS%level)
      LHS%box = fmm_parent_box(LHS%box)
      LHS%bra = fmm_parent_bra(LHS%bra)
      LHS%level = LHS%level-1
    end do
  else
    do while (RHS%level > LHS%level)
      RHS%box = fmm_parent_box(RHS%box)
      RHS%bra = fmm_parent_bra(RHS%bra)
      RHS%level = RHS%level-1
    end do
  end if

end subroutine fmm_translate_to_common_grid

!-------------------------------------------------------------------------------

end module fmm_box_utils

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRACI_RPT2(ISTART,NDIM,XMAT,STSYM,NCI,CI)

use sguga, only: CIS, EXS, LEVEL, SGS
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ISTART, NDIM, STSym, NCI
real(kind=wp), intent(inout) :: XMAT(NDIM,NDIM), CI(NCI)
integer(kind=iwp) :: I, IORB, J, JORB, LI, LJ, M
real(kind=wp) :: Fact, SCL, XJM
real(kind=wp), allocatable :: SGM(:), TVEC(:), XSAV(:,:)

if (NDIM <= 0) return

call mma_allocate(XSAV,NDIM,NDIM,Label='XSAV')
XSAV(:,:) = XMAT(:,:)
call mma_allocate(TVEC,NDIM,LABEL='TVEC')
call mma_allocate(SGM,NCI,LABEL='SGM')
SGM(:) = Zero

do J=1,NDIM
  FACT = One/XMAT(J,J)
  TVEC(:) = -FACT*XMAT(:,J)
  TVEC(J) = FACT
  XMAT(:,J) = Zero
  XMAT(J,J) = One
  ! Array T now contains a factor of XMAT of the form
  ! (e(1),..e(k-1),T,..,e(n)), where e(i) is the standard
  ! unit column vector, with elements Kronecker(l,i).
  ! Apply its inverse to XMAT.
  do M=J+1,NDIM
    XJM = XMAT(J,M)
    XMAT(:,M) = XMAT(:,M)+TVEC(:)*XJM
    XMAT(J,M) = TVEC(J)*XJM
  end do
  ! Transform CI array:
  ! CI:=( 1 + Sum(U(I)E(IJ)) + (1/2)Sum(U(I)U(M)E(IJ,MJ)) ) CI,
  ! where U(I) = T(I)-Kronecker(I,J).
  JORB = ISTART-1+J
  LJ = LEVEL(JORB)
  SGM(1:NCI) = (OneHalf-Half*TVEC(J))*CI(1:NCI)
  do I=1,NDIM
    IORB = ISTART-1+I
    LI = LEVEL(IORB)
    SCL = Half*TVEC(I)
    if (I == J) SCL = SCL-Half
    call SG_Epq_Psi(SGS,CIS,EXS,LI,LJ,SCL,STSYM,CI,SGM)
  end do
  do I=1,NDIM
    IORB = ISTART-1+I
    LI = LEVEL(IORB)
    SCL = TVEC(I)
    if (I == J) SCL = SCL-One
    call SG_Epq_Psi(SGS,CIS,EXS,LI,LJ,SCL,STSYM,SGM,CI)
  end do

end do

call mma_deallocate(SGM)
call mma_deallocate(TVEC)
XMAT(:,:) = XSAV(:,:)
call mma_deallocate(XSAV)

end subroutine TRACI_RPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
*-- Process input to QMSTAT. All input varibles are stored in
*   qminp.fh which in turn are initialized in qmstat_init.
*
      Subroutine Get_Qmstat_Input(iQ_Atoms)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "warnings.fh"

      Character*180 Key
      Character*20 Kword
      Character*180 Get_Ln
      Character VecsQue*3
      Dimension CoTEMP1(3),CoTEMP2(3),CoTEMP3(3),CoTEMP4(3),CoTEMP5(3)
      Dimension SlFacTemp(6)
      External Get_Ln,iClast
      Logical YesNo(20),Changed

*
*-- Say what is done and set all YesNo to false; their purpose is to
*   keep track on compulsory keywords and certain keyword combinations.
*
*      Write(6,*)
*      Write(6,*)'Input processed...'
      Do 1, i=1,20
        YesNo(i)=.false.
1     Continue

*
*-- Use some nice routines to collect input.
*
      LuRd=79
      LuRd=IsFreeUnit(LuRd)
      Call SpoolInp(LuRd)
      Rewind(LuRd)
      Call RdNlst(LuRd,'QMSTAT')

*
*-- The turning-point in this do-while loop.
*
1000  Continue

*
*-- Use Get_Ln to read the lines; it takes care of commented lines.
*
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)

*
*-- The keywords and their labels.
*
      If(Kword(1:4).eq.'TITL') Go To 101
      If(Kword(1:4).eq.'SIMU') Go To 103
      If(Kword(1:4).eq.'THRE') Go To 104
      If(Kword(1:4).eq.'STEP') Go To 105
      If(Kword(1:4).eq.'RUN ') Go To 106
      If(Kword(1:4).eq.'PRIN') Go To 107
      If(Kword(1:4).eq.'EXTE') Go To 108
      If(Kword(1:4).eq.'EDIT') Go To 109
      If(Kword(1:4).eq.'CONF') Go To 110
      If(Kword(1:4).eq.'QMSU') Go To 111
      If(Kword(1:4).eq.'SOLV') Go To 112
      If(Kword(1:4).eq.'RASS') Go To 113
      If(Kword(1:4).eq.'SCFS') Go To 114
      If(Kword(1:4).eq.'SING') Go To 115
      If(Kword(1:4).eq.'ANAL') Go To 116
      If(Kword(1:4).eq.'EXTR') Go To 117
      If(Kword(1:4).eq.'END ') Go To 99999

*
*-- This code is only reached if an illegal keyword in the
*   first tier is encountered.
*
**
      iChrct=Len(Kword)
      Last=iCLast(Kword,iChrct)
      Write(6,*)
      Write(6,*)'ERROR!'
      Write(6,'(1X,A,A)')Kword(1:Last),' is not a valid keyword!'
      Call Quit(_RC_INPUT_ERROR_)

*
* <<<TITLe>>>   Read title.
*
101   Continue
      Key=Get_Ln(LuRd)
      Joblab=Trim(Key)
      ATitle=.true.
      Go To 1000

*
* <<<SIMUlation parameters>>>   Read a variety of simulation
*                               parameters.
*
103   Continue
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)
*---<<<RADIe>>>
      If(Kword(1:4).eq.'RADI') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,Rstart)
        Go To 103
*---<<<PERMitivity>>>
      Elseif(Kword(1:4).eq.'PERM') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,Diel)
        Go To 103
*---<<<TEMPerature>>>
      Elseif(Kword(1:4).eq.'TEMP') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,Temp)
        Go To 103
*---<<<PRESsure>>>
      Elseif(Kword(1:4).eq.'PRES') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,Pres)
        Go To 103
*---<<<SURFace>>>
      Elseif(Kword(1:4).eq.'SURF') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,Surf)
        Go To 103
*---<<<TRANslation>>>
      Elseif(Kword(1:4).eq.'TRAN') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,DelX)
        Go To 103
*---<<<ROTAtion>>>
      Elseif(Kword(1:4).eq.'ROTA') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,DelFi)
        Go To 103
*---<<<CAVIty>>>
      Elseif(Kword(1:4).eq.'CAVI') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,DelR)
        Go To 103
*---<<<FORCe>>>
      Elseif(Kword(1:4).eq.'FORC') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,Forcek)
        Go To 103
*---<<<BREPulsion>>>
      Elseif(Kword(1:4).eq.'BREP') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,dLJRep)
        Go To 103
*---<<<SEED>>>
      Elseif(Kword(1:4).eq.'SEED') then
        Key=Get_Ln(LuRd)
        Call Get_I1(1,iSeed)
        Go To 103
*---<<<PARAlleltemp>>>
      Elseif(Kword(1:4).eq.'PARA') then
        ParallelT=.true.
        Key=Get_Ln(LuRd)
        Call Get_I1(1,nTemp)
        Key=Get_Ln(LuRd)
        Call Get_I(1,nStFilT,nTemp)
        Key=Get_Ln(LuRd)
        Call Get_F(1,ParaTemps,nTemp)
        Go To 103
*---<<<END simulation parameters>>>
      Elseif(Kword(1:4).eq.'END ') then
        Go To 1000
      Endif
*---Here we come if something gets wrong above
      Write(6,*)
      Write(6,*)' Unrecognized keyword in the SIMUlation parameter sect'
     &//'ion:',Kword(1:4)
      Call Quit(_RC_INPUT_ERROR_)

*
* <<<THREshold>>>    Get the polarization thresholds.
*
104   Continue
      Key=Get_Ln(LuRd)
      Call Get_F1(1,Pollim)
      Call Get_F1(2,Enelim)
      Call Get_I1(3,itMax)
      Go To 1000

*
* <<<STEPs>>>   Specify how many macro- and microsteps.
*
105   Continue
      Key=Get_Ln(LuRd)
      Call Get_I1(1,NMacro)
      Call Get_I1(2,NMicro)
      Go To 1000

*
* <<<RUN >>>   What type of simulation are we to run?
*
106   Continue
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)
      If(Kword(1:4).eq.'ANAL') Anal=.true.
      If(Kword(1:4).eq.'QMEQ') Qmeq=.true.
      If(Kword(1:4).eq.'QMPR') then
        QmProd=.true.
        Read(LuRd,*)Inter,iNrUt
        Write(SaFilUt(6:6),'(i1.1)')iNrUt
        iLuSaUt=32+iNrUt
      Endif
      If(Kword(1:2).eq.'SM') then
        Write(6,*)
        Write(6,*)'No classical simulations are available.'
        Call Quit(_RC_INPUT_ERROR_)
      Endif
      YesNo(8)=.true.
      Go To 1000

*
* <<<PRINt>>>   Specify print-level.
*
107   Continue
      Key=Get_Ln(LuRd)
      Call Get_I1(1,iPrint)
      Go To 1000

*
* <<<EXTErnal>>>   External one-electron perturbation
*                  should be added on the hamiltonian.
*
108   Continue
      AddExt=.true.
      Key=Get_Ln(LuRd)
      Call Get_I1(1,nExtAddOns)
      If(nExtAddOns.gt.MxExtAddOn) then
        Write(6,*)
        Write(6,*)'Too many external perturbations asked for.'
        Call Quit(_RC_INPUT_ERROR_)
      Endif
      Do 10801, i=1,nExtAddOns
        Read(LuRd,*)ScalExt(i),ExtLabel(i),iCompExt(i)
10801 Continue
      Go To 1000

*
* <<<EDITstartfile>>> Section for editing and displaying stuff on
*                     given startfile.
*
109   Continue
      EdSt=.true.
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)
*----<<<DELEte>>>   Delete solvent molecules.
      If(Kword(1:4).eq.'DELE') then
        DelOrAdd(1)=.true.
        Key=Get_Ln(LuRd)
        Call Get_I1(1,NrStarti)
        Call Get_I1(2,NrStartu)
        Key=Get_Ln(LuRd)
        Call Get_I1(1,nDel)
        Go To 109
      Endif
*----<<<ADD >>>    Add solvent molecules.
      If(Kword(1:4).eq.'ADD ') then
        DelOrAdd(2)=.true.
        Key=Get_Ln(LuRd)
        Call Get_I1(1,NrStarti)
        Call Get_I1(2,NrStartu)
        Key=Get_Ln(LuRd)
        Call Get_I1(1,nAdd)
        Go To 109
      Endif
*----<<<QMDElete>>>   Substitute all slots with non-water coordinates
*                     with water coordinates.
      If(Kword(1:4).eq.'QMDE') then
        DelOrAdd(3)=.true.
        Key=Get_Ln(LuRd)
        Call Get_I1(1,NrStarti)
        Call Get_I1(2,NrStartu)
        Go To 109
      Endif
*----<<<DUMP coordinates>>>  Dump coordinates in a way suitable for
*                            graphical display.
      If(Kword(1:4).eq.'DUMP') then
        DelOrAdd(4)=.true.
        Key=Get_Ln(LuRd)
        Call UpCase(Key)
        cDumpForm=Key(1:4)
        Key=Get_Ln(LuRd)
        Call Get_I1(1,NrStarti)
        Go To 109
      Endif
*----<<<END editstartfile>>>
      If(Kword(1:4).eq.'END ') then
        Write(StFilIn(6:6),'(i1.1)')NrStarti
        Write(StFilUt(6:6),'(i1.1)')NrStartu
        Go To 1000
      Endif
*---Here we come if something gets wrong above
      Write(6,*)
      Write(6,*)' Unrecognized keyword in the EDITstartfile sect'
     &//'ion:',Kword(1:4)
      Call Quit(_RC_INPUT_ERROR_)

*
* <<<CONFiguration>>>    Where is the initial configuration to be
*                        obtained. Also, if we wish to edit the
*                        startfile.
*
110   Continue
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)
*---<<<ADD >>>  How many to add at random.
      If(Kword(1:4).eq.'ADD ') then
        Key=Get_Ln(LuRd)
        Call Get_I1(1,iExtra)
        If(iExtra.gt.MxPut) then
          Write(6,*)
          Write(6,*)'The present limit of explicit solvent molecules i'
     &//'s',MxPut,'.'
          Call Quit(_RC_INPUT_ERROR_)
        Endif
        Go To 110
*---<<<FILE>>>  Read configuration/s from a file and put them there.
      Elseif(Kword(1:4).eq.'FILE') then
        Key=Get_Ln(LuRd)
        Kword=Trim(Key)
        Call UpCase(Kword)
*------<<<STARtfile>>>  Read from startfile.
        If(Kword(1:4).eq.'STAR') then
          Key=Get_Ln(LuRd)
          Kword=Trim(Key)
          Call UpCase(Kword)
*---------<<<SCRAtch>>> Just put QM as given on RUNFILE.
          If(Kword(1:4).eq.'SCRA') then
            Key=Get_Ln(LuRd)
            Call Get_I1(1,iNrIn)
            Call Get_I1(2,iNrUt)
            iRead=8
*---------<<<COPY>>> Collect place of QM from startfile. WARNING!
*                    You must use consistent startfile and RUNFILE!
          Elseif(Kword(1:4).eq.'COPY') then
            Key=Get_Ln(LuRd)
            Call Get_I1(1,iNrIn)
            Call Get_I1(2,iNrUt)
            iRead=7
*---------<<<CM  >>> Put QM in CM of QM-place on startfile.
          Elseif(Kword(1:2).eq.'CM') then
            Key=Get_Ln(LuRd)
            Call Get_I1(1,iNrIn)
            Call Get_I1(2,iNrUt)
            iRead=6
          Else
            Write(6,*)
            Write(6,*)'Illegal StartFile option.'
            Call Quit(_RC_INPUT_ERROR_)
          Endif
*------<<<SAMPfile>>>  Read configurations from sampfile and collect
*                      the extracted information in iNrExtr.
        Elseif(Kword(1:4).eq.'SAMP') then
          Key=Get_Ln(LuRd)
          Call Get_I1(1,iNrIn)
          Call Get_I1(2,iNrExtr)
          iRead=9
          Write(SimEx(6:6),'(i1.1)')iNrExtr
          YesNo(9)=.true.
*-----CRASH-BOOM-BANG!
        Else
          Write(6,*)
          Write(6,*)' Error in CONFiguration section, FILE subsection.'
          Call Quit(_RC_INPUT_ERROR_)
        Endif
        Write(StFilIn(6:6),'(i1.1)')iNrIn
        Write(StFilUt(6:6),'(i1.1)')iNrUt
        Write(SaFilIn(6:6),'(i1.1)')iNrIn
        iLuStIn=8+iNrIn
        iLuStUt=16+iNrUt
        iLuSaIn=24+iNrIn
        Go To 110
*---<<<INPUt>>>  Signify that the first configuration will be given
*                explicitly in input. The coordinates are then given
*                in the solvent section.
      Elseif(Kword(1:4).eq.'INPU') then
        Key=Get_Ln(LuRd)
        Call Get_I1(1,iNrUt)
        iLuStUt=16+iNrUt
        YesNo(5)=.true.  !User will give coord:s in input.
        Go To 110
      Elseif(Kword(1:4).eq.'END ') then
        YesNo(2)=.true.  !Signify that source of starting conf. is
                       !specified.
        Go To 1000
      Endif
*---Here we come if something gets wrong above
      Write(6,*)
      Write(6,*)' Unrecognized keyword in the CONFiguration section:'
     &,Kword(1:4)
      Call Quit(_RC_INPUT_ERROR_)

*
* <<<QMSUrrounding>>>  Give parameters for the QM-Stat.Mech.
*                      interaction.
*
111   Continue
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)
*---<<<DPARameters>>>  Dispersion
      If(Kword(1:4).eq.'DPAR') then
        Do 1111, i=1,iQ_Atoms
          Key=Get_Ln(LuRd)
          Call Get_F(1,Udisp(i,1),1)
          Call Get_F(2,Udisp(i,2),1)
1111    Continue
        Go To 111
*---<<<ELECtrostatic>>> Electrostatic Slater Numbers
      Elseif(Kword(1:4).eq.'ELEC') then
1131    Continue
        Key=Get_Ln(LuRd)
        Kword=Trim(Key)
        Call UpCase(Kword)
*------<<<THREsholds>>>  First is the Cutoff (distance Quantum Site-
*                        Classical molecule) to evaluate Penetration
*                        effects. Second, difference between two Slater
*                        exponents to not be consider the same value.
        If(Kword(1:4).eq.'THRE') then
          Key=Get_Ln(LuRd)
          Call Get_F1(1,Cut_Elc)
          Call Get_F1(2,DifSlExp)
          Go To 1131
        Endif
*-----<<<NOPEnetration>>>  Electrostatic Penetration Not Computed
        If(Kword(1:4).eq.'NOPE') then
          lSlater=.false.
          Go To 1131
        Endif
*-----<<<QUADrupoles>>>  Electrostatic Penetration Computed in quadrupoles.
        If(Kword(1:4).eq.'QUAD') then
          lQuad=.true.
          Go To 1131
        Endif
*------<<<END Electrostatic>>>
        If(Kword(1:4).eq.'END ') then
          Go To 111
        Endif
        Write(6,*)
        Write(6,*)' Error in QMSUrrounding section, ELECtrostatic sub'
     &//'section.'
        Call Quit(_RC_INPUT_ERROR_)
*---<<<XPARameters>>>  Exchange repulsion
      Elseif(Kword(1:4).eq.'XPAR') then
1112    Continue
        Key=Get_Ln(LuRd)
        Kword=Trim(Key)
        Call UpCase(Kword)
*------<<<S2  >>>  The S2 parameter
        If(Kword(1:4).eq.'S2  ') then
          Key=Get_Ln(LuRd)
          Call Get_F1(1,Exrep2)
          Go To 1112
        Endif
*------<<<S4  >>>  The S4 parameter
        If(Kword(1:4).eq.'S4  ') then
          Key=Get_Ln(LuRd)
          Call Get_F1(1,Exrep4)
          Go To 1112
        Endif
*------<<<S6  >>>  The S6 parameter
        If(Kword(1:4).eq.'S6  ') then
          Key=Get_Ln(LuRd)
          Call Get_F1(1,Exrep6)
          Go To 1112
        Endif
*------<<<S10 >>>  The S10 parameter
        If(Kword(1:4).eq.'S10 ') then
          Key=Get_Ln(LuRd)
          Call Get_F1(1,Exrep10)
          Go To 1112
        Endif
*------<<<CUTOff>>> The cut-off radii for repulsion. The first is
*                   outer radius that says EX=0 if R.gt.Cut_Ex1, while
*                   the second is a EX=infinity if R.lt.Cut_Ex2.
        If(Kword(1:4).eq.'CUTO') then
          Key=Get_Ln(LuRd)
          Call Get_F1(1,Cut_Ex1)
          Call Get_F1(2,Cut_Ex2)
          Go To 1112
        Endif
*------<<<END xparameters>>>
        If(Kword(1:4).eq.'END ') then
          Go To 111
        Endif
        Write(6,*)
        Write(6,*)' Error in QMSUrrounding section, XPARameters subsec'
     &//'tion.'
        Call Quit(_RC_INPUT_ERROR_)
*---<<<DAMPing>>>  Damping parameters for Qm-Surrounding interaction.
      Elseif(Kword(1:4).eq.'DAMP') then
1119    Continue
        Key=Get_Ln(LuRd)
        Kword=Trim(Key)
        Call UpCase(Kword)
*------<<<DISPersion>>>  Dispersion damping parameters. This part
*                        should have a AUTO keyword which collects
*                        default parameters from the MpProp file.
        If(Kword(1:4).eq.'DISP') then
          Dispdamp=.true.
          Key=Get_Ln(LuRd)
*-- Damping numbers for solvent
          Call Get_F(1,CharDi(1),1)
          Call Get_F(2,QuaDi(1,1),1)
          Call Get_F(3,QuaDi(2,1),1)
          Call Get_F(4,QuaDi(3,1),1)
          Key=Get_Ln(LuRd)
          Call Get_F(1,CharDi(2),1)
          Call Get_F(2,QuaDi(1,2),1)
          Call Get_F(3,QuaDi(2,2),1)
          Call Get_F(4,QuaDi(3,2),1)
*-- Damping numbers for solute
          Do 11711, i=1,iQ_Atoms
            Key=Get_Ln(LuRd)
            Call Get_F(1,CharDiQ(i),1)
            Call Get_F(2,QuaDiQ(1,i),1)
            Call Get_F(3,QuaDiQ(2,i),1)
            Call Get_F(4,QuaDiQ(3,i),1)
11711     Continue
          Go To 1119
*------<<<FIELd>>> Parameters for damping electric field.
        Elseif(Kword(1:4).eq.'FIEL') then
          Fielddamp=.true.
          Key=Get_Ln(LuRd)
          Call Get_F1(1,CAFieldG)
          Call Get_F1(2,CBFieldG)
          Call Get_F1(3,CFExp)
          Go To 1119
*------<<<END damping>>>
        Elseif(Kword(1:4).eq.'END ') then
          Go To 111
        Endif
        Write(6,*)
        Write(6,*)' Error in QMSUrrounding section, DAMPing subsection.'
        Call Quit(_RC_INPUT_ERROR_)
*---<<<END qmsurrounding>>>
      Elseif(Kword(1:4).eq.'END ') then
        Go To 1000
      Endif
*---And here we only go if unrecognized keyword is encountered.
      Write(6,*)
      Write(6,*)' Unrecognized keyword in the QMSUrrounding section:'
     &,Kword(1:4)
      Call Quit(_RC_INPUT_ERROR_)

*
* <<<SOLVent>>>  Specify stuff about the solvent. Usually, these
*                parameters should not be altered.
*
112   Continue
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)
*---<<<EXCHange>>>  Exchange repulsion parameters to solvent-solvent.
      If(Kword(1:4).eq.'EXCH') then
        Do 1081, i=1,nAtom
          Do 1082, j=1,i
            Key=Get_Ln(LuRd)
            Call Get_F(1,Sexrep(i,j),1)
            Call Get_F(2,Sexre1(i,j),1)
            Call Get_F(3,Sexre2(i,j),1)
            Sexrep(j,i)=Sexrep(i,j)
            Sexre1(j,i)=Sexre1(i,j)
            Sexre2(j,i)=Sexre2(i,j)
1082      Continue
1081    Continue
        Go To 112
      Endif
*---<<<DISPersion>>>  Dispersion parameters to solvent-solvent.
      If(Kword(1:4).eq.'DISP') then
        Do 1091, i=1,nPol
          Do 1092, j=1,i
            Key=Get_Ln(LuRd)
            Call Get_F(1,Disp(i,j),1)
            Disp(j,i)=Disp(i,j)
1092      Continue
1091    Continue
        Go To 112
      Endif
*---<<<COORdinates>>>  Explicitly given coordinates of solvent
*                      molecules. Also need number of particles.
      If(Kword(1:4).eq.'COOR') then
        YesNo(6)=.true.  !Signify that user gives coordinates.
        Key=Get_Ln(LuRd)
        Call Get_I1(1,nPart)
        kaunt=0
        Do 1101, i=1,nPart
          Do 1102, j=1,nAtom
            kaunt=kaunt+1
            Key=Get_Ln(LuRd)
            Call Get_F(1,Cordst(kaunt,1),1)
            Call Get_F(2,Cordst(kaunt,2),1)
            Call Get_F(3,Cordst(kaunt,3),1)
1102      Continue
          Do 1103, kk=1,3
            CoTEMP1(kk)=Cordst(kaunt-2,kk)
            CoTEMP2(kk)=Cordst(kaunt-1,kk)
            CoTEMP3(kk)=Cordst(kaunt-0,kk)
1103      Continue
          Call OffAtom(CoTEMP1,CoTEMP2,CoTEMP3,CoTEMP4,CoTEMP5)
          kaunt=kaunt+1
          Do 1104, kk=1,3
            Cordst(kaunt,kk)=CoTEMP4(kk)
1104      Continue
          kaunt=kaunt+1
          Do 1105, kk=1,3
            Cordst(kaunt,kk)=CoTEMP5(kk)
1105      Continue
1101    Continue
        Go To 112
      Endif
*---<<<CAVRepulsion>>>  Repulsion parameters between solvent and
*                       cavity boundary.
      If(Kword(1:4).eq.'CAVR') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,Exdtal)
        Call Get_F1(2,Exdt1)
        Go To 112
      Endif
*---<<<OCORbitals>>>  Occupied Orbitals for the solvent molecule
      If(Kword(1:4).eq.'OCOR') then
        Key=Get_Ln(LuRd)
        Call Get_I(1,iOrb(2),1)
        Go To 112
      Endif
*---<<<ATCEchpol>>>  Number of atoms, centers, charges and
*                    polarizabilities.
* Jose               Slater Sites
      If(Kword(1:4).eq.'ATCE') then
        Key=Get_Ln(LuRd)
        Call Get_I1(1,nAtom)
        Call Get_I1(2,nCent)
        Call Get_I1(3,nCha)
        Call Get_I1(4,nPol)
        Call Get_I1(5,nSlSiteC)
        Go To 112
      Endif
*---<<<CHARge>>>  Magnitude of the charges.
      If(Kword(1:4).eq.'CHAR') then
        Key=Get_Ln(LuRd)
        Call Get_F(1,Qsta,nCha)
        Go To 112
      Endif
*---<<<POLArizability>>>  Magnitude of polarizabilities.
      If(Kword(1:4).eq.'POLA') then
        Key=Get_Ln(LuRd)
        Call Get_F(1,Pol,nPol)
        Go To 112
      Endif
*Jose+++++++++++++
*---<<<SLATer>>> Magnitude of Slater PreFactors and Exponents.
      If(Kword(1:4).eq.'SLAT') then
        Key=Get_Ln(LuRd)
        Call Get_I1(1,lMltSlC)
        If(lMltSlC.gt.1) then
          Write(6,*)
          Write(6,*)'Too high order of multipole in classical system'
          Write(6,*)'              Higher order is 1'
          Call Quit(_RC_INPUT_ERROR_)
        Endif
        Do 2221, i=1,nSlSiteC
          Do 2223, j=0,lMltSlC
            nS=j*(j+1)*(j+2)/6
            nT=(j+1)*(j+2)*(j+3)/6
            Key=Get_Ln(LuRd)
            Call Get_F1(1,SlExpTemp)
            SlExpC(j+1,i)=SlExpTemp
            njhr=nT-nS
            Key=Get_Ln(LuRd)
            Call Get_F(1,SlFacTemp,njhr)
            njhr=1
            Do 2224, k=nS+1,nT
              SlFactC(k,i)=SlFacTemp(njhr)
              njhr=njhr+1
2224        Continue
2223      Continue
          Key=Get_Ln(LuRd)
          Call Get_F(1,SlPC(i),1)
2221    Continue
        Go To 112
      Endif

*---<<<END solvent>>>
      If(Kword(1:4).eq.'END ') then
        Go To 1000
      Endif
*---And the bla bla bla if something gets wrong.
      Write(6,*)
      Write(6,*)' Unrecognized keyword in the SOLVent section:'
     &,Kword(1:4)
      Call Quit(_RC_INPUT_ERROR_)

*
* <<<RASSisection>>>  Give some numbers specific for the handling
*                     of the RASSI-construction of the wave-func.
*
113   Continue
      QmType='RASSI'
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)
*---<<<JOBFiles>>>  How many jobfiles and how many states in them.
      If(Kword(1:4).eq.'JOBF') then
        Key=Get_Ln(LuRd)
        Call Get_I1(1,NrFiles)
        Key=Get_Ln(LuRd)
        Call Get_I(1,NrStates,NrFiles)
        Go To 113
      Endif
*---<<<EQSTate>>> Which state is to be equilibrated.
      If(Kword(1:4).eq.'EQST') then
        Key=Get_Ln(LuRd)
        Call Get_I1(1,nEqState)
        Go To 113
      Endif
*---<<<MOREduce>>> Work in reduced MO-basis.
      If(Kword(1:4).eq.'MORE') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,ThrsRedOcc)
        MoAveRed=.true.
        Go To 113
      Endif
*---<<<CONTract>>> Contract the RASSI state basis.
      If(Kword(1:4).eq.'CONT') then
        Key=Get_Ln(LuRd)
        Call Get_F1(1,ThrsCont)
        ContrStateB=.true.
        Go To 113
      Endif
*---<<<LEVElshift>>> Introduce levelshift of RASSI states.
      If(Kword(1:4).eq.'LEVE') then
        Key=Get_Ln(LuRd)
        Call Get_I1(1,nLvlShift)
        Key=Get_Ln(LuRd)
        Call Get_I(1,iLvlShift,nLvlShift)
        Key=Get_Ln(LuRd)
        Call Get_F(1,dLvlShift,nLvlShift)
*----- Just a little sorting.
7485    Continue
        Changed=.false.
        Do 7484, i=1,nLvlShift-1
          If(iLvlShift(i).gt.iLvlShift(i+1)) then
            iTemp=iLvlShift(i)
            iLvlShift(i)=iLvlShift(i+1)
            iLvlShift(i+1)=iTemp
            dTemp=dLvlShift(i)
            dLvlShift(i)=dLvlShift(i+1)
            dLvlShift(i+1)=dTemp
            Changed=.true.
          Endif
7484    Continue
        If(Changed) GoTo 7485
        Go To 113
      Endif
*---<<<CISElect>>> Use overlap criterion in choosing state.
      If(Kword(1:4).eq.'CISE') then
        lCiSelect=.true.
        Key=Get_Ln(LuRd)
        Call Get_I1(1,nCIRef)
        Key=Get_Ln(LuRd)
        Call Get_I(1,iCIInd,nCIRef)
        Key=Get_Ln(LuRd)
        Call Get_F(1,dCIRef,nCIRef)
        GoTo 113
      Endif
*---<<<END rassisection>>>
      If(Kword(1:4).eq.'END ') then
        YesNo(3)=.true.  !Rassi section has been visited.
        Go To 1000
      Endif
*---HOW COULD IT GET WRONG HERE?
      Write(6,*)
      Write(6,*)' Unrecognized keyword in the RASSisection section:'
     &,Kword(1:4)
      Call Quit(_RC_INPUT_ERROR_)

*
* <<<SCFSection>>>   Numbers for a SCF-QmStat run.
*
114   Continue
      QmType='SCF'
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)
*---<<<ORBItals>>>  Specifiy the reduced orbital space in which the
*                   problem is solved.
      If(Kword(1:4).eq.'ORBI') then
        Key=Get_Ln(LuRd)
        Call Get_I(1,iOrb(1),1)
        Call Get_I1(2,iOcc1)
        If(iOrb(1).gt.MxOrb) then
          Write(6,*)
          Write(6,*)'The parameter MxOrb is set too low, or your '
     &//'total number of orbitals too high.'
          Call Quit(_RC_INPUT_ERROR_)
        Endif
        Go To 114
      Endif
*---<<<MP2Denscorr>>>
      If(Kword(1:4).eq.'MP2D') then
        Mp2DensCorr=.true.
        Go To 114
      Endif
*---<<<END scfsection>>>
      If(Kword(1:4).eq.'END ') then
        YesNo(4)=.true.  !Scf section has been visited.
        Go To 1000
      Endif
*---ETWAS FALSCH!
      Write(6,*)
      Write(6,*)' Unrecognized keyword in the SCFSection:',Kword(1:4)
      Call Quit(_RC_INPUT_ERROR_)

*
* <<<SINGle-point>>>   Signify that a set of single point calculations
*                      are to be done.
*
115   Continue
      SingPoint=.true.
      YesNo(7)=.true.
      Go To 1000

*
* <<<ANALyze section>>> Give details what analysis of the sampfile
*                        coordinates that is to be done.
*
116   Continue
      Go To 1000

*
* <<<EXTRact section>>> Give details what QM and QM/MM analysis
*                        that is to be done from the sampfile
*                        coordinates.
*
117   Continue
      Key=Get_Ln(LuRd)
      Kword=Trim(Key)
      Call UpCase(Kword)
*---<<<TOTAl energy>>>
      If(Kword(1:4).eq.'TOTA') then
        lExtr(1)=.true.
        Go To 117
      Endif
*---<<<DIPOle>>>
      If(Kword(1:4).eq.'DIPO') then
        lExtr(2)=.true.
        Go To 117
      Endif
*---<<<QUADrupole>>>
      If(Kword(1:4).eq.'QUAD') then
        lExtr(3)=.true.
        Go To 117
      Endif
*---<<<EIGEn things>>>
      If(Kword(1:4).eq.'EIGE') then
        lExtr(4)=.true.
        Key=Get_Ln(LuRd)
        Call Get_I1(1,iExtr_Eig)
        Call Get_S(2,VecsQue,1)
        Call UpCase(VecsQue)
        If(VecsQue(1:3).eq.'YES') lExtr(5)=.true.
        Go To 117
      Endif
*---<<<EXPEctation values>>>
      If(Kword(1:4).eq.'EXPE') then
        lExtr(6)=.true.
        Go To 117
      Endif
*---<<<ELOCal>>>
      If(Kword(1:4).eq.'ELOC') then
        lExtr(7)=.true.
        Key=Get_Ln(LuRd)
        Call Get_I1(1,NExtr_Atm)
        Key=Get_Ln(LuRd)
        Call Get_I(1,iExtr_Atm,NExtr_Atm)
        Go To 117
      Endif
******JoseMEP****************
*---<<<MESP>>>
* The Main Electrostatic potential, field and field gradients will
* be obtained in order to produce perturbation integrals that will
* be used to optimize the intramolecular geometry of the QM system.
*
      If(Kword(1:4).eq.'MESP') then
        lExtr(8)=.true.
        Go To 117
      Endif
******************************
*---<<<END extract section>>>
      If(Kword(1:4).eq.'END ') then
        YesNo(10)=.true.
        GoTo 1000
      Endif
*---ETWAS FALSCH!
      Write(6,*)
      Write(6,*)' Unrecognized keyword in the EXTRact section:'
     &                                              ,Kword(1:4)
      Call Quit(_RC_INPUT_ERROR_)

*
*-- Exit
*
99999 Continue

*
*-- Check if mandatory input was included and that no blatant
*   inconcistencies exist. Not fool-proof, fools!
*
      Call MandatoryInp(YesNo)

*
*-- Good bye.
*

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Compute_Xhole_Int(nBasLop,nSym,ipSqMom,Func,nSize)
      use Her_RW
      use Real_Spherical
      Implicit Real*8 (a-h,o-z)

#include "real.fh"
#include "nq_info.fh"
#include "status.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: D1ao(:)
      Dimension nBasLop(nSym)
      Logical Do_Gamma, Do_Grad, On_Top, Do_Tau, Do_MO, Do_TwoEl
      Logical DSCF
      Character*4 DFTFOCK, KSDFT
      Integer nSize
      Real*8, Allocatable:: CMO(:)

*
*-- Check symmetry
*
      If(nSym.ne.1) then
        Write(6,*)
        Write(6,*)' You should not run LoProp with symmetry!'
        Call Abend()
      Endif
*
*-- Set a lot of numbers and labels. See below for more help.
*
      nB=nBasLop(1)     !-- number of basis functions
      nTri=nB*(nB+1)/2  !-- obvious!
      Func=Zero         !-- initialize
      Dens=Zero         !-- initialize
      nFckDim=1         !-- for open-shell the fock-matrix has
                        !   two versions, but this implementation
                        !   is not for UHF (but for CASSCF)
      nD=1              !-- much like nFckDim
      Do_Gamma=.false.  !-- optional stuff in DFT-theory; for our
                        !   purpose, just scheiss.
      Do_Grad=.false.   !-- see above.
      On_Top=.false.    !-- see above.
      Do_Tau=.false.    !-- see above.
      Do_MO=.true.      !-- in our integration kernel, we need MOs.
      Do_TwoEl=.false.  !-- scheiss in our functional.

      Write(DFTFOCK,'(A)')'XHOL'  !-- Tell the routines that we wish
                                  !   to run a xhole calculation.
      Write(KSDFT,'(A)')'LDA'     !-- Just to get the routines to
                                  !   take the fastest path, no other
                                  !   meaning.
      Call mma_allocate(D1ao,nTri)
      nDens=nTri
      Call Get_D1ao(D1ao,nDens)!-- The density matrix.
      ExFac=Get_ExFac(KSDFT)      !-- Zero, in fact.
      Functional_type=LDA_type    !-- Number from nq_info.fh.
      EThr=1.0d-9
      Call Put_dScalar('EThr',EThr)!-- A threshold for energy accuracy
                                   !   in DFT/SCF. Dummy.
      Call Seward_Init             !-- Initialize a lot of shit.
      nDiff=0                      !-- like above
      DSCF=.false.                 !-- like above
      Call GetInf(DSCF,nDiff)      !-- like above
      Call SetUp_iSD               !-- like above
      Call Get_iScalar('nSym',mIrrep)    !-- Stupid number in nq_info
                                         !   needed to fool do_mo
                                         !   stuff, since they normally
                                         !   are only activated by
                                         !   CASDFT
      Call Get_iArray('nBas',mBas,mIrrep)!-- Like above

*
*-- Then we need orbital density dipoles.
*
      nCMO=nB**2
      Call mma_allocate(CMO,nCMO,Label='CMO')
      nOrb=INT(sqrt(dble(nCMO)))
      Call Get_CMO(CMO,nCMO)
      nB=mBas(0)
      Call GetMem('MultSq','Allo','Real',iMultSq,nB**2)
      Call GetMem('TEMP','Allo','Real',iTEMP,nB*nOrb)
      Call GetMem('MultiKulti','Allo','Real',iMult1,nOrb**2+4)
      Call GetMem('OrbDipsX','Allo','Real',ip_OrbDip(1),nOrb*(nOrb+1)/2)
      Call GetMem('OrbDipsY','Allo','Real',ip_OrbDip(2),nOrb*(nOrb+1)/2)
      Call GetMem('OrbDipsZ','Allo','Real',ip_OrbDip(3),nOrb*(nOrb+1)/2)
      irc=-1
      Lu_One=49
      Lu_One=IsFreeUnit(Lu_One)
      Call OpnOne(irc,0,'ONEINT',Lu_One)
      If(irc.ne.0) then
        Write(6,*)
        Write(6,*)'ERROR! Could not open one-electron integral file.'
        Call Abend()
      Endif
      Do i=1,3
        irc=-1
        iOpt=1
        iSmLbl=1
        Call iRdOne(irc,iOpt,'Mltpl  1',i,nSize,iSmLbl)
        irc=-1
        iOpt=0
        iSmLbl=0
        Call RdOne(irc,iOpt,'Mltpl  1',i,Work(iMult1),iSmLbl)
        Call Square(Work(iMult1),Work(iMultSq),1,nB,nB)
      Call DGEMM_('T','N',nOrb,nB,nB,
     &            One,CMO,nB,
     &                Work(iMultSq),nB,
     &            Zero,Work(iTEMP),nOrb)
      Call DGEMM_('N','N',nOrb,nOrb,nB,
     &            One,Work(iTEMP),nOrb,
     &                CMO,nB,
     &                Zero,Work(iMult1),nOrb)
        kaunt1=0
        kaunt2=0
        Do iO1=1,nOrb
          Do iO2=1,nOrb
            If(iO1.ge.iO2) then
              Work(ip_OrbDip(i)+kaunt1)=Work(iMult1+kaunt2)
              kaunt1=kaunt1+1
            Endif
            kaunt2=kaunt2+1
          Enddo
        Enddo
      Enddo
      Call ClsOne(irc,Lu_One)
      Call GetMem('MultSq','Free','Real',iMultSq,nB**2)
      Call GetMem('TEMP','Free','Real',iTEMP,nB*nOrb)
      Call GetMem('MultiKulti','Free','Real',iMult1,nOrb**2+4)
      Call mma_deallocate(CMO)

*
*-- Anders' little helper on DrvNQ:
*     Argument (1): The name on the integration kernel. Is a routine
*                   in src/nq_util/ directory.
*              (2): Through some "fooling" of the integration routines
*                   this argument will upon return contain the matrix
*                   elements.
*              (3): nFckDim is described above. Just one.
*              (4): Here the functional "energy" comes, in other words
*                   the molecular expectation value
*              (5): Just shit.
*              (6): The one-electron density matrix.
*              (7): Dimension on all one-electron matrices.
*              (8): Like (3).
*              (9-17): Total scheiss from our perspective.
*              (18): Label to signal that we will need MOs.
*              (19): We use no two-electron stuff, hence false.
*              (20): Usually, this tells what type of Fock-matrix
*                    we use, but now we "rob" this variable for our
*                    purpose and let the value XHOL signify that we
*                    are computing the xhole dipole.
      Call GetMem('X-Dipole elements','Allo','Real',ip_MatEl,nTri)
!IFG: The call to DrvNQ below is completely messed up, please fix
      Call WarningMessage(2,'There is surely a bug here!')
!     Call DrvNQ(Do_XHoleDip,Work(ip_MatEl),nFckDim,Func,Dens
!    &          ,D1ao,nTri,nD,Do_Gamma,Do_Grad,Dummy
!    &          ,iDummy,Dummy,Dummy,iDummy,On_Top,Do_Tau,Do_MO
!    &          ,Do_TwoEl,DFTFOCK)
*      FFF=ddot_(nDens,D1ao,1,Work(ip_MatEl),1)
*      write(6,*)'YYY:',nDens,FFF,Func,ip_MatEl
*
*-- Put the second-moments in square form.
*
      Call GetMem('2MomSq','Allo','Real',ipSqMom,nB**2)
      Call Square(Work(ip_MatEl),Work(ipSqMom),1,nB,nB)

*
*-- Deallocate
*
      Call mma_deallocate(D1ao)
      Call Free_iSD()
      Call GetMem('X-Dipole elements','Free','Real',ip_MatEl,nTri)
      Call GetMem('OrbDipsX','Free','Real',ip_OrbDip(1),nOrb*(nOrb+1)/2)
      Call GetMem('OrbDipsY','Free','Real',ip_OrbDip(2),nOrb*(nOrb+1)/2)
      Call GetMem('OrbDipsZ','Free','Real',ip_OrbDip(3),nOrb*(nOrb+1)/2)
      Call Free_HerRW()

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GENSTR_MCLR(NEL,NELMN1,NELMX1,NELMN3,NELMX3,
     *                  ISTASO,NOCTYP,NSMST,Z,LSTASO,
     *                  IREORD,STRING,IOC,IOTYP,IPRNT)
*
* Generate strings consisting of  NEL electrons fullfilling
*   1 : Between NELMN1 AND NELMX1 electrons in the first NORB1 orbitals
*   2 : Between NELMN3 AND NELMX3 electrons in the last  NORB3 orbitals
*
* In the present version the strings are directly ordered into
* symmetry and occupation type .
*
* Jeppe Olsen Winter of 1990
* ========
* Output :
* ========
* STRING(IEL,ISTRIN) : Occupation of strings.
* IREORD             : Reordering array going from lexical
*                      order to symmetry and occupation type order.
*
      IMPLICIT REAL*8 ( A-H,O-Z)
*. Input
      DIMENSION ISTASO(NOCTYP,NSMST)
#include "detdim.fh"
#include "orbinp_mclr.fh"
      INTEGER Z(NACOB,NEL)
*
*.Output
      INTEGER STRING(NEL,*),IREORD(*)
*.Scratch arrays
      DIMENSION IOC(*),LSTASO(NOCTYP,NSMST)
*
*
      NTEST0 = 0
      NTEST = MAX(NTEST0,IPRNT)
*
      Call iCopy(NOCTYP*NSMST,[0],0,LSTASO,1)
      NSTRIN = 0
      IORB1F = 1
      IORB1L = IORB1F+NORB1-1
      IORB2F = IORB1L + 1
      IORB2L = IORB2F+NORB2-1
      IORB3F = IORB2L + 1
      IORB3L = IORB3F+NORB3-1
* Loop over possible partitionings between RAS1,RAS2,RAS3
      DO 1001 IEL1 = NELMX1,NELMN1,-1
      DO 1003 IEL3 = NELMN3,NELMX3, 1
       IF(IEL1.GT. NORB1 ) GOTO 1001
       IF(IEL3.GT. NORB3 ) GOTO 1003
       IEL2 = NEL - IEL1-IEL3
       IF(IEL2 .LT. 0 .OR. IEL2 .GT. NORB2 ) GOTO 1003
       IFRST1 = 1
* Loop over RAS 1 occupancies
901    CONTINUE
         IF( IEL1 .NE. 0 ) THEN
           IF(IFRST1.EQ.1) THEN
            CALL ISTVC2(IOC(1),0,1,IEL1)
            IFRST1 = 0
           ELSE
             CALL NXTORD(IOC,IEL1,IORB1F,IORB1L,NONEW1)
             IF(NONEW1 .EQ. 1 ) GOTO 1003
           END IF
         END IF
         IF( NTEST .GE. 500) THEN
           WRITE(6,*) ' RAS 1 string '
           CALL IWRTMA(IOC,1,IEL1,1,IEL1)
         END IF
         IFRST2 = 1
         IFRST3 = 1
* Loop over RAS 2 occupancies
902      CONTINUE
           IF( IEL2 .NE. 0 ) THEN
             IF(IFRST2.EQ.1) THEN
              CALL ISTVC2(IOC(IEL1+1),IORB2F-1,1,IEL2)
              IFRST2 = 0
             ELSE
               CALL NXTORD(IOC(IEL1+1),IEL2,IORB2F,IORB2L,NONEW2)
               IF(NONEW2 .EQ. 1 ) THEN
                 IF(IEL1 .NE. 0 ) GOTO 901
                 IF(IEL1 .EQ. 0 ) GOTO 1003
               END IF
             END IF
           END IF
           IF( NTEST .GE. 500) THEN
             WRITE(6,*) ' RAS 1 2 string '
             CALL IWRTMA(IOC,1,IEL1+IEL2,1,IEL1+IEL2)
           END IF
           IFRST3 = 1
* Loop over RAS 3 occupancies
903        CONTINUE
             IF( IEL3 .NE. 0 ) THEN
               IF(IFRST3.EQ.1) THEN
                CALL ISTVC2(IOC(IEL1+IEL2+1),IORB3F-1,1,IEL3)
                IFRST3 = 0
               ELSE
                 CALL NXTORD(IOC(IEL1+IEL2+1),
     &           IEL3,IORB3F,IORB3L,NONEW3)
                 IF(NONEW3 .EQ. 1 ) THEN
                   IF(IEL2 .NE. 0 ) GOTO 902
                   IF(IEL1 .NE. 0 ) GOTO 901
                   GOTO 1003
                 END IF
               END IF
             END IF
             IF( NTEST .GE. 500 ) THEN
               WRITE(6,*) ' RAS 1 2 3 string '
               CALL IWRTMA(IOC,1,NEL,1,NEL)
             END IF
* Next string has been constructed , Enlist it !.
             NSTRIN = NSTRIN + 1
*. Symmetry
             ISYM = ISYMST_MCLR(IOC,NEL)
*. Occupation type
             ITYP = IOCTP2_MCLR(IOC,NEL,IOTYP)
*
             IF(ITYP.NE.0) THEN
               LSTASO(ITYP,ISYM) = LSTASO(ITYP,ISYM)+ 1
               LEXCI = ISTRNM(IOC,NACOB,NEL,Z,IREORD,0)
               LACTU = ISTASO(ITYP,ISYM)-1+LSTASO(ITYP,ISYM)
               IREORD(LEXCI) = LACTU
               If (NEL.ne.0) Call iCopy(NEL,IOC,1,STRING(1,LACTU),1)
             END IF
*
           IF( IEL3 .NE. 0 ) GOTO 903
           IF( IEL3 .EQ. 0 .AND. IEL2 .NE. 0 ) GOTO 902
           IF( IEL3 .EQ. 0 .AND. IEL2 .EQ. 0 .AND. IEL1 .NE. 0)
     &     GOTO 901
1003  CONTINUE
1001  CONTINUE
*
      IF(NTEST.GE.1 ) THEN
        WRITE(6,*) ' Number of strings generated   ', NSTRIN
      END IF
      IF(NTEST.GE.10)  THEN
        IF(NTEST.GE.100) THEN
          NPR = NSTRIN
        ELSE
          NPR = MIN(NSTRIN,50)
        END IF
        WRITE(6,*) ' Strings generated '
        WRITE(6,*) ' =================='
        ISTRIN = 0
        DO 100 ISYM = 1, NSMST
        DO 101 ITYP = 1,NOCTYP
          LSTRIN = MIN(LSTASO(ITYP,ISYM),NPR-ISTRIN)
          IF(LSTRIN.GT.0) THEN
            WRITE(6,*) ' Strings of type and symmetry ',ITYP,ISYM
            DO 90 KSTRIN = 1,LSTRIN
              ISTRIN = ISTRIN + 1
              WRITE(6,'(2X,I4,8X,(10I5))')
     &        ISTRIN,(STRING(IEL,ISTRIN),IEL = 1,NEL)
90          CONTINUE
          END IF
101     CONTINUE
100     CONTINUE
*
        WRITE(6,*) ' Array giving actual place from lexical place'
        WRITE(6,*) ' ============================================'
        CALL IWRTMA(IREORD,1,NPR,1,NPR)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RdCtl_Slapaf(LuSpool,Dummy_Call)

use Symmetry_Info, only: Symmetry_Info_Get
use Slapaf_Info, only: Atom, Baker, Beta, Beta_Disp, CallLast, CnstWght, Coor, Cubic, Curvilinear, Cx, ddV_Schlegel, Delta, &
                       dMEPStep, eMEPTest, Fallback, FindTS, GNrm_Threshold, GradRef, Gx, HrmFrq_Show, HWRS, iOptC, iOptH, IRC, &
                       iRow, iRow_c, isFalcon, Iter, Lbl, lCtoF, lDoubleIso, Line_Search, lNmHss, lOld, lTherm, Max_Center, &
                       MaxItr, MEP, MEP_Algo, MEP_Type, MEPCons, MEPNum, MF, Mode, mRowH, MxItr, NADC, nBVec, nLambda, nMEP, &
                       nsRot, nStab, nSup, nUserPT, nWndw, Redundant, RefGeo, Request_Alaska, rFuzz, rHidden, rMEP, RtRnc, &
                       ThrCons, ThrEne, ThrGrd, ThrMEP, Track, TSConstraints, User_Def, UserP, UserT, WeightedConstraints, Weights
use kriging_mod, only: blavAI, Kriging, Max_Microiterations, nD_In
use UnixInfo, only: SuperName
use PrintLevel, only: nPrint
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Ten, Half, Angstrom
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LuSpool
logical(kind=iwp), intent(in) :: Dummy_Call
integer(kind=iwp) :: i, iAtom, iDum(1), iErr, iMEP, iNull, iOff_Iter, iPrint, iRout, istatus, iTmp, j, jStrt, kPrint, Lu_UDC, &
                     Lu_UDCTMP, Lu_UDIC, LuRd, LuTS, mPrint, NewLine, nLbl, nRP, nRx, nSaddle, nsAtom, nSupSy
real(kind=wp) :: HSR, HSR0, Update, Valu, xWeight
logical(kind=iwp) :: Expert, Explicit_IRC, External_UDC, FirstNum, Found, Manual_Beta, ThrInp
character(len=180) :: Chr, Key
character(len=16) :: FilNam
character(len=3) :: MEPLab
real(kind=wp), allocatable :: DIR(:,:), Tmp(:), TmpRx(:)
integer(kind=iwp), external :: IsFreeUnit
character(len=180), external :: Get_Ln

!                                                                      *
!***********************************************************************
!                                                                      *
Expert = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
! Initiate some parameters

iRout = 2
iPrint = nPrint(iRout)
call Symmetry_Info_Get()
call Init_Slapaf()
nsAtom = size(Coor,2)

call f_Inquire('UDC.Gateway',External_UDC)

iMEP = 0
Explicit_IRC = .false.
WeightedConstraints = .false.
ThrInp = .false.
call Qpg_iScalar('nMEP',Found)
if (Found) call Get_iScalar('nMEP',iMEP)
if (iMEP == 0) then
  iOff_Iter = 0
  call Put_iScalar('iOff_Iter',iOff_Iter)
end if
Manual_Beta = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
! When called from outside Slapaf or as a dummy call, process no
! input but proceed with default values only.

if ((SuperName == 'slapaf') .and. (.not. Dummy_Call)) then
  !                                                                    *
  !*********************************************************************
  !************************   Input section   **************************
  !*********************************************************************
  !                                                                    *
  LuRd = LuSpool
  call RdNlst(LuRd,'SLAPAF')
  do
    Chr = Get_Ln(LuRd)
    call UpCase(Chr)
    !write(u6,'(A)') Chr
    !write(u6,*) iOptC
    if (Chr == '') cycle
    if (Chr(1:1) == '*') cycle
    select case (Chr(1:4))
      !case ('AIL ')
      !  !                                                              *
      !  !***** AIL  ****************************************************
      !  !                                                              *
      !  ! Width limits of the Matern function
      !
      !  Chr = Get_Ln(LuRd)
      !  call Get_F(1,lb,3)

      !case ('AIP ')
      !  !                                                              *
      !  !***** AIP  ****************************************************
      !  !                                                              *
      !  ! Parameter of differentiability for Matern function
      !
      !  Chr = Get_Ln(LuRd)
      !  call Get_F1(1,pAI)
      !  if ((pAI > 3) .or. (pAI < 1)) anMd = .false.

      !case ('AISP')
      !  !                                                              *
      !  !***** AISP ****************************************************
      !  !                                                              *
      !  ! Defining the number of source points for the AI method
      !
      !  Chr = Get_Ln(LuRd)
      !  call Get_I1(1,nspAI)

      !case ('AIMD')
      !  !                                                              *
      !  !***** AIMD ****************************************************
      !  !                                                              *
      !  ! Analytical or numerical Matern derivatives
      !
      !  Chr = Get_Ln(LuRd)
      !  if ((Chr == 'False') .or. (Chr == 'false')) then
      !    anMd = .false.
      !  else
      !    anMd = .true.
      !  end if

      !case ('AIME')
      !  !                                                              *
      !  !***** AIME ****************************************************
      !  !                                                              *
      !  ! Minimum energy differences of the last two iterations
      !  ! (loop exit condition)
      !
      !  Chr = Get_Ln(LuRd)
      !  call Get_F1(1,Thr_microiterations)

      !case ('AIBL')
      !  !                                                              *
      !  !***** AIBL ****************************************************
      !  !                                                              *
      !  ! Base line modification value to not ordinary
      !  ! (Trend Function on GEK)
      !
      !  Chr = Get_Ln(LuRd)
      !  call Get_F1(1,blvAI)
      !  blAI = .true.

      !case ('AIMB')
      !  !                                                              *
      !  !***** AIMB ****************************************************
      !  !                                                              *
      !  ! Base line modification value to maximum value of the Energy
      !  ! This option supersedes any value assigned to blAI
      !
      !  Chr = Get_Ln(LuRd)
      !  mblAI = .true.

      !case ('L-VA')
      !  !                                                              *
      !  !***** L-VA ****************************************************
      !  !                                                              *
      !  ! Change the l value of the GEK.
      !
      !  Chr = Get_Ln(LuRd)
      !  Set_l = .true.
      !  call Get_F1(1,Value_l)
      !  call Qpg_dScalar('Value_l',Found)
      !  if (.not. Found) call Put_dScalar('Value_l',Value_l)

      case ('NDEL')
        !                                                              *
        !***** NDELta **************************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call Get_I1(1,nD_In)

      case ('BAKE')
        !                                                              *
        !***** BAKE ****************************************************
        !                                                              *
        Baker = .true.

      case ('C1-D')
        !                                                              *
        !***** C1-D ****************************************************
        !                                                              *
        iOptC = ibclr(iOptC,0)
        iOptC = ibset(iOptC,1)
        iOptC = ibclr(iOptC,2)
        iOptC = ibclr(iOptC,3)

      case ('C2-D')
        !                                                              *
        !***** C2-D ****************************************************
        !                                                              *
        iOptC = ibclr(iOptC,0)
        iOptC = ibclr(iOptC,1)
        iOptC = ibset(iOptC,2)
        iOptC = ibclr(iOptC,3)

      case ('CART')
        !                                                              *
        !***** CART ****************************************************
        !                                                              *
        CurviLinear = .false.

      case ('CNWE')
        !                                                              *
        !***** CNWE ****************************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call Get_F1(1,CnstWght)

      case ('CONS')
        !                                                              *
        !***** CONS ****************************************************
        !                                                              *
        ! Copy constraints definition into the UDC file, to be read
        ! (after fixing and merging, if necessary) by DefInt2/Cllct2.

        if (.not. Expert) then
          write(u6,*)
          write(u6,*) ' ************ ERROR ***************'
          write(u6,*) ' Obsolete input standard!'
          write(u6,*) ' The CONSTRAINT section should'
          write(u6,*) ' be define in the &Gateway input.'
          write(u6,*)
          write(u6,*) ' To override add the EXPERT keyword'
          write(u6,*) ' to the top of the SLAPAF input.'
          write(u6,*) ' **********************************'
          call Quit_OnUserError()
        end if
        if (External_UDC) then
          call WarningMessage(2,'Error in RdCtl_Slapaf')
          write(u6,*)
          write(u6,*) '****************** ERROR *********************'
          write(u6,*) 'Multiple definitions of constraints.'
          write(u6,*) 'Check Gateway and Slapaf inputs for conflicts!'
          write(u6,*) '**********************************************'
          call Quit_OnUserError()
        end if
        Lu_UDC = 20
        FilNam = 'UDC'
        Lu_UDC = IsFreeUnit(Lu_UDC)
        call Molcas_Open(Lu_UDC,FilNam)
        do
          Key = Get_Ln(LuRd)
          call UpCase(Key)
          Key = adjustl(Key)
          write(Lu_UDC,'(A)') trim(Key)
          if (Key(1:4) == 'END') exit
        end do
        close(Lu_UDC)

      case ('CTOF')
        !                                                              *
        !***** CTOF ****************************************************
        !                                                              *
        ! Read the internal (C)oordinate specification (TO) be (F)ollowed.

        if (iRow > 0) then
          call WarningMessage(2,'Error in RdCtl_Slapaf')
          write(u6,*)
          write(u6,*) '*********** ERROR ***************'
          write(u6,*) 'CtoF and User-defined Coordinates'
          write(u6,*) 'are mutually exclusive.          '
          write(u6,*) '*********************************'
          call Quit_OnUserError()
        end if
        iNull = 0
        NewLine = 1
        lCtoF = .true.
        Lu_UDIC = 91
        FilNam = 'UDIC'
        call molcas_open(Lu_UDIC,FilNam)
        rewind(Lu_UDIC)
        Key = Get_Ln(LuRd)
        call UpCase(Key)
        call FixEqualSign2(Key,LuRd,Lu_UDIC,iNull,NewLine)
        write(Lu_UDIC,'(A)') Key
        close(Lu_UDIC)

      case ('CUBI')
        !                                                              *
        !***** CUBI ****************************************************
        !                                                              *
        Cubic = .true.

      case ('DDVS')
        !                                                              *
        !***** DDVS ****************************************************
        !                                                              *
        DDV_Schlegel = .true.

      case ('DELT')
        !                                                              *
        !***** DELT ****************************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call Get_F1(1,Delta)

      case ('DISO')
        !                                                              *
        !***** DISO ****************************************************
        !                                                              *
        lDoubleIso = .true.

      case ('DXDX')
        !                                                              *
        !***** DXDX ****************************************************
        !                                                              *
        iOptC = ibset(iOptC,4)
        iOptC = ibclr(iOptC,5)
        iOptC = ibclr(iOptC,6)

      case ('DXG ','GDX ')
        !                                                              *
        !***** DXG  ****************************************************
        !                                                              *
        iOptC = ibclr(iOptC,4)
        iOptC = ibset(iOptC,5)
        iOptC = ibclr(iOptC,6)

      case ('END ')
        exit

      case ('EXPE')
        !                                                              *
        !***** EXPE ****************************************************
        !                                                              *
        Expert = .true.

      case ('EXTR')
        !                                                              *
        !***** EXTR ****************************************************
        !                                                              *
        ! Put the program name and the time stamp onto the extract file

        write(u6,*) 'RdCtl_Slapaf: EXTRACT option is redundant and is ignored!'

      case ('FALC')
        !                                                              *
        !***** FALC ****************************************************
        !                                                              *
        isFalcon = .true.

      case ('FIND')
        !                                                              *
        !***** FIND ****************************************************
        !                                                              *
        FindTS = .true.

      case ('FUZZ')
        !                                                              *
        !***** FUZZ ****************************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call UpCase(Chr)
        call Get_F1(1,rFuzz)
        if (index(Chr,'ANGSTROM') /= 0) rFuzz = rFuzz/Angstrom
        rFuzz = max(rFuzz,1.0e-3_wp)

      case ('GG  ')
        !                                                              *
        !***** GG   ****************************************************
        !                                                              *
        iOptC = ibclr(iOptC,4)
        iOptC = ibclr(iOptC,4)
        iOptC = ibset(iOptC,4)

      case ('GNRM')
        !                                                              *
        !***** GNRM ****************************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call Get_F1(1,GNrm_Threshold)

      case ('GRAD')
        !                                                              *
        !***** GRAD ****************************************************
        !                                                              *
        call mma_allocate(GradRef,3,nsAtom,Label='GradRef')

        call Read_v(LuRd,GradRef,1,3*nsAtom,1,iErr)
        if (iErr /= 0) then
          call WarningMessage(2,'Error in RdCtl_Slapaf')
          write(u6,*)
          write(u6,*) '*************** ERROR ******************'
          write(u6,*) 'Error reading reference gradient vector.'
          write(u6,*) '****************************************'
          call Quit_OnUserError()
        end if

        ! If there is a transverse vector stored, we are not using this one

        call qpg_dArray('Transverse',Found,nRP)
        if (Found) call mma_deallocate(GradRef)

      case ('HRMS')
        !                                                              *
        !***** HRMS ****************************************************
        !                                                              *
        HrmFrq_Show = .true.

      case ('HUPD')
        !                                                              *
        !***** HUPD ****************************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        read(Chr,*) Chr
        call UpCase(Chr)
        select case (Chr)
          !case ('MEYER') then
          !  iOptH = ibset(0,0)
          !case ('BP') then
          !  iOptH = ibset(0,1)
          case ('BFGS')
            iOptH = ibset(0,2)
          case ('NONE')
            iOptH = ibset(0,3)
          case ('MSP')
            iOptH = ibset(0,4)
          case ('EU')
            iOptH = ibset(0,5)
          case ('TS-BFGS')
            iOptH = ibset(0,6)
          case default
            call WarningMessage(2,'Error in RdCtl_Slapaf')
            write(u6,*)
            write(u6,*) '************ ERROR ****************'
            write(u6,*) 'Unsupported Hessian update method: ',trim(Chr)
            write(u6,*) '***********************************'
            call Quit_OnUserError()
        end select

      case ('HWRS')
        !                                                              *
        !***** HWRS ****************************************************
        !                                                              *
        HWRS = .true.

      case ('INTE')
        !                                                              *
        !***** INTE ****************************************************
        !                                                              *
        ! Read the internal coordinate specification.

        NewLine = 1
        Lu_UDIC = 91
        FilNam = 'UDIC'
        call molcas_open(Lu_UDIC,FilNam)
        rewind(Lu_UDIC)

        ! mInt is the number of internal coordinates you will define.
        ! mInt = nDimBC - mTROld
        ! Subroutine DefInt defines the B matrix.
        ! The matrix B relates a shift in an internal coordinate to
        ! shifts in cartesian coordinates,
        !
        !           |dq> = B |dx>
        !                      =
        ! and has the dimension (3*nsAtom x mInt).
        inte: do
          Key = Get_Ln(LuRd)
          call UpCase(Key)
          if (Key(1:4) == 'END ') then
            close(Lu_UDIC)
            exit inte
          end if

          ! Here is a fix because auto will break up the lines if there is an
          ! equal sign in the input.

          ! Lines with VARY or FIX doesn't have equal signs

          if (Key(1:4) == 'VARY') nBVec = iRow
          if ((Key(1:4) == 'VARY') .or. (Key(1:3) == 'FIX') .or. (Key(1:4) == 'ROWH')) NewLine = 0

          do
            if (NewLine /= 1) exit
            if (index(Key,'=') == 0) call FixEqualSign2(Key,LuRd,Lu_UDIC,iRow,NewLine)
            if (NewLine == 2) then
              close(Lu_UDIC)
              exit inte
            end if
          end do

          iRow = iRow+1

          write(Lu_UDIC,'(A)') Key

          ! If this line does not have a continuation the next line should
          ! have a equal sign!
          if (index(Key,'&') == 0) NewLine = 1
        end do inte

      case ('IRC ')
        !                                                              *
        !***** IRC *****************************************************
        !                                                              *
        call Qpg_iScalar('IRC',Found)
        if (Found) then
          call Get_iScalar('IRC',IRC)
        else
          IRC = 1
          call Put_iScalar('IRC',IRC)
        end if
        MEP = .true.
        rMEP = .false.

      case ('ITER')
        !                                                              *
        !***** ITER ****************************************************
        !                                                              *
        ! read max iterations

        Chr = Get_Ln(LuRd)
        call Get_I1(1,iTmp)
        MxItr = min(iTmp,MxItr)

      case ('KRIG')
        !                                                              *
        !***** KRIG ****************************************************
        !                                                              *
        ! Activate Kriging

        Kriging = .true.
        Line_Search = .false.

      case ('LAST')
        !                                                              *
        !***** LAST ****************************************************
        !                                                              *
        do
          Chr = Get_Ln(LuRd)
          Chr = adjustl(Chr)
          if ((Chr /= '') .and. (Chr(1:1) == '*')) exit
        end do
        call UpCase(Chr)
        call Put_cArray('LastEnergyMethod',Chr,8)

      case ('LINE')
        !                                                              *
        !***** LINE ****************************************************
        !                                                              *
        Line_Search = .true.

      case ('MAXS')
        !                                                              *
        !***** MAXS ****************************************************
        !                                                              *
        do
          Chr = Get_Ln(LuRd)
          if ((Chr /= '') .and. (Chr(1:1) /= '*')) exit
        end do
        call Get_F1(1,Beta)

      case ('MAXD')
        !                                                              *
        !***** MAXD ****************************************************
        !                                                              *
        do
          Chr = Get_Ln(LuRd)
          if ((Chr /= '') .and. (Chr(1:1) /= '*')) exit
        end do
        call Get_F1(1,Beta_Disp)
        Manual_Beta = .true.

      case ('MEP-','MEP ')
        !                                                              *
        !***** MEP-/MEP  ***********************************************
        !                                                              *
        MEP = .true.
        rMEP = .false.

      case ('MEPA','IRCA')
        !                                                              *
        !***** MEPA/IRCA ***********************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call UpCase(Chr)
        if (Chr(1:2) == 'GS') then
          MEP_Algo = 'GS'
        else if (Chr(1:2) == 'MB') then
          MEP_Algo = 'MB'
        else
          call WarningMessage(2,'Error in RdCtl_Slapaf')
          write(u6,*)
          write(u6,*) '************* ERROR ************'
          write(u6,*) ' Unrecognized MEP/IRC algorithm.'
          write(u6,*) '********************************'
          call Quit_OnUserError()
        end if

      case ('MEPC','IRCC')
        !                                                              *
        !***** MEPC/IRCC ***********************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call Get_F1(1,ThrMEP)
        ThrMEP = max(Zero,ThrMEP)

      case ('MEPS','IRCS')
        !                                                              *
        !***** MEPStep/IRCStep *****************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call UpCase(Chr)
        call Get_F1(1,dMEPStep)

        ! Note that according to the Gonzalez-Schlegel method, only half
        ! this step is used in the constraint

        if (index(Chr,'ANGSTROM') /= 0) dMEPStep = dMEPStep/Angstrom

      case ('MEPT','IRCT')
        !                                                              *
        !***** MEPT/IRCT ***********************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call UpCase(Chr)
        if (Chr(1:6) == 'SPHERE') then
          MEP_Type = 'SPHERE'
        else if (Chr(1:5) == 'PLANE') then
          MEP_Type = 'TRANSVERSE'
        else
          call WarningMessage(2,'Error in RdCtl_Slapaf')
          write(u6,*)
          write(u6,*) '********** ERROR **********'
          write(u6,*) ' Unrecognized MEP/IRC type.'
          write(u6,*) '***************************'
          call Quit_OnUserError()
        end if

      case ('MODE')
        !                                                              *
        !***** MODE ****************************************************
        !                                                              *
        ! Mode following algorithm

        do
          Chr = Get_Ln(LuRd)
          if ((Chr /= '') .and. (Chr(1:1) /= '*')) exit
        end do
        call Get_I1(1,mode)

      case ('MXMI')
        !                                                              *
        !***** MXMI ****************************************************
        !                                                              *
        ! Maximum number of Iterations for the Kriging method

        Chr = Get_Ln(LuRd)
        call Get_I1(1,Max_Microiterations)

      case ('NMEP','NIRC')
        !                                                              *
        !***** NMEP/NIRC ***********************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call Get_I1(1,nMEP)
        nMEP = min(max(nMEP,1),MaxItr)

      case ('NEWT')
        !                                                              *
        !***** NEWT ****************************************************
        !                                                              *
        iOptC = ibset(iOptC,0)
        iOptC = ibclr(iOptC,1)
        iOptC = ibclr(iOptC,2)
        iOptC = ibclr(iOptC,3)

      case ('NOEM')
        !                                                              *
        !***** NOEM ****************************************************
        !                                                              *
        eMEPTest = .false.

      case ('NOFA')
        !                                                              *
        !***** NOFA ****************************************************
        !                                                              *
        ! Deactivate fallback to conventional

        Fallback = .false.

      case ('NOHW')
        !                                                              *
        !***** NOHW ****************************************************
        !                                                              *
        HWRS = .false.

      case ('NOLA')
        !                                                              *
        !***** NOLA ****************************************************
        !                                                              *
        CallLast = .false.

      case ('NOLI')
        !                                                              *
        !***** NOLI ****************************************************
        !                                                              *
        Line_Search = .false.

      case ('NOWB')
        !                                                              *
        !***** NO VDWB VdW correction both coordinate and Hessian ******
        !                                                              *
        iOptC = ibclr(iOptC,10)
        iOptC = ibclr(iOptC,11)

      case ('NOWC')
        !                                                              *
        !***** NO VDWB VdW correction for coordinate only **************
        !                                                              *
        iOptC = ibclr(iOptC,11)

      case ('NOWH')
        !                                                              *
        !***** NO VDWB VdW correction for Hessian only *****************
        !                                                              *
        iOptC = ibclr(iOptC,10)

      case ('NUME')
        !                                                              *
        !***** NUME ****************************************************
        !                                                              *
        lNmHss = .true.

      case ('OLDF')
        !                                                              *
        !***** OLDF ****************************************************
        !                                                              *
        lOld = .true.

      case ('PRFC')
        !                                                              *
        !***** PRFC ****************************************************
        !                                                              *
        ! set nPrint to print internal coordinates and hessian

        nPrint(21) = 6  ! Eigen-/Values/Vectors of the Hessian (diagmtrx)
        nPrint(116) = 6 ! Internal Forces (rlxctl)
        if (.not. Request_Alaska) nPrint(30) = 6 ! Coords & Forces (defint)
        nPrint(122) = 6 ! Auto-Defined Internal coordinates (printq_sl)

      case ('PRIN')
        !                                                              *
        !***** PRIN ****************************************************
        !                                                              *
        do
          Chr = Get_Ln(LuRd)
          call UpCase(Chr)
          if ((Chr /= '') .and. (Chr(1:1) /= '*')) exit
        end do
        call Get_I1(1,mPrint)
        do i=1,mPrint
          do
            Chr = Get_Ln(LuRd)
            call UpCase(Chr)
            if ((Chr /= '') .and. (Chr(1:1) /= '*')) exit
          end do
          call Get_I1(1,iRout)
          call Get_I1(2,kPrint)
          nPrint(iRout) = kPrint
        end do

      case ('RATI')
        !                                                              *
        !***** RATI ****************************************************
        !                                                              *
        iOptC = ibclr(iOptC,0)
        iOptC = ibclr(iOptC,1)
        iOptC = ibclr(iOptC,2)
        iOptC = ibset(iOptC,3)

      case ('REDU')
        !                                                              *
        !***** REDU ****************************************************
        !                                                              *
        Redundant = .true.

      case ('REAC')
        !                                                              *
        !***** REAC ****************************************************
        !                                                              *
        Explicit_IRC = .true.
        call mma_allocate(TmpRx,3*nsAtom,Label='TmpRx')
        call Read_v(LuRd,TmpRx,1,3*nsAtom,1,iErr)
        if (IErr /= 0) then
          call WarningMessage(2,'Error in RdCtl_Slapaf')
          write(u6,*)
          write(u6,*) '********** ERROR ***********************'
          write(u6,*) ' Error while reading the Reaction vector'
          write(u6,*) '****************************************'
          call Quit_OnUserError()
        end if

      case ('REFE')
        !                                                              *
        !***** REFE ****************************************************
        !                                                              *
        call mma_allocate(RefGeo,3,nsAtom,Label='RefGeo')
        call Read_v(LuRd,RefGeo,1,3*nsAtom,1,iErr)
        if (iErr /= 0) then
          call WarningMessage(2,'Error in RdCtl_Slapaf')
          write(u6,*)
          write(u6,*) '************ ERROR ***************'
          write(u6,*) 'Error reading reference structure.'
          write(u6,*) '**********************************'
          call Quit_OnUserError()
        end if

      case ('RHID')
        !                                                              *
        !***** rHidden *************************************************
        !                                                              *
        Key = Get_Ln(LuRd)
        call UpCase(Key)
        call Get_F1(1,rHidden)
        if (rHidden < Zero) then
          call WarningMessage(2,'Error in RdCtl_Slapaf')
          write(u6,*)
          write(u6,*) '************ ERROR *****************'
          write(u6,*) 'Error reading rHidden. Should be >0.'
          write(u6,*) '************************************'
          call Quit_OnUserError()
        end if
        if (index(Key,'ANGSTROM') /= 0) rHidden = rHidden/Angstrom

      case ('RMEP')
        !                                                              *
        !***** rMEP ****************************************************
        !                                                              *
        rMEP = .true.
        MEP = .false.

      case ('RS-P')
        !                                                              *
        !***** RS-P ****************************************************
        !                                                              *
        iOptC = ibclr(iOptC,9)

      case ('RTRN')
        !                                                              *
        !***** RTRN ****************************************************
        !                                                              *
        Chr = Get_Ln(LuRd)
        call UpCase(Chr)
        call Get_I1(1,Max_Center)
        call Get_F1(2,rtrnc)
        if (index(Chr,'ANGSTROM') /= 0) Rtrnc = Rtrnc/Angstrom

      case ('SUPS')
        !                                                              *
        !***** SUPS ****************************************************
        !                                                              *
        ! Introduce supersymmetry
        ! Input format
        ! nsg                (number of super groups)
        ! Repeat nsg times
        ! nmem, (ind.., i = 1, nmem)

        Chr = Get_Ln(LuRd)
        call Get_I1(1,nSupSy)
        call mma_allocate(nSup,NSUPSY,Label='nSup')
        call mma_allocate(Atom,nsAtom,Label='Atom')
        jStrt = 1
        do i=1,nSupSy
          read(LuRd,*,iostat=istatus) nSup(i),(Atom(j),j=jStrt,jStrt+nSup(i)-1)
          if (istatus > 0) then
            call WarningMessage(2,'Error in RdCtl_Slapaf')
            write(u6,*)
            write(u6,*) '************ ERROR ****************'
            write(u6,*) 'Error while reading supersymmetry.'
            write(u6,*) '***********************************'
            call Quit_OnUserError()
          end if
          jStrt = jStrt+nSup(i)
        end do

      case ('TFOF')
        !                                                              *
        !***** TFOF ****************************************************
        !                                                              *
        ! adding energy to the last energy value of the base line
        ! This option supersedes any value assigned to blAI and mblAI

        Chr = Get_Ln(LuRd)
        call Get_F1(1,blavAI)

      case ('THER')
        !                                                              *
        !***** THER ****************************************************
        !                                                              *
        lNmHss = .true.
        lTherm = .true.
        Chr = Get_Ln(LuRd)
        call Get_I1(1,nsRot)
        Chr = Get_Ln(LuRd)
        call Get_F1(1,UserP)
        do
          Chr = Get_Ln(LuRd)
          call UpCase(Chr)
          if (Chr(1:4) == 'END ') then
            if (nUserPT == 0) then
              nUserPT = 1
              UserT(1) = 298.15_wp
            end if
            exit
          end if
          nUserPT = nUserPT+1
          call Get_F1(1,UserT(nUserPT))
        end do

      case ('THRS')
        !                                                              *
        !***** THRS ****************************************************
        !                                                              *
        ! read the gradient threshold

        Chr = Get_Ln(LuRd)
        call Get_F1(1,ThrEne)
        call Get_F1(2,ThrGrd)
        ThrInp = .true.

      case ('TOLE')
        !                                                              *
        !***** TOLE ****************************************************
        !                                                              *
        ! read the constraints threshold

        Chr = Get_Ln(LuRd)
        call Get_F1(1,ThrCons)
        ThrCons = abs(ThrCons)

      case ('TRAC')
        !                                                              *
        !***** TRAC ****************************************************
        !                                                              *
        Track = .true.

      case ('TS  ')
        !                                                              *
        !***** TS   ****************************************************
        !                                                              *
        iOptC = ibclr(iOptC,7)

      case ('TSCO')
        !                                                              *
        !***** TSCO ****************************************************
        !                                                              *
        LuTS = 20
        FilNam = 'TSC'
        LuTS = IsFreeUnit(LuTS)
        call Molcas_Open(LuTS,FilNam)
        do
          Key = Get_Ln(LuRd)
          call UpCase(Key)
          Key = adjustl(Key)
          write(LuTS,'(A)') trim(Key)
          if (Key(1:4) == 'END') exit
        end do
        close(LuTS)
        TSConstraints = .true.

      case ('VDWB')
        !                                                              *
        !***** VDWB VdW correction both coordinate and Hessian *********
        !                                                              *
        iOptC = ibset(iOptC,10)
        iOptC = ibset(iOptC,11)

      case ('VDWC')
        !                                                              *
        !***** VDWB VdW correction for coordinate only *****************
        !                                                              *
        iOptC = ibset(iOptC,11)

      case ('VDWH')
        !                                                              *
        !***** VDWB VdW correction for Hessian only ********************
        !                                                              *
        iOptC = ibset(iOptC,10)

      case ('WIND')
        !                                                              *
        !***** WIND ****************************************************
        !                                                              *
        do
          Chr = Get_Ln(LuRd)
          call UpCase(Chr)
          if ((Chr /= '') .and. (Chr(1:1) /= '*')) exit
        end do
        call Get_I1(1,nWndw)

      case default
        call WarningMessage(2,'Error in RdCtl_Slapaf')
        if (Chr(1:1) == ' ') then
          write(u6,*) ' RdCtl_Slapaf: Command line starts with a blank.'
        else
          write(u6,*)
          write(u6,*) ' *********** ERROR ***********'
          write(u6,*) ' The program has been supplied'
          write(u6,*) ' with an unknown command.     '
          write(u6,*) ' *****************************'
        end if
        write(u6,'(A)') Chr
        call Quit_OnUserError()

    end select
  end do
  !                                                                    *
  !*********************************************************************
  !**********************   End of input section   *********************
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Now start fixing constraints.
! First get the external constraints.

if (External_UDC) then
  call Merge_Constraints('UDC.Gateway','','UDC',nLambda,iRow_c)
else
  call Merge_Constraints('','UDC','UDC',nLambda,iRow_c)
end if

! Initial preprocessing

if (iRow_c > 1) then
  Lu_UDC = IsFreeUnit(20)
  call Molcas_Open(Lu_UDC,'UDC')
  call Preprocess_UDC(Lu_UDC,iPrint)
  close(Lu_UDC)
else
  NADC = .false.
end if

! Add NAC if needed

if (NADC) then
  Lu_UDCTMP = IsFreeUnit(20)
  call Molcas_Open(Lu_UDCTMP,'UDCTMP')
  write(Lu_UDCTMP,*) 'NADC = NAC'
  write(Lu_UDCTMP,*) 'VALUE'
  write(Lu_UDCTMP,*) 'NADC = 0.0'
  write(Lu_UDCTMP,*) 'END'
  close(Lu_UDCTMP)
  call Merge_Constraints('UDC','UDCTMP','UDC',nLambda,iRow_c)
end if

! Add MEP/IRC if needed

if (MEP .or. rMEP .or. (abs(IRC) == 1)) then
  if (abs(IRC) == 1) then
    MEPLab = 'IRC'
  else
    MEPLab = 'MEP'
  end if
  if (MEPCons .and. (.not. Expert)) then
    call WarningMessage(2,'Error in RdCtl_Slapaf')
    write(u6,*)
    write(u6,*) '***************** ERROR ********************'
    write(u6,*) ' There is a '//trim(Mep_Type)//' constraint that may'
    write(u6,*) ' conflict with '//MEPLab//' calculations.'
    write(u6,*) ' You should not explictly specify this constraint,'
    write(u6,*) ' but just rely on '//MEPLab//'Step/'//MEPLab//'Type keywords.'
    write(u6,*) ' If you really know what you are doing, you'
    write(u6,*) ' can use the EXPERT keyword.'
    write(u6,*) '********************************************'
    call Quit_OnUserError()
  end if
  WeightedConstraints = .true.
  Valu = dMEPStep
  if (MEP_Type == 'SPHERE') Valu = abs(Valu)
  if (MEP .and. (MEP_Algo == 'GS')) Valu = Half*Valu
  if (rMEP) Valu = max(real(iMEP+1,kind=wp),One)*Valu
  Lu_UDCTMP = IsFreeUnit(20)
  call Molcas_Open(Lu_UDCTMP,'UDCTMP')
  write(Lu_UDCTMP,*) MEPLab//' = '//MEP_Type
  write(Lu_UDCTMP,*) 'VALUE'
  write(Lu_UDCTMP,*) MEPLab//' = ',Valu
  write(Lu_UDCTMP,*) 'END'
  close(Lu_UDCTMP)
  call Merge_Constraints('UDC','UDCTMP','UDC',nLambda,iRow_c)
  Beta = min(Beta,abs(Valu))
  MEPnum = nLambda
end if

! Final fixes

call Fix_UDC(iRow_c,nLambda,nsAtom,nStab,.true.)
!                                                                      *
!***********************************************************************
!                                                                      *
! Initiate some variables which can only be set after the input has
! been read.

if ((.not. ThrInp) .and. (.not. Baker)) ThrEne = Zero

call Init2()

! Gradients are not needed at the first iteration of a numerical
! Hessian procedure (and only that, i.e. MxItr=0)
FirstNum = (allocated(mRowH) .or. lNmHss .or. Cubic) .and. (Iter == 1) .and. (MxItr == 0)

if ((SuperName == 'slapaf') .and. (.not. FirstNum)) then

  if (Track) then
    call Process_Track()
  else
    call Put_iArray('Root Mapping',iDum,0)
  end if

  call Process_Gradients()

end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Put in the "Reaction vector" in Cartesians.
! Priority order:
! 1) Explicit by user input (REAC keyword)
! 2) Found on RunOld
! 3) Found on RunFile

if (abs(IRC) == 1) then

  ! If this is the first macro iteration in the IRC search then
  ! pick up the reaction vector.

  if (Explicit_IRC .and. (iMEP == 0)) then
    ! Case 1)
    MF(:,1:nsAtom) = reshape(TmpRx,[3,nsAtom])
  else if (iMEP == 0) then
    call NameRun('RUNOLD')
    call qpg_dArray('Reaction Vector',Found,nRx)
    !write(u6,*) 'RUNOLD: Found=',Found
    if (Found) then
      ! Case 2)
      call Get_dArray('Reaction Vector',MF,3*nsAtom)
      call NameRun('#Pop')
    else
      call NameRun('#Pop')
      call qpg_dArray('Reaction Vector',Found,nRx)
      !write(u6,*) 'RUNFILE: Found=',Found
      if (Found) then
        ! Case 3)
        call Get_dArray('Reaction Vector',MF,3*nsAtom)
      else
        call WarningMessage(2,'Error in RdCtl_Slapaf')
        write(u6,*)
        write(u6,*) '************ ERROR **************'
        write(u6,*) 'IRC calculation but no IRC vector'
        write(u6,*) '*********************************'
        call Quit_OnUserError()
      end if
    end if
  end if

  ! Fix the direction forward/backwards

  if ((iMEP == 0) .and. (iRC == -1)) MF(:,1:nsAtom) = -MF(:,1:nsAtom)
  if ((iMEP == 0) .and. (MEP_Type == 'TRANSVERSE')) call Put_dArray('Transverse',MF,3*nsAtom)

end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (FindTS .and. (.not. TSConstraints)) call SysWarnMsg('RdCtl_Slapaf','WARNING:','FindTS specified, but no TSConstraints. '// &
                                                        'It is highly recommended to use TSConstraints in SLAPAF instead of '// &
                                                        '(or in addition to) global constraints when using FindTS. '// &
                                                        'TSConstraints will be lifted in the final TS search.')
TSConstraints = TSConstraints .and. FindTS

if ((MEP .or. rMEP) .and. (.not. Request_Alaska)) then

  ! If no initial direction given, use the gradient (force)

  call qpg_dArray('Transverse',Found,nRP)
  if (.not. Found) then
    ! Assume the initial reaction vector is already massaged
    if (Explicit_IRC) then
      call Put_dArray('Transverse',TmpRx,3*nsAtom)
    else
      ! The direction is given by the gradient, but in weighted coordinates
      call mma_allocate(Dir,3,nsAtom,Label='Dir')
      do iAtom=1,nsAtom
        xWeight = Weights(iAtom)
        Dir(:,iAtom) = Gx(:,iAtom,iter)/xWeight
      end do
      call Put_dArray('Transverse',Dir,3*nsAtom)
      call mma_deallocate(Dir)
    end if
  end if
end if

if (Explicit_IRC) call mma_deallocate(TmpRx)

! Activate MPS update of Hessian if FindTS

if (FindTS) then

  if (btest(iOptH,5)) then
    iOptH = ibset(0,5) ! EU
  else if (btest(iOptH,6)) then
    iOptH = ibset(0,6) ! TS-BFGS
  else
    iOptH = ibset(0,4) ! MSP
  end if
  iOptC = ibset(iOptC,12)

  ! Increase the update window so that we will not lose the update
  ! which generated the negative curvature.

  nWndw = 4*nWndw
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Modify some options if TS search

if (.not. btest(iOptC,7)) then
  if (.not. btest(iOptH,3)) iOptH = ibset(0,4) ! MSP
  Line_search = .false.
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! For TS optimization with the Saddle method set update to MSP

call qpg_dArray('Saddle',Found,nSaddle)
if (Found .and. (nSaddle /= 0)) then
  call mma_allocate(Tmp,nSaddle,Label='Tmp')
  call Get_dArray('Saddle',Tmp,nSaddle)
  HSR0 = Tmp(nSaddle-2)
  HSR = Tmp(nSaddle-1)
  Update = Tmp(nSaddle)
  if (Update == Two) then

    ! Enable FindTS procedure

    !write(u6,*) 'Enable FindTS procedure'
    if (.not. btest(iOptH,3)) iOptH = ibset(0,4) ! MSP
    nWndw = 4*nWndw
    ! make it look as if this were FindTS with constraints
    FindTS = .true.
    TSConstraints = .true.
    iOptC = ibset(iOptC,12)
    iOptC = ibset(iOptC,13)
    Beta = 0.1_wp

  else

    ! Normal constrained optimization with a reduced threshold.
    ! Let the threshold be somewhat tighter as we are close to the TS.

    if ((HSR/HSR0 < 0.2_wp) .or. (HSR < 0.2_wp)) then
      !ThrGrd = 0.0003_wp
      Beta = 0.1_wp
    else
      !ThrGrd = 0.003_wp
      ThrGrd = Ten*ThrGrd
    end if

    ! Add the constraints from the Saddle method

    call Merge_Constraints('UDC','UDC.Saddle','UDC',nLambda,iRow_c)

  end if
  call mma_deallocate(Tmp)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
nLbl = max(3*nsAtom+nLambda,iRow+iRow_c)
call mma_allocate(Lbl,nLbl,Label='Lbl')
!                                                                      *
!***********************************************************************
!                                                                      *
! Modify some options if constraints are part of the calculation.

if ((nLambda > 0) .or. TSConstraints) then
  iOptC = ibset(iOptC,8) ! Constraints
  Line_search = .false.
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! No iterations set iOptC=0

if (MxItr == 0) iOptC = 0
!                                                                      *
!***********************************************************************
!                                                                      *
! Activate some additional printing for numerical Hessian

!GGd: Coherency with patch 7.1.615 !      If (lNmHss) nPrint(122) = 10
!                                                                      *
!***********************************************************************
!                                                                      *
! Do some preprocessing due to input choice

if (Request_Alaska) nPrint(51) = 0
call PrePro(nsAtom,Cx(1,1,iter))
!                                                                      *
!***********************************************************************
!                                                                      *
! In case of Kriging we use a sorting step in update_sl. For this
! to work we need the values of the internal coordinates for more
! points than the window size. Here we increase it with a factor of
! 2 temporarily. The sorted list will still be of the original size.
! However, the default window for kriging is twice as large as
! for conventional calculations.

if (Kriging) then
  nWndw = 4*nWndw  ! 2*2=4

  ! No micro iterations the first MEP iteration

  if ((MEP .or. rMEP) .and. (iter == 1)) Max_Microiterations = 0

  ! Reduce default maximum dispersion during the initial
  ! stage of a FindTS calculation: we don't want to fulfil the
  ! constraints too early

  call Qpg_iScalar('TS Search',Found)
  if (Found) call Get_lScalar('TS Search',Found)
  if (FindTS .and. (.not. (Found .or. Manual_Beta))) Beta_Disp = 0.1_wp
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out input parameters, No output if we didn't find the proper
! gradients on the runfile. We will come back!!!

if ((SuperName == 'slapaf') .and. (.not. Request_Alaska)) call WrInp_sl()
!                                                                      *
!***********************************************************************
!                                                                      *
User_Def = iRow /= 0
if (.not. User_Def) nBVec = 1
!                                                                      *
!***********************************************************************
!                                                                      *
if (lNmHss .and. allocated(mRowH)) then
  call WarningMessage(2,'Error in RdCtl_Slapaf')
  write(u6,*)
  write(u6,*) '**************************************************'
  write(u6,*) ' ERROR: NUMErical and ROWH are mutually exclusive '
  write(u6,*) '**************************************************'
  call Quit_OnUserError()
end if
if (lCtoF .and. User_Def) then
  call WarningMessage(2,'Error in RdCtl_Slapaf')
  write(u6,*)
  write(u6,*) '******************************************'
  write(u6,*) ' ERROR: CtoF and User-defined Coordinates '
  write(u6,*) '        are mutually exclusive.           '
  write(u6,*) '******************************************'
  call Quit_OnUserError()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine RdCtl_Slapaf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GSTTBL(       C,     CTT,    IATP,    IASM,    IBTP,
     &                      IBSM,   IOCOC,  NOCTPA,  NOCTPB,   NSASO,
     &                     NSBSO,  PSSIGN,  ICOOSC,     IDC,  PLSIGN,
     &                       LUC,     SCR,   NSMST,  ISCALE,  SCLFAC)
*****************************************************************************
* Variables status:
* C     = input CI vector
* CTT   = output CI vector in SD format
* obtain  determinant block (iatp iasm, ibtp ibsm )
* from vector packed in combination format according to IDC
*
*. If ISCALE = 1, the routine scales and returns the block
*  in determinant notmalization, and SCLFAC = 1.0D0
*
* If ISCALE = 0, the routine does not perform any overall
* scaling, and a scale factor is returned in SCLFAC
*
* IF ISCALE = 0, zero blocks are not set explicitly to zero,
* instead  zero is returned in SCLFAC
*
* ISCALE, SCLFAC added May 97
*
      IMPLICIT REAL*8           (A-H,O-Z)
#include "io_util.fh"
      DIMENSION C(*),CTT(*),NSASO(NSMST, *),NSBSO(NSMST, *)
      DIMENSION IOCOC(NOCTPA,NOCTPB),ICOOSC(NOCTPA,NOCTPB,*)
      DIMENSION SCR(*)
      DIMENSION ISGVST(1)
      DIMENSION IDUMMY(1)
*
C?    write(6,*) ' GSTTBL  ,IATP,IASM,IBTP,IBSM,ISCALE'
C?    write(6,*)            IATP,IASM,IBTP,IBSM,ISCALE
* =================
* Read in from disc
* =================
      IF(LUC.NE.0) THEN
        CALL IDAFILE(LUC,2,IDUMMY,1,IDISK(LUC))
        LBL=IDUMMY(1)
        CALL IDAFILE(LUC,2,IDUMMY,1,IDISK(LUC))
C?      write(6,*) ' LBL = ', LBL
         IF(ISCALE.EQ.1) THEN
            CALL FRMDSC(     SCR,     LBL,      -1,     LUC,  IMZERO,
     &                   IAMPACK)
         ELSE
            NO_ZEROING = 1
            CALL FRMDSC2(     SCR,     LBL,      -1,     LUC,  IMZERO,
     &                    IAMPACK,NO_ZEROING)
         END IF
*
         IF(IMZERO.EQ.1.AND.ISCALE.EQ.0) THEN
            SCLFAC = 0.0D0
         ELSE
            NAST = NSASO(IASM,IATP)
            NBST = NSBSO(IBSM,IBTP)
            IF(LBL.NE.0) THEN
               CALL SDCMRF(     CTT,     SCR,       2,    IATP,    IBTP,
     &                         IASM,    IBSM,    NAST,    NBST,     IDC,
     &                       PSSIGN,  PLSIGN,  ISGVST,    LDET,   LCOMB,
     &                       ISCALE,  SCLFAC)
            ELSE
               SCLFAC = 0.0D0
            END IF
         END IF
*
C?      WRITE(6,*) ' ISCALE and SCLFAC on return in GSTTBL',
C?   &  ISCALE,SCLFAC

*. ISGVST and PLSIGN missing to make it work for IDC = 3,4
      ELSE
* =================
* Pack out from C
* =================
         IF(ISCALE.EQ.0) THEN
            WRITE(6,*) ' GSTTBL : LUC = 0 and ISCALE = 0'
            WRITE(6,*) ' I will scale as normal '
            SCLFAC = 1.0D0
         END IF
* Permutation sign
*. To get rid of annoying compiler warning
         PSIGN = 0.0D0
         IF(IDC.EQ.2) THEN
            PSIGN = PSSIGN
         ELSE IF(IDC .EQ. 3 ) THEN
            PSIGN = PLSIGN
         END IF
         PLSSGN = PLSIGN * PSSIGN
* check for different packing possibilities and unpack
         IF(IASM.GT.IBSM.OR.IDC.EQ.1
     &        .OR.(IDC.EQ.3.AND.IASM.GE.IBSM))THEN
**************
** IASM > IBSM
**************
            IF ( IDC.LT.4 ) THEN
*. Simple copy
               IBASE = ICOOSC(IATP,IBTP,IASM)
               NELMNT = NSASO(IASM,IATP)*NSBSO(IBSM,IBTP)
               CALL COPVEC(C(IBASE),CTT,NELMNT)
C?       write(6,*) ' simple copy IBASE NELMNT ',IBASE,NELMNT
C?       CALL WRTMAT(CTT,NSASO(IASM,IATP),NSBSO(IBSM,IBTP),
C?   &   NSASO(IASM,IATP),NSBSO(IBSM,IBTP))
cidc            ELSE IF( IDC.EQ.4 ) THEN
*. MLMS packed
c               IF(IATP.GT.IBTP) THEN
c                  IBASE = ICOOSC(IATP,IBTP,IASM)
c                  NELMNT = NSASO(IASM,IATP)*NSBSO(IBSM,IBTP)
c                  CALL COPVEC(C(IBASE),CTT,NELMNT)
c               ELSE IF(IATP.EQ.IBTP) THEN
c                  IBASE = ICOOSC(IATP,IATP,IASM)
c                  NAST = NSASO(IASM,IATP)
c                  CALL TRIPK3(CTT,C(IBASE),2,NAST,NAST,PLSIGN*PSSIGN)
c               ELSE IF( IATP.LT.IBTP) THEN
c                  IBASE = ICOOSC(IBTP,IATP,IASM)
c                  NROW  = NSASO(IASM,IBTP)
c                  NCOL  = NSBSO(IBSM,IATP)
c                  CALL TRPMT3(C(IBASE),NROW,NCOL,CTT)
c                  NELMNT = NROW*NCOL
c                  CALL SCALVE(CTT,PLSIGN*PSSIGN,NELMNT)
cidc               END IF
            END IF
         ELSE IF( IASM.EQ.IBSM) THEN
**************
** IASM = IBSM
**************
            IF(IATP.GT.IBTP.OR.IDC.EQ.3) THEN
*.. simple copying
               IBASE = ICOOSC(IATP,IBTP,IASM)
               NELMNT = NSASO(IASM,IATP)*NSBSO(IBSM,IBTP)
               CALL COPVEC(C(IBASE),CTT,NELMNT)
            ELSE IF( IATP.EQ.IBTP) THEN
*.. expand triangular packed matrix
               IBASE = ICOOSC(IATP,IBTP,IASM)
               NAST = NSASO(IASM,IATP)
               CALL TRIPK3(     CTT,C(IBASE),       2,    NAST,    NAST,
     &                       PSSIGN)
            ELSE IF( IATP .LT. IBTP) THEN
*.. transpose ibtp iasm iatp ibsm block
               IBASE = ICOOSC(IBTP,IATP,IASM)
               NRI = NSASO(IASM,IBTP)
               NCI = NSBSO(IASM,IATP)
               CALL TRPMT3(C(IBASE),NRI,NCI,CTT)
               IF(PSSIGN.EQ.-1.0D0) CALL SCALVE(CTT,-1.0D0,NRI*NCI)
            END IF
         ELSE IF( IASM .LT. IBSM ) THEN
**************
** IASM < IBSM
**************
*.. transpose ibtp ibsm iatp iasm block
            IF(IDC.LT.4) THEN
               IBASE = ICOOSC(IBTP,IATP,IBSM)
               NRI = NSASO(IBSM,IBTP)
               NCI = NSBSO(IASM,IATP)
               IF( IDC.EQ.2) THEN
                  CALL TRPMT3(C(IBASE),NRI,NCI,CTT)
c               ELSE IF( IDC.EQ.3) THEN
c                  CALL COPVEC(C(IBASE),CTT,NRI*NCI)
               END IF
               IF(PSIGN.EQ.-1.0D0) CALL SCALVE(CTT,-1.0D0,NRI*NCI)
cidc            ELSE IF ( IDC .EQ. 4 ) THEN
c               IF(IBTP.GT.IATP) THEN
c                  IBASE = ICOOSC(IBTP,IATP,IBSM)
c                  NRI = NSASO(IBSM,IBTP)
c                  NCI = NSBSO(IASM,IATP)
c                  CALL TRPMT3(C(IBASE),NRI,NCI,CTT)
c                  IF(PSSIGN.EQ.-1.0D0) CALL SCALVE(CTT,-1.0D0,NRI*NCI)
c               ELSE IF (IBTP.EQ.IATP) THEN
c                  IBASE = ICOOSC(IBTP,IATP,IBSM)
c                  NRI   = NSASO(IBSM,IATP)
c                  NCI   = NSBSO(IASM,IATP)
c                  CALL TRIPK3(CTT,C(IBASE),2,NRI,NCI,PLSSGN)
c                  IF(PLSIGN.EQ.-1.0D0) CALL SCALVE(CTT,-1.0D0,NRI*NCI)
c               ELSE IF( IBTP.LT.IATP) THEN
c                  IBASE = ICOOSC(IATP,IBTP,IBSM)
c                  NELMNT = NSASO(IBSM,IATP)*NSBSO(IASM,IBTP)
c                  CALL COPVEC(C(IBASE),CTT,NELMNT)
cidc                  IF(PLSIGN.EQ.-1.0D0) CALL SCALVE(CTT,-1.0D0,NELMNT)
c               END IF
            END IF
         END IF
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer_array(IOCOC)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine change1_cvb()

use casvb_global, only: kbasis, mnion, mxion, nalf, nbet, nconf, ndetvb, nel, norb, nvb
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: changed
integer(kind=iwp), external :: nvb_cvb
logical(kind=iwp), external :: chpcmp_cvb ! ... Change of dimensioning variables ...

! Arrays for determinant handling (E_ij) and definition of VB wavefunction:
changed = .false.
if (chpcmp_cvb(norb)) changed = .true.
if (chpcmp_cvb(nalf)) changed = .true.
if (chpcmp_cvb(nbet)) changed = .true.
if (chpcmp_cvb(nel)) changed = .true.

if (changed) call touch_cvb('CASPRINT')

if (chpcmp_cvb(nconf)) changed = .true.

if (.not. changed) call cnfchk_cvb()
nvb = nvb_cvb(kbasis)

if (chpcmp_cvb(ndetvb)) changed = .true.
if (chpcmp_cvb(mxion)) changed = .true.
if (chpcmp_cvb(mnion)) changed = .true.
if (changed) call touch_cvb('MEM1')

return

end subroutine change1_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE EXTRROW(INMAT,IROW,NROW,NCOL,IOUTVEC)
*
* Extract row IROW from integer matrix INMAT
*
* Jeppe Olsen, Winter 1996
*
      IMPLICIT REAL*8(A-H,O-Z)
*
      DIMENSION INMAT(NROW,NCOL)
      DIMENSION IOUTVEC(NCOL)
*
      DO ICOL = 1, NCOL
        IOUTVEC(ICOL) = INMAT(IROW,ICOL)
      END DO
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Output vector from EXTRROW '
        WRITE(6,*) ' Extracted ROW ', IROW
        CALL IWRTMA(IOUTVEC,1,NCOL,1,NCOL)
      END IF
*
      RETURN
      END
C !!! Start trace !!!

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Victor P. Vysotskiy                              *
!***********************************************************************

subroutine NIdiag_New(H,U,n,nv)
!***********************************************************************
!                                                                      *
! This routine is a wrapper that calls appropriate LAPACK routines to  *
! perform diagonalization of symmetric matrices stored in lower        *
! triangular form.                                                     *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Victor P. Vysotskiy                                         *
!          Lund university, Sweden                                     *
! Written  2013                                                        *
!                                                                      *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, r8
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
!----------------------------------------------------------------------*
! Dummy arguments                                                      *
! n    - Dimension of matrix                                           *
! nv   - Length of eigenvectors nv>=n                                  *
! H    - Matrix to be diagonalized                                     *
! U    - Eigenvectors                                                  *
!----------------------------------------------------------------------*
integer(kind=iwp), intent(in) :: n, nv
real(kind=wp), intent(inout) :: H(*)
real(kind=wp), intent(out) :: U(nv,n)
!----------------------------------------------------------------------*
! Local variables                                                      *
!----------------------------------------------------------------------*
integer(kind=iwp) :: lrwrk, liwrk, lh, info, I, M
real(kind=wp) :: abstol
integer(kind=iwp), allocatable :: IPSZ(:), IWRK(:)
real(kind=wp), allocatable :: DIA(:), EVL(:), HDUP(:), OFF(:), RWRK(:), TAU(:)
real(kind=r8), external :: dlamch_
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
if (n == 0) return
#ifdef _DEBUGPRINT_
write(u6,*) 'New nidiag'
#endif
call FZero(U,nv*n)

lh = n*(n+1)/2
liwrk = 10*n
lrwrk = 20*n

call mma_allocate(DIA,n,label='DIA')
call mma_allocate(EVL,n,label='EVL')
call mma_allocate(OFF,n-1,label='OFF')
call mma_allocate(TAU,n-1,label='TAU')
call mma_allocate(IPSZ,2*n,label='IPSZ')
call mma_allocate(IWRK,liwrk,label='IWRK')
call mma_allocate(RWRK,lrwrk,label='RWRK')
call mma_allocate(HDUP,lh,label='HDUP')

call dcopy_(lh,H,1,HDUP,1)

info = 0
call dsptrd_('U',n,HDUP,DIA,OFF,TAU,info)

if (info /= 0) then
# ifdef _DEBUGPRINT_
  write(u6,'(A,I4)') 'Failed to tridiagonalize matrix',info
# endif
else

# if defined(_ACML_) && defined(__PGI)
  call ILAENVSET(10,'X','X',0,0,0,0,1,INFO)
  call ILAENVSET(11,'X','X',0,0,0,0,1,INFO)
# endif
  abstol = dlamch_('Safe minimum')
  info = 0
  call dstevr_('V','A',n,DIA,OFF,Zero,Zero,0,0,abstol,M,EVL,U,nv,IPSZ,RWRK,lrwrk,IWRK,liwrk,info)

  if (info /= 0) then
#   ifdef _DEBUGPRINT_
    write(u6,'(A,I4)') 'Failed to diagonalize matrix',info
#   endif
  else

    call dopmtr_('Left','U','N',N,N,HDUP,TAU,U,nv,RWRK,info)

    if (info /= 0) then
#     ifdef _DEBUGPRINT_
      write(u6,'(A,I4)') 'Failed to back transform vectors',info
#     endif
    else

      call dcopy_(lh,HDUP,1,H,1)

      do I=1,N
        H((I*(I+1))/2) = EVL(I)
      end do
    end if
  end if
end if

call mma_deallocate(DIA)
call mma_deallocate(EVL)
call mma_deallocate(OFF)
call mma_deallocate(TAU)
call mma_deallocate(IPSZ)
call mma_deallocate(IWRK)
call mma_deallocate(RWRK)
call mma_deallocate(HDUP)

if (info /= 0) then
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'Using the old Givens rot. based routine'
# endif
  call NIdiag(H,U,n,nv)
end if

do i=1,n
  Call VecPhase(U(1,i),nv)
end do
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
return

end subroutine NIdiag_New

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine mkorbperm2_cvb(orbs,cvb,owrk,cvbdet)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "spinb_cvb.fh"
      dimension orbs(norb,norb),cvb(nvb)
      dimension owrk(norb,norb),cvbdet(ndetvb)

      if(ip(1).ge.1)then
        write(6,'(/,a)')' Permuting orbitals :'
        write(6,'(1x,30i4)')(iorbprm(iorb),iorb=1,norb)
      endif
      do 100 iorb=1,norb
      jorb=abs(iorbprm(iorb))
      sgn=dble(sign(1,iorbprm(iorb)))
      call fmove_cvb(orbs(1,jorb),owrk(1,iorb),norb)
      call dscal_(norb,sgn,owrk(1,iorb),1)
100   continue
      call fmove_cvb(owrk,orbs,norb*norb)
      call str2vbc_cvb(cvb,cvbdet)
      call permvb_cvb(cvbdet,iorbprm)
      call vb2strc_cvb(cvbdet,cvb)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2000, Roland Lindh                                *
************************************************************************
      SubRoutine PrRF(DSCF,NonEq,iCharge,jPrint)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*                                                                      *
*             Modified for Langevin polarizabilities, Marsk 2000 (RL)  *
************************************************************************
      use External_Centers, only: nXF, iXPolType
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
      Logical DSCF, NonEq
      Integer StrnLn
*
*
      IF (jPrint.GE.2) THEN
      If (lRF.and..Not.PCM.and.lRFCav) Then
         Write (6,*)
         Write (6,'(5X,A)')
     &       'Reaction Field calculation: the Kirkwood model'
         Write (6,'(5X,A,E10.3)') ' Dielectric Constant :',Eps
         Write (6,'(5X,A,E10.3)') ' Eps_opt             :',EpsInf
         Write (6,'(5X,A,E10.3)') ' Radius of Cavity(au):',rds
         Write (6,'(5X,A,I2)')    ' l_Max               :',lMax
         If (NonEq) Then
            Write (6,'(5X,A)')
     &               ' Calculation type    : non-equilibrium'
         Else
            Write (6,'(5X,A)')
     &               ' Calculation type    : equilibrium'
         End If
         Write (6,*)
      End If
      If (iXPolType.gt.0) Then
         Write (6,*)
         Write (6,'(5X,A)') ' Explicit polarisabilities activated'
         Write (6,'(5X,A)') ' -----------------------------------'
         Write (6,'(5X,A,I2)')     ' Number of points    :',nXF
         If (iXPolType.eq.1) Then
            Write (6,'(5X,A)')
     &           ' Polarisabilities are isotropic'
         ElseIf (iXPolType.eq.2) Then
            Write (6,'(5X,A)')
     &           ' Polarisabilities are anisotropic'
         EndIf
         Write (6,*)
      EndIf
      If (lLangevin) Then
         Write (6,'(5X,A)') 'Langevin dipole moments activated'
         Write (6,'(5X,A,I2)')     ' Gitter type         :',latato
         Write (6,'(5X,A)')        ' Gitter centers'
         Do i = 1, latato
            Write (6,'(3(5x,F10.4))') (Cordsi(j,i),j=1,3)
         End Do
         Write (6,'(5X,A,E10.3)')  ' Max. Latt. Extn(au) :',radlat
         Write (6,'(5X,A,F10.4)')  ' Cell dimensions     :',scala
         Write (6,'(5X,A,F10.4)')  '                      ',scalb
         Write (6,'(5X,A,F10.4)')  '                      ',scalc
         Write (6,'(5X,A,F10.4)')  ' Overal scaling      :',scaaa
         Write (6,'(5X,A,F10.4)')  ' Site polarizability :',polsi
         Write (6,'(5X,A,F10.4)')  ' Site dipole moment  :',dipsi
         Write (6,'(5X,A,F10.4)')  ' Atoms in the latt.  :',gAtom
         Write (6,'(5X,A,F10.4)')  ' Diel. delete param. :',diedel
         Write (6,'(5X,A,F10.4)')  ' Inverse Boltzman f. :',tK
         Write (6,'(5X,A,E10.1)')  ' clim                :',clim
         Write (6,'(5X,A,F10.4)')  ' afac                :',afac
         Write (6,'(5X,A,I10  )')  ' nexp                :',nexpo
         Write (6,'(5X,A,F10.4)')  ' prefac              :',prefac
         Write (6,*)
      End If
      If (PCM) Then
         aArea = RSlPar(7)
         r_min_Sphere = RSlPar(3)
         Write (6,*)
         Write (6,'(5X,A)')
     &         ' Polarizable Continuum Model (PCM) activated'
         nSolvent=StrnLn(Solvent)
         Write (6,'(5X,A,A)')
     &         ' Solvent: ',Solvent(1:nSolvent)
         If (.Not.Conductor) Then
            Write (6,'(5X,A)') ' Version: Dielectric'
         Else
            Write (6,'(5X,A)') ' Version: Conductor'
         End If
         Write (6,'(5X,A,F6.4,A)')
     &               ' Average area for surface element on the '
     &             //'cavity boundary: ', aArea, ' Angstrom^2'
         Write (6,'(5X,A,F6.4,A)')
     &               ' Minimum radius for added spheres: ',
     &               r_min_Sphere, ' Angstrom'
         If (NonEq) Then
            Write (6,'(5X,A)')
     &               ' Calculation type: non-equilibrium'
     &             //' (slow component from JobOld)'
         Else
            Write (6,'(5X,A)')
     &               ' Calculation type: equilibrium'
         End If
         Write (6,*)
      End If
      ENDIF

      If (lRF) Call Init_RctFld(NonEq,iCharge)
      If (DSCF) Call Allok2
*
      Return
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CLagDXC_DP(iSym,nAS,nAshT,BDER,SDER,DG1,DG2,DF1,DF2,DEPSA,DEASUM,iLo,iHi,jLo,jHi,LDC,G1,G2,SC,SC2,lg_S)

use Index_Functions, only: iTri, nTri_Elem
use SUPERINDEX, only: MTUV
use caspt2_global, only: ipea_shift
use caspt2_module, only: EASUM, EPSA, NTUVES
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
#endif
use Constants, only: Zero, Four, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSym, nAS, nAshT, iLo, iHi, jLo, jHi, LDC, lg_S
real(kind=wp), intent(in) :: BDER((iHi-iLo+1)*(jHi-jLo+1)), SC((iHi-iLo+1)*(jHi-jLo+1)), SC2((iHi-iLo+1)*(jHi-jLo+1))
real(kind=wp), intent(inout) :: SDER((iHi-iLo+1)*(jHi-jLo+1)), DG1(nAshT,nAshT), DG2(nAshT,nAshT,nAshT,nAshT), DF1(nAshT,nAshT), &
                                DF2(nAshT,nAshT,nAshT,nAshT), DEPSA(nAshT,nAshT), DEASUM, G1(nAshT,nAshT), &
                                G2(nAshT,nAshT,nAshT,nAshT)
integer(kind=iwp) :: iLoS, ISADR, ISADR2, ITABS, ITUV, ITUVABS, iTWV, IUABS, IVABS, iWabs, IXABS, iXWZ, IXYZ, IXYZABS, IYABS, &
                     IZABS, jLoS, NROW
real(kind=wp) :: bsBDER, EU, EY, EYU, FACT, ValB, ValS
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: iHiS, irank, jHiS
#else
#include "macros.fh"
unused_var(lg_S)
#endif

! LDC == 0, if not parallel; SC is triangular
! LDC /= 0, if parallel    ; SC is square
! In both cases, BDER and SDER are square

ISADR = 0
NROW = 0
iLoS = 0
jLoS = 0
#ifdef _MOLCAS_MPP_
if (is_real_par()) then
  irank = 0
  call GA_Distribution(lg_S,iRank,iLoS,iHiS,jLoS,jHiS)
  NROW = jHiS-jLoS+1 !! = NAS
  call GA_GET(lg_S,jLoS,jHiS,iLoS,iHiS,SC2,NROW)
end if
#endif
do IXYZ=jLo,jHi
  IXYZABS = IXYZ+NTUVES(ISYM)
  IXABS = MTUV(1,IXYZABS)
  IYABS = MTUV(2,IXYZABS)
  IZABS = MTUV(3,IXYZABS)
  EY = EPSA(IYABS)
  do ITUV=iLo,iHi
    ITUVABS = ITUV+NTUVES(ISYM)
    ITABS = MTUV(1,ITUVABS)
    IUABS = MTUV(2,ITUVABS)
    IVABS = MTUV(3,ITUVABS)
    EU = EPSA(IUABS)
    EYU = EY+EU
    FACT = EYU-EASUM
    if (LDC == 0) then
      ISADR = 1+iTUV-iLo+NAS*(iXYZ-jLo)
    else
      ISADR = 1+iTUV-iLo+LDC*(iXYZ-jLo)
    end if
    ValB = BDER(ISADR)

    if ((iTUV == iXYZ) .and. (ipea_shift /= Zero)) then
      !! BC in the next equation refers to the active overlap
      !! ipea_shift*Half*BC(ISADR)*(Four-DREF(IDT)-DREF(IDV)+DREF(IDU))
      bsBDER = ipea_shift*Half*ValB
      SDER(iSAdr) = SDER(iSAdr)+bsBDER*(Four-G1(iTabs,iTabs)+G1(iUabs,iUabs)-G1(iVabs,iVabs))
      if (LDC == 0) then
        iSAdr2 = nTri_Elem(iTUV)
      else
        ISADR2 = 1+iTUV-iLo+LDC*(iTUV-jLo)
      end if
      DG1(iTabs,iTabs) = DG1(iTabs,iTabs)-bsBDER*SC(iSAdr2)
      DG1(iUabs,iUabs) = DG1(iUabs,iUabs)+bsBDER*SC(iSAdr2)
      DG1(iVabs,iVabs) = DG1(iVabs,iVabs)-bsBDER*SC(iSAdr2)
    end if

    !! First VALUE contribution in MKBC_DP (FACT)
    !if (LDC == 0) ISADR = iTri(ITUV,IXYZ)
    SDER(ISADR) = SDER(ISADR)+FACT*ValB
    ValS = SDER(ISADR)

    !! DEPSA can be computed simultaneously with the F3
    !! contributions, but remember that SC here is the overlap,
    !! whereas SC in FG3 subroutines are just G3 matrix
    if (ldc == 0) then
      do iWabs=1,nAshT
        iTWV = iTabs+nAshT*(iWabs-1)+nAshT**2*(iVabs-1)
        iSAdr2 = iTri(iTWV,iXYZ)
        DEPSA(iWabs,iUabs) = DEPSA(iWabs,iUabs)+ValB*SC(iSAdr2)

        iXWZ = iXabs+nAshT*(iWabs-1)+nAshT**2*(iZabs-1)
        iSAdr2 = iTri(iTUV,iXWZ)
        DEPSA(iWabs,iYabs) = DEPSA(iWabs,iYabs)+ValB*SC(iSAdr2)
      end do
    else
      !! assume SC has all columns (which is reasonable)
      !iTWV = iTabs+nAshT**2*(iVabs-1)
      !ISADR2 = 1+iTWV-jLoS+NROW*(iXYZ-iLoS)
      !call DaXpY_(nAshT,ValB,SC2(iSAdr2),nAshT,DEPSA(1,iUabs),1)
      !iXWZ = iXabs+nAshT**2*(iZabs-1)
      !ISADR2 = 1+iTUV-iLo+LDC*(iXWZ-jLo)
      !call DaXpY_(nAshT,ValB,SC(iSAdr2),LDC*nAshT,DEPSA(1,iYabs),1)
      do iWabs=1,nAshT
        !! we do not have all elements, so use distributed memory
        iTWV = iTabs+nAshT*(iWabs-1)+nAshT**2*(iVabs-1)
        ISADR2 = 1+iTWV-jLoS+NROW*(iXYZ-iLoS)
        DEPSA(iWabs,iUabs) = DEPSA(iWabs,iUabs)+ValB*SC2(iSAdr2)

        !! we have all elements, so local memory
        iXWZ = iXabs+nAshT*(iWabs-1)+nAshT**2*(iZabs-1)
        ISADR2 = 1+iTUV-iLo+LDC*(iXWZ-jLo)
        DEPSA(iWabs,iYabs) = DEPSA(iWabs,iYabs)+ValB*SC(iSAdr2)
      end do
    end if

    !! If non-parallel, overlap is triangular
    !! If parallel, the index is the same to that of SDER
    if (LDC == 0) iSAdr = iTri(iTUV,iXYZ)
    DEASUM = DEASUM-ValB*SC(iSAdr)

    ! dyu ( Fvztx - EPSA(u)*Gvztx )
    ! dyu Gvztx
    if (IYABS == IUABS) then
      !VALUE = VALUE+Two*(FP(IP)-EU*PREF(IP))
      DF2(iVabs,iZabs,iTabs,iXabs) = DF2(iVabs,iZabs,iTabs,iXabs)+ValB
      DG2(iVabs,iZabs,iTabs,iXabs) = DG2(iVabs,iZabs,iTabs,iXabs)-EU*ValB

      !VALUE = VALUE+Two*PREF(IP)
      DG2(iVabs,iZabs,iTabs,iXabs) = DG2(iVabs,iZabs,iTabs,iXabs)+ValS
    end if
    DEPSA(iYabs,iUabs) = DEPSA(iYabs,iUabs)-ValB*G2(iVabs,iZabs,iTabs,iXabs)

    ! dyx ( Fvutz - EPSA(y)*Gvutz )
    ! dyx Gvutz -> dut Gzyxv
    if (IYABS == IXABS) then
      !VALUE = VALUE+Two*(FP(IP)-EY*PREF(IP))
      DF2(iVabs,iUabs,iTabs,iZabs) = DF2(iVabs,iUabs,iTabs,iZabs)+ValB
      DG2(iVabs,iUabs,iTabs,iZabs) = DG2(iVabs,iUabs,iTabs,iZabs)-EY*ValB

      !VALUE = VALUE+Two*PREF(IP)
      DG2(iVabs,iUabs,iTabs,iZabs) = DG2(iVabs,iUabs,iTabs,iZabs)+ValS
    end if
    DEPSA(iYabs,iXabs) = DEPSA(iYabs,iXabs)-ValB*G2(iVabs,iUabs,iTabs,iZabs)

    ! dtu ( Fvxyz - EPSA(u)*Gvxyz + dyx Fvz -
    !        (EPSA(u)+EPSA(y)*dyz Gvz)
    ! dtu Gvxyz + dtu dyx Gvz
    if (ITABS == IUABS) then
      !VALUE = VALUE+Two*(FP(IP)-EU*PREF(IP))
      DF2(iVabs,iXabs,iYabs,iZabs) = DF2(iVabs,iXabs,iYabs,iZabs)+ValB
      DG2(iVabs,iXabs,iYabs,iZabs) = DG2(iVabs,iXabs,iYabs,iZabs)-EU*ValB

      !VALUE = VALUE+Two*PREF(IP)
      DG2(iVabs,iXabs,iYabs,iZabs) = DG2(iVabs,iXabs,iYabs,iZabs)+ValS
      if (IYABS == IXABS) then
        !VALUE = VALUE+FD(ID)-EYU*DREF(ID)
        DF1(iVabs,iZabs) = DF1(iVabs,iZabs)+ValB
        DG1(iVabs,iZabs) = DG1(iVabs,iZabs)-EYU*ValB

        !VALUE = VALUE+DREF(iTri(ID1,ID2))
        DG1(iVabs,iZabs) = DG1(iVabs,iZabs)+ValS
      end if
    end if
    DEPSA(iTabs,iUabs) = DEPSA(iTabs,iUabs)-ValB*G2(iVabs,iXabs,iYabs,iZabs)
    if (iYabs == iXabs) DEPSA(iTabs,iUabs) = DEPSA(iTabs,iUabs)-ValB*G1(iVabs,iZabs)
    if (iTabs == iUabs) DEPSA(iYabs,iXabs) = DEPSA(iYabs,iXabs)-ValB*G1(iVabs,iZabs)
  end do
# ifdef _MOLCAS_MPP_
  if (is_real_par() .and. (IXYZ == iHiS) .and. (iRank /= NPROCS-1)) then
    irank = irank+1
    call GA_Distribution(lg_S,iRank,iLoS,iHiS,jLoS,jHiS)
    call GA_GET(lg_S,jLoS,jHiS,iLoS,iHiS,SC2,NROW)
  end if
# endif
end do

return

end subroutine CLagDXC_DP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
SUBROUTINE matern(dh, m, d1, d2)
  use kriging_mod
  Implicit None
#include "stdalloc.fh"
  integer d1,d2,i
  REAL*8 a,d,dh(d1,d2),m(d1,d2)
  REAL*8, Allocatable :: d0(:,:)
  INTEGER*8 c
!
  Call mma_Allocate(d0,d1,d2,label="d0")
!
! For this expresion you can check https://en.wikipedia.org/wiki/Mat%C3%A9rn_covariance_function
! and equations (11) and (12) on ref.
  d0(:,:) = sqrt(dh)
  c = idint(pAI)
  a = Gamma(pAI+1)/Gamma(2*pAI+1)
  m = 0.0D0
  do i=0, c
    d=DBLE(i)
    m = m + (Gamma(pAI+1.0D0+d)/(Gamma(d+1.D0)*Gamma(pAI+1.0D0-d)))*(2.0D0*Sqrt(2.0D0*pAI+1.0D0)*d0)**(pAI-i)
  enddo
  m = a*m*exp(-sqrt(2.0D0*pAI+1)*d0)
!
  Call mma_deallocate(d0)
!
END SUBROUTINE matern

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine NrmClc(Vec,lth,SubNam,MatNam)
************************************************************************
*                                                                      *
*     purpose: compute and print out norms for debuging purposes       *
*                                                                      *
*     input:                                                           *
*       Vec     : vector whose norm is going to be computed (lth)      *
*       SumNam  : name of a subroutine it is called from               *
*       MatNam  : name of a matrix                                     *
*       DeBug   : T - print out norm                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
      Real*8 Vec(lth)
      Character SubNam*(*), MatNam*(*)
*
      R = DDot_(lth,Vec,1,Vec,1)
      Q = DDot_(lth,[1.0D0],0,Vec,1)
      S = 0.0D0
      Do i = 1, lth
         S = S + Vec(i)*DBLE(i)
      End Do
      Write(6,'(5A,3E24.16)')' Norm of ',MatNam,' in ',SubNam,' = ',
     &                        R,Q,S
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Kinetic_Exchange(N1,N2,M1,S1,M2,S2,eso1,eso2,tpar,upar,lant,OPT,HKEX,MR1,SR1,MR2,SR2)
! compute KE, within various options :
! the Ln site
!  N1, eso1, M1, S1, MR1, SR1
! the radical
!  N2, eso2, M2, S2, MR2, SR2
! exchange Hamiltonian
!  HKEX

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero, cOne
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: N1, N2, lant, OPT
complex(kind=wp), intent(in) :: M1(3,N1,N1), S1(3,N1,N1), M2(3,N2,N2), S2(3,N2,N2)
real(kind=wp), intent(in) :: eso1(N1), eso2(N2), tpar, upar
complex(kind=wp), intent(out) :: HKEX(N1,N1,N2,N2), MR1(3,N1,N1), SR1(3,N1,N1), MR2(3,N2,N2), SR2(3,N2,N2)
integer(kind=iwp) :: i, i1, i2, info, iprint, is1, is2, j, l
real(kind=wp) :: gtens(3,4), maxes(3,3,4)
complex(kind=wp) :: MM(3,2,2)
real(kind=wp), allocatable :: eloc1(:), eloc2(:), wcr(:)
complex(kind=wp), allocatable :: ABIT(:,:,:,:), H1(:,:), H1T(:,:), H2(:,:), HCOV(:,:), HEXC(:,:,:,:), MM1(:,:,:), SM1(:,:,:), &
                                 TMP(:), TMP2(:,:), TMP3(:,:), Z1(:,:), Z2(:,:), ZCR(:,:), ZZ1(:,:), ZZ2(:,:)

! determine the pseudospin on each site (Z1 and Z2):
iprint = 1
gtens(:,:) = 0.0_wp
maxes(:,:,:) = 0.0_wp
call mma_allocate(Z1,N1,N1,label='Z1')
call mma_allocate(Z2,N2,N2,label='Z2')
call pseudospin(M1,N1,Z1,3,1,iprint)
call pseudospin(M2,N2,Z2,3,1,iprint)
#ifdef _DEBUGPRINT_
call pa_prMat('KE_Exchange:: Pseudospin site 1',Z1,N1)
call pa_prMat('KE_Exchange:: Pseudospin site 2',Z2,N2)
#endif
! get the "traced-to-zero" local energy states on both sites:
call mma_allocate(eloc1,N1,label='eloc1')
call mma_allocate(eloc2,N1,label='eloc2')
call rtrace(N1,eso1,eloc1)
call rtrace(N2,eso2,eloc2)
call mma_allocate(H1,N1,N1,label='H1')
call mma_allocate(H2,N2,N2,label='H2')
H1(:,:) = cZero
H2(:,:) = cZero
do I2=1,N1
  do i=1,N1
    H1(:,I2) = H1(:,I2)+ELOC1(i)*conjg(Z1(i,:))*Z1(i,I2)
  end do
end do
do I2=1,N2
  do i=1,N2
    H2(:,I2) = H2(:,I2)+ELOC2(i)*conjg(Z2(i,:))*Z2(i,I2)
  end do
end do
call mma_deallocate(eloc1)
call mma_deallocate(eloc2)
call mma_allocate(HCOV,N1,N1,label='HCOV')
call mma_allocate(HEXC,N1,N1,N2,N2,label='HEXC')
if ((OPT == 1) .or. (OPT == 3) .or. (OPT > 4)) then ! full
  call KE_Covalent(N1,lant,tpar,upar,1,HCOV)
  call KE_Exchange(N1,N2,lant,tpar,upar,1,HEXC)
else if ((OPT == 2) .or. (OPT == 4)) then ! 1/U model
  call KE_Covalent(N1,lant,tpar,upar,2,HCOV)
  call KE_Exchange(N1,N2,lant,tpar,upar,2,HEXC)
end if

call mma_allocate(H1T,N1,N1,label='H1T')
call mma_allocate(TMP,max(N1,N2)**2,label='TMP')
H1T(:,:) = H1(:,:)+HCOV(:,:)
! rewrite the HCOV in the initial ab initio basis:
call ZGEMM_('N','N',N1,N1,N1,cOne,Z1,N1,HCOV,N1,cZero,TMP,N1)
call ZGEMM_('N','C',N1,N1,N1,cOne,TMP,N1,Z1,N1,cZero,HCOV,N1)
! rewrite the H1 in the initial ab initio basis:
call ZGEMM_('N','N',N1,N1,N1,cOne,Z1,N1,H1,N1,cZero,TMP,N1)
call ZGEMM_('N','C',N1,N1,N1,cOne,TMP,N1,Z1,N1,cZero,H1,N1)
! rewrite the H2 in the initial ab initio basis:
call ZGEMM_('N','N',N2,N2,N2,cOne,Z2,N2,H2,N2,cZero,TMP,N2)
call ZGEMM_('N','C',N2,N2,N2,cOne,TMP,N2,Z2,N2,cZero,H2,N2)
! rewrite the H1T in the initial ab initio basis:
call ZGEMM_('N','N',N1,N1,N1,cOne,Z1,N1,H1T,N1,cZero,TMP,N1)
call ZGEMM_('N','C',N1,N1,N1,cOne,TMP,N1,Z1,N1,cZero,H1T,N1)
! rewrite the HEXC in the initial ab initio basis:
do is1=1,N2
  do is2=1,N2
    call ZGEMM_('N','N',N1,N1,N1,cOne,Z1,N1,HEXC(:,:,is1,is2),N1,cZero,TMP,N1)
    call ZGEMM_('N','C',N1,N1,N1,cOne,TMP,N1,Z1,N1,cZero,HEXC(:,:,is1,is2),N1)
  end do
end do
do is1=1,N1
  do is2=1,N1
    call ZGEMM_('N','N',N2,N2,N2,cOne,Z2,N2,HEXC(is1,is2,:,:),N2,cZero,TMP,N2)
    call ZGEMM_('N','C',N2,N2,N2,cOne,TMP,N2,Z2,N2,cZero,HEXC(is1,is2,:,:),N2)
  end do
end do

call mma_deallocate(Z1)
call mma_deallocate(Z2)

call mma_allocate(ABIT,N1,N1,N2,N2,label='ABIT')
HKEX(:,:,:,:) = cZero
do i=1,N1
  do i1=1,N2
    ABIT(i,i,i1,i1) = H1(i,i)+H2(i1,i1)
  end do
end do
HKEX(:,:,:,:) = HEXC(:,:,:,:)+ABIT(:,:,:,:)
call mma_deallocate(ABIT)
call mma_deallocate(H1)
call mma_deallocate(H2)
call mma_deallocate(HCOV)
call mma_deallocate(HEXC)
! H1T = H1 + HCOV
call mma_allocate(wcr,N1,label='wcr')
call mma_allocate(zcr,N1,N1,label='zcr')
call diag_c2(H1T,N1,info,wcr,zcr)
do i=1,N1
  write(u6,'(2(A,i2,A,F15.9))') 'ESO1(',i,')=',ESO1(i),'  ESO1+COV(',i,')=',wcr(i)-wcr(1)
end do
do i=1,N1
  do j=1,N1
    write(u6,'(A,i2,A,i2,A,2F20.14)') 'ZCR(',i,',',j,')=',ZCR(i,j)
  end do
end do
call mma_deallocate(wcr)
call mma_deallocate(H1T)

! rotate to COV basis:
if ((opt == 3) .or. (opt == 4)) then
  do is1=1,N2
    do is2=1,N2
      call ZGEMM_('C','N',N1,N1,N1,cOne,ZCR,N1,HKEX(:,:,is1,is2),N1,cZero,TMP,N1)
      call ZGEMM_('N','N',N1,N1,N1,cOne,TMP,N1,ZCR,N1,cZero,HKEX(:,:,is1,is2),N1)
    end do
  end do
end if
! compute the g tensors for initial and initial+covalence:
call mma_allocate(MM1,3,N1,N1,label='MM1')
call mma_allocate(SM1,3,N1,N1,label='SM1')
MM(:,:,:) = M1(:,1:2,1:2)
call atens(MM,2,gtens(:,1),maxes(:,:,1),1)
MM(:,:,:) = M1(:,3:4,3:4)
call atens(MM,2,gtens(:,2),maxes(:,:,2),1)
call mma_allocate(TMP2,N1,N1,label='TMP2')
do L=1,3
  TMP2(:,:) = M1(L,:,:)
  call ZGEMM_('C','N',N1,N1,N1,cOne,ZCR,N1,TMP2,N1,cZero,TMP,N1)
  call ZGEMM_('N','N',N1,N1,N1,cOne,TMP,N1,ZCR,N1,cZero,TMP2,N1)
  MM1(L,:,:) = TMP2(:,:)
  TMP2(:,:) = S1(L,:,:)
  call ZGEMM_('C','N',N1,N1,N1,cOne,ZCR,N1,TMP2,N1,cZero,TMP,N1)
  call ZGEMM_('N','N',N1,N1,N1,cOne,TMP,N1,ZCR,N1,cZero,TMP2,N1)
  SM1(L,:,:) = TMP2(:,:)
end do
call mma_deallocate(zcr)
call mma_deallocate(TMP2)
MM(:,:,:) = MM1(:,1:2,1:2)
call atens(MM,2,gtens(:,3),maxes(:,:,3),1)
MM(:,:,:) = MM1(:,3:4,3:4)
call atens(MM,2,gtens(:,4),maxes(:,:,4),1)
write(u6,'(A)') 'Initial g tensors of the ground and first excited KD'
do i=1,2
  write(u6,'((A,F12.6,A,3F12.7))') 'gX=',gtens(1,i),' axis X: ',(maxes(j,1,i),j=1,3)
  write(u6,'((A,F12.6,A,3F12.7))') 'gY=',gtens(2,i),' axis Y: ',(maxes(j,2,i),j=1,3)
  write(u6,'((A,F12.6,A,3F12.7))') 'gZ=',gtens(3,i),' axis Z: ',(maxes(j,3,i),j=1,3)
  write(u6,*)
end do
write(u6,'(A)') 'Initial+Covalence g tensors of the ground and first excited KD'
do i=3,4
  write(u6,'((A,F12.6,A,3F12.7))') 'gX=',gtens(1,i),' axis X: ',(maxes(j,1,i),j=1,3)
  write(u6,'((A,F12.6,A,3F12.7))') 'gY=',gtens(2,i),' axis Y: ',(maxes(j,2,i),j=1,3)
  write(u6,'((A,F12.6,A,3F12.7))') 'gZ=',gtens(3,i),' axis Z: ',(maxes(j,3,i),j=1,3)
  write(u6,*)
end do
!------
if ((opt == 3) .or. (opt == 4)) then
  ! rotate the magnetic moment to the coordinate
  ! system of main magnetic axes on Ln
  call rotmom2(SM1,N1,maxes(:,:,3),SR1)
  call rotmom2(MM1,N1,maxes(:,:,3),MR1)
  call rotmom2(S2,N2,maxes(:,:,3),SR2)
  call rotmom2(M2,N2,maxes(:,:,3),MR2)
  ! find the local pseudospins on both sites:
  call mma_allocate(ZZ1,N1,N1,label='ZZ1')
  call mma_allocate(ZZ2,N2,N2,label='ZZ2')
  call pseudospin(MR1,N1,ZZ1,3,1,iprint)
  call pseudospin(MR2,N2,ZZ2,3,1,iprint)
# ifdef _DEBUGPRINT_
  call pa_prMat('KE_Exchange:: Pseudospin site 1',ZZ1,N1)
  call pa_prMat('KE_Exchange:: Pseudospin site 2',ZZ2,N2)
# endif
  call mma_allocate(TMP2,N1,N1,label='TMP2')
  call mma_allocate(TMP3,N2,N2,label='TMP3')
  ! rewrite the magnetic moments and spin moments in new local bases:
  do L=1,3
    TMP2(:,:) = MR1(L,:,:)
    call ZGEMM_('C','N',N1,N1,N1,cOne,ZZ1,N1,TMP2,N1,cZero,TMP,N1)
    call ZGEMM_('N','N',N1,N1,N1,cOne,TMP,N1,ZZ1,N1,cZero,TMP2,N1)
    MR1(L,:,:) = TMP2(:,:)
    TMP2(:,:) = SR1(L,:,:)
    call ZGEMM_('C','N',N1,N1,N1,cOne,ZZ1,N1,TMP2,N1,cZero,TMP,N1)
    call ZGEMM_('N','N',N1,N1,N1,cOne,TMP,N1,ZZ1,N1,cZero,TMP2,N1)
    SR1(L,:,:) = TMP2(:,:)

    TMP3(:,:) = MR2(L,:,:)
    call ZGEMM_('C','N',N2,N2,N2,cOne,ZZ2,N2,TMP3,N2,cZero,TMP,N2)
    call ZGEMM_('N','N',N2,N2,N2,cOne,TMP,N2,ZZ2,N2,cZero,TMP3,N2)
    MR2(L,:,:) = TMP3(:,:)
    TMP3(:,:) = SR2(L,:,:)
    call ZGEMM_('C','N',N2,N2,N2,cOne,ZZ2,N2,TMP3,N2,cZero,TMP,N2)
    call ZGEMM_('N','N',N2,N2,N2,cOne,TMP,N2,ZZ2,N2,cZero,TMP3,N2)
    SR2(L,:,:) = TMP3(:,:)
  end do
  ! rewrite the exchnage matrix in the basis of local pseudospins:
  do is1=1,N2
    do is2=1,N2
      call ZGEMM_('C','N',N1,N1,N1,cOne,ZZ1,N1,HKEX(:,:,is1,is2),N1,cZero,TMP,N1)
      call ZGEMM_('N','N',N1,N1,N1,cOne,TMP,N1,ZZ1,N1,cZero,HKEX(:,:,is1,is2),N1)
    end do
  end do
  do is1=1,N1
    do is2=1,N1
      TMP3(:,:) = HKEX(is1,is2,:,:)
      call ZGEMM_('C','N',N2,N2,N2,cOne,ZZ2,N2,TMP3,N2,cZero,TMP,N2)
      call ZGEMM_('N','N',N2,N2,N2,cOne,TMP,N2,ZZ2,N2,cZero,TMP3,N2)
      HKEX(is1,is2,:,:) = TMP3(:,:)
    end do
  end do
  call mma_deallocate(ZZ1)
  call mma_deallocate(ZZ2)
  call mma_deallocate(TMP2)
  call mma_deallocate(TMP3)
else !opt=1, opt=2, and opt>4
  MR1(:,:,:) = M1(:,:,:)
  SR1(:,:,:) = S1(:,:,:)
  MR2(:,:,:) = M2(:,:,:)
  SR2(:,:,:) = S2(:,:,:)
end if

call mma_deallocate(MM1)
call mma_deallocate(SM1)
call mma_deallocate(TMP)

return

end subroutine Kinetic_Exchange

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

       SUBROUTINE FindMax(ipLaJ,transa,numA,numJ,ipMaxJ)

       Implicit Real*8 (a-h,o-z)
       Integer  ipLaJ,numA,numJ,ipMaxJ
       character*1 transA

#include "WrkSpc.fh"


       If (transA.eq.'N') Then

          Do jvc=1,numJ

             iLaJ = ipLaJ + numA*(jvc-1)

             XMax = abs(Work(iLaJ))

             Do ia=2,numA

                XMax = Max(XMax,abs(Work(iLaJ+ia-1)))

             End Do

             Work(ipMaxJ+jvc-1) = XMax

          End Do

       ElseIf (transA.eq.'T') Then

          Do jvc=1,numJ

             iLaJ = ipLaJ + jvc - 1

             XMax = abs(Work(iLaJ))

             Do ia=2,numA

                XMax = Max(XMax,abs(Work(iLaJ+numJ*(ia-1))))

             End Do

             Work(ipMaxJ+jvc-1) = XMax

          End Do

       Else

          write(6,*)'FindMax: wrong input argument, transA= ',transA
          Call Abend

       EndIf


       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dBuu(uM12,nQQ,nDim,g,Hss,Inv)

use Slapaf_Info, only: dBM, idBM, mq, nqBM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nQQ, nDim
real(kind=wp), intent(in) :: uM12(nDim), g(nQQ)
real(kind=wp), intent(inout) :: Hss(nDim,nDim)
logical(kind=iwp), intent(in) :: Inv
integer(kind=iwp) :: i, i_Dim, idB, iElem, iq, iQQ, jDim, nElem
real(kind=wp) :: dBqR
real(kind=wp), allocatable :: K(:,:), Temp(:,:), Y(:)

if (.not. allocated(dBM)) then
  Hss(:,:) = Zero
  return
end if

call mma_allocate(Y,mq,Label='Y')
call mma_allocate(K,mq,nQQ,Label='K')
call Get_dArray('K',K,mq*nQQ)

! Compute Y(qR) = Sum_(Q) g(Q) rK(qR,Q)

Y(:) = Zero
do iQQ=1,nQQ
  Y(:) = Y(:)+g(iQQ)*K(:,iQQ)
end do
call mma_deallocate(K)

! Compute Temp = Sum_(qR) Y(qR) * dB(qR)

call mma_allocate(Temp,nDim,nDim,Label='Temp')
Temp(:,:) = Zero

idB = 1
do iq=1,mq
  nElem = nqBM(iq)
  do iElem=idB,idB+(nElem**2)-1
    dBqR = dBM(iElem)
    i_Dim = idBM(1+(iElem-1)*2)
    jDim = idBM(2+(iElem-1)*2)
    Temp(i_Dim,jDim) = Temp(i_Dim,jDim)+Y(iq)*dBqR
  end do
  idB = idB+nElem**2
end do
call mma_deallocate(Y)

if (Inv) Temp(:,:) = -Temp(:,:)

do i=1,nDim
  Hss(:,i) = Hss(:,i)+Temp(:,i)/sqrt(uM12(:)*uM12(i))
end do

call mma_deallocate(Temp)

return

end subroutine dBuu

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
************************************************************************
      Subroutine Update_inner(kIter,Beta,Beta_Disp,Step_Trunc,nWndw,
     &                        mIter,Kriging_Hessian,qBeta,iOpt_RS,
     &                        First_MicroIteration,Iter,qBeta_Disp)
************************************************************************
*     Object: to update coordinates                                    *
*                                                                      *
*    Input:                                                            *
*      kIter          : iteration counter                              *
*      Beta           : damping factor step length                     *
*      Beta_Disp      : damping factor variance                        *
*                                                                      *
*    OutPut:                                                           *
*      Step_Trunc     : character label to denote truncation type      *
*                                                                      *
*                                                                      *
*     Author: Roland Lindh                                             *
*             2000                                                     *
************************************************************************
      use Slapaf_info, only: GNrm, Lambda, Energy, qInt, dqInt, Shift,
     &                       BMx, Degen, nStab, Smmtrc, Lbl
      use Slapaf_Parameters, only: iRow_c, iInt, nFix, iOptH,
     &                             HrmFrq_Show, Curvilinear, FindTS,
     &                             nBVec, nDimBC, iOptC, iNeg,
     &                             TSConstraints, GNrm_Threshold, Mode,
     &                             GrdMax, StpMax, nLambda
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
      Integer iDum(1)
      Logical Found, Kriging_Hessian, First_MicroIteration
      Character Step_Trunc, File1*8, File2*8, Step_Trunc_
      Real*8, Allocatable:: Hessian(:,:), Wess(:,:), AMat(:),
     &                      RHS(:), ErrVec(:,:), EMtrx(:,:)
      Integer, Allocatable:: Index(:), iFlip(:)
      Real*8, Allocatable:: R(:,:), dRdq(:,:,:), CInt(:), CInt0(:),
     &                      T(:,:), d2L(:,:,:), BM(:,:), dBM(:,:,:),
     &                      Energy_L(:), dEdx(:,:), x(:,:), du(:),
     &                      dEdq(:,:), dx(:,:), dy(:), BVec(:,:),
     &                      Scr1(:), Scr2(:), Value(:), Value0(:),
     &                      Mult(:), dBVec(:), Tmp(:)
      Character(LEN=8), Allocatable:: Lbl_Tmp(:)
*                                                                      *
************************************************************************
*                                                                      *
* This option should careful debugged more.
*                                              RL December 2020
#define _NEW_CODE_
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _NEW_CODE_
      Real*8, Allocatable:: QC(:,:,:)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      nQQ = SIZE(qInt,1)
      nsAtom=SIZE(Degen,2)
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Lu=6
      Write (Lu,*)'Update_inner:iOpt_RS,Beta,Beta_Disp=',
     &                     iOpt_RS,Beta,Beta_Disp
      Call RecPrt('Update_inner: qInt',' ',qInt,nQQ,kIter)
      Call RecPrt('Update_inner: Shift',' ',Shift,nQQ,kIter-1)
      Call RecPrt('Update_inner: GNrm',' ',GNrm,kIter,1)
      Call RecPrt('Update_inner: Energy',' ',Energy,kIter,1)
      n1=3*nsAtom
      Call RecPrt('Update_inner: dQ/dx(BMx)',' ',BMx,n1,nQQ)
#endif
*
      GrdMax=Zero
      StpMax=Zero
*
      Step_Trunc='N'
      nA = (Max(nQQ,kIter)+1)**2
      Call mma_Allocate(AMat,nA,Label='AMat')
      Call mma_Allocate(Index,kIter,Label='Index')
      Call mma_Allocate(ErrVec,nQQ,(kIter+1),Label='ErrVec')
      Call mma_Allocate(EMtrx,kIter+1,kIter+1,Label='EMtrx')
      Call mma_Allocate(RHS,kIter+1)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Pick up the Hessian in internal coordinates and then update it
*     according to some Hessian update method (BFGS, MSP, etc.)
*
*
      If (Kriging_Hessian) Then
         iOptH_ = iOr(8,iAnd(iOptH,32))
      Else
         iOptH_ = iOptH
      End If
      Call mma_Allocate(Hessian,nQQ,nQQ,Label='Hessian')
      Call Get_dArray('Hss_Q',Hessian,nQQ**2)
*
*     Perform the Hessian update, in case of GEK it essentially will
*     modify the Hessian if it is needed to guide 2nd order
*     optimization towards a minimum or a TS.
*
#ifdef _DEBUGPRINT_
      Write (Lu,*)
      Write (Lu,*)
      Write (Lu,*) ' *** Updating the molecular Hessian ***'
      Write (Lu,*)
      jPrint=99
#else
      jPrint=5
#endif
      Call Update_H(nWndw,Hessian,nQQ,
     &              mIter,iOptC,
     &              Shift(1,kIter-mIter+1),dqInt(1,kIter-mIter+1),
     &              iOptH_,jPrint,GNrm(kIter),
     &              nsAtom,.True.,
     &              First_MicroIteration)
*
*     Call RecPrt('Update_inner: Hessian',' ',Hessian,nQQ,nQQ)
*     Write (6,*) 'After corrections'
*     Call DiagMtrx(Hessian,nQQ,jNeg)
*
*     Save the number of internal coordinates on the runfile.
*
      Call Put_iScalar('No of Internal coordinates',nQQ)
*
*     Save the force constant matrix on the runfile.
*
      Call Put_dArray('Hess',Hessian,nQQ**2)
*
*     Optional frequency analysis
*
      If (HrmFrq_Show) Call GF_on_the_fly(iDo_DipM)

*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*---- If this is a constrained optimization with the goal of finding a
*     transition state and we have one negative eigenvalue of the
*     Hessian then shift over to Mode Following RF to find the TS.
*
*     If TSConstraints were given, merge them with global constraints if
*     they exist, unless we are in TS regime.
*     If TS constraints were not given, remove global constraints when in
*     TS regime.
*
      Call qpg_darray('TanVec',Found,nRP)
      If (FindTS.and.First_MicroIteration) Then
         File1='UDC'
         File2='TSC'
         If (.not.TSConstraints) File2=''
         If (iNeg(1).ge.1) Then
            If ((GNrm(kIter).le.GNrm_Threshold).or.Found) Then
*              Change to MFRF optimization.
               Mask=1+2+4+8+16+32+64+256+512+1024+2048+8192
               iOptC=iAnd(iOptC,Mask)
               Call Put_lScalar('TS Search',.True.)
               If (TSConstraints) Then
                  File2=''
               Else
                  File1=''
               End If
            End If
         End If
         Call Merge_Constraints(File1,File2,'UDC',nLambda,iRow_c)
         Call Fix_UDC(iRow_c,nLambda,nsAtom,nStab,.False.)
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      If ( nLambda.eq.0) Then
         M=3*nsAtom
         N=nQQ
         NRHS=1
         Call mma_Allocate(Tmp,M,Label='Tmp:M')
*
*        Iterate to avoid too large displacement in cartesians.
*        If the maximum displacement is more than 2*Beta, reduce the step.
*
*        Initial setup to ensure fCart=1.0 at first iteration.
         rInter=Beta
         fCart=Ten
         rCart=fCart*rInter
         nLoop=0
         Do While (rCart.ge.Two*Beta)
            nLoop=nLoop+1
            If (nLoop.gt.10) Exit
            If (rCart.gt.rInter) Then
              fCart=fCart*rInter/rCart
            Else
              fCart=fCart*0.9D0
            End If
            nA = (Max(nQQ,kIter)+1)**2
*                                                                      *
************************************************************************
*                                                                      *
            gBeta=One
            xBeta=One
            gg_last=Beta
            dxdx_last=Beta
            Sf=Sqrt(Two)
            If (iOpt_RS.eq.0) Then
               kStart=Max(1,kIter-4)
               iEnd=kIter
            Else
               kStart=Max(1,Iter-4)
               iEnd=Iter
            End If
            Thr=1.0D-6
            Do iIter = kStart, iEnd
*
               If (iIter.ne.kIter) Then
                  dxdx=
     &             Sqrt(DDot_(nQQ,Shift(1,iIter),1,Shift(1,iIter),1))
*
                  If (dxdx.lt.0.75D0*dxdx_last.and.
     &                dxdx.lt.(Beta-Thr)) Then
*                    Increase trust radius
C                    xBeta=xBeta*Sf
                     xBeta=Min(Two,xBeta*Sf)
                  Else If (dxdx.gt.1.25D0*dxdx_last.or.
     &                     dxdx.ge.(Beta+Thr)) Then
*                    Reduce trust radius
                     xBeta=Max(One/Five,xBeta/Sf)
                  End If
                  dxdx_last=dxdx
               End If
*
               gg=Sqrt(DDot_(nQQ-nLambda,dqInt(:,iIter),1,
     &                                      dqInt(:,iIter),1))
               If (gg.lt.0.75D0*gg_last.and.gg.lt.(Beta-Thr)) Then
*                 Increase trust radius
C                 gBeta=gBeta*Sf
                  gBeta=Min(Two,gBeta*Sf)
               Else If (gg.gt.1.25D0*gg_last.or.gg.ge.(Beta+Thr)) Then
*                 Reduce trust radius
                  gBeta=Max(One/Five,gBeta/Sf)
               End If
               gg_last=gg
*
            End Do
            tBeta= Max(Beta*Min(xBeta,gBeta),Beta/Ten)
C           Write (6,*) 'tBeta=',tBeta
*                                                                      *
************************************************************************
*                                                                      *
*---------- Compute updated geometry in Internal coordinates
*
            fact=One
            qBeta=fCart*tBeta
            Thr_RS=1.0D-7
            Do
               Step_Trunc_=Step_Trunc
               Call Newq(qInt,nQQ,kIter,Shift,Hessian,dqInt,
     &                   ErrVec,EMtrx,RHS,
     &                   AMat,nA,
     &                   qBeta,nFix,Index,
     &                   Energy,Step_Trunc_,Thr_RS)
               If (Step_Trunc.eq.'N') Step_Trunc=' '
               If (iOpt_RS.eq.0) Then
                  If (Step_Trunc_.eq.'N') Step_Trunc_=' '
                  Step_Trunc=Step_Trunc_
                  Exit
               End If
               If (Step_Trunc//Step_Trunc_.eq.' *') Step_Trunc='.'
*
               qInt(:,kIter+1)=qInt(:,kIter)+Shift(:,kIter)
               Call Dispersion_Kriging_Layer(qInt(1,kIter+1),Disp,
     &                                       nQQ)
#ifdef _DEBUGPRINT_
               Write (6,*) 'Disp,Beta_Disp=',Disp,Beta_Disp
#endif
               fact=Half*fact
               qBeta=Half*qBeta
               If (One-disp/Beta_Disp.gt.1.0D-3) Exit
               If ((fact.lt.1.0D-5) .or. (disp.lt.Beta_Disp)) Exit
               Step_Trunc='*'
            End Do
#ifdef _DEBUGPRINT_
               Write (6,*) 'Step_Trunc=',Step_Trunc
#endif
*
            Call MxLbls(nQQ,dqInt(1,kIter),Shift(1,kIter),Lbl)
*
*---------- Set shift vector to zero for frozen internal coordinates.
*
            If (nFix.gt.0)
     &         Call dcopy_(nFix,[Zero],0,Shift(iInt+1,kIter),1)
*
*           Rough conversion to Cartesians
*
            Call Eq_Solver('T',M,N,NRHS,BMx,Curvilinear,Degen,
     &                     Shift(1,kIter),Tmp)
            rInter=Sqrt(dDot_(N,Shift(1,kIter),1,Shift(1,kIter),1))
            rCart=Zero
            Do i=1,nsAtom
               rCart=Max(rCart,
     &                   Sqrt(dDot_(3,Tmp(i),nsAtom,Tmp(i),nsAtom)))
            End Do
         End Do
         Call mma_deallocate(Tmp)
         Call Put_dScalar('Max error',Zero)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*        Optimization with constraints using Lagrangian technique.
*
*        Allocate memory for the new arrays
*
         Call mma_allocate(R,nLambda,kIter,Label='R')
         Call mma_allocate(dRdq,nQQ,nLambda,kIter,Label='dRdq')
         dRdq(:,:,:)=Zero
         Call mma_allocate(T,nQQ,nQQ,Label='T')
         T(:,:)=Zero
         Call mma_allocate(dy,nLambda,Label='dy')
         Call mma_allocate(dx,(nQQ-nLambda),kIter,Label='dx')
         dx(:,:)=Zero
         Call mma_allocate(dEdq,nQQ,kIter,Label='dEdQ')
         Call mma_allocate(du,nQQ,Label='du')
         Call mma_allocate(X,(nQQ-nLambda),(kIter+1),Label='X')
         X(:,:)=Zero
         call mma_allocate(dEdx,nQQ-nLambda,kIter,Label='dEdx')
         Call mma_allocate(Wess,nQQ-nLambda,nQQ-nLambda,
     &                     Label='Wess')
         Wess(:,:)=Zero
         Call mma_allocate(Energy_L,kIter,Label='Energy_L')
*
         Energy_L(:)=Energy(1:kIter)
*
         If (nQQ+nLambda.gt.SIZE(Lbl)) Then
            Call mma_allocate(Lbl_tmp,nQQ+nLambda,Label='Lbl_tmp')
            Lbl_tmp(:)=''
            Lbl_tmp(1:SIZE(Lbl))=Lbl(:)
            Call mma_deallocate(Lbl)
            Call mma_allocate(Lbl,nQQ+nLambda,Label='Lbl')
            Lbl(:)=Lbl_tmp(:)
            call mma_deallocate(Lbl_tmp)
         End If
*
         nBVec=iRow_c-nLambda-1
*
         n1=3*nsAtom
         Call mma_allocate(BM,n1,nLambda,Label='BM')
         Call mma_allocate(dBM,n1,n1,nLambda,Label='dBM')
*
         Call mma_allocate(BVec,3*nsAtom,nBVec,Label='BVec')
         Call mma_allocate(Value,nBVec,Label='Value')
         Call mma_allocate(Value0,nBVec,Label='Value0')
         Call mma_allocate(CInt,nLambda,Label='CInt')
         Call mma_allocate(CInt0,nLambda,Label='CInt0')
         Call mma_allocate(Mult,nBVec**2,Label='Mult')
         Call mma_allocate(iFlip,nBVec,Label='iFlip')
         Call mma_allocate(dBVec,nBVec*(3*nsAtom)**2,Label='dBVec')
*                                                                      *
************************************************************************
*                                                                      *
*        Compute the constraints
*                                                                      *
************************************************************************
*                                                                      *
         Do lIter = 1, kIter
*                                                                      *
************************************************************************
*                                                                      *
            Call DefInt2(BVec,dBVec,nBVec,BM,nLambda,nsAtom,
     &                   iRow_c,Value,cInt,cInt0,Lbl(nQQ+1),
     &                   (lIter.eq.kIter).and.First_MicroIteration,
     &                   Mult,dBM,Value0,lIter,iFlip)
*
*           Assemble r
*
            R(:,lIter)=cInt(:)-cInt0(:)
*
*           Assemble dC/dQ: Solve  B dC/dQ = dC/dx
*
*           where B = dQ/dx
*
            dRdq(:,:,lIter)=Zero
#ifdef _DEBUGPRINT_
            Write (Lu,*) 'Update_inner: lIter=',lIter
            Call RecPrt('Update_inner: dQ/dx(BMx)',' ',BMx,n1,nQQ)
            Call RecPrt('Update_inner: dC/dx(BM)',' ',BM,n1,nLambda)
#endif
*
            M=n1
            N=nQQ
            NRHS=nLambda
*
*           Temporary fix of the dC/dx vector which always
*           is propted up with the full degeneracy factor.
*
            If (.NOT.Curvilinear) Then
               Do iLambda=1,nLambda
                  Do i = 1, n1
                     iAtom = (i+2)/3
                     ixyz = i - (iAtom-1)*3
                     BM(i,iLambda)=BM(i,iLambda)/Degen(ixyz,iAtom)
                  End Do
               End Do
            End If
            If (lIter.eq.kIter) Then
               LudRdX=30
               Call DaName(LudRdX,'dRdX')
               iAd=0
               iDum(1)=nLambda
               Call iDaFile(LudRdX,1,iDum,1,iAd)
               iDum(1)=n1
               Call iDaFile(LudRdX,1,iDum,1,iAd)
               Call dDaFile(LudRdX,1,BM,nLambda*n1,iAd)
               Call DaClos(LudRdX)
            End If
            Call Eq_Solver('N',M,N,NRHS,BMx,Curvilinear,Degen,
     &                     BM,dRdq(1,1,lIter))
#ifdef _DEBUGPRINT_
            Call RecPrt('Update_inner: dRdq(1,1,lIter)',' ',
     &                   dRdq(1,1,lIter),nQQ,nLambda)
#endif
*                                                                      *
************************************************************************
*                                                                      *
         End Do     ! lIter
*                                                                      *
************************************************************************
*                                                                      *
         Call mma_deallocate(dBVec)
         Call mma_deallocate(iFlip)
         Call mma_deallocate(Mult)
         Call mma_deallocate(cInt0)
         Call mma_deallocate(cInt)
         Call mma_deallocate(Value0)
         Call mma_deallocate(Value)
         Call mma_deallocate(BVec)
*
#ifdef _DEBUGPRINT_
         Call RecPrt('Update_inner: R',' ',R,nLambda,kIter)
         Call RecPrt('Update_inner: dRdq',' ',dRdq,nQQ*nLambda,
     &               kIter)
         Do i = 1, nLambda
            Write (6,*) ' iLambda=',i
            Call RecPrt('Update_inner: d2C/dx2',' ',dBM(1,1,i),n1,n1)
         End Do
         If (Curvilinear) Call dBPrint(nQQ,nDimBC)
#endif
         Call mma_deallocate(BM)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- Assemble d^2C/dQ^2
*
*        The expression is written as
*
*        dQ/dx * d^2C/dQ^2 * (dQ/dx)^T = d^2C/dx^2 - Sum (d^2Q/dx^2 * dC/dQ)
*
*        Dimensions
*        dQ/dx     :  3*nsAtom x nQQ
*        d^2C/dx^2 :  3*nsatom x 3*nsatom
*        d^2C/dQ^2 :  nQQ   x nQQ
*
#ifdef _NEW_CODE_
*        Compute Sum (d^2Q/dx^2 * dC/dQ)
*
         Call mma_allocate(QC,nDimBC,nDimBC,nLambda,Label='QC')
         QC(:,:,:)=Zero
         If (Curvilinear) Call dBMult(dRdq(1,1,kIter),
     &                                QC,nQQ,nDimBC,nLambda)
#ifdef _DEBUGPRINT_
         Write (Lu,*) 'Update_inner: kIter=',kIter
         Call RecPrt('dRdq(1,1,kIter)',' ',dRdq(1,1,kIter),nQQ,1)
         Do iLambda=1,nLambda
            Write (6,*) 'Update_inner: iLambda=',iLambda
            Call RecPrt('Update_inner: QC',' ',QC(1,1,iLambda),
     &                   nDimBC,nDimBC)
         End Do
#endif
*
*        Subtract the term from d^2C/dx^2
*
         Do k = 1, nLambda
            j = 0
            Do jx = 1, n1
               jAtom = (jx+2)/3
               jxyz = jx - (jAtom-1)*3
               If (Smmtrc(jxyz,jAtom)) Then
                  j = j + 1
*
                  i=0
                  Do ix = 1, n1
                     iAtom = (ix+2)/3
                     ixyz = ix - (iAtom-1)*3
                     If (Smmtrc(ixyz,iAtom)) Then
                        i = i + 1
                        dBM(ix,jx,k) = dBM(ix,jx,k) - QC(i,j,k)
                     End If
                  End Do
               End If
            End Do
         End Do
         Call mma_deallocate(QC)
#endif
*
         Call mma_allocate(Scr2,nQQ*n1*nLambda,Label='Scr2')
         Call mma_allocate(Scr1,nQQ*n1*nLambda,Label='Scr1')
#ifdef _DEBUGPRINT_
         Call RecPrt('Update_inner: d^2C/dx^2(dBM)',' ',dBM,n1**2,
     &               nLambda)
#endif
*
*        Temporary fix of the d^2C/dx^2 vector which always
*        is propted up with the full degeneracy factor.
*
         If (.NOT.Curvilinear) Then
            Do k = 1, nLambda
               Do j = 1, n1
                  jAtom = (j+2)/3
                  jxyz = j - (jAtom-1)*3
                  Do i = 1, n1
                     iAtom = (i+2)/3
                     ixyz = i - (iAtom-1)*3
                     dBM(i,j,k)=dBM(i,j,k)/(Degen(ixyz,iAtom)
     &                                     *Degen(jxyz,jAtom))
                  End Do
               End Do
            End Do
         End If
#ifdef _DEBUGPRINT_
         Call RecPrt('Update_inner: d^2C/dx^2(dBM)',' ',dBM,n1**2,
     &               nLambda)
#endif
*
*        Solve first for y in
*                dQ/dx y = d^2C/dx^2 - Sum (d^2Q/dx^2 * dC/dQ)
*
*        where y   = d^2C/dQ^2 * (dQ/dx)^T
*
*        and   y^T = dQ/dx * d^2C/dQ^2
*
         M=3*nsAtom
         N=nQQ
         NRHS=n1*nLambda
         Call Eq_Solver('N',M,N,NRHS,BMx,Curvilinear,Degen,dBM,Scr1)
*
*        Generate y^T in Scr2
*
         Call TRNSPS(nQQ,n1*nLambda,Scr1,Scr2)
#ifdef _DEBUGPRINT_
         Call RecPrt('d^2C/dQ^2 * (dQ/dx)^T',' ',Scr1,nQQ,n1*nLambda)
         Call RecPrt('dQ/dx * d^2C/dQ^2',' ',Scr2,n1*nLambda,nQQ)
#endif
         Call mma_deallocate(dBM)
*
*        Followed by solve for x in B x = y^T for which B = dQ/dx
*
         NRHS=nLambda*nQQ
         Call Eq_Solver('N',M,N,NRHS,BMx,Curvilinear,Degen,Scr2,Scr1)
         Call mma_allocate(d2L,nQQ,nQQ,nLambda,Label='d2L')
*
         Call TRNSPS(nQQ*nLambda,nQQ,Scr1,d2L)
#ifdef _DEBUGPRINT_
         Call RecPrt('Scr1',' ',Scr1,nQQ*nLambda,nQQ)
         Do i = 1, nLambda
            Write (6,*) ' iLambda=',i
            Call RecPrt('Update_inner: d2L',' ',d2L(:,:,i),
     &                  nQQ,nQQ)
         End Do
#endif
         Call mma_deallocate(Scr2)
         Call mma_deallocate(Scr1)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*------- Compute updated geometry in Internal coordinates
*
         Mode_Save=Mode
         Mode=0
         M=3*nsAtom
         N=nQQ
         NRHS=1
         Call mma_Allocate(Tmp,M,Label='Tmp:M')
*
*        Iterate to avoid too large displacement in cartesians.
*        If the maximum displacement is more than 2*Beta, reduce the step.
*
*        Initial setup to ensure fCart=1.0 at first iteration.
         Thr_RS=1.0D-7
         rInter=Beta
         fCart=Ten
         rCart=fCart*rInter
         nLoop=0
         Do While (rCart.ge.Two*Beta)
            nLoop=nLoop+1
            If (nLoop.gt.100) Exit
            If (rCart.gt.rInter) Then
              fCart=fCart*rInter/rCart
            Else
              fCart=fCart*0.9D0
            End If
            qBeta=fCart*Beta
            Call Con_Opt(R,dRdq,T,dqInt,Lambda,qInt,Shift,dy,dx,
     &                dEdq,du,x,dEdx,Wess,GNrm(kIter),
     &                nWndw,Hessian,nQQ,kIter,
     &                iOptH_,jPrint,Energy_L,nLambda,
     &                ErrVec,EMtrx,RHS,
     &                AMat,nA,qBeta,qBeta_Disp,nFix,
     &                Index,Step_Trunc,Lbl,
     &                d2L,nsAtom,
     &                iOpt_RS,Thr_RS,iter,
     &                First_Microiteration)
            If (iOpt_RS.eq.1) Exit
*
*           Rough conversion to Cartesians
*
            Call Eq_Solver('T',M,N,NRHS,BMx,Curvilinear,Degen,
     &                     Shift(1,kIter),Tmp)
            rInter=Sqrt(dDot_(N,Shift(1,kIter),1,Shift(1,kIter),1))
            rCart=Zero
            Do i=1,nsAtom
               rCart=Max(rCart,
     &                   Sqrt(dDot_(3,Tmp(i),nsAtom,Tmp(i),nsAtom)))
            End Do
         End Do
         Mode=Mode_Save
         Call mma_deallocate(Tmp)
*
#ifdef _DEBUGPRINT_
         Write (Lu,*)
         Write (Lu,*) '********************************************'
         Write (Lu,*) '* Lagrange multipliers for the constraints *'
         Write (Lu,*) '********************************************'
         Write (Lu,'(1X,A,2X,ES13.6)')
     &       (Lbl(nQQ+iInt),-One*Lambda(iInt,mIter),
     &        iInt=1,nLambda)
         Write (Lu,*)
#endif
*
         Call mma_deallocate(d2L)
         Call mma_deallocate(Energy_L)
         Call mma_deallocate(Wess)
         Call mma_deallocate(dEdx)
         Call mma_deallocate(x)
         Call mma_deallocate(du)
         Call mma_deallocate(dEdq)
         Call mma_deallocate(dx)
         Call mma_deallocate(dy)
         Call mma_deallocate(T)
         Call mma_deallocate(dRdq)
         Call mma_deallocate(R)
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_Deallocate(Hessian)
      Call mma_Deallocate(RHS)
      Call mma_Deallocate(EMtrx)
      Call mma_Deallocate(ErrVec)
      Call mma_Deallocate(Index)
      Call mma_Deallocate(AMat)
#ifdef _WARNING_WORKAROUND_
      If (Smmtrc(1,1)) i=nDimBC
#endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
*               2010, Grigory A. Shamov                                *
*               2017, Giovanni Li Manni                                *
*               2017, Aron Cohen                                       *
************************************************************************
      Subroutine xSSBD(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object:  SSB-D exchange functional by Swart                          *
*                                                                      *
*      Author: G. Li Manni, A. Cohen, Max Planck Institute Stuttgart   *
*              Summer 2017, edited in Cambridge (UK) & Palermo (Sicily)*
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)

* IDORD=Order of derivatives to request from XPBE:
      idord=1
*
      Rho_Min=T_X*1.0D-2
*
      if (ispin.eq.1) then
* ispin=1 means spin zero.

* T_X: Screening threshold of total density.
        Ta=0.5D0*T_X
        do iGrid=1,mgrid
         rhoa=rho(ipR,iGrid)
         if(rhoa.lt.Ta) goto 110
         grdrhoa_x=rho(ipdRx,iGrid)
         grdrhoa_y=rho(ipdRy,iGrid)
         grdrhoa_z=rho(ipdRz,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2

         call xSSBD_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)
         F_xc(iGrid)=F_xc(iGrid)+Coeff*(2.0D0*Fa)
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+Coeff*dFdrhoa
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+Coeff*dFdgammaaa
* Note: For xpbe, dFdgammaab is zero.
 110     continue
        end do

      else
* ispin .ne. 1, use both alpha and beta components.

        do iGrid=1,mgrid
         rhoa=Max(Rho_Min,rho(ipRa,iGrid))
         rhob=Max(Rho_Min,rho(ipRb,iGrid))
         rho_tot=rhoa+rhob
         if(rho_tot.lt.T_X) goto 210
         grdrhoa_x=rho(ipdRxa,iGrid)
         grdrhoa_y=rho(ipdRya,iGrid)
         grdrhoa_z=rho(ipdRza,iGrid)
         sigmaaa=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         call xSSBD_(idord,rhoa,sigmaaa,Fa,dFdrhoa,dFdgammaaa,
     &          d2Fdra2,d2Fdradgaa,d2Fdgaa2)

         grdrhob_x=rho(ipdRxb,iGrid)
         grdrhob_y=rho(ipdRyb,iGrid)
         grdrhob_z=rho(ipdRzb,iGrid)
         sigmabb=grdrhob_x**2+grdrhob_y**2+grdrhob_z**2
         call xSSBD_(idord,rhob,sigmabb,Fb,dFdrhob,dFdgammabb,
     &          d2Fdrb2,d2Fdrbdgbb,d2Fdgbb2)

         F_xc(iGrid)=F_xc(iGrid)+Coeff*(Fa+Fb)
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+Coeff*dFdrhoa
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+Coeff*dFdrhob
* Maybe derivatives w.r.t. gamma_aa, gamma_ab, gamma_bb should be used instead.
* Note: For xpbe, dFdgammaab is zero.
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+Coeff*dFdgammaaa
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+Coeff*dFdgammabb
 210     continue
        end do

      end if

      Return
      End

      subroutine XSSBD_(idord,rho_s,gamma_s,F,dFdr,dFdg,
     & d2Fdr2,  d2Fdrdg, d2Fdg2)
      implicit none

      integer idord
      real*8 rho_s,gamma_s,F,dFdr,dFdg
      real*8  d2Fdr2,  d2Fdrdg, d2Fdg2
      real*8 rho, gamma, pi
      parameter(pi=3.14159265358979d0)
      real*8 rho43,rrho,rho13,gam12,s,d1s1,d1s2
      real*8 g,gp,d1g1,d1g2
      real*8 rA, rB, rC, rD, rE, rU, RF, fac
      real*8 C, Cs, Cx
      parameter (rA=1.079966d0, rB=0.197465d0, rC=0.272729d0)
      parameter (rE=5.873645d0, rU=-0.749940d0)
      parameter (rD=rB*(1.0d0-rU), rF=0.949488d0)

      rho=rho_s+1.0D-16
      gamma=gamma_s+1.0D-16
      C = -3d0/(4d0*pi)*(3d0*pi*pi)**(1.d0/3.d0)
      Cs = 0.5d0/(3d0*pi*pi)**(1.d0/3.d0)
      Cs = Cs * C               ! account for including C in rho43

      rho43 = C*(2d0*rho)**(4.d0/3.d0)
      rrho = 0.5d0/rho
      rho13 = 4.d0/3.d0*rho43*rrho
      gam12 = 2d0*dsqrt(gamma)
      s = Cs*gam12/rho43
      d1s1 = -4.d0/3.d0*s*rrho
      d1s2 = 0.5d0*s/gamma
c
c     Evaluate the GC part of F(s), i.e. g(s) = F(s) - 1
c

      g= rB*s*s/(1d0+rC*s*s)
     +               - rD*s*s/(1d0+rE*s**4)
      gp= 2d0*rB*s/(1d0+rC*s*s)**2 +
     +         (2d0*rD*rE*s**5 - 2d0*rD*s)/(1d0+rE*s**4)**2

!            g=gssb0(s)
!            gp=gssb1(s)
c
      Cx = 3.d0/4.d0*(3.d0/pi)**(1.d0/3.d0)*2.d0**(1.d0/3.d0)
      fac = rU*rF*Cx*rB/(2*(3*pi**2)**(1.d0/3.d0))**2/2**(2/3.d0)
      d1g1 = gp*d1s1
      d1g2 = gp*d1s2
      F = rho43*g*0.5d0+rho43*rA*0.5d0
     & +fac*gamma/((rho)**(4.d0/3.d0)+0.1d0)

      if(idord.lt.1) goto 99
            dFdr = (rho13*g+rho43*d1g1)+rho13*rA
     &  - fac*gamma/(rho**(4.d0/3.d0)+0.1d0)**2*4.d0/3.d0*rho**(1/3.d0)
            dFdg =  0.5d0*rho43*d1g2
     &  + fac/((rho)**(4.d0/3.d0)+0.1d0)

      if(idord.lt.2) goto 99

      write(6,*) '2nd derivatives not programmed ssb1'
      Call Abend()

 99   continue

      return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(d2Fdr2)
         Call Unused_real_array(d2Fdrdg)
         Call Unused_real_array(d2Fdg2)
      End If
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE SMOST_MCLR(NSMST,NSMCI,MXPCSM,ISMOST)
*
* ISMOST(ISYM,ITOTSM) : Symmetry of an internal state if ITOTSM
*                       if symmetry of 1 string is ISYM, the
*                       symmetry of the other string is
*                       ISMOST(ISYM,ITOTSM)
*
* Jeppe Olsen , Spring of 1991
*
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION ISMOST(MXPCSM,MXPCSM)
*
      DO 1000 ITOTSM = 1, NSMCI
        DO 900 ISTSM  = 1, NSMST
          JSTSM = 1 + IEOR(ISTSM-1,ITOTSM-1)
          ISMOST(ISTSM,ITOTSM) = JSTSM
900     CONTINUE
1000  CONTINUE
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Markus P. Fuelscher                              *
*               2013, Giovanni Li Manni                                *
************************************************************************
      Subroutine CASDFT_terms(CMO,F,FI,D1I,D1A,D1S)
*
*     This routine is a modification of SGFCIN, adapted to a CASDFT
*     implementation in which the CI step of a CASDFT calculation is
*         not corrected by DFT. DFT will play a role only in the Orbital
*         optimization step.
*     Purpose:
*     Generate the Fock-matrix for the frozen and inactive orbitals.
*     Compute also the core energy. Finally, transform the Fock-matrix
*     into the basis of the active orbitals.
*
*     M.P. Fuelscher, Lund, July 1990
*     GLM, Minneapolis,   May 2013
*
#ifdef _DMRG_
!     module dependencies
      use qcmaquis_interface_cfg
#endif
      Implicit Real*8 (A-H,O-Z)
*
#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='CASDFT_Terms')
#include "rasscf.fh"
#include "WrkSpc.fh"
#include "rctfld.fh"
#include "pamint.fh"
#include "timers.fh"
#include "SysDef.fh"
*
      Dimension CMO(*) ,F(*) , FI(*) , D1I(*) , D1A(*), D1S(*)
      Character*8 Label
      Logical First, Dff, Do_DFT
      Parameter ( Zero=0.0d0 , One=1.0d0 )


***********************************************************
C Local print level (if any)
***********************************************************
      IPRLEV=IPRLOC(3)
c      IPRLEV=100
      If ( IPRLEV.ge.DEBUG ) then
       Write(LF,*) 'Printing matrices in CASDFT_Terms'
       Write(LF,*)
       Write(LF,*) ' CMO in CASDFT_terms'
       Write(LF,*) ' ---------------------'
       Write(LF,*)
       ioff=1
       Do iSym = 1,nSym
         iBas = nBas(iSym)
         if(iBas.ne.0) then
           write(6,*) 'Sym =', iSym
           do i= 1,iBas
             write(6,*) (CMO(ioff+iBas*(i-1)+j),j=0,iBas-1)
           end do
           iOff = iOff + (iBas*iBas)
         end if
       End Do

       Write(LF,*)
       Write(LF,*) ' D1I in AO basis in CASDFT_Terms'
       Write(LF,*) ' ---------------------'
       Write(LF,*)
       iOff=1
       Do iSym = 1,nSym
         iBas = nBas(iSym)
         call wrtmat(D1I(ioff),iBas,iBas, iBas, iBas)
         iOff = iOff + iBas*iBas
       End Do

       Write(LF,*)
       Write(LF,*) ' D1S in AO basis in CASDFT_Terms'
       Write(LF,*) ' ---------------------'
       Write(LF,*)
       iOff=1
       Do iSym = 1,nSym
         iBas = nBas(iSym)
         call wrtmat(D1S(ioff),iBas,iBas, iBas, iBas)
         iOff = iOff + iBas*iBas
       End Do


       Write(LF,*)
       Write(LF,*) ' D1A in AO basis in CASDFT_Terms'
       Write(LF,*) ' ---------------------'
       Write(LF,*)
       iOff=1
       Do iSym = 1,nSym
         iBas = nBas(iSym)
         call wrtmat(D1A(ioff),iBas,iBas, iBas, iBas)
         iOff = iOff + iBas*iBas
       End Do

      End If


*
***********************************************************
* Generate molecular charges
***********************************************************
      Call GetMem('Ovrlp','Allo','Real',iTmp0,nTot1+4)
      iRc=-1
      iOpt=2
      iComp=1
      iSyLbl=1
      Label='Mltpl  0'
      Call RdOne(iRc,iOpt,Label,iComp,Work(iTmp0),iSyLbl)
      Tot_Nuc_Charge=Work(iTmp0+nTot1+3)
      If ( iRc.ne.0 ) then
         Write(LF,*) 'CASDFT_Terms: iRc from Call RdOne not 0'
         Write(LF,*) 'Label = ',Label
         Write(LF,*) 'iRc = ',iRc
         Call Abend
      Endif
      Call GetMem('Ovrlp','Free','Real',iTmp0,nTot1+4)

      Tot_El_Charge=Zero
      Do iSym=1,nSym
         Tot_El_Charge=Tot_El_Charge
     &                -2.0D0*DBLE(nFro(iSym)+nIsh(iSym))
      End Do
      Tot_El_Charge=Tot_El_Charge-DBLE(nActEl)
      Tot_Charge=Tot_Nuc_Charge+Tot_El_Charge
*      If ( IPRLEV.ge.DEBUG ) then
*          write(6,*)
*       write(6,*) 'Total Charge :', Tot_Charge
*      end if
*
***********************************************************
* Load bare nuclei Hamiltonian
***********************************************************
      Call GetMem('Fcore','Allo','Real',iTmp1,nTot1)
      iComp  =  1
      iSyLbl =  1
      iRc    = -1
      iOpt   =  6
      Label  = 'OneHam  '
      Call RdOne(iRc,iOpt,Label,iComp,Work(iTmp1),iSyLbl)
      If ( iRc.ne.0 ) then
         Write(LF,*) 'CASDFT_Terms: iRc from Call RdOne not 0'
         Write(LF,*) 'Label = ',Label
         Write(LF,*) 'iRc = ',iRc
         Call Abend
      Endif
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' OneHam in AO basis in CASDFT_Terms'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=0
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',Work(iTmp1+iOff),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End IF
*
***********************************************************
* Load the nuclear repulsion energy
***********************************************************
      Call Get_dScalar('PotNuc',potNuc)
c      write(6,*)
c      write(6,*) 'PotNuc in casdft_terms.f:', PotNuc

*
***********************************************************
* Generate total density
***********************************************************
*
*      If ( IPRLEV.ge.DEBUG ) then
*       Call GetMem('D_MAT','Allo','Real',iTmp31,nBas*nBas)
*          call FZERO(Work(iTmp31),nBas*nBas)
*          Call Daxpy_(nBas*nBas,1.0D0,D1I,1,Work(iTmp31),1)
*          Call Daxpy_(nBas*nBas,1.0D0,D1A,1,Work(iTmp31),1)
*      Write(LF,*)
*       Write(LF,*) ' DMAT not folded in AO basis in CASDFT_Terms'
*       Write(LF,*) ' ---------------------'
*       Write(LF,*)
*          call wrtmat(Work(iTmp31),nBas,nBas, nBas, nBas)
*       Call GetMem('D_MAT','Free','Real',iTmp31,nBas*nBas)
*      End IF

      Call GetMem('DtmpI','Allo','Real',iTmp3,nTot1)
      Call GetMem('DtmpA','Allo','Real',iTmp4,nTot1)
      Call Fold(nSym,nBas,D1I,Work(iTmp3))
      Call Fold(nSym,nBas,D1A,Work(iTmp4))
      Call Daxpy_(nTot1,1.0D0,Work(iTmp4),1,Work(iTmp3),1)
      Call Put_D1ao(Work(iTmp3),nTot1)
      call xflush(6)
***********************************************************
* Generate spin-density
***********************************************************
        Call GetMem('DtmpS','Allo','Real',iTmp7,nTot1)
        Call Fold(nSym,nBas,D1S,Work(iTmp7))
        Call Put_D1Sao(Work(iTmp7),nTot1)
        Call GetMem('DtmpS','Free','Real',iTmp7,nTot1)
*
***********************************************************
* One- and two-electron type contributions
***********************************************************
*
      Call GetMem('htmp','Allo','Real',iTmp5,nTot1)
      Call GetMem('gtmp','Allo','Real',iTmp6,nTot1)
      Call dcopy_(nTot1,[0.0d0],0,Work(iTmp5),1)
      Call dcopy_(nTot1,[0.0d0],0,Work(iTmp6),1)
*
      First=.True.
      Dff=.False.
      Do_DFT=.True.

      Call Put_iArray('nFro',nFro,nSym)
      Call Put_iArray('nAsh',nAsh,nSym)
      Call Put_iArray('nIsh',nIsh,nSym)

      iCharge=Int(Tot_Charge)
c iTmp5 and iTmp6 are not updated in DrvXV...
      Call DrvXV(Work(iTmp5),Work(iTmp6),Work(iTmp3),
     &             PotNuc,nTot1,First,Dff,NonEq,lRF,
     &             KSDFT_TEMP,ExFac,iCharge,iSpin,D1I,D1A,
     &             nTot1,DFTFOCK,Do_DFT)

      Call Daxpy_(nTot1,1.0d0,Work(iTmp5),1,Work(iTmp1),1)
      Call Daxpy_(nTot1,1.0d0,Work(iTmp6),1,FI,1)

      Call GetMem('gtmp','Free','Real',iTmp6,nTot1)
      Call GetMem('htmp','Free','Real',iTmp5,nTot1)
      Call GetMem('DtmpA','Free','Real',iTmp4,nTot1)
      Call GetMem('DtmpI','Free','Real',iTmp3,nTot1)

***********************************************************
*     Compute energy contributions
***********************************************************
      Call GetMem('DoneI','Allo','Real',iTmp2,nTot1)

      Call Fold(nSym,nBas,D1I,Work(iTmp2))
*
      Eone = dDot_(nTot1,Work(iTmp2),1,Work(iTmp1),1)
      Call Get_dScalar('PotNuc',PotNuc_Ref)
      Eone = Eone + (PotNuc-PotNuc_Ref)
      Etwo = dDot_(nTot1,Work(iTmp2),1,FI,1)
      Call GetMem('DoneI','Free','Real',iTmp2,nTot1)
      EMY  = PotNuc_Ref+Eone+0.5d0*Etwo

      CASDFT_Funct = 0.0D0
      Call Get_dScalar('CASDFT energy',CASDFT_Funct)
      If ( IPRLEV.ge.DEBUG ) then
         Write(LF,*) ' Nuclear repulsion energy :',PotNuc
*         Write(LF,*) ' Nuclear repulsion energy Ref :',PotNuc_Ref
         Write(LF,*) ' One-electron core energy :',Eone
         Write(LF,*) ' Two-electron core energy :',Etwo
         Write(LF,*) ' Total core energy        :',EMY
         Write(LF,*) ' CASDFT Energy            :',CASDFT_Funct
      End If

***********************************************************
* Printing matrices
***********************************************************
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' FI matrix in CASDFT_Terms only 2-electron terms'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',FI(iOff),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End If

      Call DaXpY_(nTot1,One,Work(iTmp1),1,FI,1)

      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' Inactive Fock matrix in AO basis in CASDFT_terms'
        write(LF,*) '(it already contains OneHam and TwoEl contrib.)'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',FI(iOff),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End If

      Call GetMem('Fcore','Free','Real',iTmp1,nTot1)

***********************************************************
*     Transform FI to active orbital basis and move it over to F.
*     Remove also the symmetry blocking.
***********************************************************
***********************************************************
* Shall I add here the DFT contribution? Maybe not yet!
* I am commenting off... if needed we can always re-activate.
***********************************************************
      MXNB=0
      MXNA=0
      DO ISYM=1,NSYM
        MXNB=MAX(MXNB,NBAS(ISYM))
        MXNA=MAX(MXNA,NASH(ISYM))
      END DO
      CALL GETMEM('XXX0','ALLO','REAL',LX0,NTOT1)
      CALL GETMEM('XXX1','ALLO','REAL',LX1,NTOT1)
      CALL GETMEM('XXX2','ALLO','REAL',LX2,MXNB*MXNB)
      CALL GETMEM('XXX3','ALLO','REAL',LX3,MXNB*MXNA)
      CALL dcopy_(NTOT1,FI,1,WORK(LX1),1)
*      Call Get_dExcdRa(ipTmpFckI,nTmpFck)
*      CALL DaXpY_(NTOT1,1.0D0,Work(ipTmpFckI),1,WORK(LX1),1)
*     If ( IPRLEV.ge.DEBUG ) then
*         Write(LF,*)
*         Write(LF,*) ' Exchange Corr. in AO basis in CASDFT_Terms'
*         Write(LF,*) ' ---------------------'
*         Write(LF,*)
*         iOff=1
*         Do iSym = 1,nSym
*           iBas = nBas(iSym)
*           Call TriPrt(' ','(5G17.11)',Work(ipTmpFckI+ioff-1),iBas)
*           iOff = iOff + (iBas*iBas+iBas)/2
*         End Do
*     End If
*      Call Free_Work(ipTmpFckI)
*      If ( IPRLEV.ge.DEBUG ) then
*        Write(LF,*)
*        Write(LF,*) ' Modified FI in AO basis in CASDFT_Terms'
*        Write(LF,*) ' ---------------------'
*        Write(LF,*)
*        iOff=1
*        Do iSym = 1,nSym
*          iBas = nBas(iSym)
*          Call TriPrt(' ','(5G17.11)',Work(LX1+ioff-1),iBas)
*          iOff = iOff + (iBas*iBas+iBas)/2
*        End Do
*      End If
*
      CALL MOTRAC(CMO,WORK(LX1),WORK(LX2),WORK(LX3))
      CALL GETMEM('XXX3','FREE','REAL',LX3,MXNB*MXNA)
      CALL GETMEM('XXX2','FREE','REAL',LX2,MXNB*MXNB)
      CALL dcopy_(NACPAR,[ZERO],0,F,1)
      NTU=0
      ITU=0
      IADD=0

      IF (NACTEL.NE.0) THEN
         EMYN=EMY/DBLE(NACTEL)
      ELSE
         EMYN=0.0d0
      ENDIF
      DO NST=1,NSYM
        NAT=NASH(NST)
        IF(NAT.NE.0) THEN
          DO NT=1,NAT
            NTU=NTU+IADD
            DO NU=1,NT
              NTU=NTU+1
              ITU=ITU+1
              F(NTU)=WORK(LX1-1+ITU)
              IF(NT.EQ.NU) F(NTU)=F(NTU)+EMYN
              WORK(LX0-1+ITU) = F(NTU)
            END DO
          END DO
          IADD=IADD+NAT
        ENDIF
      END DO
#ifdef _DMRG_
      if(.not.doDMRG)then
        CALL CP_ONE_INT(WORK(LX0),ITU)
      end if
#endif
      CALL GETMEM('XXX1','FREE','REAL',LX1,NTOT1)
      CALL GETMEM('XXX0','FREE','REAL',LX0,NTOT1)

*     print h0
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*)
        Write(LF,*)
        Write(LF,*)
        Write(LF,*) ' Fock matrix in MO basis, h0, in CASDFT_TERMS'
        Write(LF,*) ' ------------'
        Call TriPrt(' ',' ',F,NAC)
      End If


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_mXOs(kOrb,XO,locc,nSkal,nIrrep,nOcc)

use ChoArr, only: nBasSh
use RI_glob, only: CMOi
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: kOrb, locc, nSkal, nIrrep, nOcc(nIrrep)
real(kind=wp), intent(out) :: XO(locc,nSkal,nIrrep)
integer(kind=iwp) :: ib, iOff, iok, ir, isk, kb

!                                                                      *
!***********************************************************************
!                                                                      *
XO(:,:,:) = Zero

! Loop over irreps

do ir=1,nIrrep

  ! The next block of X_i,mu

  !call RecPrt('X_i,mu',' ',CMOi(kOrb)%SB(ir)%A2,nOcc(ir),nBas(ir))

  ! Loop over all valence shells

  iOff = 0
  do isk=1,nSkal

    ! Loop over all basis functions of this shell in this irrep.

    !write (u6,*) 'isk,nBasSh(ir,isk)=',isk,nBasSh(ir,isk)

    do ib=1,nBasSh(ir,isk)
      kb = iOff+ib ! relative SO index in this irrepp

      ! Loop over all the occupied MOs and pick up the largest coefficient for shell isk

      do iok=1,nOcc(ir)
        !write(u6,*) 'iok,kb=',iok,kb
        !write(u6,*) 'CMOi(kOrb)%SB(ir)%A2(iok,kb)',CMOi(kOrb)%SB(ir)%A2(iok,kb)
        XO(iok,isk,ir) = max(XO(iok,isk,ir),abs(CMOi(kOrb)%SB(ir)%A2(iok,kb)))
      end do
    end do
    iOff = iOff+nBasSh(ir,isk)
  end do
  !call RecPrt('XO(*,*,ir)',' ',XO(1,1,ir),locc,nskal)
end do

return

end subroutine Get_mXOs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Markus P. Fuelscher                              *
!               1991, Per Ake Malmqvist                                *
!               1998, Roland Lindh                                     *
!***********************************************************************

subroutine SaveBin(iBin,iOpt)
!***********************************************************************
!                                                                      *
!     Purpose: Phase 1 of the bin sorting algorithm                    *
!              Once a bin is filled it has to be dumped to disk.       *
!              First, however, we like to sort and pack the buffers.   *
!              A further complication arises due to the fact that a    *
!              bin is shorter than the records as used in the wave-    *
!              function codes.                                         *
!                                                                      *
!     Called from: SORT1A and SORT1B                                   *
!                                                                      *
!     Calls to : PKI4,PKR8,DaFile,SetVec,ErrTra,ISORTX,I4Len,R8Len     *
!                                                                      *
!     Calling Parameters:                                              *
!     iBin   : Bin number to be saved                                  *
!                                                                      *
!     Global data declarations (Include files) :                       *
!     PkCtl  : packing table                                           *
!                                                                      *
!     local data declarations:                                         *
!     Scr    : temporary array used for initializing records           *
!                                                                      *
!     Modified to remove sorting step, R. Lindh, March '98             *
!                                                                      *
!*** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****

use sort_data, only: iDaTmp, iDATwo, iDIBin, iDVBin, IndBin, lDaRec, lIndx, lInts, lStRec, lTop, LuTmp, LuTwo, lwIBin, lwVBin, &
                     mDaTmp, mDaTwo, mInt, nRec, nSect, n_Int, ValBin
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, ItoB, RtoB

implicit none
integer(kind=iwp), intent(in) :: iBin, iOpt
#include "PkCtl.fh"
integer(kind=iwp) :: i, idiv, Init_do_setup_d, Init_do_setup_e, Init_do_setup_l, iOptIO, iSave, iScr(lStRec), lIBin, lIRec, lVBin, &
                     lVRec, mInds, mInts, mxIRec, mxVRec, nInts, nKeep, nSave
real(kind=wp) :: Scr(lStRec)

!----------------------------------------------------------------------*
!         as the packed integral labels add an extra 1-2 Byte          *
!         disk space per integral we have to adjust the record         *
!         length of LuTmp to the different machines.                   *
!----------------------------------------------------------------------*
idiv = ItoB/2
if (Pack) idiv = idiv/2
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
nInts = n_Int(iBin)
!----------------------------------------------------------------------*
!         precompute the packed length of a record                     *
!----------------------------------------------------------------------*
call I4LEN(nInts,lwIBin(1,iBin),lIndx)
call R8LEN(iOpt,nInts,lwVBin(1,iBin),lInts)
mxIRec = ((lDaRec/idiv)-lTop-1)*ItoB
mxVRec = (lDaRec-lTop-1)*RtoB
nSave = 0
lIRec = 0
lVRec = 0
do iSave=1,nInts
  lIRec = lIRec+lIndx(iSave)
  lVRec = lVRec+lInts(iSave)
  if ((lIRec < mxIRec) .and. (lVRec < mxVRec)) nSave = iSave
end do
lIRec = 0
lVRec = 0
do iSave=1,nSave
  lIRec = lIRec+lIndx(iSave)
  lVRec = lVRec+lInts(iSave)
end do
!----------------------------------------------------------------------*
!         now pack and check the packed record length again            *
!----------------------------------------------------------------------*
call PKI4(nSave,lIBin,lwIBin(1,iBin),IndBin(lTop+1))
mInds = (lIBin+ItoB-1)/ItoB
mInt(3,iBin) = mInt(3,iBin)+mInds
if (lIBin > mxIRec) then
  write(u6,*)
  write(u6,'(2X,A,I3.3,A)') '*** Error in SAVEBIN ***'
  write(u6,'(2X,A)') 'An inconsistency has been deteced'
  write(u6,'(2X,A)') 'lIRec > mxIRec '
  write(u6,*)
  call xFlush(u6)
  call Abend()
end if
if (lIBin /= lIRec) then
  write(u6,*)
  write(u6,'(2X,A,I3.3,A)') '*** Error in SAVEBIN ***'
  write(u6,'(2X,A)') 'An inconsistency has been deteced'
  write(u6,'(2X,A)') 'lIBin # lIRec'
  write(u6,*)
  call xFlush(u6)
  call Abend()
end if
call PKR8(iOpt,nSave,lVBin,lwVBin(1,iBin),ValBin(lTop+1))
mInts = (lVBin+RtoB-1)/RtoB
mInt(2,iBin) = mInt(2,iBin)+mInts
if (lVBin > mxVRec) then
  write(u6,*)
  write(u6,'(2X,A,I3.3,A)') '*** Error in SAVEBIN ***'
  write(u6,'(2X,A)') 'An inconsistency has been deteced'
  write(u6,'(2X,A)') 'lVRec > mxVRec '
  write(u6,*)
  call xFlush(u6)
  call Abend()
end if
if (lVBin /= lVRec) then
  write(u6,*)
  write(u6,'(2X,A,I3.3,A)') '*** Error in SAVEBIN ***'
  write(u6,'(2X,A)') 'An inconsistency has been deteced'
  write(u6,'(2X,A)') 'lVBin # lVRec'
  write(u6,*)
  call xFlush(u6)
  call Abend()
end if
!----------------------------------------------------------------------*
!     write the record header                                          *
!----------------------------------------------------------------------*
IndBin(1) = iDIBin(2,iBin)
IndBin(2) = lIBin+lTop*ItoB
IndBin(3) = nSave
ValBin(1) = iDVBin(2,iBin)
ValBin(2) = lVBin+lTop*RtoB
ValBin(3) = nSave
!----------------------------------------------------------------------*
!     save the record on disk                                          *
!----------------------------------------------------------------------*
iDaTmp = iDIBin(1,iBin)
iDaTwo = iDVBin(1,iBin)
iOptIO = 1

! If a new sector mark it on the disk to make sure that it is continuous.

if (mod(nRec(iBin),nSect) == 0) then
  iDaTmp = mDaTmp
  iDaTwo = mDaTwo

  iScr(:) = 0
  call iDAFILE(LuTmp,iOptIO,iScr,(lStRec/idiv),mDaTmp)

  Scr(:) = Zero
  call dDAFILE(LuTwo,iOptIO,Scr,lStRec,mDaTwo)

  iDIBin(2,iBin) = iDaTmp
  iDVBin(2,iBin) = iDaTwo
  if (iDVBin(3,iBin) < 0) iDVBin(3,iBin) = iDaTwo
end if

call iDAFILE(LuTmp,iOptIO,IndBin,(lDaRec/idiv),iDaTmp)
iDIBin(1,iBin) = iDaTmp
call dDAFILE(LuTwo,iOptIO,ValBin,lDaRec,iDaTwo)
iDVBin(1,iBin) = iDaTwo
nRec(iBin) = nRec(iBin)+1
!----------------------------------------------------------------------*
!         cleanup                                                      *
!----------------------------------------------------------------------*
nKeep = nInts-nSave
if (nKeep > 0) then
  do i=1,nKeep
    lwIBin(i,iBin) = lwIBin(nSave+i,iBin)
    lwVBin(i,iBin) = lwVBin(nSave+i,iBin)
  end do
end if
n_Int(iBin) = nKeep

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine SaveBin

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine casinfoprint_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"

      if(ip(1).ge.0.and.(.not.up2date_cvb('CASPRINT')))then
        write(6,'(/,a,i4)')' Number of active electrons :',nel
        write(6,'(a,i4)')  ' Number of active orbitals  :',norb
        write(6,'(a,f4.1)')' Total spin                 :',
     >    DBLE(nalf-nbet)/two
        if(nsym.eq.1)then
          write(6,'(a,i4)')' State symmetry             :',isym
        else
          iqisym=mstacki_cvb(nsym)
          incr=0
          do i=1,mxirrep
          if(isymv(i).eq.1)then
            incr=incr+1
            iw(incr+iqisym-1)=i
          endif
          enddo
          write(6,'(a,i4,7i3)')' State symmetries           :',
     >      (iw(ii+iqisym-1),ii=1,nsym)
          call mfreei_cvb(iqisym)
        endif
        write(6,'(/,a,100i3)')' Symmetries of active MOs   : ',
     >    (ityp(ii),ii=1,norb)
        call make_cvb('CASPRINT')
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Input_Grid_It(iRun,INPORB)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************
!                                                                      *
! Object: input module for grid code                                   *
!                                                                      *
!***********************************************************************

use grid_it_globals, only: CutOff, Grid, GridAxis1, GridAxis2, GridAxis3, GridDense, GridNormal, GridOrigin, GridSparse, iGauss, &
                           iGridNpt, iMaxDown, iMaxUp, iReq, isAll, isAtom, iAuMO, iBinary, isColor, isCurDens, isCutOff, isDebug, &
                           isDensity, iDerivative, isLine, isLuscus, isMOPack, isSphere, isTheOne, isTotal, isUserGrid, isVirt, &
                           itRange, MAXGRID, nBytesPackedVal, nGridPoints, NoOrb, NoSort, nReq, OneCoor, Region, TheGap, TheName, &
                           Title1, Virt
use stdalloc, only: mma_allocate
use Constants, only: Zero, Four
use Definitions, only: wp, iwp, u5, u6

implicit none
integer(kind=iwp), intent(in) :: iRun
character(len=*), intent(out) :: INPORB
integer(kind=iwp) :: i, i_bits, iD, iDum(1), iErr, iKey, inUnit, iNet, iReadNet, iTemp(3), j, magicValue, n
logical(kind=iwp) :: isAuto, isCustOrig, isFileOrb, isSubBlock
real(kind=wp) :: dTemp(4), rD, rDum(1), rSubBlock, SubBlock(3), XFminCh
character(len=256) :: FileStr, FileIn
character(len=120) :: SelectStr
character(len=80) :: Key, MULLprt
character :: What
character(len=*), parameter :: AllKeys = 'PRIN BINA ASCI NPOI DENS SPAR ORBI REGI ONE  TITL &
                                         &GAP  END  NODE TOTA NAME VB   ALL  ATOM CUBE GRID &
                                         &PACK PKLI PKBI NOOR LINE ORAN ERAN DEBU CUTO NOPA &
                                         &GORI SELE NOSO FILE SPHR COLO VIRT MULL SUBB XDER &
                                         &YDER ZDER GDER CURD CRXJ UMAX NOLU XFIE LUS1 LUS2 &
                                         &PLUS MINU XFMI'
integer(kind=iwp), external :: MyGetKey

!do i=1,nRout
!  nPrint(i) = 5
!end do
iBinary = 3
isAuto = .true.
iNet = 0
iReadNet = 0
isTheOne = .false.
Title1 = ' '
TheName = ' '
TheGap = Four
!nMOmin = 0
!nGrid = 5
nReq = -1
isDensity = .true.
iDerivative = 0
isCurDens = .false.
!isRxJ = 0
!iuseMaxes = 0
iAuMO = -1
isAtom = .false.
isTotal = .false.
!isVB = 0
isAll = .false.
isUserGrid = .false.
iGauss = 0
NoOrb = .false.
iMaxUp = 7
iMaxDown = 7
isLine = .false.
itRange = 1
isDebug = .false.
isCutOff = .false.
CutOff = 2.5_wp
isCustOrig = .false.
NoSort = .false.
isFileOrb = .false.
isSphere = .false.
isColor = .false.
isVirt = .false.
!isMULL = 0
!isLONGPRT = 0
!isWDW = 0
isSubBlock = .false.
isLuscus = .true.
!isLusMath = 0
!aLusMath = -1
! not preparing the GRIDCHARGE file as external source for XFIELD input
!isXField = 0
XFminCh = Zero
! Default values for packing
isMOPack = .false.
!isBinPack = 0
!xLeft = 0.005_wp
!xRight = 0.7_wp
! (really, half range:)
!iyRange = 128
nBytesPackedVal = 1
!iMinYLeft = 4
!xLoErr = 0.10_wp
!xHiErr = Quart
INPORB = 'INPORB'
if (iRun == 0) then
  ! make defaults for a fast run via call from other module
  iNet = 1  ! set sparse
  !iBinary = 0 ! temporary set Ascii output
  !iMaxUp = 1
  !iMaxDown = 5
  !isMOPack = .false. ! packed grids not working with 64bit (?)
  !isCutOff = .true.
  !goto 500 (?)
end if
GridOrigin(:) = Zero
GridAxis1(:) = Zero
GridAxis2(:) = Zero
GridAxis3(:) = Zero

! KeyWord directed input

InUnit = u5
! Function MyGetKey (InUnit, What, IValue, RValue, SValue, N, IArray, RArray)

call RdNLst(InUnit,'GRID_IT')
do
  What = 'S'
  if (MyGetKey(InUnit,What,iD,rD,Key,iD,iDum,rDum) /= 0) exit
  iKey = index(AllKeys,Key(1:4))
  if ((iKey == 0) .or. ((iKey-1)/5*5 /= (iKey-1))) then
    write(u6,'(a,a)') 'Unrecognized keyword in input file:',Key(1:4)
    call Quit_OnUserError()
  end if
  iKey = (iKey-1)/5+1

  select case (iKey)
    case (1)
      ! PRIN
      What = 'I'
      if (MyGetKey(InUnit,What,n,rD,Key,iD,iDum,rDum) /= 0) call error()
      do j=1,n
        What = 'A'
        if (MyGetKey(InUnit,What,iD,rD,Key,2,iTemp,rDum) /= 0) call error()
        !write(u6,*) 'debug'
        !nPrint(iTemp(1)) = iTemp(2)
      end do
    case (2)
      ! BINARY = default
      iBinary = 1
    case (3)
      ! ASCII = for debug
      !write(u6,*) ' Keyword ASCII is obsolete'
      !write(u6,*) ' It can be used only for debugging purpose'
      !write(u6,*) ' Note that .lus files produced with this option '
      !write(u6,*) '      can not be visualised'
      iBinary = 0
    case (4)
      ! NPOI
      What = 'A'
      if (MyGetKey(InUnit,What,iD,rD,Key,3,iGridNpt,rDum) /= 0) call error()
      iNet = -1
      iReadNet = iReadNet+1
    case (5)
      ! DENSE - dense grid network..
      iNet = 2
      iReadNet = iReadNet+1
    case (6)
      ! SPARSE - rare grid network..
      iNet = 1
      iReadNet = iReadNet+1
    case (7)
      ! ORBI Orbitals
      if (nReq > 0) then
        write(u6,*) 'ORBI keyword can not be used together with SELEct'
        call Quit_OnUserError()
      end if
      What = 'I'
      if (MyGetKey(InUnit,What,nReq,rD,Key,iD,iDum,rDum) /= 0) call error()

      if (nReq > MAXGRID) then
        write(u6,'(a,i5,a,i5)') 'Too many requested orbitals ',nReq,'>',MAXGRID
        call Quit_OnUserError()
      end if
      read(inUnit,*,iostat=iErr) (iReq(i),i=1,nReq*2)
      if (iErr /= 0) call error()
      !What = 'A'
      !if (MyGetKey(InUnit,What,iD,rD,Key,nReq*2,iReq,rDum) /= 0) call error()
      iAuMO = 0
    case (8)
      ! REGION
      What = 'D'
      if (MyGetKey(InUnit,What,iD,rD,Key,2,iDum,Region) /= 0) call error()
      itRange = 1
      iAuMO = 1
      write(u6,*) ' *** Warning keyword REGION is obsolete'
      write(u6,*) ' ***         assumimg Energy range '
    case (9)
      ! ONE - debug option
      What = 'D'
      if (MyGetKey(InUnit,What,iD,rD,Key,7,iDum,OneCoor) /= 0) call error()
      isTheOne = .true.
      iBinary = 0
    case (10)
      ! TITLE
      ! NOTE: Title can be only ONE line here!!!
      What = 'S'
      if (MyGetKey(InUnit,What,iD,rD,Title1,iD,iDum,rDum) /= 0) call error()
    case (11)
      ! GAP
      What = 'R'
      if (MyGetKey(InUnit,What,iD,TheGap,Key,iD,iDum,rDum) /= 0) call error()
    case (12)
      ! END
      exit
    case (13)
      ! NODENSITY
      isDensity = .false.
    case (14)
      ! TOTAL
      isTotal = .true.
    case (15)
      ! NAME
      read(InUnit,'(a)') TheName
      !What = 'S'
      !if (MyGetKey(InUnit,What,iD,rD,TheName,iD,iDum,rDum) /= 0) call error()
      ! unfortunately MyGetKey uppercases strings!
    case (16)
      ! VB
      !isVB = 1
      call Quit_OnUserError()
    case (17)
      ! All
      isAll = .true.
    case (18)
      ! Atom
      isAtom = .true.
      iNet = -1
      iGridNpt(1) = 0
      iGridNpt(2) = 0
      iGridNpt(3) = 0
    case (19)
      ! CUBE
      iGauss = 1
      iBinary = 0
      write(u6,*) 'Cube option is moved to grid2cube'
      call Quit_OnUserError()
    case (20)
      ! Grid
      isUserGrid = .true.
      iBinary = 0
      iNet = -1
      iGridNpt(1) = 0
      iGridNpt(2) = 0
      iGridNpt(3) = 0
      What = 'I'
      if (MyGetKey(InUnit,What,nGridPoints,rD,Key,iD,iDum,rDum) /= 0) call error()
      call mma_allocate(Grid,3,nGridPoints,label='Grid')
      read(InUnit,*,iostat=iErr) Grid(:,:)
      if (iErr /= 0) call error()
    case (21)
      ! Pack
      !isMOPack = .true.
    case (22)
      ! PkLims
      What = 'D'
      if (MyGetKey(InUnit,What,iD,rD,Key,4,iDum,dTemp) /= 0) call error()
      !xLeft = dTemp(1)
      !xRight = dTemp(2)
      !xLoErr = dTemp(3)
      !xHiErr = dTemp(4)
    case (23)
      ! PkBits
      What = 'I'
      if (MyGetKey(InUnit,What,i_bits,rD,Key,iD,iDum,rDum) /= 0) call error()
      if (i_bits == 16) then
        !iyRange = 32768
        nBytesPackedVal = 2
      end if
    case (24)
      ! NoOrbitals
      NoOrb = .true.
    case (25)
      ! LINE - density on line
      What = 'D'
      if (MyGetKey(InUnit,What,iD,rD,Key,7,iDum,OneCoor) /= 0) call error()
      isTheOne = .true.
      isTotal = .true.
      iBinary = 0
      isLine = .true.
    case (26)
      ! ORANGE
      What = 'D'
      if (MyGetKey(InUnit,What,iD,rD,Key,2,iDum,Region) /= 0) call error()
      itRange = 0
      iAuMO = 1
      NoSort = .true.
    case (27)
      ! ERANGE
      What = 'D'
      if (MyGetKey(InUnit,What,iD,rD,Key,2,iDum,Region) /= 0) call error()
      itRange = 1
      iAuMO = 1
    case (28)
      ! DEBUG
      iBinary = 0
      isDebug = .true.
    case (29)
      ! CUTOFF
      What = 'R'
      if (MyGetKey(InUnit,What,iD,CutOff,Key,iD,iDum,rDum) /= 0) call error()
      isCutOff = .true.
    case (30)
      ! NOPACK
      !isMOPack = .false.
    case (31)
      ! GORI
      isCustOrig = .true.
      What = 'D'
      if (MyGetKey(InUnit,What,iD,rD,Key,3,iDum,GridOrigin) /= 0) call error()
      if (MyGetKey(InUnit,What,iD,rD,Key,3,iDum,GridAxis1) /= 0) call error()
      if (MyGetKey(InUnit,What,iD,rD,Key,3,iDum,GridAxis2) /= 0) call error()
      if (MyGetKey(InUnit,What,iD,rD,Key,3,iDum,GridAxis3) /= 0) call error()
    case (32)
      ! SELEct
      What = 'S'
      if (MyGetKey(InUnit,What,iD,rD,SelectStr,iD,iDum,rDum) /= 0) call error()
      if (nReq > 0) then
        write(u6,*) 'SELEct keyword can not be used together with ORBItals'
        call Quit_OnUserError()
      end if
      call gridExpandSelect(SelectStr)
      iAuMO = 0
    case (33)
      ! NOSOrt
      NoSort = .true.
    case (34)
      ! FILE
      read(InUnit,'(A)') FileIn
      isFileOrb = .true.
      call fileorb(FileIn,FileStr)
      write(u6,*) 'INPORB file: ',trim(FileStr)
    case (35)
      ! SPHR
      isSphere = .true.
    case (36)
      ! COLOr
      isColor = .true.
    case (37)
      ! VIRT
      isVirt = .true.
      What = 'R'
      if (MyGetKey(InUnit,What,iD,Virt,Key,iD,iDum,rDum) /= 0) call error()
    case (38)
      ! MULLiken charges per MO
      !isMULL = 1
      read(InUnit,'(A)') MULLPRT
      call upCASE(MULLPRT)
      MULLPRT = adjustl(MULLPRT)
      !if (MULLPRT(1:4) == 'LONG') isLONGPRT = 1
    case (39)
      ! SUBBLOCK
      What = 'D'
      if (MyGetKey(InUnit,What,iD,rD,Key,3,iDum,SubBlock) /= 0) call error()
      What = 'R'
      if (MyGetKey(InUnit,What,iD,rSubBlock,Key,iD,iDum,rDum) /= 0) call error()
      isSubBlock = .true.
    case (40)
      ! XDER
      iDerivative = 1
      call Quit_OnUserError()
    case (41)
      ! YDER
      iDerivative = 2
      call Quit_OnUserError()
    case (42)
      ! ZDER
      iDerivative = 3
      call Quit_OnUserError()
    case (43)
      iDerivative = 4
      call Quit_OnUserError()
    case (44)
      ! CURD (current density)
      isCurDens = .true.
      call Quit_OnUserError()
    case (45)
      ! CRXJ (current density, rxj)
      isCurDens = .true.
      !isRxJ = 1
      call Quit_OnUserError()
    case (46)
      ! UMAX (use magnetic axes)
      !iuseMaxes = 1
    case (47)
      ! NOLUSCUS
      isLuscus = .false.
      iBinary = 0
    case (48)
      ! XFIEld - ask Grid_It to compute electronic density on a DFT integration grid
      !isXField = 1
      iReadNet = iReadNet+1 !make the grid definition exclusive
    case (49)
      ! LUS1
      write(u6,*) 'Not implemented'
      !isLusMath = 1
      !read(InUnit,'(a)') LUS1
    case (50)
      ! LUS2
      write(u6,*) 'Not implemented'
      !isLusMath = 1
      !read(InUnit,'(a)') LUS2
    case (51)
      ! PLUS
      write(u6,*) 'Not implemented'
      !aLusMath = 1
    case (52)
      ! MINUS
      write(u6,*) 'Not implemented'
      !aLusMath = -1
    case (53)
      ! XFMI xfield minimum charge of each grid point to be stored
      What = 'R'
      if (MyGetKey(InUnit,What,iD,XFminCh,Key,iD,iDum,rDum) /= 0) call error()
    case default
  end select
end do

!***********************************************************************
!                                                                      *
!                       End of input section.                          *
!                                                                      *
!***********************************************************************
!if (isLusMath == 1) return
if (isLuscus .and. (iBinary == 0)) then
  write(u6,*) 'ASCII keyword is set, but NoLUSCUS is not'
  write(u6,*) 'calling abend as the best option available'
  call Quit_OnUserError()
end if
close(InUnit)
if (isLuscus .and. isLine) then
  write(u6,*) 'LUSCUS and LINE options are not compatible'
  call Quit_OnUserError()
end if

if (iReadNet > 1) write(u6,'(a)') 'Warning: Double definition of GRID net'

! Well, there is something to do!

if (isFileOrb) then
  INPORB = FileStr
end if
call OpenGrid(INPORB)

! try to generate grid position automatically

magicValue = 0
if (iNet >= 0) then
  magicValue = GridNormal
  if (iNet == 1) magicValue = GridSparse
  if (iNet == 2) magicValue = GridDense
end if
if (isCustOrig .and. (iNet /= -1)) then
  write(u6,*) 'GORI can be used only with NPOI'
  call Quit_OnUserError()
end if
call MyCoor(isAuto,GridOrigin(1),GridOrigin(2),GridOrigin(3),GridAxis1(1),GridAxis2(2),GridAxis3(3),iGridNpt(1),iGridNpt(2), &
            iGridNpt(3),magicValue,isCustOrig)

if (isSubBlock) then
  do i=1,3
    GridOrigin(i) = SubBlock(i)-rSubBlock
  end do
  GridAxis1(1) = rSubBlock*2
  GridAxis2(2) = rSubBlock*2
  GridAxis3(3) = rSubBlock*2
  iGridNpt(1) = 40
  iGridNpt(2) = 40
  iGridNpt(3) = 40
end if

return

contains

subroutine error()
  write(u6,'(a,a,a)') 'Error during reading ',Key(1:20),'section in input file'
  call Quit_OnUserError()
end subroutine error

end subroutine Input_Grid_It

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
*  CHO_get_ER
*
*> @brief
*>   Compute the Edmiston--Ruedenberg functional for a given set of occupied MOs
*> @author F. Aquilante
*>
*> @details
*> Computes the Edmiston--Ruedenberg functional
*>
*> \f[ W = \sum_i \mathit{ER}[i] = \sum_i (ii|ii) \f]
*>
*> for a given set of occupied MOs.
*>
*> The functional orbital components \p ER(i) are
*> computed by using the Cholesky representation \f$ L_{ab,J} \f$
*> of the AO two-electron integrals, namely
*>
*> \f[ \mathit{ER}[i] = \sum_J V[i]_J V[i]_J \f]
*>
*> where
*>
*> \f[ V[i]_J = \sum_{ab} D[i]_{ab} L_{ab,J} \f]
*>
*> and
*>
*> \f[ D[i]_{a,b} = C[i]_a C[i]_b \f]
*>
*> @note
*> Requires initialization of the Cholesky information.
*>
*> @param[out]    irc     return code
*> @param[in]     CMO     MOs matrix, stored as \p C(a,k)
*> @param[in]     nOcc    number of occupied orbitals in each symmetry
*> @param[in,out] ER      orbital components of the ER functional}
*> @param[in,out] W       value of the Edmiston--Ruedenberg functional
*> @param[in]     timings switch on/off timings printout
************************************************************************
      SUBROUTINE CHO_get_ER(irc,CMO,nOcc,ER,W,timings)
      Implicit Real*8 (a-h,o-z)
      Logical timings
      Integer nOcc(*),iOcc(8),isMO(8)
      Real*8  CMO(*),ER(*),W
      Real*8  tread(2),tintg(2)
      Character*10  SECNAM

      parameter (SECNAM = 'CHO_get_ER')
      parameter (zero = 0.0d0, half = 0.5d0, two = 2.0d0)

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )

************************************************************************
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
************************************************************************

      IREDC = -1

      JSYM=1
      If (NumCho(JSYM).lt.1) Then
         Write(6,*)SECNAM//'No total symmetric vectors present'
         irc = 77
         Return
      EndIf

      CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

      do i=1,2            ! 1 --> CPU   2 --> Wall
         tread(i) = zero  !time for reading the vectors
         tintg(i) = zero  !time for computing the functional
      end do

C --- compute some offsets and other quantities
      MaxB=nBas(1)
      iOcc(1)=0
      isMO(1)=0
      Do kSym=2,nSym
         iOcc(kSym) = iOcc(kSym-1) + nOcc(kSym-1)
         isMO(kSym) = isMO(kSym-1) + nBas(kSym-1)**2
         MaxB = Max(MaxB,nBas(kSym))
      End Do

      MaxBB = MaxB*(MaxB+1)/2
      nOccT = iOcc(nSym) + nOcc(nSym)

      W = zero ! initialization of the ER-functional value
      Call Fzero(ER(1),nOccT) ! and its orbital components

      Call GetMem('DLT','Allo','Real',ipDLT,MaxBB)
      Call Fzero(Work(ipDLT),MaxBB)

      iLoc = 3 ! use scratch location in reduced index arrays

      JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
      JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

      Do JRED=JRED1,JRED2

C --- Memory management section -----------------------------
C ---
      CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

      if (nVrs.eq.0) goto 999

      if (nVrs.lt.0) then
         Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs < 0. STOP!!'
         call abend()
      endif

      Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
      if(irc.ne.0)then
        Write(6,*)SECNAM//'cho_X_setred non-zero return code. rc= ',irc
        call abend()
      endif

      IREDC=JRED

      nRS = nDimRS(JSYM,JRED)

      Call GetMem('rsD','Allo','Real',ipDab,nRS)

      Call GetMem('MaxM','Max','Real',KDUM,LWORK)

      nVec  = Min(LWORK/(nRS+1),nVrs)

      If (nVec.lt.1) Then
         WRITE(6,*) SECNAM//': Insufficient memory for batch'
         WRITE(6,*) 'LWORK= ',LWORK
         WRITE(6,*) 'min. mem. need= ',nRS+1
         irc = 33
         CALL Abend()
         nBatch = -9999  ! dummy assignment
      End If

      LREAD = nRS*nVec

      Call GetMem('rsL','Allo','Real',ipLab,LREAD)
      Call GetMem('VJ','Allo','Real',ipVJ,nVec)

C --- BATCH over the vectors in JSYM=1 ----------------------------

      nBatch = (nVrs-1)/nVec + 1

      DO iBatch=1,nBatch

         If (iBatch.eq.nBatch) Then
            JNUM = nVrs - nVec*(nBatch-1)
         else
            JNUM = nVec
         endif

         JVEC = nVec*(iBatch-1) + iVrs
         IVEC2 = JVEC - 1 + JNUM

         CALL CWTIME(TCR1,TWR1)

         CALL CHO_VECRD(Work(ipLab),LREAD,JVEC,IVEC2,JSYM,
     &                  NUMV,JRED,MUSED)

         If (NUMV.le.0 .or. NUMV.ne.JNUM) then
            irc=77
            RETURN
         End If

         CALL CWTIME(TCR2,TWR2)
         tread(1) = tread(1) + (TCR2 - TCR1)
         tread(2) = tread(2) + (TWR2 - TWR1)

         CALL CWTIME(TCI1,TWI1)

         Do kSym=1,nSym

            Do ik=1,nOcc(kSym)

C --- Compute the i-th orbital component D[i](a,b) of the density
C --- D[i](a,b) is stored as upper-triangular
               Do ib=1,nBas(kSym)

                  ipb = isMO(kSym) + nBas(kSym)*(ik-1) + ib

                  Do ia=1,ib-1

                     ipa = isMO(kSym) + nBas(kSym)*(ik-1) + ia
                     ipab = ipDLT + ib*(ib-1)/2 + ia - 1
                     Work(ipab) = CMO(ipa)*CMO(ipb)

                  End Do

                  ipab = ipDLT + ib*(ib+1)/2 - 1
                  Work(ipab) = half*CMO(ipb)**2  !diagonal scaled

               End Do

C --- Transform the density to reduced storage
               Call switch_density(iLoc,ipDLT,ipDab,kSym)

C  ( r .ge. s )
C ------------------------------------------------------------
C --- V[i]{#J} <- V[i]{#J} + 2 * sum_rs  L(rs,{#J}) * D[i](rs)
C=============================================================

               CALL DGEMV_('T',nRS,JNUM,
     &                    TWO,Work(ipLab),nRS,
     &                    Work(ipDab),1,ZERO,Work(ipVJ),1)


C ----------------------------------------------------------
C --- ER[i] <- ER[i]  +  sum_J V[i](J)^2
C===========================================================
               Do jv=1,JNUM

                  ER(iOcc(kSym)+ik) = ER(iOcc(kSym)+ik)
     &                              + Work(ipVJ+jv-1)**2
               End Do


            End Do


         End Do

         CALL CWTIME(TCI2,TWI2)
         tintg(1) = tintg(1) + (TCI2 - TCI1)
         tintg(2) = tintg(2) + (TWI2 - TWI1)


      END DO  !end batch loop

C --- free memory
      Call GetMem('VJ','Free','Real',ipVJ,nVec)
      Call GetMem('rsL','Free','Real',ipLab,LREAD)
      Call GetMem('rsD','Free','Real',ipDab,nRS)


999   Continue

      END DO   ! loop over red sets

      Call GetMem('DLT','Free','Real',ipDLT,MaxBB)

C --- Sync components
      Call GAdGOp(ER,nOccT,'+')

C --- Compute the ER-functional from its orbital components
      W = Zero
      Do ik=1,nOccT
         W = W + ER(ik)
      End Do



      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1

*
*---- Write out timing information
      if(timings)then

      Write(6,*)
      Write(6,*)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)'Timing from ', SECNAM,'            CPU      WALL '
      Write(6,*)'- - - - - - - - - - - - - - - - - - - - - - - - -'
         Write(6,'(2x,A26,2f10.2)')'READ VECTORS                     '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COMPUTE (ii|ii)                  '
     &                           //'         ',tintg(1),tintg(2)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,*)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


      irc=0

      Return
      End



      SUBROUTINE switch_density(iLoc,ipXLT,ipXab,kSym)

      Implicit Real*8 (a-h,o-z)
      Integer  cho_isao
      External cho_isao

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

************************************************************************
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
******
      IndRed(i,k) = iWork(ip_IndRed-1+nnBstrT(1)*(k-1)+i)
******
      iRS2F(i,j)  = iWork(ip_iRS2F-1+2*(j-1)+i)
************************************************************************

      jSym = 1 ! only total symmetric density

      Do jRab=1,nnBstR(jSym,iLoc)

         kRab = iiBstr(jSym,iLoc) + jRab
         iRab = IndRed(kRab,iLoc)

         iag   = iRS2F(1,iRab)  !global address
         ibg   = iRS2F(2,iRab)

         iSyma = cho_isao(iag)  !symmetry block; Sym(b)=Sym(a)

         xf = dble(1-min(1,abs(iSyma-kSym)))

         ias   = iag - ibas(iSyma)  !address within that symm block
         ibs   = ibg - ibas(iSyma)
         iab   = iTri(ias,ibs)

         kfrom = ipXLT + iab - 1

         Work(ipXab+jRab-1) = xf*Work(kfrom)

      End Do  ! jRab loop


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine TRIPK2_2(AUTPAK,APAK,MATDIM,NDIM,SGN)
! REFORMATTING BETWEEN LOWER TRIANGULAR PACKING
! AND FULL MATRIX FORM FOR A SYMMETRIC OR ANTI SYMMETRIC MATRIX
!
! PACKED TO FULL FORM
! APAK STORED IN LOWER HALF
!  SGN * APAK TRANSPOSED IS STORED IN UPPPER PART
! NOTE : COLUMN WISE STORAGE SCHEME IS USED FOR PACKED BLOCKS

use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: MATDIM, NDIM
real(kind=wp), intent(out) :: AUTPAK(MATDIM,MATDIM)
real(kind=wp), intent(in) :: APAK(*), SGN
integer(kind=iwp) :: IJ, J

IJ = 0
do J=1,NDIM
  AUTPAK(J,J:NDIM) = SGN*APAK(IJ+J:IJ+NDIM)
  AUTPAK(J:NDIM,J) = APAK(IJ+J:IJ+NDIM)
  IJ = IJ+NDIM-J
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' AUTPAK AND APAK FROM TRIPK2_2'
call WRTMAT(AUTPAK,NDIM,MATDIM,NDIM,MATDIM)
call PRSM2(APAK,NDIM)
#endif

end subroutine TRIPK2_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE SIGDER(IVEC,JVEC,SCAL)
      use definitions, only: wp, iwp
      use constants, only: Zero, One, Two
      use Fockof, only: FAI_Full, FAT_Full, FIA_Full, FIT_Full,
     &                  FTA_Full, FTI_Full, IOFFIT, IOFFIA, IOFFTA,
     &                  FIT, FTI, FIA, FAI, FAT, FTA
      use caspt2_global, only: LUSTD,idSDMat
      use caspt2_global, only: FIFA,LISTS
      use stdalloc, only: mma_allocate, mma_deallocate
      use EQSOLV, only: IFCOUP
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      USE Para_Info, ONLY: Is_Real_Par, King
#endif
      use fake_GA, only: Allocate_GA_Array, Deallocate_GA_Array,
     &                   GA_Arrays
      use caspt2_module, only: CPUSGM, TIOSGM, FockType, G1SecIn,
     &                         nActEl, nCases, nSym, nASup, nIsh, nAsh,
     &                         nSsh, nOrb, nInDep, nISup
      IMPLICIT None
#if defined(_MOLCAS_MPP_) && defined(_GA_)
#include "global.fh"
#endif
      integer(kind=iwp), intent(in):: iVec, jVec
      real(kind=wp), intent(in) :: Scal

      real(kind=wp) CPU, CPU0, CPU1
      real(kind=wp) TIO, TIO0, TIO1
      real(kind=wp) FACT
      integer(kind=iwp) iCase, iCase1, idSDer, IfC, IFIFA, iLoop,
     &                  IMLTOP, ISYM, ISYM1, ISYM2, lCX, lg_CX, lg_D2,
     &                  lg_Sgm2, Lg_SgmX, lg_V1, lSgmX,
     &                  lSgmX_Sta, Max_MESG_SIZE, NA, NAS, NAS1, NAS2,
     &                  nCX, nD1, NFIA, NFIT, NFTA, NI, NIN1, NIN2,
     &                  NIS1, NIS2, nLoop, NO, NS, nSgm1, nSgm2,
     &                  lSgm2_Sta, nD2, iCase2, nSgm2_Blk, nSgmX,
     &                  nSgmX_Blk
      real(kind=wp), allocatable :: WRK(:),SDER1(:),SDER2(:),SGM1(:),
     &                              D1(:), SGM2(:), D2(:)
      integer(kind=iwp) MaxLen
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      logical(kind=iwp) :: bStat
#endif
C
C     Work in the MO basis
C     We need both explicit and implicit overlap derivatives. The latter
C     comes from the derivative of the transformation matrix.
C
C     p,q: inactive or secondary
C     y,z: active (t,u)
C     a,b: internally contracted
C     T1_{px} * S1_{xy} f_{yz} * T2_{pz}
C     = T1pa*C1xa * S1xy * fyz * T2pb*C2zb
C     Derivative of S1:
C     = (T1Ct1)px * (T2Ct2*f)py * dS1xy/da
C     Derivative of C1 (or, Lagrangian multiplier in MO basis):
C     = T1pa*dC1xa/da * S1xy * fyz * T2pb*C2zb
C       ...
C     = -1/2 (T1Ct1)pu * dS1tu/da * (T2Ct2*f*S1C1*Ct1)pt
C     Derivative of C2 (or, Lagrangian multiplier in MO basis):
C     = T1pa*C1xa * S1xy * fyz * T2pb*dC2zb/da
C       ...
C     = -1/2 (T1Ct1St1*f*C2*Ct2)pt * (T2Ct2)pu * dS2tu/da
C
C     About IMLTOP for the SGM subroutine
C     With IMLTOP=0: the vector for the second argument has to be
C     contravariant form (T*C),
C     With IMLTOP=1: the vector for the first  argument has to be
C     covariant form (T*SC),
C
C
C     Allocate some matrices for storing overlap and transformation
C     derivatives. Here constructs these derivatives in the MO basis,
C     but not in the internally contracted basis.
C
      MaxLen = 0
      Do iCase = 1, 11
        Do iSym = 1, nSym
          nAS = nASUP(iSym,iCase)
          MaxLen = Max(MaxLen,nAS*nAS)
        End Do
      End Do
C
      call mma_allocate(WRK,MaxLen,Label='WRK')
      Call DCopy_(MaxLen,[Zero],0,WRK,1)
C
      Do iCase = 1, 11
        Do iSym = 1, nSym
          nAS = nASUP(iSym,iCase)
          idSDer = idSDMat(iSym,iCase)
          CALL DDAFILE(LuSTD,1,WRK,nAS*nAS,idSDer)
        End Do
      End Do
      call mma_deallocate(WRK)
C
C If the G1 correction to the Fock matrix is used, then the
C inactive/virtual coupling elements (which are non-zero for the
C case of average CASSCF) cannot be used in the CASPT2 equations.
      IF(FOCKTYPE.EQ.'G1      ' .AND. (.NOT. G1SECIN)) THEN
        IFCOUP(12,5)=0
        IFCOUP(13,5)=0
      END IF


C Transform to standard representation:
      CALL PTRTOC(0,IVEC,IVEC) !! T*C (internally contracted -> MO)
      IF(IVEC.NE.JVEC) CALL PTRTOC(0,JVEC,JVEC)

C Set up non-diagonal blocks of Fock matrix:
C SVC: add transposed fock matrix blocks
      NFIT=0
      NFIA=0
      NFTA=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NS=NSSH(ISYM)
        IOFFIT(ISYM)=NFIT
        IOFFIA(ISYM)=NFIA
        IOFFTA(ISYM)=NFTA
        NFIT=NFIT+NA*NI
        NFIA=NFIA+NS*NI
        NFTA=NFTA+NS*NA
      END DO
      NFIT=NFIT+1
      NFIA=NFIA+1
      NFTA=NFTA+1

      Call mma_allocate(FIT_Full,NFIT,Label='FIT_Full')
      Call mma_allocate(FTI_Full,NFIT,Label='FTI_Full')

      Call mma_allocate(FIA_Full,NFIA,Label='FIA_Full')
      Call mma_allocate(FAI_Full,NFIA,Label='FAI_Full')

      Call mma_allocate(FTA_Full,NFTA,Label='FTA_Full')
      Call mma_allocate(FAT_Full,NFTA,Label='FAT_Full')

      IFIFA=1
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NS=NSSH(ISYM)
        NO=NORB(ISYM)

        FIT(ISYM)%A(1:NA*NI) =>
     &     FIT_Full(IOFFIT(ISYM)+1:IOFFIT(ISYM)+NA*NI)
        FTI(ISYM)%A(1:NA*NI) =>
     &     FTI_Full(IOFFIT(ISYM)+1:IOFFIT(ISYM)+NA*NI)

        FIA(ISYM)%A(1:NS*NI) =>
     &     FIA_Full(IOFFIA(ISYM)+1:IOFFIA(ISYM)+NS*NI)
        FAI(ISYM)%A(1:NS*NI) =>
     &     FAI_Full(IOFFIA(ISYM)+1:IOFFIA(ISYM)+NS*NI)

        FTA(ISYM)%A(1:NS*NA) =>
     &     FTA_Full(IOFFTA(ISYM)+1:IOFFTA(ISYM)+NS*NA)
        FAT(ISYM)%A(1:NS*NA) =>
     &     FAT_Full(IOFFTA(ISYM)+1:IOFFTA(ISYM)+NS*NA)

        CALL FBLOCK(FIFA(IFIFA),NO,NI,NA,NS,
     &              FIT(ISYM)%A(:),FTI(ISYM)%A(:),
     &              FIA(ISYM)%A(:),FAI(ISYM)%A(:),
     &              FTA(ISYM)%A(:),FAT(ISYM)%A(:))

        IFIFA=IFIFA+(NO*(NO+1))/2

      END DO

      CALL TIMING(CPU0,CPU,TIO0,TIO)
C
C     Is it possible to reduce to one loop? We have to compute bra and
C     ket overlap and bra and ket wavefunctions are not identical, so
C     it seems impossible to reduce?
C
      NLOOP=2
      DO ILOOP=1,NLOOP
        !! ILOOP1 : <T+lambda|H|T       >
        !! ILOOP2 : <T       |H|T+lambda>

C Loop over types and symmetry block of sigma vector:
      DO ICASE1=1,11
*     DO ICASE1=1,NCASES
        DO ISYM1=1,NSYM
          IF(NINDEP(ISYM1,ICASE1).EQ.0) Cycle
          NIS1=NISUP(ISYM1,ICASE1)
          NAS1=NASUP(ISYM1,ICASE1)
          NIN1=NINDEP(ISYM1,ICASE1)
          NSGM2=NIS1*NAS1
          IF(NSGM2.EQ.0) Cycle

          CALL mma_allocate(SGM2,NSGM2,Label='SGM2')
          SGM2(:)=Zero

          NSGM1=0
C         LSGM1=1
          IF(ICASE1.EQ.1) THEN
            NSGM1=NASH(ISYM1)*NISH(ISYM1)
          ELSE IF(ICASE1.EQ.4) THEN
            NSGM1=NASH(ISYM1)*NSSH(ISYM1)
          ELSE IF(ICASE1.EQ.5.AND.ISYM1.EQ.1) THEN
            NSGM1=NIS1
          END IF
          CALL mma_allocate(SGM1,MAX(1,NSGM1),Label='SGM1')
          SGM1(:) = Zero

          IMLTOP=0
          DO ICASE2=ICASE1+1,NCASES
            IFC=IFCOUP(ICASE2,ICASE1)
            IF(IFC.EQ.0) Cycle
            DO ISYM2=1,NSYM
              IF(NINDEP(ISYM2,ICASE2).EQ.0) Cycle
              NIS2=NISUP(ISYM2,ICASE2)
              NAS2=NASUP(ISYM2,ICASE2)
              NCX=NIS2*NAS2
              IF(NCX.EQ.0) Cycle

              CALL RHS_ALLO(NAS2,NIS2,lg_CX)
              CALL RHS_READ(NAS2,NIS2,lg_CX,ICASE2,ISYM2,IVEC)
              IF (IVEC.NE.JVEC .AND. ILOOP.EQ.2) THEN
                !! T = T + \lambda
                If (SCAL.ne.One)
     &             CALL RHS_SCAL(NAS2,NIS2,lg_CX,SCAL)
                CALL RHS_ALLO(NAS2,NIS2,lg_V1)
                CALL RHS_READ(NAS2,NIS2,lg_V1,ICASE2,ISYM2,JVEC)
                CALL RHS_DAXPY(NAS2,NIS2,One,lg_V1,lg_CX)
                CALL RHS_FREE(lg_V1)
              END IF
C SVC: for case H (12,13) we can now pass the distributed array ID to
C the SGM subroutines
              IF (ICASE2.EQ.12 .OR. ICASE2.EQ.13) THEN
                LCX=lg_CX
C               XTST=RHS_DDOT(NAS2,NIS2,lg_CX,lg_CX)
              ELSE
                LCX=Allocate_GA_Array(NCX,'CX')
                CALL RHS_GET(NAS2,NIS2,lg_CX,GA_Arrays(LCX)%A)
                CALL RHS_FREE(lg_CX)
C               XTST=DDOT_(NCX,GA_Arrays(LCX)%A,1,
C    &                         GA_Arrays(LCX)%A,1)
              END IF

#ifdef _DEBUGPRINT_
              WRITE(6,*)' ISYM1,ICASE1:',ISYM1,ICASE1
              WRITE(6,*)' ISYM2,ICASE2:',ISYM2,ICASE2
              WRITE(6,*)' SIGMA calling SGM with IMLTOP=',IMLTOP
#endif
C Compute contribution SGM2 <- CX, and SGM1 <- CX  if any
              CALL SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,
     &                 SGM1,SGM2,LCX,LISTS)

              IF (ICASE2.EQ.12 .OR. ICASE2.EQ.13) THEN
                CALL RHS_FREE(lg_CX)
              ELSE
                Call Deallocate_GA_Array(LCX)
              END IF
            End Do
          End Do

C-SVC: sum the replicate arrays:
          MAX_MESG_SIZE = 2**27
          DO LSGM2_STA=1,NSGM2,MAX_MESG_SIZE
            NSGM2_BLK=MIN(MAX_MESG_SIZE,NSGM2-LSGM2_STA+1)
            CALL GADSUM(SGM2(LSGM2_STA),NSGM2_BLK)
          END DO

          IF (NSGM1.GT.0) THEN
            CALL GADSUM(SGM1,NSGM1)
          END IF

C If there are 1-electron contributions, add them into the 2-el
C part (This requires a non-empty active space.)
          IF(NSGM1.GT.0) THEN
            FACT=One/(DBLE(MAX(1,NACTEL)))
            IF (ICASE1.EQ.1) THEN
              CALL SPEC1A(IMLTOP,FACT,ISYM1,SGM2,SGM1)
            ELSE IF(ICASE1.EQ.4) THEN
              CALL SPEC1C(IMLTOP,FACT,ISYM1,SGM2,SGM1)
            ELSE IF(ICASE1.EQ.5.AND.ISYM1.EQ.1) THEN
              CALL SPEC1D(IMLTOP,FACT,SGM2,SGM1)
            END IF
          END IF
          call mma_deallocate(SGM1)

C-SVC: no need for the replicate arrays any more, fall back to one array
          CALL RHS_ALLO (NAS1,NIS1,lg_SGM2)
          CALL RHS_PUT (NAS1,NIS1,lg_SGM2,SGM2)
          CALL mma_deallocate(SGM2)

C Add to sigma array. Multiply by S to  lower index.
C         CALL RHS_ALLO(NAS1,NIS1,lg_SGMX)
C         CALL RHS_READ(NAS1,NIS1,lg_SGMX,ICASE1,ISYM1,JVEC)
          IF (ICASE1.LE.11) THEN
            CALL RHS_ALLO(NAS1,NIS1,lg_CX)
            CALL RHS_READ(NAS1,NIS1,lg_CX,ICASE1,ISYM1,IVEC)
            If (IVEC.NE.JVEC .AND. ILOOP.EQ.1) Then
              !! T = T + \lambda
              If (SCAL.ne.One) CALL RHS_SCAL(NAS1,NIS1,lg_CX,SCAL)
              CALL RHS_ALLO(NAS1,NIS1,lg_V1)
              CALL RHS_READ(NAS1,NIS1,lg_V1,ICASE1,ISYM1,JVEC)
              CALL RHS_DAXPY(NAS1,NIS1,One,lg_V1,lg_CX)
              CALL RHS_FREE(lg_V1)
            End If

            call mma_allocate(SDER1,NAS1*NAS1,Label='SDER1')
            idSDer = idSDMat(iSym1,iCase1)
            CALL DDAFILE(LuSTD,2,SDER1,nAS1*nAS1,idSDer)

            Call C1S1DER(SDER1)

            idSDer = idSDMat(iSym1,iCase1)
            CALL DDAFILE(LuSTD,1,SDER1,nAS1*nAS1,idSDer)
            call mma_deallocate(SDER1)

            CALL RHS_FREE(lg_CX)
          END IF

*         IF(ICASE1.NE.12 .AND. ICASE1.NE.13) THEN
C           CALL RHS_STRANS(NAS1,NIS1,ALPHA,lg_SGM2,lg_SGMX,
C    &                      ICASE1,ISYM1)
*         ELSE
*           CALL RHS_DAXPY(NAS1,NIS1,ALPHA,lg_SGM2,lg_SGMX)
*         END IF
          CALL RHS_FREE (lg_SGM2)

C Write SGMX to disk.
C         CALL RHS_SAVE (NAS1,NIS1,lg_SGMX,ICASE1,ISYM1,JVEC)
C         CALL RHS_FREE (lg_SGMX)
        End Do
      End Do

      IMLTOP=1
C Loop over types and symmetry block of CX vector:
      DO ICASE1=1,11
*     DO ICASE1=1,NCASES
        DO ISYM1=1,NSYM
          IF(NINDEP(ISYM1,ICASE1).EQ.0) Cycle
          NIS1=NISUP(ISYM1,ICASE1)
          NAS1=NASUP(ISYM1,ICASE1)
          ND2=NIS1*NAS1
          IF(ND2.EQ.0) Cycle

          CALL RHS_ALLO (NAS1,NIS1,lg_D2)
          CALL RHS_SCAL (NAS1,NIS1,lg_D2,Zero)
C Contract S*CX to form D2. Also form D1 from D2, if needed.

          NCX=ND2
          CALL RHS_ALLO (NAS1,NIS1,lg_CX)
          CALL RHS_READ (NAS1,NIS1,lg_CX,ICASE1,ISYM1,IVEC)

          IF (IVEC.NE.JVEC .AND. ILOOP.EQ.1) THEN
            !! T = T + \lambda
            If (SCAL.ne.One) CALL RHS_SCAL(NAS1,NIS1,lg_CX,SCAL)
            CALL RHS_ALLO(NAS1,NIS1,lg_V1)
            CALL RHS_READ(NAS1,NIS1,lg_V1,ICASE1,ISYM1,JVEC)
            CALL RHS_DAXPY(NAS1,NIS1,One,lg_V1,lg_CX)
            CALL RHS_FREE(lg_V1)
          END IF

          IF(ICASE1.NE.12 .AND. ICASE1.NE.13) THEN
           CALL RHS_STRANS(NAS1,NIS1,One,lg_CX,lg_D2,
     &                     ICASE1,ISYM1)
          ELSE
           CALL RHS_DAXPY(NAS1,NIS1,One,lg_CX,lg_D2)
          END IF
          CALL RHS_FREE (lg_CX)

          CALL mma_allocate(D2,ND2,Label='D2')
          CALL RHS_GET (NAS1,NIS1,lg_D2,D2)
          CALL RHS_FREE (lg_D2)

          ND1=0
C         LD1=1
          IMLTOP=1
          FACT=One/(DBLE(MAX(1,NACTEL)))
          IF(ICASE1.EQ.1) THEN
            ND1=NASH(ISYM1)*NISH(ISYM1)
            IF(ND1.GT.0) THEN
              call mma_allocate(D1,ND1,Label='D1')
              D1(:) = Zero
              CALL SPEC1A(IMLTOP,FACT,ISYM1,D2,D1)
            END IF
          ELSE IF(ICASE1.EQ.4) THEN
            ND1=NASH(ISYM1)*NSSH(ISYM1)
            IF(ND1.GT.0) THEN
              call mma_allocate(D1,ND1,Label='D1')
              D1(:) = Zero
              CALL SPEC1C(IMLTOP,FACT,ISYM1,D2,D1)
            END IF
          ELSE IF(ICASE1.EQ.5.AND.ISYM1.EQ.1) THEN
            ND1=NIS1
            IF(ND1.GT.0) THEN
              call mma_allocate(D1,ND1,Label='D1')
              D1(:) = Zero
              CALL SPEC1D(IMLTOP,FACT,D2,D1)
            END IF
          END IF
          If (.NOT.ALLOCATED(D1)) CALL mma_allocate(D1,1,Label='D1')

          !! No need to compute for ICASE2 = 12 and 13
          DO ICASE2=ICASE1+1,11 !! NCASES
            IF(IFCOUP(ICASE2,ICASE1).EQ.0) Cycle
            DO ISYM2=1,NSYM
              IF(NINDEP(ISYM2,ICASE2).EQ.0) Cycle
              NIS2=NISUP(ISYM2,ICASE2)
              NAS2=NASUP(ISYM2,ICASE2)
              NIN2=NINDEP(ISYM2,ICASE2)
              NSGMX=NIS2*NAS2
              IF(NSGMX.EQ.0) Cycle

              IF (ICASE2.EQ.12 .OR. ICASE2.EQ.13) THEN
                CALL RHS_ALLO(NAS2,NIS2,lg_SGMX)
                CALL RHS_READ(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
                LSGMX=lg_SGMX
              ELSE
                LSGMX=Allocate_GA_Array(NSGMX,'SGMX')
              END IF

#ifdef _DEBUGPRINT_
              WRITE(6,*)' ISYM1,ICASE1:',ISYM1,ICASE1
              WRITE(6,*)' ISYM2,ICASE2:',ISYM2,ICASE2
              WRITE(6,*)' SIGMA calling SGM with IMLTOP=',IMLTOP
#endif
C Compute contribution SGMX <- D2, and SGMX <- D1  if any
              CALL SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,
     &                 D1,D2,LSGMX,LISTS)
C             If (iCase2.LE.11) Then
C             End If

              IF (ICASE2.NE.12 .AND. ICASE2.NE.13) THEN
                MAX_MESG_SIZE = 2**27
                DO LSGMX_STA=1,NSGMX,MAX_MESG_SIZE
                  NSGMX_BLK=MIN(MAX_MESG_SIZE,NSGMX-LSGMX_STA+1)
                  CALL GADSUM(GA_Arrays(LSGMX)%A(LSGMX_STA),
     &                        NSGMX_BLK)
                END DO
C               CALL RHS_ALLO(NAS2,NIS2,lg_SGMX)
C               CALL RHS_READ(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
C               CALL RHS_ADD(NAS2,NIS2,lg_SGMX,GA_Array(LSGMX)%A)
                !! do C2DER
                call mma_allocate(SDER2,NAS2*NAS2,Label='SDER2')
                idSDer = idSDMat(iSym2,iCase2)
                CALL DDAFILE(LuSTD,2,SDER2,nAS2*nAS2,idSDer)

                Call C2DER(SDER2)

                idSDer = idSDMat(iSym2,iCase2)
                CALL DDAFILE(LuSTD,1,SDER2,nAS2*nAS2,idSDer)
                call mma_deallocate(SDER2)
                !!
C               Call Deallocate_GA_Array(LSGMX)
              END IF

C-SVC: no need for the replicate arrays any more, fall back to one array
C             CALL RHS_SAVE (NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
              IF (ICASE2.EQ.12 .OR.ICASE2.EQ.13) THEN
                CALL RHS_FREE (lg_SGMX)
              ELSE
                Call Deallocate_GA_Array(LSGMX)
              END IF
            End Do
          End Do
          CALL mma_deallocate(D2)
          call mma_deallocate(D1)
        End Do
      End Do

      End Do
C
C
C
      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUSGM=CPUSGM+(CPU1-CPU0)
      TIOSGM=TIOSGM+(TIO1-TIO0)
C
      Call mma_deallocate(FIT_Full)
      Call mma_deallocate(FTI_Full)
      Call mma_deallocate(FIA_Full)
      Call mma_deallocate(FAI_Full)
      Call mma_deallocate(FTA_Full)
      Call mma_deallocate(FAT_Full)
      Do iSym = 1, nSym
         nullify(FIT(iSym)%A,FTI(iSym)%A,FIA(iSym)%A,FAI(iSym)%A,
     &           FTA(iSym)%A,FAT(iSym)%A)
      End Do

C Transform contrav C  to ei%Agenbasis of H0(diag):
      CALL PTRTOSR(1,IVEC,IVEC)
      IF(IVEC.NE.JVEC) CALL PTRTOSR(1,JVEC,JVEC)


      Contains
C
C-----------------------------------------------------------------------
C
      Subroutine C1S1DER(SDER)
C
      Implicit None
C
      real(kind=wp), intent(inout):: SDER(*)

      integer(kind=iwp) iType
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      integer(kind=iwp) lg_SDER
#endif
C
C     (T2Ct2*f)py * (T1Ct1)pz * dS1yz/da
C     -1/2 (T2Ct2*f*S1*C1*Ct1)pt * (T1Ct1)pu * dS1tu/da
C
      !! Finalize the derivative of S1
      !! 2S. (T2Ct2*f) * T1Ct1
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      if (is_real_par()) then
        CALL GA_CREATE_STRIPED ('H',NAS1,NAS1,'SDER',lg_SDER)
        CALL GA_PUT(lg_SDER,1,NAS1,1,NAS1,SDER,NAS1)
        call GA_DGEMM ('N','T',NAS1,NAS1,NIS1,
     *                 Two,lg_CX,lg_SGM2,One,lg_SDER)
      else
#endif
        Call DGEMM_('N','T',NAS1,NAS1,NIS1,
     *              Two,GA_Arrays(lg_CX)%A,NAS1,
     &                      GA_Arrays(lg_SGM2)%A,NAS1,
     *              One,SDER,NAS1)
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      end if
#endif
C     do i = 1, nas1*nis1
C       write (*,'(i4,2f20.10)') ,i,GA_Arrays(lg_cx)%A(i),
C    &                              GA_Arrays(lg_sgm2)%A(i)
C     end do
C
      !! Next, the derivative of C1
      !! 2C. (T2Ct2*f) * S1*C1 (MO -> IC)
      !!     lg_T * lg_V2 -> lg_V1
      CALL RHS_ALLO(NIN1,NIS1,lg_V1)
      ITYPE=1
      !! SGM2 is local quantity, so put this in GA?
      CALL RHS_SR2C (ITYPE,1,NAS1,NIS1,NIN1,lg_V1,lg_SGM2,
     &               ICASE1,ISYM1)
      !! 3C. (T2Ct2*f) * S1*C1 * Ct1 (IC -> MO)
      !!     lg_T * lg_V1 -> lg_V2
      ITYPE=0
      CALL RHS_SR2C (ITYPE,0,NAS1,NIS1,NIN1,lg_V1,lg_SGM2,
     &               ICASE1,ISYM1)
      CALL RHS_FREE(lg_V1)
C
      !! 4C. (T1Ct1*f) * (T2Ct2St2*f*C1*Ct1)
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      if (is_real_par()) then
        call GA_DGEMM ('N','T',NAS1,NAS1,NIS1,
     *                -One,lg_CX,lg_SGM2,One,lg_SDER)
        CALL GA_GET(lg_SDER,1,NAS1,1,NAS1,SDER,NAS1)
        bStat = GA_destroy(lg_SDER)
      else
#endif
        Call DGEMM_('N','T',NAS1,NAS1,NIS1,
     *             -One,GA_Arrays(lg_CX)%A,NAS1,
     &                      GA_Arrays(lg_SGM2)%A,NAS1,
     *              One,SDER,NAS1)
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      end if
#endif
C
      End Subroutine C1S1DER
C
C-----------------------------------------------------------------------
C
      Subroutine C2DER(SDER)
C
      Implicit None
C
      real(kind=wp), intent(inout):: SDER(*)

      integer(kind=iwp) iType, lg_Sgm, lg_v2
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      integer(kind=iwp) lg_SDER
#endif
C
C     -1/2 (T2Ct2)pu * dS2tu/da * (T1Ct1St1*f*C2*Ct2)pt
C
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      if (is_real_par()) then
        CALL GA_CREATE_STRIPED ('V',NAS2,NIS2,'SDER',lg_SGMX)
        CALL GA_PUT(lg_SGMX,1,NAS2,1,NIS2,GA_Arrays(LSGMX)%A,NAS2)
      else
#endif
       lg_SGMX = LSGMX
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      end if
#endif
C
      !! For icase = 12 or 13, there is no need to transform,
      !! so LTMP is always replicated, but T for A and C are
      !! distributed?, so...
      CALL RHS_ALLO(NIN2,NIS2,lg_V2)
      !! 2. (T1Ct1St1*f) * C2 (MO -> IC; LTMP -> LTMP2)
      ITYPE=0
      CALL RHS_SR2C (ITYPE,1,NAS2,NIS2,NIN2,lg_V2,lg_SGMX,
     &               ICASE2,ISYM2)
      !! 3. (T1Ct1St1*f) * C2 * Ct2 (IC -> MO; LTMP2 -> LTMP)
      CALL RHS_SR2C (ITYPE,0,NAS2,NIS2,NIN2,lg_V2,lg_SGMX,
     &               ICASE2,ISYM2)
      CALL RHS_FREE(lg_V2)
C
      !! 4. (T2Ct2*f) * (T1Ct1St1*f*C2*Ct2)
      CALL RHS_ALLO(NAS2,NIS2,lg_SGM)
      CALL RHS_READ(NAS2,NIS2,lg_SGM,ICASE2,ISYM2,IVEC)
          IF (IVEC.NE.JVEC .AND. ILOOP.EQ.2) THEN
            !! T = T + \lambda
            If (SCAL.ne.One) CALL RHS_SCAL(NAS2,NIS2,lg_SGM,SCAL)
            CALL RHS_ALLO(NAS2,NIS2,lg_V1)
            CALL RHS_READ(NAS2,NIS2,lg_V1,ICASE2,ISYM2,JVEC)
            CALL RHS_DAXPY(NAS2,NIS2,One,lg_V1,lg_SGM)
            CALL RHS_FREE(lg_V1)
          END IF
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      if (is_real_par()) then
        CALL GA_CREATE_STRIPED ('H',NAS2,NAS2,'SDER',lg_SDER)
        CALL GA_PUT(lg_SDER,1,NAS2,1,NAS2,SDER,NAS2)
        call GA_DGEMM ('N','T',NAS2,NAS2,NIS2,
     *                -One,lg_SGM,lg_SGMX,One,lg_SDER)
        CALL GA_GET(lg_SDER,1,NAS2,1,NAS2,SDER,NAS2)
        bStat = GA_destroy(lg_SGMX)
        bStat = GA_destroy(lg_SDER)
      else
#endif
        Call DGEMM_('N','T',NAS2,NAS2,NIS2,
     *             -One,GA_Arrays(lg_SGM)%A,NAS2,
     &                      GA_Arrays(LSGMX)%A,NAS2,
     *              One,SDER,NAS2)
#if defined(_MOLCAS_MPP_) && defined(_GA_)
      end if
#endif
      CALL RHS_FREE(lg_SGM)
C
      End Subroutine C2DER
C
      End subroutine sigder

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine barrier( nBlock, dipIn, W, imanifold, NMULT, NDIM,
     &                    doPLOT, iprint)
c the present Subroutine computes the matrix elements of the transitions from states forming the blocking barrier;
c the states of opposite magnetization are given in the input, under keyword MLTP:
c the magnetic field is applied to each group of states delared at MLTP in order to form states of a definite
c projection of M on the quantization axis.
c  N --  dimension of the barrier

      Implicit None
#include "stdalloc.fh"
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)          :: nBlock, nMult, iprint, imanifold
      Integer, intent(in)          :: nDim(nMult)
      Real(kind=8), intent(in)    :: W(nBlock)
      Complex(kind=8), intent(in) :: dipIn(3,nBlock,nBlock)
      Logical, intent(in)          :: doPLOT
!-----------------------------------------------------------------------
      Integer          :: k,l,i,j,i1,i2,il,idim,Ifunct,j1,j2,iMult,ipar
      Integer          :: nb,maxmult
      Real(kind=8)    :: mave
      Character(len=90):: string2
      Character(len=5) :: s1,s2

      Integer, allocatable          :: ibas(:,:)
!                                          (nmult,nBlock)
      Real(kind=8), allocatable    :: gtens(:)
!                                           (3)
      Real(kind=8), allocatable    :: maxes(:,:), E(:)
!                                           (3,3), E(nmult)
      Real(kind=8), allocatable    :: wz(:,:)
!                                        (nmult,nBlock)
      Complex(kind=8), allocatable :: dipN(:,:,:)
!                                          (3,nBlock,nBlock)
      Complex(kind=8), allocatable :: dipN3(:,:,:)
!                                           (3,ndim(imanifold),ndim(imanifold))
      Complex(kind=8), allocatable :: CZ(:,:,:)
!                                        (nmult,nBlock,nBlock)
      Complex(kind=8), allocatable :: Ztr(:,:)
!                                         (nBlock,nBlock)
      Complex(kind=8), allocatable :: ML(:,:,:)
!                                        (3,nBlock,nBlock)
      Complex(kind=8), allocatable :: tmp(:,:)
!                                         (nBlock,nBlock)
      Complex(kind=8), allocatable :: MM(:)
!                                        (3)
      Complex(kind=8), allocatable :: dipso5(:,:,:,:,:)
!                                            (3,nmult,10,nmult,10)
!-----------------------------------------------------------------------

      If((nmult>0).and.(nBlock>0)) Then
         Call mma_allocate(ibas,nmult,nBlock,'ibas')
         Call mma_allocate(wz,nmult,nBlock,'wz')
         Call mma_allocate(cz,nmult,nBlock,nBlock,'cz')
         Call icopy( nmult*nBlock,[0],0,ibas,1)
         Call dcopy_(nmult*nBlock,[0.0_wp],0,wz,1)
         Call zcopy_(nmult*nBlock*nBlock,[(0.0_wp,0.0_wp)],0,CZ,1)
      End If

      If(nmult>0) Then
         Call mma_allocate(E,nmult,'E')
         Call mma_allocate(dipso5,3,nmult,10,nmult,10,'dipso5')
         Call dcopy_(nmult,[0.0_wp],0,E,1)
         Call zcopy_(3*nmult*10*nmult*10,[(0.0_wp,0.0_wp)],0,dipso5,1)
      End If

      If(nBlock>0) Then
         Call mma_allocate(dipN,3,nBlock,nBlock,'dipN')
         Call mma_allocate(ML,3,nBlock,nBlock,'ML')
         Call mma_allocate(Ztr,nBlock,nBlock,'Ztr')
         Call mma_allocate(tmp,nBlock,nBlock,'tmp')
         Call zcopy_(3*nBlock*nBlock,[(0.0_wp,0.0_wp)],0,dipN,1)
         Call zcopy_(3*nBlock*nBlock,[(0.0_wp,0.0_wp)],0,ML,1)
         Call zcopy_(nBlock*nBlock,[(0.0_wp,0.0_wp)],0,Ztr,1)
         Call zcopy_(nBlock*nBlock,[(0.0_wp,0.0_wp)],0,tmp,1)
      End If

      k=nDim(imanifold)
      If(k>0) Then
         Call mma_allocate(dipN3,3,k,k,'dipN3')
         Call zcopy_(3*k*k,[(0.0_wp,0.0_wp)],0, dipN3,1)
      End If

      Call mma_allocate(gtens,3,'gtens')
      Call mma_allocate(MM,3,'MM')
      Call mma_allocate(maxes,3,3,'maxes')
      Call dcopy_(3,[0.0_wp],0,gtens,1)
      Call dcopy_(3*3,[0.0_wp],0,maxes,1)
      Call zcopy_(3,[(0.0_wp,0.0_wp)],0,MM,1)


!-----------------------------------------------------------------------
      Do i=1,3
        maxes(i,i)=1.0_wp
      End Do
c  rotate the magnetic moment to the magnetic axes of the ground multiplet ( NDIM(1) )
      If(ndim(imanifold).le.1) Then
        Write(6,'(a,i2,a)') 'The manifold ',imanifold,
     &                      'was chosen for determination of the '//
     &                      'quantization axis.'
        Write(6,'(a     )') 'However, the size of this manifold is:'
        Write(6,'(a,i1  )') 'size = ',ndim(imanifold)
        Write(6,'(a     )') 'in this case, quantization axis will '//
     &                      'remain the original Z axis'
      Else
        Do i=1,ndim(imanifold)
          Do j=1,ndim(imanifold)
            Do l=1,3
              dipN3(l,i,j)=dipIn(l,i,j)
            End Do
          End Do
        End Do
        Call atens(dipN3, ndim(imanifold), gtens, maxes, 1 )
      End If
      Call rotmom2( dipIn(1:3,1:nBlock,1:nBlock), nBlock,
     &              maxes(1:3,1:3), dipN(1:3,1:nBlock,1:nBlock) )
      If(iprint.gt.2) Then
        Write(6,*)
        Write(6,'(10X,A)') 'Magnetic moment (dipIN) in the '//
     &                     'original coordinate system'
        Write(6,*)
        Write(6,'(A,11X,A,20X,A,20X,A,15x,A)') '< I | moment | J >',
     &                                         'projection = X',
     &                                         'projection = Y',
     &                                         'projection = Z',
     &                                   'ABS(< i | moment | j >)/3'
        Write(6,*)
        Do I=1,nBlock
          Do J=1,nBlock
            MAVE=0.0_wp
            MAVE=( abs(dipIN(1,I,J)) +
     &             abs(dipIN(2,I,J)) +
     &             abs(dipIN(3,I,J)) )/3.0_wp
            Write(6,'(A,i2,1x,A,i2,A, 3(2F16.11,2x),8X,F17.11)')
     &              '<',i,'| moment |',j,' >', (dipIN(L,I,J),L=1,3),MAVE
          End Do
        End Do
        Write(6,'(///)')
        Write(6,'(10X,A)') 'Magnetic moment (dipN) in the '//
     &                     'coordinate system of the magnetic axes'
        Write(6,*)
        Write(6,'(A,11X,A,20X,A,20X,A,15x,A)') '< I | moment | J >',
     &                                         'projection = X',
     &                                         'projection = Y',
     &                                         'projection = Z',
     &                                   'ABS(< i | moment | j >)/3'
        Write(6,*)
        Do I=1,nBlock
          Do J=1,nBlock
            MAVE=0.0_wp
            MAVE=( abs(dipN(1,I,J)) +
     &             abs(dipN(2,I,J)) +
     &             abs(dipN(3,I,J)) )/3.0_wp
            Write(6,'(A,i2,1x,A,i2,A, 3(2F16.11,2x),8X,F17.11)')
     &              '<',i,'| moment |',j,' >', (dipN(L,I,J),L=1,3),MAVE
          End Do
        End Do
      End If
c------------------------------------------------------------------------
c  determine the "CZ matrix":
      Ifunct=1
      Do il=1,nmult
        idim=ndim(il)
        If(idim.eq.0) Then
          Return
        Else If(idim.eq.1) Then
          CZ(il,1,1)=(1.0_wp,0.0_wp)
          WZ(il,1)=W(Ifunct)
        Else ! idim > 1

       Call pseudospin(  dipN(1:3,Ifunct:(Ifunct+ndim(il)-1),
     &                            Ifunct:(Ifunct+ndim(il)-1) ),
     &                      ndim(il),
     &                  CZ( il, 1:ndim(il), 1:ndim(il)),
     &                   3, 1, iprint)

       If (iPrint.gt.2) Call pa_prMat('barrier:  CZ',
     &      CZ(il,1:nDim(il),1:nDim(il)),nDim(il))
        End If
        Ifunct=Ifunct+ndim(il)
      End Do
c------------------------------------------------------------------------
c  compute the matrix elements between multiplets
      l=0
      ibas=0
      Do i=1,nmult
        Do j=1,ndim(i)
          l=l+1
          ibas(i,j)=l
        End Do
      End Do

      maxmult=0
      Do il=1,nmult
        If(ndim(il).gt.maxmult) Then
          maxmult=ndim(il)
        End If
      End Do
c build the transformation matrix Z(nBlock,nBlock)
      Call zcopy_(nBlock*nBlock,[(0.0_wp,0.0_wp)],0,ZTR,1)
      Do iMult=1,nmult
        Do j1=1,ndim(iMult)
          Do j2=1,ndim(iMult)
            i=ibas(iMult,j1)
            j=ibas(iMult,j2)
            Ztr( i, j )=CZ(iMult,j1,j2)
          End Do
        End Do
      End Do

      Call zcopy_(3*nBlock*nBlock,[(0.0_wp,0.0_wp)],0,ML,1)
      Do L=1,3
         Call zcopy_(nBlock*nBlock,[(0.0_wp,0.0_wp)],0,TMP,1)
         Call ZGEMM_('C','N',nBlock,nBlock,nBlock,(1.0_wp,0.0_wp),
     &                  Ztr,nBlock,
     &          dipN(L,:,:),nBlock,              (0.0_wp,0.0_wp),
     &                  TMP,nBlock )
         Call ZGEMM_('N','N',nBlock,nBlock,nBlock,(1.0_wp,0.0_wp),
     &                  TMP,nBlock,
     &                  Ztr,nBlock,              (0.0_wp,0.0_wp),
     &            ML(L,:,:),nBlock)
      End Do !L

      If(iprint.gt.2) Then
        Write(6,*)
        Write(6,'(10X,A)') 'Magnetic moment (ML) in the '//
     &                     'coordinate system of the magnetic axes'
        Write(6,*)
        Write(6,'(A,11X,A,20X,A,20X,A,15x,A)') '< I | moment | J >',
     &                                         'projection = X',
     &                                         'projection = Y',
     &                                         'projection = Z',
     &                                   'ABS(< i | moment | j >)/3'
        Write(6,*)
        Do I=1,nBlock
          Do J=1,nBlock
            MAVE=0.0_wp
            MAVE=( abs(ML(1,I,J)) +
     &             abs(ML(2,I,J)) +
     &             abs(ML(3,I,J)) )/3.0_wp
            Write(6,'(A,i2,1x,A,i2,A, 3(2F16.11,2x),8X,F17.11)')
     &              '<',i,'| moment |',j,' >', (ML(L,I,J),L=1,3),MAVE
          End Do
        End Do
      End If

      Call zcopy_(3*nmult*10*nmult*10,[(0.0_wp,0.0_wp)],0,DIPSO5,1)
      Do l=1,3
        Do i1=1,nmult
          Do j1=1,ndim(i1)
            Do i2=1,nmult
              Do j2=1,ndim(i2)
                i=ibas(i1,j1)
                j=ibas(i2,j2)
                dipso5(l,i1,j1,i2,j2)=ML(l,i,j)

c                write(6,'(A,5i3,A,2F20.12,3x,2I5)')
c     &                  'DIPSO5(',l,i1,j1,i2,j2,')=',
c     &                   dipso5(  l,i1,j1,i2,j2), i,j
              End Do
            End Do
          End Do
        End Do
      End Do

      If(doPLOT) then
         CALL plot_barrier(nBlock,nMult,nDIM,W,dipso5)
         Write(6,'(A)') 'The following files '
         Write(6,'(A)') '#-->  $WorkDir/BARRIER.plt'
         Write(6,'(A)') '#-->  $WorkDir/BARRIER_ENE.dat'
         Write(6,'(A)') '#-->  $WorkDir/BARREIR_TME.dat'
         Write(6,'(A)') '#-->  $WorkDir/BARREIR.plt'
         Write(6,'(A)') 'Have been generated successfully.'
      End If


ccccccccccccccccccccccccccccccccccccc


c   new print-out code :
      Write(6,*)
      Write(6,'(100A)') ('%',i=1,95)
      Write(6,'(15X,A)') 'AB INITIO BLOCKING BARRIER'
      Write(6,'(100A)') ('%',i=1,95)
      Write(6,'(A)') 'please, acknowledge the fact that the '//
     &               'information printed below provides'
      Write(6,'(A)') 'only a qualitative relaxation path of a '//
     &               'single-molecule magnet'
      Write(6,*)
c check the parity of all manIfolds:
      ipar=0
      i=1
      Do il=1,nmult
        ipar=ipar + mod(ndim(il),2)
        If(mod(ndim(il),2).eq.1)  i= i + 1
!        count the number of odd manifolds
c        Write(6,'(3(A,i2,2x))') 'il=',il,'ipar=',ipar,'i=',i
      End Do
      If (i.gt.1) Then
        ipar=ipar/(i-1)
      End If

      Ifunct=0
      Do il=1,nmult
        E(il)=0.0_wp
        Do i=1,ndim(il)
          E(il)=E(il)+W(Ifunct+i)/ndim(il)
        End Do
        Ifunct=Ifunct+ndim(il)
      End Do
      Write(6,'(A)') 'Zeeman eigenstates:'
c
c the convention to label states in the blocing barrier is the following:
c   Size of the             labelling scheme
c   manifold
c      1    ---------------                     0
c      2    ---------------                 1+,    1-
c      3    ---------------                 1+, 0, 1-
c      4    ---------------             2+, 1+,    1-, 2-
c      5    ---------------             2+, 1+, 0, 1-, 2-
c      6    ---------------         3+, 2+, 1+,    1-, 2-, 3-
c      7    ---------------         3+, 2+, 1+, 0, 1-, 2-, 3-
c      8    ---------------     4+, 3+, 2+, 1+,    1-, 2-, 3-, 4-
c      9    ---------------     4+, 3+, 2+, 1+, 0, 1-, 2-, 3-, 4-
c      9    --------------- 5+, 4+, 3+, 2+, 1+,    1-, 2-, 3-, 4-, 5-
c      9    --------------- 5+, 4+, 3+, 2+, 1+, 0, 1-, 2-, 3-, 4-, 5-
c    label(il,istate) is a Character*5 array of dimension (nmult,10)
c
c  notation:   multiplet . Lbl+
c  two Characters are assigned for multiplet
c

cccccccccccccccccccccccccccccccccccccccccccccccccc      cccc

      If(ipar.eq.0) Then
c  all multiplets have the same parity
        Write(string2, '(a, i2, a)') '(A,', maxmult, 'A,A)'
        Write(6,string2) '-------',
     &    ('--------------',i=1,maxmult),'----------------'
        If(mod(maxmult,2).eq.0) Then
           Write(string2, '(a, i2, a,i2,a)')
     &        '(A,',maxmult/2,'(A,i2,a),',
     &              maxmult/2,'(A,i2,a),a)'
           Write(6,string2) ' Mult.|',
     &       ('     ',i,'+     |',i=maxmult/2,1,-1),
     &       ('     ',i,'-     |',i=1,maxmult/2,1),
     &        '    E (cm-1)   |'
        Else If(mod(maxmult,2).eq.1) Then
           Write(string2, '(a,i2,a,i2,a)') '(A,',
     &                                      (maxmult-1)/2,'(A,i2,a),a,',
     &                                      (maxmult-1)/2,'(A,i2,a),a)'
           Write(6,string2)
     &        ' Mult.|',
     &       ('     ',i,'+     |',i=int((maxmult-1)/2),1,-1),
     &        '      0      |',
     &       ('     ',i,'-     |',i=1,int((maxmult-1)/2),1),
     &        '    E (cm-1)   |'
        End If
      Write(string2, '(a, i2, a)') '(A,', maxmult, 'A,A)'
      Write(6,string2) '------|',
     & ('-------------|', i=1,maxmult),
     &  '---------------|'

        Do il=1,nmult
      If(ndim(il).lt.maxmult) Then
        nb=int((maxmult-ndim(il))/2)
           Write(string2, '(3(a,i2),a)') '(2x,i2,a,',nb,'A,',
     &            ndim(il),'(F11.7,a),',nb,'A,F13.7,a)'
           Write(6,string2)
     &          il,'. | ',
     &          ('            | ',i=1,nb),
     & ( dble(dipso5(3,il,i,il,i)),' | ',i=1,ndim(il)),
     &          ('            | ',i=1,nb),
     &          E(il),' |'
      Else
         Write(string2, '(a, i2, a)') '(2x,i2,a,',maxmult,
     &                             '(F11.7,a),F13.7,a)'
         Write(6,string2) il,'. | ',
     &   ( dble(dipso5(3,il,i,il,i)),
     &    ' | ',i=1,ndim(il)), E(il),' |'
      End If
      End Do !il
      Write(string2, '(a, i2, a)') '(A,', maxmult, 'A,A)'
      Write(6,string2) '------|',
     & ('-------------|', i=1,maxmult),
     &  '---------------|'

      Else !ipar
c  multiplets have different parity (even and odd)
        Write(string2, '(a, i2, a, i2, a)')
     &  '(A,', maxmult/2, 'A,A,', maxmult/2,'A,A)'
        Write(6,string2) '-------',
     &    ('--------------',i=1,maxmult/2),
     &     '--------------',
     &    ('--------------',i=1,maxmult/2),
     &     '----------------'
         If(mod(maxmult,2).eq.0) Then  !maxmult = even
            Write(string2, '(a, i2, a, i2, a)')
     &           '(A,',maxmult/2,'(A,i2,a),a,'
     &                ,maxmult/2,'(A,i2,a),a)'
            Write(6,string2) ' Mult.|',
     &        ('     ',i,'+     |',i=maxmult/2,1,-1),
     &         '      0      |',
     &        ('     ',i,'-     |',i=1,maxmult/2,1),
     &         '    E (cm-1)   |'
            Write(string2, '(a, i2, a, i2, a)')
     &         '(A,', maxmult/2, 'A,A,',maxmult/2,'A,A)'
            Write(6,string2) '------|',
     &        ('-------------|', i=1,maxmult/2),
     &         '-------------|',
     &        ('-------------|', i=1,maxmult/2),
     &         '---------------|'

           Do il=1,nmult
             If(mod(ndim(il),2).eq.0) Then
!               il = even > the same parity as maxmult
                nb=(maxmult-ndim(il))/2
                If(nb.eq.0) Then !ndim(il) => maxmult
                Write(string2, '(2(a,i2),a)') '(2x,i2,a,',
     &                  ndim(il)/2,'(F11.7,a),    A,',
     &                  ndim(il)/2,'(F11.7,a),F13.7,a)'
                Write(6,string2) il,'. | ',
     &   ( dble(dipso5(3,il,i,il,i)),' | ',i=1,ndim(il)/2),
     &     '            | ' ,
     &   ( dble(dipso5(3,il,i,il,i)),' | ',i=1+ndim(il)/2,
     &    ndim(il)), E(il),' |'
                Else !nb>0, Integer
                Write(string2, '(4(a,i2),a)') '(2x,i2,a,',nb,'A,',
     &                            ndim(il)/2,'(F11.7,a),    A,',
     &                            ndim(il)/2,'(F11.7,a),',
     &                                      nb,'A,F13.7,a)'
                Write(6,string2) il,'. | ',
     &          ('            | ',i=1,nb),
     &          ( dble(dipso5(3,il,i,il,i)),
     &                    ' | ',i=1,ndim(il)/2),
     &           '            | ' ,
     &          ( dble(dipso5(3,il,i,il,i)),
     &                    ' | ',i=1+ndim(il)/2,ndim(il)),
     &          ('            | ',i=1,nb),
     &          E(il),' |'
                End If
             Else ! il = odd  < maxmult
               nb=(maxmult+1-ndim(il))/2
                Write(string2, '(4(a,i2),a)') '(2x,i2,a,',nb,'A,',
     &              ndim(il),'(F11.7,a),',nb,'A,F13.7,a)'
                Write(6,string2) il,'. | ',
     &          ('            | ',i=1,nb),
     &   ( dble(dipso5(3,il,i,il,i)),' | ',i=1,ndim(il)),
     &          ('            | ',i=1,nb),
     &          E(il),' |'
             End If
           End Do


         Else ! maxmult = odd
           Write(string2, '(a, i2, a, i2, a)') '(A,',
     &                           (maxmult-1)/2,'(a,i2,a),a,',
     &                           (maxmult-1)/2,'(a,i2,a),A)'
           Write(6,string2)
     &        ' Mult.|',
     &       ('     ',i,'+     |',i=  int((maxmult-1)/2),1,-1),
     &        '      0      |',
     &       ('     ',i,'-     |',i=1,int((maxmult-1)/2),1),
     &        '    E (cm-1)   |'
           Write(string2, '(a, i2, a, i2, a)')
     &        '(A,', maxmult/2, 'A,A,',maxmult/2,'A,A)'
           Write(6,string2) '------|',
     &       ('-------------|', i=1,maxmult/2),
     &        '-------------|',
     &       ('-------------|', i=1,maxmult/2),
     &        '---------------|'

            Do il=1,nmult
             If(mod(ndim(il),2).eq.1) Then
!               il = odd,  the parity of il = maxmult
                nb=(maxmult-ndim(il))/2
                If(nb.eq.0) Then !ndim(il) => maxmult
                Write(string2, '(2(a,i2),a)') '(2x,i2,a,',
     &                  ndim(il),'(F11.7,a),F13.7,a)'
                Write(6,string2) il,'. | ',
     &   ( dble(dipso5(3,il,i,il,i)),' | ',i=1,ndim(il)),
     &          E(il),' |'
                Else !nb>0, Integer
                Write(string2, '(4(a,i2),a)') '(2x,i2,a,',
     &          nb,'A,', ndim(il),'(F11.7,a),', nb,'A,F13.7,a)'
                Write(6,string2) il,'. | ',
     &          ('            | ',i=1,nb),
     &   ( dble(dipso5(3,il,i,il,i)),' | ',i=1,ndim(il)),
     &          ('            | ',i=1,nb),
     &          E(il),' |'
                End If

             Else ! il = even  < maxmult
               nb=(maxmult-1-ndim(il))/2
                If(nb.eq.0) Then !ndim(il) => maxmult
                Write(string2, '(2(a,i2),a)') '(2x,i2,a,',
     &                  ndim(il)/2,'(F11.7,a),    A,',
     &                  ndim(il)/2,'(F11.7,a),F13.7,a)'
                Write(6,string2) il,'. | ',
     &   ( dble(dipso5(3,il,i,il,i)),' | ',i=1,ndim(il)/2),
     &     '            | ' ,
     &   ( dble(dipso5(3,il,i,il,i)),' | ',i=1+ndim(il)/2,
     &    ndim(il)), E(il),' |'
                Else !nb>0, Integer
                Write(string2, '(4(a,i2),a)') '(2x,i2,a,',nb,'A,',
     &                            ndim(il)/2,'(F11.7,a),    A,',
     &                            ndim(il)/2,'(F11.7,a),',
     &                                      nb,'A,F13.7,a)'
                Write(6,string2) il,'. | ',
     &          ('            | ',i=1,nb),
     &   ( dble(dipso5(3,il,i,il,i)),' | ',i=1,ndim(il)/2),
     &           '            | ' ,
     &   ( dble(dipso5(3,il,i,il,i)),' | ',i=1+ndim(il)/2,
     &                                                 ndim(il)),
     &          ('            | ',i=1,nb),E(il),' |'
                End If
             End If
            End Do

         End If
      Write(string2, '(a, i2, a, i2, a)')
     & '(A,', maxmult/2, 'A,A,',maxmult/2,'A,A)'
      Write(6,string2) '------|',
     & ('-------------|', i=1,maxmult/2),
     &  '-------------|',
     & ('-------------|', i=1,maxmult/2),
     &  '---------------|'
      End If ! ipar , line 271
      Write(6,*)
c  printing of all off-diagonal matrix elements
      Write(6,'(A)') 'Matrix elements of the magnetic moment '//
     &               'connecting Zeeman eigenstates'
      Write(6,'(A)') 'The average is done according to the formula:'
      Write(6,'(A)') '<i|m|j> = ( ABS(<i|m_X|j>) + ABS(<i|m_Y|j>) + '//
     &                           'ABS(<i|m_Z|j>) ) / 3'
      Write(6,*)
      Write(6,'(A)') 'MATRIX ELEMENTS BETWEEN STATES WITH '//
     & 'OPPOSITE MAGNETIZATION'
      Write(6,'(A)') 'in cases with even number of electrons, '//
     &                'these values cannot be used'
      Write(6,'(A)') 'check the tunnelling splitting instead'
      Write(6,'(4A)') '-------','-------------------------',
     & '----------------------------------------',
     & '------------------------'
      Write(6,'(A,5x,A,5x,A,13x,A,13x,A,8x,a,8x,a)') ' Mult.|',
     & 'Matrix Element','|','Complex VALUE','|','AVERAGE','|'
      Write(6,'(4A)') '------|','------------------------|',
     & '---------Real------------imaginary-----|',
     & '-----------------------|'

      Do il=1,nmult
      If(ndim(il).eq.1) Then
               write(s1,'(i2,A1,A1,A1)') il,'.','0',' '
               write(s2,'(i2,A1,A1,A1)') il,'.','0',' '
               Call prbar(il,s1,s2,dipso5(1:3,il,1,il,1))
      Else
c         If( mod(ndim(il),2)==0 ) Then   ! even multiplicity

        Do i=1,int(ndim(il)/2)
      If(i.gt.1) Write(6,'(4A)') '      |',
     & '------------------------|',
     & '---------------------------------------|',
     & '-----------------------|'
            write(s1,'(i2,A1,i1,A1)') il,'.',i,'+'
            Do j=i,int(ndim(il)/2)
              write(s2,'(i2,A1,i1,A1)') il,'.',j,'+'
c            !Call prbar(il,s1,s2,dipso5(1:3,il,i,il,ndim(il)-i+1))
              Call prbar(il,s1,s2,dipso5(1:3,il,i,il, j ) )
            End Do

            Do j=i,int(ndim(il)/2)
              write(s2,'(i2,A1,i1,A1)') il,'.',j,'-'
c            !Call prbar(il,s1,s2,dipso5(1:3,il,i,il,ndim(il)-i+1))
              Call prbar(il,s1,s2,dipso5(1:3,il,i,il, ndim(il)-j+1 ) )
            End Do
        End Do

c        !Else ! mod(ndim(il),2)==1 , i.e. odd multiplicity
c        End If

      End If
      Write(6,'(4A)') '------|','------------------------|',
     & '---------------------------------------|',
     & '-----------------------|'
      End Do !il
      Write(6,*)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      Write(6,'(10A)') ('##########',i=1,10)
      Do k=1,nmult-1
      Write(6,*)
      Write(6,'(A,i2,a)') 'MATRIX ELEMENTS BETWEEN STATES ARISING '//
     & 'FROM NEIGHBORING MULTIPLETS: I -> I+',k,' :'
      Write(6,'(4A)') '-------','-------------------------',
     & '----------------------------------------',
     & '------------------------'
      Write(6,'(A,5x,A,5x,A,13x,A,13x,A,8x,a,8x,a)') ' Mult.|',
     & 'Matrix Element','|','Complex VALUE','|','AVERAGE','|'
      Write(6,'(4A)') '------|','------------------------|',
     & '---------Real------------imaginary-----|',
     & '-----------------------|'
      Do il=1,nmult-k
      If( mod(ndim(il),2) .eq. 0 )  Then
       Do i=ndim(il)/2,1,-1
          If(mod(ndim(il+k),2) .eq. 0 ) Then
                Do j=ndim(il+k)/2,1,-1

               write(s1,'(i2,A1,i1,A1)') il  ,'.',i,'+'
               write(s2,'(i2,A1,i1,A1)') il+k,'.',j,'+'
               Call prbar(il,s1,s2,dipso5(1:3,il,i,il+k,j))

                End Do

                Do j=1,ndim(il+k)/2

               write(s1,'(i2,A1,i1,A1)') il  ,'.',i,'+'
               write(s2,'(i2,A1,i1,A1)') il+k,'.',j,'-'
               Call prbar(il,s1,s2,dipso5(1:3,il,i,il+k,ndim(il+k)-j+1))

                End Do

          Else !ndim(il+k) is odd
             If(ndim(il+k).eq.1) Then

               write(s1,'(i2,A1,i1,A1)') il  ,'.', i ,'+'
               write(s2,'(i2,A1,A1,A1)') il+k,'.','0',' '
               Call prbar(il,s1,s2,dipso5(1:3,il,i,il+k,1))

             Else

                Do j=(ndim(il+k)-1)/2,1,-1
                   write(s1,'(i2,A1,i1,A1)') il  ,'.',i,'+'
                   write(s2,'(i2,A1,i1,A1)') il+k,'.',j,'+'
                   Call prbar(il,s1,s2,dipso5(1:3,il,i,il+k,j))
                End Do

                write(s1,'(i2,A1,i1,A1)') il  ,'.', i ,'+'
                write(s2,'(i2,A1,A1,A1)') il+k,'.','0',' '
                MM(1:3)=dipso5(1:3,il,i,il+k,(ndim(il+k)+1)/2)
                Call prbar(il,s1,s2,MM(1:3))

                Do j=1,(ndim(il+k)-1)/2
                  write(s1,'(i2,A1,i1,A1)') il  ,'.', i ,'+'
                  write(s2,'(i2,A1,A1,A1)') il+k,'.','0',' '
                  MM(1:3)=dipso5(1:3,il,i,il+k,ndim(il+k)-j+1)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do

             End If ! ndim(il+k) = 1
          End If ! ndim(il+k)
      If(i.gt.1) Write(6,'(4A)') '      |','------------------------|',
     & '---------------------------------------|',
     & '-----------------------|'
       End Do !i

      Else ! ndim(il) = odd

       If(ndim(il).eq.1) Then
          If(mod(ndim(il+k),2) .eq. 0 ) Then
                Do j=ndim(il+k)/2,1,-1
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,i1,A1)') il+k,'.', j ,'+'
                  MM(1:3)=dipso5(1:3,il,1,il+k,j)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do

                Do j=1,ndim(il+k)/2
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,i1,A1)') il+k,'.', j ,'-'
                  MM(1:3)=dipso5(1:3,il,1,il+k,ndim(il+k)-j+1)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do

          Else !ndim(il+k) is odd
             If(ndim(il+k).eq.1) Then
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,A1,A1)') il+k,'.','0',' '
                  MM(1:3)=dipso5(1:3,il,1,il+k,1)
                  Call prbar(il,s1,s2,MM(1:3))
             Else
                Do j=(ndim(il+k)-1)/2,1,-1
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,i1,A1)') il+k,'.', j ,'+'
                  MM(1:3)=dipso5(1:3,il,1,il+k,j)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,A1,A1)') il+k,'.','0',' '
                  MM(1:3)=dipso5(1:3,il,1,il+k,(ndim(il+k)+1)/2)
                  Call prbar(il,s1,s2,MM(1:3))

                Do j=1,(ndim(il+k)-1)/2
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,i1,A1)') il+k,'.', j ,'-'
                  MM(1:3)=dipso5(1:3,il,1,il+k,ndim(il+k)-j+1)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
             End If ! ndim(il+k) = 1
          End If ! ndim(il+k), parity

       Else !ndim(il) > 1, odd

       Do i=(ndim(il)-1)/2,1,-1
          If(mod(ndim(il+k),2) .eq. 0 ) Then
                Do j=ndim(il+k)/2,1,-1
                  write(s1,'(i2,A1,i1,A1)') il  ,'.',i,'+'
                  write(s2,'(i2,A1,i1,A1)') il+k,'.',j,'+'
                  MM(1:3)=dipso5(1:3,il,i,il+k,j)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
                Do j=1,ndim(il+k)/2
                  write(s1,'(i2,A1,i1,A1)') il  ,'.',i,'+'
                  write(s2,'(i2,A1,i1,A1)') il+k,'.',j,'-'
                  MM(1:3)=dipso5(1:3,il,i,il+k,ndim(il+k)-j+1)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
          Else !ndim(il+k) is odd
             If(ndim(il+k).eq.1) Then
                  write(s1,'(i2,A1,i1,A1)') il  ,'.', i ,'+'
                  write(s2,'(i2,A1,A1,A1)') il+k,'.','0',' '
                  MM(1:3)=dipso5(1:3,il,i,il+k,1)
                  Call prbar(il,s1,s2,MM(1:3))
             Else
                Do j=(ndim(il+k)-1)/2,1,-1
                  write(s1,'(i2,A1,i1,A1)') il  ,'.',i,'+'
                  write(s2,'(i2,A1,i1,A1)') il+k,'.',j,'+'
                  MM(1:3)=dipso5(1:3,il,i,il+k,j)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
                  write(s1,'(i2,A1,i1,A1)') il  ,'.', i ,'+'
                  write(s2,'(i2,A1,A1,A1)') il+k,'.','0',' '
                  MM(1:3)=dipso5(1:3,il,i,il+k,(ndim(il+k)+1)/2)
                  Call prbar(il,s1,s2,MM(1:3))
                Do j=1,(ndim(il+k)-1)/2
                  write(s1,'(i2,A1,i1,A1)') il  ,'.', i ,'+'
                  write(s2,'(i2,A1,i1,A1)') il+k,'.', j ,'-'
                  MM(1:3)=dipso5(1:3,il,i,il+k,ndim(il+k)-j+1)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
             End If ! ndim(il+k) = 1
          End If ! ndim(il+k), parity
      Write(6,'(4A)') '      |','------------------------|',
     & '---------------------------------------|',
     & '-----------------------|'
       End Do ! i


          If(mod(ndim(il+k),2) .eq. 0 ) Then
                Do j=ndim(il+k)/2,1,-1
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,i1,A1)') il+k,'.', j ,'+'
                  MM(1:3)=dipso5(1:3,il,(ndim(il)+1)/2,il+k,j)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
                Do j=1,ndim(il+k)/2
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,i1,A1)') il+k,'.', j ,'-'
                  MM(1:3)=dipso5(1:3,il  ,(ndim(il)+1)/2,
     &                               il+k, ndim(il+k)-j+1)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
          Else !ndim(il+k) is odd
             If(ndim(il+k).eq.1) Then
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,A1,A1)') il+k,'.','0',' '
                  MM(1:3)=dipso5(1:3,il,(ndim(il)+1)/2,il+k,1)
                  Call prbar(il,s1,s2,MM(1:3))
             Else
                Do j=(ndim(il+k)-1)/2,1,-1
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,i1,A1)') il+k,'.', j ,'+'
                  MM(1:3)=dipso5(1:3,il,(ndim(il)+1)/2,il+k,j)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,A1,A1)') il+k,'.','0',' '
                  MM(1:3)=dipso5(1:3,il,(ndim(il)+1)/2,
     &                             il+k,(ndim(il+k)+1)/2)
                  Call prbar(il,s1,s2,MM(1:3))
                Do j=1,(ndim(il+k)-1)/2
                  write(s1,'(i2,A1,A1,A1)') il  ,'.','0',' '
                  write(s2,'(i2,A1,i1,A1)') il+k,'.', j ,'-'
                  MM(1:3)=dipso5(1:3,il,(ndim(il)+1)/2,
     &                             il+k,ndim(il+k)-j+1)
                  Call prbar(il,s1,s2,MM(1:3))
                End Do
             End If ! ndim(il+k) = 1
          End If ! ndim(il+k), parity

       End If ! ndim(il), size

      End If !ndim(il), parity
      Write(6,'(4A)') '------|','------------------------|',
     & '---------------------------------------|',
     & '-----------------------|'
      End Do ! il
      End Do ! k

!-----------------------------------------------------------------------
      If((nmult>0).and.(nBlock>0)) Then
         Call mma_deallocate(ibas)
         Call mma_deallocate(wz)
         Call mma_deallocate(cz)
      End If

      If(nmult>0) Then
         Call mma_deallocate(E)
         Call mma_deallocate(dipso5)
      End If

      If(nBlock>0) Then
         Call mma_deallocate(dipN)
         Call mma_deallocate(ML)
         Call mma_deallocate(Ztr)
         Call mma_deallocate(tmp)
      End If

      k=nDim(imanifold)
      If(k>0) Then
         Call mma_deallocate(dipN3)
      End If

      Call mma_deallocate(gtens)
      Call mma_deallocate(MM)
      Call mma_deallocate(maxes)


      Return
      End



      Subroutine prbar(ist,s1,s2,M)

      Implicit none
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)          :: ist
      Character(len=5), intent(in) :: s1, s2
      Complex(kind=8), intent(in) :: M(3)
!     local
      Character(len=30) :: fx, fy, fz
      Character(len=40) :: f1, f2
      Real(kind=8)     :: R

      write(fx,'(i2,5a)') ist,'. | <',s1,' | mu_X |',s2,' > |'
      write(fy,'(i2,5a)') ist,'. | <',s1,' | mu_Y |',s2,' > |'
      write(fz,'(i2,5a)') ist,'. | <',s1,' | mu_Z |',s2,' > |'
      R=0.0_wp
      R=( abs(M(1))+abs(M(2))+abs(M(3)) )/3.0_wp

      f1='(2x,a,2E19.11,1x,A,      23x,A)'
      f2='(2x,a,2E19.11,1x,A,E22.12,1x,A)'
      Write(6,f1) fx,M(1),'|',  '|'
      Write(6,f2) fy,M(2),'|',R,'|'
      Write(6,f1) fz,M(3),'|',  '|'
      Return
      End subroutine prbar

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine procinp_caspt2()
!SVC: process CASPT2 input based on the data in the input table, and
! initialize global common-block variables appropriately.

use inputData, only: input
use PrintLevel, only: TERSE
use UnixInfo, only: SuperName
use Molcas, only: MxRoot, MxSym
use caspt2_global, only: cmpThr, cntThr, CompressMPS, ConvInvar, dnmThr, do_csf, do_grad, do_lindep, do_nac, if_equalW, if_invar, &
                         if_invaria, if_SSDM, imag_shift, iParRHS, ipea_shift, iPrGlb, iRoot1, iRoot2, MAXBUF, real_shift, &
                         sigma_p_epsilon, sigma_p_exponent, Weight
use caspt2_module, only: BMatrix, BSpect, BTrans, CIThr, CPT2Method, DMRG, DoCumulant, DWType, FockType, G1SECIN, HZero, IfChol, &
                         IfDens, IfDOrtho, IfDW, IfMix, IFMSCoup, IfProp, IfRMS, IfsadRef, IfXMS, iRlxRoot, iRoot, JMS, MaxIt, &
                         mState, nCases, nDel, nFro, nGroup, nGroupState, nIsh, nLYGroup, nLYRoot, nRas1T, nRas3T, nRoots, nRoots, &
                         nSsh, nState, nSym, OrbIn, OutFmt, PrOrb, PRSD, PT2Method, RFPERT, RHSDirect, Root2State, SDECOM, &
                         SMatrix, ThrConv, ThrEne, ThrOCC, ThrSHN, ThrSHS, Zeta
use SC_NEVPT2, only: Do_FIC, Do_SC, SC_amplitude, SC_prop, SC_thres
#ifdef _DMRG_
use qcmaquis_info, only: qcm_group_names
use qcmaquis_interface_cfg, only: dmrg_file, qcmaquis_param
use qcmaquis_interface, only: qcmaquis_interface_init_checkpoint, qcmaquis_interface_remove_param, qcmaquis_interface_set_param
use PrintLevel, only: VERBOSE
use stdalloc, only: mma_allocate
#endif
#if 0
! NOT TESTED
use OFembed, only: Do_OFemb
#endif
use Constants, only: Zero, Quart
use Definitions, only: wp, iwp, u6, RtoB
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, nProcs
use Definitions, only: MPIInt
#endif

implicit none
integer(kind=iwp) :: I, iDNG, iDummy, iGroup, iOff, iSym, J, nCore(mxSym), nDiff, NFI, NSD
logical(kind=iwp) :: DNG, DNG_available, do_imag, do_real, do_sigp, Found, Is_iRlxRoot_Set
character(len=180) :: Env
character(len=16) :: mstate1
integer(kind=iwp), external :: isStructure
logical(kind=iwp), external :: RF_On

! nCore: Number of non-valence orbitals per symmetry
! Is_iRlxRoot_Set: Geometry-determining root
! Env: Environment
! mstate1: NAC or not
! iGroup: State selection
! DNG: Numerical gradients

! Hzero and Focktype are merged together into Hzero. We keep the
! variable Focktype not to break the input keyword which is documented
! in the manual. However, eventually we will have to keep only Hzero
! and remove Focktype.
Hzero = input%Hzero
if ((Hzero /= 'STANDARD') .and. (Hzero /= 'CUSTOM') .and. (Hzero /= 'DYALL')) then
  call WarningMessage(2,'invalid 0th-order Hamiltonian: '//trim(Hzero))
  call Quit_OnUserError()
end if

! Choose Focktype, reset IPEA shift to 0 for non-standard fock matrices
Focktype = input%Focktype
if (Focktype /= 'STANDARD') then
  ! if both Hzero and Focktype are not standard, quit
  if ((Hzero /= 'STANDARD') .and. (Hzero /= 'DYALL')) then
    call WarningMessage(2,'Requested combination of FOCKtype'//' and HZERo not possible.')
    call Quit_OnUserError()
  end if
  ! IPEA shift different from zero only for standard Focktype
  if (ipea_shift /= Zero) then
    ipea_shift = Zero
    if (IPRGLB >= TERSE) call WarningMessage(1,'IPEA shift reset to zero!')
  end if
else if (Hzero /= 'DYALL') then
  ! user-specified IPEA shift or not?
  if (input%ipea) then
    ipea_shift = input%ipea_shift
  else
    ! Set default IPEA to 0.25 Eh or 0.0
    call getenvf('MOLCAS_NEW_DEFAULTS',Env)
    call upcase(Env)
    if (Env == 'YES') then
      ipea_shift = Zero
    else
      ipea_shift = Quart
    end if
  end if
end if

! copy over to Hzero the content of Focktype, if Hzero is not CUSTOM or DYALL
if ((Hzero /= 'CUSTOM') .and. (Hzero /= 'DYALL')) Hzero = Focktype

! print warnings if deviating from the default
if ((Hzero /= 'STANDARD') .and. (Hzero /= 'DYALL')) call warningmessage(1,'User-modified 0th-order Hamiltonian!')

! real/imaginary shifts
real_shift = Input%real_shift
imag_shift = Input%imag_shift

! sigma-p regularizers
if ((input%sigma_1_epsilon /= Zero) .and. (input%sigma_2_epsilon /= Zero)) then
  call WarningMessage(2,'SIG1 and SIG2 keywords are mutually exclusive')
  call Quit_OnUserError()
end if

if (input%sigma_1_epsilon > Zero) then
  sigma_p_epsilon = Input%sigma_1_epsilon
  sigma_p_exponent = 1
end if

if (input%sigma_2_epsilon > Zero) then
  sigma_p_epsilon = Input%sigma_2_epsilon
  sigma_p_exponent = 2
end if

do_real = real_shift > Zero
do_imag = imag_shift > Zero
do_sigp = sigma_p_epsilon > Zero
if ((do_real .and. (do_imag .or. do_sigp)) .or. (do_imag .and. do_sigp)) then
  call WarningMessage(2,'More than one intruder-state removal technique active: SHIFt/IMAGinary/SIG1/SIG2 are mutually exclusive!')
  call Quit_OnUserError()
end if

! RHS algorithm selection
if (Input%PRHS == '0') Input%PRHS = 'DEFAULT'
if (Input%PRHS == '1') Input%PRHS = 'OLD'
if (Input%PRHS == '2') Input%PRHS = 'NEW'
if (Input%PRHS == '3') Input%PRHS = 'DIRECT'  ! synonym of the DIREct keyword (undocumented)
if ((Input%PRHS /= 'DEFAULT') .and. (Input%PRHS /= 'OLD') .and. (Input%PRHS /= 'NEW') .and. (Input%PRHS /= 'DIRECT')) then
  call WarningMessage(1,'The selected PRHS is not supported. Going to use the default strategy.')
  Input%PRHS = 'DEFAULT'
end if
iParRHS = 1
#ifdef _MOLCAS_MPP_
! The RHS on-demand algorithm doesn't handle serial calculations
! because it's not adapted for use with regular Work arrays, only
! global arrays, and needs to be switched off (using rhsall instead)
RHSDIRECT = Is_Real_Par() .and. (Input%RHSD .or. (Input%PRHS == 'DIRECT'))
if (Is_Real_Par() .and. ((Input%PRHS == 'DEFAULT') .or. (Input%PRHS == 'NEW')) .and. (.not. RHSDIRECT)) iParRHS = 2
! maximum number of real values handled by a single GADGOP call
! compilers complain about huge(xxx)/RtoB with -Werror=integer-division
MAXBUF = (huge(1_MPIInt)-mod(int(huge(1_MPIInt),kind=iwp),RtoB))/RtoB
#else
RHSDIRECT = .false.
MAXBUF = (huge(RtoB)-mod(huge(RtoB),RtoB))/RtoB
#endif

! Cholesky: set defaults if it was not called during input
if (.not. (Input%ChoI .or. Input%Chol)) call Cho_caspt2_rdInp(.true.,iDummy)

! Initialize
RFpert = Input%RFPert

OUTFMT = 'DEFAULT'
G1SECIN = .false.
PRORB = Input%PrOrb
PRSD = Input%PrSD
NCASES = 13

JMS = Input%JMS
NLYROOT = Input%OnlyRoot
NLYGROUP = 0

DoCumulant = Input%DoCumulant
DMRG = Input%DMRG
CompressMPS = Input%CompressMPS

!***********************************************************************
!
! Root selection
!
!***********************************************************************
!SB: create a flat array, putting (X)MS states with increasing
! group number. do not allow to run both MS and XMS in the same
! calculation, it can lead to catastrophic results.
! For MS, put one state per group, for XMS put all states in
! a single group.
! Example: lets say the input is:
! MULTistate = 3 3 4 5

! then the arrays that are created will be:
! nstate = 3
! mstate(nstate): 3 4 5
! nGroup = 3
! nGroupState(nGroup): 1 1 1

! On the other hand, if the input is
! XMULtistate = 4 1 2 3 4

! then the arrays that are created will be:
! nstate = 4
! mstate(nstate): 1 2 3 4
! nGroup = 1
! nGroupState(nGroup): 4

NSTATE = 0
MSTATE(:) = 0
NGROUP = 0
NGROUPSTATE = 0
! This is the case for MS-CASPT2 and DW-CASPT2
if (Input%MULT) then
  if (Input%XMUL .or. Input%RMUL) then
    call WarningMessage(2,'Keyword MULT cannot be used with neither XMUL nor RMUL.')
    call Quit_OnUserError()
  end if
  ! Either the states were specified manually or the keyword "all"
  ! was used, so first we check the keyword all
  if (Input%AllMult) then
    NSTATE = NROOTS
    MSTATE(:) = IROOT
    NGROUP = NSTATE
    NGROUPSTATE(1:NGROUP) = 1
  else
    ! Save the states that need to be computed
    NGROUP = Input%nMultState
    MSTATE(1:NGROUP) = Input%MultGroup%A(1:NGROUP)
    NSTATE = NSTATE+NGROUP
    NGROUPSTATE(1:NGROUP) = 1
  end if
end if
IOFF = NSTATE

! This is the case for XMS-CASPT2 and XDW-CASPT2
if (Input%XMUL) then
  if (Input%MULT .or. Input%RMUL) then
    call WarningMessage(2,'Keyword XMUL cannot be used with neither MULT nor RMUL.')
    call Quit_OnUserError()
  end if
  ! This is a XDW-CASPT2 calculation. It is actually more similar to
  ! a MS-CASPT2 one since we need to put one state per group and thus
  ! have as many groups as states. Nevertheless, it makes more sense
  ! from the user point of view to ask for it through XMUL and DWMS
  if (Input%DWMS) then
    if (Input%AllXMult) then
      NSTATE = NROOTS
      MSTATE(:) = IROOT
      NGROUP = NSTATE
      NGROUPSTATE(1:NGROUP) = 1
    else
      NGROUP = Input%nXMulState
      MSTATE(1:NGROUP) = Input%XMulGroup%A(1:NGROUP)
      NSTATE = NSTATE+NGROUP
      NGROUPSTATE(1:NGROUP) = 1
    end if
    ! This is a XMS-CASPT2: one group with all the states
  else
    if (Input%AllXMult) then
      NSTATE = NROOTS
      MSTATE(:) = IROOT
      NGROUP = 1
      NGROUPSTATE(1) = NSTATE
    else
      NGROUP = 1
      NGROUPSTATE(NGROUP) = Input%nXMulState
      MSTATE(1:NGROUPSTATE(NGROUP)) = Input%XMulGroup%A(1:NGROUPSTATE(NGROUP))
      NSTATE = NSTATE+NGROUPSTATE(NGROUP)
    end if
  end if
end if

! This is the case for RMS-CASPT2
if (Input%RMUL) then
  if (Input%MULT .or. Input%XMUL) then
    call WarningMessage(2,'Keyword RMUL cannot be used with neither MULT nor XMUL.')
    call Quit_OnUserError()
  end if
  if (Input%AllRMult) then
    NSTATE = NROOTS
    MSTATE(:) = IROOT
    NGROUP = NSTATE
    NGROUPSTATE(1:NGROUP) = 1
  else
    NGROUP = Input%nRMulState
    MSTATE(1:NGROUP) = Input%RMulGroup%A(1:NGROUP)
    NSTATE = NSTATE+NGROUP
    NGROUPSTATE(1:NGROUP) = 1
  end if
end if
! After parsing mult, xmult or rmult, check that no two equal states where
! given in the input
if (Input%MULT .or. Input%XMUL .or. Input%RMUL) then
  do I=1,NSTATE
    do J=I+1,NSTATE
      if (MSTATE(I) == MSTATE(J)) then
        call WarningMessage(2,'The same root cannot be used twice in MULT/XMUL/RMUL blocks.')
        call Quit_OnUserError()
      end if
    end do
  end do
end if
! The LROOt keyword specifies a single root to be used. It should not be
! used together with either MULT or XMUL keywords.
if (Input%LROO) then
  if (Input%MULT .or. Input%XMUL .or. Input%RMUL) then
    call WarningMessage(2,'Keyword LROO cannot be used together with the MULT or XMUL keywords.')
    call Quit_OnUserError()
  end if
  NSTATE = 1
  MSTATE(1) = Input%SingleRoot
  NGROUP = 1
  NGROUPSTATE(1) = 1
end if
! if still nothing was selected we should default to compute all the
! roots that were part of the rasscf orbital optimization.
if (NSTATE == 0) then
  NSTATE = NROOTS
  MSTATE(:) = IROOT
  NGROUP = NSTATE
  NGROUPSTATE(1:NGROUP) = 1
end if
! Find the group number for OnlyRoot
if (NLYROOT /= 0) then
  IOFF = 0
  do IGROUP=1,NGROUP
    do I=1,NGROUPSTATE(IGROUP)
      if (IOFF+I == NLYROOT) NLYGROUP = IGROUP
    end do
    IOFF = IOFF+NGROUPSTATE(IGROUP)
  end do
end if
! Finally, some sanity checks.
if ((NSTATE <= 0) .or. (NSTATE > MXROOT)) then
  call WarningMessage(2,'Number of states is <0 or too large.')
  write(u6,'(a,i8)') ' NSTATE = ',NSTATE
  write(u6,*) ' Check usage of keywords MULT/XMUL/RMUL.'
  call Quit_OnUserError()
end if
! setup root to state translation
ROOT2STATE(:) = 0
do I=1,NSTATE
  ROOT2STATE(MSTATE(I)) = I
end do

! Relax root selection

iRlxRoot = -1
call Qpg_iScalar('NumGradRoot',Is_iRlxRoot_Set)
if (Is_iRlxRoot_Set) call Get_iScalar('NumGradRoot',iRlxRoot)
if (Input%RlxRoot > 0) iRlxRoot = Input%RlxRoot
if (iRlxRoot == -1) iRlxRoot = NSTATE
if (iRlxRoot > NSTATE) then
  if (IPRGLB >= TERSE) then
    call WarningMessage(1,'Too large iRlxRoot.')
    write(u6,*) ' Reset to NSTATE=',NSTATE
  end if
  iRlxRoot = NSTATE
end if

!***********************************************************************
!
! Determine number of Frozen/Deleted orbitals
!
!***********************************************************************
! The number of Frozen orbitals is initially read from the reference
! wavefunction. Here, we modify that number to be the larger of what
! was in the reference and the non-valence orbitals.
call Get_iArray('Non valence orbitals',nCore,nSym)
do iSym=1,nSym
  if (nCore(iSym) > nFro(iSym)) then
    nDiff = nCore(iSym)-nFro(iSym)
    nDiff = min(nDiff,nISh(iSym))
    nFro(iSym) = nFro(iSym)+nDiff
    nISh(iSym) = nISh(iSym)-nDiff
  end if
end do
! if a user specified the number of frozen orbitals explicitely, then
! that number overwrites the automatically chosen numbers, but it we
! warn the user and report what the computed number was.
if (Input%FROZ) then
  if (IPRGLB >= TERSE) call WarningMessage(1,'User changed nr of frozen orbitals.')
  do I=1,NSYM
    NFI = NFRO(I)+NISH(I)
    if (NFI < Input%nFro(I)) then
      call WarningMessage(2,'Too many frozen orbitals!')
      call Quit_OnUserError()
    else
      nFro(I) = Input%nFro(I)
    end if
    NISH(I) = NFI-nFro(I)
  end do
end if
! Set user-specified number of deleted orbitals.
if (Input%DELE) then
  do I=1,NSYM
    NSD = NSSH(I)+NDEL(I)
    if (NSD < Input%nDel(I)) then
      call WarningMessage(2,'Too many deleted orbitals!')
      call Quit_OnUserError()
    else
      NDEL(I) = Input%nDel(I)
    end if
    NSSH(I) = NSD-nDel(I)
  end do
end if

! NOT TESTED
#if 0
!***********************************************************************
!
! Orbital-free embedding.
!
!***********************************************************************
if (Input%OFEmbedding) then
  Do_OFemb = .true.
  write(u6,*)
  write(u6,*) '  --------------------------------------'
  write(u6,*) '   Orbital-Free Embedding Calculation   '
  write(u6,*) '  --------------------------------------'
  write(u6,*)
end if
#endif
!***********************************************************************
!
! Determine what kind of calculations are needed/requested.
!
!***********************************************************************
! flags for enabling/disabling sections
IFPROP = Input%Properties
IFDENS = Input%DENS
IFMIX = .not. Input%NoMix
IFXMS = Input%XMUL
IFRMS = Input%RMUL
IFMSCOUP = (Input%MULT .or. IFXMS .or. IFRMS) .and. (.not. Input%NoMult)
if ((nState == 1) .and. (NLYROOT /= mState(1))) IFMSCOUP = .false.
IFDW = Input%DWMS
! Set type and exponent for DWMS
DWType = Input%DWType
if (IFDW) then
  if ((DWType <= 0) .or. (DWType > 3)) then
    call WarningMessage(2,'DWTYpe should be either 1, 2 or 3.')
    call Quit_OnUserError()
  end if
  zeta = Input%zeta
end if

! Choice? of preprocessing route
ORBIN = 'TRANSFOR'

! Expectation values of H0 needed or not? Spectral resolution?
BMATRIX = 'YES     '
BTRANS = 'YES     '
BSPECT = 'YES     '
! Overlap matrix needed? Linear dependence removal needed?
SMATRIX = 'YES     '
SDECOM = 'YES     '
! Presently, we always need the ON transformation/Lindep removal.
! Consistency of these demands:
if (BSPECT /= 'NO      ') BTRANS = 'YES     '
if (BTRANS /= 'NO      ') BMATRIX = 'YES     '
if (BTRANS /= 'NO      ') SDECOM = 'YES     '
if (SDECOM /= 'NO      ') SMATRIX = 'YES     '

#ifdef _DMRG_
if (DMRG) then
  ! just exit if somebody tries to do QD-CASPT2 with DMRG
  if (IFMSCOUP) then
    call WarningMessage(2,'Couplings with DMRG-CASPT2 not supported')
    call Quit_OnUserError()
  end if

  ! set OpenMolcas environment variables
  call getenv('Project',qcmaquis_param%project_name)
  call getenv('WorkDir',qcmaquis_param%workdir)

  ! save checkpoint paths for all states
  call mma_allocate(dmrg_file%qcmaquis_checkpoint_file,nstate)
  do i=1,nstate
    dmrg_file%qcmaquis_checkpoint_file(i) = trim(qcmaquis_param%workdir)//'/'//qcm_group_names(1)%states(mstate(i))
  end do

  ! initialize the interface using a checkpoint file
  if (iPrGlb >= VERBOSE) write(u6,*) 'PROCINP initializing QCMaquis DMRG interface...'
  call qcmaquis_interface_init_checkpoint(dmrg_file%qcmaquis_checkpoint_file(1))

  ! remove all measurements just to be sure
  call qcmaquis_interface_remove_param('MEASURE[1rdm]')
  call qcmaquis_interface_remove_param('MEASURE[2rdm]')
  call qcmaquis_interface_remove_param('MEASURE[3rdm]')
  call qcmaquis_interface_remove_param('MEASURE[4rdm]')
  call qcmaquis_interface_remove_param('MEASURE[1spdm]')
  call qcmaquis_interface_remove_param('MEASURE[ChemEntropy]')

  ! only set 1-rdm here and the other rdms later on in grpini
  call qcmaquis_interface_set_param('MEASURE[1rdm]','1')
  !call qcmaquis_interface_set_param('MEASURE[2rdm]','1')
  !call qcmaquis_interface_set_param('MEASURE[3rdm]','1')
  !call qcmaquis_interface_set_param('MEASURE[4rdm]','1')
end if
#endif
!***********************************************************************
!
! Thresholds
!
!***********************************************************************
if (Input%THRE) then
  if (IPRGLB >= TERSE) call WarningMessage(1,'User modified linear dependency thresholds!')
end if
THRSHN = Input%THRSHN
THRSHS = Input%THRSHS
THRCONV = Input%THRCONV
CITHR = Input%PrWF
THRENE = 50.0_wp
THROCC = 5.0e-4_wp
MAXIT = Input%MaxIter
DNMTHR = Input%DNMTHR
CMPTHR = Input%CMPTHR
CNTTHR = Input%CNTTHR

PT2Method = 'CASPT2'
CPT2Method = 'CASPT2'

Do_FIC = .true.
Do_SC = .false.
SC_prop = .false.
SC_amplitude = .false.
if (HZERO == 'DYALL') then
  MAXIT = 0
  Do_FIC = input%DOPC
  Do_SC = input%DOSC
  SC_prop = input%SCPROP .or. (.not. Do_FIC)
  SC_amplitude = SC_prop
  SC_thres = abs(input%SC_thres)
  if (NRAS1T+NRAS3T > 0) then
    call warningMessage(2,'NEVPT2 calculations with a RAS reference wavefunction are not supported')
    call quit_onUserError()
  end if
  if ((.not. Do_FIC) .and. (.not. Do_SC)) then
    call warningMessage(2,'Both NOPC and NOSC are specified? Cannot do the job...')
    call quit_onUserError()
  end if
  if (ipea_shift /= Zero) then
    ipea_shift = Zero
    if (IPRGLB >= TERSE) call warningMessage(1,'IPEA shift is automatically turned off for NEVPT2')
  end if
  if (do_real .or. do_imag .or. do_sigp) then
    if (IPRGLB >= TERSE) call warningMessage(1,'Real or imaginary shift or sigma regularization is being used only for PC-NEVPT2')
  end if
  ! The option XMULT forces to use the state-averaged Fock
  if (IFXMS) input%SADREF = .true.
  ! However, <Psi^0|Hact|Psi^0> is always diagonal, so skip the diagonalization process of the model states
  IFXMS = .false.
  IFRMS = .false.

  PT2Method = 'NEVPT2'
  CPT2Method = 'PC-NEVPT2'
  if (SC_prop) CPT2Method = 'SC-NEVPT2'
end if

!***********************************************************************
!
! Gradients
!
!***********************************************************************

! at the moment the calculation of analytic gradients has many
! technical restrictions and we need to make sure that we do not
! run into a unsupported combination of keywords, these are:
! 1. no symmetry
! 2. all CASSCF roots included in QD-CASPT2 gradients
! 3. QD-CASPT2 gradients only with CD/DF

call put_iScalar('mp2prpt',0)

! check if numerical gradients were requested in GATEWAY
call qpg_iScalar('DNG',DNG_available)
if (DNG_available) then
  call get_iScalar('DNG',iDNG)
  DNG = iDNG == 1
else
  DNG = .false.
end if

! if the CASPT2 module was called by the NUMERICAL_GRADIENT one,
! we make sure to disable analytic gradients
if (SuperName(1:18) == 'numerical_gradient') then
  call put_iScalar('mp2prpt',0)
  DNG = .true.
  do_grad = .false.
end if

! check first if the user specifically asked for analytic gradients
! I think GRDT keyword should be ignored for numerical gradient and last energy
do_lindep = .false.
if ((input%GRDT .or. input%NAC) .and. (SuperName(1:18) /= 'numerical_gradient') .and. (SuperName(1:11) /= 'last_energy')) then
  do_grad = Input%GRDT .or. input%NAC

  ! quit if both analytical and numerical gradients were explicitly requested
  if (DNG) then
    call warningMessage(2,'It seems that numerical gradients were requested in GATEWAY and analytical gradients in CASPT2. '// &
                        'Please choose only one of the two!')
    call quit_onUserError()
  end if

  ! only allow analytic gradients without symmetry
  if (nSym /= 1) then
    call warningMessage(2,'Analytic gradients only available without symmetry.')
    call quit_onUserError()
  end if

  if (ipea_shift /= Zero) do_lindep = .true.

  ! only allow analytic gradients either with nstate = nroots or with sadref
  if ((nState /= nRoots) .and. (.not. ifsadref)) then
    call warningMessage(2,'Analytic gradients available only if all CASSCF roots are included in the CASPT2 calculation or '// &
                        'with the SADRef keyword.')
    call quit_onUserError()
  end if

  ! QD-CASPT2 analytic gradients available only with DF or CD
  if (ifMSCoup .and. (.not. ifChol)) then
    call warningMessage(2,'MS-type analytic gradients available only with density fitting or Cholesky decomposition.')
    call quit_onUserError()
  end if

  ! CASPT2 analytic gradients with state-dependent density available only with DF or CD
  if ((.not. ifChol) .and. (.not. input%SADREF) .and. (nRoots /= 1)) then
    call warningMessage(2,'Analytic gradients with state-dependent density available only with density fitting or Cholesky '// &
                        'decomposition.')
    call quit_onUserError()
  end if
# ifdef _MOLCAS_MPP_
  ! No parallel without RI/CD
  if ((.not. ifChol) .and. (nProcs > 1)) then
    call warningMessage(2,'Analytic gradients without density fitting or Cholesky decomposition not available in parallel '// &
                        'executions.')
    call quit_onUserError()
  end if
# ifndef _GA_
  ! for the time being no gradients without GA
  ! Parallel CASPT2 gradient is implemented with some GA-specific subroutines
  ! partially because I can use OpenMolcas only for which GA is required.
  ! As long as OpenMolcas concerns, this should be no problem (at all)
  if (nProcs > 1) then
    call warningMessage(2,'Analytic gradients not available without GA installed. Install GA and link.')
    call quit_onUserError()
  end if
# endif
# endif

end if

! inside LAST_ENERGY we do not need analytic gradients
if (SuperName(1:11) == 'last_energy') DNG = .true.

! check if the calculation is inside a loop and make analytical
! gradients default in this case, unless the user specifically
! requested numerical gradients in GATEWAY
if (isStructure() == 1) then
  ! check the hard constraints first
  if ((.not. DNG) .and. (nSym == 1)) then
    do_grad = .true.

    ! check weaker constraints, if not met, revert to numerical gradients
    if (ifMSCoup .and. (.not. ifChol)) do_grad = .false.
    if ((ipea_shift /= Zero) .and. (.not. ifChol)) do_grad = .false.
    if ((nState /= nRoots) .and. (.not. ifsadref)) do_grad = .false.
  end if
end if

! compute full unrelaxed density for gradients
if (do_grad) ifDens = .true.

if (do_grad) then
  call put_iScalar('mp2prpt',2)
  do_nac = input%NAC

  !! If states to be computed are requested by ALASKA
  !! (if "@" presents in MCLR Root), always compute for these states
  call Qpg_cArray('MCLR Root',Found,I)
  if (Found) then
    call Get_cArray('MCLR Root',mstate1,16)
    if (mstate1 /= '****************') then
      if (index(mstate1,'@') /= 0) then
        read(mstate1,'(1X,I7,1X,I7)') iRoot1,iRoot2
        if (iRoot1 /= 0) do_nac = .true.
        if (iRoot1 == 0) then
          iRoot1 = iRoot2
          iRlxRoot = iRoot1
          do_nac = .false.
        end if
      end if
    end if
  end if

  !! If nothing is specified by ALASKA, use the states in &CASPT2
  if ((iRoot1 == 0) .and. (iRoot2 == 0)) then
    if ((input%iNACRoot1 == 0) .and. (input%iNACRoot2 == 0)) then
      iRoot1 = iRlxRoot
      iRoot2 = iRlxRoot
    else
      iRoot1 = input%iNACRoot1
      iRoot2 = input%iNACRoot2
    end if
  end if
end if

if (do_nac) then
  do_csf = input%CSF
  if (isStructure() == 1) do_csf = .false. !! omit the CSF term during (any) geometry optimizations
end if

IFSADREF = input%SADREF
IFDORTHO = input%DORTHO
if_invar = input%INVAR
if (ipea_shift /= Zero) if_invar = .false.
if_invaria = input%IAINVAR
if (sigma_p_epsilon /= Zero) if_invaria = .false. !! I'm not sure this is necessary, but it is needed for now
if (SC_prop) if_invaria = .false.
ConvInvar = input%ThrConvInvar

if ((ipea_shift /= Zero) .and. do_grad .and. (.not. IFDORTHO)) then
  call warningMessage(2,'Analytic gradients with IPEA shift must use the CORT or DORT option.')
  call quit_onUserError()
end if

#ifdef _MOLCAS_MPP_
if (do_grad .and. (sigma_p_epsilon /= Zero) .and. (nProcs > 1)) then
  call warningMessage(2,'Analytic gradients without the sigma^P regularization not available in parallel executions.')
  call quit_onUserError()
end if
#endif

if (do_grad .and. RF_On() .and. (.not. if_invar)) then
  if (IPRGLB >= TERSE) call warningMessage(1,'Analytic gradients with IPEA shift and PCM is not fully analytic.')
end if

!! Whether the Fock matrix (eigenvalues) is constructed with
!! the state-averaged density matrix or not.
!! The name of the variable is like state-specific DM,
!! but not necessarily state-specific. It is a matter of the
!! structure of DWGT(:,:) array or matrix.
!! DWGT is a matrix form for SS- and MS-CASPT2 with
!! state-specific DM, XDW-CASPT2, and RMS-CASPT2, while it is an
!! array for SS- and MS-CASPT2 with state-averaged DM (with SADREF
!! option) and XMS-CASPT2.
if (IFSADREF .or. (nRoots == 1) .or. (IFXMS .and. (.not. IFDW))) then
  if_SSDM = .false.
else
  if_SSDM = .true.
end if

!! Check if unequal-weighted MCSCF or not. Used only for gradients.
if (do_grad) then
  if (if_SSDM) if_equalW = .false.
  do I=2,nRoots
    if (Weight(1) /= Weight(I)) if_equalW = .false.
  end do
  if (.not. if_equalW) if_SSDM = .true.
end if

!! issue #448
if ((IFDENS .and. (.not. do_grad)) .and. (NRAS1T+NRAS3T > 0)) then
  call warningMessage(2,'DENS keyword cannot be combined with RAS.')
  call quit_onUserError()
end if

if (do_grad .and. (HZERO == 'DYALL')) then
  if ((.not. Do_FIC) .and. (.not. SC_prop)) then
    call warningMessage(2,'PC-NEVPT2 properties cannot be computed without PC-NEVPT2 energy. Remove the NOPC keyword.')
    call quit_onUserError()
  end if
  if ((.not. Do_SC) .and. SC_prop) then
    call warningMessage(2,'SC-NEVPT2 properties cannot be computed without SC-NEVPT2 energy. Remove the NOSC keyword.')
    call quit_onUserError()
  end if
end if

end subroutine procinp_caspt2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!***********************************************************************

subroutine EMPTY(BUF,IBUF,LASTAD,SO,KBUF,NTPB)

use guga_global, only: IADD10, ICASE, ILIM, IOUT, IV0, JRC, LN, Lu_10, Lu_11, NBUF, NMAT
use guga_util_global, only: COP, ICOP1, nCOP
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: KBUF, LASTAD(*), NTPB
real(kind=wp), intent(out) :: BUF(KBUF)
integer(kind=iwp), intent(out) :: IBUF(KBUF+2)
real(kind=wp), intent(_OUT_) :: SO(*)
integer(kind=iwp) :: I, IADR, ICLR, II, IIQQ, IJJ, IKK, IN_, IND, IOFF, IQ, ISUM, ITYP, IVL, IVL0, J, JJ, JJ1, JJ2, KK, LENGTH, NBX
integer(kind=iwp), external :: ICUNP

ISUM = JRC(ILIM)
IOUT = 0
NMAT = 0
ICLR = NTPB
IN_ = ICLR+1
NBX = 0
IOFF = 0
do II=1,ISUM
  if (II <= JRC(1)) then
    IVL = IV0
    KK = II
  else if (II <= JRC(2)) then
    IVL = IV0-1
    KK = II-JRC(1)
  else if (II <= JRC(3)) then
    IVL = IV0-2
    KK = II-JRC(2)
  else
    IVL = IV0-3
    KK = II-JRC(3)
  end if
  IOUT = IOUT+1
  ICOP1(IOUT) = 0
  if (IOUT >= NBUF) then
    ICOP1(nCOP+1) = NBUF
    call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
    call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
    NMAT = NMAT+NBUF
    IOUT = 0
  end if
  IVL0 = IV0-IVL
  !IND = KK+2**16*IVL0
  IND = ior(KK,ishft(IVL0,16))
  IOUT = IOUT+1
  ICOP1(IOUT) = IND
  if (IOUT >= NBUF) then
    ICOP1(nCOP+1) = NBUF
    call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
    call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
    NMAT = NMAT+NBUF
    IOUT = 0
  end if
  IJJ = 0
  JJ = (II-1)*LN
  do I=1,LN
    JJ1 = ICUNP(ICASE,JJ+I)
    do J=1,I
      IJJ = IJJ+1
      IN_ = IN_+1
      if (IN_ > ICLR) then
        IN_ = 1
        SO(1:ICLR) = Zero
        NBX = NBX+1
        IADR = LASTAD(NBX)
        do while (IADR /= -1)
          ! FPS
          call dDAFILE(Lu_11,2,BUF,KBUF,IADR)
          call iDAFILE(Lu_11,2,IBUF,KBUF+2,IADR)
          LENGTH = IBUF(KBUF+1)
          IADR = IBUF(KBUF+2)
          do IIQQ=1,LENGTH
            IQ = IBUF(IIQQ)-IOFF
            SO(IQ) = BUF(IIQQ)
          end do
        end do
        IOFF = IOFF+ICLR
      end if
      if (JJ1 == 0) cycle
      JJ2 = ICUNP(ICASE,JJ+J)
      if (JJ2 == 0) cycle
      ITYP = 0
      if (I == J) ITYP = 1
      IKK = IJJ
      if (ITYP == 1) IKK = I
      if (SO(IN_) == Zero) cycle
      IOUT = IOUT+1
      !PAM96 ICOP1(IOUT) = ior(ITYP,ishft(IKK,1))
      !ICOP1(IOUT) = ITYP+2*IKK
      ICOP1(IOUT) = ior(ITYP,ishft(IKK,1))
      COP(IOUT) = SO(IN_)
      if (IOUT < NBUF) cycle
      ICOP1(nCOP+1) = NBUF
      call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT = NMAT+NBUF
      IOUT = 0
    end do
  end do
end do

return

end subroutine EMPTY

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine ModFck(Fock,Ovlp,nFO,CMO,nCMO,mynOcc)
************************************************************************
*                                                                      *
*     purpose: Modify Fock matrix taking into account frozen orbitals  *
*              F <- [1 - S*D(f)]*F  (symmetrized).                     *
*                                                                      *
*     input:                                                           *
*       Fock    : Fock matrix of length nFO                            *
*       Ovlp    : overlap matrix of length nFO                         *
*                                                                      *
*     output:                                                          *
*       Fock    : modified Fock matrix                                 *
*                                                                      *
*     called from: NewOrb, DCore, EGrad                                *
*                                                                      *
*     calls to: DFroz, Sym                                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 Fock(nFO),Ovlp(nFO),CMO(nCMO)
      Integer mynOcc(*)
      Real*8, Dimension(:), Allocatable:: DFro, DFSq, OvSq, Aux1
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*---- Allocate memory for density contribution
      Call mma_allocate(DFro,nBT,Label='DFro')
*
*---- Allocate memory for squared density (then for squared Fock matrix)
      Call mma_allocate(DFSq,MaxBas**2,Label='DFSq')
*
*---- Allocate memory for squared overlap and later for 1 - S*D(f)
      Call mma_allocate(OvSq,MaxBas**2,Label='OvSq')
*
*---- Allocate memory for S*D(f)
      Call mma_allocate(Aux1,MaxBas**2,Label='Aux1')
*
*---- Generate contribution to the density mat. from frozen orbitals
      Call DFroz(DFro,nBT,CMO,nBO,mynOcc)
*
      ij   = 1
      Do iSym = 1, nSym
*
         If (nBas(iSym).gt.0) Then
*---------- Square density and overlap
            Call DSq(DFro(ij),DFSq,1,nBas(iSym),nBas(iSym))
            Call Square(Ovlp(ij),OvSq,1,nBas(iSym),nBas(iSym))
*
*---------- Compute S*D(f)
            Call DGEMM_('N','N',
     &                  nBas(iSym),nBas(iSym),nBas(iSym),
     &                  1.0d0,OvSq,nBas(iSym),
     &                        DFSq,nBas(iSym),
     &                  0.0d0,Aux1,nBas(iSym))
*
*---------- Put unit matrix to memory ascribed for overlap and compute 1 - S*D(f)
            call dcopy_(nBas(iSym)**2,[Zero],0,OvSq,1)
            call dcopy_(nBas(iSym)   ,[One] ,0,OvSq,nBas(iSym) + 1)
            call daxpy_(nBas(iSym)**2,-One,Aux1,1,OvSq,1)
*
*---------- Square Fock matrix and store in memory ascribed for density
            Call Square(Fock(ij),DFSq,1,nBas(iSym),nBas(iSym))
*
*---------- Compute F <- [1 - S*D(f)]*F
            Call DGEMM_('N','N',
     &                  nBas(iSym),nBas(iSym),nBas(iSym),
     &                  1.0d0,OvSq,nBas(iSym),
     &                        DFSq,nBas(iSym),
     &                  0.0d0,Aux1,nBas(iSym))
*
*---------- Symmetrize modified Fock matrix
            Call Sym(Aux1,Fock(ij),nBas(iSym))
         End If
*
*------- Update pointers
         ij = ij + nBas(iSym)*(nBas(iSym) + 1)/2
*
      End Do
*
*---- Deallocate memory
      Call mma_deallocate(Aux1)
      Call mma_deallocate(OvSq)
      Call mma_deallocate(DFSq)
      Call mma_deallocate(DFro)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End
      SubRoutine Sym(A,S,n)
************************************************************************
*                                                                      *
*     purpose: Symmetrize matrix                                       *
*                                                                      *
*     input:                                                           *
*       A       : input matrix (square)                                *
*       n       : dimension                                            *
*                                                                      *
*     output:                                                          *
*       S       : Symmetrized matrix (triangular)                      *
*                                                                      *
*     called from: ModFck                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
      Real*8 A(n,n),S(n*(n+1)/2)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
      ij = 0
      Do i = 1, n
         Do j = 1, i
            ij = ij + 1
            S(ij) = (A(i,j) + A(j,i))/2.0d+00
         End Do
      End Do
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine outmo(imo,ipower,cmo,clincomb,cout,nbas,nmo)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: imo, ipower, nbas, nmo
real(kind=wp), intent(in) :: cmo(nbas,nmo), clincomb(nmo)
real(kind=wp), intent(out) :: cout(nbas)
integer(kind=iwp) :: i
real(kind=wp), allocatable :: TmpMo(:)

if (imo /= 0) then
  cout(:) = cmo(:,imo)
  call power(cout,nbas,ipower)
else
  cout(:) = Zero
  call mma_allocate(TmpMo,nbas,label='TmpMo')
  do i=1,nmo
    if (clincomb(i) /= Zero) then
      TmpMo(:) = cmo(:,i)
      call power(TmpMo,nbas,ipower)
      cout(:) = cout(:)+clincomb(i)*TmpMo(:)
    end if
  end do
  call mma_deallocate(TmpMo)
end if

return

end subroutine outmo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Modify_TInt_p(TInt,nTheta_All,List2,mData)

use Basis_Info, only: Shells
use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: nTheta_All, mData, List2(mData,nTheta_All)
real(kind=wp), intent(inout) :: TInt(nTheta_All,nTheta_All)
integer(kind=iwp) :: iShll, iTheta_All, jShll, jTheta_All, kShll, lShll, nConti, nContj, nContk, nContl, nPrimi, nPrimj, nPrimk, &
                     nPriml
real(kind=wp) :: Coeff_i, Coeff_j, Coeff_k, Coeff_l
real(kind=r8), external :: DDot_

#ifdef _DEBUGPRINT_
call RecPrt('Modify_TInt_p: TInt',' ',TInt,nTheta_All,nTheta_All)
#endif
do iTheta_All=1,nTheta_All
# ifdef _DEBUGPRINT_
  iPrim = List2(5,iTheta_All)
# endif
  iShll = List2(7,iTheta_All)
  nConti = Shells(iShll)%nBasis_C
  nPrimi = Shells(iShll)%nExp
  Coeff_i = DDot_(nConti,Shells(iShll)%Cff_c(1,1,1),nPrimi,Shells(iShll)%Cff_c(1,1,1),nPrimi)
  Coeff_i = sqrt(Coeff_i)

# ifdef _DEBUGPRINT_
  jPrim = List2(6,iTheta_All)
# endif
  jShll = List2(8,iTheta_All)
  nContj = Shells(jShll)%nBasis_C
  nPrimj = Shells(jShll)%nExp
  Coeff_j = DDot_(nContj,Shells(jShll)%Cff_c(1,1,1),nPrimj,Shells(jShll)%Cff_c(1,1,1),nPrimj)
  Coeff_j = sqrt(Coeff_j)

  do jTheta_All=1,nTheta_All
#   ifdef _DEBUGPRINT_
    kPrim = List2(5,jTheta_All)
#   endif
    kShll = List2(7,jTheta_All)
    nContk = Shells(kShll)%nBasis_C
    nPrimk = Shells(kShll)%nExp
    Coeff_k = DDot_(nContk,Shells(kShll)%Cff_c(1,1,1),nPrimk,Shells(kShll)%Cff_c(1,1,1),nPrimk)
    Coeff_k = sqrt(Coeff_k)

#   ifdef _DEBUGPRINT_
    lPrim = List2(6,jTheta_All)
#   endif
    lShll = List2(8,jTheta_All)
    nContl = Shells(lShll)%nBasis_C
    nPriml = Shells(lShll)%nExp
    Coeff_l = DDot_(nContl,Shells(lShll)%Cff_c(1,1,1),nPriml,Shells(lShll)%Cff_c(1,1,1),nPriml)
    Coeff_l = sqrt(Coeff_l)

    TInt(iTheta_All,jTheta_All) = TInt(iTheta_All,jTheta_All)*Coeff_i*Coeff_j*Coeff_k*Coeff_l
#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) Coeff_i,Coeff_j,Coeff_k,Coeff_l
    write(u6,*) iPrim,jPrim,kPrim,lPrim
    write(u6,*) nPrimi,nPrimj,nPrimk,nPriml
#   endif

  end do

end do
#ifdef _DEBUGPRINT_
call RecPrt('Modify_TInt_p: TInt',' ',TInt,nTheta_All,nTheta_All)
#endif

return

end subroutine Modify_TInt_p

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 FUNCTION DER(IDER,IS1,IS2,AL,BE)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C    CALCULATE INTEGRAL OVER DERIVATIVE OF THE FUNCTIONS
C
      INTEGER IS1(3),IS2(3),I1(2,3),I2(2,3)
      REAL*8 F(2),G(2)
      COMMON /CRELOP/ PI,ZWP,SQPI,VELIT,PREA,CSQ,ZWPH32,FAK(26),
     *ZWPH12,BCO(210),GAM(20),IMAX
      DO 1 I=1,3
      DO 2 J=1,2
      I1(J,I)=IS1(I)
      I2(J,I)=IS2(I)
2     CONTINUE
1     CONTINUE
      I1(1,IDER)=I1(1,IDER)+1
      I1(2,IDER)=I1(2,IDER)-1
      I2(1,IDER)=I2(1,IDER)+1
      I2(2,IDER)=I2(2,IDER)-1
      L1=IS1(IDER)+1
      GOTO (10,11,12,13,14),L1
101   WRITE (6,100) IDER,IS1,IS2,AL,BE
100   FORMAT(' ILLEGAL ANGULAR MOMENTUM (DER)'/,
     \       ' IDER,IS1,IS2,AL,BE PRINTED'/,1X,7I5,3X,2D20.8)
      Call Abend
10    F(1)=-2.D0*AL
      J1=1
      GOTO 19
C
11    F(2)=1.D0
      F(1)=-2.D0*AL
      J1=2
      GOTO 19
C
12    F(2)=2.D0
      F(1)=-2.D0*AL
      J1=2
      GOTO 19
C
13    F(2)=3.D0
      F(1)=-2.D0*AL
      J1=2
      GOTO 19
C
14    F(2)=4.0D0
      F(1)=-2.0D0*AL
      J1=2
C
19    L2=IS2(IDER)+1
      GOTO (20,21,22,23,24),L2
      GOTO 101
C
20    G(1)=-2.D0*BE
      J2=1
      GOTO 29
C
21    G(2)=1.D0
      G(1)=-2.D0*BE
      J2=2
      GOTO 29
C
22    G(2)=2.D0
      G(1)=-2.D0*BE
      J2=2
      GOTO 29
C
23    G(2)=3.D0
      G(1)=-2.D0*BE
      J2=2
      GOTO 29
C
24    G(2)=4.0D0
      G(1)=-2.0D0*BE
      J2=2
C
29    SUM=0.D0
      DO 30 I=1,J1
      DO 31 J=1,J2
      II=I1(I,1)+I2(J,1)
      JJ=I1(I,2)+I2(J,2)
      KK=I1(I,3)+I2(J,3)
      ANG=THETA(II+JJ,KK)*PHI(JJ,II)
      IF (ANG.EQ.0.D0) GOTO 31
      EX=-DBLE(II+JJ+KK+2)*0.5D0
      SUM=SUM+F(I)*G(J)*0.5D0*ANG*GAM(II+JJ+KK+2)*
     \        (AL+BE)**EX
31    CONTINUE
30    CONTINUE
      DER=SUM
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_PFake_PutVec(Vec,InfV,nVec,iSym,iV1)

use Cholesky, only: Cho_AdrVec, LuCho_G
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_IN_) :: Vec(*)
integer(kind=iwp), intent(inout) :: InfV(2,*)
integer(kind=iwp), intent(in) :: nVec, iSym, iV1
integer(kind=iwp) :: iAdr, iOpt, iPos, iVec, lTot
character(len=*), parameter :: SecNam = 'Cho_PFake_PutVec'

if (nVec < 1) return

if (CHO_ADRVEC == 1) then
  iOpt = 1
  lTot = sum(InfV(1,iV1:iV1+nVec-1))
  iAdr = InfV(2,iV1)
  call dDAFile(LuCho_G(iSym),iOpt,Vec,lTot,iAdr)
  do iVec=iV1+1,iV1+nVec
    InfV(2,iVec) = InfV(2,iVec-1)+InfV(1,iVec-1)
  end do
else if (CHO_ADRVEC == 2) then
  iPos = 1
  do iVec=iV1,iV1+nVec-1
    iOpt = 1
    lTot = InfV(1,iVec)
    iAdr = InfV(2,iVec)
    call dDAFile(LuCho_G(iSym),iOpt,Vec(iPos),lTot,iAdr)
    iPos = iPos+InfV(1,iVec)
    InfV(2,iVec+1) = iAdr
  end do
else
  call Cho_Quit('Illegal CHO_ADRVEC in '//SecNam,102)
end if

end subroutine Cho_PFake_PutVec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Cho_X_Init
*
*> @brief
*>   Initialize Cholesky vector information for external use.
*> @author Thomas Bondo Pedersen
*>
*> @details
*> This routine reads and processes the information
*> stored on the runfile/restart files by the Cholesky
*> decomposition utility.
*> This routine is also used for setting up the environment in
*> density fitting (DF or RI) runs.
*> Index arrays are allocated and initialized.
*> All information is stored in the include files
*> cholesky.fh, choorb.fh, and choptr.fh.
*>
*> \p BufFrac is the fraction of total available memory that will be
*> allocated as Cholesky vector buffer. For example, \p BufFrac = ``0.35``
*> implies that 35% of the total available memory (after the
*> allocations of this routine) will be allocated for Cholesky
*> vectors. The vectors will be read into the buffer as part of
*> the initialization. The reading routines can then be used as
*> usual; the buffer is automatically taken care of by the reading
*> routines. If \p BufFrac is less than or equal to zero, no buffer
*> will be used.
*>
*> Return codes:
*>
*> - \p irc = ``-2``: Local DF not implemented here
*> - \p irc = ``-1``: Cholesky flag not found on runfile
*> - \p irc =  ``0``: initialization success
*> - \p irc =  ``1``: runfile info corrupted
*> - \p irc =  ``2``: restart file info corrupted
*> - \p irc =  ``3``: inconsistent include file(s) detected (typically an internal error/bug)
*> - \p irc =  ``4``: error in parallel setup
*>
*> @note
*> The two-electron repulsion integrals must have been decomposed by Seward.
*>
*> @param[out] irc     Return code
*> @param[in]  BufFrac Fraction of memory to be used as buffer
************************************************************************
      Subroutine Cho_X_Init(irc,BufFrac)
#include "implicit.fh"
#include "choorb.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "choptr2.fh"
#include "chosp.fh"
#include "choini.fh"
#include "choprint.fh"
#include "chobkm.fh"
#include "WrkSpc.fh"

      Character*10 SecNam
      Parameter (SecNam = 'Cho_X_Init')

#if defined (_DEBUGPRINT_)
      Character*2 Unt
#endif

      Logical DidCholesky, FirstCall
      Logical isDF, isLocalDF, DoDummy

      Integer ChoIsIni, ip, l

      Integer  Cho_iSumElm
      External Cho_iSumElm

      Save FirstCall
      Data FirstCall /.true./

      nBstSh(i)=iWork(ip_nBstSh-1+i)
      iSP2F(i)=iWork(ip_iSP2F-1+i)

C     Register entry.
C     ---------------

#if defined (_DEBUGPRINT_)
      Call GetMem('CXI_MX1','Max ','Real',ip_Max,l_Max)
      Call Cho_Word2Byte(l_Max,8,Byte,Unt)
      Write(6,*) '>>>>> Available memory on entry to ',SecNam,': ',
     &           l_Max,' = ',Byte,Unt
#endif

C     Check that this is a Cholesky run.
C     ----------------------------------

      Call DecideOnCholesky(DidCholesky)
      If (.not. DidCholesky) Go To 100

C     Check if already initialized.
C     -----------------------------

      If (FirstCall) Then ! it cannot be already done
         FirstCall = .false.
      Else ! might be already done
         Call Get_iScalar('ChoIni',ChoIsIni)
         If (ChoIsIni .eq. ChoIniCheck) Then ! already done
            irc = 0
            Go To 1
         End If
      End If

C     Check if this is density fitting (DF).
C     --------------------------------------

      Call DecideOnDF(isDF)
      If (isDF) Then
         Call DecideOnLocalDF(isLocalDF)
         If (isLocalDF) Go To 99
      End If

C     Define all entries in include files choorb.fh, cholesky.fh,
C     choprint.fh, and choptr.fh.
C     -------------------------------------------------------------

      Call Cho_X_SetInc(irc)
      If (irc .ne. 0) Then
         Go To 103  ! include file inconsistency detected
      End If

C     Set parallel info (picked up from para_info.fh).
C     -------------------------------------------------

      CHO_FAKE_PAR = .False.
      Call Cho_ParConf(CHO_FAKE_PAR)

C     Define entries in choptr2.fh.
C     ------------------------------

      Call Cho_SetPtr2()

C     Set run mode to "external".
C     ---------------------------

      Run_Mode = Run_External

C     Set output unit used by the decomposition core routines.
C     --------------------------------------------------------

      LuPri = 6

C     Set print level to -5 (ensuring that Cho_X_Checkdiag will
C     print information, if called). All other routines will be
C     silent.
C     ---------------------------------------------------------

      iPrint=-5

C     Get nSym: the number of irreps.
C     -------------------------------

      Call Get_iScalar('nSym',nSym)
      If (nSym.lt.1 .or. nSym.gt.8) Then
         Write(6,*) SecNam,': nSym out of bounds: ',nSym
         Go To 101
      End If

C     Get Cho_AdrVec: addressing of vector files (1=WA, 2=DA).
C     --------------------------------------------------------

      Call Get_iScalar('ChoVec Address',Cho_AdrVec)

C     Open files with red. set and vector info.
C     -----------------------------------------

      Call Cho_UnIni()
      Call Cho_OpenVR(1,2)

C     Set vector I/O model etc.
C     -------------------------

      Cho_IOVec = 3
      N1_VecRd  = 2
      N2_VecRd  = 3
      nSys_Call = 0
      nDGM_Call = 0

C     Get info (derived) from the runfile.
C     nBas  : #basis functions in each irrep
C     iSOShl: shell index for each basis function (SO)
C     NumCho: #Cholesky vectors in each irrep
C     MaxVec: max. element in NumCho (used to allocate InfVec)
C     --------------------------------------------------------

      Call Get_iArray('nBas',nBas,nSym)
      iBas(1) = 0
      nBasT   = nBas(1)
      Do iSym = 2,nSym
         iBas(iSym) = nBasT
         nBasT = nBasT + nBas(iSym)
      End Do
      If (nBasT .lt. 1) Then
         Write(6,*) SecNam,': nBasT out of bounds: ',nBasT
         Go To 101
      End If
      l_iSOShl = nBasT
      Call GetMem('iSOShl','Allo','Inte',ip_iSOShl,l_iSOShl)
      Call Get_iArray('ISOSHL',iWork(ip_iSOShl),nBasT)

      Call Get_iArray('NumCho',NumCho,nSym)
      NumChT = Cho_iSumElm(NumCho,nSym)
      MaxVec = NumCho(1)
      Do iSym = 2,nSym
         MaxVec = max(MaxVec,NumCho(iSym))
      End Do

C     Read Cholesky restart file. Allocate InfRed and InfVec.
C     nShell: #shells
C     nnShl_Tot : total #shell pairs
C     nnShl : #shell pairs contributing in diagonal
C     MaxRed: #reduced sets (used to allocate InfRed)
C     InfRed: InfRed(i) is the disk address of reduced set i
C     InfVec: InfVec(i,1,iSym) is the parent index of vector i in irrep
C                              iSym in first reduced set
C             InfVec(i,2,iSym) is the reduced set of this vector
C             InfVec(i,3,iSym) is the disk address for reading this
C                              vector
C             InfVec(i,4,iSym) is the WA disk address of this vector.
C             InfVec(i,5,iSym) in a parallel run is the global index
C                              of the i-th vector in iSym for this node
C                              (in serial: InfVec(i,5,iSym) = i)
C     Note: InfVec(i,5,iSym) is treated in a quite dirty way here:
C       for DF:
C           not defined in serial, thus it will be defined by the call
C           to Cho_X_DefineInfVec_5.
C           defined in parallel (simply read from disk and not modified
C           by Cho_X_DefineInfVec_5).
C       for Cholesky:
C           not defined in serial, thus it will be defined by the call
C           to Cho_X_DefineInfVec_5.
C           not defined in parallel, thus it will be defined by the call
C           to Cho_X_DefineInfVec_5. It is later modified by
C           Cho_X_Init_Par.
C     ------------------------------------------------------------------

      ierr = 0
      Call Cho_X_RdRst(ierr)
      If (ierr .ne. 0) Go To 102
      nnShl_Tot = nShell*(nShell+1)/2
      Call Cho_X_DefineInfVec_5(isDF)

C     nnShl_SP makes it possible to use function Cho_F2SP.
C     (Stored in chosp.fh)
C     ----------------------------------------------------

      nnShl_SP = nnShl

C     Allocate and initialize index arrays.
C     -------------------------------------

      l_iiBstRSh = nSym*nnShl*3
      l_nnBstRSh = nSym*nnShl*3
      Call GetMem('iiBstRSh','Allo','Inte',ip_iiBstRSh,l_iiBstRSh)
      Call GetMem('nnBstRSh','Allo','Inte',ip_nnBstRSh,l_nnBstRSh)
      Call Cho_RstD_GetInd1()
      mmBstRT = nnBstRT(1)

      l_IndRed = nnBstRT(1)*3
      l_IndRSh = nnBstRT(1)
      Call GetMem('IndRed','Allo','Inte',ip_IndRed,l_IndRed)
      Call GetMem('IndRSh','Allo','Inte',ip_IndRSh,l_IndRSh)
      Call Cho_RstD_GetInd2()

      l_iSP2F = nnShl
      Call GetMem('SP2F','Allo','Inte',ip_iSP2F,l_iSP2F)
      Call Cho_RstD_GetInd3(iWork(ip_iSP2F),l_iSP2F)

C     Allocate and read bookmarks (if available on runfile).
C     ------------------------------------------------------

      If (isDF) Then
         ip_BkmVec=0
         l_BkmVec=0
         nRow_BkmVec=0
         nCol_BkmVec=0
         ip_BkmThr=0
         l_BkmThr=0
         nRow_BkmThr=0
         nCol_BkmThr=0
      Else
         l=4
         Call GetMem('BkmDim','Allo','Inte',ip,l)
         Call Get_iArray('Cholesky BkmDim',iWork(ip),l)
         nRow_BkmVec=iWork(ip)
         nCol_BkmVec=iWork(ip+1)
         nRow_BkmThr=iWork(ip+2)
         nCol_BkmThr=iWork(ip+3)
         Call GetMem('BkmDim','Free','Inte',ip,l)
         If (nRow_BkmVec.gt.0 .and. nCol_BkmVec.gt.0 .and.
     &       nRow_BkmThr.gt.0 .and. nCol_BkmThr.gt.0) Then
            l_BkmVec=nRow_BkmVec*nCol_BkmVec
            Call GetMem('BkmVec','Allo','Inte',ip_BkmVec,l_BkmVec)
            Call Get_iArray('Cholesky BkmVec',iWork(ip_BkmVec),l_BkmVec)
            l_BkmThr=nRow_BkmThr*nCol_BkmThr
            Call GetMem('BkmVec','Allo','Real',ip_BkmThr,l_BkmThr)
            Call Get_dArray('Cholesky BkmThr',Work(ip_BkmThr),l_BkmThr)
         Else
            ip_BkmVec=0
            l_BkmVec=0
            nRow_BkmVec=0
            nCol_BkmVec=0
            ip_BkmThr=0
            l_BkmThr=0
            nRow_BkmThr=0
            nCol_BkmThr=0
         End If
      End If

C     mySP is set because a few core routines may use it.
C     After the decomposition is done, it must be a trivial mapping and
C     the user (programmer) should not worry about it at all.
C     -----------------------------------------------------------------

      l_mySP = nnShl
      Call GetMem('mySP','Allo','Inte',ip_mySP,l_mySP)
      Do ijShl = 1,nnShl
         iWork(ip_mySP-1+ijShl) = ijShl
      End Do

C     Copy reduced set 1 to location 2.
C     ---------------------------------

      Call Cho_RSCopy(iWork(ip_iiBstRSh),iWork(ip_nnBstRSh),
     &                iWork(ip_IndRed),1,2,nSym,nnShl,mmBstRT,3)

C     Get dimensions of reduced sets.
C     -------------------------------

      l_nDimRS = nSym*MaxRed
      Call GetMem('nDimRS','Allo','Inte',ip_nDimRS,l_nDimRS)
      Call iCopy(nSym,nnBstR(1,1),1,iWork(ip_nDimRS),1)
      iLoc = 3
      Do iRed = 2,MaxRed
         kOff1 = ip_nnBstRSh + nSym*nnShl*(iLoc - 1)
         kOff2 = ip_IndRed   + mmBstRT*(iLoc - 1)
         Call Cho_GetRed(iWork(ip_InfRed),iWork(kOff1),
     &                   iWork(kOff2),iWork(ip_IndRsh),iWork(ip_iSP2F),
     &                   MaxRed,nSym,nnShl,mmBstRT,iRed,.false.)
         Call Cho_SetRedInd(iWork(ip_iiBstRSh),iWork(ip_nnBstRSh),
     &                      nSym,nnShl,iLoc)
         kOff3 = ip_nDimRS + nSym*(iRed - 1)
         Call iCopy(nSym,nnBstR(1,iLoc),1,iWork(kOff3),1)
      End Do

C     Copy reduced set 1 to location 3.
C     ---------------------------------

      Call Cho_RSCopy(iWork(ip_iiBstRSh),iWork(ip_nnBstRSh),
     &                iWork(ip_IndRed),1,3,nSym,nnShl,mmBstRT,3)

C     Derive:
C     nBasSh: #basis functions in sym. block of shell.
C     nBstSh: #basis functions in each shell.
C     Mx2Sh : max. shell pair dimension.
C     iShlSO: index of SO within its shell.
C     ------------------------------------------------

      l_iBasSh = nSym*nShell
      l_nBasSh = nSym*nShell
      l_nBstSh = nShell
      Call GetMem('iBasSh','Allo','Inte',ip_iBasSh,l_iBasSh)
      Call GetMem('nBasSh','Allo','Inte',ip_nBasSh,l_nBasSh)
      Call GetMem('nBstSh','Allo','Inte',ip_nBstSh,l_nBstSh)
      Call Cho_SetSh(iWork(ip_iBasSh),iWork(ip_nBasSh),iWork(ip_nBstSh),
     &               iBas,nBas,iWork(ip_iSOShl),nSym,nShell,nBasT)

      MxOrSh = nBstSh(1)
      Do iShl = 2,nShell
         MxOrSh = max(MxOrSh,nBstSh(iShl))
      End Do

      Mx2Sh = 0
      Do ijShl = 1,nnShl
         Call Cho_InvPck(iSP2F(ijShl),iShl,jShl,.True.)
         If (iShl .eq. jShl) Then
            Numij = nBstSh(iShl)*(nBstSh(iShl)+1)/2
         Else
            Numij = nBstSh(iShl)*nBstSh(jShl)
         End If
         Mx2Sh = max(Mx2Sh,Numij)
      End Do

      l_iShlSO = nBasT
      Call GetMem('iShlSO','Allo','Inte',ip_iShlSO,l_iShlSO)
      Call Cho_SetSh2(iWork(ip_iShlSO),iWork(ip_iSOShl),
     &                iWork(ip_nBstSh),nBasT,nShell)

C     Allocate and compute mapping RS1->Full.
C     ---------------------------------------

      l_iRS2F = 2*nnBstRT(1)
      Call GetMem('iRS2F','Allo','Inte',ip_iRS2F,l_iRS2F)
      Call Cho_RSTOF(iWork(ip_iRS2F),2,nnBstRT(1),1)

C     Allocate integer scratch array used for Cholesky vector I/O.
C     ------------------------------------------------------------

      DoDummy = .not.(Cho_IOVec.eq.1 .or. Cho_IOVec.eq.2 .or.
     &                Cho_IOVec.eq.3 .or. Cho_IOVec.eq.4)
      Call Cho_Allo_iScr(DoDummy)

C     Setup for parallel runs.
C     ------------------------

      Call Cho_X_Init_Par(irc,isDF)
      If (irc .ne. 0) Then
         Go To 104
      End If

#if defined (_DEBUGPRINT_)
C     Debug: test bookmarks.
C     Note that 1C-CD flag must be available on runfile
C     (make sure _DEBUGPRINT_ is defined also in Cho_Final().
C     --------------------------------------------------
      If (l_BkmVec.gt.0 .and. l_BkmThr.gt.0) Then
         Call Get_iScalar('1C-CD',is1CCD)
         Call Cho_TestBookmark(irc,.True.,is1CCD.eq.1)
         If (irc.ne.0) Call Cho_Quit('Bookmark test failed!',104)
      End If
#endif

C     Allocate and initialize (i.e. read vectors) vector buffer.
C     ----------------------------------------------------------

      Frac = min(max(BufFrac,0.0d0),1.0d0)
      Call Cho_VecBuf_Init(Frac,nnBstR(1,1)) ! allocate
      Call Cho_VecBuf_Ini2() ! read

C     Normal exit point.
C     ------------------

      ChoIsIni = ChoIniCheck
      Call Put_iScalar('ChoIni',ChoIsIni)
      irc = 0
      Go To 1

C     Error branches.
C     ===============

   99 Continue ! Local DF not implemented
C TODO/FIXME: compute Cholesky vectors from LDF coefficients here?
         irc=-2
         Write(6,'(//,A,A,//)')
     &   SecNam,': Local DF not implemented!'
      Go To 1

  100 Continue ! Cholesky flag not found on runfile
         irc = -1
         Write(6,'(//,A,A,//)')
     &   SecNam,': two-electron integrals not Cholesky decomposed!'
      Go To 1

  101 Continue ! Bad info obtained from runfile
         irc = 1
         Write(6,'(//,A,A,//)')
     &   SecNam,': WARNING: error reading runfile!'
      Go To 1

  102 Continue ! restart info corrupted
         irc = 2
         Write(6,'(//,A,A)')
     &   SecNam,': WARNING: error reading restart info!'
         Write(6,'(A,A,I6,//)')
     &   SecNam,': return code from read:',ierr
      Go To 1

  103 Continue ! include file inconsistency detected
         irc = 3
         Write(6,'(//,A,A,//)')
     &   SecNam,': WARNING: include file inconsistency detected!'
      Go To 1

  104 Continue ! error in parallel setup
         irc = 4
         Write(6,'(//,A,A,//)')
     &   SecNam,': WARNING: error in parallel setup!'
      Go To 1

C     Return.
C     =======

    1 Continue
#if defined (_DEBUGPRINT_)
      Call GetMem('CXI_MX2','Max ','Real',ip_Max,l_Max)
      Call Cho_Word2Byte(l_Max,8,Byte,Unt)
      Write(6,*) '>>>>> Available memory on exit from ',SecNam,': ',
     &           l_Max,' = ',Byte,Unt
      Call xFlush(6)
#endif
      End


      SubRoutine Cho_X_DefineInfVec_5(isDF)
C
C     Purpose: Trivial definition of location 5 of InfVec:
C              InfVec(i,5,iSym) = i
C              The routine does nothing in case of parallel DF.
C
      Implicit None
      Logical isDF
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer kOff, iSym, i
      Logical doDefine
#include "para_info.fh"

C Define in case of
C 1) serial Cholesky
C 2) serial DF
C 3) parallel Cholesky
C Do NOT define for parallel DF.
      doDefine = .not.Is_Real_Par() .or.
     &           (Is_Real_Par() .and. .not.isDF)
      If (doDefine) Then
         Do iSym = 1,nSym
            kOff = ip_InfVec - 1 + MaxVec*InfVec_N2*(iSym-1) + MaxVec*4
            Do i = 1,NumCho(iSym)
               iWork(kOff+i) = i
            End Do
         End Do
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine OvlDel(Ovlp,nOvlp,TrMat,nTrMat)
!***********************************************************************
!                                                                      *
!     purpose: Remove near linear dependencies from basis set          *
!                                                                      *
!     input:                                                           *
!       Ovlp    : overlap in AO basis of length nOvlp                  *
!       TrMat   : unit matrix or matrix transforming from AO's to      *
!                 cartesian functions (dependently on input) of        *
!                 length nTrMat                                        *
!                                                                      *
!     output:                                                          *
!       TrMat   : input matrix modified such, that near linear de-     *
!                 pendencies (if exist) are removed                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: DelThr, MaxBas, MaxBOF, MaxOrF, MiniDn, nBas, nDel, nFro, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nOvlp, nTrMat
real(kind=wp), intent(in) :: Ovlp(nOvlp)
real(kind=wp), intent(inout) :: TrMat(nTrMat)
integer(kind=iwp) :: iDum, iErr, iiBT, ij, Ind, iNew, iOld, iOrb, iSym, nFound, nOF, nOrbi
real(kind=wp) :: Dummy
real(kind=wp), allocatable :: EVal(:), EVec(:), NewB(:), OvlH(:), OvlS(:), OvlT(:), Scratch(:)

! Allocate memory for transformed overlap matrix
call mma_allocate(OvlT,nTri_Elem(MaxOrF),Label='OvlT')

! Allocate memory for half-transformed overlap matrix
call mma_allocate(OvlH,MaxBOF,Label='OvlH')

! Allocate memory for squared overlap matrix
call mma_allocate(OvlS,MaxBas**2,Label='OvlS')

! Allocate memory for eigenvectors of overlap
call mma_allocate(EVec,MaxOrF**2,Label='EVec')

! Allocate memory for eigenvalues of overlap
call mma_allocate(EVal,MaxOrF,Label='EVal')

! Allocate memory for 'basis' that diagonalizes overlap
call mma_allocate(NewB,MaxBOF,Label='NewB')

ij = 1
iOld = 1
iNew = 1
do iSym=1,nSym

  iiBT = nTri_Elem(nBas(iSym))
  nOF = nOrb(iSym)-nFro(iSym)

  ! Copy frozen vectors to the right position
  if (nFro(iSym)*nBas(iSym) > 0) then
    !write(u6,'(a,i2)') 'Copying symmetry block',iSym
    !write(u6,'(i8,a,i8)') iOld,' ->',iNew
    !write(u6,'(a,i8)') 'nTrMat =',nTrMat
    TrMat(iNew:iNew+nFro(iSym)*nBas(iSym)-1) = TrMat(iOld:iOld+nFro(iSym)*nBas(iSym)-1)
  !else
  !  write(u6,'(a,i2)') 'No copying of symmetry block',iSym
  end if

  iOld = iOld+nFro(iSym)*nBas(iSym)
  iNew = iNew+nFro(iSym)*nBas(iSym)

  if (nOF > 0) then

    ! Square overlap and transform to basis given by TrMat
    call Square(Ovlp(ij),OvlS,1,nBas(iSym),nBas(iSym))
    call DGEMM_('N','N',nBas(iSym),nOF,nBas(iSym), &
                One,OvlS,nBas(iSym), &
                TrMat(iOld),nBas(iSym), &
                Zero,OvlH,nBas(iSym))
    call DGEMM_Tri('T','N',nOF,nOF,nBas(iSym), &
                   One,TrMat(iOld),nBas(iSym), &
                   OvlH,nBas(iSym), &
                   Zero,OvlT,nOF)

    ! Diagonalize overlap and form eigenvalues vector
    call mma_allocate(Scratch,nOF**2,Label='Scrtach')
    Dummy = Zero
    iDum = 0
    call Diag_Driver('V','A','L',nOF,OvlT,Scratch,nOF,Dummy,Dummy,iDum,iDum,EVal,EVec,nOF,1,0,'J',nFound,iErr)
    call mma_deallocate(Scratch)
    !?? Ovlt(1:nTri_Elem(nOF)) = Zero
    !?? iDiag = 0
    !?? do i=1,nOF
    !??   OvlT(i+iDiag) = EVal(i)
    !??   iDiag = iDiag+i
    !?? end do

    ! Transform to basis that diagonalizes overlap
    call DGEMM_('N','N',nBas(iSym),nOF,nOF, &
                One,TrMat(iOld),nBas(iSym), &
                EVec,nOF, &
                Zero,NewB,nBas(iSym))

    ! Remove linear dependencies
    nOrbi = nFro(iSym)
    ind = 1
    do iOrb=1,nOF
      if (EVal(iOrb) > DelThr) then
        if (EVal(iOrb) < 1.0e-5_wp) MiniDn = .false.
        TrMat(iNew:iNew+nBas(iSym)-1) = NewB(ind:ind+nBas(iSym)-1)
        iNew = iNew+nBas(iSym)
        nOrbi = nOrbi+1
      end if
      ind = ind+nBas(iSym)
    end do

    iOld = iOld+nOF*nBas(iSym)
    nDel(iSym) = nOrb(iSym)-nOrbi
    nOrb(iSym) = nOrbi

  end if

  ij = ij+iiBT

end do
call Put_iArray('nDel',nDel,nSym)

! Deallocate memory
call mma_deallocate(NewB)
call mma_deallocate(EVal)
call mma_deallocate(EVec)
call mma_deallocate(OvlS)
call mma_deallocate(OvlH)
call mma_deallocate(OvlT)

end subroutine OvlDel

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
*               Jesper Wisborg Krogh                                   *
************************************************************************
*  Chk4NAN
*
*> @brief
*>   Check whether an array contains NANs
*> @author Per &Aring;ke Malmqvist
*> @modified_by Jesper Wisborg Krogh
*>
*> @details
*> The routine checks the elements of the input array for NANs. If any are found,
*> up to 100 of these will be listed. Upon return \p iErr contains the number of
*> NANs found.
*>
*> @param[in]  nDim  Total dimension of array
*> @param[in]  Array Array to be checked
*> @param[out] Ierr  Return code
************************************************************************
      Subroutine Chk4NAN(nDim, Array, Ierr)
      Implicit None
      Real*8 Array, CheckSum
      Character*16 str16
      Integer nDim, iCount, I, Ierr
      Dimension Array(nDim)
*
      ICOUNT=0
      CHECKSUM=0.0D0
      DO I=1,nDim
         CHECKSUM=CHECKSUM+ARRAY(I)
      END DO
      WRITE(STR16,'(G16.7)') CHECKSUM
      CALL NORMAL(STR16)
      IF(STR16(1:1).eq.'N') THEN
         Write(6,*) '!!! WARNING !!!'
         Write(6,*) 'NANs encountered'
         Write(6,*)
         Write(6,*)' The numbers in the array will now be checked.'
         Write(6,*)' There are ',NDIM,' elements.'
         DO I=1,nDim
            WRITE(STR16,'(G16.7)') ARRAY(I)
            CALL NORMAL(STR16)
            IF(STR16(1:1).eq.'N') THEN
               ICOUNT=ICOUNT+1
               IF(iCount .le. 100) THEN
                  WRITE(6,*)' Element nr.', I,' is ',ARRAY(I)
               END IF
            END IF
         END DO
         IF(ICOUNT.GT.100) THEN
            WRITE(6,*)' ...too many. I give up here.'
         END IF
         Write(6,*) 'There were a total of ',iCount,' NANs'
      END IF
*
      iErr = iCount
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine rotmom(MOM, N, R, MOMR )
      ! inverse rotation
      Implicit None
      Integer, Parameter :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in) :: N
      Real(kind=8), intent(in) :: R(3,3) !rotation matrix
!     initial momentum matrix
      Complex(kind=8), intent(in) :: MOM(3,N,N)
!     rotated momentum matrix
      Complex(kind=8), intent(out) :: MOMR(3,N,N)
c  local variables
      Integer :: i,j,l,k
      Complex(kind=8) :: RC(3,3)

c rotate the matrix

      Call zcopy_(3*N*N,[(0.0_wp,0.0_wp)],0,MOMR,1)

      Do l=1,3
         Do k=1,3
            RC(l,k) = (0.0_wp,0.0_wp)
            RC(l,k) = cmplx(R(l,k),0.0d0,wp)
         End Do
      End Do

      Do i=1,N
         Do j=1,N
            Do l=1,3
               Do k=1,3
                  MOMR(l,i,j) = MOMR(l,i,j) + RC(l,k) * MOM(k,i,j)
               End Do
            End Do
         End Do
      End Do

      Return
      End
c------------------------------------------------------------------------
      Subroutine rotmom2(MOM, N, R, MOMR)
      Implicit None
      Integer, Parameter :: wp=selected_real_kind(p=15,r=307)
      Integer, intent(in) :: N
      Real(kind=8),intent(in) :: R(3,3) !rotation matrix
      Complex(kind=8),intent(in) :: MOM(3,N,N) !initial momentum matrix
!     rotated momentum matrix
      Complex(kind=8),intent(out) :: MOMR(3,N,N)
c  local variables
      Integer i,j,l,k
      Complex(kind=8) :: RC(3,3)

c rotate the matrix
      Call zcopy_(3*N*N,[(0.0_wp,0.0_wp)],0,MOMR,1)

      Do l=1,3
         Do k=1,3
            RC(l,k) = (0.0_wp,0.0_wp)
            RC(l,k) = cmplx(R(l,k),0.0d0,wp)
         End Do
      End Do

      Do i=1,N
         Do j=1,N
            Do l=1,3
               Do k=1,3
                  MOMR(l,i,j) = MOMR(l,i,j) + RC(k,l) * MOM(k,i,j)
               End Do
            End Do
         End Do
      End Do

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SODist(SOValue,mAO,nCoor,mBas,nCmp,nDeg,MOValue,nMOs,iAO,CMOs,nCMO,DoIt)

use SOAO_Info, only: iAOtSO
use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: mAO, nCoor, mBas, nCmp, nDeg, nMOs, iAO, nCMO, DoIt(nMOs)
real(kind=wp), intent(in) :: SOValue(mAO*nCoor,mBas,nCmp*nDeg), CMOs(nCMO)
real(kind=wp), intent(inout) :: MOValue(mAO*nCoor,nMOs)
integer(kind=iwp) :: i1, iCMO, iDeg, iIrrep, iMO, iOff, iOff_CMO(0:7), iOff_MO(0:7), iSO, itmp1, itmp2

#ifdef _DEBUGPRINT_
write(6,*) 'SODist: MO-Coefficients'
iOff = 1
do iIrrep=0,nIrrep-1
  if (nBas(iIrrep) > 0) then
    write(u6,*) ' Symmetry Block',iIrrep
    call RecPrt(' ',' ',CMOs(iOff),nBas(iIrrep),nBas(iIrrep))
  end if
  iOff = iOff+nBas(iIrrep)**2
end do
#endif

! Compute some offsets

itmp1 = 1
itmp2 = 0
do iIrrep=0,nIrrep-1
  iOff_MO(iIrrep) = itmp1
  iOff_CMO(iIrrep) = itmp2
  itmp1 = itmp1+nBas(iIrrep)
  itmp2 = itmp2+nBas(iIrrep)*nBas(iIrrep)
end do

do i1=1,nCmp
  iDeg = 0
  do iIrrep=0,nIrrep-1
    iSO = iAOtSO(iAO+i1,iIrrep)
    if (iSO < 0) cycle
    iDeg = iDeg+1
    iOff = (i1-1)*nDeg+iDeg

    ! Distribute contribution to all MO's in this irrep

    iMO = iOff_MO(iIrrep)
    iCMO = iOff_CMO(iIrrep)+iSO
    call MyDGeMM(DoIt(iMO),mAO*nCoor,nBas(iIrrep),mBas,SOValue(:,:,iOff),mAO*nCoor,CMOs(iCMO),nBas(iIrrep),MOValue(:,iMO:), &
                 mAO*nCoor)
  end do
end do

#ifdef _DEBUGPRINT_
call RecPrt('SODist: MOValue(mAO*nCoor,nMOs)',' ',MOValue(1,1),mAO*nCoor,nMOs)
#endif

end subroutine SODist

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
        subroutine o3v3ctl (wrk,wrksize,NvGrp,LunAux)
c
c       docasny drajver o3v3 procesov
c
        implicit none
#include "chcc1.fh"
#include "chcc_parcc.fh"
#include "para_info.fh"
#include "o3v3.fh"
#include "wrk.fh"
c
        integer NvGrp,LunAux,maxdim
        integer proc,beGrp,aGrp
        integer nJobs,addJobs,actJobs,actNode
c
c
c1      Def parameters for o3v3 processes
c
        call DefParo3v3 (NvGrp,maxdim)
c
c
c2        Distribute work among nodes (def BetaID, BeAID)
c
c2.1        vanish BetaID, BeAID
        do proc=0,nProcs-1
        do beGrp=1,NvGrp
          BetaID(proc,beGrp)=0
          do aGrp=1,NvGrp
            BeAID(proc,beGrp,aGrp)=0
          end do
        end do
        end do
c
c
        if (nProcs.eq.1) then
c2.2.1        single node
c
           do beGrp=1,NvGrp
             BetaID(0,beGrp)=1
            do aGrp=1,NvGrp
              BeAID(0,beGrp,aGrp)=1
            end do
           end do
c
        else
c2.2.2        multi node
c        (N.B. trochu odflaknute, dalo by sa este zohladnit ze tie nody,
c         ktore maju o jeden job navyse nebudu tie, kde je BetaID=1,
c        resp. nebudu tie, kde sa realizuje X0.1 prispevok a pod)
c
          nJobs=int((NvGrp*NvGrp)/nProcs)
          addJobs=mod((NvGrp*NvGrp),nProcs)
c
          actNode=0
          actJobs=nJobs
c
c
          do beGrp=1,NvGrp
          BetaID(actNode,beGrp)=1
          if (printkey.ge.10) then
          write (6,*) 'BetaID',actnode,beGrp
          end if
          do aGrp=1,NvGrp
            BeAID(actNode,beGrp,aGrp)=1
            if (printkey.ge.10) then
            write (6,*) 'BeAID',actnode,beGrp,aGrp
            end if
            actJobs=actJobs-1
            if (actJobs.eq.-1) then
              actNode=actNode+1
              actJobs=nJobs
            else if (actJobs.eq.0) then
              if (addJobs.gt.0) then
                addJobs=addJobs-1
              else
                actNode=actNode+1
                actJobs=nJobs
              end if
            end if
          end do
          end do
c
        end if
c@@
        if (printkey.ge.10) then
        do proc=0,nProcs-1
        do beGrp=1,NvGrp
          write (6,99) proc,beGrp,(BeAID(proc,beGrp,aGrp),aGrp=1,NvGrp)
        end do
        end do
        end if
99        format (1x,i3,1x,i2,5x,24(i1,1x))
c@@
c
c
c3      A ideme na to
c
        call o3v3jk (wrk(1),wrksize,NvGrp,maxdim,LunAux)
        if (printkey.gt.1) then
        write (6,*) ' o3v3jk done'
        end if
c
        call o3v3chol (wrk(1),wrksize,NvGrp,maxdim,LunAux)
        if (printkey.gt.1) then
        write (6,*) ' o3v3chol done'
        end if
c
        call o3v3t2 (wrk(1),wrksize,NvGrp,maxdim,LunAux)
        if (printkey.gt.1) then
        write (6,*) ' o3v3t2 done'
        end if
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine genovlp(Lhigh,coulovlp)
      implicit real*8 (a-h,o-z)
cbs   generates overlap of normalized  primitives.
#include "para.fh"
#include "param.fh"
      dimension evecinv(MxprimL,MxprimL)
     *,coulovlp(MxprimL,MxprimL,-1:1,-1:1,0:Lmax,0:Lmax)
      do L=0,Lhigh
              do Jrun=1,nprimit(L)
              do Irun=1,nprimit(L)
        normovlp(Irun,Jrun,L)=coulovlp(irun,jrun,0,0,L,L)
              enddo
              enddo
cbs   invert the matrix, not very elegant, but sufficient
      ipnt=0
      do jrun=1,nprimit(L)
      do irun=1,jrun
      ipnt=ipnt+1
      scratchinv(ipnt)=normovlp(irun,jrun,L)
      enddo
      enddo
      do Jrun=1,nprimit(L)
      do Irun=1,MxprimL
      evecinv(Irun,Jrun)=0d0
      enddo
      enddo
      do Jrun=1,nprimit(L)
      evecinv(jrun,jrun)=1d0
      enddo
      call Jacob(scratchinv,evecinv,nprimit(L),MxprimL)
      do irun=1,nprimit(L)
      eval(irun)=sqrt(scratchinv((irun*irun+irun)/2))
      enddo
cbs   ensure normalization of the vectors.
      do IRUN=1,nprimit(L)
      fact=0d0
      do JRUN=1,nprimit(L)
      fact=fact+evecinv(JRUN,IRUN)*evecinv(JRUN,IRUN)
      enddo
      fact=1d0/sqrt(fact)
      do JRUN=1,nprimit(L)
      evecinv(JRUN,IRUN)=fact*evecinv(JRUN,IRUN)
      enddo
      enddo
cbs   now generate rootOVLP
      do irun=1,nprimit(L)
      do jrun=1,nprimit(L)
      rootOVLP(irun,jrun,l)=0d0
      enddo
      enddo
      do jrun=1,nprimit(L)
      do irun=1,nprimit(L)
      do krun=1,nprimit(L)
      rootOVLP(irun,jrun,L)=rootOVLP(irun,jrun,L)+
     *evecinv(irun,krun)*evecinv(jrun,krun)*eval(krun)
      enddo
      enddo
      enddo
cbs   now generate rootOVLPinv
      do irun=1,nprimit(L)
      eval(irun)=1d0/eval(irun)
      enddo
      do irun=1,nprimit(L)
      do jrun=1,nprimit(L)
      rootOVLPinv(irun,jrun,l)=0d0
      enddo
      enddo
      do jrun=1,nprimit(L)
      do irun=1,nprimit(L)
      do krun=1,nprimit(L)
      rootOVLPinv(irun,jrun,L)=rootOVLPinv(irun,jrun,L)+
     *evecinv(irun,krun)*evecinv(jrun,krun)*eval(krun)
      enddo
      enddo
      enddo
cbs   now generate OVLPinv
      do irun=1,nprimit(L)
      eval(irun)=eval(irun)*eval(irun)
      enddo
      do irun=1,nprimit(L)
      do jrun=1,nprimit(L)
      OVLPinv(irun,jrun,l)=0d0
      enddo
      enddo
      do jrun=1,nprimit(L)
      do irun=1,nprimit(L)
      do krun=1,nprimit(L)
      OVLPinv(irun,jrun,L)=OVLPinv(irun,jrun,L)+
     *evecinv(irun,krun)*evecinv(jrun,krun)*eval(krun)
      enddo
      enddo
      enddo
      enddo
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Ignacio Fdez. Galvan                             *
************************************************************************
*  Random_Vector
*
*> @brief
*>   Generate a random vector in an \f$ N \f$ dimensional hypersphere
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Generate a random \f$ N \f$ dimensional vector of unit length or less,
*> by using random normal-distributed numbers. \cite Mul1959-CACM-2-19
*> The normal-distributed random numbers are generated with the Box--Muller
*> transform. \cite Box1958-AMS-29-610
*>
*> @param[in]  N    Dimension of the generated vector
*> @param[out] Vec  Generated random vector
*> @param[in]  UVec Specifies whether the vector should be of unit length
************************************************************************
      SUBROUTINE Random_Vector(N,Vec,UVec)
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: N
      REAL*8, INTENT(OUT) :: Vec(N)
      LOGICAL, INTENT(IN) :: UVec
#include "real.fh"
      INTEGER :: i
      INTEGER, SAVE :: iSeed=0
      REAL*8 :: U, V, X, Y, m, sm, tot_m
      REAL*8, EXTERNAL :: Random_Molcas
      REAL*8, PARAMETER :: Thr=1.0D-8
*
*     Initialize random seed
      IF (iSeed==0) CALL GetSeed(iSeed)
*
*     To reduce numerical errors, repeat until the size is reasonable
      tot_m = Zero
      DO WHILE ((tot_m < Thr) .OR. (tot_m > One/Thr))
        tot_m = Zero
        DO i=1,N,2
*         Get two independent normal distributed-variales, X and Y
*         See doi:10.1214/aoms/1177706645
          U = Random_Molcas(iSeed)
          V = Two*Pi*Random_Molcas(iSeed)
          m = -Two*LOG(U)
          sm = SQRT(m)
          X = sm*COS(V)
          Y = sm*SIN(V)
*         Add them to the vector,
*         being careful with the last one if N is odd
*         See doi:10.1145/377939.377946
          IF (i==N) THEN
            Vec(i) = X
            tot_m = tot_m + X*X
          ELSE
            Vec(i:i+1) = [X, Y]
            tot_m = tot_m + m
          END IF
        END DO
      END DO
*     Normalize the vector
*     and scale by a random (0,1) number if no unit vector desired
      IF (UVec) THEN
        sm = One
      ELSE
        sm = Random_Molcas(iSeed)
      END IF
      Vec(:) = sm/SQRT(tot_m)*Vec(:)
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine set_nm(exch,ncut,encut_definition,nk,mg,nTempMagn,hmax,w,encut_rate,TempMagn,nM,EM,dbg)

use Constants, only: Zero, cm_s, hPlanck, kBoltzmann, mBohr
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: exch, ncut, encut_definition, nk, mg, nTempMagn
real(kind=wp), intent(in) :: hmax, W(exch), encut_rate, TempMagn(nTempMagn)
integer(kind=iwp), intent(out) :: nM
real(kind=wp), intent(out) :: EM
logical(kind=iwp), intent(in) :: dbg
integer(kind=iwp) :: i
real(kind=wp) :: diff, T_High
real(kind=wp), parameter :: boltz_k = kBoltzmann/(cm_s*hPlanck), & ! in cm-1*K-1
                            mu_bohr = mBohr/(cm_s*hPlanck) ! in cm-1*T-1

#include "warnings.h"

nM = 1
EM = Zero
diff = Zero
T_High = Zero
if (nTempMagn > 0) T_High = maxval(TempMagn(:))

if (dbg) then
  write(u6,*) 'exch             = ',exch
  write(u6,*) 'ncut             = ',ncut
  write(u6,*) 'encut_definition = ',encut_definition
  write(u6,*) 'nk               = ',nk
  write(u6,*) 'mg               = ',mg
  write(u6,*) 'nM               = ',nM
  write(u6,*) 'nTempMagn        = ',nTempMagn
  write(u6,*) 'hmax             = ',hmax
  write(u6,*) 'encut_rate       = ',encut_rate
  write(u6,*) 'EM               = ',EM
  write(u6,*) 'TempMagn()       = ',TempMagn(:)
  write(u6,*) 'W()              = ',W(:)
end if

if (encut_definition == 1) then

  if (ncut > exch) then
    nm = exch
    em = w(exch)
  else
    nm = ncut
    em = w(nm)
  end if

else if (encut_definition == 2) then

  nm = exch
  em = nk*boltz_k*T_High+mg*mu_bohr*abs(hmax)

  do i=1,exch
    if (i > 1) diff = w(i)-w(i-1)
    if ((w(i) > em) .and. (diff > 1.0e-4_wp)) then
      nm = i-1
      exit
    end if
  end do

else if (encut_definition == 3) then

  nm = exch
  em = w(exch)*encut_rate

  do i=1,exch
    if (i > 1) diff = w(i)-w(i-1)
    if ((w(i) > em) .and. (diff > 1.0e-4_wp)) then
      nm = i-1
      exit
    end if
  end do

else

  write(u6,'(A)') 'something is wrong with "encut_definition"'
  call quit(_RC_INPUT_ERROR_)

end if !encut_definition

return

end subroutine set_nm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines
c     divt
c     divthelp1
c     divthelp2
c     divthelp3
c     mktau
c     mktauhelp1
c     mktauhelp2
c     mkq
c     mkqhelp1
c     mkqhelp2
c     max5
c     max5h1
c     max5h2
c
c     --------------------------------------------------------
c
       subroutine divt (wrk,wrksize,
     & nind,mapdt,mapit,mapddp1,mapidp1,mapddp2,
     &                  mapidp2,rc)
c
c     this routine divide T amplitudes by denominators, ie differences in dp
c
c     nint         - number of indexes in T (2 or 4) (I)
c     mapdt   - direct map of T (I)
c     mapit        - inverse map of T (I)
c     mapddp1        - direct map of dpa (I)
c     mapidp1        - inverse map of dpa (I)
c     mapddp2        - direct map of dpb (I)
c     mapidp2        - inverse map of dpb (I)
c     rc        - return (error) code
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer nind,rc
c
       integer mapdt(0:512,1:6)
       integer mapit(1:8,1:8,1:8)
c
       integer mapddp1(0:512,1:6)
       integer mapidp1(1:8,1:8,1:8)
c
       integer mapddp2(0:512,1:6)
       integer mapidp2(1:8,1:8,1:8)
c
c     help variables
c
       integer posst,possdp,possdpa,possdpb,possdpi,possdpj
       integer dimi,dimj,dima,dimb,dimab,dimij,syma,symb,symi,symj
       integer iit,iidp,iidpa,iidpb,iidpi,iidpj
c
       rc=0
c
       if (nind.eq.2) then
cI    T1 amplitudes - 2 indexes
c
       if (mapdt(0,1).eq.3) then
cI.1  T1aa case
c
       do 100 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       dima=nva(syma)
       dimi=noa(syma)
       iidp=mapidp1(syma,1,1)
       possdp=mapddp1(iidp,1)
c
       if ((dima*dimi).gt.0) then
       call divthelp1 (wrk(posst),dima,dimi,wrk(possdp))
       end if
c
 100    continue
c
       else if (mapdt(0,1).eq.4) then
cI.2  T1bb case
c
       do 200 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       dima=nvb(syma)
       dimi=nob(syma)
       iidp=mapidp2(syma,1,1)
       possdp=mapddp2(iidp,1)
c
       if ((dima*dimi).gt.0) then
       call divthelp1 (wrk(posst),dima,dimi,wrk(possdp))
       end if
c
 200    continue
c
       else
cI.3  invalid T1 type
c     RC=1 : incorrect map for T1
       rc=1
       return
       end if
c
       else if (nind.eq.4) then
cII   T2 amplitudes - 4 indexes
c
       if (mapdt(0,6).eq.0) then
cII.1 T2abab case

       do 300 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       symb=mapdt(iit,4)
       symi=mapdt(iit,5)
       symj=mapdt(iit,6)
       dima=nva(syma)
       dimb=nvb(symb)
       dimi=noa(symi)
       dimj=nob(symj)
       iidpa=mapidp1(syma,1,1)
       iidpb=mapidp2(symb,1,1)
       iidpi=mapidp1(symi,1,1)
       iidpj=mapidp2(symj,1,1)
       possdpa=mapddp1(iidpa,1)
       possdpb=mapddp2(iidpb,1)
       possdpi=mapddp1(iidpi,1)
       possdpj=mapddp2(iidpj,1)
c
       if (mapdt(iit,2).gt.0) then
       call divthelp2 (wrk(posst),dima,dimb,dimi,dimj,
     & wrk(possdpa),wrk(possdpb),wrk(possdpi),wrk(possdpj),
     & noa(syma),nob(symb))
       end if
c
 300    continue
c
       else if ((mapdt(0,6).eq.4).and.(mapdt(0,1).eq.3)) then
cII.2 T2aaaa case
c
       do 400 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       symb=mapdt(iit,4)
       symi=mapdt(iit,5)
       symj=mapdt(iit,6)
       dima=nva(syma)
       dimb=nva(symb)
       dimi=noa(symi)
       dimj=noa(symj)
       iidpa=mapidp1(syma,1,1)
       iidpb=mapidp1(symb,1,1)
       iidpi=mapidp1(symi,1,1)
       iidpj=mapidp1(symj,1,1)
       possdpa=mapddp1(iidpa,1)
       possdpb=mapddp1(iidpb,1)
       possdpi=mapddp1(iidpi,1)
       possdpj=mapddp1(iidpj,1)
c
       if (mapdt(iit,2).eq.0) goto 400

       if (syma.ne.symb) then
c     different symmetries a,b; i,j
       call divthelp2 (wrk(posst),dima,dimb,dimi,dimj,
     & wrk(possdpa),wrk(possdpb),wrk(possdpi),wrk(possdpj),
     & noa(syma),noa(symb))
c
       else
c     same symmetries a,b; i,j
       dimab=(dima*(dima-1))/2
       dimij=(dimi*(dimi-1))/2
       call divthelp3 (wrk(posst),dimab,dimij,wrk(possdpa),wrk(possdpi),
     & dima,dimi,noa(syma))
       end if
c
 400    continue
c
       else if ((mapdt(0,6).eq.4).and.(mapdt(0,1).eq.4)) then
cII.3 T2bbbb case
c
       do 500 iit=1,mapdt(0,5)
c
       posst=mapdt(iit,1)
       syma=mapdt(iit,3)
       symb=mapdt(iit,4)
       symi=mapdt(iit,5)
       symj=mapdt(iit,6)
       dima=nvb(syma)
       dimb=nvb(symb)
       dimi=nob(symi)
       dimj=nob(symj)
       iidpa=mapidp2(syma,1,1)
       iidpb=mapidp2(symb,1,1)
       iidpi=mapidp2(symi,1,1)
       iidpj=mapidp2(symj,1,1)
       possdpa=mapddp2(iidpa,1)
       possdpb=mapddp2(iidpb,1)
       possdpi=mapddp2(iidpi,1)
       possdpj=mapddp2(iidpj,1)
c
       if (mapdt(iit,2).eq.0) goto 500

       if (syma.ne.symb) then
c     different symmetries a,b; i,j
       call divthelp2 (wrk(posst),dima,dimb,dimi,dimj,
     & wrk(possdpa),wrk(possdpb),wrk(possdpi),wrk(possdpj),
     & nob(syma),nob(symb))
c
       else
c     same symmetries a,b; i,j
       dimab=(dima*(dima-1))/2
       dimij=(dimi*(dimi-1))/2
       call divthelp3 (wrk(posst),dimab,dimij,wrk(possdpa),wrk(possdpi),
     & dima,dimi,nob(syma))
       end if
c
 500    continue
c
       else
cII.4 RC=2 : incorrect mapdt for T2
       rc=2
       return
       end if
c
       else
cIII  invalid nind
c     RC=3 : nind is not 2 or 4 (Stup)
       rc=3
       end if
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(mapit)
       end
c
c     ----------
c
       subroutine divthelp1 (t1,dima,dimi,dp)
c
c     this routine do
c     t1(a,i) = t1(a,i)/(dp(i)-dp(a))
c
c     t1        - T1 matrix (I/O)
c     dima    - v dimension of T1 (I)
c     dimi    - o domension of T1 (I)
c     dp      - diagonal part of Fok (I)
c
c     N.B. Since for T1 i and a are of the same spin, there is no reason
c     to specify spin of dp. It must be automatically the same spin ad i and a.
c
       integer dima,dimi
       real*8 t1(1:dima,1:dimi)
       real*8 dp(*)
c
c     help variables
c
       integer a,i
       real*8 dpi,den
c
       do 100 i=1,dimi
       dpi=dp(i)
       do 101 a=1,dima
c     t1(a,i)=t1(a,i)/(dpi-dp(dimi+a))
c
       den=dpi-dp(dimi+a)
       if (abs(den).lt.1.0d-7) then
       if (abs(t1(a,i)).gt.1.0d-10) then
       t1(a,i)=t1(a,i)/den
       end if
       else
       t1(a,i)=t1(a,i)/den
       end if
c
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine divthelp2 (t2,dima,dimb,dimi,dimj,dpa,dpb,dpi,dpj,
     &                       shifta,shiftb)
c
c     this routine do
c     t2(a,b,i,j) = t2(a,b,i,j)/(dpi(i)+dpj(j)-dpa(a)-dpb(b))
c
c     t2        - T2 matrix (I/O)
c     dima    - 1 dimension of T2 (I)
c     dimb    - 2 dimension of T2 (I)
c     dimi    - 3 domension of T2 (I)
c     dimj    - 4 domension of T2 (I)
c     dpa     - diagonal part of Fok corresponding to irrep of a (I)
c     dpb     - diagonal part of Fok corresponding to irrep of b (I)
c     dpi     - diagonal part of Fok corresponding to irrep of i (I)
c     dpj     - diagonal part of Fok corresponding to irrep of j (I)
c     shifta        - number off occ orbitals in spin and symmetry of a (I)
c     shiftb        - number off occ orbitals in spin and symmetry of b (I)
c
c     N.B. Since for T1 i and a are of the same spin, there is no reason
c     to specify spin of dp. It must be automatically the same spin ad i and a.
c
       integer dima,dimb,dimi,dimj,shifta,shiftb
       real*8 t2(1:dima,1:dimb,1:dimi,1:dimj)
       real*8 dpa(*)
       real*8 dpb(*)
       real*8 dpi(*)
       real*8 dpj(*)
c
c     help variables
c
       integer i,j,a,b
       real*8 den,denj,denij,denijb
c
       do 100 j=1,dimj
       denj=dpj(j)
       do 101 i=1,dimi
       denij=denj+dpi(i)
       do 102 b=1,dimb
       denijb=denij-dpb(shiftb+b)
       do 103 a=1,dima
c     t2(a,b,i,j)=t2(a,b,i,j)/(denijb-dpa(shifta+a))
c
       den=denijb-dpa(shifta+a)
       if (abs(den).lt.1.0d-7) then
       if (abs(t2(a,b,i,j)).gt.1.0d-10) then
       t2(a,b,i,j)=t2(a,b,i,j)/den
       end if
       else
       t2(a,b,i,j)=t2(a,b,i,j)/den
       end if
c
 103    continue
 102    continue
 101    continue
 100    continue
c
       return
       end
c
c     ----------
c
       subroutine divthelp3 (t2,dimab,dimij,dpa,dpi,dima,dimi,shift)
c
c     this routine do
c     t2(ab,ij) = t2(ab,ij)/(dp(i)+dp(j)-dp(a)-dp(b))
c     for spin and symmetry of a = b
c     and spin and symmetry of i = j
c
c     t2        - T2 matrix (I/O)
c     dimab   - 1 dimension of T2 (I)
c     dimij   - 3 domension of T2 (I)
c     dpa     - diagonal part of Fok corresponding to irrep of a (I)
c     dpi     - diagonal part of Fok corresponding to irrep of i (I)
c     dima    - number of a in this spin and symm of a (I)
c     dimi    - number of a in this spin and symm of i (I)
c     shift         - number off occ orbitals in spin and symmetry of a (I)
c
c     N.B. Since for T1 i and a are of the same spin, there is no reason
c     to specify spin of dp. It must be automatically the same spin ad i and a.
c
       integer dimab,dimij,dima,dimi,shift
       real*8 t2(1:dimab,1:dimij)
       real*8 dpa(*)
       real*8 dpi(*)
c
c     help variables
c
       integer i,j,a,b,ij,ab
       real*8 den,deni,denij,denija
c
       ij=0
       do 100 i=2,dimi
       deni=dpi(i)
       do 101 j=1,i-1
       denij=deni+dpi(j)
       ij=ij+1
c
       ab=0
       do 102 a=2,dima
       denija=denij-dpa(shift+a)
       do 103 b=1,a-1
       ab=ab+1
c     t2(ab,ij)=t2(ab,ij)/(denija-dpa(shift+b))
c
       den=denija-dpa(shift+b)
       if (abs(den).lt.1.0d-7) then
       if (abs(t2(ab,ij)).gt.1.0d-10) then
       t2(ab,ij)=t2(ab,ij)/den
       end if
       else
       t2(ab,ij)=t2(ab,ij)/den
       end if
c
c
 103    continue
 102    continue
 101    continue
 100    continue
c
       return
       end
c
c     ---------------------------------------------------
c
       subroutine mktau (wrk,wrksize,
     & mapdt2,mapit2,mapdt1a,mapit1a,mapdt1b,mapit1b,
     &                   fact,rc)
c
c     this routine do:
c     t2(abij) = t2(abij) + fact. (t1(ai).t1(bj)-t1(bi).t1(aj))
c     N.B. T24a,4b must be of type 4, T2abab of type 0
c
c     mapdt2  - direct map of T2 (I)
c     mapit2        - inverse map of T2 (I)
c     mapdt1a        - direct map of T1aa (I)
c     mapit1a        - inverse map of T1aa (I)
c     mapdt1b        - direct map of T1bb (I)
c     mapit1b        - inverse map of T1bb (I)
c     fact    - numerical factor (I)
c     rc        - return (error) code
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer rc
       real*8 fact
c
       integer mapdt2(0:512,1:6)
       integer mapit2(1:8,1:8,1:8)
c
       integer mapdt1a(0:512,1:6)
       integer mapit1a(1:8,1:8,1:8)
c
       integer mapdt1b(0:512,1:6)
       integer mapit1b(1:8,1:8,1:8)
c
c     help variables
c
       integer posst2,posst1a,posst1b,posst11,posst12
       integer dimi,dimj,dima,dimb,dimab,dimij,syma,symb,symi,symj
       integer iit2,iit1a,iit1b,iit11,iit12
c
       rc=0
c
       if (mapdt2(0,6).eq.0) then
cI.1  T2abab case

       do 100 iit2=1,mapdt2(0,5)
c
       posst2=mapdt2(iit2,1)
       syma=mapdt2(iit2,3)
       symb=mapdt2(iit2,4)
       symi=mapdt2(iit2,5)
       symj=mapdt2(iit2,6)
       dima=nva(syma)
       dimb=nvb(symb)
       dimi=noa(symi)
       dimj=nob(symj)
       iit1a=mapit1a(syma,1,1)
       iit1b=mapit1b(symb,1,1)
       posst1a=mapdt1a(iit1a,1)
       posst1b=mapdt1b(iit1b,1)
c
       if ((syma.eq.symi).and.(symb.eq.symj).and.(mapdt2(iit2,2).gt.0))
     & then
       call mktauhelp1 (wrk(posst2),wrk(posst1a),wrk(posst1b),
     & dima,dimb,dimi,dimj,noa(symi),nob(symj),fact)
       end if
c
 100    continue
c
       else if ((mapdt2(0,6).eq.4).and.(mapdt2(0,1).eq.3)) then
cI.2  T2aaaa case
c
       do 200 iit2=1,mapdt2(0,5)
c
       posst2=mapdt2(iit2,1)
       syma=mapdt2(iit2,3)
       symb=mapdt2(iit2,4)
       symi=mapdt2(iit2,5)
       symj=mapdt2(iit2,6)
       dima=nva(syma)
       dimb=nva(symb)
       dimi=noa(symi)
       dimj=noa(symj)
       iit11=mapit1a(syma,1,1)
       iit12=mapit1a(symb,1,1)
       posst11=mapdt1a(iit11,1)
       posst12=mapdt1a(iit12,1)
c
       if ((syma.eq.symi).and.(symb.eq.symj).
     & and.(syma.ne.symj).and.(mapdt2(iit2,2).gt.0)) then
cI.2.*case T2(sym1,sym2,sym1,sym2)
c
       call mktauhelp1 (wrk(posst2),wrk(posst11),wrk(posst12),
     & dima,dimb,dimi,dimj,noa(syma),noa(symb),fact)
c
       else if ((syma.eq.symi).and.(symb.eq.symj).
     & and.(syma.eq.symj).and.(mapdt2(iit2,2).gt.0)) then
cI.2.*case T2(sym1,sym1,sym1,sym1)
c
       dimab=(dima*(dima-1))/2
       dimij=(dimi*(dimi-1))/2
       call mktauhelp2 (wrk(posst2),wrk(posst11),
     & dimab,dimij,dima,dimi,noa(syma),fact)
c
       end if
c
 200    continue
c
       else if ((mapdt2(0,6).eq.4).and.(mapdt2(0,1).eq.4)) then
cI.3  T2bbbb case
c
       do 300 iit2=1,mapdt2(0,5)
c
       posst2=mapdt2(iit2,1)
       syma=mapdt2(iit2,3)
       symb=mapdt2(iit2,4)
       symi=mapdt2(iit2,5)
       symj=mapdt2(iit2,6)
       dima=nvb(syma)
       dimb=nvb(symb)
       dimi=nob(symi)
       dimj=nob(symj)
       iit11=mapit1b(syma,1,1)
       iit12=mapit1b(symb,1,1)
       posst11=mapdt1b(iit11,1)
       posst12=mapdt1b(iit12,1)
c
       if ((syma.eq.symi).and.(symb.eq.symj).
     & and.(syma.ne.symj).and.(mapdt2(iit2,2).gt.0)) then
cI.3.*case T2(sym1,sym2,sym1,sym2)
c
       call mktauhelp1 (wrk(posst2),wrk(posst11),wrk(posst12),
     & dima,dimb,dimi,dimj,nob(syma),nob(symb),fact)
c
       else if ((syma.eq.symi).and.(symb.eq.symj).
     & and.(syma.eq.symj).and.(mapdt2(iit2,2).gt.0)) then
cI.3.*case T2(sym1,sym1,sym1,sym1)
c
       dimab=(dima*(dima-1))/2
       dimij=(dimi*(dimi-1))/2
       call mktauhelp2 (wrk(posst2),wrk(posst11),
     & dimab,dimij,dima,dimi,nob(syma),fact)
c
       end if
c
 300    continue
c
       else
cI.4  RC=1 : incorrect mapdt for T2
       rc=1
       return
       end if
c
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(mapit2)
       end
c
c     ----------
c
       subroutine mktauhelp1 (t2,t11,t12,dima,dimb,dimi,dimj,shifta,
     &                        shiftb,fact)
c
c     this routine do
c     t2(a,b,i,j) = t2(a,b,i,j) + fact [T11(a,i).T12(b,j)]
c
c     t2        - T2 matrix (I/O)
c     t11     - T1 amplitudes corresponding to spin ia (I)
c     t12     - T1 amplitudes corresponding to spin jb (I)
c     dima    - 1 dimension of T2 (I)
c     dimb    - 2 dimension of T2 (I)
c     dimi    - 3 domension of T2 (I)
c     dimj    - 4 domension of T2 (I)
c     shifta        - number off occ orbitals in spin and symmetry of a (I)
c     shiftb        - number off occ orbitals in spin and symmetry of b (I)
c     fact    - numerical factor (I)
c
c     N.B. symi must be syma and symj must be symb
c
c
       integer dima,dimb,dimi,dimj,shifta,shiftb
       real*8 fact
       real*8 t2(1:dima,1:dimb,1:dimi,1:dimj)
       real*8 t11(1:dima,1:dimi)
       real*8 t12(1:dimb,1:dimj)
c
c     help variables
c
       integer i,j,a,b
c
       do 100 j=1,dimj
       do 101 i=1,dimi
       do 102 b=1,dimb
       do 103 a=1,dima
       t2(a,b,i,j)=t2(a,b,i,j)+fact*(t11(a,i)*t12(b,j))
 103    continue
 102    continue
 101    continue
 100    continue
c
       return
c Avoid unused argument warnings
       if (.false.) then
         call Unused_integer(shifta)
         call Unused_integer(shiftb)
       end if
       end
c
c     ----------
c
       subroutine mktauhelp2 (t2,t1,dimab,dimij,dima,dimi,shift,fact)
c
c     this routine do
c     t2(ab,ij) = t2(ab,ij) + fact* (T1(a,i).t1(b,j)-t1(b,i).t1(a,j))
c     for spin and symmetry of all indices equal
c
c     t2        - T2 matrix (I/O)
c     t1      - t1 matrix (I)
c     dimab   - 1 dimension of T2 (I)
c     dimij   - 3 domension of T2 (I)
c     dima    - number of a in this spin and symm of a (I)
c     dimi    - number of a in this spin and symm of i (I)
c     shift         - number off occ orbitals in spin and symmetry of a (I)
c     fact    - numerical factor (I)
c
c     N.B. Since for T1 i and a are of the same spin, there is no reason
c     to specify spin of dp. It must be automatically the same spin ad i and a.
c
       integer dimab,dimij,dima,dimi,shift
       real*8 fact
       real*8 t2(1:dimab,1:dimij)
       real*8 t1(1:dima,1:dimi)
c
c     help variables
c
       integer i,j,a,b,ij,ab
c
       ij=0
       do 100 i=2,dimi
       do 101 j=1,i-1
       ij=ij+1
c
       ab=0
       do 102 a=2,dima
       do 103 b=1,a-1
       ab=ab+1
       t2(ab,ij)=t2(ab,ij)+fact*(t1(a,i)*t1(b,j)-t1(b,i)*t1(a,j))
c
 103    continue
 102    continue
 101    continue
 100    continue
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(shift)
       end
c
c     ---------------------------------------------------
c
       subroutine mkq (wrk,wrksize,
     & mapdt2,mapit2,mapdt11,mapit11,mapdt12,mapit12,
     &                 fact,rc)
c
c     this routine do:
c     t2(a,b,i,j) = fact . t2(a,b,i,j) +t11(ai).t12(bj)
c     for T2aaaa, T2bbbb and T2abab but they must be expanded (typ=0)
c
c     mapdt2  - direct map of T2 (I)
c     mapit2        - inverse map of T2 (I)
c     mapdt11        - direct map of T1 (I)
c     mapit11        - inverse map of T1 (I)
c     mapdt12        - direct map of T11 (I)
c     mapit12        - inverse map of T12 (I)
c     fact    - numerical factor (I)
c     rc        - return (error) code
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer rc
       real*8 fact
c
       integer mapdt2(0:512,1:6)
       integer mapit2(1:8,1:8,1:8)
c
       integer mapdt11(0:512,1:6)
       integer mapit11(1:8,1:8,1:8)
c
       integer mapdt12(0:512,1:6)
       integer mapit12(1:8,1:8,1:8)
c
c     help variables
c
       integer posst2,posst11,posst12
       integer dimi,dimj,dima,dimb,syma,symb,symi,symj
       integer iit2,iit11,iit12
c
       rc=0
c
       if (mapdt2(0,6).eq.0) then
cI.1  typ of t2 is 0 (T2 is expanded)

       do 100 iit2=1,mapdt2(0,5)
c
       posst2=mapdt2(iit2,1)
       syma=mapdt2(iit2,3)
       symb=mapdt2(iit2,4)
       symi=mapdt2(iit2,5)
       symj=mapdt2(iit2,6)
       dima=dimm(mapdt2(0,1),syma)
       dimb=dimm(mapdt2(0,2),symb)
       dimi=dimm(mapdt2(0,3),symi)
       dimj=dimm(mapdt2(0,4),symj)
       iit11=mapit11(syma,1,1)
       iit12=mapit12(symb,1,1)
       posst11=mapdt11(iit11,1)
       posst12=mapdt12(iit12,1)
c
       if ((syma.eq.symi).and.(symb.eq.symj).and.(mapdt2(iit2,2).gt.0))
     & then
       call mkqhelp1 (wrk(posst2),wrk(posst11),wrk(posst12),
     & dima,dimb,dimi,dimj,noa(symi),nob(symj),fact)
       else if (mapdt2(iit2,2).gt.0) then
       call mkqhelp2 (wrk(posst2),mapdt2(iit2,2),mapdt2(iit2,2),fact)
       end if
c
 100    continue
c
c
       else
cI.4  RC=1 : typ of T2 is not 0
       rc=1
       return
       end if
c
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(mapit2)
       end
c
c     ----------
c
       subroutine mkqhelp1 (t2,t11,t12,dima,dimb,dimi,dimj,shifta,
     &                      shiftb,fact)
c
c     this routine do
c     t2(a,b,i,j) = fact . t2(a,b,i,j) [T11(a,i).T12(b,j)]
c
c     t2        - T2 matrix (I/O)
c     t11     - T1 amplitudes corresponding to spin ia (I)
c     t12     - T1 amplitudes corresponding to spin jb (I)
c     dima    - 1 dimension of T2 (I)
c     dimb    - 2 dimension of T2 (I)
c     dimi    - 3 domension of T2 (I)
c     dimj    - 4 domension of T2 (I)
c     shifta        - number off occ orbitals in spin and symmetry of a (I)
c     shiftb        - number off occ orbitals in spin and symmetry of b (I)
c     fact    - numerical factor (I)
c
c     N.B. symi must be syma and symj must be symb
c
c
       integer dima,dimb,dimi,dimj,shifta,shiftb
       real*8 fact
       real*8 t2(1:dima,1:dimb,1:dimi,1:dimj)
       real*8 t11(1:dima,1:dimi)
       real*8 t12(1:dimb,1:dimj)
c
c     help variables
c
       integer i,j,a,b
c
       do 100 j=1,dimj
       do 101 i=1,dimi
       do 102 b=1,dimb
       do 103 a=1,dima
       t2(a,b,i,j)=fact*t2(a,b,i,j)+(t11(a,i)*t12(b,j))
 103    continue
 102    continue
 101    continue
 100    continue
c
       return
c Avoid unused argument warnings
       if (.false.) then
         call Unused_integer(shifta)
         call Unused_integer(shiftb)
       end if
       end
c
c     ----------
c
       subroutine mkqhelp2 (vector,dimv,lenght,factor)
c
c     this routine do vector = vector*factot
c     vector - multilyied vector (I/O)
c     dimv   - dimension of vecrot
c     lenght - lenght of vector to be multiplyied
c     factor - scaling factor
c
c     $N.B. this routine should be substitued by mv0s3v
c
       integer dimv,lenght
       real*8 vector(1:dimv)
       real*8 factor
c
c     help variable
c
       integer n
c
       if (lenght.gt.0) then
       do 10 n=1,lenght
       vector(n)=vector(n)*factor
 10     continue
       end if
c
       return
       end
c
c     ---------------------------------------------------
c
       subroutine max5 (wrk,wrksize,
     & nind,mapd,mapi,text)
c
c     this routine find and type:
c     a) note
c     b) 5 maximal elements with their indexes in given vector V
c     c) euclidian norm
c
c     nind  - number of indexes in V (I)
c     mapd  - direct map of V (I)
c     mapi  - inverese map of V (I)
c     text  - notice (I)
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer nind
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
       character*8 text
c
c     help variables
c
       integer nhelp1,nhelp2,i,j,a,b,it
       real*8 value
       integer imax(1:8,1:5)
       real*8 rmax (1:5)
c
c0    set rmax,imax=0
c
       do 10 nhelp1=1,5
       rmax(nhelp1)=0.0d0
       do 11 nhelp2=1,8
       imax(nhelp2,nhelp1)=0
 11     continue
 10     continue
c
c
       if (nind.eq.2) then
c
c1    T1aa or T1bb amplitudes
c
c1.1  find 5 max
c
       nhelp1=mapd(1,1)
       do 100 it=1,mapd(0,5)
       do 50 i=1,dimm(mapd(0,2),mapd(it,4))
       do 51 a=1,dimm(mapd(0,1),mapd(it,3))
       value=wrk(nhelp1)
       if (abs(value).ge.abs(rmax(5))) then
c     write this amplitude
       call max5h1 (imax,rmax,mapd(it,3),0,mapd(it,4),0,a,0,i,0,
     & value)
       end if
       nhelp1=nhelp1+1
 51     continue
 50     continue
 100    continue
c
c1.2  write output
       If (fullprint.ge.0) call max5h2 (wrk,wrksize,
     & nind,mapd,mapi,rmax,imax,text)
c
       else if (mapd(0,6).eq.0) then
c
c2    T2abab amplitudes
c
c2.1  find 5 max
c
       nhelp1=mapd(1,1)
       do 200 it=1,mapd(0,5)
       do 150 j=1,dimm(mapd(0,4),mapd(it,6))
       do 151 i=1,dimm(mapd(0,3),mapd(it,5))
       do 152 b=1,dimm(mapd(0,2),mapd(it,4))
       do 153 a=1,dimm(mapd(0,1),mapd(it,3))
       value=wrk(nhelp1)
       if (abs(value).ge.abs(rmax(5))) then
c     write this amplitude
       call max5h1 (imax,rmax,mapd(it,3),mapd(it,4),
     & mapd(it,5),mapd(it,6),a,b,i,j,value)
       end if
       nhelp1=nhelp1+1
 153    continue
 152    continue
 151    continue
 150    continue
 200    continue
c
c2.2  write output
       If (fullprint.ge.0) call max5h2 (wrk,wrksize,
     & nind,mapd,mapi,rmax,imax,text)
c
       else
c
c3    T2aaaa or T2bbbb amplitudes
c
c3.1  find 5 max
c
       nhelp1=mapd(1,1)
       do 300 it=1,mapd(0,5)
c
       if (mapd(it,3).eq.mapd(it,4)) then
c     case syma=symb, symi=symj
c
       do 230 i=2,dimm(mapd(0,3),mapd(it,5))
       do 231 j=1,i-1
       do 232 a=2,dimm(mapd(0,1),mapd(it,3))
       do 233 b=1,a-1
       value=wrk(nhelp1)
       if (abs(value).ge.abs(rmax(5))) then
c     write this amplitude
       call max5h1 (imax,rmax,mapd(it,3),mapd(it,4),
     & mapd(it,5),mapd(it,6),a,b,i,j,value)
       end if
       nhelp1=nhelp1+1
 233    continue
 232    continue
 231    continue
 230    continue
c
       else
c     case syma>symb, symi> symj
       do 250 j=1,dimm(mapd(0,4),mapd(it,6))
       do 251 i=1,dimm(mapd(0,3),mapd(it,5))
       do 252 b=1,dimm(mapd(0,2),mapd(it,4))
       do 253 a=1,dimm(mapd(0,1),mapd(it,3))
       value=wrk(nhelp1)
       if (abs(value).ge.abs(rmax(5))) then
c     write this amplitude
       call max5h1 (imax,rmax,mapd(it,3),mapd(it,4),
     & mapd(it,5),mapd(it,6),a,b,i,j,value)
       end if
       nhelp1=nhelp1+1
 253    continue
 252    continue
 251    continue
 250    continue
       end if
c
 300    continue
c
c3.2  write output
       If (fullprint.ge.0) call max5h2 (wrk,wrksize,
     & nind,mapd,mapi,rmax,imax,text)
c
       end if
c
       return
       end
c
c     ---------------------
c
       subroutine max5h1 (imax,rmax,symp,symq,symr,syms,p,q,r,s,value)
c
c     this routine add new max amplitude and skip smallest
c
c     imax - store of indexes of 5 max (I/O)
c     rmax - store of values of 5 max (I/O)
c     symp - symmetry of p index (I)
c     symq - symmetry of q index (I)
c     symr - symmetry of r index (I)
c     syms - symmetry of s index (I)
c     p    - value of p index (I)
c     q    - value of q index (I)
c     r    - value of r index (I)
c     s    - value of s index (I)
c     value- value of amplitude (I)
c
       integer imax(1:8,1:5)
       real*8 rmax (1:5)
       integer symp,symq,symr,syms,p,q,r,s
       real*8 value
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp3
c
c1    find possition of this value
c
       do 10 nhelp1=1,5
       if (abs(value).ge.abs(rmax(nhelp1))) then
       goto 20
       end if
 10     continue
c
c2    1-(nhelp1-1) stay untought
c
c3    push other records if necc.
c
 20     if (nhelp1.lt.5) then
       do 30 nhelp2=4,nhelp1,-1
       rmax(nhelp2+1)=rmax(nhelp2)
       do 31 nhelp3=1,8
       imax(nhelp3,nhelp2+1)=imax(nhelp3,nhelp2)
 31     continue
 30     continue
       end if
c
c4    add new one
c
       rmax(nhelp1)=value
       imax(1,nhelp1)=symp
       imax(2,nhelp1)=symq
       imax(3,nhelp1)=symr
       imax(4,nhelp1)=syms
       imax(5,nhelp1)=p
       imax(6,nhelp1)=q
       imax(7,nhelp1)=r
       imax(8,nhelp1)=s
c
       return
       end
c
c     ---------------------
c
       subroutine max5h2 (wrk,wrksize,
     & nind,mapd,mapi,rmax,imax,text)
c
c     this routine write:
c     a) note
c     b) 5 maximal elements with their indexes in given vector V
c     c) euclidian norm
c
c     nind  - number of indexes in V (I)
c     mapd  - direct map of V (I)
c     mapi  - inverese map of V (I)
c     rmax  - store of maximal values (I)
c     imax  - store of corr. indexes (I)
c     text  - notice (I)
c
#include "ccsd1.fh"
#include "wrk.fh"
c
       integer nind
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
       integer imax(1:8,1:5)
       real*8 rmax (1:5)
       character*8 text
c
c     help variables
c
       integer nhelp1,nhelp2,rc
       real*8 scalar
c
c1    write notice
c
       write(6,101) text
 101    format (' Five largest amplitudes of :',a8)
c
c2    write 5 maximal amplitudes
c
       write(6,102)
 102    format ('  SYMA   SYMB   SYMI   SYMJ     A      B',
     &          '      I      J     VALUE')
       do 10 nhelp1=1,5
       write(6,103) (imax(nhelp2,nhelp1),nhelp2=1,8),rmax(nhelp1)
 103    format (8(2x,i3,2x),f15.10)
 10     continue
c
c3    write euclidian norm
c
c3.1  calc euclidian norm
       call multdot (wrk,wrksize,
     & nind,mapd,mapi,1,mapd,mapi,1,scalar,rc)
       scalar=sqrt(scalar)
c
       write(6,104) scalar
 104    format (' Euclidian norm is :',f17.10)
c
       write(6,*)
c
       return
       end
c
c     ---------------------------------------------------
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

!#define _DEBUGPRINT_
subroutine RdJobIph(CIVec)
!***********************************************************************
!                                                                      *
!     Read the contents of the JOBIPH file.                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use MckDat, only: sNew
use gugx, only: CIS, EXS, SGS
use MCLR_Data, only: CMO, FnJob, FnMck, G1t, G2t, IRLXROOT, ISNAC, ISTATE, LuJob, LuMck, nA, NACSTATES, nNA, NSSA, OVERRIDE, SA
use input_mclr, only: Debug, ERASSCF, Headerjp, iMCPD, iMSPD, iPT2, iRoot, iSpin, iTOC, iTocIph, lRoots, McKinley, nActEl, nAsh, &
                      nBas, nCOnf, nCSF, nDel, nElec3, nFro, nHole1, nIsh, nOrb, nRoots, nRS1, nRS2, nRS3, nSym, ntAsh, ntASqr, &
                      ntATri, ntBas, ntBSqr, ntBTri, ntIsh, ntISqr, ntITri, PT2, State_Sym, TitleJP, Weight
use dmrginfo, only: DoDMRG, LRRAS2, RGRAS2
use Molcas, only: LenIn, MxOrb, MxRoot, MxSym
use RASDim, only: MxIter, MxTit
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), allocatable, intent(out) :: CIVec(:,:)
integer(kind=iwp) :: i, iDisk, iDummer, iGo, iMode, iOpt, iRC, iS, iSym, Iter, j, jS, k, kRoots, kS, Length, lS, nAct, nAct2, &
                     nAct4, nG1, nG2
real(kind=wp) :: PotNuc0, rdum(1), Temp
logical(kind=iwp) :: Found
character(len=8) :: Method
real(kind=wp), allocatable :: Tmp2(:)
character, allocatable :: TempTxt(:)

!                                                                      *
!***********************************************************************
!                                                                      *
debug = .false.
#ifdef _DEBUGPRINT_
debug = .true.
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
!     Save the ROOT input parameter                                    *
!----------------------------------------------------------------------*
kRoots = lRoots
!----------------------------------------------------------------------*
!     Read the table of disk addresses                                 *
!----------------------------------------------------------------------*
call DaName(LuJob,FnJob)
iDisk = 0
call iDaFile(LuJob,2,iToc,iTOCIPH,iDisk)
!----------------------------------------------------------------------*
!     Read the the system description                                  *
!----------------------------------------------------------------------*
call mma_allocate(TempTxt,(LenIn+8)*MxOrb,Label='TempTxt')
iDisk = iToc(1)

!write(u6,*) 'if dmrg, it should be something else'
call WR_RASSCF_Info(LuJob,2,iDisk,nActEl,iSpin,nSym,State_sym,nFro,nIsh,nAsh,nDel,nBas,MxSym,TempTxt,(LenIn+8)*mxorb,nConf, &
                    HeaderJP,144,TitleJP,4*18*mxTit,PotNuc0,lRoots,nRoots,iRoot,mxRoot,nRs1,nRs2,nRs3,nHole1,nElec3,iPt2,Weight)

if (doDMRG) then ! yma
  nash(:) = LRras2(:)
  nrs2(:) = LRras2(:)
end if
!do i=1,8
!  write(u6,*) i,'-irrep',nIsh(i),nAsh(i),nRs1(i),nRs2(i),nRs3(i)
!  call xflush(u6)
!end do

call mma_deallocate(TempTxt)
!----------------------------------------------------------------------*
!     Overwrite the variable lroots if approriate, i.e if lroot        *
!     was set by input.                                                *
!----------------------------------------------------------------------*
if (kRoots /= -1) then
  if (iPt2 /= 0) then
    write(u6,*) 'RdJobiph: kRoots /= -1 .and. iPt2 /= 0'
    call Abend()
  else if (kRoots > lRoots) then
    write(u6,*) 'RdJobiph: kRoots /= -1 .and. kRoots > lRoots'
    call Abend()
  end if
  lRoots = kRoots
  nRoots = 1
end if
!----------------------------------------------------------------------*
!     Precompute the total sum of variables and size of matrices       *
!----------------------------------------------------------------------*
ntIsh = sum(nIsh(1:nSym))
ntIsqr = sum(nIsh(1:nSym)**2)
ntAsh = sum(nAsh(1:nSym))
ntAsqr = sum(nAsh(1:nSym)**2)
ntBas = sum(nBas(1:nSym))
ntBsqr = sum(nBas(1:nSym)**2)
nOrb(1:nSym) = nBas(1:nSym)-nDel(1:nSym)
Length = sum(nBas(1:nSym)*nOrb(1:nSym))
ntItri = 0
ntAtri = 0
ntBtri = 0
nna = 0
do iSym=1,nSym
  ntItri = ntItri+nTri_Elem(nIsh(iSym))
  ntAtri = ntAtri+nTri_Elem(nAsh(iSym))
  ntBtri = ntBtri+nTri_Elem(nBas(iSym))
  nA(iSym) = nna
  nnA = nnA+nAsh(isym)
end do

! Generate the nr. of csf in each sub-sym, used in geom-opt with SA DMRG-SCF
if (doDMRG) then  ! yma
  imode = -99
  ! generate the Nr. of csfs in each sym
  call GugaNew(nSym,iSpin,nActEl,nHole1,nElec3,nRs1,nRs2,nRs3,SGS,CIS,EXS,rdum,imode,State_Sym,State_Sym)
  NCSF(1:nSym) = CIS%NCSF(1:nSym)
  NCONF = CIS%NCSF(State_Sym)
  call mkGuga_Free(SGS,CIS,EXS)

  !do isym=1,8
  !  write(u6,*) 'isym_ncsf in rdjobiph ',ncsf(isym)
  !end do
end if

!----------------------------------------------------------------------*
!     Load the orbitals used in the last macro iteration               *
!----------------------------------------------------------------------*

call mma_allocate(CMO,Length,Label='CMO')
call Get_dArray_chk('Last orbitals',CMO,Length)

! Read state for geo opt

call Get_iScalar('Relax CASSCF root',irlxroot)
call Get_cArray('Relax Method',Method,8)
iMCPD = .false.
iMSPD = .false.
if ((Method == 'MCPDFT') .or. (Method == 'MSPDFT')) then
  iMCPD = .true.
  if (Method == 'MSPDFT') iMSPD = .true.
  do i=1,lroots
    if (iroot(i) == irlxroot) istate = i
  end do
end if
if ((Method == 'CASSCFSA') .or. (Method == 'CASPT2') .or. (Method == 'RASSCFSA')) then
  call Get_iScalar('SA ready',iGo)
  if (iGo /= 2) SA = .true.
  Found = .true.
  if (override) then
    if (isNAC) then
      do j=1,2
        NSSA(j) = 0
        do i=1,lroots
          if (iroot(i) == NACStates(j)) NSSA(j) = i
        end do
        if (NSSA(j) == 0) Found = .false.
      end do
    else
      irlxroot = iroot(istate)
    end if
  else
    istate = 0
    do i=1,lroots
      if (iroot(i) == irlxroot) istate = i
    end do
    if (istate == 0) Found = .false.
  end if
  if (.not. Found) then
    call WarningMessage(2,'Cannot relax a root not included in the SA')
    call Abend()
  end if
else if ((irlxroot == 1) .and. (.not. (McKinley .or. PT2 .or. iMCPD))) then
  write(u6,*)
  write(u6,*) 'W A R N I N G !'
  write(u6,*)
  write(u6,*) 'Redundant rlxroot input in RASSCF!'
  write(u6,*) 'I''ll sign off here without a clean termination!'
  write(u6,*) 'However, I have to fix the epilogue file.'
  write(u6,*)
  irc = -1
  iopt = ibset(0,sNew)
  call OPNMCK(irc,iopt,FNMCK,LUMCK)
  iopt = 0
  call WrMck(iRC,iOpt,'nSym',1,nBas,iDummer)
  call ClsFls_MCLR()
  call Finish(0)
end if

!iDisk = iToc(9)
!if (IPT2 == 0) iDisk = iToc(2)
!call dDaFile(LuJob,2,CMO,ntBsqr,iDisk)
!jpCMO = 1
!do iSym=1,nSym
!  CMO(jpCMO+norb(isym)*nbas(isym):jpCMO+(norb(isym)+ndel(isym))*nbas(isym)-1) = Zero
!  write(Line,'(A,i2.2)') 'MO coefficients, iSym = ',iSym
!  call RecPrt(Line,' ',CMO(jpCMO),nBas(iSym),nBas(iSym))
!  jpCMO = jpCMO+nBas(iSym)*nBas(iSym)
!end do
!----------------------------------------------------------------------*
!     Load the CI vectors for the SA roots                             *
!----------------------------------------------------------------------*

! If doDMRG, introducing CI coeffieients later :
!    1) only coefficients of importants DETs using MPS2CI
!    2) and together with DET numbers from GUGA generation part

if (doDMRG) then  ! yma
  call mma_allocate(CIVec,nConf,nroots,Label='CIVec')
else
  call mma_allocate(CIVec,nConf,nroots,Label='CIVec')
  do i=1,nroots
    j = iroot(i)
    iDisk = iToc(4)
    do k=1,j-1
      call dDaFile(LuJob,0,rdum,nConf,iDisk)
    end do
    call dDaFile(LuJob,2,CIVec(:,i),nConf,iDisk)
  end do
!#ifdef _DEBUGPRINT_       ! yma umcomment
!  do i=1,nroots            !yma
!    inum = 0
!    dv_ci2 = Zero
!    do j=1,nconf
!      !yma CI-threshold
!      if (abs(CIVec(j,i)) < Zero) then
!        inum = inum+1
!        CIVec(j,i) = Zero
!      else
!        dv_ci2 = dv_ci2+CIVec(j,i)**2
!      end if
!    end do
!    !call DVcPrt('CI coefficients',' ',CIVec(:,i),nConf)!yma
!    !write(u6,*) 'dismissed dets num', inum
!    !write(u6,*) 'absolutely CI^2',dv_ci2
!  end do
!#endif
end if

!----------------------------------------------------------------------*
!     Load state energy                                                *
!----------------------------------------------------------------------*
call mma_allocate(Tmp2,mxRoot*mxIter,Label='Tmp2')
iDisk = iToc(6)
#ifdef _DEBUGPRINT_
if (debug) then
  write(u6,*) 'NROOTS: ',nroots
  write(u6,*) 'iROOTS: ',(iroot(i),i=1,nroots)
  write(u6,*) 'lROOTS: ',lroots
end if
#endif
call dDaFile(LuJob,2,Tmp2,mxRoot*mxIter,iDisk)

do iter=0,mxIter-1
  do i=1,nroots
    j = iroot(i)
    ! It should be 0.0 in DMRG case
    Temp = Tmp2(iter*mxRoot+j)
    if (Temp /= Zero) ERASSCF(i) = Temp
    !if (debug) write(u6,*) ERASSCF(i),i
  end do
end do

#ifdef _DEBUGPRINT_
if (debug) then
  write(u6,*) (Tmp2(i),i=1,lroots)
  write(u6,*) 'RASSCF energies=',(ERASSCF(i),i=1,nroots)
end if
#endif
call mma_deallocate(Tmp2)

nAct = 0    ! 1/2

if (doDMRG) then  ! yma
  call dmrg_dim_change_mclr(RGras2,ntash,0)
  nash(:) = RGras2(:)
  nrs2(:) = RGras2(:)
end if

nAct2 = 0
nAct4 = 0
do iSym=1,nSym
  nAct = nAct+nAsh(iSym)
  nAct2 = nAct2+nAsh(iSym)**2
end do
do iS=1,nSym
  do jS=1,nSym
    do kS=1,nSym
      lS = Mul(Mul(is,js),ks)
      nAct4 = nAct4+nAsh(iS)*nAsh(jS)*nAsh(kS)*nAsh(lS)
    end do
  end do
end do

nG1 = nTri_Elem(nAct)
call mma_allocate(G1t,nG1,Label='G1t')
nG2 = nTri_Elem(nG1)
call mma_allocate(G2t,nG2,Label='G2t')
call RDDENS(G1t,ng1,G2t,ng2)

#ifdef _DEBUGPRINT_
call Triprt('G1',' ',G1t,ntash)
call Triprt('G2',' ',G2t,ng1)
#endif

if (doDMRG) then ! yma
  call dmrg_dim_change_mclr(LRras2,nact,0)
  nash(:) = LRras2(:)
  nrs2(:) = LRras2(:)
end if
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine RdJobIph

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine saverest2(lunrst,energy,niter,iokey,daddr)
! this routine saves restart informations:
! energy, niter
! to prepaired position in lunrst

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lunrst, niter, iokey
real(kind=wp), intent(in) :: energy
integer(kind=iwp), intent(inout) :: daddr
integer(kind=iwp) :: idum(1)
real(kind=wp) :: dum(1)

!1 write energy,niter
if (iokey == 1) then
  ! Fortran IO
  write(lunrst) energy,niter

else
  ! MOLCAS IO
  dum(1) = energy
  call ddafile(lunrst,1,dum,1,daddr)
  idum(1) = niter
  call idafile(lunrst,1,idum,1,daddr)
end if

return

end subroutine saverest2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkT_red (T2red,T2full,dimbe,no)
c
c        this routine produce reduced set of ampitudes for storing:
c       T2red(be'ga',u,v) <- T2full(be',ga',u,v)
c        for beGrp=gaGrp
c
        implicit none
        integer dimbe,no
        real*8 T2full(1:dimbe,1:dimbe,1:no,1:no)
        real*8 T2red(1:dimbe*(dimbe+1)/2,1:no,1:no)
c
c        help variables
        integer i,j,be,ga,bega
c
        do j=1,no
        do i=1,no
c
        bega=0
        do be=1,dimbe
        do ga=1,be
        bega=bega+1
c
          T2red(bega,i,j)=T2Full(be,ga,i,j)
c
        end do
        end do
c
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2016,2017, Roland Lindh                                *
************************************************************************
      SubRoutine GrdClc(What,QNR)
      use SCF_Arrays
      Implicit Real*8 (a-h,o-z)
      Character What*3
      Logical   QNR
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "WrkSpc.fh"
*
      nD = iUHF + 1
*                                                                      *
************************************************************************
*                                                                      *
*     QNR     : Quasi-Newton in effect
*
      If (QNR) Then
         Call GrdClc_(What,Dens,TwoHam,Vxc,nBT,nDens,nD,OneHam,
     &                CMO   ,nBB,Ovrlp,CMO)
      Else
         Call GrdClc_(What,Dens,TwoHam,Vxc,nBT,nDens,nD,OneHam,
     &                Lowdin,nBB,Ovrlp,CMO)
      End If
*
      Return
      End
      SubRoutine GrdClc_(What,Dens,TwoHam,Vxc,mBT,mDens,nD,OneHam,
     &                   OCMO,mBB,Ovrlp,CMO)
************************************************************************
*                                                                      *
*     purpose: Compute gradients and write on disk.                    *
*                                                                      *
*                                                                      *
*     input:                                                           *
*       What    : variable telling what gradients compute: 'All' -     *
*                 all gradients, 'Lst' - last gradient                 *
*                                                                      *
*     called from: Wfctl_scf                                           *
*                                                                      *
*     calls to:         EGrad                                          *
*               uses SubRoutines and Functions from Module lnklst.f    *
*               -linked list implementation to store series of vectors *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "infso.fh"
#include "stdalloc.fh"
#include "file.fh"
#include "llists.fh"
*
      Real*8 Dens(mBT,nD,mDens), TwoHam(mBT,nD,mDens), CMO(mBB,nD),
     &       OneHam(mBT), OCMO(mBB,nD), Ovrlp(mBT), Vxc(mBT,nD,mDens)
      Real*8, Dimension(:,:), Allocatable:: GrdOO,GrdOV,AuxD,AuxT,AuxV
      Character What*3
#include "interfaces_scf.fh"
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*define _DEBUGPRINT_
*
      If (What.ne.'All' .and. What.ne.'Lst') Then
         Write (6,*) 'GrdClc: What.ne."All" .and. What.ne."Lst"'
         Write (6,'(A,A)') 'What=',What
         Call Abend()
      End If

*--- Allocate memory for gradients and gradient contributions
      Call mma_allocate(GrdOO,nOO,nD,Label='GrdOO')
      Call mma_allocate(GrdOV,nOO,nD,Label='GrdOV')

*--- Allocate memory for auxiliary matrices
      Call mma_allocate(AuxD,nBT,nD,Label='AuxD')
      Call mma_allocate(AuxT,nBT,nD,Label='AuxT')
      Call mma_allocate(AuxV,nBT,nD,Label='AuxV')

*--- Find the beginning of the loop
      If (What.eq.'All') Then
         LpStrt = 1
      Else
         LpStrt = kOptim
      End If

*--- Compute all gradients / last gradient
*
      iter_d=iter-iter0
      Do iOpt = LpStrt, kOptim
         iDT = iter_d - kOptim + iOpt
*
         Call dCopy_(nOV*nD,[Zero],0,GrdOV,1)
*
         jDT=MapDns(iDT)
         If (jDT.lt.0) Then
            Call RWDTG(-jDT,AuxD,nBT*nD,'R','DENS  ',iDisk,MxDDsk)
            Call RWDTG(-jDT,AuxT,nBT*nD,'R','TWOHAM',iDisk,MxDDsk)
            Call RWDTG(-jDT,AuxV,nBT*nD,'R','dVxcdR',iDisk,MxDDsk)
*
            Call EGrad(OneHam,AuxT,AuxV,Ovrlp,AuxD,nBT,OCMO,nBO,
     &                 GrdOO,nOO,nD,CMO)
*
         Else
*
            Call EGrad(OneHam,TwoHam(1,1,jDT),Vxc(1,1,jDT),Ovrlp,
     &                 Dens(1,1,jDT),nBT,OCMO,nBO,GrdOO,nOO,nD,CMO)
*
         End If
*
         Call vOO2OV(GrdOO,nOO,GrdOV,nOV,nD)
*
*------- Write Gradient to linked list
*
         Call PutVec(GrdOV,nD*nOV,LuGrd,iDT+iter0,MemRsv,'OVWR',LLGrad)
*
#ifdef _DEBUGPRINT_
         Write (6,*) 'GrdClc: Put Gradient iteration:',iDT+iter0
         Write (6,*) 'iOpt=',iOpt
         Call NrmClc(GrdOO,nOO*nD,'GrdClc','GrdOO')
         Call NrmClc(GrdOV,nOV*nD,'GrdClc','GrdOV')
         Call RecPrt('GrdClc: g(i)',' ',GrdOV,1,nOV*nD)
#endif
      End Do
*
*     Deallocate memory
*
      Call mma_deallocate(AuxD)
      Call mma_deallocate(AuxT)
      Call mma_deallocate(AuxV)
      Call mma_deallocate(GrdOV)
      Call mma_deallocate(GrdOO)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

subroutine RHSOD_G(IVEC)

use Symmetry_Info, only: Mul
use SUPERINDEX, only: MAGEB, MAGTB, MAREL
use CHOVEC_IO, only: ChoVec_Read, ChoVec_Size, NVTOT_CHOSYM
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB
#else
use fake_GA, only: GA_Arrays
#endif
use caspt2_global, only: iPrGlb
use caspt2_module, only: NAGEB, NAGEBES, NAGTB, NAGTBES, NASUP, NISH, NISUP, NSSH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Half, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: IA, IAABS, IAEND, IAGEC, IAGECTOT, IAGTC, IAGTCTOT, IAJ, IASTA, IAV, IC, ICABS, iCASE, ICJ, ICV, IDX, IIEND, &
                     IISTA, IJ, IJAGEC, IJAGECEND, IJAGECSTA, IJAGTC, IJAGTCEND, IJAGTCSTA, IOBRA(8,8), IOFF, IOFFAJ, IOFFAV, &
                     IOFFCJ, IOFFCV, IOKET(8,8), ISYA, ISYAC, ISYC, ISYJ, ISYM, ISYV, IV, lg_W, MW, NAC, NAS, NBRABUF, NIS, NJ, &
                     NKETBUF, NV, NW
real(kind=wp) :: AVCJ, CVAJ, GM, GP, SCL
real(kind=wp), allocatable :: BRABUF(:), KETBUF(:)
real(kind=wp), parameter :: SQRTA = sqrt(OneHalf), SQRTH = sqrt(Half)
real(kind=wp), external :: DDot_
!logical Incore

if (iPrGlb >= DEBUG) write(6,*) 'RHS on demand: case G'

!***********************************************************************
! Case G (10,11):
! GP(v,jac)=((av,cj)+(cv,aj))/SQRT(2+2*Kron(a,b))
! GM(v,jac)=((av,cj)-(cv,aj))*SQRT(3/2)
!***********************************************************************

! -SVC- Case G is slightly special, in that the inactive superindices are
! so large, that it is suboptimal to have a direct translation table for
! them. Instead, the code loops over symmetry blocks of J-AC and figures
! out if the indices on the processor fall within a block or not. Within
! a J-AC symmetry block, NJ(ISYJ) and NAGEB(ISYAC) are known, so they can
! be determined by integer(kind=iwp) division. This could be optimized by combining
! it with loop peeling (on the todo list?).

!***********************************************************************
!SVC: read in all the cholesky vectors (need all symmetries)
!***********************************************************************
call CHOVEC_SIZE(3,NBRABUF,IOBRA)
call CHOVEC_SIZE(4,NKETBUF,IOKET)

call mma_allocate(BRABUF,NBRABUF,LABEL='BRABUF')
call mma_allocate(KETBUF,NKETBUF,LABEL='KETBUF')

call CHOVEC_READ(3,BRABUF,NBRABUF)
call CHOVEC_READ(4,KETBUF,NKETBUF)

iCASE = 10
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  ! find start and end block
  IOFF = 0
  do ISYJ=1,NSYM
    ISYAC = Mul(ISYJ,ISYM)
    ISYV = ISYM

    NJ = NISH(ISYJ)
    NAC = NAGEB(ISYAC)
    ! what is start/end in this block?
    IJAGECSTA = max(IISTA-IOFF,1)
    IJAGECEND = min(IIEND-IOFF,NJ*NAC)

    do IJAGEC=IJAGECSTA,IJAGECEND
      IAGEC = (IJAGEC-1)/NJ+1
      IJ = IJAGEC-NJ*(IAGEC-1)
      IAGECTOT = IAGEC+NAGEBES(ISYAC)
      IAABS = MAGEB(1,IAGECTOT)
      ICABS = MAGEB(2,IAGECTOT)
      IA = MAREL(1,IAABS)
      ISYA = MAREL(2,IAABS)
      IC = MAREL(1,ICABS)
      ISYC = MAREL(2,ICABS)
      do IV=IASTA,IAEND ! these are always all elements
        ! compute integrals (ajvl) and (alvj)
        NV = NVTOT_CHOSYM(Mul(ISYA,ISYV))
        IAV = IA-1+NSSH(ISYA)*(IV-1)
        ICJ = IC-1+NSSH(ISYC)*(IJ-1)
        IOFFAV = 1+IOBRA(ISYA,ISYV)+NV*IAV
        IOFFCJ = 1+IOKET(ISYC,ISYJ)+NV*ICJ
        AVCJ = DDOT_(NV,BRABUF(IOFFAV),1,KETBUF(IOFFCJ),1)

        NV = NVTOT_CHOSYM(Mul(ISYC,ISYV))
        ICV = IC-1+NSSH(ISYC)*(IV-1)
        IAJ = IA-1+NSSH(ISYA)*(IJ-1)
        IOFFCV = 1+IOBRA(ISYC,ISYV)+NV*ICV
        IOFFAJ = 1+IOKET(ISYA,ISYJ)+NV*IAJ
        CVAJ = DDOT_(NV,BRABUF(IOFFCV),1,KETBUF(IOFFAJ),1)

        ! GP(v,jac)=((av,cj)+(cv,aj))/SQRT(2+2*Kron(a,b))
        if (IAABS == ICABS) then
          SCL = Half
        else
          SCL = SQRTH
        end if
        GP = SCL*(AVCJ+CVAJ)
        ! write element EP
        IDX = IV+NAS*(IJAGEC+IOFF-IISTA)
#       ifdef _MOLCAS_MPP_
        DBL_MB(MW+IDX-1) = GP
#       else
        GA_Arrays(lg_w)%A(IDX) = GP
#       endif
      end do
    end do

    IOFF = IOFF+NJ*NAC
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

iCASE = 11
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) cycle

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)
  NW = NAS*(IIEND-IISTA+1)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  ! find start and end block
  IOFF = 0
  do ISYJ=1,NSYM
    ISYAC = Mul(ISYJ,ISYM)
    ISYV = ISYM

    NJ = NISH(ISYJ)
    NAC = NAGTB(ISYAC)
    ! what is start/end in this block?
    IJAGTCSTA = max(IISTA-IOFF,1)
    IJAGTCEND = min(IIEND-IOFF,NJ*NAC)

    do IJAGTC=IJAGTCSTA,IJAGTCEND
      IAGTC = (IJAGTC-1)/NJ+1
      IJ = IJAGTC-NJ*(IAGTC-1)
      IAGTCTOT = IAGTC+NAGTBES(ISYAC)
      IAABS = MAGTB(1,IAGTCTOT)
      ICABS = MAGTB(2,IAGTCTOT)
      IA = MAREL(1,IAABS)
      ISYA = MAREL(2,IAABS)
      IC = MAREL(1,ICABS)
      ISYC = MAREL(2,ICABS)
      do IV=IASTA,IAEND ! these are always all elements
        ! compute integrals (ajvl) and (alvj)
        NV = NVTOT_CHOSYM(Mul(ISYA,ISYV))
        IAV = IA-1+NSSH(ISYA)*(IV-1)
        ICJ = IC-1+NSSH(ISYC)*(IJ-1)
        IOFFAV = 1+IOBRA(ISYA,ISYV)+NV*IAV
        IOFFCJ = 1+IOKET(ISYC,ISYJ)+NV*ICJ
        AVCJ = DDOT_(NV,BRABUF(IOFFAV),1,KETBUF(IOFFCJ),1)

        NV = NVTOT_CHOSYM(Mul(ISYC,ISYV))
        ICV = IC-1+NSSH(ISYC)*(IV-1)
        IAJ = IA-1+NSSH(ISYA)*(IJ-1)
        IOFFCV = 1+IOBRA(ISYC,ISYV)+NV*ICV
        IOFFAJ = 1+IOKET(ISYA,ISYJ)+NV*IAJ
        CVAJ = DDOT_(NV,BRABUF(IOFFCV),1,KETBUF(IOFFAJ),1)

        ! GM(v,jac)=((av,cj)-(cv,aj))*SQRT(3/2)
        GM = SQRTA*(AVCJ-CVAJ)
        ! write element GM
        IDX = IV+NAS*(IJAGTC+IOFF-IISTA)
#       ifdef _MOLCAS_MPP_
        DBL_MB(MW+IDX-1) = GM
#       else
        GA_Arrays(lg_W)%A(IDX) = GM
#       endif
      end do
    end do

    IOFF = IOFF+NJ*NAC
  end do
  !*********************************************************************

  call RHS_Release_Update(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)
end do
!***********************************************************************

call mma_deallocate(BRABUF)
call mma_deallocate(KETBUF)

end subroutine RHSOD_G

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine kindiag(TKIN,ndim,evec,eval,breit)
!bs determines eigenvectors and -values of TKIN

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ndim
real(kind=wp), intent(in) :: tkin(ndim,ndim)
real(kind=wp), intent(out) :: evec(ndim,ndim), eval(ndim)
logical(kind=iwp), intent(in) :: breit
integer(kind=iwp) :: irun, irun1, irun2, itria, JRUN
real(kind=wp) :: fact
real(kind=wp), allocatable :: TKINTRIA(:)

call mma_allocate(TKINTRIA,ndim*(ndim+1)/2,label='TKINTRIA')

!bs move symmetric matrix to triangular matrix
itria = 1
do irun2=1,ndim
  do irun1=1,irun2
    TKINTRIA(itria) = TKIN(irun1,irun2)
    itria = itria+1
  end do
end do
evec(:,:) = Zero
do irun1=1,ndim
  evec(irun1,irun1) = One
end do
!bs now diagonalize
call Jacob(TKINTRIA,evec,ndim,ndim)
!bs get the eigenvalues
if (breit) then
  eval(:) = Zero
else
  do irun=1,ndim
    eval(irun) = TKINTRIA(irun*(irun+1)/2)
  end do
end if
call mma_deallocate(TKINTRIA)
!bs ensure normalization of the vectors.
do IRUN=1,ndim
  fact = Zero
  do JRUN=1,ndim
    fact = fact+evec(JRUN,IRUN)*evec(JRUN,IRUN)
  end do
  fact = One/sqrt(fact)
  evec(:,IRUN) = fact*evec(:,IRUN)
end do

return

end subroutine kindiag

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine ClsFls_CASPT2
************************************************************************
*     Close files.                                                     *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
************************************************************************
      Implicit real*8 (a-h,o-z)
*----------------------------------------------------------------------*
*     Start                                                            *
*-------------------------------------- -------------------------------*

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
      Call DaClos(LUCIEX)
* PAM08
*      Call DaClos(LUMORB)
      Call DaClos(LUONEM)
      Call DaClos(LUINTM)
      Call DaClos(LUDRA)
      Call DaClos(LUDRATOT)
      Call DaClos(LUHLF1)
      Call DaClos(LUHLF2)
      Call DaClos(LUHLF3)
      Call DaClos(LUDMAT)
      Call DaClos(LUSOLV)
      Call DaClos(LUSBT)
      DO IVEC=1,6
        CALL DaClos(LURHS(IVEC))
      END DO
      DO IMAT=1,4
        CALL DaClos(LUH0T(IMAT))
      END DO
*---  close the ORDINT file -------------------------------------------*
      If (.not.IfChol) then
         iRc=-1
         iOpt=0
         Call ClsOrd(iRc,iOpt)
         IF(IRC.NE.0 .AND. IPRGLB.GT.SILENT) THEN
          Call WarningMessage(1,'Failed to close ORDINT file.')
         END IF
      End If
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine Ortho(AMat,nAMat,Ovlp,nOvlp)
!***********************************************************************
!                                                                      *
!     purpose: Transform to orthonormal basis (one symmetry block      *
!              at a time)                                              *
!     input:                                                           *
!       AMat    : transformation matrix to non-orthonormal basis of    *
!                 length nAMat                                         *
!       Ovlp    : overlap in AO basis of length nOvlp                  *
!                                                                      *
!     output:                                                          *
!       AMat    : transformation matrix to orthonormal basis           *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: MaxBas, MaxBxO, MaxOrb, nSym, nOrb, nBas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAMat, nOvlp
real(kind=wp), intent(inout) :: AMat(nAMat)
real(kind=wp), intent(in) :: Ovlp(nOvlp)
integer(kind=iwp) :: iiBO, iiBT, ij, im, iSym
real(kind=wp), allocatable :: OvlT(:), OvlH(:), OvlS(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Allocate memory for transformed overlap matrix
call mma_allocate(OvlT,MaxOrb**2,Label='OvlT')

! Allocate memory for half-transformed overlap matrix
call mma_allocate(OvlH,MaxBxO,Label='OvlH')

! Allocate memory for squared overlap matrix
call mma_allocate(OvlS,MaxBas**2,Label='OvlS')

ij = 1
im = 1
do iSym=1,nSym

  iiBO = nBas(iSym)*nOrb(iSym)
  iiBT = nTri_Elem(nBas(iSym))

  if (nOrb(iSym) > 0) then

    ! Square overlap and transform to the basis given by AMat
    !call Square(Ovlp(ij),nBas(iSym),OvlS,nBas(iSym))
    call Square(Ovlp(ij),OvlS,1,nBas(iSym),nBas(iSym))
    call DGEMM_('N','N',nBas(iSym),nOrb(iSym),nBas(iSym), &
                One,OvlS,nBas(iSym), &
                AMat(im),nBas(iSym), &
                Zero,OvlH,nBas(iSym))
    call DGEMM_('T','N',nOrb(iSym),nOrb(iSym),nBas(iSym), &
                One,AMat(im),nBas(iSym), &
                OvlH,nBas(iSym), &
                Zero,OvlT,nOrb(iSym))

    ! Orthogonalize (Gram-Schmidt)
    call Orthox(OvlT,AMat(im),nOrb(iSym),nBas(iSym))

  end if

  ! Update pointers
  im = im+iiBO
  ij = ij+iiBT

end do

! Deallocate memory
call mma_deallocate(OvlT)
call mma_deallocate(OvlH)
call mma_deallocate(OvlS)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*
return

end subroutine Ortho

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine CPFCTL(C,S,W,TPQ,ENP,EPP,BST,EPB,AP,BIJ,CN,TEMP)

use cpf_global, only: DETOT, ETHRE, ETOT, ICASE, ICONV, ICPF, IDIIS, INCPF, INDX, IPRINT, IRC, ISDCI, ITER, ITPUL, JSY, MAXIT, &
                      MAXITP, NTMAX, POTNUC
use Constants, only: One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: C(*), S(*), EPP(*), BST((MAXIT+1)**2)
real(kind=wp), intent(in) :: W(*), ENP(*)
real(kind=wp), intent(_OUT_) :: TPQ(*), EPB(*), AP(*)
real(kind=wp), intent(out) :: BIJ((MAXIT+1)**2), CN(MAXIT+1), TEMP(NTMAX)
integer(kind=iwp) :: I, IP, ITP
real(kind=wp) :: C0, DECORR, DELE, EENP, ENER, ETOTT

call EPSBIS(JSY,INDX,C,W,EPB)
call EPSPRIM(JSY,INDX,C,S,EPP)
IP = IRC(4)
call VECSUM_CPFMCPF(EPP,ENER,IP)
ETOTT = ENER+POTNUC
DELE = ETOTT-ETOT
ETOT = ETOTT
if (ITER == 1) then
  write(u6,'(1X,A)') ' ITER      TOTAL ENERGY          CORR ENERGY           DECREASE'
end if
write(u6,'(1X,I3,3(5X,F16.8))') ITER,ETOT,ENER,DELE
if ((abs(DELE) < ETHRE) .and. (ITPUL /= 1)) ICONV = 1
if ((ICONV == 0) .and. (ITER /= MAXIT)) then
  ! If more iterations should be done.
  IDIIS = 0
  if (ITPUL == MAXITP) IDIIS = 1
  call APPRIM(EPP,EPB,TPQ,AP,ENP,TEMP,ICASE)
  call CUPDATE(JSY,INDX,C,S,AP,BST,ENP)
  ITP = ITPUL+1
  call DIIS_CPF(C,S,BST,MAXIT,BIJ,ITP,CN)
else
  if (ICONV == 1) write(u6,37)
  if (ICONV == 0) write(u6,38)
  if (ISDCI == 1) write(u6,30) ETOT
  if (ICPF == 1) write(u6,35) ETOT
  if (INCPF == 1) write(u6,39) ETOT
  if ((ISDCI == 0) .and. (ICPF == 0) .and. (INCPF == 0)) write(u6,36) ETOT
  write(u6,31) ENER,POTNUC
  if (ISDCI == 1) call Add_Info('E_SDCI',[ETOT],1,8)
  if (ICPF == 1) call Add_Info('E_CPF',[ETOT],1,8)
  if (INCPF == 1) call Add_Info('E_ACPF',[ETOT],1,8)
  if ((ISDCI == 0) .and. (ICPF == 0) .and. (INCPF == 0)) call Add_Info('E_MCPF',[ETOT],1,8)
  if (ISDCI /= 0) then
    EENP = ENP(IRC(4))
    C0 = One/sqrt(EENP)
    DECORR = ENER*(EENP-One)
    DETOT = ETOT+DECORR
    write(u6,32) DETOT
    write(u6,33) DECORR,C0
  end if

  if (IPRINT > 5) then
    if (IPRINT > 5) write(u6,34) (ENP(I),I=1,IRC(4))
  end if
end if

return

30 format(/,5X,'FINAL CI ENERGY',6X,F17.8)
31 format(5X,'FINAL CORRELATION ENERGY',F14.8,'  REFERENCE ENERGY',F17.8)
32 format(5X,'DAVIDSON CORR. ENERGY',F17.8)
33 format(5X,'DAVIDSON CORRECTION',F19.8,'  C0 = ',F12.6)
34 format(/,(5X,'ENP',5F10.6))
35 format(/,5X,'FINAL CPF ENERGY',5X,F17.8)
36 format(/,5X,'FINAL MCPF ENERGY',5X,F17.8)
37 format(/,5X,'CALCULATION CONVERGED')
38 format(/,5X,'CALCULATION NOT COMPLETELY CONVERGED')
39 format(/,5X,'FINAL ACPF ENERGY',4X,F17.8)

end subroutine CPFCTL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_VecBuf_Print(Lupri,nSym)
!
! Purpose: print allocation information of Cholesky vector buffer to
!          unit Lupri (if Lupri<1 nothing is printed).

use Cholesky, only: CHVBUF, l_CHVBUF_SYM
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: Lupri, nSym
integer(kind=iwp) :: iSym
real(kind=wp) :: xGb
character(len=2) :: Unt
character(len=*), parameter :: SecNam = 'Cho_VecBuf_Print'

if (Lupri < 1) return
if ((nSym < 1) .or. (nSym > 8)) call Cho_Quit('nSym error in '//SecNam,104)

call Cho_Head('Size of Cholesky vector buffer','-',80,Lupri)
write(Lupri,*)
do iSym=1,nSym
  call Cho_Word2Byte(l_ChVBuf_Sym(iSym),8,xGb,Unt)
  write(Lupri,'(A,I2,A,I10,A,F8.2,A,A,A)') 'Dimension, sym.',iSym,': ',l_ChVBuf_Sym(iSym),' 8-byte words (',xGb,' ',Unt,')'
end do
call Cho_Word2Byte(size(ChVBuf),8,xGb,Unt)
write(Lupri,'(/,A,I10,A,F8.2,A,A,A)') 'Total dimension  : ',size(ChVBuf),' 8-byte words (',xGb,' ',Unt,')'

end subroutine Cho_VecBuf_Print

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine mkp1(nEX,lst,rMat,rdiag)
      use negpre
      Implicit Real*8 (a-h,o-z)
#include "Pointers.fh"

#include "Input.fh"
#include "stdalloc.fh"
      Real*8 rMat(*),rdiag(*)
      Integer lst(nex)
      Real*8, Allocatable:: Tmp1(:), Tmp2(:)

      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

      Call mma_allocate(TMP1,nconf,Label='Tmp1')
      Call mma_allocate(TMP2,nconf,Label='Tmp2')

      idisk=0
      Do i=1,lroots
       Call dDaFile(LuCIV,2,Tmp1,nconf,iDisk)
       jdisk=0
       Do j=1,i
         Call dDafile(luciv,2,Tmp2,nconf,jDisk)
         rTmp=0.0d0
         Do k=1,nex
          do l=1,nex
           kk=lst(k)
           ll=lst(l)
           rtmp=rtmp+Tmp1(kk)*Tmp2(ll)*rmat(itri(k,l))
          End Do
         End Do
         Do k=1,nconf
          rtmp=rtmp+Tmp1(k)*Tmp2(k)*rdiag(k)
         End Do
         If (i.eq.j) rtmp=rtmp-ERASSCF(1)
         Do  k=1,nEx
          kk=lst(k)
          rtmp=rtmp-Tmp1(kk)*Tmp2(kk)*(rdiag(kk+1)-ERASSCF(1))
         End Do
         P1(itri(i,j))=rtmp
        End Do
       End Do

       Call mma_deallocate(TMP2)
       Call mma_deallocate(TMP1)

       Return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function Index_NoSym(iCntr,iCmp,iCnt,iAng,iR,Index,iBas,
     &                             nBas)
      Integer Index(5,nBas)
*
 98   Continue
      Index_NoSym=0
      Do i = 1, iBas
         If (Index(1,i).eq.iCntr .and.
     &       Index(2,i).eq.iCmp  .and.
     &       Index(3,i).eq.iCnt  .and.
     &       Index(4,i).eq.iAng  .and.
     &       Index(5,i).eq.iR   ) Then
            Index_NoSym=i
            Go To 99
         End If
      End Do
*
      iBas=iBas+1
      Index(1,iBas)=iCntr
      Index(2,iBas)=iCmp
      Index(3,iBas)=iCnt
      Index(4,iBas)=iAng
      Index(5,iBas)=iR
      Go To 98
*
 99   Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Stefano Battaglia                                *
************************************************************************
      subroutine prettyprint(A,N,M)
* This subroutine pretty prints the NxM matrix A
      implicit none

#include "rasdim.fh"
#include "caspt2.fh"

* Input arguments
      integer N,M
      real*8 A(N,M)

      integer i,j,jStart,jEnd

      do jStart=1,N,5
        jEnd = min(jStart+4, N)
        write(6,'(1x,5i16)')(mstate(j),j=jStart,jEnd)
        do i=1,N
          write(6,'(1x,i3,2x,5f16.8)')mstate(i),(A(i,j),j=jStart,jEnd)
        end do
        write(6,*)
      end do

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Start_MCLR()
************************************************************************
*                                                                      *
*     Precompute whatever can be before starting the response section  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      use Arrays, only: CMO_Inv, CMO
      Implicit real*8 (a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "stdalloc.fh"
      Character(LEN=5) Fname
      Real*8, Allocatable:: STmat(:), Smat(:)
*----------------------------------------------------------------------*
*     start                                                            *
*----------------------------------------------------------------------*
*
      call setup_MCLR(1)
*
      If ((StepType.ne.'RUN2').and.(iAnd(kPrint,4).eq.4))
     &    Write(6,'(6X,A)') 'Transformation of integrals'
*     For the mp2-gradient calculations we want the transformation
*     routine to produce all integrals of the occupied and virtual
*     orbitals so we tell it that the whole space is inactive and
*     that the active is empty
*
*-----Use the driver from the CASPT2 code (only none-squared).
*
*
      ! re-direct the transformed integrals to the MOTRA file
      ! which is preserved at the end of the calculation.
      ! LuTri1 is deleted.
      If (TwoStep) Then
         LuTri1=LuMOTRA
         FnTri1=FnMOTRA
         Call DaName_MF_wa(LuQDAT,FnQDAT)
      End If

      Call DaName_MF_wa(LuTri1,FnTri1)

      If (newCho) Then
*
**       Compute inverse CMO
*
        lTriDens=0
        lSqrDens=0
        nOrbBas =0
        Do iSym=1,nSym
          lTriDens = lTriDens + nBas(iSym)*(nBas(iSym)+1)/2
          lSqrDens = lSqrDens + nBas(iSym)**2
          nOrbBas  = nOrbBas  + nOrb(iSym)*nBas(iSym)
        End Do
        Call mma_allocate(STmat,lTriDens,Label='STmat')
        Call mma_allocate(Smat,lSqrDens,Label='Smat')
*
        iSymlbl=1
        Call RdOne(irc,6,'Mltpl  0',1,STmat,iSymlbl)
*
        index = 1
        iOff = 0
        Do iSym = 1, nSym
           Do i = 1, nBas(iSym)
              Do j = 1, i-1
                 Smat(j+nBas(iSym)*(i-1)+iOff) =STmat(index)
                 Smat(i+nBas(iSym)*(j-1)+iOff) =STmat(index)
                 index = index + 1
              End Do
              Smat(i+nBas(iSym)*(i-1)+iOff) =STmat(index)
              index = index + 1
           End Do
           ioff=ioff+nBas(iSym)**2
        End Do
        Call mma_deallocate(STmat)
*
        Call mma_allocate(CMO_inv,nOrbBas,Label='CMO_Inv')
        iOff1 = 1
        iOff2 = 1
        Do iSym = 1, nSym
           Call dGemm_('T','N', nOrb(iSym),nBas(iSym),nBas(iSym),
     &                1.0d0,CMO(iOff2), nBas(iSym),
     &                      Smat(iOff1), nBas(iSym),
     &                0.0d0,CMO_Inv(iOff2), nOrb(iSym))
*
           iOff1 =  iOff1 + nBas(iSym)**2
           iOff2 =  iOff2 + nOrb(iSym)*nBas(iSym)
        End Do
*
        Call mma_deallocate(Smat)
      EndIf
*
      Call SetUp_CASPT2_Tra(nSym,nBas,nOrb,nIsh,nAsh,
     &                      nFro,nDel,CMO,nDens2,
     &                      LuTri1,LuTri2,LuHlf2,LuHlf3)
      iType=3  ! Means that TraCtl is called by MCLR

      If ((.not.newCho).and.(StepType.ne.'RUN2')) Then
        Call TraCtl_Drv(iType,.True.,1)
      End If

      If(TwoStep.and.(StepType.eq.'RUN2')) Then
        ! fetch some data from existing file LuTri1
        ! (from a previous MCLR run)
        ! and make it available to ERI common block intgrl.fh
        ! (LuTRI1=LuMOTRA)
        Call put_temp_data_on_intgrl(LuMOTRA,nSym,nOrb,nIsh,nAsh)
      End If
*
*
*     Init Cholesky informations
      If (NewCho) Then
         BufFrac=0.3D0
         Call Cho_X_Init(irc,BufFrac)
         iSeed=10
         Do i=1,nsym
           LuAChoVec(i) = IsFreeUnit(iSeed)
           iseed=LuAChoVec(i)+1
           Write(Fname,'(A4,I1)') 'CHTA',i
           Call DANAME_MF_WA(LuAChoVec(i),Fname)
         End Do
         Do i=1,nsym
           LuIChoVec(i) = IsFreeUnit(iSeed)
           iSeed=LuIChoVec(i)+1
           Write(Fname,'(A4,I1)') 'CHTI',i
           Call DANAME_MF_WA(LuIChoVec(i),Fname)
         End Do
         LuChoInt(1) = IsFreeUnit(iSeed)
         Write(Fname,'(A4)') 'CHIN'
         Call DANAME_MF_WA(LuChoInt(1),Fname)
         LuChoInt(2) = IsFreeUnit(iSeed)
         Write(Fname,'(A4)') 'CHTU'
         Call DANAME_MF_WA(LuChoInt(2),Fname)
      EndIf
*
      Call DaClos(LuTri2)
      Call DaClos(LuHlf2)
      Call DaClos(LuHlf3)
*
      Call FckMat
      Call StPert
*
**    With Cholesky there is no other choice than computing some
**    integrals used for the preconditioner
*
      If (NewCho) Call cho_prec_mclr(CMO,nIsh,nASh,LuAChoVec,LuChoInt)
*
*----------------------------------------------------------------------*
*     exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

      Subroutine put_temp_data_on_intgrl(LUINTMZ_, NSYMZ_, NORBZ_,
     &                                   NISHZ_, NASHZ_  )
      Implicit None
      Integer ::       LUINTMZ_, NSYMZ_
      Integer ::       NORBZ_(8), NISHZ_(8), NASHZ_(8)
      Integer ::       nLength, iAddress, i
#include "intgrl.fh"
      iAddress=0
      IAD2M(1:3,1:36*36)=0
      nLength=3*36*36
      ! read the address list from the existing file
      Call iDaFile(LUINTMZ_,2,IAD2M,nLength,iAddress)
      NSYMZ=NSYMZ_
      LUINTMZ=LUINTMZ_
      Do i=1,NSYMZ_
        NORBZ(i) = NORBZ_(i)
      End Do
      Return
* Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer_array(NISHZ_)
        Call Unused_integer_array(NASHZ_)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function Eval_RMin(Alpha,m,R_H)
      Implicit Real*8 (a-h,o-z)
#include "itmax.fh"
#include "real.fh"
      Real*8 Eval_RMin, ln_x
*     Write (6,*) 'Alpha,m,R_H=',
*    &            Alpha,m,R_H
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute r_1 as a function of m and R_H
*
*     Eq(25) R. Lindh, P.-A. Malmqvist, L. Gagliardi,
*     TCA, 106:178-187 (2001)
*
      D_m=-4.0D0
      If (m.eq. 4) D_m=-2.3D0
      If (m.eq. 2) D_m=-1.0D0
      If (m.eq. 0) D_m= 1.9D0
      If (m.eq.-2) D_m= 9.1D0
*
*     x = alpha * (r_1)**2
*
      ln_x=(Two/(DBLE(m)+Three))*( D_m- LOG(One/R_H) )
*
      R_Min=Sqrt(Exp(ln_x)/Alpha)
*
      Eval_RMin = R_Min
*     Write (*,*) 'Eval_RMin=',Eval_RMin
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_PTS_Final(NVT,l_NVT)
!
! Thomas Bondo Pedersen, April 2010.

use Cholesky, only: NumCho_G, NumChT_G
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: l_NVT, NVT(l_NVT)

NumCho_G(1:l_NVT) = NVT(:)
NumChT_G = sum(NumCho_G(1:l_NVT))
call Cho_Final(.false.)

end subroutine Cho_PTS_Final

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000-2016, Valera Veryazov                             *
!***********************************************************************
!*****************************************************************************
!                                                                            *
! Author:   Valera Veryazov 2000-2016                                        *
!           Theoretical Chemistry                                            *
!           Lund University                                                  *
!           Sweden                                                           *
!                                                                            *
!*****************************************************************************

subroutine WhichMolcas(Molcas)
!  if MOLCAS_STAMP='Alone'
!     get value of MOLCAS.

implicit none
character(len=*), intent(out) :: Molcas

Molcas = ' '
call getenvf('MOLCAS_STAMP',Molcas)
if (Molcas(1:1) /= 'A') then
  Molcas = ' '
  return
end if

Molcas = ' '
call getenvf('MOLCAS',Molcas)

return

end subroutine WhichMolcas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine sortindxr_cvb(n,arrin,indx)
      implicit real*8 (a-h,o-z)
      dimension arrin(n),indx(n)
c -- purpose: indexing arrin so that arrin(indx(j)), j=1..n is in
c    ascending numerical order.
c    method is heapsort, see also subroutine hpsort.
c -- taken from numerical recipies, p 233.
      do 11 j=1,n
        indx(j)=j
  11  continue
      if(n.le.1) return
      l=n/2+1
      ir=n
  10  continue
        if(l.gt.1) then
          l=l-1
          indxt=indx(l)
          q=arrin(indxt)
        else
          indxt=indx(ir)
          q=arrin(indxt)
          indx(ir)=indx(1)
          ir=ir-1
          if(ir.eq.1) then
            indx(1)=indxt
            return
          end if
        end if
        i=l
        j=2*l
  20    if(j.le.ir) then
          if(j.lt.ir) then
            if(arrin(indx(j)).lt.arrin(indx(j+1))) j=j+1
          end if
          if(q.lt.arrin(indx(j))) then
            indx(i)=indx(j)
            i=j
            j=2*j
          else
            j=ir+1
          end if
        goto 20
        end if
        indx(i)=indxt
      goto 10
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Markus P. Fuelscher                              *
!***********************************************************************

subroutine PrInp_MBPT2(Eocc,Eext,iTst)
!***********************************************************************
!                                                                      *
!     Print the program banner, date and time of execution             *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1992                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use MBPT2_Global, only: iDel, iFro, iPL, nBas, nDel1, nDel2, nDsto, nFro1, nFro2, nTit, Title
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Eocc(*), Eext(*)
integer(kind=iwp), intent(in) :: iTst
integer(kind=iwp) :: i, ii, iOrb, iSym, k, left, lLine, lPaper, nLine
logical(kind=iwp) :: lFro, lDel
character(len=3) :: lIrrep(8)
character(len=8) :: Fmt1, Fmt2
character(len=120) :: Line, StLine
character(len=102) :: XLine
#include "corbinf.fh"

!----------------------------------------------------------------------*
!     Start and define the paper width                                 *
!----------------------------------------------------------------------*
lPaper = 132
!----------------------------------------------------------------------*
!     Initialize header lines                                          *
!----------------------------------------------------------------------*
lLine = len(Line)
do i=1,lLine
  StLine(i:i) = '*'
end do
lPaper = 132
left = (lPaper-lLine)/2
write(Fmt1,'(A,I3.3,A)') '(',left,'X,A)'
write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
!----------------------------------------------------------------------*
!     Print the project title                                          *
!----------------------------------------------------------------------*
if (nTit > 0) then
  write(u6,*)
  nLine = nTit+5
  do i=1,nLine
    Line = ''
    if ((i == 1) .or. (i == nLine)) Line = StLine
    if (i == 3) Line = 'Project:'
    if ((i >= 4) .and. (i <= nLine-2)) then
      Line = Title(i-3)
    end if
    call Center_Text(Line)
    write(u6,Fmt1) '*'//Line//'*'
  end do
  write(u6,*)
end if
!----------------------------------------------------------------------*
!     Print the coordinates of the system                              *
!----------------------------------------------------------------------*
if (iPL >= 2) call PrCoor()
!----------------------------------------------------------------------*
!     Print contents of the runfile RUNFILE                            *
!----------------------------------------------------------------------*

call Get_cArray('Irreps',lIrrep,24)
do iSym=1,nSym
  lIrrep(iSym) = adjustr(lIrrep(iSym))
end do

if (iPL >= 2) then
  write(u6,*)
  write(u6,Fmt2//'A)') 'Contents of RUNFILE file:'
  write(u6,Fmt2//'A)') '-------------------------'
  write(u6,*)
  write(u6,Fmt2//'A,T47,8I4)') 'Symmetry species',(iSym,iSym=1,nSym)
  write(u6,Fmt2//'A,T47,8(1X,A))') '                ',(lIrrep(iSym),iSym=1,nSym)
  write(u6,Fmt2//'A,T47,8I4)') 'Number of basis functions',(nBas(iSym),iSym=1,nSym)
  write(u6,Fmt2//'A,T47,8I4)') 'Frozen occupied orbitals',(nFro(iSym),iSym=1,nSym)
  write(u6,Fmt2//'A,T47,8I4)') 'Active occupied orbitals',(nOcc(iSym),iSym=1,nSym)
  write(u6,Fmt2//'A,T47,8I4)') 'Active external orbitals',(nExt(iSym),iSym=1,nSym)
  write(u6,Fmt2//'A,T47,8I4)') 'Deleted external orbitals',(nDel(iSym),iSym=1,nSym)
end if
!----------------------------------------------------------------------*
!     ordering and orbital energies of the frozen occupied orbitals    *
!----------------------------------------------------------------------*
lFro = .false.
do iSym=1,nSym
  if (nFro1(iSym)+nFro2(iSym) /= 0) lFro = .true.
end do
if (iPL >= 2) then
  if (lFro) then
    write(u6,*)
    write(u6,*)
    write(u6,Fmt2//'A,T47)') 'Reference numbers of frozen occupied orbitals according to the original input sequence'
    do iSym=1,nSym
      if (nFro1(iSym) /= 0) then
        write(u6,Fmt2//'A,I2,T47,20I3,(/T49,20I3))') 'symmetry species',iSym,(iOrb,iOrb=1,nFro1(iSym))
      end if
      if (nFro2(iSym) /= 0) then
        write(u6,Fmt2//'A,I2,T47,20I3,(/T49,20I3))') 'symmetry species',iSym,(iFro(iSym,iOrb),iOrb=1,nFro2(iSym))
      end if
    end do
  end if
  write(u6,*)
  write(u6,*)
  write(u6,Fmt2//'A,T47)') 'Energies of the active occupied orbitals'
  ii = 0
  do iSym=1,nSym
    if (nOcc(iSym) /= 0) then
      write(u6,*)
      write(u6,Fmt2//'A,I2,(T40,5F14.6))') 'symmetry species',iSym,(Eocc(ii+k),k=1,nOcc(iSym))
      ii = ii+nOcc(iSym)
    end if
  end do
end if
!----------------------------------------------------------------------*
!     ordering and orbital energies of the deleted external orbitals   *
!----------------------------------------------------------------------*
lDel = .false.
do iSym=1,nSym
  if (nDel(iSym)+nDel1(iSym)+nDel2(iSym) /= 0) lDel = .true.
end do
if (iPL >= 2) then
  if (lDel) then
    write(u6,*)
    write(u6,*)
    write(u6,Fmt2//'A,T47)') 'Reference numbers of deleted external orbitals according to the original input sequence'
    do iSym=1,nSym
      if ((nDel1(iSym) /= 0) .or. (nDsto(iSym) /= 0)) then
        write(u6,Fmt2//'A,I2,T47,20I3,(/T49,20I3))') 'symmetry species',iSym, &
                                                     (nBas(iSym)-nFro(iSym)-nOcc(iSym)-iOrb+1,iOrb=nDsto(iSym)+nDel1(iSym),1,-1)
      end if
      if (nDel2(iSym) /= 0) then
        write(u6,Fmt2//'A,I2,T47,20I3,(/T49,20I3))') 'symmetry species',iSym,(iDel(iSym,iOrb),iOrb=1,nDel2(iSym))
      end if
    end do
  end if
  write(u6,*)
  write(u6,*)
  write(u6,Fmt2//'A,T47)') 'Energies of the active external orbitals'
  ii = 0
  do iSym=1,nSym
    if (nExt(iSym) /= 0) then
      write(u6,*)
      write(u6,Fmt2//'A,I2,(T40,5F14.6))') 'symmetry species',iSym,(Eext(ii+k),k=1,nExt(iSym))
      ii = ii+nExt(iSym)
    end if
  end do
end if
!----------------------------------------------------------------------*
!     print header for final results                                   *
!----------------------------------------------------------------------*
if ((iTst == 0) .and. (iPL >= 2)) then
  write(u6,*)
  write(u6,*)
  nLine = 3
  do i=1,nLine
    XLine = ''
    if ((i == 1) .or. (i == nLine)) XLine = trim(StLine)
    if (i == 2) XLine = 'Results'
    call Center_Text(XLine)
    write(u6,Fmt1) '*'//XLine//'*'
  end do
  write(u6,*)
end if
!----------------------------------------------------------------------*
!     Normal termination                                               *
!----------------------------------------------------------------------*
return

end subroutine PrInp_MBPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
************************************************************************
      SUBROUTINE TRACHO2(CMO,DREF,FFAO,FIAO,FAAO,IF_TRNSF)
      USE CHOVEC_IO
      use ChoArr, only: nDimRS
      use ChoSwp, only: InfVec
      IMPLICIT NONE
* ----------------------------------------------------------------
#include "rasdim.fh"
#include "warnings.h"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "chocaspt2.fh"
#include "choglob.fh"
#include "WrkSpc.fh"
************************************************************************
*  Author : P. A. Malmqvist
************************************************************************
      REAL*8 CMO(NBSQT),DREF(NDREF),
     &       FFAO(NBTRI),FIAO(NBTRI),FAAO(NBTRI)
      LOGICAL IF_TRNSF

      INTEGER NCES(8),ip_HTVec(8)
      INTEGER ISTART(8),NUSE(8)

      REAL*8 E,ECORE1,ECORE2

      REAL*8 FACTC,FACTXA,FACTXI

      INTEGER I,J,IC,IA,ICASE,IRC,ILOC
      INTEGER JSTART
      INTEGER JRED,JRED1,JRED2,JREDC,JNUM,JV1,JV2
      INTEGER IASTA,IAEND,IISTA,IIEND
      INTEGER NA,NASZ,NI,NISZ,NBUFFY,NF,NK,NW,NPQ,NRS
      INTEGER IB,IBATCH,IBATCH_TOT,IBSTA,IBEND,NB,NBATCH
      INTEGER IDFIJ,IDIIJ,IDAIJ
      INTEGER IP_LFT,IP_LHT
      INTEGER IPDA,IPDA_RED,IPDF,IPDF_RED,IPDI,IPDI_RED
      INTEGER LC,LCNAT,LO,LOCC,LSC,LSO
      INTEGER LFA_RED,LFF_RED,LFI_RED
      INTEGER ISFA,ISFF,ISFI
      INTEGER ISYM,JSYM,ISYMA,ISYMB,ISYMK,ISYMW,ISYP,ISYQ
      INTEGER N,N1,N2
      INTEGER ip_buffy,ip_chspc,ip_ftspc,ip_htspc,ip_v
      INTEGER NUMV,NVECS_RED,NHTOFF,MUSED

      REAL*8 SCL

      REAL*8, EXTERNAL :: DDOT_

************************************************************************
* ======================================================================
* This section deals with density matrices and CMO''s
* Offsets into CMO arrays:
      IC=0
      DO ISYM=1,NSYM
       NCES(ISYM)=IC
       IC=IC+NBAS(ISYM)**2
      END DO

* Compute natural orbitals for the reference wave function:
      Call Getmem('OCC','ALLO','REAL',LOCC,NBasT)
      Call Getmem('CNAT','ALLO','REAL',LCNAT,NBSQT)
*      write(6,*)' Active/Active density matrix, triangular'
*      IF( NASHT.GT.0 ) THEN
*        call TRIPRT(' ',' ',DREF,NASHT)
*      ENDIF
      CALL REF_NATO(DREF,CMO,WORK(LOCC),WORK(LCNAT))

c Initialize Fock matrices in AO basis to zero:
      CALL DCOPY_(NBTRI,[0.0D0],0,FFAO,1)
      CALL DCOPY_(NBTRI,[0.0D0],0,FIAO,1)
      CALL DCOPY_(NBTRI,[0.0D0],0,FAAO,1)
* Construct density matrix for frozen orbitals
      Call Getmem('DF','ALLO','REAL',ipDF,NBTRI)
      DO ISYM=1,NSYM
       ISTART(ISYM)=1
       NUSE(ISYM)=NFRO(ISYM)
      END DO
      CALL GDMAT(NSYM,NBAS,ISTART,NUSE,
     &                          WORK(LCNAT),WORK(LOCC),WORK(IPDF))
* Construct density matrix for inactive orbitals
      Call Getmem('DI','ALLO','REAL',ipDI,NBTRI)
      DO ISYM=1,NSYM
       ISTART(ISYM)=NFRO(ISYM)+1
       NUSE(ISYM)=NISH(ISYM)
      END DO
      CALL GDMAT(NSYM,NBAS,ISTART,NUSE,
     &                          WORK(LCNAT),WORK(LOCC),WORK(IPDI))
* Same, for active density:
      Call Getmem('DA ','ALLO','REAL',ipDA ,NBTRI)
      DO ISYM=1,NSYM
       ISTART(ISYM)=NFRO(ISYM)+NISH(ISYM)+1
       NUSE(ISYM)=NASH(ISYM)
      END DO
      CALL GDMAT(NSYM,NBAS,ISTART,NUSE,
     &                          WORK(LCNAT),WORK(LOCC),WORK(IPDA ))
* The Cholesky routines want density matrices in a particular storage, and
* also the off-diagonal elements should be doubled. Double them:
      IDFIJ=IPDF
      IDIIJ=IPDI
      IDAIJ=IPDA
      DO ISYM=1,NSYM
       DO I=1,NBAS(ISYM)
        DO J=1,I-1
         WORK(IDFIJ)=2.0D0*WORK(IDFIJ)
         WORK(IDIIJ)=2.0D0*WORK(IDIIJ)
         WORK(IDAIJ)=2.0D0*WORK(IDAIJ)
         IDFIJ=IDFIJ+1
         IDIIJ=IDIIJ+1
         IDAIJ=IDAIJ+1
        END DO
        IDFIJ=IDFIJ+1
        IDIIJ=IDIIJ+1
        IDAIJ=IDAIJ+1
       END DO
      END DO

* Scale natural orbitals by multiplying with square root of half the
* occupation number -- This allows computing the exchange contribution
* to Fock matrices using the same formula as for closed shells.
      LSO=LOCC
      LSC=LCNAT
      DO ISYM=1,NSYM
       NF=NFRO(ISYM)
       NI=NISH(ISYM)
       NA=NASH(ISYM)
       NB=NBAS(ISYM)
       LO=LSO+NF+NI
       LC=LSC+NB*(NF+NI)
       DO IA=1,NA
        SCL=SQRT(0.5D0*WORK(LO))
        CALL DSCAL_(NB,SCL,WORK(LC),1)
        LO=LO+1
        LC=LC+NB
       END DO
       LSO=LSO+NB
       LSC=LSC+NB**2
      END DO
* ======================================================================
      CALL GETMEM('CHSPC','ALLO','REAL',IP_CHSPC,NCHSPC)
      CALL GETMEM('HTSPC','ALLO','REAL',IP_HTSPC,NHTSPC)
      IF (IF_TRNSF) THEN
       CALL GETMEM('FTSPC','ALLO','REAL',IP_FTSPC,NFTSPC)
      END IF
* ======================================================================

      !IBATCH_TOT=0
* Loop over JSYM
      DO JSYM=1,NSYM
      IBATCH_TOT=NBTCHES(JSYM)

*     write(6,*)' Tracho2 JSYM=',JSYM
*     write(6,*)'    NUMCHO_PT2(JSYM)=',NUMCHO_PT2(JSYM)
      IF(NUMCHO_PT2(JSYM).EQ.0) GOTO 1000

      JRED1=InfVec(1,2,jSym)
      JRED2=InfVec(NumCho_PT2(jSym),2,jSym)
*     write(6,*)'tracho2:  JRED1,JRED2:',JRED1,JRED2

      IF(JSYM.EQ.1) THEN
* Allocate space for temporary vector 'V' used for Coulomb contrib to
* Fock matrices:
       CALL GETMEM('V_VECTOR','ALLO','REAL',IP_V,MXCHARR)
* Local density matrices, which will be needed if JSYM=1. At the same time,
* allocate Fock matrices with the same structure and initialize to zero.
       CALL GETMEM('DF_RED','ALLO','REAL',IPDF_RED,MXCHARR)
       CALL GETMEM('DI_RED','ALLO','REAL',IPDI_RED,MXCHARR)
       CALL GETMEM('DA_RED','ALLO','REAL',IPDA_RED,MXCHARR)
       CALL GETMEM('FF_RED','ALLO','REAL',LFF_RED,MXCHARR)
       CALL GETMEM('FI_RED','ALLO','REAL',LFI_RED,MXCHARR)
       CALL GETMEM('FA_RED','ALLO','REAL',LFA_RED,MXCHARR)
      END IF


* Loop over JRED
      DO JRED=JRED1,JRED2

      CALL Cho_X_nVecRS(JRED,JSYM,JSTART,NVECS_RED)
      IF(NVECS_RED.EQ.0) GOTO 999

      ILOC=3
      CALL CHO_X_SETRED(IRC,ILOC,JRED)
* For a reduced set, the structure is known, including
* the mapping between reduced index and basis set pairs.
* The reduced set is divided into suitable batches.
* First vector is JSTART. Nr of vectors in r.s. is NVECS_RED.
*      JEND=JSTART+NVECS_RED-1
*      write(6,*)'  JRED:  JSTART,JEND:',JRED,JSTART,JEND

      IF(JSYM.EQ.1) THEN
      NRS=NDIMRS(JSYM,JRED)
      CALL DCOPY_(NRS,[0.0D0],0,WORK(IPDF_RED),1)
      CALL full2red(Work(ipDF),Work(ipDF_Red))
      CALL DCOPY_(NRS,[0.0D0],0,WORK(IPDI_RED),1)
      CALL full2red(Work(ipDI),Work(ipDI_Red))
      CALL DCOPY_(NRS,[0.0D0],0,WORK(IPDA_RED),1)
      CALL full2red(Work(ipDA),Work(ipDA_Red))
      CALL DCOPY_(NRS,[0.0D0],0,WORK(LFF_RED),1)
      CALL DCOPY_(NRS,[0.0D0],0,WORK(LFI_RED),1)
      CALL DCOPY_(NRS,[0.0D0],0,WORK(LFA_RED ),1)
      END IF

* Determine batch length for this reduced set.
* Make sure to use the same formula as in the creation of disk
* address tables, etc, above:
      NBATCH=1+(NVECS_RED-1)/MXNVC

* Loop over IBATCH
      JV1=JSTART
      DO IBATCH=1,NBATCH
      IBATCH_TOT=IBATCH_TOT+1

      JNUM=NVLOC_CHOBATCH(IBATCH_TOT)
      JV2=JV1+JNUM-1

      JREDC=JRED
* Read a batch of reduced vectors
      CALL CHO_VECRD(WORK(IP_CHSPC),NCHSPC,JV1,JV2,JSYM,
     &                        NUMV,JREDC,MUSED)
      IF(NUMV.ne.JNUM) THEN
        write(6,*)' Rats! CHO_VECRD was called, assuming it to'
        write(6,*)' read JNUM vectors. Instead it returned NUMV'
        write(6,*)' vectors: JNUM, NUMV=',JNUM,NUMV
        write(6,*)' Back to the drawing board?'
        CALL QUIT(_RC_INTERNAL_ERROR_)
      END IF
      IF(JREDC.NE.JRED) THEN
        write(6,*)' Rats! It was assumed that the Cholesky vectors'
        write(6,*)' in HALFTRNSF all belonged to a given reduced'
        write(6,*)' set, but they don''t!'
        write(6,*)' JRED, JREDC:',JRED,JREDC
        write(6,*)' Back to the drawing board?'
        write(6,*)' Let the program continue and see what happens.'
      END IF

      IF (JSYM.EQ.1) THEN
* Coulomb contribution to Fock arrays.
* V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * D(rs)
* Starting at Work(IP_CHSPC) is now an array of vectors, conceptually
* L(rs,J), where temporarily we can regard J as ranging 1..JNUM, and
* the layout of pair indices rs is unknown ('reduced storage', a secret
* inside cholesky.) Compute array V(J) at temporary space ip_V:
       CALL DGEMV_('T',NRS,JNUM,1.0D0,WORK(IP_CHSPC),NRS,
     &            WORK(IPDF_RED),1,0.0D0,WORK(IP_V),1)
* F(rs){#J} <- F(rs){#J} + FactC * sum_J L(rs,{#J})*V{#J}
             FactC=1.0D0
       CALL DGEMV_('N',NRS,JNUM,FactC,WORK(IP_CHSPC),NRS,
     &             WORK(IP_V),1,1.0D0,WORK(LFF_RED),1)
* The same thing, now for the inactive and active density matrices:
       CALL DGEMV_('T',NRS,JNUM,1.0D0,WORK(IP_CHSPC),NRS,
     &            WORK(IPDI_RED),1,0.0D0,WORK(IP_V),1)
       CALL DGEMV_('N',NRS,JNUM,FactC,WORK(IP_CHSPC),NRS,
     &             WORK(IP_V),1,1.0D0,WORK(LFI_RED),1)
       CALL DGEMV_('T',NRS,JNUM,1.0D0,WORK(IP_CHSPC),NRS,
     &             WORK(IPDA_RED),1,0.0D0,WORK(IP_V),1)
       CALL DGEMV_('N',NRS,JNUM,FactC,WORK(IP_CHSPC),NRS,
     &             WORK(IP_V),1,1.0D0,WORK(LFA_RED),1)
*      write(6,*)' Finished Coulomb contributions to Fock matrix.'
*      write(6,*)' Frozen Fock mat at Work(LFF_RED)'
*      write(6,'(1x,8f10.4)')(Work(LFF_RED+i),i=0,nRS-1)
*      write(6,*)' Inactive Fock mat at Work(LFI_RED)'
*      write(6,'(1x,8f10.4)')(Work(LFI_RED+i),i=0,nRS-1)
*      write(6,*)' Active Fock matrix at Work(LFA_RED).'
*      write(6,'(1x,8f10.4)')(Work(LFA_RED+i),i=0,nRS-1)
      END IF

* Frozen half-transformation:
      NHTOFF=0
      DO ISYMA=1,NSYM
       ISYMB=MUL(ISYMA,JSYM)
       IP_HTVEC(ISYMA)=IP_HTSPC+NHTOFF
       ISTART(ISYMA)=1
       NUSE(ISYMA)=NFRO(ISYMA)
       NHTOFF=NHTOFF+NUSE(ISYMA)*NBAS(ISYMB)*JNUM
      END DO
      CALL HALFTRNSF(IRC,WORK(IP_CHSPC),NCHSPC,1,JV1,JNUM,JNUM,
     &     JSYM,JREDC,CMO,ISTART,NUSE,IP_HTVEC)
* Frozen contributions to exchange:
          FactXI=-1.0D0
          ISFF=1
          DO ISYMB=1,NSYM
           iSymk = MUL(jSym,iSymb)
C ---------------------------------------------------------------------
c *** Compute the LT part of the FROZEN exchange matrix ********
C     FF(ab) = FF(ab) + FactXI * sum_Jk  LkJ,a * LkJ,b
C ---------------------------------------------------------------------
           NK = NFRO(ISYMK)
           NB = NBAS(ISYMB)
           If (NB*NK.ne.0) Then
            CALL DGEMM_TRI('T','N',NB,NB,NK*JNUM,
     &                  FactXI,Work(ip_HTVec(iSymk)),NK*JNUM,
     &                  Work(ip_HTVec(iSymk)),NK*JNUM,
     &                  1.0D0,FFAO(ISFF),NB)
           EndIf
           ISFF = ISFF+(NB*(NB+1))/2
          END DO

* Inactive half-transformation:
* Vectors of type HALF(K,J,B) = Sum(CHO(AB,J)*CMO(A,K) where
* A,B are basis functions of symmetry ISYMA, ISYMB,
* K is inactive of symmetry ISYMA, J is vector number in 1..NUMV
* numbered within the present batch.
* Symmetry block ISYMA,ISYMB is found at WORK(IP_HTVEC(ISYMA)
      NHTOFF=0
      DO ISYMA=1,NSYM
       ISYMB=MUL(ISYMA,JSYM)
       IP_HTVEC(ISYMA)=IP_HTSPC+NHTOFF
       ISTART(ISYMA)=NFRO(ISYMA)+1
       NUSE(ISYMA)=NISH(ISYMA)
       NHTOFF=NHTOFF+NUSE(ISYMA)*NBAS(ISYMB)*JNUM
      END DO
      CALL HALFTRNSF(IRC,WORK(IP_CHSPC),NCHSPC,1,JV1,JNUM,JNUM,
     &     JSYM,JREDC,CMO,ISTART,NUSE,IP_HTVEC)
* Inactive contributions to exchange:
          FactXI=-1.0D0
          ISFI=1
          DO ISYMB=1,NSYM
           iSymk = MUL(jSym,iSymb)
C ---------------------------------------------------------------------
c *** Compute the LT part of the INACTIVE exchange matrix ********
C     FI(ab) = FI(ab) + FactXI * sum_Jk  LkJ,a * LkJ,b
C ---------------------------------------------------------------------
           NK = NISH(iSymk)
           NB = NBAS(ISYMB)
           If (NB*NK.ne.0) Then
           CALL DGEMM_TRI('T','N',NB,NB,NK*JNUM,
     &                   FactXI,Work(ip_HTVec(iSymk)),NK*JNUM,
     &                   Work(ip_HTVec(iSymk)),NK*JNUM,
     &                   1.0D0,FIAO(ISFI),NB)
           EndIf
           ISFI = ISFI+(NB*(NB+1))/2
          END DO
*      write(6,*)' Inactive Fock mat in FIAO'
*      write(6,'(1x,8f10.4)')(FIAO(i),i=1,nbtri)

      IF (IF_TRNSF) THEN
* Loop over ISYQ
      DO ISYQ=1,NSYM
       ISYP=MUL(ISYQ,JSYM)

       N=NBAS(ISYP)
* ---------------------------------------------------
       N1=NASH(ISYP)
       N2=NISH(ISYQ)
       IC=1+NCES(ISYP) +(NFRO(ISYP)+NISH(ISYP))*N
       IP_LHT=IP_HTVEC(ISYQ)
       IP_LFT=IP_FTSPC
*   Compute fully transformed TK
       IF(N1*N2.GT.0) THEN
        CALL FULLTRNSF(N1,N2,N,CMO(IC),JNUM,WORK(IP_LHT),WORK(IP_LFT))
        CALL CHOVEC_SAVE(WORK(IP_LFT),1,ISYQ,JSYM,IBATCH_TOT)
       END IF
* ---------------------------------------------------
       N1=NSSH(ISYP)
       N2=NISH(ISYQ)
       IC=1+NCES(ISYP) +(NFRO(ISYP)+NISH(ISYP)+NASH(ISYP))*N
       IP_LHT=IP_HTVEC(ISYQ)
       IP_LFT=IP_FTSPC
*   Compute fully transformed AK
       IF(N1*N2.GT.0) THEN

C     CALL FULLTRNSF(N1,N2,N,CMO(IC),JNUM,WORK(IP_LHT),WORK(IP_LFT))

C =SVC= modified for using boxed ordering of pairs, note that the boxed
C routine is less efficient than the original one (loop over J values)
        NA=N1
        NI=N2
C Allocate memory for small buffer used in FULLTRNSF_BOXED
        NBUFFY=NA*NI
        CALL GETMEM('BUFFY','ALLO','REAL',IP_BUFFY,NBUFFY)
C Loop over boxes
        DO IASTA=1,NA,nSecBX
         IAEND=MIN(IASTA-1+nSecBX,NA)
         NASZ=1+IAEND-IASTA
         DO IISTA=1,NI,nInaBX
          IIEND=MIN(IISTA-1+nInaBX,NI)
          NISZ=1+IIEND-IISTA
C =SVC= note that WITHIN this box, the index of the outer box A (P in
C the FULLTRNSF subroutine, i.e. the secondary orbital index) is the
C fast-running index, as LFT([A],[I],J) = CMO(P,[A])^T * LHT([I],J,P)^T
C with P=1,NB.  So if used in e.g. ADDRHS as BRA(c,l,J), making an inner
C loop over secondary orbital index c is more efficient.
          CALL FULLTRNSF_BOXED (IASTA,IISTA,NASZ,NISZ,NA,NI,
     &                          N,CMO(IC+N*(IASTA-1)),JNUM,
     &                          WORK(IP_LHT),WORK(IP_LFT),
     &                          WORK(IP_BUFFY))
         ENDDO
        ENDDO
        CALL GETMEM('BUFFY','FREE','REAL',IP_BUFFY,NBUFFY)
        CALL CHOVEC_SAVE(WORK(IP_LFT),4,ISYQ,JSYM,IBATCH_TOT)
       END IF
* ---------------------------------------------------
* End loop ISYQ
      END DO
      END IF
* Active scaled natural orbitals half-transformation:
* Vectors of type HALF(W,J,B) = Sum(CHO(AB,J)*CMO(A,W) where
* A,B are basis functions of symmetry ISYMA, ISYMB,
* W is active of symmetry ISYMA, J is vector number in 1..NUMV
* numbered within the present batch.
* Symmetry block ISYMA,ISYMB is found at WORK(IP_HTVEC(ISYMA)
      NHTOFF=0
      DO ISYMA=1,NSYM
       ISYMB=MUL(ISYMA,JSYM)
       IP_HTVEC(ISYMA)=IP_HTSPC+NHTOFF
       ISTART(ISYMA)=NFRO(ISYMA)+NISH(ISYMA)+1
       NUSE(ISYMA)=NASH(ISYMA)
       NHTOFF=NHTOFF+NUSE(ISYMA)*NBAS(ISYMB)*JNUM
      END DO
      CALL HALFTRNSF(IRC,WORK(IP_CHSPC),NCHSPC,1,JV1,JNUM,JNUM,
     &    JSYM,JREDC,WORK(LCNAT),ISTART,NUSE,IP_HTVEC)
* Active (scaled) contributions to exchange:
      FactXA=-1.0D0
      ISFA=1
      DO ISYMB=1,NSYM
       iSymw = MUL(jSym,iSymb)
C ---------------------------------------------------------------------
c *** Compute the LT part of the ACTIVE exchange matrix ********
C     FA(ab) = FA(ab) + FactXA * sum_Jw  LwJ,a * LwJ,b
C ---------------------------------------------------------------------
       NW = NASH(iSymw)
       NB = NBAS(ISYMB)
       If (NB*NW.ne.0) Then
       CALL DGEMM_TRI('T','N',NB,NB,NW*JNUM,
     &               FactXA,Work(ip_HTVec(iSymw)),NW*JNUM,
     &               Work(ip_HTVec(iSymw)),NW*JNUM,
     &               1.0D0,FAAO(ISFA),NB)
       EndIf
       ISFA = ISFA+(NB*(NB+1))/2
      END DO

*      write(6,*)' Active Fock matrix in FAAO.'
*      write(6,'(1x,8f10.4)')(FAAO(i),i=1,nbtri)

* ---------------------------------------------------
* Active half-transformation:
      CALL HALFTRNSF(IRC,WORK(IP_CHSPC),NCHSPC,1,JV1,JNUM,JNUM,
     &    JSYM,JREDC,CMO,ISTART,NUSE,IP_HTVEC)


      IF (IF_TRNSF) THEN
      DO ISYQ=1,NSYM
       ISYP=MUL(ISYQ,JSYM)

       N=NBAS(ISYP)
* ---------------------------------------------------
* Loop over ISYQ
       N1=NASH(ISYP)
       N2=NASH(ISYQ)
       IC=1+NCES(ISYP) +(NFRO(ISYP)+NISH(ISYP))*N
       IP_LHT=IP_HTVEC(ISYQ)
       IP_LFT=IP_FTSPC
* Compute fully transformed TV
       IF(N1*N2.GT.0) THEN
        CALL FULLTRNSF(N1,N2,N,CMO(IC),JNUM,WORK(IP_LHT),WORK(IP_LFT))
        CALL CHOVEC_SAVE(WORK(IP_LFT),2,ISYQ,JSYM,IBATCH_TOT)
       END IF
* ---------------------------------------------------
       N1=NSSH(ISYP)
       N2=NASH(ISYQ)
       IC=1+NCES(ISYP) +(NFRO(ISYP)+NISH(ISYP)+NASH(ISYP))*N
       IP_LHT=IP_HTVEC(ISYQ)
       IP_LFT=IP_FTSPC
*   Compute fully transformed AV
       IF(N1*N2.GT.0) THEN
        CALL FULLTRNSF(N1,N2,N,CMO(IC),JNUM,WORK(IP_LHT),WORK(IP_LFT))
        CALL CHOVEC_SAVE(WORK(IP_LFT),3,ISYQ,JSYM,IBATCH_TOT)
       END IF
* ---------------------------------------------------
* End loop ISYQ
      END DO
      END IF

* 800  CONTINUE
* End loop IBATCH
       JV1=JV1+JNUM
      END DO

      IF (jSym.eq.1) THEN
* Add Coulomb contributions in local Fock matrices (in 'reduced storage')
* into the global ones:
        CALL red2full(FFAO,Work(LFF_RED))
        CALL red2full(FIAO,Work(LFI_RED))
        CALL red2full(FAAO,Work(LFA_RED))
      END IF
* End loop JRED
  999 CONTINUE
      END DO

      IF (jSym.eq.1) THEN
* Deallocate local density and fock matrices
        CALL GETMEM('V_VECTOR','FREE','REAL',IP_V,MXCHARR)
        CALL GETMEM('DF_RED','FREE','REAL',IPDF_RED,MXCHARR)
        CALL GETMEM('DI_RED','FREE','REAL',IPDI_RED,MXCHARR)
        CALL GETMEM('DA_RED','FREE','REAL',IPDA_RED,MXCHARR)
        CALL GETMEM('FF_RED','FREE','REAL',LFF_RED,MXCHARR)
        CALL GETMEM('FI_RED','FREE','REAL',LFI_RED,MXCHARR)
        CALL GETMEM('FA_RED','FREE','REAL',LFA_RED,MXCHARR)
      END IF
* End loop JSYM
 1000 CONTINUE
      END DO

      ! if using the RHS on-demand, we need all cholesky vectors on each
      ! process, collect them here
      IF (IF_TRNSF.AND.RHSDIRECT) THEN
        IP_LFT=IP_FTSPC
        DO JSYM=1,NSYM
          IBSTA=NBTCHES(JSYM)+1
          IBEND=NBTCHES(JSYM)+NBTCH(JSYM)
          DO IB=IBSTA,IBEND
            DO ISYQ=1,NSYM
              DO ICASE=1,4
                NPQ=NPQ_CHOTYPE(ICASE,ISYQ,JSYM)
                IF (NPQ.EQ.0) CYCLE
                CALL CHOVEC_LOAD(WORK(IP_LFT),ICASE,ISYQ,JSYM,IB)
                CALL CHOVEC_COLL(WORK(IP_LFT),ICASE,ISYQ,JSYM,IB)
              END DO
            END DO
          END DO
        END DO
      END IF

* Synchronize and add the contributions from all nodes into each node:
      CALL GADGOP(FFAO,NBTRI,'+')
      CALL GADGOP(FIAO,NBTRI,'+')
      CALL GADGOP(FAAO,NBTRI,'+')

* Two-electron contribution to the effective core energy
      ECORE2=0.5D0*DDOT_(NBTRI,WORK(IPDF),1,FFAO,1)
c Add OneHam to finalize frozen Fock matrix in AO basis.
c (It is in fact an effective one-electron Hamiltonian).
      CALL ADD1HAM(FFAO)
* The contraction of frozen Fock matrix with frozen density:
      E=DDOT_(NBTRI,WORK(IPDF),1,FFAO,1)
* Correct for double-counting two-electron part:
      E=E-ECORE2
* One-electron part:
      ECORE1=E-ECORE2
* Nuclear repulsion energy:
      ECORE=POTNUC+ECORE1+ECORE2

#ifdef _DEBUGPRINT_
       WRITE(6,'(6X,A,E20.10)') 'NUCLEAR REPULSION ENERGY:',POTNUC
       WRITE(6,'(6X,A,E20.10)') 'ONE-ELECTRON CORE ENERGY:',ECORE1
       WRITE(6,'(6X,A,E20.10)') 'TWO-ELECTRON CORE ENERGY:',ECORE2
       WRITE(6,'(6X,A,E20.10)') '       TOTAL CORE ENERGY:',ECORE
#endif

      Call Getmem('OCC','FREE','REAL',LOCC,NBasT)
      Call Getmem('CNAT','FREE','REAL',LCNAT,NBSQT)
      Call Getmem('DF','FREE','REAL',ipDF,NBTRI)
      Call Getmem('DI','FREE','REAL',ipDI,NBTRI)
      Call Getmem('DA ','FREE','REAL',ipDA ,NBTRI)

      CALL GETMEM('CHSPC','FREE','REAL',IP_CHSPC,NCHSPC)
      CALL GETMEM('HTSPC','FREE','REAL',IP_HTSPC,NHTSPC)
      IF (IF_TRNSF) THEN
       CALL GETMEM('FTSPC','FREE','REAL',IP_FTSPC,NFTSPC)
      END IF

#ifdef _DEBUGPRINT_
        WRITE(6,'(6X,A)')'TEST PRINT FROM TRACHO2.'
        WRITE(6,'(6X,A)')
        write(6,*)' NSYM:',NSYM
        write(6,*)' NBAS:',(NBAS(ISYM),ISYM=1,8)
        WRITE(6,'(6X,A)')
        WRITE(6,'(6X,A)')'***** FROZEN FOCK MATRIX ***** '
        ISFF=1
        DO ISYM=1,NSYM
          NB=NBAS(ISYM)
          IF( NB.GT.0 ) THEN
            WRITE(6,'(6X,A)')
            WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
            call TRIPRT(' ',' ',FFAO(ISFF),NB)
            ISFI=ISFF+(NB*(NB+1))/2
          ENDIF
        END DO
        WRITE(6,'(6X,A)')
        WRITE(6,'(6X,A)')'***** INACTIVE FOCK MATRIX ***** '
        ISFI=1
        DO ISYM=1,NSYM
          NB=NBAS(ISYM)
          IF( NB.GT.0 ) THEN
            WRITE(6,'(6X,A)')
            WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
            call TRIPRT(' ',' ',FIAO(ISFI),NB)
            ISFI=ISFI+(NB*(NB+1))/2
          ENDIF
        END DO
        WRITE(6,'(6X,A)')
        WRITE(6,'(6X,A)')'***** ACTIVE FOCK MATRIX ***** '
        ISFA=1
        DO ISYM=1,NSYM
          NB=NBAS(ISYM)
          IF( NB.GT.0 ) THEN
            WRITE(6,'(6X,A)')
            WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
            call TRIPRT(' ',' ',FAAO(ISFA),NB)
            ISFA=ISFA+(NB*(NB+1))/2
          ENDIF
        END DO
#endif

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine calcmagn1(N,E,M,T,MT,Z)
!-----------------------------------------------------------------------
! Input data:
!   N =  number of the states to be considered, scalar integer, input
!   E =  Zeeman energy of these states, array(N), real, input
!   M =  momentum of these states ( diagonal), complex array (N,N), input
!        ( only diagonal elements are used )
!   T =  scalar real number denoting temperature in K, real, input
! Output data:
!   MT=  computed momentum at temperature T, scalar real, output
!   Z =  Boltzmann statistical sum, real scalar
!-----------------------------------------------------------------------

use Constants, only: Zero, cm_s, hPlanck, kBoltzmann
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: E(N), T
complex(kind=wp), intent(in) :: M(N,N)
real(kind=wp), intent(out) :: MT, Z
integer(kind=iwp) :: i, im, mp1
real(kind=wp), parameter :: kB = kBoltzmann/(cm_s*hPlanck) ! in cm-1*K-1
!----------------------------------------------------------------------

Z = Zero
MT = Zero
im = 0
mp1 = 0
im = mod(N,11)

if (im /= 0) then
  do i=1,im !N   ! im
    Z = Z+exp(-(E(i)-E(1))/kB/T)
    MT = MT+exp(-(E(i)-E(1))/kB/T)*real(M(I,I))
  end do
  if (N < 11) then
    MT = MT/Z
    return
  end if
end if

mp1 = im+1
do i=mp1,N,11
  Z = Z+exp(-(E(i)-E(1))/kB/T)+exp(-(E(i+1)-E(1))/kB/T)+exp(-(E(i+2)-E(1))/kB/T)+exp(-(E(i+3)-E(1))/kB/T)+ &
      exp(-(E(i+4)-E(1))/kB/T)+exp(-(E(i+5)-E(1))/kB/T)+exp(-(E(i+6)-E(1))/kB/T)+exp(-(E(i+7)-E(1))/kB/T)+ &
      exp(-(E(i+8)-E(1))/kB/T)+exp(-(E(i+9)-E(1))/kB/T)+exp(-(E(i+10)-E(1))/kB/T)

  MT = MT+exp(-(E(i)-E(1))/kB/T)*real(M(i,i))+exp(-(E(i+1)-E(1))/kB/T)*real(M(i+1,i+1))+exp(-(E(i+2)-E(1))/kB/T)*real(M(i+2,i+2))+ &
       exp(-(E(i+3)-E(1))/kB/T)*real(M(i+3,i+3))+exp(-(E(i+4)-E(1))/kB/T)*real(M(i+4,i+4))+ &
       exp(-(E(i+5)-E(1))/kB/T)*real(M(i+5,i+5))+exp(-(E(i+6)-E(1))/kB/T)*real(M(i+6,i+6))+ &
       exp(-(E(i+7)-E(1))/kB/T)*real(M(i+7,i+7))+exp(-(E(i+8)-E(1))/kB/T)*real(M(i+8,i+8))+ &
       exp(-(E(i+9)-E(1))/kB/T)*real(M(i+9,i+9))+exp(-(E(i+10)-E(1))/kB/T)*real(M(i+10,i+10))
end do

MT = MT/Z

return

end subroutine calcmagn1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996,1997, Bernd Schimmelpfennig                       *
************************************************************************
Change start
c     program amfi
c     implicit real*8 (a-h,o-z)
Change else
      Subroutine amfi(IN,LUPROP,iCenter)
      implicit Real*8 (a-h,o-z)
Change end
c###########################################################################
c
c          A M F I
c
c    Atomic Mean-Field Spin-Orbit Integral Program
c
c Integral-code to generate the one- and two-electron spin-orbit integrals
c in the no-pair approximation for an atom.
c
c basis set is built by atomic functions of the form:
c
c     f(r,Omega)= r**l Y_(lm) (Omega)
c
c Allthough the code is created with a lot of care and love for
c the details, the author doesn't give any warranty for it's
c correctness.
c
c B.Schimmelpfennig  Fysikum/Stockholm Summer 1996
c
c If you use this code, please honour the authors work
c by citing this work properly.
c
c The author would like to thank the Deutsche Forschungsgemeinschaft
c for financing this project by a Forschungsstipendium.
c
c
c   The spatial integrals are expected to be used with a spin part
c   expressed in Paulis spin-matrices rather than with the Spin-operator
c   itself. So if a factor of two is somehow missing, check whether the
c   same form of the operator is used.
c
c
c   WARNING !!!   WARNING !!   WARNING !!  WARNING !!   WARNING !!
c
c   when writing spin-same-orbit and spin-other-orbit with sigma_i:
c
c   For the spin-other-orbit-integrals particle 1 and 2 are exchanged
c   on the arrays carteXOO,carteYOO,carteZOO!!!!!!!!!
c
c   The reason is to use most of the same-orbit part again and to
c   have the same symmetry for the integrals on the arrays.
c
c
c   if the spin-other-orbit-part is used in the formulation with
c   sigma_j, the particles are of cause not interchanged.
c
c
c
c   (i|HSO_mean|j) = (ij) + 1/2 * sum_M  occ(M) {
c                   2(ij|MM)_same - (iM|jM)_same -2(iM|jM)_other
c                   + (jM|iM)_same +2(jM|iM)_other }
c
c   in the subroutines some signs are changed  to reorder indices
c   in the integrals to (iM|jM) or (Mi|Mj) accoding to the way they
c   were calculated before.
c
c
c
c   one-particle integrals (really one-particle or mean-field)
c   are written to files in CONTANDMULT. Look there for information on
c   the format of files.
c
c
c  BUGS:  There is still a strange sign-error in the two-electron-integrals
c  if one applies straight-forward the formulae of the documentation.
c  This problem has been solved by the the cheater...
c
c  Everybody is welcome to find the problem in the formulas ........
c
c  First reasonable results on Thallium (SD with frozen 5D) 14.10.96
c
c
c
c
c
c  Connection to MOLCAS:
c  How wonderful, they normalize the functions exactly as I do, which
c  means they use the correct linear combinations.
c
c  Exponents and coefficients are expected in the MOLCAS-Format
c  first exponents
c  coefficients afterwards
c
c                                           8.5.97
c
c
c###########################################################################
#include "para.fh"
      logical keep    ! parameter to decide about keeping angular
cbs                     ! integrals in memory
      logical keepcart    ! parameter to decide about keeping cartesian
cbs                         ! integrals in memory
      logical makemean   ! 'true' =   generating a meanfield
      logical bonn       ! 'true' = Bonn-approach for spin-other orbit
      logical breit      ! if breit is set, BREIT-PAULI only
      logical SAMEORB    ! parameter for same-orbit only
      logical AIMP       ! parameter to delete CORE for AIMP
      logical oneonly    ! parameter to use only oneelectron integrals
      character*4  symmetry
#include "datapow.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: oneoverR3(:), CartOne(:,:), OneContr(:),
     &                      CoulOvlp(:), PowExp(:), preY(:), preXZ(:)
      Integer, Allocatable:: checkxy(:), checkz(:), interxyz(:,:),
     &                       SgnProd(:)
*
      common /ipowxyz/ ipowxyz(3,-Lmax:Lmax,0:Lmax)
c##########################################################################
cbs  #####################################################################
cbs         version with all angular integrals in memory
c         keep=.true.
cbs  #####################################################################
cbs         version without  all angular integrals in memory
          keep=.false.
cbs  #####################################################################
cbs         version without  all cartesian integrals in memory
          keepcart=.false.
cbs  #####################################################################
cbs         version with all cartesian integrals in memory
c         keepcart=.true.
cbs  #####################################################################
      ifinite=0
cbs   initialize tables with double facultatives...
      call inidf
cbs   move some powers of x,y,z to the right place   BEGIN
cbs   check if Lpowmax is high enough..
      if (Lpowmax.lt.Lmax) then
      Call SysAbendMsg('amfi', 'increase lpowmax and edit ixyzpow',' ' )
      endif
      jrun=1
      do irun=0,Lmax
      do Mval=-irun,irun
      ipowxyz(1,Mval,irun)=ixyzpow(jrun)
      ipowxyz(2,Mval,irun)=ixyzpow(jrun+1)
      ipowxyz(3,Mval,irun)=ixyzpow(jrun+2)
      jrun=jrun+3
      enddo
      enddo
cbs   move some powers of x,y,z to the right place   END
cbs   read the input
      call readbas(Lhigh,makemean,bonn,breit,symmetry,sameorb,AIMP,
     &             oneonly,ncont4,numballcart,IN,ifinite)
cbs
      icartdim=mxcontL*MxcontL*(Lmax+Lmax+1)*(Lmax+1)*Lmax
      ionecontrdim=mxcontL*MxcontL*(2*Lmax+1)*3*Lmax
      ioneoverR3dim=Lmax*(MxprimL*MxprimL+MxprimL)/2
      ipowexpdim=MxprimL*MxprimL*(Lmax+1)*(Lmax+1)*(Lmax+Lmax+6)
      icoulovlpdim=MxprimL*MxprimL*(Lmax+1)*(Lmax+1)*10
      Call mma_allocate(oneoverR3,ioneoverR3dim,Label='oneoverR3')
      Call mma_allocate(cartone,icartdim,3,Label='cartone')
      Call mma_allocate(OneContr,ionecontrdim,Label='OneContr')
      Call mma_allocate(CoulOvlp,icoulovlpdim,Label='coulovlp')
      Call mma_allocate(PowExp,iPowExpDim,Label='PowExp')
      oneoverR3(:)=0.0D0
      cartone(:,:)=0.0D0
      OneContr(:)=0.0D0
      CoulOvlp(:)=0.0D0
      PowExp(:)=0.0D0
cbs
cbs
 123  if (ifinite.eq.2) call finite
cbs
cbs
! Lhigh is the highest l-value in the basis set
      if (makemean.and.(.not.oneonly).and.ifinite.le.1)
     &   call getAOs(Lhigh)
      call genpowers(Lhigh,PowExp,CoulOvlp)
!generate powers of exponents and overlaps
cbs   start generating modified contraction coefficients
cbs   generate starting adresses of contraction coefficients  on
cbs   contrarray
      call genstar(Lhigh)
cbs   generate ovlp of normalized primitives
      call genovlp(Lhigh,CoulOvlp)
      do lrun=0,Lhigh
cbs      cont(L) arranges all the contraction coefficients for a given
cbs      L-value and renormalizes them
         call cont(lrun,breit,ifinite)
      enddo
cbs
cbs        beginning the angular part
      if (.not.oneonly) then
CBS   write(6,*) '***************************************************'
CBS   write(6,*) '********   beginning the 2e-part ******************'
CBS   write(6,*) '***************************************************'
cbs
cbs  ###################################################################
cbs  ###################################################################
cbs  ###################################################################
cbs
cbs
      idim1=(2*Lmax+1)*(2*Lmax+1)*(2*Lmax+1)*(2*Lmax+1)
      idim2=(Lmax+1)*(Lmax+1)*(Lmax+1)*(Lmax+1)
      Call mma_allocate(preY,idim1,Label='preY')
      Call mma_allocate(preXZ,idim1,Label='preXZ')
      Call mma_allocate(checkxy,idim2,Label='CheckXY')
      Call mma_allocate(checkz,idim2,Label='CheckZ')
      Call mma_allocate(interxyz,16,idim2,Label='InterXYZ')
      Call mma_allocate(SgnProd,idim1,Label='SgnProd')
*
!     subroutine for angular part
*
      call angular(Lhigh,keep,keepcart,makemean,bonn,breit,
     &             sameorb,ifinite,
     &             cartone(1,1),cartone(1,2),cartone(1,3),
     &             PowExp,CoulOvlp,preXZ,preY,
     &             checkxy,checkz,InterXYZ,SgnProd)
*
      Call mma_deallocate(SgnProd)
      Call mma_deallocate(InterXYZ)
      Call mma_deallocate(CheckZ)
      Call mma_deallocate(CheckXY)
      Call mma_deallocate(preXZ)
      Call mma_deallocate(preY)
      endif
      if (ifinite.eq.1) then ! redo everything for finite core
CBS      write(6,*) 'once more the two-electron integrals'
         ifinite=2
         goto 123
      endif
cbs ####################################################################
cbs ####################################################################
cbs ####################################################################
CBS   write(6,*) '***************************************************'
CBS   write(6,*) '*******   beginning the 1-electron-part  **********'
CBS   write(6,*) '***************************************************'
*
cbs   The one-electron spin-orbit integrals
*
      call gen1overR3(Lhigh,oneoverR3)
*
!     1/r**3  for normalized functions
*
      call contandmult(Lhigh,makemean,AIMP,oneonly,numballcart,LUPROP,
     &                 ifinite,CartOne,OneContr,oneoverR3,iCenter)
*
cbs   multiplies radial integrals with l,m-dependent
cbs   factors and contraction coefficients
      Call mma_deallocate(CoulOvlp)
      Call mma_deallocate(PowExp)
      Call mma_deallocate(OneContr)
      Call mma_deallocate(CartOne)
      Call mma_deallocate(oneoverR3)
CBS   write(6,*) '***************************************************'
CBS   write(6,*) '*******   end of  the 1-electron-part    **********'
CBS   write(6,*) '***************************************************'
cbs ####################################################################
cbs ####################################################################
cbs ####################################################################
      Return
      End Subroutine Amfi
      subroutine finite
cbs
cbs   subroutine to set up parameters for finite nucleus. The
cbs   s-functions are replaced by just one exponent which models the
cbs   nucleus.
cbs
      implicit real*8(a-h,o-z)
#include "para.fh"
#include "param.fh"
      common /nucleus/ charge,Exp_finite
      noccorb(0)=1
      do l=1,lmax_occ
         noccorb(l)=0
      enddo
      occup(1,0)=-charge
      nprimit_keep=nprimit(0)
      ncontrac_keep=ncontrac(0)
      nprimit(0)=1
      ncontrac(0)=1
      exponents(1,0)=0.5d0*Exp_finite
      return
      end subroutine finite

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Free_GenANO()

use stdalloc, only: mma_deallocate
use Genano_globals, only: wSet, pDSym, tDsym, Ssym, Cmo, Occ, Cmo2, Occ2, Eps, BasName

implicit none

call mma_deallocate(wSet)
call mma_deallocate(pDsym)
call mma_deallocate(tDsym)
call mma_deallocate(Ssym)
call mma_deallocate(Cmo)
call mma_deallocate(Occ)
if (allocated(Cmo2)) call mma_deallocate(Cmo2)
if (allocated(Occ2)) call mma_deallocate(Occ2)
call mma_deallocate(Eps)
call mma_deallocate(BasName)

end subroutine Free_GenANO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CI_SELECT_MRCI(NREF,AREF,PLEN,NSEL,CISEL,NRROOT,IROOT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AREF(NREF,NREF),CISEL(NREF,*),IROOT(NRROOT)
      DIMENSION PLEN(NREF)
      IF(NSEL.EQ.0) RETURN
C SELECTION BY PROJECTION ONTO SPACE SPANNED BY CISEL VECTORS. IROOT()
C IS SET TO SELECT THE NRROOT VECTORS WITH MAX PROJECTED LENGTH.
      DO 140 J=1,NREF
        SUM=0.0D00
        DO 130 ISEL=1,NSEL
          SUM1=0.0D00
          DO 120 I=1,NREF
            SUM1=SUM1+AREF(I,J)*CISEL(I,ISEL)
120       CONTINUE
          SUM=SUM+SUM1**2
130     CONTINUE
        PLEN(J)=SUM+J*1.0D-12
140   CONTINUE
C SELECT BY MAGNITUDE OF PLEN:
      DO 160 J=1,NRROOT
        PMAX=PLEN(1)
        JMAX=1
        DO 150 JJ=2,NREF
          IF(PMAX.GE.PLEN(JJ)) GOTO 150
          PMAX=PLEN(JJ)
          JMAX=JJ
150     CONTINUE
        PLEN(JMAX)=-PMAX
160   CONTINUE
      I=0
      DO 170 IR=1,NREF
        PL=PLEN(IR)
        IF(PL.LT.0.0D00) THEN
          I=I+1
          IROOT(I)=IR
          PL=-PL
        END IF
        PLEN(IR)=PL-IR*1.0D-12
170   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine COMMWEW(IVEC,JVEC,DCOM)
! This subroutine is one of the components needed to compute the active/active
! transition density matrix elements for the two first-order vectors IVEC and
! JVEC.
! Adds, into the matrix DCOM, a correction obtained by commutation relations.
! Present assumption: The two vectors nr. IVEC and JVEC, stored on LUSOLV,
! are both in contravariant representation. Possibly, IVEC equals JVEC.

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use SUPERINDEX, only: KTGEU, KTGTU, KTU, KTUV
use EQSOLV, only: IDSMAT
use caspt2_global, only: LUSBT
use caspt2_module, only: IASYM, NAES, NASH, NASHT, NASUP, NISUP, NSYM, NTGEUES, NTGTUES, NTUES, NTUVES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC
real(kind=wp), intent(inout) :: DCOM(NASHT,NASHT)
integer(kind=iwp) :: ICASE, IDS, ISYM, ISYMT, ISYMTU, ISYMU, ISYMX, IT, ITABS, ITUX, ITUY, ITX1, ITX2, ITXU, ITY1, ITY2, ITYU, IU, &
                     IUABS, IX, IXABS, IXT, IXT1, IXT2, IXTU, IY, IYABS, IYT, IYT1, IYT2, IYTU, K000, NAS, NAS1, NAX, NCBLK, NIS, NS
real(kind=wp) :: PARTSUM, rSUM, SGN
real(kind=wp), allocatable :: CBLK(:), SMAT(:), TBLK(:)

do ICASE=1,11
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    NCBLK = NAS*NIS
    if (NCBLK == 0) cycle
    ! Allocate CBLK, TBLK
    call MMA_ALLOCATE(CBLK,NCBLK,Label='CBLK')
    call MMA_ALLOCATE(TBLK,NCBLK,Label='TBLK')
    ! First, read in the ICASE, ISYM block of coefficients from JVEC into CBLK:
    ! Note carefully, this is not a mistake: vector JVEC into CBLK it is!
    call RDBLKC(ISYM,ICASE,JVEC,CBLK,NCBLK)
    ! Allocate overlap matrix:
    NS = nTri_Elem(NAS)
    call MMA_ALLOCATE(SMAT,NS)
    IDS = IDSMAT(ISYM,ICASE)
    call DDAFILE(LUSBT,2,SMAT,NS,IDS)
    ! Compute TBLK as the covariant representation of vector JVEC, by multiplying
    ! with the overlap matrix. Then get rid of the overlap matrix.
    TBLK(:) = Zero
    call TRIMUL(NAS,NIS,One,SMAT,CBLK,NAS,TBLK,NAS)
    call MMA_DEALLOCATE(SMAT)
    ! Finally, if IVEC not equals JVEC, read in the contravariant block of vector
    ! IVEC into CBLK:
    if (IVEC /= JVEC) call RDBLKC(ISYM,ICASE,IVEC,CBLK,NCBLK)
    ! Finally, branch to the appropriate code section:

    select case (ICASE)
      case (1)
        ! Case 1 code section:
        K000 = NTUVES(ISYM)

        do ISYMX=1,NSYM
          NAX = NASH(ISYMX)
          do IX=1,NAX
            IXABS = NAES(ISYMX)+IX
            do IY=1,NAX
              IYABS = NAES(ISYMX)+IY

              rSUM = Zero
              ISYMTU = Mul(ISYMX,ISYM)
              do ITABS=1,NASHT
                ISYMT = IASYM(ITABS)
                ISYMU = Mul(ISYMT,ISYMTU)
                do IU=1,NASH(ISYMU)
                  IUABS = NAES(ISYMU)+IU

                  IYTU = KTUV(IYABS,ITABS,IUABS)-K000
                  IXTU = KTUV(IXABS,ITABS,IUABS)-K000
                  ITYU = KTUV(ITABS,IYABS,IUABS)-K000
                  ITXU = KTUV(ITABS,IXABS,IUABS)-K000
                  ITUY = KTUV(ITABS,IUABS,IYABS)-K000
                  ITUX = KTUV(ITABS,IUABS,IXABS)-K000

                  rSUM = rSUM+sum(CBLK(IXTU:IXTU+NAS*(NIS-1):NAS)*TBLK(IYTU:IYTU+NAS*(NIS-1):NAS)+ &
                                  CBLK(ITXU:ITXU+NAS*(NIS-1):NAS)*TBLK(ITYU:ITYU+NAS*(NIS-1):NAS)- &
                                  CBLK(ITUY:ITUY+NAS*(NIS-1):NAS)*TBLK(ITUX:ITUX+NAS*(NIS-1):NAS))

                end do
              end do
              DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)+rSUM

            end do
          end do
        end do

      case (2)
        ! Case 2 code section:
        do ISYMX=1,NSYM
          NAX = NASH(ISYMX)
          do IX=1,NAX
            IXABS = NAES(ISYMX)+IX
            do IY=1,NAX
              IYABS = NAES(ISYMX)+IY

              rSUM = Zero
              ISYMT = Mul(ISYMX,ISYM)
              do IT=1,NASH(ISYMT)
                ITABS = NAES(ISYMT)+IT
                if (ITABS >= IXABS) then
                  IXT = KTGEU(ITABS,IXABS)-NTGEUES(ISYM)
                else
                  IXT = KTGEU(IXABS,ITABS)-NTGEUES(ISYM)
                end if
                if (ITABS >= IYABS) then
                  IYT = KTGEU(ITABS,IYABS)-NTGEUES(ISYM)
                else
                  IYT = KTGEU(IYABS,ITABS)-NTGEUES(ISYM)
                end if
                PARTSUM = sum(CBLK(IXT:IXT+NAS*(NIS-1):NAS)*TBLK(IYT:IYT+NAS*(NIS-1):NAS))
                if (ITABS == IXABS) PARTSUM = Two*PARTSUM
                rSUM = rSUM+PARTSUM
              end do
              DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)+rSUM

            end do
          end do
        end do

      case (3)
        ! Case 3 code section:
        do ISYMX=1,NSYM
          NAX = NASH(ISYMX)
          do IX=1,NAX
            IXABS = NAES(ISYMX)+IX
            do IY=1,NAX
              IYABS = NAES(ISYMX)+IY

              rSUM = Zero
              ISYMT = Mul(ISYMX,ISYM)
              do IT=1,NASH(ISYMT)
                ITABS = NAES(ISYMT)+IT
                if (ITABS == IXABS) cycle
                if (ITABS == IYABS) cycle
                if (ITABS > IXABS) then
                  IXT = KTGTU(ITABS,IXABS)-NTGTUES(ISYM)
                  SGN = One
                else
                  IXT = KTGTU(IXABS,ITABS)-NTGTUES(ISYM)
                  SGN = -One
                end if
                if (ITABS > IYABS) then
                  IYT = KTGTU(ITABS,IYABS)-NTGTUES(ISYM)
                else
                  IYT = KTGTU(IYABS,ITABS)-NTGTUES(ISYM)
                  SGN = -SGN
                end if
                PARTSUM = sum(CBLK(IXT:IXT+NAS*(NIS-1):NAS)*TBLK(IYT:IYT+NAS*(NIS-1):NAS))
                rSUM = rSUM+SGN*PARTSUM

              end do
              DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)+rSUM

            end do
          end do
        end do

      case (4)
        ! Case 4 code section:
        K000 = NTUVES(ISYM)

        do ISYMX=1,NSYM
          NAX = NASH(ISYMX)
          do IX=1,NAX
            IXABS = NAES(ISYMX)+IX
            do IY=1,NAX
              IYABS = NAES(ISYMX)+IY

              rSUM = Zero
              ISYMTU = Mul(ISYMX,ISYM)
              do ITABS=1,NASHT
                ISYMT = IASYM(ITABS)
                ISYMU = Mul(ISYMT,ISYMTU)
                do IU=1,NASH(ISYMU)
                  IUABS = NAES(ISYMU)+IU

                  IYTU = KTUV(IYABS,ITABS,IUABS)-K000
                  IXTU = KTUV(IXABS,ITABS,IUABS)-K000
                  ITYU = KTUV(ITABS,IYABS,IUABS)-K000
                  ITXU = KTUV(ITABS,IXABS,IUABS)-K000
                  ITUY = KTUV(ITABS,IUABS,IYABS)-K000
                  ITUX = KTUV(ITABS,IUABS,IXABS)-K000

                  rSUM = rSUM-sum(CBLK(IYTU:IYTU+NAS*(NIS-1):NAS)*TBLK(IXTU:IXTU+NAS*(NIS-1):NAS)- &
                                  CBLK(ITXU:ITXU+NAS*(NIS-1):NAS)*TBLK(ITYU:ITYU+NAS*(NIS-1):NAS)+ &
                                  CBLK(ITUY:ITUY+NAS*(NIS-1):NAS)*TBLK(ITUX:ITUX+NAS*(NIS-1):NAS))

                end do
              end do
              DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)+rSUM

            end do
          end do
        end do

      case (5)
        ! Case 5 code section:
        NAS1 = NAS/2

        do ISYMX=1,NSYM
          NAX = NASH(ISYMX)
          do IX=1,NAX
            IXABS = NAES(ISYMX)+IX
            do IY=1,NAX
              IYABS = NAES(ISYMX)+IY

              rSUM = Zero
              ISYMT = Mul(ISYMX,ISYM)
              do IT=1,NASH(ISYMT)
                ITABS = NAES(ISYMT)+IT
                IXT1 = KTU(IXABS,ITABS)-NTUES(ISYM)
                IYT1 = KTU(IYABS,ITABS)-NTUES(ISYM)
                ITX1 = KTU(ITABS,IXABS)-NTUES(ISYM)
                ITY1 = KTU(ITABS,IYABS)-NTUES(ISYM)
                IXT2 = IXT1+NAS1
                IYT2 = IYT1+NAS1
                ITX2 = ITX1+NAS1
                ITY2 = ITY1+NAS1
                rSUM = rSUM+sum(CBLK(IXT1:IXT1+NAS*(NIS-1):NAS)*TBLK(IYT1:IYT1+NAS*(NIS-1):NAS)- &
                                CBLK(ITY1:ITY1+NAS*(NIS-1):NAS)*TBLK(ITX1:ITX1+NAS*(NIS-1):NAS)+ &
                                CBLK(IXT2:IXT2+NAS*(NIS-1):NAS)*TBLK(IYT2:IYT2+NAS*(NIS-1):NAS)- &
                                CBLK(ITY2:ITY2+NAS*(NIS-1):NAS)*TBLK(ITX2:ITX2+NAS*(NIS-1):NAS))
              end do
              DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)+rSUM

            end do
          end do
        end do

      case (6)
        ! Case 6 code section:
        NAX = NASH(ISYM)
        do IX=1,NAX
          IXABS = NAES(ISYM)+IX
          do IY=1,NAX
            IYABS = NAES(ISYM)+IY

            DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)+sum(CBLK(IX:IX+NAS*(NIS-1):NAS)*TBLK(IY:IY+NAS*(NIS-1):NAS))

          end do
        end do

      case (7)
        ! Case 7 code section:
        NAX = NASH(ISYM)
        do IX=1,NAX
          IXABS = NAES(ISYM)+IX
          do IY=1,NAX
            IYABS = NAES(ISYM)+IY

            DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)+sum(CBLK(IX:IX+NAS*(NIS-1):NAS)*TBLK(IY:IY+NAS*(NIS-1):NAS))

          end do
        end do

      case (8)
        ! Case 8 code section:
        do ISYMX=1,NSYM
          NAX = NASH(ISYMX)
          do IX=1,NAX
            IXABS = NAES(ISYMX)+IX
            do IY=1,NAX
              IYABS = NAES(ISYMX)+IY

              rSUM = Zero
              ISYMT = Mul(ISYMX,ISYM)
              do IT=1,NASH(ISYMT)
                ITABS = NAES(ISYMT)+IT
                if (ITABS >= IXABS) then
                  IXT = KTGEU(ITABS,IXABS)-NTGEUES(ISYM)
                else
                  IXT = KTGEU(IXABS,ITABS)-NTGEUES(ISYM)
                end if
                if (ITABS >= IYABS) then
                  IYT = KTGEU(ITABS,IYABS)-NTGEUES(ISYM)
                else
                  IYT = KTGEU(IYABS,ITABS)-NTGEUES(ISYM)
                end if
                PARTSUM = -sum(CBLK(IYT:IYT+NAS*(NIS-1):NAS)*TBLK(IXT:IXT+NAS*(NIS-1):NAS))
                if (ITABS == IYABS) PARTSUM = Two*PARTSUM
                rSUM = rSUM+PARTSUM

              end do
              DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)+rSUM

            end do
          end do
        end do

      case (9)
        ! Case 9 code section:
        do ISYMX=1,NSYM
          NAX = NASH(ISYMX)
          do IX=1,NAX
            IXABS = NAES(ISYMX)+IX
            do IY=1,NAX
              IYABS = NAES(ISYMX)+IY

              rSUM = Zero
              ISYMT = Mul(ISYMX,ISYM)
              do IT=1,NASH(ISYMT)
                ITABS = NAES(ISYMT)+IT
                if (ITABS == IXABS) cycle
                if (ITABS == IYABS) cycle
                if (ITABS > IXABS) then
                  IXT = KTGTU(ITABS,IXABS)-NTGTUES(ISYM)
                  SGN = One
                else
                  IXT = KTGTU(IXABS,ITABS)-NTGTUES(ISYM)
                  SGN = -One
                end if
                if (ITABS > IYABS) then
                  IYT = KTGTU(ITABS,IYABS)-NTGTUES(ISYM)
                else
                  IYT = KTGTU(IYABS,ITABS)-NTGTUES(ISYM)
                  SGN = -SGN
                end if
                rSUM = rSUM-SGN*sum(CBLK(IYT:IYT+NAS*(NIS-1):NAS)*TBLK(IXT:IXT+NAS*(NIS-1):NAS))

              end do
              DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)+rSUM

            end do
          end do
        end do

      case (10)
        ! Case 10 code section:
        NAX = NASH(ISYM)
        do IX=1,NAX
          IXABS = NAES(ISYM)+IX
          do IY=1,NAX
            IYABS = NAES(ISYM)+IY

            DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)-sum(CBLK(IY:IY+NAS*(NIS-1):NAS)*TBLK(IX:IX+NAS*(NIS-1):NAS))

          end do
        end do

      case (11)
        ! Case 11 code section:
        NAX = NASH(ISYM)
        do IX=1,NAX
          IXABS = NAES(ISYM)+IX
          do IY=1,NAX
            IYABS = NAES(ISYM)+IY

            DCOM(IXABS,IYABS) = DCOM(IXABS,IYABS)-sum(CBLK(IY:IY+NAS*(NIS-1):NAS)*TBLK(IX:IX+NAS*(NIS-1):NAS))

          end do
        end do

      case default
        call ABEND()
    end select

    call MMA_DEALLOCATE(CBLK)
    call MMA_DEALLOCATE(TBLK)

    ! Here ends the loops over ISYM and ICASE.
  end do
end do

end subroutine COMMWEW

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DMInvKap_sp(rin,rout)
! _____     -1
! Kappa  = M  Kappa
!      ip   pq     iq
!
! In: rMFact        Factorized preconditioner (diagonal part
!                   of the electronic hessian that couple
!                   rotations with one common index)
! In,Out rOut       Orbital rotaotion
!
! iSym              Symmetry of rotation

use MCLR_Data, only: nDens, nDensC
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: rin(nDensC)
real(kind=wp), intent(out) :: rout(nDensC)
real(kind=wp), allocatable :: Temp(:)

call mma_allocate(Temp,nDens,Label='Temp')
call Uncompress(rin,Temp,1)

call Compress(Temp,rout,1)
call mma_deallocate(Temp)

end subroutine DMInvKap_sp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine mktau (wrk,wrksize,
     & mapdt2,mapit2,mapdt1a,mapit1a,mapdt1b,mapit1b,
     &                   fact,rc)
c
c     this routine do:
c     t2(abij) = t2(abij) + fact. (t1(ai).t1(bj)-t1(bi).t1(aj))
c     N.B. T24a,4b must be of type 4, T2abab of type 0
c
c     mapdt2  - direct map of T2 (I)
c     mapit2        - inverse map of T2 (I)
c     mapdt1a        - direct map of T1aa (I)
c     mapit1a        - inverse map of T1aa (I)
c     mapdt1b        - direct map of T1bb (I)
c     mapit1b        - inverse map of T1bb (I)
c     fact    - numerical factor (I)
c     rc        - return (error) code
c
c
#include "ccsd1.fh"
#include "wrk.fh"
       integer rc
       real*8 fact
c
       integer mapdt2(0:512,1:6)
       integer mapit2(1:8,1:8,1:8)
c
       integer mapdt1a(0:512,1:6)
       integer mapit1a(1:8,1:8,1:8)
c
       integer mapdt1b(0:512,1:6)
       integer mapit1b(1:8,1:8,1:8)
c
c     help variables
c
       integer posst2,posst1a,posst1b,posst11,posst12
       integer dimi,dimj,dima,dimb,dimab,dimij,syma,symb,symi,symj
       integer iit2,iit1a,iit1b,iit11,iit12
c
       rc=0
c
       if (mapdt2(0,6).eq.0) then
cI.1  T2abab case

       do 100 iit2=1,mapdt2(0,5)
c
       posst2=mapdt2(iit2,1)
       syma=mapdt2(iit2,3)
       symb=mapdt2(iit2,4)
       symi=mapdt2(iit2,5)
       symj=mapdt2(iit2,6)
       dima=nva(syma)
       dimb=nvb(symb)
       dimi=noa(symi)
       dimj=nob(symj)
       iit1a=mapit1a(syma,1,1)
       iit1b=mapit1b(symb,1,1)
       posst1a=mapdt1a(iit1a,1)
       posst1b=mapdt1b(iit1b,1)
c
       if ((syma.eq.symi).and.(symb.eq.symj).and.(mapdt2(iit2,2).gt.0))
     & then
       call mktauhelp1 (wrk(posst2),wrk(posst1a),wrk(posst1b),
     & dima,dimb,dimi,dimj,noa(symi),nob(symj),fact)
       end if
c
 100    continue
c
       else if ((mapdt2(0,6).eq.4).and.(mapdt2(0,1).eq.3)) then
cI.2  T2aaaa case
c
       do 200 iit2=1,mapdt2(0,5)
c
       posst2=mapdt2(iit2,1)
       syma=mapdt2(iit2,3)
       symb=mapdt2(iit2,4)
       symi=mapdt2(iit2,5)
       symj=mapdt2(iit2,6)
       dima=nva(syma)
       dimb=nva(symb)
       dimi=noa(symi)
       dimj=noa(symj)
       iit11=mapit1a(syma,1,1)
       iit12=mapit1a(symb,1,1)
       posst11=mapdt1a(iit11,1)
       posst12=mapdt1a(iit12,1)
c
       if ((syma.eq.symi).and.(symb.eq.symj).
     & and.(syma.ne.symj).and.(mapdt2(iit2,2).gt.0)) then
cI.2.*case T2(sym1,sym2,sym1,sym2)
c
       call mktauhelp1 (wrk(posst2),wrk(posst11),wrk(posst12),
     & dima,dimb,dimi,dimj,noa(syma),noa(symb),fact)
c
       else if ((syma.eq.symi).and.(symb.eq.symj).
     & and.(syma.eq.symj).and.(mapdt2(iit2,2).gt.0)) then
cI.2.*case T2(sym1,sym1,sym1,sym1)
c
       dimab=(dima*(dima-1))/2
       dimij=(dimi*(dimi-1))/2
       call mktauhelp2 (wrk(posst2),wrk(posst11),
     & dimab,dimij,dima,dimi,noa(syma),fact)
c
       end if
c
 200    continue
c
       else if ((mapdt2(0,6).eq.4).and.(mapdt2(0,1).eq.4)) then
cI.3  T2bbbb case
c
       do 300 iit2=1,mapdt2(0,5)
c
       posst2=mapdt2(iit2,1)
       syma=mapdt2(iit2,3)
       symb=mapdt2(iit2,4)
       symi=mapdt2(iit2,5)
       symj=mapdt2(iit2,6)
       dima=nvb(syma)
       dimb=nvb(symb)
       dimi=nob(symi)
       dimj=nob(symj)
       iit11=mapit1b(syma,1,1)
       iit12=mapit1b(symb,1,1)
       posst11=mapdt1b(iit11,1)
       posst12=mapdt1b(iit12,1)
c
       if ((syma.eq.symi).and.(symb.eq.symj).
     & and.(syma.ne.symj).and.(mapdt2(iit2,2).gt.0)) then
cI.3.*case T2(sym1,sym2,sym1,sym2)
c
       call mktauhelp1 (wrk(posst2),wrk(posst11),wrk(posst12),
     & dima,dimb,dimi,dimj,nob(syma),nob(symb),fact)
c
       else if ((syma.eq.symi).and.(symb.eq.symj).
     & and.(syma.eq.symj).and.(mapdt2(iit2,2).gt.0)) then
cI.3.*case T2(sym1,sym1,sym1,sym1)
c
       dimab=(dima*(dima-1))/2
       dimij=(dimi*(dimi-1))/2
       call mktauhelp2 (wrk(posst2),wrk(posst11),
     & dimab,dimij,dima,dimi,nob(syma),fact)
c
       end if
c
 300    continue
c
       else
cI.4  RC=1 : incorrect mapdt for T2
       rc=1
       return
       end if
c
c
       return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(mapit2)
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine pr_ito_int( npair, i_pair, lmax, nexch, nneq, neqv,
     &                       itype, neq, nmax, soe, MM, SM, rot, Dipol,
     &                       AnisoLines1, AnisoLines3, AnisoLines9,
     &                       DM_exchange, JITO_exchange,
     &                       HLIN1, HLIN3, HLIN9, HDIP, HDMO, HITO )
!     this function prints the parameters of the exchange interaction in an
!     accessible format
      Implicit None
#include "stdalloc.fh"
      Integer, parameter           :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)          :: npair
      Integer, intent(in)          :: nneq
      Integer, intent(in)          :: neqv
      Integer, intent(in)          :: lmax
      Integer, intent(in)          :: nmax
      Integer, intent(in)          :: nexch(nneq)
      Integer, intent(in)          :: neq(nneq)
      Integer, intent(in)          :: i_pair(npair,2)
      Real(kind=8), intent(in)    :: rot(nneq,neqv,3,3)
      Real(kind=8), intent(in)    :: soe(nneq,nmax)
      Complex(kind=8), intent(in) :: MM(nneq,3,nmax,nmax)
      Complex(kind=8), intent(in) :: SM(nneq,3,nmax,nmax)
      Complex(kind=8), intent(in) :: HLIN1(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HLIN3(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HLIN9(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HDIP(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HDMO(npair,nmax,nmax,nmax,nmax)
      Complex(kind=8), intent(in) :: HITO(npair,nmax,nmax,nmax,nmax)
      Logical, intent(in)          :: Dipol
      Logical, intent(in)          :: AnisoLines1
      Logical, intent(in)          :: AnisoLines3
      Logical, intent(in)          :: AnisoLines9
      Logical, intent(in)          :: DM_exchange
      Logical, intent(in)          :: JITO_exchange
      Character(Len=1), intent(in) :: itype(nneq)
      ! local variables
      Integer       ::   i,j,l,k,lp,i1,i2,j1,j2,lb1,lb2,iopt,ibuf,
     &                   is1,is2,js1,js2,k1,k2,q1,q2,n1,n2,nsize
      Integer       ::   nind(lmax,2),l1(2),l2(2),l3(2),l4(2)
      Real(kind=8) ::   J1C(3,3), J1Cr(3,3) !, J1C_trans(3,3)
      Complex(kind=8), allocatable :: JN(:,:,:,:)
      Complex(kind=8), allocatable :: JB(:,:,:,:)
      Complex(kind=8), allocatable :: JS(:,:,:,:)
      Real(kind=8)    :: dznrm2_,RL1,RL3,RL9,RDI,RDM,RIT
      Real(kind=8)    :: g1(3),g2(3),mg1(3,3),mg2(3,3)
      External         :: dznrm2_
      Real(kind=8)    :: cm_to_MHz
      logical DBG

      cm_to_MHz=29979.2458_wp
      DBG=.false.
c some initializations:
      nind(:,:)=0
      l=0
      Do i=1,nneq
        Do j=1,neq(i)
          l=l+1
          nind(l,1)=i
          nind(l,2)=j
        End Do
      End Do

      ibuf=npair*nmax*nmax*nmax*nmax
      If(ibuf==0) Then
         Write(6,'(A)') 'in UTMU:   ibuf=0 !!!'
         Write(6,*) 'npair= ', npair
         Write(6,*) 'nmax = ', nmax
         Call xFlush(6)
         Call xquit(128)
      End If
      RL1=dznrm2_(ibuf,HLIN1,1)
      RL3=dznrm2_(ibuf,HLIN3,1)
      RL9=dznrm2_(ibuf,HLIN9,1)
      RDI=dznrm2_(ibuf,HDIP,1)
      RDM=dznrm2_(ibuf,HDMO,1)
      RIT=dznrm2_(ibuf,HITO,1)
cccccccccccccccccccccccccccccccc
      If(DBG) Then
        Write(6,'(A,i6)') ' nmax =', nmax
        Write(6,'(A,i6)') ' lmax =', lmax
        Write(6,'(A,i6)') 'npair =', nmax
        Write(6,'(A,i6)') ' nneq =', nneq
        Write(6,'(20A)') ' itype =', (itype(i),i=1,nneq)
        Write(6,'(A)') 'i_pair'
        Do i=1,npair
          Write(6,'(2I5)') i_pair(i,1),i_pair(i,2)
        End Do
        Write(6,'(A)') 'equivalent sites'
        Do i=1, nneq
          Write(6,'(A,i2,A,i4)') 'neq(',i,') =',neq(i)
        End Do
        Write(6,'(A)') 'exchange basis'
        Do i=1, nneq
          Write(6,'(A,i2,A,i4)') 'nexch(',i,') =',nexch(i)
        End Do
        Write(6,'(A)') 'rotation matrix'
        Do i=1,nneq
          Write(6,'(A,i3)') 'site', i
          Do j=1,neq(i)
            Do l=1,3
              Write(6,'(3F12.6)') (rot(i,j,l,i1),i1=1,3)
            End Do
          End Do
        End Do
        Write(6,'(A,i3)') 'site', i
        Write(6,'(A)' ) 'magnetic moment, initial'
        Do i=1,nneq
          Write(6,'(A ,i3)') 'site', i
          Call prMom('pr_ito_int:: magnetic moment, initial',
     &                mm(i,:,:,:),nmax)
        End Do
        Write(6,'(A)' ) 'spin-orbit energies'
        Do i=1,nmax
          Write(6,'(1 5F14.5)') (soe(j,i),j=1,nneq)
        End Do

        Do lp=1,npair
         lb1=i_pair(lp,1)
         lb2=i_pair(lp,2)
          i1=nind(lb1,1) ! indices of non-equivalent sites
          i2=nind(lb2,1) ! indices of non-equivalent sites
          j1=nind(lb1,2) ! indices of equivalent sites
          j2=nind(lb2,2) ! indices of equivalent sites
          If (AnisoLines1.AND.(RL1>0.0_wp)) Then
            Write(6,'(A,i5)') 'HLIN1,  interacting pair ',lp
            Do is1=1,nexch(i1)
              Do is2=1,nexch(i1)
                Do js1=1,nexch(i2)
                  Write(6,'(10(2F10.6,2x))')
     &                     (HLIN1(lp,is1,is2,js1,js2),js2=1,nexch(i2))
                End Do
              End Do
            End Do
          End If

          If (AnisoLines3.AND.(RL3>0.0_wp)) Then
            Write(6,'(A,i5)') 'HLIN3,  interacting pair ',lp
            Do is1=1,nexch(i1)
              Do is2=1,nexch(i1)
                Do js1=1,nexch(i2)
                  Write(6,'(10(2F10.6,2x))')
     &                     (HLIN3(lp,is1,is2,js1,js2),js2=1,nexch(i2))
                End Do
              End Do
            End Do
          End If

          If (AnisoLines9.AND.(RL9>0.0_wp)) Then
            Write(6,'(A,i5)') 'HLIN9,  interacting pair ',lp
            Do is1=1,nexch(i1)
              Do is2=1,nexch(i1)
                Do js1=1,nexch(i2)
                  Write(6,'(10(2F10.6,2x))')
     &                     (HLIN9(lp,is1,is2,js1,js2),js2=1,nexch(i2))
                End Do
              End Do
            End Do
          End If

          If (Dipol.AND.(RDI>0.0_wp)) Then
            Write(6,'(A,i5)') 'HDIP,  interacting pair ',lp
            Do is1=1,nexch(i1)
              Do is2=1,nexch(i1)
                Do js1=1,nexch(i2)
                  Write(6,'(10(2F10.6,2x))')
     &                     (HDIP(lp,is1,is2,js1,js2),js2=1,nexch(i2))
                End Do
              End Do
            End Do
          End If

          If (DM_exchange.AND.(RDM>0.0_wp)) Then
            Write(6,'(A,i5)') 'HDMO,  interacting pair ',lp
            Do is1=1,nexch(i1)
              Do is2=1,nexch(i1)
                Do js1=1,nexch(i2)
                  Write(6,'(10(2F10.6,2x))')
     &                     (HDMO(lp,is1,is2,js1,js2),js2=1,nexch(i2))
                End Do
              End Do
            End Do
          End If

          If (JITO_exchange.AND.(RIT>0.0_wp)) Then
            Write(6,'(A,i5)') 'HITO,  interacting pair ',lp
            Do is1=1,nexch(i1)
              Do is2=1,nexch(i1)
                Do js1=1,nexch(i2)
                  Write(6,'(10(2F10.6,2x))')
     &                     (HITO(lp,is1,is2,js1,js2),js2=1,nexch(i2))
                End Do
              End Do
            End Do
          End If

        End Do !lp
        Call prMom('SM(i1) bf Lines1',SM(i1,1:3,1:n1,1:n1),n1)
        Call prMom('SM(i2) bf Lines1',SM(i2,1:3,1:n2,1:n2),n2)
      End If !DBG


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      Write(6,*)
      Write(6,'(100a)') (('%'),j=1,100)
      If ( (.not.AnisoLines1).and.(.not.AnisoLines3).and.
     &     (.not.AnisoLines9).and.(.not.Dipol).and.
     &     (.not.DM_exchange).and.(.not.JITO_exchange) ) Then
        Write(6,'(20x,A)') 'ITO decomposition of exchange and/or '//
     &                     'dipolar couplings.'
        Write(6,'(A)') 'AnisoLines1 =  FALSE.'
        Write(6,'(A)') 'AnisoLines3 =  FALSE.'
        Write(6,'(A)') 'AnisoLines9 =  FALSE.'
        Write(6,'(A)') 'Dipol       =  FALSE.'
        Write(6,'(A)') 'JITO_exch   =  FALSE.'
        Write(6,'(A)') 'DM_exchange =  FALSE.'
        Write(6,'(A)') 'Nothing to Do.'
        Return

      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9).and.
     &         (.not.Dipol).and.(.not.DM_exchange).and.
     &         (.not.JITO_exchange) ) Then
        Write(6,'(20x,A)') 'ITO decomposition of the Lines exchange '//
     &                     'interactions.'

      Else If((.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9))
     &        .and.Dipol.and.(.not.DM_exchange).and.
     &        (.not.JITO_exchange)) Then
        Write(6,'(20x,A)') 'ITO decomposition of the dipolar '//
     &                     'interactions.'

      Else If((AnisoLines1.or.AnisoLines3.or.AnisoLines9)
     &         .and.Dipol.and.(.not.DM_exchange).and.
     &          (.not.JITO_exchange) ) Then
        Write(6,'(20x,A)') 'ITO decomposition of exchange and/or '//
     &                     'dipolar couplings.'
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9)
     &         .and.(.not.Dipol).and.(.not.DM_exchange).and.
     &          JITO_exchange ) Then
        Write(6,'(20x,A)') 'ITO decomposition of anisotropic '//
     &                     'exchange interaction. '
      Else If(.not.(AnisoLines1.or.AnisoLines3.or.AnisoLines9)
     &         .and.Dipol.and.(.not.DM_exchange).and.
     &          JITO_exchange ) Then
        Write(6,'(20x,A)') 'ITO decomposition of anisotropic '//
     &                     'exchange interaction and dipolar '//
     &                     'couplings.'

      End If
      Write(6,'(100a)') (('%'),j=1,100)
      Write(6,*)

c decompose the exchange interaction in products of ITO
c first rotate the magnetic moments to the general coordinate system:
      Do lp=1,npair
        lb1=i_pair(lp,1)
        lb2=i_pair(lp,2)
        i1=nind(lb1,1) ! indices of non-equivalent sites
        i2=nind(lb2,1) ! indices of non-equivalent sites
        j1=nind(lb1,2) ! indices of equivalent sites
        j2=nind(lb2,2) ! indices of equivalent sites

        n1=nexch(i1)
        n2=nexch(i2)
        Write(6,'(A)') 'PART 1: Magnetic exchange is written in the '//
     &                 'coordinate systems of the LOCAL main '//
     &                 'magnetic axes of the interacting sites.'
        iopt=1
        Write(6,'(A)')
        Write(6,'(100A)') ('-',i=1,100)
        Write(6,'(A,i2)') 'Interacting pair',lp

        ! JN= exch. parameters in Naoya's ITO operators
        ! JL= exch. parameters in Liviu's ITO operators
        ! JS= exch. parameters in Stevens ESO operators
        l1(1)=  1
        l1(2)=  n1-1
        l2(1)=-(n1-1)
        l2(2)= (n1-1)
        l3(1)=  1
        l3(2)=  n2-1
        l4(1)=-(n2-1)
        l4(2)= (n2-1)
        nsize=(n1-1)*(n2-1)*(2*(n1-1)+1)*(2*(n2-1)+1)
        Call mma_allocate(JN,l1,l2,l3,l4,'JN')
        Call mma_allocate(JB,l1,l2,l3,l4,'JB')
        Call mma_allocate(JS,l1,l2,l3,l4,'JS')

!====================================================================
        If( AnisoLines1.AND.(RL1>0.0_wp) ) Then

          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)

          Call newjkqpar(n1,n2,HLIN1(lp,1:n1,1:n1,1:n2,1:n2),
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)) )


          ! re-write the first rank tensor in cartesian representation:
          ! using Naoya's ITO parameters
          J1C=0.0_wp
          J1Cr=0.0_wp
          Call tensor2cart( JB(1,-1:1,1,-1:1), J1C )

!         rotate cartesian J1C matrix by mg1 and mg2, in order to represent
!         the interaction matrix in the original coordinate system:
          mg1=0.0_wp; mg2=0.0_wp; g1=0.0_wp; g2=0.0_wp;
          Call atens( MM(i1,1:3,1:n1,1:n1), n1, g1, mg1, 2 )
          Call atens( MM(i2,1:3,1:n2,1:n2), n2, g2, mg2, 2 )
          Do i=1,3
           Do j=1,3
             Do l=1,3
               Do k=1,3
                 J1Cr(i,j)= J1Cr(i,j) + mg1(i,l)*mg2(j,k)*J1C(l,k)
               End Do
             End Do
           End Do
          End Do

        Write(6,'(A)')
        Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
     &                 '(rank-1) exchange interaction: LINES-1'
        Write(6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
        Write(6,'(A)') 'LOCAL AXES:::'
        Write(6,'(A)') 'To be used directly in exchange Hamiltonian'//
     &                 ' of the kind:'
        Write(6,'(A)') ' H = -J * S1 * S2'
        Write(6,'(A)') '     (  xx   xy  xz  )  '
        Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
        Write(6,'(A)') '     (  zx   zy  zz  )  '
        Do i=1,3
          Write(6,'(3ES22.14)') ( -J1Cr(i,j),j=1,3)
        End Do

        ! print out the data:
        Write(6,'(A)')
        Write(6,'(10x,A)') 'Parameters of the ITOs: (Liviu ITO)'
        Write(6,'( 5x,A)') 'with absolute values larger than:  0.5d-14 '
        Write(6,'(A)') '--- SITE 1 --|--- SITE 2 --|---------------'//
     &                 '--------------------------------|'
        Write(6,'(A)') ' rank | proj.| rank | proj.|           Line'//
     &                 's  Exchange  Interaction        |'
        Write(6,'(A)') '------|------|------|------|---------- Real'//
     &                 ' ----------------- Imag --------|'

        Do k1=1,n1-1,2
         Do q1=-k1,k1
          Do k2=1,n2-1,2
           Do q2=-k2,k2
            Write(6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)')
     &            k1,'|',q1,'|',k2,'|',q2,'|', JN(k1,q1,k2,q2),'|'
           End Do
          End Do
         End Do
        End Do
        Write(6,'(A)') '------|------|------|------|---------------'//
     &                 ' -------------------------------|'


!      !------------------------------------------------------------------------
!      ! verify the back transform for HAM!:
!        Call mma_allocate(HAM,n1,n1,n2,n2,'HAM')
!        Call zcopy_(n1*n1*n2*n2,[(0.0_wp,0.0_wp)],0,HAM,1)
!
!        S1a=( 0.0_wp, 0.0_wp)
!        S2a=( 0.0_wp, 0.0_wp)
!        S1b=( 0.0_wp, 0.0_wp)
!        S2b=( 0.0_wp, 0.0_wp)
!
!        Call ESO(n1,1,1,S1b(1,1:n1,1:n1),S1b(2,1:n1,1:n1),redME)
!        Call ESO(n1,1,0,S1b(3,1:n1,1:n1),W1b(  1:n1,1:n1),redME)
!        Call zcopy_(3*n1*n1,S1b,1,S2b,1)
!
!        Call prmom('SM(i1) bf recover HAM',SM(i1,1:3,1:n1,1:n1),n1)
!        Call prmom('SM(i2) bf recover HAM',SM(i2,1:3,1:n2,1:n2),n2)
!
!
!        J1C_trans=0.0_wp
!        Do i=1,3
!         Do j=1,3
!          J1C_trans(i,j)=-J1Cr(i,j)
!         End Do
!        End Do
!        Write(6,'(/)')
!        Call Aniso_Lines_Exchange9( J1C_trans, n1, n2,
!     &          S1b(1:3,1:n1,1:n1),
!     &          S2b(1:3,1:n2,1:n2), HAM )
!        Call Aniso_Lines_Exchange9( J1C_trans, n1, n2,
!     &          SM(i1,1:3,1:n1,1:n1),
!     &          SM(i2,1:3,1:n2,1:n2), HAM )
!
!        Write(6,'(A,i5)') 'HLIN1: ORIG, REGEN, DIFF:'
!        Do is1=1,n1
!         Do is2=1,n1
!          Do js1=1,n2
!           Do js2=1,n2
!           Write(6,'(4I3,3(2ES22.13,3x))') is1,is2,js1,js2,
!     &               HLIN1(lp,is1,is2,js1,js2),
!     &                    HAM(is1,is2,js1,js2),
!     &      HLIN1(lp,is1,is2,js1,js2)-HAM(is1,is2,js1,js2)
!           End Do
!          End Do
!         End Do
!        End Do
!
!        Call mma_deallocate(HAM)
        End If



!====================================================================
        If( AnisoLines3.AND.(RL3>0.0_wp) ) Then

          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)

          Call newjkqpar(n1,n2,HLIN3(lp,1:n1,1:n1,1:n2,1:n2),
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)) )

          J1C=0.0_wp
          J1Cr=0.0_wp
          ! using Liviu's ITO parameters
          Call tensor2cart( JB( 1,-1:1, 1,-1:1), J1C )

!         rotate cartesian JLinC1 by mg1 and mg2, in order to represent
!         the interaction matrix in the original coordinate system:
          mg1=0.0_wp;mg2=0.0_wp;g1=0.0_wp; g2=0.0_wp;
          Call atens( MM(i1,1:3,1:n1,1:n1), n1, g1, mg1, 2 )
          Call atens( MM(i2,1:3,1:n2,1:n2), n2, g2, mg2, 2 )
          Do i=1,3
           Do j=1,3
             Do l=1,3
               Do k=1,3
                 J1Cr(i,j)= J1Cr(i,j) + mg1(i,l)*mg2(j,k)*J1C(l,k)
               End Do
             End Do
           End Do
          End Do

          Write(6,'(A)')
          Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
     &                   '(rank-1) exchange interaction: LINES-3'
          Write(6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
          Write(6,'(A)') 'LOCAL AXES:::'
          Write(6,'(A)') 'To be used directly in exchange Hamiltonian'//
     &                   'of the kind:'
          Write(6,'(A)') ' H = -J * S1 * S2'
          Write(6,'(A)') '     (  xx   xy  xz  )  '
          Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
          Write(6,'(A)') '     (  zx   zy  zz  )  '
          Do i=1,3
            Write(6,'(3ES22.14)') ( -J1Cr(i,j),j=1,3)
          End Do

        ! print out the data:
        Write(6,'(A)')
        Write(6,'(10x,A)') 'Parameters of the ITOs: (Liviu ITO)'
        Write(6,'( 5x,A)') 'with absolute values larger than:  0.1d-20 '
        Write(6,'(A)') '--- SITE 1 --|--- SITE 2 --|---------------'//
     &                 '--------------------------------|'
        Write(6,'(A)') ' rank | proj.| rank | proj.|        Lines-3'//
     &                 '  Exchange  Interaction         |'
        Write(6,'(A)') '------|------|------|------|---------- Real'//
     &                 ' ----------------- Imag --------|'
        Do k1=1,N1-1,2
          Do q1=-k1,k1
            Do k2=1,N2-1,2
              Do q2=-k2,k2
!                If(ABS(JLin3(lp,k1,q1,k2,q2)) .gt. 0.1e-20_wp ) Then
                   Write(6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)')
     &                   k1,'|',q1,'|',k2,'|',q2,'|',
     &                   JN(k1,q1,k2,q2),'|'
!                End If
              End Do
            End Do
          End Do
        End Do
        Write(6,'(A)') '------|------|------|------|---------------'//
     &                 ' -------------------------------|'
        End If

!====================================================================
        If( AnisoLines9.AND.(RL9>0.0_wp) ) Then

          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)

          Call newjkqpar(n1,n2,HLIN9(lp,1:n1,1:n1,1:n2,1:n2),
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)) )


          J1C=0.0_wp
          J1Cr=0.0_wp
          Call tensor2cart( JB(1,-1:1, 1,-1:1), J1C)

!         rotate cartesian JLinC1 by mg1 and mg2, in order to represent
!         the interaction matrix in the original coordinate system:
          mg1=0.0_wp; mg2=0.0_wp; g1=0.0_wp; g2=0.0_wp;
          Call atens( MM(i1,1:3,1:n1,1:n1), n1, g1, mg1, 2 )
          Call atens( MM(i2,1:3,1:n2,1:n2), n2, g2, mg2, 2 )
          Do i=1,3
           Do j=1,3
             Do l=1,3
               Do k=1,3
                 J1Cr(i,j)= J1Cr(i,j) + mg1(i,l)*mg2(j,k)*J1C(l,k)
               End Do
             End Do
           End Do
          End Do

        Write(6,'(A)')
        Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
     &                 '(rank-1) exchange interaction: LINES-9'
        Write(6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
        Write(6,'(A)') 'LOCAL AXES:::'
        Write(6,'(A)') 'To be used directly in exchange Hamiltonian'//
     &                 'of the kind:'
        Write(6,'(A)') ' H = -J * S1 * S2'
        Write(6,'(A)') '     (  xx   xy  xz  )  '
        Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
        Write(6,'(A)') '     (  zx   zy  zz  )  '
        Do i=1,3
          Write(6,'(3ES22.14)') (-J1Cr(i,j),j=1,3)
        End Do

        ! print out the data:
        Write(6,'(A)')
        Write(6,'(10x,A)') 'Parameters of the ITOs:'
        Write(6,'( 5x,A)') 'with absolute values larger than:  0.1e-20 '
        Write(6,'(A)') '--- SITE 1 --|--- SITE 2 --|---------------'//
     &                 '--------------------------------|'
        Write(6,'(A)') ' rank | proj.| rank | proj.|        Lines-9'//
     &                 '  Exchange  Interaction         |'
        Write(6,'(A)') '------|------|------|------|---------- Real'//
     &                 ' ----------------- Imag --------|'
        Do k1=1,N1-1,2
         Do q1=-k1,k1
          Do k2=1,N2-1,2
           Do q2=-k2,k2
            Write(6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)')
     &            k1,'|',q1,'|',k2,'|',q2,'|',
     &            JN(k1,q1,k2,q2),'|'
           End Do
          End Do
         End Do
        End Do
        Write(6,'(A)') '------|------|------|------|---------------'//
     &                 ' -------------------------------|'
        End If

!====================================================================


        If (Dipol.AND.(RDI>0.0_wp)) Then

          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)

          Call newjkqpar(n1,n2,HDIP(lp,1:n1,1:n1,1:n2,1:n2),
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)) )

          J1C=0.0_wp
          J1Cr=0.0_wp
          Call tensor2cart( JB(1,-1:1,1,-1:1), J1C(1:3,1:3) )

!         rotate cartesian JLinC1 by mg1 and mg2, in order to represent
!         the interaction matrix in the original coordinate system:
          mg1=0.0_wp; mg2=0.0_wp; g1=0.0_wp; g2=0.0_wp;
          Call atens( MM(i1,1:3,1:n1,1:n1), n1, g1, mg1, 2 )
          Call atens( MM(i2,1:3,1:n2,1:n2), n2, g2, mg2, 2 )
          Do i=1,3
           Do j=1,3
             Do l=1,3
               Do k=1,3
                 J1Cr(i,j)= J1Cr(i,j) + mg1(i,l)*mg2(j,k)*J1C(l,k)
               End Do
             End Do
           End Do
          End Do

        Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
     &                 '(rank-1) exchange interaction: DIPOL'
        Write(6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
        Write(6,'(A)') 'LOCAL AXES:::'
        Write(6,'(A)') 'To be used directly in exchange Hamiltonian'//
     &                 'of the kind:'
        Write(6,'(A)') ' H = -J * S1 * S2'
        Write(6,'(A)') '     (  xx   xy  xz  )  '
        Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
        Write(6,'(A)') '     (  zx   zy  zz  )  '
        Do i=1,3
          Write(6,'(3ES24.14)') (-J1Cr(i,j),j=1,3)
        End Do
        Write(6,'(A)') '--- SITE 1 --|--- SITE 2 --|---------------'//
     &                 '--------------------------------|'
        Write(6,'(A)') ' rank | proj.| rank | proj.|      Dipolar  '//
     &                 'Exchange  Interaction           |'
        Write(6,'(A)') '------|------|------|------|---------- Real'//
     &                 ' ----------------- Imag --------|'
        Do k1=1,N1-1,2
          Do q1=-k1,k1
            Do k2=1,N2-1,2
              Do q2=-k2,k2
                   Write(6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)')
     &                   k1,'|',q1,'|',k2,'|',q2,'|',
     &                   JN(k1,q1,k2,q2),'|'
              End Do
            End Do
          End Do
        End Do
        Write(6,'(A)') '------|------|------|------|---------------'//
     &                 ' -------------------------------|'
        End If

!====================================================================


        If (DM_exchange.AND.(RDM>0.0_wp)) Then

          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)

          Call newjkqpar(n1,n2,HDMO(lp,1:n1,1:n1,1:n2,1:n2),
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)) )

          J1C=0.0_wp
          J1Cr=0.0_wp
          Call tensor2cart( JB(1,-1:1,1,-1:1), J1C )

          mg1=0.0_wp; mg2=0.0_wp; g1=0.0_wp; g2=0.0_wp;
          Call atens( MM(i1,1:3,1:n1,1:n1), n1, g1, mg1, 2 )
          Call atens( MM(i2,1:3,1:n2,1:n2), n2, g2, mg2, 2 )

!         rotate cartesian JLinC1 by mg1 and mg2, in order to represent
!         the interaction matrix in the original coordinate system:
          Do i=1,3
           Do j=1,3
             Do l=1,3
               Do k=1,3
                 J1Cr(i,j)= J1Cr(i,j) + mg1(i,l)*mg2(j,k)*J1C(l,k)
               End Do
             End Do
           End Do
          End Do

        Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
     &                 '(rank-1) exchange interaction: '//
     &                 'Dzyaloshinski-Morya'
        Write(6,'(A)') 'Anisotropic exchange interaction: -J matrix:'
        Write(6,'(A)') 'LOCAL AXES:::'
        Write(6,'(A)') 'To be used directly in exchange Hamiltonian'//
     &                 'of the kind:'
        Write(6,'(A)') ' H = -J * S1 * S2'
        Write(6,'(A)') '     (  xx   xy  xz  )  '
        Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
        Write(6,'(A)') '     (  zx   zy  zz  )  '
        Do i=1,3
          Write(6,'(3ES24.14)') (-J1Cr(i,j),j=1,3)
        End Do
        Write(6,'(A)') '--- SITE 1 --|--- SITE 2 --|---------------'//
     &                 '--------------------------------|'
        Write(6,'(A)') ' rank | proj.| rank | proj.|     Dzyaloshin'//
     &                 'sky - Morya Interaction         |'
        Write(6,'(A)') '------|------|------|------|---------- Real'//
     &                 ' ----------------- Imag --------|'
        Do k1=1,N1-1,2
         Do q1=-k1,k1
          Do k2=1,N2-1,2
           Do q2=-k2,k2
            Write(6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)')
     &            k1,'|',q1,'|',k2,'|',q2,'|',
     &            JN(k1,q1,k2,q2),'|'
           End Do
          End Do
         End Do
        End Do
        Write(6,'(A)') '------|------|------|------|---------------'//
     &                 ' -------------------------------|'
        End If

!====================================================================


        If (JITO_exchange.AND.(RIT>0.0_wp)) Then

          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)
          Call zcopy_(nsize,[(0.0_wp,0.0_wp)],0,
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),1)

          Call newjkqpar(n1,n2,HITO(lp,1:n1,1:n1,1:n2,1:n2),
     &            JN(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JB(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)),
     &            JS(1:(n1-1),-(n1-1):(n1-1),1:(n2-1),-(n2-1):(n2-1)) )

          J1C(1:3,1:3)=0.0_wp
          Call tensor2cart( JB(1,-1:1,1,-1:1), J1C)

          mg1=0.0_wp; mg2=0.0_wp; g1=0.0_wp; g2=0.0_wp;
          Call atens( MM(i1,1:3,1:n1,1:n1), n1, g1, mg1, 2 )
          Call atens( MM(i2,1:3,1:n2,1:n2), n2, g2, mg2, 2 )

!         rotate cartesian JLinC1 by mg1 and mg2, in order to represent
!         the interaction matrix in the original coordinate system:
          J1Cr(1:3,1:3)=0.0_wp
          Do i=1,3
           Do j=1,3
            Do l=1,3
             Do k=1,3
              J1Cr(i,j)= J1Cr(i,j) + mg1(i,l)*mg2(j,k)*J1C(l,k)
             End Do
            End Do
           End Do
          End Do

        Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
     &                 '(rank-1) exchange interaction: '//
     &                 'Anisotropic ITO exchange'
        Write(6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
        Write(6,'(A)') 'LOCAL AXES:::'
        Write(6,'(A)') '     (  xx   xy  xz  )  '
        Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
        Write(6,'(A)') '     (  zx   zy  zz  )  '
        Do i=1,3
          Write(6,'(3ES24.14)') (-J1Cr(i,j),j=1,3)
        End Do
        Write(6,'(A)') '--- SITE 1 --|--- SITE 2 --|---------------'//
     &                 '--------------------------------|'
        Write(6,'(A)') ' rank | proj.| rank | proj.|     Anisotropi'//
     &                 'c ITO Exchange Interaction      |'
        Write(6,'(A)') '------|------|------|------|---------- Real'//
     &                 ' ----------------- Imag --------|'
        Do k1=1,N1-1,2
          Do q1=-k1,k1
            Do k2=1,N2-1,2
              Do q2=-k2,k2
                 Write(6,'(4(i4,2x,A),2(1x,ES22.14),1x,A)')
     &                 k1,'|',q1,'|',k2,'|',q2,'|',
     &                 JN(k1,q1,k2,q2),'|'
              End Do
            End Do
          End Do
        End Do
        Write(6,'(A)') '------|------|------|------|---------------'//
     &                 ' -------------------------------|'
        End If

!====================================================================




!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c        Write(6,'(100A)') ('-',i=1,100)
c        Write(6,*)
c        Write(6,'(A)') 'PART 2: Magnetic exchange is written in the '//
c     &                 'GENERAL coordinate systems of the computed '//
c     &                 'system.'
c        Write(6,'(A)') 'The cartesian Z axis of the system is chosen'//
c     &                 'the quantisation axis for the local '//
c     &                 'pseudospins of the two interacting sites.'
c        Write(6,'(A)')
c
c       iopt=2
c       unity(1:3,1:3)=0.0_wp
c       unity(1,1)=1.0_wp
c       unity(2,2)=1.0_wp
c       unity(3,3)=1.0_wp
c
c       If(Lines.or.AnisoLines) Then
c
c         Call transHam( n1, n2, unity(1:3,1:3), unity(1:3,1:3),
c     &                  MM(i1,1:3,1:n1,1:n1), MM(i2,1:3,1:n2,1:n2),
c     &                  itype(i1), itype(i2),
c     &                  HLIN(lp, 1:n1,1:n1, 1:n2,1:n2),
c     &                 HLIN3(lp, 1:n1,1:n1, 1:n2,1:n2), iopt )
c         JLinG(lp, 1:(n1-1), -(n1-1):(n1-1),
c     &             1:(n2-1), -(n2-1):(n2-1) )=(0.0_wp,0.0_wp)
c         Call JKQPar( n1, n2, HLIN3(lp,1:n1,1:n1,1:n2,1:n2),
c     &                JLinG( lp,1:(n1-1), -(n1-1):(n1-1),
c     &                          1:(n2-1), -(n2-1):(n2-1)) )
c         JLinCG(lp,1:3,1:3)=0.0_wp
c         Call tensor2cart(1,1,JLinG(lp,1,-1:1,1,-1:1),
c     &                       JLinCG(lp,1:3,1:3) )
c        Write(6,'(A)')
c        Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
c     &                 '(rank-1) exchange interaction: LINES'
c        Write(6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
c        Write(6,'(A)') 'GENERAL COORD:::'
c        Write(6,'(A)') '     (  xx   xy  xz  )  '
c        Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
c        Write(6,'(A)') '     (  zx   zy  zz  )  '
c        Do i=1,3
c          Write(6,'(3ES22.14)') (JLinCG(lp,i,j),j=1,3)
c        End Do
c       End If

c       If (Dipol) Then
c         Call transHam( n1, n2, unity(1:3,1:3), unity(1:3,1:3),
c     &                  MM(i1,1:3,1:n1,1:n1), MM(i2,1:3,1:n2,1:n2),
c     &                  itype(i1), itype(i2),
c     &                  HDIP(lp, 1:n1,1:n1, 1:n2,1:n2),
c     &                 HDIP3(lp, 1:n1,1:n1, 1:n2,1:n2), iopt )
c          JDipG(lp, 1:(n1-1), -(n1-1):(n1-1),
c     &              1:(n2-1), -(n2-1):(n2-1) )=(0.0_wp,0.0_wp)
c         Call JKQPar( n1, n2, HDIP3(lp,1:n1,1:n1,1:n2,1:n2),
c     &                JDipG( lp,1:(n1-1), -(n1-1):(n1-1),
c     &                          1:(n2-1), -(n2-1):(n2-1) ) )
c         JDipCG(lp,1:3,1:3)=0.0_wp
c         Call tensor2cart(1,1,JDipG(lp,1,-1:1,1,-1:1),
c     &                       JDipCG(lp,1:3,1:3) )
c        Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
c     &                 '(rank-1) exchange interaction: DIPOL'
c        Write(6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
c        Write(6,'(A)') 'GENERAL COORD:::'
c        Write(6,'(A)') '     (  xx   xy  xz  )  '
c        Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
c        Write(6,'(A)') '     (  zx   zy  zz  )  '
c        Do i=1,3
c          Write(6,'(3ES22.14)') (JDipCG(lp,i,j),j=1,3)
c        End Do
c       End If




c        Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
c     &                 '(rank-1) exchange interaction: LINES+DIPOL'
c        Write(6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
c        Write(6,'(A)') 'GENERAL COORD:::'
c        Write(6,'(A)') '     (  xx   xy  xz  )  '
c        Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
c        Write(6,'(A)') '     (  zx   zy  zz  )  '
c        Do i=1,3
c          Write(6,'(3F24.14)')
c     &            ((JLinCG(lp,i,j)+JDipCG(lp,i,j))*cm_to_MHz,j=1,3)
c        End Do


c print out the data:
c      Write(6,'(A)')
c      Write(6,'(10x,A)') 'Parameters of the ITOs:'
c      Write(6,'( 5x,A)') 'with absolute values larger than:  0.5d-14 '
c      If((Lines.or.AnisoLines).and.(.not.Dipol)) Then
c      Write(6,'(A)') '--- SITE 1 --|--- SITE 2 --|---------------'//
c     & '----------------------|'
c      Write(6,'(A)') ' rank | proj.| rank | proj.|    Lines  Exch'//
c     & 'ange  Interaction     |'
c      Write(6,'(A)') '------|------|------|------|------ Real ---'//
c     & '-------- Imag --------|'
c      Do k1=1,N1-1,2
c        Do q1=-k1,k1
c          Do k2=1,N2-1,2
c            Do q2=-k2,k2
c                  If(ABS(JLinG(lp,k1,q1,k2,q2)) .gt. 0.5d-14 ) Then
c      Write(6,'(4(i4,2x,A),2(1x,E17.10),1x,A)')
c     & k1,'|',q1,'|',k2,'|',q2,'|',JLinG(lp,k1,q1,k2,q2),'|'
c                  End If
c            End Do
c          End Do
c        End Do
c      End Do
c      Write(6,'(A)') '------|------|------|------|---------------'//
c     & '----------------------|'
c      Else If((.not.(Lines.or.AnisoLines)).and.Dipol) Then
c      Write(6,'(A)') '--- SITE 1 --|--- SITE 2 --|---------------'//
c     & '----------------------|'
c      Write(6,'(A)') ' rank | proj.| rank | proj.|  Dipolar  Exch'//
c     & 'ange  Interaction     |'
c      Write(6,'(A)') '------|------|------|------|------ Real ---'//
c     & '-------- Imag --------|'
c      Do k1=1,N1-1,2
c        Do q1=-k1,k1
c          Do k2=1,N2-1,2
c            Do q2=-k2,k2
c                  If(ABS(JDipG(lp,k1,q1,k2,q2)) .gt. 0.5d-14 ) Then
c      Write(6,'(4(i4,2x,A),2(1x,E17.10),1x,A)')
c     & k1,'|',q1,'|',k2,'|',q2,'|',JDipG(lp,k1,q1,k2,q2),'|'
c                  End If
c            End Do
c          End Do
c        End Do
c      End Do
c      Write(6,'(A)') '------|------|------|------|---------------'//
c     & '----------------------|'
c      Else If((Lines.or.AnisoLines).and.Dipol) Then
c      Write(6,'(A)') '--- SITE 1 --|--- SITE 2 --|---------------'//
c     & '----------------------|-------------------------------------|'
c      Write(6,'(A)') ' rank | proj.| rank | proj.|    Lines  Exch'//
c     & 'ange  Interaction     |  Dipolar  Exchange  Interaction     |'
c      Write(6,'(A)') '------|------|------|------|------ Real ---'//
c     & '-------- Imag --------|------ Real ----------- Imag --------|'
c      Do k1=1,N1-1,2
c        Do q1=-k1,k1
c          Do k2=1,N2-1,2
c            Do q2=-k2,k2
c                  If ( (ABS(JLinG(lp,k1,q1,k2,q2)) .gt. 0.5d-14) .OR.
c     &                 (ABS(JDipG(lp,k1,q1,k2,q2)) .gt. 0.5d-14) )  Then
c      Write(6,'(4(i4,2x,A),2(1x,E17.10),1x,A,2(1x,E17.10),1x,A)')
c     & k1,'|',q1,'|',k2,'|',q2,'|',JLinG(lp,k1,q1,k2,q2),'|',
c     & JDipG(lp,k1,q1,k2,q2),'|'
c                  End If
c            End Do
c          End Do
c        End Do
c      End Do
c      Write(6,'(A)') '------|------|------|------|---------------'//
c     & '----------------------|-------------------------------------|'
c      End If
c
c
c
c
c
c
!      Write(6,'(A)')
!      Write(6,'(A)') 'Cartesian representation of the (rank-1)*'//
!     & '(rank-1) exchange interaction'
!      Write(6,'(A)') 'Anisotropic exchange interaction:  J matrix:'
!      Write(6,'(A)') '     (  xx   xy  xz  )  '
!      Write(6,'(A)') 'J =  (  yx   yy  yz  )  '
!      Write(6,'(A)') '     (  zx   zy  zz  )  '
!
!      express the rank-1 tensors in the sum of
!      Isotrop part    C * unit matrix
!      Symmetric part
!      Antisimmetric part
!      print out the data:
!
!      JDipCG(lp,:,:)=0.0_wp
!      If(Lines.or.AnisoLines) Then
!      Write(6,'(A)') 'Lines matrix:'
!      Do i=1,3
!      Write(6,'(3F12.6)') (JLinCG(lp,i,j),j=1,3)
!      End Do
!
!
!      ELin(lp,:,:)=0.0_wp
!      ALin(lp,:,:)=0.0_wp
!      SLin(lp,:,:)=0.0_wp
!      ELin(lp,1,1)=(JLinCG(lp,1,1)+JLinCG(lp,2,2)+JLinCG(lp,3,3))/3.0_wp
!      ELin(lp,2,2)=(JLinCG(lp,1,1)+JLinCG(lp,2,2)+JLinCG(lp,3,3))/3.0_wp
!      ELin(lp,3,3)=(JLinCG(lp,1,1)+JLinCG(lp,2,2)+JLinCG(lp,3,3))/3.0_wp
!      Do is1=1,3
!       Do is2=1,3
!       ALin(lp,is1,is2)=(JLinCG(lp,is1,is2)-JLinCG(lp,is2,is1))/2.0_wp
!       End Do
!      End Do
!      tsum=0.0_wp
!      Do l=1,3
!      tsum=tsum+JLinCG(lp,l,l)
!      End Do
!      test=0.0_wp
!      Do is1=1,3
!      test(is1,is1)=2.0_wp*tsum/3.0_wp
!      End Do
!
!      Do is1=1,3
!       Do is2=1,3
!       SLin(lp,is1,is2)=( JLinCG(lp,is1,is2)+JLinCG(lp,is2,is1)
!     &                   -test(is1,is2) )/2.0_wp
!       End Do
!      End Do
!      Write(6,'(A)') 'Elin * unit'
!      Do is1=1,3
!      Write(6,'(3F12.6)') (ELin(lp,is1,is2),is2=1,3)
!      End Do
!      Write(6,'(A)') '-2/3 * test'
!      Do is1=1,3
!      Write(6,'(3F12.6)') (-2.0_wp*test(is1,is2)/3.0_wp,is2=1,3)
!      End Do
!
!      Write(6,'(A)') 'ALin:'
!      Do is1=1,3
!      Write(6,'(3F12.6)') (ALin(lp,is1,is2),is2=1,3)
!      End Do
!      Write(6,'(A)') 'SLin:'
!      Do is1=1,3
!      Write(6,'(3F12.6)') (SLin(lp,is1,is2),is2=1,3)
!      End Do
!      End If
!
!      If(Dipol) Then
!      Write(6,'(A)') 'Dipolar exchange matrix:'
!      Do i=1,3
!      Write(6,'(3F12.6)') (JDipCG(lp,i,j),j=1,3)
!      End Do
!
!      EDip(lp,:,:)=0.0_wp
!      ADip(lp,:,:)=0.0_wp
!      SDip(lp,:,:)=0.0_wp
!      EDip(lp,1,1)=(JDipCG(lp,1,1)+JDipCG(lp,2,2)+JDipCG(lp,3,3))/3.0_wp
!      EDip(lp,2,2)=(JDipCG(lp,1,1)+JDipCG(lp,2,2)+JDipCG(lp,3,3))/3.0_wp
!      EDip(lp,3,3)=(JDipCG(lp,1,1)+JDipCG(lp,2,2)+JDipCG(lp,3,3))/3.0_wp
!      Do is1=1,3
!       Do is2=1,3
!       ADip(lp,is1,is2)=(JDipCG(lp,is1,is2)-JDipCG(lp,is2,is1))/2.0_wp
!       End Do
!      End Do
!      tsum=0.0_wp
!      Do l=1,3
!      tsum=tsum+JDipCG(lp,l,l)
!      End Do
!      test=0.0_wp
!      Do is1=1,3
!      test(is1,is1)=2.0_wp*tsum/3.0_wp
!      End Do
!      Do is1=1,3
!       Do is2=1,3
!       SDip(lp,is1,is2)=( JDipCG(lp,is1,is2)+JDipCG(lp,is2,is1)
!     &                   -test(is1,is2) )/2.0_wp
!       End Do
!      End Do
!      Write(6,'(A)') 'EDip * unit'
!      Do is1=1,3
!      Write(6,'(3F12.6)') (EDip(lp,is1,is2),is2=1,3)
!      End Do
!      Write(6,'(A)') '-2/3 * test'
!      Do is1=1,3
!      Write(6,'(3F12.6)') (-2.0_wp*test(is1,is2)/3.0_wp,is2=1,3)
!      End Do
!      Write(6,'(A)') 'ADip:'
!      Do is1=1,3
!      Write(6,'(3F12.6)') (ADip(lp,is1,is2),is2=1,3)
!      End Do
!      Write(6,'(A)') 'SDip:'
!      Do is1=1,3
!      Write(6,'(3F12.6)') (SDip(lp,is1,is2),is2=1,3)
!      End Do
!      End If
!
        Call mma_deallocate(JN)
        Call mma_deallocate(JB)
        Call mma_deallocate(JS)
      End Do ! lp, interacting pairs


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Roland Lindh                                     *
!***********************************************************************

subroutine ppps(EFInt,Zeta,ZInv,nZeta,P,lP,rKappAB,A,B,Eta,EInv,nEta,Q,lQ,rKappCD,C,D,CoorAC,TMax,iPntr,nPntr,x0,nMax,CW6,CW5,CW4, &
                CW3,CW2,CW1,CW0,CR6,CR5,CR4,CR3,CR2,CR1,CR0,ddx,HerW,HerR2,IsChi,ChiI2)
!***********************************************************************
!                                                                      *
! Object: to compute the primitive integrals of type (pp|ps).          *
!                                                                      *
!  Author:    Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN. 1994                                    *
!***********************************************************************

use Constants, only: One, Ten, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, lP, nEta, lQ, nPntr, iPntr(nPntr), nMax, IsChi
real(kind=wp), intent(out) :: EFInt(nZeta,nEta,27)
real(kind=wp), intent(in) :: Zeta(nZeta), ZInv(nZeta), P(lP,3), rKappAB(nZeta), A(3), B(3), Eta(nEta), EInv(nEta), Q(lQ,3), &
                             rKappCD(nEta), C(3), D(3), CoorAC(3,2), TMax, x0(nMax), CW6(nMax,2), CW5(nMax,2), CW4(nMax,2), &
                             CW3(nMax,2), CW2(nMax,2), CW1(nMax,2), CW0(nMax,2), CR6(nMax,2), CR5(nMax,2), CR4(nMax,2), &
                             CR3(nMax,2), CR2(nMax,2), CR1(nMax,2), CR0(nMax,2), ddx, HerW(2), HerR2(2), ChiI2
integer(kind=iwp) :: iEta, iZeta, n
real(kind=wp) :: ai, B001, B002, B101, B102, dddx, Eu21, Eu22, PAQPx1, PAQPx2, PAQPy1, PAQPy2, PAQPz1, PAQPz2, PQ2, PQx, PQy, PQz, &
                 PreFct, QCPQx1, QCPQx2, QCPQy1, QCPQy2, QCPQz1, QCPQz2, r1, r2, rho, si, T, w1, w2, x011, x012, x101, x102, x111, &
                 x112, x201, x202, x211, x212, xdInv, y011, y012, y101, y102, y111, y112, y201, y202, y211, y212, z, z011, z012, &
                 z101, z102, z111, z112, z201, z202, z211, z212, ZEInv, Zu21, Zu22
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(EInv)

xdInv = One/ddx
dddx = ddx/Ten+ddx

if (EQ(A,B) .and. (.not. EQ(C,D))) then

  ! AACD case

  do iEta=1,nEta
    do iZeta=1,nZeta
      PQx = CoorAC(1,1)-Q(iEta,1)
      PQy = CoorAC(2,1)-Q(iEta,2)
      PQz = CoorAC(3,1)-Q(iEta,3)
      PQ2 = (PQx**2+PQy**2+PQz**2)
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      rho = Zeta(iZeta)*(Eta(iEta)*ZEInv)
      T = rho*PQ2
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w1 = (((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
        w2 = (((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
        r1 = (((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
        r2 = (((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
      else
        ai = One/T
        si = sqrt(ai)
        w1 = HerW(1)*si
        w2 = HerW(2)*si
        r1 = HerR2(1)*ai
        r2 = HerR2(2)*ai
      end if
      PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)
      w1 = PreFct*w1
      w2 = PreFct*w2
      Eu21 = Eta(iEta)*(r1*ZEInv)
      Eu22 = Eta(iEta)*(r2*ZEInv)
      Zu21 = Zeta(iZeta)*(r1*ZEInv)
      Zu22 = Zeta(iZeta)*(r2*ZEInv)
      PAQPx1 = -Eu21*PQx
      PAQPx2 = -Eu22*PQx
      PAQPy1 = -Eu21*PQy
      PAQPy2 = -Eu22*PQy
      PAQPz1 = -Eu21*PQz
      PAQPz2 = -Eu22*PQz
      QCPQx1 = (Q(iEta,1)-CoorAC(1,2))+Zu21*PQx
      QCPQx2 = (Q(iEta,1)-CoorAC(1,2))+Zu22*PQx
      QCPQy1 = (Q(iEta,2)-CoorAC(2,2))+Zu21*PQy
      QCPQy2 = (Q(iEta,2)-CoorAC(2,2))+Zu22*PQy
      QCPQz1 = (Q(iEta,3)-CoorAC(3,2))+Zu21*PQz
      QCPQz2 = (Q(iEta,3)-CoorAC(3,2))+Zu22*PQz
      B001 = Half*(r1*ZEInv)
      B002 = Half*(r2*ZEInv)
      B101 = (Half-Half*Eu21)*ZInv(iZeta)
      B102 = (Half-Half*Eu22)*ZInv(iZeta)
      x101 = PAQPx1
      x102 = PAQPx2
      x011 = QCPQx1
      x012 = QCPQx2
      x201 = PAQPx1*x101+B101
      x202 = PAQPx2*x102+B102
      x111 = PAQPx1*QCPQx1+B001
      x112 = PAQPx2*QCPQx2+B002
      x211 = PAQPx1*x111+B101*x011+B001*x101
      x212 = PAQPx2*x112+B102*x012+B002*x102
      y101 = PAQPy1
      y102 = PAQPy2
      y011 = QCPQy1
      y012 = QCPQy2
      y201 = PAQPy1*y101+B101
      y202 = PAQPy2*y102+B102
      y111 = PAQPy1*QCPQy1+B001
      y112 = PAQPy2*QCPQy2+B002
      y211 = PAQPy1*y111+B101*y011+B001*y101
      y212 = PAQPy2*y112+B102*y012+B002*y102
      z101 = PAQPz1*w1
      z102 = PAQPz2*w2
      z011 = QCPQz1*w1
      z012 = QCPQz2*w2
      z201 = PAQPz1*z101+B101*w1
      z202 = PAQPz2*z102+B102*w2
      z111 = PAQPz1*QCPQz1*w1+B001*w1
      z112 = PAQPz2*QCPQz2*w2+B002*w2
      z211 = PAQPz1*z111+B101*z011+B001*z101
      z212 = PAQPz2*z112+B102*z012+B002*z102
      EFInt(iZeta,iEta,1) = x211*w1+x212*w2
      EFInt(iZeta,iEta,2) = x111*y101*w1+x112*y102*w2
      EFInt(iZeta,iEta,3) = x111*z101+x112*z102
      EFInt(iZeta,iEta,4) = y201*x011*w1+y202*x012*w2
      EFInt(iZeta,iEta,5) = y101*(z101*x011)+y102*(z102*x012)
      EFInt(iZeta,iEta,6) = z201*x011+z202*x012
      EFInt(iZeta,iEta,7) = x201*y011*w1+x202*y012*w2
      EFInt(iZeta,iEta,8) = x101*y111*w1+x102*y112*w2
      EFInt(iZeta,iEta,9) = x101*(z101*y011)+x102*(z102*y012)
      EFInt(iZeta,iEta,10) = y211*w1+y212*w2
      EFInt(iZeta,iEta,11) = y111*z101+y112*z102
      EFInt(iZeta,iEta,12) = z201*y011+z202*y012
      EFInt(iZeta,iEta,13) = x201*z011+x202*z012
      EFInt(iZeta,iEta,14) = x101*(y101*z011)+x102*(y102*z012)
      EFInt(iZeta,iEta,15) = x101*z111+x102*z112
      EFInt(iZeta,iEta,16) = y201*z011+y202*z012
      EFInt(iZeta,iEta,17) = y101*z111+y102*z112
      EFInt(iZeta,iEta,18) = z211+z212
    end do
  end do

else if ((.not. EQ(A,B)) .and. EQ(C,D)) then

  ! ABCC case

  do iEta=1,nEta
    do iZeta=1,nZeta
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      rho = Zeta(iZeta)*(Eta(iEta)*ZEInv)
      PQx = P(iZeta,1)-CoorAC(1,2)
      PQy = P(iZeta,2)-CoorAC(2,2)
      PQz = P(iZeta,3)-CoorAC(3,2)
      T = rho*(PQx**2+PQy**2+PQz**2)
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w1 = (((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
        w2 = (((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
        r1 = (((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
        r2 = (((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
      else
        ai = One/T
        si = sqrt(ai)
        w1 = HerW(1)*si
        w2 = HerW(2)*si
        r1 = HerR2(1)*ai
        r2 = HerR2(2)*ai
      end if
      PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)
      w1 = PreFct*w1
      w2 = PreFct*w2
      Eu21 = Eta(iEta)*(r1*ZEInv)
      Eu22 = Eta(iEta)*(r2*ZEInv)
      Zu21 = Zeta(iZeta)*(r1*ZEInv)
      Zu22 = Zeta(iZeta)*(r2*ZEInv)
      PAQPx1 = (P(iZeta,1)-CoorAC(1,1))-Eu21*PQx
      PAQPx2 = (P(iZeta,1)-CoorAC(1,1))-Eu22*PQx
      PAQPy1 = (P(iZeta,2)-CoorAC(2,1))-Eu21*PQy
      PAQPy2 = (P(iZeta,2)-CoorAC(2,1))-Eu22*PQy
      PAQPz1 = (P(iZeta,3)-CoorAC(3,1))-Eu21*PQz
      PAQPz2 = (P(iZeta,3)-CoorAC(3,1))-Eu22*PQz
      QCPQx1 = Zu21*PQx
      QCPQx2 = Zu22*PQx
      QCPQy1 = Zu21*PQy
      QCPQy2 = Zu22*PQy
      QCPQz1 = Zu21*PQz
      QCPQz2 = Zu22*PQz
      B001 = Half*(r1*ZEInv)
      B002 = Half*(r2*ZEInv)
      B101 = (Half-Half*Eu21)*ZInv(iZeta)
      B102 = (Half-Half*Eu22)*ZInv(iZeta)
      x101 = PAQPx1
      x102 = PAQPx2
      x011 = QCPQx1
      x012 = QCPQx2
      x201 = PAQPx1*x101+B101
      x202 = PAQPx2*x102+B102
      x111 = PAQPx1*QCPQx1+B001
      x112 = PAQPx2*QCPQx2+B002
      x211 = PAQPx1*x111+B101*x011+B001*x101
      x212 = PAQPx2*x112+B102*x012+B002*x102
      y101 = PAQPy1
      y102 = PAQPy2
      y011 = QCPQy1
      y012 = QCPQy2
      y201 = PAQPy1*y101+B101
      y202 = PAQPy2*y102+B102
      y111 = PAQPy1*QCPQy1+B001
      y112 = PAQPy2*QCPQy2+B002
      y211 = PAQPy1*y111+B101*y011+B001*y101
      y212 = PAQPy2*y112+B102*y012+B002*y102
      z101 = PAQPz1*w1
      z102 = PAQPz2*w2
      z011 = QCPQz1*w1
      z012 = QCPQz2*w2
      z201 = PAQPz1*z101+B101*w1
      z202 = PAQPz2*z102+B102*w2
      z111 = PAQPz1*QCPQz1*w1+B001*w1
      z112 = PAQPz2*QCPQz2*w2+B002*w2
      z211 = PAQPz1*z111+B101*z011+B001*z101
      z212 = PAQPz2*z112+B102*z012+B002*z102
      EFInt(iZeta,iEta,1) = x111*w1+x112*w2
      EFInt(iZeta,iEta,2) = y101*x011*w1+y102*x012*w2
      EFInt(iZeta,iEta,3) = (z101*x011)+(z102*x012)
      EFInt(iZeta,iEta,4) = x211*w1+x212*w2
      EFInt(iZeta,iEta,5) = x111*y101*w1+x112*y102*w2
      EFInt(iZeta,iEta,6) = x111*z101+x112*z102
      EFInt(iZeta,iEta,7) = y201*x011*w1+y202*x012*w2
      EFInt(iZeta,iEta,8) = y101*(z101*x011)+y102*(z102*x012)
      EFInt(iZeta,iEta,9) = z201*x011+z202*x012
      EFInt(iZeta,iEta,10) = x101*y011*w1+x102*y012*w2
      EFInt(iZeta,iEta,11) = y111*w1+y112*w2
      EFInt(iZeta,iEta,12) = (z101*y011)+(z102*y012)
      EFInt(iZeta,iEta,13) = x201*y011*w1+x202*y012*w2
      EFInt(iZeta,iEta,14) = x101*y111*w1+x102*y112*w2
      EFInt(iZeta,iEta,15) = x101*(z101*y011)+x102*(z102*y012)
      EFInt(iZeta,iEta,16) = y211*w1+y212*w2
      EFInt(iZeta,iEta,17) = y111*z101+y112*z102
      EFInt(iZeta,iEta,18) = z201*y011+z202*y012
      EFInt(iZeta,iEta,19) = x101*z011+x102*z012
      EFInt(iZeta,iEta,20) = (y101*z011)+(y102*z012)
      EFInt(iZeta,iEta,21) = z111+z112
      EFInt(iZeta,iEta,22) = x201*z011+x202*z012
      EFInt(iZeta,iEta,23) = x101*(y101*z011)+x102*(y102*z012)
      EFInt(iZeta,iEta,24) = x101*z111+x102*z112
      EFInt(iZeta,iEta,25) = y201*z011+y202*z012
      EFInt(iZeta,iEta,26) = y101*z111+y102*z112
      EFInt(iZeta,iEta,27) = z211+z212
    end do
  end do

else if (EQ(A,B) .and. EQ(C,D)) then

  ! AACC case

  PQx = CoorAC(1,1)-CoorAC(1,2)
  PQy = CoorAC(2,1)-CoorAC(2,2)
  PQz = CoorAC(3,1)-CoorAC(3,2)
  PQ2 = (PQx**2+PQy**2+PQz**2)
  do iEta=1,nEta
    do iZeta=1,nZeta
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      rho = Zeta(iZeta)*(Eta(iEta)*ZEInv)
      T = rho*PQ2
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w1 = (((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
        w2 = (((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
        r1 = (((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
        r2 = (((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
      else
        ai = One/T
        si = sqrt(ai)
        w1 = HerW(1)*si
        w2 = HerW(2)*si
        r1 = HerR2(1)*ai
        r2 = HerR2(2)*ai
      end if
      PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)
      w1 = PreFct*w1
      w2 = PreFct*w2
      Eu21 = Eta(iEta)*(r1*ZEInv)
      Eu22 = Eta(iEta)*(r2*ZEInv)
      Zu21 = Zeta(iZeta)*(r1*ZEInv)
      Zu22 = Zeta(iZeta)*(r2*ZEInv)
      PAQPx1 = -Eu21*PQx
      PAQPx2 = -Eu22*PQx
      PAQPy1 = -Eu21*PQy
      PAQPy2 = -Eu22*PQy
      PAQPz1 = -Eu21*PQz
      PAQPz2 = -Eu22*PQz
      QCPQx1 = Zu21*PQx
      QCPQx2 = Zu22*PQx
      QCPQy1 = Zu21*PQy
      QCPQy2 = Zu22*PQy
      QCPQz1 = Zu21*PQz
      QCPQz2 = Zu22*PQz
      B001 = Half*(r1*ZEInv)
      B002 = Half*(r2*ZEInv)
      B101 = (Half-Half*Eu21)*ZInv(iZeta)
      B102 = (Half-Half*Eu22)*ZInv(iZeta)
      x101 = PAQPx1
      x102 = PAQPx2
      x011 = QCPQx1
      x012 = QCPQx2
      x201 = PAQPx1*x101+B101
      x202 = PAQPx2*x102+B102
      x111 = PAQPx1*QCPQx1+B001
      x112 = PAQPx2*QCPQx2+B002
      x211 = PAQPx1*x111+B101*x011+B001*x101
      x212 = PAQPx2*x112+B102*x012+B002*x102
      y101 = PAQPy1
      y102 = PAQPy2
      y011 = QCPQy1
      y012 = QCPQy2
      y201 = PAQPy1*y101+B101
      y202 = PAQPy2*y102+B102
      y111 = PAQPy1*QCPQy1+B001
      y112 = PAQPy2*QCPQy2+B002
      y211 = PAQPy1*y111+B101*y011+B001*y101
      y212 = PAQPy2*y112+B102*y012+B002*y102
      z101 = PAQPz1*w1
      z102 = PAQPz2*w2
      z011 = QCPQz1*w1
      z012 = QCPQz2*w2
      z201 = PAQPz1*z101+B101*w1
      z202 = PAQPz2*z102+B102*w2
      z111 = PAQPz1*QCPQz1*w1+B001*w1
      z112 = PAQPz2*QCPQz2*w2+B002*w2
      z211 = PAQPz1*z111+B101*z011+B001*z101
      z212 = PAQPz2*z112+B102*z012+B002*z102
      EFInt(iZeta,iEta,1) = x211*w1+x212*w2
      EFInt(iZeta,iEta,2) = x111*y101*w1+x112*y102*w2
      EFInt(iZeta,iEta,3) = x111*z101+x112*z102
      EFInt(iZeta,iEta,4) = y201*x011*w1+y202*x012*w2
      EFInt(iZeta,iEta,5) = y101*(z101*x011)+y102*(z102*x012)
      EFInt(iZeta,iEta,6) = z201*x011+z202*x012
      EFInt(iZeta,iEta,7) = x201*y011*w1+x202*y012*w2
      EFInt(iZeta,iEta,8) = x101*y111*w1+x102*y112*w2
      EFInt(iZeta,iEta,9) = x101*(z101*y011)+x102*(z102*y012)
      EFInt(iZeta,iEta,10) = y211*w1+y212*w2
      EFInt(iZeta,iEta,11) = y111*z101+y112*z102
      EFInt(iZeta,iEta,12) = z201*y011+z202*y012
      EFInt(iZeta,iEta,13) = x201*z011+x202*z012
      EFInt(iZeta,iEta,14) = x101*(y101*z011)+x102*(y102*z012)
      EFInt(iZeta,iEta,15) = x101*z111+x102*z112
      EFInt(iZeta,iEta,16) = y201*z011+y202*z012
      EFInt(iZeta,iEta,17) = y101*z111+y102*z112
      EFInt(iZeta,iEta,18) = z211+z212
    end do
  end do

else

  ! ABCD case

  do iEta=1,nEta
    do iZeta=1,nZeta
      ZEInv = One/(Eta(iEta)+Zeta(iZeta)+(Eta(iEta)*Zeta(iZeta)*ChiI2)*real(IsChi,kind=wp))
      rho = Zeta(iZeta)*(Eta(iEta)*ZEInv)
      PQx = P(iZeta,1)-Q(iEta,1)
      PQy = P(iZeta,2)-Q(iEta,2)
      PQz = P(iZeta,3)-Q(iEta,3)
      T = rho*(PQx**2+PQy**2+PQz**2)
      if (T < TMax) then
        n = iPntr(int((T+dddx)*xdInv))
        z = T-x0(n)
        w1 = (((((CW6(n,1)*z+CW5(n,1))*z+CW4(n,1))*z+CW3(n,1))*z+CW2(n,1))*z+CW1(n,1))*z+Cw0(n,1)
        w2 = (((((CW6(n,2)*z+CW5(n,2))*z+CW4(n,2))*z+CW3(n,2))*z+CW2(n,2))*z+CW1(n,2))*z+Cw0(n,2)
        r1 = (((((CR6(n,1)*z+CR5(n,1))*z+CR4(n,1))*z+CR3(n,1))*z+CR2(n,1))*z+CR1(n,1))*z+CR0(n,1)
        r2 = (((((CR6(n,2)*z+CR5(n,2))*z+CR4(n,2))*z+CR3(n,2))*z+CR2(n,2))*z+CR1(n,2))*z+CR0(n,2)
      else
        ai = One/T
        si = sqrt(ai)
        w1 = HerW(1)*si
        w2 = HerW(2)*si
        r1 = HerR2(1)*ai
        r2 = HerR2(2)*ai
      end if
      PreFct = rKappCD(iEta)*rKappAB(iZeta)*sqrt(ZEInv)
      w1 = PreFct*w1
      w2 = PreFct*w2
      Eu21 = Eta(iEta)*(r1*ZEInv)
      Eu22 = Eta(iEta)*(r2*ZEInv)
      Zu21 = Zeta(iZeta)*(r1*ZEInv)
      Zu22 = Zeta(iZeta)*(r2*ZEInv)
      PAQPx1 = (P(iZeta,1)-CoorAC(1,1))-Eu21*PQx
      PAQPx2 = (P(iZeta,1)-CoorAC(1,1))-Eu22*PQx
      PAQPy1 = (P(iZeta,2)-CoorAC(2,1))-Eu21*PQy
      PAQPy2 = (P(iZeta,2)-CoorAC(2,1))-Eu22*PQy
      PAQPz1 = (P(iZeta,3)-CoorAC(3,1))-Eu21*PQz
      PAQPz2 = (P(iZeta,3)-CoorAC(3,1))-Eu22*PQz
      QCPQx1 = (Q(iEta,1)-CoorAC(1,2))+Zu21*PQx
      QCPQx2 = (Q(iEta,1)-CoorAC(1,2))+Zu22*PQx
      QCPQy1 = (Q(iEta,2)-CoorAC(2,2))+Zu21*PQy
      QCPQy2 = (Q(iEta,2)-CoorAC(2,2))+Zu22*PQy
      QCPQz1 = (Q(iEta,3)-CoorAC(3,2))+Zu21*PQz
      QCPQz2 = (Q(iEta,3)-CoorAC(3,2))+Zu22*PQz
      B001 = Half*(r1*ZEInv)
      B002 = Half*(r2*ZEInv)
      B101 = (Half-Half*Eu21)*ZInv(iZeta)
      B102 = (Half-Half*Eu22)*ZInv(iZeta)
      x101 = PAQPx1
      x102 = PAQPx2
      x011 = QCPQx1
      x012 = QCPQx2
      x201 = PAQPx1*x101+B101
      x202 = PAQPx2*x102+B102
      x111 = PAQPx1*QCPQx1+B001
      x112 = PAQPx2*QCPQx2+B002
      x211 = PAQPx1*x111+B101*x011+B001*x101
      x212 = PAQPx2*x112+B102*x012+B002*x102
      y101 = PAQPy1
      y102 = PAQPy2
      y011 = QCPQy1
      y012 = QCPQy2
      y201 = PAQPy1*y101+B101
      y202 = PAQPy2*y102+B102
      y111 = PAQPy1*QCPQy1+B001
      y112 = PAQPy2*QCPQy2+B002
      y211 = PAQPy1*y111+B101*y011+B001*y101
      y212 = PAQPy2*y112+B102*y012+B002*y102
      z101 = PAQPz1*w1
      z102 = PAQPz2*w2
      z011 = QCPQz1*w1
      z012 = QCPQz2*w2
      z201 = PAQPz1*z101+B101*w1
      z202 = PAQPz2*z102+B102*w2
      z111 = PAQPz1*QCPQz1*w1+B001*w1
      z112 = PAQPz2*QCPQz2*w2+B002*w2
      z211 = PAQPz1*z111+B101*z011+B001*z101
      z212 = PAQPz2*z112+B102*z012+B002*z102
      EFInt(iZeta,iEta,1) = x111*w1+x112*w2
      EFInt(iZeta,iEta,2) = y101*x011*w1+y102*x012*w2
      EFInt(iZeta,iEta,3) = (z101*x011)+(z102*x012)
      EFInt(iZeta,iEta,4) = x211*w1+x212*w2
      EFInt(iZeta,iEta,5) = x111*y101*w1+x112*y102*w2
      EFInt(iZeta,iEta,6) = x111*z101+x112*z102
      EFInt(iZeta,iEta,7) = y201*x011*w1+y202*x012*w2
      EFInt(iZeta,iEta,8) = y101*(z101*x011)+y102*(z102*x012)
      EFInt(iZeta,iEta,9) = z201*x011+z202*x012
      EFInt(iZeta,iEta,10) = x101*y011*w1+x102*y012*w2
      EFInt(iZeta,iEta,11) = y111*w1+y112*w2
      EFInt(iZeta,iEta,12) = (z101*y011)+(z102*y012)
      EFInt(iZeta,iEta,13) = x201*y011*w1+x202*y012*w2
      EFInt(iZeta,iEta,14) = x101*y111*w1+x102*y112*w2
      EFInt(iZeta,iEta,15) = x101*(z101*y011)+x102*(z102*y012)
      EFInt(iZeta,iEta,16) = y211*w1+y212*w2
      EFInt(iZeta,iEta,17) = y111*z101+y112*z102
      EFInt(iZeta,iEta,18) = z201*y011+z202*y012
      EFInt(iZeta,iEta,19) = x101*z011+x102*z012
      EFInt(iZeta,iEta,20) = (y101*z011)+(y102*z012)
      EFInt(iZeta,iEta,21) = z111+z112
      EFInt(iZeta,iEta,22) = x201*z011+x202*z012
      EFInt(iZeta,iEta,23) = x101*(y101*z011)+x102*(y102*z012)
      EFInt(iZeta,iEta,24) = x101*z111+x102*z112
      EFInt(iZeta,iEta,25) = y201*z011+y202*z012
      EFInt(iZeta,iEta,26) = y101*z111+y102*z112
      EFInt(iZeta,iEta,27) = z211+z212
    end do
  end do

end if

return

end subroutine ppps

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,1999, Per Ake Malmqvist                           *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
* 1999: GEMINAL R12 ENABLED                  *
*--------------------------------------------*
      SUBROUTINE SIGMA_CASPT2(ALPHA,BETA,IVEC,JVEC)
      use Fockof
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "sigma.fh"
#include "SysDef.fh"
#include "cplcas.fh"

C Compute |JVEC> := BETA* |JVEC> + ALPHA* (H0-E0)* |IVEC>
C where the vectors are represented in transformed basis and
C are  stored at positions IVEC and JVEC on the LUSOLV unit.


#ifdef _DEBUGPRINT_
      WRITE(6,*)' Entering SIGMA.'
      WRITE(6,*)
     &' Compute |JVEC> := Beta*|JVEC> + Alpha*(H0-E0)|IVEC>'
      WRITE(6,'(1x,a,2f15.6)')'Alpha,Beta:',Alpha,Beta
      WRITE(6,'(1x,a,2i5)')'IVEC,JVEC:',IVEC,JVEC
#endif

C Enter coupling cases for non-diagonal blocks:
      DO J=1,NCASES
      DO I=1,NCASES
      IFCOUP(I,J)=0
      END DO
      END DO
      IFCOUP( 2, 1)= 1
      IFCOUP( 3, 1)= 2
      IFCOUP( 5, 1)= 3
      IFCOUP( 6, 1)= 4
      IFCOUP( 7, 1)= 5
      IFCOUP( 6, 2)= 6
      IFCOUP( 7, 3)= 7
      IFCOUP( 5, 4)= 8
      IFCOUP( 8, 4)= 9
      IFCOUP( 9, 4)=10
      IFCOUP(10, 4)=11
      IFCOUP(11, 4)=12
      IFCOUP( 6, 5)=13
      IFCOUP( 7, 5)=14
      IFCOUP(10, 5)=15
      IFCOUP(11, 5)=16
      IFCOUP(12, 5)=23
      IFCOUP(13, 5)=24
      IFCOUP(12, 6)=17
      IFCOUP(13, 7)=18
      IFCOUP(10, 8)=19
      IFCOUP(11, 9)=20
      IFCOUP(12,10)=21
      IFCOUP(13,11)=22

C If the G1 correction to the Fock matrix is used, then the
C inactive/virtual coupling elements (which are non-zero for the
C case of average CASSCF) cannot be used in the CASPT2 equations.
      IF(FOCKTYPE.EQ.'G1      ' .AND. (.NOT. G1SECIN)) THEN
        IFCOUP(12,5)=0
        IFCOUP(13,5)=0
      END IF

      IFTEST=0
C Flop counts:
      NFSCA=0
      NFDXP=0
      NFMV =0
      NFR1 =0
C First compute diagonal block contributions:
CTEST      WRITE(6,*)' First, do it for (H0(diag)-E0).'
      CALL PSGMDIA(ALPHA,BETA,IVEC,JVEC)
      IF(ALPHA.EQ.0.0D0) GOTO 99
CTEST      WRITE(6,*)
CTEST     & ' From now on, scaling with BETA is already done.'
CTEST      WRITE(6,*)' Test print  after SGMDIA call in SIGMA:'
CTEST      WRITE(6,*)' Should be zero, in first iteration.'
CTEST      CALL OVLPRT(JVEC,JVEC,OVLAPS)
C From now on, scaling with BETA is already done.

C Transform to standard representation:
      CALL PTRTOC(0,IVEC,IVEC)
      CALL PTRTOC(1,JVEC,JVEC)

C Set up non-diagonal blocks of Fock matrix:
C SVC: add transposed fock matrix blocks
      NFIT=0
      NFIA=0
      NFTA=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NS=NSSH(ISYM)
        IOFFIT(ISYM)=NFIT
        IOFFIA(ISYM)=NFIA
        IOFFTA(ISYM)=NFTA
        NFIT=NFIT+NA*NI
        NFIA=NFIA+NS*NI
        NFTA=NFTA+NS*NA
      END DO
      NFIT=NFIT+1 !?
      NFIA=NFIA+1 !?
      NFTA=NFTA+1 !?

      Call mma_allocate(FIT_Full,NFIT,Label='FIT_Full')
      Call mma_allocate(FTI_Full,NFIT,Label='FTI_Full')

      Call mma_allocate(FIA_Full,NFIA,Label='FIA_Full')
      Call mma_allocate(FAI_Full,NFIA,Label='FAI_Full')

      Call mma_allocate(FTA_Full,NFTA,Label='FTA_Full')
      Call mma_allocate(FAT_Full,NFTA,Label='FAT_Full')

      IFIFA=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NS=NSSH(ISYM)
        NO=NORB(ISYM)

        FIT(ISYM)%A(1:NA*NI) =>
     &     FIT_Full(IOFFIT(ISYM)+1:IOFFIT(ISYM)+NA*NI)
        FTI(ISYM)%A(1:NA*NI) =>
     &     FTI_Full(IOFFIT(ISYM)+1:IOFFIT(ISYM)+NA*NI)

        FIA(ISYM)%A(1:NS*NI) =>
     &     FIA_Full(IOFFIA(ISYM)+1:IOFFIA(ISYM)+NS*NI)
        FAI(ISYM)%A(1:NS*NI) =>
     &     FAI_Full(IOFFIA(ISYM)+1:IOFFIA(ISYM)+NS*NI)

        FTA(ISYM)%A(1:NS*NA) =>
     &     FTA_Full(IOFFTA(ISYM)+1:IOFFTA(ISYM)+NS*NA)
        FAT(ISYM)%A(1:NS*NA) =>
     &     FAT_Full(IOFFTA(ISYM)+1:IOFFTA(ISYM)+NS*NA)

        CALL FBLOCK(WORK(LFIFA+IFIFA),NO,NI,NA,NS,
     &              FIT(ISYM)%A(:),FTI(ISYM)%A(:),
     &              FIA(ISYM)%A(:),FAI(ISYM)%A(:),
     &              FTA(ISYM)%A(:),FAT(ISYM)%A(:))

        IFIFA=IFIFA+(NO*(NO+1))/2

      END DO

      CALL TIMING(CPU0,CPU,TIO0,TIO)
C Loop over types and symmetry block of sigma vector:
      DO 300 ICASE1=1,11
*     DO 300 ICASE1=1,NCASES
        DO 301 ISYM1=1,NSYM
          IF(NINDEP(ISYM1,ICASE1).EQ.0) GOTO 301
          NIS1=NISUP(ISYM1,ICASE1)
          NAS1=NASUP(ISYM1,ICASE1)
          NSGM2=NIS1*NAS1
          IF(NSGM2.EQ.0) GOTO 301

          CALL GETMEM('SGM2','ALLO','REAL',LSGM2,NSGM2)
          CALL DCOPY_(NSGM2,[0.0D0],0,WORK(LSGM2),1)

          NSGM1=0
          LSGM1=1
          IF(ICASE1.EQ.1) THEN
            NSGM1=NASH(ISYM1)*NISH(ISYM1)
          ELSE IF(ICASE1.EQ.4) THEN
            NSGM1=NASH(ISYM1)*NSSH(ISYM1)
          ELSE IF(ICASE1.EQ.5.AND.ISYM1.EQ.1) THEN
            NSGM1=NIS1
          END IF
          IF(NSGM1.GT.0) THEN
            CALL GETMEM('SGM1','ALLO','REAL',LSGM1,NSGM1)
            CALL DCOPY_(NSGM1,[0.0D0],0,WORK(LSGM1),1)
          END IF

          IMLTOP=0
          DO 200 ICASE2=ICASE1+1,NCASES
            IFC=IFCOUP(ICASE2,ICASE1)
            IF(IFC.EQ.0) GOTO 200
            DO 100 ISYM2=1,NSYM
              IF(NINDEP(ISYM2,ICASE2).EQ.0) GOTO 100
              NIS2=NISUP(ISYM2,ICASE2)
              NAS2=NASUP(ISYM2,ICASE2)
              NCX=NIS2*NAS2
              IF(NCX.EQ.0) GOTO 100

              CALL RHS_ALLO(NAS2,NIS2,lg_CX)
              CALL RHS_READ(NAS2,NIS2,lg_CX,ICASE2,ISYM2,IVEC)
C SVC: for case H (12,13) we can now pass the distributed array ID to
C the SGM subroutines
              IF (ICASE2.EQ.12 .OR. ICASE2.EQ.13) THEN
                LCX=lg_CX
                XTST=RHS_DDOT(NAS2,NIS2,lg_CX,lg_CX)
              ELSE
                CALL GETMEM('CX','ALLO','REAL',LCX,NCX)
                CALL RHS_GET(NAS2,NIS2,lg_CX,WORK(LCX))
                CALL RHS_FREE(NAS2,NIS2,lg_CX)
                XTST=DDOT_(NCX,WORK(LCX),1,WORK(LCX),1)
              END IF

              IF(XTST.GT.1.0D12) THEN
                WRITE(6,'(1x,a,6i10)')' SIGMA A. ICASE2,ISYM2:',
     &                                           ICASE2,ISYM2
                GOTO 999
              END IF

#ifdef _DEBUGPRINT_
              WRITE(6,*)' ISYM1,ICASE1:',ISYM1,ICASE1
              WRITE(6,*)' ISYM2,ICASE2:',ISYM2,ICASE2
              WRITE(6,*)' SIGMA calling SGM with IMLTOP=',IMLTOP
#endif
C Compute contribution SGM2 <- CX, and SGM1 <- CX  if any
              CALL SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,
     &                 WORK(LSGM1),LSGM2,LCX,iWORK(LLISTS))

              IF (ICASE2.EQ.12 .OR. ICASE2.EQ.13) THEN
                CALL RHS_FREE(NAS2,NIS2,lg_CX)
              ELSE
                CALL GETMEM('CX','FREE','REAL',LCX,NCX)
              END IF

C Check for colossal values of SGM2 and SGM1
              XTST=DDOT_(NSGM2,WORK(LSGM2),1,WORK(LSGM2),1)
              IF(XTST.GT.1.0D12) THEN
                WRITE(6,'(1x,a,6i10)')' SIGMA B. ICASE1,ISYM1:',
     &                                           ICASE1,ISYM1
                WRITE(6,'(1x,a,6i10)')'          ICASE2,ISYM2:',
     &                                           ICASE2,ISYM2
                GOTO 999
              END IF

              IF(NSGM1.GT.0) THEN
                XTST=DDOT_(NSGM1,WORK(LSGM1),1,WORK(LSGM1),1)
                IF(XTST.GT.1.0D12) THEN
                  WRITE(6,'(1x,a,6i10)')' SIGMA B2. ICASE1,ISYM1:',
     &                                              ICASE1,ISYM1
                  WRITE(6,'(1x,a,6i10)')'           ICASE2,ISYM2:',
     &                                              ICASE2,ISYM2
                  GOTO 999
                END IF
              END IF

 100        CONTINUE
 200      CONTINUE

C-SVC: sum the replicate arrays:
          MAX_MESG_SIZE = 2**27
          DO LSGM2_STA=1,NSGM2,MAX_MESG_SIZE
            NSGM2_BLK=MIN(MAX_MESG_SIZE,NSGM2-LSGM2_STA+1)
            CALL GADSUM(WORK(LSGM2+LSGM2_STA-1),NSGM2_BLK)
          END DO

          IF (NSGM1.GT.0) THEN
            CALL GADSUM(WORK(LSGM1),NSGM1)
          END IF

C       XTST2=DDOT_(NSGM2,WORK(LSGM2),1,WORK(LSGM2),1)
C       XTST1=0.0D0
C       IF(NSGM1.GT.0)XTST1=DDOT_(NSGM1,WORK(LSGM1),1,WORK(LSGM1),1)
C       WRITE(6,'(1x,a,a,i2,2f16.6)')
C    & 'Contr. SGM2, SGM1, ',cases(icase1),isym1,xtst2,xtst1

C If there are 1-electron contributions, add them into the 2-el
C part (This requires a non-empty active space.)
          IF(NSGM1.GT.0) THEN
            FACT=1.0D00/(DBLE(MAX(1,NACTEL)))
            IF (ICASE1.EQ.1) THEN
              CALL SPEC1A(IMLTOP,FACT,ISYM1,WORK(LSGM2),
     &                  WORK(LSGM1))
            ELSE IF(ICASE1.EQ.4) THEN
              CALL SPEC1C(IMLTOP,FACT,ISYM1,WORK(LSGM2),
     &                  WORK(LSGM1))
            ELSE IF(ICASE1.EQ.5.AND.ISYM1.EQ.1) THEN
              CALL SPEC1D(IMLTOP,FACT,WORK(LSGM2),WORK(LSGM1))
            END IF

            XTST=DDOT_(NSGM2,WORK(LSGM2),1,WORK(LSGM2),1)
            IF(XTST.GT.1.0D12) THEN
              WRITE(6,'(1x,a,6i10)')' SIGMA C. ICASE1,ISYM1:',
     &                                         ICASE1,ISYM1
              GOTO 999
            END IF

            CALL GETMEM('SGM1','FREE','REAL',LSGM1,NSGM1)
          END IF

C-SVC: no need for the replicate arrays any more, fall back to one array
          CALL RHS_ALLO (NAS1,NIS1,lg_SGM2)
          CALL RHS_PUT (NAS1,NIS1,lg_SGM2,WORK(LSGM2))
          CALL GETMEM('SGM2','FREE','REAL',LSGM2,NSGM2)

C Add to sigma array. Multiply by S to  lower index.
          NSGMX=NSGM2
          CALL RHS_ALLO(NAS1,NIS1,lg_SGMX)
          CALL RHS_READ(NAS1,NIS1,lg_SGMX,ICASE1,ISYM1,JVEC)

          XTST=RHS_DDOT(NAS1,NIS1,lg_SGMX,lg_SGMX)
          IF(XTST.GT.1.0D12) THEN
            WRITE(6,'(1x,a,6i10)')' SIGMA D. ICASE1,ISYM1:',ICASE1,ISYM1
            WRITE(6,'(1x,a,6i10)')'          ICASE2,ISYM2:',ICASE2,ISYM2
            GOTO 999
          END IF

*         IF(ICASE1.NE.12 .AND. ICASE1.NE.13) THEN
            CALL RHS_STRANS(NAS1,NIS1,ALPHA,lg_SGM2,lg_SGMX,
     &                      ICASE1,ISYM1)
*         ELSE
*           CALL RHS_DAXPY(NAS1,NIS1,ALPHA,lg_SGM2,lg_SGMX)
*         END IF
          CALL RHS_FREE (NAS1,NIS1,lg_SGM2)

          XTST=RHS_DDOT(NAS1,NIS1,lg_SGMX,lg_SGMX)
          IF(XTST.GT.1.0D12) THEN
            WRITE(6,'(1x,a,6i10)')' SIGMA E. ICASE1,ISYM1:',ICASE1,ISYM1
            WRITE(6,'(1x,a,6i10)')'          ICASE2,ISYM2:',ICASE2,ISYM2
            GOTO 999
          END IF

C Write SGMX to disk.
          CALL RHS_SAVE (NAS1,NIS1,lg_SGMX,ICASE1,ISYM1,JVEC)
          CALL RHS_FREE (NAS1,NIS1,lg_SGMX)
 301    CONTINUE
 300  CONTINUE

      IMLTOP=1
C Loop over types and symmetry block of CX vector:
      DO 600 ICASE1=1,11
*     DO 600 ICASE1=1,NCASES
        DO 601 ISYM1=1,NSYM
          IF(NINDEP(ISYM1,ICASE1).EQ.0) GOTO 601
          NIS1=NISUP(ISYM1,ICASE1)
          NAS1=NASUP(ISYM1,ICASE1)
          ND2=NIS1*NAS1
          IF(ND2.EQ.0) GOTO 601

          CALL RHS_ALLO (NAS1,NIS1,lg_D2)
          CALL RHS_SCAL (NAS1,NIS1,lg_D2,0.0D0)
C Contract S*CX to form D2. Also form D1 from D2, if needed.

          NCX=ND2
          CALL RHS_ALLO (NAS1,NIS1,lg_CX)
          CALL RHS_READ (NAS1,NIS1,lg_CX,ICASE1,ISYM1,IVEC)

          XTST=RHS_DDOT(NAS1,NIS1,lg_CX,lg_CX)
          IF(XTST.GT.1.0D12) THEN
            WRITE(6,'(1x,a,6i10)')' SIGMA F. ICASE1,ISYM1:',ICASE1,ISYM1
            GOTO 999
          END IF

          IF(ICASE1.NE.12 .AND. ICASE1.NE.13) THEN
           CALL RHS_STRANS (NAS1,NIS1,ALPHA,lg_CX,lg_D2,ICASE1,ISYM1)
          ELSE
           CALL RHS_DAXPY(NAS1,NIS1,ALPHA,lg_CX,lg_D2)
          END IF
          CALL RHS_FREE (NAS1,NIS1,lg_CX)

CPAM Sanity check:
          XTST=RHS_DDOT(NAS1,NIS1,lg_D2,lg_D2)
          IF(XTST.GT.1.0D12) THEN
            WRITE(6,'(1x,a,6i10)')' SIGMA G1 ICASE1,ISYM1:',ICASE1,ISYM1
            WRITE(6,'(1x,a,6i10)')'          ICASE2,ISYM2:',ICASE2,ISYM2
            GOTO 999
          END IF

          CALL GETMEM('D2','ALLO','REAL',LD2,ND2)
          CALL RHS_GET (NAS1,NIS1,lg_D2,WORK(LD2))
          CALL RHS_FREE (NAS1,NIS1,lg_D2)

          ND1=0
          LD1=1
          IMLTOP=1
          FACT=1.0D00/(DBLE(MAX(1,NACTEL)))
          IF(ICASE1.EQ.1) THEN
            ND1=NASH(ISYM1)*NISH(ISYM1)
            IF(ND1.GT.0) THEN
              CALL GETMEM('D1','ALLO','REAL',LD1,ND1)
              CALL DCOPY_(ND1,[0.0D0],0,WORK(LD1),1)
              CALL SPEC1A(IMLTOP,FACT,ISYM1,WORK(LD2),
     &                    WORK(LD1))
            END IF
          ELSE IF(ICASE1.EQ.4) THEN
            ND1=NASH(ISYM1)*NSSH(ISYM1)
            IF(ND1.GT.0) THEN
              CALL GETMEM('D1','ALLO','REAL',LD1,ND1)
              CALL DCOPY_(ND1,[0.0D0],0,WORK(LD1),1)
              CALL SPEC1C(IMLTOP,FACT,ISYM1,WORK(LD2),
     &                    WORK(LD1))
            END IF
          ELSE IF(ICASE1.EQ.5.AND.ISYM1.EQ.1) THEN
            ND1=NIS1
            IF(ND1.GT.0) THEN
              CALL GETMEM('D1','ALLO','REAL',LD1,ND1)
              CALL DCOPY_(ND1,[0.0D0],0,WORK(LD1),1)
              CALL SPEC1D(IMLTOP,FACT,WORK(LD2),WORK(LD1))
            END IF
          END IF

          IF(ND1.GT.0) THEN
            XTST=DDOT_(ND1,WORK(LD1),1,WORK(LD1),1)
            IF(XTST.GT.1.0D12) THEN
              WRITE(6,'(1x,a,6i10)')' SIGMA G2 ICASE1,ISYM1:',
     &                                         ICASE1,ISYM1
              WRITE(6,'(1x,a,6i10)')'          ICASE2,ISYM2:',
     &                                         ICASE2,ISYM2
              GOTO 999
            END IF
          END IF

          DO 500 ICASE2=ICASE1+1,NCASES
            IF(IFCOUP(ICASE2,ICASE1).EQ.0) GOTO 500
            DO 400 ISYM2=1,NSYM
              IF(NINDEP(ISYM2,ICASE2).EQ.0) GOTO 400
              NIS2=NISUP(ISYM2,ICASE2)
              NAS2=NASUP(ISYM2,ICASE2)
              NSGMX=NIS2*NAS2
              IF(NSGMX.EQ.0) GOTO 400

              IF (ICASE2.EQ.12 .OR. ICASE2.EQ.13) THEN
                CALL RHS_ALLO(NAS2,NIS2,lg_SGMX)
                CALL RHS_READ(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
                LSGMX=lg_SGMX
              ELSE
                CALL GETMEM('SGMX','ALLO','REAL',LSGMX,NSGMX)
                CALL DCOPY_(NSGMX,[0.0D0],0,WORK(LSGMX),1)
              END IF

* SVC: this array is just zero....
*             XTST=DDOT_(NSGMX,WORK(LSGMX),1,WORK(LSGMX),1)
*             IF(XTST.GT.1.0D12) THEN
*               WRITE(6,'(1x,a,6i10)')' SIGMA H. ICASE1,ISYM1:',
*    &                                           ICASE1,ISYM1
*               WRITE(6,'(1x,a,6i10)')'          ICASE2,ISYM2:',
*    &                                           ICASE2,ISYM2
*               GOTO 999
*             END IF

#ifdef _DEBUGPRINT_
              WRITE(6,*)' ISYM1,ICASE1:',ISYM1,ICASE1
              WRITE(6,*)' ISYM2,ICASE2:',ISYM2,ICASE2
              WRITE(6,*)' SIGMA calling SGM with IMLTOP=',IMLTOP
#endif
C Compute contribution SGMX <- D2, and SGMX <- D1  if any
              CALL SGM(IMLTOP,ISYM1,ICASE1,ISYM2,ICASE2,
     &                 WORK(LD1),LD2,LSGMX,iWORK(LLISTS))

              IF (ICASE2.EQ.12 .OR. ICASE2.EQ.13) THEN
                XTST=RHS_DDOT(NAS2,NIS2,lg_SGMX,lg_SGMX)
              ELSE
                XTST=DDOT_(NSGMX,WORK(LSGMX),1,WORK(LSGMX),1)
              END IF

              IF(XTST.GT.1.0D12) THEN
                WRITE(6,'(1x,a,6i10)')' SIGMA I. ICASE1,ISYM1:',
     &                                           ICASE1,ISYM1
                WRITE(6,'(1x,a,6i10)')'          ICASE2,ISYM2:',
     &                                           ICASE2,ISYM2
                GOTO 999
              END IF

              IF (ICASE2.NE.12 .AND. ICASE2.NE.13) THEN
                MAX_MESG_SIZE = 2**27
                DO LSGMX_STA=1,NSGMX,MAX_MESG_SIZE
                  NSGMX_BLK=MIN(MAX_MESG_SIZE,NSGMX-LSGMX_STA+1)
                  CALL GADSUM(WORK(LSGMX+LSGMX_STA-1),NSGMX_BLK)
                END DO
                CALL RHS_ALLO(NAS2,NIS2,lg_SGMX)
                CALL RHS_READ(NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
                CALL RHS_ADD(NAS2,NIS2,lg_SGMX,WORK(LSGMX))
                CALL GETMEM('SGMX','FREE','REAL',LSGMX,NSGMX)
              END IF

C-SVC: no need for the replicate arrays any more, fall back to one array
              CALL RHS_SAVE (NAS2,NIS2,lg_SGMX,ICASE2,ISYM2,JVEC)
              CALL RHS_FREE (NAS2,NIS2,lg_SGMX)
 400        CONTINUE
 500      CONTINUE
          CALL GETMEM('D2','FREE','REAL',LD2,ND2)
          IF(ND1.GT.0) CALL GETMEM('D1','FREE','REAL',LD1,ND1)
 601    CONTINUE
 600  CONTINUE

      CALL TIMING(CPU1,CPU,TIO1,TIO)
      CPUSGM=CPUSGM+(CPU1-CPU0)
      TIOSGM=TIOSGM+(TIO1-TIO0)

#ifdef _DEBUGPRINT_
      WRITE(6,*)' End of SIGMA. Flop counts:'
      WRITE(6,'(a,i12)')' In MLTSCA:',NFSCA
      WRITE(6,'(a,i12)')' In MLTDXP:',NFDXP
      WRITE(6,'(a,i12)')' In MLTMV :',NFMV
      WRITE(6,'(a,i12)')' In MLTR1 :',NFR1
      WRITE(6,*)
#endif

      Call mma_deallocate(FIT_Full)
      Call mma_deallocate(FTI_Full)
      Call mma_deallocate(FIA_Full)
      Call mma_deallocate(FAI_Full)
      Call mma_deallocate(FTA_Full)
      Call mma_deallocate(FAT_Full)
      Do iSym = 1, nSym
         FIT(iSym)%A => Null()
         FTI(iSym)%A => Null()
         FIA(iSym)%A => Null()
         FAI(iSym)%A => Null()
         FTA(iSym)%A => Null()
         FAT(iSym)%A => Null()
      End Do

C Transform contrav C  to eigenbasis of H0(diag):
      CALL PTRTOSR(1,IVEC,IVEC)
C Transform covar. sigma to eigenbasis of H0(diag):
      CALL PTRTOSR(0,JVEC,JVEC)

  99  CONTINUE
      RETURN

 999  CONTINUE
C Error exit.
      WRITE(6,*)' Colossal value detected in SIGMA.'
      WRITE(6,*)' This implies that the thresholds used for linear'
      WRITE(6,*)' dependence removal must be increased.'
      WRITE(6,*)' Present values, THRSHN, THRSHS:',THRSHN,THRSHS
      WRITE(6,*)' Use keyword THRESHOLD in input to increase these'
      WRITE(6,*)' values and then run again.'
      CALL ABEND()
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               1996, Per Ake Malmqvist                                *
************************************************************************
      SubRoutine Drv1El()
************************************************************************
*                                                                      *
* Object: driver for computation of one-electron matrices.             *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January 1991                                             *
************************************************************************
      Use AMFI_Info
      Use Basis_Info
      Use GeoList
      Use MpmC
      Use PrpPnt
      Use External_Centers
      Use SW_file
      use Symmetry_Info, only: iChBas
      use Temporary_Parameters, only: PrPrt, Short, Primitive_Pass
      use PAM2
      use DKH_Info, only: BSS, DKroll
      use Sizes_of_Seward, only: S
      use Real_Info, only: PotNuc, kVector
      use Logical_Info, only: Vlct, lRel, lAMFI, NEMO, Do_FckInt,
     &                        DoFMM, EMFR, GIAO, lPSOI
      Implicit Real*8 (A-H,O-Z)
      External MltInt, KnEInt, MVeInt,  VeInt,  D1Int,  NAInt,  EFInt,
     &         OAMInt, OMQInt, DMSInt, WelInt, XFdInt,  PrjInt,
     &         QpVInt,  M1Int,  M2Int, SROInt, AMPInt, PXPInt,  PXInt,
     &          VPInt,  PPInt, CntInt, EMFInt,
     &         MltInt_GIAO,
     &         KneInt_GIAO,
     &          NAInt_GIAO,
     &          dTdmu_Int
      External MltMem, KnEMem, MVeMem,  VeMem,  D1Mem,  NAMem,  EFMem,
     &         OAMMem, OMQMem, DMSMem, WelMem, XFdMem,  PrjMem,
     &         QpVMem,  M1Mem,  M2Mem, SROMem, AMPMem, PXPmem,  PXMem,
     &          VPMem,  PPMem, CntMem, EMFMem,
     &         MltMem_GIAO,
     &         KneMem_GIAO,
     &          NAMem_GIAO,
     &          dTdmu_Mem
      External PAM2Int, FragPint,
     &         PAM2Mem, FragPMem
      External P_Int, EPEInt,
     &         P_Mem, EPEMem
#ifdef _FDE_
      ! Embedding
      External embPotMem, embPotKernel
      Real*8, Dimension(:), Allocatable :: Emb_Int
#endif
*     ipList: list of pointers to the integrals of each component
*             of the operator
*     OperI: list which irreps a particular component of the operator
*            belongs to
*     OperC: list the character of each component of the operator
*     CoorO: list of origins of the operator, one for each component
      Integer, Dimension(:), Allocatable :: ipList, OperI, OperC
      Real*8, Dimension(:), Allocatable :: CoorO, Nuc, KnE_Int, NA_Int,
     &                                     FragP, OneHam, PtEl,
     &                                     PtNuc, SumEl, SumNuc
      logical lECPnp,lECP
      logical lPAM2np,lPAM2
      logical lPP, lFAIEMP
#include "Molcas.fh"
#include "print.fh"
#include "nq_info.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "wldata.fh"
#include "property_label.fh"
#include "oneswi.fh"
#include "warnings.fh"
#ifdef _FDE_
#include "embpotdata.fh"
#endif
      Integer iSymR(0:3)
      Character*8 Label
      Character*512 FName
      Real*8 Ccoor(3)
      Integer iAtmNr2(mxdbsc), nComp
      Real*8 Charge2(mxdbsc)
      Dimension dum(1),idum(1)
*
      iRout = 131
      iPrint = nPrint(iRout)
*
      Call StatusLine(' Seward:',' Computing 1-electron integrals')
*
      Call Set_Basis_Mode('Valence')
      Call Setup_iSD()
#ifdef _FDE_
      if (embPot) call EmbPotRdRun
#endif
*
      lPAM2 = .False.
      lECP  = .False.
      lPP   = .False.
      lFAIEMP = .False.
      Do i = 1, nCnttp
         lPam2 = lPam2 .or. dbsc(i)%lPam2
         lECP  = lECP  .or. dbsc(i)%ECP
         lPP   = lPP   .or. dbsc(i)%nPP.ne.0
         lFAIEMP  = lFAIEMP  .or. dbsc(i)%Frag
      End Do
*
*     set center selector in OneSwi to all centers (default)
*
      NDDO = .FALSE.
      If (Prprt.and.DKroll) Then
         Call WarningMessage(2,
     &               'Prprt and DKroll options can not be combined!')
         Call Quit_OnUserError()
      End If
*
*     We will always compute the following one-electron integrals per
*     default.
*     1) Multipole moments up to quadrupole moments
*     2) Kinetic energy
*     3) Nuclear Attraction
*     4) ECP contributions
*     5) One-Electron Hamiltonian
*     6) Mass-Velocity
*     7) Darwin 1-electron contact term
*
      lECPnp = lECP
      lPAM2np = lPAM2
      if (DKroll.and.Primitive_Pass) then
         lECPnp = .False.
      endif
      If (Prprt) Then
         FName=SW_FileOrb
         Call GetDens(FName(:mylen(FName)),short,iPrint)
         Call CollapseOutput(1,'   Molecular properties:')
         Write (6,'(3X,A)')    '   ---------------------'
         Write (6,*)
      End If
************************************************************************
************************************************************************
*1)                                                                    *
*                                                                      *
*     Multipole Moments starting with the overlap. If SEWARD is run in *
*     the property mode we will skip the overlap integrals.            *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=One
      iLow = 0
      mMltpl=S%nMltpl
      If (Prprt) iLow = 1
*
*     If not Douglas-Kroll and primitive pass do no property integrals
*
      If (Primitive_Pass) Then
         iLow=0
         If (.Not. DKroll) mMltpl=-1
      End If
*
      Do 10 iMltpl = iLow, S%nMltpl
         Write (Label,'(A,I2)') 'Mltpl ', iMltpl
         nComp = (iMltpl+1)*(iMltpl+2)/2
         Call DCopy_(3,Coor_MPM(1,iMltpl+1),1,Ccoor,1)
         Call Allocate_Auxiliary()
         iComp=0
         Do 11 ix = iMltpl, 0, -1
            If (Mod(ix,2).eq.0) Then
               iSymX=1
            Else
               ixyz=1
               iSymX=2**IrrFnc(ixyz)
               If (Ccoor(1).ne.Zero) iSymX = iOr(iSymX,1)
            End If
            Do 12 iy = iMltpl-ix, 0, -1
               If (Mod(iy,2).eq.0) Then
                  iSymY=1
               Else
                  ixyz=2
                  iSymY=2**IrrFnc(ixyz)
                  If (Ccoor(2).ne.Zero) iSymY = iOr(iSymY,1)
               End If
               iz = iMltpl-ix-iy
               If (Mod(iz,2).eq.0) Then
                  iSymZ=1
               Else
                  ixyz=4
                  iSymZ=2**IrrFnc(ixyz)
                  If (Ccoor(3).ne.Zero) iSymZ = iOr(iSymZ,1)
               End If
               iChO = Mod(ix,2)*iChBas(2)
     &              + Mod(iy,2)*iChBas(3)
     &              + Mod(iz,2)*iChBas(4)
*
               OperI(1+iComp) = MltLbl(iSymX,MltLbl(iSymY,iSymZ))
               OperC(1+iComp) = iChO
               Call DCopy_(3,Coor_MPM(1,iMltpl+1),1,
     &                    CoorO(1+iComp*3),1)
               iComp = iComp + 1
 12         Continue
 11      Continue
*
         Call MltNuc(CoorO,Chrg,Centr,S%kCentr,Nuc,iMltpl,nComp)
*--- pow hack
         If(iMltpl.eq.0) Then
            Call Put_dScalar('Total Nuclear Charge',Nuc(1))
         End If
*--- pow hack
         nOrdOp=iMltpl
         Call OneEl(MltInt,MltMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*                                                                      *
************************************************************************
*                                                                      *
*        Write FMM multipole moments to disk
*
         If (.Not.Prprt.and.DoFMM) Then
            Write (Label,'(A,I2)') 'FMMInt', iMltpl
            Call OneEl(MltInt,MltMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
*
*           FMM overlap distribution centres:
*           Pretend they are 1-e integrals with three (x,y,z)
*           components and write to disk in canonical order
*
            If(iMltpl.eq.0) Then
               Write (Label,'(A)') 'FMMCnX'
               Call OneEl(MltInt,MltMem,Label,ipList,OperI,
     &                 nComp,CoorO,nOrdOp+1,Nuc,rHrmt,
     &                 OperC,dum,1,dum,idum,0,0,
     &                 dum,1,0)
               Write (Label,'(A)') 'FMMCnY'
               Call OneEl(MltInt,MltMem,Label,ipList,OperI,
     &                 nComp,CoorO,nOrdOp+1,Nuc,rHrmt,
     &                 OperC,dum,1,dum,idum,0,0,
     &                 dum,1,0)
               Write (Label,'(A)') 'FMMCnZ'
               Call OneEl(MltInt,MltMem,Label,ipList,OperI,
     &                 nComp,CoorO,nOrdOp+1,Nuc,rHrmt,
     &                 OperC,dum,1,dum,idum,0,0,
     &                 dum,1,0)
            End If
         End If
*                                                                      *
************************************************************************
*                                                                      *
*        For picture-change corrected integrals.
*
         If (DKroll.and.Primitive_Pass) Then
            Write (Label,'(A,I2)') 'pMp   ', iMltpl
            PLabel='MltInt'
            Call FZero(Nuc,nComp)
            Call OneEl(PXPInt,PXPMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp+2,Nuc,rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
         End If
*                                                                      *
************************************************************************
*                                                                      *
         If (iMltpl.eq.0) Then
*           these are overlap integrals...
*           set center selector in OneSwi to single center...
            NDDO = .TRUE.
            Write (Label,'(A,I2)') 'MltplS', iMltpl
            Call OneEl(MltInt,MltMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
*           reset center selector in OneSwi to all centers...
            NDDO = .FALSE.
         End If
*
         Call Deallocate_Auxiliary()
*
 10   Continue
************************************************************************
************************************************************************
*1a)                                                                   *
*                                                                      *
*     PAM integrals                                                    *
*                                                                      *
*                                                                      *
*                                                                      *
************************************************************************
************************************************************************
      If (lPAM2np.and..Not.Primitive_Pass) Then
         Call molcas_open(28,'R_vect')
         PLabel=' '
         rHrmt = One
         iPAMcount=1
        Do 348 kCnttpPAM = 1, nCnttp

           nPAMltpl=dbsc(kCnttpPAM)%nPAM2

           If(nPAMltpl.lt.0) Go To 348
*
           iAddr=1
           Do 347 iPAMltpl=0,nPAMltpl
              nOrdOp= iPAMltpl
              nComp =(iPAMltpl+1)*(iPAMltpl+2)/2
              iPAMPrim=Int(dbsc(kCnttpPAM)%PAM2(iAddr))
              iPAMBas =Int(dbsc(kCnttpPAM)%PAM2(iAddr+1))

              if(iPAMBas.eq.0.or.iPAMPrim.eq.0) go to 3471
              Ccoor(:)=Zero
              Call Allocate_Auxiliary()
              Do iComp=0,nComp-1
                 Call dcopy_(3,dbsc(kCnttpPAM)%Coor,1,
     &                       CoorO(1+3*iComp),1)
              End Do
*
*****    Define symmetry properties of the operator:
*
         iComp=0
         Do 111 ix = iPAMltpl, 0, -1
            If (Mod(ix,2).eq.0) Then
               iSymX=1
            Else
               ixyz=1
               iSymX=2**IrrFnc(ixyz)
               If (Ccoor(1).ne.Zero) iSymX = iOr(iSymX,1)
            End If
            Do 121 iy = iPAMltpl-ix, 0, -1
               If (Mod(iy,2).eq.0) Then
                  iSymY=1
               Else
                  ixyz=2
                  iSymY=2**IrrFnc(ixyz)
                  If (Ccoor(2).ne.Zero) iSymY = iOr(iSymY,1)
               End If
               iz = iPAMltpl-ix-iy
               If (Mod(iz,2).eq.0) Then
                  iSymZ=1
               Else
                  ixyz=4
                  iSymZ=2**IrrFnc(ixyz)
                  If (Ccoor(3).ne.Zero) iSymZ = iOr(iSymZ,1)
               End If
               iChO = Mod(ix,2)*iChBas(2)
     &              + Mod(iy,2)*iChBas(3)
     &              + Mod(iz,2)*iChBas(4)
*
               OperC(1+iComp) = iChO
               OperI(1+iComp) = 1
*
               iComp = iComp + 1
 121        Continue
 111     Continue
*
*****    Loop over basis finction
*
         Call mma_allocate(PAMexp,iPAMPrim,2,label='PAMexp')
         Call dcopy_(iPAMPrim,dbsc(kCnttpPAM)%PAM2(iAddr+2),1,
     &               PAMexp(1,1),1)
         Do iPAMf=1,iPAMBas
            Call dcopy_(iPAMPrim,
     &                  dbsc(kCnttpPAM)%PAM2(iAddr+2+iPAMPrim*iPAMf),1,
     &                  PAMexp(1,2),1)
            Write (Label,'(A,I2.2,I1.1,I2.2)')
     &             'PAM', kCnttpPAM,iPAMltpl,iPAMf
*

            Call dcopy_(nComp,[Zero],0,Nuc,1)

            Call OneEl(PAM2Int,PAM2Mem, Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)

c           iPAMcount=iPAMcount+1
*
         End Do
         Call mma_deallocate(PAMexp)
         Call Deallocate_Auxiliary()
 3471    iAddr=iAddr+2+iPAMPrim*(iPAMBas+1)
 347     Continue
 348    Continue
        close(28)
      End If
************************************************************************
************************************************************************
*2)                                                                    *
*                                                                      *
*     Kinetic energy, nuclear attraction and ECP/PP integrals          *
*                                                                      *
*     Mass-velocity and One-electron Darwin contact term integrals.    *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=One
      nComp=1
*
      If (.Not.Prprt) Then
         Call Allocate_Auxiliary()
         Call dcopy_(3,[Zero],0,CoorO,1)
         OperI(1) = 1
         OperC(1) = iChBas(1)
*
         Label='Kinetic '
         nOrdOp = 2
         Call OneEl(KnEInt,KnEMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         nOrdOp = 0
*
         Label='Attract '
         Call OneEl(NAInt,NAMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,[PotNuc],rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
#ifdef _FDE_
         ! Embedding
         if (embPot) then
          Label='Embpot '
          Call OneEl(EmbPotKernel,EmbPotMem,Label,ipList,OperI,nComp,
     &               CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &               dum,1,dum,idum,0,0,
     &               dum,1,0)
         end if
#endif

*        set center selector in OneSwi to two center NA Int...
         NDDO = .TRUE.
         Label='AttractS'
         Call OneEl(NAInt,NAMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,[PotNuc],rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*        reset center selector in OneSwi to all centers...
         NDDO = .FALSE.
         If (lECPnp.and..Not.Primitive_Pass) Then
*
            Label='PrjInt  '
            Call OneEl(PrjInt,PrjMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
            Label='M1Int   '
            Call OneEl(M1Int, M1Mem, Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
            Label='M2Int   '
            Call OneEl(M2Int, M2Mem, Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
            Label='SROInt  '
            Call OneEl(SROInt,SROMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
         End If     ! lECPnp
         If (lPP.and..Not.Primitive_Pass) Then
            Label='PPInt   '
            Call OneEl(PPInt,PPMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
         End If
         If (Allocated(XF).and..Not.Primitive_Pass) Then
            mOrdOp=nOrd_XF
            Label='XFdInt  '
            Call OneEl(XFdInt,XFdMem,Label,ipList,OperI,nComp,
     &                 CoorO,mOrdOp,[Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
         End If     ! lXF
         If (lRel.and..Not.Primitive_Pass) Then
            Label='MassVel '
            nOrdOp=4
            Call OneEl(MVeInt,MVeMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
            Label='Darwin  '
            nOrdOp=0
            Call OneEl(D1Int,D1Mem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
         End If     ! lRel
*
         Call Deallocate_Auxiliary()
      End If
************************************************************************
************************************************************************
*8a)                                                                   *
*                                                                      *
*     Velocity integrals.                                              *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=-One
      If (Vlct.and..Not.Primitive_Pass) Then
         nOrdOp = 1
         Label='Velocity'
         nComp = 3
         Call Allocate_Auxiliary()
         Call dcopy_(3*nComp,[Zero],0,CoorO,1)
         ixyz=1
         OperI(1  ) = 2**IrrFnc(ixyz)
         OperC(1  ) = iChBas(2)
         ixyz=2
         OperI(1+1) = 2**IrrFnc(ixyz)
         OperC(1+1) = iChBas(3)
         ixyz=4
         OperI(1+2) = 2**IrrFnc(ixyz)
         OperC(1+2) = iChBas(4)
*
         Call dcopy_(3,[Zero],0,Nuc,1)
         Call OneEl(VeInt,VeMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
      End If    ! Vlct
************************************************************************
************************************************************************
*8b)                                                                   *
*                                                                      *
*     Electromagnetic field radiation integrals.                       *
*                                                                      *
*     Note that the integral is not symmetric or antisymmetric!        *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=-One ! Note used
      If (EMFR.and..Not.Primitive_Pass) Then
*
*        The second term in eq. 14 of Bernadotte et al
*
         nOrdOp = 0
         Label='EMFR0'
         nComp = 2
         Call Allocate_Auxiliary()
*        Here we put in the k-vector
         Call FZero(CoorO,3*nComp)
         Call dcopy_(3,KVector,1,CoorO,1)
*
*        The electromagnetic field operator contributes to all
*        irreducible irreps, hence OperI=255. Since the operator
*        itself is not symmetry adapted OperC is set to a dummy value.
*
         OperI(1   ) = 255
         OperI(1+1 ) = 255
         OperC(1   ) = 0 ! Dummy
         OperC(1+1 ) = 0 ! Dummy
*
         Call dcopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(EMFInt,EMFMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
*
*        The first (dominating) term in eq. 14 of Bernadotte et al
*
         nOrdOp = 1
         Label='EMFR'
         nComp = 12
         Call Allocate_Auxiliary()
*        Here we put in the k-vector
         Call FZero(CoorO,3*nComp)
         Call dcopy_(3,KVector,1,CoorO,1)
*
*        The electromagnetic field operator contributes to all
*        irreducible irreps, hence OperI=255. Since the operator
*        itself is not symmetry adapted OperC is set to a dummy value.
*
         OperI(1   ) = 255
         OperI(1+1 ) = 255
         OperI(1+2 ) = 255
         OperI(1+3 ) = 255
         OperI(1+4 ) = 255
         OperI(1+5 ) = 255
         OperI(1+6 ) = 255
         OperI(1+7 ) = 255
         OperI(1+8 ) = 255
         OperI(1+9 ) = 255
         OperI(1+10) = 255
         OperI(1+11) = 255
         OperC(1   ) = 0 ! Dummy
         OperC(1+1 ) = 0 ! Dummy
         OperC(1+2 ) = 0 ! Dummy
         OperC(1+3 ) = 0 ! Dummy
         OperC(1+4 ) = 0 ! Dummy
         OperC(1+5 ) = 0 ! Dummy
         OperC(1+6 ) = 0 ! Dummy
         OperC(1+7 ) = 0 ! Dummy
         OperC(1+8 ) = 0 ! Dummy
         OperC(1+9 ) = 0 ! Dummy
         OperC(1+10) = 0 ! Dummy
         OperC(1+11) = 0 ! Dummy
*
         Call dcopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(EMFInt,EMFMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
      End If    ! EMFR
************************************************************************
************************************************************************
*9)                                                                    *
*10)                                                                   *
*                                                                      *
*     Electric field integrals.                                        *
*     Electric field gradient integrals.                               *
*                                                                      *
************************************************************************
************************************************************************
      ixyz=1
      iSymX = 2**IrrFnc(ixyz)
      ixyz=2
      iSymY = 2**IrrFnc(ixyz)
      ixyz=4
      iSymZ = 2**IrrFnc(ixyz)
      ixyz=3
      iSymXY = 2**IrrFnc(ixyz)
      ixyz=5
      iSymXZ = 2**IrrFnc(ixyz)
      ixyz=6
      iSymYZ = 2**IrrFnc(ixyz)
      ixyz=7
      iSyXYZ = 2**IrrFnc(ixyz)
*
      PLabel=' '
      rHrmt=One
      Do nOrdOp = 0, nOrdEF
*
         nComp = (nOrdOp+1)*(nOrdOp+2)/2
*
         Call Allocate_Auxiliary()
*
      Do iEF = 1, nEF
*
*        Note that this parsing is a bit different here!
*
         Write (Label,'(A,I1,I5)') 'EF',nOrdOp,iEF
         Ccoor(:)=EF_Centers(:,iEF)
*
         iSymR(0) = 1
         If (Ccoor(1).ne.Zero) iSymR(0) = iOr(iSymR(0),iSymX)
         If (Ccoor(2).ne.Zero) iSymR(0) = iOr(iSymR(0),iSymY)
         If (Ccoor(3).ne.Zero) iSymR(0) = iOr(iSymR(0),iSymZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero)
     &      iSymR(0) = iOr(iSymR(0),iSymXY)
         If (Ccoor(1).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymR(0) = iOr(iSymR(0),iSymXZ)
         If (Ccoor(2).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymR(0) = iOr(iSymR(0),iSymYZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero .and.
     &       Ccoor(3).ne.Zero) iSymR(0) = iOr(iSymR(0),iSyXYZ)
*
         ixyz=1
         iSym=2**IrrFnc(ixyz)
         If (Ccoor(1).ne.Zero ) iSym = iOr(iSym,1)
         iSymR(1)=iSym
*
         ixyz=2
         iSym=2**IrrFnc(ixyz)
         If (Ccoor(2).ne.Zero ) iSym = iOr(iSym,1)
         iSymR(2)=iSym
*
         ixyz=4
         iSym=2**IrrFnc(ixyz)
         If (Ccoor(3).ne.Zero ) iSym = iOr(iSym,1)
         iSymR(3)=iSym
*
         iComp=0
         Do ix = nOrdOp, 0, -1
            Do iy = nOrdOp-ix, 0, -1
               iz=nOrdOp-ix-iy
               iComp = iComp + 1
*
               iSymX=1
               If (Mod(ix,2).ne.0) iSymX=iSymR(1)
               iSymCX=MltLbl(iSymR(0),iSymX)
               iSymY=1
               If (Mod(iy,2).ne.0) iSymY=iSymR(2)
               iSymCXY=MltLbl(iSymCX,iSymY)
               iSymZ=1
               If (Mod(iz,2).ne.0) iSymZ=iSymR(3)
*
               OperI(1+(iComp-1)) = MltLbl(iSymCXY,iSymZ)
               OperC(1+(iComp-1)) = Mod(ix,2)*iChBas(2)
     &                              + Mod(iy,2)*iChBas(3)
     &                              + Mod(iz,2)*iChBas(4)
*
               Call dcopy_(3,Ccoor,1,CoorO(1+(iComp-1)*3),1)
            End Do
         End Do
*
         Call EFNuc(CoorO,Chrg,Centr,S%kCentr,Nuc,nOrdOp)
         Call OneEl(EFInt,EFMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*                                                                      *
************************************************************************
*                                                                      *
*        For picture-change corrected property integrals.
*
         If (DKroll.and.Primitive_Pass) Then
            Write (Label,'(A,I1,I5)') 'PP',nOrdOp,iEF
            PLabel='EFInt '
            Call FZero(Nuc,nComp)
            Call OneEl(PXPInt,PXPMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp+2,Nuc,rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
         End If
*                                                                      *
************************************************************************
*                                                                      *
      End Do
         Call Deallocate_Auxiliary()
*
* For a properties calculation, read the EF values saved in a temp file
* and write the sum through Add_Info
*
         If (PrPrt.and.nEF.gt.0) Then
           Call mma_allocate(PtEl,nComp,label='PtEl')
           Call mma_allocate(PtNuc,nComp,label='PtNuc')
           Call mma_allocate(SumEl,nComp,label='SumEl')
           Call mma_allocate(SumNuc,nComp,label='SumNuc')
           Call FZero(SumEl,nComp)
           Call FZero(SumNuc,nComp)
*          Read and sum the values
           LuTmp=10
           Call DaName(LuTmp,'TMPPRP')
           iDisk=0
           Do iEf=1,nEF
             Call dDaFile(LuTmp,2,PtEl,nComp,iDisk)
             Call dDaFile(LuTmp,2,PtNuc,nComp,iDisk)
             Call DaXpY_(nComp,One,PtEl,1,SumEl,1)
             Call DaXpY_(nComp,One,PtNuc,1,SumNuc,1)
           End Do
           Call DaClos(LuTmp)
*          set the tolerance according to the total number of centers
*          (assuming error scales with sqrt(nEF))
           iTol=5
           iTol=iTol-NInt(Half*Log10(Dble(nEF)))
           Write (label,'(a,i1,a)') 'EF',nOrdOp,'   el'
           Call Add_Info(label,SumEl,nComp,iTol)
           Write (label,'(a,i1,a)') 'EF',nOrdOp,'  nuc'
           Call Add_Info(label,SumNuc,nComp,iTol)
           Call mma_deallocate(PtEl)
           Call mma_deallocate(PtNuc)
           Call mma_deallocate(SumEl)
           Call mma_deallocate(SumNuc)
         End If
*
      End Do
************************************************************************
************************************************************************
*12)                                                                   *
*                                                                      *
*     Orbital angular momentum integrals.                              *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=-One
      If (Allocated(OAM_Center).and..Not.Primitive_Pass) Then
         Label='AngMom  '
         nComp = 3
         nOrdOp = 2
         Call Allocate_Auxiliary()
         Call dcopy_(3,OAM_Center,1,CoorO(1  ),1)
         Call dcopy_(3,OAM_Center,1,CoorO(1+3),1)
         Call dcopy_(3,OAM_Center,1,CoorO(1+6),1)
         Call dcopy_(3,OAM_Center,1,Ccoor,1)
         ixyz=1
         iSymX = 2**IrrFnc(ixyz)
         ixyz=2
         iSymY = 2**IrrFnc(ixyz)
         ixyz=4
         iSymZ = 2**IrrFnc(ixyz)
         iSymCx = iSymX
         If (Ccoor(1).ne.Zero) iSymCx = iOr(iSymCx,1)
         iSymCy = iSymY
         If (Ccoor(2).ne.Zero) iSymCy = iOr(iSymCy,1)
         iSymCz = iSymZ
         If (Ccoor(3).ne.Zero) iSymCz = iOr(iSymCz,1)
*
         iSymLx = iOr(MltLbl(iSymCy,iSymZ),MltLbl(iSymCz,iSymY))
         iChOx = iChBas(3) + iChBas(4)
         OperI(1  ) = iSymLx
         OperC(1  ) = iChOx
         iSymLy = iOr(MltLbl(iSymCz,iSymX),MltLbl(iSymCx,iSymZ))
         iChOy = iChBas(4) + iChBas(2)
         OperI(1+1) = iSymLy
         OperC(1+1) = iChOy
         iSymLz = iOr(MltLbl(iSymCx,iSymY),MltLbl(iSymCy,iSymX))
         iChOz = iChBas(2) + iChBas(3)
         OperI(1+2) = iSymLz
         OperC(1+2) = iChOz
*
         Call dcopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(OAMInt,OAMMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
      End If   ! lOAM
************************************************************************
************************************************************************
*12b)                                                                  *
*                                                                      *
*     Velocity quadrupole.                                             *
*     (the companion symmetric combination to the angular momentum)    *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=-One
      If (Vlct.and.(S%nMltpl.ge.2).and..Not.Primitive_Pass) Then
         Label='MLTPV  2'
         nComp = 6
         nOrdOp = 2
         Call Allocate_Auxiliary()
*
*        Use origin for quadrupole moment
         Call DCopy_(nComp,Coor_MPM(1,3),0,CoorO(1  ),3)
         Call DCopy_(nComp,Coor_MPM(2,3),0,CoorO(1+1),3)
         Call DCopy_(nComp,Coor_MPM(3,3),0,CoorO(1+2),3)
         Call dCopy_(3,Coor_MPM(1,3),1,Ccoor,1)
*
         ixyz=1
         iSymX = 2**IrrFnc(ixyz)
         ixyz=2
         iSymY = 2**IrrFnc(ixyz)
         ixyz=4
         iSymZ = 2**IrrFnc(ixyz)
         iSymCx = iSymX
         If (Ccoor(1).ne.Zero) iSymCx = iOr(iSymCx,1)
         iSymCy = iSymY
         If (Ccoor(2).ne.Zero) iSymCy = iOr(iSymCy,1)
         iSymCz = iSymZ
         If (Ccoor(3).ne.Zero) iSymCz = iOr(iSymCz,1)
*
* Calculates QpV_ij = r_i*p_j+p_i*r_j (or rater p -> nabla)
*
* QpVxx
         OperI(1  ) = MltLbl(iSymCx,iSymX)
         OperC(1  ) = iChBas(2)
* QpVxy
         OperI(1+1) = MltLbl(iSymCx,iSymY)
         OperC(1+1) = iChBas(2) + iChBas(3)
* QpVxz
         OperI(1+2) = MltLbl(iSymCx,iSymZ)
         OperC(1+2) = iChBas(2) + iChBas(4)
* QpVyy
         OperI(1+3) = MltLbl(iSymCy,iSymY)
         OperC(1+3) = iChBas(3)
* QpVyz
         OperI(1+4) = MltLbl(iSymCy,iSymZ)
         OperC(1+4) = iChBas(3) + iChBas(4)
* QpVzz
         OperI(1+5) = MltLbl(iSymCz,iSymZ)
         OperC(1+5) = iChBas(4)
*
         Call DCopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(QpVInt,QpVMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
      End If   ! Vlct.and.(S%nMltpl.ge.2)
************************************************************************
************************************************************************
*12c)                                                                  *
*                                                                      *
*     Orbital Magnetic Quadrupole integrals.                           *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=-One
      If (Allocated(OMQ_Center).and..Not.Primitive_Pass) Then
         Label='OMQ     '
         nComp = 9
         nOrdOp = 3
         Call Allocate_Auxiliary()
*
         Call dcopy_(nComp,[OMQ_Center(1)],0,CoorO(1  ),3)
         Call dcopy_(nComp,[OMQ_Center(2)],0,CoorO(1+1),3)
         Call dcopy_(nComp,[OMQ_Center(3)],0,CoorO(1+2),3)
         Ccoor(:)=OMQ_Center(:)
*
         ixyz=1
         iSymX = 2**IrrFnc(ixyz)
         ixyz=2
         iSymY = 2**IrrFnc(ixyz)
         ixyz=4
         iSymZ = 2**IrrFnc(ixyz)
         iSymCx = iSymX
         If (Ccoor(1).ne.Zero) iSymCx = iOr(iSymCx,1)
         iSymCy = iSymY
         If (Ccoor(2).ne.Zero) iSymCy = iOr(iSymCy,1)
         iSymCz = iSymZ
         If (Ccoor(3).ne.Zero) iSymCz = iOr(iSymCz,1)
*
         iSymLx = iOr(MltLbl(iSymCy,iSymZ),MltLbl(iSymCz,iSymY))
         iSymLy = iOr(MltLbl(iSymCz,iSymX),MltLbl(iSymCx,iSymZ))
         iSymLz = iOr(MltLbl(iSymCx,iSymY),MltLbl(iSymCy,iSymX))
*
* Calculates M_ij = r_j*L_i + L_i*r_j = 2*r_j*L_i + i hbar E_ijk r_k
* Since the i hbar is included outside we could do
* M_ij = r_j*L_i + L_i*r_j = 2*r_j*L_i + E_ijk r_k
* We use all nine components even if we only need 6 of these later.
*
* Mxx
         iSymxLx = MltLbl(iSymCx,iSymLx)
         iChOxx = iChBas(15)
         OperI(1  ) = iSymxLx
         OperC(1  ) = iChOxx
* Mxy
         iSymxLy = iSymCz
         iChOxy = iChBas(4)
         OperI(1+1) = iSymxLy
         OperC(1+1) = iChOxy
* Mxz
         iSymxLz = iSymCy
         iChOxz = iChBas(3)
         OperI(1+2) = iSymxLz
         OperC(1+2) = iChOxz
* Myx
         iSymyLx = iSymCz
         iChOyx = iChBas(4)
         OperI(1+3) = iSymyLx
         OperC(1+3) = iChOyx
* Myy
         iSymyLy = MltLbl(iSymCy,iSymLy)
         iChOyy = iChBas(15)
         OperI(1+4) = iSymyLy
         OperC(1+4) = iChOyy
* Myz
         iSymyLz = iSymCx
         iChOyz = iChBas(4)
         OperI(1+5) = iSymyLz
         OperC(1+5) = iChOyz
* Mzx
         iSymzLx = iSymCy
         iChOzx = iChBas(3)
         OperI(1+6) = iSymzLx
         OperC(1+6) = iChOzx
* Mzy
         iSymzLy = iSymCx
         iChOzy = iChBas(4)
         OperI(1+7) = iSymzLy
         OperC(1+7) = iChOzy
* Mzz
         iSymzLz = MltLbl(iSymCz,iSymLz)
         iChOzz = iChBas(15)
         OperI(1+8) = iSymzLz
         OperC(1+8) = iChOzz
*
         Call DCopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(OMQInt,OMQMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
      End If   ! lOMQ
************************************************************************
************************************************************************
*13)                                                                   *
*                                                                      *
*                                                                      *
*                                                                      *
************************************************************************
************************************************************************
      If (DKroll.and.Primitive_Pass) then
         rHrmt=One
         Label='pVp     '
         PLabel='NAInt '
         nOrdOp=2
         nComp = 1
         Call Allocate_Auxiliary()
         Call dcopy_(3,[Zero],0,CoorO,1)
         OperI(1  ) = 1
         OperC(1  ) = iChBas(1)

         Call dcopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(PXPInt,PXPMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)

         Call Deallocate_Auxiliary()
*
         If (BSS) Then
            rHrmt=-One
            nOrdOp = 1
            nComp = 3
            Call Allocate_Auxiliary()
*
            Call dcopy_(3*nComp,[Zero],0,CoorO,1)
            Call dcopy_(3,[Zero],0,Nuc,1)
*
            ixyz=1
            OperI(1  ) = 2**IrrFnc(ixyz)
            OperC(1  ) = iChBas(2)
            ixyz=2
            OperI(1+1) = 2**IrrFnc(ixyz)
            OperC(1+1) = iChBas(3)
            ixyz=4
            OperI(1+2) = 2**IrrFnc(ixyz)
            OperC(1+2) = iChBas(4)
*
            Label='pV      '
            PLabel='NAInt '
            Call OneEl(PXInt,PXMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
*
            Label='Vp      '
            Call OneEl(VPInt,VPMem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
*
            Call Deallocate_Auxiliary()
         End If    ! BSSInt
      End If
************************************************************************
************************************************************************
*14)                                                                   *
*                                                                      *
*     Diamagnetic shielding integrals.                                 *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=One
*
      mDMS=nDMS
      If (Primitive_Pass) mDMS=0
*
      Do 1500 iDMS = 1, mDMS
         Write (Label,'(A,I2,I2)') 'DMS ',1,iDMS
         nComp = 9
         nOrdOp=2
         CCoor(:)=DMS_Centers(:,iDMS)
         Call Allocate_Auxiliary()
         iSymC = 1
         If (Ccoor(1).ne.Zero) iSymC = iOr(iSymC,iSymX)
         If (Ccoor(2).ne.Zero) iSymC = iOr(iSymC,iSymY)
         If (Ccoor(3).ne.Zero) iSymC = iOr(iSymC,iSymZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero)
     &      iSymC = iOr(iSymC,iSymXY)
         If (Ccoor(1).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymC = iOr(iSymC,iSymXZ)
         If (Ccoor(2).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymC = iOr(iSymC,iSymYZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero .and.
     &       Ccoor(3).ne.Zero) iSymC = iOr(iSymC,iSyXYZ)
*
         iComp = 0
         iC = 0
         Do 1510 ix = 1, 0, -1
         Do 1511 iy = 1-ix, 0, -1
            iz=1-ix-iy
            iC = iC + 1
            iChO1 = iChBas(iC+1)
            ixyz=0
            If (Mod(ix,2).ne.0) ixyz=iOr(ixyz,1)
            If (Mod(iy,2).ne.0) ixyz=iOr(ixyz,2)
            If (Mod(iz,2).ne.0) ixyz=iOr(ixyz,4)
            iSym = 2**IrrFnc(ixyz)
            If (Ccoor(iC).ne.Zero) iSym = iOr(iSym,1)
            iD = 0
            Do 1512 jx = 1, 0, -1
            Do 1513 jy = 1-jx, 0, -1
               jz=1-jx-jy
               iD = iD + 1
               iChO2 = iChBas(iD+1)
               jxyz=0
               If (Mod(jx,2).ne.0) jxyz=iOr(jxyz,1)
               If (Mod(jy,2).ne.0) jxyz=iOr(jxyz,2)
               If (Mod(jz,2).ne.0) jxyz=iOr(jxyz,4)
               iSymD = 2**IrrFnc(jxyz)
               If (Dxyz(iD).ne.Zero) iSymD = iOr(iSymD,1)
               If (iC.eq.iD) Then
                  i2 = iD + 1
                  If (i2.gt.3) i2 = i2 - 3
                  i3 = iD + 2
                  If (i3.gt.3) i3 = i3 - 3
                  iChO = iAnd(iChBas(i2+1),iChBas(i3+1))
               Else
                  iChO = iOr(iChO1,iChO2)
               End If
               OperI(1+iComp) = MltLbl(iSymD,MltLbl(iSym,iSymC))
               OperC(1+iComp) = iChO
               Call dcopy_(3,Ccoor,1,CoorO(1+iComp*3),1)
               iComp = iComp + 1
 1513       Continue
 1512       Continue
 1511    Continue
 1510    Continue
         Call dcopy_(3,Dxyz,1,CoorO(1+3),1)
*
         Call dcopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(DMSInt,DMSMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
1500  Continue
************************************************************************
************************************************************************
*15)                                                                   *
*                                                                      *
*     Nuclear attraction integrals for finite centers.                 *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=One
      Label='Center  '
************************************************************************
************************************************************************
*16)                                                                   *
*                                                                      *
*     Spherical well integrals.                                        *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=One
      If (.Not.Prprt.and..Not.Primitive_Pass) Then
         nComp=1
         iWel = 0
         Call Allocate_Auxiliary()
         Call dcopy_(3,[Zero],0,CoorO,1)
         OperI(1) = 1
         OperC(1) = iChBas(1)
         Do 1600 iWel = 1, nWel
            r0   = Wel_Info(1,iWel)
            ExpB = Wel_Info(2,iWel)
            Write (Label,'(A,I4)') 'Well',iWel
            Call OneEl(WelInt,WelMem,Label,ipList,OperI,nComp,
     &                 CoorO,iWel,[Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
 1600    Continue
         Call Deallocate_Auxiliary()
      End If  ! .Not.Prprt
************************************************************************
************************************************************************
*5)                                                                    *
*                                                                      *
*     One-electron Hamiltonian integrals.                              *
*                                                                      *
************************************************************************
************************************************************************
      If (.Not.Prprt.and..Not.Primitive_Pass) Then
         Call mma_allocate(KnE_Int,n2Tri(1)+4,label='KnE_Int')
         Call mma_allocate(NA_Int,n2Tri(1)+4,label='NA_Int')
#ifdef _FDE_
         ! Embedding
         if (embpot) Call mma_allocate(Emb_Int,n2Tri(1)+4,
     &                                 label='Emb_Int')
#endif
         iOpt = 0
         lOper = 0
         iRC = -1
         Label='Kinetic '
         Call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
         If (iRC.ne.0) then
            Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
            Call Quit(_RC_IO_ERROR_READ_)
         End If
         Label='Attract '
         lOper = 0
         iRC = -1
         Call RdOne(iRC,iOpt,Label,1,NA_Int,lOper)
         If (iRC.ne.0) then
            Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
            Call Quit(_RC_IO_ERROR_READ_)
         End If
         Call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
#ifdef _FDE_
         ! Embedding
         if (embpot) then
          if (embPotInBasis) then
!           write(*,*) "ENTER"
           ! If the potential is given in basis set representation it
           ! has not been calculated with a OneEl call and is just read
           ! from file here.
           iunit = isFreeUnit(1)
           call molcas_open(iunit, embPotPath)
           do iEmb=1, n2Tri(1)
            read(iunit,*) Emb_Int(iEmb)
!            write(*,*) iEmb-1, ": ", Emb_Int(iEmb)
           end do
           close(iunit)
          else
           Label='embpot  '
           lOper = 0
           iRC=-1
           Call RdOne(iRC,iOpt,Label,1,Emb_Int,lOper)
           If (iRC.ne.0) then
              Call WarningMessage(2,
     &                    'Drv1El: Error reading ONEINT;'
     &                  //'Label='//Label)
              Call Quit(_RC_IO_ERROR_READ_)
           End If
          end if
          Call DaXpY_(n2Tri(1)+4,One,Emb_Int,1,NA_Int,1)
         end if
#endif
*
*--------Add contribution from ECP
*
         If (lECPnp) Then
            Label='PrjInt  '
            lOper = 0
            iRC = -1
            Call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
            If (iRC.ne.0) then
               Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
               Call Quit(_RC_IO_ERROR_READ_)
            End If
            Call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
            Label='M1Int   '
            lOper = 0
            iRC = -1
            Call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
            If (iRC.ne.0) then
               Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
               Call Quit(_RC_IO_ERROR_READ_)
            End If
            Call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
            Label='M2Int   '
            lOper = 0
            iRC = -1
            Call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
            If (iRC.ne.0) then
               Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
               Call Quit(_RC_IO_ERROR_READ_)
            End If
            Call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
            Label='SROInt  '
            lOper = 0
            iRC = -1
            Call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
            If (iRC.ne.0) then
               Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
               Call Quit(_RC_IO_ERROR_READ_)
            End If
            Call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
         End If   ! lECPnp
*
*--------Add contributions from the Pseudo Potential
*
         If (lPP) Then
            Label='PPInt   '
            lOper = 0
            iRC = -1
            Call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
            If (iRC.ne.0) then
               Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
               Call Quit(_RC_IO_ERROR_READ_)
            End If
            Call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
         End If
*
*--------Add contributions from the external field
*
         If (Allocated(XF)) Then
            Label='XFdInt  '
            lOper = 0
            iRC = -1
            Call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
            If (iRC.ne.0) then
               Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
               Call Quit(_RC_IO_ERROR_READ_)
            End If
            Call DaXpY_(n2Tri(1)+4,One,KnE_Int,1,NA_Int,1)
         End If ! lXF
*
*--------Add contributions from Spherical wells
*
         If (nWel.ne.0) Then
            Do iWel = 1, nWel
               Fact=Wel_Info(3,iWel)
               Write (Label,'(A,I4)') 'Well',iWel
               lOper = 0
               iRC = -1
               Call RdOne(iRC,iOpt,Label,1,KnE_Int,lOper)
               If (iRC.ne.0) then
                  Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
                  Call Quit(_RC_IO_ERROR_READ_)
               End If
               Call DaXpY_(n2Tri(1)+4,Fact,KnE_Int,1,NA_Int,1)
            End Do
         End If  ! nWel.ne.0
*
         Label='OneHam  '
         If (iPrint.ge.10) Call PrMtrx(Label,[lOper],1,[1],NA_Int)
         iRC = -1
         Call WrOne(iRC,iOpt,Label,1,NA_Int,lOper)
         If (iRC.ne.0) then
            Call WarningMessage(2,
     &                  'Drv1El: Error writing ONEINT;'
     &                //'Label='//Label)
            Call Quit(_RC_IO_ERROR_WRITE_)
         End If

#ifdef _FDE_
         ! Embedding
         if (embpot) then
          Label='embpot  '
          iRC = -1
          Call WrOne(iRC,iOpt,Label,1,Work(ipEmb),lOper)
          If (iRC.ne.0) then
             Call WarningMessage(2,
     &                   'Drv1El: Error writing ONEINT;'
     &                 //'Label='//Label)
             Call Quit(_RC_IO_ERROR_WRITE_)
          End If
         end if
#endif
*
         Label='OneHam 0'
         iRC = -1
         Call WrOne(iRC,iOpt,Label,1,NA_Int,lOper)
         If (iRC.ne.0) then
            Call WarningMessage(2,
     &                  'Drv1El: Error writing ONEINT;'
     &                //'Label='//Label)
            Call Quit(_RC_IO_ERROR_WRITE_)
         End If
         Call mma_deallocate(NA_Int)
         Call mma_deallocate(KnE_Int)

#ifdef _FDE_
         ! Embedding
         if (embPot) Call mma_deallocate(Emb_Int)
#endif
      End If
************************************************************************
************************************************************************
*17)                                                                   *
*                                                                      *
*     Angular momentum products (PAM)                                  *
*                                                                      *
************************************************************************
************************************************************************
* Hermitized products of angular momentum integrals
* Component(1) is Lx*Lx
* Component(2) is (Lx*Ly+Ly*Lx)/2, etc.
* Coded P-A Malmqvist, Garching, Nov 1996
      PLabel=' '
      rHrmt=-One
      If (Allocated(AMP_Center).and..Not.Primitive_Pass) Then
         Label='AMProd  '
         nComp = 6
         nOrdOp = 2
         Call Allocate_Auxiliary()
         Call dcopy_(nComp,[AMP_Center(1)],0,CoorO(1  ),3)
         Call dcopy_(nComp,[AMP_Center(2)],0,CoorO(1+1),3)
         Call dcopy_(nComp,[AMP_Center(3)],0,CoorO(1+2),3)
         CCoor(:)=AMP_Center(:)
C Symmetry labels iSymX  for operator d/dx, etc.
C Symmetry labels iSymLx for operator Lx, etc.
C Characters iChOx for operator Lx, etc.
         ixyz=1
         iSymX = 2**IrrFnc(ixyz)
         ixyz=2
         iSymY = 2**IrrFnc(ixyz)
         ixyz=4
         iSymZ = 2**IrrFnc(ixyz)
         iSymCx = iSymX
         If (Ccoor(1).ne.Zero) iSymCx = iOr(iSymCx,1)
         iSymCy = iSymY
         If (Ccoor(2).ne.Zero) iSymCy = iOr(iSymCy,1)
         iSymCz = iSymZ
         If (Ccoor(3).ne.Zero) iSymCz = iOr(iSymCz,1)
         iSymLx = iOr(MltLbl(iSymCy,iSymZ),MltLbl(iSymCz,iSymY))
         iChOx = iChBas(3) + iChBas(4)
         iSymLy = iOr(MltLbl(iSymCz,iSymX),MltLbl(iSymCx,iSymZ))
         iChOy = iChBas(4) + iChBas(2)
         iSymLz = iOr(MltLbl(iSymCx,iSymY),MltLbl(iSymCy,iSymX))
         iChOz = iChBas(2) + iChBas(3)

C Symmetry labels and characters of products. Let G be the full
C  molecular point group, and Gsub=subgroup of G=stabilizer of
C gauge origin. The totally symmetric irrep of Gsub can be
C decomposed into irreps of G.
C Then symmetry label=packed array of bits, one for each irrep
C of G. The bit is set, if that irrep is included in the
C decomposition of the totally symmetric irrep of Gsub.
         OperI(1  )=MltLbl(iSymLx,iSymLx)
         OperI(1+1)=MltLbl(iSymLx,iSymLy)
         OperI(1+2)=MltLbl(iSymLx,iSymLz)
         OperI(1+3)=MltLbl(iSymLy,iSymLy)
         OperI(1+4)=MltLbl(iSymLy,iSymLz)
         OperI(1+5)=MltLbl(iSymLz,iSymLz)
         OperC(1  )=0
         OperC(1+1)=iEOr(iChOx,iChOy)
         OperC(1+2)=iEOr(iChOx,iChOz)
         OperC(1+3)=0
         OperC(1+4)=iEOr(iChOy,iChOz)
         OperC(1+5)=0
*
         Call dcopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(AMPInt,AMPMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
      End If
************************************************************************
************************************************************************
*17)                                                                   *
*                                                                      *
*     Contact term integrals                                           *
*                                                                      *
************************************************************************
************************************************************************
      ixyz=1
      iSymX = 2**IrrFnc(ixyz)
      ixyz=2
      iSymY = 2**IrrFnc(ixyz)
      ixyz=4
      iSymZ = 2**IrrFnc(ixyz)
      ixyz=3
      iSymXY = 2**IrrFnc(ixyz)
      ixyz=5
      iSymXZ = 2**IrrFnc(ixyz)
      ixyz=6
      iSymYZ = 2**IrrFnc(ixyz)
      ixyz=7
      iSyXYZ = 2**IrrFnc(ixyz)
      PLabel=' '
      rHrmt=One
*
      mCnt=0
      If (nOrdEF.eq.2) mCnt=nEF
*
      nComp = 1
      nOrdOp = 1
      Do iCnt = 1, mCnt
         Write (Label,'(A,I5)') 'Cnt',iCnt
         CCoor(:)=EF_Centers(:,iCnt)
         Call Allocate_Auxiliary()
*
         iSymR(0) = 1
         If (Ccoor(1).ne.Zero) iSymR(0) = iOr(iSymR(0),iSymX)
         If (Ccoor(2).ne.Zero) iSymR(0) = iOr(iSymR(0),iSymY)
         If (Ccoor(3).ne.Zero) iSymR(0) = iOr(iSymR(0),iSymZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero)
     &      iSymR(0) = iOr(iSymR(0),iSymXY)
         If (Ccoor(1).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymR(0) = iOr(iSymR(0),iSymXZ)
         If (Ccoor(2).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymR(0) = iOr(iSymR(0),iSymYZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero .and.
     &       Ccoor(3).ne.Zero) iSymR(0) = iOr(iSymR(0),iSyXYZ)
*
         OperI(1) = iSymR(0)
         OperC(1) = 0
*
         Call dcopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(CntInt,CntMem,Label,ipList,OperI,nComp,
     &              Ccoor,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*                                                                      *
************************************************************************
*                                                                      *
*        For picture-change corrected integrals.
*
         If (DKroll.and.Primitive_Pass) Then
            Write (Label,'(A,I2)') 'pCp   ', iCnt
            PLabel='CntInt'
            Call FZero(Nuc,nComp)
            Call OneEl(PXPInt,PXPMem,Label,ipList,OperI,nComp,
     &                 CCoor,nOrdOp+2,Nuc,rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
         End If
*
         Call Deallocate_Auxiliary()
      End Do
*
* For a properties calculation, read the CNT values saved in a temp file
* and write the sum through Add_Info
*
      If (PrPrt.and.mCnt.gt.0) Then
        Call mma_allocate(PtEl,1,label='PtEl')
        Call mma_allocate(PtNuc,1,label='PtNuc')
        Call mma_allocate(SumEl,1,label='SumEl')
        Call mma_allocate(SumNuc,1,label='SumNuc')
        SumEl(1)=Zero
        SumNuc(1)=Zero
*       Read and sum the values
        LuTmp=10
        Call DaName(LuTmp,'TMPPRP')
        iDisk=0
        Do iCnt=1,mCnt
          Call dDaFile(LuTmp,2,PtEl,1,iDisk)
          Call dDaFile(LuTmp,2,PtNuc,1,iDisk)
          SumEl(1)=SumEl(1)+PtEl(1)
          SumNuc(1)=SumNuc(1)+PtNuc(1)
        End Do
        Call DaClos(LuTmp)
*       set the tolerance according to the total number of centers
*       (assuming error scales with sqrt(mCnt))
        iTol=5
        iTol=iTol-NInt(Half*Log10(Dble(mCnt)))
        Write (label,'(a,a)') 'CNT','   el'
        Call Add_Info(label,SumEl,1,iTol)
        Write (label,'(a,a)') 'CNT','  nuc'
        Call Add_Info(label,SumNuc,1,iTol)
        Call mma_deallocate(PtEl)
        Call mma_deallocate(PtNuc)
        Call mma_deallocate(SumEl)
        Call mma_deallocate(SumNuc)
      End If
*
************************************************************************
************************************************************************
*18)                                                                   *
*     Gradient of overlap integrals with respect to the magnetic field *
*                                                                      *
************************************************************************
************************************************************************
      If (GIAO.and..Not.Primitive_Pass) Then
      PLabel=' '
      rHrmt=-One
      nB=3
      iLow = 0
      mMltpl=0 ! Do only overlap.
C     mMltpl=-1 ! Do only overlap.
      Do iMltpl = iLow, mMltpl
         Write (Label,'(A,I2)') 'dMP/dB', iMltpl
         mComp = (iMltpl+1)*(iMltpl+2)/2
         nComp = mComp * nB
         Call DCopy_(3,Coor_MpM(1,iMltpl+1),1,Ccoor,1)
         Call Allocate_Auxiliary()
*
         iComp=0
         Do ix = iMltpl, 0, -1
*
*---------- Pick up which irrep each of the cartesian components of
*           the operator belongs to. If the operator is associated
*           with a center other than origin add the total symmetric
*           irrep.
*
            If (Mod(ix,2).eq.0) Then
               iSymX=1
            Else
               ixyz=1
               iSymX=2**IrrFnc(ixyz)
               If (Ccoor(1).ne.Zero) iSymX = iOr(iSymX,1)
            End If
            Do iy = iMltpl-ix, 0, -1
               If (Mod(iy,2).eq.0) Then
                  iSymY=1
               Else
                  ixyz=2
                  iSymY=2**IrrFnc(ixyz)
                  If (Ccoor(2).ne.Zero) iSymY = iOr(iSymY,1)
               End If
               iz = iMltpl-ix-iy
               If (Mod(iz,2).eq.0) Then
                  iSymZ=1
               Else
                  ixyz=4
                  iSymZ=2**IrrFnc(ixyz)
                  If (Ccoor(3).ne.Zero) iSymZ = iOr(iSymZ,1)
               End If
*
*------------- Multiply cartesian components to generate which irreps
*              the current element of the multipole moment operator
*              belong to. The lowest significant bit if set indicate that
*              a particular irrep is included.
*
               iTemp = MltLbl(iSymX,MltLbl(iSymY,iSymZ))
*
               iChO = Mod(ix,2)*iChBas(2)
     &              + Mod(iy,2)*iChBas(3)
     &              + Mod(iz,2)*iChBas(4)
*
*------------- Now combine with the character of the first derivative
*              with respect to the magnetic field.
*
               iSymRx=2**IrrFnc(1)
               iSymRy=2**IrrFnc(2)
               iSymRz=2**IrrFnc(4)
*
               iB = 1
               iChOx = Mod(ix  ,2)*iChBas(2)
     &               + Mod(iy+1,2)*iChBas(3)
     &               + Mod(iz+1,2)*iChBas(4)
               OperC(1+(iB-1)*mComp+iComp) = iChOx
               iSymBx = MltLbl(iSymRy,iSymRz)
               OperI(1+(iB-1)*mComp+iComp) = MltLbl(iTemp,iSymBx)
               Call DCopy_(3,Coor_MPM(1,iMltpl+1),1,
     &                      CoorO(1+((iB-1)*mComp+iComp)*3),1)
*
               iB = 2
               iChOy = Mod(ix+1,2)*iChBas(2)
     &               + Mod(iy  ,2)*iChBas(3)
     &               + Mod(iz+1,2)*iChBas(4)
               OperC(1+(iB-1)*mComp+iComp) = iChOy
               iSymBy = MltLbl(iSymRz,iSymRx)
               OperI(1+(iB-1)*mComp+iComp) = MltLbl(iTemp,iSymBy)
               Call DCopy_(3,Coor_MPM(1,iMltpl+1),1,
     &                      CoorO(1+((iB-1)*mComp+iComp)*3),1)
*
               iB = 3
               iChOz = Mod(ix+1,2)*iChBas(2)
     &               + Mod(iy+1,2)*iChBas(3)
     &               + Mod(iz  ,2)*iChBas(4)
               OperC(1+(iB-1)*mComp+iComp) = iChOz
               iSymBz = MltLbl(iSymRx,iSymRy)
               OperI(1+(iB-1)*mComp+iComp) = MltLbl(iTemp,iSymBz)
               Call DCopy_(3,Coor_MPM(1,iMltpl+1),1,
     &                      CoorO(1+((iB-1)*mComp+iComp)*3),1)
*
               iComp = iComp + 1
            End Do
         End Do
*
*        Zero nuclear contribution.
         Call dcopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(MltInt_GIAO,MltMem_GIAO,
     &              Label,ipList,OperI,nComp,
     &              CoorO,iMltpl,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
*
      End Do
*
      End If
************************************************************************
************************************************************************
*19)                                                                   *
*     Atomic mean field integrals for spin-orbit calculations          *
*                                                                      *
************************************************************************
************************************************************************
      If (lAMFI.and..Not.Prprt.and..Not.Primitive_Pass) Then
         PLabel=' '
         rHrmt=-One
         Label='AMFI    '
         nComp = 3
         Call Allocate_Auxiliary()
         OperI(1  )=2**IrrFnc(6)
         OperC(1  )=iChBas(7)
         OperI(1+1)=2**IrrFnc(5)
         OperC(1+1)=iChBas(6)
         OperI(1+2)=2**IrrFnc(3)
         OperC(1+2)=iChBas(4)

* BP -   Turn off AMFI integrals for certain atom types
*        as requested by the PAMF keyword

*        Note that Drv_AMFI will onluy process dbsc of valence typ.
*        Hence the restriction on the loop.

         Do i=1,nCnttp
            If (dbsc(i)%ECP  .or.
     &          dbsc(i)%Aux  .or.
     &          dbsc(i)%Frag) Cycle
            iAtmNr2(i) = dbsc(i)%AtmNr
            Charge2(i) = dbsc(i)%Charge

c           write(6,*) "iAtmNr2(i)",i, iAtmNr2(i)
c           write(6,*) "Charge(i)", i, dbsc(i)%Charge

            iAtom_Number= dbsc(i)%AtmNr
            If (iAtom_Number<0 .or. iAtom_Number>SIZE(No_AMFI)) Then
               Write (6,*) 'Illegal atom number.'
               Write (6,*) 'Atom number=',iAtom_Number
               Call Abend()
            End If
            If (No_AMFI(iAtom_Number)) then
               write(6,*) "Disabling AMFI for atom type ",
     &                 dbsc(i)%AtmNr
               iAtmNr2(i) = 0
               Charge2(i) = 0.0d0
            End if
         End do

         Call Drv_AMFI(Label,ipList,OperI,nComp,rHrmt,OperC,iAtmNr2,
     &                 Charge2)

         Call Deallocate_Auxiliary()
      End If
************************************************************************
************************************************************************
*KAMAL)                                                                *
*              GEN1INT                                                 *
*                                                                      *
*                                                                      *
*                                                                      *
************************************************************************
************************************************************************
      If (lPSOI.and..Not.Prprt.and..Not.Primitive_Pass) Then
#ifdef _GEN1INT_
         PLabel=' '
         rHrmt=-One
         nComp = 3
         Call Get_nAtoms_All(nAtoms)
         Do iCnt=1, nAtoms
         Write (Label,'(A,I2)') 'PSOI  ', iCnt
         nPSOI=iCnt
         nOrdOp = 1
         Call Allocate_Auxiliary()

         iComp=0
         do iComp= 1,nComp
c FIXME ipPSO is uninitialized
c        Call DCopy_(3,Work(ipPSO),1,CoorO(1+(iComp-1)*3),1)
         Call SysAbendMsg('Drv1El',
     &        'Faulty code (undefined Work index).',
     &        'Please correct it or contact the developer.')
         enddo

         ixyz=1
         iSymX = 2**IrrFnc(ixyz)
         ixyz=2
         iSymY = 2**IrrFnc(ixyz)
         ixyz=4
         iSymZ = 2**IrrFnc(ixyz)
         iSymCx = iSymX
         If (Ccoor(1).ne.Zero) iSymCx = iOr(iSymCx,1)
         iSymCy = iSymY
         If (Ccoor(2).ne.Zero) iSymCy = iOr(iSymCy,1)
         iSymCz = iSymZ
         If (Ccoor(3).ne.Zero) iSymCz = iOr(iSymCz,1)
*
         iSymLx = iOr(MltLbl(iSymCy,iSymZ),MltLbl(iSymCz,iSymY))
         iChOx = iChBas(3) + iChBas(4)
         OperI(1  ) = iSymLx
         OperC(1  ) = iChOx
         iSymLy = iOr(MltLbl(iSymCz,iSymX),MltLbl(iSymCx,iSymZ))
         iChOy = iChBas(4) + iChBas(2)
         OperI(1+1) = iSymLy
         OperC(1+1) = iChOy
         iSymLz = iOr(MltLbl(iSymCx,iSymY),MltLbl(iSymCy,iSymX))
         iChOz = iChBas(2) + iChBas(3)
         OperI(1+2) = iSymLz
         OperC(1+2) = iChOz

*        Zero nuclear contribution
         Call DCopy_(nComp,[Zero],0,Nuc,1)
         Call OneEl(PSOInt,PSOMem,Label,ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
         enddo
!1555      Continue
          !Call PrMtrx(Label,lOper,nComp,ip)
#else
         Call WarningMessage(2,
     &   'Drv1El: NO Gen1int interface available!')
         Call Abend()
#endif
       End If   ! lOAM
************************************************************************
************************************************************************
*20)                                                                   *
*     The gradient of the kinetic energy and the nuclear attraction    *
*     energy with respect to the magnetic field.                       *
*                                                                      *
************************************************************************
************************************************************************
      If (GIAO.and..Not.Primitive_Pass) Then
         PLabel=' '
         rHrmt=-One
         nOrdOp = 0
         nComp = 3
         Call Allocate_Auxiliary()
         Call dcopy_(3*nComp,[Zero],0,CoorO,1)
         ixyz=1
         OperI(1  ) = 2**IrrFnc(ixyz)
         OperC(1  ) = iChBas(2)
         ixyz=2
         OperI(1+1) = 2**IrrFnc(ixyz)
         OperC(1+1) = iChBas(3)
         ixyz=4
         OperI(1+2) = 2**IrrFnc(ixyz)
         OperC(1+2) = iChBas(4)
*
         Call dcopy_(3,[Zero],0,Nuc,1)
*
         Label='dT/dB   '
         Call OneEl(KneInt_GIAO,KneMem_GIAO,Label,
     &              ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         nOrdOp = 1
         Label='dV/dB   '
         Call OneEl( NAInt_GIAO, NAMem_GIAO,Label,
     &              ipList,OperI,nComp,
     &              CoorO,nOrdOp,Nuc,rHrmt,OperC,
     &              dum,1,dum,idum,0,0,
     &              dum,1,0)
*
         Call Deallocate_Auxiliary()
*
*        Differentiate the generalized kinetic energy operator with respect
*        to the magnetic moment at the centers.
*
         nOrdOp = 1
         nComp = 3
         ixyz=1
         iSymX = 2**IrrFnc(ixyz)
         ixyz=2
         iSymY = 2**IrrFnc(ixyz)
         ixyz=4
         iSymZ = 2**IrrFnc(ixyz)
         ixyz=3
         iSymXY = 2**IrrFnc(ixyz)
         ixyz=5
         iSymXZ = 2**IrrFnc(ixyz)
         ixyz=6
         iSymYZ = 2**IrrFnc(ixyz)
         ixyz=7
         iSyXYZ = 2**IrrFnc(ixyz)
*
         iEF = 0
         Do  iCnttp = 1, nCnttp
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               iEF=iEF+1
               Write (Label,'(A,I2)') 'dT/dmu',iEF
               CCoor(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
               Call Allocate_Auxiliary()
               iSymC = 1
               If (Ccoor(1).ne.Zero) iSymC = iOr(iSymC,iSymX)
               If (Ccoor(2).ne.Zero) iSymC = iOr(iSymC,iSymY)
               If (Ccoor(3).ne.Zero) iSymC = iOr(iSymC,iSymZ)
               If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero)
     &            iSymC = iOr(iSymC,iSymXY)
               If (Ccoor(1).ne.Zero .and. Ccoor(3).ne.Zero)
     &            iSymC = iOr(iSymC,iSymXZ)
               If (Ccoor(2).ne.Zero .and. Ccoor(3).ne.Zero)
     &            iSymC = iOr(iSymC,iSymYZ)
               If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero .and.
     &             Ccoor(3).ne.Zero) iSymC = iOr(iSymC,iSyXYZ)
*
               iComp=0
               Do ix = nOrdOp, 0, -1
                  Do iy = nOrdOp-ix, 0, -1
                     iComp = iComp + 1
                     iz = nOrdOp-ix-iy
                     ixyz=0
                     If (Mod(ix,2).ne.0) ixyz=iOr(ixyz,1)
                     If (Mod(iy,2).ne.0) ixyz=iOr(ixyz,2)
                     If (Mod(iz,2).ne.0) ixyz=iOr(ixyz,4)
                     iSym = 2**IrrFnc(ixyz)
                     If (Ccoor(iComp).ne.Zero ) iSym = iOr(iSym,1)
                     OperI(1+(iComp-1)) = MltLbl(iSymC,iSym)
                     OperC(1+(iComp-1)) = iChBas(iComp+1)
                     Call dcopy_(3,Ccoor,1,CoorO(1+(iComp-1)*3),1)
                  End Do
               End Do
*
*              Call EFNuc(CoorO,Chrg,Centr,S%kCentr,Nuc,nOrdOp)
*

               Call OneEl(dTdmu_Int,dTdmu_Mem,Label,ipList,
     &                    OperI,nComp,
     &                    CoorO,nOrdOp,Nuc,rHrmt,
     &                    OperC,dum,1,dum,idum,0,0,
     &                    dum,1,0)
*
               Call Deallocate_Auxiliary()
            End Do
         End Do
      End If
************************************************************************
************************************************************************
*                                                                      *
* 21) Atomic Fock matrix                                               *
*                                                                      *
************************************************************************
************************************************************************
      PLabel=' '
      rHrmt=One
      nComp=1
      nOrdOp = 0
      If (.Not.Prprt.and..Not.Primitive_Pass.and.Do_FckInt) Then
         Call Allocate_Auxiliary()
         Call dcopy_(3,[Zero],0,CoorO,1)
         OperI(1) = 1
         OperC(1) = iChBas(1)
*
         Label='FckInt  '
         Call Drv_Fck(Label,ipList,OperI,nComp,
     &                CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &                dum,1,dum,idum,0,0,
     &                dum,1,0)
*
         Call Deallocate_Auxiliary()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
*     Deallocate memory for property calculation.
*
      If (Prprt) Then
         If (Short) Call mma_deallocate(Den)
         Call mma_deallocate(Vec)
         Call mma_deallocate(Occ)
         Call CollapseOutput(0,'   Molecular properties:')
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Is this the second pass in a relativistic calculation?
*     In that case: close ONEINT, open ONEREL, read the pVp
*     integrals, close ONEREL, re-open ONEINT, calculate the
*     DK integrals in the contracted basis set, transform and
*     replace the one-electron integrals on ONEINT.
*
      If (DKroll.and..Not.Primitive_Pass) then
      If (BSS) Then
            Call BSSint
         Else
            Call DKRelInt_DP
         End If
      End If
************************************************************************
************************************************************************
*20)                                                                   *
*     Produce information for the NEMO interface.                      *
*                                                                      *
************************************************************************
************************************************************************
      If (NEMO) Then
         If (Primitive_Pass) Then
*
*           Compute p-matrix and put it temporarily on ONEREL.
            PLabel=' '
            rHrmt=One
            nComp=3
            nOrdOp = 0
            Call Allocate_Auxiliary()
            Do iComp = 1, nComp
               Call dcopy_(3,[Zero],0,CoorO(1+(iComp-1)*3),1)
               OperI(1+(iComp-1)) = 1
               OperC(1+(iComp-1)) = iChBas(1)
            End Do
*
            Label='P_matrix'
            Call OneEl(P_Int,P_Mem,Label,ipList,OperI,nComp,
     &                 CoorO,nOrdOp,[Zero,Zero,Zero],rHrmt,OperC,
     &                 dum,1,dum,idum,0,0,
     &                 dum,1,0)
            Call Deallocate_Auxiliary()
         Else
*
*-----------Assemble transformation matrix between the contracted and
*           the primitive basis.
*
            Call NEMO_Opt1()
*
         End If
      End If
************************************************************************
************************************************************************
*21)                                                                   *
*     Fragment AIEMP integrals: projection and 2-electron interaction  *
*                               integrals contracted with the          *
*                               fragment's density matrices            *
*                                                                      *
************************************************************************
************************************************************************
      If(lFAIEMP.and..not.Primitive_Pass) Then
* projection integrals
        PLabel=' '
        rHrmt=One
        nComp=1
        nOrdOp = 0
        Call Allocate_Auxiliary()
        Call dcopy_(3,[Zero],0,CoorO,1)
        OperI(1) = 1
        OperC(1) = iChBas(1)
        Label='FragProj'
        Call OneEl(FragPInt,FragPMem,Label,ipList,OperI,nComp,
     &             CoorO,nOrdOp,[Zero],rHrmt,OperC,
     &             dum,1,dum,idum,0,0,
     &             dum,1,0)
        Call Deallocate_Auxiliary()
* add the results to the one-electron hamiltonian
        iOpt = 0
        lOper = 0
        iRC = -1
        Call mma_allocate(FragP,n2Tri(1)+4,label='FragP')
        Call RdOne(iRC,iOpt,Label,1,FragP,lOper)
        If (iRC.ne.0) Then
           Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
           Call Quit(_RC_IO_ERROR_READ_)
        End If
        Label = 'OneHam  '
        lOper = 0
        iRC = -1
        Call mma_allocate(OneHam,n2Tri(1)+4,label='OneHam')
        Call RdOne(iRC,iOpt,Label,1,OneHam,lOper)
        If (iRC.ne.0) Then
           Call WarningMessage(2,
     &                  'Drv1El: Error reading ONEINT;'
     &                //'Label='//Label)
           Call Quit(_RC_IO_ERROR_READ_)
        End If
        Call DaXpY_(n2Tri(1)+4,One,FragP,1,OneHam,1)
        iRC = -1
        Call WrOne(iRC,iOpt,Label,1,OneHam,lOper)
        If (iRC.ne.0) Then
           Call WarningMessage(2,
     &                  'Drv1El: Error writing ONEINT;'
     &                //'Label='//Label)
           Call Quit(_RC_IO_ERROR_WRITE_)
        End If
        iRC = -1
        Label = 'OneHam 0'
        Call WrOne(iRC,iOpt,Label,1,OneHam,lOper)
        If (iRC.ne.0) Then
           Call WarningMessage(2,
     &                  'Drv1El: Error writing ONEINT;'
     &                //'Label='//Label)
           Call Quit(_RC_IO_ERROR_WRITE_)
        End If
        Call mma_deallocate(FragP)
        Call mma_deallocate(OneHam)
* 2-electron interaction integrals (are added to the one-electron
* hamiltonian locally)
        Call Drv2El_FAIEMP()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call Free_iSD()
*                                                                      *
************************************************************************
*                                                                      *
      Return
*
      Contains
      Subroutine Allocate_Auxiliary()
      Implicit None
*
      Call mma_Allocate(ipList,nComp,label='ipList')
      Call mma_Allocate(OperI,nComp,label='OperI')
      Call mma_Allocate(OperC,nComp,label='OperC')
      Call mma_Allocate(CoorO,3*nComp,label='CoorO')
      Call mma_Allocate(Nuc,nComp,label='Nuc')
*
      Return
      End Subroutine Allocate_Auxiliary
      Subroutine Deallocate_Auxiliary()
      Implicit None
*
      Call mma_Deallocate(OperC)
      Call mma_Deallocate(OperI)
      Call mma_Deallocate(ipList)
      Call mma_Deallocate(CoorO)
      Call mma_Deallocate(Nuc)
*
      Return
      End Subroutine Deallocate_Auxiliary
*
      End Subroutine Drv1el

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine getmo2_cvb(cmo,cmo2,ic)

use casvb_global, only: iact_mo, nact_mo, nbas_mo, nbasf_mo, nbasi_mo, nbasisq_mo, nbassqf_mo, nsym_mo
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: cmo(nbas_mo,nbas_mo)
real(kind=wp), intent(inout) :: cmo2(nbas_mo,nbas_mo)
integer(kind=iwp), intent(in) :: ic
integer(kind=iwp) :: iorb, isk, jbas
real(kind=wp), allocatable :: cmoblk(:)

! Construct full matrix of MOs in symmetry-adapted AO basis:
call mma_allocate(cmoblk,nbasisq_mo,label='cmoblk')
call getmoblk_cvb(cmoblk)
cmo(:,:) = Zero
do isk=1,nsym_mo
  do jbas=1,nbasi_mo(isk)
    cmo(nbasf_mo(isk)+1:nbasf_mo(isk)+nbasi_mo(isk),jbas+nbasf_mo(isk)) = &
      cmoblk(nbassqf_mo(isk)+(jbas-1)*nbasi_mo(isk)+1:nbassqf_mo(isk)+jbas*nbasi_mo(isk))
  end do
end do
call mma_deallocate(cmoblk)

if (mod(ic,2) == 1) then
  call mxinv_cvb(cmo,nbas_mo)
  call dgetmi(cmo,nbas_mo,nbas_mo)
end if

if (ic >= 2) then
  do iorb=1,nact_mo
    cmo2(:,iorb) = cmo(:,iact_mo(iorb))
  end do
end if

return

end subroutine getmo2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Build_Mp2Dens(ip_TriDens,ip_Density,CMO,
     &                          mSym,nOrbAll,nOccAll,Diagonalize)

      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "corbinf.fh"
*
      Integer   ip_AOTriBlock
      Real*8    CMO(*)
      Integer   ipSymRec(8)
      Integer   ipSymTri(8)
      Integer   ipSymLin(8)
      Integer   nOrbAll(8), nOccAll(8), ip_Density(8)
      Logical   Diagonalize
      Character*30 Note
*
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
*
      nOrbAllTot = nOrbAll(1)
      nOrbAllMax = nOrbAll(1)
      lRecTot = nOrbAll(1)*nOrbAll(1)
      Do iSym = 2, mSym
         nOrbAllTot = nOrbAllTot + nOrbAll(iSym)
         nOrbAllMax = Max(nOrbAllMax, nOrbAll(iSym))
         lRecTot = lRecTot + nOrbAll(iSym)*nOrbAll(iSym)
      End Do
*

*     A blockmatrix of the size Orb(iSym) X Orb(iSym) is
*     allocated and set to zero
      Call GetMem('AORecBlock','Allo','Real',ip_AORecBlock,
     &            nOrbAllMax**2)
      Call GetMem('TmpRecBlock','Allo','Real',ip_TmpRecBlock,
     &            nOrbAllMax**2)
      Call GetMem('AOTriBlock','Allo','Real',ip_AOTriBlock,
     &            nOrbAllMax*(nOrbAllMax+1) / 2)
      If(Diagonalize) Then
         Call GetMem('MOTriBlock','Allo','Real',ip_MOTriBlock,
     &            nOrbAllMax*(nOrbAllMax+1) / 2)
         Call GetMem('EigenVecBlock','Allo','Real',ip_EigenVecBlock,
     &               nOrbAllMax*nOrbAllMax)
         Call GetMem('EigenValBlock','Allo','Real',ip_EigenValBlock,
     &               nOrbAllMax)
         Call GetMem('EigenVectors','Allo','Real',ip_EigenVecTot,
     &               lRecTot)
         Call GetMem('EigenValues','Allo','Real',ip_EigenValTot,
     &               nOrbAllTot)
         Call GetMem('Energies','Allo','Real',ip_Energies,nOrbAllTot)
         Call GetMem('IndT','Allo','Inte',ip_IndT,7*mSym)
         Call FZero(Work(ip_Energies),nOrbAllTot)
      End If


      Call FZero(Work(ip_AORecBlock),nOrbAllMax**2)
      Call FZero(Work(ip_TmpRecBlock),nOrbAllMax**2)
      Call FZero(Work(ip_AOTriBlock),nOrbAllMax
     &                            * (nOrbAllMax+1)/2)

*
*     Setup a pointer to a symmetryblock in rect or tri representation.
      ipSymRec(1) = 0
      ipSymTri(1) = 0
      ipSymLin(1) = 0
      Do iSym = 2, 8
         ipSymTri(iSym) = ipSymTri(iSym-1)
     &                  + (nOrbAll(iSym-1))
     &                  * (nOrbAll(iSym-1)+1)/2
         ipSymRec(iSym) = ipSymRec(iSym-1)
     &                  + (nOrbAll(iSym-1))**2
         ipSymLin(iSym) = ipSymLin(iSym-1)
     &                  + (nOrbAll(iSym-1))
      End Do
*
      Do iSym = 1, mSym

         If(nOrbAll(iSym).ne.0) Then
*
*           Set initial values for the eigenvectors to the CMO-matrix.
*           If we transform the CMO-matrix in the same way as the MO-matrix
*           needs to be treated to be diagonal we get a transformation from
*           AO to canonical basis. Also sets the energies to zero since they
*           have no physical relevance in this basis.
            If(Diagonalize) Then
               Do i = 1, nOrbAll(iSym)**2
                  Work(ip_EigenVecBlock + i-1)
     &               = CMO(ipSymRec(iSym)+i)
               End Do
            End If
*     Transform the symmetryblock to AO-density
            Call DGEMM_('N','N',nOrbAll(iSym),nOrbAll(iSym),
     &                 nOrbAll(iSym),1.0d0 , CMO(ipSymRec(iSym)+1),
     &                 nOrbAll(iSym),Work(ip_Density(iSym)),
     &                 nOrbAll(iSym), 0.0d0, Work(ip_TmpRecBlock),
     &                 nOrbAll(iSym))
            Call DGEMM_('N','T',nOrbAll(iSym),nOrbAll(iSym),
     &                 nOrbAll(iSym),1.0d0,Work(ip_TmpRecBlock),
     &                 nOrbAll(iSym),CMO(ipSymRec(iSym)+1),
     &                 nOrbAll(iSym),0.0d0, Work(ip_AORecBlock),
     &                 nOrbAll(iSym))
*            Call RecPrt('AODens:','(20F8.5)',Work(ip_AORecBlock),
*     &                  nOrb(iSym),nOrb(iSym))
*            Call RecPrt('MODens:','(20F8.5)',Work(ip_MORecBlock),
*     &                  nOrb(iSym), nOrb(iSym))
            Call Fold_Mat(1,nOrbAll(iSym),Work(ip_AORecBlock),
     &                    Work(ip_AOTriBlock))
            call dcopy_(nOrbAll(iSym)*(nOrbAll(iSym)+1)/2,
     &                 Work(ip_AOTriBlock),1,
     &                 Work(ip_TriDens+ipSymTri(iSym)),1)

            If(Diagonalize) Then
*     Make a normal folded matrix
*
               index = 0
               Do i = 1, nOrbAll(iSym)
                  Do j = 1,i
                     Work(ip_MOTriBlock+index) =  Work(ip_Density(iSym)+
     &                    j-1+(i-1)*(nOrbAll(iSym)))
                     index = index + 1
                  End Do
               End Do
*
               Call NIDiag(Work(ip_MOTriBlock),Work(ip_EigenVecBlock),
     &                     nOrbAll(iSym),nOrbAll(iSym),0)



               Do i = 1, nOrbAll(iSym)
                  Work(ip_EigenValBlock+i-1) =
     &                    Work(ip_MOTriBlock+iTri(i,i)-1)
               End Do
*
               Call JacOrd3(Work(ip_EigenValBlock),
     &                      Work(ip_EigenVecBlock),
     &                      nOrbAll(iSym),nOrbAll(iSym))

#ifdef _DEBUGPRINT_
               Write(6,*) 'The sorted eigenvalues are'
               Do i = 1, nOrbAll(iSym)
                  Write(6,*) Work(ip_EigenValBlock+i-1)
               End Do
               Write(6,*) 'Eigenvectors sorted'
               Do i=1, nOrbAll(iSym)**2
                  Write(6,*) Work(ip_EigenVecBlock+i-1)
               End Do
#endif
*
               call dcopy_(nOrbAll(iSym)**2,
     &                    Work(ip_EigenVecBlock),1,
     &                    Work(ip_EigenVecTot+ipSymRec(iSym)),1)
               call dcopy_(nOrbAll(iSym),
     &                    Work(ip_EigenValBlock),1,
     &                    Work(ip_EigenValTot+ipSymLin(iSym)),1)

            End If

*
         End If
      End Do

*     Put the MP2 natural orbitals we just produced on disk to the file
*     MP2ORB.

      If(Diagonalize) Then
         LuMP2=50
         LuMP2=IsFreeUnit(LuMP2)
*        Build the TypeIndex array
         iOff=ip_IndT
         Do iSym=1,mSym
            iWork(iOff+0)=nFro(iSym)
            iWork(iOff+1)=nOcc(iSym)
            iWork(iOff+2)=0
            iWork(iOff+3)=0
            iWork(iOff+4)=0
            iWork(iOff+5)=nOrb(iSym)-nFro(iSym)-nOcc(iSym)-nDel(iSym)
            iWork(iOff+6)=nDel(iSym)
            iOff=iOff+7
         End Do
         Note='*  Natural MP2 orbitals'
         Call WrVec('MP2ORB',LuMP2,'COEI',mSym,nOrbAll,nOrbAll,
     &              Work(ip_EigenVecTot),Work(ip_EigenValTot),
     &              Work(ip_Energies),iWork(ip_IndT),Note)
*        Create a molden-file
         iUHF = 0
         Call Molden_Interface(iUHF,'MP2ORB','MD_MP2')
*
      End If



      Call GetMem('AORecBlock','Free','Real',ip_AORecBlock,
     &            nOrbAllMax**2)
      Call GetMem('TmpRecBlock','Free','Real',ip_TmpRecBlock,
     &            nOrbAllMax**2)
      Call GetMem('AOTriBlock','Free','Real',ip_AOTriBlock,
     &            nOrbAllMax*(nOrbAllMax+1) / 2)
*
      If(Diagonalize) Then
         Call GetMem('MOTriBlock','Free','Real',ip_MOTriBlock,
     &            nOrbAllMax*(nOrbAllMax+1) / 2)
         Call GetMem('EigenVecBlock','Free','Real',ip_EigenVecBlock,
     &               nOrbAllMax*nOrbAllMax)
         Call GetMem('EigenValBlock','Free','Real',ip_EigenValBlock,
     &               nOrbAllMax)
         Call GetMem('EigenVectors','Free','Real',ip_EigenVecTot,
     &               lRecTot)
         Call GetMem('EigenValues','Free','Real',ip_EigenValTot,
     &               nOrbAllTot)
         Call GetMem('Energies','Free','Real',ip_Energies,nOrbAllTot)
         Call GetMem('IndT','Free','Inte',ip_IndT,7*mSym)
      End If

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(nOccAll)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986,1995, Bernd Artur Hess                            *
!               2005, Jesper Wisborg Krogh                             *
!***********************************************************************

subroutine Sogr(idbg,N,SS,SINV,P,G,A1)
!     SUBROUTINE TO CALCULATE TRANSFORMATION TO SCHMIDT-
!     ORTHOGONALIZED BASIS.
!     N              DIMENSION OF MATRICES. ISIZE=N*(N+1)/2
!     SS(ISIZE)      ORIGINAL OVERLAP MATRIX (LOWER TRIANGULAR)
!                    WILL NOT BE DESTROYED
!     P (ISIZE)      OUTPUT TRANSFORMATION MATRIX
!     G (ISIZE)      SCRATCH
!     A1(N)          SCRATCH

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: idbg, N
real(kind=wp), intent(in) :: SS(*)
real(kind=wp), intent(out) :: SINV(N,N)
real(kind=wp), intent(_OUT_) :: P(*), G(*), A1(*)
integer(kind=iwp) :: I, ierr, IH, IJ, IL, IQ, J, J1, JF, JL, JQ, K, L, LG
real(kind=wp) :: ETOT, S1KK, SUM_

if (iDbg > 0) call PrMat(idbg,SS,n,0,'SS')
ierr = 0
JL = 0
IQ = 0
do J=1,N
  IL = JL
  JQ = IQ
  S1KK = SS(IQ+J)
  G(IL+J) = One
  if (J > 1) then
    J1 = J-1
    JL = 0
    do K=1,J1
      LG = JQ
      ETOT = Zero
      do L=1,K
        LG = LG+1
        JL = JL+1
        ETOT = ETOT+SS(LG)*G(JL)
      end do
      S1KK = S1KK-ETOT*ETOT
      A1(K) = ETOT
    end do
    JF = 1
    JL = IL
    do K=1,J1
      SUM_ = Zero
      JL = JL+1
      JF = JF+K-1
      IH = JF
      do L=K,J1
        IH = IH+L-1
        SUM_ = SUM_+A1(L)*G(IH)
      end do
      G(JL) = -SUM_
    end do
  end if
  if (s1kk <= 1.0e-16_wp) then
    write(u6,*) '    Sogr| j=',j,' s1kk=',s1kk
    ierr = ierr+1
  end if
  S1KK = One/sqrt(S1KK)
  JL = IL
  do K=1,J
    JL = JL+1
    IQ = IQ+1
    G(JL) = G(JL)*S1KK
    P(IQ) = G(JL)
  end do
end do
IJ = 0
do I=1,N
  do J=1,I
    IJ = IJ+1
    SINV(I,J) = Zero
    SINV(J,I) = P(IJ)
  end do
end do
if (ierr > 0) then
  write(u6,'(a)') 'function has negative norm'
  call Abend()
end if
if (iDbg > 0) call PrMat(idbg,P,n,0,'P')

return

end subroutine Sogr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine contone(L,oneoverR3,onecontr,Lmax,
     *contcoeff,nprim,ncont,MxcontL,dummy,
     *onecartx,onecartY,onecartZ,charge,oneonly)
cbs   contracts one-electron integrals and multiplies with l,m-dependent
cbs   factors for L-,L0,L+
      implicit real*8 (a-h,o-z)
      dimension oneoverR3(*),
     *onecontr(MxcontL,MxcontL,-Lmax:Lmax,3),
     *contcoeff(nprim,ncont),dummy(ncont,ncont),
     *onecartx(MxcontL,MxcontL,
     *(Lmax+Lmax+1)*(Lmax+1)),
     *onecarty(MxcontL,MxcontL,
     *(Lmax+Lmax+1)*(Lmax+1)),
     *onecartz(MxcontL,MxcontL,
     *(Lmax+Lmax+1)*(Lmax+1))
      logical oneonly
      ipnt(I,J)=(max(i,j)*(max(i,j)-1))/2+min(i,j)
cbs   first of all cleaning dummy and onecontr
      do jrun=1,ncont
      do irun=1,ncont
      dummy(irun,jrun)=0d0
      enddo
      enddo
      if (oneonly) then
      iprod=MxcontL*MxcontL*(Lmax+Lmax+1)*(Lmax+1)
      call dzero(onecartx,iprod)
      call dzero(onecarty,iprod)
      call dzero(onecartz,iprod)
      endif
      iprod=3*(Lmax+lmax+1)*MxcontL*MxcontL
      call dzero(onecontr,iprod)
cbs   contract onto dummy
      do icont2=1,ncont
      do icont1=1,ncont
      do iprim2=1,nprim
      do iprim1=1,nprim
      dummy(icont1,icont2)=dummy(icont1,icont2)+
     *contcoeff(iprim1,icont1)*contcoeff(iprim2,icont2)*
     *oneoverR3(ipnt(iprim1,iprim2))
      enddo
      enddo
      enddo
      enddo
      do icont2=1,ncont
      do icont1=1,ncont
      dummy(icont1,icont2)=dummy(icont1,icont2)*charge
      enddo
      enddo
cbs   start to add l,m dependent factors
      do M=-L,L
      factormin=sqrt(DBLE(L*L-M*M+L+M))
      factor0=DBLE(M)
      factorplus=sqrt(DBLE(L*L-M*M+L-M))
      do irun=1,ncont
      do jrun=1,ncont
      onecontr(irun,jrun,M,1)=dummy(jrun,irun)*factormin  ! L-minus
      enddo
      enddo
      do irun=1,ncont
      do jrun=1,ncont
      onecontr(irun,jrun,M,2)=dummy(jrun,irun)*factor0    ! L-0
      enddo
      enddo
      do irun=1,ncont
      do jrun=1,ncont
      onecontr(irun,jrun,M,3)=dummy(jrun,irun)*factorplus ! L-plus
      enddo
      enddo
      enddo
cbs   make the final cartesian integrals
      call cartoneX(L,Lmax,onecontr,ncont,
     *MxcontL,onecartX(1,1,1))
      call cartoneY(L,Lmax,onecontr,ncont,
     *MxcontL,onecartY(1,1,1))
      call cartoneZ(L,Lmax,onecontr,ncont,
     *MxcontL,onecartZ(1,1,1))
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!***********************************************************************

module definitions
    use iso_fortran_env, only: int32, int64, real32, real64
    implicit none
    private
    public :: wp, MPIInt, HDF5Int
    public :: int32, int64, real32, real64
    public :: i4, i8, r4, r8


    ! This is the type of MPI arguments
    ! NOTE: If legacy integer*4 declarations are replaced with integer(MPIInt)
    !       we can support 32bit and 64bit versions.
    !       Which will require appropiate compile flags here.
    integer, parameter :: MPIInt = int32

    ! This is the type of HDF5 arguments
    ! NOTE: If legacy integer*4 declarations are replaced with integer(HDF5Int)
    !       we can support 32bit and 64bit versions.
    !       Which will require appropiate compile flags here.
    integer, parameter :: HDF5Int = int32

    ! This is the working precision and should be preferably used.
    integer, parameter :: wp = real64


    ! Although the constants from iso_fortran_env or `selected_real_kind`
    ! are preferred over non-standard real*8 etc.
    ! We define some kinds to refer to the non-standard notation.
    ! **DON'T USE THESE UNLESS YOU EXPLICILTY WANT TO REFER TO real*8 etc.**
    ! `wp` etc. are always preferred.

    real*4 :: r4_example
    real*8 :: r8_example

    integer*4 :: i4_example
    integer*8 :: i8_example

    integer, parameter :: &
        r4 = kind(r4_example), &
        r8 = kind(r8_example), &
        i4 = kind(i4_example), &
        i8 = kind(i8_example)

end module definitions

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkI_Q47 (Va,V,dimb,dima,no)
c
c       this routine do:
c       Create Va(B',o_A,o_B,A')  needed in step Q48
c       from following available array (permuted as given):
c       V1(B',o_A,o_B,A') = (A',o_A|B',o_B)
c       N.B.
c
c       N.B. Kvajt odflaknute, aj koment k rutine odflaknuty

c
        implicit none
        integer dima,dimb,no
        real*8 Va(1:dimb,1:no,1:no,1:dima)
        real*8 V(1:dimb,1:no,1:no,1:dima)
c
c       help variables
        integer a,b,i,j
c
        do a=1,dima
        do j=1,no
        do i=1,no
        do b=1,dimb
          Va(b,i,j,a)=2.0d0*V(b,j,i,a)-V(b,i,j,a)
        end do
        end do
        end do
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1981, Per-Olof Widmark                                 *
!***********************************************************************
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!                                                                      C
!  THIS ROUTINE SORTS THE VECTORS X AND Y, WHERE THE VECTOR X IS       C
!  USED AS THE KEYS.                                                   C
!                                                                      C
!  DATE: 81 04 14                                                      C
!                                                                      C
!  AUTHOR: P-O WIDMARK                                                 C
!                                                                      C
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine SORT_POT(X,Y,N)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(inout) :: X(N), Y(N)
integer(kind=iwp) :: I, J, IND
real(kind=wp) :: SMALL, Z

do I=2,N
  IND = I-1
  SMALL = X(IND)
  do J=I,N
    if (X(J) <= SMALL) then
      IND = J
      SMALL = X(IND)
    end if
  end do
  Z = X(I-1)
  X(I-1) = X(IND)
  X(IND) = Z
  Z = Y(I-1)
  Y(I-1) = Y(IND)
  Y(IND) = Z
end do

return

end subroutine SORT_POT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakeWwd(Ww,W1,aSGrp,beSGrp,gaSGrp)
! this routine does:
! Make Ww(+)((aa)",(bega)") from W1(a",be",a",ga")
! and index bega" is be">=ga"
! for all cases aSGrp >= bSGrp
! N.B. rutinky MakeWwHlpx niesu prilis vymakane @
!
! parameter description:
! Ww     - array for Ww+(-) (O)
! W1     - array for W1(a",be",a",ga") (I)
! xSGrp  - SubGroup of a",be",ga" (I)

use Index_Functions, only: nTri_Elem
use chcc_global, only: DimSGrpa, DimSGrpbe
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: Ww(*)
real(kind=wp), intent(in) :: W1(*)
integer(kind=iwp), intent(in) :: aSGrp, beSGrp, gaSGrp
integer(kind=iwp) :: dima, dimbe, dimbega, dimga

!1 def dimensions

dimbe = DimSGrpbe(beSGrp)
dimga = DimSGrpbe(gaSGrp)
dima = DimSGrpa(aSGrp)

if (beSGrp == gaSGrp) then
  dimbega = nTri_Elem(dimbe)
else
  dimbega = dimbe*dimga
end if

!2 Make Ww matrix

if (beSGrp == gaSGrp) then
  call MakeWwdHlp1(Ww,W1,dima,dimbe,dimbega)
else
  call MakeWwdHlp2(Ww,W1,dima,dimbe,dimga)
end if

return

end subroutine MakeWwd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Roland Lindh                                     *
!               2015, Ignacio Fdez. Galvan (split from gencxctl)       *
!***********************************************************************

subroutine get_drdq(drdq,mInt,nLambda,mLambda,Iter)
!***********************************************************************
! subroutine to get the dr/dq vectors for the constraints as given in  *
! the 'UDC' file.                                                      *
!***********************************************************************

use Slapaf_Info, only: BMx, Degen
use Slapaf_Parameters, only: iRow_c, Curvilinear
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, r8, u6

implicit none
integer(kind=iwp), intent(in) :: mInt, nLambda, Iter
real(kind=wp), intent(inout) :: drdq(mInt,nLambda)
integer(kind=iwp), intent(out) :: mLambda
integer(kind=iwp) :: n3, nBV, i, iLambda, iOff, iOff2, iAtom, ixyz
real(kind=wp) :: RR
logical(kind=iwp) :: lWrite
integer(kind=iwp), allocatable :: iFlip(:)
real(kind=wp), allocatable :: BVc(:), dBVc(:), BMx_t(:,:), Val(:), Val0(:), cInt(:), cInt0(:), Mult(:), dBMx(:)
character(len=8), allocatable :: Lbl(:)
real(kind=r8), external :: DDot_

lWrite = .false.
n3 = size(Degen)

if (nLambda /= 0) then
  nBV = iRow_c-nLambda-1
  call mma_allocate(BMx_t,n3,nLambda,Label='BMx_t')

  call mma_allocate(BVc,n3*nBV,Label='BVc')
  call mma_allocate(dBVc,nBV*n3**2,Label='dBVc')
  call mma_allocate(Val,nBV,Label='Val')
  call mma_allocate(Val0,nBV,Label='Val0')
  Val0(:) = Zero
  call mma_allocate(cInt,nLambda,Label='cInt')
  call mma_allocate(cInt0,nLambda,Label='cInt0')
  call mma_allocate(Mult,nBV**2,Label='Mult')
  call mma_allocate(dBMx,nLambda*n3**2,Label='dBMx')
  call mma_allocate(iFlip,nBV,Label='iFlip')
  call mma_allocate(Lbl,mInt,Label='Lbl')

  call DefInt2(BVc,dBVc,nBV,BMx_t,nLambda,size(Degen,2),iRow_c,Val,cInt,cInt0,Lbl,lWrite,Mult,dBMx,Val0,Iter,iFlip)

  call mma_deallocate(Lbl)
  call mma_deallocate(iFlip)
  call mma_deallocate(dBMx)
  call mma_deallocate(Mult)
  call mma_deallocate(cInt0)
  call mma_deallocate(cInt)
  call mma_deallocate(Val0)
  call mma_deallocate(Val)
  call mma_deallocate(dBVc)
  call mma_deallocate(BVc)

# ifdef _DEBUGPRINT_
  call RecPrt('BMx_t',' ',BMx_t,n3,nLambda)
# endif

  ! Assemble dr/dq: Solve  B dr/dq = dr/dx

  drdq(:,:) = Zero

  ! Temporary fix of the dC/dx vector which always
  ! is propted up with the full degeneracy factor.

  if (.not. Curvilinear) then
    do iLambda=1,nLambda
      do i=1,n3
        iAtom = (i+2)/3
        ixyz = i-(iAtom-1)*3
        BMx_t(i,iLambda) = BMx_t(i,iLambda)/Degen(ixyz,iAtom)
      end do
    end do
  end if

  call Eq_Solver('N',n3,mInt,nLambda,BMx,Curvilinear,Degen,BMx_t,drdq)
# ifdef _DEBUGPRINT_
  call RecPrt('drdq',' ',drdq,mInt,nLambda)
# endif

  call mma_deallocate(BMx_t)
end if

! Double check that we don't have any null vectors

iOff = 1
iOff2 = 1
mLambda = nLambda
do iLambda=1,nLambda
  RR = sqrt(DDot_(mInt,drdq(1,iOff),1,drdq(1,iOff),1))
  if (RR < 1.0e-12_wp) then
    write(u6,*) 'Warning: constraint ',iLambda,' has a null vector, I''ll remove it!'
    mLambda = mLambda-1
  else
    if (iOff /= iOff2) call dCopy_(mInt,drdq(1,iOff),1,drdq(1,iOff2),1)
    iOff2 = iOff2+1
  end if
  iOff = iOff+1
end do
if (mLambda < nLambda) call FZero(drdq(1,mLambda+1),mInt*(nLambda-mLambda))

return

end subroutine get_drdq

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine vAssmbl(Rnxyz,Axyz,la,Rxyz,lr,Bxyz,lb,nZeta,HerW,nHer,
     &                  Temp)
************************************************************************
*                                                                      *
* Object: to assemble the cartesian components of the multipole moment *
*         matrix within the framework of the Gauss-Hermite quadrature. *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Rnxyz(nZeta*3,0:la,0:lb,0:lr), HerW(nHer),
     &       Axyz(nZeta*3,nHer,0:la),
     &       Rxyz(nZeta*3,nHer,0:lr),
     &       Bxyz(nZeta*3,nHer,0:lb), Temp(nZeta*3,nHer)
      Character*80 Label
*
      iRout = 123
      iPrint = nPrint(iRout)
*     iPrint = 99
      If (iPrint.ge.99) Then
         Call RecPrt(' In vAssmbl:HerW',' ',HerW,1,nHer)
         Call RecPrt(' In vAssmbl:Axyz',' ',Axyz,nZeta*3,nHer*(la+1))
         Call RecPrt(' In vAssmbl:Bxyz',' ',Bxyz,nZeta*3,nHer*(lb+1))
         Call RecPrt(' In vAssmbl:Rxyz',' ',Rxyz,nZeta*3,nHer*(lr+1))
      End If
*
*
      call dcopy_(3*nZeta*(la+1)*(lb+1)*(lr+1),[Zero],0,
     &           Rnxyz,1)
      Do 100 ia = 0, la
         Do 110 ib = 0, lb
            Do 111 iHer = 1, nHer
               Do 112 iZCar = 1, 3*nZeta
                  Temp(iZCar,iHer) =  Axyz(iZCar,iHer,ia)*
     &                                Bxyz(iZCar,iHer,ib)*HerW(iHer)
 112           Continue
 111        Continue
            Do 120 ir = 0, lr
*
*     Generate the cartesian components of the multipole moment
*     matrix as a sum of the value of the integrand, evaluated
*     at a root, times a weight.
*
               Do 30 iHer = 1, nHer
                  Do 10 iZCar = 1, 3*nZeta
                     Rnxyz(iZCar,ia,ib,ir) = Rnxyz(iZCar,ia,ib,ir) +
     &                             Temp(iZCar,iHer)*
     &                             Rxyz(iZCar,iHer,ir)
 10               Continue
 30            Continue
*
               If (iPrint.ge.99) Then
                  Write (Label,'(A,I2,A,I2,A,I2,A)')
     &            ' In vAssmbl: Rnxyz(',ia,',',ib,',',ir,')'
                  Call RecPrt(Label,' ',Rnxyz(1,ia,ib,ir),nZeta,3)
               End If
 120        Continue
 110     Continue
 100  Continue
*
*     Call GetMem(' Exit vAssmbl ','LIST','REAL',iDum,iDum)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine REO_GASDET_S(IREO,NSSOA,NSSOB,NBLOCK,IBLOCK,NAEL,NBEL,IASTR,IBSTR,NSMST,NOCCLS,NGAS,IOCCLS,NORB,NOBPT,IB_CONF_OPEN, &
                        iconf_reo,nconf_tot,ib_conf_reo,maxop,nconf_per_open,IB_SD_FOR_OPEN,IZSCR,IZ,IOCMIN,IOCMAX,IDET_OC, &
                        IDET_MS,IDET_VC,MINOP,IBCONF_ALL_SYM_FOR_OCCLS,PSSIGN,NPDTCNF)
! SUBROUTINE REO_GASDET_S --> 44
!
! Reorder determinants in GAS space from det to configuration order
!
! IBCONF_ALL_SYM_FOR_OCCLS : Offset to start of configurations of given occls in list containing all symmetries
! Z_PTDT(IOPEN+1)%A gives Z array for prototype dets with IOPEN
! REO_PTDT(IOPEN+1)%A gives the corresponding reorder array open orbitals

use lucia_data, only: REO_PTDT, Z_PTDT
use Constants, only: One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: IREO(*), IZSCR(*), IZ(*), IOCMIN(*), IOCMAX(*), IDET_OC(*), IDET_MS(*), IDET_VC(*)
integer(kind=iwp), intent(in) :: NSMST, NSSOA(NSMST,*), NSSOB(NSMST,*), NBLOCK, IBLOCK(8,NBLOCK), NAEL, NBEL, NOCCLS, NGAS, &
                                 IOCCLS(NGAS,NOCCLS), NORB, NOBPT(*), IB_CONF_OPEN(*), nconf_tot, iconf_reo(nconf_tot), maxop, &
                                 ib_conf_reo(maxop+1), nconf_per_open(maxop+1), IB_SD_FOR_OPEN(*), MINOP, &
                                 IBCONF_ALL_SYM_FOR_OCCLS(NOCCLS), NPDTCNF(*)
integer(kind=iwp), intent(inout) :: IASTR(*), IBSTR(*)
real(kind=wp), intent(in) :: PSSIGN
integer(kind=iwp) :: IA, IADR_SD_CONF_ORDER, IAGRP, IASM, IATP, IB, IB_OCCLS, IBCNF_OUT, IBGRP, IBSM, IBTP, icnf_out, IDET, &
                     IDUM(1), IOC, IPTDT, IRESTR, ISIGN_2003, ISGN, JBLOCK, MINIA, NASTR1, NBSTR1, nconf_op, NCONF_P, NDOUBLE, &
                     NEL, NIA, NIB, NOCOB, NOPEN, NOPEN_AL, NPTDT
integer(kind=iwp), external :: ilex_for_conf_new, IZNUM_PTDT, NOP_FOR_CONF

IAGRP = 1
IBGRP = 2

NEL = NAEL+NBEL

IDET = 0
do JBLOCK=1,NBLOCK
  IATP = IBLOCK(1,JBLOCK)
  IBTP = IBLOCK(2,JBLOCK)
  IASM = IBLOCK(3,JBLOCK)
  IBSM = IBLOCK(4,JBLOCK)
  !write(u6,*) ' REO_GASDET, IATP, IBTP = ',IATP,IBTP
  ! Occupation class of this combination of string
  call IAIB_TO_OCCLS(IAGRP,IATP,IBGRP,IBTP,IOC)
  !    IAIB_TO_OCCLS(IAGRP,IATP,IBGRP,IBTP,IOC)
  ! Arcweights for this occupation class
  call MXMNOC_OCCLS(IOCMIN,IOCMAX,NGAS,NOBPT,IOCCLS(:,IOC),MINOP)
  !    MXMNOC_OCCLS(MINEL,MAXEL,NORBTP,NORBFTP,NELFTP)
  ! the arcweights
  call CONF_GRAPH(IOCMIN,IOCMAX,NORB,NEL,IZ,NCONF_P,IZSCR)
  !    CONF_GRAPH(IOCC_MIN,IOCC_MAX,NORB,NEL,IARCW,NCONF,ISCR)
  ! Obtain alpha strings of sym IASM and type IATP
  IDUM(1) = 0
  call GETSTR_TOTSM_SPGP(1,IATP,IASM,NAEL,NASTR1,IASTR,NORB,0,IDUM,IDUM)
  ! Obtain Beta strings of sym IBSM and type IBTP
  IDUM(1) = 0
  call GETSTR_TOTSM_SPGP(2,IBTP,IBSM,NBEL,NBSTR1,IBSTR,NORB,0,IDUM,IDUM)
  ! Occupation class corresponding to this combination
  ! The following call should presumably use 'IOC' rather than 'IOCNUM'
  ! The variable name IOCNUM seems to be used nowhere... PAM 2009
  !call IAIB_TO_OCCLS(1,IATP,2,IBTP,IOCNUM)
  call IAIB_TO_OCCLS(1,IATP,2,IBTP,IOC)
  !    IAIB_TO_OCCLS(IAGRP,IATP,IBGRP,IBTP,IOC)
  ! Offset to this occupation class in occupation class ordered cnf list
  IB_OCCLS = IBCONF_ALL_SYM_FOR_OCCLS(IOC)
  ! Info for this occupation class:
  IRESTR = 0
  if ((PSSIGN == One) .and. (IASM == IBSM) .and. (IATP == IBTP)) IRESTR = 1

  NIA = NSSOA(IASM,IATP)
  NIB = NSSOB(IBSM,IBTP)

  do IB=1,NIB
    if (IRESTR == 1) then
      MINIA = IB
    else
      MINIA = 1
    end if
    do IA=MINIA,NIA
      IDET = IDET+1
      !PAM06 call ABSTR_TO_ORDSTR(IASTR(1,IA),IBSTR(1,IB),NAEL,NBEL,
      call ABSTR_TO_ORDSTR(IASTR(1+NAEL*(IA-1)),IBSTR(1+NBEL*(IB-1)),NAEL,NBEL,IDET_OC,IDET_MS,ISGN)
      !    ABSTR_TO_ORDSTR(IA_OC,IB_OC,NAEL,NBEL,IDET_OC,IDET_SP,ISGN)
      ! Number of open orbitals in this configuration
      NOPEN = NOP_FOR_CONF(IDET_OC,NEL)
      !       NOP_FOR_CONF(ICONF,NEL)
      NDOUBLE = (NEL-NOPEN)/2
      NOCOB = NOPEN+NDOUBLE
      NOPEN_AL = NAEL-NDOUBLE
      !write(u6,*) ' NOPEN, NOPEN_AL = ',NOPEN,NOPEN_AL
      !ERROR NPTDT = IBINOM(NOPEN,NOPEN_AL)
      NPTDT = NPDTCNF(NOPEN+1)
      ! Packed form of this configuration
      call REFORM_CONF_OCC(IDET_OC,IDET_VC,NEL,NOCOB)
      ! Address of this configuration
      ! Offset to configurations with this number of open orbitals in
      ! reordered cnf list
      !write(u6,*) 'iconf_reo_new array:'
      !call iwrtma(iconf_reo_new,1,nconf_tot,1,nconf_tot)
      !.. Giovanni and Dongxia comment off the following line
      !ICNF_OUT = ILEX_FOR_CONF(IDET_VC,NOCOB,NORB,NEL,IZ,1,ICONF_REO(IB_OCCLS))
      !!          ILEX_FOR_CONF(ICONF,NOCC_ORB,NORB,NEL,IARCW,IDOREO,IREO)
      !.. end
      !write(u6,*) 'ib_conf_reo at line 2401, and maxop',maxop
      !call iwrtma(ib_conf_reo,1,maxop+1,1,maxop+1)
      !call iwrtma(nconf_per_open,1,maxop+1,1,maxop+1)
      !write(u6,*) 'before calling ilex_for_conf_new, in reogas_det_s'
      !write(u6,*) 'nopen =',nopen
      !write(u6,*) 'and nconf_per_open(nopen+1) =',nconf_per_open(nopen+1)
      !write(u6,*) 'check iconf_reo array'
      !call iwrtma(iconf_reo,1,nconf_tot,1,nconf_tot)
      nconf_op = nconf_per_open(nopen+1)
      !call iwrtma(nconf_per_open,1,maxop+1,1,maxop+1)
      icnf_out = ilex_for_conf_new(idet_vc,nocob,norb,nel,iz,1,iconf_reo(ib_conf_reo(nopen+1)),nconf_op,ib_occls)+ &
                 ib_conf_reo(nopen+1)-1
      !write(u6,*) ' number of configuration in output list',ICNF_OUT
      ! Spinprojections of open orbitals
      call EXTRT_MS_OPEN_OB(IDET_OC,IDET_MS,IDET_VC,NEL)
      !    EXTRT_MS_OPEN_OB(IDET_OC,IDET_MS,IDET_OPEN_MS,NEL)

      ISIGN_2003 = 1
      if (abs(PSSIGN) == One) then
        ! If combinations are used, then the prototype determinants
        ! are defined so the first open spin-orbital is having alpha spin.
        ! In ab order, the included determinant is defined, by having
        ! alpha-spin in the first singly occupied orbital. These definitions
        ! may differ, so ensure that the included det obeys prototype constraint
        ! Address of this spinprojection pattern
        if (IDET_VC(1) < 0) then
          IDET_VC(1:NOPEN) = -IDET_VC(1:NOPEN)
          if (PSSIGN == -One) ISIGN_2003 = -1
          ! Update sign AB => ordered list
          !PAM06 call ABSTR_TO_ORDSTR(IBSTR(1,IB),IASTR(1,IA),NBEL,NAEL,
          call ABSTR_TO_ORDSTR(IBSTR(1+NBEL*(IB-1)),IASTR(1+NAEL*(IA-1)),NBEL,NAEL,IDET_OC,IDET_MS,ISGN)
        end if
      end if
      IPTDT = IZNUM_PTDT(IDET_VC,NOPEN,NOPEN_AL,Z_PTDT(NOPEN+1)%A,REO_PTDT(NOPEN+1)%A,1)
      !       IZNUM_PTDT(IAB,NOPEN,NALPHA,Z,NEWORD,IREORD)
      !write(u6,*) ' Number of det in list of PTDT ', IPTDT
      !write(u6,*) ' IB_SD_FOR_OPEN(NOPEN+1) = ',IB_SD_FOR_OPEN(NOPEN+1)
      !write(u6,*) ' ICNF_OUT, NPTDT ',ICNF_OUT, NPTDT
      IBCNF_OUT = IB_CONF_OPEN(NOPEN+1)
      !write(u6,*) ' IBCNF_OUT = ',IBCNF_OUT
      IADR_SD_CONF_ORDER = IB_SD_FOR_OPEN(NOPEN+1)-1+(ICNF_OUT-IBCNF_OUT)*NPTDT+IPTDT
      if (IADR_SD_CONF_ORDER <= 0) then
        write(u6,*) ' Problemo, IADR_SD_CONF_ORDER < 0'
        write(u6,*) ' IADR_SD_CONF_ORDER = ',IADR_SD_CONF_ORDER
        call XFLUSH(u6)
      end if
      !write(u6,*) ' IADR_SD_CONF_ORDER, ISGN, IDET = ',IADR_SD_CONF_ORDER,ISGN,IDET
      IREO(IADR_SD_CONF_ORDER) = ISGN*IDET*ISIGN_2003

    end do
    ! End of loop over alpha strings
  end do
  ! End of loop over beta strings
end do
! End of loop over blocks

#ifdef _DEBUGPRINT_
write(u6,*) ' Reorder array, CONF order => string order'
write(u6,*) ' ========================================='
call IWRTMA(IREO,1,IDET,1,IDET)
#endif

end subroutine REO_GASDET_S

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Valera Veryazov                                        *
!***********************************************************************
!  CollapseOutput
!
!> @brief
!>   Place markers for collapsed parts in output
!> @author V. Veryazov
!>
!> @details
!> If \p iSw = ``1``, print Message preceded by a marker to
!> start collapsed part in the output.
!>
!> If \p iSw = ``0``, place a marker to terminate collapsed part.
!> \p STR is not used, but recommended.
!>
!> @param[in] iSw Begin/End switch
!> @param[in] STR Message
!***********************************************************************

subroutine CollapseOutput(iSw,STR)

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iSw
character(len=*), intent(in) :: STR
#include "print.fh"

if (icolorize == 1) then
  if (iSw == 1) then
    write(u6,'(A,A)') '++ ',trim(STR)
  else
    write(u6,'(A)') '--'
  end if
else
  if (iSw == 1) write(u6,'(A)') trim(STR)
end if

return

end subroutine CollapseOutput

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine WfCtl_td(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,
     &                    iRHSDisp,iRHSCIDISP,converged)
************************************************************************
*                                                                      *
*                                                                      *
*     called from: MCLR                                                *
*                                                                      *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
#include "WrkSpc.fh"
#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "csfbas_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"

      Logical Orb,CI,Response
      Parameter (iTimeCC = 1 )
      Parameter (iTimeKK = 2 )
      Parameter (iTimeKC = 3 )
      Parameter (iTimeCK = 4 )
#include "crun_mclr.fh"
      Character*8   Fmt2
      Integer iKapDisp(nDisp),isigDisp(nDisp)
      Integer iRHSDisp(nDisp),iRHSCIDisp(nDisp)
      Integer iCIDisp(nDisp),iCIsigDisp(nDisp)
      Integer pstate_sym,opout
      Logical lPrint,converged(8)
      Real*8 Clock(4)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
      one=1.0d0
*
*----------------------------------------------------------------------*
*     Initialize blank and header lines                                *
*----------------------------------------------------------------------*
      TIM2=0.0D0
      TIM3=0.0D0
      TIM4=0.0D0
*
      call dcopy_(4,[0.0d0],0,CLOCK,1)
      lPaper=132
      lLine =120
      left=(lPaper-lLine)/2
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'
*----------------------------------------------------------------------*
      iDis=0
*
*
      fail=.false.
      Do i=1,8
       Converged(i)=.true.
      end do
      lprint=.false.
      idasave=0
      LU_50 = 50
      If (SAVE) CALL DANAME(LU_50,'RESIDUALS')
      If (iAnd(kprint,2).eq.2) lprint=.true.
      iDisp=0
      kksym=1
      kkksym=nsym
      If (PT2) kkkSym=1

c
c Starting loop over all symmetries/PT
c
      Do 100 iSym=kksym,kkksym
        PState_SYM=iEor(State_Sym-1,iSym-1)+1
        nconf1=ncsf(PState_Sym)
        CI=.false.
        If (iMethod.eq.2.and.nconf1.gt.0) CI=.true.

        If (CI.and.nconf1.eq.1.and.isym.eq.1) CI=.false.
*          Initiate CSF <-> SD
        If (CI)
     &     Call InCSFSD(iEor(iSym-1,State_Sym-1)+1,
     &                  State_sym,.false.)
*
*
*          Calculate length of the density, Fock and Kappa matrix etc
*          notice that this matrixes not necessary are symmetric.
*          Store pointers.
*
*          Input:
*                 iSym : Symmetry of perturbation
*
*          Output: Commonblocks (Pointers.fh)
*
        PState_SYM=iEor(State_Sym-1,iSym-1)+1
        nConf2=nint(xispsm(PState_SYM,1))
*       nConf2=ndtasm(PState_SYM)
        nconf3=nint(Max(xispsm(PState_SYM,1),xispsm(State_SYM,1)))
*       nconf3=Max(ndtasm(PState_SYM),ndtasm(State_SYM))
c
c Setup is realted to symmtry treatment
c
*
        Call Setup_MCLR(iSym)
*
*
*       Determine if we should page CI vectors
*
*                                    [2]
*         Calculate the diagonal of E    and store in core/disc
*
        iphx=0
        If (CI) Then
c
c CIDia calculates the <i|H|i> elements (diagonal)? From the CI-CI part of E?
c
            Call CIDia_td(PState_Sym)
            irc=ipout(ipdia)
*
*       Allocate disk/memory space
*
*
*       This areas should be addressed through ipin
*       ipout will page them out to disk and free the memory area
*       if page mode is used
*
*       opout will release the memory area without update the disk
*
c      ipget is like getmem but handles weather the vector is on disk or not.
c
c
        ips1 =ipget(2*nconf3)
        ips2 =ipget(2*nconf3)
        ipst =ipget(2*nconf3)
        ipcit=ipget(2*nconf1)
        ipcid=ipget(2*nconf1)
C
*       Write(*,*) 'I have allocated: ips1, ips2,ipst,ipcit,ipcid',
*    &           ips1, ips2,ipst,ipcit,ipcid
C

        End If
*
*
       npre2=npre(isym)
c
*#ifndef DEBUG
C
C OBS npre2 not def
C
       ipPre2=ipget(npre2)
*
*
        call Prec_dig(Work(ipin(ipPre2)),isym)
*
*
        Call GetMem('DigPrec','Allo','Real',ipDigPrec,nDensC)
        call dcopy_(nDensC,[0.0d0],0,Work(ipDigPrec),1)
        Call Prec_td(Work(ipin(ipPre2)),Work(ipDigPrec),isym)
*
*
*       Call Getmem('wfctl02','CHECK','REAL',idum,idum)
       irc=ipout(ippre2)
*#endif
*
*      OK START WORKING
*
        iDEND=lDisp(iSym)
*       If (SewLab.eq.'NONE    '.and.(.not.mckinley)) iDEND=1
c
c Loop over all PT of sym isym
c
        Do 110 jDisp=1,iDEnd
          iDisp=iDisp+1
          jspin=0
          If (iAnd(nTPert(idisp),1).eq.1) jSpin=1
          if (jspin.eq.0) Then
           nconf1=ncsf(PState_Sym)
          else
           nConf1=nint(xispsm(Pstate_Sym,1))
          end if
          If (.not.lCalc(iDisp)) Then
             converged(isym)=.false.
             Goto 110
          End If
*
*    Allocate areas for scratch and state variables
*
          Call GetMem('kappa ','Allo','Real',ipKap  ,nDens2+6)
          Call GetMem('dkappa','Allo','Real',ipdKap ,nDens2+6)
          Call GetMem('sigma ','Allo','Real',ipSigma,nDens2+6)
          Call GetMem('Temp1 ','Allo','Real',ipTemp1,nDens2+6)
          Call GetMem('Temp2 ','Allo','Real',ipTemp2,nDens2+6)
          Call GetMem('Temp3 ','ALLO','Real',ipTemp3,nDens2+6)
          Call GetMem('Temp4 ','Allo','Real',ipTemp4,nDens2+6)
          Call Getmem('Scr1  ','ALLO','Real',ipSc1  ,nDens2+6)
          Call Getmem('Scr3  ','ALLO','Real',ipSc3  ,nDens2+6)
          Call Getmem('Scr2  ','ALLO','Real',ipSc2  ,nDens2+6)
          call dcopy_(nDens2,[0.0d0],0,Work(ipTemp1),1)
          call dcopy_(nDens2,[0.0d0],0,Work(ipKap),1)
          call dcopy_(nDens2,[0.0d0],0,Work(ipsigma),1)
          call dcopy_(nDens2,[0.0d0],0,Work(ipdKap),1)
          If (CI) Then
             Call GetMem('1Dens','ALLO','Real',ipDe,n1dens)
             Call GetMem('2Dens','ALLO','Real',ipP,n2dens)
             Call GetMem('2Dens','ALLO','Real',iprmoaa,n2dens)
             call dcopy_(n1dens,[0.0d0],0,Work(ipDe),1)
             call dcopy_(n2dens,[0.0d0],0,Work(ipP),1)
             call dcopy_(n2dens,[0.0d0],0,Work(iprmoaa),1)
          End If
*
*-----------------------------------------------------------------------------
*
*    Calculate RHS for the perturbation. The b^x vector!
*    ipsigma is the orbital part and ipTemp4 is the cipart
*
*-----------------------------------------------------------------------------
*
*                 (T1,T2,T3,T4,T5,T6,T7,Kappa1,CI1)
*
           kain=ipkap
           Call RHS_td(Work(ipSigma),Work(ipKap),Work(ipTemp1),
     &              Work(ipTemp3),Work(ipSc2),Work(ipdKap),
     &              Work(ipSc3),
     &              Work(ipTemp4),ipST,
     &              iDisp,iSym-1,Work(ipCMO),jdisp,jspin,CI)
*
*           Call Getmem('wfctl1a','CHECK','REAL',idum,idum)
*
           call dscal_(nDens2,-1.0d0,Work(ipTemp4),1)
c
c Make RHS twice as long and change sign on second part!
c
           If (CI) Then
               call dcopy_(nConf1,Work(ipin(ipst)),1,
     &               Work(ipin(ipst)+nConf1),1)
               call dscal_(nConf1,-1.0d0,Work(ipin(ipst)+nConf1),1)
           End If
C
*           Call RECPRT('IpST',' ',Work(ipin(ipST)),nConf1*2,1)
*           Call RECPRT('CI',' ',Work(ipin(ipci)),nconf1,1)
*           Stop 10
C
          irc=opout(ipci)
*
          If (lprint) Write(6,*)
     &      '       Iteration         Delta     Res(kappa) Res(CI)'
          iLen=nDensC
          iRHSDisp(iDisp)=iDis
          Call Compress(Work(ipTemp4),Work(ipSigma),iSym)
          r1 = 0.50d0*ddot_(ndensc,Work(ipsigma),1,Work(ipsigma),1)
*
          Call UnCompress(Work(ipSigma),Work(ipTemp4),iSym)
*          Call RECPRT('IpSigma',' ',Work(ipSigma),nDensC,1)
          Call dDaFile(LuTemp,1,Work(ipSigma),iLen,iDis)
          If (CI)
     &    call dcopy_(2*nConf1,[0.0d0],0,Work(ipin(ipCIT)),1)
          irc=ipout(ipcit)
          If (CI) Then
            ilen=2*nconf1
            iRHSCIDisp(iDisp)=iDis
            Call dDaFile(LuTemp,1,Work(ipin(ipST)),iLen,iDis)
            Call DSCAL_(2*nConf1,-1.0d0,Work(ipin(ipST)),1)
          End If
*
         Call DMInvKap_td(Work(ipDigPrec),Work(ipSigma),
     &                   Work(ipKap))
C
* No Prec
*         call dcopy_(ndensC,work(ipSigma),1,Work(ipKap),1)
C
          irc=opout(ippre2)
*         kap:kap
          r2 = 0.50d0*ddot_(ndensc,Work(ipKap),1,Work(ipKap),1)
C         Write(6,*) 'r1,r2',r1,r2
          If (r2.gt.r1) Write(6,*) 'Warning ',
     &     ' perturbation number ',idisp,
     &     ' might diverge'
*
*         dkap=Kap in matrix form
          Call UnCompress(Work(ipKap),Work(ipdKap),iSym)
c
c DMinvCI is related to cidia and inverts the precond CI-CI
c part of E
c Has to be modified: <i|H|i> --> <i|H|i>+w
c

          If (CI) Then
                Call DMinvCI_td(Work(ipin(ipST)),
     &                          Work(ipin(ipCid)), -omega,isym)
                Call DMinvCI_td(work(ipin(ipST)+nConf1),
     &                          work(ipin(ipCId)+nconf1),
     &                          omega,isym)
C
* No Prec
*                call dcopy_(2*nConf1,work(ipin(ipST)),1,
*     &                       Work(ipin(ipCId)),1)
C
          End if

*
          If (CI) Then
             deltaC= 0.50d0*ddot_(2*nConf1,Work(ipin(ipST)),1,
     &                   Work(ipin(ipCId)),1)
             irc=ipout(ipcid)
          Else
            deltac=0.0d0
          End If
          deltaK= 0.50d0*ddot_(nDensC,Work(ipKap),1,Work(ipSigma),1)
          call dcopy_(nDens,[0.0d0],0,Work(ipKap),1)
          delta=deltac+deltaK
C         Write(6,*) 'delta',delta

          If (delta.eq.0.0D0) Goto 300

          delta0=delta
          Orb=.true.
          ReCo=-1.0d0
          iter=1
*-----------------------------------------------------------------------------
*
*
***********************************************************
*          I   T   E   R   A   T   I   O   N   S          *
***********************************************************
*
*
200       Continue
*
*
**********************************************************************
*
*       O R B I T A L    P A R T of the trail vector
*
**********************************************************************
*



           If (orb) Then

*-----------------------------------------------------------------------------
*
*                      ~    ~
*            Construct F,(ij|kl)
*
*-----------------------------------------------------------------------------
c
c j2 specifies which part of E I want to look at
c j2=0 --> K-K, j2=-1 --> CI-CI, These are antisym within themself
c j2>0 --> CI-K and K-CI, These parts are antisym between eachother
c

             irc=ipnout(-1)
             Call RInt_ns(Work(ipdKap),
     &                 Work(iprmoaa),    ! OIT 2-el-int (active indexes)
     &                 Work(ipSc2),      ! SC2 contains the E*kappa
     &                 Work(ipTemp4),    ! Contains OIT FI
     &                 isym,reco,jspin,rInEne) ! OIT integrals are used
*
             Call RInttd(Work(ipSc2),Work(ipdKap),isym)
c
             Clock(iTimeKK)=Clock(iTimeKK)+Tim2
*
*
*-----------------------------------------------------------------------------
*
*            kappa->CI
*
*            H(kappa)|0>
*
*                [2]
*            S1=E   k ( kappa TO CI ) <i|H|0>-<i|0>*Energy
*
*-----------------------------------------------------------------------------
*
c
c This cisigma call gives <j|H(k)|0> and <j|H(k)t|0>
c
             If (CI) Then
*              Adjusted to timedep
               Call CISigma_td(jspin,State_Sym,pstate_sym,
     &                      ipTemp4,iprmoaa,idum,
     &                      ipCI,ipS1,'T')
               Clock(iTimeKC)=Clock(iTimeKC)+Tim3
*
*              This will give us a better
*              convergence in the PCG. Notice that
*
*              ~Inactive     ~
*              E        + <0|H|0> = 0
*
*              when the wavefunction is converged.
*
c
c These terms are to be able to handel less converged CASSCF wave func
c
               If (isym.eq.1) Then
                 rGrad=ddot_(nconf1,Work(ipin(ipCI)),1,
     &                   Work(ipin(ips1)),1)
                 call daxpy_(nConf1,-rGrad,
     &                    Work(ipin(ipCI)),1,Work(ipin(ipS1)),1)
                 rGrad=ddot_(nconf1,Work(ipin(ipCI)),1,
     &                   Work(ipin(ips1)+nconf1),1)
                 call daxpy_(nConf1,-rGrad,
     &                     Work(ipin(ipCI)),1,Work(ipin(ipS1)+nconf1),1)
               End if
                call dscal_(nconf1,-1.0d0,Work(ipin(ips1)),1)
                call dscal_(2*nconf1,2.0d0,Work(ipin(ips1)),1)
C
*                Call RECPRT('S1',' ',Work(ipin(ipS1)),2*nconf1,1)
*                Stop 10
C

               irc=opout(ipCI)
************************************************************************
*
*
************************************************************************
*
             End If  ! If ci


           End If
*
************************************************************************
*
*        C I    P A R T of the trail vector
*
************************************************************************
*
           If (CI) Then


*-----------------------------------------------------------------------------
*
*                  [2]
*            S2 = E   CID  ( CI TO CI ) = <i|H|d> -E<i|d>
*
*-----------------------------------------------------------------------------
*
             irc=ipnout(-1)
             if (CI) Call CISigma_td(0,PState_Sym,Pstate_sym,
     &                    ipFIMO,k2int,idum,
     &                    ipCId,ipS2,'S')
*
c I want the RASSCF energy of the ACTIVE electrons !!!!
c EC=-E[act]           E[RASSCF]=E[inact]+E[act]+E[nuc]
c
             EC=rin_ene+potnuc-ERASSCF(1)
*
                Call DaXpY_(nConf1,EC,Work(ipin(ipCId)),1,
     &                  Work(ipin(ipS2)),1)
                Call DaXpY_(nConf1,EC,Work(ipin(ipCId)+nConf1),1,
     &                  Work(ipin(ipS2)+nConf1),1)
                call dscal_(2*nConf1,2.0d0,Work(ipin(ipS2)),1)
c
c Add the wS contribution
c The (-) sign in both daxpys assumes that the two parts of ipcid are def with diff sign.
c This is not true for the debug option!! ipcid = 1 regardless of part which part
c The S-contribution will make E-wS loose its symmetry because E is sym and S
c is antisym.
c
             Call DaXpY_(nConf1,-2.0d0*omega,Work(ipin(ipCId)),1,
     &                  Work(ipin(ipS2)),1)
             Call DaXpY_(nConf1,2.0d0*omega,
     &            Work(ipin(ipCId)+nConf1),1,Work(ipin(ipS2)+nConf1),1)
             Clock(iTimeCC)=Clock(iTimeCC)+Tim4
*
             irc=ipout(ips2)
             irc=opout(ipcid)
             irc=opout(ipci)
*
*-----------------------------------------------------------------------------
*
*            CI -> Kappa
*
*
*                 [2]
*            SC3=E   CID   (SC3=F(<d|E|0>+<0|E|d>)
*
*-----------------------------------------------------------------------------
*
             Response=.true.
             irc=ipnout(-1)
c
             Call CIDens_TD(ipCid,PState_Sym,
     &                       Work(ipp),Work(ipDe))     ! Jeppes
*
*            density for inactive= 2(<d|0>+<0|d>)
*
             d_0=0.0d0
*
*            This is just for debugging purpose.
*            When we use it for actual calculations d_0 == 0
*
c This if statement is just for better convergence! Grad term
c Leave this for later!
c
             If (isym.eq.1) Then
                d_1=ddot_(nconf1,Work(ipin(ipCid)),1,
     &                  Work(ipin(ipci)),1)
                d_2=ddot_(nconf1,Work(ipin(ipCid)+nConf1),1,
     &                  Work(ipin(ipci)),1)
                d_0 = d_1 + d_2
             End If
c
c Fockgen gives the Fock matrix, MO integrals and one index transformed
c MO integrals
c
                 Call Fockgen_td(d_0,Work(ipDe),Work(ipp),
     &                    Work(ipSc3),isym)
*
*-----------------------------------------------------------------------------
*
           End If
*
**********************************************************************
*
*        Sc1  kappa-> kappa
*        Sc3  CI -> kappa
*        S1   kappa -> CI
*        S2   CI -> CI
*        dKap present step
*        Kap  kappaX
*        CIT  CIX
*        CId  present step
**********************************************************************
*
*        Add together
*
*
**********************************************************************
C
*         If (isym.eq.2) Then
*            Call RECPRT('Sc2',' ',Work(ipSc2),ndens2,1)
*            Call RECPRT('Sc3',' ',Work(ipSc3),ndens2,1)
*            Call RECPRT('S1',' ',Work(ipin(ipS1)),2*nConf1,1)
*            Call RECPRT('S2',' ',Work(ipin(ipS2)),2*nConf1,1)
*            Call RECPRT('ST',' ',Work(ipin(ipSt)),2*nConf1,1)
*            Call RECPRT('cid',' ',Work(ipin(ipcid)),2*nConf1,1)
*            Call RECPRT('dkap',' ',Work(ipdkap),ndens2,1)
*            Call RECPRT('sigma',' ',Work(ipsigma),ndens2,1)
*            Stop 10
*         End If
C
           irc=ipnout(-1)
           if (CI) then   ! if (.false.) then
            Call DZaXpY(nDens,One,Work(ipSc2),1,
     &            Work(ipSc3),1,Work(ipSc1),1)
           Else
            call dcopy_(nDens,Work(ipSc2),1,Work(ipSc1),1)
           End If
           Call Compress(Work(ipSc1),Work(ipTemp4),isym)   ! ds
           Call Compress(Work(ipdKap),Work(ipTemp2),isym) ! DX
c
c S1 + S2 --> S1
c
C
*           call dcopy_(2*nconf1,[0.0d0],0, !Work(ipin1(ipS2,2*nconf1)),1,
*     %                Work(ipin1(ipS1,2*nconf1)),1)
C
           If (CI) Then  !If (.false.) then
                     Call DaXpY_(2*nConf1,1.0d0,
     &               Work(ipin1(ipS2,2*nconf1)),1,
     &               Work(ipin1(ipS1,2*nconf1)),1)
                     irc=opout(ips2)
           End If
*
*-----------------------------------------------------------------------------
*
*                ######   #####   #####
*                #     # #     # #     #
*                #     # #       #
*                ######  #       #  ####
*                #       #       #     #
*                #       #     # #     #
*                #        #####   #####
*
*-----------------------------------------------------------------------------
**********************************************************************
*
*
*                     delta
*          rAlpha=------------
*                 dKappa:dSigma
*
*-----------------------------------------------------------------------------
           rAlphaC=0.0d0
           rAlphaK=0.0d0
           If (orb)
     &      rAlphaK=0.5d0*ddot_(nDensC,Work(ipTemp4),1,Work(ipTemp2),1)
           If (CI) Then
              rAlphaC=0.5d0*ddot_(2*nConf1,Work(ipin(ipS1)),1,
     &                   Work(ipin(ipCId)),1)
           End If
           rAlpha=delta/(rAlphaK+ralphaC)
C
*           write(*,*)' delta, rAlphaK, rAlphaC', delta, rAlphaK, rAlphaC
*           Stop 10
*
*-------------------------------------------------------------------*
*
*          Kappa=Kappa+rAlpha*dKappa
*          Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa
*
           If (orb) Then
            Call DaxPy_(nDensC,ralpha,Work(ipTemp2),1,Work(ipKap),1)
            Call DaxPy_(nDensC,-ralpha,Work(ipTemp4),1,Work(ipSigma),1)
            resk=sqrt(0.5d0*ddot_(nDensC,Work(ipSigma),1,
     &            Work(ipSigma),1))
           End If
           resci=0.0d0
C
*          Call RECPRT('ST',' ',Work(ipin(ipSt)),2*nconf1,1)
*          Call RECPRT('S1',' ',Work(ipin(ipS1)),2*nconf1,1)
C
           If (CI) Then
              Call DaXpY_(2*nConf1,ralpha,Work(ipin(ipCId)),1,
     &                  Work(ipin(ipCIT)),1)
              irc=ipout(ipcit)
              Call DaXpY_(2*nConf1,-ralpha,Work(ipin(ipS1)),1,
     &                   Work(ipin1(ipST,2*nconf1)),1)
              irc=opout(ipS1)
              ip=ipin(ipst)
              resci=sqrt(0.5d0*ddot_(2*nconf1,Work(ip),1,
     &                        Work(ip),1))
           End If
*
*-------------------------------------------------------------------*
*
*          Precondition......
*             -1
*          S=M  Sigma
*
          irc=opout(ipcid)
          If (CI) Then
             Call DMinvCI_td(work(ipin(ipST)),
     &                          Work(ipin(ipS2)), -omega,isym)
             Call DMinvCI_td(work(ipin(ipST)+nConf1),
     &                          Work(ipin(ipS2)+nconf1),omega,isym)
C
* No Prec
*            call dcopy_(2*nConf1,work(ipin(ipst)),1,
*     &                      Work(ipin(ips2)),1)
C
          End if
          irc=opout(ipci)
          irc=opout(ipdia)
*
          Call DMInvKap_td(Work(ipDigPrec),Work(ipSigma),
     &                   Work(ipSc2))
C
* No Prec
*              call dcopy_(ndensc,work(ipsigma),1,Work(ipSc2),1)
C
           irc=opout(ippre2)
*
*-------------------------------------------------------------------*
*               s:Sigma
*          Beta=-------
*                delta
*
*          delta=s:sigma
*
*          dKappa=s+Beta*dKappa
*
           If (CI) Then
               deltaC=0.50d0*ddot_(2*nConf1,Work(ipin(ipST)),1,
     &                     Work(ipin(ipS2)),1)
           irc=ipout(ipST)
           else
           deltaC=0.0d0
           end if
*
           deltaK=0.50d0*ddot_(nDensC,Work(ipSigma),1,Work(ipSc2),1)
           If (.not.CI) Then
             rBeta=deltaK/delta
             delta=deltaK
             Call DScal_(nDensC,rBeta,Work(ipTemp2),1)
             Call DaXpY_(nDensC,1.0d0,Work(ipsc2),1,Work(ipTemp2),1)
           Else
             rbeta=(deltac+deltaK)/delta
             delta=deltac+deltaK
             Call DScal_(2*nConf1,rBeta,Work(ipin(ipCID)),1)
             Call DScal_(nDensC,rBeta,Work(ipTemp2),1)
             Call DaXpY_(2*nConf1,1.0d0,Work(ipin(ipS2)),1,
     &                             Work(ipin(ipCID)),1)
             Call DaXpY_(nDensC,1.0d0,Work(ipsc2),1,Work(ipTemp2),1)
             irc=opout(ipS2)
             irc=ipout(ipCID)
           End If
*

*    ######  #    #  #####        #####    ####    ####
*    #       ##   #  #    #       #    #  #    #  #    #
*    #####   # #  #  #    #       #    #  #       #
*    #       #  # #  #    #       #####   #       #  ###
*    #       #   ##  #    #       #       #    #  #    #
*    ######  #    #  #####        #        ####    ####
*


*
*-------------------------------------------------------------------*
*
           Call UnCompress(Work(ipTemp2),Work(ipdKap),isym)
*
c
c iBreak is defined via include!
c
           res=0.0D0 ! dummy initialize
           If (iBreak.eq.1) Then
*             This is the actual breaking!
              If (abs(delta).lt.abs(Epsilon**2*delta0)) Goto 300
           Else If (ibreak.eq.2) Then
              res=sqrt(resk**2+resci**2)
              If (res.lt.abs(epsilon)) Goto 300
           Else
              If (abs(delta).lt.abs(Epsilon**2*delta0).and.
     &            res.lt.abs(epsilon))  Goto 300
           End If
c
c This breaks the PCG iterations by going to 210
c
           If (iter.ge.niter) goto 210
           If (lprint)
     &     Write(6,Fmt2//'A,i2,A,F12.7,F12.7,F12.7,F12.7,F12.7)')
     &            '     ',
     &            iter,'       ',delta/delta0,resk,resci,deltac,deltak

           iter=iter+1
*          Call GetMem(' LIST ','LIST','REAL',iDum,iDum)

          Goto 200
*
**********************************************************************
*
 210      Continue
          Write(6,Fmt2//'A,I4,A)')
     &    'No convergence for perturbation no: ',
     &                      idisp,'. Increase Iter.'
          converged(isym)=.false.
          fail=.true.
          Goto 310
 300      Write(6,Fmt2//'A,I4,A,I4,A)')
     &           'Perturbation no: ',idisp,' converged in ',
     &             iter-1,' steps.'
          irc=ipnout(-1)
*          stop 10
 310      Continue
C         Write(6,*)'Response'
          Call GetMem('temptd','ALLO','Real',ipTempTd,nDens2)
          Call Uncompress(Work(ipkap),Work(ipTempTd),isym)
C
*          Do iS=1,nSym
*             jS=iEOr(iS-1,iSym-1)+1
*             Call RECPRT('TempTd',' ',Work(ipTempTd+ipMat(iS,jS)-1),
*     &              nBas(iS),nBas(jS))
*          End Do
C
          Call GetMem('temptd','Free','Real',ipTempTd,nDens2)
C
*         If (CI) Then
*            Write(*,*)'cit1',ddot_(nConf1,Work(ipin(ipcit)),
*    &          1,Work(ipin(ipcit)),1)
*            Write(*,*)'cit2',ddot_(nConf1,Work(ipin(ipcit)+nConf1),
*    &          1,Work(ipin(ipcit)+nConf1),1)
*         End If
C
*          Call RECPRT('ipcit',' ',Work(ipin(ipcit)),2*nConf1,1)
*          Call RECPRT('ipkap',' ',Work(ipkap),4,1)
*          Stop 10
C
          Write(6,*)
          iLen=ndensC
          iKapDisp(iDisp)=iDis
          Call dDaFile(LuTemp,1,Work(ipKap),iLen,iDis)
          iSigDisp(iDisp)=iDis
          Call dDaFile(LuTemp,1,Work(ipSigma),iLen,iDis)
          If (CI) Then
            ilen=2*nconf1
            iCIDisp(iDisp)=iDis

            Call dDaFile(LuTemp,1,Work(ipin(ipCIT)),iLen,iDis)
            iCISigDisp(iDisp)=iDis
            Call dDaFile(LuTemp,1,Work(ipin(ipST)),iLen,iDis)
          End If
*
          Call GetMem('Temp4  ','FREE','Real',ipTemp4,nDens)
          Call GetMem('Temp3  ','FREE','Real',ipTemp3,ndens)
          Call GetMem('Temp2  ','FREE','Real',ipTemp2,nDens)
          Call GetMem('Temp1  ','FREE','Real',ipTemp1,nDens)
          Call GetMem('sigma  ','FREE','Real',ipSigma,nDens)
          Call GetMem('dkappa ','FREE','Real',ipdKap ,nDens)
          Call GetMem('kappa  ','FREE','Real',ipKap  ,nDens)
          Call Getmem('Scr1   ','FREE','Real',ipSc1  ,nDens2)
          Call Getmem('Scr2   ','FREE','Real',ipSc2  ,nDens2)
          Call Getmem('Scr3   ','FREE','Real',ipSc3  ,nDens2)
          If (CI) Then
             Call GetMem('2Dens','FREE','Real',iprmoaa,n2dens)
             Call GetMem('2Dens','FREE','Real',ipP,n1dens)
             Call GetMem('1Dens','FREE','Real',ipDe,n2dens)
          End If
 110     Continue
*
*        Free all memory and remove from disk all data
*        related to this symmetry
*
         If (CI) Then
            irc=ipclose(ipdia)
         Else
            irc=ipclose(ipPre2)
         End If
*
*        Call GetMem('PREC','FREE','Real',ipPRE,nDens2)
         Call GetMem('DigPrec','Free','Real',ipDigPrec,nDensC)
         If (iphx.ne.0) Then
            Call Getmem('EXPHS','FREE','REAL',iphx,idum)
            Call Getmem('EXPHF','FREE','INTE',ipvt,idum)
            Call Getmem('EXPLS','FREE','INTE',iplst,idum)
         End If

 100  Continue
      If (debug) Then
      Write(6,*)  '****************************************',
     &            '****************************************'
      Write(6,*)
      End If
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine input3_cvb(
     >  iorbrel,mxdimrel,ifxorb,ifxstr,
     >  izrstr,iorts,irots,izeta,
     >  ip_iconfs,orbs,irdorbs,ip_cvb,ip_symelm,kbasiscvb_inp)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "inpmod_cvb.fh"
#include "spinb_cvb.fh"
#include "malloc_cvb.fh"
      parameter (nglob=5,nstrin=51,nendvb=3,nspec=3,
     >  ncrit=2,nmeth=12,nwkw=5,ncmp=4)
      character*8 global,string,endvb,specl
      character*8 crit,weightkw,methkw
      character*50 inpstr
      logical firsttime_cvb
      logical DoCholesky
      external firsttime_cvb
      dimension global(nglob),string(nstrin),endvb(nendvb),specl(nspec)
      dimension crit(ncrit)
      dimension weightkw(nwkw),methkw(nmeth)
      dimension iorbrel(mxdimrel),ifxorb(mxorb)
      dimension iorts(*),irots(*),izeta(*)
      dimension orbs(mxaobf,mxorb),irdorbs(mxorb)
      dimension idum(1)
      save global,string,endvb,specl
      save crit,weightkw,methkw
      data global/'XXXXxxxx','START   ','GUESS   ','PRINT   ',
     >            'PREC    '/
      data string/'XXXXxxxx','XXXXxxxx','SAVE    ','XXXXxxxx',
     >            'ORBPERM ','COUPLE  ','MAXITER ','CRIT    ',
     >            'CASPROJ ','PROJCAS ','NOCASPRO','NOPROJCA',
     >            'XXXXxxxx','XXXXxxxx','SYMELM  ','ORBREL  ',
     >            'XXXXxxxx','SYMPROJ ','NOSYMPRO','FIXORB  ',
     >            'FIXSTRUC','DELSTRUC','FREORB  ','FRESTRUC',
     >            'ORTHCON ','SADDLE  ','SHSTRUC ','VBWEIGHT',
     >            'CIWEIGHT','SCORR   ','NOSCORR ','METHOD  ',
     >            'OPTIM   ','OPT     ','ENDOPTIM','REPORT  ',
     >            'ENDREPOR','XXXXxxxx','TUNE    ','XXXXxxxx',
     >            'OPPOSITE','XXXXxxxx','XXXXxxxx','STAT    ',
     >            'INIT    ','NOINIT  ','TIDY    ','PLOC    ',
     >            'NOPLOC  ','ALTERNAT','ENDALTER'/
      data endvb/ 'ENDVB   ','ENDCASVB','END     '/
      data specl/ 'SERVICE ','MOSCOW  ','PERFLOC '/
      data crit/  'OVERLAP ','ENERGY  '/
      data weightkw/'CHIRGWIN','LOWDIN  ','INVERSE ','NONE    ',
     >              'ALL     '/
      data methkw/'FLETCHER','TRIM    ','TRUSTOPT','DAVIDSON',
     >            'STEEP   ','VB2CAS  ','AUGHESS ','AUG2    ',
     >            'CHECK   ','DFLETCH ','NONE    ','SUPER   '/


      Call DecideOnCholesky(DoCholesky)
      If (DoCholesky) Then
        write(6,*)'** Cholesky or RI/DF not yet implemented in CASVB **'
        call abend_cvb()
      EndIf

      call fstring_cvb(specl,nspec,istr,ncmp,2)
      if(istr.eq.1)then
c 'SERVICE'
        service=.true.
        write(6,'(1x,a,/)') '**** Service mode **** '
        call service_cvb()
        return
      elseif(istr.eq.2)then
c 'MOSCOW'
        service=.true.
        write(6,'(1x,a,/)') '**** MOSCOW mode **** '
        call moscow_cvb()
        return
      elseif(istr.eq.3)then
        service=.true.
        write(6,'(1x,a,/)') '**** PERFLOC mode **** '
        !call perfloc_plc(3)
        call perfloc_plc()
        return
      endif

1000  continue

c  CASSCF wavefunction information :
      call casinfoinp_cvb()
c  VB wavefunction information :
      call fraginp_cvb(ip_iconfs)

      igroup=0
      call fstring_cvb(global,nglob,istr,ncmp,2)
      if(istr.ne.0)then
        igroup=1
        goto 1110
      endif
      call fstring_cvb(string,nstrin,istr,ncmp,2)
      if(istr.ne.0)then
        igroup=2
        goto 1110
      endif
      call fstring_cvb(endvb,nendvb,istr,ncmp,2)
      if(istr.ne.0)then
        igroup=3
        goto 1110
      endif
1110  continue
      if(igroup.eq.3)then
c 'ENDVB', 'ENDCASVB' or 'END'
        istr=0
      endif

      if(igroup.eq.2)goto 1111
      if(istr.eq.2)then
c 'START'
        strtvb=zero
520     call string_cvb(inpstr,1,nread,1)
        if(nread.eq.1)then
          if(inpstr(1:3).eq.'CI=')then
            call setfn_cvb(strtci,inpstr(4:50))
            goto 520
          elseif(inpstr(1:3).eq.'VB=')then
            call setfn_cvb(strtvb,inpstr(4:50))
            goto 520
          elseif(inpstr(1:3).eq.'MO=')then
            call setfn_cvb(strtmo,inpstr(4:50))
            goto 520
          elseif(inpstr(1:4).eq.'INT=')then
            call setfn_cvb(strtint,inpstr(5:50))
            goto 520
          endif
        endif
        if(valid_cvb(strtvb).and.firsttime_cvb())
     >    call touch_cvb('STRTGS')
      elseif(istr.eq.3)then
c 'GUESS'
        call gsinp_cvb(
     >    orbs,irdorbs,ip_cvb,nvbinp,kbasiscvb_inp,
     >    mxaobf,mxorb,kbasis,strtvb)
      elseif(istr.eq.4)then
c 'PRINT'
        call int_cvb(ip,10,nread,1)
      elseif(istr.eq.5)then
c 'PREC'
        call int_cvb(idum,1,nread,1)
        iprec=idum(1)
        if(iprec.lt.0)then
          write(6,*)' Illegal precision :',iprec
          call abend_cvb()
        endif
        call int_cvb(idum,1,nread,1)
        iwidth=idum(1)
        call formats_cvb()
      endif

c 'ENDVB', 'ENDCASVB' , 'END' or unrecognized keyword -- end of input :
      if(istr.ne.0)goto 1000
1111  continue

      if(istr.eq.1)then
      elseif(istr.eq.2)then
      elseif(istr.eq.3)then
c 'SAVE'
1520    call string_cvb(inpstr,1,nread,1)
        if(nread.eq.1)then
          if(inpstr(1:5).eq.'VBCI=')then
            call setfn_cvb(savvbci,inpstr(6:50))
            goto 1520
          elseif(inpstr(1:3).eq.'VB=')then
            call setfn_cvb(savvb,inpstr(4:50))
            goto 1520
          endif
        endif
      elseif(istr.eq.4)then
      elseif(istr.eq.5)then
c 'ORBPERM'
        if(firsttime_cvb())call touch_cvb('ORBPERM')
        call int_cvb(iorbprm,mxorb,nread,0)
        if(nread.gt.mxorb)then
          write(6,*)' Too many orbitals in ORBPERM keyword!'
          call abend_cvb()
        endif
        do 13350 iorb=1,nread
        if(abs(iorbprm(iorb)).lt.1.or.abs(iorbprm(iorb)).gt.mxorb)then
          write(6,'(a,40i3)')' Illegal orbital label(s) in ORBPERM:',
     >      (iorbprm(ior),ior=1,nread)
          call abend_cvb()
        endif
13350   continue
      elseif(istr.eq.6)then
c 'COUPLE'
        kbasis_old=kbasis
        call fstring_cvb(spinbkw,nspinb,kbasis,ncmp,1)
        if(kbasis.eq.0)kbasis=kbasis_old
        if(kbasis.eq.7)kbasis=6
      elseif(istr.eq.7)then
c  'MAXITER'
        call int_cvb(idum,1,nread,0)
        mxiter=idum(1)
      elseif(istr.eq.8)then
c 'CRIT'
        call fstring_cvb(crit,ncrit,icrit,ncmp,1)
        if(icrit.ne.1.and.icrit.ne.2)then
          write(6,*)' Unrecognized CRIT keyword!'
          call abend_cvb()
        endif
      elseif(istr.eq.9.or.istr.eq.10)then
c 'CASPROJ' or 'PROJCAS'
        projcas=.true.
      elseif(istr.eq.11.or.istr.eq.12)then
c 'NOCASPROJ' or 'NOPROJCAS'
        projcas=.false.
      elseif(istr.eq.15)then
c 'SYMELM'
        call symelminp_cvb(ip_symelm,nsyme,tags,izeta,
     >    mxirrep,mxorb,mxsyme,ityp)
      elseif(istr.eq.16)then
c 'ORBREL'
        iorb=0
        jorb=0
        call int_cvb(idum,1,nread,1)
        iorb=idum(1)
        call int_cvb(idum,1,nread,1)
        jorb=idum(1)
        if(iorb.lt.1.or.iorb.gt.mxorb.or.jorb.lt.1.or.jorb.gt.mxorb)then
          write(6,*)' Illegal orbital number(s) in ORBREL:',iorb,jorb
          call abend_cvb()
        endif
        iorbrel(1+ndimrel)=iorb
        iorbrel(2+ndimrel)=jorb
        nops=0
15300   call fstring_cvb(tags,nsyme,itag,3,1)
        if(itag.ne.0)then
          nops=nops+1
          if(ndimrel+3+nops.gt.mxdimrel)then
            write(6,*)' Too many symmetry elements in ORBREL keyword!'
            call abend_cvb()
          endif
          iorbrel(nops+3+ndimrel)=itag
          goto 15300
        endif
        iorbrel(3+ndimrel)=nops
        norbrel=norbrel+1
        ndimrel=ndimrel+3+nops
      elseif(istr.eq.18)then
c 'SYMPROJ'
        projsym=.true.
        call izero(isympr,mxirrep)
        call int_cvb(idum,1,nread,1)
        isymput=idum(1)
        if(nread.eq.1)then
          isympr(isymput)=1
15320     call int_cvb(idum,1,nread,1)
          isymput=idum(1)
          if(nread.eq.1)then
            isympr(isymput)=1
            goto 15320
          endif
        else
          call imove_cvb(isymv,isympr,mxirrep)
        endif
      elseif(istr.eq.19)then
c 'NOSYMPROJ'
        projsym=.false.
      elseif(istr.eq.20)then
c 'FIXORB'
        itmp = mstacki_cvb(mxorb)
        call intchk_cvb(iw(itmp),mxorb,nfxorb,0,'FIXORB',-1)
        call izero(ifxorb,mxorb)
        do 15340 i=1,nfxorb
        ifxorb(iw(i+itmp-1))=1
15340   continue
        call mfreei_cvb(itmp)
      elseif(istr.eq.21)then
c 'FIXSTRUC'
        lfxvb=0
        call mhpfreei_cvb(ifxstr)
        mxread=mavaili_cvb()/2
        ifxstr=mheapi_cvb(mxread)
        call intchk_cvb(iw(ifxstr),mxread,nfxvb,0,'FIXSTRUC',lfxvb)
        call mrealloci_cvb(ifxstr,nfxvb)
      elseif(istr.eq.22)then
c 'DELSTRUC'
        lzrvb=0
        call mhpfreei_cvb(izrstr)
        mxread=mavaili_cvb()/2
        izrstr=mheapi_cvb(mxread)
        call intchk_cvb(iw(izrstr),mxread,nzrvb,0,'DELSTRUC',lzrvb)
        call mrealloci_cvb(izrstr,nzrvb)
      elseif(istr.eq.23)then
c 'FREORB' - not implemented
        itmp = mstacki_cvb(mxorb)
        call intchk_cvb(iw(itmp),mxorb,nfrorb1,0,'FREORB',-1)
        itmp2 = mstackiz_cvb(mxorb)
        do i=1,nfrorb1
        iw(iw(i+itmp-1)+itmp2-1)=1
        enddo
        nfxorb1=0
        do i=1,mxorb
        if(iw(i+itmp2-1).eq.1)then
          nfxorb1=nfxorb1+1
          iw(nfxorb1+itmp-1)=i
        endif
        enddo
        call mfreei_cvb(itmp)
        nfxorb=max(nfxorb,nfxorb1)
      elseif(istr.eq.24)then
c 'FRESTRUC' - not implemented (and code incomplete)
        lfxvb=1
        call mhpfreei_cvb(ifxstr)
        mxread=mavaili_cvb()/2
        ifxstr=mheapi_cvb(mxread)
        call intchk_cvb(iw(ifxstr),mxread,nfxvb,0,'FRESTRUC',lfxvb)
        call mrealloci_cvb(ifxstr,nfxvb)
      elseif(istr.eq.25)then
c 'ORTHCON'
        mxgroup=40
        mxortl=40
        mxpair=mxorb*(mxorb-1)/2
        itmpa = mstacki_cvb(mxorb*mxorb)
        itmpb = mstacki_cvb(mxorb*mxgroup)
        itmpc = mstacki_cvb(mxgroup)
        itmpd = mstacki_cvb(mxortl)
        call orthcon_cvb(iorts,iw(itmpa),iw(itmpb),iw(itmpc),
     >  iw(itmpd),mxortl,mxpair)
        call mfreei_cvb(itmpa)
      elseif(istr.eq.26)then
c 'SADDLE'
        call int_cvb(idum,1,nread,1)
        isaddle=idum(1)
      elseif(istr.eq.27)then
c 'SHSTRUC'
        ishstruc=1
      elseif(istr.eq.28)then
c 'VBWEIGHT'
        ivbweights=0
15600   call fstring_cvb(weightkw,nwkw,istr2,ncmp,1)
        if(istr2.eq.1)then
          if(mod(ivbweights,2).eq.0)ivbweights=ivbweights+1
        elseif(istr2.eq.2)then
          if(mod(ivbweights,4).le.1)ivbweights=ivbweights+2
        elseif(istr2.eq.3)then
          if(mod(ivbweights,8).le.3)ivbweights=ivbweights+4
        elseif(istr2.eq.4)then
          ivbweights=0
        elseif(istr2.eq.5)then
          ivbweights=7
        endif
        if(istr2.gt.0)goto 15600
      elseif(istr.eq.29)then
c 'CIWEIGHT'
        npcf=10
        iciweights=0
15700   call fstring_cvb(weightkw,nwkw,istr2,ncmp,1)
        if(istr2.eq.1)then
          if(mod(iciweights,2).eq.0)iciweights=iciweights+1
        elseif(istr2.eq.2)then
          if(mod(iciweights,4).le.1)iciweights=iciweights+2
        elseif(istr2.eq.3)then
          if(mod(iciweights,8).le.3)iciweights=iciweights+4
        elseif(istr2.eq.4)then
          iciweights=0
        elseif(istr2.eq.5)then
          iciweights=7
        endif
        if(istr2.gt.0)goto 15700
        call int_cvb(idum,1,nread,1)
        npcf=idum(1)
      elseif(istr.eq.30)then
c 'SCORR'
        sij=.true.
      elseif(istr.eq.31)then
c 'NOSCORR'
        sij=.false.
      elseif(istr.eq.32)then
c 'METHOD'
        call fstring_cvb(methkw,nmeth,istr2,ncmp,1)
        if(istr2.ne.0)then
          imethod=istr2
        endif
      elseif(istr.eq.33.or.istr.eq.34)then
c 'OPTIM' or 'OPT'
        call maxdims_cvb()
        call loopcntr_cvb(1)
      elseif(istr.eq.35)then
c 'ENDOPTIM'
        call maxdims_cvb()
        call loopcntr_cvb(2)
      elseif(istr.eq.36)then
c 'REPORT '
        call maxdims_cvb()
        call loopcntr_cvb(3)
      elseif(istr.eq.37)then
c 'ENDREPOR'
        call maxdims_cvb()
        call loopcntr_cvb(4)
      elseif(istr.eq.39)then
c 'TUNE'
        call tuneinp_cvb()
      elseif(istr.eq.41)then
c 'OPPOSITE'
        opposite=.true.
      elseif(istr.eq.44)then
c 'STAT'
        if(firsttime_cvb())call touch_cvb('STAT')
      elseif(istr.eq.45)then
c 'INIT'
        initial=1
      elseif(istr.eq.46)then
c 'NOINIT'
        initial=0
      elseif(istr.eq.47)then
c 'TIDY'
      elseif(istr.eq.48)then
c 'PLOC'
        ploc=.true.
      elseif(istr.eq.49)then
c 'NOPLOC'
        ploc=.false.
      elseif(istr.eq.50)then
c 'ALTERN'
        mxalter=50
        call int_cvb(idum,1,nread,1)
        mxalter=idum(1)
        call loopcntr2_cvb(5,mxalter)
      elseif(istr.eq.51)then
c 'ENDALTER'
        call loopcntr_cvb(6)
      endif

c 'ENDVB', 'ENDCASVB' , 'END' or unrecognized keyword -- end of input :
      if(istr.ne.0)goto 1000
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(irots)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000-2016, Valera Veryazov                             *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Author:   Valera Veryazov 2000-2016                                  *
!           Theoretical Chemistry                                      *
!           Lund University                                            *
!           Sweden                                                     *
!                                                                      *
!***********************************************************************

subroutine StdIn_Name(Name)

use Definitions, only: iwp, u6

implicit none
character(len=16), intent(out) :: Name
character(len=132) :: Line
integer(kind=iwp) :: i, ib, ie, Iter, nName

nName = len(Name)
if (nName /= 16) then
  write(u6,*) 'StdIn_Name: Wrong length of character Name'
  call Abend()
end if
!write(u6,*) 'nName=',nName

Name = 'Stdin.  '
call GetEnvf('EMIL_RC2',Line)
read(Line,'(I132.132)') Iter
!write(u6,*) 'Line=',Line
!write(u6,*) 'Iter=',Iter
Iter = Iter+1
if (Line(1:1) == ' ') then
  Name(7:7) = '2'
else if (Iter <= 9) then
  write(Name(7:7),'(I1)') Iter
else if (Iter <= 99) then
  write(Name(7:8),'(I2)') Iter
else
  write(u6,*) 'StdIn_Name: Error in Line!'
  call Abend()
end if
Line = ' '
call GetEnvf('EMIL_InLoop',Line)
ib = -1
ie = -1
do i=1,len(Line)
  if ((Line(i:i) /= ' ') .and. (ib == -1)) then
    ib = i
  else if ((Line(i:i) == ' ') .and. (ib > 0)) then
    ie = i
    exit
  end if
end do
Name(index(Name,' '):) = '.'//Line(ib:ie)
!write(u6,*) '>',Line,'<',ib,ie
!write(u6,*) 'StdIn=',Name

return

end subroutine StdIn_Name

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Aufbau(EOr,nEOr,nAuf,Occup,nOccup,iOK,nD)
************************************************************************
*                                                                      *
*     purpose: sets the orbital occupation numbers in the different    *
*              irreps according to the Aufbau scheme...                *
*                                                                      *
*     method:  sets up a map vector, which is sorted with respect to   *
*              the orbital energies, neglecting the boundaries of the  *
*              different irrep blocks. The lowest orbitals then are    *
*              occupied...                                             *
*     input:                                                           *
*       EOr(nEOr)     : orbital energies                               *
*       nAuf          : # (doubly) occupied orbitals                   *
*                                                                      *
*     output:                                                          *
*       Occup(nOccup) : orbital occupation numbers                     *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*     calls to: ?????                                                  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1995                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
*     declaration subroutine parameters
      Real*8 EOr(nEOr,nD), Occup(nOccup,nD)
      Integer nAuf(2)
*
*     declaration of local variables...
      Integer, Dimension(:,:), Allocatable:: Map, Irp
      Real*8 Sum_el(2)
      Integer nOrb_AS(2), mOrb_AS(2)
*
*     These uccupation number vectors are used to determine if we have
*     convergence.
*
      Integer nOccAuf(MxSym,2,2),kOccAuf
      Save    nOccAuf,kOccAuf
      Data    kOccAuf/-1/
*
      Call mma_allocate(Map,nEOr,nD,Label='Map')
      Call mma_allocate(Irp,nEOr,nD,Label='Irp')
*----------------------------------------------------------------------*
* Initialize convergence detection                                     *
*----------------------------------------------------------------------*
      If(kOccAuf.eq.-1) Then
         Do i=1,MxSym
            nOccAuf(i,1,1)=-1
            nOccAuf(i,2,1)=-1
c for RHF we will not use nOccAuf_ab
            nOccAuf(i,1,2)=-1
            nOccAuf(i,2,2)=-1
         End Do
         kOccAuf=1
      End If
*
*---- Set up map...
*
      iOrbAS=1
      Do iSym = 1, nSym
         Do iOrb = 1, nOrb(iSym)-nFro(iSym)
            Do iD = 1, nD
               Irp(iOrbAS,iD)=iSym
               Map(iOrbAS,iD)=iOrbAS
            End Do
            iOrbAS=iOrbAS+1
         End Do
      End Do
      nOrbAS=iOrbAS-1
*
*---- Now sort map with respect to orbital energies (bubblesort)
*
      Do iOrbAS = 1, nOrbAS-1
         Do jOrbAS = nOrbAS-1, iOrbAS, -1
            Do iD = 1, nD
               If (EOr(Map(  jOrbAS,iD),iD).gt.
     &             EOr(Map(1+jOrbAS,iD),iD))
     &           Call Swap_Seward(Map(  jOrbAS,iD),
     &                            Map(1+jOrbAS,iD))
            End Do
         End Do
      End Do
*
*---- and fill up the orbitals...
*
      Call ICopy(nSym,[0],0,nOcc,1)
      call dcopy_(nOccup*nD,[Zero],0,Occup,1)
*
      If (Teee) then
*
         UHF_occ=3.0d0-UHF_Size
         mD = 2/nD
         Do iD = 1, nD
            eferm=FermiPop(EOr(1,iD),Occup(1,iD),nOrbAS,RTemp,
     &                     nAuf(iD)*mD,UHF_occ)
#ifdef _DEBUGPRINT_
            Write (6,'(A,G20.10)')'         E(Fermi)=',eferm
#endif
         End Do
*
         iOrbAS=0
         Do iSym = 1, nSym
            Do iD = 1, nD
               nOrb_AS(iD)=0
               mOrb_AS(iD)=0
               sum_el(iD)=0.0d0
            End Do

            jOrbAS = iOrbAS
            unlikelyOcc=0.19D0
            Do iOrb = 1, nOrb(iSym)-nFro(iSym)
               iOrbAS = iOrbAS + 1
               Do iD = 1, nD
                  If (Occup(iOrbAS,iD).ge.UHF_occ-unlikelyOcc)
     &               nOrb_AS(iD) = nOrb_AS(iD) + 1
                  If (Occup(iOrbAS,iD).lt.unlikelyOcc)
     &               mOrb_AS(iD) = mOrb_AS(iD) + 1
                  sum_el(iD)=sum_el(iD)+Occup(iOrbAS,iD)
               End Do
            End Do
            Fact=nD*0.5D0
            Fact2=0.99D0 + DBLE(2-nD)
            Do iD = 1, nD
               nOccAuf(iSym,kOccAuf,iD)=nOrb_AS(iD)
               nOcc(iSym,iD)=INT(Fact*(sum_el(iD)+Fact2/nSym))
            End Do
         End Do
         kOccAuf=3-kOccAuf
*
      Else
*
         Fact=Two/DBLE(nD)
         Do iD = 1, nD
            Do iOrbAS = 1, nAuf(iD)
               iSym=Irp(Map(iOrbAS,iD),iD)
               nOcc(iSym,iD)=nOcc(iSym,iD)+1
               ipOcc=0
               Do jSym = 1, iSym-1
                  ipOcc=ipOcc+nOrb(jSym)
               End Do
               Occup(ipOcc+nOcc(iSym,iD),iD)=Fact
            End Do
         End Do
*
      End If
*
      iOK=1
      Do iD = 1, nD
         nElec=0
         Do iSym=1,nSym
            If (nOccAuf(iSym,1,iD).ne.nOccAuf(iSym,2,iD)) iOK=0
            nElec=nElec+nOccAuf(iSym,1,iD)
         End Do
         If(nElec.ne.nAuf(iD)) iOK=0
      End Do
      If (iOK.eq.1) Then
         Do iSym=1,nSym
            Do iD = 1, nD
               nOcc(iSym,iD)=nOccAuf(iSym,1,iD)
            End Do
         End Do
      End If
*
*---- Write new occupation on the RUNFILE
*
      Call Put_iArray('nIsh',nOcc(1,1),nSym)
      if(iUHF.eq.1) Call Put_iArray('nIsh beta',nOcc(1,2),nSym)
*
      Call mma_deallocate(Irp)
      Call mma_deallocate(Map)
*
      Return
      End
************************************************************************
*                                                                      *
* This function computes the Fermi energy level for a number of        *
* energy levels and populates them. Each level is populated with up    *
* to 2 electrons.                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: June 1999                                                   *
* History:                                                             *
*                                                                      *
************************************************************************
      Real*8 Function FermiPop(e,o,n,T,nEle,UHF_occ)
      Implicit None
*----------------------------------------------------------------------*
* Dummy arguments:                                                     *
* e(*) -- Orbital energies, input.                                     *
* o(*) -- Orbital occupations, output.                                 *
* n    -- Number of orbitals, input.                                   *
* T    -- Temperature, input.                                          *
* nEle -- Number of electrons.                                         *
*----------------------------------------------------------------------*
      Real*8  e(*),o(*),T,UHF_occ
      Integer n,nEle
*----------------------------------------------------------------------*
* Local variables:                                                     *
*----------------------------------------------------------------------*
      Real*8  ef,beta,f,f_old,Step,ff
      Real*8  x0,x1,x2,y0,y1,y2,z
      Integer i,iter
*----------------------------------------------------------------------*
* Initialize                                                           *
*----------------------------------------------------------------------*
      ef=0.0d0
      If (T.le.0.0d0) Then
         beta=1.0D99
      Else
         beta=1.0d0/T
      End If
*----------------------------------------------------------------------*
* Scan for Fermi level                                                 *
*----------------------------------------------------------------------*
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write(6,'(a)') 'Scan for Fermi energy level'
      Write(6,'(a)') '       ef             y       '
      Write(6,'(a)') ' -------------- --------------'
#endif

      f=-nEle
      f_old=f
      Do i=1,n
*        Write (6,'(A,G20.10)') 'e(i)=',e(i)
         z=beta*(e(i)-ef)
         z=Min(z,30.d0)
         f=f+UHF_occ/(1.0d0+exp(z))
      End Do
      If(f.gt.0.0d0) Then
         Step=-1.0d0
      Else
         Step=1.0d0
      End If
      Iter=0
100   Continue
         Iter=Iter+1
         If(Iter.gt.100000) GoTo 101
         f_old=f
         ef=ef+Step
c         f=-nEle
         ff=0.0d0
cvv overoptimization with Intel compiler
         i=1
300      continue
c         Do i=1,n
            z=beta*(e(i)-ef)
            z=Min(z,30.d0)
            ff=ff+1/(1.0d0+exp(z))
            i=i+1
            if(i.le.n) goto 300
c         End Do
         f=-nEle+ff*UHF_occ
#ifdef _DEBUGPRINT_
         Write(6,'(2G20.10)') ef,f
#endif
         If(f*f_old.gt.0.0d0) GoTo 100
101   Continue
*----------------------------------------------------------------------*
* Refine with interval halving.                                       *
*----------------------------------------------------------------------*
#ifdef _DEBUGPRINT_
      Write(6,'(a)') 'Refine Fermi level with interval halving'
      Write(6,'(a)') '       y0            y2             y1       '
      Write(6,'(a)') ' -------------- -------------- --------------'
#endif
      x0=ef-Step
      x1=ef
      y0=f_old
      y1=f
      x2=0.5d0*(x0+x1)
      Iter=0
200   Continue
         Iter=iter+1
         If(Iter.gt.1000) GoTo 201
         ef=x2
         f=-nEle
         Do i=1,n
            z=beta*(e(i)-ef)
            z=Min(z,30.0d0)
            f=f+UHF_occ/(1.0d0+exp(z))
         End Do
         y2=f
#ifdef _DEBUGPRINT_
         Write(6,'(3f15.8)') y0,y2,y1
#endif
         If(abs(y2).lt.1.0d-9) GoTo 201
         If(y0*y2.le.0.0d0) Then
            x1=x2
            y1=y2
         Else
            x0=x2
            y0=y2
         End If
         x2=0.5d0*(x0+x1)
         GoTo 200
201   Continue

*----------------------------------------------------------------------*
* Populate occupation number vector.                                   *
*----------------------------------------------------------------------*
*     Write (*,*)
      f=0.0d0
      Do i=1,n
*        Write(*,'(2G20.10)') e(i),ef
         z=beta*(e(i)-ef)
*        Write (*,*) 'z,Beta=',z,Beta
         z=Min(z,30.0d0)
*        Write (*,*) 'z=',z
         o(i)=UHF_occ/(1.0d0+exp(z))
*        Write(*,'(1G20.10)') o(i)
         f=f+o(i)
      End Do
      f=nEle/f
*     Write (*,*)
*     Write(*,'(1G20.10)') f
*     Write (*,*)
      Do i=1,n
         o(i)=f*o(i)
*        Write(*,'(1G20.10)') o(i)
      End Do
*----------------------------------------------------------------------*
* Done                                                                 *
*----------------------------------------------------------------------*

      FermiPop=ef
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Ignacio Fdez. Galvan                             *
************************************************************************
*  CG_Solver
*
*> @brief
*>   Solve a system of linear equations with a preconditioned conjugate gradients method
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Given a system of linear equations \f$ A x = b \f$, this routine attempts to solve
*> it with a preconditioned conjugate gradients method.
*> The matrix \p A should be symmetric positive definite.
*> The method is useful with a sparse matrix, where \f$ A x \f$ can be computed efficiently.
*> The preconditioner is an incomplete Cholesky decomposition, which becomes complete
*> with a dense matrix, and then it should converge at the first iteration.
*> If a dense matrix is used, the \p ija(1) value must be `0`.
*> On output, \p info contains the number of iterations needed for convergence,
*> or `-1` if it did not converge.
*>
*> @param[in]     n    Size of the system
*> @param[in]     nij  Size of \p A and \p ija
*> @param[in]     A    Input matrix in dense or sparse format
*> @param[in]     ija  Index vector of matrix \p A
*> @param[in]     b    Vector of independent terms
*> @param[in,out] x    Solution vector
*> @param[in,out] info Status info
************************************************************************
      SUBROUTINE CG_Solver(n,nij,A,ija,b,x,info)
      IMPLICIT NONE
      INTEGER n, ija(*), nij, maxk, recomp, k, info
      REAL*8 A(nij), b(n), x(n)
      REAL*8, DIMENSION(:), ALLOCATABLE :: r, p, Ap, z, y
      REAL*8 rr, alpha, beta
      REAL*8 Thr, RelThr
      INTEGER ipLo, ipUp, ipijLo, ipijUp
      PARAMETER (Thr=1.0d-20)
      real*8 ddot_
      external ddot_
      LOGICAL Sparse
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"

      CALL mma_allocate(r,n)
      CALL mma_allocate(p,n)
      CALL mma_allocate(Ap,n)
      CALL mma_allocate(z,n)
      CALL mma_allocate(y,n)

c     Same algorithm, with different calls for sparse or dense matrices
      Sparse=(ija(1).GT.0)

      maxk=MAX(10,n*n)
      recomp=MAX(50,INT(n/DBLE(10)))
      call dcopy_(n,b,1,r,1)

      IF (Sparse) THEN
        CALL Allocate_Work(ipLo,nij)
        CALL Allocate_Work(ipUp,nij)
        CALL Allocate_iWork(ipijLo,nij)
        CALL Allocate_iWork(ipijUp,nij)
c
c       Compute the preconditioner
        CALL Sp_ICD(n,A,ija,Work(ipLo),iWork(ipijLo))
        CALL Sp_Transpose(n,Work(ipLo),iWork(ipijLo),
     &                          Work(ipUp),iWork(ipijUp),nij)

c
c       Initial guess: r = A*x-b
        CALL Sp_MV(n,-One,A,ija,x,One,r)
        CALL Sp_TriSolve(n,'L',Work(ipLo),iWork(ipijLo),r,y)
        CALL Sp_TriSolve(n,'U',Work(ipUp),iWork(ipijUp),y,z)
        call dcopy_(n,z,1,p,1)
        rr=DDot_(n,z,1,r,1)
        RelThr=Thr*MAX(rr,One)
        k=1
        DO WHILE ((ABS(rr).GE.RelThr).AND.(k.LE.maxk))
          CALL Sp_MV(n,One,A,ija,p,Zero,Ap)
          alpha=rr/DDot_(n,p,1,Ap,1)
          call daxpy_(n,alpha,p,1,x,1)
          beta=rr
c
c         Recompute or update the residual
          IF (MOD(k,recomp).EQ.0) THEN
            call dcopy_(n,b,1,r,1)
            CALL Sp_MV(n,-One,A,ija,x,One,r)
          ELSE
            call daxpy_(n,-alpha,Ap,1,r,1)
          END IF
          CALL Sp_TriSolve(n,'L',Work(ipLo),iWork(ipijLo),r,y)
          CALL Sp_TriSolve(n,'U',Work(ipUp),iWork(ipijUp),y,z)
          rr=DDot_(n,z,1,r,1)
          call dscal_(n,rr/beta,p,1)
          call daxpy_(n,One,z,1,p,1)
          k=k+1
        END DO
        CALL Free_Work(ipLo)
        CALL Free_Work(ipUp)
        CALL Free_iWork(ipijLo)
        CALL Free_iWork(ipijUp)
      ELSE
        CALL Allocate_Work(ipLo,nij)

c
c       With a dense matrix, the preconditioner could be replaced with
c       something else, otherwise this is just solving the system with
c       a direct method
        call dcopy_(n*n,A,1,Work(ipLo),1)
        call dpotrf_('L',n,Work(ipLo),n,info)

        CALL DSyMV('L',n,-One,A,n,x,1,One,r,1)
        call dcopy_(n,r,1,z,1)
        CALL DPoTrS('L',n,1,Work(ipLo),n,z,n,info)
        call dcopy_(n,z,1,p,1)
        rr=DDot_(n,z,1,r,1)
        RelThr=Thr*MAX(rr,One)
        k=1
        DO WHILE ((ABS(rr).GE.RelThr).AND.(k.LE.maxk))
          Call dGeMV_('N',n,n,One,A,n,p,1,Zero,Ap,1)
          alpha=rr/DDot_(n,p,1,Ap,1)
          call daxpy_(n,alpha,p,1,x,1)
          beta=rr
          IF (MOD(k,recomp).EQ.0) THEN
            call dcopy_(n,b,1,r,1)
            Call dGeMV_('N',n,n,-One,A,n,x,1,One,r,1)
          ELSE
            call daxpy_(n,-alpha,Ap,1,r,1)
          END IF
          call dcopy_(n,r,1,z,1)
          CALL DPoTrS('L',n,1,Work(ipLo),n,z,n,info)
          rr=DDot_(n,z,1,r,1)
          call dscal_(n,rr/beta,p,1)
          call daxpy_(n,One,z,1,p,1)
          k=k+1
        END DO
        CALL Free_Work(ipLo)
      END IF

c
c     Set the return value
      IF (k.LE.maxk) THEN
        info=k
      ELSE
        info=-1
      END IF

      CALL mma_deallocate(r)
      CALL mma_deallocate(p)
      CALL mma_deallocate(Ap)
      CALL mma_deallocate(z)
      CALL mma_deallocate(y)

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine exth5(a,b,dimp,dimq,dimqr,q)
! this routine extracts A(p,qr) -> B_q(p,r)
!
! a     - matrix a (Input)
! b     - matrix b (Output)
! dimp  - dimension of p (Input)
! dimq  - dimension of q (and also r) (Input)
! dimqr - dimension of qr (Input)
! q     - value of index q (Input)

use CCT3_global, only: nshf
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dimqr, q
real(kind=wp), intent(in) :: a(dimp,dimqr)
real(kind=wp), intent(out) :: b(dimp,dimq)
integer(kind=iwp) :: qr0, r, rq

if (q == 0) return

! r>q part
if (q > 1) then
  qr0 = nshf(q)
  b(:,1:q-1) = a(:,qr0+1:qr0+q-1)
end if

! r=q part
b(:,q) = Zero

! r<p part
if (q < dimq) then
  do r=q+1,dimq
    rq = nshf(r)+q
    b(:,r) = -a(:,rq)
  end do
end if

return

end subroutine exth5

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Roland Lindh                                           *
************************************************************************
*  ip_of_Work
*
*> @brief
*>   Return pointer to be used in \c Work which corresponds to the first element of array \p A
*> @author R. Lindh
*>
*> @details
*> Function returns pointer such that \p A and \c Work(ip_of_Work(A)) refer to
*> the same memory location.
*>
*> @param[in] A first element of real array
*>
*> @return pointer to \p A in \c Work
************************************************************************
      Integer Function ip_of_work(A)
      Implicit real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Real*8 A
*
      loc1=(idLoc(A)-idLoc(Work(ip_Dummy)))
      loc2=(idLoc(Work(ip_Dummy+1))-idLoc(Work(ip_Dummy)))
      ip_of_Work = ip_Dummy + loc1/loc2
*
      Return
      End

      Integer Function ip_of_Work_i(A)
      Implicit real*8 (a-h,o-z)
      Integer A
      ip_of_Work_i = ip_of_Work_i_internal(A)
*
*     This is to allow type punning without an explicit interface
      Contains
      Integer Function ip_of_Work_i_internal(A)
      Use Iso_C_Binding
      Integer, Target :: A
      Real*8, Pointer :: dA
      Call C_F_Pointer(C_Loc(A),dA)
      ip_of_Work_i_internal = ip_of_Work(dA)
      Nullify(dA)
      End Function ip_of_Work_i_internal
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Giovanni Li Manni                                *
!               2019, Oskar Weser                                      *
!***********************************************************************

module fcidump_transformations

use general_data, only: nActEl, nAsh, nBas, nSym, ntot1, ntot2
use rasscf_global, only: nAc, nAcPar, Emy
use index_symmetry, only: one_el_idx_flatten
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

public :: fold_Fock, get_orbital_E

contains

!>  @brief
!>    Get the orbital energies.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  If it is the 1A or 1B iteration (0 <= actual_iter <= 1), the one electron
!>  energies are read from the InpOrb.
!>  Otherwise orbital_energies is a copy of DIAF.
!>
!>  @param[in] actual_iter
!>  @param[in] DIAF
!>  @param[out] orbital_energies
subroutine get_orbital_E(actual_iter,DIAF,orbital_energies)

  integer(kind=iwp), intent(in) :: actual_iter
  real(kind=wp), intent(in) :: DIAF(:)
  real(kind=wp), intent(out) :: orbital_energies(:)

  orbital_energies = Zero
  if ((0 <= actual_iter) .or. (actual_iter <= 1)) then
    call read_orbital_energies(nSym,nBas,orbital_energies)
  else
    orbital_energies(:) = DIAF(:)
  end if

  contains

  subroutine read_orbital_energies(nSym,nBas,orbital_energies)

    use Definitions, only: u6

    integer(kind=iwp), intent(in) :: nSym, nBas(:)
    real(kind=wp), intent(inout) :: orbital_energies(:)
    integer(kind=iwp) :: err, iDummy(1)
    real(kind=wp) :: Dummy(1)
    character(len=80) :: VecTit
    logical(kind=iwp) :: okay
    integer(kind=iwp), parameter :: LuInpOrb = 10
    character(len=*), parameter :: FnInpOrb = 'INPORB'

    call f_Inquire(FnInpOrb,okay)
    if (okay) then
      call RdVec(FnInpOrb,LuInpOrb,'E',nSym,nBas,nBas,Dummy,Dummy,orbital_energies,iDummy,VecTit,0,err)
    else
      write(u6,*) 'RdCMO: Error finding MO file'
      call Abend()
    end if

  end subroutine read_orbital_energies

end subroutine get_orbital_E

!>  @brief
!>    Generate inactive Fock-matrix in active MO space
!>
!>  @author Oskar Weser
!>
!>  @details
!>  Generate the Fock-matrix for the frozen and inactive orbitals.
!>  in the basis of the active MOs as obtained from ::SGFCIN.
!>  Has the sideeffect of setting \p EMY to the core energy.
!>
!>  @param[in] CMO The MO coefficients.
!>  @param[in] D1I_AO The inactive one-body density matrix in AO-space
!>    \f[D^{\text{AO}, I} = 2 C (C^I)^\dagger \f]
!>    See ::get_D1I_rasscf.
!>  @param[in] D1A_AO The active one-body density matrix in AO-space
!>    \f[ D^{\text{AO}, A} = C^A D^A (C^A)^\dagger \f]
!>    See ::get_D1A_rasscf.
!>  @param[in] D1S_MO The active spin density matrix in MO-space
!>    \f[ D^A_\alpha - D^A_\beta \f]
!>  @param[in,out] F_In The inactive Fock matrix in AO-space
!>    \f[\sum_{\sigma\rho} D^I_{\sigma\rho}(g_{\mu\nu\sigma\rho} - \frac{1}{2} g_{\mu\sigma\rho\nu})\f]
!>    In output FI contains also the core energy added to
!>    the diagonal elements.
!>    \f[\sum_{\sigma\rho} D^I_{\sigma\rho}(g_{\mu\nu\sigma\rho} -
!>      \frac{1}{2} g_{\mu\sigma\rho\nu}) + \frac{E^{(0)}}{n_el} \delta_{\mu\nu} \f]
!>  @param[out] folded_Fock The inactive Fock matrix
!>    in the basis of the active MOs as obtained from ::SGFCIN.
subroutine fold_Fock(CMO,D1I_AO,D1A_AO,D1S_MO,F_In,folded_Fock)

  use stdalloc, only: mma_allocate, mma_deallocate

  real(kind=wp), intent(in) :: CMO(nTot2), D1A_AO(nTot2), D1I_AO(nTot2), D1S_MO(nAcPar)
  real(kind=wp), intent(inout) :: F_In(nTot1)
  real(kind=wp), intent(out) :: folded_Fock(nAcPar)
  integer(kind=iwp) :: i, n
  real(kind=wp) :: core_E_per_act_el
  real(kind=wp), allocatable :: D1S_AO(:), D1S_MO_blocked(:)

  ! D1S_AO: one-body spin density matrix in AO-space
  ! D1S_MO: blocked one-body spin density matrix in MO-space
  call mma_allocate(D1S_AO,nTot2,Label='D1S_AO')
  call mma_allocate(D1S_MO_blocked,nAcPar,Label='D1S_MO_blocked')

  D1S_MO_blocked(:nAcPar) = D1S_MO(:nAcPar)
  if (nAsh(1) /= nAc) call DBlock(D1S_MO_blocked)
  call get_D1A_RASSCF(CMO,D1S_MO_blocked,D1S_AO)
  ! SGFCIN has side effects and EMY/core_energy is set in this routine.
  ! Besides F_In will contain the one electron contribution afterwards.
  call SGFCIN(CMO,folded_fock,F_In,D1I_AO,D1A_AO,D1S_AO)

  call mma_deallocate(D1S_AO)
  call mma_deallocate(D1S_MO_blocked)

  ! Remove the core energy in the diagonal elements.
  if (nActEl /= 0) then
    core_E_per_act_el = Emy/real(nActEl,kind=wp)
  else
    core_E_per_act_el = Zero
  end if

  do i=1,sum(nAsh)
    n = one_el_idx_flatten(i,i)
    folded_Fock(n) = folded_Fock(n)-core_E_per_act_el
  end do

end subroutine fold_Fock

end module fcidump_transformations

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine cvprt_cvb(a,l)
      implicit real*8(a-h,o-z)
#include "formats_cvb.fh"
      character*20 a
      logical l
      character*16 a1
      save huge
      data huge/1d20/

      if(l)then
        write(6,'(2a)')a,'     Converged.'
      else
        write(6,'(2a)')a,' Not converged.'
      endif
      return
      entry cvprt2_cvb(a1,f1,f2,ic)
      if(abs(f2).ne.huge)then
        if(ic.eq.1.and.f1.lt.f2)then
          write(6,formcvp)a1,f1,'     smaller than',f2
        elseif(ic.eq.1)then
          write(6,formcvp)a1,f1,' not smaller than',f2
        elseif(ic.eq.2.and.f1.gt.f2)then
          write(6,formcvp)a1,f1,'     greater than',f2
        elseif(ic.eq.2)then
          write(6,formcvp)a1,f1,' not greater than',f2
        endif
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
! Some incomplete documentation (logical variables)
!
! Vlct       : logical flag to indicate that the velocity integrals will
!              be computed
! lRel       : logical flag to indicate that the 1-electron Darwin and
!              mass-velocity integrals should be computed
! UnNorm     : logical flag to indicate that the primitive basis
!              functions should not be normalized
! lSchw      : logical flag to indicate that the Cauchy-Schwartz
!              inequality should be used in the prescreening
! lAMFI      : logical flag for Atomic Mean Field Integrals
! GIAO       : integrals for first derivative with respect to B
! Do_FckInt  : logical flag for FckInt
! Do_GuessOrb: logical flag for GuessOrb
! EMFR       : electromagnetic field radiation
! FNMC       : finite nuclear mass correction

module Gateway_Info

use Constants, only: Zero, One, Three
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: lLen = 19, & ! number of logical elements
                                rLen = 45 ! number of real, elements
real(kind=wp) :: AccMch = 1.0e-15_wp, &
                 cdMax = Zero, &
                 ChiI2 = Zero, &
                 CoC(3) = Zero, &
                 CoM(3) = Zero, &
                 CutInt = 1.0e-16_wp, &
                 E1 = Zero, &
                 E2 = Zero, &
                 EtMax = Zero, &
                 kVector(3) = Zero, &
                 PAX(3,3) = Zero, &
                 PkAcc = 1.0e-14_wp, &
                 PotNuc = Zero, &
                 Prin(3) = Zero, &
                 qNuc = Zero, &
                 RadMax = Zero, &
                 rMI(6) = Zero, &
                 RPQMin = 0.4_wp, &
                 Rtrnc = Three, &
                 SadStep = 0.1_wp, &
                 Shake = -One, &
                 ThrInt = 1.0e-14_wp, &
                 Thrs = 1.0e-6_wp, &
                 TMass = Zero
logical(kind=iwp) :: Align_Only = .false., &
                     Do_Align = .true., &
                     Do_FckInt = .true., &
                     Do_GuessOrb = .true., &
                     DoFMM = .false., &
                     EMFR = .false., &
                     FNMC = .false., &
                     GIAO = .false., &
                     lAMFI = .false., &
                     lDOWNONLY = .false., &
                     lMXTC = .false., &
                     lRel = .false., &
                     lRP = .false., &
                     lRP_Post = .false., &
                     lSchw = .true., &
                     lUPONLY = .false., &
                     NEMO = .false., &
                     UnNorm = .false., &
                     Vlct = .true.

public :: AccMch, Align_Only, cdMax, ChiI2, CoC, CoM, CutInt, Do_Align, Do_FckInt, Do_GuessOrb, DoFMM, E1, E2, EMFR, EtMax, FNMC, &
          GIAO, kVector, lAMFI, lDOWNONLY, lMXTC, lRel, lRP, lRP_Post, lSchw, lUPONLY, NEMO, PAX, PkAcc, PotNuc, Prin, qNuc, &
          RadMax, Gateway_Info_Dmp, Gateway_Info_Get, rMI, RPQMin, Rtrnc, SadStep, Shake, ThrInt, Thrs, TMass, UnNorm, Vlct

contains

subroutine Gateway_Info_Dmp()

  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp), allocatable :: iDmp(:)
  real(kind=wp), allocatable :: rDmp(:)

  call mma_allocate(rDmp,rLen,Label='rDmp:Real')

  rDmp(01) = AccMch
  rDmp(02) = ThrInt
  rDmp(03) = PotNuc
  rDmp(04) = Rtrnc
  rDmp(05) = CutInt
  rDmp(06) = TMass
  rDmp(07) = qNuc
  rDmp(08) = PkAcc
  rDmp(09) = Thrs
  rDmp(10) = RadMax
  rDmp(11) = cdMax
  rDmp(12) = EtMax
  rDmp(13) = E1
  rDmp(14) = E2
  rDmp(15) = RPQMin
  rDmp(16) = SadStep
  rDmp(17) = Shake
  rDmp(18) = ChiI2
  rDmp(19:21) = CoM(1:3)
  rDmp(22:27) = rMI(1:6)
  rDmp(28:30) = Prin(1:3)
  rDmp(31:39) = reshape(PAX(1:3,1:3),[3*3])
  rDmp(40:42) = CoC(1:3)
  rDmp(43:45) = kVector(1:3)

  call Put_dArray('Real_Info',rDmp,rLen)
  call mma_deallocate(rDmp)

  call mma_allocate(iDmp,lLen,Label='iDmp:Logical')

  iDmp(01) = merge(1,0,Vlct)
  iDmp(02) = merge(1,0,lRel)
  iDmp(03) = merge(1,0,UnNorm)
  iDmp(04) = merge(1,0,lSchw)
  iDmp(05) = merge(1,0,lAMFI)
  iDmp(06) = merge(1,0,NEMO)
  iDmp(07) = merge(1,0,Do_GuessOrb)
  iDmp(08) = merge(1,0,Do_FckInt)
  iDmp(09) = merge(1,0,Align_Only)
  iDmp(10) = merge(1,0,DoFMM)
  iDmp(11) = merge(1,0,lRP)
  iDmp(12) = merge(1,0,lRP_Post)
  iDmp(13) = merge(1,0,Do_Align)
  iDmp(14) = merge(1,0,EMFR)
  iDmp(15) = merge(1,0,GIAO)
  iDmp(16) = merge(1,0,lUPONLY)
  iDmp(17) = merge(1,0,lDOWNONLY)
  iDmp(18) = merge(1,0,FNMC)
  iDmp(19) = merge(1,0,lMXTC)

  call Put_iArray('Logical_Info',iDmp,lLen)
  call mma_deallocate(iDmp)

end subroutine Gateway_Info_Dmp

subroutine Gateway_Info_Get()

  use stdalloc, only: mma_allocate, mma_deallocate

  integer(kind=iwp), allocatable :: iDmp(:)
  real(kind=wp), allocatable :: rDmp(:)

  call mma_allocate(rDmp,rLen,Label='rDmp:Real')
  call Get_dArray('Real_Info',rDmp,rLen)

  AccMch = rDmp(01)
  ThrInt = rDmp(02)
  PotNuc = rDmp(03)
  Rtrnc = rDmp(04)
  CutInt = rDmp(05)
  TMass = rDmp(06)
  qNuc = rDmp(07)
  PkAcc = rDmp(08)
  Thrs = rDmp(09)
  RadMax = rDmp(10)
  cdMax = rDmp(11)
  EtMax = rDmp(12)
  E1 = rDmp(13)
  E2 = rDmp(14)
  RPQMin = rDmp(15)
  SadStep = rDmp(16)
  Shake = rDmp(17)
  ChiI2 = rDmp(18)
  CoM(1:3) = rDmp(19:21)
  rMI(1:6) = rDmp(22:27)
  Prin(1:3) = rDmp(28:30)
  PAX(1:3,1:3) = reshape(rDmp(31:39),[3,3])
  CoC(1:3) = rDmp(40:42)
  kVector(1:3) = rDmp(43:45)

  call mma_deallocate(rDmp)

  call mma_allocate(iDmp,lLen,Label='iDmp:Logical')
  call Get_iArray('Logical_Info',iDmp,lLen)

  Vlct = iDmp(1) > 0
  lRel = iDmp(2) > 0
  UnNorm = iDmp(3) > 0
  lSchw = iDmp(4) > 0
  lAMFI = iDmp(5) > 0
  NEMO = iDmp(6) > 0
  Do_GuessOrb = iDmp(7) > 0
  Do_FckInt = iDmp(8) > 0
  Align_Only = iDmp(9) > 0
  DoFMM = iDmp(10) > 0
  lRP = iDmp(11) > 0
  lRP_Post = iDmp(12) > 0
  Do_Align = iDmp(13) > 0
  EMFR = iDmp(14) > 0
  GIAO = iDmp(15) > 0
  lUPONLY = iDmp(16) > 0
  lDOWNONLY = iDmp(17) > 0
  FNMC = iDmp(18) > 0
  lMXTC = iDmp(19) > 0

  call mma_deallocate(iDmp)

end subroutine Gateway_Info_Get

end module Gateway_Info

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_RdQCol_Indx(xInt,IDCol,nRow,nCol,Lunit)
!
! Purpose: read indexed qualified columns from WA file with unit
!          Lunit. (WA=word-addressable)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCol, IDCol(nCol), nRow, Lunit
real(kind=wp), intent(out) :: xInt(nRow,nCol)
integer(kind=iwp) :: iAdr, iCol, iOpt, lTot

if ((nRow < 1) .or. (nCol < 1)) return

do iCol=1,nCol
  iOpt = 2
  lTot = nRow
  iAdr = nRow*(IDCol(iCol)-1)
  call dDAFile(Lunit,iOpt,xInt(:,iCol),lTot,iAdr)
end do

end subroutine Cho_RdQCol_Indx

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  PERMVB := Permute orbitals in V1 according to IPERM.             *
c  *  PERMCI := Permute orbitals in V1 according to IPERM.             *
c  *                                                                   *
c  *  V1 is either full CI vector (NDET), or just                      *
c  *  VB determinants (NDETVB).                                        *
c  *                                                                   *
c  *********************************************************************
      subroutine permvb_cvb(v1,iperm)
c  Permutes orbitals in V1 according to IPERM.
      implicit real*8 (a-h,o-z)
      logical vb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension iperm(norb),v1(*)

      vb=.true.
      k1 = mstacki_cvb((norb+1)*(nalf+1))
      k2 = mstacki_cvb((norb+1)*(nbet+1))
      k5 = mstacki_cvb(norb+1)
      k6 = mstacki_cvb(norb+1)
      k7 = mstacki_cvb(norb+1)
      k8 = mstacki_cvb(norb)
      k9 = mstacki_cvb(norb)
      k10= mstacki_cvb(norb)
      k11= mstacki_cvb(norb)
      k12= mstacki_cvb(norb)
      k13= mstacki_cvb(nda)
      k14= mstackr_cvb(nda)
      k15= mstacki_cvb(ndb)
      k16= mstackr_cvb(ndb)
      if(vb)then
        k17= mstackr_cvb(ndetvb)
      elseif(mavailr_cvb().ge.ndet)then
        ialg=1
        k17= mstackr_cvb(ndet)
      else
        ialg=2
        k17= mstackr_cvb(nda)
      endif
      if(vb)then
        call permvb2_cvb(v1,iperm,vb,iwork(ll(11)),iwork(ll(12)),
     >    iwork(k1),iwork(k2),iwork(k5),iwork(k6),
     >    iwork(k7),iwork(k8),iwork(k9),iwork(k10),iwork(k11),
     >    iwork(k12),
     >    iwork(k13),work(k14),iwork(k15),work(k16),work(k17),ialg)
      else
        iv1=nint(v1(1))
cDLC iwork(maddr_r2i_cvb(iaddr_ci(iv1))) --> work(iaddr_ci(iv1))
        call permvb2_cvb(work(iaddr_ci(iv1)),
     >    iperm,vb,iwork(ll(11)),iwork(ll(12)),
     >    iwork(k1),iwork(k2),iwork(k5),iwork(k6),
     >    iwork(k7),iwork(k8),iwork(k9),iwork(k10),iwork(k11),
     >    iwork(k12),
     >    iwork(k13),work(k14),iwork(k15),work(k16),work(k17),ialg)
      endif
      call mfreei_cvb(k1)
      return
      end
      subroutine permci_cvb(v1,iperm)
      implicit real*8 (a-h,o-z)
      logical vb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension iperm(norb),v1(*)
      vb=.false.
      k1 = mstacki_cvb((norb+1)*(nalf+1))
      k2 = mstacki_cvb((norb+1)*(nbet+1))
      k5 = mstacki_cvb(norb+1)
      k6 = mstacki_cvb(norb+1)
      k7 = mstacki_cvb(norb+1)
      k8 = mstacki_cvb(norb)
      k9 = mstacki_cvb(norb)
      k10= mstacki_cvb(norb)
      k11= mstacki_cvb(norb)
      k12= mstacki_cvb(norb)
      k13= mstacki_cvb(nda)
      k14= mstackr_cvb(nda)
      k15= mstacki_cvb(ndb)
      k16= mstackr_cvb(ndb)
      if(vb)then
        k17= mstackr_cvb(ndetvb)
      elseif(mavailr_cvb().ge.ndet)then
        ialg=1
        k17= mstackr_cvb(ndet)
      else
        ialg=2
        k17= mstackr_cvb(nda)
      endif
      if(vb)then
        call permvb2_cvb(v1,iperm,vb,iwork(ll(11)),iwork(ll(12)),
     >    iwork(k1),iwork(k2),iwork(k5),iwork(k6),
     >    iwork(k7),iwork(k8),iwork(k9),iwork(k10),iwork(k11),
     >    iwork(k12),
     >    iwork(k13),work(k14),iwork(k15),work(k16),work(k17),ialg)
      else
        iv1=nint(v1(1))
cDLC iwork(maddr_r2i_cvb(iaddr_ci(iv1))) --> work(iaddr_ci(iv1))
        call permvb2_cvb(work(iaddr_ci(iv1)),
     >    iperm,vb,iwork(ll(11)),iwork(ll(12)),
     >    iwork(k1),iwork(k2),iwork(k5),iwork(k6),
     >    iwork(k7),iwork(k8),iwork(k9),iwork(k10),iwork(k11),
     >    iwork(k12),
     >    iwork(k13),work(k14),iwork(k15),work(k16),work(k17),ialg)
      endif
      call mfreei_cvb(k1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Torsion_List(
     &                 nq,
     &                 nAtoms,iIter,nIter,Cx,jStab,
     &                 nStab,nDim,Smmtrc,Process,Value,
     &                 nB,iANr,qLbl,iRef,
     &                 fconst,rMult,LuIC,Name,Indq,iPrv,Proc_dB,
     &                 iTabBonds,nBonds,iTabAI,mAtoms,iTabAtoms,nMax,
     &                 mB_Tot,mdB_Tot,
     &                 BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,nqB)
      use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Parameter (mB = 4*3)
      Real*8 Cx(3,nAtoms,nIter), A(3,4), Grad(mB), Hess(mB**2),
     &       fconst(nB), Value(nB,nIter),
     &       Ref(3,4), Prv(3,4), rMult(nB), Grad_ref(9),
     &       BM(nB_Tot), dBM(ndB_Tot)
      Integer   nStab(nAtoms), iANr(nAtoms),
     &          iDCRR(0:7), jStab(0:7,nAtoms),
     &          iStabM(0:7), Ind(4), iDCR(4), iDCRT(0:7),
     &          iDCRS(0:7), iStabN(0:7), iStabO(0:7), iChOp(0:7),
     &          Indq(3,nB), iDCRX(0:7), iDCRY(0:7), nqB(nB),
     &          iTabBonds(3,nBonds), iTabAI(2,mAtoms),
     &          iTabAtoms(2,0:nMax,mAtoms), iBM(nB_Tot),idBM(2,ndB_Tot)
      Logical Smmtrc(3,nAtoms), Process, PSPrint,
     &        MinBas, Help, Proc_dB, R_Stab_A, Torsion_Check
      Character*14 Label, qLbl(nB)
      Character*3 ChOp(0:7)
#include "Molcas.fh"
      Character*(LENIN) Name(nAtoms)
      Character*(LENIN4) Lbls(4)
#include "bondtypes.fh"
#define _FMIN_
#include "ddvdt.fh"
#include "ddvdt_trsn.fh"
      Data ChOp/'E  ','X  ','Y  ','XY ','Z  ','XZ ','YZ ','XYZ'/
      Data iChOp/1,1,1,2,1,2,2,3/
      Data f_Const_Min2/1.0D-1/
#include "constants.fh"
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
      If (nBonds.lt.3) Return
      iRout=152
      iPrint=nPrint(iRout)
      nqT=0
      PSPrint=.False.
      Call FZero(Hess,144)
#ifdef _DEBUGPRINT_
      iPrint=99
      If (iPrint.ge.99) PSPrint=.True.
#endif
*
*---- Loop over dihedrals
*
      bohr=CONST_BOHR_RADIUS_IN_SI_ * 1.0D+10
      MinBas=.False.
      If (MinBas) Then
         Fact=1.3d0
      Else
         Fact=One
      End If
      nCent=4
*
*     Order will play a role here. That is, the torsion
*     A-R(B)-T(C)-TS(D) is NOT identical to
*     A-R(B)-TS(D)-T(C). Hence we put no restriction on the
*     pairs AB and CD. However, for the pair of pairs we have
*     that order is irrelevant, i.e. ABCD is identical to
*     DCBA. To guarantee this we limit the pairs to the unique
*     combinations.
*
      Do iBond = 1, nBonds
*
*        The center bond may be a "magic" bond
         iBondType=iTabBonds(3,iBond)
#ifdef _DEBUGPRINT_
         Write (6,*)
         Write (6,*) 'iBond,iBondType=',iBond,iBondType
#endif
*
*        Center bond should not be a van der Waals bond,
*        anything else goes!
*
         If (iBondType.eq.vdW_Bond) Go To 201
*
*        Extract index to the center atom in an "Magic" bond if this
*        is a magic bond.
*
         If (iBondType.gt.Magic_Bond) Then
            iMagic=iBondType-3
         Else
            iMagic=0
         End If
*
         Do iCase = 1, 2
*
            If (iCase.eq.1) Then
               jAtom_ = iTabBonds(1,iBond)
               kAtom_ = iTabBonds(2,iBond)
            Else
               jAtom_ = iTabBonds(2,iBond)
               kAtom_ = iTabBonds(1,iBond)
            End If
*
            jAtom = iTabAI(1,jAtom_)
            kAtom = iTabAI(1,kAtom_)
            jr = iTabRow(iANr(jAtom))
            kr = iTabRow(iANr(kAtom))
            Ind(2) = jAtom
            Ind(3) = kAtom
            iDCR(2) = iTabAI(2,jAtom_)
            If (R_Stab_A(iDCR(2),jStab(0,jAtom),nStab(jAtom)))
     &          iDCR(2)=iOper(0)
            iDCR(3) = iTabAI(2,kAtom_)
            If (R_Stab_A(iDCR(3),jStab(0,kAtom),nStab(kAtom)))
     &          iDCR(3)=iOper(0)
#ifdef _DEBUGPRINT_
            Write (6,*)
            Write (6,*) 'R,T=',Name(jAtom),ChOp(iDCR(2)),
     &                         Name(kAtom),ChOp(iDCR(3))
#endif
*
            nNeighbor_j = iTabAtoms(1,0,jAtom_)
            nCoBond_j=nCoBond(jAtom_,mAtoms,nMax,iTabBonds,nBonds,
     &                        nBonds,iTabAtoms)
            nFgBond_j=nFgBond(jAtom_,mAtoms,nMax,iTabBonds,nBonds,
     &                        nBonds,iTabAtoms)
            nNeighbor_k = iTabAtoms(1,0,kAtom_)
            nCoBond_k=nCoBond(kAtom_,mAtoms,nMax,iTabBonds,nBonds,
     &                        nBonds,iTabAtoms)
            nFgBond_k=nFgBond(kAtom_,mAtoms,nMax,iTabBonds,nBonds,
     &                        nBonds,iTabAtoms)
            If ( nCoBond_j.lt.2.and.nFgBond_j.eq.0) Go To 250
            If ( nCoBond_k.lt.2.and.nFgBond_k.eq.0) Go To 250
*
#ifdef _DEBUGPRINT_
            Write (6,*) 'nNeighbor_j,nNeighbor_k=',
     &                   nNeighbor_j,nNeighbor_k
#endif
*
         Do iNeighbor = 1, nNeighbor_j
            iAtom_ = iTabAtoms(1,iNeighbor,jAtom_)
            nCoBond_i=nCoBond(iAtom_,mAtoms,nMax,iTabBonds,nBonds,
     &                        nBonds,iTabAtoms)
            nFgBond_i=nFgBond(iAtom_,mAtoms,nMax,iTabBonds,nBonds,
     &                        nBonds,iTabAtoms)
            jBond  = iTabAtoms(2,iNeighbor,jAtom_)
            If (jBond.eq.iBond) Go To 301
            jBondType=iTabBonds(3,jBond)
#ifdef _DEBUGPRINT_
            Write (6,*) 'jBond,jBondType=',jBond,jBondType
#endif
            If (jBondType.eq.vdW_Bond   .or.
     &          jBondType.eq.Magic_Bond) Go To 301
*           If (nCoBond_j.gt.2.and.
*    &          (nCoBond_i.ge.4.and.nFgBond_i.eq.0)) Go To 301
*           If (nCoBond_i.ge.8 .and.
*    &          nCoBond_j.ge.8 .and.
*    &          nCoBond_k.ge.8      ) Go To 301
            iAtom = iTabAI(1,iAtom_)
            If (iBondType.gt.Magic_Bond .and. iAtom.eq.iMagic) Go To 301
            ir = iTabRow(iANr(iAtom))
            Ind(1) = iAtom
            iDCR(1)= iTabAI(2,iAtom_)
            If (R_Stab_A(iDCR(1),jStab(0,iAtom),nStab(iAtom)))
     &          iDCR(1)=iOper(0)
*
*---------- Torsion should be A-..., eliminate P(A)-...
*
            If (iDCR(1).ne.iOper(0)) Go To 301
*
*----------- Eliminate A-R(B)-T(C)-TS(C) over A-B-RT(C)-RTS(D)
*            Proceed if A-R-T(C)-TS(C)
*
            If (R_Stab_A(iDCR(2),jStab(0,iAtom),nStab(iAtom)) .and.
     &          iDCR(2).ne.iOper(0)) Go To 301
*
*----------- Eliminate A-R(B)-T(C)-TS(D) over A-R(B)-C-S(D)
*            Proceed if A-R(B)-C-S(D)
*
            If (R_Stab_A(iDCR(3),jStab(0,iAtom),nStab(iAtom)) .and.
     &          R_Stab_A(iDCR(3),jStab(0,jAtom),nStab(jAtom)) .and.
     &          iDCR(3).ne.iOper(0)) Go To 301
#ifdef _DEBUGPRINT_
            Write (6,*)
            Write (6,*) 'E=',Name(iAtom),ChOp(iDCR(1))
#endif
            call dcopy_(3,Cx(1,iAtom,iIter),1,A,  1)
            call dcopy_(3,Cx(1,iAtom,iRef), 1,Ref,1)
            call dcopy_(3,Cx(1,iAtom,iPrv), 1,Prv,1)
            Help = ir.gt.3.or.jr.gt.3
*
*---------- Form double coset representatives for (iAtom,jAtom)
*
            Call DCR(Lambda,
     &               jStab(0,iAtom),nStab(iAtom),
     &               jStab(0,jAtom),nStab(jAtom),
     &               iDCRR,nDCRR)
            kDCRR=iDCR(2)
#ifdef _DEBUGPRINT_
            Write (6,'(10A)') 'R={',(ChOp(iDCRR(i)),
     &                            i=0,nDCRR-1),'}  '
            Write (6,'(2A)') 'R=',ChOp(kDCRR)
#endif
            Call OA(kDCRR,Cx(1:3,jAtom,iIter),  A(1:3,2))
            Call OA(kDCRR,Cx(1:3,jAtom,iRef ),Ref(1:3,2))
            Call OA(kDCRR,Cx(1:3,jAtom,iPrv ),Prv(1:3,2))
#ifdef _DEBUGPRINT_
            Write (6,'(10A)') 'U={',(ChOp(jStab(i,iAtom)),
     &                         i=0,nStab(iAtom)-1),'}  '
            Write (6,'(10A)') 'V={',(ChOp(jStab(i,jAtom)),
     &                         i=0,nStab(jAtom)-1),'}  '
#endif
*
*---------- Form stabilizer for (iAtom,jAtom)
*
            Call Inter(jStab(0,iAtom),nStab(iAtom),
     &                 jStab(0,jAtom),nStab(jAtom),
     &                 iStabM,nStabM)
#ifdef _DEBUGPRINT_
            If (PSPrint) Then
               Write (6,'(10A)') 'M={',
     &               (ChOp(iStabM(i)),i=0,nStabM-1),'}  '
            End If
#endif
            If (Help) Then
               rij2=(Ref(1,1)-Ref(1,2))**2
     &             +(Ref(2,1)-Ref(2,2))**2
     &             +(Ref(3,1)-Ref(3,2))**2
               Rab=Sqrt(rij2)
               RabCov=(CovRadT(iANr(iAtom))
     &               +CovRadT(iANr(jAtom)))/bohr
               r0=Zero
               Alpha=Zero
               f_Const_ij=Zero
               f_Const_ij_Ref=f_Const_ij
            Else
               r0=rAV(ir,jr)
               Alpha=aAv(ir,jr)
               rij2_Ref=(Ref(1,1)-Ref(1,2))**2
     &                 +(Ref(2,1)-Ref(2,2))**2
     &                 +(Ref(3,1)-Ref(3,2))**2
               f_Const_ij_Ref=rkt*Exp(Alpha*(r0**2-rij2_Ref))
               rij2=(A(1,1)-A(1,2))**2
     &             +(A(2,1)-A(2,2))**2
     &             +(A(3,1)-A(3,2))**2
               f_Const_ij=rkt*Exp(Alpha*(r0**2-rij2))
            End If
*
            Do lNeighbor = 1, nNeighbor_k
               lAtom_ = iTabAtoms(1,lNeighbor,kAtom_)
               nCoBond_l=nCoBond(lAtom_,mAtoms,nMax,iTabBonds,nBonds,
     &                           nBonds,iTabAtoms)
               nFgBond_l=nFgBond(lAtom_,mAtoms,nMax,iTabBonds,nBonds,
     &                           nBonds,iTabAtoms)
               lAtom = iTabAI(1,lAtom_)
               Ind(4) = lAtom
               iDCR(4) = iTabAI(2,lAtom_)
               If (R_Stab_A(iDCR(4),jStab(0,lAtom),nStab(lAtom)))
     &             iDCR(4)=iOper(0)
               kBond  = iTabAtoms(2,lNeighbor,kAtom_)
               If (kBond.eq.iBond) Go To 401
               If (lAtom_.eq.iAtom_) Go To 401
               kBondType=iTabBonds(3,kBond)
#ifdef _DEBUGPRINT_
         Write (6,*) 'kBond,kBondType=',kBond,kBondType
#endif
               If (kBondType.eq.vdW_Bond    .or.
     &             kBondType.eq.Magic_Bond) Go To 401
*              If (nCoBond_k.gt.2.and.
*    &             (nCoBond_l.ge.4.and.nFgBond_l.eq.0)) Go To 401
*              If (nCoBond_j.ge.8 .and.
*    &             nCoBond_k.ge.8 .and.
*    &             nCoBond_l.ge.8      ) Go To 401
*
               If (iBondType.gt.Magic_Bond .and. lAtom.eq.iMagic)
     &            Go To 401
               lr = iTabRow(iANr(lAtom))
               kDCRT= iDCR(3)
               kDCRTS=iDCR(4)
               kDCRS=iEor(kDCRTS,kDCRT)
#ifdef _DEBUGPRINT_
               Write (6,*) 'i,j,k,l=',
     &               Name(iAtom),ChOp(iDCR(1)),
     &               Name(jAtom),ChOp(iDCR(2)),
     &               Name(kAtom),ChOp(iDCR(3)),
     &               Name(lAtom),ChOp(iDCR(4))
#endif
*
*------------- Eliminate A-R(B)-T(C)-TS(D) over A-TSR(B)-S(C)-D
*
               If (R_Stab_A(iDCR(4),jStab(0,iAtom),nStab(iAtom)) .and.
     &             R_Stab_A(iDCR(4),jStab(0,jAtom),nStab(jAtom)) .and.
     &             R_Stab_A(iDCR(4),jStab(0,kAtom),nStab(kAtom)) .and.
     &             iDCR(4).ne.iOper(0)) Go To 401
*
               nE=1
               If (iDCR(2).eq.iOper(0)) nE=nE+1
               If (iDCR(3).eq.iOper(0)) nE=nE+1
               If (iDCR(4).eq.iOper(0)) nE=nE+1
               mE=1
               If (R_Stab_A(iDCR(4),
     &             jStab(0,iAtom),nStab(iAtom))) mE=mE+1
               If (R_Stab_A(iEOr(iDCR(4),iDCR(3)),
     &             jStab(0,kAtom),nStab(kAtom))) mE=mE+1
               If (R_Stab_A(iEOr(iDCR(4),iDCR(2)),
     &             jStab(0,jAtom),nStab(jAtom))) mE=mE+1
               If (nE.lt.mE) Go To 401
               If (nE.eq.mE .and. iAtom.gt.lAtom) Go To 401

#ifdef _DEBUGPRINT_
               Write (6,*)
               Write (6,*) 'TS=',Name(lAtom),ChOp(iDCR(4))
#endif
*
               Help = ir.gt.3.or.jr.gt.3.or.kr.gt.3.or.lr.gt.3
*
               Write (Label,'(A,I2,A,I2,A,I2,A,I2,A)')
     &                'D(',iAtom,',',jAtom,',',kAtom,',',lAtom,')'
#ifdef _DEBUGPRINT_
               Write (6,'(A,I2,A,I2,A,I2,A,I2,A)')
     &                'D(',iAtom,',',jAtom,',',kAtom,',',lAtom,')'
#endif
*
*------------- Form double coset representatives for (kAtom,lAtom)
*
               Call DCR(Lambda,
     &                  jStab(0,kAtom),nStab(kAtom),
     &                  jStab(0,lAtom),nStab(lAtom),
     &                  iDCRS,nDCRS)
#ifdef _DEBUGPRINT_
               Write (6,'(10A)') 'S={',(ChOp(iDCRS(i)),
     &                            i=0,nDCRS-1),'}  '
               Write (6,'(10A)') 'W={',(ChOp(jStab(i,kAtom)),
     &                            i=0,nStab(kAtom)-1),'}  '
               Write (6,'(10A)') 'X={',(ChOp(jStab(i,lAtom)),
     &                            i=0,nStab(lAtom)-1),'}  '
               Write (6,'(2A)') 'S=',ChOp(kDCRS)
#endif
*
               Ref(1:3,3) = Cx(1:3,kAtom,iRef)
               Call OA(kDCRS,Cx(1:3,lAtom,iRef),Ref(1:3,4))
               Prv(1:3,3) = Cx(1:3,kAtom,iPrv)
               Call OA(kDCRS,Cx(1:3,lAtom,iPrv),Prv(1:3,4))
*
               If (Help) Then
                  rkl2=(Ref(1,3)-Ref(1,4))**2
     &                +(Ref(2,3)-Ref(2,4))**2
     &                +(Ref(3,3)-Ref(3,4))**2
                  Rcd=Sqrt(rkl2)
                  RcdCov=(CovRadT(iANr(kAtom))
     &                  +CovRadT(iANr(lAtom)))/bohr
               Else
                  r0=rAV(kr,lr)
                  rkl2=(Ref(1,3)-Ref(1,4))**2
     &                +(Ref(2,3)-Ref(2,4))**2
     &                +(Ref(3,3)-Ref(3,4))**2
               End If
*
*------------- Form stabilizer for (kAtom,lAtom)
*
               Call Inter(jStab(0,kAtom),nStab(kAtom),
     &                    jStab(0,lAtom),nStab(lAtom),
     &                    iStabN,nStabN)
*
#ifdef _DEBUGPRINT_
               If (PSPrint) Then
                  Write (6,'(10A)') 'N={',
     &                  (ChOp(iStabN(i)),i=0,nStabN-1),'}  '
               End If
#endif
*
*------------- Form double coset representatives for
*              ((iAtom,jAtom),(kAtom,lAtom))
*
               Call DCR(Lambda,
     &                  iSTabM,nStabM,
     &                  iStabN,nStabN,
     &                  iDCRT,nDCRT)
*
*------------- Take care of some special cases which normally
*              are not included. If A=B we will normally exclude
*              the pairs R(A)-A and TS(C)-T(C).
*
               Call iCopy(nDCRT,iDCRT,1,iDCRX,1)
               Call iCopy(nDCRT,iDCRT,1,iDCRY,1)
               nDCRX=nDCRT
               nDCRY=nDCRT
               If (iAtom.eq.jAtom) Then
*                 Write (6,*) ' Special fix'
                  Call Union(iDCRX,nDCRX,iDCRY,nDCRY,
     &                       kDCRR,iDCRT,nDCRT)
               Else If (kAtom.eq.lAtom) Then
*                 Write (6,*) ' Special fix'
                  Call Union(iDCRX,nDCRX,iDCRY,nDCRY,
     &                       kDCRS,iDCRT,nDCRT)
               End If
*
#ifdef _DEBUGPRINT_
               Write (6,'(10A)') 'T={',
     &               (ChOp(iDCRT(i)),i=0,nDCRT-1),'}  '
#endif
               If (PSPrint) Write (6,'(2A)') 'kDCRT=',ChOp(kDCRT)
*
               kDCRTS=iEor(kDCRT,kDCRS)
*
               If (PSPrint) Write (6,'(2A)') 'T=',ChOp(kDCRT)
               Call OA(kDCRT ,Cx(1:3,kAtom,iIter),  A(1:3,3))
               Call OA(kDCRT ,Cx(1:3,kAtom,iRef ),Ref(1:3,3))
               Call OA(kDCRT ,Cx(1:3,kAtom,iPrv ),Prv(1:3,3))
               Call OA(kDCRTS,Cx(1:3,lAtom,iIter),  A(1:3,4))
               Call OA(kDCRTS,Cx(1:3,lAtom,iRef ),Ref(1:3,4))
               Call OA(kDCRTS,Cx(1:3,lAtom,iPrv ),Prv(1:3,4))
*
*------------- Form the stabilizer for the torsion
*
               If (iAtom.eq.lAtom .and.
     &             jAtom.eq.kAtom.and.kDCRR.eq.kDCRS) Then
                  Call Union(iStabM,nStabM,
     &                       iStabN,nStabN,
     &                       kDCRTS,iStabO,nStabO)
               Else
                  Call Inter(iStabM,nStabM,
     &                       iStabN,nStabN,
     &                       iStabO,nStabO)
               End If
*
#ifdef _DEBUGPRINT_
               If (PSPrint) Then
                  Write (6,'(10A)') 'M={',
     &                  (ChOp(iStabM(i)),i=0,nStabM-1),'}  '
                  Write (6,'(10A)') 'N={',
     &                  (ChOp(iStabN(i)),i=0,nStabN-1),'}  '
                  Write (6,'(10A)') 'O={',
     &                  (ChOp(iStabO(i)),i=0,nStabO-1),'}  '
               End If
#endif
*
*------------- Compute the degeneracy of the torsion
*
               iDeg=nIrrep/nStabO
               Deg=Sqrt(DBLE(iDeg))
*
*------------- Test if coordinate should be included
*
               If (Help) Then
                  rjk2=(Ref(1,2)-Ref(1,3))**2
     &                +(Ref(2,2)-Ref(2,3))**2
     &                +(Ref(3,2)-Ref(3,3))**2
                  Rbc=Sqrt(rjk2)
                  RbcCov=(CovRadT(iANr(jAtom))
     &                  +CovRadT(iANr(kAtom)))/bohr
                  Diff=RbcCov-Rbc
                  If (Diff.lt.Zero) Diff = Zero
                  f_Const=A_Trsn(1)+A_Trsn(2)*Diff
                  f_Const=f_Const*Fact
                  r0=Zero
                  Alpha=Zero
                  f_Const_Ref=f_Const
               Else
                  r0=rAV(jr,kr)
                  Alpha=aAv(jr,kr)
                  rjk2_Ref=(Ref(1,2)-Ref(1,3))**2
     &                    +(Ref(2,2)-Ref(2,3))**2
     &                    +(Ref(3,2)-Ref(3,3))**2
                  f_Const_ijk_Ref=f_Const_ij_Ref
     &                       *Exp(Alpha*(r0**2-rjk2_Ref))
                  rjk2=(A(1,2)-A(1,3))**2
     &                +(A(2,2)-A(2,3))**2
     &                +(A(3,2)-A(3,3))**2
                  f_Const_ijk=f_Const_ij
     &                       *Exp(Alpha*(r0**2-rjk2))
*
                  r0=rAV(kr,lr)
                  Alpha=aAv(kr,lr)
                  rkl2_Ref=(Ref(1,3)-Ref(1,4))**2
     &                    +(Ref(2,3)-Ref(2,4))**2
     &                    +(Ref(3,3)-Ref(3,4))**2
                  f_Const_Ref=f_Const_ijk_Ref
     &                   *Exp(Alpha*(r0**2-rkl2_Ref))
                  rkl2=(A(1,3)-A(1,4))**2
     &                +(A(2,3)-A(2,4))**2
     &                +(A(3,3)-A(3,4))**2
                  f_Const=f_Const_ijk
     &                   *Exp(Alpha*(r0**2-rkl2))
               End If
               If (Torsion_Check(iAtom,jAtom,kAtom,lAtom,
     &                           Ref,iTabAtoms,
     &                           nMax,mAtoms)) Then
                  f_Const_Ref=Max(f_Const_Ref,10.D0*F_Const_Min)
               End If

               If (f_Const_Ref.lt.f_Const_Min .and.
     &             iBondType.ne.Fragments_Bond .and.
     &             iBondType.le.Fragments_Bond .and.
     &             jBondType.ne.Fragments_Bond .and.
     &             kBondType.ne.Fragments_Bond
     &            )  Go To 401
*
*
*------------- Check that valence angles are above threshold
*
               mCent=3
               delta = (15.0D0/180.D0)*Pi
               If (nAtoms.eq.4) delta = -Ten
               Call Bend(Ref(1,1),mCent,Fi2,Grad_ref,.False.,
     &                   .False.,'        ',Hess,.False.)
               If (Fi2.gt.Pi-delta) Go To 401
               If (Fi2.lt.delta) Go To 401
               Call Bend(Ref(1,2),mCent,Fi3,Grad_ref,.False.,
     &                   .False.,'        ',Hess,.False.)
               If (Fi3.gt.Pi-delta) Go To 401
               If (Fi3.lt.delta) Go To 401
*              Write (6,*) ' T Force Constant:',f_Const
*
               nq = nq + 1
               If (.Not.Process) mB_Tot = mB_Tot + mB
               If (.Not.Proc_dB) mdB_Tot = mdB_Tot + mB**2
*              Write (6,*) 'nq=',nq
*
               nqT = nqT + 1
               iF1=1
               Call NxtWrd(Name(iAtom),iF1,iE1)
               Lbls(1)=Name(iAtom)(iF1:iE1)
               iF2=1
               Call NxtWrd(Name(jAtom),iF2,iE2)
               Lbls(2)=Name(jAtom)(iF2:iE2)
               If (kDCRR.ne.0) Then
                  Lbls(2)(iE2+1:iE2+1)='('
                  Lbls(2)(iE2+2:iE2+1+iChOp(kDCRR))=
     &                  ChOp(kDCRR)(1:iChOp(kDCRR))
                  Lbls(2)(iE2+2+iChOp(kDCRR):
     &                    iE2+2+iChOp(kDCRR))=')'
                  Call NxtWrd(Lbls(2),iF2,iE2)
               End If
               iF3=1
               Call NxtWrd(Name(kAtom),iF3,iE3)
               Lbls(3)=Name(kAtom)(iF3:iE3)
               If (kDCRT.ne.0) Then
                  Lbls(3)(iE3+1:iE3+1)='('
                  Lbls(3)(iE3+2:iE3+1+iChOp(kDCRT))=
     &                  ChOp(kDCRT)(1:iChOp(kDCRT))
                  Lbls(3)(iE3+2+iChOp(kDCRT):
     &                    iE3+2+iChOp(kDCRT))=')'
                  Call NxtWrd(Lbls(3),iF3,iE3)
               End If
               iF4=1
               Call NxtWrd(Name(lAtom),iF4,iE4)
               Lbls(4)=Name(lAtom)(iF4:iE4)
               If (kDCRTS.ne.0) Then
                  Lbls(4)(iE4+1:iE4+1)='('
                  Lbls(4)(iE4+2:iE4+1+iChOp(kDCRTS))=
     &                  ChOp(kDCRTS)(1:iChOp(kDCRTS))
                  Lbls(4)(iE4+2+iChOp(kDCRTS):
     &                    iE4+2+iChOp(kDCRTS))=')'
                  Call NxtWrd(Lbls(4),iF4,iE4)
               End If
               Write (LuIC,'(A,I3.3,8A)')
     &                't',nqT,' = Dihedral ',
     &                    Lbls(1)(iF1:iE1),
     &                ' ',Lbls(2)(iF2:iE2),
     &                ' ',Lbls(3)(iF3:iE3),
     &                ' ',Lbls(4)(iF4:iE4)
#ifdef _DEBUGPRINT_
               Write (6,'(A,I3.3,8A)')
     &                't',nqT,' = Dihedral ',
     &                    Lbls(1)(iF1:iE1),
     &                ' ',Lbls(2)(iF2:iE2),
     &                ' ',Lbls(3)(iF3:iE3),
     &                ' ',Lbls(4)(iF4:iE4)
               Write (6,*) 'iDeg=',iDeg
#endif
               Label=' '
               Write (Label,'(A,I3.3)') 't',nqT
*
               Call Trsn(A,nCent,Val,Grad,.False.,.False.,
     &                   '        ',Hess,Proc_dB)
               If (iIter.eq.iPrv) Then
                  Val_Prv=Val
               Else
                  Val_Prv=Value(nq,iPrv)
               End If
*
*------------- correct for 2Pi flip relative to reference.
*
               Range1=Two*Pi*0.8D0
               Range2=Pi*0.80D0
               Range3=Pi*1.20D0
               If (Abs(Val_Prv-Val).gt.Range1) Then
                  If (Sign(One,Val_Prv).eq.One) Then
                     Val=Val+Two*Pi
                  Else
                     Val=Val-Two*Pi
                  End If
               Else If (Abs(Val_Prv-Val).gt.Range2 .and.
     &                  Abs(Val_Prv-Val).lt.Range3) Then
                  If (Val_Prv-Val.gt.Zero) Then
                     Val=Val+Pi
                  Else
                     Val=Val-Pi
                  End If
               End If
#ifdef _DEBUGPRINT_
               If (PSPrint) Then
                  Call RecPrt('Trsns:  B',' ',Grad,3,4)
                  Call RecPrt('Trsns: dB',' ',Hess,12,12)
               End If
#endif
*
               If (Process) Then
*
                  Indq(1,nq)=5
                  ij = (jAtom-1)*nAtoms + iAtom
                  kl = (lAtom-1)*nAtoms + kAtom
                  Indq(2,nq) = (kl-1)*nAtoms**2 + ij
                  ijDCR = kDCRT*8 + kDCRR+1
                  Indq(3,nq) = kDCRS*8**2 + ijDCR
*
                  If (iMagic.ne.0) Then
                     f_Const=Max(f_Const,f_Const_Min2)
                  Else If (.Not. Help .and.
     &                    (iBondType.eq.Fragments_Bond .or.
     &                     jBondType.eq.Fragments_Bond .or.
     &                     kBondType.eq.Fragments_Bond )) Then
                     f_Const=Max(f_Const,f_Const_Min*1.D3)
                  Else
                     f_Const=Max(f_Const,f_Const_Min)
                  End If
                  fconst(nq)=Sqrt(f_Const)
                  rMult(nq)=Deg
*                 Scale down fconst if angles are close to linear
                  CosFi=Max(Abs(Cos(Fi2)),Abs(Cos(Fi3)))
                  CosThr=0.97D0
                  If (CosFi.gt.CosThr) Then
                    CosFi=(CosFi-CosThr)/(One-CosThr)
                    fconst(nq)=(One-CosFi**2)*fconst(nq)
                  End If
*
                  Value(nq,iIter)=Val
                  qLbl(nq) = Label
*
*---------------- Project the gradient vector
*
                  Call ProjSym(nAtoms,nCent,Ind,nStab,
     &                         jStab,A,iDCR,Grad,
     &                         Smmtrc,nDim,PSPrint,Hess,
     &                         mB_Tot,mdB_Tot,
     &                         BM,dBM,iBM,idBM,nB_Tot,ndB_Tot,
     &                         Proc_dB,nqB,nB,nq,rMult(nq))
*
               End If
*
  401          Continue
            End Do               ! iNeighbor_k
  301       Continue
         End Do                  ! iNeighbor_j
 250     Continue
         End Do                  ! iCase
  201    Continue
      End Do                     ! iBonds
#ifdef _DEBUGPRINT_
      Write (6,*) 'nqT=',nqT
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      Function Torsion_Check(iAtom,jAtom,kAtom,lAtom,Ref,iTabAtoms,
     &                       nMax,mAtoms)
      Implicit Real*8 (a-h,o-z)
      Logical Torsion_Check
      Real*8 Ref(3,4), Coor(3,4)
      Integer iTabAtoms(2,0:nMax,mAtoms), iCase(4,12), iSet(4), jSet(4)
      Data iCase/1,2,3,4, 1,2,4,3, 2,1,3,4, 2,1,4,3,
     &           1,3,2,4, 1,3,4,2, 3,1,2,4, 3,1,4,2,
     &           1,4,2,3, 1,4,3,2, 4,1,2,3, 4,1,3,2/
*
      Torsion_Check=.False.
      iSet(1)=iAtom
      iSet(2)=jAtom
      iSet(3)=kAtom
      iSet(4)=lAtom
C     Write (*,*) 'Here we go!'
C     Write (*,*) 'iSet=',iSet
*
*     Check all twelve possible torsions to see which one is the one
*     which should at least be included.
*
      FC=0.0D0
      Test=0.0D0
      Do ii = 1, 12
         jSet(1) = iSet(iCase(1,ii))
         jSet(2) = iSet(iCase(2,ii))
         jSet(3) = iSet(iCase(3,ii))
         jSet(4) = iSet(iCase(4,ii))
C        Write (*,*) 'ii,jSet=',ii,jSet
         call dcopy_(3,Ref(1,iCase(1,ii)),1,Coor(1,1),1)
         call dcopy_(3,Ref(1,iCase(2,ii)),1,Coor(1,2),1)
         call dcopy_(3,Ref(1,iCase(3,ii)),1,Coor(1,3),1)
         call dcopy_(3,Ref(1,iCase(4,ii)),1,Coor(1,4),1)
C        Call RecPrt('Coor',' ',Coor,3,4)
         Test=FC_Torsion(jSet,Coor,iTabAtoms,nMax,mAtoms)
         If (Test.gt.FC) Then
            If (ii.gt.1) Return
            FC=Test
         End If
      End Do
      Torsion_Check=.True.
C     Write (*,*) 'Torsion_Check=',Torsion_Check
*
      Return
      End
      Function FC_Torsion(jSet,Coor,iTabAtoms,nMax,mAtoms)
      Implicit Real*8 (a-h,o-z)
      Real*8 FC_Torsion
      Integer iTabAtoms(2,0:nMax,mAtoms), iCase(2,3), jSet(4)
      Real*8  Coor(3,4), Gij(3)
#include "bondtypes.fh"
      Data iCase/1,2, 2,3, 3,4/
*
      FC_Torsion=0.0D0
      Do ii = 1, 3
         iHit=0
         iAtom=jSet(iCase(1,ii))
         jAtom=jSet(iCase(2,ii))
*
*        Loop over the neighbor atoms of iAtom to see if jAtom is a neighbor. If
*        it is check that the bond is classified as a covalent bond.
*
         Do i = 1, iTabAtoms(1,0,iAtom)
            If (jAtom.eq.iTabAtoms(1,i,iAtom) .and.
     &          iTabAtoms(2,i,iAtom).eq.Covalent_Bond) Then
                iHit=1
                iAtom_=iCase(1,ii)
                jAtom_=iCase(2,ii)
                Gij(ii)=1.0D0/Sqrt( (Coor(1,iAtom_)-Coor(1,jAtom_))**2
     &                             +(Coor(2,iAtom_)-Coor(2,jAtom_))**2
     &                             +(Coor(3,iAtom_)-Coor(3,jAtom_))**2 )
            End If
         End Do
         If (iHit.eq.0) Return
      End Do
      FC_Torsion=Gij(1)*Gij(2)*Gij(3)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_grc42y (mapda,mapdb,mapdc,mapia,mapib,mapic,
     & mvec,ssa,ssb,possc0,ix)
c
#include "t31.fh"
c
       integer mapda(0:512,1:6)
       integer mapdb(0:512,1:6)
       integer mapdc(0:512,1:6)
c
       integer mapia(1:8,1:8,1:8)
       integer mapib(1:8,1:8,1:8)
       integer mapic(1:8,1:8,1:8)
c
       integer mvec(1:4096,1:7)
       integer possc0
       integer ssa,ssb
c
c     help variables
c
       integer nhelp1,nhelp2,nhelp4
       integer nhelp41,nhelp42,nhelp21,nhelp22
       integer ntest1,ntest2
       integer sa1,sa2,sa3,sa4,sb1,sb2,sa34,sa134
       integer ia,ib,iy,ix
       integer possct
c
c     sctructure A(pq,rs)*B(rs)=YC(pq)
c
c1.0  prepare mapdc,mapic
c
       if ((mapda(0,6).eq.1).or.(mapda(0,6).eq.4)) then
       ntest1=1
       else
       ntest1=0
       end if
c
       call cct3_grc0 (2,ntest1,mapda(0,1),mapda(0,2),0,0,mmul(ssa,ssb),
     & possc0,possct,mapdc,mapic)
c
c1.1  define limitations - p>q,r,s must be tested - ntest1
c     p,q,r>s must be tested - ntest2
c
       if ((mapda(0,6).eq.1).or.(mapda(0,6).eq.4)) then
       ntest1=1
       else
       ntest1=0
       end if
c
       if ((mapda(0,6).eq.3).or.(mapda(0,6).eq.4)) then
       ntest2=1
       else
       ntest2=0
       end if
c
c1.2  def symm states and test the limitations
c
       ix=1
       do 100 sb1=1,nsym
       sa3=sb1
c
       sb2=mmul(ssb,sb1)
       sa4=sb2
       sa34=mmul(sa3,sa4)
       if ((ntest2.eq.1).and.(sb1.lt.sb2)) then
c     Meggie out
       goto 100
       end if
c
       do 50 sa1=1,nsym
       sa134=mmul(sa1,sa34)
c
       sa2=mmul(ssa,sa134)
       if ((ntest1.eq.1).and.(sa1.lt.sa2)) then
c     Meggie out
       goto 50
       end if
c
c1.3  def mvec,mapdc and mapdi
c
       ia=mapia(sa1,sa2,sa3)
       ib=mapib(sb1,1,1)
       iy=mapic(sa1,1,1)
c
c     yes/no
       if ((mapda(ia,2).gt.0).and.(mapdb(ib,2).gt.0)) then
       nhelp1=1
       else
       goto 50
       end if
c
c     rowA
       nhelp21=dimm(mapda(0,1),sa1)
       nhelp22=dimm(mapda(0,2),sa2)
       if ((ntest1.eq.1).and.(sa1.eq.sa2)) then
       nhelp2=nhelp21*(nhelp21-1)/2
       else
       nhelp2=nhelp21*nhelp22
       end if
c
c     sum
       nhelp41=dimm(mapda(0,3),sa3)
       nhelp42=dimm(mapda(0,4),sa4)
       if ((ntest2.eq.1).and.(sa3.eq.sa4)) then
       nhelp4=nhelp41*(nhelp41-1)/2
       else
       nhelp4=nhelp41*nhelp42
       end if
c
       mvec(ix,1)=nhelp1
       mvec(ix,2)=mapda(ia,1)
       mvec(ix,3)=mapdb(ib,1)
       mvec(ix,4)=mapdc(iy,1)
       mvec(ix,5)=nhelp2
       mvec(ix,6)=nhelp4
       mvec(ix,7)=0
c
       ix=ix+1
c
 50     continue
 100    continue
       ix=ix-1
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_MOReOrd(CMO,COcc,CVir)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: reorder MOs,
C
C              CMO(alpha,i) -> COcc(i,alpha)
C              CMO(alpha,a) -> CVir(alpha,a)
C
#include "implicit.fh"
      Real*8 COcc(*), CVir(*), CMO(*)
#include "cholesky.fh"
#include "chomp2.fh"
#include "choorb.fh"

      iCount = 0
      Do iSym = 1,nSym

         jCount = iCount + nBas(iSym)*nFro(iSym)

         Do i = 1,nOcc(iSym)
            kOff1 = jCount + nBas(iSym)*(i-1) + 1
            kOff2 = iT1AOT(iSym,iSym) + i
            Call dCopy_(nBas(iSym),CMO(kOff1),1,COcc(kOff2),nOcc(iSym))
         End Do

         kOff1 = jCount + nBas(iSym)*nOcc(iSym) + 1
         kOff2 = iAOVir(iSym,iSym) + 1
         Call dCopy_(nBas(isym)*nVir(iSym),CMO(kOff1),1,CVir(kOff2),1)

         iCount = iCount + nBas(iSym)*nBas(iSym)

      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Gateway_global

use Definitions, only: iwp

implicit none
private

integer(kind=iwp), parameter :: G_Mode = 1, S_Mode = 2, GS_Mode = 3
integer(kind=iwp) :: iPack = 0, IsChi = 0, iWRopt = 0, Run_Mode
logical(kind=iwp) :: asymptotic_Rys = .false., &
                     DirInt = .false., &
                     Expert = .true., &
                     Fake_ERIs = .false., &
                     FMM_shortrange = .false., &
                     force_out_of_core = .false., &
                     force_part_c = .false., &
                     force_part_p = .false., &
                     IfAllOrb = .false., &
                     NoTab = .false., &
                     Onenly = .false., &
                     Primitive_Pass = .true., &
                     PrPrt = .false., &
                     Short = .true., &
                     Test = .false.
character(len=512) :: SW_FileOrb = 'INPORB'

public :: asymptotic_Rys, DirInt, Expert, Fake_ERIs, FMM_shortrange, force_out_of_core, force_part_c, force_part_p, G_Mode, &
          GS_Mode, IfAllOrb, iPack, IsChi, iWRopt, NoTab, Onenly, Primitive_Pass, PrPrt, Run_Mode, S_Mode, Short, SW_FileOrb, Test

end module Gateway_global

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE COVLP(C1IN,C2IN,DIA,PA,SXN,C1,C2,X,OVL)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C RASSCF program version IBM-3090: SX section
C
C Purpose:Calculation of the overlap between two super-CI
C vectors C1IN and C2IN. The result is given in OVL.
C C1,C2, and X are scratch areas.
C
C ********** IBM-3090 Release 89 01 25 **********
CPAM01 Added: replace correct overlap by adding a diagonal
CPAM01 quantity to the overlap of brillouin states.
C
      DIMENSION C1IN(*),C2IN(*),DIA(*),SXN(*),X(*),C1(*),C2(*),PA(*)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='COVLP   ')

      IPRLEV=IPRLOC(4)
      IF(IPRLEV.ge.DEBUG) THEN
       WRITE(LF,*)' Entering ',ROUTINE
      END IF
CPAM02 Note structure of SX-vectors: First NROOT elements are special.
CPAM02 Elements NROOT+1,..,NROOT+NSXS contain the usual SX elements.
CPAM02 NROOT=1 always right now. Part of the code is prepared for using
CPAM02 several roots, so most of the code must use the general case.
      OVL=0.0D0
      DO I=1,NROOT
        OVL=OVL+C1IN(I)*C2IN(I)
      END DO

CPAM01 Adding overlap from small shift of SX overlaps:
      OVL=OVL+(1.0D-6)*DDOT_(NSXS,C1IN(NROOT+1),1,C2IN(NROOT+1),1)
C
C renormalize the C vector (simple element-by-element scaling).
C
      DO I=1,NSXS
       C1(I)=SXN(I)*C1IN(I+NROOT)
       C2(I)=SXN(I)*C2IN(I+NROOT)
      END DO

      ISTIA=0
      ISTBM=0
      IASHI=0
      DO ISYM=1,NSYM
       NIO=NISH(ISYM)
       NAO=NASH(ISYM)
       NIA=NIO+NAO
       NEO=NSSH(ISYM)
       NAE=NAO+NEO
       IF(NIA.EQ.0.OR.NAE.EQ.0) GO TO 97
C
C p is secondary (p = q = a)
C
       IF(NEO.NE.0) THEN
        CALL DGEMM_('N','N',
     &              NIA,NEO,NIA,
     &              1.0d0,DIA(ISTIA+1),NIA,
     &              C1(ISTBM+1+NIA*NAO),NIA,
     &              0.0d0,X,NIA)
        OVLADD=DDOT_(NIA*NEO,X,1,C2(ISTBM+1+NIA*NAO),1)
        OVL=OVL+OVLADD
       ENDIF
  97   CONTINUE
       ISTIA=ISTIA+NIA**2
       ISTBM=ISTBM+NIA*NAE
       IASHI=IASHI+NAO
      END DO

* A very long loop over  symmetry
      ISTIA=0
      ISTBM=0
      IASHI=0
      DO ISYM=1,NSYM
       NIO=NISH(ISYM)
       NAO=NASH(ISYM)
       NIA=NIO+NAO
       NEO=NSSH(ISYM)
       NAE=NAO+NEO
C
C r is inactive (r = s = i); p and q are active
C
       IF(NIO.NE.0.AND.NAO.NE.0) THEN
        IC1=ISTBM
        DO NP=NIO+1,NIA
         IC2=ISTBM
         DO NQ=NIO+1,NIA
          C1C2=0.0D0
          DO NI=1,NIO
           C1C2=C1C2+C1(IC1+NI)*C2(IC2+NI)
          END DO
          FAC=-DIA(ISTIA+NIA*(NP-1)+NQ)
          IF(NP.EQ.NQ) FAC=FAC+2.0D0
          OVLADD=C1C2*FAC
          OVL=OVL+OVLADD
          IC2=IC2+NIA
         END DO
         IC1=IC1+NIA
        END DO
       ENDIF
C
C r,s active and p,q active  (p,r=t,u; q,s=v,x)
C
       DO NT=2,NAO
        NTT=NT+IASHI
        DO NU=1,NT-1
         NUT=NU+IASHI
         NTUT=ITRI(NTT)+NUT

         IASHJ=0
         TERM=0.0D0
         ISTC2=0
         DO JSYM=1,NSYM
          NAOJ=NASH(JSYM)
          NIOJ=NISH(JSYM)
          NIAJ=NIOJ+NAOJ
          NAEJ=NAOJ+NSSH(JSYM)
          IF(NAOJ.GT.1) THEN
           IF(JSYM.EQ.ISYM) THEN
*--------
            DO NV=2,NAOJ
             NVT=NV+IASHJ
             DO NX=1,NV-1
              NXT=NX+IASHJ
              NVXT=ITRI(NVT)+NXT
              NTUVX=ITRI(MAX(NTUT,NVXT))+MIN(NTUT,NVXT)
              PRQS=-4.0D0*PA(NTUVX)
              IF(NU.EQ.NX) PRQS=PRQS+DIA(ISTIA+NIA*(NT+NIO-1)+NV+NIO)
              IF(NT.EQ.NV) PRQS=PRQS+DIA(ISTIA+NIA*(NU+NIO-1)+NX+NIO)
              IF(NT.EQ.NX) PRQS=PRQS-DIA(ISTIA+NIA*(NU+NIO-1)+NV+NIO)
              IF(NU.EQ.NV) PRQS=PRQS-DIA(ISTIA+NIA*(NT+NIO-1)+NX+NIO)
              TERM=TERM+PRQS*C2(ISTC2+NIAJ*(NV-1)+NIOJ+NX)
             END DO
            END DO
*--------
           ELSE
            DO NV=2,NAOJ
             NVT=NV+IASHJ
             DO NX=1,NV-1
              NXT=NX+IASHJ
              NVXT=ITRI(NVT)+NXT
              NTUVX=ITRI(MAX(NTUT,NVXT))+MIN(NTUT,NVXT)
              PRQS=-4.0D0*PA(NTUVX)
              TERM=TERM+PRQS*C2(ISTC2+NIAJ*(NV-1)+NIOJ+NX)
             END DO
            END DO
           ENDIF
*--------
          ENDIF
          ISTC2=ISTC2+NIAJ*NAEJ
          IASHJ=IASHJ+NAOJ
         END DO
         OVLADD=C1(ISTBM+NIA*(NT-1)+NIO+NU)*TERM
         OVL=OVL+OVLADD
        END DO
       END DO

       ISTIA=ISTIA+NIA**2
       ISTBM=ISTBM+NIA*NAE
       IASHI=IASHI+NAO

* End of very long loop over  symmetry
      END DO
C
      IF(IPRLEV.GE.DEBUG) THEN
       Write(LF,'(1X,A,F15.9)') ' OVERLAP IN COVLP:',OVL
      END IF

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Roland Lindh                                     *
************************************************************************
      SubRoutine XFdInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: kernel routine for the computation of nuclear attraction     *
*         integrals.                                                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden, April '95                               *
************************************************************************
      use external_centers
      use Phase_Info
      Implicit Real*8 (A-H,O-Z)
      External TNAI, Fake, XCff2D, XRys2D
#include "itmax.fh"
#include "real.fh"
#include "print.fh"

#include "int_interface.fh"

*-----Local variables
      Real*8 C(3), TC(3), Coori(3,4), CoorAC(3,2),
     &       ZFd((iTabMx+1)*(iTabMx+2)/2), ZRFd((iTabMx+1)*(iTabMx+2)/2)
      Logical EQ, NoLoop, NoSpecial
      Integer iAnga(4), iDCRT(0:7), iStb(0:7), jCoSet(8,8)
      Character ChOper(0:7)*3
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
C     nElem(ixyz) = 2*ixyz+1
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      iRout = 151
      iPrint = nPrint(iRout)
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
*---- Loop over charges and dipole moments in the external field
*
      nData=3
      Do iOrdOp = 0, nOrdOp
*
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = iOrdOp
      iAnga(4) = 0
      call dcopy_(3, A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
      mabMin = nabSz(Max(la,lb)-1)+1
      mabMax = nabSz(la+lb)
      If (EQ(A,RB)) mabMin=nabSz(la+lb-1)+1
      mcdMin = nabSz(iOrdOp-1)+1
      mcdMax = nabSz(iOrdOp)
      lab=(mabMax-mabMin+1)
      kab=nElem(la)*nElem(lb)
      lcd=(mcdMax-mcdMin+1)
      kcd=nElem(iOrdOp)*nElem(0)
      labcd=lab*lcd
*
*     Compute FLOP's and size of work array which Hrr will use.
*
      Call mHrr(la,lb,nFLOP,nMem)
*
*---- Distribute the work array
*
      ip2 = 1
      ip1 = ip2 + nZeta*Max(labcd,lcd*nMem)
      mArr = nArr - Max(labcd,lcd*nMem)
*
*     Find center to accumulate angular momentum on. (HRR)
*
      If (la.ge.lb) Then
       call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
       call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
*
      llOper = lOper(1)
*
*     Loop over centers of the external field.
*
      iDum=0
      Do iFd = 1, nXF
*
         NoLoop=.True.
         Do jElem = 1, nElem(iOrdOp)
            ZFd(jElem)=XF(nData+jElem,iFd)
*        Divide quadrupole diagonal by 2 due to different normalisation
            if((iOrdOp.eq.2).and.
     &           (jElem.eq.1.or.jElem.eq.4.or.jElem.eq.6))
     &           ZFd(jElem)=ZFd(jElem)*0.5D0
            NoLoop = NoLoop .and.  ZFd(jElem).eq.Zero
         End Do
*
         If (NoLoop) Go To 111
*------- Pick up the center coordinates
         C(1:3)=XF(1:3,iFd)

         If (iPrint.ge.99) Call RecPrt('C',' ',C,1,3)
*
*------- Generate stabilizor of C
*
         iChxyz=iChAtm(C)
         Call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)
*
*--------Find the DCR for M and S
*
         Call DCR(LmbdT,iStabM,nStabM,iStb,nStb,iDCRT,nDCRT)
         Fact = DBLE(nStabM) / DBLE(LmbdT)
*
         If (iPrint.ge.99) Then
            Write (6,*) ' m      =',nStabM
            Write (6,'(9A)') '(M)=',(ChOper(iStabM(ii)),
     &            ii = 0, nStabM-1)
            Write (6,*) ' s      =',nStb
            Write (6,'(9A)') '(S)=',(ChOper(iStb(ii)),
     &            ii = 0, nStb-1)
            Write (6,*) ' LambdaT=',LmbdT
            Write (6,*) ' t      =',nDCRT
            Write (6,'(9A)') '(T)=',(ChOper(iDCRT(ii)),
     &            ii = 0, nDCRT-1)
         End If

*
         Do lDCRT = 0, nDCRT-1
            Call OA(iDCRT(lDCRT),C,TC)
*
            jElem=0
            Do ix = iOrdOp, 0, -1
               If (Mod(ix,2).eq.0) Then
                  Factx=One
               Else
                  Factx=DBLE(iPhase(1,iDCRT(lDCRT)))
               End If
               Do iy = iOrdOp-ix, 0, -1
                  If (Mod(iy,2).eq.0) Then
                     Facty=One
                  Else
                     Facty=DBLE(iPhase(2,iDCRT(lDCRT)))
                  End If
                  iz = iOrdOp-ix-iy
                  If (Mod(iz,2).eq.0) Then
                     Factz=One
                  Else
                     Factz=DBLE(iPhase(3,iDCRT(lDCRT)))
                  End If
*
                  jElem = jElem + 1
                  ZRFd(jElem)=Factx*Facty*Factz*ZFd(jElem)
               End Do
            End Do
*
            call dcopy_(3,TC,1,CoorAC(1,2),1)
            call dcopy_(3,TC,1,Coori(1,3),1)
            call dcopy_(3,TC,1,Coori(1,4),1)
*
*           Compute integrals with the Rys quadrature.
*
            nT = nZeta
            NoSpecial=.True.
            Call Rys(iAnga,nT,Zeta,ZInv,nZeta,
     &               [One],[One],1,P,nZeta,
     &               TC,1,rKappa,[One],Coori,Coori,CoorAC,
     &               mabmin,mabmax,mcdMin,mcdMax,
     &               Array(ip1),mArr*nZeta,
     &               TNAI,Fake,XCff2D,XRys2D,NoSpecial)
*
*---------- The integrals are now ordered as ijkl,e,f
*
*           a) Change the order to f,ijkl,e
*           b) Unfold e to ab, f,ijkl,ab
*           c) Change the order back to ijkl,ab,f
*
*a)--------
*
            Call DGeTMO(Array(ip1),nZeta*lab,nZeta*lab,lcd,
     &                  Array(ip2),lcd)
*
*b)---------Use the HRR to unfold e to ab
*
            Call HRR(la,lb,A,RB,Array(ip2),lcd*nZeta,nMem,ipIn)
            ip3=ip2-1+ipIn
*
*c)--------
*
            Call DGeTMO(Array(ip3),lcd,lcd,nZeta*kab,Array(ip1),
     &                  nZeta*kab)
*
*-----------Accumulate contributions to the symmetry adapted operator
*
            nOp = NrOpr(iDCRT(lDCRT))
            ipI=ip1
*
            Do i = 1, nElem(iOrdOp)
               If (ZRFd(i).ne.Zero)
     &            Call SymAdO(Array(ipI),nZeta,la,lb,nComp,Final,nIC,
     &                        nOp         ,lOper,iChO,-Fact*ZRFd(i))
               ipI=ipI+nZeta*nElem(la)*nElem(lb)
            End Do
*
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
            Write (6,*) (Fact*ZFd(i),i = 1, nElem(iOrdOp))
            Call RecPrt('Array(ip1)',' ',Array(ip1),nZeta,
     &              (la+1)*(la+2)/2*(lb+1)*(lb+2)/2*nElem(iOrdOp))
            Call RecPrt('Final',' ',Final,
     &              nZeta,(la+1)*(la+2)/2*(lb+1)*(lb+2)/2*nIC)
#endif

*
         End Do  ! End loop over DCRs
*
111      Continue
      End Do     ! iFd
*
          nData = nData + nElem(iOrdOp)
      End Do     !  iOrdOp
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_integer(nHer)
         Call Unused_real_array(CCoor)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADAADAS1_GAS(NK,I1,XI1S,LI1,IORB,NIORB,IAC,JORB,NJORB,JAC,KSTR,NKEL,NKSTR,IREO,IZ,NOCOB,KMAX,KMIN,IEND,SCLFAC,NSTRI)
! Obtain I1(KSTR) = +/- a+/a  IORB a+/a JORB !KSTR>
! Only orbital pairs IOB > JOB are included
!
! KSTR is restricted to strings with relative numbers in the
! range KMAX to KMIN
!
! =====
! Input
! =====
! IORB : First I orbital to be added
! NIORB : Number of orbitals to be added : IORB to IORB-1+NIORB
!        are used. They must all be in the same TS group
! JORB : First J orbital to be added
! LORB : Number of orbitals to be added : JORB to JORB-1+NJORB
!        are used. They must all be in the same TS group
! KMAX : Largest allowed relative number for K strings
! KMIN : Smallest allowed relative number for K strings
!
! ======
! Output
! ======
!
! NK      : Number of K strings
! I1(KSTR,JORB) : /= 0 =>  a+IORB a+JORB !KSTR> = +/-!ISTR>
! XI1S(KSTR,JORB) : above +/-
!               : == 0    a + JORB !KSTR> = 0
! Offset is KMIN
!
! ISCR : Local scratch, at most 1000 orbitals in a given TS block)
!
! L.R. Jan 20, 1998

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: LI1, IORB, NIORB, IAC, JORB, NJORB, JAC, NKEL, NKSTR, KSTR(NKEL,NKSTR), IREO(*), NOCOB, &
                                 IZ(NOCOB,NKEL+2), KMAX, KMIN, NSTRI
integer(kind=iwp), intent(out) :: NK, I1(LI1,NIORB*NJORB), IEND
real(kind=wp), intent(out) :: XI1S(LI1,NIORB*NJORB)
real(kind=wp), intent(in) :: SCLFAC
integer(kind=iwp) :: IACT, IDIAG, IEL, IIEL, IIELMAX, IIELMIN, IIORB, IJ, IJOFF, ILEX, ILEX0, ILEX1, ILEX2, IORB1, IORB2, IORBMAX, &
                     IORBMIN, ISCR(1000), JEL, JJ, JJEL, JJELMAX, JJELMIN, JJORB, JORB1, JORB2, JORBMAX, JORBMIN, KEL, KEND, &
                     KKORB, KKSTR
real(kind=wp) :: SIGNIJ, SIGNJ, SGN, SGNARR(0:63)

!PAM2009 Array of values, replacing expressions such as (-One)**INT:
SGNARR(0::2) = One
SGNARR(1::2) = -One

! Some dummy initializations
SGN = Zero

#ifdef _DEBUGPRINT_
write(u6,*) ' ===================='
write(u6,*) ' ADADS1_GAS speaking'
write(u6,*) ' ===================='
write(u6,*) ' IORB,NIORB,IAC ',IORB,NIORB,IAC
write(u6,*) ' JORB,NJORB,JAC ',JORB,NJORB,JAC

!write(u6,*) ' Kstrings in action (el,string)'
!write(u6,*) ' ==============================='
write(u6,*) ' 24 elements of reorder array'
call IWRTMA(IREO,1,24,1,24)
!    IWRTMA(KSTR,NKEL,NKSTR,NKEL,NKSTR)
#endif

IORBMIN = IORB
IORBMAX = IORB+NIORB-1

JORBMIN = JORB
JORBMAX = JORB+NJORB-1

KEND = min(NKSTR,KMAX)
if (KEND < NKSTR) then
  IEND = 0
else
  IEND = 1
end if
NK = KEND-KMIN+1

if ((IAC == 2) .and. (JAC == 2)) then

  ! ==========================
  ! Creation- creation mapping
  ! ==========================

  do KKSTR=KMIN,KEND
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Occupation of string ',KKSTR
    call IWRTMA(KSTR(1,KKSTR),1,NKEL,1,NKEL)
#   endif
    ! Loop over electrons after which JORB can be added
    do JEL=0,NKEL

      if (JEL == 0) then
        JORB1 = JORBMIN-1
      else
        JORB1 = max(JORBMIN-1,KSTR(JEL,KKSTR))
      end if
      if (JEL == NKEL) then
        JORB2 = JORBMAX+1
      else
        JORB2 = min(JORBMAX+1,KSTR(JEL+1,KKSTR))
      end if
#     ifdef _DEBUGPRINT_
      write(u6,*) ' JEL JORB1 JORB2 ',JEL,JORB1,JORB2
#     endif

      if ((JEL > 0) .and. (JORB1 >= JORBMIN) .and. (JORB1 <= JORBMAX)) then
        ! vanishing for any IORB
        IJOFF = (JORB1-JORBMIN)*NIORB
        do IIORB=1,NIORB
          IJ = IJOFF+IIORB
          I1(KKSTR-KMIN+1,IJ) = 0
          XI1S(KKSTR-KMIN+1,IJ) = Zero
        end do
      end if

      if ((JORB1 < JORBMAX) .and. (JORB2 > JORBMIN)) then
        ! Orbitals JORB1+1 - JORB2-1 can be added after electron JEL
        !PAM2009 SIGNJ = SCLFAC*(-One)**JEL)
        SIGNJ = SGNARR(JEL)*SCLFAC
        ! reverse lexical number of the first JEL ELECTRONS
        ILEX0 = 1
        do JJEL=1,JEL
          ILEX0 = ILEX0+IZ(KSTR(JJEL,KKSTR),JJEL)
        end do
        do JJORB=JORB1+1,JORB2-1
          ! And electron JEL + 1
          ILEX1 = ILEX0+IZ(JJORB,JEL+1)
          ! Add electron IORB
          do IEL=JEL,NKEL
            if (IEL == JEL) then
              IORB1 = max(JJORB,IORBMIN-1)
            else
              IORB1 = max(IORBMIN-1,KSTR(IEL,KKSTR))
            end if
            if (IEL == NKEL) then
              IORB2 = IORBMAX+1
            else
              IORB2 = min(IORBMAX+1,KSTR(IEL+1,KKSTR))
            end if
#           ifdef _DEBUGPRINT_
            write(u6,*) ' IEL IORB1 IORB2 ',IEL,IORB1,IORB2
#           endif
            if ((IEL > JEL) .and. (IORB1 >= IORBMIN) .and. (IORB1 <= IORBMAX)) then
              IJ = (JJORB-JORBMIN)*NIORB+IORB1-IORBMIN+1
              I1(KKSTR-KMIN+1,IJ) = 0
              XI1S(KKSTR-KMIN+1,IJ) = Zero
            end if
            if ((IORB1 < IORBMAX) .and. (IORB2 > IORBMIN)) then
              ! Orbitals IORB1+1 - IORB2 -1 can be added after ELECTRON IEL in KSTR
              ! Reverse lexical number of the first IEL+1 electrons
              ILEX2 = ILEX1
              do IIEL=JEL+1,IEL
                ILEX2 = ILEX2+IZ(KSTR(IIEL,KKSTR),IIEL+1)
              end do
              ! add terms for the last electrons
              do IIEL=IEL+1,NKEL
                ILEX2 = ILEX2+IZ(KSTR(IIEL,KKSTR),IIEL+2)
              end do
              IJOFF = (JJORB-JORBMIN)*NIORB
              !PAM2009 SIGNIJ = SIGNJ*(-One)**(IEL+1)
              SIGNIJ = SIGNJ*SGNARR(IEL+1)
              do IIORB=IORB1+1,IORB2-1
                IJ = IJOFF+IIORB-IORBMIN+1
                ILEX = ILEX2+IZ(IIORB,IEL+2)
                IACT = IREO(ILEX)
#               ifdef _DEBUGPRINT_
                write(u6,*) 'IIORB JJORB',IIORB,JJORB
                write(u6,*) ' ILEX IACT ',ILEX,IACT
#               endif
                I1(KKSTR-KMIN+1,IJ) = IACT
                XI1S(KKSTR-KMIN+1,IJ) = SIGNIJ
              end do
            end if
          end do
        end do
      end if
    end do
  end do
else if ((IAC == 1) .and. (JAC == 1)) then

  ! =============================================
  ! annihilation - annihilation mapping (a i a j)
  ! =============================================

  do KKSTR=KMIN,KEND
    ! Active range for electrons
    IIELMIN = 0
    IIELMAX = 0
    JJELMIN = 0
    JJELMAX = 0

    do KEL=1,NKEL
      KKORB = KSTR(KEL,KKSTR)
      if ((IIELMIN == 0) .and. (KKORB >= IORBMIN)) IIELMIN = KEL
      if ((JJELMIN == 0) .and. (KKORB >= JORBMIN)) JJELMIN = KEL
      if (KKORB <= IORBMAX) IIELMAX = KEL
      if (KKORB <= JORBMAX) JJELMAX = KEL
    end do
    if (IIELMIN == 0) IIELMIN = NKEL+1
    if (JJELMIN == 0) JJELMIN = NKEL+1

#   ifdef _DEBUGPRINT_
    write(u6,*) ' Occupation of string ',KKSTR
    call IWRTMA(KSTR(1,KKSTR),1,NKEL,1,NKEL)
#   endif
    ! Loop over first electron to be removed
    !do JEL=1,NKEL
    do JEL=JJELMIN,JJELMAX
      JJORB = KSTR(JEL,KKSTR)
      ! Loop over second electron to be removed
      !do IEL=JEL+1,NKEL
      do IEL=max(JEL+1,IIELMIN),IIELMAX
        IIORB = KSTR(IEL,KKSTR)
#       ifdef _DEBUGPRINT_
        write(u6,*) ' IEL JEL IORB JORB ',IEL,JEL,IORB,JORB
#       endif
        if ((IIORB >= IORBMIN) .and. (IIORB <= IORBMAX) .and. (JJORB >= JORBMIN) .and. (JJORB <= JORBMAX)) then
          !PAM09 SGN = SCLFAC*(-One)**(IEL+JEL-1)
          SGN = SGNARR(IEL+JEL+1)*SCLFAC
          ! reverse lexical number of the double annihilated string
          ILEX = 1
          do JJEL=1,JEL-1
            ILEX = ILEX+IZ(KSTR(JJEL,KKSTR),JJEL)
          end do
          do JJEL=JEL+1,IEL-1
            ILEX = ILEX+IZ(KSTR(JJEL,KKSTR),JJEL-1)
          end do
          do JJEL=IEL+1,NKEL
            ILEX = ILEX+IZ(KSTR(JJEL,KKSTR),JJEL-2)
          end do
          IACT = IREO(ILEX)
          if ((IACT <= 0) .or. (IACT > NSTRI)) then
            write(u6,*) ' IACT out of bounds, IACT =  ',IACT
            !stop ' IACT out of bounds'
            call SYSABENDMSG('lucia_util/adaadas1_gas','Internal error','')
          end if
#         ifdef _DEBUGPRINT_
          write(u6,*) ' ILEX and IACT ',ILEX,IACT
#         endif

          IJ = (JJORB-JORB)*NIORB+IIORB-IORB+1
          I1(KKSTR-KMIN+1,IJ) = IACT
          XI1S(KKSTR-KMIN+1,IJ) = SGN
        end if
        ! End if orbitals are in correct range
      end do
      ! End of loop over IEL
    end do
    ! End of loop over JEL
  end do
  ! End of loop over Kstrings

else if ((IAC == 2) .and. (JAC == 1)) then

  ! ==================================
  ! Creation-annihilation map a+ i a j
  ! ==================================

  !do KKSTR=1,NKSTR
  do KKSTR=KMIN,KEND
    ! Indicate where a given orbital i should be added in KKSTR
    ISCR(IORBMIN:IORBMIN+NIORB-1) = 0
    IIEL = 1
    do IIORB=IORBMIN,IORBMAX
      do
        if (IIEL <= NKEL) then
          if (IIORB < KSTR(IIEL,KKSTR)) then
            ISCR(IIORB) = IIEL
            exit
          else if (IIORB == KSTR(IIEL,KKSTR)) then
            ISCR(IIORB) = -IIEL
            IIEL = IIEL+1
            exit
          else if (IIORB > KSTR(IIEL,KKSTR)) then
            IIEL = IIEL+1
          end if
        else if (IIEL == NKEL+1) then
          ISCR(IIORB) = IIEL
          exit
        end if
      end do
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) ' ISCR from IORBMIN array for KKSTR = ',KKSTR
    write(u6,*) ' IORBMIN, NIORB',IORBMIN,NIORB
    call IWRTMA(ISCR(IORBMIN),1,NIORB,1,NIORB)
#   endif
    do JEL=1,NKEL
      JJORB = KSTR(JEL,KKSTR)
      if ((JJORB >= JORBMIN) .and. (JJORB <= JORBMAX)) then
        do IIORB=IORBMIN,IORBMAX
          IEL = ISCR(IIORB)
          !write(u6,*) ' JEL IEL JJORB IIORB',JEL,IEL,JJORB,IIORB
          IACT = 0
          if ((IEL > 0) .and. (IIORB > JJORB)) then
            ! New string is  a+1 ... a+ jel-1 a+jel+1 ..a+iel-1 a+iiorb a+iel+1 ...
            ! Lexical number of new string
            ILEX = 1
            do KEL=1,JEL-1
              ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL)
            end do
            do KEL=JEL+1,IEL-1
              ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL-1)
            end do
            ILEX = ILEX+IZ(IIORB,IEL-1)
            do KEL=IEL,NKEL
              ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL)
            end do
            IACT = IREO(ILEX)
            if ((IACT <= 0) .or. (IACT > NSTRI)) then
              write(u6,*) ' 1: IACT out of bounds, IACT =  ',IACT
              write(u6,*) ' NSTRI = ',NSTRI
              write(u6,*) 'IIORB,JJORB ',IIORB,JJORB
              write(u6,*) ' Kstring :'
              call IWRTMA(KSTR(1,KKSTR),1,NKEL,1,NKEL)
              write(u6,*) ' ILEX = ',ILEX
              write(u6,*) 'IZ matrix'
              call IWRTMA(IZ,NOCOB,NKEL,NOCOB,NKEL)
              !stop ' IACT out of bounds'
              call SYSABENDMSG('lucia_util/adaadas1_gas','Internal error','')
            end if
            !PAM2009 SGN = SCLFAC*(-One)**(IEL+JEL-1)
            SGN = SGNARR(IEL+JEL+1)*SCLFAC
          else if ((IEL > 0) .and. (IIORB < JJORB)) then
            ! New string is  a+1 ... a+ iel-1 a+ iiorb a+iel+1 ..a+jel-1 a+jel+1 ...
            ILEX = 1
            do KEL=1,IEL-1
              ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL)
            end do
            ILEX = ILEX+IZ(IIORB,IEL)
            do KEL=IEL,JEL-1
              ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL+1)
            end do
            do KEL=JEL+1,NKEL
              ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL)
            end do
            !write(u6,*) ' ILEX =',ILEX
            IACT = IREO(ILEX)
            if ((IACT <= 0) .or. (IACT > NSTRI)) then
              write(u6,*) '2 IACT out of bounds, IACT =  ',IACT
              !stop ' IACT out of bounds'
              call SYSABENDMSG('lucia_util/adaadas1_gas','Internal error','')
            end if
            !write(u6,*) ' IACT = ',IACT
            !PAM2009 SGN = SCLFAC*(-One)**(IEL+JEL)
            SGN = SGNARR(IEL+JEL)*SCLFAC
          else if ((IEL < 0) .and. (IIORB == JJORB)) then
            ! Diagonal excitation
            SGN = SCLFAC
            IACT = KKSTR
          end if
          if (IACT /= 0) then
            IJ = (JJORB-JORB)*NIORB+IIORB-IORB+1
            I1(KKSTR-KMIN+1,IJ) = IACT
            XI1S(KKSTR-KMIN+1,IJ) = SGN
          end if
        end do
        ! End of loop over IIORB
      end if
      ! End of  active cases
    end do
    ! End of loop over electrons to be annihilated
  end do
  !^ End of loop over Kstrings
else if ((IAC == 1) .and. (JAC == 2)) then

  ! ===================================
  ! Annihilation-creation  map a i a+ j
  ! ===================================

  ! Diagonal excitations ?
  if (IORBMIN == JORBMIN) then
    IDIAG = 1
  else
    IDIAG = 0
  end if
  !do KKSTR=1,NKSTR
  do KKSTR=KMIN,KEND
    ! Indicate where a given orbital j should be added in KKSTR
    ISCR(JORBMIN:JORBMIN+NJORB-1) = 0
    JJEL = 1
    do JJORB=JORBMIN,JORBMAX
      do
        if (JJEL <= NKEL) then
          if (JJORB < KSTR(JJEL,KKSTR)) then
            ISCR(JJORB) = JJEL
            exit
          else if (JJORB == KSTR(JJEL,KKSTR)) then
            ISCR(JJORB) = -JJEL
            JJEL = JJEL+1
            exit
          else if (JJORB > KSTR(JJEL,KKSTR)) then
            JJEL = JJEL+1
          end if
        else if (JJEL == NKEL+1) then
          ISCR(JJORB) = JJEL
          exit
        end if
      end do
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) ' ISCR from JORBMIN array for KKSTR = ',KKSTR
    call IWRTMA(ISCR(JORBMIN),1,NJORB,1,NJORB)
#   endif
    do IEL=1,NKEL+IDIAG
      ! IEL = NKEL + 1 will be used for excitations a+j aj
      if (IEL <= NKEL) IIORB = KSTR(IEL,KKSTR)
      if (((IIORB >= IORBMIN) .and. (IIORB <= IORBMAX)) .or. (IEL == NKEL+1)) then
        do JJORB=JORBMIN,JORBMAX
          JEL = ISCR(JJORB)
          !write(u6,*) ' IEL IIORB JEL JJORB ',IEL,IIORB,JEL,JJORB
          IACT = 0
          if (IEL <= NKEL) then
            if ((JEL > 0) .and. (JJORB > IIORB)) then
              ! New string is  a+1 ... a+ iel-1 a+iel+1 ..a+jel-1 a+jjorb a+jel+1 ...
              ! Lexical number of new string
              ILEX = 1
              do KEL=1,IEL-1
                ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL)
              end do
              do KEL=IEL+1,JEL-1
                ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL-1)
              end do
              ILEX = ILEX+IZ(JJORB,JEL-1)
              do KEL=JEL,NKEL
                ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL)
              end do
              IACT = IREO(ILEX)
              if ((IACT <= 0) .or. (IACT > NSTRI)) then
                write(u6,*) '3 IACT out of bounds, IACT =  ',IACT
                write(u6,*) ' ILEX,KKSTR ',ILEX,KKSTR
                write(u6,*) ' occupation of KSTR'
                call IWRTMA(KSTR,1,NKEL,1,NKEL)
                write(u6,*) ' IEL JEL ',IEL,JEL
                write(u6,*) ' IIORB,JJORB',IIORB,JJORB
                !stop ' IACT out of bounds'
                call SYSABENDMSG('lucia_util/adaadas1_gas','Internal error','')
              end if
              !PAM2009 SGN = SCLFAC*(-One)**(IEL+JEL)
              SGN = SGNARR(IEL+JEL)*SCLFAC
            else if ((JEL > 0) .and. (JJORB < IIORB)) then
              ! New string is  a+1 ... a+ jel-1 a+ jjorb a+jel+1 ..a+iel-1 a+iel+1 ...
              ILEX = 1
              do KEL=1,JEL-1
                ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL)
              end do
              ILEX = ILEX+IZ(JJORB,JEL)
              do KEL=JEL,IEL-1
                ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL+1)
              end do
              do KEL=IEL+1,NKEL
                ILEX = ILEX+IZ(KSTR(KEL,KKSTR),KEL)
              end do
              IACT = IREO(ILEX)
              !PAM2009 SGN = SCLFAC*(-One)**(IEL+JEL-1)
              SGN = SGNARR(IEL+JEL+1)*SCLFAC
              if ((IACT <= 0) .or. (IACT > NSTRI)) then
                write(u6,*) '4 IACT out of bounds, IACT =  ',IACT
                write(u6,*) ' NSTRI = ',NSTRI
                write(u6,*) 'IIORB,JJORB ',IIORB,JJORB
                write(u6,*) ' Kstring :'
                call IWRTMA(KSTR(1,KKSTR),1,NKEL,1,NKEL)
                write(u6,*) ' ILEX = ',ILEX
                write(u6,*) 'IZ matrix'
                call IWRTMA(IZ,NOCOB,NKEL,NOCOB,NKEL)
                !stop ' IACT out of bounds'
                call SYSABENDMSG('lucia_util/adaadas1_gas','Internal error','')
              end if
            end if
            if (IACT /= 0) then
              IJ = (JJORB-JORB)*NIORB+IIORB-IORB+1
              I1(KKSTR-KMIN+1,IJ) = IACT
              XI1S(KKSTR-KMIN+1,IJ) = SGN
            end if
          else if ((IEL == NKEL+1) .and. (JEL > 0)) then
            ! Diagonal excitations aja+j
            JJ = (JJORB-JORB)*NJORB+JJORB-JORB+1
            I1(KKSTR-KMIN+1,JJ) = KKSTR
            XI1S(KKSTR-KMIN+1,JJ) = SCLFAC
          end if
        end do
        ! End of loop over JJORB
      end if
      ! End of  active cases
    end do
    ! End of loop over electrons to be annihilated
  end do
  ! End of loop over Kstrings
end if
! End of types of creation mappings

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from ADADST1_GAS'
write(u6,*) ' ====================='
write(u6,*) ' Number of K strings accessed ',NK
if (NK /= 0) then
  IJ = 0
  do JJORB=JORB,JORB+NJORB-1
    do IIORB=IORB,IORB+NIORB-1
      IJ = IJ+1
      !write(u6,*) ' IJ = ',IJ
      !if (IIORB > JJORB) then
      write(u6,*) ' Info for orbitals (iorb,jorb) ',IIORB,JJORB
      write(u6,*) ' Excited strings and sign'
      call IWRTMA(I1(1,IJ),1,NK,1,NK)
      call WRTMAT(XI1S(1,IJ),1,NK,1,NK)
      !end if
    end do
  end do
end if
#endif

end subroutine ADAADAS1_GAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA_RdOrb_FromInpOrb()

implicit none
character(len=*), parameter :: SecNam = 'RPA_RdOrb_FromInpOrb'

call RPA_Warn(3,SecNam//': Reading orbitals from INPORB not implemented yet')

end subroutine RPA_RdOrb_FromInpOrb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_Map2CF(AB,nRow,nCol,Map)
C
C     Thomas Bondo Pedersen, January 2011
C
C     Purpose: set up map from 2CFunctions of atom pair AB to the
C              product functions of AB
C              Note that, if nCol>1 and A=B, two product functions are
C              mapped to: one with u>v and one with u<v.
C
      Implicit None
      Integer AB
      Integer nRow, nCol
      Integer Map(nRow,nCol)
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Character*10 SecNam
      Parameter (SecNam='LDF_Map2CF')

      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom

      Integer A, B
      Integer nSA, nSB
      Integer ipA, ipB
      Integer iSA, iSB
      Integer iShellA, iShellB
      Integer ip_kOff, l_kOff
      Integer i2C
      Integer iA, iB, iAB, iBA

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_2CFunctions
      Integer List2C
      Integer kOff
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      List2C(i,j)=iWork(AP_2CFunctions(2,AB)-1+4*(j-1)+i)
      kOff(i,j)=iWork(ip_kOff-1+nSA*(j-1)+i)

      If (AP_2CFunctions(1,AB).gt.0) Then
         If (nRow.lt.AP_2CFunctions(1,AB)) Then
            Call WarningMessage(2,
     &                           SecNam//': insufficient row dimension')
            Call LDF_Quit(1)
         End If
         If (nCol.lt.1) Then
            Call WarningMessage(2,
     &                           SecNam//': insufficient col dimension')
            Call LDF_Quit(1)
         End If
         A=AP_Atoms(1,AB)
         B=AP_Atoms(2,AB)
         nSA=LDF_nShell_Atom(A)
         nSB=LDF_nShell_Atom(B)
         ipA=LDF_lShell_Atom(A)-1
         l_kOff=nSA*nSB
         Call GetMem('kOff','Allo','Inte',ip_kOff,l_kOff)
         Call LDF_uvOffset(AB,nSA,nSB,iWork(ip_kOff))
         Do i2C=1,AP_2CFunctions(1,AB)
            iSA=List2C(1,i2C)
            iA=List2C(2,i2C)
            iSB=List2C(3,i2C)
            iB=List2C(4,i2C)
            iShellA=iWork(ipA+iSA)
            iAB=kOff(iSA,iSB)+nBasSh(iShellA)*(iB-1)+iA
            Map(i2C,1)=iAB
         End Do
         If (A.eq.B .and. nCol.gt.1) Then
            ipB=ipA
            Do i2C=1,AP_2CFunctions(1,AB)
               iSA=List2C(1,i2C)
               iA=List2C(2,i2C)
               iSB=List2C(3,i2C)
               iB=List2C(4,i2C)
               iShellB=iWork(ipB+iSB)
               iBA=kOff(iSB,iSA)+nBasSh(iShellB)*(iA-1)+iB
               Map(i2C,2)=iBA
            End Do
         End If
         Call GetMem('kOff','Free','Inte',ip_kOff,l_kOff)
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine gr_evb1_cvb(civbh,civbs,civb,dvbdet,grad,grad1,grad2,gradx,vec1)

use casvb_global, only: f1, f2, f3, f4, ndet, ndetvb, nfr, norb, npr, ovraa, ww
use Constants, only: Zero, One, Two
use Definitions, only: wp

implicit none
real(kind=wp), intent(inout) :: civbh(0:ndet), civbs(0:ndet)
real(kind=wp), intent(in) :: civb(0:ndet)
real(kind=wp), intent(out) :: dvbdet(ndetvb), grad(nfr), grad1(npr), grad2(npr), gradx(norb,norb), vec1(npr)

f1 = One/ovraa
f2 = -Two*f1*f1*ww
f1 = Two*f1
f3 = -f1*f1
f4 = -f1*f3*ww

gradx(:,:) = Zero
call onedens_cvb(civb,civbs,gradx,.true.,1)

call mkgrd_cvb(civb,civbs,grad1,dvbdet,npr,.true.)
call mkgrd_cvb(civb,civbh,grad2,dvbdet,npr,.true.)

! Use VEC1 as work:
vec1(:) = f1*grad2(:)+f2*grad1(:)
call prgrad_cvb(vec1,npr)

call make_cvb('ORBFREE')
call make_cvb('CIFREE')
call all2free_cvb(vec1,grad,1)

return

end subroutine gr_evb1_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine CD_Tester_CPPF(PDM,X,n)

use Index_Functions, only: iTri, nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: PDM(nTri_Elem(n))
real(kind=wp), intent(out) :: X(n,n)
integer(kind=iwp) :: i, j

do j=1,n
  X(j,j) = PDM(iTri(j,j))
  do i=j+1,n
    X(i,j) = PDM(iTri(i,j))
    X(j,i) = X(i,j)
  end do
end do

end subroutine CD_Tester_CPPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Oskar Weser                                      *
!***********************************************************************



!>  @brief
!>    Master module for fcidump.
module fcidump
  use rasscf_data, only : nacpar
  use general_data, only : nAsh, nTot, nTot1, nTot2
  use fcidump_tables, only : OrbitalTable, FockTable, TwoElIntTable,&
    mma_allocate, mma_deallocate, fill_orbitals, fill_fock, fill_2ElInt
  use fcidump_transformations, only : get_orbital_E, fold_Fock
  use fcidump_reorder, only : reorder
  use fcidump_dump, only : dump_ascii, dump_hdf5
  implicit none
  private
  public :: make_fcidumps, transform, DumpOnly, cleanup
  logical :: DumpOnly = .false.
  save
contains

  subroutine make_fcidumps(ascii_path, h5_path, orbital_energies, folded_Fock,&
                           TUVX, core_energy, permutation)
    use general_data, only : nSym, nAsh
    character(len=*), intent(in) :: ascii_path, h5_path
    real*8, intent(in) :: orbital_energies(:), folded_Fock(:), TUVX(:), core_energy
    integer, intent(in), optional :: permutation(:)
    type(OrbitalTable) :: orbital_table
    type(FockTable) :: fock_table
    type(TwoElIntTable) :: two_el_table
    integer :: orbsym(sum(nAsh(:nSym))), n, j

    call mma_allocate(fock_table, nacpar)
    call mma_allocate(two_el_table, size(TUVX))
    call mma_allocate(orbital_table, sum(nAsh))

    call fill_orbitals(orbital_table, orbital_energies)
    call fill_fock(fock_table, folded_Fock)
    call fill_2ElInt(two_el_table, TUVX)

    n = 1
    do j = 1, nSym
      orbsym(n : n + nAsh(j) - 1) = j
      n = n + nAsh(j)
    end do

    if (present(permutation)) then
      call reorder(orbital_table, fock_table, two_el_table, orbsym, permutation)
    end if

    call dump_ascii(ascii_path, core_energy, orbital_table, fock_table, &
                    & two_el_table, orbsym)
    call dump_hdf5(h5_path, core_energy, orbital_table, fock_table, &
                    & two_el_table, orbsym)

    call mma_deallocate(fock_table)
    call mma_deallocate(two_el_table)
    call mma_deallocate(orbital_table)
  end subroutine make_fcidumps

  subroutine transform(actual_iter, CMO, DIAF, D1I_AO, D1A_AO, D1S_MO, &
                       F_IN, orbital_E, folded_Fock)
    integer, intent(in) :: actual_iter
    real*8, intent(in) :: DIAF(nTot),&
      CMO(nTot2),&
      D1I_AO(nTot2),&
      D1A_AO(nTot2),&
      D1S_MO(nAcPar)
    real*8, intent(inout) :: F_IN(nTot1)
    real*8, intent(out) :: orbital_E(nTot), folded_Fock(nAcPar)

    call get_orbital_E(actual_iter, DIAF, orbital_E)
    call fold_Fock(CMO, D1I_AO, D1A_AO, D1S_MO, F_In, folded_Fock)
  end subroutine transform

  subroutine cleanup()
    use fcidump_reorder, only : fcidump_reorder_cleanup => cleanup
    call fcidump_reorder_cleanup()
  end subroutine
end module fcidump

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine DCR(Lambda,iStab1,nStab1,iStab2,nStab2,iDCR,mDCR)
      Use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (A-H,O-Z)
      Integer   iStab1(0:nStab1-1),iStab2(0:nStab2-1), iDCR(0:7)
      Integer   Index(50), Lambda_all(1275), mDCR_all(1275),
     &          iDCR_all(0:7,1275)
      Save   Index, Lambda_all, mDCR_all, iDCR_all
#include "dcr.fh"
*
      Ind1=0
      Do i = 1, nStab1-1
         Do iIrrep = 1, nIrrep-1
            If (iStab1(i).eq.iOper(iIrrep)) Then
               Ind1=Ind1+2**(iIrrep-1)
               Go To 11
            End If
         End Do
 11      Continue
      End Do
      Do k = 1, nIndex
         If (Ind1.eq.Index(k)) Then
            Ind1=k
            Go To 10
         End If
      End Do
      nIndex=nIndex+1
      Index(nIndex)=Ind1
      Ind1=nIndex
10    Continue
*
      Ind2=0
      Do i = 1, nStab2-1
         Do iIrrep = 1, nIrrep-1
            If (iStab2(i).eq.iOper(iIrrep)) Then
               Ind2=Ind2+2**(iIrrep-1)
               Go To 21
            End If
         End Do
 21      Continue
      End Do
      Do k = 1, nIndex
         If (Ind2.eq.Index(k)) Then
            Ind2=k
            Go To 20
         End If
      End Do
      nIndex=nIndex+1
      Index(nIndex)=Ind2
      Ind2=nIndex
20    Continue
*
      ij = Max(Ind1,Ind2)*(Max(Ind1,Ind2)-1)/2 + Min(Ind1,Ind2)
*
      If (.Not.Done(ij)) Then
         Call DCR_(Lambda_all(ij),iStab1,nStab1,iStab2,nStab2,
     &             iDCR_all(0,ij),mDCR_all(ij))
         Done(ij)=.True.
      End If
      Lambda=Lambda_all(ij)
      mDCR  =mDCR_all(ij)
      Call ICopy(mDCR,iDCR_all(0,ij),1,iDCR,1)
*
      Return
      End
*
      Subroutine DCR_Init
#include "dcr.fh"
      nindex=0
      Do I=1,1275
         Done(I)=.False.
      End Do
      Return
      End
      SubRoutine DCR_(Lambda,iStab1,nStab1,iStab2,nStab2,iDCR,mDCR)
************************************************************************
* Oject: to compute the double coset representatives (DCR) and Lambda. *
*                                                                      *
* Called from: OneEl                                                   *
*              NucAtt                                                  *
*              TwoEl                                                   *
*                                                                      *
* Calling    : None                                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
************************************************************************
      Use Symmetry_Info, only: nIrrep, iOper
      Implicit Real*8 (A-H,O-Z)
      Integer   iStab1(0:nStab1-1),iStab2(0:nStab2-1),iDCR(0:7)
      Integer   iScrt(0:7,0:7)
*
      iScrt(:,:)=0
*
*     Construct all UGV subgroups. We accumulate the number of times an
*     operator appears in each UGV subgroup.
*
      Do 20 i = 0, nIrrep-1
         Do 30 j = 0, nStab1-1
            Do 40 k = 0, nStab2-1
               jik=iEor(iStab1(j),iEor(iOper(i),iStab2(k)))
               iScrt(i,jik) = iScrt(i,jik) + 1
 40         Continue
 30      Continue
 20   Continue
*
*     Find Lambda. Lambda is the number of times an operator is in the
*     subgroup UGV. Look only in the first subgroup.
*
      Do 100 i = 0, 7
         If(iScrt(0,i).ne.0) Lambda = iScrt(0,i)
 100  Continue
*
*     Find the unique double cosets (DC) and construct the double coset
*     representatives (DCR)
*
*     Move the first double coset representative, i.e. take the first
*     operator which appears in the subgroup UGV.
*
      mDCR = 0
      Do 200 i = 0, 7
         If(iScrt(0,iOper(i)).ne.0) Then
            iDCR(mDCR)=iOper(i)
            mDCR = mDCR + 1
            Go To 201
         End If
 200  Continue
 201  Continue
*
*     Now look through the remaining subgroups UGV, if any. If a new
*     unique subgroup is found take a representative from this set.
*     Observe that the subgroups UGV are either totally identical or
*     completely disjoint.
*
      Do 210 i=1, nIrrep-1
         Do 211 k = 0, nIrrep-1
*           Check if operator exists in UGV.
            If (iScrt(i,iOper(k)).eq.0) Go To 211
            Do 212 j = 0, mDCR-1
*              See that no element of UGV is already in DCR.
               If (iDCR(j).eq.iOper(k)) Go To 210
 212        Continue
 211     Continue
*        Here if new unique subgroup UGV was found.
         Do 220 k = 0, nIrrep-1
*           Move a representative to the DCR set.
            If(iScrt(i,iOper(k)).ne.0) Then
               iDCR(mDCR)=iOper(k)
               mDCR = mDCR + 1
               Go To 221
            End If
 220     Continue
 221     Continue
*
 210  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Francesco Aquilante                              *
!***********************************************************************

subroutine Cho_SOSmp2_DecDrv(irc,DelOrig,Diag)
! Francesco Aquilante, May 2007.
!
! Purpose: decompose M(ai,bj) = (ai|bj)^2 for use in
!          SOS-MP2 approach.
!
! DelOrig: flag for deleting files with original vectors after
!          decomposition completes.

use ChoMP2, only: OldVec
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
logical(kind=iwp), intent(in) :: DelOrig
real(kind=wp), intent(in) :: Diag(*)
integer(kind=iwp) :: iAdr, iBin, iClos(2), iOpt, iSym, iTyp, kOffD, lB, Left, lTot, MxQual, nBin, nDim, nInC
real(kind=wp) :: ErrStat(3), RMS, Thr, XMn, XMx
logical(kind=iwp) :: Failed
integer(kind=iwp), allocatable :: iPivot(:), iQual(:)
real(kind=wp), allocatable :: Bin(:), Buf(:), Qual(:)
logical(kind=iwp), parameter :: Restart = .false.
character(len=*), parameter :: SecNam = 'Cho_SOSmp2_DecDrv'
external :: Cho_SOSmp2_Col, ChoMP2_Vec
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "chomp2_dec.fh"

! Initializations.
! ----------------

irc = 0

if (Verbose) then
  nBin = 18
  call mma_allocate(Bin,nBin,label='Bin')
else
  nBin = 0
end if

do iSym=1,nSym
  nMP2Vec(iSym) = 0
  InCore(iSym) = .false.
end do
NowSym = -999999

if (DelOrig) then
  iClos(1) = 3  ! signals close and delete original vectors
else
  iClos(1) = 2  ! signals close and keep original vectors
end if
iClos(2) = 2    ! signals close and keep result vectors

! Print.
! ------

if (Verbose) then
  write(u6,*)
  call Cho_Head('Cholesky Decomposition of  M(ai,bj) = (ai|bj)^2 for SOS-MP2','=',80,u6)
  write(u6,'(/,1X,A)') 'Configuration of decomposition:'
  write(u6,'(1X,A,1P,D15.6)') 'Threshold: ',ThrMP2
  write(u6,'(1X,A,1P,D15.6)') 'Span     : ',SpanMP2
  if (ChkDecoMP2) then
    write(u6,'(1X,A)') 'Full decomposition check activated.'
  end if
end if

! Start symmetry loop.
! --------------------

kOffD = 1
do iSym=1,nSym

  nDim = nT1am(iSym)
  if ((nDim > 0) .and. (NumCho(iSym) > 0)) then

    if (Verbose .and. (nBin > 0)) then
      Bin(1) = 1.0e2_wp
      do iBin=2,nBin
        Bin(iBin) = Bin(iBin-1)*0.1_wp
      end do
      write(u6,'(//,1X,A,I2,A,I9)') '>>> Cholesky decomposing symmetry block ',iSym,', dimension: ',nDim
      write(u6,'(/,1X,A)') 'Analysis of initial diagonal:'
      call Cho_AnaSize(Diag(kOffD),nDim,Bin,nBin,u6)
    end if

    ! Open files.
    ! -----------

    do iTyp=1,2
      call ChoMP2_OpenF(1,iTyp,iSym)
    end do

    ! Setup decomposition.
    ! --------------------

    NowSym = iSym

    if (MxQualMP2 /= MxQual_Def) then ! user-defined
      MxQual = min(max(MxQualMP2,1),nDim)
    else ! default
      if (nDim > 10) then
        MxQual = max(min(nDim/10,MxQualMP2),1)
      else
        MxQual = max(min(nDim,MxQualMP2),1)
      end if
    end if
#   if !defined (_I8_)
    lTstBuf = (nDim+MxQual)*MxQual
    lTstQua = nDim*(MxQual+1)
    do while (((lTstBuf < 0) .or. (lTstQua < 0)) .and. (MxQual > 0))
      MxQual = MxQual-1
      lTstBuf = (nDim+MxQual)*MxQual
      lTstQua = nDim*(MxQual+1)
    end do
    if (MxQual < 1) then
      write(u6,*) SecNam,': MxQual causes integer overflow!'
      write(u6,*) SecNam,': parameters:'
      write(u6,*) 'Symmetry block: ',iSym
      write(u6,*) 'Dimension     : ',nDim
      write(u6,*) 'MxQual        : ',MxQual
      irc = -99
      call finalize()
      return
    end if
#   endif

    call mma_allocate(Qual,nDim*(MxQual+1),label='Qual')
    call mma_allocate(iQual,MxQual,label='iQual')
    call mma_allocate(iPivot,nDim,label='iPivot')

    call mma_maxDBLE(lB)
    lBuf = min((nDim+MxQual)*MxQual,lB)
    Left = lB-lBuf
    nInC = Left/nDim
    if (nInC >= NumCho(iSym)) then
      InCore(iSym) = .true.
      lTot = nDim*NumCho(iSym)
      call mma_allocate(OldVec,lTot,Label='OldVec')
      iOpt = 2
      iAdr = 1
      call ddaFile(lUnit_F(iSym,1),iOpt,OldVec,lTot,iAdr)
    end if
    call mma_maxDBLE(lBuf)
    call mma_allocate(Buf,lBuf,label='DecBuf')

    ! Decompose this symmetry block.
    ! ------------------------------

    Thr = ThrMP2
    Span = SpanMP2
    call ChoDec(Cho_SOSmp2_Col,ChoMP2_Vec,Restart,Thr,Span,MxQual,Diag(kOffD),Qual,Buf,iPivot,iQual,nDim,lBuf,ErrStat, &
                nMP2Vec(iSym),irc)
    if (irc /= 0) then
      write(u6,*) SecNam,': ChoDec returned ',irc,'   Symmetry block: ',iSym
      call finalize()
      return
    end if
    XMn = ErrStat(1)
    XMx = ErrStat(2)
    RMS = ErrStat(3)
    if (Verbose) then
      write(u6,'(/,1X,A)') '- decomposition completed!'
      write(u6,'(1X,A,I9,A,I9,A)') 'Number of vectors needed: ',nMP2Vec(iSym),' (number of AO vectors: ',NumCho(iSym),')'
      write(u6,'(1X,A)') 'Error statistics for (ai|ai)^2 [min,max,rms]:'
      write(u6,'(1X,1P,3(D15.6,1X))') XMn,XMx,RMS
    end if
    Failed = (abs(Xmn) > Thr) .or. (abs(XMx) > thr) .or. (RMS > Thr)
    if (Failed) then
      if (.not. Verbose) then
        write(u6,'(1X,A)') 'Error statistics for (ai|ai)^2 [min,max,rms]:'
        write(u6,'(1X,1P,3(D15.6,1X))') XMn,XMx,RMS
      end if
      write(u6,*) SecNam,': (ai|bj)^2 decomposition failed!'
      irc = -9999
      call finalize()
      return
    end if

    ! If requested, check decomposition.
    ! ----------------------------------

    if (ChkDecoMP2) then
      write(u6,*)
      write(u6,*) SecNam,': Checking M(ai,bj)=(ai|bj)^2 CD.'
      write(u6,*) 'Symmetry block: ',iSym
      write(u6,*) 'Threshold, Span, MxQual: ',Thr,Span,MxQual
      write(u6,*) 'Error statistics for (ai|ai)^2 [min,max,rms]:'
      write(u6,*) ErrStat(:)
      call Cho_SOSmp2_DecChk(irc,iSym,Qual,nDim,MxQual,Buf,lBuf,ErrStat)
      if (irc /= 0) then
        write(u6,*) SecNam,': ChoMP2_DecChk returned ',irc,'   Symmetry block: ',iSym
        call ChoMP2_Quit(SecNam,'SOS-MP2 decomposition failed!',' ')
      else
        XMn = ErrStat(1)
        XMx = ErrStat(2)
        RMS = ErrStat(3)
        Failed = Failed .or. (abs(Xmn) > Thr) .or. (abs(XMx) > Thr) .or. (RMS > Thr)
        write(u6,*) 'Error statistics for (ai|bj)^2 [min,max,rms]:'
        write(u6,*) XMn,XMx,RMS
        if (Failed) then
          write(u6,*) '==> DECOMPOSITION FAILURE <=='
          irc = -9999
          call finalize()
          return
        else
          write(u6,*) '==> DECOMPOSITION SUCCESS <=='
        end if
        call xFlush(u6)
      end if
    end if

    ! Free memory.
    ! ------------

    call mma_deallocate(Buf)
    if (InCore(iSym)) call mma_deallocate(OldVec)
    call mma_deallocate(Qual)
    call mma_deallocate(iQual)
    call mma_deallocate(iPivot)

    ! Close (possibly deleting original) files.
    ! -----------------------------------------

    do iTyp=1,2
      call ChoMP2_OpenF(iClos(iTyp),iTyp,iSym)
    end do

    ! Update pointer to diagonal block.
    ! ---------------------------------

    kOffD = kOffD+nT1am(iSym)

  else

    if (Verbose) then
      write(u6,'(//,1X,A,I2,A)') '>>> Symmetry block',iSym,' is empty!'
    end if

  end if

end do

call finalize()

return

contains

subroutine finalize()
  integer(kind=iwp) :: iSym, iTyp
  if (irc /= 0) then ! make sure files are closed before exit
    do iSym=1,nSym
      do iTyp=1,2
        call ChoMP2_OpenF(2,iTyp,iSym)
      end do
    end do
  end if
  if (allocated(Bin)) call mma_deallocate(Bin)
end subroutine

end subroutine Cho_SOSmp2_DecDrv

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990-1992, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine SchInt(CoorM,iAnga,mZeta,Zeta,ZInv,rKapab,P,rKapcd,Q,nZeta,Wrk,nWork2,HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
!***********************************************************************
!                                                                      *
! Object: to compute zeta, kappa, P, and the integrals [nm|nm] for     *
!         prescreening. This is done for all unique pairs of centers   *
!         generated from the symmetry unique centers A and B.          *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!             Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN.                              *
!             June '91, modified to compute zeta, P, kappa and inte-   *
!             grals for Schwarz inequality in a k2 loop.               *
!             April '92 modified from k2Loop to a separate subroutine  *
!              for estimates of the gradient.                          *
!***********************************************************************

use Index_Functions, only: nTri_Elem1, nTri3_Elem1
use Real_Spherical, only: ipSph, RSph
use Rys_interfaces, only: cff2d_kernel, modu2_kernel, rys2d_kernel, tval_kernel
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: iAnga(4), mZeta, nZeta, nWork2, nHrrMtrx, iShlla, jShllb
real(kind=wp), intent(in) :: CoorM(3,4), Zeta(mZeta), ZInv(mZeta), rKapab(mZeta), P(nZeta,3), rKapcd(mZeta), Q(nZeta,3)
real(kind=wp), intent(out) :: Wrk(nWork2), HMtrx(nHrrMtrx,2)
integer(kind=iwp), intent(out) :: i_Int
integer(kind=iwp) :: iW3, la, lb, lta, ltb, mabcd, mabMax, mabMin, mcdMax, mcdMin, ne, nT
real(kind=wp) :: CoorAC(3,2)
logical(kind=iwp), parameter :: NoSpecial = .true.
procedure(cff2d_kernel) :: Cff2Dq
procedure(modu2_kernel) :: ModU2
procedure(rys2d_kernel) :: xRys2D
procedure(tval_kernel) :: TERISq
logical(kind=iwp), external :: EQ

la = iAnga(1)
lb = iAnga(2)
#ifdef _DEBUGPRINT_
call RecPrt(' In SchInt: CoorM',' ',CoorM,3,4)
call RecPrt(' In SchInt: P',' ',P,nZeta,3)
call RecPrt(' In SchInt: Q',' ',Q,nZeta,3)
write(u6,*) 'iAnga=',iAnga
#endif

! Compute primitive integrals to be used in the prescreening
! by the Schwarz inequality.

! Compute actual size of [a0|c0] block

lta = nTri_Elem1(la)
ltb = nTri_Elem1(lb)
mabMin = nTri3_Elem1(max(la,lb)-1)
if (EQ(CoorM(1,1),CoorM(1,2))) mabMin = nTri3_Elem1(la+lb-1)
mabMax = nTri3_Elem1(la+lb)-1
mcdMin = nTri3_Elem1(max(la,lb)-1)
if (EQ(CoorM(1,3),CoorM(1,4))) mcdMin = nTri3_Elem1(la+lb-1)
mcdMax = mabMax
mabcd = (mabMax-mabMin+1)*(mcdMax-mcdMin+1)

! Find the proper centers to start of with the angular
! momentum on. If la == lb there will exist an
! ambiguity to which center that angular momentum should
! be accumulated on. In that case we will use A and C of
! the order as defined by the basis functions types.

if (iAnga(1) >= iAnga(2)) then
  CoorAC(:,1) = CoorM(:,1)
  CoorAC(:,2) = CoorM(:,3)
else
  CoorAC(:,1) = CoorM(:,2)
  CoorAC(:,2) = CoorM(:,4)
end if

! Compute [a0|c0], ijkl,a,c

nT = mZeta*1
call Rys(iAnga,nT,Zeta,ZInv,mZeta,Zeta,ZInv,mZeta,P,nZeta,Q,nZeta,rKapab,rKapcd,CoorM,CoorM,CoorAC,mabMin,mabMax,mcdMin,mcdMax, &
         Wrk,nWork2,TERISq,ModU2,Cff2Dq,xRys2D,NoSpecial)

#ifdef _DEBUGPRINT_
call RecPrt(' In SchInt: ijkl,[a0|c0]',' ',Wrk,mZeta,mabcd)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate transformation matrix from intermediate integrals
! to final angular composition, observe that since the 2nd order
! particle matrix is transformed from real spherical harmonics
! to cartesians that the prescreening integrals also are in
! cartesians!

ne = (mabMax-mabMin+1)
call HrrMtrx(HMtrx(:,1),ne,la,lb,CoorM(:,1),CoorM(:,2),.false.,RSph(ipSph(la)),lta,.false.,RSph(ipSph(lb)),ltb)
call HrrMtrx(HMtrx(:,2),ne,la,lb,CoorM(:,3),CoorM(:,4),.false.,RSph(ipSph(la)),lta,.false.,RSph(ipSph(lb)),ltb)
!                                                                      *
!***********************************************************************
!                                                                      *
! Apply a transpose prior to Tnsctl to fake the action of Cntrct.

iW3 = 1+mZeta*mabcd
call DGeTMO(Wrk,mZeta,mZeta,mabcd,Wrk(iW3),mabcd)
Wrk(1:mabcd*mZeta) = Wrk(iW3:iW3+mabcd*mZeta-1)
call TnsCtl(Wrk,nWork2,mZeta,mabMax,mabMin,mabMax,mabMin,HMtrx(:,1),HMtrx(:,2),la,lb,la,lb,lta,ltb,lta,ltb,iShlla,jShllb,iShlla, &
            jShllb,i_Int)
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt(' In SchInt',' ',Wrk(i_Int),mZeta,(lta*ltb)**2)
#endif

end subroutine SchInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PT2INI
      USE INPUTDATA
      USE REFWFN
      USE PT2WFN
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "pt2_guga.fh"
#include "WrkSpc.fh"
#include "intgrl.fh"
#include "eqsolv.fh"
#include "chocaspt2.fh"
#include "compiler_features.h"

      INTEGER LuSpool
C     Cholesky
      Integer iSym, iRC

*
* Probe the RunFile for some basic information
*
      Call Get_cArray('Seward Title',Header,144)
      Call Get_iScalar('nSym',nSym)
      Call Get_iArray('nBas',nBas,nSym)
      Call Get_iScalar('Unique atoms',nUniqAt)
      nbast=sum(nbas(1:nsym))
      nbsqt=sum(nbas(1:nsym)**2)
      Call Get_cArray('Unique Basis Names',Name,(LENIN8)*nbast)
      Call DecideOnCholesky(IfChol)
* PAM Feb 2008: The following statement was moved here from
* prpctl, in case prpctl call is bypassed by keyword ''NOPROP''.
      Call Put_cArray('Relax Method','CASPT2  ',8)
*
*     Allocate Input struct, read and process the Input
*
#ifdef ALLOC_SCAL
      ALLOCATE(Input)
#endif
      LuSpool=21
      Call SpoolInp(LuSpool)
      CALL READIN_CASPT2(LuSpool,nSym)
      Call Close_LuSpool(LuSpool)
* Initialize scratch files.
      CALL OPNFLS_CASPT2
* Initialize the reference wavefunction file and read basic info
      Call refwfn_init(Input%FILE)
      Call refwfn_info
* the input processing needs some data from the reference wavefunction
* to be set, hence this phase occurs after reading that data.
      Call ProcInp_Caspt2
*
* Allocate some arrays that will stay globally allocated:
*

* Finally read the MO and CI data from the refwfn file, and close it as
* we have no more need for it and the same filename might be reused for
* the pt2wfn file. We do this after input processing because we need to
* know which roots to pick up. The MOs are stored on LUONEM, at address
* IAD1M(1), and the CI arrays on LUCIEX at IDCIEX.
      Call refwfn_data
      Call refwfn_close

* If necessary, make modifications to the inactive/virtual orbitals. The
* new MOs, if any, will overwrite the originals on LUONEM at IAD1M(1).
      If (Input%modify_correlating_MOs) Then
        Call correlating_orbitals
      End If

* After possible reconfiguration of inactives/virtuals, the computation
* of total sizes of orbital spaces is done here, before any other code
* (that might rely on these to be correctly set!)
      Call wfnsizes

* Create the PT2 wavefunction file (formerly JOBMIX). The reference file
* should not be active, as it might be the same file (in which case it
* is overwritten).
      call pt2wfn_init
      call pt2wfn_data
*
* Global allocations active throughout the program (NOTRI was computed
* during the call to wfnsizes, so this is done here.)
*
* The total fock matrix (sum of inactive and active contrib.)
      NFIFA=NOTRI
      CALL GETMEM('LFIFA','ALLO','REAL',LFIFA,NFIFA)
* The one-electron Hamiltonian
      NHONE=NOTRI
      CALL GETMEM('LHONE','ALLO','REAL',LHONE,NHONE)
* The fock matrix with contributions from inactive orbitals, only.
      NFIMO=NOTRI
      CALL GETMEM('LFIMO','ALLO','REAL',LFIMO,NFIMO)
* The fock matrix with contributions from active orbitals, only.
      NFAMO=NOTRI
      CALL GETMEM('LFAMO','ALLO','REAL',LFAMO,NFAMO)
* Density matrices, active indices.
      CALL GETMEM('LDREF','ALLO','REAL',LDREF,NDREF)
      CALL GETMEM('LPREF','ALLO','REAL',LPREF,NPREF)
* All the density matrices kept in memory
      CALL GETMEM('LDMIX','ALLO','REAL',LDMIX,NDREF*NSTATE)
      CALL GETMEM('LDWGT','ALLO','REAL',LDWGT,NSTATE*NSTATE)

* Print input data
      CALL PRINP_CASPT2

C INITIALIZE SPLIT-GRAPH UGA TABLES.
      CALL POLY0

C Initialize superindex tables. Check memory needs.
      CALL SIZES

C Initialize sizes, offsets etc used in equation solver.
      CALL EQCTL1

      If (IfChol) then
* initialize Cholesky information
        Call Cho_X_init(irc,0.0d0)
        if (irc.ne.0) then
          write(6,*) 'CASPT2: Non-zero rc in Cho_X_init'
          CALL QUIT(irc)
        endif
* import_ch transfers some values from cholesky.fh to chocaspt2.fh
        call import_cho(numcho_pt2,infvec_n2_pt2,maxvec_pt2)
        Call setup_cho(nSym,nIsh,nAsh,nSsh,NumCho_pt2,'Allo')
* get unit numbers for Cholesky MO vectors
        Do iSym=1,nSym
          Call Cho_Caspt2_OpenF(0,1,iSym,nIsplit(iSym))
          Call Cho_Caspt2_OpenF(0,2,iSym,nAsplit(iSym))
        End Do
* set up size info for cholesky vector transformation in tracho2
        call trachosz
      End If

* Allocate global orbital arrays:
      CALL GETMEM('LCMOPT2','ALLO','REAL',LCMOPT2,NCMO)
* Allocate global orbital transformation arrays:
      CALL GETMEM('TORB','ALLO','REAL',LTORB,NTORB)
      CALL GETMEM('TAT','ALLO','REAL',LTAT,NTAT)

      END

      SUBROUTINE PT2CLS
      USE SUPERINDEX
      USE INPUTDATA
      USE PT2WFN
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
#include "ofembed.fh"
#include "eqsolv.fh"
#include "chocaspt2.fh"

      Integer iSym
#ifndef ALLOC_SCAL
      Integer iGrp
#endif
C     Cholesky return code
      INTEGER irc
C     size of idsct array
      INTEGER NIDSCT

      If (IfChol) then
*---  Finalize Cholesky information
         Call Cho_X_Final(irc)
         if (irc.ne.0) then
            write(6,*) 'CASPT2: Non-zero rc in Cho_X_Final'
            CALL QUIT(irc)
         endif
*     Delete files of MO Cholesky vectors.
         Do iSym=1,nSym
            Call Cho_Caspt2_OpenF(3,1,iSym,nIsplit(iSym)) !close+delete
            Call Cho_Caspt2_OpenF(3,2,iSym,nAsplit(iSym)) !close+delete
         End Do
*     Deallocate memory used as index arrays in the setup section
         Call setup_cho(nSym,nIsh,nAsh,nSsh,NumCho_pt2,'Free')
* NOT TESTED
#if 0
         If (Done_OFemb) Then
            Call Free_Work(ipFMaux)
         EndIf
#endif
         ! deallocate chovec_io arrays
         call trachosz_free
      End If

* Deallocate SGUGA tables:
      CALL PCLOSE

C     Deallocate MAGEB, etc, superindex tables:
      CALL SUPFREE
* Deallocate global array for Fock matrix, etc:
      CALL GETMEM('LFIFA','FREE','REAL',LFIFA,NFIFA)
      CALL GETMEM('LHONE','FREE','REAL',LHONE,NHONE)
      CALL GETMEM('LFIMO','FREE','REAL',LFIMO,NFIMO)
      CALL GETMEM('LFAMO','FREE','REAL',LFAMO,NFAMO)
      CALL GETMEM('LDREF','FREE','REAL',LDREF,NDREF)
      CALL GETMEM('LPREF','FREE','REAL',LPREF,NPREF)
      CALL GETMEM('LDMIX','FREE','REAL',LDMIX,NDREF*NSTATE)
      CALL GETMEM('LDWGT','FREE','REAL',LDWGT,NSTATE*NSTATE)
* Deallocate global orbital transformation arrays:
      CALL GETMEM('TORB','FREE','REAL',LTORB,NTORB)
      CALL GETMEM('TAT','FREE','REAL',LTAT,NTAT)
* Deallocate global orbital arrays:
      CALL GETMEM('LCMOPT2','FREE','REAL',LCMOPT2,NCMO)
* Deallocate global RHS disk offsets (allocated in eqctl1):
      NIDSCT=MXSCT*8*MXCASE*MXVEC
      CALL GETMEM('IDSCT','FREE','INTE',LIDSCT,NIDSCT)

      call pt2wfn_close
C     Close all files:
      CALL CLSFLS_CASPT2

C free input struct
#ifdef ALLOC_SCAL
      DEALLOCATE(Input)
#else
      IF (ALLOCATED(Input%MultGroup%State))
     &   DEALLOCATE(Input%MultGroup%State)
      IF (ALLOCATED(Input%nXMulState)) DEALLOCATE(Input%nXMulState)
      IF (ALLOCATED(Input%XMulGroup)) THEN
        DO iGrp = 1, SIZE(Input%XMulGroup)
          IF (ALLOCATED(Input%XMulGroup(iGrp)%State))
     &       DEALLOCATE(Input%XMulGroup(iGrp)%State)
          DEALLOCATE(Input%XMulGroup)
        END DO
      END IF
      IF (ALLOCATED(Input%nFro)) DEALLOCATE(Input%nFro)
      IF (ALLOCATED(Input%nDel)) DEALLOCATE(Input%nDel)
      IF (ALLOCATED(Input%NamFro)) DEALLOCATE(Input%NamFro)
      IF (ALLOCATED(Input%HEff)) DEALLOCATE(Input%HEff)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ShfANM(nInter,nIter,rInt,Shift)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 rInt(nInter,nIter), Shift(nInter,nIter)
*
      If (nIter.eq.1) Return

#ifdef _DEBUGPRINT_
      Call RecPrt(' ShfANM: rInt',' ',rInt,nInter,nIter)
#endif
*
*-----Shifts: dq = q   -q
*               n   n+1  n
*
      Do Iter=1,nIter-1
         call dcopy_(nInter,rInt(1,Iter+1),1,Shift(1,Iter),1)
         Call DaXpY_(nInter,-One,rInt(1,Iter),1,Shift(1,Iter),1)
      End Do

#ifdef _DEBUGPRINT_
      Call RecPrt(' In ShfANM: New Shifts',' ',Shift,nInter,nIter-1)
#endif

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!  mcpdft_init
!
!> @brief
!>   Initialize variables in commons, and set default values.
!>   Determine whether orbital files should be read, etc.
!>
!> @details
!> Sets values in the modules timers, rasscf_global and general_data.
!***********************************************************************

subroutine mcpdft_init()

use Fock_util_global, only: DoCholesky
use Cholesky, only: ChFracMem
use timers, only: TimeAoMo, TimeCIOpt, TimeDavid, TimeDens, TimeFock, TimeHCSCE, TimeHDiag, TimeHSel, TimeInput, TimeOrb, &
                  TimePage, TimeRelax, TimeSigma, TimeTotal, TimeTrans, TimeWfn
use mcpdft_output, only: set_print_level
use general_data, only: ispin, nactel, nash, nbas, ndel, nelec3, nfro, nhole1, nish, nrs1, nrs2, nrs3, nssh, stsym
use rasscf_global, only: DFTFOCK, ExFac, IPT2, iroot, iTRI, iTRIM, iXSym, lROOTS, NonEq, NROOTS, TITLE, weight
use Constants, only: Zero, One
use Definitions, only: iwp
#ifdef _MOLCAS_MPP_
use Definitions, only: wp
#endif

implicit none
integer(kind=iwp) :: i

!----------------------------------------------------------------------*

! Set print levels, and adjust them if needed:
call set_print_level()

! Cholesky-related settings:
call DecideOnCholesky(DoCholesky)

#ifdef _MOLCAS_MPP_
ChFracMem = 0.3_wp
#else
ChFracMem = Zero
#endif

! Default title line:
TITLE(1) = '(No title given)'

! number of roots required in CI
NROOTS = 1
! number of roots actually used in CI-DAVIDSON
LROOTS = 1
! sequence numbers for roots in CI counted from lowest energy.
iRoot = 0
IROOT(1) = 1
! weights used for average energy calculations
WEIGHT = Zero
WEIGHT(1) = One

! Default value for type of CASSCF (used for DFT)
DFTFOCK = 'ROKS'
ExFac = Zero

! default spin value (singlet)
ISPIN = 1
! default symmetry
STSYM = 1
! default number of active electrons
NACTEL = 0
! default maximum number of holes in RAS1
NHOLE1 = 0
! default maximum number of electrons in RAS3
NELEC3 = 0
! This run will not be the start for a CASPT2 calculation
IPT2 = 0

! These keys will activate the calculation of the high
! frequency contribution to the reaction field
! ???
! This key controls if a non-equilibrium reaction field
! calculation is performed.
NonEq = .false.

! set default values for orbitals
nFro(:) = 0
nIsh(:) = 0
nAsh(:) = 0
nRs1(:) = 0
NRS2(:) = 0
NRS3(:) = 0
NSSH(:) = 0
NDEL(:) = 0
NBAS(:) = 0
ixsym(:) = 0

! Auxiliary vector ITRI(I)=I*(I-1)/2
do I=2,ITRIM
  ITRI(I) = ITRI(I-1)+I-1
end do

! Initialize Timing Variables
TimeTotal = Zero
TimeInput = Zero
TimeWfn = Zero
TimeDens = Zero
TimeSigma = Zero
TimeHSel = Zero
TimeHDiag = Zero
TimeFock = Zero
TimeAoMo = Zero
TimeTrans = Zero
TimeCIOpt = Zero
TimeOrb = Zero
TimeDavid = Zero
TimePage = Zero
TimeHCSCE = Zero
TimeRelax = Zero

end subroutine mcpdft_init

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Naoki Nakatani                                   *
************************************************************************
      Subroutine BLOCK_DENSI_RASSCF(jRoot,D,DS,PS,PA,PT)
      Implicit Real*8 (A-H,O-Z)
* Load 2RDM from Block DMRG and compute D, DS, PS, and PA
* Written by N. Nakatani, Oct. 2014
*
* D   : 1-El density matrix
*
* DS  : spin density matrix
*
* PS  : symmetrized 2-El density matrix
*
* PA  : anti-symmetrized 2-El density matrix
*
* PT  : working space for 2-El density matrix (NAC**4)
*
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
*
      Dimension D(NACPAR),DS(NACPAR),PS(NACPR2),PA(NACPR2)
      Dimension PT(NAC,NAC,NAC,NAC)
*
      Call DCOPY_(NACPAR,0.0D0,0,D, 1)
      Call DCOPY_(NACPAR,0.0D0,0,DS,1)
      Call DCOPY_(NACPR2,0.0D0,0,PS,1)
      Call DCOPY_(NACPR2,0.0D0,0,PA,1)
*
      If(NACTEL.GT.1) Then
        Call block_load2pdm(NAC,PT,jRoot,jRoot)
* No spin density is obtained from Spin-adapted DMRG (Block's default)
* TODO: 1-El density matrix should be computed with spin-orbital index
*       to store spin density with Block code...
        IJ_pack=1
        Do J=1,NAC
          Do I=1,J
            D1sum=0.0D0
            Do K=1,NAC
              D1sum=D1sum+PT(K,K,I,J)
            End Do
            D(IJ_pack)=D1sum/(NACTEL-1)
*           DS(IJ_pack)=0.0D0
            IJ_pack=IJ_pack+1
          End Do
        End Do

        IJKL_pack=0
        Do I=1,NAC
          Do J=1,I
            Do K=1,I
              LLIM=K
              If(K.EQ.I)LLIM=J
              DO L=1,LLIM
                IJKL_pack=IJKL_pack+1
                If(K.EQ.L) Then
                  PS(IJKL_pack)=0.5D0*PT(L,K,J,I)
*                 PA(IJKL_pack)=0.0D0
                Else
                  PS(IJKL_pack)=0.5D0*(PT(L,K,J,I)+PT(K,L,J,I))
                  PA(IJKL_pack)=0.5D0*(PT(L,K,J,I)-PT(K,L,J,I))
                End If
              End Do
            End Do
          End Do
        End Do
      Else
* special case for NACTEL = 1
        Call block_load1pdm(NAC,PT,jRoot,jRoot)
        IJ_pack=1
        Do J=1,NAC
          Do I=1,J
            D(IJ_pack)=PT(I,J,1,1)
            IJ_pack=IJ_pack+1
          End Do
        End Do
      End If

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Paul B Calio                                     *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Based on cmsbk.f from Jie J. Bao &&                            *
! Additional work from  rhs_nac                                  *
! ****************************************************************

subroutine Calcbk_CMSNAC(bk,R,nTri,GDMat,zX)

use Index_Functions, only: nTri_Elem
use MCLR_Data, only: nDens, nNA
use input_mclr, only: nRoots, ntAsh
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: bk(nDens)
real(kind=wp), intent(in) :: R(nRoots,nRoots), GDMat(nTri_Elem(nRoots),nnA,nnA), zX(nTri_Elem(nRoots-1))
integer(kind=iwp), intent(inout) :: nTri
integer(kind=iwp) :: nG1, nP2
real(kind=wp), allocatable :: FOccMO(:), P2MOt(:)

ng1 = nTri_Elem(ntash)
nP2 = nTri_Elem(ng1)
call mma_allocate(FOccMO,nDens)
call mma_allocate(P2MOt,nP2)
bk(:) = Zero
call GetWFFock_NAC(FOccMO,bk,R,nTri,P2MOt,nP2)
call GetQaaFock(FOccMO,P2MOt,GDMat,zX,nP2)
call GetPDFTFock_NAC(bk)
call PutCMSFockOcc(FOccMO,nTri)

call mma_deallocate(FOccMO)
call mma_deallocate(P2MOt)

end subroutine Calcbk_CMSNAC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010,2011, Thomas Bondo Pedersen                       *
************************************************************************
      Subroutine LDF_ComputeC(iAtomPair,ip_C,l_C,ip_Z,l_Z,irc)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Input:
C        iAtomPair - index of atom pair in atom pair list
C        ip_C, l_C - pointer and dimension of array
C                    containing CBar on entry and C on exit
C        ip_Z, l_Z - pointer and dimension of array containing Z
C
C     Output:
C        irc - return code
C
C     Return codes:
C        irc=-1: input error
C        irc=0:  all is fine
C        irc=1:  internal error
C
C     Purpose:
C
C     Compute
C
C     C[uv,J] = { CBar[uv,J] - sum(I=J+1,M) C[uv,I]*Z[I,J] }/Z[J,J]
C
C     where CBar is contained in C on entry. (For Z vectors, see
C     LDF_ComputeCBar.)
C
C     If any of the columns of C has norm less than 1.0d-16, the column
C     and corresponding auxiliary basis function will be removed.
C
      Implicit None
      Integer iAtomPair
      Integer ip_C, l_C
      Integer ip_Z, l_Z
      Integer irc
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      Character*12 SecNam
      Parameter (SecNam='LDF_ComputeC')
#endif

      Real*8 Small
      Parameter (Small=1.0d-24)

      Integer  LDF_nBasAux_Pair, LDF_nBas_Atom
      External LDF_nBasAux_Pair, LDF_nBas_Atom

      Integer nuv
      Integer M

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Init return code
      irc=0
#if defined (_DEBUGPRINT_)
      If (iAtomPair.lt.1 .or. iAtomPair.gt.NumberOfAtomPairs) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': iAtomPair out of bounds:',iAtomPair
         irc=-1
         Return
      End If
#endif

      ! Get number of AO products
      nuv=LDF_nBas_Atom(AP_Atoms(1,iAtomPair))
     &   *LDF_nBas_Atom(AP_Atoms(2,iAtomPair))

      ! Get number of auxiliary functions
      M=LDF_nBasAux_Pair(iAtomPair)

#if defined (_DEBUGPRINT_)
      If (l_C.ne.nuv*M .or. l_Z.ne.M*(M+1)/2) Then
         Write(6,'(A,A)') SecNam,': array dimension error'
         Write(6,'(A,2I10)') 'l_C,nuv*M:',l_C,nuv*M
         Write(6,'(A,2I10)') 'l_Z,M*(M+1)/2:',l_Z,M*(M+1)/2
         irc=-1
         Return
      End If
#endif

      ! Compute C
      Call LDF_ComputeC_(Work(ip_C),Work(ip_Z),nuv,M,irc)

      ! Clean rows corresponding to 2C functions, i.e.
      ! C(uv,J)=delta(uv,J) where J is a 2C function
      Call LDF_CleanC(iAtomPair,Work(ip_C),nuv,M)

      ! Remove columns with norm <=Small, and update lindep/2CFun info
      ! accordingly.
      Call LDF_RemoveColumnsOfC(iAtomPair,Work(ip_C),nuv,M,Small)

#ifndef _DEBUGPRINT_
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(l_C)
         Call Unused_integer(l_Z)
      End If
#endif
      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_ComputeC_(C,Z,nuv,M,irc)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Compute C (see LDF_ComputeC)
C
      Implicit None
      Integer nuv, M
      Real*8  C(nuv,M)
      Real*8  Z(*)
      Integer irc

      Real*8 ZJJ_inv
#if defined (_DEBUGPRINT_)
      Real*8 TooSmall
      Parameter (TooSmall=1.0d-20)
#endif

      Integer i, j
      Integer iTri
      iTri(i,j)=i*(i-1)/2+j

      irc=0
#if defined (_DEBUGPRINT_)
      Do J=1,M
         If (Z(iTri(J,J)).lt.TooSmall) Then
            irc=irc+1
         End If
      End Do
      If (irc.gt.0) Then
         Write(6,'(I9,A,I9,A,1P,D16.6)')
     &   irc,' of',M,' Z diagonals are smaller than',TooSmall
         irc=1
         Return
      End If
#endif

      Do J=M,1,-1
         ZJJ_inv=1.0d0/Z(iTri(J,J))
         Call dScal_(nuv,ZJJ_inv,C(1,J),1)
         Do I=J-1,1,-1
            Call dAXPY_(nuv,-Z(iTri(J,I)),C(1,J),1,C(1,I),1)
         End Do
      End Do

      End
************************************************************************
************************************************************************
************************************************************************
      Subroutine LDF_RemoveColumnsOfC(iAtomPair,C,nuv,M,Thr)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Purpose: Remove columns (and corresponding auxiliary functions)
C     with 2-norm less than Thr.
C
      Implicit None
      Integer iAtomPair
      Integer nuv, M
      Real*8  C(nuv,M)
      Real*8  Thr
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "localdf_bas.fh"
#include "localdf_int.fh"

      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      Integer  LDF_nShell_Atom, LDF_nBasSh_Atom
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nShell_Atom, LDF_nBasSh_Atom

      Character*8 Label

      Integer ip_TOC, l_TOC, ip, MM
      Integer I, J, K, l
      Integer iAtom, jAtom
      Integer iS, jS, iShell, jShell
      Integer ip0, n1CLinDep, n2CFunctions
      Integer nShell_i, ij, ijS
      Integer i2CF

      real*8 ddot_
      external ddot_

      Integer nBasSh
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      Integer IndxG
      Integer IndxG2
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      IndxG(i,j)=iWork(ip_IndxG-1+l_IndxG_1*(j-1)+i)
      IndxG2(i,j)=iWork(ip_IndxG2-1+l_IndxG2_1*(j-1)+i)

      l_TOC=M
      Call GetMem('RCCTOC','Allo','Inte',ip_TOC,l_TOC)

      MM=0
      ip=ip_TOC-1
      Do I=1,M
         If (sqrt(dDot_(nuv,C(1,I),1,C(1,I),1)).gt.Thr) Then
            MM=MM+1
            iWork(ip+I)=MM
         Else
            iWork(ip+I)=0
         End If
      End Do

      If (MM.lt.M) Then
         Do I=1,M
            J=iWork(ip+I)
            If (J.gt.0 .and. J.lt.I) Then
               Call dCopy_(nuv,C(1,I),1,C(1,J),1)
            End If
         End Do
         !Call FZero(C(1,MM+1),nuv*(M-MM))
         Call LDF_SetIndxG(iAtomPair)
         iAtom=AP_Atoms(1,iAtomPair)
         jAtom=AP_Atoms(2,iAtomPair)
         n1CLinDep=AP_1CLinDep(1,iAtomPair)
         ip0=LDF_lAuxShell_Atom(iAtom)-1
         Do iS=1,LDF_nAuxShell_Atom(iAtom)
            iShell=iWork(ip0+iS)
            Do i=1,nBasSh(iShell)
               J=IndxG(i,iShell)
               If (J.gt.0) Then
                  If (iWork(ip+J).eq.0) Then
                     n1CLinDep=n1CLinDep+1
                  End If
               End If
            End Do
         End Do
         If (jAtom.ne.iAtom) Then
            ip0=LDF_lAuxShell_Atom(jAtom)-1
            Do jS=1,LDF_nAuxShell_Atom(jAtom)
               jShell=iWork(ip0+jS)
               Do i=1,nBasSh(jShell)
                  J=IndxG(i,jShell)
                  If (J.gt.0) Then
                     If (iWork(ip+J).eq.0) Then
                        n1CLinDep=n1CLinDep+1
                     End If
                  End If
               End Do
            End Do
         End If
         If (n1CLinDep.gt.0) Then
            Write(Label,'(A,I5.5)') '1CL',iAtomPair-1
            l=3*AP_1CLinDep(1,iAtomPair)
            If (l.gt.0) Then
               ip=AP_1CLinDep(2,iAtomPair)
               Call GetMem(Label,'Free','Inte',ip,l)
            End If
            l=3*n1CLinDep
            Call GetMem(Label,'Allo','Inte',ip,l)
            iWork(ip_AP_1CLinDep+2*(iAtomPair-1))=n1CLinDep
            iWork(ip_AP_1CLinDep+2*(iAtomPair-1)+1)=ip
            ip0=LDF_lAuxShell_Atom(iAtom)-1
            n1CLinDep=0
            Do iS=1,LDF_nAuxShell_Atom(iAtom)
               iShell=iWork(ip0+iS)
               Do i=1,nBasSh(iShell)
                  J=IndxG(i,iShell)
                  If (J.gt.0) Then
                     If (iWork(ip_TOC-1+J).eq.0) Then
                        iWork(ip+3*n1CLinDep)=iAtom
                        iWork(ip+3*n1CLinDep+1)=iS
                        iWork(ip+3*n1CLinDep+2)=i
                        n1CLinDep=n1CLinDep+1
                     End If
                  Else
                     iWork(ip+3*n1CLinDep)=iAtom
                     iWork(ip+3*n1CLinDep+1)=iS
                     iWork(ip+3*n1CLinDep+2)=i
                     n1CLinDep=n1CLinDep+1
                  End If
               End Do
            End Do
            If (jAtom.ne.iAtom) Then
               ip0=LDF_lAuxShell_Atom(jAtom)-1
               Do jS=1,LDF_nAuxShell_Atom(jAtom)
                  jShell=iWork(ip0+jS)
                  Do i=1,nBasSh(jShell)
                     J=IndxG(i,jShell)
                     If (J.gt.0) Then
                        If (iWork(ip_TOC-1+J).eq.0) Then
                           iWork(ip+3*n1CLinDep)=jAtom
                           iWork(ip+3*n1CLinDep+1)=jS
                           iWork(ip+3*n1CLinDep+2)=i
                           n1CLinDep=n1CLinDep+1
                        End If
                     Else
                        iWork(ip+3*n1CLinDep)=jAtom
                        iWork(ip+3*n1CLinDep+1)=jS
                        iWork(ip+3*n1CLinDep+2)=i
                        n1CLinDep=n1CLinDep+1
                     End If
                  End Do
               End Do
            End If
         End If
         If (AP_2CFunctions(1,iAtomPair).gt.0) Then
            n2CFunctions=0
            nShell_i=LDF_nShell_Atom(iAtom)
            ip0=AP_2CFunctions(2,iAtomPair)-1
            Do i2CF=0,AP_2CFunctions(1,iAtomPair)-1
               ip=ip0+4*i2CF
               iS=iWork(ip+1)
               i=iWork(ip+2)
               jS=iWork(ip+3)
               j=iWork(ip+4)
               ijS=nShell_i*(jS-1)+iS
               ij=LDF_nBasSh_Atom(iS,iAtom)*(j-1)+i
               K=IndxG2(ij,ijS)
               If (K.gt.0) Then
                  If (iWork(ip_TOC-1+K).gt.0) Then
                     n2CFunctions=n2CFunctions+1
                  End If
               End If
            End Do
            If (n2CFunctions.lt.AP_2CFunctions(1,iAtomPair)) Then
               Write(Label,'(A,I5.5)') '2CF',iAtomPair-1
               If (n2CFunctions.eq.0) Then
                  k=4*AP_2CFunctions(1,iAtomPair)
                  ip0=AP_2CFunctions(2,iAtomPair)
                  Call GetMem(Label,'Free','Inte',ip0,k)
                  iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=0
                  iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=0
               Else
                  l=4*n2CFunctions
                  Call GetMem(Label,'Allo','Inte',ip,l)
                  nShell_i=LDF_nShell_Atom(iAtom)
                  ip0=AP_2CFunctions(2,iAtomPair)-1
                  n2CFunctions=0
                  Do i2CF=0,AP_2CFunctions(1,iAtomPair)-1
                     iS=iWork(ip0+4*i2CF+1)
                     i=iWork(ip0+4*i2CF+2)
                     jS=iWork(ip0+4*i2CF+3)
                     j=iWork(ip0+4*i2CF+4)
                     ijS=nShell_i*(jS-1)+iS
                     ij=LDF_nBasSh_Atom(iS,iAtom)*(j-1)+i
                     K=IndxG2(ij,ijS)
                     If (K.gt.0) Then
                        If (iWork(ip_TOC-1+K).gt.0) Then
                           iWork(ip+4*n2CFunctions)=iS
                           iWork(ip+4*n2CFunctions+1)=i
                           iWork(ip+4*n2CFunctions+2)=jS
                           iWork(ip+4*n2CFunctions+3)=j
                           n2CFunctions=n2CFunctions+1
                        End If
                     End If
                  End Do
                  k=4*AP_2CFunctions(1,iAtomPair)
                  ip0=AP_2CFunctions(2,iAtomPair)
                  Call GetMem(Label,'Free','Inte',ip0,k)
                  iWork(ip_AP_2CFunctions+2*(iAtomPair-1))=n2CFunctions
                  iWork(ip_AP_2CFunctions+2*(iAtomPair-1)+1)=ip
               End If
            End If
         End If
         Call LDF_UnsetIndxG()
      End If

      Call GetMem('RCCTOC','Free','Inte',ip_TOC,l_TOC)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_CleanC(AB,C,nuv,M)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: clean C such that C(uv,J)=delta(uv,J) for 2C functions J.
C              This is only approximately true without this clean-up.
C
      Implicit None
      Integer AB
      Integer nuv, M
      Real*8  C(nuv,M)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

#if defined (_DEBUGPRINT_)
      Character*10 SecNam
      Parameter (SecNam='LDF_CleanC')
#endif

      Integer  LDF_nBasAux_Atom
      External LDF_nBasAux_Atom

      Integer ip_Map, l_Map
      Integer A, B
      Integer M1
      Integer i2C, j2C
      Integer nRow, nCol

      Integer i, j
      Integer Map
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      Map(i,j)=iWork(ip_Map-1+AP_2CFunctions(1,AB)*(j-1)+i)

      If (AP_2CFunctions(1,AB).lt.1) Return ! nothing to do
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      nRow=AP_2CFunctions(1,AB)
      If (A.eq.B) Then
         nCol=2
      Else
         nCol=1
      End If
      l_Map=nRow*nCol
      Call GetMem('2CMap','Allo','Inte',ip_Map,l_Map)
      Call LDF_Map2CF(AB,nRow,nCol,iWork(ip_Map))
      M1=LDF_nBasAux_Atom(A)
      If (B.ne.A) Then
         M1=M1+LDF_nBasAux_Atom(B)
      End If
      M1=M1-AP_1CLinDep(1,AB)
#if defined (_DEBUGPRINT_)
      If ((M1+AP_2CFunctions(1,AB)).gt.M) Then
         Call WarningMessage(2,SecNam//': M1+M2 != M')
         Call LDF_Quit(1)
      End If
#endif
      Do J=1,M1
         Do i2C=1,AP_2CFunctions(1,AB)
            C(Map(i2C,1),J)=0.0d0
         End Do
      End Do
      Do j2C=1,AP_2CFunctions(1,AB)
         J=M1+j2C
         Do i2C=1,j2C-1
            C(Map(i2C,1),J)=0.0d0
         End Do
         C(Map(j2C,1),J)=1.0d0
         Do i2C=j2C+1,AP_2CFunctions(1,AB)
            C(Map(i2C,1),J)=0.0d0
         End Do
      End Do
      If (A.eq.B) Then
         Do J=1,M1
            Do i2C=1,AP_2CFunctions(1,AB)
               C(Map(i2C,2),J)=0.0d0
            End Do
         End Do
         Do j2C=1,AP_2CFunctions(1,AB)
            J=M1+j2C
            Do i2C=1,j2C-1
               C(Map(i2C,2),J)=0.0d0
            End Do
            C(Map(j2C,1),J)=1.0d0
            Do i2C=j2C+1,AP_2CFunctions(1,AB)
               C(Map(i2C,2),J)=0.0d0
            End Do
         End Do
      End If
      Call GetMem('2CMap','Free','Inte',ip_Map,l_Map)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_CALCINT_1(ISHLAB)
C
C     Purpose: calculate qualified integral columns from
C              shell pair distribution (**|ISHLA ISHLB).
C
C     Version 1: store full shell quadruple.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*17 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_CALCINT_1')

      LOGICAL   DOINTS, LOCDBG
      PARAMETER (LOCDBG = .FALSE.)
      PARAMETER (INFINT = INF_INT, INFIN2 = INF_IN2)

      INTEGER NAB(8)

      IIBSTRSH(I,J,K)=IWORK(ip_IIBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      NNBSTRSH(I,J,K)=IWORK(ip_NNBSTRSH-1+NSYM*NNSHL*(K-1)+NSYM*(J-1)+I)
      INDRED(I,J)=IWORK(ip_INDRED-1+MMBSTRT*(J-1)+I)
      IQUAB(I,J)=IWORK(ip_IQUAB-1+MAXQUAL*(J-1)+I)
      NBSTSH(I)=IWORK(ip_NBSTSH-1+I)
      ISP2F(I)=IWORK(ip_iSP2F-1+I)

#if defined (_DEBUGPRINT_)
      CALL GETMEM('INT.LEAK','MAX ','REAL',KLEAK,LLEAK)
      MEM_START = LLEAK
#endif

C     Initializations.
C     ----------------

      CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.TRUE.)

      NAB(1) = NQUAL(1) - IOFFQ(1)
      DO ISYM = 2,NSYM
         NAB(ISYM) = NQUAL(ISYM) - IOFFQ(ISYM)
      END DO

      IOFF_COL(1) = 0
      LCOL = NNBSTR(1,2)*NAB(1)
      DO ISYM = 2,NSYM
         IOFF_COL(ISYM) = LCOL
         LCOL = LCOL + NNBSTR(ISYM,2)*NAB(ISYM)
      END DO

      IF (ISHLA .EQ. ISHLB) THEN
         NUMAB = NBSTSH(ISHLA)*(NBSTSH(ISHLA) + 1)/2
      ELSE
         NUMAB = NBSTSH(ISHLA)*NBSTSH(ISHLB)
      END IF
      MAXCD = 0
      DO ISHLCD = 1,NNSHL
         ISYM   = 1
         DOINTS = (NAB(ISYM).GT.0) .AND.
     &            (NNBSTRSH(ISYM,ISHLCD,2).GT.0)
         DO WHILE ((ISYM.LT.NSYM) .AND. (.NOT.DOINTS))
            ISYM   = ISYM + 1
            DOINTS = (NAB(ISYM).GT.0) .AND.
     &               (NNBSTRSH(ISYM,ISHLCD,2).GT.0)
         END DO
         IF (DOINTS) THEN
            CALL CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.TRUE.)
            IF (ISHLC .EQ. ISHLD) THEN
               NUMCD = NBSTSH(ISHLC)*(NBSTSH(ISHLC) + 1)/2
            ELSE
               NUMCD = NBSTSH(ISHLC)*NBSTSH(ISHLD)
            END IF
            MAXCD = MAX(MAXCD,NUMCD)
         END IF
      END DO
      L4SHMX = MAXCD*NUMAB

      XXSHL = DBLE(NNSHL)
      XSKIP = 0.0D0

      IF (IPRINT .GE. INFINT) WRITE(LUPRI,*)

C     Allocate memory and initialize:
C     qualified columns in reduced set,
C     max. shell quadruple.
C     ---------------------------------

      CALL GETMEM('INT.4sh','ALLO','REAL',K4SH,L4SHMX)
      CALL GETMEM('INT.col','ALLO','REAL',KCOL,LCOL)
      CALL CHO_DZERO(WORK(KCOL),LCOL)

C     Set memory used by seward.
C     --------------------------

      CALL GETMEM('INT.MAX','MAX ','REAL',KINT,LINT)
      CALL XSETMEM_INTS(LINT)

C     Loop over shell quadruples.
C     ---------------------------

      DO ISHLCD = 1,NNSHL

C        Set left shell pair index.
C        --------------------------

         CALL CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.TRUE.)
         IF (ISHLC .EQ. ISHLD) THEN
            NUMCD = NBSTSH(ISHLC)*(NBSTSH(ISHLC) + 1)/2
         ELSE
            NUMCD = NBSTSH(ISHLC)*NBSTSH(ISHLD)
         END IF

C        Find out if this shell pair (CD) contributes to
C        current reduced set.
C        -----------------------------------------------

         ISYM   = 1
         DOINTS = (NAB(ISYM).GT.0) .AND.
     &            (NNBSTRSH(ISYM,ISHLCD,2).GT.0)
         DO WHILE ((ISYM.LT.NSYM) .AND. (.NOT.DOINTS))
            ISYM   = ISYM + 1
            DOINTS = (NAB(ISYM).GT.0) .AND.
     &               (NNBSTRSH(ISYM,ISHLCD,2).GT.0)
         END DO

         IF (DOINTS) THEN

C           Print message.
C           --------------

            IF (IPRINT .GE. INFINT) THEN
                WRITE(LUPRI,'(A,I5,1X,I5,A,I5,1X,I5,A)')
     &          'Invoking Seward for shell quadruple (',ISHLC,ISHLD,
     &          '|',ISHLA,ISHLB,')'
            END IF

C           Calculate integrals.
C           --------------------

            CALL CHO_TIMER(C1,W1)
            L4SH = NUMCD*NUMAB
            CALL CHO_DZERO(WORK(K4SH),L4SH)
            CALL CHO_MCA_INT_1(ISHLCD,ISHLAB,
     &                         WORK(K4SH),L4SH,
     &                         LOCDBG.OR.(IPRINT.GE.100))
            CALL CHO_TIMER(C2,W2)
            TINTEG(1,1) = TINTEG(1,1) + C2 - C1
            TINTEG(2,1) = TINTEG(2,1) + W2 - W1

C           Extract columns in reduced set.
C           IAB: index AB within full shell pair.
C           JAB: index AB within current reduced set.
C           KAB: index AB within qualifieds.
C           -----------------------------------------

            DO ISYM = 1,NSYM
               DO KAB = 1,NAB(ISYM)

                  JAB = IQUAB(IOFFQ(ISYM)+KAB,ISYM)
                  IAB = INDRED(INDRED(JAB,2),1)

                  DO JCD0 = 1,NNBSTRSH(ISYM,ISHLCD,2)

                     JCDS = IIBSTRSH(ISYM,ISHLCD,2) + JCD0
                     JCD  = IIBSTR(ISYM,2) + JCDS
                     ICD  = INDRED(INDRED(JCD,2),1)

                     KOFF1 = KCOL + IOFF_COL(ISYM)
     &                     + NNBSTR(ISYM,2)*(KAB - 1) + JCDS - 1
                     KOFF2 = K4SH + NUMCD*(IAB - 1) + ICD - 1

                     WORK(KOFF1) = WORK(KOFF2)

                  END DO

               END DO
            END DO

         ELSE

C           Update skip counter.
C           --------------------

            XSKIP = XSKIP + 1.0D0

C           Print message.
C           --------------

            IF (IPRINT .GE. INFINT) THEN
                WRITE(LUPRI,'(A,I5,1X,I5,A,I5,1X,I5,A)')
     &          'NOTICE: skipping shell quadruple    (',ISHLC,ISHLD,
     &          '|',ISHLA,ISHLB,')'
            END IF

         END IF

      END DO

C     Write the columns to disk.
C     --------------------------

      CALL CHO_TIMER(C1,W1)
      DO ISYM = 1,NSYM
         LTOT = NNBSTR(ISYM,2)*NAB(ISYM)
         IF (LTOT .GT. 0) THEN
            IOPT = 1
            KOFF = KCOL + IOFF_COL(ISYM)
            IADR = NNBSTR(ISYM,2)*IOFFQ(ISYM)
            CALL DDAFILE(LUSEL(ISYM),IOPT,WORK(KOFF),LTOT,IADR)
         END IF
      END DO
      CALL CHO_TIMER(C2,W2)
      TINTEG(1,2) = TINTEG(1,2) + C2 - C1
      TINTEG(2,2) = TINTEG(2,2) + W2 - W1

C     Free memory: both memory used by seward and used here.
C     ------------------------------------------------------

      CALL XRLSMEM_INTS
      CALL GETMEM('INT.col','FREE','REAL',KCOL,LCOL)
      CALL GETMEM('INT.4sh','FREE','REAL',K4SH,L4SHMX)

C     Print skip statistics.
C     ----------------------

      IF (IPRINT .GE. INFIN2) THEN
         PCT = 1.0D2*XSKIP/XXSHL
         WRITE(LUPRI,'(A,F7.2,A)')
     &   'Skipped',PCT,'% of rows (shell pairs) in this distribution'
      END IF

#if defined (_DEBUGPRINT_)
      CALL GETMEM('INT.LEAK','MAX ','REAL',KLEAK,LLEAK)
      MEM_END = LLEAK
      LEAK = MEM_END - MEM_START
      IF (LEAK .NE. 0) THEN
         WRITE(LUPRI,'(//,A,A,I9)')
     &   SECNAM,': Memory leak:',LEAK
         CALL CHO_QUIT('Memory leak detected in '//SECNAM,104)
      END IF
#endif

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
*               Thomas Bondo Pedersen                                  *
************************************************************************
      SubRoutine UpdateB(Col,nOrb2Loc,ipLbl,nComp,Gamma_rot,iMO_s,iMO_t,
     &                   Debug)
C
C     Author: T.B. Pedersen
C
C     Purpose: update MO dipole matrices for Boys localisation.
C              (Almost exact copy of UpdateP by Y. Carissan.)
C
      Implicit Real*8 (a-h,o-z)
      Real*8  Col(nOrb2Loc,2)
      Integer ipLbl(nComp)
      Logical Debug
#include "WrkSpc.fh"

      Character*18 Label

      cosg   = cos(Gamma_rot)
      sing   = sin(Gamma_rot)
      cos2g  = cosg*cosg
      sin2g  = sing*sing
      cosing = cosg*sing

      Do iComp = 1,nComp

         ip  = ipLbl(iComp)
         ip0 = ip - 1

         kOff_s = ip0 + nOrb2Loc*(iMO_s-1)
         kOff_t = ip0 + nOrb2Loc*(iMO_t-1)
         kOff_ss = kOff_s + iMO_s
         kOff_ts = kOff_s + iMO_t
         kOff_st = kOff_t + iMO_s
         kOff_tt = kOff_t + iMO_t
         Dss = Work(kOff_ss)
         Dst = Work(kOff_st)
         Dtt = Work(kOff_tt)
#if defined (_DEBUGPRINT_)
         Dts = Work(kOff_ts)
         Tst = Dst - Dts
         If (abs(Tst) .gt. 1.0d-14) Then
            Write(6,*) 'Broken symmetry in UpdateB!!'
            Write(6,*) 'MOs s and t: ',iMO_s,iMO_t
            Write(6,*) 'Component  : ',iComp
            Write(6,*) 'Dst  = ',Dst
            Write(6,*) 'Dts  = ',Dts
            Write(6,*) 'Diff = ',Tst
            Call SysAbendMsg('UpdateB','Broken symmetry!','[1]')
         End If
#endif

         Call dCopy_(nOrb2Loc,Work(kOff_s+1),1,Col(1,1),1)
         Call dCopy_(nOrb2Loc,Work(kOff_t+1),1,Col(1,2),1)

         Call dScal_(nOrb2Loc,cosg,Work(kOff_s+1),1)
         Call dAXPY_(nOrb2Loc,sing,Col(1,2),1,Work(kOff_s+1),1)
         Call dScal_(nOrb2Loc,cosg,Work(kOff_t+1),1)
         Call dAXPY_(nOrb2Loc,-sing,Col(1,1),1,Work(kOff_t+1),1)

         Work(kOff_s+iMO_s) = Dss*cos2g + Dtt*sin2g
     &                      + 2.0d0*Dst*cosing
         Work(kOff_s+iMO_t) = (Dtt-Dss)*cosing + Dst*(cos2g-sin2g)
         Work(kOff_t+iMO_s) = Work(kOff_s+iMO_t)
         Work(kOff_t+iMO_t) = Dtt*cos2g + Dss*sin2g
     &                      - 2.0d0*Dst*cosing

         Call dCopy_(nOrb2Loc,Work(kOff_s+1),1,Work(ip0+iMO_s),nOrb2Loc)
         Call dCopy_(nOrb2Loc,Work(kOff_t+1),1,Work(ip0+iMO_t),nOrb2Loc)

#if defined (_DEBUGPRINT_)
         Dst = Work(kOff_st)
         Dts = Work(kOff_ts)
         Tst = Dst - Dts
         If (abs(Tst) .gt. 1.0d-14) Then
            Write(6,*) 'Broken symmetry in UpdateB!!'
            Write(6,*) 'MOs s and t: ',iMO_s,iMO_t
            Write(6,*) 'Component  : ',iComp
            Write(6,*) 'Dst  = ',Dst
            Write(6,*) 'Dts  = ',Dts
            Write(6,*) 'Diff = ',Tst
            Call SysAbendMsg('UpdateB','Broken symmetry!','[2]')
         End If
#endif

      End Do

      If (Debug) Then
         Write(6,*) 'In UpdateB'
         Write(6,*) '----------'
         Do iComp = 1,nComp
            Write(Label,'(A,I2,A,I4)') 'MO Dip',iComp,'   col',iMO_s
            ip = ipLbl(iComp) + nOrb2Loc*(iMO_s-1)
            Call RecPrt(Label,' ',Work(ip),nOrb2Loc,1)
            Write(Label,'(A,I2,A,I4)') 'MO Dip',iComp,'   col',iMO_t
            ip = ipLbl(iComp) + nOrb2Loc*(iMO_t-1)
            Call RecPrt(Label,' ',Work(ip),nOrb2Loc,1)
         End Do
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      Subroutine Rd2Int_SCF
************************************************************************
*                                                                      *
*     purpose: Read basis set informations from two-electron file      *
*              and compare them with those read from 2-el. file        *
*                                                                      *
*     called from: ReadIn                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*

#include "mxdm.fh"
#include "infscf.fh"
*
*---- Define local variables
      Dimension nBasX(MxSym)
      Logical SqI2

      iRc=-1
      Call GetOrd(iRc,SqI2,nSymX,nBasX,nSkip)
      If (iRc.ne.0) Then
         Write (6,*) 'The program failed to read the header of ORDINT.'
         Call Abend
      End If
*
      If (nSymX.ne.nSym) Then
         Write (6,*) 'nSymX.ne.nSym, nSymX, nSym=',nSymX,nSym
         Call Abend
      End If
      Do iSym = 1, nSym
         If (nBas(iSym).ne.nBasX(iSym)) Then
            Write (6,*) 'nBas(iSym).ne.nBasX(iSym)'
            Write (6,*) 'nBas=',nBas
            Write (6,*) 'nBasX=',nBasX
            Call Abend
         End If
      End Do

      End subroutine Rd2Int_SCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine makecivecp_cvb(civec,civecp,orbs)
! Construct CIVECP:

use casvb_global, only: gjorb_type, icnt_ci, memplenty, ndet, norb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: civec(0:ndet), civecp(0:ndet)
real(kind=wp), intent(in) :: orbs(norb,norb)
integer(kind=iwp) :: icivecp
type(gjorb_type) :: gjorb
real(kind=wp), allocatable :: owrk(:,:)

icivecp = nint(civecp(0))
if (icnt_ci(icivecp) == 3) return

call mma_allocate(owrk,norb,norb,label='owrk')
call mma_allocate(gjorb%r,norb,norb,label='gjorb%r')
call mma_allocate(gjorb%i1,norb,label='gjorb%i1')
call mma_allocate(gjorb%i2,2,norb*norb,label='gjorb%i2')
call trnsps(norb,norb,orbs,owrk)
call gaussj_cvb(owrk,gjorb)
if (memplenty) then
  call getci_cvb(civec)
  call cicopy_cvb(civec,civecp)
else
  call cird_cvb(civecp,61001.2_wp)
end if
call applyt_cvb(civecp,gjorb)
call mma_deallocate(owrk)
call mma_deallocate(gjorb%r)
call mma_deallocate(gjorb%i1)
call mma_deallocate(gjorb%i2)

icnt_ci(icivecp) = 3

return

end subroutine makecivecp_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine JITO_Exchange_Int(MxR1,MxR2,imaxrank,n1,n2,JR,JI,HAM)
! this Subroutine calculates the anisotropic exchange interaction between
! two sites, of the one interacting pair on the basis of input ITO parameters

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: MxR1, MxR2, imaxrank(2), n1, n2
real(kind=wp), intent(in) :: JR(MxR1,-MxR1:MxR1,MxR2,-MxR2:MxR2), JI(MxR1,-MxR1:MxR1,MxR2,-MxR2:MxR2)
complex(kind=wp), intent(out) :: HAM(n1,n1,n2,n2)
integer(kind=iwp) :: ibuf, k1, k2, l1, l2, q1, q2
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: m1, m2
#endif
real(kind=wp) :: C01, C02, jpar
complex(kind=wp), allocatable :: J(:,:,:,:), O1(:,:), O2(:,:), OO(:,:,:,:), OW(:,:,:,:), W1(:,:), W2(:,:), WO(:,:,:,:), WW(:,:,:,:)
real(kind=wp), external :: dnrm2_

! ----  initial checks
if ((n1 <= 0) .or. (n2 <= 0)) return
HAM(:,:,:,:) = cZero
ibuf = MxR1*(2*MxR1+1)*MxR2*(2*MxR2+1)
if (ibuf == 0) return
jpar = dnrm2_(ibuf,JR,1)+dnrm2_(ibuf,JI,1)
if (jpar == Zero) return
! ---- end initial checks
call mma_allocate(J,[1,MxR1],[-MxR1,MxR1],[1,MxR2],[-MxR2,MxR2],label='J')
J(:,:,:,:) = cZero
do k1=1,MxR1,2
  do k2=1,MxR2,2
    J(k1,:,k2,:) = cmplx(JR(k1,:,k2,:),JI(k1,:,k2,:),kind=wp)
  end do
end do
!-----------------------------------------------------------------------
call mma_allocate(O1,n1,n1,'operator O1')
call mma_allocate(W1,n1,n1,'operator W1')
call mma_allocate(O2,n2,n2,'operator O2')
call mma_allocate(W2,n2,n2,'operator W2')
call mma_allocate(OO,n1,n1,n2,n2,'operator OO')
call mma_allocate(OW,n1,n1,n2,n2,'operator WO')
call mma_allocate(WO,n1,n1,n2,n2,'operator OW')
call mma_allocate(WW,n1,n1,n2,n2,'operator WW')
!-----------------------------------------------------------------------
do k1=1,imaxrank(1),2
  do q1=0,k1
    do k2=1,imaxrank(2),2
      do q2=0,k2
        ! generate the operator matrix K=ik, Q=iq, dimension=na
        call ITO(n1,k1,q1,C01,O1,W1)
        call ITO(n2,k2,q2,C02,O2,W2)
        ! generate coupled operators:
        do l1=1,n2
          do l2=1,n2
            OO(:,:,l1,l2) = O1(:,:)*O2(l1,l2)
            OW(:,:,l1,l2) = O1(:,:)*W2(l1,l2)
            WO(:,:,l1,l2) = W1(:,:)*O2(l1,l2)
            WW(:,:,l1,l2) = W1(:,:)*W2(l1,l2)
          end do
        end do
        ! compute the exchange Hamiltonian:
        if ((q1 == 0) .and. (q2 == 0)) then
          HAM(:,:,:,:) = HAM(:,:,:,:)+J(k1,0,k2,0)*OO(:,:,:,:)
        else if ((q1 == 0) .and. (q2 /= 0)) then
          HAM(:,:,:,:) = HAM(:,:,:,:)+J(k1,0,k2,q2)*OO(:,:,:,:)+J(k1,0,k2,-q2)*OW(:,:,:,:)
        else if ((q1 /= 0) .and. (q2 == 0)) then
          HAM(:,:,:,:) = HAM(:,:,:,:)+J(k1,q1,k2,0)*OO(:,:,:,:)+J(k1,-q1,k2,0)*WO(:,:,:,:)
        else if ((q1 /= 0) .and. (q2 /= 0)) then
          HAM(:,:,:,:) = HAM(:,:,:,:)+J(k1,q1,k2,q2)*OO(:,:,:,:)+J(k1,q1,k2,-q2)*OW(:,:,:,:)+J(k1,-q1,k2,q2)*WO(:,:,:,:)+ &
                         J(k1,-q1,k2,-q2)*WW(:,:,:,:)
        end if
      end do
    end do
  end do
end do ! k1

#ifdef _DEBUGPRINT_
write(u6,'(A)') 'JITO_Exchange_Int: generated <m1,l1|HAM|m2,l2>'
do m1=1,n1
  do m2=1,n1
    do l1=1,n2
      do l2=1,n2
        write(u6,'(A,i2,A,i2,A,i2,A,i2,A,2ES22.14)') '<',m1,',',l1,'| HAM |',m2,',',l2,'> = ',HAM(m1,m2,l1,l2)
      end do
    end do
  end do
end do
#endif

call mma_deallocate(J)
call mma_deallocate(OO)
call mma_deallocate(OW)
call mma_deallocate(WO)
call mma_deallocate(WW)
call mma_deallocate(O1)
call mma_deallocate(W1)
call mma_deallocate(O2)
call mma_deallocate(W2)

return

end subroutine JITO_Exchange_Int

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,2020, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      Subroutine Seward_Init
************************************************************************
*                                                                      *
*     Object: to set data which is stored in common blocks             *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose      *
*             January 1990                                             *
************************************************************************
      use EFP_Module
      use k2_arrays
      use Basis_Info
      use RICD_Info, only: iRI_Type, Do_RI
      implicit real*8 (a-h,o-z)
      External Reduce_Prt
      Logical Reduce_Prt
#include "pstat.fh"
#include "print.fh"
#include "notab.fh"
#include "status.fh"
#include "twoswi.fh"
#include "rmat.fh"
#include "gam.fh"
#include "real.fh"
#include "relae.fh"
#include "FMM.fh"
#include "nac.fh"
#include "srint.fh"
      Logical lGENINT
      Character(LEN=180) Env
*                                                                      *
************************************************************************
*                                                                      *
C
C...  Parameters for srint
C
      shortrange=.False.
      isr_simulate=0
*
*     Initialize FMM.fh
*
      FMM_shortrange = .False.
      asymptotic_Rys = .False.
*                                                                      *
************************************************************************
*                                                                      *
*
*-----Info
*
      Seward_Status=InActive
*
*-----LInfo
*
      IRFLAG1=0
      lGENINT=.False.
*
      Call GetEnvF('MOLCAS_NEW_DEFAULTS', Env)
      Call UpCase(Env)
      If (Env.eq.'YES') Then
         Do_RI=.True.
         iRI_Type=4
      End If
*
*-----PStat
*
      r1=0.d0
      r2=0.d0
      r3=0.d0
      r4=0.d0
      q1=0.d0
      q2=0.d0
      q3=0.d0
      q4=0.d0
      MaxReq=0
      MinXtr=0
      iTotal=0
      MaxMem=0
*
*-----Print
*
      iPL=iPrintLevel(-1)
      If (iPL.eq.2) Then
         iPL=5
      Else If (iPL.eq.3) Then
         iPL=6
      Else If (iPL.eq.4) Then
         iPL=7
      Else If (iPL.eq.5) Then
         iPL=49  ! 99 would be just too much
      End If
      Do i = 1, nRout
         nPrint(i)=iPL
      End Do
      If ((Reduce_Prt().and.iPL.lt.6).or.iPL.eq.0) Then
         Show=.False.
      Else
         Show=.True.
      End If
*
*-----NoTab
*
      NoTab=.false.
*
      NDDO=.False.
*
      GT_Status=InActive
      T_Status =InActive
      PP_Status=InActive
      k2_Status=InActive
      RctFld_Status=InActive
      ERI_Status=InActive
      Indexation_Status=Inactive
      XMem_Status=Inactive
      NQ_Status=Inactive
      Seward_Status=Active
*
      Call Set_Binom
      Call Set_CanInd
*
*     Set some default value for RMAT type integration
*
*---- rmat.fh
*
      RmatR     = 10.0D0
      Epsabs    = 10.D-10
      Epsrel    = 1.D-14
      qCoul     = 0.0D0
      Epsq      = 1.D-8
      bParm     = 0.0D0
      dipol(1)  = 0.0D0
      dipol(2)  = 0.0D0
      dipol(3)  = 0.0D0
      Dipol1    = 0.0D0
      keyr      = 6
      Quadpack  = .True.
      nagint    = .False.
      testint   = .False.
      RMat_On   = .False.
*
*---- gam.fh
*
      lgamma = 9
*
*     relae.fh
*
      irelae=-1
*
      Call DCR_Init()
*
      Call Set_Basis_Mode('Valence')
*
      Call Mk_TriInd()
*
      Call CovRadT_Init()
*
*     nac.fh
*
      isNAC = .False.
      isCSF = .False.
*
*     EFP stuff
*
      lEFP=.False.
      nEFP_fragments=0
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
*               2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine PLF_LDF_Gmax_S(TInt,nTInt,
     &                          AOint,ijkl,
     &                          iCmp,jCmp,kCmp,lCmp,
     &                          iBas,jBas,kBas,lBas)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*          Modified for Local DF, Thomas Bondo Pedersen, Oct. 2010     *
*                                                                      *
************************************************************************
      Implicit None
      Integer nTInt
      Real*8  TInt(nTInt)
      Integer ijkl, iCmp, jCmp, kCmp, lCmp
      Real*8  AOInt(ijkl,iCmp,jCmp,kCmp,lCmp)
      Integer iBas, jBas, kBas, lBas
#if defined (_DEBUGPRINT_)
#include "localdf_bas.fh"
#include "localdf_int3.fh"
#include "WrkSpc.fh"

      Character*14 SecNam
      Parameter (SecNam='PLF_LDF_Gmax_S')
#endif

      Integer i4
      Integer lSOl
      Integer nijkl

#if defined (_DEBUGPRINT_)
      Integer i
      Integer nBasSh
      nBasSh(i)=iWork(ip_nBasSh-1+i)

      If (iCmp*iBas.ne.1) Then
         Call WarningMessage(2,SecNam//': Shell dimension problem [1]')
         Call LDF_Quit(1)
      End If
      If (jCmp*jBas.ne.nBasSh(SHB)) Then
         Call WarningMessage(2,SecNam//': Shell dimension problem [2]')
         Call LDF_Quit(1)
      End If
      If (kCmp*kBas.ne.1) Then
         Call WarningMessage(2,SecNam//': Shell dimension problem [3]')
         Call LDF_Quit(1)
      End If
      If (lCmp*lBas.ne.nBasSh(SHD)) Then
         Call WarningMessage(2,SecNam//': Shell dimension problem [4]')
         Call LDF_Quit(1)
      End If
      If (SHB.ne.SHD) Then
         Call WarningMessage(2,SecNam//': SHB != SHD')
         Call LDF_Quit(1)
      End If
      If (nTInt.lt.2) Then
         Call WarningMessage(2,SecNam//' nTInt < 2')
         Call LDF_Quit(1)
      End If
#endif

      TInt(1)=0.0d0
      TInt(2)=0.0d0
      Do i4=1,lCmp
         Do lSOl=1,lBas
            nijkl=lBas*(lSOl-1)+lSOl
            TInt(1)=max(TInt(1),AOInt(nijkl,1,i4,1,i4))
            TInt(2)=TInt(2)+AOInt(nijkl,1,i4,1,i4)
         End Do
      End Do

#ifndef _DEBUGPRINT_
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iBas)
         Call Unused_integer(jBas)
         Call Unused_integer(kBas)
      End If
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHO_FOCK_RASSI_X(DLT,MO1,MO2,FLT,FSQ,TUVX)
!*********************************************************************
!  Author : F. Aquilante
!
!  Note:  this routine differs from CHO_FOCK_RASSI because it can
!         handle ALSO the case where the 2 sets of MOs are different!
!         The Exchange contribution is non-symmetric and so is FI
!
! *************** INACTIVE AO-BASIS FOCK MATRIX **********************
!
!   FI(ab) = 2 * sum_J  Lab,J * U(J)  -  sum_Jk  Yka,J * Xkb,J
!
!      U(J) = sum_gd  Lgd,J * DI(gd)
!
!      a,b,g,d:  AO-index
!      k:        MO-index   belonging to (Inactive)
!      v,w,x,y:  MO-indices belonging to (Active)
!
!*********************************************************************

use ChoArr, only: nDimRS
use ChoSwp, only: InfVec
use Symmetry_Info, only: Mul
use Fock_util_global, only: Fake_CMO2
use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type, SBA_Type, twxy_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
type(DSBA_Type), intent(in) :: DLT, MO1(2), MO2(2)
type(DSBA_Type), intent(inout) :: FLT(1), FSQ
real(kind=wp), intent(_OUT_) :: TUVX(*)
#include "chotime.fh"
#include "rassi.fh"
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: i, ia, iabt, ib, iBatch, iCase, iLoc, irc, iREDC, iSkip(8), iSwap, iSym, iSyma, iSymb, iSymk, iSymv, IVEC2, &
                     iVrs, jDen, JNUM, JRED, JRED1, JRED2, jSym, JVC, JVEC, k, kDen, kMOs, l, LREAD, LWORK, mDen, mTTvec, mTvec, &
                     MUSED, NAv, NAw, nBatch, nDen, NK, nMOs, nRS, NUMV, nVec, nVrs, rc
real(kind=wp) :: Fact, TCC1, TCC2, TCINT1, TCINT2, tcoul(2), TCR1, TCR2, TCR3, TCR4, TCR7, TCX1, TCX2, texch(2), tintg(2), TOTCPU, &
                 TOTCPU1, TOTCPU2, TOTWALL, TOTWALL1, TOTWALL2, tread(2), TWC1, TWC2, TWINT1, TWINT2, TWR1, TWR2, TWR3, TWR4, &
                 TWR7, TWX1, TWX2
logical(kind=iwp) :: add, DoReord
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: Debug
#endif
character(len=50) :: CFmt
type(SBA_Type), target :: Laq(2)
type(twxy_Type) :: Scr
real(kind=wp), allocatable :: Drs(:), Frs(:), Lrs(:,:)
real(kind=wp), pointer :: VJ(:) => null()
real(kind=wp), parameter :: FactCI = One, FactXI = -One
character(len=*), parameter :: SECNAM = 'CHO_FOCK_RASSI_X'
logical(kind=iwp), parameter :: DoRead = .false.

!*************************************************
#ifdef _DEBUGPRINT_
Debug = .false. ! to avoid double printing in CASSCF-debug
#endif
DoReord = .false.
IREDC = -1 ! unknown reduced set in core

nDen = 2
if (Fake_CMO2) nDen = 1 ! MO1 = MO2
kDen = nDen

call CWTIME(TOTCPU1,TOTWALL1) ! start clock for total time

! 1 --> CPU   2 --> Wall
tread(:) = zero ! time read/transform vectors
tcoul(:) = zero ! time for computing Coulomb
texch(:) = zero ! time for computing Exchange
tintg(:) = zero ! time for computing (tw|xy) integrals

! *************** BIG LOOP OVER VECTORS SYMMETRY *******************
do jSym=1,nSym

  if (NumCho(jSym) < 1) cycle

  iCase = 0 ! twxy
  call Allocate_DT(Scr,nAsh,nAsh,JSYM,nSym,iCase)

  iLoc = 3 ! use scratch location in reduced index arrays

  ! ****************     MEMORY MANAGEMENT SECTION    *****************
  ! --------------------------------------------------------------
  ! compute memory needed to store at least 1 vector of JSYM
  ! and do all the subsequent calculations
  ! --------------------------------------------------------------
  mTvec = 0  ! mem for storing the half-transformed vec
  mTTvec = 0  ! mem for Lvb,J and Lvw,J
  do l=1,nSym
    k = Mul(l,JSYM)
    mTvec = mTvec+nDen*nBas(l)*nIsh(k)
    mTTvec = mTTvec+(nBas(l)+nAsh(l))*nAsh(k)
  end do

  mTvec = max(mTvec,mTTvec,1)

  ! ------------------------------------------------------------------
  ! ------------------------------------------------------------------

  JRED1 = InfVec(1,2,jSym)            ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) ! red set of the last vec

  do JRED=JRED1,JRED2

    call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

    if (nVrs == 0) cycle ! no vectors in that (jred,jsym)

    if (nVrs < 0) then
      write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
      call abend()
    end if

    call Cho_X_SetRed(irc,iLoc,JRED) ! set index arrays at iLoc
    if (irc /= 0) then
      write(u6,*) SECNAM//'cho_X_setred non-zero return code.   rc= ',irc
      call abend()
    end if

    IREDC = JRED

    nRS = nDimRS(JSYM,JRED)

    if (JSYM == 1) then
      call mma_allocate(Drs,nRS,Label='Drs')
      call mma_allocate(Frs,nRS,Label='Frs')
      Drs(:) = Zero
      Frs(:) = Zero
    end if

    call mma_maxDBLE(LWORK)

    nVec = min(LWORK/(nRS+mTvec),nVrs)

    if (nVec < 1) then
      write(u6,*) SECNAM//': Insufficient memory for batch'
      write(u6,*) 'LWORK= ',LWORK
      write(u6,*) 'min. mem. need= ',nRS+mTvec
      write(u6,*) 'jsym= ',jsym
      rc = 33
      call Abend()
      nBatch = -9999 ! dummy assignment
    end if

    LREAD = nRS*nVec

    call mma_allocate(Lrs,nRS,nVec,Label='Lrs')

    if (JSYM == 1) then
      ! Transform the density to reduced storage
      add = .false.
      mDen = 1
      call swap_full2rs(irc,iLoc,nRS,mDen,JSYM,[DLT],Drs,add)
    end if

    ! BATCH over the vectors ----------------------------

    nBatch = (nVrs-1)/nVec+1

    do iBatch=1,nBatch

      if (iBatch == nBatch) then
        JNUM = nVrs-nVec*(nBatch-1)
      else
        JNUM = nVec
      end if

      iSwap = 2 ! LpJ,b are returned
      do jDen=1,nDen
        call Allocate_DT(Laq(jDen),nIsh,nBas,nVec,JSYM,nSym,iSwap)
      end do

      JVEC = nVec*(iBatch-1)+iVrs
      IVEC2 = JVEC-1+JNUM

      call CWTIME(TCR1,TWR1)

      call CHO_VECRD(Lrs,LREAD,JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

      if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
        rc = 77
        write(u6,*) 'return code = ',rc
        return
      end if

      call CWTIME(TCR2,TWR2)
      tread(1) = tread(1)+(TCR2-TCR1)
      tread(2) = tread(2)+(TWR2-TWR1)

      if (JSYM == 1) then
        ! ************ (alpha+beta) COULOMB CONTRIBUTION  ****************
        !
        ! Contraction with the density matrix
        ! -----------------------------------
        ! V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * DI(rs)
        !==========================================================

        call CWTIME(TCC1,TWC1)

        VJ(1:JNUM) => Laq(1)%A0(1:JNUM)

        call DGEMV_('T',nRS,JNUM,ONE,Lrs,nRS,Drs,1,ZERO,VJ,1)

        ! FI(rs){#J} <- FI(rs){#J} + FactCI * sum_J L(rs,{#J})*V{#J}
        !===========================================================

        Fact = real(min(jVec-iVrs,1),kind=wp)

        call DGEMV_('N',nRS,JNUM,FactCI,Lrs,nRS,VJ,1,Fact,Frs,1)

        call CWTIME(TCC2,TWC2)
        tcoul(1) = tcoul(1)+(TCC2-TCC1)
        tcoul(2) = tcoul(2)+(TWC2-TWC1)

        VJ => null()

      end if ! Coulomb contribution

      ! *************** EXCHANGE CONTRIBUTIONS  ***********************

      call CWTIME(TCR3,TWR3)

      kMOs = 1
      nMOs = nDen

      ! Set up the skipping flags
      ! ---------------------------------------------------------
      do i=1,nSym

        k = Mul(i,JSYM)
        iSkip(k) = min(1,nIsh(k)*NBAS(i))

      end do
      ! -------------------------------------------------------------

      ! *********************** HALF-TRANSFORMATION  ****************

      call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,MO1,Laq,DoRead)

      call CWTIME(TCR4,TWR4)
      tread(1) = tread(1)+(TCR4-TCR3)
      tread(2) = tread(2)+(TWR4-TWR3)

      if (irc /= 0) then
        rc = irc
        write(u6,*) 'CHO_X_getVtra failed! '
        return
      end if

      call CWTIME(TCX1,TWX1)

      do iSyma=1,nSym

        iSymk = Mul(JSYM,iSyma)

        ! ---------------------------------------------------------------------
        ! *** Compute the InActive exchange matrix
        !
        !     FI(ab) = FI(ab) + FactXI * sum_Jk  X(2)kJ,a * X(1)kJ,b
        ! ---------------------------------------------------------------------
        NK = nIsh(iSymk)

        if (iSkip(iSymk) /= 0) then

          call DGEMM_('T','N',NBAS(iSyma),NBAS(iSyma),NK*JNUM,FactXI,Laq(kDen)%SB(iSymk)%A3,NK*JNUM,Laq(1)%SB(iSymk)%A3,NK*JNUM, &
                      One,FSQ%SB(iSyma)%A2,NBAS(iSyma))

        end if

        ! --------------------------------------------------------------------
      end do  !loop over MOs symmetries

      call CWTIME(TCX2,TWX2)
      texch(1) = texch(1)+(TCX2-TCX1)
      texch(2) = texch(2)+(TWX2-TWX1)

      do jDen=1,nDen
        call Deallocate_DT(Laq(jDen))
      end do

      ! ************  END EXCHANGE CONTRIBUTION  ****************

      iSwap = 0  ! Lvb,J are returned
      call Allocate_DT(Laq(1),nAsh,nBas,nVec,JSYM,nSym,iSwap)
      call Allocate_DT(Laq(2),nAsh,nAsh,nVec,JSYM,nSym,iSwap)

      ! ----------------------------------------------------------------
      ! First half Active transformation  Lvb,J = sum_a  C1(v,a) * Lab,J
      ! ----------------------------------------------------------------

      call CWTIME(TCR7,TWR7)

      ! Set up the skipping flags
      ! ---------------------------------------------------------
      do i=1,nSym

        k = Mul(i,JSYM)
        iSkip(k) = min(1,NBAS(i)*nAsh(k))

      end do

      kMOs = 1
      nMOs = 1 ! Active MOs (1st set)

      call CHO_X_getVtra(irc,Lrs,LREAD,jVEC,JNUM,JSYM,iSwap,IREDC,nMOs,kMOs,MO2,Laq,DoRead)

      if (irc /= 0) then
        rc = irc
        return
      end if

      ! ----------------------------------------------------------------
      ! Active-Active transformation  Lvw,J = sum_b  Lvb,J * C2(w,b)
      ! ----------------------------------------------------------------
      do iSymb=1,nSym

        iSymv = Mul(JSYM,iSymb)
        NAv = nAsh(iSymv)
        NAw = nAsh(iSymb) ! iSymb=iSymw

        if (NAv*NAw /= 0) then

          do JVC=1,JNUM

            call DGEMM_('N','T',NAv,NAw,NBAS(iSymb),One,Laq(1)%SB(iSymv)%A3(:,:,JVC),NAv,MO2(kDen)%SB(iSymb)%A2,NAw,Zero, &
                        Laq(2)%SB(iSymv)%A3(:,:,JVC),NAv)

          end do

        end if

      end do

      ! *************** EVALUATION OF THE (TW|XY) INTEGRALS ***********

      call CWTIME(TCINT1,TWINT1)

      DoReord = (JRED == JRED2) .and. (iBatch == nBatch)

      call CHO_rassi_twxy(irc,Scr,Laq(2),TUVX,nAsh,JSYM,JNUM,DoReord)

      call CWTIME(TCINT2,TWINT2)
      tintg(1) = tintg(1)+(TCINT2-TCINT1)
      tintg(2) = tintg(2)+(TWINT2-TWINT1)

      if (irc /= 0) then
        rc = irc
        return
      end if

      ! ---------------- END (TW|XY) EVALUATION -----------------------

      call Deallocate_DT(Laq(2))
      call Deallocate_DT(Laq(1))
    end do ! end batch loop

    if (JSYM == 1) then
      ! backtransform fock matrix to full storage
      add = .true.
      mDen = 1
      call swap_rs2full(irc,iLoc,nRS,mDen,JSYM,FLT,Frs,add)
    end if

    ! free memory
    call mma_deallocate(Lrs)

    if (JSYM == 1) then
      call mma_deallocate(Frs)
      call mma_deallocate(Drs)
    end if

  end do ! loop over red sets

  call Deallocate_DT(Scr)

end do ! loop over JSYM

! Accumulate Coulomb and Exchange contributions
do iSym=1,nSym

  do ia=1,nBas(iSym)
    do ib=1,ia-1
      iabt = ia*(ia-1)/2+ib
      FSQ%SB(iSym)%A2(ib,ia) = FSQ%SB(iSym)%A2(ib,ia)+FLT(1)%SB(iSym)%A1(iabt)
      FSQ%SB(iSym)%A2(ia,ib) = FSQ%SB(iSym)%A2(ia,ib)+FLT(1)%SB(iSym)%A1(iabt)
    end do
    iabt = ia*(ia+1)/2
    FSQ%SB(iSym)%A2(ia,ia) = FSQ%SB(iSym)%A2(ia,ia)+FLT(1)%SB(iSym)%A1(iabt)
  end do

end do

call CWTIME(TOTCPU2,TOTWALL2)
TOTCPU = TOTCPU2-TOTCPU1
TOTWALL = TOTWALL2-TOTWALL1

! Write out timing information
if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky RASSI timing from '//SECNAM
  write(u6,CFmt) '----------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) 'Fock matrix construction        CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'

  write(u6,'(2x,A26,2f10.2)') 'READ/TRANSFORM VECTORS                    ',tread(1),tread(2)
  write(u6,'(2x,A26,2f10.2)') 'COULOMB                                   ',tcoul(1),tcoul(2)
  write(u6,'(2x,A26,2f10.2)') 'EXCHANGE                                  ',texch(1),texch(2)
  write(u6,'(2x,A26,2f10.2)') '(TW|XY) INTEGRALS                         ',tintg(1),tintg(2)
  write(u6,*)
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

! Print the Fock-matrix
#ifdef _DEBUGPRINT_
if (Debug) then ! to avoid double printing in RASSI-debug

  write(u6,'(6X,A)') 'TEST PRINT FROM '//SECNAM
  write(u6,'(6X,A)')
  do ISYM=1,NSYM
    if (NBAS(ISYM) > 0) then
      write(u6,'(6X,A)') '***** INACTIVE FOCK MATRIX ***** '
      write(u6,'(6X,A)')
      write(u6,'(6X,A,I2)') 'SYMMETRY SPECIES:',ISYM
      call CHO_OUTPUT(FSQ%SB(ISYM)%A2,1,NBAS(ISYM),1,NBAS(ISYM),NBAS(ISYM),NBAS(ISYM),1,u6)
    end if
  end do

end if
#endif

rc = 0

return

end subroutine CHO_FOCK_RASSI_X

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine defvhlp9(r2,v,dimr2b,dimr2ac,dimva,dimvb,dimvc,adda,addc)
! this routine does
! V(a,b,c)aba = - R2(b,ac)
! for syma==symc
!
! r2      - r2 matrix (I)
! v       - v matrix (O)
! dimr2b  - dimension of b in R2 (I)
! dimr2ac - dimension of ac in R2 (I)
! dimva   - dimension of a in V (I)
! dimvb   - dimension of b in V (I)
! dimvc   - dimension of c in V (I)
! adda    - additional constant to a (I)
! addc    - additional constant to c (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimr2b, dimr2ac, dimva, dimvb, dimvc, adda, addc
real(kind=wp), intent(in) :: r2(dimr2b,dimr2ac)
real(kind=wp), intent(out) :: v(dimva,dimvb,dimvc)
integer(kind=iwp) :: a, acr2, c, cr2

do c=1,dimvc
  cr2 = c+addc
  do a=1,dimva
    !acr2 = indab(a+adda,cr2)
    if ((a+adda) >= cr2) then
      acr2 = (a+adda)*(a+adda-1)/2+cr2
    else
      acr2 = cr2*(cr2-1)/2+a+adda
    end if
    v(a,:,c) = -r2(1:dimvb,acr2)
  end do
end do

return

end subroutine defvhlp9

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Kntc(Txyz,Sxyz,na,nb,Alpha,Beta,nZeta)
!***********************************************************************
!                                                                      *
! Object: to assemble the cartesian components of the kinetic energy   *
!         integral from the cartesian components of the overlap        *
!         integral.                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Constants, only: Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: na, nb, nZeta
real(kind=wp), intent(out) :: Txyz(nZeta,3,0:na,0:nb)
real(kind=wp), intent(in) :: Sxyz(nZeta,3,0:na+1,0:nb+1), Alpha(nZeta), Beta(nZeta)
#include "print.fh"
integer(kind=iwp) :: ia, ib, iCar, iPrint, iRout
character(len=80) :: Label

iRout = 115
iPrint = nPrint(iRout)

if (iPrint >= 99) then
  call RecPrt(' In Kntc: Alpha',' ',Alpha,nZeta,1)
  call RecPrt(' In Kntc: Beta ',' ',Beta,nZeta,1)
  do ia=0,na+1
    do ib=0,nb+1
      write(Label,'(A,I2,A,I2,A)') ' In Kntc: Sxyz(',ia,',',ib,')'
      call RecPrt(Label,' ',Sxyz(:,:,ia,ib),nZeta,3)
    end do
  end do
end if
do ia=0,na
  do ib=0,nb
    if ((ia /= 0) .and. (ib /= 0)) then
      do iCar=1,3
        Txyz(:,iCar,ia,ib) = Two*Alpha*Beta*Sxyz(:,iCar,ia+1,ib+1)+Half*real(ia*ib,kind=wp)*Sxyz(:,iCar,ia-1,ib-1)- &
                             Alpha*real(ib,kind=wp)*Sxyz(:,iCar,ia+1,ib-1)-Beta*real(ia,kind=wp)*Sxyz(:,iCar,ia-1,ib+1)
      end do
    else if (ia /= 0) then
      do iCar=1,3
        Txyz(:,iCar,ia,ib) = Two*Alpha*Beta*Sxyz(:,iCar,ia+1,ib+1)-Beta*real(ia,kind=wp)*Sxyz(:,iCar,ia-1,ib+1)
      end do
    else if (ib /= 0) then
      do iCar=1,3
        Txyz(:,iCar,ia,ib) = Two*Alpha*Beta*Sxyz(:,iCar,ia+1,ib+1)-Alpha*real(ib,kind=wp)*Sxyz(:,iCar,ia+1,ib-1)
      end do
    else
      do iCar=1,3
        Txyz(:,iCar,ia,ib) = Two*Alpha*Beta*Sxyz(:,iCar,ia+1,ib+1)
      end do
    end if
    if (iPrint >= 99) then
      write(Label,'(A,I2,A,I2,A)') ' In Kntc: Txyz(',ia,',',ib,')'
      call RecPrt(Label,' ',Txyz(:,:,ia,ib),nZeta,3)
    end if
  end do
end do

return

end subroutine Kntc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_DRV()
!
! Purpose: MOLCAS interface to Cholesky decomposition driver.

#ifdef _DEBUGPRINT_
use Gateway_Info, only: CutInt, ThrInt
#endif
use Cholesky, only: HaltIt, Lupri, MySP, nShell
use stdalloc, only: mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ICODE, irc
real(kind=wp) :: THRAO
#ifdef _DEBUGPRINT_
real(kind=wp) :: CUTINT1, CUTINT2, THRINT1, THRINT2
#endif
logical(kind=iwp) :: DOFOCK, DOGRAD, INDEXATION
character(len=*), parameter :: SECNAM = 'CHO_MCA_DRV'

call STATUSLINE('Seward: ','Cholesky decomposition of ERIs')

! Initialize integral program (this does some memory
! allocations; thus, DO NOT move this.
! --------------------------------------------------

#ifdef _DEBUGPRINT_
CUTINT1 = CutInt
THRINT1 = ThrInt
#endif

call Set_Basis_Mode('Valence')
call Setup_iSD()
NSHELL = -1
INDEXATION = .true.
THRAO = Zero
DOFOCK = .false.
DOGRAD = .false.
call SETUP_INTS(NSHELL,INDEXATION,THRAO,DOFOCK,DOGRAD)

#ifdef _DEBUGPRINT_
CUTINT2 = CutInt
THRINT2 = ThrInt
write(LUPRI,*) SECNAM,': CutInt before Setup_Ints: ',CUTINT1
write(LUPRI,*) SECNAM,': CutInt after  Setup_Ints: ',CUTINT2
write(LUPRI,*) SECNAM,': ThrInt before Setup_Ints: ',THRINT1
write(LUPRI,*) SECNAM,': ThrInt after  Setup_Ints: ',THRINT2
if ((CUTINT2 /= CUTINT1) .or. (THRINT2 /= THRINT1)) call CHO_QUIT('Initialization error in '//SECNAM,102)
#endif

! Start the Cholesky decomposition program.
! -----------------------------------------

ICODE = 0
call CHO_DRV(ICODE)
if (ICODE /= 0) then
  write(LUPRI,*) SECNAM,': decomposition driver returned code ',ICODE
  call CHO_QUIT('Decomposition failed!',104)
end if

! Finalize integral program.
! --------------------------

call TERM_INTS()

! Halt execution if requested.
! ----------------------------

if (HALTIT) then
  write(LUPRI,*) SECNAM,': halting execution after decomposition as requested...'
  call GASYNC()
  call CHO_QUIT('End of Test (in '//SECNAM//')',100)
end if

call GASYNC()
call Free_iSD()

call mma_deallocate(MySP,safe='*')
call Cho_X_dealloc(irc)

end subroutine CHO_MCA_DRV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function C2R8(CBuf)
      Real*8 C2R8
      Character CBuf(*)
      C2R8=C2R8_Internal(CBuf)
*
*     This is to allow type punning without an explicit interface
      Contains
      Real*8 Function C2R8_Internal(CBuf)
      Use Iso_C_Binding
      Character, Target :: CBuf(*)
      Real*8, Pointer :: Buf
      Call C_F_Pointer(C_Loc(CBuf(1)),Buf)
      C2R8_Internal=Buf
      Nullify(Buf)
      Return
      End Function C2R8_Internal
*
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_VecBuf_Check()
!
! Thomas Bondo Pedersen, September 2012.
!
! Check buffer integrity and stop if corrupted.

use Cholesky, only: LuPri
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: irc
real(kind=wp) :: Tol
logical(kind=iwp) :: Verbose
character :: Txt

Tol = 1.0e-12_wp
Verbose = .false.
Txt = ' '
call Cho_VecBuf_CheckIntegrity(Tol,Verbose,Txt,irc)
if (irc /= 0) then
  write(LuPri,'(A,I3)') 'Cho_VecBuf_Check: buffer integrity check returned code',irc
  call Cho_Quit('Cholesky vector buffer corrupted',104)
end if

end subroutine Cho_VecBuf_Check

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine MergeBS (z1,n1,z2,n2,z,n,RatioThres,iDominantSet)
      Implicit Real*8 (a-h,o-z)
      Real*8 z1(n1), z2(n2), z(*)
      Parameter (mPrim=60)
      Integer ix1(mPrim), ix2(mPrim)
      Logical IfTest
      Data IfTest/.False./
*
#ifdef _DEBUGPRINT_
      IfTest=.True.
#endif
      If (n1.gt.mPrim .or. n2.gt.mPrim) Then
        Call WarningMessage(2,'Error in MergeBS')
        Write (6,*) ' MergeBS: n1,n2 .gt.mPrim',n1,n2,mPrim
        Write (6,*) ' MergeBS: rise mPrim and recompile'
        Call Abend()
      End If
*
      iSetPrev     = 0
*
      Do i = 1, mPrim
        ix1(i) = i
        ix2(i) = i
      End Do
*
      Do i = 1, n1 - 1
        Do j = i + 1, n1
          If (z1(ix1(i)).lt.z1(ix1(j)))  then
            idum=ix1(i)
            ix1(i)=ix1(j)
            ix1(j)=idum
          End If
        End Do
      End Do
*
      Do i = 1, n2 - 1
        Do j = i + 1, n2
          If (z2(ix2(i)).lt.z2(ix2(j)))  then
            idum=ix2(i)
            ix2(i)=ix2(j)
            ix2(j)=idum
          End If
        End Do
      End Do
*
      If (IfTest) Write (6,'(A)')
      If (IfTest) Write (6,'(4f20.4)') (z1(ix1(i)),i=1,n1)
      If (IfTest) Write (6,'(A)')
      If (IfTest) Write (6,'(4f20.4)') (z2(ix2(i)),i=1,n2)
*
      i = 0
      i1 = 1
      i2 = 1
      Do while (i1.le.n1 .or. i2.le.n2)
         i = i + 1
        If (i.gt.mPrim) Then
           Call WarningMessage(2,'Error in MergeBS')
           Write (6,*) ' MergeBS: i.gt.mPrim',i,mPrim
           Write (6,*) ' MergeBS: rise mPrim and recompile'
           Call Abend()
        End If
        If ( i1.gt.n1 ) Then
          z(i) = z2(ix2(i2))
          iSetThis = 2
          i2 = i2 + 1
        Else If ( i2.gt.n2 ) Then
          z(i) = z1(ix1(i1))
          iSetThis = 1
          i1 = i1 + 1
        Else If ( z1(ix1(i1)) .gt. z2(ix2(i2)) ) then
          z(i) = z1(ix1(i1))
          iSetThis = 1
          i1 = i1 + 1
        Else
          z(i) = z2(ix2(i2))
          iSetThis = 2
          i2 = i2 + 1
        End If
*
        If (i.eq.1) Then
          iSetPrev = iSetThis
        Else
          ratio = z(i-1)/z(i)
          If (ratio.ge.RatioThres) Then
            iSetPrev = iSetThis
          Else
            If (iSetThis.ne.iDominantSet) Then
              i = i - 1
            Else If (iSetThis.eq.iDominantSet) Then
              If (iSetPrev.ne.iDominantSet) Then
                z(i-1) = z(i)
                i = i - 1
              Else
                continue
              End If
              iSetPrev = iSetThis
            End If
          End If
        End If

      End Do
*
      n = i
      If (IfTest) Write (6,'(I4)') n
      If (IfTest) Write (6,'(4f20.4)') (z(i),i=1,n)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016-2017, Stefan Knecht                               *
!***********************************************************************

!ifdef _DEBUGPRINT_
subroutine prepMPS(trorb,istate,lsym,mplet,mspro,nacte,tra,ntra,nish,nash,nosh,nsym,lupri,job,ist)
!-------------------------------------------------------------------------------
!
!    driver routine for the MPS rotation wrt the orbital transformation matrix
!    given in TRA.
!    --> rotate MPS state ISTATE
!    NOTE: TRA contains square matrices, one per symmetry
!
!-------------------------------------------------------------------------------

! module dependencies
#ifdef _DMRG_
use qcmaquis_info, only: qcm_group_names, qcm_prefixes
use qcmaquis_interface_cfg, only: dmrg_orbital_space, dmrg_state, dmrg_symmetry
use qcmaquis_interface_mpssi, only: qcmaquis_mpssi_rotate
use fortran_strings, only: str
use Constants, only: Zero, One
use Definitions, only: u6
#endif
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: trorb
integer(kind=iwp), intent(in) :: istate, lsym, mplet, mspro, nacte, ntra, nsym, nish(nsym), nash(nsym), nosh(nsym), lupri, job, ist
real(kind=wp), intent(inout) :: tra(ntra)
#ifdef _DMRG_
integer(kind=iwp) :: i, ii, ista, isym, jorb, ni, no
real(kind=wp) :: fac
real(kind=wp), allocatable :: tmat(:,:)

! tmat: active-active rotation matrix
! Leon 8/12/2016 -- istatereal: "real" state index across all JobIphs, needed when we read checkpoint file names

if (.not. trorb) then
  write(lupri,'(a,a)') ' prepMPS: no MPS rotation requested for state ', &
                       trim(qcm_group_names(job)%states(ist))//' jobiph: '//str(job)//', root: '//str(istate)
  return
else
  write(lupri,'(a,a)') ' prepMPS:    MPS rotation requested for state ', &
                       trim(qcm_group_names(job)%states(ist))//' jobiph: '//str(job)//', root: '//str(istate)
end if

dmrg_orbital_space%nash(1:nsym) = nash(1:nsym)
dmrg_symmetry%nirrep = nsym
dmrg_state%nactel = nacte
dmrg_state%ms2 = mplet
dmrg_state%irefsm = lsym

#ifdef _DEBUGPRINT_
write(lupri,*) ' Entering prepMPS. TRA='
write(lupri,'(1x,5f16.8)') (TRA(I),I=1,NTRA)
#endif

!> find first the scaling factor to transform wrt the inactive orbitals
fac = One
ista = 1
do isym=1,nsym
  no = nosh(isym)
  do i=1,nish(isym)
    ii = ista+(no+1)*(i-1)
    fac = fac*tra(ii)
  end do
  ista = ista+no**2
end do
fac = fac**2
#ifdef _DEBUGPRINT_
write(lupri,*) ' scaling factor for MPS (inactive orbital rotations)',fac
#endif

dmrg_state%ms2 = mspro

if (nsym > 1) then
  write(u6,*) 'MPS rotation not supported with symmetry'
  call abend()
end if

!call mma_allocate(tmat,nash(1),nash(1))
! Leon: I get a maybe-uninitialized error if I use mma_allocate on tmat
allocate(tmat(nash(1),nash(1)))
tmat = Zero
ista = 1
jorb = 0
do isym=1,nsym
  ni = nish(isym)
  no = nosh(isym)
  do i=1,nash(isym)
    ! copy the active-active part of the rotation matrix into tmat
    tmat(i,:) = tra(1+(no+i)*ni+nash(isym)*(i-1):(no+i)*ni+nash(isym)*i)
  end do
  ista = ista+no**2
end do

! rotate MPS
call qcmaquis_mpssi_rotate(qcm_prefixes(job),istate,tmat,nash(1)**2,fac,mspro)

if (allocated(tmat)) deallocate(tmat)
!call mma_deallocate(tmat)

#else
write(lupri,*) ' calling prepMPS w/o DMRG interface - foolish!'
write(lupri,*) ' ... no actual task is performed.'
! Avoid unused variable warnings if DMRG is disabled
#include "macros.fh"
unused_var(trorb)
unused_var(istate)
unused_var(lsym)
unused_var(mplet)
unused_var(mspro)
unused_var(nacte)
unused_var(tra)
unused_var(nish)
unused_var(nash)
unused_var(nosh)
unused_var(job)
unused_var(ist)
#endif

end subroutine prepMPS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*

      SUBROUTINE DIADNS(ISYM,ICASE,VEC1,VEC2,DPT2,LIST)

      IMPLICIT REAL*8 (A-H,O-Z)


#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "sigma.fh"

      DIMENSION VEC1(*),VEC2(*)
      DIMENSION DPT2(*)
      DIMENSION LIST(*)
      DIMENSION IOFDIJ(8),IOFDAB(8)
      DIMENSION IOFCD(8,8)

C Compute diagonal-block contribs to a trans density matrix.
C Vector blocks are in spectral resolution basis (ON).
C Each square matrix block of density matrix elements is
C computed and stored in full, even if VEC1=VEC2.
C Present implementation does not compute active-active
C contributions. This should be added in a separate routine,
C since it requires transformation to standard (Non-ON) basis.

      NIN=NINDEP(ISYM,ICASE)
      IF(NIN.EQ.0) RETURN
      NIS=NISUP(ISYM,ICASE)
      IF(NIS.EQ.0) RETURN
      NAS=NASUP(ISYM,ICASE)
      NVEC=NIN*NIS
      SQR2=SQRT(2.0D00)

      IFTEST=0
C Set up various offset arrays:
      IDIJ=0
      DO IS=1,NSYM
        NI=NISH(IS)
        NA=NASH(IS)
        NO=NORB(IS)
        IDTU=IDIJ+NO*NI+NI
        IDAB=IDTU+NO*NA+NA
        IOFDIJ(IS)=IDIJ
        IOFDAB(IS)=IDAB
        IDIJ=IDIJ+NO*NO
      END DO
      DO IS=1,NSYM
        ICD=0
        ICEP=0
        ICEM=0
        ICGP=0
        ICGM=0
        DO JS=1,NSYM
          IJS=MUL(IS,JS)
          IOFCD(IS,JS)=ICD
          ICD =ICD +NSSH(JS)*NISH(IJS)
          ICEP=ICEP+NSSH(JS)*NIGEJ(IJS)
          ICEM=ICEM+NSSH(JS)*NIGTJ(IJS)
          ICGP=ICGP+NISH(JS)*NAGEB(IJS)
          ICGM=ICGM+NISH(JS)*NAGTB(IJS)
        END DO
      END DO

C Core contribution:
      OVL=DDOT_(NVEC,VEC1,1,VEC2,1)
      DO IS=1,NSYM
        NI=NISH(IS)
        NO=NORB(IS)
        IDII=IOFDIJ(IS)+1
        DO III=1,NI
          DPT2(IDII)=DPT2(IDII)+2.0D0*OVL
          IDII=IDII+NO+1
        END DO
      END DO
*
      LLST1 = 0 ! dummy initialize
      NLST1 = 0 ! dummy initialize
*
      GOTO (1,2,3,4,5,6,7,8,9,10,11,12,13) ICASE
      RETURN

C -----------------------------------------------
   1  CONTINUE
C Case A
      NI=NISH(ISYM)
      NO=NORB(ISYM)
      DO II=1,NI
        IV2=1+NIN*(II-1)
        DO IJ=1,NI
          IDIJ=IOFDIJ(ISYM)+II+NO*(IJ-1)
          IV1=1+NIN*(IJ-1)
          DPT2(IDIJ)=DPT2(IDIJ)-
     &           DDOT_(NIN,VEC1(IV1),1,VEC2(IV2),1)
        END DO
      END DO
      GOTO 100
C -----------------------------------------------
   2  CONTINUE
C Case BP
   3  CONTINUE
C Case BM
C Unfold VEC1 and VEC2 into X1(MU,K,I), X2(MU,K,I):
      NX=NIN*NIMX**2
      CALL GETMEM('DIA_X1','ALLO','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','ALLO','REAL',LX2,NX)
      DO ISYMK=1,NSYM
       ISYMI=MUL(ISYMK,ISYM)
       NK=NISH(ISYMK)
       NI=NISH(ISYMI)
       NKI=NK*NI
       IF(NKI.EQ.0) GOTO 903
       CALL DCOPY_(NIN*NKI,[0.0D0],0,WORK(LX1),1)
       CALL DCOPY_(NIN*NKI,[0.0D0],0,WORK(LX2),1)
       IF(ICASE.EQ.2) THEN
         LLST1=LLIST(ISYMK,ISYM,14)
         NLST1=NLIST(ISYMK,ISYM,14)
         VAL1(1)= 1.0D00
         VAL1(2)= SQR2
       ELSE IF(ICASE.EQ.3) THEN
         LLST1=LLIST(ISYMK,ISYM,15)
         NLST1=NLIST(ISYMK,ISYM,15)
         VAL1(1)= 1.0D00
         VAL1(2)=-1.0D00
       END IF
       IF(NLST1.EQ.0) GOTO 903
       INCX1=1
       INCX2=NIN
       INCX3=NIN*NK
       INCY1=1
       INCY2=NIN
       LEN1=NIN
       CALL MLTUNF(LIST(LLST1),WORK(LX1),VEC1)
       CALL MLTUNF(LIST(LLST1),WORK(LX2),VEC2)
C D(I,J) := Add contraction -X2(MU,K,I)*X1(MU,K,J):
       IDIJ=1+IOFDIJ(ISYMI)
       NO=NORB(ISYMI)
       CALL DGEMM_('T','N',NI,NI,NIN*NK,-1.0D00,
     &            WORK(LX2),NIN*NK,WORK(LX1),NIN*NK,
     &            1.0D00,DPT2(IDIJ),NO)
 903   CONTINUE
      END DO
      CALL GETMEM('DIA_X1','FREE','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','FREE','REAL',LX2,NX)
      GOTO 100
C -----------------------------------------------
   4  CONTINUE
C Case C
      NS=NSSH(ISYM)
      NO=NORB(ISYM)
      DO IA=1,NS
        IV1=1+NIN*(IA-1)
        DO IB=1,NS
          IDAB=IOFDAB(ISYM)+IA+NO*(IB-1)
          IV2=1+NIN*(IB-1)
          DPT2(IDAB)=DPT2(IDAB)+
     &          DDOT_(NIN,VEC1(IV1),1,VEC2(IV2),1)
        END DO
      END DO
      GOTO 100
C -----------------------------------------------
   5  CONTINUE
C Case D
      DO ISYMA=1,NSYM
       NS=NSSH(ISYMA)
       NOA=NORB(ISYMA)
       ISYMI=MUL(ISYMA,ISYM)
       NI=NISH(ISYMI)
       NOI=NORB(ISYMI)
       IV=1+NIN*IOFCD(ISYM,ISYMA)
       INCA=NIN*NI
       DO II=1,NI
         IV2=IV+NIN*(II-1)
         DO IJ=1,NI
           IDIJ=IOFDIJ(ISYMI)+II+NOI*(IJ-1)
           SUM=DPT2(IDIJ)
           IV1=IV+NIN*(IJ-1)
           DO IA=1,NS
             IV11=IV1+INCA*(IA-1)
             IV22=IV2+INCA*(IA-1)
             SUM=SUM-DDOT_(NIN,VEC1(IV11),1,VEC2(IV22),1)
           END DO
           DPT2(IDIJ)=SUM
         END DO
       END DO
       DO IA=1,NS
         IV1=IV+INCA*(IA-1)
         DO IB=1,NS
           IDAB=IOFDAB(ISYMA)+IA+NOA*(IB-1)
           IV2=IV+INCA*(IB-1)
             DPT2(IDAB)=DPT2(IDAB)+
     &             DDOT_(INCA,VEC1(IV1),1,VEC2(IV2),1)
         END DO
       END DO
      END DO

      GOTO 100
C -----------------------------------------------
   6  CONTINUE
C Case EP
   7  CONTINUE
C Case EM
      NX=NIN*NSMX*NIMX**2
      CALL GETMEM('DIA_X1','ALLO','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','ALLO','REAL',LX2,NX)
      IYOFF=0
      DO ISYMA=1,NSYM
       ISYMKI=MUL(ISYMA,ISYM)
       NA=NSSH(ISYMA)
       NOA=NORB(ISYMA)
       IF(ICASE.EQ.6) NKIY=NIGEJ(ISYMKI)
       IF(ICASE.EQ.7) NKIY=NIGTJ(ISYMKI)
       IY=1+IYOFF
C First, contributions to DIJ.
C Unfold VEC1 and VEC2 into X1(MU,A;K,I), X2(MU,A;K,I):
       DO ISYMK=1,NSYM
        ISYMI=MUL(ISYMK,ISYMKI)
        NK=NISH(ISYMK)
        NI=NISH(ISYMI)
        NAKI=NA*NK*NI
        IF(NAKI.EQ.0) GOTO 907
        CALL DCOPY_(NIN*NAKI,[0.0D0],0,WORK(LX1),1)
        CALL DCOPY_(NIN*NAKI,[0.0D0],0,WORK(LX2),1)
        IF(ICASE.EQ.6) THEN
          LLST1=LLIST(ISYMK,ISYMKI,14)
          NLST1=NLIST(ISYMK,ISYMKI,14)
          VAL1(1)= 1.0D00
          VAL1(2)= SQR2
        ELSE IF(ICASE.EQ.7) THEN
          LLST1=LLIST(ISYMK,ISYMKI,15)
          NLST1=NLIST(ISYMK,ISYMKI,15)
          VAL1(1)= 1.0D00
          VAL1(2)=-1.0D00
        END IF
        IF(NLST1.EQ.0) GOTO 907
        INCX1=1
        INCX2=NIN*NA
        INCX3=NIN*NA*NK
        INCY1=1
        INCY2=NIN*NA
        LEN1=NIN*NA
        CALL MLTUNF(LIST(LLST1),WORK(LX1),VEC1(IY))
        CALL MLTUNF(LIST(LLST1),WORK(LX2),VEC2(IY))
C  D(I,J) := Add contraction -X2(MU,A,K,I)*X1(MU,A,K,J):
        IDIJ=1+IOFDIJ(ISYMI)
        NOI=NORB(ISYMI)
        CALL DGEMM_('T','N',NI,NI,NIN*NA*NK,-1.0D00,
     &             WORK(LX2),NIN*NA*NK,WORK(LX1),NIN*NA*NK,
     &             1.0D00,DPT2(IDIJ),NOI)
 907    CONTINUE
       END DO
C Second, contributions to DAB.
       IF(NKIY.GT.0) THEN
        DO IA=1,NA
         DO IB=1,NA
          IDAB=IOFDAB(ISYMA)+IA+NOA*(IB-1)
          SUM=DPT2(IDAB)
          DO MU=1,NIN
            IY1=IYOFF+MU+NIN*(IA-1)
            IY2=IYOFF+MU+NIN*(IB-1)
            SUM=SUM+DDOT_(NKIY,VEC1(IY1),INCY2,VEC2(IY2),INCY2)
          END DO
          DPT2(IDAB)=SUM
         END DO
        END DO
       END IF
       IYOFF=IYOFF+NIN*NA*NKIY
      END DO
      CALL GETMEM('DIA_X1','FREE','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','FREE','REAL',LX2,NX)
      GOTO 100
C -----------------------------------------------
   8  CONTINUE
C Case FP
   9  CONTINUE
C Case FM
C Unfold VEC1 and VEC2 into X1(MU,C,A), X2(MU,C,B):
      NX=NIN*NSMX**2
      CALL GETMEM('DIA_X1','ALLO','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','ALLO','REAL',LX2,NX)
      DO ISYMC=1,NSYM
       ISYMA=MUL(ISYMC,ISYM)
       NC=NSSH(ISYMC)
       NA=NSSH(ISYMA)
       NCA=NC*NA
       IF(NCA.EQ.0) GOTO 909
       CALL DCOPY_(NIN*NCA,[0.0D0],0,WORK(LX1),1)
       CALL DCOPY_(NIN*NCA,[0.0D0],0,WORK(LX2),1)
       IF(ICASE.EQ.8) THEN
         LLST1=LLIST(ISYMC,ISYM,16)
         NLST1=NLIST(ISYMC,ISYM,16)
         VAL1(1)= 1.0D00
         VAL1(2)= SQR2
       ELSE IF(ICASE.EQ.9) THEN
         LLST1=LLIST(ISYMC,ISYM,17)
         NLST1=NLIST(ISYMC,ISYM,17)
         VAL1(1)= 1.0D00
         VAL1(2)=-1.0D00
       END IF
       IF(NLST1.EQ.0) GOTO 909
       INCX1=1
       INCX2=NIN
       INCX3=NIN*NC
       INCY1=1
       INCY2=NIN
       LEN1=NIN
       CALL MLTUNF(LIST(LLST1),WORK(LX1),VEC1)
       CALL MLTUNF(LIST(LLST1),WORK(LX2),VEC2)
C D(A,B) := Add contraction  X1(MU,C,A)*X2(MU,C,B):
       IDAB=1+IOFDAB(ISYMA)
       NOA=NORB(ISYMA)
       CALL DGEMM_('T','N',NA,NA,NIN*NC,+1.0D00,
     &            WORK(LX1),NIN*NC,WORK(LX2),NIN*NC,
     &            1.0D00,DPT2(IDAB),NOA)
 909   CONTINUE
      END DO
      CALL GETMEM('DIA_X1','FREE','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','FREE','REAL',LX2,NX)
      GOTO 100
C -----------------------------------------------
  10  CONTINUE
C Case GP
  11  CONTINUE
C Case GM
      NX=NIN*NIMX*NSMX**2
      CALL GETMEM('DIA_X1','ALLO','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','ALLO','REAL',LX2,NX)
      IYOFF=0
      DO ISYMI=1,NSYM
       ISYMCA=MUL(ISYMI,ISYM)
       NI=NISH(ISYMI)
       NOI=NORB(ISYMI)
       IF(ICASE.EQ.10) NCAY=NAGEB(ISYMCA)
       IF(ICASE.EQ.11) NCAY=NAGTB(ISYMCA)
       IY=1+IYOFF
C First, contributions to DAB.
C Unfold VEC1 and VEC2 into X1(MU,I;C,A), X2(MU,I;C,A):
       DO ISYMC=1,NSYM
        ISYMA=MUL(ISYMC,ISYMCA)
        NC=NSSH(ISYMC)
        NA=NSSH(ISYMA)
        NICA=NI*NC*NA
        IF(NICA.EQ.0) GOTO 911
        CALL DCOPY_(NIN*NICA,[0.0D0],0,WORK(LX1),1)
        CALL DCOPY_(NIN*NICA,[0.0D0],0,WORK(LX2),1)
        IF(ICASE.EQ.10) THEN
          LLST1=LLIST(ISYMC,ISYMCA,16)
          NLST1=NLIST(ISYMC,ISYMCA,16)
          VAL1(1)= 1.0D00
          VAL1(2)= SQR2
        ELSE IF(ICASE.EQ.11) THEN
          LLST1=LLIST(ISYMC,ISYMCA,17)
          NLST1=NLIST(ISYMC,ISYMCA,17)
          VAL1(1)= 1.0D00
          VAL1(2)=-1.0D00
        END IF
        IF(NLST1.EQ.0) GOTO 911
        INCX1=1
        INCX2=NIN*NI
        INCX3=NIN*NI*NC
        INCY1=1
        INCY2=NIN*NI
        LEN1=NIN*NI
        CALL MLTUNF(LIST(LLST1),WORK(LX1),VEC1(IY))
        CALL MLTUNF(LIST(LLST1),WORK(LX2),VEC2(IY))
C  D(A,B) := Add contraction +X1(MU,I,C,A)*X2(MU,I,C,B):
        IDAB=1+IOFDAB(ISYMA)
        NOA=NORB(ISYMA)
        CALL DGEMM_('T','N',NA,NA,NIN*NI*NC,+1.0D00,
     &             WORK(LX1),NIN*NI*NC,WORK(LX2),NIN*NI*NC,
     &             1.0D00,DPT2(IDAB),NOA)
 911    CONTINUE
       END DO
C Second, contributions to DIJ.
       IF(NCAY.GT.0) THEN
        DO II=1,NI
         DO IJ=1,NI
          IDIJ=IOFDIJ(ISYMI)+II+NOI*(IJ-1)
          SUM=DPT2(IDIJ)
          DO MU=1,NIN
            IY1=IYOFF+MU+NIN*(IJ-1)
            IY2=IYOFF+MU+NIN*(II-1)
            SUM=SUM-DDOT_(NCAY,VEC1(IY1),INCY2,VEC2(IY2),INCY2)
          END DO
          DPT2(IDIJ)=SUM
         END DO
        END DO
       END IF
       IYOFF=IYOFF+NIN*NI*NCAY
      END DO
      CALL GETMEM('DIA_X1','FREE','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','FREE','REAL',LX2,NX)
      GOTO 100
C -----------------------------------------------
  12  CONTINUE
C Case HP
  13  CONTINUE
C Case HM
C Unfold VEC1 and VEC2 into X1(MU,K,I), X2(MU,K,I):
      NX=NAS*NIMX**2
      CALL GETMEM('DIA_X1','ALLO','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','ALLO','REAL',LX2,NX)
      DO ISYMK=1,NSYM
       ISYMI=MUL(ISYMK,ISYM)
       NK=NISH(ISYMK)
       NI=NISH(ISYMI)
       NKI=NK*NI
       IF(NKI.EQ.0) GOTO 813
       CALL DCOPY_(NAS*NKI,[0.0D0],0,WORK(LX1),1)
       CALL DCOPY_(NAS*NKI,[0.0D0],0,WORK(LX2),1)
       IF(ICASE.EQ.12) THEN
         LLST1=LLIST(ISYMK,ISYM,14)
         NLST1=NLIST(ISYMK,ISYM,14)
         VAL1(1)= 1.0D00
         VAL1(2)= SQR2
       ELSE IF(ICASE.EQ.13) THEN
         LLST1=LLIST(ISYMK,ISYM,15)
         NLST1=NLIST(ISYMK,ISYM,15)
         VAL1(1)= 1.0D00
         VAL1(2)=-1.0D00
       END IF
       IF(NLST1.EQ.0) GOTO 813
       INCX1=1
       INCX2=NAS
       INCX3=NAS*NK
       INCY1=1
       INCY2=NAS
       LEN1=NAS
       CALL MLTUNF(LIST(LLST1),WORK(LX1),VEC1)
       CALL MLTUNF(LIST(LLST1),WORK(LX2),VEC2)
C D(I,J) := Add contraction -X2(MU,K,I)*X1(MU,K,J):
       IDIJ=1+IOFDIJ(ISYMI)
       NOI=NORB(ISYMI)
       CALL DGEMM_('T','N',NI,NI,NAS*NK,-1.0D00,
     &            WORK(LX2),NAS*NK,WORK(LX1),NAS*NK,
     &            1.0D00,DPT2(IDIJ),NOI)
 813   CONTINUE
      END DO
      CALL GETMEM('DIA_X1','FREE','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','FREE','REAL',LX2,NX)
C Unfold VEC1 and VEC2 into X1(A,C,IJ), X2(A,C,IJ):
      NX=NIS*NSMX**2
      CALL GETMEM('DIA_X1','ALLO','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','ALLO','REAL',LX2,NX)
      DO ISYMC=1,NSYM
       ISYMA=MUL(ISYMC,ISYM)
       NC=NSSH(ISYMC)
       NA=NSSH(ISYMA)
       NCA=NC*NA
       IF(NCA.EQ.0) GOTO 913
       CALL DCOPY_(NIS*NCA,[0.0D0],0,WORK(LX1),1)
       CALL DCOPY_(NIS*NCA,[0.0D0],0,WORK(LX2),1)
       IF(ICASE.EQ.12) THEN
         LLST1=LLIST(ISYMA,ISYM,16)
         NLST1=NLIST(ISYMA,ISYM,16)
         VAL1(1)= 1.0D00
         VAL1(2)= SQR2
       ELSE IF(ICASE.EQ.13) THEN
         LLST1=LLIST(ISYMA,ISYM,17)
         NLST1=NLIST(ISYMA,ISYM,17)
         VAL1(1)= 1.0D00
         VAL1(2)=-1.0D00
       END IF
       IF(NLST1.EQ.0) GOTO 913
       INCX1=NCA
       INCX2=1
       INCX3=NA
       INCY1=NAS
       INCY2=1
       LEN1=NIS
       CALL MLTUNF(LIST(LLST1),WORK(LX1),VEC1)
       CALL MLTUNF(LIST(LLST1),WORK(LX2),VEC2)
C D(A,B) := Add contraction  X1(A,C,IJ)*X2(B,C,IJ):
       IDAB=1+IOFDAB(ISYMA)
       NOA=NORB(ISYMA)
       CALL DGEMM_('N','T',NA,NA,NIS*NC,+1.0D00,
     &            WORK(LX1),NA,WORK(LX2),NA,
     &            1.0D00,DPT2(IDAB),NOA)
 913   CONTINUE
      END DO
      CALL GETMEM('DIA_X1','FREE','REAL',LX1,NX)
      CALL GETMEM('DIA_X2','FREE','REAL',LX2,NX)
      GOTO 100
C -----------------------------------------------
 100  CONTINUE

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Giovanni Ghigo                                   *
!***********************************************************************

subroutine OutZMAT(nAtoms,XYZCoords,N_ZMAT)
!***********************************************************************
! Author: Giovanni Ghigo                                               *
!         Torino (Italy)  February-March 2007                          *
!                                                                      *
! This subroutine generates the nuclear coordinates in Z-matrix        *
! format using the connection indices recovered from RunFile.          *
! Remember:                                                            *
!           X dummy atoms - NAT(i)= 0 - are included in SEWARD         *
!           Z ghost atoms - NAT(i)=-1 - are NOT included in SEWARD     *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Angstrom, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms, N_ZMAT
real(kind=wp), intent(inout) :: XYZCoords(3,nAtoms)
integer(kind=iwp) :: i, iAtom, iAX, iBonded, iRX, iTX, j, LuWr
real(kind=wp) :: alpha, arccos, bond, Bt(3,4), CTX(3,4), dBt(3,4,3,4), dMaxTrasl, dvec2, dXYZ(3), dXYZ2(3), prod, theta
logical(kind=iwp) :: IfTest
character(len=8) :: Label
character(len=5), allocatable :: Symbols(:)
integer(kind=iwp), allocatable :: iZmat(:,:), NAT(:)
real(kind=wp), allocatable :: ZMAT(:,:), ZMATCoords(:,:)
real(kind=wp), parameter :: ThrsTrasl = One  ! Threshold for warning

call mma_allocate(Symbols,N_ZMAT,Label='Symbols')
call mma_allocate(NAT,N_ZMAT,Label='NAT')
call mma_allocate(ZMATCoords,3,N_ZMAT,Label='ZMATCoords')
call mma_allocate(ZMAT,N_ZMAT,3,Label='ZMAT')

#ifdef _DEBUGPRINT_
IfTest = .true.
#else
IfTest = .false.
#endif

LuWr = u6
dMaxTrasl = Zero
Label = ' '
ZMAT(:,:) = Zero
ZMATCoords(:,:) = Zero
call Get_cArray('Symbol ZMAT',Symbols,N_ZMAT*5)
call mma_allocate(iZmat,3,N_ZMAT,label='iZmat')
call Get_iArray('Index ZMAT',iZmat,N_ZMAT*3)
call Get_iArray('NAT ZMAT',NAT,N_ZMAT)

if (IfTest) then
  write(LuWr,*)
  write(LuWr,*) '------------------------------------------------'
  write(LuWr,*) 'OutZMat - Z-Matrix Data :'
  write(LuWr,*) '          N_ZMAT=',N_ZMAT
  write(LuWr,*) '   Label  NA      i   j   k'
  do i=1,N_ZMAT
    write(LuWr,97) i,Symbols(i),NAT(i),(iZmat(j,i),j=1,3)
  end do
  write(LuWr,*)
  write(LuWr,*) '------------------------------------------------'
  write(LuWr,*) 'OutZMat - XYZCoords (angstrom):'
  do i=1,nAtoms
    write(LuWr,98) i,(Angstrom*XYZCoords(j,i),j=1,3)
  end do
  write(LuWr,*)
end if

if (N_ZMAT < 3) return
if (N_ZMAT > nAtoms+3) then
  write(LuWr,'(A)') ' ZMAT cannot be defined :'
  write(LuWr,'(A)') ' Too many ghost Z atoms. '
  return
end if

! Z are ghost atoms
! A are both dummy (X) and real atoms

! Z  Z  Z
if ((NAT(1) == -1) .and. (NAT(2) == -1) .and. (NAT(3) == -1)) then
  iBonded = 0
  do i=4,N_ZMAT
    if ((iZmat(1,i) == 2) .and. (iBonded == 0)) iBonded = i
  end do
  if (iBonded == 0) then
    ZMATCoords(3,2) = One/Angstrom
  else
    ZMATCoords(3,2) = XYZCoords(3,iBonded-3)
  end if
  iBonded = 0
  do i=4,N_ZMAT
    if ((iZmat(1,i) == 3) .and. (iBonded == 0)) iBonded = i
  end do
  if (iBonded == 0) then
    ZMATCoords(1,3) = One/Angstrom
  else
    ZMATCoords(1,3) = XYZCoords(1,iBonded-3)
  end if
  if (iZmat(1,3) == 2) ZMATCoords(3,3) = ZMATCoords(3,2)
  ZMATCoords(:,4:N_ZMAT) = XYZCoords(:,1:N_ZMAT-3)
end if

! Z  Z  A
if ((NAT(1) == -1) .and. (NAT(2) == -1) .and. (NAT(3) >= 0)) then
  iBonded = 0
  do i=3,N_ZMAT
    if ((iZmat(1,i) == 2) .and. (iBonded == 0)) iBonded = i
  end do
  if (iBonded == 0) then
    ZMATCoords(3,2) = One/Angstrom
  else
    ZMATCoords(3,2) = XYZCoords(3,iBonded-2)
  end if
  ZMATCoords(:,3:N_ZMAT) = XYZCoords(:,1:N_ZMAT-2)
end if

! Z  A  Z
if ((NAT(1) == -1) .and. (NAT(3) == -1) .and. (NAT(2) >= 0)) then
  dMaxTrasl = Zero
  dXYZ(:) = XYZCoords(:,1)
  do iAtom=1,N_ZMAT-2
    XYZCoords(1:2,iAtom) = XYZCoords(1:2,iAtom)-dXYZ(1:2)
  end do
  ZMATCoords(:,2) = XYZCoords(:,1)
  dMaxTrasl = maxval(abs(dXYZ(1:2)))
  if (dMaxTrasl >= ThrsTrasl) write(LuWr,'(A)') '  Warning: MaxTrasl >= ThrsTrasl for atom ',Symbols(2)
  if (iZmat(1,3) == 2) ZMATCoords(3,3) = ZMATCoords(3,2)
  iBonded = 0
  do i=4,N_ZMAT
    if ((iZmat(1,i) == 3) .and. (iBonded == 0)) iBonded = i
  end do
  if (iBonded == 0) then
    ZMATCoords(1,3) = One/Angstrom
  else
    ZMATCoords(1,3) = XYZCoords(1,iBonded-2)
  end if
  ZMATCoords(:,4:N_ZMAT) = XYZCoords(:,2:N_ZMAT-2)
end if

! A  Z  Z
if ((NAT(1) >= 0) .and. (NAT(2) == -1) .and. (NAT(3) == -1)) then
  dXYZ(:) = XYZCoords(:,1)
  do iAtom=1,N_ZMAT-2
    XYZCoords(:,iAtom) = XYZCoords(:,iAtom)-dXYZ(:)
  end do
  dMaxTrasl = maxval(abs(dXYZ(:)))
  if (dMaxTrasl >= ThrsTrasl) write(LuWr,'(A)') '  Warning: MaxTrasl >= ThrsTrasl for atom ',Symbols(1)
  iBonded = 0
  do i=4,N_ZMAT
    if ((iZmat(1,i) == 2) .and. (iBonded == 0)) iBonded = i
  end do
  if (iBonded == 0) then
    ZMATCoords(3,2) = One/Angstrom
  else
    ZMATCoords(3,2) = XYZCoords(3,iBonded-2)
  end if
  iBonded = 0
  do i=4,N_ZMAT
    if ((iZmat(1,i) == 3) .and. (iBonded == 0)) iBonded = i
  end do
  if (iBonded == 0) then
    ZMATCoords(1,3) = One/Angstrom
  else
    ZMATCoords(1,3) = XYZCoords(1,iBonded-2)
  end if
  ZMATCoords(:,4:N_ZMAT) = XYZCoords(:,2:N_ZMAT-2)
end if

! Z  A  B
if ((NAT(1) == -1) .and. (NAT(2) >= 0) .and. (NAT(3) >= 0)) then
  dXYZ(:) = XYZCoords(:,1)
  dXYZ(3) = Zero
  do iAtom=2,N_ZMAT
    ZMATCoords(:,iAtom) = XYZCoords(:,iAtom-1)-dXYZ(:)
  end do
  dMaxTrasl = maxval(abs(dXYZ(:)))
  if (dMaxTrasl >= ThrsTrasl) write(LuWr,'(A)') '  Warning: MaxTrasl >= ThrsTrasl for atom ',Symbols(2)
end if

! A  Z  B
if ((NAT(1) >= 0) .and. (NAT(2) == -1) .and. (NAT(3) >= 0)) then
  dXYZ = XYZCoords(:,1)
  do iAtom=1,N_ZMAT-1
    XYZCoords(:,iAtom) = XYZCoords(:,iAtom)-dXYZ(:)
  end do
  dMaxTrasl = maxval(abs(dXYZ(:)))
  if (dMaxTrasl >= ThrsTrasl) write(LuWr,'(A)') '  Warning: MaxTrasl >= ThrsTrasl for atom ',Symbols(1)
  iBonded = 0
  do i=3,N_ZMAT
    if ((iZmat(1,i) == 2) .and. (iBonded == 0)) iBonded = i
  end do
  if (iBonded == 0) then
    ZMATCoords(3,2) = One/Angstrom
  else
    ZMATCoords(3,2) = XYZCoords(3,iBonded-1)
  end if
  ZMATCoords(:,3:N_ZMAT) = XYZCoords(:,2:N_ZMAT-1)
end if

! A  B  Z
if ((NAT(1) >= 0) .and. (NAT(2) >= 0) .and. (NAT(3) == -1)) then
  dMaxTrasl = Zero
  dXYZ = XYZCoords(:,1)
  do iAtom=1,N_ZMAT-1
    XYZCoords(:,iAtom) = XYZCoords(:,iAtom)-dXYZ(:)
  end do
  dMaxTrasl = maxval(abs(dXYZ(:)))
  if (dMaxTrasl >= ThrsTrasl) write(LuWr,'(A)') '  Warning: MaxTrasl >= ThrsTrasl for atom ',Symbols(1)
  ZMATCoords(:,2) = XYZCoords(:,2)
  if (iZmat(1,3) == 1) then
    iBonded = 0
    do i=4,N_ZMAT
      if ((iZmat(1,i) == 3) .and. (iBonded == 0)) iBonded = i
    end do
    if (iBonded == 0) then
      ZMATCoords(1,3) = One/Angstrom
    else
      ZMATCoords(1,3) = XYZCoords(1,iBonded-2)
    end if
  else
    ZMATCoords(:,3) = XYZCoords(:,2)
    ZMATCoords(1,3) = XYZCoords(1,2)+One/Angstrom
  end if
  ZMATCoords(:,4:N_ZMAT) = XYZCoords(:,3:N_ZMAT-1)
end if

! A  B  C
if ((NAT(1) >= 0) .and. (NAT(2) >= 0) .and. (NAT(3) >= 0)) ZMATCoords(:,:) = XYZCoords(:,1:N_ZMAT)

if (IfTest) then
  write(LuWr,*)
  write(LuWr,*) '------------------------------------------------'
  write(LuWr,*) 'OutZMat - ZMATCoords : '
  do i=1,N_ZMAT
    write(LuWr,99) i,NAT(i),(Angstrom*ZMATCoords(j,i),j=1,3)
  end do
end if

iAtom = 2
iRX = iZMAT(1,iAtom)
dXYZ(:) = ZMATCoords(:,iAtom)-ZMATCoords(:,iRX)
bond = sqrt(sum(dXYZ(:)**2))
ZMAT(iAtom,1) = bond*Angstrom

if (N_ZMAT >= 3) then
  iAtom = 3
  iRX = iZMAT(1,iAtom)
  iAX = iZMAT(2,iAtom)
  dXYZ(:) = ZMATCoords(:,iAtom)-ZMATCoords(:,iRX)
  dXYZ2(:) = ZMATCoords(:,iAX)-ZMATCoords(:,iRX)
  bond = sqrt(sum(dXYZ(:)**2))
  ZMAT(iAtom,1) = bond*Angstrom
  prod = sum(dXYZ(:)*dXYZ2(:))
  dvec2 = sqrt(sum(dXYZ2(:)**2))
  arccos = prod/(bond*dvec2)
  if (arccos > One) arccos = sign(One,arccos)
  alpha = acos(arccos)
  ZMAT(iAtom,2) = alpha/deg2rad
end if

if (N_ZMAT >= 4) then
  do iAtom=4,N_ZMAT
    if (NAT(iAtom) == -1) then
      write(LuWr,'(A)') ' ZMAT cannot be defined :'
      write(LuWr,'(A)') ' Found X atom.           '
      return
    end if
    iRX = iZMAT(1,iAtom)
    iAX = iZMAT(2,iAtom)
    iTX = iZMAT(3,iAtom)
    dXYZ(:) = ZMATCoords(:,iAtom)-ZMATCoords(:,iRX)
    dXYZ2(:) = ZMATCoords(:,iAX)-ZMATCoords(:,iRX)
    bond = sqrt(sum(dXYZ(:)**2))
    ZMAT(iAtom,1) = bond*Angstrom
    prod = sum(dXYZ(:)*dXYZ2(:))
    dvec2 = sqrt(sum(dXYZ2(:)**2))
    arccos = prod/(bond*dvec2)
    if (arccos > One) arccos = sign(One,arccos)
    alpha = acos(arccos)
    ZMAT(iAtom,2) = alpha/deg2rad
    CTX(:,1) = ZMATCoords(:,iTX)
    CTX(:,2) = ZMATCoords(:,iAX)
    CTX(:,3) = ZMATCoords(:,iRX)
    CTX(:,4) = ZMATCoords(:,iAtom)
    call Trsn(CTX,4,theta,Bt,.false.,.false.,Label,dBt,.false.)
    ZMAT(iAtom,3) = -theta/deg2rad
  end do
end if

write(LuWr,*)
write(LuWr,*) '****************************************************************'
write(LuWr,*) '* Nuclear coordinates in Z-Matrix format / angstrom and degree *'
write(LuWr,*) '----------------------------------------------------------------'
do i=1,N_ZMAT
  if (i == 1) write(LuWr,201) Symbols(i)
  if (i == 2) write(LuWr,202) Symbols(i),iZmat(1,i),ZMAT(i,1)
  if (i == 3) write(LuWr,203) Symbols(i),(iZmat(j,i),ZMAT(i,j),j=1,2)
  if (i >= 4) write(LuWr,204) Symbols(i),(iZmat(j,i),ZMAT(i,j),j=1,3)
end do
call mma_deallocate(iZmat)
write(LuWr,*)

call mma_deallocate(ZMAT)
call mma_deallocate(ZMATCoords)
call mma_deallocate(NAT)
call mma_deallocate(Symbols)

return

97 format(I3,1X,A,1X,I3,3X,3I4)
98 format(I3,1X,3(F12.6))
99 format(I3,1X,I3,1X,3(F12.6))
201 format(5X,A5)
202 format(5X,A5,1X,I4,F13.6)
203 format(5X,A5,1X,2(I4,F13.6))
204 format(5X,A5,1X,3(I4,F13.6))

end subroutine OutZMAT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
! This routine dumps doubles in xml format.                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Author:  Per-Olof Widmark                                            *
!          Lund University, Sweden                                     *
!                                                                      *
!***********************************************************************

subroutine xml_dDump(TagName,Appear,Units,Level,Content,nx,ny)

use Definitions, only: wp, iwp

implicit none
!----------------------------------------------------------------------*
! Dummy arguments                                                      *
!----------------------------------------------------------------------*
character(len=*), intent(in) :: TagName, Appear, Units
real(kind=wp), intent(in) :: Content(*)
integer(kind=iwp), intent(in) :: nx, ny, Level
interface
  subroutine xml_ddumpc(name_,nx_name,appear,nx_appear,units,nx_units,Level,data_,nxx,nyx) bind(C,name='xml_ddumpc_')
    use, intrinsic :: iso_c_binding, only: c_char
    use Definitions, only: MOLCAS_C_INT, MOLCAS_C_REAL
    character(kind=c_char) :: name_(*), appear(*), units(*)
    integer(kind=MOLCAS_C_INT) :: nx_name, nx_appear, nx_units, Level, nxx, nyx
    real(kind=MOLCAS_C_REAL) :: data_(*)
  end subroutine xml_ddumpc
end interface
!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
call xml_ddumpc(TagName,len(TagName),Appear,len(Appear),Units,len(Units),Level,Content,nx,ny)
!----------------------------------------------------------------------*
! Done                                                                 *
!----------------------------------------------------------------------*
return

end subroutine xml_dDump

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function IDMIN(N,X,INCX)
! FINDS THE INDEX OF ELEMENT HAVING MIN. VALUE.

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: IDMIN
integer(kind=iwp), intent(in) :: N, INCX
real(kind=wp), intent(in) :: X(*)
integer(kind=iwp) :: I, IXX
real(kind=wp) :: DMIN

IDMIN = 0
if (N >= 1) then
  IDMIN = 1
  if (N /= 1) then
    if (INCX /= 1) then
      ! CODE FOR INCREMENT NOT EQUAL TO 1
      IXX = 1
      DMIN = X(1)
      IXX = IXX+INCX
      do I=2,N
        if (X(IXX) < DMIN) then
          IDMIN = I
          DMIN = X(IXX)
        end if
        IXX = IXX+INCX
      end do
    else
      ! CODE FOR INCREMENT EQUAL TO 1
      DMIN = X(1)
      do I=2,N
        if (X(I) < DMIN) then
          IDMIN = I
          DMIN = X(I)
        end if
      end do
    end if
  end if
end if

return

end function IDMIN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
C
      SUBROUTINE SECORD(A,B,C,FAC,NAL,NBL,NSIJ,IFT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*),B(*),C(*)
      IAB=0
      NAA=0
      DO 10 NA=1,NAL
      NBB=0
      NA1=NBL
      IF(NSIJ.EQ.1)NA1=NA-1
      IF(NA1.EQ.0)GO TO 15
      DO 20 NB=1,NA1
      IAB=IAB+1
      IF(IFT.EQ.0)C(IAB)=B(NAA+NB)+A(NBB+NA)
      IF(IFT.EQ.1)C(IAB)=B(NAA+NB)-A(NBB+NA)
      NBB=NBB+NAL
20    CONTINUE
15    IF(NSIJ.NE.1)GO TO 35
      IAB=IAB+1
      C(IAB)=FAC*A(NAA+NA)
35    NAA=NAA+NBL
10    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Pavel Neogrady                                   *
!***********************************************************************

subroutine grc0stack(bsize,typ,typp,typq,typr,typs,stot,post,map)
! This routine defines %d and %i for specific
! 3 index intermediate A(pq,Bp), needed when stacking
! (About Bp, see notes in multstack)
! This routine is a modification of grc0 routine
! P.N. 17.02.06
!
! N.B. (this routine cannot run with +OP2)

use ccsd_global, only: dimm, Map_Type, mmul, nsym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: bsize, typ, typp, typq, typr, typs, stot
integer(kind=iwp), intent(out) :: post
type(Map_Type), intent(inout) :: map
integer(kind=iwp) :: i, nhelp1, nhelp2, pos, sp, sq

! To get rid of compiler warning
pos = 0
i = 0

! vanishing %i files

map%i(1:nsym,1:nsym,1:nsym) = 0

! matrix A(p,q) or specifically A(i,j,Bp)

i = 1
pos = map%pos0

do sp=1,nsym

  sq = mmul(stot,sp)
  ! Meggie out
  if ((typ == 1) .and. (sp < sq)) cycle

  nhelp1 = dimm(typp,sp)
  nhelp2 = dimm(typq,sq)

  ! def %i
  map%i(sp,1,1) = i

  ! def position
  map%d(i,1) = pos

  ! def length
  if ((typ == 1) .and. (sp == sq)) then
    map%d(i,2) = bsize*nhelp1*(nhelp1-1)/2
  else
    map%d(i,2) = bsize*nhelp1*nhelp2
  end if

  ! def sym p,q
  map%d(i,3) = sp
  map%d(i,4) = sq
  map%d(i,5) = 0
  map%d(i,6) = 0

  pos = pos+map%d(i,2)
  i = i+1

end do

post = pos

! definition of other coll

map%d(0,1) = typp
map%d(0,2) = typq
map%d(0,3) = typr
map%d(0,4) = typs
map%d(0,5) = i-1
map%d(0,6) = typ

return

end subroutine grc0stack

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine EditStart
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

      Parameter (ThrdSpread=1.0d0)
      Dimension iC(3),iC2(3)
      Dimension Coord(MxCen*MxPut,3),Coo(MxCen,3),CooRef(MxCen,3)
      Character Filstart*6,FilSlut*6,Head*200
      Logical Exist,ValidOrNot

*
*-- Inquire if file exists, and if so open it.
*
      Write(FilStart,'(A5,i1.1)')'STFIL',NrStarti
      Call f_Inquire(FilStart,Exist)
      If(.not.Exist) then
        Write(6,*)
        Write(6,*)'The input startfile given in the EDITstartfile'
     &//' section was not found.'
        Call Quit(_RC_IO_ERROR_READ_)
      Endif
      iLu=73
      Call DaName(iLu,Filstart)

*
*-- Read header and coordinates.
*
      iDisk=0
      Call WrRdSim(iLu,2,iDisk,iTcSim,64,Etot,Ract,nPart,Gamold
     &            ,GaOld,Esub)
      iDisk=iTcSim(1)
      Do 5,l=1,3
        Call GetMem('Coordinates','Allo','Real',iC(l),nPart*nCent)
        Call dDaFile(iLu,2,Work(iC(l)),nPart*nCent,iDisk)
5     Continue
      Call DaClos(iLu)

*
*-- Now take different paths depending of what user have requested in
*   the input.
*

*
*-- If deleting solvent molecules.
*
      If(DelOrAdd(1)) then
*
*----Find the solvent molecules fartherst away from origo and
*    delete them.
*
        Do 10, i=1,nDel
          rMax=0.0d0
          indMax=0
          Do 20, j=1,nPart
            r=0.0d0
            Do 30, k=1,3
              r=r+Work(iC(k)+(j-1)*nCent)**2
30          Continue
            If(r.gt.rMax) then
              rMax=r
              indMax=j
            Endif
20        Continue
          Do 40, j=indMax,nPart-i
            Do 50, l=1,3
              Do 60, ll=1,nCent
                Work(iC(l)+(j-1)*nCent+ll-1)=Work(iC(l)+j*nCent+ll-1)
60            Continue
50          Continue
40        Continue
10      Continue
*
*----Print the new set of coordinates to a startfile.
*
        iLu=74
        Write(FilSlut,'(A5,i1.1)')'STFIL',NrStartu
        Call DaName(iLu,FilSlut)
        iDisk=0
        Call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,Ract,nPart-nDel,Gamold
     &              ,Gaold,Esub)
        iTcSim(1)=iDisk
        Do 70, l=1,3
          Call dDaFile(iLu,1,Work(iC(l)),(nPart-nDel)*nCent,iDisk)
          iTcSim(1+l)=iDisk
70      Continue
        iDisk=0
        Call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,Ract,nPart-nDel,Gamold
     &              ,Gaold,Esub)
        Call DaClos(iLu)
*
*----If user wants, print print print.
*
        If(iPrint.ge.10) then
          Do 1001, i=1,(nPart-nDel)*nCent
            Coord(i,1)=Work(iC(1)+i-1)
            Coord(i,2)=Work(iC(2)+i-1)
            Coord(i,3)=Work(iC(3)+i-1)
1001      Continue
          Write(Head,*)'Final coordinates'
          Call Cooout(Head,Coord,nPart-nDel,nCent)
        Endif
      Endif

*
*-- If adding solvent molecules.
*
      If(DelOrAdd(2)) then
        Do 301, i=1,nPart*nCent
          Coord(i,1)=Work(iC(1)+i-1)
          Coord(i,2)=Work(iC(2)+i-1)
          Coord(i,3)=Work(iC(3)+i-1)
301     Continue
        If(nAdd.ne.0) then
*---- Just an ugly trick for using nypart. It requires that the first
*     slot contains the solvent coordinates, so we, temporarily, put
*     them there.
          Do 3010, i=1,nCent
            Do 3011, j=1,3
              Coord(i,j)=Cordst(i,j)
3011        Continue
3010      Continue
*---- Introduce the new particles. nPart is redefined.
          Call NyPart(nAdd,nPart,Coord,rStart,nCent,iSeed)
*---- The ugly trick is reversed, and the first slot is retained.
          Do 3012, i=1,nCent
            Do 3013, j=1,3
              Coord(i,j)=Work(iC(j)+i-1)
3013        Continue
3012      Continue
        Endif
*
*----Then dump new coordinates on designated startfile.
*
        Do 3001, k=1,3
          Call GetMem('NewCoo','Allo','Real',iC2(k),nPart*nCent)
3001    Continue
        Do 302, i=1,nPart*nCent
          Work(iC2(1)+i-1)=Coord(i,1)
          Work(iC2(2)+i-1)=Coord(i,2)
          Work(iC2(3)+i-1)=Coord(i,3)
302     Continue
        iLu=74
        Write(FilSlut,'(A5,i1.1)')'STFIL',NrStartu
        Call DaName(iLu,FilSlut)
        iDisk=0
        Call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,RStart,nPart,Gamold
     &              ,Gaold,Esub)
        iTcSim(1)=iDisk
        Do 270, l=1,3
          Call dDaFile(iLu,1,Work(iC2(l)),nPart*nCent,iDisk)
          iTcSim(1+l)=iDisk
270     Continue
        iDisk=0
        Call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,RStart,nPart,Gamold
     &              ,Gaold,Esub)
        Call DaClos(iLu)
        If(iPrint.ge.10) then
          Write(Head,*)'Final coordinates'
          Call Cooout(Head,Coord,nPart,nCent)
        Endif
        Do 3002, k=1,3
          Call GetMem('NewCoo','Free','Real',iC2(k),nPart*nCent)
3002    Continue
      Endif

*
*-- If requested, substitute all particles that are not of valid water
*   geometry for, you guessed it, valid water molecules.
*
      If(DelOrAdd(3)) then
        nRemoved=0
        Do 451, iPart=1,nPart
          ind=nCent*(iPart-1)
          Do 452, iCent=1,nCent
            Coo(iCent,1)=Work(iC(1)+ind+iCent-1)
            Coo(iCent,2)=Work(iC(2)+ind+iCent-1)
            Coo(iCent,3)=Work(iC(3)+ind+iCent-1)
            CooRef(iCent,1)=Cordst(iCent,1)
            CooRef(iCent,2)=Cordst(iCent,2)
            CooRef(iCent,3)=Cordst(iCent,3)
452       Continue
          Call IsItValid(Coo,CooRef,ValidOrNot)
          If(.not.ValidOrNot) then
            dCMx=0.0d0
            dCMy=0.0d0
            dCMz=0.0d0
            Do 453, iCent=1,nCent
              dCMx=dCMx+Work(iC(1)+ind+iCent-1)
              dCMy=dCMy+Work(iC(2)+ind+iCent-1)
              dCMz=dCMz+Work(iC(3)+ind+iCent-1)
453         Continue
            dCMx=dCMx*(1.0d0/dble(nCent))
            dCMy=dCMy*(1.0d0/dble(nCent))
            dCMz=dCMz*(1.0d0/dble(nCent))
*------ Check if the points are spread out, otherwise just delete.
            dSpread=0.0d0
            Do 455, iCent=1,nCent
              dSpread=dSpread+(Work(iC(1)+ind+iCent-1)-dCMx)**2
              dSpread=dSpread+(Work(iC(2)+ind+iCent-1)-dCMy)**2
              dSpread=dSpread+(Work(iC(3)+ind+iCent-1)-dCMz)**2
455         Continue
            dSpread=dSpread*(1.0d0/dble(nCent))
            If(dSpread.lt.ThrdSpread) then
              nRemoved=nRemoved+1
              Do 456, jP=iPart,nPart-1
                jnd1=(jP-1)*nCent
                jnd2=(jP)*nCent
                Do 457, iCent=1,nCent
                  Work(iC(1)+jnd1+iCent-1)=Work(iC(1)+jnd2+iCent-1)
                  Work(iC(2)+jnd1+iCent-1)=Work(iC(2)+jnd2+iCent-1)
                  Work(iC(3)+jnd1+iCent-1)=Work(iC(3)+jnd2+iCent-1)
457             Continue
456           Continue
            Else
              Do 454, iCent=1,nCent
                Work(iC(1)+ind+iCent-1)=dCMx+CooRef(iCent,1)
                Work(iC(2)+ind+iCent-1)=dCMy+CooRef(iCent,2)
                Work(iC(3)+ind+iCent-1)=dCMz+CooRef(iCent,3)
454           Continue
            Endif
          Endif
451     Continue
        nPart=nPart-nRemoved
*
*----Print the new set of coordinates to a startfile.
*
        iLu=74
        Write(FilSlut,'(A5,i1.1)')'STFIL',NrStartu
        Call DaName(iLu,FilSlut)
        iDisk=0
        Call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,Ract,nPart,Gamold
     &              ,Gaold,Esub)
        iTcSim(1)=iDisk
        Do 71, l=1,3
          Call dDaFile(iLu,1,Work(iC(l)),nPart*nCent,iDisk)
          iTcSim(1+l)=iDisk
71      Continue
        iDisk=0
        Call WrRdSim(iLu,1,iDisk,iTcSim,64,Etot,Ract,nPart,Gamold
     &              ,Gaold,Esub)
        Call DaClos(iLu)
*
*----If user wants, print print print.
*
        If(iPrint.ge.10) then
          Do 1002, i=1,nPart*nCent
            Coord(i,1)=Work(iC(1)+i-1)
            Coord(i,2)=Work(iC(2)+i-1)
            Coord(i,3)=Work(iC(3)+i-1)
1002      Continue
          Write(Head,*)'Final coordinates'
          Call Cooout(Head,Coord,nPart,nCent)
        Endif
      Endif

*
*-- If the user want to, print the coordinates in some format suitable
*   for graphical representation.
*
      If(DelOrAdd(4)) then
        If(cDumpForm(1:4).eq.'MOLD') then
          Do 444, iCent=1,nCent
            CooRef(iCent,1)=Cordst(iCent,1)
            CooRef(iCent,2)=Cordst(iCent,2)
            CooRef(iCent,3)=Cordst(iCent,3)
444       Continue
          Call MoldenDump(iC,CooRef,nPart,nAtom,nCent)
        Endif
      Endif

*
*-- Deallocate.
*
      Do 501,l=1,3
        Call GetMem('Coordinates','Free','Real',iC(l),nPart*nCent)
501   Continue

*
*-- This routine ends now!
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module MckDat

use Molcas, only: MxSym
use Definitions, only: iwp, ItoB

implicit none
private

!----------------------------------------------------------------------*
!                                                                      *
! Return codes:                                                        *
!   %good - No error                                                   *
!   %CL01 - file is not opened                                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Switches for one electron integral handlers:                         *
!   sOpSiz - Return only size of array                                 *
!   sNoOri - Do not read origin of operator                            *
!   sNoNuc - Do not read nuclear contribution                          *
!   sRdFst - Read first operator                                       *
!   sRdNxt - Read next operator                                        *
!   sNew   - New file, create.                                         *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Other definitions                                                    *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
! Parameters:                                                          *
!   NaN    - Not a Number = Variable undefined                         *
!   NotNaN - A Number = Variable is defined                            *
!   nTitle - length of title.                                          *
!   PhyRec - physical buffer size for DAFILE                           *
!   nBuf   - logical internal buffer size for reading/writing matrices *
!   MxOp   - Max number of operators                                   *
!   LenOp  - Length of TOC field defining operator                     *
!                                                                      *
! Pointers:                                                            *
!   pFID     - File identifier                                         *
!   pVersN   - Version number                                          *
!   pTitle   - Titleof the problem                                     *
!   pOp      - Operator list                                           *
!   pSym     - Number of irred. representations                        *
!   pSymOp   - generator of irred. representation                      *
!   pBas     - Number of basis functions per irred. representation     *
!   pASh     -   ?                                                     *
!   pish     -   ?                                                     *
!   pChdisp  -   ?                                                     *
!   pndisp   -   ?                                                     *
!   pldisp   -   ?                                                     *
!   pnrdisp  -   ?                                                     *
!   pdegdisp -   ?                                                     *
!   ptdisp   -   ?                                                     *
!   pPert    -   ?                                                     *
!   pNext    - Next free record                                        *
!                                                                      *
! Offsets:                                                             *
!   oLabel - Label of operator                                         *
!   oComp  - Component number                                          *
!   oSymLb - Symmetry label of operator                                *
!   oAddr  - Disk address                                              *
!                                                                      *
!----------------------------------------------------------------------*

type FInfo_type
  integer(kind=iwp) :: ID = 4097, VN = 1024
end type FInfo_type
type(FInfo_type), parameter :: FInfoMck = FInfo_type()

type rc_type
  integer(kind=iwp) :: good = 0, &
                       CL01 = 1
end type rc_type
type(rc_type), parameter :: rcMck = rc_type()

integer(kind=iwp), parameter :: sOpSiz  =          0, &
                                sNoOri  = sOpSiz  +1, &
                                sNoNuc  = sNoOri  +1, &
                                sRdFst  = sNoNuc  +1, &
                                sRdNxt  = sRdFst  +1, &
                                sRdCur  = sRdNxt  +1, &
                                sLength = sRdCur  +1, &
                                sDbg    = sLength +1
integer(kind=iwp), parameter :: sNew = 0, &
                                sDmp = sNew +1
integer(kind=iwp), parameter :: NaN = -1, NotNaN = 0, &
                                nTitle = (72*2)/ItoB, &
                                PhyRec = 1024, nBuf = 4*PhyRec, MxOp = 2048, LenOp = 5
integer(kind=iwp), parameter :: pFID     = 1, &
                                pVersN   = pFID     +1, &
                                pTitle   = pVersN   +1, &
                                pOp      = pTitle   +nTitle+1, &
                                pSym     = pOp      +MxOp*LenOp, &
                                pSymOp   = pSym     +1, &
                                pBas     = pSymOp   +int(real(3*MxSym+ItoB-1)/real(ItoB)), &
                                pASh     = pBas     +MxSym, &
                                pish     = pAsh     +MxSym, &
                                pChdisp  = pish     +MxSym, &
                                pndisp   = pchdisp  +5*MxOp, &
                                pldisp   = pndisp   +1, &
                                pnrdisp  = pldisp   +MxSym, &
                                pdegdisp = pnrdisp  +MxOp, &
                                ptdisp   = pdegdisp +MxOp, &
                                pPert    = Ptdisp   +MxOp, &
                                pNext    = ppert    +5, &
                                pEnd     = pNext    +1
integer(kind=iwp), parameter :: oLabel = 0, &
                                oComp  = oLabel +2, &
                                oSymLb = oComp  +1, &
                                oAddr  = oSymLb +1

type AuxMck_type
  integer(kind=iwp) :: Lu = 0
  logical(kind=iwp) :: Opn = .false.
end type AuxMck_type

integer(kind=iwp), parameter :: lTocMck = 1024*int(real(pEnd+1023)/1024.0)
integer(kind=iwp) :: TmpBuf(nBuf), TocMck(lTocMck)
type(AuxMck_type) :: AuxMck

public :: AuxMck, FInfoMck, LenOp, lTocMck, MxOp, NaN, nBuf, NotNaN, nTitle, oAddr, oComp, oLabel, oSymLb, pASh, pBas, pChdisp, &
          pdegdisp, pEnd, pFID, pish, pldisp, pndisp, pNext, pnrdisp, pOp, pPert, pSym, pSymOp, ptdisp, pTitle, pVersN, rcMck, &
          sLength, sDbg, sDmp, sNew, sNoNuc, sNoOri, sOpSiz, sRdCur, sRdFst, sRdNxt, TmpBuf, TocMck

end module MckDat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Markus P. Fuelscher                              *
*               2013, Giovanni Li Manni                                *
*               2016, Andrew M. Sand                                   *
************************************************************************
      Subroutine MSCtl(CMO,F,FI,FA,Ref_Ener)
!CMO,F,FI
*
*     This routine is a modification of SGFCIN, adapted to a CASDFT
*     implementation in which the CI step of a CASDFT calculation is
*         not corrected by DFT. DFT will play a role only in the Orbital
*         optimization step.
*     Purpose:
*     Generate the Fock-matrix for the frozen and inactive orbitals.
*     Compute also the core energy. Finally, transform the Fock-matrix
*     into the basis of the active orbitals.
*
*     M.P. Fuelscher, Lund, July 1990
*     GLM, Minneapolis,   May 2013
*     AMS, Minneapolis,   Feb 2016
*
      Implicit Real*8 (A-H,O-Z)
      Dimension CMO(*) ,F(*) , FI(*), FA(*), Ref_Ener(*)
*
#include "rasdim.fh"
#include "general.fh"
#include "input_ras.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='MSCTL   ')
#include "rasscf.fh"
#include "WrkSpc.fh"
#include "rctfld.fh"
#include "pamint.fh"
#include "timers.fh"
#include "SysDef.fh"
#include "csfbas.fh"
#include "gugx.fh"
#include "casvb.fh"
#include "wadr.fh"
#include "rasscf_lucia.fh"
#include "raswfn.fh"
#include "ksdft.fh"
      Logical DoActive,DoQmat,DoCholesky
!      Logical TraOnly
      Integer ALGO

      COMMON /CHOTODO /DoActive,DoQmat,ipQmat
      COMMON /CHLCAS /DoCholesky,ALGO

*
      Character*8 Label
      Logical First, Dff, Do_DFT,Found
      Parameter ( Zero=0.0d0 , One=1.0d0 )
      integer iD1I,iD1Act,iD1ActAO,iD1Spin,iD1SpinAO,IAD19
      integer iJOB,dmDisk,iP2d
      integer itmp0,itmp1,itmp2,itmp3,itmp4
      integer itmp5,itmp6,itmp7,itmpn,itmpk,itmpa
      integer ifocki,ifocka
      integer IADR19(1:30)
      integer LP,NQ,LQ,LPUVX
      integer  LOEOTP,NACP,NACP2
      integer vdisk,jroot
      real*8,dimension(1:nroots) :: Energies
      integer count_tmp1,count_tmp2
      integer  i_off1,i_off2,ifone
      integer isym,iorb,iash,iish,jsym
      integer LUGS
      LOGICAL Do_Rotate
      COMMON /MSPDFT/ Do_Rotate
      External IsFreeUnit
c      iTrii(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)


      Call unused_real_array(F)
***********************************************************
C Local print level (if any)
***********************************************************
      IPRLEV=IPRLOC(3)
*      iprlev=debug

***********************************************************
* Load the nuclear repulsion energy
***********************************************************
*TRS
      Call Get_iScalar('Relax CASSCF root',iRlxRoot)
*      write(6,*) 'rlxroot ', irlxroot
*TRS
*
      Call Get_dScalar('PotNuc',potNuc)

***********************************************************
* Generate molecular charges
***********************************************************
      Call GetMem('Ovrlp','Allo','Real',iTmp0,nTot1+4)
      iRc=-1
      iOpt=2
      iComp=1
      iSyLbl=1
      Label='Mltpl  0'
      Call RdOne(iRc,iOpt,Label,iComp,Work(iTmp0),iSyLbl)
      Tot_Nuc_Charge=Work(iTmp0+nTot1+3)
      If ( iRc.ne.0 ) then
         Write(LF,*) 'CASDFT_Terms: iRc from Call RdOne not 0'
         Write(LF,*) 'Label = ',Label
         Write(LF,*) 'iRc = ',iRc
         Call Abend
      Endif
      Call GetMem('Ovrlp','Free','Real',iTmp0,nTot1+4)

      Tot_El_Charge=Zero
      Do iSym=1,nSym
         Tot_El_Charge=Tot_El_Charge
     &                -2.0D0*DBLE(nFro(iSym)+nIsh(iSym))
      End Do
      Tot_El_Charge=Tot_El_Charge-DBLE(nActEl)
      Tot_Charge=Tot_Nuc_Charge+Tot_El_Charge


***********************************************************
* Load bare nuclei Hamiltonian
***********************************************************
      Call GetMem('Fcore','Allo','Real',iTmp1,nTot1)
      iComp  =  1
      iSyLbl =  1
      iRc    = -1
      iOpt   =  6
      Label  = 'OneHam  '
      Call RdOne(iRc,iOpt,Label,iComp,Work(iTmp1),iSyLbl)
      If ( iRc.ne.0 ) then
         Write(LF,*) 'CASDFT_Terms: iRc from Call RdOne not 0'
         Write(LF,*) 'Label = ',Label
         Write(LF,*) 'iRc = ',iRc
         Call Abend
      Endif
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' OneHam in AO basis in CASDFT_Terms'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=0
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',Work(iTmp1+iOff),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End If

c      if(iPrLev.ge.DEBUG) then
      Call GetMem('Kincore','Allo','Real',iTmpk,nTot1)
c--reads kinetic energy integrals  Work(iTmpk)--(Label=Kinetic)----
      iComp  =  1
      iSyLbl =  1
      iRc    = -1
      iOpt   =  6
      Label  = 'Kinetic '
      Call RdOne(iRc,iOpt,Label,iComp,Work(iTmpk),iSyLbl)
      If ( iRc.ne.0 ) then
         Write(LF,*) 'CASDFT_Terms: iRc from Call RdOne not 0'
         Write(LF,*) 'Label = ',Label
         Write(LF,*) 'iRc = ',iRc
         Call Abend
      Endif
      Call GetMem('NucElcore','Allo','Real',iTmpn,nTot1)
      iComp  =  1
      iSyLbl =  1
      iRc    = -1
      iOpt   =  6
      Label  = 'Attract '
      Call RdOne(iRc,iOpt,Label,iComp,Work(iTmpn),iSyLbl)
      If ( iRc.ne.0 ) then
         Write(LF,*) 'CASDFT_Terms: iRc from Call RdOne not 0'
         Write(LF,*) 'Label = ',Label
         Write(LF,*) 'iRc = ',iRc
         Call Abend
      Endif
c      end if


!Here we calculate the D1 Inactive matrix (AO).
      Call GetMem('D1Inact','Allo','Real',iD1I,NTOT2)
      Call Get_D1I_RASSCF_m(CMO,Work(iD1I))

      IF(IPRLEV.ge.DEBUG) THEN
         write(6,*) 'iD1inact'
         do i=1,ntot2
         write(6,*) Work(iD1i-1+i)
         end do
      END IF

        iJOB=0
        IAD19=0
        Call f_Inquire('JOBOLD',Found)
        If (.not.found) then
          Call f_Inquire('JOBIPH',Found)
          if (Found) JOBOLD=JOBIPH
        end if
        If (Found) iJOB=1
        If (iJOB.eq.1) Then
           if(JOBOLD.le.0) Then
             JOBOLD=20
             Call DaName(JOBOLD,'JOBOLD')
           end if
        end if
       IADR19(:)=0
       Call IDaFile(JOBOLD,2,IADR19,15,IAD19)
       IADR15 = IADR19
       vDisk =  IADR19(4)
       dmDisk = IADR19(3)
!       Call GetMem('jVector','Allo','Real',ijVec,nConf)
       Call GetMem('D1Active','Allo','Real',iD1Act,NACPAR)
       Call GetMem('D1ActiveAO','Allo','Real',iD1ActAO,NTOT2)
       Call GetMem('D1Spin','Allo','Real',iD1Spin,NACPAR)
       Call GetMem('D1SpinAO','Allo','Real',iD1SpinAO,NTOT2)

       Call GetMem('DtmpI','Allo','Real',iTmp3,nTot1)
       Call GetMem('DtmpA','Allo','Real',iTmp4,nTot1)
       Call GetMem('P2','Allo','Real',iP2d,NACPR2)


       Call GetMem('FockI','ALLO','Real',ifocki,ntot1)
       Call GetMem('FockA','ALLO','Real',ifocka,ntot1)

************************************************************************
* load back two-electron integrals (pu!vx)
************************************************************************
      lPUVX = 1
      If (.not.DoCholesky .or. ALGO.eq.1) Then
        If ( nFint.gt.0) then
          iDisk = 0
          Call GetMem('PUVX','Allo','Real',lPUVX,nFint)
          Call DDaFile(LUINTM,2,Work(lPUVX),nFint,iDisk)
        End If
      End If
      IF(IPRLEV.ge.DEBUG) THEN
        write(6,*) 'PUVX integrals in SXCTL'
        call wrtmat(Work(lPUVX),1,nFInt,1,nFInt)
      END IF


!This iSA is used to control gradient calculations.  Analytic gradients
!(in ALASKA) will only run if iSA=1, and iSA will only be set to one if
!the on-top potentials are computed as part of this calculation.
          iSA = 99
      Call Put_iScalar('SA ready',iSA)


!We loop over the number of states.  For each state, we read the density
!matrices from the JOBIPH file.
       do jroot=1,lroots
!       do d_off=1,1!100!,43!33,33!1,43

       !Load a fresh FockI and FockA
*        if(jroot.eq.irlxroot) then
         Call dcopy_(ntot1,FI,1,Work(ifocki),1)
         Call dcopy_(ntot1,FA,1,Work(ifocka),1)
*        end if
*
!Read in the density matrices for <jroot>.
!         Call Fzero(Work(ijVec),nConf)
         Call Fzero(Work(iD1Act),NACPAR)
         Call Fzero(Work(iD1ActAO),NTOT2)
         Call Fzero(Work(iD1Spin),NACPAR)
         Call Fzero(Work(iD1SpinAO),NTOT2)
         Call Fzero(Work(iTmp3),nTot1)
         Call Fzero(Work(iTmp4),nTot1)
         Call Fzero(Work(iP2d),NACPR2)
!         Call DDaFile(JOBIPH,2,Work(ijVec),nConf,jDisk)
!Get the D1 Active matrix for this state.  These should probably be
!most easily read from the previous JOBIPH file.  Then, convert D1A from
!the MO to the AO basis.

         Call DDaFile(JOBOLD,2,Work(iD1Act),NACPAR,dmDisk)
*        write(6,*) "D1"
*        do i=1,nacpar
*          write(6,*) Work(id1act-1+i)
*        end do

      if(.false.) then
         LUDM=90
         LUDM=IsFreeUnit(LUDM)
         Call Molcas_Open(LUDM,'DMs.out')
         do i=1,NACPAR
           read(LUDM,*) Work(id1Act-1+i)
         end do
         Close(LUDM)
      end if

      if(DoGradPDFT.and.jroot.eq.irlxroot) then
        Call GetMem('P2t','allo','Real',iP2dt1,NACPR2)
        Call FZero(Work(ip2dt1),Nacpr2)
        Call P2_contraction(Work(iD1Act),Work(iP2dt1))
*        write(6,*) "P2_t"
*        do i=1,nacpr2
*          write(6,*) i,Work(ip2dt1-1+i)
*        end do
        Call Put_P2MOt(Work(iP2dt1),NACPR2)
        Call GetMem('P2t','free','Real',iP2dt1,NACPR2)
      end if

      IF(IPRLEV.ge.DEBUG) THEN
        write(6,*) 'd1act'
        do i=1,NACPAR
          write(6,*) work(iD1Act-1+i)
        end do
      end if

         Call Put_D1MO(Work(iD1Act),NACPAR)
         Call DDaFile(JOBOLD,2,Work(iD1Spin),NACPAR,dmDisk)
         Call DDaFile(JOBOLD,2,Work(iP2d),NACPR2,dmDisk)
         Call Put_P2MO(Work(iP2d),NACPR2)
*        write(6,*) "P2"
*        do i=1,nacpr2
*          write(6,*) Work(ip2d-1+i)
*        end do
         Call DDaFile(JOBOLD,0,Work(iP2d),NACPR2,dmDisk)
      IF(IPRLEV.ge.DEBUG) THEN
        write(6,*) 'D2'
        do i=1,NACPR2
          write(6,*) Work(ip2d-1+i)
        end do
      END IF



***********************************************************
* Generate total density
***********************************************************

         If(NASH(1).ne.NAC) Call DBLOCK_m(Work(iD1Act))
      IF(IPRLEV.ge.DEBUG) THEN
        write(6,*) 'd1act'
        do i=1,NACPAR
          write(6,*) work(iD1Act-1+i)
        end do
      end if
         Call Get_D1A_RASSCF_m(CMO,Work(iD1Act),Work(iD1ActAO))
*         write(6,*) "is this it?",ntot2
*         do i=1,ntot2
*           write(6,*) Work(iD1ActAO-1+i)
*         end do

!ANDREW _ RIGHT HERE
      if(DoGradPDFT.and.jroot.eq.irlxroot) then
        Call GetMem('DtmpA_g','Allo','Real',iTmp_grd,nTot1)
        Call Fold_pdft(nSym,nBas,Work(iD1ActAO),Work(iTmp_grd))
        Call put_darray('d1activeao',Work(iTmp_grd),ntot1)
        Call GetMem('DtmpA_g','Free','Real',iTmp_grd,nTot1)
      end if
!END _RIGHT HERE
*
         Call Fold(nSym,nBas,Work(iD1I),Work(iTmp3))
         Call Fold(nSym,nBas,Work(iD1ActAO),Work(iTmp4))
*
         Call Daxpy_(nTot1,1.0D0,Work(iTmp4),1,Work(iTmp3),1)
!Maybe I can write all of these matrices to file, then modify stuff in
!the nq code to read in the needed density.  In other words, I need to
!replace the next call with something that supports multistates.
         Call Put_D1ao(Work(iTmp3),nTot1)
      IF(IPRLEV.ge.DEBUG) THEN
         write(6,*) 'd1ao'
         do i=1,ntot1
           write(6,*) work(itmp3-1+i)
         end do
cPS         call xflush(6)
      end if

!Get the spin density matrix for open shell cases
***********************************************************
* Generate spin-density
***********************************************************
         if(iSpin.eq.1) then
           Call dcopy_(NACPAR,[0.0d0],0,Work(iD1SpinAO),1)
         end if
         IF ( NASH(1).NE.NAC ) CALL DBLOCK_m(Work(iD1Spin))
         Call Get_D1A_RASSCF_m(CMO,Work(iD1Spin),
     &                      Work(iD1SpinAO))
         Call GetMem('DtmpS','Allo','Real',iTmp7,nTot1)
         Call Fold(nSym,nBas,Work(iD1SpinAO),Work(iTmp7))
         Call Put_D1Sao(Work(iTmp7),nTot1)
      IF(IPRLEV.ge.DEBUG) THEN
         write(6,*) 'd1so'
         do i=1,ntot1
           write(6,*) work(itmp7-1+i)
         end do
      end if
         Call GetMem('DtmpS','Free','Real',iTmp7,nTot1)


***********************************************************
* Calculation of the CASDFT_energy
***********************************************************
!Perhaps ideally, we should rework how DrvXV (and its children) handles
!the AO to MO transformation on the grid.  It seems like perhaps we are
!doing redundant transformations by retransforming AOs (which may have
!been included in a previous batch) into MOs.
*
        Call GetMem('htmp','Allo','Real',iTmp5,nTot1)
        Call GetMem('gtmp','Allo','Real',iTmp6,nTot1)
        Call dCopy_(nTot1,[0.0d0],0,Work(iTmp5),1)
        Call dCopy_(nTot1,[0.0d0],0,Work(iTmp6),1)
*
        First=.True.
        Dff=.False.
        Do_DFT=.True.

        Call Put_iArray('nFro',nFro,nSym)
        Call Put_iArray('nAsh',nAsh,nSym)
        Call Put_iArray('nIsh',nIsh,nSym)

        iCharge=Int(Tot_Charge)

c iTmp5 and iTmp6 are not updated in DrvXV...
                   NTU=0
                   ITU=0
                   IADD=0

                    Do iSym = 1,nSym
                    iAsh = nAsh(iSym)
                    IF(iAsh.NE.0) THEN
                    DO NT=1,iAsh
                    NTU=NTU+IADD
                    DO NU=1,NT
                    NTU=NTU+1
                     ITU=ITU+1
                    ENDDO
                    ENDDO
                    IADD=IADD+iAsh
                    End If
                    End Do
          NACP=(NAC+NAC**2)/2
          NACP2=(NACP+NACP**2)/2
          NCEH2=1

      do_pdftPot=.false.
      if(DoGradPDFT.and.jroot.eq.irlxroot) then

        do_pdftPot=.true.

        CALL GETMEM('TE_POTG','ALLO','REAL',LTEOTPG,NFINT)
        CALL GETMEM('OE_POT','ALLO','REAL',LOEOTP,NTOT1)
        Call DCopy_(NTOT1,[0.0d0],0,Work(LOEOTP),1)
        Call DCopy_(NFINT,[0.0d0],0,work(LTEOTPG),1)

      !preallocate the runfile stuff for inact-containing potentials.
        count_tmp1 = 0
        count_tmp2 = 0
        do isym=1,nsym
          do jsym=1,nsym
         count_tmp2 = count_tmp2 + nIsh(isym)*(nIsh(jsym)+nAsh(jsym))**2
          end do
          count_tmp1 = count_tmp1 + nIsh(isym)*(nish(isym)+nAsh(isym))
        end do
        CALL GETMEM('JUNK','ALLO','REAL',ijunk,count_tmp2)
        Call DCopy_(count_tmp2,[0.0d0],0,Work(ijunk),1)
!        Call Put_dArray('TEP_I',work(ijunk),count_tmp2)
        CALL GETMEM('JUNK','Free','REAL',ijunk,count_tmp2)

        CALL GETMEM('JUNK','ALLO','REAL',ijunk,count_tmp1)
        Call DCopy_(count_tmp1,[0.0d0],0,Work(ijunk),1)
!        Call Put_dArray('OEP_I',work(ijunk),count_tmp1)
        CALL GETMEM('JUNK','Free','REAL',ijunk,count_tmp1)

        Call Put_dArray('ONTOPO',work(LOEOTP),NTOT1)
        Call Put_dArray('ONTOPT',work(LTEOTPG),NFINT)

        Call DCopy_(NTOT1,[0.0d0],0,Work(LOEOTP),1)
        Call DCopy_(NFINT,[0.0d0],0,work(LTEOTPG),1)

        Call Put_dArray('FI_V',work(LOEOTP),NTOT1)
        Call Put_dArray('FA_V',work(LOEOTP),NTOT1)

        CALL GETMEM('OE_POT','FREE','REAL',LOEOTP,NTOT1)
        CALL GETMEM('TE_POTG','FREE','REAL',LTEOTPG,NFINT)
      end if !DoGradPdft

        Call DrvXV(Work(iTmp5),Work(iTmp6),Work(iTmp3),
     &             PotNuc,nTot1,First,Dff,NonEq,lRF,
     &             KSDFT_TEMP,ExFac,iCharge,iSpin,
     &             Work(iD1I),Work(iD1ActAO),
     &             nTot1,DFTFOCK,Do_DFT)


        Call Daxpy_(nTot1,1.0d0,Work(iTmp5),1,Work(iTmp1),1)
        Call Daxpy_(nTot1,1.0d0,Work(iTmp6),1,Work(iFockI),1)

        Call GetMem('gtmp','Free','Real',iTmp6,nTot1)
        Call GetMem('htmp','Free','Real',iTmp5,nTot1)

!
***********************************************************
*     Compute energy contributions
***********************************************************
      iTmp2=0
      Call GetMem('DoneI','Allo','Real',iTmp2,nTot1)

      Call Fold(nSym,nBas,Work(iD1I),Work(iTmp2))
c         call xflush(6)

      Call GetMem('DoneA','Allo','Real',iTmpa,nTot1)
c         call xflush(6)
      Call Fold(nSym,nBas,Work(iD1ActAO),Work(iTmpa))
c         call xflush(6)
*
      Eone = dDot_(nTot1,Work(iTmp2),1,Work(iTmp1),1)
      Call Get_dScalar('PotNuc',PotNuc_Ref)
      Eone = Eone + (PotNuc-PotNuc_Ref)
      Etwo = dDot_(nTot1,Work(iTmp2),1,Work(iFockI),1)

!**************Kinetic energy of inactive electrons********
      Ekin = dDot_(nTot1,Work(iTmp2),1,Work(iTmpk),1)

!*****Nuclear electron attraction for inactive electrons******
      Enuc = dDot_(nTot1,Work(iTmp2),1,Work(iTmpn),1)

c**************Kinetic energy of active electrons*********
      EactK = dDot_(nTot1,Work(iTmpk),1,Work(iTmpa),1)

      EactN = dDot_(nTot1,Work(iTmpn),1,Work(iTmpa),1)
      EFI = dDot_(nTot1,Work(iFockI),1,Work(iTmpa),1)
c         call xflush(6)
      Eact = EactK + EactN + EFI
      EMY  = PotNuc_Ref+Eone+0.5d0*Etwo

      CASDFT_Funct = 0.0D0
      Call Get_dScalar('CASDFT energy',CASDFT_Funct)
*TRS
      If ( IPRLEV.ge.DEBUG ) then
       Write(LF,'(4X,A35,F18.8)')
     &  'Nuclear repulsion energy :',PotNuc
       Write(LF,'(4X,A35,F18.8)')
     &  'One-electron kinetic core energy:',Ekin
       Write(LF,'(4X,A35,F18.8)')
     &   'Nuc-elec attraction core energy:',Enuc
       Write(LF,'(4X,A35,F18.8)') 'One-electron core energy:',Eone
       Write(LF,'(4X,A35,F18.8)') 'Two-electron core energy:',Etwo
       Write(LF,'(4X,A35,F18.8)') 'Total core energy:',EMY
       Write(LF,'(4X,A35,F18.8)') 'Active Kinetic energy:',EactK
       Write(LF,'(4X,A35,F18.8)')
     &  'Active nuc-elec attraction energy:',EactN
c       Write(LF,*) ' CASDFT Energy            :',CASDFT_Funct
      End If
c         call xflush(6)
***********************************************************
* Printing matrices
***********************************************************
      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' FI matrix in CASDFT_Terms only 2-electron terms'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',Work(IFockI+iOff-1),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End If

      Call DaXpY_(nTot1,One,Work(iTmp1),1,Work(iFockI),1)

      If ( IPRLEV.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' Inactive Fock matrix in AO basis in CASDFT_terms'
        write(LF,*) '(it already contains OneHam and TwoEl contrib.)'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
        iOff=1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          Call TriPrt(' ','(5G17.11)',Work(iFockI+iOff-1),iBas)
          iOff = iOff + (iBas*iBas+iBas)/2
        End Do
      End If


************************************************************************
* update and transform the Fock matrices FI and FA ----> FMAT routine
************************************************************************

      If (.not.DoCholesky .or. ALGO.eq.1) Then
*      If (jroot.eq.irlxroot) Then
*TRS
      if (iprlev.ge.debug) then
            write(6,*) 'id1act before reading in'
            do i=1,nacpar
              write(6,*) work(id1act-1+i)
            end do
      end if
*
        Call GetMem('id1act_FA','ALLO','Real',id1act_FA,nacpar)
        Call GetMem('id1actao_FA','ALLO','Real',id1actao_FA,ntot2)
*
        itsDisk = IADR19(3)
        do i=1,irlxroot-1
          Call DDaFile(JOBOLD,0,Work(iD1Act_FA),NACPAR,itsDisk)
          Call DDaFile(JOBOLD,0,Work(iD1Spin),NACPAR,itsDisk)
          Call DDaFile(JOBOLD,0,Work(iP2d),NACPR2,itsDisk)
          Call DDaFile(JOBOLD,0,Work(iP2d),NACPR2,itsDisk)
        end do
        Call DDaFile(JOBOLD,2,Work(iD1Act_FA),NACPAR,itsDisk)
        IF ( NASH(1).NE.NAC ) CALL DBLOCK_m(Work(iD1Act_FA))
        Call Get_D1A_RASSCF_m(CMO,Work(iD1Act_FA),Work(iD1ActAO_FA))
*****
        Call GetMem('lcmo','ALLO','Real',lcmo,ntot2)
        CALL DCOPY_(NTOT2,CMO,1,WORK(LCMO),1)
        if(iprlev.ge.debug) then
            write(6,*) 'cmo before tractl'
            do i=1,ntot2
              write(6,*) work(lcmo-1+i)
            end do
            write(6,*) 'lpuvx before tractl'
            do i=1,nfint
              write(6,*) work(lpuvx-1+i)
            end do
            write(6,*) 'ltuvx after tractl'
            do i=1,nacpr2
              write(6,*) work(ltuvx-1+i)
            end do
            write(6,*) 'id1act_fa before tractl'
            do i=1,nacpar
              write(6,*) work(id1act_FA-1+i)
            end do
            write(6,*) 'id1actao_fa before tractl'
            do i=1,ntot2
              write(6,*) work(id1actao_FA-1+i)
            end do
            write(6,*) 'id1act before tractl'
            do i=1,nacpar
              write(6,*) work(id1act-1+i)
            end do
            write(6,*) 'id1actao before tractl'
            do i=1,ntot2
              write(6,*) work(id1actao-1+i)
            end do
            write(6,*) 'id1i before tractl'
            do i=1,ntot2
              write(6,*) work(id1i-1+i)
            end do
        end if
*
        Call GetMem('FockI_save','ALLO','Real',ifocki_save,ntot1)
        if(iprlev.ge.debug) then
            write(6,*) 'ifocki before tractl'
            do i=1,ntot1
              write(6,*) work(ifocki-1+i)
            end do
        end if
*
        call  dcopy_(ntot1,work(ifocki),1,work(ifocki_save),1)
*
        if (iprlev.ge.debug) then
             write(6,*) 'ifocki_save before tractl'
             do i=1,ntot1
               write(6,*) work(ifocki_save-1+i)
             end do

             write(6,*) 'ifocka before tractl'
             do i=1,ntot1
               write(6,*) work(ifocka-1+i)
             end do
         end if
*
      Call GetMem('ltuvx_tmp','ALLO','Real',ltuvx_tmp,nacpr2)
      Call GetMem('lpuvx_tmp','ALLO','Real',lpuvx_tmp,nfint)
*
      CALL DCOPY_(nacpr2,[Zero],0,WORK(ltuvx_tmp),1)
      if (iprlev.ge.debug) then
            write(6,*) 'ltuvx before !!! tractl'
            do i=1, nacpr2
              write(6,*) work(ltuvx_tmp-1+i)
            end do
      end if
*
      CALL DCOPY_(nfint,[Zero],0,WORK(lpuvx_tmp),1)
      if (iprlev.ge.debug) then
            write(6,*) 'lpuvx before tractl'
            do i=1,nfint
              write(6,*) work(lpuvx_tmp-1+i)
            end do
      end if
*
*
         CALL TRACTL2(WORK(lcmo),WORK(LPUVX_tmp),WORK(LTUVX_tmp),
     &                WORK(iD1I),WORK(ifocki),
     &                WORK(iD1ActAO),WORK(ifocka),
     &                IPR,lSquare,ExFac)
*        Call dcopy_(ntot1,FA,1,Work(ifocka),1)
        if (iprlev.ge.debug) then
             write(6,*) 'FA tractl msctl'
             call wrtmat(Work(ifocka),1,ntot1,1,ntot1)
             write(6,*) 'FI tractl msctl'
             call wrtmat(Work(ifocki),1,ntot1,1,ntot1)
        end if
*
      Call GetMem('ltuvx_tmp','Free','Real',ltuvx_tmp,nacpr2)
      Call GetMem('lpuvx_tmp','Free','Real',lpuvx_tmp,nfint)
*
        if(iprlev.ge.debug) then
            write(6,*) 'cmo after tractl'
            do i=1,ntot2
              write(6,*) work(lcmo-1+i)
            end do
            write(6,*) 'lpuvx after tractl'
            do i=1,nfint
              write(6,*) work(lpuvx-1+i)
            end do
            write(6,*) 'ltuvx after tractl'
            do i=1,nacpr2
              write(6,*) work(ltuvx-1+i)
            end do
           write(6,*) 'id1act_FA after tractl'
            do i=1,nacpar
              write(6,*) work(id1act_FA-1+i)
            end do
            write(6,*) 'id1actao_FA after tractl'
            do i=1,ntot2
              write(6,*) work(id1actao_FA-1+i)
            end do
            write(6,*) 'id1act after tractl'
            do i=1,nacpar
              write(6,*) work(id1act-1+i)
            end do
            write(6,*) 'id1actao after tractl'
            do i=1,ntot2
              write(6,*) work(id1actao-1+i)
            end do
            write(6,*) 'id1i before tractl'
            do i=1,ntot2
              write(6,*) work(id1i-1+i)
            end do
        end if

        if(iprlev.ge.debug) then
            write(6,*) 'ifocki after tractl'
            do i=1,ntot1
              write(6,*) work(ifocki-1+i)
            end do
        end if

        if (iprlev.ge.debug) then
             write(6,*) 'ifocki_save after tractl'
             do i=1,ntot1
               write(6,*) work(ifocki_save-1+i)
             end do
*
             write(6,*) 'ifocka after tractl'
             do i=1,ntot1
               write(6,*) work(ifocka-1+i)
             end do
         end  if
*
*        if (jroot.ne.irlxroot) then
*        Call dcopy_(ntot1,FI,1,Work(ifocki),1)
*        Call dcopy_(ntot1,FA,1,Work(ifocka),1)
*        end if
*
         Call Fmat_m(CMO,Work(lPUVX),Work(iD1Act),Work(iD1ActAO),
     &             Work(iFockI_save),Work(iFockA))
        call  dcopy_(ntot1,work(ifocki_save),1,work(ifocki),1)
*        call  dcopy_(nacpar,work(id1act_FA),1,work(id1act),1)
        Call GetMem('FockI_Save','Free','Real',ifocki_save,ntot1)
        Call GetMem('lcmo','Free','Real',lcmo,ntot2)
        Call GetMem('id1act_FA','Free','Real',id1act_FA,nacpar)
        Call GetMem('id1actao_FA','Free','Real',id1actao_FA,ntot2)
!
!
        if (iprlev.ge.debug) then
             write(6,*) 'FA after fmat 1'
             call wrtmat(Work(ifocka),1,ntot1,1,ntot1)
             write(6,*) 'FI after fmat 1'
             call wrtmat(Work(ifocki),1,ntot1,1,ntot1)
        end if
*      end if
*TRS
******
      Else

         Write(LF,*)'SXCTL: Illegal Cholesky parameter ALGO= ',ALGO
         call abend()

      EndIf
*
      if (iprlev.ge.debug) then
           write(6,*) 'id1act after copy in tractl'
            do i=1,nacpar
              write(6,*) work(id1act-1+i)
            end do
      end if
*
         IF(ISTORP(NSYM+1).GT.0) THEN
           CALL GETMEM('ISTRP','ALLO','REAL',LP,ISTORP(NSYM+1))
           CALL DmatDmat_m(Work(iD1Act),WORK(LP))
           CALL GETMEM('ISTRP','ALLO','REAL',LP1,ISTORP(NSYM+1))
           CALL PMAT_RASSCF_M(Work(iP2d),WORK(LP1))
         END IF

       if(iprlev.ge.debug) then
         write(6,*) 'dmatdmat'
         do i=1,istorp(nsym+1)
           write(6,*) Work(LP-1+i)
         end do
       end if
         NQ=0
         NSXS=0
         NIAIA=0
         do ISYM=1,NSYM
           NQ = MAX(NQ,NASH(ISYM)*NORB(ISYM))
           NSXS= NSXS+(NISH(ISYM)+NASH(ISYM))*(NASH(ISYM)+NSSH(ISYM))
           NIAIA = NIAIA+(NASH(ISYM)+NISH(ISYM))**2
         end do
         if(NQ.lt.NIAIA) NQ=NIAIA

         CALL GETMEM('FOCK','ALLO','REAL',LFOCK,NTOT4)
         CALL GETMEM('SXBM','ALLO','REAL',LBM,NSXS)
         CALL GETMEM('SXLQ','ALLO','REAL',LQ,NQ) ! q-matrix(1symmblock)
         IFINAL = 1
         CALL FOCK_m(WORK(LFOCK),WORK(LBM),Work(iFockI),Work(iFockA),
     &         Work(iD1Act),WORK(LP),WORK(LQ),WORK(LPUVX),IFINAL,CMO)
!TMP TEST
!         Call Put_Darray('fock_tempo',Work(ipFocc),ntot1)
!END TMP TEST


         CASDFT_Funct = 0
         Call Get_dScalar('CASDFT energy',CASDFT_Funct)

         CASDFT_E = ECAS+CASDFT_Funct

!         Write(6,*)
!         '**************************************************'
!         write(6,*) 'ENERGY REPORT FOR STATE',jroot
*TRS
*          write(6,*) 'ECAS', ECAS

*TRS
        Call Print_MCPDFT_2(CASDFT_E,PotNuc,EMY,ECAS,CASDFT_Funct,
     &         jroot,Ref_Ener)
c         call xflush(6)


         IF(Do_Rotate) Then
            Energies(jroot)=CASDFT_Funct
*JB         replacing ref_ener with MC-PDFT energy for MS-PDFT use
            Ref_Ener(jroot)=CASDFT_E
         ELSE
            Energies(jroot)=CASDFT_E
         END IF


         CALL GETMEM('SXBM','FREE','REAL',LBM,NSXS)
         CALL GETMEM('SXLQ','FREE','REAL',LQ,NQ)
!At this point, the energy calculation is done.  Now I need to build the
!fock matrix if this root corresponds to the relaxation root.

!***********************************************************************
*
*            BUILDING OF THE NEW FOCK MATRIX                           *
*
************************************************************************
        if(DoGradPDFT.and.jroot.eq.irlxroot) then

         Write(LF,*) 'Calculating potentials for analytic gradients...'
!MCLR requires two sets of things:
!1. The effective one-body Fock matrix and the effective two-body fock
!matrix.  These are used to generate the CI gradient inside of MCLR
!2. The effective generalized fock matrix.  This is used to calculate
!the orbital gradient inside of MCLR and is also used in the
!renormalization/effective lagrangian part of the final gradient
!evalutation.

!I think the plan should be to add on the missing pieces (to Fock_occ)
!which come from the one- and two-electron potentials.  These pieces are
!given by
! F_{xy} = \sum_{p} V_{py} D_{px} + \sum_{pqr} 2v_{pqry}d_{pqrx}.

!
!      write(6,*) 'NACPAR (input fock)',nacpar
!      write(6,*) 'ntot1 (# of V, fock_occ)',ntot1
!      write(6,*) 'nfint (# of v)',nfint
cPS         call xflush(6)

!I will read in the one- and two-electron potentials here

      Call GetMem('ONTOPT','ALLO','Real',ipTmpLTEOTP,nfint)
      Call GetMem('ONTOPO','ALLO','Real',ipTmpLOEOTP,ntot1)
      Call FZero(Work(iptmplteotp),Nfint)
      Call FZero(Work(iptmploeotp),ntot1)


      Call Get_dArray('ONTOPT',work(ipTmpLTEOTP),NFINT)
      Call Get_dArray('ONTOPO',work(ipTmpLOEOTP),NTOT1)
!
        If ( IPRLEV.ge.DEBUG ) then
        write(6,*) 'One-electron potentials'
        do i=1,ntot1
          write(6,*) Work(iptmploeotp-1+i)
        end do
        write(6,*) 'Two-electron potentials'
        do i=1,nfint
          if (abs(work(lpuvx-1+i)).ge.1d-10)then
            write(6,*) Work(iptmplteotp-1+i),work(lpuvx-1+i)
          end if
        end do
        end if
*
*         do i=1,nacpr2
*         call dcopy_(nacpr2,0.0d0,1,Work(ltuvx_tmp-1+i),1)
*         end do
*
*         CALL DCOPY_(NTOT2,CMO,1,WORK(LCMO),1)
*
*         do i=1,nfint
*         Call dcopy_(nfint,0.0D0,1,WORK(lpuvx_tmp-1+i),1)
*         end do
*
*
*         CALL TRA_CTL2_(WORK(lcmo),
*     &          WORK(LPUVX_tmp),WORK(LTUVX_tmp),WORK(id1actao)
*     &         ,WORK(ifocka),WORK(id1i),WORK(ifocki),IPR,lSquare,ExFac)
*
*         write(6,*) 'cmo after before fmat 2'
*         do i=1,ntot2
*           write(6,*) work(lcmo-1+i)
*         end do
*        write(6,*) 'lpuvx after before fmat 2'
*         do i=1,nfint
*           write(6,*) work(lpuvx-1+i)
*         end do
*        write(6,*) 'id1act after before fmat 2'
*         do i=1,nacpar
*           write(6,*) work(id1act-1+i)
*         end do
*        write(6,*) 'id1actao after before fmat 2'
*         do i=1,ntot2
*           write(6,*) work(id1actao-1+i)
*         end do
*
*         write(6,*) 'ifocki_save after before fmat 2'
*         do i=1,ntot1
*           write(6,*) work(ifocki_save-1+i)
*         end do
*        write(6,*) 'ifocka after before fmat 2'
*         do i=1,ntot1
*           write(6,*) work(ifocka-1+i)
*         end do
*

*        Call Fmat_m(CMO,Work(lPUVX),Work(iD1Act),Work(iD1ActAO),
*     &             Work(iFockI_save),Work(iFockA))
*       call  dcopy_(ntot1,work(ifocki_save),1,work(ifocki),1)
*
*        Call GetMem('FockI_Save','Free','Real',ifocki_save,ntot1)
*        Call GetMem('lcmo','Free','Real',lcmo,ntot2)
*
*        write(6,*) 'FA msctl after fmat 2'
*        call wrtmat(Work(ifocka),1,ntot1,1,ntot1)
*        write(6,*) 'FI msctl after fmat 2'
*        call wrtmat(Work(ifocki),1,ntot1,1,ntot1)

!

!______________________________________________________
!Grab the active-active part of the FI+FA matrix (currently held in the
!FA matrix) and place it in an array of size NACPAR.  Add the oeotp to
!it.  Write to file.
        If ( IPRLEV.ge.DEBUG ) then
      write(6,*) "FA+FI to send to MCLR"
      do i=1,Ntot1
        write(6,*) Work(ifocka-1+i)
      end do
        end if

      Call GetMem('F_ONE','ALLO','Real',iFone,NTOT1)
      CALL DCOPY_(NTOT1,[0.0D0],0,WORK(iFone),1)

!I think I need to generate FI, which will contain both the one-electron
!potential contribution and the V_kkpu contribution.



      CALL GETMEM('FI_V','ALLO','REAL',ifiv,Ntot1)
      Call Get_dArray('FI_V',work(ifiv),NTOT1)
!         Call Dscal_(nTOT1,4.0d0,Work(ifiv),1)
*         write(6,*) 'fiv after tractl'
*         do i=1,ntot1
*           write(6,*) work(ifiv-1+i)
*         end do

      !Call daxpy_(ntot1,0.5d0,Work(ifiv),1,Work(iFocka),1)
      Call daxpy_(ntot1,1.0d0,Work(ifiv),1,Work(iFocka),1)
      Call daxpy_(ntot1,1.0d0,Work(iptmploeotp),1,Work(iFocka),1)


      i_off1=0
      i_off2=0


      Do iSym = 1,nSym
        iBas = nBas(iSym)
        iOrb = nOrb(iSym)
        iFro = nFro(iSym)
        iAct = nAsh(iSym)
        iIsh = nIsh(iSym)

      !FI + FA + V_oe

        do i=1,iBas
          do j=1,i
!            if (i.gt.iIsh.and.j.gt.iIsh) then
!              if(i.le.iAct+iIsh.and.j.le.iAct+iIsh) then
                Work(iFone+i_off1) = Work(ifone+i_off1) +
     &              Work(ifocka+i_off2)
                i_off1 = i_off1 + 1
!              end if
!            end if
            i_off2 = i_off2 + 1
          end do
        end do
      end do
        If ( IPRLEV.ge.DEBUG ) then
      write(6,*) 'F1 to send'
      do i=1,NTOT1
        write(6,*) work(iFone-1+i)
      end do
        end if

      !Add the V_kktu contribution to Fone_tu?
!STILL MUST DO!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!This should be addressed in the upd_FI routine.

      !Write to file.
      LUTMP=87
      LUTMP=IsFreeUnit(LUTMP)
      Call Molcas_Open(LUTMP,'TmpFock')
      do i=1,ntot1
        write(LUTMP,*) Work(iFone+i-1)
      end do

!Write the TUVX teotp to file.q

!      Call GetMem('ttTUVX2','Allo','Real',ittTUVX2,NACPR2)
!      Call Get_TUVX(Work(lPUVX),Work(ittTUVX2))
!      write(6,*) 'TUVX'
!      do i=1,nacpr2
!      write(6,*) work(ittTUVX2-1+i)
!      end do
!      Call GetMem('ttTUVX2','Free','Real',ittTUVX2,NACPR2)


      Call GetMem('ttTUVX','Allo','Real',ittTUVX,NACPR2)
      CALL DCOPY_(nacpr2,[0.0D0],0,WORK(ittTUVX),1)
      Call Get_TUVX(Work(ipTmpLTEOTP),Work(ittTUVX))
      !Call Get_TUVX(Work(lpuvx),Work(ittTUVX))

      !Unpack TUVX to size
      do i=1,nacpr2
        write(LUTMP,*) Work(ittTUVX+i-1)
      end do
      Close(LUTMP)
      Call GetMem('F_ONE','Free','Real',iFone,NTOT1)
      Call GetMem('ttTUVX','Free','Real',ittTUVX,NACPR2)


!____________________________________________________________
!This next part is to generate the MC-PDFT generalized fock operator.


!      CALL DCOPY_(nFint,[0.0D0],0,WORK(ipTmpLTEOTP),1)
!      CALL DCOPY_(ntot1,[0.0D0],0,WORK(ipTmpLOEOTP),1)
!        write(6,*) 'ONTOPT'
!        call wrtmat(Work(ipTmpLTEOTP),1,nFInt,1,nFInt)
!        write(6,*) 'ONTOPO'
!        call wrtmat(Work(ipTmpLOEOTP),1,ntot1,1,ntot1)

!Zero out the matrices.  We will be adding the potential-containing
!terms as a correction to the Focc component already on the runfile.
      CALL DCOPY_(ntot1,[0.0D0],0,WORK(iFocka),1)
      CALL DCOPY_(ntot1,[0.0D0],0,WORK(iFocki),1)

!The corrections (from the potentials) to FI and FA are built in the NQ
!part of the code, for efficiency's sake.  It still needs to be
!debugged.
      CALL GETMEM('FA_V','ALLO','REAL',ifav,Ntot1)
      Call Get_dArray('FA_V',work(ifav),NTOT1)
!         Call Dscal_(nTOT1,4.0d0,Work(ifav),1)
      !work(ifav-1+2) = 0d0


!         Call Dscal_(ntot1,0.5d0,Work(ifiv),1)
!         Call Dscal_(ntot1,0.5d0,Work(ifav),1)
      !Call Dscal_(nfint,-0.5d0,Work(ipTmpLTEOTP),1)
        If ( IPRLEV.ge.DEBUG ) then
      write(6,*) "extra terms to update FI"
      do i=1,ntot1
      write(6,*) Work(ifiv-1+i)
      end do
      !Call TriPrt(' ','(5G18.10)',Work(ifiv),norb(1))
      write(6,*) "extra terms to update FA"
      do i=1,ntot1
      write(6,*) Work(ifav-1+i)
      end do
      !Call TriPrt(' ','(5G18.10)',Work(ifav),norb(1))
        end if

        If ( IPRLEV.ge.DEBUG ) then
      CALL GETMEM('FA_t','ALLO','REAL',ifat,Ntot1)
      Call dcopy_(ntot1,[0.0d0],0,work(ifat),1)
      Call DaXpY_(NTOT1,1.0D0,Work(ipTmpLOEOTP),1,Work(ifat),1)
      Call daxpy_(NTOT1,1.0D0,Work(ifiv),1,Work(ifat),1)
      Call daxpy_(NTOT1,1.0D0,Work(ifav),1,Work(ifat),1)
      write(6,*) "Total F additions:"
      Call TriPrt(' ','(5G18.10)',Work(ifat),norb(1))
      CALL GETMEM('FA_t','free','REAL',ifat,Ntot1)
        end if



      !Add one e potential, too.
!test comment
      Call DaXpY_(NTOT1,1.0D0,Work(ipTmpLOEOTP),1,Work(ifocki),1)
      !Add two e potentials
!test comment
      Call daxpy_(NTOT1,1.0D0,Work(ifiv),1,Work(ifocki),1)
!test comment
      Call daxpy_(NTOT1,1.0D0,Work(ifav),1,Work(ifocka),1)
        If ( IPRLEV.ge.DEBUG ) then
      write(6,*) "new FI"
      Call TriPrt(' ','(5G18.10)',Work(ifocki),norb(1))
      write(6,*) "new FA"
      Call TriPrt(' ','(5G18.10)',Work(ifocka),norb(1))
        end if

      CALL GETMEM('FI_V','Free','REAL',ifiv,Ntot1)
      CALL GETMEM('FA_V','Free','REAL',ifav,Ntot1)

!Reordering of the two-body density matrix.
!      Call Getmem('test_p2','allo','real',ip2test,ISTORP(NSYM+1))
!      Call dcopy_(ISTORP(NSYM+1),Work(LP),1,Work(ip2test),1)

       IF(ISTORP(NSYM+1).GT.0) THEN
      CALL DCOPY_(ISTORP(NSYM+1),[0.0D0],0,WORK(LP),1)
!p = work(iP2d)
         CALL PMAT_RASSCF_M(Work(iP2d),WORK(LP))
      END IF
!test comment add
!      Call FZero(Work(iptmplteotp),nfint)
!test comment add end

!Must add to existing FOCK operator (occ/act). FOCK is not empty.
         CALL GETMEM('SXBM','ALLO','REAL',LBM,NSXS)
         CALL GETMEM('SXLQ','ALLO','REAL',LQ,NQ) ! q-matrix(1symmblock)
         CALL FOCK_update(WORK(LFOCK),WORK(LBM),Work(iFockI),
     &        Work(iFockA),Work(iD1Act),WORK(LP),
     &        WORK(LQ),WORK(ipTmpLTEOTP),IFINAL,CMO)

         Call Put_Fock_Occ(Work(ipFocc),ntot1)
        If ( IPRLEV.ge.DEBUG ) then
        write(6,*) 'FOCC_OCC'
        call wrtmat(Work(ipFocc),1,ntot1,1,ntot1)


      write(6,*) 'DONE WITH NEW FOCK OPERATOR'
        end if

         CALL GETMEM('SXBM','Free','REAL',LBM,NSXS)
         CALL GETMEM('SXLQ','Free','REAL',LQ,NQ) ! q-matrix(1symmblock)
      Call GetMem('ONTOPO','FREE','Real',ipTmpLOEOTP,ntot1)
      Call GetMem('ONTOPT','FREE','Real',ipTmpLTEOTP,nfint)


!Put some information on the runfile for possible gradient calculations.
      Call Put_iScalar('Number of roots',nroots)
      Call Put_dArray('Last energies',Energies,nroots)
      Call Put_cArray('Relax Method','MCPDFT  ',8)
      Call Put_dScalar('Last energy',Energies(iRlxRoot))
          iSA = 1
       !need to do MCLR for gradient runs. (1 to run, 2 to skip)
       !MUST MODIFY THIS.  I need to check that the calculation is not
       !SA, and if it is, set iSA to -1.
      Call Put_iScalar('SA ready',iSA)
      Call Put_cArray('MCLR Root','****************',16)


!      Call GetMem('P2t','allo','Real',iP2dt1,NACPR2)
!      Call FZero(Work(ip2dt1),Nacpr2)
!      !I need the non-symmetry blocked d1act, hence the read.
!      Call GetMem('D1Act1','Allo','Real',iD1Act1,NACPAR)
!      Call Get_D1MO(Work(iD1Act1),NACPAR)
!        write(6,*) 'd1act'
!        do i=1,NACPAR
!          write(6,*) work(iD1Act1-1+i)
!        end do
!      Call P2_contraction(Work(iD1Act1),Work(iP2dt1))
!      Call Put_P2MOt(Work(iP2dt1),NACPR2)
!      Call GetMem('P2t','free','Real',iP2dt1,NACPR2)
!      Call GetMem('Dens','free','Real',iD1Act1,NACPAR)

!Put information needed for geometry optimizations.
      !if (jroot.eq.iRlxRoot) then
          iSA = 1 !need to do MCLR for gradient runs. (1 to run, 2 to
*skip)
       !MUST MODIFY THIS.  I need to check that the calculation is not
       !SA, and if it is, set iSA to -1.
      Call Put_iScalar('SA ready',iSA)
      Call Put_cArray('MCLR Root','****************',16)
      Call Put_iScalar('Relax CASSCF root',irlxroot)
      !end if



      end if !DoGradPDFT

      !if (jroot.eq.iRlxRoot) then
      Call Put_iScalar('Number of roots',nroots)
      Call Put_dArray('Last energies',Energies,nroots)
      Call Put_cArray('Relax Method','MCPDFT  ',8)
      Call Put_dScalar('Last energy',Energies(iRlxRoot))
      !end if

      Call GetMem('DoneI','Free','Real',iTmp2,nTot1)
      Call GetMem('DoneA','Free','Real',iTmpa,nTot1)
      CALL GETMEM('FOCK','Free','REAL',LFOCK,NTOT4)
         IF(ISTORP(NSYM+1).GT.0) THEN
           CALL GETMEM('ISTRP','FREE','REAL',LP,ISTORP(NSYM+1))
           CALL GETMEM('ISTRP','FREE','REAL',LP1,ISTORP(NSYM+1))
         END IF
      end do !loop over roots

      if(DoGradPDFT) then
        dmDisk = IADR19(3)
        do jroot=1,irlxroot-1
          Call DDaFile(JOBOLD,0,Work(iD1Act),NACPAR,dmDisk)
          Call DDaFile(JOBOLD,0,Work(iD1Spin),NACPAR,dmDisk)
          Call DDaFile(JOBOLD,0,Work(iP2d),NACPR2,dmDisk)
          Call DDaFile(JOBOLD,0,Work(iP2d),NACPR2,dmDisk)
        end do
        Call DDaFile(JOBOLD,2,Work(iD1Act),NACPAR,dmDisk)
*        Andrew added this line to fix heh2plus
        Call DDaFile(JOBOLD,2,Work(iD1Spin),NACPAR,dmDisk)
        Call Put_D1MO(Work(iD1Act),NACPAR)
*        write(6,*) 'd1Spin'
*        do i=1,NACPAR
*          write(6,*) work(iD1spin-1+i)
*        end do
*TRS commenting out because we already read over this
*        Call DDaFile(JOBOLD,0,Work(iD1Spin),NACPAR,dmDisk)
        Call DDaFile(JOBOLD,2,Work(iP2d),NACPR2,dmDisk)
        Call Put_P2MO(Work(iP2d),NACPR2)
*        write(6,*) 'D2'
*        do i=1,NACPR2
*          write(6,*) Work(ip2d-1+i)
*        end do

         If(NASH(1).ne.NAC) Call DBLOCK_m(Work(iD1Act))
         Call Get_D1A_RASSCF_m(CMO,Work(iD1Act),Work(iD1ActAO))

         Call Fold(nSym,nBas,Work(iD1I),Work(iTmp3))
         Call Fold(nSym,nBas,Work(iD1ActAO),Work(iTmp4))
         Call Daxpy_(nTot1,1.0D0,Work(iTmp4),1,Work(iTmp3),1)
         Call Put_D1ao(Work(iTmp3),nTot1)
!         write(6,*) 'd1ao'
!         do i=1,ntot1
!           write(6,*) work(itmp3-1+i)
!         end do

!Get the spin density matrix for open shell cases
***********************************************************
* Generate spin-density
***********************************************************
*TRS ams also commented out this if and endif part of this
* statement
         !if(iSpin.eq.1) then
           Call dcopy_(NACPAR,[Zero],0,Work(iD1SpinAO),1)
         !end if
         IF ( NASH(1).NE.NAC ) CALL DBLOCK_m(Work(iD1Spin))
         Call Get_D1A_RASSCF_m(CMO,Work(iD1Spin),
     &                      Work(iD1SpinAO))
         Call GetMem('DtmpS','Allo','Real',iTmp7,nTot1)
         Call Fold(nSym,nBas,Work(iD1SpinAO),Work(iTmp7))
         Call Put_D1Sao(Work(iTmp7),nTot1)
!         write(6,*) 'd1so'
!         do i=1,ntot1
!           write(6,*) work(itmp7-1+i)
!         end do
         Call GetMem('DtmpS','Free','Real',iTmp7,nTot1)




        Call DDaFile(JOBOLD,0,Work(iP2d),NACPR2,dmDisk)
      end if


      if(doGSOR) then
        LUGS=25
        LUGS=IsFreeUnit(LUGS)
        IAD19=0
        Call DaName(LUGS,'JOBGS')
        Call IDaFile(LUGS,2,IADR19,15,IAD19)
        Call DDAFile(LUGS,1,Energies,lroots,IADR19(6))
        Call DaClos(LUGS)
      end if

      If (.not.DoCholesky .or. ALGO.eq.1) Then
        if (nFint.gt.0) then
          Call GetMem('PUVX','FREE','Real',lPUVX,nFint)
        end if
      End If

!Free up all the memory we can here, eh?
      Call GetMem('DtmpA','Free','Real',iTmp4,nTot1)
      Call GetMem('DtmpI','Free','Real',iTmp3,nTot1)

      Call GetMem('D1Active','free','Real',iD1Act,NACPAR)
      Call GetMem('D1ActiveAO','free','Real',iD1ActAO,NTOT2)
      Call GetMem('D1Spin','free','Real',iD1Spin,NACPAR)
      Call GetMem('D1SpinAO','free','Real',iD1SpinAO,NTOT2)
      Call GetMem('Fcore','Free','Real',iTmp1,nTot1)
      Call GetMem('FockI','FREE','Real',ifocki,ntot1)
      Call GetMem('FockA','FREE','Real',ifocka,ntot1)
*      Call DDaFile(JOBOLD,0,Work(iP2d),NACPR2,dmDisk)
      Call GetMem('P2','Free','Real',iP2d,NACPR2)
      Call GetMem('D1Inact','Free','Real',iD1i,NTOT2)
      Call GetMem('Kincore','free','Real',iTmpk,nTot1)
      Call GetMem('NucElcore','free','Real',iTmpn,nTot1)
c      call xflush(6)
      Return
      END

      Subroutine P2_contraction(D1MO,P2MO)
      Implicit Real*8 (A-H,O-Z)
      Dimension D1MO(*),P2MO(*)
#include "rasdim.fh"
#include "general.fh"
#include "rasscf.fh"
#include "WrkSpc.fh"
      integer :: i,j,k,l,ij,kl,ijkl
      integer :: iD1c
      real*8 :: fact

      iTrii(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*      write(6,*) 'inside p2_contraction'



      Call GetMem('D1copy','Allo','Real',iD1c,NACPAR)
      Call DCOPY_(NACPAR,D1MO,1,Work(iD1c),1)
!      Call DSCAL_(NACPAR,0.50d0,Work(iD1c),1)
!      do i=1,nac
!         Work(iD1c + iTrii(i,i)-1) =
!     &   work(iD1c + iTrii(i,i)-1)*2
!      end do


       ijkl=0
       do i=1,nac
         do j=1,i
           ij = iTrii(i,j)
           do k=1,i
             if(i.eq.k) then
               lmax = j
             else
               lmax = k
             end if
             do l=1,lmax
               kl = iTrii(k,l)
               ijkl = ijkl + 1
               fact=1.0d0
               if(k.eq.l) fact=0.5d0
               p2MO(ijkl) = fact*Work(iD1c-1+ij)*Work(iD1c-1+kl)
             end do
           end do
         end do
       end do
       Call GetMem('D1copy','FREE','Real',iD1c,NACPAR)
      end subroutine


      Subroutine Fold_pdft(nSym,nBas,A,B)

      Implicit Real*8 (A-H,O-Z)

      Dimension nBas(*) , A(*) , B(*)

      iOff1 = 0
      iOff2 = 0
      Do iSym = 1, nSym
        mBas = nBas(iSym)
        Do iBas= 1, mBas
          Do jBas = 1 , iBas-1
            B(iOff2+jBas) =   A(iOff1+jBas)
          End Do
          B(iOff2+iBas) =  A(iOff1+iBas)
          iOff1 = iOff1 + mBas
          iOff2 = iOff2 + iBas
        End Do
      End Do

      Return
      end
************ columbus interface ****************************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE AUXC(N,NBC,TC,ANSC)
      IMPLICIT REAL*8 (A-H,O-Z)
      X=1D0/(1D0+TC)
      Y=TC*X
      X=sqrt(X**(NBC+1))
      DUM=1D0
      IF (N.GT.1) THEN
        DO 10 I=N,2,-1
          DUM=DUM*Y*DBLE(NBC+2*I-3)/DBLE(2*I-2) + 1.D0
10      CONTINUE
      ENDIF
      ANSC=X*DUM
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LoProp_Print(rMP,nij,nAtoms,Q_Nuc,LblCnt,lSave)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nij, nAtoms
real(kind=wp), intent(in) :: rMP(nij), Q_Nuc(nAtoms)
character(len=LenIn4), intent(in) :: LblCnt(nAtoms)
logical(kind=iwp), intent(in) :: lSave
integer(kind=iwp) :: i, iAtom, iEnd, ij, Inc, iPL, iSt, mAtoms
character(len=120) :: Banner_Line(3)
real(kind=wp), allocatable :: E_Charge(:), LPChg(:), Q_Charge(:)
character(len=LenIn), allocatable :: Lbl(:)
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: Reduce_Prt

!                                                                      *
!***********************************************************************
!                                                                      *
! Get the print level

iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0
if (iPL < 2) return
!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Binom()
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over all domains

write(u6,*)
Banner_Line(1) = 'LoProp Charges per center'
#ifdef _DEBUGPRINT_
Banner_Line(2) = ' '
Banner_Line(3) = 'Note that this charge analysis only makes sense if the orbital basis is of true AO type!'
call Banner(Banner_Line,3,120)
#else
write(u6,'(6X,A)') trim(Banner_Line(1))
#endif

call mma_allocate(E_Charge,nAtoms,label='E_Charge')
call mma_allocate(Q_Charge,nAtoms,label='Q_Charge')
call mma_allocate(Lbl,nAtoms,label='Lbl')

! Collect data

mAtoms = 0
ij = 0
do iAtom=1,nAtoms
  ij = iAtom*(iAtom+1)/2
  if ((LblCnt(iAtom)(LenIn1:LenIn4) == ':E  ') .or. (LblCnt(iAtom)(LenIn1:LenIn4) == '    ')) then
    mAtoms = mAtoms+1
    Q_Charge(mAtoms) = Q_nuc(iAtom)
    E_Charge(mAtoms) = rMP(ij)
    Lbl(mAtoms) = LblCnt(iAtom)(1:LenIn)
  end if
end do
if (lSave) then
  call mma_allocate(LPChg,mAtoms,label='LoProp Chg')
  LPChg(:) = Q_Charge(1:mAtoms)+E_Charge(1:mAtoms)
  call Put_dArray('LoProp Charge',LPChg,mAtoms)
  call mma_deallocate(LPChg)
end if

! Print out the stuff!

Inc = 10
do iSt=1,mAtoms,Inc
  iEnd = min(mAtoms,iSt+Inc-1)
  write(u6,*)
  write(u6,'(/16X,10(3X,A))') (Lbl(i),i=iSt,iEnd)
  write(u6,'(6X,A,10F9.4)') 'Nuclear   ',(Q_Charge(i),i=iSt,iEnd)
  write(u6,'(6X,A,10F9.4)') 'Electronic',(E_Charge(i),i=iSt,iEnd)
  write(u6,*)
  write(u6,'(6X,A,10F9.4)') 'Total     ',(Q_Charge(i)+E_Charge(i),i=iSt,iEnd)
end do

call mma_deallocate(E_Charge)
call mma_deallocate(Q_Charge)
call mma_deallocate(Lbl)

#ifdef _DEBUGPRINT_
write(u6,*)
call Banner(Banner_Line,0,120)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine LoProp_Print

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine tr2NsA1(CMO,X1,nX1,X2,nX2,X3,nX3,
     &      pqUS,npqUS, pqRU,npqRU, pqTU,npqTU, lBuf)
C
C SECOND ORDER TWO-ELECTRON TRANSFORMATION ROUTINE
C
C THIS ROUTINE IS CALLED FOR EACH SYMMETRY BLOCK OF INTEGRALS
C (ISP,ISQ,ISR,ISS) WITH ISP.GE.ISQ AND ISR.GE.ISS.
C P,Q,R,S are SO indices.
C A,B are MO indices, counting only non-frozen and non-deleted.
C T,U are occupied MO indices, only non-frozen and non-deleted.
C INTEGRALS (AB/TU) ARE ALWAYS GENERATED
C EXCHANGE INTEGRALS (AT/BU) ARE GENERATED AS FOLLOWS:
C (AT/BU) IF ISP.GE.ISR
C (AT/UB) IF ISP.GT.ISS AND ISP.NE.ISQ
C (TA/BU) IF ISQ.GT.ISR AND ISP.NE.ISQ
C (TA/UB) IF ISQ.GE.ISS AND ISP.NE.ISQ
C
*
      Implicit real*8(a-h,o-z)
CPAM98      COMMON/INTTRA/ISP,ISQ,ISR,ISS,NBP,NBQ,NBR,NBS,NBPQ,NBRS,IRRST,
CPAM98     &              NOCP,NOCQ,NOCR,NOCS,NPQ,LADX,LRUPQ,LURPQ,LTUPQ,
CPAM98     &              NOP,NOQ,NOR,NOS,LMOP,LMOQ,LMOR,LMOS,LMOP2,LMOQ2,
CPAM98     &              LMOR2,LMOS2,IAD13,ITP,ITQ,ITR,ITS

#include "rasdim.fh"
#include "caspt2.fh"
#include "trafo.fh"
#include "intgrl.fh"

#include "SysDef.fh"
      DIMENSION CMO(NCMO)
      Dimension X1(nX1),X2(nX2),X3(nX3)
      Dimension PQTU(nPQTU),pqRU(npqRU),pqUS(npqUS)

      NSYMP=NSYM*(NSYM+1)/2
      NOTU=NOCR*NOCS
      IF(ISR.EQ.ISS) NOTU=(NOCR**2+NOCR)/2
      NOUS=NOCR*NBS
      NORU=NBR*NOCS
      icc  =NOP*NOQ*NOCR*NOCS
      icxc1=NOP*NOCQ*NOR*NOCS
      icxc3=NOP*NOCQ*NOCR*NOS
      icxc5=NOCP*NOQ*NOR*NOCS
      icxc7=NOCP*NOQ*NOCR*NOS
c
c Check for in core or out of core transformation
c
C     1. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|US) ON UNIT LUHLF1
      IPQMX1=NBPQ
cvv prevent integer overflow
      IF(1.0d0*NBPQ*NOUS.GT.LURPQ) THEN
       IPQMX1=LURPQ/NOUS
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|US)',IPQMX1
       IAD1S=0
       CALL dDAFILE(LUHLF1,0,pqUS,IPQMX1,IAD1S)
      ENDIF
      IAD1=0
      IOUT1=0
C     2. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|RU) ON UNIT LUHLF2
      IPQMX2=NBPQ
cvv prevent integer overflow
      IF(1.0d0*NBPQ*NORU.GT.LRUPQ) THEN
       IPQMX2=LRUPQ/NORU
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|RU)',IPQMX2
       IAD2S=0
       CALL dDAFILE(LUHLF2,0,pqRU,IPQMX2,IAD2S)
      ENDIF
      IAD2=0
      IOUT2=0
C     3. SORT OF PARTIALLY TRANSFORMED INTEGRALS (PQ|TU) ON UNIT LUHLF3
      IPQMX3=NBPQ
cvv prevent integer overflow
      IF(1.0d0*NBPQ*NOTU.GT.LTUPQ) THEN
       IPQMX3=LTUPQ/NOTU
c      WRITE(*,*) 'OUT OF CORE SORT FOR INTEGRALS (PQ|TU)',IPQMX3
       IAD3S=0
       CALL dDAFILE(LUHLF3,0,PQTU,IPQMX3,IAD3S)
      ENDIF
      IAD3=0
      IOUT3=0
c
c First half transformation
c
      LPQ=0
      NPQ=0
      iRc=0
      iOpt=1
      IRSST=1-NBRS
c Loop over p,q symmetry pair, if(ISP.eq.ISQ) loop should be triangle
      Do IP=1,NBP
       Num=NBQ
       if(ISP.eq.ISQ) Num=IP
       Do IQ=1,Num
        IOUT1=IOUT1+1
        IOUT2=IOUT2+1
        IOUT3=IOUT3+1
c  Read integrals (pq,rs)
        If(LPQ.eq.NPQ) then
         Call Rdord(iRc,iOpt,ISP,ISQ,ISR,ISS,X1,lBuf,nPQ)
         IF(IRC.GT.1) THEN
           WRITE(6,*)' ERROR RETURN CODE IRC=',IRC
           WRITE(6,*)' FROM RDORD, CALLED FROM TRA2.'
           CALL Abend
         END IF
         iOpt=2
         LPQ=0
         IRSST=1-NBRS
        Endif
        LPQ=LPQ+1
        IRSST=IRSST+NBRS
c  Square if necessary
        If(ISR.eq.ISS)then
         Call Square(X1(IRSST),X2,1,NBS,NBS)
        Else
         call dcopy_(NBRS,X1(IRSST),1,X2,1)
        Endif

c====================================================
c  First half transformation to (pq,Us), if ISR.ne.ISS
c  For exchange case3,4 (AT,UB), case7,8 (TA,UB)
c====================================================
        If(icxc3.ne.0.or.icxc7.ne.0)then
         If(ISR.ne.ISS)then
c  (pq,rs) -> (pq,Us)
          CALL DGEMM_('N','N',
     &                NBS,NOCR,NBR,
     &                1.0d0,X2,NBS,
     &                CMO(LMOR2),NBR,
     &                0.0d0,X3,NBS)
c  (pq,Us) Sorting
          IF(IOUT1.GT.IPQMX1) THEN
           IOUT1=1
cvv           DO I=1,NOUS
cvv            CALL dDAFILE(LUHLF1,1,pqUS(1+IPQMX1*(I-1)),IPQMX1,IAD1)
cvv           Enddo
         CALL dDAFILE(LUHLF1,1,pqUS,IPQMX1*NOUS,IAD1)
          ENDIF
          CALL DCOPY_(NOUS,X3,1,pqUS(IOUT1),IPQMX1)
         Endif
        Endif
c
c  First half transformation to (pq,rU)
c  For coulomb (AB,TU), exchange case1,2 (AT,BU), case5,6 (TA,BU)
c
        If(icc.ne.0.or.icxc1.ne.0.or.icxc5.ne.0)then
c  (pq,rs) -> (pq,rU)
         CALL DGEMM_('T','N',
     &               NBR,NOCS,NBS,
     &               1.0d0,X2,NBS,
     &               CMO(LMOS2),NBS,
     &               0.0d0,X3,NBR)
c  (pq,rU) Sorting
         IF(IOUT2.GT.IPQMX2) THEN
          IOUT2=1
cvv          DO I=1,NORU
cvv           CALL dDAFILE(LUHLF2,1,pqRU(1+IPQMX2*(I-1)),IPQMX2,IAD2)
cvv          Enddo
        CALL dDAFILE(LUHLF2,1,pqRU,IPQMX2*NORU,IAD2)
         ENDIF
         CALL DCOPY_(NORU,X3,1,pqRU(IOUT2),IPQMX2)

c  First half transformation to (pq,TU), if(ISR.eq.ISS)then triangle
c  (pq,rU) -> (pq,TU)
         If(icc.ne.0)then
          If(ISR.eq.ISS)then
           CALL MXMT(X3,        NBR,1,
     &               CMO(LMOR2),1,NBR,
     &               X2,
     &               NOCR,NBR)
          Else
           CALL DGEMM_('T','N',
     &                 NOCS,NOCR,NBR,
     &                 1.0d0,X3,NBR,
     &                 CMO(LMOR2),NBR,
     &                 0.0d0,X2,NOCS)
          Endif
c  (pq,TU) Sorting
          IF(IOUT3.GT.IPQMX3) THEN
           IOUT3=1
cvv           DO I=1,NOTU
cvv            CALL dDAFILE(LUHLF3,1,PQTU(1+IPQMX3*(I-1)),IPQMX3,IAD3)
cvv           Enddo
         CALL dDAFILE(LUHLF3,1,PQTU,IPQMX3*NOTU,IAD3)
          ENDIF
          CALL DCOPY_(NOTU,X2,1,PQTU(IOUT3),IPQMX3)
         Endif
        Endif
       Enddo
      Enddo
c  Store last buffer
      IF(IPQMX1.LT.NBPQ) THEN
cvv       DO I=1,NOUS
cvv        CALL dDAFILE(LUHLF1,1,pqUS(1+IPQMX1*(I-1)),IPQMX1,IAD1)
cvv       Enddo
      CALL dDAFILE(LUHLF1,1,pqUS,IPQMX1*NOUS,IAD1)
      ENDIF
      IF(IPQMX2.LT.NBPQ) THEN
cvv       DO I=1,NORU
cvv        CALL dDAFILE(LUHLF2,1,pqRU(1+IPQMX2*(I-1)),IPQMX2,IAD2)
cvv       Enddo
      CALL dDAFILE(LUHLF2,1,pqRU,IPQMX2*NORU,IAD2)
      ENDIF
      IF(IPQMX3.LT.NBPQ) THEN
cvv       DO I=1,NOTU
cvv        CALL dDAFILE(LUHLF3,1,PQTU(1+IPQMX3*(I-1)),IPQMX3,IAD3)
cvv       Enddo
      CALL dDAFILE(LUHLF3,1,PQTU,IPQMX3*NOTU,IAD3)
      ENDIF

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function GTH1ES_MCLR(IORB,ITP,ISM,JORB,JTP,JSM)
! This is a fantastic solution of the problem hehehehe!!
!  EAW
!
! one electron integral between orbitals (iorb,itp,ism,jorb,jsm,jtp)
!
! correct combination of row and column symmetry is assumed

use MCLR_Data, only: IBsO, IBTSOB, IREOTS, KAIN1, pInt1
use input_mclr, only: nIsh, nOrb
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: GTH1ES_MCLR
integer(kind=iwp), intent(in) :: IORB, ITP, ISM, JORB, JTP, JSM
integer(kind=iwp) :: I1, I_ABS, IJ, IREO, J1, J_ABS, JREO

I_ABS = IORB+IBTSOB(ITP,ISM)-1
IREO = IREOTS(I_ABS)
J_ABS = JORB+IBTSOB(JTP,JSM)-1
JREO = IREOTS(J_ABS)
I1 = IREO-IBSO(ISM)+1+nISH(ISM)
J1 = JREO-IBSO(JSM)+1+nISH(JSM)
IJ = pInt1(ISM)-1+(J1-1)*NORB(ISM)+I1
GTH1ES_MCLR = KAIN1(IJ)

end function GTH1ES_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Rulin Feng                                       *
!***********************************************************************

subroutine HFCSD(LABEL,IC,BUFF,NBUFF,NSIZ,ISCHK)
!***********************************************************************
!     Objective: to compute the 'spin-dependent' part of the hyperfine *
!                from the magnetic integrals contributions             *
!     Output: BUFF                                                     *
!***********************************************************************

use hfc_logical, only: MagX2C_Avail
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Three, Four
use Definitions, only: wp, iwp, u6

implicit none
character(len=8), intent(inout) :: LABEL
integer(kind=iwp), intent(in) :: IC, NBUFF, NSIZ
real(kind=wp), intent(inout) :: BUFF(NBUFF)
integer(kind=iwp), intent(inout) :: ISCHK
integer(kind=iwp) :: ICM, IOPT, IRC
real(kind=wp) :: DA
real(kind=wp), allocatable :: TA(:)

! Set MAG_X2C to avoid add_info in hfcts
MagX2C_Avail = .true.
IOPT = 0
call mma_allocate(TA,NBUFF,Label='TA')
! BUFF needs to be initialized
BUFF(:) = Zero
! end of initialization
DA = Two

select case (IC)

  case (1)
    ! EF2(1) = (2*MAG(1)-MAG(5)-MAG(9))*(2/3)
    ICM = 1
    DA = Four/Three
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)
    BUFF(NSIZ+1:NBUFF) = TA(NSIZ+1:NBUFF)

    ICM = 5
    DA = -Two/Three
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)

    ICM = 9
    DA = -Two/Three
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)

  case (2)
    ! EF2(2) = MAG(2)*2
    ICM = 2
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)
    BUFF(NSIZ+1:NBUFF) = TA(NSIZ+1:NBUFF)

  case (3)
    ! EF2(3) = MAG(3)*2
    ICM = 3
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)
    BUFF(NSIZ+1:NBUFF) = TA(NSIZ+1:NBUFF)

  case (4)
    ! EF2(4) = (2*MAG(5)-MAG(1)-MAG(9))*(2/3)
    ICM = 5
    DA = Four/Three
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)
    BUFF(NSIZ+1:NBUFF) = TA(NSIZ+1:NBUFF)

    ICM = 1
    DA = -Two/Three
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)

    ICM = 9
    DA = -Two/Three
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)

  case (5)
    ! EF2(5) = MAG(6)*2
    ICM = 6
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)
    BUFF(NSIZ+1:NBUFF) = TA(NSIZ+1:NBUFF)

  case (6)
    ! EF2(6) = (MAG(1)+MAG(5)+MAG(9))*2
    ICM = 1
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)
    BUFF(NSIZ+1:NBUFF) = TA(NSIZ+1:NBUFF)

    ICM = 5
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)

    ICM = 9
    call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
    if (IRC /= 0) call ErrStop()
    BUFF(1:NSIZ) = BUFF(1:NSIZ)+DA*TA(1:NSIZ)

  case default
    write(u6,'(6X,A)') '*** ERROR IN SUBROUTINE HFCSD ***'
    call Abend()

end select

call mma_deallocate(TA)

contains

subroutine ErrStop()

  write(u6,*)
  write(u6,'(6X,A)') '*** ERROR IN SUBROUTINE HFCSD ***'
  write(u6,'(6X,A)') '  FAILED IN READING FROM  ONEINT'
  write(u6,'(6X,A)') ' PLEASE MAKE SURE THE MAGNETIC'
  write(u6,'(6X,A)') ' HYPERFINE INTEGRALS ARE AVAILABLE'
  write(u6,'(6X,A,A)') '  LABEL     = ',LABEL
  write(u6,'(6X,A,I2)') '  COMPONENT = ',ICM
  write(u6,*)
  call ABEND()

end subroutine ErrSTop

end subroutine HFCSD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine ddrestart2_cvb(c,axc,vec,
     >  hp,solp,
     >  maxdav,n,
     >  nvguess1,nvrestart1,
     >  eigval,eigvec)
      implicit real*8 (a-h,o-z)
#include "direct_cvb.fh"
      dimension c(n,maxdav),axc(n,maxdav),vec(n)
      dimension hp(maxdav,maxdav)
      dimension solp(maxdav)
      dimension eigval(maxdav),eigvec(maxdav,maxdav)

      call fmove_cvb(hp,eigvec,maxdav*maxdav)
      call mxdiag_cvb(eigvec,eigval,maxdav)

      nvrestart1=0
      nvguess1=0
      call mxatb_cvb(c,solp,n,maxdav,1,vec)
      if(ifollow.le.2)then
c  (Put lower-lying solutions in AxC :)
        do 200 ir=1,nroot-1
        if(ifollow.eq.1)then
          ir_use=maxdav-ir+1
        else
          ir_use=ir
        endif
        call mxatb_cvb(c,eigvec(1,ir_use),n,maxdav,1,axc(1,ir+1))
200     continue
        call fmove_cvb(axc(1,2),c(1,2),n*(nroot-1))
      endif
      call fmove_cvb(vec,c(1,1),n)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
       SubRoutine OutRAS_td(iKapDisp,iCiDisp)
********************************************************************
*                                                                  *
* Writes the response to a permenent file MCKINT - Instead of      *
* just a temporary one.                                            *
* Contracts the response coefficient to the hessian                *
*                                                                  *
* Input                                                            *
*       iKapDisp : Disk locations of solutions to respons equation *
*       iCIDisp  : Disk locations of CI Soulutions to response     *
*                                                                  *
* Author: Anders Bernhardsson, 1996                                *
*         Theoretical Chemistry, University of Lund                *
********************************************************************
       Implicit Real*8 (a-h,o-z)
#include "detdim.fh"
#include "Input.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "disp_mclr.fh"
#include "cicisp_mclr.fh"
#include "stdalloc.fh"
       Character(LEN=8) Label
       Integer Pstate_sym
       Integer iKapDisp(nDisp),iCiDisp(nDisp)
       Logical CI
       Real*8, Allocatable:: Kap1(:), Kap2(:), Kap3(:), CIp1(:,:)
*
*-------------------------------------------------------------------*
*
* Ok construct hessian
*
*-------------------------------------------------------------------*
*
       Write(6,*)
       Write(6,*) '      Writing response to disk in Split guga '//
     &     'GUGA format'
       Write(6,*)
       idisp=0
       Do 100 iSym=1,nSym
          Call Setup_MCLR(iSym)
          PState_SYM=iEor(State_Sym-1,iSym-1)+1
          nconfM=ncsf(PState_Sym)
          nconf1=ncsf(PState_Sym)
          CI=.false.
          If (iMethod.eq.2.and.nconf1.gt.0) CI=.true.
          If (CI.and.nconf1.eq.1.and.isym.eq.1) CI=.false.
          if (Timedep) nconfM=nconfM*2
*
*    Allocate areas for scratch and state variables
*
          Call mma_allocate(Kap1,nDens2,Label='Kap1')
          Call mma_allocate(Kap2,nDens2,Label='Kap2')
          Call mma_allocate(Kap3,nDens2,Label='Kap3')
          If (CI) Then
             If (TimeDep) Then
                Call mma_allocate(CIp1,nconf1,2,Label='CIp1')
             Else
                Call mma_allocate(CIp1,nconf1,1,Label='CIp1')
             End If
           call InCSFSD(Pstate_sym,State_sym,.true.)
          End If
        Do 110 jDisp=1,lDisp(iSym)
         iDisp=iDisp+1
          kdisp=DspVec(idisp)
          iDisk=iKapDisp(iDisp)
          Len=nDensC
*---------------------------------------------------------
* LuTemp temp file in wfctl where the response is written
*---------------------------------------------------------
          Call dDaFile(LuTemp,2,Kap1,Len,iDisk)
*         if (ndensc.ne.0) Call RecPrt('K',' ',Kap1,ndensc,1)
          Call Uncompress(Kap1,Kap3,isym)
          If (CI) Then
             ilen=nconfM
             idis=iCIDisp(iDisp)
             Call dDaFile(LuTemp,2,CIp1,iLen,iDis)
*            Call RecPrt(' ',' ',CIp1,nconfM,1)
          End If
          Call TCMO(Kap3,isym,-1)
          irc=ndens2
          Label='KAPPA   '
          iopt=128
          isyml=2**(isym-1)
          ipert=kdisp
          Call dWrMCk(iRC,iOpt,Label,ipert,Kap3,isyml)
          if (irc.ne.0) Call Abend()
          irc=nconfM
          iopt=128
          Label='CI      '
          isyml=2**(isym-1)
          ipert=kdisp

          If (iAnd(kprint,8).eq.8) Write(6,*) 'Perturbation ',ipert

          If (Timedep.and.CI) then
            Call Guganew(CIp1(:,2),0,pstate_sym)
            Call DSCAL_(nconf1,-1.0d0,CIp1(:,2),1)
          End If

          If (CI) call Guganew(CIp1(:,1),0,pstate_sym)
          If (Timedep) then
            If (CI) Then
*              Call RecPrt(' ',' ',CIp1,nconfM,1)
               Call dWrMCk(iRC,iOpt,Label,ipert,CIp1,isyml)
            End If
          Else
            If (imethod.eq.2.and.(.not.CI).and.nconf1.eq.1)
     &         CIp1(1,1)=0.0d0
            Call dWrMCk(iRC,iOpt,Label,ipert,CIp1,isyml)
            if (irc.ne.0) Call Abend()
          End If
************************************************************************
*
 110     Continue
*
*    Free areas for scratch and state variables
*
          If (CI) Call mma_deallocate(CIp1)
          Call mma_deallocate(Kap3)
          Call mma_deallocate(Kap2)
          Call mma_deallocate(Kap1)
 100  Continue

*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine GetSh_Localisation(X,nBas,m,XSh,nShell,iSO2Sh,iOpt,
     &                              Norm)
      Implicit Real*8 (a-h,o-z)
      Real*8  X(nBas,m), XSh(nShell,*)
      Integer iSO2Sh(*)
      Character*3 Norm  ! 'MAX' or 'FRO'

      Character*3 myNorm

      If (nBas.lt.1 .or. nShell.lt.1) Return

      myNorm = Norm
      Call UpCase(myNorm)

      If (iOpt .eq. 1) Then
         Call dCopy_(nShell*m,[0.0d0],0,XSh,1)
         If (myNorm .eq. 'MAX') Then
            Do j = 1,m
               Do i = 1,nBas
                  iShell = iSO2Sh(i)
                  XSh(iShell,j) = max(abs(X(i,j)),XSh(iShell,j))
               End Do
            End Do
         Else If (myNorm .eq. 'FRO') Then
            Do j = 1,m
               Do i = 1,nBas
                  iShell = iSO2Sh(i)
                  XSh(iShell,j) = XSh(iShell,j) + X(i,j)**2
               End Do
               Do iShell = 1,nShell
                  XSh(iShell,j) = sqrt(XSh(iShell,j))
               End Do
            End Do
         End If
      Else
         If (m .ne. nBas) Then
            Call SysAbendMsg('GetSh_Localisation','Fatal error',
     &                       'm != nBas')
         End If
         Call dCopy_(nShell*nShell,[0.0d0],0,XSh,1)
         If (myNorm .eq. 'MAX') Then
            Do j = 1,nBas
               jShell = iSO2Sh(j)
               Do i = 1,nBas
                  iShell = iSO2Sh(i)
                  XSh(iShell,jShell) =
     &               max(abs(X(i,j)),XSh(iShell,jShell))
               End Do
            End Do
         Else If (myNorm .eq. 'FRO') Then
            Do j = 1,nBas
               jShell = iSO2Sh(j)
               Do i = 1,nBas
                  iShell = iSO2Sh(i)
                  XSh(iShell,jShell) = XSh(iShell,jShell) + X(i,j)**2
               End Do
            End Do
            Do jShell = 1,nShell
               Do iShell = 1,nShell
                  Xsh(iShell,jShell) = sqrt(Xsh(iShell,jShell))
               End Do
            End Do
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine o3v3t2(wrk,wrksize,NvGrp,maxdim,LunAux)
! This routine does:
!
! --- Part III, generation of X, Y intermediates
!
!  T2(be,ga,u,v) <-
!  T21  +             [ (be,u|ga,v)                 ]
!  T22  + sum(i,j)    [ Ta(be,ga,ij) . A(i,j,u,v)   ]
!  T21 implemented as X0:
!  T22 implemented as X4:
!
! X(be,u,ga,v) <<-
!    X0 (T21)     1/2 (be,u|ga,v)
!    X1         + Q(be,u,i,a) . E(ga,a,i,v)
!    X2 (T24)   + Gvv(a,be)   . t2(ga,a,v,u)
!    X3 (T25)   - Goo(i,u)    . t2(ga,be,v,i)
!    X4 (T22)   + sum(i>=j)   [ Ta(be,ga,ij) . A(ij,u,v)  ]
!               - 1/2 sum(i)  [ Ta(be,ga,ii) . A(ii,u,v)  ]
!    Xe (T2ex)  - sum(i,j)    [ Aex(i,j,u,v) . T1(be,i) .T1(ga,j) ]
!                 Xe - o4v2 term is factorized to o4v + o3v2 terms
!
! Y(be,u,ga,v) = K(be,u,i,a) . t2(i,a,ga,v)
!
! where E(ga,a,i,v) = 2 t2(ga,a,v,i) - t2(ga,a,i,v)
!
! T1(be,u) << -
! T11  +            [  F(be,u)                   ]
! T12  - sum(a,i)   [ 2F(a,i) . t(be,i) . t(a,u) ]
! T13  + sum(a)     [  Hvv(a,be) . t(a,u)        ]
! T14  - sum(i)     [  Hoo(i,u)  . t(be,i)       ]
! T15  + sum(a,i)   [  Hoo(a,i)  .
!     (2t2(be,a,u,i) - t2(be,a,i,u) + t(a,u).t(be,i)) ]
!
! Extra cost - multiple reading:
!              1) N_be . T;
!              2) N_ga . Q
!              3) N_ga . K
!
!1 intermediates Q and K will be temporarily stored in files
!  QFil, KFil as follows
!  do beGrp
!    do aGrp
!      Q(K) (be',u,i,a')
!    end do
!  end do
!
!2 Structure of files, where selected group of (pq|rs) are
!  stored (V'O|OO) - I1 ; (V'O|V'O) - I2 ; (V'V'|OO) - I3
!
!  (A'I|JK)  I1inxx xx - Group of A'
!
!  (A'I|B'J) I2xxyy xx - Group of A'
!                   yy - Group of B'
!
!  (A'B'|IJ) I3xxyy xx - Group of A'
!                   yy - Group of B'
!
!3 Structure of Cholesky vector files
!
!  L1(m,I ,A')  L1vcxx xx - Group of A'
!
!  L2(m,A',B')  L2xxyy xx - Group of A'
!                      yy - Group of B'
!
!4 Structure of Amplitude file
!  t2(A',B',IJ)  T2xxyy xx - Group of A'
!                       yy - Group of B'

use Index_Functions, only: nTri_Elem
use chcc_global, only: BeAID, BetaID, DimGrpv, I2Name, intkey, no, nv, PosA, PosAex, PosFree, PosFvo, PosGoo, PosGvv, PosHoo, &
                       PosHvo, PosHvv, PosT1n, PosT1o, printkey, T2Name, TCpu, TCpu_l, Tmp1Name, Tmp2Name, TWall, TWall_l, TWall0, &
                       Xyes, XYyes
use Para_Info, only: MyRank
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, NvGrp, maxdim, LunAux
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: adda, addbe, addga, aGrp, beGrp, dim_1, dim_2, dima, dimbe, dimga, gaGrp, PosH1, PosH2, PosH3, PosH4, PosK, &
                     PosQ, PosT, PosV1, PosV2, PosV3, PosV4, PosX, PosY
character(len=6) :: LunName

! --- introduction part ---
!
! Distribute memory
! @@ yet distribution is the same for all three o3v3 drivers,
! v buducnosti nosnost usposobit vsetky 3 vlastne

PosT = PosFree
call DistMemo3v3t2(maxdim,PosV1,PosV2,PosV3,PosV4,PosH1,PosH2,PosH3,PosH4,PosK,PosQ,PosT)

if (printkey >= 10) write(u6,*) ' Last Value :',PosT,wrksize
if (PosT > wrksize) then
  !mp write(u6,*) ' Nieje dobre, Dr. Ch.  Kokotopuloss',
  write(u6,*) ' Not Enough memory in o3v3t2 step! Increase large and/or small segmentation ', &
              real(PosT,kind=wp)/real(wrksize,kind=wp)
  call abend()
end if

!G Vanish XYyes

XYyes(1:NvGrp,1:NvGrp) = 0

PosX = PosQ
PosY = PosK

addbe = 0
do beGrp=1,NvGrp
  dimbe = DimGrpv(beGrp)

  !## test, if this beGrp is planed to be run on this node
  dim_1 = sum(BeAID(myRank,beGrp,1:NvGrp))
  dim_1 = dim_1+BetaID(myRank,beGrp)
  if (dim_1 /= 0) then
    if (printkey > 1) write(u6,*) ' o3v3 T2 - ID, beGrp',myRank,beGrp ! nie som si isty ....
    !mp
    call CWTime(TCpu,TWall)
    if (printkey > 1) then
      write(u6,*)
      write(u6,'(A,f18.1)') ' Cpu last call [s] = ',TCpu-TCpu_l
      write(u6,'(A,f18.1)') 'Wall last call [s] = ',TWall-TWall_l
      write(u6,*)
      write(u6,'(A,f18.1)') 'Total Cpu  [s] = ',TCpu
      write(u6,'(A,f18.1)') 'Total Wall [s] = ',TWall-TWall0
      write(u6,'(A,f18.2)') 'TCpu/TWall [%] = ',100.0_wp*TCpu/(TWall-TWall0)
      write(u6,*)
    end if
    TCpu_l = TCpu
    TWall_l = TWall
    !mp

    !T1G vanish H4(be',u)
    dim_1 = dimbe*no
    wrk(PosH4:PosH4+dim_1-1) = Zero

    !G Extract H1(be',I) <- T1(be,I)
    call ExtT1(wrk(PosH1),wrk(PosT1o),dimbe,addbe)

    addga = 0
    do gaGrp=1,NvGrp
      dimga = DimGrpv(gaGrp)

      ! initialize X(be',u,ga',v) as X0, calc in step II
      ! vanish Y(be',u,ga',v)
      LunName = Tmp2Name(beGrp,gaGrp)
      dim_1 = no*no*DimGrpv(beGrp)*DimGrpv(gaGrp)
      if (Xyes(beGrp,gaGrp) == 1) then
        call GetX(wrk(PosX),dim_1,LunAux,LunName,1,1)
        Xyes(beGrp,gaGrp) = 2
      else
        wrk(PosX:PosX+dim_1-1) = Zero
      end if
      wrk(PosY:PosY+dim_1-1) = Zero

      !G Extract H2(ga',I) <- T1(ga,I)
      call ExtT1(wrk(PosH2),wrk(PosT1o),dimga,addga)

      adda = 0
      do aGrp=1,NvGrp
        dima = DimGrpv(aGrp)

        ! Test, if this Be' A' combination is to be run on this node
        if (BeAID(myRank,beGrp,aGrp) /= 0) then
           if (printkey >= 10) write(u6,*) ' o3v3 T2 - ID,be,a,ga',myRank,beGrp,aGrp,gaGrp

           !XY1.1.1 read V1(ga',a',p,q) <- t2(ga',a',p,q)
           LunName = T2Name(gaGrp,aGrp)
           if (aGrp == gaGrp) then
             dim_1 = nTri_Elem(dimga)*no*no
             call GetX(wrk(PosV2),dim_1,LunAux,LunName,1,1)
             !XY1.1.2 Expand V1(be',b',p,q) <- V2(be'b',p,q)
             dim_1 = nTri_Elem(dima)
             call ExpT2(wrk(posV2),wrk(PosV1),dimga,dim_1,no)
           else
             dim_1 = dimga*dima*no*no
             call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
           end if

           if (gaGrp == beGrp) then
             !@ tento if nebol prevereny dostatocne
             ! term T15 only for ga'=be'
             ! use     : V1(be',a',I,J) = T2(be',a',I,J)
             !           H1(be',I) = T1(be,I) also H2
             ! destroy : V2,V3 (also V4 is free)

             !T15.1 Extract V2(a',I) <- T1(a,i)
             call ExtT1(wrk(PosV2),wrk(PosT1o),dima,adda)

             !T15.2 Make V3(be',u,a',i) <- 2t2(be,a,u,i)-t2(be,a,i,u)+t(a,u).t(be,i)
             call MkT_T15(wrk(PosV3),wrk(PosV1),wrk(PosH1),wrk(posV2),dimbe,dima,no)

             !T15.3 Extract V2(a',i) <- Hvo(a',i) rutina identicka s ExtT1
             call ExtT1(wrk(PosV2),wrk(PosHvo),dima,adda)

             !T15.4f Calc H4(be',u) <<- V3(be',u,a',i) . V2(a',i)
             call mv0v1a3u(dimbe*no,dima*no,dima*no,dimbe*no,dimbe*no,dima*no,1,1,wrk(PosV3),wrk(PosV2),wrk(PosH4))

           end if

           !X2.1 Map V3(a',u,ga',v) <- V1(ga',a',v,u)
           call Map4_3142(wrk(PosV1),wrk(PosV3),dimga,dima,no,no)

           !X2.2 Extract H3(a',be') <- Gvv(be,a)
           call ExH_X2(wrk(PosGvv),wrk(PosH3),dima,dimbe,nv,adda,addbe)

           !X2.3 Calc V4(be',u,ga',v) <- H3(T)(a',be') . V3(a',u,ga',v)
           dim_1 = dimbe*dimga*no*no
           wrk(PosV4:PosV4+dim_1-1) = Zero
           dim_1 = dimga*no*no
           call mc0c1at3b(dima,dimbe,dima,dim_1,dimbe,dim_1,dimbe,dima,dim_1,wrk(PosH3),wrk(PosV3),wrk(PosV4))

           !X2.4f Add X(be',u,ga',v) <<- +V4(be',u,ga',v)
           ! pozor na faktor, cele X je s vahou 0.5, sem teda asi 2
           dim_1 = dimbe*dimga*no*no
           wrk(PosX:PosX+dim_1-1) = wrk(PosX:PosX+dim_1-1)+Two*wrk(PosV4:PosV4+dim_1-1)

           if (aGrp == beGrp) then
             ! now a=be, i.e in V1 there is t2(ga',be',I,J)

             !X3.1 Calc V2(ga',be',v,u) <- V1(ga',be',v,i) . Goo(i,u)
             dim_1 = dimga*dimbe*no*no
             wrk(PosV2:PosV2+dim_1-1) = Zero
             dim_1 = dimga*dimbe*no
             call mc0c1a3b(dim_1,no,no,no,dim_1,no,dim_1,no,no,wrk(PosV1),wrk(PosGoo),wrk(PosV2))

             !X3.2 map V3((be',u,ga',v) <- V2(ga',be',v,u)
             call Map4_3142(wrk(posV2),wrk(PosV3),dimga,dimbe,no,no)

             !X3.3f Add X(be',u,ga',v) <<- -V3(be',u,ga',v)
             ! pozor na faktor, cele X je s vahou 0.5, sem teda asi -2
             dim_1 = dimbe*dimga*no*no
             wrk(PosX:PosX+dim_1-1) = wrk(PosX:PosX+dim_1-1)-Two*wrk(PosV3:PosV3+dim_1-1)

             !X4.1 Map V2(be',ga',J,I) <- V1(ga',be',I,J)
             call Map4_2143(wrk(PosV1),wrk(PosV2),dimga,dimbe,no,no)

             !X4.2 Make Tau in V2(be',ga',I,J)
             call MkTau_chcc(wrk(PosV2),wrk(PosH1),wrk(PosH2),dimbe,dimga,no,One,One)

             !X4.3 Extract V3(be',ga',ij) <- V2(be',ga',I,J)
             call ExV_X41(wrk(PosV3),wrk(PosV2),dimbe*dimga,no)

             !X4.5 V4(be',ga',u,v) <- V3(be',ga',ij) . A(ij,u,v)
             dim_1 = dimga*dimbe*no*no
             wrk(PosV4:PosV4+dim_1-1) = Zero
             dim_1 = dimbe*dimga
             dim_2 = nTri_Elem(no)
             call mc0c1a3b(dim_1,dim_2,dim_2,no*no,dim_1,no*no,dim_1,dim_2,no*no,wrk(PosV3),wrk(PosA),wrk(PosV4))

             !X4.6 Map V3(ij,V,U) <- A(ij,U,V)
             dim_1 = nTri_Elem(no)
             call Map3_132(wrk(PosA),wrk(PosV3),dim_1,no,no)

             !X4.7 Set A(ij,V,U) <- V3(ij,V,U)
             dim_1 = no*no*nTri_Elem(no)
             wrk(PosA:PosA+dim_1-1) = wrk(PosV3:PosV3+dim_1-1)

             !X4.8 Make V3(be',ga',ij) <- V2(be',ga',J,I) for i>=j
             call ExV_X43(wrk(PosV3),wrk(PosV2),dimbe*dimga,no)

             !X4.9 V4(be',ga',u,v) << - V3(be',ga',ij) . A(ij,u,v)
             dim_1 = dimbe*dimga
             dim_2 = nTri_Elem(no)
             call mc0c1a3b(dim_1,dim_2,dim_2,no*no,dim_1,no*no,dim_1,dim_2,no*no,wrk(PosV3),wrk(PosA),wrk(PosV4))

             !X4.10 Map V3(ij,U,V) <- A(ij,V,U)
             dim_1 = nTri_Elem(no)
             call Map3_132(wrk(PosA),wrk(PosV3),dim_1,no,no)

             !X4.11 Set A(ij,U,V) <- V3(ij,U,V)
             dim_1 = no*no*nTri_Elem(no)
             wrk(PosA:PosA+dim_1-1) = wrk(PosV3:PosV3+dim_1-1)

             !X4.12 Extract H3(i,u,v) <- A(ii,u,v)
             call ExA_X4(wrk(PosA),wrk(PosH3),no)

             !X4.13 Extract V3(be',ga',i) <- V2(be',ga',I,J)
             call ExV_X42(wrk(PosV3),wrk(PosV2),dimbe*dimga,no)

             !X4.14 V4(be',ga',u,v) <<- - V3(be',ga',i) . H3(i,u,v)
             dim_1 = dimbe*dimga
             call mc0c2a3b(dim_1,no,no,no*no,dim_1,no*no,dim_1,no,no*no,wrk(PosV3),wrk(PosH3),wrk(PosV4))

             !X4.15 Map V3(be',u,ga',v) <- V4(be',ga',u,v)
             call Map4_1324(wrk(PosV4),wrk(PosV3),dimbe,dimga,no,no)

             !X4.16f Add X(be',u,ga',v) <<- V3(be',u,ga',v)
             ! pozor na faktor, cele X je s vahou 0.5, sem teda asi 1
             dim_1 = dimbe*dimga*no*no
             wrk(PosX:PosX+dim_1-1) = wrk(PosX:PosX+dim_1-1)+wrk(PosV3:PosV3+dim_1-1)

             !Xe Term Xe (V2,V3 and V4 can be used)
             ! only in cholesky based approach

             if (intkey == 0) then
               !Xe.1 Ext V2(i,u,v,j) <- Aex(ij,uv)
               call Ext_Aex(wrk(PosAex),wrk(PosV2),no)

               !Xe.2 V3(be',u,v,j) <- H1(=T1)(be',i) . V2(i,u,v,j)
               dim_1 = dimbe*no*no*no
               wrk(PosV3:PosV3+dim_1-1) = Zero
               dim_1 = no*no*no
               call mc0c1a3b(dimbe,no,no,dim_1,dimbe,dim_1,dimbe,no,dim_1,wrk(PosH1),wrk(PosV2),wrk(PosV3))

               !Xe.3 Map V4(j,ga') <- H2(ga',j)
               call Map2_21(wrk(PosH2),wrk(PosV4),dimga,no)

               !Xe.4 V2(be',u,v,ga') <- V3(be',u,v,j) . V4(j,ga')
               dim_1 = dimbe*dimga*no*no
               wrk(PosV2:PosV2+dim_1-1) = Zero
               dim_1 = dimbe*no*no
               call mc0c1a3b(dim_1,no,no,dimga,dim_1,dimga,dim_1,no,dimga,wrk(PosV3),wrk(PosV4),wrk(PosV2))

               !Xe.5 Map V3(be',u,ga',v) <- V2(be,u,v,ga')
               call Map3_132(wrk(PosV2),wrk(PosV3),dimbe*no,no,dimga)

               !Xe.6f Add X(be',u,ga',v) <<- - V3(be',u,ga',v)
               ! pozor na faktor, cele X je s vahou 0.5, sem teda asi -1
               dim_1 = dimbe*dimga*no*no
               wrk(PosX:PosX+dim_1-1) = wrk(PosX:PosX+dim_1-1)-wrk(PosV3:PosV3+dim_1-1)
             end if

           end if

           !X1.2 map V2(a',i,ga',v) <- V1(ga',a',i,v)
           call Map4_3124(wrk(PosV1),wrk(PosV2),dimga,dima,no,no)

           !X1.3 read V1(be',u,i,a') <- Q(be',u,i,a')
           LunName = Tmp1Name(beGrp,aGrp)
           dim_1 = dimbe*dima*no*no
           call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,0)
           !X1.4 Map V3(be',u,a',i) <- V1(be',u,i,a')
           dim_1 = dimbe*no
           call Map3_132(wrk(PosV1),wrk(PosV3),dim_1,no,dima)

           !Y1.2 read V1(be',u,i,a') <- K(be',u,i,a')
           dim_1 = dimbe*dima*no*no
           call GetX(wrk(PosV1),dim_1,LunAux,LunName,0,1)
           !Y1.3 Map V4(be',u,a',i) <- V1(be',u,i,a')
           dim_1 = dimbe*no
           call Map3_132(wrk(PosV1),wrk(PosV4),dim_1,no,dima)

           !Y1.4f Y(be',u,ga',v) <<- V4(be',u,a',i) . V2(a',i,ga',v)
           call mc0c1a3b(dimbe*no,dima*no,dima*no,dimga*no,dimbe*no,dimga*no,dimbe*no,dima*no,dimga*no,wrk(PosV4),wrk(PosV2), &
                         wrk(PosY))

           !X1.5 Make E: V1(a',i,ga',v) = 2 V2(a',v,ga',i) - V2(a',i,ga',v)
           call MkE_Y3(wrk(PosV1),wrk(PosV2),dima,dimga,no)

           !X1.6f X(be',u,ga',v) <<- V3(be',u,a',i) . V1(a',i,ga',v)
           call mc0c1a3b(dimbe*no,dima*no,dima*no,dimga*no,dimbe*no,dimga*no,dimbe*no,dima*no,dimga*no,wrk(PosV3),wrk(PosV1), &
                         wrk(PosX))

        end if
        adda = adda+dima
      end do

      !X0.1 read V1(be',u,ga',j) <- (be',u|ga',v)
      !## this contribution need to be taken only once for given be'ga'
      !   thus will be executed on that node, where be',a'=1 is calculated
      if (BeAID(myRank,beGrp,1) == 1) then
        LunName = I2Name(beGrp,gaGrp)
        dim_1 = dimbe*dimga*no*no
        call GetX(wrk(PosV1),dim_1,LunAux,LunName,1,1)
      else
        dim_1 = dimbe*dimga*no*no
        wrk(PosV1:PosV1+dim_1-1) = Zero
      end if

      !X0.2f Add X(be',u,ga',v) <<- 1/2 V1(be',u,ga',v)
      ! pozor na faktor, cele X je s vahou 0.5, sem teda asi 1
      dim_1 = dimbe*dimga*no*no
      wrk(PosX:PosX+dim_1-1) = wrk(PosX:PosX+dim_1-1)+wrk(PosV1:PosV1+dim_1-1)

      ! save X,Y
      LunName = Tmp2Name(beGrp,gaGrp)
      dim_1 = dimbe*dimga*no*no
      XYyes(beGrp,gaGrp) = 1
      call SaveX(wrk(PosX),dim_1,LunAux,LunName,1,0)
      call SaveX(wrk(PosY),dim_1,LunAux,LunName,0,1)

      !@@
      !call Chck_Y(wrk(PosY),dimbe,addbe,dimga,addga)
      !call Chck_X(wrk(PosX),dimbe,addbe,dimga,addga)
      !@@
      addga = addga+dimga
    end do

    !## These contributions must be taken only once per Beta'
    if (BetaID(myRank,beGrp) == 1) then

      !T12.1 calc V1(i,u) <<- Fvo(T)(a,i) . T1o(a,u)
      dim_1 = no*no
      wrk(PosV1:PosV1+dim_1-1) = Zero
      call mc0c1at3b(nv,no,nv,no,no,no,no,nv,no,wrk(PosFvo),wrk(PosT1o),wrk(PosV1))

      !T12.2 calc V2(be',u) <<- T1o(be',i) . V1(i,u)
      dim_1 = no*dimbe
      wrk(PosV2:PosV2+dim_1-1) = Zero
      call mc0c1a3b(dimbe,no,no,no,dimbe,no,dimbe,no,no,wrk(PosT1o),wrk(PosV1),wrk(PosV2))

      !T12.3f Add H4(be',u) <<- -2.0 V2(be',u)
      wrk(PosX:PosX+dim_1-1) = wrk(PosX:PosX+dim_1-1)-Two*wrk(PosV2:PosV2+dim_1-1)

      !T13.1 Extract V1(a,be') <- Hvv(a,be)
      call ExH_T13(wrk(PosV1),wrk(PosHvv),dimbe,addbe,nv)

      !T13.2f Add H4(be',u) <<- V1(T)(a,be') . T1(a,i)
      call mc0c1at3b(nv,dimbe,nv,no,dimbe,no,dimbe,nv,no,wrk(PosV1),wrk(PosT1o),wrk(PosH4))

      !T14.1 calc V1(be',u) <- H1(be',i) . Hoo(i,u)
      dim_1 = no*dimbe
      wrk(PosV1:PosV1+dim_1-1) = Zero
      call mc0c1a3b(dimbe,no,no,no,dimbe,no,dimbe,no,no,wrk(PosH1),wrk(PosHoo),wrk(PosV1))

      !T14.2f Add H4(be',u) <<- - V1(be',u)
      dim_1 = no*dimbe
      wrk(PosH4:PosH4+dim_1-1) = wrk(PosH4:PosH4+dim_1-1)-wrk(PosV1:PosV1+dim_1-1)

    end if

    !T1G Add T1n(be,u) <<- H4(be',u)
    call AdT_T17(wrk(PosT1n),wrk(PosH4),nv,dimbe,no,addbe,One)

  end if
  addbe = addbe+dimbe
end do

!## correct Xyes (those, modified to 2 reset to 1)
do dim_1=1,NvGrp
  do dim_2=1,NvGrp
    if (Xyes(dim_1,dim_2) == 2) Xyes(dim_1,dim_2) = 1
  end do
end do

#ifdef _MOLCAS_MPP_
!## Synchronizacny bod:
!1 Allreduce T1n
!2 Allreduce X,Y (yet not needed)
dim_1 = nv*no
call gadgop(wrk(PosT1n),dim_1,'+')
#endif

!T11.1 Add T1n(be,u) <<- Fvo(be,u)
dim_1 = nv*no
wrk(PosT1n:PosT1n+dim_1-1) = wrk(PosT1n:PosT1n+dim_1-1)+wrk(PosFvo:PosFvo+dim_1-1)

!@@
!call Chck_T1(wrk(PosT1n),0)
!@@

return

end subroutine o3v3t2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE RFTTS( BLOCKSI, BLOCKSO,  IBLOCK,  NBLOCK,   ICOPY,
     &                    NSMST,    NSASO,   NSBSO,
     &                      IDC,      PS,    IWAY,   IPRNT)
*
* Reformat between determinant and combination form of
* matrices. No scaling is performed .
*
* IWAY = 1 : dets to combs
* IWAY = 2 : combs to dets
*
* Combination storage mode is defined BY IDC
*
*. Jeppe Olsen, August 1995
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
      DIMENSION NSASO(NSMST,*),NSBSO(NSMST,*)
*.
      DIMENSION BLOCKSI(*),BLOCKSO(*)
      INTEGER IBLOCK(8,NBLOCK)
*

      NTEST = 00
      NTEST = MAX(NTEST,IPRNT)
*
      LENGTH = 0
      IF(IWAY.EQ.1) THEN
        ISCI = 1
        ISCO = 2
      ELSE
        ISCI = 2
        ISCO = 1
      END IF
*
      IF( NTEST .GT. 10 ) THEN
        WRITE(6,*) ' Information from RFTTS  '
        WRITE(6,*) ' ======================= '
        WRITE(6,*) ' Input vector '
        CALL WRTTTS(  BLOCKSI,   IBLOCK,   NBLOCK,    NSMST,
     &                NSASO,    NSBSO,     ISCI)
      END IF
*
      DO JBLOCK = 1, NBLOCK
*
        IATP = IBLOCK(1, JBLOCK)
        IBTP = IBLOCK(2, JBLOCK)
        IASM = IBLOCK(3, JBLOCK)
        IBSM = IBLOCK(4, JBLOCK)
        IF(IBLOCK(1,JBLOCK).GT.0) THEN
*
        IF(IWAY.EQ.1) THEN
          IOFFI = IBLOCK(5,JBLOCK)
          IOFFO = IBLOCK(6,JBLOCK)
        ELSE
          IOFFO = IBLOCK(5,JBLOCK)
          IOFFI = IBLOCK(6,JBLOCK)
        END IF
*. Is this block diagonal in packed form
        IF(IDC.EQ.2.AND.IASM.EQ.IBSM.AND.IATP.EQ.IBTP) THEN
          IPACK = 1
        ELSE
          IPACK = 0
        END IF
        NIA = NSASO(IASM,IATP)
        NIB = NSBSO(IBSM,IBTP)
*. Number of elements in output block
        IF(IPACK .EQ. 1 .AND. ISCO.EQ.2 ) THEN
          NELMNT =  NIA*(NIA+1)/2
        ELSE
          NELMNT =  NIA*NIB
        END IF
C?     WRITE(6,*) ' JBLOCK, NELMNT = ', JBLOCK,NELMNT
C?     write(6,*)
C?   & ' RFTTS : IATP IBTP IASM IBSM ',IATP,IBTP,IASM,IBSM
C?     WRITE(6,*)
C?   & ' RFTTS : NIA NIB IOFFI,IOFFO',NIA,NIB,IOFFI,IOFFO
*
        IF(IPACK.EQ.0) THEN
*. Just copy
          CALL COPVEC(BLOCKSI(IOFFI),BLOCKSO(IOFFO),NELMNT)
        ELSE
          IF(IWAY.EQ.1) THEN
*. unpacked => packed
C TRIPK3(AUTPAK,APAK,IWAY,MATDIM,NDIM,SIGN)
            CALL TRIPK3(BLOCKSI(IOFFI),BLOCKSO(IOFFO),1,NIA,NIA,
     &                        PS)
          ELSE
*. Packed => unpacked
            CALL TRIPK3(BLOCKSO(IOFFO),BLOCKSI(IOFFI),2,NIA,NIA,
     &                        PS)
          END IF
        END IF
        LENGTH = LENGTH + NELMNT
        END IF
      END DO
*
      IF(ICOPY.NE.0) THEN
        CALL COPVEC(BLOCKSO,BLOCKSI,LENGTH)
      END IF
*
      IF( NTEST .GT. 10 ) THEN
        WRITE(6,*) ' Information from RFTTS  '
        WRITE(6,*) ' ======================= '
        WRITE(6,*) ' Output vector '
        CALL WRTTTS(  BLOCKSO,   IBLOCK,   NBLOCK,    NSMST,
     &                NSASO,    NSBSO,     ISCO)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CHO_SCF_RDINP(DFonly,LuSpool)
!***********************************************************************
!
!  Purpose:   If DFonly, use defaults only.
!             Else, read and process input for Cholesky section in SCF
!
!***********************************************************************

use Fock_util_global, only: Deco, DensityCheck, Estimate, Update
use Cholesky, only: ChFracMem, timings
use InfSCF, only: ALGO, dmpk, nScreen, ReOrd
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: DFonly
integer(kind=iwp), intent(in) :: LuSpool
integer(kind=iwp) :: iChrct, Last
real(kind=wp) :: dmpk_dfl
character(len=180) :: Key, KWord
character(len=*), parameter :: SECNAM = 'CHO_SCF_RDINP'
integer(kind=iwp), external :: iCLast
character(len=180), external :: Get_Ln

!                                                                      *
!**** Algorithms for using Cholesky vectors in SCF *********************
!                                                                      *
!   ALGO:
!          0  --->  Integrals are regenerated on the fly
!                   from a set of Cholesky vectors resorted on disk
!                   (Used only for debugging! Amazingly slow!)
!
!          1  --->  The resorted Cholesky vectors are used directly
!                   by the Fock matrix builder routines and contracted
!                   with the proper density matrices. Uses
!                   vectors resorted either on disk or on the fly
!                   (Used only for debugging! Very slow!)
!
!          2  --->  As in option 1 but using the MO-basis transformed
!                   vectors for computing the exchange term
!
!          3  --->  As in option 2 but using the MO-basis vectors
!                   transformed directly in reduced sets
!
!          4  --->  Local-exchange (LK) algorithm for the exchange term
!                                                                      *
!***********************************************************************
!                                                                      *
! Default  parameters

#ifdef _MOLCAS_MPP_
ChFracMem = 0.3_wp
#else
ChFracMem = Half
#endif

! set some parameters if not specified in ChoInput section
ALGO = 4
REORD = .false.
DECO = .true.
DensityCheck = .false.
timings = .false.
NSCREEN = 10    ! default screening interval (# of red sets)
dmpk = 0.045_wp ! default damping of the screening threshold
Estimate = .false.
Update = .true.
if (DFonly) return

dmpk_dfl = dmpk
!                                                                      *
!***********************************************************************
!                                                                      *
!                                                                      *
!***********************************************************************
!                                                                      *
! Process the input

!----------------------------------------------------------------------*
! The big turning point.                                               *
!----------------------------------------------------------------------*
do
  !--------------------------------------------------------------------*
  ! Use Get_Ln to read the lines.                                      *
  !--------------------------------------------------------------------*
  Key = Get_Ln(LuSpool)
  Kword = Key
  call UpCase(Kword)
  !--------------------------------------------------------------------*
  ! The keywords and their labels.                                     *
  !--------------------------------------------------------------------*

  if ((KWord(1:1) == '*') .or. (KWord == '')) cycle
  select case (KWord(1:4))
    case ('ALGO')
      !                                                                *
      !***** ALGO ******************************************************
      !                                                                *
      ! Read Cholesky algorithm parameters

      read(LuSpool,*) ALGO

#     ifdef _DEBUGPRINT_
      select case (ALGO)
        case (0)
          write(u6,*) 'Integral regeneration from Cholesky vectors reordered on disk'
        case (1)
          write(u6,*) 'Density-based Cholesky. Default reorder: on the fly'
        case (2)
          write(u6,*) 'MO-based-Exchange Cholesky. Default reorder: on the fly'
        case (3)
          write(u6,*) 'MO-based-Exchange Cholesky. MO-transformation in reduced sets'
        case (4)
          write(u6,*) 'Local-Exchange (LK) algorithm.'
      end select
      write(u6,*)
#     endif

    case ('REOR')
      !                                                                *
      !***** REOR ******************************************************
      !                                                                *
      REORD = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Vectors reordered on DISK'
      write(u6,*)
#     endif

    case ('NODE')
      !                                                                *
      !***** NODE ******************************************************
      !                                                                *
      DECO = .false.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Not-Using Decomposed density matrix'
      write(u6,*)
#     endif

    case ('DCHK')
      !                                                                *
      !***** DCHK ******************************************************
      !                                                                *
      DensityCheck = .true.

    case ('TIME')
      !                                                                *
      !***** TIME ******************************************************
      !                                                                *
      timings = .true.

    case ('SCRN')
      !                                                                *
      !***** SCRN ******************************************************
      !                                                                *
      read(LuSpool,*) NSCREEN

    case ('DMPK')
      !                                                                *
      !***** DMPK ******************************************************
      !                                                                *
      read(LuSpool,*) dmpk
      if (dmpk < Zero) then
        write(u6,*) 'OBS! Specified Negative DMPK value. Restore Defaults'
        dmpk = dmpk_dfl
      end if

    case ('UPDA')
      !                                                                *
      !***** UPDA ******************************************************
      !                                                                *
      Update = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Local-K with updating of the true diagonals'
      write(u6,*)
#     endif

    case ('ESTI')
      !                                                                *
      !***** ESTI ******************************************************
      !                                                                *
      Estimate = .true.
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Local-K with evaluation of the diagonals from the current vec'
      write(u6,*)
#     endif

    case ('LOCK','LK  ')
      !                                                                *
      !***** LOCK or LK ************************************************
      !                                                                *
      algo = 4
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Local-Exchange (LK) algorithm.'
      write(u6,*)
#     endif

    case ('NOLK')
      !                                                                *
      !***** NoLK ******************************************************
      !                                                                *
      algo = 3
#     ifdef _DEBUGPRINT_
      write(u6,*) 'Local-Exchange (LK) screening turned off! '
      write(u6,*)
#     endif

    case ('MEMF')
      !                                                                *
      !***** MemF ******************************************************
      !                                                                *
      read(LuSpool,*) ChFracMem

    case ('ENDC','END ','ENDO')
      !                                                                *
      !***** ENDOFchoinput  ********************************************
      !                                                                *
      exit

    case default
      !----------------------------------------------------------------*
      ! Control section                                                *
      !----------------------------------------------------------------*
      iChrct = len(KWord)
      Last = iCLast(KWord,iChrct)
      write(u6,'(1X,A,A)') KWord(1:Last),' is not a keyword!'
      write(u6,*) SECNAM,' Error in keyword.'
      call Quit_OnUserError()
  end select
end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine CHO_SCF_RDINP

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine divthelp1 (t1,dima,dimi,dp)
c
c     this routine do
c     t1(a,i) = t1(a,i)/(dp(i)-dp(a))
c
c     t1        - T1 matrix (I/O)
c     dima    - v dimension of T1 (I)
c     dimi    - o domension of T1 (I)
c     dp      - diagonal part of Fok (I)
c
c     N.B. Since for T1 i and a are of the same spin, there is no reason
c     to specify spin of dp. It must be automatically the same spin ad i and a.
c
       integer dima,dimi
       real*8 t1(1:dima,1:dimi)
       real*8 dp(*)
c
c     help variables
c
       integer a,i
       real*8 dpi,den
c
       do 100 i=1,dimi
       dpi=dp(i)
       do 101 a=1,dima
c     t1(a,i)=t1(a,i)/(dpi-dp(dimi+a))
c
       den=dpi-dp(dimi+a)
       if (abs(den).lt.1.0d-7) then
       if (abs(t1(a,i)).gt.1.0d-10) then
       t1(a,i)=t1(a,i)/den
       end if
       else
       t1(a,i)=t1(a,i)/den
       end if
c
 101    continue
 100    continue
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*
*-- This is just an interface for the state transformation. Either
*   we use usual AO-basis route, or we take the reduced MO-basis
*   route.
*
      Subroutine StateMME(MoOrNot,nAObas,nMObas,nState,nTyp,iCi,iBigT
     &                   ,iMME,iCent,ipAvRed,Cha,Dip,Qua)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "WrkSpc.fh"

      Dimension iMME(MxMltp*(MxMltp+1)*(MxMltp+2)/6),iCent(MxBas**2)
      Dimension Cha(MxStOT,MxQCen),Dip(MxStOT,3,MxQCen)
      Dimension Qua(MxStOT,6,MxQCen)
      Logical MoOrNot

      If(.not.MoOrNot) then
        Call StateMMEao(nAObas,nState,nTyp,iBigT,iMME,iCent,Cha,Dip,Qua)
      Else
        Call StateMMEmo(nAObas,nMObas,nState,nTyp,iCi,iBigT,iMME,iCent
     &                 ,ipAvRed,Cha,Dip,Qua)
      Endif

      Return
      End


*
*-- AO-basis route.
*
      Subroutine StateMMEao(nAObas,nState,nTyp,iBigT,iMME,iCent,Cha,Dip
     &                     ,Qua)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension iMME(MxMltp*(MxMltp+1)*(MxMltp+2)/6),iCent(MxBas**2)
      Dimension Cha(MxStOT,MxQCen),Dip(MxStOT,3,MxQCen)
      Dimension Qua(MxStOT,6,MxQCen)

      kaunter=0
      nSize=nAObas*(nAObas+1)/2
      Call GetMem('Transition','Allo','Real',ipAOG,nSize)
      Call GetMem('OnTheWay','Allo','Real',ipO,nTyp)
*--- Loop over state pairs.
      Do 101, iS1=1,nState
        Do 102, iS2=1,iS1
          kaunter=kaunter+1
*------Collect this piece of the TDM in AO-basis.
          Call dCopy_(nSize,Work(iBigT+nSize*(kaunter-1)),iONE
     &              ,Work(ipAOG),iONE)
          kaunta=0
*------- Loop over AO-basis pairs and transform them as well as
*        distribute their multipoles. Observe that the array iCent
*        keeps track on where a certain AO-basis pair belongs.
          Do 103, iB1=1,nAObas
            Do 104, iB2=1,iB1
              PerAake=Work(ipAOG+kaunta)
              Do 105, iTyp=1,nTyp
                Work(ipO+iTyp-1)=Work(iMME(iTyp)+kaunta)*PerAake
105           Continue
              kaunta=kaunta+1
              Cha(kaunter,iCent(kaunta))=
     &           Cha(kaunter,iCent(kaunta))+Work(ipO)
              Dip(kaunter,1,iCent(kaunta))=
     &           Dip(kaunter,1,iCent(kaunta))+Work(ipO+1)
              Dip(kaunter,2,iCent(kaunta))=
     &           Dip(kaunter,2,iCent(kaunta))+Work(ipO+2)
              Dip(kaunter,3,iCent(kaunta))=
     &           Dip(kaunter,3,iCent(kaunta))+Work(ipO+3)
              Qua(kaunter,1,iCent(kaunta))=
     &           Qua(kaunter,1,iCent(kaunta))+Work(ipO+4)
              Qua(kaunter,2,iCent(kaunta))=
     &           Qua(kaunter,2,iCent(kaunta))+Work(ipO+5)
*----------- The reason why 7 and 6 are interchanged is that
*            QMSTAT uses the ordering xx,xy,yy,xz,yz,zz while
*            Seward uses the ordering xx,xy,xz,yy,yz,zz.
              Qua(kaunter,3,iCent(kaunta))=
     &           Qua(kaunter,3,iCent(kaunta))+Work(ipO+7)
              Qua(kaunter,4,iCent(kaunta))=
     &           Qua(kaunter,4,iCent(kaunta))+Work(ipO+6)
              Qua(kaunter,5,iCent(kaunta))=
     &           Qua(kaunter,5,iCent(kaunta))+Work(ipO+8)
              Qua(kaunter,6,iCent(kaunta))=
     &           Qua(kaunter,6,iCent(kaunta))+Work(ipO+9)
104         Continue
103       Continue
102     Continue
101   Continue
      Call GetMem('OnTheWay','Free','Real',ipO,nTyp)
      Call GetMem('Transition','Free','Real',ipAOG,nSize)

      Return
      End


*
*-- MO-basis route.
*
      Subroutine StateMMEmo(nAObas,nMObas,nState,nTyp,iCi,iBigT,iMME
     &                     ,iCent,ipAvRed,Cha,Dip,Qua)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension iMME(MxMltp*(MxMltp+1)*(MxMltp+2)/6),iCent(MxBas**2)
      Dimension Cha(MxStOT,MxQCen),Dip(MxStOT,3,MxQCen)
      Dimension Qua(MxStOT,6,MxQCen)

      kaunter=0
      nSizeA=nAObas*(nAObas+1)/2
      nSizeM=nMObas*(nMObas+1)/2
      Call GetMem('Transition','Allo','Real',ipMOG,nSizeM)
      Call GetMem('SqMO','Allo','Real',ipMOG_s,nMObas**2)
      Call GetMem('TEMP','Allo','Real',iTEMP,nAObas*nMObas)
      Call GetMem('SqAO','Allo','Real',ipAOG_s,nAObas**2)
      Call GetMem('TransitionA','Allo','Real',ipAOG,nSizeA)
      Call GetMem('OnTheWay','Allo','Real',ipO,nTyp)
*
*--- Loop over state pairs.
*
      Do 101, iS1=1,nState
        Do 102, iS2=1,iS1
          kaunter=kaunter+1
*
*------- Collect the proper piece of the TDM in MO-basis.
*
          Call dCopy_(nSizeM,Work(iBigT+nSizeM*(kaunter-1)),iONE
     &              ,Work(ipMOG),iONE)
*
*------- Additional transformation step from MO to AO.
*
          Call Square(Work(ipMOG),Work(ipMOG_s),iONE,nMObas,nMObas)
          kk=0
          Do 403, i=1,nMObas
            Do 404, j=1,nMObas
              If(i.ne.j)Work(ipMOG_s+kk)=0.5d0*Work(ipMOG_s+kk)
              kk=kk+1
404         Continue
403       Continue
          Call Dgemm_('N','N',nAObas,nMObas,nMObas,ONE,Work(ipAvRed)
     &              ,nAObas,Work(ipMOG_s),nMObas,ZERO,Work(iTEMP)
     &              ,nAObas)
          Call Dgemm_('N','T',nAObas,nAObas,nMObas,ONE,Work(iTEMP)
     &              ,nAObas,Work(ipAvRed),nAObas,ZERO,Work(ipAOG_s)
     &              ,nAObas)
          kk=0
          Do 405, i=1,nAObas
            Do 406, j=1,nAObas
              If(i.ne.j)Work(ipAOG_s+kk)=2.0d0*Work(ipAOG_s+kk)
              kk=kk+1
406         Continue
405       Continue
          Call SqToTri_Q(Work(ipAOG_s),Work(ipAOG),nAObas)
*
*------- Loop over AO-basis pairs.
*
          kaunta=0
          Do 103, iB1=1,nAObas
            Do 104, iB2=1,iB1
              PerAake=Work(ipAOG+kaunta)
              Do 105, iTyp=1,nTyp
                Work(ipO+iTyp-1)=Work(iMME(iTyp)+kaunta)*PerAake
105           Continue
              kaunta=kaunta+1
              Cha(kaunter,iCent(kaunta))=
     &           Cha(kaunter,iCent(kaunta))+Work(ipO)
              Dip(kaunter,1,iCent(kaunta))=
     &           Dip(kaunter,1,iCent(kaunta))+Work(ipO+1)
              Dip(kaunter,2,iCent(kaunta))=
     &           Dip(kaunter,2,iCent(kaunta))+Work(ipO+2)
              Dip(kaunter,3,iCent(kaunta))=
     &           Dip(kaunter,3,iCent(kaunta))+Work(ipO+3)
              Qua(kaunter,1,iCent(kaunta))=
     &           Qua(kaunter,1,iCent(kaunta))+Work(ipO+4)
              Qua(kaunter,2,iCent(kaunta))=
     &           Qua(kaunter,2,iCent(kaunta))+Work(ipO+5)
*----------- The reason why 7 and 6 are interchanged is that
*            QMSTAT uses the ordering xx,xy,yy,xz,yz,zz while
*            Seward uses the ordering xx,xy,xz,yy,yz,zz.
              Qua(kaunter,3,iCent(kaunta))=
     &           Qua(kaunter,3,iCent(kaunta))+Work(ipO+7)
              Qua(kaunter,4,iCent(kaunta))=
     &           Qua(kaunter,4,iCent(kaunta))+Work(ipO+6)
              Qua(kaunter,5,iCent(kaunta))=
     &           Qua(kaunter,5,iCent(kaunta))+Work(ipO+8)
              Qua(kaunter,6,iCent(kaunta))=
     &           Qua(kaunter,6,iCent(kaunta))+Work(ipO+9)
104         Continue
103       Continue
102     Continue
101   Continue
      Call GetMem('Transition','Free','Real',ipMOG,nSizeM)
      Call GetMem('SqMO','Free','Real',ipMOG_s,nMObas**2)
      Call GetMem('TEMP','Free','Real',iTEMP,nAObas*nMObas)
      Call GetMem('SqAO','Free','Real',ipAOG_s,nAObas**2)
      Call GetMem('TransitionA','Free','Real',ipAOG,nSizeA)
      Call GetMem('OnTheWay','Free','Real',ipO,nTyp)

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iCi)
      End


*
*-- The reduced MO-basis route. OBSOLOTE!! WORKS BUT IS SLOW!!!
*
      Subroutine StateMMEmo_NO(nAObas,nMObas,nState,nTyp,iCi,iBigT,iMME
     &                     ,iCent,ipAvRed,Cha,Dip,Qua)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "WrkSpc.fh"

      Dimension iMME(MxMltp*(MxMltp+1)*(MxMltp+2)/6),iCent(MxBas**2)
      Dimension iAcc(MxMltp*(MxMltp+1)*(MxMltp+2)/6)
      Dimension Cha(MxStOT,MxQCen),Dip(MxStOT,3,MxQCen)
      Dimension Qua(MxStOT,6,MxQCen)

      kaunter=0
      nSizeA=nAObas*(nAObas+1)/2
      nSizeM=nMObas*(nMObas+1)/2
      Call GetMem('Transition','Allo','Real',ipMOG,nSizeM)
      Do 200, i=1,nTyp
        Call GetMem('Accumulate','Allo','Real',iAcc(i),nSizeA)
200   Continue
*--- Loop over state pairs.
      Do 201, iS1=1,nState
        Do 202, iS2=1,iS1
          kaunter=kaunter+1
*------- Collect the proper piece of the TDM in MO-basis.
          Call dCopy_(nSizeM,Work(iBigT+nSizeM*(kaunter-1)),iONE
     &              ,Work(ipMOG),iONE)
*------- Loop over centres in molecule. This is now necessary since
*        MOs are contrary to AOs not localized, hence the simple
*        construction with iCent used above, can not be used here.
          Do 203, iCentre=1,iCi
            Do 2031, i=1,nTyp
              Call dCopy_(nSizeA,[ZERO],iZERO,Work(iAcc(i)),iONE)
2031        Continue
            kaunta=0
*--------- Loop over AO-basis pairs.
            Do 204, iB1=1,nAObas
              Do 205, iB2=1,iB1
                kaunta=kaunta+1
*------------- If this basis pair belongs to the given centre,
*              accumulate all multipoles.
                If(iCent(kaunta).eq.iCentre) then
                  Do 2051, i=1,nTyp
                    Work(iAcc(i)+kaunta-1)=Work(iAcc(i)+kaunta-1)
     &                                    +Work(iMME(i)+kaunta-1)
2051              Continue
                Endif
205           Continue
204         Continue
*--------- Transform the MME on this centre to MO-basis. We hence
*          get the contribution to the density distributed on a
*          specific centre.
            Call MMEtoRMO(nAObas,nMObas,ipAvRed,iAcc)
*--------- Ordinary evaluations of expectation values.
            Cha(kaunter,iCentre)=Ddot_(nSizeM,Work(iAcc(1)),iONE
     &                                  ,Work(ipMOG),iONE)
            Dip(kaunter,1,iCentre)=Ddot_(nSizeM,Work(iAcc(2)),iONE
     &                                  ,Work(ipMOG),iONE)
            Dip(kaunter,2,iCentre)=Ddot_(nSizeM,Work(iAcc(3)),iONE
     &                                  ,Work(ipMOG),iONE)
            Dip(kaunter,3,iCentre)=Ddot_(nSizeM,Work(iAcc(4)),iONE
     &                                  ,Work(ipMOG),iONE)
            Qua(kaunter,1,iCentre)=Ddot_(nSizeM,Work(iAcc(5)),iONE
     &                                  ,Work(ipMOG),iONE)
            Qua(kaunter,2,iCentre)=Ddot_(nSizeM,Work(iAcc(6)),iONE
     &                                  ,Work(ipMOG),iONE)
            Qua(kaunter,3,iCentre)=Ddot_(nSizeM,Work(iAcc(8)),iONE
     &                                  ,Work(ipMOG),iONE)
            Qua(kaunter,4,iCentre)=Ddot_(nSizeM,Work(iAcc(7)),iONE
     &                                  ,Work(ipMOG),iONE)
            Qua(kaunter,5,iCentre)=Ddot_(nSizeM,Work(iAcc(9)),iONE
     &                                  ,Work(ipMOG),iONE)
            Qua(kaunter,6,iCentre)=Ddot_(nSizeM,Work(iAcc(10)),iONE
     &                                  ,Work(ipMOG),iONE)
203       Continue
202     Continue
201   Continue
      Call GetMem('Transition','Free','Real',ipMOG,nSizeM)
      Do 206, i=1,nTyp
        Call GetMem('Accumulate','Free','Real',iAcc(i),nSizeA)
206   Continue

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Find_Dipole_Center(q_A,q_B,Dipole_A,Dipole_B,qn_A,qn_B,R_A,R_B,t,iPlot)

use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: q_A, q_B, Dipole_A, Dipole_B, qn_A, qn_B, R_A, R_B
real(kind=wp), intent(out) :: t
integer(kind=iwp), intent(in) :: iPlot
integer(kind=iwp) :: i
real(kind=wp) :: ax, bx, cx, Delta, E, fa, fb, fc, golden, R, r_best, r_best2, R_Test
integer(kind=iwp) :: nSteps = 100
real(kind=wp), parameter :: E_Threshold = 1.0e-12_wp, R_Threshold = 1.0e-12_wp
logical(kind=iwp), parameter :: Absolute = .false.
real(kind=wp), external :: Golden2, Multipole_Expansion

R = R_B-R_A

Delta = R/real(nSteps+1,kind=wp)
R_Test = R_A+Delta
if (iPlot == 1) then
  write(u6,*) 'Electronic contributions: q_A, q_B = ',q_a,q_b
  do i=1,nSteps
    R_Test = R_A+Delta*real(i,kind=wp)
    E = Multipole_Expansion(q_A,q_B,Dipole_A,Dipole_B,R_A,R_B,R_Test,Absolute)
    write(u6,'(1X,A,F6.3,1X,F20.12)') 'R, E = ',R_test,E
    call xFlush(u6)
  end do
  write(u6,*) 'Nuclear contributions: q_A, q_B = ',qn_A,qn_B
  do i=1,nSteps
    R_Test = R_A+Delta*real(i,kind=wp)
    E = Multipole_Expansion(qn_A,qn_B,Zero,Zero,R_A,R_B,R_Test,Absolute)
    write(u6,'(1X,A,F6.3,1X,F20.12)') 'R, E = ',R_test,E
    call xFlush(u6)
  end do
  write(u6,*) 'Total contributions: q_A, q_B = ',q_a+qn_a,q_b+qn_b
  do i=1,nSteps
    R_Test = R_A+Delta*real(i,kind=wp)
    E = Multipole_Expansion(q_A+qn_A,q_B+qn_B,Dipole_A,Dipole_B,R_A,R_B,R_Test,Absolute)
    write(u6,'(1X,A,F6.3,1X,F20.12)') 'R, E = ',R_test,E
    call xFlush(u6)
  end do
end if

ax = (R_A+R_B)*Half+Delta
bx = (R_A+R_B)*Half-Delta
! First make an initial bracketing of the minima
call mnBrak2(ax,bx,cx,fa,fb,fc,multipole_expansion,q_a,q_b,dipole_a,dipole_b,r_a,r_b)
! Use Golden to find the minima
golden = golden2(ax,bx,cx,multipole_expansion,r_threshold,e_threshold,r_best,q_a,q_b,dipole_a,dipole_b,r_a,r_b)
t = (r_best-half*R)/R
write(u6,'(A,3F18.10)') 't_el , r_best, golden = ',t,r_best,golden
call xflush(u6)

ax = (R_A+R_B)*Half+Delta
bx = (R_A+R_B)*Half-Delta
!ax = -0.245_wp
!bx = -0.263_wp
! First make an initial bracketing of the minima
call mnBrak2(ax,bx,cx,fa,fb,fc,multipole_expansion,qn_a,qn_b,zero,zero,r_a,r_b)
! Use Golden to find the minima
golden = golden2(ax,bx,cx,multipole_expansion,r_threshold,e_threshold,r_best2,qn_a,qn_b,zero,zero,r_a,r_b)
t = (r_best2-half*R)/R
write(u6,'(A,3F18.10)') 't_nuc, r_best, golden = ',t,r_best2,golden
call xflush(u6)
r_best = (abs(q_a+q_b)*R_best+abs(qn_a+qn_b)*R_best2)/(abs(q_a+q_b)+abs(qn_a+qn_b))
t = (r_best-half*R)/R
write(u6,'(A,3F18.10)') 't_fit, r_best, golden = ',t,r_best,golden
call xflush(u6)

!?? ax = (R_A+R_B)*Half + Delta
!?? bx = (R_A+R_B)*Half - Delta
!?? !ax = -0.245_wp
!?? !bx = -0.263_wp
!?? ! First make an initial bracketing of the minima
!?? call mnBrak2(ax,bx,cx,fa,fb,fc,multipole_expansion,q_a+qn_a,q_b+qn_b,dipole_a,dipole_b,r_a,r_b)
!?? ! Use Golden to find the minima
!?? golden = golden2(ax,bx,cx,multipole_expansion,r_threshold,e_threshold,r_best,q_a+qn_a,q_b+qn_b,dipole_a,dipole_b,r_a,r_b)
!?? t = (r_best-half*R)/R
!?? write(u6,'(A,3F18.10)') 't_sum, r_best, golden = ',t, r_best, golden
!?? call xflush(u6)

return

end subroutine Find_Dipole_Center

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine pa_sort (a, n)
      Implicit None
      Integer n, a(n), temp, k, l
      Do k = 1, n - 1
        Do l = k+1, n
         If (a(k).gt.a(l)) Then
         temp = a(k)
         a(k) = a(l)
         a(l) = temp
         End If
        End Do
      End Do
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine UrobL1(L1,NaGrp,LunAux)
! vyraba fily so simulovanymi L1 vektormi
! so spravnou strukturou

use chcc_global, only: DimGrpv, L1Name, nc, no
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: L1(*)
integer(kind=iwp), intent(in) :: NaGrp, LunAux
integer(kind=iwp) :: aGrp, len_
real(kind=wp) :: schem

!1 cycle over a,be Groups

do aGrp=1,NaGrp

  !1.1 def length
  len_ = nc*DimGrpv(aGrp)*no

  !1.2 full L1 with random numbers
  schem = 1.0e-2_wp
  call RNFill(len_,L1,schem)

  !1.3 open proper file
  !open(unit=LunAux,file=L1Name(aGrp),form='unformatted')
  call MOLCAS_BinaryOpen_Vanilla(LunAux,L1Name(aGrp))

  !1.4 write L1 into proper file
  write(u6,*) aGrp,len_
  call wri_chcc(LunAux,len_,L1)

  close(LunAux)

end do

return

end subroutine UrobL1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine evb2cas2_cvb(orbs,cvb,ioptc,iter,fx,
     >   dxnrm,dx_amx,
     >   civec,civb,civbh,res,resh,
     >   cvbdet,gjorb)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "formats_cvb.fh"
#include "tols_cvb.fh"
      logical dx_ok,grad_ok
      dimension orbs(norb,norb),cvb(nvb)
      dimension civec(ndet),civb(ndet),civbh(ndet)
      dimension cvbdet(ndetvb)
      dimension gjorb(*),res(*),resh(*)
      dimension h(2,2),eig(2)
      dimension orbinv(norb,norb)

      if(ip(3).ge.0)then
        write(6,'(/,a)')' Starting VB2CAS optimization.'
        write(6,'(a)')' -----------------------------'
      endif

      dx_ok=(dx_amx.lt.dx(1,3).and.dxnrm.lt.dx(2,3))

      if(.not.projcas)then
        call str2vbc_cvb(cvb,cvbdet)
        call vb2cic_cvb(cvbdet,civb)
      elseif(projcas)then
        if(memplenty)then
          call cicopy_cvb(civec,civbh)
        else
          call cird_cvb(civbh,61001.2d0)
        endif
        call fmove_cvb(orbs,orbinv,norb*norb)
        call mxinv_cvb(orbinv,norb)
        call gaussj_cvb(orbinv,gjorb)
        call applyt_cvb(civbh,gjorb)
        call pvbcopy_cvb(civbh,civb)
        call ci2vbc_cvb(civbh,cvbdet)
      endif

      call gaussj_cvb(orbs,gjorb)
      call applyt_cvb(civb,gjorb)
      call proj_cvb(civb)

      call cinorm_cvb(civb,cnrm)
      call ciscale_cvb(civb,one/sqrt(cnrm))

      call cicopy_cvb(civb,civbh)
      call applyh_cvb(civbh)

      call cidot_cvb(civb,civbh,evb)
      if(ip(3).ge.2)write(6,formAF)
     >  ' Residual calculation based on Evb :',evb+corenrg
c RES()=CIVBH()-EVB*CIVB()
      call cicopy_cvb(civbh,res)
      call cidaxpy_cvb(-evb,civb,res)

      if(tstfile_cvb(67123.2d0))then
        call cird_cvb(resh,67123.2d0)
        call cidot_cvb(res,resh,rescas_ovr)
c        call cidot_cvb(civb,resh,civb_ovr)
c        dxnrm_ci=sqrt(2d0*(one-civb_ovr))
c        write(6,*)' dxnrm dxnrm_ci :',dxnrm,dxnrm_ci
c        write(6,*)' gradient in VB basis :',2d0*rescas_ovr/dxnrm
        grad_ok=(2d0*rescas_ovr/dxnrm.lt.grd(1,3))
      else
        grad_ok=.false.
      endif
      call ciwr_cvb(civb,67123.2d0)

      call cinorm_cvb(res,resnrm)
      if(ip(3).ge.2)then
        write(6,'(a)')' '
        write(6,formAD)' Residual norm:',resnrm
        write(6,'(a)')' '
      endif
      call ciscale_cvb(res,one/sqrt(resnrm))
      call cidot_cvb(res,civb,ovr)
c RES()=RES()-OVR*CIVB()
      call cidaxpy_cvb(-ovr,civb,res)
      call cinorm_cvb(res,resnrm)
      call ciscale_cvb(res,one/sqrt(resnrm))
      call cidot_cvb(civbh,civb,h(1,1))
      call cidot_cvb(civbh,res,h(1,2))

      call cicopy_cvb(res,resh)
      call applyh_cvb(resh)

      call cidot_cvb(resh,civb,h(2,1))
      call cidot_cvb(resh,res,h(2,2))

      if(ip(3).ge.2)then
        write(6,*)' 2x2 Hamiltonian matrix :'
        eig(1)=h(1,1)
        eig(2)=h(2,2)
        h(1,1)=h(1,1)+corenrg
        h(2,2)=h(2,2)+corenrg
        call mxprintd_cvb(h,2,2,0)
        h(1,1)=eig(1)
        h(2,2)=eig(2)
      endif

      call mxdiag_cvb(h,eig,2)
      if(ip(3).ge.2)then
        write(6,*)' Eigenvalues :',eig(1)+corenrg,eig(2)+corenrg
        write(6,*)' Eigenvectors :'
        call mxprint_cvb(h,2,2,0)
      endif

      if(abs(h(1,1)).gt.abs(h(1,2)))then
        if(ip(3).ge.2)write(6,*)' Using root 1 :'
        call ciscale_cvb(civb,h(1,1))
        call cidaxpy_cvb(h(2,1),res,civb)
      else
        if(ip(3).ge.2)write(6,*)' Using root 2 :'
        call ciscale_cvb(civb,h(1,2))
        call cidaxpy_cvb(h(2,2),res,civb)
      endif
      call cinorm_cvb(civb,cnrm)
      call ciscale_cvb(civb,one/sqrt(cnrm))
      if(memplenty)then
c        call cidot_cvb(civb,civec,ovr)
        call cicopy_cvb(civb,civec)
      else
        call cird_cvb(res,61001.2d0)
c        call cidot_cvb(civb,res,ovr)
        call ciwr_cvb(civb,61001.2d0)
      endif

      evb=evb+corenrg
      fx=evb
      ovraa=one
      iter=1
      ioptc=0
c      ovrcrit=.125d-10
c      if(abs(one-abs(ovr)).gt.ovrcrit)iter=2
      if(.not.(dx_ok.and.grad_ok))iter=2
      call setcnt_cvb(civec,1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Roland Lindh                                     *
************************************************************************
      Subroutine DiracX(mGrid,Rho,nRho,iSpin,F_xc,dF_dRho,
     &                  ndF_dRho,Coeff,T_X)
************************************************************************
*      Author:Roland Lindh, Department of Chemical Physics, University *
*             of Lund, SWEDEN. November 2000                           *
************************************************************************
C-Ajitha Modifying the kernel output structure
      use KSDFT_Info, only: F_xca, F_xcb
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
#include "ksdft.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
cGLM     &           F_xca(mGrid),F_xcb(mGrid)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
      THIRD =One/Three
      FTHIRD=Four/Three
      CVX   =(two**THIRD)*((three/Pi)**THIRD)
      Rho_min=T_X*1.0D-2
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute value of energy and integrad on the grid
*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=1
*
      If (iSpin.eq.1) Then
*                                                                      *
************************************************************************
*                                                                      *
      Do iGrid = 1, mGrid
         d_alpha =Rho(ipR,iGrid)
         DTot=Two*d_alpha
         If (DTot.lt.T_X) Go To 100
*
*------- Exchange contributions to energy
*
         functional=-Three/Two*CVX*d_alpha**FTHIRD
         F_xc(iGrid)=F_xc(iGrid)+Coeff*functional
*
*------- Exchange contributions to the AO intergrals
*
         func_d_rho_alpha=-CVX*d_alpha**THIRD
*

         dF_dRho(ipR,iGrid) = dF_dRho(ipR,iGrid)
     &                               + Coeff*func_d_rho_alpha
*
 100     Continue
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=/=1
*
      Else
*                                                                      *
************************************************************************
*                                                                      *
      Do iGrid = 1, mGrid
         d_alpha =Max(Rho_Min,Rho(ipRa,iGrid))
         d_beta  =Max(Rho_Min,Rho(ipRb,iGrid))
         DTot=d_alpha+d_beta
         If (DTot.lt.T_X) Go To 200
*------- Exchange contributions to energy
*
         functional =-Three/Four*CVX*(d_alpha**FTHIRD+d_beta**FTHIRD)
         functionala=-Three/Four*CVX*(d_alpha**FTHIRD)
         functionalb=-Three/Four*CVX*(                d_beta**FTHIRD)
         F_xc(iGrid) =F_xc(iGrid) +Coeff*functional
         F_xca(iGrid)=F_xca(iGrid)+Coeff*functionala
         F_xcb(iGrid)=F_xcb(iGrid)+Coeff*functionalb
*
*------- Exchange contributions to the AO intergrals
*
         func_d_rho_alpha=-CVX*d_alpha**THIRD
         func_d_rho_beta =-CVX*d_beta **THIRD
*
         dF_dRho(ipRa,iGrid) = dF_dRho(ipRa,iGrid)
     &                               + Coeff*func_d_rho_alpha
         dF_dRho(ipRb,iGrid) = dF_dRho(ipRb,iGrid)
     &                               + Coeff*func_d_rho_beta
*
 200     Continue
*
      End Do
*
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SETRSDIM(NDIMRS,MSYM,MRED,IRED,ILOC)
!
! Purpose: set reduced set dimension.

use Cholesky, only: MaxRed, nnBstR, nSym
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: MSYM, MRED, IRED, ILOC
integer(kind=iwp), intent(inout) :: NDIMRS(MSYM,MRED)

if (IRED <= MAXRED) NDIMRS(:,IRED) = NNBSTR(1:NSYM,ILOC)

end subroutine CHO_SETRSDIM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RTSWGH(TARR,NT,U2,WGH,NRYS)

use vRys_RW, only: HerR2, HerW2, iHerR2, iHerW2
use abdata, only: atab, btab, p0, tvalue
use Gateway_global, only: asymptotic_Rys
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Five, Twelve, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NT, NRYS
real(kind=wp), intent(in) :: TARR(NT)
real(kind=wp), intent(out) :: U2(NRYS,NT), WGH(NRYS,NT)
integer(kind=iwp) :: IDEG, iroot, IT, J, k, nx
real(kind=wp) :: a2, a3, a4, a5, a6, b1, b2, b3, b4, b5, BK, c1, c2, c3, c4, c5, c6, corr, DELTA, p, R, R1, R2, RSUM, T, tmp, x1, &
                 x2, x3, xn, Z, ZZ
real(kind=wp), allocatable :: ALPHA(:), BETA(:), BINV(:), ROOT(:,:), RYS(:), RYSD(:)
real(kind=wp), parameter :: coef1 = -One/120.0_wp, coef2 = Five/120.0_wp, coef3 = -One/Twelve, coef4 = One/Twelve, &
                            coef5 = -Five/120.0_wp, coef6 = One/120.0_wp

#ifdef _DEBUGPRINT_
iRout = 78
iPrint = nPrint(iRout)
#endif

if (NRYS > ubound(atab,1)) then
  call WarningMessage(2,' Too many requested Rys roots.')
  call AbEnd()
end if

call mma_allocate(ALPHA,[0,max(NRYS,1)],label='ALPHA')
call mma_allocate(BETA,[0,max(NRYS,1)],label='BETA')
call mma_allocate(BINV,max(NRYS,2),label='BINV')
call mma_allocate(ROOT,max(NRYS,2),max(NRYS,2),label='ROOT')
call mma_allocate(RYS,[0,max(NRYS,2)],label='RYS')
call mma_allocate(RYSD,[0,max(NRYS,1)],label='RYSD')
RYSD(0) = Zero

do IT=1,NT
  T = TARR(IT)
  ! Use asymptotic formulae if outside table.
  !MAW if (t > TVALUE(ubound(TVALUE,1)-2)) then

  ! For the FMM we use the asymptotic limit to compute the
  ! multipole-component of the integrals

  if ((t > TVALUE(ubound(TVALUE,1)-2)) .or. asymptotic_Rys) then
    tmp = One/T
    U2(:,IT) = HerR2(iHerR2(nRys):iHerR2(nRys)+nRys-1)*tmp
    WGH(:,IT) = HerW2(iHerW2(nRys):iHerW2(nRys)+nRys-1)*sqrt(tmp)
    cycle
  end if
  ! translate to tabulation function for equidist. interp.
  ! xn=interpol. variable.
  ! Ex: T=0.0--0.05 gives xn=0.0--1.0 (approx.)
  xn = Five*T+200.0_wp*T/(14.0_wp+T)
  nx = int(xn)
  p = xn-real(nx,kind=wp)
  a2 = (p+Two)
  a3 = (p+One)*a2
  a4 = (p)*a3
  a5 = (p-One)*a4
  a6 = (p-Two)*a5
  b5 = (p-Three)
  b4 = (p-Two)*b5
  b3 = (p-One)*b4
  b2 = (p)*b3
  b1 = (p+One)*b2
  c1 = coef1*b1
  c2 = coef2*a2*b2
  c3 = coef3*a3*b3
  c4 = coef4*a4*b4
  c5 = coef5*a5*b5
  c6 = coef6*a6
  ALPHA(0) = c1*ATAB(0,nx-2)+c2*ATAB(0,nx-1)+c3*ATAB(0,nx)+c4*ATAB(0,nx+1)+c5*ATAB(0,nx+2)+c6*ATAB(0,nx+3)
  ALPHA(1:NRYS) = c1*ATAB(1:NRYS,nx-2)+c2*ATAB(1:NRYS,nx-1)+c3*ATAB(1:NRYS,nx)+c4*ATAB(1:NRYS,nx+1)+c5*ATAB(1:NRYS,nx+2)+ &
                  c6*ATAB(1:NRYS,nx+3)
  BETA(1:NRYS) = c1*BTAB(1:NRYS,nx-2)+c2*BTAB(1:NRYS,nx-1)+c3*BTAB(1:NRYS,nx)+c4*BTAB(1:NRYS,nx+1)+c5*BTAB(1:NRYS,nx+2)+ &
                 c6*BTAB(1:NRYS,nx+3)
  BINV(1:NRYS) = One/BETA(1:NRYS)
  rys(0) = c1*p0(nx-2)+c2*p0(nx-1)+c3*p0(nx)+c4*p0(nx+1)+c5*p0(nx+2)+c6*p0(nx+3)
  ROOT(1,1) = ALPHA(0)
  x1 = (ALPHA(0)+ALPHA(1))*Half
  x2 = (ALPHA(0)-ALPHA(1))*Half
  x3 = sqrt(x2**2+BETA(1)**2)
  ROOT(1,2) = x1-x3
  ROOT(2,2) = x1+x3
  ! LOOP OVER DEGREE OF RYS POLY
  do IDEG=3,NRYS
    ! ESTIMATE POSITION OF U2 OF THIS DEGREE:
    ROOT(1,IDEG) = (real(IDEG,kind=wp)-Half)*ROOT(1,IDEG-1)/real(IDEG,kind=wp)
    ROOT(IDEG,IDEG) = ONE-(real(IDEG,kind=wp)-Half)*(ONE-ROOT(IDEG-1,IDEG-1))/real(IDEG,kind=wp)
    do IROOT=2,IDEG-1
      R1 = ROOT(IROOT,IDEG-1)
      R2 = ROOT(IROOT-1,IDEG-1)
      x2 = (real(IROOT,kind=wp)-Half)/real(IDEG,kind=wp)
      x1 = ONE-x2
      R = x1*R1+x2*R2
      ROOT(IROOT,IDEG) = R
    end do
    !if (IDEG == NRYS) ITER = 0
    RYSD(1) = RYS(0)*BINV(1)
    do IROOT=1,IDEG
      Z = ROOT(IROOT,IDEG)
      ! Compute the correction coefficient:
      corr = Zero
      do J=1,iroot-1
        corr = corr+one/(root(iroot,ideg)-root(j,ideg))
      end do
      do J=iroot+1,ideg
        corr = corr+one/(root(iroot,ideg)-root(j,ideg))
      end do
      ! COMPUTE RYS AND FIRST DERIVATIVE, DO NEWTON-RAPHSON:
      do
        RYS(1) = (Z-ALPHA(0))*RYSD(1)
        ZZ = (Z-ALPHA(1))
        RYSD(2) = (ZZ*RYSD(1)+RYS(1))*BINV(2)
        RYS(2) = (ZZ*RYS(1)-BETA(1)*RYS(0))*BINV(2)
        do K=2,IDEG-1
          ZZ = Z-ALPHA(K)
          BK = BETA(K)
          RYSD(K+1) = (RYS(K)+ZZ*RYSD(K)-BK*RYSD(K-1))*BINV(K+1)
          RYS(K+1) = (ZZ*RYS(K)-BK*RYS(K-1))*BINV(K+1)
        end do
        DELTA = -RYS(IDEG)/(RYSD(IDEG)-CORR*RYS(IDEG))
        Z = Z+DELTA
        !if (IDEG == NRYS) ITER = ITER+1
        if (abs(DELTA) <= 1.0e-8_wp) exit
      end do
      ROOT(IROOT,IDEG) = Z
    end do
  end do
  !if (NRYS > 2) write(u6,'(1x,a,f8.2)') ' Avg. iter/root:',(iter*one)/NRYS
  do IROOT=1,NRYS
    Z = ROOT(IROOT,NRYS)
    ! COMPUTE RYS VALUES AND ADD SQUARES TO GET WGH:
    RSUM = RYS(0)**2
    if (NRYS /= 1) then
      RYS(1) = (Z-ALPHA(0))*RYS(0)*BINV(1)
      RSUM = RSUM+RYS(1)**2
      if (NRYS /= 2) then
        ZZ = (Z-ALPHA(1))
        RYS(2) = (ZZ*RYS(1)-BETA(1)*RYS(0))*BINV(2)
        RSUM = RSUM+RYS(2)**2
        if (NRYS /= 3) then
          do K=2,NRYS-2
            ZZ = Z-ALPHA(K)
            BK = BETA(K)
            RYS(K+1) = (ZZ*RYS(K)-BK*RYS(K-1))*BINV(K+1)
            RSUM = RSUM+RYS(K+1)**2
          end do
        end if
      end if
    end if
    WGH(IROOT,IT) = ONE/RSUM
    U2(IROOT,IT) = ROOT(IROOT,NRYS)
  end do

end do

call mma_deallocate(ALPHA)
call mma_deallocate(BETA)
call mma_deallocate(BINV)
call mma_deallocate(ROOT)
call mma_deallocate(RYS)
call mma_deallocate(RYSD)

#ifdef _DEBUGPRINT_
if (iPrint >= 99) then
  call RecPrt(' Roots',' ',U2,nRys,nT)
  call RecPrt(' Weights',' ',Wgh,nRys,nT)
end if
#endif

return

end subroutine RTSWGH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine DMinvCI_td(rin,rout,rome,idsym)
      use ipPage, only: W
      use negpre
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "real.fh"
#include "Pointers.fh"
#include "incdia.fh"

      Real*8 rout(*),rin(*)
*                                    -1           -1
*                               (H -E) |0><0|(H -E)|Sigma>
*                  -1             0            0
*     |rNew>=(H - E) |Sigma> - ----------------------------
*              0                               -1
*                                      <0|(H -E) |0>
*                                           0
*
      if (nconf1.gt.1) then
         irc=ipin(ipdia)
         Do i=1,nconf1
            rout(i)=rin(i)/(W(ipdia)%Vec(i)+rome)
         End Do
*
*        To asure orthogonal response if response is in same symmetry as
*        wavefunction
*
         If (idsym.eq.1) Then
            irc=ipin(ipCI)
            r1=ddot_(nconf1,W(ipCI)%Vec,1,rout,1)

            r2=0.0d0
            irc=ipin(ipDia)
            Do i=1,nconf1
               r2=r2+W(ipCI)%Vec(i)**2/(W(ipDia)%Vec(i)+rome)
            End Do

            Do i=1,nconf1
               rout(i)=rout(i)-r1/r2*W(ipCI)%Vec(i)/
     &               (W(ipDia)%Vec(i)+rome)
            end do
         end if

      else

        rout(1:nConf1) = rin(1:nConf1)

      end if

      rout(1:nConf1) = Half * rout(1:nConf1)

      return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine chop6_cvb()

use casvb_global, only: endvar, grad1, grad2, gradx, hessorb, hesst, icase6, icnt_ci, ishstruc, ivbweights, maxdav, mxdav, &
                        mxirrep, mxiter, ncivb, ndet, ndetvb, nirrep, norb, npr, nprorb, nvb, release, sstruc, sstruc2, variat, &
                        vec1, wdx
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: iwp, u6, RtoI

implicit none
integer(kind=iwp) :: idav, ir, iremain, mem_applyh, memwrk, ncimx, need
logical(kind=iwp) :: done

if (release(6)) then
  call mma_deallocate(sstruc,safe='*')
  call mma_deallocate(sstruc2,safe='*')
  call mma_deallocate(hessorb,safe='*')
  call mma_deallocate(hesst,safe='*')
  call mma_deallocate(wdx,safe='*')
  call mma_deallocate(grad1,safe='*')
  call mma_deallocate(grad2,safe='*')
  call mma_deallocate(gradx,safe='*')
  call mma_deallocate(vec1,safe='*')
end if
release(6) = .true.
release(7) = .false.

icnt_ci(6) = 0
if (icase6 == 1) then
  !FIXME: These deallocations should not be needed
  call mma_deallocate(sstruc,safe='*')
  call mma_deallocate(sstruc2,safe='*')
  call mma_deallocate(hessorb,safe='*')
  call mma_deallocate(hesst,safe='*')
  call mma_deallocate(wdx,safe='*')
  call mma_deallocate(grad1,safe='*')
  call mma_deallocate(grad2,safe='*')
  call mma_deallocate(gradx,safe='*')
  call mma_deallocate(vec1,safe='*')
  ! Standard non-linear optimization procedure:
  call mma_allocate(sstruc,norb*norb+nvb+1+mxirrep,1,label='sstruc')
  call mma_allocate(sstruc2,npr,1,label='sstruc2')
  call mma_allocate(hessorb,nprorb,nprorb,label='hessorb')
  call mma_allocate(hesst,norb**2,norb**2,label='hesst')
  call mma_allocate(wdx,npr,label='wdx')
  call mma_allocate(grad1,npr,label='grad1')
  call mma_allocate(grad2,npr,label='grad2')
  call mma_allocate(gradx,norb,norb,label='gradx')
  call mma_allocate(vec1,max(npr,ndetvb),label='vec1')
else if (icase6 == 2) then
  ! Overlap-based Davidson optimization:
  call mma_maxDBLE(iremain)
  maxdav = min(mxiter,nvb,mxdav)

  memwrk = ndetvb+5*norb*norb+3*(norb+2*norb*norb+RtoI-1)/RtoI
  done = .false.
  do idav=maxdav,1,-1
    ! NEED is approx req. memory:
    need = 2*nvb*idav+2*nvb+idav+1000+memwrk
    if (need < iremain) then
      done = .true.
      exit
    end if
  end do
  if (.not. done) then
    idav = 0
    if (nvb == 0) then
      need = 1000+memwrk
      if (need < iremain) done = .true.
    end if
  end if
  if (.not. done) then
    write(u6,*) ' Not enough memory for Davidson!',need,iremain
    call abend_cvb()
  end if
  maxdav = idav

else if (icase6 == 3) then
  ! Energy-based Davidson optimization:
  call mma_maxDBLE(iremain)
  maxdav = min(mxiter,nvb,mxdav)

  ! neread is uninitialized
  !mem_applyh = ndet+neread
  mem_applyh = ndet
  ncimx = 0
  do ir=1,nirrep
    ncimx = max(ncimx,ncivb(ir))
  end do
  if (ncimx /= ndet) mem_applyh = mem_applyh+ncimx
  memwrk = ndetvb+3*norb*norb+2*(norb+2*norb*norb+RtoI-1)/RtoI

  done = .false.
  do idav=maxdav,1,-1
    ! NEED is approx req. memory:
    need = 3*nvb*idav+nvb+idav*(2*idav+3)+1000+mem_applyh+memwrk
    if (need < iremain) then
      done = .true.
      exit
    end if
  end do
  if (.not. done) then
    idav = 0
    if (nvb == 0) then
      need = 1000+memwrk
      if (need < iremain) done = .true.
    end if
  end if
  if (.not. done) then
    write(u6,*) ' Not enough memory for Davidson!',need,iremain
    call abend_cvb()
  end if
  maxdav = idav

else if (icase6 == 4) then
  ! Wavefunction analysis:
  if (((.not. variat) .or. endvar) .and. ((ivbweights > 1) .or. (ishstruc == 1))) then
    !FIXME: These deallocations should not be needed
    call mma_deallocate(sstruc,safe='*')
    call mma_deallocate(sstruc2,safe='*')
    call mma_allocate(sstruc,nvb,nvb,label='sstruc')
    call mma_allocate(sstruc2,nvb,nvb,label='sstruc2')
  end if
end if

return

end subroutine chop6_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine asc2ab2_cvb(detvec,nvec,nel,nalf,
     >  nbet,ndet,
     >  mindet,maxdet,nkdet,xdet,locc)
      implicit real*8 (a-h,o-w,y-z),integer(x)
      dimension detvec(ndet,nvec)
      dimension mindet(0:nel),maxdet(0:nel),nkdet(0:nel),
     >  xdet(0:nel,0:nalf)
      dimension locc(nel)

      do 100 iorb=0,nel
      mindet(iorb)=max(iorb-nbet,0)
      maxdet(iorb)=min(iorb,nalf)
100   continue
      call weight_cvb(xdet,mindet,maxdet,nalf,nel)
      call imove_cvb(maxdet,nkdet,nel+1)
      call occupy_cvb(nkdet,nel,locc,locc(nalf+1))
      inddet=1
200   continue
      tip=party_cvb(locc,nel)
      call dscal_(nvec,party_cvb(locc,nel),detvec(inddet,1),ndet)
      call loind_cvb(nel,nalf,nkdet,mindet,maxdet,
     >               locc,locc(nalf+1),inddet,xdet,*200)
      return
      end
c  ********************************
c  ** VB determinant information **
c  ********************************

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ALLOC_m
C
C     RASSCF: allocation of core memory
C
C     Called from inpctl
C
C     No subroutine calls
C
C     ********** IBM-3090 Release 88 10 11 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='ALLOC   ')
      IPRLEV=IPRLOC(1)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
C
C     Compute space needed for transformed two-electron integrals
C
!AMS
      ISTORD(1)=0
      ISTORP(1)=0
      IORD=0
      IORP=0
      DO NSP=1,NSYM
       NOP=NORB(NSP)
       NAP=NASH(NSP)
       DO NSQ=1,NSYM
        NAQ=NASH(NSQ)
        NSPQ=IEOR(NSP-1,NSQ-1)
        DO NSR=1,NSYM
         NSPQR=IEOR(NSPQ,NSR-1)+1
         NAR=NASH(NSR)
         DO NSS=1,NSR
          IF(NSPQR.NE.NSS) GO TO 11
          NAS=NASH(NSS)
          NRS=NAR*NAS
          IF(NSS.EQ.NSR) NRS=(NAR+NAR**2)/2
          IORD=IORD+NOP*NAQ*NRS
          IORP=IORP+NAP*NAQ*NRS
11       CONTINUE
         END DO
        END DO
       END DO
       ISTORD(NSP+1)=IORD
       ISTORP(NSP+1)=IORP
      END DO
      NFINT=ISTORD(NSYM+1)
C
      IF(IPRLEV.GE.DEBUG) THEN
       Write(LF,'(1X,A,5X,9I5)')'ISTORD-vector:',(ISTORD(I),I=1,NSYM+1)
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine CAssmbl(Rnxyz,Axyz,la,Bxyz,lb,nZeta,HerW,nHer)
!***********************************************************************
!                                                                      *
! Object: to assemble the cartesian components of the multipole moment *
!         matrix within the framework of the Gauss-Hermite quadrature. *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Constants, only: cZero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: la, lb, nZeta, nHer
complex(kind=wp), intent(out) :: Rnxyz(nZeta*3,0:la,0:lb)
complex(kind=wp), intent(in) :: Axyz(nZeta*3,nHer,0:la), Bxyz(nZeta*3,nHer,0:lb)
real(kind=wp), intent(in) :: HerW(nHer)
#include "print.fh"
integer(kind=iwp) :: ia, ib, iHer, iPrint, iRout
character(len=80) :: Label

iRout = 123
iPrint = nPrint(iRout)
if (iPrint >= 99) then
  call RecPrt(' In CAssmbl:HerW',' ',HerW,1,nHer)
  call CRecPrt(' In CAssmbl:Axyz',' ',Axyz,nZeta*3,nHer*(la+1),'R')
  call CRecPrt(' In CAssmbl:Axyz',' ',Axyz,nZeta*3,nHer*(la+1),'I')
  call CRecPrt(' In CAssmbl:Bxyz',' ',Bxyz,nZeta*3,nHer*(lb+1),'R')
  call CRecPrt(' In CAssmbl:Bxyz',' ',Bxyz,nZeta*3,nHer*(lb+1),'I')
end if

! Initialize to zero

Rnxyz(:,:,:) = cZero

do ia=0,la
  do ib=0,lb

    ! Generate the cartesian components of the multipole moment
    ! matrix as a sum of the value of the integrand, evaluated
    ! at a root, times a weight.

    do iHer=1,nHer
      Rnxyz(:,ia,ib) = Rnxyz(:,ia,ib)+Axyz(:,iHer,ia)*Bxyz(:,iHer,ib)*HerW(iHer)
    end do

    if (iPrint >= 99) then
      write(Label,'(A,I2,A,I2,A)') ' In CAssmbl: Rnxyz(',ia,',',ib,')'
      call CRecPrt(Label,' ',Rnxyz(:,ia,ib),nZeta,3,'R')
      call CRecPrt(Label,' ',Rnxyz(:,ia,ib),nZeta,3,'I')
    end if
  end do
end do

return

end subroutine CAssmbl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RdCIV()
!***********************************************************************
!                                                                      *
!     Read the contents of the JOBIPH file.                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use gugx, only: CIS, EXS, SGS
use MCLR_Data, only: ERAS, LuCIV, LuJob
use input_mclr, only: iSpin, iTOC, lRoots, nActEl, nConf, nCSF, nElec3, nHole1, nRS1, nRS2, nRS3, nSym, State_Sym
use Molcas, only: MxRoot
use RASDim, only: MxIter
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: i, iDisk, iDisk1, Iter
real(kind=wp), allocatable :: OCIvec(:), Tmp(:,:)

call DaName(LuCIV,'ROOTS')
iDisk = 0
!----------------------------------------------------------------------*
!     Load the CI vector for all roots                                 *
!----------------------------------------------------------------------*

call mma_Allocate(OCIvec,nConf,Label='OCIvec')

iDisk = iToc(4)
idisk1 = 0
do i=1,lroots
  call dDaFile(LuJob,2,OCIvec,nConf,iDisk)
  call GugaNew(nSym,iSpin,nActEl,nHole1,nElec3,nRs1,nRs2,nRs3,SGS,CIS,EXS,OCIvec,1,State_Sym,State_Sym)
  NCSF(1:nSym) = CIS%NCSF(1:nSym)
  NCONF = CIS%NCSF(State_Sym)
  call mkGuga_Free(SGS,CIS,EXS)

  call dDafile(LuCIV,1,OCIvec,nconf,iDisk1)
end do

call mma_deAllocate(OCIvec)
!----------------------------------------------------------------------*
!     Load state energy                                                *
!----------------------------------------------------------------------*

call mma_allocate(Tmp,mxRoot,mxIter,Label='Tmp')
iDisk = iToc(6)
call dDaFile(LuJob,2,Tmp,mxRoot*mxIter,iDisk)
ERAS(1:lroots) = Zero
do i=1,lroots
  do iter=mxIter,1,-1
    if (Tmp(i,iter) /= Zero) then
      ERAS(i) = Tmp(i,iter)
      exit
    end if
  end do
end do
call mma_deallocate(Tmp)
!----------------------------------------------------------------------*
!     exit                                                             *
!----------------------------------------------------------------------*

end subroutine RdCIV

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SOAO_g(iSD4,nSD,nSO, MemPrm, MemMax,
     &                  iBsInc,jBsInc,kBsInc,lBsInc,
     &                  iPrInc,jPrInc,kPrInc,lPrInc,
     &                  ipMem1,ipMem2, Mem1,  Mem2,
     &                  iPrint,iFnc, MemPSO)
      use Basis_Info, only: Shells
      Implicit Real*8 (a-h,o-z)
*
      Integer iSD4(0:nSD,4), iAnga(4), iCmpa(4),
     &        iFnc(4), iAO(4)
*
      iPrimi   = Shells(iSD4( 0,1))%nExp
      jPrimj   = Shells(iSD4( 0,2))%nExp
      kPrimk   = Shells(iSD4( 0,3))%nExp
      lPriml   = Shells(iSD4( 0,4))%nExp
      iBasi    = Shells(iSD4( 0,1))%nBasis
      jBasj    = Shells(iSD4( 0,2))%nBasis
      kBask    = Shells(iSD4( 0,3))%nBasis
      lBasl    = Shells(iSD4( 0,4))%nBasis
      Do iQuad = 1, 4
         iAnga(iQuad)  = iSD4( 1,iQuad)
         iCmpa(iQuad)  = iSD4( 2,iQuad)
         iAO(iQuad)    = iSD4( 7,iQuad)
      End Do
*
                  Call PSOAO1(nSO,MemPrm, MemMax,
     &                        iAnga, iCmpa, iAO  ,iFnc,
     &                        iBasi,iBsInc, jBasj,jBsInc,
     &                        kBask,kBsInc, lBasl,lBsInc,
     &                        iPrimi,iPrInc,jPrimj,jPrInc,
     &                        kPrimk,kPrInc,lPriml,lPrInc,
     &                        ipMem1,ipMem2, Mem1,  Mem2, MemPSO)
#ifdef _DEBUGPRINT_
         Write (6,*) ' ************** Memory partioning **************'
         Write (6,*) ' ipMem1=',ipMem1
         Write (6,*) ' Mem1=',Mem1
         Write (6,*) ' Mem2=',Mem2
         Write (6,*) ' Mem3=',Mem3
         Write (6,*) ' MemPSO=',MemPSO
         Write (6,*) ' MemScr=',MemScr
         Write (6,*) ' Mend=',Mend

         Write (6,*) ' iBasi,iBsInc=',iBasi,iBsInc
         Write (6,*) ' jBasj,jBsInc=',jBasj,jBsInc
         Write (6,*) ' kBasi,kBsInc=',kBask,kBsInc
         Write (6,*) ' lBasl,lBsInc=',lBasl,lBsInc
         Write (6,*) ' iPrimi,iPrInc=',iPrimi,iPrInc
         Write (6,*) ' jPrimj,jPrInc=',jPrimj,jPrInc
         Write (6,*) ' kPrimk,kPrInc=',kPrimk,kPrInc
         Write (6,*) ' lPriml,lPrInc=',lPriml,lPrInc
         Write (6,*) ' ***********************************************'
#endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(iPrint)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Print_T_Values(T_Values,iT_Sets,iANr,EC,Bond_Threshold,nAtoms,nij,Standard,iWarnings,Num_Warnings,iPrint)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nij, iT_Sets(nij), nAtoms, iANr(nAtoms), iWarnings(nij), Num_Warnings, iPrint
real(kind=wp), intent(in) :: T_Values(nij), EC(3,nij), Bond_Threshold
logical(kind=iwp), intent(in) :: Standard
#include "Molcas.fh"
integer(kind=iwp) :: i, iAtom, ii, ij, j, jAtom, jj, Last_NonBlank
real(kind=wp) :: Bond_Length, Bond_Max, bs_t, Factor, Radius_i, Radius_j
integer(kind=iwp), parameter :: iLength = 25
character(len=iLength) :: Warning
character(len=17) :: BondLbl
character(len=LenIn), allocatable :: AtomLbl(:)
character(len=LenIn4), allocatable :: AtomLbl4(:)
real(kind=wp), external :: Bragg_Slater

! Print header

call mma_allocate(AtomLbl,nAtoms,label='AtomLbl')
call mma_allocate(AtomLbl4,nAtoms,label='AtomLbl4')

call Get_cArray('LP_L',AtomLbl4,LenIn4*nAtoms)
do i=1,nAtoms
  AtomLbl(i) = AtomLbl4(i)(1:LenIn)
end do
call mma_deallocate(AtomLbl4)
ij = 0
write(u6,*)
if (Num_Warnings > 0) then
  write(u6,'(A,I3,A)') 'During optimization of the expansion centers ',Num_Warnings,' warnings were encountered.'
  write(u6,*)
  write(u6,'(A)') ' iAtom   jAtom   Atom(s)          Factor   Bragg-Slater      t      Warning'
else
  write(u6,'(A)') ' iAtom   jAtom   Atom(s)          Factor   Bragg-Slater      t'
end if

! Print informations for the atoms

do iAtom=1,nAtoms
  ii = iAtom*(iAtom+1)/2
  if ((iT_sets(ii) == 1) .or. (iPrint >= 2)) then
    write(BondLbl,'(A)') AtomLbl(iAtom)
    Last_NonBlank = 0
    j = 0
    do i=1,17
      if (BondLbl(i:i) /= ' ') then
        j = j+1
        BondLbl(j:j) = BondLbl(i:i)
        Last_NonBlank = j
      end if
    end do
    do i=Last_NonBlank+1,17
      BondLbl(i:i) = ' '
    end do

    if (Num_Warnings > 0) then
      call Warnings_lp(iWarnings(ii),Warning,iLength)
      if (iT_sets(ii) == 1) then
        write(u6,'(1X,I3,5X,8X,A17,24X,F7.4,3X,A)') iAtom,BondLbl,T_Values(ij),Warning
      else if (Standard) then
        write(u6,'(1X,I3,5X,8X,A17,24X,A,3X,A)') iAtom,BondLbl,'Standard',Warning
      else
        write(u6,'(1X,I3,5X,8X,A17,24X,A,3X,A)') iAtom,BondLbl,'Skipped',Warning
      end if
    else
      if (iT_sets(ii) == 1) then
        write(u6,'(1X,I3,5X,8X,A17,24X,F7.4)') iAtom,BondLbl,T_Values(ij)
      else if (Standard) then
        write(u6,'(1X,I3,5X,8X,A17,24X,A)') iAtom,BondLbl,'Standard'
      else
        write(u6,'(1X,I3,5X,8X,A17,24X,A)') iAtom,BondLbl,'Skipped'
      end if
    end if
  end if
end do

write(u6,'(79A)') ('-',i=1,79)

! Print informations for the bonds

do iAtom=1,nAtoms
  ii = iAtom*(iAtom+1)/2
  do jAtom=1,iAtom-1
    ij = iAtom*(iAtom-1)/2+jAtom
    if ((iT_sets(ij) == 1) .or. (iPrint >= 2)) then
      jj = jAtom*(jAtom+1)/2
      Factor = Zero
      write(BondLbl,'(3A)') AtomLbl(iAtom),'-',AtomLbl(jAtom)
      Radius_i = Bragg_Slater(iANr(iAtom))
      Radius_j = Bragg_Slater(iANr(jAtom))
      Bond_Length = sqrt((EC(1,ii)-EC(1,jj))**2+(EC(2,ii)-EC(2,jj))**2+(EC(3,ii)-EC(3,jj))**2)
      Bond_Max = Bond_Threshold*(Radius_i+Radius_j)
      Factor = Bond_Length/Bond_Max
      bs_t = Radius_i/(Radius_i+Radius_j)-Half

      Last_NonBlank = 0
      j = 0
      do i=1,17
        if (BondLbl(i:i) /= ' ') then
          j = j+1
          BondLbl(j:j) = BondLbl(i:i)
          Last_NonBlank = j
        end if
      end do
      do i=Last_NonBlank+1,17
        BondLbl(i:i) = ' '
      end do

      if (Num_Warnings > 0) then
        call Warnings_lp(iWarnings(ij),Warning,iLength)
        if (iT_sets(ij) == 1) then
          write(u6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,F7.4,3X,A)') iAtom,jAtom,BondLbl,Factor,BS_t,T_Values(ij),Warning
        else if (Standard) then
          write(u6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,A,3X,A)') iAtom,jAtom,BondLbl,Factor,BS_t,'Standard',Warning
        else
          write(u6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,A,3X,A)') iAtom,jAtom,BondLbl,Factor,BS_t,'Skipped',Warning
        end if
      else
        if (iT_sets(ij) == 1) then
          write(u6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,F7.4)') iAtom,jAtom,BondLbl,Factor,BS_t,T_Values(ij)
        else if (Standard) then
          write(u6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,A)') iAtom,jAtom,BondLbl,Factor,BS_t,'Standard'
        else
          write(u6,'(1X,I3,5X,I3,5X,A17,F6.3,5X,F7.4,6X,A)') iAtom,jAtom,BondLbl,Factor,BS_t,'Skipped'
        end if
      end if
    end if
  end do
end do

call mma_deallocate(AtomLbl)

return

end subroutine Print_T_Values

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ireorg(wrk,wrksize,symp,symq,symr,syms,typp,typq,typr,typs,pospv1,posqv1,posrv1,possv1,typpv1,typqv1,typrv1,typsv1, &
                  typv2,posv10,posv20,fact)
! this routine is up level routine for ireorg1 (also more detailed
! description can be found there).
! v1 must be of type 0, v2 can be 0,1,3 and 4
! this routine only prepares some constants, required by ireorg1,
! that can be deduced form input data - dimpq,dimrs,dimt-dimx
!
! symp-s     - symmetries of p-s (I)
! typp-s     - types of indices p-s in V2 (I)
! posp-sv1   - positions of p-s ind. in v1 (I)
! typp-sv1   - types of indices, corresponding to p-s in V1 (I)
! typv2      - type of V2 (0,1,2,4) (I)
! posv10,20  - initial positions of V1 and V2 in wrk (I)
! fact       - multiplication factors (usually +-1.0) (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, symp, symq, symr, syms, typp, typq, typr, typs, pospv1, posqv1, posrv1, possv1, typpv1, &
                                 typqv1, typrv1, typsv1, typv2, posv10, posv20
real(kind=wp), intent(inout) :: wrk(wrksize)
real(kind=wp), intent(in) :: fact
integer(kind=iwp) :: dimpq, dimrs, ind(4), mhelp = -1, nhelp = -1, rc

! define dimensions of V1

call ireorg2(symp,typpv1,nhelp,rc)
ind(pospv1) = nhelp
call ireorg2(symq,typqv1,nhelp,rc)
ind(posqv1) = nhelp
call ireorg2(symr,typrv1,nhelp,rc)
ind(posrv1) = nhelp
call ireorg2(syms,typsv1,nhelp,rc)
ind(possv1) = nhelp

! def dimpq,dimrs

call ireorg2(symp,typp,nhelp,rc)
call ireorg2(symq,typq,mhelp,rc)

if (((typv2 == 1) .or. (typv2 == 4)) .and. (symp == symq)) then
  dimpq = (nhelp*(nhelp-1))/2
else
  dimpq = nhelp*mhelp
end if

call ireorg2(symr,typr,nhelp,rc)
call ireorg2(syms,typs,mhelp,rc)

if (((typv2 == 3) .or. (typv2 == 4)) .and. (symr == syms)) then
  dimrs = (nhelp*(nhelp-1))/2
else
  dimrs = nhelp*mhelp
end if

! use ireorg1

call ireorg1(symp,symq,symr,syms,typp,typq,typr,typs,pospv1,posqv1,posrv1,possv1,typpv1,typqv1,typrv1,typsv1,typv2,wrk(posv10), &
             wrk(posv20),fact,dimpq,dimrs,ind(1),ind(2),ind(3),ind(4))

return

end subroutine ireorg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine test_caspt2_setup(ntimes)
      Implicit Real*8 (a-h,o-z)
      Integer nSm,nIs(8),nAs(8),nSs(8)
      Integer NumC(8)
      External random_molcas

* Just getting test runs of the cho_caspt2_setup routine:
      write(6,*)
      write(6,*)' Exercise runs of cho_caspt2_setup with random inputs:'
      write(6,*)' Number of runs:',ntimes
      iseed=24691357
      do itimes=1,ntimes
       write(6,*)
       write(6,*)
       write(6,*)' Exercise run nr',iTimes
       nSm=2**(nint(4.0d0*random_molcas(iseed)-0.5d0))
       do iSm=1,nSm
        nIs(iSm)=nint(8.0d0*random_molcas(iseed)-0.5d0)
        x=16.0D0/nSm
        nAs(iSm)=nint(x*random_molcas(iseed)-0.5d0)
        nSs(iSm)=nint(15.0d0*random_molcas(iseed)-0.5d0)
        NumC(iSm)=nint(15.0d0*random_molcas(iseed)-0.5d0)
       end do
       call cho_caspt2_setup(nSm,nIs,nAs,nSs,NumC,'Allo')
       call cho_caspt2_setup(nSm,nIs,nAs,nSs,NumC,'Free')
      end do
      write(6,*)
      write(6,*)' End of exercises for today.'
      write(6,*)
      return
      end

      Subroutine cho_caspt2_setup(nSym,nIsh,nAsh,nSsh,NumCho,mode)
* -------------------------
* This subroutine uses the input variables to compute
* ipsp,nisplit, nasplit,lsplit,ipnp,ipip each dimensioned (1:nsym),
* in common /chocaspt2/,
* and allocates fields at iwork() addresses ipsp(1:nsym),ipnp(1:nsym),
* ipunit_f(1:nsym), each with sizes lsplit(1:nsym), and
* ipip(1:nsym), each with sizes nsym*lsplit(1:nsym)
* -------------------------
      Implicit Real*8 (a-h,o-z)
      Integer nSym,nIsh(8),nAsh(8),nSsh(8)
      Integer NumCho(8)
      Integer iAorb(8),iIorb(8),iKorb(8)
      Character*(*) mode
      Character*4   modecopy

#include "WrkSpc.fh"
#include "chocaspt2.fh"
      Integer  cho_irange
      External cho_irange

C *********************************************************************
      nIc(i,j) = iWork(ipSp(j)+i-1)
******
      nAc(i,j) = iWork(ipSp(j)+nIsplit(j)+i-1)
******
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
C *********************************************************************

      modecopy=mode(1:4)
      Call UpCase(modecopy)
      if (modecopy.eq.'FREE') then
         Do jSym=1,nSym
        If (NumCho(jSym).gt.0) then
            Call GetMem('Unit_F','Free','Inte',ipUnit_F(jSym),
     &                                         Lsplit(jSym))
            Call GetMem('iPorb','Free','Inte',ipiP(jSym),
     &                                        nSym*Lsplit(jSym))
            Call GetMem('nPorb','Free','Inte',ipnP(jSym),Lsplit(jSym))
            Call GetMem('Split','Free','Inte',ipSp(jSym),Lsplit(jSym))
        End If
         End Do
       Return
      end if

*      write(6,*)' Cho_CasPT2_SetUp entered.'
      do i=1,8
       ipunit_f(i)=0
       ipsp(i)=0
       lsplit(i)=0
       nisplit(i)=0
       nasplit(i)=0
       ipnp(i)=0
       ipip(i)=0
      end do

* Local arrays:
* iIorb(iSym) = Nr of inactive orbitals in earlier symmetries.
* iAorb(iSym) = Nr of   active orbitals in earlier symmetries.
* iKorb(iSym) = iIorb(iSym) + iAorb(iSym)
         iIorb(1)=0
         iAorb(1)=0
         iKorb(1)=0
         Do iSym=2,nSym
            iIorb(iSym) = iIorb(iSym-1) + nIsh(iSym-1)
            iAorb(iSym) = iAorb(iSym-1) + nAsh(iSym-1)
            iKorb(iSym) = iIorb(iSym) + iAorb(iSym)
         End Do

* nIO   = total number of inactive orbitals.
* nAO   = total number of active orbitals.
* nOkrb = total number of inactive+active orbitals.
* nOrb  = total number of orbitals
         nOkrb=0
         nIO=0
         nAO=0
         nO=0
         Do iSym=1,nSym
            nOkrb = nOkrb + nIsh(iSym) + nAsh(iSym)
            nOrb = nIsh(iSym) + nAsh(iSym) + nSsh(iSym)
            nO = nO + nOrb*(nOrb+1)/2
            nIO = nIO + nIsh(iSym)
            nAO = nAO + nAsh(iSym)
         End Do

         xO = dble(nO)

* Task: set up the necessary administration of transformed Cholesky
* vectors. Each such vector is characterized by the composite symmetry
* label JSYM. Vectors with common JSYM are stored on the same unit.
* For a given JSYM, there are NumCho(jSym) vectors. These are separated
* into subsets -- batches -- There will be nISplit(jSym) batches with
* vectors with a fixed inactive orbital index (Inactive vectors), and
* nASplit(jSym) batches with vectors with a fixed active index
* (Active vectors). Each batch has vectors with fixed index within a
* range of size iWork(ipsp(jSym)+i-1) where i is in 1..nISplit(jSym) or
*  in nISplit(jSym)+1..nISplit(jSym)+nASplit(jSym).
* The vectors themselves have a size of iWork(ipnp(jSym)+i-1)
* The vectors are generally referred to as e.g. p#k, where #k stands
* for the fixed inactive or active orbital, while p is all the orbitals
* with a symmetry such that the compound symmetry label is JSYM.
* There will be a (possibly large) number of such vectors, each indexed
* with 'J' gennerally. This is the summation index in the definition of
* the cholesky vectors.
         Do jSym=1,nSym
*      write(6,*)' NumCho(jSym)=',NumCho(jSym)
            If (NumCho(jSym).lt.1) goto 99


         Call GetMem('MaxMem','Max','Real',Kdummy,MemMx)
            xMemMx = dble(MemMx)
* xMemMx = largest allocatable field.

  5      Continue
         jfrac=1

 10         Continue
         Mem1 = 2*NumCho(jSym)/jfrac  ! hold 2 vectors in memory
            If (Mem1.eq.0 .and. jfrac.gt.1) then
            Call Cho_x_Quit('cho_caspt2_setup',
     &                          ': Sorry! Too little memory!!',' ')
            EndIf

         kfrac=0
* Go here to try using larger kfrac.
 20      Continue
         kfrac=kfrac+1
* Subdivide the set of orbitals into kfrac pieces of size .le. nKsp
         nKsp = nOkrb/kfrac
* If kfrac has grown too large, start again using kfrac=1 but larger jfrac
            If (nKsp .eq. 0) Then
                jfrac = jfrac + 1
                goto 10

            EndIf

* Loop over pieces of the orbital set:
         nPmax=0
         Do iK1=1,nOkrb,nKsp
          iK2=max(iK1-1+nKsp,nOkrb)
* For this piece, compute the number of (p,k) orbital pairs
* with p active or secondary, and with joint symmetry jSym:
          nP=0
          Do iK=iK1,iK2
             kS = cho_irange(iK,iKorb,nSym,.false.)
             jS = MulD2h(kS,jSym)
             nP = nP + nAsh(jS) + nSsh(jS)
          End Do
* nPmax will be the largest number of such pairs in any piece.
          nPmax = Max(nPmax,nP)
         End Do

* PAM:The following looks strange, since the max is over the same set
* of numbers no matter what jSym is.
            mRHS=0
            Do iS=1,nSym
               jS = MulD2h(iS,jSym)
               mRHS = Max( mRHS, Max(nAsh(jS),nSsh(jS)) )
            End Do

C --- Conversion to real*8 to avoid integer overflow on 32-bit machines

* PAM:Why would this be 'mem for right-hand side?'
            xRHS = dble(mRHS**2)           ! mem. for right hand side
            xLpk = dble(Mem1*nPmax*nKsp)   ! store Cholesky MO vectors
            xPIQK= dble((nPmax*nKsp)**2)   ! store integrals
            xmNeed= xO + xPIQK + Max(xLpk,2*xRHS) ! Fmat+integrals+rhs

         If (xmNeed .gt. xMemMx) GoTo 20

* This also looks strange -- nIAc=all the inact+act orbitals no matter what.?
                nIAc = nOkrb

            jIAc = nIAc
            LSplit(jSym)=1
            Do while (jIAc .lt. nOkrb)
               LSplit(jSym) = LSplit(jSym) + 1
               jIAc = jIAc + nIAc

            End Do

* What does this mean? Simply that lsplit(jSym) will be 'the next'
* of something?
            LSplit(jSym) = LSplit(jSym) + 1 ! separate out Ina from Act

* Need xmNeedNow units of memory
            xmNeedNow = xmNeed + dble((3+nSym)*LSplit(jSym))

            If (xmNeedNow.gt.xMemMx) Then
* Does it help to start all over again??
                xMemMx = xMemMx - dble((3+nSym)*LSplit(jSym))
                goto 5

            EndIf

*         write(6,*)' Determined splitting. lsplit(jsym)=', lsplit(jsym)
* Allocate arrays, in all (3+nSym)*lsplit(jSym) elements:
            Call GetMem('Split','Allo','Inte',ipSp(jSym),Lsplit(jSym))
            Call GetMem('nPorb','Allo','Inte',ipnP(jSym),Lsplit(jSym))
            Call GetMem('iPorb','Allo','Inte',ipiP(jSym),
     &                                        nSym*Lsplit(jSym))
            Call GetMem('Unit_F','Allo','Inte',ipUnit_F(jSym),
     &                                         Lsplit(jSym))

         nmin=Min(nIO,nIAc)
            jS=0
         if(nmin.gt.0) jS=nIO/nmin
         Do i=0,jS-1
           iWork(ipsp(jSym)+i) = nmin
            End Do
         mDiff = jS*nmin - nIO
            If (mDiff .gt. 0) Then
               iWork(ipSp(jSym)+jS) = mDiff
               jS = jS + 1
            Endif
            nIsplit(jSym) = jS

         nmin=Min(nAO,nIAc)
            jS=0
         if(nmin.gt.0) jS=nAO/nmin
         Do i=0,jS-1
           iWork(ipsp(jSym)+nisplit(jSym)+i) = nmin
            End Do
         mDiff = jS*nmin - nAO
            If (mDiff .gt. 0) Then
               iWork(ipSp(jSym)+nIsplit(jSym)+jS) = mDiff
               jS = jS + 1
            Endif
            nAsplit(jSym) = jS

* Note: The inactive orbitals will be partitioned.
* The isp=1..nisplit(jSym) is counter of the partitions.
* ioff will be the number of inactive orbitals in earlier partitions.
            ioff=0
*      write(6,*)' Partitions for inactive fixed indices:'
            Do isp=1,nIsplit(jSym)
*      write(6,*)' Partition nr isp=',isp
* ioff+1 is the first orbital of partition isp.
               lS = cho_irange(ioff+1,iIorb,nSym,.false.)
*      write(6,*)' First inactive orbital:',ioff+1
*      write(6,*)'           Its symmetry:',lS
* lS is its symmetry.
               iK = nIc(isp,jSym) + ioff
* Note: nIc(isp,jSym)=iWork(ipsp(jSym)+isp-1)
* iK is the last orbital of the partition, and kS its symmetry
               kS = cho_irange(iK,iIorb,nSym,.false.)
*      write(6,*)' Last  inactive orbital:',iK
*      write(6,*)'           Its symmetry:',kS

* Compute offsets into array at iWork(ipiP(jSym)..), formally dimensioned
*  as (1:nSym,1:nsp) where nsp is nisplit(jsym)+nasplit(jsym)
* Initialize with offsets=0, which is appropriate for non-used symmetries:
               nPorb=0
               Do jS=1,nSym
                 iWork(ipiP(jSym)+nSym*(isp-1)+jS-1)=nPorb
               End Do
* and then loop over the actual values.
* Loop over the symmetry range of inactive orbitals in the partition
               Do iS=lS,kS
*      write(6,*)'    If #k has symmetry:',iS
* jS is then the symmetry of its companion orbital in the pair.
                  jS=MulD2h(iS,jSym)
*      write(6,*)'   then p has symmetry:',jS
*      write(6,*)' Number of p orbitals :',nAsh(jS) + nSsh(jS)
*      write(6,*)' Offset to them       :',nPOrb
* ipip(jSym) is pointer to an array dimensioned iP(nSym,nisplit(jSym))
* which is used for offsets. In some other array, after the position
* iP(jS,isp) follows space for nAsh(jS)+nSsh(jS) items.
                  iWork(ipiP(jSym)+nSym*(isp-1)+jS-1) = nPorb
* Update nPorb.
                  nPorb = nPorb + nAsh(jS) + nSsh(jS)
               End Do

* ipnp(jSym) is pointer to an array dimensioned nP(nisplit(jSym))
* It gives the total size for the items mentioned above.
               iWork(ipnP(jSym)+isp-1) = nPorb
               ioff = ioff + nIc(isp,jSym)

            End Do

* Here follows similar arrays for the active orbitals.
* Addressing is the same, except we use iP(jS,nisplit(jSym)+isp)
* and nP(nisplit(jSym)+isp)
            ioff=0
            Do isp=1,nAsplit(jSym)
               lS = cho_irange(ioff+1,iAorb,nSym,.false.)

               iw = nAc(isp,jSym) + ioff
               kS = cho_irange(iw,iAorb,nSym,.false.)

* Initialize with offsets=0, which is appropriate for non-used symmetries:
               nPorb=0
               Do jS=1,nSym
                 iWork(ipiP(jSym)+nSym*(nIsplit(jSym)+isp-1)+jS-1)=nPorb
               End Do
* and then loop over the actual values.
               Do iS=lS,kS
                 jS=MulD2h(iS,jSym)
                 iWork(ipiP(jSym)+nSym*(nIsplit(jSym)+isp-1)+jS-1)=nPorb
                 nPorb = nPorb + nAsh(jS) + nSsh(jS)
               End Do

               iWork(ipnP(jSym)+nIsplit(jSym)+isp-1) = nPorb
               ioff = ioff + nAc(isp,jSym)

            End Do



99          Continue

         End Do

      write(6,*)
      write(6,*)' cho_caspt2_setup report:'
      write(6,*)
      write(6,'(1x,a,8i4)')' Inactive :',(nIsh(isym),isym=1,nSym)
      write(6,'(1x,a,8i4)')' Active   :',(nAsh(isym),isym=1,nSym)
      write(6,'(1x,a,8i4)')' Secondary:',(nSsh(isym),isym=1,nSym)
      write(6,*)
      write(6,'(1x,a,8i4)')' NumCho   :',(NumCho(isym),isym=1,nSym)
      write(6,*)
      do jsym=1,nsym
       write(6,*)' Symm:',jSym
       write(6,*)' Partition  Fixed orbitals       nPorb space'
       kend=0
       do isp=1,nisplit(jsym)
        ksta=kend+1
        kend=kend+iWork(ipsp(jSym)+isp-1)
        kstasym=cho_irange(ksta,iIorb,nSym,.false.)
        kendsym=cho_irange(kend,iIorb,nSym,.false.)
        nPorb=iWork(ipnp(jSym)+isp-1)
        write(6,'(1x,i4,5x,i4,a4,i4,2x,i1,a4,i1,5x,i4)')
     &        isp,ksta,' -- ',kend,kstasym,' -- ',kendsym,nPorb
        write(6,'(1x,a,8i8)')' iP Offsets:',(iWork(ipip(jSym)+
     &                 nSym*(isp-1)+MulD2h(jSym,iS)-1),iS=1,nSym)
       write(6,*)
       end do
       kend=0
       do isp=1,nasplit(jsym)
        ksta=kend+1
        kend=kend+iWork(ipsp(jSym)+nisplit(jSym)+isp-1)
        kstasym=cho_irange(ksta,iAorb,nSym,.false.)
        kendsym=cho_irange(kend,iAorb,nSym,.false.)
        nPorb=iWork(ipnp(jSym)+nisplit(jSym)+isp-1)
        write(6,'(1x,i4,5x,i4,a4,i4,2x,i1,a4,i1,5x,i4)')
     &        isp,ksta,' -- ',kend,kstasym,' -- ',kendsym,nPorb
        write(6,'(1x,a,8i8)')' iP Offsets:',
     &         (iWork(ipip(jSym)+nSym*(nisplit(jSym)+isp-1)+
     &                             MulD2h(jSym,iS)-1),iS=1,nSym)
       write(6,*)
       end do
      End Do


      Return
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!               2021, Roland Lindh                                     *
!***********************************************************************

subroutine swap_tosqrt(irc,iLoc,nRS,JSYM,XLT,Xab)

use ChoArr, only: iRS2F
use Symmetry_Info, only: Mul
use Data_Structures, only: NDSBA_Type
use Definitions, only: wp, iwp

#include "intent.fh"
implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: iLoc, nRS, JSYM
type(NDSBA_Type), intent(_OUT_) :: XLT
real(kind=wp), intent(in) :: Xab(nRS)
#include "cholesky.fh"
#include "choorb.fh"
integer(kind=iwp) :: iag, ias, ibg, ibs, iSyma, iSymb, jRab, kRab
integer(kind=iwp), external :: cho_isao

!                                                                      *
!***********************************************************************
!                                                                      *
if (JSYM /= 1) then ! NON TOTAL-SYMMETRIC

  do jRab=1,nnBstR(jSym,iLoc)

    kRab = iiBstr(jSym,iLoc)+jRab ! already in 1st red set

    iag = iRS2F(1,kRab) ! global address
    ibg = iRS2F(2,kRab)

    iSyma = cho_isao(iag) ! symmetry block
    iSymb = Mul(jSym,iSyma) ! sym(a) > sym(b)

    ias = iag-ibas(iSyma)
    ibs = ibg-ibas(iSymb)

    XLT%SB(iSyma,iSymb)%A2(ias,ibs) = sqrt(abs(Xab(kRab)))

  end do ! jRab loop

else if (JSYM == 1) then

  do jRab=1,nnBstR(jSym,iLoc)

    kRab = iiBstr(jSym,iLoc)+jRab ! already in 1st red set

    iag = iRS2F(1,kRab) ! global address
    ibg = iRS2F(2,kRab)

    iSyma = cho_isao(iag) ! sym(a)=sym(b)

    ias = iag-ibas(iSyma) ! address within that symm block
    ibs = ibg-ibas(iSyma)

    XLT%SB(iSyma,iSyma)%A2(ias,ibs) = sqrt(abs(Xab(kRab)))
    XLT%SB(iSyma,iSyma)%A2(ibs,ias) = sqrt(abs(Xab(kRab)))

  end do ! jRab loop

end if

irc = 0

return

end subroutine swap_tosqrt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  trg_SVD
!
!> @brief  Transform a gradient to a rotated reference
!> @author Ignacio Fdez. Galvan
!>
!> @details
!> Transforms a gradient computed with respect to the rotation parameters
!> at the "current" orbitals to the rotation parameters at the "reference"
!> orbitals.
!>
!> @see ::trg_series
!>
!> @param[in]     Nv   Number of virtual orbitals
!> @param[in]     No   Number of occupied orbitals
!> @param[in]     X    Rotation parameters from reference to current
!> @param[in,out] G    Gradient at the current orbitals, will be replaced with the transformed gradient
!***********************************************************************

subroutine trg_svd(Nv,No,X,G)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none

integer(kind=iwp), intent(in) :: Nv, No
real(kind=wp), intent(in) :: X(Nv,No)
real(kind=wp), intent(inout) :: G(Nv,No)
integer(kind=iwp) :: i, j, k
real(kind=wp) :: aux
real(kind=wp), allocatable :: D(:,:,:), G1(:,:), P(:,:), Q(:,:), R(:,:), s(:), tmp(:,:), W(:,:), Z(:,:)
real(kind=wp), parameter :: thrs = sqrt(epsilon(thrs))

! This applies the transformation
!
!   G_trans = R [(Z+Z^T) (*) D1 + (Z-Z^T) (*) D2 ] Q^T +
!             + (R sinc(s) R^T) G (I - Q Q^T)
!
! where
!
!   X = R s Q^T  (SVD of X)
!   Z = R^T G Q
!   D1_ij = sinc(s_i-s_j)/2     D2_ij = sinc(s_i+s_j)/2
!   (*) denotes an element-wise product
!   sinc(x) = sin(x)/x ; sinc(0) = 1
!
! for the special case where G and X are both antisymmetric with a
! single nonzero off-diagonal block.

k = min(No,Nv)
if (k < 1) return

call mma_allocate(Q,Nv,k,label='Q')
call mma_allocate(R,k,No,label='R')
call mma_allocate(s,k,label='s')

! Do the SVD, note the R matrix is already transposed
call mma_allocate(G1,Nv,No,label='G1')
G1(:,:) = X(:,:)
call large_svd(Nv,No,G1,Q,R,s)

call mma_allocate(D,k,k,2,label='D')
do j=1,k
  do i=1,j
    aux = abs(s(i)-s(j))
    if (aux < thrs) then
      D(i,j,1) = Half
    else
      D(i,j,1) = Half*sin(aux)/aux
    end if
    aux = abs(s(i)+s(j))
    if (aux < thrs) then
      D(i,j,2) = Half
    else
      D(i,j,2) = Half*sin(aux)/aux
    end if
    D(j,i,:) = D(i,j,:)
  end do
end do

! Z = Q^T G R
call mma_allocate(Z,k,k,label='Z')
call mma_allocate(tmp,k,k,label='tmp')
if (No <= Nv) then
  call dgemm_('T','N',No,No,Nv,One,Q,Nv,G,Nv,Zero,tmp,No)
  call dgemm_('N','T',No,No,No,One,tmp,No,R,No,Zero,Z,No)
else
  call dgemm_('N','T',Nv,Nv,No,One,G,Nv,R,Nv,Zero,tmp,Nv)
  call dgemm_('T','N',Nv,Nv,Nv,One,Q,Nv,tmp,Nv,Zero,Z,Nv)
end if
! C = (Z+Z^T) (*) D1 + (Z-Z^T) (*) D2
!   = Z (*) (D1+D2) + Z.T (*) (D1-D2)
tmp(:,:) = Z(:,:)*(D(:,:,1)+D(:,:,2))+transpose(Z(:,:))*(D(:,:,1)-D(:,:,2))
call mma_deallocate(D)
! G1 = Q C R^T
if (No <= Nv) then
  call dgemm_('N','N',No,No,No,One,tmp,No,R,No,Zero,Z,No)
  call dgemm_('N','N',Nv,No,No,One,Q,Nv,Z,No,Zero,G1,Nv)
else
  call dgemm_('N','N',Nv,Nv,Nv,One,Q,Nv,tmp,Nv,Zero,Z,Nv)
  call dgemm_('N','N',Nv,No,Nv,One,Z,Nv,R,Nv,Zero,G1,Nv)
end if
call mma_deallocate(Z)

call mma_allocate(W,k,k,label='W')
call mma_allocate(P,No+Nv-k,No+Nv-k,label='P')
call mma_allocate(Z,Nv,No,label='Z')
if (No <= Nv) then
  ! W = R sinc(s) R^T
  do i=1,k
    if (s(i) < thrs) then
      tmp(i,:) = R(i,:)
    else
      tmp(i,:) = sin(s(i))/s(i)*R(i,:)
    end if
  end do
  call dgemm_('T','N',No,No,No,One,R,No,tmp,No,Zero,W,No)
  ! P = I - Q Q^T
  call dgemm_('N','T',Nv,Nv,No,-One,Q,Nv,Q,Nv,Zero,P,Nv)
  do i=1,Nv
    P(i,i) = P(i,i)+One
  end do
  ! G = P G W
  call dgemm_('N','N',Nv,No,No,One,G,Nv,W,No,Zero,Z,Nv)
  call dgemm_('N','N',Nv,No,Nv,One,P,Nv,Z,Nv,Zero,G,Nv)
else
  ! W = Q sinc(s) Q^T
  do i=1,k
    if (s(i) < thrs) then
      tmp(:,i) = Q(:,i)
    else
      tmp(:,i) = sin(s(i))/s(i)*Q(:,i)
    end if
  end do
  call dgemm_('N','T',Nv,Nv,Nv,One,tmp,Nv,Q,Nv,Zero,W,Nv)
  ! P = I - R R^T
  call dgemm_('T','N',No,No,Nv,-One,R,Nv,R,Nv,Zero,P,No)
  do i=1,No
    P(i,i) = P(i,i)+One
  end do
  ! G = W G P
  call dgemm_('N','N',Nv,No,Nv,One,W,Nv,G,Nv,Zero,Z,Nv)
  call dgemm_('N','N',Nv,No,No,One,Z,Nv,P,No,Zero,G,Nv)
end if
! G = G + G1
G(:,:) = G(:,:)+G1(:,:)

call mma_deallocate(Q)
call mma_deallocate(R)
call mma_deallocate(s)
call mma_deallocate(W)
call mma_deallocate(P)
call mma_deallocate(Z)
call mma_deallocate(G1)
call mma_deallocate(tmp)

end subroutine trg_svd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Ext_W3 (V3,M2,nc,no,dimc,dimcpp,addcpp)
c
c        this routine do:
c         Extract M2(m,c",i) <- V3(m,c',i)
c
        implicit none
        integer nc,no,dimc,dimcpp,addcpp
        real*8 V3(1:nc,1:dimc,1:no)
        real*8 M2(1:nc,1:dimcpp,1:no)
c
c        help variables
        integer m,i,c,cpp
c
        do i=1,no
          c=addcpp
          do cpp=1,dimcpp
          c=c+1
            do m=1,nc
              M2(m,cpp,i)=V3(m,c,i)
            end do
          end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine CrSph2(Win,ijkl,ncd,
     &                  Scrt,nScrt,
     &                  Coeff1,iCar,iSph,Tr1,Pr1,
     &                  Coeff2,jCar,jSph,Tr2,Pr2,Wout,mab)
************************************************************************
*                                                                      *
* Object : to transform the two-electron integrals from cartesian      *
*          gaussians to spherical gaussians.                           *
*                                                                      *
*          Observe that most of the time Win and Wout will overlap.    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
      Real*8 Win(ijkl*ncd*iCar*jCar), Scrt(nScrt),
     &       Coeff1(iCar,iCar), Coeff2(jCar,jCar),
     &       Wout(ijkl*ncd*mab)
      Logical Tr1, Pr1, Tr2, Pr2
*
      iRout = 60
      iPrint = nPrint(iRout)
*     Call RecPrt(' In CrSph2: (ab|CD) ',' ',Win,ncd*ijkl,iCar*jCar)
      If (Tr1.and.Tr2) Then
*        Call RecPrt(' Right contraction',' ',Coeff2,jCar,jSph)
*        Starting with CD,IJKL,a,b transform to B,CD,IJKL,a
*        Call xxDGeMul(Coeff2,jCar,'T',
*    &               Win,ijkl*ncd*iCar,'T',
*    &               Scrt,jSph,
*    &               jSph,jCar,ijkl*ncd*iCar)
         Call TTMul(Coeff2,Win,Scrt,jCar,jSph,ijkl*ncd*iCar)
*
*        Call RecPrt(' Left contraction',' ',Coeff1,iCar,iSph)
*        Transform B,CD,IJKL,a to AB,CD,IJKL
*        Call xxDGeMul(Coeff1,iCar,'T',
*    &               Scrt,jSph*ncd*ijkl,'T',
*    &               Wout,iSph,
*    &               iSph,iCar,jSph*ncd*ijkl)
         Call TTMul(Coeff1,Scrt,Wout,iCar,iSph,jSph*ncd*ijkl)
*        Transpose AB,CD,IJKL to IJKL,AB,CD
         call dcopy_(mab*ncd*ijkl,Wout,1,Scrt,1)
         Call dGeTMO(Scrt,mab*ncd,mab*ncd,ijkl,Wout,ijkl)
      Else If (Tr2) Then
*        Call RecPrt(' Right contraction',' ',Coeff2,jCar,jSph)
*        Starting with CD,IJKL,a,b transform to B,CD,IJKL,a
*        Call xxDGeMul(Coeff2,jCar,'T',
*    &               Win,ncd*ijkl*iCar,'T',
*    &               Scrt,jSph,
*    &               jSph,jCar,ncd*ijkl*iCar)
         Call TTMul(Coeff2,Win,Scrt,jCar,jSph,ijkl*ncd*iCar)
*        Transpose B,CD,IJKL,a to IJKL,aB,CD
         Call DGeTMO(Scrt,jSph*ncd,jSph*ncd,ijkl*iCar,Wout,ijkl*iCar)
      Else If (Tr1) Then
*        Transpose CD,IJKL,a,b to b,CD,IJKL,a
         Call DGeTMO(Win,ncd*ijkl*iCar,ncd*ijkl*iCar,jCar,Scrt,jCar)
*
*        Call RecPrt(' Left contraction',' ',Coeff1,iCar,iSph)
*        Transform b,CD,IJKL,a to Ab,CD,IJKL
*        Call xxDGeMul(Coeff1,iCar,'T',
*    &               Scrt,jCar*ncd*ijkl,'T',
*    &               Wout,iSph,
*    &               iSph,iCar,jCar*ncd*ijkl)
         Call TTMul(Coeff1,Scrt,Wout,iCar,iSph,jCar*ncd*ijkl)
*        Transpose Ab,CD,IJKL to IJKL,Ab,CD
         call dcopy_(iSph*jCar*ncd*ijkl,Wout,1,Scrt,1)
         Call DGeTMO(Scrt,iSph*jCar*ncd,iSph*jCar*ncd,ijkl,Wout,ijkl)
      Else
*         Transpose CD,IJKL,a,b to IJKL,ab,CD
          If (ncd.ne.1) Then
             call dcopy_(ncd*ijkl*iCar*jCar,Win,1,Scrt,1)
             Call DGeTMO(Scrt,ncd,ncd,ijkl*iCar*jCar,Wout,
     &                                ijkl*iCar*jCar)
          Else
             call dcopy_(ncd*ijkl*iCar*jCar,Win,1,Scrt,1)
             call dcopy_(ncd*ijkl*iCar*jCar,Scrt,1,Wout,1)
          End If
      End If
*
*     Call RecPrt(' In CrSph2: (AB|CD)',' ',Wout,ijkl,ncd*mab)
*     Call GetMem(' Exit CrSph2','CHECK','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Pr1)
         Call Unused_logical(Pr2)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FrzDel(NREMO,IREMO,EOCC,E1,NREME,IREME,EEXT,E2,CMO,CMO1,ISEQ)
! MOLPT2(MOLCAS) SUBROUTINE
! CODED AJS, MAR. 15, 1990
!
! THIS SUBROUTINE IS USED TO MOVE THE ADDITIONALLY FROZEN AND
! ADDITIONALLY DELETED ORBITALS TO THE BOTTOM OR TO THE TOP
! RESPECTIVELY, OF THE EIGENVECTOR LIST. THE ORBITAL ENERGIES='PRIN'
! ARE REARRANGED ACCORDINGLY

#include "intent.fh"

use MBPT2_Global, only: nBas
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NREMO(*), IREMO(8,*), NREME(*), IREME(8,*)
real(kind=wp), intent(_OUT_) :: EOCC(*), EEXT(*), CMO(*)
real(kind=wp), intent(in) :: E1(*), E2(*), CMO1(*)
integer(kind=iwp), intent(_OUT_) :: ISEQ(*)
integer(kind=iwp) :: I, IAD, IAD0, IADD, IADE, IADF, IADO, IADR, IEE, IENE, IENO, IEO, ISYM, J
#include "corbinf.fh"

IAD0 = 1
IADR = 1
IEO = 0
IENO = 0
IENE = 0
IEE = 0
do ISYM=1,NSYM
  IADF = IADR
  IADO = IADF+NBAS(ISYM)*(NFRO(ISYM)+NREMO(ISYM))
  IADE = IADF+NBAS(ISYM)*(NFRO(ISYM)+NOCC(ISYM))
  IADD = IADF+NBAS(ISYM)*(NBAS(ISYM)-NDEL(ISYM)-NREME(ISYM))
  do I=1,NBAS(ISYM)
    ISEQ(I) = I
  end do
  do I=1,NFRO(ISYM)
    ISEQ(I) = 0
  end do
  do I=NBAS(ISYM),NBAS(ISYM)-NDEL(ISYM)+1,-1
    ISEQ(I) = 0
  end do
  do I=1,NREMO(ISYM)
    J = IREMO(ISYM,I)
    ISEQ(J) = 0
  end do
  do I=1,NREME(ISYM)
    J = IREME(ISYM,I)+NFRO(ISYM)+NOCC(ISYM)
    ISEQ(J) = 0
  end do

  do I=1,NFRO(ISYM)+NOCC(ISYM)
    IAD = IAD0+(I-1)*NBAS(ISYM)
    if (ISEQ(I) == 0) then
      ! frozen, move to appropriate place in symmetry block
      ! observe the sequence: frozen/occupied/external/deleted
      call DCOPY_(NBAS(ISYM),CMO1(IAD),1,CMO(IADF),1)
      IADF = IADF+NBAS(ISYM)
    else
      ! occupied...
      call DCOPY_(NBAS(ISYM),CMO1(IAD),1,CMO(IADO),1)
      IADO = IADO+NBAS(ISYM)
      IENO = IENO+1
      EOCC(IENO) = E1(IEO+I-NFRO(ISYM))
    end if
  end do
  do I=NFRO(ISYM)+NOCC(ISYM)+1,NBAS(ISYM)
    IAD = IAD0+(I-1)*NBAS(ISYM)
    if (ISEQ(I) == 0) then
      ! delete, move to appropriate place in symmetry block
      ! observe the sequence: frozen/occupied/external/deleted
      call DCOPY_(NBAS(ISYM),CMO1(IAD),1,CMO(IADD),1)
      IADD = IADD+NBAS(ISYM)
    else
      ! external...
      call DCOPY_(NBAS(ISYM),CMO1(IAD),1,CMO(IADE),1)
      IADE = IADE+NBAS(ISYM)
      IENE = IENE+1
      EEXT(IENE) = E2(IEE+I-NFRO(ISYM)-NOCC(ISYM))
    end if
  end do
  IADR = IADR+NBAS(ISYM)**2
  IAD0 = IADR
  IEO = IEO+NOCC(ISYM)
  IEE = IEE+NEXT(ISYM)

  ! UPDATE NFRO, NOCC, NEXT, NDEL, AND NORB

  NFRO(ISYM) = NFRO(ISYM)+NREMO(ISYM)
  NOCC(ISYM) = NOCC(ISYM)-NREMO(ISYM)
  NDEL(ISYM) = NDEL(ISYM)+NREME(ISYM)
  NEXT(ISYM) = NEXT(ISYM)-NREME(ISYM)
  NORB(ISYM) = NBAS(ISYM)-NFRO(ISYM)-NDEL(ISYM)
end do

return

end subroutine FrzDel

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine casinfo1_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "casinfo_cvb.fh"
      logical iphex,oldex

c  Information from molcas interface file 'JOBIPH' :
      write(6,'(2a)')' ------- Recover RASSCF-related information',
     >              ' --------------------------------------'
      call f_inquire('JOBIPH',iphex)
      call f_inquire('JOBOLD',oldex)
      if(iphex)then
        write(6,'(/,a)')' Using JOBIPH interface file.'
       Call Copy_JobIph("JOBIPH","JOBOLD")
      elseif(oldex)then
        write(6,'(/,a)')' Using JOBOLD interface file.'
       Call Copy_JobIph("JOBOLD","JOBIPH")
      else
        write(6,'(/,a)')' Error: need either JOBOLD or JOBIPH file!'
        call abend_cvb()
      endif

      call rdjobiph_cvb('JOBIPH')
      call setjobiph_cvb(iorcore_c,iorclos_c,iorocc_c,mxirrep,
     >  nstsym_c,weight_c,istnel_c,istsy_c,istms2_c,nstats_c,
     >  mxstt_ci,mxstsy_ci,nel_c,norb_c,i2s_c,isym_c,mcore_c,neltot_c)
      call rasscf(ireturn_rasscf)
      call clsfls_rasscf()
c  rasscf will have overwritten jobiph ...
       Call Copy_JobIph("JOBOLD","JOBIPH")
      write(6,'(2a)')' ------- RASSCF-related information recovered',
     >              ' ------------------------------------'
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine saamphlp1(t24a,t24b,t22b,noa,nob,nva,nvb,key)
! adaptation routine for T2 amplitudes for symi=symj, syma=symb
!
! t24a - amplitudes T2(ab,ij)aaaa (I/O)
! t24b - amplitudes T2(ab,ij)bbbb (I/O)
! t22b - amplitudes T2(a,b,i,j)abab (I/O)
! noa  - number of alpha occupied orbitals in symi (I)
! nob  - number of beta occupied orbitals in symi (I)
! nva  - number of alpha virtual orbitals in syma (I)
! nvb  - number of beta virtual orbitals in syma (I)
! key  - type of adaptation (I)
!        0 - no adaptation
!        1 - T2 DDVV adaptation
!        2 - T2 DDVV + T1 DV adaptation
!        3 - full T1 and T2 adaptation (only for doublets)
!        4 - full T2 without SDVS (only for doublets)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, Two, Six, Twelve, Half, Quart
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: noa, nob, nva, nvb, key
real(kind=wp), intent(inout) :: t24a(nTri_Elem(nva-1),nTri_Elem(noa-1)), t24b(nTri_Elem(nvb-1),nTri_Elem(nob-1)), &
                                t22b(nva,nvb,noa,nob)
integer(kind=iwp) :: a, ab, ab1, b, i, ij, j, nd, nsa, nsi, nv
real(kind=wp) :: t1, t2, taaaa, tabab, tabba, tbaab, tbaba, tbbbb

if (key == 0) return

nd = nob
nv = nva
nsi = noa-nob
nsa = nvb-nva

! T2 adatption
!
! case I) DDVV i>=j,a>=b
! turn od in any case of type of adaptation
!
! aaaa=t24a(ijab) DDVV
! bbbb=t24b(ijab) DDVV
! abab=t22b(ijab) DDVV
! abba=-t22b(ijba) DDVV
! baab=-t22b(jiab) DDVV
! baba=t22b(ji,ba) DDVV
!
! direct
! t1 = (abab+baba-abba-baab)/4
! t2 = (2aaaa+2bbbb+abab+baba+abba+baab)/12
!
! reverse
!
! aaaa = 2t2
! bbbb = 2t2
! abab = t2+t1
! abba = t2-t1
! baab = t2-t1
! baba = t2+t1

do a=2,nv
  do b=1,a-1
    ab = (a-1)*(a-2)/2+b
    ab1 = (a+nsa-1)*(a+nsa-2)/2+b+nsa
    do i=2,nd
      do j=1,i-1
        ij = (i-1)*(i-2)/2+j

        taaaa = t24a(ab,ij)
        tbbbb = t24b(ab1,ij)
        tabab = t22b(a,b+nsa,i,j)
        tabba = -t22b(b,a+nsa,i,j)
        tbaab = -t22b(a,b+nsa,j,i)
        tbaba = t22b(b,a+nsa,j,i)

        t1 = Quart*(tabab+tbaba-tabba-tbaab)
        t2 = (Two*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/Twelve

        t24a(ab,ij) = Two*t2
        t24b(ab1,ij) = Two*t2
        t22b(a,b+nsa,i,j) = t2+t1
        t22b(b,a+nsa,i,j) = t1-t2
        t22b(a,b+nsa,j,i) = t1-t2
        t22b(b,a+nsa,j,i) = t2+t1

      end do
    end do
  end do
end do

do a=2,nv
  do b=1,a-1
    ab = (a-1)*(a-2)/2+b
    ab1 = (a+nsa-1)*(a+nsa-2)/2+b+nsa
    do i=1,nd
      j = i
      ij = (i-1)*(i-2)/2+j

      !taaaa = t24a(ab,ij)
      !tbbbb = t24b(ab1,ij)
      tabab = t22b(a,b+nsa,i,j)
      tabba = -t22b(b,a+nsa,i,j)
      tbaab = -t22b(a,b+nsa,j,i)
      tbaba = t22b(b,a+nsa,j,i)

      t1 = Quart*(tabab+tbaba-tabba-tbaab)
      !t2 = (Two*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/Twelve
      t2 = Zero

      !t24a(ab,ij) = Two*t2
      !t24b(ab1,ij) = Two*t2
      t22b(a,b+nsa,i,j) = t2+t1
      t22b(b,a+nsa,i,j) = t1-t2
      t22b(a,b+nsa,j,i) = t1-t2
      t22b(b,a+nsa,j,i) = t2+t1

    end do
  end do
end do

do a=1,nv
  b = a
  ab = (a-1)*(a-2)/2+b
  ab1 = (a+nsa-1)*(a+nsa-2)/2+b+nsa
  do i=2,nd
    do j=1,i-1
      ij = (i-1)*(i-2)/2+j

      !taaaa = t24a(ab,ij)
      !tbbbb = t24b(ab1,ij)
      tabab = t22b(a,b+nsa,i,j)
      tabba = -t22b(b,a+nsa,i,j)
      tbaab = -t22b(a,b+nsa,j,i)
      tbaba = t22b(b,a+nsa,j,i)

      t1 = Quart*(tabab+tbaba-tabba-tbaab)
      !t2 = (Two*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/Twelve
      t2 = Zero

      !t24a(ab,ij) = Two*t2
      !t24b(ab1,ij) = Two*t2
      t22b(a,b+nsa,i,j) = t2+t1
      t22b(b,a+nsa,i,j) = t1-t2
      t22b(a,b+nsa,j,i) = t1-t2
      t22b(b,a+nsa,j,i) = t2+t1

    end do
  end do
end do

do a=1,nv
  b = a
  ab = (a-1)*(a-2)/2+b
  ab1 = (a+nsa-1)*(a+nsa-2)/2+b+nsa
  do i=1,nd
    j = i
    ij = (i-1)*(i-2)/2+j

    !taaaa = t24a(ab,ij)
    !tbbbb = t24b(ab1,ij)
    tabab = t22b(a,b+nsa,i,j)
    tabba = -t22b(b,a+nsa,i,j)
    tbaab = -t22b(a,b+nsa,j,i)
    tbaba = t22b(b,a+nsa,j,i)

    t1 = Quart*(tabab+tbaba-tabba-tbaab)
    !t2 = (Two*(taaaa+tbbbb)+tabab+tbaba+tabba+tbaab)/Twelve
    t2 = Zero

    !t24a(ab,ij) = Two*t2
    !t24b(ab1,ij) = Two*t2
    t22b(a,b+nsa,i,j) = t2+t1
    t22b(b,a+nsa,i,j) = t1-t2
    t22b(a,b+nsa,j,i) = t1-t2
    t22b(b,a+nsa,j,i) = t2+t1

  end do
end do

if (((key == 3) .or. (key == 4)) .and. (nsa > 0)) then

  ! case II) DDVS i>=j,a,b
  !
  ! bbbb = t24b(ij,ab)
  ! abab = t22b(i,j,a,b)
  ! baab =-t22b(j,i,a,b)
  !
  ! direct :
  !
  ! t1=(abab-baab)/2
  ! t2=(2bbbb+abab+baab)/6
  !
  ! reverse:
  !
  ! bbbb = 2t2
  ! abab = t2+t1
  ! baab = t2-t1

  b = nsa
  do a=1,nv
    ab = a*(a-1)/2+b
    do i=2,nd
      do j=1,i-1
        ij = (i-1)*(i-2)/2+j

        tbbbb = t24b(ab,ij)
        tabab = t22b(a,b,i,j)
        tbaab = -t22b(a,b,j,i)

        t1 = Half*(tabab-tbaab)
        t2 = (Two*tbbbb+tabab+tbaab)/Six

        t24b(ab,ij) = Two*t2
        t22b(a,b,i,j) = t2+t1
        t22b(a,b,j,i) = t1-t2

      end do
    end do
  end do

  b = nsa
  do a=1,nv
    ab = a*(a-1)/2+b
    do i=1,nd
      j = i
      ij = (i-1)*(i-2)/2+j

      !tbbbb = t24b(ab,ij)
      tabab = t22b(a,b,i,j)
      tbaab = -t22b(a,b,j,i)

      t1 = Half*(tabab-tbaab)
      !t2 = (Two*tbbbb+tabab+tbaab)/Six
      t2 = Zero

      !t24b(ab,ij) = Two*t2
      t22b(a,b,i,j) = t2+t1
      t22b(a,b,j,i) = t1-t2

    end do
  end do

end if

if (((key == 3) .or. (key == 4)) .and. (nsi > 0)) then

  ! case III) SDVV i,j,a>=b
  !
  ! aaaa=t24a(ij,ab)
  ! abab=t22b(i,j,a,b)
  ! abba=-t22b(i,j,b,a)
  !
  ! direct
  !
  ! t1=(abab-abba)/2
  ! t2=(2aaaa+abab+abba)/6
  !
  ! reverse
  !
  ! aaaa=2t2
  ! abab=t2+t1
  ! abba=t2-t1

  i = nd+nsi
  do a=2,nv
    do b=1,a-1
      ab = (a-1)*(a-2)/2+b
      do j=1,nd
        ij = (i-1)*(i-2)/2+j

        taaaa = t24a(ab,ij)
        tabab = t22b(a,b+nsa,i,j)
        tabba = -t22b(b,a+nsa,i,j)

        t1 = Half*(tabab-tabba)
        t2 = (Two*taaaa+tabab+tabba)/Six

        t24a(ab,ij) = Two*t2
        t22b(a,b+nsa,i,j) = t2+t1
        t22b(b,a+nsa,i,j) = t1-t2

      end do
    end do
  end do

  i = nd+nsi
  do a=1,nv
    b = a
    ab = (a-1)*(a-2)/2+b
    do j=1,nd
      ij = (i-1)*(i-2)/2+j

      !taaaa = t24a(ab,ij)
      tabab = t22b(a,b+nsa,i,j)
      tabba = -t22b(b,a+nsa,i,j)

      t1 = Half*(tabab-tabba)
      !t2 = (Two*taaaa+tabab+tabba)/Six
      t2 = Zero

      !t24a(ab,ij) = Two*t2
      t22b(a,b+nsa,i,j) = t2+t1
      t22b(b,a+nsa,i,j) = t1-t2

    end do
  end do

end if

return

end subroutine saamphlp1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE NCNF_TO_NCOMP(MAXOP,NCONF_PER_OPEN,NCOMP_PER_OPEN,
     &                         NCOMP)
*
* Number of configurations per number of open orbitals is given
* Find total number of some components, defined by number
* of components per open
*
* In practice : components are SD's, CSF's or CMB's
*
* Jeppe Olsen, Dec. 2001
*
#include "implicit.fh"
*. Input
      INTEGER NCONF_PER_OPEN(*), NCOMP_PER_OPEN(*)
*
      NCOMP = 0
      DO IOPEN = 0, MAXOP
        NCOMP =
     &  NCOMP + NCONF_PER_OPEN(IOPEN+1)*NCOMP_PER_OPEN(IOPEN+1)
      END DO
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE ORBCTL(CMO_X,NCMO)
      use fciqmc_interface, only: DoFCIQMC
      use caspt2_global, only:iPrGlb
      use Printlevel, only: debug, verbose
      use caspt2_global, only: CMO, FIMO, FIFA, HONE, DREF, TORB
      use caspt2_global, only: LUONEM
      use ChoCASPT2
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: iEOF1M, bName, nBas, nSym, OutFmt, PrOrb,
     &                         ThrEne, ThrOcc, iAd1M, nFro, nOrb, nBasT,
     &                         EPS, nDel
      IMPLICIT NONE
      INTEGER NCMO
      REAL*8 CMO_X(NCMO)

      INTEGER ISYM
      INTEGER I1,I2
      INTEGER IDISK
      REAL*8  OCC_DUM(1)
      REAL*8, ALLOCATABLE:: OrbE(:)

C Calculate transformation matrix to PT2 orbitals, defined as those
C that have standard Fock matrix FIFA diagonal within inactive,
C active, and secondary subblocks.

c Determine PT2 orbitals, and transform CI coeffs.
      IF(IPRGLB.GE.DEBUG) THEN
       WRITE(6,*)' ORBCTL calling MKRPTORB...'
      END IF
* The CMO coefficient array is changed by orthonormal transformations of
* each of the inactive,Ras1,Ras2,Ras3,and secondary (i.e. virtual) orbitals
* in each symmetry. The transformation matrices are stored as a sequence of
* square matrices in TORB. The transformation is such that each of the
* diagonal blocks of the Fock matrix FIFA is diagonalized.
* MKRPTORB will at the same time transform each of the CI arrays on file
* such that, with new CMO vectors, they still represent the original
* wave function.

* The CI arrays are on file with unit number LUCIEX. There is NSTATE
* CI arrays, stored sequentially. The original set starts at disk address
* IDCIEX, the transformed ones are written after IDTCEX.
      CALL MKRPTORB(FIFA,SIZE(FIFA),TORB,SIZE(TORB),CMO_X,NCMO)
      IF(IPRGLB.GE.DEBUG) THEN
       WRITE(6,*)' ORBCTL back from MKRPTORB.'
      END IF

* Use the transformation matrices to change the HONE, FIMO, and FIFA arrays:
      if (.not. DoFCIQMC) then
          CALL TRANSFOCK(TORB,SIZE(TORB),HONE,SIZE(HONE),1)
          CALL TRANSFOCK(TORB,SIZE(TORB),FIMO,SIZE(FIMO),1)

* When doing XMS, FAMO refers only to the last state, therefore it's wrong!
* However, we never use it anywhere else...
          ! CALL TRANSFOCK(TORB,FAMO,1)
*****

          CALL TRANSFOCK(TORB,SIZE(TORB),FIFA,SIZE(FIFA),1)

* When doing XMS, DREF refers to the last state considered and it is not the
* state average density, therefore it's wrong to transform it!
* However, it is never used again in this part, and next time it is used, it
* is actually recomputed for the right place.
          CALL TRANSDREF(TORB,SIZE(TORB),DREF,SIZE(DREF))
*****
      end if

* DREF is not really used for anything important in MKEPS, this is why we don't
* care that we pass the wrong one in...
      CALL MKEPS(FIFA,DREF)

      IF(IPRGLB.GE.DEBUG) THEN
       WRITE(6,*)' ORBCTL back from TRANSFOCK.'
      END IF

      if (.not. DoFCIQMC) then
C Save new MO coeffs, and the transformation matrices:
      IDISK=IAD1M(2)
      CALL DDAFILE(LUONEM,1,CMO,NCMO,IDISK)
      IAD1M(4)=IEOF1M
      IDISK=IAD1M(4)
      CALL DDAFILE(LUONEM,1,TORB,SIZE(TORB),IDISK)
      IEOF1M=IDISK
      end if

c Print new orbitals. First, form array of orbital energies.
      CALL mma_allocate(ORBE,NBAST,Label='ORBE')
      I1=1
      I2=1
      DO ISYM=1,NSYM
        IF(NFRO(ISYM).GT.0) THEN
          CALL DCOPY_(NFRO(ISYM),[0.0D0],0,ORBE(I2),1)
          I2=I2+NFRO(ISYM)
        END IF
        IF(NORB(ISYM).GT.0) THEN
          CALL DCOPY_(NORB(ISYM),EPS(I1),1,ORBE(I2),1)
          I1=I1+NORB(ISYM)
          I2=I2+NORB(ISYM)
        END IF
        IF(NDEL(ISYM).GT.0) THEN
          CALL DCOPY_(NDEL(ISYM),[0.0D0],0,ORBE(I2),1)
          I2=I2+NDEL(ISYM)
        END IF
      END DO
c Then call utility routine PRIMO.
      IF ( IPRGLB.GE.VERBOSE ) THEN
        WRITE(6,*) ' The internal wave function representation has'//
     &             ' been changed to use quasi-canonical orbitals:'
        WRITE(6,*) ' those which diagonalize the Fock matrix within'//
     &             ' inactive-inactive,'
        WRITE(6,*) ' active-active and virtual-virtual submatrices.'
        IF(.NOT. PRORB) THEN
          WRITE(6,*)' On user''s request, the quasi-canonical orbitals'
          WRITE(6,*)' will not be printed.'
          CALL mma_deallocate(ORBE)
          RETURN
        END IF

C Print orbitals. Different options:
        IF ( OUTFMT.EQ.'LONG    ' ) THEN
          THRENE=2.0d0**31
          THROCC=-2.0d0**31
        ELSE IF ( OUTFMT.EQ.'DEFAULT ' ) THEN
          THRENE=5.0d+00
          THROCC=5.0d-04
        END IF
        CALL PRIMO(' Quasi-canonical orbitals',.FALSE.,.TRUE.,
     &              THROCC,THRENE,NSYM,NBAS,NBAS,BNAME,
     &              ORBE,OCC_DUM,CMO_X,-1)
      END IF

      CALL mma_deallocate(ORBE)

      END SUBROUTINE ORBCTL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine XDR_Local_Ham(nbas,isize,jsize,imethod,paratyp,dkhorder,xorder,inS,inK,inV,inpVp,inUL,inUS,nbl,ibl,Lmap,DoFullLT,clight)
! Local (Atom/Block) relativistic transformation of Hamiltonian

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nbas, isize, jsize, imethod, paratyp, dkhorder, xorder, nbl, ibl(nbl), Lmap(nbas)
real(kind=wp), intent(in) :: inS(isize), inV(isize), inpVp(isize), clight
real(kind=wp), intent(inout) :: inK(isize)
real(kind=wp), intent(out) :: inUL(jsize), inUS(jsize)
logical(kind=iwp), intent(in) :: doFullLT
integer(kind=iwp) :: i, j, k, iblock, mbl, ks, kL
real(kind=wp), allocatable :: sK(:,:), sS(:,:), sV(:,:), spVp(:,:), sH(:,:), sB(:,:), sKL(:,:), sSL(:,:), sVL(:,:), spVpL(:,:), &
                              sULL(:,:), sUSL(:,:), tmp(:,:)

! Convert triangle matrices to square matrices

call mma_allocate(sK,nbas,nbas,label='skin')
call mma_allocate(sS,nbas,nbas,label='sSS')
call mma_allocate(sV,nbas,nbas,label='sV')
call mma_allocate(spVp,nbas,nbas,label='spVp')
call mma_allocate(sH,nbas,nbas,label='sHam')
call mma_allocate(sB,nbas,nbas,label='sSav')
k = 0
do i=1,nbas
  do j=1,i
    k = k+1
    sK(j,i) = inK(k)
    sS(j,i) = inS(k)
    sV(j,i) = inV(k)
    spVp(j,i) = inpVp(k)
    if (i /= j) then
      sK(j,i) = inK(k)
      sS(j,i) = inS(k)
      sV(j,i) = inV(k)
      spVp(j,i) = inpVp(k)
    end if
  end do
end do
inUL(:) = Zero
inUS(:) = Zero
if (.not. DoFullLT) then
  sH(:,:) = sK(:,:)+sV(:,:)
end if

! Cycle for each local blocks

ks = 0
do iblock=1,nbl
  mbl = ibl(iblock)
  call mma_allocate(sKL,mbl,mbl,label='skinL')
  call mma_allocate(sSL,mbl,mbl,label='sSSL')
  call mma_allocate(sVL,mbl,mbl,label='sVL')
  call mma_allocate(spVpL,mbl,mbl,label='spVpL')
  call mma_allocate(sULL,mbl,mbl,label='ULlco')
  call mma_allocate(sUSL,mbl,mbl,label='USlco')

  ! Copy block matrices

  do i=1,mbl
    do j=1,mbl
      sKL(j,i) = sK(Lmap(j+ks),Lmap(i+ks))
      sSL(j,i) = sS(Lmap(j+ks),Lmap(i+ks))
      sVL(j,i) = sV(Lmap(j+ks),Lmap(i+ks))
      spVpL(j,i) = spVp(Lmap(j+ks),Lmap(i+ks))
    end do
  end do

  ! Calculate relativistic one-electron Hamiltonian for each blocks

  if (imethod == 2) then

    ! Call X2C driver

    call x2c_ts1e(mbl,sSL,sKL,sVL,spVpL,sULL,sUSL,clight)
  else if (imethod == 3) then

    ! Call BSS driver

    call bss_ts1e(mbl,sSL,sKL,sVL,spVpL,sULL,sUSL,clight)
  else if (imethod == 1) then

    ! Call arbitrary order DKH driver

    call dkh_ts1e(mbl,sSL,sKL,sVL,spVpL,sULL,sUSL,clight,dkhorder,xorder,paratyp)
  end if

  ! Copy back to full matrix

  do i=1,mbl
    do j=1,mbl
      kL = Lmap(j+ks)-1+(Lmap(i+ks)-1)*nbas
      inUL(kL+1) = sULL(j,i)
      inUS(kL+1) = sUSL(j,i)
      if (.not. DoFullLT) then
        sH(Lmap(j+ks),Lmap(i+ks)) = sVL(j,i)
      else
        sB(Lmap(j+ks),Lmap(i+ks)) = sVL(j,i)
      end if
    end do
  end do

  ! End cycle for blocks

  call mma_deallocate(sKL)
  call mma_deallocate(sSL)
  call mma_deallocate(sVL)
  call mma_deallocate(spVpL)
  call mma_deallocate(sULL)
  call mma_deallocate(sUSL)
  ks = ks+mbl
end do

! Apply transformation construct from each blocks

if (DoFullLT) then
  call mma_allocate(tmp,nbas,nbas,label='Tempm')
  call dmxma(nbas,'C','N',inUS,sK,sS,Two*clight)
  call dmxma(nbas,'N','N',sS,inUS,sH,-Two*clight)
  call dmxma(nbas,'N','N',sS,inUL,tmp,One)
  call daxpy_(nbas*nbas,One,tmp,1,sH,1)
  call dmxma(nbas,'C','N',inUL,sK,sS,One)
  call dmxma(nbas,'N','N',sS,inUS,tmp,Two*clight)
  call daxpy_(nbas*nbas,One,tmp,1,sH,1)

  call dmxma(nbas,'C','N',inUL,sV,sS,One)
  call dmxma(nbas,'N','N',sS,inUL,tmp,One)
  call daxpy_(nbas*nbas,One,tmp,1,sH,1)
  call dmxma(nbas,'C','N',inUS,spVp,sS,One)
  call dmxma(nbas,'N','N',sS,inUS,tmp,One)
  call daxpy_(nbas*nbas,One,tmp,1,sH,1)
  call mma_deallocate(tmp)
  ks = 0
  do iblock=1,nbl
    mbl = ibl(iblock)
    do i=1,mbl
      do j=1,mbl
        kL = Lmap(j+ks)-1+(Lmap(i+ks)-1)*nbas
        sH(Lmap(j+ks),Lmap(i+ks)) = sB(Lmap(j+ks),Lmap(i+ks))
      end do
    end do
    ks = ks+mbl
  end do
end if
sV(:,:) = sH(:,:)

! Copy relativistic one-electron Hamiltonian back to inK

k = 1
do i=1,nbas
  do j=1,i
    inK(k) = sV(j,i)
    k = k+1
  end do
end do

! Free temp memories

call mma_deallocate(sK)
call mma_deallocate(sS)
call mma_deallocate(sV)
call mma_deallocate(spVp)
call mma_deallocate(sH)
call mma_deallocate(sB)

return

end subroutine XDR_Local_Ham

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_GnVc_Drv(irc,Diag)
C
C     Purpose: generate vectors from a known "map" and diagonal.
C              First reduced set must have been set up, which is
C              reasonable, since it is naturally done along with the
C              diagonal.
C
#include "implicit.fh"
      Real*8 Diag(*)
#include "cholesky.fh"
#include "choprint.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Character*12 SecNam
      Parameter (SecNam = 'Cho_GnVc_Drv')

      Character*2  Unt
      Character*26 String

      Integer LastRed(8), nScrV(8)
      Integer ip_mapRS2RS, l_mapRS2RS
      Common / GnVcMp / ip_mapRS2RS(8), l_mapRS2RS(8)

      Parameter (N2 = InfVec_N2)

      InfVec(i,j,k)=iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
      nVecRS(i,j)=iWork(ip_nVecRS-1+nSym*(j-1)+i)
      iVecRS(i,j)=iWork(ip_iVecRS-1+nSym*(j-1)+i)
      mapRS2RS(i,j)=iWork(ip_mapRS2RS(i)-1+j)

C     Start timing.
C     -------------

      Call Cho_Timer(tCPU1,tWall1)

C     Set return code.
C     ----------------

      irc = 0

C     Make a dummy allocation.
C     ------------------------

      l_GnVcDum = 1
      Call Cho_Mem('GnVcDum','Allo','Real',ip_GnVcDum,l_GnVcDum)

C     Copy first reduced set to current reduced set stored at location
C     2.
C     ----------------------------------------------------------------

      Call Cho_X_RSCopy(irc,1,2)
      If (irc .ne. 0) Then
         Write(Lupri,*) SecNam,': Cho_X_RSCopy returned ',irc
         Go To 100 ! exit
      End If

C     Allocate memory for shell pair list.
C     ------------------------------------

      l_ListSP = nnShl
      Call Cho_Mem('ListSP','Allo','Inte',ip_ListSP,l_ListSP)

C     Set number of integral passes (= number of reduced sets).
C     Set ID of last reduced set in each symmetry.
C     ---------------------------------------------------------

      nPass = 0
      Do iSym = 1,nSym
         If (NumCho(iSym) .lt. 1) Then
            LastRed(iSym) = 0
         Else
            LastRed(iSym) = InfVec(NumCho(iSym),2,iSym)
         End If
         nPass = max(nPass,LastRed(iSym))
      End Do
      If (nPass .lt. 1) Then
         Call Cho_Quit('nPass is non-positive in '//SecNam,102)
      Else If (nPass .ne. XnPass) Then
         Call Cho_Quit('nPass != XnPass in '//SecNam,102)
      End If

C     nVecRS(iSym,jRed): #vectors of sym. iSym, reduced set jRed.
C     iVecRS(iSym,jRed): 1st vec. of sym. iSym, reduced set jRed.
C                        (0 means no vectors!!)
C     -----------------------------------------------------------

      l_nVecRS = nSym*nPass
      l_iVecRS = l_nVecRS
      Call Cho_Mem('nVecRS','Allo','Inte',ip_nVecRS,l_nVecRS)
      Call Cho_Mem('iVecRS','Allo','Inte',ip_iVecRS,l_iVecRS)
      Call Cho_iZero(iWork(ip_nVecRS),l_nVecRS)
      Call Cho_iZero(iWork(ip_iVecRS),l_iVecRS)
      Do iSym = 1,nSym
         nTotVec = 0
         Do jRed = 1,LastRed(iSym)
            Call Cho_X_nVecRS(jRed,iSym,iVec1,nVec)
            If (nVec.lt.0 .or. iVec1.lt.0) Then
               Call Cho_Quit(SecNam
     &                       //'Cho_X_nVecRS returned negative nVec',
     &                       103)
            Else
               iWork(ip_nVecRS-1+nSym*(jRed-1)+iSym) = nVec
               iWork(ip_iVecRS-1+nSym*(jRed-1)+iSym) = iVec1
            End If
            nTotVec = nTotVec + nVecRS(iSym,jRed)
         End Do
         If (nTotVec .ne. NumCho(iSym)) Then
            Call Cho_Quit('Initialization error in '//SecNam,102)
         End If
      End Do

C     Allocate RS-to-RS mapping array.
C     --------------------------------

      Do iSym = 1,nSym
         l_mapRS2RS(iSym) = nnBstR(iSym,1)
         Call Cho_Mem('mapRS2RS','Allo','Inte',
     &                ip_mapRS2RS(iSym),l_mapRS2RS(iSym))
      End Do

C     Split remaining memory.
C     -----------------------

      Call Cho_Mem('GnVcMx','GetM','Real',ip_Wrk,l_WrkT)
      If (l_WrkT .lt. 2) Then
         Write(Lupri,*) SecNam,': max. allocatable memory is ',
     &                  l_WrkT
         Write(Lupri,*) 'Please increase available memory.'
         irc = 101
         Go To 100 ! exit
      Else
         l_Wrk = l_WrkT/2
      End If

#if defined (_DEBUGPRINT_)
C     Debug: force batching.
C     ----------------------

      lNdMx = 0
      Do iPass = 1,nPass
         lNeed = nnBstR(1,2)*nVecRS(1,iPass)
         Do iSym = 2,nSym
            lNeed = lNeed + nnBstR(iSym,2)*nVecRS(iSym,iPass)
         End Do
         lNdMx = max(lNdMx,lNeed)
      End Do
      l_Wrk = min(l_Wrk,lNdMx)
#endif

C     Reinitialize vector counters.
C     -----------------------------

      Call Cho_iZero(NumCho,nSym)
      NumChT = 0

C     Start batch loop over integral passes.
C     --------------------------------------

      iPass = 0
      nBatch= 0
      Do While (iPass .lt. nPass)

         If (iPrint .ge. INF_PASS) Call Cho_Timer(TlTot1,WlTot1)

C        Update batch counter.
C        ---------------------

         nBatch = nBatch + 1
         iPass1 = iPass + 1
         If (nBatch .gt. nPass) Then
            Write(Lupri,*) SecNam,': batch counter exceeds ',
     &      'pass counter: ',nBatch,' > ',nPass
            irc = 103
            Go To 100 ! exit
         End If

C        Set up this batch based on current reduced set.
C        NumPass: the number of passes treated in this batch.
C        --------------------------------------------------------

         jRed    = iPass
         NumPass = 0
         l_Int   = 0
         lThis   = 0
         Do While (jRed .lt. nPass)
            jRed  = jRed + 1
            lThis = nnBstR(1,2)*nVecRS(1,jRed)
            Do iSym = 2,nSym
               lThis = lThis + nnBstR(iSym,2)*nVecRS(iSym,jRed)
            End Do
            l_Int = l_Int + lThis
            If (l_Int .gt. l_Wrk) Then
               l_Int = l_Int - lThis ! reset memory need
               jRed  = nPass ! break loop
            Else
               NumPass = NumPass + 1
            End If
         End Do
         If (NumPass .lt. 1) Then
            Write(Lupri,*) SecNam,': insufficient memory for batch ',
     &                     nBatch
            Write(Lupri,*) SecNam,': at least  ',lThis,
     &                     ' double precision words needed.'
            Write(Lupri,*) SecNam,': available ',l_Wrk,
     &                     ' double precision words.'
            irc = 101
            Go To 100 ! exit
         End If

C        Print.
C        ------

         If (iPrint .ge. INF_PASS) Then
            Write(String,'(A19,I7)') 'Integral Pass Batch',nBatch
            Call Cho_Head(String,'*',80,Lupri)
            Write(Lupri,'(A,I5,A,I5,A,I5,A)')
     &      'Integral passes treated:',iPass1,' to',iPass+NumPass,
     &      ' of',nPass,' passes.'
            Call Cho_Word2Byte(l_WrkT,8,dl_WrkT,Unt)
            Write(Lupri,'(A,I10,A,F10.3,A,A)')
     &      'Total memory available           : ',l_WrkT,
     &      ' 8-byte words; ',dl_WrkT,' ',Unt
            Call Cho_Word2Byte(l_Int,8,dl_Int,Unt)
            Write(Lupri,'(A,I10,A,F10.3,A,A)')
     &      'Memory used for integrals/vectors: ',l_Int,
     &      ' 8-byte words; ',dl_Int,' ',Unt
            Call Cho_iZero(nScrV,nSym)
            Do i = iPass1,iPass+NumPass
               Do iSym = 1,nSym
                  nScrV(iSym) = nScrV(iSym) + nVecRS(iSym,i)
               End Do
            End Do
            Write(Lupri,'(A,8I8)')
     &      '#vec. gener.  : ',(nScrV(i),i=1,nSym)
            Call Cho_Flush(Lupri)
         End If

C        Allocate memory for integral columns and initialize.
C        ----------------------------------------------------

         Call Cho_Mem('GnVc.Int','Allo','Real',ip_Int,l_Int)
         Call Cho_dZero(Work(ip_Int),l_Int)

C        Set up map from first reduced set to reduced set iPass1.
C        --------------------------------------------------------

         irc = 0
         Call Cho_X_RSCopy(irc,1,3)
         If (irc .ne. 0) Then
            Call Cho_Quit(SecNam
     &                    //': non-zero return code from Cho_X_RSCopy',
     &                    104)
         End If
         Do iSym = 1,nSym
            Call Cho_RS2RS(iWork(ip_mapRS2RS(iSym)),l_mapRS2RS(iSym),
     &                     3,2,iPass1,iSym)
         End Do

C        Set up "qualified column" index arrays.
C        nQual(iSym): #qualifieds in symmetry iSym
C        iQuAB(iAB,iSym): addr of qualified iAB, sym. iSym in curr.
C                         reduced set.
C        ----------------------------------------------------------

         Call Cho_iZero(nQual,nSym)
         iPass2 = iPass1 + NumPass - 1
         Do jPass = iPass1,iPass2
            Do iSym = 1,nSym
               kOff0 = ip_iQuAB - 1 + MaxQual*(iSym-1)
               iV1 = iVecRS(iSym,jPass)
               iV2 = iV1 + nVecRS(iSym,jPass) - 1
               Do iV = iV1,iV2
                  iAB = InfVec(iV,1,iSym) ! addr in 1st red. set
                  jAB = iAB - iiBstR(iSym,1)
                  kAB = mapRS2RS(iSym,jAB) ! addr in curr. red. set
#if defined (_DEBUGPRINT_)
                  If (kAB.lt.1 .or. kAB.gt.nnBstR(iSym,2)) Then
                     Write(Lupri,*) SecNam,': illegal kAB = ',kAB
                     Write(Lupri,*) 'Vector, symmetry, pass: ',
     &                              IV,iSym,jPass
                     Write(Lupri,*) 'Allowed range: 1 - ',nnBstR(iSym,2)
                     Call Cho_Quit('Index error in '//SecNam,104)
                  End If
#endif
                  nQual(iSym) = nQual(iSym) + 1
                  iWork(kOff0+nQual(iSym)) = iiBstR(iSym,2) + kAB
               End Do
            End Do
         End Do

         iOff_Col(1) = 0
         NumInt = nnBstR(1,2)*nQual(1)
         Do iSym = 2,nSym
            iOff_Col(iSym) = NumInt
            NumInt = NumInt + nnBstR(iSym,2)*nQual(iSym)
         End Do
         If (l_Int .ne. NumInt) Then
            Call Cho_Quit('Integral memory error in '//SecNam,101)
         End If

C        Compute all integrals needed for NumPass passes.
C        ------------------------------------------------

         If (iPrint .ge. INF_PASS) Call Cho_Timer(TlInt1,WlInt1)
         NumSP = 0
         Call Cho_GnVc_GetInt(Work(ip_Int),l_Int,
     &                        iWork(ip_nVecRS),iWork(ip_iVecRS),
     &                        iWork(ip_ListSP),
     &                        nSym,nPass,nnShl,iPass1,NumPass,NumSP)
         If (NumSP .lt. 1) Then
            Call Cho_Quit('No shell pairs calculated!',104)
         End If
         If (iPrint .ge. INF_PASS) Call Cho_Timer(TlInt2,WlInt2)

C        Generate vectors.
C        -----------------

         If (iPrint .ge. INF_PASS) Call Cho_Timer(TlDec1,WlDec1)
         Call Cho_GnVc_GenVec(Diag,Work(ip_Int),l_Int,
     &                        iWork(ip_nVecRS),iWork(ip_iVecRS),
     &                        nSym,nPass,iPass1,NumPass)
         If (iPrint .ge. INF_PASS) Call Cho_Timer(TlDec2,WlDec2)

C        Deallocate memory.
C        ------------------

         Call Cho_Mem('GnVc.Int','Free','Real',ip_Int,l_Int)

C        Print timing for this batch.
C        ----------------------------

         If (iPrint .ge. INF_PASS) Then
            TlInt = TlInt2 - TlInt1
            WlInt = WlInt2 - WlInt1
            TlDec = TlDec2 - TlDec1
            WlDec = WlDec2 - WlDec1
            Call Cho_Timer(TlTot2,WlTot2)
            TlTot = TlTot2 - TlTot1
            WlTot = WlTot2 - WlTot1
            Write(Lupri,'(/,A,I7,A)')
     &      'Overall timings for integral pass batch',nBatch,
     &      ' (CPU/Wall in seconds):'
            Write(Lupri,'(A,F12.2,1X,F12.2)')
     &      'Integrals    : ',TlInt,WlInt
            Write(Lupri,'(A,F12.2,1X,F12.2)')
     &      'Decomposition: ',TlDec,WlDec
            Write(Lupri,'(A,F12.2,1X,F12.2)')
     &      'Total        : ',TlTot,WlTot
            Write(Lupri,'(A,I7,A,I7,A)')
     &      'Integral passes treated:',iPass1,' to',iPass1-1+NumPass
            Call Cho_Flush(Lupri)
         End If

C        Update pass counter.
C        --------------------

         iPass = iPass + NumPass

      End Do ! integral pass loop

C     Exit after deallocating memory (by flushing).
C     ---------------------------------------------

  100 Continue
      Did_DecDrv = .true.
      Call Cho_Mem('GnVcDum','Flush','Real',ip_GnVcDum,l_GnVcDum)
      Call Cho_Timer(tCPU2,tWall2)
      tDecDrv(1) = tDecDrv(1) + tCPU2  - tCPU1
      tDecDrv(2) = tDecDrv(2) + tWall2 - tWall1

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine check_Fthaw(iRC)

      Implicit Real*8 (a-h,o-z)
#include "warnings.fh"
      COMMON  / OFembed_T / ThrFThaw
      Character*16 NamRfil
      Logical ok
      Real*8 Ene(1000,4)
*
      If (ThrFThaw.le.0.0d0) Return
*
      Call f_inquire('AUXRFIL',ok)
      If ( .not.ok ) Return
*
      Call Get_NameRun(NamRfil)
      Call NameRun('AUXRFIL')
      Call Get_dScalar('Last energy',EneB)
      Call NameRun(NamRfil)
      Call Get_dScalar('Last energy',EneA)
*
      iSeed=7
      Lu=IsFreeUnit(iSeed)
      Call f_inquire('FRETHAW',ok)
      If ( .not.ok ) Then
         open(Lu,file='FRETHAW')
         write(Lu,'(I4,2F18.10)') 1, EneA, EneB
         Go To 99
      Else
         open(Lu,file='FRETHAW',status='old')
      EndIf
*
      read(Lu,'(I4,2F18.10)') iter0, Ene(1,1), Ene(1,3)
      If (iter0.eq.1000) Then
         write(6,*) ' Error! check_Fthaw: maxIter reached! '
         Call Abend
      EndIf
      Do i=2,iter0
         read(Lu,'(I4,4F18.10)') kiter, Ene(i,1), Ene(i,2), Ene(i,3),
     &                                  Ene(i,4)
      End Do
*
      iter=iter0+1
      DEneA=EneA-Ene(iter0,1)
      DEneB=EneB-Ene(iter0,3)
*
      Rewind Lu
      write(Lu,'(I4,2F18.10)') iter, Ene(1,1), Ene(1,3)
      Do i=2,iter0
         write(Lu,'(I4,4F18.10)') iter, Ene(i,1), Ene(i,2), Ene(i,3),
     &                                  Ene(i,4)
      End Do
      write(Lu,'(I4,4F18.10)') iter, EneA, DEneA, EneB, DEneB
*
      write(6,*)
      write(6,*) '**************************************************'//
     &           '*****************************'
      write(6,*) '*************** Energy Statistics for Freeze-n-Thaw'//
     &           ' ***************************'
      write(6,*) '**************************************************'//
     &           '*****************************'
      write(6,*) '         Energy_A       Delta(Energy_A)      '//
     &           'Energy_B       Delta(Energy_B)'
      write(6,'(I3,1X,F18.10,18X,F18.10)') 1, Ene(1,1), Ene(1,3)
      Do i=2,iter0
         write(6,'(I3,1X,4F18.10)') i, Ene(i,1), Ene(i,2), Ene(i,3),
     &                                Ene(i,4)
      End Do
      write(6,'(I3,1X,4F18.10)') iter, EneA, DEneA, EneB, DEneB
      write(6,*) '**************************************************'//
     &           '*****************************'
*
      If ( abs(DEneA).lt.ThrFThaw .and.
     &     abs(DEneB).lt.ThrFThaw ) Then
         write(6,'(A,E9.2,A)')' Convergence reached ! (Thr = ',ThrFThaw,
     &                        ')'
         write(6,*)
         iRC=_RC_ALL_IS_WELL_
         Close(Lu,status='delete')
         Return
      Else
         write(6,'(A,E9.2,A)')' Convergence NOT reached yet ! (Thr = ',
     &                        ThrFThaw,')'
         write(6,*)
      EndIf
*
99    Continue
      Close(Lu,status='keep')
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
!                                                                      *
!***********************************************************************

subroutine SCF_Init()
!***********************************************************************
!                                                                      *
!     purpose: set up parameters that has to be predefined in SCF      *
!                                                                      *
!***********************************************************************

use InfSCF, only: AccCon, AddFragments, C1DIIS, Damping, DelThr, DIIS, DIISTh, DltnTH, DoFMM, DThr, E1V, E2V, EKin, EmConv, &
                  Energy, EneV, EThr, ExFac, FckAuf, FThr, iCoCo, iDisk, IDKeep, InVec, iPrint, iPrOrb, Iter, IterSO, jPrint, &
                  jVOut, kIVO, kOptim, KSDFT, lPaper, LstVec, MapDns, MiniDn, MxIter, NamFld, nAtoms, nBas, nCore, nD, nDel, &
                  nDens, nDisc, nFro, nFrz, nIter, nIterP, nOcc, NoProp, nOrb, nSym, One_Grid, OnlyProp, pmTime, PotNuc, PreSch, &
                  qNRTh, QudThr, RFPert, RGEK, RSRFO, rTemp, Scrmbl, TemFac, Thize, TimFld, TStop, Two_Thresholds, WarnCFG, &
                  WarnPOCC, WarnSlow, WrOutD
use NDDO, only: twoel_NDDO
use hfc_logical, only: UHF_HFC
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iFMM, iPrintLevel, nData
logical(kind=iwp) :: Found
logical(kind=iwp), external :: Reduce_Prt

!----------------------------------------------------------------------*
!     Initialize global variables                                      *
!----------------------------------------------------------------------*
call Peek_iScalar('nSym',nSym)
nAtoms = 0
nBas(:) = 0
nOrb(:) = 0
nOcc(:,:) = 0
if (nD == 1) then
  call Put_iArray('nIsh',nOcc(1,1),nSym)
else
  call Put_iArray('nIsh',nOcc(1,1),nSym)
  call Put_iArray('nIsh beta',nOcc(1,2),nSym)
end if
nFro(:) = 0
call Put_iArray('nFro',nFro,nSym)
nFrz(:) = 0
nDel(:) = 0
call qpg_iarray('nDel',Found,ndata)
if (.not. Found) call Put_iArray('nDel',nDel,nSym)
Thize = 1.0e-6_wp
EThr = 1.0e-9_wp
DThr = 1.0e-4_wp
call Qpg_dScalar('S delete thr',Found)
if (Found) then
  call Get_dScalar('S delete thr',DelThr)
else
  DelThr = 1.0e-5_wp
  call Put_dScalar('S delete thr',DelThr)
end if
DiisTh = 0.15_wp
QNRTh = 0.075_wp
!DltNTh = 0.2e-4_wp
DltNTh = 0.1e-2_wp
FThr = 1.5e-4_wp
QudThr = 1.0e-5_wp
Energy = Zero
EKin = Zero
PotNuc = Zero
EneV = Zero
E1V = Zero
E2V = Zero
OnlyProp = .false.
NoProp = .false.
FckAuf = .true.

! Order: SCF(0), Guessorb(1), Lumorb(2), Core(4)
! New order: SCF(0), Lumorb(2), Guessorb(1), Core(4)

InVec = 1
LstVec(:) = -1
LstVec(1) = 0
LstVec(2) = 2
LstVec(3) = 1
LstVec(4) = 4
nIter(0) = MxIter
nIter(1) = MxIter
nIterP = 1
iter = 1
iterso = 0

iPrint = iPrintLevel(-1)
jPrint = iPrint
if (Reduce_Prt() .and. (iPrint < 3)) jPrint = 0

iPrOrb = 1
kIvo = 0
nD = 1
UHF_HFC = .false.
iCoCo = 0
jVOut = 2
Diis = .true.
Damping = .true.
One_Grid = .false.
Two_Thresholds = .true.
iDKeep = 4
lPaper = 132
nDens = 0
kOptim = 1
AccCon = '         '
nDisc = 2000
nCore = 512
iDisk(:,1) = -1
MapDns(:) = 0
PreSch = .false.
MiniDn = .true.
WrOutD = .false.
c1Diis = .false.
RSRFO = .false.
RGEK = .false.
Scrmbl = .false.
RFpert = .false.
PmTime = .false.
EmConv = .false.
AddFragments = .false.
TimFld(:) = Zero
NamFld(1) = '1) Input processing                         :'
NamFld(2) = '2) Wave function optimization               :'
NamFld(3) = '     Line Search Iterations    (QNR steps)  :'
NamFld(4) = '  a ) calculation of the density            :'
NamFld(5) = '  b ) contraction with integrals            :'
NamFld(6) = '  c ) acceleration of convergence           :'
NamFld(7) = '        recursive BFGS         (QNR steps)  :'
NamFld(8) = '  d ) solution to Roothaan-Hall equations   :'
NamFld(9) = '  e ) rotate MOs C with U       (QNR steps) :'
NamFld(10) = '        U=exp(kap)                          :'
NamFld(11) = '  f ) transformation to new reference       :'
NamFld(12) = '  g ) s-GEK/RVO microiterations             :'
NamFld(13) = '  h ) transf. Fck Mat. with C  (QNR steps)  :'
NamFld(14) = '  i ) other calculations                    :'
NamFld(15) = '3) Final processing (generation of outputs) :'
NamFld(16) = '   T O T A L                                :'
twoel_NDDO = .false.
RTemp = 0.04_wp
TemFac = 0.02_wp
TStop = Zero
KSDFT = 'SCF '
ExFac = One
WarnCfg = .false.
WarnPocc = .false.
WarnSlow = .false.

call Get_iScalar('FMM',iFMM)
DoFMM = iFMM == 1

! Initialize energy due to external potential on the run file. This
! to make sure that it can be read unconditionally and is zero if
! not redefined by DrvXV
call Poke_dScalar('KSDFT energy',Zero)
!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

end subroutine SCF_Init

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DiagMtrx(H,nH,iNeg)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
      character*16 filnam
      Real*8 H(nH,nH)
      Logical Exist
*

*
      Lu=6
      iRout=21
      iPrint=nPrint(iRout)
*
      Call GetMem('EVal','Allo','Real',ipEVal,nH*(nH+1)/2)
      Call GetMem('EVec','Allo','Real',ipEVec,nH*nH)
*
*---- Copy elements for H
*
      SumHii=Zero
      Do i = 1, nH
         Do j = 1, i
            ij=i*(i-1)/2 + j + ipEval -1
            Work(ij)=H(i,j)
         End Do
         SumHii=SumHii+H(i,i)
      End Do
*     Write (Lu,*) ' SumHii=',SumHii
*
*---- Set up a unit matrix
*
      call dcopy_(nH*nH,[Zero],0,Work(ipEVec),1)
      call dcopy_(nH,[One],0,Work(ipEVec),nH+1)
*
*---- Compute eigenvalues and eigenvectors
*
      Call NIDiag_new(Work(ipEVal),Work(ipEVec),nH,nH,0)
      Call Jacord(Work(ipEVal),Work(ipEVec),nH,nH)
*
*---- Print out the result
*
      iNeg=0
      Do i = 1, nH
         If (Work(i*(i+1)/2+ipEVal-1).lt.Zero) iNeg=iNeg+1
      End Do
      IF (iprint.gt.5) THEN
        Write (Lu,*)
        Write (Lu,*)'************************************************'//
     &              '*****************'
        Write (Lu,*)'* Eigenvalues and Eigenvectors of the Hessian   '//
     &              '                *'
        Write (Lu,*)'************************************************'//
     &              '*****************'
      END IF
*
      filnam='SPCINX'
      call f_Inquire(filnam,Exist)
*
      If (Exist .AND. iprint.gt.5) Then
*
*        Read linear combinations from disc
*
         LuTmp=11
         call molcas_binaryopen_Vanilla(luTmp,filnam)
c         Open(luTmp,File=filnam,Form='unformatted',Status='unknown')
         ReWind (LuTmp)
*
         Read (LuTmp) nq,nQQ
*
         If (nQQ.eq.nH) Then
*
           Call GetMem('rK','Allo','Real',iprK,nq*nQQ)
           Call GetMem('qEVec','Allo','Real',ipqEVec,nq*nH)
*
           Call Print_qEVec(Work(ipEVec),nH,ipEVal,nq,
     &                      Work(iprK),Work(ipqEVec),LuTmp)
*
           Call GetMem('qEVec','Free','Real',ipqEVec,nq*nH)
           Call GetMem('rK','Free','Real',iprK,nq*nQQ)
*
         Else
*
           Write (Lu,*)
           Write (Lu,*) 'Eigenvalues of the Hessian'
           Write (Lu,*)
           Write (Lu,'(1X,10F10.5)') (Work(i*(i+1)/2+ipEVal-1),i=1,nH)
           Write (Lu,*)
           Write (Lu,*) 'Eigenvectors of the Hessian'
           Write (Lu,*)
           Do i = 1, nH
              Write (Lu,'(1X,10F10.5)')
     &              (Work((j-1)*nH+i+ipEVec-1),j=1,nH)
           End Do
         End If
*
         Close (LuTmp)
*
      Else If (iprint.gt.5) Then
*
        Call Print_qEVec2(nH,ipEVal,Work(ipEVec))
*
      End If
*
      Call GetMem('EVec','Free','Real',ipEVec,nH*nH)
      Call GetMem('EVal','Free','Real',ipEVal,nH*(nH+1)/2)
*
      Return
      End


      Subroutine Print_qEVec(EVec,nH,ipEVal,nq,rK,qEVec,LuTmp)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 EVec(nH,nH), rK(nq,nH), qEVec(nq,nH)
      Character*14 qLbl(nq)
*
      Do iq = 1, nq
         Read (LuTmp) qLbl(iq),(rK(iq,iQQ),iQQ=1,nH)
      End Do
*
      Call DGEMM_('N','N',
     &            nq,nH,nH,
     &            1.0d0,rK,nq,
     &            EVec,nH,
     &            0.0d0,qEVec,nq)
*
      Lu=6
      Thr=0.0001D0
      IncQQ = 5
      Do iiQQ = 1, nH, IncQQ
         mQQ=Min(nH,iiQQ+IncQQ-1)
         Write (Lu,*)
         Write (Lu,'(14X,5I10)') (iQQ,iQQ=iiQQ,mQQ)
         Write (Lu,'(1X,A,5F10.6)') 'Eigenvalues   ',
     &               (Work(iQQ*(iQQ+1)/2+ipEVal-1),iQQ=iiQQ,mQQ)
         Write (Lu,*)
         Do iq = 1, nq
            temp=Sqrt(DDot_(nH,qEVec(iq,1),nq,qEVec(iq,1),nq))
            If (temp.gt.Thr)
     &         Write (Lu,'(1X,A,5F10.6)')
     &               qLbl(iq),(qEVec(iq,iQQ),iQQ=iiQQ,mQQ)
         End Do
         Write (Lu,*)
      End Do
*
      Return
      End

      Subroutine Print_qEVec2(nH,ipEVal,EVec)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Real*8 EVec(nH,nH)
      Character*14 qLbl(nH)
      Character*14 cLbl
      Character*120 Temp
*
* --- Skip Primitive Coords
*
      Lu_UDIC=91
      Temp='UDIC'
      Call molcas_open(Lu_UDIC,Temp)
  10  Read(Lu_UDIC,'(A)') Temp
      Call UpCase(Temp)
      If (Temp(1:4).EQ.'VARY') Go To 20
      GoTo 10
*
* --- Read Internal Coords Labels
*
   20 Do iLines = 1, nH
   40    Read(Lu_UDIC,'(A)') Temp
         Call UpCase(Temp)
         If (Temp(1:3).EQ.'FIX') Go To 40
         cLbl = ' '
         Do j = 1, 14
           If(Temp(j:j).EQ.' '.or.Temp(j:j).EQ.'=') GoTo 30
           cLbl(j:j)=Temp(j:j)
         EndDo
  30     Continue
         qLbl(iLines) = cLbl
      EndDo

      Lu=6
      IncQQ = 5
      Do iiQQ = 1, nH, IncQQ
         mQQ=Min(nH,iiQQ+IncQQ-1)
         Write (Lu,*)
         Write (Lu,'(14X,5I10)') (iQQ,iQQ=iiQQ,mQQ)
         Write (Lu,'(1X,A,5F10.6)') 'Eigenvalues   ',
     &               (Work(iQQ*(iQQ+1)/2+ipEVal-1),iQQ=iiQQ,mQQ)
         Write (Lu,*)
         Do iq = 1, nH
             Write (Lu,'(1X,A,5F10.6)') qLbl(iq),
     &               (EVec(iq,iQQ),iQQ=iiQQ,mQQ)
         End Do
         Write (Lu,*)
      End Do
*
      Close(Lu_UDIC)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DFroz(Dlt,nDlt,CMO,nCMO,OccNo)
!***********************************************************************
!                                                                      *
!     purpose: Compute contribution to the density matrix from frozen  *
!              orbitals                                                *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use InfSCF, only: nBas, nFro, nnB, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDlt, nCMO
real(kind=wp), intent(out) :: Dlt(nDlt)
real(kind=wp), intent(in) :: CMO(nCMO)
integer(kind=iwp), intent(in) :: OccNo(*)
integer(kind=iwp) :: i, iCol, ij, iOrb, ipCff, ipDlt, ipOcc, iRow, iStrtN, iStrtO, iSym, lth, nBs, nFr, nOF, nOr
real(kind=wp) :: rSum
real(kind=wp), allocatable :: NewOcc(:)
real(kind=wp), parameter :: Scal = Two, SScale = One

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! Allocate memory for new occupation numbers
call mma_allocate(NewOcc,nnB,Label='NewOcc')

! Set proper occupation numbers
iStrtN = 0
iStrtO = 0
do iSym=1,nSym
  do iOrb=1,nOrb(iSym)
    NewOcc(iStrtN+iOrb) = Zero
    if (iOrb <= nFro(iSym)) NewOcc(iStrtN+iOrb) = OccNo(iStrtO+iOrb)
  end do
  iStrtN = iStrtN+nOrb(iSym)
  iStrtO = iStrtO+nOrb(iSym)
end do

! Compute density contribution

ipCff = 0
ipDlt = 0
ipOcc = 0
do iSym=1,nSym

  nBs = nBas(iSym)
  nOr = nOrb(iSym)
  nFr = nFro(iSym)

  nOF = nOr-nFr
  lth = nTri_Elem(nBs)

  ipCff = ipCff+nBs*nFr
  do iRow=1,nBs
    rSum = Zero
    ij = -1
    do i=nFr+1,nOr
      ij = ij+1
      !if (NewOcc(ipOcc+i) == Zero) exit
      rSum = rSum+NewOcc(ipOcc+i)*CMO(ipCff+iRow+ij*nBs)*CMO(ipCff+iRow+ij*nBs)
    end do
    Dlt(ipDlt+iTri(iRow,iRow)) = rSum*SScale

    do iCol=1,iRow-1
      rSum = Zero
      ij = -1
      do i=nFr+1,nOr
        ij = ij+1
        !if (NewOcc(ipOcc+i) == Zero) exit
        rSum = rSum+NewOcc(ipOcc+i)*CMO(ipCff+iRow+ij*nBs)*CMO(ipCff+iCol+ij*nBs)
      end do
      Dlt(ipDlt+iTri(iRow,iCol)) = Scal*rSum
    end do
  end do
# ifdef _DEBUGPRINT_
  call NrmClc(Dlt(ipDlt),nBs,'DFroz','Dlt(ipDlt)')
# endif

  ipCff = ipCff+nBs*nOF
  ipDlt = ipDlt+lth
  ipOcc = ipOcc+nOr
end do

! Deallocate memory for new occupation numbers
call mma_deallocate(NewOcc)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine DFroz

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!               2019, Stefano Battaglia                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MCCTL(HEFF,NSTATE,JSTATE)

use caspt2_global, only: iPrGlb
use PrintLevel, only: VERBOSE
use caspt2_module, only: E2Corr, HZERO, mState, NLYRoot
use SC_NEVPT2, only: Do_SC, ECORR_SC, HEFF_SC
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSTATE, JSTATE
real(kind=wp), intent(inout) :: HEFF(NSTATE,NSTATE)
integer(kind=iwp) :: ISTATE
real(kind=wp) :: DVALUE, TOTCPU1, TOTCPU2, TOTWALL1, TOTWALL2
character(len=160) :: string
real(kind=wp), allocatable :: cpu_timing(:), wall_timing(:)

call mma_allocate(cpu_timing,nstate,'timing in mcctl')
call mma_allocate(wall_timing,nstate,'timing in mcctl')
cpu_timing(:) = Zero
wall_timing(:) = Zero

! The ket state is JSTATE.
! Loop over the bra states

do ISTATE=1,NSTATE

  write(string,'(A,I0,A,I0,A,I0)') 'Multistate coupling between state ',ISTATE,' and ',JSTATE,' out of ',NSTATE
  call StatusLine('CASPT2: MCCTL: ',string)
  TOTCPU1 = Zero
  TOTWALL1 = Zero
  TOTCPU2 = Zero
  TOTWALL2 = Zero
  call CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

  if (ISTATE == JSTATE) then
    HEFF(ISTATE,JSTATE) = HEFF(ISTATE,JSTATE)+E2CORR
    if ((HZERO == 'DYALL') .and. Do_SC) HEFF_SC(ISTATE,JSTATE) = HEFF_SC(ISTATE,JSTATE)+ECORR_SC(0,0)
  else
    ! Compute the effective Hamiltonian:
    call HEFVAL(ISTATE,JSTATE,DVALUE)
    HEFF(ISTATE,JSTATE) = HEFF(ISTATE,JSTATE)+DVALUE
    !! SC-NEVPT2 contributions are added in HEFVAL
  end if

  call CWTIME(TOTCPU2,TOTWALL2)
  cpu_timing(istate) = TOTCPU2-TOTCPU1
  wall_timing(istate) = TOTWALL2-TOTWALL1

end do

if ((IPRGLB >= VERBOSE) .or. (NLYROOT /= 0)) then
  write(u6,*)
  write(u6,*) 'Hamiltonian Effective Couplings'
  write(u6,*) '-------------------------------'
  write(u6,*)
  write(u6,'(10X,6X,A3,I4,A3)') ' | ',MSTATE(JSTATE),' > '
  do ISTATE=1,NSTATE
    write(u6,'(A3,I4,A3,ES22.14)') ' < ',MSTATE(ISTATE),' | ',HEFF(ISTATE,JSTATE)
  end do
end if

if ((IPRGLB >= VERBOSE) .or. (NLYROOT /= 0)) then
  write(u6,*)
  write(u6,'(A,I4,A)') 'Time spent for multi-state couplings for root ',MSTATE(JSTATE),':'
  write(u6,*) '----------------- CPU TIME  -------- WALL TIME'
  do ISTATE=1,NSTATE
    write(u6,'(A3,I4,A,F18.3,2x,F18.3)') ' < ',MSTATE(ISTATE),' |',cpu_timing(istate),wall_timing(istate)
  end do
end if
call mma_deallocate(cpu_timing)
call mma_deallocate(wall_timing)

end subroutine MCCTL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! In this routine H_0 in RASSI basis is constructed, possibly with external perturbation added on.
subroutine RasH0(nB)

use qmstat_global, only: AddExt, AvRed, BigT, ExtLabel, HmatState, iCompExt, iPrint, MoAveRed, nExtAddOns, nRedMo, nState, ScalExt
use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nB
integer(kind=iwp) :: i, iExt, iopt, irc, iS1, iS2, iSmLbl, kaunter, Lu_One, nBTri, nSize
real(kind=wp) :: Element
real(kind=wp), allocatable :: AOG(:), AOx(:), AUX(:,:), DiagH0(:), MOG(:), MOx(:), SqAO(:,:), SqMO(:,:)
integer(kind=iwp), external :: IsFreeUnit
real(kind=r8), external :: Ddot_
#include "warnings.h"

nBTri = nTri_Elem(nB)
if (.not. AddExt) then
  call mma_allocate(DiagH0,nState,label='DiagH0')
  do i=1,nState
    DiagH0(i) = HmatState(nTri_Elem(i))
  end do
  write(u6,*) '     -----RASSI H_0 eigenvalues:'
  write(u6,99) DiagH0(:)
  call mma_deallocate(DiagH0)
else

  ! Collect one-electron perturbations.

  Lu_One = IsFreeUnit(49)
  call OpnOne(irc,0,'ONEINT',Lu_One)
  call mma_allocate(AOx,nBTri,label='AOExt')
  do iExt=1,nExtAddOns
    irc = -1
    iopt = 6
    iSmLbl = 0
    call RdOne(irc,iopt,ExtLabel(iExt),iCompExt(iExt),AOx,iSmLbl)
    AOx(:) = AOx*ScalExt(iExt)
    if (irc /= 0) then
      write(u6,*)
      write(u6,*) 'ERROR when reading ',ExtLabel(iExt),'.'
      write(u6,*) 'Have Seward computed this integral?'
      call Quit(_RC_IO_ERROR_READ_)
    end if

    ! We need to know in which basis the TDM is and then transform
    ! the one-electron integrals to RASSI-basis.

    if (.not. MoAveRed) then
      call mma_allocate(AOG,nBTri,label='Transition')
      kaunter = 0
      do iS1=1,nState
        do iS2=1,iS1
          kaunter = kaunter+1
          AOG(:) = BigT(:,kaunter)
          Element = Ddot_(nBTri,AOG,1,AOx,1)
          HmatState(kaunter) = HmatState(kaunter)+Element
        end do
      end do
      call mma_deallocate(AOG)
    else
      nSize = nTri_Elem(nRedMO)
      call mma_allocate(MOG,nSize,label='Transition')
      call mma_allocate(AUX,nRedMO,nB,label='AUX')
      call mma_allocate(SqAO,nB,nB,label='SquareAO')
      call mma_allocate(SqMO,nRedMO,nRedMO,label='SquareMO')
      call mma_allocate(MOx,nSize,label='MOExt')
      call Square(AOx,SqAO,1,nB,nB)
      call Dgemm_('T','N',nRedMO,nB,nB,One,AvRed,nB,SqAO,nB,Zero,AUX,nRedMO)
      call Dgemm_('N','N',nRedMO,nRedMO,nB,One,AUX,nRedMO,AvRed,nB,Zero,SqMO,nRedMO)
      call SqToTri_Q(SqMO,MOx,nRedMO)
      kaunter = 0
      do iS1=1,nState
        ! This was 1,nState before... I think that was a bug, because HMatState is triangular
        do iS2=1,iS1
          kaunter = kaunter+1
          MOG(:) = BigT(1:nSize,kaunter)
          Element = Ddot_(nSize,MOG,1,MOx,1)
          HmatState(kaunter) = HmatState(kaunter)+Element
        end do
      end do
      call mma_deallocate(MOG)
      call mma_deallocate(AUX)
      call mma_deallocate(SqAO)
      call mma_deallocate(SqMO)
      call mma_deallocate(MOx)
    end if
  end do
  call mma_deallocate(AOx)
  call ClsOne(irc,Lu_One)

  ! If sufficient print level, print HmatState with perturbation added.

  if (iPrint >= 5) then
    write(u6,*)
    call TriPrt('H_0+External perturbation',' ',HmatState,nState)
  end if
end if

return

99 format('            ',9(F12.7,'  '))

end subroutine RasH0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SETADDR(INFRED,INFVEC,MRED,MVEC,M2,MSYM)
!
! Purpose: set first disk addresses for reduced set info and
!          vectors.

use Cholesky, only: Cho_AdrVec, LuCho, nnBstR, nnBstRT, nnShl, nSym, NumCho, XnPass
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: MRED, MVEC, M2, MSYM
integer(kind=iwp), intent(inout) :: INFRED(MRED), INFVEC(MVEC,M2,MSYM)
integer(kind=iwp) :: IADR, IOPT, IPASS, IRED, ISYM, JPASS, LSA
real(kind=wp), allocatable :: KSA(:)
character(len=*), parameter :: SECNAM = 'CHO_SETADDR'

! Set addresses.
! --------------

if (XNPASS == 0) then
  INFRED(1) = 0
  INFVEC(1,3:4,1:NSYM) = 0
else if (XNPASS > 0) then
  IRED = 3
  IPASS = XNPASS
  call CHO_GETRED(IPASS,IRED,.false.)
  call CHO_SETREDIND(IRED)
  if (IPASS == 1) then
    INFRED(IPASS+1) = INFRED(IPASS)+NSYM*NNSHL+2*NNBSTRT(IRED)+NNSHL
  else
    INFRED(IPASS+1) = INFRED(IPASS)+NSYM*NNSHL+NNBSTRT(IRED)
  end if
  do ISYM=1,NSYM
    if (NUMCHO(ISYM) == 0) then
      INFVEC(1,3:4,ISYM) = 0
    else if (NUMCHO(ISYM) > 0) then
      if (CHO_ADRVEC == 1) then
        JPASS = INFVEC(NUMCHO(ISYM),2,ISYM)
        if (JPASS == IPASS) then
          INFVEC(NUMCHO(ISYM)+1,3,ISYM) = INFVEC(NUMCHO(ISYM),3,ISYM)+NNBSTR(ISYM,IRED)
          INFVEC(NUMCHO(ISYM)+1,4,ISYM) = INFVEC(NUMCHO(ISYM),4,ISYM)+NNBSTR(ISYM,IRED)
        else if ((JPASS <= XNPASS) .and. (JPASS > 0)) then
          IPASS = JPASS
          call CHO_GETRED(IPASS,IRED,.false.)
          call CHO_SETREDIND(IRED)
          INFVEC(NUMCHO(ISYM)+1,3,ISYM) = INFVEC(NUMCHO(ISYM),3,ISYM)+NNBSTR(ISYM,IRED)
          INFVEC(NUMCHO(ISYM)+1,4,ISYM) = INFVEC(NUMCHO(ISYM),4,ISYM)+NNBSTR(ISYM,IRED)
        else
          call CHO_QUIT('[1] JPASS error in '//SECNAM,104)
        end if
      else if (CHO_ADRVEC == 2) then
        JPASS = INFVEC(NUMCHO(ISYM),2,ISYM)
        if (JPASS == IPASS) then
          LSA = NNBSTR(ISYM,IRED)
          call mma_allocate(KSA,LSA,Label='KSA')
          IOPT = 2
          IADR = INFVEC(NUMCHO(ISYM),3,ISYM)
          call DDAFILE(LUCHO(ISYM),IOPT,KSA,LSA,IADR)
          INFVEC(NUMCHO(ISYM)+1,3,ISYM) = IADR
          INFVEC(NUMCHO(ISYM)+1,4,ISYM) = INFVEC(NUMCHO(ISYM),4,ISYM)+NNBSTR(ISYM,IRED)
          call mma_deallocate(KSA)
        else if ((JPASS <= XNPASS) .and. (JPASS > 0)) then
          IPASS = JPASS
          call CHO_GETRED(IPASS,IRED,.false.)
          call CHO_SETREDIND(IRED)
          LSA = NNBSTR(ISYM,IRED)
          call mma_allocate(KSA,LSA,Label='KSA')
          IOPT = 2
          IADR = INFVEC(NUMCHO(ISYM),3,ISYM)
          call DDAFILE(LUCHO(ISYM),IOPT,KSA,LSA,IADR)
          INFVEC(NUMCHO(ISYM)+1,3,ISYM) = IADR
          INFVEC(NUMCHO(ISYM)+1,4,ISYM) = INFVEC(NUMCHO(ISYM),4,ISYM)+NNBSTR(ISYM,IRED)
          call mma_deallocate(KSA)
        else
          call CHO_QUIT('[2] JPASS error in '//SECNAM,104)
        end if
      else
        call CHO_QUIT('CHO_ADRVEC error in '//SECNAM,102)
      end if
    else
      call CHO_QUIT('NUMCHO error in '//SECNAM,104)
    end if
  end do
else
  call CHO_QUIT('XNPASS error in '//SECNAM,104)
end if

end subroutine CHO_SETADDR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine DMInvKap_td(DigPrec,rIn,rout)
*
*     Prec  Diagonal Preconditioner from Prec_td
*     rIn   nDensC long orb RHS
*     rout  Trail vector rout = T^-1B^x
*
      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
      Real*8 rOut(*),rin(*),DigPrec(*)
*
*-------------------------------------------------------------------------
* Multiply the 1/precond in vector form, rTemp, with RHS in vector form, rIn
* ---> New trail vector.
*-------------------------------------------------------------------------
*
C
*      Call RECPRT('rIn',' ',rIn,nDensC,1)
*      Call RECPRT('DigPrec',' ',DigPrec,nDensC,1)
C
      Do k=1, nDensC
            Rout(k) = rIn(k)/DigPrec(k)
      End Do
C
*      write(*,*)'rout*rout',ddot_(ndensc,Rout,1,Rout,1)
*      write(*,*)'rin*rin',ddot_(ndensc,Rin,1,Rin,1)
*      If (isym.eq.3) stop 10
C
*
      Return
      End
*

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Z_BLKFO(ISPC,ISM,IATP,IBTP,NBATCH,NBLOCK)
! Construct information about batch and block structure of CI space
! defined by ISPC,ISM,IATP,IBTP.
!
! Output is given in the form of pointers to vectors in WORK
! where the info is stored :
!
! CLBT : Length of each Batch (in blocks)
! CLEBT : Length of each Batch (in elements)
! CI1BT : Length of each block
! CIBT  : Info on each block
! CBLTP : BLock type for each symmetry
!
! NBATCH : Number of batches
! NBLOCK : Number of blocks
!
! Jeppe Olsen, Feb. 98

use lucia_data, only: Allocate_Local_Arrays, CBLTP, CI1BT, CIBT, CLBT, CLEBT, IDC, MXNTTS, NIRREP, NSTSO, NOCTYP
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: ISPC, ISM, IATP, IBTP
integer(kind=iwp), intent(out) :: NBATCH, NBLOCK
integer(kind=iwp) :: NOCTPA, NOCTPB
integer(kind=iwp), allocatable :: LCIOIO(:), SVST(:)

! Some dummy initializations
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ==================='
write(u6,*) ' Output from Z_BLKFO'
write(u6,*) ' ==================='
write(u6,*)
write(u6,*) ' ISM, ISPC = ',ISM,ISPC
#endif

NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)
! Allocate local arrays
call Allocate_Local_Arrays(MXNTTS,NIRREP)
! These should be preserved after exit so put mark for flushing here
! Info needed for generation of block info
call mma_allocate(LCIOIO,NOCTPA*NOCTPB,Label='LCIOIO')
call IAIBCM(ISPC,LCIOIO)
call mma_allocate(SVST,1,Label='SVST')
call ZBLTP(ISM,NIRREP,IDC,CBLTP,SVST)
call mma_deallocate(SVST)
! Allowed length of each batch
!if (ISIMSYM == 0) then
!  LBLOCK = MXSOOB
!else
!  LBLOCK = MXSOOB_AS
!end if

!LBLOCK = max(LBLOCK,LCSBLK)
! JESPER : Should reduce I/O
!if (ENVIRO == 'RASSCF') then
!  LBLOCK = max(int(XISPSM(IREFSM,1)),MXSOOB)
!  if (PSSIGN /= Zero) LBLOCK = int(Two*XISPSM(IREFSM,1))
!end if

!#ifdef _DEBUGPRINT_
!write(u6,*) ' LBLOCK = ',LBLOCK
!#endif

! Batches of C vector
call PART_CIV2(IDC,NSTSO(IATP)%A,NSTSO(IBTP)%A,NOCTPA,NOCTPB,NIRREP,LCIOIO,ISM,NBATCH,CLBT,CLEBT,CI1BT,CIBT,0)
! Number of BLOCKS
NBLOCK = CI1BT(NBATCH)+CLBT(NBATCH)-1
#ifdef _DEBUGPRINT_
write(u6,*) ' Number of batches',NBATCH
write(u6,*) ' Number of blocks ',NBLOCK
#endif
! Length of each block
call EXTRROW(CIBT,8,8,NBLOCK,CI1BT)

call mma_deallocate(LCIOIO)

end subroutine Z_BLKFO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SONATORBM_INT(DENS,CHARPROP,IC_,CHARTYPE,ASS,BSS,iOpt,ROTMAT,PROPVALXR,PROPVALYR,PROPVALZR,PROPVALXI,PROPVALYI,PROPVALZI)

use OneDat, only: sOpSiz
use rassi_data, only: NBTRI
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: DENS(6,NBTRI), ROTMAT(3,3)
character(len=*), intent(inout) :: CHARPROP
integer(kind=iwp), intent(in) :: IC_, ASS, BSS, iOpt
character(len=*), intent(in) :: CHARTYPE
real(kind=wp), intent(out) :: PROPVALXR, PROPVALYR, PROPVALZR, PROPVALXI, PROPVALYI, PROPVALZI
integer(kind=iwp) :: I, IC, IC_End, IC_Str, ICMP, IDUM(1), IRC, ISCHK, ITYPE, JOPT, NIP
real(kind=wp), allocatable :: IP(:), IPX(:), IPY(:), IPZ(:)

! NOW DO INTEGRATION WITH AO MATRICES
! FOR THE EXPECTATION VALUE

! Get the proper type of the property
select case (CHARTYPE)
  case ('HERMSING')
    ITYPE = 1
  case ('ANTISING')
    ITYPE = 2
  case ('HERMTRIP')
    ITYPE = 3
  case ('ANTITRIP')
    ITYPE = 4
  case default
    write(u6,*) 'RASSI/SONATORB internal error.'
    write(u6,*) 'Erroneous property type:',trim(CHARTYPE)
    call ABEND()
    ITYPE = 0
end select

! ALLOCATE A BUFFER FOR READING ONE-ELECTRON INTEGRALS
! The extra 4 elements correspond to the nuclear contribution
! and the origin of the operator
NIP = 4+NBTRI
call mma_allocate(IP,NIP,Label='IP')
if (iOpt == 1) then
  call mma_allocate(IPX,NIP,Label='IPX')
  call mma_allocate(IPY,NIP,Label='IPY')
  call mma_allocate(IPZ,NIP,Label='IPZ')
  IPX(:) = Zero
  IPY(:) = Zero
  IPZ(:) = Zero
end if

if (iOpt == 1) then
  IC_End = 3
  IC_Str = 1
else
  IC_End = IC_
  IC_Str = IC_
end if
do IC=IC_Str,IC_End ! loop over reading X,Y, and Z AO Integrals

  ! Get info from the stored integrals
  ! JOPT controls what is read.
  ! JOPT=1 Read the size information
  ! JOPT=0 Read the property
  ! JOPT=6 Read the property, skipping the nuclear contribution and the origin
  ! (see OneDat module)
  JOPT = ibset(0,sOpSiz)
  ICMP = IC
  call iRDONE(IRC,JOPT,CHARPROP,ICMP,IDUM,ISCHK)

  ! Actually read the integral
  JOPT = 0
  call RDONE(IRC,JOPT,CHARPROP,ICMP,IP,ISCHK)

  if (IRC /= 0) then
    write(u6,*)
    write(u6,'(6X,A)') '*** ERROR IN SUBROUTINE SONATORB ***'
    write(u6,'(6X,A)') '  FAILED IN READING FROM  ONEINT'
    write(u6,'(6X,A,A)') '  LABEL     = ',trim(CHARPROP)
    write(u6,'(6X,A,I2)') '  COMPONENT = ',IC
    write(u6,*)
    call ABEND()
  end if

  if (iOpt == 1) then
    ! note reordering
    IPX(:) = IPX(:)+ROTMAT(IC,1)*IP(:)
    IPY(:) = IPY(:)+ROTMAT(IC,2)*IP(:)
    IPZ(:) = IPZ(:)+ROTMAT(IC,3)*IP(:)
  end if

end do ! end loop over reading X,Y, and Z AO Integrals

PROPVALXR = Zero
PROPVALYR = Zero
PROPVALZR = Zero
PROPVALXI = Zero
PROPVALYI = Zero
PROPVALZI = Zero

! The integral is NBTRI matrix
! The property is NBTRI matrix
! We only work with half the matrix. Therefore, this would
! have a factor of 2. However, the factor of 1/2 was missing
! in SONATORB.F from the symmetric/antisymmetric equations
if ((ITYPE == 1) .or. (ITYPE == 3)) then
  if (iOpt == 1) then
    do I=1,NBTRI
      PROPVALXR = PROPVALXR+IPX(I)*DENS(1,I)
      PROPVALYR = PROPVALYR+IPY(I)*DENS(2,I)
      PROPVALZR = PROPVALZR+IPZ(I)*DENS(3,I)

      PROPVALXI = PROPVALXI+IPX(I)*DENS(4,I)
      PROPVALYI = PROPVALYI+IPY(I)*DENS(5,I)
      PROPVALZI = PROPVALZI+IPZ(I)*DENS(6,I)
    end do
  else
    do I=1,NBTRI
      PROPVALXR = PROPVALXR+IP(I)*DENS(1,I)
      PROPVALYR = PROPVALYR+IP(I)*DENS(2,I)
      PROPVALZR = PROPVALZR+IP(I)*DENS(3,I)

      PROPVALXI = PROPVALXI+IP(I)*DENS(4,I)
      PROPVALYI = PROPVALYI+IP(I)*DENS(5,I)
      PROPVALZI = PROPVALZI+IP(I)*DENS(6,I)
    end do
  end if
else
  if (iOpt == 1) then
    do I=1,NBTRI
      PROPVALXI = PROPVALXI+IPX(I)*DENS(1,I)
      PROPVALYI = PROPVALYI+IPY(I)*DENS(2,I)
      PROPVALZI = PROPVALZI+IPZ(I)*DENS(3,I)

      PROPVALXR = PROPVALXR-IPX(I)*DENS(4,I)
      PROPVALYR = PROPVALYR-IPY(I)*DENS(5,I)
      PROPVALZR = PROPVALZR-IPZ(I)*DENS(6,I)
    end do
  else
    do I=1,NBTRI
      PROPVALXI = PROPVALXI+IP(I)*DENS(1,I)
      PROPVALYI = PROPVALYI+IP(I)*DENS(2,I)
      PROPVALZI = PROPVALZI+IP(I)*DENS(3,I)

      PROPVALXR = PROPVALXR-IP(I)*DENS(4,I)
      PROPVALYR = PROPVALYR-IP(I)*DENS(5,I)
      PROPVALZR = PROPVALZR-IP(I)*DENS(6,I)
    end do
  end if
end if

write(u6,*)
write(u6,*) '************************************'
write(u6,*) 'SONATORB EXPECTATION VALUES'
write(u6,*) ' PROPERTY: ',trim(CHARPROP)
write(u6,*) ' TYPE: ',trim(CHARTYPE)
write(u6,*) ' STATE (K,L): ',ASS,BSS
write(u6,*) '************************************'
write(u6,*) 'Property: Re(X): ',PROPVALXR
write(u6,*) 'Property: Re(Y): ',PROPVALYR
write(u6,*) 'Property: Re(Z): ',PROPVALZR
write(u6,*) 'Property: Im(X): ',PROPVALXI
write(u6,*) 'Property: Im(Y): ',PROPVALYI
write(u6,*) 'Property: Im(Z): ',PROPVALZI
write(u6,*) '************************************'

! Free up un-needed space
call mma_deallocate(IP)
if (iOpt == 1) then
  call mma_deallocate(IPX)
  call mma_deallocate(IPY)
  call mma_deallocate(IPZ)
end if

end subroutine SONATORBM_INT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine setipermzeta_cvb(ipermzeta,orbs,symelm,izeta)

use casvb_global, only: norb, nsyme, nzeta, tags
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: ipermzeta(norb,nzeta)
real(kind=wp), intent(in) :: orbs(norb,norb), symelm(norb*norb,nsyme)
integer(kind=iwp), intent(in) :: izeta(nsyme)
integer(kind=iwp) :: iorb, isyme, izeta1, jorb
real(kind=wp), allocatable :: orbinv(:,:), owrk(:,:), owrk2(:,:)
real(kind=wp), parameter :: thresh = 1.0e-8_wp

call mma_allocate(orbinv,norb,norb,label='orbinv')
call mma_allocate(owrk,norb,norb,label='owrk')
call mma_allocate(owrk2,norb,norb,label='owrk2')

if (nzeta > 0) then
  orbinv(:,:) = orbs(:,:)
  call mxinv_cvb(orbinv,norb)
end if

izeta1 = 0
do isyme=1,nsyme
  if (izeta(isyme) /= 0) then
    izeta1 = izeta1+1
    ! Determine orbital permutation for sym. operation ISYME:
    call mxatb_cvb(symelm(:,isyme),orbs,norb,norb,norb,owrk2)
    call mxatb_cvb(orbinv,owrk2,norb,norb,norb,owrk)
    do iorb=1,norb
      do jorb=1,norb
        if (abs(abs(owrk(jorb,iorb))-One) < thresh) then
          ipermzeta(iorb,izeta1) = nint(owrk(jorb,iorb))*jorb
        else if (abs(owrk(jorb,iorb)) > thresh) then
          write(u6,*) ' Fatal error! Symmetry operation ',tags(isyme),' does not permute the VB orbitals!'
          call mxprint_cvb(owrk,norb,norb,0)
          call abend_cvb()
        end if
      end do
    end do
  end if
end do

call mma_deallocate(orbinv)
call mma_deallocate(owrk)
call mma_deallocate(owrk2)

return

end subroutine setipermzeta_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Markus P. Fuelscher                              *
************************************************************************
      Subroutine ClnMO_m(CMO)

************************************************************************
*                                                                      *
*     In order to preserve symmetry of orbitals which belong           *
*     to a point group of higher order than those allowed in           *
*     MOLCAS, it is sometimes necessary to enforce the MO coefficients *
*     to remain zero. This subroutine does that job in every           *
*     iteration.                                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 2000                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*     This subroutine replaces the one written earlier by L. Serrano   *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 2000                                 *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

#include "rasdim.fh"
#include "general.fh"
#include "rasscf.fh"
#include "WrkSpc.fh"

      Dimension CMO(*)

* Prelude


* Body

      iOff = ipCleanMask-1
      Do iSym = 1,nSym
        mBas = nBas(iSym)
        Do i = 1,mBas
          ii = (i-1)*mBas+iOff
          Do j = 1,mBas
            ij = j+ii
            If ( iWork(ij).eq.1 ) CMO(ij) = 0.0D0
          End Do
        End Do
        iOff = iOff+mBas*mBas
      End Do

* Epilogue


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine casinfoset_cvb()
      implicit real*8 (a-h,o-z)
c ... Files/Hamiltonian available ...
      logical, external :: valid_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "inpmod_cvb.fh"
#include "WrkSpc.fh"
#include "casinfo_cvb.fh"
      logical hadinput
      logical debug
      data debug/.false./

      if(debug)then
        write(6,*)' casinfoset :'
        write(6,*)' ------------'
        write(6,*)' iorocc_c  :',iorocc_c
        write(6,*)' iorclos_c :',iorclos_c
        write(6,*)' iorcore_c :',iorcore_c
        write(6,*)' nstsym_c  :',nstsym_c
        write(6,*)' weight_c  :',weight_c
        write(6,*)' istnel_c  :',istnel_c
        write(6,*)' istsy_c   :',istsy_c
        write(6,*)' istms2_c  :',istms2_c
        write(6,*)' nstats_c  :',nstats_c
        write(6,*)' strtint_c :',strtint_c
        write(6,*)' strtci_c  :',strtci_c
        write(6,*)' strtmo_c  :',strtmo_c
        write(6,*)' iorocc_d  :',iorocc_d
        write(6,*)' iorclos_d :',iorclos_d
        write(6,*)' iorcore_d :',iorcore_d
        write(6,*)' nstsym_d  :',nstsym_d
        write(6,*)' weight_d  :',weight_d
        write(6,*)' istnel_d  :',istnel_d
        write(6,*)' istsy_d   :',istsy_d
        write(6,*)' istms2_d  :',istms2_d
        write(6,*)' nstats_d  :',nstats_d
        write(6,*)' strtint_d :',strtint_d
        write(6,*)' strtci_d  :',strtci_d
        write(6,*)' strtmo_d  :',strtmo_d
      endif
      hadinput=.false.
      do 100 i=1,mxstsy_ci
      if(iorocc_d(i).ne.-1)hadinput=.true.
      if(iorclos_d(i).ne.-1)hadinput=.true.
      if(iorcore_d(i).ne.-1)hadinput=.true.
100   continue
      if(hadinput)then
        do 200 i=1,mxstsy_ci
        if(iorocc_d(i).eq.-1)iorocc_d(i)=0
        if(iorclos_d(i).eq.-1)iorclos_d(i)=0
        if(iorcore_d(i).eq.-1)iorcore_d(i)=0
200     continue
      else
        call imove_cvb(iorcore_c,iorcore_d,mxstsy_ci)
        call imove_cvb(iorclos_c,iorclos_d,mxstsy_ci)
        call imove_cvb(iorocc_c,iorocc_d,mxstsy_ci)
      endif

      mcore_d=0
c  Ensure no negative number of orbitals :
      do 300 i=1,mxirrep
      iorclos_d(i)=iorclos_d(i)+iorcore_d(i)
      iorocc_d(i)=iorocc_d(i)+iorclos_d(i)
      mcore_d=mcore_d+iorclos_d(i)
300   continue

      if(nstsym_d.eq.0)then
        nstsym_d=nstsym_c
        call imove_cvb(nstats_c,nstats_d,mxstsy_ci)
        call imove_cvb(istnel_c,istnel_d,mxstsy_ci)
        call imove_cvb(istsy_c,istsy_d,mxstsy_ci)
        call imove_cvb(istms2_c,istms2_d,mxstsy_ci)
        call fmove_cvb(weight_c,weight_d,mxstt_ci*mxstsy_ci)
        if(mcore_d.ne.mcore_c)then
c  Different number of core orbitals input -> assume NELTOT the same :
          do 400 i=1,mxstsy_ci
          if(istnel_d(i).ne.0)istnel_d(i)=istnel_d(i)
     >      +2*(mcore_c-mcore_d)
400       continue
        endif
      endif
      strtint_d=strtint
      strtmo_d=strtmo
      strtci_d=strtci
      if(.not.valid_cvb(strtint_d))strtint_d=strtint_c
      if(.not.valid_cvb(strtmo_d))strtmo_d=strtmo_c
      if(.not.valid_cvb(strtci_d))strtci_d=strtci_c
      strtint=strtint_d
      strtmo=strtmo_d
      strtci=strtci_d

c  Set active space information
      sum=zero
      do 600 i=1,nstsym_d
      do 601 j=1,nstats_d(i)
      if(weight_d(j,i).lt.zero)then
        write(6,'(a,f10.4,i3,a,i1)')
     >    ' Fatal error: WEIGHT factor negative :',weight_d(j,i),j,'.',i
        call abend_cvb()
      endif
      sum=sum+weight_d(j,i)
601   continue
600   continue
      sum=one/sum
      call dscal_(mxstt_ci*mxstsy_ci,sum,weight_d,1)
      nel_d=-1
      i2s_d=-1
      call izero(isymv,mxirrep)
      do 700 i=1,nstsym_d
      do 800 j=1,nstats_d(i)
      if(weight_d(j,i).gt.1.d-20)goto 900
800   continue
      goto 700
900   continue
      if(nel_d.ne.-1.and.nel_d.ne.istnel_d(i))then
        write(6,*)' Fatal error: ELEC varies in WF cards!'
        call abend_cvb()
      endif
      if(i2s_d.ne.-1.and.i2s_d.ne.istms2_d(i))then
        write(6,*)' Fatal error: SPIN varies in WF cards!'
        call abend_cvb()
      endif
      nel_d=istnel_d(i)
      i2s_d=istms2_d(i)
      isym_d=istsy_d(i)
      isymv(isym_d)=1
700   continue
      nsym=0
      do 1000 is=1,mxirrep
      if(isymv(is).eq.1)nsym=nsym+1
1000  continue

      nel=nel_d
      isym=isym_d

      call izero(ityp,mxorb)
      mcore=0
      norb=0
      incr=0
      do 1100 i=1,mxirrep
      ioc=iorocc_d(i)-iorclos_d(i)
      norb=norb+ioc
      mcore=mcore+iorclos_d(i)
      do 1200 j=1,ioc
      ityp(j+incr)=i
1200  continue
      incr=incr+ioc
1100  continue
c  Set NIRREP :
      nirrep=1
      do 1350 irrep=1,mxirrep
      if(iorcore_d(irrep).gt.0.or.iorclos_d(irrep).gt.0.or.
     >   iorocc_d(irrep).gt.0)nirrep=irrep
1350  continue
      if(nirrep.eq.3)nirrep=4
      if(nirrep.gt.4)nirrep=8

      noe=max(norb,nel)
      nbet=(nel-i2s_d)/2
      nalf=nel-nbet
c  Basic checks
      if(nel.lt.0.or.norb.lt.0.or.i2s_d.lt.0.or.nel.gt.2*norb.or.
     >  mod(nel,2).ne.mod(i2s_d,2))then
        write(6,*)' Impossible numbers: active electrons :',nel
        write(6,*)'                     active orbitals  :',norb
        write(6,*)'                     total spin       :',
     >    DBLE(nalf-nbet)/two
        call abend_cvb()
      endif
      if(isym.eq.0)then
        write(6,*)' WARNING: State symmetry not found - assuming A1.'
        isym=1
        nsym=1
        call izero(isymv,mxirrep)
        isymv(1)=1
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1996, Markus P. Fuelscher                         *
*               1990, Jeppe Olsen                                      *
************************************************************************
      Subroutine Reord2(NORB,NEL,IREFSM,IMODE,
     &                  ICONF,ISPIN,CIOLD,CINEW,kcnf)
************************************************************************
*                                                                      *
*     Rearrange CI-vectors                                             *
*     iMode=0 --> from SGA to split graph GUGA order                   *
*     iMode=1 --> from split graph GUGA to SGA order                   *
*                                                                      *
*     calling arguments:                                               *
*     nOrb    : integer                                                *
*               total number of active orbitals                        *
*     nEl     : integer                                                *
*               total number of active electrons                       *
*     iRefSm  : integer                                                *
*               state symmetry                                         *
*     iMode   : integer                                                *
*               switch selecting reordering mode (see above)           *
*     iConf   : array of integer                                       *
*               string information                                     *
*     iSpin   : array of integer                                       *
*               spin coupling information                              *
*     nSm     : array of integer                                       *
*               symmetry per active orbital                            *
*     CIold   : array of real*8                                        *
*               incoming CI vector                                     *
*     CInew   : array of real*8                                        *
*               outgoing CI vector                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher and J. Olsen                                      *
*     University of Lund, Sweden, 1990                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*     - updated for integral direct and reaction field calculations    *
*       M.P. Fuelscher, University of Lund, Sweden, 1996               *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)


#include "rasdim.fh"
#include "strnum.fh"
#include "ciinfo.fh"
#include "spinfo.fh"
#include "gugx.fh"
#include "WrkSpc.fh"
#include "output_ras.fh"
      PARAMETER (ROUTINE='REORD2  ')
C
      DIMENSION ICONF(*),ISPIN(*)
      DIMENSION CIOLD(*),CINEW(*)
      DIMENSION KCNF(NEL)
C
      DIMENSION IWALK(mxAct)

      IPRLEV=IPRLOC(3)
C
C     LOOP OVER CONFIGURATIONS TYPES
C
      ICSFJP = 0
      ICNBS0 = 0
      IPBAS = 0
      DO 1000 ITYP = 1, NTYP
        IOPEN = ITYP + MINOP - 1
        ICL = (NEL - IOPEN) / 2
C      BASE ADRESS FOR CONFIGURATION OF THIS TYPE
        IF( ITYP .EQ. 1 ) THEN
          ICNBS0 = 1
        ELSE
          ICNBS0 = ICNBS0 + NCNFTP(ITYP-1,IREFSM)*(NEL+IOPEN-1)/2
        END IF
C      BASE ADRESS FOR PROTOTYPE SPIN COUPLINGS
        IF( ITYP .EQ. 1 ) THEN
          IPBAS = 1
        ELSE
          IPBAS = IPBAS + NCSFTP(ITYP-1)*(IOPEN-1)
        END IF
C
C     LOOP OVER NUMBER OF CONFIGURATIONS OF TYPE ITYP AND PROTOTYPE
C     SPIN COUPLINGS
C
        DO 900  IC = 1, NCNFTP(ITYP,IREFSM)
          ICNBS = ICNBS0 + (IC-1)*(IOPEN+ICL)
          DO 800 IICSF = 1,NCSFTP(ITYP)
            ICSFJP = ICSFJP + 1
            ICSBAS = IPBAS + (IICSF-1)*IOPEN
*. Obtain configuration in standard RASSCF form
            IIBOP = 1
            IIBCL = 1
            JOCC  = ICL + IOPEN
            DO KOCC = 0, JOCC-1
              KORB = ICONF(ICNBS+KOCC)
              IF(KORB.LT.0) THEN
*. Doubly occupied orbitals
                KCNF(IIBCL) = ABS(KORB)
                IIBCL = IIBCL + 1
              ELSE
*. Singly occupied orbital
                KCNF(ICL+IIBOP) = KORB
                IIBOP = IIBOP + 1
              END IF
            END DO
*
C     COMPUTE STEP VECTOR
            CALL STEPVEC(KCNF(1),KCNF(ICL+1),ICL,IOPEN,
     &                   ISPIN(ICSBAS),NORB,IWALK)
C     GET SPLIT GRAPH ORDERING NUMBER
            ISG=ISGNUM(IWORK(LDOWN),IWORK(LUP),
     &                 IWORK(LDAW),IWORK(LRAW),
     &                 IWORK(LUSGN),IWORK(LLSGN),
     &                 IWALK)
C     GET PHASE PHASE FACTOR
            IP=IPHASE(IWORK(LDRT),IWORK(LUP),IWALK)
            IF( IMODE.EQ.0 ) THEN
              CINEW(ISG)=CIOLD(ICSFJP)
              IF( IP.LT.0 ) CINEW(ISG)=-CIOLD(ICSFJP)
            ELSE
              CINEW(ICSFJP)=CIOLD(ISG)
              IF( IP.LT.0 ) CINEW(ICSFJP)=-CIOLD(ISG)
            ENDIF
800       CONTINUE
900     CONTINUE
1000  CONTINUE
C
      IF( IPRLEV.GE.DEBUG ) THEN
        LPRINT=MIN(200,ICSFJP)
        WRITE (6,*)
        WRITE (6,*) ' OLD CI-VECTOR IN SUBROUTINE REORD',
     &              ' (MAX. 200 ELEMENTS)'
        WRITE (6,'(10F12.8)') (CIOLD(I),I=1,LPRINT)
        WRITE (6,*) ' NEW CI-VECTOR IN SUBROUTINE REORD',
     &              ' (MAX. 200 ELEMENTS)'
        WRITE (6,'(10F12.8)') (CINEW(I),I=1,LPRINT)
        WRITE (6,*)
      ENDIF
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine makecivecp_cvb(civec,civecp,orbs)
c  Construct CIVECP :
      implicit real*8 (a-h,o-z)
c ... Content of CI vectors ...
      logical, external :: tstcnt_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension orbs(norb,norb)
      dimension civec(ndet),civecp(ndet)

      if(tstcnt_cvb(civecp,3))return

      iowrk  = mstackr_cvb(norb*norb)
      igjorb = mstackr_cvb(norb*norb+ihlf_cvb(norb+2*norb*norb))
      call transp_cvb(orbs,work(iowrk),norb,norb)
      call gaussj_cvb(work(iowrk),work(igjorb))
      if(memplenty)then
        call getci_cvb(civec)
        call cicopy_cvb(civec,civecp)
      else
        call cird_cvb(civecp,61001.2d0)
      endif
      call applyt_cvb(civecp,work(igjorb))
      call mfreer_cvb(iowrk)

      call setcnt_cvb(civecp,3)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Checker(mGrid,Rho,nRho,P2_ontop,
     &                   nP2_ontop,iSpin,F_xc,
     &                   dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_Z)
      Implicit Real*8 (A-H,O-Z)
      External LSDA, BLYP, BPBE, B3LYP, B2PLYP, HFS, HFB, HFO,
     &  XAlpha, LSDA5, B3LYP5,TLYP,NLYP, OLYP, O3LYP, OPBE,
     &  SSBSW, SSBD, PBE, PBESOL, PBE0, M06L, M06, M062X, M06HF, O2PLYP,
     & HFG, GLYP, GPBE, HFB86, B86LYP, B86PBE, BWIG, KT3,
     & KT2, RGE2, PTCA
      Integer Functional_type
#include "functional_types.fh"
#include "stdalloc.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),
     &       P2_ontop(nP2_ontop,mGrid), F_xc(mGrid),
     &       dF_dP2ontop(ndF_dP2ontop,mGrid)
      Real*8, Allocatable:: F_xc1(:), F_xc2(:), F_xc3(:), F_xc4(:),
     &                      dF_temp(:), Rho_temp(:)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(F_xc1,mGrid,Label='F_xc1')
      Call mma_allocate(F_xc2,mGrid,Label='F_xc2')
      Call mma_allocate(F_xc3,mGrid,Label='F_xc3')
      Call mma_allocate(F_xc4,mGrid,Label='F_xc4')
      Call mma_allocate(dF_temp,ndF_dRho*mGrid,Label='dF_temp')
      Call mma_allocate(Rho_temp,nRho*mGrid,Label='Rho_temp')
      T_x=1.0D-8
*                                                                      *
************************************************************************
*                                                                      *
      Functional_type=LDA_type
*---- LSDA
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              LSDA,Functional_type,'LSDA',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- LSDA5
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              LSDA5,Functional_type,'LSDA5',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- HFS
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              HFS,Functional_type,'HFS',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- xalpha
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              XAlpha,Functional_type,'xAlpha',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*
      Functional_type=GGA_type
*---- HFB
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              HFB,Functional_type,'HFB',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- HFO
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              HFO,Functional_type,'HFO',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- HFB86
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              HFB86,Functional_type,'HFB86',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- HFG
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              HFG,Functional_type,'HFG',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- BWIG
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              BWIG,Functional_type,'BWIG',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- BLYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              BLYP,Functional_type,'BLYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- OLYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              OLYP,Functional_type,'OLYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- KT3
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              KT3,Functional_type,'KT3',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- KT2
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              KT2,Functional_type,'KT2',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- GLYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              GLYP,Functional_type,'GLYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- B86LYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              B86LYP,Functional_type,'B86LYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- BPBE
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              BPBE,Functional_type,'BPBE',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- OPBE
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              OPBE,Functional_type,'OPBE',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- GPBE
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              GPBE,Functional_type,'GPBE',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- B86PBE
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              B86PBE,Functional_type,'B86PBE',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- TLYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              TLYP,Functional_type,'TLYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
#ifdef _SKIP_
*---- NLYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              NLYP,Functional_type,'NLYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
#endif
*---- B3LYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              B3LYP,Functional_type,'B3LYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- O3LYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              O3LYP,Functional_type,'O3LYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- B2PLYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              B2PLYP,Functional_type,'B2PLYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- O2PLYP
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              O2PLYP,Functional_type,'O2PLYP',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- B3LYP5
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              B3LYP5,Functional_type,'B3LYP5',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- PBE0
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              PBE0,Functional_type,'PBE0',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- PBE
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              PBE,Functional_type,'PBE',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- SSBSW
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              SSBSW,Functional_type,'SSBSW',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- SSBD
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              SSBD,Functional_type,'SSBD',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- PBEsol
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              PBEsol,Functional_type,'PBESOL',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- RGE2
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              RGE2,Functional_type,'RGE2',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- PTCA
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              PTCA,Functional_type,'PTCA',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*
*
      Functional_type=meta_GGA_type1
*---- M06-L
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              M06L,Functional_type,'M06-L',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- M06
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              M06,Functional_type,'M06',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- M06-2X
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              M062X,Functional_type,'M06-2X',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*---- M06-HF
      Call Checker_(mGrid,Rho,nRho,P2_ontop,
     &              nP2_ontop,iSpin,F_xc,
     &              dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &              M06HF,Functional_type,'M06-HF',
     &              F_xc1,F_xc2,
     &              F_xc3,F_xc4,
     &              dF_temp,Rho_temp)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Rho_temp)
      Call mma_deallocate(dF_temp)
      Call mma_deallocate(F_xc4)
      Call mma_deallocate(F_xc3)
      Call mma_deallocate(F_xc2)
      Call mma_deallocate(F_xc1)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(T_Z)
      End
      Subroutine Checker_(mGrid,Rho,nRho,P2_ontop,
     &                   nP2_ontop,iSpin,F_xc,
     &                   dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X,
     &                   Kernel,Ftype,FName,F_xc1,F_xc2,F_xc3,F_xc4,
     &                   dF_temp,Rho_temp)
      Implicit Real*8 (A-H,O-Z)
      External Kernel
#include "functional_types.fh"
#include "nq_index.fh"
#include "real.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),
     &       P2_ontop(nP2_ontop,mGrid), F_xc(mGrid),
     &       dF_dP2ontop(ndF_dP2ontop,mGrid), F_xc1(mGrid),F_xc2(mGrid),
     &       F_xc3(mGrid), F_xc4(mGrid), dF_temp(ndF_dRho,mGrid),
     &       Rho_temp(nRho,mGrid)
      Integer FType
      Character FName*(*)
*                                                                      *
************************************************************************
*                                                                      *
C     Write (*,*) 'Functional: ',FName
      Call FZero(F_xc,mGrid)
      Call FZero(dF_dRho,ndF_dRho*mGrid)
      Call Kernel(mGrid,Rho,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc,
     &            dF_dRho,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*                                                                      *
************************************************************************
*                                                                      *
      Delta=1.0D-3
      Error=1.0D-4
      Thr_V_a=1.0D-8
      Tf=(One-Two*Delta)
*                                                                      *
************************************************************************
*                                                                      *
*     Check for rho (alpha)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipR,iGrid) = (One+Delta)*Rho(ipR,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipRa,iGrid) = (One+Delta)*Rho(ipRa,iGrid)
         End Do
      End If
      Call FZero(F_xc1,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc1,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipR,iGrid) = (One-Delta)*Rho(ipR,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipRa,iGrid) = (One-Delta)*Rho(ipRa,iGrid)
         End Do
      End If
      Call FZero(F_xc2,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc2,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipR,iGrid) = (One+Two*Delta)*Rho(ipR,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipRa,iGrid) = (One+Two*Delta)*Rho(ipRa,iGrid)
         End Do
      End If
      Call FZero(F_xc3,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc3,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipR,iGrid) = (One-Two*Delta)*Rho(ipR,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipRa,iGrid) = (One-Two*Delta)*Rho(ipRa,iGrid)
         End Do
      End If
      Call FZero(F_xc4,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc4,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      Do iGrid = 1, mGrid
         If (iSpin.eq.1) Then
            If (Tf*Rho(ipR,iGrid).lt.T_x) Go To 99
            V_a=dF_dRho(ipR,iGrid)
            Delta0=Delta*Rho(ipR,iGrid)*Two
         Else
            If (Tf*Rho(ipRa,iGrid).lt.T_x) Go To 99
            V_a=dF_dRho(ipRa,iGrid)
            Delta0=Delta*Rho(ipRa,iGrid)
         End If
         Diff1=F_xc1(iGrid)-F_xc2(iGrid)
         Diff2=F_xc3(iGrid)-F_xc4(iGrid)
         V_n=(Two*Diff1-Diff2/Four)/(Three*Delta0)
         Rel_Diff=Abs((V_a-V_n)/V_n)
         If (V_a-V_n.eq.Zero) Rel_Diff=Zero
C        If (V_a.eq.Zero) Rel_Diff=Abs(V_n)
         If (Abs(V_a).lt.Thr_V_a) Rel_Diff=Abs(V_n)
         If (Rel_Diff.gt.Error) Then
            Call WarningMessage(2,'Rel_Diff.gt.Error')
            Write (6,'(A,A)') 'Functional:',FName
            Write (6,*) 'Error in dF_dRho(alpha)!'
            Write (6,*) 'V_a,V_n=',V_a,V_n
            Write (6,*) 'iGrid,mGrid=',iGrid,mGrid
            If (iSpin.eq.1) Then
               Write (6,*) 'Rho=',Rho(ipR,iGrid)
               Write (6,*) 'GradRho=',Rho(ipdRx,iGrid),
     &                                Rho(ipdRy,iGrid),
     &                                Rho(ipdRz,iGrid)
               Write (6,*) 'Tau=',    Rho(ipTau,iGrid)
            Else
               Write (6,*) 'Rho=',Rho(ipRa,iGrid),
     &                            Rho(ipRb,iGrid)
               Write (6,*) 'GradRho=',Rho(ipdRxa,iGrid),
     &                                Rho(ipdRya,iGrid),
     &                                Rho(ipdRza,iGrid)
               Write (6,*) '        ',Rho(ipdRxb,iGrid),
     &                                Rho(ipdRyb,iGrid),
     &                                Rho(ipdRzb,iGrid)
               Write (6,*) 'Tau=',    Rho(ipTaua,iGrid),
     &                                Rho(ipTaub,iGrid)
            End If
            Write (6,*) 'F_xc(iGrid),F_xc1(iGrid),F_xc2(iGrid)=',
     &                   F_xc(iGrid),F_xc1(iGrid),F_xc2(iGrid)
            Call Abend()
         End If
 99      Continue
      End Do
*
      If (iSpin.eq.1) Go To 100
*                                                                      *
************************************************************************
*                                                                      *
*     Check for rho (beta)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipRb,iGrid) = (One+Delta)*Rho(ipRb,iGrid)
      End Do
      Call FZero(F_xc1,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc1,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipRb,iGrid) = (One-Delta)*Rho(ipRb,iGrid)
      End Do
      Call FZero(F_xc2,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc2,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipRb,iGrid) = (One+Two*Delta)*Rho(ipRb,iGrid)
      End Do
      Call FZero(F_xc3,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc3,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipRb,iGrid) = (One-Two*Delta)*Rho(ipRb,iGrid)
      End Do
      Call FZero(F_xc4,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc4,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      Do iGrid = 1, mGrid
         If (Tf*Rho(ipRb,iGrid).lt.T_x) Go To 101
         V_a=dF_dRho(ipRb,iGrid)
         Delta0=Delta*Rho(ipRb,iGrid)
         Diff1=F_xc1(iGrid)-F_xc2(iGrid)
         Diff2=F_xc3(iGrid)-F_xc4(iGrid)
         V_n=(Two*Diff1-Diff2/Four)/(Three*Delta0)
         Rel_Diff=Abs((V_a-V_n)/V_n)
         If (V_a-V_n.eq.Zero) Rel_Diff=Zero
C        If (V_a.eq.Zero) Rel_Diff=Abs(V_n)
         If (Abs(V_a).lt.Thr_V_a) Rel_Diff=Abs(V_n)
         If (Rel_Diff.gt.Error) Then
            Call WarningMessage(2,'Rel_Diff.gt.Error')
            Write (6,'(A,A)') 'Functional:',FName
            Write (6,*) 'Error in dF_dRho(beta)!'
            Write (6,*) 'V_a,V_n=',V_a,V_n
            Write (6,*) 'iGrid,mGrid=',iGrid,mGrid
            Write (6,*) 'Rho=',Rho(ipRa,iGrid),
     &                         Rho(ipRb,iGrid)
            Write (6,*) 'GradRho=',Rho(ipdRxa,iGrid),
     &                             Rho(ipdRya,iGrid),
     &                             Rho(ipdRza,iGrid)
            Write (6,*) '        ',Rho(ipdRxb,iGrid),
     &                             Rho(ipdRyb,iGrid),
     &                             Rho(ipdRzb,iGrid)
            Write (6,*) 'Tau=',    Rho(ipTaua,iGrid),
     &                             Rho(ipTaub,iGrid)
            Write (6,*) 'F_xc(iGrid),F_xc1(iGrid),F_xc2(iGrid)=',
     &                   F_xc(iGrid),F_xc1(iGrid),F_xc2(iGrid)
            Call Abend()
         End If
 101     Continue
      End Do
*
 100  Continue
      If (FType.eq.LDA_type) Return
*                                                                      *
************************************************************************
*                                                                      *
*    Check for grad rho (alpha)
*    What we will do is actually check the derivative wrt the norm of
*    grad rho alpha.
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipdRx,iGrid) = (One+Delta)*Rho(ipdRx,iGrid)
            Rho_Temp(ipdRy,iGrid) = (One+Delta)*Rho(ipdRy,iGrid)
            Rho_Temp(ipdRz,iGrid) = (One+Delta)*Rho(ipdRz,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipdRxa,iGrid) = (One+Delta)*Rho(ipdRxa,iGrid)
            Rho_Temp(ipdRya,iGrid) = (One+Delta)*Rho(ipdRya,iGrid)
            Rho_Temp(ipdRza,iGrid) = (One+Delta)*Rho(ipdRza,iGrid)
         End Do
      End If
      Call FZero(F_xc1,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc1,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipdRx,iGrid) = (One-Delta)*Rho(ipdRx,iGrid)
            Rho_Temp(ipdRy,iGrid) = (One-Delta)*Rho(ipdRy,iGrid)
            Rho_Temp(ipdRz,iGrid) = (One-Delta)*Rho(ipdRz,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipdRxa,iGrid) = (One-Delta)*Rho(ipdRxa,iGrid)
            Rho_Temp(ipdRya,iGrid) = (One-Delta)*Rho(ipdRya,iGrid)
            Rho_Temp(ipdRza,iGrid) = (One-Delta)*Rho(ipdRza,iGrid)
         End Do
      End If
      Call FZero(F_xc2,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc2,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipdRx,iGrid) = (One+Two*Delta)*Rho(ipdRx,iGrid)
            Rho_Temp(ipdRy,iGrid) = (One+Two*Delta)*Rho(ipdRy,iGrid)
            Rho_Temp(ipdRz,iGrid) = (One+Two*Delta)*Rho(ipdRz,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipdRxa,iGrid) = (One+Two*Delta)*Rho(ipdRxa,iGrid)
            Rho_Temp(ipdRya,iGrid) = (One+Two*Delta)*Rho(ipdRya,iGrid)
            Rho_Temp(ipdRza,iGrid) = (One+Two*Delta)*Rho(ipdRza,iGrid)
         End Do
      End If
      Call FZero(F_xc3,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc3,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipdRx,iGrid) = (One-Two*Delta)*Rho(ipdRx,iGrid)
            Rho_Temp(ipdRy,iGrid) = (One-Two*Delta)*Rho(ipdRy,iGrid)
            Rho_Temp(ipdRz,iGrid) = (One-Two*Delta)*Rho(ipdRz,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipdRxa,iGrid) = (One-Two*Delta)*Rho(ipdRxa,iGrid)
            Rho_Temp(ipdRya,iGrid) = (One-Two*Delta)*Rho(ipdRya,iGrid)
            Rho_Temp(ipdRza,iGrid) = (One-Two*Delta)*Rho(ipdRza,iGrid)
         End Do
      End If
      Call FZero(F_xc4,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc4,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      Do iGrid = 1, mGrid
         If (iSpin.eq.1) Then
            If (Tf*Rho(ipR,iGrid).lt.T_x) Go To 199
            Gaa=Rho(ipdRx,iGrid)**2
     &         +Rho(ipdRy,iGrid)**2
     &         +Rho(ipdRz,iGrid)**2
            Gaa1o2=Sqrt(Gaa)
            Gab=Gaa
            V_a=dF_dRho(ipGxx,iGrid)*Two*Gaa1o2
     &         +dF_dRho(ipGxy,iGrid)*Gab/Gaa1o2
            Delta0=Delta*Sqrt(Gaa)*Two
         Else
            If (Tf*Rho(ipRa,iGrid).lt.T_x) Go To 199
            Gaa=Rho(ipdRxa,iGrid)**2
     &         +Rho(ipdRya,iGrid)**2
     &         +Rho(ipdRza,iGrid)**2
            Gab=Rho(ipdRxa,iGrid)*Rho(ipdRxb,iGrid)
     &         +Rho(ipdRya,iGrid)*Rho(ipdRyb,iGrid)
     &         +Rho(ipdRza,iGrid)*Rho(ipdRzb,iGrid)
            Gaa1o2=Sqrt(Gaa)
            V_a=dF_dRho(ipGaa,iGrid)*Two*Gaa1o2
     &         +dF_dRho(ipGab,iGrid)*Gab/Gaa1o2
            Delta0=Delta*Sqrt(Gaa)
         End If
         Diff1=F_xc1(iGrid)-F_xc2(iGrid)
         Diff2=F_xc3(iGrid)-F_xc4(iGrid)
         V_n=(Two*Diff1-Diff2/Four)/(Three*Delta0)
         Rel_Diff=Abs((V_a-V_n)/V_n)
         If (V_a-V_n.eq.Zero) Rel_Diff=Zero
C        If (V_a.eq.Zero) Rel_Diff=Abs(V_n)
         If (Abs(V_a).lt.Thr_V_a) Rel_Diff=Abs(V_n)
         If (Rel_Diff.gt.Error) Then
            Call WarningMessage(2,'Rel_Diff.gt.Error')
            Write (6,'(A,A)') 'Functional:',FName
            Write (6,*) 'Error in dF_dgradRho(alpha)!'
            Write (6,*) 'V_a,V_n=',V_a,V_n
            Write (6,*) 'iGrid,mGrid=',iGrid,mGrid
            Write (6,*) 'Diff1,Diff2=',Diff1,Diff2
            If (iSpin.eq.1) Then
               Write (6,*) 'Rho=',Rho(ipR,iGrid)
               Write (6,*) 'GradRho=',Rho(ipdRx,iGrid),
     &                                Rho(ipdRy,iGrid),
     &                                Rho(ipdRz,iGrid)
               Write (6,*) 'Tau=',    Rho(ipTau,iGrid)
            Else
               Write (6,*) 'Rho=',Rho(ipRa,iGrid),
     &                            Rho(ipRb,iGrid)
               Write (6,*) 'GradRho=',Rho(ipdRxa,iGrid),
     &                                Rho(ipdRya,iGrid),
     &                                Rho(ipdRza,iGrid)
               Write (6,*) '        ',Rho(ipdRxb,iGrid),
     &                                Rho(ipdRyb,iGrid),
     &                                Rho(ipdRzb,iGrid)
               Write (6,*) 'Tau=',    Rho(ipTaua,iGrid),
     &                                Rho(ipTaub,iGrid)
            End If
            Call Abend()
         End If
 199     Continue
      End Do
*
      If (iSpin.eq.1) Go To 200
*                                                                      *
************************************************************************
*                                                                      *
*     Check for grad rho (beta)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipdRxb,iGrid) = (One+Delta)*Rho(ipdRxb,iGrid)
         Rho_Temp(ipdRyb,iGrid) = (One+Delta)*Rho(ipdRyb,iGrid)
         Rho_Temp(ipdRzb,iGrid) = (One+Delta)*Rho(ipdRzb,iGrid)
      End Do
      Call FZero(F_xc1,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc1,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipdRxb,iGrid) = (One-Delta)*Rho(ipdRxb,iGrid)
         Rho_Temp(ipdRyb,iGrid) = (One-Delta)*Rho(ipdRyb,iGrid)
         Rho_Temp(ipdRzb,iGrid) = (One-Delta)*Rho(ipdRzb,iGrid)
      End Do
      Call FZero(F_xc2,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc2,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipdRxb,iGrid) = (One+Two*Delta)*Rho(ipdRxb,iGrid)
         Rho_Temp(ipdRyb,iGrid) = (One+Two*Delta)*Rho(ipdRyb,iGrid)
         Rho_Temp(ipdRzb,iGrid) = (One+Two*Delta)*Rho(ipdRzb,iGrid)
      End Do
      Call FZero(F_xc3,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc3,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipdRxb,iGrid) = (One-Two*Delta)*Rho(ipdRxb,iGrid)
         Rho_Temp(ipdRyb,iGrid) = (One-Two*Delta)*Rho(ipdRyb,iGrid)
         Rho_Temp(ipdRzb,iGrid) = (One-Two*Delta)*Rho(ipdRzb,iGrid)
      End Do
      Call FZero(F_xc4,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc4,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      Do iGrid = 1, mGrid
         If (Tf*Rho(ipRa,iGrid).lt.T_x) Go To 201
         Gbb=Rho(ipdRxb,iGrid)**2
     &      +Rho(ipdRyb,iGrid)**2
     &      +Rho(ipdRzb,iGrid)**2
         Gab=Rho(ipdRxa,iGrid)*Rho(ipdRxb,iGrid)
     &      +Rho(ipdRya,iGrid)*Rho(ipdRyb,iGrid)
     &      +Rho(ipdRza,iGrid)*Rho(ipdRzb,iGrid)
         Gbb1o2=Sqrt(Gbb)
         V_a=dF_dRho(ipGbb,iGrid)*Two*Gbb1o2
     &      +dF_dRho(ipGab,iGrid)*Gab/Gbb1o2
         Delta0=Delta*Sqrt(Gbb)
         Diff1=F_xc1(iGrid)-F_xc2(iGrid)
         Diff2=F_xc3(iGrid)-F_xc4(iGrid)
         V_n=(Two*Diff1-Diff2/Four)/(Three*Delta0)
         Rel_Diff=Abs((V_a-V_n)/V_n)
         If (V_a-V_n.eq.Zero) Rel_Diff=Zero
C        If (V_a.eq.Zero) Rel_Diff=Abs(V_n)
         If (Abs(V_a).lt.Thr_V_a) Rel_Diff=Abs(V_n)
         If (Rel_Diff.gt.Error) Then
            Call WarningMessage(2,'Rel_Diff.gt.Error')
            Write (6,'(A,A)') 'Functional:',FName
            Write (6,*) 'Error in dF_dgradRho(beta)!'
            Write (6,*) 'V_a,V_n=',V_a,V_n
            Write (6,*) 'iGrid,mGrid=',iGrid,mGrid
            Write (6,*) 'Rho=',Rho(ipRa,iGrid),
     &                         Rho(ipRb,iGrid)
            Write (6,*) 'GradRho=',Rho(ipdRxa,iGrid),
     &                             Rho(ipdRya,iGrid),
     &                             Rho(ipdRza,iGrid)
            Write (6,*) '        ',Rho(ipdRxb,iGrid),
     &                             Rho(ipdRyb,iGrid),
     &                             Rho(ipdRzb,iGrid)
            Write (6,*) 'Tau=',    Rho(ipTaua,iGrid),
     &                             Rho(ipTaub,iGrid)
            Call Abend()
         End If
 201     Continue
      End Do
*
 200  Continue
      If (FType.eq.GGA_type) Return
*                                                                      *
************************************************************************
*                                                                      *
*     Check for tau (alpha)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipTau,iGrid) = (One+Delta)*Rho(ipTau,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipTaua,iGrid) = (One+Delta)*Rho(ipTaua,iGrid)
         End Do
      End If
      Call FZero(F_xc1,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc1,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipTau,iGrid) = (One-Delta)*Rho(ipTau,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipTaua,iGrid) = (One-Delta)*Rho(ipTaua,iGrid)
         End Do
      End If
      Call FZero(F_xc2,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc2,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipTau,iGrid) = (One+Two*Delta)*Rho(ipTau,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipTaua,iGrid) = (One+Two*Delta)*Rho(ipTaua,iGrid)
         End Do
      End If
      Call FZero(F_xc3,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc3,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      If (iSpin.eq.1) Then
         Do iGrid = 1, mGrid
            Rho_Temp(ipTau,iGrid) = (One-Two*Delta)*Rho(ipTau,iGrid)
         End Do
      Else
         Do iGrid = 1, mGrid
            Rho_Temp(ipTaua,iGrid) = (One-Two*Delta)*Rho(ipTaua,iGrid)
         End Do
      End If
      Call FZero(F_xc4,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc4,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      Do iGrid = 1, mGrid
         If (iSpin.eq.1) Then
            If (Tf*Rho(ipR,iGrid).lt.T_x) Go To 299
            V_a=dF_dRho(ipT,iGrid)
            Delta0=Delta*Rho(ipTau,iGrid)*Two
         Else
            If (Tf*Rho(ipRa,iGrid).lt.T_x) Go To 299
            V_a=dF_dRho(ipTa,iGrid)
            Delta0=Delta*Rho(ipTaua,iGrid)
         End If
         Diff1=F_xc1(iGrid)-F_xc2(iGrid)
         Diff2=F_xc3(iGrid)-F_xc4(iGrid)
         V_n=(Two*Diff1-Diff2/Four)/(Three*Delta0)
         Rel_Diff=Abs((V_a-V_n)/V_n)
         If (V_a-V_n.eq.Zero) Rel_Diff=Zero
C        If (V_a.eq.Zero) Rel_Diff=Abs(V_n)
         If (Abs(V_a).lt.Thr_V_a) Rel_Diff=Abs(V_n)
         If (Rel_Diff.gt.Error) Then
            Call WarningMessage(2,'Rel_Diff.gt.Error')
            Write (6,'(A,A)') 'Functional:',FName
            Write (6,*) 'Error in tau(alpha)!'
            Write (6,*) 'V_a,V_n=',V_a,V_n
            If (iSpin.eq.1) Then
               Write (6,*) 'Rho=',Rho(ipR,iGrid)
               Write (6,*) 'GradRho=',Rho(ipdRx,iGrid),
     &                                Rho(ipdRy,iGrid),
     &                                Rho(ipdRz,iGrid)
               Write (6,*) 'Tau=',    Rho(ipTau,iGrid)
            Else
               Write (6,*) 'Rho=',Rho(ipRa,iGrid),
     &                            Rho(ipRb,iGrid)
               Write (6,*) 'GradRho=',Rho(ipdRxa,iGrid),
     &                                Rho(ipdRya,iGrid),
     &                                Rho(ipdRza,iGrid)
               Write (6,*) '        ',Rho(ipdRxb,iGrid),
     &                                Rho(ipdRyb,iGrid),
     &                                Rho(ipdRzb,iGrid)
               Write (6,*) 'Tau=',    Rho(ipTaua,iGrid),
     &                                Rho(ipTaub,iGrid)
            End If
            Call Abend()
         End If
 299     Continue
      End Do
*
      If (iSpin.eq.1) Go To 300
*                                                                      *
************************************************************************
*                                                                      *
*     Check for tau (beta)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipTaub,iGrid) = (One+Delta)*Rho(ipTaub,iGrid)
      End Do
      Call FZero(F_xc1,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc1,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipTaub,iGrid) = (One-Delta)*Rho(ipTaub,iGrid)
      End Do
      Call FZero(F_xc2,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc2,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipTaub,iGrid) = (One+Two*Delta)*Rho(ipTaub,iGrid)
      End Do
      Call FZero(F_xc3,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc3,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      call dcopy_(nRho*mGrid,Rho,1,Rho_Temp,1)
      Do iGrid = 1, mGrid
         Rho_Temp(ipTaub,iGrid) = (One-Two*Delta)*Rho(ipTaub,iGrid)
      End Do
      Call FZero(F_xc4,mGrid)
      Call Kernel(mGrid,Rho_Temp,nRho,P2_ontop,
     &            nP2_ontop,iSpin,F_xc4,
     &            dF_temp,ndF_dRho,dF_dP2ontop,ndF_dP2ontop,T_X)
*
      Do iGrid = 1, mGrid
         If (Tf*Rho(ipRa,iGrid).lt.T_x) Go To 301
         V_a=dF_dRho(ipTb,iGrid)
         Delta0=Delta*Rho(ipTaub,iGrid)
         Diff1=F_xc1(iGrid)-F_xc2(iGrid)
         Diff2=F_xc3(iGrid)-F_xc4(iGrid)
         V_n=(Two*Diff1-Diff2/Four)/(Three*Delta0)
         Rel_Diff=Abs((V_a-V_n)/V_n)
         If (V_a-V_n.eq.Zero) Rel_Diff=Zero
C        If (V_a.eq.Zero) Rel_Diff=Abs(V_n)
         If (Abs(V_a).lt.Thr_V_a) Rel_Diff=Abs(V_n)
         If (Rel_Diff.gt.Error) Then
            Call WarningMessage(2,'Rel_Diff.gt.Error')
            Write (6,'(A,A)') 'Functional:',FName
            Write (6,*) 'Error in tau(beta)!'
            Write (6,*) 'V_a,V_n=',V_a,V_n
            Write (6,*) 'Rho=',Rho(ipRa,iGrid),
     &                         Rho(ipRb,iGrid)
            Write (6,*) 'GradRho=',Rho(ipdRxa,iGrid),
     &                             Rho(ipdRya,iGrid),
     &                             Rho(ipdRza,iGrid)
            Write (6,*) '        ',Rho(ipdRxb,iGrid),
     &                             Rho(ipdRyb,iGrid),
     &                             Rho(ipdRzb,iGrid)
            Write (6,*) 'Tau=',    Rho(ipTaua,iGrid),
     &                             Rho(ipTaub,iGrid)
            Call Abend()
         End If
 301     Continue
      End Do
 300  Continue
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module GuessOrb_Global

use Definitions, only: wp, iwp

implicit none
private

#include "Molcas.fh"
integer(kind=iwp), parameter :: MxBasis = 5000
real(kind=wp) :: xCharge(MxAtom), PrThr, SThr, TThr, GapThr
integer(kind=iwp) :: nSym, nBas(MxSym), nOcc(MxSym), nVir(MxSym), nDel(MxSym), nNuc, iPrFmt
character(len=LenIn) :: AtName(MxAtom)
character(len=LenIn8) :: Label(MxBasis)
logical(kind=iwp) :: PrintMOs, PrintEor, PrintPop
#ifdef _HDF5_
integer(kind=iwp) :: wfn_fileid, wfn_energy, wfn_mocoef, wfn_occnum, wfn_orbene, wfn_tpidx
#endif

public :: GapThr, iPrFmt, Label, MxAtom, MxBasis, MxSym, AtName, nBas, nDel, nNuc, nOcc, nSym, nVir, PrintEor, PrintMOs, PrintPop, &
          PrThr, SThr, TThr, xCharge
#ifdef _HDF5_
public :: wfn_energy, wfn_fileid, wfn_mocoef, wfn_occnum, wfn_orbene, wfn_tpidx
#endif

end module GuessOrb_Global

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine AOAdd_NQ(AOInt,iBas,iBas_Eff,jBas,jBas_Eff,PrpInt,nPrp,
     &                 iCmp,jCmp,iShell,jShell,iAO,jAO)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January '91                                              *
************************************************************************
      use SOAO_Info, only: iAOtSO
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 AOInt(0:iBas_Eff-1,0:jBas_Eff-1,iCmp,jCmp), PrpInt(nPrp)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      iTri(i,j)=Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************

#ifdef _DEBUGPRINT_
      Call RecPrt(' In AOAdd:AOInt',' ',AOInt,iBas_Eff*jBas_Eff,
     &            iCmp*jCmp)
      Write (6,*) 'iBas_Eff,jBas_Eff,iCmp,jCmp=',iBas_Eff,jBas_Eff,
     &            iCmp,jCmp
      Write (6,*) 'nPrp=',nPrp
#endif
*
      iAdd = iBas-iBas_Eff
      jAdd = jBas-jBas_Eff
      Do i1 = 1, iCmp
         iSO1=iAOtSO(iAO+i1,0)
*
         jjMx = jCmp
         If (iShell.eq.jShell) jjMx = i1
         Do i2 = 1, jjMx
            iSO2=iAOtSO(jAO+i2,0)
*
            Do indAO1_Eff = 0, iBas_Eff-1
               indAO1=indAO1_Eff+iAdd
               Indi = iSO1+indAO1
*
               jBsMax = jBas_Eff - 1
               If (iSO1.eq.iSO2) jBsMax=indAO1_Eff
               Do indAO2_Eff = 0, jBsMax
                  indAO2=indAO2_Eff+jAdd
                  Indj = iSO2+indAO2
#ifdef _DEBUGPRINT_
                  Write (6,*) 'iC,jC,iB,jB=',i1,i2,indAO1+1,
     &                                             indAO2+1
                  Write (6,*) 'Indi,Indj=',Indi,Indj
#endif
*
*                 Add one matrix element
*
                  PrpInt(iTri(Indi,Indj))=PrpInt(iTri(Indi,Indj))
     &                   + AOInt(indAO1_Eff,indAO2_Eff,i1,i2)
*
               End Do ! indAO2
            End Do   ! indAO1
         End Do      ! i2
      End Do         ! i1
*
#ifdef _DEBUGPRINT_
      Call GetMem(' Exit AOAdd','CHECK','REAL',iDum,iDum)
#endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine main_bdata_cvb()
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "seth_cvb.fh"
#include "spinb_cvb.fh"

      md2h(1,1)=1
      md2h(2,1)=2
      md2h(3,1)=3
      md2h(4,1)=4
      md2h(5,1)=5
      md2h(6,1)=6
      md2h(7,1)=7
      md2h(8,1)=8

      md2h(1,2)=2
      md2h(2,2)=1
      md2h(3,2)=4
      md2h(4,2)=3
      md2h(5,2)=6
      md2h(6,2)=5
      md2h(7,2)=8
      md2h(8,2)=7

      md2h(1,3)=3
      md2h(2,3)=4
      md2h(3,3)=1
      md2h(4,3)=2
      md2h(5,3)=7
      md2h(6,3)=8
      md2h(7,3)=5
      md2h(8,3)=6

      md2h(1,4)=4
      md2h(2,4)=3
      md2h(3,4)=2
      md2h(4,4)=1
      md2h(5,4)=8
      md2h(6,4)=7
      md2h(7,4)=6
      md2h(8,4)=5

      md2h(1,5)=5
      md2h(2,5)=6
      md2h(3,5)=7
      md2h(4,5)=8
      md2h(5,5)=1
      md2h(6,5)=2
      md2h(7,5)=3
      md2h(8,5)=4

      md2h(1,6)=6
      md2h(2,6)=5
      md2h(3,6)=8
      md2h(4,6)=7
      md2h(5,6)=2
      md2h(6,6)=1
      md2h(7,6)=4
      md2h(8,6)=3

      md2h(1,7)=7
      md2h(2,7)=8
      md2h(3,7)=5
      md2h(4,7)=6
      md2h(5,7)=3
      md2h(6,7)=4
      md2h(7,7)=1
      md2h(8,7)=2

      md2h(1,8)=8
      md2h(2,8)=7
      md2h(3,8)=6
      md2h(4,8)=5
      md2h(5,8)=4
      md2h(6,8)=3
      md2h(7,8)=2
      md2h(8,8)=1

      zero=0d0
      one=1.d0
      two=2d0
      onem=-1d0
      r3by4=.75d0
      p8=.8d0
      sqp5=.70710678118654752440d0
      sq2=1.41421356237309504880d0
      mxopt=500
      mxcnt=5000
      opposite=.false.
      corenrg=0d0
      spinb(1)='Kotani      '
      spinb(2)='Serber      '
      spinb(3)='Rumer       '
      spinb(4)='Rumer (LT)  '
      spinb(5)='Projected   '
      spinb(6)='Determinants'
      spinb(7)='Determinants'
      spinbkw(1)='KOTANI  '
      spinbkw(2)='SERBER  '
      spinbkw(3)='RUMER   '
      spinbkw(4)='LTRUMER '
      spinbkw(5)='PROJECT '
      spinbkw(6)='DET     '
      spinbkw(7)='DETERM  '
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function trace2(n,A,B)

use Constants, only: cZero
use Definitions, only: wp, iwp

implicit none
complex(kind=wp) :: trace2
integer(kind=iwp), intent(in) :: n
complex(kind=wp), intent(in) :: A(n,n), B(n,n)
integer(kind=iwp) :: i, k

trace2 = cZero
do i=1,n
  do k=1,n
    trace2 = trace2+A(k,i)*B(i,k)
  end do
end do

end function trace2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine EqScf(iQ_Atoms,nAtomsCC,Coord,nBas,nBas_C,nCnC_C
     &                ,iSupDeAll,iV1DeAll)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"
#include "files_qmstat.fh"
#include "qmcom.fh"
#include "qm1.fh"
#include "integral.fh"
#include "numbers.fh"
#include "WrkSpc.fh"
#include "warnings.fh"
#include "constants.fh"

      Parameter (Conver1=1.0d10*CONST_BOHR_RADIUS_IN_SI_)
      Parameter (Conver2=2.0d0*Pi/360.0d0)
*     Parameter (BoltzK=1.0d-3*CONST_BOLTZMANN_/CONV_AU_TO_KJ_)
      Dimension nBas(1),nBas_C(1),nCnC_C(MxBasC),Coord(MxAt*3)
      Dimension Eint(MxQCen,10),Poli(MxQCen,10)
      Dimension iFP(3),iGP(3),iDT(3),iFi(3),iFil(MxQCen,10)
      Dimension Smat(MxOT),Vmat(MxOT),BoMaH(MxAt),BoMaO(MxAt)
      Dimension SmatPure(MxOT)
*****Jose** Interaction with Slater type to consider Penetration
      Dimension Eint_Nuc(MxAt)
*****JoseMEP**New variables for the MEP calculation
      Dimension SumElcPot(MxQCen,10)
      Dimension PertElcInt(MxBas*(MxBas+1)/2)
      Character*4 Labjhr
*****
      Character Memlabel*20,Memlaabe*20,Memlaaab*20,MemLaaaa*20
      Character MemQFal*20,Head*200,ChCo*2,ChCo2*2
      Logical DidWeAccept,Haveri,CalledBefore,SampleThis,InCutOff
      Parameter (ExLim=10) !Over how long distance the exchange rep.
                           !is computed, the solv-solv.
      External Ranf
      Logical Exist
      Dimension Dum(1),iDum(1)

*----------------------------------------------------------------------*
* Enter.                                                               *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
* Make some conversions, initializations and zeros.                    *
*----------------------------------------------------------------------*
      BoltzK=1.0d-3*CONST_BOLTZMANN_/CONV_AU_TO_KJ_
      Ract=Rstart              !Initial radie
      delX=delX/Conver1        !angstrom-->Bohr
      delFi=delFi*Conver2      !degree-->radian
      delR=delR/Conver1        !angstrom-->Bohr
      CalledBefore=.false.
      SampleThis=.true.
      iSupDeAll=iSupM
      iV1DeAll=iV1
      If(ParallelT) nMacro=nTemp*nMacro
*
*---- If we have vacuum, then no volume-pressure work is done, nor do we
*     have any cavitation free-energy.
*
      If(abs(Diel-1).le.0.0001d0) then
        Gamma=0
        Gam=0
      Else
       If(SURF.le.0.0d0) then
        Gamma=0
        Gam=0
       Else
        Gamma=Pres*4.188790205d0*.52917d0**3*6.023d0*.00001d0
     &       *1.01325d0/627.52d0/4.184d0
        Gam=.0005973455d0/74d0*SURF
       Endif
      Endif
      If(Temp.le.0.0d0) then
        BetaBol=1.0d23
      Else
        BetaBol=1.0d0/(Temp*BoltzK)
      Endif
      DiFac=-(Diel-1)/(Diel+1)
      Expran=0
      Expre=0
      ggsum=0
      HighS=0
      corr=0
      iHowMSampUT=0
      iHowMSampIN=0
      iD=1
      Adisp=Disp(1,2)
      nBaseC=nBas_C(1)
      nBaseQ=nBas(1)
      iTri=(iOrb(1)*(iOrb(1)+1))/2
      iTriBasQ=nBaseQ*(nBaseQ+1)/2
      timeCLAS=0
      timeEX=0
      timeEL=0
      timeMC=0
*
*---- If some damping has been requested, prepare it here and print.
*
      If((Dispdamp.or.FieldDamp).and.iPrint.ge.8) then
        Write(6,*)
        Write(6,*)'-----Various damping data.'
        Write(6,*)
      Endif
      If(Dispdamp) then
*
*---- Construct the Born-Mayer parameters, a la Brdarski-Karlstrom
*
        Call BornMayerBK(iQ_Atoms,BoMaH,BoMaO)
      Endif

      If(Fielddamp) then
        if(iPrint.ge.8) then
          Write(6,*)'  Damping the field between Qm-region and solvent.'
          Write(6,*)'  E_damp=E_0*(1-exp(alpha*distance))^N'
          Write(6,*)'  alpha(QM-oxygen)   =',CAFieldG
          Write(6,*)'  alpha(QM-hydrogen) =',CBFieldG
          Write(6,*)'  N                  =',CFexp
        endif
      Endif
*--------------------------------------------------------------------------*
* Check what to run - equilibration or production - and say something      *
* beautiful to the user.                                                   *
*--------------------------------------------------------------------------*
      If(Qmeq.and.iRead.ne.9) then
        Call NiceOutPut('EIQ',Gam,Gamma,BetaBol)
      Elseif(QmProd.and.iRead.ne.9) then
        Call NiceOutPut('PIQ',Gam,Gamma,BetaBol)
        Call DaName(iLuSaUt,SaFilUt)
        iDisk=0 !Put some dummy on the sampfile so we have space for
                !the real number later.
        Call iDaFile(iLuSaUt,1,[iHowMSampUT],1,iDisk)
        !Below we make a check for extreme cases. Our algorithm to
        !select sampling configurations sets this limit.
        iProdMax=(2**30-1)*2
        If((nMacro*nMicro).ge.iProdMax) then
          Write(6,*)
          Write(6,*)'WARNING! Too large numbers for nMacro and nMicro t'
     &//'o run production!'
          Write(6,*)'   Their product must not be greater than 2**31!'
          Write(6,*)'   If you wish to make such large samples, you can'
     &//' run several samplings and collect several sampfiles.'
          Call Quit(_RC_INTERNAL_ERROR_)
        Endif
      Elseif(iRead.eq.9) then !If we read from sampfile: open the
                           !sampfile and read how many configurations
                           !and open extract file.
        Call NiceOutPut('SSS',Gam,Gamma,BetaBol)
        Call DaName(iLuSaIn,SaFilIn)
        iDiskSa=0
        Call iDaFile(iLuSaIn,2,iDum,1,iDiskSa)
        iHowMSampIN=iDum(1)
        iLuExtr=54
        iLuExtr=IsFreeUnit(iLuExtr)
        Call OpnFl(SimEx,iLuExtr,Exist)
        Write(iLuExtr,*)'Extract-File'
        Write(iLuExtr,*)
        !And put some words in the output
        Write(6,*)
        Write(6,*)'   Total number of sampled configurations:'
     &           ,iHowMSampIN
        Write(6,*)'   Reading from the file ',SaFilIn
        Write(6,*)'   Summarizing data put on ',SimEx
******JoseMEP
      ! If we perform MEP calculation, first we make some zeros
      ! and allocate some memory.
        If(lExtr(8)) then
          Do 1001, ijhr=1,MxQCen
            Do 1002, jjhr=1,10
               SumElcPot(ijhr,jjhr)=0.0d0
               AvElcPot(ijhr,jjhr)=0.0d0
1002        Continue
1001      Continue
          NCountField=0

          iTriMaxBasQ=MxBas*(MxBas+1)/2
          call dcopy_(iTriMaxBasQ,[ZERO],iZERO,PertNElcInt,iONE)
c          write(6,*)'ipAOSum',ipAOSum
          Call GetMem('SumOvlAOQ','Allo','Real',ipAOSum,iTriBasQ)
          call dcopy_(iTriBasQ,[ZERO],iZERO,Work(ipAOSum),iONE)
c          write(6,*)'ipAOSum',ipAOSum
        Endif
**********
      Else
        Write(6,*)
        Write(6,*)'Error 1 in classical subroutine.'
        Call Quit(_RC_INTERNAL_ERROR_)
      Endif
*----------------------------------------------------------------------*
* If we have input file, then read from it.                            *
*----------------------------------------------------------------------*
      iCStart=(((iQ_Atoms-1)/nAtom)+1)*nCent+1
      iCNum=(iCStart-1)/nCent
      i9=0
58886 Continue
      i9=i9+1
      If(iRead.le.8.and.iRead.ge.6) then
        Call Get8(Ract,Dum(1))
      Elseif(iRead.eq.9) then
        Call Get9(Ract,Coord,info_atom,iQ_Atoms,iDiskSa)
      Else
        If(iExtra.gt.0) then
          Call NyPart(iExtra,nPart,Cordst,Rstart,nCent,iSeed)
        Endif
        If(iPrint.ge.10) then
          Write(Head,*)'Coordinates of the initial distribution.'
          Call Cooout(Head,Cordst,nPart,nCent)
        Endif
      Endif
*
*---- Give a startvalue for the Total energy. The effect is that we
*     always accept the first microstep.
*
      Etot=1D+10
*----------------------------------------------------------------------*
* Compute som numbers to simplify the handling of indeces.             *
*----------------------------------------------------------------------*
      ncpart=Ncent*nPart
      ncParm=ncPart-(nCent*icNum)
      nClas=nPart-iCNum
      indma=npart*npol
      iGG=nPart*nPol
      iCi=(iQ_Atoms*(iQ_Atoms+1))/2
*----------------------------------------------------------------------*
* Substitue classical waters for quantum molecule.                     *
*----------------------------------------------------------------------*
      If(iRead.eq.8.or.iRead.eq.0) then
        Call PlaceIt(Coord,iQ_Atoms,iCNum)
      Elseif(iRead.eq.6) then
        Call PlaceIt9(Coord,Cordst,info_atom,iQ_Atoms)
        If(iPrint.ge.10) then
          Write(Head,*)'CM-centred coordinates after substitution.'
          Call Cooout(Head,Cordst,nPart,nCent)
        Endif
      Endif
*----------------------------------------------------------------------*
*                                                                      *
*------------------------- START SIMULATION ---------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      iSnurr=0  !How many steps taken totally.
      nSiffiB=0  !A number for blocking.
*
*---- The Macrosteps.
*
      Do 2000, iMacro=1,nMacro
        Esav=0.0d0
        If(iRead.eq.9) then
          iAcc=1
        Else
          iAcc=0
        Endif

*------ If we are running parallel tempering, then...
        If(ParallelT) Call ParaRoot(Ract,BetaBol,Etot,CalledBefore
     &                             ,SampleThis)

*
*------ The Microsteps.
*
        Do 2001, iMicro=1,nMicro
          Call Timing(Cpu1,Tim1,Tim2,Tim3)
          Eold=Etot
          iSnurr=iSnurr+1
*
*-------- Generate new configuration, both solvent and QM-region.
*
          Call GeoGen(Ract,Rold,iCNum,iQ_Atoms)
*
*-------- Compute Solvent-solvent interaction.
*
          Call ClasClas(iCNum,iCStart,ncParm,Coord,iFP,iGP,iDT,iFI,iDist
     &                 ,iDistIm,Elene,Edisp,Exrep,E2Die,ExDie)
          Call QMPosition(EHam,Cordst,Coord,Forcek,dLJrep,Ract,iQ_Atoms)
          Call Timing(Cpu2,Tim1,Tim2,Tim3)
          timeCLAS=timeCLAS+(Cpu2-Cpu1)
*--------------------------------------------------------------------------*
* Work a bit with the quantum part.                                        *
*--------------------------------------------------------------------------*
          Do 4002, i=1,3
            xyzMyQ(i)=0  !Dipoles for the QM-part, see polink.f.
            xyzMyI(i)=0
4002      Continue
          nSize=3*nPol*nPart
          Do 400, i=1,iCi  !Allocate memory for the field on the QM-mol.
            Do 4000, j=1,10 !iCi: number of quantum molecule sites.
              Write(MemQFal,'(A,i2.2,i2.2)')'Falt',i,j
              Call GetMem(MemQFal,'Allo','Real',iFil(i,j),nSize)
4000        Continue
400       Continue
          Do 401, i=1,iCi
            Do 402, j=1,10 !Charges (1),Dipoles(3),Quadrupoles(6)
              Do 403, k=1,nPart*nPol !Classical polarisation sites
                                     !including quantum molecule.
                Work(iFil(i,j)-1+k)=0.0d0
                Work(iFil(i,j)-1+k+nPart*nPol)=0.0d0
                Work(iFil(i,j)-1+k+2*nPart*nPol)=0.0d0
403           Continue
              Eint(i,j)=0.0d0
402         Continue
          If (i.le.MxAt) Eint_Nuc(i)=0.0d0
401       Continue
*
*-------- Compute the exchange operator.
*
          Call ExScf(iCStart,nBaseQ,nBaseC,nCnC_C,iQ_Atoms
     &              ,nAtomsCC,Ax,Ay,Az,iTri,Smat,SmatPure,InCutOff
     &              ,ipAOSum)
          Call Timing(Cpu3,Tim1,Tim2,Tim3)
          timeEX=timeEX+(Cpu3-Cpu2)

*
*---- Electrostatics, anfangen bitte.
*
*
*-------- Compute various gradients of 1/r.
*
          If(lSlater) then
            Call OneOverR_Sl(iFil,Ax,Ay,Az,BoMaH,BoMaO,EEDisp
     &                      ,iCNum,Eint,iQ_Atoms,outxyz
     &                      ,Eint_Nuc)
          Else
            Call OneOverR(iFil,Ax,Ay,Az,BoMaH,BoMaO,EEDisp
     &                   ,iCNum,Eint,iQ_Atoms,outxyz)
          Endif

*
*-- Couple the pair-part of the electrostatics with QM-region.
*
          Call Hel(Eint,iTri,iCi,Cha,DipMy,Quad,Vmat,iprint)

*
*-- Polarize system.
*
          Call PolScf(iDist,iDistIm,iDT,iFI,iFP,iFil,iCStart,iTri
     &               ,VMat,Smat,DiFac,Ract,icnum,energy,NVarv
     &               ,iMOC,Haveri,iQ_Atoms,ip_ExpVal,Poli)

*
*----- Energy from QM-nuclei interacting with solvent field.
*
          If(lSlater) then
            Do 702, i=1,iQ_Atoms
              Energy=Energy-Eint_Nuc(i)*ChaNuc(i)
702         Continue
          Else
            Do 703, i=1,iQ_Atoms
              Energy=Energy-Eint(i,1)*ChaNuc(i)
703         Continue
          Endif

*
*----- Some additional boost of short-range repulsion.
*
          Call BoostRep(AddRep,SmatPure,iMOC,iOrb(1),InCutOff)

*
*----- Sum-up what we will call QM-region energy.
*
          Energy=Energy-EEdisp+AddRep

*----------------------------------------------------------------------*
* Final induction and reaction field energies.                         *
*----------------------------------------------------------------------*
          Call ReaInd(iGP,iDT,iDistIm,iCNum,IndMa,NcParm,Sum1,s90um)
          Call Timing(Cpu4,Tim1,Tim2,Tim3)
          timeEL=timeEL+(Cpu4-Cpu3)
*----------------------------------------------------------------------*
* Construct the final energy.                                          *
*----------------------------------------------------------------------*
          EnCLAS=Elene+EHam-Edisp+Exrep+E2Die+ExDie
          Etot=EnCLAS-0.5*S90um-Sum1+Gamma*Ract**3+Energy+Gam*Ract**2
          Dele=Etot-Eold
*--------------------------------------------------------------------------*
* Printing and various if requsted.                                        *
*--------------------------------------------------------------------------*
          If(iPrint.ge.10) then
            If(Haveri) Etot=999999
            Write(6,*)
            Write(6,*)'   ----Microstep',iMicro
            Write(6,*)'         Number of iterations:',nVarv
            Write(6,*)'         Total energy:',Etot
            Write(6,*)'         Of which is'
            Write(6,*)'            Pairwise solvent-solvent '
     &//'interaction:',EnCLAS
            Write(6,*)'              Solvent-solvent Electrostatic'
     &,Elene
            Write(6,*)'              Harmonic Spring:',EHam
            Write(6,*)'              Solvent-solvent Dispersion:',-Edisp
            Write(6,*)'              Solvent-solvent Exchange:',Exrep
            Write(6,*)'            Energy of induced dipoles in field f'
     &//'rom explicit solvent:',-Sum1
            Write(6,*)'            Energy of solvent charge distributio'
     &//'n in reaction field:',-0.5*S90um
            Write(6,*)'            Solvent E-interaction with image:'
     &,E2Die
            Write(6,*)'            Solvent Repulsion with boundary:'
     &,ExDie
            Write(6,*)'            Solvent-Solute dispersion:',EEdisp
            Write(6,*)'            Energy of QM-region:',Energy
            Write(6,*)'              Higher order overlap exchange pair'
     &//'-term:',AddRep
            Write(6,*)'            Surface tension term:',Gam*Ract**2
            Write(6,*)'            Volume-pressure term:',Gamma*Ract**3
            Write(6,*)'         Previous accepted energy:',Eold
            Write(6,*)'         Difference:',Dele
            Write(6,*)'         Total dipole in QM-region:(',-xyzMyQ(1),
     &',',-xyzMyQ(2),',',-xyzMyQ(3),')'
            Write(6,*)'         Radie:',Ract
            If(Haveri) then
              Write(6,*)'    WARNING! SOME OF THE NUMBERS ABOVE HAVE NO'
     &//' MEANING SINCE THE POLARIZATION DID NOT CONVERGE!!!'
              GoTo 8194
            Endif
          Endif

*
*-- If we are collecting stuff from a sampfile, now is the time to put
*   data on the extract file. For centre specific stuff, call good-old
*   Allen for them.
*
          If(iRead.eq.9) then
            If(lExtr(6)) then
              E_Nuc_Rubbet=0.0d0
              If(lSlater) then
                Do 6347, iAt=1,iQ_Atoms
                  E_Nuc_Rubbet=E_Nuc_Rubbet
     &                  -(Eint_Nuc(iAt)+Poli(iAt,1))*ChaNuc(iAt)
6347            Continue
              Else
                Do 6348, iAt=1,iQ_Atoms
                  E_Nuc_Rubbet=E_Nuc_Rubbet
     &                  -(Eint(iAt,1)+Poli(iAt,1))*ChaNuc(iAt)
6348            Continue
              Endif
            Endif
            If(lExtr(7)) then
              Call AllenGinsberg('SCF  ',Eint,Poli,ChaNuc,Cha,DipMy
     &                          ,Quad,MxOT,iMOC,iOrb(1),iExtr_Atm
     &                          ,.false.,iOcc1,iQ_Atoms
     &                          ,ip_ExpCento,E_Nuc_Part,lSlater
     &                          ,Eint_Nuc)

            Endif
            Call Extract(iLuExtr,i9,Etot,xyzMyQ,FockM,iMOC,iDt,iOrb(1)
     &                  ,Dum,xyzQuQ,ip_ExpVal,ip_ExpCento
     &                  ,E_Nuc_Rubbet,E_Nuc_Part)
****JoseMEP**********
      ! If MEP option. Add electr. potential, field, etc for
      ! all solvent config.
            If(lExtr(8)) then
              Labjhr='Add '
              Call AverMEP(Labjhr,Eint,Poli,iCi,SumElcPot
     &                     ,NCountField,PertElcInt
     &                     ,iONE,iONE,[iONE],[iONE],iONE)
              NCountField=NCountField+1
            Endif
*********
            GoTo 9090
          Endif
*----------------------------------------------------------------------*
* Resume the MC-wrap up.                                               *
*----------------------------------------------------------------------*
          Dele=Dele*BetaBol
          DidWeAccept=.true.
          If(Dele.lt.0) then
            iAcc=iAcc+1
          Else
            Expe=Exp(-Dele)
            Expran=ranf(iseed)
            If(iPrint.ge.10) then
              Write(6,*)'         Positive energy change!'
              Write(6,*)'         Boltzmann weight:',Expe
              Write(6,*)'         Random number:',ExpRan
            Endif
            iAcc=iAcc+1
            If(Expe.lt.ExpRan) then
              Call Oldge(iAcc,Etot,Eold,Ract,Rold)
              DidWeAccept=.false.
              If(iPrint.ge.10) then
                Write(6,*)'         Not accepted!'
              Endif
            Endif
          Endif
          If(DidWeAccept)Esav=Esav+Etot
*----------------------------------------------------------------------*
* If this is a production run, then put stuff on the sampfile.         *
*----------------------------------------------------------------------*
          If(QmProd) then !<-- Are we producing.
            If(SampleThis) then !<-- Should we sample this (relevant
                                !when paralleltempering is used).
              If(Inter.ne.0) then
                Inte=(iSnurr/Inter)*Inter
                If(Inte.eq.((iMacro-1)*nMicro+iMicro)) then
                  Call Put9(Etot,Ract,iDT,iHowMSampUT,Gamma,Gam,Esav
     &                     ,iDisk)
                Endif
              Endif
            Endif
          Endif
*--------------------------------------------------------------------------*
* Free memory.                                                             *
*--------------------------------------------------------------------------*
9090      Continue
          iOrba=iOrb(1)
          nSize=(nClas*(nClas-1)/2)*(nCent**2)
          nSizeIm=(nClas*nCent)**2
          Call GetMem('DistMat','Free','Real',iDist,nSize)
          Call GetMem('DistMatIm','Free','Real',iDistIm,nSizeIm)
          IndMa=nPol*nPart
          Do 90001,i=1,3
            Write(ChCo,'(I1.1)')i
            Write(MemLabel,*)'FP'//ChCo
            Write(MemLaabe,*)'GP'//ChCo
            Write(MemLaaab,*)'DT'//ChCo
            Write(MemLaaaa,*)'FI'//ChCo
            Call GetMem(MemLabel,'Free','Real',iFP(i),IndMa)
            Call GetMem(MemLaabe,'Free','Real',iGP(i),IndMa)
            Call GetMem(MemLaaab,'Free','Real',iDT(i),IndMa)
            Call GetMem(MemLaaaa,'Free','Real',iFI(i),IndMa)
90001     Continue
          nSize=3*nPol*nPart
          Do 90002, i=1,iCi
            Do 90003, j=1,10
              Write(ChCo,'(I2.2)')i
              Write(ChCo2,'(I2.2)')j
              Write(MemQFal,*)'Falt'//ChCo//ChCo2
              Call GetMem(MemQFal,'Free','Real',iFil(i,j),nSize)
90003       Continue
90002     Continue
          Call GetMem('Coeff','Free','Real',iMOC,iOrba**2)
          Call Timing(Cpu5,Tim1,Tim2,Tim3)
          timeMC=timeMC+(Cpu5-Cpu4)
*--------------------------------------------------------------------------*
* End of Microstep.                                                        *
*--------------------------------------------------------------------------*
2001    Continue
*----------------------------------------------------------------------*
* Have we collected all sampled configurations? If no, go up again.    *
* If yes, then close some files and take a little jump downwards to    *
* the END!!!                                                           *
*----------------------------------------------------------------------*
*Jose***************************************
* This point is also used to perform the Average of the Potential,
* Field and Field gradients to obtain and average Electrostatic
* perturbation. The Non-Electr. perturbation is also obtained here
* it will be added directly to the One-electron file.
*******************************************

        If(i9.lt.iHowMSampIN.and.iRead.eq.9) then
          GoTo 58886
        Elseif(i9.ge.iHowMSampIN.and.iRead.eq.9) then
******JoseMEP**
      ! If MEP option. Obtain the mean Potential, Field
      ! and Field Gradients.
      ! It si also obtained the average of the Non-Electrostatic
      ! perturbation
          If(lExtr(8)) then
              Labjhr='Aver'
              Call AverMEP(Labjhr,Eint,Poli,iCi,SumElcPot
     &                     ,NCountField,PertElcInt
     &                     ,iONE,iONE,[iONE],[iONE],iONE)
*
              AverFact=1.0d0/Dble(NCountField)
              Call DaxPy_(iTriBasQ,AverFact,Work(ipAOSum),iONE
     &                   ,PertNElcInt,iONE)
              Call GetMem('SumOvlAOQ','Free','Real',ipAOSum,iTriBasQ)
          Endif
*********
          Call DaClos(iLuSaIn)
          Close(iLuExtr)
          GoTo 58887
        Endif
*----------------------------------------------------------------------*
* Write to startfile.                                                  *
*----------------------------------------------------------------------*
8194    Continue
        ESav=Esav/Dble(iAcc)
        Call Put8(Ract,Etot,Gamma,Gam,Esav)
        If(Haveri) Call Quit(_RC_NOT_CONVERGED_)
*----------------------------------------------------------------------*
* Print some things here at the end of the macrostep.                  *
*----------------------------------------------------------------------*
        If(.not.ParallelT) then
          jMacro=iMacro
        Else
          jMacro=1+(iMacro-1)/nTemp
        Endif
        Write(6,'(A,i4)')'---Macrostep ',jMacro
        Write(6,'(A,i4)')'     Number of microsteps:',nMicro
        Pr=100.0d0*(Dble(iAcc)/Dble(nMicro))
        Write(6,'(A,i4,A,f5.1,A)')'     Number of acceptances:',iAcc,'('
     &                          ,Pr,'%)'
        Write(6,'(A,f12.4)')'     Radie (a.u.):',Ract
        Write(6,'(A,f16.8)')'     Average Energy (a.u.) in Macrostep:'
     &                     ,Esav
        Write(6,'(A,3(f12.4))')'     Total dipole in QM-region last mic'
     &//'rostep (a.u.):',-xyzMyQ(1),-xyzMyQ(2),-xyzMyQ(3)
        Write(6,*)
        Call xFlush(6)
*--------------------------------------------------------------------------*
* End of Macrostep.                                                        *
*--------------------------------------------------------------------------*
2000  Continue
*----------------------------------------------------------------------*
* Put some things on info-file. Used to make tests.                    *
*----------------------------------------------------------------------*
      Call Add_Info('Total Energy',[Etot],1,6)
      Call Add_Info('Induction of system',[Sum1],1,6)
      Call Add_Info('React. field int.',[s90um],1,6)
      Call Add_Info('Solv-Solu Disp.',[EEdisp],1,6)
      Call Add_Info('QM-region Energy',[Energy],1,6)
      Call Add_Info('QM-region dipole',xyzMyQ,3,5)
*----------------------------------------------------------------------*
* Close some external files.                                           *
*----------------------------------------------------------------------*
58887 Continue
      If(QmProd.and.iRead.ne.9) then
        iDisk=0
        Call iDaFile(iLuSaUt,1,[iHowMSampUT],1,iDisk)
        Call DaClos(iLuSaUt)
      Endif
*--------------------------------------------------------------------------*
* The End... be happy!                                                     *
*--------------------------------------------------------------------------*
      Write(6,*)
      Write(6,*)
      Write(6,*)' Time statistics. (hour:minute:second)'
      Write(6,*)' -----------------------------------------------------'
      it1h=int(timeCLAS)/3600
      it1m=int(timeCLAS-it1h*3600)/60
      t1s=timeCLAS-it1h*3600-it1m*60
      Write(6,8)'   Time spent on pair-wise solvent-solvent interaction'
     &//'s: ',it1h,':',it1m,':',t1s
      it2h=int(timeEX)/3600
      it2m=int(timeEX-it2h*3600)/60
      t2s=timeEX-it2h*3600-it2m*60
      Write(6,8)'   Time spent on solvent-solute overlap calculations: '
     &,it2h,':',it2m,':',t2s
      it3h=int(timeEL)/3600
      it3m=int(timeEL-it3h*3600)/60
      t3s=timeEL-it3h*3600-it3m*60
      Write(6,8)'   Time spent on solvent and solute electrostatic inte'
     &//'raction: ',it3h,':',it3m,':',t3s
      it4h=int(timeMC)/3600
      it4m=int(timeMC-it4h*3600)/60
      t4s=timeMC-it4h*3600-it4m*60
      Write(6,8)'   Time spent on the Metropolis-Monte Carlo decision: '
     &,it4h,':',it4m,':',t4s
8     Format(A,I4,A,I3,A,F5.2)

      Return
      End


*--------------------------------------------------------------------------*
* A small internal subroutine to compute the Nemo exchange repulsion.      *
*--------------------------------------------------------------------------*
      Real*8 Function ExNemo(i,j,a)
      Implicit Real*8 (a-h,o-z)
#include "maxi.fh"
#include "qminp.fh"
      Real*8 a
      Integer i,j
*The function
      ExNemo=Exp(-Sexrep(i,j)/a)*Sexre1(i,j)+Sexre2(i,j)*(a**20)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DeDe_Mck(FD,nFD,ipOffD,nOffD,DDen,lDDen,mDeDe,mIndij)

use k2_arrays, only: MaxDe
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nFD, nOffD, lDDen
real(kind=wp), intent(in) :: FD(nFD)
integer(kind=iwp), intent(out) :: ipOffD(3,nOffD), mDeDe, mIndij
real(kind=wp), intent(out) :: DDen(lDDen)
integer(kind=iwp) :: ipD00, ipDeDe, nr_of_Densities
logical(kind=iwp) :: DFT_Storage, Special_NoSym

Special_NoSym = .false.
DFT_Storage = .false.
nr_of_Densities = 1

ipDeDe = 1
ipD00 = 1
! ipDijS is controlled in the calling routine
call mk_DeDe(FD,nFD,nr_of_Densities,ipOffD,nOffD,ipDeDe,ipD00,MaxDe,mDeDe,mIndij,Special_NoSym,DFT_Storage,DDen,lDDen)

return

end subroutine DeDe_Mck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine StPert()

use Index_Functions, only: nTri_Elem
use MckDat, only: sNew
use ipPage, only: ipin, W
use MCLR_Data, only: FAMO_SpinM, FAMO_SpinP, Fm, FnMck, Fp, G1m, G1p, G2mm, G2mp, G2pp, Hss, ipCI, lDisp, LuMck, MS2, nDens, &
                     rBetaA, rBetaS, RMS, SwLbl
use input_mclr, only: McKinley, nAsh, nBas, nDisp, nIsh, nSym, nTPert, PT2, SpinPol, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: idum(1), iDummer, iOpt, iRC, iS, nAct, nG, nG2, nHss, nMax
real(kind=wp) :: rAlphas
character(len=288) :: Header
character(len=16) :: Label
character(len=8) :: MckLbl
real(kind=wp), allocatable :: Tmp1(:), Tmp2(:)

nHss = 0
do iS=1,nSym
  nHss = nHss+nTri_Elem(lDisp(is))
end do
call mma_allocate(Hss,nHss,Label='Hss')
Hss(:) = Zero

if (.not. Mckinley) then
  irc = -1
  iopt = ibset(0,sNew)
  call OPNMCK(irc,iopt,FNMCK,LUMCK)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error opening MCKINT'
    call Abend()
  end if
  irc = -1
  iopt = 0
  LABEL = 'SEWARD'
  if (PT2) LABEL = 'PT2LAG'
  MckLbl = 'PERT'
  call cWrMck(iRC,iOpt,MckLbl,1,LABEL,iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
  irc = -1
  iopt = 0
  MckLbl = 'NDISP'
  idum(1) = ndisp
  call WrMck(iRC,iOpt,MckLbl,1,idum,iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
  irc = -1
  iopt = 0
  MckLbl = 'TDISP'
  call WrMck(iRC,iOpt,MckLbl,1,ntpert,iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
  irc = -1
  iopt = 0
  MckLbl = 'Title'
  call cWrMck(iRC,iOpt,MckLbl,1,Header,iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
  irc = -1
  iopt = 0
  MckLbl = 'nSym'
  idum(1) = nSym
  call WrMck(iRC,iOpt,MckLbl,1,idum,iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
  irc = -1
  iopt = 0
  MckLbl = 'nBas'
  call WrMck(iRC,iOpt,MckLbl,1,nBas,iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
  irc = -1
  iopt = 0
  MckLbl = 'ldisp'
  call WrMck(iRC,iOpt,MckLbl,1,ldisp,iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
  irc = -1
  iopt = 0
  MckLbl = 'chdisp'
  call cWrMck(iRC,iOpt,MckLbl,1,swlbl(1),iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
  irc = -1
  iopt = 0
  MckLbl = 'NISH'
  call WrMck(iRC,iOpt,MckLbl,1,nish,iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
  irc = -1
  iopt = 0
  MckLbl = 'NASH'
  call WrMck(iRC,iOpt,MckLbl,1,nash,iDummer)
  if (irc /= 0) then
    write(u6,*) 'StPert: Error writing to MCKINT'
    write(u6,'(A,A)') 'MckLbl=',MckLbl
    call Abend()
  end if
end if

if (SPINPOL) then
  call coeff(ralphas,rbetaa,rbetas)
  rms = real(ms2,kind=wp)*Half
  nAct = sum(nAsh(1:nSym))
  nG = nAct**2
  nG2 = nAct**4
  call mma_allocate(famo_spinp,nDens,Label='famo_spinp')
  call mma_allocate(famo_spinm,nDens,Label='famo_spinm')
  call mma_allocate(G2mp,nG2,Label='G2mp')
  call mma_allocate(G2pp,nG2,Label='G2pp')
  call mma_allocate(G2mm,nG2,Label='G2mm')
  call mma_allocate(Fm,nG2,Label='Fm')
  call mma_allocate(Fp,nG2,Label='Fp')
  call mma_allocate(G1p,nG,Label='G1p')
  call mma_allocate(G1m,nG,Label='G1m')
  call ipin(ipCI)
  call SpinDens(W(ipCI)%A,W(ipCI)%A,STATE_SYM,STATE_SYM,G2mm,G2mp,G2pp,Fm,Fp,G1m,G1p,2)

  call mma_allocate(Tmp2,nDens,Label='Tmp2')
  call mma_MaxDBLE(nMax)
  call mma_allocate(Tmp1,nMax/2,Label='Tmp1')

  call Ex_spin(G1p,FAMO_Spinp,Tmp1,nMax/2,Tmp2)
  call Ex_spin(G1m,FAMO_Spinm,Tmp1,nMax/2,Tmp2)

  call mma_deallocate(Tmp1)
  call mma_deallocate(Tmp2)
end if

end subroutine StPert

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine ddinit_cvb(method,nparm1,nfrdim1,maxd1,mxit1,
     >  ifollow1,isaddle1,ip1,corenrg1,n_div1)
      implicit real*8 (a-h,o-z)
      character*(*) method
#include "direct_cvb.fh"

c  Input parameters:
      nparm=nparm1
      nfrdim=nfrdim1
      maxd=maxd1
      mxit=mxit1
      ifollow=ifollow1
      isaddle=isaddle1
      nroot=max(1,isaddle1+1)
      ip=ip1
      corenrg=corenrg1
      n_div=n_div1
c  Defaults:
      resthr=1d-5
c  Local DIRDIAG parameters:
      orththr=1d-10
      nortiter=50

      if(method.eq.'AxEx')then
        mxrhs=0
        ivrhs=0
c  Arrays:  C       AxC     RES
c           AP      SOLP    SOLP_RES
        idd(1) = mstackr_cvb(nparm*maxd)
        idd(2) = mstackr_cvb(nparm*maxd)
        idd(3) = mstackr_cvb(nparm)
        idd(4) = mstackr_cvb(maxd*maxd)
        idd(5) = mstackr_cvb(maxd)
        idd(6) = mstackr_cvb(maxd)
      elseif(method.eq.'AxESx')then
        mxrhs=0
        ivrhs=0
c  Arrays:  C       AxC     SxC     RES
c           AP      SOLP    SOLP_RES
        idd(1) = mstackr_cvb(nparm*maxd)
        idd(2) = mstackr_cvb(nparm*maxd)
        idd(3) = mstackr_cvb(nparm*maxd)
        idd(4) = mstackr_cvb(nparm)
        idd(5) = mstackr_cvb(maxd*maxd)
        idd(6) = mstackr_cvb(maxd)
        idd(7) = mstackr_cvb(maxd)
      elseif(method.eq.'Axb')then
        mxrhs=1
        ivrhs=4
c  Arrays:  C       SxC     RES     RHS
c           RHSP    SOLP    SOLP_RES
        idd(1) = mstackr_cvb(nparm*maxd)
        idd(2) = mstackr_cvb(nparm*maxd)
        idd(3) = mstackr_cvb(nparm)
        idd(4) = mstackr_cvb(nparm)
        idd(5) = mstackr_cvb(maxd)
        idd(6) = mstackr_cvb(maxd)
        idd(7) = mstackr_cvb(maxd)
      elseif(method.eq.'AxExb')then
        mxrhs=1
        ivrhs=4
c  Arrays:  C       AxC     RES     RHS
c           AP      RHSP    SOLP    SOLP_RES
        idd(1) = mstackr_cvb(nparm*maxd)
        idd(2) = mstackr_cvb(nparm*maxd)
        idd(3) = mstackr_cvb(nparm)
        idd(4) = mstackr_cvb(nparm)
        idd(5) = mstackr_cvb(maxd*maxd)
        idd(6) = mstackr_cvb(maxd)
        idd(7) = mstackr_cvb(maxd)
        idd(8) = mstackr_cvb(maxd)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               2019, Ignacio Fdez. Galvan                             *
************************************************************************
      SubRoutine Util5(Beta,nZeta,Final,la,lb,Slalbp,Slalbm)
************************************************************************
*                                                                      *
* Object: to assemble the velocity quadrupole integrals from the       *
*         derivative integrals and dipole integrals.                   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             February '91                                             *
*     Adapted from util2: Ignacio Fdez. Galvan, July 2019              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8  Final (nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,6),
     &        Slalbp(nZeta,(la+1)*(la+2)/2,(lb+2)*(lb+3)/2,3),
     &        Slalbm(nZeta,(la+1)*(la+2)/2, lb   *(lb+1)/2,3),
     &        Beta(nZeta)
      Character*80 Label
*
*     Statement function for cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
      nElem(ix) = (ix+1)*(ix+2)/2
*
      iRout = 211
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
          Write (6,*) ' In Util5 la,lb=',la,lb
          Call RecPrt('Beta',' ',Beta,nZeta,1)
          Do 100 ia = 1, nElem(la)
             Do 200 ib = 1, nElem(lb+1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbp(',ia,',',ib,'x)'
                Call RecPrt(Label,' ',Slalbp(1,ia,ib,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbp(',ia,',',ib,'y)'
                Call RecPrt(Label,' ',Slalbp(1,ia,ib,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                 ' Slalbp(',ia,',',ib,'z)'
                Call RecPrt(Label,' ',Slalbp(1,ia,ib,3),nZeta,1)
 200         Continue
 100      Continue
          If (lb.gt.0) Then
             Do 101 ia = 1, nElem(la)
                Do 201 ib = 1, nElem(lb-1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Slalbm(',ia,',',ib,'x)'
                   Call RecPrt(Label,' ',Slalbm(1,ia,ib,1),nZeta,1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Slalbm(',ia,',',ib,'y)'
                   Call RecPrt(Label,' ',Slalbm(1,ia,ib,2),nZeta,1)
                   Write (Label,'(A,I2,A,I2,A)')
     &                    ' Slalbm(',ia,',',ib,'z)'
                   Call RecPrt(Label,' ',Slalbm(1,ia,ib,3),nZeta,1)
 201            Continue
 101         Continue
          End If
      End If
*
      Do 10 ixa = la, 0, -1
         Do 11 iya = la-ixa, 0, -1
            iza = la-ixa-iya
            ipa = Ind(la,ixa,iza)
*
      Do 20 ixb = lb, 0, -1
         Do 21 iyb = lb-ixb, 0, -1
            izb = lb-ixb-iyb
            ipb = Ind(lb,ixb,izb)
*
            Do 30 iZeta = 1, nZeta
               Final(iZeta,ipa,ipb,1) = Two*Beta(iZeta)*
     &            Two*Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),1)
               Final(iZeta,ipa,ipb,2) = Two*Beta(iZeta)*
     &            (Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb)  ,1)+
     &             Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),2))
               Final(iZeta,ipa,ipb,3) = Two*Beta(iZeta)*
     &            (Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),1)+
     &             Slalbp(iZeta,ipa,Ind(lb+1,ixb+1,izb),3))
               Final(iZeta,ipa,ipb,4) = Two*Beta(iZeta)*
     &            Two*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb)  ,2)
               Final(iZeta,ipa,ipb,5) = Two*Beta(iZeta)*
     &            (Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),2)+
     &             Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb)  ,3))
               Final(iZeta,ipa,ipb,6) = Two*Beta(iZeta)*
     &            Two*Slalbp(iZeta,ipa,Ind(lb+1,ixb,izb+1),3)
 30         Continue
*
            If (ixb.gt.0) Then
               Do 31 iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,1) = Final(iZeta,ipa,ipb,1)
     &                -Dble(ixb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),1)
     &                 *Two
                  Final(iZeta,ipa,ipb,2) = Final(iZeta,ipa,ipb,2)
     &                -Dble(ixb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),2)
                  Final(iZeta,ipa,ipb,3) = Final(iZeta,ipa,ipb,3)
     &                -Dble(ixb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb-1,izb),3)
 31            Continue
            End If
*
            If (iyb.gt.0) Then
               Do 32 iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,2) = Final(iZeta,ipa,ipb,2)
     &                -Dble(iyb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb)  ,1)
                  Final(iZeta,ipa,ipb,4) = Final(iZeta,ipa,ipb,4)
     &                -Dble(iyb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb)  ,2)
     &                 *Two
                  Final(iZeta,ipa,ipb,5) = Final(iZeta,ipa,ipb,5)
     &                -Dble(iyb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb)  ,3)
 32            Continue
            End If
*
            If (izb.gt.0) Then
               Do 33 iZeta = 1, nZeta
                  Final(iZeta,ipa,ipb,3) = Final(iZeta,ipa,ipb,3)
     &                -Dble(izb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),1)
                  Final(iZeta,ipa,ipb,5) = Final(iZeta,ipa,ipb,5)
     &                -Dble(izb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),2)
                  Final(iZeta,ipa,ipb,6) = Final(iZeta,ipa,ipb,6)
     &                -Dble(izb)*Slalbm(iZeta,ipa,Ind(lb-1,ixb,izb-1),3)
     &                 *Two
 33            Continue
            End If
*
 21      Continue
 20   Continue
*
 11      Continue
 10   Continue
*
      If (iPrint.ge.49) Then
          Write (6,*) ' In Util5 la,lb=',la,lb
          Do 300 iElem = 1, nElem(la)
             Do 310 jElem = 1, nElem(lb)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',xx) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,1),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',xy) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,2),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',xz) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,3),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',yy) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,4),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',yz) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,5),nZeta,1)
                Write (Label,'(A,I2,A,I2,A)')
     &                ' Final (',iElem,',',jElem,',zz) '
                Call RecPrt(Label,' ',Final(1,iElem,jElem,6),nZeta,1)
 310         Continue
 300      Continue
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C#define _DEBUGPRINT_
C======================================================================C
C This file collects the subroutines and functions used to get info    C
C from the LDF common blocks.                                          C
C======================================================================C
C >>> Logical Function LDF_With2CF()
      Logical Function LDF_With2CF()
      Implicit None
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomPairInfoIsSet
      External LDF_AtomPairInfoIsSet
#endif
      Integer iAtomPair
      Integer i
      Integer n2CFunctions
      n2CFunctions(i)=iWork(ip_AP_2CFunctions+2*(i-1))
#if defined (_DEBUGPRINT_)
      If (.not.LDF_AtomPairInfoIsSet()) Then
         Call WarningMessage(2,'LDF_With2CF: atom pair info unset!')
         Call LDF_Quit(1)
      End If
#endif
      LDF_With2CF=.False.
      iAtomPair=0
      Do While (iAtomPair.lt.NumberOfAtomPairs .and. .not.LDF_With2CF)
         iAtomPair=iAtomPair+1
         LDF_With2CF=n2CFunctions(iAtomPair).gt.0
      End Do
      End
************************************************************************
C >>> Integer Function LDF_UniqueAtomPair(iAtomPair)
      Integer Function LDF_UniqueAtomPair(iAtomPair)
      Implicit None
      Integer iAtomPair
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomPairInfoIsSet
      External LDF_AtomPairInfoIsSet
      Integer  LDF_nAtomPair
      External LDF_nAtomPair
      If (.not.LDF_AtomPairInfoIsSet()) Then
         Call WarningMessage(2,'LDF_UniqueAtomPair: info not set!')
         Call LDF_Quit(1)
      End If
      If (iAtomPair.lt.1 .or. iAtomPair.gt.LDF_nAtomPair()) Then
         Call WarningMessage(2,
     &                   'LDF_UniqueAtomPair: iAtomPair out of bounds!')
         Call LDF_Quit(1)
      End If
#endif
      LDF_UniqueAtomPair=iWork(ip_AP_Unique-1+iAtomPair)
      End
************************************************************************
C >>> Integer Function LDF_UniqueAtom(iAtom)
      Integer Function LDF_UniqueAtom(iAtom)
      Implicit None
      Integer iAtom
#include "ldf_atom_info.fh"
#include "WrkSpc.fh"
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomInfoIsSet
      External LDF_AtomInfoIsSet
      Integer  LDF_nAtom
      External LDF_nAtom
      If (.not.LDF_AtomInfoIsSet()) Then
         Call WarningMessage(2,'LDF_UniqueAtom: info not set!')
         Call LDF_Quit(1)
      End If
      If (iAtom.lt.1 .or. iAtom.gt.LDF_nAtom()) Then
         Call WarningMessage(2,'LDF_UniqueAtom: iAtom out of bounds!')
         Call LDF_Quit(1)
      End If
#endif
      LDF_UniqueAtom=iWork(ip_A_Unique-1+iAtom)
      End
************************************************************************
C >>> Integer Function LDF_nUniqueAtomPair()
      Integer Function LDF_nUniqueAtomPair()
      Implicit None
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"
      Integer iAtomPair
      Integer AP2UAP, i
      AP2UAP(i)=iWork(ip_AP_Unique-1+i)
      LDF_nUniqueAtomPair=0
      Do iAtomPair=1,NumberOfAtomPairs
         If (AP2UAP(iAtomPair).eq.iAtomPair)
     &      LDF_nUniqueAtomPair=LDF_nUniqueAtomPair+1
      End Do
      End
************************************************************************
C >>> Integer Function LDF_nUniqueAtom()
      Integer Function LDF_nUniqueAtom()
      Implicit None
#include "ldf_atom_info.fh"
#include "WrkSpc.fh"
      Integer iAtom
      Integer A2UA, i
      A2UA(i)=iWork(ip_A_Unique-1+i)
      LDF_nUniqueAtom=0
      Do iAtom=1,NumberOfAtoms
         If (A2UA(iAtom).eq.iAtom) LDF_nUniqueAtom=LDF_nUniqueAtom+1
      End Do
      End
************************************************************************
C >>> Integer Function LDF_NumberOfValenceShellsOnAtom(iAtom)
      Integer Function LDF_NumberOfValenceShellsOnAtom(iAtom)
      Implicit None
      Integer iAtom
#include "ldf_atom_info.fh"
#include "WrkSpc.fh"
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomInfoIsSet
      External LDF_AtomInfoIsSet

      If (.not.LDF_AtomInfoIsSet()) Then
         Call SysAbendMsg('LDF_NumberOfValenceShellsOnAtom',
     &                    'LDF Atom Info is not defined!',
     &                    'Unable to proceed')
      End If
      If (iAtom.lt.1 .or. iAtom.gt.NumberOfAtoms) Then
         Call SysAbendMsg('LDF_NumberOfValenceShellsOnAtom',
     &                    'Input variable iAtom out of bounds',
     &                    'iAtom < 1 or iAtom > NumberOfAtoms')
      End If
#endif
      LDF_NumberOfValenceShellsOnAtom=iWork(ip_A_Shells+2*(iAtom-1))
      End
************************************************************************
C >>> Integer Function LDF_nShell_Atom(iAtom)
      Integer Function LDF_nShell_Atom(iAtom)
      Implicit None
      Integer iAtom
      Integer LDF_NumberOfValenceShellsOnAtom
      LDF_nShell_Atom=LDF_NumberOfValenceShellsOnAtom(iAtom)
      End
************************************************************************
C >>> Integer Function LDF_NumberOfAuxiliaryShellsOnAtom(iAtom)
      Integer Function LDF_NumberOfAuxiliaryShellsOnAtom(iAtom)
      Implicit None
      Integer iAtom
#include "ldf_atom_info.fh"
#include "WrkSpc.fh"
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomInfoIsSet
      External LDF_AtomInfoIsSet

      If (.not.LDF_AtomInfoIsSet()) Then
         Call SysAbendMsg('LDF_NumberOfAuxiliaryShellsOnAtom',
     &                    'LDF Atom Info is not defined!',
     &                    'Unable to proceed')
      End If
      If (iAtom.lt.1 .or. iAtom.gt.NumberOfAtoms) Then
         Call SysAbendMsg('LDF_NumberOfAuxiliaryShellsOnAtom',
     &                    'Input variable iAtom out of bounds!',
     &                    'iAtom < 1 or iAtom > NumberOfAtoms')
      End If
#endif
      LDF_NumberOfAuxiliaryShellsOnAtom=iWork(ip_A_AuxShells
     &                                        +2*(iAtom-1))
      End
************************************************************************
C >>> Integer Function LDF_nAuxShell_Atom(iAtom)
      Integer Function LDF_nAuxShell_Atom(iAtom)
      Implicit None
      Integer iAtom
      Integer LDF_NumberOfAuxiliaryShellsOnAtom
      LDF_nAuxShell_Atom=LDF_NumberOfAuxiliaryShellsOnAtom(iAtom)
      End
************************************************************************
C >>> Integer Function LDF_NumberOfAtoms()
      Integer Function LDF_NumberOfAtoms()
      Implicit None
#include "ldf_atom_info.fh"
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomInfoIsSet
      External LDF_AtomInfoIsSet

      If (.not.LDF_AtomInfoIsSet()) Then
         Call SysAbendMsg('LDF_NumberOfAtoms',
     &                    'LDF Atom Info is not defined!',
     &                    'Unable to proceed')
      End If
      If (NumberOfAtoms.lt.1) Then
         Call SysAbendMsg('LDF_NumberOfAtoms',
     &                    'Number of atoms zero or negative!',
     &                    'Unable to proceed')
      End If
#endif
      LDF_NumberOfAtoms=NumberOfAtoms
      End
************************************************************************
C >>> Integer Function LDF_nAtom()
      Integer Function LDF_nAtom()
      Implicit None
      Integer LDF_NumberOfAtoms
      LDF_nAtom=LDF_NumberOfAtoms()
      End
************************************************************************
C >>> Integer Function LDF_nShell()
      Integer Function LDF_nShell()
      Implicit None
#include "localdf_bas.fh"
      LDF_nShell=nShell_Valence
      End
************************************************************************
C >>> Integer Function LDF_nBasSh(iShell)
      Integer Function LDF_nBasSh(iShell)
      Implicit None
      Integer iShell
#include "localdf_bas.fh"
#include "WrkSpc.fh"
#if defined (_DEBUGPRINT_)
      If (iShell.lt.1 .or.
     &    iShell.gt.(nShell_Valence+nShell_Auxiliary+1)) Then
         Call WarningMessage(2,'LDF_nBasSh_Atom: iAtom out of bounds')
         Call LDF_Quit(1)
      End If
#endif
      LDF_nBasSh=iWork(ip_nBasSh-1+iShell)
      End
************************************************************************
C >>> Integer Function LDF_nBasSh_Atom(iShell,iAtom)
      Integer Function LDF_nBasSh_Atom(iShell,iAtom)
      Implicit None
      Integer iShell, iAtom
#include "WrkSpc.fh"
      Integer jShell
      Integer  LDF_lShell_Atom, LDF_nBasSh
      External LDF_lShell_Atom, LDF_nBasSh
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomInfoIsSet
      External LDF_AtomInfoIsSet
      Integer  LDF_nAtom, LDF_nShell_Atom
      External LDF_nAtom, LDF_nShell_Atom
      If (.not.LDF_AtomInfoIsSet()) Then
         Call WarningMessage(2,'LDF_nBasSh_Atom: LDF Atom Info not set')
         Call LDF_Quit(1)
      End If
      If (iAtom.lt.1 .or. iAtom.gt.LDF_nAtom()) Then
         Call WarningMessage(2,'LDF_nBasSh_Atom: iAtom out of bounds')
         Call LDF_Quit(1)
      End If
      If (iShell.lt.1 .or. iShell.gt.LDF_nShell_Atom(iAtom)) Then
         Call WarningMessage(2,'LDF_nBasSh_Atom: iShell out of bounds')
         Call LDF_Quit(1)
      End If
#endif
      jShell=iWork(LDF_lShell_Atom(iAtom)-1+iShell)
      LDF_nBasSh_Atom=LDF_nBasSh(jShell)
      End
************************************************************************
C >>> Integer Function LDF_nBasAuxSh_Atom(iAuxShell,iAtom)
      Integer Function LDF_nBasAuxSh_Atom(iAuxShell,iAtom)
      Implicit None
      Integer iAuxShell, iAtom
#include "WrkSpc.fh"
#include "localdf_bas.fh"
      Integer jAuxShell
      Integer  LDF_lAuxShell_Atom
      External LDF_lAuxShell_Atom
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomInfoIsSet
      External LDF_AtomInfoIsSet
      Integer  LDF_nAtom, LDF_nAuxShell_Atom
      External LDF_nAtom, LDF_nAuxShell_Atom
#endif
      Integer i
      Integer nBasSh
      nBasSh(i)=iWork(ip_nBasSh-1+i)
#if defined (_DEBUGPRINT_)
      If (.not.LDF_AtomInfoIsSet()) Then
         Call SysWarnMsg('LDF_nBasAuxSh_Atom',
     &                      'LDF Atom Info not set!',
     &                      '')
         Call LDF_Quit(1)
      End If
      If (iAtom.lt.1 .or. iAtom.gt.LDF_nAtom()) Then
         Call SysWarnMsg('LDF_nBasAuxSh_Atom',
     &                      'iAtom out of bounds!',
     &                      'iAtom<1 or iAtom>nAtom')
         Call LDF_Quit(1)
      End If
      If (iAuxShell.lt.1 .or.
     &    iAuxShell.gt.LDF_nAuxShell_Atom(iAtom)) Then
         Call SysWarnMsg('LDF_nBasAuxSh_Atom',
     &                      'iAuxShell out of bounds!',
     &                      'iAuxShell<1 or iAuxShell>nAuxShell_Atom')
         Call LDF_Quit(1)
      End If
#endif
      jAuxShell=iWork(LDF_lAuxShell_Atom(iAtom)+iAuxShell-1)
      LDF_nBasAuxSh_Atom=nBasSh(jAuxShell)
      End
************************************************************************
C >>> Integer Function LDF_nBasAux_Pair(iAtomPair)
      Integer Function LDF_nBasAux_Pair(iAtomPair)
      Implicit None
      Integer iAtomPair
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"
      Integer iAtom, jAtom
      Integer  LDF_nBasAux_Atom
      External LDF_nBasAux_Atom
#if defined (_DEBUGPRINT_)
      Integer  nAtom
      Integer  LDF_nAtom
      External LDF_nAtom
      Logical  LDF_AtomPairInfoIsSet
      External LDF_AtomPairInfoIsSet
#endif
      Integer i, j
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
#if defined (_DEBUGPRINT_)
      If (.not.LDF_AtomPairInfoIsSet()) Then
         Call WarningMessage(2,
     &                      'LDF_nBasAux_Pair: Atom Pair Info not set!')
         Call LDF_Quit(1)
      End If
      If (iAtomPair.lt.1 .or. iAtomPair.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,
     &                    'LDF_nBasAux_Pair: iAtomPair out of bounds')
         Call LDF_Quit(1)
      End If
#endif
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)
#if defined (_DEBUGPRINT_)
      nAtom=LDF_nAtom()
      If (iAtom.lt.1 .or. iAtom.gt.nAtom .or.
     &    jAtom.lt.1 .or. jAtom.gt.nAtom) Then
         Call WarningMessage(2,
     &                    'LDF_nBasAux_Pair: iAtom/jAtom out of bounds')
         Call LDF_Quit(1)
      End If
#endif
      LDF_nBasAux_Pair=LDF_nBasAux_Atom(iAtom)
      If (jAtom.ne.iAtom) Then
         LDF_nBasAux_Pair=LDF_nBasAux_Pair+LDF_nBasAux_Atom(jAtom)
      End If
      LDF_nBasAux_Pair=LDF_nBasAux_Pair-AP_1CLinDep(1,iAtomPair)
      LDF_nBasAux_Pair=LDF_nBasAux_Pair+AP_2CFunctions(1,iAtomPair)
      End
************************************************************************
C >>> Integer Function LDF_nBasAux_Pair_wLD(iAtomPair)
      Integer Function LDF_nBasAux_Pair_wLD(iAtomPair)
      Implicit None
      Integer iAtomPair
      Integer LDF_nBasAux_Pair_WithLinDep
      LDF_nBasAux_Pair_wLD=LDF_nBasAux_Pair_WithLinDep(iAtomPair)
      End
************************************************************************
C >>> Integer Function LDF_nBasAux_Pair_WithLinDep(iAtomPair)
      Integer Function LDF_nBasAux_Pair_WithLinDep(iAtomPair)
      Implicit None
      Integer iAtomPair
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"
      Integer iAtom, jAtom
      Integer  LDF_nBasAux_Atom
      External LDF_nBasAux_Atom
#if defined (_DEBUGPRINT_)
      Integer  nAtom
      Integer  LDF_nAtom
      External LDF_nAtom
      Logical  LDF_AtomPairInfoIsSet
      External LDF_AtomPairInfoIsSet
#endif
      Integer i, j
      Integer AP_Atoms
      Integer AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
#if defined (_DEBUGPRINT_)
      If (.not.LDF_AtomPairInfoIsSet()) Then
         Call WarningMessage(2,
     &           'LDF_nBasAux_Pair_WithLinDep: Atom Pair Info not set!')
         Call LDF_Quit(1)
      End If
      If (iAtomPair.lt.1 .or. iAtomPair.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,
     &           'LDF_nBasAux_Pair_WithLinDep: iAtomPair out of bounds')
         Call LDF_Quit(1)
      End If
#endif
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)
#if defined (_DEBUGPRINT_)
      nAtom=LDF_nAtom()
      If (iAtom.lt.1 .or. iAtom.gt.nAtom .or.
     &    jAtom.lt.1 .or. jAtom.gt.nAtom) Then
         Call WarningMessage(2,
     &         'LDF_nBasAux_Pair_WithLinDep: iAtom/jAtom out of bounds')
         Call LDF_Quit(1)
      End If
#endif
      LDF_nBasAux_Pair_WithLinDep=LDF_nBasAux_Atom(iAtom)
      If (jAtom.ne.iAtom) Then
         LDF_nBasAux_Pair_WithLinDep=LDF_nBasAux_Pair_WithLinDep
     &                              +LDF_nBasAux_Atom(jAtom)
      End If
      LDF_nBasAux_Pair_WithLinDep=LDF_nBasAux_Pair_WithLinDep
     &                           +AP_2CFunctions(1,iAtomPair)
      End
************************************************************************
C >>> Integer Function LDF_nBasAux_Atom(iAtom)
      Integer Function LDF_nBasAux_Atom(iAtom)
      Implicit None
      Integer iAtom
      Integer i
      Integer  LDF_nAuxShell_Atom, LDF_nBasAuxSh_Atom
      External LDF_nAuxShell_Atom, LDF_nBasAuxSh_Atom
#if defined (_DEBUGPRINT_)
      Integer  LDF_nAtom
      External LDF_nAtom
      If (iAtom.lt.1 .or. iAtom.gt.LDF_nAtom()) Then
         Call WarningMessage(2,'LDF_nBasAux_Atom: iAtom out of bounds')
         Call LDF_Quit(1)
      End If
#endif
      LDF_nBasAux_Atom=0
      Do i=1,LDF_nAuxShell_Atom(iAtom)
         LDF_nBasAux_Atom=LDF_nBasAux_Atom+LDF_nBasAuxSh_Atom(i,iAtom)
      End Do
      End
************************************************************************
C >>> Integer Function LDF_nBas_Atom(iAtom)
      Integer Function LDF_nBas_Atom(iAtom)
      Implicit None
      Integer iAtom
      Integer i
      Integer  LDF_nShell_Atom, LDF_nBasSh_Atom
      External LDF_nShell_Atom, LDF_nBasSh_Atom
#if defined (_DEBUGPRINT_)
      Integer  LDF_nAtom
      External LDF_nAtom
      If (iAtom.lt.1 .or. iAtom.gt.LDF_nAtom()) Then
         Call WarningMessage(2,'LDF_nBas_Atom: iAtom out of bounds')
         Call LDF_Quit(1)
      End If
#endif
      LDF_nBas_Atom=0
      Do i=1,LDF_nShell_Atom(iAtom)
         LDF_nBas_Atom=LDF_nBas_Atom+LDF_nBasSh_Atom(i,iAtom)
      End Do
      End
************************************************************************
C >>> Integer Function LDF_nAuxShell()
      Integer Function LDF_nAuxShell()
      Implicit None
#include "localdf_bas.fh"
      LDF_nAuxShell=nShell_Auxiliary
      End
************************************************************************
C >>> Integer Function LDF_nAtomPair()
      Integer Function LDF_nAtomPair()
      Implicit None
#include "ldf_atom_pair_info.fh"
      LDF_nAtomPair=NumberOfAtomPairs
      End
************************************************************************
C >>> Integer Function LDF_ListOfValenceShellsOnAtom(iAtom)
      Integer Function LDF_ListOfValenceShellsOnAtom(iAtom)
      Implicit None
      Integer iAtom
#include "ldf_atom_info.fh"
#include "WrkSpc.fh"
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomInfoIsSet
      External LDF_AtomInfoIsSet
      If (.not.LDF_AtomInfoIsSet()) Then
         Call SysAbendMsg('LDF_ListOfValenceShellsOnAtom',
     &                    'LDF Atom Info is not defined!',
     &                    'Unable to proceed')
      End If
      If (iAtom.lt.1 .or. iAtom.gt.NumberOfAtoms) Then
         Call SysAbendMsg('LDF_ListOfValenceShellsOnAtom',
     &                    'Input variable iAtom out of bounds',
     &                    'iAtom < 1 or iAtom > NumberOfAtoms')
      End If
#endif
      LDF_ListOfValenceShellsOnAtom=iWork(ip_A_Shells+2*(iAtom-1)+1)
      End
************************************************************************
C >>> Integer Function LDF_lShell_Atom(iAtom)
      Integer Function LDF_lShell_Atom(iAtom)
      Implicit None
      Integer iAtom
      Integer LDF_ListOfValenceShellsOnAtom
      LDF_lShell_Atom=LDF_ListOfValenceShellsOnAtom(iAtom)
      End
************************************************************************
C >>> Integer Function LDF_ListOfAuxiliaryShellsOnAtom(iAtom)
      Integer Function LDF_ListOfAuxiliaryShellsOnAtom(iAtom)
      Implicit None
      Integer iAtom
#include "ldf_atom_info.fh"
#include "WrkSpc.fh"
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomInfoIsSet
      External LDF_AtomInfoIsSet
      If (.not.LDF_AtomInfoIsSet()) Then
         Call SysAbendMsg('LDF_NumberOfAuxiliaryShellsOnAtom',
     &                    'LDF Atom Info is not defined!',
     &                    'Unable to proceed')
      End If
      If (iAtom.lt.1 .or. iAtom.gt.NumberOfAtoms) Then
         Call SysAbendMsg('LDF_ListOfAuxiliaryShellsOnAtom',
     &                    'Input variable iAtom out of bounds!',
     &                    'iAtom < 1 or iAtom > NumberOfAtoms')
      End If
#endif
      LDF_ListOfAuxiliaryShellsOnAtom=iWork(ip_A_AuxShells+2*(iAtom-1)
     &                                      +1)
      End
************************************************************************
C >>> Integer Function LDF_lAuxShell_Atom(iAtom)
      Integer Function LDF_lAuxShell_Atom(iAtom)
      Implicit None
      Integer iAtom
      Integer LDF_ListOfAuxiliaryShellsOnAtom
      LDF_lAuxShell_Atom=LDF_ListOfAuxiliaryShellsOnAtom(iAtom)
      End
************************************************************************
C >>> Integer Function LDF_DiskAddressOfC(iAtomPair)
      Integer Function LDF_DiskAddressOfC(iAtomPair)
C Note: returns -1 if fitting coefficients are not available on disk.
      Implicit None
      Integer iAtomPair
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomPairInfoIsSet
      External LDF_AtomPairInfoIsSet
      If (.not.LDF_AtomPairInfoIsSet()) Then
         Call WarningMessage(2,'LDF_DiskAddressOfC: info not set')
         Call LDF_Quit(1)
      End If
      If (iAtomPair.lt.1 .or. iAtomPair.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,
     &                    'LDF_DiskAddressOfC: iAtomPair out of bounds')
         Call LDF_Quit(1)
      End If
#endif
      LDF_DiskAddressOfC=iWork(ip_AP_DiskC-1+iAtomPair)
      End
************************************************************************
C >>> Integer Function LDF_Coord_Atom(iAtom)
      Integer Function LDF_Coord_Atom(iAtom)
      Implicit None
      Integer iAtom
#include "ldf_atom_info.fh"
#if defined (_DEBUGPRINT_)
      If (l_Coord.lt.1) Then
         Call WarningMessage(2,'LDF_Coord_Atom: Info not set!')
         Call LDF_Quit(1)
      End If
      If (iAtom.lt.1 .or. iAtom.gt.NumberOfAtoms) Then
         Call WarningMessage(2,'LDF_Coord_Atom: iAtom out of bounds!')
         Call LDF_Quit(1)
      End If
#endif
      LDF_Coord_Atom=ip_Coord+3*(iAtom-1)
      End
************************************************************************
C >>> Integer Function LDF_AtomWithCoordinates(R)
      Integer Function LDF_AtomWithCoordinates(R)
      Implicit None
      Real*8 R(3)
#include "ldf_atom_info.fh"
#include "WrkSpc.fh"
      Integer iAtom, ip_i
      Real*8  d
      Integer  LDF_Coord_Atom
      External LDF_Coord_Atom
#if defined (_DEBUGPRINT_)
      If (l_Coord.lt.1) Then
         Call WarningMessage(2,
     &             'LDF_AtomWithCoordinates: LDF Atom Info is not set!')
         Call LDF_Quit(1)
      End If
#endif
      LDF_AtomWithCoordinates=0
      Do iAtom=1,NumberOfAtoms
         ip_i=LDF_Coord_Atom(iAtom)
         d=sqrt((Work(ip_i)-R(1))**2
     &         +(Work(ip_i+1)-R(2))**2
     &         +(Work(ip_i+2)-R(3))**2)
         If (d.lt.1.0d-12) Then
            LDF_AtomWithCoordinates=iAtom
            Return
         End If
      End Do
      End
************************************************************************
C >>> Logical Function LDF_AtomPairInfoIsSet()
      Logical Function LDF_AtomPairInfoIsSet()
      Implicit None
#include "ldf_atom_pair_info.fh"
      LDF_AtomPairInfoIsSet=
     &                   LDF_AtomPairInfo_Status.eq.LDF_AtomPairInfo_Set
      End
************************************************************************
C >>> Logical Function LDF_AtomPairInfoIsUnset()
      Logical Function LDF_AtomPairInfoIsUnset()
      Implicit None
#include "ldf_atom_pair_info.fh"
      LDF_AtomPairInfoIsUnset=
     &                 LDF_AtomPairInfo_Status.eq.LDF_AtomPairInfo_Unset
      End
************************************************************************
C >>> Integer Function LDF_AtomPair_DiagDim(iAtomPair)
      Integer Function LDF_AtomPair_DiagDim(iAtomPair)
      Implicit None
      Integer iAtomPair
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"
      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom
#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomPairInfoIsSet
      External LDF_AtomPairInfoIsSet
#endif
      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
#if defined (_DEBUGPRINT_)
      If (.not.LDF_AtomPairInfoIsSet()) Then
         Call WarningMessage(2,
     &                 'LDF_AtomPair_DiagDim: Atom Pair Info not set!')
         Call LDF_Quit(1)
      End If
      If (iAtomPair.lt.1 .or. iAtomPair.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,
     &                 'LDF_AtomPair_DiagDim: iAtomPair out of bounds!')
         Call LDF_Quit(1)
      End If
#endif
      LDF_AtomPair_DiagDim=LDF_nBas_Atom(AP_Atoms(1,iAtomPair))
     &                    *LDF_nBas_Atom(AP_Atoms(2,iAtomPair))
      End
************************************************************************
C >>> Logical Function LDF_AtomInfoIsSet()
      Logical Function LDF_AtomInfoIsSet()
      Implicit None
#include "ldf_atom_info.fh"
      LDF_AtomInfoIsSet=LDF_AtomInfo_Status.eq.LDF_AtomInfo_Set
      End
************************************************************************
C >>> Logical Function LDF_AtomInfoIsUnset()
      Logical Function LDF_AtomInfoIsUnset()
      Implicit None
#include "ldf_atom_info.fh"
      LDF_AtomInfoIsUnset=LDF_AtomInfo_Status.eq.LDF_AtomInfo_Unset
      End
************************************************************************
C >>> Real*8 Function LDF_AtomicDistance(iAtom,jAtom)
      Real*8 Function LDF_AtomicDistance(iAtom,jAtom)
      Implicit None
      Integer iAtom, jAtom
#include "WrkSpc.fh"
      Integer  LDF_Coord_Atom
      External LDF_Coord_Atom
      Integer ip_i, ip_j
      ip_i=LDF_Coord_Atom(iAtom)
      ip_j=LDF_Coord_Atom(jAtom)
      LDF_AtomicDistance=sqrt((Work(ip_i)-Work(ip_j))**2
     &                       +(Work(ip_i+1)-Work(ip_j+1))**2
     &                       +(Work(ip_i+2)-Work(ip_j+2))**2)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagFro4(NBSQT,iSym0,iSymI,iSymJ,iSymK,iSymL0,DPT2AO,DPT2CAO,FPT2AO,FPT2CAO,WRK1)

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use CHOVEC_IO, only: NVLOC_CHOBATCH
use Cholesky, only: InfVec, nDimRS, nnBstR
use ChoCASPT2, only: MXNVC, NCHSPC, NUMCHO_PT2
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, King
#endif
use caspt2_module, only: NBAS, NBTCHES, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NBSQT, iSym0, iSymI, iSymJ, iSymK, iSymL0
real(kind=wp), intent(inout) :: DPT2AO(NBSQT), DPT2CAO(NBSQT)
real(kind=wp), intent(out) :: FPT2AO(NBSQT), FPT2CAO(NBSQT), WRK1(NBSQT)
integer(kind=iwp) :: i, IBATCH, IBATCH_TOT, ILOC, ipVecL, ipWRK(8), IRC, iSkip(8), iSMax, ISTLT(8), ISTSQ(8), iSwap, iSym, iSymIJ, &
                     iSymL, iVec, j, JNUM, JRED, JRED1, JRED2, JREDC, JREDL, JSTART, jSym, JV1, JV2, JVEC1, jVref, lscr, MUSED, &
                     nB, nB2, nB3, nBasI, nBasIJ, nBasJ, nBasK, nBasKL, nBasL, NBATCH, NUMV, NVECS_RED
real(kind=wp) :: tmp
real(kind=wp), allocatable :: CHSPC(:), WRK2(:)
#include "warnings.h"

!! It shoudl be zero, but just in case
FPT2AO(1:NBSQT) = Zero
FPT2CAO(1:NBSQT) = Zero

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  !! To broadcast DPT2AO and DPT2CAO
  if (.not. King()) then
    DPT2AO(1:NBSQT) = Zero
    DPT2CAO(1:NBSQT) = Zero
  end if
  call GADGOP(DPT2AO,NBSQT,'+')
  call GADGOP(DPT2CAO,NBSQT,'+')
end if
#endif

iSym = iSym0

ISTSQ(1) = 0
ISTLT(1) = 0
do jSym=2,nSym
  nB = nBas(jSym-1)
  nB2 = nB**2
  nB3 = nTri_Elem(nB)
  ISTSQ(jSym) = ISTSQ(jSym-1)+nB2
  ISTLT(jSym) = ISTLT(jSym-1)+nB3
end do
iSkip(1:nSym) = 1
ipWRK(1:nSym) = 1

nBasI = nBas(iSymI)
nBasJ = nBas(iSymJ)
iSymIJ = Mul(iSymI,iSymJ)
nBasIJ = nBasI*nBasJ
if (iSymI == iSymJ) nBasIJ = nTri_Elem(nBasI)
if (nBasIJ == 0) return

nBasK = nBas(iSymK)
iSMax = iSymK
if (iSymK == iSymI) iSMax = iSymJ
iSymL = Mul(iSymIJ,iSymK)
if (iSymL > iSMax) return !! should not
nBasL = nBas(iSymL0)
nBasKL = nBasK*nBasL
if (iSymK == iSymL0) nBasKL = nTri_Elem(nBasK)
if (nBasKL == 0) return

call mma_allocate(CHSPC,NCHSPC,Label='CHSPC')
call mma_allocate(WRK2,NBSQT,Label='WRK2')

IBATCH_TOT = NBTCHES(iSym)

if (NUMCHO_PT2(iSym) == 0) return

!ipnt = ip_InfVec+MaxVec_PT2*(1+InfVec_N2_PT2*(iSym-1))
!JRED1 = iWork(ipnt)
!JRED2 = iWork(ipnt-1+NumCho_PT2(iSym))
JRED1 = InfVec(1,2,iSym)
JRED2 = InfVec(NumCho_PT2(iSym),2,iSym)
!write(u6,*) 'jred1,jred2 = ',jred1,jred2

! Loop over JRED
do JRED=JRED1,JRED2

  call Cho_X_nVecRS(JRED,iSym,JSTART,NVECS_RED)
  if (NVECS_RED == 0) cycle

  ILOC = 3
  call CHO_X_SETRED(IRC,ILOC,JRED)
  ! For a reduced set, the structure is known, including
  ! the mapping between reduced index and basis set pairs.
  ! The reduced set is divided into suitable batches.
  ! First vector is JSTART. Nr of vectors in r.s. is NVECS_RED.
  !JEND = JSTART+NVECS_RED-1

  ! Determine batch length for this reduced set.
  ! Make sure to use the same formula as in the creation of disk
  ! address tables, etc, above:
  NBATCH = 1+(NVECS_RED-1)/MXNVC

  ! Loop over IBATCH
  JV1 = JSTART
  do IBATCH=1,NBATCH
    IBATCH_TOT = IBATCH_TOT+1

    JNUM = NVLOC_CHOBATCH(IBATCH_TOT)
    JV2 = JV1+JNUM-1

    JREDC = JRED
    ! Read a batch of reduced vectors
    call CHO_VECRD(CHSPC,NCHSPC,JV1,JV2,iSym,NUMV,JREDC,MUSED)

    if (NUMV /= JNUM) then
      write(u6,*) ' Rats! CHO_VECRD was called, assuming it to'
      write(u6,*) ' read JNUM vectors. Instead it returned NUMV'
      write(u6,*) ' vectors: JNUM, NUMV=',JNUM,NUMV
      write(u6,*) ' Back to the drawing board?'
      call QUIT(_RC_INTERNAL_ERROR_)
    end if
    if (JREDC /= JRED) then
      write(u6,*) ' Rats! It was assumed that the Cholesky vectors'
      write(u6,*) ' in HALFTRNSF all belonged to a given reduced'
      write(u6,*) ' set, but they don''t!'
      write(u6,*) ' JRED, JREDC:',JRED,JREDC
      write(u6,*) ' Back to the drawing board?'
      write(u6,*) ' Let the program continue and see what happens.'
    end if

    ipVecL = 1
    do iVec=1,NUMV
      !! (strange) reduced form -> squared AO vector (mu nu|iVec)
      jVref = 1 !! only for iSwap=1
      !lscr = nTri_Elem(nBasI)
      !if (l_NDIMRS < 1) then
      if (size(nDimRS) < 1) then
        lscr = NNBSTR(iSym,3)
      else
        JREDL = INFVEC(iVec,2,iSym)
        !lscr = iWork(ip_nDimRS+iSym-1+nSym*(JREDL-1)) !! JRED?
        lscr = nDimRS(iSym,JREDL)
      end if
      JVEC1 = 1
      iSwap = 2
      WRK2(:) = Zero
      call Cho_ReOrdr(irc,CHSPC(ipVecL),lscr,jVref,JVEC1,1,1,iSym,JREDC,iSwap,ipWRK,WRK2,iSkip)
      ipVecL = ipVecL+lscr

      ! ----- Fock-like transformations -----

      call FDGTRF_RI(WRK2,DPT2AO,FPT2AO)
      call FDGTRF_RI(WRK2,DPT2CAO,FPT2CAO)
    end do
    JV1 = JV1+JNUM
  end do
end do

call mma_deallocate(CHSPC)
call mma_deallocate(WRK2)

!! Have to symmetrize Fock-transformed matrices
do i=1,nBasI
  do j=1,i-1
    tmp = (FPT2AO(i+nBasI*(j-1))+FPT2AO(j+nBasI*(i-1)))*Half
    FPT2AO(i+nBasI*(j-1)) = Tmp
    FPT2AO(j+nBasI*(i-1)) = Tmp
    tmp = (FPT2CAO(i+nBasI*(j-1))+FPT2CAO(j+nBasI*(i-1)))*Half
    FPT2CAO(i+nBasI*(j-1)) = Tmp
    FPT2CAO(j+nBasI*(i-1)) = Tmp
  end do
end do

#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  call GADGOP(FPT2AO,NBSQT,'+')
  call GADGOP(FPT2CAO,NBSQT,'+')
end if
#endif

return

contains

subroutine FDGTRF_RI(ChoVec,DD,FF)

  real(kind=wp), intent(in) :: ChoVec(nBasI**2), DD(nBasI**2)
  real(kind=wp), intent(inout) :: FF(nBasI**2)
  real(kind=wp) :: Scal
  real(kind=wp), external :: ddot_

  !! Coulomb
  Scal = DDot_(nBasI**2,DD,1,ChoVec,1)
  FF(1:nBasI**2) = FF(1:nBasI**2)+Scal*ChoVec(1:nBasI**2)

  !! Exchange
  call DGEMM_('T','N',nBasI,nBasI,nBasI,One,ChoVec,nBasI,DD,nBasI,Zero,WRK1,nBasI)
  call DGEMM_('T','T',nBasI,nBasI,nBasI,-Half,ChoVec,nBasI,WRK1,nBasI,One,FF,nBasI)

end subroutine FDGTRF_RI

end subroutine OLagFro4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Roland Lindh                                     *
************************************************************************
      Subroutine Nr_Shells(nSkal)
************************************************************************
*                                                                      *
*     Object: to compute the number of unique shells in the input.     *
*                                                                      *
*     Author: Roland Lindh, Chemical Physics, University of Lund,      *
*             Sweden. January '98.                                     *
************************************************************************
      use Basis_Info
      Implicit Real*8 (A-H,O-Z)
#include "Basis_Mode_Parameters.fh"
#include "Basis_Mode.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Determine the number of shells
*
      nSkal=0
      If (Basis_Mode.ne.Valence_Mode .and.
     &    Basis_Mode.ne.Auxiliary_Mode .and.
     &    Basis_Mode.ne.Fragment_Mode .and.
     &    Basis_Mode.ne.With_Auxiliary_Mode .and.
     &    Basis_Mode.ne.With_Fragment_Mode .and.
     &    Basis_Mode.ne.All_Mode) Then
         Call WarningMessage(2,'Nr_Shells: illegal Basis_Mode')
         Call Abend()
      End If
*
      If (Atomic) Go To 300
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Molecular set up                                                 *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Do iCnttp = 1, nCnttp
         nTest = dbsc(iCnttp)%nVal-1
         Do iCnt = 1, dbsc(iCnttp)%nCntr
*
            Do 200 iAng=0, nTest
               iShll = dbsc(iCnttp)%iVal + iAng
               nExpi=Shells(iShll)%nExp
               If (nExpi.eq.0) Cycle
               nBasisi=Shells(iShll)%nBasis
               If (nBasisi.eq.0) Cycle
*
               If (Basis_Mode.eq.Valence_Mode .and.
     &             (Shells(iShll)%Aux.or.Shells(iShll)%Frag)) Go To 200
               If (Basis_Mode.eq.Auxiliary_Mode .and.
     &             .Not.Shells(iShll)%Aux) Go To 200
               If (Basis_Mode.eq.Fragment_Mode .and.
     &             .Not.Shells(iShll)%Frag) Go To 200
               If (Basis_Mode.eq.With_Auxiliary_Mode .and.
     &             Shells(iShll)%Frag) Go To 200
               If (Basis_Mode.eq.With_Fragment_Mode .and.
     &             Shells(iShll)%Aux) Go To 200
               nSkal = nSkal + 1
*
 200        Continue                     ! iAng
         End Do                          ! iCnt
      End Do                             ! iCnttp
*
      Return
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Atomic set up                                                    *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
 300  Continue
*
      Do iCnttp = kCnttp, lCnttp
      nTest = dbsc(iCnttp)%nVal-1
      Do 400 iAng=0, nTest
         iShll = dbsc(iCnttp)%iVal + iAng
         nExpi=Shells(iShll)%nExp
         If (nExpi.eq.0) Cycle
         nBasisi=Shells(iShll)%nBasis
         If (nBasisi.eq.0) Cycle
*
         If (Shells(iShll)%Frag) Go To 400
         nSkal = nSkal + 1
*
 400  Continue                     ! iAng
      End Do
      If (dbsc(kCnttp)%Aux) nSkal=nSkal+1 ! Add dummy shell
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRPMT3(XIN,NROW,NCOL,XOUT)
! XOUT(I,J) = XIN(J,I)
!
! With a few considerations for large scale cases with cache minimization

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NROW, NCOL
real(kind=wp), intent(in) :: XIN(NROW,NCOL)
real(kind=wp), intent(out) :: XOUT(NCOL,NROW)
integer(kind=iwp) :: ICBLK, ICEND, ICOFF, IRBLK, IREND, IROFF, IROW, LCBLK, LRBLK, NCBLK, NRBLK
integer(kind=iwp), parameter :: IMET = 2

if (IMET == 1) then
  ! Straightforward, no blocking
  call TRNSPS(NROW,NCOL,XIN,XOUT)
else if (IMET == 2) then
  ! Simple blocking of matrix
  LRBLK = 40
  LCBLK = 40
  NRBLK = NROW/LRBLK
  NCBLK = NCOL/LCBLK
  if (LRBLK*NRBLK /= NROW) NRBLK = NRBLK+1
  if (LCBLK*NCBLK /= NCOL) NCBLK = NCBLK+1

  do IRBLK=1,NRBLK
    if (IRBLK == 1) then
      IROFF = 1
    else
      IROFF = IROFF+LRBLK
    end if
    IREND = min(NROW,IROFF+LRBLK-1)
    do ICBLK=1,NCBLK
      if (ICBLK == 1) then
        ICOFF = 1
      else
        ICOFF = ICOFF+LCBLK
      end if
      ICEND = min(NCOL,ICOFF+LCBLK-1)

      do IROW=IROFF,IREND
        XOUT(ICOFF:ICEND,IROW) = XIN(IROW,ICOFF:ICEND)
      end do

    end do
  end do
end if

end subroutine TRPMT3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT_red(T2red,T2full,dimbe,no)
! this routine produces reduced set of ampitudes for storing:
! T2red(be'ga',u,v) <- T2full(be',ga',u,v)
! for beGrp=gaGrp

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimbe, no
real(kind=wp), intent(out) :: T2red(nTri_Elem(dimbe),no,no)
real(kind=wp), intent(in) :: T2full(dimbe,dimbe,no,no)
integer(kind=iwp) :: be, bega, i, j

do j=1,no
  do i=1,no

    bega = 0
    do be=1,dimbe

      T2red(bega+1:bega+be,i,j) = T2Full(be,1:be,i,j)

      bega = bega+be
    end do

  end do
end do

return

end subroutine MkT_red

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function iPL_espf()
! Returns the print level

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iPL_espf
integer(kind=iwp) :: iPL
integer(kind=iwp), external :: iPrintLevel
logical(kind=iwp), external :: Reduce_Prt

iPL = iPrintLevel(-1)
if (Reduce_Prt() .and. (iPL < 3)) iPL = 0
iPL_espf = iPL

return

end function iPL_espf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function mcheckxy(m1,m2,m3,m4)
!bs makes a check, if there is an interaction inbetween cartesian functions
!bs with m-values m1-m4

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: mcheckxy
integer(kind=iwp), intent(in) :: m1, m2, m3, m4
integer(kind=iwp) :: int12a, int12b, int34a, int34b

mcheckxy = 1
int12a = m1+m2
int12b = -m1+m2
int34a = m3+m4
int34b = -m3+m4
!bs lots of checks
if (abs(int12a+int34a) == 1) return
if (abs(int12a-int34a) == 1) return
if (abs(int12b+int34b) == 1) return
if (abs(int12b-int34b) == 1) return
if (abs(int12a+int34b) == 1) return
if (abs(int12a-int34b) == 1) return
if (abs(int12b+int34a) == 1) return
if (abs(int12b-int34a) == 1) return
mcheckxy = 0

return

end function mcheckxy

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2005, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine GetGrad_ER(Functional,GradNorm,R,CMO,nBasis,nOrb2Loc,
     &                      Timing)
C
C     Thomas Bondo Pedersen, November 2005.
C
C     Purpose: compute ER Functional and its gradient norm.
C              The R matrix is computed as R(i,j) = (ij|jj).
C
C     Note: symmetry is NOT allowed (but is not tested!).
C
      Implicit Real*8 (a-h,o-z)
      Real*8  R(nOrb2Loc,nOrb2Loc), CMO(nBasis,nOrb2Loc)
      Logical Timing
#include "WrkSpc.fh"

      Character*10 SecNam
      Parameter (SecNam = 'GetGrad_ER')

      Character*80 Txt

      Parameter (nSym = 1)
      Integer nOcc(nSym), ipCMO(nSym)

C     Initialization.
C     ---------------

      Functional = 0.0d0
      GradNorm = 0.0D0
      If (nOrb2Loc.lt.1 .or. nBasis.lt.1) Return

C     Transpose CMO (only the part to be localised).
C     ----------------------------------------------

      lCMO = nOrb2Loc*nBasis
      Call GetMem('CMO_T','Allo','Real',ipCMO(1),lCMO)
      ip0 = ipCMO(1) - 1
      Do i = 1,nOrb2Loc
         Call dCopy_(nBasis,CMO(1,i),1,Work(ip0+i),nOrb2Loc)
      End Do

C     Compute R.
C     ----------

      nOcc(1) = nOrb2Loc
      irc = -1
      Call Cho_Get_Rij(irc,ipCMO,nOcc,R,Timing)
      If (irc .ne. 0) Then
         Write(Txt,'(A,I6)') 'Cho_Get_Rij returned',irc
         Call SysAbendMsg(SecNam,'Calculation of ER gradient failed:',
     &                    Txt)
      End If
      Call GetMem('CMO_T','Free','Real',ipCMO(1),lCMO)

C     Compute gradient norm and functional.
C     -------------------------------------

      Do i = 1,nOrb2Loc-1
         Functional = Functional + R(i,i)
         Do j = i+1,nOrb2Loc
            GradNorm = GradNorm + (R(i,j)-R(j,i))**2
         End Do
      End Do
      Functional = Functional + R(nOrb2Loc,nOrb2Loc)
      GradNorm = 4.0d0*sqrt(GradNorm)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SMMAT_MASKED(PROP,PRMAT,NSS,ISONUM,ISPINCMP,ISS_INDEX,IST,INUM,JST,JNUM)

use Cntrl, only: ICOMP, ISOCMP, NPROP, NSTATE, PNAME, PTYPE, SOPRNM, SOPRTP
use wigner_util, only: dclebs
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: PROP(NSTATE,NSTATE,NPROP)
integer(kind=iwp), intent(in) :: NSS, ISONUM, ISPINCMP, ISS_INDEX(NSTATE+1), INUM, IST(INUM), JNUM, JST(JNUM)
real(kind=wp), intent(inout) :: PRMAT(NSS,NSS)
integer(kind=iwp) :: I, IFSPIN, IPRCMP, IPRNUM, IPROP, ISS, ISTATE, J, JSS, JSTATE, MPLET1, MPLET2, MSPROJ1, MSPROJ2
real(kind=wp) :: CG0, CGM, CGP, CGX, CGY, EXPKR, FACT, S1, S2, SM1, SM2, SMINUS, SPLUS, SXMER, SYMEI, SZMER

IPRNUM = -1
IPRCMP = 0
PRMAT(:,:) = Zero
! IFSPIN takes values the values 0,1,2
! 0 = spin free property
! 1 = spin operator (S)
! 2 = spin dependent property, triplet operator
IFSPIN = 0

if (ISONUM == 0) then
  IPRNUM = 0
  IFSPIN = 1
  IPRCMP = ISPINCMP
else
  do IPROP=1,NPROP
    if ((PNAME(IPROP) == SOPRNM(ISONUM)) .and. (PTYPE(IPROP) == SOPRTP(ISONUM)) .and. (ICOMP(IPROP) == ISOCMP(ISONUM))) then
      IPRNUM = IPROP
      if (PNAME(IPRNUM)(1:5) == 'TMOM0') then
        IFSPIN = 2
        IPRCMP = ISPINCMP
      end if
      exit
    end if
  end do
end if
if (IPRNUM == -1) then
  write(u6,*) 'SMMAT_MASKED, Abend IPRNUM == -1'
  write(u6,*) 'SMMAT_MASKED, PRLBL=','>',PNAME(ISONUM),'<'
  call Abend()
end if

! Mapping from spin states to spin-free state and to spin:
do I=1,INUM
  ISTATE = IST(I)
  ISS = ISS_INDEX(ISTATE)
  MPLET1 = ISS_INDEX(ISTATE+1)-ISS_INDEX(ISTATE)
  S1 = Half*real(MPLET1-1,kind=wp)
  do MSPROJ1=-MPLET1+1,MPLET1-1,2
    SM1 = Half*real(MSPROJ1,kind=wp)
    ISS = ISS+1

    do J=1,JNUM
      JSTATE = JST(J)
      JSS = ISS_INDEX(JSTATE)
      MPLET2 = ISS_INDEX(JSTATE+1)-ISS_INDEX(JSTATE)
      S2 = Half*real(MPLET2-1,kind=wp)
      do MSPROJ2=-MPLET2+1,MPLET2-1,2
        SM2 = Half*real(MSPROJ2,kind=wp)
        JSS = JSS+1

        if ((IFSPIN == 0) .and. (IPRNUM /= 0)) then
          if ((MPLET1 == MPLET2) .and. (MSPROJ1 == MSPROJ2)) PRMAT(ISS,JSS) = PROP(ISTATE,JSTATE,IPRNUM)
        else if ((IFSPIN == 1) .and. (IPRNUM == 0)) then
          SXMER = Zero
          SYMEI = Zero
          SZMER = Zero
          SMINUS = Zero
          SPLUS = Zero
          if ((ISTATE == JSTATE) .and. (MPLET1 == MPLET2)) then
            if (MSPROJ1 == MSPROJ2-2) then
              SMINUS = sqrt((S1+SM2)*(S1-SM1))
              SXMER = Half*SMINUS
              SYMEI = Half*SMINUS
            else if (MSPROJ1 == MSPROJ2) then
              SZMER = SM1
            else if (MSPROJ1 == MSPROJ2+2) then
              SPLUS = sqrt((S1+SM1)*(S1-SM2))
              SXMER = Half*SPLUS
              SYMEI = -Half*SPLUS
            end if
            if (IPRCMP == 1) then
              PRMAT(ISS,JSS) = SXMER
            else if (IPRCMP == 2) then
              PRMAT(ISS,JSS) = SYMEI
            else if (IPRCMP == 3) then
              PRMAT(ISS,JSS) = SZMER
            end if
          end if
        else if (IFSPIN == 2) then

          ! The code here is a replica from smmat.
          ! Look in that source for comments.

          FACT = One/sqrt(real(MPLET1,kind=wp))
          if (MPLET1 == MPLET2-2) FACT = -FACT
          CGM = FACT*DCLEBS(S2,One,S1,SM2,-One,SM1)
          CG0 = FACT*DCLEBS(S2,One,S1,SM2,Zero,SM1)
          CGP = FACT*DCLEBS(S2,One,S1,SM2,One,SM1)
          CGX = sqrt(Half)*(CGM-CGP)
          CGY = -sqrt(Half)*(CGM+CGP)

          EXPKR = PROP(ISTATE,JSTATE,IPRNUM)

          if (IPRCMP == 1) then
            EXPKR = EXPKR*CGX
          else if (IPRCMP == 2) then
            EXPKR = EXPKR*CGY
          else if (IPRCMP == 3) then
            EXPKR = EXPKR*CG0
          end if
          PRMAT(ISS,JSS) = EXPKR
        end if

      end do !MSPROJ2
    end do !JSTATE
  end do !MSPROJ1
end do !ISTATE

return

end subroutine SMMAT_MASKED

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETVEC2(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,
     &                       SCR,LSCR)
C
C     Purpose: read Cholesky vectors IVEC=IVEC1,....,IVEC1+NUMVEC-1
C              of symmetry ISYM from file. The vectors are returned
C              in the "current" reduced set. This routine attempts
C              to minimize gather/scatter operations along the lines
C              of cho_getvec1. However, in this version, buffering
C              is (hopefully) further improved by reading vectors
C              across reduced sets.
C
C     NOTE: the scratch array SCR(LSCR) is used to read vectors from
C           disk and should not be smaller than NNBSTR(ISYM,1)+1,
C           preferably more.
C
#include "implicit.fh"
      DIMENSION CHOVEC(LENVEC,NUMVEC)
      DIMENSION SCR(LSCR)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_GETVEC2')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

      INTEGER IOFF(0:1)

      PARAMETER (N2 = INFVEC_N2)

      INFVEC(I,J,K)=IWORK(ip_INFVEC-1+MAXVEC*N2*(K-1)+MAXVEC*(J-1)+I)
      ISCR(I)=IWORK(ip_ISCR-1+I)

C     Some initializations.
C     ---------------------

      ILOC = 3

      IVEC2 = IVEC1 + NUMVEC - 1

      KJUNK = 1
      KSCR  = KJUNK + 1
      LEFT  = LSCR  - KSCR + 1
      IF (LEFT .LT. 1) THEN
         CALL CHO_QUIT('Insufficient scratch space in '//SECNAM,101)
      END IF

      SCR(KJUNK) = 0.0D0
      IOFF(0)    = KJUNK

C     Start buffer batch loop.
C     ------------------------

      KVEC1 = 1
      JVEC1 = IVEC1
      IREDC = -1
      IMAPC = -1
      DO WHILE (JVEC1 .LE. IVEC2)

C        Read as many vectors as fit into scratch space.
C        -----------------------------------------------

         JRED1 = INFVEC(JVEC1,2,ISYM)
         NVRD  = 0
         MUSED = 0
         CALL CHO_VECRD(SCR(KSCR),LEFT,JVEC1,IVEC2,ISYM,
     &                  NVRD,IREDC,MUSED)
         IF (CHO_ADRVEC .EQ. 1) THEN
            NSYS_CALL = NSYS_CALL + 1
         ELSE IF (CHO_ADRVEC .EQ. 2) THEN
            NSYS_CALL = NSYS_CALL + NVRD
         ELSE
            CALL CHO_QUIT('CHO_ADRVEC error in '//SECNAM,102)
         END IF

C        Quit if no vectors were read.
C        -----------------------------

         IF (NVRD .LT. 1) THEN
            CALL CHO_QUIT('Insufficient scratch space for read in '
     &                    //SECNAM,101)
         END IF

C        Loop over reduced sets in scratch space.
C        ----------------------------------------

         JVEC2   = JVEC1 + NVRD - 1
         JRED2   = INFVEC(JVEC2,2,ISYM)
         LVEC1   = JVEC1
         IOFF(1) = KSCR - 1
         DO JRED = JRED1,JRED2

C           Count vectors read from this reduced set.
C           -----------------------------------------

            LNUM = 0
            LVEC = LVEC1 - 1
            DO WHILE (LVEC.LT.JVEC2)
               LVEC = LVEC + 1
               LRED = INFVEC(LVEC,2,ISYM)
               IF (LRED .EQ. JRED) THEN
                  LNUM = LNUM + 1 ! increase counter
               ELSE
                  LVEC = JVEC2 ! break loop
               END IF
            END DO

            IF (LNUM .GT. 0) THEN

C              Read index arrays for this reduced set (if needed).
C              ---------------------------------------------------

               IF (JRED .NE. IREDC) THEN
                  KOFF1 = ip_NNBSTRSH + NSYM*NNSHL*(ILOC - 1)
                  KOFF2 = ip_INDRED   + MMBSTRT*(ILOC - 1)
                  CALL CHO_GETRED(IWORK(ip_INFRED),IWORK(KOFF1),
     &                            IWORK(KOFF2),IWORK(ip_INDRSH),
     &                            IWORK(ip_iSP2F),
     &                            MAXRED,NSYM,NNSHL,MMBSTRT,JRED,
     &                            .FALSE.)
                  CALL CHO_SETREDIND(IWORK(ip_IIBSTRSH),
     &                               IWORK(ip_NNBSTRSH),NSYM,NNSHL,3)
                  IREDC = JRED
               END IF

C              Set up rs-to-rs map (if needed).
C              --------------------------------

               IF (JRED .NE. IMAPC) THEN
                  CALL CHO_RS2RS(IWORK(ip_ISCR),l_ISCR,2,3,JRED,ISYM)
                  IMAPC = JRED
               END IF

C              Copy vectors to result array.
C              -----------------------------

               DO LVEC = 1,LNUM
                  KVEC = KVEC1 + LVEC - 1
                  DO IAB = 1,NNBSTR(ISYM,2)
                     KOFF = IOFF(MIN(ISCR(IAB),1)) + ISCR(IAB)
                     CHOVEC(IAB,KVEC) = SCR(KOFF)
                  END DO
                  IOFF(1) = IOFF(1) + NNBSTR(ISYM,3)
               END DO

C              Update local vector counters.
C              -----------------------------

               KVEC1 = KVEC1 + LNUM
               LVEC1 = LVEC1 + LNUM

            END IF

         END DO

C        Update global vector counter.
C        -----------------------------

         JVEC1 = JVEC1 + NVRD

      END DO

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine pseud2(ccr,gout,lambu,ltot1,mproju,ncr,nkcrl,nkcru,zcr,lit,ljt,ai,aj,xi,yi,zi,xj,yj,zj,xc,yc,zc,kcrs,lcru,lproju1,crda, &
                  crdb)
! compute type 2 core potential integrals

use ppint_arrays, only: binom, dfac, lmf, lml, lmx, lmy, lmz, zlm
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lambu, ltot1, mproju, ncr(*), lit, ljt, kcrs, lcru, lproju1, nkcrl(lproju1,*), nkcru(lproju1,*)
real(kind=wp), intent(inout) :: gout(*)
real(kind=wp), intent(in) :: ccr(*), zcr(*), ai, aj, xi, yi, zi, xj, yj, zj, xc, yc, zc
real(kind=wp), intent(out) :: crda(lit,3), crdb(ljt,3)
integer(kind=iwp) :: i, ijt, inc, it, itl, itu, j, jt, jtl, jtu, kcrl, kcru, l, lama, lamb, ldifa1, ldifb, lhi, llo, lmahi, lmalo, &
                     lmau, lmbhi, lmblo, lmbu, m, mhi, n, nhi, nlma, nlmahi, nlmalo, nlmau, nlmbu, nlo
real(kind=wp) :: aa, aarr2, angp, ca, cb, fctr2, rka, rkb, s, tai, taj, xka, xkb, yka, ykb, zka, zkb
real(kind=wp), allocatable :: anga(:,:,:), angb(:,:,:), qsum(:,:,:)
integer(kind=iwp), parameter :: llt_(7,2) = reshape([1,2,5,11,21,36,57,1,4,10,20,35,56,84],shape(llt_))

fctr2 = Four
itl = llt_(lit,1)
itu = llt_(lit,2)
jtl = llt_(ljt,1)
jtu = llt_(ljt,2)
tai = ai+ai
taj = aj+aj
aa = ai+aj
do i=1,3
  crda(1,i) = One
  crdb(1,i) = One
end do
xka = xc-xi
yka = yc-yi
zka = zc-zi
ca = sqrt(xka*xka+yka*yka+zka*zka)
if (lit /= 1) then
  crda(2,1) = xka
  crda(2,2) = yka
  crda(2,3) = zka
  if (lit /= 2) then
    do i=1,3
      do j=3,lit
        crda(j,i) = crda(2,i)*crda(j-1,i)
      end do
    end do
  end if
end if
xkb = xc-xj
ykb = yc-yj
zkb = zc-zj
cb = sqrt(xkb*xkb+ykb*ykb+zkb*zkb)
if (ljt /= 1) then
  crdb(2,1) = xkb
  crdb(2,2) = ykb
  crdb(2,3) = zkb
  if (ljt /= 2) then
    do i=1,3
      do j=3,ljt
        crdb(j,i) = crdb(2,i)*crdb(j-1,i)
      end do
    end do
  end if
end if
aarr2 = (ai*aj/aa)*(ca-cb)**2

if (ca == Zero) then
  rka = Zero
  lmau = 1
else
  xka = -xka/ca
  yka = -yka/ca
  zka = -zka/ca
  rka = tai*ca
  lmau = lcru+(lit-1)
end if
if (cb == Zero) then
  rkb = Zero
  lmbu = 1
else
  xkb = -xkb/cb
  ykb = -ykb/cb
  zkb = -zkb/cb
  rkb = taj*cb
  lmbu = lcru+(ljt-1)
end if
if ((ca == Zero) .and. (cb == Zero)) then
  lhi = min(lcru,lit,ljt)
  llo = mod((lit-1),2)+1
  if ((llo /= mod((ljt-1),2)+1) .or. (llo > lhi)) return
  inc = 2
else if (ca == Zero) then
  lhi = min(lcru,lit)
  llo = mod((lit-1),2)+1
  if (llo > lhi) return
  inc = 2
else if (cb == Zero) then
  lhi = min(lcru,ljt)
  llo = mod((ljt-1),2)+1
  if (llo > lhi) return
  inc = 2
else
  lhi = lcru
  llo = 1
  inc = 1
end if

call mma_allocate(anga,lit,mproju,lcru+lit-1,label='anga')
call mma_allocate(angb,ljt,mproju,lcru+ljt-1,label='angb')
call mma_allocate(qsum,ltot1,lambu,lcru+lit-1,label='qsum')

do l=llo,lhi,inc
  mhi = l+l-1
  lmalo = max(l-(lit-1),1)
  lmahi = min(lmau,l+(lit-1))
  lmblo = max(l-(ljt-1),1)
  lmbhi = min(lmbu,l+(ljt-1))

  ! compute radial integrals

  kcrl = nkcrl(l+1,kcrs)
  kcru = nkcru(l+1,kcrs)
  call rad2(ccr,kcrl,kcru,l,lambu,lmahi,lmalo,lmbhi,lmblo,ltot1,ncr,qsum,rka,rkb,zcr,lit,ljt,ca,cb,tai,taj,aa,aarr2,fctr2)

  ! compute angular integrals and combine with radial integrals

  ijt = 0
  do it=itl,itu
    call ang2(anga,binom,crda,dfac,it,l,lit,lmalo,lmahi,lmf,lml,lmx,lmy,lmz,mproju,xka,yka,zka,zlm)
    do jt=jtl,jtu
      ijt = ijt+1
      s = Zero
      call ang2(angb,binom,crdb,dfac,jt,l,ljt,lmblo,lmbhi,lmf,lml,lmx,lmy,lmz,mproju,xkb,ykb,zkb,zlm)
      do lama=lmalo,lmahi
        ldifa1 = abs(l-lama)+1
        nlmau = lit-mod(lit-ldifa1,2)
        do lamb=lmblo,lmbhi
          ldifb = abs(l-lamb)
          nlmbu = (ljt-1)-mod((ljt-1)-ldifb,2)
          nlo = ldifa1+ldifb
          nhi = nlmau+nlmbu
          do n=nlo,nhi,2
            nlmalo = max(ldifa1,n-nlmbu)
            nlmahi = min(nlmau,n-ldifb)
            angp = Zero
            do m=1,mhi
              do nlma=nlmalo,nlmahi,2
                angp = angp+anga(nlma,m,lama)*angb((n+1)-nlma,m,lamb)
              end do
            end do
            s = s+angp*qsum(n,lamb,lama)
          end do
        end do
      end do
      gout(ijt) = gout(ijt)+s
    end do
  end do
end do

call mma_deallocate(anga)
call mma_deallocate(angb)
call mma_deallocate(qsum)

return

end subroutine pseud2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  DefinePairDomain
!
!> @brief
!>   Define pair domains
!> @author Thomas Bondo Pedersen
!>
!> @details
!> Pair domains are defined by the union of individual orbital
!> domains, \p iDomain(0:nAtom,nOcc), see SubRoutine ::DefineDomain.
!>
!> On exit, the contents of \p iPairDomain array are:
!>
!> - \p iPairDomain(0,ij): number of atoms in pair domain \c ij.
!> - \p iPairDomain(n,ij): id of atom \c n (\c n = ``1``, ``2``, ..., \p iPairDomain(0,ij)) in pair domain \c ij.
!>
!> The contents of \p Rmin array are:
!>
!> - \p Rmin(ij): minimum distance between atoms in pair \p ij.
!>
!> The contents of \p iClass array are (for \c i = ``1``, ``2`` , ``3``, ..., \p nRThr):
!>
!> - \p iClass(ij) = \c i-1 implies \p Rmin(ij) &le; \p RThr(i) and
!> - \p iClass(ij) = \p nRThr implies \p Rmin(ij) > \p RThr(nRThr)
!>
!> Note that if classification is not wanted, simply specify
!> \p nRThr = ``0`` (in which case arrays \p iClass and \p RThr are not referenced,
!> may be dummy arguments in the call to this routine).
!> The \p iDomain array should be set by SubRoutine ::DefineDomain
!> before calling this routine.
!>
!> Return codes:
!>
!> - \p irc = ``0``: all OK.
!>
!> (at the moment, this is the only possible return code, but that
!> might change.)
!>
!> @param[out] irc         Return code
!> @param[out] iPairDomain Pair domain definition
!> @param[out] iClass      Classification
!> @param[out] Rmin        Minimum interatomic distance in each pair
!> @param[in]  iDomain     Orbital domain definition
!> @param[in]  RThr        Thresholds for classification
!> @param[in]  Coord       Nuclear coordinates
!> @param[in]  nAtom       Number of atoms
!> @param[in]  nOcc        Number of orbitals for which domains are defined
!> @param[in]  nRThr       Number of thresholds for classification
!***********************************************************************

subroutine DefinePairDomain(irc,iPairDomain,iClass,Rmin,iDomain,RThr,Coord,nAtom,nOcc,nRThr)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: nAtom, nOcc, iDomain(0:nAtom,nOcc), nRThr
integer(kind=iwp), intent(_OUT_) :: iPairDomain(0:nAtom,*), iClass(*)
real(kind=wp), intent(_OUT_) :: Rmin(*)
real(kind=wp), intent(in) :: RThr(*), Coord(3,nAtom)
integer(kind=iwp) :: i, iA, iAtom, iCount, ij, isThere, j, jA, jAtom, kAtom, lD, nnOcc
real(kind=wp) :: R
integer(kind=iwp), allocatable :: Union(:,:)

! Set return code.
! ----------------

irc = 0
if (nOcc < 2) return

! Set pair domains as union of individual domains: [ij]=[i]U[j] for i>=j.
! -----------------------------------------------------------------------

nnOcc = nOcc*(nOcc+1)/2
iPairDomain(:,1:nnOcc) = 0

call mma_allocate(Union,nAtom,nOcc,label='Union')

Union(:,:) = 0
do i=1,nOcc
  do iA=1,iDomain(0,i)
    iAtom = iDomain(iA,i)
    Union(iAtom,i) = 1
  end do
end do

ij = 0
do j=1,nOcc
  ij = ij+1
  lD = iDomain(0,j)
  iPairDomain(0:lD,ij) = iDomain(0:lD,j) ! case i=j
  do i=j+1,nOcc
    iCount = 0
    ij = ij+1
    do kAtom=1,nAtom
      isThere = Union(kAtom,j)+Union(kAtom,i)
      if (isThere > 0) then
        iCount = iCount+1
        iPairDomain(iCount,ij) = kAtom
      end if
    end do
    iPairDomain(0,ij) = iCount
  end do
end do

call mma_deallocate(Union)

! Set min. distance between any two atoms in pairs of domains.
! ------------------------------------------------------------

ij = 0
do j=1,nOcc
  ij = ij+1
  Rmin(ij) = Zero ! case i=j
  do i=j+1,nOcc
    ij = ij+1
    Rmin(ij) = huge(Rmin)
    do jA=1,iDomain(0,j)
      jAtom = iDomain(jA,j)
      do iA=1,iDomain(0,i)
        iAtom = iDomain(iA,i)
        R = sqrt((Coord(1,iAtom)-Coord(1,jAtom))**2+(Coord(2,iAtom)-Coord(2,jAtom))**2+(Coord(3,iAtom)-Coord(3,jAtom))**2)
        Rmin(ij) = min(Rmin(ij),R)
      end do
    end do
  end do
end do

! Set classification for each pair domain.
! Note that the caller must have ordered the thresholds according to
! RThr(1) < RThr(2) < RThr(3) < ... < RThr(nRThr)
! ------------------------------------------------------------------

if (nRThr > 0) then
  iClass(1:nnOcc) = nRThr
  do ij=1,nnOcc
    i = 0
    do while (i < nRThr)
      i = i+1
      if (Rmin(ij) <= RThr(i)) then
        iClass(ij) = i-1
        i = nRThr ! break while loop
      end if
    end do
  end do
end if

end subroutine DefinePairDomain

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Valera Veryazov                                  *
!***********************************************************************

subroutine SysExpand(strin,strout,iRet)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     general purpose routine for expanding frequently used messages   *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     V.Veryazov University of Lund, 2001                              *
!                                                                      *
!***********************************************************************
!   character s*256
!   call sysexpand('MSG: open ',s,i)  - correct call
!   call sysexpand('MSG: opens ',s,i) - uncorrect, but could be fixed
!   call sysexpand('MSG: uNit ',s,i)  - mixed case
!   call sysexpand('MSG: blah ',s,i)  - will print BLAH  i=real len of s
!   call sysexpand('blah-blah ',s,i)  - will print string as is and return i=0
!***********************************************************************

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: strin
character(len=*), intent(out) :: strout
integer(kind=iwp), intent(out) :: iRet
integer(kind=iwp), save :: ifset = 0, itab(0:255)
integer(kind=iwp) :: i, ii, ik, ip, j
character(len=512) :: sstrin
character :: c
character(len=*), parameter :: up = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ ', &
                               lw = 'abcdefghijklmnopqrstuvwxyz ', &
                               printable = '1234567890-=~!@#$%^&*()_+<>,.?/\[]":;'
! FORTRAN hash :-)
integer(kind=iwp), parameter :: MAXlabel = 8
integer(kind=iwp), save :: MSGlen(MAXlabel)
character(len=*), parameter :: MSGlabel(MAXlabel) = [character(len=13) :: &
                                                     'OPEN', &
                                                     'CLOSE', &
                                                     'UNIT', &
                                                     'DELETE', &
                                                     'SEEK', &
                                                     'INVALIDOPTION', &
                                                     'USED', &
                                                     'NOTOPENED' &
                                                    ], &
  MSGtext(MAXlabel) = [character(len=128) :: &
                       'Premature abort while opening file',                            & !OPEN
                       'Premature abort while closing the file',                        & !CLOSE
                       'Invalid unit number (Lu<=0 or Lu>99)',                          & !UNIT
                       'Premature abort while removing the file',                       & !DELETE
                       'Premature abort while seeking the file',                        & !SEEK
                       'An invalid option or combination of options has been supplied', & !INVALIDOPTION
                       'Invalid unit number. The file is already opened',               & !USED
                       'File is not Opened'                                             & !NOTOPENED
                      ]

! preset of saved data
! this code uses a part of upcase routine
if (ifset == 0) then
  ifset = 1
  do i=0,255
    itab(i) = -1
  end do
  do ii=1,26
    i = ichar(up(ii:ii))
    j = ichar(lw(ii:ii))
    itab(j) = i
    itab(i) = i
  end do
  do i=1,MAXlabel
    do j=128,1,-1
      if (MSGtext(i)(j:j) /= ' ') exit
    end do
    MSGlen(i) = j
  end do
end if
! fixation of bug in G77
sstrin = strin
! no action if it's an ordinary message
if (sstrin(1:4) /= 'MSG:') then
  do ii=1,len(sstrin)
    c = sstrin(ii:ii)
      ip = index(up,c)+index(lw,c)+index(printable,c)
      !write(u6,*) 'ii',ii
      if (ip == 0) sstrin(ii:ii) = ' '
  end do
  iRet = 0
  return
end if
! uppercase with removing noncharacters.
ik = 0
do ii=5,len(sstrin)
  i = ichar(sstrin(ii:ii))
  j = itab(i)
  if (j >= 0) then
    ik = ik+1
    sstrin(ik:ik) = char(j)
  end if
end do
strout = sstrin(1:ik)
iRet = ik
do ii=1,MAXlabel
  if (sstrin(1:ik) == MSGlabel(ii)) then
    strout = MSGtext(ii)(1:MSGlen(ii))
    iRet = MSGlen(ii)
    return
  end if
end do
! try again...
do ii=1,MAXlabel
  if (sstrin(1:4) == MSGlabel(ii)(1:4)) then
    strout = MSGtext(ii)(1:MSGlen(ii))
    iRet = MSGlen(ii)
    return
  end if
end do

return

end subroutine SysExpand

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine evb2cas_cvb(orbs,cvb,fx,ioptc,iter)

use casvb_global, only: civb1, civb2, civb3, civb4, civb5, norb, nvb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_IN_) :: orbs(norb,norb), cvb(nvb)
real(kind=wp), intent(out) :: fx
integer(kind=iwp), intent(out) :: ioptc, iter
integer(kind=iwp) :: idum
real(kind=wp) :: dx_amx, dxnrm
real(kind=wp), allocatable :: tmp(:)
real(kind=wp), external :: dnrm2_
logical(kind=iwp), external :: tstfile_cvb ! ... Files/Hamiltonian available ...

if (tstfile_cvb(66000.2_wp)) then
  call mma_allocate(tmp,norb*norb+nvb,label='tmp')
  call rdlow_cvb(tmp,norb*norb+nvb,66000.2_wp,0)
  tmp(1:norb*norb) = pack(orbs(:,:),.true.)-tmp(1:norb*norb)
  tmp(norb*norb+1:) = cvb(:)-tmp(norb*norb+1:)
  dxnrm = dnrm2_(norb*norb+nvb,tmp,1)
  call findamx_cvb(tmp,norb*norb+nvb,dx_amx,idum)
  call mma_deallocate(tmp)
end if
call wrlow_cvb(orbs,norb*norb,66000.2_wp,0)
call wrlow_cvb(cvb,nvb,66000.2_wp,norb*norb)
call evb2cas2_cvb(orbs,cvb,ioptc,iter,fx,dxnrm,dx_amx,civb1,civb2,civb3,civb4,civb5)

return

end subroutine evb2cas_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PMPLFM(AP,B,NDIM)
! Add lower half of a full matrix to a matrix packed
! in lower triangular form (packed matrix stored columnwise)

use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: AP(*)
real(kind=wp), intent(in) :: B(*)
integer(kind=iwp), intent(in) :: NDIM
integer(kind=iwp) :: IBSF, IBSP, ICOL, NELMNT

IBSP = 1
IBSF = 1
do ICOL=1,NDIM
  NELMNT = NDIM-ICOL+1
  AP(IBSP:IBSP+NELMNT-1) = AP(IBSP:IBSP+NELMNT-1)+B(IBSF:IBSF+NELMNT-1)
  IBSP = IBSP+NELMNT
  IBSF = IBSF+NDIM
end do

return

end subroutine PMPLFM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      SUBROUTINE INTDIA(DIAG,NSPC,ISPC,ISM,LSPC,
     &           IAMCMP,ecore)
*
* CI diagonal in SD basis for the NCSPC ci spaces defined by
* ISPC,ISM
*
* if IAMCMP .ne. 0 : then it is assumed that a complex
* hermitian eigenvalued problem is being solved by
* doubling the dimensions. The diagonal is then
* constructed and written out twice
*
      IMPLICIT REAL*8(A-H,O-Z)
*
* ==============
*.Specific Input
* ==============
*
      INTEGER ISPC(NSPC),LSPC(NSPC),ISM(NSPC)
*
* ==============
*.General Input
* ==============
*
*./ORBINP/ : NACOB used
*
#include "detdim.fh"
#include "orbinp_mclr.fh"
#include "cicisp_mclr.fh"
#include "strbas_mclr.fh"
#include "cstate_mclr.fh"
#include "strinp_mclr.fh"
#include "stinf_mclr.fh"
#include "csm.fh"
#include "WrkSpc.fh"
#include "cprnt_mclr.fh"
#include "spinfo_mclr.fh"
#include "crun_mclr.fh"
#include "dmrginfo_mclr.fh"
      Real*8 DIAG(*)
*
* ======
*.Output
* ======
*
*       OBS THIS WILL JUST WORK FOR CASSCF/RASSCF RESPONSE
      ISYM=ism(1)
      LUDIA=0

      if(doDMRG)then  ! yma
         call dmrg_dim_change_mclr(RGras2(1:8),ntoob,0)
         call dmrg_dim_change_mclr(RGras2(1:8),nacob,0)
      end if

*
*
**. Local memory
*
      Call GetMem('KLJ   ','ALLO','REAL',KLJ   ,NTOOB**2)
      Call GetMem('KLK   ','ALLO','REAL',KLK   ,NTOOB**2)
      Call GetMem('KLSC2 ','ALLO','REAL',KLSCR2,2*NTOOB**2)
      Call GetMem('KLXA  ','ALLO','REAL',KLXA  ,NACOB)
      Call GetMem('KLXB  ','ALLO','REAL',KLXB  ,NACOB)
      Call GetMem('KLSCR ','ALLO','REAL',KLSCR ,2*NACOB)
      if(doDMRG)then !yma
* wired Call GetMem('KLH1D ','ALLO','REAL',KLH1D ,NACOB_KLH1D)
        Call GetMem('KLH1D ','ALLO','REAL',KLH1D ,NACOB)
      else
        Call GetMem('KLH1D ','ALLO','REAL',KLH1D ,NACOB)
      end if
*     Call GetMem('KLSMOS','ALLO','REAL',KLSMOS,NSMST)
      Call GetMem('KLSMO2','ALLO','INTE',KLBLTP,NSMST)

*
        KLSVST = 1
*. Largest NOCTPA*NOCTPB block
      MXOCOC = 0
      DO IISPC = 1, NSPC
        NOCTPA = NOCTYP(IASTFI(ISPC(IISPC)))
        NOCTPB = NOCTYP(IBSTFI(ISPC(IISPC)))
        MXOCOC = MAX(MXOCOC,NOCTPA*NOCTPB)
      END DO
      Call GetMem('KLIOIO','ALLO','INTE',KLIOIO,NOCTPA*NOCTPB)
**. Diagonal of one-body integrals and coulomb and exchange integrals
*
      CALL GT1DIA_MCLR(WORK(KLH1D))
      CALL GTJK_MCLR(WORK(KLJ),WORK(KLK))
*
*. K goes to J - K
      ONE = +1.0D0
      ONEG = -1.0D0
      CALL VECSUM(WORK(KLK),WORK(KLK),WORK(KLJ),
     &            ONEG,ONE,NTOOB **2)
*
*
*. Loop over internal CI spaces
*
      IF(IAMCMP.EQ.0) THEN
        NLOOP = 1
      ELSE
        NLOOP = 2
      END IF
      DO 200 ILOOP = 1, NLOOP
      DO 100 IISPC = 1, NSPC
        IATP = IASTFI(ISPC(IISPC))
        IBTP = IBSTFI(ISPC(IISPC))
        NAEL = NELEC(IATP)
        NBEL = NELEC(IBTP)
        NOCTPA = NOCTYP(IATP)
        NOCTPB = NOCTYP(IBTP)
        MNRS1C = MNR1IC(ISPC(IISPC))
        MXRS3C = MXR3IC(ISPC(IISPC))
*
        CALL ZBLTP(ISMOST(1,ISM(IISPC)),NSMST,IDC,
     &       iWORK(KLBLTP),iWORK(KLSVST))
        CALL IAIBCM_MCLR(MNRS1C,MXRS3C,NOCTPA,NOCTPB,
     &       iWORK(KEL1(IATP)),iWORK(KEL3(IATP)),
     &       iWORK(KEL1(IBTP)),iWORK(KEL3(IBTP)),
     &       iWORK(KLIOIO),IPRDIA)
*
        IF(ICISTR.LE.1) THEN
          LLUDIA = 0
        ELSE
          LLUDIA = LUDIA
        END IF
        CALL CIDIA4(NAEL,iWORK(KOCSTR(IATP)),
     &              NBEL,iWORK(KOCSTR(IBTP)),
     &       NACOB,DIAG,NSMST,WORK(KLH1D),
     &       ISMOST(1,ISM(IISPC)),iWORK(KLBLTP),
     &       WORK(KLXA),WORK(KLXB),WORK(KLSCR),WORK(KLJ),
     &       WORK(KLK),iWORK(KNSTSO(IATP)),iWORK(KNSTSO(IBTP)),
     &       iWORK(KLIOIO),NOCTPA,NOCTPB,iWORK(KISTSO(IATP)),
     &       iWORK(KISTSO(IBTP)),LLUDIA,ECORE,
     &       PLSIGN,PSSIGN,IPRDIA,NTOOB,ICISTR)
*
      IF(ICISTR.LE.1.AND.LUDIA.GT.0) THEN
*. Each CI space is written in one record
        CALL ITODS(LSPC(IISPC),1,0,LUDIA)
        CALL TODSC_MCLR(DIAG,LSPC(IISPC),0,LUDIA)
      END IF
  100 CONTINUE
*. Write end of vector mark
      IF(LUDIA.GT.0) CALL ITODS([-1],1,0,LUDIA)
  200 CONTINUE

*
      Call GetMem('KLIOIO','FREE','INTE',KLIOIO,NOCTPA*NOCTPB)
      Call GetMem('KLJ   ','FREE','REAL',KLJ   ,NTOOB**2)
      Call GetMem('KLK   ','FREE','REAL',KLK   ,NTOOB**2)
      Call GetMem('KLSC2 ','FREE','REAL',KLSCR2,2*NTOOB**2)
      Call GetMem('KLXA  ','FREE','REAL',KLXA  ,NACOB)
      Call GetMem('KLXB  ','FREE','REAL',KLXB  ,NACOB)
      Call GetMem('KLSCR ','FREE','REAL',KLSCR ,2*NACOB)
      Call GetMem('KLH1D ','FREE','REAL',KLH1D ,NACOB)
      Call GetMem('KLSMO2','FREE','INTE',KLBLTP,NSMST)

      if(doDMRG)then  ! yma
         call dmrg_dim_change_mclr(LRras2(1:8),ntoob,0)
         call dmrg_dim_change_mclr(LRras2(1:8),nacob,0)
      end if

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Victor P. Vysotskiy                              *
************************************************************************

*  GetShMem
*
*> @brief
*>   A simple work space manager, used by all programs in MOLCAS
*> @author  Victor P. Vysotskiy
*>
*> @details
*> \p NameIn, \p KeyIn, and \p TypeIn are strings of any size. They are
*> not case sensitive, and only the four first letters matter.
*> If \p KeyIn is '``allo``' (or '``ALLO``' or ...) then ::GETMEM will return the
*> position of a previously unused piece of shared memory workspace,
*> capable of holding at least \p LENGTH items, and register that piece as being in use.
*> If \p TypeIn is '``Real``', the items will be accessible in
*> \c WORK(IPOS) ... ``WORK(IPOS-1+LENGTH)``.
*> If \p TypeIn is '``Inte``', the items will be accessible in
*> \c IWORK(IPOS) ... ``IWORK(IPOS-1+LENGTH)``.
*> If \p KeyIn is '``Free``', the piece will be returned to the free pool.
*> \p NameIn has no function, except that the user provides a label to the
*> field, which is used in error prints or listings.
*> \p Path is functional only in conjuction with the 'Files In Memory' I/O
*> layer. Otherwise, just simple use an empty string.
*> \p ShmId on enter must be a non-zero integer value which is being replaced on output
*> by an unique integer ID. This ID must be used for any further manipulation
*> on shared memory segment with the \p iPos offset.
*>
*> @note
*> An include file, WrkSpc.fh, declares common ``/WrkSpc/``,
*> containing two arrays,
*> \c WORK and \c IWORK, which  are equivalenced.
*> ::GETMEM uses calls to the Molcas's MA memory allocator routines.
*>
*> @param[in]     NameIn Arbitrary label
*> @param[in]     KeyIn Allo $|$ Free
*> @param[in]     TypeIn Real $|$ Inte $|$ Char
*> @param[in,out] iPos   Position
*> @param[in,out] Length Nr of items
*> @param[in]     Path   An arbitrary path or empty
*> @param[in,out] ShmId  An unique shared memory id
************************************************************************
      Subroutine GetShMem (NameIn,KeyIn,TypeIn,iPos,Length,Path,ShmId)
************************************************************************
*                                                                      *
* History: Victor P. Vysotskiy                                         *
*    2012: Native Molcas's Memory Allocator; Thread safety             *
*                                                                      *
************************************************************************
#include "SysCtl.fh"
#include "warnings.h"
#include "WrkSpc.fh"
#include "mama.fh"
*
*
      Character*(*)    NameIn,KeyIn,TypeIn
      Character*(*)    Path
      Character*4096   Cpath
      Character*8      FldNam,eopr,elbl,etyp
      Character*4      Key,VarTyp
      Integer          iPos,Length,ShmId
      Interface
        Function c_getshmem(name_,Op,dtyp,offset,len_,path,SHM_Id)
     &           bind(C,name='c_getshmem_')
          Use, Intrinsic :: iso_c_binding, only: c_char
          Use Definitions, only: MOLCAS_C_INT
          Integer(kind=MOLCAS_C_INT) :: c_getshmem
          Character(kind=c_char) :: name_(*), Op(*), dtyp(*), path(*)
          Integer(kind=MOLCAS_C_INT) :: offset, len_, SHM_Id
        End Function c_getshmem
      End Interface

*----------------------------------------------------------------------*
*     Initialize the Common / MemCtl / the first time it is referenced *
*----------------------------------------------------------------------*
      If ( MemCtl(ipStat).ne.ON ) then
         Call IniMem()
      End if
*----------------------------------------------------------------------*
*     read default parameters from Common / MemCtl /                   *
*----------------------------------------------------------------------*
      iW=MemCtl(ipSysOut)
      If ( MemCtl(ipTrace).eq.ON ) then
         Write(iW,*) ' <<< Entering GetMem 5.0 >>>'
         Write(iW,'(A,2X,A4)') ' Clear  =      ',MemCtl(ipClear)
         Write(iW,'(A,2X,A4)') ' Key    =    ',KeyIn
         Write(iW,'(A,2X,A4)') ' Name   =    ',NameIn
         Write(iW,'(A,2X,A4)') ' Type   =    ',TypeIn
         Write(iW,'(A,I12)') ' length =    ',Length
         Write(iW,'(A,I12)') ' iPos   =    ',iPos
      End If
*----------------------------------------------------------------------*
*     convert input strings to standard format                         *
*----------------------------------------------------------------------*
      Call StdFmt(NameIn,FldNam)
      Call StdFmt(KeyIn,Key)
      Call StdFmt(TypeIn,VarTyp)
*----------------------------------------------------------------------*
*     prepare passed values to the C char format                       *
*----------------------------------------------------------------------*
      elbl=FldNam
      elbl(8:8)=char(0)
      eopr=Key
      eopr(8:8)=char(0)
      etyp=VarTyp
      etyp(8:8)=char(0)
C      n=LEN(TRIM(path)); cpath(n+1:n+1)=char(0)
      n=LEN(path(1:index(path,' ')-1))
      cpath(n+1:n+1)=char(0)
*----------------------------------------------------------------------*
*     Allocate/Free new memory                                              *
*----------------------------------------------------------------------*

      If( Key.ne.'ALLO') iPos=iPos-kind2goff(VarTyp)
      iRc=c_getshmem(elbl,eopr,etyp,iPos,Length,cpath,ShmId)
      If(iRc.lt.0) Then
        If ( Key.eq.'ALLO' ) Then
          Write (6,'(A)')
     &         'MMA failed to allocate a memory block.'
        Else If ( Key.eq.'FREE' ) Then
          Write (6,'(A)')
     &         'MMA failed to release the memory block for further use.'
        End If
        Go To 777
      End If

      If ( Key.eq.'ALLO') iPos=iPos+kind2goff(VarTyp)

      Return
*
 777  Continue
      Call Quit(_RC_MEMORY_ERROR_)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CSDTVC_MCLR(CSFVEC,DETVEC,IWAY,DTOCMT,ICTSDT,
     &                  IREFSM,ICOPY,IPRNT)
*
* IWAY = 1 : CSF to DETERMINANT TRANSFORMATION
* IWAY = 2 : DETERMINANT TO CSF TRANSFORMATION
*
* ICOPY .NE. 0 : Copy output into input
*                so input becomes output while
*                output remains output
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CSFVEC(*),DETVEC(*)
      DIMENSION DTOCMT(*),ICTSDT(*)
#include "detdim.fh"
#include "spinfo_mclr.fh"
*

      ZERO = 0.0D0
      ONE = 1.0D0
      MULTS = MULTSP
      MS2 = MS2P
      IOFFCS = 0 ! dummy initialize
      IOFFDT = 0 ! dummy initialize
      IOFFCD = 0 ! dummy initialize
*

      NDET = NDTASM(IREFSM)
      NCSF = NCSASM(IREFSM)
*
      IF(IWAY .EQ. 1 ) THEN
*
* ===========================
*.. CSF to DET transformation
* ===========================
*
        CALL SETVEC(DETVEC,ZERO ,NDET)
*. Multiply with  expansion matrix
        DO 100 ITYP = 1,NTYP
          call xflush(6)
          IDET = NDPCNT(ITYP)
          ICSF = NCPCNT(ITYP)
          ICNF = NCNATS(ITYP,IREFSM)
          IF(ITYP .EQ. 1 ) THEN
            IOFFCS = 1
            IOFFDT = 1
            IOFFCD = 1
          ELSE
            IOFFCS = IOFFCS+NCNATS(ITYP-1,IREFSM)*NCPCNT(ITYP-1)
            IOFFDT = IOFFDT+NCNATS(ITYP-1,IREFSM)*NDPCNT(ITYP-1)
            IOFFCD = IOFFCD + NDPCNT(ITYP-1)*NCPCNT(ITYP-1)
          END IF
          IF( IDET*ICNF*ICSF .GT. 0 ) THEN
          CALL  DGEMM_('N','N',IDET,ICNF,ICSF,ONE ,
     &                DTOCMT(IOFFCD),IDET,
     &                CSFVEC(IOFFCS),ICSF,ZERO,
     &                DETVEC(IOFFDT),IDET)
         END IF
  100   CONTINUE
*. Sign changes
        CALL COPVEC(DETVEC,CSFVEC,NDET)
*. Change to string ordering
        CALL SCAVCS(DETVEC,CSFVEC,ICTSDT,NDET)
        IF(ICOPY.NE.0) CALL COPVEC(DETVEC,CSFVEC,NDET)
      ELSE
*
* ====================================
*  Determinant to csf transformation
* ====================================
*
C. To CSF ordering

        CALL GATVCS(CSFVEC,DETVEC,ICTSDT,NDET)
        CALL COPVEC(CSFVEC,DETVEC,NDET)
C. Multiply with CIND expansion matrix
        DO 200 ITYP = 1,NTYP
          IDET = NDPCNT(ITYP)
          ICSF = NCPCNT(ITYP)
          ICNF = NCNATS(ITYP,IREFSM)
          IF(ITYP .EQ. 1 ) THEN
            IOFFCS = 1
            IOFFDT = 1
            IOFFCD = 1
          ELSE
            IOFFCS = IOFFCS+NCNATS(ITYP-1,IREFSM)*NCPCNT(ITYP-1)
            IOFFDT = IOFFDT+NCNATS(ITYP-1,IREFSM)*NDPCNT(ITYP-1)
            IOFFCD = IOFFCD + NDPCNT(ITYP-1)*NCPCNT(ITYP-1)
          END IF
          IF( IDET*ICNF*ICSF .GT. 0 ) THEN
          CALL  DGEMM_('T','N',ICSF,ICNF,IDET,ONE ,
     &                DTOCMT(IOFFCD),IDET,
     &                DETVEC(IOFFDT),IDET,ZERO,
     &                CSFVEC(IOFFCS),ICSF)
          END IF
  200   CONTINUE
        IF( ICOPY .NE. 0 ) CALL COPVEC(CSFVEC,DETVEC,NCSF)
       END IF

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(IPRNT)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_maxDG(SDG,nnSkal,MxBasSh)
!***********************************************************************
!     Compute Sqrt(Abs( (mu,nu|mu,nu) ) )                              *
!     Make a list of the largest such element for each shell-pair      *
!     Store in SDG.                                                    *
!***********************************************************************

use Index_Functions, only: iTri
use ChoArr, only: iRS2F, iSOShl
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nnSkal
real(kind=wp), intent(inout) :: SDG(nnSkal)
integer(kind=iwp), intent(out) :: MxBasSh
#include "cholesky.fh"
integer(kind=iwp) :: iabSh, iag, iaSh, ibg, ibSh, iLoc, jRab, jSym, kRab
real(kind=wp), allocatable :: Diag(:)

!                                                                      *
!***********************************************************************
!                                                                      *
SDG(:) = Zero

iLoc = 1 ! point to 1st reduced set in index arrays
call mma_allocate(Diag,NNBSTRT(iLoc),Label='Diag')

! Read the diagonal of the integrals, (mu,nu|mu,nu)

call CHO_IODIAG(DIAG,2)

do jSym=1,nSym

  do jRab=1,nnBstR(jSym,iLoc)

    kRab = iiBstr(jSym,iLoc)+jRab ! already in 1st red set

    iag = iRS2F(1,kRab)  !global address
    ibg = iRS2F(2,kRab)

    iaSh = iSOShl(iag) ! shell to which it belongs
    ibSh = iSOShl(ibg)

    iabSh = iTri(iaSh,ibSh)

    SDG(iabSh) = max(SDG(iabSh),sqrt(abs(Diag(kRab))))

  end do  ! jRab loop
end do

call mma_deallocate(Diag)

MxBasSh = MxOrSh

return

end subroutine Get_maxDG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine AdV_G2 (G2,V,nv,dimbe,dima,no,addbe,adda,fact)
c
c       this routine do:
c       G2(be',a') <- fact sum(i) V(be',i,i,a')
c
c       N.B. Kvajt odflaknute

c
        implicit none
        integer nv,dimbe,dima,no,addbe,adda
        real*8 fact
        real*8 G2(1:nv,1:nv)
        real*8 V(1:dimbe,1:no,1:no,1:dima)
c
c       help variables
c
        integer be,a,i,afull
c
        do a=1,dima
        afull=adda+a
        do i=1,no
        do be=1,dimbe
          G2(addbe+be,afull)=G2(addbe+be,afull)+fact*V(be,i,i,a)
        end do
        end do
        end do
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_GetCutInt(Value)
C
C     Thomas Bondo Pedersen, November 2010.
C
C     Returns the value of CutInt.
C
      use Gateway_Info, only: CutInt
      Real*8 Value

      Value=CutInt
      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_SetCutInt(Value)
C
C     Thomas Bondo Pedersen, November 2010.
C
C     Sets the value of CutInt.
C
      use Gateway_Info, only: CutInt
      Real*8 Value
      CutInt=Value
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LNM(Cart,nAtoms,Hess,Scrt1,Scrt2,Vctrs,
     &               mAtoms,nDim,iAnr,Smmtrc,Cx,Gx,nIter,iOptH,
     &               Degen,Schlegel,Analytic_Hessian,
     &               iOptC,iTabBonds,iTabAtoms,nBonds,nMax,nHidden,
     &               nMDstep,MMkept)
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "angstr.fh"
      Real*8 Cart(3,nAtoms+nHidden), Hess(3*nAtoms*(3*nAtoms+1)/2),
     &       Cx(3*mAtoms,nIter),
     &       Gx(3*mAtoms,nIter), Scrt1((3*nAtoms)**2),
     *       Scrt2((3*nAtoms)**2), Vctrs(3*nAtoms,nDim),
     &       Degen(3*mAtoms)
      Integer   iANr(nAtoms+nHidden), iTabBonds(3,nBonds),
     &          iTabAtoms(2,0:nMax,nAtoms+nHidden)
      Logical Smmtrc(3*mAtoms), Schlegel, Analytic_Hessian,
     &        Found, RunOld
      Character*180 Line,Get_Ln
      External Get_Ln
      Dimension XYZ(3)

      iRout=120
      iPrint=nPrint(iRout)
#ifdef _DEBUGPRINT_
      iPrint=99
      If (iPrint.ge.19) Then
         Call RecPrt('In LNM: Cart',' ',Cart,3,nAtoms)
         If (nHidden.ne.0) Call RecPrt('In LNM: Cart(hidden atoms)',' ',
     &                                 Cart(1,nAtoms+1),3,nHidden)
         Call RecPrt('In LNM: Vctrs',' ',Vctrs,3*nAtoms,nDim)
         Write (6,*) 'iAnr=',iANr
         Write (6,*) 'Analytic Hessian=',Analytic_Hessian
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     CARTESIAN HESSIAN is generated approximately here or the analytic*
*     is read from file.                                               *
*                                                                      *
*-----Retrieve the analytic Hessian or compute the Hessian in cartesians
*     from the Hessian model function.
*
*                                                                      *
************************************************************************
*                                                                      *
      If (Analytic_Hessian) Then
*                                                                      *
************************************************************************
*                                                                      *
*
*        The Hessian matrix is read in the basis of the symmetric
*        displacements.
*
         Call Get_AnalHess(ipHess,Len)
         RunOld=.False.
         If (Len.eq.0) Then
            Call NameRun('RUNOLD')
            Call Get_AnalHess(ipHess,Len)
            Call NameRun('#Pop')
            RunOld=.True.
         End If
         Len3=ndim
         Len3=Len3*(Len3+1)/2
         If (Len.ne.Len3) Then
            Call WarningMessage(2,' Error on RELAX in LNM: Len.ne.Len3')
            write(6,*) len,len3
            Call Abend()
         End If
         call dcopy_(Len,Work(ipHess),1,Hess,1)
         Call Free_Work(ipHess)
*
*        Modify matrix with degeneracy factors and square the
*        matrix.
*
         Call FZero(Scrt1,nDim**2)
         ii = 0
         Do i = 1, 3*mAtoms
            If (Smmtrc(i)) Then
               ii = ii + 1
               jj = 0
               Do j = 1, i
                  If (Smmtrc(j)) Then
                     jj = jj + 1
                     ijTri=ii*(ii-1)/2 + jj
                     ij = (jj-1)*ndim + ii
                     ji = (ii-1)*ndim + jj
                     Tmp= Hess(ijTri)*sqrt(degen(i)*degen(j))
                     Scrt1(ij) = Tmp
                     Scrt1(ji) = Tmp
                  End If
               End Do
            End If
         End Do
#ifdef _DEBUGPRINT_
         Call TriPrt('Hessian(anal.)',' ',Hess,nDim)
         Write (6,*) 'nDim,nAtoms,mAtoms=',
     &                nDim,nAtoms,mAtoms
         Call RecPrt('Hessian(anal.)',' ',Scrt1,nDim,nDim)
#endif
*
**       If the analytic Hessian corresponds to the current iteration,
**       disable Hessian updating
*
         If (RunOld) Call NameRun('RUNOLD')
         Call Get_iScalar('HessIter',IterHess)
         If (RunOld) Call NameRun('#Pop')
         If (IterHess.eq.nIter) iOptH = iOr(8,iAnd(iOptH,32))
*                                                                      *
************************************************************************
*                                                                      *
      Else   ! Use the Hessian Model Function
*                                                                      *
************************************************************************
*                                                                      *
cnf
c   A mean Hessian using some structures extracted form the Tinker MD?
cnf
         If (nMDstep .gt. 0) Then
            NTT = 3*nAtoms*(3*nAtoms+1)/2
            Fact = One/Dble(nMDstep)
            Call Allocate_Work(ipHtmp,NTT)
            Call dCopy_(NTT,[Zero],0,Work(ipHtmp),1)
            iMDsnap = IsFreeUnit(1)
            Call Molcas_Open(iMDsnap,'snap.hess')
            Line = Get_Ln(iMDsnap)
            If (Line(1:8) .ne. 'NMM') Then
               Write(6,'(A)') 'LNM: Cannot find NMM in snap.hess'
               Call Quit_OnUserError()
            Else
               Call Get_I1(2,nMMtot)
            End If
            Do iSnap = 1, nMDstep
               iHidden = 0
               Do iMM = 0,nMMtot-1
                  Line = Get_Ln(iMDsnap)
                  If (iWork(MMkept+iMM) .eq. 1) Then
                     iHidden = iHidden + 1
                     Call Get_F(3,XYZ,3)
                     Cart(1,nAtoms+iHidden) = XYZ(1)/Angstr
                     Cart(2,nAtoms+iHidden) = XYZ(2)/Angstr
                     Cart(3,nAtoms+iHidden) = XYZ(3)/Angstr
                  End If
               End Do
               If (iHidden .ne. nHidden) Then
                  Write(6,'(A,2i3)') 'LNM: iHidden ne nHidden',iHidden,
     &            nHidden
                  Call Quit_OnUserError()
               End If
               Call ddV(Cart,nAtoms,Hess,iANr,Schlegel,iOptC,
     &            iTabBonds,iTabAtoms,nBonds,nMax,nHidden)
               Call daxpy_(NTT,Fact,Hess,1,Work(ipHtmp),1)
            End Do
            Close(iMDsnap)
            Call Free_iWork(MMkept)
            Call dCopy_(NTT,Work(ipHtmp),1,Hess,1)
            Call Free_Work(ipHtmp)
         Else
            Call ddV(Cart,nAtoms,Hess,iANr,Schlegel,iOptC,
     &            iTabBonds,iTabAtoms,nBonds,nMax,nHidden)
         End If
#ifdef _DEBUGPRINT_
         If (iPrint.ge.19)
     &      Call TriPrt(' The Model Hessian','(12f9.5)',Hess,3*nAtoms)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*----    Square the matrix
*
         Do i = 1, 3*nAtoms
            Do j = 1, i
               ijTri=i*(i-1)/2 + j
               ij = (j-1)*(3*nAtoms) + i
               ji = (i-1)*(3*nAtoms) + j
               Scrt1(ij) = Hess(ijTri)
               Scrt1(ji) = Hess(ijTri)
            End Do
         End Do
*        Call RecPrt('Scrt1',' ',Scrt1,3*nAtoms,3*nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
         If (iPrint.ge.19)
     &      Call RecPrt(' Scrt1',' ',Scrt1,3*nAtoms,3*nAtoms)
#endif
         If (nIrrep.eq.1) Go To 99
*
*------  Now project out the total symmetric part of the Hessian
*
         Call DGEMM_('N','N',
     &               3*nAtoms,nDim,3*nAtoms,
     &               1.0d0,Scrt1,3*nAtoms,
     &               Vctrs,3*nAtoms,
     &               0.0d0,Scrt2,3*nAtoms)
#ifdef _DEBUGPRINT_
         If (iPrint.ge.19)
     &      Call RecPrt(' Scrt2',' ',Scrt2,3*nAtoms,nDim)
#endif
         Call DGEMM_('T','N',
     &               nDim,nDim,3*nAtoms,
     &               1.0d0,Vctrs,3*nAtoms,
     &               Scrt2,3*nAtoms,
     &               0.0d0,Scrt1,nDim)
#ifdef _DEBUGPRINT_
         If (iPrint.ge.19)
     &      Call RecPrt(' The Symmetrized Hessian',' ',Scrt1,nDim,nDim)
#endif
 99      Continue
*                                                                      *
************************************************************************
*                                                                      *
*        Now project hessian using reaction path vector if TS search
*
         Call qpg_darray('TanVec',Found,nRP)
         If (Found) Then
            If (nRP.ne.3*mAtoms) Then
               Call WarningMessage(2,' Error in LNM: nRP.ne.3*mAtoms')
               Write (6,*) 'nRP,3*mAtoms=',nRP,mAtoms
               Call Abend()
            End If
*
            Call GetMem('TanVec','ALLO','REAL',ipTan,nRP+nRP**2)
            Call FZero(Work(ipTan),nRP+nRP**2)
            ipHTan = ipTan + nRP
            Call Get_dArray('TanVec',Work(ipTan),nRP)
*
*           Call RecPrt('TanVec',' ',Work(ipTan),nRP,1)
            i = 0
            Do ix = 1, nRP
               If (Smmtrc(ix)) Then
                  i = i + 1
                  Work(ipTan+i-1)=Work(ipTan+ix-1)
               End If
            End Do
            nRP = nDim
*           Call RecPrt('TanVec',' ',Work(ipTan),nRP,1)
*
*           Compute H|i>
*
            Call dGeMV_('N',nRP,nRP,
     &                 1.0d0,scrt1,nRP,
     &                       Work(ipTan),1,
     &                 0.0d0,Work(ipHTan),1)
*
*           Compute <i|H|i>
*
            eigen=0.0d0
            Do i=0,nRP-1
               eigen=eigen+Work(ipHTan+i)*Work(ipTan+i)
            End Do
*           Write (*,*) 'Eigen=',eigen
            If (eigen.lt.Zero) Go To 98
*
*           Form H - H|i><i| - |i><i|H
*
            Do i=0,nRP-1
               Do j=0,nRP-1
                  scrt1(nRP*i+j+1) = scrt1(nRP*i+j+1)
     &                             - Work(ipHTan+i)*Work(ipTan+j)
     &                             - Work(ipTan+i)*Work(ipHTan+j)
               End Do
            End Do
*
*
 98         Continue
            Call GetMem('TanVec','FREE','REAL',ipTan,nRP+nRP**2)
         End If
*        Call RecPrt('Scrt1(final)',' ',Scrt1,nDim,nDim)
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Do j = 1, nDim
         Do i = 1, j
            ij = (j-1)*nDim + i
            ijTri= i*(i-1)/2 + j
            Hess(ijTri)=Scrt1(ij)
         End Do
      End Do
*     Call RecPrt('Scrt1(final)',' ',Scrt1,nDim,nDim)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _WARNING_WORKAROUND_
      If (.False.) Then
         Call Unused_real_array(Cx)
         Call Unused_real_array(Gx)
      End If
#endif
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Jonas Bostrom                                    *
!***********************************************************************

subroutine ChoMP2g_Reord_R(Wrk,lWrk)
!
! Jonas Bostrom, Apr 2010
!
! Purpose: To reorder R-vectors so it is practical to access
!          one ia-piece at the time.

use Symmetry_Info, only: Mul
use Cholesky, only: nSym
use ChoMP2, only: AdrR1, AdrR2, iT1am, lUnit_F, LuRInv, nMoMo, nMP2Vec, nOcc, nVir
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lWrk
real(kind=wp), intent(out) :: Wrk(lWrk)
integer(kind=iwp) :: iA, iAdr, iAdr1, iAdr2, iBat, iClos, iI, ioffset1, iOffset2, iOpt, iSeed, iSym, iSymA, iSymI, iTypR, iVec, &
                     iVec1, iVecOV, kEndRia1, kRia1, kRia2, lRia, lTot, maxvalue, nBatR, NumVec, nVec
character(len=5) :: Fname
character(len=*), parameter :: SecNam = 'ChoMP2g_Reord_r'
integer(kind=iwp), external :: IsFreeUnit

iTypR = 2
iVecOV = 6
maxvalue = 1000

! Do not delete vectors
! ---------------------
iClos = 2

iSeed = 7
LuRInv(1) = IsFreeUnit(iSeed)
write(Fname,'(A4,I1)') 'TMPV',4
call DaName_MF_WA(LuRInv(1),Fname)

LuRInv(2) = IsFreeUnit(iSeed)
write(Fname,'(A4,I1)') 'TMPV',5
call DaName_MF_WA(LuRInv(2),Fname)

iAdr1 = 1
iAdr2 = 1
do iSymI=1,nSym
  do iSymA=1,nSym
    iSym = Mul(iSymA,iSymI)
    do iI=1,nOcc(iSymI)
      AdrR1(iSymA,iSymI,iI) = iAdr1
      iAdr1 = iAdr1+nVir(iSymA)*nMP2Vec(iSym)
    end do
    do iA=1,nVir(iSymA)
      AdrR2(iSymA,iSymI,iA) = iAdr2
      iAdr2 = iAdr2+nOcc(iSymI)*nMP2Vec(iSym)
    end do
  end do
end do

do iSym=1,nSym
  if (nMP2Vec(iSym) == 0) cycle
  nVec = min(maxvalue,nMP2Vec(iSym))
  if (nVec < 1) call SysAbendMsg(SecNam,'Insufficient memory','[1]')
  nBatR = (nMP2Vec(iSym)-1)/nVec+1

  ! Allocate memory for Ria-vectors
  ! -------------------------------

  lRia = nMoMo(iSym,iVecOV)*nVec
  kRia1 = 1
  kEndRia1 = kRia1+lRia

  kRia2 = kEndRia1

  ! Open Cholesky amplitude vectors
  ! -------------------------------
  call ChoMP2_OpenF(1,iTypR,iSym)

  do iBat=1,nBatR
    if (iBat == nBatR) then
      NumVec = nMP2Vec(iSym)-nVec*(nBatR-1)
    else
      NumVec = nVec
    end if
    iVec = nVec*(iBat-1)+1

    ! Read Amplitude vectors
    ! ----------------------
    iOpt = 2
    lTot = nMoMo(iSym,iVecOV)*NumVec
    iAdr = nMoMo(iSym,iVecOV)*(iVec-1)+1
    call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia1),lTot,iAdr)

    do iVec1=1,NumVec
      do iSymI=1,nSym
        iSymA = Mul(iSymI,iSym)
        do iI=1,nOcc(iSymI)
          ioffset1 = (iI-1)*nVir(iSymA)+iT1am(iSymA,iSymI)+(iVec1-1)*nMoMo(iSym,iVecOV)
          iOffset2 = (iVec1-1)*nVir(iSymA)+(iI-1)*NumVec*nVir(iSymA)+iT1am(iSymA,iSymI)*NumVec
          Wrk(kRia2+iOffset2:kRia2+iOffset2+nVir(iSymA)-1) = Wrk(kRia1+iOffset1:kRia1+iOffset1+nVir(iSymA)-1)
        end do
      end do
    end do

    ! Put the reordered vectors on disk
    iOpt = 1
    do iSymI=1,nSym
      iSymA = Mul(iSymI,iSym)
      do iI=1,nOcc(iSymI)
        lTot = nVir(iSymA)*NumVec
        iAdr = AdrR1(iSymA,iSymI,iI)+(iVec-1)*nVir(iSymA)
        iOffset2 = (iI-1)*NumVec*nVir(iSymA)+iT1am(iSymA,iSymI)*NumVec
        call dDaFile(LuRInv(1),iOpt,Wrk(kRia2+iOffSet2),lTot,iAdr)
      end do
    end do

  end do     !iBat
  do iBat=1,nBatR
    if (iBat == nBatR) then
      NumVec = nMP2Vec(iSym)-nVec*(nBatR-1)
    else
      NumVec = nVec
    end if
    iVec = nVec*(iBat-1)+1

    ! Read Amplitude vectors
    ! ----------------------
    iOpt = 2
    lTot = nMoMo(iSym,iVecOV)*NumVec
    iAdr = nMoMo(iSym,iVecOV)*(iVec-1)+1
    call dDaFile(lUnit_F(iSym,iTypR),iOpt,Wrk(kRia1),lTot,iAdr)

    do iSymI=1,nSym
      iSymA = Mul(iSymI,iSym)
      do iI=1,nOcc(iSymI)
        do iA=1,nVir(iSymA)

          iOffSet1 = iA-1+(iI-1)*nVir(iSymA)+iT1am(iSymA,iSymI)
          iOffSet2 = iI-1+(iA-1)*NumVec*nOcc(iSymI)+iT1am(iSymA,iSymI)*NumVec
          call dCopy_(NumVec,Wrk(kRia1+iOffset1),nMoMo(iSym,iVecOV),Wrk(kRia2+iOffset2),nOcc(iSymI))
        end do
      end do
    end do

    ! Put the reordered vectors on disk
    iOpt = 1
    do iSymI=1,nSym
      iSymA = Mul(iSymI,iSym)
      do iA=1,nVir(iSymA)
        lTot = nOcc(iSymI)*NumVec
        iAdr = AdrR2(iSymA,iSymI,iA)+(iVec-1)*nOcc(iSymI)
        iOffset2 = (iA-1)*NumVec*nOcc(iSymI)+iT1am(iSymA,iSymI)*NumVec
        call dDaFile(LuRInv(2),iOpt,Wrk(kRia2+iOffset2),lTot,iAdr)
      end do
    end do

  end do    !iBat

  call ChoMP2_OpenF(iClos,iTypR,iSym)

end do !iSym

call DaClos(LuRInv(1))
call DaClos(LuRInv(2))

end subroutine ChoMP2g_Reord_R

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_ORDER(VEC,LVEC,IJOB)
!
! Purpose: sort elements of VEC in
!          IJOB = -1: descending order
!          IJOB =  1: ascending  order
!          (all other IJOB values are ignored)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LVEC, IJOB
real(kind=wp), intent(inout) :: VEC(LVEC)
integer(kind=iwp) :: I, IMAX, IMIN, J
real(kind=wp) :: VMAX, VMIN

if (IJOB == -1) then

  do I=1,LVEC-1
    VMAX = VEC(I)
    IMAX = I
    do J=I+1,LVEC
      if (VEC(J) > VMAX) then
        VMAX = VEC(J)
        IMAX = J
      end if
    end do
    if (IMAX /= I) then
      VEC(IMAX) = VEC(I)
      VEC(I) = VMAX
    end if
  end do

else if (IJOB == 1) then

  do I=1,LVEC-1
    VMIN = VEC(I)
    IMIN = I
    do J=I+1,LVEC
      if (VEC(J) < VMIN) then
        VMIN = VEC(J)
        IMIN = J
      end if
    end do
    if (IMIN /= I) then
      VEC(IMIN) = VEC(I)
      VEC(I) = VMIN
    end if
  end do

end if

end subroutine CHO_ORDER

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ZTRNSF(N,UR,UI,AR,AI)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(in) :: UR(N,N), UI(N,N)
real(kind=wp), intent(inout) :: AR(N,N), AI(N,N)
real(kind=wp), allocatable :: CI(:,:), CR(:,:)

call mma_allocate(CR,N,N,Label='CR')
call mma_allocate(CI,N,N,Label='CI')
call DGEMM_('N','N',N,N,N,One,AR,N,UR,N,Zero,CR,N)
call DGEMM_('N','N',N,N,N,-One,AI,N,UI,N,One,CR,N)
call DGEMM_('N','N',N,N,N,One,AR,N,UI,N,Zero,CI,N)
call DGEMM_('N','N',N,N,N,One,AI,N,UR,N,One,CI,N)
call DGEMM_('T','N',N,N,N,One,UR,N,CR,N,Zero,AR,N)
call DGEMM_('T','N',N,N,N,One,UI,N,CI,N,One,AR,N)
call DGEMM_('T','N',N,N,N,One,UR,N,CI,N,Zero,AI,N)
call DGEMM_('T','N',N,N,N,-One,UI,N,CR,N,One,AI,N)
call mma_deallocate(CI)
call mma_deallocate(CR)

end subroutine ZTRNSF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Jonas Bostrom                                    *
************************************************************************
      SubRoutine ChoMP2_Energy_GetPQInd(LnPQRSprod, LiPQRSprod,
     &                                  iBatch,jBatch)
C
C     Jonas Bostrom, june 2008
C
C     Purpose: setup (pq|rs) index arrays for calculating mp2_densities.
C
      Implicit None
      Integer iBatch, jBatch
      Integer LnPQRSprod,LiPQRSprod(8)
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"

      Integer iSym
      Integer i, j
      Integer LnPQprod

      Character*14 String
      Character*22 SecNam
      Parameter (SecNam = 'ChoMP2_Energy_GetPQInd')

      LnPQprod(i,j)=iWork(ip_LnPQprod-1+nSym*(j-1)+i)

      If (iBatch .eq. jBatch) Then
         LnPQRSprod = 0
         If (ChoAlg .eq. 1) Then
            Do iSym = 1,nSym
               LiPQRSprod(iSym) = LnPQRSprod
               LnPQRSprod = LnPQRSprod
     &                    + LnPQprod(iSym,iBatch)
     &                    * (LnPQprod(iSym,iBatch)+1)/2
            End Do
         Else
            Write(String,'(A8,I6)') 'ChoAlg =',ChoAlg
            Call ChoMP2_Quit(SecNam,'ChoAlg out-of-bounds error!',
     &                       String)
         End If
      Else
         LnPQRSprod = 0
         Do iSym = 1,nSym
            LiPQRSprod(iSym) = LnPQRSprod
            LnPQRSprod = LnPQRSprod + LnPQprod(iSym,iBatch)*
     &                                LnPQprod(iSym,jBatch)
         End Do
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Anders Ohrn                                            *
!***********************************************************************

!----------------------------------------------------------------------*
! A function that returns the binomial coefficient. The coefficients   *
! are stored since N and P will not under normal circumstances be      *
! so large.                                                            *
!----------------------------------------------------------------------*
function NoverP_Q(N,P)

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: NoverP_Q
integer(kind=iwp), intent(in) :: N, P
integer(kind=iwp) :: ind
integer(kind=iwp), parameter :: Bino(21) = [1,1,1,1,2,1,1,3,3,1,1,4,6,4,1,1,5,10,10,5,1]
#include "warnings.h"

NoverP_Q = 1
if (N >= 6) then
  write(u6,*) 'Must extend NoverP_Q!'
  call Quit(_RC_INTERNAL_ERROR_)
else
  ind = nTri_Elem1(N)-(N-P)
  NoverP_Q = Bino(ind)
end if

return

end function NoverP_Q

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine qbess(alpha,binom,dfac,l,lambu,lmahi,lmbhi,ltot1,nu,prd,qsum,rka,rkb)
! Compute type 2 radial integrals, scaled by exp(-arc2)/sqrt(pi),
! using the Bessel function formula for
! lama=max(l,nu) to lmahi, lamb=max(l,nu) to lmbhi, n=lama+lamb-l-l

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: l, lambu, lmahi, lmbhi, ltot1, nu
real(kind=wp), intent(in) :: alpha, binom(*), dfac(*), prd, rka, rkb
real(kind=wp), intent(inout) :: qsum(ltot1,lambu,lmahi)
integer(kind=iwp) :: it, iu, lamap, lambp, lami, lmaphi, lmbphi, lmihi, lmlo, lmplo, n, num1
real(kind=wp) :: dsum, fct, fcta, fctb, fctra, fctrad, fctran, fctrb, fctrbd, fctrbn, fctrt, fctrtd, fctrtn, fctru, fctrud, fctrun
real(kind=wp), allocatable :: apwr(:), aterm1(:), aterm2(:), bpref(:), bpwr(:), bterm1(:), ssi(:)

call mma_allocate(apwr,lmbhi-nu+1,label='apwr')
call mma_allocate(aterm1,lmbhi-nu+1,label='aterm1')
call mma_allocate(aterm2,lmbhi-nu+1,label='aterm2')
call mma_allocate(bpref,lmbhi-nu+1,label='bpwr')
call mma_allocate(bpwr,lmahi-nu+1,label='bpwr')
call mma_allocate(bterm1,lmahi-nu+1,label='bterm1')
call mma_allocate(ssi,lmahi+lmbhi-nu,label='ssi')

! nu=l+1-npi/2
! Bessel function formula applies to all npi=2 cases, no npi=1
! cases, and some npi=0 cases.
num1 = nu-1
lmlo = max(l,nu)
lmaphi = lmahi-num1
lmbphi = lmbhi-num1
fcta = rka/(alpha+alpha)
fct = rka*fcta
fctb = rkb/(alpha+alpha)
bpref(1) = fctb**num1
do lambp=2,lmbphi
  bpref(lambp) = fctb*bpref(lambp-1)
end do
apwr(1) = One
do lambp=2,lmbphi
  apwr(lambp) = fct*apwr(lambp-1)
end do
fct = rkb*fctb
bpwr(1) = One
do lamap=2,lmaphi
  bpwr(lamap) = fct*bpwr(lamap-1)
end do
lmihi = lmaphi+lmbphi+(nu-2)
call ssibfn(lmihi-1,rka*fctb,ssi)
do lami=1,lmihi
  ssi(lami) = ssi(lami)/dfac(lami+lami-1)
end do
lmplo = lmlo-num1
fctra = (alpha+alpha)**(nu-2)*fcta**(lmlo-1)*prd/sqrt(Four*alpha)* &
        ((dfac(2*(2*lmplo+num1)-1)/dfac(2*(lmplo+num1)+1))*dfac(2*num1+1))/dfac(2*(lmplo+num1)+1)
fctran = (2*(2*lmplo+num1)-1)
fctrad = (2*(lmplo+num1)+1)
do lamap=lmplo,lmaphi
  fctru = One
  fctrun = (nu+num1)
  fctrud = (2*(lamap+num1)+1)
  do iu=1,lmbphi
    aterm1(iu) = fctru*apwr(iu)
    fctru = fctru*fctrun/fctrud
    fctrun = fctrun+Two
    fctrud = fctrud+Two
  end do
  do it=1,lamap
    bterm1(it) = binom((lamap*(lamap-1))/2+it)*bpwr(it)
  end do
  fctrb = fctra
  fctrbn = (2*(lamap+lmplo+num1)-1)
  fctrbd = (2*(lmplo+num1)+1)
  do lambp=lmplo,lmbphi
    n = ((2*(nu-l)-1)+lamap)+lambp
    do iu=1,lambp
      aterm2(iu) = binom((lambp*(lambp-1))/2+iu)*aterm1(iu)
    end do
    dsum = Zero
    fctrt = One
    fctrtn = (nu+num1)
    fctrtd = (2*(lambp+num1)+1)
    do it=1,lamap
      do iu=1,lambp
        dsum = dsum+aterm2(iu)*(fctrt*bterm1(it))*ssi((it+(nu-2))+iu)
      end do
      fctrt = fctrt*fctrtn/fctrtd
      fctrtn = fctrtn+Two
      fctrtd = fctrtd+Two
    end do
    qsum(n,lambp+num1,lamap+num1) = qsum(n,lambp+num1,lamap+num1)+fctrb*bpref(lambp)*dsum
    fctrb = fctrb*fctrbn/fctrbd
    fctrbn = fctrbn+Two
    fctrbd = fctrbd+Two
  end do
  fctra = fcta*fctra*fctran/fctrad
  fctran = fctran+Two
  fctrad = fctrad+Two
end do

call mma_deallocate(apwr)
call mma_deallocate(aterm1)
call mma_deallocate(aterm2)
call mma_deallocate(bpref)
call mma_deallocate(bpwr)
call mma_deallocate(bterm1)
call mma_deallocate(ssi)

return

end subroutine qbess

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GASCI(     ISM,    ISPC,   IPRNT,    EREF,IIUSEH0P,
     &                 MPORENP_E)
*
* CI optimization in GAS space number ISPC for symmetry ISM
*
*
* Jeppe Olsen, Winter of 1995
*
      IMPLICIT REAL*8(A-H,O-Z)
      EXTERNAL MV7
#include "mxpdim.fh"
#include "cicisp.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "clunit.fh"
#include "csm.fh"
#include "cstate.fh"
#include "crun.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "strbas.fh"
#include "glbbas.fh"
#include "cprnt.fh"
#include "oper.fh"
#include "gasstr.fh"
#include "cgas.fh"
#include "lucinp.fh"
#include "intform.fh"


#include "cintfo.fh"
#include "spinfo_lucia.fh"
#include "rasscf_lucia.fh"
#include "io_util.fh"
*
*. Common block for communicating with sigma
      COMMON/CANDS/ICSM,ISSM,ICSPC,ISSPC
*
#include "cecore.fh"
      COMMON/CMXCJ/MXCJ,MAXK1_MX,LSCMAX_MX
*
      COMMON/H_OCC_CONS/IH_OCC_CONS
*
      INTEGER IOCCLS_ARR(1), ZERO_ARR(1)
*
*. Should all parameters be tranfered to Molcas?
c      PARAMETER (IALL = 0)
*
      LOGICAL IPACK
*
      IPACK = .FALSE.
*
      IDUM=0
      NTEST = 1
      NTEST = MAX(NTEST,IPRNT)
c      MXACJ = 0
c      MXACIJ = 0
c      MXAADST = 0
*. Normal integrals accessed
      IH1FORM = 1
      I_RES_AB = 0
      IH2FORM = 1
*. CI not CC
*. Not just number conserving part
c      IH_OCC_CONS_TEST = 0
c      IF(IH_OCC_CONS_TEST.EQ.1) THEN
c         WRITE(6,*) ' IH_OCC_CONS set to one in GASCI '
c         WRITE(6,*) ' IH_OCC_CONS set to one in GASCI '
c         WRITE(6,*) ' IH_OCC_CONS set to one in GASCI '
c         WRITE(6,*) ' IH_OCC_CONS set to one in GASCI '
c         WRITE(6,*) ' IH_OCC_CONS set to one in GASCI '
c         WRITE(6,*) ' IH_OCC_CONS set to one in GASCI '
c         WRITE(6,*) ' IH_OCC_CONS set to one in GASCI '
c         WRITE(6,*) ' IH_OCC_CONS set to one in GASCI '
c         WRITE(6,*) ' IH_OCC_CONS set to one in GASCI '
c         IH_OCC_CONS = 1
c      END IF
*
      IF(NTEST .GE. 20) THEN
         WRITE(6,*)
         WRITE(6,*) ' ====================================='
         WRITE(6,*) ' Control has been transferred to GASCI'
         WRITE(6,*) ' ====================================='
         WRITE(6,*)
         WRITE(6,*) ' IIUSEH0P = ', IIUSEH0P
         WRITE(6,*) ' MPORENP_E = ', MPORENP_E
      END IF
      IF(NTEST.GE.5) THEN
         WRITE(6,'(A)') '  A few pertinent data : '
         WRITE(6,*)
         WRITE(6,'(A,I2)') '  CI space         ',ISPC
         WRITE(6,*)
         WRITE(6,*) ' Number of GAS spaces included ',LCMBSPC(ISPC)
         WRITE(6,'(A,10I3)') '  GAS spaces included           ',
     &        (ICMBSPC(II,ISPC),II=1,LCMBSPC(ISPC))
         WRITE(6,*)
         WRITE(6,*) ' Occupation constraints : '
         WRITE(6,*) '========================= '
         WRITE(6,*)
         WRITE(6,*)
         DO JJGASSPC = 1, LCMBSPC(ISPC)
            JGASSPC = ICMBSPC(JJGASSPC,ISPC)
            WRITE(6,*)
     &           ' Gas space  Min acc. occupation Max acc. occupation '
            WRITE(6,*)
     &           ' ================================================== '
            DO IGAS = 1, NGAS
               WRITE(6,'(3X,I2,13X,I3,16X,I3)') IGAS,
     &              IGSOCCX(IGAS,1,JGASSPC),IGSOCCX(IGAS,2,JGASSPC)
            END DO
         END DO
*
      END IF
*
      NDET = INT(XISPSM(ISM,ISPC))
      NEL = NELCI(ISPC)
        IF (NTEST .GE. 20)
     &       WRITE(6,*) ' Number of determinants/combinations  ',NDET
      IF(NDET.EQ.0) THEN
         WRITE(6,*) ' The number of determinants/combinations is zero.'
         WRITE(6,*) ' I am sure that fascinating discussions about '
         WRITE(6,*) ' the energy of such a wave function exists, '
         WRITE(6,*) ' but I am just a dumb program, so I will stop'
         WRITE(6,*)
         WRITE(6,*) ' GASCI : Vanishing number of parameters '
*         STOP       ' GASCI : Vanishing number of parameters '
         CALL SYSABENDMSG('lucia_util/gasci','User error',' ')
      END IF
*.Transfer to CANDS
      ICSM = ISM
      ISSM = ISM
      ICSPC = ISPC
      ISSPC = ISPC
*. Complete operator
      I12 = 2
*. Class info
C     IF(ICLSSEL.EQ.1) THEN
*. Number of occupation classes
      IATP = 1
      IBTP = 2
      NEL = NELFTP(IATP)+NELFTP(IBTP)
      IWAY = 1
      ZERO_ARR(1)=0
      CALL OCCLS(         1,    NOCCLS,IOCCLS_ARR,       NEL,      NGAS,
     &           IGSOCC(1,1),IGSOCC(1,2),       0,ZERO_ARR,   NOBPT)
*. and then the occupation classes
*
      IF(NOCSF.EQ.1) THEN
         NVAR = NDET
      ELSE
C*JESPER : Addition start
C        NVAR = NCSASM(ISM)
         NVAR = NCSF_PER_SYM(ISM)
C*JESPER : Addition end
      END  IF
      IF(IPRNT.GE.5) WRITE(6,*) '  NVAR in GASCI ', NVAR
*. Allocate memory for diagonalization
c      IF(ISIMSYM.EQ.0) THEN
         LBLOCK = MXSOOB
c      ELSE
c         LBLOCK = MXSOOB_AS
c      END IF
      LBLOCK = MAX(LBLOCK,LCSBLK)
* JESPER : Should reduce I/O
         LBLOCK = MAX(INT(XISPSM(IREFSM,1)),MXSOOB)
         IF(PSSIGN.NE.0.0D0) LBLOCK = INT(2.0D0*XISPSM(IREFSM,1))
*
*. Information about block structure- needed by new PICO2 routine.
*. Memory for partitioning of C vector
      IATP = 1
      IBTP = 2
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
      NTTS = MXNTTS
      CALL GETMEM('CLBT  ','ALLO','INTE',KLCLBT ,NTTS  )
      CALL GETMEM('CLEBT ','ALLO','INTE',KLCLEBT ,NTTS  )
      CALL GETMEM('CI1BT ','ALLO','INTE',KLCI1BT,NTTS  )
      CALL GETMEM('CIBT  ','ALLO','INTE',KLCIBT ,8*NTTS)
*. Additional info required to construct partitioning
      CALL GETMEM('CIOIO ','ALLO','INTE',KLCIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('CBLTP ','ALLO','INTE',KLCBLTP,NSMST)
*
      CALL IAIBCM(ISPC,IWORK(KLCIOIO))
*. option KSVST not active so
      KSVST = 1
      CALL ZBLTP(ISMOST(1,ISM),NSMST,IDC,IWORK(KLCBLTP),IWORK(KSVST))
*
*. Batches  of C vector
      CALL PART_CIV2(      IDC,
     &               IWORK(KLCBLTP),
     &               IWORK(KNSTSO(IATP)),
     &               IWORK(KNSTSO(IBTP)),NOCTPA,NOCTPB, NSMST,LBLOCK,
     &               IWORK(KLCIOIO),
*
     &               ISMOST(1,ISM),
     &                  NBATCH,
     &               IWORK(KLCLBT),
     &               IWORK(KLCLEBT),IWORK(KLCI1BT),IWORK(KLCIBT),
     &               0,ISIMSYM)
*. Number of BLOCKS
      NBLOCK = IFRMR(IWORK(KLCI1BT),1,NBATCH)
     &       + IFRMR(IWORK(KLCLBT),1,NBATCH) - 1
*.
*. Enabling the calculation of excited states in a new way. Lasse
*. This can be realized for GAS1 to GASN (for the GAS version)
*. Here we find which type should be eliminated in the diagonal and
*. in the sigma vector calculation. This to satisfy RASSI.
*. Insert if statement
      IF(I_ELIMINATE_GAS.GE.1) THEN
        CALL I_AM_SO_EXCITED(NBATCH,IWORK(KLCIBT),IWORK(KLCLBT),
     &                       IWORK(KLCI1BT))
      END IF
*. End of story for Lasse
*.
      CALL GETMEM('CLBT  ','FREE','INTE',KLCLBT ,NTTS  )
      CALL GETMEM('CLEBT ','FREE','INTE',KLCLEBT ,NTTS  )
*. Length of each block
      CALL EXTRROW(IWORK(KLCIBT),8,8,NBLOCK,IWORK(KLCI1BT))
      CALL GETMEM('CI1BT ','FREE','INTE',KLCI1BT,NTTS  )
*.
*. Class divisions of  dets
*. ( Well, in principle I am against class division, but I
*    realize that it is a fact so ...)
*
*. If PICO2/SBLOCK are used, three blocks are used in PICO2, so
*...
*. Largest block of strings in zero order space
      MXSTBL0 = MXNSTR
*. type of alpha and beta strings
      IATP = 1
      IBTP = 2
*. alpha and beta strings with an electron removed
      IATPM1 = 3
      IBTPM1 = 4
*. alpha and beta strings with two electrons removed
      IATPM2 = 5
      IBTPM2 = 6
*
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
*. Largest number of strings of given symmetry and type
      MAXA = 0
      IF(NAEL.GE.1) THEN
        MAXA1 = IMNMX(IWORK(KNSTSO(IATPM1)),NSMST*NOCTYP(IATPM1),2)
C?          WRITE(6,*) ' MAXA1 1', MAXA1
        MAXA = MAX(MAXA,MAXA1)
      END IF
      IF(NAEL.GE.2) THEN
        MAXA1 = IMNMX(IWORK(KNSTSO(IATPM2)),NSMST*NOCTYP(IATPM2),2)
        MAXA = MAX(MAXA,MAXA1)
      END IF
      MAXB = 0
      IF(NBEL.GE.1) THEN
        MAXB1 = IMNMX(IWORK(KNSTSO(IBTPM1)),NSMST*NOCTYP(IBTPM1),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      IF(NBEL.GE.2) THEN
        MAXB1 = IMNMX(IWORK(KNSTSO(IBTPM2)),NSMST*NOCTYP(IBTPM2),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      MXSTBL = MAX(MAXA,MAXB,MXSTBL0)
      IF(IPRCIX.GE.2 ) WRITE(6,*)
     &' Largest block of strings with given symmetry and type',MXSTBL
*. Largest number of resolution strings and spectator strings
*  that can be treated simultaneously
      MAXI = MIN( MXINKA,MXSTBL)
      MAXK = MIN( MXINKA,MXSTBL)
*.scratch space for projected matrices and a CI block
*
*. Scratch space for CJKAIB resolution matrices
*. Size of C(Ka,Jb,j),C(Ka,KB,ij)  resolution matrices
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
      CALL MXRESCPH(IWORK(KLCIOIO),IOCTPA,IOCTPB, NOCTPA, NOCTPB,
     &                    NSMST,NSTFSMSPGP,MXPNSMST, NSMOB,MXPNGAS,
     &                     NGAS,  NOBPTS,  IPRCIX,    MAXK,NELFSPGP,
     &                     MXCJ,  MXCIJA,  MXCIJB, MXCIJAB,  MXSXBL,
     &                 MXADKBLK,  IPHGAS,NHLFSPGP,    MNHL, IADVICE,
*
     &                 MXCJ_ALLSYM,MXADKBLK_AS,MX_NSPII)
      IF(IPRCIX.GE.2) THEN
        WRITE(6,*) 'GASCI  : MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL',
     &           MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL
        WRITE(6,*) ' MXADKBLK ,MXADKBLK_AS', MXADKBLK, MXADKBLK_AS
      END IF
c         IF(ISIMSYM.EQ.1) THEN
c            MXCJ = MAX(MXCJ_ALLSYM,MX_NSPII)
c            MXADKBLK_AS = MXADKBLK
c         END IF
*. Using hardwired routines, MXCIJAB also used
      LSCR2 = MAX(MXCJ,MXCIJA,MXCIJB,MXCIJAB,MX_NSPII)
      IF(IPRCIX.GE.2)
     &     WRITE(6,*) ' Space for two resolution matrices ',2*LSCR2
      LSCR12 = MAX(LBLOCK,2*LSCR2)
CSVC: is KVEC3 used at all before it is deallocated again?
      CALL GETMEM('KC2   ','ALLO','REAL',KVEC3,LSCR12)
      KVEC1 = KCI_POINTER
      KVEC2 = KSIGMA_POINTER
      KVEC3_LENGTH = MAX(LSCR12,2*LBLOCK,KVEC3_LENGTH)
*
*. CI diagonal - if required
*
      IF(IDIAG.EQ.2) THEN
         LUDIA = LUSC1
      END IF
      IF(.NOT.(IDIAG.EQ.2.AND.IRESTR.EQ.1)) THEN
         ECOREP = 0.0D0
         IF(ICISTR.GE.2) IDISK(LUDIA)=0
         I12 = 2
         SHIFT = ECORE_ORIG-ECORE
         CALL GASDIAT(WORK(KVEC1),  LUDIA,  SHIFT, ICISTR,    I12,
     &                IWORK(KLCBLTP),NBLOCK,IWORK(KLCIBT))
*
c         IF(IIUSEH0P.EQ.1) THEN
c*. Diagonal with F
c            CALL SWAPVE(WORK(KFI),WORK(KINT1O),NINT1)
c            CALL GASDIAT(WORK(KVEC1),LUSC52,SHIFT,ICISTR,1,
c     &           WORK(KLCBLTP),NBLOCK,WORK(KLCIBT))
c            CALL SWAPVE(WORK(KFI),WORK(KINT1O),NINT1)
c*. diag of (1-Lambda) F + Lambda H
c            FAC1 = 1.0D0 - XLAMBDA
c            FAC2 = XLAMBDA
c            CALL VECSMD(WORK(KVEC1),WORK(KVEC2),FAC1,FAC2,
c     &           LUSC52,LUDIA,LUSC53,1,LBLK)
c            CALL COPVCD(LUSC53,LUDIA,WORK(KVEC1),1,LBLK)
c         END IF
         IF(NOCSF.EQ.1.AND.ICISTR.EQ.1) THEN
            IDISK(LUDIA)=0
            CALL TODSC(WORK(KVEC1),NVAR,-1,LUDIA)
         END IF
         IF(IPRCIX.GE.2) WRITE(6,*) ' Diagonal constructed  '
      ELSE
         WRITE(6,*) ' Diagonal not calculated '
      END IF

      IDUMMY=1
      IDUM=1
      CALL GETMEM('CIOIO ','FREE','INTE',KLCIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('CBLTP ','FREE','INTE',KLCBLTP,NSMST)
      CALL GETMEM('CIBT  ','FREE','INTE',KLCIBT ,8*NTTS)
      CALL GETMEM('KC2   ','FREE','REAL',KVEC3,LSCR12)
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_real(EREF)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991-1994,1996,1997,2000, Jeppe Olsen                  *
************************************************************************
      SUBROUTINE RSBB2BN_LUCIA(   IASM,   IATP,   IBSM,   IBTP,    NIA,
     &                             NIB,   JASM,   JATP,   JBSM,   JBTP,
     &                             NJA,    NJB,  IAGRP,  IBGRP,   NGAS,
     &                            IAOC,   IBOC,   JAOC,   JBOC,     SB,
     &                              CB,  ADSXA, STSTSX,MXPNGASX,NOBPTS,
*
     &                            MAXK,   SSCR,   CSCR,     I1,   XI1S,
     &                              I2,   XI2S,     I3,   XI3S,     I4,
     &                            XI4S,   XINT,  NSMOB,  NSMST,  NSMSX,
     &                           NSMDX,MXPOBSX, IUSEAB,  CJRES,  SIRES,
     &                          SCLFAC, NTESTG, NSEL2E, ISEL2E,IUSE_PH,
*
     &                          IPHGAS,  XINT2)
*
* SUBROUTINE RSBB2BN_LUCIA --> 52
*
*
* Combined alpha-beta double excitation
* contribution from given C block to given S block
*. If IUSAB only half the terms are constructed
* =====
* Input
* =====
*
* IASM,IATP : Symmetry and type of alpha  strings in sigma
* IBSM,IBTP : Symmetry and type of beta   strings in sigma
* JASM,JATP : Symmetry and type of alpha  strings in C
* JBSM,JBTP : Symmetry and type of beta   strings in C
* NIA,NIB : Number of alpha-(beta-) strings in sigma
* NJA,NJB : Number of alpha-(beta-) strings in C
* IAGRP : String group of alpha strings
* IBGRP : String group of beta strings
* IAEL1(3) : Number of electrons in RAS1(3) for alpha strings in sigma
* IBEL1(3) : Number of electrons in RAS1(3) for beta  strings in sigma
* JAEL1(3) : Number of electrons in RAS1(3) for alpha strings in C
* JBEL1(3) : Number of electrons in RAS1(3) for beta  strings in C
* CB   : Input C block
* ADSXA : sym of a+, a+a => sym of a
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
* NTSOB  : Number of orbitals per type and symmetry
* IBTSOB : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* NSMOB,NSMST,NSMSX : Number of symmetries of orbitals,strings,
*       single excitations
* MAXK   : Largest number of inner resolution strings treated at simult.
*
*
* ======
* Output
* ======
* SB : updated sigma block
*
* =======
* Scratch
* =======
*
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* I2, XI2S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* XINT  : Space for two electron integrals
*
* Jeppe Olsen, Winter of 1991
*
* Feb 92 : Loops restructured ; Generation of I2,XI2S moved outside
* October 1993 : IUSEAB added
* January 1994 : Loop restructured + CJKAIB introduced
* February 1994 : Fetching and adding to transposed blocks
* October 96 : New routines for accessing annihilation information
*             Cleaned and shaved, only IROUTE = 3 option active
* October   97 : allowing for N-1/N+1 switch
*
* Last change : Aug 2000
*
      USE Para_Info, ONLY: MyRank, nProcs
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
#include "mxpdim.fh"
#include "timers.fh"
      INTEGER ADSXA(MXPOBS,MXPOBS),STSTSX(NSMST,NSMST)
      INTEGER NOBPTS(MXPNGAS,*)
*
      INTEGER ISEL2E(*)
*.Input
      DIMENSION CB(*),IBOC(*),JBOC(*),IAOC(*),JAOC(*),IPHGAS(*)
*.Output
      DIMENSION SB(*)
*.Scratch
      DIMENSION SSCR(*),CSCR(*)
      DIMENSION I1(*),XI1S(*),I2(*),XI2S(*)
      DIMENSION I3(*),XI3S(*),I4(*),XI4S(*)
      DIMENSION XINT(*), XINT2(*)
      DIMENSION CJRES(*),SIRES(*)
*
C-jwk-cleanup      DIMENSION H(MXPTSOB*MXPTSOB)
*.Local arrays
      DIMENSION ITP(20),JTP(20),KTP(20),LTP(20)
C-jwk-cleanup      DIMENSION IOP_TYP(2),IOP_AC(2),IOP_REO(2)
*
      DIMENSION IJ_TYP(2),IJ_DIM(2),IJ_REO(2),IJ_SYM(2)
c      DIMENSION IJ_AC(2)
      DIMENSION KL_TYP(2),KL_DIM(2),KL_REO(2),KL_SYM(2)
c      DIMENSION KL_AC(2)
*
      DIMENSION IASPGP(20),IBSPGP(20),JASPGP(20),JBSPGP(20)
*. Arrays for reorganization
C-jwk-cleanup      DIMENSION NADDEL(6),IADDEL(4,6),IADOP(4,6),ADSIGN(6)
C    &          SIGNREO,NADOP,NADDEL,IADDEL,ADSIGN)
*

#include "oper.fh"
*
      NTESTL = 000
      NTEST = MAX(NTESTG,NTESTL)
*
      IF(NTEST.GE.500) THEN
*
        WRITE(6,*) ' =============== '
        WRITE(6,*) ' RSBB2BN speaking '
        WRITE(6,*) ' =============== '
*
      END IF
*. A few constants
      ZERO = 0.0D0
      ONE = 1.0D0
*. Groups defining each supergroup
      CALL GET_SPGP_INF(IATP,IAGRP,IASPGP)
      CALL GET_SPGP_INF(JATP,IAGRP,JASPGP)
      CALL GET_SPGP_INF(IBTP,IBGRP,IBSPGP)
      CALL GET_SPGP_INF(JBTP,IBGRP,JBSPGP)
*
*. Symmetry of allowed excitations
      IJSM = STSTSX(IASM,JASM)
      KLSM = STSTSX(IBSM,JBSM)
      IF(IJSM.EQ.0.OR.KLSM.EQ.0) GOTO 9999
      IF(NTEST.GE.600) THEN
        write(6,*) ' IASM JASM IJSM ',IASM,JASM,IJSM
        write(6,*) ' IBSM JBSM KLSM ',IBSM,JBSM,KLSM
      END IF
*.Types of SX that connects the two strings
      CALL SXTYP2_GAS(   NKLTYP,      KTP,      LTP,     NGAS,     IBOC,
     &                     JBOC,   IPHGAS)
      CALL SXTYP2_GAS(   NIJTYP,      ITP,      JTP,     NGAS,     IAOC,
     &                     JAOC,   IPHGAS)
      IF(NIJTYP.EQ.0.OR.NKLTYP.EQ.0) GOTO 9999

      DO 2001 IJTYP = 1, NIJTYP
*
        ITYP = ITP(IJTYP)
        JTYP = JTP(IJTYP)
        DO 1940 ISM = 1, NSMOB
          JSM = ADSXA(ISM,IJSM)
          IF(JSM.EQ.0) GOTO 1940
          NI = NOBPTS(ITYP,ISM)
          NJ = NOBPTS(JTYP,JSM)
          IF(NI.EQ.0.OR.NJ.EQ.0) GOTO 1940
*. Should N-1 or N+1 projection be used for alpha strings
          IJ_TYP(1) = ITYP
          IJ_TYP(2) = JTYP
c          IJ_AC(1)  = 2
c          IJ_AC(2) =  1
c          NOP = 2
c          IF(IUSE_PH.EQ.1) THEN
c            CALL ALG_ROUTERX(IAOC,JAOC,NOP,IJ_TYP,IJ_AC,IJ_REO,
c     &           SIGNIJ)
c          ELSE
*. Enforced a+ a
            IJ_REO(1) = 1
            IJ_REO(2) = 2
c          END IF
*. Two choices here :
*  1 : <Ia!a+ ia!Ka><Ja!a+ ja!Ka> ( good old creation mapping)
*  2 :-<Ia!a  ja!Ka><Ja!a  ia!Ka>  + delta(i,j)
C?        WRITE(6,*) ' RSBB2BN : IOP_REO : ', (IOP_REO(II),II=1,2)
          IF(IJ_REO(1).EQ.1.AND.IJ_REO(2).EQ.2) THEN
*. Business as usual i.e. creation map
            IJAC = 2
            SIGNIJ2 = SCLFAC
*
            IJ_DIM(1) = NI
            IJ_DIM(2) = NJ
            IJ_SYM(1) = ISM
            IJ_SYM(2) = JSM
            IJ_TYP(1) = ITYP
            IJ_TYP(2) = JTYP
          ELSE
*. Terra Nova, annihilation map
            IJAC = 1
            SIGNIJ2 = -SCLFAC
*
            IJ_DIM(1) = NJ
            IJ_DIM(2) = NI
            IJ_SYM(1) = JSM
            IJ_SYM(2) = ISM
            IJ_TYP(1) = JTYP
            IJ_TYP(2) = ITYP
          END IF
*
*. Generate creation- or annihilation- mappings for all Ka strings
*
*. For operator connecting to |Ka> and |Ja> i.e. operator 2
          CALL ADAST_GAS(IJ_SYM(2),IJ_TYP(2),  NGAS,JASPGP,  JASM,
     &                         I1,    XI1S,  NKASTR,    IEND,   IFRST,
     &                      KFRST,    KACT, SIGNIJ2,    IJAC)
C         CALL ADAST_GAS(JSM,JTYP,JATP,JASM,IAGRP,
C    &         I1,XI1S,NKASTR,IEND,IFRST,KFRST,KACT,SCLFACS,IJ_AC)
*. For operator connecting |Ka> and |Ia>, i.e. operator 1
          CALL ADAST_GAS(IJ_SYM(1),IJ_TYP(1),  NGAS,IASPGP,  IASM,
     &                         I3,    XI3S,  NKASTR,    IEND,   IFRST,
     &                      KFRST,    KACT,     ONE,    IJAC)
C         CALL ADAST_GAS(ISM,ITYP,NGAS,IASPGP,IASM,
C    &         I3,XI3S,NKASTR,IEND,IFRST,KFRST,KACT,ONE,IJ_AC)
*. Compress list to common nonvanishing elements
          IDOCOMP = 0
          IF(IDOCOMP.EQ.1) THEN
              CALL COMPRS2LST(     I1,   XI1S,IJ_DIM(2),   I3, XI3S,
     &                        IJ_DIM(1),NKASTR,NKAEFF)
          ELSE
              NKAEFF = NKASTR
          END IF

*. Loop over batches of KA strings
          NKABTC=0
          DO
            NKABTC=NKABTC+NPROCS
            NKABTCSZ=MAX(NKAEFF-1,0)/NKABTC+1
            IF (NKABTCSZ.LE.MAXK) EXIT
          END DO
*
          DO 1801 IKABTC = 1+MYRANK, NKABTC, NPROCS
            KABOT = (IKABTC-1)*NKABTCSZ + 1
            KATOP = MIN(KABOT+NKABTCSZ-1,NKAEFF)
            LKABTC = KATOP-KABOT+1
            IF (LKABTC.LE.0) EXIT
*. Obtain C(ka,J,JB) for Ka in batch
            CALL TIMING(CPU0,CPU,WALL0,WALL)
            DO JJ = 1, IJ_DIM(2)
              CALL GET_CKAJJB(     CB,IJ_DIM(2),  NJA,CJRES,LKABTC,
     &                            NJB,
     &                             JJ,
     &                        I1(KABOT+(JJ-1)*NKASTR),
     &                        XI1S(KABOT+(JJ-1)*NKASTR))
*
            END DO
            CALL TIMING(CPU1,CPU,WALL1,WALL)
            TSIGMA(4)=TSIGMA(4)+(WALL1-WALL0)
            IF(NTEST.GE.500) THEN
              WRITE(6,*) ' Updated CJRES as C(Kaj,Jb)'
              CALL WRTMAT(CJRES,NKASTR*NJ,NJB,NKASTR*NJ,NJB)
            END IF
*
c            MXACJ=MAX(MXACJ,NIB*LKABTC*IJ_DIM(1),NJB*LKABTC*IJ_DIM(2))
            CALL SETVEC(SIRES,ZERO,NIB*LKABTC*IJ_DIM(1))
            FACS = 1.0D0
*
            DO 2000 KLTYP = 1, NKLTYP
              KTYP = KTP(KLTYP)
              LTYP = LTP(KLTYP)
*. Allowed double excitation ?
c              IJKL_ACT = 1
c              IF(IJKL_ACT.EQ.0) GOTO 2000
              IF(NTEST.GE.100) THEN
                WRITE(6,*) ' KTYP, LTYP', KTYP, LTYP
              END IF
*. Should this group of excitations be included
              IF(NSEL2E.NE.0) THEN
               IAMOKAY=0
               IF(ITYP.EQ.JTYP.AND.ITYP.EQ.KTYP.AND.ITYP.EQ.LTYP)THEN
                 DO JSEL2E = 1, NSEL2E
                   IF(ISEL2E(JSEL2E).EQ.ITYP)IAMOKAY = 1
                 END DO
               END IF
               IF(IAMOKAY.EQ.0) GOTO 2000
              END IF
*
              KL_TYP(1) = KTYP
              KL_TYP(2) = LTYP
c              KL_AC(1)  = 2
c              KL_AC(2) =  1
c              NOP = 2
c              IF(IUSE_PH.EQ.1) THEN
c                CALL ALG_ROUTERX(IBOC,JBOC,NOP,KL_TYP,KL_AC,KL_REO,
c     &               SIGNKL)
c              ELSE
*. Enforced a+ a
                KL_REO(1) = 1
                KL_REO(2) = 2
                SIGNKL = 1.0D0
c              END IF
*
              DO 1930 KSM = 1, NSMOB
                LSM = ADSXA(KSM,KLSM)
                IF(NTEST.GE.100) THEN
                  WRITE(6,*) ' KSM, LSM', KSM, LSM
                END IF
                IF(LSM.EQ.0) GOTO 1930
                NK = NOBPTS(KTYP,KSM)
                NL = NOBPTS(LTYP,LSM)
*
                IF(KL_REO(1).EQ.1.AND.KL_REO(2).EQ.2) THEN
*. Business as usual i.e. creation map
                  KLAC = 2
                  KL_DIM(1) = NK
                  KL_DIM(2) = NL
                  KL_SYM(1) = KSM
                  KL_SYM(2) = LSM
                  KL_TYP(1) = KTYP
                  KL_TYP(2) = LTYP
                ELSE
*. Terra Nova, annihilation map
                  KLAC = 1
                  KL_DIM(1) = NL
                  KL_DIM(2) = NK
                  KL_SYM(1) = LSM
                  KL_SYM(2) = KSM
                  KL_TYP(1) = LTYP
                  KL_TYP(2) = KTYP
                END IF
*. If IUSEAB is used, only terms with i.ge.k will be generated so
                IKORD = 0
                IF(IUSEAB.EQ.1.AND.ISM.GT.KSM) GOTO 1930
                IF(IUSEAB.EQ.1.AND.ISM.EQ.KSM.AND.ITYP.LT.KTYP)
     &          GOTO 1930
                IF(IUSEAB.EQ.1.AND.ISM.EQ.KSM.AND.ITYP.EQ.KTYP)
     &          IKORD = 1
*
                IF(NK.EQ.0.OR.NL.EQ.0) GOTO 1930
*. Obtain all connections a+l!Kb> = +/-/0!Jb>
*. currently we are using creation mappings for kl
*. (Modify to use ADAST later )
                CALL ADAST_GAS(KL_SYM(2),KL_TYP(2),NGAS,JBSPGP,  JBSM,
     &                              I2,   XI2S, NKBSTR,   IEND,  IFRST,
     &                           KFRST,   KACT, SIGNKL,   KLAC)
C               CALL ADSTN_GAS(LSM,LTYP,JBTP,JBSM,IBGRP,
C    &               I2,XI2S,NKBSTR,IEND,IFRST,KFRST,KACT,ONE   )
                IF(NKBSTR.EQ.0) GOTO 1930
*. Obtain all connections a+k!Kb> = +/-/0!Ib>
                CALL ADAST_GAS(KL_SYM(1),KL_TYP(1),NGAS,IBSPGP,  IBSM,
     &                              I4,   XI4S, NKBSTR,   IEND,  IFRST,
     &                           KFRST,   KACT,    ONE,   KLAC)
C               CALL ADSTN_GAS(KSM,KTYP,IBTP,IBSM,IBGRP,
C    &               I4,XI4S,NKBSTR,IEND,IFRST,KFRST,KACT,ONE   )
                IF(NKBSTR.EQ.0) GOTO 1930
*
* Fetch Integrals as (iop2 iop1 |  k l )
*
                IXCHNG = 0
                ICOUL = 1
*. Normal integrals with conjugation symmetry
                  CALL GETINT(   XINT,
     &                        IJ_TYP(2),
     &                        IJ_SYM(2),
     &                        IJ_TYP(1),
     &                        IJ_SYM(1),
*
     &                        KL_TYP(1),
     &                        KL_SYM(1),KL_TYP(2),KL_SYM(2),IXCHNG, 0,
     &                              0,  ICOUL)
*
* S(Ka,i,Ib) = sum(j,k,l,Jb)<Ib!a+kba lb!Jb>C(Ka,j,Jb)*(ji!kl)
*
                IROUTE = 3
                CALL TIMING(CPU0,CPU,WALL0,WALL)
                CALL SKICKJ_LUCIA( SIRES, CJRES,LKABTC,NKBSTR,  XINT,
     &                            IJ_DIM(1),
     &                            IJ_DIM(2),
     &                            KL_DIM(1),KL_DIM(2),NKBSTR,I4,XI4S,
     &                                I2,  XI2S, IKORD,  FACS,IROUTE )
                CALL TIMING(CPU1,CPU,WALL1,WALL)
                TSIGMA(5)=TSIGMA(5)+(WALL1-WALL0)
*
*
                IF(NTEST.GE.500) THEN
                  WRITE(6,*) ' Updated Sires as S(Kai,Ib)'
                  CALL WRTMAT(SIRES,LKABTC*NI,NIB,LKABTC*NI,NIB)
                END IF
*
 1930         CONTINUE
*             ^ End of loop over KSM
 2000       CONTINUE
*           ^ End of loop over KLTYP
*
*. Scatter out from s(Ka,Ib,i)
*
            IF(NTEST.GE.1000) THEN
              WRITE(6,*) ' S(Ka,Ib,i) as S(Ka,Ibi)'
              CALL WRTMAT(SIRES,LKABTC,NIB*IJ_DIM(1),LKABTC,IJ_DIM(1))
            END IF
*
            CALL TIMING(CPU0,CPU,WALL0,WALL)
            DO II = 1, IJ_DIM(1)
              CALL ADD_SKAIIB(  SB,IJ_DIM(1),  NIA,SIRES,LKABTC,
     &                            NIB,
     &                             II,
     &                        I3(KABOT+(II-1)*NKASTR),
     &                        XI3S(KABOT+(II-1)*NKASTR))
            END DO
            CALL TIMING(CPU1,CPU,WALL1,WALL)
            TSIGMA(6)=TSIGMA(6)+(WALL1-WALL0)
 1801     CONTINUE
*.        ^End of loop over partitioning of alpha strings
 1940   CONTINUE
*       ^ End of loop over ISM
 2001 CONTINUE
*     ^ End of loop over IJTYP
*
 9999 CONTINUE
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(MXPNGASX)
        CALL Unused_real_array(SSCR)
        CALL Unused_real_array(CSCR)
        CALL Unused_integer(NSMSX)
        CALL Unused_integer(NSMDX)
        CALL Unused_integer(MXPOBSX)
        CALL Unused_integer(IUSE_PH)
        CALL Unused_real_array(XINT2)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine two2mean12a(carteSO,carteOO,occup,AOcoeffs,onecart,
     *ncontmf,norbsum,noccorb,sameorb)
      implicit real*8 (a-h,o-z)
#include "para.fh"
      logical sameorb
      dimension
     *carteSO(ncontmf,norbsum,ncontmf,norbsum),
     *carteOO(ncontmf,norbsum,ncontmf,norbsum),
     *occup(*),AOcoeffs(MxcontL,*),onecart(MxcontL,MxcontL)
      if (sameorb) THEN
      do icartleft=1,norbsum
      do icartright=1,norbsum
      coeff=0d0
      do Mrun=1,noccorb
      coeff=coeff+occup(Mrun)*AOcoeffs(icartleft,Mrun)*
     *      AOcoeffs(icartright,Mrun)
      enddo
      coeff=0.5d0*coeff
      do irun=1,ncontmf
      do jrun=1,ncontmf
      onecart(irun,jrun)=onecart(irun,jrun)-coeff*
     *carteSO(irun,icartleft,jrun,icartright)
      enddo
      enddo
      enddo
      enddo
      else
      do icartleft=1,norbsum
      do icartright=1,norbsum
      coeff=0d0
      do Mrun=1,noccorb
      coeff=coeff+occup(Mrun)*AOcoeffs(icartleft,Mrun)*
     *      AOcoeffs(icartright,Mrun)
      enddo
      coeff=0.5d0*coeff
      do irun=1,ncontmf
      do jrun=1,ncontmf
      onecart(irun,jrun)=onecart(irun,jrun)-coeff*
     *(carteSO(irun,icartleft,jrun,icartright)+
     *2d0*carteOO(irun,icartleft,jrun,icartright))
      enddo
      enddo
      enddo
      enddo
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Random_Vector
!
!> @brief
!>   Generate a random vector in an \f$ N \f$ dimensional hypersphere
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Generate a random \f$ N \f$ dimensional vector of unit length or less,
!> by using random normal-distributed numbers. \cite Mul1959-CACM-2-19
!> The normal-distributed random numbers are generated with the Box--Muller
!> transform. \cite Box1958-AMS-29-610
!>
!> @param[in]  N    Dimension of the generated vector
!> @param[out] Vec  Generated random vector
!> @param[in]  UVec Specifies whether the vector should be of unit length
!***********************************************************************

subroutine Random_Vector(N,Vec,UVec)

use Constants, only: Zero, One, Two, Pi
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N
real(kind=wp), intent(out) :: Vec(N)
logical(kind=iwp), intent(in) :: UVec
integer(kind=iwp) :: i, iSeed = 0
real(kind=wp) :: m, sm, tot_m, U, V, X, Y
real(kind=wp), parameter :: Thr = 1.0e-8_wp
real(kind=wp), external :: Random_Molcas

! Initialize random seed
if (iSeed == 0) call GetSeed(iSeed)

! To reduce numerical errors, repeat until the size is reasonable
tot_m = Zero
do while ((tot_m < Thr) .or. (tot_m > One/Thr))
  tot_m = Zero
  do i=1,N,2
    ! Get two independent normal distributed-variales, X and Y
    ! See doi:10.1214/aoms/1177706645
    U = Random_Molcas(iSeed)
    V = Two*Pi*Random_Molcas(iSeed)
    m = -Two*log(U)
    sm = sqrt(m)
    X = sm*cos(V)
    Y = sm*sin(V)
    ! Add them to the vector,
    ! being careful with the last one if N is odd
    ! See doi:10.1145/377939.377946
    if (i == N) then
      Vec(i) = X
      tot_m = tot_m+X*X
    else
      Vec(i:i+1) = [X,Y]
      tot_m = tot_m+m
    end if
  end do
end do
! Normalize the vector
! and scale by a random (0,1) number if no unit vector desired
if (UVec) then
  sm = One
else
  sm = Random_Molcas(iSeed)
end if
Vec(:) = sm/sqrt(tot_m)*Vec(:)

return

end subroutine Random_Vector

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine RHS_PUT(NAS,NIS,lg_W,W)
!SVC: this routine copies a local buffer to a global array

use fake_GA, only: GA_Arrays
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, King
use Definitions, only: u6
#endif
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NAS, NIS, lg_W
real(kind=wp), intent(in) :: W(NAS*NIS)
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: IOFF, MAX_MESG_SIZE, NIS_BATCH, NIS_END, NIS_STA

if (Is_Real_Par()) then
  if (KING()) then
    ! SVC: when the _total_ size of a message exceeds 2**31-1 _bytes_,
    ! some implementations (e.g. MPICH, and thus also Intel MPI) fail.
    ! If this is the case, chop up the largest dimension and perform the
    ! GA_Put in batches smaller than 2**31-1 bytes (I took 2**27 elements
    ! which is 2**30 bytes).
    MAX_MESG_SIZE = 2**27
    if (NAS*NIS > MAX_MESG_SIZE) then
      NIS_BATCH = MAX_MESG_SIZE/NAS
      if (NIS_BATCH == 0) then
        write(u6,'(1X,A)') 'RHS_GET: NAS exceeds MAX_MESG_SIZE:'
        write(u6,'(1X,I12,A,I12)') NAS,' > ',MAX_MESG_SIZE
        call AbEnd()
      end if
      do NIS_STA=1,NIS,NIS_BATCH
        NIS_END = min(NIS_STA+NIS_BATCH-1,NIS)
        IOFF = NAS*(NIS_STA-1)+1
        call GA_Put(lg_W,1,NAS,NIS_STA,NIS_END,W(IOFF),NAS)
      end do
    else
      call GA_Put(lg_W,1,NAS,1,NIS,W,NAS)
    end if
  end if
else
#endif
  GA_Arrays(lg_W)%A(1:NAS*NIS) = W(:)
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine RHS_PUT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine vCrtCmp(Zeta12,P,nZeta,A,Axyz,na,HerR,nHer,ABeq)
!***********************************************************************
!                                                                      *
! Object: to compile the value of the angular part of a basis function *
!         evaluated at a root of the quadrature.                       *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             November '90                                             *
!***********************************************************************

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nZeta, na, nHer
real(kind=wp), intent(in) :: Zeta12(nZeta), P(nZeta,3), A(3), HerR(nHer)
real(kind=wp), intent(out) :: Axyz(nZeta,3,nHer,0:na)
logical(kind=iwp), intent(in) :: ABeq(3)
integer(kind=iwp) :: ia, iCar, iHer
#ifdef _DEBUGPRINT_
character(len=80) :: Label
#endif

#ifdef _DEBUGPRINT_
call RecPrt(' In vCrtCmp: HerR',' ',HerR,1,nHer)
call RecPrt(' In vCrtCmp: Zeta',' ',Zeta12,nZeta,1)
call RecPrt(' In vCrtCmp: A   ',' ',A,1,3)
call RecPrt(' In vCrtCmp: P   ',' ',P,nZeta,3)
#endif
Axyz(:,:,:,0) = One
if (na /= 0) then

  do iHer=1,nHer
    do iCar=1,3

      if (ABeq(iCar)) then
        Axyz(:,iCar,iHer,1) = HerR(iHer)*Zeta12(:)
      else
        Axyz(:,iCar,iHer,1) = HerR(iHer)*Zeta12(:)+P(:,iCar)-A(iCar)
      end if

      do ia=2,na
        Axyz(:,iCar,iHer,ia) = Axyz(:,iCar,iHer,1)*Axyz(:,iCar,iHer,ia-1)
      end do

    end do
  end do

end if

#ifdef _DEBUGPRINT_
do ia=0,na
  do iHer=1,nHer
    write(Label,'(A,I2,A,I2,A)') ' In vCrtCmp: Axyz (iHer=',iHer,',ia=',ia,')'
    call RecPrt(Label,' ',Axyz(:,:,iHer,ia),nZeta,3)
  end do
end do
#endif

end subroutine vCrtCmp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
*               1996, Anders Bernhardsson                              *
************************************************************************
      SUBROUTINE RASSG4(C,S,CB,SB,C2,ICOCOC,ISOCOC,ICSMOS,ISSMOS,
     &                  ICBLTP,ISBLTP,
     &                  NORB1,NORB2,NORB3,NACOB,
     &                  NSSOA,ISSOA,NSSOB,ISSOB,
     &                  NAEL,IAGRP,NBEL,IBGRP,NOCTPA,NOCTPB,
     &                  NSMST,NSMOB,NSMSX,NSMDX,NTSOB,IBTSOB,ITSOB,
     &                  MAXIJ,MAXK,MAXI,ICSMOD,IINMOD,LI,LC,LS,
     &                  XINT,CSCR,SSCR,SXSTSM,STSTSX,STSTDX,
     &                  SXDXSX,ADSXA,ASXAD,
     &                  IAEL1,IAEL3,
     &                  IBEL1,IBEL3,IDC,
     &                  ISOOSC,NSOOSC,ISOOSE,NSOOSE,
     &                  ICOOSC,NCOOSC,ICOOSE,NCOOSE,
     &                  IASOOS,IACOOS,
     &                  I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,
     &                  IDOH2,ISTRFL,PS,IPRNT,LUC,LUHC,IST,
     &                  CJRES,SIRES,NOPARt,TimeDep)
      IMPLICIT REAL*8(A-H,O-Z)
*
*      LOOP OVER SIGMA AND C VECTOR
*
#include "detdim.fh"
* Jeppe Olsen , Winter of 1991
* small modifications by eaw 96
*
* =====
* Input
* =====
*
* ICOCOC : Allowed type combinations for C
* ISOCOC : Allowed type combinations for S(igma)
* ICSMOS : Symmetry array for C
* ISSMOS : Symmetry array for S
* ICBLTP : Block types for C
* ISBLTP : Block types for S
*
* NORB1(2,3) : Number of orbitals in RAS1(2,3)
* NACOB : Number of active orbitals
* H     : Active one-body Hamiltonian with core contributions
* C     : CI vector
* CB    : Array able to hold largest STT block of C
* NSSOA : Number of strings per type and symmetry for alpha strings
* ISSOA : Offset for strings if given type and symmetry, alpha strings
* NAEL  : Number of active alpha electrons
* NSSOB : Number of strings per type and symmetry for beta strings
* ISSOB : Offset for strings if given type and symmetry, beta strings
* NBEL  : Number of active beta electrons
* NTSOB : Number of orbitals per type and symmetry
* ITSOB : Orbitals of given type and symmetry
* IBTSOB: Offset for ITSOB
*
* MAXIJ : Largest allowed number of orbital pairs treated simultaneously
* MAXK  : Largest number of N-2,N-1 strings treated simultaneously
* MAXI  : Max number of N strings treated simultaneously
*
* ICSMOD : 1 => Single symmetry blocks of C and S are treated
*               simultaneously
* ICSMOD : 2 => Single symmetry-occ-occ blocks of C and S are treated
*               simultaneously
* IINMOD :
*
* LI : Length of scratch array for integrals
* LC : Length of scratch array for C
* LS : Length of scratch array for S
* XINT : Scratch array for integrals
* CSCR : Scratch array for C vector (space for res. matr.)
* SSCR : Scratch array for S vector (space for res. matr.)
*
* The C and S vectors are accessed through routines that
* either fetches/disposes symmetry blocks or
* Symmetry-occupation-occupation blocks
*
*
* IST :  = 1 => Singlet operator
*        = 2 => Triplet operator\
*
* IDOH2 : = 1 => both one and two particle parts
*         = 0 => only one-electron operator
* A triplet one electron operator is defined as E(aa)-E(bb)
* A triplet two-electron operator is defined as (E(aa)+E(bb))(E(aa)-E(bb))
*
      Logical TimeDep
*.General input
      INTEGER SXSTST(1), DXSTST(1) ! HMMMMMM
      INTEGER ICOCOC(NOCTPA,NOCTPB),ISOCOC(NOCTPA,NOCTPB)
      INTEGER ICSMOS(NSMST),ISSMOS(NSMST)
      INTEGER ICBLTP(NSMST),ISBLTP(NSMST)
      INTEGER NSSOA(NOCTPA,nsmst),ISSOA(NOCTPA,nsmst)
      INTEGER NSSOB(NOCTPB,nsmst),ISSOB(NOCTPB,nsmst)
      INTEGER SXSTSM(NSMSX,NSMST)
      INTEGER STSTSX(NSMST,NSMST)
      INTEGER STSTDX(NSMST,NSMST)
      INTEGER ADSXA(MXPOBS,2*MXPOBS),ASXAD(MXPOBS,2*MXPOBS)
      INTEGER SXDXSX(2*MXPOBS,4*MXPOBS)
      INTEGER NTSOB(3,NSMOB),IBTSOB(3,NSMOB),ITSOB(mxporb)
      INTEGER IAEL1(*),IAEL3(*)
      INTEGER IBEL1(*),IBEL3(*)
*.Scratch
      DIMENSION SB(*),CB(*),C2(*)
      DIMENSION XINT(*),CSCR(*),SSCR(*)
      INTEGER ISOOSC(NOCTPA,NOCTPB,NSMST),NSOOSC(NOCTPA,NOCTPB,NSMST)
      INTEGER ISOOSE(NOCTPA,NOCTPB,NSMST),NSOOSE(NOCTPA,NOCTPB,NSMST)
      INTEGER ICOOSC(NOCTPA,NOCTPB,NSMST),NCOOSC(NOCTPA,NOCTPB,NSMST)
      INTEGER ICOOSE(NOCTPA,NOCTPB,NSMST),NCOOSE(NOCTPA,NOCTPB,NSMST)
      INTEGER IASOOS(NOCTPA,NOCTPB,NSMST),IACOOS(NOCTPA,NOCTPB,NSMST)
      DIMENSION I1(MAXK,*),I2(MAXK,*),XI1S(MAXK,*),XI2S(MAXK,*),
     &          I3(MAXK,*),I4(MAXK,*),XI3S(MAXK,*),XI4S(MAXK,*)
      DIMENSION CJRES(*),SIRES(*)
*
      DIMENSION LASM(4),LBSM(4),LATP(4),LBTP(4),LSGN(5),LTRP(5)
*.
      DIMENSION C(*),S(*),ISTRFL(*)
*
      ZERO = 0.0D0
      PL=Zero
* ================================
* 1 : Arrays for accessing C and S
* ================================
*

********************************************************************
*
*.Sigma, compact form
      CALL ZOOS(ISSMOS,ISBLTP,NSMST,ISOCOC,NSSOA,NSSOB,
     &          NOCTPA,NOCTPB,IDC,ISOOSC,NSOOSC,NSCMBC,0)
*. Sigma with expanded diagonal blocks
      CALL ZOOS(ISSMOS,ISBLTP,NSMST,ISOCOC,NSSOA,NSSOB,
     &          NOCTPA,NOCTPB,IDC,ISOOSE,NSOOSE,NSCMBE,1)
*.C, compact form
      CALL ZOOS(ICSMOS,ICBLTP,NSMST,ISOCOC,NSSOA,NSSOB,
     &          NOCTPA,NOCTPB,IDC,ICOOSC,NCOOSC,NCCMBC,0)
*.C, Full determinant form
      CALL ZOOS(ICSMOS,ICBLTP,NSMST,ISOCOC,NSSOA,NSSOB,
     &          NOCTPA,NOCTPB,1  ,ICOOSE,NCOOSE,NCCMBE,1)
*
*********************************************************************
*

*. Initialize loop over batches of sigma blocks
      ISENSM = 1
      ISENTA = 1
      ISENTB = 1
      IFRSTS = 1
* Loop over batches over sigma blocks
      IF(LUHC.GT.0) REWIND LUHC

10001 CONTINUE
*. Next batch of sigma blocks
        ISSTSM = ISENSM
        ISSTTA = ISENTA
        ISSTTB = ISENTB
        CALL INCOOS(IDC,ISBLTP,NSOOSE,NOCTPA,NOCTPB,ISSTSM,ISSTTA,
     &              ISSTTB,NSMST,ISENSM,ISENTA,ISENTB,IASOOS,
     &              LS,ISFINI,NSBLK,IFRSTS,ISOCOC)
        IF(NSBLK.EQ.0.AND.ISFINI.NE.0) GOTO 10002
        IFRSTS = 0
*. Initialize sigma blocks
        IS1SM = ISSTSM
        IS1TA = ISSTTA
        IS1TB = ISSTTB
        LSBLK = 0
        DO ISBLK = 1, NSBLK
          LSBLK = LSBLK + NSOOSE(IS1TA,IS1TB,IS1SM)
          IF(ISBLK.NE.NSBLK) THEN
            CALL NXTBLK_MCLR(IS1TA,IS1TB,IS1SM,NOCTPA,NOCTPB,NSMST,
     &      ISBLTP,IDC,NONEWS,ISOCOC)
          END IF
        End Do
*       CALL SETVEC(SB,ZERO ,LSBLK)
        call dcopy_(LSBLK,[ZERO],0,SB,1)
*. Initialize loop over blocks over C vector
        ICENSM = 1
        ICENTA = 1
        ICENTB = 1
        IF(LUC.GT.0) REWIND LUC
*. Loop over blocks of C vector
        IFRSTC = 1
 9001   CONTINUE
          ICSTSM = ICENSM
          ICSTTA = ICENTA
          ICSTTB = ICENTB
*
          CALL INCOOS(IDC,ICBLTP,NCOOSE,NOCTPA,NOCTPB,ICSTSM,ICSTTA,
     &         ICSTTB,NSMST,ICENSM,ICENTA,ICENTB,IACOOS,
     &         LC,IFINIC,NCBLK,IFRSTC,ICOCOC)

*. If no more C blocks goto next batch of sigma blocks
          IF(NCBLK.EQ.0.AND.IFINIC.NE.0) GOTO 10001
          IFRSTC = 0
*. Read C blocks into core
          IC1SM = ICSTSM ! Symmetry alpha
          IC1TA = ICSTTA ! Type alpha string
          IC1TB = ICSTTB ! Type Beta string
          ICOFF = 1
          DO ICBLK = 1, NCBLK
            ICBSM = ICSMOS(IC1SM) ! Symmetry Beta string
            IF(ICOCOC(IC1TA,IC1TB).EQ.1) THEN
*
*              C CI vector in
*              CB Block of CI vector out
*

             CALL GSTTBL_MCLR(C,CB(ICOFF),IC1TA,IC1SM,IC1TB,ICBSM,
     &                  ICOCOC,NOCTPA,NOCTPB,NSSOA,NSSOB,PS,ICOOSC,IDC,
     &                  PL,LUC,C2)
            END IF

            ICOFF = ICOFF + NCOOSE(IC1TA,IC1TB,IC1SM)
            IF(ICBLK.NE.NCBLK) THEN
              CALL NXTBLK_MCLR(IC1TA,IC1TB,IC1SM,NOCTPA,NOCTPB,NSMST,
     &        ICBLTP,IDC,NONEWC,ICOCOC)
            END IF
          End Do
*
*********************************************************************
*
*. Loop over sigma and C blocks in core and obtain  contribution from
* given C block to given S block
          ISOFF = 1
          IASM = ISSTSM
          IATP = ISSTTA
          IBTP = ISSTTB
          DO 10000 ISBLK = 1, NSBLK
           call xflush(6)
           IBSM = ISSMOS(IASM)
           NIA = NSSOA(IATP,IASM)
           NIB = NSSOB(IBTP,IBSM)
           IF(NIA.NE.0.AND.NIB.NE.0) THEN
            JASM = ICSTSM
            JATP = ICSTTA
            JBTP = ICSTTB
            ICOFF = 1
            DO 9000 ICBLK = 1, NCBLK
              call xflush(6)
              JBSM = ICSMOS(JASM)
              NJA = NSSOA(JATP,JASM)
              NJB = NSSOB(JBTP,JBSM)
              XNORM2 = DDot_(NJA*NJB,CB(ICOFF),1,CB(ICOFF),1)
              IF(NIA.NE.0.AND.NIB.NE.0.AND.NJA.NE.0.AND.NJB.NE.0 .AND.
     &        ISOCOC(IATP,IBTP).EQ.1.AND.ICOCOC(JATP,JBTP).EQ.1.AND.
     &         XNORM2.NE.0.0D0) THEN
*. Other symmetry blocks that can be obtained from this block
!                write(*,*)"Other symmetry blocks that can be obtained"
!                call xflush(6)

                CALL PRMBLK(IDC,ISTRFL,JASM,JBSM,JATP,JBTP,PS,PL,
     &                      LATP,LBTP,LASM,LBSM,LSGN,LTRP,NPERM)
C    &                      TimeDep)
                DO 8765 IPERM = 1, NPERM
                  LLASM = LASM(IPERM)
                  LLBSM = LBSM(IPERM)
                  LLATP = LATP(IPERM)
                  LLBTP = LBTP(IPERM)
                  NLLA = NSSOA(LLATP,LLASM)
                  NLLB = NSSOB(LLBTP,LLBSM)
                  IF(LTRP(IPERM).EQ.1) THEN
                    LROW = NSSOA(LATP(IPERM-1),LASM(IPERM-1))
                    LCOL = NSSOB(LBTP(IPERM-1),LBSM(IPERM-1))
                    CALL TRPMAT(CB(ICOFF),LROW,LCOL,C2)
                    call dcopy_(LROW*LCOL,C2,1,CB(iCOFF),1)
                  END IF
                  IF(LSGN(IPERM).EQ.-1)
     &            CALL DSCAL_(LROW*LCOL,-1.0d0,CB(ICOFF),1)
*
*
*    Generation of contribution to sigma block
*    from given CI block
*
!                 Write(*,*)'TimeDep in rassg4',TimeDep
!                 call xflush(6)
                 If (TimeDep) Then
*                      Write(*,*)'I call rssbcbn_td'
                      CALL RSSBCBN_td(IASM,IATP,IBSM,IBTP,
     &                LLASM,LLATP,LLBSM,LLBTP,
     &                IAEL1(IATP),IAEL3(IATP),
     &                IBEL1(IBTP),IBEL3(IBTP),
     &                IAEL1(LLATP),IAEL3(LLATP),
     &                IBEL1(LLBTP),IBEL3(LLBTP),
     &                NAEL,NBEL,
     &                IAGRP,IBGRP,
     &                SB(ISOFF),CB(ICOFF),IDOH2,
     &                ADSXA,SXSTST,STSTSX,DXSTST,STSTDX,SXDXSX,
     &                NTSOB,IBTSOB,ITSOB,MAXI,MAXK,
     &                SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,
     &                C2,NSMOB,NSMST,NSMSX,NSMDX,NIA,NIB,NLLA,NLLB,
     &                MXPOBS,IPRNT,IST,CJRES,SIRES,NOPART,TimeDep)
*
!                      Call RECPRT('SSCR in rassg4',' ',SSCR,5,1) !yma
!                      call xflush(6)
                 Else
                      CALL RSSBCBN_MCLR(IASM,IATP,IBSM,IBTP,
     &                LLASM,LLATP,LLBSM,LLBTP,
     &                IAEL1(IATP),IAEL3(IATP),
     &                IBEL1(IBTP),IBEL3(IBTP),
     &                IAEL1(LLATP),IAEL3(LLATP),
     &                IBEL1(LLBTP),IBEL3(LLBTP),
     &                NAEL,NBEL,
     &                IAGRP,IBGRP,
     &                SB(ISOFF),CB(ICOFF),IDOH2,
     &                ADSXA,SXSTST,STSTSX,DXSTST,STSTDX,SXDXSX,
     &                NTSOB,IBTSOB,ITSOB,MAXI,MAXK,
     &                SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,
     &                C2,NSMOB,NSMST,NSMSX,NSMDX,NIA,NIB,NLLA,NLLB,
     &                MXPOBS,IPRNT,IST,CJRES,SIRES,NOPART,TimeDep)
                 End If
*
 8765           CONTINUE
*. Transpose or scale to restore order ??
                  IF(LTRP(NPERM+1).EQ.1) THEN
                    CALL TRPMAT(CB(ICOFF),NJB,NJA,C2)
                    call dcopy_(NJA*NJB,C2,1,CB(ICOFF),1)
                  END IF
                  IF(LSGN(NPERM+1).EQ.-1)
     &            CALL DSCAL_(NJA*NJB,-1.0d0,CB(ICOFF),1)
*
              END IF
              ICOFF = ICOFF + NCOOSE(JATP,JBTP,JASM)
*. NeXt C block
              IF(ICBLK.NE.NCBLK) THEN
                CALL NXTBLK_MCLR(JATP,JBTP,JASM,NOCTPA,NOCTPB,NSMST,
     &          ICBLTP,IDC,NONEWC,ICOCOC)
              END IF
 9000       CONTINUE
*. End of loop over C blocks in Batch
*. NeXt S block
           END IF
           ISOFF = ISOFF + NSOOSE(IATP,IBTP,IASM)
           IF(ISBLK.NE.NSBLK) THEN
               CALL NXTBLK_MCLR(IATP,IBTP,IASM,NOCTPA,NOCTPB,NSMST,
     &         ISBLTP,IDC,NONEWS,ISOCOC)
            END IF
10000     CONTINUE
********************************************************************
*. End of loop over S blocks in batch
*. End of loop over batches of C blocks

          IF(IFINIC.EQ.0) GOTO 9001
*. Transfer S block to permanent storage
C
*          Call RECPRT('SB in rassg4',' ',S,5,1)
C
          I1ASM = ISSTSM
          I1TA  = ISSTTA
          I1TB  = ISSTTB
          IOFF  = 1
          DO ISBLK = 1, NSBLK
           I1BSM = ISSMOS(I1ASM)
           IF(ISOCOC(I1TA,I1TB).EQ.1) THEN
            CALL PSTTBL_MCLR(S,SB(IOFF),I1TA,I1ASM,I1TB,I1BSM,ISOCOC,
     &                  NOCTPA,NOCTPB,NSSOA,NSSOB,PS,
     &                  ISOOSC,2,IDC,LUHC,C2)
           END IF
           IOFF = IOFF + NSOOSE(I1TA,I1TB,I1ASM)
           IF(ISBLK.NE.NSBLK) THEN
            CALL NXTBLK_MCLR(I1TA,I1TB,I1ASM,NOCTPA,NOCTPB,NSMST,
     &      ISBLTP,IDC,NONEWS,ISOCOC)
           END IF
          End Do
      IF(ISFINI.EQ.0) GOTO 10001
*. End of loop over batches of S blocks
10002 CONTINUE
********************************************************************
      IF(LUHC.GT.0) CALL ITODS([-1],1,LBLK,LUHC)

      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NORB1)
        CALL Unused_integer(NORB2)
        CALL Unused_integer(NORB3)
        CALL Unused_integer(NACOB)
        CALL Unused_integer_array(ISSOA)
        CALL Unused_integer_array(ISSOB)
        CALL Unused_integer(MAXIJ)
        CALL Unused_integer(ICSMOD)
        CALL Unused_integer(IINMOD)
        CALL Unused_integer(LI)
        CALL Unused_integer_array(SXSTSM)
        CALL Unused_integer_array(ASXAD)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRPMT3(XIN,NROW,NCOL,XOUT)
*
* XOUT(I,J) = XIN(J,I)
*
*. With a few considerations for large scale cases with cache minimization
*
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XIN(NROW,NCOL),XOUT(NCOL,NROW)
*
*. To get rid of annoying and incorrect compiler warnings
      IROFF = 0
      ICOFF = 0
*
      IWAY = 2
      IF(IWAY.EQ.1) THEN
*. Straightforward, no blocking
        DO IROW =1, NROW
          DO ICOL = 1, NCOL
            XOUT(ICOL,IROW) = XIN(IROW,ICOL)
          END DO
        END DO
      ELSE IF(IWAY.EQ.2) THEN
*. Simple blocking of matrix
        LRBLK = 40
        LCBLK = 40
        NRBLK = NROW/LRBLK
        NCBLK = NCOL/LCBLK
        IF(LRBLK*NRBLK.NE.NROW) NRBLK = NRBLK + 1
        IF(LCBLK*NCBLK.NE.NCOL) NCBLK = NCBLK + 1
*
        DO IRBLK = 1,NRBLK
          IF(IRBLK.EQ.1) THEN
            IROFF = 1
          ELSE
            IROFF = IROFF + LRBLK
          END IF
          IREND = MIN(NROW,IROFF+LRBLK-1)
          DO ICBLK = 1, NCBLK
            IF(ICBLK.EQ.1) THEN
              ICOFF = 1
            ELSE
              ICOFF = ICOFF + LCBLK
            END IF
            ICEND = MIN(NCOL,ICOFF+LCBLK-1)
*
            DO IROW = IROFF,IREND
              DO ICOL = ICOFF,ICEND
                XOUT(ICOL,IROW) = XIN(IROW,ICOL)
              END DO
            END DO
*
          END DO
        END DO
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine CAssmbl(Rnxyz,Axyz,la,Bxyz,lb,nZeta,HerW,nHer)
************************************************************************
*                                                                      *
* Object: to assemble the cartesian components of the multipole moment *
*         matrix within the framework of the Gauss-Hermite quadrature. *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 HerW(nHer)
      Complex*16 Rnxyz(nZeta*3,0:la,0:lb),
     &           Axyz(nZeta*3,nHer,0:la),
     &           Bxyz(nZeta*3,nHer,0:lb)
#ifdef _DARWIN_
      Complex*16 vv1, vv2
#endif
      Character*80 Label
*
      iRout = 123
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In CAssmbl:HerW',' ',HerW,1,nHer)
         Call CRecPrt(' In CAssmbl:Axyz',' ',
     &                Axyz,nZeta*3,nHer*(la+1),'R')
         Call CRecPrt(' In CAssmbl:Axyz',' ',
     &                Axyz,nZeta*3,nHer*(la+1),'I')
         Call CRecPrt(' In CAssmbl:Bxyz',' ',
     &                Bxyz,nZeta*3,nHer*(lb+1),'R')
         Call CRecPrt(' In CAssmbl:Bxyz',' ',
     &                Bxyz,nZeta*3,nHer*(lb+1),'I')
      End If
*
*     Initialize to zero
*
      Do ib = 0, lb
         Do ia = 0, la
            Do iZeta = 1, nZeta
               Rnxyz(iZeta,ia,ib)=DCMPLX(Zero,Zero)
            End Do
         End Do
      End Do
*
      Do 100 ia = 0, la
         Do 110 ib = 0, lb
*
*     Generate the cartesian components of the multipole moment
*     matrix as a sum of the value of the integrand, evaluated
*     at a root, times a weight.
*
               Do 30 iHer = 1, nHer
                  Do 10 iZCar = 1, 3*nZeta
c vv. splitted in order to make GNU compiler on Mac more happy.
#ifdef _DARWIN_
                  vv1=Axyz(iZCar,iHer,ia)
                  vv2=Bxyz(iZCar,iHer,ib)*HerW(iHer)
                  Rnxyz(iZCar,ia,ib)= Rnxyz(iZCar,ia,ib)+vv1*vv2
#else
                     Rnxyz(iZCar,ia,ib) = Rnxyz(iZCar,ia,ib) +
     &                             Axyz(iZCar,iHer,ia)*
     &                             Bxyz(iZCar,iHer,ib)*
     &                             HerW(iHer)
#endif
 10               Continue
 30            Continue
*
               If (iPrint.ge.99) Then
                  Write (Label,'(A,I2,A,I2,A)')
     &            ' In CAssmbl: Rnxyz(',ia,',',ib,')'
                  Call CRecPrt(Label,' ',Rnxyz(1,ia,ib),nZeta,3,'R')
                  Call CRecPrt(Label,' ',Rnxyz(1,ia,ib),nZeta,3,'I')
               End If
 110     Continue
 100  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dWdR(R,iNQ,Weights,list_p,nlist_p,invlist,dW_dR,nGrad_Eff,iTab,dW_Temp,dPB,nGrid)

use NQ_Structure, only: NQ_data
use nq_Grid, only: Pax
use nq_Info, only: On, Rotational_Invariance
use Constants, only: Zero, One, Two, Three, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iNQ, nlist_p, list_p(nlist_p), invlist(*), nGrad_Eff, iTab(4,nGrad_Eff), nGrid
real(kind=wp), intent(in) :: R(3,nGrid), Weights(nGrid)
real(kind=wp), intent(out) :: dW_dR(nGrad_Eff,nGrid), dW_Temp(3,nlist_p), dPB(3,nlist_p,nlist_p)
integer(kind=iwp) :: iA, iB, iC, iCar, iD, iGrad, iGrid, iiB, jNQ, kNQ, lNQ
real(kind=wp) :: dmu_BC_dA(3), dmu_BC_dB(3), dmu_BC_dC(3), dOdxs(3), dZ_dB(3), Fact, Osxyz(3), P_A, P_B, r_B, R_BC, R_BCxyz(3), &
                 r_Bxyz(3), r_C, r_Cxyz(3), rMU_BC, s_MU_BC, sxyz(3), temp, tMU_BC, xdiff0, xdiff1, xdiff2, xdiff3, Z
real(kind=wp), parameter :: Thrs = 1.0e-20_wp

!                                                                      *
!***********************************************************************
!                                                                      *
! See J. Chem. Phys. 98 (1993) 5612 doi:10.1063/1.464906
!                                                                      *
!***********************************************************************
!                                                                      *
! iNQ is the index of the current atomic grid to which these grid points belong.

iA = invlist(iNQ)
!                                                                      *
!***********************************************************************
!                                                                      *
dW_dR(:,1:nGrid) = Zero
do_grid: do iGrid=1,nGrid
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! The current grid point is associated with center A and the
  ! "atomic" displacement vector relative to center A is computed.

  Osxyz(:) = R(:,iGrid)-NQ_data(iNQ)%Coor(:)

  sxyz(1) = sum(Pax(:,1)*Osxyz(:))
  sxyz(2) = sum(Pax(:,2)*Osxyz(:))
  sxyz(3) = sum(Pax(:,3)*Osxyz(:))

  Z = Zero
  dPB(:,:,:) = Zero

  ! Compute all P_B and corresponding derivatives.

  !P_A = Zero
  P_A = One ! Dummy set
  do iiB=1,nlist_p
    if (iiB == 1) then
      iB = iA
    else if (iiB == iA) then
      iB = 1
    else
      iB = iiB
    end if

    kNQ = list_p(iB)
    r_Bxyz(:) = R(:,iGrid)-NQ_Data(kNQ)%Coor(:)
    r_B = sqrt(sum(r_Bxyz(:)**2))

    ! loop over C=/=B for all s(mu_BC), see Eq. B3

    P_B = One
    do iC=1,nlist_p

      if (iC /= iB) then
        lNQ = list_p(iC)
        r_Cxyz(:) = R(:,iGrid)-NQ_Data(lNQ)%Coor(:)
        r_C = sqrt(sum(r_Cxyz(:)**2))
        R_BCxyz(:) = NQ_Data(kNQ)%Coor(:)-NQ_Data(lNQ)%Coor(:)
        R_BC = sqrt(sum(R_BCxyz(:)**2))

        ! Eq. B6

        rMU_BC = (r_B-r_C)/R_BC
        if (rMU_BC <= Half) then
          xdiff0 = rMU_BC
          xdiff1 = (xdiff0*Half)*(Three-xdiff0**2)
          xdiff2 = (xdiff1*Half)*(Three-xdiff1**2)
          xdiff3 = (xdiff2*Half)*(Three-xdiff2**2)

          ! Eq. B4

          s_MU_BC = Half*(One-xdiff3)

          P_B = P_B*s_MU_BC
          if (P_B <= Thrs) exit
          tMU_BC = -27.0_wp*(One-xdiff2**2)*(One-xdiff1**2)*(One-rMU_BC**2)/(16.0_wp*max(s_MU_BC,1.0e-99_wp))
        else
          xdiff0 = rMU_BC-One
          xdiff1 = (-OneHalf-Half*xdiff0)*xdiff0**2
          xdiff2 = (-OneHalf-Half*xdiff1)*xdiff1**2
          xdiff3 = (-OneHalf-Half*xdiff2)*xdiff2**2
          s_MU_BC = -Half*xdiff3

          P_B = P_B*s_MU_BC
          if (P_B <= Thrs) exit
          tMU_BC = 27.0_wp*(Two+xdiff2)*xdiff2*(Two+xdiff1)*xdiff1*(Two+xdiff0)*xdiff0/(16.0_wp*max(s_MU_BC,1.0e-99_wp))
        end if

        ! Differentiate mu_BC with respect to the center, D.

        do iD=1,nlist_p
          !jNQ = list_p(iD)

          if (iD == iB) then

            ! d mu_BC(r_A) / dB, Eq. B10

            if (r_B == Zero) then
              dmu_BC_dB(:) = r_C*R_BCxyz(:)/R_BC**3
            else
              dmu_BC_dB(:) = -r_Bxyz(:)/(r_B*R_BC)-(r_B-r_C)*R_BCxyz(:)/R_BC**3
            end if

            dPB(:,iB,iB) = dPB(:,iB,iB)+tMU_BC*dmu_BC_dB(:)

          else if (iD == iC) then

            ! d mu_BC(r_A) / dC, Eq, B10

            if (r_C == Zero) then
              dmu_BC_dC(:) = r_B*R_BCxyz(:)/R_BC**3
            else
              dmu_BC_dC(:) = r_Cxyz(:)/(r_C*R_BC)+(r_B-r_C)*R_BCxyz(:)/R_BC**3
            end if
            dPB(:,iC,iB) = dPB(:,iC,iB)+tMU_BC*dmu_BC_dC(:)

          end if

          ! d mu_BC(r_A) / dr_A

          if (r_B == Zero) then
            dmu_BC_dA(:) = (-r_Cxyz(:)/r_C)/R_BC
          else if (r_C == Zero) then
            dmu_BC_dA(:) = (r_Bxyz(:)/r_B)/R_BC
          else
            dmu_BC_dA(:) = (r_Bxyz(:)/r_B-r_Cxyz(:)/r_C)/R_BC
          end if

          ! The direct term

          if (iD == iA) dPB(:,iA,iB) = dPB(:,iA,iB)+tMU_BC*dmu_BC_dA(:)

          if (Rotational_Invariance == On) then
            jNQ = list_p(iD)
            do iCar=1,3
              dOdxs(1) = sum(NQ_Data(jNQ)%dOdx(1,:,iCar)*sxyz(:))
              dOdxs(2) = sum(NQ_Data(jNQ)%dOdx(2,:,iCar)*sxyz(:))
              dOdxs(3) = sum(NQ_Data(jNQ)%dOdx(3,:,iCar)*sxyz(:))
              temp = tMU_BC*sum(dmu_BC_dA(:)*dOdxs(:))

              dPB(iCar,iD,iB) = dPB(iCar,iD,iB)+temp
            end do
          end if

        end do ! iD

      end if
    end do     ! iC

    ! Multiply derivatives with P_B as in Eq. B8

    dPB(:,:,iB) = P_B*dPB(:,:,iB)

    if (iB == iA) P_A = P_B
    if (P_A <= Thrs) cycle do_grid

    ! Denominator Eq. B2
    Z = Z+P_B
  end do ! iB

  if (P_A == Zero) then
    Fact = Zero
  else
    Fact = Weights(iGrid)*Z/P_A
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Assemble the gradient

  do iB=1,nlist_p

    dZ_dB(1) = sum(dPB(1,iB,:))
    dZ_dB(2) = sum(dPB(2,iB,:))
    dZ_dB(3) = sum(dPB(3,iB,:))

    ! Eq. B7

    dW_Temp(:,iB) = dPB(:,iB,iA)/Z-(P_A*dZ_dB(:))/Z**2
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Pick up the relevant gradients

  do iB=1,nlist_p
    kNQ = list_p(iB)
    do iGrad=1,nGrad_Eff
      if (iTab(3,iGrad) /= kNQ) cycle
      iCar = iTab(1,iGrad)
      dW_dR(iGrad,iGrid) = Fact*dW_Temp(iCar,invlist(kNQ))
    end do
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end do do_grid ! iGrid
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine dWdR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Danjo De Chavez                                  *
!***********************************************************************
!  matexp
!
!> @brief  Compute the exponential of the U matrix
!> @author Danjo De Chavez (2022)
!>
!> @details
!> Computes the exponential of an antisymmetric real matrix U through
!> a modified Taylor expansion of the K matrix. This takes advantage of the
!> subblocks and trend in the powers of K matrix. \cite Sei2022-JCTC-18-4164
!>
!> \note
!> Some equations in the reference are wrong.
!>
!> @param[in]     N        Size of the square matrix
!> @param[in]     No       Number of Occupied Orbitals
!> @param[in,out] U        U matrix is replaced by its exponential
!***********************************************************************

subroutine matexp(N,No,U)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none

integer(kind=iwp), intent(in) :: N, No
real(kind=wp), intent(inout)  :: U(N,N)

integer(kind=iwp)  :: Nv
integer(kind=iwp)  :: count, i

real(kind=wp), parameter :: thrsh = 1.0D-20
real(kind=wp) :: ithrsh, ithrshoo, ithrshvv, ithrshvo, factor

real(kind=wp), allocatable :: Uoo(:,:), xUoo(:,:), Koo(:,:)
real(kind=wp), allocatable :: Uvv(:,:), xUvv(:,:), Kvv(:,:)
real(kind=wp), allocatable :: Uvo(:,:), xUvo(:,:), Kvo(:,:)
real(kind=wp), allocatable :: Uov(:,:)
real(kind=wp), allocatable :: theta(:,:)

if (N < 1) return
Nv = N-No

call mma_allocate(theta,Nv,No,label='theta')

call mma_allocate(Koo,No,No,label='Koo')
call mma_allocate(Kvv,Nv,Nv,label='Kvv')
call mma_allocate(Kvo,Nv,No,label='Kvo')

call mma_allocate(Uoo,No,No,label='Uoo')
call mma_allocate(Uvv,Nv,Nv,label='Uvv')
call mma_allocate(Uov,No,Nv,label='Uov')
call mma_allocate(Uvo,Nv,No,label='Uvo')

call mma_allocate(xUoo,No,No,label='xUoo')
call mma_allocate(xUvv,Nv,Nv,label='xUvv')
call mma_allocate(xUvo,Nv,No,label='xUvo')

theta(:,:) = U(No+1:N,:No)

U(:,:) = Zero

count  = 1
factor = One

ithrsh = 2.0E-16_wp

! Initialization
! Taylor expansion terms to n=1

Uov(:,:) = Zero
Uvo(:,:) = Zero

Uoo(:,:) = Zero

xUoo(:,:) = Zero
xUvv(:,:) = Zero
xUvo(:,:) = Zero

do i=1,No
  Uoo(i,i) = One
end do

Uvv(:,:) = Zero

do i=1,Nv
  Uvv(i,i) = One
end do

Kvo(:,:) = theta
Uvo(:,:) = theta

! Main Loop
! Taylor expansion terms from n=2 to convergence

do while (thrsh < ithrsh)
  count = count+1

  if (mod(count,2)==0) then
    call dgemm_('T','N',No,No,Nv,One,-theta,Nv,Kvo,Nv,Zero,Koo,No)
    call dgemm_('N','T',Nv,Nv,No,One,Kvo,Nv,-theta,Nv,Zero,Kvv,Nv)
    factor = factor*count
    Uoo(:,:) = Uoo + Koo/factor
    Uvv(:,:) = Uvv + Kvv/factor

  else
    call dgemm_('N','N',Nv,No,No,One,theta,Nv,Koo,No,Zero,Kvo,Nv)
    factor = factor*count
    Uvo(:,:) = Uvo + Kvo/factor

    ithrshoo = maxval(abs(Uoo-xUoo)/(abs(Uoo)+thrsh))
    ithrshvv = maxval(abs(Uvv-xUvv)/(abs(Uvv)+thrsh))
    ithrshvo = maxval(abs(Uvo-xUvo)/(abs(Uvo)+thrsh))
    ithrsh   = max(ithrshoo, ithrshvv, ithrshvo)

    xUoo(:,:) = Uoo
    xUvv(:,:) = Uvv
    xUvo(:,:) = Uvo

  end if
end do

Uov(:,:) = -transpose(Uvo)

U(:No,:No)       = Uoo
U(No+1:N,:No)    = Uvo
U(:No,No+1:N)    = Uov
U(No+1:N,No+1:N) = Uvv

call mma_deallocate(Koo)
call mma_deallocate(Kvv)
call mma_deallocate(Kvo)

call mma_deallocate(Uoo)
call mma_deallocate(Uvv)
call mma_deallocate(Uov)
call mma_deallocate(Uvo)

call mma_deallocate(xUoo)
call mma_deallocate(xUvv)
call mma_deallocate(xUvo)

call mma_deallocate(theta)

return

end subroutine matexp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE expx(x,x2,y,v,a,b,thmax,n)
c
c     RASSCF Program version IBM-3090: SX section
c
c     Purpose: This subroutine computes exp(X), where X is formed
c              from the super-CI coefficient matrix C for one symmetry
c              block.
c              The resulting matrix exp(X) is stored in X,
c              the input matrix X is thus destroyed.
c              exp(X) = 1 + V*a*V(+) + V*b*V(+)*X   where
c              V is the matrix of eigenvectors of the Hermitian matrix X**2
c              a is a diagonal matrix: a(ii) = cos(theta(i)) - 1
c              b is a diagonal matrix: b(ii) = sin(theta(i))/theta(i)
c              with theta(i)**2 = -eps(i)
c              eps(i) are the eigenvalues of X**2
c              X has dimension N*N
c
c          ********** IBM-3090 MOLCAS Release: 90 02 22 **********
c
      IMPLICIT REAL*8 (a-h,o-z)
#include "output_ras.fh"
      Parameter (Routine='EXPX')
#include "warnings.fh"

      DIMENSION x(*), x2(*), v(*), a(*), b(*), y(*)

c
c     square the matrix X into the symmetric matrix X2
c
      ij=0
      i1=1
      DO i=1,n
        j1=1
        DO j=1,i
          ij=ij+1
          x2(ij)=-ddot_(n,x(i1),1,x(j1),1)
          j1=j1+n
        END DO
        i1=i1+n
      END DO
c
c     NOW DIAGONALIZE X2
c
      call dcopy_(n*n, [0.0d0], 0, v, 1)
      call dcopy_(n, [1.0d0], 0, v, n+1)
      CALL Jacob (x2, v, n, n)
c
c     CHECK FOR SMALL VALUES OF THE EIGENVALUES
c
      ii=0
      epsmin=0.0d00
      DO i=1,n
        ii=ii+i
        eps=x2(ii)
        epsmin=min(epsmin,eps)
* PAM 2008: The following test is essentially a sanity check of the code.
* But this code has always worked nicely for years, and no longer needs
* this checking. However, the test can be inadvertently triggered occasionally
* due to extreme rounding errors. Rather than using an arbitrary threshold,
* I now deactivate this test.
*        IF (eps.gt.1.0d-8) THEN
*          Write(LF,*)
*          Write(LF,'(6X,120A1)') ('=',j=1,120)
*          Write(LF,*)
*          Write(LF,'(6X,A)') 'EXPX Error: '//
*     &    'A positive eigenvalue has been found in subroutine EXPX !!!'
*          Write(LF,'(6X,A)')
*     &    'This is possible only if there is a severe malfunction     '
*          Write(LF,'(6X,A)')
*     &    'of the program. Please issue a bug report.'
*          Write(LF,'(6X,A,E20.6)') 'eps=',eps
*          Call Quit(_RC_INTERNAL_ERROR_)
*        END IF
        IF (eps.gt.0.0D0) eps=0.0D0
        IF (eps.gt.-3.0d-7) THEN
          a(i)=eps/2.0D0
          b(i)=1.0d0+eps/6.0D0
        ELSE IF (eps.gt.-3.0D-4) THEN
          a(i)=(eps/2.0D0)*(1.0D0+eps/12.0D0)
          b(i)=1.0d0+(eps/6.0D0)*(1.0D0+eps/20.0D0)
        ELSE IF (eps.gt.-1.0D-3) THEN
          a(i)=(eps/2.0D0)*(1.0D0+(eps/12.0D0)*(1.0D0+eps/30.0D0))
          b(i)=1.0d0+(eps/6.0D0)*
     &                    (1.0D0+(eps/20.0D0)*(1.0D0+eps/42.0D0))
        ELSE
          theta=sqrt(-eps)
          a(i)=cos(theta)-1.0D0
          b(i)=sin(theta)/theta
        END IF
      END DO
      thmax=sqrt(-epsmin)
c
c     NOW FORM THE MATRIX EXP(X)=1+V*A*V(+)+V*B*V(+)*X
c     FIRST FORM THE MATRIX Y = V(+)*X
c
      CALL DGEMM_('T','N',
     &            n,n,n,
     &            1.0d0,v,n,
     &            x,n,
     &            0.0d0,y,n)
c
c     MULTIPLY Y IN PLACE WITH THE DIAGONAL MATRIX B
c
      DO i=1,n
        call dscal_(n, b(i), y(i), n)
      END DO
c
c     ADD A*V(+)
c
      CALL dnaxpy (n, n, a, 1, v, 1, n, y, n, 1)
c
c     MULTIPLY V WITH Y TO OBTAIN EXP(X)-1
c     STORE THE RESULT IN THE MATRIX X
c
      CALL DGEMM_('N','N',
     &            n,n,n,
     &            1.0d0,v,n,
     &            y,n,
     &            0.0d0,x,n)
C Finally, add 1 to obtain exp(x)
      do i=1,n**2,(n+1)
        x(i)=x(i)+1.0D0
      end do
c
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mkciinfo2_cvb(i1alf,i1bet,iafrm,ibfrm,iato,ibto,
     >  phato,phbto,
     >  xalf,xbet,xalf2,xbet2,mingrph,maxgrph,
     >  nk,locc,lunocc,inewocc,iaccm)
      implicit real*8 (a-h,o-w,y-z),integer(x)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension i1alf(n1a,norb),i1bet(n1b,norb)
      dimension iafrm(norb,nda),ibfrm(norb,ndb)
      dimension iato(norb,0:nam1),ibto(norb,0:nbm1)
      dimension phato(norb,nam1),phbto(norb,nbm1)
      dimension xalf(0:norb,0:nalf),xbet(0:norb,0:nbet)
      dimension xalf2(0:norb,0:nalf-1),xbet2(0:norb,0:nbet-1)
      dimension mingrph(0:norb),maxgrph(0:norb)
      dimension nk(0:norb),locc(norb+1),lunocc(norb+1)
      dimension inewocc(norb),iaccm(norb)

      call izero(iafrm,nda*norb)
      call izero(ibfrm,ndb*norb)
      call izero(iato,(nam1+1)*norb)
      call izero(ibto,(nbm1+1)*norb)
      call fzero(phato,nam1*norb)
      call fzero(phbto,nbm1*norb)
c Alpha loop:
      call izero(iaccm,norb)
      do 100 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nalf,0)
      maxgrph(iorb)=min(iorb,nalf)
100   continue
      call weight_cvb(xalf,mingrph,maxgrph,nalf,norb)
      call imove_cvb(maxgrph,nk,norb+1)
      call occupy_cvb(nk,norb,locc,lunocc)
      index=1
200   continue
      call izero(inewocc,norb)
      do 300 i=1,nalf
      inewocc(locc(i))=1
300   continue
      do 325 iel=1,norb
      if(inewocc(iel).eq.1)then
        iaccm(iel)=iaccm(iel)+1
        i1alf(iaccm(iel),iel)=index
      endif
325   continue
c Indexing arrays :
      do 350 i=1,nalf
      inewocc(locc(i))=0
      iafrm(locc(i),index)=indget_cvb(inewocc,nalf,norb,xalf)
      inewocc(locc(i))=1
350   continue
      call loind_cvb(norb,nalf,nk,mingrph,maxgrph,
     >                       locc,lunocc,index,xalf,*200)
c Beta loop:
      call izero(iaccm,norb)
      do 400 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nbet,0)
      maxgrph(iorb)=min(iorb,nbet)
400   continue
      call weight_cvb(xbet,mingrph,maxgrph,nbet,norb)
      call imove_cvb(maxgrph,nk,norb+1)
      call occupy_cvb(nk,norb,locc,lunocc)
      index=1
500   continue
      call izero(inewocc,norb)
      do 600 i=1,nbet
      inewocc(locc(i))=1
600   continue
      do 625 iel=1,norb
      if(inewocc(iel).eq.1)then
        iaccm(iel)=iaccm(iel)+1
        i1bet(iaccm(iel),iel)=index
      endif
625   continue
c Indexing arrays :
      do 650 i=1,nbet
      inewocc(locc(i))=0
      ibfrm(locc(i),index)=indget_cvb(inewocc,nbet,norb,xbet)
      inewocc(locc(i))=1
650   continue
      call loind_cvb(norb,nbet,nk,mingrph,maxgrph,
     >                       locc,lunocc,index,xbet,*500)

c  Altered definitions of I1ALF & I1BET :
      do 700 iorb=1,norb
      do 701 ia=1,n1a
      iax=i1alf(ia,iorb)
      iaxtmp=iafrm(iorb,iax)
      i1alf(ia,iorb)=iaxtmp
701   continue
700   continue
      if(absym(4))then
c  I1ALF & I1BET may share memory:
        if(iiloc(i1alf).ne.iiloc(i1bet))
     >    call imove_cvb(i1alf,i1bet,norb*n1a)
      else
        do 800 iorb=1,norb
        do 801 ib=1,n1b
        ibx=i1bet(ib,iorb)
        ibxtmp=ibfrm(iorb,ibx)
        i1bet(ib,iorb)=ibxtmp
801     continue
800     continue
      endif
c More indexing arrays :
c Second alpha loop (NALF-1):
      do 1100 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nalf-1,0)
      maxgrph(iorb)=min(iorb,nalf-1)
1100  continue
      call weight_cvb(xalf2,mingrph,maxgrph,nalf-1,norb)
      call imove_cvb(maxgrph,nk,norb+1)
      call occupy_cvb(nk,norb,locc,lunocc)
      index=1
1200  continue
      call izero(inewocc,norb)
      do 1300 i=1,nalf-1
      inewocc(locc(i))=1
1300  continue
      do 1350 i=1,norb-nalf+1
      inewocc(lunocc(i))=1
      iato(lunocc(i),index)=indget_cvb(inewocc,nalf,norb,xalf)
      inewocc(lunocc(i))=0
      if(mod(nalf+i+1+lunocc(i),2).eq.0)then
        phato(lunocc(i),index)= one
      else
        phato(lunocc(i),index)=-one
      endif
1350  continue
      call loind_cvb(norb,nalf-1,nk,mingrph,maxgrph,
     >                       locc,lunocc,index,xalf2,*1200)

      if(nbet.le.0)goto 1700
c Second beta loop (NBET-1):
      do 1400 iorb=0,norb
      mingrph(iorb)=max(iorb-norb+nbet-1,0)
      maxgrph(iorb)=min(iorb,nbet-1)
1400  continue
      call weight_cvb(xbet2,mingrph,maxgrph,nbet-1,norb)
      call imove_cvb(maxgrph,nk,norb+1)
      call occupy_cvb(nk,norb,locc,lunocc)
      index=1
1500  continue
      call izero(inewocc,norb)
      do 1600 i=1,nbet-1
      inewocc(locc(i))=1
1600  continue
      do 1650 i=1,norb-nbet+1
      inewocc(lunocc(i))=1
      ibto(lunocc(i),index)=indget_cvb(inewocc,nbet,norb,xbet)
      inewocc(lunocc(i))=0
      if(mod(nbet+i+1+lunocc(i),2).eq.0)then
        phbto(lunocc(i),index)= one
      else
        phbto(lunocc(i),index)=-one
      endif
1650  continue
      call loind_cvb(norb,nbet-1,nk,mingrph,maxgrph,
     >                       locc,lunocc,index,xbet2,*1500)
1700  continue
      return
      end
c  ****************************************
c  ** Routines involving CI, ORBS and VB **
c  ****************************************
c  *********************************************************************
c  *                                                                   *
c  *  EXC1   := apply combination of single-excitations                *
c  *  DENS1  := calculate one-electron (transition) density            *
c  *                                                                   *
c  *  :> Icfrom:    right-hand vector                                  *
c  *  :> Icto:      left-hand vector (dens1: input exc1: output)       *
c  *  :> vij:       Orbital matrix (exc1: input dens1: output)         *
c  *  :> diag:      Include diagonal of vij?                           *
c  *  :> iPvb:      Include Pvb (0: no, 1: on left, 2: on right)       *
c  *                                                                   *
c  *  :< Icto:      left-hand vector (dens1: input exc1: output)       *
c  *  :< vij:       Orbital matrix (exc1: input dens1: output)         *
c  *                                                                   *
c  *********************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine WrDisk(rIn,nrIn,jDisp,iIrrep)
! Sorry about this litle subroutine
! The reason is just that right now I want to use AO for SCF
! and MO for RASSCF, this will hopefully be changed, but if you
! see this mess before that I apologize

use McKinley_global, only: ipDisp, ipDisp2, ipDisp3, ipMO, nMethod, RASSCF
use Index_Functions, only: iTri, nTri_Elem
use Basis_Info, only: nBas
use pso_stuff, only: CMO, G1
use Symmetry_Info, only: iOper, nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(in) :: nrIn, jDisp, iIrrep
real(kind=wp), intent(in) :: rIn(nrIn)
#include "etwas.fh"
#include "print.fh"
integer(kind=iwp) :: iii, iopt, ip(0:7), ip2(0:7), ipCC, ipCM(0:7), ipIn1, ipOut, irc, jAsh, jIrrep, kAsh, kIrrep, nA(0:7), nin, &
                     nIn2, nna
real(kind=wp) :: rDe
integer(kind=iwp) :: n
character(len=8) :: Label
real(kind=wp), allocatable :: Act(:), InAct(:), rOut(:), TempX(:), TempY(:)
integer(kind=iwp), external :: NrOpr
real(kind=r8), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
if (Show) then
  write(u6,*)
  write(u6,*) '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
  write(u6,*)
  write(u6,*) 'jDisp=',jDisp
end if
nin = 0
nIn2 = 0
nna = 0
ipCC = 1
do jIrrep=0,nIrrep-1
  kIrrep = NrOpr(ieor(iOper(jIrrep),iOper(iIrrep)))
  if (kIrrep < jIrrep) then
    ip(jIrrep) = nIn
    nIn = nIN+nBas(kIrrep)*nBas(jIrrep)
  else if (kIrrep == jIrrep) then
    ip(jIrrep) = nIn
    nIn = nIN+nTri_Elem(nBas(kIrrep))
  end if
  ip2(kIrrep) = nIn2
  nIn2 = nIn2+nBas(kIrrep)*nBas(jIrrep)
  nA(jIrrep) = nnA
  nnA = nnA+nAsh(jIrrep)
  ipCM(jIrrep) = ipCC
  ipCC = ipCC+nBas(jIrrep)**2
# ifdef __INTEL_COMPILER
  ! To avoid error in intel optimization -O3
  if (.false.) write(u6,*) ip(jIrrep)
# endif
end do
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_allocate(Act,nIn2,Label='Act')
Act(:) = Zero
call mma_allocate(InAct,nIn2,Label='InAct')
InAct(:) = Zero
call mma_allocate(rOut,nIn2,Label='rOut')
rOut(:) = Zero
call mma_allocate(TempX,nIn2,Label='TempX')
call mma_allocate(TempY,nIn2,Label='TempY')
!                                                                      *
!***********************************************************************
!                                                                      *
! Fock1

if (Show) then
  write(u6,*)
  write(u6,*) 'Fock1'
  write(u6,*)
end if
do jIrrep=0,nIrrep-1
  kIrrep = NrOpr(ieor(iOper(jIrrep),iOper(iIrrep)))
  if ((nBAs(jIrrep) > 0) .and. (nbas(kIrrep) > 0)) then
    if (kIrrep < jIrrep) then
      call DGEMM_('N','N',nBas(jIrrep),nBas(kIrrep),nBas(kIrrep),One,rIn(ipDisp(jDisp)+ip(jIrrep)),nBas(jIrrep), &
                  CMO(ipCM(kIrrep),1),nBas(kIrrep),Zero,TempY,nBas(jIrrep))
      call DGEMM_('T','N',nBas(jIrrep),nBas(kirrep),nBas(jIrrep),One,CMO(ipCM(jIrrep),1),nBas(jIrrep),TempY,nBas(jIrrep),Zero, &
                  Act(1+ip2(kIrrep)),nBas(jIrrep))
      if (Show) then
        write(u6,*)
        write(u6,*) 'ipDisp(jDisp),ip(jIrrep)=',ipDisp(jDisp),ip(jIrrep)
        call RecPrt('ipDisp',' ',rIn(ipDisp(jDisp)+ip(jIrrep)),nBas(jIrrep),nBas(kIrrep))
        write(u6,'(A,G20.10)') 'ipDisp:', &
                               DDot_(nBas(jIrrep)*nBas(kIrrep),rIn(ipDisp(jDisp)+ip(jIrrep)),1,rIn(ipDisp(jDisp)+ip(jIrrep)),1)
        write(u6,'(A,G20.10)') 'ipCM(kIrrep):',DDot_(nBas(kIrrep)*nBas(kIrrep),CMO(ipCM(kIrrep),1),1,CMO(ipCM(kIrrep),1),1)
        write(u6,'(A,G20.10)') 'ipCM(jIrrep):',DDot_(nBas(jIrrep)*nBas(jIrrep),CMO(ipCM(jIrrep),1),1,CMO(ipCM(jIrrep),1),1)
      end if
      call DGetMO(Act(1+ip2(kIrrep)),Nbas(jIrrep),nbas(jIrrep),nBas(kIrrep),Act(1+ip2(jIrrep)),nBas(kIrrep))
    else if (kIrrep == jIrrep) then
      call Square(rIn(ipDisp(jDisp)+ip(jIrrep)),TempX,1,nBas(kirrep),nBas(kirrep))
      call DGEMM_('N','N',nBas(jIrrep),nBas(kIrrep),nBas(kIrrep),One,TempX,nBas(jIrrep),CMO(ipCM(kIrrep),1),nBas(kIrrep),Zero, &
                  TempY,nBas(jIrrep))
      call DGEMM_('T','N',nBas(jIrrep),nBas(kirrep),nBas(jIrrep),One,CMO(ipCM(jIrrep),1),nBas(jIrrep),TempY,nBas(jIrrep),Zero, &
                  Act(1+ip2(jIrrep)),nBas(jIrrep))
    end if
    if (Show) then
      write(u6,*) 'jIrrep,kIrrep=',jIrrep,kIrrep
      write(u6,'(A,G20.10)') 'Act:',DDot_(nIn2,Act,1,Act,1)
    end if
  end if
end do
!                                                                      *
!***********************************************************************
!                                                                      *

if (nMethod == RASSCF) then

  ! Fock2

  if (Show) then
    write(u6,*)
    write(u6,*) 'Fock2'
    write(u6,*)
  end if
  do jIrrep=0,nIrrep-1
    kIrrep = NrOpr(ieor(iOper(jIrrep),iOper(iIrrep)))
    if ((nBas(jIrrep) > 0) .and. (nBas(kIrrep) > 0)) then
      if (kIrrep == jIrrep) then
        call Square(rIn(ipDisp2(jDisp)+ip(jIrrep)),TempX,1,nBas(kirrep),nBas(kirrep))
        call DGEMM_('N','N',nBas(jIrrep),nBas(kIrrep),nBas(kIrrep),One,TempX,nBas(jIrrep),CMO(ipCM(kIrrep),1),nBas(kIrrep),Zero, &
                    TempY,nBas(jIrrep))
        call DGEMM_('T','N',nBas(jIrrep),nBas(kirrep),nBas(jIrrep),One,CMO(ipCM(jIrrep),1),nBas(jIrrep),TempY,nBas(jIrrep),Zero, &
                    InAct(1+ip2(jIrrep)),nBas(jIrrep))
      else if (kirrep < jirrep) then
        call DGEMM_('N','N',nBas(jIrrep),nBas(kIrrep),nBas(kIrrep),One,rIn(ipDisp2(jDisp)+ip(jIrrep)),nBas(jIrrep), &
                    CMO(ipCM(kIrrep),1),nBas(kIrrep),Zero,TempY,nBas(jIrrep))
        call DGEMM_('T','N',nBas(jIrrep),nBas(kirrep),nBas(jIrrep),One,CMO(ipCM(jIrrep),1),nBas(jIrrep),TempY,nBas(jIrrep),Zero, &
                    InAct(1+ip2(kIrrep)),nBas(jIrrep))
        call DGetMO(InAct(1+ip2(kIrrep)),Nbas(jIrrep),nBas(jIrrep),nBas(kIrrep),InAct(1+ip2(jIrrep)),nBas(kIrrep))
      end if
      if (Show) then
        write(u6,*) 'jIrrep,kIrrep=',jIrrep,kIrrep
        write(u6,'(A,G20.10)') 'InAct:',DDot_(nIn2,InAct,1,InAct,1)
      end if
    end if
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Fock Tot

  if (Show) then
    write(u6,*)
    write(u6,*) 'Fock Tot'
    write(u6,*)
  end if
  iii = 0
  do jIrrep=0,nIrrep-1
    kIrrep = NrOpr(ieor(iOper(jIrrep),iOper(iIrrep)))

    if (nBas(jIrrep)*nIsh(kIrrep) > 0) then
      n = nIsh(kIrrep)*nBas(jIrrep)
      rOut(ip2(kIrrep)+1:ip2(kIrrep)+n) = rOut(ip2(kIrrep)+1:ip2(kIrrep)+n)+ &
                                          Two*(Act(ip2(kIrrep)+1:ip2(kIrrep)+n)+InAct(ip2(kIrrep)+1:ip2(kIrrep)+n))
    end if

    if (nBas(jIrrep) > 0) then
      do jAsh=1,nAsh(kIrrep)
        do kAsh=1,nAsh(kIrrep)
          rDe = G1(iTri(nA(kIrrep)+jAsh,nA(kIrrep)+kAsh),1)
          ipOut = 1+ip2(kIrrep)+nIsh(kIrrep)*nBas(jIrrep)+nBas(jIrrep)*(kAsh-1)
          ipIn1 = 1+ip2(kIrrep)+nBas(jIrrep)*(jAsh-1+nIsh(kIrrep))
          rOut(ipOut:ipOut+nBas(jIrrep)-1) = rOut(ipOut:ipOut+nBas(jIrrep)-1)+rde*InAct(ipIn1:ipIn1+nBas(jIrrep)-1)
        end do
      end do
    end if

    if (nBas(jIrrep)*nAsh(kIrrep) > 0) then
      ipOut = 1+ip2(kIrrep)+nIsh(kIrrep)*nBas(jIrrep)
      if (Show) then
        write(u6,*) 'jIrrep,kIrrep=',jIrrep,kIrrep
        write(u6,'(A,G20.10)') 'ipDisp3:',DDot_(nBas(jIrrep)*nAsh(kIrrep),rIn(ipDisp3(jDisp)+iii),1,rIn(ipDisp3(jDisp)+iii),1)
      end if
      call DGEMM_('T','N',nBas(jIrrep),nAsh(kIrrep),nBas(jIrrep),One,CMO(ipCM(jIrrep),1),nBas(jIrrep),rIn(ipDisp3(jDisp)+iii), &
                  nBas(jIrrep),Zero,TempY,nBas(jIrrep))
      n = nAsh(kIrrep)*nBas(jIrrep)
      rOut(ipOut:ipOut+n-1) = rOut(ipOut:ipOut+n-1)+TempY(1:n)
      iii = iii+nBas(jIrrep)*nAsh(kIrrep)
    end if
#   ifdef __INTEL_COMPILER
    if (.false.) write(u6,*) kIrrep,iii
#   endif
    if (Show) then
      write(u6,*) 'jIrrep,kIrrep=',jIrrep,kIrrep
      write(u6,'(A,G20.10)') 'rOut:',DDot_(nIn2,rOut,1,rOut,1)
    end if
  end do
  if (Show) write(u6,*)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  irc = -1
  iopt = 0
  Label = 'TOTAL'
  call dWrMck(irc,iopt,Label,jdisp,rOut,2**iIrrep)
  if (iRc /= 0) then
    write(u6,*) 'WrDisk: Error writing to MCKINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if
  if (Show) then
    write(u6,'(A,G20.10)') 'TOTAL:',DDot_(nIn2,rOut,1,rOut,1)
  end if

  irc = -1
  iopt = 0
  Label = 'INACTIVE'
  call dWrMck(irc,iopt,Label,jdisp,InAct,2**iIrrep)
  if (iRc /= 0) then
    write(u6,*) 'WrDisk: Error writing to MCKINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if
  if (Show) then
    write(u6,'(A,G20.10)') 'INACTIVE:',DDot_(nIn2,InAct,1,InAct,1)
    write(u6,*)
  end if

  irc = -1
  iopt = 0
  Label = 'MOPERT'
  call dWrMck(irc,iopt,Label,jdisp,rIn(ipMO(jdisp)),2**iIrrep)
  if (iRc /= 0) then
    write(u6,*) 'WrDisk: Error writing to MCKINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! SCF case
  irc = -1
  iopt = 0
  Label = 'TOTAL'
  call dWrMck(irc,iopt,Label,jdisp,Act,2**iIrrep)
  if (iRc /= 0) then
    write(u6,*) 'WrDisk: Error writing to MCKINT'
    write(u6,'(A,A)') 'Label=',Label
    call Abend()
  end if
  if (Show) then
    write(u6,'(A,G20.10)') 'TOTAL:',DDot_(nIn2,Act,1,Act,1)
  end if

end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(TempY)
call mma_deallocate(TempX)
call mma_deallocate(rOut)
call mma_deallocate(InAct)
call mma_deallocate(Act)
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine WrDisk

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine OLDFCM(ipH,nQQ,nsAtom,iPrint,RunOld)
      Implicit Real*8 (a-h,o-z)
************************************************************************
*                                                                      *
*     Object : To read in a force constant matrix from another         *
*              interphase.                                             *
*                                                                      *
************************************************************************
#include "WrkSpc.fh"
      Character*8 Method
      Character*(*) RunOld
      Logical Found
*
*...  Prologue
*
*...  Set runfile to be RUNOLD
      Call NameRun(RunOld)
*
*...  Get the method used in the old calculation
         Call Get_cArray('Relax Method',Method,8)
*
*...  Get the final energy obtained by the last calculation
*        Call Get_Energy(Energy)
         Call Get_dScalar('Last energy',Energy)
*
*...  Get the number of internal coordinates
         Call Get_iScalar('No of Internal coordinates',iInter)
         If ( iInter.le.0 ) Then
            Call WarningMessage(2,
     &                  'OldFCM: iInter.le.0')
            Write (6,*) 'iInter=',iInter
            Call Abend()
         End If
*
*...  Get the force constant matrix
         Call qpg_dArray('Hess',Found,nHess)
         If (.not.Found .or. nHess.eq.0) Then
            Call SysAbendmsg('OldFcm','Did not find:','Hess')
         End If
         Call GetMem('Hess','Allo','Real',ipRlx,nHess)
         Call get_dArray('Hess',Work(ipRlx),nHess)

         lHess = iInter**2
         If ( nHess.ne.lHess ) Then
            Call WarningMessage(2,'OldFCM: nHess.ne.lHess')
            Write (6,*) 'length,lHess=',length,lHess
            Call Abend()
         End If
*
*...  Reset runfile to be RUNFILE
      Call NameRun('RUNFILE')
*
*...  Echo the input information
         If (iPrint.ge.6) Then
         Write(6,*)
         Write(6,'(6X,A)')
     &   'SLAPAF has been supplied with an old force constant matrix.'
         Write(6,'(6X,3A)')
     &   'It is based on ',Method,' calculations.'
         Write(6,'(6X,A,F18.10)')
     &   'The final energy was',Energy
         End If
         If (iPrint.ge.99)
     &   Call RecPrt(' OldFcm',' ',Work(ipRlx),iInter,iInter)
*
         ipH = ipRlx
         nQQ = iINter
*
*...  Epilogue, end
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nsAtom)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE PRPCTL(MODE,UEFF,U0)
      use definitions, only: iwp, wp, u6
      use constants, only: Zero, Half, One, Five
      USE PT2WFN, only: PT2WFN_DENSSTORE
      use caspt2_global, only:iPrGlb
      use OneDat, only: sNoNuc, sNoOri
      use caspt2_global, only: do_grad,do_nac,iRoot1,iRoot2,SLag,
     &                         DPT2_tot,DPT2C_tot
      use caspt2_global, only: CMO, CMO_Internal, CMOPT2, TORB, NCMO,
     &                       LISTS
      use caspt2_global, only: LUONEM
      use PrintLevel, only: USUAL, VERBOSE
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: Is_Real_Par
#endif
      use stdalloc, only: mma_allocate, mma_deallocate
      use EQSOLV, only: IVECX, NLSTOT
      use caspt2_module, only: NSTATE, IFMSCOUP, IFPROP, irlxroot,
     &                         ISCF, JSTATE, BNAME, NASHT, NBAST, NCONF,
     &                         NSYM, OUTFMT, PRORB, THRENE, THROCC,
     &                         NORB, NBAS, NISH, NASH, IAD1M, NFRO,
     &                         NRAS1, NRAS2, NRAS3, MSTATE, NDEL,
     &                         Energy, MSTATE

      IMPLICIT None

      integer(kind=iwp), intent(in):: Mode
      real(kind=wp), intent(in):: UEFF(NSTATE,NSTATE),U0(*)

      Logical(kind=iwp) FullMlk,lSave,Do_ESPF
      Character(Len=8) Label
      Character(Len=128) FILENAME,MDNAME
      Character(Len=80) Note
      integer(kind=iwp) IndType(56)
      real(kind=wp) Dummy(2), DUM(1), SCAL
      integer(kind=iwp) NFROSAV(NSYM),NORBSAV(NSYM)
      real(kind=wp), allocatable :: DMAT(:),CI1(:),CI2(:),SGM(:),
     &                              TG1(:,:),CNAT(:),OCC(:),Scr(:)
      integer(kind=iwp) I, iComp, IDISK, IDMAT, IDMOFF, IERR, II, II2,
     &                  IJ, IJ2, IndT, iOpt, iRc, iShift, ISTATE,
     &                  iSyLbl, ISYM, iUHF, KSTATE, LUTMP, N, nDens,
     &                  NDMAT, NO, NOCC
      integer(kind=iwp), external:: IsFreeUnit

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par() .AND. IPRGLB.GE.USUAL .AND. .not.do_grad) THEN
        WRITE(u6,'(1X,A)') ' ====================================='
        WRITE(u6,'(1X,A)') ' CASPT2 properties were requested, but'
        WRITE(u6,'(1X,A)') ' these are not efficiently implemented'
        WRITE(u6,'(1X,A)') ' in parallel. If you do not need them,'
        WRITE(u6,'(1X,A)') ' not using the PROP keyword could lead'
        WRITE(u6,'(1X,A)') ' to a significant speed up.'
        WRITE(u6,'(1X,A)') ' ====================================='
      END IF
#else
      call unused_logical(do_grad)
#endif

* PAM2008 When this subroutine is called, theMSTATE calculation has been done
* for the (individual) state nr JSTATE in 1,2,..,NSTATE.
* The corresponding CI-root from rasscf, the root state for this PT2,
* is number MSTATE(JSTATE) on the input JOBIPH file.
* JSTATE,NSTATE and MSTATE() are in the caspt2_module.F90 file.
      IERR=0
      IF(NSTATE.GT.1) THEN
       N=MSTATE(JSTATE)
       IF(N.LE.0 .or. N.GT.999) THEN
        WRITE(u6,*)' Subroutine PRPCTL fails -- It seems to get data'
        WRITE(u6,*)' computed for a root nr ',N
        WRITE(u6,*)' which is surely wrong.'
        WRITE(u6,*)' PRPCTL gives up, there will be no calculations'
        WRITE(u6,*)' done of orbitals, properties, etc for this state.'
        WRITE(u6,*)' This was state nr JSTATE=',JSTATE
        WRITE(u6,*)' in the MS-CASPT2 calculation.'
        IERR=1
       END IF
      END IF
      IF(IERR.GT.0) Return

      FullMlk=.True.
      IF (.NOT.PRORB ) FullMlk=.False.

      IF ( IPRGLB.GE.USUAL ) THEN
       WRITE(u6,'(20A4)')('----',I=1,20)
      END IF

C Compute density matrix, output orbitals, and properties.

C Compute density matrix of CASPT2 wave function, in MO basis,
C to produce output orbitals.
C This density matrix may be approximated in several ways, see DENS.
      NDMAT=0
      NOCC=0
      IF (MODE.EQ.0) THEN
        !! Density matrix for each state (single-state)
        DO ISYM=1,NSYM
          NO=NORB(ISYM)
          NDMAT=NDMAT+(NO**2+NO)/2
          NOCC=NOCC+NBAS(ISYM)
        END DO
        call mma_allocate(DMAT,NDMAT,Label='DMAT')
        CALL DCOPY_(NDMAT,[Zero],0,DMAT,1)
        CALL mma_allocate(LISTS,NLSTOT,LABEL='LISTS')
        CALL MKLIST(LISTS)
        CALL DENS(IVECX,DMAT,UEFF,U0)
        CALL mma_deallocate(LISTS)
      ELSE
        !! Density matrix for the target adiabatic state
        !! MODE = 1 is called after gradient stuff only for MS, so
        !! the density computed here is what we call a correct unrelaxed
        !! correlated CASPT2 density
        !! Called after gradient calculations, only, from GrdCls
        DO ISYM=1,NSYM
          NO=NBAS(ISYM)
          NDMAT=NDMAT+(NO**2+NO)/2
          NOCC=NOCC+NBAS(ISYM)
        END DO
        call mma_allocate(DMAT,NDMAT,Label='DMAT')
        CALL DCOPY_(NDMAT,[Zero],0,DMAT,1)
        !! Copy the unrelaxed density matrix to triangular
        !! The basis of DPT2_tot is natural (CASSCF)
        IDMAT = 0
        IDMOFF = 0
        DO ISYM=1,NSYM
          NO=NBAS(ISYM)
          DO II = 1, NO
            DO IJ = 1, II
              !! second-order (DPT2) and first-order (DPT2C)
              DMAT(1+IDMAT) = DPT2_TOT(IDMOFF+II+NO*(IJ-1))
     *                      + DPT2C_TOT(IDMOFF+II+NO*(IJ-1))*0.25d+00
              IF (.NOT.DO_NAC) THEN
                !! Add the reference density matrix (inactive)
                IF (II.EQ.IJ .and. II.LE.NFRO(ISYM)+NISH(ISYM))
     *            DMAT(1+IDMAT) = DMAT(1+IDMAT) + 2.0D+00
              END IF
              IDMAT = IDMAT + 1
            END DO
          END DO
          IDMOFF = IDMOFF + NO*NO
        END DO
        !! Add the reference density matrix (active)
        call mma_allocate(CI1,NCONF,Label='CI1')
        call mma_allocate(CI2,NCONF,Label='CI2')
        call mma_allocate(SGM,NCONF,Label='SGM')
        call mma_allocate(TG1,NASHT,NASHT,Label='TG1')
        DO ISTATE = 1, NSTATE
          IF (ISCF.NE.0) THEN
            CI1(1)=One
          ELSE
            CALL LOADCI_XMS('N',1,CI1,ISTATE,U0)
          END IF
          DO KSTATE = 1, NSTATE
            SCAL = SLag(ISTATE,KSTATE)
            IF (.NOT.DO_NAC) THEN
              IF (ISTATE.EQ.IROOT1.AND.KSTATE.EQ.IROOT2)
     *          SCAL = SCAL + One
            END IF
            IF (ABS(SCAL).LE.1.0D-09) CYCLE
            IF (ISCF.NE.0) THEN
              CI2(1)=One
            ELSE
              CALL LOADCI_XMS('N',1,CI2,KSTATE,U0)
            END IF
            Call Dens1T_RPT2(CI1,CI2,
     *                       SGM,TG1,nAshT)
            CALL DSCAL_(NASHT**2,SCAL,TG1,1)
            DO II = 1, NASH(1)
              II2 = II+NFRO(1)+NISH(1)
              DO IJ = 1, II
                IJ2 = IJ+NFRO(1)+NISH(1)
                DMAT(II2*(II2-1)/2+IJ2)
     *            = DMAT(II2*(II2-1)/2+IJ2)
     *            + TG1(II,IJ)*Half + TG1(IJ,II)*Half
              END DO
            END DO
          END DO
        END DO
        call mma_deallocate(CI1)
        call mma_deallocate(CI2)
        call mma_deallocate(SGM)
        call mma_deallocate(TG1)

        !! The density matrix above has frozen orbitals.
        !! Accordingly, the natural orbitals should be generated
        !! by diagonalizing all orbitals (including frozen), so
        !! make the number of frozen orbitals zero for the moment.
        CALL ICOPY(NSYM,NFRO,1,NFROSAV,1)
        CALL ICOPY(NSYM,NORB,1,NORBSAV,1)
        CALL ICOPY(NSYM,[0],0,NFRO,1)
        CALL ICOPY(NSYM,NBAS,1,NORB,1)
      END IF

C Compute natural orbitals of CASPT2 wave function.
      CALL mma_allocate(CMO_Internal,NCMO,Label='CMO_Internal')
      CMO=>CMO_Internal
      CMO(:)=CMOPT2(:)
      IF (MODE.EQ.1) THEN
        !! Read the CASSCF orbital (really?)
        IDISK=IAD1M(1)
        call ddafile(LUONEM,2,CMO,NCMO,IDISK)
      END IF
      call mma_allocate(CNAT,NCMO,Label='CNAT')
      call mma_allocate(OCC,NOCC,Label='OCC')
      CALL NATORB_CASPT2(DMAT,CMO,OCC,CNAT)
      CALL mma_deallocate(CMO_Internal)
      nullify(CMO)
C Backtransform density matrix to original MO basis before storing
      CALL TRANSFOCK(TORB,SIZE(TORB),DMAT,NDMAT,-1)
      CALL PT2WFN_DENSSTORE(DMAT,NDMAT)
      call mma_deallocate(DMAT)
      IF (MODE.EQ.1) THEN
        !! Restore with frozen orbitals
        CALL ICOPY(NSYM,NFROSAV,1,NFRO,1)
        CALL ICOPY(NSYM,NORBSAV,1,NORB,1)
      END IF

      IF (IFMSCOUP.AND.MODE.EQ.0.AND..NOT.IFPROP) THEN
        !! Do not show properties, if PROP calculation is not requested
        call mma_deallocate(CNAT)
        call mma_deallocate(OCC)
        RETURN
      END IF

C Write natural orbitals as standard orbital file on PT2ORB
* PAM2008: Separate PT2ORB files for each state:
      FILENAME='PT2ORB'
      MDNAME='MD_PT2'
      IF(NSTATE.GT.1.AND.MODE.EQ.0) THEN
       FILENAME='PT2ORB.x'
       MDNAME='MD_PT2.x'
       N=MSTATE(JSTATE)
       IF(N.LE.9) THEN
        WRITE(FILENAME(8:8),'(I1)') N
        WRITE(MDNAME(8:8),'(I1)') N
       ELSE IF(N.LE.99) THEN
        WRITE(FILENAME(8:9),'(I2)') N
        WRITE(MDNAME(8:9),'(I2)') N
       ELSE IF(N.LE.999) THEN
        WRITE(FILENAME(8:10),'(I3)') N
        WRITE(MDNAME(8:10),'(I3)') N
       END IF
      END IF
* PAM2008: For MS-CASPT2 with more than one state, orbital files will
* now be numbered PT2ORB.1 ... PT2ORB.999
* depending on which CI-root of the rasscf calculation that was
* the root state of the PT2.
      LUTMP=19
      LUTMP=ISFREEUNIT(LUTMP)
* PAM 2008: Add typeindex information:
*----------------------------------------------------------------------*
*     Make typeindex information                                       *
*----------------------------------------------------------------------*
      iShift=0
      DO ISYM=1,NSYM
        IndT=0
        IndType(1+iShift)= NFRO(ISYM)
        IndT=IndT+NFRO(ISYM)
        IndType(2+iShift)= NISH(ISYM)
        IndT=IndT+NISH(ISYM)
        IndType(3+iShift)= NRAS1(ISYM)
        IndT=IndT+NRAS1(ISYM)
        IndType(4+iShift)= NRAS2(ISYM)
        IndT=IndT+NRAS2(ISYM)
        IndType(5+iShift)= NRAS3(ISYM)
        IndT=IndT+NRAS3(ISYM)
        IndType(7+iShift)= NDEL(ISYM)
        IndT=IndT+NDEL(ISYM)
        IndType(6+iShift)= NBAS(ISYM)-IndT
        iShift=iShift+7
      EndDo
      If (NSTATE.GT.1) THEN
        Write(Note,'(A41,I3,A3,f22.12)')
     &   '* CASPT2 natural orbitals for root number',N,
     &   ' E=',Energy(JSTATE)
      Else
        Note='* CASPT2 natural orbitals'
      End If

      CALL WRVEC(FILENAME,LUTMP,'COI',NSYM,NBAS,NBAS,
     &  CNAT, OCC,Dummy  ,IndType,Note)
      iUHF=0
      Call Molden_Interface(iUHF,FILENAME,MDNAME)

C Write natural orbitals to standard output.
      IF ( IPRGLB.GE.VERBOSE) THEN
       WRITE(u6,*)
       WRITE(u6,'(A)')'  The CASPT2 orbitals are computed as natural '//
     &          'orbitals of a density matrix'
       WRITE(u6,'(A)')'  defined as:'
       WRITE(u6,'(A)')'   D = (D0 + D1 + D2)/<PSI|PSI>'
       WRITE(u6,'(A)')' where D0..D2 are zeroth..2nd order'//
     &                ' contributions'
       WRITE(u6,'(A)')' and |PSI> is the total wave function.'
       WRITE(u6,'(A)')' A new RasOrb file named PT2ORB is prepared.'
       IF (PRORB) THEN
         IF ( OUTFMT.EQ.'LONG    ' ) THEN
           THRENE=2.0d0**31
           THROCC=-2.0d0**31
         ELSE IF ( OUTFMT.EQ.'DEFAULT ' ) THEN
           THRENE=Five
           THROCC=5.0d-04
         END IF
         CALL PRIMO('Output orbitals from CASPT2',
     &           .TRUE.,.FALSE.,THROCC,THRENE,NSYM,NBAS,
     &            NBAS,BNAME,DUM,OCC,CNAT,-1)
       END IF
      END IF

* compute Mulliken's orbital populations

      IF ( IPRGLB.GE.USUAL ) THEN
        WRITE(u6,*)
        WRITE(u6,*)
        WRITE(u6,'(6X,A)') 'Mulliken population Analysis:'
        WRITE(u6,'(6X,A)') '-----------------------------'

        call mma_allocate(Scr,NBAST**2,Label='Scr')
        iRc=-1
        iOpt=ibset(ibset(0,sNoOri),sNoNuc)
        iComp=1
        iSyLbl=1
        Label='Mltpl  0'
        Call RdOne(iRc,iOpt,Label,iComp,Scr,iSyLbl)
        If ( iRc.eq.0 ) then
           lSave = MSTATE(JSTATE) .eq. irlxroot
           Call Charge(nSym,nBas,bName,
     &               CNAT,OCC,Scr,2,FullMlk,lSave)
        End If
        call mma_deallocate(Scr)
      END IF

* compute one-electron properties

      IF ( IPRGLB.GE.USUAL ) THEN
        WRITE(u6,*)
        WRITE(u6,'(6X,A)') 'Expectation values of various properties:'
        WRITE(u6,'(6X,A)') '-----------------------------------------'
      END IF

      nDens=0
      Do i = 1, nSym
         nDens=nDens+nBas(i)*(nBas(i)+1)/2
      End Do
      call mma_allocate(Scr,NDENS,Label='Scr')
*
      Call DOne_Caspt2(CNAT,OCC,Scr)
      Call Put_dArray('D1ao',Scr,nDens)
*
      Note='Temporary orbital file used by prpt.'
      if (mode.eq.1) Note='var'
      LuTmp=50
      LuTmp=IsFreeUnit(LuTmp)
      Call WrVec('TMPORB',LuTmp,'CO',nSym,nBas,nBas,
     &            CNAT,OCC,Dummy,IndType,Note)
      Call Prpt()
cnf
*
*------- ESPF analysis
      Call DecideOnESPF(Do_ESPF)
      lSave = MSTATE(JSTATE) .eq. irlxroot
      If (Do_ESPF) Call espf_analysis(lSave)
cnf
*
*---- On return from PrPt the 1-particle matrix is stored
*     in the beginning of the scratch array.
*
      call mma_deallocate(Scr)
      call mma_deallocate(CNAT)
      call mma_deallocate(OCC)

      END SUBROUTINE PRPCTL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CIDIA_CI_UTIL(NORB,NCONF,IREFSM,
     *                 CSFDIA,G,TUVX,LUDAVID)
C
C     PURPOSE: - COMPUTE DIAGONAL ELEMENTS OF THE CI-MATRIX
C                THE DETERMINANT BASIS
C              - TRANSLATE FORM DET => CSF BASIS
C
C     CALLING PARAMETERS:
C     NORB  :  NO. OF ACTIVE ORBITALS
C     NCONF :  NO. OF CSF
C     IREFSM:  REFERENCE SYMMETRY
C     CSFDIA:  DIAGONAL OF CI MATRIX IN CSF BASIS
C     G     :  MODIFIED ONE ELECTRON HAMILTONIAN INCLUDING CORE ELECTR.
C     TUVX  :  TWO-ELECTRON INTEGRALS
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "ciinfo.fh"
#include "spinfo.fh"
#include "detbas.fh"
#include "csfbas.fh"
#include "strnum.fh"
#include "WrkSpc.fh"
#include "timers.fh"
#include "rasscf_lucia.fh"
#include "output_ras.fh"
      PARAMETER (ROUTINE='CIDIA_CI')
C
      DIMENSION CSFDIA(*)
      DIMENSION G(*)
      DIMENSION TUVX(*)
      DIMENSION Dummy(1)
C
      Call Timing(Tissot_1,Swatch,Swatch,Swatch)
      IPRLEV=IPRLOC(3)
C
C     ALLOCATE LOCAL MEMORY
C
      CALL GETMEM('XA','ALLO','REAL',KX,NORB)
      CALL GETMEM('SCR','ALLO','REAL',KSCR,2*NORB)
      CALL GETMEM('H1DIA','ALLO','REAL',KH1DIA,NORB)
C
C     SELECT DIAGONAL ONEBODY INTEGRALS
C
      II=0
      DO 100 I = 1,NORB
        II=II+I
        Work(KH1DIA-1+I) = G(II)
100   CONTINUE
C
C     COMPUTE CI DIAGONAL IN DETERMINANT BASIS
C
*
      CALL Lucia_Util('Diag',iDummy,iDummy,Dummy)
*
      CALL GETMEM('DETDIA','ALLO','REAL',KDDIA,NDET)
      CALL get_diag(work(kddia),ndet)
C
C     TRANSFORM CI DIAGONAL FROM DET TO CSF BASIS
C
      IPRINT=0
      IF(IPRLEV.EQ.INSANE) IPRINT=40
      CALL CSDIAG_CI_UTIL(CSFDIA,Work(KDDIA),NCNFTP(1,IREFSM),
     *     NTYP,iWork(KICTS(1)),NDTFTP,NCSFTP,IPRINT)
      One       = 1.0d0
      eCore_Hex = Get_eCore()
      CALL DAXPY_(NCONF,eCore_Hex,[One],0,CSFDIA,1)
C
C     DEALLOCATE LOCAL MEMORY
C
      CALL GETMEM('XA','FREE','REAL',KX,NORB)
      CALL GETMEM('SCR','FREE','REAL',KSCR,2*NORB)
      CALL GETMEM('H1DIA','FREE','REAL',KH1DIA,NORB)
      CALL GETMEM('DETDIA','FREE','REAL',KDDIA,NDET)
C
C     PRINT CI-DIAGONAL
C
      IF ( IPRLEV.GE.DEBUG ) THEN
        IPRL=NCONF
        IF( IPRLEV.LT.INSANE ) IPRL=MIN(IPRL,200)
        Call dVcPrt('CI-DIAGONAL (max.200 elemwnts)',' ',CSFDIA,NCONF)
      END IF
C
C     SAVE THE CI_DIAGONAL ON TAPE
C
      Call Save_H_diag(nConf,CSFDIA,LUDAVID)
C
      Call Timing(Tissot_2,Swatch,Swatch,Swatch)
      Tissot_2 = Tissot_2 - Tissot_1
      Tissot_3 = Tissot_3 + Tissot_2
C
      RETURN
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(TUVX)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Giovanni Li Manni                                *
!               2019,2024, Oskar Weser                                 *
!               2021, Werner Dobrautz                                  *
!***********************************************************************

module fciqmc_make_inp
    use definitions, only: wp
    use linalg_mod, only: verify_
    use general_data, only: nActEl, iSpin
    use fortran_strings, only: str
    use stdalloc, only: mma_deallocate
    implicit none
    private
    public :: make_inp, cleanup
    ! Sometimes no default value on purpose
    integer, public :: &
        totalwalkers, &
        Time = 200, &
            !! Default value for time per NECI run
        trial_wavefunction = 1000000000, &
            !! Practically this means no trial_wavefunction by default
        nmcyc = 50000, &
        pops_trial = 1000, &
        stepsshift = 10, &
        addtoinitiator = 3, &
        semi_stochastic = 1000, &
        highlypopwrite = 50, &
        startsinglepart = 10, &
        pops_core = 10000
    character(len=:), allocatable, public :: definedet
    real(wp), public :: &
        proje_changeref = 1.2_wp, &
        max_tau = 0.02_wp, &
        maxwalkerbloom = 2._wp, &
        memoryfacpart = 5.0_wp, &
        memoryfacspawn = 10.0_wp, &
        ! Default value for NECI RealSpawnCutOff
        realspawncutoff = 0.3_wp, &
        ! Default value for NECI diagonal shift value
        diagshift = 0.00_wp, &
        shiftdamp = 0.02_wp

    type, public :: t_RDMsampling
        integer :: start, n_samples, step
    end type t_RDMsampling

    type(t_RDMsampling), public :: RDMsampling
    save
contains

    !>  @brief
    !>    Generate an Input for NECI
    !>
    !>  @author
    !>    G. Li Manni, Oskar Weser
    !>
    !>  @param[in] path
    !>  @param[in] readpops If true the readpops option for NECI is set.
    !>  @param[in] tGUGA
    !>  @param[in] FCIDUMP_name
    !>  @param[in] GAS_spaces
    !>  @param[in] GAS_particles
    subroutine make_inp(path, readpops, tGUGA, FCIDUMP_name, GAS_spaces, GAS_particles)
        character(len=*), intent(in) :: path
        logical, intent(in) :: readpops, tGUGA
        character(len=*), intent(in), optional :: FCIDUMP_name
        integer, intent(in), optional :: GAS_spaces(:, :), GAS_particles(:, :)

        integer :: i, isFreeUnit, file_id, indentlevel, iGAS, iSym
        integer :: nGAS, nSym
        integer, parameter :: indentstep = 4

        call verify_(present(GAS_spaces) .eqv. present(GAS_particles), 'present(GAS_spaces) .eqv. present(GAS_particles)')

        call add_info('Default number of total walkers', [real(totalwalkers, wp)], 1, 6)
        call add_info('Default number of cycles ', [real(nmcyc, wp)], 1, 6)
        call add_info('Default value for Time  ', [real(Time, wp)], 1, 6)

        file_id = isFreeUnit(39)
        call Molcas_Open(file_id, path)

        indentlevel = 0
        write(file_id, A_fmt()) 'Title'
        write(file_id, *)
        write(file_id, A_fmt()) 'System read'
        call indent()
        write(file_id, I_fmt()) 'electrons ', nActEl
        if (tGUGA) then
            write(file_id, A_fmt()) 'nonuniformrandexcits mol_guga_weighted'
        else
            write(file_id, A_fmt()) 'nonuniformrandexcits pchb localised'
        end if
        write(file_id, A_fmt()) 'nobrillouintheorem'
        if (tGUGA) then
            write(file_id, I_fmt()) 'guga', iSpin - 1
        else if (iSpin /= 1) then
            write(file_id, I_fmt()) 'spin-restrict', iSpin - 1
        end if
        if (present(FCIDUMP_name)) then
            write(file_id, A_fmt()) 'FCIDUMP-name', FCIDUMP_name
        end if

        write(file_id, A_fmt()) 'freeformat'
        if (present(GAS_spaces) .and. present(GAS_particles)) then
            nGAS = size(GAS_spaces, 1)
            nSym = size(GAS_spaces, 2)
            write(file_id, A_fmt()) 'GAS-SPEC '//str(nGAS)//' \'
            call indent()
            do iGAS = 1, nGAS
                write(file_id, '('//indent_fmt()//'I0, 1x, I0, 1x, I0, 1x, A)') &
                    sum([(GAS_spaces(iGAS, iSym), iSym=1, nSym)]), &
                    GAS_particles(iGAS, 1), GAS_particles(iGAS, 2), '\'
            end do
            write(file_id, '('//indent_fmt()//')', advance='no')
            do iSym = 1, nSym
            do iGAS = 1, nGAS
            do i = 1, GAS_spaces(iGAS, iSym)
                write(file_id, '(I0, 1x)', advance='no') iGAS
            end do
            end do
            end do
            write(file_id, *)
            call dedent()
        end if
        call dedent()
        write(file_id, A_fmt()) 'endsys'
        write(file_id, *)
        write(file_id, A_fmt()) 'calc'
        call indent()
        if (allocated(DefineDet)) then
            write(file_id, A_fmt()) 'definedet '//trim(definedet)
        end if
        write(file_id, *)
        write(file_id, I_fmt()) 'totalwalkers', totalwalkers
        write(file_id, A_fmt()) merge(' ', '#', readpops)//'readpops'
        write(file_id, A_fmt()) merge(' ', '#', readpops)//'walkcontgrow'
        write(file_id, *)
        write(file_id, I_fmt()) 'semi-stochastic', semi_stochastic
        write(file_id, I_fmt()) 'pops-core', pops_core
        write(file_id, *)
        write(file_id, A_fmt()) 'methods'
        call indent()
        write(file_id, A_fmt()) 'method vertex fcimc'
        call dedent()
        write(file_id, A_fmt()) 'endmethods'
        write(file_id, *)
        write(file_id, R_fmt()) 'diagshift', diagshift
        write(file_id, R_fmt()) 'shiftdamp', shiftdamp
        write(file_id, I_fmt()) 'stepsshift', stepsshift
        write(file_id, A_fmt()) 'jump-shift'
        write(file_id, *)
        write(file_id, I_fmt()) 'nmcyc', nmcyc
        write(file_id, I_fmt()) 'time', time
        write(file_id, *)
        write(file_id, I_fmt()) 'startsinglepart', startsinglepart
        write(file_id, R_fmt()) 'proje-changeref', proje_changeref
        write(file_id, *)

        write(file_id, A_fmt()) 'truncinitiator'
        write(file_id, I_fmt()) 'addtoinitiator ', addtoinitiator
        write(file_id, A_fmt()) 'allrealcoeff'
        write(file_id, R_fmt()) 'realspawncutoff', realspawncutoff

        write(file_id, *)
        write(file_id, A_fmt()) 'tau-values \'
        call indent()
        write(file_id, kw_fmt('F0.2, 1x, A')) 'max', max_tau, '\'
        if (readpops) then
            write(file_id, A_fmt()) 'start from-popsfile'
        else
            write(file_id, A_fmt()) 'start user-defined 0.01'
        end if
        call dedent()

        write(file_id, A_fmt()) 'tau-search \'
        call indent()
        if (tGUGA) then
            write(file_id, A_fmt()) 'algorithm histogramming \'
        else
            write(file_id, A_fmt()) 'algorithm conventional \'
        end if
        write(file_id, A_fmt()) 'stop-condition no-change 500 \'
        write(file_id, R_fmt()) 'maxwalkerbloom', maxwalkerbloom
        call dedent()


        write(file_id, R_fmt()) ''

        write(file_id, R_fmt()) 'memoryfacspawn', memoryfacspawn
        write(file_id, R_fmt()) 'memoryfacpart', memoryfacpart
        write(file_id, I_fmt())
        call dedent()
        write(file_id, A_fmt()) 'endcalc'
        write(file_id, *)
        write(file_id, A_fmt()) 'logging'
        call indent()
        write(file_id, I_fmt()) 'highlypopwrite', Highlypopwrite
        write(file_id, A_fmt()) 'hdf5-pops'
        if (tGUGA) then
            write(file_id, A_fmt()) 'print-molcas-rdms'
        else
            write(file_id, A_fmt()) 'print-spin-resolved-RDMs'
        end if
        write(file_id, A_fmt()) 'printonerdm'
        write(file_id, '('//str(indentlevel)//'x, A,1x,I0,1x,I0,1x,I0)') &
            'RDMlinspace', &
            RDMsampling%start, RDMsampling%n_samples, RDMsampling%step
        call dedent()
        write(file_id, A_fmt()) 'endlog'
        write(file_id, A_fmt()) 'end'

        close (file_id)

    contains

        function indent_fmt() result(res)
            character(len=:), allocatable :: res
            if (indentlevel /= 0) then
                res = str(indentlevel)//'x, '
            else
                res = ''
            end if
        end function

        function kw_fmt(value_fmt) result(res)
            character(len=*), intent(in) :: value_fmt
            character(len=:), allocatable :: res
            res = '('//indent_fmt()//'A, 1x, '//value_fmt//')'
        end function

        function I_fmt() result(res)
            character(len=:), allocatable :: res
            res = kw_fmt('I0')
        end function

        function R_fmt() result(res)
            character(len=:), allocatable :: res
            res = kw_fmt('F0.2')
        end function

        function A_fmt() result(res)
            character(len=:), allocatable :: res
            res = kw_fmt('A')
        end function

        subroutine indent()
            indentlevel = indentlevel + indentstep
        end subroutine

        subroutine dedent()
            indentlevel = indentlevel - indentstep
        end subroutine
    end subroutine make_inp

    subroutine cleanup()
        call mma_deallocate(definedet,safe='*')
    end subroutine cleanup

end module fciqmc_make_inp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3dhlp2(w,v,dimp,dimpq,dimr,denijk,ec,diagp,diagr,dimdiagp,dimdiagr,addp,addr)
! this routine realizes following procedure
! for symp=symq/=symr
!
! ec = sum(pq,r) [ W(pq,r) . V(pq,r) / Dijkpqr ]
!
! w        - W matrix (I)
! v        - V matrix (I)
! dimp     - dimension of p (q) index (I)
! dimpq    - dimension of pq index (I)
! dimr     - dimension of r index (I)
! denijk   - sum of i,j,k diagonal (other) F parts (I)
! ec       - energy contribution
! diagp    - vector of diagonal parts of symmetry p (q) (I)
! diagr    - vector of diagonal parts of symmetry r (I)
! dimdiagp - dimension of diagonal parts in symmetry p (I)
! dimdiagr - dimension of diagonal parts in symmetry r (I)
! addp     - additional constant to p (Nocc) (I)
! addr     - additional constant to r (Nocc) (I)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimpq, dimr, dimdiagp, dimdiagr, addp, addr
real(kind=wp), intent(in) :: w(dimpq,dimr), v(dimpq,dimr), denijk, diagp(dimdiagp), diagr(dimdiagr)
real(kind=wp), intent(out) :: ec
integer(kind=iwp) :: p, pq, q, r
real(kind=wp) :: denijkpqr, denijkpr, denijkr

ec = Zero

do r=1,dimr
  denijkr = denijk-diagr(addr+r)
  pq = 0
  do p=2,dimp
    denijkpr = denijkr-diagp(p+addp)
    do q=1,p-1
      pq = pq+1
      denijkpqr = denijkpr-diagp(q+addp)
      ec = ec+w(pq,r)*v(pq,r)/denijkpqr
    end do
  end do
end do

return

end subroutine t3dhlp2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012,2013, Victor P. Vysotskiy                         *
************************************************************************
************************************************************************
*                                                                      *
*                     Thread safe                                      *
*                     POSIX - I/O                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* rc=AixPRd(Handle,Buf,nBuf,iDisk,iErrSkip)                            *
*                                                                      *
* A buffer is read from a file associated with the file handle. The    *
* operation is synchronous, but can be done in parallel by multiple    *
* threads                                                              *
*                                                                      *
* Input:  Handle   - This is the unique file identifier associated     *
*                    with the file. It is created by AixOpn, and must  *
*                    be used on subsequent references to the file.     *
*         Buf      - The buffer that is to be written to disk.         *
*         nBuf     - Length of the buffer in words.                    *
*         iDisk    - External disk address.                            *
*         iErrSkip - if 0 : stop in the error case                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Victor P. Vysotskiy                                         *
*          University of Lund, Sweden, 2012-2013                       *
* Written: 2012-2013                                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* History:                                                             *
*                                                                      *
************************************************************************
      Integer Function AixPRd(handle,Buf,nBuf,iDisk,iErrSkip)
      Implicit Integer (a-z)

#include "SysDef.fh"

#include "blksize.fh"
#include "switch.fh"
#include "ctl.fh"
      Dimension Buf(*)
      Character*80 ErrTxt
      Character*16 TheName
#ifndef _OLD_IO_STAT_
#include "pfio.fh"
      Real*8   CPUA,CPUE,TIOA,TIOE
#endif
#include "warnings.fh"
      Data TheName/'AixPRd'/
*----------------------------------------------------------------------*
* Entry to AixRd                                                       *
*----------------------------------------------------------------------*
      AixPRd=0
      rc=0
*----------------------------------------------------------------------*
* Check if file is opened.                                             *
*----------------------------------------------------------------------*
      n=1
100   If(CtlBlk(pHndle,n).ne.handle) Then
         n=n+1
         If(n.gt.MxFile) Then
            AixPRd=eNtOpn
            Return
         End If
         Go To 100
      End If
      nFile=n
      desc=CtlBlk(pDesc,nFile)
#ifndef _OLD_IO_STAT_
      Call FSCB2UNIT(handle,Lu)
      Call Timing(CPUA,CPUE,TIOA,TIOE)
#endif
*----------------------------------------------------------------------*
* Position file pointer                                                *
*----------------------------------------------------------------------*
      pDisk=pHeadOffset+iDisk
#ifndef _OLD_IO_STAT_
      If(CtlBlk(pWhere,nFile).ne.pDisk) Then
         ProfData(8,Lu)=ProfData(8,Lu)+1
      End If
#endif
*----------------------------------------------------------------------*
* Read from file                                                       *
*----------------------------------------------------------------------*
      CtlBlk(pWhere,nFile)=pDisk+nBuf
      if(nBuf.gt.0) rc=c_pread(desc,Buf,nBuf,pDisk)
      If(rc.lt.0) Then
            if(iErrSkip.eq.1) then
             AixPRd=99
             return
            endif
         idum=iPrintLevel(3)
         Call FASTIO('STATUS')
         AixPRd=AixErr(ErrTxt)
            Call SysQuitFileMsg(_RC_IO_ERROR_READ_,
     *                                TheName,FCtlBlk(nFile),
     *      'Premature abort while reading buffer from disk', ErrTxt)

      Else If(rc.ne.nBuf) Then
            if(iErrSkip.eq.1) then
             AixPRd=99
             return
            endif
         idum=iPrintLevel(3)
         Call FASTIO('STATUS')
         AixPRd=eEof
            Call SysQuitFileMsg(_RC_IO_ERROR_READ_,
     *            TheName,FCtlBlk(nFile),
     *            'Premature abort while reading buffer from disk:',
     *      '\n End of file reached ')
      End If
#ifndef _OLD_IO_STAT_
      Call Timing(CPUA,CPUE,TIOA,TIOE)
      ProfData(4,Lu)=ProfData(4,Lu)+1
      ProfData(5,Lu)=ProfData(5,Lu)+nBuf
      ProfData(6,Lu)=ProfData(6,Lu)+TIOE
#endif

*----------------------------------------------------------------------*
* Finished so return to caller                                         *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 12, 2022, created this file.               *
! ****************************************************************

subroutine CalcNewX(X,H,G,nSPair,XScr,GScr,EigVal,ScrDiag,nScr)

use CMS, only: CMSThres, PosHess, BigQaaGrad, nPosHess, LargestQaaGrad, NeedMoreStep
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSPair, nScr
real(kind=wp), intent(out) :: X(nSPair), XScr(nSPair), GScr(nSPair), EigVal(nSPair), ScrDiag(nScr)
real(kind=wp), intent(inout) :: H(nSPair**2)
real(kind=wp), intent(in) :: G(nSPair)
integer(kind=iwp) :: INFO, iPair
real(kind=wp) :: AbsGrad, AbsHess, MinGrad, ThreG, ThreH, ValGrad, ValHess

! Commented lines are options under development and may be used in future
! Thanks to Matthew R. Hermes for this algorithm

! Solve for x in hx=-g.
! 1. diagonalize h to h' with rotation matrix C
! 2. (C^T)h(C)(C^T)x=(C^T)g
! 3. define x'=(C^T)x; g'=(C^T)g, we have (h')(x')=(g')
! 4. (x')_p = (g')_p / (h')_pp
! 5. x=(C)(C^T)x=(C)(x')

!write(u6,*) 'gradient before diag'
!call RecPrt(' ',' ',G,1,nSPair)
!write(u6,*) 'hessian before diag'
!call RecPrt(' ',' ',EigVal,1,nSPair)
!*****Step 1
call DSYEV_('V','U',nSPair,H,nSPair,EigVal,ScrDiag,nScr,INFO)

!*****Step 3, g'=(C^T)g
call DGEMM_('n','n',1,nSPair,nSPair,One,G,1,H,nSPair,Zero,GScr,1)

!*****Step 4
ThreG = CMSThres*1.0e-2_wp
ThreH = CMSThres*1.0e-4_wp
MinGrad = CMSThres*1.0e5_wp
!write(u6,*) 'gradient'
!call RecPrt(' ','(1X,15(F9.6,1X))',GScr,1,nSPair)
!write(u6,*) 'hessian'
!call RecPrt(' ','(1X,15(F9.6,1X))',EigVal,1,nSPair)

LargestQaaGrad = Zero
nPosHess = 0
do iPair=1,nSPair
  ValGrad = GScr(iPair)
  AbsGrad = abs(ValGrad)
  ValHess = EigVal(iPair)
  AbsHess = abs(ValHess)

  if (ValHess > ThreH) nPosHess = nPosHess+1
  if (AbsGrad > LargestQaaGrad) LargestQaaGrad = AbsGrad

  if ((AbsGrad < ThreG) .and. (AbsHess < ThreH)) then
    !write(u6,*) 'constant Qaa for pair',ipair
    XScr(iPair) = Zero
  else
    XScr(iPair) = ValGrad/AbsHess
  end if

  if ((AbsGrad < ThreG) .and. (ValHess > ThreH)) then
    !write(u6,*) 'local minimum for pair',ipair
    XScr(iPair) = MinGrad/abs(EigVal(iPair))
    if (XScr(iPair) > 1.0e-2_wp) XScr(iPair) = 1.0e-2_wp
  end if

end do

PosHess = .false.
BigQaaGrad = .false.
NeedMoreStep = .false.
if (nPosHess > 0) PosHess = .true.
if (LargestQaaGrad > ThreG) BigQaaGrad = .true.

if (PosHess .or. BigQaaGrad) NeedMoreStep = .true.

!write(u6,*) 'steps taken'
!call RecPrt(' ','(1X,15(F9.6,1X))',XScr,1,nSPair)
!*****Step 5
call DGEMM_('n','t',1,nSPair,nSPair,One,XScr,1,H,nSPair,Zero,X,1)

return

end subroutine CalcNewX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Calculation of matrix elements over vibrational wave functions
! of a given series of observables by a simpson quadrature.
! The vibrational wave functions have been computed in vibrot
! and stored on unit Vibwvs=12 for each rotational quantum number.
! The observables are read as input for a sequence of R-values
! and fitted to an analytical form in function pot.
! This routine is called when the parameter iobs is not zero.
! integration is performed on a logaritmic scale (u=ln(r))
! between Umin and Umax with a grid size del corresponding to
! ndim integration steps. ndim has to be odd.
!
! ********** MOLCAS-2 Release 91 05 01 **********

subroutine Vibmat(ne,ndim,Umin,Umax,Title,R,PotR,Temp)

use Vibrot_globals, only: J1A, J2A, Vibwvs, iad12
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, kBoltzmann, auTokJ
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ne, ndim
real(kind=wp), intent(in) :: Umin, Umax, R(ndim), PotR(ndim), Temp
character(len=80), intent(in) :: Title
integer(kind=iwp) :: iPrint, i, J, iad, ind, ist, ist1, ist2, ndim1, nv, nv1, nv2, nv11, nv12, nv22, nwork
logical(kind=iwp) :: WarnV, WarnR
real(kind=wp) :: Joule, beta, del, E, O, Obsr, ri, Smax, W, WarnRq, WarnVq, Wfirst, Wlast
integer(kind=iwp), allocatable :: nv1w(:), nv2w(:)
real(kind=wp), allocatable :: Vib(:), X(:), SumO(:), SumW(:), Wmin(:), Wmax(:), Ener(:), S(:), Obs(:), Sw(:)

write(u6,*)
call CollapseOutput(1,'Matrix elements of observable: '//Title)
WarnV = .false.
WarnR = .false.
WarnVq = Zero
WarnRq = Zero
Joule = 1.0e3_wp*auTokJ
beta = One/(kBoltzmann*Temp)
!write(u6,'(a,e12.5)') 'Bolzmann ',kBoltzmann
!write(u6,'(a,e12.5)') 'au to J  ',Joule
!write(u6,'(a,e12.5)') 'Temp     ',Temp
!write(u6,'(a,e12.5)') 'beta     ',beta
ndim1 = ndim+1
nwork = ne*ndim1
call mma_allocate(Vib,nwork,label='Vib')
call mma_allocate(X,ndim,label='X')
call mma_allocate(SumO,ne,label='SumO')
call mma_allocate(SumW,ne,label='SumW')
call mma_allocate(Wmin,ne,label='Wmin')
call mma_allocate(Wmax,ne,label='Wmax')
call mma_allocate(Ener,ne,label='Ener')
call mma_allocate(nv1w,ne*(ne+1)/2,label='nv1w')
call mma_allocate(nv2w,ne*(ne+1)/2,label='nv2w')
call mma_allocate(S,ne*(ne+1)/2,label='S')
call mma_allocate(Sw,ne*(ne+1)/2,label='Sw')
call mma_allocate(Obs,ne*(ne+1)/2,label='Obs')

SumO(:) = Zero
SumW(:) = Zero
Wmin(:) = Zero
Wmax(:) = Zero

del = (Umax-Umin)/(ndim-1)
iPrint = 1

! loop over rotational quantum numbers
do J=J1A,J2A

  ! Read vibrational functions for this J-value. store in vib.
  ist = 1
  iad = iad12(J-J1A+1)
  do nv=1,ne
    call DDafile(Vibwvs,2,Vib(ist),ndim1,iad)
    !write(u6,6668) nv,(Vib(i+ist-1),i=1,ndim+1)
    ist = ist+ndim1
  end do
  call DDafile(Vibwvs,2,Ener,ne,iad)

  ! Compute overlap matrix S
  ist1 = -ndim1
  nv12 = 0
  do nv1=1,ne
    ist1 = ist1+ndim1
    ist2 = -ndim1
    do nv2=1,nv1
      ist2 = ist2+ndim1
      nv12 = nv12+1

      ! Set up scalar product and integrate
      do i=1,ndim
        X(i) = Vib(i+ist1)*Vib(i+ist2)*R(i)**2
      end do
      call Simpsn(X,del,ndim,S(nv12))
    end do
  end do

  ! Check overlap matrix for non-orthogonality
  nv12 = 0
  Smax = Zero
  do nv1=1,ne
    do nv2=1,nv1
      nv12 = nv12+1
      if (nv1 /= nv2) then
        if (abs(S(nv12)) > abs(Smax)) Smax = S(nv12)
      end if
    end do
  end do
  if (abs(Smax) > 1.0e-4_wp) write(u6,1200) Smax

  ! Print overlap matrix
  if (iPrint >= 2) then
    write(u6,'(1x,A)') 'Overlap matrix for vibrational wave functions'
    nv12 = 0
    do nv1=1,ne
      do nv2=1,nv1
        nv12 = nv12+1
        nv1w(nv12) = nv1
        nv2w(nv12) = nv2
        Sw(nv12) = S(nv12)
      end do
    end do
    write(u6,'(6(3X,2I3,F12.6))') (nv1w(i),nv2w(i),Sw(i),i=1,nv12)
  end if

  ! set up integrand array for this Observable
  ist1 = -ndim
  nv12 = 0
  nv11 = 0
  do nv1=1,ne
    nv11 = nv11+nv1
    nv22 = 0
    ist1 = ist1+ndim
    ist2 = -ndim
    do nv2=1,nv1
      nv22 = nv22+nv2
      ist2 = ist2+ndim
      nv12 = nv12+1
      do i=1,ndim
        ri = R(i)
        X(i) = Vib(i+ist1)*Vib(i+ist2)*potR(i)*ri**2
      end do
      call Simpsn(x,del,ndim,Obsr)
      Obs(nv12) = Obsr/sqrt(S(nv11)*S(nv22))
    end do
  end do

  ! write matrix elements
  write(u6,'(">>>>",1x,A,I3)') 'matrix elements over vibrational wave functions (atomic units) for rotational quantum number',J
  nv12 = 0
  do nv1=1,ne
    do nv2=1,nv1
      nv12 = nv12+1
      nv1w(nv12) = nv1
      nv2w(nv12) = nv2
      Sw(nv12) = Obs(nv12)
    end do
  end do
  write(u6,'(6(3X,2I3,F12.6))') (nv1w(i),nv2w(i),Sw(i),i=1,nv12)
  Wfirst = One
  Wlast = Zero
  do nv=1,ne
    ind = nv*(nv+1)/2
    O = Obs(ind)
    E = Ener(nv)*Joule
    W = exp(-beta*E)
    SumW(nv) = SumW(nv)+W
    SumO(nv) = SumO(nv)+W*O
    if (J == J1a) then
      Wmax(nv) = W
      Wmin(nv) = W
    else
      Wmax(nv) = max(W,Wmax(nv))
      Wmin(nv) = min(W,Wmin(nv))
    end if
    if (nv == 1) Wfirst = W
    if (nv == ne) WLast = W
    !write(u6,'(a,3g15.6)') '... E,W,O ',E,W,O
  end do
  !write(u6,'(a,f12.6)') 'Wlast/Wfirst',Wlast/Wfirst
  if (Wlast/Wfirst > 1.0e-3_wp) then
    WarnVq = max(WarnVq,Wlast/Wfirst)
    WarnV = .true.
  end if

! End of loop over rotational quantum number
end do

do nv=1,ne
  !write(u6,'(a,i3)') 'Temp terms for vibration qn ',nv
  !write(u6,'(a,es15.6)') 'SumW(nv) ',SumW(nv)
  !write(u6,'(a,es15.6)') 'SumO(nv) ',SumO(nv)
  !write(u6,'(a,es15.6)') 'Wmax(nv) ',Wmax(nv)
  !write(u6,'(a,es15.6)') 'Wmin(nv) ',Wmin(nv)
  !write(u6,*)
  if (Wmin(nv)/Wmax(nv) > 1.0e-3_wp) then
    WarnRq = max(WarnRq,Wmin(nv)/Wmax(nv))
    WarnR = .true.
  end if
end do
O = Zero
W = Zero
do nv=1,ne
  O = O+SumO(nv)
  W = W+SumW(nv)
end do
O = O/W
write(u6,*)
write(u6,'(a,es15.6,a,f9.3,a)') 'Temperature averaged observable:',O,'  at',Temp,'K'
if (WarnV) then
  write(u6,*)
  write(u6,'(a)') '***'
  write(u6,'(a)') '*** Warning, temperature weighting not converged with respect to vibrational quantum numbers'
  write(u6,'(a)') '***'
  write(u6,'(a,es10.3,a)') '*** Quotient',WarnVq,' should be small'
  write(u6,'(a)') '***'
  write(u6,*)
end if
if (WarnR) then
  write(u6,*)
  write(u6,'(a)') '***'
  write(u6,'(a)') '*** Warning, temperature weighting not converged with respect to rotational quantum numbers'
  write(u6,'(a)') '***'
  write(u6,'(a,es10.3,a)') '*** Quotient',WarnRq,' should be small'
  write(u6,'(a)') '***'
  write(u6,*)
end if
call CollapseOutput(0,'Matrix elements of observable: '//Title)

call mma_deallocate(Vib)
call mma_deallocate(X)
call mma_deallocate(SumO)
call mma_deallocate(SumW)
call mma_deallocate(Wmin)
call mma_deallocate(Wmax)
call mma_deallocate(Ener)
call mma_deallocate(nv1w)
call mma_deallocate(nv2w)
call mma_deallocate(S)
call mma_deallocate(Sw)
call mma_deallocate(OBs)

! End of calculation for this Observable.

return

!6668 format(/1x,'Vib-values',i3/(1x,6f12.6))
1200 format(/1x,'***** Warning: Non-orthogonality between vibrational',1x,'wave functions.' &
            /13x,'Largest overlap matrix element is',f14.6)

end subroutine Vibmat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Luca De Vico                                           *
!***********************************************************************
!  Get_Nuc_Charge_All
!
!> @brief
!>   Get nuclear charges from RUNFILE
!> @author L. De Vico
!>
!> @details
!> Place nuclear charges (in a.u.) into array \p Charges_All(*).
!> Based on ::Get_Coord_All
!>
!> @param[out] Charges_All Array of charges
!> @param[in]  nAtoms_All  Number of atoms
!***********************************************************************

subroutine Get_Nuc_Charge_All(Charges_All,nAtoms_All)

use Symmetry_Info, only: iOper, nIrrep, Symmetry_Info_Get
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms_All
real(kind=wp), intent(out) :: Charges_All(nAtoms_All)
integer(kind=iwp) :: Active = 0, iAll_Atom, iChAtom, iCo, iCoSet(0:7,0:7), iGen(3), iStab(0:7), iUnique_Atom, MaxDCR, nAtoms, &
                     nAtoms_Allx, nCoSet, nGen, nStab
real(kind=wp) :: Charge_Old
real(kind=wp), allocatable :: CMu(:), CU(:,:)
integer(kind=iwp), external :: iChxyz

call Get_nAtoms_All(nAtoms_Allx)
if (nAtoms_All /= nAtoms_Allx) then
  write(u6,*) 'Get_Nuc_Charge_All: nAtoms_All /= nAtoms_Allx'
  write(u6,*) 'nAtoms_All=',nAtoms_All
  write(u6,*) 'nAtoms_Allx=',nAtoms_Allx
  call Abend()
end if

call Get_iScalar('Unique atoms',nAtoms)

call mma_allocate(CU,3,nAtoms,label='CU')
call Get_dArray('Unique Coordinates',CU,3*nAtoms)

call mma_allocate(CMu,nAtoms,label='CMu')
call Get_dArray('Nuclear charge',CMu,nAtoms)

!write(u6,*) 'Enter Get_Nuc_Charge_All_'
!                                                                      *
!***********************************************************************
!                                                                      *
if (Active == 0) then
  call Symmetry_Info_Get()
  Active = 1
end if
!write(u6,*) 'Get_Nuc_Charge_All_: nIrrep=',nIrrep
!write(u6,*) 'Get_Nuc_Charge_All_: iOper=',(iOper(i),i=0,nIrrep-1)
!                                                                      *
!***********************************************************************
!                                                                      *
nGen = 0
if (nIrrep == 2) nGen = 1
if (nIrrep == 4) nGen = 2
if (nIrrep == 8) nGen = 3
if (nGen >= 1) iGen(1) = iOper(1)
if (nGen >= 2) iGen(2) = iOper(2)
if (nGen == 3) iGen(3) = iOper(4)
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate list of all nuclear charges

iAll_Atom = 0
MaxDCR = 0
do iUnique_Atom=1,nAtoms
  iChAtom = iChxyz(CU(:,iUnique_Atom),iGen,nGen)
  call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
  nCoSet = nIrrep/nStab

  Charge_Old = CMu(iUnique_Atom)

  do iCo=0,nCoSet-1
    iAll_Atom = iAll_Atom+1
    Charges_All(iAll_Atom) = Charge_Old
  end do

end do

!call RecPrt('CMu',' ',CMu,1,nAtoms)
!call RecPrt('Charges_All',' ',Charges_All,1,nAtoms_All)
!                                                                      *
!***********************************************************************
!                                                                      *

call mma_deallocate(CU)
call mma_deallocate(CMu)

return

end subroutine Get_Nuc_Charge_All

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Markus P. Fuelscher                              *
!               2018, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine ReadVC(CMO,OCC,D,DS,P,PA,scheme)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     get start MO-coefficients                                        *
!     (if the CI is restarted from a previous calculation get          *
!      also the density matrices)                                      *
!                                                                      *
!     calling arguments:                                               *
!     CMO     : array of real*8                                        *
!               MO-coefficients                                        *
!     OCC     : array of real*8                                        *
!               occupation numbers                                     *
!     INVEC   : integer                                                *
!               flag indicating orbital type                           *
!     D       : array of real*8                                        *
!               averaged one-body density matrix                       *
!     DS      : array of real*8                                        *
!               averaged one-body spin density matrix                  *
!     P       : array of real*8                                        *
!               averaged two body density matrix                       *
!     PA      : array of real*8                                        *
!               averaged antisymmetric twobody density matrix          *
!     FI      : array of real*8                                        *
!               inactive Fock matrix                                   *
!     D1I     : array of real*8                                        *
!               inactive one body density matrix                       *
!     D1A     : array of real*8                                        *
!               active one body density matrix                         *
!     TUVX    : array of real*8                                        *
!               two-electron integrals (tu!vx)                         *
!     IFINAL  : integer                                                *
!               termination flag                                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher                                                  *
!     University of Lund, Sweden, 1998                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     none                                                             *
!                                                                      *
!***********************************************************************

use rasscf_global, only: iAdr15, iAlphaBeta, iCIrst, iOverwr, iPhName, iRoot, iSUPSM, iXsym, lRoots, nAcPar, nAcpr2, nOrbT, &
                         nRoots, purify, Weight
use general_data, only: CleanMask, Invec, JobIph, JobOld, LuStartOrb, nBas, nDel, nOrb, nSSH, nSym, nTot, nTot2, StartOrbFile
use casvb_global, only: ifvb
use orthonormalization, only: ON_scheme_values, orthonormalize, t_ON_scheme
use PrintLevel, only: DEBUG, TERSE, VERBOSE
use output_ras, only: IPRGLB, IPRLOC
use Molcas, only: LenIn, MaxBfn, MxOrb, MxRoot, MxSym
use RASDim, only: MxTit
#ifdef _HDF5_
use mh5, only: mh5_close_file, mh5_exists_dset, mh5_fetch_dset, mh5_open_file_r
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, RtoI

implicit none
real(kind=wp), intent(out) :: CMO(nTot2)
real(kind=wp), intent(inout) :: OCC(nTot), D(nAcPar), DS(nAcPar), P(nAcpr2), PA(nAcpr2)
type(t_ON_scheme), intent(in) :: scheme
integer(kind=iwp) :: i, iAD15, IAD19, IADR19(30), iDisk, iDummy(1), iErr, iJOB, iPrlev, iSym, jRoot, kRoot, lll, nData, NNwOrd, &
                     nTmp(8)
real(kind=wp) :: Dummy(1), Scal
logical(kind=iwp) :: changed, found
character(len=(LenIn+8)*mxOrb) :: lJobH1
character(len=2*72) :: lJobH2
character(len=80) :: VecTit
character(len=72) :: JobTit(mxTit)
character(len=4) :: Label
integer(kind=iwp), allocatable :: JobH(:), NewOrd(:), TIND(:), TmpXSym(:)
real(kind=wp), allocatable :: CMO_copy(:), Ene(:), JobR(:), Scr(:)
#ifdef _HDF5_
integer(kind=iwp) :: mh5id
character(len=:), allocatable :: typestring
#endif
integer(kind=iwp), external :: isfreeunit
#include "warnings.h"

!----------------------------------------------------------------------*
!                                                                      *
!----------------------------------------------------------------------*
! Local print level (if any)
IPRLEV = IPRLOC(1)
if (IPRLEV >= DEBUG) write(u6,*) ' Entering READVC'
!----------------------------------------------------------------------*
! Do we use default orbitals?                                          *
!----------------------------------------------------------------------*
if (InVec == 0) then
  call qpg_darray('RASSCF orbitals',Found,nData)
  if (Found) then
    InVec = 6
    if (IPRLEV >= TERSE) write(u6,'(6x,a)') 'Orbitals from runfile: rasscf orbitals'
  end if
end if
call Check_InVec(InVec)
if (InVec == 0) then
  call qpg_darray('SCF orbitals',Found,nData)
  if (Found) then
    InVec = 7
    if (IPRLEV >= TERSE) write(u6,'(6x,a)') 'Orbitals from runfile: scf orbitals'
  end if
end if
call Check_InVec(InVec)
if (InVec == 0) then
  call qpg_darray('Guessorb',Found,nData)
  if (Found) then
    InVec = 5
    if (IPRLEV >= TERSE) write(u6,'(6x,a)') 'Orbitals from runfile: guessorb orbitals'
  end if
end if
call Check_InVec(InVec)
if (Invec == 0) InVec = 1

!----------------------------------------------------------------------*
LUStartOrb = IsFreeUnit(19)
if (ifvb == 2) invec = 3
if (InVec == 2) then
  ! read from unit formatted ascii file with starting orbitals

  ! Note: Inside RDVEC, the file StartOrbFile is opened, but uses blindly
  ! the unit number provided here. So that should better be a usable
  ! number, or else!
  Label = 'CO  '
  if (iAlphaBeta == 1) Label(3:3) = 'A'
  if (iAlphaBeta == -1) Label(3:3) = 'B'
  if (iOverwr == 1) then
    call RDVEC(StartOrbFile,LUStartOrb,Label,NSYM,NBAS,NBAS,CMO,OCC,Dummy,iDummy,VECTIT,0,iErr)
  else
    Label(4:4) = 'I'
    call mma_allocate(TIND,maxbfn,Label='TIND')
    call RDVEC(StartOrbFile,LUStartOrb,Label,NSYM,NBAS,NBAS,CMO,OCC,Dummy,TIND,VECTIT,0,iErr)
    ! If the typeindex array is used to resort orbitals, then if also
    ! a supersymmetry array is used, it has to be changed.
    ! The supersymmtry array is IXSYM().
    ! VECSORT is a utility that does not know about supersymmetry.
    ! So changing any orbital indices in IXSYM (or potentially any
    ! other orbital indices -- what about ALTER??) must be done HERE
    ! immediately togather with the VecSort, but not *inside* VecSort.

    ! But VecSort does not return any indexing information -- how are
    ! we to know how to change IXSYM?
    ! VecSort changed to include a reindexing array!
    NNwOrd = sum(NBas(1:NSym))
    call mma_allocate(NEWORD,NNwOrd,Label='NewOrd')
    !call VecSort(NSYM,NBAS,NBAS,CMO,OCC,TIND,iErr)
    call VecSort(NSYM,NBAS,NBAS,CMO,OCC,TIND,NNwOrd,NewOrd,iErr)
    ! If there is a supersymmetry array, use the orbital mapping:
    if (iSUPSM /= 0) then
      call mma_allocate(TMPXSYM,NNwOrd,Label='TmpXSym')
      do I=1,NNwOrd
        TmpXSym(I) = IXSYM(NewOrd(I))
      end do
      IXSYM(1:NNwOrd) = TmpXSym(:)
      call mma_deallocate(TMPXSYM)
    end if

    call mma_deallocate(NewOrd)
    call mma_deallocate(TIND)
  end if
  close(LUStartOrb)
  if (iErr == 1) then
    write(u6,*) 'RASSCF tried to read input orbitals from a'
    write(u6,*) 'file, but encountered an error in the'
    write(u6,*) 'TypeIndex data.'
    call Abend()
    return
  end if

  if (IPRLEV >= TERSE) then
    write(u6,'(6X,A)') 'The MO-coefficients are taken from the file:'
    write(u6,'(6X,A)') trim(StartOrbFile)
    write(u6,'(6X,A,A)') 'Title:',VecTit(2:80)
  end if

else if (InVec == 3) then
  ! read from unit JOBOLD (binary file)
  IAD19 = 0
  iJOB = 0
  call f_Inquire('JOBOLD',Found)
  if (Found) iJOB = 1
  if (iJOB == 1) then
    if (JOBOLD <= 0) then
      JOBOLD = 20
      call DaName(JOBOLD,'JOBOLD')
    end if
  else
    if (IPRLEV >= TERSE) write(u6,'(6X,A)') 'File JOBOLD not found -- use JOBIPH.'
    if (JOBIPH > 0) then
      JOBOLD = JOBIPH
    else
      call DaName(JOBOLD,IPHNAME)
    end if
  end if
  call IDaFile(JOBOLD,2,IADR19,15,IAD19)
  if (IADR19(15) == -1) then
    IAD19 = 0
    call IDAFILE(JOBOLD,2,IADR19,30,IAD19)
  else
    IADR19(16:30) = 0
    if (IPRGLB >= VERBOSE) call WarningMessage(1,'Old JOBIP file layout.')
  end if
  lll = 10+RtoI
  lll = max(lll,mxSym)
  lll = max(lll,mxOrb)
  lll = max(lll,mxRoot)
  call mma_allocate(JobH,lll,Label='JobH')
  call mma_allocate(JobR,MxRoot,Label='JobH')
  iAd19 = iAdr19(1)
  call WR_RASSCF_Info(JobOld,2,iAd19,JobH(1),JobH(2),JobH(3),JobH(4),JobH,JobH,JobH,JobH,JobH,mxSym,lJobH1,(LenIn+8)*mxOrb, &
                      JobH(5),lJobH2,2*72,JobTit,72*mxTit,JobR(1),JobH(6),JobH(7),JobH,mxRoot,JobH,JobH,JobH,JobH(8),JobH(9), &
                      JobH(10),JobR(:))
  if (IPRLEV >= TERSE) then
    if (iJOB == 1) then
      write(u6,'(6X,A)') 'The MO-coefficients are taken from the file:'
      write(u6,'(6X,A)') 'JOBOLD'
    else
      write(u6,'(6X,A)') 'The MO-coefficients are taken from the file:'
      write(u6,'(6X,A)') trim(iPhName)
    end if
    write(VecTit(1:72),'(A72)') JobTit(1)
    write(u6,'(6X,2A)') 'Title:',VecTit(1:72)
  end if
  call mma_deallocate(JobH)
  call mma_deallocate(JobR)
  iAd19 = iAdr19(2)
  call DDaFile(JobOld,2,CMO,NTOT2,iAd19)
  call DDaFile(JobOld,2,OCC,nTot,iAd19)
  if (ICIRST == 1) then
    if (IPRLEV >= VERBOSE) then
      if (iJOB == 1) then
        write(u6,'(6X,A)') 'The active density matrices (D,DS,P,PA) are read from file JOBOLD and weighted together.'
      else
        write(u6,'(6X,A)') 'The active density matrices (D,DS,P,PA) are read from file '//trim(iPhName)//' and weighted together.'
      end if
    end if
    call mma_allocate(Scr,NACPR2,Label='Scr')
    iDisk = IADR19(3)
    do jRoot=1,lRoots
      Scal = Zero
      do kRoot=nRoots,1,-1
        if (iRoot(kRoot) == jRoot) then
          Scal = Weight(kRoot)
          exit
        end if
      end do
      call DDaFile(JOBOLD,2,scr,NACPAR,iDisk)
      D(:) = D(:)+Scal*Scr(1:NACPAR)
      call DDaFile(JOBOLD,2,scr,NACPAR,iDisk)
      DS(:) = DS(:)+Scal*Scr(1:NACPAR)
      call DDaFile(JOBOLD,2,scr,NACPR2,iDisk)
      P(:) = P(:)+Scal*Scr(:)
      call DDaFile(JOBOLD,2,scr,NACPR2,iDisk)
      PA(:) = PA(:)+Scal*Scr(:)
    end do
    call mma_deallocate(Scr)
  end if
  !SVC: read the L2ACT and LEVEL arrays from the jobiph file
  !IFG: disabled, since it breaks when changing active space specification
  !IAD19 = IADR19(18)
  !if (IAD19 /= 0) then
  !  call IDAFILE(JOBOLD,2,IDXSX,mxAct,IAD19)
  !  call IDAFILE(JOBOLD,2,IDXCI,mxAct,IAD19)
  !end if
  if ((JOBOLD > 0) .and. (JOBOLD /= JOBIPH)) then
    call DaClos(JOBOLD)
    JOBOLD = -1
  else if (JOBOLD > 0) then
    JOBOLD = -1
  end if

else if (InVec == 4) then
  ! read from a HDF5 wavefunction file
# ifdef _HDF5_
  if (IPRLEV >= TERSE) then
    write(u6,'(6X,A)') 'The MO-coefficients are taken from the file:'
    write(u6,'(6X,A)') trim(StartOrbFile)
  end if

  mh5id = mh5_open_file_r(StartOrbFile)
  call mma_allocate(typestring,maxbfn,Label='typestring')
  typestring(1:maxbfn) = ''
  select case (iAlphaBeta)
    case (1)
      Label = 'CA  '
      VecTit = 'MO_ALPHA_TYPEINDICES'
    case (-1)
      Label = 'CB  '
      VecTit = 'MO_BETA_TYPEINDICES'
    case default
      Label = 'C   '
      VecTit = 'MO_TYPEINDICES'
  end select
  call RdVec_HDF5(mh5id,Label,NSYM,NBAS,CMO,Dummy,Dummy,iDummy)
  if (mh5_exists_dset(mh5id,trim(VecTit))) call mh5_fetch_dset(mh5id,trim(VecTit),typestring)
  call mh5_close_file(mh5id)
  ! Reorder orbitals based on typeindex
  if (typestring /= '') then
    NNwOrd = sum(NBas(1:nSym))
    call mma_allocate(TInd,NNWOrd,Label='TIND')
    call mma_allocate(NewOrd,NNwOrd,Label='NewOrd')
    call tpstr2tpidx(typestring,TInd,NNWOrd)
    call VecSort(NSYM,NBAS,NBAS,CMO,OCC,TInd,NNwOrd,NewOrd,iErr)
    ! If there is a supersymmetry array, use the orbital mapping:
    if (iSUPSM /= 0) then
      call mma_allocate(TmpXSym,NNwOrd,Label='TmpXSym')
      do i=1,NNwOrd
        TmpXSym(i) = iXSym(NewOrd(i))
      end do
      iXSym(1:NNwOrd) = TmpXSym(:)
      call mma_deallocate(TmpXSym)
    end if
    call mma_deallocate(NewOrd)
    call mma_deallocate(TInd)
  end if
  call mma_deallocate(typestring)
# else
  write(u6,*) 'Orbitals requested from HDF5, but this'
  write(u6,*) 'installation does not support that, abort!'
  call abend()
# endif

else if (InVec == 5) then
  ! guess MO-coefficients

  if (IPRLEV >= VERBOSE) write(u6,'(6x,a)') 'Detected guessorb orbitals'
  call Qpg_dArray('Guessorb',Found,nData)
  call Get_dArray('Guessorb',CMO,nData)
  call Qpg_iArray('nDel_go',Found,nData)
  if (Found) then
    call Get_iArray('nDel_go',nTmp,nData)
    Changed = .false.
    do iSym=1,nSym
      if (nTmp(iSym) > nDel(iSym)) Changed = .true.
    end do
    if (Changed) then
      write(u6,'(5x,a,8i5)') 'Number of deleted orbitals changed from',(nDel(i),i=1,nSym)
      write(u6,'(5x,a,8i5)') '                           changed to  ',(nTmp(i),i=1,nSym)
    end if
    do iSym=1,nSym
      if (nTmp(iSym) > nDel(iSym)) then
        nSsh(iSym) = nSsh(iSym)-nTmp(iSym)+nDel(iSym)
        nOrb(iSym) = nOrb(iSym)-nTmp(iSym)+nDel(iSym)
        nOrbT = nOrbT-nTmp(iSym)+nDel(iSym)
        nDel(iSym) = nTmp(iSym)
      end if
    end do
    if (IPRLEV >= TERSE) write(u6,'(6X,A)') 'The MO-coefficients are taken from guessorb on runfile'
  end if
else if (InVec == 6) then
  if (IPRLEV >= VERBOSE) write(u6,'(6x,a)') 'Detected old RASSCF orbitals'
  call qpg_darray('RASSCF orbitals',Found,nData)
  call get_darray('RASSCF orbitals',CMO,nData)
  call Qpg_iArray('nDel',Found,nData)
  if (Found) then
    call Get_iArray('nDel',nTmp,nData)
    Changed = .false.
    do iSym=1,nSym
      if (nTmp(iSym) > nDel(iSym)) Changed = .true.
    end do
    if (Changed) then
      write(u6,'(5x,a,8i5)') 'Number of deleted orbitals changed from',(nDel(i),i=1,nSym)
      write(u6,'(5x,a,8i5)') '                           changed to  ',(nTmp(i),i=1,nSym)
    end if
    do iSym=1,nSym
      if (nTmp(iSym) > nDel(iSym)) then
        nSsh(iSym) = nSsh(iSym)-nTmp(iSym)+nDel(iSym)
        nOrb(iSym) = nOrb(iSym)-nTmp(iSym)+nDel(iSym)
        nOrbT = nOrbT-nTmp(iSym)+nDel(iSym)
        nDel(iSym) = nTmp(iSym)
      end if
    end do
    if (IPRLEV >= TERSE) write(u6,'(6X,A)') 'The MO-coefficients are taken from rasscf orbitals on runfile'
  end if
else if (InVec == 7) then
  if (IPRLEV >= VERBOSE) write(u6,'(6x,a)') 'Detected SCF orbitals'
  call qpg_darray('SCF orbitals',Found,nData)
  call get_darray('SCF orbitals',CMO,nData)
  call Qpg_iArray('nDel',Found,nData)
  if (Found) then
    call Get_iArray('nDel',nTmp,nData)
    Changed = .false.
    do iSym=1,nSym
      if (nTmp(iSym) > nDel(iSym)) Changed = .true.
    end do
    if (Changed) then
      write(u6,'(5x,a,8i5)') 'Number of deleted orbitals changed from',(nDel(i),i=1,nSym)
      write(u6,'(5x,a,8i5)') '                           changed to  ',(nTmp(i),i=1,nSym)
    end if
    do iSym=1,nSym
      if (nTmp(iSym) > nDel(iSym)) then
        nSsh(iSym) = nSsh(iSym)-nTmp(iSym)+nDel(iSym)
        nOrb(iSym) = nOrb(iSym)-nTmp(iSym)+nDel(iSym)
        nOrbT = nOrbT-nTmp(iSym)+nDel(iSym)
        nDel(iSym) = nTmp(iSym)
      end if
    end do
  end if
  if (IPRLEV >= TERSE) write(u6,'(6X,A)') 'The MO-coefficients are taken from scf orbitals on runfile'
else if (InVec == 1) then
  if (IPRLEV >= VERBOSE) write(u6,'(6X,A)') 'The MO-coefficients are obtained by diagonalizing the core Hamiltonian'
  call Guess(CMO)
else
  write(u6,*) 'Severe internal bug prevents further calculation.'
  write(u6,*) 'Invalid value for INVEC in READVC. Program stops.'
  write(u6,*) 'Please issue bug report. INVEC=',INVEC
  call QUIT(_RC_GENERAL_ERROR_)
end if
! print start orbitals
if (IPRLEV >= DEBUG) then
  call mma_allocate(ENE,nTot,Label='ENE')
  ENE(:) = Zero
  call PRIMO_RASSCF('Input orbitals',ENE,OCC,CMO)
  call mma_deallocate(ENE)
end if

! cleaning orbitals for high symmetry cases

if (allocated(CleanMask)) call ClnMO(CMO)
if (PURIFY(1:6) == 'LINEAR') call LINPUR(CMO)
if (PURIFY(1:4) == 'ATOM') call SPHPUR(CMO)

if (scheme%val /= ON_scheme_values%no_ON) then
  call mma_allocate(CMO_copy,nTot2)
  CMO_copy(:) = CMO(:)
  call orthonormalize(CMO_copy,scheme,CMO)
  call mma_deallocate(CMO_copy)
end if

! save start orbitals

IAD15 = IADR15(2)
call DDAFILE(JOBIPH,1,CMO,NTOT2,IAD15)
call DDAFILE(JOBIPH,1,OCC,NTOT,IAD15)

! exit

return

end subroutine ReadVC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function GETH1E(IORB,ITP,ISM,JORB,JTP,JSM)
! One-electron integral for active
! orbitals (IORB,ITP,ISM),(JORB,JTP,JSM)
!
! The orbital symmetries are used to obtain the
! total symmetry of the operator

use Symmetry_Info, only: Mul
use lucia_data, only: IBSO, IH1FORM, INT1, IOBPTS, IREOTS, MXPNGAS, NACOBS, PGINT1, PGINT1A, PINT1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: GETH1E
integer(kind=iwp), intent(in) :: IORB, ITP, ISM, JORB, JTP, JSM
integer(kind=iwp) :: IJSM
real(kind=wp), external :: GTH1ES

IJSM = Mul(ISM,JSM)
GETH1E = Zero
if (IH1FORM == 1) then
  ! Normal integrals, lower triangular packed
  if (IJSM == 1) then
    !write(u6,*) ' GETH1E, old route'
    GETH1E = GTH1ES(IREOTS,PINT1,INT1,IBSO,MXPNGAS,IOBPTS,NACOBS,IORB,ITP,ISM,JORB,JTP,JSM,1)
  else
    GETH1E = GTH1ES(IREOTS,PGINT1(IJSM)%A,INT1,IBSO,MXPNGAS,IOBPTS,NACOBS,IORB,ITP,ISM,JORB,JTP,JSM,1)
  end if
else
  ! Integrals are in full blocked form
  GETH1E = GTH1ES(IREOTS,PGINT1A(IJSM)%A,INT1,IBSO,MXPNGAS,IOBPTS,NACOBS,IORB,ITP,ISM,JORB,JTP,JSM,0)
end if

end function GETH1E

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine GetGrad_ER(Functional,GradNorm,R,CMO,nBasis,nOrb2Loc,Timing)
! Thomas Bondo Pedersen, November 2005.
!
! Purpose: compute ER Functional and its gradient norm.
!          The R matrix is computed as R(i,j) = (ij|jj).
!
! Note: symmetry is NOT allowed (but is not tested!).

use Data_structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use Constants, only: Zero, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBasis, nOrb2Loc
real(kind=wp), intent(out) :: Functional, GradNorm, R(nOrb2Loc,nOrb2Loc)
real(kind=wp), intent(in) :: CMO(nBasis,nOrb2Loc)
logical(kind=iwp), intent(in) :: Timing
integer(kind=iwp), parameter :: nSym = 1
integer(kind=iwp) :: i, irc, j, nOcc(nSym)
character(len=80) :: Txt
type(DSBA_Type) :: CMOt
character(len=*), parameter :: SecNam = 'GetGrad_ER'

! Initialization.
! ---------------

Functional = Zero
GradNorm = Zero
if ((nOrb2Loc < 1) .or. (nBasis < 1)) return

! Transpose CMO (only the part to be localised).
! ----------------------------------------------

call Allocate_DT(CMOt,[nOrb2Loc],[nBasis],nSym)
do i=1,nOrb2Loc
  CMOt%SB(1)%A2(i,:) = CMO(:,i)
end do

! Compute R.
! ----------

nOcc(1) = nOrb2Loc
irc = -1
call Cho_Get_Rij(irc,CMOt,nOcc,R,Timing)
if (irc /= 0) then
  write(Txt,'(A,I6)') 'Cho_Get_Rij returned',irc
  call SysAbendMsg(SecNam,'Calculation of ER gradient failed:',Txt)
end if
call Deallocate_DT(CMOt)

! Compute gradient norm and functional.
! -------------------------------------

do i=1,nOrb2Loc-1
  Functional = Functional+R(i,i)
  do j=i+1,nOrb2Loc
    GradNorm = GradNorm+(R(i,j)-R(j,i))**2
  end do
end do
Functional = Functional+R(nOrb2Loc,nOrb2Loc)
GradNorm = Four*sqrt(GradNorm)

end subroutine GetGrad_ER

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine PckMO2(COUT,nAcO,icmpi,iBasi,jcmpj,jBasj,iAOi,jAOj)
      use Basis_Info, only: nBas
      use SOAO_Info, only: iAOtSO
      use pso_stuff
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "etwas.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 COUT(*)
      Integer iCmp(4),nBs(4)
      Integer iTwoj(0:7),iaoii(4)
      Data iTwoj/1,2,4,8,16,32,64,128/
*
      nBs(1)=iBasi
      nBs(2)=jBasj
      iAOii(1)=iAOi
      iAOii(2)=jAOj
      icmp(1)=icmpi
      icmp(2)=jcmpj
      ip2=1
      nA=0
      Do iIrrep=0,nIrrep-1
         nA=nA+nAsh(iIrrep)
      End Do
      Do iCnt=1,2
         ipC=0
         Do iIrrep=0,nIrrep-1
            iOrb=nIsh(iIrrep)
            Do iAsh=1,nAsh(iIrrep)
               jj=iCmp(iCnt)
               Do i1=1,jj
                  iSO=iAOtSO(iAOii(iCnt)+i1,iIrrep)
                  If (iSO>0) Then
                     ip1=ipC+(iOrb+iAsh-1)*nBas(iIrrep)+iso
                     call dcopy_(nBs(iCnt),CMO(ip1,1),1,COUT(ip2),1)
                  Else
                     call dcopy_(nBs(iCnt),[0.0d0],0,COUT(ip2),1)
                  End If
                  ip2=ip2+nBs(iCnt)
               End Do
            End Do
            ipc=ipc+nBas(iIrrep)**2
         End Do
      End Do
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nAcO)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mxgendiag_cvb(a,s,eigval,n)
      implicit real*8 (a-h,o-z)
#include "malloc_cvb.fh"
      dimension a(n,n),s(n,n),eigval(n)
      dimension wrk(1)

      info=0
      lwrk=-1
      call dsygv_(1,'V','U',n,a,n,s,n,eigval,wrk,lwrk,info)
      lwrk=nint(wrk(1))
      i1 = mstackr_cvb(lwrk)
      call dsygv_(1,'V','U',n,a,n,s,n,eigval,w(i1),lwrk,info)
      call mfreer_cvb(i1)
      if(info.ne.0)then
        write(6,*)' Error in generalized diagonalization!'
        write(6,*)' Dsygv exited with code:',info
        call abend_cvb()
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PrOrbTab(ORBTAB)
      IMPLICIT NONE
      INTEGER ORBTAB(*)
      CHARACTER(LEN=8)  STRING8
      CHARACTER(LEN=8), EXTERNAL :: ORBNAM
      INTEGER IEXTNUM,INPART,INSBP,ISORB,IPART,ISMLAB,ISOIND
      INTEGER ISPART,ISPLAB,NSPORB,KOINFO,KSPART
      INTEGER NSPART
      WRITE(6,*)
      WRITE(6,*)'============================================='
      WRITE(6,*)' Orbital table printout.'
      WRITE(6,'(a,i16)')'            Table size:',ORBTAB(1)
      WRITE(6,'(a,i16)')'       Table type code:',ORBTAB(2)
      WRITE(6,'(a,i16)')'   Nr of spin-orbitals:',ORBTAB(3)
      WRITE(6,'(a,i16)')' Nr of active sp-orbs :',ORBTAB(4)
      WRITE(6,'(a,i16)')' Nr of symmetry labels:',ORBTAB(5)
      WRITE(6,'(a,i16)')' Nr of partitions     :',ORBTAB(6)
      WRITE(6,'(a,i16)')' Nr of sub-partitions :',ORBTAB(7)
      WRITE(6,'(a,i16)')' Nr of active part    :',ORBTAB(8)
      WRITE(6,'(a,i16)')' Nr of active subpart :',ORBTAB(9)
      WRITE(6,*)'---------------------------------------------'
      WRITE(6,*)' IEXTNUM  = Orbital index, in external order.'
      WRITE(6,*)' ISMLAB= Symmetry label'
      WRITE(6,*)' ISOIND= In-Symmetry orbital index, external order.'
      WRITE(6,*)' ISPLAB= Spin component label'
      WRITE(6,*)' IPART= Orbital partition label'
      WRITE(6,*)' INPART= In-Partition orbital index'
      WRITE(6,*)' ISPART= Orbital sub-partition label'
      WRITE(6,*)' INSBP = In-Subpartition orbital index'
      WRITE(6,*)' ORBNAM= Orbital name'
      WRITE(6,*)'---------------------------------------------'
      NSPORB= ORBTAB(3)
      KOINFO=19
      NSPART=ORBTAB(7)
      KSPART=ORBTAB(10)
      WRITE(6,*)'         IEXTNUM ISMLAB ISOIND ISPLAB  IPART INPART'
     &           //' ISPART  INSBP ORBNAM'
      DO ISORB=1,NSPORB
        IEXTNUM= ORBTAB(KOINFO+ 0+(ISORB-1)*8)
        ISMLAB = ORBTAB(KOINFO+ 1+(ISORB-1)*8)
        ISOIND = ORBTAB(KOINFO+ 2+(ISORB-1)*8)
        ISPLAB = ORBTAB(KOINFO+ 3+(ISORB-1)*8)
        IPART  = ORBTAB(KOINFO+ 4+(ISORB-1)*8)
        INPART = ORBTAB(KOINFO+ 5+(ISORB-1)*8)
        ISPART = ORBTAB(KOINFO+ 6+(ISORB-1)*8)
        INSBP  = ORBTAB(KOINFO+ 7+(ISORB-1)*8)
        STRING8= ORBNAM(ISORB,ORBTAB)
        WRITE(6,'(1x,9I7,2X,A8)') ISORB,IEXTNUM,ISMLAB,ISOIND,ISPLAB,
     &                           IPART,INPART,ISPART,INSBP,STRING8
      END DO
      WRITE(6,*)
      WRITE(6,*)' Nr of spin orbitals in each subpartition:'
      WRITE(6,'(1x,20i5)') (ORBTAB(KSPART-1+ISPART),ISPART=1,NSPART)
      WRITE(6,*)'============================================='

      END SUBROUTINE PrOrbTab

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Dresselhaus                                     *
!***********************************************************************
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
! Object: calculate the energy due to an embedding potential           !
!                                                                      !
! Called from: RASSCF                                                  !
!                                                                      !
! Calling    : ddot_                                                   !
!              dcopy                                                   !
!              daxpy                                                   !
!                                                                      !
!     Author: Thomas Dresselhaus                                       !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!real(kind=wp) function embPotEne1(density,length)
!
!use stdalloc, only: mma_allocate, mma_deallocate
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: length
!real(kind=wp), intent(in) :: density(length)
!
!! Local variables
!integer(kind=iwp) :: readCheck
!real(kind=wp), allocatable :: embInts(:)
!real(kind=wp), external :: embpotenescf
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!! Allocate memory for the integrals
!call mma_allocate(embInts,length,label='EmbPotInts')
!
!! Read in the one-electron integrals due to the embedding potential
!readCheck = -1
!call RdOne(readCheck,6,'embpot  ',1,embInts,1)
!if (readCheck /= 0) then
!  write(u6,*) 'R1Inta: Error readin ONEINT'
!  write(u6,'(a,a)') 'Label=embpot  '
!  call Abend()
!end if
!
!! Calculate
!embPotEne1 = embPotEneSCF(density,embInts,length)
!
!! Clean Memory
!call mma_deallocate(embInts)
!
!end function

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
real(kind=wp) function embPotEneSCF(density,embeddingInts,length)

use Definitions, only: wp, iwp, r8

implicit none
integer(kind=iwp), intent(in) :: length
real(kind=wp), intent(in) :: density(length), embeddingInts(length)
real(kind=r8), external :: ddot_

! In this case the energy is just the dot-product of the vectors which resemble
! the packed matrices.
embPotEneSCF = DDot_(length,density,1,embeddingInts,1)

end function embPotEneSCF

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
real(kind=wp) function embPotEneMODensities(densityInactive,densityActive,embeddingInts,nBasPerSym,nBasTotSquare,nSym)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, nBasPerSym(nSym), nBasTotSquare
real(kind=wp), intent(in) :: densityInactive(nBasTotSquare), densityActive(nBasTotSquare), embeddingInts(*)
!real(kind=wp), intent(in) :: coefficientMatrix(nBasFunc**2)

! Local variables
real(kind=wp), allocatable :: totalDensity(:), totalDensityPacked(:)
!real(kind=wp), allocatable :: transformedEmbInts(:)
real(kind=wp) :: embpotenescf
integer(kind=iwp) :: i, dens_dim_packed, iRow, iCol, counter, counter2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! TODO
!if (nFrozenOrbs > 0) then
!  write(u6,*) 'ERROR! Usage of an embedding potential is not yet able to treat frozen orbitals!'
!  call Abend()
!end if

call mma_allocate(totalDensity,nBasTotSquare)

dens_dim_packed = 0
do i=1,nSym
  dens_dim_packed = dens_dim_packed+((nBasPerSym(i)*(nBasPerSym(i)+1))/2)
end do
call mma_allocate(totalDensityPacked,dens_dim_packed)

call dcopy_(nBasTotSquare,densityInactive,1,totalDensity,1)
call daxpy_(nBasTotSquare,One,densityActive,1,totalDensity,1)

!write(u6,*) 'Unpacked total density'
!do i=1, dens_dim
!  write(u6,*) totalDensity(i)
!end do

!Pack density
counter = 0
counter2 = 0
do i=1,nSym
  do iRow=1,nBasPerSym(i)
    do iCol=1,iRow
      counter = counter+1
      if (iRow == iCol) then
        totalDensityPacked(counter) = totalDensity((iRow-1)*nBasPerSym(i)+iCol+counter2)
      else
        totalDensityPacked(counter) = 2*totalDensity((iRow-1)*nBasPerSym(i)+iCol+counter2)
      end if
    end do
  end do
  counter2 = counter2+nBasPerSym(i)*nBasPerSym(i)
end do
!write(u6,*) 'nSym=', nSym
!write(u6,*) 'nTot2=', nBasTotSquare
!write(u6,*) 'dens_dim_packed=', dens_dim_packed
!write(u6,*) 'FOOOO Total dens    |  pot'
!do i=1, dens_dim_packed
!  write(u6,*) totalDensityPacked(i), '  |  ', embeddingInts(i)
!end do

!! Transformation
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Well, a TraFo does not seem to be necessary.                               !
! Justification:                                                             !
! 1. The totalDensity matrix (sum of the incoming ones) is exactly symmetric !
! 2. With the currently activated scheme the integrated density on the grid  !
!    produces the correct number of electrons.                               !
! 3. In a CASSCF calculation with 0 active electrons/orbitals (i.e. actually !
!    a HF calculation) the totalDensity matrix should be diagonal with only  !
!    '2.0's and '0.0's on the diagonal if it is expressed in MO basis. This  !
!    is not observed though.
! Conclusion: the incoming matrices actually are expressed in the AO basis;  !
!             they are just not packed.                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!call transAOtoMO(coefficientMatrix,embeddingInts,transformedEmbInts,nBasFunc,nFrozenOrbs)
!
!embPotEneMODensities = embPotEneSCF(totalDensity,transformedEmbInts,dens_dim)
embPotEneMODensities = embPotEneSCF(totalDensityPacked,embeddingInts,dens_dim_packed)

call mma_deallocate(totalDensity)
call mma_deallocate(totalDensityPacked)
!call mma_deallocate(transformedEmbInts)

return

end function embPotEneMODensities

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Just to be clean this is in a seperate subroutine          !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!subroutine transAOtoMO (coefficientMatrix,inMatrix,outMatrix,nBasFunc,nFrozenOrbs)
!
!use stdalloc, only: mma_allocate, mma_deallocate
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: nBasFunc, nFrozenOrbs
!real(kind=wp), intent(in) :: coefficientMatrix(nBasFunc**2), inMatrix(nBasFunc*(nBasFunc+1)/2)
!real(kind=wp), intent(out) :: outMatrix(nBasFunc*(nBasFunc+1)/2)
!
!! Local variables
!real(kind=wp), allocatable :: unpackedMatrix(:), halfTrafoMat(:)
!
!call mma_allocate(unpackedMatrix,nBasFunc**2,label='unpackedMatrix')
!call mma_allocate(halfTrafoMat,nBasFunc**2,label='halfTrafoMat')
!
!! TODO
!if (nFrozenOrbs > 0) then
!  write(u6,*) 'ERROR! Usage of an embedding potential is not yet able to treat frozen orbitals!'
!  call Abend()
!end if
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!call Square(inMatrix,unpackedMatrix,1,nBasFunc,nBasFunc)
!! stefan: check T (transpose) whether it is correct...
!call DGEMM_('T','N',nBasFunc,nBasFunc,nBasFunc,One,unpackedMatrix,nBasFunc,coefficientMatrix(nFrozenOrbs*nBasFunc),nBasFunc,Zero, &
!            halfTrafoMat,nBasFunc)
!call DGEMM_Tri('T','N',nBasFunc,nBasFunc,nBasFunc,One,halfTrafoMat,nBasFunc,coefficientMatrix(nFrozenOrbs*nBasFunc),nBasFunc, &
!               Zero,outMatrix,nBasFunc)
!
!call mma_deallocate(unpackedMatrix)
!call mma_deallocate(halfTrafoMat)
!
!end subroutine

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_ZeroDiag_Rst(Diag,iSym,iABG)
C
C     Purpose: zero diagonal element iABG (in global diagonal, rs1).
C              For serial runs, this is trivial. For parallel runs, we
C              need first to figure out if the treated diagonal element
C              is in fact present in the local diagonal.
C
      Implicit None
      Real*8  Diag(*)
      Integer iSym, iABG
#include "cho_para_info.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "choglob.fh"
#include "WrkSpc.fh"

      Integer iAB1, iAB2, iAB, jAB, kAB

      Integer i, j
      Integer IndRed, iL2G
      IndRed(i,j)=iWork(ip_IndRed-1+mmBstRT*(j-1)+i)
      iL2G(i)=iWork(ip_iL2G-1+i)

      If (Cho_Real_Par) Then
         iAB1 = iiBstR(iSym,2) + 1
         iAB2 = iAB1 + nnBstR(iSym,2) - 1
         Do iAB = iAB1,iAB2
            jAB = IndRed(iAB,2)  ! addr in local rs1
            kAB = iL2G(jAB)      ! addr in global rs1
            If (kAB .eq. iABG) Then ! found...
               Diag(jAB) = 0.0d0    ! now zero local diagonal elm.
               Return
            End If
         End Do
      Else
         Diag(iABG) = 0.0d0
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Lowdin_LP(S,C,nDim)
! S: full-storage overlap (S) matrix
! C: on exit, the S^-1/2 matrix

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nDim
real(kind=wp), intent(in) :: S(nDim,nDim)
real(kind=wp), intent(out) :: C(nDim,nDim)
integer(kind=iwp) :: i, j, k
real(kind=wp) :: eigenv, sij, toosml
real(kind=wp), allocatable :: Blk(:,:), Eval(:)
real(kind=wp), parameter :: DIAGTH = 1.0e-12_wp, DANGER = 1.0e3_wp

! diagth  threshold for matrix diagonalization used in
!         subroutine jacobi.  in jacobi, this  constant
!         is called doneth.
! danger  criterion for deciding that the job should be
!         aborted due to numerical problems caused by near
!         linear dependencies in the basis set.
!         all eigenvalues of the weighted overlap
!         matrix must be greater than DIAGTH*DANGER.

toosml = diagth*danger

call mma_allocate(Eval,nDim*(nDim+1)/2,label='Eval')
call mma_allocate(Blk,nDim,nDim,label='Blk')
Blk(:,:) = Zero
do i=1,nDim
  do j=1,i
    Eval(i*(i-1)/2+j) = S(i,j)
  end do
  Blk(i,i) = One
end do

! diagonalize overlap matrix

call Jacob(Eval,Blk,nDim,nDim)

!call RecPrt('Blk',' ',Blk,nDim,nDim)
!call TriPrt('Eval',' ',Eval,nDim)

! form the inverse sqrt of the overlap matrix of the vectors:
! (avoid numerical problems of linear dependence (too small eigenvalues)
! by prescreening
! the  eigenvalues)

do i=1,nDim
  eigenv = Eval(i*(i+1)/2)
  if (eigenv < toosml) then
    write(u6,910) eigenv,toosmL
    return
  end if
  Eval(i*(i+1)/2) = One/sqrt(eigenv)
end do

! Compute S^-1/2

do i=1,nDim
  do j=1,i
    sij = Zero
    do k=1,nDim
      sij = sij+Eval(k*(k+1)/2)*Blk(i,k)*Blk(j,k)
    end do
    C(i,j) = sij
    C(j,i) = sij
  end do
end do

call mma_deallocate(Eval)
call mma_deallocate(Blk)

!call RecPrt('C',' ',C,nDim,nDim)

return

910 format(/1X,'An eigenvalue of the overlap matrix of the symmetrized Jacobi transf. matrix of ',E13.5,' has been found.'/1X, &
            'This is lower than the allowed threshold of ',E13.5)

end subroutine Lowdin_LP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine AddDEPSA(nDPT2,nAshT,DPT2,DEPSA)

use caspt2_module, only: NAES, NASH, NBAS, NDEL, NFRO, NISH, NORB, NSYM
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDPT2, nAshT
real(kind=wp), intent(inout) :: DPT2(nDPT2)
real(kind=wp), intent(in) :: DEPSA(nAshT,nAshT)
integer(kind=iwp) :: iMO1, iMO2, iOrb, iOrb0, iOrb2, iSym, itabs, iuabs, jOrb, jOrb0, jOrb2, nOrbI1, nOrbI2
real(kind=wp) :: Val

iMO1 = 1
iMO2 = 1
do iSym=1,nSym
  nOrbI1 = nOrb(iSym)
  nOrbI2 = nBas(iSym)-nDel(iSym)
  if (nOrbI2 > 0) then
    !! Add active orbital density
    !! Probably incorrect if symmetry
    do iOrb0=1,nAsh(iSym)
      ! iOrb1 = nIsh(iSym)+iOrb0
      iOrb2 = nFro(iSym)+nIsh(iSym)+iOrb0
      itabs = iOrb0+NAES(iSym)
      do jOrb0=1,nAsh(iSym)
        ! jOrb1 = nIsh(iSym)+jOrb0
        jOrb2 = nFro(iSym)+nIsh(iSym)+jOrb0
        iuabs = jOrb0+NAES(iSym)
        DPT2(iMO2+iOrb2-1+nOrbI2*(jOrb2-1)) = DPT2(iMO2+iOrb2-1+nOrbI2*(jOrb2-1))+DEPSA(itabs,iuabs)
      end do
    end do
    !! Symmetrize DPT2 (for shift)
    do iOrb=1,nBas(iSym)-nDel(iSym)
      do jOrb=1,iOrb-1
        Val = (DPT2(iMO2+iOrb-1+nOrbI2*(jOrb-1))+DPT2(iMO2+jOrb-1+nOrbI2*(iOrb-1)))*Half
        DPT2(iMO2+iOrb-1+nOrbI2*(jOrb-1)) = Val
        DPT2(iMO2+jOrb-1+nOrbI2*(iOrb-1)) = Val
      end do
    end do
  end if
  iMO1 = iMO1+nOrbI1*nOrbI1
  iMO2 = iMO2+nOrbI2*nOrbI2
end do

end subroutine AddDEPSA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Integral_RI_3(iCmp,iShell,MapOrg,
     &                         iBas,jBas,kBas,lBas,kOp,
     &                         Shijij,IJeqKL,iAO,iAOst,ijkl,
     &                         AOInt,SOInt,nSOint,
     &                         iSOSym,nSkal,nSOs,
     &                         TInt,nTInt,itOffs,nSym)
*     calls the proper routines IndSft/PLF
*     if IntOrd_jikl==.TRUE. integral order within symblk: jikl
*                      else  integral order within symblk: ijkl
      Use RICD_Info, only: LDF
      Implicit Real*8 (A-H,O-Z)
*
#include "j12.fh"
#include "WrkSpc.fh"
*
      Real*8 AOInt(*), SOInt(*), TInt(nTInt)
      Integer iCmp(4), iShell(4), iAO(4),
     &        iAOst(4), kOp(4), iSOSym(2,nSOs),
     &        itOffs(0:nSym-1,0:nSym-1,0:nSym-1), MapOrg(4)
      Logical Shijij,IJeqKL
*                                                                      *
************************************************************************
*                                                                      *
      nIrrep2=nSym**2
*                                                                      *
************************************************************************
*                                                                      *
      If (LDF) Then
*                                                                      *
************************************************************************
*                                                                      *
         If (nSym==1) Then
           Call PLF_LDF_3(AOInt,ijkl,iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &                   iShell,iAO,iAOst,Shijij.and.IJeqKL,
     &                   iBas,jBas,kBas,lBas,kOp,
     &                   TInt,nTInt,iTOffs,
     &                   iWork(ip_ShlSO),iWork(ip_nBasSh),
     &                   iWork(ip_SOShl),nSO,nSkal_Valence,nSym,
     &                   iWork(ip_iSSOff+(klS-1)*nIrrep2))
         Else
           Call WarningMessage(2,'Not implemented yet!')
           Call Abend()
C          Call IndSft_RI_3(iCmp,iShell,
C    &                      iBas,jBas,kBas,lBas,Shijij,
C    &                      iAO,iAOst,ijkl,SOInt,nSOint,iSOSym,nSOs,
C    &                      TInt,nTInt,iTOffs,
C    &                      iWork(ip_ShlSO),iWork(ip_nBasSh),
C    &                      iWork(ip_SOShl),nSO,nSkal_Valence,nSym,
C    &                      iWork(ip_iSSOff+(klS-1)*nIrrep2))
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
         If (nSym==1) Then
           Call PLF_RI_3(AOInt,ijkl,iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &                   iShell,iAO,iAOst,Shijij.and.IJeqKL,
     &                   iBas,jBas,kBas,lBas,kOp,
     &                   TInt,nTInt,iTOffs,
     &                   iWork(ip_ShlSO),iWork(ip_nBasSh),
     &                   iWork(ip_SOShl),nSO,nSkal_Valence,nSym,
     &                   iWork(ip_iSSOff+(klS-1)*nIrrep2))
      Else
           Call IndSft_RI_3(iCmp,iShell,
     &                      iBas,jBas,kBas,lBas,Shijij,
     &                      iAO,iAOst,ijkl,SOInt,nSOint,iSOSym,nSOs,
     &                      TInt,nTInt,iTOffs,
     &                      iWork(ip_ShlSO),iWork(ip_nBasSh),
     &                      iWork(ip_SOShl),nSO,nSkal_Valence,nSym,
     &                      iWork(ip_iSSOff+(klS-1)*nIrrep2))
         End If
*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(MapOrg)
         Call Unused_integer(nSkal)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_SubScr_Dia(ChoVec,nVec,iSym,iLoc,DSPNorm)
!
! Purpose: compute diagonal from Cholesky vectors and find norm
!          for each shell pair. Needed for screening of vector
!          subtraction. Which norm is used is determined by
!          string DSPNorm:
!
!          DSPNorm = 'Max' : max. element
!          DSPNorm = 'Fro' : Frobenius norm
!
!          Any other norm is taken to be 'Max'.

use Cholesky, only: DSPNm, DSubScr, iiBstRSh, LuPri, nnBstR, nnBstRSh, nnShl
#ifdef _DEBUGPRINT_
use Cholesky, only: Cho_SScreen, nSym
#endif
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: ChoVec(*)
integer(kind=iwp), intent(in) :: nVec, iSym, iLoc
character(len=*), intent(in) :: DSPNorm
integer(kind=iwp) :: iAB, iAB1, iAB2, iSP, iVec, kOff, lstr
character(len=3) :: myDSPNorm
character(len=*), parameter :: SecNam = 'Cho_SubScr_Dia'

#ifdef _DEBUGPRINT_
if ((iLoc < 1) .or. (iLoc > 3)) call Cho_Quit('iLoc error in '//SecNam,104)
if ((iSym < 1) .or. (iSym > nSym)) call Cho_Quit('iSym error in '//SecNam,104)
if (.not. Cho_SScreen) call Cho_Quit('Cho_SScreen is .False. in '//SecNam,104)
#endif

! Initialize and check for early return.
! --------------------------------------

DSubScr(1:nnBstR(iSym,iLoc)) = Zero
DSPNm(1:nnShl) = Zero
if ((nVec < 1) .or. (nnBstR(iSym,iLoc) < 1)) return

! Compute diagonal.
! -----------------

do iVec=1,nVec
  kOff = nnBstR(iSym,iLoc)*(iVec-1)
  DSubScr(1:nnBstR(iSym,iLoc)) = DSubScr(1:nnBstR(iSym,iLoc))+ChoVec(kOff+1:kOff+nnBstR(iSym,iLoc))**2
end do

! Find diagonal norm in each shell pair.
! --------------------------------------

lstr = len(DSPNorm)
if (lstr < 3) then
  myDSPNorm = 'MAX'
else
  myDSPNorm = DSPNorm(1:3)
  call UpCase(myDSPNorm)
end if

#ifdef _DEBUGPRINT_
if (lstr < 1) then
  write(Lupri,*) SecNam,': input norm: (null string)'
else if (lstr < 3) then
  write(Lupri,*) SecNam,': input norm: ',DSPNorm,' (incomplete)'
else
  write(Lupri,*) SecNam,': input norm: ',DSPNorm
end if
write(Lupri,*) SecNam,': norm used : ',myDSPNorm
#endif

if (myDSPNorm == 'MAX') then
  do iSP=1,nnShl
    iAB1 = iiBstRSh(iSym,iSP,iLoc)+1
    iAB2 = iAB1+nnBstRSh(iSym,iSP,iLoc)-1
    do iAB=iAB1,iAB2
      DSPNm(iSP) = max(DSPNm(iSP),DSubScr(iAB))
    end do
  end do
else if (myDSPNorm == 'FRO') then
  do iSP=1,nnShl
    iAB1 = iiBstRSh(iSym,iSP,iLoc)+1
    iAB2 = iAB1+nnBstRSh(iSym,iSP,iLoc)-1
    DSPNm(iSP) = DSPNm(iSP)+sum(DSubScr(iAB1:iAB2)**2)
    DSPNm(iSP) = sqrt(DSPNm(iSP))
  end do
else
  write(Lupri,*) SecNam,': WARNING: unkown norm: ',DSPNorm
  write(Lupri,*) SecNam,': WARNING: using max element...'
  do iSP=1,nnShl
    iAB1 = iiBstRSh(iSym,iSP,iLoc)+1
    iAB2 = iAB1+nnBstRSh(iSym,iSP,iLoc)-1
    do iAB=iAB1,iAB2
      DSPNm(iSP) = max(DSPNm(iSP),DSubScr(iAB))
    end do
  end do
end if

end subroutine Cho_SubScr_Dia

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine StoreMpAsLop(nAtoms,ANr,nB,T,Ti,MP,lMax,EC)

use MPProp_globals, only: AtBoMltPl, Cor
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nB, lMax
integer(kind=iwp), intent(out) :: ANr(nAtoms)
real(kind=wp), intent(out) :: T(nB,nB), Ti(nB,nB), MP(nAtoms*(nAtoms+1)/2,(lMax+1)*(lMax+2)*(lMax+3)/6), EC(3,nAtoms*(nAtoms+1)/2)
integer(kind=iwp) :: i, iAt1, iAt2, iAtK, iMu, ix, iy, j, kaunter, kompost, l

!-- Let's fix the ANr.

call Get_iArray('LP_A',ANr,nAtoms)

!-- Let's fix the uber-simple T and T(-1).

T(:,:) = Zero
do i=1,nB
  T(i,i) = One
end do
Ti(:,:) = T(:,:)

!-- Let's fix the expansion centres.

kaunter = 0
do i=1,nAtoms
  do j=1,i
    kaunter = kaunter+1
    EC(:,kaunter) = Cor(:,i,j)
  end do
end do

! Let's fix the multipole moments. Unlike LoProp, MpProp has here
! included the nuclei contribution, which we have to remove pronto
! to be compatible.

iMu = 0
do l=0,lMax
  kompost = 0
  do ix=l,0,-1
    do iy=l-ix,0,-1
      kompost = kompost+1
      iMu = iMu+1
      iAtK = 0
      do iAt1=1,nAtoms
        do iAt2=1,iAt1
          iAtK = iAtK+1
          MP(iAtK,iMu) = AtBoMltPl(l)%A(kompost,iAtK)
        end do
        if (l == 0) then
          MP(iAtK,iMu) = MP(iAtK,iMu)-real(ANr(iAt1),kind=wp)
        end if
      end do
    end do
  end do
end do

return

end subroutine StoreMpAsLop

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cooout(Head,Cordst,nPart,nCent)

use Definitions, only: wp, iwp, u6

implicit none
character(len=200), intent(in) :: Head
integer(kind=iwp), intent(in) :: nPart, nCent
real(kind=wp), intent(in) :: Cordst(3,nPart*nCent)
integer(kind=iwp) :: i, j, kaunter

write(u6,*)
write(u6,*)
write(u6,'(A)') Head
kaunter = 0
do i=1,nPart
  write(u6,*) 'Molecule ',i
  do j=1,nCent
    kaunter = kaunter+1
    write(u6,*) Cordst(:,kaunter)
  end do
end do

return

end subroutine Cooout

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADSTN_GASSM(NSTB,NSTA,IOFFK,IOFFI,IOFFISP,IOFFKSP,ICREORB,ICRESTR,IORBTSF,IORBTF,NORBTS,NSTAK,NSTAI,NSTAKTS,NELB, &
                       NACGSOB,ISTMAP,SGNMAP,SCLFAC)
! Creation mappings from K-strings of given sym in each gasspace
!
! Input
! NSTB    : Number of strings before active gasspace
! NSTA    : Number of strings after active gasspace
! IOFFK   : Offset for K group of strings in active gasspace, i.e. start of
!           this symmetry of active K group strings
! IOFFI   : Offset for I group of strings in active gasspace, i.e. start of
!           this symmetry of active I group strings
! IOFFISP : Offset for this symmetrydistribution of active I supergroup strings
! IOFFKSP : Offset for this symmetrydistribution of active K supergroup strings
! ICREORB : Orbital part of creation map for active K groupstrings
! ICRESTR : String  part of creation map for active K groupstrings
! IORBTSF : First active orbital (first orbital in in active GASspace
!           with required sym)
! IORBTF  : First orbital in active gas space, (can have any sym)
! NORBTS  : Number of orbitals of given symmetry and type
! NSTAK   : Number of K groupstrings with given correct symmetry
! NSTAKTS : Total Number of K supergroup strings with correct symmetry
! NSTAI   : Number of I groupstrings in active gasspace

use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSTB, NSTA, IOFFK, IOFFI, IOFFISP, IOFFKSP, NACGSOB, NSTAK, ICREORB(NACGSOB,NSTAK+IOFFK-1), &
                                 ICRESTR(NACGSOB,NSTAK+IOFFK-1), IORBTSF, IORBTF, NORBTS, NSTAI, NSTAKTS, NELB
integer(kind=iwp), intent(inout) :: ISTMAP(NSTAKTS,IORBTSF+NORBTS)
real(kind=wp), intent(inout) :: SGNMAP(NSTAKTS,IORBTSF+NORBTS)
real(kind=wp), intent(in) :: SCLFAC
integer(kind=iwp) :: IA, IADRI0, IADRK0, IB, IORB, IORBRT, IORBRTS, ISTR, KSTR, NSTAINSTA, NSTAKNSTA
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IORBR, NK
#endif
real(kind=wp) :: SIGN0, SGN

!write(u6,*) ' ADSTN_GASSM : NSTA, NSTB, NSTAK',NSTA,NSTB,NSTAK
!write(u6,*) ' IOFFISP,IOFFKSP',IOFFISP,IOFFKSP
!write(u6,*) ' IORBTSF IORBTF ',IORBTSF,IORBTF

!SIGN0 = SCLFAC*(-One)**NELB
if (mod(NELB,2) == 0) then
  SIGN0 = SCLFAC
else
  SIGN0 = -SCLFAC
end if
!write(u6,*) ' NELB sign0 = ',NELB,SIGN0
do KSTR=IOFFK,NSTAK+IOFFK-1
  do IORB=IORBTSF,IORBTSF-1+NORBTS
    ! Relative to Type-symmetry start
    IORBRTS = IORB-IORBTSF+1
    ! Relative to type start
    IORBRT = IORB-IORBTF+1
    !write(u6,*) 'IORB IORBRT KSTR ',IORB,IORBRT,KSTR
    !write(u6,*) 'ICRESTR(IORBRT,KSTR),ICREORB(IORBRT,KSTR)',ICRESTR(IORBRT,KSTR),ICREORB(IORBRT,KSTR)
    if (ICREORB(IORBRT,KSTR) > 0) then
      ! Excitation is open, corresponding active I string
      if (ICRESTR(IORBRT,KSTR) > 0) then
        SGN = SIGN0
        ISTR = ICRESTR(IORBRT,KSTR)
      else
        SGN = -SIGN0
        ISTR = -ICRESTR(IORBRT,KSTR)
      end if
      ! Relative to start of given symmetry for this group
      ISTR = ISTR-IOFFI+1
      ! This Creation is active for all choices of strings in supergroup
      ! before and after the active type. Store the corrsponding mappings
      IADRK0 = (KSTR-IOFFK)*NSTA+IOFFKSP-1
      IADRI0 = (ISTR-1)*NSTA+IOFFISP-1
      !write(u6,*) ' ISTR IADRK0 IADRI0 = ',ISTR,IADRK0,IADRI0

      NSTAINSTA = NSTAI*NSTA
      NSTAKNSTA = NSTAK*NSTA
      do IB=1,NSTB
        ISTMAP(IADRK0+1:IADRK0+NSTA,IORBRTS) = [(IADRI0+IA,IA=1,NSTA)]
        SGNMAP(IADRK0+1:IADRK0+NSTA,IORBRTS) = SGN
        IADRI0 = IADRI0+NSTAINSTA
        IADRK0 = IADRK0+NSTAKNSTA
      end do
    !else
    !  SGN = Zero
    !  ISTR = 0
    !  ! This Creation is inactive for all choices of strings in supergroup
    !  ! before and after the active type.
    !  IADRK0 = (KSTR-IOFFK)*NSTA+IOFFKSP-1
    !  !write(u6,*) ' ISTR IADRK0 = ',ISTR,IADRK0
    !
    !  do IB=1,NSTB
    !    do IA=1,NSTA
    !      KBKA = IADRK0+(IB-1)*NSTAK*NSTA+IA
    !      !write(u6,*) ' IBKA, KBKA ',IBKA,KBKA
    !      if (ISTMAP(KBKA,IORBRTS) /= 999) then
    !        write(u6,*) ' overwriting ???'
    !        write(u6,*) ' Element ',(IORBRTS-1)*NSTAKTS+KBKA
    !        stop
    !      end if
    !      ISTMAP(KBKA,IORBRTS) = ISTR
    !      SGNMAP(KBKA,IORBRTS) = SGN
    !
    !    end do
    !  end do
    end if
    ! This Creation is active for all choices of strings in supergroup
    ! before and after the active type. Store the corrsponding mappings
    !OLD IADRK0 = (KSTR-IOFFK)*NSTA+IOFFKSP-1
    !OLD IADRI0 = (ISTR-1)*NSTA+IOFFISP-1
    !write(u6,*) ' ISTR IADRK0 IADRI0 = ',ISTR,IADRK0,IADRI0

    !OLD do IB=1,NSTB
    !OLD  do IA=1,NSTA
    !OLD    IBKA = IADRI0+(IB-1)*NSTAI*NSTA+IA
    !OLD    KBKA = IADRK0+(IB-1)*NSTAK*NSTA+IA
    !?      write(u6,*) ' IBKA, KBKA ',IBKA,KBKA
    !OLD    ISTMAP(KBKA,IORBRTS) = IBKA
    !OLD    SGNMAP(KBKA,IORBRTS) = SGN
    !OLD  end do
    !OLD end do
    !end if

  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from ADSTN_GASSM'
write(u6,*) ' ======================='
NK = NSTB*NSTAK*NSTA
write(u6,*) ' Number of K strings accessed ',NK
if (NK /= 0) then
  do IORB=IORBTSF,IORBTSF+NORBTS-1
    IORBR = IORB-IORBTSF+1
    write(u6,*) ' Update Info for orbital ',IORB
    write(u6,*) ' Excited strings and sign'
    call IWRTMA(ISTMAP(1,IORBR),1,NK,1,NK)
    call WRTMAT(SGNMAP(1,IORBR),1,NK,1,NK)
  end do
end if
#endif

end subroutine ADSTN_GASSM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000,2016, Valera Veryazov                             *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Author:   Valera Veryazov 2000-2016                                  *
!           Theoretical Chemistry                                      *
!           Lund University                                            *
!           Sweden                                                     *
!                                                                      *
!***********************************************************************
!  CheckRun
!
!> @brief
!>   Check that the program was started via molcas shell script
!> @author V. Veryazov
!>
!> @details
!> The routine checks ``MOLCAS_STAMP`` and quits if this variable
!> has wrong value (to prevent the creation of dummy files)
!***********************************************************************

subroutine CheckRun()

use Definitions, only: u6

implicit none
character(len=256) :: Molcas

Molcas = ' '
call getenvf('MOLCAS_STAMP',Molcas)
if (Molcas(1:1) == 'A') then
  return
end if
if (Molcas(1:1) /= '5') then
  write(u6,*) 'Usage: molcas module_name input'
  call Abend()
end if

return

end subroutine CheckRun

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifdef _IN_MODULE_

subroutine Effective_CD_Pairs(ij2,nij_Eff)

use Index_Functions, only: nTri_Elem
use Basis_Info, only: dbsc, nBas, nBas_Aux, nCnttp, Shells
use Symmetry_Info, only: nIrrep
use ChoArr, only: iSOShl
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: nij_Eff
integer(kind=iwp), allocatable, intent(out) :: ij2(:,:)
#include "cholesky.fh"
integer(kind=iwp) :: i, iAng, iCnttp, iIrrep, ij, ij_Eff, iOff, iShll, iSym, j, jOff, nAux_Tot, nij, nSkal_Valence, nVal_Tot
integer(kind=iwp), allocatable :: ij3(:), SO_ab(:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the max number of auxiliary shells in case of CD.
! Hence we do not have any explicit auxiliary basis set!

nSkal_Valence = 0
do iCnttp=1,nCnttp
  if (.not. dbsc(iCnttp)%Aux) then
    do iAng=0,dbsc(iCnttp)%nVal-1
      iShll = dbsc(iCnttp)%iVal+iAng
      if (.not. Shells(iShll)%Aux) nSkal_Valence = nSkal_Valence+dbsc(iCnttp)%nCntr
    end do
  end if
end do

! Max number of pairs

nij = nTri_Elem(nSkal_Valence)
call mma_allocate(ij3,nij,Label='ij3')
ij3(:) = 0
!write(u6,*) 'nij3=',nij
!                                                                      *
!***********************************************************************
!                                                                      *
nAux_Tot = 0
nVal_Tot = 0
do iIrrep=0,nIrrep-1
  nAux_Tot = nAux_Tot+nBas_Aux(iIrrep)
  nVal_Tot = nVal_Tot+nBas(iIrrep)
end do

call mma_allocate(SO_ab,2*nAux_Tot,Label='SO_ab')
SO_ab(:) = 0

iOff = 1
jOff = 0
nSym = nIrrep
do iSym=1,nSym
  iIrrep = iSym-1
  call CHO_X_GET_PARDIAG(iSym,SO_ab(iOff))

  call Get_Auxiliary_Shells(SO_ab(iOff),nBas_Aux(iIrrep),jOff,iSOShl,nVal_Tot,ij3,nij)

  jOff = jOff+nBas_Aux(iIrrep)
  iOff = iOff+2*nBas_Aux(iIrrep)
end do
call mma_deallocate(SO_ab)
!                                                                      *
!***********************************************************************
!                                                                      *
nij_Eff = 0
do i=1,nij
  nij_Eff = nij_Eff+ij3(i)
end do
!write(u6,*) 'nij_Eff=',nij_Eff
if (nij_Eff > nij) then
  call WarningMessage(2,'Effective_CD_Pairs: nij_Eff > nij')
  call Abend()
end if

call mma_allocate(ij2,2,nij_Eff,Label='ij2')
ij = 0
ij_Eff = 0
do i=1,nSkal_Valence
  do j=1,i
    ij = ij+1
    !write (u6,*) 'i,j,ij=',i,j,ij
    if (ij3(ij) == 1) then
      ij_Eff = ij_Eff+1
      !write(u6,*) 'ij_Eff=',ij_Eff
      ij2(1,ij_Eff) = i
      ij2(2,ij_Eff) = j
    end if
  end do
end do
if (ij_Eff /= nij_Eff) then
  call WarningMessage(2,'Effective_CD_Pairs: ij_Eff /= nij_Eff')
  call Abend()
end if
call mma_deallocate(ij3)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Effective_CD_Pairs

#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Per-Olof Widmark                                       *
!***********************************************************************
!***********************************************************************
!                                                                      *
!======================================================================*
!                                                                      *
! Author: Per-Olof Widmark                                             *
!         IBM Sweden                                                   *
!                                                                      *
!***********************************************************************

subroutine NOphase(a,n)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: a(n,n)
integer(kind=iwp) :: i
real(kind=wp) :: sgn

sgn = One
do i=1,n
  if (sgn*a(1,i) < Zero) a(:,i) = -a(:,i)
  sgn = -sgn
end do

return

end subroutine NOphase

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_PutRed(iPass,iLoc)
!
! Purpose: write global and local reduced set index arrays
!          to disk and set
!          address for next write. iLoc specifies the location in
!          the index arrays to write, and iPass identifies the
!          reduced set (i.e. the integral pass).

use Cholesky, only: Cho_Real_Par, LuRed, LuRed_G, TMISC
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iPass, iLoc
integer(kind=iwp) :: iTmp
real(kind=wp) :: c1, c2, w1, w2

call CWTime(c1,w1)

if (Cho_Real_Par) then

  ! Swap local and global reduced set indices and use original serial
  ! routine to write global index arrays.
  ! -----------------------------------------------------------------

  call Cho_P_IndxSwp()
  iTmp = LuRed
  LuRed = LuRed_G
  call Cho_PutRed(iPass,iLoc)
  LuRed = iTmp
  call Cho_P_IndxSwp()

end if

! Write local index arrays.
! -------------------------

call Cho_PutRed(iPass,iLoc)

call CWTime(c2,w2)
tMisc(1,2) = tMisc(1,2)+c2-c1
tMisc(2,2) = tMisc(2,2)+w2-w1

end subroutine Cho_P_PutRed

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine InpCtl_MCLR(iPL)
************************************************************************
*                                                                      *
*     Read all relevant input data and display them                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************

      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Files_mclr.fh"
#include "WrkSpc.fh"
#include "Pointers.fh"
#include "sa.fh"
#include "negpre.fh"

#include "detdim.fh"
#include "csfbas_mclr.fh"
#include "spinfo_mclr.fh"
#include "dmrginfo_mclr.fh"
      logical ldisk,ipopen

! ==========================================================
      integer,allocatable::index_SD(:) ! not final version
      real*8,allocatable::vector_cidmrg(:)
! ==========================================================

*                                                                      *
************************************************************************
*                                                                      *
      Call Rd1Int_MCLR !Read in interesting info from RUNFILE and ONEINT
      Call RdAB   ! Read in orbitals, perturbation type, etc.
*                                                                      *
************************************************************************
*                                                                      *
      Call Rd2Int(iPL) ! Read in 2el header
*                                                                      *
************************************************************************
*                                                                      *
      Call RdInp_MCLR()  ! Read in input
*                                                                      *
************************************************************************
*                                                                      *
*     Default activate ippage utility

*

      ldisk  =ipopen(0,.True.)
*
      write(6,*) "iMethod:",iMethod,iCASSCF
      If (iMethod.eq.iCASSCF) Then
         If (TimeDep) Then
            Call RdJobIph_td
         Else
            Call RdJobIph
         End If

*        Write(6,*) 'Setup of Determinant tables'
         Call DetCtl   ! set up determinant tables
*....... Read in tables from disk
         Call InCsfSD(State_sym,State_sym,.true.)

             !Call GetMem('CIvec','Allo','Real',ipNEW,NCONF)
             !Call GetMem('OCIvec','Free','Real',ipCI,nConf)
             !ipCI=ipNEW
*                                                                      *
************************************************************************
*                                                                      *
*        Write(6,*) 'Transformation of CI vector to symmetric '
*    &             ,'group from GUGA pepresentation'

         !> scratch  ! yma testing
!         if(doDMRG.and.doMCLR)then
!           call xflush(117)
!           close(117)
!         end if

         Do i=1,nroots
           ! yma
!          No need to copy,since there are no CI-vectors
           if(doDMRG.and.doMCLR)then
             Call Getmem('CIROOT','ALLO','REAL',ipT,ndets_RGLR)
           else
             Call Getmem('CIROOT','ALLO','REAL',ipT,nconf)
             call dcopy_(nconf,Work(ipCI+(i-1)*nconf),1,Work(ipT),1)
           end if

           !> If doDMRG
           if(doDMRG.and.doMCLR)then ! yma
           else
             Call GugaCtl_MCLR(ipT,1)   ! transform to sym. group
           end if

! Here should be the position for introducing the CI(SR) coefficients
!           iSSM=1     ! yma
!           write(6,*)"Set ISSM eq 1 ",ISSM

           if(doDMRG)then !yma
             ! mma_allocate and mma_deallocate
             allocate(index_SD(ndets_RGLR))
             allocate(vector_cidmrg(ndets_RGLR))
             call ci_reconstruct(i,ndets_RGLR,vector_cidmrg,
     &                           index_SD)
             do ii=1,ndets_RGLR
               if(abs(vector_cidmrg(ii)).lt.0.0d0)then
                 vector_cidmrg(ii)=0.0d0
               end if
             end do
             call CSDTVC_dmrg(work(ipT),vector_cidmrg,2,WORK(KDTOC),
     &                     index_SD,ISSM,1,IPRDIA)
             ! mma_allocate and mma_deallocate
             deallocate(index_SD)
             deallocate(vector_cidmrg)
           end if

           call dcopy_(nconf,Work(ipT),1,Work(ipCI+(i-1)*nconf),1)

          if(doDMRG.and.doMCLR)then !yma
            Call Getmem('CIROOT','FREE','REAL',ipT,ndets_RGLR)
          else
            Call Getmem('CIROOT','FREE','REAL',ipT,nconf)
          end if
        End Do

*                                                                      *
************************************************************************
*                                                                      *
        ldisk  =ipopen(nconf,page)
*
*        If we are computing Lagrangian multipliers we pick up all CI
*        vectors. For Hessian calculations we pick up just one vector.
*
C        Write (*,*) 'iState,SA,nroots=',iState,SA,nroots
         If (SA.or.iMCPD) Then
            ipcii=ipget(nconf*nroots)
            call dcopy_(nconf*nroots,Work(ipCI),1,Work(ipin(ipcii)),1)
            nDisp=1
         Else
            ipcii=ipget(nconf)
            ipCI_ = ipCI + (iState-1)*nConf
            call dcopy_(nConf,Work(ipCI_),1,Work(ipin(ipcii)),1)
            If (iRoot(iState).ne.1) Then
               Write (6,*) 'McKinley does not support computation of'
     &                   //' harmonic frequencies of excited states'
               Call Abend()
            End If
         End If
C        Call RecPrt('CI vector',' ',Work(ipin(ipcii)),1,nConf)
         Call Getmem('CIVEC','FREE','REAL',ipci,idum)
         ipci=ipcii
         irc=ipout(ipci)
*                                                                      *
************************************************************************
*                                                                      *
         If (ngp) Call rdciv
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call InpOne           ! read in oneham
      Call PrInp_MCLR(iPL)  ! Print all info
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Francesco Aquilante                              *
************************************************************************
      SUBROUTINE Tw_corr_drv(EOrb,nEO,CMO,nCMO,Ecorr)

      Implicit Real*8 (a-h,o-z)
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
      Integer nEO, nCMO
      Real*8 EOrb(nEO), CMO(nCMO), Ecorr
      Real*8, Allocatable :: Eov(:)

      Call mma_Allocate(Eov,nEO,Label='Eov')

      ipEOkk=1
      ipEVir=ipEOkk+nnOc
      iOff=0
      jOff=0
      kOff=0
      Do iSym=1,nSym
         nOkk=nFro(iSym)+nOcc(iSym,1)
         nExt=nBas(iSym)-nDel(iSym)-nOkk
         jOrb=1+jOff
         jOkk=ipEOkk+iOff
         Do i=0,nOkk-1
            Eov(jOkk+i)=EOrb(jOrb+i)
         End Do
         jOrb=jOrb+nOkk
         jVir=ipEVir+kOff
         Do i=0,nExt-1
            Eov(jVir+i)=EOrb(jOrb+i)
         End Do
         iOff=iOff+nOkk
         jOff=jOff+nOrb(iSym)
         kOff=kOff+nExt
      End Do

      Call Tw_corr(irc,Ecorr,CMO,Eov(:ipEVir-1),Eov(ipEVir:))

      Call mma_deallocate(Eov)
      Return
      End
*****************************************************************************
*                                                                           *
*****************************************************************************
      SUBROUTINE Tw_corr(irc,DeTW,CMOI,EOcc,EVir)

#include "implicit.fh"
#include "stdalloc.fh"
      Real*8 DeTW, CMOI(*), EOcc(*), EVir(*)
C
      Integer nExt(8)
#include "mxdm.fh"
#include "infscf.fh"
#include "chomp2_cfg.fh"
      Dimension Grad(1)
      Real*8, Allocatable :: DMAT(:,:), F_DFT(:)

      DoDens = .false.
      ChoAlg = 2
*
      CALL mma_allocate(DMAT,nBT,2,Label='DMAT')

      nElk=0
      Do i=1,nSym
         nExt(i)=nBas(i)-nDel(i)-nOcc(i,1)-nFro(i)
         nElk=nElk+2*(nFro(i)+nOcc(i,1))
      End Do

      CALL DM_FNO_RHF(irc,nSym,nBas,nFro,nOcc(1,1),nExt,nDel,
     &                    CMOI,EOcc,EVir,DMAT(:,2),DMAT(:,1))
      If (irc .ne. 0) Then
         Write(6,*) 'DM_FNO_RHF returned ',irc
         Call SysAbendMsg('DM_FNO_RHF',
     &                    'Non-zero return code from DM_FNO_RHF',
     &                    ' ')
      EndIf

      CALL mma_allocate(F_DFT,nBT,Label='F_DFT')
*
      Call Fold_tMat(nSym,nBas,DMAT(:,1),DMAT(:,1))
      call dscal_(nBT,0.5d0,DMAT(:,1),1)
      Call Fold_tMat(nSym,nBas,DMAT(:,2),DMAT(:,2))
      call dscal_(nBT,0.5d0,DMAT(:,2),1)
      Grad=0.0d0

      Call wrap_DrvNQ('HUNTER',F_DFT,1,TW,
     &                      DMAT(:,1),nBT,1,
     &                      .false.,
     &                      Grad,1,'SCF ')

      Call wrap_DrvNQ('HUNTER',F_DFT,1,TW0,
     &                      DMAT(:,2),nBT,1,
     &                      .false.,
     &                      Grad,1,'SCF ')
      DeTW=(TW-TW0)/dble(nElk)
*
      Call mma_deallocate(F_DFT)
      Call mma_deallocate(DMAT)
*
      Return
      End
*****************************************************************************
*                                                                           *
*****************************************************************************

      SUBROUTINE DM_FNO_RHF(irc,nSym,nBas,nFro,nIsh,nSsh,nDel,
     &                          CMOI,EOcc,EVir,DM0,DM)
*****************************************************************************
*                                                                           *
*     Purpose:  setup of FNO density matrix calculation (RHF-based)         *
*                                                                           *
*     Author:   F. Aquilante  (Geneva, Sep 2010)                            *
*                                                                           *
*****************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
*
      Integer nBas(nSym),nFro(nSym),nIsh(nSym),nSsh(nSym),
     &        nDel(nSym)
      Real*8  CMOI(*), EOcc(*), EVir(*), DM0(*), DM(*)
#include "chfnopt.fh"
*
      Integer lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
      Real*8, Allocatable:: CMO(:,:), EOrb(:,:), DMAT(:)
*
*
      irc=0
      MP2_small=.false.
*
*----------------------------------------------------------------------*
*     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
*----------------------------------------------------------------------*
*
      nBasT=0
      ntri=0
      nSQ=0
      nBmx=0
      nOrb=0
      nVV=0
      Do i=1,nSym
        nBasT=nBasT+nBas(i)
        nOrb=nOrb+nFro(i)+nIsh(i)+nSsh(i)+nDel(i)
        ntri=ntri+nBas(i)*(nBas(i)+1)/2
        nSQ=nSQ+nBas(i)**2
        nVV=nVV+nSsh(i)**2
        nBmx=Max(nBmx,nBas(i))
      End Do
      IF(nBasT.GT.mxBas) then
       Write(6,'(/6X,A)')
     & 'The number of basis functions exceeds the present limit'
       Call Abend
      Endif
*
      NCMO=nSQ
      Call mma_allocate(CMO,nCMO,2,Label='CMO')
      CALL DCOPY_(NCMO,CMOI,1,CMO(:,1),1)
*
      nOA=0
      Do iSym=1,nSym  ! setup info
         lnFro(iSym)=nFro(iSym)
         lnOcc(iSym)=nIsh(iSym)
         nOA=nOA+lnOcc(iSym)
         lnVir(iSym)=nSsh(iSym)
         lnOrb(iSym)=lnOcc(iSym)+lnVir(iSym)
         lnDel(iSym)=nDel(iSym)
      End Do
*
      Call mma_Allocate(EOrb,nOrb,4,Label='EOrb')
      jOff=0
      kOff=0
      lOff=0
      Do iSym=1,nSym
         jp=1+lOff+nFro(iSym)
         jOcc=jOff+1
         call dcopy_(nIsh(iSym),EOcc(jOcc),1,EOrb(jp,1),1)
         jVir=kOff+1
         jp=jp+nIsh(iSym)
         call dcopy_(nSsh(iSym),EVir(jVir),1,EOrb(jp,1),1)
         jOff=jOff+nIsh(iSym)
         kOff=kOff+nSsh(iSym)
         lOff=lOff+nBas(iSym)
      End Do
      ioff=0
      joff=0
      koff=0
      Do iSym=1,nSym
         ifr=1+ioff+nFro(iSym)
         ito=1+joff
         call dcopy_(nIsh(iSym),EOrb(ifr,1),1,EOrb(ito,3),1)
         ifr=1+ioff+nFro(iSym)+nIsh(iSym)
         ito=1+koff
         call dcopy_(nSsh(iSym),EOrb(ifr,1),1,EOrb(ito,4),1)
         ioff=ioff+nBas(iSym)
         joff=joff+nIsh(iSym)
         koff=koff+nSsh(iSym)
      End Do
      Call mma_Allocate(DMAT,nVV+nOA,Label='DMAT')
      DMAT(:)=Zero

      ip_X = ip_of_Work(DMAT(1))
      ip_Y = ip_X+nVV
      Call FnoSCF_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,ip_X,ip_Y)
      ip_X = 1

      CMO(:,2)=Zero
      iOff=0
      Do iSym=1,nSym
         kfr=1+iOff+nBas(iSym)*nFro(iSym)
         kto=1+iOff+nBas(iSym)*lnFro(iSym)
         call dcopy_(nBas(iSym)*lnOcc(iSym),CMO(kfr,1),1,CMO(kto,2),1)
         kfr=1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
         kto=kto+nBas(iSym)*lnOcc(iSym)
         call dcopy_(nBas(iSym)*lnVir(iSym),CMO(kfr,1),1,CMO(kto,2),1)
         iOff=iOff+nBas(iSym)**2
      End Do
      Call Check_Amp_SCF(nSym,lnOcc,lnVir,iSkip)
      If (iSkip.gt.0) Then
         Call ChoMP2_Drv(irc,Dummy,CMO(:,2),EOrb(:,3),EOrb(:,4))
         If(irc.ne.0) then
           write(6,*) 'MP2 pseudodensity calculation failed !'
           Call Abend
         Endif
      Else
         write(6,*)
         write(6,*)'There are ZERO amplitudes T(ai,bj) with the given '
         write(6,*)'combinations of inactive and virtual orbitals !! '
         write(6,*)'Check your input and rerun the calculation! Bye!!'
         Call Abend
      Endif
*
*
*     Compute the correlated density in AO basis
*     -------------------------------------------------------------
      jOcc=ip_X+nVV
c           write(6,*) ' Occ    : ',(DMAT(jOcc+j),j=0,nOA-1)
c           write(6,*) ' Sum    : ',ddot_(nOA,1.0d0,0,DMAT(jOcc),1)
      call dscal_(nOA,2.0d0,DMAT(jOcc),1)
      Call daxpy_(nOA,2.0d0,[1.0d0],0,DMAT(jOcc),1)
*
      iOff=0
      jOff=0
      kDM=1
      Do iSym=1,nSym
*
         kto=1+jOff
         nOkk=nFro(iSym)+nIsh(iSym)
         Call DGEMM_Tri('N','T',nBas(iSym),nBas(iSym),nOkk,
     &                      2.0d0,CMO(kto,1),nBas(iSym),
     &                            CMO(kto,1),nBas(iSym),
     &                      0.0d0,DM0(kDM),nBas(iSym))
*
         sqocc=sqrt(2.0d0)
         call dscal_(nBas(iSym)*nFro(iSym),sqocc,CMO(kto,1),1)
         Do j=0,nIsh(iSym)-1
             sqocc=sqrt(DMAT(jOcc+j))
             ito=kto+nBas(iSym)*j
             call dscal_(nBas(iSym),sqocc,CMO(ito,1),1)
         End Do
         Call DGEMM_Tri('N','T',nBas(iSym),nBas(iSym),nOkk,
     &                      1.0d0,CMO(kto,1),nBas(iSym),
     &                            CMO(kto,1),nBas(iSym),
     &                      0.0d0,DM(kDM),nBas(iSym))
*
         if (nSsh(iSym).gt.0) then
           jD=ip_X+iOff
*     Eigenvectors will be in increasing order of eigenvalues
           Call Eigen_Molcas(nSsh(iSym),DMAT(jD),EOrb(:,2),Eorb(:,1))
*     Reorder to get relevant eigenpairs first
           Do j=1,nSsh(iSym)/2
              Do i=1,nSsh(iSym)
                 lij=jD-1+nSsh(iSym)*(j-1)+i
                 kij=jD-1+nSsh(iSym)**2-(nSsh(iSym)*j-i)
                 tmp=DMAT(lij)
                 DMAT(lij)=DMAT(kij)
                 DMAT(kij)=tmp
              End Do
              tmp=EOrb(j,2)
              EOrb(j,2)=EOrb(nSsh(iSym)-j,2)
              EOrb(nSsh(iSym)-j,2)=tmp
           End Do
*
*     Compute new MO coeff. : X=C*U
           kfr=1+jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
           kto=1+jOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
           Call DGEMM_('N','N',nBas(iSym),nSsh(iSym),nSsh(iSym),
     &                        1.0d0,CMO(kfr,2),nBas(iSym),
     &                              DMAT(jD),nSsh(iSym),
     &                        0.0d0,CMO(kto,1),nBas(iSym))

c          write(6,*) ' Occ_vir: ',(EOrb(j,2),j=1,nSsh(iSym))
c          write(6,*) ' Sum_vir: ',ddot_(nSsh(iSym),1.0d0,0,EOrb(:,2),1)
           Do j=0,nSsh(iSym)-1
              sqocc=sqrt(2.0d0*EOrb(1+j,2))
              jto=kto+nBas(iSym)*j
              call dscal_(nBas(iSym),sqocc,CMO(jto,1),1)
           End Do
           Call DGEMM_Tri('N','T',nBas(iSym),nBas(iSym),nSsh(iSym),
     &                        1.0d0,CMO(kto,1),nBas(iSym),
     &                              CMO(kto,1),nBas(iSym),
     &                        1.0d0,DM(kDM),nBas(iSym))

           iOff=iOff+nSsh(iSym)**2
         endif
         jOff=jOff+nBas(iSym)**2
         kDM =kDM +nBas(iSym)*(nBas(iSym)+1)/2
         jOcc=jOcc+nIsh(iSym)
      End Do
*
      Call mma_deAllocate(EOrb)
      Call mma_deAllocate(DMAT)
      Call mma_deallocate(CMO)
*
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine Check_Amp_SCF(nSym,nOcc,nVir,iSkip)

      Implicit Real*8 (a-h,o-z)
      Integer nSym, nOcc(nSym), nVir(nSym), iSkip
      Integer nT1amTot, nT1am(8)

      MulD2h(i,j)=iEor(i-1,j-1) + 1

      iSkip=0
      nT1amTot=0
      Do iSym = 1,nSym
         nT1am(iSym) = 0
         Do iSymi = 1,nSym
            iSyma = MulD2h(iSymi,iSym)
            nT1am(iSym) = nT1am(iSym)
     &                  + nVir(iSyma)*nOcc(iSymi)
         End Do
         nT1amTot = nT1amTot + nT1am(iSym)
      End Do

      If (nT1amTot .gt. 0) iSkip=1
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      SubRoutine FnoSCF_putInf(mSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,
     &                         ip_X,ip_Y)
C
C     Purpose: put info in MP2 common blocks.
C
#include "implicit.fh"
      Integer lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
      Integer ip_X, ip_Y
C
#include "corbinf.fh"
#include "chomp2_cfg.fh"
C
C
      nSym = mSym
C
      Do iSym = 1,nSym
         nOrb(iSym) = lnOrb(iSym)
         nOcc(iSym) = lnOcc(iSym)
         nFro(iSym) = lnFro(iSym)
         nDel(iSym) = lnDel(iSym)
         nExt(iSym) = lnVir(iSym)
      End Do
C
      DoFNO=.true.
      ip_Dab=ip_X
      ip_Dii=ip_Y
      l_Dab=nExt(1)
      l_Dii=nOcc(1)
      Do iSym=2,nSym
         l_Dab=l_Dab+nExt(iSym)**2
         l_Dii=l_Dii+nOcc(iSym)
      End Do
C
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Reset_ThrGrd(nIter,mTtAtm,ThrGrd)
      use Slapaf_Info, only: Cx
      use Slapaf_Parameters, only: nDimBC
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
      Logical Found
      Integer, Allocatable:: TabAI(:), AN(:)
      Real*8, Allocatable:: TR(:), Vec(:), Coor(:,:), Tmp(:)
      Integer, Allocatable:: TabB(:,:), TabA(:,:,:)
*                                                                      *
************************************************************************
*                                                                      *
      Interface
        Subroutine Box(Coor,nsAtom,iANr,TabB,TabA,nBonds,nMax)
        Integer nsAtom
        Real*8 Coor(3,nsAtom)
        Integer iANr(nsAtom)
        Integer, Allocatable:: TabB(:,:), TabA(:,:,:)
        Integer nBonds, nMax
        End Subroutine Box
        Subroutine Hidden(Coor,AN,nHidden)
        Real*8, Allocatable:: Coor(:,:)
        Integer, Allocatable:: AN(:)
        Integer nHidden
        End Subroutine Hidden
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      nsAtom=SIZE(Cx,2)
*                                                                      *
************************************************************************
*                                                                      *
      Call qpg_dArray('Saddle',Found,nSaddle)
      If (.NOT.Found) Return
      iIter = nIter           ! Normal Computation
*                                                                      *
************************************************************************
*                                                                      *
*---- Find the translational and rotational eigenvectors for the
*     current structure.
*
      Call mma_allocate(TR,18*nsAtom,Label='TR')
      TR(:)=Zero
*
      Call TRPGen(nDimBC,nsAtom,Cx(1,1,iIter),mTR,.False.,TR)
*
*     Call RecPrt('TR',' ',TR,nDimBC,mTR)
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_Allocate(TabAI,2*mTtAtm,Label='TabAI')
      Call mma_Allocate(Vec,3*mTtAtm*nDimBC,Label='Vec')
      Call mma_Allocate(AN,mTtAtm,Label='AN')
      Call mma_Allocate(Coor,3,mTtAtm,Label='Coor')
*
*-----Generate Grand atoms list
*
      Call GenCoo(Cx(1,1,iIter),nsAtom,Coor,mTtAtm,Vec,nDimBC,AN,TabAI)
*
*---- Are there some hidden frozen atoms ?
*
      Call Hidden(Coor,AN,nHidden)
*
*-----Generate bond list
*
      mTtAtm = mTtAtm+nHidden
      Call Box(Coor,mTtAtm,AN,TabB,TabA,nBonds,nMax)
      mTtAtm = mTtAtm-nHidden
*                                                                      *
************************************************************************
*                                                                      *
*     If there are some bond types 2, and we are in saddle
*     far from the TS, let us get a reduced threshold to avoid
*     wasting our time
*
      Call mma_allocate(Tmp,nSaddle,Label='Tmp')
      Call Get_dArray('Saddle',Tmp,nSaddle)
      Found=.false.
      If (Tmp(nSaddle-1).gt.0.50d0) Then
         Do i=1,nBonds
            If (TabB(3,i).eq.2) Then
               Found=.true.
               Go To 20
            EndIf
         End Do
 20      Continue
         If (Found) Then
*           ThrGrd=0.03D0
            ThrGrd=Ten*ThrGrd
            Call WarningMessage(1,
     &             'Molecule composed of many fragments '//
     &             'Convergence threshold reduced')
         EndIf
      EndIf
      Call mma_deallocate(Tmp)
*
      Call mma_deallocate(TabA)
      Call mma_deallocate(TabB)
      Call mma_deallocate(Coor)
      Call mma_deallocate(AN)
      Call mma_deallocate(Vec)
      Call mma_deallocate(TabAI)
      Call mma_deallocate(TR)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
*  GetKandC
*
*> @brief
*>   Utility routine for quaternion resolution
*> @author Y. Carissan
*>
*> @details
*> Performs the following operation:
*>
*> \f[ K = (V_1-U_1) \times (V_2-U_2) \\
*>     C = K . (U_1 \times U_2) \f]
*>
*> @param[in]  U1 Input vector \f$ U_1 \f$
*> @param[in]  U2 Input vector \f$ U_2 \f$
*> @param[in]  V1 Input vector \f$ V_1 \f$
*> @param[in]  V2 Input vector \f$ V_2 \f$
*> @param[out] K  Output vector \f$ K \f$
*> @param[out] C  Output value \f$ C \f$
************************************************************************
      Subroutine GetKandC(U1,U2,V1,V2,K,C)
      Implicit none
#include "debug.fh"
#include "real.fh"
      Real*8 U1(3),V1(3),U2(3),V2(3),K(3)
      Real*8 T1(3),T2(3)
      Real*8 C
      real*8 ddot_
      external ddot_

      call dcopy_(3,V1,1,T1,1)   ! T1=V1
      call dcopy_(3,V2,1,T2,1)   ! T2=V2

      Call daxpy_(3,-One,U1,1,T1,1) ! T1 = T1-U1 = V1-U1
      Call daxpy_(3,-One,U2,1,T2,1) ! T2 = T2-U2 = V2-U2

      Call cross(T1,T2,K)          ! K = T1 x T2 = (V1-U1) x (V2-U2)
      Call cross(U1,U2,T1)         ! T1 = U1 x U2
      C=ddot_(3,K,1,T1,1)           ! C = K . (U1 x U2)

      if (debug) then
        Call RecPrt("K",' ',K,3,1)
        Write(6,*) "C",C
      end if

      Return ! K and C

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991,1993,1999, Roland Lindh                      *
*               1990, IBM                                              *
************************************************************************
      SubRoutine Drv_Fck(Label,ip,lOper,nComp,CCoor,
     &                   nOrdOp,rNuc,rHrmt,iChO,
     &                   opmol,ipad,opnuc,iopadr,idirect,isyop,
     &                   PtChrg,nGrid,iAddPot)
      use PAM2
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "stdalloc.fh"
#include "print.fh"
#include "real.fh"
#include "warnings.fh"
      Character Label*8
      Real*8 CCoor(3,nComp), rNuc(nComp), PtChrg(nGrid)
      Integer ip(nComp), lOper(nComp), iChO(nComp), iStabO(0:7)
      Dimension opmol(*),opnuc(*),iopadr(*)
      Real*8, Dimension(:), Allocatable :: Int1El
      Integer iTwoj(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 112
      iPrint = nPrint(iRout)
      If (iPrint.ge.19) Then
         Write (6,*) ' In OneEl: Label', Label
         Write (6,*) ' In OneEl: nComp'
         Write (6,'(1X,8I5)') nComp
         Write (6,*) ' In OneEl: lOper'
         Write (6,'(1X,8I5)') lOper
         Write (6,*) ' In OneEl: n2Tri'
         Do iComp = 1, nComp
            ip(iComp) = n2Tri(lOper(iComp))
         End Do
         Write (6,'(1X,8I5)') (ip(iComp),iComp=1,nComp)
         Call RecPrt(' CCoor',' ',CCoor,3,nComp)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute the number of blocks from each component of the operator
*     and the irreps it will span.
*
      nIC = 0
      llOper = 0
      Do iComp = 1, nComp
         llOper = iOr(llOper,lOper(iComp))
         Do iIrrep = 0, nIrrep-1
            If (iAnd(lOper(iComp),iTwoj(iIrrep)).ne.0) nIC = nIC + 1
         End Do
      End Do
      If (iPrint.ge.20) Write (6,*) ' nIC =',nIC
      If (nIC.eq.0) Go To 999
      Call SOS(iStabO,nStabO,llOper)
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate memory for symmetry adapted one electron integrals.
*     Will just store the unique elements, i.e. low triangular blocks
*     and lower triangular elements in the diagonal blocks.
*
      Call ICopy(nComp,[-1],0,ip,1)
      LenTot=0
      Do iComp = 1, nComp
         LenInt=n2Tri(lOper(iComp))
         LenTot=LenTot+LenInt+4
      End Do
      Call mma_allocate(Int1El,LenTot)
      ip(1)=1
      Call DCopy_(LenTot,[Zero],0,Int1El(ip(1)),1)
      iadr=ip(1)
      do iComp = 1, nComp
         LenInt=n2Tri(lOper(iComp))
         ip(icomp)=iadr
         iadr=iadr+LenInt+4
*        Copy center of operator to work area.
         Call DCopy_(3,Ccoor(1,iComp),1,Int1El(ip(iComp)+LenInt),1)
*        Copy nuclear contribution to work area.
         Int1El(ip(iComp)+LenInt+3) = rNuc(iComp)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute all SO integrals for all components of the operator.
*
      Call Drv_Fck_Internal(Label,ip,Int1El,LenTot,lOper,nComp,CCoor,
     &                      nOrdOp,rHrmt,iChO,
     &                      opmol,opnuc,ipad,iopadr,idirect,isyop,
     &                      iStabO,nStabO,nIC,
     &                      PtChrg,nGrid,iAddPot)
*                                                                      *
************************************************************************
*                                                                      *
*                    P O S T P R O C E S S I N G                       *
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.10)    Call PrMtrx(Label,lOper,nComp,ip,Int1El)
*                                                                      *
************************************************************************
*                                                                      *
*---- Write integrals to disc.
*
      mpp_state=1
      Do iComp = 1, nComp
         iSmLbl = lOper(iComp)
*                                                                      *
************************************************************************
*                                                                      *
*------- Write integrals to disc
*
         iOpt = 0
         iRC = -1
         If (Label(1:3).eq.'PAM')
     &      Write(Label,'(A5,I3.3)') 'PAM  ',iPAMcount
c        Write(6,*) ' oneel *',Label,'*'


         Call WrOne(iRC,iOpt,Label,iComp,Int1El(ip(iComp)),iSmLbl)

         If (Label(1:3).eq.'PAM')
     &      Call WrOne(iRC,iOpt,Label,1,Int1El(ip(iComp)),iSmLbl)
         iPAMcount=iPAMcount+1

         If (iRC.ne.0) then
            Write(6,*) ' *** Error in subroutine ONEEL ***'
            Write(6,*) '     Abend in subroutine WrOne'
            Call Quit(_RC_IO_ERROR_WRITE_)
         End If
      End Do  ! iComp
*                                                                      *
************************************************************************
*                                                                      *
*---- Deallocate memory for integral
*
      Call mma_deallocate(Int1El)
*                                                                      *
************************************************************************
*                                                                      *
 999  Continue
      Return
      End
      Subroutine Drv_Fck_Internal(Label,ip,Int1El,LenTot,lOper,nComp,
     &                            CCoor,nOrdOp,rHrmt,iChO,opmol,opnuc,
     &                            ipad,iopadr,idirect,isyop,iStabO,
     &                            nStabO,nIC,PtChrg,nGrid,iAddPot)
************************************************************************
*                                                                      *
* Object: to compute the one-electron integrals. The method employed at*
*         this point is not necessarily the fastest. However, the total*
*         time for the computation of integrals will depend on the time*
*         spent in computing the two-electron integrals.               *
*         The memory at this point is assumed to be large enough to do *
*         the computation in core.                                     *
*         The data is structured with respect to four indices, two (my *
*         ny or i j) refer to primitives or basis functions and two (a *
*         b) refer to the components of the cartesian or spherical     *
*         harmonic gaussians.                                          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*             Modified for Hermite-Gauss quadrature November '90       *
*             Modified for Rys quadrature November '90                 *
*             Modified for multipole moments November '90              *
*                                                                      *
*             Modified for general kernel routines January  91         *
*             Modified for nonsymmetrical operators February  91       *
*             Modified for better symmetry treatement October  93      *
*             Modified loop structure April 99                         *
************************************************************************
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "angtp.fh"
#include "real.fh"
#include "rmat_option.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "nsd.fh"
#include "setup.fh"
      Real*8 A(3), B(3), RB(3), CCoor(3,nComp), PtChrg(nGrid)
      Character ChOper(0:7)*3, Label*8
      Integer nOp(2), ip(nComp), lOper(nComp), iChO(nComp),
     &        iDCRR(0:7), iDCRT(0:7), iStabM(0:7), iStabO(0:7)
      Integer iTwoj(0:7)
      Dimension opmol(*),opnuc(*),iopadr(*)
      Real*8, Dimension(:), Allocatable :: Zeta, ZI, SO, Fnl
      Real*8 Int1El(LenTot)
      Data iTwoj/1,2,4,8,16,32,64,128/
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement functions
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 112
      iPrint = nPrint(iRout)
*     iPrint = 99
*
*-----Auxiliary memory allocation.
*
      Call mma_allocate(Zeta,S%m2Max)
      Call mma_allocate(ZI,S%m2Max)
*                                                                      *
************************************************************************
*                                                                      *
      Call Nr_Shells(nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*-----Double loop over shells. These loops decide the integral type
*
      Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
         Do jS = iS, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
            B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
************************************************************************
*                                                                      *
*           Allocate memory for SO integrals that will be generated by
*           this batch of AO integrals.
*
            nSO=0
            Do iComp = 1, nComp
               iSmLbl=lOper(iComp)
               nSO=nSO+MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            End Do
            If (iPrint.ge.29) Write (6,*) ' nSO=',nSO
            If (nSO.eq.0) Go To 131
            Call mma_allocate(SO,nSO*iBas*jBas)
            Call DCopy_(nSO*iBas*jBas,[Zero],0,SO,1)
*                                                                      *
************************************************************************
*                                                                      *
            If (iPrint.ge.19) Write (6,'(A,A,A,A,A)')
     &        ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
*                                                                      *
************************************************************************
*                                                                      *
*           Allocate memory for the final integrals all in the
*           primitive basis.
            lFinal = nIC * S%MaxPrm(iAng) * S%MaxPrm(jAng) *
     &               nElem(iAng)*nElem(jAng)
            Call mma_allocate(Fnl,lFinal)
            Call dCopy_(lFinal,[Zero],0,Fnl,1)
*                                                                      *
************************************************************************
*                                                                      *
*           At this point we can compute Zeta.
*           This is now computed in the ij or ji order.
*
            Call ZXia(Zeta,ZI,iPrim,jPrim,Shells(iShll)%Exp,
     &                                    Shells(jShll)%Exp)
*                                                                      *
************************************************************************
*                                                                      *
*           Find the DCR for A and B
*
            Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &                     dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
*
*           Find the stabilizer for A and B
*
            Call Inter(dc(mdci)%iStab,dc(mdci)%nStab,
     &                 dc(mdcj)%iStab,dc(mdcj)%nStab,
     &                 iStabM,nStabM)
*
            Call DCR(LambdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
            If (iPrint.ge.19) Then
               Write (6,*)
               Write (6,*) ' g      =',nIrrep
               Write (6,*) ' u      =',dc(mdci)%nStab
               Write (6,'(9A)') '(U)=',(ChOper(dc(mdci)%iStab(ii)),
     &               ii = 0, dc(mdci)%nStab-1)
               Write (6,*) ' v      =',dc(mdcj)%nStab
               Write (6,'(9A)') '(V)=',(ChOper(dc(mdcj)%iStab(ii)),
     &               ii = 0, dc(mdcj)%nStab-1)
               Write (6,*) ' LambdaR=',LmbdR
               Write (6,*) ' r      =',nDCRR
               Write (6,'(9A)') '(R)=',(ChOper(iDCRR(ii)),
     &               ii = 0, nDCRR-1)
               Write (6,*) ' m      =',nStabM
               Write (6,'(9A)') '(M)=',(ChOper(iStabM(ii)),
     &               ii = 0, nStabM-1)
            End If
*                                                                      *
************************************************************************
*                                                                      *
*           Compute normalization factor
*
            iuv = dc(mdci)%nStab*dc(mdcj)%nStab
            If (MolWgh.eq.1) Then
               Fact = DBLE(nStabO) / DBLE(LambdT)
            Else If (MolWgh.eq.0) Then
               Fact = DBLE(iuv*nStabO) / DBLE(nIrrep**2 * LambdT)
            Else
               Fact = Sqrt(DBLE(iuv))*DBLE(nStabO)/
     &                DBLE(nirrep*LambdT)
            End If
            Fact = One / Fact
*                                                                      *
************************************************************************
*                                                                      *
*           Loops over symmetry operations acting on the basis.
*
            nOp(1) = NrOpr(0)
*           Do lDCRR = 0, nDCRR-1
            Do lDCRR = 0, 0
             Call OA(iDCRR(lDCRR),B,RB)
             nOp(2) = NrOpr(iDCRR(lDCRR))
             If (iPrint.ge.49) Write (6,'(A,3F6.2,2X,3F6.2)') '*',
     &             (A(i),i=1,3),(RB(i),i=1,3)
*                                                                      *
************************************************************************
*                                                                      *
*            Pick up epsilon from memory
*
            Call FZero(Fnl,iBas*jBas*iCmp*jCmp*nIC)
            Do iB = 1, iBas
               Do jB = 1, iBas
                  ijB=(jB-1)*iBas+iB
                  Do iC = 1, iCmp
                     ijC=(iC-1)*iCmp+iC
                     iTo= + (ijC-1)*iBas**2+ijB
#ifdef _DEBUGPRINT_
                     Write (6,*)'ijB,ijC=',ijB,ijC
                     Write (6,*)'Fnl(iTo),Shells(iShll)%FockOp(iB,jB)=',
     &                           Fnl(iTo),Shells(iShll)%FockOp(iB,jB)
#endif
                     Fnl(iTo)=Shells(iShll)%FockOp(iB,jB)
                  End Do
               End Do
            End Do
#ifdef _DEBUGPRINT_
            Call RecPrt('EOrb',' ',Shells(iShll)%FockOp,iBas,1)
            Call RecPrt('EOrb',' ',Shells(iShll)%FockOp,iBas,iBas)
            Call RecPrt('FckInt',' ',Fnl,iBas*jBas,iCmp*jCmp*nIC)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*            At this point accumulate the batch of integrals onto the
*            final symmetry adapted integrals.
*
             If (iPrint.ge.99) Then
                Call RecPrt (' Accumulated SO integrals, so far...',
     &                               ' ',SO,iBas*jBas,nSO)
             End If
*
*------------Symmetry adapt component by component
*
             iSOBlk = 1
             iIC = 1
             Do iComp = 1, nComp
              iSmLbl=lOper(iComp)
              mSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
              If (mSO.eq.0) Then
                 Do iIrrep = 0, nIrrep-1
                    If (iAnd(lOper(iComp),iTwoj(iIrrep)).ne.0)
     &                  iIC = iIC + 1
                 End Do
              Else
                 Call SymAd1(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                       iShell,jShell,iShll,jShll,
     &                       iAO,jAO,Fnl,
     &                       iBas,jBas,nIC,iIC,SO(iSOBlk),mSO,nOp)
                 iSOBlk = iSOBlk + mSO*iBas*jBas
              End If
             End Do
*
            End Do
*                                                                      *
************************************************************************
*                                                                      *
*           Multiply with factors due to projection operators
*
            If (Fact.ne.One) Call DScal_(nSO*iBas*jBas,Fact,SO,1)
            If (iPrint.ge.99) Then
               Write (6,*) ' Scaling SO''s', Fact
               Call RecPrt(' Accumulated SO integrals',' ',
     &                     SO,iBas*jBas,nSO)
            End If
*                                                                      *
************************************************************************
*                                                                      *
*           Scatter the SO's on to the non-zero blocks of the
*           lower triangle.
*
            iSOBlk = 1
            Do iComp = 1, nComp
              iSmLbl=lOper(iComp)
              If (n2Tri(iSmLbl).ne.0) Then
                 mSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
              Else
                 mSO=0
              End If
              If (mSO.ne.0) Then
                 Call SOSctt(SO(iSOBlk),iBas,jBas,mSO,Int1El(ip(iComp)),
     &                       n2Tri(iSmLbl),iSmLbl,iCmp,jCmp,iShell,
     &                       jShell,iAO,jAO,nComp,Label,lOper,rHrmt)
                 iSOBlk = iSOBlk + mSO*iBas*jBas
              End If
            End Do
*                                                                      *
************************************************************************
*                                                                      *
            Call mma_deallocate(Fnl)
            Call mma_deallocate(SO)
*                                                                      *
************************************************************************
*                                                                      *
 131        Continue
         End Do
      End Do
*
      Call mma_deallocate(ZI)
      Call mma_deallocate(Zeta)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(CCoor)
         Call Unused_integer(nOrdOp)
         Call Unused_integer_array(iChO)
         Call Unused_real_array(opmol)
         Call Unused_real_array(opnuc)
         Call Unused_integer(ipad)
         Call Unused_integer_array(iopadr)
         Call Unused_integer(idirect)
         Call Unused_integer(isyop)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(iAddPot)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine AllenGinsberg(QMMethod,Eint,Poli,dNuc,Cha,Dip,Qua
     &                        ,MxBaux,iVEC,nDim,iExtr_Atm,lEig,iEig
     &                        ,iQ_Atoms,ip_ExpCento,E_Nuc_Part
     &                        ,lSlater,Eint_Nuc)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "numbers.fh"
#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension Eint(MxQCen,10),Poli(MxQCen,10)
      Dimension Cha(MxBaux,MxQCen),Dip(MxBaux,3,MxQCen)
      Dimension Qua(MxBaux,6,MxQCen),dNuc(MxAt)
      Dimension iExtr_Atm(MxAt),Eint_Nuc(MxAt)
      Dimension iCenSet(MxAt**2)
      Character QMMethod*5
      Logical lEig,Check1,Check2,lSlater

*
*-- Set up centre index set. The order of centres are decided by
*   the MpProp-program and are hence collected in the get_center
*   routine.
*
*
*-- Atom centres
*
      Do 901, iAt=1,MxAt
        If(iExtr_Atm(iAt).eq.-1) then
          GoTo 902
        Else
          iCenSet(iAt)=iExtr_Atm(iAt)
        Endif
901   Continue
      NExtrAt=iAt
902   Continue
      NExtrAt=iAt-1
*
*-- Bond centres
*
      kaunter=iQ_Atoms
      kaunt=NExtrAt
      Do 905, iAt=2,iQ_Atoms
        Do 906, jAt=1,iAt-1
          kaunter=kaunter+1
          Check1=.false.
          Check2=.false.
          Do 907, i1=1,NExtrAt
            If(iAt.eq.iCenSet(i1)) Check1=.true.
            If(jAt.eq.iCenSet(i1)) Check2=.true.
907       Continue
          If(Check1.and.Check2) then
            kaunt=kaunt+1
            iCenSet(kaunt)=kaunter
          Endif
906     Continue
905   Continue
*
*-- A minor check.
*
      NExpect=NExtrAt*(nExtrAt+1)/2
      NTotal=kaunt
      If(NTotal.ne.NExpect) then
        Write(6,*)
        Write(6,*)' Error in atom specification for partial'
     &//' perturbation extraction.'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif

*
*-- Compute partial nuclear contribution.
*
      E_Nuc_Part=0.0d0
      Do 931, iAt=1,NExtrAt
        iCx=iCenSet(iAt)
        If(lSlater) then
          E_Nuc_Part=E_Nuc_Part
     &         -(Eint_Nuc(iCx)+Poli(iCx,1))*dNuc(iCx)
        Else
          E_Nuc_Part=E_Nuc_Part
     &         -(Eint(iCx,1)+Poli(iCx,1))*dNuc(iCx)
        Endif
931   Continue

*
*-- Set up matrix elements for the partial perturbations.
*   Compare with hel, helstate, polink and polins.
*
      Call GetMem('VelPart','Allo','Real',iVelP,nDim*(nDim+1)/2)
      Call GetMem('VpoPart','Allo','Real',iVpoP,nDim*(nDim+1)/2)
      call dcopy_(nDim*(nDim+1)/2,[ZERO],iZERO,Work(iVelP),iONE)
      call dcopy_(nDim*(nDim+1)/2,[ZERO],iZERO,Work(iVpoP),iONE)
      kk=0
      Do 911, i=1,nDim
        Do 912, j=1,i
          kk=kk+1
          Do 913, k=1,NTotal
            iCx=iCenSet(k)
            dMp=Cha(kk,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,1)*dMp
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,1)*dMp
            dMp=Dip(kk,1,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,2)*dMp
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,2)*dMp
            dMp=Dip(kk,2,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,3)*dMp
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,3)*dMp
            dMp=Dip(kk,3,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,4)*dMp
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,4)*dMp
            dMp=Qua(kk,1,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,5)*dMp
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,5)*dMp
            dMp=Qua(kk,3,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,7)*dMp
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,7)*dMp
            dMp=Qua(kk,6,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,10)*dMp
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,10)*dMp
            dMp=Qua(kk,2,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,6)*dMp*2.0d0
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,6)*dMp*2.0d0
            dMp=Qua(kk,4,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,8)*dMp*2.0d0
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,8)*dMp*2.0d0
            dMp=Qua(kk,5,iCx)
            Work(iVelP+kk-1)=Work(iVelP+kk-1)+Eint(iCx,9)*dMp*2.0d0
            Work(iVpoP+kk-1)=Work(iVpoP+kk-1)+Poli(iCx,9)*dMp*2.0d0
913       Continue
912     Continue
911   Continue

*
*-- Collect expectation value for the partial perturbation.
*
      Call Expectus(QMMethod,Work(iVelP),Work(iVelP),Work(iVpoP)
     &             ,Work(iVpoP),MxBaux,iVEC,nDim,lEig,iEig
     &             ,ip_ExpCento)

*
*-- Deallocate.
*
      Call GetMem('VelPart','Free','Real',iVelP,nDim*(nDim+1)/2)
      Call GetMem('VpoPart','Free','Real',iVpoP,nDim*(nDim+1)/2)

*
*-- Howl
*

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine CIDIA(iSym,ralp)
      Implicit Real*8 (a-h,o-z)
#include "detdim.fh"
#include "crun_mclr.fh"
#include "cicisp_mclr.fh"
#include "spinfo_mclr.fh"
#include "csfbas_mclr.fh"
#include "incdia.fh"
#include "WrkSpc.fh"

#include "Input.fh"
#include "Pointers.fh"
#include "negpre.fh"
      Integer iSM(1),LSPC(1),iSPC(1),IDUM(1)
*
*     This is just a interface to hide Jeppe from the rest of the world
*     we dont want to let world see the work of the danish
*     (I hope he never reads that)
*     Anyway concerning the CSF/SD stuff.
*     If we work with spin dependent perturbations
*     we never use CSF's (to complicated), instead we use
*     SD in all parts of the program,
*     otherwise we will switch to SD representation in this routine
*
      NSPC=1
      ISPC(1)=1
      iSM(1)=iSym
      IAMCMP=0
      ICISTR=1
      i=2
      If (isym.eq.state_sym) i=1
      If (NOCSF.eq.0) Then
        ncsf1=NCSASM(ISYM)
        nsd=max(ncsf(isym),nint(XISPSM(ISYM,1)))
*       Call GetMem('DIAGCSF','ALLO','REAL',ipDCSF,nSD)
        ipdcsfi=ipget(nsd)
        ipdcsf=ipin(ipdcsfi)
        Call GetMem('DIAGSD','ALLO','REAL',ipDSD,nSD)
      Else
        nsd=max(ncsf(isym),nint(XISPSM(ISYM,1)))
*       Call GetMem('DIAGSD','ALLO','REAL',ipDSD,nSD)
        ipDSDi=ipGet(nsd)
        ipdsd=ipin(ipdsdi)
      End If
      If (nocsf.eq.0) Then
         nD=NCSASM(ISYM)
         ipDia=ipDCSF
         ipdiai=ipdcsfi
      Else
        nD=idint(XISPSM(ISYM,ISPC(1)))
        ipDIA=ipDSD
        ipdiai=ipdsdi
      End If
      LSPC(1)=nSD
      Call IntDia(Work(ipDSD),NSPC,ISPC,ISM,LSPC,
     &           IAMCMP,rin_ene+potnuc)
      If (Nocsf.ne.1)
     &Call CSDIAG(Work(ipDCSF),Work(ipDSD),
     &              NCNATS(1,ISYM),NTYP,
     &              iWORK(KICTS(i)),NDPCNT,NCPCNT,0,
     &              0,IDUM,IPRNT)

      If (nocsf.eq.0)
     & Call GetMem('DIAGSD','FREE','REAL',ipDSD,nSD)
*     Calculate explicit part of hamiltonian
*
      np2=Min(nd,nexp_max)
      np1=0
      nq=0
      If (np2.ne.0) Then
       irc=ipnout(ipdiai)
       call h0(Work(ipin(ipdiai)),
     &         np1,nexp_max,nq,isym,iphx,ipvt,iplst,nexp,
     &         TimeDep)
      Else
        nexp=0
        iphx=0
      End if
*     Call Getmem('KICONF1','FREE','INTEGER',kiconf(i),lConf)

      ip=ipin(ipdiai)

      ECAS=ERASSCF(1)
      Do iC=1,nD
       If ((Work(ip+ic-1)-ECAS).ne.0.0d0) Then
        Work(ip+iC-1)=1.0d0/(Work(ip+ic-1)-ECAS)
       Else
        Work(ip+iC-1)=1.0d5
       End If
      End do
*                 -1
*     ralp=<0|(H-E) |0>
*
      Call GetMem('TMP','ALLO','REAL',ipq,nD)
      call dcopy_(nD,[0.0d0],0,Work(ipq),1)
      Call ExpHinvv(work(ipin(ipdiai)),Work(ipin(ipCI)),
     &          Work(ipQ),0.0d0,1.0d0)
      ralp=DDOT_(nD,Work(ipin(ipCI)),1,Work(ipQ),1)
      irc=ipnout(ipdiai)
      IF (NGP) Then
         Call MKP1INV(work(ipin(ipdiai)))
         Call MKCIPRE
      End If
      Call GetMem('TMP','FREE','REAL',ipq,nD)

      ipdia=ipdiai
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SPIND2(ISYOP,MS2OP,IORBTAB,ISSTAB,IFSBTAB1,IFSBTAB4,PSI1,PSI4,SPD2)

use Index_Functions, only: nTri_Elem
use rassi_global_arrays, only: FSBANN1, FSBANN2, FSBANN3, FSBANN4
use Symmetry_Info, only: MUL
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ISYOP, MS2OP, IORBTAB(*), ISSTAB(*), IFSBTAB1(*), IFSBTAB4(*)
real(kind=wp), intent(in) :: PSI1(*), PSI4(*)
real(kind=wp), intent(inout) :: SPD2(*)
integer(kind=iwp) :: IJKL, IMODE, ISMLAB, ISORB, ISPLAB, JISORB, JSMLAB, JSORB, JSPLAB, KLMS2, KLSORB, KLSYM, KOINFO, KSMLAB, &
                     KSORB, KSPLAB, LSMLAB, LSORB, LSPLAB, NASGEM, NASORB, ND1, ND2, ND3, ND4
real(kind=wp) :: COEFF, OVLP
real(kind=wp), allocatable :: ANN1(:), ANN2(:), ANN3(:), ANN4(:)
real(kind=wp), external :: OVERLAP_RASSI

! Nr of active spin-orbitals
NASORB = IORBTAB(4)
! Nr of active spin-orbital pairs:
NASGEM = nTri_Elem(NASORB-1)
KOINFO = 19

do ISORB=2,NASORB
  ! Symmetry properties:
  ISMLAB = IORBTAB(KOINFO+1+8*(ISORB-1))
  ISPLAB = IORBTAB(KOINFO+3+8*(ISORB-1))
  ! Annihilate a single spin orbital, ISORB:
  IMODE = -1
  call FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB1,1)
  ND1 = FSBANN1(5)
  COEFF = One
  call mma_allocate(ANN1,ND1,Label='ANN1')
  ANN1(:) = Zero
  call PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,FSBANN1,IFSBTAB1,COEFF,ANN1,PSI1)
  !TEST write(u6,*) ' The ANN1 wave function, with ISORB=',ISORB
  !TEST PRTHR = 0.01_wp
  !TEST call PRWVF(IORBTAB,ISSTAB,FSBANN1,PRTHR,ANN1)
  do JSORB=1,ISORB-1
    ! Symmetry properties:
    JSMLAB = IORBTAB(KOINFO+1+8*(JSORB-1))
    JSPLAB = IORBTAB(KOINFO+3+8*(JSORB-1))
    ! Pair index:
    JISORB = nTri_ELem(ISORB-2)+JSORB
    ! Annihilate once more, the spin orbital JSORB:
    IMODE = -1
    call FSBOP(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN1,2)
    ND2 = FSBANN2(5)
    call mma_allocate(ANN2,ND2,Label='ANN2')
    ANN2(:) = Zero
    call PRIMSGM(IMODE,JSORB,IORBTAB,ISSTAB,FSBANN2,FSBANN1,COEFF,ANN2,ANN1)
    !TEST write(u6,*) ' The ANN2 wave function, with JSORB=',JSORB
    !TEST PRTHR = 0.01_wp
    !TEST call PRWVF(IORBTAB,ISSTAB,FSBANN2,PRTHR,ANN2)

    KLSYM = MUL(MUL(ISMLAB,JSMLAB),ISYOP)
    KLMS2 = MS2OP+ISPLAB+JSPLAB
    do LSORB=2,NASORB
      ! Symmetry properties:
      LSMLAB = IORBTAB(KOINFO+1+8*(LSORB-1))
      LSPLAB = IORBTAB(KOINFO+3+8*(LSORB-1))
      ! Annihilate a single spin orbital, LSORB:
      IMODE = -1
      call FSBOP(IMODE,LSORB,IORBTAB,ISSTAB,IFSBTAB4,4)
      ND4 = FSBANN4(5)
      COEFF = One
      call mma_allocate(ANN4,ND4,Label='ANN4')
      ANN4(:) = Zero
      call PRIMSGM(IMODE,LSORB,IORBTAB,ISSTAB,FSBANN4,IFSBTAB4,COEFF,ANN4,PSI4)
      !TEST write(u6,*) ' The ANN4 wave function, with LSORB=',LSORB
      !TEST PRTHR = 0.01_wp
      !TEST call PRWVF(IORBTAB,ISSTAB,FSBANN4,PRTHR,ANN4)
      do KSORB=1,LSORB-1
        OVLP = Zero
        ! Symmetry properties:
        KSMLAB = IORBTAB(KOINFO+1+8*(KSORB-1))
        KSPLAB = IORBTAB(KOINFO+3+8*(KSORB-1))
        if (MUL(KSMLAB,LSMLAB) /= KLSYM) cycle
        if (KSPLAB+LSPLAB /= KLMS2) cycle
        ! Pair index:
        KLSORB = nTri_Elem(LSORB-2)+KSORB
        ! Annihilate once more, the spin orbital KSORB:
        IMODE = -1
        call FSBOP(IMODE,KSORB,IORBTAB,ISSTAB,FSBANN4,3)
        ND3 = FSBANN3(5)
        call mma_allocate(ANN3,ND3,Label='ANN3')
        ANN3(:) = Zero
        call PRIMSGM(IMODE,KSORB,IORBTAB,ISSTAB,FSBANN3,FSBANN4,COEFF,ANN3,ANN4)
        !TEST write(u6,*) ' The ANN3 wave function, with KSORB=',KSORB
        !TEST PRTHR = 0.01_wp
        !TEST call PRWVF(IORBTAB,ISSTAB,FSBANN3,PRTHR,ANN3)
        ! Compute the spin transition density matrix element:
        OVLP = OVERLAP_RASSI(FSBANN2,FSBANN3,ANN2,ANN3)
        !TEST write(u6,*) ' Their overlap:',OVLP
        IJKL = JISORB+NASGEM*(KLSORB-1)
        SPD2(IJKL) = SPD2(IJKL)+OVLP
        call mma_deallocate(ANN3)
        call mma_deallocate(FSBANN3)
      end do
      call mma_deallocate(ANN4)
      call mma_deallocate(FSBANN4)
    end do
    call mma_deallocate(ANN2)
    call mma_deallocate(FSBANN2)
  end do
  call mma_deallocate(ANN1)
  call mma_deallocate(FSBANN1)
end do

end subroutine SPIND2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Yoshio Nishimoto                                 *
!***********************************************************************
!
! Prepare conjugate gradient squared-related things

subroutine CGS_pre(nDensC,nConf1,nRoots,Kappa,dKappa,Sigma,Fancy,Sc1,ipCI,ipCId,ipDia,ipPre2,iPre,ipST,ipS1,delta,iSym,iter)

use ipPage, only: ipIn, opOut, W
use ISRotation, only: DMInvISR, InvSCF, ISR
use cgs_mod, only: CGSvec, PCGS
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none

integer(kind=iwp), intent(in) :: nDensC, nConf1, nRoots, ipCI, ipCId, ipDia, ipPre2, iPre(*), ipST, ipS1
real(kind=wp), intent(inout) :: Kappa(*), dKappa(*), Sigma(*), Fancy(*), Sc1(*)
real(kind=wp), intent(out) :: delta
integer(kind=iwp), intent(inout) :: iSym, iter
real(kind=wp) :: deltaC, deltaK
real(kind=wp), external :: ddot_

! R0
CGSvec%R0(1:nDensC) = Kappa(1:nDensC)
W(CGSvec%ipR0)%A(1:nConf1*nRoots) = W(ipST)%A(1:nConf1*nRoots)
if (.not. InvSCF) ISR%R0(:,:) = ISR%Rvec(:,:)

if (PCGS == 5) then
  !! precondition p (K-1*p)
  call ipIn(ipST)
  call DMinvCI_SA(CGSvec%ipR0,W(ipST)%A,Fancy)
  call opOut(ipCI)
  call opOut(ipdia)

  call ipIn(ipPre2)
  call DMInvKap(W(ipPre2)%A,iPre,CGSvec%R0,Kappa,Sc1,iSym,iter)
  call opOut(ipPre2)

  if (.not. InvSCF) call DMInvISR(ISR%R0,ISR%Rvec)

  !! r0 <-- K-1*r
  CGSvec%R0(1:nDensC) = Kappa(1:nDensC)
  W(CGSvec%ipR0)%A(1:nConf1*nRoots) = W(ipST)%A(1:nConf1*nRoots)
  if (.not. InvSCF) ISR%R0(:,:) = ISR%Rvec(:,:)
end if

! u_k
CGSvec%Uvec(1:nDensC) = Kappa(1:nDensC)
W(CGSvec%ipUvec)%A(1:nConf1*nRoots) = W(ipST)%A(1:nConf1*nRoots)
if (.not. InvSCF) ISR%Uvec(:,:) = ISR%Rvec(:,:)

! p_k
dKappa(1:nDensC) = CGSvec%Uvec(1:nDensC)
CGSvec%Pvec(1:nDensC) = dKappa(1:nDensC)
W(ipCId)%A(1:nConf1*nRoots) = W(CGSvec%ipUvec)%A(1:nConf1*nRoots)
W(CGSvec%ipPvec)%A(1:nConf1*nRoots) = W(ipCId)%A(1:nConf1*nRoots)
if (.not. InvSCF) then
  ISR%Pvec(:,:) = ISR%Uvec(:,:)
  if (PCGS == 4) ISR%Rvec(:,:) = ISR%R0(:,:)
  ISR%Xvec(:,:) = Zero
end if

deltaC = ddot_(nConf1*nroots,W(CGSvec%ipR0)%A,1,W(CGSvec%ipR0)%A,1)
if (.not. InvSCF) deltaC = deltaC+ddot_(nRoots**2,ISR%R0,1,ISR%R0,1)
deltaK = ddot_(nDensC,CGSvec%R0,1,CGSvec%R0,1)
Kappa(1:nDensC) = Zero
delta = deltaC+deltaK

if (PCGS == 5) then
  Sigma(1:nDensC) = CGSvec%R0(1:nDensC)
  W(ipS1)%A(1:nConf1*nRoots) = W(CGSvec%ipR0)%A(1:nConf1*nRoots)
end if

end subroutine CGS_pre

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
************************************************************************
* SubRoutine GATskL(create,nTsk,igaTsk)                                *
*  -> initialize or kill global task list                              *
*     create:   Logical: .TRUE. -> create / .FALSE. -> kill            *
*     nTsk:     # of tasks                                             *
*     igaTsk:   global array handle to global task list (on return)    *
************************************************************************
      SubRoutine GATskL(create,nTsk,igaTsk)
      Implicit None
      Logical create
      Integer nTsk,igaTsk
#ifdef _MOLCAS_MPP_
#  include "global.fh"
#  include "mafdecls.fh"
      Logical, External :: Is_Real_Par
      Logical ok
      Integer nProcs,Chk
*
      If (.Not. Is_Real_Par()) Return
      If (create) Then
        nProcs=ga_nnodes()
        Chk=(nTsk+nProcs-1)/nProcs
        ok=ga_create(MT_INT,nTsk,1,'GlTskL',Chk,1,igaTsk)
        If (.NOT.ok) Then
          Write (6,*) 'GATskL: ga_create not OK!'
          Call GAStp('GATskL',42)
          Call Abend()
        End If
        Call ga_zero(igaTsk)
      Else
        ok=ga_destroy(igaTsk)
      End If
#else
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(create)
         Call Unused_integer(nTsk)
         Call Unused_integer(igaTsk)
      End If
#endif
      Return
      End
*----------------------------------------------------------------------*
      SubRoutine GATskL_Zero(igaTsk)
      Implicit None
      Integer igaTsk
#ifdef _MOLCAS_MPP_
#  include "global.fh"

      Call ga_zero(igaTsk)
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(igaTsk)
#endif
      Return
      End
************************************************************************
* Integer Function RsvTsk(igaTsk,iTskLs,nTsk,iStart)                   *
*  -> reserve a task for my node and mark it on the global task list   *
*     as reserved.                                                     *
*     igaTsk:   global array handle to global task list                *
*     iTskLs:   my private task list (my favourite sequence of tasks)  *
*     nTsk:     # of tasks                                             *
*     iStart:   starting value of index of private task list           *
************************************************************************
      Integer Function RsvTsk(igaTsk,iTskLs,nTsk,mTsk,iStart,iS,iE)
      Implicit None
      Integer nTsk,mTsk,igaTsk,iTskLs(nTsk,2),iStart,iS,iE
#ifdef _MOLCAS_MPP_
#  include "global.fh"
      Logical Reserved
      Logical, External :: King
#  ifdef _GA_
      Integer iCnt,iTsk
*
      If (iStart.gt.mTsk) Then
        iTsk=0
        iCnt=nTsk
      Else
        Do iCnt = iStart, mTsk
          iTsk = iTskLs(iCnt,1)
*         try to reserve iTsk on global task list...
          Reserved = ga_read_inc(igaTsk,iTsk,1,1) .ne. 0
          If (Reserved) Then
             iE = iE - 1
             iTskLs(iE,2)=iTsk
          Else
             iS = iS + 1
             iTskLs(iS,2)=iTsk
             Go To 100
          End If
        End Do
        iTsk=0
  100   Continue
*
      End If
      RsvTsk=iTsk
      iStart=iCnt
#  else
#    include "WrkSpc.fh"
      Integer iCnt,iTsk,One,ipTSKR
      Data    One/1/
*
      If (iStart.gt.mTsk) Then
        iTsk=0
        iCnt=nTsk
      Else
        Call GetMem('TSKR','ALLO','INTE',ipTSKR,mTsk)
        Call ga_readb_inc(igaTsk,mTsk,iTskLs(iStart,1),iWork(ipTSKR))
        Do iCnt = iStart, mTsk
          iTsk = iTskLs(iCnt,1)
          Reserved = iWork(ipTSKR+iCnt-iStart) .ne. 0
          If (Reserved) Then
             iE = iE - 1
             iTskLs(iE,2)=iTsk
          Else
             iS = iS + 1
             iTskLs(iS,2)=iTsk
             Go To 100
          End If
        End Do
        iTsk=0
  100   Continue
        Call GetMem('TSKR','FREE','INTE',ipTSKR,mTsk)
      End If
      RsvTsk=iTsk
      iStart=iCnt
#  endif
#else
      RsvTsk=0
      iStart=nTsk
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(igaTsk)
         Call Unused_integer_array(iTskLs)
         Call Unused_integer(mTsk)
         Call Unused_integer(iS)
         Call Unused_integer(iE)
      End If
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
function IZNUM_PTDT(IAB,NOPEN,NALPHA,Z,NEWORD,IREORD)
! Address of prototype determinant IAB
! alpha occupation is used to define lex address
!
! Jeppe Olsen, Dec. 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IZNUM_PTDT
integer(kind=iwp), intent(in) :: NOPEN, IAB(NOPEN), NALPHA, Z(NOPEN,NALPHA), NEWORD(*), IREORD
integer(kind=iwp) :: I, IALPHA, IZ

#ifdef _DEBUGPRINT_
write(u6,*) ' IZNUM_PTDT, NOPEN, NALPHA = ',NOPEN,NALPHA
write(u6,*) ' Input Z- matrix'
call IWRTMA(Z,NOPEN,NALPHA,NOPEN,NALPHA)
#endif

IZ = 1
IALPHA = 0
do I=1,NOPEN
  if (IAB(I) > 0) then
    IALPHA = IALPHA+1
    IZ = IZ+Z(I,IALPHA)
  end if
end do

!write(u6,*) ' IZ = ',IZ
if (IREORD == 0) then
  IZNUM_PTDT = IZ
else
  IZNUM_PTDT = NEWORD(IZ)
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from IZNUM_PTDT'
write(u6,*) ' Prototype determinant'
call IWRTMA(IAB,1,NOPEN,1,NOPEN)
write(u6,*) ' Address = ',IZNUM_PTDT
#endif

end function IZNUM_PTDT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
*               Markus P. Fuelscher                                    *
************************************************************************
      SubRoutine DmpInf()
************************************************************************
*                                                                      *
* Object: to dump all input information on the file INFO.              *
*                                                                      *
* Called from: Seward                                                  *
*                                                                      *
* Calling    :                                                         *
*              Put_dArray                                              *
*              Get_dArray                                              *
*              Put_iArray                                              *
*              Get_iArray                                              *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January 1992                                             *
*                                                                      *
* modified by M.P. Fuelscher                                           *
* - changed to used communication file                                 *
************************************************************************
      use External_Centers
      use Basis_Info, only: Basis_Info_Dmp
      use Center_Info, only: Center_Info_Dmp
      use Symmetry_Info, only: Symmetry_Info_Dmp
      use SOAO_Info, only: SOAO_Info_Dmp
      use Sizes_of_Seward, only: Size_Dmp
      use DKH_Info, only: DKH_Info_Dmp
      use Real_Info, only: Real_Info_Dmp
      use RICD_Info, only: RICD_Info_Dmp
      use Logical_Info, only: Logical_Info_Dmp
      Implicit Real*8 (A-H,O-Z)
#include "stdalloc.fh"
#include "real.fh"
#include "rctfld.fh"
#include "nq_info.fh"
      Integer  iix(2)
      Real*8   rix(2)
      nbyte_i = iiloc(iix(2)) - iiloc(iix(1))
      nbyte_r = idloc(rix(2)) - idloc(rix(1))
*
      Call DmpInf_Internal(
     & cRFStrt,iRFStrt,lRFStrt,rRFStrt,cQStrt,iQStrt,rQStrt)
*
*     This is to allow type punning without an explicit interface
      Contains
      SubRoutine DmpInf_Internal(
     & cRFStrt,iRFStrt,lRFStrt,rRFStrt,cQStrt,iQStrt,rQStrt)
      Use Iso_C_Binding
      Integer, Target :: cRFStrt,iRFStrt,lRFStrt,
     &                   cQStrt,iQStrt
      Real*8, Target :: rRFStrt,rQStrt
      Integer, Pointer :: p_cRF(:),p_iRF(:),
     &                    p_lRF(:),p_cQ(:),p_iQ(:)
      Real*8, Pointer :: p_rRF(:),p_rQ(:)
*                                                                      *
************************************************************************
*                                                                      *
      Call SOAO_Info_Dmp()
      Call Basis_Info_Dmp()
      Call Center_Info_Dmp()
      Call Symmetry_Info_Dmp()
      Call Size_Dmp()
      Call DKH_Info_Dmp()
      Call Real_Info_Dmp()
      Call RICD_Info_Dmp()
      Call Logical_Info_Dmp()
*                                                                      *
************************************************************************
*                                                                      *
*     Reaction field parameters
*
      Len = iiLoc(lRFEnd)-iiLoc(lRFStrt)
      Len = (Len+nByte_i)/nByte_i
      Call C_F_Pointer(C_Loc(lRFStrt),p_lRF,[Len])
      Call Put_iArray('RFlInfo',p_lRF,Len)
*
      Len = idLoc(rRFEnd)-idLoc(rRFStrt)
      Len = (Len+nByte_r)/nByte_r
      Call C_F_Pointer(C_Loc(rRFStrt),p_rRF,[Len])
      Call Put_dArray('RFrInfo',p_rRF,Len)
*
      Len = iiLoc(iRFEnd)-iiLoc(iRFStrt)
      Len = (Len+nByte_i)/nByte_i
      Call C_F_Pointer(C_Loc(iRFStrt),p_iRF,[Len])
      Call Put_iArray('RFiInfo',p_iRF,Len)
*
      Len = iiLoc(cRFEnd)-iiLoc(cRFStrt)
      Len = (Len+nByte_i)/nByte_i
      Call C_F_Pointer(C_Loc(cRFStrt),p_cRF,[Len])
      Call Put_iArray('RFcInfo',p_cRF,Len)
*
      Nullify(p_lRF,p_rRF,p_iRF,p_cRF)
*                                                                      *
************************************************************************
*                                                                      *
*     Numerical integration information and parameters
*
      Len = idLoc(rQEnd)-idLoc(rQStrt)
      Len = (Len+nByte_r)/nByte_r
      Call C_F_Pointer(C_Loc(rQStrt),p_rQ,[Len])
      Call Put_dArray('Quad_r',p_rQ,Len)
*
      Len = iiLoc(iQEnd)-iiLoc(iQStrt)
      Len = (Len+nByte_i)/nByte_i
      Call C_F_Pointer(C_Loc(iQStrt),p_iQ,[Len])
      Call Put_iArray('Quad_i',p_iQ,Len)
*
      Len = iiLoc(cQEnd)-iiLoc(cQStrt)
      Len = (Len+nByte_i)/nByte_i
      Call C_F_Pointer(C_Loc(cQStrt),p_cQ,[Len])
      Call Put_iArray('Quad_c',p_cQ,Len)
*
      Nullify(p_rQ,p_iQ,p_cQ)
*                                                                      *
************************************************************************
*                                                                      *
      Call External_Centers_Dmp()
*                                                                      *
************************************************************************
*                                                                      *
      Call DMP_EFP()
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End SubRoutine DmpInf_Internal
*
      End SubRoutine DmpInf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MakeWwHlp1 (Ww,W1,
     c                       dima,dimb,dimab,dimbe,dimga,dimbega,key)
c
c       this routine do:
c       Make  Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
c       for the case a"=b" , be"=ga"
c       N.B. algoritmus nieje prilis vymakany
c
c       parameter description
c       Ww     - array for Ww+(-) (O)
c       W1     - array for W1(a",be",b",ga") (I)
c       dimx   - dimension of a",b",ab",be",ga",bega" (I)
c       key    - 1 - calc Ww+, 2 - calc Ww- (I)
c
        implicit none
        integer dima,dimb,dimab,dimbe,dimga,dimbega,key
        real*8 Ww(1:dimab,1:dimbega)
        real*8 W1(1:dima,1:dimbe,1:dimb,1:dimga)
c
c       help variables
        integer a,b,ab,be,ga,bega
c
c
        if (key.eq.1) then
          bega=0
          do be=1,dimbe
          do ga=1,be
          bega=bega+1
          ab=0
          do a=2,dima
          do b=1,a-1
          ab=ab+1
            Ww(ab,bega)=W1(a,be,b,ga)+W1(b,be,a,ga)
          end do
          end do
          end do
          end do
        else
          bega=0
          do be=2,dimbe
          do ga=1,be-1
          bega=bega+1
          ab=0
          do a=2,dima
          do b=1,a-1
          ab=ab+1
            Ww(ab,bega)=W1(a,be,b,ga)-W1(b,be,a,ga)
          end do
          end do
          end do
          end do
        end if
c
c        Cely clen ma Faktor 2, tu teda nevydelim 2
c        call mv0sv (dimab*dimbega,dimab*dimbega,
c    c              Ww(1,1),0.5d0)
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Roland Lindh                                           *
!               Valera Veryazov                                        *
!***********************************************************************

subroutine print_ddNorm(nMOs,Wdd,det3)
!***********************************************************************
! Adapted from SAGIT to work with OpenMolcas (October 2020)            *
!***********************************************************************

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nMOs
real(kind=wp), intent(in) :: Wdd(nMOs,nMOs), det3
integer(kind=iwp) :: i, j

do i=1,nMOs
  write(u6,'(20F8.3)') (Wdd(i,j)*det3,j=1,nMOs)
end do

return

end subroutine print_ddNorm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010-2012, Jonas Bostrom                               *
*               2013, Roland Lindh                                     *
************************************************************************
      Subroutine ChoMP2g_GradSetup(irc,CMO)
************************************************************************
*                                                                      *
*     Author: Jonas Bostrom (2010-2012)                                *
*             Roland Lindh, Implementation of symmetry (some while in  *
*                           New Orleans during the 245th National ACS  *
*                           meeting, 7-11 April 2013).                 *
************************************************************************
#include "implicit.fh"
#include "WrkSpc.fh"
#include "chomp2g.fh"
#include "chomp2.fh"
#include "cholesky.fh"
#include "choorb.fh"
*
      Integer nOccAll(8), iOffCInv(8), iOffLRo(8,8), iOffLRb(8,8),
     &        nLRo(8), nLRb(8), iOffD(8), iAdrR(8), iOff_WJL(8),
     &        nB3(8), iOffB3(8,8), iOffCMOo(8), iAdrB(8)
      Real*8 CMO(*)
*
      Character*5 fname
      Character*6 fname2
*
      Character*9  ThisNm
      Character*17 SecNam
      Integer LuB(2), LuA(2)
      Parameter (SecNam = 'ChoMP2g_GradSetup', ThisNm = 'GradSetup')
*                                                                      *
************************************************************************
*                                                                      *
      iWr=1
      iRd=2
*                                                                      *
************************************************************************
*                                                                      *
*     Compute some sizes of some arrays
*
      nBas2    = 0
      lTriDens = 0
      lRecDens = 0
      nOrbBas = 0
      nOccBas = 0
      nVirBas = 0
      iAdr=1
      jAdr=1
      iOff_JL = 0
      iCMOo = 0
      Do iSym = 1, nSym
         iOffCMOo(iSym)=iCMOo
         iCMOo = iCMOo + nBas(iSym)*nOcc(iSym)
         iOff_WJL(iSym)=iOff_JL
         iOff_JL = iOff_JL + nMP2Vec(iSym)*NumCho(iSym)
         iAdrR(iSym)=iAdr
         iAdrB(iSym)=jAdr
         iOffD(iSym) = nBas2
         nBas2 = nBas2 + nBas(iSym)*nBas(iSym)
         lTriDens = lTriDens + nBas(iSym)*(nBas(iSym)+1)/2
         lRecDens = lRecDens + nBas(iSym)*nBas(iSym)
         nOccAll(iSym) = nFro(iSym) + nOcc(iSym)
         iOffCInv(iSym) = nOrbBas
         nOrbBas = nOrbBas + nOrb(iSym)*nBas(iSym)
         nOccBas = nOccBas + nOcc(iSym)*nBas(iSym)
         nVirBas = nVirBas + nVir(iSym)*nBas(iSym)
         nOO=0
         nBB=0
         iB3 = 0
         Do jSym = 1, nSym
            kSym = iEor(iSym-1,jSym-1)+1
*
            iOffLRo(iSym,jSym) = nOO
            iOffLRb(iSym,jSym) = nBB
            nOO = nOO + nOrb(jSym)*nOrb(kSym)
            nBB = nBB + nBas(jSym)*nBas(kSym)
            iOffB3(iSym,jSym)=iB3
            iB3 = iB3 + nBas(jSym)*nOcc(kSym)
         End Do
         nB3(iSym)=iB3
         nLRo(iSym)=nOO
         nLRb(iSym)=nBB
         iAdr = iAdr + nBB*nMP2Vec(iSym)
         jAdr = jAdr + nBB*NumCho(iSym)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('CMO_inv','Allo','Real',ip_CMO_inv,nOrbBas)
      Call FZero(Work(ip_CMO_inv),nOrbBas)
      Call GetMem('CMO_o  ','Allo','Real',ip_CMO_o  ,nOccBas)
      Call GetMem('CMO_v  ','Allo','Real',ip_CMO_v  ,nVirBas)
*                                                                      *
************************************************************************
*                                                                      *
*     Get memory for density matricies and overlap matrix
*
      Call GetMem('MP2Density','Allo','Real',ip_MP2Density,lRecDens)
      Call GetMem('SCFDensity','Allo','Real',ip_SCFDensity,lRecDens)
      Call GetMem('Overlap', 'Allo','Real', ip_Smat, lRecDens)
*
      Call GetMem('MP2TTotDensity','Allo','Real',ip_MP2TTotDensity,
     &            lTriDens)
      Call GetMem('MP2TDensity','Allo','Real',ip_MP2TDensity,lTriDens)
      Call GetMem('SCFTDensity','Allo','Real',ip_SCFTDensity,lTriDens)
      Call Getmem('OverlapT','Allo','Real', ip_STmat,lTriDens)
*                                                                      *
************************************************************************
*                                                                      *
*     Get the Variational MP2 Density and the HF density
*
      Call Get_D1ao_Var(Work(ip_MP2TTotDensity),lTriDens)
      Call Get_D1ao(Work(ip_SCFTDensity), lTriDens)
*                                                                      *
************************************************************************
*                                                                      *
*     Get the overlap matrix
*
      iSymlbl=1
      Call RdOne(irc,6,'Mltpl  0',1,Work(ip_STmat),iSymlbl)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the differential MP2 density
      Do i = 1, lTriDens
         Work(ip_MP2TDensity + i-1)=2.0d0*(Work(ip_MP2TTotDensity+i-1)-
     &                                Work(ip_SCFTDensity + i-1))
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Modified for triangular storage to quadratic storage. Some of the
*     triangular storage is folded, i.e off diagonal element are
*     multiplied with 2.
*
      index = 0
      iOff = 0
      Do iSym = 1, nSym
         Do i = 1, nBas(iSym)
            Do j = 1, i-1
               Work(ip_MP2Density+ j-1 + nBas(iSym)*(i-1)+iOff) =
     &                            Work(ip_MP2TDensity+index)/2.0d0
               Work(ip_MP2Density+ i-1 + nBas(iSym)*(j-1)+iOff) =
     &                            Work(ip_MP2TDensity+index)/2.0d0
               Work(ip_SCFDensity+ j-1 + nBas(iSym)*(i-1)+iOff) =
     &                            Work(ip_SCFTDensity+index)/2.0d0
               Work(ip_SCFDensity+ i-1 + nBas(iSym)*(j-1)+iOff) =
     &                            Work(ip_SCFTDensity+index)/2.0d0
               Work(ip_Smat + j-1 + nBas(iSym)*(i-1)+iOff) =
     &                         Work(ip_STmat+index)
               Work(ip_Smat + i-1 + nBas(iSym)*(j-1)+iOff) =
     &                         Work(ip_STmat+index)
*
               index = index + 1
            End Do
            Work(ip_MP2Density+ i-1 + nBas(iSym)*(i-1)+iOff) =
     &                      Work(ip_MP2TDensity+index)
            Work(ip_SCFDensity+ i-1 + nBas(iSym)*(i-1)+iOff) =
     &                      Work(ip_SCFTDensity+index)
            Work(ip_Smat + i-1 + nBas(iSym)*(i-1)+iOff) =
     &                      Work(ip_STmat+index)
*
            index = index + 1
         End Do
         iOff = iOff + nBas(iSym)**2
      End Do
*
*     Deallocate temporary memory
*
      Call GetMem('MP2TTotDensity','Free','Real',ip_MP2TTotDensity,
     &            lTriDens)
      Call GetMem('MP2TDensity','Free','Real',ip_MP2TDensity,lTriDens)
      Call GetMem('SCFTDensity','Free','Real',ip_SCFTDensity,lTriDens)
      Call Getmem('OverlapT','Free','Real', ip_STmat,lTriDens)
*                                                                      *
************************************************************************
*                                                                      *
*     Calculate inverse CMO-matrix as C^-1 = C^T*S
*     --------------------------------------------
*
      iOff1 = 0
      iOff2 = 0
      Do iSym = 1, nSym
         Call dGemm_('T','N', nOrb(iSym),nBas(iSym),nBas(iSym),
     &              1.0d0,CMO(1+iOff2), nBas(iSym),
     &                    Work(ip_Smat+iOff1), nBas(iSym),
     &              0.0d0,Work(ip_CMO_inv+iOff2), nOrb(iSym))
*
         iOff1 =  iOff1 + nBas(iSym)**2
         iOff2 =  iOff2 + nOrb(iSym)*nBas(iSym)
      End Do
*
      Call GetMem('Overlap', 'Free','Real', ip_Smat, lRecDens)
*                                                                      *
************************************************************************
*                                                                      *
*     Calculate occupied and virtual inverse CMO-matrices
*     ---------------------------------------------------
*
      k_v = 1
      k_o = 1
      iOff2 = 0
      Do iSym = 1, nSym
         Do i = 1, nOrb(iSym)
            Do j = 1, nBas(iSym)
               If(i.gt. nFro(iSym) .and. (i .le. nOccAll(iSym))) Then
                  Work(ip_CMO_o+k_o-1) = CMO((i-1)*nBas(iSym)+j+iOff2)
                  k_o = k_o+1
               Else If(i.gt. nOccAll(iSym)) Then
                  Work(ip_CMO_v+k_v-1) = CMO((i-1)*nBas(iSym)+j+iOff2)
                  k_v = k_v+1
               End If
            End Do
         End Do
         iOff2 =  iOff2 + nOrb(iSym)*nBas(iSym)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Open Cholesky vector files.
*     ---------------------------
*
      iTypL = 1
      iTypR = 2
*
      Do iSym = 1, nSym
         Call ChoMP2_OpenF(1,iTypL,iSym)
         Call ChoMP2_OpenF(1,iTypR,iSym)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Open some temporaty files
*
      iSeed = 7
      LuXVec = IsFreeUnit(iSeed)
      FName='TMPV1'
      Call DaName_MF_WA(LuXVec,Fname)

      iSeed = 7
      LuYVec = isFreeUnit(iSeed)
      FName='TMPV2'
      Call DaName_MF_WA(LuYVec,Fname)

      iSeed = 7
      LuRVec = isFreeUnit(iSeed)
      FName='TMPV3'
      Call DaName_MF_WA(LuRVec,Fname)

      LuLVec = isFreeUnit(iSeed)
      FName='TMPV4'
      Call DaName_MF_WA(LuLVec,Fname)

      iSeed = 7
      LuBTmp = isFreeUnit(iSeed)
      FName='TMPV6'
      Call DaName_MF_WA(LuBTmp,Fname)
*                                                                      *
************************************************************************
*                                                                      *
*     Open files for the terms in Eqs. 35, 36, 40, and 41.
*     i=1 Coulombic and i=2 Exchange contributions.
*     This can be merged into singel 2-center and 3-center
*     contributions
*
      Do i = 1,2
*
         iSeed = 7
         LuA(i) = isFreeUnit(iSeed)
         Write(Fname2,'(A5,I1)') 'AMP2V',i
         Call DaName_MF_WA(LuA(i),Fname2)
*
         iSeed = 7
         LuB(i) = isFreeUnit(iSeed)
         Write(Fname2,'(A5,I1)') 'BMP2V',i
         Call DaName_MF_WA(LuB(i),Fname2)
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Max number of vectors in one batch. This is not foolproof, if you
*     run the code with too little ram you might get problems
*     ------------------------------------------------------------------
*
*     This has to be recoded to be dynamic. To be done after the
*     symmetry has been implemented in the code.
*
      maxvalue = 10
*                                                                      *
************************************************************************
*                                                                      *
      nVec = 0
      Do iSym = 1, nSym
         nVec = min(max(NumCho(iSym),nMP2Vec(iSym),nVec),maxvalue)
         If(nVec .lt. 1) Then
            Call ChoMP2_Quit(SecNam,'Insufficient memory','[1]')
         End If
      End Do
      iSym=1  ! Here we are!
*
*     Allocate memory for L-vectors
*     -----------------------------
*
      iVecFF = 1
      iVecOF = 2
      iVecVF = 3
      iVecFO = 4
      iVecOO = 5
      iVecVO = 6
      iVecFV = 7
      iVecOV = 8
      iVecVV = 9
*
      lCJK = nMoMo(iSym,iVecFF)*nVec
      Call GetMem('CJK','Allo','Real',ip_CJK, lCJK)
*
      lCKi = nMoMo(iSym,iVecOF)*nVec
      Call GetMem('CKi','Allo','Real',ip_CKi, lCKi)
*
      lCKa = nMoMo(iSym,iVecVF)*nVec
      Call GetMem('CKa','Allo','Real',ip_CKa, lCKa)
*
      lCiK = nMoMo(iSYm,iVecFO)*nVec
      Call GetMem('CiK','Allo','Real',ip_CiK, lCiK)
*
      lCij = nMoMo(iSym,iVecOO)*nVec
      Call GetMem('Cij','Allo','Real',ip_Cij, lCij)
*
      lCia = nMoMo(iSym,iVecVO)*nVec
      Call GetMem('Cia','Allo','Real',ip_Cia, lCia)
*
      lCaK = nMoMo(iSym,iVecFV)*nVec
      Call GetMem('CaK','Allo','Real',ip_CaK, lCaK)
*
      lCai = nMoMo(iSym,iVecOV)*nVec
      Call GetMem('Cai','Allo','Real',ip_Cai, lCai)
*
      lCab = nMoMo(iSym,iVecVV)*nVec
      Call GetMem('Cab','Allo','Real',ip_Cab, lCab)
*
      lCpq = nOrb(iSym)*nOrb(iSym)*nVec
      Call GetMem('Cpq','Allo','Real',ip_Cpq, lCpq)
*
*     The Cholesky vectors of the MP2 amplitudes,
*     see Eq. 26.
*
      lRia = nOcc(iSym)*nVir(iSym)*nVec
      Call GetMem('Ria','Allo','Real',ip_Ria, lRia)
*
      lCpn = nOrb(iSym)*nBas(iSym)*nVec
      Call GetMem('Cpn','Allo','Real',ip_Cpn, lCpn)
*
      lRin = nOcc(iSym)*nBas(iSym)*nVec
      Call GetMem('Rin','Allo','Real',ip_Rin, lRin)
*
      lCmn = nBas(iSym)*nBas(iSym)*nVec
      Call GetMem('Cmn','Allo','Real',ip_Cmn, lCmn)
*
      lRmn = nBas(iSym)*nBas(iSym)*nVec
      Call GetMem('Rmn','Allo','Real',ip_Rmn, lRmn)
*
      lUkn = nBas(iSym)*nBas(iSym)*nVec
      Call GetMem('Ukn','Allo','Real',ip_Ukn, lUkn)
*
      lVkn = nBas(iSym)*nBas(iSym)*nVec
      Call GetMem('Vkn','Allo','Real',ip_Vkn, lVkn)
*
      lWJL = NumCho(iSym)*nMP2Vec(iSym)
      Call GetMem('WJL','Allo','Real',ip_WJL, lWJL)
      Call FZero(Work(ip_WJL),lWJL)
*
      lWmjKJ = nVec*nVec*nOcc(iSym)*nBas(iSym)
      Call GetMem('WmjKJ','Allo','Real',ip_WmjKJ, lWmjKJ)
*
      lB3jl = nBas(iSym)*nOcc(iSym)*nVec
      Call GetMem('B3jl','Allo','Real',ip_B3jl, lB3jl)
*
      lB3kl = nBas(iSym)*nBas(iSym)*nVec
      Call GetMem('B3kl','Allo','Real',ip_B3kl, lB3kl)
*                                                                      *
************************************************************************
*                                                                      *
*     Start loop over batches of C_pq^J vectors
*
      Do iSym = 1, nSym
      Do iiJ = 1, NumCho(iSym), nVec
         nJ  = Min(nVec, NumCho(iSym) - (iiJ -1) )
*
*        Read C_pq^J-vectors from disk
*        -----------------------------

         lTot = nMoMo(iSym,iVecFF)*nJ
         iAdr = 1 + nMoMo(iSym,iVecFF)*(iiJ-1) + iAdrOff(iSym,iVecFF)
         Call dDaFile(lUnit_F(iSym,iTypL),iRd,Work(ip_CJK),lTot,iAdr)

         lTot = nMoMo(iSym,iVecOF)*nJ
         iAdr = 1 + nMoMo(iSym,iVecOF)*(iiJ-1) + iAdrOff(iSym,iVecOF)
         Call dDaFile(lUnit_F(iSym,iTypL),iRd,Work(ip_CKi),lTot,iAdr)

         lTot = nMoMo(iSym,iVecVF)*nJ
         iAdr = 1 + nMoMo(iSym,iVecVF)*(iiJ-1) + iAdrOff(iSym,iVecVF)
         Call dDaFile(lUnit_F(iSym,iTypL),iRd,Work(ip_CKa),lTot,iAdr)

         lTot = nMoMo(iSym,iVecFO)*nJ
         iAdr = 1 + nMoMo(iSym,iVecFO)*(iiJ-1) + iAdrOff(iSym,iVecFO)
         Call dDaFile(lUnit_F(iSym,iTypL),iRd,Work(ip_CiK),lTot,iAdr)

         lTot = nMoMo(iSym,iVecOO)*nJ
         iAdr = 1 + nMoMo(iSym,iVecOO)*(iiJ-1) + iAdrOff(iSym,iVecOO)
         Call dDaFile(lUnit_F(iSym,iTypL),iRd,Work(ip_Cij),lTot,iAdr)

         lTot = nMoMo(iSym,iVecVO)*nJ
         iAdr = 1 + nMoMo(iSym,iVecVO)*(iiJ-1) + iAdrOff(iSym,iVecVO)
         Call dDaFile(lUnit_F(iSym,iTypL),iRd,Work(ip_Cia),lTot,iAdr)

         lTot = nMoMo(iSym,iVecFV)*nJ
         iAdr = 1 + nMoMo(iSym,iVecFV)*(iiJ-1) + iAdrOff(iSym,iVecFV)
         Call dDaFile(lUnit_F(iSym,iTypL),iRd,Work(ip_CaK),lTot,iAdr)

         lTot = nMoMo(iSym,iVecOV)*nJ
         iAdr = 1 + nMoMo(iSym,iVecOV)*(iiJ-1) + iAdrOff(iSym,iVecOV)
         Call dDaFile(lUnit_F(iSym,iTypL),iRd,Work(ip_Cai),lTot,iAdr)

         lTot = nMoMo(iSym,iVecVV)*nJ
         iAdr = 1 + nMoMo(iSym,iVecVV)*(iiJ-1) + iAdrOff(iSym,iVecVV)
         Call dDaFile(lUnit_F(iSym,iTypL),iRd,Work(ip_Cab),lTot,iAdr)

*        Put the C_pq^J-vectors together to one large vector
*        ------------------------------------------------

         iOff3 = 0
         Do iJ = 1, nJ
*
            iOffFF=0
            iOffOF=0
            iOffFO=0
            iOffOO=0
            iOffVF=0
            iOffFV=0
            iOffVO=0
            iOffOV=0
            iOffVV=0
            iOffBB=0
            Do jSym = 1, nSym
               kSym=iEor(iSym-1,jSym-1)+1
            Do i = 1, nFro(kSym)
               iOff1 = nMoMo(iSym,iVecFF)*(iJ-1) + (i-1)*nFro(jSym)
               Call dCopy_(nFro(jSym),Work(ip_CJK+iOff1+iOffFF),1,
     &                               Work(ip_Cpq+iOff3+iOffBB),1)
               iOff3 = iOff3+nFro(jSym)
               iOff1 = nMoMo(iSym,iVecOF)*(iJ-1) + (i-1)*nOcc(jSym)
               Call dCopy_(nOcc(jSym),Work(ip_CKi+iOff1+iOffOF),1,
     &                               Work(ip_Cpq+iOff3+iOffBB),1)
               iOff3 = iOff3+nOcc(jSym)
               iOff1 = nMoMo(iSym,iVecVF)*(iJ-1) + (i-1)*nVir(jSym)
               Call dCopy_(nVir(jSym),Work(ip_CKa+iOff1+iOffVF),1,
     &                               Work(ip_Cpq+iOff3+iOffBB),1)
               iOff3 = iOff3+nVir(jSym)
            End Do
*
            Do i = 1, nOcc(kSym)
               iOff1 = nMoMo(iSym,iVecFO)*(iJ-1) + (i-1)*nFro(jSym)
               Call dCopy_(nFro(jSym),Work(ip_CiK+iOff1+iOffFO),1,
     &                               Work(ip_Cpq+iOff3+iOffBB),1)
               iOff3 = iOff3 + nFro(jSym)
               iOff1 = nMoMo(iSym,iVecOO)*(iJ-1) + (i-1)*nOcc(jSym)
               Call dCopy_(nOcc(jSym),Work(ip_Cij+iOff1+iOffOO),1,
     &                               Work(ip_Cpq+iOff3+iOffBB),1)
               iOff3 = iOff3 + nOcc(jSym)
               iOff1 = nMoMo(iSym,iVecVO)*(iJ-1) + (i-1)*nVir(jSym)
               Call dCopy_(nVir(jSym),Work(ip_Cia+iOff1+iOffVO),1,
     &                               Work(ip_Cpq+iOff3+iOffBB),1)
               iOff3 = iOff3 + nVir(jSym)
            End Do
*
            Do i = 1, nVir(kSym)
               iOff1 = nMoMo(iSym,iVecFV)*(iJ-1) + (i-1)*nFro(jSym)
               Call dCopy_(nFro(jSym),Work(ip_CaK+iOff1+iOffFV),1,
     &                               Work(ip_Cpq+iOff3+iOffBB),1)
               iOff3 = iOff3 + nFro(jSym)
               iOff1 = nMoMo(iSym,iVecOV)*(iJ-1) + (i-1)*nOcc(jSym)
               Call dCopy_(nOcc(jSym),Work(ip_Cai+iOff1+iOffOV),1,
     &                               Work(ip_Cpq+iOff3+iOffBB),1)
               iOff3 = iOff3 + nOcc(jSym)
               iOff1 = nMoMo(iSym,iVecVV)*(iJ-1) + (i-1)*nVir(jSym)
               Call dCopy_(nVir(jSym),Work(ip_Cab+iOff1+iOffVV),1,
     &                               Work(ip_Cpq+iOff3+iOffBB),1)
               iOff3 = iOff3 + nVir(jSym)
            End Do
*
            iOffFF = iOffFF + nFro(jSym)*nFro(kSym)
            iOffOF = iOffOF + nOcc(jSym)*nFro(kSym)
            iOffFO = iOffFO + nFro(jSym)*nOcc(kSym)
            iOffOO = iOffFO + nOcc(jSym)*nOcc(kSym)
            iOffVF = iOffVF + nVir(jSym)*nFro(kSym)
            iOffFV = iOffFV + nFro(jSym)*nVir(kSym)
            iOffVO = iOffVO + nVir(jSym)*nOcc(kSym)
            iOffOV = iOffOV + nOcc(jSym)*nVir(kSym)
            iOffVV = iOffVV + nVir(jSym)*nVir(kSym)
            iOffBB = iOffBB + nBas(jSym)*nBas(kSym)
            End Do
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
            Do jSym = 1, nSym
               kSym = iEor(iSym-1,jSym-1)+1
*
*           Do backtransformations of the Cholesky-vectors to get C_mn.
*           ----------------------------------------------------------
*
*           (C^-1)^T x C_pq^J = C_nq^J
*
            iOff1 = nLRo(iSym)*(iJ-1) + iOffLRo(iSym,jSym)
            Call dGemm_('T', 'N',nBas(jSym),nOrb(kSym), nOrb(jSym),
     &                 1.0d0,Work(ip_CMO_inv+iOffCInv(jSym)),nOrb(jSym),
     &                       Work(ip_Cpq+iOff1), nOrb(jSym),
     &                 0.0d0,Work(ip_Cpn), nBas(jSym))
*
*           C_nq^J x  (C^-1) = C_nm^J
*
            iOff2 = nLRb(iSym)*(iJ-1) + iOffLRb(iSym,jSym)
            Call dGemm_('N','N',nBas(jSym),nBas(kSym), nOrb(kSym),
     &                 1.0d0,Work(ip_Cpn),nBas(jSym),
     &                       Work(ip_CMO_inv+iOffCInv(kSym)),nOrb(kSym),
     &                 0.0d0,Work(ip_Cmn+iOff2), nBas(jSym))
*
            End Do
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
            Do jSym = 1, nSym
               kSym = iEor(iSym-1,jSym-1)+1
*
*           C_nm^J x D(MP2)_mk = U_nk^J, Eq. (43)
*
            iOff = nLRb(iSym)*(iJ-1) + iOffLRb(iSym,jSym)
            iOff0= iOffD(kSym)
            Call dGemm_('N','N',nBas(jSym),nBas(kSym), nBas(kSym),
     &                 1.0d0,Work(ip_Cmn+iOff),nBas(jSym),
     &                       Work(ip_MP2Density+iOff0), nBas(kSym),
     &                 0.0d0,Work(ip_Ukn+iOff), nBas(jSym))
*
*           D(HF)_kn x C_nm^J = V_km^J, Eq. (42)
*
            iOff0= iOffD(jSym)
            Call dGemm_('N','N',nBas(jSym),nBas(kSym), nBas(jSym),
     &                 1.0d0,Work(ip_SCFDensity+iOff0), nBas(jSym),
     &                       Work(ip_Cmn+iOff), nBas(jSym),
     &                 0.0d0,Work(ip_Vkn+iOff), nBas(jSym))
*
            End Do
         End Do ! iJ
*                                                                      *
************************************************************************
*                                                                      *
*        Write C_nm^J, U_nk^J, and V_km^J to disk.
*
         lTot = nLRb(iSym)*nJ
*
         iAdr = iAdrB(iSym) + nLRb(iSym)*(iiJ-1)
         Call dDaFile(LuLVec,iWr,Work(ip_Cmn),lTot,iAdr)
         iAdr = iAdrB(iSym) + nLRb(iSym)*(iiJ-1)
         Call dDaFile(LuXVec,iWr,Work(ip_Ukn),lTot,iAdr)
         iAdr = iAdrB(iSym) + nLRb(iSym)*(iiJ-1)
         Call dDaFile(LuYVec,iWr,Work(ip_Vkn),lTot,iAdr)
*                                                                      *
************************************************************************
*                                                                      *
         Do lSym = 1, nSym
         Do iiK = 1, nMP2Vec(lSym), nVec
            nK = Min(nVec, nMP2Vec(lSym) - (iiK-1))
*
*           Read the R-Vectors
*
            lTot = nMoMo(lSym,iVecOV)*nK
            iAdr = nMoMo(lSym,iVecOV)*(iiK-1) + 1
            Call dDaFile(lUnit_F(lSym,iTypR),iRd,Work(ip_Ria),lTot,iAdr)

*           Do backtransformations of the Amplitude-vectors to get Rmnx.
*           ------------------------------------------------------------
*           See Eq. (39).
*
            iOff_Ria = 0
            iOff_Rin = 0
            iOff_Rmn = 0
            Do iK = 1, nK

               Do jSym = 1, nSym
                  kSym = iEor(lSym-1,jSym-1)+1
*
*                 C_na x R_ai^K = R_ni^K  (Temporary storage)
*
               iOff1 = iOff_Ria
               iOff_Ria = iOff_Ria + nVir(jSym)*nOcc(kSym)
               iOff2 = iOff_Rin
               iOff_Rin = iOff_Rin + nBas(jSym)*nOcc(kSym)
               Call dGemm_('N','N',nBas(jSym),nOcc(kSym), nVir(jSym),
     &              1.0d0,Work(ip_CMO_v),nBas(jSym),
     &                    Work(ip_Ria+iOff1), nVir(jSym),
     &              0.0d0,Work(ip_Rin+iOff2), nBas(jSym))
*
*              R_ni^K x C_mi^T = R_nm^K
*
               iOff3 = iOff_Rmn
               iOff_Rmn = iOff_Rmn + nBas(jSym)*nBas(kSym)
               Call dGemm_('N','T',nBas(jSym),nBas(kSym), nOcc(kSym),
     &                 1.0d0,Work(ip_Rin+iOff2),nBas(jSym),
     &                       Work(ip_CMO_o), nBas(kSym),
     &                 0.0d0,Work(ip_Rmn+iOff3), nBas(jSym))
*
               End Do ! jSym
            End Do    ! iK
*
*           Write  R_mn^K to disk
*
            lTot = nLRb(iSym)*nK
            iAdr = iAdrR(iSym) +  nLRb(iSym)*(iiK-1)
            Call dDaFile(LuRVec,iWr,Work(ip_Rmn),lTot,iAdr)
*                                                                      *
************************************************************************
*                                                                      *
*           Sum_mn (R_mn^K)^T x C_mn^J = W_KJ  (Eq. 38)
*
            If (iSym.eq.lSym) Then
            iOffZ = iOff_WJL(iSym) + nMP2Vec(iSym)*(iiJ-1) + iiK-1
            Call dGemm_('T','N',nK,nJ,nLRb(iSym),
     &                 1.0d0,Work(ip_Rmn),nLRb(iSym),
     &                       Work(ip_Cmn),nLRb(iSym),
     &                 0.0d0,Work(ip_WJL+iOffZ), nMP2Vec(iSym))
            End If
*                                                                      *
************************************************************************
*                                                                      *
            Do iJ = 1, nJ
               iOff_Rin=0
               Do iK = 1, nK
*
                  Do jSym = 1, nSym
                     kSym = iEor(iSym-1,jSym-1)+1
                     mSym = iEor(lSym-1,kSym-1)+1
*
                     iOffL = nLRb(iSym)*(iJ-1) + iOffLRb(iSym,jSym)
                     iOffR = iOff_Rin
                     iOff_Rin = iOff_Rin + nBas(kSym)*nOcc(mSym)
*
*                 C_mn^J x R_ni^K = W_mi^JK, see Eq. (44)
*
                  Call dGemm_('N','N',nBas(jSym),nOcc(mSym),nBas(kSym),
     &                        1.0d0,Work(ip_Cmn+iOffL),nBas(jSym),
     &                              Work(ip_Rin+iOffR),nBas(kSym),
     &                        0.0d0,Work(ip_WmjKJ),nBas(jSym))
*
                  Fac = 1.0d0
                  If((iK .eq. 1) .and. (iiK .eq. 1)) Fac = 0.0d0
*
*                 R_nm^K x W_mi^JK, last two summation in Eqs. 40 and 41
*
                  mSym2 = iEor(lSym-1,jSym-1)+1
                  iOffB = nB3(iSym)*(iJ-1) + iOffB3(iSym,mSym2)
                  iOffR = nLRb(lSym)*(iK-1) + iOffLRb(lSym,mSym2)
                  Call dGemm_('N','N',nBas(mSym2),nOcc(mSym),nBas(jSym),
     &                       1.0d0,Work(ip_Rmn+iOffR),nBas(mSym2),
     &                             Work(ip_WmjKJ), nBas(jSym),
     &                       Fac,  Work(ip_B3jl+iOffB),nBas(mSym2))
*
                  End Do ! jSym
*
               End Do ! iK
            End Do    ! iJ
*
         End Do ! iiK
         End Do ! lSym

         Do iJ = 1, nJ
*
            Do jSym = 1, nSym
               kSym = iEor(iSym-1,jSym-1)+1
*
            iOffB1 = nB3(iSym)*(iJ-1) + iOffB3(iSym,jSym)
            iOffB2 = nLRb(iSym)*(iJ-1) + iOffLRb(iSym,jSym)
            iOff   = iOffCMOo(kSym)
*
*           Complete the 3rd RHS term in Eq. 40
*
            Call dGemm_('N','T',nBas(jSym),nBas(kSym),nOcc(kSym),
     &                -8.0d0,Work(ip_B3jl+iOffB1) , nBas(jSym),
     &                       Work(ip_CMO_o+iOff),nBas(kSym),
     &                 0.0d0,Work(ip_B3kl+iOffB2),nBas(jSym))
*
            End Do ! jSym
         End Do    ! iJ
*
*        Write matrix to file. Note that it has the same structure as
*        the R and L matrices.
*
         lTot = nLRb(iSym)*nJ
         iAdr = iAdrB(iSym) + nLRb(iSym)*(iiJ-1)
         Call dDaFile(LuBTmp,iWr,Work(ip_B3kl),lTot,iAdr)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      End Do ! iiJ
      End Do ! iSym
*
      Call GetMem('B3jl','Free','Real',ip_B3jl, lB3jl)
*
      Call GetMem('Rin','Free','Real',ip_Rin, lRin)
      Call GetMem('Ria','Free','Real',ip_Ria, lRia)
*
      Call GetMem('Cpq','Free','Real',ip_Cpq, lCpq)
      Call GetMem('Cpn','Free','Real',ip_Cpn, lCpn)
*
      Call GetMem('CJK','Free','Real',ip_CJK, lCJK)
      Call GetMem('CKi','Free','Real',ip_CKi, lCKi)
      Call GetMem('CKa','Free','Real',ip_CKa, lCKa)
      Call GetMem('CiK','Free','Real',ip_CiK, lCiK)
      Call GetMem('Cij','Free','Real',ip_Cij, lCij)
      Call GetMem('Cia','Free','Real',ip_Cia, lCia)
      Call GetMem('CaK','Free','Real',ip_CaK, lCaK)
      Call GetMem('Cai','Free','Real',ip_Cai, lCai)
      Call GetMem('Cab','Free','Real',ip_Cab, lCab)
      Call GetMem('SCFDensity','Free','Real',ip_SCFDensity,lRecDens)
*
      iSym = 1
*
      lB1kl = nBas(iSym)*nBas(iSym)*nVec
      Call GetMem('B1kl','Allo','Real',ip_B1kl, lB1kl)
*
      lB3kl_s = nBas(iSym)*nBas(iSym)*nVec
      Call GetMem('B3kl_s','Allo','Real',ip_B3kl_s, lB3kl_s)
*
      lA1 = NumCho(iSym)*NumCho(iSym)
      Call GetMem('A1','Allo','Real',ip_A1, lA1)
      Call FZero(Work(ip_A1),lA1)
*
      lA2 = NumCho(iSym)*NumCho(iSym)
      Call GetMem('A2','Allo','Real',ip_A2, lA2)
      Call FZero(Work(ip_A2),lA2)
*
      lB2kl = nBas(iSym)*nBas(iSym)*nVec
      Call GetMem('B2kl','Allo','Real',ip_B2kl, lB2kl)
*
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Start loop over batches of J
*
      iOff_A = 0
      Do iSym = 1, nSym
      Do iiJ = 1, NumCho(iSym), nVec
         nJ = Min(nVec, NumCho(iSym) - (iiJ-1))
*
*        Read V_km^J
*
         lTot = nLRb(iSym)*nJ
         iAdr = iAdrB(iSym) + nLRb(iSym)*(iiJ-1)
         Call dDaFile(LuYVec,iRd,Work(ip_Vkn),lTot,iAdr)
*
         Do iiK = 1, NumCho(iSym), nVec
            nK = Min(nVec, NumCho(iSym) - (iiK-1))
*
*           Read U_km_K
*
            lTot = nLRb(iSym)*nK
            iAdr = iAdrB(iSym) + nLRb(iSym)*(iiK-1)
            Call dDaFile(LuXVec,iRd,Work(ip_Ukn),lTot,iAdr)
*
*           U_km^K x V_km^J, 1st term RHS eq. 41

            iOffA = iiK-1 + (iiJ-1)*NumCho(iSym) + iOff_A
            Fact = 1.0D0
            Call dGemm_('T','N', nK, nJ,nLRb(iSym),
     &                 Fact,Work(ip_Ukn),nLRb(iSym),
     &                       Work(ip_Vkn),nLRb(iSym),
     &                 0.0d0,Work(ip_A1+iOffA),NumCho(iSym))
*
         End Do
*                                                                      *
************************************************************************
*                                                                      *
         Do iiK = 1, nMP2Vec(iSym), nVec
            nK = Min(nVec, nMP2Vec(iSym) - (iiK-1))
*
*           Read R_mn^K
*
            lTot = nLRb(iSym)*nK
            iAdr = iAdrR(iSym) + nLRb(iSym)*(iiK-1)
            Call dDaFile(LuRVec,iRd,Work(ip_Rmn),lTot,iAdr)
*
*           R_mn_K x W_JK, 2nd RHS term Eq. 35
*
            Fac = 1.0D0
            If (iiK.eq.1) Fac = 0.0D0
            iOffZ = iOff_WJL(iSym) + iiK-1 + (iiJ-1)*nMp2Vec(iSym)
            Call dGemm_('N','N',nLRb(iSym),nJ,nK,
     &                 -8.0d0,Work(ip_Rmn), nLRb(iSym),
     &                        Work(ip_WJL+iOffZ),nMP2Vec(iSym),
     &                  Fac,  Work(ip_B2kl),nLRb(iSym))
         End Do
*
*        Write to disk
*
         lTot = nLRb(iSym)*nJ
         iAdr = iAdrB(iSym) + nLRb(iSym)*(iiJ-1)
         Call dDaFile(LuB(2),iWr,Work(ip_B2kl),lTot,iAdr)
*                                                                      *
************************************************************************
*                                                                      *
*        Read 3rd RHS term in Eq. 40
*
         lTot = nLRb(iSym)*nJ
         iAdr = iAdrB(iSym) + nLRb(iSym)*(iiJ-1)
         Call dDaFile(LuBTmp,iRd,Work(ip_B3kl),lTot,iAdr)
*
*        Symmetrize
*
         Do iJ = 1, nJ
            iOffL = nLRb(iSym)*(iJ-1)
            Do jSym = 1, nSym
               kSym= iEor(iSym-1,jSym-1)+1
*
            Do k = 1, nBas(jSym)
               Do l = 1, nBas(kSym)
                  kl = k + nBas(jSym)*(l-1) + iOffLRb(iSym,jSym)
                  kl_s = kl
                  lk = l + nBas(kSym)*(k-1) + iOffLRb(iSym,kSym)
                  Work(ip_B3kl_s+iOffL+kl_s-1) =
     &               ( Work(ip_B3kl+iOffL+kl-1) +
     &                 Work(ip_B3kl+iOffL+lk-1) )/2
               End Do
            End Do
*
            End Do ! jSym
         End Do
*
*        Write the symmetrized 3rd term to disk
*
         lTot = nLRb(iSym)*nJ
         iAdr = iAdrB(iSym) + nLRb(iSym)*(iiJ-1)
         Call dDaFile(LuBTmp,iWr,Work(ip_B3kl_s),lTot,iAdr)
*                                                                      *
************************************************************************
*                                                                      *
*
         Do iJ = 1, nJ
            iOff = nLRb(iSym)*(iJ-1)
*
*           V_kn^J x D(MP2)_kn, 2nd RHS term Eq. 40
*
            Do jSym = 1, nSym
               kSym = iEor(iSym-1,jSym-1) + 1
*
               iOff1 = iOff + iOffLRb(iSym,jSym)
               iOff2 = iOffD(kSym)
            Call dGemm_('N','N',nBas(jSym), nBas(kSym), nBas(kSym),
     &                 1.0d0,Work(ip_Vkn+iOff1), nBas(jSym),
     &                       Work(ip_MP2Density+iOff2), nBas(kSym),
     &                 0.0d0,Work(ip_B1kl+iOff1), nBas(jSym))
            End Do
         End Do
*
*        Compound 2nd and 3rd RHS term in Eq. 40.

         Call DaXpY_(nLRb(iSym)*nJ,1.0d0,Work(ip_B3kl),1,
     &                                     Work(ip_B1kl),1)
*
*        Write compounded terms to disk
*
         lTot = nLRb(iSym)*nJ
         iAdr = iAdrB(iSym) + nLRb(iSym)*(iiJ-1)
         Call dDaFile(LuB(1),iWr,Work(ip_B1kl),lTot,iAdr)
*                                                                      *
************************************************************************
*                                                                      *
      End Do ! iiJ
         iOff_A = iOff_A + NumCho(iSym)**2
      End Do ! iSym
*
      Call GetMem('MP2Density','Free','Real',ip_MP2Density,lRecDens)
      iSym = 1
*                                                                      *
************************************************************************
*                                                                      *
*     Add nonseparable coulombic terms to A matrix
*     --------------------------------------------
*
*     -4 W_MJ x W_MK    (don't ask me why the code say 8!)
*
*     Second term RHS Eq. 36, note the different order of the indecies.
*
      iOff_A2 = 0
      Do iSym = 1, nSym
         iOff1 = iOff_WJL(iSym)
         Fact=-8.0D0
      Call dGemm_('T','N', NumCho(iSym),NumCho(iSym),nMP2Vec(iSym),
     &            Fact ,Work(ip_WJL+iOff1), nMP2Vec(iSym),!-2
     &                  Work(ip_WJL+iOff1), nMP2Vec(iSym),
     &            0.0d0,Work(ip_A2+iOff_A2),NumCho(iSym))
*
         iOff_A2 = iOff_A2 + NumCho(iSym)**2
      End Do
*
      iSym = 1
*                                                                      *
************************************************************************
*                                                                      *
*     Start loop over batches of L
*
***** Nonseparable exchange, third loop, transformation and
*
      iOff_A = 0
      Do iSym = 1, nSym
      Do iiJ = 1, NumCho(iSym), nVec
         nJ = Min(nVec,NumCho(iSym)-(iiJ-1))
*
         lTot = nLRb(iSym)*nJ
         iAdr = iAdrB(iSym) + nlRb(iSym)*(iiJ-1)
         Call dDaFile(LuBTmp,iRd,Work(ip_B3kl_s),lTot,iAdr)
*
         Do iiK = 1, NumCho(iSym), nVec
            nK = Min(nVec,NumCho(iSym)-(iiK-1))
*
            lTot = nLRb(iSym)*nK
            iAdr = iAdrB(iSym) + nLRb(iSym)*(iiK-1)
            Call dDaFile(LuLVec,iRd,Work(ip_Cmn),lTot,iAdr)
*
*           B_nm^L x C_nm^K
*
*           This is the second term of the RHS of Eq. (41)
*
            iOffA = iiJ-1 + (iiK-1)*NumCho(iSym) + iOff_A
            Fact = 1.0D0
            Call dGemm_('T', 'N', nJ, nK, nLRb(iSym),
     &                 Fact ,Work(ip_B3kl_s),nLRb(iSym),
     &                       Work(ip_Cmn), nLRb(iSym),
     &                 1.0d0,Work(ip_A1+iOffA),NumCho(iSym))
*
         End Do
*
      End Do
         iOff_A = iOff_A + NumCho(iSym)**2
      End Do ! iSym
*                                                                      *
************************************************************************
*                                                                      *
*     Write the Coulomic and Exchange contributions to the 2-center
*     integrals to disk. These terms could be merged to just one.
*
      iAdr1 = 1
      iAdr2 = 1
      iOff  = 0
      Do iSym = 1, nSym
         lTot = NumCho(iSym)*NumCho(iSym)
         Call dDaFile(LuA(1),iWr,Work(ip_A1+iOff),lTot,iAdr1)
         Call dDaFile(LuA(2),iWr,Work(ip_A2+iOff),lTot,iAdr2)
         iOff = iOff + lTot
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Close some files
*
      Call DaClos(LuXVec)
      Call DaClos(LuYVec)
      Call DaClos(LuRVec)
      Call DaClos(LuLVec)
      Call DaClos(LuBTmp)
      Do i = 1,2
         Call DaClos(LuA(i))
         Call DaClos(LuB(i))
      End Do
*
      iClos = 2
      Do iSym = 1, nSym
         Call ChoMP2_OpenF(iClos,iTypR,iSym)
         Call ChoMP2_OpenF(iClos,iTypL,iSym)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Deallocate memory
*
      Call GetMem('Cmn','Free','Real',ip_Cmn, lCmn)
*
      Call GetMem('Rmn','Free','Real',ip_Rmn, lRmn)
*
      Call GetMem('Ukn','Free','Real',ip_Ukn, lUkn)
      Call GetMem('Vkn','Free','Real',ip_Vkn, lVkn)
*
      Call GetMem('B1kl','Free','Real',ip_B1kl, lB2kl)
      Call GetMem('A1','Free','Real',ip_A1, lA1)
      Call GetMem('B2kl','Free','Real',ip_B2kl, lB2kl)
      Call GetMem('A2','Free','Real',ip_A2, lA2)
      Call GetMem('B3kl','Free','Real',ip_B3kl, lB3kl)
      Call GetMem('B3kl_s','Free','Real',ip_B3kl_s, lB3kl_s)
      Call GetMem('WmjKJ','Free','Real',ip_WmjKJ, lWmjKJ)
      Call GetMem('WJL','Free','Real',ip_WJL, lWJL)
*                                                                      *
************************************************************************
*                                                                      *
      Call GetMem('CMO_v  ','Free','Real',ip_CMO_v  ,nVirBas)
      Call GetMem('CMO_o  ','Free','Real',ip_CMO_o  ,nOccBas)
      Call GetMem('CMO_inv','Free','Real',ip_CMO_inv,nOrbBas)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!***********************************************************************
! Please inform me of any bugs at nike@hpqc.org or ndattani@uwaterloo.ca
!***********************************************************************
subroutine PLYINTRP(XI,YI,NPT,RR,C,NCFT,IDER)
!* From the NPT known mesh points (XI,YI), given in order of increasing
!  or decreasing XI(I), select the NCFT points (XJ,YJ) surrounding the
!  given point RR, and by fitting an (NCFT-1)-th degree polynomial through
!  them, interpolate to find the function CC(1) and its first IDER
!  derivatives (CC(I+1),I=1,IDER) evaluated at RR.
!* Adapted by  R.J. Le Roy  from algorithm #416,Comm.A.C.M.;  27/02/1988
!=======================================================================

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NPT, NCFT
real(kind=wp), intent(in) :: XI(NPT), YI(NPT), RR
real(kind=wp), intent(out) :: C(NCFT)
integer(kind=iwp), intent(out) :: IDER
integer(kind=iwp) :: I, I1, I2, IFC, IM, J, K, NH
real(kind=wp) :: XJ(20), XX, YJ(20)

IM = 0
if ((NCFT > 20) .or. (NCFT > NPT)) then
  write(u6,601) NCFT,NCFT,NPT
  !stop
  call ABEND()
end if
NH = NCFT/2
! First locate the known mesh points (XJ,YJ) bracketing RR
I1 = 1
I2 = NCFT
if (NCFT /= NPT) then
  if (XI(NPT) <= XI(1)) then
    do I=1,NPT
      IM = I
      if (XI(I) < RR) exit
    end do
  else
    do I=1,NPT
      IM = I
      if (XI(I) > RR) exit
    end do
  end if
  I1 = IM-NH
  if (I1 <= 0) I1 = 1
  I2 = I1+NCFT-1
  if (I2 > NPT) then
    I2 = NPT
    I1 = I2-NCFT+1
  end if
end if
XJ(1:I2-I1+1) = XI(I1:I2)-RR
YJ(1:I2-I1+1) = YI(I1:I2)
! Now determine polynomial coefficients C(I).
do I=2,NCFT
  I1 = I-1
  K = I1+1
  do J=1,I1
    K = K-1
    YJ(K) = (YJ(K+1)-YJ(K))/(XJ(I)-XJ(K))
  end do
end do
C(1) = YJ(1)
do I=2,NCFT
  XX = XJ(I)
  C(I) = C(I-1)
  if (I /= 2) then
    I1 = I-1
    K = I1+1
    do J=2,I1
      K = K-1
      C(K) = -XX*C(K)+C(K-1)
    end do
  end if
  C(1) = YJ(I)-XX*C(1)
end do
! Finally, convert polynomial coefficients to derivatives at RR.
IFC = 1
if (IDER >= NCFT) IDER = NCFT-1
if (IDER > 1) then
  do I=2,IDER
    J = I+1
    IFC = IFC*I
    C(J) = C(J)*IFC
  end do
  C(J+1:NCFT) = Zero
end if

return

601 format(/' *** Dimensioning ERROR in PLYINTRP :  either   (NCFT=',I2,' > 20)   or   (NCFT=',I2,' > NPT=',I3,')')

end subroutine PLYINTRP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

subroutine MemRg1(iAnga,nRys,MemPrm)
!***********************************************************************
! This routine will compute the memory requirement of Rysg1            *
! Memory requirement is per primitive!                                 *
!                                                                      *
! Modified to gradients 1991 R. Lindh, Dept. of Theoretical Chemistry, *
! University of Lund.                                                  *
!***********************************************************************

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: iAnga(4)
integer(kind=iwp), intent(out) :: nRys, MemPrm
integer(kind=iwp) :: la, lb, lB00, lB01, lB10, lc, ld, n2D0, n2D1, nabcd, nabMax, ncdMax

!iRout = 13
!iPrint = nPrint(iRout)
la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)
nRys = (la+lb+lc+ld+2+1)/2

MemPrm = 0
!nPAO = nTri_Elem1(la)*nTri_Elem1(lb)*nTri_Elem1(lc)*nTri_Elem1(ld)
! 1st order gradient of [ab|cd]
!MemPrm = MemPrm+nPAO*9
nabMax = la+lb+1
ncdMax = lc+ld+1
nabcd = (nabMax+1)*(ncdMax+1)
lB10 = max(min(nabMax-1,1),0)
lB01 = max(min(ncdMax-1,1),0)
lB00 = max(min(min(nabMax,ncdMax),1),0)
! 2D-Integrals
n2D0 = max(nabcd,(la+2)*(lb+2)*(ncdMax+1),(la+2)*(lb+2)*(lc+2)*(ld+2))
MemPrm = MemPrm+3*nRys*n2D0
! 1st order gradient of the 2D-integrals
n2D1 = max(nabcd,(la+2)*(lb+2)*(ncdMax+1),(la+1)*(lb+1)*(lc+1)*(ld+1)*3)
MemPrm = MemPrm+3*nRys*n2D1
! Coefficients for recurrence relations
MemPrm = MemPrm+3*nRys+3*nRys+3*nRys*(lB10+lB01+lB00)
! Roots
MemPrm = MemPrm+nRys
! The inverse of the arguments
MemPrm = MemPrm+1
! Arguments
MemPrm = MemPrm+1
! Expanded versions of Zeta, ZetInv, Eta, EtaInv, P and Q
MemPrm = MemPrm+10
!if (iPrint >= 99) then
!  write(u6,*) ' [ab|cd] 1st grad.   :',nPAO*9
!  write(u6,*) ' 2D-integrals        :',n2D0*3*nRys
!  write(u6,*) ' 2D-integrals (1st)  :',n2D1*3*nRys
!  write(u6,*) ' PAQP vector         :',3*nRys
!  write(u6,*) ' QCPQ vector         :',3*nRys
!  write(u6,*) ' B10 coefficients    :',nRys*3*lB10
!  write(u6,*) ' B00 coefficients    :',nRys*3*lB00
!  write(u6,*) ' B01 coefficients    :',nRys*3*lB01
!  write(u6,*) ' Roots               :',nRys
!  write(u6,*) ' Inverse arguments   :',1
!  write(u6,*) ' Arguments           :',1
!end if

return

end subroutine MemRg1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine rdToc(Lu)

use RunFile_data, only: icRd, lw, nToc, RunHdr, Toc
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: Lu
integer(kind=iwp) :: iDisk
integer(kind=iwp), allocatable :: Tmp(:)
character(len=lw), allocatable :: TmpLab(:)

! Prevent the compiler from creating temporary arrays
! (this means we have to create them ourselves, though)

call mma_allocate(Tmp,nToc,label='Tmp')
call mma_allocate(TmpLab,nToc,label='TmpLab')

iDisk = RunHdr%DaLab
call cDaFile(Lu,icRd,TmpLab,lw*nToc,iDisk)
Toc(:)%Lab = TmpLab(:)

iDisk = RunHdr%DaPtr
call iDaFile(Lu,icRd,Tmp,nToc,iDisk)
Toc(:)%Ptr = Tmp(:)

iDisk = RunHdr%DaLen
call iDaFile(Lu,icRd,Tmp,nToc,iDisk)
Toc(:)%Len = Tmp(:)

iDisk = RunHdr%DaMaxLen
call iDaFile(Lu,icRd,Tmp,nToc,iDisk)
Toc(:)%MaxLen = Tmp(:)

iDisk = RunHdr%DaTyp
call iDaFile(Lu,icRd,Tmp,nToc,iDisk)
Toc(:)%Typ = Tmp(:)

call mma_deallocate(Tmp)
call mma_deallocate(TmpLab)

end subroutine rdToc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine vb2cic_cvb(cvbdet,civec)
c  *********************************************************************
c  *                                                                   *
c  *  VB2CI[CFG] := VB to CASSCF transformation.                       *
c  *  CI2VB[CFG] := CASSCF to VB transformation.                       *
c  *  VB2CIAF    := Adds first-order term in CVBDET to CAS CI vector.  *
c  *                                                                   *
c  *  Transformation between VB vector and CASSCF vector (both defined *
c  *  in determinant basis).                                           *
c  *                                                                   *
c  *  Normally a simple indexed copy of the coefficients is all that   *
c  *  is required. For direct-product wavefunctions, however, a        *
c  *  partial contraction is also carried out (relevant for first-     *
c  *  order changes and gradient back transformation).                 *
c  *                                                                   *
c  *  [C] : Transforms coefficients.                                   *
c  *  [F] : Transforms a first-order change of the coefficients.       *
c  *  [G] : Transforms a gradient-type quantity.                       *
c  *                                                                   *
c  *********************************************************************
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvbdet(ndetvb),civec(*)

      icivec=nint(civec(1))
      ic=0

      if(iform_ci(icivec).ne.0)then
        write(6,*)' Unsupported format in VB2CI :',iform_ci(icivec)
        call abend_cvb()
      endif
      if(nfrag.le.1)then
        call ci2vb2_cvb(work(iaddr_ci(icivec)),cvbdet,
     >    iwork(ll(11)),iwork(ll(12)),dum,1)
      else
        call dpci2vb_cvb(work(iaddr_ci(icivec)),cvbdet,work(lv(5)),ic,
     >                   dum,1)
      endif
      call setcnt2_cvb(icivec,0)
      return
      end

      subroutine vb2cif_cvb(cvbdet,civec)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvbdet(ndetvb),civec(*)

      icivec=nint(civec(1))
      ic=1

      if(iform_ci(icivec).ne.0)then
        write(6,*)' Unsupported format in VB2CI :',iform_ci(icivec)
        call abend_cvb()
      endif
      if(nfrag.le.1)then
        call ci2vb2_cvb(work(iaddr_ci(icivec)),cvbdet,
     >    iwork(ll(11)),iwork(ll(12)),dum,1)
      else
        call dpci2vb_cvb(work(iaddr_ci(icivec)),cvbdet,work(lv(5)),ic,
     >                   dum,1)
      endif
      call setcnt2_cvb(icivec,0)
      return
      end


      subroutine ci2vbc_cvb(civec,cvbdet)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvbdet(ndetvb),civec(*)
      icivec=nint(civec(1))
      ic=0

      if(iform_ci(icivec).ne.0)then
        write(6,*)' Unsupported format in CI2VB :',iform_ci(icivec)
        call abend_cvb()
      endif
      if(nfrag.le.1)then
        call ci2vb2_cvb(work(iaddr_ci(icivec)),cvbdet,
     >    iwork(ll(11)),iwork(ll(12)),dum,0)
      else
        call dpci2vb_cvb(work(iaddr_ci(icivec)),cvbdet,work(lv(5)),ic,
     >                   dum,0)
      endif
      return
      end



      subroutine ci2vbg_cvb(civec,cvbdet)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvbdet(ndetvb),civec(*)
      icivec=nint(civec(1))
      ic=2

      if(iform_ci(icivec).ne.0)then
        write(6,*)' Unsupported format in CI2VB :',iform_ci(icivec)
        call abend_cvb()
      endif
      if(nfrag.le.1)then
        call ci2vb2_cvb(work(iaddr_ci(icivec)),cvbdet,
     >    iwork(ll(11)),iwork(ll(12)),dum,0)
      else
        call dpci2vb_cvb(work(iaddr_ci(icivec)),cvbdet,work(lv(5)),ic,
     >                   dum,0)
      endif
      return
      end

      subroutine vb2ciaf_cvb(cvbdet,civec)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvbdet(ndetvb),civec(*)
      icivec=nint(civec(1))
      if(iform_ci(icivec).ne.0)then
        write(6,*)' Unsupported format in VB2CIP :',iform_ci(icivec)
        call abend_cvb()
      endif
      if(nfrag.le.1)then
        call ci2vb2_cvb(work(iaddr_ci(icivec)),cvbdet,
     >    iwork(ll(11)),iwork(ll(12)),dum,2)
      else
        call dpci2vb_cvb(work(iaddr_ci(icivec)),cvbdet,work(lv(5)),1,
     >                   dum,2)
      endif
      call setcnt2_cvb(icivec,0)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2007, Roland Lindh                                *
************************************************************************
      SubRoutine PGet2_CD2(iCmp,iBas,jBas,kBas,lBas,
     &                     Shijij, iAO, iAOst, nijkl,PSO,nPSO,
     &                     ExFac,CoulFac,PMax,V_k,mV_k)
************************************************************************
*  Object: to assemble the 2nd order density matrix of a SCF wave      *
*          function from the 1st order density matrix.                 *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*                                                                      *
*             Modified for Cholesky 1-center gradients May 2007 by     *
*             R. Lindh                                                 *
************************************************************************
      use Basis_Info, only: nBas
      use SOAO_Info, only: iAOtSO
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 PSO(nijkl,nPSO), V_K(mV_K)
      Integer iCmp(4), iAO(4), iAOst(4)
      Logical Shijij
*     Local Array
      Integer iSym(0:7), jSym(0:7), kSym(0:7), lSym(0:7)
      Integer iTwoj(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      iRout = 39
      iPrint = nPrint(iRout)
      iPrint=99
      Call RecPrt('V_K',' ',V_K,1,mV_K)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      lOper=1
      PMax=Zero
*
*-----Quadruple loop over elements of the basis functions angular
*     description.
*     Observe that we will walk through the memory in AOInt in a
*     sequential way.
*
C     Fac = One/Four
      Fac = One
      MemSO2 = 0
      Do 100 i1 = 1, iCmp(1)
         niSym = 0
         Do 101 j = 0, nIrrep-1
            If (iAOtSO(iAO(1)+i1,j)>0) Then
               iSym(niSym) = j
               niSym = niSym + 1
            End if
101      Continue
         Do 200 i2 = 1, iCmp(2)
            njSym = 0
            Do 201 j = 0, nIrrep-1
               If (iAOtSO(iAO(2)+i2,j)>0) Then
                  jSym(njSym) = j
                  njSym = njSym + 1
               End If
201         Continue
            Do 300 i3 = 1, iCmp(3)
               nkSym = 0
               Do 301 j = 0, nIrrep-1
                  If (iAOtSO(iAO(3)+i3,j)>0) Then
                     kSym(nkSym) = j
                     nkSym = nkSym + 1
                  End If
301            Continue
               Do 400 i4 = 1, iCmp(4)
                  nlSym = 0
                  Do 401 j = 0, nIrrep-1
                     If (iAOtSO(iAO(4)+i4,j)>0) Then
                        lSym(nlSym) = j
                        nlSym = nlSym + 1
                     End If
401               Continue
*
*------Loop over irreps which are spanned by the basis function.
*
       Do 110 is = 0, niSym-1
          j1 = iSym(is)
*
          Do 210 js = 0, njSym-1
             j2 = jSym(js)
             j12 = iEor(j1,j2)
*
             Do 310 ks = 0, nkSym-1
                j3 = kSym(ks)
                j123 = iEor(j12,j3)
                Do 410 ls = 0, nlSym-1
                   j4 = lSym(ls)
                   If (j123.ne.j4) Go To 410
*
                MemSO2 = MemSO2 + 1
*
*               Unfold the way the eight indicies have been reordered.
                iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)
                jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
                kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)
                lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
*
                If (j1.ne.j2 .and. j1.ne.j3 .and. j1.ne.j4) Then
*------------------all irreps are different and the 2nd order density
*                  matrix will be identical to zero for a SCF type wave
*                  function.
                   call dcopy_(nijkl,[Zero],0,PSO(1,MemSO2),1)
                   Go To 310
                End If
*
                mijkl = 0
                Do 120 lAOl = 0, lBas-1
                   lSOl = lSO + lAOl
                   Do 220 kAOk = 0, kBas-1
                      kSOk = kSO + kAOk
                      Do 320 jAOj = 0, jBas-1
                         jSOj = jSO + jAOj
                         Do 420 iAOi = 0, iBas-1
                            iSOi = iSO + iAOi
                            mijkl = mijkl + 1
*
*---------------------------Contribution V_k(ij)*V_k(kl) to P(ijkl)
                            If (j1.eq.j2) Then
*------------------------------j3.eq.j4 also
                               Indi=Max(iSOi,jSOj)
                               Indj=iSOi+jSOj-Indi
                               Indk=Max(kSOk,lSOl)
                               Indl=kSOk+lSOl-Indk
                               iPntij=iPntSO(j1,j2,lOper,nbas)
                               iPntkl=iPntSO(j3,j4,lOper,nbas)
                               Indij=iPntij+(Indi-1)*Indi/2+Indj
                               Indkl=iPntkl+(Indk-1)*Indk/2+Indl
                               temp=V_k(Indij)*V_k(Indkl)*Coulfac
                            Else
                               temp = Zero
                            End If
*
*---------------------------Contribution -1/4*D(ik)*D(jl) to P(ijkl)
C                           If (j1.eq.j3) Then
*------------------------------j2.eq.j4 also
C                           End If
*
*---------------------------Contribution -1/4*D(il)*D(jk) to P(ijkl)
C                           If (j1.eq.j4) Then
*------------------------------j2.eq.j3 also
C                           End If
*
                            PMax=Max(PMax,Abs(Temp))
                            PSO(mijkl,MemSO2) =  Fac * temp
*
 420                     Continue
 320                  Continue
 220               Continue
 120            Continue
*
 410            Continue
 310         Continue
 210      Continue
 110   Continue
*
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
      If (nPSO.ne.MemSO2) Then
        Write (6,*) ' PGet2_CD2: nPSO.ne.MemSO2'
        Write (6,*) nPSO, MemSO2
        Call Abend
      End If
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' In PGet2_CD2:PSO ',' ',PSO,nijkl,nPSO)
      End If
      Call GetMem(' Exit PGet2_CD2','CHECK','REAL',iDum,iDum)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Shijij)
         Call Unused_real(ExFac)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine orthcvb_cvb(c,nparm1)

use casvb_global, only: cvb, cvbnrm, cvbnrm_fr, nfrag, nprvb, nvb_fr
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: c(*)
integer(kind=iwp), intent(in) :: nparm1
integer(kind=iwp) :: ifr_off, ifrag, ioff2, ioffs, nprvb2
real(kind=wp) :: f
real(kind=wp), external :: ddot_

ioffs = nparm1-nprvb
if (nfrag <= 1) then
  f = ddot_(nprvb,cvb(1:nprvb),1,c(ioffs+1:ioffs+nprvb),1)/cvbnrm
  c(ioffs+1:ioffs+nprvb) = c(ioffs+1:ioffs+nprvb)-f*cvb(1:nprvb)
else
  ifr_off = 0
  do ifrag=1,nfrag
    nprvb2 = nvb_fr(ifrag)
    ioff2 = ifr_off+ioffs
    f = ddot_(nprvb2,cvb(ifr_off+1:ifr_off+nprvb2),1,c(ioff2+1:ioff2+nprvb2),1)/cvbnrm_fr(ifrag)
    c(ioff2+1:ioff2+nprvb2) = c(ioff2+1:ioff2+nprvb2)-f*cvb(ifr_off+1:ifr_off+nprvb2)
    ifr_off = ifr_off+nprvb2
  end do
end if

return

end subroutine orthcvb_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE PKVEC(NITEM,CVEC,ICVEC)
C***********************************************************************
C
C     PURPOSE:
C     ENCODE THE CI-VECTOR BY CHANGING THE NUMBER REPRESENTATION FROM
C     REAL*8 ==> INTEGER*4
C
C     NOTE:
C     THE INCOMING DATA CVEC SHOULD NOT BE GREATER THAN 1.0.
C     THE ACCURACY OF THE UNPACKED VALUES IS APPROX. 1.0E-9.
C
C**** M.P. FUELSCHER, UNIVERSITY OF LUND, SWEDEN, NOV. 1990 ************
C
      IMPLICIT REAL*8 (A-H,O-Z)
* NOTE VERY CAREFULLY!! NINT() (and maybe similar) intrinsics
* are BROKEN in CYGWIN GFORTAN!!
* So the intermediate variable tmp is necessary for it to work!
#ifdef _CYGWIN_
      REAL*4 tmp
#endif
      DIMENSION CVEC(NITEM),ICVEC(NITEM)
      PARAMETER (SCALE=2147483647.0D0)
      INTRINSIC NINT
C
      DO 10 ITEM=1,NITEM
#ifdef _CYGWIN_
         tmp=SCALE*CVEC(ITEM)
         ICVEC(ITEM)=NINT(tmp)
#else
        ICVEC(ITEM)=NINT(SCALE*CVEC(ITEM))
#endif
10    CONTINUE
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      FUNCTION GTIJKL_MCLR(I,J,K,L)
      use Arrays, only: Int2
*
* Obtain  integral (I J ! K L )
* where I,J,K and l refers to active orbitals in type ordering
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "detdim.fh"
#include "Input.fh"
#include "orbinp_mclr.fh"
#include "crun_mclr.fh"
#include "Pointers.fh"

      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

      IABS = IREOTS(I)
*
      JABS = IREOTS(J)
*
      KABS = IREOTS(K)
*
      LABS = IREOTS(L)
*
      IJ=itri(iABS,JABS)
      KL=itri(kABS,lABS)

      GTIJKL_MCLR = INT2(itri(IJ,KL))
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1993,1998, Roland Lindh                           *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Cmpct(abcd,na,nb,nijkl,mijkl,Zeta,Kappab,P,Ind_Pair,Con,xZeta,xKapp,xP,IndZ,iOff,Jnd,xZInv,AeqB,xab,xabCon,Alpha, &
                 xAlpha,Beta,xBeta)
!***********************************************************************
!                                                                      *
! Object: to find the largest value of the integrals which will be     *
!         generated by an exponent combination. This information will  *
!         be used to prescreen the data.                               *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             June '91                                                 *
!             Modified for direct SCF, January '93                     *
!                                                                      *
!             Modified for k2 prescreening, June '98                   *
!***********************************************************************

use Gateway_Info, only: cdMax, CutInt, lSchw, RadMax
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: na, nb, nijkl, mijkl, Ind_Pair(mijkl), iOff
real(kind=wp), intent(in) :: abcd(mijkl,na,nb,na,nb), Zeta(mijkl), KappAB(mijkl), P(nijkl,3), Con(nijkl), Alpha(mijkl), Beta(mijkl)
real(kind=wp), intent(inout) :: xZeta(nijkl), xKapp(nijkl), xP(nijkl,3), xZInv(nijkl), xab(nijkl), xabCon(nijkl), xAlpha(nijkl), &
                                xBeta(nijkl)
integer(kind=iwp), intent(inout) :: IndZ(nijkl+1), Jnd
logical(kind=iwp), intent(in) :: AeqB
integer(kind=iwp) :: ia, ib, ijkl, ijkl_
real(kind=wp) :: abConMax, abMax, Check

#include "compiler_features.h"

#ifdef _DEBUGPRINT_
write(u6,*) ' In Cmpct'
write(u6,*) AeqB,iOff,Jnd
call RecPrt('Cmpct:Zeta',' ',Zeta,mijkl,1)
call RecPrt('Cmpct:KappAB',' ',KappAB,mijkl,1)
call RecPrt('Cmpct:abcd',' ',abcd,mijkl,(na*nb)**2)
#endif

! Move data

if (AeqB) then
  IndZ(iOff+1:iOff+mijkl) = Ind_Pair(:)
  xZeta(iOff+1:iOff+mijkl) = Zeta(:)
  xKapp(iOff+1:iOff+mijkl) = KappAB(:)
  xP(iOff+1:iOff+mijkl,:) = P(1:mijkl,:)
  xAlpha(iOff+1:iOff+mijkl) = Alpha(:)
  xBeta(iOff+1:iOff+mijkl) = Beta(:)
  do ijkl=1,mijkl
    ijkl_ = Ind_Pair(ijkl)
    xZInv(iOff+ijkl) = One/Zeta(ijkl)

    abMax = Zero
    do ia=1,na
      do ib=1,nb
#       ifdef _BUGGY_INTEL_OPTIM_
        if (Jnd < -1) call Abend()
#       endif
        abMax = max(abMax,abs(abcd(ijkl,ia,ib,ia,ib)))
      end do
    end do
    xab(ijkl+iOff) = sqrt(abMax)
    xabCon(ijkl+iOff) = sqrt(abMax)*Con(ijkl_)
  end do
  Jnd = Jnd+mijkl
else
  do ijkl=1,mijkl
    ijkl_ = Ind_Pair(ijkl)

    ! Select the largest element (over components)
    abMax = Zero
    do ia=1,na
      do ib=1,nb
#       ifdef _BUGGY_INTEL_OPTIM_
        if (Jnd < -1) call Abend()
#       endif
        abMax = max(abMax,abs(abcd(ijkl,ia,ib,ia,ib)))
      end do
    end do
    abMax = sqrt(abMax)
    abConMax = abMax*Con(ijkl_)
    if (lSchw) then
      Check = abConMax*cdMax
    else
      Check = KappAB(ijkl)*Con(ijkl)*RadMax
    end if
    if (Check >= CutInt) then
      Jnd = Jnd+1
      xZeta(Jnd) = Zeta(ijkl)
      xKapp(Jnd) = KappAB(ijkl)
      xP(Jnd,1) = P(ijkl,1)
      xP(Jnd,2) = P(ijkl,2)
      xP(Jnd,3) = P(ijkl,3)
      xZInv(Jnd) = One/Zeta(ijkl)
      IndZ(Jnd) = Ind_Pair(ijkl)
      xab(Jnd) = abMax
      xabCon(Jnd) = abConMax
      xAlpha(Jnd) = Alpha(ijkl)
      xBeta(Jnd) = Beta(ijkl)
    end if
  end do
end if
IndZ(nijkl+1) = Jnd

#ifdef _DEBUGPRINT_
write(u6,*) 'AeqB=',AeqB
write(u6,*) 'IndZ=',IndZ
call RecPrt('xZeta ',' ',xZeta,1,Jnd)
call RecPrt('xKapp ',' ',xKapp,1,Jnd)
call RecPrt('xP(x) ',' ',xP(1,1),1,Jnd)
call RecPrt('xP(y) ',' ',xP(1,2),1,Jnd)
call RecPrt('xP(z) ',' ',xP(1,3),1,Jnd)
call RecPrt('xZInv ',' ',xZInv,1,Jnd)
call RecPrt('xab   ',' ',xab,1,Jnd)
call RecPrt('xabCon',' ',xabCon,1,Jnd)
call RecPrt('xAlpha',' ',xAlpha,1,Jnd)
call RecPrt('xBeta ',' ',xBeta,1,Jnd)
#endif

end subroutine Cmpct

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996,1997, Anders Bernhardsson                         *
************************************************************************
      SubRoutine Prec(rpre,idsym)
************************************************************************
*
*  idsym, symmetry of orbital hessian of interest
*  CMtx preconditioner
*
*
* The orbital hessian is dominated of elements that couples
*
* kappa  -> kappa      where i is occupied and p,q is general.
*      ip        iq
*
* we therefore approximate the hessian with those diagonal
* terms in the preconditioner
*
*  Anders Bernhardsson 96
*
*     active; active,general is needed for rasscf calculation
*     and is not coded yet (ugly bastard) (970109, AB )
************************************************************************
      use Arrays, only: FAMO, FIMO, F0SQMO
      Implicit Real*8(a-h,o-z)
#include "Pointers.fh"
#include "Input.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "machine.fh"
      Real*8 rpre(*)
*
      Call Prec_internal(rpre)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine Prec_internal(rpre)
      Use Iso_C_Binding
      Real*8, Target :: rpre(*)
      Integer, Pointer :: ipre(:)
      Real*8, Allocatable:: JA(:), KA(:), Scr(:),
     &                      Temp1(:,:), Temp2(:), Temp3(:)
      nmm=0
      nmmm=0
      Do iS=1,nSym
         nMM=Max(nMM,nAsh(is)+nIsh(iS))
         nMMM=Max(nmmM,nBas(is))
      End Do
      n2=nMMM**2
      nmmm=((nmmm-1)/nRec+1)*nRec
      nmm=nmm*nMMM
      nmm=nmm**2

*
      Call mma_allocate(JA,n2,Label='JA')
      Call mma_allocate(KA,n2,Label='KA')
      Call mma_allocate(Scr,n2,Label='Scr')
*
      ip=1
      iAdr=0
      iAdr2=0
      Do iS=1,nSym
         jS=iEOr(is-1,iDSym-1)+1
         nD=nOrb(js)-nIsh(jS)
         ni=nBas(js)**2
         sign=1.0d0
         Call mma_allocate(Temp2,ni,Label='Temp2')
         Call mma_allocate(Temp3,ni,Label='Temp3')
         Temp3(:)=0.0D0
         Call mma_MaxDBLE(nTemp)
         nTemp=Min(nmm,nTemp/2)
         Call mma_allocate(Temp1,nTemp,2,Label='Temp1')
         If (nd.eq.0) Goto 100
         Do iB=1,nIsh(iS)
            call dcopy_(nD**2,[0.0d0],0,Temp3,1)
            ibb=nOrb(is)*(ib-1)+ib-2
*                                                                      *
************************************************************************
*                                                                      *
            Select Case (NewCho)
*                                                                      *
************************************************************************
*                                                                      *
            Case (.TRUE.)   ! Cho-Fock
*                                                                      *
************************************************************************
*                                                                      *
              Call preci_cho(ib,is,jS,nD,Temp3,
     &                       nOrb(is),nOrb(js),
     &                       FIMO(1+ipCM(is)+ibb),
     &                       FAMO(1+ipCM(is)+ibb),
     &                       F0sqMO(1+ipCM(is)+ibb),
     &                       FIMO(ipCM(js)),
     &                       FAMO(ipCM(js)),
     &                       F0sqMO(ipCM(js)),sign,
     &                       JA,KA,Scr,n2,
     &                       iAdr) ! OK

*                                                                      *
************************************************************************
*                                                                      *
            Case (.FALSE.)  ! Cho-MO
*                                                                      *
************************************************************************
*                                                                      *
            If (iMethod.eq.2) Then
*                                                                      *
************************************************************************
*                                                                      *
*              G
*               iaib
*
               If (nash(js).gt.0)
     &            Call Preciaa(ib,is,js,nd,Temp3,
     &                         nOrb(is),nOrb(js),
     &                         FIMO(1+ipCM(is)+ibb),
     &                         FAMO(1+ipCM(is)+ibb),
     &                         F0sqMO(1+ipCM(is)+ibb),
     &                         FIMO(ipCM(js)),
     &                         FAMO(ipCM(js)),
     &                         F0sqMO(ipCM(js)),sign,
     &                         JA,KA,Scr,n2) ! OK
*                                                                      *
************************************************************************
*                                                                      *
*              G
*               ipia
*
               If ((nOrb(js)-nish(js)-nash(js))*nash(js).gt.0)
     &            Call Preciba(ib,is,js,nd,Temp3,nOrb(js),
     &                         FIMO(ipCM(js)),
     &                         FAMO(ipCM(js)),
     &                         F0sqMO(ipCM(js)),sign,
     &                         JA,KA,Scr,n2) ! OK
*
            End If
*                                                                      *
************************************************************************
*                                                                      *
*           G
*            ipiq
*
            If ((nOrb(js)-nish(js)-nash(js)) .gt.0)
     &         Call Precibb(ib,is,js,nd,Temp3,
     &                      nbas(js),norb(js),
     &                      Temp1(:,1),Temp1(:,2),Temp2,
     &                      FiMo(1+ipCM(is)+ibb),
     &                      FAMO(1+ipcm(is)+ibb),  ! OK
     &                      FiMo(ipCM(js)),
     &                      FAMO(ipcm(js)),sign)  ! OK
*                                                                      *
************************************************************************
*                                                                      *
            End Select
*                                                                      *
************************************************************************
*                                                                      *
*           Factorize G:
*
*               T
*           G=LL
*
*            write(6,*) 'Preconditioner i =',iB
*            Do i=1,min(nd,10)
*             write(6,'(10F12.8)') (Temp3(1+(j-1)*(2*nd-j+2)/2+i-j),
*     &                             j=1,i)
*            End Do

            Call SQM(Temp3,rpre(ip),nd)

!            write(*,*)" ====== rpre ====== "
!            do i=1,nd*nd
!              write(*,*)i,"rpre",rpre(ip+i-1)
!            end do

            irc=0
            call c_f_pointer(c_loc(rpre(ip+nd**2)),ipre,[nd])
            call dgetrf_(nd,nd,rpre(ip),nd,ipre,irc)
            nullify(ipre)
            If (irc.ne.0) then
               Write(6,*) 'Error in DGETRF called from prec'
               Call Abend
            End If
            ip=ip+nD*(nd+1)
*
         End Do

 100     Continue
*                                                                      *
************************************************************************
*                                                                      *
         Do iB=1,nAsh(iS)
            ibb=nOrb(is)*(nish(is)+ib-1)+nish(is)+ib-2
            If (ib.le.nRs1(iS)+nRs2(is)+nRs3(is)) iR=3
            If (ib.le.nRs1(iS)+nRs2(is)) iR=2
            If (ib.le.nRs1(iS)) iR=1
            If (ir.eq.1) nD=nOrb(js)-nRs1(js)
            If (ir.eq.2) nD=nOrb(js)-nRs2(js)
            If (ir.eq.3) nD=nOrb(js)-nRs3(js)
            If (nd.eq.0) Goto 110
            call dcopy_(nD**2,[0.0d0],0,Temp3,1)
*
**  New Cholesky code
*
*                                                                      *
************************************************************************
*                                                                      *
            Select Case (newCho)
*                                                                      *
************************************************************************
*                                                                      *
            Case (.TRUE.)
*                                                                      *
************************************************************************
*                                                                      *
               Call Preca_cho(ib,is,js,nd,ir,Temp3,
     &                        nOrb(is),nOrb(js),
     &                        FIMO(1+ipCM(is)+ibb),
     &                        FAMO(1+ipCM(is)+ibb),
     &                        F0SqMO(1+ipCM(is)+ibb),
     &                        FIMO(ipCM(js)),
     &                        FAMO(ipCM(js)),
     &                        F0SqMO(ipCM(js)),sign,
     &                        JA,KA,Scr,n2,
     &                        iAdr2)
*                                                                      *
************************************************************************
*                                                                      *
            Case (.False.)
*                                                                      *
************************************************************************
*                                                                      *
            If (nish(js).gt.0)
     &         Call Precaii(ib,is,js,nd,ir,Temp3,
     &                      nOrb(is),nOrb(js),
     &                      FIMO(1+ipCM(is)+ibb),
     &                      FAMO(1+ipCM(is)+ibb),
     &                      F0SqMO(1+ipCM(is)+ibb),
     &                      FIMO(ipCM(js)),
     &                      FAMO(ipCM(js)),
     &                      F0SqMO(ipCM(js)),sign,
     &                      JA,KA,Scr,n2) ! OK
*           Call Precaai(ib,nd,ir,rpre(ip))
*           Call Precaaa(ib,nd,ir,rpre(ip))
            If (nish(js)*nOrb(js).gt.0)
     &         Call Precabi(ib,is,js,ir,nd,Temp3,nOrb(js),
     &                      FIMO(ipCM(js)),
     &                      FAMO(ipCM(js)),
     &                      F0SQMO(ipCM(js)),sign,
     &                      JA,KA,Temp1(:,2),n2) !+/-?
*           Call Precaba(ib,nd,ir,rpre(ip))
            If (nOrb(js).gt.0)
     &            Call Precabb_2(ib,is,js,nd,nbas(js),nOrb(js),
     &                           Temp3,
     &                           Temp1(:,1),ntemp,Temp1(:,2),
     &                           Temp2,
     &                           F0SQMO(1+ipCM(is)+ibb),
     &                           FiMo(ipCM(js)),
     &                           FAMO(ipcm(js)) ,
     &                           F0SQMO(ipCM(js)),sign)
*
*                                                                      *
************************************************************************
*                                                                      *
            End Select
*                                                                      *
************************************************************************
*                                                                      *

            Call SQM(Temp3,rpre(ip),nD)
            irc=0
            call c_f_pointer(c_loc(rpre(ip+nd**2)),ipre,[nd])
            call dgetrf_(nd,nd,rpre(ip),nd,ipre,irc)
            nullify(ipre)
            If (irc.ne.0) then
               Write(6,*) 'Error in DGETRF called from prec'
               Call Abend
            End If
            ip=ip+nD*(nd+1)
         End Do
110      Continue
         Call mma_deallocate(Temp1)
         Call mma_deallocate(Temp2)
         Call mma_deallocate(Temp3)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_deallocate(Scr)
      Call mma_deallocate(KA)
      Call mma_deallocate(JA)

*                                                                      *
************************************************************************
*                                                                      *
      Return
      End Subroutine Prec_internal
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Anders Bernhardsson                              *
************************************************************************
      Subroutine h0(rdia,MP1,MP2,MQ,
     &              isym,KH0S,KH0F,KSBIDT,nprciv,
     &               TimeDep)
*
* frontend to jeppes explicit routines
*
      implicit Real*8(a-h,o-z)
#include "detdim.fh"
#include "Pointers.fh"
#include "orbinp_mclr.fh"
#include "cstate_mclr.fh"
#include "crun_mclr.fh"
#include "cicisp_mclr.fh"
#include "spinfo_mclr.fh"
#include "incdia.fh"
#include "WrkSpc.fh"
#include "csfbas_mclr.fh"
#include "negpre.fh"
      Real*8 rdia(*)
      Logical TimeDep
*
      MXP1=MP1
      MXP2=MP2
      MXQ=MQ
      ispc=1
      NDET= nint(XISPSM(ISYM,ISPC))
      IF(NOCSF.EQ.1) THEN
        NVAR=nDET
      ELSE
        NVAR = NCSASM(ISYM)
      END  IF
*
      LBLK=NVAR
      NSBDET = MXP1 + MXP2 + MXQ
      MXP = MXP1 + MXP2
      LH0 = MXP*(MXP+1)/2 + MXP1*MXQ
      MXCSFC = 0
      MXDTFC = 0
      DO  ITYP = 1, NTYP
        MXCSFC = MAX(MXCSFC,NCPCNT(ITYP) )
        MXDTFC = MAX(MXDTFC,NDPCNT(ITYP) )
      End Do

      nactel=naelci(1)+nbelci(1)
      If (TimeDep) Then
         EnA=E2_td(Work(ipFiMo),Work(k2int),0,-1)
      Else
         EnA=E2(Work(ipFiMo),Work(k2int),0,-1)
      End If
      LH0SCR =
     &  MAX(6*NSBDET,4*NSBDET+4*NOCOB,MXP1*(MXP1+1)/2+MXP1**2)
      LVEC2=2 * NACTEL + MXCSFC**2
     &               + 6*MXDTFC+2*MXDTFC**2
     &               + MAX(MXDTFC*NACTEL+2*NACTEL,4*NACOB+2*NACTEL)
      LVEC2=Max(lvec2,ndet)
*
      If (isym.eq.irefsm) then
       ieaw=1
      else
       ieaw=2
      end if
      CALL GetMem('KSBIDT','ALLO','INTE',KSBIDT,NSBDET)
      CALL GetMem('EXPH0S','ALLO','REAL',KH0S,MXP**2)
      CALL GetMem('EXPH0F','ALLO','INTE',KH0F,MXP)
      CALL GetMem('EXPH0','ALLO','REAL',KH0,LH0)
      CALL GetMem('KSBCNF','ALLO','INTE',KSBCNF,NSBDET)
      Call GETMEM('KH0SCR','ALLO','REAL',KH0SCR,LH0SCR)
      iKH0SCR=ip_of_iWork_d(Work(KH0SCR))
      Call GetMem('KVEC2','ALLO','REAL',KVEC2,lvec2)
*
      Call H0MAT_MCLR(Work(KH0),
     &       iWORK(KSBIDT),iWORK(KSBCNF),
     &       MXP1,MXP2,MXQ,NACOB,NPRCIV,
     &       NOCSF,ISYM,IDC,PSSIGN,ECOREP,
     &       rDIA,Work(KVEC2),work(kh0scr),iWork(ikh0scr),ieaw)

*
      do i=1,nprciv
       Work(KH0+i*(i+1)/2-1)=Work(KH0+i*(i+1)/2-1)-ENA
      End Do
      IF (NGP)
     & Call mkp1(nprciv,iWORK(KSBIDT),Work(kh0),rdia)
*     Call Triprt('PRECI',' ',Work(KH0),nprciv)
*     write(*,*) (iWork(KSBIDT+i),i=0,nprciv-1)
      Call GetMem('KVEC2','FREE','REAL',KVEC2,lvec)
      Call GETMEM('KH0SCR','FREE','REAL',KH0SCR,LH0SCR)
      CALL GetMem('KSBCNF','FREE','INTE',KSBCNF,NSBDET)
*     CALL GetMem('KSBIDT','FREE','INTE',KSBIDT,NSBDET)
      call square(Work(KH0),Work(KH0S),1,NPRCIV,NPRCIV)
      CALL GetMem('EXPH0','FREE','REAL',KH0,LH0)
*
cVV: next dummy statement is needed for Intel MKL installation.
      if(KH0S.eq.666) write(6,*) Work(KH0S)
      irc=0
      call dgetrf_(NPRCIV,NPRCIV,Work(KH0S),NPRCIV,
     &            iWork(KH0F),irc)
      If (irc.ne.0) Then
        Write(6,*) 'Sorry but you have an singular ci matrix'
        Write(6,*) 'Set ExpDimension and restart mclr'
        call Abend
      End If
*
*
      Return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT20u(T2,V,oe,dima,dimb,adda,addb,no)
! this routine does:
! T2(a',b',i,j)=(a'i|b'j)/Dija'b'
!  for aGrp/=bGrp
! N.B.2 qvajt odflaknute

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, adda, addb, no
real(kind=wp), intent(out) :: T2(dima,dimb,no,no)
real(kind=wp), intent(in) :: V(dima,no,dimb,no), oe(*)
integer(kind=iwp) :: b, i, j

do j=1,no
  do i=1,no
    do b=1,dimb
      T2(:,b,i,j) = V(:,i,b,j)/(oe(i)+oe(j)-oe(adda+1:adda+dima)-oe(addb+b))
    end do
  end do
end do

return

end subroutine MkT20u

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1987, Bjorn O. Roos                                    *
!***********************************************************************
!--------------------------------------------*
! 1987  B. O. ROOS                           *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND, SWEDEN                 *
!--------------------------------------------*

subroutine tr2NsB(CMO,X1,X2,pqrs,TUrs,lBuf,MAXRS)
! SECOND ORDER TWO-ELECTRON TRANSFORMATION ROUTINE
!
! THIS ROUTINE IS CALLED FOR EACH SYMMETRY BLOCK OF INTEGRALS
! (ISP,ISQ,ISR,ISS) WITH ISP >= ISQ AND ISR >= ISS.
! P,Q,R,S are SO indices.
! A,B are MO indices, counting only non-frozen and non-deleted.
! T,U are occupied MO indices, only non-frozen and non-deleted.
! INTEGRALS (AB/TU) ARE ALWAYS GENERATED
! EXCHANGE INTEGRALS (AT/BU) ARE GENERATED AS FOLLOWS:
! (AT/BU) IF ISP >= ISR
! (AT/UB) IF ISP > ISS AND ISP /= ISQ
! (TA/BU) IF ISQ > ISR AND ISP /= ISQ
! (TA/UB) IF ISQ >= ISS AND ISP /= ISQ
!
! ********** IBM-3090 RELEASE 87 09 14 **********
! Replace MXMA with DGEMM P-AA Malmqvist 1992-05-06.
!
!
! This and tr2NsB routines transform non-squared AO integrals. The
! transformed MO integrals are stored as the same as Tr2Sq
! subroutine does.

use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
#include "rasdim.fh"
#include "caspt2.fh"
real(kind=wp), intent(in) :: CMO(NCMO)
real(kind=wp), intent(_OUT_) :: X1(*), X2(*)
real(kind=wp), intent(inout) :: PQRS(*), TURS(*)
integer(kind=iwp), intent(in) :: lBuf, MAXRS
integer(kind=iwp) :: IAD3, IAD3S, icc, iOpt, IPQ, IPQMX3, IPQST, iRc, IRS, IRSST, ISPQRS, ITU, IX2, Kread, Length, LPQ, LRS, NOTU, &
                     NP, NQ, NR, Nread, Nrest, NRS, NS, NSYMP, NT, NU, Num, NumPQ, NumRS
#include "trafo.fh"
#include "intgrl.fh"

icc = NOCP*NOCQ*NOR*NOS

if (ISP > ISR) then

  NSYMP = NSYM*(NSYM+1)/2
  NOTU = NOCP*NOCQ
  if (ISP == ISQ) NOTU = (NOCP**2+NOCP)/2

  ! SORT OF PARTIALLY TRANSFORMED INTEGRALS (TU/RS) ON UNIT LUHLF3
  IPQMX3 = NBRS
  if (NBRS*NOTU > LTUPQ) then
    IPQMX3 = LTUPQ/NOTU
    !write(u6,*)'OUT OF CORE SORT FOR INTEGRALS (TU/RS)',IPQMX3,nbrs
    IAD3S = 0
    call dDAFILE(LUHLF3,0,TURS,IPQMX3,IAD3S)
  end if
  IAD3 = 0

  ! MaxRS should be given
  IRS = 0
  LRS = 0
  NRS = 0
  Kread = 0
  Nread = NBRS/MaxRS
  Nrest = mod(NBRS,MaxRS)
  if (Nrest == 0) then
    Nrest = MaxRS
  else
    Nread = Nread+1
  end if

  if (icc /= 0) then

    ! Loop over r,s pair
    do NR=1,NBR
      NumRS = NBS
      if (ISR == ISS) NumRS = NR
      do NS=1,NumRS
        IRS = IRS+1

        ! Loop over p,q pair
        if (LRS == NRS) then
          Kread = Kread+1
          IPQ = 0
          LPQ = 0
          NPQ = 0
          iRc = 0
          iOpt = 1
          IRSST = 1-NBRS
          do NP=1,NBP
            NumPQ = NBQ
            if (ISP == ISQ) NumPQ = NP
            do NQ=1,NumPQ
              IPQ = IPQ+1

              ! Read integrals (pq,rs)
              if (LPQ == NPQ) then
                call Rdord(iRc,iOpt,ISP,ISQ,ISR,ISS,X1,lBuf,nPQ)
                if (IRC > 1) then
                  write(u6,*) ' ERROR RETURN CODE IRC=',IRC
                  write(u6,*) ' FROM RDORD, CALLED FROM TRA2.'
                  call Abend()
                end if
                iOpt = 2
                LPQ = 0
                IRSST = 1-NBRS
              end if
              LPQ = LPQ+1
              IRSST = IRSST+NBRS
              ! Here, we have all the (pq,rs) for this p,q pair
              ! Copy X1 and construct (pq,rs) for this p,q pair
              Length = MaxRS
              if (Kread == Nread) Length = Nrest
              call dcopy_(Length,X1(IRSST+MaxRS*(Kread-1)),1,PQRS(IPQ),NBPQ)
              ! End of loop over p,q pair
            end do
          end do
          LRS = 0
          NRS = Length
        end if
        LRS = LRS+1

        ! Transfer for this r,s pair
        if (ISP == ISQ) then
          call Square(PQRS(NBPQ*(LRS-1)+1),X2,1,NBP,NBP)
          ! (pq,rs) -> (pU,rs)
          call DGEMM_('T','N',NBP,NOCQ,NBQ,One,X2,NBQ,CMO(LMOQ2),NBQ,Zero,X1,NBP)
          ! (pU,rs) -> (TU,rs)
          call DGEMM_Tri('T','N',NOCP,NOCP,NBP,One,X1,NBP,CMO(LMOP2),NBP,Zero,X2,NOCP)
        else
          call dcopy_(NBPQ,PQRS(NBPQ*(LRS-1)+1),1,X2,1)
          ! (pq,rs) -> (pU,rs)
          call DGEMM_('T','N',NBP,NOCQ,NBQ,One,X2,NBQ,CMO(LMOQ2),NBQ,Zero,X1,NBP)
          ! (pU,rs) -> (TU,rs)
          call DGEMM_('T','N',NOCQ,NOCP,NBP,One,X1,NBP,CMO(LMOP2),NBP,Zero,X2,NOCQ)
        end if
        ! Store buffer
        if (IRS > IPQMX3) then
          IRS = 1
          call dDAFILE(LUHLF3,1,TURS,IPQMX3*NOTU,IAD3)
        end if
        ! Sorting
        call dcopy_(NOTU,X2,1,TURS(IRS),IPQMX3)
        ! End of loop over r,s pair
      end do
    end do
    ! Store the last buffer
    if (IPQMX3 < NBRS) then
      call dDAFILE(LUHLF3,1,TURS,IPQMX3*NOTU,IAD3)
    end if
  end if

  if (icc /= 0) then
    ISPQRS = ((ISP**2-ISP)/2+ISQ-1)*NSYMP+(ISR**2-ISR)/2+ISS
    IAD2M(1,ISPQRS) = IAD13
    ITU = 0
    ! Loop over t,u pair
    do NT=1,NOCP
      Num = NOCQ
      if (ISP == ISQ) Num = NT
      do NU=1,Num
        IPQST = 1+NBRS*ITU
        ITU = ITU+1
        ! Read buffer
        if (IPQMX3 < NBRS) then
          call RBuf_tra2(LUHLF3,TURS,NBRS,IPQMX3,NOTU,ITU,IPQST,IAD3S)
        end if
        if (ISR == ISS) then
          ! Square
          call Square(TURS(IPQST),X2,1,NBR,NBR)
          ! (TU,rs) -> (TU,sB)
          call DGEMM_('T','N',NBR,NOS,NBS,One,X2,NBS,CMO(LMOS2),NBS,Zero,X1,NBR)
          ! (TU,sB) -> (TU,AB)
          call DGEMM_Tri('T','N',NOR,NOR,NBR,One,X1,NBR,CMO(LMOR2),NBR,Zero,X2,NOR)
          IX2 = (NOR*NOR+NOR)/2
        else
          call dcopy_(NBRS,TURS(IPQST),1,X2,1)
          ! (TU,rs) -> (TU,As)
          call DGEMM_('T','N',NBR,NOS,NBS,One,X2,NBS,CMO(LMOS2),NBS,Zero,X1,NBR)
          ! (TU,As) -> (TU,AB)
          call DGEMM_('T','N',NOS,NOR,NBR,One,X1,NBR,CMO(LMOR2),NBR,Zero,X2,NOS)
          IX2 = NOR*NOS
        end if
        ! Store (TU,AB) of this t,u pair

        ! WRITE THESE BLOCK OF INTEGRALS ON LUINTM

        call GADSum(X2,IX2)
        call dDAFILE(LUINTM,1,X2,IX2,IAD13)
        ! End of Loop over t,u pair
      end do
    end do
  end if
end if

return

end subroutine tr2NsB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1988,1991,1992,1998, Per Ake Malmqvist                 *
************************************************************************
*--------------------------------------------*
* 1998  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE POLY3(IFF)
      use fciqmc_interface, only: DoFCIQMC
      use caspt2_global, only:iPrGlb
      use caspt2_global, only:LUCIEX, IDTCEX, LUSOLV
      use PrintLevel, only: VERBOSE
      use gugx, only: SGS, L2ACT
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: DoCumulant, iSCF, jState, nActel,
     &                         nConf, nState, STSym, EPSA, mState
#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_ || defined _DMRG_
      use caspt2_module, only: DMRG
#endif
      use pt2_guga, only: CIThr, nG1, nG2, nG3, nG3Tot, Eta
      IMPLICIT NONE
C  IBM TEST VERSION 0, 1988-06-23.
C  NEW VERSION 1991-02-23, FOR USE WITH RASSCF IN MOLCAS PACKAGE.
C  NEW VERSION 1992-12-05, FOR MOLCAS-3 VERSION.
C  NEW VERSION 1998-10-02
C  AUTHOR: PER-AAKE MALMQUIST

C THIS PROGRAM CALCULATES 1-EL, 2-EL, AND 3-EL
C DENSITY MATRICES FOR A CASSCF WAVE FUNCTION.
C IF THE INTEGER KEY IFF.EQ.1, THEN
C IT ALSO PRODUCES THE CONTRACTIONS OF 1-EL -- 4-EL
C DENSITY MATRICES WITH THE FOCK OPERATOR USED IN
C THE CASSCF-MP2 PROGRAM. THE RESULTS ARE WRITTEN
C TO FILE IN SEVERAL FORMS, TO SUPPORT BOTH KERSTINS
C PRESENT PROGRAM AND ALSO SUCH NEW PROCEDURES WHICH
C MIGHT TAKE ADVANTAGE OF ALL INDEX PERMUTATION SYMMETRIES.
C THE RDSTAT AND THE GUGA ROUTINES USED IN THIS
C PROGRAM ASSUMES THE JOBIPH IS PRODUCED BY THE RASSCF PROGRAM.


      INTEGER IFF

      INTEGER ILEV
      INTEGER NG3MAX
      INTEGER ILUID

      INTEGER IDCI
      INTEGER J

      INTEGER IPARDIV
      INTEGER*1, ALLOCATABLE :: idxG3(:,:)
      REAL*8, ALLOCATABLE, TARGET:: G1(:), G2(:), G3(:)
      REAL*8, ALLOCATABLE, TARGET:: F1_H(:), F2_H(:), F3_H(:)
      REAL*8, POINTER:: F1(:), F2(:), F3(:)
      REAL*8, ALLOCATABLE:: CI(:)

      Integer :: nLev
      nLev = SGS%nLev


      IF (IFF.EQ.1) THEN
C ORBITAL ENERGIES IN CI-COUPLING ORDER:
        DO ILEV=1,NLEV
          ETA(ILEV)=EPSA(L2ACT(ILEV))
        END DO
      END IF

      CALL mma_allocate(G1,NG1,LABEL='G1')
      CALL mma_allocate(G2,NG2,LABEL='G2')

C-SVC20100831: recompute approximate max NG3 size needed
      NG3MAX=iPARDIV(NG3TOT,NG2)

C-SVC20100831: allocate local G3 matrices
      CALL mma_allocate(G3,NG3MAX,LABEL='G3')

      CALL mma_allocate(idxG3,6,NG3MAX,label='idxG3')
      idxG3(:,:)=0

      G1(1)=0.0D0
      G2(1)=0.0D0
      G3(1)=0.0D0

C ALLOCATE SPACE FOR CORRESPONDING COMBINATIONS WITH H0:
      IF (IFF.EQ.1) THEN
        CALL mma_allocate(F1_H,NG1,LABEL='F1_H')
        CALL mma_allocate(F2_H,NG2,LABEL='F2_H')
        CALL mma_allocate(F3_H,NG3MAX,LABEL='F3_H')
        F1=>F1_H
        F2=>F2_H
        F3=>F3_H
      ELSE
        F1=>G1
        F2=>G2
        F3=>G3
      END IF

* NG3 will change inside subroutine MKFG3 to the actual
* number of nonzero elements, that is why here we allocate
* with NG3MAX, but we only store (PT2_PUT) the first NG3
* elements of the G3 and F3
      NG3=NG3MAX

      if (.not. DoFCIQMC) then
        CALL mma_allocate(CI,NCONF,Label='CI')

        IF (.NOT. DoCumulant .AND. ISCF.EQ.0) THEN
          IDCI=IDTCEX
          DO J=1,JSTATE-1
            CALL DDAFILE(LUCIEX,0,CI,NCONF,IDCI)
          END DO
          CALL DDAFILE(LUCIEX,2,CI,NCONF,IDCI)
          IF (IPRGLB.GE.VERBOSE) THEN
            WRITE(6,*)
            IF (NSTATE.GT.1) THEN
              WRITE(6,'(A,I4)')
     &       ' With new orbitals, the CI array of state ',MSTATE(JSTATE)
            ELSE
              WRITE(6,*)' With new orbitals, the CI array is:'
            END IF
            CALL PRWF_CP2(STSYM,NCONF,CI,CITHR)
          END IF
        ELSE
          CI(1)=1.0D0
        END IF
      end if

      IF (ISCF.NE.0.AND.NACTEL.NE.0) THEN
        CALL SPECIAL( G1,G2,G3,F1,F2,F3,idxG3)
      ELSE IF (ISCF.EQ.0) THEN
C-SVC20100903: during mkfg3, NG3 is set to the actual value
#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_ || defined _DMRG_
        IF (.NOT. DoCumulant .AND. .NOT. DMRG) THEN
#endif
          If (.NOT.ALLOCATED(CI)) CALL mma_allocate(CI,1,LABEL='CI')
          CALL MKFG3(IFF,CI,G1,F1,G2,F2,G3,F3,idxG3,nLev)
#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_ || defined _DMRG_
        ELSE
          CALL MKFG3DM(IFF,G1,F1,G2,F2,G3,F3,idxG3,nLev)
        END IF
#endif
      END IF

      if (ALLOCATED(CI)) CALL mma_deallocate(CI)

      IF(NLEV.GT.0) THEN
        CALL PT2_PUT(NG1,' GAMMA1',G1)
        CALL PT2_PUT(NG2,' GAMMA2',G2)
        CALL PT2_PUT(NG3,' GAMMA3',G3)
        iLUID=0
        CALL I1DAFILE(LUSOLV,1,idxG3,6*NG3,iLUID)
        IF(IFF.EQ.1) THEN
          CALL PT2_PUT(NG1,' DELTA1',F1)
          CALL PT2_PUT(NG2,' DELTA2',F2)
          CALL PT2_PUT(NG3,' DELTA3',F3)
        END IF
      END IF

      IF(NLEV.GT.0) THEN
        CALL mma_deallocate(G1)
        CALL mma_deallocate(G2)
        CALL mma_deallocate(G3)
        CALL mma_deallocate(idxG3)
        IF(IFF.EQ.1) THEN
          CALL mma_deallocate(F1_H)
          CALL mma_deallocate(F2_H)
          CALL mma_deallocate(F3_H)
        END IF
        F1=>Null()
        F2=>Null()
        F3=>Null()
      END IF

      END SUBROUTINE POLY3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE READIN_RASSI()
      use rassi_global_arrays, only: HAM, ESHFT, HDIAG, JBNUM, LROOT
      use kVectors
#ifdef _DMRG_
      use qcmaquis_interface_cfg
#endif

      IMPLICIT NONE
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='READIN')
#include "rasdim.fh"
#include "rassi.fh"
#include "cntrl.fh"
#include "jobin.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      CHARACTER*80 LINE
      INTEGER MXPLST
      PARAMETER (MXPLST=50)
      CHARACTER*8 TRYNAME
      Integer ALGO,Nscreen
      Real*8  dmpk, tmp
      Logical timings, Estimate, Update, Deco, PseudoChoMOs
      Logical lExists
      Common /CHORASSI / ALGO,Nscreen,dmpk
      COMMON /CHOTIME / timings
      COMMON /LKSCREEN / Estimate, Update, Deco, PseudoChoMOs
      Integer I, J, ISTATE, JSTATE, IJOB, ILINE, LINENR
      Integer LuIn
      Integer NFLS

      character(len=7) :: input_id = '&RASSI '


      Call SpoolInp(LuIn)

C --- Default settings for Cholesky
      Algo = 2
      Nscreen = 10
      dmpk = 1.0d-1
      timings = .false.
      Estimate = .false.
      Update = .true.
      Deco = .true.
      PseudoChoMOs = .false.
#if defined (_MOLCAS_MPP_)
      ChFracMem=0.3d0
#else
      ChFracMem=0.0d0
#endif

      !> set some defaults for MPSSI
      QDPT2SC = .true.
      QDPT2EV = .false.
#ifdef _DMRG_
      !> make sure that we read checkpoint names from xxx.h5 files, for example: rasscf.h5, nevpt2.h5, caspt2.h5, ...
      doMPSSICheckpoints = .true.
      if(doDMRG) input_id = '&MPSSI '
#endif

      !Defaults for SI-PDFT runs:
      Second_time = .false.
      DoGSOR = .false.

C Find beginning of input:
 50   Read(LuIn,'(A72)',END=998) LINE
      CALL NORMAL(LINE)
      IF(LINE(1:7).NE.input_id) GOTO 50
      LINENR=0
100   Read(LuIn,'(A72)',END=998) LINE
      LINENR=LINENR+1
      CALL NORMAL(LINE)
      IF(LINE(1:1).EQ.'*') GOTO 100
      IF(LINE.EQ.' ') GOTO 100
      IF (LINE(1:4).EQ.'END ') GOTO 200
C ------------------------------------------
      IF (LINE(1:4).EQ.'TEST') THEN
        PRSXY=.TRUE.
        PRORB=.TRUE.
        PRTRA=.TRUE.
        PRCI=.TRUE.
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'SECO') THEN
        SECOND_TIME = .true.
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'GSOR') THEN
        DoGSOR = .true.
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'BINA') THEN
        BINA=.TRUE.
        NATO=.TRUE.
        Read(LuIn,*,ERR=997) NBINA
        LINENR=LINENR+1
        Read(LuIn,*,ERR=997) (IBINA(1,I),IBINA(2,I),I=1,NBINA)
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'EXTR') THEN
        IF(IPGLOB.GT.SILENT) THEN
         Call WarningMessage(1,'Obsolete EXTRACT keyword used.')
         WRITE(6,*)' Please remove it from the input.'
        END IF
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'NATO') THEN
        NATO=.TRUE.
        Read(LuIn,*,ERR=997) NRNATO
        LINENR=LINENR+1
        GOTO 100
      END IF
C-------------------------------------------
CTL2004-start
C-------------------------------------------
      IF (LINE(1:4).EQ.'NONA') THEN
         NONA=.TRUE.
        Read(LuIn,*,ERR=997)NONA_ISTATE, NONA_JSTATE
        LINENR=LINENR+1
        GOTO 100
      END IF
C-------------------------------------------
CTL2004-end
C-------------------------------------------
      IF(LINE(1:4).EQ.'RFPE') THEN
        RFPERT=.TRUE.
        GOTO 100
      END IF
C -- FA 2005 start--------------------------
C-------------------------------------------
C --- Cholesky with default settings
      IF(LINE(1:4).EQ.'CHOL') THEN
        Call Cho_rassi_rdInp(.true.,LuIn)
        GOTO 100
      END IF
C --- Cholesky with customized settings
      IF(LINE(1:4).EQ.'CHOI') THEN
        Call Cho_rassi_rdInp(.False.,LuIn)
        GOTO 100
      END IF
C -- FA 2005 end----------------------------
      IF(LINE(1:4).EQ.'SOPR') THEN
        Read(LuIn,*,ERR=997) NSOPR,(SOPRNM(I),ISOCMP(I),
     &                            I=1,MIN(MXPROP,NSOPR))
        LINENR=LINENR+1
        DO I=1,MIN(MXPROP,NSOPR)
          CALL UPCASE(SOPRNM(I))
          If(SOPRNM(I)(1:5).EQ.'MLTPL') THEN
            IF(SOPRNM(I)(7:8).EQ.'  ') THEN
              SOPRNM(I)='MLTPL  '//SOPRNM(I)(6:6)
            ELSE IF(SOPRNM(I)(8:8).EQ.' ') THEN
              SOPRNM(I)='MLTPL '//SOPRNM(I)(6:7)
            END IF
          END IF
        END DO
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'PROP') THEN
        Read(LuIn,*,ERR=997) NPROP,(PNAME(I),ICOMP(I),
     &                            I=1,MIN(MXPROP,NPROP))
        LINENR=LINENR+1
        DO I=1,MIN(MXPROP,NPROP)
          CALL UPCASE(PNAME(I))
          If(PNAME(I)(1:5).EQ.'MLTPL') THEN
            IF(PNAME(I)(7:8).EQ.'  ') THEN
              PNAME(I)='MLTPL  '//PNAME(I)(6:6)
            ELSE IF(PNAME(I)(8:8).EQ.' ') THEN
              PNAME(I)='MLTPL '//PNAME(I)(6:7)
            END IF
          END IF
        END DO
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'OVER') THEN
        PRSXY=.TRUE.
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'TRDI') THEN
* Print transition dipole vectors
        PRDIPVEC=.TRUE.
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'TDMN') THEN
* Print transition dipole vectors
        PRDIPVEC=.TRUE.
        Read(LuIn,*,ERR=997) TDIPMIN
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'TRDC') THEN
* Print COMPLEX transition dipole vectors
        PRDIPCOM=.TRUE.
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'ORBI') THEN
        PRORB=.TRUE.
        GOTO 100
      END IF
C ------------------------------------------
      IF (LINE(1:4).EQ.'CIPR') THEN
        PRCI=.TRUE.
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'THRS')THEN
        Read(LuIn,*,ERR=997) CITHR
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'ONEL') THEN
        IFHAM=.FALSE.
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'ONEE') THEN
        IFHAM=.FALSE.
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'SPIN') THEN
        IFSO=.TRUE.
        GOTO 100
      END IF
      IF(LINE(1:4).EQ.'NTOC') THEN
        IFNTO=.TRUE.
        GOTO 100
      END IF
C ------------------------------------------
* PAM07 Added: Keyword for printing spin-orbit coupling matrix elements
* A threshold in reciprocal cm is entered.
      IF(LINE(1:4).EQ.'SOCO') THEN
        Read(LuIn,*,ERR=997) SOTHR_PRT
        LINENR=LINENR+1
        IF(SOTHR_PRT.LT.0.0D0) SOTHR_PRT=0.0D0
        NSOTHR_PRT=10000
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'NROF'.or.LINE(1:4).EQ.'NR O') THEN
        NSTATE=0
        Read(LuIn,*,ERR=997) NJOB,TRYNAME
        CALL UpCase(TRYNAME)
        IF(TRYNAME.EQ.'ALL') THEN
          LINENR=LINENR+1
        ELSE
          BACKSPACE(LuIn)
          Read(LuIn,*,ERR=997) NJOB,(NSTAT(I),I=1,NJOB)
          DO IJOB=1,NJOB
            NSTATE=NSTATE+NSTAT(IJOB)
          END DO
          Call mma_allocate(JBNUM,nState,Label='JBNUM')
          Call mma_allocate(LROOT,nState,Label='LROOT')
          LINENR=LINENR+1
          NSTATE=0
          DO IJOB=1,NJOB
            ISTAT(IJOB)=NSTATE+1
            Read(LuIn,*,ERR=997) (LROOT(NSTATE+J),J=1,NSTAT(IJOB))
            LINENR=LINENR+1
            DO ISTATE=NSTATE+1,NSTATE+NSTAT(IJOB)
              JBNUM(ISTATE)=IJOB
            END DO
            NSTATE=NSTATE+NSTAT(IJOB)
          END DO
        END IF
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'IPHN') THEN
*        Read(LuIn,'(9(A7,1X))',ERR=997)(JBNAME(I),I=1,NJOB)
*        LINENR=LINENR+1
        DO I=1,NJOB
         READ(LuIn,*,ERR=997) JBNAME(I)
         LINENR=LINENR+1
         CALL UpCase(JBNAME(I))
        END DO
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'FILE') THEN
        READ(LuIn,*,ERR=997) NJOB
        LINENR=LINENR+1
        DO I=1,NJOB
         READ(LuIn,*,ERR=997) LINE
         LINENR=LINENR+1
         CALL FILEORB(LINE,JBNAME(I))
        END DO
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'HEXT') THEN
        IFHEXT=.TRUE.
        IFHAM =.TRUE.
        Call mma_allocate(HAM,nState,nState,Label='HAM')
        Read(LuIn,*,ERR=997)((HAM(ISTATE,JSTATE),
     &                                           JSTATE=1,ISTATE),
     &                                           ISTATE=1,NSTATE)
        DO ISTATE=1,NSTATE-1
         DO JSTATE=ISTATE+1,NSTATE
            HAM(ISTATE,JSTATE)=HAM(JSTATE,ISTATE)
         END DO
        END DO
        LINENR=LINENR+NSTATE
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'HEFF') THEN
        IFHEFF=.TRUE.
        IFHAM =.TRUE.
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'HCOM') THEN
        IFHCOM=.TRUE.
        IFHAM =.TRUE.
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'EJOB') THEN
        IFEJOB=.TRUE.
        IFHAM=.TRUE.
!   Leon: Is it really needed?
!        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'HDIA') THEN
        IFHDIA=.TRUE.
        Call mma_allocate(HDIAG,nState,Label='nState')
        Read(LuIn,*,ERR=997)(HDIAG(ISTATE),ISTATE=1,NSTATE)
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'SHIF') THEN
        IFSHFT=.TRUE.
        Call mma_allocate(ESHFT,nState,Label='ESHFT')
        Read(LuIn,*,ERR=997)(ESHFT(ISTATE),ISTATE=1,NSTATE)
        LINENR=LINENR+1
        GOTO 100
      END IF
C--------------------------------------------
      If(Line(1:4).eq.'TOFI') then
        ToFile=.true.
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
      If(Line(1:4).eq.'J-VA') then
        IFJ2=1
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
      If(Line(1:4).eq.'OMEG') then
        IFJZ=1
        Linenr=Linenr+1
        GoTo 100
      Endif
C-SVC 2007-----------------------------------
      If(Line(1:4).eq.'EPRG') then
        IFGCAL=.TRUE.
        Read(LuIn,*,ERR=997) EPRTHR
        IF (EPRTHR .LT. 0.0D0) EPRTHR=0.0D0
        Linenr=Linenr+1
        GoTo 100
      Endif

C tjd- BMII: Print out spin-orbit properties to files
      IF(Line(1:4).eq.'PRPR') then
        WRITE(6,*) "SPIN-ORBIT PROPERTY PRINT ON"
        LPRPR=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif

C tjd- Yoni: Force an identity SO hamiltonian
      IF (LINE(1:4).eq.'HAMI') then
        WRITE(6,*) "Identity Hamiltonian turned on"
        LHAMI=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif

c BP - Hyperfine calculations
      If(Line(1:4).eq.'EPRA') then
      !write(6,*)"EPRA read"
        IFACAL=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif
      If(Line(1:4).eq.'AFCO') then
      !write(6,*)"AFCO read"
        IFACALSD=.FALSE.
        Linenr=Linenr+1
        GoTo 100
      Endif
      If(Line(1:4).eq.'ASDO') then
      !write(6,*)"ASDO read"
        IFACALFC=.FALSE.
        Linenr=Linenr+1
        GoTo 100
      Endif
c Kamal Sharkas beg - PSO Hyperfine calculations
      If(Line(1:4).eq.'AFCC') then
        IFACALFCON=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif

      If(Line(1:4).eq.'ASDC') then
        IFACALSDON=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif

      If(Line(1:4).eq.'FCSD') then
        IFACALFCSDON=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif

      If(Line(1:4).eq.'APSO') then
        IFACALPSO=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif

      If(Line(1:4).eq.'GTSA') then
        IFGTCALSA=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif

      If(Line(1:4).eq.'ATSA') then
        IFATCALSA=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif

      If(Line(1:4).eq.'SHMP') then
        IFGTSHSA=.TRUE.
        Read(LuIn,*,ERR=997) MULTIP
        Linenr=Linenr+1
        GoTo 100
      Endif

      If(Line(1:4).eq.'VSUS') then
        IFVANVLECK=.TRUE.
        READ(LuIn,*,err=997) TMINS, TMAXS, NTS
        Linenr=Linenr+1
        GoTo 100
      Endif

      If(Line(1:4).eq.'NMRT') then
        IFSONCINI=.TRUE.
        READ(LuIn,*,err=997) TMINP, TMAXP, NTP
        Linenr=Linenr+1
        GoTo 100
      Endif

      If(Line(1:4).eq.'NMRF') then
        IFSONCIFC=.TRUE.
        READ(LuIn,*,err=997) TMINF, TMAXF, NTF
        Linenr=Linenr+1
        GoTo 100
      Endif

c Kamal Sharkas end - PSO Hyperfine calculations

c BP Natural orbitals options
      If(Line(1:4).eq.'SONO') then
        Read(LuIn,*,ERR=997) SONATNSTATE
        CALL GETMEM('SONATS','ALLO','INTE',LSONAT,SONATNSTATE)
        Linenr=Linenr+1
        DO ILINE=1,SONATNSTATE
          Read(LuIn,*,ERR=997) IWORK(LSONAT-1+ILINE)
          Linenr=Linenr+1
        END DO
        GoTo 100
      Endif
      If(Line(1:4).eq.'SODI') then
        Read(LuIn,*,ERR=997) SODIAGNSTATE
        CALL GETMEM('SODIAG','ALLO','INTE',LSODIAG,SODIAGNSTATE)
        Linenr=Linenr+1
        DO ILINE=1,SODIAGNSTATE
          Read(LuIn,*,ERR=997) IWORK(LSODIAG-1+ILINE)
          Linenr=Linenr+1
        END DO
        GoTo 100
      Endif
      If(Line(1:4).eq.'NOSO') then
        NOSO=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif
      If(Line(1:4).eq.'CURD') then
        IFCURD=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif
c END BP OPTIONS
C-SVC 2007 2008------------------------------
      If(Line(1:4).eq.'MAGN') then
        IFXCAL=.TRUE.
        READ(LuIn,*,err=997) NBSTEP,BSTART,BINCRE,BANGRES
        READ(LuIn,*,err=997) NTSTEP,TSTART,TINCRE
        IF (BANGRES.GT.0.0D0) THEN
            IFMCAL=.TRUE.
        ENDIF
        Linenr=Linenr+2
        GoTo 100
      EndIf
C--------------------------------------------
      If(Line(1:4).eq.'XVIN') then
        PRXVR=.true.
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
      If(Line(1:4).eq.'XVES') then
        PRXVE=.true.
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
      If(Line(1:4).eq.'XVSO') then
        PRXVS=.true.
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
      If(Line(1:4).eq.'MEIN') then
        PRMER=.true.
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
      If(Line(1:4).eq.'MEES') then
        PRMEE=.true.
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
      If(Line(1:4).eq.'MESO') then
        PRMES=.true.
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
C*****IS 30-09/2007**************************
      IF(Line(1:4).eq.'HOP ') THEN
        HOP=.TRUE.
        LINENR=LINENR+1
        GOTO 100
      ENDIF
C--------------------------------------------
      IF(Line(1:4).eq.'TRAC') THEN
        TRACK=.TRUE.
        IFHAM=.FALSE.
        LINENR=LINENR+1
        GOTO 100
      ENDIF
C--------------------------------------------
      IF(Line(1:4).eq.'STOV') THEN
        ONLY_OVERLAPS=.TRUE.
        IFHAM=.FALSE.
        LINENR=LINENR+1
        GOTO 100
      ENDIF
C--------------------------------------------
      If(Line(1:4).eq.'DCOU') then
        IfDCpl=.True.
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
C*PAM Nov 2011
      IF(Line(1:4).eq.'TRD1') THEN
        IFTRD1=.TRUE.
        LINENR=LINENR+1
        GOTO 100
      ENDIF
C--------------------------------------------
      IF(Line(1:4).eq.'TRD2') THEN
        IFTRD1=.TRUE.
        IFTRD2=.TRUE.
        LINENR=LINENR+1
        GOTO 100
      ENDIF
C--------------------------------------------
*CEH April 2015
      IF(Line(1:4).eq.'DQVD') THEN
        DQVD=.TRUE.
        LINENR=LINENR+1
        GOTO 100
      ENDIF
C--------------------------------------------
      IF(LINE(1:4).EQ.'ALPH')THEN
        Read(LuIn,*,ERR=997) ALPHZ
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'BETA')THEN
        Read(LuIn,*,ERR=997) BETAE
        LINENR=LINENR+1
        GOTO 100
      END IF
C--------------------------------------------
*LKS Sep 2015
      IF(Line(1:4).eq.'DIPR') THEN
! Printing threshold for dipole intensities. Current default 1.0D-5
        DIPR=.TRUE.
        Read(LuIn,*,ERR=997) OSTHR_DIPR
        LINENR=LINENR+1
        GOTO 100
      ENDIF
C--------------------------------------------
      IF(LINE(1:4).EQ.'QIPR')THEN
! Printing threshold for quadrupole intensities. Current default 1.0D-5
        QIPR=.TRUE.
        Read(LuIn,*,ERR=997) OSTHR_QIPR
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'QIAL')THEN
! Print all contributions for quadrupole intensities.
        QIALL=.TRUE.
        LINENR=LINENR+1
        GOTO 100
      END IF
C--------------------------------------------
      IF(LINE(1:4).EQ.'RSPR') THEN
! Printing threshold for rotatory strength. Current default 1.0D-7
        RSPR=.TRUE.
        Read(LuIn,*,ERR=997) RSTHR
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'CD  ') THEN
! Perform regular circular dichroism - velocity and mixed gauge
        DOCD = .TRUE.
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'DYSO')THEN
! Enable Dyson orbital calculations
        DYSO=.TRUE.
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'DYSE')THEN
! Enable Dyson orbital calculations
        DYSEXPORT=.TRUE.
        Read(LuIn,*,ERR=997) DYSEXPSF,DYSEXPSO
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      If(Line(1:4).eq.'TINT') then
! Calculate exact isotropically averaged semi-classical intensities
! Activate integration of transition intensities
! based on the exact non-relativistic Hamiltonian in the weak field
! approximation.
        Do_TMOM=.TRUE.
        Linenr=Linenr+1
        GoTo 100
      Endif
C ------------------------------------------
      If(Line(1:4).eq.'TIGR') then
! Group exact TINT to reduce computational cost
! TMGr_thrs is the tolerance in the relative energy (unitless)
! TMGr_thrs only works with SUBS keyword
        Read(LuIn,*,ERR=997) TMGr_thrs
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
      IF(LINE(1:4).EQ.'PRRA')THEN
! Print the raw directions for exact semi-classical intensities
        PRRAW=.TRUE.
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'PRWE')THEN
! Print the weighted directions for exact semi-classical intensities
        PRWEIGHT=.TRUE.
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'TOLE')THEN
! Set tolerance for different gauges - currently 10 percent (0.1D0)
! Defined as Tolerance = ABS(1-O_r/O_p)
        Read(LuIn,*,ERR=997) TOLERANCE
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      IF(LINE(1:4).EQ.'SUBS')THEN
! Reduce looping in intensities. Set limit for the inner and outer loop
        REDUCELOOP=.TRUE.
        Read(LuIn,*,ERR=997) LOOPDIVIDE
        LINENR=LINENR+1
        GOTO 100
      END IF
C ------------------------------------------
      If(Line(1:4).eq.'IIOR') then
! Set the order of the Lebedev polynomials used for the numerical
! isotropic integration. Current default 5.
        Read(LuIn,*,ERR=997) L_Eff
        Linenr=Linenr+1
        GoTo 100
      Endif
C--------------------------------------------
      If(Line(1:4).eq.'DIRE') then
! Set a specific direction of the incident light when computing
! the transition intensities in the use of
! the vector field (A) in the non-relativistic Hamiltonian.
        Do_SK=.TRUE.
        Read(LuIn,*,ERR=997) nk_Vector
        Linenr=Linenr+1
        Call mma_allocate(k_Vector,3,nk_Vector,label='k-Vector')
        Do j = 1, nk_Vector
           Read(LuIn,*,ERR=997) (k_Vector(i,j),i=1,3)
           Linenr=Linenr+1
           tmp=k_Vector(1,j)**2+k_Vector(2,j)**2+k_Vector(3,j)**2
           tmp = 1.0D0/Sqrt(tmp)
           k_Vector(1,j)=k_Vector(1,j)*tmp
           k_Vector(2,j)=k_Vector(2,j)*tmp
           k_Vector(3,j)=k_Vector(3,j)*tmp
        End Do
        GoTo 100
      Endif
C--------------------------------------------
      If(Line(1:4).eq.'POLA') then
        Do_Pol=.TRUE.
        Linenr=Linenr+1
        Read(LuIn,*,ERR=997) (e_Vector(i),i=1,3)
        GoTo 100
      Endif
#ifdef _DMRG_
C--------------------------------------------
      if (Line(1:4).eq.'QDSC') then
        QDPT2SC = .true.
        goto 100
      end if
C--------------------------------------------
      if (Line(1:4).eq.'QDPC') then
        QDPT2SC = .false.
        goto 100
      end if
#endif
C These errors could eventually be removed
C--------------------------------------------
      if (Line(1:4).eq.'TMOS') then
        write(6,*)' Keyword TMOS is deprecated, use TINT instead.'
        goto 999
      end if
C--------------------------------------------
      if (Line(1:4).eq.'KVEC') then
        write(6,*)' Keyword KVEC is deprecated, use DIRE instead.'
        goto 999
      end if
C--------------------------------------------
      if (Line(1:4).eq.'L-EF') then
        write(6,*)' Keyword L-EF is deprecated, use IIOR instead.'
        goto 999
      end if
C--------------------------------------------
      if (Line(1:4).eq.'REDL') then
        write(6,*)' Keyword REDL is deprecated, use SUBS instead.'
        goto 999
      end if
C--------------------------------------------
      if (Line(1:4).eq.'TMGR') then
        write(6,*)' Keyword TMGR is deprecated, use TIGR instead.'
        goto 999
      end if
C--------------------------------------------
*
      WRITE(6,*)' The following input line was not understood:'
      WRITE(6,'(A)') LINE
      GOTO 999

997   CONTINUE
      Call WarningMessage(2,'Error reading standard input.')
      WRITE(6,*)' RASSI input near line nr.',LINENR+1
      GOTO 999

998   CONTINUE
      Call WarningMessage(2,'I/O error.')
      WRITE(6,*)' READIN: Unexpected end of input file.'

999   CONTINUE
      CALL XFLUSH(6)
      CALL ABEND()

200   CONTINUE
cnf
      If (IfDCpl .and. .not.IfHam) Then
         Call WarningMessage(1,'Input request was ignored.')
         Write(6,*) ' Cannot compute the approximate derivative',
     &              ' coupling terms without the energies.'
         Write(6,*) ' Ignore them.'
         IfDCpl = .False.
      End If
cnf
      If (Do_Pol.and..not.Do_SK) Then
         Call WarningMessage(1,'Input request was ignored.')
         Write(6,*) ' Polarization direction can only be used with'
         Write(6,*) ' specific k-vector directions.'
         Do_Pol = .False.
      End If
! Prints warning if rot. str. threshold is defined without any calculations
      If(RSPR) Then
        If (.NOT.DOCD .AND. .NOT.Do_TMOM) Then
          Call WarningMessage(1,'Input request was ignored.')
          WRITE(6,*)
     &     'Warning: Rotatory strength threshold specified (RSPR) '//
     &     'without calculating rotatory strength'
        End if
      End if
* Determine file names, if undefined.
      IF(JBNAME(1).EQ.'UNDEFINE') THEN
* The first (perhaps only) jobiph file is named 'JOB001', or maybe 'JOBIPH'
* when no name has been issued by the user:
        NFLS=0
        TRYNAME='JOB001'
        CALL F_INQUIRE(TRYNAME,LEXISTS)
        IF(LEXISTS) THEN
          NFLS=1
          JBNAME(NFLS)=TRYNAME
        ELSE
          TRYNAME='JOBIPH'
          CALL F_INQUIRE(TRYNAME,LEXISTS)
          IF(LEXISTS) THEN
            NFLS=1
            JBNAME(NFLS)=TRYNAME
          ELSE
            Call WarningMessage(1,'RASSI lacks JobIph files.')
            WRITE(6,*)' RASSI fails: No jobiph files found.'
            CALL ABEND()
          END IF
        END IF
* Subsequent (if any) jobfiles can be named according to old
* or new naming convention.
* Using new standard scheme for default jobiph names?
        DO I=1,MXJOB-1
          IF (NJOB.GT.0.AND.I.GT.NJOB) GOTO 211
          WRITE(TRYNAME,'(A6,I2.2)') 'JOBIPH',I
          CALL F_INQUIRE(TRYNAME,LEXISTS)
          IF(LEXISTS) THEN
            NFLS=NFLS+1
            JBNAME(NFLS)=TRYNAME
          ELSE
            GOTO 211
          END IF
        END DO
        Call WarningMessage(1,'RASSI fails to identify JobIph files.')
        WRITE(6,*)' Too many jobiph files in this directory.'
        CALL ABEND()
 211    CONTINUE
        IF(NFLS.EQ.1) THEN
* We may be using old standard scheme for default jobiph names?
          DO I=1,MXJOB-1
            IF (NJOB.GT.0.AND.I.GT.NJOB) GOTO 212
            WRITE(TRYNAME,'(A3,I3.3)') 'JOB',I+1
            CALL F_INQUIRE(TRYNAME,LEXISTS)
            IF(LEXISTS) THEN
              NFLS=NFLS+1
              JBNAME(NFLS)=TRYNAME
            ELSE
              GOTO 212
            END IF
           END DO
           Call WarningMessage(1,
     &       'RASSI fails to identify JobIph files.')
           WRITE(6,*)' Too many jobiph files in this directory.'
           CALL ABEND()
 212       CONTINUE
           IF(NFLS.GT.1) THEN
* Then we are definitely using the old default file name convention.
           END IF
        END IF
        IF(NJOB.GT.0) THEN
* Input has been given for NJOB, etc., and will be used.
          IF(NFLS.LT.NJOB) THEN
            Call WarningMessage(1,'RASSI found too few JobIph files.')
            CALL ABEND()
          END IF
        ELSE
* Use defaults.
          NJOB=NFLS
        END IF
      END IF

      CALL XFLUSH(6)

      Call Close_LuSpool(LuIn)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2009, Giovanni Ghigo                                   *
!***********************************************************************

!  InterSystem Crossing rate evaluation: Reduction of States
!  Author: Giovanni Ghigo
!          Dip. Chimica Generale e Chimica Organica, Torino (ITALY)
!          07 Jan-09 - XX Jan-09

subroutine LogEVec(iPrint,nOsc,max_nOrd,minQ,nMaxQ,nMat,lVec,nYes)
! Generate Logical Vector of useful States

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iPrint, nOsc, max_nOrd, minQ, nMaxQ(nOsc), nMat(0:max_nOrd,nOsc)
integer(kind=iwp), intent(out) :: lVec(0:max_nOrd), nYes
integer(kind=iwp) :: iOrd, iOsc, nSumQ

if (iPrint >= 3) then
  write(u6,*) ' Original number of States=',max_nOrd+1
end if

do iOrd=0,max_nOrd
  lVec(iOrd) = 1
  nSumQ = 0
  do iOsc=1,nOsc
    if (nMat(iOrd,iOsc) > nMaxQ(iOsc)) lVec(iOrd) = 0
    nSumQ = nSumQ+nMat(iOrd,iOsc)
  end do
  if (nSumQ < minQ) lVec(iOrd) = 0
end do
nYes = 0
do iOrd=0,max_nOrd
  nYes = nYes+lVec(iOrd)
end do

if (iPrint >= 3) then
  write(u6,*) ' Selected number of States=',nYes
end if

return

end subroutine LogEVec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NatOrb_MCLR(Dens,CMOO,CMON,OCCN)

use MCLR_Data, only: ipCM, ipMat, nDens
use input_mclr, only: kPrint, nBas, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: Dens(*), CMOO(*)
real(kind=wp), intent(_OUT_) :: CMON(*), OCCN(*)
integer(kind=iwp) :: i, iEnd, ii, ij, iO, iS, iSt, j
real(kind=wp), allocatable :: EVal(:), EVec(:)

call mma_allocate(EVec,nDens,Label='EVec')
call mma_allocate(EVal,nDens,Label='EVal')

! Diagonalize the density matrix and transform orbitals

if (btest(kprint,3)) then
  write(u6,*)
  write(u6,*) '           Effective natural population'
  write(u6,*) '           ============================'
  write(u6,*)
end if
io = 0
do is=1,nsym
  ij = 0
  do i=0,nbas(is)-1
    do j=0,i
      ij = ij+1
      Eval(ij) = Dens(ipMat(is,is)+i+j*nbas(is))
    end do
  end do
  call unitmat(EVec,nbas(is))
  call JACOB(EVal,EVec,nbas(is),nbas(is))
  ii = 0
  do i=1,nbas(is)
    ii = ii+i
    OCCN(io+i) = Eval(ii)
  end do
  IST = IO+1
  IEND = IO+NBAS(is)
  if (btest(kprint,1)) write(u6,'(6X,A3,I2,A1,10F11.6,/,(12X,10F11.6))') 'sym',iS,':',(OCCN(I),I=IST,IEND)
  if (nBas(is) >= 1) &
    call DGEMM_('N','N',NBAS(is),NBAS(is),NBAS(is),One,CMOO(ipCM(is)),NBAS(is),EVec,NBAS(is),Zero,CMON(ipCM(is)),NBAS(is))
  io = io+nbas(is)
end do

call mma_deallocate(EVec)
call mma_deallocate(Eval)

end subroutine NatOrb_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989-1992, Roland Lindh                                *
!               1990, IBM                                              *
!               1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine Request_MCLR_Run(Run_MCLR,ireturn,iPrint)

use Definitions, only: iwp, u6

implicit none
logical(kind=iwp), intent(in) :: Run_MCLR
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp), intent(in) :: iPrint
#include "warnings.h"
integer(kind=iwp) :: LuInput
character(len=16) :: StdIn
integer(kind=iwp), external :: IsFreeUnit

if (Run_MCLR) then

  ! McKinley will automatically generate the input for MCLR
  ! and signal to AUTO (iRC=2) to run the input file Stdin.x.

  if (iPrint >= 6) then
    write(u6,*)
    write(u6,*) ' McKinley requests the MCLR module to be executed!'
    write(u6,*)
  end if

  LuInput = IsFreeUnit(11)
  call StdIn_Name(StdIn)
  call Molcas_Open(LuInput,StdIn)
  write(LuInput,'(A)') ' &MCLR &End'
  write(LuInput,'(A)') 'End of Input'
  close(LuInput)
  ireturn = _RC_INVOKED_OTHER_MODULE_
else
  ireturn = _RC_ALL_IS_WELL_
end if

return

end subroutine Request_MCLR_Run

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jonas Bostrom                                          *
************************************************************************
      subroutine Construct_A(nFIorb,nIrrep)
**************************************************************
*     Author: Jonas Bostr{\"o}m
*
*     Purpose: Computation of the matrix A to contract with the 2-center
*              derivative in the Exchange part of the DF-gradients
*
*     Equation: A_KL = sum_ij = C^K_ij*C^L_ij
*
*     Input:
*            nFIOrb: Array of # of Inactive(Occupied) + frozen orbitals
*                    in each irrep.
*            nIrrep: Number of irreducible representations.
**************************************************************************
      Implicit Real*8 (a-h,o-z)
      Integer  nVec(8)
      Integer nFIorb(8)
      Character Fname*6
      Character*13 SECNAM
      Parameter (SECNAM = 'CONSTRUCT_A')

#include "cholesky.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
*
*************************
*     Define some indeces
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
      iTri(i,j) = max(i,j)*(max(i,j)-3)/2 + i + j
*************************
      Do i = 1, nIrrep
         nVec(i) = NumCho(i)
      End Do
      Call GAIGOP(nVec,nIrrep,'+')
*

*
      Do iChSym = 1, nIrrep
         Nij = 0
         Do iSym = 1, nIrrep
            jSym = MulD2h(iChSym,iSym)
            If(iChSym.eq.1) Then
               Nij=Nij + nFIorb(iSym)*(nFIorb(iSym)+1)/2
            Else
               Nij=Nij + nFIorb(iSym)*nFIorb(jSym)
            End If
         End Do
         If(Nij.eq.0) Go To 1000
         Call GetMem('MemChk','Max','Real',iDum,MemMax)
         MemMax = 60
*     Setup batches in a way so that we maximize the number of full rows in A_KL we
*     can have in memory at one time and if zero row fits we maximize the number of
*     columns of one


         rNij = Real(Nij)
         rMemMax = Real(MemMax)
         rChoFull=Real(nVec(iChSym))
*--------------------------------------
*         Write(6,*) 'rNij', rNij
*         Write(6,*) 'rMemMax', rMemMax
*         Write(6,*) 'rChoFull', rChoFull
*---------------------------------------
         If(rChoFull*(rChoFull+1)/2+rNij*rChoFull.lt.rMemMax) Then
            nBatL = 1
            nBatK = 1
            nBatVecK = nVec(iChSym)
            nBatVecL = nVec(iChSym)
         Else
            rChoMaxK = (rMemMax - rNij*rChoFull)/rChoFull
            iChoMaxK = Int(rChoMaxK)
            nBatVecK = Min(iChoMaxK,nVec(iChSym))
*-------------------------------------------------
*            Write(6,*) 'rChoMaxK', rChoMaxK
*            Write(6,*) 'iChoMaxK', iChoMaxK
*            Write(6,*) 'nBatVecK', nBatVecK
*-------------------------------------------------
            If(nBatVecK.ne.0) Then
               nBatK = nVec(iChSym)/nBatVecK
               nFullK = nBatVecK*nBatK
               If(nFullK.lt.nVec(iChSym)) nBatK=nBatK+1
               nBatL = 1
               nBatVecL = nVec(iChSym)
            Else
               nBatK=0
            End If

*
            If(nBatK.le.0) Then
               nBatVecK = 1
               nBatK = nVec(iChSym)
               rChoMaxL = rMemMax/(1+2*Nij)
               iChoMaxL = Int(rChoMaxL)
               nBatVecL = min(iChoMaxL,nVec(iChSym))
*-------------------------------------------------
*               Write(6,*) 'rChoMaxL', rChoMaxL
*               Write(6,*) 'iChoMaxL', iChoMaxL
*               Write(6,*) 'nBatVecL', nBatVecL
*-------------------------------------------------
               nBatL = nVec(iChSym)/nBatVecL
               nFullL = nBatVecL*nBatL
               If(nFullL.lt.nVec(iChSym)) nBatL=nBatL+1
               If(nBatL.lt.0) Then
                  Call WarningMessage(2,'Error in Construct_A')
                  Write(6,*) 'Too little memory available'
                  Write(6,*) 'Consider increasing MOLCAS_MEM'
                  Call Abend
               End If
            Else
               nBatL = 1
            End If
         End If

*         Write(6,*) 'nBatK, nBatL', nBatK, nBatL
*         Write(6,*) 'nBatVecK,nBatVecL',nBatVecK,nBatVecL
         iSeed = 8
         LuCVec = IsFreeUnit(iSeed)
         Write(Fname,'(A4,I1)') 'CVEC',iChSym
         Call DaName_MF_WA(LuCVec,Fname)
*
         iSeed = 9
         LuAMat = IsFreeUnit(iSeed)
         Write(Fname,'(A4,I1)') 'AMAT',iChSym
         Call DaName_MF_WA(LuAMat,Fname)
*
         l_Cvec1 = nBatVecL*Nij
         l_Cvec2 = nBatVecK*Nij
         If((nBatL.eq.1).and.(nBatK.eq.1)) Then
            l_Amat = nBatVecK*(nBatVecK+1)/2
         Else
            l_Amat = nBatVecK*nBatVecL
         End If
*         Write(6,*) 'l_Amat', l_Amat
         Call GetMem('C_vec1','Allo','Real',ip_Cvec1,l_Cvec1)
         Call GetMem('C_vec2','Allo','Real',ip_Cvec2,l_Cvec2)
         Call GetMem('A_matrix','Allo','Real',ip_Amat,l_Amat)
         Call FZero(Work(ip_Amat),l_Amat)
*
         nVecK = nBatVecK
         Do iBatK = 1, nBatK
*            Write(6,*) 'iBatK', iBatK
            If(iBatK.eq.nBatK) nVecK = nVec(iChSym) - (nBatK-1)*nBatVecK

*            iAdr = (iBatK-1)*Nij*nBatVecK
*            Write(6,*) 'iAdr1', iAdr
*            Call dDaFile(LuCVec,2,Work(ip_Cvec1),nVecK*Nij,iAdr)
            nVecL = nBatVecL
            iBatL_Max = iBatK/nBatVecL
            iRest = mod(iBatK,nBatVecL)
            if(iRest.ne.0) iBatL_Max = iBatL_Max+1
            Do iBatL = 1, iBatL_Max
*               Write(6,*) 'iBatL', iBatL
               If(iBatL.eq.nBatL) nVecL =nVec(iChSym)-(nBatL-1)*nBatVecL
               iAdr = (iBatL-1)*Nij*nVecL
*               Write(6,*) 'iadr', iAdr
               Call dDaFile(LuCVec,2,Work(ip_Cvec1),nVecL*Nij,iAdr)
               If(nBatL.ne.1) Then
                  iAdr = (iBatK-1)*Nij*nVecK
                  Call dDaFile(LuCVec,2,Work(ip_Cvec2),nVecK*Nij,iAdr)
               End If

*------------------------------------------------
*               Write(6,*) 'C-Vector1'
*               Do i = 0, nVecL*Nij-1
*                  Write(6,*) Work(ip_Cvec1+i)
*               End Do
*               If(iBatL.ne.0) Then
*                  Write(6,*) 'C-Vector2'
*                  Do i = 0, nVecK*Nij-1
*                     Write(6,*) Work(ip_Cvec2+i)
*                  End Do
*               End If
*------------------------------------------------


               Do iK = 1, nVecK
*                  If(iBatK.eq.iBatL) nL = iK
                  iK_Real = iK + nVecK*(iBatK-1)
*                 The L-vectors already done in an earlier batch
                  iL_passed = (iBatL-1)*nBatVecL
                  iL_max = min(iK_Real - iL_passed,nBatVecL)
                  Do iL = 1, iL_max
                     A_KL = 0
*                     Write(6,*) 'iL,iK', iL,iK
                     Do ij = 1, Nij
                        If(nBatL.eq.1) Then
                           index_K = ij-1 + (iK_Real-1)*Nij
                        Else
                           index_K = ij-1 + (iK-1)*Nij
                        End If
                        index_L = ij-1 + (iL-1)*Nij
*                        Write(6,*) 'index_K', index_K
*                        Write(6,*) 'index_L', index_L
                        If(nBatL.eq.1) Then
                           A_KL = A_KL + Work(ip_Cvec1+index_L)*
     &                                   Work(ip_CVec1+index_K)
                        Else
                           A_KL = A_KL + Work(ip_CVec1+index_L)*
     &                                   Work(ip_CVec2+index_K)
                        End If
                     End Do
                     iSkip = (iBatK-1)*nBatVecK
                     index_A = iTri(iL,iK_Real) - 1 - iTri(iSkip,iSkip)
*-----------------------------------------------------------
*                     Write(6,*) 'iTri1', iTri(iL,iK_Real)
*                     Write(6,*) 'iTri2', iTri(iSkip,iSkip)
*                     Write(6,*) 'index_A', index_A
*-----------------------------------------------------------
                     Work(ip_Amat+index_A) = A_KL
                  End Do
               End Do
*----------------------------------------------
*               Write(6,*) 'A-matrixpiece'
*               Do i=0, l_Amat-1
*                  Write(6,*) Work(ip_Amat+i)
*               End Do
*----------------------------------------------

               iKmaxLast = nBatVecK*(iBatK-1)
               iKmaxThis = iKmaxLast + nVecK
               iAdr=iTri(iKmaxLast,iKmaxLast)+(iBatL-1)*nBatVecL
               l_Atemp = iTri(iKmaxThis,iKmaxThis)-
     &                   iTri(iKmaxLast,iKmaxLast)
               l_Atemp = l_Atemp - (iBatL-1)*nBatVecL
               l_Atemp = min(l_Atemp,l_Amat)
*               Write(6,*) 'iAdrA', iAdr
*               Write(6,*) 'l_Atemp', l_Atemp
               Call dDaFile(LuAMat,1,Work(ip_Amat),l_Atemp,iAdr)
            End Do
         End Do

*


         Call GetMem('C_vec1','Free','Real',ip_Cvec1,l_Cvec1)
         Call GetMem('C_vec2','Free','Real',ip_Cvec2,l_Cvec2)
         Call GetMem('A_matrix','Free','Real',ip_Amat,l_Amat)
#ifdef _DEBUG
         Call GetMem('A_mat','Allo','Real',ip_A,
     &               nVec(iChSym)*(nVec(iChSym)+1)/2)
         iAdr=0
         Call dDaFile(LuAMat,2,Work(ip_A),
     &                nVec(iChSym)*(nVec(iChSym)+1)/2,iAdr)
_
         Write(6,*) 'A-matrix in symm:',iChSym
         Do i = 0, nVec(iChSym)*(nVec(iChSym)+1)/2-1
            Write(6,*) Work(ip_A+i)
         End Do
         Call GetMem('A_mat','Free','Real',ip_A,
     &               nVec(iChSym)*(nVec(iChSym)+1)/2)
#endif
 1000    Continue
      End Do !iChSym



      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine get_dipole()
! Purpose :  Read in the dipole matrix from the MOLCAS output (SO)

use rhodyn_data, only: a_einstein, dipole, dysamp, dysamp_bas, E_SO, emiss, flag_dyson, flag_emiss, ipglob, ispin, lroots, &
                       lrootstot, N, prep_dipolei, prep_dipoler, prep_do, runmode, SO_CI
use rhodyn_utils, only: dashes, transform
use mh5, only: mh5_put_dset
use Constants, only: Zero, cZero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, j, k, l, ii, jj

if (ipglob > 2) then
  call dashes()
  write(u6,*) 'Begin get_dipole'
  call dashes()
end if

! To put the imaginary part of diagonal elements to 0 just in case
do j=1,lrootstot
  dipole(j,j,:) = real(dipole(j,j,:))
end do
! process Dyson amplitudes
if (flag_dyson .and. (N > 2)) then
  ! Transformation of Dyson amplitudes matrix to SF basis
  call transform(cmplx(dysamp,kind=wp),SO_CI,dysamp_bas,.false.)
  ! nullify non-neighbouring SF blocks, ii,jj - block indices
  ii = 0
  jj = 0
  do k=1,N
    do l=1,k
      if ((k-l) > 1) then
        do i=ii,(ii+lroots(k)*ispin(k))
          do j=jj,(jj+lroots(l)*ispin(l))
            dysamp_bas(i,j) = cZero
            dysamp_bas(j,i) = cZero
          end do
        end do
      end if
      jj = jj+lroots(l)*ispin(l)
    end do
    ii = ii+lroots(k)*ispin(k)
    jj = 0
  end do
else if (flag_dyson) then
  dysamp_bas(:,:) = dysamp
end if
if (flag_dyson) then
  dysamp_bas(:,:) = abs(dysamp_bas**2)
  if (ipglob > 2) write(u6,*) 'dysamp processing successfully finished'
end if

! calculate matrix of Einstein coefficient A if emission spectrum needed
!if ((DM_basis /= 'SO') .and. (DM_basis /= 'CSF_SO') .and. (DM_basis /= 'SF_SO')) then
!  flag_emiss=.False.
!  write(u6,*) 'Emission spectra can be calculated only if SOC  density matrix available. '// &
!              'Set DMBasis keyword to SO, CSF_SO, or SF_SO'
!end if
if (flag_emiss) then
  a_einstein = Zero
  emiss = Zero
  ii = 1
  do j=1,(lrootstot-1)
    do i=(j+1),lrootstot
      do k=1,3
        a_einstein(i,j) = a_einstein(i,j)+abs(dipole(i,j,k))**2
      end do
      ! write down frequencies
      emiss(ii) = abs(E_SO(i)-E_SO(j))
      a_einstein(i,j) = a_einstein(i,j)*emiss(ii)**3
      ii = ii+1
    end do
  end do
end if

if (runmode /= 4) then
  ! not CM case
  call mh5_put_dset(prep_dipoler,real(dipole))
  call mh5_put_dset(prep_dipolei,aimag(dipole))
  if (flag_dyson) then
    call mh5_put_dset(prep_do,real(dysamp_bas))
  end if
end if

if (ipglob > 2) write(u6,*) 'End get_dipole'

end subroutine get_dipole

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE LOOP14(KM,ISTOP,IT1,IT2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      ISTOP=0
      KM1=KM+1
      IDIF=IA(J1(KM1))-IA(J2(KM1))
      IF(IDIF.NE.1)GO TO 55
      IF(IWAY(KM).EQ.2)GO TO 55
      IWAY(KM)=2
C     (HE,FG)
      IF(K3(IT1+J1(KM1)).EQ.0.OR.K0(IT2+J2(KM1)).EQ.0)GO TO 55
      WM0=D0
      WP0=D0
      IF(K2F(JM1(KM1)).EQ.0)GO TO 141
      J2(KM)=K0(IT2+J2(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)
      WM0=BS4(IB(J2(KM1)))
      IF(K1F(JM(KM1)).EQ.0)GO TO 142
      GO TO 143
141   IF(K1F(JM(KM1)).EQ.0)GO TO 55
      J2(KM)=K0(IT2+J2(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM)=ICOUP(KM1)
143   WP0=BS3(IB(J2(KM1))+2)
142   COUP(KM)=WM0*COUP1(KM1)+WP0*COUP(KM1)
      GO TO 40
55    ISTOP=1
40      Continue
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Ignacio Fdez. Galvan                             *
************************************************************************
*  Transpose_TDM
*
*> @brief
*>   Transpose a transition density matrix in place.
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Transpose a transition density matrix, stored in symmetry blocks,
*> replacing the original matrix. The matrices contain only the symmetry
*> blocks that match the total symmetry of the transition.
*>
*> @param[in,out] TDM       Transition density matrix
*> @param[in]     Symmetry  Symmetry of the transition
************************************************************************
      Subroutine Transpose_TDM(TDM,Symmetry)
      Implicit None
      Real*8, Intent(InOut) :: TDM(*)
      Integer, Intent(In) :: Symmetry
#include "rassi.fh"
#include "symmul.fh"
#include "stdalloc.fh"
      Integer :: iSym1,iSym2,nTot,i,j
      Integer :: iBlock(0:8)
      Real*8, Allocatable :: Tmp(:)
* Compute the location of all the stored symmetry blocks
      nTot=0
      iBlock(0)=0
      Do iSym1=1,nSym
        iSym2=Mul(Symmetry,iSym1)
        nTot=nTot+nBasF(iSym1)*nBasF(iSym2)
        iBlock(iSym1)=nTot
      End Do
* Make a copy so we can transpose in place
      Call mma_Allocate(Tmp,nTot,Label='Tmp')
      Call dCopy_(nTot,TDM,1,Tmp,1)
* Transpose symmetry block (a,b) onto symmetry block (b,a)
      Do iSym1=1,nSym
        iSym2=Mul(Symmetry,iSym1)
        Do i=1,nBasF(iSym2)
          Do j=1,nBasF(iSym1)
            TDM(iBlock(iSym2-1)+(j-1)*nBasF(iSym2)+i) =
     &      Tmp(iBlock(iSym1-1)+(i-1)*nBasF(iSym1)+j)
          End Do
        End Do
      End Do
      Call mma_deAllocate(Tmp)
      End Subroutine

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*                                                                      *
      Subroutine dBMult(dCdQ,QC,nQQ,nDim,nLambda)
*                                                                      *
************************************************************************
*                                                                      *
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "db.fh"
      Real*8 dCdQ(nQQ,nLambda), QC(nDim**2,nLambda)
*
      Call FZero(QC,nDim**2*nLambda)
      If (ip_dB.eq.ip_Dummy) Then
         Return
      End If
      Call Allocate_Work(ipX,mq*nLambda)
      Call FZero(Work(ipX),mq*nLambda)
      Call Allocate_Work(ipK,mq*nQQ)
      Call Get_dArray('K',Work(ipK),mq*nQQ)
*
      Call DGEMM_('N','N',mq,nLambda,nQQ,
     &            1.0D0,Work(ipK),mq,
     &                  dCdQ,nQQ,
     &            0.0D0,Work(ipX),mq)
      Call Free_Work(ipK)
*
      idB = 0
      Do iq = 0, mq-1
         nElem = iWork(ip_nqB + iq)
         Do iElem = idB, idB + (nElem**2)-1
            dBqR=Work(ip_dB+iElem)
            iDim=iWork(iElem*2 + ip_idB  )
            jDim=iWork(iElem*2 + ip_idB+1)
            ijDim = (jDim-1)*nDim + iDim
            Do iLambda = 1, nLambda
               X = Work((iLambda-1)*mq + iq + ipX)
               QC(ijDim,iLambda) = QC(ijDim,iLambda)
     &                           + X * dBqR
            End Do
         End Do
         idB = idB + nElem**2
      End Do
      Call Free_Work(ipX)
*
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine dBPrint(nQQ,nDim)
*                                                                      *
************************************************************************
*                                                                      *
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
#include "db.fh"
      If (ip_dB.eq.ip_Dummy) Return
      Call GetMem('dBQQ','Allo','Real',ipBuf,nDim**2)
      Call Allocate_Work(ipK,mq*nQQ)
      Call Get_dArray('K',Work(ipK),mq*nQQ)
      Do iQQ = 1, nQQ
         Call FZero(Work(ipBuf),nDim**2)
         idB = 0
         Do iq = 0, mq-1
            nElem = iWork(ip_nqB + iq)
            rK = Work((iQQ-1)*mq + iq + ipK)
            Do iElem = idB, idB + (nElem**2)-1
               dBqR=Work(ip_dB+iElem)
               iDim=iWork(iElem*2 + ip_idB  )
               jDim=iWork(iElem*2 + ip_idB+1)
               ijDim = (jDim-1)*nDim + iDim + ipBuf-1
               Work(ijDim) = Work(ijDim) + rK * dBqR
            End Do
            idB = idB + nElem**2
         End Do
         Call RecPrt('dBQQ',' ',Work(ipBuf),nDim,nDim)
      End Do
      Call Free_Work(ipBuf)
*
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine dBuu(uM12,nQQ,nDim,g,Hss,Inv)
*                                                                      *
************************************************************************
*                                                                      *
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "real.fh"
#include "db.fh"
      Real*8 uM12(nDim), g(nQQ), Hss(nDim,nDim)
      Logical Inv
*
      If (ip_dB.eq.ip_Dummy) Then
         Call FZero(Hss,nDim**2)
         Return
      End If
      Call Allocate_Work(ipY,mq)
      Call Allocate_Work(ipK,mq*nQQ)
      Call Get_dArray('K',Work(ipK),mq*nQQ)
*
*     Compute Y(qR) = Sum_(Q) g(Q) rK(qR,Q)
*
      Call FZero(Work(ipY),mq)
      Do iQQ = 1, nQQ
         ipKk = (iQQ-1)*mq + ipK
         Call DaXpY_(mq,g(iQQ),Work(ipKk),1,Work(ipY),1)
      End Do
      Call Free_Work(ipK)
*
*     Compute Temp = Sum_(qR) Y(qR) * dB(qR)
*
      Call GetMem('temp','Allo','Real',ipTemp,nDim**2)
      Call FZero(Work(ipTemp),nDim**2)
      idB = 0
      Do iq = 0, mq-1
         YqR = Work(ipY+iq)
         nElem = iWork(ip_nqB + iq)
         Do iElem = idB, idB + (nElem**2)-1
            dBqR=Work(ip_dB+iElem)
            iDim=iWork(iElem*2 + ip_idB  )
            jDim=iWork(iElem*2 + ip_idB+1)
            ijDim = (jDim-1)*nDim + iDim + ipTemp-1
            Work(ijDim) = Work(ijDim) + YqR * dBqR
         End Do
         idB = idB + nElem**2
      End Do
      Call Free_Work(ipY)
*
      If (Inv) Call DScal_(nDim**2,-One,Work(ipTemp),1)
*
      Do i = 1, nDim
         Do j = 1, nDim
            xx = Sqrt(uM12(i)*uM12(j))
            ij = ipTemp + (j-1)*nDim + i - 1
            Hss(i,j) = Hss(i,j) +  Work(ij) / xx
         End Do
      End Do
*
      Call Free_Work(ipTemp)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine IndSft2(iCmp,iShell,iBas,jBas,kBas,lBas,
     &                   Shijij, iAO, iAOst, ijkl,SOint,nSOint,
     &                   iSOSym,nSOs)
************************************************************************
*  object: to sift and index the SO integrals.                         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          april '90                                                   *
************************************************************************
      use k2_arrays, only: Sew_Scr
      use SOAO_Info, only: iAOtSO, iOffSO
      use lw_Info
      use Gateway_Info, only: ThrInt
      use Symmetry_Info, only: nIrrep
      use sort_data, only: DimSyB, iStBin, lSll, mxSyP, nSkip, Square,
     &                     TriSyB
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
*
      Real*8 SOint(ijkl,nSOint)
      Integer iCmp(4), iShell(4), iAO(4), iAOst(4), iSOSym(2,nSOs)
      Logical Shijij, Shij, Shkl, qijij, qij, qkl
*     local array
      Integer iSym(0:7), jSym(0:7), kSym(0:7), lSym(0:7)
      Logical dupli
      Data tr1,tr2/0.0d0,0.0d0/
      Save tr1,tr2
      irout = 39
      iprint = nprint(irout)
*     iPrint=99
      k12=0
      k34=0
      If (iPrint.ge.49) Then
         r1=DDot_(ijkl*nSOInt,SOInt,1,[One],0)
         r2=DDot_(ijkl*nSOInt,SOInt,1,SOInt,1)
         tr1=tr1+r1
         tr2=tr2+r2
         Write (6,*) ' Sum=',r1,tr1
         Write (6,*) ' Dot=',r2,tr2
      End If
      If (iprint.ge.99)
     &   Call RecPrt(' in indsft:SOint ',' ',SOint,ijkl,nSOint)
      memSO2 = 0
*
*     allocate space to store integrals together with their
*     Symmetry batch and sequence number
*     To avoid conflicts in using memory this is done in the
*     subroutine PSOAO
*
      nUt=-1
*
*     quadruple loop over elements of the basis functions angular
*     description. loops are reduced to just produce unique SO integrals
*     observe that we will walk through the memory in AOint in a
*     sequential way.
*
      Shij = iShell(1).eq.iShell(2)
      Shkl = iShell(3).eq.iShell(4)
      Do 100 i1 = 1, iCmp(1)
         Do 101 j = 0, nIrrep-1
            ix = 0
            If (iAOtSO(iAO(1)+i1,j)>0) ix = 2**j
            iSym(j) = ix
101      Continue
         jCmpMx = iCmp(2)
         If (Shij) jCmpMx = i1
         Do 200 i2 = 1, jCmpMx
            Do 201 j = 0, nIrrep-1
               ix = 0
               If (iAOtSO(iAO(2)+i2,j)>0) ix = 2**j
               jSym(j) = ix
201         Continue
            qij = i1.eq.i2
            If (iShell(2).gt.iShell(1)) then
               i12 = iCmp(2)*(i1-1) + i2
            else
               i12 = iCmp(1)*(i2-1) + i1
            End If
            Do 300 i3 = 1, iCmp(3)
               Do 301 j = 0, nIrrep-1
                  ix = 0
                  If (iAOtSO(iAO(3)+i3,j)>0) ix = 2**j
                  kSym(j) = ix
301            Continue
               lCmpMx = iCmp(4)
               If (Shkl) lCmpMx = i3
               Do 400 i4 = 1, lCmpMx
                  Do 401 j = 0, nIrrep-1
                     ix = 0
                     If (iAOtSO(iAO(4)+i4,j)>0) ix = 2**j
                     lSym(j) = ix
401               Continue
                  qkl = i3.eq.i4
                  If (iShell(4).gt.iShell(3)) then
                     i34 = iCmp(4)*(i3-1) + i4
                  else
                     i34 = iCmp(3)*(i4-1) + i3
                  End If
                  If (Shijij .and. i34.gt.i12) go to 400
                  qijij = Shijij .and. i12.eq.i34
C          Write (6,*) 'i1,i2,i3,i4=',i1,i2,i3,i4
*
*      loop over Irreps which are spanned by the basis function.
*      again, the loop structure is restricted to ensure unique
*      integrals.
*
       Do 110 j1 = 0, nIrrep-1
          If (iSym(j1).eq.0) go to 110
          j2max = nIrrep-1
          If (Shij .and. qij) j2max = j1
          Do 210 j2 = 0, j2max
             If (jSym(j2).eq.0) go to 210
             j12 = ieor(j1,j2)
             If (qijij) then
                If (Shij .and. qij) then
                    k12 = j1*(j1+1)/2 + j2+1
                else If (Shij) then
                    k12 = nIrrep*j1 + j2+1
                else If (iShell(1).gt.iShell(2)) then
                    k12 = nIrrep*j1 + j2+1
                else
                    k12 = nIrrep*j2 + j1+1
                End If
             End If
*
             iSymi=max(j1,j2)+1
             jSymj=min(j1,j2)+1
*
             Do 310 j3 = 0, nIrrep-1
                If (kSym(j3).eq.0) go to 310
                j4 = ieor(j12,j3)
                If (lSym(j4).eq.0) go to 310
                If (Shkl .and. qkl .and. j4.gt.j3) go to 310
                If (qijij) then
                   If (Shkl .and. qkl) then
                      k34 = j3*(j3+1)/2 + j4+1
                   else If (Shkl) then
                      k34 = nIrrep*j3 + j4+1
                   else If (iShell(3).gt.iShell(4)) then
                      k34 = nIrrep*j3 + j4+1
                   else
                      k34 = nIrrep*j4 + j3+1
                   End If
                   If (k34.gt.k12) go to 310
                End If
C               Write (6,*) 'j1,j2,j3,j4=',j1,j2,j3,j4
*
                memSO2 = memSO2 + 1
                If ( (nSkip(j1+1)+nSkip(j2+1)+
     &                nSkip(j3+1)+nSkip(j4+1) ).ne.0 ) GoTo 310
*
*               Compute absolute starting SO index
                iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)+iOffSO(j1)
                jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)+iOffSO(j2)
                kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+iOffSO(j3)
                lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+iOffSO(j4)
C               Write (6,*) 'iSO,jSO,kSO,lSO=',iSO,jSO,kSO,lSO
*
                kSymk=max(j3,j4)+1
                lSyml=min(j3,j4)+1
*
                iSym12=TriSyB(iSymi,jSymj)
                iSym34=TriSyB(kSymk,lSyml)
*
*               Order Irrep index canonical
                If ( iSym34.gt.iSym12 ) then
                   iSyBlk= mxSyP*(iSym34-1)+iSym12
                   jSyBlk= mxSyP*(iSym12-1)+iSym34
                   nij=DimSyB(kSymk,lSyml)
                   nkl=DimSyB(iSymi,jSymj)
                   iSq1=nkl
                   iSq2=1
                   iSq3=1
                   iSq4=nij
                   iQQ1=lSll(iSyBlk)/nkl
                   iQQ2=nkl+1
                   iQQ3=nij+1
                   iQQ4=lSll(jSyBlk)/nij
                   iPP1=iQQ1
                   iPP2=0
                   iPP3=0
                   iPP4=iQQ4
                Else
                   iSyBlk= mxSyP*(iSym12-1)+iSym34
                   jSyBlk= mxSyP*(iSym34-1)+iSym12
                   nij=DimSyB(iSymi,jSymj)
                   nkl=DimSyB(kSymk,lSyml)
                   iSq1=1
                   iSq2=nkl
                   iSq3=nij
                   iSq4=1
                   iQQ1=nkl+1
                   iQQ2=lSll(iSyBlk)/nkl
                   iQQ3=lSll(jSyBlk)/nij
                   iQQ4=nij+1
                   iPP1=0
                   iPP2=iQQ2
                   iPP3=iQQ3
                   iPP4=0
                End If
C               Write (*,*) '<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
C               Write (*,*) 'iSyBlk,jSyBlk=',iSyBlk,jSyBlk
C               Write (*,*) 'iSq1,iSq2,iSq3,iSq4=',
C    &                       iSq1,iSq2,iSq3,iSq4
C               Write (*,*) 'iQQ1,iQQ2,iQQ3,iQQ4=',
C    &                       iQQ1,iQQ2,iQQ3,iQQ4
C               Write (*,*) 'nkl,nij=',
C    &                       nkl,nij
*
*               Duplicate integral if permuted integral is
*               in the same irrep or if all blocks should
*               be duplicated.
                dupli=(iSyBlk.eq.jSyBlk).or.Square
*
                If (.Not.dupli) Then
*
                nijkl = 0
                Do lSOl = lSO, lSO+lBas-1
                   Do kSOk = kSO, kSO+kBas-1
                      kl=iPD(kSOk,lSOl,iSOSym,nSOs)
                      Do jSOj = jSO, jSO+jBas-1
                         Do iSOi = iSO, iSO+iBas-1
                            nijkl = nijkl + 1
                            AInt=SOint(nijkl,memSO2)
                            If (Abs(AInt).lt.ThrInt) Go To 199
                            ij=iPD(iSOi,jSOj,iSOSym,nSOs)
C                           Write (*,*)
C                           Write (*,*) 'iSOi,jSOj,kSOk,lSOl=',
C    &                                   iSOi,jSOj,kSOk,lSO
C                           Write (*,*) 'ij,kl=',ij,kl
*
                            nUt=nUt+1
                            Sew_Scr(lwInt+nUt)=AInt
                            iBin=(kl-1)/iQQ1 +(ij-1)/iQQ2
                            iSqNum = (kl-iBin*iPP1)*iSq1
     &                             + (ij-iBin*iPP2)*iSq2
     &                             - nkl
                            Sew_Scr(lwSqN+nUt)=DBLE(iSqNum)
                            Sew_Scr(lwSyB+nUt)=DBLE(iBin+iStBin(iSyBlk))
C                           Write (*,*) 'iSqNum,iBin=',iSqNum,iBin+
C    &                                   iStBin(iSyBlk)
*
 199                        Continue
                         End Do
                      End Do
                   End Do
                End Do
*
                Else
*
                nijkl = 0
                Do lSOl = lSO, lSO+lBas-1
                   Do kSOk = kSO, kSO+kBas-1
                      kl=iPD(kSOk,lSOl,iSOSym,nSOs)
                      Do jSOj = jSO, jSO+jBas-1
                         Do iSOi = iSO, iSO+iBas-1
                            nijkl = nijkl + 1
                            AInt=SOint(nijkl,memSO2)
                            If (Abs(AInt).lt.ThrInt) Go To 299
                            ij=iPD(iSOi,jSOj,iSOSym,nSOs)
*
C                           Write (*,*)
C                           Write (*,*) 'iSOi,jSOj,kSOk,lSOl=',
C    &                                   iSOi,jSOj,kSOk,lSO
C                           Write (*,*) 'ij,kl=',ij,kl
*
                            nUt=nUt+1
                            Sew_Scr(lwInt+nUt)=AInt
                            iBin=(kl-1)/iQQ1 +(ij-1)/iQQ2
                            iSqNum = (kl-iBin*iPP1)*iSq1
     &                             + (ij-iBin*iPP2)*iSq2
     &                             - nkl
                            Sew_Scr(lwSqN+nUt)=DBLE(iSqNum)
                            Sew_Scr(lwSyB+nUt)=DBLE(iBin+iStBin(iSyBlk))
C                           Write (*,*) 'iSqNum,iBin=',iSqNum,iBin+
C    &                                   iStBin(iSyBlk)
*
                            nUt=nUt+1
                            Sew_Scr(lwInt+nUt)=AInt
                            jBin=(kl-1)/iQQ3 +(ij-1)/iQQ4
                            jSqNum = (kl-jBin*iPP3)*iSq3
     &                             + (ij-jBin*iPP4)*iSq4
     &                             - nij
                            Sew_Scr(lwSqN+nUt)=DBLE(jSqNum)
                            Sew_Scr(lwSyB+nUt)=DBLE(jBin+iStBin(jSyBlk))
C                           Write (*,*) 'jSqNum,jBin=',jSqNum,jBin+
C    &                                   iStBin(jSyBlk)
*
 299                        Continue
                         End Do
                      End Do
                   End Do
                End Do
*
                End If
*
310          Continue
210       Continue
110    Continue
*
400            Continue
300         Continue
200      Continue
100   Continue
*
*     pass the integral to phase 1 of the bin sorting algorithm
*
      Call R8PREP(nUt+1,Sew_Scr(lwInt))
      Call SORT1A(nUt+1,Sew_Scr(lwInt),Sew_Scr(lwSqN),Sew_Scr(lwSyB))
      nUt=0
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE NADIAG
      USE SUPERINDEX
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"

#include "SysDef.fh"

C Set up non-active diagonal elements of H0.


      DO 3000 ICASE=1,13
        DO 3001 ISYM=1,NSYM
          NIN=NINDEP(ISYM,ICASE)
          IF(NIN.EQ.0) GOTO 3001
          NIS=NISUP(ISYM,ICASE)
          NAS=NASUP(ISYM,ICASE)
          IF(ICASE.GT.11)
     &        CALL GETMEM('LBD','ALLO','REAL',LBD,NAS)
          CALL GETMEM('LID','ALLO','REAL',LID,NIS)
          GOTO (100,200,300,400,500,600,700,800,900,1000,
     &          1100,1200,1300) ICASE
          WRITE(6,*)'NADIAG: Fall through computed GOTO.'
          CALL ABEND()

C VJTU CASE:
 100  CONTINUE
      DO 110 IIS=1,NIS
        IIQ=IIS+NIES(ISYM)
        WORK(LID-1+IIS)= -EPSI(IIQ)
 110  CONTINUE
      GOTO 2000

C VJTIP CASE:
 200  CONTINUE
      DO 210 IIS=1,NIS
        IIQ=IIS+NIGEJES(ISYM)
        IIABS=MIGEJ(1,IIQ)
        IJABS=MIGEJ(2,IIQ)
        WORK(LID-1+IIS)= -EPSI(IIABS)-EPSI(IJABS)
 210  CONTINUE
      GOTO 2000

C VJTIM CASE:
 300  CONTINUE
      DO 310 IIS=1,NIS
        IIQ=IIS+NIGTJES(ISYM)
        IIABS=MIGTJ(1,IIQ)
        IJABS=MIGTJ(2,IIQ)
        WORK(LID-1+IIS)= -EPSI(IIABS)-EPSI(IJABS)
 310  CONTINUE
      GOTO 2000

C ATVX  CASE:
 400  CONTINUE
      DO 410 IIS=1,NIS
        IIQ=IIS+NSES(ISYM)
        WORK(LID-1+IIS)= +EPSE(IIQ)
 410  CONTINUE
      GOTO 2000

C AIVX  CASE:
 500  CONTINUE
      IIS=0
      DO 510 ISYMA=1,NSYM
        ISYMI=MUL(ISYMA,ISYM)
        DO 511 IA=1,NSSH(ISYMA)
          IAABS=IA+NSES(ISYMA)
          DO 512 II=1,NISH(ISYMI)
            IIABS=II+NIES(ISYMI)
            IIS=IIS+1
            EDIAG= -EPSI(IIABS)+EPSE(IAABS)
            WORK(LID-1+IIS)= EDIAG
 512      CONTINUE
 511    CONTINUE
 510  CONTINUE
      GOTO 2000

C VJAIP CASE:
 600  CONTINUE
      IIS=0
      DO 610 ISYMA=1,NSYM
        ISYMIJ=MUL(ISYMA,ISYM)
        DO 611 I2=1,NIGEJ(ISYMIJ)
          I2ABS=I2+NIGEJES(ISYMIJ)
          IIABS=MIGEJ(1,I2ABS)
          IJABS=MIGEJ(2,I2ABS)
          DO 612 IA=1,NSSH(ISYMA)
            IAABS=IA+NSES(ISYMA)
            IIS=IIS+1
            EDIAG= -EPSI(IIABS)-EPSI(IJABS)+EPSE(IAABS)
            WORK(LID-1+IIS)= EDIAG
 612      CONTINUE
 611    CONTINUE
 610  CONTINUE
      GOTO 2000

C VJAIM CASE:
 700  CONTINUE
      IIS=0
      DO 710 ISYMA=1,NSYM
        ISYMIJ=MUL(ISYMA,ISYM)
        DO 711 I2=1,NIGTJ(ISYMIJ)
          I2ABS=I2+NIGTJES(ISYMIJ)
          IIABS=MIGTJ(1,I2ABS)
          IJABS=MIGTJ(2,I2ABS)
          DO 712 IA=1,NSSH(ISYMA)
            IAABS=IA+NSES(ISYMA)
            IIS=IIS+1
            EDIAG= -EPSI(IIABS)-EPSI(IJABS)+EPSE(IAABS)
            WORK(LID-1+IIS)= EDIAG
 712      CONTINUE
 711    CONTINUE
 710  CONTINUE
      GOTO 2000

C BVATP CASE:
 800  CONTINUE
      DO 810 IIS=1,NIS
        IIQ=IIS+NAGEBES(ISYM)
        IAABS=MAGEB(1,IIQ)
        IBABS=MAGEB(2,IIQ)
        WORK(LID-1+IIS)= +EPSE(IAABS)+EPSE(IBABS)
 810  CONTINUE
      GOTO 2000

C BVATM CASE:
 900  CONTINUE
      DO 910 IIS=1,NIS
        IIQ=IIS+NAGTBES(ISYM)
        IAABS=MAGTB(1,IIQ)
        IBABS=MAGTB(2,IIQ)
        WORK(LID-1+IIS)= +EPSE(IAABS)+EPSE(IBABS)
 910  CONTINUE
      GOTO 2000

C BJATP CASE:
 1000 CONTINUE
      IIS=0
      DO 1010 ISYMI=1,NSYM
        ISYMAB=MUL(ISYMI,ISYM)
        DO 1011 I2=1,NAGEB(ISYMAB)
          I2ABS=I2+NAGEBES(ISYMAB)
          IAABS=MAGEB(1,I2ABS)
          IBABS=MAGEB(2,I2ABS)
          DO 1012 II=1,NISH(ISYMI)
            IIABS=II+NIES(ISYMI)
            IIS=IIS+1
            EDIAG= -EPSI(IIABS)+EPSE(IAABS)+EPSE(IBABS)
            WORK(LID-1+IIS)= EDIAG
 1012     CONTINUE
 1011   CONTINUE
 1010 CONTINUE
      GOTO 2000

C BJATM CASE:
 1100 CONTINUE
      IIS=0
      DO 1110 ISYMI=1,NSYM
        ISYMAB=MUL(ISYMI,ISYM)
        DO 1111 I2=1,NAGTB(ISYMAB)
          I2ABS=I2+NAGTBES(ISYMAB)
          IAABS=MAGTB(1,I2ABS)
          IBABS=MAGTB(2,I2ABS)
          DO 1112 II=1,NISH(ISYMI)
            IIABS=II+NIES(ISYMI)
            IIS=IIS+1
            EDIAG= -EPSI(IIABS)+EPSE(IAABS)+EPSE(IBABS)
            WORK(LID-1+IIS)= EDIAG
 1112     CONTINUE
 1111   CONTINUE
 1110 CONTINUE
      GOTO 2000

C BJAIP CASE:
 1200 CONTINUE
      DO 1210 IAB=1,NAGEB(ISYM)
        IABQ=IAB+NAGEBES(ISYM)
        IAABS=MAGEB(1,IABQ)
        IBABS=MAGEB(2,IABQ)
        IIS=IIS+1
        EDIAG= EPSE(IAABS)+EPSE(IBABS)
        WORK(LBD-1+IAB)= EDIAG
 1210 CONTINUE
      DO 1220 IIJ=1,NIGEJ(ISYM)
        IIJQ=IIJ+NIGEJES(ISYM)
        IIABS=MIGEJ(1,IIJQ)
        IJABS=MIGEJ(2,IIJQ)
        EDIAG= -EPSI(IIABS)-EPSI(IJABS)
        WORK(LID-1+IIJ)= EDIAG
 1220 CONTINUE
      GOTO 2000

C BJAIM CASE:
 1300 CONTINUE
      DO 1310 IAB=1,NAGTB(ISYM)
        IABQ=IAB+NAGTBES(ISYM)
        IAABS=MAGTB(1,IABQ)
        IBABS=MAGTB(2,IABQ)
        IIS=IIS+1
        EDIAG= EPSE(IAABS)+EPSE(IBABS)
        WORK(LBD-1+IAB)= EDIAG
 1310 CONTINUE
      DO 1320 IIJ=1,NIGTJ(ISYM)
        IIJQ=IIJ+NIGTJES(ISYM)
        IIABS=MIGTJ(1,IIJQ)
        IJABS=MIGTJ(2,IIJQ)
        EDIAG= -EPSI(IIABS)-EPSI(IJABS)
        WORK(LID-1+IIJ)= EDIAG
 1320 CONTINUE
      GOTO 2000

 2000 CONTINUE
C NOTE: BDIAG elements used in cases 12 & 13.
      IDID=IDBMAT(ISYM,ICASE)
      IF(ICASE.GT.11) THEN
        CALL DDAFILE(LUSBT,1,WORK(LBD),NAS,IDID)
        CALL GETMEM('LBD','FREE','REAL',LBD,NAS)
      ELSE
C Dummy read the BDIAG elements. NOTE: NAS, not NIN.
        CALL DDAFILE(LUSBT,0,WORK(1),NAS,IDID)
      END IF
      CALL DDAFILE(LUSBT,1,WORK(LID),NIS,IDID)
      CALL GETMEM('LID','FREE','REAL',LID,NIS)

 3001   CONTINUE
 3000 CONTINUE


      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
SUBROUTINE predict(gh)
  use kriging_mod
#include "stdalloc.fh"
  real*8 tsum
  integer INFO
  integer i,gh ! ipiv the pivot indices that define the permutation matrix
  real*8, Allocatable :: B(:), A(:,:)
  integer, Allocatable :: IPIV(:)
!
  Call mma_allocate(B,m_t,label="B")
!
    if (gh.eq.0) then

      !A contains the factors L and U from the factorization A = P*L*U as computed by DGETRF
      Call mma_allocate(A,m_t,m_t,label="A")
      Call mma_allocate(IPIV,m_t,label="IPIV")
      ! calculations of Energy and dispersion
      A(:,:) = full_R
      B(:) = cv(:,1,1)
      pred = sb + dot_product(B,Kv)
      CALL DGESV_(m_t, 1,A,m_t,IPIV,B,m_t,INFO )
      var = 1d0 - dot_product(B,CV(:,1,1))

      if (ordinary) Then
        tsum = sum(rones(1:m_t))
        B(:) = cv(:,1,1)
        var=max(var+(1d0-dot_product(B,rones))**2/tsum,0d0)
      end if

      sigma=sqrt(var*variance)
      Call mma_deallocate(A)
      Call mma_deallocate(IPIV)

    else if (gh.eq.1) then

      do k=1,nInter
        B(:) = cv(:,k,1)
        gpred(k) = dot_product(B,Kv)
      enddo

    else if (gh.eq.2) then

      do k=1,nInter
        do i=k,nInter
          B(:) = cv(:,i,k)
          hpred(k,i) = dot_product(B, Kv)
          if (i.ne.k) hpred(i,k) = hpred(k,i)
        enddo
      enddo

    endif
!
  Call mma_deallocate(B)
!
END SUBROUTINE predict

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine CNTOST(ICONF,ICTSDT,NAEL,NBEL,IPRODT,IREFSM,NORB,NEL,IGENSG,ISGNA,ISGNB,IAGRP,IBGRP,IOOS,PSSIGN)
! Obtain pointer abs(ICTSDT(I)) giving address of determinant I in
! STRING ordering for determinant I in CSF ordering.
! Going between the two formats can involve a sign change. this is
! stored in the sign of ICTSDT)
! SGNCTS is thus to be multiplied with vector ordered in CSF ordering.
!
! December 1990 : NCNFCN,ICNFOK added
! January 1991  : IGENSG,ISGNA,ISGNB added
! April   1991  : LUCIA version
! September 1993 > Sign and address stored together

use MCLR_Data, only: MINOP, NCNATS, NDPCNT, NTYP
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICONF(*), NAEL, NBEL, IPRODT(*), IREFSM, NORB, IGENSG, ISGNA(*), ISGNB(*), IAGRP, IBGRP, IOOS(*)
integer(kind=iwp), intent(_OUT_) :: ICTSDT(*)
integer(kind=iwp), intent(out) :: NEL
real(kind=wp), intent(in) :: PSSIGN
integer(kind=iwp) :: IABNUM, IC, ICL, ICNBS, ICNBS0, ICNF, IDET, IJKL_NUM, IOCC, IOPEN, IPBAS, IPSFAC, ISGN, ISGNAB, ITYP, JDET, &
                     JDTABS, MXDT
integer(kind=iwp), allocatable :: LDTBL(:), LIA(:), LIB(:), SCR23(:)

! IWORK should at least be of length (MXDT+2)*NEL,
! where MXDT is the largest number of prototype determinants occuring
! in a single block.

NEL = NAEL+NBEL

! Local memory

! Largest number of dets for a given type
MXDT = max(0,maxval(NDPCNT(1:NTYP)))
call mma_allocate(LDTBL,MXDT*NEL,Label='LDTBL')
call mma_allocate(LIA,NAEL,Label='LIA')
call mma_allocate(LIB,NBEL,Label='LIB')
call mma_allocate(SCR23,NEL,Label='SCR23')

! Loop over configurations and generate determinants in compact form

ICNF = 0
JDTABS = 0
IPSFAC = 0 ! Removes a compiler error
ISGNAB = 0 ! Removes a compiler error
ICNBS0 = 0 ! dummy initialize
IPBAS = 0  ! dummy initialize
ijkl_num = 0 !yma counter
do ITYP=1,NTYP
  IDET = NDPCNT(ITYP)
  IOPEN = ITYP+MINOP-1
  ICL = (NEL-IOPEN)/2
  IOCC = IOPEN+ICL
  if (ITYP == 1) then
    ICNBS0 = 1
  else
    ICNBS0 = ICNBS0+NCNATS(ITYP-1,IREFSM)*(NEL+IOPEN-1)/2
  end if
  ! Base for prototype determinants
  if (ITYP == 1) then
    IPBAS = 1
  else
    IPBAS = IPBAS+NDPCNT(ITYP-1)*(IOPEN-1)
  end if
  ! Determinants for this configuration
  do IC=1,NCNATS(ITYP,IREFSM)
    ICNF = ICNF+1
    ICNBS = ICNBS0+(IC-1)*(IOPEN+ICL)
    ! Check orbital occupancy with additional constraints
#   ifdef _DEBUGPRINT_
    write(u6,*) ' IC ICNF ICNBS',IC,ICNF,ICNBS
#   endif
    call CNDET_MCLR(ICONF(ICNBS),IPRODT(IPBAS),IDET,NEL,IOCC,IOPEN,ICL,LDTBL)
    ! Separate determinants into strings and determine string number.
    do JDET=1,IDET
      !write(117,'(1X,I8,1X,A,1X)',advance='no') ITYP,'ITYP'  ! yma
      JDTABS = JDTABS+1
      call DETSTR_MCLR(LDTBL(1+(JDET-1)*NEL),LIA,LIB,NEL,NAEL,NBEL,ISGN,SCR23)
      ijkl_num = ijkl_num+1
      ! Find number (and sign)of this determinant in string ordering
      ICTSDT(JDTABS) = IABNUM(LIA,LIB,IAGRP,IBGRP,IGENSG,ISGNA,ISGNB,ISGNAB,IOOS,NORB,IPSFAC,PSSIGN)
      if (ISGN*ISGNAB*IPSFAC == -1) ICTSDT(JDTABS) = -ICTSDT(JDTABS)
    end do
  end do
end do
call mma_deallocate(SCR23)
call mma_deallocate(LIB)
call mma_deallocate(LIA)
call mma_deallocate(LDTBL)

end subroutine CNTOST

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE INDMAT(ICSPCK,INTSYM,INDX,ISAB,JREFX,CISEL)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "mrci.fh"
      DIMENSION INDX(*),ICSPCK(*),INTSYM(*)
      DIMENSION ISAB(NVIRT,NVIRT),JREFX(*)
      DIMENSION CISEL(NREF,NSEL)
      CHARACTER*20 STR20
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CPAM97      JCASE(L)=UNPACK(CSPCK((L+29)/30), 2*L-(2*L-1)/60*60, 2)
      JCASE(L)=ICUNP(ICSPCK,L)
CPAM96      JSYM(L)=UNPACK(INTSYM((L+9)/10),3*MOD(L-1,10)+1,3)+1
      JSYM(L)=JSUNP(INTSYM,L)
C
      ILIM=4
      IF(IFIRST.NE.0)ILIM=2
      DO 5 I=1,NSYM
         NVPAIR(I)=0
5     CONTINUE
      ISMAX=0
      DO 15 NA=1,NVIRT
        DO 25 NB=1,NA
          NSAB=MUL(NSM(LN+NA),NSM(LN+NB))
          NVPAIR(NSAB)=NVPAIR(NSAB)+1
          ISAB(NA,NB)=NVPAIR(NSAB)
          ISMAX=MAX(ISMAX,ISAB(NA,NB))
          ISAB(NB,NA)=ISAB(NA,NB)
25      CONTINUE
        NDIAG(NA)=ISAB(NA,NA)
15    CONTINUE
C INDX - STARTING POINT IN CI VECTOR OF EACH BLOCK WITH A
C COMMON INTERNAL WALK.
C VALENCE CONFIGURATIONS:
      IR=IRC(1)
      DO 10 II=1,IR
        INDX(II)=II
10    CONTINUE
      JSC(1)=IR
C SINGLY EXCITED CONFIGURATIONS:
      IR1=IR+1
      IR2=IRC(2)
      IND=IR
      DO 20 II=IR1,IR2
         INDX(II)=IND
         NSS=MUL(JSYM(II),LSYM)
         IND=IND+NVIR(NSS)
20    CONTINUE
      JSC(2)=IND
      NCDOUB=IND-JSC(1)
      IF(IFIRST.EQ.0) THEN
C DOUBLY EXCITED CONFIGURATIONS:
        IR1=IR2+1
        IR2=IRC(4)
        JSC(3)=JSC(2)
        DO 30 II=IR1,IR2
           INDX(II)=IND
           NSS=MUL(JSYM(II),LSYM)
           IND=IND+NVPAIR(NSS)
           IF(II.EQ.IRC(3))JSC(3)=IND
30      CONTINUE
        JSC(4)=IND
        JJM=(JJS(LSYM+1)-JJS(LSYM))*NVIRT
        NCTRIP=JSC(3)-JSC(2)-JJM
        NCSING=JSC(4)-JSC(3)
      ELSE
        JJM=0
        NCTRIP=0
        NCSING=0
      END IF
      NCONF=JSC(ILIM)
C LIST THE REFERENCE CONFIGURATIONS, AND AT THE SAME TIME,
C IDENTIFY CSFS GIVEN IN SELECTION VECTOR INPUT:
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,*)'      LIST OF REFERENCE CONFIGURATIONS.'
      CALL XFLUSH(6)
      WRITE(6,*)'     CONF NR:    GUGA CASE NUMBERS OF ACTIVE ORBITALS:'
      CALL XFLUSH(6)
      DO 135 I=1,IRC(1)
        IREF=JREFX(I)
        IF(IREF.EQ.0) GOTO 135
        IREFX(IREF)=I
        IOFF=LN*(I-1)
        WRITE(6,'(5X,I6,7X,30I1)') I,(JCASE(IOFF+J),J=1,LN)
      CALL XFLUSH(6)
        JJ=0
        DO 134 ISEL=1,NSEL
          CISEL(IREF,ISEL)=0.0D00
          NC=NCOMP(ISEL)
          DO 133 IC=1,NC
            STR20=SSEL(JJ+IC)
            DO 132 ILEV=1,LN
              JCAS1=JCASE(IOFF+ILEV)
              READ(STR20(ILEV:ILEV),'(I1)') JCAS2
              IF(JCAS1.NE.JCAS2) GOTO 133
132         CONTINUE
            CISEL(IREF,ISEL)=CSEL(JJ+IC)
            JJ=JJ+NC
            GOTO 134
133       CONTINUE
          JJ=JJ+NC
134     CONTINUE
135   CONTINUE
C ORTHONORMALIZE THE SELECTION VECTORS:
      DO 137 ISEL=1,NSEL
        DO 136 JSEL=1,ISEL-1
          X=DDOT_(NREF,CISEL(1,JSEL),1,CISEL(1,ISEL),1)
          CALL DAXPY_(NREF,-X,CISEL(1,JSEL),1,CISEL(1,ISEL),1)
136     CONTINUE
        X=1.0D00/DDOT_(NREF,CISEL(1,ISEL),1,CISEL(1,ISEL),1)
        CALL DSCAL_(NREF,X,CISEL(1,ISEL),1)
137   CONTINUE
      WRITE(6,*)
      CALL XFLUSH(6)
      WRITE(6,*)'      REAL CONFIGURATIONS:'
      CALL XFLUSH(6)
      IF(IFIRST.EQ.0) THEN
        WRITE(6,215)NREF,NCVAL-NREF,NCDOUB,NCTRIP,NCSING
      CALL XFLUSH(6)
215     FORMAT(/,6X,'               REFERENCE ',I8,
     *         /,6X,'           OTHER VALENCE ',I8,
     *         /,6X,' DOUBLET COUPLED SINGLES ',I8,
     *         /,6X,' TRIPLET COUPLED DOUBLES ',I8,
     *         /,6X,' SINGLET COUPLED DOUBLES ',I8)
      ELSE
        WRITE(6,216)NREF,NCVAL-NREF,NCDOUB
      CALL XFLUSH(6)
216     FORMAT(/,6X,'               REFERENCE ',I8,
     *         /,6X,'           OTHER VALENCE ',I8,
     *         /,6X,' DOUBLET COUPLED SINGLES ',I8)
      END IF
      JSCI=JSC(ILIM)-JJM
      WRITE(6,'(6X,A,I8)')'                  TOTAL ',JSCI
      CALL XFLUSH(6)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE initial_surfacehop()
      use Tully_variables
      implicit none
#include "surfacehop.fh"
      logical Found
      real*8  DT
      tullyL=.false.
      decoherence=.false.
      DECO=0.0
      Ethreshold=huge(Ethreshold)
      RandThreshold=0.0
      tullySubVerb=.false.
      fixedrandL=.false.
      FixedRand=-1.0
      lH5Restart= .False.

      call qpg_dscalar('Timestep',Found)
      if (Found) then
         call Get_dScalar('Timestep',DT)
         NSUBSTEPS=Int(200*DT/41.3)
      else
         NSUBSTEPS=0
      end if
      end subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Per Ake Malmqvist                                *
!***********************************************************************

subroutine MKPROJ(CRVEC,CMO,TUVX)

use rasscf_global, only: CORESHIFT
use general_data, only: NASH, NBAS, NCRVEC, NTOT2
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CRVEC(NCRVEC), CMO(NTOT2)
real(kind=wp), intent(inout) :: TUVX(*)
integer(kind=iwp) :: IPOS, IT, ITU, IU, IV, IVX, IX, IXMX, NA, NB
real(kind=wp) :: COREPROJ, CS_TU, CS_TUV
real(kind=wp), allocatable :: CS_TMP(:)
real(kind=wp), external :: DDot_

NA = NASH(1)
NB = NBAS(1)

call mma_allocate(CS_TMP,NB,Label='CS_TMP')
do IT=1,NA
  CS_TMP(IT) = DDOT_(NB,CMO((IT-1)*NB+1),1,CRVEC,1)
end do

IPOS = 0
ITU = 0
do IT=1,NA
  do IU=1,IT
    CS_TU = CS_TMP(IT)*CS_TMP(IU)
    ITU = ITU+1
    IVX = 0
    do IV=1,IT
      CS_TUV = CS_TU*CS_TMP(IV)
      IXMX = IV
      if (IT == IV) IXMX = IU
      do IX=1,IXMX
        IVX = IVX+1
        IPOS = IPOS+1
        COREPROJ = CS_TUV*CS_TMP(IX)
        TUVX(IPOS) = TUVX(IPOS)+CORESHIFT*COREPROJ
      end do
    end do
  end do
end do

call mma_deallocate(CS_TMP)

end subroutine MKPROJ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FoundAtomicNumber(LuWr,Symb,NAT,iErr)

use isotopes, only: MaxAtomNum, PTab
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LuWr
character(len=6), intent(inout) :: Symb
integer(kind=iwp), intent(out) :: NAT, iErr
integer(kind=iwp) :: i

if ((Symb(1:1) <= 'z') .and. (Symb(1:1) >= 'a')) Symb(1:1) = char(ichar(Symb(1:1))-32)
if ((Symb(2:2) <= 'Z') .and. (Symb(2:2) >= 'A')) Symb(2:2) = char(ichar(Symb(2:2))+32)
iErr = 1

do i=1,MaxAtomNum
  if (Symb(1:2) == adjustl(PTab(i))) then
    iErr = 0
    NAT = i
    return
  end if
end do
do i=1,MaxAtomNum
  if (' '//Symb(1:1) == PTab(i)) then
    iErr = 0
    NAT = i
    return
  end if
end do

! --- Z atoms are ghost atoms that will disappear in seward
if (Symb(1:1) == 'Z') then
  iErr = 0
  NAT = -1
  return
end if
! --- X atoms are dummy atoms that will appear in seward
if (Symb(1:1) == 'X') then
  iErr = 0
  NAT = 0
  return
end if

write(LuWr,*) '   [FoundAtomicNumber]: Wrong atomic symbol !'

return

end subroutine FoundAtomicNumber

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Real*8 Function LDF_InteractionRange(A)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: return the max interatomic distance (in bohr) for atom
C              pairs in which atom A takes part.
C
C     Note: Atom to atom pair map must have been set up
C           (call LDF_SetA2AP()); if not, -1.0d0 is returned.
C
      Implicit None
      Integer A
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#include "ldf_a2ap.fh"

#if defined (_DEBUGPRINT_)
      Character*20 SecNam
      Parameter (SecNam='LDF_InteractionRange')
#endif

      Real*8   LDF_AtomicDistance
      External LDF_AtomicDistance

      Real*8  Rmax
      Integer n, ip, iAB, AB, A_, B_

      Integer i, j
      Integer A2AP
      Integer AP_Atoms
      A2AP(i,j)=iWork(ip_A2AP-1+2*(j-1)+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      LDF_InteractionRange=-1.0d0
      If (l_A2AP.gt.0) Then
         Rmax=-1.0d0
         n=A2AP(1,A)
         ip=A2AP(2,A)-1
         Do iAB=1,n
            AB=iWork(ip+iAB)
            A_=AP_Atoms(1,AB)
            B_=AP_Atoms(2,AB)
#if defined (_DEBUGPRINT_)
            If (A_.ne.A .and. B_.ne.A) Then
               Call WarningMessage(2,
     &                          SecNam//': A2AP info not properly set!')
               Call LDF_Quit(1)
            End If
#endif
            Rmax=max(Rmax,LDF_AtomicDistance(A_,B_))
         End Do
         LDF_InteractionRange=Rmax
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Luca De Vico                                           *
************************************************************************
*  Get_Nuc_Charge_All
*
*> @brief
*>   Get nuclear charges from RUNFILE
*> @author L. De Vico
*>
*> @details
*> Place nuclear charges (in a.u.) into array \p Charges_All(*).
*> Based on ::Get_Coord_All
*>
*> @param[out] Charges_All Array of charges
*> @param[in]  nAtoms_All  Number of atoms
************************************************************************
      Subroutine Get_Nuc_Charge_All(Charges_All,nAtoms_All)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Charges_All(nAtoms_All)
*
      Call Get_nAtoms_All(nAtoms_Allx)
      If (nAtoms_All.ne.nAtoms_Allx) Then
         Write (6,*) 'Get_Nuc_Charge_All: nAtoms_All.ne.nAtoms_Allx'
         Write (6,*) 'nAtoms_All=',nAtoms_All
         Write (6,*) 'nAtoms_Allx=',nAtoms_Allx
         Call Abend
      End If

      Call Get_iScalar('Unique atoms',nAtoms)

      Call Allocate_Work(ipCU,3*nAtoms)
      Call Get_dArray('Unique Coordinates',Work(ipCU),3*nAtoms)

      Call Allocate_Work(ipCMu, nAtoms)
      Call Get_dArray('Nuclear charge',Work(ipCMu),nAtoms)

      Call Get_Nuc_Charge_All_(Work(ipCU),Work(ipCMu),nAtoms,
     &                    Charges_All,nAtoms_All)

      Call Free_Work(ipCMu)
      Call Free_Work(ipCU)
*
      Return
      End
*                                                                      *
************************************************************************
*                                                                      *
      Subroutine Get_Nuc_Charge_All_(Coord_Unique,Charges_Unique,
     &                       nUnique_Atoms,Charges_All,nAll_Atoms)
      use Symmetry_Info, only: nIrrep, iOper, Symmetry_Info_Get
      Implicit None
#include "real.fh"
      Integer nUnique_Atoms, nAll_Atoms
      Real*8  Coord_Unique(3,nUnique_Atoms),
     &        Charges_Unique(nUnique_Atoms),
     &        Charges_All(nAll_Atoms)
      Integer iGen(3), iCoSet(0:7,0:7), iStab(0:7)
      Integer nGen, iAll_Atom, MaxDCR, iUnique_Atom, iChAtom, nStab,
     &        nCoSet, iCo, iChxyz
      Real*8 Charge_Old
      Integer, Save :: Active=0
*     Write (*,*) 'Enter Get_Nuc_Charge_All_'
*                                                                      *
************************************************************************
*                                                                      *
      if(Active.eq.0) then
       Call Symmetry_Info_Get
       Active=1
      endif
*     Write (*,*) 'Get_Nuc_Charge_All_: nIrrep=',nIrrep
*     Write (*,*) 'Get_Nuc_Charge_All_: iOper=',(iOper(i),i=0,nIrrep-1)
*                                                                      *
************************************************************************
*                                                                      *
      nGen=0
      If (nIrrep.eq.2) nGen=1
      If (nIrrep.eq.4) nGen=2
      If (nIrrep.eq.8) nGen=3
      If (nGen.ge.1) iGen(1)=iOper(1)
      If (nGen.ge.2) iGen(2)=iOper(2)
      If (nGen.eq.3) iGen(3)=iOper(4)
*                                                                      *
************************************************************************
*                                                                      *
*     Generate list of all nuclear charges
*
      iAll_Atom=0
      MaxDCR=0
      Do iUnique_Atom = 1, nUnique_Atoms
         iChAtom=iChxyz(Coord_Unique(1,iUnique_Atom),iGen,nGen)
         Call Stblz(iChAtom,nStab,iStab,MaxDCR,iCoSet)
         nCoSet=nIrrep/nStab

         Charge_Old = Charges_Unique(iUnique_Atom)

         Do iCo = 0, nCoSet-1
            iAll_Atom = iAll_Atom + 1
            Charges_All(iAll_Atom) = Charge_Old
         End Do
*
      End Do
*
*     Call RecPrt('Charges_Unique',' ',Charges_Unique,1,nUnique_Atoms)
*     Call RecPrt('Charges_All',' ',Charges_All,1,nAll_Atoms)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Process input to QMSTAT. All input variables are stored in
! qmstat_global which in turn are initialized in qmstat_init.
subroutine Get_Qmstat_Input(iQ_Atoms)

use qmstat_global, only: AddExt, Anal, ATitle, CAFieldG, CBFieldG, cDumpForm, CFExp, CharDi, CharDiQ, ContrStateB, Cordst, &
                         Cut_Elc, Cut_Ex1, Cut_Ex2, dCIRef, DelFi, DelOrAdd, DelR, DelX, Diel, DifSlExp, Disp, DispDamp, dLJRep, &
                         dLvlShift, EdSt, Enelim, ExtLabel, Exdt1, Exdtal, Exrep10, Exrep2, Exrep4, Exrep6, FieldDamp, Forcek, &
                         iCIInd, iCompExt, iExtr_Atm, iExtr_Eig, iExtra, iLuSaIn, iLuSaUt, iLuStIn, iLuStUt, iLvlShift, iNrIn, &
                         iNrUt, Inter, iOcc1, iOrb, iPrint, iRead, iSeed, itMax, Joblab, lCiSelect, lExtr, lMltSlC, lQuad, &
                         lSlater, MoAveRed, Mp2DensCorr, MxPut, nAdd, nAtom, nCent, nCha, nCIRef, nDel, nEqState, nExtAddOns, &
                         nLvlShift, nMacro, nMicro, nPart, nPol, NrFiles, NrStarti, NrStartu, NrStates, nSlSiteC, nStFilT, nTemp, &
                         ParallelT, ParaTemps, Pol, Pollim, Pres, Qmeq, QmProd, QmType, Qsta, QuaDi, QuaDiQ, rStart, SaFilIn, &
                         SaFilUt, ScalExt, Sexre1, Sexre2, Sexrep, SimEx, SingPoint, SlExpC, SlFactC, SlPC, StFilIn, StFilUt, &
                         Surf, Temp, ThrsCont, ThrsRedOcc, Udisp
use Index_Functions, only: nTri3_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iQ_Atoms
#include "warnings.h"
integer(kind=iwp) :: i, iChrct, iNrExtr, iTemp, j, kaunt, Last, LuRd, NExtr_Atm, njhr, nS, nT
real(kind=wp) :: CoTEMP1(3), CoTEMP2(3), CoTEMP3(3), CoTEMP4(3), CoTEMP5(3), dTemp, SlExpTemp, SlFacTemp(6)
logical(kind=iwp) :: Changed, YesNo(20)
character(len=180) :: Key
character(len=20) :: Kword
character(len=3) :: VecsQue
integer(kind=iwp), external :: iClast, IsFreeUnit
character(len=180), external :: Get_Ln
real(kind=wp), allocatable :: Tmp(:), Tmp2(:,:)

! Say what is done and set all YesNo to false; their purpose is to
! keep track on compulsory keywords and certain keyword combinations.

!write(u6,*)
!write(u6,*)'Input processed...'
YesNo(:) = .false.

! Use some nice routines to collect input.

LuRd = IsFreeUnit(79)
call SpoolInp(LuRd)
rewind(LuRd)
call RdNlst(LuRd,'QMSTAT')

! The turning-point in this do-while loop.

do

  ! Use Get_Ln to read the lines; it takes care of commented lines.

  Key = Get_Ln(LuRd)
  Kword = trim(Key)
  call UpCase(Kword)

  ! The keywords and their labels.

  select case (Kword(1:4))
    case default
      ! This code is only reached if an illegal keyword in the
      ! first tier is encountered.

      iChrct = len(Kword)
      Last = iCLast(Kword,iChrct)
      write(u6,*)
      write(u6,*) 'ERROR!'
      write(u6,'(1X,A,A)') Kword(1:Last),' is not a valid keyword!'
      call Quit(_RC_INPUT_ERROR_)

    case ('TITL')
      ! <<<TITLe>>>   Read title.

      Key = Get_Ln(LuRd)
      Joblab = trim(Key)
      ATitle = .true.

    case ('SIMU')
      ! <<<SIMUlation parameters>>>   Read a variety of simulation parameters.

      do
        Key = Get_Ln(LuRd)
        Kword = trim(Key)
        call UpCase(Kword)
        select case (KWord(1:4))
          case default
            ! Here we come if something gets wrong
            write(u6,*)
            write(u6,*) ' Unrecognized keyword in the SIMUlation parameter section:',Kword(1:4)
            call Quit(_RC_INPUT_ERROR_)
          case ('RADI')
            ! <<<RADIe>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,rStart)
          case ('PERM')
            ! <<<PERMitivity>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,Diel)
          case ('TEMP')
            ! <<<TEMPerature>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,Temp)
          case ('PRES')
            ! <<<PRESsure>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,Pres)
          case ('SURF')
            ! <<<SURFace>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,Surf)
          case ('TRAN')
            ! <<<TRANslation>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,DelX)
          case ('ROTA')
            ! <<<ROTAtion>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,DelFi)
          case ('CAVI')
            ! <<<CAVIty>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,DelR)
          case ('FORC')
            ! <<<FORCe>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,Forcek)
          case ('BREP')
            ! <<<BREPulsion>>>
            Key = Get_Ln(LuRd)
            call Get_F1(1,dLJRep)
          case ('SEED')
            ! <<<SEED>>>
            Key = Get_Ln(LuRd)
            call Get_I1(1,iSeed)
          case ('PARA')
            ! <<<PARAlleltemp>>>
            ParallelT = .true.
            Key = Get_Ln(LuRd)
            call Get_I1(1,nTemp)
            call mma_allocate(nStFilT,nTemp,label='nStFilT')
            call mma_allocate(Paratemps,nTemp,label='Paratemps')
            Key = Get_Ln(LuRd)
            call Get_I(1,nStFilT,nTemp)
            Key = Get_Ln(LuRd)
            call Get_F(1,ParaTemps,nTemp)
          case ('END ')
            ! <<<END simulation parameters>>>
            exit
        end select
      end do

    case ('THRE')
      ! <<<THREshold>>>    Get the polarization thresholds.

      Key = Get_Ln(LuRd)
      call Get_F1(1,Pollim)
      call Get_F1(2,Enelim)
      call Get_I1(3,itMax)

    case ('STEP')
      ! <<<STEPs>>>   Specify how many macro- and microsteps.

      Key = Get_Ln(LuRd)
      call Get_I1(1,nMacro)
      call Get_I1(2,nMicro)

    case ('RUN ')
      ! <<<RUN >>>   What type of simulation are we to run?

      Key = Get_Ln(LuRd)
      Kword = trim(Key)
      call UpCase(Kword)
      select case (Kword(1:4))
        case ('ANAL')
          Anal = .true.
        case ('QMEQ')
          Qmeq = .true.
        case ('QMPR')
          QmProd = .true.
          read(LuRd,*) Inter,iNrUt
          write(SaFilUt(6:6),'(i1.1)') iNrUt
          iLuSaUt = 32+iNrUt
        case default
          if (Kword(1:2) == 'SM') then
            write(u6,*)
            write(u6,*) 'No classical simulations are available.'
            call Quit(_RC_INPUT_ERROR_)
          end if
      end select
      YesNo(8) = .true.

    case ('PRIN')
      ! <<<PRINt>>>   Specify print-level.

      Key = Get_Ln(LuRd)
      call Get_I1(1,iPrint)

    case ('EXTE')
      ! <<<EXTErnal>>>   External one-electron perturbation
      !                  should be added on the hamiltonian.

      AddExt = .true.
      Key = Get_Ln(LuRd)
      call Get_I1(1,nExtAddOns)
      call mma_allocate(ScalExt,nExtAddOns,label='ScalExt')
      call mma_allocate(ExtLabel,nExtAddOns,label='ExtLabel')
      call mma_allocate(iCompExt,nExtAddOns,label='iCompExt')
      do i=1,nExtAddOns
        read(LuRd,*) ScalExt(i),ExtLabel(i),iCompExt(i)
      end do

    case ('EDIT')
      ! <<<EDITstartfile>>> Section for editing and displaying stuff on given startfile.

      do
        EdSt = .true.
        Key = Get_Ln(LuRd)
        Kword = trim(Key)
        call UpCase(Kword)
        select case (Kword(1:4))
          case default
            ! Here we come if something gets wrong
            write(u6,*)
            write(u6,*) ' Unrecognized keyword in the EDITstartfile section:',Kword(1:4)
            call Quit(_RC_INPUT_ERROR_)
          case ('DELE')
            ! <<<DELEte>>>   Delete solvent molecules.
            DelOrAdd(1) = .true.
            Key = Get_Ln(LuRd)
            call Get_I1(1,NrStarti)
            call Get_I1(2,NrStartu)
            Key = Get_Ln(LuRd)
            call Get_I1(1,nDel)
          case ('ADD ')
            ! <<<ADD >>>    Add solvent molecules.
            DelOrAdd(2) = .true.
            Key = Get_Ln(LuRd)
            call Get_I1(1,NrStarti)
            call Get_I1(2,NrStartu)
            Key = Get_Ln(LuRd)
            call Get_I1(1,nAdd)
          case ('QMDE')
            ! <<<QMDElete>>>   Substitute all slots with non-water coordinates with water coordinates.
            DelOrAdd(3) = .true.
            Key = Get_Ln(LuRd)
            call Get_I1(1,NrStarti)
            call Get_I1(2,NrStartu)
          case ('DUMP')
            ! <<<DUMP coordinates>>>  Dump coordinates in a way suitable for graphical display.
            DelOrAdd(4) = .true.
            Key = Get_Ln(LuRd)
            call UpCase(Key)
            cDumpForm = Key(1:4)
            Key = Get_Ln(LuRd)
            call Get_I1(1,NrStarti)
          case ('END ')
            ! <<<END editstartfile>>>
            write(StFilIn(6:6),'(i1.1)') NrStarti
            write(StFilUt(6:6),'(i1.1)') NrStartu
            exit
        end select
      end do

    case ('CONF')
      ! <<<CONFiguration>>>    Where is the initial configuration to be
      !                        obtained. Also, if we wish to edit the startfile.

      do
        Key = Get_Ln(LuRd)
        Kword = trim(Key)
        call UpCase(Kword)
        select case (Kword(1:4))
          case default
            ! Here we come if something gets wrong
            write(u6,*)
            write(u6,*) ' Unrecognized keyword in the CONFiguration section:',Kword(1:4)
            call Quit(_RC_INPUT_ERROR_)
          case ('ADD ')
            ! <<<ADD >>>  How many to add at random.
            Key = Get_Ln(LuRd)
            call Get_I1(1,iExtra)
            if (iExtra > MxPut) then
              write(u6,*)
              write(u6,*) 'The present limit of explicit solvent molecules is',MxPut,'.'
              call Quit(_RC_INPUT_ERROR_)
            end if
          case ('FILE')
            ! <<<FILE>>>  Read configuration/s from a file and put them there.
            Key = Get_Ln(LuRd)
            Kword = trim(Key)
            call UpCase(Kword)
            select case (Kword(1:4))
              case default
                ! CRASH-BOOM-BANG!
                write(u6,*)
                write(u6,*) ' Error in CONFiguration section, FILE subsection.'
                call Quit(_RC_INPUT_ERROR_)
              case ('STAR')
                ! <<<STARtfile>>>  Read from startfile.
                Key = Get_Ln(LuRd)
                Kword = trim(Key)
                call UpCase(Kword)
                select case (KWord(1:4))
                  case default
                    write(u6,*)
                    write(u6,*) 'Illegal StartFile option.'
                    call Quit(_RC_INPUT_ERROR_)
                  case ('SCRA')
                    ! <<<SCRAtch>>> Just put QM as given on RUNFILE.
                    Key = Get_Ln(LuRd)
                    call Get_I1(1,iNrIn)
                    call Get_I1(2,iNrUt)
                    iRead = 8
                  case ('COPY')
                    ! <<<COPY>>> Collect place of QM from startfile. WARNING!
                    !            You must use consistent startfile and RUNFILE!
                    Key = Get_Ln(LuRd)
                    call Get_I1(1,iNrIn)
                    call Get_I1(2,iNrUt)
                    iRead = 7
                  case ('CM  ')
                    ! <<<CM  >>> Put QM in CM of QM-place on startfile.
                    Key = Get_Ln(LuRd)
                    call Get_I1(1,iNrIn)
                    call Get_I1(2,iNrUt)
                    iRead = 6
                end select
              case ('SAMP')
                ! <<<SAMPfile>>>  Read configurations from sampfile and collect
                !                 the extracted information in iNrExtr.
                Key = Get_Ln(LuRd)
                call Get_I1(1,iNrIn)
                call Get_I1(2,iNrExtr)
                iRead = 9
                write(SimEx(6:6),'(i1.1)') iNrExtr
                YesNo(9) = .true.
            end select
            write(StFilIn(6:6),'(i1.1)') iNrIn
            write(StFilUt(6:6),'(i1.1)') iNrUt
            write(SaFilIn(6:6),'(i1.1)') iNrIn
            iLuStIn = 8+iNrIn
            iLuStUt = 16+iNrUt
            iLuSaIn = 24+iNrIn
          case ('INPU')
            ! <<<INPUt>>>  Signify that the first configuration will be given
            !              explicitly in input. The coordinates are then given
            !              in the solvent section.
            Key = Get_Ln(LuRd)
            call Get_I1(1,iNrUt)
            iLuStUt = 16+iNrUt
            YesNo(5) = .true. !User will give coords in input.
          case ('END ')
            YesNo(2) = .true. !Signify that source of starting conf. is specified.
            exit
        end select
      end do

    case ('QMSU')
      ! <<<QMSUrrounding>>>  Give parameters for the QM-Stat.Mech. interaction.

      do
        Key = Get_Ln(LuRd)
        Kword = trim(Key)
        call UpCase(Kword)
        select case (Kword(1:4))
          case default
            ! Here we only go if unrecognized keyword is encountered.
            write(u6,*)
            write(u6,*) ' Unrecognized keyword in the QMSUrrounding section:',Kword(1:4)
            call Quit(_RC_INPUT_ERROR_)
          case ('DPAR')
            ! <<<DPARameters>>>  Dispersion
            do i=1,iQ_Atoms
              Key = Get_Ln(LuRd)
              call Get_F(1,Udisp(1,i),1)
              call Get_F(2,Udisp(2,i),1)
            end do
          case ('ELEC')
            ! <<<ELECtrostatic>>> Electrostatic Slater Numbers
            do
              Key = Get_Ln(LuRd)
              Kword = trim(Key)
              call UpCase(Kword)
              select case (Kword(1:4))
                case default
                  write(u6,*)
                  write(u6,*) ' Error in QMSUrrounding section, ELECtrostatic subsection.'
                  call Quit(_RC_INPUT_ERROR_)
                case ('THRE')
                  ! <<<THREsholds>>>  First is the Cutoff (distance Quantum Site-
                  !                   Classical molecule) to evaluate Penetration
                  !                   effects. Second, difference between two Slater
                  !                   exponents to not be consider the same value.
                  Key = Get_Ln(LuRd)
                  call Get_F1(1,Cut_Elc)
                  call Get_F1(2,DifSlExp)
                case ('NOPE')
                  ! <<<NOPEnetration>>>  Electrostatic Penetration Not Computed
                  lSlater = .false.
                case ('QUAD')
                  ! <<QUADrupoles>>>  Electrostatic Penetration Computed in quadrupoles.
                  lQuad = .true.
                case ('END ')
                  ! <<<END Electrostatic>>>
                  exit
              end select
            end do
          case ('XPAR')
            ! <<<XPARameters>>>  Exchange repulsion
            do
              Key = Get_Ln(LuRd)
              Kword = trim(Key)
              call UpCase(Kword)
              select case (Kword(1:4))
                case default
                  write(u6,*)
                  write(u6,*) ' Error in QMSUrrounding section, XPARameters subsection.'
                  call Quit(_RC_INPUT_ERROR_)
                case ('S2  ')
                  ! <<<S2  >>>  The S2 parameter
                  Key = Get_Ln(LuRd)
                  call Get_F1(1,Exrep2)
                case ('S4  ')
                  ! <<<S4  >>>  The S4 parameter
                  Key = Get_Ln(LuRd)
                  call Get_F1(1,Exrep4)
                case ('S6  ')
                  ! <<<S6  >>>  The S6 parameter
                  Key = Get_Ln(LuRd)
                  call Get_F1(1,Exrep6)
                case ('S10 ')
                  ! <<<S10 >>>  The S10 parameter
                  Key = Get_Ln(LuRd)
                  call Get_F1(1,Exrep10)
                case ('CUTO')
                  ! <<<CUTOff>>> The cut-off radii for repulsion. The first is
                  !              outer radius that says EX=0 if R > Cut_Ex1, while
                  !              the second is a EX=infinity if R < Cut_Ex2.
                  Key = Get_Ln(LuRd)
                  call Get_F1(1,Cut_Ex1)
                  call Get_F1(2,Cut_Ex2)
                case ('END ')
                  ! <<<END xparameters>>>
                  exit
              end select
            end do
          case ('DAMP')
            ! <<<DAMPing>>>  Damping parameters for Qm-Surrounding interaction.
            do
              Key = Get_Ln(LuRd)
              Kword = trim(Key)
              call UpCase(Kword)
              select case (Kword(1:4))
                case default
                  write(u6,*)
                  write(u6,*) ' Error in QMSUrrounding section, DAMPing subsection.'
                  call Quit(_RC_INPUT_ERROR_)
                case ('DISP')
                  ! <<<DISPersion>>>  Dispersion damping parameters. This part
                  !                   should have a AUTO keyword which collects
                  !                   default parameters from the MpProp file.
                  DispDamp = .true.
                  Key = Get_Ln(LuRd)
                  ! Damping numbers for solvent
                  call Get_F(1,CharDi(1),1)
                  call Get_F(2,QuaDi(1,1),1)
                  call Get_F(3,QuaDi(2,1),1)
                  call Get_F(4,QuaDi(3,1),1)
                  Key = Get_Ln(LuRd)
                  call Get_F(1,CharDi(2),1)
                  call Get_F(2,QuaDi(1,2),1)
                  call Get_F(3,QuaDi(2,2),1)
                  call Get_F(4,QuaDi(3,2),1)
                  ! Damping numbers for solute
                  call mma_allocate(CharDiQ,iQ_Atoms,label='CharDiQ')
                  call mma_allocate(QuaDiQ,3,iQ_Atoms,label='QuaDiQ')
                  do i=1,iQ_Atoms
                    Key = Get_Ln(LuRd)
                    call Get_F(1,CharDiQ(i),1)
                    call Get_F(2,QuaDiQ(1,i),1)
                    call Get_F(3,QuaDiQ(2,i),1)
                    call Get_F(4,QuaDiQ(3,i),1)
                  end do
                case ('FIEL')
                  ! <<<FIELd>>> Parameters for damping electric field.
                  FieldDamp = .true.
                  Key = Get_Ln(LuRd)
                  call Get_F1(1,CAFieldG)
                  call Get_F1(2,CBFieldG)
                  call Get_F1(3,CFExp)
                case ('END ')
                  ! <<<END damping>>>
                  exit
              end select
            end do
          case ('END ')
            ! <<<END qmsurrounding>>>
            exit
        end select
      end do

    case ('SOLV')
      ! <<<SOLVent>>>  Specify stuff about the solvent. Usually, these
      !                parameters should not be altered.

      do
        Key = Get_Ln(LuRd)
        Kword = trim(Key)
        call UpCase(Kword)
        select case (KWord(1:4))
          case default
            ! The bla bla bla if something gets wrong.
            write(u6,*)
            write(u6,*) ' Unrecognized keyword in the SOLVent section:',Kword(1:4)
            call Quit(_RC_INPUT_ERROR_)
          case ('EXCH')
            ! <<<EXCHange>>>  Exchange repulsion parameters to solvent-solvent.
            do i=1,nAtom
              do j=1,i
                Key = Get_Ln(LuRd)
                call Get_F(1,Sexrep(i,j),1)
                call Get_F(2,Sexre1(i,j),1)
                call Get_F(3,Sexre2(i,j),1)
                Sexrep(j,i) = Sexrep(i,j)
                Sexre1(j,i) = Sexre1(i,j)
                Sexre2(j,i) = Sexre2(i,j)
              end do
            end do
          case ('DISP')
            ! <<<DISPersion>>>  Dispersion parameters to solvent-solvent.
            do i=1,nPol
              do j=1,i
                Key = Get_Ln(LuRd)
                call Get_F(1,Disp(i,j),1)
                Disp(j,i) = Disp(i,j)
              end do
            end do
          case ('COOR')
            ! <<<COORdinates>>>  Explicitly given coordinates of solvent
            !                    molecules. Also need number of particles.
            YesNo(6) = .true. !Signify that user gives coordinates.
            Key = Get_Ln(LuRd)
            call Get_I1(1,nPart)
            kaunt = 0
            do i=1,nPart
              do j=1,nAtom
                kaunt = kaunt+1
                Key = Get_Ln(LuRd)
                call Get_F(1,Cordst(1,kaunt),1)
                call Get_F(2,Cordst(2,kaunt),1)
                call Get_F(3,Cordst(3,kaunt),1)
              end do
              CoTEMP1(:) = Cordst(:,kaunt-2)
              CoTEMP2(:) = Cordst(:,kaunt-1)
              CoTEMP3(:) = Cordst(:,kaunt-0)
              call OffAtom(CoTEMP1,CoTEMP2,CoTEMP3,CoTEMP4,CoTEMP5)
              kaunt = kaunt+1
              Cordst(:,kaunt) = CoTEMP4(:)
              kaunt = kaunt+1
              Cordst(:,kaunt) = CoTEMP5(:)
            end do
          case ('CAVR')
            ! <<<CAVRepulsion>>>  Repulsion parameters between solvent and cavity boundary.
            Key = Get_Ln(LuRd)
            call Get_F1(1,Exdtal)
            call Get_F1(2,Exdt1)
          case ('OCOR')
            ! <<<OCORbitals>>>  Occupied Orbitals for the solvent molecule
            Key = Get_Ln(LuRd)
            call Get_I(1,iOrb(2),1)
          case ('ATCE')
            ! <<<ATCEchpol>>>  Number of atoms, centers, charges and polarizabilities.
            ! Jose Slater Sites
            Key = Get_Ln(LuRd)
            call Get_I1(1,nAtom)
            call Get_I1(2,nCent)
            call Get_I1(3,nCha)
            call Get_I1(4,nPol)
            call Get_I1(5,nSlSiteC)
            ! Reallocate Qsta
            call mma_allocate(Tmp,max(size(Qsta),nCha),label='Tmp')
            Tmp(1:size(Qsta)) = Qsta
            call mma_deallocate(Qsta)
            call move_alloc(Tmp,Qsta)
            ! Reallocate Pol
            call mma_allocate(Tmp,max(size(Pol),nPol),label='Tmp')
            Tmp(1:size(Pol)) = Pol
            call mma_deallocate(Pol)
            call move_alloc(Tmp,Pol)
            ! Reallocate Disp
            call mma_allocate(Tmp2,max(size(Disp,1),nPol),max(size(Disp,2),nPol),label='Tmp')
            Tmp2(1:size(Disp,1),1:size(Disp,2)) = Disp
            call mma_deallocate(Disp)
            call move_alloc(Tmp2,Disp)
            ! Reallocate SlExpC
            call mma_allocate(Tmp2,4,max(size(SlExpC,2),nSlSiteC),label='Tmp')
            Tmp2(:,1:size(SlExpC,2)) = SlExpC
            call mma_deallocate(SlExpC)
            call move_alloc(Tmp2,SlExpC)
            ! Reallocate SlFactC
            call mma_allocate(Tmp2,4,max(size(SlFactC,2),nSlSiteC),label='Tmp')
            Tmp2(:,1:size(SlFactC,2)) = SlFactC
            call mma_deallocate(SlFactC)
            call move_alloc(Tmp2,SlFactC)
            ! Reallocate SlPC
            call mma_allocate(Tmp,max(size(SlPC),nSlSiteC),label='Tmp')
            Tmp(1:size(SlPC)) = SlPC
            call mma_deallocate(SlPC)
            call move_alloc(Tmp,SlPC)
            ! Reallocate Sexrep
            call mma_allocate(Tmp2,max(size(Sexrep,1),nAtom),max(size(Sexrep,2),nAtom),label='Tmp')
            Tmp2(1:size(Sexrep,1),1:size(Sexrep,2)) = Sexrep
            call mma_deallocate(Sexrep)
            call move_alloc(Tmp2,Sexrep)
            ! Reallocate Sexre1
            call mma_allocate(Tmp2,max(size(Sexre1,1),nAtom),max(size(Sexre1,2),nAtom),label='Tmp')
            Tmp2(1:size(Sexre1,1),1:size(Sexre1,2)) = Sexre1
            call mma_deallocate(Sexre1)
            call move_alloc(Tmp2,Sexre1)
            ! Reallocate Sexre2
            call mma_allocate(Tmp2,max(size(Sexre2,1),nAtom),max(size(Sexre2,2),nAtom),label='Tmp')
            Tmp2(1:size(Sexre2,1),1:size(Sexre2,2)) = Sexre2
            call mma_deallocate(Sexre2)
            call move_alloc(Tmp2,Sexre2)
          case ('CHAR')
            ! <<<CHARge>>>  Magnitude of the charges.
            Key = Get_Ln(LuRd)
            call Get_F(1,Qsta,nCha)
          case ('POLA')
            ! <<<POLArizability>>>  Magnitude of polarizabilities.
            Key = Get_Ln(LuRd)
            call Get_F(1,Pol,nPol)
          case ('SLAT')
            !Jose+++++++++++++
            ! <<<SLATer>>> Magnitude of Slater PreFactors and Exponents.
            Key = Get_Ln(LuRd)
            call Get_I1(1,lMltSlC)
            if (lMltSlC > 1) then
              write(u6,*)
              write(u6,*) 'Too high order of multipole in classical system'
              write(u6,*) '              Highest order is 1'
              call Quit(_RC_INPUT_ERROR_)
            end if
            do i=1,nSlSiteC
              do j=0,lMltSlC
                nS = nTri3_Elem(j)
                nT = nTri3_Elem(j+1)
                Key = Get_Ln(LuRd)
                call Get_F1(1,SlExpTemp)
                SlExpC(j+1,i) = SlExpTemp
                njhr = nT-nS
                Key = Get_Ln(LuRd)
                call Get_F(1,SlFacTemp,njhr)
                SlFactC(nS+1:nT,i) = SlFacTemp(1:nT-nS)
              end do
              Key = Get_Ln(LuRd)
              call Get_F(1,SlPC(i),1)
            end do
            !+++++++++++++++++
          case ('END ')
            ! <<<END solvent>>>
            exit
        end select
      end do

    case ('RASS')
      ! <<<RASSisection>>>  Give some numbers specific for the handling
      !                     of the RASSI-construction of the wave-func.

      QmType = 'RASSI'
      do
        Key = Get_Ln(LuRd)
        Kword = trim(Key)
        call UpCase(Kword)
        select case (Kword(1:4))
          case default
            ! HOW COULD IT GET WRONG HERE?
            write(u6,*)
            write(u6,*) ' Unrecognized keyword in the RASSisection section:',Kword(1:4)
            call Quit(_RC_INPUT_ERROR_)
          case ('JOBF')
            ! <<<JOBFiles>>>  How many jobfiles and how many states in them.
            Key = Get_Ln(LuRd)
            call Get_I1(1,NrFiles)
            call mma_allocate(NrStates,NrFiles,label='NrStates')
            Key = Get_Ln(LuRd)
            call Get_I(1,NrStates,NrFiles)
          case ('EQST')
            ! <<<EQSTate>>> Which state is to be equilibrated.
            Key = Get_Ln(LuRd)
            call Get_I1(1,nEqState)
          case ('MORE')
            ! <<<MOREduce>>> Work in reduced MO-basis.
            Key = Get_Ln(LuRd)
            call Get_F1(1,ThrsRedOcc)
            MoAveRed = .true.
          case ('CONT')
            ! <<<CONTract>>> Contract the RASSI state basis.
            Key = Get_Ln(LuRd)
            call Get_F1(1,ThrsCont)
            ContrStateB = .true.
          case ('LEVE')
            ! <<<LEVElshift>>> Introduce levelshift of RASSI states.
            Key = Get_Ln(LuRd)
            call Get_I1(1,nLvlShift)
            call mma_allocate(iLvlShift,nLvlShift,label='iLvlShift')
            call mma_allocate(dLvlShift,nLvlShift,label='dLvlShift')
            Key = Get_Ln(LuRd)
            call Get_I(1,iLvlShift,nLvlShift)
            Key = Get_Ln(LuRd)
            call Get_F(1,dLvlShift,nLvlShift)
            ! Just a little sorting.
            do
              Changed = .false.
              do i=1,nLvlShift-1
                if (iLvlShift(i) > iLvlShift(i+1)) then
                  iTemp = iLvlShift(i)
                  iLvlShift(i) = iLvlShift(i+1)
                  iLvlShift(i+1) = iTemp
                  dTemp = dLvlShift(i)
                  dLvlShift(i) = dLvlShift(i+1)
                  dLvlShift(i+1) = dTemp
                  Changed = .true.
                end if
              end do
              if (.not. Changed) exit
            end do
          case ('CISE')
            ! <<<CISElect>>> Use overlap criterion in choosing state.
            lCiSelect = .true.
            call mma_allocate(iCIInd,nCIRef,label='iCIInd')
            call mma_allocate(dCIRef,nCIRef,label='dCIRef')
            Key = Get_Ln(LuRd)
            call Get_I1(1,nCIRef)
            Key = Get_Ln(LuRd)
            call Get_I(1,iCIInd,nCIRef)
            Key = Get_Ln(LuRd)
            call Get_F(1,dCIRef,nCIRef)
          case ('END ')
            ! <<<END rassisection>>>
            YesNo(3) = .true.  !Rassi section has been visited.
            exit
        end select
      end do

    case ('SCFS')
      ! <<<SCFSection>>>   Numbers for a SCF-QmStat run.

      QmType = 'SCF'
      do
        Key = Get_Ln(LuRd)
        Kword = trim(Key)
        call UpCase(Kword)
        select case (Kword(1:4))
          case default
            ! ETWAS FALSCH!
            write(u6,*)
            write(u6,*) ' Unrecognized keyword in the SCFSection:',Kword(1:4)
            call Quit(_RC_INPUT_ERROR_)
          case ('ORBI')
            ! <<<ORBItals>>>  Specifiy the reduced orbital space in which the problem is solved.
            Key = Get_Ln(LuRd)
            call Get_I(1,iOrb(1),1)
            call Get_I1(2,iOcc1)
          case ('MP2D')
            ! <<<MP2Denscorr>>>
            Mp2DensCorr = .true.
          case ('END ')
            ! <<<END scfsection>>>
            YesNo(4) = .true.  !Scf section has been visited.
            exit
        end select
      end do

    case ('SING')
      ! <<<SINGle-point>>>   Signify that a set of single point calculations are to be done.

      SingPoint = .true.
      YesNo(7) = .true.

    case ('ANAL')
      ! <<<ANALyze section>>> Give details what analysis of the sampfile coordinates that is to be done.

    case ('EXTR')
      ! <<<EXTRact section>>> Give details what QM and QM/MM analysis
      !                       that is to be done from the sampfile coordinates.

      do
        Key = Get_Ln(LuRd)
        Kword = trim(Key)
        call UpCase(Kword)
        select case (Kword(1:4))
          case default
            ! ETWAS FALSCH!
            write(u6,*)
            write(u6,*) ' Unrecognized keyword in the EXTRact section:',Kword(1:4)
            call Quit(_RC_INPUT_ERROR_)
          case ('TOTA')
            ! <<<TOTAl energy>>>
            lExtr(1) = .true.
          case ('DIPO')
            ! <<<DIPOle>>>
            lExtr(2) = .true.
          case ('QUAD')
            ! <<<QUADrupole>>>
            lExtr(3) = .true.
          case ('EIGE')
            ! <<<EIGEn things>>>
            lExtr(4) = .true.
            Key = Get_Ln(LuRd)
            call Get_I1(1,iExtr_Eig)
            call Get_S(2,VecsQue,1)
            call UpCase(VecsQue)
            if (VecsQue(1:3) == 'YES') lExtr(5) = .true.
          case ('EXPE')
            ! <<<EXPEctation values>>>
            lExtr(6) = .true.
          case ('ELOC')
            ! <<<ELOCal>>>
            lExtr(7) = .true.
            Key = Get_Ln(LuRd)
            call Get_I1(1,NExtr_Atm)
            call mma_deallocate(iExtr_Atm)
            call mma_allocate(iExtr_Atm,NExtr_Atm,label='iExtr_Atm')
            Key = Get_Ln(LuRd)
            call Get_I(1,iExtr_Atm,NExtr_Atm)
          case ('MESP')
            !*****JoseMEP****************
            ! <<<MESP>>>
            ! The Main Electrostatic potential, field and field gradients will
            ! be obtained in order to produce perturbation integrals that will
            ! be used to optimize the intramolecular geometry of the QM system.
            lExtr(8) = .true.
            !*****************************
          case ('END ')
            ! <<<END extract section>>>
            YesNo(10) = .true.
        end select
      end do

    case ('END ')
      ! <<<END >>>

      exit

  end select
end do

! Check if mandatory input was included and that no blatant
! inconsistencies exist. Not fool-proof, fools!

call MandatoryInp(YesNo)

! Good bye.

return

end subroutine Get_Qmstat_Input

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_W1(W1,aSGrp,beSGrp,bSGrp,gaSGrp)
! cek W1

use Index_Functions, only: nTri_Elem
use chcc_global, only: nv, Q4
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: W1(nTri_Elem(nv/2-1),nTri_Elem(nv/2))
integer(kind=iwp), intent(in) :: aSGrp, beSGrp, bSGrp, gaSGrp
integer(kind=iwp) :: a, ab, ap, b, bad, be, bega, bep, bp, ga, gap
real(kind=wp) :: s

if (aSGrp == 2) then
  ap = nv/2
else
  ap = 0
end if

if (bSGrp == 2) then
  bp = nv/2
else
  bp = 0
end if

if (gaSGrp == 2) then
  gap = nv/2
else
  gap = 0
end if

if (beSGrp == 2) then
  bep = nv/2
else
  bep = 0
end if

bad = 0
bega = 0
do be=1,nv/2
  do ga=1,be
    bega = bega+1
    ab = 0
    do a=2,nv/2
      do b=1,a-1
        ab = ab+1
        s = (Q4(ap+a,bep+be,bp+b,gap+ga)+Q4(ap+a,gap+ga,bp+b,bep+be))/1
        if (abs(W1(ab,bega)-s) > 1.0e-10_wp) then
          bad = bad+1
          !write(u6,99) a,b,be,ga,ab,bega,s,W1(a,be,ga)
          !99 format(4(i2,1x),2(i6,1x),2(f15.10))
        end if
        W1(ab,bega) = s
      end do
    end do
  end do
end do

if (bad == 0) then
  write(u6,*) ' Chck W OK ',bad
else
  write(u6,*) ' Chck W Bug !!!!!!! ',bad
end if

return

end subroutine Chck_W1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2022, Jie J. Bao                                       *
************************************************************************
******************************************************************
* history:                                                       *
* Jie J. Bao, on Apr. 12, 2022, created this file.               *
******************************************************************

*This file contains subroutines that calculates the DDg matrix, Q_aa,
* the Gradient and Hessian of Q_aa wrt intermediate-state rotations.

************************************************************************
      Subroutine CalcDDg(DDg,GD,Dg,nDDg,nGD,lRoots2,NAC2)
******************************************************************
*     Gtuvx : two-electron integral, g_tuvx                      *
*     GD    : "generalized 1-e density matrix"                   *
*              GD^KL: transition density matrix from L to K      *
*              GD^KK: density matrix for state K                 *
*     Dg    :  sum_{vx}{GD^KL_vx * g_tuvx}                       *
*     In GDorbit and Dgorbit, the leading index is orbital index;*
*     In GDstate and Dgstate, the leading index is state index.  *
*                                                                *
*     DDg   :  sum_{tuvx}{GD^KL_tu * GD^MN_vx * g_tuvx}          *
*      namely, sum_{tu}{GD^KL_tu * Dg^MN_tu}                     *
******************************************************************
      INTEGER nDDg, nGD, lRoots2, NAC2
      Real*8 DDg(nDDg),GD(nGD),Dg(nGD)


      CALL DGEMM_('T','N',lRoots2,lRoots2,NAC2,
     &               1.0d0, Dg, NAC2, GD, NAC2,
     &               0.0d0, DDg, lRoots2)

      RETURN
      End Subroutine

************************************************************************


      Subroutine CalcHessCMS(Hess,DDg,nDDg,lRoots,nSPair)
      INTEGER nDDg,lRoots,nSPair
      Real*8 DDg(nDDg),Hess(nSPair**2)
      Real*8 Vklmn,Vlknm,Vklnm,Vlkmn
      INTEGER K,L,M,N,iKL,iMN,iLoc1,iLoc2,iLoc3,iLoc4,iLoc5,
     &        lRoots2,lRoots3,lRoots23

      lRoots2=lRoots**2
      lRoots3=lRoots2*lRoots
      lRoots23=lRoots2+lRoots3

      DO K=2,lRoots
      DO L=1,K-1
       iKL=(K-2)*(K-1)/2+L
       Do M=2,lRoots
       Do N=1,M-1
        iMN=(M-2)*(M-1)/2+N
        Vklmn=0.0d0
        Vlknm=0.0d0
        Vlkmn=0.0d0
        Vklnm=0.0d0
        iLoc5=K+(L-1)*lRoots+(M-1)*lRoots2+(N-1)*lRoots3
        IF(L.eq.M) THEN
         iLoc4=K+(N-1)*lRoots
         iLoc1=iLoc4+(K-1)*lRoots23
         iLoc2=iLoc4+(N-1)*lRoots23
         iLoc3=iLoc4+(L-1)*lRoots23
         Vklmn=DDg(iLoc1)+DDg(iLoc2)-2.0d0*DDg(iLoc3)-4.0d0*DDg(iLoc5)
C         Vklmn=DDg(K,N,K,K)+DDg(K,N,N,N)-2.0d0*DDg(K,N,L,L)
C     &         -4.0d0*DDg(K,L,M,N)
        END IF
        IF(K.eq.N) THEN
         iLoc4=L+(M-1)*lRoots
         iLoc1=iLoc4+(L-1)*lRoots23
         iLoc2=iLoc4+(M-1)*lRoots23
         iLoc3=iLoc4+(K-1)*lRoots23
         Vlknm=DDg(iLoc1)+DDg(iLoc2)-2.0d0*DDg(iLoc3)-4.0d0*DDg(iLoc5)
C         Vlknm=DDg(L,M,L,L)+DDg(L,M,M,M)-2.0d0*DDg(L,M,K,K)
C     &         -4.0d0*DDg(K,L,M,N)
        END IF
        IF(K.eq.M) THEN
         iLoc4=L+(N-1)*lRoots
         iLoc1=iLoc4+(L-1)*lRoots23
         iLoc2=iLoc4+(N-1)*lRoots23
         iLoc3=iLoc4+(K-1)*lRoots23
         Vlkmn=DDg(iLoc1)+DDg(iLoc2)-2.0d0*DDg(iLoc3)-4.0d0*DDg(iLoc5)
C         Vlkmn=DDg(L,N,L,L)+DDg(L,N,N,N)-2.0d0*DDg(L,N,K,K)
C     &         -4.0d0*DDg(K,L,M,N)
        END IF
        IF(L.eq.N) THEN
         iLoc4=K+(M-1)*lRoots
         iLoc1=iLoc4+(K-1)*lRoots23
         iLoc2=iLoc4+(M-1)*lRoots23
         iLoc3=iLoc4+(L-1)*lRoots23
         Vklnm=DDg(iLoc1)+DDg(iLoc2)-2.0d0*DDg(iLoc3)-4.0d0*DDg(iLoc5)
C         Vklnm=DDg(K,M,K,K)+DDg(K,M,M,M)-2.0d0*DDg(K,M,L,L)
C     &         -4.0d0*DDg(K,L,M,N)
        END IF
        Hess((iKL-1)*nSPair+iMN)=Vklmn+Vlknm-Vklnm-Vlkmn
       End Do
       End Do
      END DO
      END DO


      RETURN
      End Subroutine

************************************************************************

      Subroutine CalcGradCMS(Grad,DDg,nDDg,lRoots,nSPair)
      INTEGER nDDg,lRoots,nSPair
      Real*8 Grad(nSPair),DDg(nDDg)

      INTEGER K,L,iKL,lRoots2,lRoots3,iLoc1,iLoc2

      lRoots2=lRoots**2
      lRoots3=lRoots*lRoots2

      DO K=2,lRoots
       Do L=1,K-1
        iLoc1=K+(K-1)*lRoots+(K-1)*lRoots2+(L-1)*lRoots3
        iLoc2=L+(L-1)*lRoots+(K-1)*lRoots2+(L-1)*lRoots3
        iKL=(K-1)*(K-2)/2+L
        Grad(iKL)=DDg(iLoc1)-DDg(iLoc2)
       End Do
      END DO
      CALL DSCal_(nSPair,2.0d0,Grad,1)
      RETURN
      End Subroutine
************************************************************************


************************************************************************
      Subroutine CalcQaa(Qaa,DDg,lRoots,nDDg)
      INTEGER lRoots,nDDg
      Real*8 DDg(nDDg)
      Real*8 Qaa

      INTEGER iState,iLoc,Int1,lRoots2

      lRoots2=lRoots**2
      Int1=(lRoots2+1)*(lRoots+1)
      Qaa=0.0d0
      DO iState=1,lRoots
       iLoc=(iState-1)*Int1+1
       Qaa=Qaa+DDg(iLoc)
      END DO
      Qaa=Qaa/2.0d0

      RETURN
      End Subroutine

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE ALSO(ISTOP,LPERMA,IRC1,ISMAX)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "cpfmcpf.fh"
C     DYNAMICAL ALLOCATION FOR SORTING
C     ADDRESSES LW(11)-LW(25)
      NVT=IROW(NVIRT+1)
C     BUFFER FOR INTEGRALS AT LPERMA = LW(7) ON FPS
      LPERMX=LPERMA+NTIBUF
      LICX=LIC-LPERMX
C     DYNAMICAL ALLOCATION FOR SORTING AIBJ
      NOB2=IROW(NORBT+1)
      NOT2=IROW(LN+1)
      NOV=3*NOT2
      INOV=NOV
      LSTO3=LICX-2*INOV-3*NOB2
C LBUF1: Nr of available reals per bin
      LBUF1=LSTO3/NOV
CPAM96      LBUF=(LBUF/2)*2
CPAM96C     *** FPS ***
CPAM96C     LBUF=(LBUF1-2)/2
C LBUF: Nr of items per bin
      LBUF=(RTOI*LBUF1-2)/(RTOI+1)
      IF(LBUF.GT.998)LBUF=998
      LBUF=((LBUF+2)/RTOI)*RTOI-2
      LBUF1=(LBUF*(RTOI+1)+2+(RTOI-1))/RTOI
CPAM96      WRITE(6,150)NOV,MADR,LBUF
CPAM96150   FORMAT(6X,'NUMBER OF CHAINS ON DRUM',I7,
CPAM96     */,6X,'PRESENT LIMIT',I18,
CPAM96     */,6X,'BUFFERT FOR SORTING',I13,
CPAM96     */,6X,'PRESENT LIMIT',16X,'20')
      IF(LBUF.LT.20) THEN
        ISTOP=3
        WRITE(6,*)'ALSO: Impossibly small buffers, too many bins,'
        WRITE(6,*)'for sorting AIBJ. Program will have to stop.'
      END IF
C     SORTING AREA , BUFOUT AND INDOUT
C     ALSO HDIAG IN DIAG
      LW(11)=LPERMX
C     CORE ADDRESSES , ICAD
CRL   LW(12)=LW(11)+NOV*(2*LBUF+2)
CPAM96      LW(12)=LW(11)+NOV*(LBUF+LBUF/2+2)
      LW(12)=LW(11)+NOV*((LBUF*(RTOI+1)+2+(RTOI-1))/RTOI)
C     BUFFER-COUNTER , IBUFL
      LW(13)=LW(12)+INOV
C     FOCK-MATRIX
      LW(14)=LW(13)+INOV
C     MAXIMUM LENGTH OF HDIAG
      MAX11=NVT
      IF(MAX11.LT.IRC1)MAX11=IRC1
      IF(LW(14).LT.LW(11)+MAX11)LW(14)=LW(11)+MAX11
C     IIJJ-INTEGRALS
      LW(15)=LW(14)+NOB2
C     IJIJ-INTEGRALS
      LW(16)=LW(15)+NOB2
      LIM=LW(16)+NOB2-1
CPAM96      WRITE(6,404)LIM
CPAM96404   FORMAT(6X,'STORAGE FOR SORTING AIBJ',I7)
      IF(LIM.GT.LIC) THEN
        ISTOP=1
        WRITE(6,*)'ALSO: Too much storage needed for AIBJ.'
        WRITE(6,'(1X,A,2I10)')'LIM,LIC:',LIM,LIC
      END IF
C     DYNAMICAL ALLOCATION FOR SORTING ABCD
      JBUF=1
      NOVT=0
      IF(IFIRST.NE.0)GO TO 35
      IPASS=1
110   NVT5=(NVT-1)/IPASS+1
      INVT5=NVT5
      LICXX=LICX-KBUFF1
      LSTO4=LICXX-2*INVT5
CRL   JBUF1=LSTO4/NVT5
C JBUF1: Nr of available reals per bin
      JBUF1=LSTO4/NVT5-1
CPAM96      JBUF=2*(JBUF1-1)/3
CPAM96      JBUF=(JBUF/2)*2
CPAM96C     *** FPS ***
CPAM96CRL   JBUF=(JBUF1-2)/2
C JBUF: Nr of items per bin
      JBUF=(RTOI*JBUF1-2)/(RTOI+1)
      IF(JBUF.GT.800)GO TO 120
      IPASS=IPASS+1
      IF(IPASS.GT.5)GO TO 120
      GO TO 110
120   IF(JBUF.GT.998)JBUF=998
      NOVT=NOV+NVT
      JBUF=((JBUF+2)/RTOI)*RTOI-2
      JBUF1=(JBUF*(RTOI+1)+2+(RTOI-1))/RTOI
CPAM96      WRITE(6,150)NOVT,MADR,JBUF
CPAM96      WRITE(6,160)IPASS
C160   FORMAT(6X,'NUMBER OF PASSES',I15)
      IF(JBUF.LT.20) THEN
        ISTOP=3
        WRITE(6,*)'ALSO: Impossibly small buffers, too many bins,'
        WRITE(6,*)'for sorting ABCD. Program will have to stop.'
      END IF
C     BUFACBD
      LW(96)=LPERMX
C     SORTING AREA , BUFOUT AND INDOUT
      LW(17)=LW(96)+KBUFF1
C     CORE ADDRESSES , ICAD
CRL   LW(18)=LW(17)+NVT5*(2*JBUF+2)
CPAM96      LW(18)=LW(17)+NVT5*(JBUF+JBUF/2+2)
      LW(18)=LW(17)+NVT5*((JBUF*(RTOI+1)+2+(RTOI-1))/RTOI)
C     BUFFER-COUNTER , IBUFL
      LW(19)=LW(18)+INVT5
      LIM=LW(19)+INVT5-1
C     ACBDS
C     (NOTE: FIRST PART OF BUFOUT (=2*JBUF+2) USED DURING CONSTRUCTION O
C     ACBDS AND ACBDT VECTORS)
CRL   LW(94)=LW(17)+2*JBUF+2
CPAM96      LW(94)=LW(17)+JBUF+JBUF/2+2
      LW(94)=LW(17)+(JBUF*(RTOI+1)+2+(RTOI-1))/RTOI
C     ACBDT
      LW(95)=LW(94)+ISMAX
      LIMT=LW(95)+ISMAX
      IF(LIMT.GT.LW(18)) THEN
        ISTOP=1
        WRITE(6,*)'ALSO: Too much storage needed for ABCD.'
        WRITE(6,'(1X,A,2I10)')'LIMT,LW(18):',LIMT,LW(18)
      END IF
CPAM96      WRITE(6,402)
CPAM96402   FORMAT(6X,'NOT ENOUGH STORAGE IN SORTB')
CPAM96401   WRITE(6,405)LIM
CPAM96405   FORMAT(6X,'STORAGE FOR SORTING ABCD',I7)
      IF(LIM.GT.LIC) THEN
        ISTOP=1
        WRITE(6,*)'ALSO: Too much storage needed for ABCD.'
        WRITE(6,'(1X,A,2I10)')'LIM,LIC:',LIM,LIC
      END IF
C     DYNAMICAL ALLOCATION FOR SORTING ABCI
      NOV=LN*NVIRT+1
35    IF(IFIRST.NE.0)NOV=1
      INOV=NOV
      LSTO4=LICX-2*INOV
C KBUF1: Nr of available reals per bin
      KBUF1=LSTO4/NOV
CPAM96      KBUF=2*(KBUF1-1)/3
CPAM96      KBUF=(KBUF/2)*2
CPAM96C     *** FPS ***
CPAM96CRL   KBUF=(KBUF1-2)/2
C KBUF: Nr of items per bin
      KBUF=(RTOI*KBUF1-2)/(RTOI+1)
      IF(KBUF.GT.998)KBUF=998
      NOVT=NOVT+NOV
      KBUF=((KBUF+2)/RTOI)*RTOI-2
      KBUF1=(KBUF*(RTOI+1)+2+(RTOI-1))/RTOI
CPAM96      WRITE(6,150)NOVT,MADR,KBUF
      IF(KBUF.LT.20) THEN
        ISTOP=3
        WRITE(6,*)'ALSO: Impossibly small buffers, too many bins,'
        WRITE(6,*)'for sorting ABCI. Program will have to stop.'
      END IF
C     SORTING AREA , BUFOUT AND INDOUT
      LW(20)=LPERMX
C     CORE ADDRESSES , ICAD
CRL   LW(21)=LW(20)+NOV*(2*KBUF+2)
CPAM96      LW(21)=LW(20)+NOV*(KBUF+KBUF/2+2)
      LW(21)=LW(20)+NOV*((KBUF*(RTOI+1)+2+(RTOI-1))/RTOI)
C     BUFFER-COUNTER , IBUFL
      LW(22)=LW(21)+INOV
      LIM=LW(22)+MAX(INOV-1,25000)
C     BIAC
C     (NOTE: FIRST PART OF BUFOUT(=2*KBUF+2) USED WHEN READING THE SORTE
CRL   LW(23)=LW(20)+2*KBUF+2
CPAM96      LW(23)=LW(20)+KBUF+KBUF/2+2
      LW(23)=LW(20)+(KBUF*(RTOI+1)+2+(RTOI-1))/RTOI
C     BICA
      LW(24)=LW(23)+ISMAX
C     BUFBI,INDBI
      LW(25)=LW(24)+ISMAX
      LIMT=LW(25)+KBUFF1+2
      IF(LIMT.GE.LIM) then
        ISTOP=1
        WRITE(6,*)'ALSO: Too much storage needed.'
        WRITE(6,'(1X,A,2I10)')'LIMT,LIM:',LIMT,LIM
      END IF
      IF(LIM.GT.LIC) THEN
        ISTOP=1
        WRITE(6,*)'ALSO: Too much storage needed for ABCI.'
        WRITE(6,'(1X,A,2I10)')'LIM,LIC:',LIM,LIC
      END IF
CPAM96411   WRITE(6,410)LIM
CPAM96410   FORMAT(6X,'STORAGE FOR SORTING ABCI',I7)
      IF(NOVT.GE.MADR) THEN
        ISTOP=2
        WRITE(6,*)'ALSO: Too much storage needed.'
        WRITE(6,'(1X,A,2I10)')'NOVT,MADR:',NOVT,MADR
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine HssPrt(Hess,nHess)

use Index_Functions, only: iTri
use Symmetry_Info, only: lIrrep, nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nHess
real(kind=wp), intent(in) :: Hess(nHess)
#include "Molcas.fh"
#include "disp.fh"
integer(kind=iwp) :: i, iDisp, ii, iIrrep, j, jj, nDisp(0:7)
character(len=39) :: Label
real(kind=wp), allocatable :: Temp(:)

!                                                                      *
!***********************************************************************
!                                                                      *
iDisp = 0
do iIrrep=0,nIrrep-1
  nDisp(iIrrep) = iDisp
  iDisp = iDisp+lDisp(iIrrep)
end do

if (nirrep == 1) then
  write(Label,100) 'Hessian in Irrep ',lIrrep(0)
  call TriPrt(Label,' ',Hess,ldisp(0))
else
  call mma_allocate(Temp,nHess,Label='Temp')
  do iIrrep=0,nIrrep-1
    write(Label,100) 'Hessian in Irrep ',lIrrep(iIrrep)
    do i=1,lDisp(iirrep)
      do j=1,i
        ii = iTri(i,j)
        jj = iTri(ndisp(iirrep)+i,ndisp(iirrep)+j)
        Temp(ii) = Hess(jj)
      end do
    end do
    call TriPrt(Label,' ',Temp,ldisp(iirrep))
  end do
  call mma_deallocate(Temp)
end if
!                                                                      *
!***********************************************************************
!                                                                      *

return

100 format(A,A)

end subroutine HssPrt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Yan Zhao                                         *
************************************************************************
      Subroutine XVS98(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                 CoeffA,iSpin,F_xc,T_X,ijzy)
************************************************************************
*                                                                      *
*  xvs98 evaluates the exchange part of the VS98 and M06 suite of      *
*  functionals on a grid.                                              *
*  !!! Second derivatives are not available yet.                       *
*                                                                      *
*  Ref:  T. V. Voorhis and G. E. Scuseria, J. Chem. Phys. 109,         *
*        400 (1998).                                                   *
*       Y. Zhao and D. G. Truhlar, J. Chem. Phys. 125,                 *
*        194101 (2006).                                                *
*                                                                      *
*       ijzy - 1 VS98                                                  *
*       ijzy - 2 M06-L                                                 *
*       ijzy - 3 M06-HF                                                *
*       ijzy - 4 M06                                                   *
*                                                                      *
*  YZ (10/07)                                                          *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 Rho(nRho,mGrid),dF_dRho(ndF_dRho,mGrid),F_xc(mGrid)
      Integer mGrid

      integer ijzy
      REAL*8 rrho, rho43, rho13, rhoo, rho53, rho83
      REAL*8  Gamma
c
c     kinetic energy density or tau
c
      REAL*8 tauu,DTol
      REAL*8 f13, f43, f53, f83, f113, f4o3
      REAL*8 gx, gg, x, z, kx,xk,zk
      REAL*8 Nine, F10, F11
      REAL*8 cf, Axlsda, r1, r2, r3, r4, r5, r6

c      functional derivatives below FFFFFFFFFFFF

       REAL*8 dxdr, dxdg, dzdr, dzdt, dgdx, dgdz

c      functional derivatives above FFFFFFFFFFFF

       parameter (cf = 9.115599720d0, Axlsda = -0.9305257363491d0 )
       parameter (gg  = 0.00186726d0)
       parameter (f13=1.d0/3.d0,f43=4.0d0/3.0d0,f53=5.0d0/3.0d0)
       parameter (f83=8.d0/3.0d0, F113=11.0d0/3.d0,f4o3=4.0D0/3.D0)
       parameter (Nine=9.0d0,F10=10.d0, F11=11.d0)

      if (ijzy.eq.1) then
c
c     Parameters for VS98
c
        r1=  -9.800683d-01
        r2=  -3.556788d-03
        r3=   6.250326d-03
        r4=  -2.354518d-05
        r5=  -1.282732d-04
        r6=   3.574822d-04
      elseif (ijzy.eq.2) then
c
c     Parameters for M06-L
c
        r1 =   6.012244D-01*Axlsda
        r2 =   4.748822D-03*Axlsda
        r3 =  -8.635108D-03*Axlsda
        r4 =  -9.308062D-06*Axlsda
        r5 =   4.482811D-05*Axlsda
        r6 =   0.000000D+00
      elseif (ijzy.eq.3) then
c
c     Parameters for M06-HF
c
        r1 =   -1.179732D-01*Axlsda
        r2 =   -2.500000D-03*Axlsda
        r3 =   -1.180065D-02*Axlsda
        r4 =   0.000000D+00
        r5 =   0.000000D+00
        r6 =   0.000000D+00
      elseif (ijzy.eq.4) then
c
c     Parameters for M06
c
c
c     Parameters for M06
c
        r1 =   1.422057D-01*Axlsda
        r2 =   7.370319D-04*Axlsda
        r3 =   -1.601373D-02*Axlsda
        r4 =   0.000000D+00
        r5 =   0.000000D+00
        r6 =   0.000000D+00
      endif

      DTol = T_X

*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=1
*
      If (iSpin.eq.1) Then
*                                                                      *
************************************************************************
*                                                                      *
        Ta=0.5D0*T_X
        Do iGrid = 1, mGrid
         rhoo=max(1.0D-24,rho(ipR,igrid))
         if(rhoo.lt.Ta) goto 110
         grdrhoa_x=rho(ipdRx,igrid)
         grdrhoa_y=rho(ipdRy,igrid)
         grdrhoa_z=rho(ipdRz,igrid)

         rho43 = rhoo**F4o3
         rrho = 1.0d0/rhoo       ! reciprocal of rho
         rho13 = rho43*rrho
         rho53 = rhoo**F53
         rho83 = rho53*rhoo
         tauu=Rho(ipTau,iGrid)
         Gamma=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         x = gamma/rho83
         dxdr = -f83*x*rrho
         dxdg = One/rho83
         z = tauu/rho53 - cf
         dzdr = -f53 * tauu/rho83
         dzdt = One/rho53
         kx = One + gg*x + gg*z
         xk = x/kx
         zk = z/kx
         call gvt4(gx,dgdx,dgdz,xk,zk,kx,gg,gg,r1,r2,r3,r4,r5,r6)
         F_xc(iGrid)=F_xc(iGrid)+(2.0D0*rho43*gx)
c
c     functional derivatives
c
*        dF/dRho
         dF_dRho(ipR,iGrid)=dF_dRho(ipR,iGrid)+ f43*rho13*gx +
     &                  rho43*(dgdx*dxdr + dgdz*dzdr)
*        dF/dGamma
         dF_dRho(ipGxx,iGrid)=dF_dRho(ipGxx,iGrid)+rho43*(dgdx*dxdg)
*        dF/dTau
         dF_dRho(ipT,iGrid)=dF_dRho(ipT,iGrid)+ rho43*(dgdz*dzdt)
110     continue
        Enddo
       else
* ispin .ne. 1, use both alpha and beta components.
        Ta=0.5D0*T_X
        do igrid=1,mgrid
c
* alpha component
c
         rhoo=max(1.0D-24,rho(ipRa,iGrid))
         if(rhoo.lt.Ta) goto 210
         grdrhoa_x=rho(ipdRxa,iGrid)
         grdrhoa_y=rho(ipdRya,iGrid)
         grdrhoa_z=rho(ipdRza,iGrid)

         rho43 = rhoo**F4o3
         rrho = 1.0d0/rhoo       ! reciprocal of rho
         rho13 = rho43*rrho
         rho53 = rhoo**F53
         rho83 = rho53*rhoo
         tauu=Rho(ipTaua,iGrid)
         Gamma=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         x = gamma/rho83
         dxdr = -f83*x*rrho
         dxdg = One/rho83
         z = tauu/rho53 - cf
         dzdr = -f53 * tauu/rho83
         dzdt = One/rho53
         kx = One + gg*x + gg*z
         xk = x/kx
         zk = z/kx
         call gvt4(gx,dgdx,dgdz,xk,zk,kx,gg,gg,r1,r2,r3,r4,r5,r6)
         F_xc(iGrid)=F_xc(iGrid)+rho43*gx
c
c     functional derivatives
c
*        dF/dRhoa
         dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)+ f43*rho13*gx +
     &                  rho43*(dgdx*dxdr + dgdz*dzdr)
*        dF/dGammaaa
         dF_dRho(ipGaa,iGrid)=dF_dRho(ipGaa,iGrid)+rho43*(dgdx*dxdg)
*        dF/dTaua
         dF_dRho(ipTa,iGrid)=dF_dRho(ipTa,iGrid)+ rho43*(dgdz*dzdt)
210      continue
c
c beta component
c
         rhoo=max(1.0D-24,rho(ipRb,iGrid))
         if(rhoo.lt.Ta) goto 310
         grdrhoa_x=rho(ipdRxb,iGrid)
         grdrhoa_y=rho(ipdRyb,iGrid)
         grdrhoa_z=rho(ipdRzb,iGrid)

         rho43 = rhoo**F4o3
         rrho = 1.0d0/rhoo       ! reciprocal of rho
         rho13 = rho43*rrho
         rho53 = rhoo**F53
         rho83 = rho53*rhoo
         tauu=Rho(ipTaub,iGrid)
         Gamma=grdrhoa_x**2+grdrhoa_y**2+grdrhoa_z**2
         x = gamma/rho83
         dxdr = -f83*x*rrho
         dxdg = One/rho83
         z = tauu/rho53 - cf
         dzdr = -f53 * tauu/rho83
         dzdt = One/rho53
         kx = One + gg*x + gg*z
         xk = x/kx
         zk = z/kx
         call gvt4(gx,dgdx,dgdz,xk,zk,kx,gg,gg,r1,r2,r3,r4,r5,r6)
         F_xc(iGrid)=F_xc(iGrid)+rho43*gx
c
c     functional derivatives
c
*        dF/dRhob
         dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)+ f43*rho13*gx +
     &                  rho43*(dgdx*dxdr + dgdz*dzdr)
*        dF/dGammabb
         dF_dRho(ipGbb,iGrid)=dF_dRho(ipGbb,iGrid)+rho43*(dgdx*dxdg)
*        dF/dTaub
         dF_dRho(ipTb,iGrid)=dF_dRho(ipTb,iGrid)+ rho43*(dgdz*dzdt)
310      continue
        enddo
       endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(CoeffA)
      End

      Subroutine gvt4(g,dgdx,dgdz,xk,zk,k,c,ct,r1,r2,r3,r4,r5,r6)
      Implicit none
c
c     Evaluate the GVT4 form in the VS98 functional
c
c
c    some working variables
      REAL*8 g,dgdx,dgdz,xk,zk,k,c,ct,r1,r2,r3,r4,r5,r6
      REAL*8 sxk,szk,sk,sc,sct,sr1,sr2,sr3,sr4,sr5,sr6,sk2
      REAL*8 One, Two, Three
      Data One/1.0d0/, Two/2.0d0/, Three/3.0d0/
C
      sxk = xk
      szk = zk
      sk = k
      sc = c
      sct = ct
      sr1 = r1
      sr2 = r2
      sr3 = r3
      sr4 = r4
      sr5 = r5
      sr6 = r6
      sk2 = sk*sk
      g =  (sr1 + sr2*sxk + sr3*szk
     $  +sr4*sxk*sxk + sr5*szk*sxk + sr6*szk*szk)/sk
      dgdx =   (-sr1*sc
     $  +sr2*(One-Two*sc*sxk)
     $  -Two*sr3*szk*sc
     $  +sr4*(Two*sxk-Three*sxk*sxk*sc)
     $  +sr5*(szk -Three*szk*sxk*sc)
     $  -Three*sr6*szk*szk*sc )/sk2
      dgdz =   (-sr1*sct
     $  -Two*sr2*sxk*sct
     $  +sr3*(One-Two*szk*sct)
     $  -Three*sr4*sxk*sxk*sct
     $  +sr5*(sxk-Three*sxk*szk*sct)
     $  +sr6*(Two*szk-Three*szk*szk*sct))/sk2

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Per-Olof Widmark                                 *
*               1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine iWrOne(rc,Option,InLab,Comp,Data,SymLab)
************************************************************************
*                                                                      *
*     Purpose: write data to one-electron integral file                *
*                                                                      *
*     Calling parameters:                                              *
*     rc      : Return code                                            *
*     Option  : Switch to set options                                  *
*     InLab   : Identifier for the data to write                       *
*     Comp    : Composite identifier to select components              *
*     Data    : contains on input the data to store on disk            *
*     SymLab  : symmetry label of the provided data                    *
*                                                                      *
*     Global data declarations (Include file):                         *
*     Parm    : Table of paramaters                                    *
*     rcParm  : Table of return codes                                  *
*     Switch  : Table of options                                       *
*     Common  : Common block containing TocOne                         *
*     Data    : Data definitions                                       *
*                                                                      *
*     Local data declarations:                                         *
*     Label   : character*8, used to covert incoming names             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark and M.P. Fuelscher                                  *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
#include "OneRc.fh"
#include "OneFlags.fh"

#include "OneDat.fh"
*
      Character*(*) InLab
      Dimension Data(*)
*
      Character*8 TmpLab,Label
      Dimension LabTmp(2)
*     Equivalence (TmpLab,LabTmp)
      Logical debug, Close
*----------------------------------------------------------------------*
*     Start procedure:                                                 *
*     Define inline function (symmetry multiplication)                 *
*----------------------------------------------------------------------*
      MulTab(i,j)=iEor(i-1,j-1)+1
*----------------------------------------------------------------------*
*     Pick up the file definitions                                     *
*----------------------------------------------------------------------*
      rc    = rc0000
      LuOne = AuxOne(pLu  )
      Open  = AuxOne(pOpen)
*----------------------------------------------------------------------*
*     Check the file status                                            *
*----------------------------------------------------------------------*
      Close=.False.
      If ( Open.ne.1 ) Then
*
*------- Well, I'll open and close it for you under the default name
*
         LuOne=77
         LuOne=isFreeUnit(LuOne)
         Label='ONEINT  '
*        Write(*,*) 'WrOne: opening OneInt'
         iRC=-1
         iOpt=0
         Call OpnOne(iRC,iOpt,Label,LuOne)
         If (iRC.ne.0) Then
            Write (6,*) 'WrOne: Error opening file'
            Call Abend
         End If
         Close=.True.
      End If
*----------------------------------------------------------------------*
*     Truncate the label to 8 characters and convert it to upper case  *
*----------------------------------------------------------------------*
      Label=InLab
      Call UpCase(Label)
      TmpLab=Label
      Call ByteCopy(TmpLab,LabTmp,8)
*----------------------------------------------------------------------*
*     Print debugging information                                      *
*----------------------------------------------------------------------*
      debug=.False.
      If(iAnd(option,1024).ne.0) debug=.true.
      If(debug) Then
         Call DmpOne
         Write(6,*) '<<< Entering WrOne >>>'
         Write(6,'(a,z8)') ' rc on entry:     ',rc
         Write(6,'(a,a)')  ' Label on entry:  ',Label
         Write(6,'(a,z8)') ' Comp on entry:   ',Comp
         Write(6,'(a,z8)') ' SymLab on entry: ',SymLab
         Write(6,'(a,z8)') ' Option on entry: ',Option
      End If
*----------------------------------------------------------------------*
*     Store operators as individual records on disk                    *
*     Note: If the incoming operator has already been stored           *
*     previously (label, component and symmetry labels are identical)  *
*     it will replace the existing one.                                *
*----------------------------------------------------------------------*
         k=0
         Do 500 i=MxOp,1,-1
#ifdef _I8_
            If(TocOne(pOp+LenOp*(i-1)+oLabel  ).eq.LabTmp(1) .and.
     &         TocOne(pOp+LenOp*(i-1)+oComp   ).eq.Comp      .and.
     &         TocOne(pOp+LenOp*(i-1)+oSymLb  ).eq.SymLab          ) k=i
#else
            If(TocOne(pOp+LenOp*(i-1)+oLabel  ).eq.LabTmp(1) .and.
     &         TocOne(pOp+LenOp*(i-1)+oLabel+1).eq.LabTmp(2) .and.
     &         TocOne(pOp+LenOp*(i-1)+oComp   ).eq.Comp      .and.
     &         TocOne(pOp+LenOp*(i-1)+oSymLb  ).eq.SymLab          ) k=i
#endif
500      Continue
         iDisk=TocOne(pOp+LenOp*(k-1)+oAddr   )
         If(k.eq.0) Then
           Do 505 i=MxOp,1,-1
              If(TocOne(pOp+LenOp*(i-1)+oLabel).eq.NaN) k=i
505        Continue
           iDisk=TocOne(pNext)
         End If
         If(k.eq.0) Then
            rc=rcWR11
            Write (6,*) 'WrOne: The total number of operators',
     &                  ' exceeds the limit'
            Write (6,*) 'k.eq.0'
            Call Abend()
         End If
         Len=0
         Do 510 i=1,nSym
         Do 511 j=1,i
            ij=MulTab(i,j)-1
            If(iAnd(2**ij,SymLab).ne.0) Then
               If(i.eq.j) Then
                  Len=Len+nBas(i)*(nBas(i)+1)/2
               Else
                  Len=Len+nBas(i)*nBas(j)
               End If
            End If
511      Continue
510      Continue
         Len=RtoI*(Len+nAuxDt)
         TocOne(pOp+LenOp*(k-1)+oLabel  )=LabTmp(1)
#ifndef _I8_
         TocOne(pOp+LenOp*(k-1)+oLabel+1)=LabTmp(2)
#endif
         TocOne(pOp+LenOp*(k-1)+oComp   )=Comp
         TocOne(pOp+LenOp*(k-1)+oSymLb  )=SymLab
         TocOne(pOp+LenOp*(k-1)+oAddr   )=iDisk
         Call iDaFile(LuOne,1,Data,Len,iDisk)
         TocOne(pNext)=Max(TocOne(pNext),iDisk)
*----------------------------------------------------------------------*
*     Finally copy the TocOne back to disk                             *
*----------------------------------------------------------------------*
      iDisk=0
      Call iDaFile(LuOne,1,TocOne,lToc,iDisk)
*
      If (Close) Then
         iRC=-1
         iOpt=0
         Call ClsOne(iRC,iOpt)
         If (iRC.ne.0) Then
            Write (6,*) 'WrOne: Error closing file'
            Call Abend
         End If
      End If
*----------------------------------------------------------------------*
*     Terminate procedure                                              *
*----------------------------------------------------------------------*
      Return
      End

      Subroutine WrOne(rc,Option,InLab,Comp,Data,SymLab)
      Implicit Integer (A-Z)
*
      Character*(*) InLab
      Real*8 Data(*)
*
      Call WrOne_Internal(Data)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine WrOne_Internal(Data)
      Use Iso_C_Binding
      Real*8, Target :: Data(*)
      Integer, Pointer :: iData(:)
      Call C_F_Pointer(C_Loc(Data(1)),iData,[1])
      Call iWrOne(rc,Option,InLab,Comp,iData,SymLab)
      Nullify(iData)
      return
      End Subroutine WrOne_Internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3loopb(oeh,oep,t1a,t1b,nga,ngb,ngc,vblock,energ,isp,LU,ifvo,scored,enx)
!mp subroutine t3loopb(oeh,oep,t1a,t1b,g,nga,ngb,ngc,vblock,energ,
! implemented integer offsets, PV, 16 may 2004.

use ChT3_global, only: nblock, NNOAB, NNUAB, NOAB, NUAB
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: oeh(*), oep(*)
real(kind=wp), intent(inout) :: t1a(*), t1b(*), energ(*)
integer(kind=iwp), intent(in) :: nga, ngb, ngc, vblock, isp, lu(6)
logical(kind=iwp), intent(in) :: ifvo
logical(kind=iwp), intent(out) :: scored
real(kind=wp), intent(out) :: enx
integer(kind=iwp) :: adim, aset, bdim, bset, cdim, cset, en_offset_ah, en_offset_ap, en_offset_bh, en_offset_bp, iasblock(5), n, &
                     nuga, nugc, t1_offset_a, t1_offset_b
real(kind=wp), allocatable :: kab(:), kac(:), kbc(:), kc(:), kca(:), kcb(:), la(:), lb(:), lxa(:), lxb(:), lxc(:), mi(:), mij(:), &
                              t3a(:), t3b(:), vab(:), vac(:), vbc(:)

en_offset_ah = (isp-1)*noab(1)
en_offset_bh = (2-isp)*noab(1)
en_offset_ap = (isp-1)*nuab(1)
en_offset_bp = (2-isp)*nuab(1)
t1_offset_a = (isp-1)*noab(1)*nuab(1)
t1_offset_b = (2-isp)*noab(1)*nuab(1)
N = noab(isp)+nuab(isp)

!mp
scored = .true.
!mp !!!if (.not. lastcall) then
!mp
enx = Zero
!mpn write(u6,*) 'Bef isp, energ(isp), enx = ',isp,energ(isp),enx
!mp !!!if (energ(isp) == Zero) then
! this is a first entry - initialization (makes no harm if repeated)
nuga = nuab(isp)/vblock
if ((nuga*vblock) < nuab(isp)) nuga = nuga+1
!!write(u6,*) 'first,nuga,vblock',nuga,vblock
nugc = nuab(3-isp)/vblock
if ((nugc*vblock) < nuab(3-isp)) nugc = nugc+1
!!write(u6,*) 'first,nugc,vblock',nugc,vblock

iasblock(1) = vblock*vblock*N/nblock
if (iasblock(1)*nblock < vblock*vblock*N) iasblock(1) = iasblock(1)+1

iasblock(2) = nnoab(isp)*vblock*N/nblock
if (iasblock(2)*nblock < nnoab(isp)*vblock*N) iasblock(2) = iasblock(2)+1

iasblock(3) = nnoab(3)*vblock*N/nblock
if (iasblock(3)*nblock < nnoab(3)*vblock*N) iasblock(3) = iasblock(3)+1

iasblock(4) = nnoab(isp)*vblock*vblock/nblock
if (iasblock(4)*nblock < nnoab(isp)*vblock*vblock) iasblock(4) = iasblock(4)+1

iasblock(5) = nnoab(3)*vblock*vblock/nblock
if (iasblock(5)*nblock < nnoab(3)*vblock*vblock) iasblock(5) = iasblock(5)+1

!mp call w_rescope(G,'GT3loopb')
!mp call w_free(g,0,'GT3loopb')
! allocations
if (nuga /= 1) then
  !mp call w_alloc(kab,noab(isp)*vblock*vblock*n,'kaT3loopb')
  call mma_allocate(kab,noab(isp)*vblock*vblock*n,label='loopb_kab')
  !mp call w_alloc(kcb,noab(isp)*vblock*vblock*n,'kbT3loopb')
  call mma_allocate(kcb,noab(isp)*vblock*vblock*n,label='loopb_kcb')
  !mp call w_alloc(kbc,vblock*vblock*n,'kcT3loopb')
  call mma_allocate(kbc,vblock*vblock*n,label='loopb_kbc')
else
  !mp call w_alloc(kab,noab(isp)*N*nnuab(isp),'kaT3loopb')
  call mma_allocate(kab,noab(isp)*N*nnuab(isp),label='loopb_kab')
end if
!mp call w_alloc(kac,vblock*vblock*n,'kcT3loopb')
call mma_allocate(kac,vblock*vblock*n,label='loopb_kac')
!mp call w_alloc(kca,noab(isp)*vblock*vblock*n,'kbT3loopb')
call mma_allocate(kca,noab(isp)*vblock*vblock*n,label='loopb_kca')
!mp call w_alloc(kc,vblock*vblock*n,'kcT3loopb')
call mma_allocate(kc,vblock*vblock*n,label='loopb_kc')
!mp call w_alloc(la,nnoab(isp)*vblock*n,'laT3loopb')
call mma_allocate(la,nnoab(isp)*vblock*n,label='loopb_la')
!mp call w_alloc(lxa,nnoab(3)*vblock*n,'lbaT3loopb')
call mma_allocate(lxa,nnoab(3)*vblock*n,label='loopb_lxa')
!mpn write(u6,*) 'check lxa'
!mpn write(u6,*) 'nnoab(1), (2), (3) = ',nnoab(1),nnoab(2),nnoab(3)
!mpn write(u6,*) 'nnuab(1), (2), (3) = ',nnuab(1),nnuab(2),nnuab(3)
if (nuga /= 1) then
  !mp call w_alloc(lb,nnoab(isp)*vblock*n,'lbT3loopb')
  call mma_allocate(lb,nnoab(isp)*vblock*n,label='loopb_lb')
  !mp call w_alloc(lxb,nnoab(3)*vblock*n,'labT3loopb')
  call mma_allocate(lxb,nnoab(3)*vblock*n,label='loopb_lxb')
end if
!mp call w_alloc(lxc,nnoab(3)*vblock*n,'lacT3loopb')
call mma_allocate(lxc,nnoab(3)*vblock*n,label='loopb_lxc')
!mp call w_alloc(t3a,vblock*vblock*vblock,'t3aT3loopb')
call mma_allocate(t3a,vblock*vblock*vblock,label='loopb_t3a')
!mp call w_alloc(t3b,vblock*vblock*vblock,'t3bT3loopb')
call mma_allocate(t3b,vblock*vblock*vblock,label='loopb_t3b')
!mp call w_alloc(vac,vblock*vblock*nnoab(3),'vbcT3loopb')
call mma_allocate(vac,vblock*vblock*nnoab(3),label='loopb_vac')
if (nuga /= 1) then
  !mp call w_alloc(vab,vblock*vblock*nnoab(isp),'vabT3loopb')
  call mma_allocate(vab,vblock*vblock*nnoab(isp),label='loopb_vab')
  !mp call w_alloc(vbc,vblock*vblock*nnoab(3),'vacT3loopb')
  call mma_allocate(vbc,vblock*vblock*nnoab(3),label='loopb_vbc')
else
  !mp call w_alloc(vab,nnoab(isp)*nnuab(isp),'vabT3loopb')
  call mma_allocate(vab,nnoab(isp)*nnuab(isp),label='loopb_vab')
end if
!mp call w_alloc(mi,noab(isp)*vblock**3,'miT3loopb')
call mma_allocate(mi,noab(isp)*vblock**3,label='loopb_mi')
!mp
!mpn write(u6,*) 'mi check = ',noab(isp)*vblock**3
!mpn write(u6,*) 'nnoab(1), (2), (3) = ',nnoab(1),nnoab(2),nnoab(3)
!mpn write(u6,*) 'nnuab(1), (2), (3) = ',nnuab(1),nnuab(2),nnuab(3)
!mp
!mp call w_alloc(mij,N*vblock,'mijT3loopb')
call mma_allocate(mij,N*vblock,label='loopb_mij')
!mp !!!end if     ! energ = 0 - initialization

aset = (nga-1)*vblock
adim = min(vblock,nuab(isp)-aset)
bset = (ngb-1)*vblock
bdim = min(vblock,nuab(isp)-bset)
cset = (ngc-1)*vblock
cdim = min(vblock,nuab(3-isp)-cset)

! case1 nga=ngb=ngc

if (nga == ngb) then

  !mpn write(u6,*) 'ide call t3_bta_aac'
  !mp call t3_bta_aac(nuga,nugc,g(kab),g(kca),g(kac),g(kc),g(la),g(lxa),g(lxc),g(mi),g(mij),adim,cdim,N,noab(isp),nuab(isp), &
  !mp                 noab(3-isp),nuab(3-isp),lu,iasblock,nga,ngc,oeh(en_offset_ah+1),oeh(en_offset_bh+1), &
  !mp                 oep(aset+en_offset_ap+1),oep(cset+en_offset_bp+1),enx,g(vab),g(vac),t1a(noab(isp)*aset+t1_offset_a+1), &
  !mp                 t1b(noab(isp)*aset+t1_offset_a+1),t1a(noab(3-isp)*cset+t1_offset_b+1),t1b(noab(3-isp)*cset+t1_offset_b+1), &
  !mp                 g(t3a),g(t3b),ifvo)
  call t3_bta_aac(nuga,nugc,kab,kca,kac,kc,la,lxa,lxc,mi,mij,adim,cdim,N,noab(isp),noab(3-isp),lu,iasblock,nga,ngc, &
                  oeh(en_offset_ah+1),oeh(en_offset_bh+1),oep(aset+en_offset_ap+1),oep(cset+en_offset_bp+1),enx,vab,vac, &
                  t1a(noab(isp)*aset+t1_offset_a+1),t1b(noab(isp)*aset+t1_offset_a+1),t1a(noab(3-isp)*cset+t1_offset_b+1), &
                  t1b(noab(3-isp)*cset+t1_offset_b+1),t3a,t3b,ifvo)
else
  !mpn write(u6,*) 'ide call t3_bta_abc'
  !mp call t3_bta_abc(nuga,nugc,g(kab),g(kcb),g(kca),g(kac),g(kbc),g(kc),g(la),g(lb),g(lxa),g(lxb),g(lxc),g(mi),g(mij),adim,bdim, &
  !mp                 cdim,N,noab(isp),nuab(isp),noab(3-isp),nuab(3-isp),lu,iasblock,nga,ngb,ngc,oeh(en_offset_ah+1), &
  !mp                 oeh(en_offset_bh+1),oep(aset+en_offset_ap+1),oep(bset+en_offset_ap+1),oep(cset+en_offset_bp+1),enx,g(vab), &
  !mp                 g(vbc),g(vac),t1a(noab(isp)*aset+t1_offset_a+1),t1b(noab(isp)*aset+t1_offset_a+1), &
  !mp                 t1a(noab(isp)*bset+t1_offset_a+1),t1b(noab(isp)*bset+t1_offset_a+1),t1a(noab(3-isp)*cset+t1_offset_b+1), &
  !mp                 t1b(noab(3-isp)*cset+t1_offset_b+1),g(t3a),g(t3b),ifvo)
  call t3_bta_abc(nuga,nugc,kab,kcb,kca,kac,kbc,kc,la,lb,lxa,lxb,lxc,mi,mij,adim,bdim,cdim,N,noab(isp),noab(3-isp),lu,iasblock, &
                  nga,ngb,ngc,oeh(en_offset_ah+1),oeh(en_offset_bh+1),oep(aset+en_offset_ap+1),oep(bset+en_offset_ap+1), &
                  oep(cset+en_offset_bp+1),enx,vab,vbc,vac,t1a(noab(isp)*aset+t1_offset_a+1),t1b(noab(isp)*aset+t1_offset_a+1), &
                  t1a(noab(isp)*bset+t1_offset_a+1),t1b(noab(isp)*bset+t1_offset_a+1),t1a(noab(3-isp)*cset+t1_offset_b+1), &
                  t1b(noab(3-isp)*cset+t1_offset_b+1),t3a,t3b,ifvo)
end if   ! cases
!mpn write(u6,*) 'isp, energ(isp), enx = ',isp,energ(isp),enx
energ(isp) = energ(isp)+enx
!mp !!!write(u6,'(A,3(i5,2x),f21.19)') 'nga, ngb, ngc, inc = ',nga,ngb,ngc,enx
!mp !!!end if  ! lastcall
!mp write(u6,*)
!mp write(u6,*) 'deallocating arrays in t3loob'
!mp write(u6,*)
!mp
call mma_deallocate(mij)
call mma_deallocate(mi)
if (nuga /= 1) then
  call mma_deallocate(vbc)
end if
call mma_deallocate(vab)
call mma_deallocate(vac)
call mma_deallocate(t3a)
call mma_deallocate(t3b)
call mma_deallocate(lxc)
if (nuga /= 1) then
  call mma_deallocate(lxb)
  call mma_deallocate(lb)
end if
call mma_deallocate(lxa)
call mma_deallocate(la)
call mma_deallocate(kc)
call mma_deallocate(kca)
call mma_deallocate(kac)
if (nuga /= 1) then
  call mma_deallocate(kbc)
  call mma_deallocate(kcb)
end if
call mma_deallocate(kab)

return

end subroutine t3loopb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SONATORBM(CHARTYPE,
     &                     USOR,USOI,ASS,BSS,NSS,
     &                     iOpt,ROTMAT,DENSOUT)
      use rassi_aux, only : idisk_TDM
      use rassi_global_arrays, only: JBNUM
      use stdalloc, only: mma_allocate, mma_deallocate
      use Cntrl, only: NSTATE, LSYM1, LSYM2, IRREP, MLTPLT
      use cntrl, Only: LuTDM
      use Symmetry_Info, only: nSym=>nIrrep, MUL
      use rassi_data, only: NBTRI,NBASF,NTDMZZ

      IMPLICIT None
      CHARACTER(LEN=8) CHARTYPE
      INTEGER ASS,BSS,NSS
      Real*8 USOR(NSS,NSS),USOI(NSS,NSS)
      INTEGER iOpt
      Real*8 ROTMAT(3,3)
      Real*8 DENSOUT(6,NBTRI)

      Integer IOFF(8)
      Integer, allocatable:: MAPST(:), MAPSP(:), MAPMS(:)
      Real*8, allocatable:: TMPR(:), TMPI(:), SCR(:), TDMZZ(:)
      Real*8, allocatable, Target:: SDMXR(:) ,SDMYR(:) ,SDMZR(:)
      Real*8, allocatable, Target:: SDMXI(:) ,SDMYI(:) ,SDMZI(:)
      Real*8, allocatable, Target:: SDMXR2(:) ,SDMYR2(:) ,SDMZR2(:)
      Real*8, allocatable, Target:: SDMXI2(:) ,SDMYI2(:) ,SDMZI2(:)
      Type A2_Array
        Real*8, Pointer:: A2(:)=>Null()
      End Type A2_Array
      Type (A2_array):: IZMR(3)
      Type (A2_array):: IZMI(3)
      Type (A2_array):: IZMR2(3)
      Type (A2_array):: IZMI2(3)
      REAL*8 CGY, CGX, CG0, TDM, S1, SM1, S2, SM2, FACT, CGM, CGP, URR,
     &       UIR, URL, UIL, DCLEBS
      INTEGER ITYPE, ISS, ISF, JOB, MPLET, MSPROJ, KSS, KSF, MPLETK,
     &        MSPROJK, LSS, LSF, MPLETL, MSPROJL, JOB1, JOB2, ISY12,
     &        IEMPTY, IDISK, IGO, IOF, ITD, ISY, NB, J, I, IJ, ISY1,
     &        NB1, ISY2, NB2, IDIR

c VV: dummy initialization
      CGY=-1
      CGX=-1
      CG0=-1
C Get the proper type of the property
      ITYPE=0
      IF(CHARTYPE.EQ.'HERMSING') ITYPE=1
      IF(CHARTYPE.EQ.'ANTISING') ITYPE=2
      IF(CHARTYPE.EQ.'HERMTRIP') ITYPE=3
      IF(CHARTYPE.EQ.'ANTITRIP') ITYPE=4
      IF(ITYPE.EQ.0) THEN
        WRITE(6,*)'RASSI/SONATORB internal error.'
        WRITE(6,*)'Erroneous property type:',CHARTYPE
        CALL ABEND()
      END IF

C The following creates an array that is used to
C map a specific spin state to the corresponding
C spin-free state and to its spin
C (see prprop.f and others)

      CALL mma_allocate(MAPST,NSS,Label='MAPST')
      CALL mma_allocate(MAPSP,NSS,Label='MAPSP')
      CALL mma_allocate(MAPMS,NSS,Label='MAPMS')

      ISS=0
      DO ISF=1,NSTATE
        JOB=JBNUM(ISF)
        MPLET=MLTPLT(JOB)

        DO MSPROJ=-MPLET+1,MPLET-1,2
          ISS=ISS+1
          MAPST(ISS)=ISF
          MAPSP(ISS)=MPLET
          MAPMS(ISS)=MSPROJ
        END DO
      END DO


c Allocate some arrays
c SDMXR, etc      DM/TDM for this iteration
c SDMXR2, etc     Accumulated DM/TDM
c TMPR,I          Temporary array for U*AU multiplication
c TDMZZ           DM/TDM as read from file
c SCR             Scratch for expansion of TDMZZ
      CALL mma_allocate(SDMXR,NBTRI,Label='SDMXR')
      CALL mma_allocate(SDMYR,NBTRI,Label='SDMYR')
      CALL mma_allocate(SDMZR,NBTRI,Label='SDMZR')
      CALL mma_allocate(SDMXI,NBTRI,Label='SDMXI')
      CALL mma_allocate(SDMYI,NBTRI,Label='SDMYI')
      CALL mma_allocate(SDMZI,NBTRI,Label='SDMZI')
      SDMXR(:)=0.0D0
      SDMYR(:)=0.0D0
      SDMZR(:)=0.0D0
      SDMXI(:)=0.0D0
      SDMYI(:)=0.0D0
      SDMZI(:)=0.0D0
      IZMR(1)%A2=>SDMXR(:)
      IZMR(2)%A2=>SDMYR(:)
      IZMR(3)%A2=>SDMZR(:)
      IZMI(1)%A2=>SDMXI(:)
      IZMI(2)%A2=>SDMYI(:)
      IZMI(3)%A2=>SDMZI(:)

      CALL mma_allocate(SDMXR2,NBTRI,Label='SDMXR2')
      CALL mma_allocate(SDMYR2,NBTRI,Label='SDMYR2')
      CALL mma_allocate(SDMZR2,NBTRI,Label='SDMZR2')
      CALL mma_allocate(SDMXI2,NBTRI,Label='SDMXI2')
      CALL mma_allocate(SDMYI2,NBTRI,Label='SDMYI2')
      CALL mma_allocate(SDMZI2,NBTRI,Label='SDMZI2')
      SDMXR2(:)=0.0D0
      SDMYR2(:)=0.0D0
      SDMZR2(:)=0.0D0
      SDMXI2(:)=0.0D0
      SDMYI2(:)=0.0D0
      SDMZI2(:)=0.0D0
      IZMR2(1)%A2=>SDMXR2(:)
      IZMR2(2)%A2=>SDMYR2(:)
      IZMR2(3)%A2=>SDMZR2(:)
      IZMI2(1)%A2=>SDMXI2(:)
      IZMI2(2)%A2=>SDMYI2(:)
      IZMI2(3)%A2=>SDMZI2(:)


      CALL mma_allocate(TMPR,NBTRI,Label='TMPR')
      CALL mma_allocate(TMPI,NBTRI,Label='TMPI')
      TMPR(:)=0.0D0
      TMPI(:)=0.0D0

      CALL mma_allocate(SCR,NBTRI,Label='SCR')
c zeroed inside the loop
c      SCR(:)=0.0D0

      CALL mma_allocate(TDMZZ,NTDMZZ,Label='TDMZZ')
      TDMZZ(:)=0.0D0

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C MAIN LOOP OVER KSF/LSF
C WRITTEN AS IN PRPROP
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C CORRESPONDING SPIN-FREE STATES OF THE
C REQUESTED SPIN STATES
      DO KSS=1,NSS
       KSF=MAPST(KSS)
       MPLETK=MAPSP(KSS)
       MSPROJK=MAPMS(KSS)

       DO LSS=1,NSS
        LSF=MAPST(LSS)
        MPLETL=MAPSP(LSS)
        MSPROJL=MAPMS(LSS)

        JOB1=JBNUM(KSF)
        JOB2=JBNUM(LSF)
        LSYM1=IRREP(JOB1)
        LSYM2=IRREP(JOB2)
        ISY12=MUL(LSYM1,LSYM2)

C SET UP AN OFFSET TABLE FOR SYMMETRY BLOCKS
        Call mk_IOFF(IOFF,nSYM,NBASF,ISY12)

c These are going to be zero, so head them off at the pass
        IF(ITYPE.LE.2
     &     .AND.(MPLETK.NE.MPLETL.OR.MSPROJK.NE.MSPROJL)) GOTO 2200


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
C Transition density matrices, TDMZZ, in AO basis.
C WDMZZ similar, but WE-reduced 'triplet' densities.
C TDMZZ will store either, depending on the type
        CALL DCOPY_(NTDMZZ,[0.0D00],0,TDMZZ,1)


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C IDTDM: TOC array for transition 1-matrices
c TDMZZ is stored on disk from i = 1, NSTATE j=1, i
c so swap if needed
        iEmpty=iDisk_TDM(KSF,LSF,2)
        IDISK=iDisk_TDM(KSF,LSF,1)
        iOpt=2
        IF (ITYPE.GE.3) Then
           iGo=4
           CALL dens2file(TDMZZ,TDMZZ,TDMZZ,
     &                    nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,KSF,LSF)
C NOTE-the TD matrix as read in has an incorrect sign
           CALL DSCAL_(NTDMZZ,-1.0d0,TDMZZ,1)
        Else
           iGo=1
           CALL dens2file(TDMZZ,TDMZZ,TDMZZ,
     &                    nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,KSF,LSF)
        END IF


c Anti-hermitian properties need a little fixing
        IF((ITYPE.EQ.2.OR.ITYPE.EQ.4).AND.(KSF.LE.LSF))
     &          CALL DSCAL_(NTDMZZ,-1.0d0,TDMZZ,1)


C CALCULATE THE SYMMETRIC AND ANTISYMMETRIC FOLDED TRANS D MATRICES
C AND SIMILAR WE-REDUCED SPIN DENSITY MATRICES
        SCR(:)=0.0D0

C This code expands the NTDMZZ-size matrix into
C an NBTRI-sized matrix
C SPECIAL CASE: DIAGONAL SYMMETRY BLOCKS.
C NOTE: During the folding, all off-diagonal values
C  are doubled. This factor of 2 is made up when
C  multiplying just the triangle with the AO matrix (DDOT)
C  rather than the entire matrix

C TODO - get rid of if statements in inner loop
ccccccccccccccccccc

c DIAGONAL SYMMETRY BLOCKS
        IF(ISY12.EQ.1) THEN
          IOF=0
          ITD=0
          DO ISY=1,NSYM
            NB=NBASF(ISY)
            IF(NB.EQ.0) cycle
            DO J=1,NB
              DO I=1,NB
                ITD=ITD+1
                TDM=TDMZZ(ITD)
                IF(I.GE.J) THEN
                  IJ=IOF+(I*(I-1))/2+J
                  IF(I.GT.J) THEN
                    IF(ITYPE.EQ.2) SCR(IJ)=SCR(IJ)+TDM
                    IF(ITYPE.EQ.4) SCR(IJ)=SCR(IJ)+TDM
                  END IF
                ELSE
                  IJ=IOF+(J*(J-1))/2+I
                  IF(ITYPE.EQ.2) SCR(IJ)=SCR(IJ)-TDM
                  IF(ITYPE.EQ.4) SCR(IJ)=SCR(IJ)-TDM
                END IF
                IF(ITYPE.EQ.1) SCR(IJ)=SCR(IJ)+TDM
                IF(ITYPE.EQ.3) SCR(IJ)=SCR(IJ)+TDM
              END DO
            END DO
            IOF=IOF+(NB*(NB+1))/2
          END DO
        ELSE
C GENERAL CASE, NON-DIAGONAL SYMMETRY BLOCKS
C THEN LOOP OVER ELEMENTS OF TDMZZ
          ITD=0
          DO ISY1=1,NSYM
            NB1=NBASF(ISY1)
            IF(NB1.EQ.0) cycle
            ISY2=MUL(ISY1,ISY12)
            NB2=NBASF(ISY2)
            IF(NB2.EQ.0) cycle
            IF(ISY1.GT.ISY2) THEN
              DO J=1,NB2
                DO I=1,NB1
                  ITD=ITD+1
                  TDM=TDMZZ(ITD)
                  IJ=IOFF(ISY1)+I+NB1*(J-1)
                  SCR(IJ)=SCR(IJ)+TDM
                END DO
              END DO
            ELSE
              DO J=1,NB2
                DO I=1,NB1
                  ITD=ITD+1
                  TDM=TDMZZ(ITD)
                  IJ=IOFF(ISY2)+J+NB2*(I-1)
                  SCR(IJ)=SCR(IJ)-TDM
                END DO
              END DO
            END IF
          END DO
        END IF


c ie, see how AMFI is processed in soeig.f
        SDMXR(:)=0.0D0
        SDMYR(:)=0.0D0
        SDMZR(:)=0.0D0
        SDMXI(:)=0.0D0
        SDMYI(:)=0.0D0
        SDMZI(:)=0.0D0

        IF(ITYPE.GE.3) THEN
          S1=0.5D0*DBLE(MPLETK-1)
          SM1=0.5D0*DBLE(MSPROJK)
          S2=0.5D0*DBLE(MPLETL-1)
          SM2=0.5D0*DBLE(MSPROJL)
          FACT=1.0D0/SQRT(DBLE(MPLETK))
          IF(MPLETK.EQ.MPLETL-2) FACT=-FACT

          CGM=FACT*DCLEBS(S2,1.0D0,S1,SM2,-1.0D0,SM1)
          CG0=FACT*DCLEBS(S2,1.0D0,S1,SM2, 0.0D0,SM1)
          CGP=FACT*DCLEBS(S2,1.0D0,S1,SM2,+1.0D0,SM1)
          CGX=SQRT(0.5D0)*(CGM-CGP)
          CGY=SQRT(0.5D0)*(CGM+CGP)
        END IF

        IF((ITYPE.EQ.1.OR.ITYPE.EQ.2)
     &          .AND.MPLETK.EQ.MPLETL
     &          .AND.MSPROJK.EQ.MSPROJL) THEN
          CALL DAXPY_(NBTRI,1.0d0,SCR,1,SDMZR,1)
        ELSE IF(ITYPE.EQ.3.OR.ITYPE.EQ.4) THEN
          If (iOpt.eq.1) Then
          CALL DAXPY_(NBTRI,CGX*ROTMAT(1,1),SCR,1,SDMXR,1)
          CALL DAXPY_(NBTRI,CGY*ROTMAT(2,1),SCR,1,SDMXI,1)
          CALL DAXPY_(NBTRI,CG0*ROTMAT(3,1),SCR,1,SDMXR,1)

          CALL DAXPY_(NBTRI,CGX*ROTMAT(1,2),SCR,1,SDMYR,1)
          CALL DAXPY_(NBTRI,CGY*ROTMAT(2,2),SCR,1,SDMYI,1)
          CALL DAXPY_(NBTRI,CG0*ROTMAT(3,2),SCR,1,SDMYR,1)

          CALL DAXPY_(NBTRI,CGX*ROTMAT(1,3),SCR,1,SDMZR,1)
          CALL DAXPY_(NBTRI,CGY*ROTMAT(2,3),SCR,1,SDMZI,1)
          CALL DAXPY_(NBTRI,CG0*ROTMAT(3,3),SCR,1,SDMZR,1)
          Else
          CALL DAXPY_(NBTRI,CGX,SCR,1,SDMXR,1)
          CALL DAXPY_(NBTRI,CGY,SCR,1,SDMYI,1)
          CALL DAXPY_(NBTRI,CG0,SCR,1,SDMZR,1)
          End If
        END IF


cccccccccccccccccccccccccccccccccccccccccccccccccccccc
c SPINORBIT
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Sign of the left-hand imaginary part is handled
c when doing DAXPY
        URR=USOR(LSS,BSS)
        UIR=USOI(LSS,BSS)
        URL=USOR(KSS,ASS)
        UIL=USOI(KSS,ASS)

        DO IDIR=1,3
          CALL DCOPY_(NBTRI,[0.0D00],0,TMPR,1)
          CALL DCOPY_(NBTRI,[0.0D00],0,TMPI,1)

C right side
          CALL DAXPY_(NBTRI,       URR,IZMR(IDIR)%A2(:),1,TMPR,1)
          CALL DAXPY_(NBTRI,-1.0d0*UIR,IZMI(IDIR)%A2(:),1,TMPR,1)
          CALL DAXPY_(NBTRI,       UIR,IZMR(IDIR)%A2(:),1,TMPI,1)
          CALL DAXPY_(NBTRI,       URR,IZMI(IDIR)%A2(:),1,TMPI,1)

C left side
         CALL DAXPY_(NBTRI,       URL,TMPR,1,IZMR2(IDIR)%A2(:),1)
         CALL DAXPY_(NBTRI,       UIL,TMPI,1,IZMR2(IDIR)%A2(:),1)
         CALL DAXPY_(NBTRI,       URL,TMPI,1,IZMI2(IDIR)%A2(:),1)
         CALL DAXPY_(NBTRI,-1.0d0*UIL,TMPR,1,IZMI2(IDIR)%A2(:),1)
        END DO
cccccccccccccccccccccc
c END SPINORBIT STUFF
cccccccccccccccccccccc



C END MAIN LOOP OVER STATES (KSS,LSS)
 2200   CONTINUE

       END DO
      END DO


C Store this density to DENSOUT
      IF(ITYPE.EQ.3.OR.ITYPE.EQ.4) THEN
        DO I=1,NBTRI
          DENSOUT(1,I)=SDMXR2(I)
          DENSOUT(2,I)=SDMYR2(I)
          DENSOUT(3,I)=SDMZR2(I)
          DENSOUT(4,I)=SDMXI2(I)
          DENSOUT(5,I)=SDMYI2(I)
          DENSOUT(6,I)=SDMZI2(I)
        END DO
      ELSE
        DO I=1,NBTRI
          DENSOUT(1,I)=SDMZR2(I)
          DENSOUT(2,I)=SDMZR2(I)
          DENSOUT(3,I)=SDMZR2(I)
          DENSOUT(4,I)=SDMZI2(I)
          DENSOUT(5,I)=SDMZI2(I)
          DENSOUT(6,I)=SDMZI2(I)
        END DO
      END IF

c Free memory
      CALL mma_deallocate(SCR)
      CALL mma_deallocate(TDMZZ)

      Call mma_deallocate(SDMXR)
      Call mma_deallocate(SDMYR)
      Call mma_deallocate(SDMZR)
      Call mma_deallocate(SDMXI)
      Call mma_deallocate(SDMYI)
      Call mma_deallocate(SDMZI)
      nullify(IZMR(1)%A2,IZMR(2)%A2,IZMR(3)%A2,IZMI(1)%A2,IZMI(2)%A2,
     &        IZMI(3)%A2)

      Call mma_deallocate(TMPI)
      Call mma_deallocate(TMPR)

      Call mma_deallocate(SDMXR2)
      Call mma_deallocate(SDMYR2)
      Call mma_deallocate(SDMZR2)
      Call mma_deallocate(SDMXI2)
      Call mma_deallocate(SDMYI2)
      Call mma_deallocate(SDMZI2)
      nullify(IZMR2(1)%A2,IZMR2(2)%A2,IZMR2(3)%A2,IZMI2(1)%A2,
     &        IZMI2(2)%A2,IZMI2(3)%A2)

      Call mma_deallocate(MAPMS)
      Call mma_deallocate(MAPSP)
      Call mma_deallocate(MAPST)

      END SUBROUTINE SONATORBM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Vibrot(ngrid,nvib,Umin,Umax,R,PotR,E0,dE0,Redm,Req,
     &                  scale,temp)
C
C     Numerical solution of the vibrational Schroedinger equation
C     for a diatomic molecule.
C
C     PotR is the electronic energy given as input
C     Redm is the reduced mass
C     Jrot is the rotational quantum number
C     G is the radial wave function in a logaritmic scale U=ln(R)
C     Umin to Umax is the integration range
C     del is the step length
C     R=exp(U) is the radial coordinates
C     E is the energy
C     ndim is the number of integration steps
C     E0 is the starting value for an eigenvalue search. E0 is simply
C     put equal to the minimum value of the potential.
C     nvib is the number of eigenvalues wanted.
C     dE0 the original step length in the energy interpolation procedure
C
C     ********** MOLCAS-2 Release 90 05 01 **********
C
      Implicit Real*8 (A-H,O-Z)
C
#include "dimensions.fh"
#include "intinp.fh"
#include "observ.fh"
#include "warnings.fh"
      Dimension R(npoint+4),V(npoint),G(npoint),Svec(npoint),
     *          S(3*npoint),Ener(npoint),PotR(npoint+4),H(3*npoint),
     *          alfa(npoint),beta(npoint),W(npoint),B(npoint),
     *          Vec(npoint)
C
      Data zero/0.D 0/,one/1.D 0/,two/2.D 0/,three/3.D 0/,four/4.D 0/,
     *               five/5.D 0/,six/6.D 0/,twelve/12.D 0/
C
      D    = zero ! dummy initialize
      DMem = zero ! dummy initialize
C
      If(ngrid.gt.npoint) then
       Write(6,999) ngrid,npoint
999    Format(/1x,'Number of gridpoints',I4,' is larger than'/
     *        1x,' Dimension npoint=',I3,' in VIBROT.'/
     *        1x,' Program cannot continue.')
      Endif
C
C
      del=(Umax-Umin)/(ngrid-1)
      del2=del**2
      del12=del2/twelve
      del56=del2*five/six
      Thre=1.0D-08
      PotR0=PotR(ngrid+1)
      PotRn1=PotR(ngrid+2)
      R0=R(ngrid+1)
      Rn1=R(ngrid+2)
C
      Write(6,2700)
2700  Format(//1x,'Eigenstates'//1x,' Vib. q.n.   Rot. q.n.    Energy')
C
C     Start loop over rotational quantum numbers
C
      Est=E0
      Do 500 J=J1A,J2A
       iad12(J-J1A+1)=iadvib
       Xrot=-one/two+sqrt(one/four+J*(J+1)-lambda**2)
C
C      Construct effective potential V
C      and overlap vector Svec
C
       const=one/four+Xrot*(Xrot+1)
       redM2=two*redM
       Svec0=redM2*R0**2
       V0=const+Svec0*PotR0
       SvecN1=redM2*Rn1**2
       VN1=const+SvecN1*PotRn1
       Do 11 i=1,ngrid
        fact=redM2*R(i)**2
        Svec(i)=fact
        V(i)=const+fact*PotR(i)
11     Continue
C
C      Construct Hamilton and Overlap matrices
C
       k=3
       ngrid1=ngrid-1
       Do 20 i=2,ngrid1
        k=k+1
        H(k)=one-del12*V(i-1)
        S(k)=-del12*Svec(i-1)
        k=k+1
        H(k)=-two-DEL56*V(i)
        S(k)=-DEL56*Svec(i)
        k=k+1
        H(k)=one-del12*V(i+1)
        S(k)=-del12*Svec(i+1)
20     continue
       H(3)=one-del12*V(2)
       S(3)=-del12*Svec(2)
       nn1=3*ngrid-2
       H(nn1)=one-del12*V(ngrid1)
       S(nn1)=-del12*Svec(ngrid1)
C
C      H(1,1) and S(1,1) depends explicitly on energy and are
C      therefore constructed during the iteration process
C
C      set up and solve secular problem
C      search for eigenvalues starting from E0.
C
       fac=exp(-del*(Xrot+one/two))
       X2=redM/(two*Xrot+three)
       term2=fac*X2*R0**2
       term4=X2*R(1)**2
       H11a=-two-del56*V(1)
       Hnna=-two-del56*V(ngrid)
       H11c=one-del12*V0
       Hnnc=one-del12*VN1
       S11a=-del56*Svec(1)
       Snna=-del56*Svec(ngrid)
       S11c=-del12*Svec0
       Snnc=-del12*SvecN1
       delRN=Rn1-R(ngrid)
       nn=3*ngrid-1
C
       Do 100 ivib=1,nvib
        iter=0
        E=E0-dE0
        ist=0
        Emem=zero
        dE=dE0
C IFG Stop if above the dissociation limit
C     (assuming energy at infinity is set to zero)
101     If (E.gt.Zero) then
         Call SysQuitMsg(_RC_NOT_CONVERGED_,'VibRot',
     *        'Failed to find a state.','Try decreasing STEP.')
        End If
        E=E+dE
C       Compute h(1,1) and s(1,1)
        GAM0=(fac+(PotR0-E)*term2)/(one+(PotR0-E)*term4)
        H11=H11a+GAM0*H11c
        S11=S11a+GAM0*S11c
        H(2)=H11
        S(2)=S11
C       Compute H(N,N) and S(N,N)
        GAMn=exp(-sqrt(-redM2*E)*delRN-del/two)
        H(nn)=HnnA+GAMn*HnnC
        S(nn)=SnnA+GAMn*SnnC
C       Calculate secular determinant
        D1t=H11-E*S11
        D1=D1t/abs(D1t)
        D2=one
        k=3
        Do 110 i=2,ngrid
         Akk=H(k+2)-E*S(k+2)
         D=D1*Akk/abs(Akk)-D2*(H(k)-E*S(k))*(H(k+1)-E*S(k+1))/
     *   abs((H(k-1)-E*S(k-1))*Akk)
         D2=D1
         D1=D
         k=k+3
110     Continue
C
        If(ist.ne.0) go to 111
        ist=1
        Dmem=D
        go to 101
111     If(D/Dmem.lt.zero) go to 112
        Dmem=D
        go to 101
C       an eigenvalue has been bracketed
112     E1=E
        E=E1-DE*D/(D-Dmem)
        If(abs(E-Emem).lt.thre) go to 120
        Emem=E
        E=E-DE
        DE=DE/three
        E=E-DE
        ist=0
        go to 101
C       One eigenvalue found. Remove scaling
120     Ener(ivib)=(E-Est)/scale
        E0=E+dE0
        alfa(ngrid)=H(nn)-E*S(nn)
        beta(ngrid)=H(nn-1)-E*S(nn-1)
        k=nn+1
        Do 130 i=1,ngrid1
         k=k-3
         ii=ngrid-i
         If(ii.ne.1) beta(ii)=H(K-2)-E*S(K-2)
         Wii=(H(k)-E*S(k))/alfa(ii+1)
         alfa(ii)=H(k-1)-E*S(k-1)-Wii*beta(ii+1)
         W(ii)=Wii
130     Continue
C       step 2: unit right hand side
        If(abs(alfa(1)).eq.zero) alfa(1)=1.0D-10
        G(1)=one/alfa(1)
        Do 131 I=2,ngrid
         G(i)=(one-beta(i)*G(i-1))/alfa(i)
131     Continue
C       step 3: g on the right hand side
134     B(ngrid)=G(ngrid)
        Do 132 i=1,ngrid1
         ii=ngrid-i
         B(ii)=G(ii)-W(ii)*B(ii+1)
132     Continue
        Vec(1)=B(1)/alfa(1)
        Do 133 i=2,ngrid
         Vec(i)=(B(i)-beta(i)*Vec(i-1))/alfa(i)
133     Continue
C       normalize g and vec
        Gmax=zero
        Vmax=zero
        Do 140 i=1,ngrid
         AGi=abs(G(i))
         If(AGi.gt.Gmax) Gmax=AGi
         AVi=abs(Vec(i))
         If(AVi.gt.Vmax) Vmax=AVi
140     Continue
        diffm=zero
        Do 150 i=1,ngrid
         G(i)=G(i)/Gmax
         Vec(i)=Vec(i)/Vmax
         Adif=abs(Vec(i))-abs(G(i))
         If(Adif.gt.diffm) diffm=Adif
150     Continue
        If(diffm.lt.1.E-06.and.iter.ne.0) go to 160
        iter=iter+1
        Do 151 i=1,ngrid
         G(i)=Vec(i)
151     Continue
        go to 134
160     Continue
        Evib=(E-Est)/scale
CGG: Remove scaling
        Vec(ngrid+1)=E/scale
C        Vec(ngrid+1)=E
        Call DDafile(Vibwvs,1,Vec(1),ngrid+1,iadvib)
C
C       Print energies and notify on end point values
C
        V1=abs(Vec(1))
        Vn=abs(Vec(ngrid))
        THR=1.D-03
        If(V1.lt.THR.and.Vn.lt.THR) Write(6,3000) ivib-1,J,Evib
        If(V1.lt.THR.and.Vn.ge.THR) Write(6,3001) ivib-1,J,Evib,Vn
        If(V1.ge.THR.and.Vn.lt.THR) Write(6,3002) ivib-1,J,Evib,V1
        If(V1.ge.THR.and.Vn.ge.THR) Write(6,3003) ivib-1,J,Evib,V1,Vn
3000    Format(4X,I3,9X,I3,2X,F12.6)
3001    Format(4X,I3,9X,I3,2X,F12.6,5X,
     *         'Warning:function value at Rmax is',f12.6)
3002    Format(4X,I3,9X,I3,2X,F12.6,5X,
     *         'Warning:function value at Rmin is',f12.6)
3003    Format(4X,I3,9X,I3,2X,F12.6,5X,
     *         'Warning:function value at Rmin is',F12.6,' and at Rmax',
     *          F12.6)
C
100    Continue
C
       iadrsp(J-J1A+1)=iadvib
       Call DDafile(Vibwvs,1,Ener(1),nvib,iadvib)
       E0=Est
500   Continue
C
C     write address record to Vibwvs
C
      iadvib=0
      Call iDafile(Vibwvs,1,iad12,100,iadvib)
C
C     Compute spectroscopic parameters
C
      E0x=Est/scale
      If(ispc.ne.0) Call Spectc(Req,E0x,Atom1,Atom2,nvib)
C
C     Compute matrix elements of observables
C
      If(iobs.ne.0) then
       Do 600 i=1,iobs
       Call Vibmat(nvib,ngrid,Umin,Umax,Titobs(i),R,EoutO(1,i),temp)
600    Continue
      Endif
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3aphlp6 (a1,a2,b,dimp,dimq,dimr,dimpq,ns,szkey)
c
c     this routine realize following procedure
c     for symp=symq.ne.symr
c
c     B(pq,r)=B(pq,r)+ns*(A1(q,r,p)-A2(p,r,q))
c
c     a1     - A1 matrix (I)
c     a2     - A2 matrix (I)
c     b      - B  matrix (I/O)
c     dimp   - dimension of p index (I)
c     dimq   - dimension of q index (I)
c     dimr   - dimension of r index (I)
c     dimpq  - dimension of pq (I)
c     ns     - singum of the permutation (+-1) (I)
c     szkey  - set zero key (I)
c     = 0 no vanishing
c     = 1 set B=0 at the beggining
c
#include "t31.fh"
       integer dimp,dimq,dimr,dimpq,ns,szkey
       real*8 a1(1:dimq,1:dimr,1:dimp)
       real*8 a2(1:dimp,1:dimr,1:dimq)
       real*8 b(1:dimpq,1:dimr)
c
c     help variables
c
       integer p,q,r,pq0
       integer nhelp
c
c
       if (szkey.eq.1) then
       nhelp=dimpq*dimr
       call cct3_mv0zero (nhelp,nhelp,b)
       end if
c
       if (ns.eq.1) then
c     phase +1
c
       do 104 r=1,dimr
       do 1040 p=2,dimp
       pq0=nshf(p)
       do 1041 q=1,p-1
       b(pq0+q,r)=b(pq0+q,r)-a2(p,r,q)
 1041   continue
 1040   continue
 104    continue
c
       do 106 r=1,dimr
       do 1060 p=2,dimp
       pq0=nshf(p)
       do 1061 q=1,p-1
       b(pq0+q,r)=b(pq0+q,r)+a1(q,r,p)
 1061   continue
 1060   continue
 106    continue
c
       else
c     phase -1
c
       do 204 r=1,dimr
       do 2040 p=2,dimp
       pq0=nshf(p)
       do 2041 q=1,p-1
       b(pq0+q,r)=b(pq0+q,r)+a2(p,r,q)
 2041   continue
 2040   continue
 204    continue
c
       do 206 r=1,dimr
       do 2060 p=2,dimp
       pq0=nshf(p)
       do 2061 q=1,p-1
       b(pq0+q,r)=b(pq0+q,r)-a1(q,r,p)
 2061   continue
 2060   continue
 206    continue
c
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Do_Int_CASDFT2(Weights,nGrid,mAO,
     &                         TabSO,nTabSO,TabMO,nTabMO,
     &                         nD,FckInt,nFckInt,nFckDim,
     &                         RhoI,RhoA,mRho,dF_dRho,ndF_dRho,
     &                         dFdP2ontop,ndFdP2ontop,
     &                         TmpPUVX,nTmpPUVX)
      Implicit Real*8 (A-H,O-Z)
#include "nq_info.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "debug.fh"
#include "nsd.fh"
#include "setup.fh"
#include "nq_index.fh"
      Real*8 Weights(nGrid),
     &       TabSO(mAO,nGrid,nTabSO),
     &       TabMO(mAO,nGrid,nTabMO),
     &       FckInt(nFckInt,nFckDim),
     &       dF_dRho(ndF_dRho,nGrid),
     &       dFdP2ontop(ndFdP2ontop,nGrid),
     &       RhoI(mRho,nGrid),RhoA(mRho,nGrid),
     &       TmpPUVX(nTmpPUVX)
      Integer iOff_Ash(0:7),iOff_Bas(0:7)
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      jOff_=0
      Do iIrrep = 0, mIrrep-1
         iOff_Ash(iIrrep)=jOff_ + nIsh(iIrrep) ! ? not used
         iOff_Bas(iIrrep)=jOff_
         jOff_=jOff_+mBas(iIrrep)
      End Do
*
      iOff=0
      Do iIrrep = 0, mIrrep - 1
         Do iBas_ = 1, mBas(iIrrep)
            iBas = iBas_ + iOff_Bas(iIrrep)
            Do jBas_ = 1, iBas_
               jBas = jBas_ + iOff_Bas(iIrrep)
               ijInd=iOff+iTri(iBas_,jBas_)
*
*              Sorry Sergey but I do not understand these two different
*              options. mAO is not properly set.
*
               If (mAO.eq.4) Then
                  Do iGrid=1,nGrid
                     OrbProd  = TabSO(1,iGrid,iBas)*TabSO(1,iGrid,jBas)
                     OrbProdx = TabSO(2,iGrid,iBas)*TabSO(1,iGrid,jBas)
     &                        + TabSO(1,iGrid,iBas)*TabSO(2,iGrid,jBas)
                     OrbPrody = TabSO(3,iGrid,iBas)*TabSO(1,iGrid,jBas)
     &                        + TabSO(1,iGrid,iBas)*TabSO(3,iGrid,jBas)
                     OrbProdz = TabSO(4,iGrid,iBas)*TabSO(1,iGrid,jBas)
     &                        + TabSO(1,iGrid,iBas)*TabSO(4,iGrid,jBas)
*
                     FckInt(ijInd,1) = FckInt(ijInd,1)
     &                               + Weights(iGrid)
     &                               *(OrbProd* dF_dRho(ipRa,iGrid)
     &                                +OrbProdx*dF_dRho(ipdRxa,iGrid)
     &                                +OrbPrody*dF_dRho(ipdRya,iGrid)
     &                                +OrbProdz*dF_dRho(ipdRza,iGrid))
                     FckInt(ijInd,2) = FckInt(ijInd,2)
     &                               + Weights(iGrid)
     &                               *(OrbProd* dF_dRho(ipRb,iGrid)
     &                                +OrbProdx*dF_dRho(ipdRxb,iGrid)
     &                                +OrbPrody*dF_dRho(ipdRyb,iGrid)
     &                                +OrbProdz*dF_dRho(ipdRzb,iGrid))
*
                  End Do ! iGrid
               Else
                  Do iGrid=1,nGrid
                     OrbProd  = TabSO(1,iGrid,iBas)*TabSO(1,iGrid,jBas)
                     FckInt(ijInd,1) = FckInt(ijInd,1)
     &                               + Weights(iGrid)
     &                               * OrbProd* dF_dRho(ipRa,iGrid)
                     FckInt(ijInd,2) = FckInt(ijInd,2)
     &                               + Weights(iGrid)
     &                               * OrbProd* dF_dRho(ipRb,iGrid)
*
                  End Do ! iGrid
               End If
*
            End Do  ! jBas
         End Do ! iBas
         iOff = iOff + (mBas(iIrrep)**2+mBas(iIrrep))/2
      End Do  ! iIrrep
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(TabMO)
         Call Unused_integer(nD)
         Call Unused_real_array(RhoI)
         Call Unused_real_array(RhoA)
         Call Unused_real_array(dFdP2ontop)
         Call Unused_real_array(TmpPUVX)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RBufO_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IADXS)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: LUHLFX, LL, LBuf, NOTU, KKTU, IADXS
real(kind=wp), intent(_OUT_) :: W(*)
integer(kind=iwp) :: IADX, IEnd, IST, Length, MEMX

call mma_maxDBLE(MEMX)
IADX = (KKTU-1)*IADXS
IST = 1
Length = LBuf
IEnd = LBuf

do
  call dDAFILE(LUHLFX,2,W(IST),Length,IADX)
  IST = IST+LBuf
  IEnd = IEnd+LBuf
  if (IEnd > LL) Length = mod(LL,LBuf)
  IADX = IADX+(NOTU-1)*IADXS
  if (IST > LL) exit
end do

return

end subroutine RBufO_tra2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine trunc_dkh (nbas,isize,znuc,maxexp,minexp,dkhorder,
     *                      clight,scrno1,scrno2,scrno3,vv,
     *                      nn,e,scr5,scr8,scr9,tran,sinv)
c
************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 25.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer nbas,isize,dkhorder,scrno1,scrno2,scrno3
      real*8 znuc,maxexp,minexp,clight,vv(nbas,nbas),
     *                 nn(nbas,nbas),e(nbas),
     *                 scr5(nbas,nbas,scrno1),scr8(isize,scrno2),
     *                 scr9(nbas,scrno3),tran(nbas,nbas),sinv(nbas,nbas)
c
      real*8 scaling,truncthrsh,ddum1,ddum2,maxew
      parameter (truncthrsh=1.0d-10)
c
C     integer i,j,ij
      integer i,j
      real*8 dum(1)
c
c
      write (stdout,1001) truncthrsh
1001  format (/8X,76('-'),/8X,'|',4X,'Determination of necessary value',
     *        ' of dkhorder for exact decoupling',5X,'|',/8X,76('-'),
     *        //4X,'Truncation threshold (truncthrsh):',1X,D13.6)
c
      scaling=1.0d0/(4.0d0*clight*clight)
c       scaling=1.0d0
c
      write (stdout,1020)
1020  format (/4X,'Calculation of scaled eigenvalues ( scaling=1',
     *        '/(4c^2) ) of',//8X,'the truncation estimate operator',
     *        ' V_k = AVA*(AV~A)^(k-1):',//8X,'k',26X,'Smallest',20X,
     *        'Largest',14X,'Abs_value',/)
c
      call mat_triang (scr8(1,1),nbas,vv)
c
      do 10 i=0,3*maxorder
        dum=1.0
        call diagr (scr8(1,1),nbas,tran,scr9(1,1),sinv,scr5(1,1,3),dum)
        do 20 j=1,nbas
          scr9(j,1)=scr9(j,1)*scaling
  20    continue
        ddum1=abs(scr9(1,1))
        ddum2=abs(scr9(nbas,1))
        if (ddum1.ge.ddum2) maxew=ddum1
        if (ddum2.ge.ddum1) maxew=ddum2
        write (stdout,1030) i+1,i+1,scr9(1,1),scr9(nbas,1),maxew
1030    format (7X,I2,6X,'DKH',I2,3X,F24.12,3X,F24.12,9X,D13.6)
        if (maxew.lt.truncthrsh) then
          write (stdout,1040) i,dkhorder
1040      format (/4X,'For this system (Z, nbas, maxexp, truncthrsh)',
     *            ' DKH',I2,/6X,'should be sufficient for exact ',
     *            'decoupling.',//4X,'Here:  dkhorder = ',I2,'.',
     *            //2X,76('-'))
          goto 150
        endif
        call mat_sq_from_t (scr5(1,1,1),nbas,scr8(1,1))
        call DGEMM_('N','N',nbas,nbas,nbas,1.0d0,scr5(1,1,1),
     *               nbas,nn,nbas,0.0d0,scr5(1,1,2),nbas)
        call mat_copy (scr5(1,1,1),nbas,nbas,scr5(1,1,2))
        call mat_triang (scr8(1,1),nbas,scr5(1,1,1))
c
  10  continue
c
 150  continue
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real(znuc)
        call Unused_real(maxexp)
        call Unused_real(minexp)
        call Unused_real_array(e)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!***********************************************************************

subroutine CHO_REORDR(irc,scr,lscr,jVref,JVEC1,JNUM,NUMV,JSYM,IREDC,iSwap,ipChoV,Arr,iSkip)
!***********************************************************
! Author: F. Aquilante
!
! Purpose:  SCR(lscr) contains JNUM cholesky vectors
!           starting from JVEC1 and stored in reduced
!           sets. The routine performs a reallocation
!           of these elements in a set of target
!           arrays identified by the pointers ipChoV.
!           In the target arrays, the vectors are
!           stored in full dimension and as a
!           subset of a a given NUMV number of vectors.
!           Each pointer should thereby point to a
!           location where the corresponding Cholesky
!           vector of a given unique symmetry pair
!           of indices has to be stored
!
! Input:
!     Ivec1 =  first vector to be copied
!     JNum  =  # of vectors to be copied
!
!     NumV  =  total # of vectors in the target arrays
!
!     iSwap :   = 0   L(a,b,J) is returned
!                     (in LT-storage if sym(a)=sym(b))
!               = 1   L(a,J,b) is returned
!               = 2   L(a,J,b) is returned
!                     (in SQ-storage if sym(a)=sym(b))
!
!     iSkip(syma)=0 : skip the symmetry block a.
!                  Any vector L(ab) or L(ba) with syma x symb=JSYM
!                  won't be returned in the target array
!
!     IREDC :  reduced set in core at the moment of
!              the call to the routine.
!              Can be set to -1 by the calling routine
!
!********************************************************

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri, nTri_Elem
use Cholesky, only: iBas, iiBstR, IndRed, InfVec, iRS2F, nBas, nDimRS, nnBstR
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: lscr, jVref, JVEC1, JNUM, NUMV, JSYM, iSwap, ipChoV(*), iSkip(*)
real(kind=wp), intent(in) :: Scr(lscr)
integer(kind=iwp), intent(inout) :: IREDC
real(kind=wp), intent(inout) :: Arr(*)
integer(kind=iwp) :: iabf, iag, ias, ibg, ibs, iLoc, iRab, iSyma, iSymb, jRab, JRED, JVEC, kchov, kchov1, kchov2, kRab, kscr, NREAD
integer(kind=iwp), external :: cho_isao

!*********************************************************
!
! From Reduced sets to full storage
! ---------------------------------
!
! iSwap = 0
!
!  L{a,b,J} ---> L(a,b,J)
!
! iSwap = 1
!
!  L{a,b,J} ---> L(a,J,b)
!
! iSwap = 2
!
!  L{a,b,J} ---> L(ab,J)  ! with squaring of the
!                         ! "diagonal" symmetry blocks
!
!*********************************************************

iLoc = 3 ! use scratch location in reduced index arrays

if ((jSym == 1) .and. (iSwap == 0)) then  ! L(ab),J

  NREAD = 0
  kchov = 0
  kchov2 = 0
  do JVEC=1,JNUM

    JRED = InfVec(JVEC1-1+JVEC,2,jSym)

    if (JRED /= IREDC) then ! JRED is not the rs in core
      call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
      IREDC = JRED
    end if

    kscr = NREAD
    NREAD = NREAD+nDimRS(jSym,JRED)

    do jRab=1,nnBstR(jSym,iLoc)

      kRab = iiBstr(jSym,iLoc)+jRab
      iRab = IndRed(kRab,iLoc)

      iag = iRS2F(1,iRab)  !global address
      ibg = iRS2F(2,iRab)

      iSyma = cho_isao(iag)  !symmetry block

      kscr = kscr+1

      if (iSkip(iSyma) /= 0) then

        ias = iag-ibas(iSyma)  !addr within that symm block
        ibs = ibg-ibas(iSyma)

        iabf = iTri(ias,ibs)
        kchov = (JVEC-1)*nTri_Elem(nBas(iSyma))+iabf+ipChoV(iSyma)-1

        Arr(kchov) = Scr(kscr)

      end if

    end do

  end do

else if ((jSym == 1) .and. (iSwap == 1)) then  ! LaJ,b

  NREAD = 0
  kchov = 0
  kchov2 = 0
  do JVEC=1,JNUM

    JRED = InfVec(JVEC1-1+JVEC,2,jSym)

    if (JRED /= IREDC) then ! JRED is not the rs in core
      call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
      IREDC = JRED
    end if

    kscr = NREAD
    NREAD = NREAD+nDimRS(jSym,JRED)

    do jRab=1,nnBstR(jSym,iLoc)

      kRab = iiBstr(jSym,iLoc)+jRab
      iRab = IndRed(kRab,iLoc)

      iag = iRS2F(1,iRab)  !global address
      ibg = iRS2F(2,iRab)

      iSyma = cho_isao(iag)  !symmetry block

      kscr = kscr+1

      if (iSkip(iSyma) /= 0) then

        ias = iag-ibas(iSyma)  !addr within that symm block
        ibs = ibg-ibas(iSyma)

        kchov1 = nBas(iSyma)*NUMV*(ibs-1)+nBas(iSyma)*(jVref+JVEC-2)+ias+ipChoV(iSyma)-1
        kchov2 = nBas(iSyma)*NUMV*(ias-1)+nBas(iSyma)*(jVref+JVEC-2)+ibs+ipChoV(iSyma)-1

        Arr(kchov1) = Scr(kscr)
        Arr(kchov2) = Scr(kscr)

      end if

    end do

  end do

else if ((jSym == 1) .and. (iSwap == 2)) then  ! L[ab],J

  NREAD = 0
  kchov = 0
  kchov2 = 0
  do JVEC=1,JNUM

    JRED = InfVec(JVEC1-1+JVEC,2,jSym)

    if (JRED /= IREDC) then ! JRED is not the rs in core
      call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
      IREDC = JRED
    end if

    kscr = NREAD
    NREAD = NREAD+nDimRS(jSym,JRED)

    do jRab=1,nnBstR(jSym,iLoc)

      kRab = iiBstr(jSym,iLoc)+jRab
      iRab = IndRed(kRab,iLoc)

      iag = iRS2F(1,iRab)  !global address
      ibg = iRS2F(2,iRab)

      iSyma = cho_isao(iag)  !symmetry block

      kscr = kscr+1

      if (iSkip(iSyma) /= 0) then

        ias = iag-ibas(iSyma)  !addr within that symm block
        ibs = ibg-ibas(iSyma)

        kchov1 = nBas(iSyma)*nBas(iSyma)*(JVEC-1)+nBas(iSyma)*(ibs-1)+ias+ipChoV(iSyma)-1
        kchov2 = nBas(iSyma)*nBas(iSyma)*(JVEC-1)+nBas(iSyma)*(ias-1)+ibs+ipChoV(iSyma)-1

        Arr(kchov1) = Scr(kscr)
        Arr(kchov2) = Scr(kscr)

      end if

    end do

  end do

else if ((jSym > 1) .and. (iSwap == 0)) then

  NREAD = 0
  kchov = 0
  kchov2 = 0
  do JVEC=1,JNUM

    JRED = InfVec(JVEC1-1+JVEC,2,jSym)

    if (JRED /= IREDC) then ! JRED is not the rs in core
      call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
      IREDC = JRED
    end if

    kscr = NREAD
    NREAD = NREAD+nDimRS(jSym,JRED)

    do jRab=1,nnBstR(jSym,iLoc)

      kRab = iiBstr(jSym,iLoc)+jRab
      iRab = IndRed(kRab,iLoc)

      iag = iRS2F(1,iRab)  !global address
      ibg = iRS2F(2,iRab)

      iSyma = cho_isao(iag)  !symmetry block
      iSymb = Mul(jSym,iSyma) ! sym(a) > sym(b)

      kscr = kscr+1

      if (iSkip(iSyma) /= 0) then

        ias = iag-ibas(iSyma)  !addr within that symm block
        ibs = ibg-ibas(iSymb)

        kchov = nBas(iSyma)*nBas(iSymb)*(JVEC-1)+nBas(iSyma)*(ibs-1)+ias+ipChoV(iSyma)-1

        Arr(kchov) = Scr(kscr)

      end if

    end do

  end do

else if ((jSym > 1) .and. (iSwap == 1)) then

  NREAD = 0
  kchov = 0
  kchov2 = 0
  do JVEC=1,JNUM

    JRED = InfVec(JVEC1-1+JVEC,2,jSym)

    if (JRED /= IREDC) then ! JRED is not the rs in core
      call Cho_X_SetRed(irc,iLoc,JRED) !set indx arrays at iLoc
      IREDC = JRED
    end if

    kscr = NREAD
    NREAD = NREAD+nDimRS(jSym,JRED)

    do jRab=1,nnBstR(jSym,iLoc)

      kRab = iiBstr(jSym,iLoc)+jRab
      iRab = IndRed(kRab,iLoc)

      iag = iRS2F(1,iRab)  !global address
      ibg = iRS2F(2,iRab)

      iSyma = cho_isao(iag)  !symmetry block
      iSymb = Mul(jSym,iSyma) ! sym(a) > sym(b)

      kscr = kscr+1

      if (iSkip(iSyma) /= 0) then

        ias = iag-ibas(iSyma)  !addr within that symm block
        ibs = ibg-ibas(iSymb)

        kchov = nBas(iSyma)*NUMV*(ibs-1)+nBas(iSyma)*(jVref+JVEC-2)+ias+ipChoV(iSyma)-1

        Arr(kchov) = Scr(kscr)

      end if

    end do

  end do

else

  write(u6,*) 'Wrong parameters combination. JSYM,iSwap= ',JSYM,iSwap
  irc = 66
  return

end if

irc = 0

return

end subroutine CHO_REORDR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Valera Veryazov                                  *
!***********************************************************************

subroutine SysPutsEnd()

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i

write(u6,'(a,73x,a)') ' ###','###'
write(u6,'(a,73x,a)') ' ###','###'
write(u6,'(a,79a1)') ' ',('#',i=1,79)
write(u6,'(a,79a1)') ' ',('#',i=1,79)

return

end subroutine SysPutsEnd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine update_cvb(dx)
      implicit real*8 (a-h,o-z)
c ... Make: up to date? ...
      logical, external :: up2date_cvb
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension dx(*)
c      dimension orbs(norb,norb),cvb(nvb)

      if(orbopt)call touch_cvb('ORBS')
      if(strucopt)call touch_cvb('CVB')
      call make_cvb('WFN')
c  TRY quantities only up2date if SVB/EVB ok :
      if(up2date_cvb('SVBTRY'))call make_cvb('SVB')
      if(up2date_cvb('EVBTRY'))call make_cvb('EVB')

      ic = 1
      i1 = mstackr_cvb(norb*norb)
      i2 = mstackr_cvb(nvb)
      i3 = mstackr_cvb(norb*norb)
      call update2_cvb(work(i1),work(i2),work(lv(1)),work(lv(2)),
     >  work(lw(2)),dx,
     >  ic,
     >  norb,nvb,nprorb,npr,orbopt,strucopt,sym,
     >  work(lp(6)),iwork(ls(11)),nort,work(i3))
      call fmove_cvb(work(i1),work(lv(1)),norb*norb)
      call fmove_cvb(work(i2),work(lv(2)),nvb)
      call str2vbc_cvb(work(lv(2)),work(lv(5)))
      call mfreer_cvb(i1)
      return
      end
      subroutine upd_cvb(dx,orbs,cvb)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "WrkSpc.fh"
      dimension dx(*)
      dimension orbs(norb,norb),cvb(nvb)
      if(orbopt)call touch_cvb('ORBSTRY')
      if(strucopt)call touch_cvb('CVBTRY')
      call make_cvb('WFNTRY')
      ic = 2
      i1 = mstackr_cvb(norb*norb)
      call update2_cvb(orbs,cvb,work(lv(1)),work(lv(2)),
     >  work(lw(2)),dx,
     >  ic,
     >  norb,nvb,nprorb,npr,orbopt,strucopt,sym,
     >  work(lp(6)),iwork(ls(11)),nort,work(i1))
      call mfreer_cvb(i1)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine dTdmu_mem(nRys,Mem_dTdMu,la,lb,lr)
*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      Mem_dTdMu=0
      nRys =0
      Call EFMmP(nOrder,MmEFP,la,lb+1,lr)
      Mem_dTdMu=Max(Mem_dTdMu,MmEFP)
      nRys =Max(nRys,nOrder)
      If (lb.ge.1) Then
         Call EFMmP(nOrder,MmEFP,la,lb-1,lr)
         Mem_dTdMu=Max(Mem_dTdMu,MmEFP)
         nRys =Max(nRys,nOrder)
      End If
*
*     Add a scratch area for intermediate integrals
*
      MemDer = 3*nElem(la)*nElem(lb+1)
      If (lb.ge.1) MemDer=MemDer + 3*nElem(la)*nElem(lb-1)
      Mem_dTdMu = Mem_dTdMu + MemDer + 1
      Mem_dTdMu = Mem_dTdMu + nElem(la)*nElem(lb)*3
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE MAB(ICASE,JSY,INDEX,C,S,FC,A,B,F,W,THET,ENP,NII)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "cpfmcpf.fh"
      DIMENSION JSY(*),INDEX(*),C(*),S(*),FC(*),A(*),B(*),
     &          F(*),W(*),THET(NII,NII),ENP(*)
      DIMENSION ICASE(*)
      DIMENSION IPOA(9),IPOF(9)
      DIMENSION IOC(55)
CPAM97      EXTERNAL UNPACK
CPAM97      INTEGER UNPACK
CRL   JO(L)=IAND(ISHFT(QOCC((L+29)/30),-2*((L+29)/30*30-L)),3)
CPAM97      JO(L)=UNPACK(QOCC((L+29)/30), 2*L-(2*L-1)/60*60, 2)
      JO(L)=ICUNP(ICASE,L)
CRL   JSYM(L)=IAND(ISHFT(JSY((L+19)/20),-3*((L+19)/20*20-L)),7)+1
CPAM96      JSYM(L)=UNPACK(JSY((L+9)/10),3*MOD(L-1,10)+1,3)+1
      JSYM(L)=JSUNP_CPF(JSY,L)
      NAB=0 ! dummy initialize
      NOB2=IROW(NORBT+1)
      IF(IPRINT.GE.15) THEN
        WRITE(6,'(A,/,(10F12.6))')' S,AB',(S(I),I=1,JSC(4))
      CALL XFLUSH(6)
        WRITE(6,'(A,/,(10F12.6))')' W,AB',(W(I),I=1,JSC(4))
      CALL XFLUSH(6)
        IF(IDENS.EQ.1)WRITE(6,'(A,/,(10F12.6))')
     &                      ' FC,AB',(FC(I),I=1,NOB2)
      END IF
      INUM=IRC(4)-IRC(3)
      CALL MPSQ2(C,S,W,MUL,INDEX,JSY,NDIAG,INUM,IRC(3),
     *LSYM,NVIRT,SQ2)
      NCLIM=4
      IF(IFIRST.NE.0)NCLIM=2
C     MOVE FOCK (DENSITY) MATRIX TO F IN SYMMETRY BLOCKS
      CALL IPO_CPF(IPOF,NVIR,MUL,NSYM,1,-1)
      ITURN=0
90    DO 10 IASYM=1,NSYM
      IAB=IPOF(IASYM)
      NA1=NSYS(IASYM)+1
      NA2=NSYS(IASYM+1)
      IF(NA2.LT.NA1)GO TO 10
      DO 15 NA=NA1,NA2
      DO 20 NB=NA1,NA2
      IAB=IAB+1
      IF(NA.GE.NB)NAB=IROW(LN+NA)+LN+NB
      IF(NB.GT.NA)NAB=IROW(LN+NB)+LN+NA
      IF(ITURN.EQ.1)GO TO 320
      IF(IDENS.EQ.0)F(IAB)=D0
      IF(IDENS.EQ.1)F(IAB)=FC(NAB)
      IF(NA.NE.NB)F(IAB)=FC(NAB)
      GO TO 20
320   IF(NA.LT.NB)FC(NAB)=F(IAB)
20    CONTINUE
15    CONTINUE
10    CONTINUE
      IF(ITURN.EQ.0)GO TO 11
      TR=D0
      IJ=0
      DO 510 I=1,NORBT
      IJ=IJ+I
      TR=TR+FC(IJ)
510   CONTINUE
      If (iPrint.ge.15) WRITE(6,310)TR
310   FORMAT(/,6X,'TRACE OF DENSITY MATRIX',F16.8)
      GO TO 300
11    II1=0
      ITAIL=IRC(NCLIM)
      DO 40 INDA=1,ITAIL
      IF(IDENS.EQ.0)GO TO 111
      DO 110 I=1,LN
      II1=II1+1
      JOJ=JO(II1)
      IF(JOJ.GT.1)JOJ=JOJ-1
      IOC(I)=JOJ
110   CONTINUE
111   IF(INDA.GT.IRC(1))GO TO 120
      IF(IDENS.EQ.0.OR.INDA.EQ.IREF0)GO TO 40
      ENPQ=(D1-THET(INDA,INDA)/D2)*(ENP(INDA)+ENP(INDA)-D1)+
     *THET(INDA,INDA)/D2
      TSUM=C(INDA)*C(INDA)/ENPQ
      GO TO 106
120   MYSYM=JSYM(INDA)
      MYL=MUL(MYSYM,LSYM)
      INMY=INDEX(INDA)+1
      ENPQ=(D1-THET(INDA,INDA)/D2)*(ENP(INDA)+ENP(INDA)-D1)+
     *THET(INDA,INDA)/D2
      FACS=SQRT(ENP(INDA))*SQRT(ENP(INDA))/ENPQ
      FACW=(FACS*(D2-THET(INDA,INDA))/ENPQ)*ENP(INDA)-FACS
      IF(INDA.GT.IRC(2))GO TO 25
C     DOUBLET-DOUBLET INTERACTIONS
      IF(NVIR(MYL).EQ.0)GO TO 40
      IF(IDENS.EQ.1)GO TO 65
      CALL SETZ(A,NVIR(MYL))
      CALL FMMM(F(IPOF(MYL)+1),C(INMY),A,NVIR(MYL),1,NVIR(MYL))
      CALL DAXPY_(NVIR(MYL),FACS,A,1,S(INMY),1)
      CALL DAXPY_(NVIR(MYL),FACW,A,1,W(INMY),1)
      GO TO 40
65    CALL FMUL2_CPF(C(INMY),C(INMY),A,NVIR(MYL),NVIR(MYL),1)
      IPF=IPOF(MYL)+1
      IN=IPOF(MYL+1)-IPOF(MYL)
      ENPQ=(D1-THET(INDA,INDA)/D2)*(ENP(INDA)+ENP(INDA)-D1)+
     *THET(INDA,INDA)/D2
      COPI=D1/ENPQ
      CALL VSMA(A,1,COPI,F(IPF),1,F(IPF),1,IN)
      NVIRA=NVIR(MYL)
      LNA=LN+NSYS(MYL)
      IIA=IROW(LNA+1)
      TSUM=D0
      DO 130 I=1,NVIRA
      SUM=COPI*C(INMY)*C(INMY)
      INMY=INMY+1
      TSUM=TSUM+SUM
      IIA=IIA+LNA+I
      FC(IIA)=FC(IIA)+SUM
130   CONTINUE
      GO TO 106
C     TRIPLET-TRIPLET AND SINGLET-SINGLET INTERACTIONS
25    IFT=1
      IF(INDA.GT.IRC(3))IFT=0
      CALL IPO_CPF(IPOA,NVIR,MUL,NSYM,MYL,IFT)
      IN=0
      TSUM=D0
      DO 70 IASYM=1,NSYM
      IAB=IPOF(IASYM+1)-IPOF(IASYM)
      IF(IAB.EQ.0)GO TO 70
      ICSYM=MUL(MYL,IASYM)
      IF(NVIR(ICSYM).EQ.0)GO TO 70
      IF(IDENS.EQ.1)GO TO 75
      IF(MYL.NE.1)GO TO 30
      IF(IFT.EQ.0)CALL SQUAR_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
C      IF(IFT.EQ.1)CALL SQUARN_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      IF(IFT.EQ.1)CALL SQUARM_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      NAA=NVIR(IASYM)*NVIR(IASYM)
      CALL SETZ(B,NAA)
      CALL FMMM(F(IPOF(IASYM)+1),A,B,NVIR(IASYM),NVIR(IASYM),
     *NVIR(IASYM))
      CALL SETZ(A,NAA)
      CALL DAXPY_(NAA,FACS,B,1,A,1)
      IF(IFT.EQ.1)GO TO 230
      CALL SIADD_CPF(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
      CALL SETZ(A,NAA)
      CALL DAXPY_(NAA,FACW,B,1,A,1)
      CALL SIADD_CPF(A,W(INMY+IPOA(IASYM)),NVIR(IASYM))
      GO TO 70
230   CALL TRADD_CPF(A,S(INMY+IPOA(IASYM)),NVIR(IASYM))
      CALL SETZ(A,NAA)
      CALL DAXPY_(NAA,FACW,B,1,A,1)
      CALL TRADD_CPF(A,W(INMY+IPOA(IASYM)),NVIR(IASYM))
      GO TO 70
30    NAC=NVIR(IASYM)*NVIR(ICSYM)
      CALL SETZ(A,NAC)
      IF(IASYM.GT.ICSYM)GO TO 31
      CALL FMMM(F(IPOF(IASYM)+1),C(INMY+IPOA(ICSYM)),A,
     *NVIR(IASYM),NVIR(ICSYM),NVIR(IASYM))
      CALL DAXPY_(NAC,FACS,A,1,S(INMY+IPOA(ICSYM)),1)
      CALL DAXPY_(NAC,FACW,A,1,W(INMY+IPOA(ICSYM)),1)
      GO TO 70
31    CALL FMMM(C(INMY+IPOA(IASYM)),F(IPOF(IASYM)+1),A,
     *NVIR(ICSYM),NVIR(IASYM),NVIR(IASYM))
      CALL DAXPY_(NAC,FACS,A,1,S(INMY+IPOA(IASYM)),1)
      CALL DAXPY_(NAC,FACW,A,1,W(INMY+IPOA(IASYM)),1)
      GO TO 70
75    IF(MYL.NE.1)GO TO 330
      IF(IFT.EQ.0)CALL SQUAR_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      IF(IFT.EQ.1)CALL SQUARM_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM))
      GO TO 255
330   IF(IASYM.GT.ICSYM)GO TO 231
      NAC=NVIR(IASYM)*NVIR(ICSYM)
      IF(IFT.EQ.0)CALL DCOPY_(NAC,C(INMY+IPOA(ICSYM)),1,A,1)
      IF(IFT.EQ.1)CALL VNEG_CPF(C(INMY+IPOA(ICSYM)),1,A,1,NAC)
      GO TO 255
231   CALL MTRANS_CPF(C(INMY+IPOA(IASYM)),A,NVIR(IASYM),NVIR(ICSYM))
255   CALL FMUL2_CPF(A,A,B,NVIR(IASYM),NVIR(IASYM),NVIR(ICSYM))
      IPF=IPOF(IASYM)+1
      ENPQ=(D1-THET(INDA,INDA)/D2)*(ENP(INDA)+ENP(INDA)-D1)+
     *THET(INDA,INDA)/D2
      COPI=D1/ENPQ
      CALL VSMA(B,1,COPI,F(IPF),1,F(IPF),1,IAB)
      NVIRA=NVIR(IASYM)
      NVIRC=NVIR(ICSYM)
      INN=1
      LNC=LN+NSYS(ICSYM)
      IIC=IROW(LNC+1)
      DO 105 I=1,NVIRC
      SUM=DDOT_(NVIRA,A(INN),1,A(INN),1)
      SUM=COPI*SUM
      TSUM=TSUM+SUM
      IIC=IIC+LNC+I
      FC(IIC)=FC(IIC)+SUM
      INN=INN+NVIRA
105   CONTINUE
70    CONTINUE
      IF(IDENS.EQ.0)GO TO 40
      TSUM=TSUM/D2
106   IJ=0
      DO 107 I=1,LN
      IJ=IJ+I
      FC(IJ)=FC(IJ)+IOC(I)*TSUM
107   CONTINUE
40    CONTINUE
      ITURN=1
      IF(IDENS.EQ.1)GO TO 90
300   CALL MDSQ2(C,S,W,MUL,INDEX,JSY,NDIAG,INUM,IRC(3),
     *LSYM,NVIRT,SQ2)
      IF(IPRINT.GE.15) THEN
        WRITE(6,'(A,/,(10F12.6))')' S,AB',(S(I),I=1,JSC(4))
      CALL XFLUSH(6)
        WRITE(6,'(A,/,(10F12.6))')' W,AB',(W(I),I=1,JSC(4))
      CALL XFLUSH(6)
        IF(IDENS.EQ.1)WRITE(6,'(A,/,(10F12.6))')
     &                      ' FC,AB',(FC(I),I=1,NOB2)
      END IF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1996, Markus P. Fuelscher                         *
*               1991, Per Ake Malmqvist                                *
************************************************************************
      Subroutine SORT0
************************************************************************
*                                                                      *
*     Purpose: Prepare all information needed to sort 2el integral     *
*              into canonical order. This is the interface which       *
*              matches the sorting algorithm to SEWARD.                *
*     Method:  The method of choice is a modification of the bin       *
*              sorting algorithm. The sorting processes in three       *
*              steps: 1). The integrals are  distributed into          *
*                         the bins where the buffers to save integral  *
*                         values and labels are kept separated.        *
*                         If a bin is filled the 'value buffer' is     *
*                         written to LuOrd but the 'label buffer' is   *
*                         stored on LuTmp. Prior to writing all data   *
*                         are compressed.                              *
*                         (c.f. subroutines SORT1A and SORT1B)         *
*                     2). All integrals belonging to the same slice    *
*                         are picked from the disk and sorted in       *
*                         memory. When sorting is completed the        *
*                         overwrite the old records and, if necessary, *
*                         new records are appended to LuOrd. Forward   *
*                         chaining indices are constructed an added to *
*                         the buffers. Hereafter LuTmp is not needed   *
*                         anymore.                                     *
*                         (c.f. subroutines SORT2, SORT2A and SORT2B)  *
*                     3). Finally, the records are brought into        *
*                         sequential order and the file header is      *
*                         completed                                    *
*                         (c.f. subroutines SORT3 and SORT4)           *
*     References: M. Yoshimine in 'Numerical Algorithms in Chemistry:  *
*                 Algebraic Methods', NRCC wokshop 1978                *
*                                                                      *
*     Called from: Seward_main                                         *
*                                                                      *
*     Calls to : MkSrt0,MkSrt1,MkSrt2,OpnOrd,ErrOrd,IniPkR8            *
*                                                                      *
*     Calling parameters: none                                         *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDef  : definitions of the record structure                    *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*     Srt1    : common block containing information the number of      *
*               bins and partitioning of symmetry blocks               *
*     Srt2    : common block containing information pertinent to       *
*               the bin sorting algorithm                              *
*     PkCtl   : packing table                                          *
*     iTMax   : SEWARD's definition of highest angular momentum        *
*     Info    : SEWARD's tables of definitions                         *
*                                                                      *
*     Global data declarations (Include files) :                       *
*                                                                      *
*     Local data declarations: none                                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.-Aa. Malmqvist                             *
*     University of Lund, Sweden, 1991                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     - build in option to use multiple file units                     *
*       M. P. Fuelscher, University of Lund, Sweden, 1996              *
*     - build in option to use a virtual disk                          *
*       M. P. Fuelscher, University of Lund, Sweden, 1996              *
*                                                                      *
************************************************************************
*
      use Basis_Info, only: nBas
      use srt2
      use Symmetry_Info, only: nIrrep, iSkip
      use Integral_parameters, only: iPack
      Use Real_Info, only: PkAcc
      Implicit Integer (A-Z)
*
#include "TwoDat.fh"
#include "srt0.fh"
#include "srt1.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "warnings.fh"
      Logical PkMode
*----------------------------------------------------------------------*
*     pick up the print level                                          *
*----------------------------------------------------------------------*
      iRout = 80
      iPrint = nPrint(iRout)
      If ( iPrint.gt.10) Write (6,*) ' >>> Enter SORT0 <<<'
*----------------------------------------------------------------------*
*     start timer                                                      *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*     assume there is no vortual diak available                        *
*----------------------------------------------------------------------*
      RAMD = .false.
*----------------------------------------------------------------------*
*     open the two electron integral file                              *
*----------------------------------------------------------------------*
*
      LuTwo=isfreeunit(40)
      iOpt=1
      iRc=0
      Call OPNORD(iRc,iOpt,'ORDINT',LuTwo)
      If ( iRc.ne.0 ) Then
         Write (6,*) 'SORT0: Error opening ORDINT'
         Call Abend()
      End If
*
      iOpt=Toctwo(IsForm)
      Kase=iAnd(iOpt,15)
      If(Kase.eq.0) Then
         lBin=lBin_tce
      Else
         lBin=lBin_rle
      End If
*
*----------------------------------------------------------------------*
*     Initialize the common /SRT0/                                     *
*     (Get total no. of irred. representations, basis dimensions ect.) *
*----------------------------------------------------------------------*
*
      Call MKSRT0(0,nIrrep,nBas,iSkip)
*
*----------------------------------------------------------------------*
*     Initialize the common /SRT1/, i.e.,                              *
*     determine the partitioning of the 2el integrals into             *
*     submatrices (slices) where the size of the slices is             *
*     determined by the maximum number of bins (mxBin)                 *
*----------------------------------------------------------------------*
*
      Call MKSRT1()
*
*----------------------------------------------------------------------*
*     allocate the space required in phase1 of the bin sort algoritm   *
*----------------------------------------------------------------------*
*
      Call mma_allocate(lwVBin,lBin,nBin,Label='lwVBin')
      Call mma_allocate(lwIBin,lBin,nBin,Label='lwIBin')
*
      Call mma_allocate(lIndx,lBin,Label='lIndx')
      Call mma_allocate(lInts,lBin,Label='lInts')
      Call mma_allocate(ValBin,lBin,Label='ValBin')
      Call mma_allocate(IndBin,lBin,Label='IndBin')
*
*----------------------------------------------------------------------*
*     compute various offsets for each Bin and also                    *
*     initialize various pointers, counters and disk adresses          *
*----------------------------------------------------------------------*
*
      Call MKSRT2
*
*----------------------------------------------------------------------*
*     set packing mode and initialize packing table                    *
*----------------------------------------------------------------------*
*
      PkMode=.True.
      If ( iPack.ne.0 ) PkMode=.false.
      Call INIPKR8(PkAcc,PkMode)
*
*----------------------------------------------------------------------*
*     generate table of contents on 2el integral file                  *
*----------------------------------------------------------------------*
*
      Call MKORD(iDisk)
*
*----------------------------------------------------------------------*
*     Because the bin sorting algorithm heavily relies on random       *
*     access to the disks from here on the disk access control is      *
*     transfered to the sorting algorithm directly.                    *
*----------------------------------------------------------------------*
*
      iDaTw0=iDisk
      iDaTwo=iDaTw0
      mDaTwo=iDaTw0
*
*----------------------------------------------------------------------*
*     open the scratch file                                            *
*----------------------------------------------------------------------*
*
      LuTmp=isfreeunit(50)
      Call DANAME_MF(LuTmp,'TEMP01')
      iDaTmp=0
      mDaTmp=0

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_X_CompVec(irc,NVT,l_NVT,nBlock,l_nBlock,nV,l_nV1,l_nV2,iV1,l_iV11,l_iV12,ip_Z,l_Z1,l_Z2,Z,l_Z,Free_Z)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: Compute Cholesky vectors from Z vectors in core
!          and integrals computed on the fly:
!
!          L(uv,J) = 1/Z(J,J)
!                  * [ (uv|J) - sum[K=1,J-1] L(uv,K)*Z(J,K) ]
!
! NVT(i): total number of Cholesky vectors (all nodes), sym. i
! nBlock(i): number of vector blocks, sym. i
! nV(i,j): number of vectors in block i of sym. j
! iV1(i,j): index of first vector in block i of sym. j
! ip_Z(i,j): pointer to Z block i of sym. j
!
! If (Free_Z): Z array will be de-allocated here using ip_Z(1,1) as
! start point of the array - i.e. assuming that the Z blocks are
! stored as one coherent array. If this is not the case, simply put
! Free_Z=.False. Letting this routine deallocate Z maximizes the
! memory available for vector distribution.
!
! Vectors are distributed across nodes and stored according to
! reduced set 1 (all of them!).

use Index_Functions, only: iTri, nTri_Elem
#ifdef _DEBUGPRINT_
use Cholesky, only: iSP2F
#endif
use Cholesky, only: IndRSh, INF_PASS, iOff_Batch, IPRINT, iQuAB, iQuAB_here, LuPri, LuTmp, MaxQual, nDGM_call, nDim_Batch, &
                    nnBstRSh, nnShl, nQual, nSym, pTemp, TDECOM
use Cholesky_procedures, only: Cho_X_GetIP_InfVec
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One, OneHalf
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: l_NVT, NVT(l_NVT), l_nBlock, nBlock(l_nBlock), l_nV1, l_nV2, nV(l_NV1,l_NV2), l_iV11, l_iV12, &
                                 iV1(l_IV11,l_iV12), l_Z1, l_Z2, ip_Z(l_Z1,l_Z2), l_Z
real(kind=wp), intent(inout) :: Z(l_Z)
logical(kind=iwp) :: Free_Z
integer(kind=iwp) :: iAdr(8), iCountSP, incZd, iSp, iSP_, iSP_1, iSP_2, iSym, J, J_inBlock, jBlock, K, K_inBlock, kBlock, kI, kL, &
                     kOffI, kOffZ, kZ, kZd, l_Int, l_Wrk, l_Zd, ldL, ldZ, Left, lTot, MaxQual_SAVE, n, nBatch, nSP, nSP_Max, &
                     nSP_this_batch
real(kind=wp) :: Byte, C0, C1, PDone, PMem, TotCPU, TotMem, TotWall, W0, W1, X0, X1, Y0, Y1
character(len=2) :: Unt
integer(kind=iwp), pointer :: InfVcT(:,:,:)
integer(kind=iwp), allocatable :: XCVLSP(:), XCVnBt(:), XCVTMP(:)
real(kind=wp), allocatable :: XCVInt(:), XCVZd(:)
real(kind=wp), parameter :: Mnt = 60.0_wp
character(len=*), parameter :: SecNam = 'Cho_X_CompVec'
integer(kind=iwp), external :: Cho_F2SP
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, nBlock_Max, nnB, nTot, nTot2
integer(kind=iwp), parameter :: myDebugInfo = 100
real(kind=wp), parameter :: Tol = 1.0e-14_wp
#endif

! Init return code
irc = 0

#ifdef _DEBUGPRINT_
! Check input
if ((l_NVT < nSym) .or. (l_nBlock < nSym) .or. (l_nV2 < nSym) .or. (l_iV12 < nSym) .or. (l_Z2 < nSym)) then
  irc = -2
  return
end if
nBlock_Max = nBlock(1)
do iSym=2,nSym
  nBlock_Max = max(nBlock_Max,nBlock(iSym))
end do
nnB = nTri_Elem(nBlock_Max)
if ((l_nV1 < nBlock_Max) .or. (l_iV11 < nBlock_Max) .or. (l_Z1 < nnB)) then
  irc = -1
  return
end if
#endif

! Parallel runs: open tmp vector files
call Cho_XCV_TmpFiles(irc,1)
if (irc /= 0) then
  write(LuPri,'(A,A,I8,A)') SecNam,': [1] Error in Cho_XCV_TmpFiles! (Return code:',irc,')'
  irc = 1
  return
end if

! Get pointer to InfVec array for all vectors
call Cho_X_GetIP_InfVec(InfVcT)

! Copy reduced set 1 to location 2.
! I.e. make rs1 the "current" reduced set.
call Cho_X_RSCopy(irc,1,2)
if (irc /= 0) then
  write(LuPri,'(A,A,I8,A)') SecNam,': Error in Cho_X_RSCopy! (Return code:',irc,')'
  irc = 1
  return
end if

! Allocate tmp array to keep track of which shell pairs are
! computed on this node.
call mma_allocate(XCVTMP,nnShl,Label='XCVTMP')

! Allocate and set list of parent shell pairs to compute
! NOTE: the tmp array allocated above is used here!!!
XCVTMP(:) = 0
nSP = 0
do iSym=1,nSym
  do J=1,NVT(iSym)
    iSP = Cho_F2SP(IndRSh(InfVcT(J,1,iSym))) ! Parent SP
    if ((iSP > 0) .and. (iSP <= nnShl)) then
      if (XCVTMP(iSP) == 0) nSP = nSP+1
      XCVTMP(iSP) = XCVTMP(iSP)+1
    else
      call Cho_Quit(SecNam//': Parent SP error!!',103)
    end if
  end do
end do
call mma_allocate(XCVLSP,nSP,Label='XCVLSP')
nSP = 0
do iSP=1,nnShl
  if (XCVTMP(iSP) > 0) then
    XCVLSP(nSP) = iSP
    nSP = nSP+1
  end if
end do
#ifdef _DEBUGPRINT_
if (nSP /= size(XCVLSP)) call Cho_Quit('SP counting error [1] in '//SecNam,103)
nTot = sum(NVT(1:nSym))
nTot2 = 0
do i=1,nSP
  nTot2 = nTot2+XCVTMP(XCVLSP(i))
end do
if (iPrint >= myDebugInfo) then
  call Cho_Head('Shell pair info from '//SecNam,'*',80,LuPri)
  write(LuPri,'(/,A,I8,/)') 'Number of shell pairs giving rise to vectors:',nSP
  do i=1,nSP
    iSP = XCVLSP(i)
    call Cho_InvPck(iSP2F(iSP),j,k,.true.)
    write(Lupri,'(A,I8,A,I4,A,I4,A,I8,A)') 'Shell pair',iSP,' (shells',j,',',k,') gives rise to',XCVTMP(iSP),' vectors'
  end do
  write(LuPri,'(A,I8,/,A,I8,/,A,I8)') 'Total number of vectors (from SP).................',nTot2, &
                                      'Total number of vectors (from NVT)................',nTot, &
                                      'Difference........................................',nTot2-nTot
end if
if (nTot /= nTot2) call Cho_Quit('SP counting error [2] in '//SecNam,103)
#endif

! Re-allocate and set qualification arrays
pTemp => iQuAB
MaxQual_SAVE = MaxQual
MaxQual = NVT(1)
do iSym=2,nSym
  MaxQual = max(MaxQual,NVT(iSym))
end do
call mma_allocate(iQuAB_here,MaxQual,nSym,Label='iQuAB_here')
iQuAB => iQuAB_here
nQual(1:nSym) = NVT(1:nSym)
iQuAB(1:nQual(iSym),1:nSym) = InfVcT(1:nQual(iSym),1,1:nSym) ! parent product for vector J

! Modify diagonal of Z matrix
! Z(J,J) <- 1/Z(J,J)
! If Z memory should not be de-allocated, save a backup of the
! diagonal.
if (Free_Z) then
  l_Zd = 1
  incZd = 0
else
  l_Zd = sum(NVT(1:nSym))
  incZd = 1
end if
call mma_allocate(XCVZd,l_Zd,Label='XCVZd')
kZd = 1
do iSym=1,nSym
  do jBlock=1,nBlock(iSym)
    kOffZ = ip_Z(iTri(jBlock,jBlock),iSym)-1
    do J_inBlock=1,nV(jBlock,iSym)
#     ifdef _DEBUGPRINT_
      ! Check for division by zero or negative diagonal
      ! This would be a bug....
      if ((abs(Z(kOffZ+iTri(J_inBlock,J_inBlock))) < Tol) .or. (Z(kOffZ+iTri(J_inBlock,J_inBlock)) < -Tol)) then
        write(LuPri,'(//,A,A)') SecNam,': Ooooops!'
        write(LuPri,'(A)') '....division by small or negative number....'
        write(LuPri,'(A,I8)') 'iSym=',iSym
        write(LuPri,'(A,I8)') 'jBlock=',jBlock
        write(LuPri,'(A,I8)') 'J=',iV1(jBlock,iSym)+J_inBlock-1
        write(LuPri,'(A,ES15.6)') 'Z(J,J)=',Z(kOffZ+iTri(J_inBlock,J_inBlock))
        write(LuPri,'(A,ES15.6)') 'Tolerance=',Tol
        call Cho_Quit('Division by small or negative number in '//SecNam,103)
      end if
#     endif
      XCVZd(kZd) = Z(kOffZ+iTri(J_inBlock,J_inBlock))
      Z(kOffZ+iTri(J_inBlock,J_inBlock)) = One/XCVZd(kZd)
      kZd = kZd+incZd
    end do
  end do
end do

! Distribute shell pairs across nodes according to dimension
! (helps load balance the linear algebra part below)
call Cho_XCV_Distrib_SP(XCVTMP,size(XCVTMP),iCountSP)

! Allocate batch dimension array
call mma_allocate(XCVnBt,max(iCountSP,1),Label='XCVnBt')

! Allocate offset array for batched SP loop
call mma_allocate(iOff_Batch,nSym,nnShl,Label='iOff_Batch')

! Split remaining memory in two parts.
! One for integrals/vectors, one for Seward.
call mma_maxDBLE(l_Wrk)
if (l_Wrk < 3) call Cho_Quit('Insufficient memory in '//SecNam,101)
l_Int = int(real(l_Wrk,kind=wp)/OneHalf)
call mma_allocate(XCVInt,l_Int,Label='XCVInt')
call mma_MaxDBLE(l_Wrk)
call xSetMem_Ints(l_Wrk)

! Print
if (iPrint >= Inf_Pass) then
  call Cho_Head('Generation of Cholesky vectors','=',80,LuPri)
  call Cho_Word2Byte(l_Int,8,Byte,Unt)
  write(LuPri,'(/,A,I12,A,F10.3,1X,A,A)') 'Memory available for integrals/vectors..',l_Int,' (',Byte,Unt,')'
  call Cho_Word2Byte(l_Wrk,8,Byte,Unt)
  write(LuPri,'(A,I12,A,F10.3,1X,A,A)') 'Memory available for Seward.............',l_Wrk,' (',Byte,Unt,')'
  write(LuPri,'(A,I12)') 'Number of shell pairs, total (nnShl)....',nnShl
  write(LuPri,'(A,I12)') 'Number of shell pairs, this node........',iCountSP
  write(LuPri,'(//,65X,A)') 'Time/min'
  write(LuPri,'(1X,A,5X,A,5X,A,2X,A,10X,A,16X,A,6X,A)') 'Batch','iSP1','iSP2','%Done','Memory','CPU','Wall'
  write(LuPri,'(A)') '----------------------------------------------------------------------------'
  call XFlush(LuPri)
  TotMem = Zero
  TotCPU = Zero
  TotWall = Zero
end if

! Compute Cholesky vectors in batched loop over shell pairs
iAdr(1:nSym) = 0 ! disk addresses
iSP_1 = 1
nBatch = 0
do while (iSP_1 <= iCountSP)
  if (iPrint >= Inf_Pass) call CWTime(X0,Y0)
  ! Set batch info
  Left = l_Int
  nSP_Max = iCountSP-iSP_1+1
  nSP_this_batch = 0
  do while ((Left > 0) .and. (nSP_this_batch < nSP_Max))
    iSP = iSP_1+nSP_this_batch
    n = sum(nnBstRSh(1:nSym,XCVTMP(iSP),2)*NVT(1:nSym))
    if (n <= Left) then
      Left = Left-n
      nSP_this_batch = nSP_this_batch+1
    else
      Left = 0 ! break while loop
    end if
  end do
  if (nSP_this_batch < 1) call Cho_Quit(SecNam//': Insufficient memory for shell pair batch',101)
  iSP_2 = iSP_1+nSP_this_batch-1
  do iSym=1,nSym
    nDim_Batch(iSym) = 0
    do iSP_=iSP_1,iSP_2
      iSP = XCVTMP(iSP_)
      iOff_Batch(iSym,iSP) = nDim_Batch(iSym)
      nDim_Batch(iSym) = nDim_Batch(iSym)+nnBstRSh(iSym,iSP,2)
    end do
  end do
  ! Calculate integrals (uv|J) for uv in shell pair batch and
  ! for all J (shell pairs that give rise to vectors are
  ! listed in ListSP).
  call Cho_XCV_GetInt(irc,XCVTMP(iSP_1),nSP_this_batch,XCVLSP,size(XCVLSP),NVT,l_NVT,XCVInt,size(XCVInt))
  if (irc /= 0) then
    write(LuPri,'(A,A,I8)') SecNam,': Cho_XCV_GetInt returned code',irc
    call Cho_Quit(SecNam//': Error in Cho_XCV_GetInt',104)
  end if
  ! Convert integrals into Cholesky vectors in each symmetry
  call CWTime(C0,W0)
  kOffI = 1
  do iSym=1,nSym
    ldL = max(nDim_Batch(iSym),1)
    do jBlock=1,nBlock(iSym)
      kOffZ = ip_Z(iTri(jBlock,jBlock),iSym)-1
      do J_inBlock=1,nV(jBlock,iSym)
        ! Convert integral column into Cholesky vector
        ! L(uv,J)=(uv|J)/Z(J,J)
        ! Note that the inverse was taken before the integral
        ! loop - i.e. Z(J,J) <- 1/Z(J,J)
        J = iV1(jBlock,iSym)+J_inBlock-1
        kL = kOffI+nDim_Batch(iSym)*(J-1)
        XCVInt(kL:kL+nDim_Batch(iSym)-1) = Z(kOffZ+iTri(J_inBlock,J_inBlock))*XCVInt(kL:kL+nDim_Batch(iSym)-1)
        ! Subtract from subsequent columns in current block
        ! using BLAS1
        ! (uv|K) <- (uv|K) - L(uv,J)*Z(K,J), K>J (in jBlock)
        do K_inBlock=J_inBlock+1,nV(jBlock,iSym)
          K = iV1(jBlock,iSym)+K_inBlock-1
          XCVInt(kOffI+nDim_Batch(iSym)*(K-1):kOffI+nDim_Batch(iSym)*K-1) = &
            XCVInt(kOffI+nDim_Batch(iSym)*(K-1):kOffI+nDim_Batch(iSym)*K-1)- &
            Z(kOffZ+iTri(K_inBlock,J_inBlock))*XCVInt(kL:kL+nDim_Batch(iSym)-1)
        end do
      end do
      ! Subtract from subsequent blocks using BLAS3
      ! (uv|K) <- (uv|K) - sum[J] L(uv,J)*Z(K,J),
      ! K>J (K in kBlock>jBlock containing J)
      kL = kOffI+nDim_Batch(iSym)*(iV1(jBlock,iSym)-1)
      do kBlock=jBlock+1,nBlock(iSym)
        kI = kOffI+nDim_Batch(iSym)*(iV1(kBlock,iSym)-1)
        kZ = ip_Z(iTri(kBlock,jBlock),iSym)
        ldZ = max(nV(kBlock,iSym),1)
        call dGeMM_('N','T',nDim_Batch(iSym),nV(kBlock,iSym),nV(jBlock,iSym),-One,XCVInt(kL),ldL,Z(kZ),ldZ,One,XCVInt(kI),ldL)
      end do
    end do
    nDGM_Call = nDGM_Call+nTri_Elem(nBlock(iSym)-1)
    kOffI = kOffI+nDim_Batch(iSym)*NVT(iSym)
  end do
  call CWTime(C1,W1)
  tDecom(1,3) = tDecom(1,3)+(C1-C0)
  tDecom(2,3) = tDecom(2,3)+(W1-W0)
  ! Write vectors to temp files
  call CWTime(C0,W0)
  kL = 1
  do iSym=1,nSym
    lTot = nDim_Batch(iSym)*NVT(iSym)
    if (lTot > 0) then
      call DDAFile(LuTmp(iSym),1,XCVInt(kL),lTot,iAdr(iSym))
      kL = kL+lTot
    end if
  end do
  call CWTime(C1,W1)
  tDecom(1,2) = tDecom(1,2)+(C1-C0)
  tDecom(2,2) = tDecom(2,2)+(W1-W0)
  ! Print
  if (iPrint >= Inf_Pass) then
    call CWTime(X1,Y1)
    PDone = 1.0e2_wp*real(iSP_2,kind=wp)/real(iCountSP,kind=wp)
    lTot = sum(nDim_Batch(1:nSym)*NVT(1:nSym))
    call Cho_Word2Byte(lTot,8,Byte,Unt)
    PMem = 1.0e2_wp*real(lTot,kind=wp)/real(l_Int,kind=wp)
    write(LuPri,'(I6,1X,I8,1X,I8,1X,F6.1,1X,F10.3,1X,A,A,F7.2,A,1X,F9.2,1X,F9.2)') nBatch+1,iSP_1,iSP_2,PDone,Byte,Unt,' (',PMem, &
                                                                                   '%)',(X1-X0)/Mnt,(Y1-Y0)/Mnt
    call XFlush(LuPri)
    TotMem = TotMem+real(lTot,kind=wp)
    TotCPU = TotCPU+(X1-X0)/Mnt
    TotWall = TotWall+(Y1-Y0)/Mnt
  end if
  ! Update counters and save batch dimension
  iSP_1 = iSP_1+nSP_this_batch
  nBatch = nBatch+1
  XCVnBt(nBatch) = nSP_this_batch
end do
if (iPrint >= Inf_Pass) then
  write(LuPri,'(A)') '- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - '
  call Cho_RWord2Byte(TotMem,Byte,Unt)
  write(LuPri,'(32X,F10.3,1X,A,12X,F9.2,1X,F9.2)') Byte,Unt,TotCPU,TotWall
  write(LuPri,'(A)') '----------------------------------------------------------------------------'
  call XFlush(LuPri)
end if

! If not deallocate Z matrix then reconstruct diagonal of Z matrix
! Z(J,J) <- 1/Z(J,J)
if (.not. Free_Z) then
  kZd = 0
  do iSym=1,nSym
    do jBlock=1,nBlock(iSym)
      kOffZ = ip_Z(iTri(jBlock,jBlock),iSym)-1
      do J_inBlock=1,nV(jBlock,iSym)
        J = iV1(jBlock,iSym)+J_inBlock-1
        Z(kOffZ+iTri(J_inBlock,J_inBlock)) = XCVZd(kZd+J)
      end do
    end do
    kZd = kZd+NVT(iSym)
  end do
end if

! Deallocations
call xRlsMem_Ints()
call mma_deallocate(XCVInt)
call mma_deallocate(iOff_Batch)
call mma_deallocate(XCVZd)
nullify(iQuAB)
call mma_deallocate(iQuAB_here)
call mma_deallocate(XCVLSP)

! Reset qualification array pointers and MaxQual
iQuAB => pTemp
MaxQual = MaxQual_SAVE

! Parallel runs: distribute vectors across nodes (store on files)
! Serial runs: write vectors to permanent files
call CWTime(C0,W0)
call Cho_XCV_DistributeVectors(irc,XCVnBt,nBatch,XCVTMP,iCountSP,NVT,l_NVT)
if (irc /= 0) then
  write(LuPri,'(A,A,I8)') SecNam,': Cho_XCV_DistributeVectors returned code',irc
  call Cho_Quit(SecNam//': Error in Cho_XCV_DistributeVectors',104)
end if
call CWTime(C1,W1)
tDecom(1,2) = tDecom(1,2)+(C1-C0)
tDecom(2,2) = tDecom(2,2)+(W1-W0)

! Deallocations
call mma_deallocate(XCVnBt)
call mma_deallocate(XCVTMP)

! Parallel runs: close and erase tmp vector files
call Cho_XCV_TmpFiles(irc,3)
if (irc /= 0) then
  write(LuPri,'(A,A,I8,A)') SecNam,': [3] Error in Cho_XCV_TmpFiles! (Return code:',irc,')'
  call Cho_Quit(SecNam//': Error in Cho_XCV_TmpFiles',104)
end if

end subroutine Cho_X_CompVec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine HRR(la,lb,A,B,Target,nPrim,nTrgt,ipIn)
************************************************************************
*                                                                      *
* Object: to generate the contracted integrals (one or two-electron)   *
*         from (a+b,0| or (0,a+b| type of integrals. The approach      *
*         implemented here is the same as that one described by Rys,   *
*         Dupuis and King. In this they implemented the method for the *
*         2D-integrals. The method was later implemented to be applied *
*         on the contracted integrals( Head-Gordon & Pople).           *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             February '90                                             *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden.                                         *
*             Modified to not use pointers June '91                    *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Target(nPrim,nTrgt), A(3), B(3), AB(3)
*
*     Statement function for canonical indices
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      Ind1(ixyz,ix,iz) = ixyz*(ixyz+1)*(ixyz+2)/6
     &                 + (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
*     Fast exit if HRR will not be applied.
      If (la.eq.0 .or. lb.eq.0) Then
         ipIn = 1
         Return
      End If
*
      AB(1) = A(1) - B(1)
      AB(2) = A(2) - B(2)
      AB(3) = A(3) - B(3)
      If (lb.gt.la) Then
         AB(1) = -AB(1)
         AB(2) = -AB(2)
         AB(3) = -AB(3)
      End If
      ABSqrt=Sqrt(AB(1)**2+AB(2)**2+AB(3)**2)
      If (ABSqrt.eq.Zero) Then
         Call OCHRR(Target,nPrim,nTrgt,la,lb,ipIn)
      Else
*
         ib1Max=Min(la,lb)
         iaMin =Max(la,lb)
         ipRslt = 0
         Do 10 ib1 = 1, ib1Max
            ib=ib1-1
            iaMax = la+lb-ib1
            Do 15 ia = iaMax, iaMin, -1
               ia1=ia+1
               If (Mod(ib1,2).eq.0) Then
*                 Low loading of target integrals.
                  iab1 = nElem(ib1)*(Ind1(ia,ia,0)-Ind1(iaMin,iaMin,0))
*                 High access of source integrals.
                  iab  =  nTrgt - nElem(ib)*(Ind1(iaMax+1,0,iaMax+1) -
     &                    Ind1(ia,ia,0)+1)
                  ia1b =  nTrgt - nElem(ib)*(Ind1(iaMax+1,0,iaMax+1) -
     &                    Ind1(ia1,ia1,0)+1)
               Else
*                 High loading of target integrals.
                  iab1 = nTrgt - nElem(ib1)*(Ind1(iaMax,0,iaMax) -
     &                   Ind1(ia,ia,0)+1)
*                 Low access of source integrals.
                  iab  = nElem(ib)*(Ind1(ia,ia,0)-Ind1(iaMin,iaMin,0))
                  ia1b = nElem(ib)*(Ind1(ia1,ia1,0)-Ind1(iaMin,iaMin,0))
               End If
               ipRslt = iab1
*
*              Generate this block of integrals with the HRR
*
               Call HRR1(Target(1,iab1+1),nElem(ia)*nElem(ib1),
     &                   Target(1,ia1b+1),nElem(ia1)*nElem(ib),AB,
     &                   Target(1,iab+1),nElem(ia)*nElem(ib),
     &                   ia,ib,ia1,ib1,nPrim,la,lb)
*
 15         Continue
 10      Continue
         ipIn = nPrim*ipRslt + 1
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Roland Lindh                                     *
************************************************************************
      Subroutine Init_UpdMask(nInter)
      Use NewH_mod
      use Slapaf_Parameters, only: Curvilinear, Redundant
      use Slapaf_Info, only: Coor
      Implicit None
#include "stdalloc.fh"
      Integer, Allocatable:: IsMM(:)
      Integer nsAtom, nInter
*
      Integer iAtom, i, nAtMM

      nsAtom=SIZE(Coor,2)
*
*---- If redundant Cartesians and no symmetry, use unit matrix for MM atoms
*
      If (Redundant.and.(.not.Curvilinear).and.
     &    (3*nsAtom.eq.nInter)) Then
         Call mma_allocate(UpdMask,nInter,label="UpdMask")
         Call mma_allocate(IsMM,nsAtom,Label='IsMM')
         Call MMCount(nsAtom,nAtMM,IsMM)
         Do iAtom=1,nsAtom
            If (IsMM(iAtom).eq.1) Then
               Do i=1,3
                 UpdMask((iAtom-1)*3+i)=1
               End Do
            Else
               Do i=1,3
                 UpdMask((iAtom-1)*3+i)=0
               End Do
            End If
         End Do
         Call mma_deallocate(IsMM)
      End If
*
      Return
      End Subroutine Init_UpdMask

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_GETMAXSHL(DIASH,SMAX,ISHLAB)
!
! Purpose: Get max. shell pair and update DIASH.

use Cholesky, only: nnShl
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: DIASH(*)
real(kind=wp), intent(out) :: SMAX
integer(kind=iwp), intent(out) :: ISHLAB
integer(kind=iwp) :: JSHLAB
character(len=*), parameter :: SECNAM = 'CHO_GETMAXSHL'

SMAX = -1.0e9_wp
ISHLAB = -1
do JSHLAB=1,NNSHL
  if (DIASH(JSHLAB) > SMAX) then
    SMAX = DIASH(JSHLAB)
    ISHLAB = JSHLAB
  end if
end do

if (ISHLAB < 1) then
  call CHO_QUIT('Error in '//SECNAM,104)
else
  DIASH(ISHLAB) = Zero
end if

end subroutine CHO_GETMAXSHL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DIAGRO(CI,SGM,CBUF,SBUF,DBUF,AREF,EREF,
     *              CSECT,RSECT,XI1,XI2,CNEW,SCR,ICI)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "warnings.fh"
#include "mrci.fh"
#include "WrkSpc.fh"
      DIMENSION CI(NCONF),SGM(NCONF)
      DIMENSION CBUF(MBUF,MXVEC),SBUF(MBUF,MXVEC),DBUF(MBUF)
      DIMENSION AREF(NREF,NREF),EREF(NREF)
      DIMENSION CSECT(NSECT,MXVEC),RSECT(NSECT,MXVEC)
      DIMENSION XI1(NSECT,NRROOT),XI2(NSECT,NRROOT)
      DIMENSION CNEW(NSECT,NRROOT),SCR(*)
      DIMENSION ICI(MBUF)
      DIMENSION IDC(MXVEC),IDS(MXVEC)
      DIMENSION HCOPY(MXVEC,MXVEC),SCOPY(MXVEC,MXVEC)
      DIMENSION PCOPY(MXVEC,MXVEC)
      DIMENSION EPERT(MXROOT),ELAST(MXROOT),PSEL(MXVEC),RNRM(MXROOT)
*
      WRITE(6,*)
      WRITE(6,*)('-',I=1,60)
      IF (ICPF.EQ.0) THEN
         WRITE(6,*)'   MR SDCI CALCULATION.'
      ELSE
         WRITE(6,*)'   MR ACPF CALCULATION.'
      END IF
      WRITE(6,*)('-',I=1,60)
      WRITE(6,*)
      WRITE(6,*)'         CONVERGENCE STATISTICS:'
      WRITE(6,'(1X,A)')'ITER NVEC     ENERGIES    LOWERING'//
     & ' RESIDUAL SEL.WGT CPU(S) CPU TOT'
      ITER=0
      CALL SETTIM
      CALL TIMING(CPTNOW,DUM,DUM,DUM)
      CPTOLD=CPTNOW
      CPTSTA=CPTNOW
C LOOP HEAD FOR CI ITERATIONS:
1000  CONTINUE
      ITER=ITER+1
* -------------------------------------------------------------------
C CALCULATE SIGMA ARRAYS FOR SHIFTED HAMILTONIAN IN MCSF BASIS:
      DO 100 I=1,NNEW
         IVEC=1+MOD(NVTOT-NNEW+I-1,MXVEC)
         IDISK=IDISKC(IVEC)
         DO 110 ISTA=1,NCONF,MBUF
            NN=MIN(MBUF,NCONF+1-ISTA)
            CALL iDAFILE(LUEIG,2,ICI,NN,IDISK)
            CALL UPKVEC(NN,ICI,CI(ISTA))
110      CONTINUE
         CALL GETMEM('BMN','ALLO','REAL',LBMN,NBMN)
         CALL GETMEM('IBMN','ALLO','INTE',LIBMN,NBMN)
         CALL GETMEM('BIAC2','ALLO','REAL',LBIAC2,ISMAX)
         CALL GETMEM('BICA2','ALLO','REAL',LBICA2,ISMAX)
         CALL GETMEM('BFIN3','ALLO','REAL',LBFIN3,KBUFF1)
         CALL GETMEM('AC1','ALLO','REAL',LAC1,ISMAX)
         CALL GETMEM('AC2','ALLO','REAL',LAC2,ISMAX)
         CALL GETMEM('BFIN4','ALLO','REAL',LBFIN4,KBUFF1)
         CALL GETMEM('ABIJ','ALLO','REAL',LABIJ,NVSQ)
         CALL GETMEM('AIBJ','ALLO','REAL',LAIBJ,NVSQ)
         CALL GETMEM('AJBI','ALLO','REAL',LAJBI,NVSQ)
         CALL GETMEM('ASCR1','ALLO','REAL',LASCR1,NVMAX**2)
         CALL GETMEM('BSCR1','ALLO','REAL',LBSCR1,NVMAX**2)
         CALL GETMEM('FSCR1','ALLO','REAL',LFSCR1,NVSQ)
         CALL GETMEM('FSEC','ALLO','REAL',LFSEC,2*NVSQ)
         CALL GETMEM('BFIN5','ALLO','REAL',LBFIN5,KBUFF1)
         CALL GETMEM('ASCR2','ALLO','REAL',LASCR2,NVMAX**2)
         CALL GETMEM('BSCR2','ALLO','REAL',LBSCR2,NVMAX**2)
         CALL GETMEM('FSCR2','ALLO','REAL',LFSCR2,NVSQ)
         CALL GETMEM('DBK','ALLO','REAL',LDBK,2*NVSQ)
cvv         CALL SIGMA(HWORK,CI,SGM)
cpam         CALL SIGMA(HWORK)
*PAM04         CALL SIGMA(HWork(LSGM),HWork(LAREF),HWork(LCI),HWork(LINTSY),
*PAM04     &        HWork(LINDX),HWork(LBMN),HWork(LIBMN),HWork(LBIAC2),
         CALL SIGMA(SGM,AREF,CI,IWork(LINTSY),
     &        IWork(LINDX),Work(LBMN),IWork(LIBMN),Work(LBIAC2),
*PAM04     &        HWork(LBICA2),HWork(LBFIN3),HWork(LFIJKL),HWork(LISAB),
     &        Work(LBICA2),Work(LBFIN3),IWork(LISAB),
*PAM04     &        HWork(LAC1),HWork(LAC2),HWork(LBFIN4),HWork(LABIJ),
     &        Work(LAC1),Work(LAC2),Work(LBFIN4),Work(LABIJ),
*PAM04     &        HWork(LAIBJ),HWork(LAJBI),HWork(LBFIN1),HWork(LASCR1),
     &        Work(LAIBJ),Work(LAJBI),Work(LASCR1),
*PAM04     &        HWork(LBSCR1),HWork(LFSCR1),HWork(LFSEC),HWork(LFOCK),
     &        Work(LBSCR1),Work(LFSCR1),Work(LFSEC),Work(LFOCK),
     &        Work(LBFIN5),Work(LASCR2),Work(LBSCR2),
*PAM04     &        HWork(LFSCR2),HWork(LDBK),HWork(LCSPCK))
     &        Work(LFSCR2),Work(LDBK),IWork(LCSPCK))
         CALL GETMEM('BFIN5','FREE','REAL',LBFIN5,KBUFF1)
         CALL GETMEM('ASCR2','FREE','REAL',LASCR2,NVMAX**2)
         CALL GETMEM('BSCR2','FREE','REAL',LBSCR2,NVMAX**2)
         CALL GETMEM('FSCR2','FREE','REAL',LFSCR2,NVSQ)
         CALL GETMEM('DBK','FREE','REAL',LDBK,2*NVSQ)
         CALL GETMEM('ABIJ','FREE','REAL',LABIJ,NVSQ)
         CALL GETMEM('AIBJ','FREE','REAL',LAIBJ,NVSQ)
         CALL GETMEM('AJBI','FREE','REAL',LAJBI,NVSQ)
         CALL GETMEM('ASCR1','FREE','REAL',LASCR1,NVMAX**2)
         CALL GETMEM('BSCR1','FREE','REAL',LBSCR1,NVMAX**2)
         CALL GETMEM('FSCR1','FREE','REAL',LFSCR1,NVSQ)
         CALL GETMEM('FSEC','FREE','REAL',LFSEC,2*NVSQ)
         CALL GETMEM('BMN','FREE','REAL',LBMN,NBMN)
         CALL GETMEM('IBMN','FREE','INTE',LIBMN,NBMN)
         CALL GETMEM('BIAC2','FREE','REAL',LBIAC2,ISMAX)
         CALL GETMEM('BICA2','FREE','REAL',LBICA2,ISMAX)
         CALL GETMEM('BFIN3','FREE','REAL',LBFIN3,KBUFF1)
         CALL GETMEM('AC1','FREE','REAL',LAC1,ISMAX)
         CALL GETMEM('AC2','FREE','REAL',LAC2,ISMAX)
         CALL GETMEM('BFIN4','FREE','REAL',LBFIN4,KBUFF1)
         NSTOT=NSTOT+1
C WRITE IT OUT:
         IVEC=1+MOD(NSTOT-1,MXVEC)
         IDISK=IDISKS(IVEC)
         IF(IDISK.EQ.-1) IDISK=IDFREE
         DO 120 ISTA=1,NCONF,MBUF
            NN=MIN(MBUF,NCONF+1-ISTA)
            CALL dDAFILE(LUEIG,1,SGM(ISTA),NN,IDISK)
120      CONTINUE
         IF (IDISK.GT.IDFREE) THEN
            IDISKS(IVEC)=IDFREE
            IDFREE=IDISK
         END IF
100   CONTINUE
* -------------------------------------------------------------------
C NR OF VECTORS PRESENTLY RETAINED:
      NVEC=MIN(MXVEC,NVTOT)
C NR OF OLD VECTORS RETAINED:
      NOLD=NVEC-NNEW
* -------------------------------------------------------------------
C COPY HSMALL, SSMALL AND PSMALL IN REORDERED FORM, BY AGE:
      DO 206 L=NNEW+1,NVEC
         LL=1+MOD(NVTOT-L,MXVEC)
         DO 2060 K=NNEW+1,NVEC
            KK=1+MOD(NVTOT-K,MXVEC)
            HCOPY(K,L)=HSMALL(KK,LL)
            SCOPY(K,L)=SSMALL(KK,LL)
            PCOPY(K,L)=PSMALL(KK,LL)
2060     CONTINUE
206   CONTINUE
C CLEAR NEW AREAS TO BE USED:
      DO 207 K=1,NVEC
         DO 2070 L=1,NNEW
            HCOPY(K,L)=0.0D00
            SCOPY(K,L)=0.0D00
            PCOPY(K,L)=0.0D00
2070     CONTINUE
207   CONTINUE
C THEN LOOP OVER BUFFERS. FIRST GET COPIES OF DISK ADDRESSES:
      DO 210 K=1,NVEC
         IDC(K)= IDISKC(K)
         IDS(K)= IDISKS(K)
210   CONTINUE
      DO 200 ISTA=1,NCONF,MBUF
         IEND=MIN(NCONF,ISTA+MBUF-1)
         IBUF=1+IEND-ISTA
         DO 220 K=1,NVEC
            KK=1+MOD(NVTOT-K,MXVEC)
            CALL iDAFILE(LUEIG,2,ICI,IBUF,IDC(KK))
            CALL UPKVEC(IBUF,ICI,CBUF(1,K))
            IF(K.GT.NNEW) GOTO 220
            CALL dDAFILE(LUEIG,2,SBUF(1,K),IBUF,IDS(KK))
220      CONTINUE
* -------------------------------------------------------------------
C NOTE: AT THIS POINT, THE COLUMNS NR 1..NVEC OF CBUF WILL
C CONTAIN THE BUFFERS OF, FIRST, THE NNEW NEWEST PSI ARRAYS,
C THEN, THE NOLD ONES FROM EARLIER ITERATIONS.
C THE COLUMNS 1..NNEW OF SBUF WILL CONTAIN THE NEWEST NNEW
C SIGMA ARRAYS. LEADING DIMENSION OF CBUF AND SBUF IS MBUF. ACTUAL
C BUFFER SIZE IS IBUF, WHICH CAN BE SMALLER. ACCUMULATE:
         CALL DGEMM_('T','N',
     &               NVEC,NNEW,IBUF,
     &               1.0d0,CBUF,MBUF,
     &               CBUF,MBUF,
     &               0.0d0,SCR,NVEC)
         KL=0
         DO 230 L=1,NNEW
            DO 231 K=1,NVEC
               KL=KL+1
               SCOPY(K,L)=SCOPY(K,L)+SCR(KL)
231         CONTINUE
230      CONTINUE
         CALL DGEMM_('T','N',
     &               NVEC,NNEW,IBUF,
     &               1.0d0,CBUF,MBUF,
     &               SBUF,MBUF,
     &               0.0d0,SCR,NVEC)
         KL=0
         DO 240 L=1,NNEW
            DO 241 K=1,NVEC
               KL=KL+1
               HCOPY(K,L)=HCOPY(K,L)+SCR(KL)
241         CONTINUE
240      CONTINUE
C ALSO, UPDATE PSMALL, WHICH IS USED FOR SELECTION.
         IF(ISTA.GT.IREFX(NRROOT)) GOTO 200
         DO 250 I=1,NRROOT
            IR=IROOT(I)
            IRR=IREFX(IR)
            IF(IRR.LT.ISTA) GOTO 250
            IF(IRR.GT.IEND) GOTO 250
            IPOS=IRR+1-ISTA
            DO 260 L=1,NNEW
               DO 261 K=1,NVEC
                  PCOPY(K,L)=PCOPY(K,L)+CBUF(IPOS,K)*CBUF(IPOS,L)
261            CONTINUE
260         CONTINUE
250      CONTINUE
200   CONTINUE
C TRANSFER ELEMENTS BACK TO HSMALL, ETC.
       DO 256 L=1,NNEW
          LL=1+MOD(NVTOT-L,MXVEC)
          DO 2560 K=1,NVEC
             KK=1+MOD(NVTOT-K,MXVEC)
             H=HCOPY(K,L)
             S=SCOPY(K,L)
             P=PCOPY(K,L)
             HCOPY(L,K)=H
             SCOPY(L,K)=S
             PCOPY(L,K)=P
             HSMALL(KK,LL)=H
             SSMALL(KK,LL)=S
             PSMALL(KK,LL)=P
             HSMALL(LL,KK)=H
             SSMALL(LL,KK)=S
             PSMALL(LL,KK)=P
2560     CONTINUE
256   CONTINUE
      IF(IPRINT.GE.10) THEN
        WRITE(6,*)
        WRITE(6,*)' HSMALL MATRIX:'
        DO 251 I=1,NVEC
          WRITE(6,'(1X,5F15.6)')(HSMALL(I,J),J=1,NVEC)
251     CONTINUE
        WRITE(6,*)
        WRITE(6,*)' SSMALL MATRIX:'
        DO 252 I=1,NVEC
          WRITE(6,'(1X,5F15.6)')(SSMALL(I,J),J=1,NVEC)
252     CONTINUE
        WRITE(6,*)
         WRITE(6,*)' PSMALL MATRIX:'
         DO 253 I=1,NVEC
           WRITE(6,'(1X,5F15.6)')(PSMALL(I,J),J=1,NVEC)
253      CONTINUE
C        WRITE(6,*)
C        WRITE(6,*)
C        WRITE(6,*)' HCOPY MATRIX:'
C        DO 1251 I=1,NVEC
C          WRITE(6,'(1X,5F15.6)')(HCOPY(I,J),J=1,NVEC)
C1251    CONTINUE
C        WRITE(6,*)
C        WRITE(6,*)' SCOPY MATRIX:'
C        DO 1252 I=1,NVEC
C          WRITE(6,'(1X,5F15.6)')(SCOPY(I,J),J=1,NVEC)
C1252    CONTINUE
C        WRITE(6,*)
      END IF
* -------------------------------------------------------------------
C THE UPPER-LEFT NVEC*NVEC SUBMATRICES OF HSMALL AND SSMALL NOW
C CONTAINS THE CURRENT HAMILTONIAN AND OVERLAP MATRICES, IN THE
C BASIS OF PRESENTLY RETAINED PSI VECTORS. DIAGONALIZE, BUT USE
C THE REORDERED MATRICES IN SCOPY, HCOPY,DCOPY. THERE THE BASIS
C FUNCTIONS ARE ORDERED BY AGE.
      THR=1.0D-06
      CALL SECULAR(MXVEC,NVEC,NRON,HCOPY,SCOPY,
     &                VSMALL,ESMALL,SCR,THR)
C REORDER THE ELEMENTS OF VSMALL TO GET EIGENVECTORS OF HSMALL. NOTE:
C THIS IS NOT THE SAME AS IF WE DIAGONALIZED HSMALL DIRECTLY.
C THE DIFFERENCE OCCURS WHENEVER VECTORS ARE THROWN OUT OF THE
C CALCULATION IN SECULAR BECAUSE OF LINEAR DEPENDENCE. THE RESULT
C WILL DEPEND SLIGHTLY BUT CRITICALLY ON THE ORDER BY WHICH THE
C VECTORS WERE ORTHONORMALIZED.
      DO 259 I=1,NRON
        DO 257 K=1,NVEC
          KK=1+MOD(NVTOT-K,MXVEC)
          SCR(KK)=VSMALL(K,I)
257     CONTINUE
        DO 258 K=1,NVEC
          VSMALL(K,I)=SCR(K)
258     CONTINUE
259   CONTINUE
      IF(NRON.LT.NRROOT) THEN
        WRITE(6,*)'DIAGRO Error: Linear dependence has reduced'
        WRITE(6,*)' the number of solutions to NRON, but you'
        WRITE(6,*)' wanted NRROOT soultions.'
        WRITE(6,'(1X,A,I3)')'  NRON=',NRON
        WRITE(6,'(1X,A,I3)')'NRROOT=',NRROOT
        CALL QUIT(_RC_INTERNAL_ERROR_)
      END IF
C ORDER THE EIGENFUNCTIONS BY DECREASING OVERLAP WITH THE SPACE
C SPANNED BY THE ORIGINALLY SELECTED REFCI ROOTS.
      CALL DGEMM_('N','N',
     &            NVEC,NRON,NVEC,
     &            1.0d0,PSMALL,MXVEC,
     &            VSMALL,MXVEC,
     &            0.0d0,SCR,NVEC)
      II=1
      DO 350 I=1,NRON
        PSEL(I)=DDOT_(NVEC,VSMALL(1,I),1,SCR(II),1)
        II=II+NVEC
350   CONTINUE
C PSEL(I) NOW CONTAINS EXPECTATION VALUE OF PMAT FOR I-TH EIGENVECTOR.
C     WRITE(6,*)' ARRAY OF SELECTION AMPLITUDES IN SCR:'
C     WRITE(6,'(1X,5F15.6)')(PSEL(I),I=1,NRON)
      DO 380 I=1,NRON-1
        IMAX=I
        PMAX=PSEL(I)
        DO 360 J=I+1,NRON
          IF(PSEL(J).LT.PMAX) GOTO 360
          PMAX=PSEL(J)
          IMAX=J
360     CONTINUE
        IF(IMAX.EQ.I) GOTO 380
        PSEL(IMAX)=PSEL(I)
        PSEL(I)=PMAX
        TMP=ESMALL(IMAX)
        ESMALL(IMAX)=ESMALL(I)
        ESMALL(I)=TMP
        DO 370 K=1,NVEC
          TMP=VSMALL(K,IMAX)
          VSMALL(K,IMAX)=VSMALL(K,I)
          VSMALL(K,I)=TMP
370     CONTINUE
380   CONTINUE
C FINALLY, REORDER THE SELECTED ROOTS BY ENERGY:
      DO 1380 I=1,NRROOT-1
        IMIN=I
        EMIN=ESMALL(I)
        DO 1360 J=I+1,NRROOT
          IF(ESMALL(J).GE.EMIN) GOTO 1360
          EMIN=ESMALL(J)
          IMIN=J
1360    CONTINUE
        IF(IMIN.EQ.I) GOTO 1380
        ESMALL(IMIN)=ESMALL(I)
        ESMALL(I)=EMIN
        TMP=PSEL(IMIN)
        PSEL(IMIN)=PSEL(I)
        PSEL(I)=TMP
        DO 1370 K=1,NVEC
          TMP=VSMALL(K,IMIN)
          VSMALL(K,IMIN)=VSMALL(K,I)
          VSMALL(K,I)=TMP
1370    CONTINUE
1380  CONTINUE
C     WRITE(6,*)' EIGENVALUES OF HSMALL. NRON=',NRON
C     WRITE(6,'(1X,5F15.6)')(ESMALL(I),I=1,NRON)
C     WRITE(6,*)' SELECTION WEIGHTS:'
C     WRITE(6,'(1X,5F15.6)')(   PSEL(I),I=1,NRON)
C     WRITE(6,*)' SELECTED EIGENVECTORS:'
C     DO 381 I=1,NRROOT
C       WRITE(6,'(1X,5F15.6)')(VSMALL(K,I),K=1,NVEC)
C381  CONTINUE
C     WRITE(6,*)
* -------------------------------------------------------------------
C CALCULATE RESIDUAL ARRAYS FOR THE NRROOTS EIGENFUNCTIONS OF HSMALL.
C ALSO, USE THE OPPORTUNITY TO FORM MANY OTHER SMALL ARRAYS.
      CALL GETMEM('ARR','ALLO','REAL',LARR,11*NRROOT**2)
      CALL HZLP1(CBUF,SBUF,DBUF,WORK(LARR),CSECT,RSECT,XI1,XI2,ICI)
C USE THESE SMALLER ARRAYS TO FORM HZERO AND SZERO. THIS IS
C OVERLAP AND HAMILTONIAN IN THE BASIS (PSI,RHO,XI1,XI2), WHERE
C PSI ARE THE EIGENFUNCTIONS OF HSMALL, RHO ARE RESIDUALS, ETC.
      CALL HZ(WORK(LARR))
      CALL GETMEM('ARR','FREE','REAL',LARR,11*NRROOT**2)
      NZ=4*NRROOT
C      WRITE(6,*)
C      WRITE(6,*)' AFTER HZ CALL. HZERO HAMILTONIAN:'
C      DO 391 I=1,NZ
C        WRITE(6,'(1X,5F15.6)')(HZERO(I,J),J=1,NZ)
C 391  CONTINUE
C      WRITE(6,*)' SZERO:'
C      DO 392 I=1,NZ
C        WRITE(6,'(1X,5F15.6)')(SZERO(I,J),J=1,NZ)
C 392  CONTINUE
      DO 393 I=1,NRROOT
        RNRM(I)=SQRT(SZERO(NRROOT+I,NRROOT+I))
        EPERT(I)=ESMALL(I)-SZERO(3*NRROOT+I,NRROOT+I)
393   CONTINUE
C      WRITE(6,*)
C      WRITE(6,*)' PERTURBATION ESTIMATES TO ENERGY:'
C      WRITE(6,'(1X,5F15.6)')(ESHIFT+EPERT(I),I=1,NRROOT)
* ------------------------------------------------------------------
      NCONV=0
      CALL TIMING(CPTNOW,DUM,DUM,DUM)
      CPTIT=CPTNOW-CPTOLD
      CPTOLD=CPTNOW
      CPTOT=CPTNOW-CPTSTA
      IF(ITER.EQ.1) THEN
        EDISP=ESMALL(1)+ESHIFT
        WRITE(6,1234) ITER,NVEC,EDISP,RNRM(1),PSEL(1),CPTIT,CPTOT
      ELSE
          ELOW=ESMALL(1)-ELAST(1)
          IF((ELOW.LT.0.0D00).AND.(ABS(ELOW).LE.ETHRE)) NCONV=1
          EDISP=ESMALL(1)+ESHIFT
        WRITE(6,1235) ITER,NVEC,EDISP,ELOW,RNRM(1),PSEL(1),CPTIT,CPTOT
      END IF
      IF(NRROOT.GT.1) THEN
        DO 1240 I=2,NRROOT
          EDISP=ESMALL(I)+ESHIFT
          EDIFF=ESMALL(I)-ESMALL(1)
          IF(ITER.EQ.1) THEN
            WRITE(6,1236) EDISP,RNRM(I),PSEL(I)
          ELSE
            ELOW=ESMALL(I)-ELAST(I)
            IF((ELOW.LT.0.0D00).AND.(ABS(ELOW).LE.ETHRE)) NCONV=NCONV+1
            WRITE(6,1237) EDISP,ELOW,RNRM(I),PSEL(I)
          END IF
1240    CONTINUE
        WRITE(6,*)
      END IF
      DO 1241 I=1,NRROOT
        ELAST(I)=ESMALL(I)
1241  CONTINUE
1234  FORMAT(1X,I4,1X,I4,1X,F15.8,9X  ,D9.2,1X,F6.3,2(1X,F7.1))
1235  FORMAT(1X,I4,1X,I4,1X,F15.8,D9.2,D9.2,1X,F6.3,2(1X,F7.1))
1236  FORMAT(11X,           F15.8,9X  ,D9.2,1X,F6.3)
1237  FORMAT(11X,           F15.8,D9.2,D9.2,1X,F6.3)
      IF(NCONV.EQ.NRROOT) THEN
        WRITE(6,*)' CONVERGENCE IN ENERGY.'
        GOTO 2000
      END IF
* ------------------------------------------------------------------
      THR=1.0D-06
      CALL SECULAR(MXZ,NZ,NRON,HZERO,SZERO,VZERO,EZERO,SCR,THR)
C     WRITE(6,*)' AFTER SECULAR CALL. NRON=',NRON
C     WRITE(6,*)' EIGENVALUES & -VECTORS:'
C     DO 395 I=1,NRON
C       WRITE(6,'(1X,5F15.6)') EZERO(I)
C       WRITE(6,'(1X,5F15.6)')(VZERO(K,I),K=1,NZ)
C395  CONTINUE
C ORDER THE EIGENFUNCTIONS BY DECREASING SIZE OF PSI PART.
        CALL DGEMM_('T','N',
     &              NRON,NRROOT,NZ,
     &              1.0d0,VZERO,MXZ,
     &              SZERO,MXZ,
     &              0.0d0,SCR(1+NRON),NRON)
      DO 450 I=1,NRON
        II=I
        SUM=0.0D00
        DO 440 K=1,NRROOT
          II=II+NRON
          SUM=SUM+SCR(II)**2
440     CONTINUE
        SCR(I)=SUM
450   CONTINUE
C     WRITE(6,*)
C     WRITE(6,*)' SELECTION CRITERION VECTOR, BEFORE ORDERING:'
C     WRITE(6,'(1X,5F15.6)')(SCR(I),I=1,NRON)
      DO 480 I=1,NRON-1
        IMAX=I
        PMAX=SCR(I)
        DO 460 J=I+1,NRON
          IF(SCR(J).LT.PMAX) GOTO 460
          PMAX=SCR(J)
          IMAX=J
460     CONTINUE
        IF(IMAX.EQ.I) GOTO 480
        SCR(IMAX)=SCR(I)
        SCR(I)=PMAX
        TMP=EZERO(IMAX)
        EZERO(IMAX)=EZERO(I)
        EZERO(I)=TMP
        DO 470 K=1,NZ
          TMP=VZERO(K,IMAX)
          VZERO(K,IMAX)=VZERO(K,I)
          VZERO(K,I)=TMP
470     CONTINUE
480   CONTINUE
CPAM 94-10-30, must reorder as before (DO 1380 etc):
C REORDER THE SELECTED ROOTS BY ENERGY:
      DO 1480 I=1,NRROOT-1
        IMIN=I
        EMIN=EZERO(I)
        DO 1460 J=I+1,NRROOT
          IF(EZERO(J).GE.EMIN) GOTO 1460
          EMIN=EZERO(J)
          IMIN=J
1460    CONTINUE
        IF(IMIN.EQ.I) GOTO 1480
        EZERO(IMIN)=EZERO(I)
        EZERO(I)=EMIN
        TMP=SCR(IMIN)
        SCR(IMIN)=SCR(I)
        SCR(I)=TMP
        DO 1470 K=1,NZ
          TMP=VZERO(K,IMIN)
          VZERO(K,IMIN)=VZERO(K,I)
          VZERO(K,I)=TMP
1470    CONTINUE
1480  CONTINUE
CPAM 94-10-30, end of update.
C NOTE: IF THE UPDATE PART IS SMALL ENOUGH FOR ALL THE FIRST NRROOT
C ARRAY, THE CALCULATION HAS CONVERGED.
      NNEW=0
C     WRITE(6,*)' CONVERGENCE CRITERION: SIZE OF UPDATE PART.'
      DO 490 I=1,NRROOT
        SQNRM=1.0D00-SCR(I)
C       WRITE(6,*)' ROOT NR, SQNRM:',I,SQNRM
        IF(SQNRM.LT.SQNLIM) GOTO 490
        NNEW=NNEW+1
490   CONTINUE
C      WRITE(6,*)
C      WRITE(6,*)' EIGENVALUES OF THE HZERO HAMILTONIAN:'
C      WRITE(6,'(1X,5F15.6)')(EZERO(I),I=1,NRON)
C      WRITE(6,*)' SELECTION WEIGHTS:'
C      WRITE(6,'(1X,5F15.6)')(  SCR(I),I=1,NRON)
C      WRITE(6,*)' EIGENVECTORS:'
C      DO 394 I=1,NRON
C        WRITE(6,'(1X,5F15.6)')(VZERO(K,I),K=1,NZ)
C 394  CONTINUE
C      WRITE(6,*)' NR OF NEW VECTORS SELECTED, NNEW:',NNEW
      IF(NNEW.EQ.0) THEN
        WRITE(6,*)' CONVERGENCE IN NORM.'
        GOTO 2000
      END IF
C NOTE: A CHANGE HERE. ALWAYS USE ALL THE NRROOT UPDATED VECTORS TO
C AVOID OVERWRITING AN EARLY CONVERGED VECTOR (WHICH HAS NEVER BEEN
C OUTDATED BY A LATER) BY A VECTOR BELONGING TO ANOTHER ROOT.
      NNEW=NRROOT
* -------------------------------------------------------------------
C FORM NEW UPDATED VECTORS: SKIP THE FIRST NRROOT-NNEW VECTORS,
C WHICH MAKE NO ESSENTIAL IMPROVEMENT.
C     WRITE(6,*)' RESET VZERO TO (0,0,0,1) FOR CONVENTIONAL DAVIDSON.'
C     CALL DCOPY_(NRROOT*MXZ,[0.0D00],0,VZERO,1)
C     CALL DCOPY_(NRROOT,[1.0D00],0,VZERO(3*NRROOT+1,1),MXZ+1)
      CALL HZLP2(CBUF,SBUF,DBUF,CSECT,RSECT,XI1,XI2,CNEW,ICI)
      IF(ITER.LT.MAXIT) GOTO 1000
      WRITE(6,*)' UNCONVERGED.'
2000  CONTINUE
      WRITE(6,*)' ',('*',III=1,70)
C WRITE CI VECTORS TO LUREST -- CI RESTART FILE.
      IDREST=0
      DO 2220 I=1,NRROOT
        IVEC=1+MOD(NVTOT-NRROOT+I-1,MXVEC)
        IDISK=IDISKC(IVEC)
        DO 2210 ISTA=1,NCONF,MBUF
          NN=MIN(MBUF,NCONF+1-ISTA)
          CALL iDAFILE(LUEIG,2,ICI,NN,IDISK)
          CALL UPKVEC(NN,ICI,CI(ISTA))
2210    CONTINUE
        CALL CSFTRA(' CSF',CI,AREF)
        C2REF=0.0D00
        DO 2215 IR=1,NREF
          ICSF=IREFX(IR)
          C=CI(ICSF)
          C2REF=C2REF+C**2
2215    CONTINUE
        IR=IROOT(I)
        ECI=ESMALL(I)+ESHIFT
        ENREF=ECI-EREF(IR)
        C2NREF=1.0D00-C2REF
C WRITE ENERGIES TO PRINTED OUTPUT, AND SAVE TOTAL ENERGIES TO ENGY
C FOR LATER PRINTOUT WITH PROPERTIES:
        WRITE(6,'(A,I3)')'               FINAL RESULTS FOR STATE NR ',I
        WRITE(6,'(A,I3)')' CORRESPONDING ROOT OF REFERENCE CI IS NR:',IR
        WRITE(6,'(A,F15.8)')'            REFERENCE CI ENERGY:',EREF(IR)
        WRITE(6,'(A,F15.8)')'         EXTRA-REFERENCE WEIGHT:',C2NREF
        IF(ICPF.EQ.1) THEN
          WRITE(6,'(A,F15.8)')'        ACPF CORRELATION ENERGY:',ENREF
          WRITE(6,'(A,F15.8)')'                    ACPF ENERGY:',ECI
          ENGY(I,1)=ECI
          ENGY(I,2)=0.0D00
          ENGY(I,3)=0.0D00
          Call Add_Info('E_MRACPF',[ECI],1,8)
        ELSE
          WRITE(6,'(A,F15.8)')'          CI CORRELATION ENERGY:',ENREF
          WRITE(6,'(A,F15.8)')'                      CI ENERGY:',ECI
C APPROXIMATE CORRECTIONS FOR UNLINKED QUADRUPLES:
          QDAV=ENREF*C2NREF/C2REF
          EDAV=ECI+QDAV
          QACPF=ENREF*(C2NREF*(1.0D00-GFAC))/(C2REF+GFAC*C2NREF)
          EACPF=ECI+QACPF
          WRITE(6,'(A,F15.8)')'            DAVIDSON CORRECTION:',QDAV
          WRITE(6,'(A,F15.8)')'               CORRECTED ENERGY:',EDAV
          WRITE(6,'(A,F15.8)')'                ACPF CORRECTION:',QACPF
          WRITE(6,'(A,F15.8)')'               CORRECTED ENERGY:',EACPF
          ENGY(I,1)=ECI
          ENGY(I,2)=QDAV
          ENGY(I,3)=QACPF
          Call Add_Info('E_MRSDCI',[ECI],1,8)
        END IF
        WRITE(6,*)
*PAM04        CALL PRWF_MRCI (HWORK(LCSPCK),HWORK(LINTSY),HWORK(LINDX),
*PAM04     &             CI,HWORK(LJREFX) )
        CALL PRWF_MRCI (IWORK(LCSPCK),IWORK(LINTSY),IWORK(LINDX),
     &             CI,IWORK(LJREFX) )
        WRITE(6,*)' ',('*',III=1,70)
        CALL dDAFILE(LUREST,1,CI,NCONF,IDREST)
2220  CONTINUE
      Call XFlush(6)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LU2DESC(Lu,Desc)

use Fast_IO, only: CtlBlk, MxFile, pDesc, pHndle
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: Lu
integer(kind=iwp), intent(inout) :: Desc
integer(kind=iwp) :: handle, n, nFile
integer(kind=iwp), external :: lu2handle

handle = lu2handle(Lu)

n = 1
do
  if (CtlBlk(pHndle,n) == handle) exit
  n = n+1
  if (n > MxFile) then
    return
  end if
end do
nFile = n
Desc = CtlBlk(pDesc,nFile)

return

end subroutine LU2DESC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine ClrBuf(idcrr,idcrs,idcrt,ngr,Shijij,iAnga,iCmp,iCmpa,iShll,iShell,jShell,iBasi,jBasj,kBask,lBasl,Dij1,Dij2,mDij,nDij, &
                  Dkl1,Dkl2,mDkl,nDkl,Dik1,Dik2,mDik,nDik,Dil1,Dil2,mDil,nDil,Djk1,Djk2,mDjk,nDjk,Djl1,Djl2,mDjl,nDjl,rFinal, &
                  nFinal,FckTmp,nFT,Scrtch1,nS1,Scrtch2,nS2,Temp,nTemp,TwoHam,nTwo,IndGrd,Indx,iAO,iAOst,iuvwx,n8,ltri,moip,nAcO, &
                  rmoin,nmoin,ntemptot,Buffer,nop,din,dan,new_fock)
!***********************************************************************
!                                                                      *
!       Called from: Twoel                                             *
!       takes care of the integrals                                    *
!       integrals -> fckmatrix,MO                                      *
!       in the near feature a disk based version                       *
!                                                                      *
!       Calling:   CntrDens : Gets the indexes for d1                  *
!                  MkFck : Add up the integrals on the Fock Matrix     *
!                                                                      *
!       Author: Anders Bernhardsson, Theoretical Chemistry,            *
!               University of Lund, Sweden, June '95                   *
!***********************************************************************

use McKinley_global, only: CPUStat, ipDisp, ipDisp2, nFckAcc, nMethod, nMOTrans, RASSCF
use pso_stuff, only: ndens
use Symmetry_Info, only: nIrrep
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idcrr, idcrs, idcrt, ngr, iAnga(4), iCmp(4), icmpa(4), iShll(4), iShell(4), jShell(4), iBasi, &
                                 jBasj, kBask, lBasl, mDij, nDij, mDkl, nDkl, mDik, nDik, mDil, nDil, mDjk, nDjk, mDjl, nDjl, &
                                 nFinal, nFT, nS1, nS2, nTemp, nTwo, IndGrd(3,4,0:7), Indx(3,4), iAO(4), iAOst(4), iuvwx(4), &
                                 moip(0:7), nAcO, nmoin, ntemptot, nop(4)
logical(kind=iwp), intent(in) :: Shijij, n8, ltri, new_fock
real(kind=wp), intent(in) :: Dij1(mDij,nDij), Dij2(mDij,nDij), Dkl1(mDkl,nDkl), Dkl2(mDkl,nDkl), Dik1(mDik,nDik), Dik2(mDik,nDik), &
                             Dil1(mDil,nDil), Dil2(mDil,nDil), Djk1(mDjk,nDjk), Djk2(mDjk,nDjk), Djl1(mDjl,nDjl), Djl2(mDjl,nDjl), &
                             rFinal(nFinal), din(*), dan(*)
real(kind=wp), intent(out) :: FckTmp(nFT), Scrtch1(nS1), Scrtch2(nS2), Temp(nTemp)
real(kind=wp), intent(inout) :: TwoHam(nTwo), rmoin(nMOIN), buffer(*)
integer(kind=iwp) :: iCar, iCent, iCnt, iGr, ii, iIrrep, ij1, ij2, ij3, ij4, ik1, ik2, ik3, ik4, il1, il2, il3, il4, ip, ipFin, &
                     jk1, jk2, jk3, jk4, jl1, jl2, jl3, jl4, jOp(6), kl1, kl2, kl3, kl4, nabcd, nao, nijkl
logical(kind=iwp) :: pert(0:7)
real(kind=wp) :: dum1, dum2, dum3, ExFac, Time

nijkl = iBasi*jBasj*kBask*lBasl
nabcd = iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)
call Timing(dum1,Time,dum2,dum3)

ExFac = One

if (ltri) then
  if (.not. new_fock) then
    !------------------------------------------------------------*
    !
    !   Get the size of the work area that should be contracted
    !
    !------------------------------------------------------------*
    if (jShell(1) >= jShell(2)) then
      ij1 = iBasi
      ij2 = jBasj
      ij3 = iCmp(1)
      ij4 = iCmp(2)
    else
      ij1 = jBasj
      ij2 = iBasi
      ij3 = iCmp(2)
      ij4 = iCmp(1)
    end if
    if (jShell(3) >= jShell(4)) then
      kl1 = kBask
      kl2 = lBasl
      kl3 = iCmp(3)
      kl4 = iCmp(4)
    else
      kl1 = lBasl
      kl2 = kBask
      kl3 = iCmp(4)
      kl4 = iCmp(3)
    end if
    if (jShell(1) >= jShell(3)) then
      ik1 = iBasi
      ik2 = kBask
      ik3 = iCmp(1)
      ik4 = iCmp(3)
    else
      ik1 = kBask
      ik2 = iBasi
      ik3 = iCmp(3)
      ik4 = iCmp(1)
    end if
    if (jShell(1) >= jShell(4)) then
      il1 = iBasi
      il2 = lBasl
      il3 = iCmp(1)
      il4 = iCmp(4)
    else
      il1 = lBasl
      il2 = iBasi
      il3 = iCmp(4)
      il4 = iCmp(1)
    end if
    if (jShell(2) >= jShell(3)) then
      jk1 = jBasj
      jk2 = kBask
      jk3 = iCmp(2)
      jk4 = iCmp(3)
    else
      jk1 = kBask
      jk2 = jBasj
      jk3 = iCmp(3)
      jk4 = iCmp(2)
    end if
    if (jShell(2) >= jShell(4)) then
      jl1 = jBasj
      jl2 = lBasl
      jl3 = iCmp(2)
      jl4 = iCmp(4)
    else
      jl1 = lBasl
      jl2 = jBasj
      jl3 = iCmp(4)
      jl4 = iCmp(2)
    end if

    ! Here we go

    nao = iBasi*jBasj*kBask*lBasl*iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)
    call CtlDns(iDCRR,iDCRS,iDCRT,jOp)
  end if

  ! Add this contribution to the (Inactive) Fock Matrix

  ! Out from  CD : jOp

  do iCent=1,4
    do iCar=1,3
      pert(:) = .false.

      ! To which irreps does this derivative contribute?

      do iIrrep=0,nIrrep-1
        if (indgrd(iCar,iCent,iIrrep) /= 0) pert(iIrrep) = .true.
      end do

      if (Indx(iCar,iCent) > 0) then
        iGr = Indx(iCar,iCent)-1
        ipFin = 1+iGr*nijkl*nabcd
        if (.not. new_fock) then
          call MkFck(iAnga,iCmp,Shijij,iShll,iShell,iBasi,jBasj,kBask,lBasl,iAO,iAOst,nop,jop,Dij1,mDij,nDij,ij1,ij2,ij3,ij4,Dkl1, &
                     mDkl,nDkl,kl1,kl2,kl3,kl4,Dik1,mDik,nDik,ik1,ik2,ik3,ik4,Dil1,mDil,nDil,il1,il2,il3,il4,Djk1,mDjk,nDjk,jk1, &
                     jk2,jk3,jk4,Djl1,mDjl,nDjl,jl1,jl2,jl3,jl4,rFinal(ipFin),nAO,TwoHam,nTwo,Scrtch2,nS2,FckTmp,nFT,pert, &
                     iuvwx(iCent),iCent,iCar,indgrd,ipDisp)
          if (nMethod == RASSCF) call MkFck(iAnga,iCmp,Shijij,iShll,iShell,iBasi,jBasj,kBask,lBasl,iAO,iAOst,nop,jop,Dij2,mDij, &
                                            nDij,ij1,ij2,ij3,ij4,Dkl2,mDkl,nDkl,kl1,kl2,kl3,kl4,Dik2,mDik,nDik,ik1,ik2,ik3,ik4, &
                                            Dil2,mDil,nDil,il1,il2,il3,il4,Djk2,mDjk,nDjk,jk1,jk2,jk3,jk4,Djl2,mDjl,nDjl,jl1,jl2, &
                                            jl3,jl4,rFinal(ipFin),nAO,TwoHam,nTwo,Scrtch2,nS2,FckTmp,nFT,pert,iuvwx(iCent),iCent, &
                                            iCar,indgrd,ipDisp2)

        else
          ip = ipDisp(abs(indgrd(iCar,iCent,0)))
          call FckAcc_NoSym(iAnga,iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4),Shijij,iShll,iShell,nijkl,rFinal(ipFin),TwoHam(ip),dan, &
                            ndens,iAO,iAOst,iBasi,jBasj,kBask,lBasl,ExFac)
          if (nMethod == RASSCF) then
            ip = ipDisp2(abs(indgrd(iCar,iCent,0)))
            call FckAcc_NoSym(iAnga,iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4),Shijij,iShll,iShell,nijkl,rFinal(ipFin),TwoHam(ip),din, &
                              nDens,iAO,iAOst,iBasi,jBasj,kBask,lBasl,ExFac)
          end if
        end if

      else if (Indx(iCar,iCent) < 0) then
        Temp(1:nabcd*nijkl) = Zero
        do iCnt=1,4
          iGr = Indx(iCar,iCnt)
          if (iGr > 0) then
            ipFin = 1+(iGr-1)*nijkl*nabcd
            do ii=1,nabcd*nijkl
              Temp(ii) = Temp(ii)-rFinal(ipFin-1+ii)
            end do
          end if
        end do

        if (.not. new_fock) then
          call MkFck(iAnga,iCmp,Shijij,iShll,iShell,iBasi,jBasj,kBask,lBasl,iAO,iAOst,nop,jop,Dij1,mDij,nDij,ij1,ij2,ij3,ij4,Dkl1, &
                     mDkl,nDkl,kl1,kl2,kl3,kl4,Dik1,mDik,nDik,ik1,ik2,ik3,ik4,Dil1,mDil,nDil,il1,il2,il3,il4,Djk1,mDjk,nDjk,jk1, &
                     jk2,jk3,jk4,Djl1,mDjl,nDjl,jl1,jl2,jl3,jl4,Temp,nAO,TwoHam,nTwo,Scrtch2,nS2,FckTmp,nFT,pert,iuvwx(iCent), &
                     icent,iCar,indgrd,ipDisp)
          if (nMethod == RASSCF) call MkFck(iAnga,iCmp,Shijij,iShll,iShell,iBasi,jBasj,kBask,lBasl,iAO,iAOst,nop,jop,Dij2,mDij, &
                                            nDij,ij1,ij2,ij3,ij4,Dkl2,mDkl,nDkl,kl1,kl2,kl3,kl4,Dik2,mDik,nDik,ik1,ik2,ik3,ik4, &
                                            Dil2,mDil,nDil,il1,il2,il3,il4,Djk2,mDjk,nDjk,jk1,jk2,jk3,jk4,Djl2,mDjl,nDjl,jl1,jl2, &
                                            jl3,jl4,Temp,nAO,TwoHam,nTwo,Scrtch2,nS2,FckTmp,nFT,pert,iuvwx(iCent),icent,iCar, &
                                            indgrd,ipDisp2)

        else
          ip = ipDisp(abs(indgrd(iCar,iCent,0)))
          call FckAcc_NoSym(iAnga,iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4),Shijij,iShll,iShell,nijkl,Temp,TwoHam(ip),dan,nDens,iAO, &
                            iAOst,iBasi,jBasj,kBask,lBasl,ExFac)
          if (nMethod == RASSCF) then
            ip = ipDisp2(abs(indgrd(iCar,iCent,0)))
            call FckAcc_NoSym(iAnga,iCmpa(1),iCmpa(2),iCmpa(3),iCmpa(4),Shijij,iShll,iShell,nijkl,Temp,TwoHam(ip),din,nDens,iAO, &
                              iAOst,iBasi,jBasj,kBask,lBasl,ExFac)
          end if
        end if

      end if
    end do
  end do
  call Timing(dum1,Time,dum2,dum3)
  CPUStat(nFckAcc) = CPUStat(nFckAcc)+Time
end if

if (n8 .and. (nmethod == RASSCF)) call MakeMO(rFinal,Scrtch1,nTempTot,nFinal,iCmp,iCmpa,iBasi,jBasj,kBask,lBasl,nGr,Indx,moip, &
                                              naco,nop,indgrd,ishll,ishell,rmoin,nMOIN,iuvwx,iaost,Buffer,ianga)

call Timing(dum1,Time,dum2,dum3)
CPUStat(nMOTrans) = CPUStat(nMOTrans)+Time

return

end subroutine ClrBuf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine RInt_SP(rkappa,rmos,rmoa,Focki,Sigma)
*
*                          ^   ~
*     Constructs  F  = <0|[Q  ,H]|0>
*                  pq       pq
*
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
#include "glbbas_mclr.fh"
#include "spin.fh"
      Real*8 rkappa(nDensC),Sigma(nDensC),
     &       Focki(ndens2),rMOs(*),rmoa(*)
*
*     D,FA used in oit of FA
*     p11 -> (~~|  )
*     p12 -> (  |~~)
*     sign1 k**t=sign K
*     sign2=Sign K * Lambda
*
*
      Call GetMem('MOTemp2','ALLO','REAL',ipMT1,nmba)
      Call GetMem('MOTemp1','ALLO','REAL',ipMT2,nmba)
      Call GetMem('MOTemp3','ALLO','REAL',ipMT3,nmba)
      Call GetMem('Sigma','ALLO','REAL',ipScr,ndensc)
*
      Call Oit_sp(rkappa,Work(ipScr),-1,1,
     &            -1.0d0,Work(ipG2mp),1.0d0,Work(ipfm),
     &            Work(ipg1m),Work(ipfamo_spinm),
     &            Work(ipMT1),Work(ipMT2),Focki)
*     Call DYAX(ndensc,rbetaA/2.0d0,Work(ipSCR),1,sigma,1)
      Call DYAX(ndensc,1.0d0,Work(ipSCR),1,sigma,1)
      Call Recprt(' ',' ',Work(ipSCR),ndensc,1)
*
*     kappa_S
*
      Call Oit_sp(rkappa,Work(ipScr),1,1,
     &            -1.0d0,Work(ipG2mp),1.0d0,Work(ipfm),
     &            Work(ipg1m),Work(ipfamo_spinm),
     &            Work(ipMT1),Work(ipMT2),Focki)
*     call daxpy_(ndensc,-rbetaA/2.0d0,Work(ipSCR),1,sigma,1)
      call daxpy_(ndensc,-1.0d0,Work(ipSCR),1,sigma,1)
      Call Recprt(' ',' ',Work(ipSCR),ndensc,1)
*
*     alpha_S
*
      If (rbetas.ne.0.0d0) Then
        Call Oit_sp(rkappa,Work(ipScr),-1,-1,
     &            1.0d0,Work(ipG2pp),1.0d0,Work(ipfp),
     &            Work(ipg1p),Work(ipfamo_spinp),
     &            Work(ipMT1),Work(ipMT2),Focki)
*     call daxpy_(ndensc,rbetaS,Work(ipSCR),1,sigma,1)
      call daxpy_(ndensc,1.0d0,Work(ipSCR),1,sigma,1)
      Call Recprt(' ',' ',Work(ipSCR),ndensc,1)
      End if
      Call Oit_sp(rkappa,Work(ipScr),-1,-1,
     &            1.0d0,Work(ipG2pp),1.0d0,Work(ipG2mm),
     &            Work(ipg1p),Work(ipFamo_spinp),
     &            Work(ipMT1),Work(ipMT2),Focki)
*     call daxpy_(ndensc,ralphas,Work(ipSCR),1,sigma,1)
      Call Recprt(' ',' ',Work(ipSCR),ndensc,1)

      Call AddGrad_sp(rKappa,Work(ipScr),Work(ipFS),1,1.0d0,1.0d0)
      Call Recprt(' ',' ',Work(ipSCR),ndensc,1)
      call daxpy_(ndensc,rbetaA/2.0d0,Work(ipSCR),1,sigma,1)
*
      Call DZAXPY(nmba,1.0d0,Work(ipMT1),1,
     &           Work(ipMT2),1,Work(ipMT3),1)
      Call PickMO_MCLR(Work(ipMT3),rmos,1)
*
      Call DZAXPY(nmba,-1.0d0,Work(ipMT2),1,
     &           Work(ipMT1),1,Work(ipMT3),1)
      Call PickMO_MCLR(Work(ipMT3),rmoa,1)

      Call GetMem('Sigma','FREE','REAL',ipScr,ndensc)
      Call GetMem('MOTemp3','FREE','REAL',ipMT3,nmba)
      Call GetMem('MOTemp2','FREE','REAL',ipMT2,nmba)
      Call GetMem('MOTemp1','FREE','REAL',ipMT1,nmba)
*
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine hdir2(nP,L,dX,dY,dZ,Ang,iprint)
! angstep == steps in the angular distribution. It defines the number of points
!            in which M will be computed;
!      nP == number of points, ( nP = 360/angstep )
!       L == cartesian component of the magnetisation torque
!            If L=1 (i.e.X), rotation of the M occurs in the YZ plane
!            If L=2 (i.e.Y), rotation of the M occurs in the XZ plane
!            If L=3 (i.e.Z), rotation of the M occurs in the XY plane

use Constants, only: Zero, deg2rad
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nP, L, iprint
real(kind=wp), intent(out) :: dX(nP), dY(nP), dZ(nP), Ang(nP)
integer(kind=iwp) :: i
real(kind=wp) :: AngRad, AngStep

AngStep = 360.0_wp/real(nP-1,kind=wp)

if (L == 1) then
  dX(:) = Zero
  do i=1,nP
    AngRad = real(i-1,kind=wp)*AngStep*deg2rad
    Ang(i) = real(i-1,kind=wp)*AngStep
    dY(i) = cos(AngRad)
    dZ(i) = sin(AngRad)
  end do
else if (L == 2) then
  dY(:) = Zero
  do i=1,nP
    AngRad = real(i-1,kind=wp)*AngStep*deg2rad+122.625_wp*deg2rad
    Ang(i) = real(i-1,kind=wp)*AngStep
    dX(i) = cos(AngRad)
    dZ(i) = sin(AngRad)
  end do
else if (L == 3) then
  dZ(:) = Zero
  do i=1,nP
    AngRad = real(i-1,kind=wp)*AngStep*deg2rad
    Ang(i) = real(i-1,kind=wp)*AngStep
    dX(i) = cos(AngRad)
    dY(i) = sin(AngRad)
  end do
else
  write(u6,'(A   )') 'Error. Parametr L can take only Integer values 1, 2 or 3.'
  write(u6,'(A,I5)') 'Current value: L = ',L
end if

if (iprint > 2) then
  write(u6,'(A,I5)') 'Angular grid for Magnetization Torque, Cartesian Component =',L
  write(u6,'(2x,A,4x,A,5x,3(10X,A,10x))') 'Nr.','Angle','X','Y','Z'
  do i=1,nP
    write(u6,'(I4,F10.3,3x,3F21.14)') i,Ang(i),dX(i),dY(i),dZ(i)
  end do
end if

return

end subroutine hdir2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine read_dmrg_parameter_for_mclr()

use input_mclr, only: ERASSCF
use dmrginfo, only: DoDMRG, DoMCLR, LRRAS2, MS2_RGLR, nEle_RGLR, nStates_RGLR, RGRAS2
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: i, ierr

open(unit=100,file='dmrg_for_mclr.parameters',status='OLD',action='READ',iostat=ierr)
if (ierr /= 0) then
  doDMRG = .false.
  doMCLR = .false.
else
  read(100,'(11X,L1,4X)') doDMRG
  read(100,'(4X,I8,4X)') nele_RGLR
  read(100,'(4X,I8,4X)') ms2_RGLR
  !write(u6,*) doDMRG,dmrg_state%nactel,dmrg_state%ms2
  do i=1,8
    read(100,'(4X,I3)',advance='no') RGras2(i)
  end do
  read(100,*)
  do i=1,8
    read(100,'(4X,I3)',advance='no') LRras2(i)
  end do
  !write(u6,*) RGras2
  !write(u6,*) LRras2
  read(100,*)
  read(100,'(4X,I8,4X)') nstates_RGLR
  !call mma_allocate(checkpoint,nstates_RGLR,label='checkpoint')
  !checkpoint = ''
  do i=1,nstates_RGLR
    read(100,*)
    read(100,'(G20.12)') ERASSCF(i)
    write(6,*) 'RASSCF energy',ERASSCF(i)
  end do
  ! It is redundant
  doMCLR = .true.
end if
close(100)

write(u6,*) 'doDMRG, nele_dmrg, ms2_dmrg'
write(u6,*) doDMRG,nele_rglr,ms2_rglr
call xflush(u6)

end subroutine read_dmrg_parameter_for_mclr

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
* Here we construct the density matrix given the orbital
* coefficients.
      SUBROUTINE DENSI_MO(DENS,ORBCO,IS,IA,NBAS,IDIM)
      IMPLICIT Real*8 (A-H,O-Z)
      DIMENSION DENS(*),ORBCO(IDIM,*)
      IJ=0
      DO 8 I=1,NBAS
        DO 9 J=1,I
          IJ=IJ+1
          DENS(IJ)=0.0d0
   9    CONTINUE
   8  CONTINUE
      DO 10 I=IS,IS+IA-1
        IJ=0
        DO 11 J=1,NBAS
          DO 12 K=1,J
            IJ=IJ+1
            DENS(IJ)=DENS(IJ)+4.d0*ORBCO(J,I)*ORBCO(K,I)
 12       CONTINUE
          DENS(IJ)=DENS(IJ)-ORBCO(J,I)*ORBCO(J,I)*2.d0
 11     CONTINUE
  10  CONTINUE
      RETURN
      END


* The RASSI-density matrix subroutine.
      Subroutine DensiSt(Dens,StVec,iS,nSt,iDim)
      Implicit Real*8 (a-h,o-z)
      Dimension Dens(*),StVec(iDim,*)

* iS        -        Which state that is occupied.
* Dens        -        The density
* StVec        -        The coefficients for how the new states are expressed
*                with the old.
      kaunt=0
      Do 101, i=1,nSt
        Do 102, j=1,i
          kaunt=kaunt+1
          Dens(kaunt)=0.0d0
102     Continue
101   Continue
      kaunt=0
      Do 112, ii=1,nSt
        Do 113, jj=1,ii
          kaunt=kaunt+1
          If(ii.eq.jj) then
            Dens(kaunt)=1.0d0*StVec(ii,iS)*StVec(jj,iS)
          Else
            Dens(kaunt)=2.0d0*StVec(ii,iS)*StVec(jj,iS)
          Endif
113     Continue
112   Continue
      Return
      End

* MP2 density correction.
      Subroutine DCorrCorr(Dens,DenCorr,Trace_Diff,iOrb,iOcc)
      Implicit Real*8 (a-h,o-z)
      Dimension Dens(*),DenCorr(*)
      Trace_HF=dble(iOcc*2)
      kaunt=0
      T=Trace_HF/(Trace_HF-Trace_Diff)
      Do 183, i=1,iOrb
        Do 184, j=1,i
          kaunt=kaunt+1
          Dens(kaunt)=T*(Dens(kaunt)-DenCorr(kaunt))
184     Continue
183   Continue
*      Trace=0.0d0
*      kaunt=0
*      Do 181, i=1,iOrb
*        Do 182, j=1,i
*          kaunt=kaunt+1
*          If(i.eq.j)Trace=Trace+Dens(kaunt)
*182     Continue
*181   Continue
*      call triprt('KKK',' ',Dens,iorb)
*      write(6,*)'QQQ:',Trace
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Roland Lindh                                     *
*               2004, Takashi Tsuchiya                                 *
************************************************************************
      Subroutine AOEval(iAng,nCoor,Coor,xyz,RA,Transf,CffSph,nElem,nCmp,
     &                  Angular,nTerm,nForm,Thr_Rad,nRad,mExp,nExp,
     &                  Alpha,Radial,nBas,CffCnt,AOValue,mAO,
     &                  px,py,pz,ipx,ipy,ipz)
************************************************************************
* Object: to compute the values of the AOs on a grid. The calculation  *
*         is sectioned in an angular part and a radial part. Due to the*
*         gradients we have 3 angular parts and 2 radial part.         *
*                                                                      *
*      Author:Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN. November '95                            *
*      Modified by: Takashi Tsuchiya, Dept. of Theoretical Chemistry,  *
*                   University of Lund, SWEDEN. February 2004          *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
      Real*8 xyz(nCoor,3,0:iAng+nRad-1), Coor(3,nCoor), RA(3),
     &       CffSph(nElem,nCmp), Alpha(nExp), Radial(nCoor,nRad,nBas),
     &       CffCnt(mExp,nBas), AOValue(mAO,nCoor,nBas,nCmp)
      Integer Angular(nTerm,5,nForm)
      Logical Transf
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Character*80 Label
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Index for derivatives in AOValue
*
*     mAO =   1:    F
*             2:   dFdx
*             3:   dFdy
*             4:   dFdz
*             5:  d2Fdxdx
*             6:  d2Fdxdy
*             7:  d2Fdxdz
*             8:  d2Fdydy
*             9:  d2Fdydz
*            10:  d2Fdzdz
*            11:  d3Fdxdxdx
*            12:  d3Fdxdxdy
*            13:  d3Fdxdxdz
*            14:  d3Fdxdydy
*            15:  d3Fdxdydz
*            16:  d3Fdxdzdz
*            17:  d3Fdydydy
*            18:  d3Fdydydz
*            19:  d3Fdydzdz
*            20:  d3Fdzdzdz
*            ... and so on;
*                in the same order for the higher order derivatives.
*                                                                      *
************************************************************************
*                                                                      *
      Ind(iy,iz) = (iy+iz)*(iy+iz+1)/2 + iz + 1
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      iRout=132
      iPrint=nPrint(iRout)
C     iPrint=99
      If (iPrint.ge.49) Then
         Write(6,*) '********** AOEval ***********'
         Write (6,*) 'In AOEval'
         Call RecPrt('Coor',' ',Coor,3,nCoor)
         Call RecPrt('CffCnt',' ',CffCnt,mExp,nBas)
         Call RecPrt('CffSph',' ',CffSph,nElem,nCmp)
         Write (6,*) 'RA=',RA
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*---- Initialize AOValue
*
      AOValue(:,:,:,:)=Zero
*
*---- Set the order of derivation
*
      nDrv=nRad-1
C     Write(6,*) '----- nDrv = ', nDrv
*                                                                      *
************************************************************************
*                                                                      *
*---- Evaluate the radial part
*----    Normal radial part and
*----    premultiplied with (minus two times the exponent)**iDrv
*
#ifdef _DEBUGPRINT_
      If (nRad.LE.0 .AND. nRad.GE.5) Then
         Write (6,*) 'AOEval: illegal value of nRad!'
         Call Abend()
      End If
#endif
*
      Thre=-99D0
      If (Thr_Rad.gt.0.0D0) Thre=Log(Thr_Rad)
      Exp_Min=1.0D10
      Do iExp = 1, nExp
         Exp_Min=Min(Exp_Min,Alpha(iExp))
      End Do
      Radial(:,:,:)=Zero
      Do iCoor = 1, nCoor
         R2=(Coor(1,iCoor)-RA(1))**2
     &     +(Coor(2,iCoor)-RA(2))**2
     &     +(Coor(3,iCoor)-RA(3))**2
         Do iExp = 1, nExp
            If (-Alpha(iExp)*R2.lt.Thre) Go To 9898
            Tmp=Exp(-Alpha(iExp)*R2)
            If (nRad.eq.1) Then
               Do iBas = 1, nBas
                  XCff=CffCnt(iExp,iBas)
                  Radial(iCoor,1,iBas)=Radial(iCoor,1,iBas) + XCff*Tmp
               End Do
            Else If (nRad.eq.2) Then
               Tmp2=-Two*Alpha(iExp)*Tmp
               Do iBas = 1, nBas
                  XCff=CffCnt(iExp,iBas)
                  Radial(iCoor,1,iBas)=Radial(iCoor,1,iBas) + XCff*Tmp
                  Radial(iCoor,2,iBas)=Radial(iCoor,2,iBas) + XCff*Tmp2
               End Do
            Else If (nRad.eq.3) Then
               Tmp2=-Two*Alpha(iExp)*Tmp
               Tmp3=-Two*Alpha(iExp)*Tmp2
               Do iBas = 1, nBas
                  XCff=CffCnt(iExp,iBas)
                  Radial(iCoor,1,iBas)=Radial(iCoor,1,iBas) + XCff*Tmp
                  Radial(iCoor,2,iBas)=Radial(iCoor,2,iBas) + XCff*Tmp2
                  Radial(iCoor,3,iBas)=Radial(iCoor,3,iBas) + XCff*Tmp3
               End Do
            Else If (nRad.eq.4) Then
               Tmp2=-Two*Alpha(iExp)*Tmp
               Tmp3=-Two*Alpha(iExp)*Tmp2
               Tmp4=-Two*Alpha(iExp)*Tmp3
               Do iBas = 1, nBas
                  XCff=CffCnt(iExp,iBas)
                  Radial(iCoor,1,iBas)=Radial(iCoor,1,iBas) + XCff*Tmp
                  Radial(iCoor,2,iBas)=Radial(iCoor,2,iBas) + XCff*Tmp2
                  Radial(iCoor,3,iBas)=Radial(iCoor,3,iBas) + XCff*Tmp3
                  Radial(iCoor,4,iBas)=Radial(iCoor,4,iBas) + XCff*Tmp4
               End Do
            Else
               Do iBas = 1, nBas
                  XCff=CffCnt(iExp,iBas)
                  Radial(iCoor,1,iBas)=Radial(iCoor,1,iBas) + XCff*Tmp
               End Do
               Do iDrv = 1, nDrv
                  Tmp=-Two*Alpha(iExp)*Tmp
                  Do iBas = 1, nBas
                     XCff=CffCnt(iExp,iBas)
                     Radial(iCoor,iDrv+1,iBas)=Radial(iCoor,iDrv+1,iBas)
     &                                        +  XCff*Tmp
                  End Do
               End Do
            End If
         End Do
 9898    Continue
      End Do
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
            Write (6,*) mExp,nExp
            Write (Label,'(A)')'Radial(nCoor*nRad,nBas)'
            Call RecPrt(Label,'(10G20.10)',Radial,nCoor*nRad,nBas)
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Evaluate the angular part
*
      If (iAng+nRad-1.ge.1) Then
         Do iCoor = 1, nCoor
            xyz(iCoor,1,0)=One
            xyz(iCoor,2,0)=One
            xyz(iCoor,3,0)=One
            xyz(iCoor,1,1)=px*(Coor(1,iCoor)-RA(1))
            xyz(iCoor,2,1)=py*(Coor(2,iCoor)-RA(2))
            xyz(iCoor,3,1)=pz*(Coor(3,iCoor)-RA(3))
         End Do
         Do i = 2, iAng+nRad-1
            Do iCoor = 1, nCoor
               xyz(iCoor,1,i)=xyz(iCoor,1,i-1)*xyz(iCoor,1,1)
               xyz(iCoor,2,i)=xyz(iCoor,2,i-1)*xyz(iCoor,2,1)
               xyz(iCoor,3,i)=xyz(iCoor,3,i-1)*xyz(iCoor,3,1)
            End Do
         End Do
      Else
         xyz(:,:,0)=One
      End If
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Do i = 0, iAng+nRad-1
            Write (Label,'(A,I2,A)')'xyz(nCoor,nCar,',i,')'
            Call RecPrt(Label,'(3E12.6)',xyz(1,1,i),nCoor,3)
         End Do
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Calculate the angular components of the derivatives
*
      Angular(:,:,:)=0
*
      Do ix = iAng, 0, -1
*
         Do iy = iAng-ix, 0, -1
            iz = iAng-ix-iy
            ip=Ind(iy,iz)
*
*---------- Initial values for 0th-order derivative
*
            Angular(1,1,1)=ix
            Angular(1,2,1)=iy
            Angular(1,3,1)=iz
            Angular(1,4,1)=0
            Angular(1,5,1)=1
*
*
*---------- Calculate derivatives of the angular components
*
*           jf: Formula to be derivated
*           if: New formula by way of derivation
*
            if = 1
C           Call PrntA(nterm,nform,Angular,if,0)
            Do jDrv = 0,nDrv-1
               Do jx = jDrv,0,-1
                  Do jy = jDrv-jx,0,-1
                     jz = jDrv-jx-jy
                     jf = Ind(jy,jz)
*
                     Do kDrv = 0,jDrv-1
                        jf=jf+(kDrv+1)*(kDrv+2)/2
                     End Do
*
#ifdef _DEBUGPRINT_
                     If (iPrint.ge.99) Then
                        Write (6,*) ' jx,jy,jz,jf=',jx,jy,jz,jf
                     End If
#endif
*
                     If (jy .EQ. 0 .AND. jz .EQ. 0) then
                       if=if+1
                       Call dFdxyz(nTerm,nForm,Angular,jf,if,1,ipx,jDrv)
C                      Call PrntA(nterm,nform,Angular,if,jdrv+1)
                       if=if+1
                       Call dFdxyz(nTerm,nForm,Angular,jf,if,2,ipy,jDrv)
C                      Call PrntA(nterm,nform,Angular,if,jdrv+1)
                       if=if+1
                       Call dFdxyz(nTerm,nForm,Angular,jf,if,3,ipz,jDrv)
C                      Call PrntA(nterm,nform,Angular,if,jdrv+1)
                     Else if (jz .EQ. 0) then
                       if=if+1
                       Call dFdxyz(nTerm,nForm,Angular,jf,if,2,ipy,jDrv)
C                      Call PrntA(nterm,nform,Angular,if,jdrv+1)
                       if=if+1
                       Call dFdxyz(nTerm,nForm,Angular,jf,if,3,ipz,jDrv)
C                      Call PrntA(nterm,nform,Angular,if,jdrv+1)
                     Else
                       if=if+1
                       Call dFdxyz(nTerm,nForm,Angular,jf,if,3,ipz,jDrv)
C                      Call PrntA(nterm,nform,Angular,if,jdrv+1)
                     Endif
                  End Do
               End Do
            End Do
*
*
*---------- Distribute contributions to the real spherical harmonics
*----------            and combine with angular part
*----------       to yield the values and the gradients
*
            If (Transf) Then
              Do iCmp = 1, nCmp
                Cff=CffSph(ip,iCmp)
                If (Cff.ne.Zero) Then
                  kForm=0
                  Do iDrv = 0,nDrv
                    mForm=(iDrv+1)*(iDrv+2)/2
                    Do iForm = kForm+1, kForm+mForm
                      mTerm=2**(iDrv)
                      Do iTerm = 1, mTerm
                        iCoef=Angular(iTerm,5,iForm)
                        If (iCoef.ne.0) Then
                          Coef=DBLE(iCoef)
                          iRad =Angular(iTerm,4,iForm)+1
                          Do iBas = 1, nBas
                            Do iCoor = 1, nCoor
                              AOValue(iForm,iCoor,iBas,iCmp)
     &                         = AOValue(iForm,iCoor,iBas,iCmp)
     &                         + xyz(iCoor,1,Angular(iTerm,1,iForm))
     &                         * xyz(iCoor,2,Angular(iTerm,2,iForm))
     &                         * xyz(iCoor,3,Angular(iTerm,3,iForm))
     &                         * Coef
     &                         * Cff
     &                         * Radial(iCoor,iRad,iBas)
                            End Do
                          End Do
                        End If
                      End Do
                    End Do
                    kForm=kForm+mForm
                  End Do
                End If
              End Do
            Else
              kForm=0
              Do iDrv = 0, nDrv
                mForm=(iDrv+1)*(iDrv+2)/2
                Do iForm = kForm+1, kForm+mForm
                  mTerm=2**(iDrv)
                  Do iTerm = 1, mTerm
                    iCoef=Angular(iTerm,5,iForm)
                    If (iCoef.ne.0) Then
                      Coef=DBLE(iCoef)
                      iRad =Angular(iTerm,4,iForm)+1
                      Do iBas = 1, nBas
                        Do iCoor = 1, nCoor
                          AOValue(iForm,iCoor,iBas,ip)
     &                     = AOValue(iForm,iCoor,iBas,ip)
     &                     + xyz(iCoor,1,Angular(iTerm,1,iForm))
     &                     * xyz(iCoor,2,Angular(iTerm,2,iForm))
     &                     * xyz(iCoor,3,Angular(iTerm,3,iForm))
     &                     * Coef
     &                     * Radial(iCoor,iRad,iBas)
                        End Do
                      End Do
                    End If
                  End Do
                End Do
                kForm=kForm+mForm
              End Do
            End If
*
*
         End Do
*
      End Do
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      If (iPrint.ge.49) Then
         Write(6,*) 'mAO,nCoor,nBas,nCmp',mAO,nCoor,nBas,nCmp
         Call RecPrt('AOValue','(10G20.10)',AOValue,mAO,nCoor*nBas*nCmp)
      End If
#endif

      End
*
      Subroutine dFdxyz(mterm,mform,N,jp,ip,ixyz,ipf,jdrv)
*
      Implicit real*8 (a-h,o-z)
      Integer N(mterm,5,mform)
*
*
*     ipf: Phase factor in integer
*
*
*
*
      nterm=2**jdrv
      iterm=0
*
      Do jterm=1,nterm
*
*
*        downward operation
*        (derivation of angular part)
*
*
         iterm=iterm+1
         Do i=1,5
            If (i .EQ. ixyz) then
               N(iterm,ixyz,ip)=N(jterm,ixyz,jp)-1
            Else
               N(iterm,i,ip)=N(jterm,i,jp)
            End if
         End do
         N(iterm,5,ip)=N(iterm,5,ip)*N(jterm,ixyz,jp)
         N(iterm,5,ip)=N(iterm,5,ip)*ipf
*
*
*        upward operation
*        (derivation of radial  part)
*
*
         iterm=iterm+1
         Do i=1,5
            If (i .EQ. ixyz) then
               N(iterm,ixyz,ip)=N(jterm,ixyz,jp)+1
            Else
               N(iterm,i,ip)=N(jterm,i,jp)
            End if
         End do
         N(iterm,4,ip)=N(iterm,4,ip)+1
         N(iterm,5,ip)=N(iterm,5,ip)*ipf
      End do
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1996, Roland Lindh                      *
!               1990, IBM                                              *
!               1995, Martin Schuetz                                   *
!***********************************************************************

subroutine Close_SemiDSCF()

use IOBUF, only: iBuf, iPos, iStatIO, lStRec, Mode_None, OnDisk

implicit none

!write(u6,*) 'Enter: Close_SemiDSCF'

! If data was transfered to the I/O buffer write buffer on disc.

! If buffer empty force the write :
if (iPos == 1) iPos = 2
if (OnDisk) call WLBuf()

iPos = lStRec+1
iStatIO = Mode_None
iBuf = -99
!write(u6,*) 'Exit: Close_SemiDSCF'

end subroutine Close_SemiDSCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2006, Giovanni Ghigo                                   *
!***********************************************************************
!  ZMatrixConverter
!
!> @brief
!>   Routine for reading seward input in Z-Matrix format
!> @author Giovanni Ghigo
!>
!> @details
!> The input for seward is read and a string vector is generate (\p STDINP).
!> This vector contains a standard seward input and it will be read later as usual
!> by a modified copy of the section ``BASI`` code already present in ::RdCtl_Seward.
!> This new code is in the ::StdSewInput routine.
!> Only the standard basis present in the ``$MOLCAS/basis_library`` are allowed.
!>
!> @param[in]     LuRd    Input file unit number
!> @param[in]     LuWr    Output file unit number
!> @param[in]     mxAtom  Parameter
!> @param[out]    STDINP  String vector of seward standard input
!> @param[out]    lSTDINP Length of String vector \p STDINP
!> @param[in]     iglobal
!> @param[in,out] nxbas
!> @param[in]     xb_label
!> @param[in]     xb_bas
!> @param[out]    iErr    Error flag
!***********************************************************************

subroutine ZMatrixConverter(LuRd,LuWr,mxAtom,STDINP,lSTDINP,iglobal,nxbas,xb_label,xb_bas,iErr)
!***********************************************************************
! Author: Giovanni Ghigo                                               *
!         Torino (Italy)  October-November 2006                        *
!                                                                      *
! This is an adaptation of Program ZMatrixConverter                    *
! A converter of Z-Matrix in cartesian coordinates in MolCAS format.   *
! Version 1.0                                                          *
! The input for seward is read and a string vector is generate. This   *
! vector is a standard seward input and it will be read later as usual *
! by a copy on the code already present in RdCtl_Seward.               *
!***********************************************************************

use ZMatConv_Mod, only: BasAva, Base, BasReq, Coords, iZmat, MaxAtoms, NAT, Symbols, Zmat
use isotopes, only: MaxAtomNum
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, deg2rad
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: LuRd, LuWr, mxAtom, iglobal
character(len=180), intent(out) :: STDINP(mxAtom*2)
integer(kind=iwp), intent(out) :: lSTDINP, iErr
integer(kind=iwp), intent(inout) :: nxbas
character(len=*), intent(in) :: xb_label(*), xb_bas(*)
integer(kind=iwp) :: i, iAtom, iSTDINP, j, k, nAtoms, NATprev, nBase, nBasis, nXAtoms
logical(kind=iwp) :: IfTest
real(kind=wp) :: r
character(len=180) :: aDebug
character(len=12) :: Angstring

#ifdef _DEBUGPRINT_
IfTest = .true.
#else
IfTest = .false.
#endif

!  ***  X dummy atoms (NA = 0 )
!  ***  Z ghost atoms (NA =-1 )
!  ***  nAskAtoms == -1  =>  Seward ZMAT input
!  ***  nAskAtoms /= -1  =>  GateWay ZMAT input

! nAtoms : nr. of atoms passed to SEWARD (includes X dummy atoms).
! nXAtoms: nr. of ghost Z atoms (not passed to SEWARD but resumed by OutZMat in SLAPAF).
! nBase  : number of BasisSets found in input.
! Base(i): BasisSet for atom with Atomic Number -i-.
! BasAva(i) & BasReq(i): Logical to check BasisSet-consistency.
! Coords(_,i): X, Y, Z, coordinates (in Angstrom) for atom -i-.

nAtoms = 0
nXAtoms = 0
nBase = 0
lSTDINP = 0
nBasis = 0
iErr = 0
Angstring = '  / Angstrom'

call mma_allocate(Base,MaxAtomNum,label='Base')
call mma_allocate(BasAva,MaxAtomNum,label='BasAva')
call mma_allocate(BasReq,MaxAtomNum,label='BasReq')
call mma_allocate(NAT,MaxAtoms,label='NAT')
call mma_allocate(Symbols,MaxAtoms,label='Symbols')
call mma_allocate(iZmat,3,MaxAtoms,label='iZmat')
call mma_allocate(Zmat,3,MaxAtoms,label='Zmat')
Base(:) = ''
BasAva(:) = .false.
BasReq(:) = .false.
NAT(:) = 0
Symbols(:) = ''
iZmat(:,:) = 0
Zmat(:,:) = Zero

! Reading input
call BasisReader(LuWr,nBase,iglobal,nxbas,xb_label,xb_bas,iErr)
if (IfTest) then
  write(LuWr,*)
  write(LuWr,*) '------------------------------------------------'
  write(LuWr,*) 'ZMatrixConverter - From BasisReader :'
  write(LuWr,*) '                   nBase=',nBase
  do i=1,size(Base)
    if (BasAva(i)) write(LuWr,'(I23,3X,A)') i,Base(i)
  end do
  write(LuWr,*)
end if
if (iErr /= 0) then
  write(LuWr,*) ' ERROR: Wrong input in Bases Set definition !'
  return
end if
call ZMatReader(LuRd,LuWr,nAtoms,nXAtoms,nBasis,-1,iErr)
if (IfTest) then
  write(LuWr,*)
  write(LuWr,*) '------------------------------------------------'
  write(LuWr,*) 'ZMatrixConverter - From ZMatReader :'
  write(LuWr,*) '                   nAtoms=',nAtoms,', nXAtoms=',nXAtoms,', Tot=',nAtoms+nXAtoms
  write(LuWr,*) ' Label NA   i    bond        j    angle       k    dihedral'
  do i=1,nAtoms+nXAtoms
    write(LuWr,'(1X,A,I3,3(1X,I4,1X,F11.6))') Symbols(i),NAT(i),(iZmat(j,i),Zmat(j,i),j=1,3)
  end do
  write(LuWr,*)
end if
if (iErr /= 0) then
  write(LuWr,*) ' ERROR: Wrong input in Z-Matrix definition !'
  return
end if

! Some checks
if (nBase == 0) then
  iErr = 1
  write(LuWr,*) 'ERROR: No basis set specified !'
  return
end if
if (nAtoms == 0) then
  iErr = 1
  write(LuWr,*) 'ERROR: No atom coordinates specified !'
  return
end if
if (nBase < nBasis) then
  iErr = 1
  write(LuWr,*) 'ERROR: Wrong number of basis sets !'
  write(LuWr,*) '       Available=',nBase,'  Required=',nBasis
  return
end if
call BasisConsistency(LuWr,iErr)
if (iErr /= 0) then
  iErr = 1
  write(LuWr,*) 'ERROR: Basis set inconsistency !'
  return
end if

call Put_iScalar('N ZMAT',nAtoms+nXAtoms)
call Put_cArray('Symbol ZMAT',Symbols(1),(nAtoms+nXAtoms)*len(Symbols))
call Put_iArray('Index ZMAT',iZmat,(nAtoms+nXAtoms)*3)
call Put_iArray('NAT ZMAT',NAT,nAtoms+nXAtoms)

call mma_allocate(Coords,3,nAtoms+nXAtoms,label='Coords')
Coords(:,:) = Zero

! Calculate coordinates
! Atom #1
if (nAtoms+nXAtoms > 1) then
  ! Atom #2
  Coords(3,2) = Zmat(1,2)  ! Z(2)=R
end if
if (nAtoms+nXAtoms > 2) then
  ! Atom #3
  if (iZmat(1,3) == 1) then
    Coords(1,3) = Zmat(1,3)*sin(Zmat(2,3)*deg2rad) ! X(2)=R sin(A)
    Coords(3,3) = Zmat(1,3)*cos(Zmat(2,3)*deg2rad) ! Z(3)=R cos(A)
  else
    Coords(1,3) = Zmat(1,3)*sin(Zmat(2,3)*deg2rad)
    Coords(3,3) = Coords(3,2)-Zmat(1,3)*cos(Zmat(2,3)*deg2rad)
  end if
end if
if (nAtoms+nXAtoms > 3) then
  ! Atom #4 ->
  do iAtom=4,nAtoms+nXAtoms
    call ZMatConv(LuWr,iAtom,iErr)
  end do
  if (iErr /= 0) return

  if (IfTest) then
    write(LuWr,*)
    write(LuWr,*) '------------------------------------------------'
    write(LuWr,*) 'ZMatrixConverter - XYZCoords (Angstroms) :'
    do i=1,nAtoms+nXAtoms
      write(LuWr,99) i,NAT(i),(Coords(j,i),j=1,3)
    end do
    write(LuWr,*)
  end if

  ! Check for superposed atoms
  do i=1,nAtoms+nXAtoms
    if (NAT(i) > 0) then
      do j=i+1,nAtoms+nXAtoms
        if (NAT(j) > 0) then
          r = Zero
          do k=1,3
            r = r+(Coords(k,i)-Coords(k,j))**2
          end do
          if (r < 1.0e-4_wp) then
            iErr = 1
            write(LuWr,*) ' ERROR: Superimposed atoms: ',i,j,'  r=',sqrt(r)
            return
          end if
        end if
      end do
    end if
  end do
end if

! Writing
if (NAT(1) == -1) then
  NATprev = -1
else
  NATprev = -9999
end if
iSTDINP = 1
do i=1,nAtoms+nXAtoms
  if (NAT(i) == -1) cycle
  if (NAT(i) /= NATprev) then
    if ((i /= 1) .and. (NATprev /= -1)) then
      write(STDINP(iSTDINP),'(A)') 'End of basis'
      iSTDINP = iSTDINP+1
    end if
    write(STDINP(iSTDINP),'(A)') 'Basis set'
    iSTDINP = iSTDINP+1
    if (NAT(i) > 0) then
      write(STDINP(iSTDINP),'(A)') Base(NAT(i))
    else
      write(STDINP(iSTDINP),'(A)') 'X..... / InLine '
      iSTDINP = iSTDINP+1
      write(STDINP(iSTDINP),'(A)') '0.   0'
      iSTDINP = iSTDINP+1
      write(STDINP(iSTDINP),'(A)') '0    0'
    end if
    iSTDINP = iSTDINP+1
    NATprev = NAT(i)
  end if
  write(STDINP(iSTDINP),'(A5,3F16.10,A)') Symbols(i),(Coords(j,i),j=1,3),Angstring
  iSTDINP = iSTDINP+1
end do
write(STDINP(iSTDINP),'(A)') 'End of basis'
lSTDINP = iSTDINP
if (IfTest) then
  write(LuWr,*)
  write(LuWr,*) '------------------------------------------------'
  write(LuWr,*) 'ZMatrixConverter - The input passed to SEWARD : '
  do i=1,iSTDINP
    aDebug = STDINP(i)
    write(LuWr,*) aDebug
  end do
  write(LuWr,*)
end if

call mma_deallocate(Base)
call mma_deallocate(BasAva)
call mma_deallocate(BasReq)
call mma_deallocate(NAT)
call mma_deallocate(Symbols)
call mma_deallocate(iZmat)
call mma_deallocate(Zmat)
call mma_deallocate(Coords)

return

99 format(I3,1X,I3,1X,3(F12.6))

end subroutine ZMatrixConverter

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Teodoro Laino                                    *
************************************************************************
C     ******************************************************************C
      SUBROUTINE COMP_NAC(ISTATE, JSTATE, SCR, nSCR,ISY12, IOFF,LCI1)
C***********************************************************************C
C COMP_NAC : This routine was created to compute NonAdiabatic Couplings C
C                                                                       C
C                      d                                                C
C    NAC =   <Psi_1 | ---- Psi_2>                                       C
C                      dR                                               C
C                                                                       C
C    where Psi_1 and Psi_2 are two MCSCF WaveFunctions                  C
C                                                                       C
C Author:     Teodoro Laino.  Scuola Normale Superiore di Pisa (Italy)  C
C Date:       27.02.2004  Lund (Sweden)                                 C
C                                                                       C
C The original idea to implement this NAC computation was due to        C
C Per-Ake Malmqvist on January 2000                                     C
C                                                                       C
C On Input:                                                             C
C             SCR:  Transition density matrice in AO basis.             C
C                                                                       C
C***********************************************************************C
      Use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      IMPLICIT REAL*8 (A-H,O-Z)

#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='COMP_NAC')
#include "Molcas.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "disp.fh"
#include "diff.fh"
#include "symmul.fh"
* Arguments
      REAL*8 SCR(nSCR)
      DIMENSION IOFF(*)
      Integer IndGrd(0:7)
      Logical TF, TstFnc
* Statement Function
      TF(mdc,iIrrep,iComp) = TstFnc(dc(mdc)%iCoSet,
     &                              iIrrep,iComp,dc(mdc)%nStab)


*
* Main Loop on all  geometrical displacements to perform
* calculation of NonAdiabatic Couplings
*
*
      NTEMP = 3 * nAlCnt
      CALL GETMEM('NACS','ALLO','REAL',NNACS,NTEMP)
      CALL DCOPY_(NTEMP, [0.D0], 0, WORK(NNACS), 1)
      idcnt = 0
      Nprop = 0
      Job   = Jstate
      Do ICnttp=1,nCnttp
         Do ICnt=1,dbsc(iCnttp)%nCntr
            IdCnt=IdCnt+1
            Do IdCar=1,3
               Nprop=Nprop+1
*
* Compute idisp to retrieve data from disk...
*
* Differentiated symmetry-unique center IDCNT
* Derivative wrt component IDCAR=1,2,3 (d/dx,d/dy,d/dz)
* INDDSP(IDCNT,IIRREP) is the number of displacements in
* earlier center/irrep. Thus it is an offset.
               Call iCopy(nIrrep,[0],0,IndGrd,1)
               lOper=0
               Do iIrrep=0,nIrrep-1
                  nDisp = IndDsp(iDcnt,iIrrep)
* First set NDISP=ordering number of this displacement.
* Then loop over directions d/dx,d/dy,d/dz
                  Do iCar=1,3
                     iComp = 2**(iCar-1)
                     If ( TF(IdCnt,iIrrep,iComp)) Then
                        ndisp=ndisp+1
* NDISP is now the ordering number of this displacement.
                        If (iDCar.eq.icar) Then
                           lOper=lOper+2**iIrrep
                           IndGrd(iIrrep) = nDisp
                        End If
                     End If
                  End Do
               End Do
               If (lOper.ne.0) Then
* For the displacement represented by this symmetry-unique
* center IDCNT and this component IDCAR, the differentiation
* operator has components with irreps that have been marked
* with '1' in LOPER, regarded as a flag array.
* INDGRD(IIRREP) will be zero, except for those irreps, and
* will then contain the ordering number of the displacement.
                  Do iIrrep = 0, nIrrep-1
                     iSmLbl = 2**iIrrep
                     If ((iAnd(2**iIrrep,lOper).ne.0).and.
     &                    (MUL(iIrrep+1,isy12).eq.1))  Then
                        idisp = indgrd(iirrep)
                        CALL COMP_NAC_IDISP(Job,
     &                                      idisp,
     &                                      iIrrep+1,
     &                                      isy12,
     &                                      SCR,
     &                                      Work(LCI1),
     &                                      Prop,
     &                                      Ioff)
                        Work(NNACS-1+idisp) = Prop
                     End If
                  End Do
               End If
            End Do
         End Do
      End Do
* Print Some Stuff related to the computation of NACs
      IF (IPGLOB.ge.TERSE) THEN
      WRITE(6,'(/,"NONADIABATIC COUPLINGS BETWEEN STATE",'//
     &          'I5,"AND STATE",I5," .",/)')ISTATE, JSTATE
      Do I = 1, nAlCnt*3
         WRITE(6,'(I5,F15.9)')I,Work(NNACS-1+I)
      End Do
      END IF
*
      CALL GETMEM('NACS','FREE','REAL',NNACS,NTEMP)
*
      RETURN
C     ******************************************************************C
      END
C     ******************************************************************C


C     ******************************************************************C
      SUBROUTINE COMP_NAC_IDISP(JOB, IDISP, ISYMP, ISY12, TDMZZ,
     &                          CISTATJ, PROPVAL, IOFF )
C***********************************************************************C
C COMP_NAC : This routine was created to compute NonAdiabatic Couplings C
C                                                                       C
C                      d                                                C
C    NAC =   <Psi_1 | ---- Psi_2>                                       C
C                      dR                                               C
C                                                                       C
C    where Psi_1 and Psi_2 are two MCSCF WaveFunctions                  C
C                                                                       C
C Author:     Teodoro Laino.  Scuola Normale Superiore di Pisa (Italy)  C
C Date:       27.02.2004  Lund (Sweden)                                 C
C                                                                       C
C The original idea to implement this NAC computation was due to        C
C Per-Ake Malmqvist on January 2000                                     C
C                                                                       C
C Files needed by this routine:                                         C
C                                                                       C
C          File             Label        Description                    C
C                                                                       C
C     -   MCKINT                                                        C
C                       1) OVRGRDA - "ANTISYMMETRIC DERIVATIVE"         C
C                       2) KAPPA   - "ORBITAL ROTATION MATRIX "         C
C                       3) CI      - "CI ARRAY DERIVATIVES    "         C
C                                                                       C
C***********************************************************************C
      IMPLICIT REAL*8 (A-H,O-Z)

#include "Molcas.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "prgm.fh"
#include "symmul.fh"
#include "rassi.fh"
#include "cntrl.fh"
#include "Files.fh"
* Arguments
      DIMENSION TDMZZ(*), CISTATJ(*), IOFF(*)
* Local Variables
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='COMP_NAC')
      CHARACTER*8 LABEL, STYPE
* Subroutine Statements


*
* Reading information from MCKINT file...
*
* Let's Compute the dimension of the 1-electron array
*
      ISUM  = 0
      DO IS=1,NSYM
       JS=MUL(IS,ISYMP)
       NBI=NBASF(IS)
       NBJ=NBASF(JS)
       NBIJ=NBI*NBJ
       ISUM=ISUM+NBIJ
      END DO
      NTEMP=ISUM
      NSCR=(NBST*(NBST+1))/2
*
* OVRGRDA...
*
      LABEL ='OVRGRDA '
      STYPE ='ANTI    '
      CALL GETMEM('OVRGRDA','ALLO','REAL',N_OVRGRDA,NTEMP)
      CALL RDMGRD(JOB,IDISP,LABEL,STYPE,ISYMP,NTEMP,WORK(N_OVRGRDA))
*
* KAPPA...
*
      LABEL ='KAPPA   '
      CALL GETMEM('KAPPA','ALLO','REAL',N_KAPPA,NTEMP)
      CALL RDMGRD(JOB,IDISP,LABEL,STYPE,ISYMP,NTEMP,WORK(N_KAPPA))
*
* CI VECTORS...
*
      LABEL ='CI      '
      CALL GETMEM('DCIVEC','ALLO','REAL',N_DCIVEC,NCONF1)
      CALL RDMCCI(JOB,IDISP,LABEL,ISYMP,NCONF1,WORK(N_DCIVEC))
*
* Compute NACs w.r.t. the IDISP displacement derivative
*
      CALL GETMEM('XMATRIX','ALLO','REAL',N_XMAT,NTEMP)
* Summ up OVRGRDA AND KAPPA contribution in XMATRIX
*
      DO I = 1, NTEMP
         WORK(N_XMAT-1+I) = 0.5D0 *  WORK(N_OVRGRDA-1+I) +
     &        WORK(N_KAPPA-1+I)
      END DO
*
      IINT  = 1
      PSUM  = 0.0D0
      ITYPE = 2
      DO  ISY1 = 1, NSYM
         NB1=NBASF(ISY1)
         IF (NB1.NE.0) THEN
            DO ISY2= 1, ISY1
               I12=MUL(ISY1,ISY2)
C     IF(IAND(2**(I12-1),ISCHK).NE.0) THEN
               NB2=NBASF(ISY2)
               IF(NB2.NE.0) THEN
                  NB12=NB1*NB2
                  IF(ISY1.EQ.ISY2) NB12=(NB12+NB1)/2
                  IF(I12.EQ.ISY12) THEN
                     IPOS=IOFF(ISY1)+1+NSCR*(ITYPE-1)
                     PSUM=PSUM+
     &               DDOT_(NB12,WORK(N_XMAT-1+IINT),1,TDMZZ(IPOS),1)
* write(6,*)'ISY1, ISY2, PSUM',ISY1, ISY2, PSUM
                  END IF
                  IINT=IINT+NB12
               END IF
C     END IF
            END DO
         END IF
      END DO
* Compute CI contribution to NACs
      IF(IPGLOB.ge.DEBUG) THEN
      write(6,*)
      write(6,*)'PSUM, CIcon',PSUM,
     &  DDOT_(NCONF1, CISTATJ, 1, WORK(N_DCIVEC), 1)
      END IF
*      do ii=1,nconf1
*         write(6,*)CISTATJ(ii),WORK(N_DCIVEC+ii-1)
*      end do
      PSUM = PSUM + DDOT_(NCONF1, CISTATJ, 1, WORK(N_DCIVEC), 1)
      PROPVAL = PSUM
*
* Deallocate Vectors
*
      CALL GETMEM('XMATRIX','FREE','REAL',N_XMAT,    NTEMP)
      CALL GETMEM('DCIVEC', 'FREE','REAL',N_DCIVEC,  NCONF1)
      CALL GETMEM('KAPPA',  'FREE','REAL',N_KAPPA,   NTEMP)
      CALL GETMEM('OVRGRDA','FREE','REAL',N_OVRGRDA, NTEMP)
*
* Now you can leave...
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      integer function irAmax(n,a,inc)
c
c     Finds the index of element having max. absolute value.
c
c     Author:  F. Aquilante
c
      implicit real*8 (a-h,o-z)
      REAL*8 a(*)
      integer n,inc
c
      iramax = 0
      if( n.lt.1 .or. inc.le.0 )return
      iramax = 1
      if(n.eq.1)return
      if(inc.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = abs(a(1))
      ix = ix + inc
      do 10 i = 2,n
         if(abs(a(ix)).le.smax) go to 5
         iramax = i
         smax = abs(a(ix))
    5    ix = ix + inc
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = abs(a(1))
      do 30 i = 2,n
         if(abs(a(i)).le.smax) go to 30
         iramax = i
         smax = abs(a(i))
   30 continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Complex*16 Function trace( n, A, B )
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
!     size of the square matrices A(n,n) and B(n,n)
      Integer, intent(in)          :: n
      Complex(kind=8), intent(in) :: A(n,n), B(n,n)
      ! local variables
      Integer :: i, k

      trace=(0.0_wp,0.0_wp)
      Do i = 1, n
        Do k = 1, n
          trace = trace + A(i,k) * B(k,i)
        End Do
      End Do

      End Function trace



      Complex*16 Function trace2( n, A, B )
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
!     size of the square matrices A(n,n) and B(n,n)
      Integer, intent(in)          :: n
      Complex(kind=8), intent(in) :: A(n,n), B(n,n)
      ! local variables
      Integer :: i, k

      trace2=(0.0_wp,0.0_wp)
      Do i = 1, n
        Do k = 1, n
          trace2 = trace2 + A(k,i) * B(i,k)
        End Do
      End Do

      End Function trace2


      Real*8 Function real_1_trace2( n, A )
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
!     size of the square matrices A(n,n)
      Integer, intent(in)          :: n
      Real(kind=8), intent(in)    :: A(n,n)
      ! local variables
      Integer :: i

      real_1_trace2=0.0_wp
      Do i = 1, n
        real_1_trace2 = real_1_trace2 + A(i,i)/dble(n)
      End Do

      End Function real_1_trace2


      Complex*16 Function complex_1_trace2( n, A )
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
!     size of the square matrices A(n,n)
      Integer, intent(in)          :: n
      Complex(kind=8), intent(in)    :: A(n,n)

      ! local variables
      Integer :: i
      Complex(kind=8) :: FACT

      complex_1_trace2=0.0_wp
      FACT=cmplx(dble(n),0.0_wp,wp)
      Do i = 1, n
        complex_1_trace2 = complex_1_trace2 + A(i,i)/FACT
      End Do

      End Function complex_1_trace2


      Complex*16 Function trace_exch( n1, n2, A, B )
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
!     size of the square matrices A(n1,n1,n2,n2) and B(n1,n1,n2,n2)
      Integer, intent(in)          :: n1, n2
      Complex(kind=8), intent(in) :: A(n1,n1,n2,n2), B(n1,n1,n2,n2)
      ! local variables
      Integer :: i1, i2, k1, k2
      Complex(kind=8) :: tr

      trace_exch=(0.0_wp,0.0_wp)
      tr=(0.0_wp,0.0_wp)
      Do i1 = 1, n1
        Do k1 = 1, n1
          Do i2 = 1, n2
            Do k2 = 1, n2
              tr = tr + A(i1,k1, i2,k2) * B( k1,i1, k2,i2)
            End Do
          End Do
        End Do
      End Do
      trace_exch=tr
      End Function trace_exch


      Complex*16 Function trace_exch2( n1, n2, A, O1, O2 )
      Implicit None
      Integer, parameter        :: wp=kind(0.d0)
!     size of the square matrices A(n1,n1,n2,n2) and B(n1,n1,n2,n2)
      Integer, intent(in)          :: n1, n2
      Complex(kind=8), intent(in) :: A(n1,n1,n2,n2)
      Complex(kind=8), intent(in) :: O1(n1,n1), O2(n2,n2)
      ! local variables
      Integer :: i1, i2, k1, k2
      Complex(kind=8) :: tr

      trace_exch2=(0.0_wp,0.0_wp)
      tr=(0.0_wp,0.0_wp)
      Do i1 = 1, n1
        Do k1 = 1, n1
          Do i2 = 1, n2
            Do k2 = 1, n2
              tr = tr + A(i1,k1, i2,k2) * O1(k1,i1)*O2(k2,i2)
            End Do
          End Do
        End Do
      End Do
      trace_exch2=tr
      End Function trace_exch2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine MnBrak2(ax,bx,cx,fa,fb,fc,f,q_a,q_b,dipole_a,dipole_b,r_a,r_b)

use Constants, only: Zero, One, Five, Half
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: ax, bx
real(kind=wp), intent(out) :: cx, fa, fb, fc
! External function f and its arguments
real(kind=wp), external :: f
real(kind=wp), intent(in) :: q_a, q_b, dipole_a, dipole_b, r_a, r_b
real(kind=wp) :: vx, fv, coefA, coefB
logical(kind=iwp) :: Def
real(kind=wp), parameter :: Lim = 100.0_wp, Ratio = Half*(One+sqrt(Five)), Thr = 1.0e-20_wp
logical(kind=iwp), parameter :: Absolute = .true.

fa = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,ax,Absolute)
fb = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,bx,Absolute)
if (fa < fb) then
  cx = ax
  ax = bx
  bx = cx
  fc = fa
  fa = fb
  fb = fc
end if
! three points such that b is between a and c,
! and f(a) > f(b) > f(c), stop when f(c) > f(b)
cx = bx+Ratio*(bx-ax)
fc = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,cx,Absolute)
do while (fc <= fb)
  write(u6,*) ax,bx,cx
  Def = .true.
  ! try a parabolic fitting
  coefA = (cx*(fb-fa)+bx*(fa-fc)+ax*(fc-fb))
  coefB = (cx**2*(fa-fb)+bx**2*(fc-fa)+ax**2*(fb-fc))
  ! only worth it if the points are not linear and
  ! if the 2nd derivative is positive
  if ((abs(coefA) > Thr) .and. (coefA*(ax-cx) > Zero)) then
    vx = -Half*coefB/coefA
    ! v is between b and c
    if ((cx-vx)*(vx-bx) > Zero) then
      fv = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,vx,Absolute)
      ! minimum between b and c
      if (fv < fc) then
        ax = bx
        bx = vx
        fa = fb
        fb = fv
        return
        ! minimum between a and v
      else if (fv > fb) then
        cx = vx
        fc = fv
        return
      end if
      ! v is beyond c, but within limits
    else if ((bx+Lim*(cx-bx)-vx)*(vx-cx) > Zero) then
      fv = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,vx,Absolute)
      ! whatever happens, replace c,v -> b,c
      bx = cx
      cx = vx
      fb = fc
      fc = fv
      ! minimum between b and v
      if (fv > fc) then
        ax = bx
        fa = fb
        return
      end if
      ! v is beyond the limit, cutoff to the limit
    else if ((vx-cx)*(cx-bx) > Zero) then
      fv = bx+Lim*(cx-bx)
      Def = .false.
    end if
  end if
  ! unless the fit went beyond limits, use default step
  if (Def) then
    vx = cx+Ratio*(cx-bx)
    fv = f(q_a,q_b,dipole_a,dipole_b,r_a,r_b,vx,Absolute)
  end if
  ax = bx
  bx = cx
  cx = vx
  fa = fb
  fb = fc
  fc = fv
end do

end subroutine MnBrak2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine BMtrx_User_Defined(
     &                 nLines,nBVec,ipBMx,nAtom,nInter,
     &                 ip_rInt,Lbl,Coor,nDim,dMass,
     &                 Name,Smmtrc,
     &                 Degen,BSet,HSet,nIter,ip_drInt,
     &                 Gx,Cx,mTtAtm,iAnr,
     &                 nStab,jStab,Numerical,
     &                 HWRS,Analytic_Hessian,
     &                 iOptC,PrQ,mxdc,iCoSet,lOld,
     &                 nFix,mTR,ip_KtB,nQQ,Redundant,nqInt,MaxItr)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
      Real*8 Coor(3,nAtom), dMass(nAtom), Degen(3*nAtom),
     &       Gx(3*nAtom,nIter), Cx(3*nAtom,nIter)
      Character Lbl(nInter)*8, Name(nAtom)*(LENIN)
      Integer   iAnr(nAtom),
     &          nStab(nAtom), jStab(0:7,nAtom), iCoSet(0:7,nAtom)
      Logical Smmtrc(3*nAtom), BSet, HSet, Redundant,
     &        Numerical, HWRS, Analytic_Hessian, PrQ, lOld
*                                                                      *
************************************************************************
*                                                                      *
      iRout=133
      iPrint=nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*.... Section for user defined internal coordinates
*
      Call Rd_UDIC(nLines,iInt,nFix,nRowH)
      nQQ=iInt+nFix
*
      If (ip_rInt.eq.ip_Dummy) Then
         nqInt=nQQ*MaxItr
         Call GetMem(' qInt','Allo','Real',ip_rInt, nqInt)
         Call GetMem('dqInt','Allo','Real',ip_drInt,nqInt)
         Call FZero(Work(ip_rInt),nqInt)
         Call FZero(Work(ip_drInt),nqInt)
      End If
      Call Allocate_Work(ipBmx,3*nAtom*nQQ)
      Call FZero(Work(ipBMx),3*nAtom*nQQ)
      Call GetMem('rMult','Allo','Real',ipMult,nBVec)
      Call GetMem('BVec','Allo','Real',ipBVec,nBVec*3*nAtom)
      Call FZero(Work(ipBVec),nBVec*3*nAtom)
      Call GetMem('Val','Allo','Real',ipVal,nBVec)
      Call FZero(Work(ipVal),nBVec)
      Call GetMem('Lab','Allo','Char',ipLab,nBVec*8)
*
*-----Compute the B matrix in symmetry distinct basis and the
*     internal coordinates.
*
      ip = ip_rInt + (nIter-1)*nQQ
      Call DefInt(Work(ipBVec),nBVec,cWork(ipLab),Work(ipBMx),nQQ,
     &            nAtom,nLines,Work(ipVal),Work(ip),Lbl,Name,
     &            Coor,dMass,jStab,nStab,mxdc,Work(ipMult),
     &            nDim-mTR,Redundant)
*
      Call GetMem('Lab','Free','Char',ipLab,nBVec*8)
      Call GetMem('Val','Free','Real',ipVal,nBVec)
      Call GetMem('BVec','Free','Real',ipBVec,nBVec*3*nAtom)
      Call GetMem('rMult','Free','Real',ipMult,nBVec)
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the gradient
*
      If (BSet) Call Force(nFix,Gx(1,nIter),nAtom,nQQ,Work(ipBMx),
     &                     Name,nIter,Work(ip_drInt),Lbl,Degen)
*                                                                      *
************************************************************************
*                                                                      *
      If (HSet.and..NOT.lOld.and.BSet) Then
         Call Allocate_Work(ip_KtB,nDim*nQQ)
*
         Call Allocate_Work(ipDegen,nDim)
         i=0
         Do ix = 1, 3*nAtom
            If (Smmtrc(ix)) Then
               Work(ipDegen+i) = Degen(ix)
               i = i + 1
            End If
         End Do
*
         Do j = 1, nQQ
            i = 0
            Do ix = 1, 3*nAtom
               If (Smmtrc(ix)) Then
                  i = i + 1
                  ij = (j-1)*nDim + i - 1 + ip_KtB
                  ixj= (j-1)*3*nAtom + ix - 1 + ipBmx
                  Work(ij) = Work(ixj)
               End If
            End Do
         End Do
*
         Do iInter = 1, nQQ
            Do iDim = 1, nDim
               ij = (iInter-1)*nDim + iDim - 1 + ip_KtB
*              Work(ij) = Work(ij) / Sqrt(Work(ipDegen+iDim-1))
               Work(ij) = Work(ij) / Work(ipDegen+iDim-1)
            End Do
         End Do
         Call Free_Work(ipDegen)
      Else
         ip_KtB = ip_Dummy
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Cx)
         Call Unused_integer(mTtAtm)
         Call Unused_integer_array(iAnr)
         Call Unused_logical(Numerical)
         Call Unused_logical(HWRS)
         Call Unused_logical(Analytic_Hessian)
         Call Unused_integer(iOptC)
         Call Unused_logical(PrQ)
         Call Unused_integer_array(iCoSet)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine fx_evb1_cvb(fx,fast,orbstry,cvbtry,
     >   civec,civbh,civbs,civb,
     >   gjorb,gjorb2,gjorb3,cvbdet)
      implicit real*8 (a-h,o-z)
      logical fast
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "formats_cvb.fh"
#include "fx_cvb.fh"
      dimension orbstry(norb,norb),cvbtry(nvb)
      dimension civec(ndet),civbh(ndet),civbs(ndet),civb(ndet)
      dimension gjorb(*),gjorb2(*),gjorb3(*)
      dimension cvbdet(ndetvb)

      call str2vbc_cvb(cvbtry,cvbdet)
      if(fast)then
        call makecivb_cvb(civec,civb,cvbdet,orbstry,cvbtry,1)
        call gaussj_cvb(orbstry,gjorb)
        call applyt_cvb(civb,gjorb)
        call proj_cvb(civb)
        call cinorm_cvb(civb,ovraa_try)
        call cicopy_cvb(civb,civbh)
        call applyh_cvb(civbh)
        call cidot_cvb(civb,civbh,ww_try)
      else
        call makecivb_cvb(civec,civb,cvbdet,orbstry,cvbtry,0)
        call vb2cic_cvb(cvbdet,civbs)
        call vb2cic_cvb(cvbdet,civbh)
        call makecivbhs_cvb(civbh,civbs,orbstry,gjorb,gjorb2,gjorb3)

        call pvbdot_cvb(civb,civbs,ovraa_try)
        call pvbdot_cvb(civb,civbh,ww_try)
      endif
      evb=ww_try/ovraa_try+corenrg
      fx=evb
      if(fast.and.ip(3).ge.2)
     >  write(6,formE)' Evb :      ',evb
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine xflush(Lu)
**********************************************************************
*                                                                    *
*   purpose:                                                         *
*   Dump buffers                                                     *
*                                                                    *
*   calling arguments:                                               *
*   Lu      : integer                                                *
*             Logical unit number                                    *
*                                                                    *
*--------------------------------------------------------------------*
*                                                                    *
*   written by:                                                      *
*   M.P. Fuelscher                                                   *
*   University of Lund, Sweden, 1996                                 *
*                                                                    *
*--------------------------------------------------------------------*
*                                                                    *
*   history: none                                                    *
*                                                                    *
**********************************************************************

#if   defined(_CRAY_C90_)
      If (Lu.EQ.6) then
         Call Flush(101)
      else
         Call Flush(Lu)
      End If
#elif defined(__INTEL_COMPILER) || defined(NAGFOR)
       Return
       If (.False.) Call Unused_integer(Lu)
#elif defined(_SOLARIS_) || defined(_IRIX64_) || defined(_HP_UX_)
      Call Flush(Lu)
#elif defined(_PRIMEPOWER_) || defined(_LINUX_)
      Call Flush(Lu)
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OEISG(REL,SREL,TREL,UREL,ZETA,ZN,NSYM,NBAS1,unrel,tnrel,hcorr,iprint,VEXTT,PVPT,EVN1,RE1R,AUXI,W1W1,iScratch,ScratchZ, &
                 ScratchSQ,Scratch)

use Constants, only: One, Two, Eight, Half, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NSYM, NBAS1, iprint
real(kind=wp), intent(out) :: REL(nBAS1*(nBAS1+1)/2), SREL(nBAS1*(nBAS1+1)/2), TREL(nBAS1*(nBAS1+1)/2), UREL(nBAS1*(nBAS1+1)/2), &
                              unrel(nBAS1*(nBAS1+1)/2), tnrel(nBAS1*(nBAS1+1)/2), hcorr(nBAS1*(nBAS1+1)/2), VEXTT(*), PVPT(*), &
                              EVN1(NBAS1,NBAS1), RE1R(NBAS1,NBAS1), AUXI(NBAS1,NBAS1), W1W1(NBAS1,NBAS1), &
                              ScratchZ(nBAS1*(nBAS1+1)/2,3), ScratchSQ(NBAS1*NBAS1,5), Scratch(NBAS1,5)
integer(kind=iwp), intent(out) :: iScratch(NBAS1*(NBAS1+1)/2)
real(kind=wp), intent(in) :: ZETA(nBAS1), ZN
integer(kind=iwp) :: I, I1, I2, I3, IJ, IM1, iparm, J, J1, J2, J3, L, NBSZ, np, NPQ, NPQ1, NPQ2, NQ
real(kind=wp) :: facto(16), TERM1, TERM2, VP, VPQ, VPQ1, VPQM2, VPQP2, VQ, W_P, WQ, ZP, ZPQ, ZQ
real(kind=wp), parameter :: SQRT8PI = sqrt(Eight/Pi)
real(kind=wp), external :: EXTC

! ONE CONFIGURATION
! ONE ELECTRON INTEGRAL PROGRAM
! COMPUTES THE MATRICES S,U,T WITH SLATER (NFLAG1=0) OR GAUSSIAN
!  (NFLAG1=1) ORBITALS AS  BASIS

! initialize
call RELOP()
! coefficients
FACTO(1) = One
FACTO(2) = One
do I=3,16
  IM1 = I-1
  FACTO(I) = IM1*FACTO(I-2)
end do
iparm = 2
!write(u6,*) ' MX100=',MX100
!write(u6,*) ' nsym',nsym
if (iprint >= 10) then
  write(u6,*) ' symmetry',nsym
  write(u6,*) ' number of basis functions',nbas1
  write(u6,*) ' charge',zn
  do i=1,nbas1
    write(u6,*) zeta(i)
  end do
end if
L = NSYM

IJ = 0
np = L
NQ = NP
do I=1,NBAS1
  ZP = ZETA(I)
  W_P = Two*(NP-L)/ZP
  do J=1,I
    IJ = IJ+1
    ZQ = ZETA(J)
    ZPQ = Half*(ZP+ZQ)
    NPQ = NP+NQ+1
    WQ = Two*(NQ-L)/ZQ
    NPQ1 = NPQ-1
    NPQ2 = NPQ-2
    VPQ = FACTO(NPQ1)/ZPQ**(Half*NPQ)
    VP = FACTO(2*NP)/ZP**(NP+Half)
    VQ = FACTO(2*NQ)/ZQ**(NQ+Half)
    if (NPQ1 > 2) then
      VPQM2 = FACTO(NPQ2-1)/ZPQ**(Half*NPQ2)
    else
      VPQM2 = One
    end if
    VPQ1 = FACTO(NPQ2)*SQRT8PI/ZPQ**(Half*NPQ1)
    VPQP2 = FACTO(NPQ+1)/ZPQ**(Half*(NPQ+2))
    TERM2 = VPQP2-VPQ*(W_P+WQ)+W_P*WQ*VPQM2
    TERM1 = One/sqrt(VP*VQ)
    SREL(IJ) = TERM1*VPQ
    UREL(IJ) = TERM1*VPQ1
    UNREL(IJ) = TERM1*VPQ1
    TNREL(IJ) = Half*ZP*ZQ*TERM1*TERM2
    !TNRE = Half*ZP*ZQ*TERM1*TERM2
    if (IPARM > 0) then
      I1 = np-1
      I2 = 0
      I3 = 0
      J1 = nq-1
      J2 = 0
      J3 = 0

      if (np == 3) then
        ! PVP FOR XY-FUNCTIONS

        REL(IJ) = EXTC(L,ZP,ZQ,1,1,0,1,1,0)

      else if (np == 4) then
        ! PVP FOR XYZ-FUNCTIONS

        REL(IJ) = EXTC(L,ZP,ZQ,1,1,1,1,1,1)

      else
        ! PVP FOR X**(NP-1)-FUNCTIONS

        REL(IJ) = EXTC(L,ZP,ZQ,I1,I2,I3,J1,J2,J3)

      end if

      !TREL(IJ) = SQROPY(ZP,ZQ,I1,I2,I3,J1,J2,J3)
      TREL(IJ) = Half*ZP*ZQ*TERM1*TERM2
    else
      TREL(IJ) = Half*ZP*ZQ*TERM1*TERM2
      !TNRE = Half*ZP*ZQ*TERM1*TERM2
    end if
  end do
end do

! CONVERT TO RELATIVISTIC INTEGRALS

NBSZ = NBAS1*(NBAS1+1)/2
!  OVERLAP  POTENTIAL  KIN.ENERGY  PVP  MULT  BU  P  G  EIG  SINV  REVT  AUX  OVE  EW  E  AA  RR  TT
call AT34R(NBAS1,NBSZ,ZN,SREL,UREL,TREL,REL,iScratch,ScratchZ(:,1),ScratchZ(:,1),ScratchZ(:,3),ScratchSQ(:,1),ScratchSQ(:,2), &
           ScratchSQ(:,3),ScratchSQ(:,4),ScratchSQ(:,5),Scratch(:,1),Scratch(:,2),Scratch(:,3),Scratch(:,4),Scratch(:,5),iprint, &
           VEXTT,PVPT,EVN1,RE1R,AUXI,W1W1)

! TRANSFER RELATIVISTIC KINETIC ENERGY AND POTENTIAL INTEGRALS

if (iprint >= 10) then
  write(u6,*) ' matrices'
  write(u6,*) l,nbas1
  write(u6,*) ' srel'
  write(u6,12) (srel(j),j=1,(nbas1*(nbas1+1))/2)
  write(u6,*) ' trel'
  write(u6,12) (trel(j),j=1,(nbas1*(nbas1+1))/2)
  write(u6,*) ' urel'
  write(u6,12) (urel(j),j=1,(nbas1*(nbas1+1))/2)
  write(u6,*) ' tnrel'
  write(u6,12) (tnrel(j),j=1,(nbas1*(nbas1+1))/2)
  write(u6,*) ' unrel'
  write(u6,12) (unrel(j),j=1,(nbas1*(nbas1+1))/2)
  write(u6,*) ' rel'
  write(u6,12) (rel(j),j=1,(nbas1*(nbas1+1))/2)
end if
ij = 0
do i=1,nbas1
  do j=1,i
    ij = ij+1
    hcorr(ij) = (trel(ij)-zn*urel(ij))-(tnrel(ij)-zn*unrel(ij))
    trel(ij) = trel(ij)-tnrel(ij)
    urel(ij) = -(zn*urel(ij)-zn*unrel(ij))
  end do
end do
if (iprint >= 20) then
  write(u6,*) ' full correction metrix'
  write(u6,*) l,nbas1
  write(u6,12) (hcorr(j),j=1,(nbas1*(nbas1+1))/2)
end if

return

12 format(4f18.14)

end subroutine OEISG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MKMAW_CP2(IDOWN,IDAW,IUP,IRAW,IMAW,LTV)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "pt2_guga.fh"
      DIMENSION IDOWN(NVERT,0:3),IDAW(NVERT,0:4)
      DIMENSION IUP(NVERT,0:3),IRAW(NVERT,0:4)
      DIMENSION IMAW(NVERT,0:3),LTV(-1:NLEV)

C BEGIN BY CONSTRUCTING THE UPCHAIN TABLE IUP:
      DO 10 IV=1,NVERT
        DO 11 IC=0,3
          IUP(IV,IC)=0
  11    CONTINUE
  10  CONTINUE
      DO 30 IU=1,NVERT-1
        DO 20 IC=0,3
          IDWN=IDOWN(IU,IC)
          IF(IDWN.EQ.0) GOTO 20
          IUP(IDWN,IC)=IU
  20    CONTINUE
  30  CONTINUE
#ifdef _DEBUGPRINT_
        WRITE(6,*)
        WRITE(6,*)' THE UPCHAIN TABLE IN MKMAW:'
        DO 40 IV=1,NVERT
          WRITE(6,1010) IV,(IUP(IV,IC),IC=0,3)
  40    CONTINUE
        WRITE(6,*)
#endif

C USE UPCHAIN TABLE TO CALCULATE THE REVERSE ARC WEIGHT TABLE:
      DO 110 IC=0,3
        IRAW(1,IC)=0
  110 CONTINUE
      IRAW(1,4)=1
      DO 130 IV=2,NVERT
        ISUM=0
        DO 120 IC=0,3
          IRAW(IV,IC)=0
          IU=IUP(IV,IC)
          IF(IU.EQ.0) GOTO 120
          IRAW(IV,IC)=ISUM
          ISUM=ISUM+IRAW(IU,4)
  120   CONTINUE
        IRAW(IV,4)=ISUM
  130 CONTINUE
#ifdef _DEBUGPRINT_
        WRITE(6,*)
        WRITE(6,*)' THE REVERSE ARC WEIGHT TABLE IN MKMAW:'
        DO 140 IV=1,NVERT
          WRITE(6,1010) IV,(IRAW(IV,IC),IC=0,4)
  140   CONTINUE
        WRITE(6,*)
#endif
C USE IDAW,IRAW TABLES TO DETERMINE MIDLEV.
C ASSUMPTION IS THAT A BALANCED NUMBER OF UPPER/LOWER WALKS
C IS THE BEST CHOICE.
      MIDLEV=1
      MINW=1000000
      DO 160 IL=1,NLEV-1
        NW=0
        DO 150 IV=LTV(IL),LTV(IL-1)-1
          NW=NW+IRAW(IV,4)-IDAW(IV,4)
 150    CONTINUE
        NW=ABS(NW)
        IF(NW.GE.MINW) GOTO 160
        MIDLEV=IL
        MINW=NW
 160  CONTINUE
      MIDV1=LTV(MIDLEV)
      MIDV2=LTV(MIDLEV-1)-1
      NMIDV=1+MIDV2-MIDV1
C COPY LOWER PART OF DIRECT ARC WEIGHT TABLE INTO IMAW:
      DO 210 IV=MIDV1,NVERT
        DO 211 IC=0,3
          IMAW(IV,IC)=IDAW(IV,IC)
  211   CONTINUE
  210 CONTINUE
C COPY UPPER PART OF REVERSE ARC WEIGHT TABLE INTO IMAW. HOWEVER,
C    NOTE THAT THE IMAW TABLE IS ACCESSED BY THE UPPER VERTEX.
      DO 230 IU=1,MIDV1-1
        DO 220 IC=0,3
          ID=IDOWN(IU,IC)
          IMAW(IU,IC)=0
          IF(ID.NE.0) IMAW(IU,IC)=IRAW(ID,IC)
  220   CONTINUE
  230 CONTINUE
C FINALLY, ADD AN OFFSET TO ARCS LEADING TO MIDLEVELS:
      ISUM=1
      DO 250 IV=MIDV1,MIDV2
        DO 240 IC=0,3
          IU=IUP(IV,IC)
          IF(IU.EQ.0) GOTO 240
          IMAW(IU,IC)=ISUM+IMAW(IU,IC)
 240    CONTINUE
        ISUM=ISUM+IRAW(IV,4)
 250  CONTINUE
      DO 270 IV=MIDV1,MIDV2
        DO 260 IC=0,3
          IF(IDOWN(IV,IC).EQ.0) GOTO 260
          IMAW(IV,IC)=ISUM+IMAW(IV,IC)
 260    CONTINUE
        ISUM=ISUM+IDAW(IV,4)
 270  CONTINUE
#ifdef _DEBUGPRINT_
 1010 FORMAT(1X,I4,5X,5(1X,I6))
        WRITE(6,*)
        WRITE(6,*)' THE MODIFIED ARC WEIGHT TABLE IN MKMAW:'
        DO 280 IV=1,NVERT
          WRITE(6,1010) IV,(IMAW(IV,IC),IC=0,3)
  280   CONTINUE
        WRITE(6,*)
#endif
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

program JOB2ASC
! SVC 20071004
! convert JOBIPH to a formatted file FMTIPH
! with some additional explanation.

use rasscf_global, only: BName, Header, IADR15, iPT2, iRoot, lRoots, NACPAR, NACPR2, NORBT, nRoots, NTOT3, PotNuc, Title, Weight
use general_data, only: ispin, jobiph, nactel, nash, nbas, nconf, ndel, ndel, nelec3, nfro, nhole1, nish, norb, nrs1, nrs2, nrs3, &
                        nsym, ntot, ntot2
use Molcas, only: LenIn, MxOrb, MxRoot, MxSym
use RASDim, only: MxIter, MxTit
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: FMTIPH, I, IAD15, ISYM, LSYM, NASHT, NFOCK, nHeader, nName, nTitle
logical(kind=iwp) :: Found
real(kind=wp), allocatable :: ADR1(:), ADR2(:), ADR(:)
integer(kind=iwp), external :: isFreeUnit

call IniMem()
call Init_LinAlg()
call PrgmInit('Job2Asc')

call f_inquire('JOBIPH',Found)
if (.not. Found) then
  call WarningMessage(2,'JOBIPH not found')
  stop
end if

JOBIPH = isFreeUnit(15)
call DANAME(JOBIPH,'JOBIPH')

FMTIPH = isFreeUnit(JOBIPH+1)
call MOLCAS_OPEN(FMTIPH,'FMTIPH')

IAD15 = 0
call IDAFILE(JOBIPH,2,IADR15,30,IAD15)
write(FMTIPH,*) 'print out of IADR15: '
write(FMTIPH,'(15I10)') IADR15(1:30)

nName = (LenIn+8)*mxOrb
nHeader = 144
nTitle = 4*18*mxTit

IAD15 = IADR15(1)
call WR_RASSCF_Info(JOBIPH,2,IAD15,NACTEL,ISPIN,NSYM,LSYM,NFRO,NISH,NASH,NDEL,NBAS,MxSym,BName,nName,NCONF,HEADER,nHeader,TITLE, &
                    nTitle,POTNUC,LROOTS,NROOTS,IROOT,MxRoot,NRS1,NRS2,NRS3,NHOLE1,NELEC3,IPT2,WEIGHT)

write(FMTIPH,*) 'number of active electrons'
write(FMTIPH,100) nActEl
write(FMTIPH,*) 'spin of the wave function'
write(FMTIPH,100) iSpin
write(FMTIPH,*) 'number of irreps'
write(FMTIPH,100) nSym
write(FMTIPH,*) 'irrep of the wave function'
write(FMTIPH,100) lSym
write(FMTIPH,*) 'number of frozen orbitals'
write(FMTIPH,200) nFro(1:MxSym)
write(FMTIPH,*) 'number of inactive orbitals'
write(FMTIPH,200) nISh(1:MxSym)
write(FMTIPH,*) 'number of active orbitals'
write(FMTIPH,200) nASh(1:MxSym)
write(FMTIPH,*) 'number of deleted orbitals'
write(FMTIPH,200) nDel(1:MxSym)
write(FMTIPH,*) 'number of basis functions'
write(FMTIPH,200) nBas(1:MxSym)
write(FMTIPH,*) 'number of configurations'
write(FMTIPH,100) nConf
write(FMTIPH,*) 'Header'
write(FMTIPH,'(36A)') Header(1:72)
write(FMTIPH,*) 'Title'
write(FMTIPH,'(80A)') Title(1:9)
write(FMTIPH,*) 'nuclear potential energy'
write(FMTIPH,400) PotNuc
write(FMTIPH,*) 'number of roots in the small CI'
write(FMTIPH,100) lRoots
write(FMTIPH,*) 'number of roots in the averaging'
write(FMTIPH,100) nRoots
write(FMTIPH,*) 'rootnumbers'
write(FMTIPH,200) iRoot(1:MxRoot)
write(FMTIPH,*) 'number of RAS1 orbitals'
write(FMTIPH,200) nRS1(1:MxSym)
write(FMTIPH,*) 'number of RAS2 orbitals'
write(FMTIPH,200) nRS2(1:MxSym)
write(FMTIPH,*) 'number of RAS3 orbitals'
write(FMTIPH,200) nRS3(1:MxSym)
write(FMTIPH,*) 'max number of holes in RAS1'
write(FMTIPH,100) nHole1
write(FMTIPH,*) 'max number of electrons in RAS3'
write(FMTIPH,100) nElec3
write(FMTIPH,*) 'iPT2'
write(FMTIPH,100) iPT2
write(FMTIPH,*) 'weight of the roots in the averaging'
write(FMTIPH,500) Weight(1:MxRoot)

NTOT = 0
NTOT2 = 0
NASHT = 0
NTOT3 = 0
NFOCK = 0
do ISYM=1,NSYM
  NTOT = NTOT+nBas(ISYM)
  NTOT2 = NTOT2+nBas(ISYM)**2
  NASHT = NASHT+nASh(ISYM)
  nOrb(iSym) = nBas(iSym)-nFro(iSym)-nDel(iSym)
  NTOT3 = NTOT3+nOrb(iSym)*(nOrb(iSym)+1)/2
  NFOCK = NFOCK+(nISh(ISYM)+nASh(ISYM))**2
end do
NACPAR = NASHT*(NASHT+1)/2
NACPR2 = NACPAR*(NACPAR+1)/2

write(FMTIPH,*) 'basis function labels and type'
write(FMTIPH,300) BName(1:NTOT)

IAD15 = IADR15(2)
call mma_allocate(ADR1,NTOT2,Label='ADR1')
call mma_allocate(ADR2,NTOT,Label='ADR2')
call DDAFILE(JOBIPH,2,ADR1,NTOT2,IAD15)
call DDAFILE(JOBIPH,2,ADR2,NTOT,IAD15)
write(FMTIPH,*) 'average orbitals'
write(FMTIPH,*) 'MO coefficients'
write(FMTIPH,*) 'length = ',NTOT2
write(FMTIPH,500) ADR1(:)
write(FMTIPH,*) 'occupation numbers'
write(FMTIPH,*) 'length = ',NTOT
write(FMTIPH,500) ADR2(:)
call mma_deallocate(ADR1)
call mma_deallocate(ADR2)

IAD15 = IADR15(3)
call mma_allocate(ADR1,NACPAR,Label='ADR1')
call mma_allocate(ADR2,NACPR2,Label='ADR2')
write(FMTIPH,*) 'density matrices for the active orbitals'
do I=1,LROOTS
  write(FMTIPH,*) 'root = ',I
  write(FMTIPH,*) 'D  : one-body density matrix'
  write(FMTIPH,*) 'length = ',NACPAR
  call DDafIle(JOBIPH,2,ADR1,NACPAR,IAD15)
  write(FMTIPH,500) ADR1(:)
  write(FMTIPH,*) 'DS : spin density matrix'
  write(FMTIPH,*) 'length = ',NACPAR
  call DDafIle(JOBIPH,2,ADR1,NACPAR,IAD15)
  write(FMTIPH,500) ADR1(:)
  write(FMTIPH,*) 'P  : symmetric two-body density matrix'
  write(FMTIPH,*) 'length = ',NACPR2
  call DDafIle(JOBIPH,2,ADR2,NACPR2,IAD15)
  write(FMTIPH,500) ADR2(:)
  write(FMTIPH,*) 'PA : antisymmetric two-body density matrix'
  write(FMTIPH,*) 'length = ',NACPR2
  call DDafIle(JOBIPH,2,ADR2,NACPR2,IAD15)
  write(FMTIPH,500) ADR2(:)
end do
call mma_deallocate(ADR1)
call mma_deallocate(ADR2)

IAD15 = IADR15(4)
call mma_allocate(ADR,NCONF,Label='ADR')
write(FMTIPH,*) 'CI coefficients'
do I=1,LROOTS
  write(FMTIPH,*) 'root = ',I
  write(FMTIPH,*) 'length = ',NCONF
  call DDafIle(JOBIPH,2,ADR,NCONF,IAD15)
  write(FMTIPH,500) ADR(:)
end do
call mma_deallocate(ADR)

IAD15 = IADR15(5)
call mma_allocate(ADR,NFOCK,Label='ADR')
call DDAFILE(JOBIPH,2,ADR,NFOCK,IAD15)
write(FMTIPH,*) 'Fock matrix for the occupied orbitals'
write(FMTIPH,*) 'length = ',NFOCK
write(FMTIPH,500) ADR(:)
call mma_deallocate(ADR)

IAD15 = IADR15(6)
call mma_allocate(ADR,mxRoot*mxIter,Label='ADR')
call DDAFILE(JOBIPH,2,ADR,mxRoot*mxIter,IAD15)
write(FMTIPH,*) 'energies from array ENER(mxRoot,mxIter)'
write(FMTIPH,*) 'length = ',mxRoot*mxIter
write(FMTIPH,500) ADR(:)
call mma_deallocate(ADR)

IAD15 = IADR15(7)
call mma_allocate(ADR,6*mxIter,Label='ADR')
call DDAFILE(JOBIPH,2,ADR,6*mxIter,IAD15)
write(FMTIPH,*) 'convergence parameters from array CONV(6,mxIter)'
write(FMTIPH,*) 'length = ',6*mxIter
write(FMTIPH,510) ADR(:)
call mma_deallocate(ADR)

IAD15 = IADR15(9)
call mma_allocate(ADR,NTOT2,Label='ADR')
call DDAFILE(JOBIPH,2,ADR,NTOT2,IAD15)
write(FMTIPH,*) 'final canonical MOs written in FCKPT2'
write(FMTIPH,*) 'length = ',NTOT2
write(FMTIPH,500) ADR(:)
call mma_deallocate(ADR)

IAD15 = IADR15(10)
call mma_allocate(ADR,NTOT3,Label='ADR')
call DDAFILE(JOBIPH,2,ADR,NTOT3,IAD15)
write(FMTIPH,*) 'inactive Fock matrix FI for CASPT2 in MO basis'
write(FMTIPH,*) 'length = ',NTOT3
write(FMTIPH,500) ADR(:)
call DDAFILE(JOBIPH,2,ADR,NTOT3,IAD15)
write(FMTIPH,*) 'CASPT2 Fock matrix FP'
write(FMTIPH,*) 'length = ',NTOT3
write(FMTIPH,500) ADR(:)
call mma_deallocate(ADR)

IAD15 = IADR15(11)
call mma_allocate(ADR,NORBT,Label='ADR')
call DDAFILE(JOBIPH,2,ADR,NORBT,IAD15)
write(FMTIPH,*) 'diagonal of the CASPT2 Fock matrix FP'
write(FMTIPH,*) 'length = ',NORBT
write(FMTIPH,500) ADR(:)
call mma_deallocate(ADR)

IAD15 = IADR15(12)
call mma_allocate(ADR1,NTOT2,Label='ADR1')
call mma_allocate(ADR2,NTOT,Label='ADR2')
write(FMTIPH,*) 'natural orbitals for the final wave functions'
do I=1,LROOTS
  write(FMTIPH,*) 'root = ',I
  write(FMTIPH,*) 'MO coefficients'
  write(FMTIPH,*) 'length = ',NTOT2
  call DDAFILE(JOBIPH,2,ADR1,NTOT2,IAD15)
  write(FMTIPH,500) ADR1(:)
  write(FMTIPH,*) 'occupation numbers'
  write(FMTIPH,*) 'length = ',NTOT
  call DDAFILE(JOBIPH,2,ADR2,NTOT,IAD15)
  write(FMTIPH,500) ADR2(:)
end do
call mma_deallocate(ADR1)
call mma_deallocate(ADR2)

IAD15 = IADR15(14)
call mma_allocate(ADR1,NTOT2,Label='ADR1')
call mma_allocate(ADR2,NTOT,Label='ADR2')
write(FMTIPH,*) 'spin orbitals for the final wave functions'
do I=1,LROOTS
  write(FMTIPH,*) 'root = ',I
  write(FMTIPH,*) 'MO coefficients'
  write(FMTIPH,*) 'length = ',NTOT2
  call DDAFILE(JOBIPH,2,ADR1,NTOT2,IAD15)
  write(FMTIPH,500) ADR1(:)
  write(FMTIPH,*) 'occupation numbers'
  write(FMTIPH,*) 'length = ',NTOT
  call DDAFILE(JOBIPH,2,ADR2,NTOT,IAD15)
  write(FMTIPH,500) ADR2(:)
end do
call mma_deallocate(ADR1)
call mma_deallocate(ADR2)

IAD15 = IADR15(17)
call mma_allocate(ADR,LROOTS**2,Label='ADR')
write(FMTIPH,*) 'effective hamiltonian from MS-CASPT2'
write(FMTIPH,*) 'length = ',LROOTS**2
call DDAFILE(JOBIPH,2,ADR,LROOTS**2,IAD15)
write(FMTIPH,500) ADR(:)
call mma_deallocate(ADR)

call DACLOS(JOBIPH)
close(FMTIPH)

call GetMem('Finish','LIST','REAL',I,0)
call GetMem('Finish','TERM','REAL',I,0)

100 format(i10)
200 format(2x,10i10)
300 format(a)
400 format(es20.12)
500 format(2x,5es20.12)
510 format(2x,6es20.12)

end program JOB2ASC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine plot_MH_with_Exp(nH,H,nTempMagn,TempMagn,MHcalc,MHexp)

use Constants, only: Zero, Five, Six
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nH, nTempMagn
real(kind=wp), intent(in) :: H(nH), TempMagn(nTempMagn), MHcalc(nH,nTempMagn), MHexp(nH,nTempMagn)
integer(kind=iwp) :: file_number, file_size, iErr, ifilenumber, iH, iTempMagn, Length, LuData, LuPlt
real(kind=wp) :: gnuplot_version, hmax, hmin, MHmax, MHmax_calc, MHmax_exp, MHmin, MHmin_calc, MHmin_exp
logical(kind=iwp) :: file_exist, is_file_open, execute_gnuplot_cmd
character(len=1023) :: gnuplot_CMD, realname_dat, realname_eps, realname_plt, realname_png
character(len=300) :: cdummy, datafile, epsfile, imagefile, line1, line2, plotfile
integer(kind=iwp), external :: AixRm, IsFreeUnit

#include "macros.fh"

iErr = 0
hmin = Zero
hmax = Zero
MHmin_exp = Zero
MHmax_exp = Zero
MHmin_calc = Zero
MHmax_calc = Zero
MHmin = Zero
MHmax = Zero
hmin = minval(H(:))-0.05_wp*maxval(H(:))
hmax = maxval(H(:))+0.05_wp*maxval(H(:))
MHmin_exp = minval(MHexp)
MHmax_exp = maxval(MHexp)
MHmin_calc = minval(MHcalc)
MHmax_calc = maxval(MHcalc)
MHmin = min(MHmin_exp,MHmin_calc)-0.08_wp*max(MHmax_exp,MHmax_calc)
MHmax = max(MHmax_exp,MHmax_calc)+0.08_wp*max(MHmax_exp,MHmax_calc)

#ifdef _DEBUGPRINT_
write(u6,*) 'nH        = ',nH
write(u6,*) 'hmin      = ',hmin
write(u6,*) 'hmax      = ',hmax
write(u6,*) 'MHmin_exp = ',MHmin_exp
write(u6,*) 'MHmax_exp = ',MHmax_exp
write(u6,*) 'MHmin_calc= ',MHmin_calc
write(u6,*) 'MHmax_calc= ',MHmax_calc
write(u6,*) 'MHmin     = ',MHmin
write(u6,*) 'MHmax     = ',MHmax
do iH=1,nH
  write(u6,*) H(iH),(MHcalc(iH,iTempMagn),MHexp(iH,iTempMagn),iTempMagn=1,nTempMagn)
end do
#endif

! generate the GNUPLOT script in the $WorkDir
line1 = ' '
line2 = ' '
gnuplot_CMD = ' '
file_exist = .false.
is_file_open = .false.
file_size = 0
execute_gnuplot_cmd = .false.
gnuplot_version = Zero

! check if the file lineOUT exists
inquire(file='lineOUT',exist=file_exist,opened=is_file_open,number=file_number)

if (file_exist) then
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'file "lineOUT" exists in WorkDir'
# endif
  if (is_file_open) then
#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'file "lineOUT" is opened'
#   endif
    ! close the file:
    close(unit=file_number,status='DELETE')
  end if
  ! delete the file
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'deleting the file...'
# endif
  iErr = AixRm('lineOUT')
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
else
  write(u6,'(A)') 'file "lineOUT" does not exist in WorkDir'
# endif
end if

! find the gnuplot
#ifdef _DEBUGPRINT_
write(u6,'(A)') 'inquire which GNUPLOT'
#endif

call systemf('which gnuplot >> lineOUT',iErr)
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif

inquire(file='lineOUT',exist=file_exist,opened=is_file_open,number=file_number,size=file_size)

#ifdef _DEBUGPRINT_
write(u6,*) 'File_number =',file_number
write(u6,*) 'Is_file_open=',is_file_open
write(u6,*) 'File_exist  =',file_exist
write(u6,*) 'File_size   =',file_size
#endif

if (file_exist) then
  if (file_size > 0) then
#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'new file "lineOUT" exists in WorkDir'
#   endif

    file_number = IsFreeUnit(93)
    call molcas_open(file_number,'lineOUT')

    read(file_number,'(A)') line1

#   ifdef _DEBUGPRINT_
    write(u6,*) 'line1=',line1
    write(u6,*) trim(line1)
#   endif
    line2 = trim(line1)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'line2=',line2
#   endif

    close(file_number)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Closing lineOUT file'
#   endif
    execute_gnuplot_cmd = .true.
  else
    ! file_size =0
    write(u6,'(A)') 'file "lineOUT" has a size=0. gnuplot was not found on the system.'
    write(u6,'(A)') 'plots will not be created.'
  end if
else
  write(u6,'(A)') 'file "lineOUT" does not exist in WorkDir'
end if
! remove file "lineOUT"
iErr = AixRm('lineOUT')
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif
!-----------------------------------------------------------------------

! check the version of the gnuplot:
if (execute_gnuplot_cmd) then
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'inquire which version of GNUPLOT is installed'
# endif
  ! attempt to execute the script
  write(gnuplot_CMD,'(2A)') trim(line2),' --version > lineOUT'
# ifdef _DEBUGPRINT_
  write(u6,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
# endif
  call systemf(gnuplot_CMD,iErr)
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif
  file_number = IsFreeUnit(94)
  call molcas_open(file_number,'lineOUT')
  read(file_number,*) cdummy,gnuplot_version
  unused_var(cdummy)
# ifdef _DEBUGPRINT_
  write(u6,'(A,F4.1)') 'gnuplot_version = ',gnuplot_version
# endif
  if (abs(gnuplot_version) < 0.1_wp) execute_gnuplot_cmd = .false.
  close(file_number)
  ! remove file "lineOUT"
  iErr = AixRm('lineOUT')
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif
end if

!write(datafile,'(3A)') 'MH.dat'
!write(imagefile,'(3A)') 'MH.png'
!write(epsfile,'(3A)') 'MH.eps'
!write(plotfile ,'(3A)') 'MH.plt'
!call prgmtranslate(datafile,realname_dat,Length)
!call prgmtranslate(imagefile,realname_png,Length)
!call prgmtranslate(epsfile,realname_eps,Length)
!call prgmtranslate(plotfile,realname_plt,Length)
!#ifdef _DEBUGPRINT_
!write(u6,'(3A)') 'realname_dat=',trim(realname_dat)
!write(u6,'(3A)') 'realname_png=',trim(realname_png)
!write(u6,'(3A)') 'realname_eps=',trim(realname_eps)
!write(u6,'(3A)') 'realname_plt=',trim(realname_plt)
!#endif
!-----------------------------------------------------------------------
do iTempMagn=1,nTempMagn

  ! generate the file "MH.dat":
  write(datafile,'(A,I0,A)') 'MH_T_',iTempMagn,'.dat'
  write(imagefile,'(A,I0,A)') 'MH_T_',iTempMagn,'.png'
  write(epsfile,'(A,I0,A)') 'MH_T_',iTempMagn,'.eps'
  write(plotfile,'(A,I0,A)') 'MH_T_',iTempMagn,'.plt'
  call prgmtranslate(datafile,realname_dat,Length)
  call prgmtranslate(imagefile,realname_png,Length)
  call prgmtranslate(epsfile,realname_eps,Length)
  call prgmtranslate(plotfile,realname_plt,Length)

  inquire(file=datafile,exist=file_exist,opened=is_file_open,number=file_number)
  if (file_exist) iErr = AixRm(trim(datafile))
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif
  ifilenumber = 0
  ifilenumber = 95+iTempMagn
  LuData = IsFreeUnit(ifilenumber)
  call molcas_open(LuData,datafile)
# ifdef _DEBUGPRINT_
  write(u6,*) 'Opening "'//trim(datafile)//'" file. iTempMagn=',iTempMagn
  write(u6,*) 'Opening "'//trim(realname_dat)//'" file. iTempMagn=',iTempMagn
# endif
  do iH=1,nH
    write(LuData,'(3ES24.14)') H(iH),MHexp(iH,iTempMagn),MHcalc(iH,iTempMagn)
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) 'Writing into the "'//trim(datafile)//'" file. iTempMagn=',iTempMagn
  write(u6,*) 'Writing into the "'//trim(realname_dat)//'" file. iTempMagn=',iTempMagn
# endif
  close(LuData)
# ifdef _DEBUGPRINT_
  write(u6,*) 'Closing the "'//trim(datafile)//'" file. iTempMagn=',iTempMagn
  write(u6,*) 'Closing the "'//trim(realname_dat)//'" file. iTempMagn=',iTempMagn
  call xFlush(u6)
# endif

  ! generate the GNUPLOT script in the $WorkDir

  inquire(file=plotfile,exist=file_exist,opened=is_file_open,number=file_number)
  if (file_exist) iErr = AixRm(trim(plotfile))
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif
  ifilenumber = 0
  ifilenumber = 105+iTempMagn
  LuPlt = IsFreeUnit(ifilenumber)
  call molcas_open(LuPlt,plotfile)
# ifdef _DEBUGPRINT_
  write(u6,*) 'Opening "'//trim(plotfile)//'" file'
  write(u6,*) 'Opening "'//trim(realname_plt)//'" file'
# endif

  ! EPS or PNG images:

  if (gnuplot_version < Five) then
    !===  GNUPLOT VERSION 4 and below ==>>  generate EPS
    write(LuPlt,'(A)') 'set terminal postscript eps enhanced color  size 3.0, 2.0 font "arial, 10"'
    write(LuPlt,'(A)') 'set output "'//trim(realname_eps)//'" '
    write(LuPlt,'(A)') 'set grid'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# Axes'
    write(LuPlt,'(A)') '  set xlabel "Magnetic Field / tesla" font "Arial,14"'
    write(LuPlt,'(A)') '  set ylabel "M / {/Symbol m}_{B}" font "Arial,14"'
    write(LuPlt,'(A)')
    write(LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[',hmin,':',hmax,']'
    write(LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',MHmin,':',MHmax,']'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# Tics for axes'
    write(LuPlt,'(A)') '  set xtics nomirror'
    write(LuPlt,'(A)') '  set ytics nomirror'
    write(LuPlt,'(A)') '  set mxtics'
    write(LuPlt,'(A)') '  set mytics'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# Margins'
    write(LuPlt,'(A)') '  set bmargin at screen 0.20'
    write(LuPlt,'(A)') '  set lmargin at screen 0.15'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# legend'
    write(LuPlt,'(A)') '  set key right bottom'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# actual plotting'

    write(LuPlt,'(A,F7.3,A)') 'plot "'//trim(realname_dat)//'" using 1:2 with points  lt 1  lw 3 lc rgb "black"  title "Exp. T=', &
                              TempMagn(iTempMagn),' K.", \'
    write(LuPlt,'(A,F7.3,A)') '     "'//trim(realname_dat)//'" using 1:3 with lines   lt 1  lw 8 lc rgb "red"    title "Calc.T=', &
                              TempMagn(iTempMagn),' K."'
    write(LuPlt,'(A)')

  else if ((gnuplot_version >= Five) .and. (gnuplot_version < Six)) then
    !===  GNUPLOT VERSION 5 and above ==>>  generate PNG
    write(LuPlt,'(A)') 'set terminal pngcairo transparent enhanced font "arial,10" fontscale 4.0 size 1800, 1200'
    write(LuPlt,'(A)') 'set output "'//trim(realname_png)//'" '
    write(LuPlt,'(A)') 'set grid'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# Axes'
    write(LuPlt,'(A)') '  set xlabel "Magnetic Field / tesla" font "Arial,14"'
    write(LuPlt,'(A)') '  set ylabel "M / {/Symbol m}_{B}" font "Arial,14"'
    write(LuPlt,'(A)')
    write(LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[',hmin,':',hmax,']'
    write(LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',MHmin,':',MHmax,']'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# Tics for axes'
    write(LuPlt,'(A)') '  set xtics nomirror'
    write(LuPlt,'(A)') '  set ytics nomirror'
    write(LuPlt,'(A)') '  set mxtics'
    write(LuPlt,'(A)') '  set mytics'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# Margins'
    write(LuPlt,'(A)') '  set bmargin at screen 0.20'
    write(LuPlt,'(A)') '  set lmargin at screen 0.15'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# legend'
    write(LuPlt,'(A)') '  set key right bottom'
    write(LuPlt,'(A)')
    write(LuPlt,'(A)') '# actual plotting'

    write(LuPlt,'(A,F7.3,A)') 'plot "'//trim(realname_dat)//'" using 1:2 with circles lt 1  lw 3 lc rgb "black"  title "Exp. T=', &
                              TempMagn(iTempMagn),' K.", \'
    write(LuPlt,'(A,F7.3,A)') '     "'//trim(realname_dat)//'" using 1:3 with lines   lt 1  lw 8 lc rgb "red"    title "Calc.T=', &
                              TempMagn(iTempMagn),' K."'
    write(LuPlt,'(A)')
  else
    write(u6,*) 'GNUPLOT has version: ',gnuplot_version
    write(u6,*) 'This version of GNUPLOT is not known and thus, unsupported.'
    execute_gnuplot_cmd = .false.
  end if
  close(LuPlt)

  if (execute_gnuplot_cmd) then
    ! attempt to execute the script
#   ifdef _DEBUGPRINT_
    file_exist = .false.
    write(u6,*) trim(realname_plt)
    inquire(file=trim(realname_plt),exist=file_exist,opened=is_file_open,number=file_number)
    if (file_exist) then
      write(u6,'(A,i0,A)') 'File "'//trim(realname_plt)//'" exists.'
    else
      write(u6,'(A,i0,A)') 'File "'//trim(realname_plt)//'" does not exist.'
    end if
    file_exist = .false.
    write(u6,*) trim(realname_dat)
    inquire(file=trim(realname_dat),exist=file_exist,opened=is_file_open,number=file_number)
    if (file_exist) then
      write(u6,'(A,i0,A)') 'File "'//trim(realname_dat)//'" exists.'
    else
      write(u6,'(A,i0,A)') 'File "'//trim(realname_dat)//'" does not exist.'
    end if
#   endif

    write(gnuplot_CMD,'(5A)') trim(line2),' < ',trim(realname_plt)
#   ifdef _DEBUGPRINT_
    write(u6,'(A,A)') 'gnuplot_CMD=',trim(gnuplot_CMD)
#   endif

    call systemf(gnuplot_CMD,iErr)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'iErr = ',iErr
#   endif

    if (gnuplot_version < Five) then
      file_exist = .false.
      inquire(file=trim(realname_eps),exist=file_exist,opened=is_file_open,number=file_number)
      if (file_exist) then
        write(u6,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was created in Working directory.'
      else
        write(u6,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was NOT created in Working directory.'
      end if
    else
      file_exist = .false.
      inquire(file=trim(realname_png),exist=file_exist,opened=is_file_open,number=file_number)
      if (file_exist) then
        write(u6,'(A,i0,A)') 'File "'//trim(realname_png)//'" was created in Working directory.'
      else
        write(u6,'(A,i0,A)') 'File "'//trim(realname_png)//'" was NOT created in Working directory.'
      end if
    end if
  end if

end do ! iTempMagn

return

end subroutine plot_MH_with_Exp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Warnings(iCode,Warning,iLength)
      Implicit Real*8 (A-H,O-Z)
      Character*(*) Warning
*
* Binary codes:
*  1: Multiple minima found
*  2: Minima not within range
*  3: Ran out of iterations
*
      If (iLength .lt. 25) Then
         Write(6,*)
     &         'Length of warning string must be at least 25 characters'
         Call Abend()
      End If
*
      Do i = 1,iLength
         Warning(i:i) = ' '
      End Do
*
      If (iCode .eq. 1) Then
         Warning = 'Multiple minima found'
      Else If (iCode .eq. 2) Then
         Warning = 'Minima not within range'
      Else If (iCode .eq. 3) Then
         Warning = 'Ran out of iterations'
      Else If (iCode .eq. 4) Then
         Warning = 'No minima found'
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CD_AInv(A,n,AInV,Thr_CD)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(_IN_) :: A(n,n)
real(kind=wp), intent(out) :: AInv(n,n)
real(kind=wp), intent(in) :: Thr_CD
integer(kind=iwp) :: iDisk, Lu_A, Lu_Q, m
real(kind=wp), allocatable :: ADiag(:), QVec(:,:)
#ifdef _ACCURACY_
real(kind=wp), allocatable :: Tmp(:,:), Tmp2(:,:)
#endif
integer(kind=iwp), external :: IsFreeUnit

call mma_allocate(ADiag,n,Label='ADiag')

Lu_A = IsFreeUnit(77)
call DaName_MF_WA(Lu_A,'AMat09')

iDisk = 0
call dDaFile(Lu_A,1,A,n**2,iDisk)

!call RecPrt('A',' ',A,n,n)

Lu_Q = IsFreeUnit(78)
call DaName_MF_WA(Lu_Q,'QMat09')

call dcopy_(n,A,n+1,ADiag,1)

call CD_AInv_Inner(n,m,ADiag,Lu_A,Lu_Q,Thr_CD)

call mma_deallocate(ADiag)

call mma_allocate(QVec,n,m,Label='QVec')

iDisk = 0
call dDaFile(Lu_Q,2,QVec,n*m,iDisk)

!call RecPrt('QVec','(6G20.10)',QVec,n,m)
call DGEMM_('N','T',n,n,m,One,QVec,n,QVec,n,Zero,AInv,n)
!call RecPrt('AInv',' ',AInv,n,n)
call DaEras(Lu_Q)
call mma_deallocate(QVec)
!                                                                      *
!***********************************************************************
!                                                                      *
! Check the accuracy I-AA^1

#ifdef _ACCURACY_
call mma_allocate(Tmp,n,n,Label='Tmp')

Tmp(:,:) = Zero
! I
call dcopy_(n,[One],0,Tmp,n+1)
! I-AA^-1
call DGEMM_('N','N',n,n,n,-One,A,n,AInv,n,One,Tmp,n)
call RecPrt('I-AA^-1','(6G20.12)',Tmp,n,n)

call DGEMM_('N','N',n,n,n,One,A,n,AInv,n,Zero,Tmp,n)

call mma_allocate(Tmp2,n,n,Label='Tmp2')
Tmp2(:,:) = Zero
call dcopy_(n,[One],0,Tmp2,n+1)
call DGEMM_('N','N',n,n,n,-One,Tmp,n,Tmp,n,One,Tmp2,n)
call RecPrt('I-AA^-1AA^-1','(6G20.12)',Tmp2,n,n)

call mma_deallocate(Tmp2)
call mma_deallocate(Tmp)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine CD_AInv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,2002, Roland Lindh                                *
************************************************************************
      SubRoutine CmbnKE_GIAO(Rxyz,nZeta,la,lb,lr,Zeta,rKappa,Final,
     &                       nComp,nB,Txyz,Wxyz,A,RB,C)
************************************************************************
*                                                                      *
* Object: to compute the first derivative of the kinetic energy        *
*         integrals with respect to the magnetic field.                *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*                                                                      *
*     Modified for GIAO's by RL June 2002, Tokyo, Japan.               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Final(nZeta,nComp,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2,nB),
     &       Zeta(nZeta), rKappa(nZeta),
     &       Rxyz(nZeta,3,0:la+1,0:lb+1,0:lr+1),
     &       Txyz(nZeta,3,0:la  ,0:lb  ,0:lr+1),
     &       Wxyz(nZeta,3,0:la  ,0:lb  ,2),
     &       A(3), RB(3), RAB(3), C(3)
      Integer Index(3,2)
*
*     Statement function for Cartesian index
*
      Ind(ixyz,ix,iz) = (ixyz-ix)*(ixyz-ix+1)/2 + iz + 1
*
      iRout = 134
      iPrint = nPrint(iRout)
*
      RAB(1)=A(1)-RB(1)
      RAB(2)=A(2)-RB(2)
      RAB(3)=A(3)-RB(3)
*
      iComp = 1
      Do ixa = 0, la
         iyaMax=la-ixa
         Index(1,1)=ixa
      Do ixb = 0, lb
         iybMax=lb-ixb
         Index(1,2)=ixb
         Do iya = 0, iyaMax
            iza = la-ixa-iya
            Index(2,1)=iya
            Index(3,1)=iza
            ipa= Ind(la,ixa,iza)
         Do iyb = 0, iybMax
            izb = lb-ixb-iyb
            Index(2,2)=iyb
            Index(3,2)=izb
            ipb= Ind(lb,ixb,izb)
*
*           If (iPrint.ge.99) Then
*              Write (*,*)
*              Write (*,*) ixa,iya,iza
*              Write (*,*) ixb,iyb,izb
*              Write (*,*) ipa,ipb
*           End If
*                                                                      *
************************************************************************
*                                                                      *
*           Loop over components of B
*
            Do iBx = 1, 3
               iBy=iBx+1-((iBx+1)/4)*3
               iBz=iBy+1-((iBy+1)/4)*3
               jxa=Index(iBx,1)
               jxb=Index(iBx,2)
               jya=Index(iBy,1)
               jyb=Index(iBy,2)
               jza=Index(iBz,1)
               jzb=Index(iBz,2)
*              Write (*,*) 'iBx,iBy,iBz=',iBx,iBy,iBz
*              Write (*,*) 'nZeta=',nZeta
*              Write (*,*) jxa,jya,jza
*              Write (*,*) jxb,jyb,jzb
*                                                                      *
************************************************************************
*                                                                      *
*           Combine integrals
*
            Do iZeta = 1, nZeta
*
               Fact = rKappa(iZeta) * Zeta(iZeta)**(-Three/Two)
*
               temp1=  Rxyz(iZeta,iBx,jxa  ,jxb  ,0) *
     &               (+Wxyz(iZeta,iBy,jya  ,jyb  ,2)
     &                *Rxyz(iZeta,iBz,jza+1,jzb  ,0)
     &                -Rxyz(iZeta,iBy,jya+1,jyb  ,0)
     &                *Wxyz(iZeta,iBz,jza  ,jzb  ,2)
     &                -Wxyz(iZeta,iBy,jya  ,jyb  ,1)
     &                *Rxyz(iZeta,iBz,jza  ,jzb+1,0)
     &                +Rxyz(iZeta,iBy,jya  ,jyb+1,0)
     &                *Wxyz(iZeta,iBz,jza  ,jzb  ,1))
*
               temp2a= Txyz(iZeta,iBx,jxa  ,jxb  ,0)* (
     &        RAB(iBy)*Rxyz(iZeta,iBy,jya  ,jyb  ,0) *
     &              (  Rxyz(iZeta,iBz,jza  ,jzb  ,1)
     &                +Rxyz(iZeta,iBz,jza  ,jzb  ,0)*C(iBz) )
     &          -   (  Rxyz(iZeta,iBy,jya  ,jyb  ,1)
     &                +Rxyz(iZeta,iBy,jya  ,jyb  ,0)*C(iBy) )
     &       *RAB(iBz)*Rxyz(iZeta,iBz,jza  ,jzb  ,0) )
*
               temp2b= Rxyz(iZeta,iBx,jxa  ,jxb  ,0)* (
     &        RAB(iBy)*Txyz(iZeta,iBy,jya  ,jyb  ,0) *
     &              (  Rxyz(iZeta,iBz,jza  ,jzb  ,1)
     &                +Rxyz(iZeta,iBz,jza  ,jzb  ,0)*C(iBz) )
     &          -   (  Txyz(iZeta,iBy,jya  ,jyb  ,1)
     &                +Txyz(iZeta,iBy,jya  ,jyb  ,0)*C(iBy) )
     &       *RAB(iBz)*Rxyz(iZeta,iBz,jza  ,jzb  ,0) )
*
               temp2c= Rxyz(iZeta,iBx,jxa  ,jxb  ,0)* (
     &        RAB(iBy)*Rxyz(iZeta,iBy,jya  ,jyb  ,0) *
     &              (  Txyz(iZeta,iBz,jza  ,jzb  ,1)
     &                +Txyz(iZeta,iBz,jza  ,jzb  ,0)*C(iBz) )
     &          -   (  Rxyz(iZeta,iBy,jya  ,jyb  ,1)
     &                +Rxyz(iZeta,iBy,jya  ,jyb  ,0)*C(iBy) )
     &       *RAB(iBz)*Txyz(iZeta,iBz,jza  ,jzb  ,0) )
*
               Final(iZeta,iComp,ipa,ipb,iBx) = Half* Fact * (
     &              temp1 + Half*(temp2a + temp2b + temp2c)
     &                                             )
            End Do
*           Write (*,*)
*                                                                      *
************************************************************************
*                                                                      *
            End Do ! iBx
*                                                                      *
************************************************************************
*                                                                      *
         End Do
         End Do
      End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine fetch_data_RunFile_init( nss, nstate )
      Implicit None

      Integer :: nss, nstate, njob, mxjob
      Logical :: FOUND



      ! check the presence of the RUNFILE
      FOUND=.false.
      Call f_inquire('RUNFILE',FOUND)
      If(FOUND.eqv..false.) Then
         Write(6,'(5X,A)') 'The RUNFILE was not found in the $WorkDir'
         Write(6,'(5X,A)') 'Are you running this calculation in the'
         Write(6,'(5X,A)') 'same $WorkDir where RASSI calculation'
         Write(6,'(5X,A)') 'was executed?'
         Write(6,'(5X,A)') 'Check your calculation again, and If'
         Write(6,'(5X,A)') 'necessary, submit a BUG report.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      ! check the presence of the necessary information on RUNFILE:
      FOUND= .FALSE.
      Call qpg_iscalar('NSS_SINGLE',FOUND)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The NSS Value was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_iscalar('NJOB_SINGLE',FOUND)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The NJOB Value was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_iscalar('MXJOB_SINGLE',FOUND)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The MXJOB Value was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_iscalar('NSTATE_SINGLE',FOUND)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The NSTATE Value was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      ! fetch scalar data from RUNFILE
      Call get_iscalar('NSS_SINGLE',NSS)
      Call get_iscalar('NJOB_SINGLE',NJOB)
      Call get_iscalar('MXJOB_SINGLE',MXJOB)
      Call get_iscalar('NSTATE_SINGLE',NSTATE)

      ! check the presence of saved arrays on RUNFILE:

      FOUND=.FALSE.
      Call qpg_iArray('MLTP_SINGLE',FOUND,MXJOB)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The MLTP array was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_iArray('JBNUM_SINGLE',FOUND,NSTATE)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The JBNUM array was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_iArray('LROOT_SINGLE',FOUND,NSTATE)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The LROOT array was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_dArray('ESO_SINGLE',FOUND,NSS)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The ESO array was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_dArray('UMATR_SINGLE',FOUND,NSS**2)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The UMATR array was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_dArray('UMATI_SINGLE',FOUND,NSS**2)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The UMATI array was not found on RUNFILE'
         Write(6,'(5X,A)') 'Please report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_dArray('ANGM_SINGLE',FOUND,3*NSTATE*NSTATE)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The ANGMOM array was not found on RUNFILE'
         Write(6,'(5X,A)') '1. Check If ANGM keyword was used for '//
     &                     'SEWARD.'
         Write(6,'(5X,A)') '2. Check If MEES keyword was used for '//
     &                     'RASSI.'
         Write(6,'(5X,A)') '3. Check If PROP keyword was used for '//
     &                     'RASSI:'
         Write(6,'(9X,A)') 'PROP'
         Write(6,'(9X,A)') '3'
         Write(6,'(9X,A)') ' ''ANGMOM'' 1'
         Write(6,'(9X,A)') ' ''ANGMOM'' 2'
         Write(6,'(9X,A)') ' ''ANGMOM'' 3'
         Write(6,'(5X,A)') 'If MEES, ANGMOM and PROP keywords  were '//
     &                     'used and you still see this problem,'
         Write(6,'(5X,A)') 'please, report a BUG.'
         Call xFlush(6)
         Call Quit_OnUserError()
      End If

      FOUND=.FALSE.
      Call qpg_dArray('DIP1_SINGLE',FOUND,3*NSTATE*NSTATE)
      If (FOUND.EQV..FALSE.) Then
         Write(6,'(5X,A)') 'The DIPMOM array was not found on RUNFILE'
         Write(6,'(5X,A)') 'Absorption intensities will not be computed'
      End If
      Return
      End Subroutine fetch_data_RunFile_init




      Subroutine fetch_data_RunFile_all( nss, nstate,
     &                                   multiplicity, eso, esfs,
     &                                   U, MM, MS, ML, DM, angmom,
     &                                   eDmom, amfi, HSO )
      Implicit None
      Integer, Parameter :: wp=selected_real_kind(p=15,r=307)
#include "stdalloc.fh"
      Integer :: nss, nstate
      Integer :: multiplicity(nstate)
      Real(kind=8) :: eso(nss), esfs(nstate), angmom(3,nstate,nstate),
     &                 eDmom(3,nstate,nstate), amfi(3,nstate,nstate)
      Complex(kind=8) :: MM(3,nss,nss), MS(3,nss,nss), ML(3,nss,nss)
      Complex(kind=8) :: DM(3,nss,nss)
      Complex(kind=8) :: U(nss,nss), HSO(nss,nss)
      ! local variables:
      Integer              :: njob, mxjob, iss, ibas(nstate,-50:50)
      Integer              :: i, j, i1, j1, ist, jst, mult, multI, multJ
      Integer              :: l, ipar, info
      Real(kind=8)        :: g_e, au2cm, thr_deg, diff
      ! allocatable local arrays:
      Integer, allocatable :: mltplt(:), jbnum(:) !,lroot(:)
      Real(kind=8), allocatable :: tmpR(:,:), tmpI(:,:), W(:)
      Complex(kind=8), allocatable :: tmp(:,:)
      Complex(kind=8) :: Spin
      External         :: Spin
      Logical          :: found_edmom, found_amfi, found_hsor,
     &                    found_hsoi

      g_e=2.00231930437180_wp
      au2cm=219474.6313702_wp
      ! get basic sizes:
      njob=0
      mxjob=0
      Call get_iScalar('NJOB_SINGLE',njob)
      Call get_iScalar('MXJOB_SINGLE',mxjob)
      ! allocate temporary memory:
      Call mma_allocate(jbnum,nstate,'jbnum')
      Call mma_allocate(mltplt,mxjob,'mltplt')
      ! get the information from RUNFILE:
      mltplt=0
      jbnum=0
      Call get_iArray('MLTP_SINGLE',MLTPLT,MXJOB)
      Call get_iArray('JBNUM_SINGLE',JBNUM,NSTATE)
      ! computing the multiplicity of each state:
      multiplicity=0
      Do i=1,nstate
         multiplicity(i) = mltplt( jbnum(i) )
      End Do
      Call mma_deallocate(jbnum)
      Call mma_deallocate(mltplt)

      ! fetch the spin-orbit energies:
      eso=0.0_wp
      Call get_dArray('ESO_SINGLE',eso,nss)

      ! fetch the spin-free energies:
      esfs=0.0_wp
      Call get_dArray('ESFS_SINGLE',esfs,nstate)

      ! fetch the U matrix:
      Call mma_allocate(tmpR,nss,nss,'tmpR')
      Call mma_allocate(tmpI,nss,nss,'tmpI')


      tmpR=0.0_wp
      tmpI=0.0_wp
      Call get_dArray('UMATR_SINGLE',tmpR,nss*nss)
      Call get_dArray('UMATI_SINGLE',tmpI,nss*nss)
      U=(0.0_wp,0.0_wp)
      Do i=1,nss
         Do j=1,nss
            U(i,j) = cmplx( tmpR(i,j), tmpI(i,j), wp )
         End Do
      End Do



      ! fetch the angular momentum integrals:
      angmom=0.0_wp
      Call get_dArray('ANGM_SINGLE',angmom,3*nstate*nstate)


      ! fetch the electric dipole moment integrals:
      edmom=0.0_wp
      found_EDMOM=.false.
      Call qpg_dArray('DIP1_SINGLE',FOUND_EDMOM,3*NSTATE*NSTATE)
      If (found_edmom)
     &  Call get_dArray('DIP1_SINGLE',edmom,3*nstate*nstate)


      ! fetch the amfi integrals:
      amfi=0.0_wp
      found_AMFI=.false.
      Call qpg_dArray('AMFI_SINGLE',FOUND_AMFI,3*NSTATE*NSTATE)
      If (found_amfi)
     &  Call get_dArray('AMFI_SINGLE',amfi,3*nstate*nstate)


      ! fetch the spin-orbit hamiltonian
      FOUND_HSOR=.FALSE.
      FOUND_HSOI=.FALSE.
      Call qpg_dArray('HAMSOR_SINGLE',FOUND_HSOR,NSS*NSS)
      Call qpg_dArray('HAMSOI_SINGLE',FOUND_HSOI,NSS*NSS)
      If (FOUND_HSOR.AND.FOUND_HSOI) Then
         tmpR=0.0_wp
         tmpI=0.0_wp
         Call get_dArray('HAMSOR_SINGLE',tmpR,nss*nss)
         Call get_dArray('HAMSOI_SINGLE',tmpI,nss*nss)
         Call zcopy_(nss*nss,[(0.0_wp,0.0_wp)],0,HSO,1)
         Do i=1,nss
            Do j=1,nss
               HSO(i,j) = cmplx( tmpR(i,j), tmpI(i,j), wp )
            End Do
         End Do
!-----------------------------------------------------------------------
!       if HSO is found, proceed to diagonalize it
         Call mma_allocate(W,nss,'W')
         Call dcopy_(nss,[0.0_wp],0,W,1)
         Call zcopy_(nss*nss,[(0.0_wp,0.0_wp)],0,U,1)
         info=0
         Call diag_c2(hso,nss,info,W,U)
         ! correct for numerical degeneracies:
         thr_deg=0.2D-13 ! a.u. = 0.2D-13*au2cm = 4.38949263E-09 cm-1
         Do i=1,nss-1
!           wtmp=W(i)
           Do j=i+1,nss
             diff=ABS( w(i)-w(j) )
             If( diff < thr_deg ) Then
               w(j)=w(i)
             End If
           End Do
         End Do

         Do i=1,nss
            ESO(i) = (W(i)-W(1))*au2cm
         End Do
         Call mma_deallocate(W)
!-----------------------------------------------------------------------
      End If
      Call mma_deallocate(tmpR)
      Call mma_deallocate(tmpI)


c-----
      ! generate a local indexing table:
      iss=0
      ibas=0
      ipar=mod(multiplicity(1),2)
      Do Ist=1,nstate
         Mult=Multiplicity(Ist)
         Do I=-(Mult-Ipar)/2,(Mult-Ipar)/2
            If( (Ipar==0) .AND. (I==0)) Go To 310
               Iss=Iss+1
               Ibas(Ist,I)=Iss
  310       Continue
         End Do ! i
      End Do ! ist

c----- expand the spin free basis to the spin-orbit basis:
      Call zcopy_(3*nss*nss,[(0.0_wp,0.0_wp)],0,MM,1)
      Call zcopy_(3*nss*nss,[(0.0_wp,0.0_wp)],0,ML,1)
      Call zcopy_(3*nss*nss,[(0.0_wp,0.0_wp)],0,MS,1)
      Do Ist=1,nstate
         Mult=Multiplicity(Ist)
         Do I=-(Mult-Ipar)/2,(Mult-Ipar)/2
            If( (Ipar==0) .AND. (I==0) ) Go To 301
            Do J=-(Mult-Ipar)/2,(Mult-Ipar)/2
               If( (Ipar==0) .AND. (J==0) ) Go To 302
               Do l=1,3
                  i1=Ibas(Ist,I)
                  j1=Ibas(Ist,J)
                  MM(l,i1,j1)=-Spin(l,Mult,I,J)*g_e
                  MS(l,i1,j1)= Spin(l,Mult,I,J)
               End Do ! l
  302          Continue
            End Do ! J
  301       Continue
         End Do ! I
      End Do ! Ist


      Do Ist=1,nstate
         MultI=Multiplicity(Ist)
         Do Jst=1,nstate
            MultJ=Multiplicity(Jst)
            If(MultI==MultJ) Then
               Do I=-(MultI-Ipar)/2,(MultI-Ipar)/2
               If( (Ipar==0) .AND. (I.eq.0) ) Go To 303
                  Do l=1,3
                     i1=Ibas(Ist,I)
                     j1=Ibas(Jst,I)
                     MM(l,i1,j1)=MM(l,i1,j1)
     &                              -CMPLX(0.0_wp,Angmom(l,Ist,Jst),wp)
                     ML(l,i1,j1)=ML(l,i1,j1)
     &                              +CMPLX(0.0_wp,Angmom(l,Ist,Jst),wp)
                     DM(l,i1,j1)=DM(l,i1,j1)
     &                              +CMPLX(eDmom(l,Ist,Jst),0.0_wp,wp)
                  End Do   ! l
  303             Continue
               End Do   ! I
            End If
         End Do   ! Jst
      End Do   ! Ist

      ! calculate the matrix elements of the spin and magnetic moment
      ! in the spin-orbit basis:
      Call mma_allocate(tmp,nss,nss,'tmp')
      Do L=1,3
         TMP=(0.0_wp,0.0_wp)
         ! spin moment
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             MS(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             MS(L,:,:), nss )
         ! orbital moment
         TMP=(0.0_wp,0.0_wp)
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             ML(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             ML(L,:,:), nss )
         ! magnetic moment
         TMP=(0.0_wp,0.0_wp)
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             MM(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             MM(L,:,:), nss )

         If(found_EDMOM) Then
         ! electric dipole moment
         TMP=(0.0_wp,0.0_wp)
         CALL ZGEMM_('C', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                     U, nss,
     &             DM(L,:,:), nss,           (0.0_wp,0.0_wp),
     &                   TMP, nss )
         CALL ZGEMM_('N', 'N', nss, nss, nss, (1.0_wp,0.0_wp),
     &                   TMP, nss,
     &                     U, nss,           (0.0_wp,0.0_wp),
     &             DM(L,:,:), nss )
         End If
      End Do !L
      Call mma_deallocate(tmp)


      Return
      End Subroutine fetch_data_RunFile_all

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FRMDSC(   ARRAY,    NDIM,  MBLOCK,   IFILE,  IMZERO,
     &                  I_AM_PACKED)
C
C     TRANSFER ARRAY FROM DISC FILE IFILE
C
*. Version allowing zero and packed blocks
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "io_util.fh"
      DIMENSION ARRAY(*)
*
      DIMENSION ISCR(2)
      PARAMETER(LPBLK=50000)
      INTEGER IPAK(LPBLK)
      DIMENSION XPAK(LPBLK)
      DIMENSION IDUMMY(1)
C
      IPACK = 1
      IF(IPACK.NE.0) THEN
*. Read if ARRAY is zero
C       MMBLOCK = MBLOCK
C       IF(MMBLOCK.GE.2) MMBLOCK = 2
C       CALL IFRMDS(ISCR,2,MMBLOCK,IFILE)
        CALL IFRMDS(ISCR,2,2,IFILE)
        IMZERO=ISCR(1)
        I_AM_PACKED=ISCR(2)
C?      IF(I_AM_PACKED.NE.0) THEN
C?      WRITE(6,*) ' File is packed, file number = ', IFILE
C?      END IF
        IF(IMZERO.EQ.1) THEN
          ZERO = 0.0D0
C?        write(6,*) ' frmdsc, length of zero block',NDIM
          CALL SETVEC(ARRAY,ZERO,NDIM)
          GOTO 1001
        END IF
      END IF
C?    WRITE(6,*) ' IMZERO I_AM_PACKED', IMZERO,I_AM_PACKED
*
      IF(I_AM_PACKED.EQ.1) THEN
        ZERO = 0.0D0
        CALL SETVEC(ARRAY,ZERO,NDIM)
*. Loop over packed records of dimension LPBLK
      NBATCH = 0
C1000 CONTINUE
*. The next LPBLK elements
        LBATCH=-2**30
  999   CONTINUE
          NBATCH = NBATCH + 1
          IF(NBATCH.NE.1) THEN
            LBATCHP = LBATCH
          END IF
*. Read next batch
          CALL IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
          LBATCH=IDUMMY(1)
          IF(LBATCH.GT.0) THEN
            CALL IDAFILE(IFILE,2,IPAK,LBATCH,IDISK(IFILE))
            CALL DDAFILE(IFILE,2,XPAK,LBATCH,IDISK(IFILE))
          END IF
          CALL IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
          ISTOP=IDUMMY(1)
          DO IELMNT = 1, LBATCH
            IF(IPAK(IELMNT).LE.0.OR.IPAK(IELMNT).GT.NDIM) THEN
              WRITE(6,*) ' FRMDSC : Problemo IELMNT = ',IELMNT
              WRITE(6,*) ' IPAK(IELMNT) = ',IPAK(IELMNT )
              WRITE(6,*) ' LBATCH IFILE  = ',LBATCH,IFILE
              IF(NBATCH.EQ.1) THEN
               WRITE(6,*) ' NBATCH = 1 '
              ELSE
               WRITE(6,*) ' NBATCH, LBATCHP', NBATCH,LBATCHP
              END IF
              WRITE(6,*) ' NDIM,IMZERO = ', NDIM,IMZERO
*             STOP ' problem in FRMDSC '
              CALL SYSABENDMSG('lucia_util/frmdsc','Internal error',
     &                         ' ')
            END IF
            ARRAY(IPAK(IELMNT)) = XPAK(IELMNT)
          END DO
        IF(ISTOP.EQ.0) GOTO 999
*. End of loop over records of truncated elements
      ELSE IF ( I_AM_PACKED.EQ.0) THEN
        NBLOCK = MBLOCK
        IF ( MBLOCK .LE. 0 ) NBLOCK = NDIM
        IREST=NDIM
        IBASE=0
  100   CONTINUE
         IF(IREST.GT.NBLOCK) THEN
           CALL DDAFILE(IFILE,2,ARRAY(IBASE+1),NBLOCK,IDISK(IFILE))
          IBASE=IBASE+NBLOCK
          IREST=IREST-NBLOCK
         ELSE
           CALL DDAFILE(IFILE,2,ARRAY(IBASE+1),IREST,IDISK(IFILE))
          IREST=0
         END IF
         CALL IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
        IF( IREST .GT. 0 ) GOTO 100
      END IF
*
 1001 CONTINUE
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1997, Jeppe Olsen                                 *
!***********************************************************************

subroutine INTIM()
! Interface to external integrals
!
! If NOINT /= 0, only pointers are constructed
! Jeppe Olsen, Winter of 1991
!
! Version : Fall 97

use lucia_data, only: ECORE, ECORE_HEX, ECORE_ORIG, INT1, INT1O, KINH1, KINH1_NOCCSYM, LSM1, LSM2, NOINT, NSMOB, NTOOB, NTOOBS, &
                      PINT1, PINT2
use Constants, only: Zero

implicit none

! Pointers for symmetry blocks of integrals
call INTPNT(PINT1,LSM1,PINT2,LSM2)

! Pointer for orbital indices for symmetry blocked matrices
call ORBINH1(KINH1,KINH1_NOCCSYM,NTOOBS,NTOOB,NSMOB)

! Change one-electron integrals to inactive fock matrix
if (NOINT == 0) then
  INT1O(:) = INT1(:)
  ECORE_HEX = Zero
end if
ECORE_ORIG = ECORE
ECORE = ECORE+ECORE_HEX

end subroutine INTIM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DetCtl
      use Arrays, only: pINT1, pINT2
*
      Implicit Real*8 (A-H,O-Z)

#include "Input.fh"
#include "cands.fh"
#include "detdim.fh"
#include "crun_mclr.fh"
#include "genop.fh"
#include "cprnt_mclr.fh"
#include "cstate_mclr.fh"
#include "stdalloc.fh"
#include "Files_mclr.fh"
#include "spinfo_mclr.fh"
#include "cicisp_mclr.fh"

      Call mma_Allocate(pINT1,nSym,Label='pInt1')
      pInt1(:)=0
      Call mma_Allocate(pINT2,nSym**3,Label='pInt2')
      pInt2(:)=0

      Pntgrp=1
      NOCSF  = 0
      idenmt=0
      nopart=0
      iopnum=1
      nIrrep=nSym
      nsmob=nSym
      mxr4tp=0
      idiag=1
      intimp=5
      incore=1
      icistr=1
      ist=1
      i12=2
      MS2=iSpin-1
      If (ms2.ne.0) Then
        idc=1
        pssign=0.0d0
      else
        itmp=(ispin-1)/2
        pssign=(-1.0d0)**itmp
        idc=2
      end if

      ntRas1=0
      ntRas2=0
      ntRas3=0
      Do iSym=1,nSym
         ntRas1=ntRas1+nRs1(iSym)
         ntRas2=ntRas2+nRs2(iSym)
         ntRas3=ntRas3+nRs3(iSym)
      End Do
      MNRS10 = Max(0,2*ntRas1-nHole1)
      MXRS30 = Max(0,Min(2*ntRas3,nElec3))
*. Initialize print flags
      IPRSTR =  0
      IPRORB =  0
      IPRCIX =  0
*. From shells to orbitals
      CALL ORBINF_MCLR(nSym,nSym,nRs1,nRs2,nRs3,mxr4tp,IPRORB) ! OK
*. Number of string types
      CALL STRTYP(ms2,nActEl,MNRS10,MXRS30,IPRSTR)   ! looks allright
*. Symmetry information
      CALL SYMINF_MCLR(nSym,IPRORB) ! looks allright
*. Internal string information
      CALL STRINF(IPRSTR)     ! looks allright, no!
*. Internal subspaces
      CALL ICISPC(MNRS10,MXRS30,IPRCIX)    ! looks allright
      CALL ICISPS(IPRCIX)        ! looks allright
*. CSF information
      CALL DANAME(LUCSF2SD,FNCSF2SD)
      CALL CSFINF(State_sym,iSpin,idum,1,IPRCIX,nsym)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKGUGA_FREE(SGS,CIS,EXS)
! PURPOSE: FREE THE GUGA TABLES

use gugx, only: CIStruct, EXStruct, SGStruct
use stdalloc, only: mma_deallocate

#include "intent.fh"

implicit none
type(SGStruct), intent(_OUT_) :: SGS
type(CIStruct), intent(_OUT_) :: CIS
type(EXStruct), intent(_OUT_) :: EXS

call mma_deallocate(SGS%ISM,safe='*')
call mma_deallocate(SGS%DRT0,safe='*')
call mma_deallocate(SGS%DOWN0,safe='*')
call mma_deallocate(SGS%DRT,safe='*')
call mma_deallocate(SGS%DOWN,safe='*')
call mma_deallocate(SGS%UP,safe='*')
call mma_deallocate(SGS%MAW,safe='*')
call mma_deallocate(SGS%LTV,safe='*')
call mma_deallocate(SGS%DAW,safe='*')
call mma_deallocate(SGS%RAW,safe='*')
call mma_deallocate(SGS%SCR,safe='*')
call mma_deallocate(SGS%Ver,safe='*')
nullify(SGS%DRTP,SGS%DOWNP)

call mma_deallocate(CIS%NOW,safe='*')
call mma_deallocate(CIS%IOW,safe='*')
call mma_deallocate(CIS%NCSF,safe='*')
call mma_deallocate(CIS%NOCSF,safe='*')
call mma_deallocate(CIS%IOCSF,safe='*')
call mma_deallocate(CIS%ICase,safe='*')

call mma_deallocate(EXS%NOCP,safe='*')
call mma_deallocate(EXS%IOCP,safe='*')
call mma_deallocate(EXS%ICoup,safe='*')
call mma_deallocate(EXS%VTab,safe='*')
call mma_deallocate(EXS%SGTMP,safe='*')
call mma_deallocate(EXS%MVL,safe='*')
call mma_deallocate(EXS%MVR,safe='*')
call mma_deallocate(EXS%USGN,safe='*')
call mma_deallocate(EXS%LSGN,safe='*')

end subroutine MKGUGA_FREE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Eq_Solver(Mode,M,N,NRHS,B,Curvilinear,Degen,dSS,DFC)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
character, intent(in) :: Mode
integer(kind=iwp), intent(in) :: M, N, NRHS
real(kind=wp), intent(in) :: B(M,N), Degen(M), dSS(*)
logical(kind=iwp), intent(in) :: Curvilinear
real(kind=wp), intent(_OUT_) :: DFC(*)
integer(kind=iwp) :: i, ij, INFO, iRHS, LDA, LDB, LWork
real(kind=wp) :: Temp(1)
real(kind=wp), allocatable :: A(:,:), Btmp(:,:), Work(:)

#include "warnings.h"

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
! Solve the equation Ax=b

LDA = M
LDB = max(1,M,N)
if (Mode == 'T') then
  call mma_allocate(A,M,M,Label='A')
  A(:,1:N) = B(:,:)
  A(:,N+1:) = Zero
  if (.not. Curvilinear) then
    do i=1,M
      A(i,:) = sqrt(Degen(i))*A(i,:)
    end do
  end if
# ifdef _DEBUGPRINT_
  call RecPrt('A',' ',A,M,M)
# endif
else
  call mma_allocate(A,M,N,Label='A')
  A(:,:) = B(:,:)
  if (.not. Curvilinear) then
    do i=1,M
      A(i,:) = sqrt(Degen(i))*A(i,:)
    end do
  end if
# ifdef _DEBUGPRINT_
  call RecPrt('A',' ',A,M,N)
# endif
end if

call mma_allocate(Btmp,LDB,NRHS,Label='Btmp')
Btmp(:,:) = Zero

if (Mode == 'T') then
  do iRHS=1,nRHS
    ij = (iRHS-1)*N
    Btmp(1:N,iRHS) = dss(ij+1:ij+N)
  end do
else
# ifdef _DEBUGPRINT_
  call RecPrt('B(raw)',' ',dss,M,nRHS)
# endif
  do iRHS=1,nRHS
    if (.not. Curvilinear) then
      ij = (iRHS-1)*M
      Btmp(1:M,iRHS) = dss(ij+1:ij+M)*sqrt(Degen(:))
    else
      ij = (iRHS-1)*M
      Btmp(1:M,iRHS) = dss(ij+1:ij+M)
    end if
  end do
end if
#ifdef _DEBUGPRINT_
call RecPrt('B(in)',' ',Btmp,LDB,NRHS)
#endif

LWork = -1
INFO = 0
call dgels_(Mode,M,N,NRHS,A,LDA,Btmp,LDB,Temp,LWork,INFO)
LWork = int(Temp(1))
call mma_allocate(Work,LWork,Label='Work')
INFO = 0
call dgels_(Mode,M,N,NRHS,A,LDA,Btmp,LDB,Work,LWork,INFO)
if (INFO > 0) then
  call WarningMessage(2,'Error in Eq_Solver')
  write(u6,*)
  write(u6,*) '***********************************************'
  write(u6,*) ' ERROR: Eq_Solver could not find a solution.   '
  write(u6,*) ' The matrix is rank deficient.                 '
  write(u6,*) '***********************************************'
  call Quit(_RC_INTERNAL_ERROR_)
end if

#ifdef _DEBUGPRINT_
call RecPrt('B(out)',' ',Btmp,LDB,NRHS)
#endif
if (Mode == 'T') then
  do iRHS=1,nRHS
    if (.not. Curvilinear) Btmp(1:M,iRHS) = Btmp(1:M,iRHS)/sqrt(Degen(:))
    ij = (iRHS-1)*M
    DFC(ij+1:ij+M) = Btmp(1:M,iRHS)
  end do
else
  do iRHS=1,nRHS
    ij = (iRHS-1)*N
    DFC(ij+1:ij+N) = Btmp(1:N,iRHS)
  end do
end if

call mma_deallocate(Work)
call mma_deallocate(Btmp)
call mma_deallocate(A)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Eq_Solver

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE ZSYM1(NIRREP,IPRNT)
*
* Number of symmetries for d2h
* Symmetry connecting arrays
* ( trivial, written for compatibility with higher point groups)
*
      INTEGER SYMPRO(8,8)
      DATA  SYMPRO/1,2,3,4,5,6,7,8,
     &             2,1,4,3,6,5,8,7,
     &             3,4,1,2,7,8,5,6,
     &             4,3,2,1,8,7,6,5,
     &             5,6,7,8,1,2,3,4,
     &             6,5,8,7,2,1,4,3,
     &             7,8,5,6,3,4,1,2,
     &             8,7,6,5,4,3,2,1 /
C     COMMON/CSM/NSMSX,NSMDX,NSMST,NSMCI,ITSSX,ITSDX
#include "csm.fh"
*
C     PARAMETER ( MXPOBS = 20 )
#include "mxpdim.fh"
      INTEGER ADASX,ASXAD,ADSXA,SXSXDX,SXDXSX
      COMMON/CSMPRD/ADASX(MXPOBS,MXPOBS),ASXAD(MXPOBS,2*MXPOBS),
     &              ADSXA(MXPOBS,2*MXPOBS),
     &              SXSXDX(2*MXPOBS,2*MXPOBS),SXDXSX(2*MXPOBS,4*MXPOBS)

      NSMSX = NIRREP
      NSMDX = NIRREP
      NSMST = NIRREP
      NSMCI = NIRREP
      NSMXT = NIRREP
      ITSSX = 1
      ITSDX = 1
      ITSXT = 1

*
C     COPMT2(AIN,AOUT,NINR,NINC,NOUTR,NOUTC,IZERO)
      CALL ICPMT2(   SYMPRO,    ADASX,        8,        8,   MXPOBS,
     &               MXPOBS,        1)
      CALL ICPMT2(   SYMPRO,    ADSXA,        8,        8,   MXPOBS,
     &             2*MXPOBS,        1)
      CALL ICPMT2(   SYMPRO,    ASXAD,        8,        8,   MXPOBS,
     &             2*MXPOBS,        1)
      CALL ICPMT2(   SYMPRO,   SXSXDX,        8,        8, 2*MXPOBS,
     &             2*MXPOBS,        1)
      CALL ICPMT2(   SYMPRO,   SXDXSX,        8,        8, 2*MXPOBS,
     &             4*MXPOBS,        1)
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(IPRNT)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DCORR(JREFX,AREF,ICSPCK,INTSYM,INDX,DMO)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION AREF(*),JREFX(*),ICSPCK(*),
     *          INTSYM(*),INDX(*),DMO(*)
*
      JO(L)=ICUNP(ICSPCK,L)
*
C CORRECTION TO DENSITY MATRIX IN ACPF CASE.
      IF(IPRINT.GE.7) WRITE(6,*)' ENP IN DENS =',ENP
      FAC=1.0D00-(1.0D00/ENP)
      IAD27=0
      CALL dDAFILE(Lu_27,2,AREF,NREF,IAD27)
      IK=0
      DO 40 INDA=1,IRC(1)
        II1=(INDA-1)*LN
        IF(JREFX(INDA).NE.0) THEN
          IK=IK+1
          TSUM=AREF(IK)*AREF(IK)*FAC
          IJ=0
          DO 110 I=1,LN
            IOC=(1+JO(II1+I))/2
            IJ=IJ+I
            DMO(IJ)=DMO(IJ)+IOC*TSUM
110       CONTINUE
        END IF
40    CONTINUE
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
         CALL Unused_integer_array(INTSYM)
         CALL Unused_integer_array(INDX)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GETPRINTLEVEL
      use rassi_aux, only: ipglob
      IMPLICIT NONE
      Integer, External :: iPrintLevel
      Logical, External :: Reduce_Prt

C Global print level
      IPGLOB=iPrintLevel(-1)
C Change print level when in an optimization loop
      IF (Reduce_Prt()) THEN
        IPGLOB=MAX(IPGLOB-2,0)
      END IF

      END SUBROUTINE GETPRINTLEVEL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Get_Molecule(ipCM,ipCoor,ipGrd,AtomLbl,nsAtom,mxdc)
      Implicit Real*8 (a-h,o-z)
#include "sbs.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "weighting.fh"
#include "Molcas.fh"
      Character*(LENIN) AtomLbl(mxdc)
      Logical TransVar, RotVar, Found
      Integer Columbus
      Real*8, Allocatable:: Grad(:)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     Read initial data
*
      Call Get_iScalar('Unique atoms',nsAtom)
      If (nsAtom.gt.mxdc) Then
         Call WarningMessage(2,'Init: nsAtom.gt.mxdc')
         Write (6,*) 'nsAtom,mxdc=',nsAtom,mxdc
         Call Abend()
      End If
*
      Call Allocate_Work(ipCoor,3*nsAtom)
      Call Get_dArray('Unique Coordinates',Work(ipCoor),3*nsAtom)
*
      Call Allocate_Work(ipCM  ,nsAtom)
      Call Get_dArray('Nuclear charge',Work(ipCM),nsAtom)
*
      Call Get_iScalar('Grad ready',iGO)
      iJustGrad = iAnd(iGO, 2**0)
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate gradient (it will be read later)
*     (This should eventually be removed, as ipGrd is unused...)
*
      Call Get_iScalar('Columbus',columbus)
      If ((iJustGrad.eq.1).and.(columbus.eq.1)) Then
*
*        C&M mode
*
         Call Get_iScalar('ColGradMode',iMode)
         If (iMode.eq.0) Then
            Call mma_allocate(Grad,3*nsAtom,Label='Grad')
            Call Get_Grad(Grad,3*nsAtom)
            Call GetMem('Grad','Allo','Real',ipGrd,3*nsAtom)
            Call DCopy_(3*nsAtom,Grad,1,Work(ipGrd),1)
            Call mma_deallocate(Grad)
         Else If (iMode.le.3) Then
            Call qpg_dArray('Grad State1',Found,Length)
            If (.not.Found .or. Length.eq.0) Then
               Call SysAbendmsg('Get_Molecule','Did not find:',
     &                          'Grad State1')
            End If
            Call GetMem('Grad','Allo','Real',ipGrd,Length)
            Call Get_dArray('Grad State1',Work(ipGrd),Length)
*
         End If
         If ( length.ne.3*nsAtom ) Then
            Call WarningMessage(2,'Init: length.ne.3*nsAtom')
            Write (6,*) 'Grad'
            Write (6,*) 'length,nsAtom=',length,nsAtom
            Call Abend()
         End If
         iJustGrad = 0
         iGO = iOr(iGO,iJustGrad)
         Call Put_iScalar('Grad ready',iGO)
      Else
*
*        M mode
*
         Call GetMem('GRAD','Allo','Real',ipGrd,3*nsAtom)
         Call FZero(Work(ipGrd),3*nsAtom)
      End If

      Call Get_cArray('Unique Atom Names',AtomLbl,LENIN*nsAtom)
*                                                                      *
************************************************************************
*                                                                      *
*     Check if method is translational or rotational variant.
*
      TransVar=iAnd(iSBS,2**7).eq.2**7
      RotVar  =iAnd(iSBS,2**8).eq.2**8
*
      iPL=iPrintLevel(-1)
      If ((TransVar.or.RotVar).and.(iPL.gt.0)) Then
         Write (6,*)
         If (TransVar)
     &      Write (6,*) '    Gradient is translational variant!'
         If (RotVar)
     &      Write (6,*) '    Gradient is rotational variant!'
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Read weights
*
      Call Qpg_dArray('Weights',Found,nData)
      If (Found.And.(nData.ge.nsAtom)) Then
*        The weights array length is actually the total number of atoms,
*        not just symmetry-unique, but the symmetry-unique ones are first
         Call GetMem('Weights','Allo','Real',ipWeights,nData)
         Call Get_dArray('Weights',Work(ipWeights),nData)
      Else
         Call SysAbendMsg('Get_Molecule',
     &        'No or wrong weights were found in the RUNFILE.','')
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************

      SubRoutine ChoMP2g_Setup(irc,EOcc,EVir)
      use ChoMP2, only: ChoMP2g_Allocated, EFrozT, EOccuT, EVirtT
      use ChoMP2, only: AdrR1, AdrR2
      use ChoMP2, only: MP2D_full, MP2D
      use ChoMP2, only: MP2W_full, MP2W
      use ChoMP2, only: MP2D_e_full, MP2D_e
      use ChoMP2, only: MP2W_e_full, MP2W_e
*
*     Jonas Bostrom, Feb 2010
*
*     Purpose: Do some additional setup only needed for
*              MP2-gradients or properties.
#include "implicit.fh"
#include "real.fh"
#include "chomp2g.fh"
#include "chomp2.fh"
#include "choorb.fh"
#include "cholesky.fh"
#include "stdalloc.fh"
      Integer irc
      Real*8 EOcc(*), EVir(*)
*
******************************************************
      MulD2h(i,j)=iEor(i-1,j-1) + 1
******************************************************
      nMOType = 3
      Call ChoMP2_GetInf(nOrb,nOcc,nFro,nDel,nVir)
*
*     Initialize an  offset for writing choleskyvectors to disk
      Do iProdType = 1, nMoType**2
         Do iSym = 1, nSym
            iAdrOff(iSym,iProdType) = 0
         End Do
      End Do

      nOccVirT = nOcc(1)*nVir(1)
      Do iSym = 2, nSym
         nOccVirT = nOccVirT + nOcc(iSym)*nVir(iSym)
      End Do

      Do iMOType = 1, nMOType
         Do iSym = 1, nSym
            nMO(iSym,1) = nFro(iSym)
            nMO(isym,2) = nOcc(iSym)
            nMO(iSym,3) = nVir(iSym)
         End Do
      End Do
*
      Do iMoType = 1, nMoType
         Do jMoType = 1, nMoType
            iProdType = jMOType + (iMOType-1)*nMOType
            Do iSym = 1, nSym
               nMoMo(iSym,iProdType) = 0
               Do iSymP = 1,nSym
                  iSymQ = MulD2h(iSymP,iSym)
                  iMoMo(iSymq,iSymp,iProdType) =
     &                  nMoMo(iSym,iProdType)
                  nMoMo(iSym,iProdType) = nMoMo(iSym,iProdType) +
     &                  nMO(iSymP,iMOType)*
     &                  nMO(iSymQ,jMOType)
               End Do
            End Do
         End Do
      End Do
      Do iMoType = 1, nMoType
         Do iSym = 1, nSym
            nMoAo(iSym,iMoType) = 0
            Do iSymAl = 1, nSym
               iSymP = MulD2h(iSymAl,iSym)
               iMoAo(iSymP,iSymAl,iMoType) = nMoAo(iSym,iMoType)
               nMoAo(iSym,iMoType) =
     &               nMoAo(iSym,iMoType) +
     &               nBas(iSymAl)*nMO(iSymP,iMoType)
            End Do
         End Do
      End Do
      Do iMoType = 1, nMoType
         Do iSym = 1, nSym
            nAoMo(iSym,iMoType) = 0
            Do iSymQ = 1, nSym
               iSymAl = MulD2h(iSymQ,iSym)
               iAoMo(iSymAl,iSymQ,iMoType) = nAoMo(iSym,iMoType)
               nAoMo(iSym,iMoType) =
     &               nAoMo(iSym,iMoType) +
     &               nBas(iSymAl)*nMO(iSymQ,iMoType)
            End Do
         End Do
      End Do

*     Allocate MP2_density
*     --------------------

      lDens = nOrb(1)*nOrb(1)
      Do iSym = 2, nSym
         lDens = lDens + nOrb(iSym)*nOrb(iSym)
      End Do
*
      ChoMP2g_Allocated=.True.

      Call mma_allocate(MP2D_full,lDens,Label='MP2D_full')
      Call mma_allocate(MP2W_full,lDens,Label='MP2W_full')
      MP2D_full(:)=Zero
      MP2W_full(:)=Zero

      iE = 0
      Do iSym = 1, nSym
         nb=nOrb(iSym)
         iS = iE + 1
         iE = iE + nb**2
         MP2D(iSym)%A(1:nb,1:nb) => MP2D_full(iS:iE)
         MP2W(iSym)%A(1:nb,1:nb) => MP2W_full(iS:iE)
      End Do

*     Allocate extended MP2_density (with deleted orbitals)
*     -----------------------------------------------------

      lDens_e = (nOrb(1)+nDel(1))*(nOrb(1)+nDel(1))
      Do iSym = 2, nSym
         lDens_e = lDens_e + (nOrb(iSym)+nDel(iSym))
     &                     * (nOrb(iSym)+nDel(iSym))
      End Do

      Call mma_allocate(MP2D_e_full,lDens_e,Label='MP2D_e_full')
      Call mma_allocate(MP2W_e_full,lDens_e,Label='MP2W_e_full')
      MP2D_e_full(:)=Zero
      MP2W_e_full(:)=Zero

      iE = 0
      Do iSym = 1, nSym
         nb=nOrb(iSym)+nDel(iSym)
         iS = iE + 1
         iE = iE + nb**2
         MP2D_e(iSym)%A(1:nb,1:nb) => MP2D_e_full(iS:iE)
         MP2W_e(iSym)%A(1:nb,1:nb) => MP2W_e_full(iS:iE)
      End Do

*     Allocate adress-field for reordered R-vectors
*     ---------------------------------------------
      Call mma_allocate(AdrR1,nSym,nSym,nOccT,Label='AdrR1')
      Call mma_allocate(AdrR2,nSym,nSym,nVirT,Label='AdrR2')

*    Allocate a vector for the orbital energies of frozen and virtual
*     frozen molecules.
      Call mma_allocate(EFrozT,Max(1,nFroT),Label='EFrozT')
      Call mma_allocate(EOccuT,Max(1,nOccT),Label='EOccuT')
      Call mma_allocate(EVirtT,Max(1,nVirT),Label='EVirtT')
*     Fill them with the right things
      Do iSym = 1, nSym
         Do i = 1, nFro(iSym)
            EFrozT(iFro(iSym)+i) = EOcc(iFro(iSym)+nOccT +i)
         End Do
         Do i = 1, nOcc(iSym)
            EOccuT(iOcc(iSym)+i) =
     &                    EOcc(iOcc(iSym) + i)
         End Do
         Do i = 1, nVir(iSym)
            EVirtT(iVir(iSym)+i) =
     &                    EVir(iVir(iSym)+iDel(iSym)+ i)
         End Do
      End Do

      irc=0

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine klvaa_vvv(x,g,vblock,N,nug,lu,last,iasblock,K,ias)
!mp subroutine klvaa_vvv(G,ix,it,ig,iscr,vblock,N,nug,lu,last,iasblock,K,ias)
!mpn subroutine klvaa_vvv(ix,it,ig,iscr,vblock,N,nug,lu,last,iasblock,K,ias)
!
!  creates K(alpha>alpha,alpha-alpha) or K(beta>beta,beta,beta)
!  DA files KMATICH(ISP)ICH(ISP)     ISP=A
!  generates antisymmetrized integrals from abab (T2) or bbaa (vvvo)
!  x, g  allocated in create_klvab_t3
!  K, ias defined in create_klvab_t3.f
!
!  parallelization (seems to be) irrelevant at the moment
!  implemented integer offsets, PV, 14 may 2004.

use ChT3_global, only: DimGrpaR, maxdim, no, NOAB, NUAB, printkey
use Index_Functions, only: iTri, nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: x(*)
real(kind=wp), intent(in) :: g(*)
integer(kind=iwp), intent(in) :: vblock, N, lu, iasblock, K
integer(kind=iwp), intent(out) :: nug
integer(kind=iwp), intent(inout) :: last, ias
integer(kind=iwp) :: A, A1, A2, a_tmp, AADT, ADIM, B, B1, b1_tmp, B2, b2_chk, i_blk, IJS, isp, j_blk, j_tmp, KADT, KI, length, &
                     length1, length2, MAXDIMM, NGA, ngaf, ngal, NGB, ngbf, ngbl, nind_ngaf, nind_ngal, nind_ngbf, nind_ngbl, NNU, &
                     NSTEP, R
real(kind=wp), allocatable :: t2_exp(:), t2_tmp(:), tmp(:)

ISP = 1
nug = nuab(isp)/vblock
if ((vblock*nug) /= nuab(isp)) nug = nug+1
NNU = nTri_Elem(NUAB(1))
if (printkey >= 11) then
  write(u6,'(A,10I5)') 'entering klvaa_vvv',vblock,N,nug,lu,last,iasblock,K,ias
  !mpn write(u6,*) ddot_(nnoab(3)*nnuab(3),Work(it),1,Work(it),1)
  !mp write(u6,*) ddot_(nnoab(3)*nnuab(3),G(it),1,G(it),1)
end if
!!do K=1,noab(isp)
!!  FN = 'VVVOI'//ICH(ISP)
!!  call GET3DM(FN,G(ig),NNUAB(isp),NUAB(ISP),K)
!!  call delf(FN,K,K)  ! all done in create_klvab_t3.f
do nga=1,nug
  A1 = (nga-1)*vblock+1
  adim = min(vblock,nuab(isp)-A1+1)
  A2 = A1+adim-1
  do ngb=1,nga
    if (nga == ngb) then
      maxdimm = nTri_Elem(adim-1)
    else
      maxdimm = adim*vblock
    end if
    x(1:N*maxdimm) = Zero
    !mp call zeroma(G(IX),1,N*maxdim)
    B1 = (ngb-1)*vblock+1

    !mp !write(u6,*)
    !mp !write(u6,*) '================================='
    !mp !write(u6,*) 'nga, ngb',nga,ngb
    !mp !write(u6,*) '================================='
    !mp !write(u6,*)

    !mpn
    ! - check the largest b2

    !mp b2_chk = b1-1+min(vblock,a2-b1)
    !mpn b2_chk = b1-1+vblock
    b2_chk = b1+min(vblock,nuab(isp)-b1+1)-1

    ! - find out which T2 blocked files will be needed
    !   for particular nga, ngb

    !mp !write(u6,'(A,4(i5,2x))') 'a1,a2,b1,b2_chk = ',a1,a2,b1,b2_chk

    call block_interf(a1,a2,b1,b2_chk,ngaf,ngal,nind_ngaf,nind_ngal,ngbf,ngbl,nind_ngbf,nind_ngbl)

    !mp !write(u6,'(A,4(i5,2x))') 'ngaf, ngal, nind_ngaf, nind_ngal',ngaf,ngal,nind_ngaf,nind_ngal
    !mp !write(u6,'(A,4(i5,2x))') 'ngbf, ngbl, nind_ngbf, nind_ngbl',ngbf,ngbl,nind_ngbf,nind_ngbl
    !mp !write(u6,*) 'maxdim = ',maxdim

    ! - read amplitudes from T2_ngaf_ngbf ...  T2_ngaf_ngbl, nga>=ngb
    !                           ....               ....
    !                        T2ngal_ngbf  ...  T2_ngal_ngbl, nga>=ngb

    ! - calculate memory requirements (consider squared T2(a',a'))

    length1 = 0
    do i_blk=ngaf,ngal
      length1 = length1+DimGrpaR(i_blk)
    end do

    length2 = 0
    do j_blk=ngbf,ngbl
      length2 = length2+DimGrpaR(j_blk)
    end do

    !mp !write(u6,*) 'length1, vblock = ',length1,vblock
    !mp !write(u6,*) 'length2, vblock = ',length2,vblock

    length = length1*length2*no*no
    !mp !write(u6,*) 'length for blocked T2 amplitudes = ',length

    ! - setup memory

    !mp !write(u6,*) 'allocating t2_exp = ',length
    call mma_allocate(t2_exp,length,label='t2_exp')

    ! - read pertinent files and store them in the new blocked structure

    call mma_allocate(t2_tmp,maxdim*maxdim*no*no,label='t2_tmp')
    call mma_allocate(tmp,maxdim*maxdim*no*no,label='tmp')

    !switch = .false.
    call gather_t2_blocked(length1,length2,ngaf,ngal,ngbf,ngbl,t2_exp,t2_tmp,tmp)

    call mma_deallocate(tmp)
    call mma_deallocate(t2_tmp)

    t2_exp(:) = -t2_exp

    !mp
    do a=a1,a2
      B2 = B1-1+min(vblock,A-B1)
      NSTEP = B2-B1+1
      !mp !write(u6,*) 'NSTEP = ',NSTEP
      if (nstep /= 0) then
        if (nga == ngb) then
          IJS = nTri_Elem(a-a1-1)+1
          !!IJS = nTri_Elem(a-a1-1)+1
        else
          IJS = (a-a1)*vblock+1
        end if
        do R=1,K-1
          ! copies (b1..b2,a,r,k)-(b1..b2,a,k,r)
          !!KADT = nTri_Elem(K-2)+R
          !!KADT = (KADT-1)*NNUAB(ISP)
          ! address and block for the A1-A2x B1-B2
          !!KADT = KADT+nTri_Elem(a-2)+B1+IT-1
          ! T2 >>> K
          !!call dcopy_(NSTEP,G(KADT),1,G(IJS),1)
          !mpn KADT = (k-1)*noab(1)*NNUAB(3)+(r-1)*NNUAB(3)+(a-1)*nuab(1)+B1+IT-1
          !mpn AADT = (r-1)*noab(1)*NNUAB(3)+(k-1)*NNUAB(3)+(a-1)*nuab(1)+B1+IT-1

          a_tmp = a-nind_ngaf
          b1_tmp = b1-nind_ngbf
          !mp !write(u6,'(A,4(i5,2x))') 'b1,   a     ,r,k = ',b1,a,r,k
          !mp !write(u6,'(A,4(i5,2x))') 'a_tmp,b1_tmp,k,r = ',a_tmp,b1_tmp,k,r

          do j_tmp=0,NSTEP-1

            KADT = (r-1)*noab(1)*length1*length2+(k-1)*length1*length2+(b1_tmp+j_tmp-1)*length1+a_tmp

            AADT = (k-1)*noab(1)*length1*length2+(r-1)*length1*length2+(b1_tmp+j_tmp-1)*length1+a_tmp

            x(IJS+j_tmp) = t2_exp(AADT)-t2_exp(KADT)
            !mp !write(u6,'(A,2(i5,2x),3(f18.10,2x))') 'XXXN = ',a_tmp,b1_tmp+j_tmp-1,x(IJS+j_tmp),t2_exp(AADT),t2_exp(KADT)

          end do

          !mp call vsub(G(KADT),1,G(AADT),1,G(IJS),1,NSTEP)
          !mpn x(IJS:IJS+NSTEP-1) = t2_exp(AADT:AADT+NSTEP-1)-t2_exp(KADT:KADT+NSTEP-1)
          !!write(u6,'(A,3I3,8D15.8)') 'T',K,R,a,(G(I),I=IJS,IJS+NSTEP-1)
          IJS = IJS+maxdimm
        end do      ! R
        !mp call zeroma(G(IJS),1,NSTEP)
        x(IJS:IJS+NSTEP-1) = Zero
        IJS = IJS+maxdimm
        ! T2 >>> K  (transposed)
        ! copies (b1..b2,a,r,k)-(b1..b2,a,k,r)
        !mpn

        ! (b1..b2,a,r,k) =? (a,b1...b2,k,r)
        ! (b1..b2,a,k,r) =? (a,b1...b2,r,k)

        !mpn
        do R=K+1,NOAB(ISP)
          !!KADT = nTri_Elem(R-2)+K
          !!KADT = (KADT-1)*NNUAB(ISP)
          !!KADT = KADT+nTri_Elem(a-2)+B1+IT-1
          !!call vneg_cht3(G(KADT),1,G(IJS),1,NSTEP)

          !mpn KADT = (k-1)*noab(1)*NNUAB(3)+(r-1)*nnUab(3)+(a-1)*nuab(1)+B1+IT-1
          !mpn AADT = (r-1)*noab(1)*NNUAB(3)+(k-1)*nnUab(3)+(a-1)*nuab(1)+B1+IT-1

          a_tmp = a-nind_ngaf
          b1_tmp = b1-nind_ngbf
          !mp !write(u6,'(A,4(i5,2x))') 'b1,   a     ,r,k = ',b1,a,r,k
          !mp !write(u6,'(A,4(i5,2x))') 'a_tmp,b1_tmp,k,r = ',a_tmp,b1_tmp,k,r

          do j_tmp=0,NSTEP-1

            KADT = (r-1)*noab(1)*length1*length2+(k-1)*length1*length2+(b1_tmp+j_tmp-1)*length1+a_tmp

            AADT = (k-1)*noab(1)*length1*length2+(r-1)*length1*length2+(b1_tmp+j_tmp-1)*length1+a_tmp

            x(IJS+j_tmp) = t2_exp(AADT)-t2_exp(KADT)
            !mp write(u6,'(A,2(i5,2x),3(f18.10,2x))') 'XXXN = ',a_tmp,b1_tmp+j_tmp-1,x(IJS+j_tmp),t2_exp(AADT),t2_exp(KADT)

          end do

          !mp call vsub(G(KADT),1,G(AADT),1,G(IJS),1,NSTEP)
          !mpn x(IJS:IJS+NSTEP-1) = t2_exp(AADT:AADT+NSTEP-1)-t2_exp(KADT:KADT+NSTEP-1)
          !!write(u6,'(A,3I3,8D15.8)') 'T',K,R,a,(G(I),I=IJS,IJS+NSTEP-1)
          !!call daxpy_(NSTEP,-One,G(KADT),1,G(IJS),1)
          IJS = IJS+maxdimm
        end do      ! R
        ! <VV|VO> >>> K original for aaaa
        ! (VV|VO( >>> K now          aabb needed (AR|BK)-(BR|AK)

        !!call EXPA1_UHF(G(IJS),1,NUAB(IS2),1,G(ISCR))
        !!KADT = IG-1+nTri_Elem(a-2)+B1
        KADT = (B1-1)*NNU
        AADT = (A-1)*NNU
        do R=1,NUAB(ISP)
          !!call dcopy_(NSTEP,G(KADT),1,G(IJS),1)
          ! first (AR|BK)
          !mp call dcopy_(NSTEP,G(KADT+iTri(a,r)),NNU,G(IJS),1)
          call dcopy_(NSTEP,g(KADT+iTri(a,r)),NNU,x(IJS),1)
          ! now  -(BR|AK)
          KI = IJS
          do B=B1,B2
            !mp G(KI) = G(KI)-G(AADT+iTri(B,R))
            x(KI) = x(KI)-g(AADT+iTri(B,R))
            KI = KI+1
          end do
          !!write(u6,'(A,3I3,8D15.8)') 'V',K,R,a,(G(I),I=IJS,IJS+NSTEP-1)
          IJS = IJS+maxdimm
          !!KADT = KADT+NNUAB(ISP)
        end do   !R
      end if     ! nstep == 0
    end do       !A
    !  <VV|VO> >>> K
    !mp !write(u6,'(A,5I5,4x,5D15.10)') 'block-w: K,a1,b1,IAS,ddot',K,a1,b1,ias,maxdim,ddot_(N*maxdim,x,1,x,1),x(1:4)
    !mp !write(u6,'(A,5I5,4x,5D15.10)') 'block-w: K,a1,b1,IAS,ddot',K,a1,b1,ias,maxdim,ddot_(N*maxdim,G(IX),1,G(IX),1), &
    !                                   (G(I),I=IX,IX+3)
    !mp  call multi_wridir(G(IX),N*maxdim,LU,IAS, last)
    !mp
    !mp !!do jjj=1,N*maxdimm
    !mp !!  if (abs(x(jjj)) > 1.0e5_wp) then
    !mp !!    write(u6,*) 'prasa 3 ',jjj,x(jjj)
    !mp !!    stop
    !mp !!  end if
    !mp !!end do
    !mp
    call multi_wridir(x,N*maxdimm,LU,IAS,last)
    ias = ias+iasblock
    !mpn
    !mp write(u6,*) 'deallocating t2_exp = ',length
    call mma_deallocate(t2_exp)
    !mpn
  end do       ! ngb
end do         ! nga
!!end do         ! K
!mp !write(u6,'(A,10I5)') 'leaving klvaa_vvv',vblock,N,nug,lu,last,iasblock,K,ias
call xflush(u6)
!!stop

return

end subroutine klvaa_vvv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine setstrtvb_cvb(recn)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      save recdef
      data recdef/3200.2d0/

      if(recn.ne.zero)return
      if(.not.tstfile_cvb(recdef))return
      do 100 iadd=1,99
      if(.not.tstfile_cvb(recdef+DBLE(iadd)))then
        jadd=iadd-1
        recn=recdef+DBLE(jadd)
        return
      endif
100   continue
      return
      end
      subroutine setsavvb_cvb(recn)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      save recdef
      data recdef/3200.2d0/
      if(recn.ne.zero)return
      do 200 iadd=0,99
      if(.not.tstfile_cvb(recdef+DBLE(iadd)))then
        recn=recdef+DBLE(iadd)
        return
      endif
200   continue
      recn=recdef+DBLE(99)
      return
      end
      logical function ifmos_cvb()
      implicit real*8 (a-h,o-z)

      ifmos_cvb=.true.
      return
      end
      logical function ifcasci_cvb()
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "applyh_cvb.fh"

      call f_inquire('JOBOLD',ifcasci_cvb)
c  In variational calculations, CI vectors will be of no use
c  unless they correspond to MOs identical to the present ones :
      if(variat.and.(invec_cvb.ne.3.or.nmcscf.gt.1))ifcasci_cvb=.false.
      return
      end
      logical function ifhamil_cvb()
      implicit real*8 (a-h,o-z)
      ifhamil_cvb=.true.
      return
      end
      logical function valid_cvb(fileid)
      implicit real*8 (a-h,o-z)

      valid_cvb=(fileid.ge.1d-2)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine rumer_cvb(bikcof,
     > nel,nalf,nbet,ndet,ifns,kbasis,iprint,nswpdim,
     > minspn,maxspn,nkspn,
     > minswp,maxswp,nkswp,ioccswp,locca,lnocca,
     > xdet,xspin,iw,
     > ialfs,ibets)
      implicit real*8 (a-h,o-w,y-z),integer(x)
      dimension bikcof(ndet,ifns)
      dimension minspn(0:nel), maxspn(0:nel), nkspn(0:nel)
      dimension minswp(0:2*nbet), maxswp(0:2*nbet)
      dimension nkswp(0:2*nbet)
      dimension ioccswp(nbet,nswpdim)
      dimension locca(nel), lnocca(nel)
      dimension xdet(0:nel,0:nalf),xspin((nel+1)*(nalf+1)),
     > iw(nel)
      dimension ialfs(nalf),ibets(nbet)
      save one
      data one/1.0d0/

      call fzero(bikcof,ifns*ndet)

c Determinant weight array (index from alpha spin string):
      call weightfl_cvb(xdet,nalf,nel)
      if(ndet.ne.xdet(nel,nalf))then
        write(6,*) ' Discrepancy in NDET:',ndet,xdet(nel,nalf)
        call abend_cvb()
      endif

c
c Rumer spin functions
c
      if(iprint.ge.2.and.(kbasis.eq.3.or.kbasis.eq.4))
     >  write(6,6100) 2**nbet
      abphase=DBLE(1-2*mod(nbet*(nbet-1)/2,2))

c Prepare NKs for a<->b interchanges in (ab-ba) terms :
      nbet2=nbet+nbet
      do 1000 iorb=0,nbet2
      minswp(iorb)=iorb/2
      maxswp(iorb)=(iorb+1)/2
1000  continue
      call imove_cvb(maxswp,nkswp,nbet2+1)
      iswp=0
1100  iswp=iswp+1
      do 1200 ia=1,nbet
      ioccswp(ia,iswp)=nkswp(2*ia)-nkswp(2*ia-1)
1200  continue
      call loop_cvb(nbet2,nkswp,minswp,maxswp,*1100)

c Spin function weight arrays:
      do 2000 iorb=0,nel
      minspn(iorb)=max(iorb-nalf,0)
      maxspn(iorb)=min(iorb/2,nbet)
2000  continue
      call weight_cvb(xspin,minspn,maxspn,nbet,nel)
      if(ifns.ne.xspin((nel+1)*(nbet+1)).and.kbasis.ne.6)then
        write(6,*) ' Discrepancy in IFNS:',ifns,xspin((nel+1)*(nbet+1))
        call abend_cvb()
      endif
      call imove_cvb(maxspn,nkspn,nel+1)
      call occupy_cvb(nkspn,nel,locca,lnocca)

c Loop:
      index=1
c Determine pairings
2100  continue
      if(kbasis.eq.6.and.index.gt.ifns)goto 3300
      do 2200 ib=1,nbet
      ibets(ib)=locca(ib)
      do 2300 ia=nalf,1,-1
      ialfs(ib)=lnocca(ia)
      if(ialfs(ib).lt.ibets(ib))then
        do 2400 iachek=1,ib-1
        if(ialfs(iachek).eq.ialfs(ib))goto 2300
2400    continue
        goto 2500
      endif
2300  continue
2500  continue
2200  continue
      do 2600 ib=nbet+1,nalf
      do 2700 ia=1,nalf
      ialfs(ib)=lnocca(ia)
      do 2800 iachek=1,ib-1
      if(ialfs(iachek).eq.ialfs(ib))goto 2700
2800  continue
      goto 2600
2700  continue
2600  continue

      if(iprint.ge.2.and.(kbasis.eq.3.or.kbasis.eq.4))
     >  write(6,6200) index,(ialfs(ii),ibets(ii),ii=1,nbet)

      if(kbasis.eq.4)then
        bikvalue=one
      else
        bikvalue=abphase*party_cvb(ialfs,nalf)*party_cvb(ibets,nbet)
      endif

      do 3000 iswp=1,nswpdim
      call izero(iw,nel)
      do 3100 ia=1,nalf
      iw(ialfs(ia))=1
3100  continue
      do 3200 ia=1,nbet
      if(ioccswp(ia,iswp).ne.0)then
c  IA => alpha electron in position number 2 (= swap).
        iw(ialfs(ia))=0
        iw(ibets(ia))=1
      endif
3200  continue
      bikcof(indget_cvb(iw,nalf,nel,xdet),index)=bikvalue
3000  continue
      call loind_cvb(nel,nbet,nkspn,minspn,maxspn,
     >                       locca,lnocca,index,xspin,*2100)
3300  continue

c Normalise
      scale=one/sqrt(dble(2**nbet))
      call dscal_(ndet*ifns,scale,bikcof,1)
      return
6100  format(/,' Number of determinants per structure:',i4)
6200  format(2x,i3,' ==> ',8(i2,'-',i2,3x))
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_FCI(UsePartPermSym,
     &                   nD,FactC,ip_DBlocks,ip_FBlocks)
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: Compute Coulomb contribution to Fock matrix using
C              conventional integrals (debug code).
C
      Implicit None
      Logical UsePartPermSym
      Integer nD
      Real*8  FactC(nD)
      Integer ip_DBlocks(nD)
      Integer ip_FBlocks(nD)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Integer AB, CD
      Integer A, B, C, D
      Integer nAB, nCD
      Integer ip_Int, l_Int
      Integer iD
      Integer ipD, ipF

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      If (UsePartPermSym) Then ! use particle permutation symmetry
         Do AB=1,NumberOfAtomPairs
            A=AP_Atoms(1,AB)
            B=AP_Atoms(2,AB)
            nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
            Do CD=1,AB-1
               C=AP_Atoms(1,CD)
               D=AP_Atoms(2,CD)
               nCD=LDF_nBas_Atom(C)*LDF_nBas_Atom(D)
               l_Int=nAB*nCD
               Call GetMem('FCIInt','Allo','Real',ip_Int,l_Int)
               Call LDF_ComputeValenceIntegrals(AB,CD,
     &                                          l_Int,Work(ip_Int))
               Do iD=1,nD
                  ipD=iWork(ip_DBlocks(iD)-1+CD)
                  ipF=iWork(ip_FBlocks(iD)-1+AB)
                  Call dGeMV_('N',nAB,nCD,
     &                       FactC(iD),Work(ip_Int),max(nAB,1),
     &                       Work(ipD),1,1.0d0,Work(ipF),1)
               End Do
               Do iD=1,nD
                  ipD=iWork(ip_DBlocks(iD)-1+AB)
                  ipF=iWork(ip_FBlocks(iD)-1+CD)
                  Call dGeMV_('T',nAB,nCD,
     &                       FactC(iD),Work(ip_Int),max(nAB,1),
     &                       Work(ipD),1,1.0d0,Work(ipF),1)
               End Do
               Call GetMem('FCIInt','Free','Real',ip_Int,l_Int)
            End Do
            l_Int=nAB**2
            Call GetMem('FCIInt','Allo','Real',ip_Int,l_Int)
            Call LDF_ComputeValenceIntegrals(AB,AB,
     &                                       l_Int,Work(ip_Int))
            Do iD=1,nD
               ipD=iWork(ip_DBlocks(iD)-1+AB)
               ipF=iWork(ip_FBlocks(iD)-1+AB)
               Call dGeMV_('N',nAB,nAB,
     &                    FactC(iD),Work(ip_Int),max(nAB,1),
     &                    Work(ipD),1,1.0d0,Work(ipF),1)
            End Do
            Call GetMem('FCIInt','Free','Real',ip_Int,l_Int)
         End Do
      Else
         Do AB=1,NumberOfAtomPairs
            A=AP_Atoms(1,AB)
            B=AP_Atoms(2,AB)
            nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
            Do CD=1,NumberOfAtomPairs
               C=AP_Atoms(1,CD)
               D=AP_Atoms(2,CD)
               nCD=LDF_nBas_Atom(C)*LDF_nBas_Atom(D)
               l_Int=nAB*nCD
               Call GetMem('FCIInt','Allo','Real',ip_Int,l_Int)
               Call LDF_ComputeValenceIntegrals(AB,CD,
     &                                          l_Int,Work(ip_Int))
               Do iD=1,nD
                  ipD=iWork(ip_DBlocks(iD)-1+CD)
                  ipF=iWork(ip_FBlocks(iD)-1+AB)
                  Call dGeMV_('N',nAB,nCD,
     &                       FactC(iD),Work(ip_Int),nAB,Work(ipD),1,
     &                       1.0d0,Work(ipF),1)
               End Do
               Call GetMem('FCIInt','Free','Real',ip_Int,l_Int)
            End Do
         End Do
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MKLIST(LIST)
      USE SUPERINDEX
      IMPLICIT NONE
C Subroutine for setting up the 17 lists of coupling
C  coefficients -- See sgm.f and sgm.ol for usage.
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"

      INTEGER LIST(*)

      INTEGER IA,IB,II,IJ,IT,IU
      INTEGER IAB,IIJ,ITU,ITU1,ITU2,IUT1,IUT2,IUV,IUU2
      INTEGER ITUV,IUTV,IUVT,IVTU,IVUT
      INTEGER IAQ,IBQ,IIQ,IJQ,ITQ,IUQ,IVQ,IUVQ
      INTEGER ILIST,ISL1,ISL2,ISL3
      INTEGER LADR,LADR1,LADR2,LADR3,LADR4,LADR5,LADR6,LADR7,LADR8,
     &        LADR9,LADR10,LADR11,LADR12,LADR13,LADR14,LADR15,
     &        LADR16,LADR17
      INTEGER NOFF


      LADR=1
      DO ILIST=1,17
       DO ISL1=1,NSYM
        DO ISL3=1,NSYM
         LLIST(ISL1,ISL3,ILIST)=LADR
         LADR=LADR+4*NLIST(ISL1,ISL3,ILIST)
        END DO
       END DO
      END DO

C Lists 1 and 2. TUV/TU*
      DO ISL1=1,NSYM
       DO ISL3=1,NSYM
        LADR1 =LLIST(ISL1,ISL3,1)
        LADR2 =LLIST(ISL1,ISL3,2)
        ISL2=MUL(ISL1,ISL3)
        DO IT=1,NASH(ISL2)
          ITQ=IT+NAES(ISL2)
          DO IUV=1,NTU(ISL3)
            IUVQ=IUV+NTUES(ISL3)
            IUQ=MTU(1,IUVQ)
            IVQ=MTU(2,IUVQ)
            ITUV=KTUV(ITQ,IUQ,IVQ)-NTUVES(ISL1)
            IUTV=KTUV(IUQ,ITQ,IVQ)-NTUVES(ISL1)
C Add to list 1: ITUV,IT,IUV,V=1
C Add to list 1: IUTV,IT,IUV+NTU(ISL3),V=1
            LIST(LADR1)=ITUV
            LIST(LADR1+1)=IT
            LIST(LADR1+2)=IUV
            LIST(LADR1+3)=1
            LADR1=LADR1+4
            LIST(LADR1)=IUTV
            LIST(LADR1+1)=IT
            LIST(LADR1+2)=IUV+NTU(ISL3)
            LIST(LADR1+3)=1
            LADR1=LADR1+4
            IVUT=KTUV(IVQ,IUQ,ITQ)-NTUVES(ISL1)
C Add to list 2: ITUV,IT,IUV,V=1
C Add to list 2: IVUT,IT,IUV+NTU(ISL3),V=-1
            LIST(LADR2)=ITUV
            LIST(LADR2+1)=IT
            LIST(LADR2+2)=IUV
            LIST(LADR2+3)=1
            LADR2=LADR2+4
            LIST(LADR2)=IVUT
            LIST(LADR2+1)=IT
            LIST(LADR2+2)=IUV+NTU(ISL3)
            LIST(LADR2+3)=2
            LADR2=LADR2+4
          END DO
         END DO
        END DO
       END DO

C Lists 3 and 5. TUV/TU+
      DO ISL1=1,NSYM
       DO ISL3=1,NSYM
        LADR3 =LLIST(ISL1,ISL3,3)
        LADR5 =LLIST(ISL1,ISL3,5)
        ISL2=MUL(ISL1,ISL3)
        DO IT=1,NASH(ISL2)
          ITQ=IT+NAES(ISL2)
          DO IUV=1,NTGEU(ISL3)
            IUVQ=IUV+NTGEUES(ISL3)
            IUQ=MTGEU(1,IUVQ)
            IVQ=MTGEU(2,IUVQ)
            IUVT=KTUV(IUQ,IVQ,ITQ)-NTUVES(ISL1)
            IUTV=KTUV(IUQ,ITQ,IVQ)-NTUVES(ISL1)
            IF(IUQ.EQ.IVQ) THEN
C Add to list 3: IUVT,IT,IUV,V=2
C Add to list 5: IUTV,IT,IUV,V=2
              LIST(LADR3)=IUVT
              LIST(LADR3+1)=IT
              LIST(LADR3+2)=IUV
              LIST(LADR3+3)=2
              LADR3=LADR3+4
              LIST(LADR5)=IUTV
              LIST(LADR5+1)=IT
              LIST(LADR5+2)=IUV
              LIST(LADR5+3)=2
              LADR5=LADR5+4
            ELSE
              IVUT=KTUV(IVQ,IUQ,ITQ)-NTUVES(ISL1)
              IVTU=KTUV(IVQ,ITQ,IUQ)-NTUVES(ISL1)
C Add to list 3: IUVT,IT,IUV,V=1
C Add to list 3: IVUT,IT,IUV,V=1
C Add to list 5: IUTV,IT,IUV,V=1
C Add to list 5: IVTU,IT,IUV,V=1
              LIST(LADR3)=IUVT
              LIST(LADR3+1)=IT
              LIST(LADR3+2)=IUV
              LIST(LADR3+3)=1
              LADR3=LADR3+4
              LIST(LADR3)=IVUT
              LIST(LADR3+1)=IT
              LIST(LADR3+2)=IUV
              LIST(LADR3+3)=1
              LADR3=LADR3+4
              LIST(LADR5)=IUTV
              LIST(LADR5+1)=IT
              LIST(LADR5+2)=IUV
              LIST(LADR5+3)=1
              LADR5=LADR5+4
              LIST(LADR5)=IVTU
              LIST(LADR5+1)=IT
              LIST(LADR5+2)=IUV
              LIST(LADR5+3)=1
              LADR5=LADR5+4
            END IF
          END DO
         END DO
        END DO
       END DO

C Lists 4 and 6. TUV/TU-
      DO ISL1=1,NSYM
       DO ISL3=1,NSYM
        LADR4 =LLIST(ISL1,ISL3,4)
        LADR6 =LLIST(ISL1,ISL3,6)
        ISL2=MUL(ISL1,ISL3)
        DO IT=1,NASH(ISL2)
          ITQ=IT+NAES(ISL2)
          DO IUV=1,NTGTU(ISL3)
            IUVQ=IUV+NTGTUES(ISL3)
            IUQ=MTGTU(1,IUVQ)
            IVQ=MTGTU(2,IUVQ)
            IUVT=KTUV(IUQ,IVQ,ITQ)-NTUVES(ISL1)
            IUTV=KTUV(IUQ,ITQ,IVQ)-NTUVES(ISL1)
            IVUT=KTUV(IVQ,IUQ,ITQ)-NTUVES(ISL1)
            IVTU=KTUV(IVQ,ITQ,IUQ)-NTUVES(ISL1)
C Add to list 4: IUVT,IT,IUV,V=1
C Add to list 4: IVUT,IT,IUV,V=-1
C Add to list 6: IUTV,IT,IUV,V=1
C Add to list 6: IVTU,IT,IUV,V=-1
            LIST(LADR4)=IUVT
            LIST(LADR4+1)=IT
            LIST(LADR4+2)=IUV
            LIST(LADR4+3)=1
            LADR4=LADR4+4
            LIST(LADR4)=IVUT
            LIST(LADR4+1)=IT
            LIST(LADR4+2)=IUV
            LIST(LADR4+3)=2
            LADR4=LADR4+4
            LIST(LADR6)=IUTV
            LIST(LADR6+1)=IT
            LIST(LADR6+2)=IUV
            LIST(LADR6+3)=1
            LADR6=LADR6+4
            LIST(LADR6)=IVTU
            LIST(LADR6+1)=IT
            LIST(LADR6+2)=IUV
            LIST(LADR6+3)=2
            LADR6=LADR6+4
          END DO
         END DO
        END DO
       END DO

C Lists 7 and 8. TU*/T
      DO ISL1=1,NSYM
       DO ISL3=1,NSYM
        LADR7 =LLIST(ISL1,ISL3,7)
        LADR8 =LLIST(ISL1,ISL3,8)
        ISL2=MUL(ISL1,ISL3)
        NOFF=NTU(ISL1)
        DO IT=1,NASH(ISL2)
          ITQ=IT+NAES(ISL2)
          DO IU=1,NASH(ISL3)
            IUQ=IU+NAES(ISL3)
            IUT1=KTU(IUQ,ITQ)-NTUES(ISL1)
            IUT2=IUT1+NOFF
C Add to list 7: IUT1,IT,IU,V=
C Add to list 7: IUT2,IT,IU,V=
            LIST(LADR7)=IUT1
            LIST(LADR7+1)=IT
            LIST(LADR7+2)=IU
            LIST(LADR7+3)=1
            LADR7=LADR7+4
            LIST(LADR7)=IUT2
            LIST(LADR7+1)=IT
            LIST(LADR7+2)=IU
            LIST(LADR7+3)=2
            LADR7=LADR7+4
C Add to list 8: ITU1,IT,IU,V=
C Add to list 8: ITU2,IT,IU,V=
            ITU1=KTU(ITQ,IUQ)-NTUES(ISL1)
            ITU2=ITU1+NOFF
            LIST(LADR8)=ITU1
            LIST(LADR8+1)=IT
            LIST(LADR8+2)=IU
            LIST(LADR8+3)=1
            LADR8=LADR8+4
            LIST(LADR8)=ITU2
            LIST(LADR8+1)=IT
            LIST(LADR8+2)=IU
            LIST(LADR8+3)=2
            LADR8=LADR8+4
          END DO
         END DO
        END DO
       END DO

C Lists  9 and 10. TU+-/T
      DO ISL1=1,NSYM
       DO ISL3=1,NSYM
        LADR9 =LLIST(ISL1,ISL3,9)
        LADR10=LLIST(ISL1,ISL3,10)
        ISL2=MUL(ISL1,ISL3)
        DO IT=1,NASH(ISL2)
          ITQ=IT+NAES(ISL2)
          DO IU=1,NASH(ISL3)
            IUQ=IU+NAES(ISL3)
            IF(ITQ.GT.IUQ) THEN
              ITU=KTGEU(ITQ,IUQ)-NTGEUES(ISL1)
C Add to list  9: ITU,IT,IU,V= 1/Sqr(2)
              LIST(LADR9)=ITU
              LIST(LADR9+1)=IT
              LIST(LADR9+2)=IU
              LIST(LADR9+3)=1
              LADR9=LADR9+4
              ITU=KTGTU(ITQ,IUQ)-NTGTUES(ISL1)
C Add to list 10: ITU,IT,IU,V= 1/Sqr(6)
              LIST(LADR10)=ITU
              LIST(LADR10+1)=IT
              LIST(LADR10+2)=IU
              LIST(LADR10+3)=1
              LADR10=LADR10+4
            ELSE IF(ITQ.LT.IUQ) THEN
              ITU=KTGEU(IUQ,ITQ)-NTGEUES(ISL1)
C Add to list  9: ITU,IT,IU,V= 1/Sqr(2)
              LIST(LADR9)=ITU
              LIST(LADR9+1)=IT
              LIST(LADR9+2)=IU
              LIST(LADR9+3)=1
              LADR9=LADR9+4
              ITU=KTGTU(IUQ,ITQ)-NTGTUES(ISL1)
C Add to list 10: ITU,IT,IU,V=-1/Sqr(6)
              LIST(LADR10)=ITU
              LIST(LADR10+1)=IT
              LIST(LADR10+2)=IU
              LIST(LADR10+3)=2
              LADR10=LADR10+4
            ELSE
              ITU=KTGEU(ITQ,IUQ)-NTGEUES(ISL1)
C Add to list  9: ITU,IT,IU,V= 1/Sqr(2)
              LIST(LADR9)=ITU
              LIST(LADR9+1)=IT
              LIST(LADR9+2)=IU
              LIST(LADR9+3)=2
              LADR9=LADR9+4
            END IF
          END DO
         END DO
        END DO
       END DO

C Lists 12 and 13. T/TU+-
      DO ISL1=1,NSYM
       DO ISL3=1,NSYM
        LADR12=LLIST(ISL1,ISL3,12)
        LADR13=LLIST(ISL1,ISL3,13)
        ISL2=MUL(ISL1,ISL3)
        DO IT=1,NASH(ISL1)
          ITQ=IT+NAES(ISL1)
          DO IU=1,NASH(ISL2)
            IUQ=IU+NAES(ISL2)
            IF(ITQ.GT.IUQ) THEN
              ITU=KTGEU(ITQ,IUQ)-NTGEUES(ISL3)
C Add to list 12: IT,IU,ITU,V= 1
              LIST(LADR12)=IT
              LIST(LADR12+1)=IU
              LIST(LADR12+2)=ITU
              LIST(LADR12+3)=1
              LADR12=LADR12+4
              ITU=KTGTU(ITQ,IUQ)-NTGTUES(ISL3)
C Add to list 13: IT,IU,ITU,V= 1
              LIST(LADR13)=IT
              LIST(LADR13+1)=IU
              LIST(LADR13+2)=ITU
              LIST(LADR13+3)=1
              LADR13=LADR13+4
            ELSE IF(ITQ.LT.IUQ) THEN
              ITU=KTGEU(IUQ,ITQ)-NTGEUES(ISL3)
C Add to list 12: IT,IU,ITU,V= 1
              LIST(LADR12)=IT
              LIST(LADR12+1)=IU
              LIST(LADR12+2)=ITU
              LIST(LADR12+3)=1
              LADR12=LADR12+4
              ITU=KTGTU(IUQ,ITQ)-NTGTUES(ISL3)
C Add to list 13: IT,IU,ITU,V=-1
              LIST(LADR13)=IT
              LIST(LADR13+1)=IU
              LIST(LADR13+2)=ITU
              LIST(LADR13+3)=2
              LADR13=LADR13+4
            ELSE
              ITU=KTGEU(ITQ,IUQ)-NTGEUES(ISL3)
C Add to list 12: IT,IU,ITU,V= 2
              LIST(LADR12)=IT
              LIST(LADR12+1)=IU
              LIST(LADR12+2)=ITU
              LIST(LADR12+3)=2
              LADR12=LADR12+4
            END IF
          END DO
         END DO
        END DO
       END DO

C List 11. T/TU*
      DO ISL1=1,NSYM
       DO ISL3=1,NSYM
        LADR11=LLIST(ISL1,ISL3,11)
        ISL2=MUL(ISL1,ISL3)
        NOFF=NTU(ISL3)
        DO IT=1,NASH(ISL1)
          ITQ=IT+NAES(ISL1)
          DO IU=1,NASH(ISL2)
            IUQ=IU+NAES(ISL2)
            IUT2=NOFF+KTU(IUQ,ITQ)-NTUES(ISL3)
C Add to list 11: IT,IU,IUT2,V= 2
            LIST(LADR11)=IT
            LIST(LADR11+1)=IU
            LIST(LADR11+2)=IUT2
            LIST(LADR11+3)=1
            LADR11=LADR11+4
          END DO
          IF(ISL3.EQ.1) THEN
           DO IUQ=1,NASHT
            IUU2=NOFF+KTU(IUQ,IUQ)-NTUES(ISL3)
C Add to list 11: IT,IT,IUU2,V= 1
            LIST(LADR11)=IT
            LIST(LADR11+1)=IT
            LIST(LADR11+2)=IUU2
            LIST(LADR11+3)=2
            LADR11=LADR11+4
           END DO
          END IF
         END DO
        END DO
       END DO

C Lists 14 and 15. I/IJ+-
      DO ISL1=1,NSYM
       DO ISL3=1,NSYM
        LADR14=LLIST(ISL1,ISL3,14)
        LADR15=LLIST(ISL1,ISL3,15)
        ISL2=MUL(ISL1,ISL3)
        DO II=1,NISH(ISL1)
          IIQ=II+NIES(ISL1)
          DO IJ=1,NISH(ISL2)
            IJQ=IJ+NIES(ISL2)
            IF(IIQ.GT.IJQ) THEN
              IIJ=KIGEJ(IIQ,IJQ)-NIGEJES(ISL3)
C Add to list 14: II,IJ,IIJ,V= 1
              LIST(LADR14)=II
              LIST(LADR14+1)=IJ
              LIST(LADR14+2)=IIJ
              LIST(LADR14+3)=1
              LADR14=LADR14+4
              IIJ=KIGTJ(IIQ,IJQ)-NIGTJES(ISL3)
C Add to list 15: II,IJ,IIJ,V= 1
              LIST(LADR15)=II
              LIST(LADR15+1)=IJ
              LIST(LADR15+2)=IIJ
              LIST(LADR15+3)=1
              LADR15=LADR15+4
            ELSE IF(IIQ.LT.IJQ) THEN
              IIJ=KIGEJ(IJQ,IIQ)-NIGEJES(ISL3)
C Add to list 14: II,IJ,IIJ,V= 1
              LIST(LADR14)=II
              LIST(LADR14+1)=IJ
              LIST(LADR14+2)=IIJ
              LIST(LADR14+3)=1
              LADR14=LADR14+4
              IIJ=KIGTJ(IJQ,IIQ)-NIGTJES(ISL3)
C Add to list 15: II,IJ,IIJ,V=-1
              LIST(LADR15)=II
              LIST(LADR15+1)=IJ
              LIST(LADR15+2)=IIJ
              LIST(LADR15+3)=2
              LADR15=LADR15+4
            ELSE
              IIJ=KIGEJ(IIQ,IJQ)-NIGEJES(ISL3)
C Add to list 14: II,IJ,IIJ,V= Sqr(2)
              LIST(LADR14)=II
              LIST(LADR14+1)=IJ
              LIST(LADR14+2)=IIJ
              LIST(LADR14+3)=2
              LADR14=LADR14+4
            END IF
          END DO
         END DO
        END DO
       END DO

C Lists 16 and 17. A/AB+-
      DO ISL1=1,NSYM
       DO ISL3=1,NSYM
        LADR16=LLIST(ISL1,ISL3,16)
        LADR17=LLIST(ISL1,ISL3,17)
        ISL2=MUL(ISL1,ISL3)
        DO IA=1,NSSH(ISL1)
          IAQ=IA+NSES(ISL1)
          DO IB=1,NSSH(ISL2)
            IBQ=IB+NSES(ISL2)
            IF(IAQ.GT.IBQ) THEN
              IAB=KAGEB(IAQ,IBQ)-NAGEBES(ISL3)
C Add to list 16: IA,IB,IAB,V= 1
              LIST(LADR16)=IA
              LIST(LADR16+1)=IB
              LIST(LADR16+2)=IAB
              LIST(LADR16+3)=1
              LADR16=LADR16+4
              IAB=KAGTB(IAQ,IBQ)-NAGTBES(ISL3)
C Add to list 17: IA,IB,IAB,V= 1
              LIST(LADR17)=IA
              LIST(LADR17+1)=IB
              LIST(LADR17+2)=IAB
              LIST(LADR17+3)=1
              LADR17=LADR17+4
            ELSE IF(IAQ.LT.IBQ) THEN
              IAB=KAGEB(IBQ,IAQ)-NAGEBES(ISL3)
C Add to list 16: IA,IB,IAB,V= 1
              LIST(LADR16)=IA
              LIST(LADR16+1)=IB
              LIST(LADR16+2)=IAB
              LIST(LADR16+3)=1
              LADR16=LADR16+4
              IAB=KAGTB(IBQ,IAQ)-NAGTBES(ISL3)
C Add to list 17: IA,IB,IAB,V=-1
              LIST(LADR17)=IA
              LIST(LADR17+1)=IB
              LIST(LADR17+2)=IAB
              LIST(LADR17+3)=2
              LADR17=LADR17+4
            ELSE
              IAB=KAGEB(IAQ,IBQ)-NAGEBES(ISL3)
C Add to list 16: IA,IB,IAB,V= Sqr(2)
              LIST(LADR16)=IA
              LIST(LADR16+1)=IB
              LIST(LADR16+2)=IAB
              LIST(LADR16+3)=2
              LADR16=LADR16+4
            END IF
          END DO
         END DO
        END DO
       END DO


      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Start_Last_Energy()
      Implicit Real*8 (a-h,o-z)
      Character*16 StdIn
      Character*8 Method
#include "print.fh"
#include "stdalloc.fh"
      Logical Saddle, FoundLastEn
      Real*8, Dimension (:,:), Allocatable :: CN
      Interface
        Subroutine Get_Coord_New(CN,nCoord)
        Real*8, Dimension (:,:), Allocatable :: CN
        Integer nCoord
        End Subroutine
      End Interface
*                                                                      *
************************************************************************
*                                                                      *
      If (nPrint(1).ge.6) Then
         Write (6,*)
         Write (6,*) ' Slapaf requests the last energy to be computed!'
         Write (6,*)
      End If
*
      LuInput=11
      LuInput=IsFreeUnit(LuInput)
      Call StdIn_Name(StdIn)
      Call Molcas_Open(LuInput,StdIn)

      Call Get_iScalar('Grad ready',iGO)
*
      Write (LuInput,'(A)') '>ECHO OFF'
      Write (LuInput,'(A)') '>export SL_OLD_TRAP=$MOLCAS_TRAP'
      Write (LuInput,'(A)') '>export MOLCAS_TRAP=ON'
*
      Call qpg_dArray('Saddle',Saddle,nSaddle)
      If (Saddle) Then
*
*         Clean up among the runfiles, etc.
*
          Write (LuInput,'(A)')
     &          '>COPY $Project$SubProject.RunFile $Project.RunFile'

          Call qpg_cArray('LastEnergyMethod',FoundLastEn,lengthlast)
          If (FoundLastEn) Then
             Call Get_cArray('LastEnergyMethod',Method,8)
          Else
             Call Get_cArray('Relax Method',Method,8)
          EndIf

          If (Method .eq. 'CASSCF'   .or.
     &        Method .eq. 'RASSCF'   .or.
     &        Method .eq. 'CASSCFSA' .or.
     &        Method .eq. 'RASSCFSA' .or.
     &        Method .eq. 'CASPT2'   .or.
     &        Method .eq. 'RASPT2'   ) Then

             Write (LuInput,'(A)')
     &             '>COPY $Project$SubProject.JobIph $Project.JobIph'
             Write (LuInput,'(A)') '>RM $Project.Reac.JobIph'
             Write (LuInput,'(A)') '>RM $Project.Prod.JobIph'
          End If
          Write (LuInput,'(A)') '>RM $Project.Reac.RunFile'
          Write (LuInput,'(A)') '>RM $Project.Prod.RunFile'
          Write (LuInput,'(A)') '>export SubProject='
          Write (LuInput,'(A)') '>export MOLCAS_SADDLE=0'
*
*         Put the final structure as the reference structure
*
          Call Get_Coord_New(CN,nCoord)
          Call NameRun('RUNREAC')
          Call Put_dArray('Ref_Geom',CN,3*nCoord)
          Call NameRun('RUNPROD')
          Call Put_dArray('Ref_Geom',CN,3*nCoord)
          Call NameRun('RUNFILE')
          Call mma_deallocate(CN)
      End If
*
      If (iGo.le.1) Then
*
*        Normal behaviour
*
         Write (LuInput,'(A)') ' &Last_Energy &End'
         Write (LuInput,'(A)') 'End of Input'
*
      Else
*
*        A CI ISC search has been performed. For the moment I care only
*        for the ISC. Once the rest is done I will take care of that as
*        well.
*
         Write (LuInput,'(A)') '>COPY $OldProject.Seward.Input '
     &                       //'State1.Seward.Input'
         Write (LuInput,'(A)') '>COPY $OldProject.Seward.Input '
     &                       //'State2.Seward.Input'
         Write (LuInput,'(A)')'>COPY $OldProject.RunFile State1.RunFile'
         Write (LuInput,'(A)')'>COPY $OldProject.RunFile State2.RunFile'
         Write (LuInput,'(A)') '>RM molcas.env'
         Write (LuInput,'(A)') '>export Project=State1'
         Write (LuInput,'(A)') ' &Last_Energy &End'
         Write (LuInput,'(A)') 'End of Input'
         Write (LuInput,'(A)') '>RM molcas.env'
         Write (LuInput,'(A)') '>export Project=State2'
         Write (LuInput,'(A)') ' &Last_Energy &End'
         Write (LuInput,'(A)') 'End of Input'
      End If
      Write (LuInput,'(A)') '>export MOLCAS_TRAP=$SL_OLD_TRAP'
*
      Write (LuInput,'(A)') '>ECHO ON'

      Close(LuInput)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Jeppe Olsen                                      *
!               1989, Markus P. Fuelscher                              *
!               Giovanni Li Manni                                      *
!***********************************************************************

subroutine DiagOrd(PHPCSF,PHPCNF,IPORDCSF,IPORDCNF,MXPDIM,condition,iter,DTOC,IPRODT,ICONF,IREFSM,ONEBOD,ECORE,NACTOB,SCR,NCONF, &
                   NEL,NAEL,NBEL,TUVX,NTEST,ExFac,IREOTS)
! Obtain primary subspace and obtain
! explicit representation of Hamiltonian matrix in subspace
!
! ARGUMENTS :
! ===========
! PHPCSF  : Diagonal Hamiltonian matrix elements in CSF (output)
! PHPCNF  : Diagonal Hamiltonian matrix elements in CNF (output)
! IPORDCSF: index array containing energetic order in CSF (output)
! IPORDCNF: index array containing energetic order in CNF (output)
! IPCSF   : CSF's defining subspace (input)
! IPCNF   : Configurations defining subspace (input)
! MXPDIM  : Largest allowed dimension of subspace (Input)
! DTOC    : Transformation matrix between CSF's and DET's (input)
! IPRODT  : Prototype determinants (input)
! ICONF   : List of configurations  (input)
! IREFSM  : symmetry of considered CI space (input)
! Onebod  : one body hamilton matrix in rectangular form (input)
! ECORE   : Core energy (input)
! NACTOB  : Number of active orbitals (input)
! SCR     : Scratch array of length ????
! NCONF   : Number of configurations of symmetry IREFSM
! NPCNF   : = NCONF
! NPCSF   : = MXPDIM
! TUVX    : Two-electron integrals (MO space)
!
! IREOTS : Type => symmetry reordering array
!
!*********** Author: GLMJ ****************
!   history:
!     Jeppe Olsen, Summer of '89
!     adapted to DETRAS by M.P. Fuelscher, October 1989

use, intrinsic :: iso_c_binding, only: c_f_pointer, c_loc
use Constants, only: One
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: MXPDIM, IPORDCSF(MXPDIM), iter, IPRODT(*), ICONF(*), IREFSM, NACTOB, NCONF, NEL, NAEL, NBEL, &
                                 IREOTS(NACTOB)
real(kind=wp), intent(out) :: PHPCSF(MXPDIM), PHPCNF(NCONF)
integer(kind=iwp), intent(out) :: IPORDCNF(NCONF)
real(kind=wp), intent(in) :: condition, DTOC(*), ONEBOD(NACTOB,NACTOB), ECORE, TUVX(*), ExFac
real(kind=wp), intent(_OUT_) :: SCR(*)
integer(kind=iwp), intent(inout) :: NTEST
integer(kind=iwp) :: ICSFMN, IICNF, IICSF, IILACT, IILB, ILRI, ILTYP, IMIN, iTmpDimBlockA, iTmpDimBlockACNF, KLCNFO, KLCONF, &
                     KLCSFO, KLFREE, KLPHPS, KLSCRS, MXCSFC, NCSFL, NCSFMN, NIRREP, NJCNF, NPCNF, NPCSF
real(kind=wp) :: Acc, RefSplit, XMAX, XMIN
real(kind=wp), external :: FNDMNX
#include "spinfo.fh"
#include "splitcas.fh"

call DIAGORD_INTERNAL(SCR)

! This is to allow type punning without an explicit interface
contains

subroutine DIAGORD_INTERNAL(SCR)

  real(kind=wp), target :: SCR(*)
  integer(kind=iwp), pointer :: iSCR(:)
  integer(kind=iwp) :: i, ICNF, ICNL, IIL, ITYP

  ICSFMN = 0 ! dummy initialize to avoid warning

  ! construct the diagonal array out of the Hamiltonian matrix

  MXCSFC = 0
  do ITYP=1,NTYP
    MXCSFC = max(MXCSFC,NCSFTP(ITYP))
  end do

  KLFREE = 1
  KLCONF = KLFREE
  KLFREE = KLFREE+NEL
  KLFREE = KLFREE+NEL
  KLPHPS = KLFREE
  KLFREE = KLFREE+MXCSFC*MXCSFC
  KLSCRS = KLFREE
  KLFREE = KLFREE+MXCSFC
  KLCSFO = KLFREE
  KLFREE = KLFREE+MXPDIM
  KLCNFO = KLFREE
  KLFREE = KLFREE+NCONF

  IILB = 1
  do ICNL=1,NCONF
    !write(u6,*) 'IILB',IILB
    call c_f_pointer(c_loc(SCR(KLCONF)),iSCR,[1])
    call GETCNF_LUCIA(iSCR,ILTYP,ICNL,ICONF,IREFSM,NEL)
    nullify(iSCR)
    !call GETCNF_LUCIA(iSCR,ILTYP,IPCNF(ICNL),ICONF,IREFSM,NEL)
    NCSFL = NCSFTP(ILTYP)
    !write(u6,*) 'NCSFL = ',NCSFL
    !call xflush(u6)
    call c_f_pointer(c_loc(SCR(KLCONF)),iSCR,[1])
    call CNHCN(iSCR,ILTYP,iSCR,ILTYP,SCR(KLPHPS),SCR(KLFREE),NAEL,NBEL,ECORE,ONEBOD,IPRODT,DTOC,NACTOB,TUVX,NTEST,ExFac,IREOTS)
    nullify(iSCR)
    do IIL=1,NCSFL
      IILACT = IILB-1+IIL
      ILRI = IIL*IIL
      PHPCSF(IILACT) = SCR(KLPHPS-1+ILRI)
      !write(u6,*) 'IILACT, ILRI = ',IILACT,ILRI
      !write(u6,*) 'PHPCSF(IILACT)',PHPCSF(IILACT)
      !call xflush(u6)
      SCR(KLSCRS-1+IIL) = SCR(KLPHPS-1+ILRI)
    end do
    XMAX = -FNDMNX(SCR(KLSCRS),NCSFL,2)
    PHPCNF(ICNL) = XMAX
    !write(u6,*) 'PHPCNF(IILACT)',PHPCNF(ICNL)
    !call xflush(u6)
    IILB = IILB+NCSFL
  end do
  !*********************** ORDERING ***************************
  Acc = 1.0e-13_wp
  XMAX = FNDMNX(PHPCNF,NCONF,2)
  RefSplit = -XMAX
  NPCSF = 0
  NPCNF = 0
  ! To avoid warnings:
  iTmpDimBlockACNF = 0
  iTmpDimBlockA = 0

  !IFINIT = 0
  do
    XMIN = XMAX+One
    IMIN = 0
    IICNF = 1
    IICSF = 1
    do ITYP=1,NTYP
      NJCNF = NCNFTP(ITYP,IREFSM)
      NIRREP = NCSFTP(ITYP)
      do ICNF=1,NJCNF
        if (PHPCNF(IICNF)+Acc < XMIN) then
          XMIN = PHPCNF(IICNF)
          IMIN = IICNF
          !write(u6,*) 'IMIN         :',IMIN
          ICSFMN = IICSF
          NCSFMN = NIRREP
        end if
        IICNF = IICNF+1
        IICSF = IICSF+NIRREP
      end do
    end do
    !write(u6,*) 'XMIN         :',XMIN
    !write(u6,*) 'NPCSF+NCSFMN :',NPCSF+NCSFMN
    !if ((NPCSF+NCSFMN) <= MXPDIM) then
    SCR(KLCNFO+NPCNF) = PHPCNF(IMIN)
    NPCNF = NPCNF+1
    IPORDCNF(NPCNF) = IMIN
    !write(u6,*)'NPCNF, IPORDCNF(NPCNF) :', NPCNF,IPORDCNF(NPCNF)
    call ISTVC2(IPORDCSF(NPCSF+1),ICSFMN-1,1,NCSFMN)
    !write(u6,*) 'IPORDCSF(NPCSF) :',(IPORDCSF(NPCSF+i),i=1,NCSFMN)
    !call IVCPRT('IPORDCSF(NPCSF) :',' ', IPORDCSF(NPCSF+1),NCSFMN)
    NPCSF = NPCSF+NCSFMN

    if (iter == 1) then
      if (EnerSplit) then
        if ((PHPCNF(IMIN)-RefSplit) <= condition) then
          iDimBlockACNF = NPCNF
          iDimBlockA = NPCSF
        end if
      else if (PerSplit) then
        if ((real(NPCSF)/real(MXPDIM))*1.0e2_wp <= condition+Acc) then
          iDimBlockACNF = NPCNF
          iDimBlockA = NPCSF
        end if
      end if
    else
      if (NPCNF <= iDimBlockACNF) then
        iTmpDimBlockACNF = NPCNF
        iTmpDimBlockA = NPCSF
      end if
    end if

    PHPCNF(IMIN) = XMAX+One
    !else
    !  ! No space for this configuration, remove previous
    !  ! configurations with the same diagonal value
    !  IFINIT = 1
    !  IICNF = NPCNF+1
    !  do
    !    IICNF = IICNF-1
    !    DIAVAL = PHPCNF(IPORDCNF(IICNF))
    !    if (abs(DIAVAL-XMIN) > 1.0e-10_wp) exit
    !    NPCNF = NPCNF-1
    !    call GETCNF_LUCIA(SCR(KLFREE),ITYP,IPCNF(IICNF),ICONF,IREFSM,NEL)
    !    call GETCNF_LUCIA(PHPCNF(NCONF+1),ITYP,IPCNF(IICNF),ICONF,IREFSM,NEL)
    !    NPCSF = NPCSF-NCSFTP(ITYP)
    !  end do
    !end if
    !if ((IFINIT /= 0) .or. (NPCNF >= NCONF)) exit
    if (NPCNF >= NCONF) exit
  end do

  if (iter /= 1) then
    iDimBlockACNF = iTmpDimBlockACNF
    iDimBlockA = iTmpDimBlockA
    !write(u6,*) 'iDimBlockACNF, iDimBlockACSF',iDimBlockACNF,iDimBlockA
  end if

  do i=0,MXPDIM-1
    SCR(KLCSFO+i) = PHPCSF(IPORDCSF(i+1))
  end do

  call dcopy_(NCONF,SCR(KLCNFO),1,PHPCNF,1)
  call dcopy_(MXPDIM,SCR(KLCSFO),1,PHPCSF,1)

  !write(u6,*) ' OUTPUT from DiagOrd'
  !write(u6,*) ' =================='
  !write(u6,*) ' Number of Configurations in primary subspace ',NCONF
  !write(u6,*) ' Number of CSFs in primary subspace ',MXPDIM
  !write(u6,*) ' Configurations included :'
  !call IWRTMA(IPORDCNF,1,NCONF,1,NCONF)
  !write(u6,*) ' CSFs included :'
  !CALL IWRTMA(IPORDCSF,1,MXPDIM,1,MXPDIM)
  !write(u6,*) 'Ordered Diagonal array in CSF basis :'
  !do i=1,MXPDIM
  !  write(u6,*) PHPCSF(IPORDCSF(i))
  !  write(u6,*) PHPCSF(i)
  !end do
  !write(u6,*) 'Ordered Diagonal array in CNF basis :'
  !do i=1,NCONF
  !  write(u6,*) PHPCNF(i)
  !end do

  return

end subroutine DIAGORD_INTERNAL

end subroutine DiagOrd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Transverse(xyz,nCent,HDist,Bf,l_Write,Label,dBf,ldB)

use Slapaf_Info, only: GradRef, R12, RefGeo, Weights
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nCent
real(kind=wp), intent(in) :: xyz(3,nCent)
real(kind=wp), intent(out) :: HDist, Bf(3,nCent)
logical(kind=iwp), intent(in) :: l_Write, ldB
character(len=8), intent(in) :: Label
real(kind=wp), intent(inout) :: dBf(3,nCent,3,nCent)
integer(kind=iwp) :: i, iCent, nTrans
real(kind=wp) :: f, RR_R12, SqInvTWeight, TWeight, xWeight
logical(kind=iwp) :: lTrans
real(kind=wp), allocatable, target :: TV(:,:)
real(kind=wp), pointer :: r12_p(:,:)
integer(kind=iwp), external :: iDeg

!                                                                      *
!***********************************************************************
!                                                                      *
! The reference direction (normal to the hyperplane) is taken from
! the input (GradRef) if allocated, or from the stored
! transverse direction if there is one, or from the R-P vector
! (R12) otherwise

if (allocated(GradRef)) then
  lTrans = .false.
  r12_p => GradRef
  !write(u6,*), 'Using Reference Gradient'
else
  call qpg_dArray('Transverse',lTrans,nTrans)
  if (lTrans) then
    call mma_allocate(TV,3,nCent,Label='TV')
    call Get_dArray('Transverse',TV,3*nCent)
    r12_p => TV
    !write(u6,*), 'Using stored Transverse'
  else
    r12_p => R12
    !write(u6,*), 'Using R-P Vector'
  end if
end if
!                                                                      *
!***********************************************************************
!                                                                      *
!call RecPrt('Ref',' ',RefGeo,3,nCent)
!call RecPrt('R12',' ',r12_p,3,nCent)

! Length of the direction vector (weighted)

RR_R12 = Zero
TWeight = Zero
do iCent=1,nCent
  xWeight = real(iDeg(xyz(1,iCent)),kind=wp)*Weights(iCent)
  TWeight = TWeight+xWeight
  do i=1,3
    RR_R12 = RR_R12+xWeight*(r12_p(i,iCent))**2
  end do
end do
RR_R12 = sqrt(RR_R12)

! The distance scaling will be 1/Sqrt(TWeight)

SqInvTWeight = One/sqrt(TWeight)

! Dot product between the x-x0 vector and the direction (weighted)

f = Zero
do iCent=1,nCent
  xWeight = real(iDeg(xyz(1,iCent)),kind=wp)*Weights(iCent)
  do i=1,3
    f = f+xWeight*(xyz(i,iCent)-RefGeo(i,iCent))*r12_p(i,iCent)
  end do
end do

! The distance to the plane is the dot product / direction length

if (RR_R12 == Zero) then
  HDist = Zero
else
  HDist = f/RR_R12*SqInvTWeight
end if
!write(u6,*) 'f, RR_R12=',f,RR_R12

if (l_Write) write(u6,'(2A,F18.8,A)') Label,' : Hyperplane distance =',HDist,' au (weighted/sqrt(total weight)'

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the WDC B-matrix
! If the direction is null, the derivative is not defined

Bf(:,:) = Zero
if (RR_R12 > Zero) then

  ! The derivative is simply the unit direction vector
  ! (with weighting and scaling accounted for)

  do iCent=1,nCent
    xWeight = real(iDeg(xyz(1,iCent)),kind=wp)*Weights(iCent)
    do i=1,3
      Bf(:,iCent) = xWeight*r12_p(:,iCent)/RR_R12*SqInvTWeight
    end do
  end do
end if
!call RecPrt('Bf',' ',Bf,3,nCent)
!                                                                      *
!***********************************************************************
!                                                                      *
! The second derivative is null, as the derivative is constant

if (ldB) dBf(:,:,:,:) = Zero

if (lTrans) call mma_deallocate(TV)
nullify(r12_p)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Transverse

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine TraPAB(nZeta,la,lb,AB,GInt,jSum,rKappa,Fac1,Fac2,
     &                  Fac3,Fac4,Fac5,A,B,P)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 AB(nZeta,(la+1)*(la+2)/2,(lb+1)*(lb+2)/2),GInt(nZeta,jSum),
     &       rKappa(nZeta), Fac1(nZeta), Fac2(nZeta), Fac3(nZeta),
     &       Fac4(nZeta), Fac5(nZeta), A(3), B(3), P(nZeta,3)
*
*-----Statement function
*
      iad(ix,iy,iz) = (iy+iz) * (iy+iz+1) / 2 + iz + 1
      iOff(ix,iy,iz) = (ix+iy+iz)*(ix+iy+iz+1)*(ix+iy+iz+2)/6
      nElem(i) = (i+1)*(i+2)/2
*
      iRout = 239
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In TraPAB: GInt',' ',GInt,nZeta,jSum)
         Call RecPrt(' In TraPAB: P   ',' ',P   ,nZeta,3)
      End If
*
*-----Initilize
*
      call dcopy_(nZeta*(la+1)*(la+2)/2*(lb+1)*(lb+2)/2,[Zero],0,AB,1)
*
*-----Remove redundant elements in GInt. This is done in place.
*
      kOff = 4
      Do 101 i = 2, la+lb
*
         Do 110 ix = i, 0, -1
            Do 120 iy = i-ix, 0, -1
               iz = i-ix-iy
               jx = ix
               jy = iy
               jz = iz
*
               lOff = 0
               Do 121 ia = 1, i-1
                  If (jz.ne.0) Then
                     lOff = 3*(2+lOff)
                     jz = jz - 1
                  Else If (jy.ne.0) Then
                     lOff = 3*(1+lOff)
                     jy = jy - 1
                  Else
                     lOff = 3*lOff
                     jx = jx - 1
                  End If
 121           Continue
               If (jz.eq.1) lOff = lOff + 3
               If (jy.eq.1) lOff = lOff + 2
               If (jx.eq.1) lOff = lOff + 1
*
               iTrgt = iOff(ix,iy,iz) + iAd(ix,iy,iz)
*              Write(*,*) ' ix,iy,iz,kOff,lOff,iTrgt=',
*    &                      ix,iy,iz,kOff,lOff,iTrgt
               call dcopy_(nZeta,GInt(1,kOff+lOff),1,GInt(1,iTrgt),1)
*
 120        Continue
 110     Continue
*
         kOff = kOff + 3**i
 101  Continue
      If (iPrint.ge.99) Then
         Call RecPrt(' In TraPAB: GInt(unique)',' ',GInt,nZeta,
     &      (la+lb+1)*(la+lb+2)*(la+lb+3)/6)
      End If
*
*-----Loop over the elements of the basis functions on A and B
*
      Do 10 ixa = la, 0, -1
         iyaMax = la - ixa
         Do 20 iya = iyaMax, 0, -1
            iza = la - ixa - iya
            ipa = iad(ixa,iya,iza)
*           Write (*,*) ' ipa,ixa,iya,iza=',ipa,ixa,iya,iza
*
            Do 40 ixb = lb, 0, -1
               iybMax = lb - ixb
               Do 50 iyb = iybMax, 0, -1
                  izb = lb - ixb - iyb
                  ipb = iad(ixb,iyb,izb)
*                 Write (*,*) ' ipb,ixb,iyb,izb=',ipb,ixb,iyb,izb
*
*-----------------Loop over the elements of functions at P
*
                  Do 11 ixas = 0, ixa
                     Call Binom(ixa,ixas,iAx)
                     Ax = DBLE(iAx)
                     Do 12 iZeta = 1, nZeta
                       If ( (ixa-ixas).eq.0 ) then
                        Fac1(iZeta) = rKappa(iZeta) * Ax
                       Else
                        Fac1(iZeta) = rKappa(iZeta) * Ax *
     &                      (P(iZeta,1)-A(1))**(ixa-ixas)
                       End If
 12                  Continue
                     Do 21 iyas = 0, iya
                        Call Binom(iya,iyas,iAy)
                        Ay = DBLE(iAy)
                        Do 22 iZeta = 1, nZeta
                          If ( (iya-iyas).eq.0 ) then
                           Fac2(iZeta) = Fac1(iZeta) * Ay
                          Else
                           Fac2(iZeta) = Fac1(iZeta) * Ay *
     &                         (P(iZeta,2)-A(2))**(iya-iyas)
                          End If
 22                     Continue
                        Do 31 izas = 0, iza
                           Call Binom(iza,izas,iAz)
                           Az = DBLE(iAz)
                           Do 32 iZeta = 1, nZeta
                             If ( (iza-izas).eq.0 ) then
                              Fac3(iZeta) = Fac2(iZeta) * Az
                             Else
                              Fac3(iZeta) = Fac2(iZeta) * Az *
     &                            (P(iZeta,3)-A(3))**(iza-izas)
                             End If
 32                        Continue
*
                           Do 41 ixbs = 0, ixb
                              Call Binom(ixb,ixbs,iBx)
                              Bx = DBLE(iBx)
                              Do 42 iZeta = 1, nZeta
                                If ( (ixb-ixbs).eq.0 ) then
                                 Fac4(iZeta) = Fac3(iZeta) * Bx
                                Else
                                 Fac4(iZeta) = Fac3(iZeta) * Bx *
     &                               (P(iZeta,1)-B(1))**(ixb-ixbs)
                                End If
 42                           Continue
                              igx = ixas + ixbs
                              Do 51 iybs = 0, iyb
                                 Call Binom(iyb,iybs,iBy)
                                 By = DBLE(iBy)
                                 Do 52 iZeta = 1, nZeta
                                   If ( (iyb-iybs).eq.0 ) then
                                    Fac5(iZeta) = Fac4(iZeta) * By
                                   Else
                                    Fac5(iZeta) = Fac4(iZeta) * By *
     &                                  (P(iZeta,2)-B(2))**(iyb-iybs)
                                   End If
 52                              Continue
                                 igy = iyas + iybs
                                 Do 61 izbs = 0, izb
                                    Call Binom(izb,izbs,iBz)
                                    Bz = DBLE(iBz)
                                    igz = izas + izbs
                                    ipg = iOff(igx,igy,igz) +
     &                                    iAd(igx,igy,igz)
*                 Write (*,*) ' ipg,igx,igy,igz=', ipg,igx,igy,igz
*
                                    Do 100 iZeta = 1, nZeta
                                      If ( (izb-izbs).eq.0 ) then
                                       AB(iZeta,ipa,ipb) =
     &                                     AB(iZeta,ipa,ipb) +
     &                                     Fac5(iZeta) *
     &                                     GInt(iZeta,ipg) * Bz
                                      Else
                                       AB(iZeta,ipa,ipb) =
     &                                     AB(iZeta,ipa,ipb) +
     &                                     Fac5(iZeta) *
     &                                     (P(iZeta,3)-B(3))**(izb-izbs)
     &                                     * GInt(iZeta,ipg) * Bz
                                      End If
 100                                Continue
*
 61                              Continue
 51                           Continue
 41                        Continue
*
 31                     Continue
 21                  Continue
 11               Continue
*
 50            Continue
 40         Continue
*
 20      Continue
 10   Continue
*
      If (iPrint.ge.89) Then
         nab = nElem(la) * nElem(lb)
         Call RecPrt(' In TraPAB: AB',' ', AB, nZeta,nab)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Ignacio Fdez. Galvan                             *
************************************************************************
*  Sp_TriSolve
*
*> @ingroup Sparse
*> @brief
*>   Solves a triangular linear system, with a sparse matrix
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Solves the linear system \f$ A x = b \f$, where \p A is a sparse triangular matrix.
*> The side argument can be either ``'L'`` if \p A is lower triangular or ``'U'`` if
*> it is upper triangular.
*> On output the vector \p x contains the solution.
*>
*> @param[in]  n    Size of the system
*> @param[in]  side Type of system
*> @param[in]  A    Matrix in sparse format
*> @param[in]  ija  Index vector of matrix \p A
*> @param[in]  b    Vector of independent terms
*> @param[out] x    Solution vector
************************************************************************
      SUBROUTINE Sp_TriSolve(n,side,A,ija,b,x)
      IMPLICIT NONE
      INTEGER n, ija(*), i, j, k
      REAL*8 A(*), b(n), x(n)
      CHARACTER side

      IF (side.EQ.'L') THEN
        DO i=1,n
          x(i)=b(i)
          DO k=ija(i),ija(i+1)-1
            j=ija(k)
            x(i)=x(i)-A(k)*x(j)
          END DO
          x(i)=x(i)/A(i)
        END DO
      ELSE IF (side.EQ.'U') THEN
        DO i=n,1,-1
          x(i)=b(i)
          DO k=ija(i),ija(i+1)-1
            j=ija(k)
            x(i)=x(i)-A(k)*x(j)
          END DO
          x(i)=x(i)/A(i)
        END DO
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Modify_NQ_grid
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "itmax.fh"
#include "nq_info.fh"
#include "grid_on_disk.fh"
      Parameter (L_Quad_Low=23, Threshold_High=1.0D-7, nR_Low=50)
*                                                                      *
************************************************************************
*                                                                      *
*                                                                      *
************************************************************************
*                                                                      *
*     Reduce the size and the accuracy of the grid temporarily
*
      L_Quad_Save=L_Quad
      Threshold_save=Threshold
      nR_Save=nR
      ThrC = Crowding
*
      L_Quad=Min(L_Quad,L_Quad_Low)
      If (Quadrature(1:3).eq.'LMG') Then
         Threshold     =Max(Threshold_High,Threshold)
      Else
         nR     =Min(nR_Low,nR)
      End If
      Crowding=Max(ThrC-Two,One)
*
      Write (6,*)
      Write (6,*) 'Modify the NQ grid!'
      Write (6,*)
      Call Funi_Print()
*                                                                      *
************************************************************************
*                                                                      *
*     Change the Grid set index.
*
      iGrid_Set=Intermediate
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine IntFcm(ipH,nQQ,lOld,lOld_Implicit,nsAtom,iter)
************************************************************************
*                                                                      *
* Object: to initialize the Hessian matrix for the first iteration.    *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             May '91                                                  *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Logical lOld, lOld_Implicit, Hess_Found, IRC
*
      iRout = 51
      iPrint = nPrint(iRout)
*
      nQQ = 0
*
*     Read force constant matrix from old interphase
*     or
*     set it to a unit matrix
*
      If (iPrint.ge.99) Call RecPrt('IntFcm: Initial Hessian',' ',
     &                              Work(ipH),nQQ,nQQ)
*
      If (lOld .AND. iter.eq.1) Then
         Call OldFcm(ipH,nQQ,nsAtom,iPrint,'RUNOLD')
      Else If (iter.eq.1) Then
         Call qpg_iScalar('IRC',IRC)
         If (.Not.IRC) Then
            Call qpg_dArray('Hess',Hess_Found,nHess)
            If (Hess_Found.And.(nHess.gt.0)) Then
               lOld_Implicit=.True.
               Call OldFcm(ipH,nQQ,nsAtom,iPrint,'RUNFILE')
            Else
               ipH =  ip_Dummy
            End If
         End If
      End If
      If (.Not.lOld.and.lOld_Implicit) lOld=.True.
      If (iPrint.ge.99.and.lOld) Call RecPrt('IntFcm: Final Hessian',
     &                       ' ',Work(ipH),nQQ,nQQ)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! s-p interaction, normal case.
function CoulTN_2(RA,RB,C,dSepInv,ExpA,ExpB)

use Constants, only: One, Two, Three, Five, Ten, Eleven, Half, Quart
use Definitions, only: wp

implicit none
real(kind=wp) :: CoulTN_2
real(kind=wp), intent(in) :: RA, RB, C, dSepInv, ExpA, ExpB
real(kind=wp) :: T1, T2, T3, TA, TB

T1 = (One/16.0_wp)*(Five+Three*C)*(One+Two*RA)
T2 = Quart*RA**2
TA = (One-C)**3*(T1+T2)*ExpA
T1 = (One/16.0_wp)*(Eleven-Ten*C+Three*C**2)*(One+Two*RB)
T2 = Half*(Two-C)*RB**2
T3 = Quart*RB**3
TB = (One+C)**2*(T1+T2+T3)*ExpB
CoulTN_2 = dSepInv**2*(One-TA-TB)

return

end function CoulTN_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_SETRSDIM(NDIMRS,MSYM,MRED,IRED,ILOC)
C
C     Purpose: set reduced set dimension.
C
#include "implicit.fh"
      INTEGER NDIMRS(MSYM,MRED)
#include "cholesky.fh"

      IF (IRED .LE. MAXRED) THEN
         CALL ICOPY(NSYM,NNBSTR(1,ILOC),1,NDIMRS(1,IRED),1)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE INT5(I,J,L)
C     I.LT.J.LT.L   I.EQ.K
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      ITYP=0
      LJS=IJ(L+1)+1
      LJM=IJ(L)
      DO 100 ITT=1,ILIM
      IT1=(ITT-1)*MXVERT
      IT2=IT1
      DO 10 LJ=LJS,LJM
      IWAY(L)=1
32    KM=L
      J2(KM+1)=LJ
      J1(KM+1)=LJ
      CALL LOOP1(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 10
41    KM=KM-1
      IWAY(KM)=1
      IF(KM.EQ.J)GO TO 51
42    CALL LOOP5(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 41
      KM=KM+1
      IF(KM.EQ.L)GO TO 32
      GO TO 42
51    ITURN=0
55    IWAY(J)=1
52    KM=J
      JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      IF(ITURN.EQ.0)CALL LOOP10(KM,ISTOP,IT1,IT2)
      IFAI=0
      IF(ITURN.EQ.1)CALL LOOP13(KM,ISTOP,IFAI,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 53
      IF(ITURN.EQ.1)GO TO 54
      ITURN=1
      GO TO 55
54    KM=KM+1
      IF(KM.EQ.L)GO TO 32
      GO TO 42
53    KM=KM-1
      IWAY(KM)=1
      IF(KM.EQ.I)GO TO 71
62    JM(KM)=IVF0+1
      JM1(KM)=IVF0+1
      IF(ITURN.EQ.0)CALL LOOP17(KM,ISTOP,IT1,IT2)
      IFAI=0
      IF(ITURN.EQ.1)CALL LOOP23(KM,ISTOP,IFAI,IT1,IT2)
      IF(ISTOP.EQ.0)GO TO 53
      KM=KM+1
      IF(KM.EQ.J)GO TO 52
      GO TO 62
71    KM=I
      IF(ITURN.EQ.0)CALL LOOP14(KM,ISTOP,IT1,IT2)
      IF(ITURN.EQ.1)CALL LOOP22(KM,ISTOP,IT1,IT2)
      IF(ISTOP.EQ.1)GO TO 73
      IF(ABS(COUP(I)).LT.1.D-06)GO TO 71
      CALL COMP(I,LJ,ITYP,I,IT1,IT2)
      GO TO 71
73    KM=KM+1
      IF(KM.EQ.J)GO TO 52
      GO TO 62
10    CONTINUE
100   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkT_CAlld(T2,X,Y,dimbe,no)
! this routine does:
! T2n(be',ga',u,v) <-
!    C1               + 1/2 X(be',u,ga',v)
!    C2               + 1/2 X(ga',v,be',u)
!    C3               - 1/2 Y(be',u,ga',v)
!    C4               - 1/2 Y(ga',v,be',u)
!    C5               - 1   Y(ga',u,be',v)
!    C6               - 1   Y(be',v,ga',u)
! for beGrp=gaGrp

use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimbe, no
real(kind=wp), intent(out) :: T2(dimbe,dimbe,no,no)
real(kind=wp), intent(in) :: X(dimbe,no,dimbe,no), Y(dimbe,no,dimbe,no)
integer(kind=iwp) :: be, ga, u, v

do v=1,no
  do u=1,no
    do ga=1,dimbe
      !do be=1,dimbe  - povodne, stacia iba cleny be>=ga
      T2(ga:dimbe,ga,u,v) = (X(ga:dimbe,u,ga,v)-Y(ga:dimbe,u,ga,v))*Half-Y(ga:dimbe,v,ga,u)
    end do
  end do
end do

do v=1,no
  do u=1,no
    do be=1,dimbe
      !do ga=1,dimbe  - povodne, stacia iba cleny be>=ga
      T2(be,1:be,u,v) = T2(be,1:be,u,v)+(X(1:be,v,be,u)-Y(1:be,v,be,u))*Half-Y(1:be,u,be,v)
    end do
  end do
end do

return

end subroutine MkT_CAlld

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Par Soderhjelm                                   *
************************************************************************
      Subroutine XFMoment(lMax,Cavxyz,Tmom,nCavxyz_,Org)

************************************************************************
*                                                                      *
*     Object:  Calculate total moment of XF multipoles, add to Cavxyz  *
*                                                                      *
*     Authors: P. Soderhjelm                                           *
*              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
*                                                                      *
*              November 2004                                           *
************************************************************************
      use External_Centers
      use Phase_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"

      Real*8 Cavxyz(nCavxyz_),Tmom(nCavxyz_),Org(3)

      Real*8 Tco(3),A(3)
      Integer iStb(0:7), jCoSet(0:7,0:7)

      If(nOrd_XF.lt.0) Return
      If(nOrd_XF.gt.lMax) Then
         Call WarningMessage(2,'nOrd_XF.gt.lMax')
         Call Abend()
      EndIf
      nInp=(nOrd_XF+1)*(nOrd_XF+2)*(nOrd_XF+3)/6
      Call FZero(Org,3)
      do i=1,nXF
*
*------------- Generate Stabilizer of C
*
! IFG: "A" was undefined, is this the right point?
         A(1:3)=XF(1:3,i)
         iChxyz=iChAtm(A)
         iDum=0
         Call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)
         Do j = 0, nIrrep/nStb - 1
            Call FZero(Tmom,nCavxyz_)
            call dcopy_(nInp,XF(4,i),1,Tmom,1)
            TCo(1:3)=XF(1:3,i)
            Tco(1)=Tco(1)*DBLE(iPhase(1,jCoSet(j,0)))
            Tco(2)=Tco(2)*DBLE(iPhase(2,jCoSet(j,0)))
            Tco(3)=Tco(3)*DBLE(iPhase(3,jCoSet(j,0)))
            If(nOrd_XF.gt.0) Then
               Tmom(2)=Tmom(2)*DBLE(iPhase(1,jCoSet(j,0)))   !Dx
               Tmom(3)=Tmom(3)*DBLE(iPhase(2,jCoSet(j,0)))   !Dy
               Tmom(4)=Tmom(4)*DBLE(iPhase(3,jCoSet(j,0)))   !Dz
               If(nOrd_XF.gt.1) Then
                  Tmom(6)=Tmom(6)*DBLE(
     &                 iPhase(1,jCoSet(j,0))*iPhase(2,jCoSet(j,0))) !Qxy
                  Tmom(7)=Tmom(7)*DBLE(
     &                 iPhase(1,jCoSet(j,0))*iPhase(3,jCoSet(j,0))) !Qxz
                  Tmom(9)=Tmom(9)*DBLE(
     &                 iPhase(2,jCoSet(j,0))*iPhase(3,jCoSet(j,0))) !Qyz
               EndIf
            EndIf
            Call ReExpand(Tmom,1,nCavxyz_,Tco,Org,1,lMax)
            Call DaXpY_(nCavxyz_,One,Tmom,1,Cavxyz,1)
         EndDo
      EndDo

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE IFRMDS(IARRAY,NDIM,MBLOCK,IFILE)
C
C     TRANSFER INTEGER ARRAY FROM DISC FILE IFILE
C
C NBLOCK .LT. 0 INDICATES USE OF FASTIO
C
C If nblock .eq. 0 NBLOCK = NDIM
      IMPLICIT REAL*8(A-H,O-Z)
#include "io_util.fh"
      DIMENSION IARRAY(*),IDUMMY(1)
C
      NBLOCK = MBLOCK

C       DO NOT USE FASTIO
        IF(NBLOCK .LE. 0 ) NBLOCK = NDIM
        IREST=NDIM
        IBASE=0
  100   CONTINUE
          IF(IREST.GT.NBLOCK) THEN
            CALL IDAFILE(IFILE,2,IARRAY(IBASE+1),NBLOCK,IDISK(IFILE))
            IBASE=IBASE+NBLOCK
            IREST=IREST-NBLOCK
          ELSE
            CALL IDAFILE(IFILE,2,IARRAY(IBASE+1),IREST,IDISK(IFILE))
            IREST=0
          END IF
          CALL IDAFILE(IFILE,2,IDUMMY,1,IDISK(IFILE))
        IF( IREST .GT. 0 ) GOTO 100
cvv      ELSE
C       USE FAST IO
cvv        CALL SQFILE(IFILE,2,IARRAY,NDIM)
cvv      END IF
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Markus P. Fuelscher                              *
************************************************************************
      Subroutine OrdIn2(iOpt,Buf,lBuf,iBatch)
************************************************************************
*                                                                      *
*    Purpose: Read a buffer of ordered two electron integrals          *
*                                                                      *
*    Calling arguments:                                                *
*    Buf    : contains on output the integrals                         *
*    lBuf   : number of integrals to be transfered                     *
*    iOpt   : option code (iOpt=1:start reading at first integral)     *
*                         (iOpt=2:continue reading)                    *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    TwoDat : table of contents and auxiliary information              *
*                                                                      *
*    Local data declarations: none                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher                                                  *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
#include "Molcas.fh"
#include "TwoDat.fh"
*
      Real*8 Buf(*)
*---------------------------------------------------------------------*
*     If this is the first block of a symmetry batch                  *
*     get the disk disk start adress and load the buffer              *
*---------------------------------------------------------------------*
      If ( iOpt.eq.1 ) then
        iOff = RAMD_adr(iBatch)
        RAMD_next = iOff
        Call dCopy_(lBuf,RAMD_ints(iOff),1,Buf,1)
        RAMD_next = RAMD_next + lBuf
*---------------------------------------------------------------------*
*     If the number of requested integrals is larger than             *
*     the current buffer first drain the current buffer and           *
*     read as many subsequent buffers as needed                       *
*---------------------------------------------------------------------*
      Else
        iOff = RAMD_next
        Call dCopy_(lBuf,RAMD_ints(iOff),1,Buf,1)
        RAMD_next = RAMD_next + lBuf
      End If
*---------------------------------------------------------------------*
*     exit                                                            *
*---------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function D_Trsn(Ind,iOp_,nStab,jStab,mxdc,nSym)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Integer jStab(0:7,mxdc), nStab(mxdc), Ind(4), iOp_(4)
      Real*8 D_Trsn
*                                                                      *
************************************************************************
*                                                                      *
*     T O R S I O N S ((iAtom,R(jAtom)),T(kAtom,S(lAtom)))
*
      D_Trsn=Zero
*
      iAtom=Ind(1)
      jAtom=Ind(2)
      kAtom=Ind(3)
      lAtom=Ind(4)
      iOp_E=iOp_(1)
      iOp_R=iOp_(2)
      iOp_T=iOp_(3)
      iOp_TS=iOp_(4)
      iOp_S=iEor(iOp_T,iOp_TS)
*     Write (*,*) iAtom,jAtom,kAtom,lAtom
*     Write (*,*) iOp_E, iOp_R, iOp_T, iOp_TS, iOp_S
*
      nU_A=nStab(iAtom)
      iU_A=iU(jStab(0,iAtom),nU_A)
      nU_B=nStab(jAtom)
      iU_B=iU(jStab(0,jAtom),nU_B)
      nU_C=nStab(kAtom)
      iU_C=iU(jStab(0,kAtom),nU_C)
      nU_D=nStab(lAtom)
      iU_D=iU(jStab(0,lAtom),nU_D)
*
*     Write (*,*) ' U_A:',iU_A,nU_A
*     Write (*,*) ' U_B:',iU_B,nU_B
*     Write (*,*) ' U_C:',iU_C,nU_C
*     Write (*,*) ' U_D:',iU_D,nU_D
*
*---- Form stabilizer for (iAtom,jAtom)
*
      iOp_ER=iEor(iOp_E,iOp_R)
      If (iAtom.eq.jAtom) Then
         iU_AB=iOr(iU_A,iUR(iOp_ER,iU_B))
      Else
         iU_AB=iAnd(iU_A,iU_B)
      End If
*     Write (*,*) iAtom.eq.jAtom
*     Write (*,*) ' U_AB:',iU_AB,nU(iU_AB)
*
*-----Form stabilizer for (kAtom,lAtom)
*
      iOp_ES=iEor(iOp_E,iOp_S)
      If (kAtom.eq.lAtom) Then
         iU_CD=iOr(iU_C,iUR(iOp_ES,iU_D))
      Else
         iU_CD=iAnd(iU_C,iU_D)
      End If
*     Write (*,*) kAtom.eq.lAtom
*     Write (*,*) ' U_CD:',iU_CD,nU(iU_CD)
*
*---- Form the stabilizer for the torsion
*
      If (iAtom.ne.lAtom .or.  jAtom.ne.kAtom .or.
     &   (iAtom.eq.lAtom .and. jAtom.eq.kAtom .and.
     &     iOp_ER.ne.iOp_ES) ) Then
         iU_ABCD=iAnd(iU_AB,iU_CD)
*        Write (*,*) ' Ops!'
      Else
         iOp_ET=iEor(iOp_E,iOp_T)
         iU_ABCD=iOr(iU_AB,iUR(iOp_ET,iU_CD))
      End If
*     Write (*,*) iAtom.ne.lAtom
*     Write (*,*) jAtom.ne.kAtom
*     Write (*,*) (iAtom.eq.lAtom .and. jAtom.eq.kAtom .and.
*    &     iOp_ER.ne.iOp_ES)
      nU_ABCD=nU(iU_ABCD)
*     Write (*,*) ' U_ABCD:',iU_ABCD,nU(iU_ABCD)
*
*-----Compute the degeneracy of the torsion
*
      iDeg=nSym/nU_ABCD
      D_Trsn=DBLE(iDeg)
*
*     Write (*,*) ' D_Trsn=',D_Trsn
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Export1(iFinal,CMO,DA,PA,DAO,Focc)
************************************************************************
*                                                                      *
*     purpose: Save all information relevant to geometry               *
*              optimizations                                           *
*                                                                      *
*     calling arguments:                                               *
*     iFinal  : Switch including routing information                   *
*     CMO     : MO coefficients in last CI                             *
*     DA      : 1-density of active orbitals                           *
*     PA      : 2-density of active orbitals                           *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1994                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
#ifdef _DMRG_
!     module dependencies
      use qcmaquis_interface_cfg
#endif
*
      Implicit Real*8 (a-h,o-z)
*...  Define global variables .........................................*
#include "rasdim.fh"
#include "rasscf.fh"
#include "gas.fh"
#include "general.fh"
#include "wadr.fh"
#include "SysDef.fh"
#include "WrkSpc.fh"
      Dimension CMO(*),DA(*),PA(*),DAO(*),Focc(*)
*...  Define local variables ..........................................*
      Character*8 RlxLbl,Method
      Logical SCF, Found
      Integer nTemp(8)
      Character(Len=16) mstate
*
*----------------------------------------------------------------------*
*     Prologue                                                         *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*     Save information pertinent to the gradient calculation           *
*----------------------------------------------------------------------*
*...  Add elementary information ......................................*
      SCF=.false.
      If (nac.eq.0.or.2*nac.eq.nactel) SCF=.true.
*
      If (SCF) then
         Do iS=1,nSym
            nTemp(is)=nAsh(is)+nIsh(is)
         End Do
         Call Put_iArray('nIsh',nTemp,nSym)
         Do iS=1,nSym
            nTemp(is)=0
         End Do
         Call Put_iArray('nAsh',nTemp,nSym)
      Else
         Call Put_iArray('nIsh',nIsh,nSym)
         Call Put_iArray('nAsh',nAsh,nSym)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Find the correct method label
*
      Method='CASSCF  '
      If (KSDFT.ne.'SCF') Method='CASDFT  '
*
*     Set flags for State-Average or Single root
*
      If (nRoots.ne.1) Then
*
*        iSA=-1 non-equivalent multi state SA-CASSCF
*        iSA=0  equivalent multi state SA-CASSCF
*        iSA=2  single root SA-CASSCF
*
         Method='CASSCFSA'
*
*        Check if equal weight SA-CASSCF
*
         iSA=0
         Do iR = 2, nRoots
            If (Weight(1).ne.Weight(iR)) iSA=-1
         End Do
         If (iSA.ne.0) Then
*
*           Check if SA-CASSCF is optimized for just one root.
*
            nW=0
            Do iR = 1, nRoots
               If (Weight(iR).ne.0.0D0) nW = nW + 1
            End Do
            If (nW.eq.1) iSA=2
         End If
         Call Put_iScalar('SA ready',iSA)
         If ((iSA.eq.0).or.(iSA.eq.-1)) Then
            mstate = '****************'
            Call Put_cArray('MCLR Root',mstate,16)
         End If
      End If
*
*     Check if it is a RASSCF function and not a CASSCF
      If (nHole1.ne.0 .or. nElec3.ne.0) Method(1:1)='R'
*     Check if it is a GASSCF function
      If (iDoGAS) Method(1:1)='G'
*     Check if it is a DMRGSCF function
      if(doDMRG)then
                        Method='DMRGSCF '
        if(nroots.ne.1) Method='DMRGSCFS'
      endif
*
      Call Put_cArray('Relax Method',Method,8)
*                                                                      *
************************************************************************
*                                                                      *
      Call Get_iScalar('nSym',i)
      Call Put_iArray('nFro',nFro,i)
      Call Put_iArray('nDel',nDel,i)
*...  Add MO-coefficients .............................................*
      Call Put_CMO(CMO,NTOT2)
*...  Add one body density matrix in AO/SO basis ......................*
      Call Put_D1AO(DAO,NTOT1)
*...  Add one body density matrix in MO, active orbitals only .........*
      Call Put_D1MO(DA,NACPAR)
*...  Add two body density matrix in MO basis, active orbitals only ...*
      If ( .not.SCF ) Call Put_P2MO(PA,NACPR2)
*...  Next version of MOLCAS add the state to relax file ..............*
      Call Qpg_iScalar('Relax Original root',Found)
      If (Found) Then
         Call Get_iScalar('Relax Original root',irlxroot1)
         Call Get_iScalar('Relax CASSCF root',irlxroot2)
         If (irlxroot1.eq.irlxroot2) Then
            Call Put_iScalar('Relax Original root',irlxroot)
         End If
      Else
         Call Put_iScalar('Relax Original root',irlxroot)
      End If
      Call Put_iScalar('Relax CASSCF root',irlxroot)
*...  Remove overlaps (computed by rassi) .............................*
      Call Put_darray('State Overlaps',Work(ip_Dummy),0)
      Call Put_lscalar('Track Done',.False.)
*...  Add generalized Fock matrix .....................................*
      If ( ifinal.ge.1 ) then
         Call Put_Fock_Occ(Focc,ntot1)
         RlxLbl='Thrs    '
         tmp=Max(thrte,thrsx)
         Call put_dscalar(RlxLbl,tmp)
      End If
*----------------------------------------------------------------------*
*     Epilogue                                                         *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE BINAT()
      use rassi_global_arrays, only : JBNUM, EIGVEC
      use rassi_aux, only : iDisk_TDM
      IMPLICIT NONE

#include "SysDef.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "rassi.fh"
#include "symmul.fh"
#include "Files.fh"
#include "WrkSpc.fh"
      INTEGER IOFF_SEV, IOFF_VEC, IOFF_TDM, IOFF_ISV
      INTEGER LONBAS, LSEV, LSAO, IOPT, ICMP, ISYLAB, LS, LV
      INTEGER LE, I, LS1, ISEL, LS2, J, K, L, LV1, LE1
      INTEGER LUMAT, LVTMAT, LSVAL, LTDMAT, LTDMAO, LSCR
      INTEGER LBRABNO, LKETBNO, LSNGV1, LSNGV2
      INTEGER IJPAIR, KEIG_BRA, KEIG_KET, LSYM_BRA
      INTEGER LSYM_KET, LSYM12, IDISK, IV, IE, ITD, IRC, ISYM
      INTEGER ISYM1, ISYM2, NB, NB1, NB2, LV2, LE2, ITD1, ITD2
      INTEGER ISV, LB, LK, NBMIN, iEmpty, iGo
      INTEGER LUNIT, ISFREEUNIT, IDUMMY
      REAL*8  SSEL, SWAP, SEV, X, DUMMY, SUMSNG, DDOT_
      CHARACTER*16 KNUM
      CHARACTER*8  BNUM
      CHARACTER*21 TXT
      CHARACTER*24 FNAME

C Tables of starting locations, created and used later
      DIMENSION IOFF_VEC(8),IOFF_SEV(8),IOFF_TDM(8),IOFF_ISV(8)
      DIMENSION IDUMMY(2),DUMMY(2)

      EXTERNAL ISFREEUNIT
      EXTERNAL DDOT_

C Nr of basis functions, total
      NBSQ=0
      DO ISYM=1,NSYM
       NBSQ=NBSQ+NBASF(ISYM)**2
      END DO
C============================================================
C START BY CREATING A SET OF ORTHONORMAL VECTORS:
      CALL GETMEM('ONBAS','ALLO','REAL',LONBAS,NBSQ)
C EIGENVALUES OF OVERLAP MATRIX:
      CALL GETMEM('SEV','ALLO','REAL',LSEV,NBST)
C READ ORBITAL OVERLAP MATRIX.
      CALL GETMEM('SAO','ALLO','REAL',LSAO,NBTRI)
      IRC=-1
      IOPT=6
      ICMP=1
      ISYLAB=1
      CALL RDONE(IRC,IOPT,'MLTPL  0',ICMP,WORK(LSAO),ISYLAB)
      IF ( IRC.NE.0 ) THEN
        WRITE(6,*)
        WRITE(6,*)'      *** ERROR IN SUBROUTINE  BINAT ***'
        WRITE(6,*)'      OVERLAP INTEGRALS ARE NOT AVAILABLE'
        WRITE(6,*)
        CALL ABEND()
      ENDIF

C LOOP OVER SYMMETRY BLOCKS
C DIAGONALIZE EACH SYMMETRY BLOCK OF THE OVERLAP MATRIX.
      LS=LSAO
      LV=LONBAS
      LE=LSEV
      DO ISYM=1,NSYM
        NB=NBASF(ISYM)
        CALL DCOPY_(NB**2,[0.0D0],0,WORK(LV),1)
        CALL DCOPY_(NB,[1.0D0],0,WORK(LV),NB+1)
        CALL JACOB(WORK(LS),WORK(LV),NB,NB)
C SORT IN ORDER OF DECREASING EIGENVALUES.
        LS1=LS
        DO I=1,NB-1
         ISEL=I
         SSEL=WORK(LS1)
         LS2=LS1
         DO J=I+1,NB
          LS2=LS2+J
          IF(WORK(LS2).GT.SSEL) THEN
            ISEL=J
            SSEL=WORK(LS2)
          END IF
         END DO
         IF (ISEL.GT.I) THEN
          LS2=LS-1+(ISEL*(ISEL+1))/2
          SWAP=WORK(LS2)
          WORK(LS2)=WORK(LS1)
          WORK(LS1)=SWAP
          DO K=1,NB
           SWAP=WORK(LV-1+K+NB*(ISEL-1))
           WORK(LV-1+K+NB*(ISEL-1))=WORK(LV-1+K+NB*(I-1))
           WORK(LV-1+K+NB*(I-1))=SWAP
          END DO
         END IF
         LS1=LS1+I+1
        END DO
C SCALE EACH VECTOR TO OBTAIN AN ORTHONORMAL BASIS.
        LS1=LS
        LV1=LV
        LE1=LE
        DO I=1,NB
          SEV=WORK(LS1)
          WORK(LE1)=SEV
          IF (SEV.GT.1.0D-14) THEN
           X=1.0D00/SQRT(SEV)
           CALL DSCAL_(NB,X,WORK(LV1),1)
          ELSE
           CALL DCOPY_(NB,[0.0D0],0,WORK(LV1),1)
          END IF
          LS1=LS1+I+1
          LV1=LV1+NB
          LE1=LE1+1
        END DO
        LS=LS+(NB*(NB+1))/2
        LV=LV+NB**2
        LE=LE+NB
      END DO
      CALL GETMEM('SAO','FREE','REAL',LSAO,NBTRI)
C Starting at Work(LONBAS) there is now symmetry blocks of CMO arrays
C describing orthonormal vectors. In case the AO overlap matrix is
C (almost) singular, one or more vectors at the end of each symmetry
C block will be null vectors.
C============================================================

C Left and right singular vectors, used temporarily
C in calls to SVD routine. Also temporary, singular values.
      CALL GETMEM('UMAT','ALLO','REAL',LUMAT,NBMX**2)
      CALL GETMEM('VTMAT','ALLO','REAL',LVTMAT,NBMX**2)
      CALL GETMEM('SVEC','ALLO','REAL',LSVAL,NBMX)
C Final bra and ket singular value array:
      CALL GETMEM('SNGV1','ALLO','REAL',LSNGV1,NBST)
C An extra copy for singular values in a different order
C used until proper GV support for binatural orbitals.
      CALL GETMEM('SNGV2','ALLO','REAL',LSNGV2,NBST)
C The transition density matrix, symmetry-blocked
C Symmetry blocks may combine different symmetries, but the size
C is certainly less than or equal to NBSQ.
      CALL GETMEM('TDMAT','ALLO','REAL',LTDMAT,NBSQ)
C Same, read buffer
      CALL GETMEM('TDMAO','ALLO','REAL',LTDMAO,NBSQ)
C Temporary intermediate in matrix multiplies
C (Also used as temporary when transposing some TDMAO matrices)
      CALL GETMEM('SCR','ALLO','REAL',LSCR,NBSQ)
C The BRA and KET binatural orbitals:
      CALL GETMEM('BRABNO','ALLO','REAL',LBRABNO,NBSQ)
      CALL GETMEM('KETBNO','ALLO','REAL',LKETBNO,NBSQ)

C A long loop over eigenstate pairs:
      DO IJPAIR=1,NBINA
C Requested state pairs for computation: (OBSOLETE)
       KEIG_BRA=IBINA(1,IJPAIR)
       KEIG_KET=IBINA(2,IJPAIR)
C Get symmetries, via jobiph number for the states:
       LSYM_BRA=IRREP(JBNUM(KEIG_BRA))
       LSYM_KET=IRREP(JBNUM(KEIG_KET))
C Combined symmetry:
       LSYM12=MUL(LSYM_BRA,LSYM_KET)
C For relating left and right symmetry blocks, offset tables are
C needed for the singular values and for the TDM.
       ITD=0
       ISV=0
       DO ISYM1=1,NSYM
        IOFF_TDM(ISYM1)=ITD
        IOFF_ISV(ISYM1)=ISV
        ISYM2=MUL(ISYM1,LSYM12)
        ITD=ITD+NBASF(ISYM1)*NBASF(ISYM2)
        ISV=ISV+NBASF(ISYM1)
       END DO
       CALL DCOPY_(NBSQ,[0.0D0],0,WORK(LTDMAT),1)
C DOUBLE LOOP OVER RASSCF WAVE FUNCTIONS
       DO I=1,NSTATE
        IF (IRREP(JBNUM(I)).NE.LSYM_BRA) GOTO 92
        DO J=1,NSTATE
         IF (IRREP(JBNUM(J)).NE.LSYM_KET) GOTO 91
C PICK UP TRANSITION DENSITY MATRIX FOR THIS PAIR OF RASSCF STATES:
C WEIGHT WITH WHICH THEY CONTRIBUTE IS EIGVEC(I,KEIG_BRA)*EIGVEC(J,KEIG_KET).
         X=EIGVEC(KEIG_BRA,i)*EIGVEC(KEIG_KET,j)
         IDISK=iDisk_TDM(J,I,1)
         IEMPTY=iDisk_TDM(J,I,2)
         iOpt=2
         iGo=1
         If (IAND(iEMPTY,1).ne.0) Then
         IF (I.GT.J) THEN
            CALL dens2file(Work(LTDMAO),Work(LTDMAO),Work(LTDMAO),
     &                     nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,I,J)
         ELSE
C Pick up conjugate TDM array, and transpose it into TDMAO.
            CALL dens2file(Work(LSCR),Work(LSCR),Work(LSCR),
     &                     nTDMZZ,LUTDM,IDISK,iEmpty,iOpt,iGo,I,J)
C Loop over the receiving side:
           DO ISYM1=1,NSYM
            ISYM2=MUL(ISYM1,LSYM12)
            NB1=NBASF(ISYM1)
            NB2=NBASF(ISYM2)
            DO K=1,NB1
             DO L=1,NB2
              WORK(LTDMAO-1+IOFF_TDM(ISYM1)+K+NB1*(L-1))=
     &              WORK(LSCR-1+IOFF_TDM(ISYM2)+L+NB2*(K-1))
             END DO
            END DO
           END DO
         END IF
         CALL DAXPY_(NBSQ,X,WORK(LTDMAO),1,WORK(LTDMAT),1)
         END IF
   91    CONTINUE
        END DO
   92   CONTINUE
       END DO
C TDMAT() now contains the transition density matrix in AO basis for
C the eigenstates.
C ------------------------------------------------------------------

C LOOP OVER SYMMETRY BLOCKS OF TDMAT.
C On the ket side, ISYM2 is not looping sequentially so we need
C tables of offsets:
       IV=0
       IE=0
       DO ISYM=1,NSYM
        IOFF_VEC(ISYM)=IV
        IOFF_SEV(ISYM)=IE
        IV=IV+NBASF(ISYM)**2
        IE=IE+NBASF(ISYM)
       END DO
       CALL DCOPY_(NBST,[0.0D0],0,WORK(LSNGV1),1)
       CALL DCOPY_(NBST,[0.0D0],0,WORK(LSNGV2),1)
       ITD=0
       DO ISYM1=1,NSYM
        ISYM2=MUL(ISYM1,LSYM12)
        NB1=NBASF(ISYM1)
        NB2=NBASF(ISYM2)
        LV1=LONBAS+IOFF_VEC(ISYM1)
        LV2=LONBAS+IOFF_VEC(ISYM2)
        LE1=LSEV+IOFF_SEV(ISYM1)
        LE2=LSEV+IOFF_SEV(ISYM2)
C TRANSFORM TO ORTHONORMAL BASIS. THIS REQUIRES THE CONJUGATE
C BASIS, BUT SINCE WE USE CANONICAL ON BASIS THIS AMOUNTS TO A
C SCALING WITH THE EIGENVECTORS OF THE OVERLAP MATRIX:
        CALL DGEMM_('N','N',NB1,NB2,NB2,1.0D0,
     &              WORK(LTDMAT+ITD),NB1,WORK(LV2),NB2,
     &         0.0D0, WORK(LSCR),NB1)
        CALL DGEMM_('T','N',NB1,NB2,NB1,1.0D0,
     &                WORK(LV1),NB1,WORK(LSCR),NB1,
     &         0.0D0, WORK(LTDMAT+ITD),NB1)
        ITD1=ITD
        DO I=1,NB1
         CALL DSCAL_(NB2,WORK(LE1-1+I),WORK(LTDMAT+ITD1),NB1)
         ITD1=ITD1+1
        END DO
        ITD2=ITD
        DO I=1,NB2
         CALL DSCAL_(NB1,WORK(LE2-1+I),WORK(LTDMAT+ITD2),1)
         ITD2=ITD2+NB1
        END DO

C SVD DECOMPOSITION OF THIS MATRIX BLOCK:
        CALL FULL_SVD(NB1,NB2,WORK(LTDMAT+ITD),
     &                WORK(LUMAT),WORK(LVTMAT),WORK(LSVAL))
* On return, WORK(LUMAT) has dimension (NB1,NB1),
* On return, WORK(LVTMAT) has dimension (NB2,NB2), transpose storage
        NBMIN=MIN(NB1,NB2)
C REEXPRESS THE SINGULAR VECTORS USING AO BASIS:
        LB=LBRABNO+IOFF_VEC(ISYM1)
        LK=LKETBNO+IOFF_VEC(ISYM2)
        CALL DGEMM_('N','N',NB1,NB1,NB1,1.0D0,
     &                WORK(LV1),NB1,WORK(LUMAT),NB1,
     &          0.0D0,WORK(LB),NB1)
        CALL DGEMM_('N','T',NB2,NB2,NB2,1.0D0,
     &                WORK(LV2),NB2,WORK(LVTMAT),NB2,
     &          0.0D0,WORK(LK),NB2)

C Move the singular values into their proper places:
        CALL DCOPY_(NBMIN,WORK(LSVAL),1,WORK(LSNGV1+IOFF_ISV(ISYM1)),1)
        CALL DCOPY_(NBMIN,WORK(LSVAL),1,WORK(LSNGV2+IOFF_ISV(ISYM2)),1)
        ITD=ITD+NB1*NB2
       END DO

C WRITE OUT THIS SET OF BI-NATURAL ORBITALS. THE FILES WILL BE NAMED
C BIORB.x_y, where x,y are KEIG_BRA and KEIG_KET.
C The BRA and KET orbitals will be written as alpha and beta, respectively,
C and the singular values will be written as "occupation numbers".

        WRITE(6,*)' Binatural singular values for the transition from'
        WRITE(6,*)' ket eigenstate KEIG_KET to bra eigenstate KEIG_BRA'
        WRITE(6,'(1x,I2,a,i2)') KEIG_BRA,' <-- ',KEIG_KET
        DO I=1,NSYM
          NB=NBASF(I)
          IF( NB.NE.0 ) THEN
            WRITE(6,'(A,I2)')' SYMMETRY SPECIES:',I
            LS=LSNGV1+IOFF_SEV(I)
            WRITE(6,'(1X,10F8.5)')(WORK(LS-1+J),J=1,NB)
          ENDIF
        END DO

        WRITE(BNUM,'(I8)') KEIG_BRA
        BNUM=ADJUSTL(BNUM)
        WRITE(KNUM,'(I8)') KEIG_KET
        KNUM=ADJUSTL(KNUM)
        TXT=TRIM(BNUM)//' <-- '//TRIM(KNUM)
        KNUM=TRIM(BNUM)//'_'//TRIM(KNUM)

        FNAME='BIORB.'//KNUM
        WRITE(6,'(A,A)')' Orbitals are written onto file id = ',FNAME
        LUNIT=50
        LUNIT=ISFREEUNIT(LUNIT)
        CALL WRVEC_(FNAME,LUNIT,'CO',1,NSYM,NBASF,NBASF,
     &     WORK(LBRABNO),WORK(LKETBNO),WORK(LSNGV1),WORK(LSNGV2),
     &     DUMMY, DUMMY, IDUMMY,
     &     '* Binatural orbitals from transition '//TRIM(TXT), 0 )
        CLOSE(LUNIT)
        SUMSNG=DDOT_(SUM(NBASF),WORK(LSNGV1),1,WORK(LSNGV2),1)
        CALL ADD_INFO("BINAT",[SUMSNG],1,5)

C End of very long loop over eigenstate pairs.
      END DO

      WRITE(6,*)('*',I=1,80)
      CALL GETMEM('ONBAS','FREE','REAL',LONBAS,NBSQ)
      CALL GETMEM('SEV','FREE','REAL',LSEV,NBST)
      CALL GETMEM('SCR','FREE','REAL',LSCR,NBSQ)
      CALL GETMEM('UMAT','FREE','REAL',LUMAT,NBMX**2)
      CALL GETMEM('VTMAT','FREE','REAL',LVTMAT,NBMX**2)
      CALL GETMEM('SVAL','FREE','REAL',LSVAL,NBMX)
      CALL GETMEM('SNGV1','FREE','REAL',LSNGV1,NBST)
      CALL GETMEM('SNGV2','FREE','REAL',LSNGV2,NBST)
      CALL GETMEM('TDMAT','FREE','REAL',LTDMAT,NBSQ)
      CALL GETMEM('TDMAO','FREE','REAL',LTDMAO,NBSQ)
      CALL GETMEM('BRABNO','FREE','REAL',LBRABNO,NBSQ)
      CALL GETMEM('KETBNO','FREE','REAL',LKETBNO,NBSQ)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine MltMem_GIAO(nHer,MemMlt,la,lb,lr)
      Parameter(nB=3)
*
      nElem(i) = (i+1)*(i+2)/2
*
      nHer=(la+lb+lr+3)/2
      MemMlt = 3*nHer*(la+1) +
     &         3*nHer*(lb+1) +
     &         3*nHer*(lr+2) +
     &         3*(la+1)*(lb+1)*(lr+2) +
     &         nElem(la)*nElem(lb)*nElem(lr)*nB
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE TRIEXP(A,B,NDIM)
C
C     AUTHOR:        M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, 1989
C     MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
C                    M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
C
C     EXPAND A REAL, SYMMETRIC MATRIX GIVEN AS THE LOWER TRIANGLE
C     INTO FULL STORAGE MODE.
C
C     CALLING PARAMETERS:
C     A   : INPUT MATRIX (LOWER TRINAGULAR STORAGE MODE)
C     B   : OUTPUT MATRIX (FULL STORAGE MODE)
C     NDIM: DIMENSION OF MATRIX A AND B
C
      REAL*8 A(*)
      REAL*8 B(*)
C
      IMODE=1
      If ( ip_of_Work(A(1)).EQ.ip_of_Work(B(1)) ) IMODE=2
C
      IF( IMODE.EQ.1 ) THEN
         K=0
         DO 10 I=1,NDIM
            DO 20 J=1,I
               K=K+1
               L1=J+(I-1)*NDIM
               B(L1)=A(K)
               L2=I+(J-1)*NDIM
               B(L2)=A(K)
20          CONTINUE
10       CONTINUE
      ENDIF
C
      IF( IMODE.EQ.2 ) THEN
         K=1+NDIM*(NDIM+1)/2
         DO 30 I=NDIM,1,-1
            DO 40 J=I,1,-1
               K=K-1
               L1=J+(I-1)*NDIM
               L2=I+(J-1)*NDIM
               L3=MAX(L2,L1)
               B(L3)=A(K)
40          CONTINUE
30       CONTINUE
         DO 50 I=1,NDIM
            DO 60 J=1,I
               L1=J+(I-1)*NDIM
               L2=I+(J-1)*NDIM
               L3=MAX(L2,L1)
               L4=MIN(L2,L1)
               B(L4)=B(L3)
60          CONTINUE
50       CONTINUE
      ENDIF
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_map11 (a,b,dimp,nfact)
c
c     maping A(p) -> nfact*B(p)
c
       integer dimp,nfact
       real*8 a(1:dimp)
       real*8 b(1:dimp)
c
       integer pp
c
       if (nfact.eq.1) then
c
       do 100 pp=1,dimp
       b(pp)=a(pp)
 100    continue
c
       else
c
       do 200 pp=1,dimp
       b(pp)=-a(pp)
 200    continue
c
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_ComputeOverlapBlock(AB,l_S,S)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: compute overlap integral S(uv) for uv on AB.
C              It is assumed that the proper initialization of one-el
C              integral data is set before calling this routine
C              (by calling LDF_SetOneEl with argument 'Mltpl  0').
C
      use iSD_data
      Implicit None
      Integer AB
      Integer l_S
      Real*8  S(l_S)
      Integer iPrim, jPrim, iAng, jAng, nOrder, lFinal, lScrt1,
     &        lScrt2, MemKrn, ixyz, MemKer, mFinal, mScrt1, mScrt2,
     &        nElem
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "localdf_bas.fh"
#include "rmat_option.fh"
#include "ldf_oneel.fh"
#include "nsd.fh"
#include "setup.fh"
#include "ldf_atom_pair_info.fh"
#include "property_label.fh"

      Real*8, Dimension(:), Allocatable :: Final, Scrtch,
     &                                     ScrSph, Kern
      Character*23 SecNam
      Parameter (SecNam='LDF_ComputeOverlapBlock')

      External MltInt, MltMem

      Integer  LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBas_Atom, LDF_nShell_Atom, LDF_lShell_Atom

      Character*8 Label

      Logical Do_PGamma

      Integer A, B
      Integer nSA, nSB
      Integer iSA, iSB
      Integer iShellA, iShellB
      Integer ipA, ipB
      Integer lS
      Integer iPrint
      Integer nGrid
      Integer iAddPot
      Integer nOrdOp
      Integer ip_SOInt, l_SOInt
      Integer ip, l
      Integer iBas, iCmp, iAO
      Integer jBas, jCmp, jAO

      Real*8  PtChrg(1)

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
*     Statement functions
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
*                                                                      *
************************************************************************
*                                                                      *
      ! Check operator label
      If (OperatorLabel.ne.'Mltpl  0') Then
         Call WarningMessage(2,SecNam//': illegal operator label')
         Write(6,'(A,A)') 'OperatorLabel=',OperatorLabel
         Call LDF_Quit(1)
      End If

      ! Get atoms
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      nSA=LDF_nShell_Atom(A)
      nSB=LDF_nShell_Atom(B)
      ipA=LDF_lShell_Atom(A)-1
      ipB=LDF_lShell_Atom(B)-1

      ! Check dimension
      lS=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      If (lS.lt.1) Return
      If (lS.gt.l_S) Then
         Call WarningMessage(2,
     &                SecNam//': insufficient integral array dimension')
         Call LDF_Quit(1)
      End If

      ! Set arguments for call to OneEl_IJ
      RMat_type_integrals=.False. ! stored in common block...
      Do_PGamma=.True.
      Label=OperatorLabel
      PLabel=' '
      iPrint=0
      nGrid=1
      PtChrg(1)=0.0d0
      iAddPot=0
      nOrdOp=0

      ! Allocate temporary integral array
      l_SOInt=0
      Do iSB=1,nSB
         iShellB=iWork(ipB+iSB)
         Do iSA=1,nSA
            iShellA=iWork(ipA+iSA)
            l_SOInt=max(l_SOInt,nBasSh(iShellA)*nBasSh(iShellB))
         End Do
      End Do
      Call GetMem('SBlock','Allo','Real',ip_SOInt,l_SOInt)
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate scratch for the evaluation of the integrals             *
*                                                                      *
      lFinal=1
      lScrt1=1
      lScrt2=1
      MemKrn=1
      Do iSB=1,nSB
         iShellB=iWork(ipB+iSB)
         Do iSA=1,nSA
            iShellA=iWork(ipA+iSA)
*
            iPrim=iSD(5,iShellA)
            jPrim=iSD(5,iShellB)
            iBas=iSD(3,iShellA)
            jBas=iSD(3,iShellB)
            iAng=iSD(1,iShellA)
            jAng=iSD(1,iShellB)
*
            mFinal=nIC*iPrim*jPrim*nElem(iAng)*nElem(jAng)
            lFinal=Max(lFinal,mFinal)
*
            mScrt1=nIC*Max(iPrim,jBas)*Max(iBas,jPrim)
     &         *nElem(iAng)*nElem(jAng)
            lScrt1=Max(mScrt1,lScrt1)
*
            mScrt2=nIC*iBas*jBas*nElem(iAng)*nElem(jAng)
            lScrt2=Max(mScrt2,lScrt2)
*
            Call MltMem(nOrder,MemKer,iAng,jAng,nOrdOp)
            MemKrn=Max(MemKer*iPrim*jPrim,MemKrn)
         End Do
      End Do
*
      Call mma_allocate(Final,lFinal,label='Final')
      Call mma_allocate(Scrtch,lScrt1,label='Scrtch')
      Call mma_allocate(ScrSph,lScrt2,label='ScrSph')
      Call mma_allocate(Kern,MemKrn,label='Kern')
*                                                                      *
************************************************************************
*                                                                      *
      ! Compute integrals
      Call Cho_dZero(S,lS)
      ip=1
      Do iSB=1,nSB
         iShellB=iWork(ipB+iSB)
         Do iSA=1,nSA
            iShellA=iWork(ipA+iSA)
            l=nBasSh(iShellA)*nBasSh(iShellB)
            Call Cho_dZero(Work(ip_SOInt),l)
            Call OneEl_IJ(iShellA,iShellB,iPrint,Do_PGamma,
     &                    Work(ip_xZeta),Work(ip_xZI),Work(ip_xKappa),
     &                    Work(ip_xPCoor),
     &                    MltInt,MltMem,Label,iWork(ip_lOper),nComp,
     &                    Work(ip_CCoor),
     &                    nOrdOp,iWork(ip_kOper),
     &                    iStabO,nStabO,nIC,
     &                    PtChrg,nGrid,iAddPot,Work(ip_SOInt),l,
     &                    Final,lFinal,Scrtch,lScrt1,
     &                    ScrSph,lScrt2,Kern,MemKrn)

            iCmp=iSD(2,iShellA)
            iBas=iSD(3,iShellA)
            iAO=iSD(7,iShellA)
            jCmp=iSD(2,iShellB)
            jBas=iSD(3,iShellB)
            jAO=iSD(7,iShellB)
            Call LDF_SortOverlapBlock(Work(ip_SOInt),iBas,jBas,
     &                                iCmp,jCmp,iAO,jAO,S(ip),l)
            ip=ip+l
         End Do
      End Do
*
      ! Deallocation
      Call mma_deallocate(Final)
      Call mma_deallocate(Scrtch)
      Call mma_deallocate(ScrSph)
      Call mma_deallocate(Kern)
*
      Call GetMem('SBlock','Free','Real',ip_SOInt,l_SOInt)

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_SortOverlapBlock(SOInt,iBas,jBas,iCmp,jCmp,iAO,jAO,
     &                                S,lS)
C
C     Thomas Bondo Pedersen, February 2011.
C
C     Purpose: extract block of overlap matrix.
C
      use SOAO_Info, only: iAOtSO
      Implicit Real*8 (a-h,o-z)
      Integer iBas, jBas
      Real*8  SOInt(iBas*jBas,*)
      Integer iCmp, jCmp
      Integer iAO, jAO
      Integer lS
      Real*8  S(lS)
#include "WrkSpc.fh"
#include "localdf_bas.fh"

#if defined (_DEBUGPRINT_)
      Character*20 SecNam
      Parameter (SecNam='LDF_SortOverlapBlock')
#endif

      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iShlSO(i)=iWork(ip_iShlSO-1+i)
      iSOShl(i)=iWork(ip_iSOShl-1+i)

      iShell=iSOShl(iAOtSO(iAO+1,0))
      jShell=iSOShl(iAOtSO(jAO+1,0))
#if defined (_DEBUGPRINT_)
      If (nBasSh(iShell)*nBasSh(jShell).gt.lS) Then
         Call WarningMessage(2,SecNam//': array dimension problem')
         Call LDF_Quit(1)
      End If
#endif
      lSO=0
      If (iShell.eq.jShell) Then
         Do iComp=1,iCmp
            iSO0=iAOtSO(iAO+iComp,0)-1
            Do jComp=1,iComp-1
               jSO0=iAOtSO(jAO+jComp,0)-1
               lSO=lSO+1
               Do jj=1,jBas
                  jSOj=iShlSO(jSO0+jj)
#if defined (_DEBUGPRINT_)
                  If (jSOj.lt.1 .or. jSOj.gt.nBasSh(jShell)) Then
                     Call WarningMessage(2,
     &                                    SecNam//' jSOj out of bounds')
                     Call LDF_Quit(1)
                  End If
#endif
                  i_j_0=nBasSh(iShell)*(jSOj-1)
                  ij0=iBas*(jj-1)
                  Do ii=1,iBas
                     iSOi=iShlSO(iSO0+ii)
#if defined (_DEBUGPRINT_)
                     If (iSOi.lt.1 .or. iSOi.gt.nBasSh(iShell)) Then
                        Call WarningMessage(2,
     &                                    SecNam//' iSOi out of bounds')
                        Call LDF_Quit(1)
                     End If
                     If ((i_j_0+iSOi).lt.1 .or. (i_j_0+iSOi).gt.lS) Then
                        Call WarningMessage(2,
     &                                     SecNam//' i_j out of bounds')
                        Call LDF_Quit(1)
                     End If
#endif
                     S(i_j_0+iSOi)=SOInt(ij0+ii,lSO)
                  End Do
               End Do
            End Do
            jComp=iComp
            jSO0=iAOtSO(jAO+jComp,0)-1
            lSO=lSO+1
            Do jj=1,jBas
               jSOj=iShlSO(jSO0+jj)
#if defined (_DEBUGPRINT_)
               If (jSOj.lt.1 .or. jSOj.gt.nBasSh(jShell)) Then
                  Call WarningMessage(2,SecNam//' jSOj out of bounds')
                  Call LDF_Quit(1)
               End If
#endif
               i_j_0=nBasSh(iShell)*(jSOj-1)
               ij0=iBas*(jj-1)
               Do ii=jj,iBas
                  iSOi=iShlSO(iSO0+ii)
#if defined (_DEBUGPRINT_)
                  If (iSOi.lt.1 .or. iSOi.gt.nBasSh(iShell)) Then
                     Call WarningMessage(2,
     &                                    SecNam//' iSOi out of bounds')
                     Call LDF_Quit(1)
                  End If
                  If ((i_j_0+iSOi).lt.1 .or. (i_j_0+iSOi).gt.lS) Then
                     Call WarningMessage(2,SecNam//' i_j out of bounds')
                     Call LDF_Quit(1)
                  End If
#endif
                  S(i_j_0+iSOi)=SOInt(ij0+ii,lSO)
                  S(nBasSh(jShell)*(iSOi-1)+jSOj)=SOInt(ij0+ii,lSO)
               End Do
            End Do
         End Do
      Else
         Do iComp=1,iCmp
            iSO0=iAOtSO(iAO+iComp,0)-1
            Do jComp=1,jCmp
               jSO0=iAOtSO(jAO+jComp,0)-1
               lSO=lSO+1
               Do jj=1,jBas
                  jSOj=iShlSO(jSO0+jj)
#if defined (_DEBUGPRINT_)
                  If (jSOj.lt.1 .or. jSOj.gt.nBasSh(jShell)) Then
                     Call WarningMessage(2,
     &                                    SecNam//' jSOj out of bounds')
                     Call LDF_Quit(1)
                  End If
#endif
                  i_j_0=nBasSh(iShell)*(jSOj-1)
                  ij0=iBas*(jj-1)
                  Do ii=1,iBas
                     iSOi=iShlSO(iSO0+ii)
#if defined (_DEBUGPRINT_)
                     If (iSOi.lt.1 .or. iSOi.gt.nBasSh(iShell)) Then
                        Call WarningMessage(2,
     &                                    SecNam//' iSOi out of bounds')
                        Call LDF_Quit(1)
                     End If
                     If ((i_j_0+iSOi).lt.1 .or. (i_j_0+iSOi).gt.lS) Then
                        Call WarningMessage(2,
     &                                     SecNam//' i_j out of bounds')
                        Call LDF_Quit(1)
                     End If
#endif
                     S(i_j_0+iSOi)=SOInt(ij0+ii,lSO)
                  End Do
               End Do
            End Do
         End Do
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Chad E. Hoyer                                          *
!***********************************************************************
!  DQVDiabat
!
!> @brief
!>   Compute diabats with DQV
!> @author C. E. Hoyer
!>
!> @details
!> This subroutine takes in properties that have been
!> computed by RASSI and uses them to compute diabatic
!> states and thus diabatic energies and couplings.
!> Currently, the user must compute x, y, z, xx,
!> yy, zz, and 1/r, and they must be computed in that
!> order.
!>
!> @param[in] PROP Properties computed in RASSI
!> @param[in] HAM
!***********************************************************************

subroutine DQVDiabat(PROP,HAM)

use Cntrl, only: AlphZ, BetaE, ICOMP, NPROP, NSTATE, PNAME
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half, Quart, Pi
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: PROP(NSTATE,NSTATE,NPROP)
real(kind=wp), intent(in) :: HAM(NSTATE,NSTATE)
integer :: I, IPROP, ISTA, JSTA, K, PNUM(7)
real(kind=wp) :: ATerm, BTerm, Chng, CosO, CTerm, RotAngF, RotAngO, SinO, ThrSch, TII, TIJ, TJJ
real(kind=wp), allocatable :: HDIA(:,:), TI(:), TJ(:), TMP(:,:), TROT(:,:), TRQ(:,:)
integer(kind=iwp), parameter :: itMAX = 50
real(kind=wp), parameter :: MTE = 1.0e-8_wp, MTF = 1.0e-14_wp, THRS = 1.0e-8_wp

! Printing some stuff

write(u6,*)
write(u6,*)
write(u6,'(6X,A)') repeat('*',100)
write(u6,'(6X,A,98X,A)') '*','*'
write(u6,'(6X,A,33X,A,34X,A)') '*',' The DQV Diabatization Section ','*'
write(u6,'(6X,A,98X,A)') '*','*'
write(u6,'(6X,A)') repeat('*',100)
write(u6,*)
write(u6,*)

call CollapseOutput(1,'DQV Diabatization section')
write(u6,'(3X,A)') '-------------------------'

! Find the properties we need
PNUM(:) = 0
do IPROP=1,NPROP
  if (PNAME(IPROP) == 'MLTPL  1') then
    if (ICOMP(IPROP) == 1) PNUM(1) = IPROP
    if (ICOMP(IPROP) == 2) PNUM(2) = IPROP
    if (ICOMP(IPROP) == 3) PNUM(3) = IPROP
  end if
  if (PNAME(IPROP) == 'MLTPL  2') then
    if (ICOMP(IPROP) == 1) PNUM(4) = IPROP
    if (ICOMP(IPROP) == 4) PNUM(5) = IPROP
    if (ICOMP(IPROP) == 6) PNUM(6) = IPROP
  end if
  if (PNAME(IPROP) == 'EF0    1') then
    if (ICOMP(IPROP) == 1) PNUM(7) = IPROP
  end if
end do
do IPROP=1,7
  if (PNUM(IPROP) == 0) then
    write(u6,*) 'DQVDiabat: Some required properties are not available'
    call Abend()
  end if
end do

! CEH Now we maximize f_DQV through a Jacobi sweep algorithm

! Initialize rotation matrix to unit matrix (theta=0)
call mma_allocate(TROT,NSTATE,NSTATE,Label='TROT')
call unitmat(TROT,NSTATE)

!Now, we have to form the trace of the quadrupole
!The user has to specify dipole then quadrupole
call mma_allocate(TRQ,NSTATE,NSTATE,Label='TRQ')
TRQ(:,:) = PROP(:,:,PNUM(4))+PROP(:,:,PNUM(5))+PROP(:,:,PNUM(6))

call RecPrt('The TRQ matrix in DQVDiabat','',TRQ,NSTATE,NSTATE)
write(u6,*)

call mma_allocate(TI,NSTATE,Label='TI')
call mma_allocate(TJ,NSTATE,Label='TJ')
do i=1,itMAX
  THRSCH = Zero

  do ISTA=1,NSTATE
    do JSTA=ISTA+1,NSTATE

      ! Equations 9 and 10 of Kleir et al. with \mu written
      ! as a vector in addition to the quadrupole trace

      ATERM = PROP(ISTA,JSTA,PNUM(1))**2+PROP(ISTA,JSTA,PNUM(2))**2+PROP(ISTA,JSTA,PNUM(3))**2+ALPHZ*TRQ(ISTA,JSTA)**2+ &
              BETAE*PROP(ISTA,JSTA,PNUM(7))**2-Quart*(PROP(ISTA,ISTA,PNUM(1))**2+PROP(ISTA,ISTA,PNUM(2))**2+ &
              PROP(ISTA,ISTA,PNUM(3))**2+ALPHZ*TRQ(ISTA,ISTA)**2+BETAE*PROP(ISTA,ISTA,PNUM(7))**2)- &
              Quart*(PROP(JSTA,JSTA,PNUM(1))**2+PROP(JSTA,JSTA,PNUM(2))**2+PROP(JSTA,JSTA,PNUM(3))**2+ALPHZ*TRQ(JSTA,JSTA)**2+ &
              BETAE*PROP(JSTA,JSTA,PNUM(7))**2)+Half*(PROP(ISTA,ISTA,PNUM(1))*PROP(JSTA,JSTA,PNUM(1))+ &
              PROP(ISTA,ISTA,PNUM(2))*PROP(JSTA,JSTA,PNUM(2))+PROP(ISTA,ISTA,PNUM(3))*PROP(JSTA,JSTA,PNUM(3))+ &
              ALPHZ*TRQ(ISTA,ISTA)*TRQ(JSTA,JSTA)+BETAE*PROP(ISTA,ISTA,PNUM(7))*PROP(JSTA,JSTA,PNUM(7)))

      BTERM = PROP(ISTA,JSTA,PNUM(1))*(PROP(ISTA,ISTA,PNUM(1))-PROP(JSTA,JSTA,PNUM(1)))+ &
              PROP(ISTA,JSTA,PNUM(2))*(PROP(ISTA,ISTA,PNUM(2))-PROP(JSTA,JSTA,PNUM(2)))+ &
              PROP(ISTA,JSTA,PNUM(3))*(PROP(ISTA,ISTA,PNUM(3))-PROP(JSTA,JSTA,PNUM(3)))+ &
              ALPHZ*TRQ(ISTA,JSTA)*(TRQ(ISTA,ISTA)-TRQ(JSTA,JSTA))+BETAE*PROP(ISTA,JSTA,PNUM(7))* &
              (PROP(ISTA,ISTA,PNUM(7))-PROP(JSTA,JSTA,PNUM(7)))

      if (abs(BTERM) > MTF) then
        if ((ATERM > MTE) .or. (ATERM < -MTE)) then
          ! This part of the code computes the rotation angle.
          CTERM = -BTERM/ATERM
          ROTANGF = atan(CTERM)

          if ((ROTANGF < Zero) .and. (BTERM > Zero)) ROTANGF = ROTANGF+PI

          if ((ROTANGF > Zero) .and. (BTERM < Zero)) ROTANGF = ROTANGF-PI

          ROTANGO = ROTANGF*Quart

          if ((ROTANGO > PI*Quart) .or. (ROTANGO < -PI*Quart)) write(u6,*) 'Quadrants 2 and 3'

          COSO = cos(ROTANGO)
          SINO = sin(ROTANGO)

        else

          write(u6,*) 'A is pretty close to zero.  Something is fishy.'
          COSO = Zero
          SINO = Zero

        end if

        !Equation 13 of Kleir et al.
        CHNG = ATERM+sqrt(ATERM**2+BTERM**2)

        if (CHNG > THRSCH) THRSCH = CHNG

        if (CHNG > MTE) then

          !Update T rotation matrix
          TI(:) = COSO*TROT(:,ISTA)+SINO*TROT(:,JSTA)
          TJ(:) = COSO*TROT(:,JSTA)-SINO*TROT(:,ISTA)
          TROT(:,ISTA) = TI(:)
          TROT(:,JSTA) = TJ(:)

          ! Rotates transition dipole matrices
          ! These equations can be found in a book on Jacobi sweeps

          do k=1,3
            TII = PROP(ISTA,ISTA,PNUM(k))
            TJJ = PROP(JSTA,JSTA,PNUM(k))
            TIJ = PROP(ISTA,JSTA,PNUM(k))
            TI(:) = COSO*PROP(:,ISTA,PNUM(k))+SINO*PROP(:,JSTA,PNUM(k))
            TJ(:) = COSO*PROP(:,JSTA,PNUM(k))-SINO*PROP(:,ISTA,PNUM(k))
            PROP(ISTA,:,PNUM(k)) = TI(:)
            PROP(:,ISTA,PNUM(k)) = TI(:)
            PROP(JSTA,:,PNUM(k)) = TJ(:)
            PROP(:,JSTA,PNUM(k)) = TJ(:)
            PROP(ISTA,JSTA,PNUM(k)) = (COSO**2-SINO**2)*TIJ+COSO*SINO*(TJJ-TII)
            PROP(JSTA,ISTA,PNUM(k)) = PROP(ISTA,JSTA,PNUM(k))
            PROP(ISTA,ISTA,PNUM(k)) = COSO**2*TII+SINO**2*TJJ+Two*COSO*SINO*TIJ
            PROP(JSTA,JSTA,PNUM(k)) = SINO**2*TII+COSO**2*TJJ-Two*COSO*SINO*TIJ
          end do

          ! Rotates trace of quadrupole matrix

          TII = TRQ(ISTA,ISTA)
          TJJ = TRQ(JSTA,JSTA)
          TIJ = TRQ(ISTA,JSTA)
          TI(:) = COSO*TRQ(:,ISTA)+SINO*TRQ(:,JSTA)
          TJ(:) = COSO*TRQ(:,JSTA)-SINO*TRQ(:,ISTA)
          TRQ(ISTA,:) = TI(:)
          TRQ(:,ISTA) = TI(:)
          TRQ(JSTA,:) = TJ(:)
          TRQ(:,JSTA) = TJ(:)
          TRQ(ISTA,JSTA) = (COSO**2-SINO**2)*TIJ+COSO*SINO*(TJJ-TII)
          TRQ(JSTA,ISTA) = TRQ(ISTA,JSTA)
          TRQ(ISTA,ISTA) = COSO**2*TII+SINO**2*TJJ+Two*COSO*SINO*TIJ
          TRQ(JSTA,JSTA) = SINO**2*TII+COSO**2*TJJ-Two*COSO*SINO*TIJ

          ! Rotates electric potential

          k = 7
          TII = PROP(ISTA,ISTA,PNUM(k))
          TJJ = PROP(JSTA,JSTA,PNUM(k))
          TIJ = PROP(ISTA,JSTA,PNUM(k))
          TI(:) = COSO*PROP(:,ISTA,PNUM(k))+SINO*PROP(:,JSTA,PNUM(k))
          TJ(:) = COSO*PROP(:,JSTA,PNUM(k))-SINO*PROP(:,ISTA,PNUM(k))
          PROP(ISTA,:,PNUM(k)) = TI(:)
          PROP(:,ISTA,PNUM(k)) = TI(:)
          PROP(JSTA,:,PNUM(k)) = TJ(:)
          PROP(:,JSTA,PNUM(k)) = TJ(:)
          PROP(ISTA,JSTA,PNUM(k)) = (COSO**2-SINO**2)*TIJ+COSO*SINO*(TJJ-TII)
          PROP(JSTA,ISTA,PNUM(k)) = PROP(ISTA,JSTA,PNUM(k))
          PROP(ISTA,ISTA,PNUM(k)) = COSO**2*TII+SINO**2*TJJ+Two*COSO*SINO*TIJ
          PROP(JSTA,JSTA,PNUM(k)) = SINO**2*TII+COSO**2*TJJ-Two*COSO*SINO*TIJ

        end if
      end if
    end do
  end do

  if (THRSCH < THRS) then
    write(u6,*) 'Converged in this many iterations:'
    write(u6,*) i
    write(u6,*)
    exit
  end if

end do
if (i > itMAX) write(u6,*) 'Max iterations'
call mma_deallocate(TRQ)
call mma_deallocate(TI)
call mma_deallocate(TJ)

call RecPrt('Diabatic Coefficients','',TROT,NSTATE,NSTATE)

call mma_allocate(TMP,NSTATE,NSTATE,Label='TMP')
TMP(:,:) = TROT(:,:)**2
call RecPrt('Weights of adiabatic states','',TMP,NSTATE,NSTATE)

call DGEMM_('T','N',NSTATE,NSTATE,NSTATE,One,TROT,NSTATE,HAM,NSTATE,Zero,TMP,NSTATE)

call mma_allocate(HDIA,NSTATE,NSTATE,Label='HDIA')
call DGEMM_('N','N',NSTATE,NSTATE,NSTATE,One,TMP,NSTATE,TROT,NSTATE,Zero,HDIA,NSTATE)
call mma_deallocate(TMP)
call mma_deallocate(TROT)

write(u6,*)
write(u6,*) 'The eigenvectors may no longer be in'
write(u6,*) 'energetic order'
write(u6,*)
call RecPrt('Diabatic Hamiltonian','',HDIA,NSTATE,NSTATE)

call CollapseOutput(0,'DQV Diabatization section')
write(u6,*)

! Molcas verify calls
call Add_Info('Adiabat1',HAM(1,1),1,4)
call Add_Info('Adiabat2',HAM(2,2),1,4)
call Add_Info('Adiabat3',HAM(3,3),1,4)
call Add_Info('DQVHam11',HDIA(1,1),1,4)
call Add_Info('DQVHam12',HDIA(1,2),1,4)
call Add_Info('DQVHam13',HDIA(1,3),1,4)
call Add_Info('DQVHam22',HDIA(2,2),1,4)
call Add_Info('DQVHam23',HDIA(2,3),1,4)
call Add_Info('DQVHam33',HDIA(3,3),1,4)
! End Molcas verify calls

call mma_deallocate(HDIA)

end subroutine DQVDiabat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Francesco Aquilante                              *
************************************************************************
      SubRoutine Cho_SOSmp2_Setup(irc)
C
C     Francesco Aquilante   May 2007.
C
C     Purpose: setup of SOS-MP2 program.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"
************************************************************************
      MulD2h(i,j)=iEor(i-1,j-1) + 1
************************************************************************

      irc = 0

C     Setup index arrays and counters.
C     --------------------------------

      If (DecoMP2 .and. ThrMP2.le.0.0D0) Then
         Call Get_dScalar('Cholesky Threshold',ThrMP2)
      End If

      Call ChoMP2_GetInf(nOrb,nOcc,nFro,nDel,nVir)
      iOcc(1) = 0
      iVir(1) = 0
      nOccT = nOcc(1)
      nVirT = nVir(1)
      Do iSym = 2,nSym
         iOcc(iSym) = nOccT
         iVir(iSym) = nVirT
         nOccT = nOccT + nOcc(iSym)
         nVirT = nVirT + nVir(iSym)
      End Do

      Do iSym = 1,nSym
         nT1am(iSym) = 0
         Do iSymi = 1,nSym
            iSyma = MulD2h(iSymi,iSym)
            iT1am(iSyma,iSymi) = nT1am(iSym)
            nT1am(iSym) = nT1am(iSym)
     &                  + nVir(iSyma)*nOcc(iSymi)
         End Do
      End Do

      Do iSym = 1,nSym
         nT1AOT(iSym) = 0
         Do iSymAl = 1,nSym
            iSymi = MulD2h(iSymAl,iSym)
            iT1AOT(iSymi,iSymAl) = nT1AOT(iSym)
            nT1AOT(iSym) = nT1AOT(iSym)
     &                   + nOcc(iSymi)*nBas(iSymAl)
         End Do
      End Do

      Do iSym = 1,nSym
         nAOVir(iSym) = 0
         Do iSyma = 1,nSym
            iSymAl = MulD2h(iSyma,iSym)
            iAOVir(iSymAl,iSyma) = nAOVir(iSym)
            nAOVir(iSym) = nAOVir(iSym)
     &                   + nBas(iSymAl)*nVir(iSyma)
         End Do
      End Do

      If (ChoAlg .eq. 2) Then
         Do iSym = 1,nSym
            nMatab(iSym) = 0
            Do iSymb = 1,nSym
               iSyma = MulD2h(iSymb,iSym)
               iMatab(iSyma,iSymb) = nMatab(iSym)
               nMatab(iSym) = nMatab(iSym) + nVir(iSyma)*nVir(iSymb)
            End Do
         End Do
      Else
         Call Cho_iZero(nMatab,8)
         Call Cho_iZero(iMatab,64)
      End If

C     If batching over occuped orbitals is forced by user, then
C        turn it Off !
C     -----------------------------------------------------------------

      ForceBatch = .false.

      nBatch = 1

C     Initialize file units.
C     ----------------------

      Do iSym = 1,nSym
         Do iTyp = 1,nTypF
            Call ChoMP2_OpenF(0,iTyp,iSym)
         End Do
      End Do

      End

************************************************************************
      SubRoutine Cho_SOSmp2_Setup_Prt(irc)
C
C     Francesco Aquilante  May 2007
C
C     Purpose: print setup for SOS-MP2.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "chomp2_cfg.fh"
#include "chomp2.fh"
#include "WrkSpc.fh"


      irc = 0

      Call Cho_Head('Cholesky SOS-MP2 Setup','=',80,6)
      Write(6,*)

      If (nBatch .gt. 1) Then
         Write(6,'(A,I6,A,I6,A)')
     &   'The list of',nOccT,' occupied orbitals has been split in',
     &   nBatch,' batches:'
         Write(6,*)'Batching is not allowed in SOS-MP2 : I stop here! '
         Call Abend()
      Else If (nBatch .eq. 1) Then
         Write(6,'(A,I6,A)')
     &   'The list of',nOccT,' occupied orbitals is not split:'
      Else
         Write(6,*) 'Oops, #batches over occupied orbitals ',
     &              'is non-positive: ',nBatch
         irc = -101
         Return
      End If

      Write(6,'(//,A)')
     & 'The following tasks will be performed:'
      Write(6,'(A)')
     & ' * AO-to-MO transformation of original Cholesky vectors.'
      If (DecoMP2) Then
         Write(6,'(A)')
     &   ' * Cholesky decomposition of M=(ai|bj)^2 matrix.'
      End If
      Write(6,*)
     & ' * Calculation of SOS-MP2 correlation energy.'

      Call xFlush(6)

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine daxpint(from,to,fact,ndim1,ndim2,ndim3,ndim4)
!bs subroutine similar to daxpy with interchange of two indices
!bs change from physicists notation to chemists notaion
!bs to(i,j,k,l)=to(i,j,k,l)+fact*from(i,k,j,l)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ndim1, ndim2, ndim3, ndim4
real(kind=wp), intent(in) :: from(ndim1,ndim2,ndim3,ndim4), fact
real(kind=wp), intent(inout) :: to(ndim1,ndim3,ndim2,ndim4)
integer(kind=iwp) :: irun2, irun3

if (fact /= Zero) then
  do irun3=1,ndim3
    do irun2=1,ndim2
      to(:,irun3,irun2,:) = to(:,irun3,irun2,:)+fact*from(:,irun2,irun3,:)
    end do
  end do
end if

return

end subroutine daxpint

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! =SVC= Special FULLTRNSF routine for boxed ordering with less
! efficiency than the original (except when we would take NWSZ=NW, which
! would make it possible to treat all J in one go)

subroutine FULLTRNSF_BOXED(IPSTA,IWSTA,NPSZ,NWSZ,NP,NW,NB,CMOBLK,NJ,BUF_HT,BUF_FT,BUFFY)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IPSTA, IWSTA, NPSZ, NWSZ, NP, NW, NB, NJ
real(kind=wp), intent(in) :: CMOBLK(NB,NPSZ), BUF_HT(NW,NJ,NB)
real(kind=wp), intent(out) :: BUF_FT(NP*NW,NJ), BUFFY(NPSZ,NWSZ)
integer(kind=iwp) :: IPW, J

! In: Vectors of type HALF(W,J,B) = Sum(CHO(AB,J)*CMO(A,W),A=1,NBAS)

! Compute fully transformed Cholesky vector buffer:
! FULL(P,W,J)=Sum(CMO(B,P)*HALF(W,J,B),B=1,NB)
iPW = 1+NW*(IPSTA-1)+NPSZ*(IWSTA-1)
do J=1,NJ
  call DGEMM_('T','T',NPSZ,NWSZ,NB,One,CMOBLK,NB,BUF_HT(IWSTA,J,1),NW*NJ,Zero,BUFFY,NPSZ)
  BUF_FT(iPW:iPW+NPSZ*NWSZ-1,J) = pack(BUFFY(:,:),.true.)
end do

end subroutine FULLTRNSF_BOXED

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Per Ake Malmqvist                                *
*               2018, Jesper Norell                                    *
************************************************************************

*****************************************************************
* Modified from MKTAB to MKDYSAB by Jesper Norell, 2018
*  SUBROUTINE MKDYSAB
*  PURPOSE: CALCULATE DYSON ORBITAL COEFFICIENTS FOR CI EXPANSIONS IN
*  BIORTHONORMAL ORBITAL BASE A,
*  IN ANALOGUE TO MKTDAB FOR TRANSITION DENSITY MATRIX.
*****************************************************************

      SUBROUTINE MKDYSAB(DYSCOF,DYSAB)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 DYSCOF(*),DYSAB(*)
#include "Molcas.fh"
#include "cntrl.fh"
#include "rassi.fh"
#include "symmul.fh"
#include "WrkSpc.fh"

C *** Symmetry is likely not handled correctly, since the effect
C *** of the annihilated electron is not accounted for.

      DIMENSION IOFFA(8)
C IOFFA=NR OF ACTIVE ORBITALS IN PREVIOUS SYMMETRY BLOCKS.
      IOFFA(1)=0
      DO I=1,NSYM-1
        IOFFA(I+1)=IOFFA(I)+NASH(I)
      END DO

C CONTRIBUTION FROM INACTIVE ORBITALS:
C (By definition 0 for Dyson orbitals,
C but we need to fill out the full vector for easier
C transformation.)
      IF(LSYM1.EQ.LSYM2) THEN
        IOFFTD=0
        DO 50 ISY=1,NSYM
          II=0
          DO 40 I=1,NISH(ISY)
            II=II+1
            IPOS=IOFFTD+II
            DYSAB(IPOS)=0.0D0
40        CONTINUE
          IOFFTD=IOFFTD+NOSH(ISY)
50      CONTINUE
      END IF

C THEN ADD CONTRIBUTION FROM ACTIVE SPACE.
      ISY12=MUL(LSYM1,LSYM2)
      IOFFTD=0
      ICOFF=1
      DO 120 ISY1=1,NSYM
        NO1=NOSH(ISY1)
        IF(NO1.EQ.0) GOTO 120
        NA1=NASH(ISY1)
        IF(NA1.EQ.0) GOTO 110
        NI1=NISH(ISY1)
        DO 100 I=1,NA1
          IA=IOFFA(ISY1)+I
          II=NI1+I
          IPOS=IOFFTD+II

! Alpha and beta contributions are added up, in analogue to other rassi
! routines.
! Alpha
          DYSAB(IPOS)=DYSCOF(ICOFF) ! Overwrite "old" values
          ICOFF=ICOFF+1
! Beta
          DYSAB(IPOS)=DYSAB(IPOS)+DYSCOF(ICOFF)
          ICOFF=ICOFF+1
100     CONTINUE
110     IOFFTD=IOFFTD+NO1
120   CONTINUE

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Roland Lindh                                           *
!***********************************************************************
!  Put_AnalHess
!
!> @brief
!>   Write the symmetry blocked nuclear Hessian in Cartesian coordinates on the runfile
!> @author R. Lindh
!>
!> @details
!> The utility will write the symmetry blocked nuclear Hessian in Cartesian coordinates on the runfile.
!>
!> @param[in] AnalHess  Array with the symmetry blocked nuclear Hessian in Cartesian coordinates
!> @param[in] nAnalHess Size of the array \p AnalHess
!***********************************************************************

subroutine Put_AnalHess(AnalHess,nAnalHess)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAnalHess
real(kind=wp), intent(in) :: AnalHess(nAnalHess)
integer(kind=iwp) :: inLoop, irderr, iSI1(7), iTmp
logical(kind=iwp) :: Found
character(len=88) :: Label

call Put_dArray('Analytic Hessian',AnalHess,nAnalHess)

! Add the iteration number corresponding to this Hessian
iSI1(2) = 0
call Qpg_iArray('Slapaf Info 1',Found,iTmp)
if (Found) call Get_iArray('Slapaf Info 1',iSI1,7)
call Getenvf('MOLCAS_ITER',Label)
read(Label,'(I80)') iTmp
call Getenvf('EMIL_InLoop',Label)
read(Label,*,IOStat=irderr) inLoop
if (irderr /= 0) inLoop = 0
if (inLoop < 1) iTmp = 0
if (iTmp == 0) then
  call Put_iScalar('HessIter',iTmp)
else
  call Put_iScalar('HessIter',iSI1(2)+1)
end if

return

end subroutine Put_AnalHess

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1989, Per Ake Malmqvist                                *
!***********************************************************************
!****************************************************************
!  PROGRAM RASSI        PER-AAKE MALMQVIST
!  SUBROUTINE GETH1     IBM-3090 RELEASE 89 01 30
!  READ THE ONE-ELECTRON HAMILTONIAN MATRIX ELEMENTS AND RETURN
!  IT AS HONEAO IN SYMMETRY-BLOCKED SQUARED FORMAT.
!  Also reads and adds reaction field contribution.
!  Also ERFNUC, reaction field contribution to nuclear repulsion.
!****************************************************************

subroutine GETH1_RASSI(HONEAO)

use OneDat, only: sNoNuc, sNoOri
use Cntrl, only: ERFNuc, RFPert
use Symmetry_Info, only: nIrrep
use rassi_data, only: NBASF, NBSQ, NBTRI
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: HONEAO(NBSQ)
integer(kind=iwp) :: iBuf, ICMP, IOPT, IP, IPQ, IQ, IQP, IRC, ISTQ, iSyLab, ISYM, NB
logical(kind=iwp) :: Found
character(len=6) :: OneLbl = 'OneHam'
real(kind=wp), allocatable :: H1(:), Tmp(:)

call mma_allocate(H1,NBTRI,Label='H1')
iRc = -1
iOpt = ibset(ibset(0,sNoOri),sNoNuc)
iCmp = 1
iSyLab = 1
OneLbl = 'OneHam'
call RdOne(iRc,iOpt,OneLbl,iCmp,H1,iSyLab)
if (IRC /= 0) then
  write(u6,*)
  write(u6,*) '      *** ERROR IN SUBROUTINE  GETH1 ***'
  write(u6,*) '   BARE NUCLEI HAMILTONIAN IS NOT AVAILABLE'
  write(u6,*)
  call ABEND()
end if
ERFNuc = Zero
if (RFpert) then
  call f_Inquire('RUNOLD',Found)
  if (Found) call NameRun('RUNOLD')
  call mma_allocate(Tmp,nBtri,Label='Tmp')
  call Get_dScalar('RF Self Energy',ERFNuc)
  call Get_dArray('Reaction field',Tmp,nBtri)
  if (Found) call NameRun('#Pop')
  H1(:) = H1(:)+Tmp(:)
  call mma_deallocate(Tmp)
end if
IBUF = 1
ISTQ = 0
do ISYM=1,nIrrep
  NB = NBASF(ISYM)
  if (NB == 0) cycle
  do IP=1,NB
    do IQ=1,IP
      IPQ = NB*(IP-1)+IQ+ISTQ
      IQP = NB*(IQ-1)+IP+ISTQ
      HONEAO(IPQ) = H1(IBUF)
      HONEAO(IQP) = H1(IBUF)
      IBUF = IBUF+1
    end do
  end do
  ISTQ = ISTQ+NB**2
end do
call mma_deallocate(H1)

end subroutine GETH1_RASSI

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine CVE2 (V,oe,dima,dimb,adda,addb,no,e2,e2os)
c
c       this routine do:
c       e2  =e2   + sum(a',b',i,j)[(a'i|b'j).{2(a'i|b'j)-(a'j|b'i)}]/Dija'b'
c       e2os=e2os + sum(a',b',i,j)[(a'i|b'j).{ (a'i|b'j)          }]/Dija'b'
c       N.B. Cierny Vypocet E2
c       N.B.2 qvajt odflaknute
c
        implicit none
        integer dima,dimb,adda,addb,no
        real*8 V(1:dima,1:no,1:dimb,1:no)
        real*8 oe(*)
        real*8 e2,e2os
c
c       help variables
        integer i,j,a,b
        real*8 dijab
c
c
        do j=1,no
          do b=1,dimb
            do i=1,no
              do a=1,dima
                dijab=oe(i)+oe(j)-oe(adda+a)-oe(addb+b)
                e2  =e2   +
     &     V(a,i,b,j)*(2.0d0*V(a,i,b,j)-V(a,j,b,i))/dijab
                e2os=e2os +
     &     V(a,i,b,j)*(      V(a,i,b,j)           )/dijab
              end do
            end do
          end do
        end do
c
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Auxil(T,nT,Fm,mHigh)
!***********************************************************************
!                                                                      *
!     Object: to compute the auxiliary functions in quadruple precision*
!             for a number of arguments.                               *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!***********************************************************************

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nT, mHigh
real(kind=wp), intent(in) :: T(nT)
real(kind=wp), intent(out) :: Fm(nT,0:mHigh)
integer(kind=iwp) :: i, m
real(kind=wp) :: Ti

call HighFm(Fm(:,mHigh),T,mHigh,nT)

! Now use recursion formula for Fm, 0<=m<mHigh

do i=1,nT
  Ti = T(i)
  do m=mHigh-1,0,-1
    Fm(i,m) = (Two*Ti*Fm(i,m+1)+exp(-Ti))/real(2*m+1,kind=wp)
  end do
end do
!call RecPrt(' Fm',' ',Fm,nT,mHigh+1)

return

end subroutine Auxil

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_VecBuf_GetLQ(QVec,l_QVec)
C
C     Purpose: extract elements corresponding to qualified diagonals
C              from vectors in buffer.
C
      Implicit Real*8 (a-h,o-z)
      Real*8  QVec(l_QVec)
#include "cholesky.fh"
#include "chovecbuf.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Integer nVecTot(8)

      iQuAB(i,j)=iWork(ip_iQuAB-1+MaxQual*(j-1)+i)
      BVec(i,j,k)=Work(ip_ChVBuf_Sym(k)-1+nnBstR(k,2)*(j-1)+i)

C     Check if there is any buffer at all.
C     ------------------------------------

      If (l_ChVBuf .lt. 1) Return

C     Extract from each symmetry block.
C     ---------------------------------

      Call Cho_P_GetGV(nVecTot,nSym)

      kOffQ = 0
      Do iSym = 1,nSym
         If (nQual(iSym) .gt. 0) Then
            Do iVec = 1,nVec_in_Buf(iSym)
               kQ = kOffQ + nQual(iSym)*(iVec-1)
               Do iQ = 1,nQual(iSym)
                  iAB = iQuAB(iQ,iSym) - iiBstR(iSym,2)
                  QVec(kQ+iQ) = BVec(iAB,iVec,iSym)
               End Do
            End Do
            kOffQ = kOffQ + nQual(iSym)*nVecTot(iSym)
         End If
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Giovanni Ghigo                                   *
!***********************************************************************

subroutine MkL2(iSymA,iSymI,iI,numV,LyType,iJy,AddLx0,SameLx)
!***********************************************************************
! Author :  Giovanni Ghigo                                             *
!           Lund University, Sweden & Torino University, Italy         *
!           February 2005                                              *
!----------------------------------------------------------------------*
! Purpuse:  Generation of the Cholesky matrix of Active(iSymA) for     *
!           occupied iI(iSymI) for numV vectors.                       *
!***********************************************************************

use Cho_Tra, only: nAsh, nIsh, TCVX
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iSymA, iSymI, iI, numV
integer(kind=iwp), intent(inout) :: LyType, iJy
real(kind=wp), intent(_OUT_) :: AddLx0(*)
logical(kind=iwp), intent(inout) :: SameLx
integer(kind=iwp) :: iAddLx, iAddTCVX, iIx, iV, LxType

! Build Lx
if (iI <= nIsh(iSymI)) then
  LxType = 2
  iIx = iI
else
  LxType = 4
  iIx = iI-nIsh(iSymI)
end if

if (.not. SameLx) then
  LyType = LxType
  iJy = iIx
else
  if ((LyType == LxType) .and. (iIx == iJy)) then
    return
  else
    SameLx = .false.
  end if
end if

iAddLx = 1
iAddTCVX = 1+nAsh(iSymA)*(iIx-1)
do iV=1,numV
  call dCopy_(nAsh(iSymA),TCVX(LxType,iSymA,iSymI)%A(iAddTCVX,iV),1,AddLx0(iAddLx),1)
  iAddLx = iAddLx+nAsh(iSymA)
end do

return

end subroutine MkL2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Steven Vancoillie                                      *
************************************************************************
      Module InputData
      Implicit None
CSVC: this module contains a data structure to keep all input variables.
C Note that I use the standard 'allocate' here against the appropriate
C Molcas practices. The reason is that these are (i) very small, and
C (ii) there is need for allocating complex things such as derived
C types, which are not supported with stdalloc. Hence, the infraction.

#include "compiler_features.h"

      Type States
      Integer, Allocatable :: State(:)
      End Type

      Type InputTable
!     TITL      one line with a descriptive name
      Character(Len=128) :: Title = ' '
!     FILE      file to read CAS/RAS reference from
      Character(Len=128) :: File = 'JOBIPH'
!     MULT      the number of states, followed by the ID of each state
      Logical :: MULT = .False.
      Integer :: nMultState = 0
      Type(States) :: MultGroup
      Logical :: AllMult = .False.
!     XMUL      extended multi-state caspt2
      Logical :: XMUL = .False.
      Integer :: nXMulState = 0
      Type(States) :: XMulGroup
      Logical :: AllXMult = .False.
!     DWMS      use dynamical weighting to construct Fock
      Logical :: DWMS = .False.
      Integer :: ZETA = 50
!     EFOC      uses rotated E_0 energies with DWMS
      Logical :: EFOC = .False.
!     LROO      compute only a single root, mutually exclusive
!               with both MULT or XMUL
      Logical :: LROO = .False.
      Integer :: SingleRoot = 0
!     RLXR      root for which the gradient is computed
      Integer :: RlxRoot = -1

!     IPEA      sets the IP-EA shift
      Logical :: IPEA = .False.
      Real*8 :: BSHIFT = 0.0d0

!     IMAG      size of extra 'imaginary' denominator shift
      Real*8 :: ShiftI = 0.0d0
!     SHIF      size of extra denominator shift
      Real*8 :: Shift = 0.0d0

!     several freeze-delete schemes, each of these should active
!     the general flag below, to indicate additional conversion is
!     needed on the input orbitals
      Logical :: modify_correlating_MOs = .False.
!     AFRE      freeze orbitals that do not have sufficient density
!               on specified 'active' atoms
      Logical :: aFreeze = .False.
      Integer :: lnFro = 0
      Real*8 :: ThrFr = 0.0d0, ThrDe = 0.0d0
      Character(Len=4), Allocatable :: NamFro(:)
!     LOVC      freeze orbitals that are not localized no the active
!               site
      Logical :: LovCASPT2 = .False.
      Real*8 :: Thr_Atm = 0.0d0
!     FNOC      delete a fraction of virtual orbitals
      Logical :: FnoCASPT2 = .False.
      Real*8 :: VFrac = 0.0d0
!     DOMP
      Logical :: DoMP2 = .False.
!     DOEN
      Logical :: DoEnv = .False.
!     VIRA
      Logical :: VIRA = .False.
!     GHOS      excludes ghost orbitals from the PT2 treatment
      Logical :: GhostDelete = .False.
      Real*8 :: ThrGD = 0.0d0

!     FROZ      number of frozen orbitals in each irrep
      Logical :: FROZ = .False.
      Integer, Allocatable :: nFro(:)
!     DELE      number of deleted orbitals in each irrep
      Logical :: DELE = .False.
      Integer, Allocatable :: nDel(:)
!     DENS      computes full density matrix from the 1st-order
!               wavefunction
      Logical :: DENS = .False.
!     RFPE      make a perturbative reaction field calculation
      Logical :: RFPert = .False.
!     THRE      thresholds for removal of:
!       ThrsHN    zero-norm components in the first-order perturbed
!                 wave function
!       ThrsHS    linear dependencies between components of the first-
!                 order perturbed wave function
      Logical :: THRE = .False.
      Real*8 :: ThrsHN = 1.0d-10, ThrsHS = 1.0d-8
!     MAXI      maximum number of iterations for solving a system of
!               linear equations, default 20. A 0 indicates: use of
!               the diagonal zeroth order hamiltonian
      Integer :: maxIter = 20
!     Conv      convergence criteria for solving a system of linear
!               equations
      Real*8 :: ThrConv = 1.0d-6
!     NOMI      do not create an PM-CAS wavefunction file (JobMix)
      Logical :: NoMix = .False.
!     NOMU      do not perform a multistate interaction
      Logical :: noMult = .False.
!     ONLY      in a MS calculation, compute a single root with
!               couplings to the other roots
      Integer :: OnlyRoot = 0
!     EFFE      read HEff coupling terms from the input and perform
!               only the multistate part
      Logical :: JMS = .False.
      Real*8, Allocatable :: HEff(:,:)
!     NOOR      do not print orbitals
      Logical :: PrOrb = .True.
!     PROP      compute properties
!     NOPR      do not compute properties
      Logical :: Properties = .False.
!     transformation of reference (input) orbitals
!     NOTR      do not transform to quasi-canonical orbitals,
!               regardless of the state of the reference orbitals
!     TRAN      transform to quasi-canonical orbitals, regardless
!               of the state of the reference orbitals
!     the default is to use transformation, unless the PT2 keyword
!     was used in the rasscf program and the fock matrix is standard
      Character(Len=8) :: ORBIN = 'TRANSFOR'
!     OFEM      add orbital-free embedding potential to the hamiltonian
      Logical :: OFEmbedding = .False.
!     OUTP      control extent of orbital printing
      Character(Len=8) :: OutFormat = 'DEFAULT '
!     PRWF      print the CI coefficients above this threshold
      Real*8 :: PrWF = 0.05d0
!     PRSD      print the determinant expansion of CSFs
      Logical :: PRSD = .False.
!     NOOR      do not print any orbitals
      Logical :: NoOrb = .False.

!     UNDOCUMENTED KEYWORDS
!     CHOL
      Logical :: CHOL = .False.
!     CHOI
      Logical :: CHOI = .False.
!     WTHR      thresholds for writing large components in the
!               first-order perturbed wave function, 3 values that
!               are for denominator, coefficient, and energy
      Real*8 :: DNMTHR = 0.3d0, CMPTHR = 0.025d0, CNTTHR = 0.005d0
!     FOCK      string representing the type of Fock matrix
      Character(Len=8) :: FockType = 'STANDARD'
!     HZER      string representing the type of 0-order hamiltonian
      Character(Len=8) :: HZero = 'STANDARD'
!     G1SE      include secondary/inactive elements of the exchange
!               matrix in the g1 modification to the fock matrix
      Logical :: G1SecIn = .False.
!     RHSD      use the RHS-ondemand algorithm for the calculation of
!               the right-hand side
      Logical :: RHSD = .False.
!     CUMU
      Logical :: DoCumulant = .False.
      End Type

#ifdef ALLOC_SCAL
      Type(InputTable), Allocatable :: Input
#else
      Type(InputTable) :: Input
#endif

      Save

      Contains

CIFG Some compilers have problems with allocatable strings.
C Use an inferior workaround.
#ifdef ALLOC_CHAR
#define alloc_dline   Allocate(Character(Len=Len(Line)) :: dLine)
#define dealloc_dline Deallocate(dLine)
#else
#define alloc_dline   !no-op
#define dealloc_dline !no-op
#endif

      Subroutine Readin_CASPT2(LuIn,nSym)
CSVC Read and store the input as independent as possible. Any sanity
C checks not required for reading in the input should be postponed till
C the proc_inp call (processing of input). The only variable needed here
C is nSym, as some input lines assume knowledge of the number of irreps.
      Implicit None
      Integer, intent(in) :: LuIn, nSym

      Character(Len=128) :: Line
#ifdef ALLOC_CHAR
      Character(len=:), Allocatable :: dLine
#else
      Character(Len=(Len(Line))) :: dLine
#endif
      Character(Len=4) :: Command, Word

      Integer :: i, j, iSym, nStates
      Integer :: iSplit, iError

      logical, external :: next_non_comment
#ifdef _ENABLE_CHEMPS2_DMRG_
      logical :: dochemps2 = .false.
#endif


*
      Rewind(LuIn)
      Call RdNLst(LuIn,'CASPT2')
10    Continue
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Command = Line(1:4)
      Call UpCase(Command)

CIFG Note that when multiple values are required, ExtendLine may
C be called (0 or more times) until the READ statement gives no error
C this allows the input to be split in lines more or less arbitrarily,
C as if the values were read directly from the file.
      Select Case (Command)

      Case('TITL')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read (Line,'(A128)') Input % Title

      ! File with the reference CAS/RAS wavefunction

      Case('FILE')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
C Not using list-directed input (*), because then the slash means
C end of input
      Read(Line,'(A)',Err=9920,End=9920) Input % FILE

      ! Root selection

      Case('MULT')
      Input % MULT = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*) Word
      Call UpCase(Word)
      If (Word=='ALL') Then
        nStates = 0
        Input%AllMult = .True.
      Else
        Read(Line,*,Err=9920,End=9920) nStates
        If (nStates.le.0) Then
          Write(6,*)' number of MULT states must be > 0, quitting!'
          Call Quit_OnUserError
        End If
      End If
      Allocate(Input%MultGroup%State(nStates))
      Input%nMultState = nStates
      iSplit = SCAN(Line,' ')
      alloc_dline
      dLine = Line(iSplit:)
      iError = -1
      Do While (iError.lt.0)
        Read(dLine,*,IOStat=iError)
     &    (Input%MultGroup%State(i), i=1,nStates)
        If (iError.gt.0) GoTo 9920
        If (iError.lt.0) Then
          If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
          Call ExtendLine(dLine,Line)
        End If
      End Do
      dealloc_dline

      Case('XMUL')
      Input % XMUL = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*) Word
      Call UpCase(Word)
      If (Word=='ALL') Then
        nStates = 0
        Input%AllXMult = .True.
      Else
        Read(Line,*,Err=9920,End=9920) nStates
        If (nStates.le.0) Then
          Write(6,*)' number of XMUL states must be > 0, quitting!'
          Call Quit_OnUserError
        End If
      End If
      Allocate(Input%XMulGroup%State(nStates))
      Input%nXMulState = nStates
      iSplit = SCAN(Line,' ')
      alloc_dline
      dLine = Line(iSplit:)
      iError = -1
      Do While (iError.lt.0)
        Read(dLine,*,IOStat=iError)
     &      (Input%XMulGroup%State(i), i=1,nStates)
        If (iError.gt.0) GoTo 9920
        If (iError.lt.0) Then
          If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
          Call ExtendLine(dLine,Line)
        End If
      End Do
      dealloc_dline


      Case('DWMS')
      Input % DWMS = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % ZETA

      Case('EFOC')
      Input % EFOC = .True.

      Case('LROO')
      Input % LROO = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % SingleRoot

      Case('RLXR')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % RlxRoot

      ! freeze-deleted control

      Case('FROZ')
      Input % FROZ = .True.
      Allocate(Input % nFro(nSYM))
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      alloc_dline
      dLine = Line
      iError = -1
      Do While (iError.lt.0)
        Read(dLine,*,IOStat=iError) (Input % nFro(iSym), iSym=1,nSym)
        If (iError.gt.0) GoTo 9920
        If (iError.lt.0) Then
          If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
          Call ExtendLine(dLine,Line)
        End If
      End Do
      dealloc_dline

      Case('DELE')
      Input % DELE = .True.
      Allocate(Input % nDel(nSYM))
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      alloc_dline
      dLine = Line
      iError = -1
      Do While (iError.lt.0)
        Read(dLine,*,IOStat=iError) (Input % nDel(iSym), iSym=1,nSym)
        If (iError.gt.0) GoTo 9920
        If (iError.lt.0) Then
          If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
          Call ExtendLine(dLine,Line)
        End If
      End Do
      dealloc_dline

      ! equation solver control

      Case('MAXI')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % maxIter

      Case('CONV')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % ThrConv

      Case('THRE')
      Input % THRE = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      alloc_dline
      dLine = Line
      iError = -1
      Do While (iError.lt.0)
        Read(dLine,*,IOStat=iError) Input % ThrsHN, Input % ThrsHS
        If (iError.gt.0) GoTo 9920
        If (iError.lt.0) Then
          If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
          Call ExtendLine(dLine,Line)
        End If
      End Do
      dealloc_dline

      Case('SHIF')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % Shift

      Case('IMAG')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % ShiftI

      ! environment

      Case('RFPE')
      Input % RFpert=.true.

      Case('OFEM')
      Input % OFEmbedding = .True.
c      call Quit_OnInstError

      ! print controls

      Case('PRWF')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % PrWF

      Case('OUTP')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Call StdFmt(Line,Input % OutFormat)

      Case('NOOR')
      Input % PrOrb = .False.

      Case('PRSD')
      Input % PRSD = .True.

      Case('WTHR')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      alloc_dline
      dLine = Line
      iError = -1
      Do While (iError.lt.0)
        Read(dLine,*,IOStat=iError)
     &    Input % DNMTHR, Input % CMPTHR, Input % CNTTHR
        If (iError.gt.0) GoTo 9920
        If (iError.lt.0) Then
          If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
          Call ExtendLine(dLine,Line)
        End If
      End Do
      dealloc_dline


      ! properties

      Case('DENS')
      Input % DENS = .True.

      Case('PROP')
      Input % Properties = .True.

      Case('NOPR')
      Input % Properties = .False.

      ! fock matrix, 0-order hamiltonian

      Case('TRAN')
      Input % ORBIN = 'TRANSFOR'

      Case('FOCK')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Call StdFmt(Line,Input % FockType)

      Case('HZER')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Call StdFmt(Line,Input % HZero)

      Case('G1SE')
      Input % G1SECIN = .True.

      Case('IPEA')
      Input % IPEA = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % BSHIFT

      ! cholesky

      Case('CHOL')
      Input % Chol = .True.
      Call Cho_caspt2_rdInp(.True.,LuIn)

      Case('CHOI')
      Input % ChoI = .True.
      Call Cho_caspt2_rdInp(.False.,LuIn)

      ! freeze-delete approximation schemes

      Case('AFRE')
      Input % aFreeze = .True.
      Input % modify_correlating_MOs = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      alloc_dline
      dLine = Line
      iError = -1
      Do While (iError.lt.0)
        Read(dLine,*,IOStat=iError)
     &    Input % lnFro, Input % ThrFr, Input % ThrDe
        If (iError.gt.0) GoTo 9920
        If (iError.lt.0) Then
          If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
          Call ExtendLine(dLine,Line)
        End If
      End Do
      dealloc_dline
      Allocate(Input % NamFro(Input % lnFro))
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Call UpCase(Line)
      alloc_dline
      dLine = Line
      iError = -1
      Do While (iError.lt.0)
        Read(dLine,*,IOStat=iError)
     &    (Input%NamFro(i), i=1,Input%lnFro)
        If (iError.gt.0) GoTo 9920
        If (iError.lt.0) Then
          If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
          Call UpCase(Line)
          Call ExtendLine(dLine,Line)
        End If
      End Do
      dealloc_dline

      Case('LOVC')
      Input % LovCASPT2 = .True.
      Input % modify_correlating_MOs = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % thr_atm

      Case('FNOC')
      Input % FnoCASPT2 = .True.
      Input % modify_correlating_MOs = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % vFrac

      Case('DOMP')
      Input % DoMP2 = .True.

      Case('DOEN')
      Input % DoEnv = .True.

      Case('VIRA')
      Input % VIRA = .True.

      Case('GHOS')
      Input % GhostDelete = .True.
      Input % modify_correlating_MOs = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % ThrGD

      Case('NOMU')
      Input % NoMult = .True.

      Case('ONLY')
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) Input % OnlyRoot

      Case('NOMI')
      Input % NoMix = .True.

      Case('RHSD')
      Input % RHSD = .True.

#ifdef _ENABLE_BLOCK_DMRG_
      Case('CUMU')
      Input % DoCumulant = .True.
#elif _ENABLE_CHEMPS2_DMRG_
      Case('CHEM')
!Quan: Using the same variable DoCumulant in Block
      Input % DoCumulant = .True.
      dochemps2 = .True.
!      if (nStates.GT.1) then
!       write(6,*) 'CHEMPS2> Only State Specific calculation supported'
!Quan: FIXME: nStates not defined
!       Call Quit_OnUserError
!      endif
#endif

      Case('EFFE')
      Input % JMS = .True.
      If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
      Read(Line,*,Err=9920,End=9920) nStates
      Allocate(Input % HEff(nStates,nStates))
      Input % HEff = 0.0d0
      Do i=1,nStates
        If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
        alloc_dline
        dLine = Line
        iError = -1
        Do While (iError.lt.0)
          Read(dLine,*,IOStat=iError)
     &      (Input % HEff(i,j),j=1,nStates)
          If (iError.gt.0) GoTo 9920
          If (iError.lt.0) Then
            If(.NOT.next_non_comment(LuIn,Line)) GoTo 9910
            Call ExtendLine(dLine,Line)
          End If
        End Do
        dealloc_dline
      End Do


      ! OBSOLETE KEYWORDS

      Case('GRAD')
      GoTo 9930

      Case('NOTR')
      GoTo 9930

      Case('JACO')
      GoTo 9930

      Case('EXTR')
      GoTo 9930

      Case('QLQR')
      GoTo 9930

      Case('NATU')
      GoTo 9930

      Case('MOLO')
      GoTo 9930

      ! DONE WITH READING INPUT

      Case('END ')
      GoTo 9000

      ! NO MATCH FOUND, UNKOWN KEYWORD

      Case Default
      GoTo 9940

      End Select
      GoTo 10

9000  CONTINUE

#ifdef _ENABLE_CHEMPS2_DMRG_
! Check if nState>1
      if ((dochemps2.EQV..True.) .and. (nStates.GT.1)) then
        write(6,*) 'CHEMPS2> Only State Specific calculation supported'
        Call Quit_OnUserError()
      endif
#endif

*---  Normal exit
      Return

*---  Error exits
9910  CONTINUE
      Call WarningMessage(2,'Premature end of input file.')
      GoTo 9999
9920  CONTINUE
      Call WarningMessage(2,'I/O error when reading line.')
      GoTo 9999
9930  CONTINUE
      Call WarningMessage(2,'Obsolete keyword: '//Command)
      GoTo 9999
9940  CONTINUE
      Call WarningMessage(2,'Unrecognized keyword: '//Command)
      GoTo 9999

9999  CONTINUE
      WRITE(6,*)' -> last line from input that was read: ', Line
      Call Quit_OnUserError

      End Subroutine

      Subroutine ExtendLine(DynLine,Line)
      Implicit None
#ifdef ALLOC_CHAR
      Character(Len=:), Allocatable, Intent(InOut) :: DynLine
      Character(Len=*), Intent(In) :: Line
      Character(Len=Len_Trim(DynLine)) :: Aux
      Aux = DynLine
      Deallocate(DynLine)
      Allocate(Character(Len=Len(Aux)+Len(Line)+1) :: DynLine)
      DynLine = Trim(Aux) // ' ' // Line
#else
      Character(Len=*), Intent(InOut) :: DynLine
      Character(Len=*), Intent(In) :: Line
      If (Len_Trim(DynLine)+Len_Trim(Line)+1 > Len(DynLine))
     &  Call WarningMessage(2,'Line(s) too long, try a newer compiler.')
      DynLine = Trim(DynLine) // ' ' // Line
#endif
      End Subroutine
      End Module

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine FdExtr(K_Lap,T,Coeff,R,Theta,DD,StpBA)
!-----------------------------------------------------------------------
! Function : Find extrema in each interval
!-----------------------------------------------------------------------

use ReMez_mod, only: IW
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: K_Lap
real(kind=wp), intent(in) :: T(40), Coeff(40), R
real(kind=wp), intent(out) :: Theta, DD(82)
logical(kind=iwp), intent(out) :: StpBA
integer(kind=iwp) :: I, IDimEnd, IDr, IDrEnd, Iter, IX, J
real(kind=wp) :: DFX, DifX, DrDif, DrInv, Dum, FF, FFF, FMax, FNew, FX, X, X1, X2, XErr1, XErr2, XErr3, XM1, XM2, XM3, XMx, XNew, &
                 XXMax
logical(kind=iwp) :: Conv, Dbg
integer(kind=iwp), parameter :: MxIter = 10000
real(kind=wp), parameter :: Thrs = 1.0e-9_wp
real(kind=wp), external :: GetDr1, GetDr2, QuadErr

IDimEnd = 2*K_Lap+1
Dbg = .false.
StpBA = .false.
do I=1,IDimEnd

  ! ===== End points =====

  if (I == 1) then
    XXMax = One
  else if (I == IDimEnd) then
    XXMax = R
  else

    ! ===== Initial values (midpoint)

    X1 = T(I-1)
    X2 = T(I)
    X = (X1+X2)*Half

    ! ===== Solve Equations =====

    Conv = .false.
    Theta = One
    outer: do Iter=1,MxIter
      FX = GetDr1(K_Lap,X,Coeff)
      DFX = GetDr2(K_Lap,X,Coeff)
      do
        XNew = X-Theta*FX/DFX
        DifX = abs(XNew-X)
        if (Dbg) write(IW,*) Iter,XNew,Difx
        if (DifX < Thrs) then
          Conv = .true.
          exit outer
        end if
        FNew = GetDr1(K_Lap,XNew,Coeff)
        FFF = (One-Theta*Half)*FX
        if (abs(FNew) < abs(FFF)) exit
        if (Dbg) write(IW,*) FNew,FFF
        Theta = Theta*Half
      end do
      X = XNew
    end do outer

    if (Conv) then
      XXMax = XNew
    else
      write(IW,'(A)') '*************** Max Iteration in FdExtr'
      write(IW,'(A,I3,A,ES23.15E3)') 'I =',I,' Max DifX. =',DifX
      !StpBA = .true.
      !return

      FMax = Zero
      XXMax = Zero

      IX = -1
      XErr2 = 9.99e2_wp
      XErr3 = XErr2
      IDr = 1000
      IDrEnd = IDr+1
      DrInv = One/real(IDr,kind=wp)
      DrDif = (X2-X1)*DrInv

      do J=1,IDrEnd
        X = X1+(J-1)*DrDif
        FF = QuadErr(K_Lap,X,Coeff)
        XErr1 = XErr2
        XErr2 = XErr3
        XErr3 = FF
        if (abs(FF) > abs(FMax)) then
          FMax = FF
          XXMax = X
          IX = J
        end if
      end do
      XXMax = -XXMax

      if ((IX /= 1) .and. (IX == IDrEnd)) then

        Dum = X1+(IX-2)*DrDif
        XM1 = QuadErr(K_Lap,Dum,Coeff)

        Dum = X1+(IX-1)*DrDif
        XM2 = QuadErr(K_Lap,Dum,Coeff)

        Dum = X1+IX*DrDif
        XM3 = QuadErr(K_Lap,Dum,Coeff)

        XErr1 = (XM3-XM1)/(Two*(XM3-Two*XM2+XM1))
        XErr2 = XErr1*DrInv-XXMax
        XMx = max(abs(XM1),abs(XM3))
        if (abs(XM2) > XMx) then
          XXMax = XErr2
          XXMax = XNew
        end if
      end if
    end if
  end if

  ! ===== Save data =====

  FMax = QuadErr(K_Lap,XXMax,Coeff)
  DD(I) = FMax
  DD(I+IDimEnd) = XXMax
end do

return

end subroutine FdExtr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_P_WrRstC(iPass)
!
! Purpose: write global restart info to disk.

use Cholesky, only: Cho_Real_Par, LuRst, LuRst_G, nSym, NumCho, NumCho_G, TMISC
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iPass
integer(kind=iwp) :: iTmp
real(kind=wp) :: c1, c2, w1, w2

call CWTime(c1,w1)
if (Cho_Real_Par) then
  call Cho_P_IndxSwp()
  call iSwap(nSym,NumCho,1,NumCho_G,1)
  iTmp = LuRst
  LuRst = LuRst_G
  call Cho_WrRstC(iPass)
  LuRst = iTmp
  call iSwap(nSym,NumCho,1,NumCho_G,1)
  call Cho_P_IndxSwp()
else
  call Cho_WrRstC(iPass)
end if
call CWTime(c2,w2)
tMisc(1,3) = tMisc(1,3)+c2-c1
tMisc(2,3) = tMisc(2,3)+w2-w1

end subroutine Cho_P_WrRstC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3sglh311 (w,dima,dimb,dimbc,s1,d1,ns)
c
c     this routine add following contribution to W
c     for syma;symb=symc
c
c     W(a;bc)  <- + S1 _i(b) . D1 _jk(a,c)
c     - S1 _i(c) . D2 _jk(a,b)
c
c     w      - W  matrix (I/O)
c     dima   - dimension of a index (I)
c     dimb   - dimension of b (c) index (I)
c     dimbc  - dimension of bc index (I)
c     s1     - S1 matrix (I)
c     s2     - S2 matrix (I)
c     d1     - D1 matrix (I)
c     d2     - D2 matrix (I)
c     ns     - signum of the contribution (+-1) (I)
c
       integer dima,dimb,dimbc,ns
       real*8 w(1:dima,1:dimbc)
       real*8 s1(1:dimb)
       real*8 d1(1:dima,1:dimb)
c
c     help variables
c
       integer a,b,c,bc
       real*8 s
c
       if (ns.eq.1) then
c     phase +1
c
       bc=0
       do 100 b=2,dimb
       s=s1(b)
       do 101 c=1,b-1
       bc=bc+1
       do 102 a=1,dima
       w(a,bc)=w(a,bc)+d1(a,c)*s
 102    continue
 101    continue
 100    continue
c
       bc=0
       do 110 b=2,dimb
       do 111 c=1,b-1
       bc=bc+1
       s=s1(c)
       do 112 a=1,dima
       w(a,bc)=w(a,bc)-d1(a,b)*s
 112    continue
 111    continue
 110    continue
c
       else
c     phase - 1
c
       bc=0
       do 200 b=2,dimb
       s=s1(b)
       do 201 c=1,b-1
       bc=bc+1
       do 202 a=1,dima
       w(a,bc)=w(a,bc)-d1(a,c)*s
 202    continue
 201    continue
 200    continue
c
       bc=0
       do 210 b=2,dimb
       do 211 c=1,b-1
       bc=bc+1
       s=s1(c)
       do 212 a=1,dima
       w(a,bc)=w(a,bc)+d1(a,b)*s
 212    continue
 211    continue
 210    continue
c
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Roland Lindh                                     *
************************************************************************
      SubRoutine Output1_Seward(lOPTO)
************************************************************************
*                                                                      *
*     Object: to write the output of seward                            *
*                                                                      *
*     Author: Roland Lindh, Dept Chem. Phys., Lund University, Sweden  *
*             September '06                                            *
************************************************************************
      use Basis_Info
      use Center_Info
      use Period
      use GeoList
      use MpmC
      use EFP_Module
      use External_centers
      use Temporary_Parameters
      use DKH_Info
      use Sizes_of_Seward, only: S
      use Real_Info, only: ThrInt, CutInt, RPQMin, kVector
      use RICD_Info, only: iRI_Type, LDF, Do_RI, Cholesky,
     &                     Do_acCD_Basis, Skip_High_AC, Cho_OneCenter,
     &                     LocalDF, Do_nacCD_Basis, Thrshld_CD
      use Logical_Info, only: Vlct, lRel, lAMFI, DoFMM, EMFR, GIAO,
     &                        FNMC, lPSOI
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "rinfo.fh"
#include "real.fh"
#include "rmat.fh"
#include "rctfld.fh"
#include "relmp.fh"
#include "relae.fh"
#include "print.fh"
#include "gateway.fh"
#include "localdf.fh"
      Logical l_aCD_Thr, lOPTO, Found
      Logical lNoPair, lPam2, lECP, lPP
      Character(LEN=80) Title(10)
#include "angstr.fh"
*                                                                      *
************************************************************************
*                                                                      *
      iRout=2
      iPrint=nPrint(iRout)
      LuWr=6
*                                                                      *
************************************************************************
*                                                                      *
      lNoPair = .False.
      lPam2   = .False.
      lECP    = .False.
      lPP     = .False.
      Do i = 1, nCnttp
         lNoPair = lNoPair .or. dbsc(i)%NoPair
         lPam2   = lPam2   .or. dbsc(i)%lPam2
         lECP    = lECP    .or. dbsc(i)%ECP
         lPP     = lPP     .or. dbsc(i)%nPP.ne.0
         lECP    = lECP    .or. dbsc(i)%ECP
         lPP     = lECP    .or. dbsc(i)%ECP
      End Do

*                                                                      *
************************************************************************
*                                                                      *
*     Start of output
*
      If (Test) Then
         Write (LuWr,*)
         Write (LuWr,'(15X,88A)') ('*',i=1,45)
         Write (LuWr,'(15X,A)')
     &   '* TEST: SEWARD will only process the input! *'
         Write (LuWr,'(15X,88A)') ('*',i=1,45)
         Go To 99
      End If
*
      iDKH_X_Order = iRELAE/10000
      iParam = iRELAE-1000 - iDKH_X_Order*10000
      iDKH_H_Order = iParam/10
      iParam = iParam - iDKH_H_Order*10
*
      Write (LuWr,'(15X,A)') 'SEWARD will generate:'
      Write (LuWr,'(15X,A,I2)')
     &        '   Multipole Moment integrals up to order ',S%nMltpl
      If (.Not.Prprt) Then
         Write (LuWr,'(15X,A)')    '   Kinetic Energy integrals'
         If (Nuclear_Model.eq.Gaussian_Type) Then
            Write (LuWr,'(15X,A)')  '   Nuclear Attraction integrals'
     &                              //' (finite nuclei - Gaussian type)'
         Else If (Nuclear_Model.eq.Point_Charge) Then
            Write (LuWr,'(15X,A)')  '   Nuclear Attraction integrals'
     &                              //' (point charge)'
         Else
            Write (LuWr,'(15X,A)')  '   Nuclear Attraction integrals'
     &                    //' (finite nuclei -  Modified Gaussian type)'
         End If
         If (lECP) Then
            If (lNoPair) Then
               If (IRELMP.EQ.0) Then
                  Write (LuWr,'(15X,A)')
     &                 '   One-Electron Hamiltonian integrals'
     &               //' modified with ECP and No-Pair contributions'
                Else If (IRELMP.EQ.1) Then
                   Write (LuWr,'(15X,A)')
     &                 '   One-Electron Hamiltonian integrals'
     &         //' modified with ECP and No-Pair (DK1) contributions'
                Else If (IRELMP.EQ.2) Then
                   Write (LuWr,'(15X,A)')
     &                 '   One-Electron Hamiltonian integrals'
     &         //' modified with ECP and No-Pair (DK2) contributions'
                Else If (IRELMP.EQ.3) Then
                   Write (LuWr,'(15X,A)')
     &                 '   One-Electron Hamiltonian integrals'
     &         //' modified with ECP and No-Pair (DK3) contributions'
                Else If (IRELMP.EQ.11) Then
                   Write (LuWr,'(15X,A)')
     &                 '   One-Electron Hamiltonian integrals'
     &               //' modified with ECP and RESC contributions'
                Else If (IRELMP.EQ.21) Then
                   Write (LuWr,'(15X,A)')
     &                 '   One-Electron Hamiltonian integrals'
     &               //' modified with ECP and ZORA contributions'
                Else If (IRELMP.EQ.22) Then
                   Write (LuWr,'(15X,A)')
     &                 '   One-Electron Hamiltonian integrals'
     &               //' modified with ECP and ZORA-FP contributions'
                Else If (IRELMP.EQ.23) Then
                   Write (LuWr,'(15X,A)')
     &                 '   One-Electron Hamiltonian integrals'
     &               //' modified with ECP and IORA contributions'
                End If
            Else
               Write (LuWr,'(15X,A)')
     &                '   One-Electron Hamiltonian integrals'
     &              //' modified with ECP contributions'
            End If
         Else
            Write (LuWr,'(15X,A)')
     &             '   One-Electron Hamiltonian integrals'
         End If
         If(FNMC) Then
            Write (LuWr,'(15X,A)')
     &             '   Finite nuclear mass correction added'
         End If
         If (lPAM2) Then
               Write (LuWr,'(15X,A)')
     &                '   Include potentials for DMFT calculation'
         End If
         If (lRel) Then
            Write (LuWr,'(15X,A)')    '   Mass-Velocity integrals'
            Write (LuWr,'(15X,A)')
     &             '   Darwin One-Electron Contact Term integrals'
         End If
         If (Vlct) Write (LuWr,'(15X,A)') '   Velocity integrals'
         If (DKroll) Then
            If (iRELAE.lt.1000) Then
               If (iRELAE.EQ.0) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic Douglas-Kroll integrals'
               Else If (IRELAE.EQ.1) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic Douglas-Kroll (DK1) integrals'
               Else If (IRELAE.EQ.2) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic Douglas-Kroll (DK2) integrals'
               Else If (IRELAE.EQ.3) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic Douglas-Kroll (DK3) integrals'
               Else If (IRELAE.EQ.4) Then
                  Write (LuWr,'(15X,A)')
     &          '   full Relativistic Douglas-Kroll (DK3) integrals'
               Else If (IRELAE.EQ.11) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic RESC integrals'
               Else If (IRELAE.EQ.21) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic ZORA integrals'
               Else If (IRELAE.EQ.22) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic ZORA-FP integrals'
               Else If (IRELAE.EQ.23) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic IORA integrals'
               Else If (IRELAE.EQ.101) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic X2C integrals'
               Else If (IRELAE.EQ.102) Then
                  Write (LuWr,'(15X,A)')
     &               '   Relativistic BSS integrals'
               Else If (BSS) Then
                  Write  (LuWr,'(15X,A)')
     &                '   Relativistic Barysz-Sadlej-Snijders integrals'
               End If
            Else
               If (LDKroll) Then
                  Write (LuWr,'(17X,A)')
     &               ' Relativistic Local-Douglas-Kroll-Hess integrals:'
                  If (nCtrLD.eq.0) Then
                     If (radiLD.eq.0.0d0) Then
                        Write(LuWr,'(17X,A)')
     &                  '   - Atomic approximation'
                     Else
                        Write(LuWr,'(17X,A)')
     &                  '   - Full local approximation'
                     End If
                  Else
                     Write(LuWr,'(17X,A)')
     &               '   - Partial local approximation:'
                     Write(LuWr,'(17X,A,10(A4))')
     &          '     - Centers: ', (dc(iCtrLD(i))%LblCnt,i=1,nCtrLD)
                     Write(LuWr,'(17X,A,F6.2,A)')
     &          '     - Cutoff radius: ', radiLD, ' Bohr'
                 End If
               Else
                  Write (LuWr,'(17X,A)')
     &               ' Relativistic Douglas-Kroll-Hess integrals:'
               Endif
               If (iParam.eq.1) Then
                  Write (LuWr,'(17X,A)')
     &                  '   - Parametrization         : OPT'
               Else If (iParam.eq.2) Then
                  Write (LuWr,'(17X,A)')
     &                  '   - Parametrization         : EXP'
               Else If (iParam.eq.3) Then
                  Write (LuWr,'(17X,A)')
     &                  '   - Parametrization         : SQR'
               Else If (iParam.eq.4) Then
                  Write (LuWr,'(17X,A)')
     &                  '   - Parametrization         : MCW'
               Else If (iParam.eq.5) Then
                  Write (LuWr,'(17X,A)')
     &                  '   - Parametrization         : CAY'
               End If
               Write (LuWr,'(17X,A,I2)')
     &               '   - DKH order of Hamiltonian:',iDKH_H_order
               Write (LuWr,'(17X,A,I2)')
     &               '   - DKH order of Properties :',iDKH_X_order
               Write (LuWr,'(17X,A)')
     &               '        - multipole moment operators'
               Write (LuWr,'(17X,A)')
     &               '        - electric potential operators'
               Write (LuWr,'(17X,A)')
     &               '        - contact operators'
            End If
         End If
         If (lRF) Then
            If (PCM) Then
               Write (LuWr,'(15X,A)')
     &               '   Reaction Field integrals (PCM)'
            Else If (lLangevin) Then
               Write (LuWr,'(15X,A)')
     &               '   Reaction Field integrals (Langevin)'
            Else
               Write (LuWr,'(15X,A)')
     &               '   Reaction Field integrals (KirkWood-Onsager)'
            End If
         End If
         If (lPP)Write (LuWr,'(15X,A)')
     &                '   Pseudo Potential integrals'
      End If
      If (Allocated(XF)) Write (LuWr,'(15X,A,I6,A)')
     &                       '   External field from',
     &                           nXF, ' point(s) added to the'
     &                           //' one-electron Hamiltonian'
      If (nEF.gt.0 .and. nOrdEF.ge.0) Write (LuWr,'(15X,A,I6,A)')
     &                       '   Electric potential for',
     &                           nEF, ' points'
      If (nEF.gt.0 .and. nOrdEF.ge.1) Write (LuWr,'(15X,A,I6,A)')
     &                       '   Electric field integrals for',
     &                           nEF, ' points'
      If (nEF.gt.0 .and. nOrdEF.ge.2) Write (LuWr,'(15X,A,I6,A)')
     &            '   Electric field gradient integrals for',
     &                           nEF, ' points'
      If (nEF.gt.0 .and. nOrdEF.ge.2) Write (LuWr,'(15X,A,I6,A)')
     &            '   Contact term integrals for',
     &                           nEF, ' points'
      If (Allocated(DMS_Centers)) Write (LuWr,'(15X,A,I6,A)')
     &            '   Diamagnetic shielding integrals for',
     &                           nDMS, ' points'
      If (Allocated(OAM_Center)) Write (LuWr,'(15X,A,3(F7.4,1X),A)')
     &                       '   Orbital angular momentum around (',
     &   (OAM_Center(i),i=1,3),')'
      If (Allocated(OMQ_Center)) Write (LuWr,'(15X,A,3(F7.4,1X),A)')
     &                       '   Orbital magnetic quadrupole around (',
     &   (OMQ_Center(i),i=1,3),')'
      If (Vlct.and.(S%nMltpl.ge.2)) Write (LuWr,'(15X,A,3(F7.4,1X),A)')
     &                       '   Velocity quadrupole around (',
     &   (Coor_MPM(i,3),i=1,3),')'
      If (Allocated(AMP_Center)) Write (LuWr,'(15X,A,3(F7.4,1X),A)')
     & '   Products of Orbital angular momentum operators around (',
     &   (AMP_Center(i),i=1,3),')'
      If (nWel.ne.0) Write (LuWr,'(15X,A,I4,A)')
     &             '   Spherical well for', nWel,
     &             ' exponent(s) added to the'
     &           //' one-electron Hamiltonian'
      If (lAMFI) Write (LuWr,'(15X,A)') '   Atomic mean-field integrals'
      If (lPSOI) Write (LuWr,'(15X,A)')
     & '   (PSO) Paramagnetic Spin-Orbit integrals'
     &     //' calculated from Gen1Int F90 library'
      If (DoFMM) Then
         Write (LuWr,'(15X,A)')
     &     '   Integral environment set up for FMM option'
         Write (LuWr,'(15X,A,F10.5)')
     &     '    - RPQMin: ',RPQMin
      End If
      If (lEFP) Then
#ifdef _EFP_
         Write (LuWr,'(15X,A)')
     &     '   Effective Fragment potentials added       '
         Write (LuWr,'(15X,A,I4)')
     &     '    - # of fragments: ',nEFP_fragments
#else
         Write (LuWr,'(15X,A)')
     &     '   EFP input specified but code not enabled for the option'
         Call Abend()
#endif
      End If
      If (.Not.Onenly) Then
         If (Cholesky) Then
            Write (LuWr,'(15X,A)')
     &        '   Cholesky decomposed two-electron'
     &           //' repulsion integrals'
           If (Cho_OneCenter) Then
            Write (LuWr,'(17X,A,G10.2)')
     &                 '  - 1C-CD Threshold: ',Thrshld_CD
           Else
            Write (LuWr,'(17X,A,G10.2)')
     &                 '  - CD Threshold: ',Thrshld_CD
           EndIf
         Else If (Do_RI) Then
            If (LocalDF) Then
               If (LDF_Constraint.eq.-1) Then
                  Write(LuWr,'(15X,A)')
     &                  '   Local Density Fitting coefficients'
               Else
                  Write(LuWr,'(15X,A)')
     &               '   Constrained Local Density Fitting coefficients'
                  If (LDF_Constraint.eq.0) Then
                     Write (LuWr,'(17X,A)')
     &                 '  - constraint type: charge'
                  Else
                     Call WarningMessage(2,'Unknown constraint!')
                     Write(6,'(A,I10)') 'LDF_Constraint=',LDF_Constraint
                     Call LDF_Quit(-1)
                  End If
               End If
               If (LDF2) Then
                  Write (LuWr,'(17X,A,G10.2)')
     &                 '  - two-center auxiliary functions included'
     &                 //' (when needed); target accuracy: ',
     &                 Thr_Accuracy
               Else
                  Write (LuWr,'(17X,A)')
     &                 '  - two-center auxiliary functions not included'
               End If
            Else If (LDF) Then
               Write (LuWr,'(15X,A)')
     &               '   LDF decomposed two-electron'
     &               //' repulsion integrals stored Cholesky style'
               Write (LuWr,'(15X,A)') '    Concept demonstration only!'
            Else
               Write (LuWr,'(15X,A)')
     &               '   RI decomposed two-electron'
     &               //' repulsion integrals stored Cholesky style'
            End If
            If (iRI_Type.eq.1) Then
               Write (LuWr,'(17X,A)')
     &                 '  - RIJ auxiliary basis'
            Else If (iRI_Type.eq.2) Then
               Write (LuWr,'(17X,A)')
     &                 '  - RIJK auxiliary basis'
            Else If (iRI_Type.eq.3) Then
               Write (LuWr,'(17X,A)')
     &                 '  - RIC auxiliary basis'
            Else If (iRI_Type.eq.5) Then
               Write (LuWr,'(17X,A)')
     &                 '  - External RICD auxiliary basis'
            Else
               If (Do_nacCD_Basis) Then
                  Write (LuWr,'(17X,A)')
     &                    '  - nacCD auxiliary basis'
               Else
                  If (Do_acCD_Basis) Then
                     Write (LuWr,'(17X,A)')
     &                    '  - acCD auxiliary basis'
                  Else
                     Write (LuWr,'(17X,A)')
     &                       '  - aCD auxiliary basis'
                  End If
               End If
               Write (LuWr,'(17X,A,G10.2)')
     &                 '  - CD Threshold: ',Thrshld_CD
               l_aCD_Thr=.False.
               Do iCnttp = 1, nCnttp
                  l_aCD_Thr=l_aCD_Thr .or. dbsc(iCnttp)%aCD_Thr.ne.One
               End Do
               If (l_aCD_Thr) Then
                  Write (LuWr,'(17X,A)')
     &                    '     Note that the threshold for individual'
     &                  //' basis sets might be modified!'
               End If
               If (Skip_High_AC) Then
                  Write (LuWr,'(17X,A)')
     &                    '  - Skip high angular momentum combinations'
               End If
            End If
         Else
            Write (LuWr,'(15X,A)')
     &        '   Two-Electron Repulsion integrals'
         End If
      End If
      If (RMat_On) Then
         Write (LuWr,*)
         Write (LuWr,'(15X,A,A)')
     &        '   OBSERVE that some integrals are modified to',
     &        ' enable variational R-matrix calculations!'
      End If
      If (GIAO) Then
         Write (LuWr,'(15X,A)')
     &        '   GIAO integrals differentiated with respect to B'
         Write (LuWr,'(15X,A)')
     &        '     dS/dB                                        '
         Write (LuWr,'(15X,A)')
     &        '     dT/dB                                        '
         Write (LuWr,'(15X,A)')
     &        '     dV/dB                                        '
      End If
*
*     Transition moment integrals for oscillator strengths of
*     electronic transitions.
*
      If (EMFR) Then
         Write (LuWr,'(15X,A)')
     &        '   Transition moment intergrals'
         Write (LuWr,'(15X,A,3(F7.4,1X),A)')
     &                       '   The wavevector k: (',
     &   (kVector(i),i=1,3),')'
         temp=Sqrt(KVector(1)**2+KVector(2)**2+kVector(3)**2)
         temp = (Two*Pi)/temp
         Write (LuWr,'(15X,A,(F10.4,1X),A)')
     &                       '   Wavelength:        ',
     &   Temp,'a.u.'
         Write (LuWr,'(15X,A,(F10.4,1X),A)')
     &                       '                      ',
     &   Temp*Angstr,'Angstrom'
         Write (LuWr,'(15X,A,(F10.4,1X),A)')
     &                       '                      ',
     &   Temp*Angstr/Ten,'nm'
      End If
*                                                                      *
************************************************************************
*                                                                      *
 99   Continue
*
      Call Qpg_cArray('SewardXTitle',Found,nTtl)
      If (Found) Then
         nTtl=nTtl/80
         Call Get_cArray('SewardXTitle',Title(1),nTtl*80)
         If (iPrint.ge.6) Then
            Write (LuWr,*)
            Write (LuWr,'(15X,88A)') ('*',i=1,88)
            Write (LuWr,'(15X,88A)') '*', (' ',i=1,86), '*'
            Do iTtl = 1, nTtl
               Write (LuWr,'(15X,A,A,A)') '*   ',Title(iTtl),'   *'
            End Do
            Write (LuWr,'(15X,88A)') '*', (' ',i=1,86), '*'
            Write (LuWr,'(15X,88A)') ('*',i=1,88)
         Else
            Write (LuWr,*)
            Write (LuWr,'(A)') ' Title:'
            Do iTtl = 1, nTtl
               Write (LuWr,'(8X,A)') Title(iTtl)
            End Do
            Write (LuWr,*)
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Write (LuWr,*)
      Write (LuWr,'(19X,A,E9.2)')
     &      'Integrals are discarded if absolute value <:',ThrInt
      Write (LuWr,'(19X,A,E9.2)')
     &      'Integral cutoff threshold is set to       <:',CutInt
*                                                                      *
************************************************************************
*                                                                      *
      If (Run_Mode.eq.GS_Mode) Call Print_Symmetry()
*                                                                      *
************************************************************************
*                                                                      *
      If (nIrrep.gt.1) Then
         If (MolWgh.eq.0) Then
            Write (LuWr,*)
            Write (LuWr,'(19X,A,A)') ' Symmetry adaptation a la',
     &                          ' DCR.'
            Write (LuWr,*)
         End If
         If (MolWgh.eq.1) Then
            Write (LuWr,*)
            Write (LuWr,'(19X,A,A)') ' Symmetry adaptation a la',
     &                          ' MOLECULE.'
            Write (LuWr,*)
         End If
         If (MolWgh.eq.2) Then
            Write (LuWr,*)
            Write (LuWr,'(19X,A)') ' Unitary symmetry adaptation'
            Write (LuWr,*)
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Print Cell unit information
*
      If (Cell_l) Then
          Write(LuWr,'(6X,30(''-''))')
          Write(LuWr,'(6X,A)') '* - the centers of the Unit Cell'
          Write(LuWr,'(A)') ' '
          Write(LuWr,'(A,3I3)') 'Spread of the unit cell:',
     &      (ispread(i),i=1,3)
          Write(LuWr,'(A)') ' '
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Write out basis set information
*
      If (Run_Mode.eq.GS_Mode) Then
         Call Print_Basis(lOPTO)
*                                                                      *
************************************************************************
*                                                                      *
*     Write out coordinates, bond, angles and torsional angles
*
         If (lOPTO) then
            Call Print_Geometry(1)
         else
            Call Print_Geometry(0)
         EndIf
         Call Print_Isotopes()
*                                                                      *
************************************************************************
*                                                                      *
*     Rigid Rotor analysis etc.
*
         Call RigRot(Centr,Mass,S%kCentr)
*                                                                      *
************************************************************************
*                                                                      *
         Call Print_Basis2()
*                                                                      *
************************************************************************
*                                                                      *
         Call Print_OpInfo()
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExtractS(iLu,i9,Etot,xyzMy,xyzQu,lExtr,ExpVal,ExpCento,ENR,ENP)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iLu, i9
real(kind=wp), intent(in) :: Etot, xyzMy(3), xyzQu(6), ExpVal(4,1), ExpCento(4,1), ENR, ENP
logical(kind=iwp), intent(in) :: lExtr(*)

write(iLu,*) '<<<<<<<Configuration ',i9,'>>>>>>>'
if (lExtr(1)) then
  write(iLu,*) 'Total Energy'
  write(iLu,'(F15.8)') Etot
end if
if (lExtr(2)) then
  write(iLu,*) 'QM-Dipole'
  write(iLu,'(3(F12.5))') xyzMy(:)
end if
if (lExtr(3)) then
  write(iLu,*) 'QM-Quadrupole'
  write(iLu,'(6(F12.5))') xyzQu(:)
end if
if (lExtr(6)) then
  write(iLu,*) 'Expectation values (T+H_nuc,V_el,V_pol,V_pp)'
  write(iLu,*) '  Nuc cont:',ENR
  write(iLu,'(4(F15.8))') ExpVal(:,1)
end if
if (lExtr(7)) then
  write(iLu,*) 'Expectation values partial V_el, V_pol'
  write(iLu,*) '  Nuc cont:',ENP
  write(iLu,'(2(F15.8))') ExpCento(:,1)
end if

return

end subroutine ExtractS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine vecprint_cvb(a,n)
! Prints vector A

use casvb_global, only: formMXP5, formMXP6, iprec, iwidth
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: a(n)
integer(kind=iwp) :: ibegin, iend, iform, nbuf
integer(kind=iwp), parameter :: mxbuf = 8

nbuf = min((iwidth-4)/(iprec+4),mxbuf)
if (nbuf == 7) nbuf = 6
iform = 0
do ibegin=1,n,nbuf
  iend = min(ibegin+nbuf-1,n)
  if (iform == 0) then
    write(u6,formMXP5) a(ibegin:iend)
  else
    write(u6,formMXP6) a(ibegin:iend)
  end if
end do

return

end subroutine vecprint_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine magnetization_pa( exch, nLoc, nM, nH, nneq, neq, neqv,
     &                          nCenter, nTempMagn, nDir, nDirZee,
     &                          nDirTot, nss, nexch, iopt, LUZee,
     &                          TempMagn, hexp, mexp, hmin, hmax, em,
     &                          zJ, thrs, dirX, dirY, dirZ, dir_weight,
     &                          w, dipexch, s_exch, dipso, s_so, eso,
     &                          hinput, r_rot, XLM, ZLM, XRM, ZRM,
     &                          zeeman_energy, compute_Mdir_vector,
     &                          m_paranoid, m_accurate, smagn, mem,
     &                          doplot )

      Implicit None
      Integer, parameter        :: wp=SELECTED_REAL_KIND(p=15,r=307)
#include "mgrid.fh"
#include "stdalloc.fh"
c constants defining the sizes
      Integer, intent(in)       :: exch, nLoc, nM
      Integer, intent(in)       :: nH, nCenter, nTempMagn
      Integer, intent(in)       :: nDir, nDirZee, nDirTot, nneq, neqv
      Integer, intent(in)       :: neq(nneq), nss(nneq), nexch(nneq)
      Integer, intent(in)       :: iopt, mem
      Integer, intent(in)       :: LUZee(nDirZee)

      Logical, intent(in)       :: hinput
      Logical, intent(in)       :: zeeman_energy
      Logical, intent(in)       :: compute_Mdir_vector
      Logical, intent(in)       :: m_paranoid
      Logical, intent(in)       :: m_accurate
      Logical, intent(in)       :: smagn
      Logical, intent(in)       :: doplot

      Real(kind=8), intent(in) :: R_ROT(nneq,neqv,3,3)
      Real(kind=8), intent(in) :: W(exch)
! exchange energies printed out in the previous part
      Real(kind=8), intent(in) :: ESO(nneq,nLoc)
! spin-orbit energies from ANISO files
      Real(kind=8), intent(in) :: Hexp(nH), Mexp(nH,nTempMagn)
      Real(kind=8), intent(in) :: thrs
      Real(kind=8), intent(in) :: XLM( nCenter,nTempMagn,3,3)
      Real(kind=8), intent(in) :: ZLM( nCenter,nTempMagn)
      Real(kind=8), intent(in) :: XRM( nCenter,nTempMagn,3,3)
      Real(kind=8), intent(in) :: ZRM( nCenter,nTempMagn)
      Real(kind=8), intent(in) :: dirX(nDir), dirY(nDir), dirZ(nDir)
      Real(kind=8), intent(in) :: dir_weight(nDirZee,3)
      Real(kind=8), intent(in) :: TempMagn(nTempMagn)
      Real(kind=8), intent(in) :: zJ, hmin, hmax, em

      Complex(kind=8), intent(in) :: DIPEXCH(3,exch,exch)
      Complex(kind=8), intent(in) ::  S_EXCH(3,exch,exch)
      Complex(kind=8), intent(in) :: dipso(nneq,3,nLoc,nLoc)
      Complex(kind=8), intent(in) ::  s_so(nneq,3,nLoc,nLoc)
c exchange data:
c      Integer NM ! number of states included in the exchange Zeeman matrix, ( Nex .LE. exch)
      Real(kind=8), allocatable :: Wex(:)
!                                   WEX(NM) ! Zeeman exchange energies
      Real(kind=8), allocatable :: Zex(:)
!                                   ZEX(nTempMagn) ! exchange statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: Sex(:,:)
!                                   SEX(3,nTempMagn) ! spin magnetisation, from the exchange block;
      Real(kind=8), allocatable :: Mex(:,:)
!                                   MEX(3,nTempMagn) ! magnetisation, from the exchange block
c data for individual sites (all states):
      Real(kind=8), allocatable :: ZL(:,:)
!                                   ZL(nneq,nTempMagn) ! local statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: WL(:,:)
!                                   WL(nneq,nLoc) ! Zeeman local energis
      Real(kind=8), allocatable :: SL(:,:,:)
!                                   SL(nneq,3,nTempMagn) ! spin magnetisation, from the local sites, using ALL states ;
      Real(kind=8), allocatable :: ML(:,:,:)
!                                   ML(nneq,3,nTempMagn) ! magnetisation, from local sites, using ALL states;
c data for individual sites (only states that enter exchange):
      Real(kind=8), allocatable :: ZR(:,:)
!                                   ZR(nneq,nTempMagn) ! local statistical sum, Boltzmann distribution, using only Nexch states
      Real(kind=8), allocatable :: WR(:,:)
!                                   WR(nneq,nLoc) ! Zeeman local reduced energies, using only Nexch states;
      Real(kind=8), allocatable :: SR(:,:,:)
!                                   SR(nneq,3,nTempMagn) ! spin magnetisation, from the local sites, using only Nexch states ;
      Real(kind=8), allocatable :: MR(:,:,:)
!                                   MR(nneq,3,nTempMagn) ! magnetisation, from local sites, using only Nexch states;
c total vectors in general coordinate system:
      Real(kind=8), allocatable :: ZRT(:,:)  !ZRT(nCenter,nTempMagn)
      Real(kind=8), allocatable :: ZLT(:,:)  !ZLT(nCenter,nTempMagn)
      Real(kind=8), allocatable :: MRT(:,:,:)!MRT(nCenter,3,nTempMagn)
      Real(kind=8), allocatable :: MLT(:,:,:)!MLT(nCenter,3,nTempMagn)
      Real(kind=8), allocatable :: SRT(:,:,:)!SRT(nCenter,3,nTempMagn)
      Real(kind=8), allocatable :: SLT(:,:,:)!SLT(nCenter,3,nTempMagn)
c data for total system:
      Real(kind=8), allocatable :: ZT(:,:)
!                                   ZT(nH,nTempMagn) ! total statistical sum, Boltzmann distribution
      Real(kind=8), allocatable :: ST(:,:,:)
!                                   ST(3,nH,nTempMagn) ! total spin magnetisation,
      Real(kind=8), allocatable :: MT(:,:,:)
!                                   MT(3,nH,nTempMagn) ! total magnetisation
c magnetic field strength and orientation data:
      Real(kind=8) :: dltH
      Real(kind=8), allocatable :: H(:) ! H(nH)
      Real(kind=8), allocatable :: dHX(:) !dHX(nDirTot)
      Real(kind=8), allocatable :: dHY(:) !dHY(nDirTot)
      Real(kind=8), allocatable :: dHZ(:) !dHZ(nDirTot)
      Real(kind=8), allocatable :: dHW(:) !dHW(nDirTot)
c total average M and average S data:
      Real(kind=8), allocatable :: MAV(:,:)      !MAV(nH,nTempMagn)
      Real(kind=8), allocatable :: SAV(:,:)      !SAV(nH,nTempMagn)
      Real(kind=8), allocatable :: MVEC(:,:,:,:)
!MVEC(nDirTot,nH,nTempMagn,3)
      Real(kind=8), allocatable :: SVEC(:,:,:,:)
!SVEC(nDirTot,nH,nTempMagn,3)

      Integer                   :: IM,I,it,itEnd,J,iH,k,isite,l,n,nP
      Integer                   :: iDir,rtob,ibuf,mem_local
      Real(kind=8)             :: cm3tomB
      Real(kind=8)             :: dev, dnrm2_
      External                  :: dev, dnrm2_
      Logical          :: DBG
      Character(Len=15):: lbl_X, lbl_Y, lbl_Z
c


      DBG=.false.
c      Boltz_k=0.6950356000_wp   !   in cm^-1*K-1
c      mu_Bohr=0.4668643740_wp   !   in cm-1*T-1
      cm3tomB=0.5584938904_wp   !   in cm3 * mol-1 * T

      Write(6,*)
      Write(6,'(100A)') (('%'),J=1,96)
      Write(6,'(40X,A)') 'CALCULATION OF THE MOLAR MAGNETIZATION'
      Write(6,'(100A)') (('%'),J=1,96)
      Write(6,*)
c----------------------------------------------------------------------
      mem_local=0
      RtoB=8
      If(dbg) Write(6,*) 'MAGN:        nM=',nM
      If(dbg) Write(6,*) 'MAGN:      exch=',exch
      If(dbg) Write(6,*) 'MAGN:      nLoc=',nLoc
      If(dbg) Write(6,*) 'MAGN: nTempMagn=',nTempMagn

      If(nM>=0) Then
        ! Zeeman exchange energy spectrum
        Call mma_allocate(Wex,nM,'Wex')
        Call dcopy_(nM,[0.0_wp],0,Wex,1)
        mem_local=mem_local+nM*RtoB
      End If

      If(nTempMagn>=0) Then
        ! exchange statistical sum, Boltzmann distribution
        Call mma_allocate(Zex,nTempMagn,'Zex')
        Call dcopy_(nTempMagn,[0.0_wp],0,Zex,1)
        mem_local=mem_local+nTempMagn*RtoB
        ! spin magnetisation, from the exchange block
        Call mma_allocate(Sex,3,nTempMagn,'Sex')
        Call dcopy_(3*nTempMagn,[0.0_wp],0,Sex,1)
        mem_local=mem_local+3*nTempMagn*RtoB
        ! magnetisation, from the exchange block
        Call mma_allocate(Mex,3,nTempMagn,'Mex')
        Call dcopy_(3*nTempMagn,[0.0_wp],0,Mex,1)
        mem_local=mem_local+3*nTempMagn*RtoB

        If(nneq>=0) Then
          ! local statistical sum, Boltzmann distribution
          Call mma_allocate(ZL,nneq,nTempMagn,'ZL')
          Call dcopy_(nneq*nTempMagn,[0.0_wp],0,ZL,1)
          mem_local=mem_local+nneq*nTempMagn*RtoB
          ! spin magnetisation, from the local sites, using ALL states
          Call mma_allocate(SL,nneq,3,nTempMagn,'SL')
          Call dcopy_(3*nneq*nTempMagn,[0.0_wp],0,SL,1)
          mem_local=mem_local+3*nneq*nTempMagn*RtoB
          !magnetisation, from local sites, using ALL states
          Call mma_allocate(ML,nneq,3,nTempMagn,'ML')
          Call dcopy_(3*nneq*nTempMagn,[0.0_wp],0,ML,1)
          mem_local=mem_local+3*nneq*nTempMagn*RtoB

!         local statistical sum, Boltzmann distribution, using only Nexch states
          Call mma_allocate(ZR,nneq,nTempMagn,'ZR')
          Call dcopy_(nneq*nTempMagn,[0.0_wp],0,ZR,1)
          mem_local=mem_local+nneq*nTempMagn*RtoB
!         spin magnetisation, from the local sites, using only Nexch states
          Call mma_allocate(SR,nneq,3,nTempMagn,'SR')
          Call dcopy_(3*nneq*nTempMagn,[0.0_wp],0,SR,1)
          mem_local=mem_local+3*nneq*nTempMagn*RtoB
          ! magnetisation, from local sites, using only Nexch states
          Call mma_allocate(MR,nneq,3,nTempMagn,'MR')
          Call dcopy_(3*nneq*nTempMagn,[0.0_wp],0,MR,1)
          mem_local=mem_local+3*nneq*nTempMagn*RtoB
        End If

        If(nLoc>=0) Then
          ! Zeeman local energies
          Call mma_allocate(WL,nneq,nLoc,'WL')
          Call dcopy_(nneq*nLoc,[0.0_wp],0,WL,1)
          mem_local=mem_local+nneq*nLoc*RtoB
          ! Zeeman local reduced energies, using only Nexch states
          Call mma_allocate(WR,nneq,nLoc,'WR')
          Call dcopy_(nneq*nLoc,[0.0_wp],0,WR,1)
          mem_local=mem_local+nneq*nLoc*RtoB
        End If

        If(nCenter>=0) Then
          ! ZRT(nCenter,nTempMagn)
          Call mma_allocate(ZRT,nCenter,nTempMagn,'ZRT')
          Call dcopy_(nCenter*nTempMagn,[0.0_wp],0,ZRT,1)
          mem_local=mem_local+nCenter*nTempMagn*RtoB
          ! ZLT(nCenter,nTempMagn)
          Call mma_allocate(ZLT,nCenter,nTempMagn,'ZLT')
          Call dcopy_(nCenter*nTempMagn,[0.0_wp],0,ZLT,1)
          mem_local=mem_local+nCenter*nTempMagn*RtoB
          ! MRT(nCenter,3,nTempMagn)
          Call mma_allocate(MRT,nCenter,3,nTempMagn,'MRT')
          Call dcopy_(nCenter*3*nTempMagn,[0.0_wp],0,MRT,1)
          mem_local=mem_local+3*nCenter*nTempMagn*RtoB
          ! MLT(nCenter,3,nTempMagn)
          Call mma_allocate(MLT,nCenter,3,nTempMagn,'MLT')
          Call dcopy_(nCenter*3*nTempMagn,[0.0_wp],0,MLT,1)
          mem_local=mem_local+3*nCenter*nTempMagn*RtoB
          ! SRT(nCenter,3,nTempMagn)
          Call mma_allocate(SRT,nCenter,3,nTempMagn,'SRT')
          Call dcopy_(nCenter*3*nTempMagn,[0.0_wp],0,SRT,1)
          mem_local=mem_local+3*nCenter*nTempMagn*RtoB
          ! SLT(nCenter,3,nTempMagn)
          Call mma_allocate(SLT,nCenter,3,nTempMagn,'SLT')
          Call dcopy_(nCenter*3*nTempMagn,[0.0_wp],0,SLT,1)
          mem_local=mem_local+3*nCenter*nTempMagn*RtoB
        End If

        If(nH>=0) Then
          ! total statistical sum, Boltzmann distribution
          Call mma_allocate(ZT,nH,nTempMagn,'ZT')
          Call dcopy_(nH*nTempMagn,[0.0_wp],0,ZT,1)
          mem_local=mem_local+nH*nTempMagn*RtoB
          ! total spin magnetisation
          Call mma_allocate(ST,3,nH,nTempMagn,'ST')
          Call dcopy_(3*nH*nTempMagn,[0.0_wp],0,ST,1)
          mem_local=mem_local+3*nH*nTempMagn*RtoB
          ! total magnetisation
          Call mma_allocate(MT,3,nH,nTempMagn,'MT')
          Call dcopy_(3*nH*nTempMagn,[0.0_wp],0,MT,1)
          mem_local=mem_local+3*nH*nTempMagn*RtoB
          ! total spin magnetisation
          Call mma_allocate(SAV,nH,nTempMagn,'SAV')
          Call dcopy_(nH*nTempMagn,[0.0_wp],0,SAV,1)
          mem_local=mem_local+nH*nTempMagn*RtoB
          ! total magnetisation
          Call mma_allocate(MAV,nH,nTempMagn,'MAV')
          Call dcopy_(nH*nTempMagn,[0.0_wp],0,MAV,1)
          mem_local=mem_local+nH*nTempMagn*RtoB
          If(nDirTot>=0) Then
            ! total spin magnetisation vector
            Call mma_allocate(SVEC,nDirTot,nH,nTempMagn,3,'SVEC')
            Call dcopy_(nDirTot*nH*nTempMagn*3,[0.0_wp],0,SVEC,1)
            mem_local=mem_local+nDirTot*nH*nTempMagn*3*RtoB
            ! total magnetisation vector
            Call mma_allocate(MVEC,nDirTot,nH,nTempMagn,3,'MVEC')
            Call dcopy_(nDirTot*nH*nTempMagn*3,[0.0_wp],0,MVEC,1)
            mem_local=mem_local+nDirTot*nH*nTempMagn*3*RtoB
          End If

        End If
      End If

      If(nDirTot>=0) Then
         ! orientation of the field
         Call mma_allocate(dHX,nDirTot,'dHX')
         Call mma_allocate(dHY,nDirTot,'dHY')
         Call mma_allocate(dHZ,nDirTot,'dHZ')
         Call mma_allocate(dHW,nDirTot,'dHW')
         Call dcopy_(nDirTot,[0.0_wp],0,dHX,1)
         Call dcopy_(nDirTot,[0.0_wp],0,dHY,1)
         Call dcopy_(nDirTot,[0.0_wp],0,dHZ,1)
         Call dcopy_(nDirTot,[0.0_wp],0,dHW,1)
         mem_local=mem_local+4*nDirTot*RtoB
      End If

      If(nH>=0) Then
         Call mma_allocate(H,nH,'H  field')
         Call dcopy_(nH,[0.0_wp],0,H,1)
         mem_local=mem_local+nH*RtoB
      End If
      If(dbg) Write(6,*) 'MAGN:  memory allocated (local):'
      If(dbg) Write(6,*) 'mem_local=', mem_local
      If(dbg) Write(6,*) 'MAGN:  memory allocated (total):'
      If(dbg) Write(6,*) 'mem_total=', mem+mem_local
c----------------------------------------------------------------------
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      nP=get_nP(nsymm,ngrid)

      Call hdir( nDir, nDirZee, dirX, dirY, dirZ, dir_weight,
     &                 nP, nsymm, ngrid, nDirTot, dHX, dHY, dHZ, dHW )
      Call Add_Info('MR_MAGN  dHX', dHX(1:5),5,10)
      Call Add_Info('MR_MAGN  dHY', dHY(1:5),5,10)
      Call Add_Info('MR_MAGN  dHZ', dHZ(1:5),5,10)
      Call Add_Info('MR_MAGN  dWX', dHW(1:5),5,10)
      If(DBG) Then
        Write(6,'(A,F10.6)') '        zJ = ',zJ
        Write(6,'(A,F10.6)') '      thrs = ',thrs
        Write(6,'(A,   I6)') '      iopt = ',iopt
        Write(6,'(A, 10I6)') '     nss(i)=',(  nss(i),i=1,nneq)
        Write(6,'(A, 10I6)') '   nexch(i)=',(nexch(i),i=1,nneq)
        Write(6,'(A,   I6)') '  nTempMagn= ',nTempMagn
        Write(6,'(A      )') 'TempMagn(i)='
        Write(6,'(10F10.6)') (TempMagn(i),i=1,nTempMagn)
        Write(6,*) 'm_paranoid =', m_paranoid
        Write(6,*) 'm_accurate =', m_accurate
        Write(6,*) '     smagn =', smagn
        Do k=1,nneq
          Write(6,'(A,i6)') 'site ', k
          Write(6,'(A,i2,A)') 'ESO(',k,')'
          Write(6,'(10F12.6)') (ESO(k,i),i=1,nss(k))
          Write(6,'(A,i2,A)') 'S_SO(',k,')'
          Do i=1,nss(k)
            Do j=1,nss(k)
              Write(6,'(3(2F15.10,3x))') (s_so(k,l,i,j),l=1,3)
            End Do
          End Do
          Write(6,'(A,i2,A)') 'DIPSO(',k,')'
          Do i=1,nss(k)
            Do j=1,nss(k)
              Write(6,'(3(2F15.10,3x))') (dipso(k,l,i,j),l=1,3)
            End Do
          End Do
        End Do !k
      End If

      Write(6,'(2X,A,i3,A)') 'Molar magnetization will be '//
     &                       'calculated in ',nH,
     &                       ' points, equally distributed in '//
     &                       'magnetic field range'
      Write(6,'(2X,F4.1,1x,a,1X,F4.1,a,5(F6.3,a))') HMIN,'--',HMAX,
     &                       ' T., at the following temperatures:'
      Do i=1,nTempMagn,10
        j=MIN(nTempMagn,i+9)
        Write(6,'(10(F8.4,A))') (TempMagn(k),' K.;',k=i,j)
      End Do
      Write(6,'(2X,A,I4,A)') 'Powder molar magnetization will be '//
     &                       'averaged on ',nP,
     &                       ' directions of the applied magnetic'//
     &                       ' field.'
      Write(6,'(2x,10A)') ('--------', i=1,10)
      If(nsymm.eq.1) Then
        Write(6,'(23x,A)') 'Lebedev-Laikov grid on a hemisphere:'
        Write(6,'(38x,A)') 'z >= 0;'
      Else If(nsymm.eq.2) Then
        Write(6,'(23x,A)') 'Lebedev-Laikov grid on a 4th-of-a-sphere:'
        Write(6,'(34x,A)') 'x >= 0; z >= 0;'
      Else If(nsymm.eq.3) Then
        Write(6,'(23x,A)') 'Lebedev-Laikov grid on a 8th-of-a-sphere:'
        Write(6,'(30x,A)') 'x >= 0; y >= 0; z >= 0;'
      End If
      Write(6,'(2x,10A)') ('--------', i=1,10)
      Write(6,'(2x,A,12x,A,2(18x,A),16x,A)') 'Nr.','x','y','z',
     &                                       'weight'
      Do i=1,nP
        Write(6,'(i4,2x,4(F18.12,1x))')
     &                  i,dHX(i+nDir+nDirZee),dHY(i+nDir+nDirZee),
     &                    dHZ(i+nDir+nDirZee),dHW(i+nDir+nDirZee)
      End Do
      Write(6,'(2x,10A)') ('--------', i=1,10)
      Write(6,'(2X,A)') 'The cut-off energy for the '//
     &                  'exact diagonalization of the Zeeman'//
     &                  ' Hamiltonian is:'
      Write(6,'(2x,a,F15.9,A)') 'E = ',EM ,' cm(-1).'
      If(NM.lt.10) Then
        Write(6,'(2X,A,i2,a)') 'The exact diagonalization of the '//
     &                         'Zeeman Hamiltonian included ',NM,
     &                         ' exchange states.'
      Else If( (NM.ge.10) .AND. (NM.lt.100) ) Then
        Write(6,'(2X,A,i3,a)') 'The exact diagonalization of the '//
     &                         'Zeeman Hamiltonian included ',NM,
     &                         ' exchange states.'
      Else If( (NM.ge.100) .AND. (NM.lt.1000) ) Then
        Write(6,'(2X,A,i4,a)') 'The exact diagonalization of the '//
     &                         'Zeeman Hamiltonian included ',NM,
     &                         ' exchange states.'
      Else If( (NM.ge.1000) .AND. (NM.lt.10000) ) Then
        Write(6,'(2X,A,i5,a)') 'The exact diagonalization of the '//
     &                         'Zeeman Hamiltonian included ',NM,
     &                         ' exchange states.'
      End If
      If(m_accurate) Then
        Write(6,'(2x,A)') 'The contribution of local excited states '//
     &                    ' is computed exactly.'
        If ( (zJ.ne.0.0_wp) .and. (m_paranoid) .and.
     &  (nTempMagn.gt.1) ) Then
          Write(6,'(2x,A)') 'The average spin is computed exactly '//
     &                      'for each temperature point.'
        Else If( (zJ.ne.0.0_wp) .and. (.not. m_paranoid) .and.
     &   (nTempMagn.gt.1) ) Then
          Write(6,'(2x,A,F9.3)') 'The average spin is computed '//
     &                           'exactly only for the temperature '//
     &                           'point T= ',MAXVAL(TempMagn(:))
          Write(6,'(2x,A     )') 'We consider this to be a good '//
     &                           'approximation.'
        End If
      Else
        If ( (zJ.ne.0.0_wp) .and. (m_paranoid) .and.
     &  (nTempMagn.gt.1) ) Then
          Write(6,'(2x,A)') 'The average spin is computed exactly '//
     &                      'for each temperature point.'
        Else If( (zJ.ne.0.0_wp) .and. (.not. m_paranoid) .and.
     &   (nTempMagn.gt.1) ) Then
          Write(6,'(2x,A,F9.3)') 'The average spin is computed '//
     &                           'exactly only for the temperature '//
     &                           ' point T= ',TempMagn(1)
          Write(6,'(2x,A)') 'We consider this to be a good '//
     &                      'approximation.'
          Write(6,'(2x,A)') 'Use MPAR keyword to compute average '//
     &                      'spin exactly, for each temperature point'//
     &                      ', in case higher accuracy is needed.'
        End If
      Write(6,'(2x,A)') 'The contribution of local excited states '//
     & ' is computed approximately (by using the susceptibility data). '
      End If
      If(compute_Mdir_vector) Then
      Write(6,'(2x,A,i2,a)') 'The magnetization vector for ',nDir,
     & ' directions of the applied magnetic field will be calculated.'
      Else
      Write(6,'(2X,A)') 'The magnetization vector was not calculated.'
      End If
      If(zeeman_energy) Then
      Write(6,'(2x,A,i2,a)') 'The Zeeman splitting for ',nDirZee,
     & ' directions of the applied magnetic field will be calculated.'
      Write(6,'(2x,a)') 'The Zeeman energies for each direction of th'//
     & 'e applied magnetic field are written in files "energy_XX.txt".'
         If(DBG) Then
            Do i=1,nDirZee
              Write(6,'(A,I4,A,I4)') 'LuZee(',i,' )=',LUZee(i)
            End Do
         End If
      Else
      Write(6,'(2X,A)') 'Computation of the Zeeman splitting was not'//
     & ' requested.'
      End If
c      If(maxval(TempMagn).lt.W(exch)) Then
c      Write(6,'(2x,A)') 'Contribution to molar magnetization coming '//
c     & 'from local excited states is taken into account.'
c      Else
c      Write(6,'(2x,A)') 'Contribution to molar magnetization coming '//
c     & 'from local excited states is NOT taken into account.'
c      Write(6,'(2x,A)') 'TMAG is requesting to compute magnetization'//
c     & ' at a larger temperature than the highest exchange state.'
c      Write(6,'(2x,A)') 'Please include more states into the '//
c     & 'exchange coupling.'
c      End If

C /// opening the loop over the field points
      Do iH=1,nH
c /// ---------------------------------------------------------------
        If (HINPUT) Then
           H(iH)=HEXP(iH)
           If(H(iH).eq.0.0_wp) Then
             H(iH)=0.0001_wp
           End If
        Else
          DLTH=(HMAX-HMIN)/DBLE(nH-1)
          If (iH.eq.1) Then
            H(iH)=HMIN+0.0001_wp
          Else
            H(iH)=HMIN+DLTH*DBLE(iH-1)
          End If
          If(H(iH).eq.0.0_wp) Then
            H(iH)=0.0001_wp
          End If
        End If

        If(DBG) Write(6,'(A,i0,A,F10.5)') 'MAGNETIZATION::  H(',
     &                                     iH,') = ', H(iH)

c ///  opening the loop over different directions of the magnetic field
        Do IM=1,NDIRTOT
          Call dcopy_(nM,[0.0_wp],0,Wex,1)
          Call dcopy_(nneq*nLoc,[0.0_wp],0,WL,1)
          Call dcopy_(nneq*nLoc,[0.0_wp],0,WR,1)
          Call dcopy_(nTempMagn,[0.0_wp],0,Zex,1)
          Call dcopy_(nneq*nTempMagn,[0.0_wp],0,ZL,1)
          Call dcopy_(nneq*nTempMagn,[0.0_wp],0,ZR,1)
          Call dcopy_(3*nTempMagn,[0.0_wp],0,Sex,1)
          Call dcopy_(3*nTempMagn,[0.0_wp],0,Mex,1)
          Call dcopy_(3*nneq*nTempMagn,[0.0_wp],0,SL,1)
          Call dcopy_(3*nneq*nTempMagn,[0.0_wp],0,ML,1)
          Call dcopy_(3*nneq*nTempMagn,[0.0_wp],0,SR,1)
          Call dcopy_(3*nneq*nTempMagn,[0.0_wp],0,MR,1)
          If(DBG) Write(6,'(A,F20.10)') 'zJ = ', zJ
c exchange magnetization:
          Call MAGN( exch, NM, dHX(iM),dHY(iM),dHZ(iM),H(iH),
     &               W, zJ, THRS,
     &               DIPEXCH,
     &                S_EXCH,
     &               nTempMagn,TempMagn,smagn,
     &               Wex,
     &               Zex,
     &               Sex,
     &               Mex, m_paranoid, DBG )
          If(DBG) Write(6,'(A,3F11.7)') 'MEX:',(Mex(l,1),l=1,3)
          If(IM == 1) THEN
           Call Add_Info('MEX_MAGN    ',[dnrm2_(3*nTempMagn,Mex,1)],1,8)
           Call Add_Info('MR_MAGN  Wex',[dnrm2_(nM,Wex,1)]         ,1,8)
          End If
c compute local magnetizations:
          If(m_accurate) Then
            Do i=1,nneq
c all states:
              If ( NSS(i).gt.NEXCH(i) )  Then
c this check is to avoid the unnecessary computation, in cases when no local excited states are present
                Call MAGN( NSS(i), NEXCH(i), dHX(iM),dHY(iM),dHZ(iM),
     &                     H(iH),
     &                     ESO(i,1:NSS(i)), zJ, THRS,
     &                     DIPSO( i,1:3,1:NSS(i),1:NSS(i) ),
     &                      S_SO( i,1:3,1:NSS(i),1:NSS(i) ),
     &                     nTempMagn,TempMagn(1:nTempMagn),smagn,
     &                     WL(i,1:NEXCH(i) ),
     &                     ZL(i,1:nTempMagn),
     &                     SL(i,1:3,1:nTempMagn),
     &                     ML(i,1:3,1:nTempMagn), m_paranoid, DBG )
                If(IM == 2) THEN
                Call Add_Info('MR_MAGN  WL',[dnrm2_(nexch(i),WL,1)],1,8)
                End If

                If(DBG) Write(6,'(A,I2,A,3F11.7)') 'ML: site',i,' : ',
     &                                   (ML(i,l,1),l=1,3)
c only local "exchange states":
                Call MAGN( NEXCH(i), NEXCH(i), dHX(iM),dHY(iM),dHZ(iM),
     &                     H(iH),
     &                     ESO(i,1:NEXCH(i)), zJ, THRS,
     &                     DIPSO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                      S_SO( i,1:3,1:NEXCH(i),1:NEXCH(i) ),
     &                     nTempMagn,TempMagn,smagn,
     &                     WR(i,1:Nexch(i)),
     &                     ZR(i,1:nTempMagn),
     &                     SR(i,1:3,1:nTempMagn),
     &                     MR(i,1:3,1:nTempMagn), m_paranoid, DBG )
                Call Add_Info('MR_MAGN  WR',[dnrm2_(nexch(i),WR,1)],1,8)
                If(DBG) Write(6,'(A,I2,A,3F11.7)') 'MR: site',i,' : ',
     &                                   (MR(i,l,1),l=1,3)
              End If
            End Do

          If(IM == 3) THEN
            Call Add_Info('ML_MAGN',[dnrm2_(3*nTempMagn*nneq,ML,1)],1,8)
            Call Add_Info('MR_MAGN',[dnrm2_(3*nTempMagn*nneq,MR,1)],1,8)
          End If

c expand the basis and rotate local vectors to the general
c coordinate system:
            Call dcopy_(  nCenter*nTempMagn,[0.0_wp],0,ZRT,1)
            Call dcopy_(  nCenter*nTempMagn,[0.0_wp],0,ZLT,1)
            Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,MRT,1)
            Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,MLT,1)
            Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,SRT,1)
            Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,SLT,1)
            isite=0
            Do i=1,NNEQ
              Do j=1,NEQ(i)
                isite=isite+1
c statistical distributions
                Do iT=1,nTempMagn
                  ZLT(isite,iT)=ZL(i,iT)
                  ZRT(isite,iT)=ZR(i,iT)
                End Do
c magnetizations:
c    use R_rot matrices, which have determinant +1.
c  note that  R_lg matrices have arbitrary determinant.
                Do iT=1,nTempMagn
                  Do l=1,3
                    Do n=1,3
                      MLT(isite,l,iT) = MLT(isite,l,iT) +
     &                                         r_rot(i,j,l,n)*ML(i,n,iT)
                      SLT(isite,l,iT) = SLT(isite,l,iT) +
     &                                         r_rot(i,j,l,n)*SL(i,n,iT)
                      MRT(isite,l,iT) = MRT(isite,l,iT) +
     &                                         r_rot(i,j,l,n)*MR(i,n,iT)
                      SRT(isite,l,iT) = SRT(isite,l,iT) +
     &                                         r_rot(i,j,l,n)*SR(i,n,iT)
                    End Do
                  End Do
                End Do
              End Do ! j, neq(i)
            End Do ! i, nneq
          End If ! m_accurate

c compute the total magnetizations according to the derived formulas:
          If (m_accurate) Then
            Do iT=1,nTempMagn
              If (smagn) Then
                Call MSUM ( nCenter, Sex(:,iT), Zex(iT),
     &                      SLT(:, :,iT), ZLT(:,iT),
     &                      SRT(:, :,iT), ZRT(:,iT), iopt,
     &                      ST(:,iH,iT),  ZT(iH,iT)  )
              End If
              Call MSUM ( nCenter, Mex(:,iT), Zex(iT),
     &                    MLT(:, :,iT), ZLT(:,iT),
     &                    MRT(:, :,iT), ZRT(:,iT), iopt,
     &                    MT(:,iH,iT),  ZT(iH,iT)  )
            End Do
          Else
c add the contribution from local excited states using the approximate
c X*H expression:
            Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,SRT,1)
            Call dcopy_(3*nCenter*nTempMagn,[0.0_wp],0,SLT,1)
            Do iT=1,nTempMagn
              Do isite=1,nCenter
                Do l=1,3
                  MRT(isite,l,iT)=( XRM(isite,iT,l,1)*H(iH)*dHX(iM)
     &                             +XRM(isite,iT,l,2)*H(iH)*dHY(iM)
     &                             +XRM(isite,iT,l,3)*H(iH)*dHZ(iM)
     &                            ) /cm3tomB
                  MLT(isite,l,iT)=( XLM(isite,iT,l,1)*H(iH)*dHX(iM)
     &                             +XLM(isite,iT,l,2)*H(iH)*dHY(iM)
     &                             +XLM(isite,iT,l,3)*H(iH)*dHZ(iM)
     &                            ) /cm3tomB
                End Do
              End Do
              If (smagn) Then
                Call MSUM ( nCenter, Sex(:,iT), Zex(iT),
     &                      SLT(:, :,iT), ZLM(:,iT),
     &                      SRT(:, :,iT), ZRM(:,iT), iopt,
     &                       ST(:,iH,iT),  ZT(iH,iT)  )
              End If
              Call MSUM ( nCenter, Mex(:,iT), Zex(iT),
     &                    MLT(:, :,iT), ZLM(:,iT),
     &                    MRT(:, :,iT), ZRM(:,iT), iopt,
     &                     MT(:,iH,iT),  ZT(iH,iT)  )
            End Do
          End If
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c print out hte Zeeman eigenstates
      If (zeeman_energy) Then
         If((iH.eq.1).and.(iM.eq.nDir+1))
     &     Write(6,'(A)') 'Energies of the Zeeman Hamiltonian '//
     &                    'for the following directions of the '//
     &                    'applied field:'
         If ( (iH.eq.1).and.(iM.gt.nDir) .and.
     &                      (iM.le.(nDir+nDirZee)) ) Then
           Write(6,'(A,I3,A,3F10.6,3x,5A)')
     &             'direction Nr.',iM-nDir, ' : ',
     &              dHX(iM), dHY(iM), dHZ(iM),
     &             'written in file "zeeman_energy_',
     &              CHAR(48+mod(int((iM-nDir)/100),10)),
     &              CHAR(48+mod(int((iM-nDir)/10 ),10)),
     &              CHAR(48+mod(    (iM-nDir)     ,10)),
     &              '.txt".'
           Write(LUZee(iM-nDir),'(A,3F24.15)')
     &              '# direction of the applied magnetic field:',
     &              dHX(iM), dHY(iM), dHZ(iM)
           Write(LuZee(iM-nDir),'(A,6x,A,1000(I4,6x) )') '# H(T)',
     &              ' State =>',(i,i=1,nm)
         End If

         If ( (iM.gt.nDir) .and. (iM.le.(nDir+nDirZee)) ) Then
           Write(LUZee(iM-nDir),'(F8.4,1000F10.3)') H(IH),
     &                                     (Wex(I),I=1,NM)
         End If
      End If !zeeman_energy
c --------------------------------------------------------------------
c  computing the AVERAGE MOMENTS calculated at dIfferent temperatures
c (TempMagn(i))
      Do iT=1,nTempMagn
        Do l=1,3
          MVEC(iM,iH,iT,l)= MT(l,iH,iT)
          SVEC(iM,iH,iT,l)= ST(l,iH,iT)
        End Do !l

c      MAV(iH,iT)=MAV(iH,iT) + MT(1,iH,iT)*dHX(iM)*dHW(iM)
c     &                      + MT(2,iH,iT)*dHY(iM)*dHW(iM)
c     &                      + MT(3,iH,iT)*dHZ(iM)*dHW(iM)
c      SAV(iH,iT)=SAV(iH,iT) + ST(1,iH,iT)*dHX(iM)*dHW(iM)
c     &                      + ST(2,iH,iT)*dHY(iM)*dHW(iM)
c     &                      + ST(3,iH,iT)*dHZ(iM)*dHW(iM)
        ! accumulate contributions:
        Call daxpy_(1,dHX(iM)*dHW(iM),MT(1,iH,iT),1,MAV(iH,iT),1)
        Call daxpy_(1,dHY(iM)*dHW(iM),MT(2,iH,iT),1,MAV(iH,iT),1)
        Call daxpy_(1,dHZ(iM)*dHW(iM),MT(3,iH,iT),1,MAV(iH,iT),1)
        Call daxpy_(1,dHX(iM)*dHW(iM),ST(1,iH,iT),1,SAV(iH,iT),1)
        Call daxpy_(1,dHY(iM)*dHW(iM),ST(2,iH,iT),1,SAV(iH,iT),1)
        Call daxpy_(1,dHZ(iM)*dHW(iM),ST(3,iH,iT),1,SAV(iH,iT),1)
      End Do !iT
c ///  closing the loops over field strengths and directions
      End Do ! iM
      End Do ! iH
c Close Zeeman files, if opened
      If (Zeeman_Energy) Then
        Do i=1,nDirZee
          Close( LUZee(i) )
        End Do
      End If


c -------------------------------------------------------------------
C   WRITING SOME OF THE OUTPUT....
C -------------------------------------------------------------------
      If (smagn) Then
      Do iT=1,nTempMagn
c      Write(6,*)
        Do iDir=1,nDir+nDirZee
c        Write(6,*)
        Write(6,'(A,A,1x,A)') '--------|',
     &  '------------------------------------------------------------|',
     & '|------------------------------------------------------------|'
        Write(6,'(A,i3,26x,A,1x,A,60x,A)')
     &  'Direction of the applied magnetic field:',iDir,'|','|','|'
        Write(6,'(A,F18.14,44x,A,1x,A,60x,A)')
     &                              'proj X=',dHX(iDIR),'|','|','|'
        Write(6,'(A,F18.14,44x,A,1x,A,60x,A)')
     &                              'proj Y=',dHY(iDir),'|','|','|'
        Write(6,'(A,F18.14,44x,A,1x,A,60x,A)')
     &                              'proj Z=',dHZ(iDir),'|','|','|'
        Write(6,'(A,F7.4,A,41x,A,1x,A,60x,A)')
     &          'Temperature = ',TempMagn(iT),' Kelvin','|','|','|'
        Write(6,'(A,A,1x,A)') '--------|',
     &  '------------------------------------------------------------|',
     & '|------------------------------------------------------------|'
        Write(6,'(2x,A,12x,2A,1x,A,10x,2A)') 'Field |',
     & 'Magnetization Vector            |','   Total Magn. |','|',
     & 'Spin Magnetization Vector         |','   Total Magn. |'
        Write(6,'(5A,1x,5A)') '--------|',
     &  '--- proj X ---|','--- proj Y ---|','--- proj Z ---|',
     &  '- in this dir.-|',
     &  '|--- proj X ---|','--- proj Y ---|','--- proj Z ---|',
     &  '- in this dir.-|'
         Do iH=1,nH
         Write(6,'(F7.3,1x,A, 3(E13.6,1x,A),E14.7,1x,A,1x,A, '//
     &                       '3(E13.6,1x,A),E14.7,1x,A)')
     &   H(iH),'|',
     &     MVEC(iDir,iH,iT,1),' ',
     &     MVEC(iDir,iH,iT,2),' ',
     &     MVEC(iDir,iH,iT,3),'|',
     &   ( MVEC(iDir,iH,iT,1)*dHX(iDir)+
     &     MVEC(iDir,iH,iT,2)*dHY(iDir)+
     &     MVEC(iDir,iH,iT,3)*dHZ(iDir) ),'|','|',
     &     SVEC(iDir,iH,iT,1),' ',
     &     SVEC(iDir,iH,iT,2),' ',
     &     SVEC(iDir,iH,iT,3),'|',
     &   ( SVEC(iDir,iH,iT,1)*dHX(iDir)+
     &     SVEC(iDir,iH,iT,2)*dHY(iDir)+
     &     SVEC(iDir,iH,iT,3)*dHZ(iDir) ),'|'
           End Do
        Write(6,'(A,A,1x,A)') '--------|',
     &  '------------------------------------------------------------|',
     & '|------------------------------------------------------------|'
          End Do !iDir
        End Do !iT

        Else

      Do iT=1,nTempMagn
        Do iDir=1,nDir+nDirZee
        Write(6,'(2A)') '--------|',
     & '------------------------------------------------------------|'
        Write(6,'(A,i3,26x,A)')
     &  'Direction of the applied magnetic field:',iDir,'|'
        Write(6,'(A,F18.14,44x,A)') 'proj X=',dHX(iDIR),'|'
        Write(6,'(A,F18.14,44x,A)') 'proj Y=',dHY(iDir),'|'
        Write(6,'(A,F18.14,44x,A)') 'proj Z=',dHZ(iDir),'|'
        Write(6,'(A,F7.4,A,41x,A)') 'Temperature = ',TempMagn(iT),
     &                       ' Kelvin','|'
       Write(6,'(2A)') '--------|',
     & '------------------------------------------------------------|'
        Write(6,'(2x,A,12x,2A)') 'Field |',
     & 'Magnetization Vector            |','   Total Magn. |'
        Write(6,'(5A)') '--------|',
     &  '--- proj X ---|','--- proj Y ---|','--- proj Z ---|',
     &  '- in this dir.-|'
         Do iH=1,nH
            Write(6,'(F7.3,1x,A,3(E13.6,1x,A),E14.7,1x,A)')
     &                         H(iH),'|',
     &              MVEC(iDir,iH,iT,1),' ',
     &              MVEC(iDir,iH,iT,2),' ',
     &              MVEC(iDir,iH,iT,3),'|',
     &            ( MVEC(iDir,iH,iT,1)*dHX(iDir)+
     &              MVEC(iDir,iH,iT,2)*dHY(iDir)+
     &              MVEC(iDir,iH,iT,3)*dHZ(iDir) ),'|'
         End Do
         Write(6,'(2A)') '--------|',
     & '------------------------------------------------------------|'
          End Do !iDir

        End Do !iT
       End If !(smagn)
c ---------------------------------------------------------------------
c     COMPUTING THE STANDARD DEVIATION OF THE MAGNETIZATION
c      If(HINPUT) Then
c        Do iT=1,nTempMagn
c          STDEV(iT) =0.0_wp
c          STDEV(iT) = dev(nH,MAV(:,iT),Mexp(:,iT))
c        End Do
c      End If

      Write(6,*)
      Write(6,'(15X,A)') 'HIGH-FIELD POWDER MAGNETIZATION'
      Write(6,'(20X,A)') '(Units: Bohr magneton)'
      Write(6,*)
      Do iT=1,nTempMagn,5
         iTEnd=min(nTempMagn,iT+4)
         Write(6,'(A,11A)') '-----------|',('---------------|',i=iT,
     &                      iTEnd+1)
         Write(6,'(A,11(F10.3,A))') '    H(T)   |STATISTICAL SUM|',
     &                    (TempMagn(i),' K.  |',i=iT,iTEnd)
         Write(6,'(A,11A)') '-----------|',('---------------|',i=iT,
     &                      iTEnd+1)
         Do iH=1,nH
          Write(6,'(F10.6,1X,A,F14.7,1x,A,11(f14.10,1x,A))')
     &             H(iH),'|',ZT(iH,1),'|', (MAV(iH,i),'|',i=iT,iTEnd)
         End Do
         Write(6,'(A,11A)') '-----------|',('---------------|',i=iT,
     &                      iTEnd+1)
         If(HINPUT) Then
            Write(6,'(A,15x,A, 11(f14.10,1x,A) )')
     &                      'ST.DEV.M   |','|',
     &               ( dev(nH,MAV(:,i),Mexp(:,i)),'|',i=iT,iTEnd)
            Write(6,'(A,11A)') '-----------|',
     &                        ('---------------|',i=iT,iTEnd+1)
         End If
      End Do
      If(smagn) Then
         Write(6,*)
         Write(6,'(15X,A)') 'HIGH-FIELD POWDER SPIN MAGNETIZATION'
         Write(6,'(20X,A)') '(Units: Bohr magneton)'
         Write(6,*)
         Do iT=1,nTempMagn,5
           iTEnd=min(nTempMagn,iT+4)
           Write(6,'(A,11A)') '-----------|',('---------------|',i=iT,
     &                                                        iTEnd+1)
           Write(6,'(A,11(F10.3,A))') '   H(T)   |STATISTICAL SUM|',
     &                               (TempMagn(i),' K.  |',i=iT,iTEnd)
           Write(6,'(A,11A)') '-----------|',('---------------|',i=iT,
     &                                                        iTEnd+1)
           Do iH=1,nH
            Write(6,'(F10.6,1X,A,F14.7,1x,A,11(f14.10,1x,A))')
     &              H(iH),'|',ZT(iH,1),'|', (SAV(iH,i),'|',i=iT,iTEnd)
           End Do
           Write(6,'(A,11A)') '-----------|',('---------------|',i=iT,
     &                                                        iTEnd+1)
         End Do
      End If!smagn
      ! add some verification:
      Call Add_Info('MR_MAGN',[dnrm2_(3*nTempMagn*nneq,MR,1)],1,8)
      Call Add_Info('MR_MAGN',[dnrm2_(3*nTempMagn*nneq,MR,1)],1,8)
      Call Add_Info('MR_MAGN',[dnrm2_(3*nTempMagn*nneq,MR,1)],1,8)

      Call Add_Info('H_MAGN       ', [dnrm2_(nH,H,1)],1,6)
      Call Add_Info('MAGN_AVERAGED', [dnrm2_(nH*nTempMagn,MAV,1)],1,6)
      Call Add_Info('ZTL_MAGN'     , [dnrm2_(nH*nTempMagn,ZT,1)],1,8)
      Do iH=1,nH
         Write(lbl_X,'(A,i3)') 'MAGN_VECT X ',iH
         Write(lbl_Y,'(A,i3)') 'MAGN_VECT Y ',iH
         Write(lbl_Z,'(A,i3)') 'MAGN_VECT Z ',iH
         ibuf=nDirTot*nTempMagn
         Call Add_Info(lbl_X,[dnrm2_(ibuf,MVEC(:,iH,:,1),1)],1,8)
         Call Add_Info(lbl_Y,[dnrm2_(ibuf,MVEC(:,iH,:,2),1)],1,8)
         Call Add_Info(lbl_Z,[dnrm2_(ibuf,MVEC(:,iH,:,3),1)],1,8)
      End Do

!-------------------------  PLOTs -------------------------------------!
      IF ( DoPlot ) THEN
         IF ( hinput ) THEN
            Call plot_MH_with_Exp( nH, H, nTempMagn, TempMagn, MAV,
     &                             Mexp, zJ )
         ELSE
            Call plot_MH_no_Exp( nH, H, nTempMagn, TempMagn, MAV, zJ )
         END IF

!         IF ( zeeman_energy ) THEN
!            Call plot_zeeman( nH, nM, nDirZee, H, LuZee )
!         END IF
      END IF
!------------------------- END PLOTs -------------------------------------!






c----------------------------------------------------------------------
      If(nM>=0) Then
        Call mma_deallocate(Wex)
      End If

      If(nTempMagn>=0) Then
        Call mma_deallocate(Zex)
        Call mma_deallocate(Sex)
        Call mma_deallocate(Mex)
        If(nneq>=0) Then
          Call mma_deallocate(ZL)
          Call mma_deallocate(SL)
          Call mma_deallocate(ML)
          Call mma_deallocate(ZR)
          Call mma_deallocate(SR)
          Call mma_deallocate(MR)
        End If

        If(nLoc>=0) Then
          Call mma_deallocate(WL)
          Call mma_deallocate(WR)
        End If

        If(nCenter>=0) Then
          Call mma_deallocate(ZRT)
          Call mma_deallocate(ZLT)
          Call mma_deallocate(MRT)
          Call mma_deallocate(MLT)
          Call mma_deallocate(SRT)
          Call mma_deallocate(SLT)
        End If

        If(nH>=0) Then
          Call mma_deallocate(ZT)
          Call mma_deallocate(ST)
          Call mma_deallocate(MT)
          Call mma_deallocate(SAV)
          Call mma_deallocate(MAV)
          If(nDirTot>=0) Then
            Call mma_deallocate(SVEC)
            Call mma_deallocate(MVEC)
          End If
        End If
      End If

      If(nDirTot>=0) Then
         Call mma_deallocate(dHX)
         Call mma_deallocate(dHY)
         Call mma_deallocate(dHZ)
         Call mma_deallocate(dHW)
      End If

      If(nH>=0) Then
         Call mma_deallocate(H)
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GT1DIS(   H1DIA,  IREOTS,    IPNT,       H,  ISMFTO,
     &                      IBSO,   NACOB)
*
* diagonal of one electron integrals over active orbitals
*
      IMPLICIT REAL*8(A-H,O-Z)
*.Input
      INTEGER IREOTS(*),IPNT(*),ISMFTO(*),IBSO(*)
      DIMENSION H(*)
*.Output
      DIMENSION H1DIA(*)
*
      DO 100 IIOB = 1, NACOB
        IOB = IREOTS(IIOB)
        ISM = ISMFTO(IIOB)
        IOBREL = IOB-IBSO(ISM)+1
C        WRITE(6,*) ' IIOB IOB ISM IOBREL '
C        WRITE(6,*)   IIOB,IOB,ISM,IOBREL
        H1DIA(IIOB) = H(IPNT(ISM)-1+IOBREL*(IOBREL+1)/2)
  100 CONTINUE
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' Diagonal one electron integrals '
        CALL WRTMAT(H1DIA,1,NACOB,1,NACOB)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1994, Jeppe Olsen                                 *
!***********************************************************************

subroutine MEMSTR()
! Construct pointers for saving information about strings and their mappings
!
!========
! Input :
!========
! Number and types of strings defined by /STRINP/
! Symmetry information stored in         /CSM/
! String information stored in           /STINF/
!=========
! Output
!=========
! Pointers stored in common block /STRBAS/
!
! Jeppe Olsen, Winter of 1990
!
! Last Revision, Dec 24 1990, Almaden
!
! Updated with iuniqtp, dec 11, 1994

use Str_Info, only: ISTAC, ITYP_DUMMY, IUNIQMP, IUNIQTP, MNRS1, MNRS3, MXRS1, MXRS3, NELEC, NOCTYP, NSTFTP, NSTTYP, NSTTYP, Str, &
                    Str_Hidden
use MCLR_Data, only: NACOB, NOBPT, NORB1, NORB2, NORB3
use input_mclr, only: nIrrep
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: IANEQ, ICREQ, IITYP, IMNEW, ITYP, JJTYP, LENGTH, LSTRIN, NSTRIN, NUMST3
integer(kind=iwp), external :: NCASTR_MCLR

LENGTH = 100
! Start of string information

! =====================================================================
!
! 1 : String information
!
! =====================================================================

! Some calls are done with points which are out of bounds. To make
! this to be strictly secure we add a dummy layer and point to that
! in the case that we are out of bounds. The code seems, however,
! not to touch these arrays.

ITYP_Dummy = NSTTYP+1

do ITYP=1,NSTTYP
  if (IUNIQTP(ITYP) == ITYP) then
    NSTRIN = NUMST3(NELEC(ITYP),NORB1,MNRS1(ITYP),MXRS1(ITYP),NORB2,NORB3,MNRS3(ITYP),MXRS3(ITYP))
    LSTRIN = NSTRIN*NELEC(ITYP)
    ! Offsets for occupation of strings and reordering array
    call mma_allocate(Str_Hidden(ITYP)%OCSTR,LSTRIN,Label='OCSTR')
    call mma_allocate(Str_Hidden(ITYP)%STREO,NSTRIN,Label='STREO')

    ! Symmetry and class of each string
    call mma_allocate(Str_Hidden(ITYP)%STSM,NSTRIN,Label='STSM')
    call mma_allocate(Str_Hidden(ITYP)%STCL,NSTRIN,Label='STCL')

    ! Number of strings per symmetry and occupation
    call mma_allocate(Str_Hidden(ITYP)%NSTSO,NOCTYP(ITYP)*nIrrep,Label='NSTSO')
    ! Offset of strings per symmetry and occupation
    call mma_allocate(Str_Hidden(ITYP)%ISTSO,NOCTYP(ITYP)*nIrrep,Label='ISTSO')
    ! Number of electrons in RAS1 and RAS3 per sub type, is sub-type active
    call mma_allocate(Str_Hidden(ITYP)%EL1,NOCTYP(ITYP),Label='EL1')
    call mma_allocate(Str_Hidden(ITYP)%EL3,NOCTYP(ITYP),Label='EL3')
    !MS: New array introduced according to Jeppe's new strinfo representation
    call mma_allocate(Str_Hidden(ITYP)%EL123,3*NOCTYP(ITYP),Label='EL123')
    ! Lexical addressing of arrays: NB! Not allocated here in Jeppe's new version!
    call mma_allocate(Str_Hidden(ITYP)%Z,NACOB*NELEC(ITYP),Label='Z')

    !MS: Introduced according to Jeppe's new concept.
    !MS: NB! Str(ITYP)%EL123 added to IEL13 parameter list!
    !MS: Be aware that IEL13 is also called in STRINF
    call IEL13(MNRS1(ITYP),MXRS1(ITYP),MNRS3(ITYP),MXRS3(ITYP),NELEC(ITYP),NOCTYP(ITYP),Str_Hidden(ITYP)%EL1,Str_Hidden(ITYP)%EL3, &
               Str_Hidden(ITYP)%EL123)

    IITYP = ITYP
  else
    IITYP = -IUNIQTP(ITYP)
  end if
  Str(ITYP)%OCSTR => Str_Hidden(IITYP)%OCSTR
  Str(ITYP)%STREO => Str_Hidden(IITYP)%STREO
  Str(ITYP)%STSM => Str_Hidden(IITYP)%STSM
  Str(ITYP)%STCL => Str_Hidden(IITYP)%STCL
  Str(ITYP)%NSTSO => Str_Hidden(IITYP)%NSTSO
  Str(ITYP)%ISTSO => Str_Hidden(IITYP)%ISTSO
  Str(ITYP)%EL1 => Str_Hidden(IITYP)%EL1
  Str(ITYP)%EL3 => Str_Hidden(IITYP)%EL3
  Str(ITYP)%EL123 => Str_Hidden(IITYP)%EL123
  Str(ITYP)%Z => Str_Hidden(IITYP)%Z
end do

! Mappings between different string types
do ITYP=1,NSTTYP
  !write(u6,*) nelec(ityp),nstrin

  if ((ISTAC(ITYP,2) /= 0) .and. (ISTAC(ITYP,1) /= 0)) then
    ! creation on string allowed, use full orbital notation
    LENGTH = NACOB*NSTFTP(ITYP)
    NSTRIN = 1
  else if ((ISTAC(ITYP,1) /= 0) .and. (ISTAC(ITYP,2) == 0)) then
    ! only annihilation allowed, use compact scheme
    LENGTH = NELEC(ITYP)*NSTFTP(ITYP)
    NSTRIN = 1
  else if ((ISTAC(ITYP,1) == 0) .and. (ISTAC(ITYP,2) /= 0)) then
    !MS: New else block
    ! Only creation allowed, use compact scheme with offsets
    Str(ITYP)%NSTSO(:) = 0
    call NUMST4_MCLR(NELEC(ITYP),NORB1,MNRS1(ITYP),MXRS1(ITYP),NORB2,NORB3,MNRS3(ITYP),MXRS3(ITYP),Str(ITYP)%NSTSO)
    LENGTH = NCASTR_MCLR(2,Str(ITYP)%NSTSO,NOCTYP(ITYP),ITYP,NOBPT,3,Str(ITYP)%EL123)
    NSTRIN = NSTFTP(ITYP)
  else
    NSTRIN = 0
  end if
  ! Explicit offsets and lengths
  call mma_allocate(Str_Hidden(ITYP)%STSTMI,NSTRIN,Label='STSTMI')
  call mma_allocate(Str_Hidden(ITYP)%STSTMN,NSTRIN,Label='STSTMN')

  ! has this map been constructed before ?
  IMNEW = 0
  if (IUNIQTP(ITYP) == ITYP) then
    IMNEW = 1
    IUNIQMP(ITYP) = ITYP
  else
    ! check type of previous map
    do JJTYP=1,ITYP-1
      IITYP = -IUNIQTP(ITYP)
      if ((abs(IUNIQTP(JJTYP)) == IITYP) .and. (IUNIQMP(JJTYP) == JJTYP)) then
        if (((ISTAC(ITYP,1) == 0) .and. (ISTAC(JJTYP,1) == 0)) .or. &
            ((ISTAC(ITYP,1) /= 0) .and. (ISTAC(JJTYP,1) /= 0) .and. &
             (abs(IUNIQTP(ISTAC(ITYP,1))) == abs(IUNIQTP(ISTAC(JJTYP,1)))))) then
          IANEQ = 1
        else
          IANEQ = 0
        end if
        if (((ISTAC(ITYP,2) == 0) .and. (ISTAC(JJTYP,2) == 0)) .or. &
            ((ISTAC(ITYP,2) /= 0) .and. (ISTAC(JJTYP,2) /= 0) .and. &
             (abs(IUNIQTP(ISTAC(ITYP,2))) == abs(IUNIQTP(ISTAC(JJTYP,2)))))) then
          ICREQ = 1
        else
          ICREQ = 0
        end if
        if ((IANEQ == 1) .and. (ICREQ == 1)) then
          IUNIQMP(ITYP) = -JJTYP
          exit
        end if

      end if
    end do
    ! Normal exit from DO loop only if no identical map was found
    if (JJTYP == ITYP) then
      IMNEW = 1
      IUNIQMP(ITYP) = ITYP
    end if
  end if

  ! note: not IITYP here
  Str(ITYP)%STSTMI => Str_Hidden(ITYP)%STSTMI
  Str(ITYP)%STSTMN => Str_Hidden(ITYP)%STSTMN

  if (IMNEW == 1) then
    call mma_allocate(Str_Hidden(ITYP)%STSTM,LENGTH,2,Label='STSTM')
    IITYP = ITYP
  else
    IITYP = -IUNIQMP(ITYP)
  end if

  Str(ITYP)%STSTM => Str_Hidden(IITYP)%STSTM

end do

! Symmetry of conjugated orbitals and orbital excitations
!    COBSM,NIFSJ,IFSJ,IFSJO
!call mma_allocate(COBSM,NACOB,Label='COBSM')
!call mma_allocate(NIFSJ,NACOB*nIrrep,Label='NIFSJ')
!call mma_allocate(IFSJ,NACOB**2,Label='IFSJ')
!call mma_allocate(IFSJO,NACOB*nIrrep,Label='IFSJO')
! Symmetry of excitation connecting  strings of given symmetry
!call mma_allocate(STSTX,nIrrep*nIrrep,Label='STSTX')

! Some dummy allocations

ITYP = ITYP_Dummy
call mma_allocate(Str_Hidden(ITYP)%NSTSO,1,Label='NSTSO')
call mma_allocate(Str_Hidden(ITYP)%EL1,1,Label='EL1')
call mma_allocate(Str_Hidden(ITYP)%EL3,1,Label='EL3')
Str(ITYP)%NSTSO => Str_Hidden(ITYP)%NSTSO
Str(ITYP)%EL1 => Str_Hidden(ITYP)%EL1
Str(ITYP)%EL3 => Str_Hidden(ITYP)%EL3

end subroutine MEMSTR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine CHEL(IA,IB,IIM,IEL,ISTOP)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: IA, IB, IIM, IEL
integer(kind=iwp), intent(out) :: ISTOP
integer(kind=iwp) :: IR, IRR

IR = IIM-1
! CHECK FOR A=0 , B=IEL
IRR = IR-IA
if (IRR >= 0) then
  if (IRR >= IB-IEL) then
    ISTOP = 0
    return
  end if
end if
if (IEL /= 1) then
  ! CHECK FOR A=1 , B=IEL-2
  IRR = IR-IA+1
  if (IRR >= 0) then
    if (IRR >= IB-IEL+2) then
      ISTOP = 0
      return
    end if
  end if
end if
ISTOP = 1

return

end subroutine CHEL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE VECSUM(       C,       A,       B,    FACA,    FACB,
     &                      NDIM)
C
C     CACLULATE THE VECTOR C(I)=FACA*A(I)+FACB*B(I)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*),B(*),C(*)
*
      IF(FACA.NE.0.0D0.AND.FACB.NE.0.0D0) THEN
        DO 100 I=1,NDIM
          S=FACA*A(I)+FACB*B(I)
          C(I)=S
  100   CONTINUE
*
      ELSE IF(FACA.EQ.0.0D0.AND.FACB.NE.0.0D0) THEN
        DO 200 I=1,NDIM
          S=FACB*B(I)
          C(I)=S
  200   CONTINUE
*
      ELSE IF(FACA.NE.0.0D0.AND.FACB.EQ.0.0D0) THEN
        DO 300 I=1,NDIM
          S=FACA*A(I)
          C(I)=S
  300   CONTINUE
*
      ELSE IF(FACA.EQ.0.0D0.AND.FACB.EQ.0.0D0) THEN
        DO 400 I=1,NDIM
          C(I)=0.0D0
  400   CONTINUE
      END IF
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ampack(wrk,wrksize,syma,symm,symp,symq,a,vint,ndimv1,ndimv2,ndimv3,ammap)
! this routine packs corresponding parts to ab direct acc. file
! from given integrals <_a,bb,p,q> read in vint
!
! syma  - irrep of first index (I)
! symm  - irrep of 2nd index - m (I)
! symp  - irrep of p (I)
! symq  - irrep of q (I)
! a     - pivot virtual index (counted in nvb set) (I)
! vint  - array of integrals <_a,mm,p,q> (I)
! ndimv1- 1st dimension of vint - norb(symb) (I)
! ndimv2- 2nd dimension of vint - norb(symp) (I)
! ndimv3- 3rd dimension of vint - norb(symq) (I)
! ammap - map for storing of addresses in DA file TEMPDA2 (I)

use ccsort_global, only: lunda2, mbas, noa, NORB, nvb, pos30, reclen
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, syma, symm, symp, symq, a, ndimv1, ndimv2, ndimv3, ammap(mbas,8,8)
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
real(kind=wp), intent(in) :: vint(ndimv1,ndimv2,ndimv3)
integer(kind=iwp) :: irec0, length, m, p, pq, q

!T if there are no a, or no integrals in _a_mpq block return

if (nvb(syma)*noa(symm)*norb(symp)*norb(symq) == 0) return

! def length of _a(m,p,q) block

length = noa(symm)*norb(symp)*norb(symq)

! map _a(mpq) block into #v3

pq = pos30-1

do q=1,norb(symq)
  do p=1,norb(symp)
    do m=1,noa(symm)
      pq = pq+1
      wrk(pq) = vint(m,p,q)
    end do
  end do
end do

! put this block to appropriate position in direct access file

irec0 = ammap(a,symm,symp)
call dawrite(lunda2,irec0,wrk(pos30),length,reclen)

return

end subroutine ampack

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GET_SPGP_INF(ISPGP,ITP,IGRP)
*
* Obtain groups defining supergroup ISPGP,ITP
*
* Jeppe Olsen, November 97
*
      IMPLICIT REAL*8(A-H,O-Z)
*. General input
#include "mxpdim.fh"
#include "cgas.fh"
#include "gasstr.fh"
*. Output
      DIMENSION IGRP(*)
*
      NTEST = 00
*. Absolute group number
C?    WRITE(6,*) ' GET_SPGP_INF : ISPGP, ITP', ISPGP, ITP
      ISPGPABS = ISPGP + IBSPGPFTP(ITP) -1
      CALL ICOPVE(ISPGPFTP(1,ISPGPABS),IGRP,NGAS)
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' GET_SPGP_INF : ISPGP ITP ISPGPABS',
     &              ISPGP, ITP, ISPGPABS
        WRITE(6,*) ' Groups of supergroups'
        CALL IWRTMA(IGRP,1,NGAS,1,NGAS)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_PRTRED(IOPT)
!
! Purpose: print information about reduced set.

use Symmetry_Info, only: Mul
use Cholesky, only: LuPri, NBAS, nnBstR, nnBstRSh, nnBstRT, nnShl, nnShl_tot, nSym
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IOPT
integer(kind=iwp) :: IRED, ISHLAB, ISYM, ISYMA, ISYMB, NRED, NSHP(2)
real(kind=wp) :: PCT1, PCT2, XBAS(8), XXBAS(8), XXBAST
logical(kind=iwp) :: CONTRIB(2)

XBAS(1:NSYM) = real(NBAS(1:NSYM),kind=wp)

XXBAST = Zero
do ISYM=1,NSYM
  XXBAS(ISYM) = Zero
  do ISYMB=1,NSYM
    ISYMA = MUL(ISYMB,ISYM)
    if (ISYMA == ISYMB) then
      XXBAS(ISYM) = XXBAS(ISYM)+XBAS(ISYMA)*(XBAS(ISYMA)+One)*Half
    else if (ISYMA > ISYMB) then
      XXBAS(ISYM) = XXBAS(ISYM)+XBAS(ISYMA)*XBAS(ISYMB)
    end if
  end do
  XXBAST = XXBAST+XXBAS(ISYM)
end do

if (IOPT == 1) then
  NRED = 1
else
  NRED = 2
end if

do IRED=1,NRED
  NSHP(IRED) = 0
  do ISHLAB=1,NNSHL
    CONTRIB(IRED) = .false.
    ISYM = 0
    do while ((.not. CONTRIB(IRED)) .and. (ISYM < NSYM))
      ISYM = ISYM+1
      if (NNBSTRSH(ISYM,ISHLAB,IRED) > 0) CONTRIB(IRED) = .true.
    end do
    if (CONTRIB(IRED)) NSHP(IRED) = NSHP(IRED)+1
  end do
end do

call CHO_HEAD('Reduced Set Information','=',80,LUPRI)

if (NNSHL_TOT == 0) then
  PCT1 = 9.9e9_wp
else
  PCT1 = 1.0e2_wp*real(NSHP(1),kind=wp)/real(NNSHL_TOT,kind=wp)
end if
if (IOPT == 1) then
  write(LUPRI,'(/,A,/,A)') 'Sym.          Full   First Red. Set','-----------------------------------'
  do ISYM=1,NSYM
    write(LUPRI,'(I3,3X,F12.1,7X,I10)') ISYM,XXBAS(ISYM),NNBSTR(ISYM,1)
  end do
  write(LUPRI,'(A)') '-----------------------------------'
  write(LUPRI,'(A,F12.1,7X,I10)') 'Total:',XXBAST,NNBSTRT(1)
  write(LUPRI,'(A)') '-----------------------------------'
  write(LUPRI,'(/,A,I10,A,I10,A,F7.2,A)') 'First Reduced Set:',NSHP(1),' of',NNSHL_TOT,' shell pairs contribute (',PCT1,'%)'
else
  if (NNSHL_TOT == 0) then
    PCT2 = 9.9e9_wp
  else
    PCT2 = 1.0e2_wp*real(NSHP(2),kind=wp)/real(NNSHL_TOT,kind=wp)
  end if
  write(LUPRI,'(/,A,/,A,/,A)') '                          Reduced Set','Sym.          Full      First    Current', &
                               '----------------------------------------'
  do ISYM=1,NSYM
    write(LUPRI,'(I3,3X,F12.1,1X,I10,1X,I10)') ISYM,XXBAS(ISYM),NNBSTR(ISYM,1),NNBSTR(ISYM,2)
  end do
  write(LUPRI,'(A)') '----------------------------------------'
  write(LUPRI,'(A,F12.1,1X,I10,1X,I10)') 'Total:',XXBAST,NNBSTRT(1),NNBSTRT(2)
  write(LUPRI,'(A)') '----------------------------------------'
  write(LUPRI,'(/,A,I10,A,I10,A,F7.2,A)') 'First Reduced Set:',NSHP(1),' of',NNSHL_TOT,' shell pairs contribute (',PCT1,'%)'
  write(LUPRI,'(A,I10,A,I10,A,F7.2,A)') 'Curr. Reduced Set:',NSHP(2),' of',NNSHL_TOT,' shell pairs contribute (',PCT2,'%)'
end if

end subroutine CHO_PRTRED

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989-1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      Subroutine Seward(ireturn)
************************************************************************
* In 1867, William Seward, for 2 cents per acre, purchased             *
* Alaska, a valueless wasteland of ice and snow.                       *
*                                                                      *
* In 1990, Roland Lindh and Ungsik Ryu worked on molecular             *
* integral evaluation, an exhausted scientific area with no            *
* room for innovation.                                                 *
*                                                                      *
* Bowen Liu                                                            *
* April, 1990                                                          *
************************************************************************
************************************************************************
*                                                                      *
*  Object: Driver for the one and two electron integral program        *
*          SEWARD. SEWARD computes integrals for cartesian and         *
*          spherical harmonic gaussian basis functions.                *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA     *
*          July '89 - May '90                                          *
*                                                                      *
*          Roland Lindh, Dept. of Theoretical Chemistry, University of *
*          Lund, SWEDEN. Modified to use Schwartz inequality for pre-  *
*          screening, July 1991.                                       *
************************************************************************
      use Real_Spherical
      use Period
      use GeoList
      use MpmC
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, lIrrep
      use LundIO
      use Temporary_Parameters
      use Integral_parameters, only: iPack, iWROpt
      use DKH_Info, only: DKroll
      use Real_Info, only: PkAcc
      use RICD_Info, only: Do_RI, Cholesky, DiagCheck, LocalDF
      use Logical_Info, only: NEMO, Do_GuessOrb, Do_FckInt, lRP_Post
      Implicit Real*8 (A-H,O-Z)
      External Integral_WrOut, Integral_WrOut2, Integral_RI_3
#include "real.fh"
#include "warnings.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "nsd.fh"
#include "setup.fh"
#include "status.fh"
#include "print.fh"
#include "gateway.fh"
#ifdef _FDE_
#include "embpotdata.fh"
#endif
      Integer iix(2), nChoV(8)
      Real*8 rrx(2)
      Logical PrPrt_Save, Exist, DoRys, lOPTO
      Real*8  DiagErr(4), Dummy(2)
C-SVC: identify runfile with a fingerprint
      Character cDNA*256
      Logical IsBorn, Do_OneEl
*                                                                      *
************************************************************************
*                                                                      *
C     Call Seward_Banner()
      lOPTO = .False.
      nByte = iiLoc(iix(2)) - iiLoc(iix(1))
      nByte_r = idloc(rrx(2))-idloc(rrx(1))
      Call CWTime(TCpu1,TWall1)
*
*     Prologue
*
      iRout=1
      LuWr=6
      PrPrt_Save = .False. ! dummy initialize
*                                                                      *
************************************************************************
*                                                                      *
*     Figure out the run_mode
*
*     Seward can be run in two different modes!
*     GS_Mode: does the work of both Gateway and Seward
*     S_Mode:  only the work of Seward
*
*
*     Check if the run file is there
*
      Call f_Inquire('RUNFILE',Exist)
      If (Exist) Then
         Call Qpg_iScalar('Run_Mode',Exist)
         If (Exist) Then
*
*           The Run_mode of the runfile is either GS_Mode or G_Mode
*
            Call Get_iScalar('Run_Mode',Run_Mode)
*
*           If the Run_mode is that Gateway is in action then Seward
*           should be run in S_mode.
*
            If (Run_Mode.eq.G_Mode) Run_Mode=S_Mode
         Else
            Run_Mode=GS_Mode
         End If
      Else
*
*        Seward runs without Gateway
*
         Run_Mode=GS_Mode
         Call MkRun(iRC,0)
         Call Put_iScalar('Run_Mode',Run_Mode)
*
*     Determine and save the fingerprint of the runfile in a field with
*     label 'BirthCertificate' if it is empty.  This allows us to
*     uniquely identify the runfile and any later associated files.
*
         Call qpg_cArray('BirthCertificate',IsBorn,nDNA)
         If (.NOT.IsBorn) Then
           Call Get_Genome(cDNA,nDNA)
           Call Put_cArray('BirthCertificate',cDNA,nDNA)
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Get the memory size available
*
      Call SetMem('Clear=Off')
*                                                                      *
************************************************************************
*                                                                      *
*     If Seward is run in S_mode most of the input is already on the
*     runfile. If Seward is run in GS_Mode it will handle the input and
*     runfile in the conventional way.
*
      Call Seward_Init()
      If (Run_Mode.eq.S_Mode) Then
*
*        S_Mode
*
         DoRys=.True.
         nDiff=0
         Call GetInf(DoRys,nDiff)
         Primitive_Pass=.True.
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
*        GS_Mode
*                                                                      *
************************************************************************
*                                                                      *
         Call Funi_Init()
         Call Basis_Info_Init()
         Call Center_Info_Init()
*
      End If ! Run_Mode.eq.S_Mode

*                                                                      *
************************************************************************
*                                                                      *
*   columbus support: initialize additional items in Runfile
*   default: no mixed operation
      call Put_iScalar('Columbus',0)
      call Put_iScalar('colgradmode',0)
      dummy(1)=0.0d0
      dummy(2)=0.0d0
      call Put_dArray ('MR-CISD energy',dummy,2)
      Call NQGrid_Init()
*                                                                      *
************************************************************************
*                                                                      *
*     Spool the input
*
      LuSpool=21
      Call SpoolInp(LuSpool)
*     Read the input from input file
*
      Call RdCtl_Seward(LuSpool,lOPTO,Do_OneEl)
      If (Run_Mode.ne.S_Mode) Then
         Call Basis_Info_Dmp()
         Call Basis_Info_Free()
         Call Basis_Info_Get()
         Call Center_Info_Dmp()
         Call Center_Info_Free()
         Call Center_Info_Get()
      End If
*
      Call Close_LuSpool(LuSpool)
*
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
 199  Continue
*
*     Process the input.
*
      Call Input_Seward(lOPTO)
*
      If (Primitive_Pass) Then
         PrPrt_Save = PrPrt
         PrPrt=.False.
      Else
         PrPrt=PrPrt_Save
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Compute the Nuclear potential energy
*
      If (.Not.Primitive_Pass) Call DrvN0()
*                                                                      *
************************************************************************
*                                                                      *
      If (Show) Then
*
*        Print out basis set information
*
         Write(6,*)
         Write(6,'(6X,A)')'Basis set specifications :'
         Write(6,'(6X,A,T30,8(2X,A))')
     &         'Symmetry species',     (lIrrep(i),i=0,nIrrep-1)
         Write(6,'(6X,A,T30,8I5)')'Basis functions',
     &                                 (nBas(i),i=0,nIrrep-1)
         Write(6,*)
*
      End If

*                                                                      *
************************************************************************
*                                                                      *
*     If only test case then clean up!
*
      If (Test) Go To 9999
*                                                                      *
************************************************************************
*                                                                      *
*     Write/update information on the run file.
*
      If (.Not.Primitive_Pass) Then
         Call DmpInf()
         Call basis2run()
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     ONE-ELECTRON INTEGRAL SECTION
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
#ifdef _FDE_
      ! Embedding
      if (embPot.and..not.embPotInBasis) then
       Call embPotInit(.false.)
      end if
#endif

      Lu_One=2
      iOpt = 1
      iRC = -1
*
*     Generate primimitive integrals only if needed.
*
      If (Primitive_Pass.and.(DKroll.or.Nemo)) Then
         Call OpnOne(iRC,iOpt,'ONEREL',Lu_One)
         Call OneBas('PRIM')
      Else
         Call OpnOne(iRC,iOpt,'ONEINT',Lu_One)
      End If
      If (iRC.ne.0) Then
         Call WarningMessage(2,
     &                  ' *** Error in subroutine INPUT ***;'
     &                //'     Abend in subroutine OpnOne')
         Call Abend()
      End If
*
      If (Do_OneEl.and.
     &    (.Not.Primitive_Pass .or.
     &    (Primitive_Pass.and.(DKroll.or.NEMO)) ) )
     &   Call Drv1El()
*
      iOpt = 0
      iRC = -1
      Call ClsOne(iRC,iOpt)
      If (iRC.ne.0) then
         Call WarningMessage(2,
     &              ' *** Error in SEWARD main ***;'
     &            //'  Abend in subroutine ClsOne')
         Call Abend()
      End If

#ifdef _FDE_
      ! Embedding
      if (embPot.and..not.embPotInBasis) Call embPotFreeMem
#endif

*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     If a pass in which primitive integrals where computed do a second
*     pass.
*
      If (Primitive_Pass) Then
         Primitive_Pass=.False.
         Call Free_iSD()
         Go To 199
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Branch out if only one-electron integrals are to be computed!
*
      If (Onenly) Go To 9999
*
*     If ERIs/CD/RI already available, one may want not to redo it!
*
      If (Fake_ERIs) Then
         Call set_fake_ERIs()
         Go To 9999
      EndIf
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     TWO-ELECTRON INTEGRAL SECTION
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*
      If ( iWRopt.eq.0 ) then
*
*------- Molcas format
*
         If (Cholesky) Then ! Cholesky decomposition
            Call Cho_MCA_Drv()
            Call Get_iArray('NumCho',nChoV,nIrrep)
            Write(6,'(6X,A,T30,8I5)')'Cholesky vectors',
     &               (nChoV(i),i=1,nIrrep)
            Write(6,*)
            Write(6,*)
         Else If (Do_RI) Then
            If (LocalDF) Then
               Call Drv2El_LocalDF()
            Else
               If (nPrint(iRout).ge.6) Then
                  Write (6,*)
                  Write (6,'(A)') 'Seward processing 2-center and '
     &                          //'3-center ERIs'
                  Write (6,*)
               End If
               Call Drv2El_3Center_RI(Integral_RI_3,Zero)
               Call Get_iArray('NumCho',nChoV,nIrrep)
               If (nPrint(iRout).ge.6) Then
                  Write(6,'(6X,A,T30,8I5)')'RI vectors',
     &                  (nChoV(i),i=1,nIrrep)
                  Write(6,*)
                  Write(6,*)
               End If
            End If
         Else
            iWrOpt_Save=iWrOpt
            iWrOpt=0
            Call Sort0
*
            Call Drv2El(Integral_WrOut2,Zero)
*
            Call Sort1B
            Call Sort2
            Call Sort3(MaxDax)
*
            If (nPrint(iRout).ge. 6) Then
               Write (6,*)
               Write (6,'(A)')
     &           ' Integrals are written in MOLCAS2 format'
               If ( iPack.ne.0 ) Then
                  Write (6,'(A)')
     &              ' No packing of integrals has been applied'
               Else
                  Write (6,'(A,G11.4)') ' Packing accuracy =',
     &                                   PkAcc
                  Write (6,'(A,I10)')
     &             ' Highest disk address written',MaxDax
               End If
               Write (6,'(A,A)') ' Diagonal and subdiagonal, '
     &           //'symmetry allowed 2-el',
     &           ' integral blocks are stored on Disk'
            End If
            iWrOpt=iWrOpt_Save
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else If (iWRopt.eq.1) Then
*
*------- Molecule format (Molcas 1.0)
*
         Lu_28=28
         Lu_28=isfreeunit(Lu_28)
         Call DaName_MF(Lu_28,'BASINT')
         iDisk=0
         lBuf=idLoc(Buf%r_End)-idLoc(Buf%Buf(1))
         lBuf=(lBuf+nByte_r)/nByte_r - 1
*
         Call Drv2El(Integral_WrOut,Zero)
*
         Call dDafile(Lu_28,1,Buf%Buf,lBuf,iDisk)
         Buf%nUt=-1
         Call dDafile(Lu_28,1,Buf%Buf,lBuf,iDisk)
         Write (6,*)
         Write (6,'(A)')' Integrals are written in MOLCAS1 format'
         Write (6,'(I10,A)') IntTot,' Integrals written on Disk'
*                                                                      *
************************************************************************
*                                                                      *
      Else
*
         Call WarningMessage(2,'Seward: Invalid value of iWRopt!')
         Call Abend()
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     At the end of the calculation free all memory to check for
*     corruption of the memory.
*

 9999 Call ClsSew()
      If (Allocated(AdCell)) Call mma_deallocate(AdCell)
      Call mma_deallocate(Coor_MPM)
      Call mma_deallocate(Chrg)
      Call mma_deallocate(Mass)
      Call mma_deallocate(Centr)
*                                                                      *
************************************************************************
*                                                                      *
      Call CWTime(TCpu2,TWall2)
      Call SavTim(4,TCpu2-TCpu1,TWall2-TWall1)
*                                                                      *
************************************************************************
*                                                                      *
*     Diagonal ERI check
*
      If (Cholesky .or. Do_RI) Then
         If (DiagCheck) Then
            write(6,*)' ==== Start Diagonal ERI check  ===='
            Call Cho_X_init(irc,ChFracMem)
            if (irc.ne.0) then
               Call WarningMessage(2,
     &                   ' Seward: Non-zero rc in Cho_X_init.')
               Call Abend()
            endif
            Call Cho_X_CheckDiag(irc,DiagErr)
            if (irc.ne.0) then
               Call WarningMessage(2,
     &                   ' Seward: Non-zero rc in Cho_X_CheckDiag.')
               Call Abend()
            endif
            Call Cho_X_Final(irc)
            if (irc.ne.0) then
               Call WarningMessage(2,
     &                   ' Seward: Non-zero rc in Cho_X_Final.')
               CALL Abend()
            endif
            write(6,*)
            write(6,*)' ====  End  Diagonal ERI check  ===='
         EndIf
      EndIf
*                                                                      *
************************************************************************
*                                                                      *
*     Automatic run of GuessOrb
*
      If (Do_GuessOrb.and.Do_FckInt) Call GuessOrb(iReturn,.FALSE.)
      If (.not.Prprt.and.Do_OneEl) Call Put_NucAttr()
*                                                                      *
************************************************************************
*                                                                      *
*
*     Epilogue
*
      If (nPrint(iRout).ge.6) Then
         Call FastIO('STATUS')
      End If
*
*
      If (Test)  Then
         ireturn=_RC_EXIT_EXPECTED_
      Else If (lRP_Post) Then
         ireturn=_RC_INVOKED_OTHER_MODULE_
      Else
         ireturn=_RC_ALL_IS_WELL_
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Rulin Feng                                       *
************************************************************************
      SUBROUTINE HFCSD(LABEL,IC,BUFF,NBUFF,NSIZ,ISCHK)
      use definitions, only: iwp, wp, u6
      use constants, only: Zero, Two, Three, Four
      use stdalloc, only: mma_allocate, mma_deallocate
      use hfc_logical, only: MAG_X2C
      IMPLICIT NONE
************************************************************************
*     Objective: to compute the 'spin-dependent' part of the hyperfine *
*                from the magnetic integrals contributions             *
*     Output: BUFF                                                     *
************************************************************************
      CHARACTER(LEN=8), intent(inout):: LABEL
      INTEGER(KIND=IWP), INTENT(IN):: IC,NBUFF,NSIZ
      INTEGER(KIND=IWP), INTENT(INOUT):: ISCHK
      REAL(KIND=WP), INTENT(INOUT):: BUFF(NBUFF)

      INTEGER(KIND=IWP) ICM,INBUFF,IOPT,IRC
      real(kind=wp) DA
      real(kind=wp), allocatable:: TA(:)

c Set MAG_X2C to avoid add_info in hfcts
      MAG_X2C=.True.
      IOPT=0
      CALL mma_allocate(TA,NBUFF,Label='TA')
c BUFF needs to be initialized
      do iNBUFF = 1, NBUFF
         BUFF(iNBUFF) = Zero
      enddo
c end of initialization
      DA = Two

      Select Case (IC)
      Case(1)
c EF2(1) = (2*MAG(1)-MAG(5)-MAG(9))*(2/3)
         ICM = 1
         DA = Four/Three
         CALL RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)
         do iNBUFF = NSIZ, NBUFF-1
             BUFF(iNBUFF+1) = TA(1+iNBUFF)
         enddo

         ICM = 5
         DA = -Two/Three
         Call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)

         ICM = 9
         DA = -Two/Three
         CALL RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)
      Case(2)
c EF2(2) = MAG(2)*2
         ICM = 2
         CALL RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)
         do iNBUFF = NSIZ, NBUFF-1
             BUFF(iNBUFF+1) = TA(1+iNBUFF)
         enddo
      Case(3)
c EF2(3) = MAG(3)*2
         ICM = 3
         CALL RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)
         do iNBUFF = NSIZ, NBUFF-1
             BUFF(iNBUFF+1) = TA(1+iNBUFF)
         enddo
      Case(4)
c EF2(4) = (2*MAG(5)-MAG(1)-MAG(9))*(2/3)
         ICM = 5
         DA = Four/Three
         CALL RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)
         do iNBUFF = NSIZ, NBUFF-1
             BUFF(iNBUFF+1) = TA(1+iNBUFF)
         enddo

         ICM = 1
         DA = -Two/Three
         Call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)

         ICM = 9
         DA = -Two/Three
         CALL RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)
      Case(5)
c EF2(5) = MAG(6)*2
         ICM = 6
         CALL RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)
         do iNBUFF = NSIZ, NBUFF-1
             BUFF(iNBUFF+1) = TA(1+iNBUFF)
         enddo
      Case(6)
c EF2(6) = (MAG(1)+MAG(5)+MAG(9))*2
         ICM = 1
         CALL RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)
         do iNBUFF = NSIZ, NBUFF-1
             BUFF(iNBUFF+1) = TA(1+iNBUFF)
         enddo

         ICM = 5
         Call RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)

         ICM = 9
         CALL RDONE(IRC,IOPT,LABEL,ICM,TA,ISCHK)
         IF (IRC.NE.0) CALL ErrStop()
         CALL DAXPY_(NSIZ,DA,TA,1,BUFF,1)
      Case Default
         WRITE(u6,'(6X,A)')'*** ERROR IN SUBROUTINE HFCSD ***'
         Call ABend()
      End Select
      CALL mma_deallocate(TA)

      Contains
      Subroutine ErrStop()
        WRITE(u6,*)
        WRITE(u6,'(6X,A)')'*** ERROR IN SUBROUTINE HFCSD ***'
        WRITE(u6,'(6X,A)')'  FAILED IN READING FROM  ONEINT'
        WRITE(u6,'(6X,A)')' PLEASE MAKE SURE THE MAGNETIC'
        WRITE(u6,'(6X,A)')' HYPERFINE INTEGRALS ARE AVAILABLE'
        WRITE(u6,'(6X,A,A)')'  LABEL     = ',LABEL
        WRITE(u6,'(6X,A,I2)')'  COMPONENT = ',ICM
        WRITE(u6,*)
        CALL ABEND()
      END Subroutine ErrSTop

      END SUBROUTINE HFCSD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine change6_cvb()
      implicit real*8 (a-h,o-z)
      logical changed
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "rls_cvb.fh"
#include "davtune_cvb.fh"
      save icase

      changed=.false.
      if(changed)call touch_cvb('CIFREE')

      nprorb=norb*(norb-1)
      if(strucopt)then
        nprvb=nvb
        npr=nprorb+nvb
      elseif(.not.(imethod.eq.4.or.imethod.eq.6))then
        nprvb=0
        npr=nprorb
      else
        npr=0
      endif
      if(chpcmp_cvb(npr))changed=.true.
      if((.not.(imethod.eq.4.or.imethod.eq.6)).and.ifinish.eq.0)then
c  Standard 2nd-order procedure :
        icase=1
      elseif(imethod.eq.4.and.icrit.eq.1.and.ifinish.eq.0)then
c  Overlap-based Davidson
        icase=2
      elseif(imethod.eq.4.and.icrit.eq.2.and.ifinish.eq.0)then
c  Energy-based Davidson
        icase=3
      elseif(imethod.eq.6.or.ifinish.eq.1.or.ifinish.eq.2)then
c  No arrays needed
        icase=4
      else
        icase=5
      endif
      if(chpcmp_cvb(icase))changed=.true.
      if(changed)call touch_cvb('MEM6')
      return

      entry chop6_cvb()
      if(release(6))call mfreer_cvb(lp(1))
      release(6)=.true.
      release(7)=.false.
      lp(1) = mstackr_cvb(0)

      call setcnt2_cvb(6,0)
      if(icase.eq.1)then
c  Standard non-linear optimization procedure :
        lp(1)= mstackr_cvb(norb*norb+nvb+1+mxirrep)
        lp(2)= mstackr_cvb(npr)
        lq(3)= mstackr_cvb(nprorb*nprorb)
        lq(4)= mstackr_cvb(norb**4)
        lp(5)= mstackr_cvb(npr)
        lp(6)= mstackr_cvb(npr)
        lq(7)= mstackr_cvb(npr)
        lq(8)= mstackr_cvb(npr)
        lq(9)= mstackr_cvb(norb*norb)
c  Vec1 work array
        lq(10)= mstackr_cvb(max(npr,ndetvb))
      elseif(icase.eq.2)then
c  Overlap-based Davidson optimization :
        iremain=mavailr_cvb()
        maxdav=min(mxiter,nvb,mxdav)

        memwrk=ndetvb+5*norb*norb+3*ihlf_cvb(norb+2*norb*norb)
        do 1 idav=maxdav,1,-1
c  NEED is approx req. memory :
        need=2*nvb*idav+2*nvb+idav+1000+memwrk
        if(need.lt.iremain)goto 2
1       continue
        idav=0
        if(nvb.eq.0)then
          need=1000+memwrk
          if(need.lt.iremain)goto 2
        endif
        write(6,*)' Not enough memory for Davidson!',need,iremain
        call abend_cvb()
2       maxdav=idav

      elseif(icase.eq.3)then
c  Energy-based Davidson optimization :
        iremain=mavailr_cvb()
        maxdav=min(mxiter,nvb,mxdav)

        mem_applyh=ndet+neread
        ncimx=0
        do ir=1,nirrep
        ncimx=max(ncimx,ncivb(ir))
        enddo
        if(ncimx.ne.ndet)mem_applyh=mem_applyh+ncimx
        memwrk=ndetvb+3*norb*norb+2*ihlf_cvb(norb+2*norb*norb)

        do 11 idav=maxdav,1,-1
c  NEED is approx req. memory :
        need=3*nvb*idav+nvb+idav*(2*idav+3)+1000+mem_applyh+memwrk
        if(need.lt.iremain)goto 12
11      continue
        idav=0
        if(nvb.eq.0)then
          need=1000+memwrk
          if(need.lt.iremain)goto 12
        endif
        write(6,*)' Not enough memory for Davidson!',need,iremain
        call abend_cvb()
12      maxdav=idav

      elseif(icase.eq.4)then
c  Wavefunction analysis :
        mstackr_cvb0=mstackr_cvb(0)
        if(((.not.variat).or.endvar).and.
     >    (ivbweights.gt.1.or.ishstruc.eq.1))then
          lp(1)= mstackr_cvb(nvb*nvb)
          lp(2)= mstackr_cvb(nvb*nvb)
        else
          lp(1)= mstackr_cvb0
          lp(2)= mstackr_cvb0
        endif
        do i=3,11
        lp(i)= mstackr_cvb0
        enddo
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine cct3_rea (lun,length,vector)
c
c     this routine read length-R8 numbers from opened unformatted file
c     with number lun form the given possition as one record
c
c     lun    - Logical unit number of file, where mediate is stored (Input)
c     length - # of R8 numbers to be read  (Input)
c     vector - space, where numbers are stored after reading  (Output)

c
#include "t31.fh"
c
       integer lun,length
       real*8 vector(1:length)
c
       if (iokey.eq.1) then
c      Fortran IO
       read (lun) (vector(i),i=1,length)
c
       else
c      MOLCAS IO
       call ddafile (lun,2,vector,length,daddr(lun))
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_SetLQ()
C
C     Purpose: set local qualified indices from known global qualified.
C
C     The local indices are stored in cholq.fh:
C
C     nQual_L(iSym)   : #qualified, irrep iSym (=1,2,..,nSym)
C     iQuAB_L(iQ,iSym): iWork(ip_iQuAB_L-1+MaxQual*(iSym-1)+iQ)
C                       address of qualified iQ of sym. iSym in current
C                       local reduced set (i.e. reduced set at location
C                       2). Not symmetry reduced, i.e. includes the
C                       offset iiBstR(iSym,2).
C     iQL2G(iQ,iSym)  : iWork(ip_iQL2G-1+MaxQual*(iSym-1)+iQ)
C                       returns index of the qualified in the global
C                       list.
C
      Implicit None
#include "cholesky.fh"
#include "choptr.fh"
#include "cholq.fh"
#include "choglob.fh"
#include "cho_para_info.fh"
#include "WrkSpc.fh"

      Integer iSym, nQL, kOff1, kOff2, iQ, iQG, i2, i, j, k

      Integer iQuAB, IndRed_G, IndRed, iL2G
      iQuAB(i,j)=iWork(ip_iQuAB-1+MaxQual*(j-1)+i)
      IndRed_G(i,j)=iWork(ip_IndRed_G-1+mmBstRT_G*(j-1)+i)
      IndRed(i,j)=iWork(ip_IndRed-1+mmBstRT*(j-1)+i)
      iL2G(i)=iWork(ip_iL2G-1+i)

      If (.not.Cho_Real_Par) Return ! not truely parallel...

      Call Cho_iZero(iWork(ip_iQuAB_L),l_iQuAB_L)
      Call Cho_iZero(iWork(ip_iQL2G),l_iQL2G)
      Do iSym = 1,nSym
         nQL = 0
         kOff1 = ip_iQuAB_L + MaxQual*(iSym-1) - 1
         kOff2 = ip_iQL2G   + MaxQual*(iSym-1) - 1
         Do iQ = 1,nQual(iSym)
            iQG = IndRed_G(iQuAB(iQ,iSym),2) ! addr of qual in glob. rs1
            i2 = iiBstR(iSym,2) + nnBstR(iSym,2)
            i = iiBstR(iSym,2)
            Do While (i .lt. i2)
               i = i + 1
               j = IndRed(i,2) ! addr in local rs1
               k = iL2G(j)     ! addr in global rs1
               If (k .eq. iQG) Then ! found qual in local set
                  nQL = nQL + 1
                  iWork(kOff1+nQL) = i
                  iWork(kOff2+nQL) = iQ
                  i = i2 ! break while loop
               End If
            End Do
         End Do
         nQual_L(iSym) = nQL
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1994, Jeppe Olsen                                 *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine IEL13(MNRS1,MXRS1,MNRS3,MXRS3,NELEC,NOCTYP,IEL1,IEL3,IEL123)
! A type of strings contains NEL electrons and
!
! The number of electrons in RAS 1 is between MNRS1 AND MXRS1
! The number of electrons in RAS 3 is between MNRS3 AND MXRS3
!
! Find the number of electrons in RAS1 and RAS3 in each subtype
! and determine if subtype  is active
!
! Jeppe Olsen, Spring 1991
!              IEL123 added Jan 1994

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: MNRS1, MXRS1, MNRS3, MXRS3, NELEC, NOCTYP
integer(kind=iwp), intent(out) :: IEL1(NOCTYP), IEL3(NOCTYP), IEL123(3,NOCTYP)
integer(kind=iwp) :: ITYP, KEL1, KEL3, NTYP

IEL1(:) = 0
IEL3(:) = 0
do KEL3=MNRS3,MXRS3
  do KEL1=MNRS1,MXRS1
    ITYP = (MXRS1-KEL1)*(MXRS3-MNRS3+1)+KEL3-MNRS3+1
    IEL1(ITYP) = KEL1
    IEL3(ITYP) = KEL3
  end do
end do
NTYP = (MXRS1-MNRS1+1)*(MXRS3-MNRS3+1)
IEL123(1,1:NTYP) = IEL1(1:NTYP)
IEL123(2,1:NTYP) = NELEC-IEL1(1:NTYP)-IEL3(1:NTYP)
IEL123(3,1:NTYP) = IEL3(1:NTYP)

#ifdef _DEBUGPRINT_
write(u6,*) ' =============='
write(u6,*) ' IEL13 speaking'
write(u6,*) ' =============='
write(u6,'(A,4I3)') ' IEL1 IEL3 for MNRS1 MXRS1 MNRS3 MXRS3 ',MNRS1,MXRS1,MNRS3,MXRS3
do ITYP=1,NOCTYP
  write(u6,'(3I3)') IEL1(ITYP),IEL3(ITYP)
end do

write(u6,*) ' IEL123 matrix'
call IWRTMA(IEL123,3,NOCTYP,3,NOCTYP)
#endif

return

end subroutine IEL13

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function nMemAm(nShBF,nIrrep,nS,jS,iOffA,Out_of_Core)

use Index_Functions, only: nTri_Elem
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nMemAm
integer(kind=iwp),intent(in) :: nIrrep, nS, nShBf(0:nIrrep-1,nS), jS
integer(kind=iwp),intent(out) :: iOffA(4,0:nIrrep-1)
logical(kind=iwp),intent(in) :: Out_of_Core
integer(kind=iwp) :: iIrrep, lS, ni, nj, nl, nn

if (Out_Of_Core) then

  ! Only a subblock of the upper trianular storage.

  nMemAm = 0
  do iIrrep=0,nIrrep-1
    nj = nShBf(iIrrep,jS)
    nl = 0
    do lS=1,jS
      nl = nl+nShBf(iIrrep,lS)
    end do
    ! Offset to where this block starts
    iOffA(1,iIrrep) = nMemAm
    ! # of basis functions for the jSs shell
    iOffA(2,iIrrep) = nj
    ! max # number of basis functions for this block
    iOffA(4,iIrrep) = nl
    ! Update nMemAm with the sise of this subblock.
    nn = nl-nj
    nMemAm = nMemAm+nTri_Elem(nl)-nTri_Elem(nn)
  end do
else

  ! The whole A matrix is in core! Upper triangular storage.

  nMemAm = 0
  do iIrrep=0,nIrrep-1
    nj = nShBf(iIrrep,jS)
    ni = 0
    do lS=1,jS-1
      ni = ni+nShBf(iIrrep,lS)
    end do
    nl = ni+nj
    ! Offset to where this block starts
    iOffA(1,iIrrep) = nMemAm+nTri_Elem(ni)
    ! # of basis functions for the jSs shell
    iOffA(2,iIrrep) = nj
    iOffA(4,iIrrep) = nl
    ! Update nMemAm with the size of the whole block for this irrep.
    do lS=jS+1,nS
      nl = nl+nShBf(iIrrep,lS)
    end do
    nMemAm = nMemAm+nTri_Elem(nl)
  end do
end if

return

end function nMemAm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Aces_Gamma()

use Index_Functions, only: nTri_Elem
use setup, only: mSkal, nSOS
use Basis_Info, only: nBas
use PSO_Stuff, only: Bin, G_ToC, lBin, LuGamma, SO2CI
use iSD_data, only: iSO2Sh
use Gateway_Info, only: CutInt
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: iBlock, iIrrep_A, iIrrep_B, iIrrep_C, iIrrep_D, iType, MaxMem, nA, nAB, nB, nBlocks, nC, nCD, nD, nPair, &
                     nQUad, nReq, nShell
integer(kind=iwp), allocatable :: iTable(:,:)
real(kind=wp), allocatable :: Buf(:), Bin3(:,:,:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
nShell = mSkal
nPair = nTri_Elem(nShell)
nQuad = nTri_Elem(nPair)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate Table Of Content for half sorted gammas.

call mma_allocate(G_Toc,nQuad,Label='G_Toc')

! Table SO to contiguous index

call mma_allocate(SO2cI,2,nSOs,Label='SO2cI')

! Both should be deallocated in CloseP!
!                                                                      *
!***********************************************************************
!                                                                      *
! Generate table with information regarding the symmetry blocks
! of the gammas as stored in Aces 2 format

if (nIrrep == 8) nBlocks = 106
if (nIrrep == 4) nBlocks = 19
if (nIrrep == 2) nBlocks = 4
if (nIrrep == 1) nBlocks = 1
call mma_Allocate(iTable,6,nBlocks,Label='iTable')
call Gamma_Blocks(iTable,nBlocks,nIrrep)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate memory for read buffer

call mma_MaxDBLE(MaxMem)
nReq = 0
do iBlock=1,nBlocks
  iType = iTable(1,iBlock)
  iIrrep_A = iTable(2,iBlock)
  iIrrep_B = iTable(3,iBlock)
  iIrrep_C = iTable(4,iBlock)
  iIrrep_D = iTable(5,iBlock)

  nA = nBas(iIrrep_A)
  nB = nBas(iIrrep_B)
  nC = nBas(iIrrep_C)
  nD = nBas(iIrrep_D)
  if ((iType == 1) .or. (iType == 2)) then
    nAB = nTri_Elem(nA)
    nCD = nTri_Elem(nC)
  else
    nAB = nA*nB
    nCD = nC*nD
  end if

  nReq = max(nReq,nAB*nCD)
end do
nReq = min(MaxMem/4,nReq)
call mma_allocate(Buf,nReq,Label='Buf')
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate bins for shell quadruplets

call mma_MaxDBLE(MaxMem)
lBin = min(MaxMem/(2*nQuad),1024)
call mma_allocate(Bin3,2,lBin,nQuad,Label='Bin3')
!                                                                      *
!***********************************************************************
!                                                                      *
! Open the bin file with half sorted gammas.

LuGamma = 60
LuGamma = isfreeunit(LuGamma)
call DaName_MF(LuGamma,'GAMMA')
!                                                                      *
!***********************************************************************
!                                                                      *
! Read the blocks off the Aces 2 file and put into half sorted bin
! file. The second half sort is done on the fly as needed.

call Read_Blocks(iTable,nBlocks,nBas,nIrrep,Buf,nReq,iSO2Sh,nSOs,Bin3,lBin,nQuad,G_Toc,SO2cI,CutInt)
!                                                                      *
!***********************************************************************
!                                                                      *
! Deallocate memory

call mma_deallocate(Bin3)
call mma_deallocate(Buf)
call mma_deallocate(iTable)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate buffer for reading the bins

call mma_allocate(Bin,2,lBin,Label='Bin')
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Aces_Gamma

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Roland Lindh                                     *
************************************************************************
      Subroutine Get_H(ip_H)
************************************************************************
*                                                                      *
*     Object: to get the force constant matrix in cartesians           *
*                                                                      *
*                                                                      *
*     Author: Roland Lindh                                             *
*             Department of Quantum Chemistry                          *
*             Uppsala University, Sweden                               *
*             October 2010                                             *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "info_slapaf.fh"
#include "WrkSpc.fh"
      Logical Found
*
*define _DEBUGPRINT_
      nX=3*nsAtom
      mInter=mInt + mTROld
      nInter=mInt
*
      Call Allocate_Work(ip_H,nX**2)
      Call Allocate_Work(ipTmp2,nX**2)
      Call Allocate_Work(ipH,nInter**2)
*---- If there is an updated Hessian in the runfile, use it;
*     otherwise use the last computed one.
*     (Hss_upd must be removed every time Hss_Q is added)
      Call Qpg_dArray('Hss_upd',Found,nHss)
      If (Found.and.(nHss.eq.nInter**2)) Then
         Call Get_dArray('Hss_upd',Work(ipH),nInter**2)
      Else
         Call Get_dArray('Hss_Q',Work(ipH),nInter**2)
      End If
      Call Allocate_Work(ipBOld,nX*nInter)
*---- If there is an old BMx stored, use it;
*     otherwise use the current BMx
      Call Qpg_dArray('BMxOld',Found,nBMx)
      If (Found.and.(nBMx.eq.nX*nInter)) Then
         Call Get_dArray('BMxOld',Work(ipBOld),nX*nInter)
      Else
         Call Get_dArray('BMtrx',Work(ipBOld),nX*nInter)
      End If
*
      Call Get_H_(nX,Work(ipBOld),mInter,nInter,Work(ipH),Degen,
     &            Work(ipTmp2),Work(ip_H),Smmtrc,nsAtom)
*
      Call Free_Work(ipBOld)
      Call Free_Work(ipH)
      Call Free_Work(ipTmp2)
*
      Return
      End
      Subroutine Get_H_(nX,BMtrx,mInter,nInter,H,Degen,
     &                 Tmp2,Tmp3,Smmtrc,nAtom)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "print.fh"
#include "WrkSpc.fh"
      Logical Smmtrc(3,nAtom)
      Real*8 BMtrx(nX,nInter), H(nInter,nInter),Degen(3,nAtom),
     &       Tmp2(nX**2), Tmp3(nX**2)
*                                                                      *
************************************************************************
*                                                                      *
*     The Hessian matrix (zero elements over translations and
*     rotations are explicitly excluded).
*
#ifdef _DEBUGPRINT_
      Call RecPrt('BMtrx',' ',BMtrx,nX,nInter)
#endif
      ii = 0
      Do i = 1, nAtom
         Do ix = 1, 3
*
            If (Smmtrc(ix,i)) Then
               iix = (i-1)*3 + ix
               ii = ii + 1
               Do j = 1, nInter
                  ij = (j-1)*mInter + ii

                  tmp_ij=Zero
                  Do k = 1, nInter
                     tmp_ij=tmp_ij+BMtrx(iix,k)*H(k,j)
                  End Do
                  Tmp2(ij)=tmp_ij

               End Do
            End If
*
         End Do
      End Do
*
      Do i = 1, mInter
*
         jj = 0
         Do j = 1, nAtom
            Do jx = 1, 3
*
               If (Smmtrc(jx,j)) Then
                  jjx=(j-1)*3+jx
                  jj = jj + 1
                  ij = (jj-1)*mInter + i
                  tmp_ij=Zero
                  Do k = 1, nInter
                     ik = (k-1)*mInter + i
                     tmp_ij=tmp_ij+Tmp2(ik)*BMtrx(jjx,k)
                  End Do
                  Tmp3(ij)=tmp_ij
               End If
*
            End Do
         End Do
*
      End Do
*
#ifdef _DEBUGPRINT_
      Call RecPrt('Hessian (cartesian)',' ',Tmp3,mInter,mInter)
#endif
      Call Put_dArray('FC-Matrix',Tmp3,mInter**2)
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(Degen)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine MkFck(iAnga,iCmp,Shijij,iShll,iShell,iBasi,jBasj,kBask,lBasl,iAO,iAOst,nOp,jOp,Dij,mDij,nDij,ij1,ij2,ij3,ij4,Dkl,mDkl, &
                 nDkl,kl1,kl2,kl3,kl4,Dik,mDik,nDik,ik1,ik2,ik3,ik4,Dil,mDil,nDil,il1,il2,il3,il4,Djk,mDjk,nDjk,jk1,jk2,jk3,jk4, &
                 Djl,mDjl,nDjl,jl1,jl2,jl3,jl4,AOInt,nAO,TwoHam,nFock,Scrtch2,nS2,FckTmp,nFT,pert,iuvwx,iCent,iCar,indgrd,ipDisp)
!***********************************************************************
!                                                                      *
! Object: Driver for the generation of the two electron contribution   *
!         to the Fock Matrix directly from the two electron integrals. *
!                                                                      *
!     Author:  Anders Bernhardsson 1995                                *
!***********************************************************************

use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iAnga(4), iCmp(4), iShll(4), iShell(4), iBasi, jBasj, kBask, lBasl, iAO(4), iAOst(4), nOp(4), &
                                 jOp(6), mDij, nDij, ij1, ij2, ij3, ij4, mDkl, nDkl, kl1, kl2, kl3, kl4, mDik, nDik, ik1, ik2, &
                                 ik3, ik4, mDil, nDil, il1, il2, il3, il4, mDjk, nDjk, jk1, jk2, jk3, jk4, mDjl, nDjl, jl1, jl2, &
                                 jl3, jl4, nAO, nFock, nS2, nFT, iuvwx, iCent, iCar, indgrd(3,4,0:7), ipdisp(*)
logical(kind=iwp), intent(in) :: Shijij, pert(0:7)
real(kind=wp), intent(in) :: Dij(mDij,nDij), Dkl(mDkl,nDkl), Dik(mDik,nDik), Dil(mDil,nDil), Djk(mDjk,nDjk), Djl(mDjl,nDjl), &
                             AOInt(nAO)
real(kind=wp), intent(inout) :: TwoHam(nFock)
real(kind=wp), intent(out) :: Scrtch2(nS2), FckTmp(nFT)
integer(kind=iwp) :: nijkl
real(kind=wp) :: Fact

! Just to make a nice interface

!iRout = 12
!iPrint = nPrint(iRout)
nijkl = iBasi*jBasj*kBask*lBasl

! Accumulate contributions directly to the symmetry adapted Fock matrix.

Fact = real(iuvwx,kind=wp)/real(nIrrep,kind=wp)

call FckAcc_mck(iAnga,iCmp(1),iCmp(2),iCmp(3),iCmp(4),Shijij,iShll,iShell,nOp,nijkl,AOInt,TwoHam,nFock,Scrtch2,nS2,iAO,iAOst, &
                iBasi,jBasj,kBask,lBasl,Dij(1,jOp(1)),ij1,ij2,ij3,ij4,Dkl(1,jOp(2)),kl1,kl2,kl3,kl4,Dik(1,jOp(3)),ik1,ik2,ik3,ik4, &
                Dil(1,jOp(4)),il1,il2,il3,il4,Djk(1,jOp(5)),jk1,jk2,jk3,jk4,Djl(1,jOp(6)),jl1,jl2,jl3,jl4,FckTmp,nFT,fact,iCar, &
                iCent,pert,indgrd,ipdisp)

return

end subroutine MkFck

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine InsL(Ll,Lg,ncLoc,nc,ncOff,dim_1)
! this routine does:
! insert Llocal(ml,dim_1) into Lglobal(m,dim_1)
! on a corresponding place

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ncLoc, nc, ncOff, dim_1
real(kind=wp), intent(in) :: Ll(ncLoc,dim_1)
real(kind=wp), intent(inout) :: Lg(nc,dim_1)

Lg(ncOff+1:ncOff+ncLoc,:) = Ll(:,:)

return

end subroutine InsL

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FndBnd(IOut,IPrint,AlBond,ToAng,MxBond,
     +                  NAtoms,IAn,C,Nbond,IBond,
     +                  IBType,PBO,Re)
      Implicit Real*8(A-H,O-Z)
C
C     Generate connectivity based on bond distances alone.  The criteria
C     are contained in routine IPBO.
C     Cartesian coords. are in Angstroms
C
      Logical AlBond
C     Character AtSymb*2,AppNum*3
      Dimension IAn(NAtoms),C(3,NAtoms), NBond(NAtoms), Re(*),
     $  IBond(MxBond,NAtoms), IBType(MxBond,NAtoms), PBo(MxBond,NAtoms)
C     Data AtSymb, AppNum /'XX','XXX'/
 1000 Format(' Maximum number of bonds=',I3,' exceeded for atom',I4,'.')
C
      Len = MxBond * NAtoms
      Do 10 I = 1, 12
      Do 11 J = 1, NAtoms
        IBond(I,J) = 0
        IBType(I,J) = 0
  11  Continue
  10  Continue
      BondOr = DBLE(0)
      Do 100 I = 1, NAtoms
        NBond(I) = 0
        Do 90 J = 1, NAtoms
          If(J.eq.I) goto 90
          RIJ = Sqrt((C(1,I)-C(1,J))**2+(C(2,I)-C(2,J))**2+
     $               (C(3,I)-C(3,J))**2)
          IBondO = IPBO(ToAng,IAn(I),IAn(J),RIJ,BondOr)
          If(IBondO.gt.0.or.AlBond) then
            NBond(I) = NBond(I) + 1
            If(NBond(I).gt.MxBond) then
              Write(IOut,1000) MxBond, I
              Call Abend()
              endIf
            IBond(NBond(I),I) = J
            IBType(NBond(I),I) = IBondO
            PBO(NBond(I),I)=BondOr
            endIf
   90     Continue
  100   Continue
      Return
c Avoid unused argument warnings
      If (.False.) Then
        Call Unused_integer(IPrint)
        Call Unused_real_array(Re)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine abc_axes(cryst, coord, xyz, abc, Do_option, iReturn )

      ! this Subroutine performs a transformation of the main axes
      ! (magnetic, anisotropic etc.) from a xyz system in
      ! crystallographic "abc" system, and vice-versa;
      !    Do_option = 1 =>  transform from xyz to abc
      !    Do_option = 2 =>  transform from abc to xyz
      !    If Do_option has other value, abort
      !    coord(3)-- Cartesian coordinates of the main magnetic center

      Implicit None
      Integer, parameter          :: wp=SELECTED_REAL_KIND(p=15,r=307)
      Integer, intent(in)         :: Do_option
      Real(kind=8), intent(inout):: xyz(3,3), abc(3,3)
      Real(kind=8), intent(in)   :: cryst(6), coord(3)
      Integer, intent(out)        :: iReturn
      ! local variables:
      Integer       :: i
      Real(kind=8) :: a,b,c,al,bt,gm,cal,cbt,cgm,sal,sbt,sgm,v,pi,x,y,z
      Real(kind=8) :: xyz2(3,3),pX(3),pY(3),pZ(3)
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! initializations
      pi  = 3.1415926535897932384626433832795028841971693993751_wp
      a   = 0.0_wp
      b   = 0.0_wp
      c   = 0.0_wp
      al  = 0.0_wp
      bt  = 0.0_wp
      gm  = 0.0_wp
      cal = 0.0_wp
      cbt = 0.0_wp
      cgm = 0.0_wp
      sal = 0.0_wp
      sbt = 0.0_wp
      sgm = 0.0_wp
      X   = 0.0_wp
      Y   = 0.0_wp
      Z   = 0.0_wp
      pX  = 0.0_wp
      pY  = 0.0_wp
      pZ  = 0.0_wp
      xyz2= 0.0_wp
!
      a   = cryst(1)
      b   = cryst(2)
      c   = cryst(3)
      al  = cryst(4)*pi/180._wp
      bt  = cryst(5)*pi/180._wp
      gm  = cryst(6)*pi/180._wp
      cal = cos(al)
      cbt = cos(bt)
      cgm = cos(gm)
      sal = sin(al)
      sbt = sin(bt)
      sgm = sin(gm)

      v = sqrt(1.0_wp-cal*cal-cbt*cbt-cgm*cgm+2.0_wp*cal*cbt*cgm )

      If ( Do_option .eq. 1 ) Then
         abc=0.0_wp
         Do i=1,3
            xyz2(1,i) = 1.0_wp*xyz(1,i)+coord(1)
            xyz2(2,i) = 1.0_wp*xyz(2,i)+coord(2)
            xyz2(3,i) = 1.0_wp*xyz(3,i)+coord(3)
         End Do

         Do i=1,3
            X=xyz2(1,i)
            Y=xyz2(2,i)
            Z=xyz2(3,i)

            pX(1)= 1.0_wp/a
            pY(1)=-cgm/(a*sgm)
            pZ(1)=((cal*cgm-cbt)/(a*v*sgm))

            pX(2)= 0.0_wp
            pY(2)= 1.0_wp/(b*sgm)
            pZ(2)= (cbt*cgm-cal)/(b*v*sgm)

            pX(3)= 0.0_wp
            pY(3)= 0.0_wp
            pZ(3)= sgm/(c*v)

            abc(1,i) = pX(1)*X + pY(1)*Y + pZ(1)*Z
            abc(2,i) = pX(2)*X + pY(2)*Y + pZ(2)*Z
            abc(3,i) = pX(3)*X + pY(3)*Y + pZ(3)*Z
         End Do

      Else If (  Do_option .eq. 2 ) Then

         xyz=0.0_wp
         Do i=1,3
            X=abc(1,i)*a
            Y=abc(2,i)*b
            Z=abc(3,i)*c

            pX(1)= 1.0_wp
            pY(1)= cgm
            pZ(1)= cbt

            pX(2)= 0.0_wp
            pY(2)= sgm
            pZ(2)= (cal-cbt*cgm)/sgm

            pX(3)= 0.0_wp
            pY(3)= 0.0_wp
            pZ(3)= v/sgm

            xyz(1,i) = X+Y*cgm+Z*cbt
            xyz(2,i) =   Y*sgm+Z*((cal-cbt*cgm)/sgm)
            xyz(3,i) =         Z*v/sgm

            xyz(1,i) = pX(1)*X + pY(1)*Y + pZ(1)*Z
            xyz(2,i) = pX(2)*X + pY(2)*Y + pZ(2)*Z
            xyz(3,i) = pX(3)*X + pY(3)*Y + pZ(3)*Z
         End Do
      Else
         Write(6,'(A)') 'the Do_option is not specified. '
         Write(6,'(A)') 'the program continues without ABCC option'
         iReturn=1
         Go To 190
      End If

 190  continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module fmm_T_pair_tests

use fmm_global_paras, only: INTK, REALK, scheme_paras, gen_mm_paras, LHS_RHS_type, T_pair_single, box_mm_paras, DO_FQ, DO_BQ, &
                            DO_NlogN, DO_FMM, ZERO_DIST_TOL, NEAR_FIELD
use fmm_box_utils, only: fmm_NF_boxes, fmm_RFF_boxes
use fmm_utils, only: fmm_quit

implicit none
private
! Public procedures
public :: fmm_init_T_pair_tests, &
          fmm_close_T_pair_tests, &
          fmm_test_and_buffer_T_pair

! Flag to test initialisation
character(len=11), save :: init_tests

contains

!-------------------------------------------------------------------------------

subroutine fmm_init_T_pair_tests(scheme)

  implicit none
  type(scheme_paras), intent(in) :: scheme

  if (scheme%phase == NEAR_FIELD) then
    call fmm_store_test(fmm_test_NF_ext)
  else
    select case (scheme%algorithm)
      case (DO_FQ)
        call fmm_store_test(fmm_test_raw_FF)
      case (DO_BQ)
        call fmm_store_test(fmm_test_FF)
      case (DO_NlogN)
        call fmm_store_test(fmm_test_LFF)
      case (DO_FMM)
        call fmm_store_test(fmm_test_LFF)
      case default
        call fmm_quit('unable to initialise T_pair_tests')
    end select
  end if

  init_tests = 'initialised'

end subroutine fmm_init_T_pair_tests

!-------------------------------------------------------------------------------

subroutine fmm_close_T_pair_tests()

  implicit none
  if (init_tests /= 'initialised') call fmm_quit('must initialise pair_tests!')
  init_tests = ' '

end subroutine fmm_close_T_pair_tests

!-------------------------------------------------------------------------------
! routine to perform T-pair test on two raw or boxed moments, and if they
! pass the pair is sent for evaluation.

subroutine fmm_test_and_buffer_T_pair(LHS,RHS,id,weight)

  use fmm_T_buffer, only: fmm_add_to_T_buffer

  type(gen_mm_paras), intent(in) :: LHS, RHS
  type(LHS_RHS_type), intent(in) :: id
  integer(INTK), intent(in)      :: weight
  type(T_pair_single) :: T_pair
  logical, external :: fmm_included_pair
  external :: fmm_stored_t_pair_mould

  if (fmm_included_pair(LHS,RHS,id)) then
    ! pour all relevant info into the T-pair mould
    call fmm_stored_t_pair_mould(LHS,RHS,id,weight,T_pair)
    ! pass single T_pair entity to contractors via buffer
    call fmm_add_to_T_buffer(T_pair)
  end if

end subroutine fmm_test_and_buffer_T_pair

!-------------------------------------------------------------------------------
! fmm_test_pass is always TRUE, bypassing normal classical/nonclassical tests

function fmm_test_pass(LHS,RHS,id)

# include "macros.fh"

  implicit none
  type(gen_mm_paras), intent(in) :: LHS, RHS
  type(LHS_RHS_type), intent(in) :: id
  logical :: fmm_test_pass

  unused_var(LHS)
  unused_var(RHS)
  unused_var(id)

  fmm_test_pass = .true.

end function fmm_test_pass

!-------------------------------------------------------------------------------
! Logical function to test if two gaussian overlaps are separated by
! more than the sum of their extents.
! fmm_test_ext is TRUE if sufficiently well-separated.

function fmm_test_ext(LHS,RHS,id)

  implicit none
  type(gen_mm_paras), intent(in) :: LHS, RHS
  type(LHS_RHS_type), intent(in) :: id
  logical :: fmm_test_ext
  real(REALK) :: r_ij(3), ext_ij, r_mod, r_zero

  ext_ij = RHS%raw_paras(id%RHS)%ext+LHS%raw_paras(id%LHS)%ext
  r_ij = RHS%raw_paras(id%RHS)%cntr-LHS%raw_paras(id%LHS)%cntr
  r_mod = r_ij(1)*r_ij(1)+r_ij(2)*r_ij(2)+r_ij(3)*r_ij(3)
  ext_ij = ext_ij*ext_ij
  r_zero = ZERO_DIST_TOL*ZERO_DIST_TOL
  fmm_test_ext = ((r_mod-ext_ij) > r_zero)

end function fmm_test_ext

!-------------------------------------------------------------------------------
! Interaction pair test routine for near-field phase.
! An interaction should be treated by multipoles if in NF boxes and
! sufficiently well-separated.

function fmm_test_NF_ext(LHS,RHS,id)

  implicit none
  type(gen_mm_paras), intent(in) :: LHS, RHS
  type(LHS_RHS_type), intent(in) :: id
  logical :: fmm_test_NF_ext
  type(box_mm_paras) :: LHStmp, RHStmp

  LHStmp%box = LHS%raw_paras(id%LHS)%box
  RHStmp%box = RHS%raw_paras(id%RHS)%box
  LHStmp%bra = LHS%raw_paras(id%LHS)%bra
  RHStmp%bra = RHS%raw_paras(id%RHS)%bra
  LHStmp%level = 0
  RHStmp%level = 0

  fmm_test_NF_ext = fmm_NF_boxes(LHStmp,RHStmp) .and. fmm_test_ext(LHS,RHS,id)

end function fmm_test_NF_ext

!-------------------------------------------------------------------------------
! Logical function to test if two boxes are in each others "Far Field"
! based on separation.  Used in simple full quadratic (FQ) algorithm
! when we wish to compare unboxed moments (c.f. fmm_test_FF function)

function fmm_test_raw_FF(LHS,RHS,id)

  implicit none
  type(gen_mm_paras), intent(in) :: LHS, RHS
  type(LHS_RHS_type), intent(in) :: id
  logical :: fmm_test_raw_FF
  type(box_mm_paras) :: LHStmp, RHStmp

  LHStmp%box = LHS%raw_paras(id%LHS)%box
  RHStmp%box = RHS%raw_paras(id%RHS)%box
  LHStmp%bra = LHS%raw_paras(id%LHS)%bra
  RHStmp%bra = RHS%raw_paras(id%RHS)%bra
  LHStmp%level = 0
  RHStmp%level = 0

  fmm_test_raw_FF = .not. (fmm_NF_boxes(LHStmp,RHStmp))

end function fmm_test_raw_FF

!-------------------------------------------------------------------------------
! Logical function to test if two boxes are in each others "Far Field"
! based on separation.  Used by Boxed Quadratic (BQ) algorithm.

function fmm_test_FF(LHS,RHS,id)

  implicit none
  type(gen_mm_paras), intent(in) :: LHS, RHS
  type(LHS_RHS_type), intent(in) :: id
  logical :: fmm_test_FF

  fmm_test_FF = .not. (fmm_NF_boxes(LHS%box_paras(id%LHS),RHS%box_paras(id%RHS)))

end function fmm_test_FF

!-------------------------------------------------------------------------------
! Logical function to test if two boxes are in each others "Local Far Field"
! based on separation;  used by FMM and NlogN algorithms;
! note that in the NlogN scheme boxes are at different levels, but the
! definition of LFF is such that we can then translate the box at the
! deeper level to the higher level and apply the same criteria as for
! two boxes at the deeper level (assuming branches join at higher levels)
! FIXME: how about branch scheme where branches don't join at higher levels??

function fmm_test_LFF(LHS_in,RHS_in,id)

  use fmm_box_utils, only: fmm_translate_to_common_grid

  implicit none
  type(gen_mm_paras), intent(in) :: LHS_in, RHS_in
  type(LHS_RHS_type), intent(in) :: id
  logical :: fmm_test_LFF

  ! introduce these so we can translate to common grid if needed
  type(box_mm_paras) :: LHS, RHS

  LHS = LHS_in%box_paras(id%LHS)
  RHS = RHS_in%box_paras(id%RHS)
  if (LHS%level /= RHS%level) then
    ! All NF, LFF and RFF definitions are based on boxes in ONE grid.
    ! We must therefore translate the boxes into a common grid first.
    ! Of course, this can be avoided by passing the transformed paras.
    call fmm_translate_to_common_grid(LHS,RHS)
  end if

  fmm_test_LFF = .false.
  if (fmm_NF_boxes(LHS,RHS)) return
  if (fmm_RFF_boxes(LHS,RHS)) return
  fmm_test_LFF = .true.

end function fmm_test_LFF

!-------------------------------------------------------------------------------

end module fmm_T_pair_tests

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************

      subroutine barf(a)
      character*(*) a
      write(6,*) a
      call abend
      end


cmp      SUBROUTINE T3AMPL_BTI(W,OEH,OEP)
      SUBROUTINE T3AMPL_BTI(OEH,OEP)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C    *** PROGRAM TRIPLY-UHF/RHF - REDUCED DIMENSION and timing - DRIVER
C
C    CALCULATION OF TRIPLE EXCITATION CONTRIBUTION TO
C    THE 4TH ORDER CORRELATION ENERGY OF MB RSPT AND CC-TRIPLES
C
C    Provides T3AMPL_BLOCKEDIMPROVED:  Accelerated algorithm.
c
c     Combines triply w/ trick by JN and limited I/Os by buffered
c     blocking scheme by PV. Blocks the virtual space to pieces
c     optimal either for parallelization or in using the available
c     memory
c     Involves also more robust and more reliable memory allocator.
c
c History
c     Buffered blocking scheme: PV, LAOG Grenoble, 16 april 2003.
c     First version w/ trick: JN, June 12, 2003
c     Parallel version: PV, 15 oct 2003.
c     Implemented integer offsets, PV, 14 may 2004.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      implicit none
      integer IUHF,LU(6)
      integer i,nuga,nugc,nga,ngb,ngc,vblock, it1
      integer NOAB,NNOAB,NUAB,NNUAB,iopt,iout,isp,krem
      real*8 OEH(*),OEP(*),ddot_,ccsdt,ccsdt4,energ(4),tccsd,
     $     ENSCF, RESULT,times(10),
     $     times_parr(10), totcpu, totwal, timerel
c     real*8 cpu0,cpu1,wall0,wall1
      character ICH*1, FN*6
      logical ifvo
      integer IHW
      common /hermit_addr/ IHW
      integer la,t1a,t1b
        logical lastcall,scored
      integer IT,ITLAST,NBF,NOMX,NU,MX2,NNO,NNU,NUO,NSO
cmp
c       integer maxspace
        integer nla,nlb
        real*8 enx1
cmp
      COMMON/PARAM/IT,ITLAST,NBF,NOMX,NU,MX2,NNO,NNU,NUO,NSO
      COMMON/IOIND/IOPT(96)
      COMMON/ENERGY/ENSCF, RESULT(102,5)
      COMMON/UHF/NOAB(2),NNOAB(3),NUAB(2),NNUAB(3),ICH(3)
      LOGICAL    RRT1,CSDAT,ORTHO,DETAIL
      COMMON/WHAT1/RRT1,CSDAT,ORTHO,DETAIL
cmp
#include "cht3_casy.fh"
#include "WrkSpc.fh"
cmp
#include "ndisk.fh"
#include "dupfiles.fh"
cmp!      include 'task_info_inc'
cmp!      include 'ws_conn_inc'
cmp
#include "para_info.fh"
#include "cht3_ccsd1.fh"
#ifdef _MOLCAS_MPP_
#include "mafdecls.fh"
#endif
!???#ifdef _MOLCAS_MPP_
!???      integer mytype, krems(nhmx)
!???#endif
cmp!!      integer me, err, len_trim
!?      integer nprocs0
!?cmp      common /my_mpi_world_com/ me, nprocs
      integer LENPAR
      common/LENPAR_com/LENPAR
c
        integer itmp
        integer imy_tsk
        integer id,j
        logical rsv_tsk
        external rsv_tsk
c
        real*8 e_ccsd, e_scf
        real*8 cpu0_aaa,wall0_aaa,cpu0_aab,wall0_aab
c
!?      nprocs0=nprocs
c Uncomment the following to force sequential mode
!      nprocs=1

      IOUT=IOPT(14)

      if (nprocs.gt.1) then
         write(6,'(A,i4,A)') ' Parallel run on ',nprocs,' nodes'
      else
         write(6,'(A,i4,A)') ' Serial run'
      endif
      call xflush(6)
c
C t^ijk_abc . D^abc_ijk =
C
C alpha-alpha-alpha (K_ab^ir+K_ab^jr-K_ac^kr)*(L_rc^jk+L_rc^ki+L_rc^ij)
C or beta-beta-beta   + permutations bca, acb
C        - M_abc^iki -M_abc^iij -M_abc^jjk+M_abc^jij-M_abc^kki+M_abc^kjk
C         + permutations bca cab
C
C        where    M_abc^ijk=K_ab^ir*L_ra^jk
C
C  strategy:   blocks the number of virtuals to pieces by ng
C              then everything in the memory!
c
c free everything from W(1) including Hermit space
c (PV) done for slaves in calling routine slave_T3AMPL_BTI
c
C parallelization: distribute common UHF
c (PV) done for slaves in calling routine slave_T3AMPL_BTI
c
cmp!!      call gettim(cpu0,wall0)

      do I=1,6
         LU(I)=90+I
      enddo

      call zeroma(times,1,10)
      call zeroma(energ,1,4)
      IHW=0

c
C calculate the T2-T3 contraction?  ifvo is the answer ! open-shell stuff !
cmp         call get3dm('FOC-VO',w,noab(1)*nuab(1)+noab(2)*nuab(2),1,0)
cmp         ifvo=(ddot_(noab(1)*nuab(1)+noab(2)*nuab(2),w,1,w,1).gt.1d-14)
        ifvo=.false.

C
C parallelization:  do this on each host >>>>>>> start
C
C allocates for two arrays of the size T1

        it1=NUAB(1)*NOAB(1)+NUAB(2)*NOAB(2)

        call GetMem('t3_ampl_t1a','Allo','Real',t1a,it1)
        call GetMem('t3_ampl_t1b','Allo','Real',t1b,it1)

        call zeroma(Work(t1a),1,it1)
        call zeroma(Work(t1b),1,it1)

         call GetMem('t3_ampl_t1','Allo','Real',itmp,
     & noab(1)*nuab(1))
         call GetMem('t3_ampl_la','Allo','Real',la,it1)

cmp!    read t1 amplitudes
        if (printkey.ge.10) then
           write (6,*) 'Reading ',it1,' t1_alpha, t1_beta amplitudes'
        end if
         call GetRest_t3 (Work(la),Work(itmp),e_ccsd)
c
cmp!         write (6,*) 'Ze t1 = ',
cmp!     & ddot_(it1,Work(la),1,Work(la),1)
c
C t1a and t1b always remain in the memory -- small fields
c
c parallelization:   on each host <<<<<<< end  - block done
c

C Remaining space can be used for the blocking in-core algorithms

        Call GetMem('t3_ampl_la','Max','Real',krem,krem)

        if (printkey.ge.10) then
           write(6,*)
           write(6,*) 'Available Memory before v_size_t3 = ', krem
           call xflush(6)
        end if
C
C determines the virtual block size
C vblock - the virtual orbitals block size
C look for optimal number with respect nprocs to v_size_t3
C
        write (6,*)
        write(6,'(2x,A)')
     &             'Starting triply with blocked virtuals algorithm'
        if (nprocs.gt.1) then
           write (6,*) ' Node Number ',MyRank
        end if
c
c Compute memory pattern.
c
        call v_size_t3(vblock,nprocs,krem,printkey)

        IUHF=1 ! open-shell stuff
        IF(IOPT(76).EQ.0)IUHF=0

        if (printkey.ge.10) then
           write (6,'(A,i1)') ' Closed-Shell calculation, IUHF = ',iuhf
        end if
c
C  create K(beta-alpha,beta-alpha) and L(alpha-beta,beta-alpha)
        ndup=0 !?????

cmp - print information on number of steps in loopa and loopb
c
        call check_loops(nuab(1),vblock,nla,nlb)
        write (6,*)
        write (6,'(A,i6)') 'Number of steps in loopa : ',nla
        write (6,'(A,i6)') 'Number of steps in loopb : ',nlb
c
c checking :
c
        if (t3_stopa.gt.nla) then
          write (6,*) 'Too many steps in t3_loopa requested in input'
          write (6,*) 'T3_LOOPA from input : ',
     & t3_starta,t3_stopa,t3_stopa-t3_startb+1
          write (6,*) 'total T3_LOOPA steps : ',nla
          call abend()
        end if
c
        if (t3_stopb.gt.nlb) then
          write (6,*) 'Too many steps in t3_loopb requested in input'
          write (6,*) 'T3_LOOPB from input : ',
     & t3_startb,t3_stopb,t3_stopb-t3_startb+1
          write (6,*) 'total T3_LOOPB steps : ',nlb
          call abend()
        end if
c
cmp
         if (gen_files) then
c
             write (6,*)
             write (6,*) 'Creating KMAT, LMAT Scratch Integral Files'//
     & '-----------------------------'
             write (6,*)
cmp
             call create_klvab_t3(vblock)
cmp
        Call CWTime(TCpu,TWall)
c
        if (printkey.gt.1) then
        write (6,*)
        write (6,'(A,f18.1)') ' Cpu last call [s] = ',
     & TCpu-TCpu_l
        write (6,'(A,f18.1)') 'Wall last call [s] = ',
     & TWall-TWall_l
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if

        TCpu_l=TCpu
        TWall_l=TWall

cmp

             write (6,*) 'Create of Integrals done',
     & '-------------------------------------------------'
             write (6,*)
cmp
c
         else
             write (6,*)
             write (6,*) 'Skipping KMAT, LMAT scratch integral',
     & ' files generation as requested'
         end if
cmp
        cpu0_aaa=TCpu
        wall0_aaa=TWall
c
        if (.not.run_triples) then
        write (6,*)
        write (6,*) 'Exiting triples after scratch integral',
     & ' files generation as requested'
        return
        !? call abend()
        end if
cmp

C  creates K(alpha-alpha,alpha-alpha) (dummy for closed shell)
C  (master only)
cmp!
cmp!  open-shell stuff
cmp!
cmp!         if(iuhf.ne.0)then
cmp!            DO isp=1,1+iuhf
cmp!               call create_klvaa_t3(w(la),vblock,isp)
cmp!            enddo
cmp!         endif

C
C parallelization: files KMATxy LMATxy x=A,B  y=A,B (BA - closed shell)
C                  generated on each host

c Sorting and initialization timing

cmp!      call gettim(cpu1,wall1)  !  prerob na poriadne timingy
      Call CWTime(TCpu,TWall)
      times(9)=times(9)+TCpu-TCpu0
      times(10)=times(10)+TWall-TWall0

      DO isp=1,1+iuhf

         nuga=nuab(isp)/vblock
         if((nuga*vblock).lt.nuab(isp))nuga=nuga+1
         nugc=nuab(3-isp)/vblock
         if((nugc*vblock).lt.nuab(3-isp))nugc=nugc+1
C  creates K(alpha-alpha,alpha-alpha) (dummy for closed shell)
c!         if(iuhf.ne.0)then   ! open-shell stuff.
c!            call create_klvaa_t3(w(la),vblock,isp)
c!         endif
         FN(5:5)=ich(isp)
         FN(6:6)=ich(isp)
         FN(1:4)='KMAT'
         call multi_opendir(FN,LU(1))
         FN(1:4)='LMAT'
         call multi_opendir(FN,LU(2))
C
C parallelization: files KMATxx LMATxx are assumed to be available
C to all tasks on each host
C
C                  not for closed shell
C     alpha-alpha-alpha   or closed shell
c
c - skip t3loopa if needed
c
        if ((t3_starta.lt.0).and.(t3_startb.gt.0)) then
          write (6,*)
          write (6,*) 'Skipping t3loopa on user request '
          write (6,*)
          goto 494
        end if
c
         i=0
         do nga=1,nuga
         do ngb=1,nga
         do ngc=1,ngb
         i=i+1
         end do
         end do
         end do
c
        if (t3_starta.lt.0) then
           call GetMem ('Imy_tsk','Allo','Inte',imy_tsk,
     &                  3*i)
        else
           call GetMem ('Imy_tsk','Allo','Inte',imy_tsk,
     &                  (t3_stopa-t3_starta+1)*3)
        end if
c
        if (t3_starta.lt.0) then
         i=0
         do nga=1,nuga
          do ngb=1,nga
           do ngc=1,ngb
              i=i+1
              iWork(imy_tsk-3+3*i)=nga
              iWork(imy_tsk-3+3*i+1)=ngb
              iWork(imy_tsk-3+3*i+2)=ngc
           end do
          end do
         end do
        else
         i=0
         do nga=1,nuga
          do ngb=1,nga
           do ngc=1,ngb
              i=i+1
c
              if ((i.ge.t3_starta).and.(i.le.t3_stopa)) then
                 iWork(imy_tsk-3+3*(i-t3_starta+1))=nga
                 iWork(imy_tsk-3+3*(i-t3_starta+1)+1)=ngb
                 iWork(imy_tsk-3+3*(i-t3_starta+1)+2)=ngc
              end if
c
         end do
         end do
         end do
        end if
c
        if (t3_starta.gt.0) then ! for correct deallocation
            i=t3_stopa-t3_starta+1
        end if
c
        write (6,*)
        write (6,*) '# of tasks to be parallelized in t3loop a = ',i
        id=666
        lastcall=.false.
        scored=.false.
        call init_tsk(id,i)
98      if (.not. rsv_tsk(id,j)) goto 99
c
        nga=iWork(imy_tsk-3+3*j)
        ngb=iWork(imy_tsk-3+3*j+1)
        ngc=iWork(imy_tsk-3+3*j+2)
c
cmp
cmp        Call GetMem('(T)','Max','Real',maxspace,maxspace)
cmp        write (*,*) 'maxspace before ',maxspace
cmp
        call t3loopa(
     $               oeh(noab(1)*(isp-1)+1),
     $               oep(nuab(1)*(isp-1)+1),
     $               Work(t1a+noab(1)*nuab(1)*(isp-1)),
     $               Work(t1b+noab(1)*nuab(1)*(isp-1)),
     $               nga,ngb,ngc,vblock,energ,isp,LU,ifvo,
     &               lastcall,scored,j,enx1)
cmp
c update 5th order terms
c

cmp      call vadd(Work(t1a),1,Work(t1a+noab(1)*nuab(1)),1,
cmp     $Work(t1a),1,noab(1)*nuab(1))

        call daxpy_((noab(1)*nuab(1)), 1.0d0,
     & Work(t1a+noab(1)*nuab(1)), 1,
     & Work(t1a), 1)
        ccsdt=2.d0*ddot_(noab(1)*nuab(1),Work(la),1,Work(t1a),1)
        call daxpy_((noab(1)*nuab(1)), -1.0d0,
     & Work(t1a+noab(1)*nuab(1)), 1,
     & Work(t1a), 1)
c
cmp
        Call CWTime(TCpu,TWall)
cmp
         if (t3_starta.lt.0) then
        write (6,'(A,i5,1x,3(i3,1x),2(f21.19,1x),2(f8.1,A,1x))')
     & 'Tsk, nga, ngb, ngc, inc = ',
     & j,
     & nga,ngb,ngc,2.0d0*enx1,ccsdt,
     & TCpu-TCpu_l,' CPU [s]',TWall-TWall_l,' Wall [s]'
         else
        write (6,'(A,i5,1x,3(i3,1x),2(f21.19,1x),2(f8.1,A,1x))')
     & 'Tsk, nga, ngb, ngc, inc = ',
     & j+t3_starta-1,
     & nga,ngb,ngc,2.0d0*enx1,ccsdt,
     & TCpu-TCpu_l,' CPU [s]',TWall-TWall_l,' Wall [s]'
         end if

         TCpu_l=TCpu
         TWall_l=TWall
cmp
cmp        Call GetMem('(T)','Max','Real',maxspace,maxspace)
cmp        write (*,*) 'maxspace after ',maxspace
cmp
c
        goto 98
99      continue
        write (6,*) 't3loopa finished'
        write (6,*)
        Call Free_tsk(id)
        call GetMem ('Imy_tsk','Free','Inte',imy_tsk,3*i)
c
cmp!         call gettim(cpu1,wall1)            ! dorob timingy !!!!!!
         Call CWTime(TCpu,TWall)
         times(isp)=times(isp)+TCpu-cpu0_aaa
         times(isp+4)=times(isp+4)+TWall-wall0_aaa

         write(6,'(1X,5A,D12.4,A,D12.4,A)')
     $        'Spin case ',ich(isp),ich(isp),ich(isp),' done:',
     $        (TCpu-cpu0_aaa),' CPU [s]',
     &        (TWall-wall0_aaa),' Wall [s]'
         call xflush(6)
cmp
        Call CWTime(TCpu,TWall)
c
        if (printkey.gt.1) then
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if

        TCpu_l=TCpu
        TWall_l=TWall
cmp

494        continue

cmp
        cpu0_aab=TCpu
        wall0_aab=TWall
cmp

        if ((t3_starta.gt.0).and.(t3_startb.lt.0)) then
          write (6,*)
          write (6,*) 'Skipping t3loopb on user request '
          write (6,*)
          goto 495
        end if
c

C     alpha-alpha-beta or beta-beta-alpha only UHF
         !!if(IUHF.ne.0)then
cmp!!            call gettim(cpu0,wall0)
            FN(5:5)=ich(3-isp)
            FN(6:6)=ich(isp)
            FN(1:4)='KMAT'
            call multi_opendir(FN,LU(3))
            FN(1:4)='LMAT'
            call multi_opendir(FN,LU(5))

            IF(IUHF.NE.0)THEN ! open-shell stuff
              FN(5:5)=ich(isp)
              FN(6:6)=ich(3-isp)
              FN(1:4)='KMAT'
              call multi_opendir(FN,LU(4))
              FN(1:4)='LMAT'
              call multi_opendir(FN,LU(6))
            ELSE
              LU(4)=LU(3)
              LU(6)=LU(5)
            ENDIF

cmp
         i=0
         do nga=1,nuga
         do ngb=1,nga
         do ngc=1,nugc
         i=i+1
         end do
         end do
         end do
c
        if (t3_startb.lt.0) then
        call GetMem ('Imy_tsk','Allo','Inte',imy_tsk,3*i)
        else
        call GetMem ('Imy_tsk','Allo','Inte',imy_tsk,
     & (t3_stopb-t3_startb+1)*3)
        end if
c
         i=0
         if (t3_startb.lt.0) then
          do nga=1,nuga
           do ngb=1,nga
            do ngc=1,nugc
               i=i+1
               iWork(imy_tsk-3+3*i)=nga
               iWork(imy_tsk-3+3*i+1)=ngb
               iWork(imy_tsk-3+3*i+2)=ngc
            end do
           end do
          end do
         else
          do nga=1,nuga
           do ngb=1,nga
            do ngc=1,nugc
               i=i+1
               if ((i.ge.t3_startb).and.(i.le.t3_stopb)) then
                  iWork(imy_tsk-3+3*(i-t3_startb+1))=nga
                  iWork(imy_tsk-3+3*(i-t3_startb+1)+1)=ngb
                  iWork(imy_tsk-3+3*(i-t3_startb+1)+2)=ngc
               end if
            end do
           end do
          end do
         end if
c
        if (t3_startb.gt.0) then
         i=t3_stopb-t3_startb+1
        end if
c
        write (6,*)
        write (6,*) '# of tasks to be parallelized in t3loopb = ',i
        id=667
        lastcall=.false.
        scored=.false.
        call init_tsk(id,i)
198      if (.not. rsv_tsk(id,j)) goto 199
c
        nga=iWork(imy_tsk-3+3*j)
        ngb=iWork(imy_tsk-3+3*j+1)
        ngc=iWork(imy_tsk-3+3*j+2)
cmp        write (6,'(A,4(i5,2x))') 'Tsk, nga, ngb, ngc = ',j,nga,ngb,ngc
c
cmp
cmp        Call GetMem('(T)','Max','Real',maxspace,maxspace)
cmp        write (*,*) 'maxspace before ',maxspace
cmp
        call t3loopb(oeh,oep,Work(t1a),Work(t1b),
     $                 nga,ngb,ngc,vblock,energ(3),isp,LU,ifvo,
     &                 lastcall,scored,j,enx1)
c
cmp???      call vadd(Work(t1a),1,Work(t1a+noab(1)*nuab(1)),1,
cmp???     $Work(t1a),1,noab(1)*nuab(1))
        call daxpy_((noab(1)*nuab(1)), 1.0d0,
     & Work(t1a+noab(1)*nuab(1)), 1,
     & Work(t1a), 1)
        ccsdt=2.d0*ddot_(noab(1)*nuab(1),Work(la),1,Work(t1a),1)
        call daxpy_((noab(1)*nuab(1)), -1.0d0,
     & Work(t1a+noab(1)*nuab(1)), 1,
     & Work(t1a), 1)
c
cmp
        Call CWTime(TCpu,TWall)
cmp
         if (t3_startb.lt.0) then
        write (6,'(A,i5,1x,3(i3,1x),2(f21.19,1x),2(f8.1,A,1x))')
     & 'Tsk, nga, ngb, ngc, inc = ',
     & j,
     & nga,ngb,ngc,2.0d0*enx1,ccsdt,
     & TCpu-TCpu_l,' CPU [s]',TWall-TWall_l,' Wall [s]'
         else
        write (6,'(A,i5,1x,3(i3,1x),2(f21.19,1x),2(f8.1,A,1x))')
     & 'Tsk, nga, ngb, ngc, inc = ',
     & j+t3_startb-1,
     & nga,ngb,ngc,2.0d0*enx1,ccsdt,
     & TCpu-TCpu_l,' CPU [s]',TWall-TWall_l,' Wall [s]'
         end if

         TCpu_l=TCpu
         TWall_l=TWall
c
cmp
cmp        Call GetMem('(T)','Max','Real',maxspace,maxspace)
cmp        write (*,*) 'maxspace before ',maxspace
cmp
c
        goto 198
199      continue
        write (6,*) 't3loopb finished'
        write (6,*)
        Call Free_tsk(id)
        call GetMem ('Imy_tsk','Free','Inte',imy_tsk,3*i)
cmp        write (6,*) ' energ = ',energ
cmp
c - deallocate arrays in t3loopb
c
cmp!            call gettim(cpu1,wall1)  ! urob poriadne timingy !!!!
            Call CWTime(TCpu,TWall)
            times(2+isp)=times(2+isp)+TCpu-cpu0_aab
            times(6+isp)=times(6+isp)+TWall-wall0_aab
            write(6,'(1X,5A,D12.4,A,D12.4,A)')
     $           'Spin case ',ich(isp),ich(isp),ich(3-isp),' done:',
     $           (TCpu-cpu0_aab),' CPU [s]',
     &           (TWall-wall0_aab),' Wall [s]'
            call xflush(6)
            do i=3,6
               close(LU(i))
            enddo
         !!endif   !! IUHF
         close (LU(1))
         close (LU(2))
      enddo                     ! isp
cmp!!      call gettim(cpu0,wall0) ! urob timingy!
cmp
        Call CWTime(TCpu,TWall)
c
        if (printkey.gt.1) then
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if
        TCpu_l=TCpu
        TWall_l=TWall
cmp

495        continue

        do i=1,10
           times_parr(i)=times(i)
        end do

#ifdef _MOLCAS_MPP_

        it1=NUAB(1)*NOAB(1)+NUAB(2)*NOAB(2)
        block
            real*8 :: real_buffer(1)
            real_buffer(1) = ccsdt
            call gadgop (real_buffer, size(real_buffer), '+')
            ccsdt = real_buffer(1)
        end block
        call gadgop (energ,4,'+')
        call gadgop (times_parr,10,'+')
c
#endif

      call xflush(6)

c Add MPI_Reduce contribution to sorting timing
cmp!cmp!      call gettim(cpu1,wall1)
cmp!      Call CWTime(TCpu,TWall)
cmp!      times(9)=times(9)+TCpu-TCpu0
cmp!      times(10)=times(10)+TWall-TWall0

C
C   T(CCSD)
C
      IF(IUHF.EQ.0)then
      energ(2)=energ(1)
      energ(4)=energ(3)
      endif
      tccsd=energ(1)+energ(2)+energ(3)+energ(4)

cmp!      IF(IUHF.EQ.0)then ! open-shell stuff
cmp!      call vadd(Work(t1a),1,Work(t1a+noab(1)*nuab(1)),1,
cmp!     $Work(t1a),1,noab(1)*nuab(1))
cmp!      ccsdt=2.d0*ddot_(noab(1)*nuab(1),Work(la),1,Work(t1a),1)
cmp!       else
cmp!      ccsdt=ddot_(noab(1)*nuab(1)+noab(2)*nuab(2),Work(la),1,Work(t1a),1)
cmp!        write (*,*) 'ze co do ... ?'
cmp!        stop
cmp!        endif

cmp! for MOLCAS verify
        Call Get_dScalar('SCF energy',e_scf)
        Call Add_Info('CHT3ene', tccsd + ccsdt, 1, 6)
        Call Add_Info('E_CHT3', tccsd + ccsdt, 1, 6)
        Call Add_Info('E_HYPE', e_scf + e_ccsd + tccsd + ccsdt, 1, 6)
c    for NUMERICAL_GRADIENTS
        Call Put_cArray('Relax Method','CHT3    ',8)
        Call Store_Energies(1,tccsd+ccsdt+e_ccsd+e_scf,1)
cmp!

c Slaves have finished here...
      if (MyRank.ne.0) then
         return
      endif
        if (printkey.gt.1) then
        write (6,*)
        write (6,*) '--------------------------------------------------'
        write (6,*)
        write (6,*) 'GADGOPed energ & ccsdt values: '
        write (6,*)
        write (6,'(A,4(f15.12,1x))') 'energ (t2-w-t3 = 2*e1 + 2*e3) ',
     & energ
        write (6,*)
        write (6,'(A,f15.12)')      'Sum                           ',
     & 2.0d0*energ(1)+2.0d0*energ(3)
        write (6,'(A,f15.12)')      'ccsdt (e5th ord. ST)          ',
     & ccsdt
        write (6,*)
        write (6,*) '--------------------------------------------------'
        end if


c Contents of times array:
c
c                  CPU      WALL
c     sorting
c     aaa           1        4
c     bbb           2        6
c     aab           3        7
c     bba           4        8
c
c Master has only to sum up the results
      do i=1,10
         times(i)=times(i)/60.d0 ! now in minutes
      enddo
      if (nprocs.gt.1) then
         do i=1,10
            times_parr(i)=times_parr(i)/60.d0
         enddo
      endif

      ccsdt4=0.d0
      if(ifvo)then
        write (6,*) 'ifvo correspond to open-shell system. Exiting'
        call abend()

cmp!         call get3dm('FOC-VO',w(la),noab(1)*nuab(1)+noab(2)*nuab(2),1,0)
cmp!         call transm(w(la),w(t1a),nuab(1),noab(1))
cmp!         call transm(w(noab(1)*nuab(1)+la),
cmp!     $        w(noab(1)*nuab(1)+t1a),nuab(2),noab(2))
c  E4 T2FT3
cmp!      IF(IUHF.EQ.0)then
cmp!      call vadd(w(t1b),1,w(t1b+noab(1)*nuab(1)),1,
cmp!     $w(t1b),1,noab(1)*nuab(1))
cmp!         ccsdt4=2.0*ddot_(noab(1)*nuab(1),w(t1a),1,w(t1b),1)
cmp!      else
cmp!         ccsdt4=ddot_(noab(1)*nuab(1)+noab(2)*nuab(2),w(t1a),1,w(t1b),1)
cmp!      endif
      endif

      RESULT(IT+3,5)=ccsdt4+ccsdt
      IF(IT.EQ.0)THEN
         RESULT(IT+1,5)=tccsd+ccsdt4+ccsdt
         if(ifvo)then
            WRITE(6,9993)TCCSD
            WRITE(6,9991)ccsdt4
            WRITE(6,9990)ccsdt
         endif
         WRITE(6,9994)TCCSD+ccsdt+ccsdt4
      ELSE
         RESULT(IT+2,5)=TCCSD
         WRITE(6,9993)TCCSD
         if(ifvo)then
            WRITE(6,9991)ccsdt4
            WRITE(6,9990)ccsdt
            WRITE(6,9995)CCSDT+ccsdt4
         else
            WRITE(6,9995)CCSDT
         endif
      ENDIF

        write (6,*) '*************************************************'
        write (6,*)
        write (6,*) 'Final Results : '
        write (6,*)
        write (6,'(A,f15.12)') '   (T)     corr. = ',tccsd + ccsdt
        write (6,'(A,f15.12)') '   CCSD(T) corr. = ',
     &                               e_ccsd + tccsd + ccsdt
        write (6,*)
        write (6,*) '*************************************************'
        write (6,*)

c Timing
      if (nprocs.gt.1) write(6,*) 'Master timings:'
      if (times(10).le.0.0d0) then
         timerel=1.0d0
      else
         timerel=times(9)/times(10)
      end if
      write(6,'(1x,a,2f13.3,a,f6.3)')'sorting cpu & wall',
     $     times(9),times(10),' (min);   cpu/wall=',timerel
      if (times(5).le.0.0d0) then
         timerel=1.0d0
      else
         timerel=times(1)/times(5)
      end if
      write(6,'(1x,a,2f13.3,a,f6.3)')'aaa     cpu & wall',
     $     times(1),times(5),' (min);   cpu/wall=',timerel
      if (times(6).le.0.0d0) then
         timerel=1.0d0
      else
         timerel=times(2)/times(6)
      end if
      IF(IUHF.NE.0)
     $write(6,'(1x,a,2f13.3,a,f6.3)')'bbb     cpu & wall',
     $     times(2),times(6),' (min);   cpu/wall=',timerel
      if (times(7).le.0.0d0) then
         timerel=1.0d0
      else
         timerel=times(3)/times(7)
      end if
      write(6,'(1x,a,2f13.3,a,f6.3)')'aab     cpu & wall',
     $     times(3),times(7),' (min);   cpu/wall=',timerel
      if (times(8).le.0.0d0) then
         timerel=1.0d0
      else
         timerel=times(4)/times(8)
      end if
      IF(IUHF.NE.0)
     $write(6,'(1x,a,2f13.3,a,f6.3)')'bba     cpu & wall',
     $     times(4),times(8),' (min);   cpu/wall=',timerel
      totcpu=times(9)
      totwal=times(10)
      do i=1,4
         totcpu=totcpu+times(i)
         totwal=totwal+times(4+i)
      enddo
      if (totwal.le.0.0d0) then
         timerel=1.0d0
      else
         timerel=totcpu/totwal
      end if
      write(6,'(1x,a,2f13.3,a,f6.3)') 'total   cpu & wall',
     $     totcpu,totwal,' (min);   cpu/wall=',timerel
      if (nprocs.le.1) goto 2000

c Parallel timing
      totcpu=times_parr(9)
      totwal=times_parr(10)
      times(9)=times_parr(9)
      do i=1,4
         totcpu=totcpu+times_parr(i)
         totwal=totwal+times_parr(4+i)
      enddo
      if (totwal.le.0.0d0) then
         timerel=1.0d0
      else
         timerel=totcpu/totwal
      end if
      write(6,*)
      write(6,*) 'Aggregate parallel timings:'
      write(6,'(1x,a,2f13.3,a,f6.3)') 'total   cpu & wall',
     $     totcpu,totwal,' (min);   cpu/wall=',timerel

c Return
 2000         continue
cmp        call w_debug(.false.,.false.,'Triply done')
!?      nprocs=nprocs0

        call GetMem('t3_ampl_la','Free','Real',la,
     & NUAB(1)*NOAB(1)+NUAB(2)*NOAB(2))
        call GetMem('t3_ampl_t1','Free','Real',itmp,
     & noab(1)*nuab(1))
        call GetMem('t3_ampl_t1a','Free','Real',t1a,it1)
        call GetMem('t3_ampl_t1b','Free','Real',t1b,it1)
      return

 9993 FORMAT(/1X,'T2-W-T3 contribution from current amplitudes ',D18.10)
 9991 FORMAT(1X,'T2-F-T3 contribution from current amplitudes ',D18.10)
 9990 FORMAT(1X,'T1-W-T3 contribution from current amplitudes ',D18.10)
 9994 FORMAT (/1X,'4th order MBPT tripleexcitation contribution '
     $     ,D18.10)
 9995 FORMAT(/1X,'5th order noniterative E[5] ST correction '
     $     ,D18.10/)
c9997 FORMAT(/1X,'Total ST correction with ROHF reference '
c    $     ,D18.10/)
      end
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine AppDerCpl(natom,nST,ChgNuc,Prop,DerCpl,HAM)
      Implicit Real*8(A-H,O-Z)
*
*     Approximate derivative couplings:         <\Psi_I|\nabla H|\Psi_J>
*                                        f_IJ =  ----------------------
*                                                     E_J - E_I
*
*     If the wfn are real-valued: f_II = 0 ; f_JI = - f_IJ -> lower triangular storage
*
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='AppDerCpl')
#include "rassi.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "real.fh"
      Dimension ChgNuc(natom),Prop(nState,nState,NProp),
     &          DerCpl(nST,3,natom),Ham(Nstate,Nstate)
      Character*3 Label
      Save Label
      Data Label/'EF1'/
*
*
      nST = nState*(nState+1)/2
      Call FZero(DerCpl,3*natom*nST)
      Do iSta = 1, nState-1
         Ei = Ham(iSta,iSta)
         Do jSta = iSta + 1, nState
            Ej = Ham(jSta,jSta)
            iST = iSta * (jSta -1) / 2 + jSta
            Write(6,1000) iSta, jSta, Ej-Ei
            Do kProp = 1, nProp
               If (PName(kProp)(1:3) .eq. Label) Then
                  Read(PName(kProp)(5:8),'(i4)') lAt
                  DerCpl(iST,IComp(kProp),lAt) =
     &                         Prop(iSta,jSta,kProp)*ChgNuc(lAt)/(Ej-Ei)
               End If
            End Do
            SumX = Zero
            SumY = Zero
            SumZ = Zero
            Do lAt = 1, natom
               Write(6,1100) lAt,(DerCpl(iST,kXYZ,lAt),kXYZ=1,3)
               SumX = SumX + DerCpl(iST,1,lAt)
               SumY = SumY + DerCpl(iST,2,lAt)
               SumZ = SumZ + DerCpl(iST,3,lAt)
            End Do
            If(IPGLOB .ge. DEBUG) Write(6,1200) SumX,SumY,SumZ
         End Do
      End Do
1000  Format(/,' Approximate derivative couplings for states ',2i3,/,
     &       ' Energy difference = ',F15.8,/,
     &       '   Atom          X              Y              Z')
1100  Format(i7,3f15.8)
1200  Format('   Sum:',3f15.8)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1987, Jeppe Olsen                                      *
*               1989, Markus P. Fuelscher                              *
************************************************************************
      SUBROUTINE ORDSTR(IINST,IOUTST,NELMNT,ISIGN,IPRINT)
C
C     AUTHOR:        J. OLSEN, UNIV. OF LUND, SWEDEN, APRIL 1987
C     MODIFICATIONS: INCLUSION INTO THE RASSCF METHOD
C                    M.P. FUELSCHER, UNIV. OF LUND, SWEDEN, MAY 1989
C
C     PURPOSE:
C
C     ORDER A STRING OF INTEGERS TO ASCENDING ORDER
C     IINST : INPUT STRING IS IINST
C     IOUTST : OUTPUT STRING IS IOUTST
C     NELMNT : NUMBER OF INTEGERS IN STRING
C     ISIGN :  SIGN OF PERMUTATION : + 1 : EVEN PERMUTATIONN
C                                    - 1 : ODD  PERMUTATION
C
C     SUBROUTINE CALLS:
C
C     ICOPY,IWRTMA
C
C
C     THIS CODE CONTAINS THE OLD ORDER CODE OF JOE GOLAB
C     ( HE IS HEREBY AKNOWLEDGED , AND I AM EXCUSED )
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IINST(NELMNT),IOUTST(NELMNT)
      INTEGER SWAP
C
      IF (NELMNT.EQ.0) RETURN
C
      CALL ICOPY(NELMNT,IINST,1,IOUTST,1)
      ISIGN = 1
C
C       BEGIN TO ORDER
C
        JOE = 1
10      I = JOE
20      CONTINUE
        IF(I.EQ.NELMNT) GO TO 50
        IF(IOUTST(I).LE.IOUTST(I+1)) GO TO 40
        JOE = I + 1
30      SWAP = IOUTST(I)
        ISIGN = - ISIGN
        IOUTST(I) = IOUTST(I+1)
        IOUTST(I+1) = SWAP
        IF(I.EQ.1) GO TO 10
        I = I - 1
        IF(IOUTST(I).GT.IOUTST(I+1)) GO TO 30
        GO TO 10
40      I = I + 1
      GO TO 20
C
C     END ORDER
C
50    CONTINUE
      IF( IPRINT.GT.30 ) THEN
        Write(6,*)  ' INPUT STRING ORDERED STRING ISIGN '
        CALL IWRTMA(IINST,1,NELMNT,1,NELMNT)
        CALL IWRTMA(IOUTST,1,NELMNT,1,NELMNT)
        Write(6,*) ' ISIGN : ', ISIGN
      END IF
C
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_Tra_1(COcc,CVir,Diag,DoDiag,Wrk,lWrk,iSym)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: transform Cholesky vectors to (ai) MO basis for symmetry
C              block iSym. Files are assumed open.
C              If requested (DoDiag=.true.), compute (ai|ai) integral
C              diagonal.
C
      use ChoSwp, only: InfVec
#include "implicit.fh"
      Real*8  COcc(*), CVir(*), Diag(*), Wrk(lWrk)
      Logical DoDiag
#include "cholesky.fh"
#include "chomp2.fh"

      Character*12 SecNam
      Parameter (SecNam = 'ChoMP2_Tra_1')

      Integer  Cho_lRead
      External Cho_lRead

      Integer ai

C     Check if anything to do.
C     ------------------------

      If (NumCho(iSym).lt.1 .or. nT1am(iSym).lt.1) Return

C     Initialize Diag (if needed).
C     ----------------------------

      If (DoDiag) Call FZero(Diag,nT1am(iSym))

C     Allocate memory for half-transformed vector.
C     --------------------------------------------

      lHlfTr = nT1AOT(iSym)

      kHlfTr = 1
      kEnd0  = kHlfTr + lHlfTr
      lWrk0  = lWrk   - kEnd0 + 1
      If (lWrk0 .lt. (nT1am(iSym)+nnBstR(iSym,1))) Then
         Call ChoMP2_Quit(SecNam,'insufficient memory','[0]')
      End If

C     Reserve memory for reading AO vectors.
C     --------------------------------------

      lRead = Cho_lRead(iSym,lWrk0)
      If (lRead .lt. 1) Then
         Write(6,*) SecNam,': memory error: lRead = ',lRead
         Call ChoMP2_Quit(SecNam,'memory error',' ')
         lWrk1 = 0 ! to avoid compiler warnings...
      Else
         lWrk1 = lWrk0 - lRead
         If (lWrk1 .lt. nT1am(iSym)) Then
            lWrk1 = nT1am(iSym)
            lRead = lWrk - nT1am(iSym)
         End If
      End If

C     Set up batch.
C     -------------

      nMOVec = min(lWrk1/nT1am(iSym),NumCho(iSym))
      If (nMOVec .lt. 1) Then
         Call ChoMP2_Quit(SecNam,'insufficient memory','[1]')
      End If
      NumBat = (NumCho(iSym) - 1)/nMOVec + 1

C     Set reduced set handles.
C     ------------------------

      iRedC = -1
      iLoc  = 3

C     Transform each batch of vectors and compute diagonal contributions
C     (if requested).
C     ------------------------------------------------------------------

      Do iBat = 1,NumBat

         If (iBat .eq. NumBat) Then
            NumV = NumCho(iSym) - nMOVec*(NumBat - 1)
         Else
            NumV = nMOVec
         End If
         iVec1 = nMOVec*(iBat - 1) + 1
         iVec2 = iVec1 + NumV - 1

         lChoMO = nT1am(iSym)*NumV

         kChoMO = kEnd0
         kChoAO = kChoMO + lChoMO
         lChoAO = lWrk0  - kChoAO + 1

         kOffMO = kChoMO
         jVec1  = iVec1
         Do While (jVec1 .le. iVec2)

            jNum = 0
            Call Cho_VecRd(Wrk(kChoAO),lChoAO,jVec1,iVec2,iSym,
     &                     jNum,iRedC,mUsed)
            If (jNum .lt. 1) Then
               Call ChoMP2_Quit(SecNam,
     &                          'insufficient memory','[2]')
            End If

            kOff = kChoAO
            Do jVec = 1,jNum
               iVec = jVec1 + jVec - 1
               iRed = InfVec(iVec,2,iSym)
               If (iRedC .ne. iRed) Then
                  irc = 0
                  Call Cho_X_SetRed(irc,iLoc,iRed)
                  If (irc .ne. 0) Then
                     Call ChoMP2_Quit(SecNam,'error in Cho_X_SetRed',
     &                                ' ')
                  End If
                  iRedC = iRed
               End If
               Call ChoMP2_TraVec(Wrk(kOff),Wrk(kOffMO),COcc,CVir,
     &                            Wrk(kHlfTr),lHlfTr,iSym,1,1,iLoc)
               kOff   = kOff   + nnBstR(iSym,iLoc)
               kOffMO = kOffMO + nT1am(iSym)
            End Do

            jVec1 = jVec1 + jNum

         End Do

         iOpt = 1
         iAdr = nT1am(iSym)*(iVec1 - 1) + 1
         Call ddaFile(lUnit_F(iSym,1),iOpt,Wrk(kChoMO),lChoMO,iAdr)

         If (DoDiag) Then
            Do iVec = 1,NumV
               kOff = kChoMO + nT1am(iSym)*(iVec-1) - 1
               Do ai = 1,nT1am(iSym)
                  Diag(ai) = Diag(ai) + Wrk(kOff+ai)*Wrk(kOff+ai)
               End Do
            End Do
         End If

      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine zz_cvb(act1,zz1,fx,fxbest1,exp1,ip1)

use casvb_global, only: dfxtol, formAD
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(out) :: act1, zz1
real(kind=wp), intent(in) :: fx, fxbest1, exp1
integer(kind=iwp), intent(in) :: ip1
real(kind=wp), parameter :: thous = 1.0e3_wp

act1 = fx-fxbest1
if (fxbest1 == -thous) act1 = One
if (((abs(act1) < dfxtol) .and. (abs(exp1) < dfxtol)) .or. (act1 == One)) then
  zz1 = One
else if (exp1 == Zero) then
  zz1 = One
else if (abs(exp1) < dfxtol) then
  zz1 = sign(One,act1)*sign(One,exp1)
else
  zz1 = act1/exp1
end if
if (ip1 >= 2) then
  if (act1 /= One) write(u6,formAD) ' Actual and expected changes :',act1,exp1
  write(u6,formAD) ' Ratio act/exp    : ',zz1
end if

return

end subroutine zz_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Logical Function RinT_(iOpT,nOpT,iOpR)
************************************************************************
*                                                                      *
* Object: to return .true. if R is in {T}.                             *
*                                                                      *
* Called from: TwoEl                                                   *
*                                                                      *
* Calling    : None                                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             June '90                                                 *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Integer iOpT(nOpT)
      RinT_ = .False.
      Do 10 i = 1, nOpT
         If (iOpT(i).eq.iOpR) Then
            RinT_ = .True.
            Return
         End If
 10   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MV7(C,HC,LUC,LUHC)
! Outer routine for sigma vector generation
! GAS version !!!!
!
! Written in terms of RASG3/SBLOCK, May 1997

use CandS, only: ISSM, ISSPC
use lucia_data, only: ENVIRO, I_AM_OUT, ICISTR, IDC, IREFSM, LCSBLK, MXNTTS, MXSOOB, N_ELIMINATED_BATCHES, NIRREP, NOCTYP, NSTSO, &
                      PSSIGN, XISPSM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: C(*)
real(kind=wp), intent(_OUT_) :: HC(*)
integer(kind=iwp), intent(in) :: LUC, LUHC
integer(kind=iwp) :: IATP, IBTP, LBLOCK, LLUC, LLUHC, NBATCH, NOCTPA, NOCTPB, NTTS
integer(kind=iwp), allocatable :: CBLTP(:), CI1BT(:), CIBT(:), CLBT(:), CLEBT(:), SIOIO(:), SVST(:)

if (ICISTR == 1) then
  write(u6,*) ' MV7 does not work for ICISTR = 1'
  write(u6,*) ' SWITCH to ICISTR = 2,3 or program'
  !stop ' MV7 does not work for ICISTR = 1'
  call SYSABENDMSG('lucia_util/mv7','Internal error','')
end if

IATP = 1
IBTP = 2

NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)
! Arrays giving allowed type combinations
call mma_allocate(SIOIO,NOCTPA*NOCTPB,Label='SIOIO')
call IAIBCM(ISSPC,SIOIO)
! Arrays for additional symmetry operation
if ((IDC == 3) .or. (IDC == 4)) then
  call mma_allocate(SVST,NIRREP,Label='SVST')
  call SIGVST(SVST,NIRREP)
else
  call mma_allocate(SVST,1,Label='SVST')
end if
! Arrays giving block type
call mma_allocate(CBLTP,NIRREP,Label='CBLTP')
call ZBLTP(ISSM,NIRREP,IDC,CBLTP,SVST)
call mma_deallocate(SVST)
! Arrays for partitioning of sigma
NTTS = MXNTTS
call mma_allocate(CLBT,NTTS,Label='CLBT')
call mma_allocate(CLEBT,NTTS,Label='CLEBT')
call mma_allocate(CI1BT,NTTS,Label='CI1BT')
call mma_allocate(CIBT,8*NTTS,Label='CIBT')
! Batches  of C vector
!if (ISIMSYM == 0) then
LBLOCK = MXSOOB
!else
!  LBLOCK = MXSOOB_AS
!end if
LBLOCK = max(LBLOCK,LCSBLK)
! JESPER : Should reduce I/O
if (ENVIRO == 'RASSCF') then
  LBLOCK = max(int(XISPSM(IREFSM,1)),MXSOOB)
  if (PSSIGN /= Zero) LBLOCK = int(2*XISPSM(IREFSM,1))
end if
call PART_CIV2(IDC,NSTSO(IATP)%A,NSTSO(IBTP)%A,NOCTPA,NOCTPB,NIRREP,SIOIO,ISSM,NBATCH,CLBT,CLEBT,CI1BT,CIBT,0)
call mma_deallocate(SIOIO)
call mma_deallocate(CBLTP)

if (ICISTR == 1) then
  LLUC = 0
  LLUHC = 0
else
  LLUC = LUC
  LLUHC = LUHC
end if

call RASSG3(C,HC,NBATCH,CLBT,CI1BT,CIBT,LLUC,LLUHC,I_AM_OUT,N_ELIMINATED_BATCHES)
!write(u6,*) ' LSCMAX_MX = ',LSCMAX_MX
! Eliminate local memory
call mma_deallocate(CLBT)
call mma_deallocate(CLEBT)
call mma_deallocate(CI1BT)
call mma_deallocate(CIBT)

end subroutine MV7

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine InfoToMp(nSym,nBas,nOcc,Energy_Without_FFPT,Ene_Occ,nOcOb,UserDen,Restart)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(8), nOcc
real(kind=wp), intent(out) :: Energy_Without_FFPT, Ene_Occ(nOcc)
integer(kind=iwp), intent(out) :: nOcOb
logical(kind=iwp), intent(in) :: UserDen, Restart
integer(kind=iwp) :: i, iDum(1), iErr, iSym, iWarn, Lu_, nVec
character(len=40) :: VTitle
character(len=8) :: Method
character(len=6) :: FName
real(kind=wp), allocatable :: Occ(:), Vec(:)

!                                                                      *
!***********************************************************************
!                                                                      *
! Set some variables needed for creating the MpProp file.              *
!                                                                      *
!***********************************************************************
!                                                                      *
nOcOb = 0
if (.not. UserDen) then
  nVec = 0
  do iSym=1,nSym
    nVec = nVec+nBas(iSym)**2
  end do
  if (Restart) then
    call Get_dScalar('MpProp Energy',Energy_Without_FFPT)
    call Get_dArray('MpProp Orb Ener',Ene_occ,nOcc)
    call Get_iScalar('MpProp nOcOb',nOcOb)
  else
    call Get_dScalar('Last energy',Energy_Without_FFPT)
    call Put_dScalar('MpProp Energy',Energy_Without_FFPT)

    call mma_allocate(Vec,nVec,label='Vec')
    call mma_allocate(Occ,nOcc,label='Occ')

    Lu_ = 11
    FName = 'INPORB'
    iDum = 0
    iWarn = 2
    call RdVec(FName,Lu_,'COE',nSym,nBas,nBas,Vec,Occ,Ene_Occ,iDum,VTitle,iWarn,iErr)
    close(Lu_)

    do i=1,nOcc
      if (Occ(i) /= Zero) nOcOb = nOcOb+1
    end do
    call Put_dArray('MpProp Orb Ener',Ene_occ,nOcc)
    call Put_iScalar('MpProp nOcOb',nOcOb)

    call mma_deallocate(Vec)
    call mma_deallocate(Occ)
  end if
else
  !Here we go if user give density as input. Need to put some
  !dummy values for later; also we give a value to the relax
  !method, which for now is called 'external'.
  Energy_Without_FFPT = Zero
  Ene_Occ(:) = Zero
  write(Method,'(A)') 'External'
  call Put_cArray('Relax Method',Method,8)
end if

return

end subroutine InfoToMp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module mh5
! Generic interfaces for HDF5

#include "intent.fh"

use, intrinsic :: iso_c_binding, only: c_char, c_null_char
use Definitions, only: wp, iwp, u6, MOLCAS_C_INT, MOLCAS_C_REAL

implicit none
private

public :: mh5_create_file, mh5_open_file_rw, mh5_open_file_r, mh5_close_file, mh5_is_hdf5, mh5_open_group, mh5_close_group, &
          mh5_exists_attr, mh5_open_attr, mh5_close_attr, mh5_exists_dset, mh5_open_dset, mh5_close_dset, mh5_create_attr_int, &
          mh5_create_attr_real, mh5_create_attr_str, mh5_put_attr, mh5_get_attr, mh5_init_attr, mh5_fetch_attr, &
          mh5_create_dset_int, mh5_create_dset_real, mh5_create_dset_str, mh5_put_dset, mh5_get_dset, mh5_init_dset, &
          mh5_fetch_dset, mh5_resize_dset, mh5_get_dset_dims

!======================
! Overloaded interfaces
!======================

! attr

interface mh5_create_attr_int
  module procedure :: mh5_create_attr_scalar_int, &
                      mh5_create_attr_array_int
end interface mh5_create_attr_int

interface mh5_create_attr_real
  module procedure :: mh5_create_attr_scalar_real, &
                      mh5_create_attr_array_real
end interface mh5_create_attr_real

interface mh5_create_attr_str
  module procedure :: mh5_create_attr_scalar_str, &
                      mh5_create_attr_array_str
end interface mh5_create_attr_str

interface mh5_put_attr
  module procedure :: mh5_put_attr_scalar_int, &
                      mh5_put_attr_scalar_real, &
                      mh5_put_attr_scalar_str, &
                      mh5_put_attr_array_int, &
                      mh5_put_attr_array_real, &
                      mh5_put_attr_array_str
end interface mh5_put_attr

interface mh5_get_attr
  module procedure :: mh5_get_attr_scalar_int, &
                      mh5_get_attr_scalar_real, &
                      mh5_get_attr_scalar_str, &
                      mh5_get_attr_array_int, &
                      mh5_get_attr_array_real, &
                      mh5_get_attr_array_str
end interface mh5_get_attr

! init = create + put + close
interface mh5_init_attr
  module procedure :: mh5_init_attr_scalar_int, &
                      mh5_init_attr_scalar_real, &
                      mh5_init_attr_scalar_str, &
                      mh5_init_attr_array_int, &
                      mh5_init_attr_array_real, &
                      mh5_init_attr_array_str
end interface mh5_init_attr

! fetch = open + get + close
interface mh5_fetch_attr
  module procedure :: mh5_fetch_attr_scalar_int, &
                      mh5_fetch_attr_scalar_real, &
                      mh5_fetch_attr_scalar_str, &
                      mh5_fetch_attr_array_int, &
                      mh5_fetch_attr_array_real, &
                      mh5_fetch_attr_array_str
end interface mh5_fetch_attr

! dset

interface mh5_create_dset_int
  module procedure :: mh5_create_dset_scalar_int, &
                      mh5_create_dset_array_int
end interface mh5_create_dset_int

interface mh5_create_dset_real
  module procedure :: mh5_create_dset_scalar_real, &
                      mh5_create_dset_array_real
end interface mh5_create_dset_real

interface mh5_create_dset_str
  module procedure :: mh5_create_dset_scalar_str, &
                      mh5_create_dset_array_str
end interface mh5_create_dset_str

interface mh5_put_dset
  module procedure :: mh5_put_dset_scalar_int, &
                      mh5_put_dset_scalar_real, &
                      mh5_put_dset_scalar_str, &
                      mh5_put_dset_array_int, &
                      mh5_put_dset_array_int_2d, &
                      mh5_put_dset_array_real, &
                      mh5_put_dset_array_real_2d, &
                      mh5_put_dset_array_real_3d, &
                      mh5_put_dset_array_str
end interface mh5_put_dset

interface mh5_get_dset
  module procedure :: mh5_get_dset_scalar_int, &
                      mh5_get_dset_scalar_real, &
                      mh5_get_dset_scalar_str, &
                      mh5_get_dset_array_int, &
                      mh5_get_dset_array_real, &
                      mh5_get_dset_array_str
end interface mh5_get_dset

! init = create + put + close
interface mh5_init_dset
  module procedure :: mh5_init_dset_scalar_int, &
                      mh5_init_dset_scalar_real, &
                      mh5_init_dset_scalar_str, &
                      mh5_init_dset_array_int, &
                      mh5_init_dset_array_real, &
                      mh5_init_dset_array_str
end interface mh5_init_dset

! fetch = open + get + close
interface mh5_fetch_dset
  module procedure :: mh5_fetch_dset_scalar_int, &
                      mh5_fetch_dset_scalar_real, &
                      mh5_fetch_dset_scalar_str, &
                      mh5_fetch_dset_array_int, &
                      mh5_fetch_dset_array_int_2d, &
                      mh5_fetch_dset_array_real, &
                      mh5_fetch_dset_array_real_2d, &
                      mh5_fetch_dset_array_real_3d, &
                      mh5_fetch_dset_array_str
end interface mh5_fetch_dset

interface mh5_resize_dset
  module procedure :: mh5_extend_dset_array
end interface mh5_resize_dset

interface mh5_get_dset_dims
  module procedure :: mh5_get_dset_array_dims
end interface mh5_get_dset_dims

!==================================
! Private interfaces to C functions
!==================================

interface

  ! file

  function mh5_c_create_file(filename) result(lu) &
           bind(C,name='mh5c_create_file')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: lu
    character(kind=c_char) :: filename(*)
  end function mh5_c_create_file

  function mh5_c_open_rw(filename) result(lu) &
           bind(C,name='mh5c_open_file_rw')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: lu
    character(kind=c_char) :: filename(*)
  end function mh5_c_open_rw

  function mh5_c_open_r(filename) result(lu) &
           bind(C,name='mh5c_open_file_r')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: lu
    character(kind=c_char) :: filename(*)
  end function mh5_c_open_r

  function mh5_c_close_file(lu) result(rc) &
           bind(C,name='mh5c_close_file')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: lu
  end function mh5_c_close_file

  function mh5_c_is_hdf5(filename) result(rc) &
           bind(C,name='mh5c_is_hdf5')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    character(kind=c_char) :: filename(*)
  end function mh5_c_is_hdf5

  ! group

  function mh5_c_open_group(lu,groupname) result(groupid) &
           bind(C,name='mh5c_open_group')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: groupid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: groupname(*)
  end function mh5_c_open_group

  function mh5_c_close_group(id) result(rc) &
           bind(C,name='mh5c_close_group')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: id
  end function mh5_c_close_group

  ! attr

  function mh5_c_exists_attr(id,attrname) result(rc) &
           bind(C,name='mh5c_exists_attr')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: id
    character(kind=c_char) :: attrname(*)
  end function mh5_c_exists_attr

  function mh5_c_open_attr(lu,attrname) result(attrid) &
           bind(C,name='mh5c_open_attr')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: attrid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: attrname(*)
  end function mh5_c_open_attr

  function mh5_c_close_attr(attrid) result(rc) &
           bind(C,name='mh5c_close_attr')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
  end function mh5_c_close_attr

  ! dset

  function mh5_c_exists_dset(id,dsetname) result(rc) &
           bind(C,name='mh5c_exists_dset')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: id
    character(len=c_char) :: dsetname(*)
  end function mh5_c_exists_dset

  function mh5_c_open_dset(lu,dsetname) result(dsetid) &
           bind(C,name='mh5c_open_dset')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: dsetid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
  end function mh5_c_open_dset

  function mh5_c_close_dset(dsetid) result(rc) &
           bind(C,name='mh5c_close_dset')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
  end function mh5_c_close_dset

  ! attr types
  ! (create|put|get)_attr_(scalar|array)_(int|real|str)

  function mh5_c_create_attr_scalar_int(lu,attrname) result(attrid) &
           bind(C,name='mh5c_create_attr_scalar_int')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: attrid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: attrname(*)
  end function mh5_c_create_attr_scalar_int

  function mh5_c_create_attr_scalar_real(lu,attrname) result(attrid) &
           bind(C,name='mh5c_create_attr_scalar_real')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: attrid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: attrname(*)
  end function mh5_c_create_attr_scalar_real

  function mh5_c_create_attr_scalar_str(lu,attrname,length) result(attrid) &
           bind(C,name='mh5c_create_attr_scalar_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: attrid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: attrname(*)
    integer(kind=MOLCAS_C_INT), value :: length
  end function mh5_c_create_attr_scalar_str

  function mh5_c_put_attr_scalar_int(attrid,val) result(rc) &
           bind(C,name='mh5c_put_attr_scalar_int')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    integer(kind=MOLCAS_C_INT) :: val
  end function mh5_c_put_attr_scalar_int

  function mh5_c_put_attr_scalar_real(attrid,val) result(rc) &
           bind(C,name='mh5c_put_attr_scalar_real')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    real(kind=MOLCAS_C_REAL) :: val
  end function mh5_c_put_attr_scalar_real

  function mh5_c_put_attr_scalar_str(attrid,val) result(rc) &
           bind(C,name='mh5c_put_attr_scalar_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    character(kind=c_char) :: val(*)
  end function mh5_c_put_attr_scalar_str

  function mh5_c_get_attr_scalar_int(attrid,val) result(rc) &
           bind(C,name='mh5c_get_attr_scalar_int')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    integer(kind=MOLCAS_C_INT) :: val
  end function mh5_c_get_attr_scalar_int

  function mh5_c_get_attr_scalar_real(attrid,val) result(rc) &
           bind(C,name='mh5c_get_attr_scalar_real')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    real(kind=MOLCAS_C_REAL) :: val
  end function mh5_c_get_attr_scalar_real

  function mh5_c_get_attr_scalar_str(attrid,val) result(rc) &
           bind(C,name='mh5c_get_attr_scalar_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    character(kind=c_char) :: val(*)
  end function mh5_c_get_attr_scalar_str

  function mh5_c_create_attr_array_int(lu,attrname,rank,dims) result(attrid) &
           bind(C,name='mh5c_create_attr_array_int')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: attrid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: attrname(*)
    integer(kind=MOLCAS_C_INT), value :: rank
    integer(kind=MOLCAS_C_INT) :: dims(*)
  end function mh5_c_create_attr_array_int

  function mh5_c_create_attr_array_real(lu,attrname,rank,dims) result(attrid) &
           bind(C,name='mh5c_create_attr_array_real')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: attrid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: attrname(*)
    integer(kind=MOLCAS_C_INT), value :: rank
    integer(kind=MOLCAS_C_INT) :: dims(*)
  end function mh5_c_create_attr_array_real

  function mh5_c_create_attr_array_str(lu,attrname,rank,dims,length) result(attrid) &
           bind(C,name='mh5c_create_attr_array_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: attrid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: attrname(*)
    integer(kind=MOLCAS_C_INT), value :: rank
    integer(kind=MOLCAS_C_INT) :: dims(*)
    integer(kind=MOLCAS_C_INT), value :: length
  end function mh5_c_create_attr_array_str

  function mh5_c_put_attr_array_int(attrid,buffer) result(rc) &
           bind(C,name='mh5c_put_attr_array_int')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    integer(kind=MOLCAS_C_INT) :: buffer(*)
  end function mh5_c_put_attr_array_int

  function mh5_c_put_attr_array_real(attrid,buffer) result(rc) &
           bind(C,name='mh5c_put_attr_array_real')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    real(kind=MOLCAS_C_REAL) :: buffer(*)
  end function mh5_c_put_attr_array_real

  function mh5_c_put_attr_array_str(attrid,buffer) result(rc) &
           bind(C,name='mh5c_put_attr_array_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    character(kind=c_char) :: buffer(*)
  end function mh5_c_put_attr_array_str

  function mh5_c_get_attr_array_int(attrid,buffer) result(rc) &
           bind(C,name='mh5c_get_attr_array_int')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    integer(kind=MOLCAS_C_INT) :: buffer(*)
  end function mh5_c_get_attr_array_int

  function mh5_c_get_attr_array_real(attrid,buffer) result(rc) &
           bind(C,name='mh5c_get_attr_array_real')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    real(kind=MOLCAS_C_REAL) :: buffer(*)
  end function mh5_c_get_attr_array_real

  function mh5_c_get_attr_array_str(attrid,buffer) result(rc) &
           bind(C,name='mh5c_get_attr_array_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: attrid
    character(kind=c_char) :: buffer(*)
  end function mh5_c_get_attr_array_str

  ! dset types
  ! (create|put|get)_dset_(scalar|array[_dyn])_(int|real|str)[_full]

  function mh5_c_create_dset_scalar_int(lu,dsetname) result(dsetid) &
           bind(C,name='mh5c_create_dset_scalar_int')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: dsetid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
  end function mh5_c_create_dset_scalar_int

  function mh5_c_create_dset_scalar_real(lu,dsetname) result(dsetid) &
           bind(C,name='mh5c_create_dset_scalar_real')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
    integer(kind=MOLCAS_C_INT) :: dsetid
  end function mh5_c_create_dset_scalar_real

  function mh5_c_create_dset_scalar_str(lu,dsetname,length) result(dsetid) &
           bind(C,name='mh5c_create_dset_scalar_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: dsetid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
    integer(kind=MOLCAS_C_INT), value :: length
  end function mh5_c_create_dset_scalar_str

  function mh5_c_put_dset_scalar_int(dsetid,val) result(rc) &
           bind(C,name='mh5c_put_dset_scalar_int')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: val
  end function mh5_c_put_dset_scalar_int

  function mh5_c_put_dset_scalar_real(dsetid,val) result(rc) &
           bind(C,name='mh5c_put_dset_scalar_real')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    real(kind=MOLCAS_C_REAL) :: val
  end function mh5_c_put_dset_scalar_real

  function mh5_c_put_dset_scalar_str(dsetid,val) result(rc) &
           bind(C,name='mh5c_put_dset_scalar_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    character(kind=c_char) :: val(*)
  end function mh5_c_put_dset_scalar_str

  function mh5_c_get_dset_scalar_int(dsetid,val) result(rc) &
           bind(C,name='mh5c_get_dset_scalar_int')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: val
  end function mh5_c_get_dset_scalar_int

  function mh5_c_get_dset_scalar_real(dsetid,val) result(rc) &
           bind(C,name='mh5c_get_dset_scalar_real')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    real(kind=MOLCAS_C_REAL) :: val
  end function mh5_c_get_dset_scalar_real

  function mh5_c_get_dset_scalar_str(dsetid,val) result(rc) &
           bind(C,name='mh5c_get_dset_scalar_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    character(kind=c_char) :: val(*)
  end function mh5_c_get_dset_scalar_str

  function mh5_c_create_dset_array_int(lu,dsetname,rank,dims) result(dsetid) &
           bind(C,name='mh5c_create_dset_array_int')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: dsetid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
    integer(kind=MOLCAS_C_INT), value :: rank
    integer(kind=MOLCAS_C_INT) :: dims(*)
  end function mh5_c_create_dset_array_int

  function mh5_c_create_dset_array_dyn_int(lu,dsetname,rank,dims) result(dsetid) &
           bind(C,name='mh5c_create_dset_array_dyn_int')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: dsetid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
    integer(kind=MOLCAS_C_INT), value :: rank
    integer(kind=MOLCAS_C_INT) :: dims(*)
  end function mh5_c_create_dset_array_dyn_int

  function mh5_c_create_dset_array_real(lu,dsetname,rank,dims) result(dsetid) &
           bind(C,name='mh5c_create_dset_array_real')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: dsetid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
    integer(kind=MOLCAS_C_INT), value :: rank
    integer(kind=MOLCAS_C_INT) :: dims(*)
  end function mh5_c_create_dset_array_real

  function mh5_c_create_dset_array_dyn_real(lu,dsetname,rank,dims) result(dsetid) &
           bind(C,name='mh5c_create_dset_array_dyn_real')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: dsetid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
    integer(kind=MOLCAS_C_INT), value :: rank
    integer(kind=MOLCAS_C_INT) :: dims(*)
  end function mh5_c_create_dset_array_dyn_real

  function mh5_c_create_dset_array_str(lu,dsetname,rank,dims,length) result(dsetid) &
           bind(C,name='mh5c_create_dset_array_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: dsetid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
    integer(kind=MOLCAS_C_INT), value :: rank
    integer(kind=MOLCAS_C_INT) :: dims(*)
    integer(kind=MOLCAS_C_INT), value :: length
  end function mh5_c_create_dset_array_str

  function mh5_c_create_dset_array_dyn_str(lu,dsetname,rank,dims,length) result(dsetid) &
           bind(C,name='mh5c_create_dset_array_dyn_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: dsetid
    integer(kind=MOLCAS_C_INT), value :: lu
    character(kind=c_char) :: dsetname(*)
    integer(kind=MOLCAS_C_INT), value :: rank
    integer(kind=MOLCAS_C_INT) :: dims(*)
    integer(kind=MOLCAS_C_INT), value :: length
  end function mh5_c_create_dset_array_dyn_str

  function mh5_c_put_dset_array_int(dsetid,exts,offs,buffer) result(rc) &
           bind(C,name='mh5c_put_dset_array_int')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: exts(*), offs(*)
    integer(kind=MOLCAS_C_INT) :: buffer(*)
  end function mh5_c_put_dset_array_int

  function mh5_c_put_dset_array_int_full(dsetid,buffer) result(rc) &
           bind(C,name='mh5c_put_dset_array_int_full')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: buffer(*)
  end function mh5_c_put_dset_array_int_full

  function mh5_c_put_dset_array_real(dsetid,exts,offs,buffer) result(rc) &
           bind(C,name='mh5c_put_dset_array_real')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: exts(*), offs(*)
    real(kind=MOLCAS_C_REAL) :: buffer(*)
  end function mh5_c_put_dset_array_real

  function mh5_c_put_dset_array_real_full(dsetid,buffer) result(rc) &
           bind(C,name='mh5c_put_dset_array_real_full')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    real(kind=MOLCAS_C_REAL) :: buffer(*)
  end function mh5_c_put_dset_array_real_full

  function mh5_c_put_dset_array_str(dsetid,exts,offs,buffer) result(rc) &
           bind(C,name='mh5c_put_dset_array_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: exts(*), offs(*)
    character(kind=c_char) :: buffer(*)
  end function mh5_c_put_dset_array_str

  function mh5_c_put_dset_array_str_full(dsetid,buffer) result(rc) &
           bind(C,name='mh5c_put_dset_array_str_full')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    character(kind=c_char) :: buffer(*)
  end function mh5_c_put_dset_array_str_full

  function mh5_c_get_dset_array_int(dsetid,exts,offs,buffer) result(rc) &
           bind(C,name='mh5c_get_dset_array_int')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: exts(*), offs(*)
    integer(kind=MOLCAS_C_INT) :: buffer(*)
  end function mh5_c_get_dset_array_int

  function mh5_c_get_dset_array_int_full(dsetid,buffer) result(rc) &
           bind(C,name='mh5c_get_dset_array_int_full')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: buffer(*)
  end function mh5_c_get_dset_array_int_full

  function mh5_c_get_dset_array_real(dsetid,exts,offs,buffer) result(rc) &
           bind(C,name='mh5c_get_dset_array_real')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: exts(*), offs(*)
    real(kind=MOLCAS_C_REAL) :: buffer(*)
  end function mh5_c_get_dset_array_real

  function mh5_c_get_dset_array_real_full(dsetid,buffer) result(rc) &
           bind(C,name='mh5c_get_dset_array_real_full')
    import :: MOLCAS_C_INT, MOLCAS_C_REAL
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    real(kind=MOLCAS_C_REAL) :: buffer(*)
  end function mh5_c_get_dset_array_real_full

  function mh5_c_get_dset_array_str(dsetid,exts,offs,buffer) result(rc) &
           bind(C,name='mh5c_get_dset_array_str')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: exts(*), offs(*)
    character(kind=c_char) :: buffer(*)
  end function mh5_c_get_dset_array_str

  function mh5_c_get_dset_array_str_full(dsetid,buffer) result(rc) &
           bind(C,name='mh5c_get_dset_array_str_full')
    import :: MOLCAS_C_INT, c_char
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    character(kind=c_char) :: buffer(*)
  end function mh5_c_get_dset_array_str_full

  ! dset extend array / get dims

  function mh5_c_extend_dset_array(dsetid,dims) result(rc) &
           bind(C,name='mh5c_extend_dset_array')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: dims(*)
  end function mh5_c_extend_dset_array

  function mh5_c_get_dset_array_dims(dsetid,dims) result(rc) &
           bind(C,name='mh5c_get_dset_array_dims')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: rc
    integer(kind=MOLCAS_C_INT), value :: dsetid
    integer(kind=MOLCAS_C_INT) :: dims(*)
  end function mh5_c_get_dset_array_dims

end interface

contains

! convert Fortran string to null-terminated C string
subroutine f2c_string(string,c_string)
  character(len=*), intent(in) :: string
  character(len=*), intent(out) :: c_string
  if (len_trim(string) > len(c_string)-1) then
    write(u6,*) 'f2c_string: input string too long'
    call abend()
  end if
  c_string = trim(string)//c_null_char
end subroutine f2c_string

!==========================
! Specific Fortran wrappers
!==========================

#define MH5_MAX_LBL_LEN 256

! file

function mh5_create_file(filename) result(lu)
  integer(kind=iwp) :: lu
  character(len=*), intent(in) :: filename
  integer(kind=iwp) :: lrealname
  character(len=4096) :: realname, c_name
  call prgmtranslate(filename,realname,lrealname)
  call f2c_string(realname,c_name)
  lu = mh5_c_create_file(c_name)
end function mh5_create_file

function mh5_open_file_rw(filename) result(lu)
  integer(kind=iwp) :: lu
  character(len=*), intent(in) :: filename
  integer(kind=iwp) :: lrealname
  character(len=4096) :: realname, c_name
  call prgmtranslate(filename,realname,lrealname)
  call f2c_string(realname,c_name)
  lu = mh5_c_open_rw(c_name)
end function mh5_open_file_rw

function mh5_open_file_r(filename) result(lu)
  integer(kind=iwp) :: lu
  character(len=*) :: filename
  integer(kind=iwp) :: lrealname
  character(len=4096) :: realname, c_name
  call prgmtranslate(filename,realname,lrealname)
  call f2c_string(realname,c_name)
  lu = mh5_c_open_r(c_name)
end function mh5_open_file_r

subroutine mh5_close_file(lu)
  integer(kind=iwp), intent(in) :: lu
  if (mh5_c_close_file(lu) < 0) call abend()
end subroutine mh5_close_file

function mh5_is_hdf5(filename) result(ishdf5)
  logical(kind=iwp) :: ishdf5
  character(len=*), intent(in) :: filename
  integer(kind=iwp) :: rc, lrealname
  character(len=4096) :: realname
  logical(kind=iwp) :: exists
  call prgmtranslate(filename,realname,lrealname)
  call f_inquire(realname,exists)
  if (exists) then
    realname(lrealname+1:lrealname+1) = c_null_char
    rc = mh5_c_is_hdf5(realname)
  else
    rc = 0
  end if
  if (rc > 0) then
    ishdf5 = .true.
  else if (rc == 0) then
    ishdf5 = .false.
  else
    ishdf5 = .false.
    call abend()
  end if
end function mh5_is_hdf5

! group

function mh5_open_group(lu,groupname) result(groupid)
  integer(kind=iwp) :: groupid
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: groupname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(groupname,mh5_lbl)
  groupid = mh5_c_open_group(lu,mh5_lbl)
end function mh5_open_group

subroutine mh5_close_group(id)
  integer(kind=iwp), intent(in) :: id
  if (mh5_c_close_group(id) < 0) call abend()
end subroutine mh5_close_group

! attr

function mh5_exists_attr(id,attrname) result(exists)
  logical(kind=iwp) :: exists
  integer(kind=iwp), intent(in) :: id
  character(len=*), intent(in) :: attrname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  integer(kind=iwp) :: rc
  call f2c_string(attrname,mh5_lbl)
  rc = mh5_c_exists_attr(id,mh5_lbl)
  if (rc > 0) then
    exists = .true.
  else if (rc == 0) then
    exists = .false.
  else
    exists = .false.
    call abend()
  end if
end function mh5_exists_attr

function mh5_open_attr(lu,attrname) result(attrid)
  integer(kind=iwp) :: attrid
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(attrname,mh5_lbl)
  attrid = mh5_c_open_attr(lu,mh5_lbl)
end function mh5_open_attr

subroutine mh5_close_attr(attrid)
  integer(kind=iwp), intent(in) :: attrid
  if (mh5_c_close_attr(attrid) < 0) call abend()
end subroutine mh5_close_attr

! dset

function mh5_exists_dset(id,dsetname) result(exists)
  logical(kind=iwp) :: exists
  integer(kind=iwp), intent(in) :: id
  character(len=*), intent(in) :: dsetname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  integer(kind=iwp) :: rc
  call f2c_string(dsetname,mh5_lbl)
  rc = mh5_c_exists_dset(id,mh5_lbl)
  if (rc > 0) then
    exists = .true.
  else if (rc == 0) then
    exists = .false.
  else
    exists = .false.
    call abend()
  end if
end function mh5_exists_dset

function mh5_open_dset(lu,dsetname) result(dsetid)
  integer(kind=iwp) :: dsetid
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(dsetname,mh5_lbl)
  dsetid = mh5_c_open_dset(lu,mh5_lbl)
end function mh5_open_dset

subroutine mh5_close_dset(dsetid)
  integer(kind=iwp), intent(in) :: dsetid
  if (mh5_c_close_dset(dsetid) < 0) call abend()
end subroutine mh5_close_dset

! attr types

function mh5_create_attr_scalar_int(lu,attrname) result(attrid)
  integer(kind=iwp) :: attrid
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(attrname,mh5_lbl)
  attrid = mh5_c_create_attr_scalar_int(lu,mh5_lbl)
end function mh5_create_attr_scalar_int

function mh5_create_attr_scalar_real(lu,attrname) result(attrid)
  integer(kind=iwp) :: attrid
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(attrname,mh5_lbl)
  attrid = mh5_c_create_attr_scalar_real(lu,mh5_lbl)
end function mh5_create_attr_scalar_real

function mh5_create_attr_scalar_str(lu,attrname,length) result(attrid)
  integer(kind=iwp) :: attrid
  integer(kind=iwp), intent(in) :: lu, length
  character(len=*), intent(in) :: attrname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(attrname,mh5_lbl)
  attrid = mh5_c_create_attr_scalar_str(lu,mh5_lbl,length)
end function mh5_create_attr_scalar_str

subroutine mh5_put_attr_scalar_int(attrid,val)
  integer(kind=iwp), intent(in) :: attrid
  integer(kind=iwp), intent(in) :: val
  if (mh5_c_put_attr_scalar_int(attrid,val) < 0) call abend()
end subroutine mh5_put_attr_scalar_int

subroutine mh5_put_attr_scalar_real(attrid,val)
  integer(kind=iwp), intent(in) :: attrid
  real(kind=wp), intent(in) :: val
  if (mh5_c_put_attr_scalar_real(attrid,val) < 0) call abend()
end subroutine mh5_put_attr_scalar_real

subroutine mh5_put_attr_scalar_str(attrid,val)
  integer(kind=iwp), intent(in) :: attrid
  character(len=*), intent(in) :: val
  if (mh5_c_put_attr_scalar_str(attrid,val) < 0) call abend()
end subroutine mh5_put_attr_scalar_str

subroutine mh5_get_attr_scalar_int(attrid,val)
  integer(kind=iwp), intent(in) :: attrid
  integer(kind=iwp), intent(out) :: val
  if (mh5_c_get_attr_scalar_int(attrid,val) < 0) call abend()
end subroutine mh5_get_attr_scalar_int

subroutine mh5_get_attr_scalar_real(attrid,val)
  integer(kind=iwp), intent(in) :: attrid
  real(kind=wp), intent(out) :: val
  if (mh5_c_get_attr_scalar_real(attrid,val) < 0) call abend()
end subroutine mh5_get_attr_scalar_real

subroutine mh5_get_attr_scalar_str(attrid,val)
  integer(kind=iwp), intent(in) :: attrid
  character(len=*), intent(out) :: val
  if (mh5_c_get_attr_scalar_str(attrid,val) < 0) call abend()
end subroutine mh5_get_attr_scalar_str

function mh5_create_attr_array_int(lu,attrname,rank,dims) result(attrid)
  integer(kind=iwp) :: attrid
  integer(kind=iwp), intent(in) :: lu, rank, dims(*)
  character(len=*), intent(in) :: attrname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(attrname,mh5_lbl)
  attrid = mh5_c_create_attr_array_int(lu,mh5_lbl,rank,dims)
end function mh5_create_attr_array_int

function mh5_create_attr_array_real(lu,attrname,rank,dims) result(attrid)
  integer(kind=iwp) :: attrid
  integer(kind=iwp), intent(in) :: lu, rank, dims(*)
  character(len=*), intent(in) :: attrname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(attrname,mh5_lbl)
  attrid = mh5_c_create_attr_array_real(lu,mh5_lbl,rank,dims)
end function mh5_create_attr_array_real

function mh5_create_attr_array_str(lu,attrname,rank,dims,length) result(attrid)
  integer(kind=iwp) :: attrid
  integer(kind=iwp), intent(in) :: lu, rank, dims(*), length
  character(len=*), intent(in) :: attrname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(attrname,mh5_lbl)
  attrid = mh5_c_create_attr_array_str(lu,mh5_lbl,rank,dims,length)
end function mh5_create_attr_array_str

subroutine mh5_put_attr_array_int(attrid,buffer)
  integer(kind=iwp), intent(in) :: attrid
  integer(kind=iwp), intent(in) :: buffer(*)
  if (mh5_c_put_attr_array_int(attrid,buffer) < 0) call abend()
end subroutine mh5_put_attr_array_int

subroutine mh5_put_attr_array_real(attrid,buffer)
  integer(kind=iwp), intent(in) :: attrid
  real(kind=wp), intent(in) :: buffer(*)
  if (mh5_c_put_attr_array_real(attrid,buffer) < 0) call abend()
end subroutine mh5_put_attr_array_real

subroutine mh5_put_attr_array_str(attrid,buffer)
  integer(kind=iwp), intent(in) :: attrid
  character, intent(in) :: buffer(*)
  if (mh5_c_put_attr_array_str(attrid,buffer) < 0) call abend()
end subroutine mh5_put_attr_array_str

subroutine mh5_get_attr_array_int(attrid,buffer)
  integer(kind=iwp), intent(in) :: attrid
  integer(kind=iwp), intent(_OUT_) :: buffer(*)
  if (mh5_c_get_attr_array_int(attrid,buffer) < 0) call abend()
end subroutine mh5_get_attr_array_int

subroutine mh5_get_attr_array_real(attrid,buffer)
  integer(kind=iwp), intent(in) :: attrid
  real(kind=wp), intent(_OUT_) :: buffer(*)
  if (mh5_c_get_attr_array_real(attrid,buffer) < 0) call abend()
end subroutine mh5_get_attr_array_real

subroutine mh5_get_attr_array_str(attrid,buffer)
  integer(kind=iwp), intent(in) :: attrid
  character, intent(_OUT_) :: buffer(*)
  if (mh5_c_get_attr_array_str(attrid,buffer) < 0) call abend()
end subroutine mh5_get_attr_array_str

subroutine mh5_init_attr_scalar_int(lu,attrname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  integer(kind=iwp), intent(in) :: val
  integer(kind=iwp) :: attrid
  attrid = mh5_create_attr_scalar_int(lu,attrname)
  call mh5_put_attr_scalar_int(attrid,val)
  call mh5_close_attr(attrid)
end subroutine mh5_init_attr_scalar_int

subroutine mh5_init_attr_scalar_real(lu,attrname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  real(kind=wp), intent(in) :: val
  integer(kind=iwp) :: attrid
  attrid = mh5_create_attr_scalar_real(lu,attrname)
  call mh5_put_attr_scalar_real(attrid,val)
  call mh5_close_attr(attrid)
end subroutine mh5_init_attr_scalar_real

subroutine mh5_init_attr_scalar_str(lu,attrname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  character(len=*), intent(in) :: val
  integer(kind=iwp) :: attrid
  attrid = mh5_create_attr_scalar_str(lu,attrname,len(val))
  call mh5_put_attr_scalar_str(attrid,val)
  call mh5_close_attr(attrid)
end subroutine mh5_init_attr_scalar_str

subroutine mh5_init_attr_array_int(lu,attrname,rank,dims,buffer)
  integer(kind=iwp), intent(in) :: lu, rank, dims(*)
  character(len=*), intent(in) :: attrname
  integer(kind=iwp), intent(in) :: buffer(*)
  integer(kind=iwp) :: attrid
  attrid = mh5_create_attr_array_int(lu,attrname,rank,dims)
  call mh5_put_attr_array_int(attrid,buffer)
  call mh5_close_attr(attrid)
end subroutine mh5_init_attr_array_int

subroutine mh5_init_attr_array_real(lu,attrname,rank,dims,buffer)
  integer(kind=iwp), intent(in) :: lu, rank, dims(*)
  character(len=*), intent(in) :: attrname
  real(kind=wp), intent(in) :: buffer(*)
  integer(kind=iwp) :: attrid
  attrid = mh5_create_attr_array_real(lu,attrname,rank,dims)
  call mh5_put_attr_array_real(attrid,buffer)
  call mh5_close_attr(attrid)
end subroutine mh5_init_attr_array_real

subroutine mh5_init_attr_array_str(lu,attrname,rank,dims,buffer,length)
  integer(kind=iwp), intent(in) :: lu, rank, dims(*), length
  character(len=*), intent(in) :: attrname
  character, intent(in) :: buffer(*)
  integer(kind=iwp) :: attrid
  attrid = mh5_create_attr_array_str(lu,attrname,rank,dims,length)
  call mh5_put_attr_array_str(attrid,buffer)
  call mh5_close_attr(attrid)
end subroutine mh5_init_attr_array_str

subroutine mh5_fetch_attr_scalar_int(lu,attrname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  integer(kind=iwp), intent(out) :: val
  integer(kind=iwp) :: attrid
  attrid = mh5_open_attr(lu,attrname)
  call mh5_get_attr_scalar_int(attrid,val)
  call mh5_close_attr(attrid)
end subroutine mh5_fetch_attr_scalar_int

subroutine mh5_fetch_attr_scalar_real(lu,attrname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  real(kind=wp), intent(out) :: val
  integer(kind=iwp) :: attrid
  attrid = mh5_open_attr(lu,attrname)
  call mh5_get_attr_scalar_real(attrid,val)
  call mh5_close_attr(attrid)
end subroutine mh5_fetch_attr_scalar_real

subroutine mh5_fetch_attr_scalar_str(lu,attrname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  character(len=*), intent(out) :: val
  integer(kind=iwp) :: attrid
  attrid = mh5_open_attr(lu,attrname)
  call mh5_get_attr_scalar_str(attrid,val)
  call mh5_close_attr(attrid)
end subroutine mh5_fetch_attr_scalar_str

subroutine mh5_fetch_attr_array_int(lu,attrname,buffer)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  integer(kind=iwp), intent(_OUT_) :: buffer(*)
  integer(kind=iwp) :: attrid
  attrid = mh5_open_attr(lu,attrname)
  call mh5_get_attr_array_int(attrid,buffer)
  call mh5_close_attr(attrid)
end subroutine mh5_fetch_attr_array_int

subroutine mh5_fetch_attr_array_real(lu,attrname,buffer)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  real(kind=wp), intent(_OUT_) :: buffer(*)
  integer(kind=iwp) :: attrid
  attrid = mh5_open_attr(lu,attrname)
  call mh5_get_attr_array_real(attrid,buffer)
  call mh5_close_attr(attrid)
end subroutine mh5_fetch_attr_array_real

subroutine mh5_fetch_attr_array_str(lu,attrname,buffer)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: attrname
  character, intent(_OUT_) :: buffer(*)
  integer(kind=iwp) :: attrid
  attrid = mh5_open_attr(lu,attrname)
  call mh5_get_attr_array_str(attrid,buffer)
  call mh5_close_attr(attrid)
end subroutine mh5_fetch_attr_array_str

! dset types

function mh5_create_dset_scalar_int(lu,dsetname) result(dsetid)
  integer(kind=iwp) :: dsetid
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(dsetname,mh5_lbl)
  dsetid = mh5_c_create_dset_scalar_int(lu,mh5_lbl)
end function mh5_create_dset_scalar_int

function mh5_create_dset_scalar_real(lu,dsetname) result(dsetid)
  integer(kind=iwp) :: dsetid
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(dsetname,mh5_lbl)
  dsetid = mh5_c_create_dset_scalar_real(lu,mh5_lbl)
end function mh5_create_dset_scalar_real

function mh5_create_dset_scalar_str(lu,dsetname,length) result(dsetid)
  integer(kind=iwp) :: dsetid
  integer(kind=iwp), intent(in) :: lu, length
  character(len=*), intent(in) :: dsetname
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  call f2c_string(dsetname,mh5_lbl)
  dsetid = mh5_c_create_dset_scalar_str(lu,mh5_lbl,length)
end function mh5_create_dset_scalar_str

subroutine mh5_put_dset_scalar_int(dsetid,val)
  integer(kind=iwp), intent(in) :: dsetid
  integer(kind=iwp), intent(in) :: val
  if (mh5_c_put_dset_scalar_int(dsetid,val) < 0) call abend()
end subroutine mh5_put_dset_scalar_int

subroutine mh5_put_dset_scalar_real(dsetid,val)
  integer(kind=iwp), intent(in) :: dsetid
  real(kind=wp), intent(in) :: val
  if (mh5_c_put_dset_scalar_real(dsetid,val) < 0) call abend()
end subroutine mh5_put_dset_scalar_real

subroutine mh5_put_dset_scalar_str(dsetid,val)
  integer(kind=iwp), intent(in) :: dsetid
  character(len=*), intent(in) :: val
  if (mh5_c_put_dset_scalar_str(dsetid,val) < 0) call abend()
end subroutine mh5_put_dset_scalar_str

subroutine mh5_get_dset_scalar_int(dsetid,val)
  integer(kind=iwp), intent(in) :: dsetid
  integer(kind=iwp), intent(out) :: val
  if (mh5_c_get_dset_scalar_int(dsetid,val) < 0) call abend()
end subroutine mh5_get_dset_scalar_int

subroutine mh5_get_dset_scalar_real(dsetid,val)
  integer(kind=iwp), intent(in) :: dsetid
  real(kind=wp), intent(out) :: val
  if (mh5_c_get_dset_scalar_real(dsetid,val) < 0) call abend()
end subroutine mh5_get_dset_scalar_real

subroutine mh5_get_dset_scalar_str(dsetid,val)
  integer(kind=iwp), intent(in) :: dsetid
  character(len=*), intent(out) :: val
  if (mh5_c_get_dset_scalar_str(dsetid,val) < 0) call abend()
end subroutine mh5_get_dset_scalar_str

function mh5_create_dset_array_int(lu,dsetname,rank,dims,dyn) result(dsetid)
  integer(kind=iwp) :: dsetid
  integer(kind=iwp), intent(in) :: lu, rank, dims(*)
  character(len=*), intent(in) :: dsetname
  logical(kind=iwp), intent(in), optional :: dyn
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  logical(kind=iwp) :: isdyn
  isdyn = .false.
  if (present(dyn)) isdyn = dyn
  call f2c_string(dsetname,mh5_lbl)
  if (isdyn) then
    dsetid = mh5_c_create_dset_array_dyn_int(lu,mh5_lbl,rank,dims)
  else
    dsetid = mh5_c_create_dset_array_int(lu,mh5_lbl,rank,dims)
  end if
end function mh5_create_dset_array_int

function mh5_create_dset_array_real(lu,dsetname,rank,dims,dyn) result(dsetid)
  integer(kind=iwp) :: dsetid
  integer(kind=iwp), intent(in) :: lu, rank, dims(*)
  character(len=*), intent(in) :: dsetname
  logical(kind=iwp), intent(in), optional :: dyn
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  logical(kind=iwp) :: isdyn
  isdyn = .false.
  if (present(dyn)) isdyn = dyn
  call f2c_string(dsetname,mh5_lbl)
  if (isdyn) then
    dsetid = mh5_c_create_dset_array_dyn_real(lu,mh5_lbl,rank,dims)
  else
    dsetid = mh5_c_create_dset_array_real(lu,mh5_lbl,rank,dims)
  end if
end function mh5_create_dset_array_real

function mh5_create_dset_array_str(lu,dsetname,rank,dims,length,dyn) result(dsetid)
  integer(kind=iwp) :: dsetid
  integer(kind=iwp), intent(in) :: lu, rank, dims(*), length
  character(len=*), intent(in) :: dsetname
  logical(kind=iwp), intent(in), optional :: dyn
  character(len=MH5_MAX_LBL_LEN) :: mh5_lbl
  logical(kind=iwp) :: isdyn
  isdyn = .false.
  if (present(dyn)) isdyn = dyn
  call f2c_string(dsetname,mh5_lbl)
  if (isdyn) then
    dsetid = mh5_c_create_dset_array_dyn_str(lu,mh5_lbl,rank,dims,length)
  else
    dsetid = mh5_c_create_dset_array_str(lu,mh5_lbl,rank,dims,length)
  end if
end function mh5_create_dset_array_str

subroutine mh5_put_dset_array_int(dsetid,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: dsetid
  integer(kind=iwp), intent(in) :: buffer(*)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: rc
  if (present(exts) .and. present(offs)) then
    rc = mh5_c_put_dset_array_int(dsetid,exts,offs,buffer)
  else if (present(exts) .or. present(offs)) then
    rc = -1
  else
    rc = mh5_c_put_dset_array_int_full(dsetid,buffer)
  end if
  if (rc < 0) call abend()
end subroutine mh5_put_dset_array_int

subroutine mh5_put_dset_array_real(dsetid,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: dsetid
  real(kind=wp), intent(in) :: buffer(*)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: rc
  if (present(exts) .and. present(offs)) then
    rc = mh5_c_put_dset_array_real(dsetid,exts,offs,buffer)
  else if (present(exts) .or. present(offs)) then
    rc = -1
  else
    rc = mh5_c_put_dset_array_real_full(dsetid,buffer)
  end if
  if (rc < 0) call abend()
end subroutine mh5_put_dset_array_real

subroutine mh5_put_dset_array_str(dsetid,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: dsetid
  character, intent(in) :: buffer(*)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: rc
  if (present(exts) .and. present(offs)) then
    rc = mh5_c_put_dset_array_str(dsetid,exts,offs,buffer)
  else if (present(exts) .or. present(offs)) then
    rc = -1
  else
    rc = mh5_c_put_dset_array_str_full(dsetid,buffer)
  end if
  if (rc < 0) call abend()
end subroutine mh5_put_dset_array_str

subroutine mh5_get_dset_array_int(dsetid,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: dsetid
  integer(kind=iwp), intent(_OUT_) :: buffer(*)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: rc
  if (present(exts) .and. present(offs)) then
    rc = mh5_c_get_dset_array_int(dsetid,exts,offs,buffer)
  else if (present(exts) .or. present(offs)) then
    rc = -1
  else
    rc = mh5_c_get_dset_array_int_full(dsetid,buffer)
  end if
  if (rc < 0) call abend()
end subroutine mh5_get_dset_array_int

subroutine mh5_get_dset_array_real(dsetid,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: dsetid
  real(kind=wp), intent(_OUT_) :: buffer(*)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: rc
  if (present(exts) .and. present(offs)) then
    rc = mh5_c_get_dset_array_real(dsetid,exts,offs,buffer)
  else if (present(exts) .or. present(offs)) then
    rc = -1
  else
    rc = mh5_c_get_dset_array_real_full(dsetid,buffer)
  end if
  if (rc < 0) call abend()
end subroutine mh5_get_dset_array_real

subroutine mh5_get_dset_array_str(dsetid,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: dsetid
  character, intent(_OUT_) :: buffer(*)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: rc
  if (present(exts) .and. present(offs)) then
    rc = mh5_c_get_dset_array_str(dsetid,exts,offs,buffer)
  else if (present(exts) .or. present(offs)) then
    rc = -1
  else
    rc = mh5_c_get_dset_array_str_full(dsetid,buffer)
  end if
  if (rc < 0) call abend()
end subroutine mh5_get_dset_array_str

subroutine mh5_extend_dset_array(dsetid,dims)
  integer(kind=iwp), intent(in) :: dsetid
  integer(kind=iwp), intent(in) :: dims(*)
  if (mh5_c_extend_dset_array(dsetid,dims) < 0) call abend()
end subroutine mh5_extend_dset_array

subroutine mh5_get_dset_array_dims(dsetid,dims)
  integer(kind=iwp), intent(in) :: dsetid
  integer(kind=iwp), intent(_OUT_) :: dims(*)
  if (mh5_c_get_dset_array_dims(dsetid,dims) < 0) call abend()
end subroutine mh5_get_dset_array_dims

subroutine mh5_init_dset_scalar_int(lu,dsetname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  integer(kind=iwp), intent(in) :: val
  integer(kind=iwp) :: dsetid
  dsetid = mh5_create_dset_scalar_int(lu,dsetname)
  call mh5_put_dset_scalar_int(dsetid,val)
  call mh5_close_dset(dsetid)
end subroutine mh5_init_dset_scalar_int

subroutine mh5_init_dset_scalar_real(lu,dsetname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  real(kind=wp), intent(in) :: val
  integer(kind=iwp) :: dsetid
  dsetid = mh5_create_dset_scalar_real(lu,dsetname)
  call mh5_put_dset_scalar_real(dsetid,val)
  call mh5_close_dset(dsetid)
end subroutine mh5_init_dset_scalar_real

subroutine mh5_init_dset_scalar_str(lu,dsetname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  character(len=*), intent(in) :: val
  integer(kind=iwp) :: dsetid
  dsetid = mh5_create_dset_scalar_str(lu,dsetname,len(val))
  call mh5_put_dset_scalar_str(dsetid,val)
  call mh5_close_dset(dsetid)
end subroutine mh5_init_dset_scalar_str

subroutine mh5_init_dset_array_int(lu,dsetname,rank,dims,buffer,dyn)
  integer(kind=iwp), intent(in) :: lu, rank, dims(*)
  character(len=*), intent(in) :: dsetname
  integer(kind=iwp), intent(in) :: buffer(*)
  logical(kind=iwp), optional :: dyn
  integer(kind=iwp) :: dsetid
  logical(kind=iwp) :: isdyn
  isdyn = .false.
  if (present(dyn)) isdyn = dyn
  dsetid = mh5_create_dset_array_int(lu,dsetname,rank,dims,isdyn)
  if (mh5_c_put_dset_array_int_full(dsetid,buffer) < 0) call abend()
  call mh5_close_dset(dsetid)
end subroutine mh5_init_dset_array_int

subroutine mh5_init_dset_array_real(lu,dsetname,rank,dims,buffer,dyn)
  integer(kind=iwp), intent(in) :: lu, rank, dims(*)
  character(len=*), intent(in) :: dsetname
  real(kind=wp), intent(in) :: buffer(*)
  logical(kind=iwp), optional :: dyn
  integer(kind=iwp) :: dsetid
  logical(kind=iwp) :: isdyn
  isdyn = .false.
  if (present(dyn)) isdyn = dyn
  dsetid = mh5_create_dset_array_real(lu,dsetname,rank,dims,isdyn)
  if (mh5_c_put_dset_array_real_full(dsetid,buffer) < 0) call abend()
  call mh5_close_dset(dsetid)
end subroutine mh5_init_dset_array_real

subroutine mh5_init_dset_array_str(lu,dsetname,rank,dims,buffer,length,dyn)
  integer(kind=iwp), intent(in) :: lu, rank, dims(*), length
  character(len=*), intent(in) :: dsetname
  character, intent(in) :: buffer(*)
  logical(kind=iwp), optional :: dyn
  integer(kind=iwp) :: dsetid
  logical(kind=iwp) :: isdyn
  isdyn = .false.
  if (present(dyn)) isdyn = dyn
  dsetid = mh5_create_dset_array_str(lu,dsetname,rank,dims,length,isdyn)
  if (mh5_c_put_dset_array_str_full(dsetid,buffer) < 0) call abend()
  call mh5_close_dset(dsetid)
end subroutine mh5_init_dset_array_str

subroutine mh5_fetch_dset_scalar_int(lu,dsetname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  integer(kind=iwp), intent(out) :: val
  integer(kind=iwp) :: dsetid
  dsetid = mh5_open_dset(lu,dsetname)
  call mh5_get_dset_scalar_int(dsetid,val)
  call mh5_close_dset(dsetid)
end subroutine mh5_fetch_dset_scalar_int

subroutine mh5_fetch_dset_scalar_real(lu,dsetname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  real(kind=wp), intent(out) :: val
  integer(kind=iwp) :: dsetid
  dsetid = mh5_open_dset(lu,dsetname)
  call mh5_get_dset_scalar_real(dsetid,val)
  call mh5_close_dset(dsetid)
end subroutine mh5_fetch_dset_scalar_real

subroutine mh5_fetch_dset_scalar_str(lu,dsetname,val)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  character(len=*), intent(out) :: val
  integer(kind=iwp) :: dsetid
  dsetid = mh5_open_dset(lu,dsetname)
  call mh5_get_dset_scalar_str(dsetid,val)
  call mh5_close_dset(dsetid)
end subroutine mh5_fetch_dset_scalar_str

subroutine mh5_fetch_dset_array_int(lu,dsetname,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  integer(kind=iwp), intent(_OUT_) :: buffer(*)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: dsetid
  dsetid = mh5_open_dset(lu,dsetname)
  if (present(exts) .and. present(offs)) then
    call mh5_get_dset_array_int(dsetid,buffer,exts,offs)
  else if (present(exts) .or. present(offs)) then
    call abend()
  else
    call mh5_get_dset_array_int(dsetid,buffer)
  end if
  call mh5_close_dset(dsetid)
end subroutine mh5_fetch_dset_array_int

subroutine mh5_fetch_dset_array_real(lu,dsetname,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  real(kind=wp), intent(_OUT_) :: buffer(*)
  integer(kind=iwp), optional :: exts(*), offs(*)
  integer(kind=iwp) :: dsetid
  dsetid = mh5_open_dset(lu,dsetname)
  if (present(exts) .and. present(offs)) then
    call mh5_get_dset_array_real(dsetid,buffer,exts,offs)
  else if (present(exts) .or. present(offs)) then
    call abend()
  else
    call mh5_get_dset_array_real(dsetid,buffer)
  end if
  call mh5_close_dset(dsetid)
end subroutine mh5_fetch_dset_array_real

subroutine mh5_fetch_dset_array_str(lu,dsetname,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  character, intent(_OUT_) :: buffer(*)
  integer(kind=iwp), optional :: exts(*), offs(*)
  integer(kind=iwp) :: dsetid
  dsetid = mh5_open_dset(lu,dsetname)
  if (present(exts) .and. present(offs)) then
    call mh5_get_dset_array_str(dsetid,buffer,exts,offs)
  else if (present(exts) .or. present(offs)) then
    call abend()
  else
    call mh5_get_dset_array_str(dsetid,buffer)
  end if
  call mh5_close_dset(dsetid)
end subroutine mh5_fetch_dset_array_str

! Workarounds for the fact that assumed-size arguments only match one-dimensional arrays
! in overloaded interfaces (would need support for assumed rank)

subroutine mh5_put_dset_array_int_2d(dsetid,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: dsetid
  integer(kind=iwp), intent(in) :: buffer(:,:)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: rc
  if (present(exts) .and. present(offs)) then
    rc = mh5_c_put_dset_array_int(dsetid,exts,offs,buffer)
  else if (present(exts) .or. present(offs)) then
    rc = -1
  else
    rc = mh5_c_put_dset_array_int_full(dsetid,buffer)
  end if
  if (rc < 0) call abend()
end subroutine mh5_put_dset_array_int_2d

subroutine mh5_put_dset_array_real_2d(dsetid,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: dsetid
  real(kind=wp), intent(in) :: buffer(:,:)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: rc
  if (present(exts) .and. present(offs)) then
    rc = mh5_c_put_dset_array_real(dsetid,exts,offs,buffer)
  else if (present(exts) .or. present(offs)) then
    rc = -1
  else
    rc = mh5_c_put_dset_array_real_full(dsetid,buffer)
  end if
  if (rc < 0) call abend()
end subroutine mh5_put_dset_array_real_2d

subroutine mh5_put_dset_array_real_3d(dsetid,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: dsetid
  real(kind=wp), intent(in) :: buffer(:,:,:)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: rc
  if (present(exts) .and. present(offs)) then
    rc = mh5_c_put_dset_array_real(dsetid,exts,offs,buffer)
  else if (present(exts) .or. present(offs)) then
    rc = -1
  else
    rc = mh5_c_put_dset_array_real_full(dsetid,buffer)
  end if
  if (rc < 0) call abend()
end subroutine mh5_put_dset_array_real_3d

subroutine mh5_fetch_dset_array_int_2d(lu,dsetname,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  integer(kind=iwp), intent(_OUT_) :: buffer(:,:)
  integer(kind=iwp), intent(in), optional :: exts(*), offs(*)
  integer(kind=iwp) :: dsetid
  dsetid = mh5_open_dset(lu,dsetname)
  if (present(exts) .and. present(offs)) then
    call mh5_get_dset_array_int(dsetid,buffer,exts,offs)
  else if (present(exts) .or. present(offs)) then
    call abend()
  else
    call mh5_get_dset_array_int(dsetid,buffer)
  end if
  call mh5_close_dset(dsetid)
end subroutine mh5_fetch_dset_array_int_2d

subroutine mh5_fetch_dset_array_real_2d(lu,dsetname,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  real(kind=wp), intent(out) :: buffer(:,:)
  integer(kind=iwp), optional :: exts(*), offs(*)
  integer(kind=iwp) :: dsetid
  dsetid = mh5_open_dset(lu,dsetname)
  if (present(exts) .and. present(offs)) then
    call mh5_get_dset_array_real(dsetid,buffer,exts,offs)
  else if (present(exts) .or. present(offs)) then
    call abend()
  else
    call mh5_get_dset_array_real(dsetid,buffer)
  end if
  call mh5_close_dset(dsetid)
end subroutine mh5_fetch_dset_array_real_2d

subroutine mh5_fetch_dset_array_real_3d(lu,dsetname,buffer,exts,offs)
  integer(kind=iwp), intent(in) :: lu
  character(len=*), intent(in) :: dsetname
  real(kind=wp), intent(out) :: buffer(:,:,:)
  integer(kind=iwp), optional :: exts(*), offs(*)
  integer(kind=iwp) :: dsetid
  dsetid = mh5_open_dset(lu,dsetname)
  if (present(exts) .and. present(offs)) then
    call mh5_get_dset_array_real(dsetid,buffer,exts,offs)
  else if (present(exts) .or. present(offs)) then
    call abend()
  else
    call mh5_get_dset_array_real(dsetid,buffer)
  end if
  call mh5_close_dset(dsetid)
end subroutine mh5_fetch_dset_array_real_3d

end module mh5

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      Subroutine FckAcc_NoSymq(iAng, iCmp, jCmp, kCmp, lCmp, Shijij,
     &                  iShll, iShell, nijkl,
     &                  AOInt,FMat,DMat,nDens,
     &                  iAO,iAOst,iBas,jBas,kBas,lBas,
     &                  DoCoul,DoExch,Dij,Dkl,Dik,Dil,Djk,Djl,ExFac)
************************************************************************
*                                                                      *
*  Object: to accumulate contibutions from the AO integrals directly   *
*          to the symmetry adapted Fock matrix.                        *
*                                                                      *
*          This version uses square density and fock matrices          *
*          Modifications by HJW, 28.12.98                              *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*          In addition to this complication we have that the order of  *
*          indices in the integrals are not ordered canonically but    *
*          rather in an order such that the contraction step will be   *
*          optimal. Hence, special care has to be taken when tracing   *
*          the density with the integrals so that both entities have   *
*          the same order.                                             *
*                                                                      *
*          The Fock matrix is computed in lower triangular form.       *
*                                                                      *
*          The density matrix is not folded if the shell indices and   *
*          the angular indices are identical.                          *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden. February '93                            *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use Basis_Info, only: nBas
      use Real_Info, only: ThrInt
      Implicit Real*8 (A-H,O-Z)
      Intrinsic Max, Min
#include "real.fh"
#include "print.fh"
      Real*8 AOInt(nijkl,iCmp,jCmp,kCmp,lCmp), FMat(nDens),
     &       DMat(nDens)
      Logical Shij, Shkl, Shijij, DoCoul, DoExch
      Integer iAng(4), iShell(4), iShll(4),
     &        iAO(4), iAOst(4), nCmpx(4), nBasx(4)
*
      Parameter (nCBMax=200)
      Integer Indx(3,nCBMax,4)
*
*                                                                      *
************************************************************************
*                                                                      *
      If (.Not.DoExch.and..Not.DoCoul) Return
      iRout = 38
      iPrint = nPrint(iRout)
*
#ifdef _DEBUGPRINT_
*     Write (*,*) DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1),
*    &            DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One  ,0)
      If (iPrint.ge.49) Then
         Write (6,*) iCmp,jCmp,kCmp,lCmp
         Write (6,*) 'iAO=',iAO
         Write (6,*) 'iAOst=',iAOst
         Write (6,*) 'iShell=',iShell
         Write (6,*) 'iShll=',iShll
         Write (6,*) 'iAng=',iAng
         Write (6,*) DoCoul,DoExch,Shijij
         Write (6,*) 'FMAT,DMAT=',DDot_(nDens,FMat,1,[One],0),
     &                            DDot_(nDens,DMat,1,[One],0)
         Write (6,*) ' FckAcc:AOIn',DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
     &               AOInt,1,AOInt,1), DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
     &               AOInt,1,[One],0)
      End If
#endif
*
      DMax=Max(Dij,Dkl,Dik,Dil,Djk,Djl)
      If (dmax.gt.Zero) Then
        thr=ThrInt/DMax
      Else
        Return
      End If
c
      Shij = iShell(1).eq.iShell(2)
      Shkl = iShell(3).eq.iShell(4)
      ntg=nbas(0)
      Fac=One
      If (Shij) Fac=Fac*Half
      If (Shkl) Fac=Fac*Half
      If (Shijij) Fac=Fac*Half
      Fac_C=Four*Fac
      Fac_E=-Fac*Exfac
C     If (nijkl.ne.ibas*jbas*kbas*lbas) Call SysHalt( 'fckacc_nosym' )
*
      nCmpx(1)=iCmp
      nCmpx(2)=jCmp
      nCmpx(3)=kCmp
      nCmpx(4)=lCmp
      nBasx(1)=iBas
      nBasx(2)=jBas
      nBasx(3)=kBas
      nBasx(4)=lBas
      nCB_Max=Max(iCmp*iBas,jCmp*jBas,kCmp*kBas,lCmp*lBas)
      If (nCB_Max.gt.nCBMax) Then
         Call WarningMessage(2,'FckAcc_NoSym: nCB_Max.gt.nCBMax')
         Write (6,*) 'nCB_Max=',nCB_Max
         Call Abend()
      End If
      Do ii = 1, 4
         iCB = 0
         Do iC = 1, nCmpx(ii)
            iSO=iAOtSO(iAO(ii)+iC,0)+iAOSt(ii)
            Do i = 1, nBasx(ii)
               iCB = iCB + 1
               Indx(1,iCB,ii)=iC
               Indx(2,iCB,ii)=i
               Indx(3,iCB,ii)=iSO
               iSO = iSO + 1
            End Do
         End Do
      End Do
*
      nkl=kBas*lBas
      nij=iBas*jBas
*
      If (.Not.DoExch) Then
         Do lCB = 1, lCmp*lBas
            i4 =Indx(1,lCB,4)
            l  =Indx(2,lCB,4)
            lSO=Indx(3,lCB,4)
            ll=(lSO-1)*ntg
*
            Do kCB = 1, kCmp*kBas
               i3 =Indx(1,kCB,3)
               k  =Indx(2,kCB,3)
               kSO=Indx(3,kCB,3)
               kk=(kSO-1)*ntg
               kl=ll+kSO
*
               kl_=(l-1)*kBas+k
*
               Do jCB = 1, jCmp*jBas
                  i2 =Indx(1,jCB,2)
                  j  =Indx(2,jCB,2)
                  jSO=Indx(3,jCB,2)
                  jj=(jSO-1)*ntg
*
                  Do iCB = 1, iCmp*iBas
                     i1 =Indx(1,iCB,1)
                     i  =Indx(2,iCB,1)
                     iSO=Indx(3,iCB,1)
                     ij=jj+iSO
*
                     ij_=(j-1)*iBas+i
                     ijkl=(kl_-1)*nij+ij_
                     AOijkl = Fac_C*AOInt(ijkl,i1,i2,i3,i4)
*
                     If (Abs(AOijkl).gt.Thr) Then
*
                        FMat(ij) = FMat(ij)+AOijkl*DMat(kl)
                        FMat(kl) = FMat(kl)+AOijkl*DMat(ij)
*
                     End If
                  End Do
               End Do
            End Do
         End Do
      Else If (.Not.DoCoul) Then
         Do lCB = 1, lCmp*lBas
            i4 =Indx(1,lCB,4)
            l  =Indx(2,lCB,4)
            lSO=Indx(3,lCB,4)
            ll=(lSO-1)*ntg
*
            Do kCB = 1, kCmp*kBas
               i3 =Indx(1,kCB,3)
               k  =Indx(2,kCB,3)
               kSO=Indx(3,kCB,3)
               kk=(kSO-1)*ntg
*
               kl_=(l-1)*kBas+k
*
               Do jCB = 1, jCmp*jBas
                  i2 =Indx(1,jCB,2)
                  j  =Indx(2,jCB,2)
                  jSO=Indx(3,jCB,2)
                  jk=kk+jSO
                  jl=ll+jSO
*
                  Do iCB = 1, iCmp*iBas
                     i1 =Indx(1,iCB,1)
                     i  =Indx(2,iCB,1)
                     iSO=Indx(3,iCB,1)
                     ik=kk+iSO
                     il=ll+iSO
*
                     ij_=(j-1)*iBas+i
                     ijkl=(kl_-1)*nij+ij_
                     AOijkl = Fac_E*AOInt(ijkl,i1,i2,i3,i4)
*
                     If (Abs(AOijkl).gt.Thr) Then
*
                        FMat(ik) = FMat(ik)+AOijkl*DMat(jl)
                        FMat(il) = FMat(il)+AOijkl*DMat(jk)
                        FMat(jl) = FMat(jl)+AOijkl*DMat(ik)
                        FMat(jk) = FMat(jk)+AOijkl*DMat(il)
*
                     End If
                  End Do
               End Do
            End Do
         End Do
      Else
         Do lCB = 1, lCmp*lBas
            i4 =Indx(1,lCB,4)
            l  =Indx(2,lCB,4)
            lSO=Indx(3,lCB,4)
            ll=(lSO-1)*ntg
*
            Do kCB = 1, kCmp*kBas
               i3 =Indx(1,kCB,3)
               k  =Indx(2,kCB,3)
               kSO=Indx(3,kCB,3)
               kk=(kSO-1)*ntg
               kl=ll+kSO
*
               kl_=(l-1)*kBas+k
*
               Do jCB = 1, jCmp*jBas
                  i2 =Indx(1,jCB,2)
                  j  =Indx(2,jCB,2)
                  jSO=Indx(3,jCB,2)
                  jj=(jSO-1)*ntg
                  jk=kk+jSO
                  jl=ll+jSO
*
                  Do iCB = 1, iCmp*iBas
                     i1 =Indx(1,iCB,1)
                     i  =Indx(2,iCB,1)
                     iSO=Indx(3,iCB,1)
                     ik=kk+iSO
                     il=ll+iSO
                     ij=jj+iSO
*
                     ij_=(j-1)*iBas+i
                     ijkl=(kl_-1)*nij+ij_
                     AOijkl = AOInt(ijkl,i1,i2,i3,i4)
                     If (Abs(AOijkl).gt.Thr) Then
*
                        FMat(ij) = FMat(ij)+Fac_C*AOijkl*DMat(kl)
                        FMat(kl) = FMat(kl)+Fac_C*AOijkl*DMat(ij)
                        FMat(ik) = FMat(ik)+Fac_E*AOijkl*DMat(jl)
                        FMat(il) = FMat(il)+Fac_E*AOijkl*DMat(jk)
                        FMat(jl) = FMat(jl)+Fac_E*AOijkl*DMat(ik)
                        FMat(jk) = FMat(jk)+Fac_E*AOijkl*DMat(il)
*
                     End If
                  End Do
               End Do
            End Do
         End Do
      End If
*
C     If (iPrint.ge.99) Then
C        Write (*,*) 'FMAT,DMAT=',DDot_(nDens,FMat,1,One,0),
C    &                            DDot_(nDens,DMat,1,One,0)
c     End If
*
*     Call GetMem(' Exit FckAcc','CHECK','REAL',iDum,iDum)
      Return
#ifndef _DEBUGPRINT_
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(iAng)
         Call Unused_integer_array(iShll)
      End If
#endif
      End

      Subroutine FckAcc_NoSym(iAng, iCmp, jCmp, kCmp, lCmp, Shijij,
     &                  iShll, iShell, nijkl,
     &                  AOInt,FMat,DMat,nDens,
     &                  iAO,iAOst,iBas,jBas,kBas,lBas,ExFac)
************************************************************************
*                                                                      *
*  Object: to accumulate contibutions from the AO integrals directly   *
*          to the symmetry adapted Fock matrix.                        *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*          In addition to this complication we have that the order of  *
*          indices in the integrals are not ordered canonically but    *
*          rather in an order such that the contraction step will be   *
*          optimal. Hence, special care has to be taken when tracing   *
*          the density with the integrals so that both entities have   *
*          the same order.                                             *
*                                                                      *
*          The Fock matrix is computed in lower triangular form.       *
*                                                                      *
*          The density matrix is not folded if the shell indices and   *
*          the angular indices are identical.                          *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, Sweden. February '93                            *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use Real_Info, only: CutInt
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8 AOInt(nijkl,iCmp,jCmp,kCmp,lCmp), FMat(nDens),
     &       DMat(nDens)
      Logical Shij, Shkl, Shijij
      Integer iAng(4), iShell(4), iShll(4),
     &        in(4), iAO(4), iAOst(4)
*     Local Arrays
*
*     Statement Function
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*
      iRout = 38
      iPrint = nPrint(iRout)
*
*     Write (*,*) DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1),
*    &            DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,One  ,0)
*     If (iPrint.ge.49) Then
*        Write (*,*) ' FckAcc:AOIn',DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
*    &               AOInt,1,AOInt,1), DDot_(nijkl*iCmp*jCmp*kCmp*lCmp,
*    &               AOInt,1,One,0)
*     End If
*
*     Quadruple loop over elements of the basis functions angular
*     description. Loops are reduced to just produce unique SO integrals
*     Observe that we will walk through the memory in AOInt in a
*     sequential way.
*
      Shij = iShell(1).eq.iShell(2)
      Shkl = iShell(3).eq.iShell(4)
*
      Fac=One
      If (Shij) Fac=Fac*Half
      If (Shkl) Fac=Fac*Half
      If (Shijij) Fac=Fac*Half
      Fac_C=Four*Fac
      Fac_E=-Fac*ExFac
*
      Do 100 i1 = 1, iCmp
         in(1)=iAOtSO(iAO(1)+i1,0)+iAOst(1)
         Do 200 i2 = 1, jCmp
            in(2)=iAOtSO(iAO(2)+i2,0)+iAOst(2)
            Do 300 i3 = 1, kCmp
               in(3)=iAOtSO(iAO(3)+i3,0)+iAOst(3)
               Do 400 i4 = 1, lCmp
                  in(4)=iAOtSO(iAO(4)+i4,0)+iAOst(4)
*
*................ Get the starting SO indices.
*
                  iSO = in(1)
                  jSO = in(2)
                  kSO = in(3)
                  lSO = in(4)
*
                  nijkl=0
                  Do l = lSO, lSO+lBas-1
                     Do k = kSO, kSO+kBas-1
                        kl=iTri(k,l)
                        D_kl=DMat(kl)*Fac_C
                        F_kl=Zero
*
                        Do j = jSO, jSO+jBas-1
                           jk=iTri(j,k)
                           jl=iTri(j,l)
                           D_jl=DMat(jl)*Fac_E
                           D_jk=DMat(jk)*Fac_E
                           F_jl=Zero
                           F_jk=Zero
                           Do i = iSO, iSO+iBas-1
                              nijkl=nijkl+1
                              AOijkl = AOInt(nijkl,i1,i2,i3,i4)
                              If (Abs(AOijkl).lt.CutInt) Go To 10
                              ij=iTri(i,j)
                              ik=iTri(i,k)
                              il=iTri(i,l)
*
                              FMat(ij) = FMat(ij)+AOijkl*D_kl
                              F_kl     = F_kl    +AOijkl*DMat(ij)
*
                              FMat(ik) = FMat(ik)+AOijkl*D_jl
                              F_jl     = F_jl    +AOijkl*DMat(ik)
                              FMat(il) = FMat(il)+AOijkl*D_jk
                              F_jk     = F_jk    +AOijkl*DMat(il)
*
 10                           Continue
                           End Do
                           FMat(jl)=FMat(jl)+F_jl*Fac_E
                           FMat(jk)=FMat(jk)+F_jk*Fac_E
                        End Do
                        FMat(kl)=FMat(kl)+F_kl*Fac_C
                     End Do
                  End Do
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
*
*     Call GetMem(' Exit FckAcc','CHECK','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(iAng)
         Call Unused_integer_array(iShll)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE VNEG_CHT3(VEC1,IST1,VEC2,IST2,NS)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VEC1(*),VEC2(*)
      IF(IST1.EQ.1.AND.IST2.EQ.1)THEN
      DO 2 I=1,NS
      VEC2(I  )=-VEC1(I  )
 2    CONTINUE
      ELSE
      IS1=1
      IS2=1
      DO 1 I=1,NS
      VEC2(IS2)=-VEC1(IS1)
      IS1=IS1+IST1
      IS2=IS2+IST2
 1    CONTINUE
      ENDIF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GF_Harmonic_Frequencies(G,GInv,Tmp1,Tmp2,EVec,EVal,RedM,iNeg,nX,nDoF)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One, autocm
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nX, nDoF
real(kind=wp), intent(in) :: G(nX**2), GInv(nX**2)
real(kind=wp), intent(out) :: Tmp1(nDoF,nDoF), EVec(nDoF,nDoF), EVal(nDoF), RedM(nDoF)
real(kind=wp), intent(inout) :: Tmp2(nX**2)
integer(kind=iwp), intent(out) :: iNeg
integer(kind=iwp) :: iHarm, iiT, iX, jHarm, jj, jX
real(kind=wp) :: r2, rlow, temp, Test_i, Test_j, tmp
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute eigenvectors and eigenfunctions

call unitmat(Tmp1,nDoF)
call NIDiag_new(Tmp2,Tmp1,nDoF,nDoF)

EVal(:) = Zero
EVec(:,:) = Zero

! Move over eigenvalue and eigenvectors, note that the eigenvectors
! are transformed back to Cartesian coordinates from mass-weighted
! Cartesians.

do iX=1,nDoF
  iiT = nTri_Elem(iX)
  EVal(iX) = Tmp2(iiT)
  EVec(:,iX) = Tmp1(:,iX)

  r2 = Zero
  do jX=1,nDoF
    jj = (jX-1)*nDoF+jX
    tmp = EVec(jX,iX)
    tmp = tmp*sqrt(G(jj))
    EVec(jX,iX) = tmp
    r2 = r2+tmp**2
  end do
  EVec(:,iX) = EVec(:,iX)/sqrt(r2)
end do
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt('EVal',' ',EVal,1,nDoF)
call RecPrt('EVec',' ',EVec,nDoF,nDoF)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the harmonic frequencies
!                                                                      *
!***********************************************************************
!                                                                      *
iNeg = 0
do iHarm=1,nDoF
  temp = EVal(iHarm)

  ! Fix imaginary frequencies

  if (temp >= Zero) then
    EVal(iHarm) = sqrt(temp)*autocm
  else
    iNeg = iNeg+1
    EVal(iHarm) = -sqrt(abs(temp))*autocm
  end if
end do
#ifdef _DEBUGPRINT_
call RecPrt('Converted EVal',' ',EVal(:),1,nDoF)
#endif

! Normalize over the metric of the masses

do iHarm=1,nDoF
  Tmp1(:,1) = EVec(:,iHarm)
  call DGEMM_('N','N',nDoF,1,nDoF,One,GInv,nDoF,Tmp1,nDoF,Zero,Tmp2,nDoF)
  r2 = DDot_(nDoF,Tmp1,1,Tmp2,1)
  RedM(iHarm) = r2
  EVec(:,iHarm) = EVec(:,iHarm)/sqrt(r2)
end do
#ifdef _DEBUGPRINT_
call RecPrt('Normal coordinates (Q)',' ',EVec,nDoF,nDoF)
#endif

! Order, from low to high. Put translations and rotations last.

do iHarm=1,nDoF-1
  Test_i = EVal(iHarm)
  if (abs(Test_i) < 1.0e-3_wp) Test_i = 1.0e5_wp
  do jHarm=iHarm+1,nDoF
    Test_j = EVal(jHarm)
    if (abs(Test_j) < 1.0e-3_wp) Test_j = 1.0e5_wp
    if (Test_j < Test_i) then
      rlow = Test_i
      Test_i = Test_j
      Test_j = rlow
      rlow = EVal(iHarm)
      EVal(iHarm) = EVal(jHarm)
      EVal(jHarm) = rLow
      rlow = RedM(iHarm)
      RedM(iHarm) = RedM(jHarm)
      RedM(jHarm) = rLow
      do iX=1,nDoF
        tmp = EVec(iX,iHarm)
        EVec(iX,iHarm) = EVec(iX,jHarm)
        EVec(iX,jHarm) = tmp
      end do
    end if
  end do
end do
#ifdef _DEBUGPRINT_
call RecPrt('Frequencies (cm-1)',' ',EVal(:),1,nDoF)
call RecPrt('Reduced masses (u)',' ',RedM,1,nDoF)
call RecPrt('Normal Coordinates',' ',EVec,nDoF,nDoF)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine GF_Harmonic_Frequencies

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005,2006, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine GetRawPAOs(R,C,nBas,nOrb,nFro,nOrb2Loc,nSym,Normalize)
! Thomas Bondo Pedersen, December 2005.
! - revised january 2006 (Thomas Bondo Pedersen).
!
! Purpose: compute projected AOs spanning the primary space from the
!          formula
!
!          R = 1 - Do*S = D*S
!
!          where Do is the "AO density" matrix of the orthogonal
!          complement orbitals and D that of the orbital space to be
!          localised (primary space).
!          S is the AO overlap matrix (which is read from disk).
!
!          Which formula is used depends on the dimensions of the
!          two spaces (such that the most economical is computed).
!
!          If (Normalize): normalize each PAO (recommended).
!                          Note that if the norm of the PAO is
!                          smaller than 1.0e-6_wp, it will not be
!                          normalized (it is left unchanged).
!
!-------------------------------------------------------------
!-TODO/FIXME: it is in most cases faster to use Do*S=C*(C^T*S)
!-------------------------------------------------------------

use Data_Structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: R(*)
real(kind=wp), intent(in) :: C(*)
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym), nFro(nSym), nOrb2Loc(nSym)
logical(kind=iwp), intent(in) :: Normalize
integer(kind=iwp) :: i, iSym, lDo, lOff, mu, nB, nF, nO2L, nOrth, nRest
real(kind=wp) :: OvlpR
character(len=80) :: Txt
type(DSBA_Type) :: CB, Ovlp, RB
real(kind=wp), allocatable, target :: DoRt(:)
real(kind=wp), pointer :: DoR(:,:)
character(len=*), parameter :: SecNam = 'GetRawPAOs'
real(kind=r8), external :: ddot_

! Read the overlap matrix from disk.
! ----------------------------------

call Allocate_DT(Ovlp,nBas,nBas,nSym,label='Ovlp')
call GetOvlp_Localisation(Ovlp%A0,'Sqr',nBas,nSym)

call Allocate_DT(RB,nBas,nBas,nSym,label='RB',Ref=R)
call Allocate_DT(CB,nBas,nBas,nSym,label='RB',Ref=C)

! Compute R.
! ----------

lDo = nBas(1)**2
do iSym=2,nSym
  lDo = max(lDo,nBas(iSym)**2)
end do
call mma_allocate(DoRt,lDo,label='Do')

do iSym=1,nSym

  nB = nBas(iSym)
  DoR(1:nB,1:nB) => DoRt(1:nB**2)
  if (nB > 0) then

    nF = nFro(iSym)
    nO2L = nOrb2Loc(iSym)
    nRest = nOrb(iSym)-nF-nO2L
    nOrth = nF+nRest ! dim. of orthogonal complement

    if (nO2L < 1) then ! R = 0
      RB%SB(iSym)%A2(:,:) = Zero
    else if (nOrth < 0) then ! error
      call SysAbendMsg(SecNam,'Dimension of orthogonal complement space < 0',' ')
    else if (nOrth == 0) then ! R = 1
      RB%SB(iSym)%A2(:,:) = Zero
      do i=1,nB
        RB%SB(iSym)%A2(i,i) = One
      end do
    else if (nOrth < nO2L) then ! R = 1 - Do*S
      if (nRest > 0) then
        lOff = nF+nO2L+1
        call GetDens_Localisation(DoR,CB%SB(iSym)%A2(:,lOff:),nB,nRest)
      else
        DoR(:,:) = Zero
      end if
      if (nF > 0) then
        call GetDens_Localisation(RB%SB(iSym)%A2,CB%SB(iSym)%A2,nB,nF)
        DoR(:,:) = DoR(:,:)+RB%SB(iSym)%A2(:,:)
      end if
      call DGEMM_('N','N',nB,nB,nB,-One,DoR,nB,Ovlp%SB(iSym)%A2,nB,Zero,RB%SB(iSym)%A2,nB)
      do i=1,nB
        RB%SB(iSym)%A2(i,i) = RB%SB(iSym)%A2(i,i)+One
      end do
    else ! R = D*S
      lOff = nF+1
      call GetDens_Localisation(DoR,CB%SB(iSym)%A2(:,lOff:),nB,nO2L)
      call DGEMM_('N','N',nB,nB,nB,One,DoR,nB,Ovlp%SB(iSym)%A2,nB,Zero,RB%SB(iSym)%A2,nB)
    end if

  end if

end do

! If requested, normalize the PAOs.
! ---------------------------------

if (Normalize) then
  do iSym=1,nSym
    nB = nBas(iSym)
    DoR(1:nB,1:nB) => DoRt(1:nB**2)
    if (nB > 0) then
      call DGEMM_('N','N',nB,nB,nB,One,Ovlp%SB(iSym)%A2,nB,RB%SB(iSym)%A2,nB,Zero,DoR,nB)
      do mu=1,nB
        OvlpR = dDot_(nB,RB%SB(iSym)%A2(:,mu),1,DoR(:,mu),1)
        if (OvlpR > 1.0e-6_wp) then
          RB%SB(iSym)%A2(:,mu) = RB%SB(iSym)%A2(:,mu)/sqrt(OvlpR)
        else if (OvlpR < Zero) then
          write(Txt,'(A,1P,D15.5)') 'Overlap = ',OvlpR
          call SysAbendMsg(SecNam,'Negative raw PAO overlap!',Txt)
        end if
      end do
    end if
  end do
end if

nullify(DoR)
call mma_deallocate(DoRt)
call Deallocate_DT(Ovlp)
call Deallocate_DT(RB)
call Deallocate_DT(CB)

end subroutine GetRawPAOs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_X_Test
!
!> @brief
!>   Check Cholesky decomposition of matrix \p X
!> @author Thomas Bondo Pedersen
!>
!> @details
!> The difference between the matrix \p X and its Cholesky
!> representation is calculated and returned in array \p Y. If the
!> RMS error is less than \p Thr, \p irc = ``0`` is returned, else a positive
!> value is returned (a negative value signals an input error).
!> The input matrix \p X may be stored as a lower triangle
!> (\p Square = ``.false.``) or as a full square matrix (\p Square = ``.true.``).
!> The dimension of \p Y will be the same as that of \p X
!> (i.e. ``n(n+1)/2`` for lower triangular storage or ``n*n`` for full
!> square storage).
!>
!> @param[in]  X      The \p n &times; \p n matrix to be tested
!> @param[in]  n      Dimension of matrix \p X
!> @param[in]  Square Flag for packing of \p X
!> @param[in]  Vec    Cholesky vectors representing \p X
!> @param[in]  nVec   Number of Cholesky vectors
!> @param[in]  xf     Factor for the scaling of the vectors
!> @param[out] Y      ``Y = X - xf*Vec*VecT``
!> @param[in]  lY     Dimension of array \p Y
!> @param[in]  Thr    Threshold allowed for RMS error
!> @param[out] irc    Return code
!***********************************************************************

subroutine Cho_X_Test(X,n,Square,Vec,nVec,xf,Y,lY,Thr,irc)

use Index_Functions, only: nTri_Elem
use Constants, only: Zero, One
use Definitions, only: wp, wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n, nVec, lY
real(kind=wp), intent(in) :: X(*), Vec(n,nVec), xf, Thr
real(kind=wp), intent(out) :: Y(lY)
logical(kind=iwp), intent(in) :: Square
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: lX
real(kind=wp) :: RMS
real(kind=wp), external :: ddot_

! Check input.
! ------------

if (n < 1) then ! nothing to do
  irc = 0
  return
else if ((nVec < 0) .or. (Thr < Zero)) then ! input error
  irc = -1
  return
end if
if (Square) then
  lX = n**2
else
  lX = nTri_Elem(n)
end if
if (lY < lX) then ! insufficient memory
  irc = -2
  return
end if

! Compute Y(ij) = X(ij) - xf * sum_J L(iJ) * L(jJ).
! -------------------------------------------------

Y(1:lX) = X(1:lX)
if (Square) then
  call DGEMM_('N','T',n,n,nVec,-xf,Vec,n,Vec,n,One,Y,n)
else
  call dGeMM_Tri('N','T',n,n,nVec,-xf,Vec,n,Vec,n,One,Y,n)
end if

! Check RMS error.
! ----------------

RMS = sqrt(dDot_(lX,Y,1,Y,1)/real(lX,kind=wp))
if (RMS > Thr) then
  irc = 1
else
  irc = 0
end if

end subroutine Cho_X_Test

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994-1996, Jeppe Olsen                                 *
************************************************************************
       SUBROUTINE DENSI2(I12,RHO1,RHO2,L,R,LUL,LUR,ieaw,n1,n2)
*
* Density matrices between L and R
*
* I12 = 1 => only one-body density
* I12 = 2 => one- and two-body density matrices
*
* Jeppe Olsen,      Oct 94
* GAS modifications Aug 95
* Two body density added, '96
*
* Two-body density is stored as rho2(ijkl)=<l!e(ij)e(kl)-delta(jk)e(il)!r>
* ijkl = ij*(ij-1)/2+kl, ij.ge.kl
*
      IMPLICIT REAL*8(A-H,O-Z)

*
* =====
*.Input
* =====
*
*.Definition of L and R is picked up from CANDS
* with L being S and  R being C
#include "cands.fh"
#include "detdim.fh"
#include "orbinp_mclr.fh"
#include "cicisp_mclr.fh"
#include "strbas_mclr.fh"
#include "cstate_mclr.fh"
#include "strinp_mclr.fh"
#include "stinf_mclr.fh"
#include "csm.fh"
#include "WrkSpc.fh"
#include "crun_mclr.fh"
#include "cprnt_mclr.fh"
#include "spinfo_mclr.fh"

#include "Input.fh"
#include "csmprd.fh"
*. Specific input
      REAL*8 L
      DIMENSION L(*),R(*)
*.Output
      DIMENSION RHO1(*),RHO2(*)
*. Before I forget it :
      DIMENSION iSXSTSM(1),IDUMMY(1)

      IDUM = 0
CFUE  IPRDEN=0
      IPRDEN=1
      ZERO = 0.0D0
      NGAS=3

      CALL SETVEC(RHO1,ZERO ,NACOB ** 2 )
      CALL SETVEC(RHO2,ZERO ,NACOB ** 2 *(NACOB**2+1)/2)
*
* Info for this internal space
*
      IATP = IASTFI(ISSPC)
      IBTP = IBSTFI(ISSPC)
      JATP = IASTFI(ICSPC)
      JBTP = IBSTFI(ICSPC)
      IF(IATP.NE.JATP.OR.IBTP.NE.JBTP) THEN
        WRITE(6,*) ' My world is falling apart'
        WRITE(6,*) ' C and sigma belongs to different types of strings'
        WRITE(6,*) ' IATP IBTP JATP JBTP ',IATP,IBTP,JATP,JBTP
        Call Abend( )
      END IF
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
*. Offsets for supergroups
      IOCTPA = 1
      IOCTPB = 1
*
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)

*
* string sym, string sym => sx sym
* string sym, string sym => dx sym
      CALL GETMEM('KSTSTS','ALLO','INTE',KSTSTS,NSMST ** 2)
      CALL GETMEM('KSTSTD','ALLO','INTE',KSTSTD,NSMST ** 2)
      CALL STSTSM_MCLR(iWORK(KSTSTS),iWORK(KSTSTD),NSMST)
*. Largest block of strings in zero order space
      MAXA0 = IMNMX(iWORK(KNSTSO(IATP)),NSMST*NOCTYP(IATP),2)
      MAXB0 = IMNMX(iWORK(KNSTSO(IBTP)),NSMST*NOCTYP(IBTP),2)
      MXSTBL0 = MXNSTR
*. Largest number of strings of given symmetry and type
      MAXA = 0
      IF(NAEL.GE.1) THEN
        MAXA1 = IMNMX(iWORK(KNSTSO(IATPM1)),NSMST*NOCTYP(IATPM1),2)
        MAXA = MAX(MAXA,MAXA1)
      END IF
      IF(NAEL.GE.2) THEN
        MAXA1 = IMNMX(iWORK(KNSTSO(IATPM2)),NSMST*NOCTYP(IATPM2),2)
        MAXA = MAX(MAXA,MAXA1)
      END IF
      MAXB = 0
      IF(NBEL.GE.1) THEN
        MAXB1 = IMNMX(iWORK(KNSTSO(IBTPM1)),NSMST*NOCTYP(IBTPM1),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      IF(NBEL.GE.2) THEN
        MAXB1 = IMNMX(iWORK(KNSTSO(IBTPM2)),NSMST*NOCTYP(IBTPM2),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      MXSTBL = MAX(MAXA,MAXB)
*. Largest number of resolution strings and spectator strings
*  that can be treated simultaneously
*. replace with MXINKA !!!
      MAXI = MIN(MXINKA,MXSTBL)
      MAXK = MIN(MXINKA,MXSTBL)
*Largest active orbital block belonging to given type and symmetry
      MXTSOB = 0
      DO IOBTP = 1, NGAS
      DO IOBSM = 1, NSMOB
       MXTSOB = MAX(MXTSOB,NOBPTS(IOBTP,IOBSM))
      END DO
      END DO
      MAXIJ = MXTSOB ** 2
*.Local scratch arrays for blocks of C and sigma
      LSCR1 = 0
      IF(ICISTR.LE.2) THEN
        LSCR1 = MXSB
      ELSE IF(ICISTR.EQ.3) THEN
        LSCR1 = MXSOOB
      END IF
      IF(ICISTR.EQ.1) THEN
        CALL GETMEM('KCB','ALLO','REAL',KCB,LSCR1)
        CALL GETMEM('KSB','ALLO','REAL',KSB,LSCR1)
      END IF

*.SCRATCH space for block of two-electron density matrix
* A 4 index block with four indeces belonging OS class

      INTSCR = MXTSOB ** 4

      CALL GETMEM('INSCR','ALLO','REAL',KINSCR,INTSCR)

*
*. Arrays giving allowed type combinations '
      CALL GETMEM('SIOIO','ALLO','INTE',KSIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('CIOIO','ALLO','INTE',KCIOIO,NOCTPA*NOCTPB)

      CALL IAIBCM_MCLR(MNR1IC(ISSPC),MXR3IC(ISSPC),NOCTPA,NOCTPB,
     &            iWORK(KEL1(IATP)),iWORK(KEL3(IATP)),
     &            iWORK(KEL1(IBTP)),iWORK(KEL3(IBTP)),
     &            iWORK(KSIOIO),IPRDEN)

*
      CALL IAIBCM_MCLR(MNR1IC(ICSPC),MXR3IC(ICSPC),NOCTPA,NOCTPB,
     &            iWORK(KEL1(IATP)),iWORK(KEL3(IATP)),
     &            iWORK(KEL1(IBTP)),iWORK(KEL3(IBTP)),
     &            iWORK(KCIOIO),IPRDEN)

*
* Get memory requirements
*
*
      CALL MXRESC(iWORK(KCIOIO),IATP,IBTP,NOCTPA,NOCTPB,NSMST,
     &            iWORK(KNSTSO(IATP)),iWORK(KNSTSO(IBTP)),
     &            IATP+1,iWORK(KNSTSO(IATP+1)),NOCTYP(IATP+1),
     &            iWORK(KNSTSO(IBTP+1)),NOCTYP(IBTP+1),
     &            NSMOB,3,3,NTSOB,IPRCIX,MAXK,
     &            iWORK(KNSTSO(IATP+2)),NOCTYP(IATP+2),
     &            iWORK(KNSTSO(IBTP+2)),NOCTYP(IBTP+2),
     &            iWORK(KEL123(IATP)),iWORK(KEL123(IBTP)),
     &            MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL,MXIJST,
     &            MXIJSTF)


      LSCR2 = MAX(MXCJ,MXCIJA,MXCIJB,MXCIJAB)
      LSCR12 = MAX(LSCR1,2*LSCR2)
      CALL GETMEM('KC2','ALLO','REAL',KC2,LSCR12)
      KSSCR = KC2
      KCSCR = KC2 + LSCR2
*
*. Space for annihilation/creation mappings
      MAXIK = MAX(MAXI,MAXK)
      LSCR3 = MAX(MXSTBL*MXTSOB,MXIJST,MAXIK*MXTSOB*MXTSOB,MXSTBL0)
      CALL GETMEM('I1','ALLO','INTE',KI1,LSCR3)
      CALL GETMEM('I2','ALLO','INTE',KI2,LSCR3)
      CALL GETMEM('I3','ALLO','INTE',KI3,LSCR3)
      CALL GETMEM('I4','ALLO','INTE',KI4,LSCR3)
      CALL GETMEM('XI1S','ALLO','REAL',KXI1S,LSCR3)
      CALL GETMEM('XI2S','ALLO','REAL',KXI2S,LSCR3)
      CALL GETMEM('XI3S','ALLO','REAL',KXI3S,LSCR3)
      CALL GETMEM('XI4S','ALLO','REAL',KXI4S,LSCR3)
*. Arrays giving block type
      CALL GETMEM('SBLTP','ALLO','INTE',KSBLTP,NSMST)
      CALL GETMEM('CBLTP','ALLO','INTE',KCBLTP,NSMST)
*. Arrays for additional symmetry operation
      KSVST = 1
      CALL ZBLTP(ISMOST(1,ISSM),NSMST,IDC,iWORK(KSBLTP),iWORK(KSVST))
      CALL ZBLTP(ISMOST(1,ICSM),NSMST,IDC,iWORK(KCBLTP),iWORK(KSVST))
*.10 OOS arrayy
      NOOS = NOCTPA*NOCTPB*NSMST
      CALL GETMEM('OOS1','ALLO','INTE',KOOS1,NOOS)
      CALL GETMEM('OOS2','ALLO','INTE',KOOS2,NOOS)
      CALL GETMEM('OOS3','ALLO','INTE',KOOS3,NOOS)
      CALL GETMEM('OOS4','ALLO','INTE',KOOS4,NOOS)
      CALL GETMEM('OOS5','ALLO','INTE',KOOS5,NOOS)
      CALL GETMEM('OOS6','ALLO','INTE',KOOS6,NOOS)
      CALL GETMEM('OOS7','ALLO','INTE',KOOS7,NOOS)
      CALL GETMEM('OOS8','ALLO','INTE',KOOS8,NOOS)
      CALL GETMEM('OOS9','ALLO','INTE',KOOS9,NOOS)
      CALL GETMEM('OOS10','ALLO','INTE',KOOS10,NOOS)
* scratch space containing active one body
      CALL GETMEM('RHO1S','ALLO','REAL',KRHO1S,NACOB ** 2)
*. For natural orbitals
      CALL GETMEM('RHO1P','ALLO','REAL',KRHO1P,NACOB*(NACOB+1)/2)
      CALL GETMEM('XNATO','ALLO','REAL',KXNATO,NACOB **2)
*. Natural orbitals in symmetry blocks
      CALL GETMEM('RHO1SM','ALLO','REAL',KRHO1SM,NACOB ** 2)
      CALL GETMEM('XNATSM','ALLO','REAL',KXNATSM,NACOB ** 2)
      CALL GETMEM('OCCSM','ALLO','REAL',KOCCSM,NACOB)
*
*
*. Transform from combination scaling to determinant scaling
*
      IF(IDC.NE.1.AND.ICISTR.EQ.1) THEN
*. Left CI vector
        CALL SCDTC2_MCLR(L,ISMOST(1,ISSM),iWORK(KSBLTP),NSMST,
     &              NOCTPA,NOCTPB,iWORK(KNSTSO(IATP)),
     &              iWORK(KNSTSO(IBTP)),iWORK(KSIOIO),IDC,
     &              2,IDUMMY,IPRDIA)
*. Right CI vector
        CALL SCDTC2_MCLR(R,ISMOST(1,ICSM),iWORK(KCBLTP),NSMST,
     &              NOCTPA,NOCTPB,iWORK(KNSTSO(IATP)),
     &              iWORK(KNSTSO(IBTP)),iWORK(KCIOIO),IDC,
     &              2,IDUMMY,IPRDIA)
      END IF

      IF(ICISTR.EQ.1) THEN
        CALL GASDN2(I12,RHO1,RHO2,
     &       R,L,WORK(KCB),WORK(KSB),WORK(KC2),
     &       iWORK(KCIOIO),iWORK(KSIOIO),ISMOST(1,ICSM),
     &       ISMOST(1,ISSM),iWORK(KCBLTP),iWORK(KSBLTP),
     &       NACOB,
     &       iWORK(KNSTSO(IATP)),iWORK(KISTSO(IATP)),
     &       iWORK(KNSTSO(IBTP)),iWORK(KISTSO(IBTP)),
     &       NAEL,IATP,NBEL,IBTP,
     &       IOCTPA,IOCTPB,NOCTPA,NOCTPB,
     &       NSMST,NSMOB,NSMSX,NSMDX,
     &       MXPNGAS,NTSOB,IBTSOB,
     &       MAXK,MAXI,LSCR1,LSCR1,
     &       WORK(KCSCR),WORK(KSSCR),
     &       iSXSTSM,iWORK(KSTSTS),iWORK(KSTSTD),SXDXSX,
     &       ADSXA,ASXAD,NGAS,
     &       iWORK(KEL123(iatp)),iWORK(KEL123(ibtp)),IDC,
     &       iWORK(KOOS1),iWORK(KOOS2),iWORK(KOOS3),iWORK(KOOS4),
     &       iWORK(KOOS5),iWORK(KOOS6),iWORK(KOOS7),iWORK(KOOS8),
     &       iWORK(KOOS9),iWORK(KOOS10),
     &       iWORK(KI1),WORK(KXI1S),iWORK(KI2),WORK(KXI2S),
     &       iWORK(KI3),WORK(KXI3S),iWORK(KI4),WORK(KXI4S),WORK(KINSCR),
     &       MXPOBS,IPRDEN,WORK(KRHO1S),LUL,LUR,
     &       PSSIGN,PSSIGN,WORK(KRHO1P),WORK(KXNATO),ieaw,n1,n2)
      ELSE IF(ICISTR.GE.2) THEN
        CALL GASDN2(I12,RHO1,RHO2,
     &       R,L,R,L,WORK(KC2),
     &       iWORK(KCIOIO),iWORK(KSIOIO),ISMOST(1,ICSM),
     &       ISMOST(1,ISSM),iWORK(KCBLTP),iWORK(KSBLTP),
     &       NACOB,
     &       iWORK(KNSTSO(IATP)),iWORK(KISTSO(IATP)),
     &       iWORK(KNSTSO(IBTP)),iWORK(KISTSO(IBTP)),
     &       NAEL,IATP,NBEL,IBTP,
     &       IOCTPA,IOCTPB,NOCTPA,NOCTPB,
     &       NSMST,NSMOB,NSMSX,NSMDX,
     &       MXPNGAS,NTSOB,IBTSOB,
     &       MAXK,MAXI,LSCR1,LSCR1,
     &       WORK(KCSCR),WORK(KSSCR),
     &       iSXSTSM,iWORK(KSTSTS),iWORK(KSTSTD),SXDXSX,
     &       ADSXA,ASXAD,NGAS,
     &       iWORK(KEL123(iatp)),iWORK(KEL123(ibtp)),IDC,
     &       iWORK(KOOS1),iWORK(KOOS2),iWORK(KOOS3),iWORK(KOOS4),
     &       iWORK(KOOS5),iWORK(KOOS6),iWORK(KOOS7),iWORK(KOOS8),
     &       iWORK(KOOS9),iWORK(KOOS10),
     &       iWORK(KI1),WORK(KXI1S),iWORK(KI2),WORK(KXI2S),
     &       iWORK(KI3),WORK(KXI3S),iWORK(KI4),WORK(KXI4S),WORK(KINSCR),
     &       MXPOBS,IPRDEN,WORK(KRHO1S),LUL,LUR,
     &       PSSIGN,PSSIGN,WORK(KRHO1P),WORK(KXNATO),ieaw,n1,n2)
      END IF

      IF(IDC.NE.1.AND.ICISTR.EQ.1) THEN
*. Transform from combination scaling to determinant scaling
*
        CALL SCDTC2_MCLR(L,ISMOST(1,ISSM),iWORK(KSBLTP),NSMST,
     &              NOCTPA,NOCTPB,iWORK(KNSTSO(IATP)),
     &              iWORK(KNSTSO(IBTP)),iWORK(KSIOIO),IDC,
     &              1,IDUMMY,IPRDIA)
        CALL SCDTC2_MCLR(R,ISMOST(1,ICSM),iWORK(KCBLTP),NSMST,
     &              NOCTPA,NOCTPB,iWORK(KNSTSO(IATP)),
     &              iWORK(KNSTSO(IBTP)),iWORK(KCIOIO),IDC,
     &              1,IDUMMY,IPRDIA)
      END IF
*
*     Free memory
*
      Call GetMem('KSTSTS','FREE','Inte',KSTSTS,IDUM)
      Call GetMem('KSTSTD','FREE','Inte',KSTSTD,IDUM)
      If (ICISTR.eq.1) Then
        Call GetMem('KCB','FREE','Real',KCB,IDUM)
        Call GetMem('KSB','FREE','Real',KSB,IDUM)
      End If
      Call GetMem('INTSCR','FREE','Real',KINSCR,IDUM)
      Call GetMem('SIOIO','FREE','Inte',KSIOIO,IDUM)
      Call GetMem('CIOIO','FREE','Inte',KCIOIO,IDUM)
      Call GetMem('KC2','FREE','Real',KC2,IDUM)
      Call GetMem('I1','FREE','Inte',KI1,IDUM)
      Call GetMem('I2','FREE','Inte',KI2,IDUM)
      Call GetMem('I3','FREE','Inte',KI3,IDUM)
      Call GetMem('I4','FREE','Inte',KI4,IDUM)
      Call GetMem('XI1S','FREE','Real',KXI1S,IDUM)
      Call GetMem('XI2S','FREE','Real',KXI2S,IDUM)
      Call GetMem('XI3S','FREE','Real',KXI3S,IDUM)
      Call GetMem('XI4S','FREE','Real',KXI4S,IDUM)
      Call GetMem('SBLTP','FREE','Inte',KSBLTP,IDUM)
      Call GetMem('CBLTP','FREE','Inte',KCBLTP,IDUM)
      Call GetMem('OOS1','FREE','Inte',KOOS1,IDUM)
      Call GetMem('OOS2','FREE','Inte',KOOS2,IDUM)
      Call GetMem('OOS3','FREE','Inte',KOOS3,IDUM)
      Call GetMem('OOS4','FREE','Inte',KOOS4,IDUM)
      Call GetMem('OOS5','FREE','Inte',KOOS5,IDUM)
      Call GetMem('OOS6','FREE','Inte',KOOS6,IDUM)
      Call GetMem('OOS7','FREE','Inte',KOOS7,IDUM)
      Call GetMem('OOS8','FREE','Inte',KOOS8,IDUM)
      Call GetMem('OOS9','FREE','Inte',KOOS9,IDUM)
      Call GetMem('OOS10','FREE','Inte',KOOS10,IDUM)
      Call GetMem('RHO1S','FREE','Real',KRHO1S,IDUM)
      Call GetMem('RHO1P','FREE','Real',KRHO1P,IDUM)
      Call GetMem('XNATO','FREE','Real',KXNATO,IDUM)
      Call GetMem('RHO1SM','FREE','Real',KRHO1SM,IDUM)
      Call GetMem('XNATSM','FREE','Real',KXNATSM,IDUM)
      Call GetMem('OCCSM','FREE','Real',KOCCSM,IDUM)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine decl_cvb(chr)
      implicit real*8 (a-h,o-z)
      character*(*) chr
#include "make_cvb.fh"

      iobj=0
      do 100 i=1,nobj
      if(charobj(i).eq.chr)iobj=i
100   continue
      if(iobj.gt.0)then
        if(iprint.gt.1)write(6,*)' Make object exists already :',chr
        return
      endif
      nobj=nobj+1
      if(nobj.gt.mxobj)then
        write(6,*)' Too many make objects, max :',mxobj
        call abend_cvb()
      endif
      charobj(nobj)=chr
      up2date(nobj)=.false.
      ioffs(nobj+1)=ioffs(nobj)
      joffs(nobj+1)=joffs(nobj)
      if(iprint.ge.10)then
        write(6,*)' IOFFS :',(ioffs(ii),ii=1,nobj+1)
        write(6,*)' JOFFS :',(joffs(ii),ii=1,nobj+1)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Integer Function LDF_X_OpenCoefficientFile()
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Opens LDF coefficient file and returns logical unit.
C
      Implicit None
      Integer Lu
      Lu=7
      Call DAName_MF_WA(Lu,'LDFC')
      LDF_X_OpenCoefficientFile=Lu
      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer Function LDF_X_OpenC()
      Implicit None
      Integer LDF_X_OpenCoefficientFile
      LDF_X_OpenC=LDF_X_OpenCoefficientFile()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine wrioff_cvb(ifield,file_id,ioffset)

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ifield, ioffset
real(kind=wp), intent(in) :: file_id
integer(kind=iwp), parameter :: nbuf = 50
integer(kind=iwp) :: ioff(nbuf)
logical(kind=iwp), external :: tstfile_cvb ! ... Files/Hamiltonian available ...

if (ifield > nbuf) then
  write(u6,*) ' ifield too large in wrioff :',ifield,nbuf
  call abend_cvb()
end if
if (tstfile_cvb(file_id)) then
  call rdi_cvb(ioff,nbuf,file_id,0)
else
  ioff(:) = 0
end if
ioff(ifield) = ioffset
call wri_cvb(ioff,nbuf,file_id,0)

return

end subroutine wrioff_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombOnly(IntegralOption,Timing,Mode,ThrPS,Add,PackedD,PackedF,nD,FactC,ip_D,F)
! Thomas Bondo Pedersen, October 2010.
!
! Purpose: Compute Coulomb contribution to Fock matrix using local
!          Density Fitting coefficients.
!
! Args:    - IntegralOption (integer)
!              111  => use two-electron integrals computed from
!                      LDF coefficients (for debugging)
!              222  => use conventional two-electron integrals
!                      (for debugging)
!              333  => use conventional or LDF two-electron
!                      integrals depending on positivity of the
!                      latter (for debugging)
!              444  => use exact integral diagonal (blocks), all
!                      other blocks are LDF
!              all other values => use production-level LDF code
!              (INPUT)
!          - Timing (boolean) .True. if detailed timing (incl total)
!            should be printed from this routine (INPUT)
!          - Mode (integer) 1:robust, 2:nonrobust, 3:half-and-half
!            to be used (INPUT)
!          - ThrPS(2): prescreening thresholds (INPUT)
!                      ThrPS(1): integral prescreening threshold
!                      ThrPS(2): prescreening threshold on
!                                contributions
!          - Add (boolean): .True. if Coulomb contribution should be
!            added to the Fock matrix (INPUT). Not available in
!            parallel execution!!
!          - PackedD (boolean): .True. if density matrices
!            are stored in lower triangular format; else quadratic
!            storage (INPUT)
!          - PackedF (boolean): .True. if Fock matrices
!            are stored in lower triangular format; else quadratic
!            storage (INPUT)
!          - nD: Number of densities/Fock matrices (INPUT)
!          - FactC(nD): scaling factor for each density (INPUT)
!          - ip_D(nD): pointers to nD density matrices (if PackedD:
!            lower triangular storage) (INPUT)
!          - F(*,nD): nD Fock matrices (if PackedF:
!            lower triangular storage) (INPUT/OUTPUT)
!
!          If (Add):  [NOT IMPLEMENTED IN PARALLEL]
!   (1)       F(uv) = F(uv) + FactC * sum_kl (uv|kl)*D(kl)
!          Else:
!   (2)       F(uv) = FactC * sum_kl (uv|kl)*D(kl)
!
!          where the integrals are given by the robust LDF
!          representation (Mode=1)
!
!          (uv|kl) = ([uv]|kl) + (uv|[kl]) - ([uv]|[kl])
!
!          or the non-robust representation (Mode=2)
!
!          (uv|kl) = ([uv]|[kl])
!
!          or the half-and-half representation (Mode=3)
!
!          (uv|kl) = 0.5*([uv]|kl) + 0.5*(uv|[kl])
!
!          The fitted products are given by
!
!          |[uv]) = sum_J C(uv,J) |J)
!
!          where the fitting functions |J) are centered on the atom
!          pair to which the product |uv) belongs.
!
!          In more detail (assuming robust fitting representation):
!
!          F(uv) = FactC * {sum_J C(uv,J)*W(J) + sum_K (uv|K)*V(K)}
!
!          W(J) = sum_kl (J|kl)*D(kl) - sum_K (J|K)*V(K)
!
!          V(K) = sum_kl C(kl,K)*D(kl)
!
! NOTES:
!   - The density matrices are assumed to be symmetric.
!   - It is the complete sum over kl in Eqs(1,2)! This means that
!     the input density matrices should NOT be scaled by 2 on the
!     off-diagonal (scaling factors are handled internally).
!   - LDF information must be properly set up before calling this
!     routine (use subroutine LDF_X_Init).
!   - Two-center functions may or mat not be included in the fitting
!     basis for a given atom pair.
!   - The algorithm is integral driven: the integrals are computed
!     once.
!   - The fitting coefficients are read from disk twice (for Coulomb
!     [V] intermediates and for the final contractions to give the
!     Fock matrix). This is not a problem if they are fully
!     buffered, but could impose an I/O bottleneck. Since the number
!     of coefficients scales linearly with system size, this should
!     be less of a problem than the quadratic scaling of full
!     Cholesky vectors.
!   - The max number of processes for which the algorithm can
!     possibly scale well equals the number of LDF atom pairs.
!   - Integral prescreening info will be set up here if not done
!     prior to calling this routine.
!   - Add is not implemented in parallel !!!
!
! ALGORITHM:
!=======================================================================
!
! If (Mode=3): FactC := 0.5*FactC
! Scale off-diagonal density blocks:
!              D[u_A v_B] <-- 2*D[u_A v_B] iff A != B
!
! Initialize V(J)=0 for all J
! *Parallel loop over atom pairs AB (A>=B):
!    - V(J) += sum_[u_A v_B] C(u_A v_B,J)*D(u_A v_B)
!      where J belongs to AB [1C and 2C funcs].
! *End parallel loop AB
! Add V over nodes.
!
! Initialize F(uv) for all significant uv.
! Initialize W(J) for all J.
!
! If (Mode=1 or Mode=3):
!    Compute 3-index contributions:
!    *Parallel loop over atom pairs AB (A>=B):
!       *Loop over atoms C
!          - Compute (u_A v_B|K) for K belonging to C [1C func]
!          - F(u_A v_B) += sum_K (u_A v_B|K)*V(K)
!          - W(K) += sum_[u_A v_B] (u_A v_B|K)*D(u_A v_B)
!       *End loop C
!       If (LDF2):
!          *loop over atom pairs CD
!             - Compute (u_A v_B|K) for K belonging to CD [2C func]
!             - F(u_A v_B) += sum_[K] (u_A v_B|K)*V(K)
!             - W(K) += sum_[u_A v_B] (u_A v_B|K)*D(u_A v_B)
!          *End loop over CD
!       End If
!    *End parallel loop AB
! End If
!
! Compute 2-index contributions:
! If (Mode=1 or Mode=2):
!    If (Mode=1):
!       - const=-1.0d0
!    Else:
!       - const=1.0d0
!    End If
!    *Parallel loop over atoms A:
!       *Loop over atoms B=1,A-1:
!          - Compute (J|K) for J in A and K in B [1C func]
!          - W(J) += const * sum_K (J|K)*V(K)
!          - W(K) += const * sum_J V(J)*(J|K)
!       *End loop B
!       - Compute (J|K) for J,K in A [1C func]
!       - W(J) += const* sum_K (J|K)*V(K)
!       If (LDF2):
!          *Loop over atom pairs CD (C>=D):
!             - Compute (J|K) for J in A [1C func], K in CD [2Cfunc]
!             - W(J) += const * sum_K (J | K)*V(K)
!             - W(K) += const * sum_J V(J)*(J|K)
!          *End loop CD
!       End If
!    *End parallel loop A
!    If (LDF2):
!       *Parallel loop over atom pairs AB (A>=B):
!          *Loop over atom pairs CD=1,AB-1:
!             - Compute (J|K) for J in AB and K in CD [2C func]
!             - W(J) += const * sum_K (J|K)*V(K)
!             - W(K) += const * sum_J V(J)*(J|K)
!          *End loop B
!          - Compute (J|K) for J,K in AB [2C func]
!          - W(J) += const* sum_K (J|K)*V(K)
!       *End loop AB
!    End If
! End If
! Add W over nodes
!
! *Parallel loop over atom pairs AB (A>=B):
!    - Read coefficient C(u_A v_B,J) for J in AB [1C,2C func]
!    - F(u_A v_B) += sum_J C(u_a v_B,J)*W(J)
! *End parallel loop AB
! Add F over nodes
!
! ALGORITHM DONE: Return F
!=======================================================================
!
! Note that arrays V, W, and F are stored locally as O(N) arrays,
! which should keep the communication bottleneck reasonable as the
! system size grows.
!
! Integral prescreening is based on the Cauchy-Schwarz inequality
! and involves estimation of the max integral in a given block.
! Integral prescreening is done at atom/atom pair block level as
! well as on shell level.
!
! Contribution prescreening is based on the submultiplicative
! property of the Frobenius norm in combination with the Cauchy-
! Schwarz inequality for positive (semi-) definite matrices.
! Specifically, an upper bound to the norm of the matrix-vector
! product
!
! y = A*x
!
! where A is a subblock of a positive (semi-) definite matrix,
! is given by
!
! ||y|| <= ||A||*||x||                  {submultiplicative property}
!        = sqrt[sum_ij A(i,j)**2]*sqrt[sum_j x(j)**2]
!       <= sqrt[sum_ij A(i,i)*A(j,j)]*sqrt[sum_j x(j)**2]  {Cauchy-Schwarz}
!        = sqrt[sum_i A(i,i)]*sqrt[sum_j A(j,j)]*sqrt[sum_j x(j)**2]
!
! This upper bound is used to avoid calculation of contributions
! below a given threshold. Contribution prescreening is done at
! atom/atom pair block level only, f.ex. for K on atom C
!
! ||sum_K (AB|K)*V(K)|| <= sqrt[sum_[u_A v_B] (u_A v_B | u_A v_B)]
!                         *sqrt[sum_K (K|K)]
!                         *sqrt[sum_K V(K)**2]

#ifdef _MOLCAS_MPP_
use Para_Info, only: nProcs, Is_Real_Par
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
#ifdef _DEBUGPRINT_
use Constants, only: One
#endif
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IntegralOption, Mode, nD, ip_D(nD)
logical(kind=iwp), intent(in) :: Timing, Add, PackedD, PackedF
real(kind=wp), intent(in) :: ThrPS(2)
real(kind=wp), intent(inout) :: FactC(nD), F(*)
logical(kind=iwp) :: UseOldCode, IPI_set_here
real(kind=wp) :: tau(2)
integer(kind=iwp) :: i, nBas, iD, ip0, l, l_DBlocks, l_FBlocks, l_VP, l_DNorm, l_CNorm, l_VNorm, l_FactC
real(kind=wp) :: tTotC1, tTotC2, tTotW1, tTotW2
integer(kind=iwp), allocatable :: DBlocks(:), FBlocks(:), VP(:)
real(kind=wp), allocatable :: DNorm(:), CNorm(:), VNorm(:), FactCBak(:)
character(len=*), parameter :: SecNam = 'LDF_Fock_CoulombOnly'
logical(kind=iwp), external :: LDF_IntegralPrescreeningInfoIsSet
integer(kind=iwp), external :: LDF_nAtom
#ifdef _DEBUGPRINT_
logical(kind=iwp) :: DoTest
real(kind=wp) :: x, y
logical(kind=iwp), external :: LDF_X_IsSet, LDF_TestBlockMatrix
#endif
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

! Start total timing.
if (Timing) then
  write(u6,'(/,84A1)') ('-',i=1,84)
  call CWTime(tTotC1,tTotW1)
end if

UseOldCode = (IntegralOption == 111) .or. (IntegralOption == 222) .or. (IntegralOption == 333)
if (UseOldCode) then
  call WarningMessage(0,SecNam//': Using atom pair-driven (old) code!')
  call xFlush(u6)
  call LDF_Fock_CoulombOnly0(IntegralOption,ThrPS(1),Mode,Add,PackedD,PackedF,nD,FactC,ip_D,F)
  call Final_Timing()
  return
end if

! Return if nothing to do
if (nD < 1) then
  call Final_Timing()
  return
end if

! Get number of basis functions (from localdf_bas.fh)
nBas = nBas_Valence
if (nBas < 1) then
  call WarningMessage(1,SecNam//': nBas<1 -- Fock matrix NOT computed!')
  write(u6,'(A,I9)') 'nBas=',nBas
  call xFlush(u6)
  call Final_Timing()
  return
end if

#ifdef _DEBUGPRINT_
if (.not. LDF_X_IsSet()) then
  call WarningMessage(2,SecNam//': LDF data not initialized!')
  call LDF_Quit(1)
end if
#endif

#ifdef _MOLCAS_MPP_
if (Add) then
  if ((nProcs > 1) .and. Is_Real_Par()) then
    write(u6,'(A,A)') SecNam,': >>Add<< feature not implemented in parallel execution!'
    call LDF_NotImplemented()
  end if
end if
#endif

! For half-and-half integral representation, scale FactC by 1/2.
! Save a copy of FactC (restored at the end)
if (Mode == 3) then
  l_FactC = nD
  call mma_allocate(FactCBak,l_FactC,label='FactCBak')
  call dCopy_(nD,FactC,1,FactCBak,1)
  call dScal_(nD,Half,FactC,1)
else
  l_FactC = 0
end if

! Set prescreening info (if not already done)
if (.not. LDF_IntegralPrescreeningInfoIsSet()) then
  call LDF_SetIntegralPrescreeningInfo()
  IPI_set_here = .true.
else
  IPI_set_here = .false.
end if
tau(1) = max(ThrPS(1),Zero) ! integral prescreening threshold
tau(2) = max(ThrPS(2),Zero) ! contribution prescreening threshold

! Initialize Fock matrices (if not Add)
if (PackedF) then
  l = nBas*(nBas+1)/2
else
  l = nBas**2
end if
if (.not. Add) then
  F(1:nD*l) = Zero
end if

! Allocate and set blocked density matrices (atom pair blocks)
l_DBlocks = nD
call mma_allocate(DBlocks,l_DBlocks,label='DBlk_P')
#ifdef _DEBUGPRINT_
x = real(NumberOfAtomPairs,kind=wp)
y = real(LDF_nAtom(),kind=wp)*(real(LDF_nAtom(),kind=wp)+One)*Half
DoTest = int(x-y) == 0
#endif
do iD=1,nD
  call LDF_AllocateBlockMatrix('Den',DBlocks(iD))
  call LDF_Full2Blocked(Work(ip_D(iD)),PackedD,DBlocks(iD))
#ifdef _DEBUGPRINT_
  if (DoTest) then
    if (.not. LDF_TestBlockMatrix(DBlocks(iD),PackedD,Work(ip_D(iD)))) then
      call WarningMessage(2,SecNam//': block matrix test failure')
      write(u6,'(A,I4,A,I9,3X,A,L1)') 'Density matrix',iD,' at location',ip_D(iD),'Packed: ',PackedD
      call LDF_Quit(1)
    end if
  end if
#endif
  call LDF_ScaleOffdiagonalMatrixBlocks(DBlocks(iD),Two)
end do

! Allocate and set blocked Fock matrices (atom pair blocks)
l_FBlocks = nD
call mma_allocate(FBlocks,l_FBlocks,label='FBlk_P')
do iD=1,nD
  call LDF_AllocateBlockMatrix('Fck',FBlocks(iD))
  call LDF_Full2Blocked(F((iD-1)*l+1),PackedF,FBlocks(iD))
end do

! Allocate and compute Frobenius norm of blocked density matrices
l_DNorm = NumberOfAtomPairs*nD
call mma_allocate(DNorm,l_DNorm,label='DNorm')
ip0 = 1
do iD=1,nD
  call LDF_BlockMatrixNorm(iWork(DBlocks(iD)),DNorm(ip0))
  ip0 = ip0+NumberOfAtomPairs
end do

! Allocate Coulomb intermediates
l_VP = nD
call mma_allocate(VP,l_VP,label='VP')
do iD=1,nD
  call LDF_AllocateAuxBasVector('CIn',VP(iD))
end do

! Allocate array for norm of fitting coefficients
l_CNorm = 4*NumberOfAtomPairs
call mma_allocate(CNorm,l_CNorm,label='CNorm')

! Compute Coulomb intermediates
! V(J) = sum_uv C(uv,J)*D(uv)
! for each density matrix
! Compute Frobenius norm of fitting coefficients.
call LDF_ComputeCoulombIntermediates(Timing,nD,DBlocks,VP,CNorm)

! Allocate and compute Frobenius norm of Coulomb intermediates
l_VNorm = (LDF_nAtom()+NumberOfAtomPairs)*nD
call mma_allocate(VNorm,l_VNorm,label='VNorm')
ip0 = 1
do iD=1,nD
  call LDF_AuxBasVectorNorm(iWork(VP(iD)),VNorm(ip0))
  ip0 = ip0+LDF_nAtom()+NumberOfAtomPairs
end do

! Compute Coulomb contributions
call LDF_Fock_CoulombOnly_(IntegralOption == 444,Timing,Mode,tau,nD,FactC,DBlocks,VP,FBlocks,CNorm,DNorm,VNorm)

! Get full storage (triangular or quadratic) Fock matrices from
! blocked ones.
do iD=1,nD
  call LDF_Blocked2Full(FBlocks(iD),PackedF,F((iD-1)*l+1))
end do

! Deallocation
call mma_deallocate(VNorm)
call mma_deallocate(CNorm)
do iD=1,nD
  call LDF_DeallocateAuxBasVector('CIn',VP(iD))
end do
call mma_deallocate(VP)
call mma_deallocate(DNorm)
do iD=1,nD
  call LDF_DeallocateBlockMatrix('Fck',FBlocks(iD))
end do
call mma_deallocate(FBlocks)
do iD=1,nD
  call LDF_DeallocateBlockMatrix('Den',DBlocks(iD))
end do
call mma_deallocate(DBlocks)

! Unset prescreening info (if set in this routine)
if (IPI_set_here) then
  call LDF_UnsetIntegralPrescreeningInfo()
end if

! Restore FactC
if (l_FactC > 0) then
  call dCopy_(nD,FactCBak,1,FactC,1)
  call mma_deallocate(FactCBak)
end if

contains

subroutine Final_Timing()
  integer(kind=iwp) :: i
  if (Timing) then
    call CWTime(tTotC2,tTotW2)
    write(u6,'(A,A,A,2(1X,F12.2),A)') 'Total time spent in ',SecNam,':         ',tTotC2-tTotC1,tTotW2-tTotW1,' seconds'
    write(u6,'(84A1)') ('-',i=1,84)
    call xFlush(u6)
  end if
end subroutine Final_Timing

end subroutine LDF_Fock_CoulombOnly

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CXClose(iSGStruct,iCIStruct,iXStruct)
#include "Struct.fh"
      Dimension iSGStruct(nSGSize)
      Dimension iCIStruct(nCISize)
      Dimension iXStruct (nXSize)
C Unpack structure iSGStruct:
      nSym   =iSGStruct(1)
CUNUSED      nLev   =iSGStruct(2)
CUNUSED      lISm   =iSGStruct(3)
CUNUSED      nVert  =iSGStruct(4)
CUNUSED      lDRT   =iSGStruct(5)
CUNUSED      lDown  =iSGStruct(6)
CUNUSED      lUp    =iSGStruct(7)
CUNUSED      MidLev =iSGStruct(8)
CUNUSED      MVSta  =iSGStruct(9)
CUNUSED      MVEnd  =iSGStruct(10)
CUNUSED      lMAW   =iSGStruct(11)
CUNUSED      lLTV   =iSGStruct(12)
C Unpack structure iCIStruct:
      nMidV =iCIStruct(1)
      nIpWlk=iCIStruct(2)
      lNOW  =iCIStruct(3)
      lIOW  =iCIStruct(4)
      lNCSF =iCIStruct(5)
      lNOCSF=iCIStruct(6)
      lIOCSF=iCIStruct(7)
      nWalk =iCIStruct(8)
      lICase=iCIStruct(9)
C Unpack structure iXStruct:
      MxEO  =iXStruct(1)
      lNOCP =iXStruct(2)
      lIOCP =iXStruct(3)
      nICoup=iXStruct(4)
      lICoup=iXStruct(5)
      nVTab =iXStruct(6)
      lVTab =iXStruct(7)
      lMVL  =iXStruct(8)
      lMVR  =iXStruct(9)
CUNUSED      NT1MX =IXSTRUCT(10)
CUNUSED      NT2MX =IXSTRUCT(11)
CUNUSED      NT3MX =IXSTRUCT(12)
CUNUSED      NT4MX =IXSTRUCT(13)
CUNUSED      NT5MX =IXSTRUCT(14)
      nNOW=2*nMidV*nSym
CUNUSED      nIOW=nNOW
      Call GetMem('MVR','Free','Inte',lMVR,2*nMidV)
      Call GetMem('MVL','Free','Inte',lMVL,2*nMidV)
      nNOCSF=nMidV*(nSym**2)
      nIOCSF=nNOCSF
      Call GetMem('NOCSF','Free','Inte',lNOCSF,nNOCSF)
      Call GetMem('IOCSF','Free','Inte',lIOCSF,nIOCSF)
      Call GetMem('NOW','Free','Inte',lNOW,nNOW)
      Call GetMem('IOW','Free','Inte',lIOW,nNOW)
      nNOCP=MxEO*nMidV*nSym
      nIOCP=nNOCP
      Call GetMem('NOCP','Free','Inte',lNOCP,nNOCP)
      Call GetMem('IOCP','Free','Inte',lIOCP,nIOCP)
      Call GetMem('NCSF','Free','Inte',lNCSF,nSym)
      nICase=nWalk*nIpWlk
      Call GetMem('ICASE','Free','Inte',lICase,nICase)
      nnICoup=(3*nICoup+1)/2
      Call GetMem('ICoup','Free','Inte',lICoup,nnICoup)
      Call GetMem('VTab','Free','Real',lVtab,nVtab)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Yoshio Nishimoto                                 *
!***********************************************************************

! Construct a dynamically-weighted density which is used for reaction field

subroutine DWDens_RASSCF(CMO,D1A,RCT_FS,IFINAL)

use rasscf_global, only: DoDMRG, Ener, IADR15, ITER, NAC, NACPAR, NACPR2, nRoots
use DWSol, only: DWSol_wgt, W_SOLV
use gas_data, only: iDoGAS
use general_data, only: JOBIPH, NACTEL, NCONF
use sguga, only: SGS
use lucia_data, only: DStmp, Dtmp, PAtmp, Pscr, PTmp
use Lucia_Interface, only: Lucia_Util
use sxci, only: IDXSX
#ifdef _DMRG_
use lucia_data, only: RF1, RF2
use rasscf_global, only: TwoRDM_qcm
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CMO(*)
real(kind=wp), intent(out) :: D1A(NACPAR), RCT_FS(NACPAR)
integer(kind=iwp), intent(in) :: IFINAL
integer(kind=iwp) :: i, iDisk, iOpt, ITERcurr, jDisk
real(kind=wp) :: rdum(1), wgt
real(kind=wp), allocatable :: CIVEC(:), DA_ave(:), DS_ave(:), DX(:)

call mma_allocate(DA_ave,NACPAR,Label='DA_ave')
call mma_allocate(DS_ave,NACPAR,Label='DS_ave')
call mma_allocate(DX,NACPAR,Label='DX')
DA_ave(:) = Zero
DS_ave(:) = Zero

ITERcurr = 1
if (ITER /= 1) ITERcurr = ITER-1
call DWSol_wgt(2,ENER(:,ITERcurr))

if ((iFinal == 0) .or. (iFinal == 1)) then
  jDisk = IADR15(3)
  do i=1,nRoots
    wgt = W_SOLV(i)
    call DDaFile(JOBIPH,2,DX,NACPAR,jDisk)
    call DDaFile(JOBIPH,2,RCT_FS,NACPAR,jDisk)
    call DDaFile(JOBIPH,0,rdum,NACPR2,jDisk)
    call DDaFile(JOBIPH,0,rdum,NACPR2,jDisk)
    if (wgt < 1.0e-10_wp) cycle
    DA_ave(:) = DA_ave(:)+wgt*DX(:)
    DS_ave(:) = DS_ave(:)+wgt*RCT_FS(:)
  end do
else if (iFinal == 2) then
  call mma_allocate(CIVEC,NCONF,Label='CIVEC')
  call mma_allocate(Dtmp,NACPAR,Label='Dtmp')
  call mma_allocate(DStmp,NACPAR,Label='DStmp')
  call mma_allocate(Ptmp,NACPR2,Label='Ptmp')

  iDisk = IADR15(4)
  do i=1,nRoots
    wgt = W_SOLV(i)
    if (NACTEL == 0) then
      CIVEC(1) = One
    else
      if (.not. doDMRG) then
        iOpt = 2
        ! load back one CI vector at the time
        call DDafile(JOBIPH,iOpt,CIVEC,nConf,iDisk)
      end if
    end if

    ! compute density matrices

    if (NAC >= 1) then
      if (NACTEL == 0) then
        Dtmp(:) = Zero
        DStmp(:) = Zero
        Ptmp(:) = Zero
      else if (doDMRG) then
#       ifdef _DMRG_
        ! copy the DMs from d1rf/d2rf for ipcmroot
        Dtmp(:) = rf1(1:NACPAR)
        if (twordm_qcm) Ptmp(:) = rf2(1:NACPR2)
        DStmp(:) = Zero
#       endif
      else
        call mma_allocate(PAtmp,NACPR2,Label='PAtmp')
        call mma_allocate(Pscr,NACPR2,Label='Pscr')
        call Lucia_Util('Densi',CI_Vector=CIVEC(:))
        if ((SGS%IFRAS > 2) .or. (iDoGAS)) call CISX(IDXSX,Dtmp,DStmp,Ptmp,PAtmp,Pscr)
        call mma_deallocate(Pscr)
        call mma_deallocate(PAtmp)
      end if ! doDMRG/doBLOK or CI
    else
      Dtmp(:) = Zero
      DStmp(:) = Zero
      Ptmp(:) = Zero
    end if
    DA_ave(:) = DA_ave(:)+wgt*Dtmp(:)
    DS_ave(:) = DS_ave(:)+wgt*DStmp(:)
  end do
  call mma_deallocate(DStmp)
  call mma_deallocate(Dtmp)
  call mma_deallocate(Ptmp)
  call mma_deallocate(CIVEC)
end if

! Construct D-ACTIVE AND D-INACTIVE IN AO BASIS

DX(:) = DS_ave(:)
call DBLOCK(DX)
call Get_D1A_RASSCF(CMO,DX,RCT_FS)

DX(:) = DA_ave(:)
call DBLOCK(DX)
call Get_D1A_RASSCF(CMO,DX,D1A)

call mma_deallocate(DA_ave)
call mma_deallocate(DS_ave)
call mma_deallocate(DX)

return

end subroutine DWDens_RASSCF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Step2(iMatrix,SMatrix,nDim,TMatrix,iType,SMatrix_Save,Temp)
! Step 2. LO S0 ->S1
! occupied virtual on the same center
! and orthonormalization of the original AO basis
! The call to lowdin_lp gives me a transformation A1, and a
! transformed S matrix

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDim, iMatrix(nDim), iType(nDim)
real(kind=wp), intent(inout) :: SMatrix(nDim,nDim), SMatrix_Save(nDim,nDim)
real(kind=wp), intent(out) :: TMatrix(nDim,nDim), Temp(nDim,nDim)
integer(kind=iwp) :: i, j

!lg write(u6,*) 'Step 2', nDim
!lg call RecPrt('Save before LW 2',' ',SMatrix_Save,nDim,nDim)
!lg write(u6,*)
do i=1,nDim
  do j=1,nDim
    !write(u6,*) iMatrix(i),iMatrix(j),SMatrix(j,i)
    if ((iMatrix(i) /= iMatrix(j)) .and. (iType(i) /= iType(j))) then
      SMatrix(j,i) = Zero
    end if
  end do
end do
!lg call RecPrt('SMatrix before LW 2',' ',SMatrix,nDim,nDim)
!lg call RecPrt('SMatrix_Save before LW 2',' ',SMatrix_Save,nDim,nDim)

TMatrix(:,:) = Zero
call dcopy_(nDim,[One],0,TMatrix,nDim+1)
call Lowdin_LP(SMatrix,TMatrix,nDim)
! Pick up S2
!lg call RecPrt('SMatrix after LW 2',' ',SMatrix,nDim,nDim)
!lg call RecPrt('TMatrix after LW 2',' ',TMatrix,nDim,nDim)
SMatrix(:,:) = SMatrix_Save(:,:)

! Now apply T2 to S2:  S3=T2(T)*S2*T2

call DGEMM_('N','N',nDim,nDim,nDim,One,SMatrix,nDim,TMatrix,nDim,Zero,Temp,nDim)
call DGEMM_('T','N',nDim,nDim,nDim,One,TMatrix,nDim,Temp,nDim,Zero,SMatrix,nDim)
!call RecPrt('S3',' ',SMatrix,nBas(1),nBas(1))
SMatrix_Save(:,:) = SMatrix(:,:)

return

end subroutine Step2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FREESTR_GAS
* Deallocate the memory that was set up in MEMSTR_GAS

*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "mxpdim.fh"
#include "orbinp.fh"
#include "strbas.fh"
#include "csm.fh"
#include "WrkSpc.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "stinf.fh"
#include "crun.fh"
* allocations during strinf_gas
#include "distsym.fh"
*
*.  Offsets for occupation and reorder array of strings
*
      DO IGRP = 1, NGRP
        NSTRIN = NSTFGP(IGRP)
        LSTRIN = NSTRIN*NELFGP(IGRP)
        CALL GETMEM('OCSTR ','FREE','INTE',KOCSTR(IGRP),LSTRIN)
        CALL GETMEM('STREO ','FREE','INTE',KSTREO(IGRP),NSTRIN)
      END DO
*
*. Number of strings per symmetry and offset for strings of given sym
*. for groups
*
      CALL GETMEM('NSTSGP','FREE','INTE',KNSTSGP(1),NSMST*NGRP)
      CALL GETMEM('ISTSGP','FREE','INTE',KISTSGP(1),NSMST*NGRP)
*
*. Number of strings per symmetry and offset for strings of given sym
*. for types
*
      DO  ITP  = 1, NSTTP
        CALL GETMEM('NSTSO ','FREE','INTE',
     &              KNSTSO(ITP),NSPGPFTP(ITP)*NSMST)
        CALL GETMEM('ISTSO ','FREE','INTE',
     &              KISTSO(ITP),NSPGPFTP(ITP)*NSMST)
      END DO
*
**. Lexical adressing of arrays : use array indices for complete active space
*
*. Not in use so
      DO  IGRP = 1, NGRP
        CALL GETMEM('Zmat  ','FREE','INTE',KZ(IGRP),NACOB*NELFGP(IGRP))
      END DO
*
*. Mappings between different groups
*
      DO  IGRP = 1, NGRP
        IEL = NELFGP(IGRP)
        IGAS = IGSFGP(IGRP)
        IORB = NOBPT(IGAS)
        ISTRIN = NSTFGP(IGRP)
*. IF creation is involve : Use full orbital notation
*  If only annihilation is involved, compact form will be used
        IF(ISTAC(IGRP,2).NE.0) THEN
          LENGTH = IORB*ISTRIN
          CALL GETMEM('ORBMAP','FREE','INTE',KSTSTM(IGRP,1),LENGTH)
          CALL GETMEM('STRMAP','FREE','INTE',KSTSTM(IGRP,2),LENGTH)
        ELSE IF(ISTAC(IGRP,1).NE.0) THEN
*. Only annihilation map so
          LENGTH = IEL*ISTRIN
          CALL GETMEM('ORBMAP','FREE','INTE',KSTSTM(IGRP,1),LENGTH)
          CALL GETMEM('STRMAP','FREE','INTE',KSTSTM(IGRP,2),LENGTH)
        ELSE
*. Neither annihilation nor creation (?!)
          KSTSTM(IGRP,1) = -1
          KSTSTM(IGRP,2) = -1
        END IF
      END DO
*
*. Symmetry of conjugated orbitals and orbital excitations
*
*     KCOBSM,KNIFSJ,KIFSJ,KIFSJO
      CALL GETMEM('Cobsm ','FREE','INTE',KCOBSM,NACOB)
      CALL GETMEM('Nifsj ','FREE','INTE',KNIFSJ,NACOB*NSMSX)
      CALL GETMEM('Ifsj  ','FREE','INTE',KIFSJ,NACOB**2 )
      CALL GETMEM('Ifsjo ','FREE','INTE',KIFSJO,NACOB*NSMSX)
*
*. Symmetry of excitation connecting  strings of given symmetry
*
      CALL GETMEM('Ststx ','FREE','INTE',KSTSTX,NSMST*NSMST)
*
*. Occupation classes
*
      CALL GETMEM('IOCLS ','FREE','INTE',KIOCLS,NMXOCCLS*NGAS)
*. Annihilation/Creation map of supergroup types
      CALL GETMEM('SPGPAN','FREE','INTE',KSPGPAN,NTSPGP*NGAS)
      CALL GETMEM('SPGPCR','FREE','INTE',KSPGPCR,NTSPGP*NGAS)
*
* Allocated during strinf_gas call
      CALL GETMEM('ISMDFGP','FREE','INTE',ISMDFGP, NSMST*NGRP)
      CALL GETMEM('NACTSYM','FREE','INTE',NACTSYM, NGRP)
      CALL GETMEM('ISMSCR','FREE','INTE',ISMSCR, NGRP)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DIATERM2_GAS(FACTOR,ITASK,VEC,NBLOCK,IBLOCK,IOFF,J12,JDC)
! = DIATERM_GAS, just J12 added !
!
! Obtain VEC = (DIAGONAL + FACTOR) ** -1 VEC (ITASK = 1)
! Obtain VEC = (DIAGONAL + FACTOR)       VEC (ITASK = 2)
!
! For the NBLOCKS givem in IBLOCK starting from BLOCK IOFF
!
! Jeppe Olsen, August 1995

use lucia_data, only: ECORE, ECORE_ORIG, IREOST, MXNSTR, NACOB, NELEC, NIRREP, NOCTYP, NSTSO, NTOOB
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use lucia_data, only: IBSPGPFTP, IDC
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: FACTOR
real(kind=wp), intent(_OUT_) :: VEC(*)
integer(kind=iwp), intent(in) :: ITASK, NBLOCK, IBLOCK(8,*), IOFF, J12, JDC
integer(kind=iwp) :: IATP, IBTP, MAXA, NAEL, NBEL, NOCTPA
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IOCTPA, IOCTPB, NOCTPB
#endif
real(kind=wp) :: ECOREP, FACTORX, SHIFT
integer(kind=iwp), allocatable :: LASTR(:), LBSTR(:)
real(kind=wp), allocatable :: LH1D(:), LJ(:), LK(:), LRJKA(:), LXB(:)
integer(kind=iwp), external :: IMNMX

IATP = 1
IBTP = 2
NAEL = NELEC(IATP)
NBEL = NELEC(IBTP)
NOCTPA = NOCTYP(IATP)

!if (JPERT == 0) then
!  ! Use full Hamiltonian
!  I12 = 2
!  IPERTOP = 0
!else
!  ! Use perturbation operator
!  if (IPART == 1) then
!    ! Moller-Plesset partitioning
!    I12 = 1
!    IPERTOP = 1
!  else if (IPART == 2) then
!    ! Epstein-Nesbet Partitioning
!    I12 = 2
!    IPERTOP = 0
!  end if
!end if

#ifdef _DEBUGPRINT_
! Offsets for alpha and beta supergroups
NOCTPB = NOCTYP(IBTP)
IOCTPA = IBSPGPFTP(IATP)
IOCTPB = IBSPGPFTP(IBTP)
write(u6,*) ' ====================='
write(u6,*) ' DIATERM2_GAS speaking'
write(u6,*) ' ====================='
write(u6,*) ' IATP IBTP NAEL NBEL ',IATP,IBTP,NAEL,NBEL
write(u6,*) ' NOCTPA NOCTPB  : ',NOCTPA,NOCTPB
write(u6,*) ' IOCTPA IOCTPB  : ',IOCTPA,IOCTPB
write(u6,*) ' IPART,J12',J12
#endif
! A bit of scracth
call mma_allocate(LJ,NTOOB**2,Label='LJ')
call mma_allocate(LK,NTOOB**2,Label='LK')
call mma_allocate(LXB,NACOB,Label='LX')
call mma_allocate(LH1D,NACOB,Label='LH1D')
! Space for blocks of strings
call mma_allocate(LASTR,MXNSTR*NAEL,Label='LASTR')
call mma_allocate(LBSTR,MXNSTR*NBEL,Label='LBSTR')
MAXA = IMNMX(NSTSO(IATP)%A,NIRREP*NOCTPA,2)
call mma_allocate(LRJKA,MAXA,Label='LRJKA')
! Diagonal of one-body integrals and coulomb and exchange integrals
! Integrals assumed in place so :
call GT1DIA(LH1D)
if (J12 == 2) call GTJK(LJ,LK,NTOOB,IREOST)
! Core energy not included
ECOREP = Zero
SHIFT = ECORE_ORIG-ECORE
FACTORX = FACTOR+SHIFT
call DIATERMS_GAS(NAEL,LASTR,NBEL,LBSTR,NACOB,VEC,NIRREP,LH1D,JDC,LXB,LJ,LK,NSTSO(IATP)%A,NSTSO(IBTP)%A,ECOREP,0,0,NTOOB,LRJKA, &
                  J12,IBLOCK(:,IOFF),NBLOCK,ITASK,FACTORX,0,[0])
! Flush local memory
call mma_deallocate(LJ)
call mma_deallocate(LK)
call mma_deallocate(LXB)
call mma_deallocate(LH1D)
call mma_deallocate(LASTR)
call mma_deallocate(LBSTR)
call mma_deallocate(LRJKA)

#ifdef _DEBUGPRINT_
write(u6,*) ' output vector from DIATRM'
call WRTTTS(VEC,IBLOCK(:,IOFF),NBLOCK,NIRREP,NSTSO(IATP)%A,NSTSO(IBTP)%A,IDC)
#endif

end subroutine DIATERM2_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine SchInt(CoorM,
     &                  iAnga,iCmp,mZeta,Zeta,ZInv,
     &                  rKapab,P,rKapcd,Q,nZeta,Wrk,nWork2,
     &                  HMtrx,nHrrMtrx,iShlla,jShllb,i_Int)
************************************************************************
*                                                                      *
* Object: to compute zeta, kappa, P, and the integrals [nm|nm] for     *
*         prescreening. This is done for all unique pairs of centers   *
*         generated from the symmetry unique centers A and B.          *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN.                              *
*             June '91, modified to compute zeta, P, kappa and inte-   *
*             grals for Schwartz inequality in a k2 loop.              *
*             April '92 modified from k2Loop to a separate subroutine  *
*              for estimates of the gradient.                          *
************************************************************************
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
      External TERISq, ModU2, Cff2Dq, xRys2D
#include "real.fh"
#include "print.fh"
      Real*8  CoorM(3,4), CoorAC(3,2), HMtrx(nHrrMtrx,2),
     &       Zeta(mZeta), ZInv(mZeta), rKapab(mZeta), P(nZeta,3),
     &       Q(nZeta,3), rKapcd(mZeta), Wrk(nWork2)
      Integer iAnga(4), iCmp(4)
      Logical EQ, NoSpecial
*
*     Statement function to compute canonical index
*
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
      nElem(i)    = (i+1)*(i+2)/2
*
      iRout = 242
      iPrint = nPrint(iRout)
*     iQ = 1
      la = iAnga(1)
      lb = iAnga(2)
      If (iPrint.ge.19) Then
         Call RecPrt(' In SchInt: CoorM',' ',CoorM,3,4)
         Call RecPrt(' In SchInt: P',' ',P,nZeta,3)
         Call RecPrt(' In SchInt: Q',' ',Q,nZeta,3)
         Write (6,*) 'iAnga=',iAnga
      End If
*
*
*-----Compute primitive integrals to be used in the prescreening
*     by the Schwartz inequality.
*
*
*-----Compute actual size of [a0|c0] block
*
      mabMin=nabSz(Max(la,lb)-1)+1
      If (EQ(CoorM(1,1),CoorM(1,2))) mabMin = nabSz(la+lb-1)+1
      mabMax=nabSz(la+lb)
      mcdMin=nabSz(Max(la,lb)-1)+1
      If (EQ(CoorM(1,3),CoorM(1,4))) mcdMin = nabSz(la+lb-1)+1
      mcdMax=mabMax
      mabcd=(mabMax-mabMin+1)*(mcdMax-mcdMin+1)
*
*-----Find the proper centers to start of with the angular
*     momentum on. If la.eq.lb there will exist an
*     ambiguity to which center that angular momentum should
*     be accumulated on. In that case we will use A and C of
*     the order as defined by the basis functions types.
*
      If (iAnga(1).ge.iAnga(2)) Then
         call dcopy_(3,CoorM(1,1),1,CoorAC(1,1),1)
         call dcopy_(3,CoorM(1,3),1,CoorAC(1,2),1)
      Else
         call dcopy_(3,CoorM(1,2),1,CoorAC(1,1),1)
         call dcopy_(3,CoorM(1,4),1,CoorAC(1,2),1)
      End If
*
*-----Compute [a0|c0], ijkl,a,c
*
      If (iPrint.ge.19) nPrint(13)=99
      nT = mZeta*1
      NoSpecial=.True.
      Call Rys(iAnga,nT,
     &         Zeta,ZInv,mZeta,Zeta,ZInv,mZeta,P,nZeta,Q,nZeta,
     &         rKapab,rKapcd,CoorM,CoorM,CoorAC,
     &         mabMin,mabMax,mcdMin,mcdMax,
     &         Wrk,nWork2,TERISq,ModU2,Cff2Dq,
     &         xRys2D,NoSpecial)
      If (iPrint.ge.19) nPrint(13)=5
*
      If (iPrint.ge.19) Call TrcPrt(' In SchInt: ijkl,[a0|c0]',' ',
     &                              Wrk,mZeta,mabcd)
      If (iPrint.ge.59) Call RecPrt(' In SchInt: ijkl,[a0|c0]',' ',
     &                              Wrk,mZeta,mabcd)
*                                                                      *
************************************************************************
*                                                                      *
*        Generate transformation matrix from intermediate integrals
*        to final angular composition, observe that since the 2nd order
*        particle matrix is transformed from real spherical harmonics
*        to cartesians that the prescreening integrals also are in
*        cartesians!
*
         ne=(mabMax-mabMin+1)
         Call HrrMtrx(HMtrx(1,1),ne,la,lb,CoorM(1,1),CoorM(1,2),
     &                .False.,RSph(ipSph(la)),nElem(la),
     &                .False.,RSph(ipSph(lb)),nElem(lb))
         Call HrrMtrx(HMtrx(1,2),ne,la,lb,CoorM(1,3),CoorM(1,4),
     &                .False.,RSph(ipSph(la)),nElem(la),
     &                .False.,RSph(ipSph(lb)),nElem(lb))
*                                                                      *
************************************************************************
*                                                                      *
*------- Apply a transpose prior to Tnsctl to fake the action of Cntrct.
*
         iW3=1+mZeta*mabcd
         Call DGeTMO(Wrk,mZeta,mZeta,mabcd,Wrk(iW3),mabcd)
         call dcopy_(mabcd*mZeta,Wrk(iW3),1,Wrk,1)
         Call TnsCtl(Wrk,nWork2,CoorM,
     &               mabcd,mZeta,mabMax,mabMin,mabMax,mabMin,
     &               HMtrx(1,1),HMtrx(1,2),
     &               la,lb,la,lb,
     &               nElem(la),nElem(lb),nElem(la),nElem(lb),
     &               iShlla,jShllb,iShlla,jShllb,i_Int)
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.19) Call TrcPrt(' In SchInt',' ',Wrk(i_Int),
     &      mZeta,(nElem(la)*nElem(lb))**2)
      If (iPrint.ge.99) Call RecPrt(' In SchInt',' ',Wrk(i_Int),
     &      mZeta,(nElem(la)*nElem(lb))**2)
*     Call GetMem(' Exit SchInt','CHECK','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(iCmp)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_CheckAllC_wLD(DoPrint)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: check all coefficients.
C
      Implicit None
      Logical DoPrint
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair_wLD
      External LDF_nBas_Atom, LDF_nBasAux_Pair_wLD

      Real*8 NormA, NormB, NormAB, NormTot

      Integer AB
      Integer ip_C, l_C, l_thisC

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      l_C=0
      Do AB=1,NumberOfAtomPairs
         l_C=max(l_C,LDF_nBas_Atom(AP_Atoms(1,AB))
     &              *LDF_nBas_Atom(AP_Atoms(2,AB))
     &              *LDF_nBasAux_Pair_wLD(AB))
      End Do
      Call GetMem('CCHE_C','Allo','Real',ip_C,l_C)
      Do AB=1,NumberOfAtomPairs
         l_thisC=LDF_nBas_Atom(AP_Atoms(1,AB))
     &          *LDF_nBas_Atom(AP_Atoms(2,AB))
     &          *LDF_nBasAux_Pair_wLD(AB)
         Call LDF_CIO_ReadC_wLD(AB,Work(ip_C),l_thisC)
         Call LDF_CheckC_wLD(DoPrint,AB,l_thisC,Work(ip_C),
     &                       NormA,NormB,NormAB,NormTot)
      End Do
      Call GetMem('CCHE_C','Free','Real',ip_C,l_C)

      End
      Subroutine LDF_CheckC_wLD(DoPrint,AB,l_C,C,
     &                          NormA,NormB,NormAB,NormTot)
C
C     Thomas Bondo Pedersen, January 2011.
C
C     Purpose: compute and optionally print norm of fitting coefficients
C              with linearly dependent functions retained.
C              It is checked that coefficients are symmetric when A=B,
C              i.e. C(uv,J)=C(vu,J).
C              It is checked that coefficients corresponding to LinDep
C              functions are zero.
C              It is checked that 2CFunction coefficients are one for
C              the corresponding product functions.
C
      Implicit None
      Logical DoPrint
      Integer AB
      Integer l_C
      Real*8  C(l_C)
      Real*8 NormA
      Real*8 NormB
      Real*8 NormAB
      Real*8 NormTot
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "ldf_atom_pair_info.fh"

      Character*14 SecNam
      Parameter (SecNam='LDF_CheckC_wLD')

      Real*8 Small
      Parameter (Small=1.0d-20)
      Real*8 Tol
      Parameter (Tol=1.0d-12)

      Logical  isConstant
      External isConstant

      Integer  LDF_nBas_Atom, LDF_nBasAux_Atom, LDF_nBasAux_Pair_wLD
      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nBas_Atom, LDF_nBasAux_Atom, LDF_nBasAux_Pair_wLD
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom

      real*8 ddot_
      external ddot_

      Integer A, B
      Integer n, M
      Integer ip, l
      Integer ip_Col, l_Col, ipCol
      Integer iCount
      Integer nASA, nASB
      Integer ipA, ipB
      Integer kAtom, kS, k
      Integer i1CLinDep
      Integer kShell
      Integer nErr, mErr
      Integer ip_Map, l_Map
      Integer i2CF, j2CF
      Integer iRow, iCol
      Integer ip0
      Integer ip_iOff, l_iOff
      Integer nSA, iSA, jSA, iA, jA, iShell, jShell, ijA, jiA

      Real*8 NormCol, Tst

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_1CLinDep
      Integer AP_2CFunctions
      Integer iOff
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      iOff(i,j)=iWork(ip_iOff-1+nSA*(j-1)+i)

      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      n=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      M=LDF_nBasAux_Pair_wLD(AB)
      If (n.lt.1 .or. M.lt.1) Then
         If (DoPrint) Then
            Write(6,'(A,A,2I10)')
     &      SecNam,': C(n,M) has zero dimension: n,M=',n,M
         End If
         Return
      End If

      l=n*M
      If (l_C.lt.l) Then
         Call WarningMessage(2,SecNam//': l_C<l')
         Write(6,'(A,2I10)') 'l_C,l=',l_C,l
         Call LDF_Quit(1)
      End If

      ip=1
      l=n*LDF_nBasAux_Atom(A)
      NormA=dDot_(l,C(ip),1,C(ip),1)
      NormTot=NormA
      NormA=sqrt(NormA)
      ip=ip+l
      If (B.ne.A) Then
         l=n*LDF_nBasAux_Atom(B)
         NormB=dDot_(l,C(ip),1,C(ip),1)
         NormTot=NormTot+NormB
         NormB=sqrt(NormB)
         ip=ip+l
      Else
         NormB=0.0d0
      End If
      If (AP_2CFunctions(1,AB).gt.0) Then
         l=n*AP_2CFunctions(1,AB)
         NormAB=dDot_(l,C(ip),1,C(ip),1)
         NormTot=NormTot+NormAB
         NormAB=sqrt(NormAB)
         ip=ip+l
      Else
         NormAB=0.0d0
      End If
      NormTot=sqrt(NormTot)

      If (DoPrint) Then
         Write(6,'(A,I10,1P,4(1X,A,D20.10))')
     &   'AB=',AB,'||CA||=',NormA,'||CB||=',NormB,'||CAB||=',NormAB,
     &   '||CTot||=',NormTot
         Call xFlush(6)
      End If

      ! Check symmetry when A=B
      If (A.eq.B) Then
         nSA=LDF_nShell_Atom(A)
         ipA=LDF_lShell_Atom(A)-1
         l_iOff=nSA**2
         Call GetMem('CiOff','Allo','Inte',ip_iOff,l_iOff)
         Call LDF_uvOffset(AB,nSA,nSA,iWork(ip_iOff))
         nErr=0
         ip=0
         Do iCol=1,M
            mErr=0
            Do jSA=1,nSA
               jShell=iWork(ipA+jSA)
               Do jA=1,nBasSh(jShell)-1
                  Do iA=jA+1,nBasSh(jShell)
                     ijA=iOff(jSA,jSA)+nBasSh(jShell)*(jA-1)+iA
                     jiA=iOff(jSA,jSA)+nBasSh(jShell)*(iA-1)+jA
                     If (abs(C(ip+ijA)-C(ip+jiA)).gt.Tol) Then
                        mErr=mErr+1
                     End If
                  End Do
               End Do
               Do iSA=jSA+1,nSA
                  iShell=iWork(ipA+iSA)
                  Do jA=1,nBasSh(jShell)
                     Do iA=1,nBasSh(iShell)
                        ijA=iOff(iSA,jSA)+nBasSh(iShell)*(jA-1)+iA
                        jiA=iOff(jSA,iSA)+nBasSh(jShell)*(iA-1)+jA
                        If (abs(C(ip+ijA)-C(ip+jiA)).gt.Tol) Then
                           mErr=mErr+1
                        End If
                     End Do
                  End Do
               End Do
            End Do
            If (mErr.ne.0) Then
               Write(6,'(A,I10,A,I10,A,I10,A,1P,D20.10,A)')
     &         'AB=',AB,' J=',iCol,' #Err=',mErr,
     &         ': C(uv,J) != C(vu,J)  (Tol=',Tol,')'
               nErr=nErr+mErr
            End If
            ip=ip+n
         End Do
         If (nErr.gt.0) Then
            Call WarningMessage(2,SecNam//': C not symmetric')
            Call LDF_Quit(1)
         End If
         Call GetMem('CiOff','Free','Inte',ip_iOff,l_iOff)
      End If

      ! Check that LinDep cols are zero
      If (AP_1CLinDep(1,AB).gt.0) Then
         l_Col=LDF_nAuxShell_Atom(A)
         If (B.ne.A) Then
            l_Col=l_Col+LDF_nAuxShell_Atom(B)
         End If
         Call GetMem('CCol','Allo','Inte',ip_Col,l_Col)
         nASA=LDF_nAuxShell_Atom(A)
         ipA=LDF_lAuxShell_Atom(A)-1
         ip=ip_Col-1
         iCount=0
         Do kS=1,nASA
            iWork(ip+kS)=iCount
            iCount=iCount+n*nBasSh(iWork(ipA+kS))
         End Do
         If (B.ne.A) Then
            nASB=LDF_nAuxShell_Atom(B)
            ipB=LDF_lAuxShell_Atom(B)-1
            ip=ip+nASA
            Do kS=1,nASB
               iWork(ip+kS)=iCount
               iCount=iCount+n*nBasSh(iWork(ipB+kS))
            End Do
         Else
            nASB=nASA
            ipB=ipA
         End If
         If (iCount.gt.(l_C-n*AP_2CFunctions(1,AB))) Then
            Call WarningMessage(2,SecNam//': Logical error [1]')
            Call LDF_Quit(1)
         End If
         nErr=0
         ip=AP_1CLinDep(2,AB)-1
         Do i1CLinDep=1,AP_1CLinDep(1,AB)
            kAtom=iWork(ip+3*(i1CLinDep-1)+1)
            kS=iWork(ip+3*(i1CLinDep-1)+2)
            k=iWork(ip+3*(i1CLinDep-1)+3)
            If (kAtom.eq.A) Then
               If (kS.lt.1 .or. kS.gt.nASA) Then
                  Call WarningMessage(2,SecNam//': Logical error [3]')
                  Call LDF_Quit(1)
               End If
               kShell=iWork(ipA+kS)
               If (kShell.le.nShell_Valence .or.
     &             kShell.gt.(nShell_Valence+nShell_Auxiliary)) Then
                  Call WarningMessage(2,SecNam//': Logical error [5]')
                  Call LDF_Quit(1)
               End If
               If (k.lt.1 .or. k.gt.nBasSh(kShell)) Then
                  Call WarningMessage(2,SecNam//': Logical error [7]')
                  Call LDF_Quit(1)
               End If
               ipCol=iWork(ip_Col-1+kS)+n*(k-1)+1
               NormCol=sqrt(dDot_(n,C(ipCol),1,C(ipCol),1))
               If (NormCol.gt.Small) Then
                  nErr=nErr+1
                  Write(6,'(A,I10,1X,A,I10,1X,A,1P,D20.10)')
     &            'AB=',AB,'Norm of LinDep col',i1CLinDep,
     &            'is non-zero:',NormCol
                  Write(6,'(3X,A,3I10)')
     &            '- info about LinDep col: k,kS,kAtom=',k,kS,kAtom
               End If
            Else If (kAtom.eq.B) Then
               If (kS.lt.1 .or. kS.gt.nASB) Then
                  Call WarningMessage(2,SecNam//': Logical error [4]')
                  Call LDF_Quit(1)
               End If
               kShell=iWork(ipB+kS)
               If (kShell.le.nShell_Valence .or.
     &             kShell.gt.(nShell_Valence+nShell_Auxiliary)) Then
                  Call WarningMessage(2,SecNam//': Logical error [6]')
                  Call LDF_Quit(1)
               End If
               If (k.lt.1 .or. k.gt.nBasSh(kShell)) Then
                  Call WarningMessage(2,SecNam//': Logical error [8]')
                  Call LDF_Quit(1)
               End If
               ipCol=iWork(ip_Col-1+nASA+kS)+n*(k-1)+1
               NormCol=sqrt(dDot_(n,C(ipCol),1,C(ipCol),1))
               If (NormCol.gt.Small) Then
                  nErr=nErr+1
                  Write(6,'(A,I10,1X,A,I10,1X,A,1P,D20.10)')
     &            'AB=',AB,'Norm of LinDep col',i1CLinDep,
     &            'is non-zero:',NormCol
                  Write(6,'(3X,A,3I10)')
     &            '- info about LinDep col: k,kS,kAtom=',k,kS,kAtom
               End If
            Else
               Call WarningMessage(2,SecNam//': Logical error [2]')
               Call LDF_Quit(1)
            End If
         End Do
         Call GetMem('CCol','Free','Inte',ip_Col,l_Col)
         If (nErr.ne.0) Then
            Call WarningMessage(2,SecNam//': non-zero LinDep col found')
            Write(6,'(A,I10,A,2I10)') 'Atom pair=',AB,'  Atoms=',A,B
            Write(6,'(A,I10)') 'Number of non-zero LinDep cols=',nErr
            Write(6,'(A,I10)') 'Total number of LinDep cols=',
     &                         AP_1CLinDep(1,AB)
            Call LDF_Quit(1)
         End If
      End If

      ! Check 2C parts
      If (AP_2CFunctions(1,AB).gt.0) Then
         l_Map=AP_2CFunctions(1,AB)
         Call GetMem('2CMap','Allo','Inte',ip_Map,l_Map)
         Call LDF_Map2CF(AB,l_Map,1,iWork(ip_Map))
         l=AP_2CFunctions(1,AB)**2
         Call GetMem('2CBlock','Allo','Real',ip,l)
         iCol=LDF_nBasAux_Atom(A)
         If (B.ne.A) Then
            iCol=iCol+LDF_nBasAux_Atom(B)
         End If
         nErr=0
         Do j2CF=1,AP_2CFunctions(1,AB)
            ip0=ip-1+AP_2CFunctions(1,AB)*(j2CF-1)
            Do i2CF=1,AP_2CFunctions(1,AB)
               iRow=iWork(ip_Map-1+i2CF)
               Work(ip0+i2CF)=C(n*iCol+iRow)
            End Do
            iRow=iWork(ip_Map-1+j2CF)
            Tst=sqrt(dDot_(M,C(iRow),n,C(iRow),n))
            If (abs(Tst-1.0d0).gt.Tol) Then
               nErr=nErr+1
               Write(6,'(2X,A,I10,1X,A,I10,1X,A,1P,D20.10)')
     &         'AB=',AB,'2CFunction=',j2CF,'norm of C row=',Tst
               Write(6,'(2X,A)') 'C row:'
               Call Cho_Output(C,iRow,iRow,1,M,n,M,1,6)
            End If
            iCol=iCol+1
         End Do
         Do i2CF=1,AP_2CFunctions(1,AB)
            Work(ip-1+AP_2CFunctions(1,AB)*(i2CF-1)+i2CF)=
     &               Work(ip-1+AP_2CFunctions(1,AB)*(i2CF-1)+i2CF)-1.0d0
         End Do
         If (.not.isConstant(Work(ip),l,0.0d0,Tol)) Then
            Call WarningMessage(2,
     &                     SecNam//': 2C subblock minus unit not zero!')
            Call Cho_Head(SecNam//': 2C subblock minus unit','-',80,6)
            Call Cho_Output(Work(ip),1,AP_2CFunctions(1,AB),
     &                      1,AP_2CFunctions(1,AB),AP_2CFunctions(1,AB),
     &                      AP_2CFunctions(1,AB),1,6)
            Write(6,'(/,2X,A,1P,D20.10)')
     &      'RMS=',sqrt(dDot_(l,Work(ip),1,Work(ip),1)/dble(l))
            If (nErr.ne.0) Then
               Call WarningMessage(2,
     &                              SecNam//': non-unit norm of 2C row')
               Write(6,'(A,I10,A,2I10)') 'Atom pair=',AB,'  Atoms=',A,B
               Write(6,'(A,I10)') 'Number of non-unit 2C rows=',nErr
               Write(6,'(A,I10)') 'Total number of 2C rows=',
     &                            AP_2CFunctions(1,AB)
            End If
            Call LDF_Quit(1)
         End If
         If (nErr.ne.0) Then
            Call WarningMessage(2,SecNam//': non-unit norm of 2C row')
            Write(6,'(A,I10,A,2I10)') 'Atom pair=',AB,'  Atoms=',A,B
            Write(6,'(A,I10)') 'Number of non-unit 2C rows=',nErr
            Write(6,'(A,I10)') 'Total number of 2C rows=',
     &                         AP_2CFunctions(1,AB)
            Call LDF_Quit(1)
         End If
         Call GetMem('2CBlock','Free','Real',ip,l)
         Call GetMem('2CMap','Free','Inte',ip_Map,l_Map)
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRCMAT(NSS,XMATR,XMATI)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 XMATR(NSS,NSS),XMATI(NSS,NSS)
C Write out matrix elements over states as a complex matrix
C in square format
      DO JSTA=1,NSS,2
       JEND=MIN(NSS,JSTA+1)
       WRITE(6,*)
       WRITE(6,'(1X,A8,12X,I3,35X,I3)')' STATE  ',(JSS,JSS=JSTA,JEND)
       DO ISS=1,NSS
       WRITE(6,'(1X,I4,2x,2(A1,F10.6,A1,F10.6,A1,3x))')
     &           ISS,('(',XMATR(ISS,JSS),',',XMATI(ISS,JSS),
     &           ')',JSS=JSTA,JEND)
       END DO
      END DO
      RETURN
      END

      SUBROUTINE PRCMAT2(INPUT,NSS,XMATR,XMATI)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 XMATR(NSS,NSS),XMATI(NSS,NSS)
#include "Molcas.fh"
#include "cntrl.fh"
      CHARACTER(LEN=8) PROPERTY
      CHARACTER(LEN=1) DIRECTION
      CHARACTER(LEN=200) FILENAME
C Write out matrix elements over states as a complex matrix
C in parsable format
      if(INPUT.gt.0) THEN
        PROPERTY = SOPRNM(INPUT)
      ELSE
        PROPERTY = 'EIGVEC'
      ENDIF

      WRITE(DIRECTION,'(I1)') ISOCMP(INPUT)
      IF (PROPERTY(1:4).EQ."MLTP") THEN
          IF (PROPERTY(8:8).EQ.'0') THEN
            FILENAME = 'monopole-'//DIRECTION//'.txt'
          ELSE IF (PROPERTY(8:8).EQ.'1') THEN
            FILENAME = 'dipole-'//DIRECTION//'.txt'
          ELSE IF (PROPERTY(8:8).EQ.'2') THEN
            FILENAME = 'quadrupole-'//DIRECTION//'.txt'
          ELSE
            GO TO 100
          END IF
      ELSE IF (PROPERTY(1:4).EQ."ANGM") THEN
          FILENAME = 'angmom-'//DIRECTION//'.txt'
      ELSE IF (PROPERTY(1:6).EQ."EIGVEC") THEN
          FILENAME = "eigvectors.txt"
      ELSE
          GO TO 100
      END IF
      OPEN(UNIT=88,FILE=FILENAME,STATUS='REPLACE')
      WRITE(88,*) "#NROW NCOL REAL IMAG"
      DO JSTA=1,NSS
        DO ISS=1,NSS
        WRITE(88,'(I4,I4,A1,E25.16,A1,E25.16)') ISS,JSTA,' ',
     &   XMATR(ISS,JSTA),' ',XMATI(ISS,JSTA)
        END DO
      END DO
      CLOSE(88)
 100  CONTINUE
      RETURN
      END

      SUBROUTINE PRCMAT3(NSS,SMATR,SMATI,DIR)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 SMATR(NSS,NSS), SMATI(NSS,NSS)
      INTEGER DIR
#include "Molcas.fh"
#include "cntrl.fh"
      CHARACTER(LEN=1) DIRECTION
      CHARACTER(LEN=200) FILENAME
C Write out spin matrix elements in parsable format
      WRITE(DIRECTION,'(I1)') DIR
      FILENAME = 'spin-'//DIRECTION//'.txt'
      OPEN(UNIT=88,FILE=FILENAME,STATUS='REPLACE')
      WRITE(88,*) "#NROW NCOL REAL IMAG"
      DO JSTA=1,NSS
        DO ISS=1,NSS
        WRITE(88,'(I4,I4,A1,E25.16,A1,E25.16)') ISS,JSTA,' ',
     &   SMATR(ISS,JSTA),' ',SMATI(ISS,JSTA)
        END DO
      END DO
      CLOSE(88)
      RETURN
      END

      SUBROUTINE MULMAT(NSS,XMATR,XMATI,ee,Z)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 XMATR(NSS,NSS),XMATI(NSS,NSS)
      COMPLEX*16 Z(NSS,NSS)
      ee=0.d0
      DO ISS=1,NSS
      DO JSS=1,NSS
      Z(ISS,JSS)=(0.0d0,0.0d0)
      enddo
      enddo
      DO ISS=1,NSS
      DO JSS=1,NSS
      ee=ee+XMATR(ISS,JSS)*XMATR(ISS,JSS)+
     & XMATI(ISS,JSS)*XMATI(ISS,JSS)
      Z(ISS,JSS)=Z(ISS,JSS)+
     &DCMPLX(XMATR(ISS,JSS),XMATI(ISS,JSS))
      enddo
      enddo
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FREQ(nX,H,nDeg,nrvec,Tmp3,EVec,EVal,RedM,iNeg)
      Implicit Real*8 (a-h,o-z)
      Real*8 H(*), Tmp3(nX,nX),
     &       EVec(2*nX,nX),
     &       EVal(2*nX),
     &       RedM(nX)

#include "real.fh"
#include "constants2.fh"
#include "stdalloc.fh"
      Integer nrvec(*),ndeg(*)
      Logical Found
      Real*8, Allocatable :: Mass(:)
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

*
*----- read masses from runfile
*
      Call Qpg_dArray('Isotopes',Found,nIsot)
      If (.Not.Found) Then
        Write(6,*) 'No masses found on RunFile'
        Call AbEnd()
      End If
      Call mma_allocate(Mass,nIsot)
      Call Get_dArray('Isotopes',Mass,nIsot)
*
*----- form the Mass Weighted Cartesian force constant matrix.
*
      iprint=0
      Do i = 1, nX
         rm=Mass(nrvec(i))
         If (rm.eq.Zero) rm=1.0d7
         Do j=1,nX
            Tmp3(i,j) = sqrt(DBLE(nDeg(i)*nDeg(j)))*
     &                  H(itri(i,j))/rm
       End Do
      End Do
*
*-----Compute eigenvectors and eigenfunctions
*
      iOpt=1
      If ( nX.gt.0 ) then
        Call Not_DGeEv(iOpt,Tmp3,nX,
     &             EVal,EVec,nX,
     &             nX)
      End If
*
*-----Compute the harmonic frequencies
*
      iNeg=0
      Do 649 iHarm = 1, 2*nX, 2
         jHarm = (iHarm+1)/2
         temp = EVal(iHarm)
         If (temp.ge.Zero) Then
            EVal(jHarm) = Sqrt(temp)*autocm
         Else
            iNeg=iNeg+1
            EVal(jHarm) = -Sqrt(Abs(temp))*autocm
         End If
 649  Continue
      If (iPrint.ge.99) Call RecPrt('Converted EVal',' ',EVal,1,nX)
      If (iPrint.ge.99) Call RecPrt('Normalized EVec',' ',
     &                               EVec,nX*2,nX)
*
*-----Normalize
*
      Do iHarm = 1, nX
        r2=Zero
        Do i=1,nx
            rm=Mass(nrvec(i))/UTOAU
            r2=r2+Evec(2*(i-1)+1,iHarm)*Evec(2*(i-1)+1,iHarm)*rm
        End Do
        RedM(iHarm)=r2
        r2=One/Sqrt(r2)
        Call DScal_(nX,r2,EVec(1,iHarm),2)
      End Do
*
*-----Order, from low to high.
*
      Do iHarm = 1, nX-1
         Do jHarm = iHarm+1, nX
            If (EVal(jHarm).lt.EVal(iHarm)) Then
               rlow=EVal(iHarm)
               EVal(iHarm)=EVal(jHarm)
               EVal(jHarm)=rLow
               rlow=RedM(iHarm)
               RedM(iHarm)=RedM(jHarm)
               RedM(jHarm)=rLow
               Call DSwap_(nX,EVec(1,iHarm),2,EVec(1,jHarm),2)
            End If
         End Do
      End Do
*
      Call mma_deallocate(Mass)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SPSPCLS_GAS( NOCTPA, NOCTPB,   IOCA,   IOCB, NELFGP,
     &                       MXPNGAS,   NGAS,ISPSPCLS,  ICLS,  NCLS,
     &                         IPRNT)
*
* Obtain mapping a-supergroup X b-supergroup => class
*
*
* =====
*.Input
* =====
*
* NOCTPA : Number of alpha types
* NOCTPB : Number of beta types
*
* IOCA(IGAS,ISTR) occupation of AS IGAS for alpha string type ISTR
* IOCB(IGAS,ISTR) occupation of AS IGAS for beta  string type ISTR
*
* MXPNGAS : Largest allowed number of gas spaces
* NGAS    : Actual number of gas spaces

*
* ======
*.Output
* ======
*
* ISPSPCLS(IATP,IBTP) => Class of this block of determinants
*                        =0 indicates unallowed(class less) combination
*
*.Input
      INTEGER IOCA(MXPNGAS,NOCTPA),IOCB(MXPNGAS,NOCTPB)
      INTEGER NELFGP(*)
      INTEGER ICLS(NGAS,NCLS)
*.Output
      INTEGER ISPSPCLS(NOCTPA,NOCTPB)

*
      NTEST = 000
      NTEST = MAX(NTEST,IPRNT)
      IF(NTEST.GE.10) THEN
        WRITE(6,*) ' ISPSPCLS_GAS entered '
        WRITE(6,*) ' ==================='
        WRITE(6,*)
        WRITE(6,*) ' IOCA and IOCB '
        CALL IWRTMA(IOCA,NGAS,NOCTPA,MXPNGAS,NGAS)
        CALL IWRTMA(IOCB,NGAS,NOCTPB,MXPNGAS,NGAS)
        WRITE(6,*)
        WRITE(6,*) ' ICLS '
        CALL IWRTMA(ICLS,NGAS,NCLS,NGAS,NCLS)
      END IF
*
      DO 100 IATP = 1, NOCTPA
        DO 90 IBTP = 1, NOCTPB
          IICLS = 0
          DO KCLS = 1, NCLS
            IAMOKAY = 1
            DO IGAS = 1, NGAS
              IEL = NELFGP(IOCA(IGAS,IATP))+NELFGP(IOCB(IGAS,IBTP))
              IF(IEL.NE.ICLS(IGAS,KCLS)) IAMOKAY = 0
            END DO
            IF(IAMOKAY.EQ.1) IICLS=KCLS
          END DO
          ISPSPCLS(IATP,IBTP) = IICLS
   90   CONTINUE
  100 CONTINUE
*
      IF ( NTEST .GE. 10 ) THEN
        WRITE(6,*)
        WRITE(6,*) ' Matrix giving classes for alpha-beta supergroups'
        WRITE(6,*)
        CALL IWRTMA(ISPSPCLS,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
      END IF
*
      RETURN
      END
C     BLKCLS(WORK(KLCIBT),NBLOCKS,WORK(KLBLKCLS),WORK(KLSPSPCL),
C    &            NOCTPA,NOCTPB)

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Ten-no Research Group                            *
!               2012, Thomas Bondo Pedersen                            *
!***********************************************************************

function FuncLa(X,Delta)

use Constants, only: One
use Definitions, only: wp

implicit none
real(kind=wp) :: FuncLa
real(kind=wp), intent(in) :: X, Delta

FuncLa = exp((-Delta+One)*X)

return

end function FuncLa

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2003-2005, Valera Veryazov                             *
!               2017, Roland Lindh                                     *
!***********************************************************************

subroutine Reset_Thresholds()

use Gateway_Info, only: ThrInt
use InfSCF, only: DltNTh, DltNTh_old, DThr, DThr_Old, EThr, EThr_old, FThr, FThr_Old, ThrInt_Old
use Definitions, only: u6

implicit none

write(u6,*)
write(u6,*) 'Restore thresholds...'
write(u6,*)
EThr = EThr_old
DThr = DThr_old
DltNTh = DltNTh_old
FThr = FThr_old
ThrInt = ThrInt_Old

return

end subroutine Reset_Thresholds

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE NXTBLK_MCLR(IATP,IBTP,IASM,NOCTPA,NOCTPB,NSMST,IBLTP,
     &                  IDC,NONEW,IOCOC)
*
* Obtain allowed block following IATP IBTP IASM
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER IBLTP(*)
      INTEGER IOCOC(NOCTPA,NOCTPB)
*
*.Initialize
      ISM = IASM
      IA = IATP
      IB = IBTP
      NONEW = 0
*.Next block
 1000 CONTINUE
      IF(IB.LT.NOCTPB) THEN
        IB = IB + 1
      ELSE
        IB = 1
        IF(IA.LT.NOCTPA) THEN
          IA = IA+ 1
        ELSE
          IA = 1
          IF(ISM.LT.NSMST) THEN
            ISM = ISM + 1
          ELSE
            NONEW = 1
          END IF
        END IF
      END IF
      IF(NONEW.EQ.1) GOTO 1001
*. Should this block be included
      IF(IDC.NE.1.AND.IBLTP(ISM).EQ.0) GOTO 1000
      IF(IDC.NE.1.AND.IBLTP(ISM).EQ.2.AND.IA.LT.IB) GOTO 1000
      IF(IOCOC(IA,IB).EQ.0) GOTO 1000
 1001 CONTINUE
*
      IATP = IA
      IBTP = IB
      IASM = ISM
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,'(A,4I4)')
     &  ' NXTBLK : ISM IA IB NONEW ', IASM,IA,IB,NONEW
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993,2000, Markus P. Fuelscher                         *
!***********************************************************************

subroutine R8LEN(iOpt,nData,Buf,iLen)
!***********************************************************************
!                                                                      *
!     Subroutine R8Len                                                 *
!                                                                      *
!     purpose: compute the packed size of a double precision           *
!              floating point number                                   *
!                                                                      *
!    Calling parameters:                                               *
!    iOpt  : Bit switch                                                *
!            bits 0-3 used for packing algorithm                       *
!    nData : number of data elements                                   *
!    Buf   : buffer containing the data                                *
!    iLen  : buffer containing the packed length                       *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher and P. O. Widmark                                 *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history:                                                         *
!     replacement of packing routines                                  *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 2000                                 *
!                                                                      *
!***********************************************************************

use Pack_mod, only: Init_do_setup_l, isPack, PkThrs
use Definitions, only: wp, iwp, RtoB

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: iOpt, nData
real(kind=wp), intent(in) :: Buf(*)
integer(kind=iwp), intent(_OUT_) :: iLen(*)
integer(kind=iwp) :: i, iZero, Kase

!----------------------------------------------------------------------*

if (.not. isPack) then
  call ICOPY(nData,[RtoB],0,iLen,1)
else
  !call ERIlen(nData,PkThrs,Buf,iLen)
  Kase = ibits(iOpt,0,4)
  if (Kase == 0) then
    call tcl_r8(Buf,nData,iLen,PkThrs,Init_do_setup_l)
    Init_do_setup_l = 0
  else
    iZero = 8
    call iCopy(nData,[8],0,iLen,1)
    do i=1,nData
      if (abs(Buf(i)) < PkThrs) then
        iLen(i) = iZero
        iZero = 0
      else
        !iLen(i) = 8
        iZero = 8
      end if
    end do
  end if
end if

!----------------------------------------------------------------------*

return

end subroutine R8LEN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine ccsd_exc (key)
c
c       check, if there is atleast one determinant in CCSD expansion
c       key=0 - no determinant in expansion
c           1 - only monoexcitations in expansion
c           2 - both mono and biexcitations in expansion
c
        implicit none
#include "ccsd1.fh"
        integer key
c
c       help variables
        integer isym,jsym,ijsym,asym,bsym,nij,nab
        integer naa,nbb,naaaa,nbbbb,nabab
c
c
c1.1    calc # of monoexcitations
c       taking into account also symmetry

        naa=0
        nbb=0
        do isym=1,nsym
          asym=isym
          naa=naa+noa(isym)*nva(asym)
          nbb=nbb+nob(isym)*nvb(asym)
        end do
c
c1.2    calc # of biexcitation
c       taking into account also symmetry
c
        naaaa=0
        do isym=1,nsym
        do jsym=1,isym
        ijsym=mmul(isym,jsym)
        if (isym.eq.jsym) then
          nij=noa(isym)*(noa(isym)-1)/2
        else
          nij=noa(isym)*noa(jsym)
        end if
          do asym=1,nsym
          bsym=mmul(ijsym,asym)
          if (bsym.lt.asym) then
            nab=nva(asym)*nva(bsym)
          else if (bsym.eq.asym) then
            nab=nva(asym)*(nva(asym)-1)/2
          else
            nab=0
          end if
          naaaa=naaaa+nij*nab
          end do
        end do
        end do
c
        nbbbb=0
        do isym=1,nsym
        do jsym=1,isym
        ijsym=mmul(isym,jsym)
        if (isym.eq.jsym) then
          nij=nob(isym)*(nob(isym)-1)/2
        else
          nij=nob(isym)*nob(jsym)
        end if
          do asym=1,nsym
          bsym=mmul(ijsym,asym)
          if (bsym.lt.asym) then
            nab=nvb(asym)*nvb(bsym)
          else if (bsym.eq.asym) then
            nab=nvb(asym)*(nvb(asym)-1)/2
          else
            nab=0
          end if
          nbbbb=nbbbb+nij*nab
          end do
        end do
        end do
c
        nabab=0
        do isym=1,nsym
        do jsym=1,isym
        ijsym=mmul(isym,jsym)
        nij=noa(isym)*nob(jsym)
          do asym=1,nsym
          bsym=mmul(ijsym,asym)
          nab=nva(asym)*nvb(bsym)
          nabab=nabab+nij*nab
          end do
        end do
        end do
c
c
c2      set key
c
        if ((naaaa+nbbbb+nabab).eq.0) then
          if ((naa+nbb).eq.0) then
            key=0
          else
            key=1
          end if
        else
          key=2
        end if
c
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine make_close_cvb(it)
      implicit real*8(a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"
#include "applyh_cvb.fh"

#include "io_cvb.fh"
#include "idbl_cvb.fh"
#include "fio.fh"
      character*8 vec(11)
      vec(1)='TMP01'
      vec(2)='TMP02'
      vec(3)='TMP03'
      vec(4)='TMP04'
      vec(5)='TMP05'
      vec(6)='TMP06'
      vec(7)='TMP07'
      vec(8)='TMP08'
      vec(9)='TMP09'
      vec(10)='VBWFN'
      vec(11)='JOBIPH'
      il=10
      if(it.eq.0) il=10
      if(it.eq.1) il=11
c  Preassign some file names to identifiers :
      do n=1,MxFile
         do i=1,il
             if(isOpen(n).eq.1) then
              if (LuName(n).eq.vec(i)) then
c         print *,'closing ',LuName(n)
                call daclos(n)
              endif
              endif
      enddo
      enddo
      if(.not.variat) then
         call mkguga_free()
         call getmem('CICTL1','FREE','REAL',lw1_cvb,0)
         call getmem('TUVX','FREE','REAL',ltuvx_cvb,0)
         call getmem('DMAT','FREE','REAL',ldmat_cvb,0)
         call getmem('DSPN','FREE','REAL',ldspn_cvb,0)
         call getmem('PMAT','FREE','REAL',lpmat_cvb,0)
         call getmem('P2AS','FREE','REAL',lpa_cvb,0)
         call getmem('DIAF','FREE','REAL',ldiaf_cvb,0)
         call getmem('FOCC','FREE','REAL',ipfocc_cvb,0)
         call getmem('FI','FREE','REAL',lfi_cvb,0)
         call getmem('FA','FREE','REAL',lfa_cvb,0)
         call getmem('D1I','FREE','REAL',ld1i_cvb,0)
         call getmem('D1A','FREE','REAL',ld1a_cvb,0)
         call getmem('D1tot','FREE','REAL',ld1tot_cvb,0)
         call getmem('OCCN','FREE','REAL',loccn_cvb,0)
         call getmem('LCMO','FREE','REAL',lcmo_cvb,0)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NRed(ArrIn,ArrOut,nX,nDim,Smmtrc)
      Implicit Real*8 (a-h,o-z)
      Real*8 ArrIn(nX), ArrOut(nDim)
      Logical Smmtrc(nX)
*
      iDim = 0
      Do iX = 1, nX
         If (Smmtrc(iX)) Then
            iDim = iDim + 1
            ArrOut(iDim)=ArrIn(iX)
         End If
      End Do
      If (iDim.ne.nDim) Then
         Write (6,*) 'In NRed: iDim.ne.nDim'
         Call Abend
      End If
*     Call RecPrt('ArrIn',' ',ArrIn,nX,1)
*     Call RecPrt('ArrOut',' ',ArrOut,nDim,1)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkV_Hoo2(V2,V,dima,dimb,no)
! this routine do:
! Make AntiSymmetric integrals
! V2(i,a',b',j) <- 2 V(b'i|a'j) - V(b'j|a'i)

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimb, dima, no
real(kind=wp), intent(out) :: V2(no,dima,dimb,no)
real(kind=wp), intent(in) :: V(dimb,no,dima,no)
integer(kind=iwp) :: a, b, j

do j=1,no
  do b=1,dimb
    do a=1,dima
      V2(:,a,b,j) = Two*V(b,j,a,:)-V(b,:,a,j)
    end do
  end do
end do

return

end subroutine MkV_Hoo2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine REFORM_CONF_FOR_GAS1(ICONF_GAS,ICONF,IBORB,IBEL,MXPORB,NEL)
! Reform between local and global numbering of
! configuration for given GAS space
!
! Global => Local
!
! Jeppe Olsen, November 2001

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: IBEL, NEL, ICONF(IBEL-1+NEL), IBORB, MXPORB
integer(kind=iwp), intent(inout) :: ICONF_GAS(MXPORB)

ICONF_GAS(1:NEL) = ICONF(IBEL:IBEL+NEL-1)-IBORB+1

#ifdef _DEBUGPRINT_
write(u6,*) ' Global => Local reform of conf'
write(u6,*) ' ICONF_GAS :'
call IWRTMA(ICONF_GAS,1,NEL,1,NEL)
write(u6,*) ' Accessed part of ICONF'
call IWRTMA(ICONF,1,IBEL-1+NEL,1,IBEL-1+NEL)
#endif

end subroutine REFORM_CONF_FOR_GAS1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_T21od (T21,beSGrp,gaSGrp)
c
c        test T2n+
c
        implicit none
#include "chcc1.fh"
        integer beSGrp,gaSGrp
        real*8 T21(1:32,1:32,1:no*(no-1)/2)
        integer a,b,u,v,be,ga,bega,uv,bad,gap,bep
        real*8 s
c
        if (beSGrp.eq.2) then
          bep=nv/2
        else
          bep=0
        end if
c
        if (gaSGrp.eq.2) then
          gap=nv/2
        else
          gap=0
        end if

        bad=0
c
        uv=0
        do u=2,no
        do v=1,u-1
        uv=uv+1
c
          bega=0
          do be=1,nv/2
          do ga=1,nv/2
          bega=bega+1
c
            s=0.0d0
            do a=1,nv
            b=a
            s=s+(Q4(b,gap+ga,a,bep+be)+Q4(b,bep+be,a,gap+ga))*
     c          (T2c(b,a,v,u)+T2c(b,a,u,v))/4
            end do
c
            s=0.0d0
            do a=2,nv
            do b=1,a-1
            s=s+(Q4(b,gap+ga,a,bep+be)-Q4(b,bep+be,a,gap+ga))*
     c          (T2c(b,a,v,u)-T2c(b,a,u,v))/2
            end do
            end do
c
          if (abs(T21(be,ga,uv)-s).gt.1.0d-10) then
            bad=bad+1
c        write (6,99) be,ga,u,v
c99        format (4(i3,1x))
          end if
          T21(be,ga,uv)=s
c
          end do
          end do
c
        end do
        end do
c
        if (bad.eq.0) then
        write (6,*) ' Chck T2 OK ', bad
        else
        write (6,*) ' Chck T2 Bug !!!!!!! ', bad
        end if
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Sergey Gusarov                                   *
*               2003, Roland Lindh                                     *
*               2003, Per Ake Malmqvist                                *
************************************************************************
      Subroutine Do_P2new(P2mo,np2act,D1mo,nd1mo,TabMO,mAO,mGrid,nMOs,
     &                   P2_ontop,nP2_ontop,RhoI,RhoA,mRho)
************************************************************************
*                                                                      *
* Object: Calculation P2 ontop density and its derivatives             *
*                                                                      *
* Called from: Do_batch                                                *
*                                                                      *
* Calling    : FZero                                                   *
*                                                                      *
*     Authors: Sergey Gusarov, University of Lund, SWEDEN,             *
*              Roland Lindh,   University of Lund, SWEDEN,             *
*              P.-A.Malmqvist, University of Lund, SWEDEN,             *
*              Jan. 2003                                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "nq_info.fh"
#include "real.fh"
      Real*8 P2mo(np2act),D1mo(nd1mo),TabMO(mAO,mGrid,nMOs),
     &       P2_ontop(nP2_ontop,mGrid)
      Integer iOff_Ash(0:7), iOff_Bas(0:7), iOff_BasAct(0:7)
      Real*8 RhoI(mRho,mGrid)
      Real*8 RhoA(mRho,mGrid)
c
c      Common  /Coord/ GGrid(3,5000)
c      Common /iCoord/ mmGrid
*                                                                      *
************************************************************************
*                                                                      *
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*      write(6,*) ' We are enter to P2cs'
*
*      Some paranoidal check(GS)
*
      If (nP2_ontop.eq.4) Then
         If (mAO.ne.4.or.mRho.ne.4) Then
           Call WarningMessage(2,' Somthings wrong in dim. in p2cs')
           Call Abend()
       End If
      Else If (nP2_ontop.eq.6) Then
         If (mAO.ne.10.or.mRho.ne.6) Then
           Call WarningMessage(2,' Somthings wrong in dim. in p2cs')
           Call Abend()
      End If
      End If
*
      Call FZero(P2_ontop,mGrid*nP2_ontop)
      jOffA_ = 0
      jOffB_ = 0
      Do iIrrep = 0, mIrrep-1
         iOff_Ash(iIrrep)=jOffA_
         iOff_Bas(iIrrep)=jOffB_
         iOff_BasAct(iIrrep)=jOffB_ + nIsh(iIrrep) + nFro(iIrrep)
         jOffA_=jOffA_+nAsh(iIrrep)
         jOffB_=jOffB_+mBas(iIrrep)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*   P(1,...) - P_2                                                     *
*   P(2,...), P(3,...), P(4,...) - grad P_2                            *
*   P(5,...) - grad^2 P_2                                              *
*   P(6,...) - additional part grad^2 P_2 for CS functional            *
*                                                                      *
************************************************************************
*
*          Inactive part:
*
************************************************************************
*                                                                      *
      NumIsh = 0
      NumAsh = 0
      Do iIrrep=0, mIrrep-1
         NumIsh = NumIsh + nISh(iIrrep)
         NumAsh = NumAsh + nAsh(iIrrep)
      End Do
*
      Do iGrid = 1, mGrid
      Do iIrrep=0, mIrrep-1
*      Write(6,*) " Symm:",iIrrep
       Do i_=1,nISh(iIrrep) + nFro(iIrrep)
        i = iOff_Bas(iIrrep) + i_
c
c         Write(6,*)  " do_p2cs: Inact-Inact:", iIrrep,i,
c     &               TabMO(1,iGrid,i)
c
          RhoI(1,iGrid) = RhoI(1,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(1,iGrid,i)
          RhoI(2,iGrid) = RhoI(2,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(2,iGrid,i)
          RhoI(3,iGrid) = RhoI(3,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(3,iGrid,i)
          RhoI(4,iGrid) = RhoI(4,iGrid) +
     *                    TabMO(1,iGrid,i)*TabMO(4,iGrid,i)
*
          RhoI(5,iGrid) = RhoI(5,iGrid) +
     *                    TabMO( 2,iGrid,i)*TabMO( 2,iGrid,i) +
     *                    TabMO( 3,iGrid,i)*TabMO( 3,iGrid,i) +
     *                    TabMO( 4,iGrid,i)*TabMO( 4,iGrid,i)
*
          RhoI(6,iGrid) = RhoI(6,iGrid) + TabMO(1,iGrid,i)*
     *                    ( TabMO( 5,iGrid,i) +
     *                      TabMO( 8,iGrid,i) +
     *                      TabMO(10,iGrid,i) )
       End Do         ! i_
      End Do         ! iIrrep
      End Do         ! iGrid
*
      If (NumIsh.ne.0) Then
      Do iGrid = 1, mGrid
       P2_ontop(1,iGrid) = RhoI(1,iGrid)*RhoI(1,iGrid)
c      Write(6,'(4f28.20)') P2_ontop(1,iGrid)
*
       P2_ontop(2,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(2,iGrid)
*
       P2_ontop(3,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(3,iGrid)
*
       P2_ontop(4,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(4,iGrid)
*
       P2_ontop(5,iGrid) = 4.0d0*RhoI(1,iGrid)*RhoI(5,iGrid) +
     *                     4.0d0*RhoI(1,iGrid)*RhoI(6,iGrid) +
     *                     8.0d0*(RhoI(2,iGrid)*RhoI(2,iGrid) +
     *                            RhoI(3,iGrid)*RhoI(3,iGrid) +
     *                            RhoI(4,iGrid)*RhoI(4,iGrid) )
*
       P2_ontop(6,iGrid) = 6.0d0*(RhoI(2,iGrid)*RhoI(2,iGrid) +
     *                            RhoI(3,iGrid)*RhoI(3,iGrid) +
     *                            RhoI(4,iGrid)*RhoI(4,iGrid))-
     *                      2.0d0*RhoI(1,iGrid)*RhoI(5,iGrid)
      End Do
      End If
************************************************************************
*
*          Active-Inactive part:
*
************************************************************************
      Do kIrrep = 0, mIrrep-1
         Do k_ = 1, nASh(kIrrep)
            k= k_ + iOff_BasAct(kIrrep)
            Do lIrrep = 0, mIrrep-1
               Do l_ = 1, nAsh(lIrrep)
                  l= l_ + iOff_BasAct(lIrrep)
                  kl=iTri(k_ + iOff_Ash(kIrrep) ,
     *                    l_ + iOff_Ash(lIrrep) )
                  Do iGrid = 1, mGrid
                     RhoA(1,iGrid) = RhoA(1,iGrid) +
     *                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(1,iGrid,l)
                     RhoA(2,iGrid) = RhoA(2,iGrid) +
     *                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(2,iGrid,l)
                     RhoA(3,iGrid) = RhoA(3,iGrid) +
     *                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(3,iGrid,l)
                     RhoA(4,iGrid) = RhoA(4,iGrid) +
     *                   D1mo(kl)*TabMO(1,iGrid,k)*TabMO(4,iGrid,l)
                     RhoA(5,iGrid) = RhoA(5,iGrid) + D1mo(kl)*(
     *                   TabMO(2,iGrid,k)*TabMO(2,iGrid,l) +
     *                   TabMO(3,iGrid,k)*TabMO(3,iGrid,l) +
     *                   TabMO(4,iGrid,k)*TabMO(4,iGrid,l) )
                     RhoA(6,iGrid) = RhoA(6,iGrid) +
     *                   D1mo(kl)*TabMO(1,iGrid,k)*(
     *                   TabMO( 5,iGrid,k) +
     *                   TabMO( 8,iGrid,k) +
     *                   TabMO(10,iGrid,k) )
                  End Do     ! iGrid
               End Do      ! l_
            End Do       ! lIrrep
         End Do        ! k_
      End Do        ! kIrrep
*
      Do iGrid = 1, mGrid
       P2_ontop(1,iGrid) = P2_ontop(1,iGrid) +
     *                     RhoI(1,iGrid)*RhoA(1,iGrid)
       P2_ontop(2,iGrid) = P2_ontop(2,iGrid) +
     *                     2.0d0*RhoI(2,iGrid)*RhoA(1,iGrid) +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(2,iGrid)
       P2_ontop(3,iGrid) = P2_ontop(3,iGrid) +
     *                     2.0d0*RhoI(3,iGrid)*RhoA(1,iGrid) +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(3,iGrid)
       P2_ontop(4,iGrid) = P2_ontop(4,iGrid) +
     *                     2.0d0*RhoI(4,iGrid)*RhoA(1,iGrid) +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(4,iGrid)
       P2_ontop(5,iGrid) = P2_ontop(5,iGrid) +
     *                     2.0d0*RhoI(5,iGrid)*RhoA(1,iGrid)  +
     *                     2.0d0*RhoI(6,iGrid)*RhoA(1,iGrid)  +
     *                     8.0d0*(RhoI(2,iGrid)*RhoA(2,iGrid) +
     *                            RhoI(3,iGrid)*RhoA(3,iGrid) +
     *                            RhoI(4,iGrid)*RhoA(4,iGrid))+
     *                     2.0d0*RhoI(1,iGrid)*RhoA(5,iGrid)  +
     *                     2.0d0*RhoI(1,iGrid)*RhoA(6,iGrid)

*
       P2_ontop(6,iGrid) = P2_ontop(6,iGrid) +
     *                     6.0d0*(RhoI(2,iGrid)*RhoA(2,iGrid)  +
     *                            RhoI(3,iGrid)*RhoA(3,iGrid)  +
     *                            RhoI(4,iGrid)*RhoA(4,iGrid)) -
     *                            RhoI(5,iGrid)*RhoA(1,iGrid)  -
     *                            RhoI(1,iGrid)*RhoA(5,iGrid)
*
      End Do
*
************************************************************************
*
*          Active-Active part:
*
************************************************************************
      If (NumAsh.ne.0) Then
      Do iIrrep = 0, mIrrep-1
         Do jIrrep = 0, mIrrep-1
         ijIrrep=iEor(iIrrep,jIrrep)
            Do kIrrep = 0, mIrrep-1
            ijkIrrep=iEor(ijIrrep,kIrrep)
*      Write(6,*) " do_p2cs:Irrep" ,iIrrep,jIrrep,kIrrep,ijkIrrep
               Do k_ = 1, nASh(kIrrep)
                  k = iOff_BasAct(kIrrep)+k_
                  Do l_ = 1, nASh(ijkIrrep)
                     l=iOff_BasAct(ijkIrrep)+l_
                     Do i_ = 1, nASh(iIrrep)
                        i=iOff_BasAct(iIrrep)+i_
                        Do j_ = 1, nASh(jIrrep)
                           j=iOff_BasAct(jIrrep)+j_
                           kl=iTri(k_ + iOff_Ash(  kIrrep) ,
     &                             l_ + iOff_Ash(ijkIrrep))
                           ij=iTri(i_ + iOff_Ash(iIrrep) ,
     &                             j_ + iOff_Ash(  jIrrep))
                           ijkl  = iTri(ij,kl)
                           Fact=0.5d0
                           if(iIrrep.eq.jIrrep) Then
                              If(k.eq.l) Fact=1.0d0
                           End If

                           Do iGrid = 1, mGrid
                              P2_ontop(1,iGrid) = P2_ontop(1,iGrid)  +
     *                                    Fact*P2mo(ijkl)*
     *                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     *                             TabMO(1,igrid,i)*TabMO(1,igrid,j)
                              P2_ontop(2,iGrid) = P2_ontop(2,iGrid)  +
     &                                     Fact*P2mo(ijkl)*(
     &                             TabMO(2,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(2,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(2,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(2,igrid,j)
     &                             )
                              P2_ontop(3,iGrid) = P2_ontop(3,iGrid) +
     &                                    Fact*P2mo(ijkl)*(
     &                             TabMO(3,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(3,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(3,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(3,igrid,j)
     &                             )
                              P2_ontop(4,iGrid) = P2_ontop(4,iGrid) +
     &                                    Fact*P2mo(ijkl)*(
     &                             TabMO(4,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(4,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(4,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(4,igrid,j)
     &                             )
                              Tmp1xx =          Fact*P2mo(ijkl)*(
     &                             TabMO(5,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(5,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(5,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(5,igrid,j)
     &                             )
                              Tmp1yy =          Fact*P2mo(ijkl)*(
     &                             TabMO(8,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(8,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(8,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(8,igrid,j)
     &                             )
                              Tmp1zz =          Fact*P2mo(ijkl)*(
     &                             TabMO(10,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(10,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(10,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(10,igrid,j)
     &                             )
c
                              Tmp2xx =          Fact*P2mo(ijkl)*(
     &                             TabMO(2,igrid,k)*TabMO(2,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(2,igrid,i)*TabMO(2,igrid,j)
     &                             )
                              Tmp2yy =          Fact*P2mo(ijkl)*(
     &                             TabMO(3,igrid,k)*TabMO(3,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(3,igrid,i)*TabMO(3,igrid,j)
     &                             )
                              Tmp2zz =          Fact*P2mo(ijkl)*(
     &                             TabMO(4,igrid,k)*TabMO(4,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(1,igrid,j) +
     &                             TabMO(1,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(4,igrid,i)*TabMO(4,igrid,j)
     &                             )
c
                              Tmp3xx =          Fact*P2mo(ijkl)*(
     &                             TabMO(2,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(2,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(2,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(2,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(2,igrid,l)*
     &                             TabMO(2,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(2,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(2,igrid,j)
     &                             )
                              Tmp3yy =          Fact*P2mo(ijkl)*(
     &                             TabMO(3,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(3,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(3,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(3,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(3,igrid,l)*
     &                             TabMO(3,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(3,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(3,igrid,j)
     &                             )
                              Tmp3zz =          Fact*P2mo(ijkl)*(
     &                             TabMO(4,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(4,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(4,igrid,k)*TabMO(1,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(4,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(4,igrid,l)*
     &                             TabMO(4,igrid,i)*TabMO(1,igrid,j) +
c
     &                             TabMO(1,igrid,k)*TabMO(4,igrid,l)*
     &                             TabMO(1,igrid,i)*TabMO(4,igrid,j)
     &                             )
                              P2_ontop(5,iGrid) = P2_ontop(5,iGrid) +
     &                                    Tmp1xx + Tmp1yy + Tmp1zz +
     &                             2.0d0*(Tmp2xx + Tmp2yy + Tmp2zz +
     &                                    Tmp3xx + Tmp3yy + Tmp3zz )
                              P2_ontop(6,iGrid) = P2_ontop(6,iGrid) +
     &                             Tmp3xx + Tmp3yy + Tmp3zz
*
                           End Do ! iGrid
                        End Do ! j_
                     End Do ! i_
                  End Do ! l_
               End Do ! k_
            End Do ! kIrrep
         End Do ! jIrrep
      End Do ! iIrrep
      End If
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine TRAFRO(MODE)

use caspt2_global, only: CMO, CMO_Internal, CMOPT2, NCMO
use caspt2_module, only: IfChol, NASH, NFRO, NISH, NORB, NOSH, NSSH, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: MODE
integer(kind=iwp) :: nFroTmp(8), nOrbTmp(8), nOshTmp(8)

if (Mode == 1) then
  nFroTmp(1:nSym) = nFro(1:nSym)
  nOshTmp(1:nSym) = nOsh(1:nSym)
  nOrbTmp(1:nSym) = nOrb(1:nSym)
  nOsh(1:nSym) = nFro(1:nSym)+nIsh(1:nSym)+nAsh(1:nSym)
  nOrb(1:nSym) = nOsh(1:nSym)+nSsh(1:nSym)
  nFro(1:nSym) = 0
end if

call mma_allocate(CMO_Internal,NCMO,Label='CMO_Internal')
CMO => CMO_Internal
CMO(:) = CMOPT2(:)
if (IfChol) then
  call TRACHO3(CMO,NCMO)
else
  call TRACTL(nCMO,CMO,0)
end if
call mma_deallocate(CMO_Internal)
nullify(CMO)

if (Mode == 1) then
  nFro(1:nSym) = nFroTmp(1:nSym)
  nOsh(1:nSym) = nOshTmp(1:nSym)
  nOrb(1:nSym) = nOrbTmp(1:nSym)
end if

return

end subroutine TRAFRO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007,2008, Roland Lindh                                *
************************************************************************
      Subroutine Mk_RICD_Shells()
************************************************************************
*                                                                      *
*    Objective: To generate aCD auxiliary basis sets on-the-fly.       *
*                                                                      *
* Called from: RdCtl_Seward                                            *
*                                                                      *
*     Author: Roland Lindh, Dept. of Chem. Phys., Lund Univ., Sweden.  *
*                                                                      *
*             Final implementation for aCD and acCD auxiliary          *
*             basis sets developed while visiting N. Ferre' at the     *
*             Univ. of Provance (champus Univ. Paul Cezanne) in        *
*             Marseille, France, 20 March - 19 April.                  *
*                                                                      *
*             Modified to transform the auxiliary basis to a true      *
*             Cholesky basis set while on TACC 2008 conference in      *
*             Songjiang District, Shanghai, China, 23-27 Sept. 2008.   *
*                                                                      *
************************************************************************
      use Real_Spherical
      use Basis_Info
      use Sizes_of_Seward, only: S
      use RICD_Info, only: Do_acCD_Basis, Skip_High_AC, Do_nacCD_Basis,
     &                     Thrshld_CD
      Implicit Real*8 (A-H,O-Z)
#include "SysDef.fh"
#include "real.fh"
#include "print.fh"
#include "status.fh"
#include "stdalloc.fh"
      Logical DoRys, Save_Logical, W2L
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
       iPrint=49
C      iPrint=99
#else
       iPrint=5
#endif
*                                                                      *
************************************************************************
*                                                                      *
*
      Call StatusLine('Gateway:',
     &                ' Generating aCD or acCD auxiliary basis set')
*                                                                      *
************************************************************************
*                                                                      *
*     Preamble: Compute kOffAO  and lOffAO
*
      Call Setup_OffAO()
*
*     Set up transformation matrix from Cartesian to real spherical
*     harmonics.
*
      Call Sphere(S%iAngMx)
*
*     Setup of tables for coefficients for the Rys roots and weights.
*
      nDiff=0
      If (S%iAngMx.eq.0) nDiff=2
      DoRys=.True.
      Call SetUp_RW(DoRys,nDiff)
*
      iShll=S%Mx_Shll - 1
      mCnttp=nCnttp
*                                                                      *
************************************************************************
*                                                                      *
*     Add the DUMMY SHELL!
*
      Call Mk_Dummy_Shell()
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Loop now over all unique valence basis sets and generate the
*     corresponding aCD auxiliary basis sets. Note that there are two
*     different types of aCD auxiliary basis sets, aCD and acCD.
*
      Do 1100 iCnttp = 1, mCnttp
         If (dbsc(iCnttp)%Frag.or.dbsc(iCnttp)%nVal.eq.0) goto 1100
#ifdef _DEBUGPRINT_
         If (iPrint.ge.99)
     &   Write (6,*) 'Generating auxiliary basis set for valence basis'
     &             //':',iCnttp
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        Procrastinate the printing of the RICD basis set to library
*        until the last unique valence basis set is processed.
*
         W2L=.True.
         Do jCnttp = iCnttp+1, mCnttp
            If (dbsc(iCnttp)%Bsl_old.eq.dbsc(jCnttp)%Bsl_old) Then
               W2L=.False.
               Exit
            End If
         End Do
*                                                                      *
************************************************************************
*                                                                      *
         If (Do_nacCD_Basis) Then
            Do_acCD_Basis=.False.
*                                                                      *
************************************************************************
*                                                                      *
*           nacCD section
*
*           Creat first a virgin aCD auxiliary basis set
*
            Thrshld_CD_Save = Thrshld_CD
            Thrshld_CD = Zero
            Save_Logical = Skip_High_AC
            Skip_High_AC = .False.
*
            kCnttp = nCnttp
            Call Mk_aCD_acCD_Shells(iCnttp,W2L)
            lCnttp = nCnttp
*
*           Now let us use the aCD auxiliary basis set to generate the
*           nacCD auxiliary basis set.
*
            Thrshld_CD = Thrshld_CD_Save
            Skip_High_AC = Save_Logical
            Call Mk_nacCD_Shells(kCnttp,lCnttp)
*
*           Remove the temporary aCD auxiliary basis set
*
            Do jCnttp = kCnttp+1, lCnttp
               Call rm_AuxShell(jCnttp)
            End Do
*                                                                      *
************************************************************************
*                                                                      *
         Else
*                                                                      *
************************************************************************
*                                                                      *
*        aCD and acCD section
*
*
            Call Mk_aCD_acCD_Shells(iCnttp,W2L)
*
         End If
*                                                                      *
************************************************************************
*                                                                      *
 1100 Continue ! iCnttp
*                                                                      *
************************************************************************
*                                                                      *
      Call Set_Basis_Mode('Valence')
*                                                                      *
************************************************************************
*                                                                      *
*     Cleanup the mess!
*
      Call CloseR()
      Call Sphere_Free()
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      Subroutine Remove_High_Exponents(iD,nD,List2,mData,nTheta_All)
      Use Basis_Info, only: Shells
      Implicit Real*8 (a-h,o-z)
************************************************************************
*                                                                      *
*     Experimental code to be used with care.                          *
*                                                                      *
************************************************************************
      Integer iD(nD), List2(mData,nTheta_All)
      Logical Skip
*
      Call iVcPrt('Remove_High_Exponents: iD',' ',iD,nD)
      mD = nD
      i = 1
 100  Continue
         iTheta_All=iD(i)
         Skip=.False.
         kAng  = List2(1,iTheta_All)
         lAng  = List2(2,iTheta_All)
         k     = List2(5,iTheta_All)
         l     = List2(6,iTheta_All)
         kShll = List2(7,iTheta_All)
         lShll = List2(8,iTheta_All)
         If (kAng.eq.lAng) Then
            l     = List2(6,iTheta_All)
            Skip = (k.eq.1.and.l.eq.1).and.Shells(kShll)%nExp.ne.1
         Else
            Skip=l.eq.1.and.Shells(lShll)%nExp.ne.1
         End If
         If (Skip) Then
            If (mD.eq.i) Then
               mD = mD -1
               Go To 200
            End If
            Do j = i+1, mD
               iD(j-1) = iD(j)
            End Do
            mD = mD -1
            Go To 100
         End If
         i = i + 1
         If (i.le.mD) Go To 100
 200  Continue
      nD = mD
      Call iVcPrt('Remove_High_Exponents: iD',' ',iD,nD)
*
      Return
      End
      Subroutine Mk_AngList(iAL,nCompA,nCompB,
     &                      iD_c,nD_c,
     &                      List2,nList2,mData,
     &                      iAng,jAng)
      Integer iAL(nCompA,nCompB), iD_c(nD_c),
     &        List2(mData,nList2)
*
      Call IZero(iAL,nCompA*nCompB)
      Do jD_c = 1, nD_c
         ijSO=iD_c(jD_c)
         If (List2(1,ijSO).eq.iAng .and.
     &       List2(2,ijSO).eq.jAng ) Then
            iA = List2(3,ijSO)
            iB = List2(4,ijSO)
            iAL(iA,iB) = 1
         End If
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine xbacktrace
!SVC: this routine tries to print a backtrace

implicit none

! use backtrace intrinsic (introduced since gfortran 4.8)
#include "compiler_features.h"
#if defined(__GNUC__) && (GCC_VERSION >= 40800)
call backtrace()
! use tracebackqq intrinsic for ifort
#elif defined(__INTEL_COMPILER)
call tracebackqq()
#endif

end subroutine xbacktrace

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine IsItValid(Coo,CooRef,ValidOrNot)

use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Coo(3,5), CooRef(3,5)
logical(kind=iwp), intent(out) :: ValidOrNot
integer(kind=iwp) :: i, j
real(kind=wp) :: dL_ref, dL_test
real(kind=wp), parameter :: dTroskel = 1.0e-4_wp

ValidOrNot = .true.
! Lengths.
outer: do i=1,4
  do j=i+1,5
    dL_test = (Coo(1,i)-Coo(1,j))**2+(Coo(2,i)-Coo(2,j))**2+(Coo(3,i)-Coo(3,j))**2
    dL_ref = (CooRef(1,i)-CooRef(1,j))**2+(CooRef(2,i)-CooRef(2,j))**2+(CooRef(3,i)-CooRef(3,j))**2
    if (abs(dL_test-dL_ref) > dTroskel) then
      ValidOrNot = .false.
      exit outer
    end if
  end do
end do outer

return

end subroutine IsItValid

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MxLbls(nInter,Grad,Shift,Lbl)

use Slapaf_Info, only: GrdLbl, StpLbl, GrdMax, StpMax
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nInter
real(kind=wp), intent(in) :: Grad(nInter), Shift(nInter)
character(len=8), intent(in) :: Lbl(nInter)
integer(kind=iwp) :: i

#ifdef _DEBUGPRINT_
call RecPrt('MxLbls:Shift',' ',Shift,nInter,1)
call RecPrt('MxLbls:Grad',' ',Grad,nInter,1)
#endif

GrdMax = Zero
StpMax = Zero
do i=1,nInter
  if (abs(Grad(i)) > abs(GrdMax)) then
    GrdMax = Grad(i)
    GrdLbl = Lbl(i)
  end if
  if (abs(Shift(i)) > abs(StpMax)) then
    StpMax = Shift(i)
    StpLbl = Lbl(i)
  end if
end do
#ifdef _DEBUGPRINT_
write(u6,*) ' Tmp output in MxLbls'
write(u6,*) GrdLbl,' ',GrdMax
write(u6,*) StpLbl,' ',StpMax
#endif

return

end subroutine MxLbls

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine setifnss_cvb(ifnss1,ifnss2,ndetvbs)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


      dimension ifnss1(0:nel,0:nel),ifnss2(0:nel,0:nel)
      dimension ndetvbs(0:nel,0:nel)

      call izero(ifnss1,(nel+1)*(nel+1))
      call izero(ifnss2,(nel+1)*(nel+1))
      call izero(ndetvbs,(nel+1)*(nel+1))

      do 100 n=0,nel
      do 101 nalfa=(n+1)/2,n
      nbeta=n-nalfa
      if(nbeta.gt.nalfa)goto 101
      call icomb_cvb(n,nbeta,iretval1)
      call icomb_cvb(n,nbeta-1,iretval2)
      ifnss1(n,nalfa-nbeta)=iretval1-iretval2
      call icomb_cvb(n,nalfa,ifnss2(n,nalfa-nbeta))
      if(nalfa.eq.nbeta)ifnss2(n,nalfa-nbeta)=
     >  (ifnss2(n,nalfa-nbeta)+1)/2
      call icomb_cvb(n,nalfa,ndetvbs(n,nalfa))
101   continue
100   continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine Orthox(S,C,nOrb,nBas)
************************************************************************
*                                                                      *
*     purpose: Perform Gram-Schmidt orthogonalization scheme           *
*                                                                      *
*     input:                                                           *
*       S       : overlap in non-orthonormal basis (square storage)    *
*       C       : matrix transforming non-orthonormal basis            *
*      nBas,nOrb: dimensions                                           *
*                                                                      *
*     output:                                                          *
*       C       : matrix transforming orthonormal basis                *
*                                                                      *
*     called from: Ortho                                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
#include "real.fh"
*
      Real*8 C(nBas,nOrb),S(nOrb,nOrb)


      Do 100 iOrb = 1, nOrb
         F = Zero
         If (S(iOrb,iOrb).gt.Zero) F=One/SqRt(S(iOrb,iOrb))
         Do 110 iBas = 1, nBas
            C(iBas,iOrb) = F*C(iBas,iOrb)
  110    Continue
         Do 120 jOrb = 1, nOrb
            S(iOrb,jOrb) = F*S(iOrb,jOrb)
            S(jOrb,iOrb) = F*S(jOrb,iOrb)
  120    Continue
         S(iOrb,iOrb) = One
         Do 130 jOrb = iOrb + 1, nOrb
            A = S(iOrb,jOrb)
            Do 131 iBas = 1, nBas
               C(iBas,jOrb) = C(iBas,jOrb) - A*C(iBas,iOrb)
  131       Continue
            Do 132 kOrb = 1, nOrb
               S(jOrb,kOrb) = S(jOrb,kOrb) - A*S(iOrb,kOrb)
  132       Continue
            Do 133 kOrb = 1, nOrb
               S(kOrb,jOrb) = S(kOrb,jOrb) - A*S(kOrb,iOrb)
  133       Continue
  130    Continue
  100 Continue

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine genpowers(Lhigh,powexp,coulovlp)
      implicit real*8 (a-h,o-z)
#include "para.fh"
#include "param.fh"
#include "dofuc.fh"
      dimension powexp(MxprimL,MxprimL,0:Lmax,0:Lmax,0:(Lmax+Lmax+5))
     *,coulovlp(MxprimL,MxprimL,-1:1,-1:1,0:Lmax,0:Lmax)
cbs   set some often used powers of exponents
      do L2=0,Lhigh
      do L1=0,L2
      do irun1=1,nprimit(L1)
      do irun2=1,nprimit(L2)
      powexp(irun1,irun2,L1,L2,0)=1d0
      enddo
      enddo
      enddo
      enddo
      do L2=0,Lhigh
      do L1=0,L2
      do Lrun=1,(L1+L2+5)
      do irun2=1,nprimit(L2)
      do irun1=1,nprimit(L1)
      fact=sqrt(0.5d0*(exponents(irun1,L1)+exponents(irun2,L2)))
cbs   write(6,*) 'fact',fact,'powexp',powexp(irun1,irun2,L1,L2,Lrun-1)
      powexp(irun1,irun2,L1,L2,Lrun)= powexp(irun1,irun2,L1,L2,Lrun-1)*
     *fact
      enddo
      enddo
      enddo
      enddo
      enddo
cbs   generate coulovlp = overlap for normalized functions, but sometimes
cbs   with shifted l-values
      do l2=0,lhigh
      do incl2=-1,1
         if (l2+incl2.ge.0) then  ! do not lower l for s-functions
         n2=l2+incl2+1
         df2=1d0/sqrt(df(n2+n2-1))
         do l1=0,l2
         do incl1=-1,1
         if (l1+incl1.ge.0) then ! do not lower l for s-functions
         n1=l1+incl1+1
         df1=1d0/sqrt(df(n1+n1-1))
         df12=df(n1+n2-1)
         do iprim2=1,nprimit(l2)
         fact2=sqrt(powexp(iprim2,iprim2,l2,l2,n2+n2+1))
         factor=fact2*df1*df2*df12
         do iprim1=1,nprimit(l1)
         fact1=sqrt(powexp(iprim1,iprim1,l1,l1,n1+n1+1))
         coulovlp(iprim1,iprim2,incl1,incl2,l1,l2)=
     *   fact1*factor/powexp(iprim1,iprim2,l1,l2,n1+n2+1)
CBS      write(6,*) 'fact1',fact1,'factor ',factor,
CBS  *   'powexp ', powexp(iprim1,iprim2,l1,l2,n1+n2+1)
         enddo
         enddo
         endif
         enddo
         enddo
         endif
      enddo
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_Goo(Goo)
! check Goo (i,u)

use chcc_global, only: Gooc, Hooc, no, nv, Q1, T1c
use stdalloc, only: mma_allocate
use Constants, only: Two
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Goo(no,no)
integer(kind=iwp) :: a, bad, i, j, u
real(kind=wp) :: s

call mma_allocate(Gooc,no,no,label='Gooc')

bad = 0

do i=1,no
  do u=1,no

    !s = Zero
    !do j=1,no
    !  do a=1,nv
    !    do b=1,nv
    !      s = s+(Two*Q21(a,i,b,j)-Q21(a,j,b,i))*T2c(a,b,u,j)
    !    end do
    !  end do
    !end do

    s = Hooc(i,u)

    do j=1,no
      do a=1,nv
        s = s+(Two*Q1(a,j,i,u)-Q1(a,i,j,u))*T1c(a,j)
      end do
    end do

    Gooc(i,u) = s

    if (abs(Goo(i,u)-s) > 1.0e-10_wp) bad = bad+1

  end do
end do

write(u6,*) ' Goo Chck :',bad

return

end subroutine Chck_Goo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dRdC(NSI,ICOORD,NESFJ,DR,RSolv,Sphere,NewSph)

use Constants, only: Two, Four, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NSI, ICOORD, NESFJ, NewSph(2)
real(kind=wp), intent(out) :: DR
real(kind=wp), intent(in) :: RSolv, Sphere(4,*)
integer(kind=iwp) :: K, NSK
real(kind=wp) :: A, B, COORDJ(3), COORDK(3), D, D2, DIFF, FAC, RI, RJ, RK, RS

! Trova la derivata del raggio della sfera NSI rispetto alla
! coordinata ICOORD (1=X, 2=Y, 3=Z) della sfera NSJ, che interseca
! NSI.
!
! La sfera NSI (che appartiene alle sfere "aggiunte" da PEDRA)
! dipende dalle due sfere "precedenti" NESFJ e K
!
! Se NESFJ o NSK sono negativi, la sfera aggiunta e' di tipo C
! e la generatrice "principale" corrisponde al label negativo
! (cfr. JCC 11, 1047 (1990))

if ((NEWSPH(1) < 0) .or. (NEWSPH(2) < 0)) then
  NSK = NEWSPH(1)
  if (abs(NSK) == NESFJ) NSK = NEWSPH(2)
  COORDJ(:) = Sphere(1:3,NESFJ)
  COORDK(:) = Sphere(1:3,abs(NSK))
  RI = Sphere(4,NSI)+RSOLV
  RJ = Sphere(4,NESFJ)+RSOLV
  RK = Sphere(4,abs(NSK))+RSOLV
  DIFF = COORDJ(ICOORD)-COORDK(ICOORD)
  D2 = (COORDJ(1)-COORDK(1))**2+(COORDJ(2)-COORDK(2))**2+(COORDJ(3)-COORDK(3))**2
  D = sqrt(D2)
  FAC = Sphere(4,NESFJ)*(RJ*RJ-D*D-RK*RK)
  if (NSK < 0) FAC = Sphere(4,abs(NSK))*(RK*RK-D*D-RJ*RJ)
  DR = DIFF*FAC/(Two*D**3*RI)
else
  K = NEWSPH(1)
  if (K == NESFJ) K = NEWSPH(2)
  COORDJ(:) = Sphere(1:3,NESFJ)
  COORDK(:) = Sphere(1:3,K)
  D2 = (COORDJ(1)-COORDK(1))**2+(COORDJ(2)-COORDK(2))**2+(COORDJ(3)-COORDK(3))**2
  D = sqrt(D2)
  B = Half*(D+Sphere(4,NESFJ)-Sphere(4,K))
  RS = RSOLV
  A = ((Sphere(4,NESFJ)+RS)**2+D2-(Sphere(4,K)+RS)**2)/D
  DR = (Two*A*B-Two*B*D-A*D)*(COORDJ(ICOORD)-COORDK(ICOORD))/(Four*D2*(Sphere(4,NSI)+RS))
end if

return

end subroutine dRdC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GASDIAT(    DIAG,   LUDIA,   ECORE,  ICISTR,     I12,
     &                      IBLTP,  NBLOCK,  IBLKFO)
*
* CI diagonal in SD basis for state with symmetry ISM in internal
* space ISPC
*
* GAS version, Winter of 95
*
* Driven by table of TTS blocks, May97
*
      IMPLICIT REAL*8(A-H,O-Z)
* =====
*.Input
* =====
*
*./ORBINP/ : NACOB used
*
#include "mxpdim.fh"
#include "orbinp.fh"
#include "cicisp.fh"
#include "strbas.fh"
#include "cstate.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "csm.fh"
#include "WrkSpc.fh"
#include "cprnt.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "io_util.fh"
*
      DIMENSION IBLTP(*)
      DIMENSION IBLKFO(8,NBLOCK)
*
* ======
*.Output
* ======
      DIMENSION DIAG(*)
*
*
      NTEST = 0
      NTEST = MAX(NTEST,IPRDIA)
*
** Specifications of internal space
*
      IATP = 1
      IBTP = 2
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*
*. Offsets for alpha and beta supergroups
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
      IF(NTEST.GE.10) THEN
        WRITE(6,*) ' ================'
        WRITE(6,*) ' GASDIA speaking '
        WRITE(6,*) ' ================'
        WRITE(6,*) ' IATP IBTP NAEL NBEL ',IATP,IBTP,NAEL,NBEL
        write(6,*) ' NOCTPA NOCTPB  : ', NOCTPA,NOCTPB
        write(6,*) ' IOCTPA IOCTPB  : ', IOCTPA,IOCTPB
      END IF
*
**. Local memory
*
      IDUM = 0
      CALL GETMEM('KLJ   ','ALLO','REAL',KLJ   ,NTOOB**2)
      CALL GETMEM('KLK   ','ALLO','REAL',KLK   ,NTOOB**2)
      CALL GETMEM('KLSC2 ','ALLO','REAL',KLSCR2,2*NTOOB**2)
      CALL GETMEM('KLXB  ','ALLO','REAL',KLXB  ,NACOB)
      CALL GETMEM('KLH1D ','ALLO','REAL',KLH1D ,NACOB)
*. Space for blocks of strings
      CALL GETMEM('KLASTR','ALLO','INTE',KLASTR,MXNSTR*NAEL)
      CALL GETMEM('KLBSTR','ALLO','INTE',KLBSTR,MXNSTR*NBEL)
      MAXA = IMNMX(IWORK(KNSTSO(IATP)),NSMST*NOCTPA,2)
      CALL GETMEM('KLRJKA','ALLO','REAL',KLRJKA,MAXA)
*
**. Diagonal of one-body integrals and coulomb and exchange integrals
*
      CALL GT1DIA(WORK(KLH1D))
      CALL GTJK(WORK(KLJ),WORK(KLK),NTOOB,WORK(KLSCR2),IREOTS,IREOST)
      IF( LUDIA .GT. 0 ) IDISK(LUDIA)=0
      CALL GASDIAS(NAEL,IWORK(KLASTR),NBEL,IWORK(KLBSTR),
     &             NACOB,DIAG,NSMST,
     &             WORK(KLH1D),WORK(KLXB),WORK(KLJ),WORK(KLK),
     &             IWORK(KNSTSO(IATP)),IWORK(KNSTSO(IBTP)),
     &             LUDIA,ECORE,PSSIGN,IPRDIA,NTOOB,ICISTR,
     &             WORK(KLRJKA),I12,IBLTP,NBLOCK,IBLKFO,
     &             I_AM_OUT,N_ELIMINATED_BATCHES)
*.Flush local memory
      CALL GETMEM('KLJ   ','FREE','REAL',KLJ   ,NTOOB**2)
      CALL GETMEM('KLK   ','FREE','REAL',KLK   ,NTOOB**2)
      CALL GETMEM('KLSC2 ','FREE','REAL',KLSCR2,2*NTOOB**2)
      CALL GETMEM('KLXB  ','FREE','REAL',KLXB  ,NACOB)
      CALL GETMEM('KLH1D ','FREE','REAL',KLH1D ,NACOB)
      CALL GETMEM('KLASTR','FREE','INTE',KLASTR,MXNSTR*NAEL)
      CALL GETMEM('KLBSTR','FREE','INTE',KLBSTR,MXNSTR*NBEL)
      CALL GETMEM('KLRJKA','FREE','REAL',KLRJKA,MAXA)
*
*
C?    STOP ' Jeppe forced me to stop after GASDIA '
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Print_MPPROP(rMP,xrMP,xnrMP,nij,nElem,lMax,EC,Polar,Lbl,nAtoms,iANr,NoField,CoC,Coor,nOcOb,Energy_Without_FFPT,Ene_Occ, &
                        MpProp_Level,Bond_Threshold,nReal_Centers)

!  rMP : Multipole moments moved to center of charge
! xrMP : Multipole moments kept on the expansion center

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, r8

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nij, nElem, lMax, nAtoms, iANr(nAtoms), nOcOb, MpProp_Level, nReal_Centers
real(kind=wp), intent(in) :: rMP(nij,nElem), xrMP(nij,nElem), EC(3,nij), Polar(6,nij), CoC(3), Coor(3,nAtoms), &
                             Energy_Without_FFPT, Ene_Occ(nOcOb), Bond_Threshold
real(kind=wp), intent(inout) :: xnrMP(nij,nElem)
character(len=LenIn), intent(in) :: Lbl(nAtoms)
logical(kind=iwp), intent(in) :: NoField
integer(kind=iwp) :: i, iAtom, iElem, iEnd, ii, ij, iSize, iStrt, iUnit, j, jAtom, l, Last_NonBlank, lMax_for_size, MxMP, nBas(8), &
                     nCenters, nSym
real(kind=wp) :: Polar_M(6)
integer(kind=iwp), parameter :: lHeader = 144
character(len=lHeader) :: Header
character(len=8) :: Method, Label
character(len=6) :: fName
logical(kind=iwp) :: Exists, Text, Bond_OK, Check_Bond, Found
logical(kind=iwp), parameter :: Use_Two_Centers_For_Atoms = .false.
real(kind=wp), allocatable :: Scratch_ele(:), Scratch_nuc(:)
real(kind=r8), external :: DDot_

MxMP = lMax
if (lMax > MpProp_Level) MxMP = MpProp_Level

call Qpg_carray('Relax Method',Found,iSize)
if (Found) then
  call Get_cArray('Relax Method',Method,8)
else
  Method = 'UNDEF   '
end if
call Get_cArray('Seward Title',Header,lHeader)
j = 0
Text = .false.
Last_NonBlank = 0
do i=1,72
  if (Text .or. (Header(i:i) /= ' ')) then
    Text = .true.
    j = j+1
    Header(j:j) = Header(i:i)
    if (Header(i:i) /= ' ') Last_NonBlank = j
  end if
end do

fName = 'MPPROP'
iUnit = 11
call OpnFl(fName,iUnit,Exists)

nCenters = nReal_Centers
if (Use_Two_Centers_For_Atoms) then
  nCenters = nCenters+nAtoms
end if

write(iUnit,'(A)') '**************************************************'
write(iUnit,'(A)') '* Molecule'
write(iUnit,'(A)') Header(1:Last_NonBlank)
write(iUnit,'(A)') '* Method'
write(iUnit,'(A)') Method
write(iUnit,'(A)') '* Level of Multipoles and Polarizabilities'
write(iUnit,'(2I5)') MxMP,1
write(iUnit,'(A)') '* All centers'
write(iUnit,'(I5)') nCenters

! Insert atoms
do iAtom=1,nAtoms
  ii = iAtom*(iAtom+1)/2
  call ReExpand(xnrMP,nij,nElem,CoC,EC(1,ii),ii,lMax)

  ! Informations on the atom
  write(iUnit,'(2I5,4X,A)') 2,1,Lbl(iAtom)
  ! The expansion center
  write(iUnit,'(3F20.10)') (EC(iElem,ii),iElem=1,3)
  ! The multipole moments
  iStrt = 1
  do l=0,MxMP
    iEnd = iStrt+(l+1)*(l+2)/2-1
    write(iUnit,'(3F20.10)') (xrMP(ii,iElem)+xnrMP(ii,iElem),iElem=iStrt,iEnd)
    iStrt = iEnd+1
  end do
  ! The size parameters (never higher than quadrupole)
  lMax_for_size = min(MxMP,2)
  iStrt = 1
  do l=0,lMax_for_size
    iEnd = iStrt+(l+1)*(l+2)/2-1
    write(iUnit,'(3F20.10)') (Zero,iElem=iStrt,iEnd)
    iStrt = iEnd+1
  end do
  ! Polarizabilities
  if (NoField) then
    write(iUnit,'(3F20.10)') (Zero,iElem=1,6)
  else
    Polar_M(1) = Polar(1,ii)
    Polar_M(2) = Polar(2,ii)
    Polar_M(3) = Polar(4,ii)
    Polar_M(4) = Polar(3,ii)
    Polar_M(5) = Polar(5,ii)
    Polar_M(6) = Polar(6,ii)
    write(iUnit,'(3F20.10)') (Polar_M(iElem),iElem=1,6)
  end if

  call ReExpand(xnrMP,nij,nElem,EC(1,ii),CoC,ii,lMax)
end do
if (Use_Two_Centers_For_Atoms) then
  ! Insert real atoms and fake values
  do iAtom=1,nAtoms

    ! Informations on the center
    write(iUnit,'(2I5,4X,A)') iANr(iAtom),1,Lbl(iAtom)
    ! The expansion center
    write(iUnit,'(3F20.10)') (Coor(iElem,iAtom),iElem=1,3)
    ! The multipole moments
    iStrt = 1
    do l=0,MxMP
      iEnd = iStrt+(l+1)*(l+2)/2-1
      write(iUnit,'(3F20.10)') (Zero,iElem=iStrt,iEnd)
      iStrt = iEnd+1
    end do
    ! The size parameters (never higher than quadrupole)
    lMax_for_size = min(MxMP,2)
    iStrt = 1
    do l=0,lMax_for_size
      iEnd = iStrt+(l+1)*(l+2)/2-1
      write(iUnit,'(3F20.10)') (One,iElem=iStrt,iEnd)
      iStrt = iEnd+1
    end do
    ! Polarizabilities
    write(iUnit,'(3F20.10)') (Zero,iElem=1,6)

  end do
end if
! Insert bonds
do jAtom=1,nAtoms
  do iAtom=jAtom+1,nAtoms
    ij = iAtom*(iAtom-1)/2+jAtom

    Bond_OK = Check_Bond(Coor(1,iAtom),Coor(1,jAtom),iANr(iAtom),iANr(jAtom),Bond_Threshold)
    if (Bond_OK) then
      Label = '       '
      write(Label,'(I3,A,I3)') jAtom,'-',iAtom
      j = 0
      do i=1,8
        if (Label(i:i) /= ' ') then
          j = j+1
          Label(j:j) = Label(i:i)
        end if
      end do
      ! Informations on the center
      write(iUnit,'(2I5,4X,A)') 2,1,Label(1:j)
      ! The expansion center
      write(iUnit,'(3F20.10)') (EC(iElem,ij),iElem=1,3)
      ! The multipole moments
      iStrt = 1
      do l=0,MxMP
        iEnd = iStrt+(l+1)*(l+2)/2-1
        write(iUnit,'(3F20.10)') (xrMP(ij,iElem),iElem=iStrt,iEnd)
        iStrt = iEnd+1
      end do
      ! The size parameters (never higher than quadrupole)
      lMax_for_size = min(MxMP,2)
      iStrt = 1
      do l=0,lMax_for_size
        iEnd = iStrt+(l+1)*(l+2)/2-1
        write(iUnit,'(3F20.10)') (One,iElem=iStrt,iEnd)
        iStrt = iEnd+1
      end do
      ! Polarizabilities
      if (NoField) then
        write(iUnit,'(3F20.10)') (Zero,iElem=1,6)
      else
        Polar_M(1) = Polar(1,ij)
        Polar_M(2) = Polar(2,ij)
        Polar_M(3) = Polar(4,ij)
        Polar_M(4) = Polar(3,ij)
        Polar_M(5) = Polar(5,ij)
        Polar_M(6) = Polar(6,ij)
        write(iUnit,'(3F20.10)') (Polar_M(iElem),iElem=1,6)
      end if
    end if

  end do
end do

!*** Molecular properties

write(iUnit,'(A)') '* Molecule properties'
call mma_allocate(Scratch_ele,nElem,label='Scratch_ele')
call mma_allocate(Scratch_nuc,nElem,label='Scratch_nuc')
do iElem=1,nElem
  Scratch_ele(iElem) = sum(rMP(:,iElem))
  Scratch_nuc(iElem) = sum(xnrMP(:,iElem))
end do
iStrt = 1
do l=0,MxMP
  iEnd = iStrt+(l+1)*(l+2)/2-1
  write(iUnit,'(3F20.10)') (Scratch_ele(iElem)+Scratch_nuc(iElem),iElem=iStrt,iEnd)
  iStrt = iEnd+1
end do
call mma_deallocate(Scratch_ele)
call mma_deallocate(Scratch_nuc)

if (NoField) then
  write(iUnit,'(3F20.10)') (Zero,iElem=1,6)
else
  Polar_M(1) = DDot_(nij,[One],0,Polar(1,1),6)
  Polar_M(2) = DDot_(nij,[One],0,Polar(2,1),6)
  Polar_M(3) = DDot_(nij,[One],0,Polar(4,1),6)
  Polar_M(4) = DDot_(nij,[One],0,Polar(3,1),6)
  Polar_M(5) = DDot_(nij,[One],0,Polar(5,1),6)
  Polar_M(6) = DDot_(nij,[One],0,Polar(6,1),6)
  write(iUnit,'(3F20.10)') (Polar_M(iElem),iElem=1,6)
end if

!*** Orbital information

call Get_iScalar('nSym',nSym)
call Get_iArray('nBas',nBas,nSym)

write(iUnit,'(A)') '* Orbital information'
write(iUnit,'(2I5)') nBas(1),nOcOb
write(iUnit,'(F20.10)') Energy_Without_FFPT
write(iUnit,'(3F20.10)') (Ene_Occ(i),i=1,nOcOb)

close(iUnit)
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Print_MPPROP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ddres2upd10_cvb( &
#                          define _CALLING_
#                          include "ddres2upd_interface.fh"
                          )

use casvb_global, only: n_div
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
#include "ddres2upd_interface.fh"
real(kind=wp) :: resnrm1, resnrm2
real(kind=wp), external :: dnrm2_

if (n_div == 0) then
  c(:) = res(:)
else
  resnrm1 = dnrm2_(n_div,res,1)
  resnrm2 = dnrm2_(n-n_div,res(n_div+1:),1)
  if (resnrm1 > resnrm2) then
    c(1:n_div) = res(1:n_div)
    c(n_div+1:) = Zero
  else
    c(1:n_div) = Zero
    c(n_div+1:) = res(n_div+1:)
  end if
end if
call ddproj_cvb(c,n)

return

end subroutine ddres2upd10_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRIMO(Header,PrOcc,PrEne,ThrOcc,ThrEne,
     *                 nSym,nBas,nOrb,Name,Ene,Occ,CMO,iPrForm)
*
************************************************************************
*                                                                      *
*     Purpose: print a set of orbitals                                 *
*                                                                      *
*     Calling parameters:                                              *
*     Header : Header line which is printed together with the          *
*              section title                                           *
*     nSym   : number of irreducible representations                   *
*     nOrb   : Total number of orbitals per irred. rep.                *
*     nBas   : Number of basis functions per irred. rep.               *
*     Name   : Center and function type label per basis function       *
*     Ene    : Orbital Energies                                        *
*     CMO    : Orbital coefficients                                    *
*     Occ    : Orbital Occupations                                     *
*     PrEne  : Switch to turn printing of orbital Energies ON/OFF      *
*     PrOcc  : Switch to turn printing of orbital Occupatios ON/OFF    *
*     ThrOcc : Threshold for Occupation number to be printed           *
*              Orbitals with Occupation number less than ThrOcc are    *
*              not printed                                             *
*     ThrEne : Threshold for orbitals Energies to be printed           *
*              Orbitals with Energies larger than ThrEne are           *
*              not printed                                             *
*     iPrForm: print level: -1 - Old way, 0- None, 1-list, 2-Short,    *
*              3-long                                                  *
*                                                                      *
************************************************************************
*
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real.fh"
*
#include "Molcas.fh"
      DIMENSION nBas(*),nOrb(*),Ene(*),CMO(*),Occ(*)
      CHARACTER*(LENIN8) Name(*)
      CHARACTER*(*) Header
      CHARACTER*24 FMT0,FMT1,FMT2,LABEL0,LABEL1,LABEL2
      Character*3 IrrepName(8)
      Character*20 Fmt_s, Fmt_l, Fmt_f, Fmt
      Character*180 Line
      Parameter (Magic=5+1+LENIN8+1+6+3)
      Character*(Magic) ChCMO
      Character*4 Star(10)
      Real*8 Shift(10)
      LOGICAL PrEne,PrOcc, Large, Go, Debug, Header_Done
      Logical Reduce_Prt
      External Reduce_Prt
      Character*(LENIN8) Clean_BName !14
      External Clean_BName
      Debug=.false.
#ifdef _DEBUGPRINT_
      Debug=.true.
#endif
*
*----------------------------------------------------------------------*
*                                                                      *
      Do i=1,10
         Star(i)=' '
      End Do
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0
      If (iPL.le.1) Return
*
      If (iPrForm.eq.0) Return
*
*----------------------------------------------------------------------*
*     Print Header                                                     *
*----------------------------------------------------------------------*
*
*
      Write(6,*)
      Call CollapseOutput(1,'   Molecular orbitals:')
      Write(6,'(6X,A)') '-------------------'
      Write(6,*)
      Write(6,'(6X,2A)') 'Title: ',Header(:mylen(Header))
c     Write(6,*)
c     Write(6,*) 'test print out'
*----------------------------------------------------------------------*
*     Legend (general)                                                 *
*----------------------------------------------------------------------*
      If(iPrForm.ge.4) Then
         Write (6,'(6X,A)') 'LEGEND'
         Write (6,'(6X,A)') '============================'
     &                    //'============================='
     &                    //'============================'
     &                    //'============================'
         Write (6,'(6X,A)') 'A basis set label has the st'
     &                    //'ructure "nl+m" or "nl-m" wher'
     &                    //'e n is the principle quantum'
     &                    //'number for atomic basis'
         Write (6,'(6X,A)') 'functions (a star, "*", deno'
     &                    //'tes a primitive, diffuse or a'
     &                    //' polarization function), l d'
     &                    //'enotes the angular quantum, '
         Write (6,'(6X,A)') 'and m the magnetic quantum n'
     &                    //'umber. The basis functions ar'
     &                    //'e normally real Spherical ha'
     &                    //'rmonics. For Cartesian type '
         Write (6,'(6X,A)') 'basis functions we use the n'
     &                    //'otation "ijk" to denote the '
     &                    //'power of the x, y, and z com'
     &                    //'ponent in the radial part.'
         Write (6,'(6X,A)') 'For p-functions we always use'
     &                    //' the notation px, py, and pz.'
      End If
*----------------------------------------------------------------------*
*     Define standard output format                                    *
*----------------------------------------------------------------------*
      NCOLS=10
      LABEL0='Orbital '
      LABEL1='Energy  '
      LABEL2='Occ. No.'
      FMT0='(10X,A12,3X,10(I5,A,1X))'
      FMT1='(10X,A12,2X,10F10.4)'
      FMT2='(5X,I4,1X,A,10F10.4)'
*
*----------------------------------------------------------------------*
*     Set up list of pointers                                          *
*----------------------------------------------------------------------*
*
      ISX=1
      ISB=1
      ISCMO=1
*
*----------------------------------------------------------------------*
*     Start loop over all irreducible representations                  *
*----------------------------------------------------------------------*
*
      nTot=0
      Do iSym = 1, nSym
         nTot=nTot+nBas(iSym)
      End Do
      Large=.false.
      if (iPrForm.eq.-1) Large=nTot.gt.256
      if (iPrForm.eq.1)  Large=.false.
      if (iPrForm.eq.2)  Large=.true.
      if (iPrForm.eq.3)  Large=.false.
      if (iPrForm.eq.4)  Large=.false.
      Call Get_cArray('Irreps',IrrepName,24)
*
      Do 100 iSym=1,nSym
        nB=nBas(iSym)
        nO=nOrb(iSym)
        If( nO.EQ.0 ) Go To 100
*
        Header_Done=.False.
*
*----------------------------------------------------------------------*
*     Start loop over columns                                          *
*----------------------------------------------------------------------*
*
        If (Large) Then
           FMT_s='(I5,1X,A,A,F6.3,A)'
           FMT_l='(I5,1X,A,A,F6.2,A)'
           FMT_f='(I5,1X,A,A,F6.1,A)'
           ThrCff=0.10d00
*
           Do iSO = 0, nO-1
            If (PrEne.and.PrOcc) Then
               Go = Ene(ISX+IsO).LE.ThrEne .AND. Occ(ISX+IsO).GE.ThrOcc
            Else If (PrEne) Then
               Go = Ene(ISX+IsO).LE.ThrEne
            Else If (PrOcc) Then
               Go = Occ(ISX+IsO).GE.ThrOcc
            Else
               Go = .False.
            End If
            If (Debug) Write (6,*) 'Go=',Go
            If (Go) Then
               If (.Not.Header_Done) Then
                  Write(6,'(/6X,A,I2,A,A)')
     &                 'Molecular orbitals for symmetry species',iSym,
     &                 ': ',IrrepName(iSym)
                  Write (6,*)
*
*----------------------------------------------------------------------*
*                 Start by listing the basis of this irrep             *
*----------------------------------------------------------------------*
*
                  Write (6,*)
                  Write (6,'(6X,A)') 'Basis set list:'
                  nCol=Min((nB+9)/10,5)
                  Inc=(nB+nCol-1)/nCol
                  jSB=iSB-1
                  Do iB = 1, Inc
ct.t.;
c                    Write (6,'(6X,5(I3,1X,A,15X))')
                     Write (6,'(4X,5(I5,1X,A,9X))')
ct.t.; end
     &               (jB,Clean_BName(Name(jSB+jB),LENIN),jB=iB, nB, Inc)
                  End Do
                  Write (6,*)
*
                  Write (6,*)
                  Write (6,*)
     &                 ' Index Energy  Occupation Coefficients ...'
                  Write (6,*)
                  Header_Done=.True.
               End If
*............. This will occupy the first 25 positions
               If (PrEne) Then
                  Energy=Ene(ISX+iSO)
               Else
                  Energy=Zero
               End If
               If (PrOcc) Then
                  Occupation=Occ(ISX+iSO)
               Else
                  Occupation=Zero
               End If
               Write(Line,'(I5,2F10.4)') iSO+1,Energy,Occupation
               If (Debug) Write (6,'(A,A)') 'Line=',Line
               iPos=1
               Cff_Mx=0.0D0
               Do iB = 0, NB-1
                  If (Abs(CMO(isCMO+iSO*nB+iB)).gt.Cff_Mx)
     &               Cff_Mx=Abs(CMO(isCMO+iSO*nB+iB))
               End Do
               If (Debug) Write (6,*) 'Cff_Mx=',Cff_Mx
               Do iB = 0, NB-1
                  If (Debug) Write (6,*) ' iB=',iB
                  If (Abs(CMO(isCMO+iSO*nB+iB)).ge.Cff_Mx*0.5D0) Then
                     If (Debug) Write (6,*) ' Process iB=',iB
                     If (Abs(CMO(isCMO+iSO*nB+iB)).ge.100.0D0) Then
                        Fmt=Fmt_f
                     Else If (Abs(CMO(isCMO+iSO*nB+iB)).ge.10.0D0) Then
                        Fmt=Fmt_l
                     Else
                        Fmt=Fmt_s
                     End If
                     If (Debug) Write (6,*) ' Fmt=',Fmt
                     Write (ChCMO,Fmt)
     &                  iB+1,Clean_BName(Name(ISB+IB),LENIN),
     &                  '(',CMO(isCMO+iSO*nB+iB),'), '
                     If (Debug) Write (6,'(A)') ChCMO
                     If (iPos.eq.1) Then
                        Line(2+Magic:2+Magic*2-1)=ChCMO
                        iPos=2
                     Else If (iPos.eq.2) Then
                        Line(2+Magic*2:2+Magic*3-1)=ChCMO
                        iPos=3
                     Else If (iPos.eq.3) Then
                        Line(2+Magic*3:2+Magic*4-1)=ChCMO
                        iPos=4
                     Else If (iPos.eq.4) Then
                        Line(2+Magic*4:2+Magic*5-1)=ChCMO
                        iPos=1
                        Write (6,'(A)') Line
                        Line=' '
                     End If
                  End If
               End Do
               If (iPos.ne.1) Write (6,'(A)') Line
               Write (6,*)
            End If
           End Do
*
        Else
*
        Do 110 ISO=0,NO-1,NCOLS
          IEO=ISO+NCOLS-1
          IEO=MIN((NO-1),IEO)
          IEO2=IEO

cvv NAG
c          Do IO=ISO,IEO2
c            If (PrEne.and.PrOcc) Then
c               If ( Ene(ISX+IO).GT.ThrEne  .OR.
c     &              Occ(ISX+IO).LT.ThrOcc ) IEO=IEO-1
c            Else If (PrEne) Then
c               If ( Ene(ISX+IO).GT.ThrEne ) IEO=IEO-1
c            Else If (PrOcc) Then
c               If ( Occ(ISX+IO).LT.ThrOcc ) IEO=IEO-1
c            End If
c          End Do

            If (PrEne.and.PrOcc) Then
             Do IO=ISO,IEO2
               If ( Ene(ISX+IO).GT.ThrEne  .OR.
     &              Occ(ISX+IO).LT.ThrOcc ) IEO=IEO-1
             enddo
            Else If (PrEne) Then
             Do IO=ISO,IEO2
               If ( Ene(ISX+IO).GT.ThrEne ) IEO=IEO-1
             enddo
            Else If (PrOcc) Then
             Do IO=ISO,IEO2
               If ( Occ(ISX+IO).LT.ThrOcc ) IEO=IEO-1
             enddo
            End If
          If ( IEO.GE.ISO ) Then
             If (.Not.Header_Done) Then
                Write(6,'(/6X,A,I2,A,A)')
     &               'Molecular orbitals for symmetry species',iSym,
     &               ': ',IrrepName(iSym)
                Header_Done=.True.
             End If
             If (PrEne) Then
                tmp=0.0D0
                Do IO=ISO,IEO
                   Shift(IO-ISO+1)=1.0D0
                   tmp=Max(Abs(Ene(ISX+IO)),tmp)
                End Do
                If (tmp.gt.1.0D3) Then
                   Write (6,*)
                   Write (6,'(10X,A)') 'Some orbital energies have '//
     &                   'been scaled by powers of 10, the power is '//
     &                   'written right after the orbital index'
                   Write (6,*)
                   Do IO=ISO,IEO
                      tmp=Abs(Ene(ISX+IO))
                      If (tmp.gt.1.0D3) Then
                         tmp=tmp*1.0D-2
                         itmp=INT(LOG10(tmp))
                         Shift(IO-ISO+1)=10.0D0**itmp
                         Write (Star(IO-ISO+1),'(A,I1,A)')
     &                         ' (',itmp,')'
                      Else
                         Star(IO-ISO+1)='    '
                      End If
                   End Do
                Else
                   Do IO=ISO,IEO
                      Star(IO-ISO+1)='    '
                   End Do
                End If
             End If
             Write(6,*)
             Write(6,FMT0) LABEL0,(1+IO,Star(IO-ISO+1),IO=ISO,IEO)
             IF ( PrEne ) Write(6,FMT1) LABEL1,
     &          (Ene(ISX+IO)/Shift(IO-ISO+1),IO=ISO,IEO)
             IF ( PrOcc ) Write(6,FMT1) LABEL2,(Occ(ISX+IO),IO=ISO,IEO)
             Write(6,*)
             if(iPrForm.ne.1) then
              Do IB=0,NB-1
                Write(6,FMT2)
     &            IB+1,Clean_BName(Name(ISB+IB),LENIN),
     &            (CMO(ISCMO+IO*NB+IB),IO=ISO,IEO)
              End Do
             endif
           End If
*
*----------------------------------------------------------------------*
*     End of loop over columns                                         *
*----------------------------------------------------------------------*
*
110     CONTINUE
        End If
*
*----------------------------------------------------------------------*
*     Update list of pointers                                          *
*----------------------------------------------------------------------*
*
        ISX=ISX+NO
        ISB=ISB+NB
        ISCMO=ISCMO+NO*NB
*
*----------------------------------------------------------------------*
*     End of loop over all irreducible representations                 *
*----------------------------------------------------------------------*
*
100   CONTINUE
*
      Call CollapseOutput(0,'   Molecular orbitals:')
      Write (6,*)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine DPT2_Trf(NBSQT,nAshT,DPT2,DPT2AO,CMO,DEPSA,DSUM)

use caspt2_module, only: NASH, NBAS, NDEL, NFRO, NISH, NORB, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NBSQT, nAshT
real(kind=wp), intent(inout) :: DPT2(NBSQT), DPT2AO(NBSQT), DSUM(NBSQT)
real(kind=wp), intent(in) :: CMO(NBSQT), DEPSA(nAshT,nAshT)
integer(kind=iwp) :: iAO, iCMO, iMO, iOrb, iOrb0, iSym, jOrb, jOrb0, nBasI, nOrbI
real(kind=wp) :: Val
real(kind=wp), allocatable :: WRK(:)

!! DPT2 transformation
!! Just transform DPT2 (in MO, block-squared) to DPT2AO (in AO,
!! block-squared). Also, for DPT2C which couples with the inactive
!! density matrix.
call mma_allocate(WRK,NBSQT,Label='WRK')

!! MO -> AO back transformation
iCMO = 1
iAO = 1
iMO = 1
do iSym=1,nSym
  iCMO = iCMO+nBas(iSym)*nFro(iSym)
  if (nORB(ISYM) > 0) then
    nBasI = nBas(iSym)
    nOrbI = nOrb(iSym)
    !! Add active orbital density
    do iOrb0=1,nAsh(iSym)
      iOrb = nIsh(iSym)+iOrb0
      ! iOrb2= nFro(iSym)+nIsh(iSym)+iOrb0
      do jOrb0=1,nAsh(iSym)
        jOrb = nIsh(iSym)+jOrb0
        ! jOrb2= nFro(iSym)+nIsh(iSym)+jOrb0
        DPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) = DPT2(iMO+iOrb-1+nOrbI*(jOrb-1))+DEPSA(iOrb0,jOrb0)
        DSUM(iMO+iOrb-1+nOrbI*(jOrb-1)) = DSUM(iMO+iOrb-1+nOrbI*(jOrb-1))+DEPSA(iOrb0,jOrb0)
      end do
    end do
    !! Symmetrize DPT2 (for shift)
    do iOrb=1,nOrb(iSym)
      do jOrb=1,iOrb
        Val = (DPT2(iMO+iOrb-1+nOrbI*(jOrb-1))+DPT2(iMO+jOrb-1+nOrbI*(iOrb-1)))*Half
        DPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) = Val
        DPT2(iMO+jOrb-1+nOrbI*(iOrb-1)) = Val
      end do
    end do
    !! First, DPT2 -> DPT2AO
    call DGEMM_('N','N',nBasI,nOrbI,nOrbI,One,CMO(iCMO),nBasI,DPT2(iMO),nOrbI,Zero,WRK,nBasI)
    call DGEMM_('N','T',nBasI,nBasI,nOrbI,One,WRK,nBasI,CMO(iCMO),nBasI,Zero,DPT2AO(iAO),nBasI)
  end if
  iCMO = iCMO+nBas(iSym)*(nOrb(iSym)+nDel(iSym))
  iAO = iAO+nBasI*nBasI
  iMO = iMO+nBasI*nBasI
end do

call mma_deallocate(WRK)

end subroutine DPT2_Trf

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine check_caspt2(mode)
! Check the roots to be considered in CASPT2 gradient
!
! With mode = 0, this subroutine should first try to decide the root
! for which CASPT2 density and MCLR are performed. If we do not have
! CASPT2 density, i.e. iGo /= 3, call CASPT2 using the root
! specified by ALASKA (or 'Relax CASSCF root'). Othewise (iGo = 3),
! we are going to perform MCLR next. If ALASKA has not specified
! roots, perform MCLR for the roots specified by CASPT2 ('Relax
! original root' for gradients, or that and 'Relax CASSCF root' for
! NAC). If ALASKA has specified, the roots are obtained from 'MCLR
! Root', and CASPT2 is then called to compute the density etc.
!
! With mode = 1, this subroutine obtains the character in 'MCLR Root'
! and determine the roots for NAC calculation.

use MCLR_Data, only: IRLXROOT, ISNAC, NACSTATES, OVERRIDE
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: Mode
#include "warnings.h"
integer(kind=iwp) :: iGo, iRlxRootPT2, iRoot1Com, iRoot1Req, iRoot2Com, iRoot2Req, iStatus, LuINPUT, LuSpool2
character(len=128) :: FileName
character(len=72) :: Line
character(len=16) :: mstate1, StdIn
logical(kind=iwp) :: Exists, NeedGrdt
integer(kind=iwp), external :: isFreeUnit, isStructure

iRlxRoot = 0
iRlxRootPT2 = 0
call Get_iScalar('SA ready',iGo)
! Requested root for gradient
call Get_iScalar('Relax CASSCF root',iRlxRoot)
! iGo=3 means that CASPT2 density has been computed
! Check the root of the density
if (iGo == 3) call Get_iScalar('Relax original root',iRlxRootPT2)

! Check this is NAC or not
isNAC = .false.
call Get_cArray('MCLR Root',mstate1,16)
if (index(mstate1,'@') /= 0) then
  ! Requested root for NAC by ALASKA
  read(mstate1,'(1X,I7,1X,I7)') NACStates(1),NACStates(2)
  if (NACStates(1) /= 0) isNAC = .true.
  if (NACStates(1) == 0) iRlxRoot = NACStates(2)
else if ((iGo == 3) .and. (iRlxRoot /= iRlxRootPT2)) then
  ! This means CASPT2 density has been computed for the states
  ! specified by the NAC option in &CASPT2 (either specified by
  ! the original input or the call below).
  ! In this case, perform MCLR anyway(?)
  ! The states can be different from those ALASKA requests.
  ! If different, ALASKA will call MCLR then CASPT2 again with
  ! the correct states.
  NACStates(1) = iRlxRoot
  NACStates(2) = iRlxRootPT2
  isNAC = .true.
  override = .true.
end if

! With mode = 1, just set NACStates
if (mode == 1) return

!write(u6,*) 'isnac = ',isnac
!if (isnac) then
!  write(u6,*) 'requested NAC:',nacstates(1),nacstates(2)
!  write(u6,*) 'computed  NAC:',irlxroot,irlxrootpt2
!else
!  write(u6,*) 'requested GRD:',irlxroot
!  write(u6,*) 'computed  GRD:',irlxrootpt2
!endif

! If CASPT2 density has been computed, and the root of
! the density is the desired one in ALASKA, go for MCLR
if (isNAC) then
  iRoot1req = max(NACStates(1),NACStates(2))
  iRoot2req = min(NACStates(1),NACStates(2))
  iRoot1com = max(iRlxRoot,iRlxRootPT2)
  iRoot2com = min(iRlxRoot,iRlxRootPT2)
  if ((iGo /= 0) .and. (iRoot1req == iRoot1com) .and. (iRoot2req == iRoot2com)) return
else
  if ((iGo /= 0) .and. (iRlxRoot == iRlxRootPT2)) return
end if

! Otherwise, compute CASPT2 density for the state specified by ALASKA (iRlxRoot)

LuInput = 11
LuInput = IsFreeUnit(LuInput)
call StdIn_Name(StdIn)
call Molcas_open(LuInput,StdIn)

write(LuInput,'(A)') '>ECHO OFF'
write(LuInput,'(A)') '>export MCLR_OLD_TRAP=$MOLCAS_TRAP'
write(LuInput,'(A)') '>export MOLCAS_TRAP=ON'

FileName = 'CASPTINP'
call f_inquire(Filename,Exists)

if (Exists) then
  LuSpool2 = 77
  LuSpool2 = IsFreeUnit(LuSpool2)
  call Molcas_Open(LuSpool2,Filename)

  NeedGrdt = (isStructure() /= 1)
  do
    read(LuSpool2,'(A)',iostat=istatus) Line
    !write(u6,'(a)') line
    if (istatus > 0) call Abend()
    if (istatus < 0) exit
    write(LuInput,'(A)') Line
    call UpCase(Line)
    if (Line(1:4) == 'GRDT') NeedGrdt = .false.
  end do

  if (NeedGrdt) then
    backspace LuInput
    write(LuInput,'(A)') 'GRDT'
  end if

  close(LuSpool2)
else
  write(u6,'(A)') 'CASPT2 gradient without &CASPT2?'
  write(u6,'(A)') 'this cannot happen, ig'
  call abend()
end if

FileName = 'MCLRINP'
call f_inquire(Filename,Exists)

! NAC states are obtained from "MCLR Roots"
if (Exists) then
  LuSpool2 = 77
  LuSpool2 = IsFreeUnit(LuSpool2)
  call Molcas_Open(LuSpool2,Filename)
  do
    read(LuSpool2,'(A)',iostat=istatus) Line
    !write(u6,'(a)') line
    if (istatus > 0) call Abend()
    if (istatus < 0) exit
    write(LuInput,'(A)') Line
  end do
  close(LuSpool2)
else
  write(LuInput,'(A)') ' &Mclr &End'
  write(LuInput,'(A)') 'End of Input'
end if

write(LuInput,'(A)') '>export MOLCAS_TRAP=$MCLR_OLD_TRAP'
write(LuInput,'(A)') '>ECHO ON'

!rewind(luinput)
!write(u6,*)
!write(u6,*) 'show luinput'
!write(u6,*)
!do
!  read(LuInput,'(A)',iostat=istatus) Line
!  write(u6,'(a)') line
!  if (istatus > 0) call Abend()
!  if (istatus < 0) exit
!end do

close(LuInput)

call Finish(_RC_INVOKED_OTHER_MODULE_)

return

end subroutine check_caspt2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Stefano Battaglia                                *
!***********************************************************************

subroutine wgtinit(H,nState)

use PrintLevel, only: DEBUG, VERBOSE
use caspt2_global, only: DWGT, iPrGlb
use caspt2_module, only: DWType, IfDW, IfXMS, Zeta
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nState
real(kind=wp), intent(in) :: H(nState,nState)
integer(kind=iwp) :: I, J, K
real(kind=wp) :: Dab, Dag, Ealpha, Ebeta, Egamma, Hab, Hag, Wtot, xi_ab, xi_ag

if (IPRGLB >= DEBUG) write(u6,*) ' Entered wgtinit.'

if (IFDW .and. (zeta >= Zero)) then
  ! If it is an XDW-CASPT2 calculation, the weights are computed
  do I=1,nState
    Ebeta = H(I,I)
    ! Compute normalization factor Wtot, i.e. the sum of all weights
    do J=1,nState
      Ealpha = H(J,J)
      Wtot = Zero
      do K=1,nState
        Egamma = H(K,K)

        if (DWType == 1) then
          ! original XDW-CASPT2, xi = Dab^2
          xi_ag = (Ealpha-Egamma)**2
        else if (DWType == 2) then
          ! new XDW-CASPT2, xi = (Haa/Hab)^2
          xi_ag = (Ealpha/H(J,K))**2
        else
          ! new XDW-CASPT2, xi = Dab/sqrt(Hab), which is DWType == 3
          ! add a small positive constant to numerator to avoid 0/0
          Dag = abs(Ealpha-Egamma)+1.0e-9_wp
          Hag = abs(H(J,K))
          ! add the smallest value of the same type as Hag to the
          ! denominator to avoid division by 0 which can lead to
          ! segfault with certain compilers
          xi_ag = Dag/(sqrt(Hag)+tiny(Hag))
        end if

        Wtot = Wtot+exp(-zeta*xi_ag)
      end do

      if (DWType == 1) then
        ! original XDW-CASPT2, xi = Dab^2
        xi_ab = (Ealpha-Ebeta)**2
      else if (DWType == 2) then
        ! new XDW-CASPT2, xi = (Haa/Hab)^2
        xi_ab = (Ealpha/H(J,I))**2
      else
        ! new XDW-CASPT2, xi = Dab/sqrt(Hab), which is DWType == 3
        ! add a small positive constant to numerator to avoid 0/0
        Dab = abs(Ealpha-Ebeta)+1.0e-9_wp
        Hab = abs(H(J,I))
        ! add the smallest value of the same type as Hag to the
        ! denominator to avoid division by 0 which can lead to
        ! segfault with certain compilers
        xi_ab = Dab/(sqrt(Hab)+tiny(Hab))
      end if

      DWGT(I,J) = exp(-zeta*xi_ab)/Wtot

    end do
  end do

else if (IFXMS .and. (.not. IFDW)) then
  ! If it is an XMS-CASPT2 calculation, all the weights are equal,
  ! i.e. they all are 1/nState
  DWGT(:,:) = One/real(nState,kind=wp)

else
  ! If it is a normal MS-CASPT2, RMS-CASPT2 or a (X)DW-CASPT2 with zeta->infinity
  ! the weight vectors are the standard unit vectors e_1, e_2, ...
  call unitmat(DWGT,nState)
end if

! In case it is a XDW calculation, print out the weights
if (IFDW .and. (IPRGLB >= VERBOSE)) then
  write(u6,*) ' Weights calculated with <I|H|I>:'
  call prettyprint(DWGT,nState,nState)
end if

end subroutine wgtinit

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Dynamic_Properties(Temp,nAtoms,rMP,nij,nPert,
     &                              nElem,Delta,EC,Polar,
     &                              iANr,Bond_Threshold,ChPol,
     &                              ChPolBB)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 Temp(nij), A(3), B(3), EC(3,nij), Polar(6,nij),
     &       rMP(nij,0:nElem-1,0:nPert-1), ChPol(6, nij),
     &       ChPolBB(6, nij)
      Integer iAnr(nAtoms)
*                                                                      *
************************************************************************
*                                                                      *
C     Call RecPrt('rMP',' ',rMP,nij*nElem,nPert)
      Write (6,*)
      Write (6,*)  ' D y n a m i c  P r o p e r t i e s'
      Write (6,*)
      Write (6,*)  ' Properties computed with FFPT'
      Write (6,*)

      Do iPol = 1, 6
         Do iAtom = 1, nAtoms
            Do jAtom = 1, iAtom
               ij=iAtom*(iAtom-1)/2+jAtom
               ChPol(iPol, ij) = 0.0
               ChPolBB(iPol, ij) = 0.0
            End Do
         End Do
      End Do


*
*     iPol: index vector for polarizability
*           (1,2,3,4,5,6)=(xx,yx,yy,zx,zy,zz)
*
      Do iPol = 1, 6
         Call FZero(Temp,nij)
C        Write (6,*)
         Do iAtom = 1, nAtoms
            ii = iAtom*(iAtom+1)/2
            call dcopy_(3,EC(1,ii),1,A,1)
            Do jAtom = 1, iAtom
               jj = jAtom*(jAtom+1)/2
               call dcopy_(3,EC(1,jj),1,B,1)
*
               ij=iAtom*(iAtom-1)/2+jAtom
*                                                                      *
************************************************************************
*                                                                      *
*              Polarizabilities: alpha(iAtom,jAtom,iCar,jCar)          *
*                                                                      *
************************************************************************
*                                                                      *
*              iCar, jCar: index of cartesian for each perturbation
*                        1=x, 2=y, 3=z
               iCar = Int((One+sqrt(Eight*DBLE(iPol)-Three))/Two)
               jCar = iPol   -iCar*(iCar-1)/2
*
*              iPert, jPert: index vector to actuall perturbation
*                    (1,2,3,4,5,6)=(+dx,-dx,+dy,-dy,+dz,-dz)
               iPert=(jCar-1)*2+1
               jPert=iPert+1
*
*              Contribution due to change of localized dipole moment
*
*------------- mu(iAtom,jAtom,iCar,+dF(jCar))
*------------- mu(iAtom,jAtom,iCar,-dF(jCar))
*
               Pol1a=(rMP(ij,iCar,iPert)-rMP(ij,iCar,jPert))/(Two*Delta)
*
               iPert_=(iCar-1)*2+1
               jPert_=iPert_+1
               Pol1b=(rMP(ij,jCar,iPert_)-rMP(ij,jCar,jPert_))
     &              /(Two*Delta)
               Pol1 = Half * (Pol1a+Pol1b)
C              Write (*,*) 'Pol1',ij,iCar,iPert,jPert
C              Write (*,*) rMP(ij,iCar,iPert),rMP(ij,iCar,jPert)
*
*              Contribution due to change of localized charges
*
               If (iAtom .ne. jAtom) Then
                  Rij_iCar=B(iCar)-A(iCar)
C                 Write (*,*) rMP(ij,0,iPert),rMP(ij,0,jPert)
                  Pol2= (rMP(ij,0,iPert)-rMP(ij,0,jPert))
     &                * Rij_iCar/(Two*Delta)
               Else
                  Pol2=Zero
               End If
*
C              Write (*,*) Pol1, Pol2

               Temp(ij) = Temp(ij) + Pol1 + Pol2
               Polar(iPol,ij)=Temp(ij)
*                                                                      *
************************************************************************
*              Compute Charge contrib                                  *
************************************************************************
*                                                                      *
               ChPol(iPol,ij)=ChPol(iPol,ij) + Pol2
               ChPolBB(iPol,ij)=ChPolBB(iPol,ij) + Pol2
************************************************************************


*                                                                      *
************************************************************************
*                                                                      *
            End Do   ! jAtom
         End Do      ! iAtom
*                                                                      *
************************************************************************
*                                                                      *
      End Do   ! iPol
*                                                                      *
************************************************************************
*                                                                      *
*            Move the polarizabilities to the atoms if needed          *
*                                                                      *
************************************************************************
*                                                                      *
      Call Move_Polar(Polar,EC,nAtoms,nij,iANr,Bond_Threshold)
      Call Move_Polar(ChPol,EC,nAtoms,nij,iANr,Bond_Threshold)

      Return

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
************************************************************************
      SubRoutine IvoGen(OneHam,nOne,CMO,nCMO,EOrb,nEOrb,mynOcc)
************************************************************************
*                                                                      *
*     purpose: Generate improved virtual orbitals by diagonalization   *
*              of the one-electron hamiltonian in the subspace spanned *
*              by the virtual orbitals                                 *
*                                                                      *
*     input:                                                           *
*       OneHam  : one-electron hamiltonian of length nOne              *
*       CMO     : molecular orbital coefficients of length nCMO        *
*                                                                      *
*     output:                                                          *
*       CMO     : molecular orbital coefficients with virtual orbitals *
*                 modified                                             *
*       EOrb    : orbital energies (set to zero for virtual orbitals)  *
*                                                                      *
*     called from: Final                                               *
*                                                                      *
*     calls to: PickUp, Sort                                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
      Real*8 OneHam(nOne),CMO(nCMO),EOrb(nEOrb)
      Integer mynOcc(*)
*
      Real*8, Dimension(:), Allocatable:: FckS, FckH, FckT,
     &                                    Scratch
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*---- Allocate memory for squared modified Fock matrix
      Call mma_allocate(FckS,MaxBas**2,Label='FckS')
*
*---- Allocate memory for half transformed Fock matrix
      Call mma_allocate(FckH,MaxBOO,Label='FckH')
*
*---- Allocate memory for transformed Fock matrix
      Call mma_allocate(FckT,MaxOrO*(MaxOrO + 1)/2,Label='FckT')
*
      ij   = 1
      iCMO = 1
      iEOr = 1
      Do iSym = 1, nSym
         nOrbi = nOrb(iSym) - mynOcc(iSym)
*
*------- If nOrbi.eq.0 - no virtual orbitals; iCMO and iEOr must be
*        updated anyway (occupied orbitals may exist)
         iCMO = iCMO + nBas(iSym)*mynOcc(iSym)
         iEOr = iEOr + mynOcc(iSym)
*
         If (nOrbi.gt.0) Then
*
*---------- Transform OneHam to space spanned by virtual orbitals
            Call Square(OneHam(ij),FckS,1,nBas(iSym),nBas(iSym))
            Call DGEMM_('N','N',
     &                  nBas(iSym),nOrbi,nBas(iSym),
     &                  1.0d0,FckS,nBas(iSym),
     &                        CMO(iCMO),nBas(iSym),
     &                  0.0d0,FckH,nBas(iSym))
            Call MxMt(CMO(iCMO),   nBas(iSym),1,
     &                FckH,1,nBas(iSym),
     &                FckT,
     &                nOrbi,nBas(iSym))
*
*---------- Diagonalize OneHam within virtual space and form orbital energies
            Call mma_allocate(Scratch,nOrbi**2,Label='Scratch')
            Dummy=0.0D0
            iDum=0
            Call Diag_Driver('V','A','L',nOrbi,FckT,
     &                       Scratch,nOrbi,Dummy,Dummy,iDum,iDum,
     &                       EOrb(iEOr),CMO(iCMO),nBas(iSym),0,-1,'J',
     &                       nFound,iErr)
            Call mma_deallocate(Scratch)
*
*---------- Orbital energies are now meaningless; set them to zero
            call dcopy_(nOrbi,[Zero],0,EOrb(iEOr),1)
*
         End If
*
*------- Update pointers
         iCMO = iCMO + nOrbi*nBas(iSym)
         iEOr = iEOr + nOrbi
         ij   = ij   + nBas(iSym)*(nBas(iSym) + 1)/2
*
      End Do
*
*---- Deallocate memory
      Call mma_deallocate(FckS)
      Call mma_deallocate(FckH)
      Call mma_deallocate(FckT)
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine cvbinit_cvb()
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "maxbfn.fh"
      parameter(iset=1)
      save is_set
      data is_set/0/

      if(is_set.eq.iset)return
      entry cvbfinit_cvb()

      mxaobf=maxbfn
      iprec=8
      iwidth=110
      call formats_cvb()
      call setidbl_cvb()
      call meminit_cvb()
      if(is_set.ne.iset)then
c  Initializations below are only carried out once :
        call io_init_cvb()
        call main_bdata_cvb()
      endif
      is_set=iset
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DENSI2_LUCIA(    I12,   RHO1,   RHO2,  RHO2S,  RHO2A,
     &                              L,      R,    LUL,    LUR,  EXPS2,
     &                        IDOSRHO1, SRHO1, IPACK)
*
* Density matrices between L and R
*
* I12 = 1 => only one-body density
* I12 = 2 => one- and two-body density matrices
*
* Jeppe Olsen,      Oct 94
* GAS modifications Aug 95
* Two body density added, '96
*
* Table-Block driven, June 97
* Spin density added, Jan. 99
*
* Jesper Wisborg Krogh
* Allowing to symmetry pack on the fly, Sept. 2003
*
* Two-body density is stored as rho2(ijkl)=<l!e(ij)e(kl)-delta(jk)e(il)!r>
* ijkl = ij*(ij-1)/2+kl, ij.ge.kl
*
* Two-body symmetric density stored in rho2s
* Two-body anti-symmetric density stored in rho2a
*
* If the two-body density matrix is calculated, then also the
* expectation value of the spin is evaluated.
* The latter is realized as
* S**2
*      = S+S- + Sz(Sz-1)
*      = -Sum(ij) a+i alpha a+j beta a i beta a j alpha + Nalpha +
*        1/2(N alpha - N beta))(1/2(N alpha - Nbeta) - 1)
* If IDOSRHO1 = 1, spin density is also calculated
      IMPLICIT REAL*8(A-H,O-Z)
c      REAL*8 INPRDD
*
* =====
*.Input
* =====
*
*.Definition of L and R is picked up from CANDS
* with L being S and  R being C
      COMMON/CANDS/ICSM,ISSM,ICSPC,ISSPC
*
#include "mxpdim.fh"
#include "orbinp.fh"
#include "cicisp.fh"
#include "strbas.fh"
#include "cstate.fh"
#include "strinp.fh"
#include "stinf.fh"
#include "csm.fh"
#include "WrkSpc.fh"
#include "crun.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "cprnt.fh"
#include "spinfo_lucia.fh"
#include "glbbas.fh"
*
      LOGICAL IPACK
      INTEGER ADASX,ASXAD,ADSXA,SXSXDX,SXDXSX
      COMMON/CSMPRD/ADASX(MXPOBS,MXPOBS),ASXAD(MXPOBS,2*MXPOBS),
     &              ADSXA(MXPOBS,2*MXPOBS),
     &              SXSXDX(2*MXPOBS,2*MXPOBS),SXDXSX(2*MXPOBS,4*MXPOBS)
#include "lucinp.fh"
#include "clunit.fh"
*. Scratch for string information
      COMMON/HIDSCR/KLOCSTR(4),KLREO(4),KLZ(4),KLZSCR
      INTEGER SXSTSM(1)
*. Specific input
      REAL*8 L
      DIMENSION L(*),R(*)
*.Output
      DIMENSION RHO1(*),RHO2(*),RHO2S(*),RHO2A(*),SRHO1(*)
*. Before I forget it :
      IDUM = 0
*     CALL MEMMAN(IDUM,IDUM,'MARK ',IDUM,'DENSI ')
      ZERO = 0.0D0
      CALL SETVEC(RHO1,ZERO ,NACOB ** 2 )
      IF(I12.EQ.2) THEN
         IF(IPACK) THEN
* If IPACK .EQ. .TRUE. then
C     Number of elements in symmetric and antisymmetric 2-body
C     density matrices are given in Nijkl.
            NIJ   = (NACOB*(NACOB+1))/2
            NIJKL = (NIJ*(NIJ+1))/2
            CALL SETVEC(RHO2S,ZERO,NIJKL)
            CALL SETVEC(RHO2A,ZERO,NIJKL)
         ELSE
            CALL SETVEC(RHO2,ZERO ,NACOB ** 2 *(NACOB**2+1)/2)
         END IF
      END IF
*
      IF(IDOSRHO1.EQ.1) THEN
        CALL SETVEC(SRHO1,ZERO,NACOB ** 2)
      END IF
*
C?     WRITE(6,*) ' ISSPC ICSPC in DENSI2 ',ISSPC,ICSPC
*
* Info for this internal space
*
* Info for this internal space
*. type of alpha and beta strings
      IATP = 1
      IBTP = 2
*. alpha and beta strings with an electron removed
      IATPM1 = 3
      IBTPM1 = 4
*. alpha and beta strings with two electrons removed
      IATPM2 = 5
      IBTPM2 = 6
*
      JATP = 1
      JBTP = 2
*. Number of supergroups
      NOCTPA = NOCTYP(IATP)
      NOCTPB = NOCTYP(IBTP)
*. Offsets for supergroups
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
*
      NAEL = NELEC(IATP)
      NBEL = NELEC(IBTP)
*
      ILSM = ISSM
      IRSM = ICSM

* string sym, string sym => sx sym
* string sym, string sym => dx sym
      CALL GETMEM('KSTSTS','ALLO','INTE',KSTSTS,NSMST ** 2)
      CALL GETMEM('KSTSTD','ALLO','INTE',KSTSTD,NSMST ** 2)
      CALL STSTSM(IWORK(KSTSTS),IWORK(KSTSTD),NSMST)
*. connection matrices for supergroups
      CALL GETMEM('CONSPA','ALLO','INTE',KCONSPA,NOCTPA**2)
      CALL GETMEM('CONSPB','ALLO','INTE',KCONSPB,NOCTPB**2)
      CALL SPGRPCON(   IOCTPA,   NOCTPA,     NGAS,  MXPNGAS, NELFSPGP,
     &              iWORK(KCONSPA),IPRCIX)
      CALL SPGRPCON(   IOCTPB,   NOCTPB,     NGAS,  MXPNGAS, NELFSPGP,
     &              iWORK(KCONSPB),IPRCIX)
*. Largest block of strings in zero order space
      MAXA0 = IMNMX(IWORK(KNSTSO(IATP)),NSMST*NOCTYP(IATP),2)
      MAXB0 = IMNMX(IWORK(KNSTSO(IBTP)),NSMST*NOCTYP(IBTP),2)
      MXSTBL0 = MXNSTR
*. Largest number of strings of given symmetry and type
      MAXA = 0
      IF(NAEL.GE.1) THEN
        MAXA1 = IMNMX(IWORK(KNSTSO(IATPM1)),NSMST*NOCTYP(IATPM1),2)
        MAXA = MAX(MAXA,MAXA1)
      END IF
      IF(NAEL.GE.2) THEN
        MAXA1 = IMNMX(IWORK(KNSTSO(IATPM2)),NSMST*NOCTYP(IATPM2),2)
        MAXA = MAX(MAXA,MAXA1)
      END IF
      MAXB = 0
      IF(NBEL.GE.1) THEN
        MAXB1 = IMNMX(IWORK(KNSTSO(IBTPM1)),NSMST*NOCTYP(IBTPM1),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      IF(NBEL.GE.2) THEN
        MAXB1 = IMNMX(IWORK(KNSTSO(IBTPM2)),NSMST*NOCTYP(IBTPM2),2)
        MAXB = MAX(MAXB,MAXB1)
      END IF
      MAXA = MAX(MAXA,MAXA0)
      MAXB = MAX(MAXB,MAXB0)
      MXSTBL = MAX(MAXA,MAXB)
      IF(IPRDEN.GE.2 ) WRITE(6,*)
     &' Largest block of strings with given symmetry and type',MXSTBL
*. Largest number of resolution strings and spectator strings
*  that can be treated simultaneously
*. replace with MXINKA !!!
      MAXI = MIN(MXINKA,MXSTBL)
      MAXK = MIN(MXINKA,MXSTBL)
C?    WRITE(6,*) ' DENSI2 : MAXI MAXK ', MAXI,MAXK
*Largest active orbital block belonging to given type and symmetry
      MXTSOB = 0
      DO IOBTP = 1, NGAS
         DO IOBSM = 1, NSMOB
            MXTSOB = MAX(MXTSOB,NOBPTS(IOBTP,IOBSM))
         END DO
      END DO
      MAXIJ = MXTSOB ** 2
*.Local scratch arrays for blocks of C and sigma
      IF(IPRDEN.GE.2) write(6,*) ' DENSI2 : MXSB MXTSOB MXSOOB ',
     &       MXSB,MXTSOB,MXSOOB
c      IF(ISIMSYM.NE.1) THEN
        LSCR1 = MXSOOB
c      ELSE
c        LSCR1 = MXSOOB_AS
c      END IF
      LSCR1 = MAX(LSCR1,LCSBLK)
* JESPER: Should reduce I/O
      IF (ENVIRO(1:6).EQ.'RASSCF') THEN
        LSCR1 = MAX(INT(XISPSM(IREFSM, 1)),MXSOOB)
        IF(PSSIGN.NE.0.0D0) LSCR1 = INT(2.0D0*XISPSM(IREFSM,1))
      ENDIF
      IF(IPRDEN.GE.2)
     &WRITE(6,*) ' ICISTR,LSCR1 ',ICISTR,LSCR1
*.SCRATCH space for block of two-electron density matrix
* A 4 index block with four indeces belonging OS class
      INTSCR = MXTSOB ** 4
      IF(IPRDEN.GE.2)
     &WRITE(6,*) ' Density scratch space ',INTSCR
      CALL GETMEM('INSCR ','ALLO','REAL',KINSCR,INTSCR)
*
*. Arrays giving allowed type combinations '
      CALL GETMEM('SIOIO ','ALLO','INTE',KSIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('CIOIO ','ALLO','INTE',KCIOIO,NOCTPA*NOCTPB)
*
      CALL IAIBCM(ISSPC,iWORK(KSIOIO))
      CALL IAIBCM(ISSPC,iWORK(KCIOIO))
*. Scratch space for CJKAIB resolution matrices
      CALL MXRESCPH(iWORK(KCIOIO),IOCTPA,IOCTPB,NOCTPA,NOCTPB,
     &                  NSMST,NSTFSMSPGP,MXPNSMST,   NSMOB, MXPNGAS,
     &                   NGAS,   NOBPTS,   IPRCIX,     MAXK, NELFSPGP,
     &                   MXCJ,   MXCIJA,   MXCIJB,  MXCIJAB,   MXSXBL,
     &               MXADKBLK,   IPHGAS, NHLFSPGP,     MNHL,  IADVICE,
*
     &              MXCJ_ALLSYM,MXADKBLK_AS,MX_NSPII)
      IF(IPRDEN.GE.2) THEN
        WRITE(6,*) ' DENSI12 :  : MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL',
     &                     MXCJ,MXCIJA,MXCIJB,MXCIJAB,MXSXBL
      END IF
      LSCR2 = MAX(MXCJ,MXCIJA,MXCIJB)
      IF(IPRDEN.GE.2)
     &WRITE(6,*) ' Space for resolution matrices ',LSCR2
      LSCR12 = MAX(LSCR1,2*LSCR2)
      IF (ENVIRO(1:6) .EQ. 'RASSCF') THEN
         LSCR12 = MAX(LSCR1,LSCR2)
      END IF
*. It is assumed that the third block already has been allocated, so
      KC2 = KVEC3
      IF(IPRCIX.GE.2)
     &WRITE(6,*) ' Space for resolution matrices ',LSCR12
      KSSCR = KC2
      KCSCR = KC2 + LSCR2
      IF (ENVIRO(1:6) .EQ. 'RASSCF') THEN
         KCSCR = KC2 + LSCR12
      END IF
*
*. Space for annihilation/creation mappings
      MAXIK = MAX(MAXI,MAXK)
      LSCR3 = MAX(MXADKBLK,MAXIK*MXTSOB*MXTSOB,MXSTBL0)
      CALL GETMEM('I1    ','ALLO','INTE',KI1,  LSCR3       )
      CALL GETMEM('I2    ','ALLO','INTE',KI2,  LSCR3       )
      CALL GETMEM('I3    ','ALLO','INTE',KI3,  LSCR3       )
      CALL GETMEM('I4    ','ALLO','INTE',KI4,  LSCR3       )
      CALL GETMEM('XI1S  ','ALLO','REAL',KXI1S,LSCR3       )
      CALL GETMEM('XI2S  ','ALLO','REAL',KXI2S,LSCR3       )
      CALL GETMEM('XI3S  ','ALLO','REAL',KXI3S,LSCR3       )
      CALL GETMEM('XI4S  ','ALLO','REAL',KXI4S,LSCR3       )
*. Arrays giving block type
      CALL GETMEM('SBLTP ','ALLO','INTE',KSBLTP,NSMST)
      CALL GETMEM('CBLTP ','ALLO','INTE',KCBLTP,NSMST)
*. Arrays for additional symmetry operation
c      IF(IDC.EQ.3.OR.IDC.EQ.4) THEN
c        CALL MEMMAN(KSVST,NSMST,'ADDL  ',2,'SVST  ')
c        CALL SIGVST(WORK(KSVST),NSMST)
c      ELSE
         KSVST = 1
c      END IF
      CALL ZBLTP(ISMOST(1,ISSM),NSMST,IDC,iWORK(KSBLTP),iWORK(KSVST))
      CALL ZBLTP(ISMOST(1,ICSM),NSMST,IDC,iWORK(KCBLTP),iWORK(KSVST))
*.0 OOS arrayy
      NOOS = NOCTPA*NOCTPB*NSMST
* scratch space containing active one body
      CALL GETMEM('RHO1S ','ALLO','REAL',KRHO1S,NACOB ** 2)
*. For natural orbitals
      CALL GETMEM('RHO1P ','ALLO','REAL',KRHO1P,NACOB*(NACOB+1)/2)
      CALL GETMEM('XNATO ','ALLO','REAL',KXNATO,NACOB **2)
*. Natural orbitals in symmetry blocks
      CALL GETMEM('RHO1S ','ALLO','REAL',KRHO1SM,NACOB ** 2)
      CALL GETMEM('RHO1S ','ALLO','REAL',KXNATSM,NACOB ** 2)
      CALL GETMEM('RHO1S ','ALLO','REAL',KOCCSM,NACOB )
*
*. Space for one block of string occupations and two arrays of
*. reordering arrays
      LZSCR = (MAX(NAEL,NBEL)+3)*(NOCOB+1) + 2 * NOCOB
      LZ    = (MAX(NAEL,NBEL)+2) * NOCOB
      CALL GETMEM('KLZSCR','ALLO','INTE',KLZSCR,LZSCR)
      DO K12 = 1, 1
        CALL GETMEM('KLOCS ','ALLO','INTE',KLOCSTR(K12),MAX_STR_OC_BLK)
      END DO
      DO I1234 = 1, 2
        CALL GETMEM('KLREO ','ALLO','INTE',KLREO(I1234),MAX_STR_SPGP)
        CALL GETMEM('KLZ   ','ALLO','INTE',KLZ(I1234),LZ)
      END DO
*. Arrays for partitioning of Left vector = sigma
      NTTS = MXNTTS
      CALL GETMEM('LBT_L  ','ALLO','INTE',KLLBTL ,NTTS  )
      CALL GETMEM('LEBT_L ','ALLO','INTE',KLLEBTL,NTTS  )
      CALL GETMEM('I1BT_L ','ALLO','INTE',KLI1BTL,NTTS  )
      CALL GETMEM('IBT_L  ','ALLO','INTE',KLIBTL ,8*NTTS)
      CALL GETMEM('SCLF_L ','ALLO','REAL',KLSCLFCL,NTTS)
      CALL PART_CIV2(IDC,iWORK(KSBLTP),
     &               iWORK(KNSTSO(IATP)),iWORK(KNSTSO(IBTP)),
     &               NOCTPA,NOCTPB,
     &               NSMST, LSCR1,
     &               iWORK(KSIOIO),ISMOST(1,ISSM),
     &               NBATCHL,
     &               iWORK(KLLBTL),iWORK(KLLEBTL),
     &               iWORK(KLI1BTL),iWORK(KLIBTL),
     &               0,ISIMSYM)
*. Number of BLOCKS
        NBLOCKL = IFRMR(IWORK(KLI1BTL),1,NBATCHL)
     &         + IFRMR(IWORK(KLLBTL),1,NBATCHL) - 1
*. Arrays for partitioning of Right  vector = C
      NTTS = MXNTTS
      CALL GETMEM('LBT_R  ','ALLO','INTE',KLLBTR ,NTTS  )
      CALL GETMEM('LEBT_R ','ALLO','INTE',KLLEBTR,NTTS  )
      CALL GETMEM('I1BT_R ','ALLO','INTE',KLI1BTR,NTTS  )
      CALL GETMEM('IBT_R  ','ALLO','INTE',KLIBTR ,8*NTTS)
      CALL GETMEM('SCLF_R ','ALLO','REAL',KLSCLFCR,NTTS)
      CALL PART_CIV2(IDC,iWORK(KCBLTP),
     &               iWORK(KNSTSO(IATP)),iWORK(KNSTSO(IBTP)),
     &               NOCTPA,NOCTPB,
     &               NSMST, LSCR1,
     &               iWORK(KCIOIO),ISMOST(1,ICSM),
     &               NBATCHR,
     &               iWORK(KLLBTR),iWORK(KLLEBTR),
     &               iWORK(KLI1BTR),iWORK(KLIBTR),
     &               0,ISIMSYM)
*. Number of BLOCKS
        NBLOCKR = IFRMR(IWORK(KLI1BTR),1,NBATCHR)
     &         + IFRMR(IWORK(KLLBTR),1,NBATCHR) - 1
C?      WRITE(6,*) ' DENSI2T :NBLOCKR =',NBLOCKR


      IF(ICISTR.EQ.1) THEN
         WRITE(6,*) ' Sorry, ICISTR = 1 is out of fashion'
         WRITE(6,*) ' Switch to ICISTR = 2 - or reprogram '
*         STOP' DENSI2T : ICISTR = 1 in use '
         CALL SYSABENDMSG('lucia_util/densi2_lucia',
     &                    'Internal error',' ')
      ELSE IF(ICISTR.GE.2) THEN
        S2_TERM1 = 0.0D0
        CALL GASDN2_LUCIA(     I12,    RHO1,    RHO2,   RHO2S,   RHO2A,
     &                           L,       R,       L,       R,WORK(KC2),
     &                    iWORK(KCIOIO),iWORK(KSIOIO),
     &                    ISMOST(1,ICSM),ISMOST(1,ISSM),
     &                    iWORK(KCBLTP),iWORK(KSBLTP),NACOB,
     &                    iWORK(KNSTSO(IATP)),iWORK(KISTSO(IATP)),
     &                    iWORK(KNSTSO(IBTP)),iWORK(KISTSO(IBTP)),
     &                    NAEL,IATP,  NBEL,  IBTP,
     &                      IOCTPA,  IOCTPB,  NOCTPA,  NOCTPB,   NSMST,
     &                       NSMOB,   NSMSX,   NSMDX, MXPNGAS,  NOBPTS,
     &                      IOBPTS,    MAXK,    MAXI,   LSCR1,   LSCR1,
     &                    WORK(KCSCR),WORK(KSSCR),
     &                    SXSTSM,iWORK(KSTSTS),iWORK(KSTSTD),SXDXSX,
     &                    ADSXA,ASXAD,NGAS,NELFSPGP,IDC,
     &                    iWORK(KI1),WORK(KXI1S),iWORK(KI2),WORK(KXI2S),
     &                    iWORK(KI3),WORK(KXI3S),iWORK(KI4),WORK(KXI4S),
     &                    WORK(KINSCR),MXPOBS,IPRDEN,WORK(KRHO1S),
     &                    LUL,LUR,PSSIGN,PSSIGN,
     &                    WORK(KRHO1P),WORK(KXNATO),
     &                    NBATCHL,
     &                    iWORK(KLLBTL),iWORK(KLLEBTL),
     &                    iWORK(KLI1BTL),iWORK(KLIBTL),
     &                    NBATCHR,
     &                    iWORK(KLLBTR),iWORK(KLLEBTR),
     &                    iWORK(KLI1BTR),iWORK(KLIBTR),
     &                    iWORK(KCONSPA),iWORK(KCONSPB),
     &                    WORK(KLSCLFCL),WORK(KLSCLFCR),
     &                    S2_TERM1, IUSE_PH,  IPHGAS,IDOSRHO1,   SRHO1,
     &                    IPACK)
*
        CALL GADSUM(RHO1,NACOB**2)
        IF(I12.EQ.2) THEN
          IF(IPACK) THEN
* If IPACK .EQ. .TRUE. then
C     Number of elements in symmetric and antisymmetric 2-body
C     density matrices are given in Nijkl.
            NIJ   = (NACOB*(NACOB+1))/2
            NIJKL = (NIJ*(NIJ+1))/2
            CALL GADSUM(RHO2S,NIJKL)
            CALL GADSUM(RHO2A,NIJKL)
          ELSE
            CALL GADSUM(RHO2,NACOB ** 2 *(NACOB**2+1)/2)
          END IF
        END IF
        IF(IDOSRHO1.EQ.1) THEN
          CALL GADSUM(SRHO1,NACOB ** 2)
        END IF
        CALL GADSUM_SCAL(S2_TERM1)
*
* CALL GASDN2_LUCIA --> 89
*
C     KLLBTR  KLLEBTR KLI1BTR KLIBTR
      END IF
C?    WRITE(6,*) ' Memcheck in densi2 after GASDN2'
C?    CALL MEMCHK
*
*
*. Add terms from hole-hole commutator
c      IF(IUSE_PH.EQ.1) THEN
c*. Overlap between left and right vector
c       XLR = INPRDD(L,R,LUR,LUL,1,-1)
c       CALL RHO1_HH(RHO1,XLR)
c      END IF

* Natural Orbitals
      CALL NATORB_LUCIA(RHO1,   NSMOB,  NTOOBS,  NACOBS,  NINOBS,IREOST,
     &                  WORK(KXNATO),WORK(KRHO1SM),WORK(KOCCSM),NACOB,
     &                  WORK(KRHO1P),IPRDEN)
*
      IF(IPRDEN.GE.5) THEN
        WRITE(6,*) ' One-electron density matrix '
        WRITE(6,*) ' ============================'
        CALL WRTMAT(RHO1,NTOOB,NTOOB,NTOOB,NTOOB)
        IF(I12.EQ.2) THEN
          WRITE(6,*) ' Two-electron density '
          CALL PRSYM(RHO2,NACOB**2)
        END IF
      END IF
*
      IF(I12.EQ.2) THEN
* <L!S**2|R>
        EXPS2 = S2_TERM1+0.25D0*DBLE(4*NAEL+(NAEL-NBEL)*(NAEL-NBEL-2))
        IF(IPRDEN.GT.0) THEN
          WRITE(6,*) ' Term 1 to S2 ', S2_TERM1
          WRITE(6,*) ' Expectation value of S2 ', EXPS2
        END IF
      ELSE
        EXPS2 = 0.0D0
      END IF
*
      IF(IDOSRHO1.EQ.1.AND.IPRDEN.GE.2) THEN
        WRITE(6,*) ' One-electron spindensity <0!E(aa) - E(bb)!0> '
        CALL WRTMAT(SRHO1,NTOOB,NTOOB,NTOOB,NTOOB)
      END IF

*. Eliminate local memory
      CALL GETMEM('KSTSTS','FREE','INTE',KSTSTS,NSMST ** 2)
      CALL GETMEM('KSTSTD','FREE','INTE',KSTSTD,NSMST ** 2)
      CALL GETMEM('CONSPA','FREE','INTE',KCONSPA,NOCTPA**2)
      CALL GETMEM('CONSPB','FREE','INTE',KCONSPB,NOCTPB**2)
      CALL GETMEM('INSCR ','FREE','REAL',KINSCR,INTSCR)
      CALL GETMEM('SIOIO ','FREE','INTE',KSIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('CIOIO ','FREE','INTE',KCIOIO,NOCTPA*NOCTPB)
      CALL GETMEM('I1    ','FREE','INTE',KI1,  LSCR3       )
      CALL GETMEM('I2    ','FREE','INTE',KI2,  LSCR3       )
      CALL GETMEM('I3    ','FREE','INTE',KI3,  LSCR3       )
      CALL GETMEM('I4    ','FREE','INTE',KI4,  LSCR3       )
      CALL GETMEM('XI1S  ','FREE','REAL',KXI1S,LSCR3       )
      CALL GETMEM('XI2S  ','FREE','REAL',KXI2S,LSCR3       )
      CALL GETMEM('XI3S  ','FREE','REAL',KXI3S,LSCR3       )
      CALL GETMEM('XI4S  ','FREE','REAL',KXI4S,LSCR3       )
      CALL GETMEM('SBLTP ','FREE','INTE',KSBLTP,NSMST)
      CALL GETMEM('CBLTP ','FREE','INTE',KCBLTP,NSMST)
      CALL GETMEM('RHO1S ','FREE','REAL',KRHO1S,NACOB ** 2)
      CALL GETMEM('RHO1P ','FREE','REAL',KRHO1P,NACOB*(NACOB+1)/2)
      CALL GETMEM('XNATO ','FREE','REAL',KXNATO,NACOB **2)
      CALL GETMEM('RHO1S ','FREE','REAL',KRHO1SM,NACOB ** 2)
      CALL GETMEM('RHO1S ','FREE','REAL',KXNATSM,NACOB ** 2)
      CALL GETMEM('RHO1S ','FREE','REAL',KOCCSM,NACOB )
      CALL GETMEM('KLZSCR','FREE','INTE',KLZSCR,LZSCR)
      DO K12 = 1, 1
        CALL GETMEM('KLOCS ','FREE','INTE',KLOCSTR(K12),MAX_STR_OC_BLK)
      END DO
      DO I1234 = 1, 2
        CALL GETMEM('KLREO ','FREE','INTE',KLREO(I1234),MAX_STR_SPGP)
        CALL GETMEM('KLZ   ','FREE','INTE',KLZ(I1234),LZ)
      END DO
      CALL GETMEM('LBT_L  ','FREE','INTE',KLLBTL ,NTTS  )
      CALL GETMEM('LEBT_L ','FREE','INTE',KLLEBTL,NTTS  )
      CALL GETMEM('I1BT_L ','FREE','INTE',KLI1BTL,NTTS  )
      CALL GETMEM('IBT_L  ','FREE','INTE',KLIBTL ,8*NTTS)
      CALL GETMEM('SCLF_L ','FREE','REAL',KLSCLFCL,NTTS)
      CALL GETMEM('LBT_R  ','FREE','INTE',KLLBTR ,NTTS  )
      CALL GETMEM('LEBT_R ','FREE','INTE',KLLEBTR,NTTS  )
      CALL GETMEM('I1BT_R ','FREE','INTE',KLI1BTR,NTTS  )
      CALL GETMEM('IBT_R  ','FREE','INTE',KLIBTR ,8*NTTS)
      CALL GETMEM('SCLF_R ','FREE','REAL',KLSCLFCR,NTTS)

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NucInd(coor,kdc,ifgrd,ifhss,indgrd,indhss,jfgrd,jfhss,jndgrd,jndhss,tr,ifg)

use McKinley_global, only: sIrrep
use Index_Functions, only: iTri
use Symmetry_Info, only: nIrrep
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Coor(3,4)
integer(kind=iwp), intent(in) :: kdc, IndGrd(0:2,0:1,0:nIrrep-1), IndHss(0:1,0:2,0:1,0:2,0:nIrrep-1)
logical(kind=iwp), intent(in) :: IfGrd(0:2,0:1), IfHss(0:1,0:2,0:1,0:2)
logical(kind=iwp), intent(out) :: JfGrd(0:2,0:3), JfHss(0:3,0:2,0:3,0:2), Tr(0:3), IfG(0:3)
integer(kind=iwp), intent(out) :: JndGrd(0:2,0:3,0:nIrrep-1), JndHss(0:3,0:2,0:3,0:2,0:nIrrep-1)
#include "Molcas.fh"
#include "disp.fh"
integer(kind=iwp) :: iCar, iCent, iComp, iIrrep, iStop, jAtom, jCar, Maxi, Mini, nDisp, nnIrrep
logical(kind=iwp), external :: EQ, TF

!                                                                      *
!***********************************************************************
!                                                                      *
JndHss(:,:,:,:,:) = 0
JndGrd(:,:,:) = 0
JfHss(:,:,:,:) = .false.
JfGrd(:,:) = .false.
Tr(:) = .false.

! COPY CNTLR MATRIXES

JfGrd(:,0:1) = Ifgrd(:,0:1)
JndGrd(:,0:1,0:nIrrep-1) = IndGrd(:,0:1,0:nIrrep-1)
JfHss(0:1,:,0:1,:) = IfHss(0:1,:,0:1,:)
JndHss(0:1,:,0:1,:,0:nIrrep-1) = IndHss(0:1,:,0:1,:,0:nIrrep-1)

! Derivatives with respect to the operator is computed via the translational invariance.

nnIrrep = nIrrep
if (sIrrep) nnIrrep = 1
do iIrrep=0,nnIrrep-1
  nDisp = IndDsp(kdc,iIrrep)
  do iCar=0,2
    iComp = 2**iCar
    if (TF(kdc,iIrrep,iComp)) then
      nDisp = nDisp+1

      ! Reset flags for the basis set centers so that we
      ! will explicitly compute the derivatives with
      ! respect to those centers. Activate flag for the
      ! third center so that its derivative will be computed
      ! by the translational invariance.

      JndGrd(iCar,0:1,iIrrep) = abs(JndGrd(iCar,0:1,iIrrep))
      JndGrd(iCar,2,iIrrep) = -nDisp
      JfGrd(iCar,0:1) = .true.
      JfGrd(iCar,2) = .false.
    else
      JndGrd(iCar,2,iIrrep) = 0
    end if
  end do
end do

! The third center is calculated by translation invariance
! This requires the 2nd derivatives on the other centers.

do iCar=0,2
  do jAtom=0,2
    if (jAtom == 2) then
      iStop = iCar
    else
      iStop = 2
    end if
    do jCar=0,iStop
      do iIrrep=0,nIrrep-1
        if ((JndGrd(iCar,2,iIrrep) /= 0) .and. (JndGrd(jCar,jAtom,iIrrep) /= 0)) then
          JndHss(2,iCar,jAtom,jCar,iIrrep) = -iTri(abs(JndGrd(iCar,2,iIrrep)),abs(JndGrd(jCar,jAtom,iIrrep)))

          Tr(2) = .true.
          if (jAtom == 2) then
            Maxi = max(iCar,jCar)
            Mini = min(iCar,jCar)
            jfHss(0,Maxi,0,Mini) = .true.
            jfHss(1,Maxi,1,Mini) = .true.
            jfHss(1,iCar,0,jCar) = .true.
            jfHss(1,jCar,0,iCar) = .true.
          else
            Maxi = max(iCar,jCar)
            Mini = min(iCar,jCar)
            jfHss(jAtom,Maxi,jAtom,Mini) = .true.
            jfHss(1,iCar,0,jCar) = .true.
            jfHss(1,jCar,0,iCar) = .true.
          end if ! jAtom == 2
        end if ! if indgrd
      end do  ! iirrep
    end do ! jCar
  end do ! jAtom
end do ! iCar

IfG(0:1) = .true.
IfG(2:3) = .false.
do iCent=0,1
  if (EQ(Coor(1,iCent+1),Coor(1,3))) then
    IfG(iCent) = .false.
    JfGrd(:,iCent) = .false.
    JfHss(iCent,:,:,:) = .false.
    JfHss(:,:,iCent,:) = .false.
    JndGrd(:,iCent,0:nIrrep-1) = 0
    JndHss(iCent,:,:,:,0:nIrrep-1) = 0
    JndHss(:,:,iCent,:,0:nIrrep-1) = 0
  end if ! uf eq
end do !icent

return

end subroutine NucInd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_P_SetVecInf(nVec,iSym,iPass)
C
C     Purpose: set global and local info for vectors.
C
      Implicit None
      Integer nVec, iSym, iPass
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
#include "cho_para_info.fh"
#include "choglob.fh"
      Integer  Cho_P_IndxParentDiag
      External Cho_P_IndxParentDiag

      Integer iV, iVec, iAB

      Integer i, j, iQuAB, IndRed
      iQuAB(i,j)=iWork(ip_iQuAB-1+MaxQual*(j-1)+i)
      IndRed(i,j)=iWork(ip_IndRed-1+mmBstRT*(j-1)+i)

      If (Cho_Real_Par) Then
C Set global vector information (by swapping index arrays)
         Call Cho_P_IndxSwp()
         Do iV = 1,nVec
            iVec = NumCho_G(iSym) + iV
            iAB = IndRed(iQuAB(iV,iSym),2)
            Call Cho_SetVecInf(iWork(ip_InfVec),MaxVec,InfVec_N2,nSym,
     &                         iVec,iSym,iAB,iPass,2)
         End Do
         Call Cho_P_IndxSwp()
C Set local vector information
         Do iV = 1,nVec
            iVec = NumCho_G(iSym) + iV
            iAB = Cho_P_IndxParentDiag(iV,iSym)
            Call Cho_SetVecInf(iWork(ip_InfVec),MaxVec,InfVec_N2,nSym,
     &                         iVec,iSym,iAB,iPass,2)
         End Do
      Else
         Do iV = 1,nVec
            iVec = NumCho(iSym) + iV
            iAB = IndRed(iQuAB(iV,iSym),2)
            Call Cho_SetVecInf(iWork(ip_InfVec),MaxVec,InfVec_N2,nSym,
     &                         iVec,iSym,iAB,iPass,2)
         End Do
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

subroutine Get_TUVX(PUVX,TUVX)
!***********************************************************************
!                                                                      *
!     extract the subset of ERIs (tu!vx) from the set (pu!vx)          *
!                                                                      *
!     calling arguments:                                               *
!     PUVX    : input, array of real                                   *
!               ERIs with indices (pu!vx)                              *
!               (three active, one general)                            *
!     TUVX    : output, array of real                                  *
!               ERIs with indices (tu!vx)                              *
!               (four active)                                          *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: PUVX(*)
real(kind=wp), intent(_OUT_) :: TUVX(*)
#include "rasdim.fh"
#include "general.fh"
integer(kind=iwp) :: iAsh, iIsh, iiT, iiU, iiV, iiX, ijSym, iOrb, iP, iPUVX, iStack, iSym, iT, iTemp, iTU, iTUVX, iU, iV, iVX, iX, &
                     jAsh, jSym, kAsh, kl_Orb_pairs, klSym, kSym, lAsh, lMax, lSym, off_Ash(mxSym), off_PUVX(mxSym)

! generate offsets
iStack = 0
do iSym=1,nSym
  off_Ash(iSym) = iStack
  iStack = iStack+nAsh(iSym)
end do

iStack = 0
do iSym=1,nSym
  off_PUVX(iSym) = iStack
  iOrb = nOrb(iSym)
  do jSym=1,nSym
    jAsh = nAsh(jSym)
    ijSym = 1+ieor(iSym-1,jSym-1)
    do kSym=1,nSym
      kAsh = nAsh(kSym)
      do lSym=1,kSym
        lAsh = nAsh(lSym)
        klSym = 1+ieor(kSym-1,lSym-1)
        if (ijSym == klSym) then
          kl_Orb_pairs = kAsh*lAsh
          if (kSym == lSym) kl_Orb_pairs = (kAsh*kAsh+kAsh)/2
          iStack = iStack+iOrb*jAsh*kl_Orb_pairs
        end if
      end do
    end do
  end do
end do

! select integrals with all 4 indices active

do iSym=1,nSym
  iOrb = nOrb(iSym)
  iAsh = nAsh(iSym)
  iIsh = nIsh(iSym)
  iPUVX = off_PUVX(iSym)
  do jSym=1,nSym
    jAsh = nAsh(jSym)
    ijSym = 1+ieor(iSym-1,jSym-1)
    do kSym=1,nSym
      kAsh = nAsh(kSym)
      lSym = 1+ieor(ijSym-1,kSym-1)
      lAsh = nAsh(lSym)

      if ((lSym <= kSym) .and. (iAsh*jAsh*kAsh*lAsh /= 0)) then

        !write(LF,*) 'sym(p,w,x,y),offset= ',isym,jsym,ksym,lsym,iPUVX
        !call recprt('(pw|xy)','(1P,5ES16.8)',PUVX(iPUVX+1),iorb*jAsh,kAsh*lAsh+Min(ijSym-2,0)*kAsh*(lAsh-1)/2)

        do iV=1,kAsh
          lMax = lAsh
          if (kSym == lSym) lMax = iV
          do iX=1,lMax
            do iU=1,jAsh
              do iP=1,iOrb
                iT = iP-iIsh
                iPUVX = iPUVX+1
                if ((iT > 0) .and. (iT <= iAsh)) then
                  iiT = iT+off_Ash(iSym)
                  iiU = iU+off_Ash(jSym)
                  if (iiU > iiT) then
                    iiT = iU+off_Ash(jSym)
                    iiU = iT+off_Ash(iSym)
                  end if

                  iTU = iiU+nTri_Elem(iiT-1)
                  iiV = iV+off_Ash(kSym)
                  iiX = iX+off_Ash(lSym)
                  if (iiX > iiV) then
                    iiV = iX+off_Ash(lSym)
                    iiX = iV+off_Ash(kSym)
                  end if
                  iVX = iiX+nTri_Elem(iiV-1)
                  if (iVX > iTU) then
                    iTemp = iTU
                    iTU = iVX
                    iVX = iTemp
                  end if
                  iTUVX = iVX+nTri_Elem(iTU-1)
                  TUVX(iTUVX) = PUVX(iPUVX)
                end if

              end do
            end do
          end do
        end do
      end if

    end do
  end do
end do

return

end subroutine Get_TUVX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine NAGrd_mck(
#define _CALLING_
#include "grd_mck_interface.fh"
     &                    )
************************************************************************
*                                                                      *
* Object: to compute the gradient of the nuclear attraction integrals. *
*          Something is wrong here                                     *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             October 1991                                             *
*              Anders Bernhardsson 1995                                *
************************************************************************
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External TNAI1, Fake, Cff2D
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "disp.fh"
#include "disp2.fh"

#include "grd_mck_interface.fh"

*     Local variables
      Integer iDCRT(0:7),Index(3,4)
      Real*8 C(3), TC(3)
      Logical DiffCnt, EQ, Tr(4)
      Real*8 Coora(3,4), Coori(3,4), CoorAC(3,2)
      Integer iAnga(4), JndGrd(3,4,0:7), mOp(4), iuvwx(4),
     &        JndHss(4,3,4,3,0:7), kndgrd(3,4,0:7)
      Logical JfGrd(3,4),kfgrd(3,4),jfg(4), JfHss(4,3,4,3)
      Integer, Parameter:: nPAO=1
      Real*8 :: PAO(nPAO)   ! Dummy array
      Integer, Parameter:: nHess=1
      Real*8 :: Hess(nHess) ! Dummy array
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
c     iRout = 150
c     iPrint = nPrint(iRout)
*
c     If (iPrint.ge.99) Then
c        Write (*,*) ' In NAGrd: nArr=',nArr
c     End If
      nGrad=lDisp(0)
      Call GetMem('Grad','Allo','REAL',ipGrad,nGrad)
*
      nRys=nHer
*
      nip = 1
      ipA = nip
      nip = nip + nAlpha*nBeta
      ipB = nip
      nip = nip + nAlpha*nBeta
      If (nip-1.gt.nArr)
     &   Write (6,*) ' nip-1.gt.nArr'
      nArray = nArr - nip +1
*
      iIrrep = 0
      iAnga(1) = la
      iAnga(2) = lb
      iAnga(3) = 0
      iAnga(4) = 0
*  Dummies
      Call ICopy(144*nIrrep,[0],0,JndHss,1)
      Call LCopy(144,[.false.],0,jfHss,1)
*
      call dcopy_(3,A,1,Coora(1,1),1)
      call dcopy_(3,RB,1,Coora(1,2),1)
      call dcopy_(3,A,1,Coori(1,1),1)
      call dcopy_(3,RB,1,Coori(1,2),1)
      If (la.ge.lb) Then
         call dcopy_(3,A,1,CoorAC(1,1),1)
      Else
         call dcopy_(3,RB,1,CoorAC(1,1),1)
      End If
      iuvwx(1) = iu
      iuvwx(2) = iv
      mOp(1) = nOp(1)
      mOp(2) = nOp(2)
*
      ipAOff = ipA
      Do 200 iBeta = 1, nBeta
         call dcopy_(nAlpha,Alpha,1,Array(ipAOff),1)
         ipAOff = ipAOff + nAlpha
 200  Continue
*
      ipBOff = ipB
      Do 210 iAlpha = 1, nAlpha
         call dcopy_(nBeta,Beta,1,Array(ipBOff),nAlpha)
         ipBOff = ipBOff + 1
 210  Continue
*
*-----Loop over nuclear centers
*
      nb=nZeta*nElem(la)*nElem(lb)
      kdc = 0
      Do 100 kCnttp = 1, nCnttp
         If (dbsc(kCnttp)%Charge.eq.Zero) Go To 111
         Do 101 kCnt = 1, dbsc(kCnttp)%nCntr
            C(1:3)=dbsc(kCnttp)%Coor(1:3,kCnt)
            DiffCnt=(IfGrad(iDCar,1).or.IfGrad(iDCar,2))
            If ((.not.DiffCnt).and.((kdc+kCnt).ne.iDCnt)) Goto 101
*
            Call DCR(LmbdT,iStabM,nStabM,
     &               dc(kdc+kCnt)%iStab,dc(kdc+kCnt)%nStab,iDCRT,nDCRT)
*           Fact = -dbsc(kCnttp)%Charge*DBLE(nStabM*nIrrep) /
*    &             DBLE(LmbdT*dc(kdc+kCnt)%nStab)
            Fact = -dbsc(kCnttp)%Charge*DBLE(nStabM) /
     &             DBLE(LmbdT)
c           If (iPrint.ge.99) Then
c              Write (*,*) ' Charge=',dbsc(kCnttp)%Charge
c              write(*,*)   'NZeta=',nzeta
c              Write(*,*)    'NrOp=',nrop
c              Write (*,*) ' Fact=',Fact
c           End If
            iuvwx(3) = dc(kdc+kCnt)%nStab
            iuvwx(4) = dc(kdc+kCnt)%nStab
            Call LCopy(12,[.false.],0,JFgrd,1)
            Call ICopy(12*nIrrep,[0],0,jndGrd,1)
            Do iCnt = 1, 2
               JfGrd(iDCar,iCnt) = IfGrad(iDCar,iCnt)
            End Do
            Do ICnt=1,2
               If (IfGrad(idcar,iCnt)) Then
                 Do iIrrep=0,nIrrep-1
                   jndGrd(iDCar,iCnt,iIrrep)=IndGrd(iIrrep)
                 End Do
               End IF
            End Do
*
            Tr(1)=.false.
            Tr(2)=.false.
            Tr(3)=.false.
            Tr(4)=.false.
            If ((kdc+kCnt).eq.iDCnt) Then
                 Tr(3)=.true.
                 JfGrd(iDCar,1) = .true.
                 JfGrd(iDCar,2) = .true.
                 Do iIrrep=0,nIrrep-1
                 jndGrd(iDCar,3,iIrrep) = - IndGrd(iIrrep)
                 End Do
            End If
*
            Do 102 lDCRT = 0, nDCRT-1
               Call lCopy(12,JfGrd,1,kfGrd,1)
               Call iCopy(12*nIrrep,JndGrd,1,kndgrd,1)
               mOp(3) = NrOpr(iDCRT(lDCRT))
               mOp(4) = mOp(3)
               Call OA(iDCRT(lDCRT),C,TC)
               call dcopy_(3,TC,1,CoorAC(1,2),1)
               call dcopy_(3,TC,1,Coora(1,3),1)
               call dcopy_(3,TC,1,Coora(1,4),1)
               call dcopy_(3,TC,1,Coori(1,3),1)
               call dcopy_(3,TC,1,Coori(1,4),1)
               If (Eq(A,RB).and.EQ(A,TC)) goto 102
               If (EQ(A,TC)) Then
                 kfGrd(iDCar,1) = .false.
                 Do iIrrep=0,nIrrep-1
                  kndGrd(iDCar,1,iirrep)=0
                 End Do
               End If
               If (EQ(RB,TC)) Then
                 kfGrd(iDCar,2) = .false.
                 Do iIrrep=0,nIrrep-1
                  kndgrd(iDCar,2,iIrrep)=0
                 End Do
               End If
*
               If (kfGrd(idcar,1)) Then
                JFG(1)=.true.
               Else
                JFG(1)=.false.
               End If
               If (kfGrd(idcar,2)) Then
                JFG(2)=.true.
               Else
                JFG(2)=.false.
               End If
               JFG(3)=.false.
               JFG(4)=.false.
               Call Rysg2(iAnga,nRys,nZeta,
     &                  Array(ipA),Array(ipB),[One],[One],
     &                  Zeta,ZInv,nZeta,[One],[One],1,
     &                  P,nZeta,TC,1,Coori,Coora,CoorAC,
     &                  Array(nip),nArray,
     &                  TNAI1,Fake,Cff2D,
     &                  PAO,nPAO,Hess,nHess,kfGrd,kndGrd,
     &                  JfHss,JndHss,mOp,iuvwx,Jfg,
     &                  nGr,Index,.true.,.false.,tr)
*
               Do iElem = 1, nElem(la)*nElem(lb)*ngr
                  Do iZeta = 1, nZeta
                     tfac = Two*rKappa(iZeta)*Pi*ZInv(iZeta)
                     indi=(iElem-1)*nZeta+iZeta
                     Array(nip+indi-1) = tfac * Array(nip+indi-1)
                  End Do
               End Do
*
#ifdef _DEBUGPRINT_
              Call RecPrt('In NaGrd PI',' ',Array(nip),nb,3)
              Call RecPrt('In NaGrd PI',' ',Final,nb,nrOp)
#endif
               Call SmAdNa(Array(nip),nb,Final,
     &            mop,loper,KndGrd,iuvwx,kfGrd,Index,
     &            idcar,Fact,JFG,tr)
c              IF (iPrint.gt.23)
c    &            Call RecPrt('In NaGrd FI',' ',Final,nb,nrOp)
 102        Continue
 101     Continue
 111     kdc = kdc + dbsc(kCnttp)%nCntr
 100  Continue
      Call GetMem('Grad','Free','REAL',ipGrad,nGrad)
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Ccoor)
         Call Unused_integer(nOrdOp)
         Call Unused_logical_array(Trans)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Martin Schuetz                                   *
!               2017, Roland Lindh                                     *
!               2018, Ignacio Fdez. Galvan                             *
!***********************************************************************

!#define _DEBUGPRINT_
!#define _DIAGONAL_ONLY_
subroutine SOrUpV(V,lvec,W,Mode,UpTp)
!***********************************************************************
!     for Ref., see T.H. Fischer and J. Almloef, JPC 96, 9768 (1992)   *
!               doi:10.1021/j100203a036                                *
!                                                                      *
!     purpose: Second Order Updated vector V using BFGS and            *
!              diagonal Hessian of Orbital Rotations                   *
!     input  : V          -> input vector                              *
!              HDiag      -> initial diagonal Hessian                  *
!              lvec       -> lengths of vectors delta, grad, HDiag & V *
!              Mode       -> update mode, see below                    *
!     The routine expects, that grad(n) and delta(n-1) are already     *
!     stored on the appropriate linked lists LLdGrd & LLDelt.          *
!     output:  W          -> H(n)V with H(n) SOrUp (inverse) Hessian   *
!                            after n-1 updates                         *
!                            mem has to be allocated from caller side  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     Adapted to work both for d=-H(-1)g and g = -Hd                   *
!     depending on the value of MODE                                   *
!     Mode='DISP':  d=-H(-1)g    BFGS update for the inverse Hessian   *
!     Mode='GRAD':  g=-Hd        DFP  update for the Hessian           *
!     2017, Roland Lindh, Harvard, Cambridge                           *
!                                                                      *
!     Adapted to do both BFGS and DFP updates depending on the value   *
!     of UPTP                                                          *
!     UpTp='BFGS':  BFGS update                                        *
!     UpTp='DFP ':  DFP update                                         *
!     Mode='DISP':  d=-H(-1)g    update for the Hessian                *
!     Mode='GRAD':  g=-Hd        update for the inverse Hessian        *
!***********************************************************************

use LnkLst, only: GetNod, iVPtr, LLDelt, LLdGrd, LLLen, LLy, LstPtr, PutVec, SCF_V
use Interfaces_SCF, only: yHx
use InfSCF, only: HDiag, Iter, IterSO, TimFld
use SCFFiles, only: LuDel, LuDGd
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: lvec
real(kind=wp), intent(in) :: V(lVec)
real(kind=wp), intent(out) :: W(lvec)
character(len=4), intent(in) :: Mode, UpTp
integer(kind=iwp) :: i, inode, ipdel, ipdgd, ipynm1, it, leny, LL1, LL2, Lu1
real(kind=wp) :: Cpu1, Cpu2, S(6), T(4), Tim1, Tim2, Tim3
logical(kind=iwp) :: diag, Inverse_H, updy
character(len=8) :: Mode_Old = ''
real(kind=wp), allocatable :: SOGrd(:), SODel(:), SOScr(:)
real(kind=wp), parameter :: Thr = 1.0e-9_wp
real(kind=wp), external :: ddot_

if (DDot_(lVec,V,1,V,1) == Zero) then
  W(:) = Zero
  return
end if
call Timing(Cpu1,Tim1,Tim2,Tim3)
S(:) = Zero
T(:) = Zero

! Dummy initializations

Inverse_H = .false.
Lu1 = -1
LL1 = -1
LL2 = -1

! This section will control the mode

if (Mode == 'DISP') then

  ! Mode for computation d = -H(-1)g

  Inverse_H = .true.
  Lu1 = LuDel
  LL1 = LLDelt
  LL2 = LLdGrd

else if (Mode == 'GRAD') then

  ! Mode for computation g = -Hd

  Inverse_H = .false.
  Lu1 = LudGd
  LL1 = LLdGrd
  LL2 = LLDelt

end if

if (Lu1 < 0) then
  write(u6,*) 'SOrUpV: Illegal mode'
  call Abend()
end if

if ((UpTp /= 'BFGS') .and. (UpTp /= 'DFP ')) then
  write(u6,*) 'SOrUpV: Illegal update type',UpTp
  call Abend()
end if

if ((iterso > 1) .and. (Mode//UpTp /= Mode_Old)) then
  write(u6,*) 'IterSO=',IterSO
  write(u6,*) 'Mode_Old:',Mode_Old
  write(u6,*) 'Mode//UpTp:',Mode//UpTp
  write(u6,*) 'SOrUpV: Illegal mode switch'
  call Abend()
end if

! Steps denoted as in the reference paper!

! (1): initialize w=HDiag*v

if (Inverse_H) then
  do i=1,lvec
    if (abs(HDiag(i)) < Thr) then
      W(i) = 1.0e2_wp*V(i)
    else
      W(i) = V(i)/HDiag(i)
    end if
  end do
else
  !do i=1,lvec
  !  W(i) = HDiag(i)*V(i)
  !end do
  call yHx(V,W,lvec)
end if
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*)
call Check_Vec(W,lVec,'H_{n-1}v')
call NrmClc(V,lVec,'SORUPV','V')
call NrmClc(HDiag,lVec,'SORUPV','HDiag')
call NrmClc(W,lVec,'SORUPV','W')
#endif

diag = (iterso == 1)
#ifdef _DIAGONAL_ONLY_
write(u6,*) ' SorUpV: Only diagonal approximation'
diag = .true.
#endif
if (diag) then
  ! (2): no further work required this time
  call Timing(Cpu2,Tim1,Tim2,Tim3)
  TimFld(7) = TimFld(7)+(Cpu2-Cpu1)
  Mode_Old = Mode//UpTp
  return
end if

! need three vectors of length lvec as scratch space

call mma_allocate(SOGrd,lvec,Label='SOGrd')
call mma_allocate(SODel,lvec,Label='SODel')
call mma_allocate(SOScr,lvec,Label='SOScr')

call GetNod(iter-1,LL2,inode)
if (inode == 0) call Error_Handling()
call iVPtr(SOGrd,lvec,inode)

! (3b): initialize y(n-1)=HDiag*dGrd(n-1) ...

if (Inverse_H) then
  do i=1,lvec
    if (abs(HDiag(i)) < Thr) then
      SOScr(i) = 1.0e2_wp*SOGrd(i)
    else
      SOScr(i) = SOGrd(i)/HDiag(i)
    end if
  end do
else
  !do i=1,lvec
  !  SOScr(i) = HDiag(i)*SOGrd(i)
  !end do
  call yHx(SOGrd,SOScr,lvec)
end if
#ifdef _DEBUGPRINT_
!call RecPrt('Init y(n-1)',' ',SOScr,1,lVec)
call NrmClc(SOScr,lVec,'SOrUpV','Init y(n-1)')
call Check_vec(SOScr,lVec,'y_{n-1}=H_{0}Delta_{n-1}')
#endif

! and store it on appropriate linked list

leny = LLLen(LLy)
call PutVec(SOScr,lvec,iter-1,'NOOP',LLy)
if (leny == LLLen(LLy)) then
  ! already there, so we don't have to recalculate later
  updy = .false.
else
  ! new listhead generated in ipy, we have to update
  updy = .true.
end if

! (4): now loop over 1..n-2 iterations.

#ifdef _DEBUGPRINT_
write(u6,*) 'IterSO=',IterSO
#endif
do it=iter-iterso+1,iter-2

  ! fetch delta(i), dGrd(i) and y(i) from corresponding LLists

  call GetNod(it,LL1,inode)
  if (inode == 0) call Error_Handling()
  call iVPtr(SODel,lvec,inode)

  call GetNod(it,LL2,inode)
  if (inode == 0) call Error_Handling()
  call iVPtr(SOGrd,lvec,inode)

  call GetNod(it,LLy,inode)
  if (inode == 0) call Error_Handling()
  call iVPtr(SOScr,lvec,inode)

  ! calculate S_k and T_k dot products.
  ! (note that S(2) is the inverse of the one in the paper

  S(1) = ddot_(lvec,SODel,1,SOGrd,1)
  if (abs(S(1)) < Thr) then
    S(1) = Zero
    !S(1) = One/Thr
  else
    S(1) = One/S(1)
  end if
  S(2) = ddot_(lvec,SOGrd,1,SOScr,1)
  S(3) = ddot_(lvec,SODel,1,V,1)
  S(4) = ddot_(lvec,SOScr,1,V,1)
  if (updy) then

    ! here we have to reload dGrd(n-1) from llist, but this
    ! for sure is a memory hit, since it was put there last

    ipdgd = LstPtr(iter-1,LL2)

    S(5) = ddot_(lvec,SODel,1,SCF_V(ipdgd)%A,1)
    S(6) = ddot_(lvec,SOScr,1,SCF_V(ipdgd)%A,1)
  else
    S(5) = Zero
    S(6) = Zero
  end if
# ifdef _DEBUGPRINT_
  write(u6,*) 'it=',it
  write(u6,*) '(S(i),i=1,6)=',(S(i),i=1,6)
# endif

  if ((Mode_Old == 'DISPBFGS') .or. (Mode_Old == 'GRADDFP ')) then
    if (abs(S(2)) < Thr) then
      S(2) = One
      !S(2) = One+S(1)/Thr
    else
      S(2) = One+S(1)*S(2)
    end if
    T(2) = S(1)*S(3)
    T(4) = S(1)*S(5)
    T(1) = S(2)*T(2)-S(1)*S(4)
    T(3) = S(2)*T(4)-S(1)*S(6)
  else if ((Mode_Old == 'DISPDFP ') .or. (Mode_Old == 'GRADBFGS')) then
    ! DFP update (or BFGS for the Hessian) use
    ! a slightly different and simpler formula
    if (abs(S(2)) < Thr) then
      S(2) = Zero
      S(2) = One/Thr
    else
      S(2) = One/S(2)
    end if
    T(1) = S(1)*S(3)
    T(2) = S(2)*S(4)
    T(3) = S(1)*S(5)
    T(4) = S(2)*S(6)
  end if

  ! Compute w and y(n-1)

# ifdef _DEBUGPRINT_
  write(u6,*) '(T(i),i=1,4)=',(T(i),i=1,4)
  call Check_Vec(W,lVec,'W(0)')
  W(:) = W(:)+T(1)*SODel(:)
  call Check_Vec(W,lVec,'W(1)')
  W(:) = W(:)-T(2)*SOScr(:)
  call Check_Vec(W,lVec,'W(2)')
# else
  W(:) = W(:)+T(1)*SODel(:)-T(2)*SOScr(:)
# endif
  if (updy) then

    ! here we have to reload y(n-1) from llist, but this
    ! for sure is a memory hit, since it was put there last
    ! -> we operate directly on the memory cells of the LList,
    ! where y(n-1) resides.

    ipynm1 = LstPtr(iter-1,LLy)
    SCF_V(ipynm1)%A(:) = SCF_V(ipynm1)%A(:)+T(3)*SODel(:)-T(4)*SOScr(:)
  end if

end do

! (5): reload y(n-1), delta(n-1) & dGrd(n-1) from linked list.
! these all are memory hits, of course

ipynm1 = LstPtr(iter-1,LLy)
ipdel = LstPtr(iter-1,LL1)
ipdgd = LstPtr(iter-1,LL2)
#ifdef _DEBUGPRINT_
write(u6,*)
!call RecPrt('y(n-1)',' ',SCF_V(ipynm1)%A,1,lVec)
call NrmClc(SCF_V(ipynm1)%A,lVec,'SOrUpV','y(n-1)')
if (Mode == 'DISP') then
  !call RecPrt('dX(n-1)',' ',SCF_V(ipdel)%A,1,lVec)
  !call RecPrt('dg(n-1)',' ',SCF_V(ipdgd)%A,1,lVec)
  call NrmClc(SCF_V(ipdel)%A,lVec,'SOrUpV','dX(n-1)')
  call NrmClc(SCF_V(ipdgd)%A,lVec,'SOrUpV','dg(n-1)')
else
  !call RecPrt('dg(n-1)',' ',SCF_V(ipdel)%A,1,lVec)
  !call RecPrt('dX(n-1)',' ',SCF_V(ipdgd)%A,1,lVec)
  call NrmClc(SCF_V(ipdel)%A,lVec,'SOrUpV','dg(n-1)')
  call NrmClc(SCF_V(ipdgd)%A,lVec,'SOrUpV','dX(n-1)')
end if
write(u6,*)
call Check_Vec(SCF_V(ipdel)%A,lvec,'delta_{n-1}')
call Check_Vec(SCF_V(ipdgd)%A,lvec,'Delta_{n-1}')
#endif

! calculate diverse dot products...

S(1) = ddot_(lvec,SCF_V(ipdel)%A,1,SCF_V(ipdgd)%A,1)
!write(u6,*) 'S(1)=',S(1)
if (abs(S(1)) < Thr) then
  S(1) = Zero
  !S(1) = One/Thr
else
  S(1) = One/S(1)
end if
!write(u6,*) 'S(1)=Alpha=',S(1)
!call Check_vec(SCF_V(ipynm1)%A,lVec,'y_{n-1}=H_{n-1}Delta_{n-1}')
S(2) = ddot_(lvec,SCF_V(ipdgd)%A,1,SCF_V(ipynm1)%A,1)
!write(u6,*) 'S(2)=Delta_{n-1}^T*y_{n-1}=',S(2)
S(3) = ddot_(lvec,SCF_V(ipdel)%A,1,V,1)
!write(u6,*) 'S(3)=delta_{n-1}^T*v=',S(3)
S(4) = ddot_(lvec,SCF_V(ipynm1)%A,1,V,1)
!write(u6,*) 'S(4)=y_{n-1}^T*v=',S(4)

#ifdef _DEBUGPRINT_
write(u6,*) '(S(i),i=1,4)=',(S(i),i=1,4)
#endif

if ((Mode_Old == 'DISPBFGS') .or. (Mode_Old == 'GRADDFP ')) then
  if (abs(S(2)) < Thr) then
    S(2) = One
    !S(2) = One+S(1)/Thr
  else
    S(2) = One+S(1)*S(2)
  end if
  !write(u6,*) 'S(2)(1+...)=',S(2)
  !write(u6,*)
  T(2) = S(1)*S(3)
  T(1) = S(2)*T(2)-S(1)*S(4)
  !write(u6,*) 'T(:)=',T(:)
else if ((Mode_Old == 'DISPDFP ') .or. (Mode_Old == 'GRADBFGS')) then
  if (abs(S(2)) < Thr) then
    S(2) = Zero
    S(2) = One/Thr
  else
    S(2) = One/S(2)
  end if
  T(1) = S(1)*S(3)
  T(2) = S(2)*S(4)
end if

! update the vector w

#ifdef _DEBUGPRINT_
write(u6,*) '(T(i),i=1,2)=',(T(i),i=1,2)
call Check_Vec(W,lVec,'W(2), again')
W(:) = W(:)+T(1)*SCF_V(ipdel)%A(:)
call Check_Vec(SCF_V(ipdel)%A,lvec,'delta_{n-1}')
call Check_Vec(W,lVec,'W(3)')
W(:) = W(:)-T(2)*SCF_V(ipdel)%A(:)
call Check_Vec(SCF_V(ipynm1)%A,lvec,'y_{n-1}')
!call RecPrt('The final W array',' ',W,1,lVec)
call NrmClc(W,lVec,'SOrUpV','The final W array')
call Check_Vec(W,lVec,'W(final)')
#else
W(:) = W(:)+T(1)*SCF_V(ipdel)%A(:)-T(2)*SCF_V(ipynm1)%A(:)
#endif

! so, we've made it, let's clean up workbench

call mma_deallocate(SOGrd)
call mma_deallocate(SODel)
call mma_deallocate(SOScr)
!
call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(7) = TimFld(7)+(Cpu2-Cpu1)

return

contains

! Error handling
subroutine Error_handling()

  ! Hmmm, no entry found in LList, that's strange
  write(u6,*) 'SOrUpV: no entry found in LList'
  call Abend()

end subroutine Error_handling

#ifdef _DEBUGPRINT_
subroutine Check_Vec(Vec,nVec,Label)

  integer(kind=iwp), intent(in) :: nVec
  real(kind=wp), intent(in) :: Vec(nVec)
  character(len=*), intent(in) :: Label

  write(u6,*) 'Norm of ',Label,' is : ',sqrt(DDot_(nVec,Vec,1,Vec,1))

end subroutine Check_Vec
#endif

end subroutine Sorupv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Markus P. Fuelscher                              *
************************************************************************
      Subroutine TrcPrt(Title,FmtIn,A,nRow,nCol)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Print the row and column norms of a rectangular matrix           *
*                                                                      *
*     calling arguments                                                *
*     Title  : character string containing a title                     *
*              If the string is empty now title will be printed        *
*     A      : retangular matrix of double precision reals             *
*     nRow   : row dimension of matrix A                               *
*     nCol   : column dimension of matrix A                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher                                                  *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "standard_iounits.fh"
#include "real.fh"
      Character*(*) Title
      Character*(*) FmtIn
      Dimension A(nRow,nCol)
      Integer StrnLn
      Parameter ( lPaper = 70 )
      Character*(lPaper) Line
      Character*20 FMT
*----------------------------------------------------------------------*
*     print the title                                                  *
*----------------------------------------------------------------------*
      lTitle=StrnLn(Title)
      If ( lTitle.gt.0 ) then
         Do 10 i=1,lPaper
             Line(i:i)=' '
10       Continue
         lLeft=1
         Do 20 i=lTitle,1,-1
            If ( Title(i:i).ne.' ' ) lLeft=i
20       Continue
         lLeft=lLeft-1
         Do 25 i=1,lPaper
            If ( i+lLeft.le.lTitle ) Line(i:i)=Title(i+lLeft:i+lLeft)
25       Continue
         Write(LuWr,*)
         Write(LuWr,'(2X,A)') Line
         Do 30 i=1,StrnLn(Line)
            Line(i:i)='-'
30       Continue
         Write(LuWr,'(2X,A)') Line
         Write(LuWr,'(2X,A,I4,A,I4)') 'mat. size = ',nRow,'x',nCol
      End If
*----------------------------------------------------------------------*
*     determine the printing format                                    *
*----------------------------------------------------------------------*
      lFmt=StrnLn(FmtIn)
      If ( lFmt.ne.0 ) then
         FMT=FmtIn
      Else
         Amax=A(1,1)
         Amin=A(1,1)
         Do 40 j=1,nCol
            Do 50 i=1,nRow
               Amax=Max(Amax,A(i,j))
               Amin=Min(Amin,A(i,j))
50          Continue
40       Continue
         Scal=Dble(Max(nRow,nCol))
         Amax=Amax*Amax*Scal
         Amin=Amin*Amin*Scal
         Pmax=0d0
         if ( Abs(Amax).gt.1.0D-72 ) Pmax=Log10(Abs(Amax))
         iPmax=Int(1d0+Pmax)
         iPmax=Max(1,iPmax)
         Pmin=0d0
         If ( Abs(Amin).gt.1.0D-72 ) Pmin=Log10(Abs(Amin))
         iPmin=Int(1d0+Pmin)
         iPmin=Max(1,iPmin)
         nDigit=14
         nDecim=Min(8,nDigit-Max(iPmin,iPmax))
         If ( Amax.lt.0d0 ) iPmax=iPmax+1
         If ( Amin.lt.0d0 ) iPmin=iPmin+1
         lNumbr=Max(iPmin,iPmax)+nDecim+2
         nCols=10
         lLine=nCols*lNumbr
         If ( lLine.gt.lPaper ) then
            If ( lLine.le.lPaper+nCols .and. nDecim.gt.1 ) then
               nDecim=nDecim-1
               lNumbr=Max(iPmin,iPmax)+nDecim
               lItem=Max(lNumbr,lPaper/nCols)
            Else
               nCols=5
               lItem=Max(lNumbr,lPaper/nCols)
            End If
         Else
            lItem=lNumbr
         End If
         Write(FMT,'(A,   I4.4,  A, I4.4,  A, I4.4,   A)')
     &             '(2X,',nCols,'F',lItem,'.',nDecim,')'
      End if
*----------------------------------------------------------------------*
*     print the data                                                   *
*----------------------------------------------------------------------*
#ifdef _DEBUGPRINT_
       Write(LuWr,*)
       Write(LuWr,'(E24.17)') DDot_(nCol*nRow,A,1,A,1),
     &                        DDot_(nCol*nRow,A,1,[One],0)
#else
       Write(LuWr,*)
       Write(LuWr,'(2X,A)') 'row norms'
       Write(LuWr,FMT)(DDot_(nCol,A(i,1),nRow,A(i,1),nRow),i=1,nRow)
       Write(LuWr,'(2X,A)') 'column norms'
       Write(LuWr,FMT)(DDot_(nRow,A(1,i),1,A(1,i),1),i=1,nCol)
#endif
*----------------------------------------------------------------------*
*     End procedure                                                    *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SetUp_CASPT2_Tra(nSym_,nBas_,nOrb_,nIsh_,nAsh_,nFro_,nDel_,CMO,lthCMO,LuIntM_,LuHlf1_,LuHlf2_,LuHlf3_)

use Symmetry_Info, only: Mul_SI => Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nSym_, nBas_(8), nOrb_(8), nIsh_(8), nAsh_(8), nFro_(8), nDel_(8), lthCMO, LuIntM_
integer(kind=iwp), intent(inout) :: LuHlf1_, LuHlf2_, LuHlf3_
real(kind=wp), intent(in) :: CMO(lthCMO)
integer(kind=iwp), external :: ip_of_Work
#include "rasdim.fh"
#include "caspt2.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
nSym = nSym_
nBas(1:nSym) = nBas_(1:nSym)
nOrb(1:nSym) = nOrb_(1:nSym)
nFro(1:nSym) = nFro_(1:nSym)
nDel(1:nSym) = nDel_(1:nSym)
nAsh(1:nSym) = nAsh_(1:nSym)
nIsh(1:nSym) = nIsh_(1:nSym)
nOsh(1:nSym) = nAsh_(1:nSym)+nIsh_(1:nSym)
!                                                                      *
!***********************************************************************
!                                                                      *
Mul(:,:) = Mul_SI(:,:)
!                                                                      *
!***********************************************************************
!                                                                      *
LCMO = ip_of_Work(CMO(1))
nCMO = lthCMO
!                                                                      *
!***********************************************************************
!                                                                      *
! Open the temporary files here! This is where they get their final
! unit numbers.

call DANAME_MF_wa(LuHlf1_,'LUHLF1')
call DANAME_MF_wa(LuHlf2_,'LUHLF2')
call DANAME_MF_wa(LuHlf3_,'LUHLF3')
LuHlf1 = LuHlf1_
LuHlf2 = LuHlf2_
LuHlf3 = LuHlf3_

! Observe that LuIntM_ should be opened prior to this call!

LuIntM = LuIntM_
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine SetUp_CASPT2_Tra

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CNF2TXT(IFORM,NORB,NCLS,NOPN,ICONF,LENGTH,TEXT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ICONF(*)
      CHARACTER*(*) TEXT
      CHARACTER*1 SEP

      MXWR=LEN(TEXT)
      NWR=1
      TEXT(1:1)='('
      IWORD = 0 ! dummy initialize
      IF(IFORM.EQ.1 .OR. IFORM.EQ.3) THEN
        NOCC=NCLS+NOPN
        IF(NCLS.EQ.0) THEN
          NWR=2
          TEXT(2:2)=';'
        END IF
        IF(IFORM.EQ.1) THEN
          DO IOCC=1,NOCC
            IORB=ICONF(IOCC)
            SEP=','
            IF(IOCC.EQ.NCLS) SEP=';'
            IF(IORB.LT.10) THEN
              NWR=MIN(MXWR,NWR+2)
              WRITE(TEXT(NWR-1:NWR),'(I1,A1)')IORB,SEP
            ELSE IF(IORB.LT.100) THEN
              NWR=MIN(MXWR,NWR+3)
              WRITE(TEXT(NWR-2:NWR),'(I2,A1)')IORB,SEP
            ELSE
              NWR=MIN(MXWR,NWR+4)
              WRITE(TEXT(NWR-3:NWR),'(I3,A1)')IORB,SEP
            END IF
          END DO
        ELSE
          DO IOCC=1,NOCC
            IW=(3+IOCC)/4
            IREST=(3+IOCC)-4*IW
            IF(IREST.EQ.0) THEN
              IWORD=ICONF(IW)
            END IF
            IORB=MOD(IWORD,256)
            IWORD=IWORD/256
            SEP=','
            IF(IOCC.EQ.NCLS) SEP=';'
            IF(IORB.LT.10) THEN
              NWR=MIN(MXWR,NWR+2)
              WRITE(TEXT(NWR-1:NWR),'(I1,A1)')IORB,SEP
            ELSE IF(IORB.LT.100) THEN
              NWR=MIN(MXWR,NWR+3)
              WRITE(TEXT(NWR-2:NWR),'(I2,A1)')IORB,SEP
            ELSE
              NWR=MIN(MXWR,NWR+4)
              WRITE(TEXT(NWR-3:NWR),'(I3,A1)')IORB,SEP
            END IF
          END DO
        END IF
      ELSE IF(IFORM.EQ.2 .OR. IFORM.EQ.4) THEN
        IF(IFORM.EQ.2) THEN
          DO IORB=1,NORB
            IOCC=ICONF(IORB)
            NWR=MIN(MXWR,NWR+1)
            WRITE(TEXT(NWR:NWR),'(I1)')IOCC
          END DO
        ELSE
          DO IORB=1,NORB
            IW=(IORB+14)/15
            IREST=IORB+14-15*IW
            IF(IREST.EQ.0) THEN
              IWORD=ICONF(IW)
            END IF
            IOCC=MOD(IWORD,4)
            IWORD=IWORD/4
            NWR=MIN(MXWR,NWR+1)
            WRITE(TEXT(NWR:NWR),'(I1)')IOCC
          END DO
        END IF
      END IF
      TEXT(NWR:NWR)=')'
      LENGTH=NWR
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine IndSft_RI_2(iCmp,iShell,jBas,lBas,Shijij,iAO,iAOst,ijkl,SOint,nSOint,nSOs,TInt,nTInt,iSO2Ind,iOffA)
!***********************************************************************
!  object: to sift and index the SO integrals.                         *
!                                                                      *
!          the indices have been scrambled before calling this routine.*
!          Hence we must take special care in order to regain the      *
!          canonical order.                                            *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          april '90                                                   *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use Basis_Info, only: nBas
use SOAO_Info, only: iAOtSO
use Symmetry_Info, only: Mul, nIrrep
use sort_data, only: nSkip
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iCmp(4), iShell(4), jBas, lBas, iAO(4), iAOst(4), ijkl, nSOint, nSOs, nTInt, iSO2Ind(nSOs), &
                                 iOffA(4,0:7)
logical(kind=iwp), intent(in) :: Shijij
real(kind=wp), intent(in) :: SOint(ijkl,nSOint)
real(kind=wp), intent(inout) :: TInt(nTInt)
integer(kind=iwp) :: i1, i12, i2, i3, i34, i4, ij, iOffA_, iOffB_, iSO, ix, j, j1, j12, j2, j3, j4, jSO, jSOj, jSym(0:7), k12, &
                     k34, kSO, lSO, lSOl, lSym(0:7), memSO2, mm_, mx, nijkl, nn
#ifdef _DEBUGPRINT_
real(kind=wp) :: tr1 = Zero, tr2 = Zero
#endif
logical(kind=iwp) :: qijij

!                                                                      *
!***********************************************************************
!                                                                      *
k12 = 0
k34 = 0
#ifdef _DEBUGPRINT_
irout = 39
iprint = nprint(irout)
if (iPrint >= 49) then
  r1 = DDot_(ijkl*nSOInt,SOInt,1,[One],0)
  r2 = DDot_(ijkl*nSOInt,SOInt,1,SOInt,1)
  tr1 = tr1+r1
  tr2 = tr2+r2
  write(u6,*) ' Sum=',r1,tr1
  write(u6,*) ' Dot=',r2,tr2
  call RecPrt(' in indsft:SOint ',' ',SOint,ijkl,nSOint)
end if
#endif
memSO2 = 0

! quadruple loop over elements of the basis functions angular
! description. loops are reduced to just produce unique SO integrals
! observe that we will walk through the memory in AOint in a
! sequential way.

i1 = 1
i3 = 1
j1 = 0
j3 = 0
do i2=1,iCmp(2)
  do j=0,nIrrep-1
    ix = 0
    if (iAOtSO(iAO(2)+i2,j) > 0) ix = 2**j
    jSym(j) = ix
  end do
  if (iShell(2) > iShell(1)) then
    i12 = iCmp(2)*(i1-1)+i2
  else
    i12 = iCmp(1)*(i2-1)+i1
  end if
  do i4=1,iCmp(4)
    do j=0,nIrrep-1
      ix = 0
      if (iAOtSO(iAO(4)+i4,j) > 0) ix = 2**j
      lSym(j) = ix
    end do
    if (iShell(4) > iShell(3)) then
      i34 = iCmp(4)*(i3-1)+i4
    else
      i34 = iCmp(3)*(i4-1)+i3
    end if
    if (Shijij .and. (i34 > i12)) cycle
    qijij = Shijij .and. (i12 == i34)
    !write(u6,*) 'i1,i2,i3,i4=',i1,i2,i3,i4

    ! loop over Irreps which are spanned by the basis function.
    ! again, the loop structure is restricted to ensure unique
    ! integrals.

    do j2=0,nIrrep-1
      if (jSym(j2) == 0) cycle
      j12 = Mul(j1+1,j2+1)-1
      if (qijij) then
        if (iShell(1) > iShell(2)) then
          k12 = nIrrep*j1+j2+1
        else
          k12 = nIrrep*j2+j1+1
        end if
      end if

      iOffA_ = iOffA(1,j2)
      iOffB_ = iOffA(3,j2)
      if (j2 /= 0) iOffB_ = iOffB_+1
      mm_ = iOffA(4,j2)
      nn = mm_-iOffA(2,j2)
      mx = nTri_Elem(nn)

      j4 = Mul(j12+1,j3+1)-1
      if (lSym(j4) == 0) cycle
      if (qijij) then
        if (iShell(3) > iShell(4)) then
          k34 = nIrrep*j3+j4+1
        else
          k34 = nIrrep*j4+j3+1
        end if
        if (k34 > k12) cycle
      end if

      memSO2 = memSO2+1
      if ((nSkip(j2+1)+nSkip(j4+1)) /= 0) cycle

      ! Compute absolute starting SO index
      jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
      lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)

      nijkl = 0
      do lSOl=lSO,lSO+lBas-1
        do jSOj=jSO,jSO+jBas-1
          nijkl = nijkl+1
          iSO = jSOj-nBas(j2)
          kSO = lSOl-nBas(j4)

          iSO = iSO2Ind(iSO+iOffB_)+nn
          ij = iTri(iSO,kSO)-mx+iOffA_
          TInt(ij) = SOint(nijkl,memSO2)

        end do
      end do

    end do

  end do
end do

return

end subroutine IndSft_RI_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine BornMayerBK(iQ_Atoms,BoMaH,BoMaO)
*
*-- With the Brdarski-Karlstrom scheme, construct the Born-Mayer
*   parameters.
*
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"

      Dimension BoMaH(MxAt),BoMaO(MxAt)
      Dimension rBdi(MxCen),rBdiQ(MxAt)
      Parameter (cjhr=0.1734d0)

*
*-- The solvent part.
*
      Do 3, i=1,2
        rdi2=0
        Do 4, j=1,3
          rdi2=rdi2+quadi(j,i)
4       Continue
        rBdi(i)=Sqrt(rdi2/charDi(i))
3     Continue

*
*-- The solute part.
*
      Do 5, i=1,iQ_Atoms
        rdi2=0
        Do 6, j=1,3
          rdi2=rdi2+QuadiQ(j,i)
6       Continue
        rBdiQ(i)=Sqrt(rdi2/charDiQ(i))
5     Continue

*
*-- Put together.
*
      Do 7,i=1,iQ_Atoms
        BoMaH(i)=1/(cjhr*(RBdiQ(i)+rbdi(1)))
        BoMaO(i)=1/(cjhr*(RBdiQ(i)+rbdi(2)))
        If(iPrint.ge.8) then
          Write(6,*)'   Born-Mayer parameters.'
          Write(6,'(A,i2,A,2(f12.4))')'    Atom ',i,' (H/O):',BoMaH(i)
     &,BoMaO(i)
        Endif
7     Continue

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_TraVec(VecAO,VecMO,COcc,CVir,Scr,lScr,
     &                         iSyCho,iSyCO,iSyCV,iLoc)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: compute ai-vector from reduced set AO vector.
C
      use ChoArr, only: iRS2F
      use ChoSwp, only: IndRed
#include "implicit.fh"
      Real*8 VecAO(*), VecMO(*), COcc(*), CVir(*)
      Real*8 Scr(lScr)
#include "cholesky.fh"
#include "choorb.fh"
#include "chomp2.fh"

      Character*13 SecNam
      Parameter (SecNam = 'ChoMP2_TraVec')

      Real*8 Fac(0:1)
      Data Fac /0.5D0,1.0D0/

      MulD2h(i,j)=iEor(i-1,j-1)+1

      If (iLoc.lt.2 .or. iLoc.gt.3) Then
         Write(6,*) SecNam,': illegal iLoc = ',iLoc
         Call ChoMP2_Quit(SecNam,'iLoc out of bounds!',' ')
      End If
      iSyScr = MulD2h(iSyCho,iSyCO)
      If (lScr .lt. nT1AOT(iSyScr)) Then
         Write(6,*) SecNam,': insufficient scratch space lScr = ',lScr
         Write(6,*) SecNam,': needed                          = ',
     &              nT1AOT(iSyScr)
         Call ChoMP2_Quit(SecNam,'Insufficient scratch space',' ')
      Else
         Call FZero(Scr,nT1AOT(iSyScr))
      End If

C     First half-transformation step:
C     Scr(i,alpha) = sum_beta VecAO(alpha,beta)*COcc(i,beta)
C     ------------------------------------------------------

      If (iSyCho .eq. 1) Then

         Do iAlBe = 1,nnBstR(iSyCho,iLoc)

            jAlBe  = IndRed(iiBstR(iSyCho,iLoc)+iAlBe,iLoc)
            iAlpha = iRS2F(1,jAlBe)
            iBeta  = iRS2F(2,jAlBe)

            iSymAl = 1
            Do iSym = nSym,2,-1
               If (iAlpha .gt. iBas(iSym)) Then
                  iSymAl = iSym
                  Go To 998
               End If
            End Do
  998       iSymBe = iSymAl
            iSymi  = MulD2h(iSymBe,iSyCO)

            jAlpha = iAlpha - iBas(iSymAl)
            jBeta  = iBeta  - iBas(iSymBe)

            AOVal  = Fac(min(abs(iAlpha-iBeta),1))*VecAO(iAlBe)
            kOffAl = iT1AOT(iSymi,iSymAl) + nOcc(iSymi)*(jAlpha - 1)
            kOffBe = iT1AOT(iSymi,iSymBe) + nOcc(iSymi)*(jBeta  - 1)
            Do i = 1,nOcc(iSymi)
               Scr(kOffAl+i) = Scr(kOffAl+i) + AOVal*COcc(kOffBe+i)
               Scr(kOffBe+i) = Scr(kOffBe+i) + AOVal*COcc(kOffAl+i)
            End Do

         End Do

      Else

         Do iAlBe = 1,nnBstR(iSyCho,iLoc)

            jAlBe  = IndRed(iiBstR(iSyCho,iLoc)+iAlBe,iLoc)
            iAlpha = iRS2F(1,jAlBe)
            iBeta  = iRS2F(2,jAlBe)

            iSymAl = 1
            Do iSym = nSym,2,-1
               If (iAlpha .gt. iBas(iSym)) Then
                  iSymAl = iSym
                  Go To 999
               End If
            End Do
  999       iSymBe = MulD2h(iSymAl,iSyCho)

            jAlpha = iAlpha - iBas(iSymAl)
            jBeta  = iBeta  - iBas(iSymBe)

            AOVal  = VecAO(iAlBe)

            iSymi  = MulD2h(iSymBe,iSyCO)
            kOffAl = iT1AOT(iSymi,iSymAl) + nOcc(iSymi)*(jAlpha - 1)
            kOffBe = iT1AOT(iSymi,iSymBe) + nOcc(iSymi)*(jBeta  - 1)
            Do i = 1,nOcc(iSymi)
               Scr(kOffAl+i) = Scr(kOffAl+i) + AOVal*COcc(kOffBe+i)
            End Do

            iSymi  = MulD2h(iSymAl,iSyCO)
            kOffAl = iT1AOT(iSymi,iSymAl) + nOcc(iSymi)*(jAlpha - 1)
            kOffBe = iT1AOT(iSymi,iSymBe) + nOcc(iSymi)*(jBeta  - 1)
            Do i = 1,nOcc(iSymi)
               Scr(kOffBe+i) = Scr(kOffBe+i) + AOVal*COcc(kOffAl+i)
            End Do

         End Do

      End If

C     Second half-transformation step:
C     VecMO(a,i) = sum_alpha CVir(alpha,a)*Scr(i,alpha)
C     -------------------------------------------------

      Do iSymi = 1,nSym

         iSyma  = MulD2h(iSymi,iSyCho)
         iSymAl = MulD2h(iSyma,iSyCV)

         nTotAl = nBas(iSymAl)
         nTota  = nVir(iSyma)
         nToti  = nOcc(iSymi)

         If (nToti.gt.0 .and. nTota.gt.0 .and. nTotAl.gt.0) Then
            kOff1 = iAOVir(iSymAl,iSyma) + 1
            kOff2 = iT1AOT(iSymi,iSymAl) + 1
            kOff3 = iT1am(iSyma,iSymi)   + 1
            Call DGEMM_('T','T',nVir(iSyma),nOcc(iSymi),nBas(iSymAl),
     &                 1.0D0,CVir(kOff1),nTotAl,Scr(kOff2),nToti,
     &                 0.0D0,VecMO(kOff3),nTota)
         End If

      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This is just an interface for the state transformation. Either
! we use usual AO-basis route, or we take the reduced MO-basis route.
subroutine StateMME(MoOrNot,nAObas,nMObas,nState,nTyp,MME,iCent,Cha,Dip,Qua)

use qmstat_global, only: MxMltp
use Index_Functions, only: nTri3_Elem, nTri_Elem
use Data_Structures, only: Alloc1DArray_Type
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp), intent(in) :: MoOrNot
integer(kind=iwp), intent(in) :: nAObas, nMObas, nState, nTyp, iCent(nTri_Elem(nAObas))
type(Alloc1DArray_Type), intent(in) :: MME(nTri3_Elem(MxMltp))
real(kind=wp), intent(inout) :: Cha(nTri_Elem(nState),*), Dip(nTri_Elem(nState),3,*), Qua(nTri_Elem(nState),6,*)

if (.not. MoOrNot) then
  call StateMMEao(nAObas,nState,nTyp,MME,iCent,Cha,Dip,Qua)
else
  call StateMMEmo(nAObas,nMObas,nState,nTyp,MME,iCent,Cha,Dip,Qua)
end if

return

end subroutine StateMME

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      FUNCTION ILEX_FOR_CONF(ICONF,NOCC_ORB,NORB,NEL,IARCW,IDOREO,IREO)
*
* A configuration ICONF of NOCC_ORB orbitals are given
* ICONF(I) = IORB implies  IORB is singly occupied
* ICONF(I) = -IORB  implies that IORB is doubly occupied
*
* Find lexical address
*
* IF IDOREO .ne. 0, IREO is used to reorder lexical number
* Jeppe Olsen, November 2001
*
#include "implicit.fh"
*. Arcweights for single and doubly occupied arcs
      INTEGER IARCW(NORB,NEL,2)
*. Reorder array
      INTEGER IREO(*)
*. Configuration
      INTEGER ICONF(NOCC_ORB)
*
      IEL = 0
      ILEX = 1

      DO IOCC = 1, NOCC_ORB
       IF(ICONF(IOCC).GT.0) THEN
         IEL = IEL + 1
         ILEX = ILEX + IARCW(ICONF(IOCC),IEL,1)
       ELSE IF(ICONF(IOCC).LT.0) THEN
         IEL = IEL + 2
         ILEX = ILEX + IARCW(-ICONF(IOCC),IEL,2)
       END IF
      END DO
*
      IF(IDOREO.NE.0) THEN
       ILEX_FOR_CONF = IREO(ILEX)
      ELSE
       ILEX_FOR_CONF = ILEX
      END IF
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Configuration '
        CALL IWRTMA(ICONF,1,NOCC_ORB,1,NOCC_ORB)
        WRITE(6,*) ' Lexical number = ', ILEX
        IF(IDOREO.NE.0)
     &  WRITE(6,*) ' Reordered number = ', ILEX_FOR_CONF
      END IF
*
      RETURN
      END
C       CALL GEN_CONF_FOR_OCCLS(IB_OCCLS,
C    &     INITIALIZE_CONF_COUNTERS,
C    &     IOCCLS,NGAS,ISYM,MINOP,MAXOP,NSMST,1,NOCOB,
C    &     NOBPT,NCONF_PER_SYM(ISYM),
C    &     NCONF_PER_OPEN(1,ISYM),IBCONF_PER_OPEN(1,ISYM),
C    &     IDUM,IDUM,IDUM,
C    &     IDOREO,IDUMMY,IDUMMY,NCONF_ALL_SYM)

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RlxCtl(iStop)
      Use Chkpnt
      use thermochem, only: lTherm
      Use kriging_mod, only: Kriging, nspAI
      Use Slapaf_Info, only: Cx, Coor, Shift, GNrm, BMx, mRowH,
     &                       Free_Slapaf, qInt, dqInt, Lbl
      use Slapaf_Parameters, only: HUpMet, User_Def, UpMeth,
     &                             HSet, BSet, PrQ, Numerical, iNeg,
     &                             E_Delta, iRef, lNmHss, Cubic,
     &                             Request_Alaska, Request_RASSI, lCtoF,
     &                             isFalcon, nDimBC, mTROld,
     &                             NmIter, MxItr, mTtAtm, nWNdw, iter
      Implicit Real*8 (a-h,o-z)
************************************************************************
*     Program for determination of the new molecular geometry          *
************************************************************************
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
      Logical GoOn, Do_ESPF, Just_Frequencies, Found, Error
      Character(LEN=1) Step_trunc
      Integer, External:: AixRm
      Integer nGB
      Real*8 rDum(1)
      Real*8, Allocatable:: GB(:), HX(:), HQ(:), KtB(:)
*                                                                      *
************************************************************************
*                                                                      *
      Lu=6
      Just_Frequencies=.False.
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*-----Process the input
*
      LuSpool=21
      Call SpoolInp(LuSpool)
*
      Call RdCtl_Slapaf(LuSpool,.False.)
      mInt = nDimBC - mTROld
*
      Call Close_LuSpool(LuSpool)
*
      Call Chkpnt_open()
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      If (Request_Alaska.or.Request_RASSI) Then
*
*        Alaska/RASSI only
         iStop=3
         Call Free_Slapaf()
         Return
       Else If (isFalcon) Then
         iStop=1
         Call Free_Slapaf()
         Return
      End if
*                                                                      *
************************************************************************
*                                                                      *
      PrQ= .Not.Request_Alaska
*                                                                      *
************************************************************************
*                                                                      *
      If (lCtoF .AND. PrQ) Call Def_CtoF(.False.)
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute the Wilson B-matrices, which describe the transformations
*     between internal and Cartesian coordinates. Values of the
*     Internal coordinates are computed too.
*
      HSet=.True.
      BSet=.True.
      kIter=iter
*
*---- Compute number of steps for numerical differentiation
*
      NmIter=1
      ! Numerical only for some rows
      If (Allocated(mRowH))  NmIter=SIZE(mRowH)+1
      If (lNmHss) NmIter=2*mInt+1    ! Full numerical
      If (Cubic)  NmIter=2*mInt**2+1 ! Full cubic
*
      If (lTherm .and. iter.EQ.1) then
         Call Put_dArray('Initial Coordinates',Coor,SIZE(Coor))
      EndIf
*
*---- Fix the definition of internal during numerical differentiation
      If (lNmHss.and.iter.lt.NmIter.and.iter.ne.1) nPrint(122)=5
*
*---- Do not overwrite numerical Hessian
      If ((lNmHss.or.Allocated(mRowH))
     &    .and.(iter.gt.NmIter.or.iter.lt.NmIter)) HSet = .False.
*
*---- Set logical to indicate status during numerical differentiation
      Numerical = lNmHss .and.iter.le.NmIter .and.iter.ne.1
*
      If (Numerical) nWndw=NmIter
      iRef=0
      Call BMtrx(SIZE(Coor,2),Coor,iter,mTtAtm,nWndw)
      nQQ = SIZE(qInt,1)
*
      nPrint(30) = nPrint(30)-1
*
      Call Put_dArray('BMtrx',BMx,SIZE(Coor)*nQQ)
      Call Put_iScalar('No of Internal coordinates',nQQ)
*                                                                      *
************************************************************************
*                                                                      *
      Call Reset_ThrGrd(Iter,mTtAtm,ThrGrd)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*-----Compute the norm of the Cartesian gradient.
*
      Call G_Nrm(nQQ,GNrm,iter,dqInt,mIntEff)
      If (nPrint(116).ge.6) Call ListU(Lu,Lbl,dqInt,nQQ,iter)
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*     Accumulate gradient for complete or partial numerical
*     differentiation of the Hessian.
*
      If ((Allocated(mRowH).and.iter.lt.NmIter) .or.
     &        (lNmHss.and.iter.lt.NmIter)) Then

         If (Allocated(mRowH).and.iter.lt.NmIter) Then
*
*----------------------------------------------------------------------*
*        I) Update geometry for selected numerical differentiation.    *
*----------------------------------------------------------------------*
*
            Call Freq1()
            UpMeth='RowH  '
         Else
*
*----------------------------------------------------------------------*
*        II) Update geometry for full numerical differentiation.       *
*----------------------------------------------------------------------*
*
            Call NwShft()
            UpMeth='NumHss'
         End If
*
         Call MxLbls(nQQ,dqInt(:,iter),Shift(:,iter),Lbl)
         iNeg(:)=-99
         HUpMet='None  '
         nPrint(116)=nPrint(116)-3
         nPrint( 52)=nPrint( 52)-1  ! Status
         nPrint( 53)=nPrint( 53)-1
         nPrint( 54)=nPrint( 54)-1
         Write (6,*) ' Accumulate the gradient for selected '//
     &               'numerical differentiation.'
         Write (6,'(1x,i5,1x,a,1x,i5)') iter,'of',NmIter
         E_Delta=Zero
         Step_Trunc=' '
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*--------Compute updated geometry in Internal coordinates
*
         Step_Trunc=' '
         E_Delta=zero
         If (Allocated(mRowH).or.lNmHss) kIter = iter - (NmIter-1)
*define UNIT_MM
#ifdef UNIT_MM
         Call Init_UpdMask(nInter)
#endif
*
*        Update geometry
*
         If (Kriging .and. Iter.ge.nspAI) Then
            Call Update_Kriging(Step_Trunc,nWndw)
         Else
            Call Update_sl(Step_Trunc,nWndw,kIter)
         End If
*
#ifdef UNIT_MM
         Call Free_UpdMask()
#endif
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*-----Transform the new internal coordinates to Cartesians
*     (if not already done by Kriging)
*
      If (Kriging .and. Iter.ge.nspAI) Then
         Coor(:,:) = Cx(:,:,Iter+1)
      Else
         PrQ=.False.
         Error=.False.
         iRef=0
         Call NewCar(Iter,Size(Coor,2),Coor,mTtAtm,Error)
      End If
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*
*-----If this is a ESPF QM/MM job, the link atom coordinates are updated
*
      Do_ESPF = .False.
      Call DecideOnESPF(Do_ESPF)
      If (Do_ESPF) Then
       Call LA_Morok(SIZE(Coor,2),Coor,2)
       Cx(:,:,Iter+1) = Coor(:,:)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Adjust some print levels
*
      If ((lNmHss.or.Allocated(mRowH)).and.iter.eq.NmIter) Then
*
*        If only frequencies no more output
*
         nPrint(21) = 5 ! Hessian already printed calling Update_sl
         If (kIter.gt.MxItr) Then
            Just_Frequencies=.True.
            nPrint(116)=nPrint(116)-3
            nPrint( 52)=nPrint( 52)-1
            nPrint( 53)=nPrint( 53)-1
            nPrint( 54)=nPrint( 54)-1
         End If
      End If
*
*     Fix correct reference structure in case of Numerical Hessian
*     optimization.
*
      If ((lNmHss.or.Allocated(mRowH)).and.kIter.eq.1) Then
         Cx(:,:,iter) = Cx(:,:,1)
      End If
*
*---- Print statistics and check on convergence
*
      GoOn = (lNmHss.and.iter.lt.NmIter) .OR.
     &       (Allocated(mRowH).and.iter.lt.NmIter)
      Numerical=(lNmHss.or.Allocated(mRowH)).and.iter.le.NmIter
      Call Convrg(iter,kIter,nQQ,iStop,MxItr,mIntEff,
     &            mTtAtm,GoOn,Step_Trunc,Just_Frequencies)
*
************************************************************************
*                                                                      *
*                           EPILOGUE                                   *
*                                                                      *
************************************************************************
*
*-----Write information to files
*
      Numerical = (lNmHss.or.Allocated(mRowH)) .and. iter.le.NmIter

      Call DstInf(iStop,Just_Frequencies)

      If (lCtoF) Call Def_CtoF(.True.)
      If (.Not.User_Def .and.
     &   ((lNmHss.and.iter.ge.NmIter).or..Not.lNmHss)) Call cp_SpcInt()
*
*-----After a numerical frequencies calculation, restore the original
*     runfile, but save the useful data (gradient and Hessian)
*
      If (lNmHss.and.iter.ge.NmIter) Then
         Call f_Inquire('RUNBACK',Found)
         If (Found) Then
*           Read data
            nGB=SIZE(Coor)
            Call mma_allocate(GB,nGB,Label='GB')
            Call Get_Grad(GB,nGB)

            Call Qpg_dArray('Hss_X',Found,nHX)
            Call mma_allocate(HX,nHX,Label='HX')
            Call Get_dArray('Hss_X',HX,nHX)

            Call Qpg_dArray('Hss_Q',Found,nHQ)
            Call mma_allocate(HQ,nHQ,Label='HQ')
            Call Get_dArray('Hss_Q',HQ,nHQ)

            Call Qpg_dArray('KtB',Found,nKtB)
            Call mma_allocate(KtB,nKtB,Label='KtB')
            Call Get_dArray('KtB',KtB,nKtB)

            Call Get_iScalar('No of Internal coordinates',nIntCoor)
*           Write data in backup file
            Call NameRun('RUNBACK')
            Call Put_Grad(GB,nGB)
            Call Put_dArray('Hss_X',HX,nHX)
            Call Put_dArray('Hss_Q',HQ,nHQ)
            Call Put_dArray('Hss_upd',rdum,0)
            Call Put_dArray('Hess',HQ,nHQ)
            Call Put_dArray('KtB',KtB,nKtB)
            Call Put_iScalar('No of Internal coordinates',nIntCoor)
*           Pretend the Hessian is analytical
            nHX2=Int(Sqrt(Dble(nHX)))
            iOff=0
            Do i=1,nHX2
               Do j=1,i
                  iOff=iOff+1
                  HX(iOff)=HX((i-1)*nHX2+j)
               End Do
            End Do
#ifdef _DEBUGPRINT_
            Call TriPrt('AnalHess',' ',HX,nHX2)
#endif

            Call Put_AnalHess(HX,iOff)
            Call NameRun('#Pop')

            Call mma_deallocate(GB)
            Call mma_deallocate(HX)
            Call mma_deallocate(HQ)
            Call mma_deallocate(KtB)
*
*           Restore and remove the backup runfile
*
            Call fCopy('RUNBACK','RUNFILE',iErr)
            If (iErr.ne.0) Call Abend()
            If (AixRm('RUNBACK').ne.0) Call Abend()
         End If
      End If
*
*-----Remove the GRADS file
*
      Call f_Inquire('GRADS',Found)
      If (Found) Then
         If (AixRm('GRADS').ne.0) Call Abend()
      End If
*
      Call Chkpnt_update()
      Call Chkpnt_close()
*                                                                      *
************************************************************************
*                                                                      *
*-----Deallocate memory
*
      Call Free_Slapaf()
*
*-----Terminate the calculations.
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  rotategeom
!
!> @brief
!>   Performs the rotation of \p Geom with the \p Q quaternion and stores the result in \p Geom
!> @author Y. Carissan
!>
!> @details
!> Performs the rotation of \p Geom with the \p Q quaternion
!> and stores the result in \p Geom.
!>
!> @param[in]     Q    Input Quaternion
!> @param[in]     nat  Number of atoms
!> @param[in,out] Geom Input and output geometry, xyz coordinates
!***********************************************************************

subroutine rotategeom(Q,nat,Geom)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nat
real(kind=wp), intent(in) :: Q(0:3)
real(kind=wp), intent(inout) :: Geom(3,nat)
real(kind=wp) :: V(3)
integer(kind=iwp) :: iat

do iat=1,nat
  V(:) = Geom(:,iat)
  call QuaterRotation(Q,V,Geom(:,iat))
end do

return

end subroutine rotategeom

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine pseud1_molcas(a,ang,ccr,gout,ipt,lmnv,ltot1,ncr,
     &  nkcrl,nkcru,qsum,xab,yab,zab,zcr,lit,ljt,ai,aj,
     &  xi,yi,zi,xj,yj,zj,xc,yc,zc,kcrs,lproju1,crda,crdb)
c
c  compute type 1 core potential integrals
c
      implicit real*8 (a-h,o-z)
      dimension llt(7,2)
      parameter (a0=0.0d0,a4=4.0d0)
      dimension a(*),ang(ltot1,*),ccr(*),crda(lit,3),crdb(ljt,3),
     &  gout(*),ipt(*),lmnv(3,*),ncr(*),nkcrl(lproju1,*),
     &  nkcru(lproju1,*),qsum(ltot1,*),xab(*),yab(*),zab(*),zcr(*)
      data llt /1,2,5,11,21,36,57,1,4,10,20,35,56,84/

      call pseud1_molcas_internal(a)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine pseud1_molcas_internal(a)
      use iso_c_binding
      real*8, target :: a(*)
      integer, pointer :: ia13(:),ia14(:),ia15(:),ia16(:),ia17(:)
      tol=20.*log(10.d0)
      fctr2=a4
      itl=llt(lit,1)
      itu=llt(lit,2)
      jtl=llt(ljt,1)
      jtu=llt(ljt,2)
      aa=ai+aj
      do 120 i=1,3
      crda(1,i)=1.d0
      crdb(1,i)=1.d0
  120 continue
      xka=xc-xi
      yka=yc-yi
      zka=zc-zi
      ca=sqrt(xka*xka+yka*yka+zka*zka)
      if(lit.eq.1) go to 220
      crda(2,1)=xka
      crda(2,2)=yka
      crda(2,3)=zka
      if(lit.eq.2) go to 220
      do 210 i=1,3
      do 211 j=3,lit
      crda(j,i)=crda(2,i)*crda(j-1,i)
  211 continue
  210 continue
  220 xkb=xc-xj
      ykb=yc-yj
      zkb=zc-zj
      cb=sqrt(xkb*xkb+ykb*ykb+zkb*zkb)
      if(ljt.eq.1) go to 240
      crdb(2,1)=xkb
      crdb(2,2)=ykb
      crdb(2,3)=zkb
      if(ljt.eq.2) go to 240
      do 230 i=1,3
      do 231 j=3,ljt
      crdb(j,i)=crdb(2,i)*crdb(j-1,i)
  231 continue
  230 continue
  240 continue
      xij=0.5d0*(xi+xj)
      yij=0.5d0*(yi+yj)
      zij=0.5d0*(zi+zj)
      xijm=0.5d0*(xi-xj)
      yijm=0.5d0*(yi-yj)
      zijm=0.5d0*(zi-zj)
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
      aaa=(ai-aj)/aa
      xk=xij+aaa*xijm-xc
      yk=yij+aaa*yijm-yc
      zk=zij+aaa*zijm-zc
      aarr1=(ai*aj/aa)*rr
      taa=aa+aa
c*
      rp2=xk*xk+yk*yk+zk*zk
      if(rp2.eq.a0) then
        rp=a0
        arp2=a0
        alpt=a0
        rk=a0
        lamu=1
      else
        rp=sqrt(rp2)
        xk=xk/rp
        yk=yk/rp
        zk=zk/rp
        arp2=aa*rp2
        alpt=aa*arp2
        rk=taa*rp
        lamu=ltot1
      endif
c
c  compute radial integrals and sum over potential terms
c
      call wzero((ltot1*lamu),qsum,1)
      kcrl=nkcrl(1,kcrs)
      kcru=nkcru(1,kcrs)
      call rad1(aa,aarr1,alpt,arp2,ccr,
     &  a(ipt(11)),fctr2,kcrl,kcru,
     &  lamu,ltot1,ncr,qsum,rk,tol,zcr)
      ijt=0
      do 90 it=itl,itu
        na1=lmnv(1,it)+1
        la1=lmnv(2,it)+1
        ma1=lmnv(3,it)+1
        do 80 jt=jtl,jtu
          ijt=ijt+1
          s=a0
          nb1=lmnv(1,jt)+1
          lb1=lmnv(2,jt)+1
          mb1=lmnv(3,jt)+1
c
c  compute angular integrals
c
          call facab(a(ipt(12)),na1,nb1,crda(1,1),crdb(1,1),xab)
          call facab(a(ipt(12)),la1,lb1,crda(1,2),crdb(1,2),yab)
          call facab(a(ipt(12)),ma1,mb1,crda(1,3),crdb(1,3),zab)
          call c_f_pointer(c_loc(a(ipt(13))),ia13,[1])
          call c_f_pointer(c_loc(a(ipt(14))),ia14,[1])
          call c_f_pointer(c_loc(a(ipt(15))),ia15,[1])
          call c_f_pointer(c_loc(a(ipt(16))),ia16,[1])
          call c_f_pointer(c_loc(a(ipt(17))),ia17,[1])
          call ang1(ang,a(ipt(11)),na1+nb1-1,la1+lb1-1,ma1+mb1-1,lamu,
     &      ia13,ia14,ia15,ia16,ia17,
     &      ltot1,xab,yab,zab,xk,yk,zk,a(ipt(18)))
          nullify(ia13,ia14,ia15,ia16,ia17)
c
c  combine angular and radial integrals
c
          do 70 lam=1,lamu
            nhi=ltot1-mod(ltot1-lam,2)
            do 60 n=lam,nhi,2
              s=s+ang(n,lam)*qsum(n,lam)
   60       continue
   70     continue
          gout(ijt)=gout(ijt)+s
   80   continue
   90 continue
      return
      end subroutine pseud1_molcas_internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mksymcvb_cvb()

use casvb_global, only: cvb, iconstruc, ipr, nvb, vbdet
use Definitions, only: wp, u6

implicit none
real(kind=wp) :: psnrm
real(kind=wp), parameter :: thresh = 1.0e-15_wp
real(kind=wp), external :: ddot_

! Constraints on struc coeffs - either symmetry or deleted
if (iconstruc > 0) then
  if (ipr(1) >= 0) write(u6,'(/,a)') ' Imposing constraints on the structure coefficients.'
  call symtrizcvb_cvb(cvb)
  psnrm = ddot_(nvb,cvb,1,cvb,1)
  if (psnrm < thresh) then
    write(u6,*) ' Fatal error - structure coefficients null after symmetrization!'
    call abend_cvb()
  end if
  if (ipr(1) >= 0) then
    write(u6,'(/,a)') ' Constrained structure coefficients :'
    write(u6,'(a)') ' ------------------------------------'
    call vecprint_cvb(cvb,nvb)
  end if
end if
call str2vbc_cvb(cvb,vbdet)

return

end subroutine mksymcvb_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine TCMO(A,isym,ictl)
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "WrkSpc.fh"
      Integer ip(8)
      Real*8 A(*)
      Call GetMem('Temp','ALLO','REAL',ipT,nDens2)
      Call ReLoad(A,isym,norb,nbas)
* irc used in call later must not be uninitialized
* since then MKL library gets upset...
      irc=0
      If (ictl.eq.-1) Then
       Do iS=1,nSym
        If (nbas(is).ne.0) Then
        Call GetMem('CMOINV','ALLO','REAL',ip(iS),
     &              nBas(is)**2+nbas(is))
        call dcopy_(nbas(is)**2,Work(ipCMO+ipcm(is)-1),1,Work(ip(is)),1)
        iip=ip_of_iWork_d(Work(ip(is)+nbas(is)**2))
        call dgetrf_(nBas(is),nBas(is),Work(ip(is)),
     &              nBas(is),iWork(iip),irc)
        If (irc.ne.0)
     &         Call SysAbendMsg('tcmo','DGETRF returns non zero', ' ')
        end if
       End Do
        Do iS=1,nSym
         js=ieor(is-1,isym-1)+1
        If (nbas(is)*nbas(js).ne.0) Then
         iip=ip_of_iWork_d(Work(ip(is)+nbas(is)**2))
         call dgetrs_('T',nbas(is),nbas(js),
     &                Work(ip(is)),nBas(is),
     &                iWork(iip),
     &                A(ipMat(is,js)),nBas(is),irc)
         if (irc.ne.0)
     &         Call SysAbendMsg('tcmo','DGETRS returns non zero', ' ')
         Call DGETMO(A(ipMat(is,js)),nBas(is),
     &                    nbas(is),nbas(js),
     &                    Work(ipT),nbas(js))
         iip=ip_of_iWork_d(Work(ip(js)+nbas(js)**2))
         call dgetrs_('T',nbas(js),nbas(is),
     &                Work(ip(js)),nBas(js),
     &                iWork(iip),
     &                Work(ipT),nBas(js),irc)
         if (irc.ne.0)
     &         Call SysAbendMsg('tcmo','DGETRS returns non zero', ' ')
         Call DGETMO(Work(ipT),nBas(js),
     &              nbas(js),nbas(is),
     &              A(ipMat(is,js)),nbas(is))
        End If
        End Do
       Do iS=1,nSym
        If (nbas(is).ne.0)
     &  Call GetMem('CMOINV','FREE','REAL',ip(iS),idum)
       End Do
      Else If (ictl.eq.1) Then
       Do iS=1,nSym
        js=ieor(is-1,isym-1)+1
        If (nBas(is)*nBas(js).ne.0) Then
           Call DGEMM_('T','N',
     &                 nOrb(iS),nBas(jS),nBas(iS),
     &                 1.0d0,Work(ipCMO+ipCM(iS)-1),nBas(is),
     &                 A(ipmat(is,js)),nBas(iS),
     &                 0.0d0,Work(ipT),nOrb(iS))
           Call DGEMM_('N','N',
     &                 nOrb(is),nOrb(jS),nBas(jS),
     &                 1.0d0,Work(ipT),nOrb(iS),
     &                 Work(ipCMO+ipCM(jS)-1),nBas(jS),
     &                 0.0d0,A(ipMat(iS,jS)),nOrb(iS))
        End If
       End Do
      Else if (ictl.eq.-2) Then
       Do iS=1,nSym
        js=ieor(is-1,isym-1)+1
        If (nBas(is)*nBas(js).ne.0) Then
           Call DGEMM_('N','N',
     &                 nBas(iS),nOrb(jS),nOrb(iS),
     &                 1.0d0,Work(ipCMO+ipCM(iS)-1),nBas(is),
     &                 A(ipmat(is,js)),nOrb(iS),
     &                 0.0d0,Work(ipT),nBas(iS))
           Call DGEMM_('N','T',
     &                 nBas(is),nBas(jS),nOrb(jS),
     &                 1.0d0,Work(ipT),nBas(iS),
     &                 Work(ipCMO+ipCM(jS)-1),nBas(jS),
     &                 0.0d0,A(ipMat(iS,jS)),nBas(iS))
        End If
       End Do
      Else
        Write(6,*) 'Oink'
        Call SysHalt('tcmo')
      End If
      Call GetMem('Temp','FREE','REAL',ipT,nDens2)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jesper Wisborg Krogh                                   *
************************************************************************
*  Lucia_Util
*
*> @brief
*>   Wrapper for using LUCIA utils in MOLCAS.
*> @author Jesper Wisborg Krogh
*>
*> @details
*> By using the LUCIA utils through this wrapper it is guaranteed
*> that all common blocks used have a common parent routine.
*>
*> @param[in] Module Identifier
*> @param[in] Int1   Argument to LUCIA
*> @param[in] Int2   Argument to LUCIA
*> @param[in] Array1 Argument to LUCIA
************************************************************************
      Subroutine Lucia_Util(Module,Int1,Int2,Array1)
#include "implicit.fh"
      Parameter(MxpLnc = 72)
      Character*(*) Module
      Character*(MxpLnc) Module_
      Dimension Array1(*)
*
* Include all LUCIA include files to make sure
* they are available during the calculation.
*
#include "mxpdim.fh"
#include "cands.fh"

#include "cecore.fh"
#include "cgas.fh"

#include "cicisp.fh"
#include "cintfo.fh"
#include "clunit.fh"

#include "cprnt.fh"
#include "crun.fh"

#include "csm.fh"
#include "cstate.fh"



#include "gasstr.fh"
#include "glbbas.fh"
#include "intform.fh"
#include "irat.fh"

#include "lucinp.fh"

#include "multd2h.fh"

#include "oper.fh"
#include "orbinp.fh"
#include "spinfo_lucia.fh"
#include "stinf.fh"
#include "strbas.fh"
#include "strinp.fh"
#include "WrkSpc.fh"
#include "rasscf_lucia.fh"
*
#ifdef _DEBUGPRINT_
      INTEGER, SAVE :: COUNTER = 0
      COUNTER=COUNTER+1
      WRITE(6,'(1X,A1,I6,A1,1X,A,1X,A1,A,A1)')
     & '[',COUNTER,']','ENTRY LUCIA_UTIL','(',Module,')'
#endif
*
* To avoid compiler warnings (I know it's ugly)
*
      iCrap = Multd2h(1,1)
*
* Make sure the Module variable is in upper case.
*
      Module_ = Module
      Call UppCas(Module_,MxpLnc)
*
* Call the appropriate routines according to Module
*
      If (Module_(1:4) .eq. 'DIAG') Then
         Call Diag_Master
      Else If (Module_(1:9) .eq. 'SIGMA_CVB') Then
*        Int1 is the symmetry to be used.
         Call Sigma_Master_CVB(Int1)
      Else If (Module_(1:5) .eq. 'SIGMA') Then
!        write(6,*) 'blubbbbbbhc'
         Call Sigma_Master
      Else If (Module_(1:5) .eq. 'TRACI') Then
!        write(6,*) 'blubbbbbbtraci'
*        Int1 is the initial disk address (for read/write of JOBIPH)
*        Int2 is the file unit for JOBIPH
*        Array1 is the transformation matrix (not sorted as LUCIA needs it).
         Call GetMem('lrec','allo','inte',ivlrec,MXNTTS)
         Call Traci_Master(Int1,Int2,Array1,iWork(ivlrec))
         Call GetMem('lrec','free','inte',ivlrec,MXNTTS)
      Else If (Module_(1:5) .eq. 'DENSI') Then
         Call Densi_Master(Int1)
      Else If (Module_(1:3) .eq. 'INI') Then
         Call Lucia_Ini
         Call DetCtl_Gas
      Else If (Module_(1:5) .eq. 'CLOSE') Then
         Call DetCtl_Free
         Call Lucia_Close
      Else
         Write(6,*) 'Unknown module requested in Lucia_Util.'
         Write(6,*) 'Module = ',Module
         Write(6,*) 'Known modules are:'
         Write(6,*) 'Diag, Sigma, Sigma_CVB, Densi, DetCtl, Ini'
         Call Abend
      End If

#ifdef _DEBUGPRINT_
      WRITE(6,'(1X,A1,I6,A1,1X,A,1X,A1,A,A1)')
     & '[',COUNTER,']','EXIT LUCIA_UTIL','(',Module,')'
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine evb2cas2_cvb(orbs,cvb,ioptc,iter,fx,dxnrm,dx_amx,civec,civb,civbh,res,resh)

!Note: this was using "sorbs" and "owrk2" instead of "cvbdet" and "gjorb", probably a bug
use casvb_global, only: corenrg, cvbdet, dx, evb, formAD, formAF, gjorb, grd, icnt_ci, ipr, memplenty, ndet, norb, nvb, ovraa, &
                        projcas
use Constants, only: One, Two
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: orbs(norb,norb), dxnrm, dx_amx
real(kind=wp), intent(_IN_) :: cvb(nvb)
integer(kind=iwp), intent(out) :: ioptc, iter
real(kind=wp), intent(out) :: fx
real(kind=wp), intent(inout) :: civec(0:ndet), civb(0:ndet), civbh(0:ndet), res(0:ndet), resh(0:ndet)
integer(kind=iwp) :: icivec
real(kind=wp) :: cnrm, eig(2), h(2,2), orbinv(norb,norb), ovr, rescas_ovr, resnrm
logical(kind=iwp) :: dx_ok, grad_ok
logical(kind=iwp), external :: tstfile_cvb ! ... Files/Hamiltonian available ...

if (ipr(3) >= 0) then
  write(u6,'(/,a)') ' Starting VB2CAS optimization.'
  write(u6,'(a)') ' -----------------------------'
end if

dx_ok = ((dx_amx < dx(1,3)) .and. (dxnrm < dx(2,3)))

if (.not. projcas) then
  call str2vbc_cvb(cvb,cvbdet)
  call vb2cic_cvb(cvbdet,civb)
else if (projcas) then
  if (memplenty) then
    call cicopy_cvb(civec,civbh)
  else
    call cird_cvb(civbh,61001.2_wp)
  end if
  orbinv(:,:) = orbs(:,:)
  call mxinv_cvb(orbinv,norb)
  call gaussj_cvb(orbinv,gjorb)
  call applyt_cvb(civbh,gjorb)
  call pvbcopy_cvb(civbh,civb)
  call ci2vbc_cvb(civbh,cvbdet)
end if

call gaussj_cvb(orbs,gjorb)
call applyt_cvb(civb,gjorb)
call proj_cvb(civb)

call cinorm_cvb(civb,cnrm)
call ciscale_cvb(civb,One/sqrt(cnrm))

call cicopy_cvb(civb,civbh)
call applyh_cvb(civbh)

call cidot_cvb(civb,civbh,evb)
if (ipr(3) >= 2) write(u6,formAF) ' Residual calculation based on Evb :',evb+corenrg
! RES()=CIVBH()-EVB*CIVB()
call cicopy_cvb(civbh,res)
call cidaxpy_cvb(-evb,civb,res)

if (tstfile_cvb(67123.2_wp)) then
  call cird_cvb(resh,67123.2_wp)
  call cidot_cvb(res,resh,rescas_ovr)
  !call cidot_cvb(civb,resh,civb_ovr)
  !dxnrm_ci = sqrt(Two*(One-civb_ovr))
  !write(u6,*) ' dxnrm dxnrm_ci :',dxnrm,dxnrm_ci
  !write(u6,*) ' gradient in VB basis :',Two*rescas_ovr/dxnrm
  grad_ok = (Two*rescas_ovr/dxnrm < grd(1,3))
else
  grad_ok = .false.
end if
call ciwr_cvb(civb,67123.2_wp)

call cinorm_cvb(res,resnrm)
if (ipr(3) >= 2) then
  write(u6,'(a)') ' '
  write(u6,formAD) ' Residual norm:',resnrm
  write(u6,'(a)') ' '
end if
call ciscale_cvb(res,One/sqrt(resnrm))
call cidot_cvb(res,civb,ovr)
! RES()=RES()-OVR*CIVB()
call cidaxpy_cvb(-ovr,civb,res)
call cinorm_cvb(res,resnrm)
call ciscale_cvb(res,One/sqrt(resnrm))
call cidot_cvb(civbh,civb,h(1,1))
call cidot_cvb(civbh,res,h(1,2))

call cicopy_cvb(res,resh)
call applyh_cvb(resh)

call cidot_cvb(resh,civb,h(2,1))
call cidot_cvb(resh,res,h(2,2))

if (ipr(3) >= 2) then
  write(u6,*) ' 2x2 Hamiltonian matrix :'
  eig(1) = h(1,1)
  eig(2) = h(2,2)
  h(1,1) = h(1,1)+corenrg
  h(2,2) = h(2,2)+corenrg
  call mxprintd_cvb(h,2,2,0)
  h(1,1) = eig(1)
  h(2,2) = eig(2)
end if

call mxdiag_cvb(h,eig,2)
if (ipr(3) >= 2) then
  write(u6,*) ' Eigenvalues :',eig(1)+corenrg,eig(2)+corenrg
  write(u6,*) ' Eigenvectors :'
  call mxprint_cvb(h,2,2,0)
end if

if (abs(h(1,1)) > abs(h(1,2))) then
  if (ipr(3) >= 2) write(u6,*) ' Using root 1 :'
  call ciscale_cvb(civb,h(1,1))
  call cidaxpy_cvb(h(2,1),res,civb)
else
  if (ipr(3) >= 2) write(u6,*) ' Using root 2 :'
  call ciscale_cvb(civb,h(1,2))
  call cidaxpy_cvb(h(2,2),res,civb)
end if
call cinorm_cvb(civb,cnrm)
call ciscale_cvb(civb,One/sqrt(cnrm))
if (memplenty) then
  !call cidot_cvb(civb,civec,ovr)
  call cicopy_cvb(civb,civec)
else
  call cird_cvb(res,61001.2_wp)
  !call cidot_cvb(civb,res,ovr)
  call ciwr_cvb(civb,61001.2_wp)
end if

evb = evb+corenrg
fx = evb
ovraa = One
iter = 1
ioptc = 0
!ovrcrit = 0.125e-10_wp
!if (abs(One-abs(ovr)) > ovrcrit) iter = 2
if (.not. (dx_ok .and. grad_ok)) iter = 2
icivec = nint(civec(0))
icnt_ci(icivec) = 1

return

end subroutine evb2cas2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Francesco Aquilante                              *
!***********************************************************************

subroutine DrvN1_EMB(Grad,Temp,nGrad)
!***********************************************************************
!                                                                      *
! Object: to compute the molecular gradient contribution due to the    *
!         inter-subsystem nuclear repulsion energy                     *
!                                                                      *
! Called from: Alaska                                                  *
!                                                                      *
! Author : F. Aquilante, Geneva, Nov 2010                              *
!***********************************************************************

use Basis_Info, only: dbsc, nCnttp
use Center_Info, only: dc
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
real(kind=wp), intent(out) :: Temp(nGrad)
#include "Molcas.fh"
#include "print.fh"
#include "disp.fh"
integer(kind=iwp) :: iCar, iCnt, iCnttp, iCnttp_B, iComp, iDCRR(0:7), igu, iIrrep, iM1xp, iM2xp, iPrint, iR, iRout, jCnt, jCntMx, &
                     jCnttp, LmbdR, mdc, nCnttp_B, ndc, nDCRR, nDisp
real(kind=wp) :: A(3), B(3), CffM1, CffM2, Cnt0M1, Cnt0M2, Cnt1M1, Cnt1M2, df_dr, dfab, dr_da, fab, Fact, Gam, PreFct, r12, RB(3), &
                 ZA, ZAZB, ZB
logical(kind=iwp) :: EQ, TstFnc
character(len=16) :: NamRfil
character(len=80) :: Lab
real(kind=wp), allocatable :: Charge_B(:)

if (nIrrep > 1) then
  call WarningMessage(2,'Error in DrvN1_Emb')
  write(u6,*) 'Sorry, OFE gradient code does not understand'
  write(u6,*) 'the use of subsystem symmetry!'
  call Quit_OnUserError()
end if
iRout = 33
iPrint = nPrint(iRout)

iIrrep = 0
Temp(:) = Zero

call Get_NameRun(NamRfil) ! save the old RUNFILE name
call NameRun('AUXRFIL')   ! switch RUNFILE name

call mma_allocate(Charge_B,nCnttp,label='B-Charges')
call Get_dArray('Nuclear charge',Charge_B,nCnttp)

call NameRun(NamRfil)   ! switch back to old RUNFILE name

ZA = One
iCnttp = 1
do while ((iCnttp <= nCnttp) .and. (ZA > Zero))
  ZA = dbsc(iCnttp)%Charge
  iCnttp = iCnttp+1
end do
iCnttp_B = iCnttp-1  ! start of atoms of subsystem B

if (iCnttp_B == 1) then ! subsystem B comes first
  ZB = Zero
  nCnttp_B = 1
  do while ((nCnttp_B <= nCnttp) .and. (ZB == Zero))
    ZB = dbsc(nCnttp_B)%Charge
    nCnttp_B = nCnttp_B+1
  end do
  nCnttp_B = nCnttp_B-1  ! end of atoms of subsystem B
else
  nCnttp_B = nCnttp
end if

mdc = 0
! Loop over centers with the same charge (A-subsystem)
do iCnttp=1,nCnttp
  if (iCnttp > 1) mdc = mdc+dbsc(iCnttp-1)%nCntr
  ZA = dbsc(iCnttp)%Charge
  if ((iCnttp >= iCnttp_B) .and. (iCnttp <= nCnttp_B) .and. (ZA > Zero)) then
    call WarningMessage(2,'Internal error in DrvN1_Emb')
    write(u6,*) ' Subsystems must come one after the other'
    call Abend()
  end if
  if (ZA == Zero) cycle
  ! Loop over all unique centers of this group (A-subsystem)
  do iCnt=1,dbsc(iCnttp)%nCntr
    A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)

    ndc = 0
    do jCnttp=iCnttp_B,nCnttp_B  ! (B-subsystem)

      if (jCnttp > iCnttp_B) ndc = ndc+dbsc(jCnttp-1)%nCntr

      ZB = Charge_B(jCnttp)

      if (ZB == Zero) cycle
      ZAZB = ZA*ZB
      jCntMx = dbsc(jCnttp)%nCntr
      do jCnt=1,jCntMx
        B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)

        Fact = One
        ! Factor due to resticted summation
        if (EQ(A,B)) Fact = Half

        ! Find the DCR for the two centers

        call DCR(LmbdR,dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,iDCRR,nDCRR)

        PreFct = Fact*ZAZB*real(nIrrep,kind=wp)/real(LmbdR,kind=wp)
        do iR=0,nDCRR-1
          call OA(iDCRR(iR),B,RB)
          if (EQ(A,RB)) cycle
          r12 = sqrt((A(1)-RB(1))**2+(A(2)-RB(2))**2+(A(3)-RB(3))**2)

          ! The factor u/g will ensure that the value of the
          ! gradient in symmetry adapted and no symmetry basis
          ! will have the same value.

          fab = One
          dfab = Zero
          if (dbsc(iCnttp)%ECP) then
            ! Add contribution from M1 operator
            Cnt0M1 = Zero
            Cnt1M1 = Zero
            do iM1xp=1,dbsc(iCnttp)%nM1
              Gam = dbsc(iCnttp)%M1xp(iM1xp)
              CffM1 = dbsc(iCnttp)%M1cf(iM1xp)
              Cnt0M1 = Cnt0M1+(CffM1*exp(-Gam*r12**2))
              Cnt1M1 = Cnt1M1+Gam*(CffM1*exp(-Gam*r12**2))
            end do
            fab = fab+Cnt0M1
            dfab = dfab-Two*r12*Cnt1M1
            ! Add contribution from M2 operator
            Cnt0M2 = Zero
            Cnt1M2 = Zero
            do iM2xp=1,dbsc(iCnttp)%nM2
              Gam = dbsc(iCnttp)%M2xp(iM2xp)
              CffM2 = dbsc(iCnttp)%M2cf(iM2xp)
              Cnt0M2 = Cnt0M2+(CffM2*exp(-Gam*r12**2))
              Cnt1M2 = Cnt1M2+Gam*(CffM2*exp(-Gam*r12**2))
            end do
            fab = fab+r12*Cnt0M2
            dfab = dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
          end if
          if (dbsc(jCnttp)%ECP) then
            ! Add contribution from M1 operator
            Cnt0M1 = Zero
            Cnt1M1 = Zero
            do iM1xp=1,dbsc(jCnttp)%nM1
              Gam = dbsc(jCnttp)%M1xp(iM1xp)
              CffM1 = dbsc(jCnttp)%M1cf(iM1xp)
              Cnt0M1 = Cnt0M1+(CffM1*exp(-Gam*r12**2))
              Cnt1M1 = Cnt1M1+Gam*(CffM1*exp(-Gam*r12**2))
            end do
            fab = fab+Cnt0M1
            dfab = dfab-Two*r12*Cnt1M1
            ! Add contribution from M2 operator
            Cnt0M2 = Zero
            Cnt1M2 = Zero
            do iM2xp=1,dbsc(jCnttp)%nM2
              Gam = dbsc(jCnttp)%M2xp(iM2xp)
              CffM2 = dbsc(jCnttp)%M2cf(iM2xp)
              Cnt0M2 = Cnt0M2+(CffM2*exp(-Gam*r12**2))
              Cnt1M2 = Cnt1M2+Gam*(CffM2*exp(-Gam*r12**2))
            end do
            fab = fab+r12*Cnt0M2
            dfab = dfab+(Cnt0M2-Two*r12**2*Cnt1M2)
          end if
          df_dr = (dfab*r12-fab)/r12**2

          if (.not. dbsc(iCnttp)%pChrg) then
            nDisp = IndDsp(mdc+iCnt,iIrrep)
            igu = nIrrep/dc(mdc+iCnt)%nStab
            do iCar=0,2
              dr_dA = (A(iCar+1)-RB(iCar+1))/r12
              iComp = 2**iCar
              if (TstFnc(dc(mdc+iCnt)%iCoSet,iIrrep,iComp,dc(mdc+iCnt)%nStab)) then
                nDisp = nDisp+1
                if (Direct(nDisp)) then
                  Temp(nDisp) = Temp(nDisp)+One/real(igu,kind=wp)*PreFct*dr_dA*df_dr
                end if
              end if
            end do
          end if
        end do
      end do
    end do
  end do
end do
if (iPrint >= 15) then
  Lab = ' OFE Nuclear Repulsion Contribution'
  call PrGrad(Lab,Temp,nGrad,ChDisp)
end if

call mma_deallocate(Charge_B)

call DaXpY_(nGrad,One,Temp,1,Grad,1)

return

end subroutine DrvN1_EMB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine negp(ipdia,ipSigma,rout)
      use ipPage, only: W
      use negpre
      Implicit Real*8 (a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
#include "real.fh"
      integer opout
      Real*8 rout(*)
      Real*8, Allocatable:: Tmp(:), Tmp2(:,:), Tmp3(:,:)
*
      idisk=0
      irc=opout(ipdia)

      Call mma_allocate(Tmp,nConf,Label='Tmp')
      Call mma_allocate(Tmp2,2,lRoots,Label='Tmp2')
      Call mma_allocate(Tmp3,2,lRoots,Label='Tmp3')

      irc=ipin(ipSigma)
      Do i=1,lroots
         Call dDAFILE(luciv,2,Tmp,nconf,idisk)
         Tmp2(1,i)=DDOT_(nconf,rout,1,Tmp,1)
         Tmp2(2,i)=DDOT_(nconf,W(ipSigma)%Vec,1,Tmp,1)
      End Do
      irc=ipout(ipsigma)
      Call dGeMV_('N',2*lroots,2*lroots,One,
     &            SS,2*lroots,Tmp2,1,Zero,Tmp3,1)

      idisk=0
      irc=ipin(ipdia)
      Do i=1,lroots
         Call dDAFILE(luciv,2,Tmp,nconf,idisk)
         Call Exphinvv(W(ipdia)%Vec,Tmp,rout,One,Tmp3(1,i))
         call daxpy_(nConf,Tmp3(2,i),Tmp,1,rout,1)
      End Do

      Call mma_deallocate(Tmp)
      Call mma_deallocate(Tmp2)
      Call mma_deallocate(Tmp3)
*
      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Local_XHole(ipXHole2,dMolExpec,nAtoms,nBas1,nTemp
     &                      ,iCenter,Ttot,Ttot_Inv,Coor
     &                      ,nij,EC,iANr,Bond_Threshold,iPrint
     &                      ,ipXHLoc2)
      Implicit Real*8 (a-h,o-z)

#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"

      Dimension Coor(3,nAtoms), Sq_Temp(nTemp), Ttot_Inv(nTemp)
      Dimension Temp(nTemp), A(3), B(3), d2Loc(nij), EC(3,nij)
      Dimension Ttot(nTemp)
      Dimension iCenter(nBas1), iANr(nAtoms)
      Logical Found
      Real*8, Allocatable:: Dens(:)

*
*---- Binomal stuff
*
      Call Set_Binom()

*
*---- Transform the density matrix to the LoProp basis
*
      Call Qpg_dArray('D1ao',Found,nDenno)
      If (Found .and. nDenno/=0) Then
         Call mma_Allocate(Dens,nDenno,Label='Dens')
      Else
         Write (6,*) 'Local XHole: D1ao not found.'
         Call Abend()
      End If
      Call Get_D1ao(Dens,nDenno)
      Call DSq(Dens,Sq_Temp,1,nBas1,nBas1)
      Call mma_deallocate(Dens)
*
      Call DGEMM_('N','T',
     &            nBas1,nBas1,nBas1,
     &            1.0d0,Sq_Temp,nBas1,
     &            Ttot_Inv,nBas1,
     &            0.0d0,Temp,nBas1)
      Call DGEMM_('N','N',
     &            nBas1,nBas1,nBas1,
     &            1.0d0,Ttot_Inv,nBas1,
     &            Temp,nBas1,
     &            0.0d0,Sq_Temp,nBas1)

*
*---- Transform the exchange-hole stuff to LoProp basis
*
      Call Transmu(Work(ipXHole2),nBas1,Ttot,Temp)

*
*---- Now localize
*
      Do iAtom = 1, nAtoms
        call dcopy_(3,Coor(1,iAtom),1,A,1)
        Do jAtom = 1, iAtom
          call dcopy_(3,Coor(1,jAtom),1,B,1)
*
*-------- Sum up contibutions to the domain ij
*
          Acc=Zero
          iOffO=ipXHole2-1
          Do j = 1, nBas1
            Do i = 1, nBas1
              If ((iCenter(i).eq.iAtom .and.
     &             iCenter(j).eq.jAtom) .or.
     &            (iCenter(i).eq.jAtom .and.
     &             iCenter(j).eq.iAtom)) Then
                ij = (j-1)*nBas1+i
                Acc = Acc + Sq_Temp(ij)*Work(ij+iOffO)
              End If
            End Do
          End Do
          ij=iAtom*(iAtom-1)/2+jAtom
          d2Loc(ij)=Acc
        End Do   ! jAtom
      End Do   ! iAtom

*
* Distributes the contributions from the bonds that doesn't fulfill the requirement
* Bond_Length <= Bond_Threshold*(Bragg_Slater(iAtom)+Bragg_Slater(jAtom) to the
* two atoms involved in the bond.
*
      Call Move_XHole(d2Loc,EC,nAtoms,nij,iANr,Bond_Threshold)
      call dcopy_(nij,d2Loc,1,Work(ipXHLoc2),1)

      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(dMolExpec)
         Call Unused_integer(iPrint)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
C This file contains routines for integrity checks of the Cholesky
C vector buffer. For debugging purposes.
      Subroutine Cho_VecBuf_EnableIntegrityCheck(irc)
C
C     Thomas Bondo Pedersen, September 2012.
C
C     Enable integrity check of buffer: allocate and store norm and sum
C     of each vector in the buffer.
C
      use ChoArr, only: nDimRS
      use ChoSwp, only: InfVec
      use ChoVecBuf, only: CHVBUF, ip_CHVBUF_SYM,
     &                     CHVBFI, ip_CHVBFI_SYM, l_CHVBFI_SYM,
     &                     nVec_in_Buf
      Implicit None
      Integer irc
#include "cholesky.fh"
#include "choprint.fh"
#include "stdalloc.fh"

      Real*8   dDot_, Cho_dSumElm
      external dDot_, Cho_dSumElm

      Integer ip
      Integer iSym
      Integer jVec
      Integer jRed
      Integer ipV
      Integer l_ChVBfI

      ! Set return code
      irc=0

      ! Not implemented in internal run mode (since the buffered vectors
      ! may change length and hence norm and sum, causing too much book
      ! keeping activity for a debug feature).
      If (RUN_MODE.NE.RUN_EXTERNAL) Return

      ! Return if no buffer is allocated
      If (.NOT.Allocated(CHVBUF)) Return

      ! Return if already enabled
      If (Allocated(CHVBFI)) Return

      ! Check that nDimRS is allocated
      If (.NOT.Allocated(nDimRS)) Then
         irc=1
         Return
      End If

      ! Allocate and store norm and sum of each vector in the buffer
      l_ChVBfI=0
      Do iSym=1,nSym
         l_ChVBfI_Sym(iSym)=2*nVec_in_Buf(iSym)
         l_ChVBfI=l_ChVBfI+l_ChVBfI_Sym(iSym)
      End Do
      If (l_ChVBfI.gt.0) Then
         Call mma_allocate(CHVBFI,l_ChVBfI,Label='CHVBFI')
         ip=1
         Do iSym=1,nSym
            ip_ChVBfI_Sym(iSym)=ip
            ip=ip+l_ChVBfI_Sym(iSym)
         End Do
         Do iSym=1,nSym
            ipV=ip_ChVBuf_Sym(iSym)
            ip=ip_ChvBfI_Sym(iSym)
            Do jVec=1,nVec_in_Buf(iSym)
               jRed=InfVec(jVec,2,iSym)
               CHVBFI(ip)=sqrt(dDot_(nDimRS(iSym,jRed),
     &                            CHVBUF(ipV),1,CHVBUF(ipV),1))
               CHVBFI(ip+1)=Cho_dSumElm(CHVBUF(ipV),nDimRS(iSym,jRed))
               ipV=ipV+nDimRS(iSym,jRed)
               ip=ip+2
            End Do
         End Do
         If (iPrint.gt.2) Then
            Call Cho_VecBuf_PrtRef('@NABLE')
         End If
         Write(LuPri,'(A)')
     &   'Cholesky vector buffer integrity checks enabled'
      Else
         Call iZero(l_ChVBfI_Sym,nSym)
         Call iZero(ip_ChVBfI_Sym,nSym)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine Cho_VecBuf_Check()
C
C     Thomas Bondo Pedersen, September 2012.
C
C     Check buffer integrity and stop if corrupted.
C
      Implicit None
#include "cholesky.fh"
      Real*8 Tol
      Logical Verbose
      Character*1 Txt
      Integer irc

      Tol=1.0d-12
      Verbose=.False.
      Txt=' '
      Call Cho_VecBuf_CheckIntegrity(Tol,Verbose,Txt,irc)
      If (irc.ne.0) Then
         Write(LuPri,'(A,I3)')
     &   'Cho_VecBuf_Check: buffer integrity check returned code',irc
         Call Cho_Quit('Cholesky vector buffer corrupted',104)
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine Cho_VecBuf_CheckIntegrity(Tol,Verbose,Txt,irc)
C
C     Thomas Bondo Pedersen, September 2012.
C
C     Check integrity of Cholesky vector buffer and print result.
C     Tol is the tolerance to use for comparing norm and sum.
C     Txt is printed along with the check message if Verbose=.True.
C     (if Verbose=.False. nothing is printed).
C     Return code:
C        irc=0: buffer OK
C        irc=1: buffer corrupted
C
C     A simpler interface is given by Subroutine Cho_VecBuf_Check.
C
      Implicit None
      Real*8  Tol
      Logical Verbose
      Character*(*) Txt
      Integer irc
#include "cholesky.fh"
      Logical Cho_VecBuf_Integrity_OK

      If (Cho_VecBuf_Integrity_OK(Tol,Verbose)) Then
         If (Verbose) Then
            Write(LuPri,'(A,A)')
     &      Txt,' Cholesky vector buffer integrity checked: OK'
            Call Cho_Flush(LuPri)
         End If
         irc=0
      Else
         If (Verbose) Then
            Write(LuPri,'(A,A)')
     &      Txt,' Cholesky vector buffer integrity checked: CORRUPTED'
            Call Cho_Quit('Buffer corrupted',104)
         End If
         irc=1
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Logical Function Cho_VecBuf_Integrity_OK(Tol,Report)
C
C     Thomas Bondo Pedersen, September 2012.
C
C     Check Cholesky vector buffer integrity: compute norm and sum of
C     vectors in the buffer and compare these values to the table
C     generated at buffer initialization.
C
      use ChoArr, only: nDimRS
      use ChoSwp, only: InfVec
      use ChoVecBuf, only: CHVBUF, ip_CHVBUF_SYM,
     &                     CHVBFI, ip_CHVBFI_SYM, l_CHVBFI_SYM,
     &                     nVec_in_Buf
      Implicit None
      Real*8  Tol
      Logical Report
#include "cholesky.fh"

      Logical OK

      Real*8   dDot_, Cho_dSumElm
      external ddot_, Cho_dSumElm


      Real*8 Nrm, Sm

      Integer nErr, iSym, jVec, jRed, n, ipV

      Integer i, j
      Real*8  RefNrm
      Real*8  RefSm
      RefNrm(i,j)=CHVBFI(ip_ChVBfI_Sym(j)+2*(i-1))
      RefSm(i,j)=CHVBFI(ip_ChVBfI_Sym(j)+2*(i-1)+1)

      nErr=0
      If (Allocated(CHVBUF) .and. Allocated(CHVBFI) .and.
     &    Allocated(nDimRS)) Then
         Do iSym=1,nSym
            If (nVec_in_Buf(iSym).gt.0 .and.
     &          l_ChVBfI_Sym(iSym).gt.0) Then
               ipV=ip_ChVBuf_Sym(iSym)
               Do jVec=1,nVec_in_Buf(iSym)
                  jRed=InfVec(jVec,2,iSym)
                  n=nDimRS(iSym,jRed)
                  Nrm=sqrt(dDot_(n,CHVBUF(ipV),1,CHVBUF(ipV),1))
                  Sm=Cho_dSumElm(CHVBUF(ipV),n)
                  OK=abs(Nrm-RefNrm(jVec,iSym)).lt.Tol .and.
     &               abs(Sm-RefSm(jVec,iSym)).lt.Tol
                  If (.not.OK) Then
                     nErr=nErr+1
                     If (Report) Then
                        Write(LuPri,'(A,I7,A,I2,A,I9)')
     &                  'Buffer corrupted: vector',jVec,' sym.',iSym,
     &                  ' dim.',n
                        Write(LuPri,'(3X,1P,3(A,D25.16))')
     &                  'Norm=',Nrm,' Reference=',RefNrm(jVec,iSym),
     &                  ' Diff=',Nrm-RefNrm(jVec,iSym)
                        Write(LuPri,'(3X,1P,3(A,D25.16))')
     &                  'Sum= ',Sm,' Reference=',RefSm(jVec,iSym),
     &                  ' Diff=',Sm-RefSm(jVec,iSym)
                     End If
                  End If
                  ipV=ipV+n
               End Do
            End If
         End Do
      End If
      If (Report) Then
         If (nErr.ne.0) Then
            Write(LuPri,'(A,I7,A,1P,D25.16)')
     &      'Buffer corrupted for ',nErr,' vectors. Tolerance=',Tol
         Else
            Write(LuPri,'(A,1P,D25.16)')
     &      'Buffer integrity OK. Tolerance=',Tol
         End If
      End If
      Cho_VecBuf_Integrity_OK=nErr.eq.0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine Cho_VecBuf_CompareNormAndSum(n,nVec,Vec,J1,iSym,irc)
C
C     Thomas Bondo Pedersen, September 2012.
C
C     Compare norm and sum of vectors against values stored in buffer
C     for Cholesky vectors J1,J1+1,J1+nVec-1 of symmetry iSym stored in
C     array Vec(n,nVec). Comparison is only made for those vectors that
C     are actually stored in the buffer, of course.
C
C     Return codes:
C        irc=0: no differences detected.
C        irc>0: number of vectors for which differences are detected.
C
      use ChoVecBuf, only: CHVBFI, ip_CHVBFI_SYM, nVec_in_Buf
      Implicit None
      Integer n
      Integer nVec
      Real*8  Vec(n,nVec)
      Integer J1
      Integer iSym
      Integer irc

      Real*8   dDot_, Cho_dSumElm
      external ddot_, Cho_dSumElm

      Real*8 Tol
      Parameter (Tol=1.0d-12)

      Integer J0
      Integer mVec
      Integer J

      Real*8 Nrm
      Real*8 Sm

      Integer k, l
      Real*8  RefNorm
      Real*8  RefSum
      RefNorm(k,l)=CHVBFI(ip_ChVBfI_Sym(l)+2*(k-1))
      RefSum(k,l)=CHVBFI(ip_ChVBfI_Sym(l)+2*(k-1)+1)

      irc=0
      If (Allocated(CHVBFI)) Then
         J0=J1-1
         mVec=min(J0+nVec,nVec_in_Buf(iSym))-J0
         Do J=1,mVec
            Nrm=sqrt(dDot_(n,Vec(1,J),1,Vec(1,J),1))
            Sm=Cho_dSumElm(Vec(1,J),n)
            If (abs(RefNorm(J0+J,iSym)-Nrm).gt.Tol .or.
     &          abs(RefSum(J0+J,iSym)-Sm).gt.Tol) Then
               irc=irc+1
            End If
         End Do
      End If

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine Cho_VecBuf_PrtRef(Txt)
C
C     Thomas Bondo Pedersen, September 2012.
C
C     Print reference norm and sum of vectors in buffer.
C     Txt is printed along with the reference values (for
C     identification).
C
      use ChoArr, only: nDimRS
      use ChoSwp, only: InfVec
      use ChoVecBuf, only: CHVBFI, ip_CHVBFI_SYM, nVec_in_Buf
      Implicit None
      Character*(*) Txt
#include "cholesky.fh"


      Integer iSym, jVec, jRed, nDim

      Integer i, j
      Real*8  RefNrm
      Real*8  RefSm
      RefNrm(i,j)=CHVBFI(ip_ChVBfI_Sym(j)+2*(i-1))
      RefSm(i,j)=CHVBFI(ip_ChVBfI_Sym(j)+2*(i-1)+1)

      If (.NOT.Allocated(nDimRS)) Then
         Call Cho_Quit(
     &        'Cho_VecBuf_PrtRef: unable to print reference values',104)
      End If
      If (Allocated(CHVBFI)) Then
         Do iSym=1,nSym
            Do jVec=1,nVec_in_Buf(iSym)
               jRed=InfVec(jVec,2,iSym)
               nDim=nDimRS(iSym,jRed)
               Write(LuPri,'(A,A,I6,A,I2,A,I9,1P,2(A,D25.16))')
     &         Txt,' Cholesky vector',jVec,
     &         ' sym.',iSym,' dim.',nDim,
     &         '  Norm=',RefNrm(jVec,iSym),' Sum=',RefSm(jVec,iSym)
            End Do
         End Do
      Else
         Write(LuPri,'(A,A)')
     &   Txt,' Cho_VecBuf_PrtRef: no reference values available!'
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GenCoo(Cart,nsAtom,Coor,mTtAtm,Vctrs,nDim,jAnr,iTabAI)

use Symmetry_Info, only: nIrrep, iOper
use Slapaf_Info, only: ANr, Degen, Smmtrc
use Constants, only: Zero, One
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nsAtom, mTtAtm, nDim
real(kind=wp), intent(in) :: Cart(3,nsAtom)
real(kind=wp), intent(out) :: Coor(3,mTtAtm), Vctrs(3*mTtAtm,nDim)
integer(kind=iwp), intent(out) :: jAnr(mTtAtm), iTabAI(2,mTtAtm)
integer(kind=iwp) :: i_Dim, iAtom, iElem, iEnd, ig, iGo, iSt, ix, jDim
real(kind=wp) :: Fact, r(3), x, y, z
logical(kind=iwp) :: New

!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('GenCoo: Cart',' ',Cart,3,nsAtom)
call RecPrt('GenCoo: Degen',' ',Degen,3,nsAtom)
#endif

! Loop over list of symmetry unique centers

iSt = 1
i_Dim = 0
do iAtom=1,nsAtom
  Fact = One/sqrt(Degen(1,iAtom))
  iEnd = iSt
  jDim = i_Dim
  Coor(:,iSt) = Cart(:,iAtom)
  iTabAI(1,iEnd) = iAtom
  iTabAI(2,iEnd) = iOper(0)
  jAnr(iEnd) = Anr(iAtom)
  do ix=1,3
    if (Smmtrc(ix,iAtom)) then
      jDim = jDim+1
      Vctrs(:,jDim) = Zero
      Vctrs((iEnd-1)*3+ix,jDim) = Fact
    end if
  end do

  ! Loop over the operators of the point group

  iElem = 1
  do ig=1,nIrrep-1
    r(1) = One
    if (btest(iOper(ig),0)) r(1) = -One
    r(2) = One
    if (btest(iOper(ig),1)) r(2) = -One
    r(3) = One
    if (btest(iOper(ig),2)) r(3) = -One
    x = r(1)*Cart(1,iAtom)
    y = r(2)*Cart(2,iAtom)
    z = r(3)*Cart(3,iAtom)

    New = .true.
    do iGo=iSt,iEnd
      if (New .and. (x == Coor(1,iGo)) .and. (y == Coor(2,iGo)) .and. (z == Coor(3,iGo))) New = .false.
    end do
    if (New) then
      iElem = iElem+1
      iEnd = iEnd+1
      Coor(1,iEnd) = x
      Coor(2,iEnd) = y
      Coor(3,iEnd) = z
      iTabAI(1,iEnd) = iAtom
      iTabAI(2,iEnd) = iOper(ig)
      jAnr(iEnd) = Anr(iAtom)
      jDim = i_Dim
      do ix=1,3
        if (Smmtrc(ix,iAtom)) then
          jDim = jDim+1
          Vctrs((iEnd-1)*3+ix,jDim) = r(ix)*Fact
        end if
      end do
    end if
  end do      ! End loop over operators

  do ix=1,3
    if (Smmtrc(ix,iAtom)) i_Dim = i_Dim+1
  end do
  iSt = iEnd+1
end do         ! End loop over centers

#ifdef _DEBUGPRINT_
call RecPrt(' In GenCoo: Coor',' ',Coor,3,mTtAtm)
call RecPrt(' In GenCoo: Vctrs',' ',Vctrs,3*mTtAtm,nDim)
write(u6,*)
write(u6,*) ' iTabAI'
write(u6,*)
do iAtom=1,mTtAtm
  write(u6,*) iTabAI(1,iAtom),iTabAI(2,iAtom)
end do
#endif

return

end subroutine GenCoo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3div(wrk,wrksize,w,v,d1,d2,typdiv,i,j,k,symi,symj,symk,ec,rc)
! w      - W (Input)
! v      - V (Input)
! d1     - 1st diagonal el. (Input)
! d2     - 2nd diagonal el. (Input)
!          (if there is only one spin, use any map's for 2)
! typdiv - typ of operation (see Table) (Input)
! i      - value of occupied index i (Inlut)
! j      - value of occupied index j (Inlut)
! k      - value of occupied index k (Inlut)
! symi   - symmetry of index i (Input)
! symj   - symmetry of index j (Input)
! symk   - symmetry of index k (Input)
! ec     - energy contribution from this part (Output)
! rc     - return (error) code (Output)
!
! this routine realizes division by denominators and
! calculate corresponding energy contribution
!
! ec = sum (abc) [ W(abc).V(abc) / Dijkabc ]
!
! for following types of W,V
!
! typdiv         Operation                Implemented
! 1     W(abc)  . V(abc) /Dijkabc           Yes
! 2     W(ab,c) . W(ab,c)/Dijkabc           Yes
! 3     W(a,bc) . V(a,bc)/Dijkabc           Yes
!
! N.B. spin combinations aaa,bbb for 1; aab for 2; and abb for 3
! are automatically assumed

use CCT3_global, only: dimm, Map_Type, noa, nob
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, typdiv, i, j, k, symi, symj, symk
real(kind=wp), intent(in) :: wrk(wrksize)
type(Map_Type), intent(in) :: w, v, d1, d2
real(kind=wp), intent(out) :: ec
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp) :: dima, dimb, dimc, id1, id2, id3, indx, iw, nhelp1, nhelp2, nhelp3, nhelp4, nhelp5, nhelp6, posd1, posd2, &
                     posd3, posv, posw, syma, symb, symc
real(kind=wp) :: denijk, eco

!0.*  some tests

if (w%d(0,6) /= v%d(0,6)) then
  ! RC=1 : typW is not equal to typV (Stup)
  rc = 1
  return
end if

if ((typdiv == 1) .and. (w%d(0,6) /= 5)) then
  ! RC=2 : typdiv=1, typW is not 5 (Stup)
  rc = 2
  return
end if

if ((typdiv == 2) .and. (w%d(0,6) /= 1)) then
  ! RC=3 : typdiv=2, typW is not 1 (Stup)
  rc = 3
  return
end if

if ((typdiv == 3) .and. (w%d(0,6) /= 2)) then
  ! RC=4 : typdiv=3, typW is not 2 (Stup)
  rc = 4
  return
end if

!0.* vanish ec

ec = Zero

!0.* def denijk

if (typdiv == 1) then
  ! cases aaa,bbb

  ! diagonal part i
  id1 = d1%i(symi,1,1)
  posd1 = d1%d(id1,1)
  indx = posd1+i-1
  denijk = wrk(indx)

  ! diagonal part j
  id1 = d1%i(symj,1,1)
  posd1 = d1%d(id1,1)
  indx = posd1+j-1
  denijk = denijk+wrk(indx)

  ! diagonal part k
  id1 = d1%i(symk,1,1)
  posd1 = d1%d(id1,1)
  indx = posd1+k-1
  denijk = denijk+wrk(indx)

else if (typdiv == 2) then
  ! case aab

  ! diagonal part i
  id1 = d1%i(symi,1,1)
  posd1 = d1%d(id1,1)
  indx = posd1+i-1
  denijk = wrk(indx)

  ! diagonal part j
  id1 = d1%i(symj,1,1)
  posd1 = d1%d(id1,1)
  indx = posd1+j-1
  denijk = denijk+wrk(indx)

  ! diagonal part k
  id2 = d2%i(symk,1,1)
  posd2 = d2%d(id2,1)
  indx = posd2+k-1
  denijk = denijk+wrk(indx)

else if (typdiv == 3) then
  ! case abb

  ! diagonal part i
  id1 = d1%i(symi,1,1)
  posd1 = d1%d(id1,1)
  indx = posd1+i-1
  denijk = wrk(indx)

  ! diagonal part j
  id2 = d2%i(symj,1,1)
  posd2 = d2%d(id2,1)
  indx = posd2+j-1
  denijk = denijk+wrk(indx)

  ! diagonal part k
  id2 = d2%i(symk,1,1)
  posd2 = d2%d(id2,1)
  indx = posd2+k-1
  denijk = denijk+wrk(indx)

end if

if (typdiv == 1) then
  !1 case W(pqr). V(pqr)

  do iw=1,w%d(0,5)

    !1.* def position of W,V
    posw = w%d(iw,1)
    posv = v%d(iw,1)

    !1.* def symmetry status
    syma = w%d(iw,3)
    symb = w%d(iw,4)
    symc = w%d(iw,5)

    !1.* def dimensions
    dima = dimm(w%d(0,1),syma)
    dimb = dimm(w%d(0,2),symb)
    dimc = dimm(w%d(0,3),symc)

    !1.* realize packing

    if (syma == symc) then
      !1.a case syma=symb=symc

      !1.a.* find address for d1,2,3 (the same one)
      id1 = d1%i(syma,1,1)

      !1.a.* def position of d1,2,3 (the same one)
      posd1 = d1%d(id1,1)

      !1.a.* def additional dimensions
      nhelp1 = dima*(dima-1)*(dima-2)/6
      nhelp2 = dimm(5,syma)
      if (w%d(0,1) == 3) then
        ! alpha cese
        nhelp3 = noa(syma)
      else
        ! beta case
        nhelp3 = nob(syma)
      end if

      !1.a.* do packing
      call t3dhlp4(wrk(posw),wrk(posv),dima,nhelp1,denijk,eco,wrk(posd1),nhelp2,nhelp3)
      ec = ec+eco

    else if (syma == symb) then
      !1.b case syma=symb/=symc

      !1.b.* find address for d1,3
      id1 = d1%i(syma,1,1)
      id3 = d1%i(symc,1,1)

      !1.b.* def position of d1,3
      posd1 = d1%d(id1,1)
      posd3 = d1%d(id3,1)

      !1.b.* def additional dimensions
      nhelp1 = dima*(dima-1)/2
      nhelp2 = dimm(5,syma)
      nhelp3 = dimm(5,symc)
      if (w%d(0,1) == 3) then
        ! alpha cese
        nhelp4 = noa(syma)
        nhelp5 = noa(symc)
      else
        ! beta case
        nhelp4 = nob(syma)
        nhelp5 = nob(symc)
      end if

      !1.b.* do packing
      call t3dhlp2(wrk(posw),wrk(posv),dima,nhelp1,dimc,denijk,eco,wrk(posd1),wrk(posd3),nhelp2,nhelp3,nhelp4,nhelp5)
      ec = ec+eco

    else if (symb == symc) then
      !1.c case syma/=symb=symc

      !1.c.* find address for d1,2
      id1 = d1%i(syma,1,1)
      id2 = d1%i(symb,1,1)

      !1.c.* def position of d1,2
      posd1 = d1%d(id1,1)
      posd2 = d1%d(id2,1)

      !1.c.* def additional dimensions
      nhelp1 = dimb*(dimb-1)/2
      nhelp2 = dimm(5,syma)
      nhelp3 = dimm(5,symb)
      if (w%d(0,1) == 3) then
        ! alpha cese
        nhelp4 = noa(syma)
        nhelp5 = noa(symb)
      else
        ! beta case
        nhelp4 = nob(syma)
        nhelp5 = nob(symb)
      end if

      !1.c.* do packing
      call t3dhlp3(wrk(posw),wrk(posv),dima,dimb,nhelp1,denijk,eco,wrk(posd1),wrk(posd2),nhelp2,nhelp3,nhelp4,nhelp5)
      ec = ec+eco

    else
      !1.d case syma/=symb/=symc

      !1.d.* find address for d1,2,3
      id1 = d1%i(syma,1,1)
      id2 = d1%i(symb,1,1)
      id3 = d1%i(symc,1,1)

      !1.d.* def position of d1,2,3
      posd1 = d1%d(id1,1)
      posd2 = d1%d(id2,1)
      posd3 = d1%d(id3,1)

      !1.d.* def additional dimensions
      nhelp1 = dimm(5,syma)
      nhelp2 = dimm(5,symb)
      nhelp3 = dimm(5,symc)
      if (w%d(0,1) == 3) then
        ! alpha cese
        nhelp4 = noa(syma)
        nhelp5 = noa(symb)
        nhelp6 = noa(symc)
      else
        ! beta case
        nhelp4 = nob(syma)
        nhelp5 = nob(symb)
        nhelp6 = nob(symc)
      end if

      !1.d.* do packing
      call t3dhlp1(wrk(posw),wrk(posv),dima,dimb,dimc,denijk,eco,wrk(posd1),wrk(posd2),wrk(posd3),nhelp1,nhelp2,nhelp3,nhelp4, &
                   nhelp5,nhelp6)
      ec = ec+eco

    end if

  end do

else if (typdiv == 2) then
  !2 case W(pq,r) . V(pq,r)

  do iw=1,w%d(0,5)

    !2.* def position of W,W
    posw = w%d(iw,1)
    posv = v%d(iw,1)

    !2.* def symmetry status
    syma = w%d(iw,3)
    symb = w%d(iw,4)
    symc = w%d(iw,5)

    !2.* def dimensions
    dima = dimm(w%d(0,1),syma)
    dimb = dimm(w%d(0,2),symb)
    dimc = dimm(w%d(0,3),symc)

    !2.* realize packing

    if (syma == symb) then
      !2.a case syma=symb,symc

      !2.a.* find address for d1,3
      id1 = d1%i(syma,1,1)
      id3 = d2%i(symc,1,1)

      !2.a.* def position of d1,3
      posd1 = d1%d(id1,1)
      posd3 = d2%d(id3,1)

      !2.a.* def additional dimensions
      nhelp1 = dima*(dima-1)/2
      nhelp2 = dimm(5,syma)
      nhelp3 = dimm(5,symc)
      nhelp4 = noa(syma)
      nhelp5 = nob(symc)

      !2.a.* do packing
      call t3dhlp2(wrk(posw),wrk(posv),dima,nhelp1,dimc,denijk,eco,wrk(posd1),wrk(posd3),nhelp2,nhelp3,nhelp4,nhelp5)
      ec = ec+eco

    else
      !2.b case syma/=symb,symc

      !2.b.* find address for d1,2,3
      id1 = d1%i(syma,1,1)
      id2 = d1%i(symb,1,1)
      id3 = d2%i(symc,1,1)

      !2.b.* def position of d1,2,3
      posd1 = d1%d(id1,1)
      posd2 = d1%d(id2,1)
      posd3 = d2%d(id3,1)

      !2.b.* def additional dimensions
      nhelp1 = dimm(5,syma)
      nhelp2 = dimm(5,symb)
      nhelp3 = dimm(5,symb)
      nhelp4 = noa(syma)
      nhelp5 = noa(symb)
      nhelp6 = nob(symc)

      !2.b.* do packing
      call t3dhlp1(wrk(posw),wrk(posv),dima,dimb,dimc,denijk,eco,wrk(posd1),wrk(posd2),wrk(posd3),nhelp1,nhelp2,nhelp3,nhelp4, &
                   nhelp5,nhelp6)
      ec = ec+eco

    end if

  end do

else if (typdiv == 3) then
  !3 case B(p,qr) = B(p,qr) + ns*(A(p,r,q)-A(p,q,r))

  do iw=1,w%d(0,5)

    !3.* def position of W,V
    posw = w%d(iw,1)
    posv = v%d(iw,1)

    !3.* def symmetry status
    syma = w%d(iw,3)
    symb = w%d(iw,4)
    symc = w%d(iw,5)

    !3.* def dimensions
    dima = dimm(w%d(0,1),syma)
    dimb = dimm(w%d(0,2),symb)
    dimc = dimm(w%d(0,3),symc)

    !3.* realize packing

    if (symb == symc) then
      !3.a case syma,symb=symc

      !3.a.* find address for d1,2
      id1 = d1%i(syma,1,1)
      id2 = d2%i(symb,1,1)

      !3.a.* def position of d1,2
      posd1 = d1%d(id1,1)
      posd2 = d2%d(id2,1)

      !3.a.* def additional dimensions
      nhelp1 = dimb*(dimb-1)/2
      nhelp2 = dimm(5,syma)
      nhelp3 = dimm(5,symb)
      nhelp4 = noa(syma)
      nhelp5 = nob(symb)

      !3.a.* do packing
      call t3dhlp3(wrk(posw),wrk(posv),dima,dimb,nhelp1,denijk,eco,wrk(posd1),wrk(posd2),nhelp2,nhelp3,nhelp4,nhelp5)
      ec = ec+eco

    else
      !3.b case syma,symb/=symc

      !3.b.* find address for d1,2,3
      id1 = d1%i(syma,1,1)
      id2 = d2%i(symb,1,1)
      id3 = d2%i(symc,1,1)

      !3.b.* def position of d1,2,3
      posd1 = d1%d(id1,1)
      posd2 = d2%d(id2,1)
      posd3 = d2%d(id3,1)

      !3.b.* def additional dimensions
      nhelp1 = dimm(5,syma)
      nhelp2 = dimm(5,symb)
      nhelp3 = dimm(5,symc)
      nhelp4 = noa(syma)
      nhelp5 = nob(symb)
      nhelp6 = nob(symc)

      !3.b.* do packing
      call t3dhlp1(wrk(posw),wrk(posv),dima,dimb,dimc,denijk,eco,wrk(posd1),wrk(posd2),wrk(posd3),nhelp1,nhelp2,nhelp3,nhelp4, &
                   nhelp5,nhelp6)
      ec = ec+eco

    end if

  end do

else
  ! RC=5 , typdiv is not 1,2,3 (NCI)
  rc = 5
  return

end if

return

end subroutine t3div

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GTJK(       RJ,       RK,    NTOOB,      SCR,   IREOTS,
     &                   IREOST)
*
* Interface routine for obtaining Coulomb (RJ) and
* Exchange integrals (RK)
*
* Ordering of intgrals is in the internal order
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "mxpdim.fh"
#include "crun.fh"
*.Input
      DIMENSION IREOTS(*), IREOST(*)
*.Output
      DIMENSION RJ(NTOOB,NTOOB),RK(NTOOB,NTOOB)
*.Scratch
      DIMENSION SCR(2*NTOOB ** 2)
        CALL GTJK_RASSCF(RJ,RK,NTOOB,IREOST)
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' RJ and RK from GTJK '
        CALL WRTMAT(RJ,NTOOB,NTOOB,NTOOB,NTOOB)
        CALL WRTMAT(RK,NTOOB,NTOOB,NTOOB,NTOOB)
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_real_array(SCR)
        CALL Unused_integer_array(IREOTS)
      END IF
      END

* Working on EXPHAM
* some known problems :
*     1 : if CSF are used diagonal is not delivered to H0mat

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995,1998, Niclas Forsberg                             *
!               1995,1998, Anders Bernhardsson                         *
!               2009, Giovanni Ghigo                                   *
!***********************************************************************

subroutine Mk_nIncDec(m_max,nOrd,msiz,mInc,mDec,mMat,Graph2,nOsc)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: m_max, nOrd, msiz, nOsc, mMat(0:nOrd,nOsc), Graph2(m_max+1,m_max+1,nOsc)
integer(kind=iwp), intent(out) :: mInc(0:msiz,nOsc), mDec(0:msiz,nOsc)
integer(kind=iwp) :: i, iv, j
integer(kind=iwp), external :: iDetnr
integer(kind=iwp), allocatable :: iVec(:)

call mma_allocate(iVec,nOsc,label='iVec')

! Create mInc.

mInc(:,:) = -1
do i=0,msiz
  iVec(:) = mMat(i,:)
  do j=1,nOsc
    iVec(j) = iVec(j)+1
    mInc(i,j) = iDetnr(iVec,Graph2,nosc,m_max)
    iVec(j) = iVec(j)-1
  end do
end do

! Create mDec.

mDec(0,:) = -1
do i=1,msiz
  do j=1,nOsc
    if (mMat(i,j) /= 0) then
      iVec(:) = mMat(i,:)
      iVec(j) = iVec(j)-1
      mDec(i,j) = iDetnr(iVec,Graph2,nosc,m_max)
      do iv=1,nOsc
        iVec(iv) = iVec(j)+1
      end do
    else
      mDec(i,j) = -1
    end if
  end do
end do

call mma_deallocate(iVec)

return

end subroutine Mk_nIncDec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SS_DRL_ACT_BL_SGT0(LIN,LRA)
!=======================================================================
!SS(1)    ACT -BL-
!SS(1-20) Drl(33)-C"(11)-C"(22)-
!SS(1-20) (11)Drl(33)-C"(22)-
!SS(1-20) (11)(22)Drl(33)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
!SS(1-16) (11)-Drl(22)-
          IF(JML.NE.MUL_TAB(LMI,LMJ).OR.JMR.NE.MUL_TAB(LMI,LMJ)) CYCLE
          IWDL=JUST(LRJ,LRI)
          IWDR=IWDL
         DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_SS(16)
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_SS(16)
          ENDDO
          CALL Drl_BL_EXT_AR_NEW(LIN,LRJ,LRA)
!SS(1-18) Drl(11)-C"(22)-
         DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_SS(18)
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_SS(18)
          ENDDO
          CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
!SS(1-20) Drl(33)-C"(11)-C"(22)-
!SS(1-20) (11)Drl(33)-C"(22)-
!SS(1-20) (11)(22)Drl(33)-
         DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_SS(20)
            VPLP_W1(MPL)=0.D0
          ENDDO
          IF(LRA.GT.NORB_DZ) THEN
            call Drl_BL_SUM_AR_new(LIN,LRI,LRJ,LRA)
          ELSE
            DO LRK=1,NORB_DZ
              IF(LRK.EQ.LRI) CYCLE
              IF(LRK.EQ.LRJ) CYCLE
              CALL Drl_BL_EXT_AR_NEW(LIN,LRK,LRA)
            ENDDO
          ENDIF
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE SS_ARBL_ACT_BL_SGT0(LIN,LRA)
!=======================================================================
!SS(1)    ACT -BL-
!SS(1-1)  Ar(01)-Bl(32)-
!SS(1-3)  Ar(13)-Bl(20)-
!SS(1-6)  (11)-Ar(23)-Bl(32)-
!SS(1-7)  Ar(13)-C'(21)-Bl(32)-
!SS(1-8)  Ar(13)-C'(22)-Bl(31)-
!SS(1-9)  Ar(23)-C'(11)-Bl(32)-
!SS(1-11) Ar(13)-Bl(31)-C"(22)-
!SS(1-12) Ar(13)-Bl(32)-C"(21)-
!SS(1-13) Ar(23)-Bl(31)-C"(12)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=MUL_TAB(JML,JMR)
      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JMLR) CYCLE
          IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
          intpos=INTIND_IJKA(IJK)
!-------------------------------------------------------------------
          W0SS1=W0_SS(1)
          W1SS1=W1_SS(1)
          W0SS3=W0_SS(3)
          W1SS3=W1_SS(3)
          W0SS6=W0_SS(6)
          W1SS6=W1_SS(6)
          W0SS7=W0_SS(7)
          W1SS7=W1_SS(7)
          W0SS8=W0_SS(8)
          W1SS8=W1_SS(8)
          W0SS9=W0_SS(9)
          W1SS9=W1_SS(9)
          W0SS11=W0_SS(11)
          W1SS11=W1_SS(11)
          W0SS12=W0_SS(12)
          W1SS12=W1_SS(12)
          W0SS13=W0_SS(13)
          W1SS13=W1_SS(13)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W0SS1=-W0SS1
            W1SS1=-W1SS1
            W0SS3=-W0SS3
            W1SS3=-W1SS3
            W0SS6=-W0SS6
            W1SS6=-W1SS6
            W0SS7=-W0SS7
            W1SS7=-W1SS7
            W0SS8=-W0SS8
            W1SS8=-W1SS8
            W0SS9=-W0SS9
            W1SS9=-W1SS9
            W0SS11=-W0SS11
            W1SS11=-W1SS11
            W0SS12=-W0SS12
            W1SS12=-W1SS12
            W0SS13=-W0SS13
            W1SS13=-W1SS13
         ENDIF
!SS(1-1)  Ar(01)-Bl(32)-
          IF(JML.EQ.1) THEN
            IWDL=JUST(LRI,LRI)
            IWDR=JUST(LRJ,LRI)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS1
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS1
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
!SS(1-3)  Ar(13)-Bl(20)-
          IF(JMR.EQ.1) THEN
            IWDL=JUST(LRJ,LRI)
            IWDR=JUST(LRJ,LRJ)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS3
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS3
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
          CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
!-------------------------------------------------------------------
!SS(1-6)  (11)-Ar(23)-Bl(32)-
          DO LRK=NORB_FRZ+1,LRI-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS6
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS6
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
!-------------------------------------------------------------------
!SS(1-7)  Ar(13)-C'(21)-Bl(32)-
          DO LRK=LRI+1,LRJ-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SS7
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SS7
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!SS(1-8)  Ar(13)-C'(22)-Bl(31)-
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SS8
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SS8
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!SS(1-9)  Ar(23)-C'(11)-Bl(32)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SS9
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SS9
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
!-------------------------------------------------------------------
!SS(1-11) Ar(13)-Bl(31)-C"(22)-
          DO LRK=LRJ+1,NORB_DZ
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS11
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS11
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!SS(1-12) Ar(13)-Bl(32)-C"(21)-
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS12
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS12
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!SS(1-13) Ar(23)-Bl(31)-C"(12)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS13
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS13
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
!-------------------------------------------------------------------
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE ST_ARBL_ACT_BL_SGT0(LIN,LRA)
!*********************************
!ST(2-3) Ar(13)-C'(22)-Bl(32)-
!ST(2-3) Ar(13)-Bl(32)-C'(22)-
!*********************************
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=MUL_TAB(JML,JMR)
      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(LMIJ.NE.JMLR) CYCLE

        W1ST3=W1_ST(3)
        NI=MOD(LRJ-LRI,2)
        IF(NI.EQ.0) W1ST3=-W1ST3

        IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
        intpos=INTIND_IJKA(IJK)
!-------------------------------------------------------------------
!ST(2-3) Ar(13)-C'(22)-Bl(32)-
          DO LRK=LRI+1,LRJ-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRK,LRJ)      !
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1ST3
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
          CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
!ST(2-3) Ar(13)-Bl(32)-C'(22)-
          DO LRK=LRJ+1,NORB_DZ
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRJ,LRK)      !
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST3
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
          CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE ST_DRL_ACT_BL_SGT0(LIN,LRA)
!ST(2-7) Drl(12)-C"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(LMIJ.NE.JML) CYCLE
!-------------------------------------------------------------------
!ST(2-7) Drl(12)-C"(22)-
          IWDL=JUST(LRJ,LRI)
          IWDR=JUST(LRI,LRJ)             !
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(7)
          ENDDO
          CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
        ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE TS_ARBL_ACT_BL_SGT0(LIN,LRA)
!=======================================================================
!TS(3) A&R-B^L-  ACT -B&L ............................................
!TS(3-3) Ar(23)-Bl(31)-C"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=MUL_TAB(JML,JMR)
      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JMLR) CYCLE
          IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
          intpos=INTIND_IJKA(IJK)
!-------------------------------------------------------------------
          W1TS3=W1_TS(3)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W1TS3=-W1TS3
          ENDIF
!TS(3-3) Ar(23)-Bl(31)-C"(22)-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TS3
          ENDDO
          DO LRK=LRJ+1,NORB_DZ
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IWDL=JUST(LRI,LRK)             !
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE STT_ARBL_ACT_BL_SGT1(LIN,LRA)
!=======================================================================
!STT(4) A&R-B^L-  ACT -B&L ............................................
!ST1(4-1) Ar(01)-Bl(31)-
!ST1(4-2) Ar(23)-Bl(31)-
!ST1(4-3) Ar(13)-C'(21)-Bl(31)-
!ST1(4-3) Ar(13)-Bl(31)-C"(21)-
!ST1(4-4) Ar(23)-C'(11)-Bl(31)-
!ST1(4-4) Ar(23)-Bl(31)-C"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=MUL_TAB(JML,JMR)
      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        W1ST1=W1_ST1(1)
        W1ST2=W1_ST1(2)
        W1ST3=W1_ST1(3)
        W1ST4=W1_ST1(4)
        IF(MOD(LRJ-LRI,2).EQ.0) THEN
          W1ST1=-W1ST1
          W1ST2=-W1ST2
          W1ST3=-W1ST3
          W1ST4=-W1ST4
        ENDIF
        IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ) !???
        intpos=INTIND_IJKA(IJK)                         !???
!ST1(4-1) Ar(01)-Bl(31)-
!ST1(4-2) Ar(23)-Bl(31)-
        IF(JML.EQ.1.AND.JMR.EQ.LMIJ) THEN
          IWDL=JUST(LRI,LRI)
          IWDR=JUST(LRI,LRJ)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST1
          ENDDO
          CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ENDIF
!ST1(4-2) (11)Ar(23)-Bl(31)-
        DO LRK=NORB_FRZ+1,LRI-1
          LMK=LSM_INN(LRK)
         IF(JML.EQ.MUL_TAB(LMK,LMI).AND.JMR.EQ.MUL_TAB(LMK,LMJ)) THEN
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST2
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
!ST1(4-3) Ar(13)-C'(21)-Bl(31)-
        DO LRK=LRI+1,LRJ-1
          LMK=LSM_INN(LRK)
         IF(JML.EQ.MUL_TAB(LMI,LMK).AND.JMR.EQ.MUL_TAB(LMK,LMJ)) THEN
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1ST3
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!ST1(4-4) Ar(23)-C'(11)-Bl(31)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1ST4
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
!ST1(4-3) Ar(13)-Bl(31)-C"(21)-
        DO LRK=LRJ+1,NORB_DZ
          LMK=LSM_INN(LRK)
         IF(JML.EQ.MUL_TAB(LMI,LMK).AND.JMR.EQ.MUL_TAB(LMJ,LMK)) THEN
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST3
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!ST1(4-4) Ar(23)-Bl(31)-C"(11)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST4
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TTS_ARBL_ACT_BL_SGT1(LIN,LRA)
!=======================================================================
!TTS(5) A&R-B^L-  ACT -B&L ............................................
!T1S(5-1)   Ar(13)-Bl(10)-
!T1S(5-2)   (11)Ar(13)-Bl(32)-
!T1S(5-2)   Ar(13)-C'(11)-Bl(32)-
!T1S(5-3)   Ar(13)-Bl(31)-C"(12)-
!T1S(5-4)   Ar(13)-Bl(32)-C"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=MUL_TAB(JML,JMR)
      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        W1TS1=W1_T1S(1)
        W1TS2=W1_T1S(2)
        W1TS3=W1_T1S(3)
        W1TS4=W1_T1S(4)
        IF(MOD(LRJ-LRI,2).EQ.0) THEN
          W1TS1=-W1TS1
          W1TS2=-W1TS2
          W1TS3=-W1TS3
          W1TS4=-W1TS4
        ENDIF
        IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ) !???
        intpos=INTIND_IJKA(IJK)                         !???
!T1S(5-1)   Ar(13)-Bl(10)-
        IF(JMR.EQ.1.AND.JML.EQ.LMIJ) THEN
          IWDL=JUST(LRI,LRJ)
          IWDR=JUST(LRJ,LRJ)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TS1
          ENDDO
          CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ENDIF
!T1S(5-2)   (11)Ar(13)-Bl(32)-
        DO LRK=NORB_FRZ+1,LRI-1
          LMK=LSM_INN(LRK)
         IF(JML.EQ.MUL_TAB(LMK,LMI).AND.JMR.EQ.MUL_TAB(LMK,LMJ)) THEN
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TS2
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
!T1S(5-2)   Ar(13)-C'(11)-Bl(32)-
        DO LRK=LRI+1,LRJ-1
          LMK=LSM_INN(LRK)
          IF(JML.EQ.MUL_TAB(LMI,LMK).AND.JMR.EQ.MUL_TAB(LMK,LMJ)) THEN
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1TS2
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
!T1S(5-3)   Ar(13)-Bl(31)-C"(12)-
        DO LRK=LRJ+1,NORB_DZ
          LMK=LSM_INN(LRK)
          IF(JML.EQ.MUL_TAB(LMI,LMK).AND.JMR.EQ.MUL_TAB(LMJ,LMK)) THEN
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TS3
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!T1S(5-4)   Ar(13)-Bl(32)-C"(11)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TS4
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TTS_Drl_ACT_BL_SGT1(LIN,LRA)
!T1S(5-5)   (11)Drl(12)-
!T1S(5-6)   Drl(12)-C"(12)-
!T1S(5-7)   Drl(12)-C"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          IF(JML.NE.MUL_TAB(LMI,LMJ).OR.JMR.NE.MUL_TAB(LMI,LMJ)) CYCLE
!T1S(5-5)   (11)Drl(12)-
          IWDL=JUST(LRI,LRJ)
          IWDR=JUST(LRJ,LRI)
         DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_T1S(5)
          ENDDO
          CALL Drl_BL_EXT_AR_NEW(LIN,LRJ,LRA)
!T1S(5-6)   Drl(11)-C"(12)-
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_T1S(6)
          ENDDO
          CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
!T1S(5-7)   Drl(12)-C"(11)-
          IWDL=JUST(LRI,LRJ)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_T1S(7)
          ENDDO
          CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE SDD_ABB_ACT_C_SGT0(LIN)
!SD1(8-5)    Ar(13)-Br(23)-BR(31)-
!SD1(8-6)    Ar(23)-Br(13)-BR(31)-
!SD1(8-7)    Ar(13)-Bl(31)-BL(23)-
!SD1(8-8)    Ar(23)-Bl(31)-BL(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        DO LRK=LRJ+1,NORB_DZ
          LMK=LSM_INN(LRK)
          W0SD5=W0_SD1(5)
          W1SD5=W1_SD1(5)
          W0SD6=W0_SD1(6)
          W1SD6=W1_SD1(6)
          W0SD7=W0_SD1(7)
          W1SD7=W1_SD1(7)
          W0SD8=W0_SD1(8)
          W1SD8=W1_SD1(8)
          NI=MOD(LRJ-LRI+NORB_DZ-LRK,2)
          IF(NI.EQ.0) THEN
            W0SD5=-W0SD5
            W1SD5=-W1SD5
            W0SD6=-W0SD6
            W1SD6=-W1SD6
            W0SD7=-W0SD7
            W1SD7=-W1SD7
            W0SD8=-W0SD8
            W1SD8=-W1SD8
         ENDIF
          IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRK-NORB_FRZ)
          INTPOS=INTIND_IJKA(IJK)

          IF(JML.EQ.LMIJ.AND.JMR.EQ.LMK) THEN
!SD1(8-5)    Ar(13)-Br(23)-BR(31)-
            IWDL=JUST(LRJ,LRI)
            IWDR=JUD(LRK)
           DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD5
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD5
            ENDDO
            CALL Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)
!SD1(8-6)    Ar(23)-Br(13)-BR(31)-
            IWDL=JUST(LRI,LRJ)
            IWDR=JUD(LRK)
           DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD6
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD6
            ENDDO
            CALL Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)
          ENDIF
!SD1(8-7)    Ar(13)-Bl(31)-BL(23)-
          IF(JML.EQ.MUL_TAB(LMI,LMK).AND.JMR.EQ.LMJ) THEN
            IWDL=JUST(LRK,LRI)
            IWDR=JUD(LRJ)
           DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD7
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD7
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!SD1(8-8)    Ar(23)-Bl(31)-BL(13)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUD(LRJ)
           DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD8
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD8
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE SDD_DrlBl_ACT_C_SGT0(LIN)
!SD1(8-9)    Drl(33)-BL(01)-
!SD1(8-10) Drl(11)-BL(23)-
!SD1(8-11) (11)Drl(33)-BL(23)-
!SD1(8-11) Drl(33)-C"(11)-BL(23)-
!SD1(8-12) Drl(33)-BL(13)-C'(21)-
!SD1(8-13) Drl(33)-BL(23)-C'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(JML.NE.1.OR.JMR.NE.LMI) CYCLE
        W0SD9=W0_SD1(9)
        W1SD9=W1_SD1(9)
        IF(MOD(NORB_DZ-LRI,2).EQ.1) THEN
          W0SD9=-W0SD9
          W1SD9=-W1SD9
        ENDIF
        DO LRK=1,LRI-1
!SD1(8-9)    Drl(33)-BL(01)-
          IWDL=JUST(LRI,LRI)
          IWDR=JUD(LRI)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD9
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD9
          ENDDO
          CALL Drl_BL_EXT_AR_NEW(LIN,LRK,LRI)
        ENDDO
      ENDDO
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
          W0SD10=W0_SD1(10)
          W1SD10=W1_SD1(10)
          W0SD11=W0_SD1(11)
          W1SD11=W1_SD1(11)
          W0SD12=W0_SD1(12)
          W1SD12=W1_SD1(12)
          W0SD13=W0_SD1(13)
          W1SD13=W1_SD1(13)
          IF(MOD(NORB_DZ-LRJ,2).EQ.1) THEN
            W0SD10=-W0SD10
            W1SD10=-W1SD10
            W0SD11=-W0SD11
            W1SD11=-W1SD11
          ENDIF
          IF(MOD(NORB_DZ-LRI,2).EQ.1) THEN
            W0SD12=-W0SD12
            W1SD12=-W1SD12
            W0SD13=-W0SD13
            W1SD13=-W1SD13
          ENDIF
!SD1(8-10) Drl(11)-BL(23)-
        IF(JML.EQ.MUL_TAB(LMI,LMJ).AND.JMR.EQ.LMI) THEN
          IWDL=JUST(LRJ,LRI)
         IWDR=JUD(LRI)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD10
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD10
          ENDDO
          CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRJ)
        ENDIF
        DO LRK=1,LRI-1
          LMK=LSM_INN(LRK)
!SD1(8-12) Drl(33)-BL(13)-C'(21)-
          IF(JML.EQ.MUL_TAB(LMI,LMJ).AND.JMR.EQ.LMJ) THEN
             IWDL=JUST(LRJ,LRI)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SD12
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SD12
            ENDDO
            CALL Drl_BL_EXT_AR_NEW(LIN,LRK,LRI)
!SD1(8-13) Drl(33)-BL(23)-C'(11)-
            IWDL=JUST(LRI,LRJ)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SD13
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SD13
            ENDDO
            CALL Drl_BL_EXT_AR_NEW(LIN,LRK,LRI)
          ENDIF
         IF(JML.EQ.MUL_TAB(LMI,LMJ).AND.JMR.EQ.LMI) THEN
!SD1(8-11) Drl(33)-C"(11)-BL(23)-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD11
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD11   !?????????
            ENDDO
            IWDL=JUST(LRJ,LRI)
            IWDR=JUD(LRI)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            CALL Drl_BL_EXT_AR_NEW(LIN,LRK,LRJ)
          ENDIF
        ENDDO
        DO LRK=NORB_FRZ+1,LRI-1
          LMK=LSM_INN(LRK)
!SD1(8-11) (11)Drl(33)-BL(23)-
          IF(JML.EQ.MUL_TAB(LMK,LMJ).AND.JMR.EQ.LMK) THEN
            IWDL=JUST(LRJ,LRK)
            IWDR=JUD(LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD11
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD11
            ENDDO
            CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRJ)
          ENDIF
        ENDDO
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE SDD_DrrBR_ACT_C_SGT0(LIN)
!SD1(8-9)    Drr(03)-BR(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      DO LRI=NORB_FRZ+1,NORB_DZ
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        IF(JML.NE.1.OR.JMR.NE.LMJ) CYCLE
        W0SD=W0_SD1(9)
        IF(MOD(NORB_DZ-LRJ,2).EQ.1) W0SD=-W0SD
        IWDL=JUST(LRI,LRI)
        IWDR=JUD(LRJ)
        DO MPL=1,MHLP
           IWAL=LPNEW_LWEI(MPL)
           IWAR=LPNEW_RWEI(MPL)
           LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
           LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD
          VPLP_W1(MPL)=0.D0
        ENDDO
        CALL Drr_BR_EXT_AR(LIN,LRI,LRJ)
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE SDD_Ar_ACT_BrBR_SGT0(LIN,LRA)
!SD1(8-1)    Ar(01)-
!SD1(8-2)    Ar(23)-
!SD1(8-3)    Ar(13)-C'(21)-
!SD1(8-4)    Ar(23)-C'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        W0SD1=W0_SD1(1)
        W1SD1=W1_SD1(1)
        W0SD2=W0_SD1(2)
        W1SD2=W1_SD1(2)
        W0SD3=W0_SD1(3)
        W1SD3=W1_SD1(3)
        W0SD4=W0_SD1(4)
        W1SD4=W1_SD1(4)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1) THEN
          W0SD1=-W0SD1
          W1SD1=-W1SD1
          W0SD2=-W0SD2
          W1SD2=-W1SD2
          W0SD3=-W0SD3
          W1SD3=-W1SD3
          W0SD4=-W0SD4
          W1SD4=-W1SD4
        ENDIF
!SD1(8-1)    Ar(01)-
        IF(JML.EQ.1.AND.JMR.EQ.LMI) THEN
          IWDL=JUST(LRI,LRI)
          IWDR=JUD(LRI)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD1
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD1
          ENDDO
          IJK=LRI-NORB_FRZ+LRA
          INTPOS=INTIND_IJKA(IJK)
          CALL Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)     !!!!!!
        ENDIF
        DO LRJ=NORB_FRZ+1,LRI-1
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(JML.NE.LMIJ) CYCLE
          IF(JMR.EQ.LMJ) THEN
!SD1(8-2)    (11)Ar(23)-
            IWDL=JUST(LRI,LRJ)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD2
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD2
            ENDDO
            IJK=LRI-NORB_FRZ+LRA
            INTPOS=INTIND_IJKA(IJK)
            CALL Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)     !!!!!!
          ENDIF
        ENDDO
!SD1(8-3)    Ar(13)-C'(21)-
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(JML.NE.LMIJ) CYCLE
          IF(JMR.EQ.LMJ) THEN
            IWDL=JUST(LRJ,LRI)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SD3
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SD3
            ENDDO
            IJK=LRI-NORB_FRZ+LRA
            INTPOS=INTIND_IJKA(IJK)
            CALL Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)     !!!!!!
!SD1(8-4)    Ar(23)-C'(11)-
            IWDL=JUST(LRI,LRJ)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SD4
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SD4
            ENDDO
            IJK=LRI-NORB_FRZ+LRA
            INTPOS=INTIND_IJKA(IJK)
            CALL Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)     !!!!!!
          ENDIF
        ENDDO
      ENDDO

      RETURN
      END

!-----------------------------------
      SUBROUTINE SDD_Ar_ACT_BlBL_SGT0(LIN,LRA)
!SD1(8-1)    Ar(01)-
!SD1(8-2)    Ar(23)-
!SD1(8-3)    Ar(13)-C'(21)-
!SD1(8-4)    Ar(23)-C'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        W0SD1=W0_SD1(1)
        W1SD1=W1_SD1(1)
        W0SD2=W0_SD1(2)
        W1SD2=W1_SD1(2)
        W0SD3=W0_SD1(3)
        W1SD3=W1_SD1(3)
        W0SD4=W0_SD1(4)
        W1SD4=W1_SD1(4)
        NI=MOD(NORB_DZ-LRI,2)
        IF(NI.EQ.1) THEN
          W0SD1=-W0SD1
          W1SD1=-W1SD1
          W0SD2=-W0SD2
          W1SD2=-W1SD2
          W0SD3=-W0SD3
          W1SD3=-W1SD3
          W0SD4=-W0SD4
          W1SD4=-W1SD4
        ENDIF
!SD1(8-1)    Ar(01)-
        IF(JML.EQ.1.AND.JMR.EQ.LMI) THEN
          IWDL=JUST(LRI,LRI)
          IWDR=JUD(LRI)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD1
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD1
          ENDDO
          IJK=LRI-NORB_FRZ+LRA
          INTPOS=INTIND_IJKA(IJK)
          CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ENDIF
        DO LRJ=NORB_FRZ+1,LRI-1
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(JML.NE.LMIJ) CYCLE
          IF(JMR.EQ.LMJ) THEN
!SD1(8-2)    (11)Ar(23)-
            IWDL=JUST(LRI,LRJ)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SD2
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SD2
            ENDDO
            IJK=LRI-NORB_FRZ+LRA
            INTPOS=INTIND_IJKA(IJK)
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
!SD1(8-3)    Ar(13)-C'(21)-
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(JML.NE.LMIJ) CYCLE
          IF(JMR.EQ.LMJ) THEN
            IWDL=JUST(LRJ,LRI)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SD3
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SD3
            ENDDO
            IJK=LRI-NORB_FRZ+LRA
            INTPOS=INTIND_IJKA(IJK)
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!SD1(8-4)    Ar(23)-C'(11)-
            IWDL=JUST(LRI,LRJ)
            IWDR=JUD(LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SD4
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SD4
            ENDDO
            IJK=LRI-NORB_FRZ+LRA
            INTPOS=INTIND_IJKA(IJK)
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE DDS_ABB_ACT_C_SGT0(LIN)
!D1S(9-2)    Ar(13)-Bl(31)-BR(32)-
!D1S(9-3)    Ar(13)-Bl(32)-BR(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
         LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
         LMJ=LSM_INN(LRJ)
         DO LRK=LRJ+1,NORB_DZ
           LMK=LSM_INN(LRK)
          W1DS2=W1_D1S(2)
           W1DS3=W1_D1S(3)
           NI=MOD(LRJ-LRI+NORB_DZ-LRK,2)
           IF(NI.EQ.1) THEN
            W1DS2=-W1DS2
             W1DS3=-W1DS3
           ENDIF
           IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRK-NORB_FRZ)
           INTPOS=INTIND_IJKA(IJK)
!D1S(9-2)    Ar(13)-Bl(31)-BR(32)-
           IF(JML.EQ.LMI.AND.JMR.EQ.MUL_TAB(LMJ,LMK)) THEN
             IWDL=JUD(LRI)
             IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
               IWAL=LPNEW_LWEI(MPL)
               IWAR=LPNEW_RWEI(MPL)
               LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
               LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
             ENDDO
             DO MPL=1,MTYPE
               VPLP_W0(MPL)=0.D0
               VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DS2
             ENDDO
             CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
!D1S(9-3)    Ar(13)-Bl(32)-BR(31)-
             IWDL=JUD(LRI)
             IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
               IWAL=LPNEW_LWEI(MPL)
               IWAR=LPNEW_RWEI(MPL)
               LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
               LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
             ENDDO
             DO MPL=1,MTYPE
               VPLP_W0(MPL)=0.D0
               VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DS3
             ENDDO
             CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
         ENDDO
      ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE TTTT_Drl_ACT_BL_SGT1(LIN,LRA)
!T1T1(12-2)  (11)Drl(11)-
!T1T1(12-2)  Drl(11)-C"(11)-
!T1T1(12-3)  (11)Drl(33)-
!T1T1(12-3)  (11)Drl(33)-C"(11)-
!T1T1(12-3)  Drl(33)-C"(11)-C"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      IF(JML.NE.JMR) RETURN
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(JML.NE.LMIJ) CYCLE
!T1T1(12-2)  (11)Drl(11)-
!T1T1(12-2)  Drl(11)-C"(11)-
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_T1T1(2)
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_T1T1(2)
        ENDDO
        IWDL=JUST(LRI,LRJ)
        IWDR=IWDL
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        ENDDO
        CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
        CALL Drl_BL_EXT_AR_NEW(LIN,LRJ,LRA)
!T1T1(12-3)  (11)Drl(33)-
!T1T1(12-3)  (11)Drl(33)-C"(11)-
!T1T1(12-3)  Drl(33)-C"(11)-C"(11)-
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_T1T1(3)
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_T1T1(3)
        ENDDO
        IF(LRA.GT.NORB_DZ) THEN
          CALL Drl_BL_SUM_AR_new(LIN,LRI,LRJ,LRA)
        ELSE
          DO LRK=1,NORB_DZ
            IF(LRK.EQ.LRI) CYCLE
            IF(LRK.EQ.LRJ) CYCLE
            CALL Drl_BL_EXT_AR_NEW(LIN,LRK,LRA)
          ENDDO
        ENDIF
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TTTT_ArBl_ACT_BL_SGT1(LIN,LRA)
!T1T1(12-1)  (11)Ar(13)-Bl(31)-
!T1T1(12-1)  Ar(13)-C'(11)-Bl(31)-
!T1T1(12-1)  Ar(13)-Bl(31)-C"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        W0TT1=W0_T1T1(1)
        W1TT1=W1_T1T1(1)
        IF(MOD(LRJ-LRI,2).EQ.0) THEN
          W0TT1=-W0TT1
          W1TT1=-W1TT1
        ENDIF
        DO LRK=NORB_FRZ+1,LRI-1
          LMK=LSM_INN(LRK)
!T1T1(12-1)  (11)Ar(13)-Bl(31)-
          IF(JML.EQ.MUL_TAB(LMK,LMI).AND.JMR.EQ.MUL_TAB(LMK,LMJ)) THEN
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRK,LRJ)
            IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
            INTPOS=INTIND_IJKA(IJK)
            DO MPL=1,MTYPE
             VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT1
             VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TT1
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
        DO LRK=LRJ+1,NORB_DZ
          LMK=LSM_INN(LRK)
          IF(JML.EQ.MUL_TAB(LMI,LMk).AND.JMR.EQ.MUL_TAB(LMJ,LMK)) THEN
!T1T1(12-1)  Ar(13)-Bl(31)-C"(11)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRJ,LRK)
            IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
            INTPOS=INTIND_IJKA(IJK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
             VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TT1
             VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TT1
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
         ENDIF
        ENDDO
        DO LRK=LRI+1,LRJ-1
          LMK=LSM_INN(LRK)
          IF(JML.EQ.MUL_TAB(LMI,LMK).AND.JMR.EQ.MUL_TAB(LMK,LMJ)) THEN
!T1T1(12-1)  Ar(13)-C'(11)-Bl(31)-
            IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
            INTPOS=INTIND_IJKA(IJK)
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
             VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0TT1
             VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1TT1
            ENDDO
            CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
         ENDIF
        ENDDO
      ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE TTDD_DrlBL_ACT_C_SGT1(LIN)
!T1D1(15-4)  Drl(11)-BL(13)-
!T1D1(15-5)  (11)Drl(33)-BL(13)-
!T1D1(15-5)  Drl(33)-C"(11)-BL(13)-
!T1D1(15-5)  Drl(33)-BL(13)-C'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      DO LRI=NORB_FRZ+1,NORB_DZ
         LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
         LMJ=LSM_INN(LRJ)
         IF(JML.EQ.MUL_TAB(LMI,LMJ).AND.JMR.EQ.LMI) THEN
           IWDL=JUST(LRI,LRJ)
           IWDR=JUD(LRI)
           W0TD4=W0_T1D1(4)
           W1TD4=W1_T1D1(4)
           W0TD5=W0_T1D1(5)
           W1TD5=W1_T1D1(5)
           IF(MOD(NORB_DZ-LRJ,2).EQ.1) THEN
             W0TD4=-W0TD4
             W1TD4=-W1TD4
             W0TD5=-W0TD5
             W1TD5=-W1TD5
           ENDIF
!T1D1(15-4)  Drl(11)-BL(13)-
!T1D1(15-5)  (11)Drl(33)-BL(13)-
           DO MPL=1,MTYPE
             VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TD4
             VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TD4
           ENDDO
           DO MPL=1,MHLP
             IWAL=LPNEW_LWEI(MPL)
             IWAR=LPNEW_RWEI(MPL)
             LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
             LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
           ENDDO
           CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRJ)

           DO MPL=1,MTYPE
             VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TD5
             VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TD5
           ENDDO
           DO LRK=1,LRI-1
!T1D1(15-5)  Drl(33)-C"(11)-BL(13)-
             DO MPL=1,MHLP
               IWAL=LPNEW_LWEI(MPL)
               IWAR=LPNEW_RWEI(MPL)
               LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
               LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
             ENDDO
             CALL Drl_BL_EXT_AR_NEW(LIN,LRK,LRJ)
           ENDDO
!T1D1(15-5)  (11)Drl(33)-BL(13)-
           DO LRK=LRI+1,LRJ-1
             DO MPL=1,MHLP
               IWAL=LPNEW_LWEI(MPL)
               IWAR=LPNEW_RWEI(MPL)
               LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
               LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
             ENDDO
             CALL Drl_BL_EXT_AR_NEW(LIN,LRK,LRJ)
           ENDDO
         ENDIF
         W0TD5=W0_T1D1(5)
         W1TD5=W1_T1D1(5)
         IF(MOD(NORB_DZ-LRI,2).EQ.0) THEN
           W0TD5=-W0TD5
           W1TD5=-W1TD5
         ENDIF
         IF(JML.EQ.MUL_TAB(LMI,LMJ).AND.JMR.EQ.LMJ) THEN
           DO MPL=1,MTYPE
             VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TD5
             VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TD5
           ENDDO
!T1D1(15-5)  Drl(33)-BL(13)-C'(11)-
           DO LRK=1,LRI-1
             IWDL=JUST(LRI,LRJ)
             IWDR=JUD(LRJ)
             DO MPL=1,MHLP
               IWAL=LPNEW_LWEI(MPL)
               IWAR=LPNEW_RWEI(MPL)
               LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
               LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
             ENDDO
             CALL Drl_BL_EXT_AR_NEW(LIN,LRK,LRI)
           ENDDO
         ENDIF
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TTDD_ABB_ACT_C_SGT1(LIN)
!T1D1(15-2)  Ar(13)-Br(13)-BR(31)-
!T1D1(15-3)  Ar(13)-Bl(31)-Bl(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        DO LRK=LRJ+1,NORB_DZ
           LMK=LSM_INN(LRK)
           W1TD2=W1_T1D1(2)
           W0TD3=W0_T1D1(3)
           W1TD3=W1_T1D1(3)
           NI=MOD(LRJ-LRI+NORB_DZ-LRK,2)
           IF(NI.EQ.0) THEN
             W1TD2=-W1TD2
             W0TD3=-W0TD3
             W1TD3=-W1TD3
           ENDIF
           IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRK-NORB_FRZ)
           INTPOS=INTIND_IJKA(IJK)
           IF(JML.EQ.MUL_TAB(LMI,LMJ).AND.JMR.EQ.LMK) THEN
!T1D1(15-2)  Ar(13)-Br(13)-BR(31)-
               IWDL=JUST(LRI,LRJ)
               IWDR=JUD(LRK)
               DO MPL=1,MHLP
                IWAL=LPNEW_LWEI(MPL)
                IWAR=LPNEW_RWEI(MPL)
                LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
                LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
               ENDDO
               DO MPL=1,MTYPE
                 VPLP_W0(MPL)=0.D0
                 VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TD2
               ENDDO
               CALL Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)
           ENDIF
           IF(JML.EQ.MUL_TAB(LMI,LMK).AND.JMR.EQ.LMJ) THEN
!T1D1(15-3)  Ar(13)-Bl(31)-Bl(13)-
               IWDL=JUST(LRI,LRK)
               IWDR=JUD(LRJ)
               DO MPL=1,MHLP
                IWAL=LPNEW_LWEI(MPL)
                IWAR=LPNEW_RWEI(MPL)
                LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
                LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
               ENDDO
               DO MPL=1,MTYPE
                 VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TD3
                 VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TD3
               ENDDO
               CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TTDD_Ar_ACT_BrBR_SGT0(LIN,LRA)
!T1D1(15-1)  (11)Ar(13)-
!T1D1(15-1)  Ar(13)-C'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        W0TD1=W0_T1D1(1)
        W1TD1=W1_T1D1(1)
        IF(MOD(NORB_DZ-LRI,2).EQ.1) THEN
          W0TD1=-W0TD1
          W1TD1=-W1TD1
        ENDIF
      DO LRJ=NORB_FRZ+1,LRI-1
!T1D1(15-1)  (11)Ar(13)-
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(JML.EQ.LMIJ.AND.JMR.EQ.LMJ) THEN
          IWDL=JUST(LRJ,LRI)
          IWDR=JUD(LRJ)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TD1
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TD1
          ENDDO
          IJK=LRI-NORB_FRZ+LRA
          INTPOS=INTIND_IJKA(IJK)
          CALL Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)     !!!!!!
        ENDIF
      ENDDO
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
!T1D1(15-1)  Ar(13)-C'(11)-
        IF(JML.EQ.LMIJ.AND.JMR.EQ.LMJ) THEN
          IWDL=JUST(LRI,LRJ)
          IWDR=JUD(LRJ)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0TD1
            VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1TD1
          ENDDO
          IJK=LRI-NORB_FRZ+LRA
          INTPOS=INTIND_IJKA(IJK)
          CALL Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)     !!!!!!
        ENDIF
      ENDDO
      ENDDO

      RETURN
      END

!------------------------------------------
      SUBROUTINE TTDD_Ar_ACT_BlBL_SGT0(LIN,LRA)
!T1D1(15-1)  (11)Ar(13)-
!T1D1(15-1)  Ar(13)-C'(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        W0TD1=W0_T1D1(1)
        W1TD1=W1_T1D1(1)
        IF(MOD(NORB_DZ-LRI,2).EQ.1) THEN
          W0TD1=-W0TD1
          W1TD1=-W1TD1
        ENDIF
      DO LRJ=NORB_FRZ+1,LRI-1
!T1D1(15-1)  (11)Ar(13)-
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(JML.EQ.LMIJ.AND.JMR.EQ.LMJ) THEN
          IWDL=JUST(LRJ,LRI)
          IWDR=JUD(LRJ)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0TD1
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TD1
          ENDDO
          IJK=LRI-NORB_FRZ+LRA
          INTPOS=INTIND_IJKA(IJK)
          CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ENDIF
      ENDDO
      DO LRJ=LRI+1,NORB_DZ
!T1D1(15-1)  Ar(13)-C'(11)-
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(JML.EQ.LMIJ.AND.JMR.EQ.LMJ) THEN
          IWDL=JUST(LRI,LRJ)
          IWDR=JUD(LRJ)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0TD1
            VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1TD1
          ENDDO
          IJK=LRI-NORB_FRZ+LRA
          INTPOS=INTIND_IJKA(IJK)
          CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
        ENDIF
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE TTV_ArBr_ACT_C_SGT1(LIN,LRA)
!T1V(18) Ar(13)-Br(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      isma=mul_tab(iml,imr)
      DO LRI=NORB_FRZ+1,NORB_DZ
         LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
         LMJ=LSM_INN(LRJ)
         LMIJ=MUL_TAB(LMI,LMJ)
         IF(JML.NE.LMIJ.OR.JMR.NE.1) CYCLE
         W1TV1=W1_T1V
         IF(MOD(LRJ-LRI,2).EQ.0) W1TV1=-W1TV1
         IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
         INTPOS=INTIND_IJKA(IJK)
         IWDL=JUST(LRI,LRJ)
         IWDR=0
         DO MPL=1,MHLP
           IWAL=LPNEW_LWEI(MPL)
           IWAR=LPNEW_RWEI(MPL)
           LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
           LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
         ENDDO
         DO MPL=1,MTYPE
           VPLP_W0(MPL)=0.D0
           VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TV1
         ENDDO
         CALL Ar_Br_BR_EXT_AR_NEW(LIN,INTPOS,ISMA)
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE DDDD_ArBl_ACT_BL_SGT0(LIN,LRA)
!D1D1(20-1) Ar(13)-BL(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
         LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
         LMJ=LSM_INN(LRJ)
         IF(JML.NE.LMI.OR.JMR.NE.LMJ) CYCLE
         W0DD1=W0_D1D1(1)
         W1DD1=W1_D1D1(1)
         IF(MOD(LRJ-LRI,2).EQ.0) THEN
           W0DD1=-W0DD1
           W1DD1=-W1DD1
         ENDIF
         IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
         INTPOS=INTIND_IJKA(IJK)
         IWDL=JUD(LRI)
         IWDR=JUD(LRJ)
         DO MPL=1,MHLP
           IWAL=LPNEW_LWEI(MPL)
           IWAR=LPNEW_RWEI(MPL)
           LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
           LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
         ENDDO
         DO MPL=1,MTYPE
           VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DD1
           VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD1
         ENDDO
         CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE DDDD_Drl_ACT_BL_SGT0(LIN,LRA)
!D1D1(20-2) Drl(11)-
!D1D1(20-3) (11)Drl(33)-
!D1D1(20-3) Drl(33)-C"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      IF(JML.NE.JMR) RETURN
      DO LRI=NORB_FRZ+1,NORB_DZ
         LMI=LSM_INN(LRI)
         IF(JML.NE.LMI) CYCLE
!D1D1(20-2) Drl(11)-
         IWDL=JUD(LRI)
         IWDR=IWDL
         DO MPL=1,MHLP
           IWAL=LPNEW_LWEI(MPL)
           IWAR=LPNEW_RWEI(MPL)
           LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
           LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
         ENDDO
         DO MPL=1,MTYPE
           VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_D1D1(2)
           VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_D1D1(2)
         ENDDO
         CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
         DO MPL=1,MTYPE
           VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_D1D1(3)
           VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_D1D1(3)
         ENDDO
         DO LRJ=1,NORB_DZ
           IF(LRJ.EQ.LRI) CYCLE
!D1D1(20-3) Drl(33)-C"(11)-
!D1D1(20-3) (11)Drl(33)-
           CALL Drl_BL_EXT_AR_NEW(LIN,LRJ,LRA)
         ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE DD1_ArBl_ACT_BL_SGT0(LIN,LRA)
!DD1(21) Ar(23)-Bl(31)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
         LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
         LMJ=LSM_INN(LRJ)
         IF(JML.NE.LMI.OR.JMR.NE.LMJ) CYCLE
         W1DD1=W1_DD1
         IF(MOD(LRJ-LRI,2).EQ.0) THEN
           W1DD1=-W1DD1
         ENDIF
         IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
         INTPOS=INTIND_IJKA(IJK)
         IWDL=JUD(LRI)
         IWDR=JUD(LRJ)
         DO MPL=1,MHLP
           IWAL=LPNEW_LWEI(MPL)
           IWAR=LPNEW_RWEI(MPL)
           LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
           LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
         ENDDO
         DO MPL=1,MTYPE
           VPLP_W0(MPL)=0.D0
           VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD1
         ENDDO
         CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE D1D_ArBl_ACT_BL_SGT0(LIN,LRA)
!DD1(21) Ar(13)-Bl(32)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
         LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
         LMJ=LSM_INN(LRJ)
         IF(JML.NE.LMI.OR.JMR.NE.LMJ) CYCLE
         W1DD1=W1_D1D(1)
         IF(MOD(LRJ-LRI,2).EQ.0) THEN
           W1DD1=-W1DD1
         ENDIF
         IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
         INTPOS=INTIND_IJKA(IJK)
         IWDL=JUD(LRI)
         IWDR=JUD(LRJ)
         DO MPL=1,MHLP
           IWAL=LPNEW_LWEI(MPL)
           IWAR=LPNEW_RWEI(MPL)
           LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
           LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
         ENDDO
         DO MPL=1,MTYPE
           VPLP_W0(MPL)=0.D0
           VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DD1
         ENDDO
         CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE D1D_Drl_ACT_BL_SGT0(LIN,LRA)
!D1D(22-2) Drl(12)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      IF(JML.NE.JMR) RETURN
      DO LRI=NORB_FRZ+1,NORB_DZ
         LMI=LSM_INN(LRI)
         IF(JML.NE.LMI) CYCLE
!D1D(22-2) Drl(12)-
         IWDL=JUD(LRI)
         IWDR=IWDL
         DO MPL=1,MHLP
           IWAL=LPNEW_LWEI(MPL)
           IWAR=LPNEW_RWEI(MPL)
           LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
           LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
         ENDDO
         DO MPL=1,MTYPE
           VPLP_W0(MPL)=0.D0
           VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_D1D(2)
         ENDDO
         CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
      ENDDO

      RETURN
      END

      SUBROUTINE  D1V_Drl_BL_ACT_C_SGT0(LIN)
!D1V(24-1)  Ar(13)-
!D1V(24-2)  Drl(33)-BL(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      ISMA=MUL_TAB(IML,IMR)
      IF(JMR.NE.1) RETURN
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(JML.NE.LMI) CYCLE
        NI=MOD(NORB_DZ-LRI,2)
!D1V(24-1)  Ar(13)-
        W0=W0_D1V(1)
        IF(NI.EQ.1)W0=-W0_D1V(1)
        IWDL=JUD(LRI)
        IWDR=0
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W0
        ENDDO
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
        ENDDO
        CALL Ar_DV_EXT_AR(51,isma,LRI,0)   !ar_dv
!D1V(24-2)  Drl(33)-BL(13)-
        W0=W0_D1V(2)
        IF(NI.EQ.1)W0=-W0_D1V(2)
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0
          VPLP_W1(MPL)=0.D0
        ENDDO
        DO LRJ=1,LRI-1
          CALL Drl_BL_EXT_AR_NEW(LIN,LRJ,LRI)
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE D1V_Ar_ACT_BrBR_SGT0(LIN,LRA)
!D1V(24-1)  Ar(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(JML.NE.LMI.OR.JMR.NE.1) CYCLE
        W0DV1=W0_D1V(1)
        W1DV1=W1_D1V(1)
        IF(MOD(NORB_DZ-LRI,2).EQ.1) THEN
          W0DV1=-W0_D1V(1)
          W1DV1=-W1_D1V(1)
        ENDIF
        IJK=LRI-NORB_FRZ+LRA
        INTPOS=INTIND_IJKA(IJK)
        IWDL=JUD(LRI)
        IWDR=0
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        ENDDO
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DV1
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DV1
        ENDDO
        CALL Ar_Br_Br_EXT_AR_NEW(LIN,INTPOS,ISMA)
      ENDDO

      RETURN
      END

      SUBROUTINE D1V_Ar_ACT_BlBL_SGT0(LIN,LRA)
!D1V(24-1)  Ar(13)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        IF(JML.NE.LMI.OR.JMR.NE.1) CYCLE
        W0DV1=W0_D1V(1)
        W1DV1=W1_D1V(1)
        IF(MOD(NORB_DZ-LRI,2).EQ.1) THEN
          W0DV1=-W0_D1V(1)
          W1DV1=-W1_D1V(1)
        ENDIF
        IJK=LRI-NORB_FRZ+LRA
        INTPOS=INTIND_IJKA(IJK)
        IWDL=JUD(LRI)
        IWDR=0
        DO MPL=1,MHLP
          IWAL=LPNEW_LWEI(MPL)
          IWAR=LPNEW_RWEI(MPL)
          LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
          LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
        ENDDO
        DO MPL=1,MTYPE
          VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0DV1
          VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1DV1
        ENDDO
        CALL Ar_Bl_BL_EXT_AR_NEW(LIN,INTPOS,ISMA,1)
      ENDDO

      RETURN
      END


!=======================================================
! END OF DV, NEXT VD
!=======================================================
      SUBROUTINE SS_DRL_ACT_BR_SGT0(LIN,LRA)
!SS(1-16) (11)-Drl(22)-
!SS(1-19) Drl(12)-C"(21)-
!SS(1-20) Drl(33)-C"(11)-C"(22)-
!SS(1-20) (11)Drl(33)-C"(22)-
!SS(1-20) (11)(22)Drl(33)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      IF(JML.NE.JMR) RETURN
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML) CYCLE
!SS(1-16) (11)-Drl(22)-
          IWDL=JUST(LRJ,LRI)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_SS(16)
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_SS(16)
          ENDDO
          CALL Drl_BR_EXT_AL_NEW(LIN,LRJ,LRA)
!SS(1-18) Drl(11)-C"(22)-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_SS(18)
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_SS(18)
          ENDDO
          CALL Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
!SS(1-20) Drl(33)-C"(11)-C"(22)-
!SS(1-20) (11)Drl(33)-C"(22)-
!SS(1-20) (11)(22)Drl(33)-
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_SS(20)
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_SS(20)
          ENDDO
          IF(LRA.GT.NORB_DZ) THEN
            call Drl_BR_SUM_AL_new(LIN,LRI,LRJ,LRA)
          ELSE
            DO LRK=1,norb_dz
              if(LRK.EQ.LRI) CYCLE
              if(LRK.EQ.LRJ) CYCLE
              CALL Drl_BR_EXT_AL_NEW(LIN,LRK,LRA)
            ENDDO
          ENDIF
        ENDDO
      ENDDO

      RETURN
      END

!============================================
      SUBROUTINE SS_S_DRL_ACT_BR_SGT0(LIN,LRA)
!SS(1-19) Drl(12)-C"(21)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      IF(JML.NE.JMR) RETURN
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML) CYCLE
!SS(1-19) Drl(12)-C"(21)-
          IWDL=JUST(LRJ,LRI)
          IWDR=JUST(LRI,LRJ)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_SS(19)
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_SS(19)
          ENDDO
          CALL Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
        ENDDO
      ENDDO

      RETURN
      END

!==============================================
      SUBROUTINE SS_S_DRL_ACT_BL_SGT0(LIN,LRA)
!SS(1-19) Drl(12)-C"(21)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      IF(JML.NE.JMR) RETURN
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          LMIJ=MUL_TAB(LMI,LMJ)
          IF(LMIJ.NE.JML) CYCLE
!SS(1-19) Drl(12)-C"(21)-
          IWDL=JUST(LRJ,LRI)
          IWDR=JUST(LRI,LRJ)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0_SS(19)
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_SS(19)
          ENDDO
          CALL Drl_BL_EXT_AR_NEW(LIN,LRI,LRA)
        ENDDO
      ENDDO

      RETURN
      END


      SUBROUTINE SS_ARBL_ACT_BR_SGT0(LIN,LRA)
!=======================================================================
!SS(1-1)  Ar(01)-Bl(32)-
!SS(1-3)  Ar(13)-Bl(20)-
!SS(1-6)  (11)-Ar(23)-Bl(32)-
!SS(1-7)  Ar(13)-C'(21)-Bl(32)-
!SS(1-8)  Ar(13)-C'(22)-Bl(31)-
!SS(1-9)  Ar(23)-C'(11)-Bl(32)-
!SS(1-11) Ar(13)-Bl(31)-C"(22)-
!SS(1-12) Ar(13)-Bl(32)-C"(21)-
!SS(1-13) Ar(23)-Bl(31)-C"(12)-
!=======================================================================
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=MUL_TAB(JML,JMR)
      ISMA=MUL_TAB(IML,IMR)
        DO LRI=NORB_FRZ+1,NORB_DZ
          LMI=LSM_INN(LRI)
          DO LRJ=LRI+1,NORB_DZ
            LMJ=LSM_INN(LRJ)
            LMIJ=MUL_TAB(LMI,LMJ)
            IF(LMIJ.NE.JMLR) CYCLE
           IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
            intpos=INTIND_IJKA(IJK)
!-------------------------------------------------------------------
          W0SS1=W0_SS(1)
          W1SS1=W1_SS(1)
          W0SS3=W0_SS(3)
          W1SS3=W1_SS(3)
          W0SS6=W0_SS(6)
          W1SS6=W1_SS(6)
          W0SS7=W0_SS(7)
          W1SS7=W1_SS(7)
          W0SS8=W0_SS(8)
          W1SS8=W1_SS(8)
          W0SS9=W0_SS(9)
          W1SS9=W1_SS(9)
          W0SS11=W0_SS(11)
          W1SS11=W1_SS(11)
          W0SS12=W0_SS(12)
          W1SS12=W1_SS(12)
          W0SS13=W0_SS(13)
          W1SS13=W1_SS(13)
          NI=MOD(LRJ-LRI,2)
          IF(NI.EQ.0) THEN
            W0SS1=-W0SS1
            W1SS1=-W1SS1
            W0SS3=-W0SS3
            W1SS3=-W1SS3
            W0SS6=-W0SS6
            W1SS6=-W1SS6
            W0SS7=-W0SS7
            W1SS7=-W1SS7
            W0SS8=-W0SS8
            W1SS8=-W1SS8
            W0SS9=-W0SS9
            W1SS9=-W1SS9
            W0SS11=-W0SS11
            W1SS11=-W1SS11
            W0SS12=-W0SS12
            W1SS12=-W1SS12
            W0SS13=-W0SS13
            W1SS13=-W1SS13
         ENDIF
!-------------------------------------------------------------------
!SS(1-1)  Ar(01)-Bl(32)-
          IF(JML.EQ.1) THEN
            IWDL=JUST(LRI,LRI)
            IWDR=JUST(LRJ,LRI)
            DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS1
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS1
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
!SS(1-3)  Ar(13)-Bl(20)-
          IF(JMR.EQ.1) THEN
            IWDL=JUST(LRJ,LRI)
            IWDR=JUST(LRJ,LRJ)
            DO MPL=1,MTYPE
            VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS3
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS3
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
          CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
!-------------------------------------------------------------------
!SS(1-6)  (11)-Ar(23)-Bl(32)-
          DO LRK=NORB_FRZ+1,LRI-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS6
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS6
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
!-------------------------------------------------------------------
          DO LRK=LRI+1,LRJ-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
!SS(1-7)  Ar(13)-C'(21)-Bl(32)-
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SS7
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SS7
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
!SS(1-8)  Ar(13)-C'(22)-Bl(31)-
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SS8
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SS8
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
!SS(1-9)  Ar(23)-C'(11)-Bl(32)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=-VPLPNEW_W0(MPL)*W0SS9
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1SS9
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
!-------------------------------------------------------------------
          DO LRK=LRJ+1,NORB_DZ
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
!SS(1-11) Ar(13)-Bl(31)-C"(22)-
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS11
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS11
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
!SS(1-12) Ar(13)-Bl(32)-C"(21)-
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS12
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS12
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
!SS(1-13) Ar(23)-Bl(31)-C"(12)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=VPLPNEW_W0(MPL)*W0SS13
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1SS13
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
!-------------------------------------------------------------------
        ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE ST_ARBL_ACT_BR_SGT0(LIN,LRA)
!ST(2-3) Ar(13)-C'(22)-Bl(32)-
!ST(2-3) Ar(13)-Bl(32)-C'(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=MUL_TAB(JML,JMR)
      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(LMIJ.NE.JMLR) CYCLE

        W1ST3=W1_ST(3)
        NI=MOD(LRJ-LRI,2)
        IF(NI.EQ.0) THEN
          W1ST3=-W1ST3
        ENDIF
        IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
        intpos=INTIND_IJKA(IJK)
!-------------------------------------------------------------------
!ST(2-3) Ar(13)-C'(22)-Bl(32)-
          DO LRK=LRI+1,LRJ-1
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRK,LRJ)       !
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1ST3
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
          CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
!-------------------------------------------------------------------
!ST(2-3) Ar(13)-Bl(32)-C'(22)-
          DO LRK=LRJ+1,NORB_DZ
            LMK=LSM_INN(LRK)
            IF(MUL_TAB(LMK,LMI).NE.JML) CYCLE
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRJ,LRK)   !
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST3
            ENDDO
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
          CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE ST_DRL_ACT_BR_SGT0(LIN,LRA)
!ST(2-7) Drl(12)-C"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=1
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        IF(LMIJ.NE.JML) CYCLE
!-------------------------------------------------------------------
!ST(2-7) Drl(12)-C"(22)-
          IWDL=JUST(LRJ,LRI)
          IWDR=JUST(LRI,LRJ)       !
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_ST(7)
          ENDDO
          CALL Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
        ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE TS_ARBL_ACT_BR_SGT0(LIN,LRA)
!=======================================================================
!TS(3) A&R-B^L-  ACT -B&R ............................................
!TS(3-3) Ar(23)-Bl(31)-C"(22)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=MUL_TAB(JML,JMR)
      ISMA=MUL_TAB(IML,IMR)
        DO LRI=NORB_FRZ+1,NORB_DZ
          LMI=LSM_INN(LRI)
          DO LRJ=LRI+1,NORB_DZ
            LMJ=LSM_INN(LRJ)
            IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ)
            intpos=INTIND_IJKA(IJK)
!-------------------------------------------------------------------
            W1TS3=W1_TS(3)
            NI=MOD(LRJ-LRI,2)
            IF(NI.EQ.0) THEN
              W1TS3=-W1TS3
            ENDIF
!-------------------------------------------------------------------
!TS(3-3) Ar(23)-Bl(31)-C"(22)-
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1TS3
            ENDDO
            DO LRK=LRJ+1,NORB_DZ
              LMK=LSM_INN(LRK)
              LMIK=MUL_TAB(LMI,LMK)
              LMJK=MUL_TAB(LMJ,LMK)
            IF(LMIK.NE.JML.OR.LMJK.NE.JMR) CYCLE
              IWDL=JUST(LRI,LRK)    !
              IWDR=JUST(LRK,LRJ)
              DO MPL=1,MHLP
                IWAL=LPNEW_LWEI(MPL)
                IWAR=LPNEW_RWEI(MPL)
                LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
                LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
              ENDDO
              CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
            ENDDO
!-------------------------------------------------------------------
          ENDDO
        ENDDO
      RETURN
      END


      SUBROUTINE STT_ARBL_ACT_BR_SGT1(LIN,LRA)
!=======================================================================
!STT(4) A&R-B^L-  ACT -BR ............................................
!ST1(4-1) Ar(01)-Bl(31)-
!ST1(4-2) Ar(23)-Bl(31)-
!ST1(4-3) Ar(13)-C'(21)-Bl(31)-
!ST1(4-3) Ar(13)-Bl(31)-C"(21)-
!ST1(4-4) Ar(23)-C'(11)-Bl(31)-
!ST1(4-4) Ar(23)-Bl(31)-C"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      JMLR=MUL_TAB(JML,JMR)
      ISMA=MUL_TAB(IML,IMR)
      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
      DO LRJ=LRI+1,NORB_DZ
        LMJ=LSM_INN(LRJ)
        LMIJ=MUL_TAB(LMI,LMJ)
        W1ST1=W1_ST1(1)
        W1ST2=W1_ST1(2)
        W1ST3=W1_ST1(3)
        W1ST4=W1_ST1(4)
        IF(MOD(LRJ-LRI,2).EQ.0) THEN
          W1ST1=-W1ST1
          W1ST2=-W1ST2
          W1ST3=-W1ST3
          W1ST4=-W1ST4
        ENDIF
        IJK=LRI-NORB_FRZ+NGW2(LRJ-NORB_FRZ)+NGW3(LRA-NORB_FRZ) !???
        intpos=INTIND_IJKA(IJK)                         !???
!ST1(4-1) Ar(01)-Bl(31)-
!ST1(4-2) Ar(23)-Bl(31)-
        IF(JML.EQ.1.AND.JMR.EQ.LMIJ) THEN
          IWDL=JUST(LRI,LRI)
          IWDR=JUST(LRI,LRJ)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST1
          ENDDO
          CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
        ENDIF
!ST1(4-2) (11)Ar(23)-Bl(31)-
        DO LRK=NORB_FRZ+1,LRI-1
          LMK=LSM_INN(LRK)
         IF(JML.EQ.MUL_TAB(LMK,LMI).AND.JMR.EQ.MUL_TAB(LMK,LMJ)) THEN
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST2
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
!ST1(4-3) Ar(13)-C'(21)-Bl(31)-
        DO LRK=LRI+1,LRJ-1
          LMK=LSM_INN(LRK)
         IF(JML.EQ.MUL_TAB(LMI,LMK).AND.JMR.EQ.MUL_TAB(LMK,LMJ)) THEN
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1ST3
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
!ST1(4-4) Ar(23)-C'(11)-Bl(31)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRK,LRJ)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=-VPLPNEW_W1(MPL)*W1ST4
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
!ST1(4-3) Ar(13)-Bl(31)-C"(21)-
        DO LRK=LRJ+1,NORB_DZ
          LMK=LSM_INN(LRK)
         IF(JML.EQ.MUL_TAB(LMI,LMK).AND.JMR.EQ.MUL_TAB(LMJ,LMK)) THEN
            IWDL=JUST(LRK,LRI)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST3
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
!ST1(4-4) Ar(23)-Bl(31)-C"(11)-
            IWDL=JUST(LRI,LRK)
            IWDR=JUST(LRJ,LRK)
            DO MPL=1,MHLP
              IWAL=LPNEW_LWEI(MPL)
              IWAR=LPNEW_RWEI(MPL)
              LP_LWEI(MPL)=IWALK_AD(JPADL,IpaeL,IWAL,IWDL)
              LP_RWEI(MPL)=IWALK_AD(JPAD,Ipae,IWAR,IWDR)
            ENDDO
            DO MPL=1,MTYPE
              VPLP_W0(MPL)=0.D0
              VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1ST4
            ENDDO
            CALL Ar_Bl_BR_EXT_AL_NEW(LIN,INTPOS,ISMA,1)
          ENDIF
        ENDDO
      ENDDO
      ENDDO

      RETURN
      END


      SUBROUTINE TTS_Drl_ACT_BR_SGT1(LIN,LRA)
!T1S(5-5)   (11)Drl(12)-
!T1S(5-6)   Drl(12)-C"(12)-
!T1S(5-7)   Drl(12)-C"(11)-
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      DO LRI=NORB_FRZ+1,NORB_DZ
        LMI=LSM_INN(LRI)
        DO LRJ=LRI+1,NORB_DZ
          LMJ=LSM_INN(LRJ)
          IF(JML.NE.MUL_TAB(LMI,LMJ).OR.JMR.NE.MUL_TAB(LMI,LMJ)) CYCLE
!T1S(5-5)   (11)Drl(12)-
          IWDL=JUST(LRI,LRJ)
          IWDR=JUST(LRJ,LRI)
         DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_T1S(5)
          ENDDO
          CALL Drl_BR_EXT_AL_NEW(LIN,LRJ,LRA)
!T1S(5-6)   Drl(11)-C"(12)-
          IWDL=JUST(LRI,LRJ)
          IWDR=JUST(LRJ,LRI)
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_T1S(6)
          ENDDO
          CALL Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
!T1S(5-7)   Drl(12)-C"(11)-
          IWDL=JUST(LRI,LRJ)
          IWDR=IWDL
          DO MPL=1,MHLP
            IWAL=LPNEW_LWEI(MPL)
            IWAR=LPNEW_RWEI(MPL)
            LP_LWEI(MPL)=IWALK_AD(JPADL,IPAEL,IWAL,IWDL)
            LP_RWEI(MPL)=IWALK_AD(JPAD,IPAE,IWAR,IWDR)
          ENDDO
          DO MPL=1,MTYPE
            VPLP_W0(MPL)=0.D0
            VPLP_W1(MPL)=VPLPNEW_W1(MPL)*W1_T1S(7)
          ENDDO
          CALL Drl_BR_EXT_AL_NEW(LIN,LRI,LRA)
        ENDDO
      ENDDO

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! WRAPPER FOR PARALLEL S AND B MATRIX ROUTINES
subroutine PSBMAT_FREEMEM(lg_M)
!SVC2010: destroy square global array S/B for symmetry iSYM
! with integer handle lg_M or if replicate or serial, free the
! tridiagonal local array at Work(lg_M)

#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: GA_Destroy
#endif
use fake_ga, only: Deallocate_GA_Array
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(inout) :: lg_M
#ifdef _MOLCAS_MPP_
logical(kind=iwp) :: bStat

if (Is_Real_Par()) then
  bStat = GA_Destroy(lg_M)
# include "macros.fh"
  unused_var(bStat)
else
#endif
  call Deallocate_GA_Array(lg_M)
#ifdef _MOLCAS_MPP_
end if
#endif

end subroutine PSBMAT_FREEMEM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine CtrlMO(moip,nAcO)
*
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
#include "etwas.fh"
      Integer moip(0:nIrrep-1)
*
      jAsh=0
      ii=0
      iTot=0
      Do iIrrep=0,nIrrep-1
            moip(iIrrep)=iTot
            iTot=iTot+nAsh(iIrrep)
      End Do
      nACO=iTot
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Mod_P2(P2mo,nP2Act,D1mo,nD1mo,DS1mo,ExFac,nDet)

use Index_Functions, only: iTri
use Symmetry_Info, only: Mul
use nq_Info, only: iOff_Ash, mIrrep, nAsh
use Constants, only: One, Two, Quart
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nP2Act, nD1mo, nDet
real(kind=wp), intent(inout) :: P2mo(nP2Act)
real(kind=wp), intent(in) :: D1mo(nD1mo), DS1mo(nD1mo), ExFac
integer(kind=iwp) :: i, i_, iIrrep, ij, ijIrrep, ijkIrrep, ijkl, ik, il, j, j_, jIrrep, jk, jl, k, k_, kIrrep, kl, l, l_
real(kind=wp) :: Fact, P2Act

!                                                                      *
!***********************************************************************
!                                                                      *
iOff_Ash(0) = 0
do iIrrep=1,mIrrep-1
  iOff_Ash(iIrrep) = iOff_Ash(iIrrep-1)+nAsh(iIrrep-1)
end do
!
!***********************************************************************
!
! active space Ptvxy

if (nDet == 1) then

  P2Act = real(nP2Act,kind=wp)
  call Put_Temp('nP2Act  ',[P2Act],1)
  call Put_Temp('P2_RAW  ',P2mo,nP2Act)

  do iIrrep=0,mIrrep-1
    do jIrrep=0,mIrrep-1
      ijIrrep = Mul(iIrrep+1,jIrrep+1)-1
      do kIrrep=0,mIrrep-1
        ijkIrrep = Mul(ijIrrep+1,kIrrep+1)-1

        do k_=1,nASh(kIrrep)
          k = iOff_Ash(kIrrep)+k_
          do l_=1,nASh(ijkIrrep)
            l = iOff_Ash(ijkIrrep)+l_
            if (l > k) exit
            kl = iTri(k,l)
            do i_=1,nASh(iIrrep)
              i = iOff_Ash(iIrrep)+i_
              il = iTri(i,l)
              ik = iTri(i,k)
              do j_=1,nASh(jIrrep)
                j = iOff_Ash(jIrrep)+j_
                if (j > i) cycle
                ij = iTri(i,j)
                if (kl > ij) cycle
                ijkl = iTri(ij,kl)
                jk = iTri(j,k)
                jl = iTri(j,l)

                Fact = One
                if ((iIrrep == jIrrep) .and. (k == l)) Fact = Two
                P2mo(ijkl) = Fact*P2mo(ijkl)

                if (iIrrep == ijkIrrep) P2mo(ijkl) = P2mo(ijkl)+(One-ExFac)*Quart*(D1mo(jk)*D1mo(il)+DS1mo(jk)*DS1mo(il))

                if (iIrrep == kIrrep) P2mo(ijkl) = P2mo(ijkl)+(One-ExFac)*Quart*(D1mo(jl)*D1mo(ik)+DS1mo(jl)*DS1mo(ik))

                P2mo(ijkl) = P2mo(ijkl)/Fact

              end do
            end do
          end do
        end do

      end do
    end do
  end do
  call Put_Temp('P2_KS   ',P2mo,nP2Act)
else
  write(u6,*) ' Not implemented yet!!! nDet=',nDet
  call Abend()
end if

return

end subroutine Mod_P2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
        subroutine o3v3chol (wrk,wrksize,NvGrp,maxdim,LunAux)
c
c       This routine do:
c
c       --- Part II - generation of Q3,K3,Gvv,Goo,T26-9 in X form
c
c       T(be,u)      <<-
c       T162 - sum(b,i)   [ (iu|be,b) . t(b,i) ]
c       T17  + sum(a,b,i) [ 2(a,i|b,be) - (b,i|a,be) ] . Ta(a,b,i,u)
c          = + sum(a,b,i)  (a,i|b,be) . [ 2 Ta(a,b,i,u) - Ta(a,b,u,i) ]
c
c       N.B. T17 implementede in expression:
c       T(a,u)      <<-
c       T17  + sum(be,b,i)  (b,i|be,a) . [ 2 Ta(b,be,i,u) - Ta(b,be,u,i) ]
c
c
c       Q(be,u,i,a) <-
c              Q3     +   [ 2(b,be|a,i) - (b,i|a,be) ] . t(b,u )
c
c       K(be,u,i,a) <-
c              K3     +   [  (b,i |a,be)             ] . t(b ,u)
c
c       Gvv(be,a)    <-
c       Gvv1  +           [ Hvv(a,be) ]
c       Gvv2  - sum(i)    [ Fvo(a,i) . t1(be,i) ]
c       Gvv3  + sum(b,i)  [ -(b,be|a,i) +2(b,i|a,be) ] . t(b,i )
c
c       Goo(i,u) <-
c       Goo1  +  <-       [ Hoo(i,u) ]
c       Goo2  + sum(a)    [ Fvo(a,i) . t1(a,u) ]
c       Goo3  + sum(a,j)  [ (2(aj|iu) - (ai|ju)) . t1(a,j) ]
c
c       terms Goo2,3 implemented as:
c       Goo2  + sum(be)   [ Fvo(be,i) . t1(be,u) ]
c       Goo3  + sum(be,j) [ (2(be,j|iu) - (be,i|ju)) . t1(be,j) ]
c
c       T2(be,ga,u,v) <<-
c       T26  + sum(a)     [ (be,u|ga,a) . t1(a,v)         ]
c       T27  - sum(a,i)   [ (iu|ga,a) . t1(be,i) . t1(a,v)]
c       T28  - sum(i)     [ (be,u|iv)          . t1(ga,i) ]
c       T29  - sum(a,i)   [ (be,u|ia). t1(a,v) . t1(ga,i) ]
c
c       N.B. T26-T29 implementede in expression:
c       T2(a,be,u,v)  <-
c       T26  + sum(b)     [           (u,a|be,b) . t1(b,v)  ]
c       T27  - sum(b,j)   [ t1(a,j) . (u,j|be,b) . t1(b,v)  ]
c       T28  - sum(j)     [           (u,a|j,v)  . t1(be,j) ]
c       T29  - sum(b,j)   [ t1(b,v) . (u,a|j,b)  . t1(be,j) ]
c        T2(a,be,u,v) is stored as X(a,u,be,v) in Tmp2Name(a,be)
c
c
c        N.B. Process V3(j,v,u,a') <- V1(m,j,v) . L1(T)(m,u,a') run
c        for Na*Nbe times, ie. Nbe . o3mv competee with Nbe . I+O (o3v)
c
c
c       Extra cost - multiple reading:
c                    1) N_be . T;
c                    2) N_ga . Q
c                    3) N_ga . K
c
c
c1      intermediates Q and K will be temporarry stored in files
c       Tmp1Name(be,a)
c       do beGrp
c       do aGrp
c         Q(K) (be',u,i,a')
c       end do
c       end do
c
c2      Structure of files, where selected group of (pq|rs) are
c       stored (V'O|OO) - I1 ; (V'O|V'O) - I2 ; (V'V'|OO) - I3
c
c       (A'I|JK)  I1inxx xx - Group of A'
c
c       (A'I|B'J) I2xxyy xx - Group of A'
c                        yy - Group of B'
c
c       (A'B'|IJ) I3xxyy xx - Group of A'
c                        yy - Group of B'
c
c
c3      Structure of Cholesky vector files
c
c       L1(m,I ,A')  L1vcxx xx - Group of A'
c
c       L2(m,A',B')  L2xxyy xx - Group of A'
c                           yy - Group of B'
c
c4      Structure of Amplitude file
c       t2(A',B',IJ)  T2xxyy xx - Group of A'
c                            yy - Group of B'
c
c
        implicit none
#include "chcc1.fh"
#include "chcc_parcc.fh"
#include "para_info.fh"
#include "o3v3.fh"
#include "chcc_files.fh"
#include "wrk.fh"
#include "chcc_casy.fh"
c
        integer NvGrp,LunAux

c       help variables
        integer dim1,dim2,dima,dimb,dimbe
        integer aGrp,bGrp,beGrp,adda,addb,addbe
        integer PossV1,PossV2,PossV3,PossV4
        integer PossH1,PossH2,PossH3,PossH4
        integer PossM1,PossM2,PossM3,PossM4,PossM5
        integer PossK,PossQ
c
        integer PossT,maxdim

c
        character*6 LunName
c
c       --- introduction part ---
c
cx      Distribute memory
c       @@ vyladit distmem, mozno netreba vsetko, toto je len prefackany
c        DistMemo3v3
c
        PossT=PossFree
        if (printkey.ge.10) then
        write (6,*) 'PossFree',PossFree,NvGrp,maxdim
        end if
        call DistMemo3v3chol (NvGrp,maxdim,
     c       PossV1,PossV2,PossV3,PossV4,
     c       PossH1,PossH2,PossH3,PossH4,
     c       PossM1,PossM2,PossM3,PossM4,PossM5,
     c       PossK,PossQ,
     c       PossT)
c
        if (printkey.ge.10) then
        write (6,*) ' Last Value :',PossT,wrksize
        end if
        if (PossT.gt.wrksize) then
cmp!           write (6,*) ' Nieje dobre, Dr. Ch.  Kokotopuloss',
       write (6,*) ' Not Enough memory in o3v3chol step!',
     & 'Increase large and/or small segmentation ',
     c                  (1.0d0*PossT)/(1.0d0*wrksize)
           call abend()
        end if
c
c
c@@
c        call Chck_mkJ
c        call Chck_mkK
c@@
c
c       read V1(m,ij) <- L1(m,ij)
        LunName=L0Name
        dim1=nc*no*(no+1)/2
        call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c        Expand M4(m,i,j) <- V1(m,ij)
        dim1=no*(no+1)/2
        call Exp1 (wrk(PossV1),wrk(PossM4),nc,dim1,no)
c
cG        Vanish Gvv,Goo
        dim1=nv*nv
        call mv0zero (dim1,dim1,wrk(PossGvv))
        dim1=no*no
        call mv0zero (dim1,dim1,wrk(PossGoo))
c
c
c##G     Vanish Xyes
c
        do dim1=1,NvGrp
        do dim2=1,NvGrp
          Xyes(dim1,dim2)=0
        end do
        end do
c
c
        addbe=0
c
        do beGrp=1,NvGrp
        dimbe=DimGrpv(beGrp)
c
c##     test, if this beGrp is planed to be run on this node
        dim1=0
        do dim2=1,NvGrp
          dim1=dim1+BeAID(myRank,beGrp,dim2)
        end do
        dim1=dim1+BetaID(myRank,beGrp)
        if (dim1.eq.0) goto 11
        if (printkey.gt.1) then
        write (6,*) ' Chol PID, beGrp',myRank,beGrp
cmp
        Call CWTime(TCpu,TWall)
        write (6,*)
        write (6,'(A,f18.1)') ' Cpu last call [s] = ',
     & TCpu-TCpu_l
        write (6,'(A,f18.1)') 'Wall last call [s] = ',
     & TWall-TWall_l
        write (6,*)
        write (6,'(A,f18.1)') 'Total Cpu  [s] = ',
     & TCpu
        write (6,'(A,f18.1)') 'Total Wall [s] = ',
     & TWall-TWall0
        write (6,'(A,f18.2)') 'TCpu/TWall [%] = ',
     & 100.0d0*TCpu/(TWall-TWall0)
        write (6,*)
        end if
        TCpu_l=TCpu
        TWall_l=TWall
cmp
c
c          Extract H1(be',I) <- T1(be,I)
          call ExtT1 (wrk(PossH1),wrk(PossT1o),dimbe,addbe)
c
c         vanish M1(m,i,u),M2(m,be',u),M3(m,be',u)
          dim1=nc*no*no
          call mv0zero (dim1,dim1,wrk(PossM1))
          dim1=nc*no*dimbe
          call mv0zero (dim1,dim1,wrk(PossM2))
          call mv0zero (dim1,dim1,wrk(PossM3))
c
cT1G          vanish H4(be',u)
          dim1=dimbe*no
          call mv0zero (dim1,dim1,wrk(PossH4))
c
c
c
           if (BetaID(myRank,beGrp).eq.1) then
c##       contributions Goo2,3  must be taken only once per Beta'
c
cGoo2.1            Extract H2(be',i) <- Fvo(be,i) (vlastnu rutinu netreba)
            call ExtT1 (wrk(PossH2),wrk(PossFvo),dimbe,addbe)
c
cGoo2.2f    Goo(i,u) <<- H2(T)(be',i) . H1(be',u)
            call mc0c1at3b (dimbe,no,dimbe,no,no,no,
     c                    no,dimbe,no,
     c                    wrk(PossH2),wrk(PossH1),wrk(PossGoo))
c
c
cGoo3.1            read V1(be',I,JK) <- I1(be',I,JK)
            dim1=dimbe*no*no*(no+1)/2
            LunName=I1Name(beGrp)
            call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
cGoo3.2            Make V2(be',j,i,u) <- 2 V1(be',j|iu) - V1(be',i|ju)
            call MkV_Goo3 (wrk(PossV1),wrk(PossV2),dimbe,no)
c
cGoo3.3f    Goo(i,u) <<- V2(T)(be',j,i,u) . H1(be,j)
            dim1=dimbe*no
c@x            dorobit rutinu  mv0v1at3u
c           call mv0v1at3u (dim1,no*no,dim1,no*no,
c    c                      no*no,dim1,1,1,
c    c                      wrk(PossV2),wrk(PossH1),wrk(PossGoo))
c
c            zatial odflaknute takto
             call mc0c1at3b (dim1,no*no,dim1,1,no*no,1,
     c                     no*no,dim1,1,
     c                     wrk(PossV2),wrk(PossH1),wrk(PossGoo))
c    c
c@x
           end if
c
c
          addb=0
c
          do bGrp=1,NvGrp
          dimb=DimGrpv(bGrp)
c
cG            Extract H2(b',I) <- T1(b,I)
            call ExtT1 (wrk(PossH2),wrk(PossT1o),dimb,addb)
c
cQK3.1      read V3(m,i,b') <- L1(m,i,b')
            LunName=L1Name(bGrp)
            dim1=nc*no*dimb
            call GetX (wrk(PossV3),dim1,LunAux,LunName,1,1)
c
cQK3.3      M1(m,i,u)   <<-  V3(m,i  ,b') . H2(b',u)
            call mc0c1a3b(nc*no,dimb,dimb,no,nc*no,no,
     c                    nc*no,dimb,no,
     c                    wrk(PossV3),wrk(PossH2),wrk(PossM1))
c
cQ3.4       read V1(m,be',b')<- [V2(m,beb') or V2(m,b'be)]<- L2(m,be',b')
c            in cases be.le.b through interstep V2
            if (beGrp.gt.bGrp) then
              LunName=L2Name(beGrp,bGrp)
              dim1=nc*dimb*dimbe
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
            else if (beGrp.eq.bGrp) then
              LunName=L2Name(beGrp,bGrp)
              dim1=nc*dimb*(dimbe+1)/2
              call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
              dim1=dimb*(dimbe+1)/2
              call Exp1 (wrk(PossV2),wrk(PossV1),nc,dim1,dimb)
            else
              LunName=L2Name(bGrp,beGrp)
              dim1=nc*dimb*dimbe
              call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
              call Map3_132 (wrk(PossV2),wrk(PossV1),nc,dimb,dimbe)
            end if
c
cQ3.5       M2(m,be',u) <<-  V1(m,be',b') . H2(b',u)
            call mc0c1a3b(nc*dimbe,dimb,dimb,no,nc*dimbe,no,
     c                    nc*dimbe,dimb,no,
     c                    wrk(PossV1),wrk(PossH2),wrk(PossM2))
c
c
c           read V2(be'b',I,J) <- T2(be',b,I,J)
            LunName=T2Name(beGrp,bGrp)
            if (bGrp.eq.beGrp) then
              dim1=dimbe*(dimbe+1)*no*no/2
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c             Expand V2(be',b',I,J) <- V1(be'b',I,J)
              dim1=dimb*(dimb+1)/2
              call ExpT2 (wrk(possV1),wrk(PossV2),dimbe,dim1,no)
            else
              dim1=dimbe*dimb*no*no
              call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
            end if
c
c           Make Tau(be',b',I,J) in V2(be',b',I,J)
               call MkTau_chcc (wrk(PossV2),wrk(PossH1),wrk(PossH2),
     c                       dimbe,dimb,no,1.0d0,1.0d0)

c           Make V1(i,b',be',u) <- 2 V2(be',b',u,i) - V2(be',b',i,u)
            call MkT_T17 (wrk(PossV1),wrk(PossV2),dimb,dimbe,no)
c
c           M3(m,be',u) <<- V3(m,i,b') . V1(i,b',be',u)
            dim1=dimb*no
            dim2=dimbe*no
            call mc0c1a3b (nc,dim1,dim1,dim2,nc,dim2,
     c                     nc,dim1,dim2,
     c                     wrk(PossV3),wrk(PossV1),wrk(PossM3))
c
c
          addb=addb+dimb
          end do
c
c
          if (BetaID(myRank,beGrp).eq.1) then
c##       contribution T16  must be taken only once per Beta'
c
c           Map V1(be',m,i) <- M2(m,be',i)
            call Map3_213 (wrk(PossM2),wrk(PossV1),nc,dimbe,no)
c
cT162.f     H4(be',u) <<- - V1(be',m,i) . M4(m,i,u)
            call mc0c2a3b (dimbe,nc*no,nc*no,no,dimbe,no,
     c                   dimbe,nc*no,no,
     c                   wrk(PossV1),wrk(PossM4),wrk(PossH4))
c
          end if
c
c
cT27.1    V4(be',v,u,j ) <- M2(T)(m,be',v) . M4(m,u,j)
          dim1=dimbe*no*no*no
          call mv0zero (dim1,dim1,wrk(PossV4))
          call mc0c1at3b (nc,dimbe*no,nc,no*no,dimbe*no,no*no,
     c                    dimbe*no,nc,no*no,
     c                    wrk(PossM2),wrk(PossM4),wrk(PossV4))
c
c
          adda=0
c
          do aGrp=1,NvGrp
          dima=DimGrpv(aGrp)
c
c         Test, if this Be' A' combination is to be run on this node
          if (BeAID(myRank,beGrp,aGrp).eq.0) goto 12
          if (printkey.ge.10) then
          write (6,*) ' Chol PID, be,a',myRank,beGrp,aGrp
          end if
c
c            Extract H2(a',I) <- T1(a,I)
            call ExtT1 (wrk(PossH2),wrk(PossT1o),dima,adda)
c
c           read Q(be',u,i,a'),K(be',u,i,a')
            LunName=Tmp1Name(beGrp,aGrp)
            dim1=dimbe*dima*no*no
            call GetX (wrk(PossQ),dim1,LunAux,LunName,1,0)
            call GetX (wrk(PossK),dim1,LunAux,LunName,0,1)
c
c           read V1(m,be',a')<- [V2(m,bea') or V2(m,a',be')] <- L2(m,be',a')
c            in cases be.le.b through interstep V2
            if (beGrp.gt.aGrp) then
              LunName=L2Name(beGrp,aGrp)
              dim1=nc*dima*dimbe
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
            else if (beGrp.eq.aGrp) then
              LunName=L2Name(beGrp,aGrp)
              dim1=nc*dima*(dimbe+1)/2
              call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
              dim1=dima*(dimbe+1)/2
              call Exp1 (wrk(PossV2),wrk(PossV1),nc,dim1,dimbe)
            else
              LunName=L2Name(aGrp,beGrp)
              dim1=nc*dima*dimbe
              call GetX (wrk(PossV2),dim1,LunAux,LunName,1,1)
              call Map3_132 (wrk(PossV2),wrk(PossV1),nc,dima,dimbe)
            end if
c
c           V3(a',u) <- V1(T)(m,be',a')(L2) . M3(m,be',u)
            call mv0zero (dima*no,dima*no,wrk(PossV3))
            call mc0c1at3b (nc*dimbe,dima,nc*dimbe,no,dima,no,
     c                      dima,nc*dimbe,no,
     c                      wrk(PossV1),wrk(PossM3),wrk(PossV3))
c
cT17.f      Add T1n(a',u) <<- V3(a',u)
                 call AdT_T17 (wrk(PossT1n),wrk(PossV3),
     c                    nv,dima,no,adda,1.0d0)
c
c           V3(be',a',i,u) <-  V1(m,be',a')(L2) . M1(m,i,u)
            dim1=dima*dimbe*no*no
            call mv0zero (dim1,dim1,wrk(PossV3))
            call mc0c1at3b (nc,dimbe*dima,nc,no*no,dimbe*dima,no*no,
     c                      dima*dimbe,nc,no*no,
     c                      wrk(PossV1),wrk(PossM1),wrk(PossV3))
c
c           map V2(be',u,i,a') <-  V3(be',a',i,u)
            call Map4_1432 (wrk(PossV3),wrk(PossV2),dimbe,dima,no,no)
c
c           Q(be',u,i,a')  <<- -V2(be',u,i,a')
            call mv0v1u (dim1,wrk(PossV2),1,wrk(PossQ),1,-1.0d0)
c
c           Gvv(be',a') <<- 2 sum(i) [V2(be',i,i,a')
            call AdV_G2 (wrk(PossGvv),wrk(PossV2),
     c                   nv,dimbe,dima,no,addbe,adda,2.0d0)
c
c           K(be',u,i,a')  <<-  V2(be',u,i,a')
            call mv0v1u (dim1,wrk(PossV2),1,wrk(PossK),1,1.0d0)
c
c           read M5(m,i,a') <- L1(m,i,a')
            LunName=L1Name(aGrp)
            dim1=dima*nc*no
            call GetX (wrk(PossM5),dim1,LunAux,LunName,1,1)
c
c           V2(be',u,i,a') <-  M2(m,be',u ) . M5(m,i,a')(L1)
            dim1=dima*dimbe*no*no
            call mv0zero (dim1,dim1,wrk(PossV2))
            call mc0c1at3b (nc,dimbe*no,nc,no*dima,dimbe*no,dima*no,
     c                      dimbe*no,nc,dima*no,
     c                      wrk(PossM2),wrk(PossM5),wrk(PossV2))
c
c           Q(be',u,i,a') <<- 2 V2(be',u,i,a')
            call mv0v1u (dim1,wrk(PossV2),1,wrk(PossQ),1,2.0d0)
c
cx          write Q and K submatrix to corresponding files
            LunName=Tmp1Name(beGrp,aGrp)
            dim1=dimbe*dima*no*no
            call SaveX (wrk(PossQ),dim1,LunAux,LunName,1,0)
            call SaveX (wrk(PossK),dim1,LunAux,LunName,0,1)
c@@
c        call Chck_K (wrk(PossK),dimbe,addbe,dima,adda)
c        call Chck_Q (wrk(PossQ),dimbe,addbe,dima,adda)
c@@
c
c           Gvv(be',a') <<- - sum(i) [V2(be,i,i,a')
            call AdV_G2 (wrk(PossGvv),wrk(PossV2),
     c                   nv,dimbe,dima,no,addbe,adda,-1.0d0)
c
c
c            Q array (alredy relesed) will be served for X
c
cT26.1f     Map Q(a',U,be',V) <-  2 . V2(be',V,U,a')
c           ie. here a' is a firs index, that means X (Q) is saved
c           in different order as K,Q
            call Map4_3421 (wrk(PossV2),wrk(PossQ),dimbe,no,no,dima)
            dim1=dima*no*no*dimbe
            call mv0sv (dim1,dim1,wrk(PossQ),2.0d0)
c
cT27.2      Map H3(j,a') <- H2(a',j)(T1)
            call Map2_21 (wrk(PossH2),wrk(PossH3),dima,no)
c
cT27.3f            V2(be',v,u,a') <- - V4(be',v,u,j) . H3(j,a')
            dim1=dimbe*no*no*dima
            call mv0zero (dim1,dim1,wrk(PossV2))
            dim1=dimbe*no*no
                 call mc0c2a3b (dim1,no,no,dima,dim1,dima,
     c                     dim1,no,dima,
     c                     wrk(PossV4),wrk(PossH3),wrk(PossV2))
c
cT289.1            V1(m,j,v) <- M4(m,j,v) (L1)
            dim1=nc*no*no
            call mv0u (dim1,wrk(PossM4),1,wrk(PossV1),1)
c
cT289.2     V1(m,j,v) <<- M1(m,j,v)
            dim1=nc*no*no
            call mv0v1u (dim1,wrk(PossM1),1,wrk(PossV1),1,1.0d0)
c
cT289.3     V3(j,v,u,a') <- V1(T) (m,j,v) . M5(m,u,a')(L1)
            dim1=no*no*no*dima
            call mv0zero (dim1,dim1,wrk(PossV3))
               call mc0c1at3b (nc,no*no,nc,no*dima,no*no,no*dima,
     c                      no*no,nc,no*dima,
     c                      wrk(PossV1),wrk(PossM5),wrk(PossV3))
c
cT289.4f    V2(be',v,u,a') <<- - H1(be',j)(T1) . V3(j,v,u,a')
            dim1=no*no*dima
                 call mc0c2a3b (dimbe,no,no,dim1,dimbe,dim1,
     c                     dimbe,no,dim1,
     c                     wrk(PossH1),wrk(PossV3),wrk(PossV2))
c
cT2G        Map V1(a',U,be',V) <- V2(be',V,U,a')
            call Map4_3421 (wrk(PossV2),wrk(PossV1),dimbe,no,no,dima)
c
cT2G        Add Q(a',u,be',v)(X) <<- V1(a',U,be',V) (Faktor 2 koli X)
            dim1=dimbe*dima*no*no
            call mv0v1u (dim1,wrk(PossV1),1,wrk(PossQ),1,2.0d0)
c
cT2G        write X(a',u,be',v) = Q(a',u,be',v)
            LunName=Tmp2Name(aGrp,beGrp)
            dim1=dimbe*dima*no*no
            Xyes(aGrp,beGrp)=1
            call SaveX (wrk(PossQ),dim1,LunAux,LunName,1,1)
c
12        adda=adda+dima
          end do
c
cT1G        Add T1n(be,u) <<- H4(be',u)
        call AdT_T17 (wrk(PossT1n),wrk(PossH4),nv,dimbe,no,addbe,1.0d0)
c
11      addbe=addbe+dimbe
        end do
c
c
#ifdef _MOLCAS_MPP_
c##        Synchronizacny bod:
c        Allreduce Goo,Gvv
        dim1=no*no
        call gadgop (wrk(PossGoo),dim1,'+')
        dim1=nv*nv
        call gadgop (wrk(PossGvv),dim1,'+')
#endif
c
c
cGoo1.1f Add Goo(i,u) <<- Hoo(i,u)
        dim1=no*no
        call mv0v1u (dim1,wrk(PossHoo),1,wrk(PossGoo),1,1.0d0)
c
c
cGvv1.1 Map V1(be,a) <- Hvv(a,be)
        call Map2_21 (wrk(PossHvv),wrk(PossV1),nv,nv)
c
cGvv1.2f Add Gvv(be,a) <<- V1(be,a)
        dim1=nv*nv
        call mv0v1u (dim1,wrk(PossV1),1,wrk(PossGvv),1,1.0d0)
c
c
cGvv2.1 Map V2(i,a) <- Fvo(a,i)
        call Map2_21 (wrk(PossFvo),wrk(PossV2),nv,no)
c
cGvv2.2 Calc V1(be,a) <- t1(be,i) . V2(i,a)
        dim1=nv*nv
        call mv0zero (dim1,dim1,wrk(PossV1))
        call mc0c1a3b (nv,no,no,nv,nv,nv,
     c                 nv,no,nv,
     c                 wrk(PossT1o),wrk(PossV2),wrk(PossV1))
c
cGvv2.3f Add Gvv(be,a) <<- - V1(be,a)
        dim1=nv*nv
        call mv0v1u (dim1,wrk(PossV1),1,wrk(PossGvv),1,-1.0d0)
c
c@@
c        call Chck_Goo (wrk(PossGoo))
c        call Chck_Gvv (wrk(PossGvv))
c@@
c
        return
        end
c
c        --------------------
c
        subroutine Chck_Goo (Goo)
c
c        check Goo (i,u)
c
        implicit none
#include "chcc1.fh"
        real*8 Goo(1:no,1:no)
c
c        help var
        integer i,u,j,a,bad
c       integer b
        real*8 s
c
        bad=0
c
        do i=1,no
        do u=1,no
c
c          s=0.0d0
c          do j=1,no
c          do a=1,nv
c          do b=1,nv
c          s=s+(2.0d0*Q21(a,i,b,j)-Q21(a,j,b,i))*T2c(a,b,u,j)
c          end do
c          end do
c          end do
c
           s=Hooc(i,u)
c
          do j=1,no
          do a=1,nv
           s=s+(2.0d0*Q1(a,j,i,u)-Q1(a,i,j,u))*T1c(a,j)
          end do
          end do
c
          Gooc(i,u)=s
c
          if (abs(Goo(i,u)-s).gt.1.0d-10) then
          bad=bad+1
          end if
c
        end do
        end do
c
        write (6,*) ' Goo Chck :',bad
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_Gvv (Gvv)
c
c        check Gvv(be,a)
c
        implicit none
#include "chcc1.fh"
        real*8 Gvv(1:nv,1:nv)
c
c        help var
        integer i,a,b,be,bad
c       integer j
        real*8 s
c
        bad=0
c
        do be=1,nv
        do a=1,nv
c
c          s=0.0d0
c          do i=1,no
c          do j=1,no
c          do b=1,nv
c          s=s+(2.0d0*Q21(a,i,b,j)-Q21(a,j,b,i))*T2c(be,b,i,j)
c          end do
c          end do
c          end do
c          s=-s
c
          s=Hvvc(be,a)
c
          do i=1,no
          do b=1,nv
          s=s+(2.0d0*Q3(a,be,b,i)-Q3(b,be,a,i))*T1c(b,i)
          end do
          end do
c
          Gvvc(be,a)=s
c
          if (abs(Gvv(be,a)-s).gt.1.0d-10) then
          bad=bad+1
          end if
c
        end do
        end do
c
        write (6,*) ' Gvv Chck :',bad
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_0 (dim,A)
c
c        check zero
c
        implicit none
        integer dim
        real*8 A(1:dim)
c
c        help var
        integer i,bad
c
        bad=0
        do i=1,dim
          if (abs(A(i)).gt.1.0d-10) then
          bad=bad+1
          end if
        end do
c
        write (6,*) ' Nonzero elements ',bad,dim
c
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_K (K,dimbe,addbe,dima,adda)
c
c        check K(be,u,i,a)
c
        implicit none
#include "chcc1.fh"
        integer dimbe,addbe,dima,adda
        real*8 K(1:dimbe,1:no,1:no,1:dima)
c
        integer be,u,i,a,bad
        real*8 s
c
        bad=0
        do a=adda+1,adda+dima
        do i=1,no
        do u=1,no
        do be=addbe+1,addbe+dimbe
c
          s=Kc(i,be,u,a)
c
          if (abs(K(be-addbe,u,i,a-adda)-s).gt.1.0d-10) then
            bad=bad+1
          end if
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck K :',bad
c99        format (a9,1x,i8,1x,4(i3,1x))
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_Q (Q,dimbe,addbe,dima,adda)
c
c        check Q(be,u,i,a)
c
        implicit none
#include "chcc1.fh"
        integer dimbe,addbe,dima,adda
        real*8 Q(1:dimbe,1:no,1:no,1:dima)
c
        integer be,u,i,a,bad
        real*8 s,sk,sj
c
        bad=0
c
        do a=adda+1,adda+dima
        do i=1,no
        do u=1,no
        do be=addbe+1,addbe+dimbe
c
          sj=Jc(be,i,u,a)
          sk=Kc(i,be,u,a)
c
          s=2*sj-sk
c
          if (abs(Q(be-addbe,u,i,a-adda)-s).gt.1.0d-10) then
            bad=bad+1
c           Q(be-addbe,u,i,a-adda)=s
          end if
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck Q :',bad
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_AA (A)
c
c        check T(a,b,i,j)
c
        implicit none
#include "chcc1.fh"
c        real*8 T(1:nv,1:nv,1:no,1:no)
         real*8 A(1:no*(no+1)/2,no,no)
c
        integer j,i,ij,u,v,bad
        real*8 s
c
        bad=0
        do v=1,no
        do u=1,no
        ij=0
        do i=1,no
        do j=1,i
        ij=ij+1
c
           s=Ac(i,j,u,v)
c
          if (abs(A(ij,u,v)-s).gt.1.0d-10) then
            bad=bad+1
c    A(ij,u,v)=s
          end if
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck AA :',bad
c
        return
        end
c
c        check Y(be,u,ga,v)
c
c        ---------------------
c
        subroutine Chck_Tx (T)
c
c        check T(a,b,i,j)
c
        implicit none
#include "chcc1.fh"
c        real*8 T(1:nv,1:nv,1:no,1:no)
         real*8 T(1:nv,1:no,1:nv,1:no)
c        real*8 T(1:nv,1:nv,1:no)
c
        integer b,j,a,i,bad
        real*8 s
c
        bad=0
        do j=1,no
        do i=1,no
        do b=1,nv
        do a=1,nv
c
           s=T2c(a,b,i,j)
c
          if (abs(T(b,i,a,j)-s).gt.1.0d-10) then
            bad=bad+1
          end if
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck T2 :',bad
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_Vx (V)
c
c        check V
c
        implicit none
#include "chcc1.fh"
         real*8 V(1:nv,1:no,1:nv,1:no)
c
        integer be,u,i,a,bad
        real*8 s
c
        bad=0
        do a=1,nv
        do i=1,no
        do u=1,no
        do be=1,nv
c
           s=2.0d0*Jc(be,i,u,a)-Kc(i,be,u,a)
           s=Kc(i,be,u,a)
c
          if (abs(V(be,u,a,i)-s).gt.1.0d-10) then
            bad=bad+1
            V(be,u,a,i)=s
          end if
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck Vx :',bad
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_Y (Y,dimbe,addbe,dimga,addga)
c
c        check Y(be,u,ga,v)
c
        implicit none
#include "chcc1.fh"
        integer dimbe,addbe,dimga,addga
        real*8 Y(1:dimbe,1:no,1:dimga,1:no)
c
        integer be,u,ga,v,bad
        integer a,i
        real*8 s
c
        bad=0
        do v=1,no
        do ga=addga+1,addga+dimga
        do u=1,no
        do be=addbe+1,addbe+dimbe
c
          s=0.0d0
          do i=1,no
          do a=1,nv
           s=s+Kc(i,be,u,a)*T2c(ga,a,i,v)
          end do
          end do
c
          if (abs(Y(be-addbe,u,ga-addga,v)-s).gt.1.0d-10) then
            bad=bad+1
          end if
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck Y :',bad
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_X (X,dimbe,addbe,dimga,addga)
c
c        check X(be,u,ga,v)
c        do X clenu nieje zahrnuty prispevok od Aex, preto picuje
c
        implicit none
#include "chcc1.fh"
        integer dimbe,addbe,dimga,addga
         real*8 X(1:dimbe,1:no,1:dimga,1:no)
c
        integer be,u,ga,v,bad
        integer a,i,j
        real*8 s,s1
c
        bad=0
        do v=1,no
        do ga=addga+1,addga+dimga
        do u=1,no
        do be=addbe+1,addbe+dimbe
c
          s=0.0d0
c
c         X2 (T24)   + Gvv(a,be)   . t2(ga,a,v,u)
          s1=0.0d0
          do a=1,nv
           s1=s1+Gvvc(be,a)*T2c(a,ga,u,v)
          end do
          s=s+2.0d0*s1
c
c         X3 (T25)   - Goo(i,u)    . t2(ga,be,v,i)
          s1=0.0d0
          do i=1,no
           s1=s1+Gooc(i,u)*T2c(ga,be,v,i)
          end do
          s=s-2.0d0*s1
c
c
c          T1 cleny
          s1=0.0d0
c
          do a=1,nv
           s1=s1+Q3(a,ga,be,u)*T1c(a,v)
          end do
c
          do i=1,no
           s1=s1-Q1(be,u,i,v)*T1c(ga,i)
          end do
c
          do i=1,no
          do a=1,nv
           s1=s1-(Q22(a,ga,i,u)*T1c(be,i))*T1c(a,v)
           s1=s1-(Q21(a,i,be,u)*T1c(a,v))*T1c(ga,i)
          end do
          end do
c
          s=s+2.0d0*s1
c
c
c         X4 (T22)   + sum(i,j)   [ Ta(be,ga,i,j) . A(i,j,u,v)  ]
          s1=0.0d0
          do i=1,no
           do j=1,no
          s1=s1+Ac(i,j,u,v)*(T2c(be,ga,i,j)+T1c(be,i)*T1c(ga,j))
          end do
          end do
           s=s+s1
c
c
c         X1   <-  Q(be,u,i,a) . (2 t2(ga,a,v,i) - t2(ga,a,i,v))
c         calc as (2J(be,i,u,a)-K(i,be,u,a)*(2t2(a,ga,i,v)-t2(ga,a,i,v)
          s1=0.d0
          do i=1,no
          do a=1,nv
          s1=s1+(2.0d0*Jc(be,i,u,a)-Kc(i,be,u,a))*
     c          (2.0d0*T2c(a,ga,i,v)-T2c(ga,a,i,v))
          end do
          end do
          s=s+s1
c
c         <- V1(be',u,ga',v)
          s1=Q21(be,u,ga,v)
          s=s+s1

           if (abs(X(be-addbe,u,ga-addga,v)-s).gt.1.0d-10) then
            bad=bad+1
          end if
c
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck X :',bad
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_Xred (X,dimbe,addbe,dimga,addga)
c
c        check X(be,u,ga,v)
c        do X clenu nieje zahrnuty prispevok od Aex, preto picuje
c
        implicit none
#include "chcc1.fh"
        integer dimbe,addbe,dimga,addga
         real*8 X(1:dimbe,1:no,1:dimga,1:no)
c
        integer be,u,ga,v,bad
        integer a,i,j
        real*8 s,s1
c
        bad=0
        do v=1,no
        do ga=addga+1,addga+dimga
        do u=1,no
        do be=addbe+1,addbe+dimbe
c
          s=0.0d0
c
c         X2 (T24)   + Gvv(a,be)   . t2(ga,a,v,u)
          s1=0.0d0
          do a=1,nv
           s1=s1+Gvvc(be,a)*T2c(a,ga,u,v)
          end do
          s=s+2.0d0*s1
c
c         X3 (T25)   - Goo(i,u)    . t2(ga,be,v,i)
          s1=0.0d0
          do i=1,no
           s1=s1+Gooc(i,u)*T2c(ga,be,v,i)
          end do
          s=s-2.0d0*s1
c
c
c          T1 cleny
          s1=0.0d0
c
          do a=1,nv
           s1=s1+Q3(a,ga,be,u)*T1c(a,v)
          end do
c
          do i=1,no
           s1=s1-Q1(be,u,i,v)*T1c(ga,i)
          end do
c
          do i=1,no
          do a=1,nv
           s1=s1-(Q22(a,ga,i,u)*T1c(be,i))*T1c(a,v)
           s1=s1-(Q21(a,i,be,u)*T1c(a,v))*T1c(ga,i)
          end do
          end do
c
cred          s=s+2.0d0*s1
c
c
c         X4 (T22)   + sum(i,j)   [ Ta(be,ga,i,j) . A(i,j,u,v)  ]
          s1=0.0d0
          do i=1,no
           do j=1,no
          s1=s1+Ac(i,j,u,v)*(T2c(be,ga,i,j)+T1c(be,i)*T1c(ga,j))
          end do
          end do
           s=s+s1
c
c
c         X1   <-  Q(be,u,i,a) . (2 t2(ga,a,v,i) - t2(ga,a,i,v))
c         calc as (2J(be,i,u,a)-K(i,be,u,a)*(2t2(a,ga,i,v)-t2(ga,a,i,v)
          s1=0.d0
          do i=1,no
          do a=1,nv
          s1=s1+(2.0d0*Jc(be,i,u,a)-Kc(i,be,u,a))*
     c          (2.0d0*T2c(a,ga,i,v)-T2c(ga,a,i,v))
          end do
          end do
          s=s+s1
c
c         <- V1(be',u,ga',v)
          s1=Q21(be,u,ga,v)
          s=s+s1

           if (abs(X(be-addbe,u,ga-addga,v)-s).gt.1.0d-10) then
            bad=bad+1
          end if
c
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' Chck X :',bad
c
        return
        end








c
c        ---------------------
c
        subroutine Chck_mkK
c
c        make K(be,u,i,a)
c
        implicit none
#include "chcc1.fh"
c
        integer be,u,i,a
        integer j,b
        real*8 s
c
        do a=1,nv
        do i=1,no
        do u=1,no
        do be=1,nv
c
          s=0.0d0
c
          s=s+Q22(be,a,i,u)
c
          do j=1,no
          s=s-Q1(a,j,i,u)*T1c(be,j)
          end do
c
          do b=1,nv
          s=s+Q3(a,be,b,i)*T1c(b,u)
          end do
c
          do j=1,no
          do b=1,nv
           s=s-Q21(b,i,a,j)*(T2c(b,be,u,j)/2+T1c(b,u)*T1c(be,j))
          end do
          end do
c
          Kc(i,be,u,a)=s
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' K done '
c
        return
        end
c
c        ---------------------
c
        subroutine Chck_mkJ
c
c        make J(be,u,i,a)
c
        implicit none
#include "chcc1.fh"
c
        integer be,u,i,a
        integer j,b
        real*8 sj
c
        do a=1,nv
        do i=1,no
        do u=1,no
        do be=1,nv
c
          sj=0.0d0
c
          do j=1,no
           sj=sj-Q1(a,i,j,u)*T1c(be,j)
          end do
c
          do b=1,nv
           sj=sj+Q3(b,be,a,i)*T1c(b,u)
          end do
c
          do j=1,no
          do b=1,nv
           sj=sj+(2.0d0*Q21(a,i,b,j)-Q21(a,j,b,i))*T2c(be,b,u,j)/2
           sj=sj-Q21(a,i,b,j)*(T2c(b,be,u,j)/2+T1c(b,u)*T1c(be,j))
          end do
          end do
c
          sj=sj+Q21(be,u,a,i)
c
          Jc(be,i,u,a)=sj
c
        end do
        end do
        end do
        end do
c
        write (6,*) ' J done'
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!               2008, Giovanni Ghigo                                   *
!***********************************************************************

subroutine Def_CtoF(lNew)
!***********************************************************************
!                                                                      *
!     Author: Giovanni Ghigo, Dep. of General and Organic Chemistry    *
!             University of Torino, ITALY                              *
!             July 2008                                                *
!     Adapted from  DefInt by                                          *
!             Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
logical(kind=iwp), intent(in) :: lNew
integer(kind=iwp) :: i1, i2, i3, iEnd, iFrst, jEnd, Lu_UDIC, mCntr, msAtom, nCntr, neq, nGo, nTemp
real(kind=wp) :: Tmp
character(len=120) :: Line, Temp
character(len=16) :: filnam
character(len=8) :: Frmt, Labels
character(len=6) :: Typ
integer(kind=iwp), allocatable :: Ind(:,:)
real(kind=wp), allocatable :: Mass(:,:), Temp2(:,:), xyz(:,:)

nTemp = len(Temp)
write(Frmt,'(A,I3.3,A)') '(F',nTemp,'.0)'

Lu_UDIC = 91
filnam = 'UDIC'
call molcas_open(Lu_UDIC,filnam)
!open(Lu_UDIC,File=filnam,Form='Formatted',Status='OLD')
rewind(Lu_UDIC)
write(u6,*)
write(u6,*) '****************************************************************'
if (lNew) then
  write(u6,*) '* New value of the internal coordinate to follow               *'
else
  write(u6,*) '* Original value of the internal coordinate to follow          *'
end if
write(u6,*) '****************************************************************'

! Step 1. BSet up the b vectors from which we will define the
! internal coordinates.

!iBVct = 0
read(Lu_UDIC,'(A)') Line
Temp = Line
call UpCase(Temp)

! Move the label of the internal coordinate

neq = index(Line,'=')
if (neq == 0) then
  call WarningMessage(2,'Error in Def_CTOF')
  write(u6,'(A)') '***********************************'
  write(u6,'(A)') ' Syntax error in line :            '
  write(u6,'(A)') Line(1:33),'...'
  write(u6,'(A)') '***********************************'
  call Quit_OnUserError()
else
  iFrst = 1
  call NxtWrd(Line,iFrst,iEnd)
  jEnd = iEnd
  if (Line(iEnd:iEnd) == '=') jEnd = jEnd-1
  if (jEnd-iFrst+1 > 8) then
    call WarningMessage(2,'Error in Def_CTOF')
    write(u6,'(A)') '***********************************'
    write(u6,'(A)') ' Syntax error in line :            '
    write(u6,'(A)') Line(1:33),'...'
    write(u6,'(A,A)') Line(iFrst:jEnd),' has more than 8 character'
    write(u6,'(A)') '***********************************'
    call Quit_OnUserError()
  end if
  Labels = Line(iFrst:jEnd)
end if

! Construct the corresponding transformation vector

mCntr = 0
if (index(Temp,'CART') /= 0) then
  nCntr = 1
  nGo = index(Temp,'CART')
  nGo = nGo-1+index(Temp(nGo:nTemp),' ')
  if (index(Temp(nGo:nTemp),'X') /= 0) then
    nGo = nGo-1+index(Temp(nGo:nTemp),'X')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'X     '
  else if (index(Temp(nGo:nTemp),'Y') /= 0) then
    nGo = nGo-1+index(Temp(nGo:nTemp),'Y')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'Y     '
  else if (index(Temp(nGo:nTemp),'Z') /= 0) then
    nGo = nGo-1+index(Temp(nGo:nTemp),'Z')
    nGo = nGo-1+index(Temp(nGo:nTemp),' ')
    Typ = 'Z     '
  else
    nGo = -1
    call WarningMessage(2,'Error in Def_CTOF')
    write(u6,*) 'DefInt: wrong cartesian type'
    write(u6,'(A,A)') 'Temp=',Temp
    call Quit_OnUserError()
  end if
else if (index(Temp,'BOND') /= 0) then
  nCntr = 2
  nGo = index(Temp,'BOND')
  nGo = nGo-1+index(Temp(nGo:nTemp),' ')
  Typ = 'STRTCH'
else if (index(Temp,'LANGLE(2)') /= 0) then
  nCntr = 3
  nGo = index(Temp,'LANGLE(2)')
  nGo = nGo-1+index(Temp(nGo:nTemp),' ')
  Typ = 'LBEND2'
else if (index(Temp,'LANGLE(1)') /= 0) then
  nCntr = 3
  nGo = index(Temp,'LANGLE(1)')
  nGo = nGo-1+index(Temp(nGo:nTemp),' ')
  Typ = 'LBEND1'
else if (index(Temp,'ANGL') /= 0) then
  nCntr = 3
  nGo = index(Temp,'ANGL')
  nGo = nGo-1+index(Temp(nGo:nTemp),' ')
  Typ = 'BEND  '
else if (index(Temp,'DIHE') /= 0) then
  nCntr = 4
  nGo = index(Temp,'DIHE')
  nGo = nGo-1+index(Temp(nGo:nTemp),' ')
  Typ = 'TRSN  '
else if (index(Temp,'OUTO') /= 0) then
  nCntr = 4
  nGo = index(Temp,'OUTO')
  nGo = nGo-1+index(Temp(nGo:nTemp),' ')
  Typ = 'OUTOFP'
else if (index(Temp,'DISS') /= 0) then
  i1 = index(Line,'(')
  i2 = index(Line,'+')
  i3 = index(Line,')')
  if ((i1 >= i2) .or. (i2 >= i3)) then
    call WarningMessage(2,'Error in Def_CTOF')
    write(u6,*) ' Line contains syntax error!'
    write(u6,'(A)') Line
    write(u6,*) i1,i2,i3
    call Quit_OnUserError()
  end if
  nGo = i3+1
  Temp = Line(i1+1:i2-1)
  read(Temp,Frmt) Tmp
  nCntr = nint(Tmp)
  Temp = Line(i2+1:i3-1)
  read(Temp,Frmt) Tmp
  mCntr = nint(Tmp)
  Typ = 'DISSOC'
else
  nGo = -1
  call WarningMessage(2,'Error in Def_CTOF')
  write(u6,*) ' Line contains syntax error!'
  write(u6,'(A)') Line
  call Quit_OnUserError()
end if

msAtom = nCntr+mCntr
call mma_allocate(xyz,3,msAtom,Label='xyz')
call mma_allocate(Temp2,3,msAtom,Label='Temp2')
call mma_allocate(Ind,2,msAtom,Label='Ind')
call mma_allocate(Mass,2,msAtom,Label='Mass')

call CllCtoF(Line(nGo:nTemp),nCntr,mCntr,xyz,Temp2,Ind,Typ,Mass,Labels)

call mma_deallocate(Mass)
call mma_deallocate(Ind)
call mma_deallocate(Temp2)
call mma_deallocate(xyz)

close(Lu_UDIC)

return

end subroutine Def_CtoF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      subroutine tmltpl(inp,lpole,maxlab,
     *                  labs,
     *                  ndim,prvec,t,temp)
c
c     Purpose: transformation of maxlab cartesian l-th
c              moments into the corresponding l-pole cartesian
c              moments; l=lpole
c
c
c     inp                    if inp.eq.0 the t matrix will be
c                            calculated. Otherwise the t matrix
c                            is transferred from the previous
c                            call
c     lpole                  l value for the l-pole moment
c     maxlab                 is the number of cartesian components
c                            of the l-pole moment
c     labs(1:maxlab)         labels for components of the l-pole
c                            moment
c     ndim                   defines the number of rows which will
c                            be transformed in the table
c                            prvec(1:ndim,1:maxlab)
c     t(1:maxlab,1:maxlab)   is the transformation matrix generated
c                            in this program for lpole=2,3,4
c     temp(1:maxlab)         is a temporary strorage area
c
************************************************************************
      implicit real*8 (a-h,o-z)
      character*1 l1,l2,l3,l4
      character*14 l14
      character*16 labs(1:maxlab)
      dimension prvec(1:ndim,1:maxlab)
      dimension t(1:maxlab,1:maxlab)
      dimension temp(1:maxlab)
      dimension irr(1:3,1:3),ilab(1:6,1:3),irrrr(1:6,1:3)
c
      k=0 ! dummy initialize
      l=0 ! dummy initialize
c
c     building of transformation matrices for the transformation
c     from cartesina l-th moments to cartesian l-pole moments
c     limited to l=2,3, and 4
c
      if (inp.eq.1) go to 98
      go to (100,200,300), lpole-1
c
c     quadrupole moments
c
  100 continue
c
      do 101 i=1,maxlab
        do 102 j=1,maxlab
          t(i,j)=0.0d+00
  102   continue
        t(i,i)=t(i,i)+1.5d+00
        read (labs(i),'(a14,2a1)') l14,l1,l2
        if (l1.eq.l2) then
          t(i,1)=t(i,1)-0.5d+00
          t(i,4)=t(i,4)-0.5d+00
          t(i,6)=t(i,6)-0.5d+00
        endif
  101 continue
      go to 99
c
c     octupole moments
c
  200 continue
c
      do 205 i=1,3
        do 206 j=1,3
          irr(i,j)=0
  206   continue
        irr(i,i)=2
  205 continue
c
      do 201 i=1,maxlab
        do 202 j=1,maxlab
          t(i,j)=0.0d+00
  202   continue
        t(i,i)=t(i,i)+2.5d+00
        read (labs(i),'(a13,3a1)') l14,l1,l2,l3
        if (l1.eq.l2) then
          do 203 i1=1,3
            do 204 i2=1,3
              ilab(i1,i2)=irr(i1,i2)
  204       continue
  203     continue
          k=0
          if (l3.eq.'X') k=1
          if (l3.eq.'Y') k=2
          if (l3.eq.'Z') k=3
          do 207 j=1,3
            ilab(j,k)=ilab(j,k)+1
            ind=(3-ilab(j,1))*(3-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)-0.5d+00
  207     continue
        endif
        if (l2.eq.l3) then
          do 208 i1=1,3
            do 209 i2=1,3
              ilab(i1,i2)=irr(i1,i2)
  209       continue
  208     continue
          k=0
          if (l1.eq.'X') k=1
          if (l1.eq.'Y') k=2
          if (l1.eq.'Z') k=3
          do 210 j=1,3
            ilab(j,k)=irr(j,k)+1
            ind=(3-ilab(j,1))*(3-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)-0.5d+00
  210     continue
        endif
        if (l1.eq.l3) then
          do 211 i1=1,3
            do 212 i2=1,3
              ilab(i1,i2)=irr(i1,i2)
  212       continue
  211     continue
          k=0
          if (l2.eq.'X') k=1
          if (l2.eq.'Y') k=2
          if (l2.eq.'Z') k=3
          do 213 j=1,3
            ilab(j,k)=irr(j,k)+1
            ind=(3-ilab(j,1))*(3-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)-0.5d+00
  213     continue
        endif
  201 continue
      go to 99
c
c     hexadexapole moments
c
  300 continue
c
      do 305 i=1,3
        do 306 j=1,3
          irr(i,j)=0
  306   continue
        do 307 j=1,6
          irrrr(j,i)=0
  307   continue
        irr(i,i)=2
  305 continue
      irrrr(1,1)=4
      irrrr(2,1)=2
      irrrr(2,2)=2
      irrrr(3,1)=2
      irrrr(3,3)=2
      irrrr(4,2)=4
      irrrr(5,2)=2
      irrrr(5,3)=2
      irrrr(6,3)=4
c
      do 301 i=1,maxlab
        do 302 j=1,maxlab
          t(i,j)=0.0d+00
  302   continue
        t(i,i)=t(i,i)+4.375d+00
        read (labs(i),'(a12,4a1)') l14,l1,l2,l3,l4
        if (l1.eq.l2) then
          do 303 i1=1,3
            do 304 i2=1,3
              ilab(i1,i2)=irr(i1,i2)
  304       continue
  303     continue
          k=0
          l=0
          if (l3.eq.'X') k=1
          if (l3.eq.'Y') k=2
          if (l3.eq.'Z') k=3
          if (l4.eq.'X') l=1
          if (l4.eq.'Y') l=2
          if (l4.eq.'Z') l=3
          do 308 j=1,3
            ilab(j,k)=ilab(j,k)+1
            ilab(j,l)=ilab(j,l)+1
            ind=(4-ilab(j,1))*(4-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)-0.625d+00
  308     continue
        endif
        if (l1.eq.l3) then
          do 309 i1=1,3
            do 310 i2=1,3
              ilab(i1,i2)=irr(i1,i2)
  310       continue
  309     continue
          k=0
          l=0
          if (l2.eq.'X') k=1
          if (l2.eq.'Y') k=2
          if (l2.eq.'Z') k=3
          if (l4.eq.'X') l=1
          if (l4.eq.'Y') l=2
          if (l4.eq.'Z') l=3
          do 311 j=1,3
            ilab(j,k)=ilab(j,k)+1
            ilab(j,l)=ilab(j,l)+1
            ind=(4-ilab(j,1))*(4-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)-0.625d+00
  311     continue
        endif
        if (l1.eq.l4) then
          do 312 i1=1,3
            do 313 i2=1,3
              ilab(i1,i2)=irr(i1,i2)
  313       continue
  312     continue
          k=0
          l=0
          if (l2.eq.'X') k=1
          if (l2.eq.'Y') k=2
          if (l2.eq.'Z') k=3
          if (l3.eq.'X') l=1
          if (l3.eq.'Y') l=2
          if (l3.eq.'Z') l=3
          do 314 j=1,3
            ilab(j,k)=ilab(j,k)+1
            ilab(j,l)=ilab(j,l)+1
            ind=(4-ilab(j,1))*(4-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)-0.625d+00
  314     continue
        endif
        if (l2.eq.l3) then
          do 315 i1=1,3
            do 316 i2=1,3
              ilab(i1,i2)=irr(i1,i2)
  316       continue
  315     continue
          k=0
          l=0
          if (l1.eq.'X') k=1
          if (l1.eq.'Y') k=2
          if (l1.eq.'Z') k=3
          if (l4.eq.'X') l=1
          if (l4.eq.'Y') l=2
          if (l4.eq.'Z') l=3
          do 317 j=1,3
            ilab(j,k)=ilab(j,k)+1
            ilab(j,l)=ilab(j,l)+1
            ind=(4-ilab(j,1))*(4-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)-0.625d+00
  317     continue
        endif
        if (l2.eq.l4) then
          do 318 i1=1,3
            do 319 i2=1,3
              ilab(i1,i2)=irr(i1,i2)
  319       continue
  318     continue
          k=0
          l=0
          if (l1.eq.'X') k=1
          if (l1.eq.'Y') k=2
          if (l1.eq.'Z') k=3
          if (l3.eq.'X') l=1
          if (l3.eq.'Y') l=2
          if (l3.eq.'Z') l=3
          do 320 j=1,3
            ilab(j,k)=ilab(j,k)+1
            ilab(j,l)=ilab(j,l)+1
            ind=(4-ilab(j,1))*(4-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)-0.625d+00
  320     continue
        endif
        if (l3.eq.l4) then
          do 321 i1=1,3
            do 322 i2=1,3
              ilab(i1,i2)=irr(i1,i2)
  322       continue
  321     continue
          k=0
          l=0
          if (l1.eq.'X') k=1
          if (l1.eq.'Y') k=2
          if (l1.eq.'Z') k=3
          if (l2.eq.'X') l=1
          if (l2.eq.'Y') l=2
          if (l2.eq.'Z') l=3
          do 323 j=1,3
            ilab(j,k)=ilab(j,k)+1
            ilab(j,l)=ilab(j,l)+1
            ind=(4-ilab(j,1))*(4-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)-0.625d+00
  323     continue
        endif
        do 324 i1=1,6
          do 325 i2=1,3
            ilab(i1,i2)=irrrr(i1,i2)
  325     continue
  324   continue
        if (l1.eq.l2.and.l3.eq.l4) then
          do 326 j=1,6
            f=0.125d+00
            if (j.eq.2.or.j.eq.3.or.j.eq.5) f=2.0d+00*f
            ind=(4-ilab(j,1))*(4-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)+f
  326     continue
        endif
        if (l1.eq.l3.and.l2.eq.l4) then
          do 327 j=1,6
            f=0.125d+00
            if (j.eq.2.or.j.eq.3.or.j.eq.5) f=2.0d+00*f
            ind=(4-ilab(j,1))*(4-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)+f
  327     continue
        endif
        if (l2.eq.l3.and.l1.eq.l4) then
          do 328 j=1,6
            f=0.125d+00
            if (j.eq.2.or.j.eq.3.or.j.eq.5) f=2.0d+00*f
            ind=(4-ilab(j,1))*(4-ilab(j,1)+1)/2+ilab(j,3)+1
            T(i,ind)=T(i,ind)+f
  328     continue
        endif
  301 continue
c
   99 continue
c
c     print the transformation matrix
c
c      write (*,'(//1x,a,i2/)') 'transformation matrix:  lpole=',lpole
c      do 401 i=1,maxlab
c        write (*,'(15f7.3)') (t(i,j),j=1,maxlab)
c  401 continue
c
   98 continue
c
c     transform cartesian moment to multipole moments
c
      do 1 icount=1,ndim
        do 2 k=1,maxlab
          temp(k)=prvec(icount,k)
    2   continue
        do 3 k=1,maxlab
          sum=+0.0d+00
          do 4 l=1,maxlab
            sum=sum+t(k,l)*temp(l)
    4     continue
          prvec(icount,k)=sum
    3   continue
    1 continue
c
      return
#ifdef _WARNING_WORKAROUND_
      if (.false.) call unused_character(l14)
#endif
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Subroutine Phase(iCmp, jCmp, kCmp, lCmp, iAng,
     &                 iShll, kOp, ijkl, AOInt)
************************************************************************
*                                                                      *
*  Object: To change the phase of the integrals in accordance with the *
*          swapping of the operators operating on the integrals.       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             June '90                                                 *
************************************************************************
      use Basis_Info
      use Real_Spherical, only: iSphCr
      use Symmetry_Info, only: iChBas
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 AOInt(ijkl,iCmp,jCmp,kCmp,lCmp)
      Integer iAng(4), iShll(4)
*
*     Statement Function
*
      iOff(ixyz)  = ixyz*(ixyz+1)*(ixyz+2)/6
*
*     Call RecPrt(' In Phase: AOInt ',' ',AOInt,ijkl,ijCmp*ijCmp)
*
*     Change phase factor. This is only necessary if T=/=E.
*
      If (kOp.eq.0 .or. iCmp*jCmp*kCmp*lCmp.eq.0) Go To 14
      ii = iOff(iAng(1))
      jj = iOff(iAng(2))
      kk = iOff(iAng(3))
      ll = iOff(iAng(4))
      Do 10 i1 = 1, iCmp
       iChBs = iChBas(ii+i1)
       If (Shells(iShll(1))%Transf) iChBs = iChBas(iSphCr(ii+i1))
       pa1T = DBLE(iPrmt(kOp,iChBs))
       Do 11 i2 = 1, jCmp
        jChBs = iChBas(jj+i2)
        If (Shells(iShll(2))%Transf) jChBs = iChBas(iSphCr(jj+i2))
        pb1T = DBLE(iPrmt(kOp,jChBs))
*
        Do 12 i3 = 1, kCmp
         kChBs = iChBas(kk+i3)
         If (Shells(iShll(3))%Transf) kChBs = iChBas(iSphCr(kk+i3))
         pa2T = DBLE(iPrmt(kOp,kChBs))
         Do 13 i4 = 1, lCmp
          lChBs = iChBas(ll+i4)
          If (Shells(iShll(4))%Transf) lChBs = iChBas(iSphCr(ll+i4))
          pb2T = DBLE(iPrmt(kOp,lChBs))
          Factor=pa1T*pb1T*pa2T*pb2T
          If (Factor.ne.One) Call DScal_(ijkl,Factor,
     &                                  AOInt(1,i1,i2,i3,i4),1)
 13      Continue
 12     Continue
 11    Continue
 10   Continue
 14   Continue
*
*     Call RecPrt(' Exit Phase: AOInt ',' ',AOInt,ijkl,
*    &            iCmp*jCmp*kCmp*lCmp)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

#ifdef _DMRG_

!***********************************************************************
!                                                                      *
!  Purpose:  read DMRG input in QCMaquis style                         *
!                                                                      *
!***********************************************************************
subroutine socc_dmrg_rdinp(luinput,initial_occ,nrs2t,nroots)

use qcmaquis_interface_utility_routines, only: lower_to_upper
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: luinput, nrs2t, nroots
integer(kind=iwp), intent(inout) :: initial_occ(nrs2t,nroots)
integer(kind=iwp) :: i, io, j, k, ls
character(len=800) :: string
character :: tag

i = 1
do
  if (i > nroots) exit

  string = ''
  read(luinput,'(a)',iostat=io) string
  if (is_iostat_end(io)) exit
  if (io > 0) call SysAbendMsg('socc_dmrg_rdinp','problem reading QCMaquis SOCC input','')
  ls = len_trim(string)
  j = 0
  do k=1,ls

    tag = string(k:k)
    if ((tag == ' ') .or. (tag == ',')) cycle

    j = j+1
    if (j > nrs2t) exit

    call lower_to_upper(tag)

    if (tag == 'U') then
      initial_occ(j,i) = 3
    else if (tag == 'D') then
      initial_occ(j,i) = 2
    else if (tag == '2') then
      initial_occ(j,i) = 4
    else if (tag == '0') then
      initial_occ(j,i) = 1
    else
      call SysAbendMsg('socc_dmrg_rdinp','problem reading QCMaquis SOCC input:','unknown orbital occupation: I know U, D, 2, 0')
    end if
  end do

  if (j /= nrs2t) call SysAbendMsg('socc_dmrg_rdinp','problem reading QCMaquis SOCC input:','wrong number of active orbitals')
  i = i+1
end do

end subroutine socc_dmrg_rdinp

#elif ! defined (EMPTY_FILES)

! Some compilers do not like empty files
#include "macros.fh"
dummy_empty_procedure(socc_dmrg_rdinp)

#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE sigma_master
*
* Controls the calculation of the sigma vector, when Lucia is called
* from Molcas Rasscf.
*
      implicit real*8 (a-h,o-z)
#include "mxpdim.fh"
#include "cicisp.fh"
#include "cstate.fh"
#include "clunit.fh"
#include "glbbas.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "cecore.fh"
#include "crun.fh"
#include "rasscf_lucia.fh"
*
* Put CI-vector from RASSCF on luc and get h0 from Molcas enviroment.
*
      IF (INI_H0 .EQ. 0) THEN
         ECORE = ECORE_ORIG
      ENDIF
      INI_H0 = 0
      NDIM = NTOOB**2
      CALL COPVEC(WORK(KINT1O_POINTER),WORK(KINT1_POINTER),NDIM)
      ECORE_ORIG = ECORE
c      IF (IUSE_PH .EQ. 1) THEN
c         CALL FI(WORK(KINT1_POINTER),ECORE_HEX,1)
c         ECORE = ECORE + ECORE_HEX
c      END IF
      call GetMem('lvec','Allo','inte',ivlrec,MXNTTS)
      CALL CPCIVC(LUC, MXNTTS, IREFSM, 1, iWork(ivlrec))
      call GetMem('lvec','Free','inte',ivlrec,MXNTTS)
*
* Calculate the sigma vector:
*
      CALL GETMEM('KC2   ','ALLO','REAL',KVEC3,KVEC3_LENGTH)
      CALL MV7(WORK(KCI_POINTER), WORK(KSIGMA_POINTER), LUC, LUSC34)
      CALL GETMEM('KC2   ','FREE','REAL',KVEC3,KVEC3_LENGTH)
*
* Export lusc34 to RASSCF
*
      call GetMem('lvec','Allo','inte',ivlrec,MXNTTS)

      CALL CPCIVC(LUSC34, MXNTTS, IREFSM, 2, iWork(ivlrec))
      call GetMem('lvec','Free','inte',ivlrec,MXNTTS)
*
      RETURN
      END
******************************
*                            *
*   Now for the CASVB case   *
*                            *
******************************
      SUBROUTINE SIGMA_MASTER_CVB(IREFSM_CASVB)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "mxpdim.fh"
#include "cands.fh"
#include "cicisp.fh"
#include "cstate.fh"
#include "clunit.fh"
#include "glbbas.fh"
#include "WrkSpc.fh"
#include "orbinp.fh"
#include "cecore.fh"
#include "crun.fh"
#include "rasscf_lucia.fh"
*
* Set ICSM and ISSM (from cands.fh) to the correct symmetry for this call
*
      ICSM  = IREFSM_CASVB
      ISSM  = IREFSM_CASVB
*
* Get h0 from Molcas enviroment.
*
      IF (INI_H0 .EQ. 0) THEN
         ECORE = ECORE_ORIG
      ENDIF
      INI_H0 = 0
      NDIM = NTOOB**2
      CALL COPVEC(WORK(KINT1O_POINTER),WORK(KINT1_POINTER),NDIM)
      ECORE_ORIG = ECORE
c      IF (IUSE_PH .EQ. 1) THEN
c         CALL FI(WORK(KINT1_POINTER),ECORE_HEX,1)
c         ECORE = ECORE + ECORE_HEX
c      END IF
*
* Write CI-vector to disc
*
      call GetMem('lvec','Allo','inte',ivlrec,MXNTTS)

      CALL CPCIVC(LUC, MXNTTS, ISSM, 1,iWork(ivlrec))
      call GetMem('lvec','Free','inte',ivlrec,MXNTTS)
*
* Calculate the sigma vector:
*
      CALL DIAG_MASTER
      CALL GETMEM('KC2   ','ALLO','REAL',KVEC3,KVEC3_LENGTH)
      CALL MV7(WORK(KCI_POINTER), WORK(KSIGMA_POINTER), LUC, LUSC34)
      CALL GETMEM('KC2   ','FREE','REAL',KVEC3,KVEC3_LENGTH)
*
* Export lusc34 to RASSCF
*
      ISIGMA_ON_DISK = 1
*
* Set ICSM and ISSM (from cands.fh) back to IREFSM
*
      ICSM  = IREFSM
      ISSM  = IREFSM
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001-2005, Valera Veryazov                             *
!               2020, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine BasisType(Filename,inline,BasisTypes)

! translate basis file names

use BasisType_Mod, only: BasTypeAll, BasTypeCon, BasTypeNuc, BasTypeRel
use Definitions, only: iwp, u6

implicit none
character(len=*), intent(in) :: Filename
integer(kind=iwp), intent(in) :: inline
integer(kind=iwp), intent(out) :: BasisTypes(4)
integer(kind=iwp) :: i, i1, iflag, iL, ileft, irecl, istatus, iunit, j, jj, LenOrig
logical(kind=iwp) :: is_error, isKnown, found
character(len=256) :: DirName, OrigName, Line, LineComp
character(len=16) :: CONT, ALLE, RELA, NUCL
character(len=4) :: tmp
character(len=3) :: vCONT, vALLE, vRELA, vNUCL
integer(kind=iwp), external :: isFreeUnit, StrnLn

CONT = '#Contraction '
ALLE = '#AllElectron '
RELA = '#Hamiltonian '
NUCL = '#Nucleus '
vCONT = 'UNK'
vALLE = 'UNK'
vRELA = 'UNK'
vNUCL = 'UNK'
isKnown = .false.
if (inline == 1) then
  BasisTypes(:) = -1
  call SysWarnMsg('BasisType','inline basis is used','assuming all defaults for the basis types')
  return
end if
BasisTypes(3) = 0
iunit = isfreeunit(20)
ileft = StrnLn(FileName)
i = StrnLn(FileName)
found = .false.

do while ((.not. found) .and. (i > 1))
  if (FileName(i:i) == '/') then
    ileft = i
    found = .true.
  end if
  i = i-1
end do

if (.not. found) then
  ileft = StrnLn(FileName)
  i = StrnLn(FileName)
  do while ((.not. found) .and. (i > 1))
    if (FileName(i:i) == '_') then
      ileft = i
      found = .true.
    end if
    i = i-1
  end do
end if
DirName = Filename(1:ileft)
i = index(Filename,' ')
if (i == 0) i = len(Filename)
OrigName = Filename(ileft+1:i)
LenOrig = i-ileft

! first, check tbl.
call molcas_open_ext2(iunit,DirName(1:ileft)//'basistype.tbl','sequential','formatted',istatus,.false.,irecl,'old',is_error)
!open(iunit,file=DirName(1:ileft)//'basistype.tbl',form='formatted',iostat=istatus)
if (istatus /= 0) then
  close(iunit)
  call molcas_open_ext2(iunit,'BASLIB_basistype.tbl','sequential','formatted',istatus,.false.,irecl,'old',is_error)
  !open(iunit,file='BASLIB_basistype.tbl',form='formatted',iostat=istatus)
end if
if (istatus /= 0) then
  write(u6,*) 'basistype.tbl is not found'
  close(iunit)
else
  do
    read(iunit,'(a)',iostat=istatus) Line
    if (istatus /= 0) exit
    if (Line(1:1) == '#') cycle
    i = index(Line,OrigName(1:LenOrig-1))
    if ((i == 1) .and. (Line(LenOrig:LenOrig) == ' ')) exit
  end do
  if (istatus == 0) then
    i = LenOrig+1
    iL = 1
    iflag = 0
    LineComp = ' '
    do jj=i,len(Line)
      if (Line(jj:jj) == ' ') then
        if (iflag == 0) then
          iflag = 1
          LineComp(iL:iL) = ':'
          iL = iL+1
        end if
      else
        iflag = 0
        LineComp(iL:iL) = Line(jj:jj)
        iL = iL+1
      end if
    end do
    isKnown = .true.
    vCONT = LineComp(2:4)
    vALLE = LineComp(6:8)
    vRELA = LineComp(10:12)
    vNUCL = LineComp(14:16)
    if (vCONT == ' ') vCONT = 'UNK'
    if (vALLE == ' ') vALLE = 'UNK'
    if (vRELA == ' ') vRELA = 'UNK'
    if (vNUCL == ' ') vNUCL = 'UNK'
  end if
  close(iunit)
end if

! now let's check the header of the basis file

Found = .false.
if (OrigName(1:LenOrig-1) /= ' ') call f_Inquire(DirName(1:ileft)//OrigName(1:LenOrig-1),Found)
if (Found) then
  !write(u6,*) 'open >',DirName(1:ileft)//OrigName(1:LenOrig-1),'<'
  call molcas_open(iunit,DirName(1:ileft)//OrigName(1:LenOrig-1))
  do
    read(iunit,'(a)',iostat=istatus) Line
    if (istatus /= 0) exit
    if (Line(1:1) == '/') then
      ! we already reached body of the file.
      LineComp = ':'//vCONT//':'//vALLE//':'//vRELA//':'//vNUCL//':'
      isKnown = .true.
      exit
    end if
    ! finish reading, let's create the return string

    !write(u6,*) 'line=',Line
    if (index(Line,CONT(1:index(CONT,' '))) == 1) then
      i = index(Line,' ')
      do j=i,len(Line)
        if (Line(j:j) /= ' ') exit
      end do
      vCONT = Line(j:j+3)
    end if
    if (index(Line,ALLE(1:index(ALLE,' '))) == 1) then
      i = index(Line,' ')
      do j=i,len(Line)
        if (Line(j:j) /= ' ') exit
      end do
      vALLE = Line(j:j+3)
    end if
    if (index(Line,RELA(1:index(RELA,' '))) == 1) then
      i = index(Line,' ')
      do j=i,len(Line)
        if (Line(j:j) /= ' ') exit
      end do
      vRELA = Line(j:j+3)
    end if

    if (index(Line,NUCL(1:index(NUCL,' '))) == 1) then
      i = index(Line,' ')
      do j=i,len(Line)
        if (Line(j:j) /= ' ') exit
      end do
      vNUCL = Line(j:j+3)
    end if

  end do

  ! well, now use tbl

  close(iunit)
end if

if (.not. isKnown) LineComp = ':UNK:UNK:UNK:UNK:'
!write(u6,*) 'DEBUG=',LineComp
tmp = LineComp(2:5)
i1 = index(BasTypeCon,tmp)
if ((i1 == 0) .or. (tmp == 'UNK:')) then
  BasisTypes(1) = -1
else
  i1 = i1/4+1
  BasisTypes(1) = i1
end if

tmp = LineComp(6:9)
i1 = index(BasTypeAll,tmp)
if ((i1 == 0) .or. (tmp == 'UNK:')) then
  BasisTypes(2) = -1
else
  i1 = i1/4+1
  BasisTypes(2) = i1
  ! hack to map YES to AE_, and NO_ to NAE
  if (BasisTypes(2) == 3) BasisTypes(2) = 1
  if (BasisTypes(2) == 4) BasisTypes(2) = 2
end if

tmp = LineComp(10:13)
i1 = index(BasTypeRel,tmp)
if ((i1 == 0) .or. (tmp == 'UNK:')) then
  BasisTypes(3) = -1
else
  i1 = i1/4+1
  BasisTypes(3) = i1
end if

tmp = LineComp(14:17)
i1 = index(BasTypeNuc,tmp)
if ((i1 == 0) .or. (tmp == 'UNK:')) then
  BasisTypes(4) = -1
else
  i1 = i1/4+1
  BasisTypes(4) = i1
end if

return

end subroutine BasisType

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ThrdO(nInter,g,A,e,Fail)
************************************************************************
*                                                                      *
* Object: to find the error vector given the gradient, and the Hessian *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 g(nInter), A(nInter,nInter), e(nInter,2)
      Logical Fail
*
      i0=1
      i1=2
      iter=0
      iStep=0
      Fail=.True.
*
*---- Compile the error vector, starting in position 1
*     Observe that g is the force and NOT the gradient
*
      call dcopy_(nInter,g,1,e(1,i0),1)
      Call DPOTRS('U',nInter,1,A,nInter,e(1,i0),nInter,iRC)
      If (iRC.ne.0) Then
         Write (6,*) 'ThrdO(DPOTRS): iRC=',iRC
         Call Abend()
      End If

      Call RecPrt(' ThrdO: e(0)',' ',e(1,i0),nInter,1)
*
      Thrd=1.D-6
      iterMx=40
*
800   Continue
      iStep=iStep+1
      Fact=0.1D0*DBLE(iStep)
*
900   Continue
*
*
*---- Newton-Raphson scheme
*
      call dcopy_(nInter,g,1,e(1,i1),1)
      Call DPOTRS('U',nInter,1,A,nInter,e(1,i1),nInter,iRC)
      If (iRC.ne.0) Then
         Write (6,*) 'ThrdO(DPOTRS): iRC=',iRC
         Call Abend()
      End If
*
*
*     Call RecPrt(' ThrdO: e',' ',e(1,i1),nInter,1)
      iter=iter+1
*
*---- Check if the error vectors are self consistent.
*
      Test=Zero
      Do i = 1, nInter
         diff = Abs(e(i,i0)-e(i,i1))
         If (diff.gt.Test) Test=diff
      End Do
*     Write (*,*) iter,diff
*
      If (iter.gt.iterMx) Then
         Call WarningMessage(1,'ThrdO: Exceeded max iterations')
         Return
      End If
*
      If (Test.lt.Thrd) Then
*------- Copy converged vectors to slot 1
         If (i1.ne.1) call dcopy_(nInter,e(1,i1),1,e(1,1),1)
         If (iStep.eq.10) Then
            Call RecPrt(' ThrdO: e(Final)',' ',e,nInter,1)
            Fail=.False.
            Return
         Else
            iter=0
            Go To 800
         End If
      Else
*------- If not change vector slot
         itmp=i0
         i0=i1
         i1=itmp
         Go To 900
      End If
      Call WarningMessage(2,'Error in ThrdO')
      Call Abend()
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine DCR(Lambda,iStab1,nStab1,iStab2,nStab2,iDCR,mDCR)
!***********************************************************************
! Oject: to compute the double coset representatives (DCR) and Lambda. *
!                                                                      *
! Called from: OneEl                                                   *
!              NucAtt                                                  *
!              TwoEl                                                   *
!                                                                      *
! Calling    : None                                                    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!***********************************************************************

use Index_Functions, only: iTri
use Symmetry_Info, only: iOper, nIrrep
use dcr_mod, only: Done, iDCR_all, Indx, Lambda_all, mDCR_all, nIndx
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: Lambda, iDCR(0:7), mDCR
integer(kind=iwp), intent(in) :: nStab1, iStab1(0:nStab1-1), nStab2, iStab2(0:nStab2-1)
integer(kind=iwp) :: i, iIrrep, ij, Ind1, Ind2, iScrt(0:7,0:7), j, jik, k

Ind1 = 0
do i=1,nStab1-1
  do iIrrep=1,nIrrep-1
    if (iStab1(i) == iOper(iIrrep)) then
      Ind1 = Ind1+2**(iIrrep-1)
      exit
    end if
  end do
end do
do k=1,nIndx
  if (Ind1 == Indx(k)) then
    Ind1 = k
    exit
  end if
end do
if (k > nIndx) then
  nIndx = nIndx+1
  Indx(nIndx) = Ind1
  Ind1 = nIndx
end if

Ind2 = 0
do i=1,nStab2-1
  do iIrrep=1,nIrrep-1
    if (iStab2(i) == iOper(iIrrep)) then
      Ind2 = Ind2+2**(iIrrep-1)
      exit
    end if
  end do
end do
do k=1,nIndx
  if (Ind2 == Indx(k)) then
    Ind2 = k
    exit
  end if
end do
if (k > nIndx) then
  nIndx = nIndx+1
  Indx(nIndx) = Ind2
  Ind2 = nIndx
end if

ij = iTri(Ind1,Ind2)

if (Done(ij)) then
  mDCR = mDCR_all(ij)
else
  iScrt(:,:) = 0

  ! Construct all UGV subgroups. We accumulate the number of times an
  ! operator appears in each UGV subgroup.

  do i=0,nIrrep-1
    do j=0,nStab1-1
      do k=0,nStab2-1
        jik = ieor(iStab1(j),ieor(iOper(i),iStab2(k)))
        iScrt(i,jik) = iScrt(i,jik)+1
      end do
    end do
  end do

  ! Find Lambda. Lambda is the number of times an operator is in the
  ! subgroup UGV. Look only in the first subgroup.

  do i=0,7
    if (iScrt(0,i) /= 0) Lambda_all(ij) = iScrt(0,i)
  end do

  ! Find the unique double cosets (DC) and construct the double coset
  ! representatives (DCR)

  ! Move the first double coset representative, i.e. take the first
  ! operator which appears in the subgroup UGV.

  mDCR = 0
  do i=0,7
    if (iScrt(0,iOper(i)) /= 0) then
      iDCR_all(mDCR,ij) = iOper(i)
      mDCR = mDCR+1
      exit
    end if
  end do

  ! Now look through the remaining subgroups UGV, if any. If a new
  ! unique subgroup is found take a representative from this set.
  ! Observe that the subgroups UGV are either totally identical or
  ! completely disjoint.

  do i=1,nIrrep-1
    outer: do k=0,nIrrep-1
      ! Check if operator exists in UGV.
      if (iScrt(i,iOper(k)) == 0) cycle outer
      do j=0,mDCR-1
        ! See that no element of UGV is already in DCR.
        if (iDCR_all(j,ij) == iOper(k)) exit outer
      end do
    end do outer
    if (k > nIrrep-1) then
      ! Here if new unique subgroup UGV was found.
      do k=0,nIrrep-1
        ! Move a representative to the DCR set.
        if (iScrt(i,iOper(k)) /= 0) then
          iDCR_all(mDCR,ij) = iOper(k)
          mDCR = mDCR+1
          exit
        end if
      end do
    end if

  end do
  mDCR_all(ij) = mDCR
  Done(ij) = .true.
end if
Lambda = Lambda_all(ij)
iDCR(0:mDCR-1) = iDCR_all(0:mDCR-1,ij)

return

end subroutine DCR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2000, Roland Lindh                                *
************************************************************************
      SubRoutine PGet2_Aces(iCmp,iBas,jBas,kBas,lBas,
     &                      Shijij, iAO, iAOst, nijkl,PSO,nPSO,
     &                      DSO,DSO_Var,DSSO,DSSO_Var,nDSO,
     &                      Gamma,nGamma,iSO2cI,nSOs,
     &                      iSO2Sh,PMax)
************************************************************************
*                                                                      *
*  Object: to assemble the 2nd order density matrix of a SCF wave      *
*          function from the 1st order density matrix.                 *
*                                                                      *
*          The indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*          DSO: HF 1st order density                                   *
*          DSO_Var: 1st order density of correlated wf.                *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             January '92.                                             *
*                                                                      *
*     Modified to Aces 2 by RL, July 2000, Gainesville, FL, USA        *
************************************************************************
      use Basis_Info, only: nBas
      use SOAO_Info, only: iAOtSO, iOffSO
      use pso_stuff
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
************ columbus interface ****************************************
#include "columbus_gamma.fh"
      parameter (exfac=1d0)
      Real*8 PSO(nijkl,nPSO), DSO(nDSO),  DSO_Var(nDSO),
     &       Gamma(nGamma),  DSSO(nDSO), DSSO_Var(nDSO)
      Integer iSO2cI(2,nSOs), iSO2Sh(nSOs)
      Integer iCmp(4), iAO(4), iAOst(4)
      Logical Shijij
*     Local Array
      Integer iSym(0:7), jSym(0:7), kSym(0:7), lSym(0:7)
      Integer iTwoj(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
*                                                                      *
************************************************************************
*                                                                      *
*     Statement Function
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 39
      iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Write (6,*) 'nSOs=',nSOs
         Write (6,*) 'iSO2Sh=',iSO2Sh
         iComp = 1
         Call PrMtrx(' In PGet2:DSO ',[iD0Lbl],iComp,1,D0)
         Call PrMtrx(' In PGet2:DSO_Var ',[iD0Lbl],iComp,1,DVar)
      End If
#endif
      lOper = 1
      t14 = Quart * ExFac
      PMax=Zero
*
*-----Quadruple loop over elements of the basis functions angular
*     description.
*     Observe that we will walk through the memory in AOInt in a
*     sequential way.
*
      MemSO2 = 0
      Do 100 i1 = 1, iCmp(1)
         niSym = 0
         Do 101 j = 0, nIrrep-1
            If (iAOtSO(iAO(1)+i1,j)>0) Then
               iSym(niSym) = j
               niSym = niSym + 1
            End if
101      Continue
         Do 200 i2 = 1, iCmp(2)
            njSym = 0
            Do 201 j = 0, nIrrep-1
               If (iAOtSO(iAO(2)+i2,j)>0) Then
                  jSym(njSym) = j
                  njSym = njSym + 1
               End If
201         Continue
            Do 300 i3 = 1, iCmp(3)
               nkSym = 0
               Do 301 j = 0, nIrrep-1
                  If (iAOtSO(iAO(3)+i3,j)>0) Then
                     kSym(nkSym) = j
                     nkSym = nkSym + 1
                  End If
301            Continue
               Do 400 i4 = 1, iCmp(4)
                  nlSym = 0
                  Do 401 j = 0, nIrrep-1
                     If (iAOtSO(iAO(4)+i4,j)>0) Then
                        lSym(nlSym) = j
                        nlSym = nlSym + 1
                     End If
401               Continue
*
*------Loop over irreps which are spanned by the basis function.
*
       Do 110 is = 0, niSym-1
          j1 = iSym(is)
*
          Do 210 js = 0, njSym-1
             j2 = jSym(js)
             j12 = iEor(j1,j2)
*
             Do 310 ks = 0, nkSym-1
                j3 = kSym(ks)
                j123 = iEor(j12,j3)
                Do 410 ls = 0, nlSym-1
                   j4 = lSym(ls)
                   If (j123.ne.j4) Go To 410
*
                MemSO2 = MemSO2 + 1
*
*               Unfold the way the eight indices have been reordered.
                iSO_r = iAOtSO(iAO(1)+i1,j1)+iAOst(1)
                jSO_r = iAOtSO(iAO(2)+i2,j2)+iAOst(2)
                kSO_r = iAOtSO(iAO(3)+i3,j3)+iAOst(3)
                lSO_r = iAOtSO(iAO(4)+i4,j4)+iAOst(4)
                iSO_a = iSO_r+iOffSO(j1)
                jSO_a = jSO_r+iOffSO(j2)
                kSO_a = kSO_r+iOffSO(j3)
                lSO_a = lSO_r+iOffSO(j4)
*
                mijkl = 0
                Do 120 lAOl = 0, lBas-1
                   lSOl   = lSO_r + lAOl
                   lSOl_a = lSO_a + lAOl
                   iShell_D=iSO2Sh(lSOl_a)
                   Index_D =iSO2cI(1,lSOl_a)
                   nDim_D  =iSO2cI(2,lSOl_a)
                   Do 220 kAOk = 0, kBas-1
                      kSOk   = kSO_r + kAOk
                      kSOk_a = kSO_a + kAOk
                      iShell_C=iSO2Sh(kSOk_a)
                      Index_C =iSO2cI(1,kSOk_a)
                      nDim_C  =iSO2cI(2,kSOk_a)
                      nDim_CD=nDim_C*nDim_D
                      iShell_CD=iTri(iShell_C,iShell_D)
                      If (iShell_C.gt.iShell_D) Then
                         Index_CD=(Index_D-1)*nDim_C + Index_C
                      Else If (iShell_C.eq.iShell_D) Then
                         Index_CD=iTri(Index_C,Index_D)
                      Else
                         Index_CD=(Index_C-1)*nDim_D + Index_D
                      End If
                      Do 320 jAOj = 0, jBas-1
                         jSOj   = jSO_r + jAOj
                         jSOj_a = jSO_a + jAOj
                         iShell_B=iSO2Sh(jSOj_a)
                         Index_B =iSO2cI(1,jSOj_a)
                         nDim_B  =iSO2cI(2,jSOj_a)
                         Do 420 iAOi = 0, iBas-1
                            iSOi   = iSO_r + iAOi
                            iSOi_a = iSO_a + iAOi
                            iShell_A=iSO2Sh(iSOi_a)
                            Index_A =iSO2cI(1,iSOi_a)
                            nDim_A  =iSO2cI(2,iSOi_a)
                            nDim_AB=nDim_A*nDim_B
                            iShell_AB=iTri(iShell_A,iShell_B)
                            If (iShell_A.gt.iShell_B) Then
                               Index_AB=(Index_B-1)*nDim_A + Index_A
                            Else If (iShell_A.eq.iShell_B) Then
                               Index_AB=iTri(Index_A,Index_B)
                            Else
                               Index_AB=(Index_A-1)*nDim_B + Index_B
                            End If
                            If (iShell_AB.gt.iShell_CD) Then
                               Index_ABCD=(Index_CD-1)*nDim_AB+Index_AB
                            Else If (iShell_AB.eq.iShell_CD) Then
                               Index_ABCD=iTri(Index_AB,Index_CD)
                            Else
                               Index_ABCD=(Index_AB-1)*nDim_CD+Index_CD
                            End If
                            mijkl = mijkl + 1
*
************ columbus interface ****************************************
*do not reconstruct the two-particle density from the one-particle
*density or partial two-particle densities but simply read them from
*file

                            if (gamma_mrcisd) goto 95
*---------------------------Contribution D(ij)*D(kl) to P(ijkl)
                            If (j1.eq.j2) Then
*------------------------------j3.eq.j4 also
                               Indi=Max(iSOi,jSOj)
                               Indj=iSOi+jSOj-Indi
                               Indk=Max(kSOk,lSOl)
                               Indl=kSOk+lSOl-Indk
                               iPntij=iPntSO(j1,j2,lOper,nbas)
                               iPntkl=iPntSO(j3,j4,lOper,nbas)
                               Indij=iPntij+(Indi-1)*Indi/2+Indj
                               Indkl=iPntkl+(Indk-1)*Indk/2+Indl
                               temp=DSO(Indij)*DSO(Indkl)
     &                           +(DSO_Var(Indij)-DSO(Indij))*DSO(Indkl)
     &                           +DSO(Indij)*(DSO_Var(Indkl)-DSO(Indkl))
                            Else
                               temp = Zero
                            End If
*
*---------------------------Contribution -1/4*D(ik)*D(jl) to P(ijkl)
                            If (j1.eq.j3) Then
*------------------------------j2.eq.j4 also
                               Indi=Max(iSOi,kSOk)
                               Indk=iSOi+kSOk-Indi
                               Indj=Max(jSOj,lSOl)
                               Indl=jSOj+lSOl-Indj
                               iPntik=iPntSO(j1,j3,lOper,nbas)
                               iPntjl=iPntSO(j2,j4,lOper,nbas)
                               Indik=iPntik+(Indi-1)*Indi/2+Indk
                               Indjl=iPntjl+(Indj-1)*Indj/2+Indl
                               temp=temp-t14*(
     &                              DSO(Indik)*DSO(Indjl)
     &                        +(DSO_Var(Indik)-DSO(Indik))*DSO(Indjl)
     &                        +DSO(Indik)*(DSO_Var(Indjl)-DSO(Indjl))
     &                        +DSSO(Indik)*DSSO(Indjl)
     &                        +(DSSO_Var(Indik)-DSSO(Indik))*DSSO(Indjl)
     &                        +DSSO(Indik)*(DSSO_Var(Indjl)-DSSO(Indjl))
     &                                       )
                            End If
*
*---------------------------Contribution -1/4*D(il)*D(jk) to P(ijkl)
                            If (j1.eq.j4) Then
*------------------------------j2.eq.j3 also
                               Indi=Max(iSOi,lSOl)
                               Indl=iSOi+lSOl-Indi
                               Indj=Max(jSOj,kSOk)
                               Indk=jSOj+kSOk-Indj
                               iPntil=iPntSO(j1,j4,lOper,nbas)
                               iPntjk=iPntSO(j2,j3,lOper,nbas)
                               Indil=iPntil+(Indi-1)*Indi/2+Indl
                               Indjk=iPntjk+(Indj-1)*Indj/2+Indk
                               temp=temp-t14*(
     &                              DSO(Indil)*DSO(Indjk)
     &                        +(DSO_Var(Indil)-DSO(Indil))*DSO(Indjk)
     &                        +DSO(Indil)*(DSO_Var(Indjk)-DSO(Indjk))
     &                        +DSSO(Indil)*DSSO(Indjk)
     &                        +(DSSO_Var(Indil)-DSSO(Indil))*DSSO(Indjk)
     &                        +DSSO(Indil)*(DSSO_Var(Indjk)-DSSO(Indjk))
     &                                       )
                            End If
*
*                           Write (*,*) 'iSO:',
*    &                                  iSOi_a,jSOj_a,kSOk_a,lSOl_a
*                           Write (*,*) 'iShell:',iShell_A,iShell_B,
*    &                                            iShell_C,iShell_D
*                           Write (*,*) 'nDim:',nDim_A,nDim_B,
*    &                                          nDim_C,nDim_D
*                           Write (*,*)  temp , Gamma(Index_ABCD),
*    &                                   Index_ABCD
                            temp = temp + Four*Gamma(Index_ABCD)
 95                         If(gamma_mrcisd) Then
                               temp=Gamma(Index_ABCD)
                            End If
*
                            PMax=Max(PMax,Abs(Temp))
                            PSO(mijkl,MemSO2) =  temp
*
 420                     Continue
 320                  Continue
 220               Continue
 120            Continue
*
 410            Continue
 310         Continue
 210      Continue
 110   Continue
*
*
 400           Continue
 300        Continue
 200     Continue
 100  Continue
      If (nPSO.ne.MemSO2) Then
         Call WarningMessage(2,'PGet2_Aces: nPSO.ne.MemSO2')
         Write (6,*) nPSO, MemSO2
         Call Abend()
      End If
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.99) Then
         Call RecPrt(' In PGet2:PSO ',' ',PSO,nijkl,nPSO)
      End If
      Call GetMem(' Exit PGet2','CHECK','REAL',iDum,iDum)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(Shijij)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,1995,1999, Jeppe Olsen                            *
************************************************************************
      SUBROUTINE LCISPC(IPRNT)
*
* Number of dets and combinations
* per symmetry for each type of internal space
*
* Jeppe Olsen , Winter 1994/1995 ( woops !)
*               MXSOOB_AS added,MXSB removed May 1999
*
* GAS VERSION
*
      IMPLICIT REAL*8(A-H,O-Z)
*
* ===================
*.Input common blocks
* ===================
*
#include "mxpdim.fh"
#include "lucinp.fh"
#include "cstate.fh"
#include "strinp.fh"
#include "strbas.fh"
#include "csm.fh"
#include "stinf.fh"
#include "cgas.fh"
#include "gasstr.fh"
#include "WrkSpc.fh"
*
* ====================
*. Output common block : XISPSM is calculated
* ====================
*
#include "cicisp.fh"
*
*
*. Number of spaces
      NICISP = NCMBSPC
C?    write(6,*) ' LCISPC : NICISP ', NICISP
*. Type of alpha- and beta strings
      IATP = 1
      IBTP = 2
*
      NOCTPA =  NOCTYP(IATP)
      NOCTPB =  NOCTYP(IBTP)
*
      IOCTPA = IBSPGPFTP(IATP)
      IOCTPB = IBSPGPFTP(IBTP)
*.Local memory
      CALL GETMEM('KLBLTP','ALLO','INTE',KLBLTP,NSMST)
      KLCVST=1
c      IF(IDC.EQ.3 .OR. IDC .EQ. 4 )
c     &CALL MEMMAN(KLCVST,NSMST,'ADDL  ',2,'KLCVST')
      CALL GETMEM('KLIOIO','ALLO','INTE',KLIOIO,NOCTPA*NOCTPB)
*. Obtain array giving symmetry of sigma v reflection times string
*. symmetry.
c      IF(IDC.EQ.3.OR.IDC.EQ.4)
c     &CALL SIGVST(WORK(KLCVST),NSMST)

*. Array defining symmetry combinations of internal strings
*. Number of internal dets for each symmetry
        CALL SMOST(NSMST,NSMCI,MXPCSM,ISMOST)
*. MXSB is not calculated anymore, set to 0
      MXSB = 0
*
      MXSOOB = 0
      MXSOOB_AS = 0
      DO 100 ICI = 1, NICISP
*. allowed combination of types
      CALL IAIBCM(ICI,iWORK(KLIOIO))

      DO  50 ISYM = 1, NSMCI
          CALL ZBLTP(ISMOST(1,ISYM),NSMST,IDC,
     &               iWORK(KLBLTP),iWORK(KLCVST))
          CALL NGASDT(IGSOCCX(1,1,ICI),IGSOCCX(1,2,ICI),
     &                NGAS,ISYM,NSMST,NOCTPA,NOCTPB,
     &                iWORK(KNSTSO(IATP)),iWORK(KNSTSO(IBTP)),
     &                ISPGPFTP(1,IBSPGPFTP(IATP)),
     &                ISPGPFTP(1,IBSPGPFTP(IBTP)),
     &                MXPNGAS,NCOMB,XNCOMB,MXS,MXSOO,
     &                iWORK(KLBLTP),NTTSBL,LCOL,
     &                iWORK(KLIOIO),MXSOO_AS)
*

          XISPSM(ISYM,ICI) = XNCOMB
          MXSOOB = MAX(MXSOOB,MXSOO)
          MXSB = MAX(MXSB,MXS)
          MXSOOB_AS = MAX(MXSOO_AS,MXSOOB_AS)
          NBLKIC(ISYM,ICI) = NTTSBL
          LCOLIC(ISYM,ICI) = LCOL
   50 CONTINUE
      CALL GETMEM('KLBLTP','FREE','INTE',KLBLTP,NSMST)
      CALL GETMEM('KLIOIO','FREE','INTE',KLIOIO,NOCTPA*NOCTPB)
  100 CONTINUE
*
      NTEST = 0
      NTEST = MAX(NTEST,IPRNT)
      IF (NTEST .GE. 5) THEN
         WRITE(6,*)
         WRITE(6,*)
         WRITE(6,*)
     &      ' Number of internal combinations per symmetry '
         WRITE(6,*)
     &      ' =========================================== '
*
         DO 200 ICI = 1, NCMBSPC
            WRITE(6,*) ' CI space ', ICI
            WRITE(6,'(1H , 4E22.15)') (XISPSM(II,ICI),II=1,NSMCI)
C         CALL WRTMAT(XISPSM(1,ICI),1,NSMCI,1,NSMCI)
  200    CONTINUE
         WRITE(6,*)
         WRITE(6,*) ' Largest Symmetry-type-type block ',MXSOOB
         WRITE(6,*) ' Largest type-type block (all symmetries) ',
     &      MXSOOB_AS
         WRITE(6,*)
*
         WRITE(6,*)
     &      ' Number of TTS subblocks per CI expansion '
         WRITE(6,*)
     &      ' ======================================== '
*
        DO  ICI = 1,  NCMBSPC
            WRITE(6,*) ' Internal CI space ', ICI
            CALL IWRTMA(NBLKIC(1,ICI),1,NSMCI,1,NSMCI)
        END DO
      END IF
*. Largest number of BLOCKS in a CI expansion
      MXNTTS = 0
      DO ICI = 1,NCMBSPC
       DO ISM =1, NSMCI
        MXNTTS = MAX(MXNTTS,NBLKIC(ISM,ICI))
       END DO
      END DO
*
      IF(NTEST.GE.5) THEN
      WRITE(6,*) ' Largest number of blocks in CI expansion',
     &   MXNTTS
*
      WRITE(6,*)
     &' Number of columns per CI expansion '
      WRITE(6,*)
     & ' =================================== '
*
      DO  ICI = 1,  NCMBSPC
          WRITE(6,*) ' Internal CI space ', ICI
          CALL IWRTMA(LCOLIC(1,ICI),1,NSMCI,1,NSMCI)
      END DO
      END IF
*
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992,2002, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RctFld(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq)
!***********************************************************************
!                                                                      *
! Object: to apply a modification to the one-electron hamiltonian due  *
!         the reaction field. The code here is direct!                 *
!         This subroutine works only if a call to GetInf has been      *
!         prior to calling this routine.                               *
!                                                                      *
!         h1: one-electron hamiltonian to be modified. Observe that    *
!             the contribution due to the reaction field is added to   *
!             this array, i.e. it should be set prior to calling this  *
!             routine.                                                 *
!                                                                      *
!         TwoHam: dito two-electron hamiltonian.                       *
!                                                                      *
!         D:  the first order density matrix                           *
!                                                                      *
!         h1, TwoHam and D are all in the SO basis.                    *
!                                                                      *
!         Observe the energy expression for the electric field -       *
!         charge distribution interaction!                             *
!                                                                      *
!         -1/2 Sum(nl) E(tot,nl)M(tot,nl)                              *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             July '92                                                 *
!                                                                      *
!             Modified for nonequilibrum calculations January 2002 (RL)*
!***********************************************************************

use Index_Functions, only: nTri3_Elem, nTri3_Elem1
use External_Centers, only: XF
use Gateway_global, only: PrPrt
use Gateway_Info, only: PotNuc
use rctfld_module, only: EPS, EPSINF, lMax, MM, rds
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One, Zero, Half
use Definitions, only: wp, iwp
# ifdef _DEBUGPRINT_
use Index_Functions, only: nTri_Elem
use Basis_Info, only: nBas
use Symmetry_Info, only: nIrrep
use Definitions, only: u6
# endif

implicit none
integer(kind=iwp), intent(in) :: nh1
real(kind=wp), intent(inout) :: h1(nh1), TwoHam(nh1), RepNuc
real(kind=wp), intent(in) :: D(nh1)
logical(kind=iwp), intent(in) :: First, Dff, NonEq
integer(kind=iwp) :: iMax, iMltpl, ip, iSymX, iSymY, iSymZ, iTemp, ix, ixyz, iy, iz, lOper(1), nComp, nOpr, nOrdOp
real(kind=wp) :: E_0_NN, FactOp(1), Origin(3)
character(len=8) :: Label2
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: iIrrep, lOff, n
character(len=72) :: Label
#endif
real(kind=wp), allocatable :: QV(:,:), Vs(:,:)
integer(kind=iwp), external :: IrrFnc, MltLbl
real(kind=wp), external :: DDot_

#include "macros.fh"
unused_var(Dff)

nComp = nTri3_Elem1(lMax)
call mma_Allocate(Vs,nComp,2,Label='Vs')
call mma_Allocate(QV,nComp,2,Label='QV')

lOper(1) = 1
nOrdOp = lMax
! Set flag so only the diagonal blocks are computed
Prprt = .true.
Origin(:) = Zero

! Generate local multipoles in the primitive basis and accumulate to
! global multipoles.
!                                                                      *
!***********************************************************************
!                                                                      *
! Add nuclear-nuclear contribution to the potential energy

if (First) then

  if (NonEq) then
    call Get_dArray('RCTFLD',QV,nComp*2)
    call Get_dScalar('E_0_NN',E_0_NN)
  end if
  !1)
  ! Compute M(nuc,nl), nuclear multipole moments

  do iMax=0,lMax
    ip = 1+nTri3_Elem(iMax)
    call RFNuc(Origin,MM(ip,1),iMax)
  end do

  ! Add contribution from XFIELD multipoles

  ! Use Vs as temporary space, it will anyway be overwritten
  if (allocated(XF)) call XFMoment(lMax,MM,Vs,nComp,Origin)

# ifdef _DEBUGPRINT_
  call RecPrt('Nuclear Multipole Moments',' ',MM(:,1),1,nComp)
# endif

  ! Solve dielectical equation(nuclear contribution), i.e.
  ! M(nuc,nl) -> E(nuc,nl)

  Vs(:,1) = MM(:,1)
  call AppFld(Vs(:,1),rds,Eps,lMax,EpsInf,NonEq)

# ifdef _DEBUGPRINT_
  call RecPrt('Nuclear Electric Field',' ',Vs(:,1),1,nComp)
# endif

  ! Vnn = Vnn - 1/2 Sum(nl) E(nuc,nl)*M(nuc,nl)

  RepNuc = PotNuc-Half*DDot_(nComp,MM(:,1),1,Vs(:,1),1)

  ! Add contributions due to slow counter charges

  if (NonEq) RepNuc = RepNuc+E_0_NN
# ifdef _DEBUGPRINT_
  write(u6,*) ' RepNuc=',RepNuc
# endif
  !2)
  ! Compute contribution to the one-electron hamiltonian

  ! hpq = hpq + Sum(nl) E(nuc,nl)*<p|M(nl)|q>

# ifdef _DEBUGPRINT_
  write(u6,*) 'h1'
  lOff = 1
  do iIrrep=0,nIrrep-1
    n = nTri_Elem(nBas(iIrrep))
    if (n > 0) then
      write(Label,'(A,I1)') 'Diagonal Symmetry Block ',iIrrep+1
      call Triprt(Label,' ',h1(lOff),nBas(iIrrep))
      lOff = lOff+n
    end if
  end do
# endif

  ! Add potential due to slow counter charges

  if (NonEq) then
    QV(:,2) = QV(:,1)
    call AppFld_NonEQ_2(QV(:,2),rds,Eps,lMax,EpsInf)
    Vs(:,1) = Vs(:,1)+QV(:,2)
  end if

  call Drv2_RF(lOper(1),Origin,nOrdOp,Vs(:,1),lMax,h1,nh1)

# ifdef _DEBUGPRINT_
  write(u6,*) 'h1(mod)'
  lOff = 1
  do iIrrep=0,nIrrep-1
    n = nTri_Elem(nBas(iIrrep))
    if (n > 0) then
      write(Label,'(A,I1)') 'Diagonal Symmetry Block ',iIrrep+1
      call Triprt(Label,' ',h1(lOff),nBas(iIrrep))
      lOff = lOff+n
    end if
  end do
# endif

  ! Update h1 and RepNuc_save with respect to static contributions!

  Label2 = 'PotNuc00'
  call Put_Temp(Label2,[RepNuc],1)
  Label2 = 'h1_raw  '
  call Put_Temp(Label2,h1,nh1)

else
  Vs(:,1) = Zero
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the electronic contribution to the charge distribution.

!3)
! M(el,nl) =  - Sum(p,q) Dpq <p|M(nl)|q>

nOpr = 1
FactOp(1) = One
! Reset array for storage of multipole moment expansion
MM(:,2) = Zero
do iMltpl=1,lMax
  do ix=iMltpl,0,-1
  if (mod(ix,2) == 0) then
        iSymX = 1
    else
      ixyz = 1
      iSymX = 2**IrrFnc(ixyz)
      if (Origin(1) /= Zero) iSymX = ibset(iSymX,0)
    end if
    do iy=iMltpl-ix,0,-1
      if (mod(iy,2) == 0) then
        iSymY = 1
      else
        ixyz = 2
        iSymY = 2**IrrFnc(ixyz)
        if (Origin(2) /= Zero) iSymY = ibset(iSymY,0)
      end if
      iz = iMltpl-ix-iy
      if (mod(iz,2) == 0) then
        iSymZ = 1
      else
        ixyz = 4
        iSymZ = 2**IrrFnc(ixyz)
        if (Origin(3) /= Zero) iSymZ = ibset(iSymZ,0)
      end if

      iTemp = MltLbl(iSymX,MltLbl(iSymY,iSymZ))
      lOper(1) = ior(lOper(1),iTemp)
    end do
  end do
end do
#ifdef _DEBUGPRINT_
write(u6,*) '1st order density'
lOff = 1
do iIrrep=0,nIrrep-1
  n = nTri_Elem(nBas(iIrrep))
  write(Label,'(A,I1)') 'Diagonal Symmetry Block ',iIrrep+1
  call Triprt(Label,' ',D(lOff),nBas(iIrrep))
  lOff = lOff+n
end do
#endif

call Drv1_RF(FactOp,nOpr,D,nh1,Origin,lOper,MM(:,2),lMax)

#ifdef _DEBUGPRINT_
call RecPrt('Electronic Multipole Moments',' ',MM(:,2),1,nComp)
#endif

! Solve dielectical equation(electronic contribution), i.e.
! M(el,nl) -> E(el,nl)

Vs(:,2) = MM(:,2)
call AppFld(Vs(:,2),rds,Eps,lMax,EpsInf,NonEq)
#ifdef _DEBUGPRINT_
call RecPrt('Electronic Electric Field',' ',Vs(:,2),1,nComp)
#endif
!4)
! Compute contribution to the two-electron hamiltonian.

! T(D)pq = T(D)pq + Sum(nl) E(el,nl)*<p|M(nl)|q>

call Drv2_RF(lOper(1),Origin,nOrdOp,Vs(:,2),lMax,TwoHam,nh1)

#ifdef _DEBUGPRINT_
write(u6,*) 'h1(mod)'
lOff = 1
do iIrrep=0,nIrrep-1
  n = nTri_Elem(nBas(iIrrep))
  if (n > 0) then
    write(Label,'(A,I1)') 'Diagonal Symmetry Block ',iIrrep+1
    call Triprt(Label,' ',h1(lOff),nBas(iIrrep))
    lOff = lOff+n
  end if
end do
write(u6,*) 'TwoHam(mod)'
lOff = 1
do iIrrep=0,nIrrep-1
  n = nTri_Elem(nBas(iIrrep))
  write(Label,'(A,I1)') 'Diagonal Symmetry Block ',iIrrep+1
  call Triprt(Label,' ',TwoHam(lOff),nBas(iIrrep))
  lOff = lOff+n
end do
write(u6,*) ' RepNuc=',RepNuc
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Write information to be used for gradient calculations or for
! non-equilibrium calculations

if (.not. NonEq) then

  ! Save total solute multipole moments and total potential
  ! of the solution.

  QV(:,1) = MM(:,1)+MM(:,2)
  QV(:,2) = Vs(:,1)+Vs(:,2)
  call Put_dArray('RCTFLD',QV,nComp*2)

  ! Compute terms to be added to RepNuc for non-equilibrium
  ! calculation.

  QV(:,2) = QV(:,1)
  call AppFld_NonEQ_1(QV(:,2),rds,Eps,lMax,EpsInf)
  E_0_NN = -Half*DDot_(nComp,QV(:,1),1,QV(:,2),1)

  QV(:,2) = QV(:,1)
  call AppFld_NonEQ_2(QV(:,2),rds,Eps,lMax,EpsInf)
  E_0_NN = E_0_NN+DDot_(nComp,MM(:,1),1,QV(:,2),1)
  call Put_dScalar('E_0_NN',E_0_NN)

end if
!                                                                      *
!***********************************************************************
!                                                                      *

call mma_deallocate(Vs)
call mma_deallocate(QV)

end subroutine RctFld

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine zz_cvb(act1,zz1,fx,fxbest1,exp1,ip1)
      implicit real*8 (a-h,o-z)
#include "opt_cvb.fh"
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

#include "formats_cvb.fh"
      save zero,one,thous
      data zero/0.d0/,one/1.d0/,thous/1d3/

      act1=fx-fxbest1
      if(fxbest1.eq.-thous)act1=one
      if((abs(act1).lt.dfxtol.and.abs(exp1).lt.dfxtol)
     >  .or.act1.eq.one)then
        zz1=one
      elseif(exp1.eq.zero)then
        zz1=one
      elseif(abs(exp1).lt.dfxtol)then
        zz1=sign(one,act1)*sign(one,exp1)
      else
        zz1=act1/exp1
      endif
      if(ip1.ge.2)then
        if(act1.ne.one)write(6,formAD)
     >    ' Actual and expected changes :',act1,exp1
        write(6,formAD)' Ratio act/exp    : ',zz1
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine tpstr2orb_sym(TYPESTRING,NB,NF,NI,N1,N2,N3,NS,ND)
!SVC: read orbital partition info from a typestring array
!     corresponding to a _specific_symmetry_ (so these variables are
!     scalars!!
!     A typestring array consists of characters of 'fi123sd'

use Definitions, only: iwp, u6

implicit none
character, intent(in) :: typestring(*)
integer(kind=iwp), intent(in) :: NB
integer(kind=iwp), intent(out) :: NF, NI, N1, N2, N3, NS, ND
integer(kind=iwp) :: IB
character :: CTYPE

NF = 0
NI = 0
N1 = 0
N2 = 0
N3 = 0
NS = 0
ND = 0
! switch typeindex:
do IB=1,NB
  CTYPE = TYPESTRING(IB)
  call UPCASE(CTYPE)
  if (CTYPE == 'F') then
    NF = NF+1
  else if (CTYPE == 'I') then
    NI = NI+1
  else if (CTYPE == '1') then
    N1 = N1+1
  else if (CTYPE == '2') then
    N2 = N2+1
  else if (CTYPE == '3') then
    N3 = N3+1
  else if (CTYPE == 'S') then
    NS = NS+1
  else if (CTYPE == 'D') then
    ND = ND+1
  else
    write(u6,*) 'TPSTR2ORB_SYM: unknown type index character '//CTYPE
    call AbEnd()
  end if
end do

end subroutine tpstr2orb_sym

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine defvhlp62(r1,v,dimr1a,dimr1b,dimr1c,dimva,dimvb,dimvc,adda)
! this routine does
! V(a,b,c)abb = R1(a,b,c)
! for symb<symc
!
! r1     - r1 matrix (I)
! v      - v matrix (O)
! dimr1a - dimension of a in R1 (I)
! dimr1b - dimension of b in R1 (I)
! dimr1c - dimension of c in R1 (I)
! dimva  - dimension of a in V (I)
! dimvb  - dimension of b in V (I)
! dimvc  - dimension of c in V (I)
! adda   - additional constant to a (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimr1a, dimr1b, dimr1c, dimva, dimvb, dimvc, adda
real(kind=wp), intent(in) :: r1(dimr1a,dimr1c,dimr1b)
real(kind=wp), intent(out) :: v(dimva,dimvb,dimvc)
integer(kind=iwp) :: c

do c=1,dimvc
  v(:,:,c) = r1(adda+1:adda+dimva,c,:)
end do

return

end subroutine defvhlp62

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine Hess(FockC,FockX,rCon,Temp1,Temp2,Temp3,
     &                Temp4, idsym,jdisp,idisp)
*
*     Constructs the connection parts that is
*     dependend on the first derivative of
*     the connection
*
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"

#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"

      Real*8 Temp1(nDens2),Temp2(nDens2),Temp3(nDens2),
     &       FockC(nDens2),FockX(nDens2),rcon(nDens2),
     &       temp4(*)
      Character*8 Label
*
      idum=1
      call dcopy_(ndens2,[0.0d0],0,Temp3,1)
      If (iAnd(ntpert(idisp),2**3).eq.8) Then
       Do iS=1,nSym
        js=iEOr(is-1,idSym-1)+1
        nnj=nOrb(js)!nash(js)+nash(js)
        If (nOrb(is)*nOrb(js).ne.0)
     &  Call DGEMM_('N','N',
     &              nOrb(is),nnj,nnj,
     &              1.0d0,rCon(ipMat(is,js)),nOrb(is),
     &              Work(ipF0SQMO+ipCM(jS)-1),nOrb(js),
     &              0.0d0,Temp3(ipMat(is,js)),nOrb(is))

       End Do
       Call DScal_(ndens2,-0.5d0,Temp3,1)
       Call DaXpY_(nDens2,0.5d0,FockC,1,Temp3,1)
       Call DaXpY_(nDens2,1.0d0,FockX,1,Temp3,1)
      Else
        call dcopy_(nDens2,FockX,1,Temp3,1)
      End If
*
*              xa     ca      xa
*     Temp3=Y=F + 1/2F  -1/2 S  F
*
      Len=0
      Do iSym=1,nSym
       Len=Len+lDisp(iSym)*(lDisp(iSym)+1)/2
      End Do
*
      nIn=0
      mdisp=0
      Do iS=1,idsym-1
       mdisp=mdisp+ldisp(is)
       nIn=nIn+lDisp(is)*(lDisp(is)+1)/2
      End Do
*
      Do 310 kDisp=1,ldisp(idsym)
         mDisp=mdisp+1
         If (iAnd(ntpert(mdisp),2**3).eq.0) Goto 310
         iRC=-1
         iOpt=0
         Label='OvrGrd'
         iOp=2**idSym
         Call dRdMck(iRC,iOpt,Label,DspVec(mDisp),Temp1,iop)
         If (iRc.ne.0) Then
            Write (6,*) 'Hess: Error reading MCKINT'
            Write (6,'(A,A)') 'Label=',Label
            Call Abend()
         End If
         ip=1
         Do iS=1,nSym
          Do jS=1,iS
           If (nOrb(is)*nOrb(jS).ne.0) Then
           If (iEOr(iS-1,jS-1).eq.idsym-1) Then
              If (is.eq.js) Then
                Call Square(Temp1(ip),Temp2(ipMat(iS,jS)),
     &                     1,nBas(is),nBas(is))
                ip=ip+nBas(is)*(nBas(iS)+1)/2
              Else
               If (nBas(is)*nBas(js).ne.0)
     &         call dcopy_(nBas(iS)*nBas(jS),
     &                   Temp1(ip),1,Temp2(ipMat(iS,jS)),1)
               ip=ip+ nBas(is)*nBas(js)
              End If
              If (nBas(is)*nBas(js).ne.0) Then
              Call DGEMM_('T','N',
     &                    nOrb(iS),nBAs(jS),nBas(iS),
     &                    1.0d0,Work(ipCMO+ipCM(iS)-1),nBas(iS),
     &                    Temp2(ipMat(iS,jS)),nBas(iS),
     &                    0.0d0,Temp4,nOrb(is))
              call dcopy_(nBas(is)*nBas(js),[0.0d0],0,
     &                    temp2(ipMat(is,js)),1)
              Call DGEMM_('N','N',
     &                    nOrb(iS),nOrb(jS),nBas(jS),
     &                    1.0d0,Temp4,nOrb(iS),
     &                    Work(ipCMO+ipCM(jS)-1),nBas(jS),
     &                    0.0d0,Temp2(ipMat(iS,jS)),nOrb(iS))
*    &                    nOrb(iS),nBas(jS),nB(jS))
              if (is.ne.js) Then
              call dcopy_(nBas(is)*nBas(js),[0.0d0],0,
     &                   temp2(ipMat(js,is)),1)
              Call DGEMM_('T','T',
     &                    nOrb(js),nOrb(iS),nBas(js),
     &                    1.0d0,Work(ipCMO+ipCM(js)-1),nBas(js),
     &                    Temp4,nOrb(is),
     &                    0.0d0,Temp2(ipMat(js,is)),nOrb(js))
*    &                    nbas(js),nBas(js),nB(iS))
              End If
              End If
            End If
           End If
          End Do
         End Do
         Fact=1.0d0
         If (kDisp.eq.jDisp) Fact=2.0d0
         Indx=nIn+Max(kDisp,jDisp)*(Max(kDisp,jDisp)-1)/2+
     &             Min(kDisp,jDisp)-1+iphss
         Work(Indx)=Work(Indx)-
     &             fact*ddot_(nDens2,Temp2,1,Temp3,1)
 310  Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************
!  setvect
!
!> @brief
!>   Computes the vectors \f$ V_1 = \mathit{XYZ}(2)-\mathit{XYZ}(1) \f$ and
!>   \f$ V_2 = \mathit{XYZ}(3)-\mathit{XYZ}(1) \f$ using the geometry \p geom
!> @author Y. Carissan
!>
!> @details
!> Computes the vectors \f$ V_1 = \mathit{XYZ}(2)-\mathit{XYZ}(1) \f$ and
!> \f$ V_2 = \mathit{XYZ}(3)-\mathit{XYZ}(1) \f$ using the geometry \p geom.
!>
!> @param[in]  natoms Number of atoms
!> @param[in]  Geom   Geometry to be considered, xyz coordinates
!> @param[in]  XYZ    atom index array
!> @param[out] V1     output vector
!> @param[out] V2     output vector
!***********************************************************************

subroutine setvect(natoms,Geom,XYZ,V1,V2)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: natoms, XYZ(3)
real(kind=wp), intent(in) :: Geom(3,natoms)
real(kind=wp), intent(out) :: V1(3), V2(3)
real(kind=wp) :: O(3), A(3), B(3)

O(:) = Geom(:,XYZ(1))
A(:) = Geom(:,XYZ(2))
B(:) = Geom(:,XYZ(3))

V1(:) = A(:)-O(:)
V2(:) = B(:)-O(:)

return

end subroutine setvect

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Preciaa(iB,iS,jS,nd,rOut,nbai,nbaj,
     &                   fockii,fockai,fockti,
     &                   focki,focka,fock,sign,
     &                   A_J,A_K,Scr,nScr)
************************************************************************
*     Change Fock(i) ne Fock(j)
*                                          [2]
*     Calculates the diagonal submatrix of E    that couple
*
*     kappa               with   kappa                for a
*          kinactive,active           kinactive,active
*
*     single inactive index.
*     Used for preconditioner.
*
*     See Olsen,Yeager, Joergensen:
*      "Optimization and characterization of an MCSCF state"
*
*     Called by prec
*
*     ib,is       :       inactive index for the submatrix
*     js          :       symmetry of active,active
*     rOut        :       Submatrix
*
************************************************************************
      Implicit Real*8(a-h,o-z)
#include "Input.fh"
#include "Pointers.fh"
#include "standard_iounits.fh"
#include "WrkSpc.fh"
      Real*8 focki(nbaj,nbaj),fock(nbaj,nbaj),focka(nbaj,nbaj),
     &       rout(*), A_J(nScr), A_K(nScr), Scr(nScr)
*                                                                      *
************************************************************************
*                                                                      *
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      itri1(i,j)=nTri-itri(nd-Min(i,j)+1,nd-Min(i,j)+1)
     &          +Max(i,j)-Min(i,j)+1
*                                                                      *
************************************************************************
*                                                                      *
      nTri=itri(nd,nd)
*                                                                      *
************************************************************************
*                                                                      *
      Do kS=1,nSym
*
         If (nAsh(kS).ne.0)
     &       Call Coul(kS,kS,iS,iS,iB,iB,A_J,Scr)
*
         Do jC=1,nAsh(kS)
            jjC=JC+nA(kS)
            jCC=jC+nIsh(kS)
*
            Call Coul(kS,iS,kS,iS,jCC,iB,A_K,Scr)
*
            Do jD=1,nAsh(kS)
               jjD=JD+nA(kS)
               jDD=jD+nIsh(kS)
*
               ip1=(jDD-1)*nBas(kS)+jCC
               ip2=( iB-1)*nBas(kS)+jDD
               aabb=A_J(ip1)
               abab=A_K(ip2)
*
               Do jA=1,nAsh(jS)
                  jjA=jA+nA(jS)
                  Do jB=1,jA
                     jjB=jB+nA(jS)
                     i=itri1(jA,jB)
*
                     rDens1=sign*work(ipg2-1+
     &                          (itri(itri(jjC,jjD),itri(jjB,jjA))))
                     rDens2=sign*work(ipg2-1+
     &                          (itri(itri(jjB,jjD),itri(jjC,jjA))))
*
                     rout(i)=rout(i)+2.0d0*rDens1*aabb
     &                              +4.0d0*rDens2*abab
*
                  End Do
               End Do
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (nAsh(jS).ne.0) Then
         Call Exch(jS,iS,jS,iS,iB,iB,A_K,Scr)
         Call Coul(jS,jS,iS,iS,iB,iB,A_J,Scr)
      End If
*
      Do jA=1,nAsh(jS)
         jAA=jA+nA(jS)
         jjA=jA+nIsh(jS)
*
         Do jB=1,jA
            jBB=jB+nA(jS)
            jjB=jB+nIsh(jS)
            i=itri1(jA,jB)
*
            Do jC=1,nAsh(jS)
               jCC=jC+nA(jS)
               jjC=jC+nIsh(jS)
               iBC=(jjC-1)*nBas(jS)+jjB
               BCbb=A_J(iBC)
               BbCb=A_K(iBC)
               iAC=(jjC-1)*nBas(jS)+jjA
               ACbb=A_J(iAC)
               AbCb=A_K(iAC)
*
               rDens1=-sign*Work(ipg1-1+itri(jAA,jCC))
               rDens2=-sign*Work(ipg1-1+itri(jBB,jCC))
               If (jAA.eq.jCC) rDens1=rdens1+sign
               If (jBB.eq.jCC) rDens2=rdens2+sign
*
               rout(i)=rout(i)
     &                +2.0d0*rdens1*(3.0d0*BbCb-BCbb)
     &                +2.0d0*rdens2*(3.0d0*AbCb-ACbb)
*
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      rFock=sign*(Fockii+FockAi)
      i=0 ! dummy initialize
      Do jA=1,nAsh(jS)
         jAA=jA+nA(jS)
         jjA=jA+nIsh(js)
         Do jB=1,JA
            jBB=jB+nA(jS)
            jjB=jB+nIsh(js)
            i=itri1(jA,jB)
            rDens=Work(ipG1+itri(jbb,jAA)-1)
            rout(i)=rout(i)+Sign*(2.0d0*rdens*Fockii + ! (ib,ib)+
     &              2.0d0*(2.0d0*Focki(jjA,jjB)+
     &              2.0d0*FockA(jjA,jjB)-Fock(jjB,jjA)))
         End Do
         rout(i) = rout(i) - 4.0d0*rFock
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nbai)
         Call Unused_real(fockti)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ProjSym(nAtoms,nCent,Ind,nStab,jStab,A,
     &                   iDCRs,B,Smmtrc,nDim,Print,dB,
     &                   mB_Tot,mdB_Tot,BM,dBM,iBM,idBM,
     &                   nB_Tot,ndB_Tot,Proc_dB,nqB,nB,iq,
     &                   rMult)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "warnings.fh"
*
#include "real.fh"
#include "print.fh"
      Real*8 Tx(3,MxAtom), A(3,nCent), B(3,nCent), ATemp(3),
     &       dB(3,nCent,3,nCent), BM(nB_Tot), dBM(ndB_Tot)
      Integer   Ind(nCent), nStab(nAtoms), jStab(0:7,nAtoms),
     &          iDCRs(nCent), iBM(nB_Tot), idBM(2,ndB_Tot), nqB(nB)
      Logical Smmtrc(3,nAtoms), Print, Proc_dB
*
      If (Print) Then
         Call RecPrt('B',' ',B,3,nCent)
         Call RecPrt('dB',' ',dB,3*nCent,3*nCent)
         Write (6,*) iDCRs
      End If
*
*---- Set up the T-matrix
*
*---- Project away nonsymmetric displacements
*
      call dcopy_(3*nCent,[One],0,Tx,1)
      Do i = 1, nCent
         Call NonSym(nStab(Ind(i)),jStab(0,Ind(i)),A(1,i),Tx(1,i))
*
*------- Rotate vector back to the unique center
*
         Call OA(iDCRS(i),Tx(1:3,i),ATemp)
         Tx(:,i)=ATemp(:)
      End Do
*
*---- Create BqR
*
      nq = 0
      Do i = 1, nCent
         Do ixyz = 1, 3
            If (Smmtrc(ixyz,Ind(i))) Then
               iDim = 0
               Do j = 1, Ind(i)
                  jxyz_Max=3
                  If (j.eq.Ind(i)) jxyz_Max=ixyz
                  Do jxyz = 1, jxyz_Max
                     If (Smmtrc(jxyz,j)) iDim = iDim + 1
                  End Do
               End Do
               mB_Tot = mB_Tot + 1
               nq = nq + 1
               BM(mB_Tot) = Tx(ixyz,i)*B(ixyz,i)
               iBM(mB_Tot) = iDim
            End If
         End Do
      End Do
      nqB(iq) = nq
*
*---- Create dBqR
*
      If (.Not.Proc_dB) Go To 99
      Do i = 1, nCent
         Do ixyz = 1, 3
            If (Smmtrc(ixyz,Ind(i))) Then
               iDim = 0
               Do j = 1, Ind(i)
                  jxyz_Max=3
                  If (j.eq.Ind(i)) jxyz_Max=ixyz
                  Do jxyz = 1, jxyz_Max
                     If (Smmtrc(jxyz,j)) iDim = iDim + 1
                  End Do
               End Do
*
               Do j = 1, nCent
                  Do jxyz = 1, 3
                     If (Smmtrc(jxyz,Ind(j))) Then
*
                        jDim = 0
                        Do k = 1, Ind(j)
                           kxyz_Max=3
                           If (k.eq.Ind(j)) kxyz_Max=jxyz
                           Do kxyz = 1, kxyz_Max
                              If (Smmtrc(kxyz,k)) jDim = jDim + 1
                           End Do
                        End Do
*
                        mdB_Tot = mdB_Tot + 1
                        dBM(mdB_Tot) = rMult*
     &                      Tx(ixyz,i)*dB(ixyz,i,jxyz,j)*Tx(jxyz,j)
                        idBM(1,mdB_Tot) = iDim
                        idBM(2,mdB_Tot) = jDim
*
                     End If
                  End Do
            End Do

            End If
         End Do
      End Do
 99   Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nDim)
      End
      Subroutine ProjSym2(nAtoms,nCent,Ind,nStab,jStab,A,
     &                   iDCRs,B,BqR,Smmtrc,Print,dB,dBqR)
      Implicit Real*8 (a-h,o-z)
#include "Molcas.fh"
#include "warnings.fh"
*
#include "real.fh"
#include "print.fh"
      Real*8 Tx(3,MxAtom), A(3,nCent), B(3,nCent), BqR(3,nAtoms),
     &       dB(3,nCent,3,nCent), dBqR(3,nAtoms,3,nAtoms), ATemp(3)
      Integer   Ind(nCent), nStab(nAtoms), jStab(0:7,nAtoms),
     &          iDCRs(nCent)
      Logical Smmtrc(3,nAtoms), Print
*
      If (Print) Then
         Call RecPrt('B',' ',B,3,nCent)
         Call RecPrt('dB',' ',dB,3*nCent,3*nCent)
         Write (6,*) iDCRs
      End If
*
*---- Set up the T-matrix
*
*---- Project away nonsymmetric displacements
*
      call dcopy_(3*nCent,[One],0,Tx,1)
      Do i = 1, nCent
         Call NonSym(nStab(Ind(i)),jStab(0,Ind(i)),A(1,i),Tx(1,i))
*
*------- Rotate vector back to the unique center
*
         Call OA(iDCRs(i),Tx(1:3,i),ATemp)
         Tx(:,i)=ATemp(:)
      End Do
*
*---- The T-matrix is now computed. Now create BqR and dBqR.
*
*---- Create BqR
*
      Call FZero(BqR,3*nAtoms)
      Do i = 1, nCent
         Do ixyz = 1, 3
            BqR(ixyz,Ind(i)) = BqR(ixyz,Ind(i))
     &                       + Tx(ixyz,i)*B(ixyz,i)
         End Do
      End Do
      If (Print) Call RecPrt('BqR',' ',BqR,1,3*nAtoms)
*
*---- Create dBqR
*
      Call FZero(dBqR,(3*nAtoms)**2)
      Do i = 1, nCent
         Do ixyz = 1, 3
*
            Do j = 1, nCent
               Do jxyz = 1, 3
*
                  dBqR(ixyz,Ind(i),jxyz,Ind(j)) =
     &               dBqR(ixyz,Ind(i),jxyz,Ind(j))
     &             + Tx(ixyz,i)*dB(ixyz,i,jxyz,j)*Tx(jxyz,j)
*
               End Do
            End Do

         End Do
      End Do
      If (Print) Call RecPrt('dBqR',' ',dBqR,3*nAtoms,3*nAtoms)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical_array(Smmtrc)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

function RecNo(itype,iRoot)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Compute the Record number of a vector                            *
!                                                                      *
!     calling arguments:                                               *
!     itype   : integer                                                *
!               vector type: 1 = H_diag                                *
!                            2 = CI_vec                                *
!                            3 = Sig_vec                               *
!     iRoot   : integer                                                *
!               root number                                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use davctl_mod, only: n_Roots, nkeep
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp) :: RecNo
integer(kind=iwp), intent(in) :: itype, iRoot
integer(kind=iwp), external :: PageNo
#include "rasdim.fh"

select case (itype)
  case (1)
    !H_diag
    RecNo = 1
  case (2)
    !CI_vec
    RecNo = 1+PageNo(iRoot)
  case (3)
    !Sig_vec
    RecNo = 1+nkeep+PageNo(iRoot)
  case (4)
    !tmp_CI_vec
    RecNo = 1+2*nKeep+iRoot
  case (5)
    !tmp_Sig_vec
    RecNo = 1+2*nKeep+n_Roots+iRoot
  case default
    RecNo = 0
    write(u6,*) 'RecNo: itype does not match'
    write(u6,*) 'itype = ',itype
    call Abend()
end select

return

end function RecNo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TRANSDREF(TORB,NTORB,DREF,NDREF)
      use definitions, only: iwp, wp
      use constants, only: Zero, One
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: nSym, nIsh, nRas1, nRas2, nRas3, nSsh
      IMPLICIT None
      integer(kind=iwp), intent(in):: NTORB, NDREF
      real(kind=wp), intent(in) :: TORB(NTORB)
      real(kind=wp), intent(inout):: DREF(NDREF)

      real(kind=wp), ALLOCATABLE:: DSQ(:), TSQ(:), TMP(:)
      integer(kind=iwp) I, IDOFF, II, IJ, IOFF, ISYM, ITOFF, J, JJ, NA,
     &                  NI, NO, NR1, NR2, NR3, NS, NT, NAMX
* Purpose: given an orbital transformation array
* transform the DREF array (blocked triangular, active)

      NT=0
      NAMX=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NR1=NRAS1(ISYM)
        NR2=NRAS2(ISYM)
        NR3=NRAS3(ISYM)
        NS=NSSH(ISYM)
        NO=NI+NR1+NR2+NR3+NS
        NA=NR1+NR2+NR3
        NAMX=MAX(NAMX,NA)
        NT=NT+NI**2+NR1**2+NR2**2+NR3**2+NS**2
      END DO

      CALL mma_allocate(DSQ,NAMX**2,LABEL='DSQ')
      CALL mma_allocate(TSQ,NAMX**2,LABEL='TSQ')
      CALL mma_allocate(TMP,NAMX**2,LABEL='TMP')

      IDOFF=0
      ITOFF=0
      DO ISYM=1,NSYM

        NI=NISH(ISYM)
        NR1=NRAS1(ISYM)
        NR2=NRAS2(ISYM)
        NR3=NRAS3(ISYM)
        NA=NR1+NR2+NR3
        NS=NSSH(ISYM)
        NO=NI+NA+NS
        IF (NO.eq.0) Cycle
* Copy the matrices to square storage: first fill with zeroes.
        TSQ(1:NA**2)=Zero
        IOFF=0
        ITOFF=ITOFF+NI**2
        DO I=1,NR1
         II=IOFF+I
         DO J=1,NR1
          JJ=IOFF+J
          TSQ(II+NA*(JJ-1))=TORB(ITOFF+I+NR1*(J-1))
         END DO
        END DO
*---
        ITOFF=ITOFF+NR1**2
        IOFF=IOFF+NR1
        DO I=1,NR2
         II=IOFF+I
         DO J=1,NR2
          JJ=IOFF+J
          TSQ(II+NA*(JJ-1))=TORB(ITOFF+I+NR2*(J-1))
         END DO
        END DO
*---
        ITOFF=ITOFF+NR2**2
        IOFF=IOFF+NR2
        DO I=1,NR3
         II=IOFF+I
         DO J=1,NR3
          JJ=IOFF+J
          TSQ(II+NA*(JJ-1))=TORB(ITOFF+I+NR3*(J-1))
         END DO
        END DO
*--- Finally, the secondary orbitals (non-deleted, virtual).
        ITOFF=ITOFF+NR3**2
        ITOFF=ITOFF+NS**2
* Now transfer the DREF matrix block to square storage:
        IJ=0
        DO I=1,NA
         DO J=1,I
          IJ=IJ+1
          DSQ(J+NA*(I-1))=DREF(IDOFF+IJ)
          DSQ(I+NA*(J-1))=DREF(IDOFF+IJ)
         END DO
        END DO
* Transform, first do DSQ*TSQ -> TMP...
       CALL DGEMM_('N','N',NA,NA,NA,One,DSQ,NA,TSQ,NA,
     &              Zero,TMP,NA)
* ... and then do TSQ(transpose)*TMP -> DSQ...
       CALL DGEMM_('T','N',NA,NA,NA,One,TSQ,NA,TMP,NA,
     &              Zero,DSQ,NA)
* Transfer DSQ values back to D, in triangular storage.
       IJ=0
       DO I=1,NA
        DO J=1,I
         IJ=IJ+1
         DREF(IDOFF+IJ)=DSQ(I+NA*(J-1))
        END DO
       END DO
       IDOFF=IDOFF+(NA*(NA+1))/2
* and repeat, using next symmetry block.

      END DO ! ISYM

      CALL mma_deallocate(DSQ)
      CALL mma_deallocate(TSQ)
      CALL mma_deallocate(TMP)

      END SUBROUTINE TRANSDREF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine DPT2_TrfStore(Scal,NBSQT,DPT2q,DPT2n,Trf,WRK)

use caspt2_module, only: NBAS, NDEL, NORB, NSYM
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NBSQT
real(kind=wp), intent(in) :: Scal, DPT2q(NBSQT), Trf(NBSQT)
real(kind=wp), intent(inout) :: DPT2n(NBSQT)
real(kind=wp), intent(out) :: WRK(NBSQT)
integer(kind=iwp) :: iMO, iSym, nOrbI

iMO = 1
do iSym=1,nSym
  if (nOrb(iSym) > 0) then
    nOrbI = nBas(iSym)-nDel(iSym)
    !! Quasi-canonical -> natural transformation of DPT2
    call DGemm_('N','N',nOrbI,nOrbI,nOrbI,One,Trf(iMO),nOrbI,DPT2q(iMO),nOrbI,Zero,WRK,nOrbI)
    call DGemm_('N','T',nOrbI,nOrbI,nOrbI,Scal,WRK,nOrbI,Trf(iMO),nOrbI,One,DPT2n(iMO),nOrbI)
  end if
  iMO = iMO+nOrbI*nOrbI
end do

return

end subroutine DPT2_TrfStore

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Steven Vancoillie                                *
************************************************************************
      module faroald
!     written by Steven Vancoillie, summer 2014
!
!     The faroald module handles sigma updates as the result of acting
!     with the hamiltonian operator on a CI vector: s = H c, where s and c
!     are CI expansions in determinant basis.
!
!     The implementation follows the minimum operation count algorithm
!     published by Olsen & Co in J. Chem. Phys. 89, 2185 (1988).

      implicit none
      save

      ! wavefunction info
      integer :: my_nel, my_norb, mult
      integer :: nela, nelb, nhoa, nhob
      integer :: ndeta, ndetb, my_ndet

      ! excitation tables
      type ex1_struct
        integer :: p, q
        integer :: sgn
        integer :: rank
      end type

      type(ex1_struct), allocatable :: ex1_a(:,:), ex1_b(:,:)
      integer :: max_ex1a, max_ex1b
      integer :: max_ex2a, max_ex2b
      integer :: max_LRs

#ifdef _PROF_
      integer*8 :: nflop
#endif

      contains

      subroutine sigma_update(h,g,sgm,psi)
      ! The sigma update routine performs the following operation:
      ! |sgm> = H |psi>, with the hamiltonian defined by
      ! H = sum_tu h(t,u) E_tu + sum_tuvx g(t,u,v,x) E_tuvx.

      use second_quantization
      implicit none

      ! integrals
      real*8, intent(in)  :: h(my_norb,my_norb)
      real*8, intent(in)  :: g(my_norb,my_norb,my_norb,my_norb)
      real*8, allocatable :: k(:,:)

      ! wavefunctions
      real*8, intent(in)    :: psi(:,:)
      real*8, intent(inout) :: sgm(:,:)

      real*8, allocatable :: psiT(:,:)
      real*8, allocatable :: sgmT(:,:)

      ! orbital indices
      integer :: t, u, v

      ! determinant index ranges
      integer :: iasta, iaend, ibsta, ibend

      integer :: ierr

      ! profiling
#ifdef _PROF_
      real*8 :: t1_cpu, t2_cpu, tot_cpu
      real*8 :: t1_wall, t2_wall, tot_wall
      real*8 :: walltime, flops
#endif

      ! Distributes a dimension over processes
      ! and returns the range of this process.
      call par_range(ndeta,iasta,iaend)
      call par_range(ndetb,ibsta,ibend)

#ifdef _PROF_
      ! initialize flop count
      nflop = 0

      call timing (t1_cpu,tot_cpu,t1_wall,tot_wall)
#endif

      ! Set the sigma vector to 0
      sgm = 0.0d0

      ! First, construct a new effective one-electron integral matrix:
      ! k_tu = h_tu - 1/2 sum_v g_tvvu, to be used with sigma1/sigma2.
      allocate (k(my_norb, my_norb))
      do u=1,my_norb
        do t=1,my_norb
          ! g_tvvu = g_vtvu
          k(t,u) = 0.0d0
          do v=1,my_norb
            k(t,u) = k(t,u) + g(v,t,v,u)
          end do
          k(t,u) = h(t,u) - 0.5d0 * k(t,u)
        end do
      end do

!     Second, for sigma2 and sigma3, we are better off with the transpose
!     of sgm and/or psi, so allocate and assign them here.
      allocate(psiT(ndetb,ndeta), stat=ierr)
      if (ierr /= 0) stop 'sigma_update: could not allocate psiT'
      call dtrans(ndeta,ndetb,psi,ndeta,psiT,ndetb)

!     Now the actual contributions to sigma are computed. For a singlet
!     (mult = 1), sigma2 is not computed and sigma3 will only do half the
!     work.  But at the end, the transpose of sigma has to be added to
!     sigma. This should be more efficient than computing everything, but
!     note that the transpose operation is also included in the timings
!     used to compute the flop efficiency.

      call sigma1(k,g,sgm,psi,ibsta,ibend)

      if (mult.ne.1) then
        ! we need efficient access to sgm by using the transpose
        allocate(sgmT(ndetb,ndeta), stat=ierr)
        if (ierr /= 0) stop 'sigma_update: could not allocate sgmT'
        call dtrans(ndeta,ndetb,sgm,ndeta,sgmT,ndetb)

        call sigma2(k,g,sgmT,psiT,iasta,iaend)

        call dtrans(ndetb,ndeta,sgmT,ndetb,sgm,ndeta)
        deallocate(sgmT)
      end if

      call sigma3(g,sgm,psiT,ibsta,ibend)

      ! sum over all processes
      call gadsum(sgm,ndeta*ndetb)

      if (mult.eq.1) then
        ! for Ms = 0 (only used for singlet), sgm := sgm + sgm^T
        call transadd(ndeta,sgm,ndeta)
      end if

      deallocate(psiT)
      deallocate(k)

#ifdef _PROF_
      call timing (t2_cpu,tot_cpu,t2_wall,tot_wall)

      walltime = t2_wall - t1_wall

      if (walltime /= 0.0d0) then
        flops = nflop / walltime
        write(6,'(1x,a,2(f10.3,a))') &
          & 'sigma update: ', &
          & walltime , ' s, ', &
          & flops * 1.0d-9 , ' Gflops.'
      end if
#endif

      end subroutine

      subroutine sigma1(k,g,sgm,psi,ibsta,ibend)
!     sigma1 = sum_jb sum_tu <jb|E_tu|ib> (h_kl - 1/2 sum_v <tv|vx>) C(ia,jb)
!        + 1/2 sum_jb sum_tuvx <jb|E_tu E_vx|ib> g_tuvx C(ia,jb)

      implicit none

      ! integrals
      real*8, intent(in)  :: k(my_norb,my_norb)
      real*8, intent(in)  :: g(my_norb,my_norb,my_norb,my_norb)

      ! wavefunctions
      real*8, intent(in)    :: psi(:,:)
      real*8, intent(inout) :: sgm(:,:)

      ! local variables
      integer :: ib, jb, kb
      integer :: ibsta, ibend
      integer :: t, u, v, x, tu, vx
      integer :: sgn_tu, sgn_vx

      integer :: ierr

      real*8, allocatable :: f(:)

      allocate(f(ndetb), stat=ierr)
      if (ierr /= 0) stop 'could not allocate f'

      do ib=ibsta,ibend
        ! f array construction
        f=0.0d0
        do tu=1,max_ex1b
          t      = ex1_b(tu,ib) % p
          u      = ex1_b(tu,ib) % q
          sgn_tu = ex1_b(tu,ib) % sgn
          kb     = ex1_b(tu,ib) % rank
          f(kb) = f(kb) + sgn_tu * k(t,u)
          do vx=1,max_ex1b
            v      = ex1_b(vx,kb) % p
            x      = ex1_b(vx,kb) % q
            sgn_vx = ex1_b(vx,kb) % sgn
            jb     = ex1_b(vx,kb) % rank
            f(jb) = f(jb) + 0.5d0 * sgn_tu * sgn_vx * g(v,x,t,u)
          end do
        end do
        ! sigma addition
        kb = 0
        do jb=1,ndetb
          if (f(jb) /= 0.0d0) then
            kb = kb + 1
#ifdef _PROF_
            nflop = nflop + 2 * ndeta
#endif
            call daxpy_(ndeta,f(jb),psi(:,jb),1,sgm(:,ib),1)
          end if
        end do
        if (kb > max_ex2b) stop 'exceeded max double excitations'
      end do

      deallocate(f)

      end subroutine

      subroutine sigma2(k,g,sgm,psi,iasta,iaend)
!     sigma2 = sum_ja sum_tu <ja|E_tu|ia> (h_kl - 1/2 sum_v <tv|vx>) C(ja,ib)
!        + 1/2 sum_ja sum_tuvx <ja|E_tu E_vx|ia> g_tuvx C(ja,ib)

      implicit none

      ! integrals
      real*8, intent(in)  :: k(my_norb,my_norb)
      real*8, intent(in)  :: g(my_norb,my_norb,my_norb,my_norb)

      ! wavefunctions
      real*8, intent(in)    :: psi(:,:)
      real*8, intent(inout) :: sgm(:,:)

      ! local variables
      integer :: ia, ja, ka
      integer :: iasta, iaend
      integer :: t, u, v, x, tu, vx
      integer :: sgn_tu, sgn_vx

      integer :: ierr

      real*8, allocatable :: f(:)

      allocate(f(ndeta), stat=ierr)
      if (ierr /= 0) stop 'could not allocate f'

      do ia=iasta,iaend
        ! f array construction
        f=0.0d0
        do tu=1,max_ex1a
          t      = ex1_a(tu,ia) % p
          u      = ex1_a(tu,ia) % q
          sgn_tu = ex1_a(tu,ia) % sgn
          ka     = ex1_a(tu,ia) % rank
          f(ka) = f(ka) + sgn_tu * k(t,u)
          do vx=1,max_ex1a
            v      = ex1_a(vx,ka) % p
            x      = ex1_a(vx,ka) % q
            sgn_vx = ex1_a(vx,ka) % sgn
            ja     = ex1_a(vx,ka) % rank
            f(ja) = f(ja) + 0.5d0 * sgn_tu * sgn_vx * g(v,x,t,u)
          end do
        end do
        ! sigma addition
        ka = 0
        do ja=1,ndeta
          if (f(ja) /= 0.0d0) then
            ka = ka + 1
#ifdef _PROF_
            nflop = nflop + 2 * ndeta
#endif
            call daxpy_(ndetb,f(ja),psi(:,ja),1,sgm(:,ia),1)
          end if
        end do
        if (ka > max_ex2a) stop 'exceeded max double excitations'
      end do

      deallocate(f)

      end subroutine

      subroutine sigma3(g,sgm,psi,ibsta,ibend)
!     sigma3(ia,ib) = sum_ja,jb sum_tu,vx <jb|E_tu|ib> <ja|E_vx|ia> g_tuvx C(ja,jb)

      implicit none

      ! integrals
      real*8, intent(in)  :: g(my_norb,my_norb,my_norb,my_norb)

      ! wavefunctions
      real*8, intent(in)    :: psi(:,:)
      real*8, intent(inout) :: sgm(:,:)

      ! determinant indices
      integer, allocatable :: ia(:), ja(:)
      integer :: i, n_couples
      integer :: ib, jb, kb
      integer :: ibsta, ibend

      ! orbital indices
      integer :: t, u, v, x, tu
      integer, allocatable :: sgn_vx(:)
      integer :: sgn_tu

      real*8, allocatable :: f(:)
      real*8, allocatable :: Ctmp(:,:), Vtmp(:)

      integer :: ierr

      allocate(ja(max_LRs), ia(max_LRs), sgn_vx(max_LRs), stat=ierr)
      if (ierr /= 0) stop 'could not allocate L/R/sgn'

      allocate(Ctmp(max_LRs,ndetb), Vtmp(max_LRs), stat=ierr)
      if (ierr /= 0) stop 'could not allocate Ctmp/Vtmp'

      allocate(f(ndetb), stat=ierr)
      if (ierr /= 0) stop 'could not allocate f'

      do v=1,my_norb
        do x=1,my_norb
          ! set up L(I), R(I), sgn(I) defined by L(ia) = E_tu R(ia)
          call LRs_init(v, x, nela, my_norb, ja, ia, sgn_vx, n_couples)
          do i=1,n_couples
            Ctmp(i,:) = psi(:,ja(i)) * sgn_vx(i)
          end do
          do ib=ibsta,ibend
            f = 0.0d0
            do tu=1,max_ex1b
              t      = ex1_b(tu,ib) % p
              u      = ex1_b(tu,ib) % q
              sgn_tu = ex1_b(tu,ib) % sgn
              jb     = ex1_b(tu,ib) % rank
              ! for singlets, only tu >= vx are used
              if (mult.eq.1) then
                if (t < v) cycle
                if (t == v .and. u < x) cycle
                if (t == v .and. u == x) then
                  f(jb) = f(jb) + sgn_tu * 0.5d0 * g(t,u,v,x)
                  cycle
                end if
              end if
              f(jb) = f(jb) + sgn_tu * g(t,u,v,x)
            end do
            ! V(ia) = sum_jb f(jb) C'(ia,jb) for all ia
            Vtmp=0.0d0
            kb = 0
            ! loop over non-identical excitations
            do tu=1,max_ex1b
              jb = ex1_b(tu,ib) % rank
              if (jb /= ib .and. f(jb) /= 0.0d0) then
                kb = kb + 1
#ifdef _PROF_
                nflop = nflop + 2 * n_couples
#endif
                call daxpy_(n_couples,f(jb),Ctmp(1,jb),1,Vtmp,1)
              end if
            end do
            ! contribution from the identical excitations
            if (f(ib) /= 0.0d0) then
#ifdef _PROF_
              nflop = nflop + 2 * n_couples
#endif
              call daxpy_(n_couples,f(ib),Ctmp(1,ib),1,Vtmp,1)
            end if
            if (kb > max_ex1b) stop 'exceeded max single excitations'
            ! s3(R_ia,ib) = s3(R_ia,ib) + V(ia)
            do i=1,n_couples
              sgm(ia(i),ib) = sgm(ia(i),ib) + Vtmp(i)
            end do
          end do
        end do
      end do

      end subroutine

      subroutine ex1_init(k, n, ex1_table)
      use second_quantization
      implicit none
      integer, intent(in) :: k, n
      type(ex1_struct), intent(out) :: ex1_table(:,:)

      integer :: my_ndet, idet
      integer :: det, tmp
      integer :: p, q, pq

      integer :: counter

      !write(6,'(1x,a)') 'excitation table'
      !write(6,'(1x,a)') 'p   q   I   J'
      my_ndet = binom_coef(k,n)
      det = lex_init(k,n)
      counter = 0
      do idet=1,my_ndet
        pq = 0
        do p=1,my_norb
          do q=1,my_norb
            tmp = ex1(p,q,det)
            if (tmp.ne.-1) then
              pq = pq + 1
              ex1_table(pq,idet) % p    = p
              ex1_table(pq,idet) % q    = q
              ex1_table(pq,idet) % sgn  = fase(tmp)
              ex1_table(pq,idet) % rank = lexrank(tmp)
              counter = counter + 1
              !write(6,'(1x,4i4)') p, q, idet, fase(tmp)*lexrank(tmp)
            end if
          end do
        end do
        det=lex_next(det)
      end do
      end subroutine

      subroutine LRs_init(p, q, my_nel, my_norb, L, R, sgn, counter)
      ! for a pair of orbitals p and q, and determinants
      ! generated by my_nel electrons in my_norb spin orbitals,
      ! re-enumerate all non-vanishing couples connected
      ! through: jdet = E_pq idet. The number of couples
      ! is given by n_det, L(i) = jdet and R(i) = idet,
      ! where i is a counter from 1 to n_det. The sign of
      ! jdet is stored in the sgn array.
      use second_quantization
      implicit none
      integer, intent(in)  :: p, q, my_nel, my_norb
      integer, intent(out) :: L(:), R(:), sgn(:), counter

      integer :: my_ndet, idet
      integer :: det, tmp

      my_ndet = binom_coef(my_nel,my_norb)
      det = lex_init(my_nel,my_norb)
      counter = 0
      do idet=1,my_ndet
        tmp = ex1(p,q,det)
        if (tmp.ne.-1) then
          counter = counter + 1
          R(counter)   = idet
          sgn(counter) = fase(tmp)
          L(counter)   = lexrank(tmp)
        end if
        det=lex_next(det)
      end do
      end subroutine

      end module

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
! THIS SUBROUTINE EVALUATES THE INTEGRAL INT(XDX) USING SIMPSON'S
! RULE. THE NUMBER OF STEPS IS NDIM (ASSUMED ODD) WITH THE GRID
! SIZE H. THE RESULTING VALUE OF THE INTEGRAL IS RETURNED IN F.
!
! ********** RELEASE 81 04 09 **********

subroutine SIMPSN(X,H,NDIM,F)

use Constants, only: Two, Six
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: X(*), H
integer(kind=iwp), intent(in) :: NDIM
real(kind=wp), intent(out) :: F
integer(kind=iwp) :: I, NDIM1

F = X(1)+X(NDIM)
NDIM1 = NDIM-1
do I=2,NDIM1
  F = F+Two*X(I)
  if (mod(I,2) == 0) F = F+Two*X(I)
end do
F = F*H/Six

return

end subroutine SIMPSN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine loopcntr_init_cvb(inputmode1,initfalse)
      implicit real*8(a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "inpmod_cvb.fh"
#include "loopcntr_cvb.fh"
#include "seth_cvb.fh"
#include "initopt_cvb.fh"
      logical initfalse
      logical guess_available,initial_opts,svbfirst,constrained_opt

      call istkinit_cvb(istackrep,nstackrep)
      inputmode=inputmode1
      ioptim=0
      ioptstep=0
      if(inputmode.eq.2)then
        loopstepmx=loopstep
        noptstep=joptstep

c  Check for "special case" => initial optimizations
        initial_opts=.true.
        guess_available=.false.
        if(nmcscf.ge.2)guess_available=.true.
        if(up2date_cvb('WRITEGS'))guess_available=.true.
        if(.not.up2date_cvb('STRTGS'))guess_available=.true.
        if(.not.up2date_cvb('INPGS'))guess_available=.true.

        if(guess_available)initial_opts=.false.
        if(noptstep.gt.0)initial_opts=.false.
c  Are we doing a constrained optimization ? :
        constrained_opt=.false.
        if(norbrel.gt.0)constrained_opt=.true.
        if(nort.gt.0)constrained_opt=.true.
        if(ndrot.gt.0)constrained_opt=.true.
        if(nfxorb.gt.0)constrained_opt=.true.
        if(ploc)constrained_opt=.true.
        if(nfxvb.gt.0.or.lfxvb.eq.1)constrained_opt=.true.
        if(nzrvb.gt.0.or.lzrvb.eq.1)constrained_opt=.true.
c  If INIT/NOINIT keyword was encountered, override :
        if(initial.eq.0)initial_opts=.false.
        if(initial.eq.1)initial_opts=.true.
c  Finally may be overridden by initfalse :
        if(initfalse)initial_opts=.false.
        if(initial_opts)then
c  IOPTCODE    +1  = REPORT
c              +2  = OPTIM
c              +4  = Svb
c              +8  = freeze structure coefficients
c              +16 = strong-orthogonality constraints

c  Should we do Svb optimization first ? :
          svbfirst=ifcasci_cvb()

          if(.not.constrained_opt)then
c  Two first optimizations are SOPP & PP :
            noptim=0
            if(svbfirst)then
              if(norb.gt.2)then
                noptim=noptim+1
                ioptcode(noptim)=22
              endif
              if(strucopt)then
                noptim=noptim+1
                ioptcode(noptim)=14
                if(noptim.eq.2)ioptcode(1)=ioptcode(1)+8
              endif
            else
              if(norb.gt.2)then
                noptim=noptim+1
                ioptcode(noptim)=18
              endif
              if(strucopt)then
                noptim=noptim+1
                ioptcode(noptim)=10
                if(noptim.eq.2)ioptcode(1)=ioptcode(1)+8
              endif
            endif
          endif
c  Then a third Svb optimization if we are doing Evb :
          if(icrit.ne.1.and.svbfirst)then
            noptim=noptim+1
            ioptcode(noptim)=6
          endif
c  Finally actual optimization :
          noptim=noptim+1
          ioptcode(noptim)=2
c  Add "report" :
          noptim=noptim+1
          ioptcode(noptim)=1

          iopt2step(0)=0
          do 100 i=1,noptim
          iopt2step(i)=1
100       continue
          iopt2step(noptim+1)=noptstep+1
        else
          noptim=noptstep
          call izero(ioptcode,noptim)
          do 200 i=0,noptim
          iopt2step(i)=i
200       continue
c  Append OPTIM keyword if none present
          noptkw=0
          do 300 lll=1,loopstepmx
          if(icode(lll).eq.1)noptkw=noptkw+1
300       continue
          if(noptkw.eq.0)then
            noptim=noptim+1
            ioptcode(noptim)=2
            iopt2step(noptim)=iopt2step(noptim-1)
          endif
c  Append REPORT keyword if none present
          nrepkw=0
          do 400 lll=1,loopstepmx
          if(icode(lll).eq.3)nrepkw=nrepkw+1
400       continue
          if(nrepkw.eq.0)then
            noptim=noptim+1
            ioptcode(noptim)=1
            iopt2step(noptim)=iopt2step(noptim-1)
          endif
          iopt2step(noptim+1)=noptstep+1
        endif
      endif
      return
      end
      logical function loopcntr_iterate_cvb()
      implicit real*8(a-h,o-z)
#include "seth_cvb.fh"
#include "loopcntr_cvb.fh"
#include "initopt_cvb.fh"
      logical unmatched
      external istkprobe_cvb
      logical istkprobe_cvb

      if(iopt2step(ioptim+1).eq.iopt2step(ioptim))then
        ioptim=ioptim+1
        goto 1100
      endif

      joptstep=0
      do 1 ll=1,loopstepmx
      if(joptstep.eq.ioptstep)goto 11
      if(icode(ll).eq.1.or.icode(ll).eq.3)joptstep=joptstep+1
1     continue
11    ll1=ll
10    continue
c  First determine if end of multi-step optimization may have been reached:
      if(istkprobe_cvb(istackrep))then
        call istkpop_cvb(istackrep,nc_zeroed)
        call istkpop_cvb(istackrep,nconvinone)
        call istkpop_cvb(istackrep,italter)
        call istkpop_cvb(istackrep,mxalter)
        call istkpop_cvb(istackrep,kk2)
        call istkpop_cvb(istackrep,ioptstep2)
        call istkpop_cvb(istackrep,ioptstep1)
c  Number of steps is IOPTSTEP2-IOPTSTEP1+1
        if(nconvinone.eq.ioptstep2-ioptstep1+1)then
          ioptstep=ioptstep2
          joptstep=ioptstep2
          ll1=kk2+1
          goto 10
        endif
c  Restore loop information :
        call istkpush_cvb(istackrep,ioptstep1)
        call istkpush_cvb(istackrep,ioptstep2)
        call istkpush_cvb(istackrep,kk2)
        call istkpush_cvb(istackrep,mxalter)
        call istkpush_cvb(istackrep,italter)
        call istkpush_cvb(istackrep,nconvinone)
        call istkpush_cvb(istackrep,nc_zeroed)
      endif
      do 100 ll=ll1,loopstepmx
      if(joptstep.eq.ioptstep)then
c  Looking for next card after previous OPTIM/REPORT:
        if(icode(ll).eq.2.or.icode(ll).eq.4)then
          if(ll.eq.1)then
            unmatched=.true.
          else
            unmatched=(icode(ll)-icode(ll-1).ne.1)
          endif
          if(unmatched)then
            write(6,'(a)')' Unmatched END or closing bracket!'
            call abend_cvb()
          endif
        endif
        if(icode(ll).eq.1.or.icode(ll).eq.3)then
c  OPTIM / REPORT :
          ioptstep=ioptstep+1
          goto 1000
        elseif(icode(ll).eq.5)then
c  ALTERN :
c  Scan rest of file for number of steps in this loop:
          iend=0
          ioptstep2=joptstep
          do 200 kk=ll+1,loopstepmx
          if(icode(kk).eq.1.or.icode(kk).eq.3)then
            ioptstep2=ioptstep2+1
          elseif(icode(kk).eq.5)then
            iend=iend-1
          elseif(icode(kk).eq.6)then
            iend=iend+1
          endif
          if(iend.eq.1)goto 300
200       continue
          write(6,*)' Run-away ENDALTERN or closing bracket!'
          call abend_cvb()
300       continue

          italter=1
          mxalter=ipos(ll)
          nconvinone=-1
          nc_zeroed=0
          call istkpush_cvb(istackrep,ioptstep+1)
          call istkpush_cvb(istackrep,ioptstep2)
          call istkpush_cvb(istackrep,kk)
          call istkpush_cvb(istackrep,mxalter)
          call istkpush_cvb(istackrep,italter)
          call istkpush_cvb(istackrep,nconvinone)
          call istkpush_cvb(istackrep,nc_zeroed)
        elseif(icode(ll).eq.6)then
c  ENDALTERN :
          call istkpop_cvb(istackrep,nc_zeroed)
          call istkpop_cvb(istackrep,nconvinone)
          call istkpop_cvb(istackrep,italter)
          call istkpop_cvb(istackrep,mxalter)
          call istkpop_cvb(istackrep,kk2)
          call istkpop_cvb(istackrep,ioptstep2)
          call istkpop_cvb(istackrep,ioptstep1)
          italter=italter+1
          nstep=ioptstep-ioptstep1+1
          if(nstep.gt.0.and.italter.le.mxalter)then
c  Next loop iteration :
            call istkpush_cvb(istackrep,ioptstep1)
            call istkpush_cvb(istackrep,ioptstep2)
            call istkpush_cvb(istackrep,kk2)
            call istkpush_cvb(istackrep,mxalter)
            call istkpush_cvb(istackrep,italter)
            call istkpush_cvb(istackrep,nconvinone)
            call istkpush_cvb(istackrep,nc_zeroed)
            ioptstep=ioptstep1
            goto 1000
          else
            if(nstep.gt.0)then
              write(6,'(/,a,i4,a)')' Exiting',nstep,
     >          '-step optimization.'
              write(6,'(a,i4)')
     >          ' Maximum number of loop iterations reached :',mxalter
            endif
          endif
        endif
      endif
      if(icode(ll).eq.1.or.icode(ll).eq.3)joptstep=joptstep+1
100   continue
      ioptstep=noptstep+1

1000  continue
      do ioptim=1,noptim
      if(iopt2step(ioptim).eq.ioptstep)goto 1100
      enddo
1100  loopcntr_iterate_cvb=(ioptim.le.noptim)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function isUnit(A,N,ldA,thrs)

! Find out if a block of A is close enough to a unit matrix

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
logical(kind=iwp) :: isunit
integer(kind=iwp), intent(in) :: N, ldA
real(kind=wp), intent(in) :: A(ldA,N), thrs
integer(kind=iwp) :: i

do i=1,N
  if (abs(A(i,i)-One) > thrs) exit
  if (any(abs(A(1:i-1,i)) > thrs)) exit
  if (any(abs(A(i+1:N,i)) > thrs)) exit
end do
isunit = (i > N)

return

end function isUnit

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function GAM(M)

use Constants, only: One, Half, Pi
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: GAM
integer(kind=iwp), intent(in) :: M
integer(kind=iwp) :: I, MA
real(kind=wp) :: G

if (mod(M,2) == 1) then
  MA = (M+1)/2
  G = One
  if (MA /= 1) then
    do I=2,MA
      G = G*real(I-1,kind=wp)
    end do
  end if
else
  MA = M
  G = sqrt(Pi)
  if (MA /= 0) then
    do I=1,MA,2
      G = G*Half*real(I,kind=wp)
    end do
  end if
end if
GAM = G

return

end function GAM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_GETVEC0(CHOVEC,LENVEC,NUMVEC,IVEC1,ISYM,
     &                       SCR,LSCR)
C
C=======================================================================
C==== DEPRECATED - USE CHO_X_GETVEC OR CHO_X_VECRD INSTEAD =============
C=======================================================================
C
C     Purpose: read Cholesky vectors IVEC=IVEC1,...,IVEC1+NUMVEC-1
C              of symmetry ISYM from file. The vectors are returned
C              in the "current" reduced set.
C
C     NOTE: array SCR(LSCR) is used for storing the vectors in the
C           red. set from disk and for a full first red. set vector.
C           Thus, to be certain that enough memory is available,
C           use LSCR = 2 x dimension of first reduced set.
C
C
      use ChoSwp, only: InfVec, IndRed
#include "implicit.fh"
      DIMENSION CHOVEC(LENVEC,NUMVEC)
      DIMENSION SCR(LSCR)
#include "cholesky.fh"

      external ddot_

      CHARACTER*11 SECNAM
      PARAMETER (SECNAM = 'CHO_GETVEC0')

      LOGICAL LOCDBG
      PARAMETER (LOCDBG = .FALSE.)

C     Initialize output array.
C     ------------------------

      CALL FZERO(CHOVEC,LENVEC*NUMVEC)

C     Read reduced set index arrays for first vector.
C     -----------------------------------------------

      IRED  = INFVEC(IVEC1,2,ISYM)
      ILOC  = 3
      CALL CHO_GETRED(IRED,ILOC,.FALSE.)
      CALL CHO_SETREDIND(3)
      KRED1 = 1
      KREAD = KRED1 + NNBSTR(ISYM,1)
      KEND1 = KREAD + NNBSTR(ISYM,3)
      LSCR1 = LSCR  - KEND1 + 1
      IF (LSCR1 .LT. 0) THEN
         WRITE(LUPRI,*) 'Insufficient scratch space in ',SECNAM
         WRITE(LUPRI,*) 'Available: ',LSCR,'   Need: ',KEND1-1
         WRITE(LUPRI,*) '- needed for RED1: ',NNBSTR(ISYM,1)
         WRITE(LUPRI,*) '- needed for READ: ',NNBSTR(ISYM,3)
         CALL CHO_QUIT('[1] Insufficient scratch space in '//SECNAM,102)
      END IF

C     Read vectors and re-order into current reduced set via reduced
C     set 1.
C     NOTE: if the read vectors are already in red. set 1, don't resort.
C     ------------------------------------------------------------------

      DO JVEC = 1,NUMVEC

         IVEC = IVEC1 + JVEC - 1
         JRED = INFVEC(IVEC,2,ISYM)
         IF (JRED .NE. IRED) THEN   ! read new reduced set
            CALL CHO_GETRED(JRED,ILOC,.FALSE.)
            CALL CHO_SETREDIND(3)
            KEND1 = KREAD + NNBSTR(ISYM,3)
            LSCR1 = LSCR  - KEND1 + 1
            IF (LSCR1 .LT. 0) THEN
               WRITE(LUPRI,*) 'Insufficient scratch space in ',SECNAM
               WRITE(LUPRI,*) 'Available: ',LSCR,'   Need: ',KEND1-1
               WRITE(LUPRI,*) '- needed for RED1: ',NNBSTR(ISYM,1)
               WRITE(LUPRI,*) '- needed for READ: ',NNBSTR(ISYM,3)
               CALL CHO_QUIT('[2] Insufficient scratch space in '
     &                       //SECNAM,102)
            END IF
            IRED = JRED
         END IF

C        IOPT = 2
C        IADR = INFVEC(IVEC,3,ISYM)
C        CALL DDAFILE(LUCHO(ISYM),IOPT,SCR(KREAD),NNBSTR(ISYM,3),IADR)
C-tbp: replaced above code to make use of buffer through cho_vecrd.
         JNUM  = 0
         IREDC = IRED
         MUSED = 0
         CALL CHO_VECRD(SCR(KREAD),NNBSTR(ISYM,3),IVEC,IVEC,ISYM,
     &                  JNUM,IREDC,MUSED)
         IF (JNUM .NE. 1) THEN
            CALL CHO_QUIT('Logical error in '//SECNAM,103)
         END IF
         NSYS_CALL = NSYS_CALL + 1
         IF (LOCDBG) THEN
            XNRM = SQRT(DDOT_(NNBSTR(ISYM,3),SCR(KREAD),1,SCR(KREAD),1))
            WRITE(LUPRI,*) SECNAM,': ',
     &                     'Vector:',IVEC,' address: ',
     &                     INFVEC(IVEC,3,ISYM),
     &                     ' norm: ',XNRM,' sym. ',ISYM,' red. set: ',
     &                     IRED,' dim.: ',NNBSTR(ISYM,3)
         END IF

         CALL FZERO(SCR(KRED1),NNBSTR(ISYM,1))
         IF (IRED .GT. 1) THEN
            DO JAB = 1,NNBSTR(ISYM,3)   ! sort into rs1 ordering
               KAB = IIBSTR(ISYM,3)  + JAB
               IAB = INDRED(KAB,3) - IIBSTR(ISYM,1)
               SCR(KRED1+IAB-1) = SCR(KREAD+JAB-1)
            END DO
            KREDU = KRED1   ! point rs2 sort to red1 resort
         ELSE IF (IRED .EQ. 1) THEN
            KREDU = KREAD   ! point rs2 sort to read (already red1)
         ELSE
            WRITE(LUPRI,*) SECNAM,': ERROR: IRED is negative: ',IRED
            CALL CHO_QUIT('Reduced set error in '//SECNAM,104)
            KREDU = -999999 ! just to avoid compiler warnings
         END IF

         DO JAB = 1,NNBSTR(ISYM,2)  ! sort into in rs2 ordering
            KAB = IIBSTR(ISYM,2)  + JAB
            IAB = INDRED(KAB,2) - IIBSTR(ISYM,1)
            CHOVEC(JAB,JVEC) = SCR(KREDU+IAB-1)
         END DO

      END DO

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cre_raswfn
*     SVC: Create a wavefunction file. If another .wfn file already
*     exists, it will be overwritten.
#ifdef _DMRG_
      use qcmaquis_interface_cfg
#endif
      implicit none
#ifdef _HDF5_
#  include "rasdim.fh"
#  include "rasscf.fh"
#  include "WrkSpc.fh"
#  include "general.fh"
#  include "stdalloc.fh"
#  include "raswfn.fh"
#  include "gugx.fh"
#  include "gas.fh"
#  include "input_ras.fh"
      Integer         IDXCI(mxAct), IDXSX(mxAct)
      Common /IDSXCI/ IDXCI,        IDXSX

      integer :: dsetid
      integer, dimension(mxsym) :: NTMP1, NTMP2, NTMP3
      character(len=1), allocatable :: typestring(:)

*     create a new wavefunction file!
      wfn_fileid = mh5_create_file('RASWFN')

*     set module type
      call mh5_init_attr (wfn_fileid,'MOLCAS_MODULE', 'RASSCF')

*     copy basic molecular information to the HDF5 file
      call run2h5_molinfo(wfn_fileid)
      call one2h5_ovlmat(wfn_fileid, nsym, nbas)
      call one2h5_fckint(wfn_fileid, nsym, nbas)
      call one2h5_crtmom(wfn_fileid, nsym, nbas)

*     set wavefunction type
      if (iDoGAS) then
        call mh5_init_attr (wfn_fileid,'CI_TYPE', 'GAS')
      else if (IFCAS.EQ.0) then
        call mh5_init_attr (wfn_fileid,'CI_TYPE', 'CAS')
      else
        call mh5_init_attr (wfn_fileid,'CI_TYPE', 'RAS')
      end if

*     general wavefunction attributes
      call mh5_init_attr (wfn_fileid,'SPINMULT', iSpin)
      call mh5_init_attr (wfn_fileid,'LSYM', lSym)
      call mh5_init_attr (wfn_fileid,'NACTEL', nActEl)
      call mh5_init_attr (wfn_fileid,'NHOLE1', nHole1)
      call mh5_init_attr (wfn_fileid,'NELEC3', nElec3)
      call mh5_init_attr (wfn_fileid,'NCONF',  nConf)
      call mh5_init_attr (wfn_fileid,'NSTATES', nRoots)
      call mh5_init_attr (wfn_fileid,'NROOTS', lRoots)

      call mh5_init_attr (wfn_fileid,'L2ACT', 1, [mxAct], IDXSX)
      call mh5_init_attr (wfn_fileid,'A2LEV', 1, [mxAct], IDXCI)

*     iteration(s)
      wfn_iter = mh5_create_attr_int (wfn_fileid,'RASSCF_ITERATIONS')

*     molecular orbital type index
      if (iDoGAS) then
        NTMP1(:)=0
        NTMP2(:)=sum(NGSSH(1:NGAS,:),dim=1)
        NTMP3(:)=0
      else
        NTMP1(:)=NRS1(:)
        NTMP2(:)=NRS2(:)
        NTMP3(:)=NRS3(:)
      end if
      call mma_allocate(typestring, ntot)
      call orb2tpstr(NSYM,NBAS,
     $        NFRO,NISH,NTMP1,NTMP2,NTMP3,NSSH,NDEL,
     $        typestring)
      dsetid = mh5_create_dset_str(wfn_fileid,
     $        'MO_TYPEINDICES', 1, [NTOT],1)
      call mh5_init_attr(dsetid, 'description',
     $        'Type index of the molecular orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
      call mh5_put_dset(dsetid, typestring)
      call mma_deallocate(typestring)
      call mh5_close_dset(dsetid)

*     roots
      call mh5_init_attr (wfn_fileid,
     $        'STATE_ROOTID', 1, [nRoots], iRoot)
      call mh5_init_attr (wfn_fileid,
     $        'STATE_WEIGHT', 1, [nRoots], Weight)

*     energy (for each CI root)
      wfn_energy = mh5_create_dset_real (wfn_fileid,
     $        'ROOT_ENERGIES', 1, [lRoots])
      call mh5_init_attr(wfn_energy, 'description',
     $        'Energy for each root in the CI, '//
     $        'arranged as array of [NROOTS]')

*     molecular orbital coefficients
      wfn_mocoef = mh5_create_dset_real(wfn_fileid,
     $        'MO_VECTORS', 1, [NTOT2])
      call mh5_init_attr(wfn_mocoef, 'description',
     $        'Coefficients of the average orbitals, '//
     $        'arranged as blocks of size [NBAS(i)**2], i=1,#irreps')

*     molecular orbital occupation numbers
      wfn_occnum = mh5_create_dset_real(wfn_fileid,
     $        'MO_OCCUPATIONS', 1, [NTOT])
      call mh5_init_attr(wfn_occnum, 'description',
     $        'Occupation numbers of the average orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')

*     molecular orbital energies
      wfn_orbene = mh5_create_dset_real(wfn_fileid,
     $        'MO_ENERGIES', 1, [NTOT])
      call mh5_init_attr(wfn_orbene, 'description',
     $        'Orbital energies of the average orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')

*     molecular orbital symmetry irreps
      wfn_supsym = mh5_create_dset_int(wfn_fileid,
     $        'SUPSYM_IRREP_INDICES', 1, [NTOT])
      call mh5_init_attr(wfn_supsym, 'description',
     $        'Supersymmetry ID of the average orbitals '//
     $        'arranged as blocks of size [NBAS(i)], i=1,#irreps')
      call mh5_init_attr(wfn_supsym, 'pointgroup', 'D5h')
      call mh5_init_attr(wfn_supsym, '#irreps', 7)
      call mh5_put_dset(wfn_supsym, IXSYM)

*     CI data for each root
      wfn_cicoef = mh5_create_dset_real(wfn_fileid,
     $        'CI_VECTORS', 2, [nConf, lRoots])
      call mh5_init_attr(wfn_cicoef, 'description',
     $        'Coefficients of configuration state functions '//
     $        'in Split-GUGA ordering, size [NCONF] '//
     $        'for each root in NROOTS: [NROOTS,NCONF].')

*     density matrices for each root
      wfn_dens = mh5_create_dset_real (wfn_fileid,
     $        'DENSITY_MATRIX', 3, [NAC, NAC, lRoots])
      call mh5_init_attr(wfn_dens, 'description',
     $        'active 1-body density matrix, size [NAC,NAC] '//
     $        'for each root in NROOTS: [NROOTS,NAC,NAC].')

      wfn_spindens = mh5_create_dset_real (wfn_fileid,
     $        'SPINDENSITY_MATRIX', 3, [NAC, NAC, lRoots])
      call mh5_init_attr(wfn_spindens, 'description',
     $        'active 1-body spin density matrix, size [NAC,NAC] '//
     $        'for each root in NROOTS: [NROOTS,NAC,NAC].')

      if (KeyTDM) then
      wfn_transdens = mh5_create_dset_real (wfn_fileid,
     $        'TRANSITION_DENSITY_MATRIX', 3,
     $        [NAC, NAC, lRoots*(lRoots-1)/2])
      call mh5_init_attr(wfn_transdens, 'description',
     $        'active 1-body transition density matrix, '//
     $        'size [NAC,NAC] for each pair of roots in NROOTS: '//
     $        '[NROOTS*(NROOTS-1)/2,NAC,NAC].')

      if (iSpin.gt.1) then
      wfn_transsdens = mh5_create_dset_real (wfn_fileid,
     $        'TRANSITION_SPIN_DENSITY_MATRIX', 3,
     $        [NAC, NAC, lRoots*(lRoots-1)/2])
      call mh5_init_attr(wfn_transsdens, 'description',
     $        'active 1-body transition spin density matrix, '//
     $        'size [NAC,NAC] for each pair of roots in NROOTS: '//
     $        '[NAC,NAC,NROOTS*(NROOTS-1)/2].')
      end if
      end if

#ifdef _DMRG_
      if (doDMRG) then
! Leon 1/12/2016: Add the QCMaquis checkpoint name to the description of each state
! maximum allowed filename length is equal to MH5_MAX_LBL_LEN=256
        wfn_dmrg_checkpoint = mh5_create_dset_str(wfn_fileid,
     $        'QCMAQUIS_CHECKPOINT', 1, [lRoots], 256)
        call mh5_init_attr(wfn_dmrg_checkpoint,'description',
     $        'QCMaquis checkpoint directory names for each root'//
     $        ' in [NROOTS].')
      end if
#endif
#endif
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jeppe Olsen                                            *
************************************************************************
      SUBROUTINE GRAPW(W,Y,MINEL,MAXEL,NORB,NEL,IPRNT)
*
* A graph of strings has been defined from
*
*      MINEL(I) is the smallest allowed number of electrons in
*      orbitals 1 through I
*
*      MAXEL(I) is the largest allowed number of electrons in
*      orbitals 1 through I
*
* Set up vertex weights W
* Set up arc weights    Y
*
* Reverse lexical ordering is used with
* weights of unoccupied orbitals set to 0
*
* Jeppe Olsen
*
       IMPLICIT REAL*8(A-H,O-Z)
       INTEGER W(NORB+1,NEL+1)
       INTEGER Y(NORB,NEL)
       INTEGER MAXEL(NORB),MINEL(NORB)
*
       NTEST = 0
       NTEST = MAX(NTEST,IPRNT)
*
      Call iCopy((NEL+1)*(NORB+1),[0],0,W,1)
      Call iCopy(NEL*NORB,[0],0,Y,1)
*
*================
*  Vertex weights
*================
*
*. (Weight for vertex(IEL,IORB) is stored in W(IORB+1,IEL+1) )
      W(1,1) = 1
      DO 300 IEL = 0, NEL
        DO 200 IORB = 1, NORB
          IF(MINEL(IORB).LE.IEL .AND. IEL .LE. MAXEL(IORB) ) THEN
            IF( IEL .GT. 0 ) THEN
              W(IORB+1,IEL+1) = W(IORB,IEL+1)
     *                        + W(IORB,IEL)
            ELSE
              W(IORB+1,1) = W(IORB,1)
            END IF
          END IF
200     CONTINUE
300   CONTINUE
*
*. Weight for arc connecting vertices (IORB-1,IEL-1) and(IORB,IEL)
*. is stored in Y(IORB,IEL)
*. Y(IORB,IEL) = W(IORB-1,IEL)
*
      DO 1300 IEL = 1, NEL
        DO 1200 IORB = 1, NORB
          IF(MINEL(IORB).LE.IEL .AND. IEL .LE. MAXEL(IORB) ) THEN
            Y(IORB,IEL) = W(IORB-1+1,IEL+1)
          END IF
1200    CONTINUE
1300  CONTINUE
*
      IF ( NTEST.GE.100 ) THEN
         WRITE(6,*) ' vertex weights'
         CALL IWRTMA(W,NORB+1,NEL+1,NORB+1,NEL+1)
         WRITE(6,*) ' arc weights'
         CALL IWRTMA(Y,NORB,NEL,NORB,NEL)
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997,1998, Jeppe Olsen                                 *
************************************************************************
      SUBROUTINE GETH1(H,ISM,ITP,JSM,JTP)
*
* One-electron integrals over orbitals belonging to
* given OS class
*
*
* The orbital symmetries  are used to obtain the total
* symmetry of the one-electron integrals.
* It is therefore assumed that ISM, JSM represents a correct symmetry block
* of the integrals
*
* Jeppe Olsen, Version of fall 97
*              Summer of 98 : CC options added
*
      IMPLICIT REAL*8(A-H,O-Z)
#include "mxpdim.fh"
#include "WrkSpc.fh"
*.Global pointers
#include "glbbas.fh"
#include "lucinp.fh"
#include "orbinp.fh"

*.Output
      DIMENSION H(*)
*
      NI = NOBPTS(ITP,ISM)
      NJ = NOBPTS(JTP,JSM)
*
*
* Normal one-electron integrals
*
        IJ = 0
        DO J = 1, NJ
          DO I = 1, NI
            IJ = IJ+1
            H(IJ) = GETH1E(I,ITP,ISM,J,JTP,JSM)
          END DO
        END DO
*
      NTEST = 0
      IF(NTEST.NE.0) THEN
        WRITE(6,*) ' H1 for itp ism jtp jsm ',ITP,ISM,JTP,JSM
        CALL WRTMAT(H,NI,NJ,NI,NJ)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine WeGotThis(nAt,nB,MP,nij,EC,lMax,iPrint,Pot_Expo,Pot_Point,Pot_Fac,Diffed)

use Index_Functions, only: nTri3_Elem1
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAt, nB, nij, lMax, iPrint
real(kind=wp), intent(in) :: MP(nij,*), EC(3,nij), Pot_Expo(nij*2), Pot_Point(nij), Pot_Fac(nij*4)
logical(kind=iwp), intent(in) :: Diffed(nij*2)
integer(kind=iwp) :: iA, iComp, iDC, iOpt, iPP, irc, iSmLbl, jA, k, kaunt, kauntA, kComp, l, nDens, nEPP, nImprove, nShitty
real(kind=wp) :: chP, CorrCoeff, DeNom, Dif1, Dif2, ElPot_APP, ElPot_MP, ElPot_REF, ErrAv1, ErrAv2, ErrCorr, ErrDe1, ErrDe2, &
                 ErrMax1, ErrMax2, ErrRe1, ErrRe2, ErrVar1, ErrVar2, Expo(4), PImp, PP, PShi, r, rinv, x, y, z
logical(kind=iwp) :: D1, D2, Found, Que
character(len=10) :: OneFile, Label
real(kind=wp), allocatable :: D1ao(:), dMullig(:), ElP(:), EPCo(:,:)
character(len=10), parameter :: DistType(2) = ['Monopole  ','Dipole    ']
real(kind=wp) :: Ddot_, ElPot
interface
  subroutine Diff_Aux1(nEPotPoints,EPCo,nB,OneFile)
    import :: wp, iwp
    integer(kind=iwp), intent(out) :: nEPotPoints
    real(kind=wp), allocatable, intent(out) :: EPCo(:,:)
    integer(kind=iwp), intent(in) :: nB
    character(len=10), intent(in) :: OneFile
  end subroutine
end interface

! Print exponents and factors.

write(u6,*)
write(u6,'(A)') ' **********************************************************************************'
write(u6,'(A)') ' *                                                                                *'
write(u6,'(A)') ' *                  Result for the Diffuse Distribution                           *'
write(u6,'(A)') ' *                                                                                *'
write(u6,'(A)') ' **********************************************************************************'
write(u6,*)
write(u6,401) 'Centre','Coordinate','Multipole','Factor','Exponent','Point-charge'
write(u6,402) '|-------------------------------------------------------------------------------------------------|'
kauntA = 0
do iA=1,nAt
  do jA=1,iA
    kauntA = kauntA+1
    do iDC=1,2
      PP = -One
      if (iDC == 1) PP = Pot_Point(kauntA)
      if (Diffed(2*(kauntA-1)+iDC)) then
        if (iDC == 1) then
          write(u6,403) kauntA,(EC(k,kauntA),k=1,3),DistType(iDC),Pot_Fac(4*(kauntA-1)+iDC),Two*Pot_Expo(2*(kauntA-1)+iDC),PP
        else if (iDC == 2) then
          write(u6,404) kauntA,(EC(k,kauntA),k=1,3),DistType(iDC),(Pot_Fac(4*(kauntA-1)+iDC+k),k=0,2),Two*Pot_Expo(2*(kauntA-1)+iDC)
        end if
      else
        if (iDC == 1) then
          write(u6,405) kauntA,(EC(k,kauntA),k=1,3),DistType(iDC),Pot_Fac(4*(kauntA-1)+iDC),'Point(inf)',PP
        else if (iDC == 2) then
          write(u6,406) kauntA,(EC(k,kauntA),k=1,3),DistType(iDC),(Pot_Fac(4*(kauntA-1)+iDC+k),k=0,2),'Point(inf)'
        end if
      end if
    end do
  end do
end do
401 format(' ',A,'     ',A,'             ',A,'             ',A,'          ',A,'     ',A)
402 format(A)
403 format(' ',I3,' (',2(F7.3,','),F7.3,')      ',A,'          ',F7.3,'          ',F7.3,'      ',F7.3)
404 format(' ',I3,' (',2(F7.3,','),F7.3,')      ',A,' (',2(F7.3,','),F7.3,') ',F7.3)
405 format(' ',I3,' (',2(F7.3,','),F7.3,')      ',A,'          ',F7.3,'            ',A,'      ',F7.3)
406 format(' ',I3,' (',2(F7.3,','),F7.3,')      ',A,' (',2(F7.3,','),F7.3,')   ',A)

! If the extra ONEINT-file exist, then do an error analysis.

Que = .false.
call F_Inquire('ONEINTP',Que)
if (Que) then
  write(u6,*)
  write(u6,'(A)') ' Found Test-grid for error analysis.'
  write(u6,*)
  ErrAv1 = Zero
  ErrAv2 = Zero
  ErrDe1 = Zero
  ErrDe2 = Zero
  ErrVar1 = Zero
  ErrVar2 = Zero
  ErrMax1 = Zero
  ErrMax2 = Zero
  ErrCorr = Zero
  nImprove = 0
  nShitty = 0
  DeNom = Zero
  write(OneFile,'(A)') 'ONEINTP'
  call Diff_Aux1(nEPP,EPCo,nB,OneFile)
  call Qpg_dArray('D1ao',Found,nDens)
  if (Found .and. (nDens /= 0)) then
    call mma_allocate(D1ao,nDens,Label='D1ao')
  else
    write(u6,*) 'WeGotThis: do not think so!'
    call Abend()
  end if
  call Get_D1ao(D1ao,nDens)
  call mma_allocate(ElP,nDens+4,label='ElPot')
  if (iPrint >= 2) then
    write(u6,*)
    write(u6,'(A)') ' Electric Potential'
    write(u6,'(A)') '  Reference   Approximate MP-expanded'
  end if

  ! Loop over all points where the electric potential has been sampled.

  call mma_allocate(dMullig,nTri3_Elem1(lMax),label='dMullig')

  do iPP=1,nEPP

    ! First, get the true electric potential, the reference.

    write(Label,'(A3,I5)') 'EF0',iPP
    irc = -1
    iOpt = 0
    iSmLbl = 0
    iComp = 1
    call RdOne(irc,iOpt,Label,iComp,ElP,iSmLbl)
    ElPot_REF = ElP(nDens+4)
    ElPot_REF = ElPot_REF-Ddot_(nDens,D1ao,1,ElP,1)

    ! Second, get the approximate electric potential and also the
    ! completely multipole expanded potential.

    ElPot_APP = Zero
    ElPot_MP = Zero
    kauntA = 1
    !rMin = 1.0e10_wp
    do iA=1,nAt
      do jA=1,iA
        x = EPCo(1,iPP)-EC(1,kauntA)
        y = EPCo(2,iPP)-EC(2,kauntA)
        z = EPCo(3,iPP)-EC(3,kauntA)
        r = sqrt(x**2+y**2+z**2)
        rinv = One/r
        D1 = Diffed(2*(kauntA-1)+1)
        D2 = Diffed(2*(kauntA-1)+2)
        Expo(1) = Pot_Expo(2*(kauntA-1)+1)
        Expo(2) = Pot_Expo(2*(kauntA-1)+2)
        chP = Pot_Point(kauntA)
        kaunt = 1
        !rmin = min(r,rmin)
        do l=0,lMax
          kComp = (l+1)*(l+2)/2
          do k=1,kComp
            dMullig(kaunt) = MP(kauntA,kaunt)
            kaunt = kaunt+1
          end do
        end do
        ElPot_APP = ElPot_APP+ElPot(r,rinv,x,y,z,dMullig,lMax,Expo,chP,D1,D2)
        ElPot_MP = ElPot_MP+ElPot(r,rinv,x,y,z,dMullig,lMax,Expo,chP,.false.,.false.)
        kauntA = kauntA+1
      end do
    end do
    !write(u6,*) 'Minimum Dist:',rMin

    ! Print if requested.

    if (iPrint >= 2) then
      write(u6,441) ElPot_REF,ElPot_APP,ElPot_MP,EPCo(:,iPP)
    end if

    ! Third, accumulate to error analysis.

    ! The difference
    Dif1 = ElPot_APP-ElPot_REF
    Dif2 = ElPot_MP-ElPot_REF
    ! Accumulate to average error
    ErrAv1 = ErrAv1+Dif1
    ErrAv2 = ErrAv2+Dif2
    ! Accumulate to variance of error
    ErrVar1 = ErrVar1+Dif1**2
    ErrVar2 = ErrVar2+Dif2**2
    ! Accumulate to deviation
    ErrDe1 = ErrDe1+abs(Dif1)
    ErrDe2 = ErrDe2+abs(Dif2)
    ! Maximal error
    if (ErrMax1 < abs(Dif1)) ErrMax1 = abs(Dif1)
    if (ErrMax2 < abs(Dif2)) ErrMax2 = abs(Dif2)
    ! Accumulate to covariance of errors
    ErrCorr = ErrCorr+Dif1*Dif2
    ! Better or worse
    if (abs(Dif1) <= abs(Dif2)) nImprove = nImprove+1
    if (abs(Dif2) < abs(Dif1)) nShitty = nShitty+1
    ! Accumulate to denominator in relative error
    DeNom = DeNom+abs(ElPot_REF)
  end do
  ErrRe1 = ErrDe1/DeNom
  ErrRe2 = ErrDe2/DeNom
  ErrAv1 = ErrAv1/real(nEPP,kind=wp)
  ErrAv2 = ErrAv2/real(nEPP,kind=wp)
  ErrDe1 = ErrDe1/real(nEPP,kind=wp)
  ErrDe2 = ErrDe2/real(nEPP,kind=wp)
  ErrVar1 = ErrVar1/real(nEPP,kind=wp)
  ErrVar2 = ErrVar2/real(nEPP,kind=wp)
  ErrCorr = ErrCorr/real(nEPP,kind=wp)
  CorrCoeff = (ErrCorr-ErrAv1*ErrAv2)/sqrt((ErrVar1-ErrAv1**2)*(ErrVar2-ErrAv2**2))
  PImp = 100.0_wp*real(nImprove,kind=wp)/real(nEPP,kind=wp)
  PShi = 100.0_wp*real(nShitty,kind=wp)/real(nEPP,kind=wp)

  ! Four, print the analysis.

  write(u6,*)
  write(u6,'(A)') '   Error Analysis'
  write(u6,'(A)') ' |----------------------------------------------------|'
  write(u6,'(A)') '                                Diffuse     MP-expanded'
  write(u6,442) '  Average absolute error:      ',ErrAv1,ErrAv2
  write(u6,442) '  Average absolute deviation:  ',ErrDe1,ErrDe2
  write(u6,442) '  Average relative error:      ',ErrRe1,ErrRe2
  write(u6,442) '  Maximal deviation:           ',ErrMax1,ErrMax2
  write(u6,*)
  write(u6,443) '  Error correlation:           ',CorrCoeff
  write(u6,444) '  Smaller error than MP:       ',PImp,'%'
  write(u6,444) '  Larger error than MP:        ',PShi,'%'
  write(u6,'(A)') ' |----------------------------------------------------|'
  write(u6,*)

  ! Deallocate

  call mma_deallocate(ElP)
  call mma_deallocate(D1ao)
  call mma_deallocate(EPCo)
  call mma_deallocate(dMullig)
  irc = -1
  call ClsOne(irc,0)
end if

441 format(3(F12.8),'    In: ',3(F8.4))
442 format(A,2(F12.8))
443 format(A,F12.8)
444 format(A,F12.8,A)

return

end subroutine WeGotThis

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine AIJK(ITAI,L0,L1,L2,L3)

use guga_global, only: IADD10, ICH, IOUT, IRC, JRC, LN, Lu_10, MXVERT, NBUF, NMAT
use guga_util_global, only: COP, ICOP1, nCOP
use Definitions, only: iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: ITAI(*)
integer(kind=iwp), intent(in) :: L0(*), L1(*), L2(*), L3(*)
integer(kind=iwp) :: I, II, IID, IND, IT1, IT2, ITT1, ITT2, ITURN, J, JJ, JJD, K, L, NI, NJ, NK

IOUT = 0
NMAT = 0
L = 0
do NI=1,LN
  do NJ=1,NI
    I = ICH(NI)
    J = ICH(NJ)
    if (I <= J) then
      I = ICH(NJ)
      J = ICH(NI)
    end if
    do NK=1,LN
      IOUT = IOUT+1
      ICOP1(IOUT) = 0
      if (IOUT >= NBUF) then
        ICOP1(nCOP+1) = NBUF
        call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
        call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
        NMAT = NMAT+NBUF
        IOUT = 0
      end if
      K = ICH(NK)
      IOUT = IOUT+1
      !IND = I+2**10*J
      IND = ior(I,ishft(J,10))
      !ICOP1(IOUT) = IND+2**20*K
      ICOP1(IOUT) = ior(IND,ishft(K,20))
      if (IOUT >= NBUF) then
        ICOP1(nCOP+1) = NBUF
        call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
        call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
        NMAT = NMAT+NBUF
        IOUT = 0
      end if
      ! DOUBLET-VALENCE INTERACTIONS
      ITURN = 1
      ITT1 = 1
      ITT2 = 0
      do
        IT1 = ITT1*MXVERT
        IT2 = ITT2*MXVERT
        if (ITT1 == 0) then
          JJ = 0
          JJD = 0
        else
          JJ = IRC(ITT1)
          JJD = JRC(ITT1)
        end if
        if (ITT2 == 0) then
          II = 0
          IID = 0
        else
          II = IRC(ITT2)
          IID = JRC(ITT2)
        end if
        if (I == K) then
          if (J /= K) then
            call INT61(L,J,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,L0,L1,L2,L3)
            call INT62(L,J,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,L0,L1,L2,L3)
          else
            call INT9(L,K,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,L0,L1,L2,L3)
          end if
        else if (J == K) then
          call INT4(L,K,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,L0,L1,L2,L3)
        else if (I == J) then
          call INT8(L,K,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,L0,L1,L2,L3)
        else if (K >= I) then
          call INT3(J,I,L,K,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,L0,L1,L2,L3)
        else if (K >= J) then
          call INT2(L,K,J,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,L0,L1,L2,L3)
        else
          call INT1(L,K,J,I,IT1,IT2,II,IID,JJ,JJD,ITURN,ITAI,L0,L1,L2,L3)
        end if
        select case (ITURN)
          case default !(1)
            ! TRIPLET-DOUBLET INTERACTIONS
            ITURN = 2
            ITT1 = 2
            ITT2 = 1
          case (2)
            ! SINGLET-DOUBLET INTERACTIONS
            ITURN = 3
            ITT1 = 3
            ITT2 = 1
          case (3)
            ! VALENCE-DOUBLET INTERACTIONS
            ITURN = 4
            ITT1 = 0
            ITT2 = 1
          case (4)
            ! DOUBLET-TRIPLET INTERACTIONS
            ITURN = 5
            ITT1 = 1
            ITT2 = 2
          case (5)
            ! DOUBLET-SINGLET INTERACTIONS
            ITURN = 6
            ITT1 = 1
            ITT2 = 3
          case (6)
            exit
        end select
      end do
    end do
  end do
end do
ICOP1(nCOP+1) = IOUT
call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
NMAT = NMAT+IOUT
ICOP1(nCOP+1) = -1
call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
write(u6,600) NMAT

return

600 format(/6X,'COEFFICIENTS FOR AIJK',I9)

end subroutine AIJK

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine date2_cvb(delcpu)

use Definitions, only: wp, u6

implicit none
real(kind=wp), intent(in) :: delcpu
character(len=120) :: line

line = ' '
call datimx(line)
write(u6,'(6a,f10.3,a)') ' CASVB completed on ',line(1:10),line(20:24),' at ',line(12:19),' after',delcpu,' CPU seconds'

return

end subroutine date2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine RFNuc(CoOP,rNucMm,ir)
************************************************************************
*                                                                      *
* Object: to compute the multipole moments for the nuclei.             *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      use Basis_Info
      use Center_Info
#ifdef _OBSOLETE_
      use External_Centers, only: nOrd_XF, XF
#endif
      use Phase_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "print.fh"
      Real*8  rNucMm((ir+1)*(ir+2)/2), CoOp(3), A(3), RA(3)
#ifdef _OBSOLETE_
     &        ,rRMy(3)
      Integer iStb(0:7), jCoSet(0:7,0:7)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      iRout = 124
      iPrint = nPrint(iRout)
      If (iPrint.ge.99) Then
         Call RecPrt(' In RFNuc:CoOp',' ',CoOp,1,3)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the nuclear contribution to the multipole moments
*
*     Contributions due to the charges of nuclear charges
*
      iq = 0
      Do ix = ir, 0, -1
         Do iy = ir-ix, 0, -1
            iq = iq + 1
            iz = ir-ix-iy
            temp = Zero
C           Write (*,*) ' ix,iy,iz=',ix,iy,iz
*
            ndc = 0
            Do iCnttp = 1, nCnttp
               ZA = dbsc(iCnttp)%Charge
               If (ZA.eq.Zero) Go To 101
               If (iPrint.ge.99) Then
                  Write (6,*) ' Charge=',ZA
                  Call RecPrt(' Centers',' ',dbsc(iCnttp)%Coor,3,
     &                        dbsc(iCnttp)%nCntr)
               End If
               Do iCnt = 1, dbsc(iCnttp)%nCntr
                  A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
                  mdc = ndc + iCnt
                  Do i = 0, nIrrep/dc(mdc)%nStab - 1
                     Call OA(dc(mdc)%iCoSet(i,0),A,RA)
C                    Call RecPrt(' RA',' ',RA,1,3)
C                    Call RecPrt(' CoOp',' ',CoOp,1,3)
#ifdef NAGFOR
                     If (iCnt.lt.-2) Write (6,*) 'Nag problem'
#endif

                     If (ix.eq.0) Then
                        CCoMx=One
                     Else
                        CCoMx=(RA(1)-CoOp(1))**ix
                     End If
                     If (iy.eq.0) Then
                        CCoMy=One
                     Else
                        CCoMy=(RA(2)-CoOp(2))**iy
                     End If
                     If (iz.eq.0) Then
                        CCoMz=One
                     Else
                        CCoMz=(RA(3)-CoOp(3))**iz
                     End If
C                    Write (*,*) CCoMx, CCoMy, CCoMz, temp
                     temp = temp + ZA * CCoMx * CCoMy * CCoMz
                  End Do
               End Do
 101           Continue
               ndc = ndc + dbsc(iCnttp)%nCntr
            End Do
            rNucMm(iq) = temp
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _OBOLETE_
*     The remainder of this subroutine is obsolete and
*     is kept only for testing reasons. It is replaced by
*     the subroutine XFMoment which is more general.
      GoTo 99





      If ((.Not.Allocated(XF)).or.(nOrd_XF.lt.0)) Go To 99
*
*     Contributions due to the charges and dipoles of the
*     static external electric field.
*
*     Write (*,*) ' Adding contibutions from esef!'

      iq = 0
      Do ix = ir, 0, -1
         Do iy = ir-ix, 0, -1
            iq = iq + 1
            iz = ir-ix-iy
            temp = Zero
*           Write (*,*) ' ix,iy,iz=',ix,iy,iz
*
            Do iFd = 1, nXF
               DAx=Zero
               DAy=Zero
               DAz=Zero
               Qxx=Zero
               Qxy=Zero
               Qxz=Zero
               Qyy=Zero
               Qyz=Zero
               Qzz=Zero
               If (nOrd_XF.eq.0) Then
                  ZA = XF(4,iFd)
               Else If (nOrd_XF.eq.1) Then
                  ZA = XF(4,iFd)
                  DAx= XF(5,iFd)
                  DAy= XF(6,iFd)
                  DAz= XF(7,iFd)
               Else If (nOrd_XF.eq.2) Then
                  ZA = XF(4,iFd)
                  DAx= XF(5,iFd)
                  DAy= XF(6,iFd)
                  DAz= XF(7,iFd)
                  Qxx= XF(8,iFd)
                  Qxy= XF(9,iFd)
                  Qxz= XF(10,iFd)
                  Qyy= XF(11,iFd)
                  Qyz= XF(12,iFd)
                  Qzz= XF(13,iFd)
               Else
                  Call WarningMessage(2,
     &                      'RFNuc: Option not implemented yet!')
                  Call Abend()
               End If
               If (iPrint.ge.99) Then
                  Write (6,*) ' Charge=',ZA
                  Write (6,*) ' ixyz=',ixyz
                  Call RecPrt(' Centers',' ',XF(1,iXF),3,1)
               End If
*
               A(1:3) = XF(1:3,iXF)
*
*------------- Generate Stabilazor of C
*
               iChxyz=iChAtm(A)
               iDum=0
               Call Stblz(iChxyz,nStb,iStb,iDum,jCoSet)
*
*              Write (*,*) ' nStb=',nStb
               Do i = 0, nIrrep/nStb - 1
                  Call OA(jCoSet(i,0),A,RA)
                  rRMy(1)=DAx*DBLE(iPhase(1,jCoSet(i,0)))
                  rRMy(2)=DAy*DBLE(iPhase(2,jCoSet(i,0)))
                  rRMy(3)=DAz*DBLE(iPhase(3,jCoSet(i,0)))
                  QRAxx = QAxx
                  QRAyy = QAyy
                  QRAzz = QAzz
                  QRAxy=DBLE(iPhase(1,jCoSet(i,0))
     &                      *iPhase(2,jCoSet(i,0)))*QAxy
                  QRAxz=DBLE(iPhase(1,jCoSet(i,0))
     &                      *iPhase(3,jCoSet(i,0)))*QAxz
                  QRAyz=DBLE(iPhase(2,jCoSet(i,0))
     &                      *iPhase(3,jCoSet(i,0)))*QAyz

                  If (ix.eq.0) Then
                     CCoMx=One
                  Else
                     CCoMx=(RA(1)-CoOp(1))**ix
                  End If
                  If (iy.eq.0) Then
                     CCoMy=One
                  Else
                     CCoMy=(RA(2)-CoOp(2))**iy
                  End If
                  If (iz.eq.0) Then
                     CCoMz=One
                  Else
                     CCoMz=(RA(3)-CoOp(3))**iz
                  End If

*                 Write (*,*) CCoMx, CCoMy, CCoMz, temp
*
*---------------- The charge contibution
*
                  temp = temp + ZA * CCoMx * CCoMy * CCoMz
*
*---------------- Dipole contributions
*
                  If (ix.ge.1) Then
                     temp = temp + DBLE(ix)*rRmy(1)*CCoMy*CCoMz*
     &                      (RA(1)-CoOp(1))**(ix-1)
                  End If
                  If (iy.ge.1) Then
                     temp = temp + DBLE(iy)*rRmy(2)*CCoMx*CCoMz*
     &                      (RA(2)-CoOp(2))**(iy-1)
                  End If
                  If (iz.ge.1) Then
                     temp = temp + DBLE(iz)*rRmy(3)*CCoMx*CCoMy*
     &                      (RA(3)-CoOp(3))**(iz-1)
                  End If

               End Do
            End Do
c            Write (*,*) ' Temp=',temp
            rNucMm(iq) = rNucMm(iq) + temp

         End Do
      End Do
*
 99   Continue
#endif
      If (iPrint.ge.99) Call RecPrt(' Nuclear Multipole Moments',
     &                              ' ',rNucMm,ip,1)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2022, Jie J. Bao                                       *
************************************************************************

************************************************************************
* History:                                                             *
* Jie J. Bao on May 09, 2022, created this file                        *
************************************************************************



       Subroutine ShiftDiag(Mat,RShift,lShift,nDim,Digit)

       INTEGER nDim,Digit
       Real*8,DIMENSION(nDim**2)::Mat
       Real*8 RShift
       Logical lShift


       Real*8,DIMENSION(nDim)::RDiag
       Real*8 MaxElem
       INTEGER I,iShift

       DO I=1,nDim
        RDiag(I)=Mat((I-1)*nDim+I)
       END DO

       MaxElem=maxval(RDiag)

*       write(6,*) 'maximum of diagonal elements',MaxElem
*       CALL RecPrt(' ',' ',RDiag,1,nDim)

       IF(abs(MaxElem).lt.Real(Digit,8)) THEN
        lShift=.false.
        RETURN
       ELSE
        lShift=.true.
        IShift=Int(MaxElem,8)/Digit*Digit
        RShift=Real(IShift,8)
*        write(6,*) lShift,IShift,RShift
       END IF

       RETURN
       End Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine prtopt2_cvb(iopt1,ioptim,italter,noptim,iorts,ifxorb,ifxstr,idelstr)

use Index_Functions, only: nTri_Elem
use casvb_global, only: icrit, ifinish, imethod, ipr, isaddle, kbasis, lfxvb, lzrvb, mxiter, nfxorb, nfxvb, norb, nort, nvb, &
                        nzrvb, projcas, projsym, spinb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iopt1, ioptim, italter, noptim, iorts(2,nTri_Elem(norb-1)), ifxorb(norb), ifxstr(nvb), idelstr(nvb)
integer(kind=iwp) :: i, ifx, io
character(len=9) :: sbformat
character(len=3) :: ayn
integer(kind=iwp), allocatable :: tmp(:)
character(len=*), parameter :: methkw(12) = ['Fletcher','    TRIM','Trustopt','Davidson','   Steep','  Vb2cas',' AugHess', &
                                             'AugHess2','   Check',' dFletch','    None','Super-CI']

if (ifinish == 0) then
  if ((ipr(3) >= 1) .or. ((ipr(3) == 0) .and. ((iopt1 == 0) .or. (italter == 1)))) then
    if (noptim == 1) then
      write(u6,'(/,a)') ' -- Starting optimization ------------------'
    else
      write(u6,'(/,a,i3,a)') ' -- Starting optimization - step',ioptim,' --------'
    end if
  end if
  if ((ipr(3) >= 1) .and. ((iopt1 == 0) .or. (italter == 1))) then
    if (icrit == 1) then
      write(u6,'(/,a)') ' Overlap-based optimization (Svb).'
    else if (icrit == 2) then
      write(u6,'(/,a)') ' Energy-based optimization (Evb).'
    end if
    write(u6,'(/,a,11x,a)') ' Optimization algorithm:',methkw(imethod)
    write(u6,'(a,i13)') ' Maximum number of iterations:',mxiter
    ayn = ' No'
    if (projcas) ayn = 'Yes'
    if (projcas) write(u6,'(a,31x,a)') ' Casproj:',ayn
    ayn = ' No'
    if (projsym) ayn = 'Yes'
    if (projsym) write(u6,'(a,31x,a)') ' Symproj:',ayn
    ayn = ' No'
    sbformat = '(a,19x,a)'
    write(sbformat(4:5),'(i2)') 31-len_trim(spinb(kbasis))
    write(u6,sbformat) ' Spin basis:',trim(spinb(kbasis))
    if (isaddle > 0) write(u6,'(/,a,i9)') ' Saddle-point optimization, order:',isaddle
    if (nort > 0) then
      write(u6,'(/,i4,a)') nort,' orthogonalization pairs defined :'
      write(u6,6100) (io,iorts(1,io),iorts(2,io),io=1,nort)
    end if
    if (nfxorb == norb) then
      write(u6,'(/,a)') ' All orbitals will be frozen.'
    else if (nfxorb > 0) then
      write(u6,'(/,a)') ' Following orbitals will be frozen :'
      call mma_allocate(tmp,nfxorb,label='tmp')
      ifx = 0
      do i=1,norb
        if ((ifxorb(i) >= 0) .and. (ifxorb(i) <= norb)) then
          ifx = ifx+1
          tmp(ifx) = i
        end if
      end do
      nfxorb = ifx
      write(u6,'(14i3)') tmp(1:nfxorb)
      call mma_deallocate(tmp)
    end if
    if ((nfxvb > 0) .and. (lfxvb == 0)) then
      write(u6,'(/,a)') ' Following structures will be frozen :'
      write(u6,'(14i3)') ifxstr(1:nfxvb)
    else if ((nfxvb == 0) .and. (lfxvb == 1)) then
      write(u6,'(/,a)') ' All structures will be frozen.'
    else if ((nfxvb > 0) .and. (lfxvb == 1)) then
      write(u6,'(/,a)') ' Following structures coefficients will be optimized :'
      write(u6,'(14i3)') ifxstr(1:nfxvb)
    end if
    if ((nzrvb > 0) .and. (lzrvb == 0)) then
      write(u6,'(/,a)') ' Following structures will be deleted :'
      write(u6,'(14i3)') idelstr(1:nzrvb)
    else if ((nzrvb == 0) .and. (lzrvb == 1)) then
      write(u6,'(/,a)') ' All structures will be deleted.'
    else if ((nzrvb > 0) .and. (lzrvb == 1)) then
      write(u6,'(/,a)') ' Following structures will not be deleted :'
      write(u6,'(14i3)') idelstr(1:nzrvb)
    end if
    write(u6,'(/,a)') ' -------------------------------------------'
  end if
  if ((iopt1 == 0) .or. (italter == 1)) call tuneprint_cvb()
else if (ifinish < 3) then
  if ((ipr(3) >= 1) .or. ((ipr(3) == 0) .and. ((iopt1 == 0) .or. (italter == 1)))) then
    if (noptim == 1) then
      write(u6,'(/,a)') ' -- Wavefunction summary -------------------'
    else
      write(u6,'(/,a,i3,a)') ' -- Wavefunction summary - step',ioptim,' ---------'
    end if
  end if
end if

return
6100 format(3(i4,': ',i2,' -',i2))

end subroutine prtopt2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine indxab2_cvb(indxa,indxb,nstra,nstrb,
     >  iocc,nsa,nsb)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension indxa(nsa),indxb(nsb)
      dimension nstra(mxirrep),nstrb(mxirrep)
      dimension iocc(norb+1)

      call izero(nstra,mxirrep)
      call izero(nstrb,mxirrep)
      inda=0
      indb=0
      do 300 iisym=1,mxirrep

      call loopstr0_cvb(iocc,index,nalf,norb)
400   continue
      irp=1
      do 500 ia=1,nalf
      irp=md2h(irp,ityp(iocc(ia)))
500   continue
      if(irp.ne.iisym)goto 600
      inda=inda+1
      nstra(iisym)=nstra(iisym)+1
      indxa(inda)=index
600   call loopstr_cvb(iocc,index,nalf,norb)
      if(index.ne.1)goto 400

      call loopstr0_cvb(iocc,index,nbet,norb)
700   continue
      irp=1
      do 800 ib=1,nbet
      irp=md2h(irp,ityp(iocc(ib)))
800   continue
      if(irp.ne.iisym)goto 900
      indb=indb+1
      nstrb(iisym)=nstrb(iisym)+1
      indxb(indb)=index
900   call loopstr_cvb(iocc,index,nbet,norb)
      if(index.ne.1)goto 700

300   continue
      return
      end
c  *************************
c  ** MOs, read and write **
c  *************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_INT_1_DBG2()
!
! Purpose: test symmetry of integral matrix.

use Symmetry_Info, only: Mul
use Index_Functions, only: iTri, nTri_Elem
use Cholesky, only: IFCSew, iSP2F, LuPri, Mx2Sh, nBstSh, nnShl
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: IA, IAB, IABCD, IABMN, IABMX, IB, IC, ICD, ICDMN, ICDMX, ID, IERR, ISHLA, ISHLAB, ISHLB, ISHLC, ISHLCD, &
                     ISHLD, ISYMA, ISYMAB, ISYMB, ISYMC, ISYMCD, ISYMD, ITST, LINT, LINTT, LSEW, NERR, NTST, NUMAB, NUMCD
real(kind=wp) :: ERRMAX, ERRMIN, TST
real(kind=wp), allocatable, target :: INT1(:)
real(kind=wp), pointer :: pINT1(:), pINT2(:)
real(kind=wp), parameter :: THR = 1.0e-14_wp
logical(kind=iwp), parameter :: PRTINT = .false.
character(len=*), parameter :: SECNAM = 'CHO_MCA_INT_1_DBG2'
integer(kind=iwp), external :: CHO_ISAOSH

write(LUPRI,*)
write(LUPRI,*)
write(LUPRI,*) SECNAM,': testing integral matrix symmetry'
write(LUPRI,*)

! Force computation of full shell quadruple.
! ------------------------------------------

if (IFCSEW /= 1) then
  write(LUPRI,*) SECNAM,': WARNING: resetting IFCSEW from ',IFCSEW,' to 1.'
  IFCSEW = 1
end if

LINTT = 2*MX2SH*MX2SH
call mma_allocate(INT1,LINTT,Label='INT1')
call mma_maxDBLE(LSEW)
call XSETMEM_INTS(LSEW)

NTST = 0
NERR = 0
do ISHLAB=1,NNSHL

  call CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.true.)
  if (ISHLB == ISHLA) then
    NUMAB = nTri_Elem(NBSTSH(ISHLA))
  else
    NUMAB = NBSTSH(ISHLA)*NBSTSH(ISHLB)
  end if

  do ISHLCD=1,ISHLAB

    call CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.true.)
    if (ISHLD == ISHLC) then
      NUMCD = nTri_Elem(NBSTSH(ISHLC))
    else
      NUMCD = NBSTSH(ISHLC)*NBSTSH(ISHLD)
    end if
    LINT = NUMCD*NUMAB
    pINT1(1:LINT) => INT1(1:LINT)
    pINT2(1:LINT) => INT1(LINT+1:LINT+LINT)

    ! Calculate integrals (CD|AB).
    ! ----------------------------

    pINT1(:) = Zero
    call CHO_MCA_INT_1(ISHLCD,ISHLAB,pINT1,LINT,PRTINT)

    ! Calculate integrals (AB|CD).
    ! ----------------------------

    pINT2(:) = Zero
    call CHO_MCA_INT_1(ISHLAB,ISHLCD,pINT2,LINT,PRTINT)

    ! Compare.
    ! --------

    ITST = 0
    IERR = 0
    call CHO_MCA_INT1_1_DBG2_CMP(pINT1,pINT2,NUMCD,NUMAB,ERRMIN,ICDMN,IABMN,ERRMAX,ICDMX,IABMX,ITST,IERR,THR,.false.,LUPRI)
    NTST = NTST+ITST
    NERR = NERR+IERR

    write(LUPRI,*) '#sym. errors for (',ISHLC,ISHLD,'|',ISHLA,ISHLB,'): ',IERR,' #tests: ',ITST
    if (IERR /= 0) then
      !write(LUPRI,*) '    Here is the shell quadruple in INT1:'
      !call CHO_OUTPUT(pINT1,1,NUMCD,1,NUMAB,NUMCD,NUMAB,1,LUPRI)
      !write(LUPRI,*) '    And the shell quadruple in INT2:'
      !call CHO_OUTPUT(pINT2,1,NUMAB,1,NUMCD,NUMAB,NUMCD,1,LUPRI)
      do IB=1,NBSTSH(ISHLB)
        ISYMB = CHO_ISAOSH(IB,ISHLB)
        do IA=1,NBSTSH(ISHLA)
          ISYMA = CHO_ISAOSH(IA,ISHLA)
          ISYMAB = MUL(ISYMA,ISYMB)
          if (ISHLB == ISHLA) then
            IAB = ITRI(IA,IB)
          else
            IAB = NBSTSH(ISHLA)*(IB-1)+IA
          end if
          do ID=1,NBSTSH(ISHLD)
            ISYMD = CHO_ISAOSH(ID,ISHLD)
            do IC=1,NBSTSH(ISHLC)
              ISYMC = CHO_ISAOSH(IC,ISHLC)
              ISYMCD = MUL(ISYMC,ISYMD)
              if (ISHLC == ISHLD) then
                ICD = ITRI(IC,ID)
              else
                ICD = NBSTSH(ISHLC)*(ID-1)+IC
              end if
              IABCD = NUMCD*(IAB-1)+ICD
              TST = abs(pINT1(IABCD))
              if ((TST > Zero) .and. (ISYMCD /= ISYMAB)) then
                write(LUPRI,*) 'Symmetry break!!'
                write(LUPRI,*) 'element ',ICD,IAB,' is non-zero: ',pINT1(IABCD)
                write(LUPRI,*) 'Symmetry is: ',MUL(ISYMCD,ISYMAB)
              end if
            end do
          end do
        end do
      end do
    end if

  end do
end do

call XRLSMEM_INTS()
call mma_deallocate(INT1)
nullify(pINT1,pINT2)

write(LUPRI,*) '***END OF ',SECNAM,': #tests: ',NTST,' #errors: ',NERR

end subroutine CHO_MCA_INT_1_DBG2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Giovanni Li Manni                                *
!               2019,2024, Oskar Weser                                 *
!               2021, Werner Dobrautz                                  *
!***********************************************************************

module fciqmc_make_inp

use linalg_mod, only: verify_
use general_data, only: iSpin, nActEl
use fortran_strings, only: str
use stdalloc, only: mma_deallocate
use Constants, only: Zero, Five, Ten
use Definitions, only: wp, iwp

implicit none
private

! Sometimes no default value on purpose
integer(kind=iwp) :: totalwalkers, &
                     Time = 200, &                      ! Default value for time per NECI run
                     trial_wavefunction = 1000000000, & ! Practically this means no trial_wavefunction by default
                     nmcyc = 50000, &
                     pops_trial = 1000, &
                     stepsshift = 10, &
                     addtoinitiator = 3, &
                     semi_stochastic = 1000, &
                     highlypopwrite = 50, &
                     startsinglepart = 10, &
                     pops_core = 10000
character(len=:), allocatable :: definedet
real(kind=wp) :: proje_changeref = 1.2_wp, &
                 max_tau = 0.02_wp, &
                 maxwalkerbloom = 2._wp, &
                 memoryfacpart = Five, &
                 memoryfacspawn = Ten, &     ! Default value for NECI RealSpawnCutOff
                 realspawncutoff = 0.3_wp, & ! Default value for NECI diagonal shift value
                 diagshift = Zero, &
                 shiftdamp = 0.02_wp

type :: t_RDMsampling
  integer(kind=iwp) :: start, n_samples, step
end type t_RDMsampling

type(t_RDMsampling) :: RDMsampling

public :: addtoinitiator, cleanup, definedet, diagshift, highlypopwrite, make_inp, max_tau, maxwalkerbloom, memoryfacpart, &
          memoryfacspawn, nmcyc, pops_core, pops_trial, proje_changeref, RDMsampling, realspawncutoff, semi_stochastic, shiftdamp, &
          startsinglepart, stepsshift, t_RDMsampling, Time, totalwalkers, trial_wavefunction

contains

!>  @brief
!>    Generate an Input for NECI
!>
!>  @author
!>    G. Li Manni, Oskar Weser
!>
!>  @param[in] path
!>  @param[in] readpops If true the readpops option for NECI is set.
!>  @param[in] tGUGA
!>  @param[in] FCIDUMP_name
!>  @param[in] GAS_spaces
!>  @param[in] GAS_particles
subroutine make_inp(path,readpops,tGUGA,FCIDUMP_name,GAS_spaces,GAS_particles)

  character(len=*), intent(in) :: path
  logical(kind=iwp), intent(in) :: readpops, tGUGA
  character(len=*), intent(in), optional :: FCIDUMP_name
  integer(kind=iwp), intent(in), optional :: GAS_spaces(:,:), GAS_particles(:,:)
  integer(kind=iwp) :: file_id, i, iGAS, indentlevel, iSym, nGAS, nSym
  integer(kind=iwp), parameter :: indentstep = 4
  integer(kind=iwp), external :: isFreeUnit

  call verify_(present(GAS_spaces) .eqv. present(GAS_particles),'present(GAS_spaces) .eqv. present(GAS_particles)')

  call add_info('Default number of total walkers',[real(totalwalkers,wp)],1,6)
  call add_info('Default number of cycles ',[real(nmcyc,wp)],1,6)
  call add_info('Default value for Time  ',[real(Time,wp)],1,6)

  file_id = isFreeUnit(39)
  call Molcas_Open(file_id,path)

  indentlevel = 0
  write(file_id,A_fmt()) 'Title'
  write(file_id,*)
  write(file_id,A_fmt()) 'System read'
  call indent()
  write(file_id,I_fmt()) 'electrons ',nActEl
  if (tGUGA) then
    write(file_id,A_fmt()) 'nonuniformrandexcits mol_guga_weighted'
  else
    write(file_id,A_fmt()) 'nonuniformrandexcits pchb localised'
  end if
  write(file_id,A_fmt()) 'nobrillouintheorem'
  if (tGUGA) then
    write(file_id,I_fmt()) 'guga',iSpin-1
  else if (iSpin /= 1) then
    write(file_id,I_fmt()) 'spin-restrict',iSpin-1
  end if
  if (present(FCIDUMP_name)) write(file_id,A_fmt()) 'FCIDUMP-name',FCIDUMP_name

  write(file_id,A_fmt()) 'freeformat'
  if (present(GAS_spaces) .and. present(GAS_particles)) then
    nGAS = size(GAS_spaces,1)
    nSym = size(GAS_spaces,2)
    write(file_id,A_fmt()) 'GAS-SPEC '//str(nGAS)//' \'
    call indent()
    do iGAS=1,nGAS
      write(file_id,'('//indent_fmt()//'I0, 1x, I0, 1x, I0, 1x, A)') sum([(GAS_spaces(iGAS,iSym),iSym=1,nSym)]), &
                                                                     GAS_particles(iGAS,1),GAS_particles(iGAS,2),'\'
    end do
    write(file_id,'('//indent_fmt()//')',advance='no')
    do iSym=1,nSym
      do iGAS=1,nGAS
        do i=1,GAS_spaces(iGAS,iSym)
          write(file_id,'(I0, 1x)',advance='no') iGAS
        end do
      end do
    end do
    write(file_id,*)
    call dedent()
  end if
  call dedent()
  write(file_id,A_fmt()) 'endsys'
  write(file_id,*)
  write(file_id,A_fmt()) 'calc'
  call indent()
  if (allocated(DefineDet)) write(file_id,A_fmt()) 'definedet '//trim(definedet)
  write(file_id,*)
  write(file_id,I_fmt()) 'totalwalkers',totalwalkers
  write(file_id,A_fmt()) merge(' ','#',readpops)//'readpops'
  write(file_id,A_fmt()) merge(' ','#',readpops)//'walkcontgrow'
  write(file_id,*)
  write(file_id,I_fmt()) 'semi-stochastic',semi_stochastic
  write(file_id,I_fmt()) 'pops-core',pops_core
  write(file_id,*)
  write(file_id,A_fmt()) 'methods'
  call indent()
  write(file_id,A_fmt()) 'method vertex fcimc'
  call dedent()
  write(file_id,A_fmt()) 'endmethods'
  write(file_id,*)
  write(file_id,R_fmt()) 'diagshift',diagshift
  write(file_id,R_fmt()) 'shiftdamp',shiftdamp
  write(file_id,I_fmt()) 'stepsshift',stepsshift
  write(file_id,A_fmt()) 'jump-shift'
  write(file_id,*)
  write(file_id,I_fmt()) 'nmcyc',nmcyc
  write(file_id,I_fmt()) 'time',time
  write(file_id,*)
  write(file_id,I_fmt()) 'startsinglepart',startsinglepart
  write(file_id,R_fmt()) 'proje-changeref',proje_changeref
  write(file_id,*)

  write(file_id,A_fmt()) 'truncinitiator'
  write(file_id,I_fmt()) 'addtoinitiator ',addtoinitiator
  write(file_id,A_fmt()) 'allrealcoeff'
  write(file_id,R_fmt()) 'realspawncutoff',realspawncutoff

  write(file_id,*)
  write(file_id,A_fmt()) 'tau-values \'
  call indent()
  write(file_id,kw_fmt('F0.2, 1x, A')) 'max',max_tau,'\'
  if (readpops) then
    write(file_id,A_fmt()) 'start from-popsfile'
  else
    write(file_id,A_fmt()) 'start user-defined 0.01'
  end if
  call dedent()

  write(file_id,A_fmt()) 'tau-search \'
  call indent()
  if (tGUGA) then
    write(file_id,A_fmt()) 'algorithm histogramming \'
  else
    write(file_id,A_fmt()) 'algorithm conventional \'
  end if
  write(file_id,A_fmt()) 'stop-condition no-change 500 \'
  write(file_id,R_fmt()) 'maxwalkerbloom',maxwalkerbloom
  call dedent()

  write(file_id,R_fmt()) ''

  write(file_id,R_fmt()) 'memoryfacspawn',memoryfacspawn
  write(file_id,R_fmt()) 'memoryfacpart',memoryfacpart
  write(file_id,I_fmt())
  call dedent()
  write(file_id,A_fmt()) 'endcalc'
  write(file_id,*)
  write(file_id,A_fmt()) 'logging'
  call indent()
  write(file_id,I_fmt()) 'highlypopwrite',Highlypopwrite
  write(file_id,A_fmt()) 'hdf5-pops'
  if (tGUGA) then
    write(file_id,A_fmt()) 'print-molcas-rdms'
  else
    write(file_id,A_fmt()) 'print-spin-resolved-RDMs'
  end if
  write(file_id,A_fmt()) 'printonerdm'
  write(file_id,'('//str(indentlevel)//'x, A,1x,I0,1x,I0,1x,I0)') 'RDMlinspace',RDMsampling%start,RDMsampling%n_samples, &
                                                                  RDMsampling%step
  call dedent()
  write(file_id,A_fmt()) 'endlog'
  write(file_id,A_fmt()) 'end'

  close(file_id)

  contains

    function indent_fmt() result(res)

      character(len=:), allocatable :: res

      if (indentlevel /= 0) then
        res = str(indentlevel)//'x, '
      else
        res = ''
      end if

    end function indent_fmt

    function kw_fmt(value_fmt) result(res)

      character(len=*), intent(in) :: value_fmt
      character(len=:), allocatable :: res

      res = '('//indent_fmt()//'A, 1x, '//value_fmt//')'

    end function kw_fmt

    function I_fmt() result(res)

      character(len=:), allocatable :: res

      res = kw_fmt('I0')

    end function I_fmt

    function R_fmt() result(res)

      character(len=:), allocatable :: res

      res = kw_fmt('F0.2')

    end function R_fmt

    function A_fmt() result(res)

      character(len=:), allocatable :: res

      res = kw_fmt('A')

    end function A_fmt

    subroutine indent()

      indentlevel = indentlevel+indentstep

    end subroutine indent

    subroutine dedent()

      indentlevel = indentlevel-indentstep

    end subroutine dedent

end subroutine make_inp

subroutine cleanup()

  call mma_deallocate(definedet,safe='*')

end subroutine cleanup

end module fciqmc_make_inp

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKDAO(CNO,OCC,DAO)

use mrci_global, only: NBAS, NBAST, NCMO, NSYM
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: CNO(NCMO), OCC(NBAST)
real(kind=wp), intent(out) :: DAO(NBAST,NBAST)
integer(kind=iwp) :: I, IB, IB1, ICNO, ISYM, NB
real(kind=wp) :: X

DAO(:,:) = Zero
IB = 1
ICNO = 1
do ISYM=1,NSYM
  IB1 = IB
  NB = NBAS(ISYM)
  do I=1,NB
    X = OCC(IB)
    call DGER(NB,NB,X,CNO(ICNO),1,CNO(ICNO),1,DAO(IB1,IB1),NBAST)
    IB = IB+1
    ICNO = ICNO+NB
  end do
end do

return

end subroutine MKDAO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine ClsFls_MCLR()
************************************************************************
*                                                                      *
*     Open files.                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "Files_mclr.fh"
#include "sa.fh"
#include "Input.fh"
      Logical DoCholesky
      Integer AixRm
*---------------------------------------------------------------------*
*     Start                                                           *
*---------------------------------------------------------------------*
      If (iMethod.eq.iCASSCF) Then
         Call DaClos(LuCSF2sd)
*------  close the JOBIPH file -------------------------------------------*
         Call DaClos(LuJob)
      End If
      Call DaClos(LuTemp)
*---  close the ORDINT file -------------------------------------------*
      Call DecideonCholesky(DoCholesky)
      If (.NOT.DoCholesky) then
         iRc=-1
         iOpt=0
         Call ClsOrd(iRc,iOpt)
         If ( iRc.ne.0 ) Then
            Write (6,*) 'ClsFls: Error closing ORDINT'
            Call Abend()
         End If
      End If
      Call DaClos(LuTri1)
      If(TwoStep) Then
        Call DaClos(LuQDAT)
        !Call DaClos(LuMOTRA)
      End If
*
*---  Close the MckInt file or Remove the MCKINT file if SA---------------*
*     Do not remove file if we are producing data on the MckInt file for
*     the RASSI module!
*
      If (SA.and..Not.RASSI) Then
*        What the...? No control at all on what file is being removed!
*        call DaEras(LuMck)
         call DaClos(LuMck)
         iRC=AixRM(FnMck)
      Else
         iRc=-1
         iOpt=0
         Call ClsMck(iRc,iOpt)
         If ( iRc.ne.0 ) Then
            Write (6,*) 'ClsFls: Error closing MCKINT'
            Call Abend()
         End If
      End If
*
      Call ipTerm()
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MltMem_GIAO( &
#                      define _CALLING_
#                      include "mem_interface.fh"
                      )

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp), parameter :: nB = 3

nHer = (la+lb+lr+3)/2
Mem = 3*nHer*(la+1)+3*nHer*(lb+1)+3*nHer*(lr+2)+3*(la+1)*(lb+1)*(lr+2)+nTri_Elem1(la)*nTri_Elem1(lb)*nTri_Elem1(lr)*nB

return

end subroutine MltMem_GIAO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NEWSSTAB(ORBTAB)

use rassi_global_arrays, only: SSTAB
use Cntrl, only: MORSBITS
use Symmetry_Info, only: MUL, nIrrep
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ORBTAB(*)
integer(kind=iwp) :: I, IERR, IKMS2, IKSCR, IKSYM, IMS2, IPOP, ISBS, ISBS1, ISBS2, ISBS3, ISBS4, ISBS5, ISBS6, ISBS7, ISBS8, ISCR, &
                     ISGN, ISORB, ISPART, ISSTP, ISYM, ITYPE, J, KMRSSBS, KMS2, KOINFO, KSBSANN, KSBSCRE, KSBSMRS, KSSTANN, &
                     KSSTCRE, KSSTP, KSYM, LPOS, MRS, MS2, MXMS2, MXPOP, N, NASPO, NASPRT, NEWMRS, NEWSBS, NEWSST, NO, NSBS, &
                     NSBSTOT, NSCR, NSSTP, NTAB
integer, external :: MORSANN, MORSCRE, MORSPOP, MORSSPIN, MORSSYMM
integer, allocatable :: NOSUB(:), OSPN(:), OSYM(:), SCR(:), SCR2(:)

! Table type ID:
ITYPE = 19
! Pick up some data from the orbital table:
NASPO = ORBTAB(4)
nIrrep = ORBTAB(5)
NASPRT = ORBTAB(9)
KOINFO = 19
! Make temporary arrays for spin label and symmetry of each orbital
call mma_allocate(OSPN,NASPO,Label='OSPN')
call mma_allocate(OSYM,NASPO,Label='OSYM')
! Make a temporary array, which gives the number of spin orbitals in
! each subpartition:
call mma_allocate(NOSUB,NASPRT,Label='NOSUB')
NOSUB(:) = 0
do ISORB=1,NASPO
  ISYM = OrbTab(KOINFO+1+(ISORB-1)*8)
  OSYM(ISORB) = ISYM
  MS2 = OrbTab(KOINFO+3+(ISORB-1)*8)
  OSPN(ISORB) = MS2
  ISPART = OrbTab(KOINFO+6+(ISORB-1)*8)
  N = 1+NOSUB(ISPART)
  NOSUB(ISPART) = N
end do
! We need a temporary array, NSBSSCR(nIrrep,0:NPOP,-MXMS2:MXMS2,NASPRT),
! to keep the number of substrings of different kind:
MXPOP = MORSBITS
MXMS2 = MORSBITS
NSCR = nIrrep*(1+MXPOP)*(2*MXMS2+1)*NASPRT
call mma_allocate(SCR,NSCR,Label='SCR')
! Addressing will be through the cumbersome formula
! ISCR=ISYM+nIrrep*(IPOP+(1+MXPOP)*(MXMS2+MS2+(2*MXMS2+1)*(ISPART-1)))
! Initialize counter of substrings:
do ISPART=1,NASPRT
  do IMS2=-MXMS2,MXMS2
    do IPOP=0,MXPOP
      do ISYM=1,nIrrep
        ! NSBSSCR(ISYM,IPOP,IMS2,ISPART)=0:
        ISCR = ISYM+nIrrep*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*(ISPART-1)))
        SCR(ISCR) = 0
      end do
    end do
  end do
  ! NSBSSCR(ISYM=1,IPOP=0,IMS2=0,ISPART)=1:
  ISCR = 1+nIrrep*(0+(1+MXPOP)*(MXMS2+0+(2*MXMS2+1)*(ISPART-1)))
  SCR(ISCR) = 1
end do
! Compute number of substrings:
ISORB = 0
do ISPART=1,NASPRT
  NO = NOSUB(ISPART)
  do I=1,NO
    ISORB = ISORB+1
    KSYM = OSYM(ISORB)
    KMS2 = OSPN(ISORB)
    do IPOP=I,1,-1
      do IMS2=-IPOP,IPOP
        IKMS2 = IMS2-KMS2
        if (abs(IKMS2) <= IPOP-1) then
          do ISYM=1,nIrrep
            IKSYM = MUL(ISYM,KSYM)
            ISCR = ISYM+nIrrep*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*(ISPART-1)))
            N = SCR(ISCR)
            IKSCR = IKSYM+nIrrep*(IPOP-1+(1+MXPOP)*(MXMS2+IKMS2+(2*MXMS2+1)*(ISPART-1)))
            N = N+SCR(IKSCR)
            SCR(ISCR) = N
          end do
        end if
      end do
    end do
  end do
end do
NSSTP = 0
NSBSTOT = 0
do ISPART=1,NASPRT
  NO = NOSUB(ISPART)
  do IPOP=0,NO
    do ISYM=1,nIrrep
      do IMS2=-NO,NO
        ISCR = ISYM+nIrrep*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*(ISPART-1)))
        N = SCR(ISCR)
        if (N > 0) then
          NSSTP = NSSTP+1
          NSBSTOT = NSBSTOT+N
        end if
      end do
    end do
  end do
end do
! We finally know the number of substring types and the number of
! substrings. Transfer non-zero entries to the final table.

! Size of table, and offsets:
KSSTP = 15
KSSTANN = KSSTP+5*NSSTP
KSSTCRE = KSSTANN+MORSBITS*NSSTP
KSBSMRS = KSSTCRE+MORSBITS*NSSTP
KMRSSBS = KSBSMRS+2*NSBSTOT
KSBSANN = KMRSSBS+2*(2**MORSBITS)*NASPRT
KSBSCRE = KSBSANN+NSBSTOT*MORSBITS
NTAB = KSBSCRE+NSBSTOT*MORSBITS-1
call mma_allocate(SSTAB,NTAB,Label='SSTAB')
SSTAB(:) = 0
! The header data
SSTAB(1) = NTAB
SSTAB(2) = ITYPE
SSTAB(3) = -1 ! Not used
SSTAB(4) = nIrrep
SSTAB(5) = NASPRT
SSTAB(6) = MORSBITS
SSTAB(7) = NSSTP
SSTAB(8) = NSBSTOT
SSTAB(9) = KSSTANN
SSTAB(10) = KSSTCRE
SSTAB(11) = KSBSMRS
SSTAB(12) = KMRSSBS
SSTAB(13) = KSBSANN
SSTAB(14) = KSBSCRE
! Fill in the Substring Type table
! Change the counter array into an array of offsets. Also allocate
! a translation table (POP,MS2,ISYM) to Substring Type.
call mma_allocate(SCR2,NSCR,Label='SCR2')
ISSTP = 0
ISBS = 0
do ISPART=1,NASPRT
  NO = NOSUB(ISPART)
  do IPOP=0,NO
    do ISYM=1,nIrrep
      do IMS2=-NO,NO
        ISCR = ISYM+nIrrep*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*(ISPART-1)))
        NSBS = SCR(ISCR)
        SCR(ISCR) = -1
        SCR2(ISCR) = -1
        if (NSBS > 0) then
          ISSTP = ISSTP+1
          SCR(ISCR) = ISBS
          SCR2(ISCR) = ISSTP
          ISBS = ISBS+NSBS
          SSTAB(KSSTP+0+5*(ISSTP-1)) = NSBS
          SSTAB(KSSTP+1+5*(ISSTP-1)) = IPOP
          SSTAB(KSSTP+2+5*(ISSTP-1)) = ISYM
          SSTAB(KSSTP+3+5*(ISSTP-1)) = IMS2
          SSTAB(KSSTP+4+5*(ISSTP-1)) = ISPART
        end if
      end do
    end do
  end do
end do

! Now produce all possible substrings:
!TEST write(u6,*) ' Test in NEWSSTAB, producing substrings.'
!TEST write(u6,'(1x,a,8i5)') 'OSYM(ISORB):',(OSYM(ISORB),ISORB=1,NASPO)
!TEST write(u6,'(1x,a,8i5)') 'OSPN(ISORB):',(OSPN(ISORB),ISORB=1,NASPO)
ISORB = 1
do ISPART=1,NASPRT
  NO = NOSUB(ISPART)
  do MRS=0,2**NO-1
    IPOP = MorsPop(MRS)
    ISYM = MorsSymm(MRS,OSYM(ISORB))
    IMS2 = MorsSpin(MRS,OSPN(ISORB))
    ! Which substring is this?
    ISCR = ISYM+nIrrep*(IPOP+(1+MXPOP)*(MXMS2+IMS2+(2*MXMS2+1)*(ISPART-1)))
    ISBS = 1+SCR(ISCR)
    !TEST write(u6,'(1x,a,8i5)') 'MRS,IPOP,IMS2,ISYM,ISBS:',MRS,IPOP,IMS2,ISYM,ISBS
    SCR(ISCR) = ISBS
    ISSTP = SCR2(ISCR)
    ! Fill in the Substring/Morsel translation arrays:
    LPOS = KSBSMRS+2*(ISBS-1)
    SSTAB(LPOS) = MRS
    SSTAB(LPOS+1) = ISSTP
    LPOS = KMRSSBS+2*(MRS+(2**MORSBITS)*(ISPART-1))
    SSTAB(LPOS) = ISBS
    SSTAB(LPOS+1) = ISSTP
  end do
  ISORB = ISORB+NO
end do
call mma_deallocate(SCR)
call mma_deallocate(SCR2)
call mma_deallocate(OSPN)
call mma_deallocate(OSYM)
do ISPART=1,NASPRT
  NO = NOSUB(ISPART)
  do MRS=0,2**NO-1
    LPOS = KMRSSBS+2*(MRS+(2**MORSBITS)*(ISPART-1))
    ISBS = SSTAB(LPOS)
    ISSTP = SSTAB(LPOS+1)
  end do
end do

! Create the Substring Annihilator and Creator arrays, and
! also Substring Type Ann/Cre arrays.
!TEST write(u6,*) ' Making annih and creat arrays:'
do ISPART=1,NASPRT
  NO = NOSUB(ISPART)
  do MRS=0,2**NO-1
    LPOS = KMRSSBS+2*(MRS+(2**MORSBITS)*(ISPART-1))
    ISBS = SSTAB(LPOS)
    ISSTP = SSTAB(LPOS+1)
    do I=1,NO
      NEWMRS = MORSANN(MRS,I)
      if (NEWMRS /= 999999) then
        ISGN = 1
        if (NEWMRS < 0) ISGN = -1
        NEWMRS = ISGN*NEWMRS
        ! Position in Morsel-to-Substring Table
        LPOS = KMRSSBS+2*(NEWMRS+(2**MORSBITS)*(ISPART-1))
        ! New substring times sign factor
        NEWSBS = ISGN*SSTAB(LPOS)
        NEWSST = SSTAB(LPOS+1)
        ! Put new substring in the table
        LPOS = KSBSANN-1+I+MORSBITS*(ISBS-1)
        SSTAB(LPOS) = NEWSBS
        ! Put new substring type in the Substring Type Annihil Table
        LPOS = KSSTANN-1+I+MORSBITS*(ISSTP-1)
        SSTAB(LPOS) = NEWSST
      end if
    end do
    ! Create: Very similar to the Annihilate code above.
    do I=1,NO
      NEWMRS = MORSCRE(MRS,I)
      if (NEWMRS /= 999999) then
        ISGN = 1
        if (NEWMRS < 0) ISGN = -1
        NEWMRS = ISGN*NEWMRS
        ! Position in Morsel-to-Substring Table
        LPOS = KMRSSBS+2*(NEWMRS+(2**MORSBITS)*(ISPART-1))
        ! New substring times sign factor
        NEWSBS = ISGN*SSTAB(LPOS)
        NEWSST = SSTAB(LPOS+1)
        ! Put new substring in the table
        LPOS = KSBSCRE-1+I+MORSBITS*(ISBS-1)
        SSTAB(LPOS) = NEWSBS
        ! Put new substring type in the Substring Type Creat Table
        LPOS = KSSTCRE-1+I+MORSBITS*(ISSTP-1)
        SSTAB(LPOS) = NEWSST
      end if
    end do
  end do
end do

! Test section, may be removed later..
if (.false.) then
  ! For all strings, check the anticommutation rules.
  IERR = 0
  do ISBS=1,NSBSTOT
    ! Its substring type
    LPOS = KSBSMRS+2*(ISBS-1)
    ISSTP = SSTAB(LPOS+1)
    ! Its subpartition
    ISPART = SSTAB(KSSTP+4+5*(ISSTP-1))
    NO = NOSUB(ISPART)
    do I=1,NO
      ! Annihilate orbital nr I in the subpartition.
      LPOS = KSBSANN-1+I+MORSBITS*(ISBS-1)
      ISBS1 = SSTAB(LPOS)
      ! Create orbital nr I in the subpartition.
      LPOS = KSBSCRE-1+I+MORSBITS*(ISBS-1)
      ISBS2 = SSTAB(LPOS)
      if ((ISBS1 /= 0) .and. (ISBS2 /= 0)) IERR = IERR+1
      if ((ISBS1 == 0) .and. (ISBS2 == 0)) IERR = IERR+1
      do J=1,I
        ! Same, for orbital J instead.
        LPOS = KSBSANN-1+J+MORSBITS*(ISBS-1)
        ISBS3 = SSTAB(LPOS)
        LPOS = KSBSCRE-1+J+MORSBITS*(ISBS-1)
        ISBS4 = SSTAB(LPOS)
        ! SBS5=A(I-)*SBS4:
        ISBS5 = 0
        if (ISBS4 /= 0) then
          ISGN = 1
          if (ISBS4 < 0) ISGN = -1
          LPOS = KSBSANN-1+I+MORSBITS*(abs(ISBS4)-1)
          ISBS5 = ISGN*SSTAB(LPOS)
        end if
        ! SBS6=A(J+)*SBS1:
        ISBS6 = 0
        if (ISBS1 /= 0) then
          ISGN = 1
          if (ISBS1 < 0) ISGN = -1
          LPOS = KSBSCRE-1+J+MORSBITS*(abs(ISBS1)-1)
          ISBS6 = ISGN*SSTAB(LPOS)
        end if
        ! SBS7=A(I+)*SBS3:
        ISBS7 = 0
        if (ISBS3 /= 0) then
          ISGN = 1
          if (ISBS3 < 0) ISGN = -1
          LPOS = KSBSCRE-1+I+MORSBITS*(abs(ISBS3)-1)
          ISBS7 = ISGN*SSTAB(LPOS)
        end if
        ! SBS8=A(J-)*SBS2:
        ISBS8 = 0
        if (ISBS2 /= 0) then
          ISGN = 1
          if (ISBS2 < 0) ISGN = -1
          LPOS = KSBSANN-1+J+MORSBITS*(abs(ISBS2)-1)
          ISBS8 = ISGN*SSTAB(LPOS)
        end if
        ! Now check:
        if (I /= J) then
          if (ISBS5+ISBS6 /= 0) IERR = IERR+1
          if (ISBS7+ISBS8 /= 0) IERR = IERR+1
        else
          if (ISBS5+ISBS6 /= ISBS) IERR = IERR+1
          if (ISBS7+ISBS8 /= ISBS) IERR = IERR+1
        end if
      end do
    end do
  end do
  write(u6,*) ' NEWSSTAB: Nr of test errors IERR=',IERR
end if

call mma_deallocate(NOSUB)

end subroutine NEWSSTAB

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine gugadrt(ireturn)
#include "gendrt.fh"
      data istep_occ/0,1,1,2/
      data mul_tab/1,2,3,4,5,6,7,8,
     *             2,1,4,3,6,5,8,7,
     *             3,4,1,2,7,8,5,6,
     *             4,3,2,1,8,7,6,5,
     *             5,6,7,8,1,2,3,4,
     *             6,5,8,7,2,1,4,3,
     *             7,8,5,6,3,4,1,2,
     *             8,7,6,5,4,3,2,1/
      sc0=seconds()

      call gugainit()

      call gugadrt_mole_inf()
      call gugadrt_paras_calculate()
      call arrange_orbital_molcas()

      call gugadrt_dbl_upwalk()       ! add by wyb 01.9.5
      call gugadrt_ext_downwalk()       ! add by wyb 01.9.5
      call gugadrt_active_drt()        ! add by wyb 01.9.5

      call add_info("CI_DIM",[dble(nci_dim)],1,1)
      call gugadrt_gugafinalize()
      ireturn=0

      sc1=seconds()
      sc=sc1-sc0
      write(6,910) sc
      return
910   format(/,1x,"end of job, takes ",f10.2,1x,"seconds"/)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gather_t2anti_blocked(length1,length2,ngbf,ngbl,t2,t2_tmp,tmp)
! length1 = length of the 1st VO index (nv)
! length2 = length of the 2nd VO index (=< vblock)
!
! This routine generates T2 amplitudes in this form :
!
! T2 = t2(a,b,j<i) - t2(b,a,j<i) finaly : <a,b,(i<j) >  ;  a in nv, b in vblock

use ChT3_global, only: DimGrpaR, LunAux, no, NvGrp, T2Name
use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: length1, length2, ngbf, ngbl
real(kind=wp), intent(inout) :: t2(*)
real(kind=wp), intent(_OUT_) :: t2_tmp(*), tmp(*)
integer(kind=iwp) :: a, a_tmp, aa, b, b_tmp, bb, dima, dimb, lasta, lastb, length
logical(kind=iwp) :: switch

!mp write(u6,*)
!mp write(u6,*) '------ DimGrpaR ------'
!mp write(u6,'(8(i5,2x))') (DimGrpaR(a_tmp),a_tmp=1,NvGrp)
!mp write(u6,*)

do a=1,NvGrp
  do b=ngbf,ngbl

    switch = .false.
    if (a >= b) then
      aa = a
      bb = b
    else
      aa = b
      bb = a
      switch = .true.
    end if

    dima = DimGrpaR(aa)
    dimb = DimGrpaR(bb)

    if (aa == bb) then  ! aa=bb
      length = nTri_Elem(dima)*no*no
      call GetX_t3(tmp,length,LunAux,T2Name(aa,bb),1,1)
    else ! aa>bb
      length = dima*dimb*no*no
      call GetX_t3(tmp,length,LunAux,T2Name(aa,bb),1,1)
    end if

    lasta = 0
    if (a > 1) then
      do a_tmp=1,a-1
        lasta = lasta+DimGrpaR(a_tmp)
      end do
    end if

    lastb = 0
    if (b > ngbf) then
      do b_tmp=ngbf,b-1
        lastb = lastb+DimGrpaR(b_tmp)
      end do
    end if

    !mp write(u6,'(A,2(i5,2x),L,2(i3,x))') 'lasta, lastb, switch, a, b = ',lasta,lastb,switch,a,b

    if (aa == bb) then ! expand tmp
      call expand4_12(tmp,t2_tmp,dima,no,no)
      call grow_t2anti_blocked1(t2,t2_tmp,dima,dimb,no,lasta,lastb,length1,length2)
    else
      if (.not. switch) then
        call grow_t2anti_blocked1(t2,tmp,dima,dimb,no,lasta,lastb,length1,length2)
      else
        call grow_t2anti_blocked2(t2,tmp,dima,dimb,no,lasta,lastb,length1,length2)
      end if
    end if

  end do
end do

return

end subroutine gather_t2anti_blocked

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,1995, Roland Lindh                                *
************************************************************************
      Subroutine C2DIIS(q,nInter,nIter,dq,H,g,error,B,RHS,
     &                  Scrt1,nScrt1,nFix,iP,iOptC)
************************************************************************
*                                                                      *
*         References:                                                  *
*           C2-DIIS: Sellers, Int. J. Quantum Chem. 45, 31-41(1993).   *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             December '94                                             *
*                                                                      *
*             Modified for anharmonic constants by R. Lindh, Oct. '95  *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 q(nInter,nIter+1), dq(nInter,nIter),
     &       H(nInter,nInter), g(nInter,nIter+1),
     &       error(nInter,nIter+1), B((nIter+1)*(nIter+1)),
     &       RHS(nIter+1), Scrt1(nScrt1)
      Integer   iP(nIter), iRc
      Logical Fail
*
*     Statement function
*
      ij(i,j,lda)= (j-1)*lda + i
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*
      iRout = 121
      iPrint = nPrint(iRout)
*
      Call FZero(Error,nInter*(nIter+1))
*
      Call Allocate_Work(ipA,nInter**2)
      call dcopy_(nInter**2,H,1,Work(ipA),1)
      iRc = 0
      call dpotrf_('U',nInter,Work(ipA),nInter,iRC)
      If (iRC.ne.0) Then
         Write (6,*) 'C2DIIS(DPOTRF): iRC=',iRC
         Call Abend()
      End If

*
*-----Compute the new set of error vectors. Here we have two
*     possibilities depending on if we use a 2nd or 3rd order
*     update method.
*
*     Note!!!!
*
*     i)  We store the force in g Not the gradient
*
*     ii) e is the displacement which should be added to the
*         current position to get to the equilibrium geometry.
*
*        r  = r   + e      e   =r  - r
*         eq   i-1   i-1    i-1  eq   i-1
*
*     Compute:
*        r  = r + e        e =r  - r
*         eq   i   i        k  eq   k
*
      If (iAnd(iOptC,16).eq.16 .or.
     &    iAnd(iOptC,32).eq.32) Then
         Call ThrdO(nInter,g(1,nIter),Work(ipA),Error(1,nIter),Fail)
         If (Fail) Then
            Call WarningMessage(2,'C2Diis: ThrdO Failed!')
            Call Quit_OnConvError()
         End If
         Do iIter = 1, nIter-1
            Do iInter = 1, nInter
               Error(iInter,iIter)=Error(iInter,nIter)
     &                            +q(iInter,nIter)-q(iInter,iIter)
            End Do
         End Do
      End If
      If (iPrint.ge.99) Call RecPrt(' Error vectors',' ',
     &    error,nInter,nIter)
*
*-----Set up small system of linear equations
*     If more error vectors than degrees of freedom
*     exclude those with large error.
*
      Do i = 1, nIter
         iP(i) = i
      End Do
*
*-----Bubble sort index array with respect to the magnitude of
*
*     <g|g>
*     <g|dx>
*     <dx|g>
*     <dx|dx>
*
      Do i = Max(1,nIter-11), nIter-1
         If (iAnd(iOptC,16).eq.16) Then
            Err1 = DDot_(nInter,Error(1,iP(i)),1,Error(1,iP(i)),1)
         Else If (iAnd(iOptC,32).eq.32) Then
            Err1 = DDot_(nInter,g(1,iP(i)),1,Error(1,iP(i)),1)
         Else If (iAnd(iOptC,64).eq.64) Then
            Err1 = DDot_(nInter,g(1,iP(i)),1,g(1,iP(i)),1)
         Else
            Err1=Zero
            Call WarningMessage(2,' Illegal iOptC setting!')
            Call Quit_OnUserError()
         End If
         ii = i
         Do j = i+1, nIter
            If (iAnd(iOptC,16).eq.16) Then
               Err2 = DDot_(nInter,Error(1,iP(j)),1,Error(1,iP(j)),1)
            Else If (iAnd(iOptC,32).eq.32) Then
               Err2 = DDot_(nInter,g(1,iP(j)),1,Error(1,iP(j)),1)
            Else If (iAnd(iOptC,64).eq.64) Then
               Err2 = DDot_(nInter,g(1,iP(j)),1,g(1,iP(j)),1)
            Else
               Err2=Zero
               Call WarningMessage(2,' Illegal iOptC setting!')
               Call Quit_OnUserError()
            End If
            If (Err2.gt.Err1) Then
               ii = j
               Err1 = Err2
            End If
         End Do
         If (ii.ne.i) Then
            iSave = iP(i)
            iP(i) = iP(ii)
            iP(ii) = iSave
         End If
      End Do
      If (iPrint.ge.99) Write (6,*) ' iP=',iP
*
*     MaxWdw=Max(3,3*(nInter-nFix)/4)
      MaxWdw=Max(3,(nInter-nFix)/2)
      MinWdw=Min(5,MaxWdw)
      mIter=Min(nIter,MinWdw)
      iOff = Max(0,nIter-mIter)
      Thrhld = 0.1D-13
      ThrCff = (Two*Ten)**2
      ThrLdp = Ten**3
      Do i = 1, mIter
         Do j = 1, i
            If (iAnd(iOptC,16).eq.16) Then
               B(iTri(i,j)) = DDot_(nInter,Error(1,iP(i+iOff)),1,
     &                                    Error(1,iP(j+iOff)),1)
            Else If (iAnd(iOptC,32).eq.32) Then
               B(iTri(i,j)) = DDot_(nInter,Error(1,iP(i+iOff)),1,
     &                                        g(1,iP(j+iOff)),1)
            Else If (iAnd(iOptC,64).eq.64) Then
               B(iTri(i,j)) = DDot_(nInter,    g(1,iP(i+iOff)),1,
     &                                        g(1,iP(j+iOff)),1)
            Else
               Call WarningMessage(2,' Illegal iOptC setting!')
               Call Quit_OnUserError()
            End If
         End Do
      End Do
      If (iPrint.ge.99) Call TriPrt(' The B Matrix',' ',B,mIter)
      call dcopy_(mIter**2,[Zero],0,Scrt1,1)
      call dcopy_(mIter,[One],0,Scrt1,mIter+1)
      Call NIDiag_new(B,Scrt1,mIter,mIter,0)
      If (iPrint.ge.99) Then
         Call TriPrt(' The B Matrix after diagonalization','(9E10.2)',
     &                B,mIter)
         Call RecPrt(' Eigenvectors','(9E10.2)',Scrt1,mIter,mIter)
      End If
*
*-----Renormalize the eigenvectors and eigenvalues to the
*     C1-DIIS format.
*
      Do iVec = 1, mIter
         Alpha = Zero
         Do i = 1, mIter
            Alpha = Alpha + Scrt1(ij(i,iVec,mIter))
         End Do
         Alpha = One/Alpha
         Call DScal_(mIter,Alpha,Scrt1(ij(1,iVec,mIter)),1)
         B(iTri(iVec,iVec)) = B(iTri(iVec,iVec)) * Alpha**2
      End Do
      If (iPrint.ge.99) Then
         Write (6,*) ' After normalization to C1-DIIS format'
         Call TriPrt(' The B Matrix after diagonalization','(9E10.2)',
     &              B,mIter)
         Call RecPrt(' Eigenvectors',' ',Scrt1,mIter,mIter)
      End If
*
*-----------Select a vector.
*
      ee_old = 1.0D+72
      c2_old = 1.0D+72
      iVec_old = -99999999
      Do iVec = 1, mIter
         If (iPrint.ge.99) Write (6,*) ' Scanning vector',iVec
         ee_new = B(iTri(iVec,iVec))
         If (iPrint.ge.99) Write (6,*)
     &           ' ee_old, ee_new=',ee_old, ee_new
*
*--------Examine if <e|e> is too low (possible round-off) or
*        linear dependency.
*
         If (ee_new.lt.Thrhld) Then
            If (iPrint.ge.99) Write (6,*)
     &         ' <e|e> is low in DIIS, iVec,<e|e>=',iVec,ee_new
*
*--------Reject if coefficients are too large (linear dep.).
*
            c2_new = DDot_(mIter,Scrt1(ij(1,iVec,mIter)),1,
     &                          Scrt1(ij(1,iVec,mIter)),1)
            If (c2_new.gt.ThrCff) Then
               If (iPrint.ge.99) Write (6,*)
     &            ' c**2 is too large in DIIS, iVec,c**2=',iVec,c2_new
                Go To 10
             End If
         End If
*
*--------Reject if coefficients are by far too large (linear dep.).
*
         c2_new = DDot_(mIter,Scrt1(ij(1,iVec,mIter)),1,
     &                   Scrt1(ij(1,iVec,mIter)),1)
         If (c2_new.gt.ThrLdp) Then
            If (iPrint.ge.99) Write (6,*)
     &         ' c**2 is too large in DIIS, iVec,c**2=',iVec,c2_new
            Go To 10
         End If
*
*--------Keep the best candidate
*
         If (ee_new*Five.lt.ee_old) Then
*-----------New vector much lower eigenvalue.
            c2_old=c2_new
            ee_old=ee_new
            iVec_old=iVec
            If (iPrint.ge.99) Write (6,*)
     &          'New vector much lower eigenvalue',iVec_old
         Else If (ee_new.le.ee_old*Five) Then
*-----------New vector is close to the old vector.
*           Selection based on relative weight of the last
*           geometry.
            If (iPrint.ge.99) Write (6,*)
     &          'Eigenvalues are close',iVec_old,iVec
            t1=Abs(Scrt1(ij(mIter,iVec_old,mIter)))/Sqrt(c2_old)
            t2=Abs(Scrt1(ij(mIter,iVec,    mIter)))/Sqrt(c2_new)
            If (t2.gt.t1*1.2d0) Then
*--------------New vector much better relative weight.
               c2_old=c2_new
               ee_old=ee_new
               iVec_old=iVec
               If (iPrint.ge.99) Write (6,*)
     &            'New vector much better relative weight',iVec_old
            Else If (t2*1.2d0.lt.t1) Then
*--------------Vectors are close in relative weight too!
*              Select on eigenvalue only
               If (iPrint.ge.99) Write (6,*)
     &            'Relative weights are close',iVec_old,iVec
               If (ee_new.lt.ee_old) Then
                  c2_old=c2_new
                  ee_old=ee_new
                  iVec_old=iVec
                  If (iPrint.ge.99) Write (6,*)
     &               'New vector has lower eigenvalue',iVec_old
               End If
            End If
         End If
*
 10      Continue
      End Do
      If (iVec_old.lt.1 .or. iVec_old.gt.mIter) Then
         Call WarningMessage(2,
     &               ' No proper solution found in C2-DIIS!')
         Call Abend()
      End If
      call dcopy_(mIter,Scrt1(ij(1,iVec_old,mIter)),1,RHS,1)
*
      If (iPrint.ge.99) Then
         Write (6,*) ' Selecting root',iVec_old
         Call RecPrt(' The solution vector',' ',RHS,1,mIter)
      End If
*
*-----Compute the interpolated parameter vector and
*     the interpolated gradient vector.
*
      call dcopy_(nInter,[Zero],0,q(1,nIter+1),1)
      call dcopy_(nInter,[Zero],0,g(1,nIter+1),1)
      call dcopy_(nInter,[Zero],0,Scrt1,1)
      Do iIter = 1, mIter
*
         If (Abs(RHS(iIter)).lt.1.0D-12) Go To 11
*
         Call DaXpY_(nInter,RHS(iIter),Error(1,iP(iIter+iOff)),1,
     &              Scrt1,1)
*
*------- The interpolated parameter vector is computed as a
*        simple linear combination
*
         Call DaXpY_(nInter,RHS(iIter),q(1,iP(iIter+iOff)),1,
     &              q(1,nIter+1),1)
*
*------- The interpolated gradient vector (Stored as force)
*
*        Sum(i) c  g                 (Coeffs stored in RHS)
*                i  i
*
         Call DaXpY_(nInter,RHS(iIter),g(1,iP(iIter+iOff)),1,
     &              g(1,nIter+1),1)
*
 11      Continue
      End Do

      If (iPrint.ge.99) Then
         Call RecPrt(' The iev',' ',Scrt1,1,nInter)
         Call RecPrt(' The ipv',' ',q(1,nIter+1),1,nInter)
         Call RecPrt(' The igv',' ',g(1,nIter+1),1,nInter)
      End If
*
*-----Compute a new independent geometry by relaxation of
*     the interpolated gradient vector.
*
      call dcopy_(nInter,g(1,nIter+1),1,dq(1,nIter),1)
      iRc = 0
      Call DPOTRS('U',nInter,1,Work(ipA),nInter,dq(1,nIter),nInter,iRC)
      If (iRC.ne.0) Then
         Write (6,*) 'C2DIIS(DPOTRS): iRC=',iRC
         Call Abend()
      End If
      If (iPrint.ge.99) Call RecPrt(' dq',' ',dq(1,nIter),1,nInter)
*
*     The shift is relative to the interpolated parameter
*     vector and we have to change it so that it is relative to the
*     actual parameter vector.
*
      Do iInter = 1, nInter
         dq(iInter,nIter) =  dq(iInter,nIter) + q(iInter,nIter+1) -
     &                                          q(iInter,nIter  )
      End Do
      If (iPrint.ge.99) Call RecPrt(' dq(corr.)',' ',
     &   dq(1,nIter),1,nInter)
*
      Call Free_Work(ipA)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKSH()
! For completeness, even case H has formally S and B
! matrices. This costs nothing, and saves conditional
! looping, etc in the rest  of the routines.

use caspt2_module, only: NINDEP, NSYM
use caspt2_global, only: LUSBT
use EQSOLV, only: IDSMAT
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: ICASE, IDISK, ISYM, NIN
real(kind=wp) :: Dum(1)

DUM(1) = One
do ISYM=1,NSYM
  do ICASE=12,13
    NIN = NINDEP(ISYM,ICASE)
    if (NIN > 0) then
      IDISK = IDSMAT(ISYM,ICASE)
      call DDAFILE(LUSBT,1,DUM,1,IDISK)
    end if
  end do
end do

end subroutine MKSH

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine printtim(nfld1,nfld2)
      implicit real*8 (a-h,o-z)
#include "timtra.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
      iout=6
      iPL=iPrintLevel(-1)
      If (iPL.le.2) Return
c
      write(iout,*)
      call CollapseOutput(1,'Timing information')
      write(iout,*)
      if(nfld1.gt.0) then
        m=nfld_tim*2
        l=nprocs*m
        call gadgop(work(igatim),l,'+')
        write(iout,1)
1       format(/' CPU times:')
        do iproc=0,nprocs-1,10
          n=min(10,nprocs-iproc)
          write(iout,5) (k, k=iproc+1,iproc+n)
5         format(t20,10i10)
          ioff=(igatim-1)+iproc*m
          do j=1,min(nfld_tim,nfld1)
            if(namfld(j).ne.' ') then
             write(iout,10) namfld(j),(work(ioff+j+k*m),k=0,n-1)
            end if
10          format(1x,a20,t21,10f10.2)
          end do
          ioff=ioff+n*m
        end do
        write(iout,11)
11      format(/' Elapsed times:')
        do iproc=0,nprocs-1,10
          n=min(10,nprocs-iproc)
          write(iout,5) (k,k=iproc+1,iproc+n)
          ioff=(igatim-1)+iproc*m+nfld_tim
          do j=1,min(nfld_tim,nfld1)
            if(namfld(j).ne.' ') then
            write(iout,10) namfld(j),(work(ioff+j+k*m),k=0,n-1)
            end if
          end do
          ioff=ioff+n*m
        end do
        call fzero(work(igatim),l)
      end if
      if(nfld2.gt.0) then
        m=nfld_stat
        l=nprocs*m
        call gadgop(work(igastat),l,'+')
        write(iout,12)
12      format(/' Task statistic:')
        do iproc=0,nprocs-1,10
          n=min(10,nprocs-iproc)
          write(iout,5) (k, k=iproc+1,iproc+n)
          ioff=(igastat-1)+iproc*m
          do j=1,min(nfld2,nfld_stat)
            if(namstat(j).ne.' ') then
             write(iout,15) namstat(j),(work(ioff+j+k*m),k=0,n-1)
            end if
15          format(1x,a20,t22,10f10.0)
          end do
          ioff=ioff+n*m
        end do
        call fzero(work(igastat),l)
      end if
      call CollapseOutput(0,'Timing information')
      write(iout,*)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE COPVCD(LUIN,LUOUT,SEGMNT,IREW,LBLK)
C
C COPY VECTOR ON FILE LUIN TO FILE LUOUT
C
C
C LBLK DEFINES STRUCTURE OF FILE
*
* Structure of output file is inherited by output file,
* if input file is packed, so is output file
*
*
C Type of file LUOUT is inherited from LUIN
      IMPLICIT REAL*8(A-H,O-Z)
#include "io_util.fh"
      DIMENSION SEGMNT(*),LBL(1),IDUMMY(1)
C
      IF( IREW .NE. 0 ) THEN
        IDISK(LUIN)=0
        IDISK(LUOUT)=0
      END IF

C
C LOOP OVER BLOCKS
C
C?      write(6,*) ' COPVCD LBLK : ', LBLK
 1000 CONTINUE
        IF(LBLK .GT. 0 ) THEN
          LBL(1) = LBLK
        ELSE IF ( LBLK .EQ. 0 ) THEN
          CALL IDAFILE(LUIN,2,LBL,1,IDISK(LUIN))
          CALL IDAFILE(LUOUT,1,LBL,1,IDISK(LUOUT))
C?        write(6,*) ' COPVCD LBL : ', LBL(1)
        ELSE IF  (LBLK .LT. 0 ) THEN
          CALL IDAFILE(LUIN,2,LBL,1,IDISK(LUIN))
          CALL IDAFILE(LUIN,2,IDUMMY,1,IDISK(LUIN))
          CALL IDAFILE(LUOUT,1,LBL,1,IDISK(LUOUT))
          CALL IDAFILE(LUOUT,1,[-1],1,IDISK(LUOUT))
        END IF
        IF( LBL(1) .GE. 0 ) THEN
          IF(LBLK .GE.0 ) THEN
            KBLK = LBL(1)
          ELSE
            KBLK = -1
          END IF
C?        write(6,*) ' LBL and KBLK ', LBL(1),KBLK
          NO_ZEROING = 1
          CALL FRMDSC2(  SEGMNT,  LBL(1),    KBLK,    LUIN,  IMZERO,
     &                  IAMPACK,NO_ZEROING)
          IF(IAMPACK.NE.0) THEN
C?          WRITE(6,*) ' COPVCD, IAMPACK,FILE = ', IAMPACK,LUIN
          END IF
          IF(IMZERO.EQ.0) THEN
            IF(IAMPACK.EQ.0) THEN
              CALL TODSC (SEGMNT,LBL(1),KBLK,LUOUT)
            ELSE
              CALL TODSCP(SEGMNT,LBL(1),KBLK,LUOUT)
            END IF
          ELSE
            CALL ZERORC(LBL(1),LUOUT,IAMPACK)
          END IF
        END IF
      IF( LBL(1) .GE. 0 .AND. LBLK .LE. 0 ) GOTO 1000
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1986, Bernd Artur Hess                            *
!***********************************************************************

function PHI(M,N)

use crelop, only: GA
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: PHI
integer(kind=iwp), intent(in) :: M, N

if ((mod(N,2) == 1) .or. (mod(M,2) == 1)) then
  PHI = Zero
else
  PHI = Two*GA(M+1)*GA(N+1)/GA(M+N+2)
end if

return

end function PHI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Chck_Th(T2)
! check T2 = T2(a,b,j_b,u_a)

use Index_Functions, only: nTri_Elem
use chcc_global, only: no, nv, T1c, T2c
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: T2(nTri_Elem(nv),no,no)
integer(kind=iwp) :: a, ab, b, bad, j, u
real(kind=wp) :: s

bad = 0

do u=1,no
  do j=1,no
    ab = 0
    do a=1,nv
      do b=1,a
        ab = ab+1

        s = T2c(a,b,j,u)+T1c(a,j)*T1c(b,u)

        if (abs(T2(ab,j,u)-s) > 1.0e-10_wp) then
          T2(ab,j,u) = s
          bad = bad+1
        end if

      end do
    end do
  end do
end do

write(u6,*) ' T2  Chck :',bad

return

end subroutine Chck_Th

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SupSym(FrcCrt,nsAtom,cMass,Coor,nSupSy,Idntcl,iAtom)
      Implicit Real*8 (a-h,o-z)
************************************************************************
*                                                                      *
*     Object: To constrain forces to higher symmetry.                  *
*                                                                      *
************************************************************************
#include "real.fh"
*
*           --- global arrays ---
*
      Real*8 FrcCrt(3,nsAtom), cMass(3), Coor(3,nsAtom)
      Integer   Idntcl(nSupSy), iAtom(nsAtom)
*
*         --- local arrays ---
*
      Real*8 E(3)
*
*
*     Loop over groups of centers which are identical.
*
      K = 0
      Do 10 I = 1, nSupSy
         FORCE = Zero
*
*        loop over centers which are identical.
*
         IDIV = 0
         Do 15 J = 1, Idntcl(I)
            K = K + 1
*           Get the number of this center
            ICEN = iAtom(K)
*
*           Get an unit vector in the direction from center of mass to
*           the ICEN'th center.
*
            E2 = Zero
            Do 20 L = 1, 3
               E(L) = Coor(L,ICEN) - cMass(L)
               E2 = E2 + E(L)*E(L)
20          Continue
            ABSE = SQRT(E2)
*           Normalize the vector.
            Do 25 L = 1, 3
               E(L) = E(L) / ABSE
25          Continue
*
*           Project the force of the ICEN'th center on this unit vector
*
            PROJ = DDot_(3,E,1,FrcCrt(1,ICEN),1)
*
*           Sum forces which should be equal
            FORCE = FORCE + PROJ * DBLE(iDeg(Coor(1,iCen)))
            IDIV = IDIV + iDeg(Coor(1,iCen))
*
*           Save the unit vector of the new force of this center
*
            Do 30 L = 1, 3
               FrcCrt(L,ICEN) = E(L)
30          Continue
15       Continue
*
*        Get the new force
         FORCE = FORCE / DBLE(IDIV)
         K = K - Idntcl(I)
*
*        Symmetrize the forces
*
         Do 35 J = 1, Idntcl(I)
            K = K + 1
            ICEN = iAtom(K)
*
            Do 40 L = 1, 3
               FrcCrt(L,ICEN) = FrcCrt(L,ICEN) * FORCE
40          Continue
35       Continue
10    Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
*               2009, Francesco Aquilante                              *
************************************************************************
      SubRoutine CD_InCore_1p_w(X,n,Wg,Vec,MxVec,NumCho,Thr,ThrNeg,
     &                          ThrFail,iD,irc)
C
C Author:   F. Aquilante, March 2009
C
C Snicked from CD_InCore_1 :
C
C     Thomas Bondo Pedersen, October 2004.
C
C     Purpose: Cholesky decompose the n-by-n matrix X,
C              using as pivot array the weighted diagonals.
C              Vectors are returned in Vec array.
C
C     Return code (irc):
C
C        0 -- decomposition success.
C      101 -- negative diagonal encountered (i.e. < ThrFail)
C      102 -- number of vectors needed exceeds max. allowed (MxVec)
C
C     Note: the algorithm is designed for incomplete Cholesky
C     decomposition, i.e. for semi-definitive matrices, and thus makes
C     use of level-1 BLAS only.
C
C     Features: In     argument wg(n), weights of the diagonal elemets.
C               In/Out argument iD(MxVec).
C                     iD(k) on exit contains the index of the diagonal
C                     from which the k-th Cholesky vector was generated
C
      Implicit None
      Integer n, MxVec, NumCho, irc
      Real*8  X(n,n), Wg(n), Vec(n,MxVec)
      Real*8  Thr, ThrNeg, ThrFail
      Integer iD(MxVec)

      Integer i, imax, j
      Integer iPass
      Real*8  Xmax, Factor, xFac, Acc

      irc = 0

      NumCho = 0
      Acc=Min(1.0D-12,thr*1.0D-2)
      xFac = 0.0D0  ! dummy set
      Do iPass = 1,n

         If (X(1,1)*Wg(1) .lt. ThrNeg) Then
            If (X(1,1)*Wg(1) .lt. ThrFail) Then
               irc = 101
               Return
            Else
               Do j = 1,n
                  X(j,1) = 0.0d0
                  X(1,j) = 0.0d0
               End Do
            End If
         End If
         Xmax = 0.0D0
         imax = 1 ! avoid that Wg(imax) below is out of bounds
         Do i = 1,n
            If (X(i,i)*Wg(i) .lt. ThrNeg) Then
               If (X(i,i)*Wg(i) .lt. ThrFail) Then
                  irc = 101
                  Return
               Else
                  Do j = 1,n
                     X(j,i) = 0.0d0
                     X(i,j) = 0.0d0
                  End Do
               End If
            End If
            If (X(i,i)*Wg(i) .gt. Xmax+Acc) Then
               Xmax = X(i,i)
               imax = i
            End If
         End Do

         If (Xmax*Wg(imax) .le. Thr) Return ! converged
         xFac = 1.0d0/sqrt(abs(Xmax))

         If (NumCho .eq. MxVec) Then ! too many vectors
            irc = 102
            Return
         End If

         Do j = 1,NumCho
            Factor = -Vec(imax,j)
            Call dAXPY_(n,Factor,Vec(1,j),1,X(1,imax),1)
         End Do
         X(imax,imax) = Xmax

         NumCho = NumCho + 1
         Do i = 1,n
            If (X(i,i) .eq. 0.0d0) Then
               Vec(i,NumCho) = 0.0d0
            Else
               Vec(i,NumCho) = xFac*X(i,imax)
            End If
         End Do

         Do i = 1,n
            X(i,i) = X(i,i) - Vec(i,NumCho)**2
         End Do
         X(imax,imax) = 0.0d0
         iD(NumCho) = imax

      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      function len_trim_cvb(a)
c  Length of string excluding trailing blanks
      implicit real*8(a-h,o-z)
      character*(*) a

      do 100 i=len(a),1,-1
      if(a(i:i).ne.' ')goto 200
100   continue
      i=0
200   len_trim_cvb=i
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!               2023, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine RdVec_Localisation(nSym,nBas,nOrb,IndT,CMO,Occ,EOrb,FName)
! Thomas Bondo Pedersen, July 2010.
!
! Read orbital info and return in a format suitable for module
! localisation: deleted orbitals are included (as zeros). This is a
! work-around to fix bugs when orbitals are deleted.

! nSym: number of irreps
! nBas: number of basis functions
! nOrb: number of orbitals
! IndT: type indices, dim: nBas
! CMO: MO coefficients, dim: nBas*nBas
! Occ: Occupation numbers, dim: nBas
! EOrb: dim: nBas
! FName: filename with input orbitals

#include "intent.fh"

use Localisation_globals, only: fileorb_id, isHDF5
#ifdef _HDF5_
use mh5, only: mh5_close_file
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym)
integer(kind=iwp), intent(_OUT_) :: IndT(*)
real(kind=wp), intent(_OUT_) :: CMO(*), Occ(*), EOrb(*)
character(len=*), intent(in) :: FName
integer(kind=iwp) :: iErr, iSym, iUHF, iWarn, iWFType, k1, k2, l_CMO, Lu, n1, n2, nBasT, nOrbT
real(kind=wp) :: Dummy(1)
character(len=80) :: VTitle
integer(kind=iwp), allocatable :: Ind_(:)
real(kind=wp), allocatable :: CMO_(:), EOr_(:), Occ_(:)
character(len=*), parameter :: SecNam = 'RdVec_Localisation'

#include "warnings.h"

nBasT = nBas(1)
nOrbT = nOrb(1)
do iSym=2,nSym
  nBasT = nBasT+nBas(iSym)
  nOrbT = nOrbT+nOrb(iSym)
end do

l_CMO = nBas(1)*nOrb(1)
do iSym=2,nSym
  l_CMO = l_CMO+nBas(iSym)*nOrb(iSym)
end do
call mma_allocate(CMO_,l_CMO,label='CMO_')
call mma_allocate(Occ_,nOrbT,label='Occ_')
call mma_allocate(EOr_,nOrbT,label='EOr_')
call mma_allocate(Ind_,nBasT,label='Ind_')

if (isHDF5) Then
  call RdVec_HDF5(fileorb_id,'COEI',nSym,nBas,CMO_,Occ_,EOr_,Ind_)
# ifdef _HDF5_
  call mh5_close_file(fileorb_id)
# endif
else
  Lu = 75
  iUHF = 0  ! restricted HF
  iWarn = 2 ! abend if nBas/nOrb info is inconsistent
  iErr = -1 ! init return code
  iWFType = -1 ! init wave function type
  Dummy(1) = huge(Dummy) ! dummy variable
  call RdVec_(FName,Lu,'COEI',iUHF,nSym,nBas,nOrb,CMO_,Dummy,Occ_,Dummy,EOr_,Dummy,Ind_,VTitle,iWarn,iErr,iWFType)
  if (iErr /= 0) then
    call WarningMessage(2,SecNam//': Non-zero return code from RdVec_')
    write(u6,'(A,A,I9)') SecNam,': RdVec_ returned code',iErr
    call xFlush(u6)
    call xQuit(_RC_IO_ERROR_READ_)
  end if
  write(u6,*)
  write(u6,'(A)') ' Header from vector file:'
  write(u6,*)
  write(u6,'(A)') trim(VTitle)
end if
write(u6,*)

k1 = 0
k2 = 0
do iSym=1,nSym
  n1 = nBas(iSym)*nOrb(iSym)
  n2 = nBas(iSym)*nBas(iSym)
  CMO(k2+1:k2+n1) = CMO_(k1+1:k1+n1)
  CMO(k2+n1+1:k2+n2) = Zero
  k1 = k1+n1
  k2 = k2+n2
end do

k1 = 0
k2 = 0
do iSym=1,nSym
  n1 = nOrb(iSym)
  n2 = nBas(iSym)
  Occ(k2+1:k2+n1) = Occ_(k1+1:k1+n1)
  Occ(k2+n1+1:k2+n2) = Zero
  EOrb(k2+1:k2+n1) = EOr_(k1+1:k1+n1)
  EOrb(k2+n1+1:k2+n2) = huge(Dummy)
  IndT(k2+1:k2+n1) = Ind_(k1+1:k1+n1)
  IndT(k2+n1+1:k2+n2) = 7
  k1 = k1+n1
  k2 = k2+n1
end do

call mma_deallocate(CMO_)
call mma_deallocate(Occ_)
call mma_deallocate(EOr_)
call mma_deallocate(Ind_)

end subroutine RdVec_Localisation

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Thomas Bondo Pedersen                                  *
************************************************************************
*  Statistics
*
*> @author Thomas Bondo Pedersen
*>
*> @details
*> Computes the following statistics for a data set \p X(i), \p i = ``1``, ``2``, ..., ``n``:
*>
*> - \p Stat(ip_Mean):      mean value
*> - \p Stat(ip_MeanAbs):   mean absolute value
*> - \p Stat(ip_Min):       minimum value
*> - \p Stat(ip_Max):       maximum value
*> - \p Stat(ip_MaxAbs):    maximum absolute value
*> - \p Stat(ip_Variance):  biased variance (i.e. RMS w.r.t. mean value)
*> - \p Stat(ip_VarianceU): unbiased variance
*>
*> @param[in]  X            Data array
*> @param[in]  n            Dimension of \p X
*> @param[out] Stat         Statistics
*> @param[in]  ip_Mean      Pointer to mean value in \p Stat
*> @param[in]  ip_MeanAbs   Pointer to mean abs. value in \p Stat
*> @param[in]  ip_Min       Pointer to min. value in \p Stat
*> @param[in]  ip_Max       Pointer to max. value in \p Stat
*> @param[in]  ip_MaxAbs    Pointer to max. abs. value in \p Stat
*> @param[in]  ip_Variance  Pointer to biased variance in \p Stat
*> @param[in]  ip_VarianceU Pointer to unbiased variance in \p Stat
************************************************************************
      SubRoutine Statistics(X,n,Stat,ip_Mean,ip_MeanAbs,ip_Min,ip_Max,
     &                      ip_MaxAbs,ip_Variance,ip_VarianceU)
      Implicit None
      Integer n
      Real*8  X(n), Stat(*)
      Integer ip_Mean, ip_MeanAbs, ip_Min, ip_Max, ip_MaxAbs
      Integer ip_Variance, ip_VarianceU

      Integer i
      Real*8  xn, xn1
      Real*8  xMean, xMeanAbs, xMin, xMax
      Real*8  xVariance

      If (n .lt. 1) Return

      xn = 1.0d0/dble(n)
      If (n .eq. 1) Then
         xn1 = 9.99D15
      Else
         xn1 = 1.0d0/dble(n-1)
      End If

      xMean    = X(1)
      xMeanAbs = abs(X(1))
      xMax     = X(1)
      xMin     = X(1)
      Do i = 2,n
         xMean    = xMean + X(i)
         xMeanAbs = xMeanAbs + abs(X(i))
         xMax     = max(xMax,X(i))
         xMin     = min(xMin,X(i))
      End Do
      xMean = xMean*xn

      If (ip_Mean    .gt. 0) Stat(ip_Mean)    = xMean
      If (ip_MeanAbs .gt. 0) Stat(ip_MeanAbs) = xMeanAbs*xn
      If (ip_Min     .gt. 0) Stat(ip_Min)     = xMin
      If (ip_Max     .gt. 0) Stat(ip_Max)     = xMax
      If (ip_MaxAbs  .gt. 0) Stat(ip_MaxAbs)  = max(abs(xMax),abs(xMin))

      If (ip_Variance.gt.0 .or. ip_VarianceU.gt.0) Then
         xVariance = (X(1)-xMean)**2
         Do i = 2,n
            xVariance = xVariance + (X(i)-xMean)**2
         End Do
         If (ip_VarianceU .gt. 0) Then
            Stat(ip_VarianceU) = sqrt(xVariance*xn1)
         End If
         If (ip_Variance .gt. 0) Then
            Stat(ip_Variance) = sqrt(xVariance*xn)
         End If
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RHSALL2(IVEC)
! ----------------------------------------------------------------
! Code for processing all the cholesky vectors
! in construction of caspt2 right-hand-side array
! Also form the active two-electron integrals 'TUVX'.
! ================================================================

use Symmetry_Info, only: Mul
use CHOVEC_IO, only: NVLOC_CHOBATCH
use PrintLevel, only: VERBOSE
use caspt2_global, only: Buff, FIMO, idxb, iPrGlb, PIQK
use caspt2_module, only: NAES, NASH, NASHT, NBTCH, NBTCHES, NISH, NSSH, NSYM
#ifdef _DEBUGPRINT_
use caspt2_module, only: NASUP, NISUP
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: IB, IB1, IB2, IBEND, IBGRP, IBSTA, iOffi, iOffK, iOffp, iOffQ, ISYI, ISYK, ISYP, ISYQ, JSYM, LBRASM, LKETSM, &
                     MXBGRP, MXPIQK, NADDBUF, NBGRP, nBra, NBRASM, NCHOBUF, NG1, NG2, NI, NK, nKet, NKETSM, NP, NPI, NQ, NQK, &
                     nSh(8,3), NTUVX, NUMERR = 0, NV
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: ICASE, ISYM, lg_W, NAS, NIS
real(kind=wp) :: DNRM2
real(kind=wp), external :: RHS_DDot
#endif
integer(kind=iwp), allocatable :: BGRP(:,:)
real(kind=wp), allocatable :: BRA(:), KET(:), TUVX(:)
integer(kind=iwp), parameter :: Inactive = 1, Active = 2, Virtual = 3

!                                                                      *
!***********************************************************************
!                                                                      *
nSh(1:NSYM,Inactive) = NISH(1:NSYM)
nSh(1:NSYM,Active) = NASH(1:NSYM)
nSh(1:NSYM,Virtual) = NSSH(1:NSYM)
!                                                                      *
!***********************************************************************
!                                                                      *

if (IPRGLB >= VERBOSE) write(u6,'(1X,A)') ' Using RHSALL2+ADDRHS algorithm'

! TUVX RHSX        Na^4
! TJVX RHSA        Na^3 Ni
! TJVL RHSB        Na^2 Ni^2
! AJVX RHSD1       Na^2 Ni   Ns
! AJCL RHSH             Ni^2 Ns^2     N^4
! AUVX RHSC        Na^3      Ns
! AUCX RHSF        Na^2      Ns^2
! AUVL RHSD2       Na^2 Ni   Ns
! AUCL RHSG        Na   Ni   Ns^2     N^3
! AJVL RHSE        Na   Ni^2 Ns       N^3

!     Initialize RHS array as 'vector' nr IVEC=IRHS on LUSOLV:

!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate and clear TUVX, two-electron integrals for active
! orbital indices only: Simple storage, same as for GAMMA2.
! TUVX is kept allocated until end of subroutine.
NG1 = NASHT**2
NG2 = NG1**2
NTUVX = NG2
call mma_allocate(TUVX,NTUVX,Label='TUVX')
TUVX(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
do JSYM=1,NSYM

  IB1 = NBTCHES(JSYM)+1
  IB2 = NBTCHES(JSYM)+NBTCH(JSYM)

  MXBGRP = IB2-IB1+1
  if (MXBGRP <= 0) cycle
  call mma_allocate(BGRP,2,MXBGRP,Label='BGRP')
  BGRP(1,1:IB2-IB1+1) = [(IB,IB=IB1,IB2)]
  BGRP(2,1:IB2-IB1+1) = [(IB,IB=IB1,IB2)]
  NBGRP = MXBGRP

  call MEMORY_ESTIMATE(JSYM,BGRP,NBGRP,NCHOBUF,MXPIQK,NADDBUF)
  if (IPRGLB > VERBOSE) then
    write(u6,*)
    write(u6,'(A,I12)') '  Number of Cholesky batches: ',IB2-IB1+1
    write(u6,'(A,I12)') '  Number of batch groups:     ',NBGRP
    write(u6,*)
  end if

  ! buffers are kept allocated until the end of JSYM loop.
  call mma_allocate(PIQK,MXPIQK,Label='PIQK')
  call mma_allocate(BUFF,NADDBUF,Label='BUFF')
  call mma_allocate(IDXB,NADDBUF,Label='IDXB')

  call mma_allocate(BRA,NCHOBUF,Label='BRA')
  call mma_allocate(KET,NCHOBUF,Label='KET')

  ! Loop over groups of batches of Cholesky vectors

  !IBSTEP = 1

  !do IBSTA=IB1,IB2,IBSTEP
  do IBGRP=1,NBGRP
    IBSTA = BGRP(1,IBGRP)
    IBEND = BGRP(2,IBGRP)

    NV = sum(NVLOC_CHOBATCH(IBSTA:IBEND))

    if (IPRGLB > VERBOSE) then
      write(u6,'(A,I12)') '  Cholesky vectors in this group = ',NV
      write(u6,*)
    end if
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read kets (Cholesky vectors) in the form L(VX), all symmetries:

    call Get_Cholesky_Vectors(Active,Active,JSYM,KET,size(KET),nKet,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Assemble contributions to TUVX integrals
    ! Reuse the ket vectors as L(TU) bra vectors

    LBRASM = 1
    do ISYI=1,NSYM
      NI = NASH(ISYI)
      iOffi = NAES(iSYI)
      if (NI == 0) cycle
      ISYP = Mul(ISYI,JSYM)
      NP = NASH(ISYP)
      iOffp = NAES(iSYP)
      if (NP == 0) cycle
      NPI = NP*NI
      NBRASM = NPI*NV
      LKETSM = 1

      do ISYK=1,NSYM
        NK = NASH(ISYK)
        iOffK = NAES(iSYK)
        if (NK == 0) cycle
        ISYQ = Mul(ISYK,JSYM)
        NQ = NASH(ISYQ)
        iOffQ = NAES(iSYQ)
        if (NQ == 0) cycle
        NQK = NQ*NK
        NKETSM = NQK*NV

        if (NPI*NQK > mxPIQK) then
          write(u6,*) 'NPIQK larger than mxPIQK in TUVX, bug?'
          call AbEnd()
        end if
        call DGEMM_('N','T',NPI,NQK,NV,One,KET(LBRASM),NPI,KET(LKETSM),NQK,Zero,PIQK,NPI)

        call ADDTUVX(NP,NI,NQ,NK,NASHT,iOffP,iOffI,iOffQ,iOffK,TUVX,nTUVX,PIQK,NPI*NQK,NUMERR)

        LKETSM = LKETSM+NKETSM
      end do
      LBRASM = LBRASM+NBRASM
    end do
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read bra (Cholesky vectors) in the form L(TJ): All symmetries

    call Get_Cholesky_Vectors(Inactive,Active,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Assemble contributions to TJVX
    ! Loop over the bras and kets, form <A|0>

    call Process_RHS_Block(Inactive,Active,Active,Active,'A ',BRA,nBra,KET,nKet,nSh,JSYM,IVEC,NV)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! TJVL RHSB
    ! TJVL: Use TJ buffer as if it was VL, form <B|0>

    call Process_RHS_Block(Inactive,Active,Inactive,Active,'B ',BRA,nBra,BRA,nBra,nSh,JSYM,IVEC,NV)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read bra (Cholesky vectors) in the form L(AJ), form <D1|0>
    ! We still have L(VX) vectors in core, at KET.

    call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AJVX RHSD1
    ! Loop over the bra and ket vectors.

    call Process_RHS_Block(Inactive,Virtual,Active,Active,'D1',BRA,nBra,KET,nKet,nSh,JSYM,IVEC,NV)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AJCL RHSH
    ! AJCL: Use AJ buffer still in core as if it was CL, form <H|0>

    call Process_RHS_Block(Inactive,Virtual,Inactive,Virtual,'H ',BRA,nBra,BRA,nBra,nSh,JSYM,IVEC,NV)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read Bra (Cholesky vectors)= L(AU)

    call Get_Cholesky_Vectors(Active,Virtual,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AUVX RHSC
    ! AUVX: Loop over the bras and kets

    call Process_RHS_Block(Active,Virtual,Active,Active,'C ',BRA,nBra,KET,nKet,nSh,JSYM,IVEC,NV)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AUCX RHSF
    ! AUCX: Use AU buffer still in core as if it was CX, form <F|0>

    call Process_RHS_Block(Active,Virtual,Active,Virtual,'F ',BRA,nBra,BRA,nBra,nSh,JSYM,IVEC,NV)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read kets (Cholesky vectors) in the form L(VL), all symmetries:

    call Get_Cholesky_Vectors(Inactive,Active,JSYM,KET,size(KET),nKet,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AUVL RHSD2
    ! Loop over bras and kets, form <D2|0>.

    call Process_RHS_Block(Active,Virtual,Inactive,Active,'D2',BRA,nBra,KET,nKet,nSh,JSYM,IVEC,NV)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read kets (Cholesky vectors) in the form L(CL), all symmetries:

    call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,KET,size(KET),nKet,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AUCL RHSG
    ! Loop over bras and kets, form  <G|0>

    call Process_RHS_Block(Active,Virtual,Inactive,Virtual,'G ',BRA,nBra,KET,nKet,nSh,JSYM,IVEC,NV)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read bra vectors AJ

    call Get_Cholesky_Vectors(Inactive,Virtual,JSYM,BRA,size(BRA),nBra,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! Read kets in the form L(VL)

    call Get_Cholesky_Vectors(Inactive,Active,JSYM,KET,size(KET),nKet,IBSTA,IBEND)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! AJVL RHSE
    ! AJVL: Loop over bras and kets. Form <E|0>

    call Process_RHS_Block(Inactive,Virtual,Inactive,Active,'E ',BRA,nBra,KET,nKet,nSh,JSYM,IVEC,NV)
    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! End of loop over batches, IB
  end do
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  call mma_deallocate(BRA)
  call mma_deallocate(KET)
  call mma_deallocate(PIQK)
  call mma_deallocate(BUFF)
  call mma_deallocate(IDXB)
  call mma_deallocate(BGRP)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! End of loop over JSYM
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Synchronized add RHS partial arrays from all nodes into each node.

!-SVC: read the DRA's from disk and copy them all to LUSOLV to continue
!      in serial mode.  FIXME: this call has to be removed when we reach
!      full parallel capabilities
!call SYNRHS(IVEC)
!-SVC: at this point, the RHS elements are on disk, both in LUSOLV and
!      as DRAs with the name RHS_XX_XX_XX with XX a number representing
!      the case, symmetry, and rhs vector respectively.

! The RHS elements of Cases A, C, D1  need a correction:
call MODRHS(IVEC,FIMO,size(FIMO))

#ifdef _DEBUGPRINT_
! compute and print RHS fingerprints
write(u6,'(1X,A4,1X,A3,1X,A18)') 'Case','Sym','Fingerprint'
write(u6,'(1X,A4,1X,A3,1X,A18)') '====','===','==========='
do ICASE=1,13
  do ISYM=1,NSYM
    NAS = NASUP(ISYM,ICASE)
    NIS = NISUP(ISYM,ICASE)
    if (NAS*NIS /= 0) then
      call RHS_ALLO(NAS,NIS,lg_W)
      call RHS_READ(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
      DNRM2 = RHS_DDOT(NAS,NIS,lg_W,lg_W)
      write(u6,'(1X,I4,1X,I3,1X,F18.11)') ICASE,ISYM,DNRM2
    end if
  end do
end do
#endif

! Synchronized add tuvx partial arrays from all nodes into each node.
call CHO_GADGOP(TUVX,NTUVX,'+')
! Put TUVX on disk for possible later use:
call PT2_PUT(NTUVX,'TUVX',TUVX)
call mma_deallocate(TUVX)
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine RHSALL2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine input_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"

#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"

      ibase = mstacki_cvb(0)

      mxpair=mxorb*(mxorb+1)/2
      mxdimrel=mxpair*(3+mxops)
      iorbrel = mstacki_cvb(mxpair*(3+mxops))

      ifxorb = mstacki_cvb(mxorb)

      iorts = mstacki_cvb(2*mxpair)
      irots = mstacki_cvb(2*mxpair)

      izeta = mstacki_cvb(mxsyme)

      iorbs = mstackrz_cvb(mxaobf*mxorb)
      irdorbs = mstackiz_cvb(mxorb)

      call input2_cvb(
     >  iw(iorbrel),mxdimrel,iw(ifxorb),
     >  iw(iorts),iw(irots),iw(izeta),w(iorbs),iw(irdorbs))
      call mfreei_cvb(ibase)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagFro0(NOSQT,NBSQT,DPT2_ori,DPT2)

use caspt2_module, only: NBAS, NDEL, NFRO, NORB, NSYM
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NOSQT, NBSQT
real(kind=wp), intent(in) :: DPT2_ori(NOSQT)
real(kind=wp), intent(inout) :: DPT2(NBSQT)
integer(kind=iwp) :: iMO1, iMO2, iOrb, iOrb1, iOrb2, iSym, jOrb, jOrb1, jOrb2, nFroI, nOrbI1, nOrbI2

iMO1 = 1
iMO2 = 1
do iSym=1,nSym
  nOrbI1 = nOrb(iSym)
  nOrbI2 = nBas(iSym)-nDel(iSym)
  if (nOrbI1 > 0) then
    nFroI = nFro(iSym)
    !! Do for all orbitals
    do iOrb=1,nOrbI1
      iOrb1 = iOrb
      iOrb2 = iOrb+nFroI
      do jOrb=1,nOrbI1
        jOrb1 = jOrb
        jOrb2 = jOrb+nFroI
        DPT2(iMO2+iOrb2-1+nOrbI2*(jOrb2-1)) = DPT2_ori(iMO1+iOrb1-1+nOrbI1*(jOrb1-1))
        DPT2(iMO2+jOrb2-1+nOrbI2*(iOrb2-1)) = DPT2_ori(iMO1+jOrb1-1+nOrbI1*(iOrb1-1))
      end do
    end do
  end if
  iMO1 = iMO1+nOrbI1*nOrbI1
  iMO2 = iMO2+nOrbI2*nOrbI2
end do

end subroutine OLagFro0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      REAL*8 FUNCTION D1MACH(I)
      INTEGER I
C
C  DOUBLE-PRECISION MACHINE CONSTANTS
C
C  D1MACH( 1) = B**(EMIN-1), THE SMALLEST POSITIVE MAGNITUDE.
C
C  D1MACH( 4) = B**(1-T), THE LARGEST RELATIVE SPACING.
C
      real*8 eps,xmin,xmax
* PAM 2008 These declarations should be used with machar
*      real*8 epsneg
*      integer ibeta,it,irnd,ngrd,machep,negep,iexp,minexp,maxexp

* PAM 2008 Do not use machar any more. Try hardcoded values:
*      call machar(ibeta,it,irnd,ngrd,machep,negep,iexp,minexp,
*     *maxexp,eps,epsneg,xmin,xmax)
      EPS=1.0D-15
      XMIN=1.0D-300
      XMAX=1.0D+300

      If (I.eq.1) then
         D1Mach = xmin
      Else If (I.eq.2) then
         D1Mach = xmax
      Else If (I.eq.4) then
         D1Mach = eps
      Else
         D1Mach = -1d0
      End If

      RETURN

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2021, Jie J. Bao                                       *
************************************************************************
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on Aug. 06, 2020, created this file.               *
* ****************************************************************
      subroutine CalcAXkzx(AXkzx,GDMat,PUVX,NPUVX,IndPUVX,zx)
#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"

******Input
      Integer NPUVX
      Real*8,DIMENSION((nRoots+1)*nRoots/2,nnA,nnA)::GDMat
      Real*8,DIMENSION(NPUVX)::PUVX
      INTEGER,DIMENSION(ntBas,ntAsh,ntAsh,ntAsh)::IndPUVX
      Real*8,DIMENSION((nRoots-1)*nRoots/2)::zx

******Output
      Real*8,DIMENSION(nDens2)::AXkzx

******Auxiliary Quantities
      INTEGER,DIMENSION(nSym)::Off_Act,Off_Orb
      Real*8,DIMENSION(:),Allocatable::DKL1,DKL2,AXktmp
      INTEGER K,L,iKL,iKL2,iKK,iLL
      INTEGER p,q

      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

      Off_Act(1)=0
      Off_Orb(1)=0
      ntOrb=nOrb(1)
      DO ISym=2,nSym
       Off_Act(ISym)=Off_Act(ISym-1)+nAsh(iSym-1)
       Off_Orb(ISym)=Off_Orb(ISym-1)+nOrb(iSym-1)
       ntOrb=ntOrb+nOrb(ISym)
      END DO

      Call FZero(AXkzx,nDens2)

      CALL mma_allocate(DKL1,ntAsh**2)
      CALL mma_allocate(DKL2,ntAsh**2)
      CALL mma_allocate(AXktmp,nDens2)

      DO K=2,nRoots
       Do L=1,K-1
       iKL=itri(K,L)
       iKK=itri(K,K)
       iLL=itri(L,L)
       iKL2=(K-1)*(K-2)/2+L
       do p=1,ntash
        do q=1,ntash
         DKL1((p-1)*ntash+q)=GDMat(IKL,p,q)+GDMat(IKL,q,p)
         DKL2((p-1)*ntash+q)=GDMat(IKK,p,q)-GDMat(ILL,p,q)
        end do
       end do
       CALL FZero(AXktmp,nDens2)
       CALL CalcAXk2(AXktmp,DKL1,DKL2,PUVX,
     & NPUVX,IndPUVX,Off_Act,Off_Orb)
       CALL CalcAXk2(AXktmp,DKL2,DKL1,PUVX,
     & NPUVX,IndPUVX,Off_Act,Off_Orb)
       CALL Daxpy_(nDens2,zx(IKL2),AXktmp,1,Axkzx,1)
       End Do
      END DO

      CALL mma_deallocate(DKL1)
      CALL mma_deallocate(DKL2)
      CALL mma_deallocate(Axktmp)
      RETURN
      END SUBROUTINE


      subroutine CalcAXk2(AXk,D1,D2,PUVX,
     & NPUVX,IndPUVX,Off_Act,Off_Orb)
#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
      Integer NPUVX
      Real*8,DIMENSION(NPUVX)::PUVX
      INTEGER,DIMENSION(ntBas,ntAsh,ntAsh,ntAsh)::IndPUVX
      Real*8,DIMENSION(ntAsh**2)::D1,D2
      INTEGER,DIMENSION(nSym)::Off_Act,Off_Orb

      Real*8,DIMENSION(nDens2)::AXk

      Real*8,DIMENSION(:),Allocatable::Opu
      INTEGER p,q,iSym,t,u,v,x,ip,iq,it,loc1,loc2
      Real*8 tempa

      CALL mma_allocate(Opu,ntBas*ntAsh)
      DO p=1,ntBas
       Do u=1,ntAsh
        tempa=0.0d0
        do v=1,ntAsh
         do x=1,ntAsh
          if(IndPUVX(p,u,v,x).ne.0)
     &tempa=tempa+PUVX(IndPUVX(p,u,v,x))*D2((v-1)*nnA+x)
         end do
        end do
        Opu((p-1)*ntAsh+u)=tempa
       End Do
      END DO
      DO iSym=1,nSym
       Do iq=1,nAsh(iSym)
       q=iq+Off_Act(ISym)
        Do ip=1,nIsh(iSym)  ! p is inactive
         p=ip+Off_Orb(ISym)
         tempa=0.0d0
         do it=1,nAsh(ISym)
          t=it+Off_Act(ISym)
          tempa=tempa+(D1((t-1)*nnA+q)+D1((q-1)*nnA+t))
     &         *Opu((p-1)*nnA+t)
         end do
*         write(6,*)'tempa after sum over t',tempa
         loc1=ipMat(iSym,iSym)+(iq-1)*nOrb(iSym)+ip-1
     &   +nOrb(iSym)*NIsh(iSym)
         loc2=ipMat(iSym,iSym)+(ip-1)*nOrb(iSym)+iq-1
     &   +NIsh(iSym)
         AXK(loc1)=AXK(loc1)+tempa
         AXK(loc2)=AXK(loc2)-tempa
        End Do
        Do ip=nIsh(iSym)+nAsh(iSym)+1,nOrb(iSym)  ! p is virtual
         p=ip+Off_Orb(ISym)
         tempa=0.0d0
         do it=1,nAsh(ISym)
          t=it+Off_Act(ISym)
          tempa=tempa+(D1((t-1)*nnA+q)+D1((q-1)*nnA+t))
     &         *Opu((p-1)*nnA+t)
         end do
         loc1=ipMat(iSym,iSym)+(iq-1)*nOrb(iSym)+ip-1
     &   +nOrb(iSym)*NIsh(iSym)
         loc2=ipMat(iSym,iSym)+(ip-1)*nOrb(iSym)+iq-1
     &   +NIsh(iSym)
         AXK(loc1)=AXK(loc1)+tempa
         AXK(loc2)=AXK(loc2)-tempa
        End Do
       END Do
      END DO
      CALL mma_deallocate(Opu)
      RETURN
      END SUBROUTINE

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Subroutine Init_RctFld(NonEq,iCharge)
       use Langevin_arrays
       use PCM_arrays, only: MM
       use external_centers, only: nXF, iXPolType
       Implicit Real*8 (a-h,o-z)
#include "rctfld.fh"
#include "status.fh"
#include "stdalloc.fh"
       Logical NonEq
*
       tK=1.0D-99 ! Boltzman factor, initial set to 0 K
       If (RctFld_Status.eq.Active) Return
       mMM = (lMax+1)*(lMax+2)*(lMax+3)/6
       nMM = 2 * mMM
       Call mma_allocate(MM,mMM,2,Label='MM')
       If (iXPolType.gt.0) nGrid = nXF
       If (lLangevin .or. (iXPolType.gt.0)) Then
          If(lLangevin) Then
             maxa = INT(radlat/scala)
             maxb = INT(radlat/scalb)
             maxc = INT(radlat/scalc)
             nabc=(2*maxa+2)*(2*maxb+2)*(2*maxc+2)
             nGrid=nGrid+nabc*latato
          EndIf
          If(iXPolType.eq.2) Then
             nPolComp = 6
          Else
             nPolComp = 1
          EndIf
          Call mma_allocate(Field,4,nGrid,Label='Field')
          Call mma_allocate(dField,4,nGrid,Label='dField')
          Call mma_allocate(Dip,3,nGrid,Label='Dip')
          Call mma_allocate(PolEf,nPolComp,nGrid,Label='PolEf')
          Call mma_allocate(DipEf,nGrid,Label='DipEf')
          Call mma_allocate(Grid,3,nGrid,Label='Grid')
*
          nCavxyz = (lMax+1)*(lMax+2)*(lMax+3)/6
          Call mma_allocate(davxyz,nCavxyz,Label='davxyz')
          Call mma_allocate(cavxyz,nCavxyz,Label='cavxyz')
          Call mma_allocate(ravxyz,nCavxyz,Label='ravxyz')
       End If
       If (.Not.PCM) NonEq_Ref=NonEq
       Call Init_PCM(NonEq,iCharge)
       RctFld_Status=Active
*
       Return
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine getmo2_cvb(cmo,cmo2,cmoblk,
     >  ic,ic2)
      implicit real*8 (a-h,o-z)
#include "mo_cvb.fh"
      dimension cmo(nbas_mo,nbas_mo),cmo2(nbas_mo,nbas_mo)
      dimension cmoblk(nbasisq_mo)

c  Construct full matrix of MOs in symmetry-adapted AO basis :
      call getmoblk_cvb(cmoblk,ic2)
      call fzero(cmo,nbas_mo*nbas_mo)
      do 100 isk=1,nsym_mo
      do 101 jbas=1,nbasi_mo(isk)
      call fmove_cvb(cmoblk(1+nbassqf_mo(isk)+(jbas-1)*nbasi_mo(isk)),
     >  cmo(nbasf_mo(isk)+1,jbas+nbasf_mo(isk)),nbasi_mo(isk))
101   continue
100   continue

      if(mod(ic,2).eq.1)then
        call mxinv_cvb(cmo,nbas_mo)
        call transp_cvb(cmo,cmo,nbas_mo,nbas_mo)
      endif

      if(ic.ge.2)then
        do 200 iorb=1,nact_mo
        call fmove_cvb(cmo(1,iact_mo(iorb)),cmo2(1,iorb),nbas_mo)
200     continue
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
************************************************************************
*  RasScf_Init
*
*> @brief
*>   Initialize variables in commons, and set default values.
*>   Determine whether orbital files should be read, etc.
*> @author  P. &Aring;. Malmqvist
*>
*> @details
*> Sets values in common blocks in rasscf.fh, general.fh, timers.fh
************************************************************************
      Subroutine RasScf_Init_m()
      Implicit Real*8 (A-H,O-Z)
      External Get_SuperName
      Character*100 ProgName, Get_SuperName
#include "rasdim.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='RasScf_Init')
#include "rasscf.fh"
#include "casvb.fh"
#include "general.fh"
#include "gas.fh"
#include "timers.fh"
#include "lucia_ini.fh"
#include "orthonormalize.fh"
#include "WrkSpc.fh"
#include "ksdft.fh"
      Integer IPRGLB_IN, IPRLOC_IN(7)
* What to do with Cholesky stuff?
      Logical DoCholesky,timings,DensityCheck
      Logical DoLocK,Deco
      Logical Estimate,Update
      Integer ALGO,Nscreen
      Real*8  dmpk,ChFracMem
      Logical, External :: Is_First_Iter

      Common /CHLCAS / DoCholesky,ALGO
      COMMON /CHODENSITY/ DensityCheck
      COMMON /CHOTIME / timings
      Common /CHOLK / DoLocK,Deco,dmpk,Nscreen
      COMMON /CHOSCREEN/ Estimate,Update
      COMMON /CHOPAR/ ChFracMem
*----------------------------------------------------------------------*
      ProgName=Get_SuperName()
*----------------------------------------------------------------------*
* How was the program called?
*PAM 2009 Someone has put a number of possibilities here. Let it stand for now.
      IfVB=0
      If (ProgName(1:6).eq.'rasscf'.or.ProgName(1:6).eq.'mcpdft') Then
         ICIRST=0
*        For geometry optimizations use the old CI coefficients.
         If (.Not.Is_First_Iter()) ICIRST=1
      ELse If (ProgName(1:5).eq.'casvb') Then
         IfVB=2
         ICIRST=0
      ELse If (ProgName(1:6).eq.'loprop') Then
C        ICIRST=1 ! to be activated!
         ICIRST=0
      ELse If (ProgName(1:11).eq.'last_energy') Then
         ICIRST=1
      ELse If (ProgName(1:18).eq.'numerical_gradient') Then
         ICIRST=1
      Else
         ICIRST=0
      End If

* Initialize print levels: See output_ras.fh
* Global logical unit numbers for standard input and standard output
      IO=5
      LF=6
* Externally set default print level control. Should the program be silent?
      IPRGLB_IN=iPrintLevel(-1)
      DO I=1,7
       IPRLOC_IN(I)=IPRGLB_IN
      END DO
* Set print levels, and adjust them if needed:
      call setprlev_m(LF,IPRGLB_IN,IPRLOC_IN)
*
* SET UP SYMMETRY MULTIPLICATION TABLE:
      MUL(1,1)=1
      M=1
      DO  N=1,3
        DO  I=1,M
          DO  J=1,M
            MUL(I+M,J)=M+MUL(I,J)
            MUL(I,J+M)=MUL(I+M,J)
            MUL(I+M,J+M)=MUL(I,J)
          END DO
         END DO
        M=2*M
      END DO

* Cholesky-related settings:
      Call DecideOnCholesky(DoCholesky)
      ALGO  = 1
      DensityCheck=.false.
      Deco=.true.
      timings=.false.
      DoLock=.true.
      Nscreen=10
      dmpk=1.0d-1
      Update=.true.
      Estimate=.false.
*
#if defined (_MOLCAS_MPP_)
      ChFracMem=0.3d0
#else
      ChFracMem=0.0d0
#endif



      OutFmt1='DEFAULT '
      OutFmt2='DEFAULT '

* Max nr of state-specific orbital files printed:
      MAXORBOUT=100
* Default title line:
      TITLE(1)='(No title given)'
*
* assign ipCleanMask to dummy pointer
      ipCleanMask=ip_Dummy
*
* iteration control
*
* maximum number of RASSCF iterations
      MAXIT=mxIter
* max number of super-CI iterations
      ITMAX=mxSxIt
* max number of iterations in Davidson diagonalization
      MAXJT=MXCIIT-2
* threshold for change in RASSCF energy
      THRE=1.D-08
*tbp, may 2013: no thre modification with Cholesky
*tbp  If (DoCholesky) then
*tbp     Call Get_dScalar('Cholesky Threshold',ThrCom)
*tbp     THRE = Max(THRE,ThrCom)
*tbp  EndIf
* threshold for max orbital rotation
*PAM2010       THRTE=1.D-04
* PAM2010: Note: This is *not* a threshold that keeps rotation down
* between iterations in order to ensure proper function of the
* optimization -- it was intended as one of the thresholds that
* determine when the calculation has converged! As such, it is
* irrelevant! The relevant threshold is the max BLB.
      THRTE=1.D-01
* threshold for max BLB matrix element
      THRSX=1.D-04
* Default damping in the SXCI orbital optimization
      SXDAMP=0.0002D0
* Default thresholds used to determine convergence in CI
      THREN=1.0D-04
      THFACT=1.0D-03
* PAM 2009, new default value for LVSHFT
* level shift parameter
      LVSHFT=0.5D00
* Quasi Newton update of the rotation matrix
      NQUNE=2
* only the CI calculation will be performed if iCIonly=1
      iCIonly=0
* only the orbitals from a JobIph to RasOrb if iOrbOnly=1
      iOrbOnly=0
* Default orbital type for RasOrb: Average orbitals
      iOrbTyp=1
* Root selection in the SXCI orbital optimization step.
* Values: LOWEST or HOMING.
      SXSEL='LOWEST  '
* Choose to only expand or generate information for CI-vectors if INOCALC = 1
      INOCALC = 0
* Save information on CI expansion if ISAVE_EXP = 1
      ISAVE_EXP = 0
* Expand a smaller CI vector in a larger one if IEXPAND = 1
      IEXPAND = 0
*
* wave function control bits
*
* new fock operator
      NewFock=1
* State used in response calculation
      iPCMROOT=1
* State to alaska
*TRS
*      iRLXROOT=0
* number of roots required in CI
      NROOTS=1
* number of roots actually used in CI-DAVIDSON
      LROOTS=1
* sequence numbers for roots in CI counted from
* lowest energy.
      Call iCopy(mxRoot,[0],0,iRoot,1)
      IROOT(1)=1
* weights used for average energy calculations
      Call dCopy_(mxRoot,[0.0D0],0,WEIGHT,1)
      WEIGHT(1)=1.0D0
* iteration energies
      Call dCopy_(mxRoot*(mxIter+2),[0.0D0],0,ENER,1)
*
      ICICH=0
* if flag is active (ICICH=1) CI roots will be selected
*             by maximum overlap with input CI function
*             ICI(NROOTS,NREF)    CSF number for each root
*             CCI(NROOTS,NREF)    corresponding CI coefficient
*             maximum number is five csf's.
*
      KAVER=0
* not zero if density matrices are to be averaged.
*     KAVER=1 symmetries KSYM(1) and KSYM(2) averaged
*     KAVER=2 also symmetries KSYM(3) and KSYM(4) averaged
*
      ISUPSM=0
* make no use of supersymmetry
      IORDEM=0
* (SVC) do not force any ordering options
      IFORDE=1
* (SVC) use ordering of orbitals
* start CI Davidson with unit guess for CI vector
* use restart option if numerical gradients are computed.
      PRWTHR = 0.05D0
* threshold for printout of CI wave function

      PROTHR=-1.0D0
* occupation threshold for printout of orbitals
* ( The negative value serves to show if no user selection was made)
      PRETHR=999999.0d0
* energy threshold for printout of orbitals

      ICICP=0
* no CI coupling (not active in this version)
      NSEL=200
* Default value for explicit Hamiltonian
*
      TMIN=0.0D0
      QNSTEP='SX'
      QNUPDT=' NO'
*     Default value for tight parameter
      KTIGHT=0
*
* Default value for type of CASSCF (used for DFT)
*
      KSDFT='SCF'
      ExFac=1.0D0
* Initialize KSDF coefficients (S Dong, 2018)
      CoefR = 1.0D0
      CoefX = 1.0D0
!      Write(6,*) ' Correlation energy scaling factor (init) is ',CoefR
!      Write(6,*) ' Exchange energy scaling factor (init) is ',CoefX
** Default orthonormalization of CMOs to be with
** Gram-Schmidt
*      Lowdin_ON=.False.
* PAM Jan 12 2010, on request, Lowdin ON has been made the default.
      Lowdin_ON=.true.
*
* default for spin projection
      LOWMS=0
* default spin value (singlet)
      ISPIN=1
* default symmetry
      LSYM=1
* default number of active electrons
      NACTEL=0
* default maximum number of holes in RAS1
      NHOLE1=0
* default maximum number of electrons in RAS3
      NELEC3=0
* This run will not be the start for a CASPT2 calculation
      IPT2=0
* This key will activate pertubational reaction field
* calculations.
      RFpert=.false.
* Do compute the spin density matrix
      ISPDEN=1
* These keys will activate the calculation of the high
* frequency contribution to the reaction field
* ???
* This key controls if a non-equilibrium reaction field
* calculation is performed.
      NonEq=.False.
* This initializes nr of input orbital swaps requested:
      NAlter=0
* set default values for orbitals
*
C
      DO I=1,mxSym
        NFRO(I)=0
        NISH(I)=0
        NASH(I)=0
        NRS1(I)=0
        NRS2(I)=0
        NRS3(I)=0
        NSSH(I)=0
        NDEL(I)=0
        NBAS(I)=0
      END DO
* initialize occupation numbers for GAS
*
      NGAS=3
      NGSSH=0
      IGSOCCX=0
      DO I=1,mxOrb
        IXSYM(I)=0
      END DO
      ICLEAN=0
      PURIFY='NO'
*
*     Auxiliary vector ITRI(I)=I*(I-1)/2
*
      ITRI(1)=0
      DO I=2,ITRIM
       ITRI(I)=ITRI(I-1)+I-1
      END DO

* Initial guess for jobiph name to use:
      IPHNAME='JOBIPH'
* Initial guess for starting orbital file:
      StartOrbFile='INPORB'
* Initialize alpha or beta orbitals (none):
      iAlphaBeta=0
*
* Initialize speed options (turn everything that's working on)
*
      Do i = 1,nSpeed
         if (i .le. 2) Then
            iSpeed(i) = 1
         else
C The rest is at the present time just to allow testing
            iSpeed(i) = 0
         end if
      End Do
*
      Ebel_3     = 0.0d0
      Eterna_3   = 0.0d0
      Rado_3     = 0.0d0
      Rolex_3    = 0.0d0
      Omega_3    = 0.0d0
      Tissot_3   = 0.0d0
      Piaget_3   = 0.0d0
      Candino_3  = 0.0d0
      Fortis_3   = 0.0d0
      Zenith_3   = 0.0d0
      Gucci_3    = 0.0d0
      Alfex_3    = 0.0d0
      WTC_3      = 0.0d0
      Longines_3 = 0.0d0
      Oris_2     = 0.0d0
      Movado_2   = 0.0d0
*
CSVC: lucia timers
      tsigma = 0.0d0
      tdensi = 0.0d0
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,2020, Roland Lindh                                *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ZXia(Zeta,ZInv,N,M,Alpha,Beta)
!***********************************************************************
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January 1990                                             *
!***********************************************************************

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, M
real(kind=wp), intent(inout) :: Zeta(N,M), ZInv(N,M)
real(kind=wp), intent(in) :: Alpha(N), Beta(M)
integer(kind=iwp) :: j

#ifdef _DEBUGPRINT_
call RecPrt(' In ZXia: Alpha',' ',Alpha,N,1)
call RecPrt(' In ZXia: Beta ',' ',Beta,M,1)
#endif

do j=1,M
  Zeta(:,j) = (Alpha(:)+Beta(j))
end do
ZInv(:,:) = One/Zeta(:,:)
#ifdef _DEBUGPRINT_
call RecPrt(' In ZXia: Zeta',' ',Zeta,N,M)
#endif

return

end subroutine ZXia

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkV_T18(Va,V,dima,no)
! this routine does:
! Va(a,j,i,u) = - [2V(ai|ju)-V(aj|iu)]
! from V(o_a,P,Q,a)
!
! N.B. Kvajto odflaknute, ozaj ze hnus, treba sa zamysliet
! ci je nutva permutacia s a-ckom na konci - bod QK2.2 @@

use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, no
real(kind=wp), intent(out) :: Va(dima,no,no,no)
real(kind=wp), intent(in) :: V(no,no,no,dima)
integer(kind=iwp) :: i, j, u

do u=1,no
  do i=1,no
    do j=1,no
      Va(:,j,i,u) = V(j,i,u,:)-Two*V(i,j,u,:)
    end do
  end do
end do

return

end subroutine MkV_T18

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
*               2012,2014, Victor P. Vysotskiy                         *
************************************************************************
      SubRoutine Cho_XCV_DistributeVectors(irc,SP_BatchDim,nSP_Batch,
     &                                     idSP,n_idSP,NVT,l_NVT)
C
C     Thomas Bondo Pedersen, April 2010.
C
C     Parallel execution: distribute vectors across nodes.
C     Serial execution: reorder vectors on tmp files and write them to
C     permanent vector files.
C
C     Victor P. Vysotskiy, 2012:
C     Number of 'ga_put' has been remarkably reduced.
C     Victor P. Vysotskiy, 2014:
C     Number of 'ga_get' has been remarkably reduced by using the stripped mode

      Implicit None
      Integer irc
      Integer nSP_Batch
      Integer SP_BatchDim(nSP_Batch)
      Integer n_idSP
      Integer idSP(n_idSP)
      Integer l_NVT
      Integer NVT(l_NVT)
#include "cho_para_info.fh"
#include "choprint.fh"
#include "cholesky.fh"

      Real*8 C0, C1, W0, W1

      irc=0
      If (Cho_Real_Par) Then
         If (iPrint.ge.Inf_Pass) Then
            Call Cho_Timer(C0,W0)
         End If
         Call Cho_XCV_DV_P(irc,SP_BatchDim,nSP_Batch,idSP,n_idSP,
     &                     NVT,l_NVT)
         If (iPrint.ge.Inf_Pass) Then
            Call Cho_Timer(C1,W1)
            Write(LuPri,'(/,1X,A)')
     &      'Timing of vector distribution:'
            Call Cho_PrtTim(' ',C1,C0,W1,W0,-1)
         End If
      Else
         If (iPrint.ge.Inf_Pass) Then
            Call Cho_Timer(C0,W0)
         End If
         Call Cho_XCV_DV_S(irc,SP_BatchDim,nSP_Batch,idSP,n_idSP)
         If (iPrint.ge.Inf_Pass) Then
            Call Cho_Timer(C1,W1)
            Write(LuPri,'(/,1X,A)')
     &      'Timing of vector write:'
            Call Cho_PrtTim(' ',C1,C0,W1,W0,-1)
         End If
      End If

      End
      SubRoutine Cho_XCV_DV_P(irc,SP_BatchDim,nSP_Batch,
     &                        id_mySP,n_mySP,NVT,l_NVT)
      Implicit None
      Integer irc
      Integer nSP_Batch
      Integer SP_BatchDim(nSP_Batch)
      Integer n_mySP
      Integer id_mySP(n_mySP)
      Integer l_NVT
      Integer NVT(l_NVT)
#if defined (_MOLCAS_MPP_)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
#include "choprint.fh"
#include "mafdecls.fh"
#include "cho_para_info.fh"
      Character*12 SecNam
      Parameter (SecNam='Cho_XCV_DV_P')

      Integer iOpt
      Parameter (iOpt=1)

      Logical  ga_create, ga_destroy
      External ga_create, ga_destroy
      Logical  ok

      Real*8 X0, X1, Y0, Y1

      Integer g_a
      Integer iSym
      Integer ip_myNumCho, l_myNumCho
      Integer ip_Mem, l_Mem
      Integer max_vector_dim
      Integer nVec_per_batch, nVec_this_batch
      Integer iBatch, nBatch
      Integer ip_V, l_V
      Integer ip_numV, l_numV
      Integer ip_IDV, l_IDV
      Integer kV, myStart, myEnd
      Integer my_nV
      Integer lTot, iAdr, iAdr0, nDim
      Integer J0, J1, J2
#if !defined(_GA_)
      Integer Jst,Jen
#endif
      Integer iSP, iSP_, iSP1, iSP2
      Integer iSP_Batch
      Integer nSP_this_batch

      Integer i, j, k
      Integer iiBstRsh, nnBstRSh
      iiBStRsh(i,j,k)=iWork(ip_iiBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      nnBStRsh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)

      ! Init return code
      irc=0

      ! Find max vector dimension
      max_vector_dim=nnBstR(1,2)
      Do iSym=1,nSym
         max_vector_dim=max(max_vector_dim,nnBstR(iSym,2))
      End Do
      If (max_vector_dim .lt. 1) Then
         irc=-2
         Return
      End If

      ! Allocate my vector counter array
      l_myNumCho=nSym
      Call GetMem('GAMNCH','Allo','Inte',ip_myNumCho,l_myNumCho)
      Call iZero(iWork(ip_myNumCho),l_myNumCho)

      ! Allocate index arrays for GA use
      l_numV=1
      Call GetMem('GANUMV','Allo','Inte',ip_numV,l_numV)

      ! Figure out how much 1/3 of total memory is
      Call GetMem('GAMX','Max ','Real',ip_Mem,l_Mem)
      l_Mem=l_Mem/3
      If (l_Mem.lt.max_vector_dim) Then
         ! OK, let us try 2/3 then...
         l_Mem=l_Mem*2
         If (l_Mem.lt.max_vector_dim) Then
            irc=-1
            Return
         End If
      End If

      ! distribute vectors, one symmetry at a time
      Do iSym=1,nSym
         If (iPrint.ge.Inf_Progress) Then
            Write(LuPri,'(/,A,I2,/,A)')
     &      'Distributing vectors, symmetry',iSym,
     &      '--------------------------------'
            Write(LuPri,'(3X,A,I8)')
     &      'Total number of vectors:',NVT(iSym)
            Write(LuPri,'(3X,A,I8)')
     &      'Local number of vectors:',NumCho(iSym)
            Write(LuPri,'(3X,A,I8)')
     &      'Vector dimension       :',nnBstR(iSym,2)
            Write(LuPri,'(3X,A,I8)')
     &      'Shell pair batches     :',nSP_Batch
            Call Cho_Flush(LuPri)
         End If
         If (NVT(iSym).gt.0 .and. nnBstR(iSym,2).gt.0) Then
            ! Set up batching, ensuring that the number of vectors is
            ! the same on all nodes
            iWork(ip_numV)=min(l_Mem/nnBstR(iSym,2),NVT(iSym))
            Call Cho_GAIGOp(iWork(ip_numV),1,'min')
            nVec_per_batch=iWork(ip_numV)
            If (nVec_per_batch .lt. 1) Then
               Call Cho_Quit(
     &               'Insufficient memory for batching in '//SecNam,101)
            End If
            nBatch=(NVT(iSym)-1)/nVec_per_batch+1
            ! Allocate memory for vectors (will hold local as well as
            ! full vectors)
            l_V=nnBstR(iSym,2)*nVec_per_batch
            Call GetMem('GAVEC','Allo','Real',ip_V,l_V)
            ! Allocate vector ID array for distribution
            l_IDV=nVec_per_batch
            Call GetMem('GADIST','Allo','Inte',ip_IDV,l_IDV)
            ! Create global array with evenly distributed chunks
            ok=ga_create(mt_dbl,nnBstR(iSym,2),nVec_per_batch,'GA_XCV',
     &                   0,0,g_a)
            If (.not. ok) Then
               Call Cho_Quit(SecNam//': ga_create() failed!',101)
            End If
            If (iPrint.ge.Inf_Progress) Then
               Write(LuPri,'(3X,A,I8)')
     &         'Vector batches         :',nBatch
               Call Cho_Flush(LuPri)
            End If
            ! Distribute in batches
            Do iBatch=1,nBatch
               ! Sync: all must be at the same batch
               ! (so that we do not put while another is getting)
               Call Cho_GASync()
               ! Determine number of vectors in this batch
               If (iBatch.eq.nBatch) Then
                  nVec_this_batch=NVT(iSym)-nVec_per_batch*(nBatch-1)
               Else
                  nVec_this_batch=nVec_per_batch
               End If
               ! First and last vector in this batch
               J1=nVec_per_batch*(iBatch-1)+1
               J2=J1+nVec_this_batch-1
               If (iPrint.ge.Inf_Progress) Then
                  Write(LuPri,'(3X,A,I8,/,3X,A)')
     &            'Vector batch number:',iBatch,
     &            '++++++++++++++++++++++++++++'
                  Write(LuPri,'(6X,A,I8)')
     &            'Number of vectors in this batch:',nVec_this_batch
                  Write(LuPri,'(6X,A,I8,1X,I8)')
     &            'First and last vector          :',J1,J2
                  Call Cho_Flush(LuPri)
                  Call Cho_Timer(X0,Y0)
               End If
               ! Loop through SP blocks of vectors in this vector batch
               iAdr0=0
               iSP1=1
               Do iSP_Batch=1,nSP_Batch
                  nSP_this_batch=SP_BatchDim(iSP_Batch)
                  iSP2=iSP1+nSP_this_batch-1
                  nDim=0
                  Do iSP=iSP1,iSP2
                     nDim=nDim+nnBstRSh(iSym,id_mySP(iSP),2)
                  End Do
                  If (nDim.gt.0) Then
                     ! Read vector block
                     lTot=nDim*nVec_this_batch
                     iAdr=iAdr0+nDim*(J1-1)
                     Call DDAFile(LuTmp(iSym),2,Work(ip_V),lTot,iAdr)
                     iAdr0=iAdr0+nDim*NVT(iSym)
                     ! Put vector block into global array
                     kV=ip_V
                     Do iSP_=iSP1,iSP2
                        iSP=id_mySP(iSP_)
                        If (nnBstRSh(iSym,iSP,2).gt.0) Then
                           myStart=iiBstRSh(iSym,iSP,2)+1
                           myEnd=myStart+nnBstRSh(iSym,iSP,2)-1
C VPV:
                           Call ga_put(g_a,myStart,myEnd,1,
     &                          nVec_this_batch,Work(kV),nDim)
                           kV=kV+nnBstRSh(iSym,iSP,2)
                        End If
                     End Do
CCC ORIGINAL_CODE
C                     Do J=1,nVec_this_batch
C                        Do iSP_=iSP1,iSP2
C                           iSP=id_mySP(iSP_)
C                           If (nnBstRSh(iSym,iSP,2).gt.0) Then
C                              myStart=iiBstRSh(iSym,iSP,2)+1
C                              myEnd=myStart+nnBstRSh(iSym,iSP,2)-1
C                              write(6,*) "ga_put:", myStart,myEnd,J,kv,
C     &                        nnBstRSh(iSym,iSP,2),nDim
C                              Call ga_put(g_a,myStart,myEnd,J,J,
C     &                                    Work(kV),nnBstRSh(iSym,iSP,2))
C                              kV=kV+nnBstRSh(iSym,iSP,2)
C                           End If
C                        End Do
C                     End Do
CCC END OF ORIGINAL
                  End If
                  iSP1=iSP1+nSP_this_batch
               End Do
               If (iPrint.ge.Inf_Progress) Then
                  Call Cho_Timer(X1,Y1)
                  Write(LuPri,'(6X,A,F12.2,1X,F12.2)')
     &            'Time for read/ga_put (sec)     :',(X1-X0),(Y1-Y0)
                  Call Cho_Flush(LuPri)
               End If
               ! Sync: all must be done putting data into g_a
               Call Cho_GASync()
               ! Compute vector distribution for this batch
               my_nV=0
               Call Cho_P_Distrib_Vec(J1,J2,iWork(ip_IDV),my_nV)
               If (iPrint.ge.Inf_Progress) Then
                  Call Cho_Timer(X0,Y0)
               End If
               ! Get vectors from global array
               J0=J1-1
               kV=ip_V
#if defined(_GA_)
               Do i=1,my_nV
                  J=iWork(ip_IDV-1+i)-J0
                  Call ga_get(g_a,1,nnBstR(iSym,2),J,J,
     &                        Work(kV),nnBstR(iSym,2))
                  kV=kV+nnBstR(iSym,2)
               End Do
#else
               if(my_nV.gt.0) Then
                  Jst=iWork(ip_IDV)-J0
                  Jen=iWork(ip_IDV-1+my_nV)-J0
                  Call ga_get_striped(g_a,1,nnBstR(iSym,2),Jst,
     &                 Jen,Work(kV),nnBstR(iSym,2),nProcs)
                  kV=kV+nnBstR(iSym,2)*my_nV
               End If
               ! VVP: First performs RMA and only then I/O
               Call Cho_GASync()
#endif
               ! Write vectors to disk
               lTot=nnBstR(iSym,2)*my_nV
               If (lTot .gt. 0) Then
                  iAdr=nnBstR(iSym,2)*iWork(ip_myNumCho-1+iSym)
                  Call DDAFile(LuCho(iSym),iOpt,Work(ip_V),lTot,iAdr)
               End If
               If (iPrint.ge.Inf_Progress) Then
                  Call Cho_Timer(X1,Y1)
                  Write(LuPri,'(6X,A,F12.2,1X,F12.2)')
     &            'Time for ga_get/write (sec)    :',(X1-X0),(Y1-Y0)
                  Call Cho_Flush(LuPri)
               End If
               ! Update my vector counter
               iWork(ip_myNumCho-1+iSym)=iWork(ip_myNumCho-1+iSym)+my_nV
            End Do
            ! Destroy global array
            ok = ga_destroy(g_a)
            ! Deallocations
            Call GetMem('GADIST','Free','Inte',ip_IDV,l_IDV)
            Call GetMem('GAVEC','Free','Real',ip_V,l_V)
         End If
      End Do

      ! Deallocations
      Call GetMem('GANUMV','Free','Inte',ip_numV,l_numV)
      Call GetMem('GAMNCH','Free','Inte',ip_myNumCho,l_myNumCho)
#else
      irc=999 ! should never be called in serial installation
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(SP_BatchDim)
         Call Unused_integer_array(id_mySP)
         Call Unused_integer_array(NVT)
      End If
#endif

      End
      SubRoutine Cho_XCV_DV_S(irc,SP_BatchDim,nSP_Batch,id_mySP,n_mySP)
      Implicit None
      Integer irc
      Integer nSP_Batch
      Integer SP_BatchDim(nSP_Batch)
      Integer n_mySP
      Integer id_mySP(n_mySP)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
#include "choprint.fh"

      Character*12 SecNam
      Parameter (SecNam='Cho_XCV_DV_S')

      Real*8 X0, X1, Y0, Y1

      Integer iSym, iSP, iSP1, iSP2, J1, nDim
      Integer ip_Mem, l_Mem
      Integer ip_V, ip_T
      Integer max_vector_dim, max_block_dim
      Integer nVec_per_batch, nVec_this_batch
      Integer iBatch, nBatch
      Integer kV, kT, kOffV, kOffT
      Integer lTot, iAdr, iAdr0
      Integer iSP_Batch, nSP_this_batch

      Integer i, j, k
      Integer iiBstRsh, nnBstRSh
      iiBStRsh(i,j,k)=iWork(ip_iiBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)
      nnBStRsh(i,j,k)=iWork(ip_nnBstRSh-1+nSym*nnShl*(k-1)+nSym*(j-1)+i)

      ! Init return code
      irc=0

      ! Find max vector dimension
      max_vector_dim=nnBstR(1,2)
      Do iSym=2,nSym
         max_vector_dim=max(max_vector_dim,nnBstR(iSym,2))
      End Do
      If (max_vector_dim .lt. 1) Then
         irc=-2
         Return
      End If

      ! Find max block dimension
      max_block_dim=0
      iSP1=1
      Do iSP_Batch=1,nSP_Batch
         nSP_this_batch=SP_BatchDim(iSP_Batch)
         iSP2=iSP1+nSP_this_batch-1
         Do iSym=1,nSym
            nDim=0
            Do iSP=iSP1,iSP2
               nDim=nDim+nnBstRSh(iSym,id_mySP(iSP),2)
            End Do
            max_block_dim=max(max_block_dim,nDim)
         End Do
         iSP1=iSP1+nSP_this_batch
      End Do
#if defined (_DEBUGPRINT_)
      If ((iSP1-1).ne.n_mySP) Then
         Call Cho_Quit(SecNam//': SP batch dimension error',103)
      End If
#endif

      ! Get largest memory block
      Call GetMem('DVSMX','Max ','Real',ip_Mem,l_Mem)
      lTot=max_vector_dim+max_block_dim
      If (l_Mem .lt. lTot) Then
         irc=-1
         Return
      End If
      Call GetMem('DVSVEC','Allo','Real',ip_Mem,l_Mem)

      ! read, reorder, and write vectors, one symmetry at a time
      Do iSym=1,nSym
         If (iPrint.ge.Inf_Progress) Then
            Write(LuPri,'(/,A,I2,/,A)')
     &      'Writing vectors, symmetry',iSym,
     &      '---------------------------'
            Write(LuPri,'(3X,A,I8)')
     &      'Total number of vectors:',NumCho(iSym)
            Write(LuPri,'(3X,A,I8)')
     &      'Vector dimension       :',nnBstR(iSym,2)
            Write(LuPri,'(3X,A,I8)')
     &      'Shell pair batches     :',nSP_Batch
            Call Cho_Flush(LuPri)
         End If
         If (NumCho(iSym).gt.0 .and. nnBstR(iSym,2).gt.0) Then
            ! Set up batching
            lTot=max_block_dim+nnBstR(iSym,2)
            nVec_per_batch=min(l_Mem/lTot,NumCho(iSym))
            If (nVec_per_batch .lt. 1) Then
               Call Cho_Quit(
     &               'Insufficient memory for batching in '//SecNam,101)
            End If
            nBatch=(NumCho(iSym)-1)/nVec_per_batch+1
            If (iPrint.ge.Inf_Progress) Then
               Write(LuPri,'(3X,A,I8)')
     &         'Vector batches         :',nBatch
               Call Cho_Flush(LuPri)
            End If
            ! Read and write vectors in batches
            Do iBatch=1,nBatch
               ! Determine number of vectors in this batch
               If (iBatch.eq.nBatch) Then
                  nVec_this_batch=NumCho(iSym)-nVec_per_batch*(nBatch-1)
               Else
                  nVec_this_batch=nVec_per_batch
               End If
               ! First vector in this batch
               J1=nVec_per_batch*(iBatch-1)+1
               If (iPrint.ge.Inf_Progress) Then
                  Write(LuPri,'(3X,A,I8,/,3X,A)')
     &            'Vector batch number:',iBatch,
     &            '++++++++++++++++++++++++++++'
                  Write(LuPri,'(6X,A,I8)')
     &            'Number of vectors in this batch:',nVec_this_batch
                  Write(LuPri,'(6X,A,I8,1X,I8)')
     &            'First and last vector          :',
     &            J1,J1+nVec_this_batch-1
                  Call Cho_Flush(LuPri)
                  Call Cho_Timer(X0,Y0)
               End If
               ! Set memory pointers
               ip_T=ip_Mem
               ip_V=ip_T+max_block_dim*nVec_this_batch
               ! Read blocked vectors and copy into full vector array
               iAdr0=0
               iSP1=1
               Do iSP_Batch=1,nSP_Batch
                  nSP_this_batch=SP_BatchDim(iSP_Batch)
                  iSP2=iSP1+nSP_this_batch-1
                  nDim=0
                  Do iSP=iSP1,iSP2
                     nDim=nDim+nnBstRSh(iSym,id_mySP(iSP),2)
                  End Do
                  If (nDim.gt.0) Then
                     lToT=nDim*nVec_this_batch
                     iAdr=iAdr0+nDim*(J1-1)
                     Call DDAFile(LuTmp(iSym),2,Work(ip_T),lTot,iAdr)
                     kT=ip_T-1
                     kV=ip_V-1
                     Do J=1,nVec_this_batch
                        kOffT=kT+nDim*(J-1)
                        kOffV=kV+nnBstR(iSym,2)*(J-1)
     &                          +iiBstRSh(iSym,id_mySP(iSP1),2)
                        Do i=1,nDim
                           Work(kOffV+i)=Work(kOffT+i)
                        End Do
                     End Do
                     iAdr0=iAdr0+nDim*NumCho(iSym)
                  End If
                  iSP1=iSP1+nSP_this_batch
               End Do
               If (iPrint.ge.Inf_Progress) Then
                  Call Cho_Timer(X1,Y1)
                  Write(LuPri,'(6X,A,F12.2,1X,F12.2)')
     &            'Time for read/reorder (sec)    :',(X1-X0),(Y1-Y0)
                  Call Cho_Flush(LuPri)
               End If
               ! Write full vectors to disk
               lTot=nnBstR(iSym,2)*nVec_this_batch
               iAdr=nnBstR(iSym,2)*(J1-1)
               Call DDAFile(LuCho(iSym),1,Work(ip_V),lTot,iAdr)
               If (iPrint.ge.Inf_Progress) Then
                  Call Cho_Timer(X0,Y0)
                  Write(LuPri,'(6X,A,F12.2,1X,F12.2)')
     &            'Time for write (sec)           :',(X0-X1),(Y0-Y1)
                  Call Cho_Flush(LuPri)
               End If
            End Do
         End If
      End Do

      ! Deallocation
      Call GetMem('DVSVEC','Free','Real',ip_Mem,l_Mem)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine InCSFSD(iState,State_sym,GUGA)
      use Str_Info, only: CNSM
      Implicit Real*8 (a-h,o-z)
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "Files_mclr.fh"
#include "spinfo_mclr.fh"
#include "stdalloc.fh"
      Logical GUGA
      Integer State_sym
      Dimension idum(1)
*
#include "csfsd.fh"

*     Place pointer
*
      iSym=iEor(State_Sym-1,iState-1)+1
*
      If (isym.eq.1.and.i1.eq.1) Return
      If (isym.eq.iAnders) Return
*
      iAdr=2
      If (iSym.eq.1) iAdr=1
      iad=0
      Do i=1,iState-1
         Call iDafile(LUCSF2SD,0,idum,lldet,iad)
         Call iDafile(LUCSF2SD,0,idum,lconf,iad)
      End Do
*
      If (iSym.ne.1) Then
         If (iAnders.eq.-9)  Then
             Call mma_allocate(CNSM(2)%icts,lldet,Label='ICTS')
             Call mma_allocate(CNSM(2)%iconf,lConf,Label='ICONF')
             iAllo=1
         End If
         iAnders=isym
      End If
      If (iSym.eq.1) Then
          If (i1.eq.-9) Then
           Call mma_allocate(CNSM(1)%icts,lldet,Label='ICTS')
           Call mma_allocate(CNSM(1)%iconf,lConf,Label='ICONF')
           i1=1
          End If
      End If

!      open(unit=1422,file="det.index") ! yma
!      do i=1,lldet
!        write(1422,*)CNSM(iAdr)%icts(i)
!      end do
!      close(1422)

! calculated from zoo.f, the GUGA number for determinent
      Call iDafile(LUCSF2SD,2,CNSM(iAdr)%icts,lldet,iad)
      Call iDafile(LUCSF2SD,2,CNSM(iAdr)%iconf,lconf,iad)

      Return

c Avoid unused argument warnings
      If (.False.) Call Unused_logical(GUGA)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine lattXPol(Grid,nGrid,nGrid_Eff,PolEff,DipEff,
     &                    XF,nXF,nOrd_XF,nPolComp)
*
      Implicit Real*8 (a-h,o-z)
*
      Real*8 Grid(3,nGrid), PolEff(nPolComp,nGrid), DipEff(nGrid)
      Real*8 XF(*)

#include "real.fh"

*
*     Statement function for Cartesian index
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2

*     Calculate number of entries per XFIELD point
      Inc = 3
      Do iOrdOp = 0, nOrd_XF
         Inc = Inc + nElem(iOrdOp)
      End Do
      Inc = Inc + 6  !iXpolType always .gt.0

*     Insert XFIELD polarisabilities into Grid
      Do iXF=1,nXF
         nGrid_Eff=nGrid_Eff+1
         Do j=1,nPolComp
            PolEff(j,nGrid_Eff)=XF(iXF*Inc-6+j)
         EndDo
         DipEff(nGrid_Eff)=Zero
         Do j=1,3
            Grid(j,nGrid_Eff)=XF((iXF-1)*Inc+j)
         EndDo
      EndDo

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1984,1989, Per Ake Malmqvist                           *
************************************************************************
      SUBROUTINE PART(SXY,TRA1,TRA2)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION SXY(NSXY),TRA1(NTRA),TRA2(NTRA)
      DIMENSION NSIZE(4)
C  PURPOSE: SXY CONTAINS THE NONSECONDARY PART OF THE MO OVERLAP
C  MATRIX. UPON RETURN, TRA1 AND TRA2 WILL CONTAIN THE COEFFICIENTS
C  FOR SEQUENTIAL SINGLE-ORBITAL TRANSFORMATIONS (VI.2, MY IJQC ARTICLE)
C  TO BIORTHONORMAL ORBITALS. SXY, TRA1 AND TRA2 ARE SYMMETRY-BLOCKED.
C  ORIGINAL VERSION, MALMQUIST 84-04-04
C  RASSCF VERSION,   MALMQUIST 89-11-15
#include "WrkSpc.fh"
#include "rasdef.fh"
#include "symmul.fh"
#include "rassi.fh"
      NOMAX=0
      DO 5 ISY=1,NSYM
        NOMAX=MAX(NOSH(ISY),NOMAX)
5     CONTINUE
      CALL GETMEM('SCRMAT','ALLO','REAL',LSCRMAT,NOMAX*NOMAX)
      CALL GETMEM('SCRPIV','ALLO','INTE',LSCRPIV,2*NOMAX)
      CALL GETMEM('SCRBUF','ALLO','REAL',LSCRBUF,NOMAX)
      II=1
      DO 10 ISY=1,NSYM
        NDIMEN=NOSH(ISY)
        IF(NDIMEN.EQ.0) GOTO 10
        NBLOCK=0
        N=NISH(ISY)
        IF(N.GT.0) THEN
          NBLOCK=NBLOCK+1
          NSIZE(NBLOCK)=N
        END IF
        N=NRS1(ISY)
        IF(N.GT.0) THEN
          NBLOCK=NBLOCK+1
          NSIZE(NBLOCK)=N
        END IF
        N=NRS2(ISY)
        IF(N.GT.0) THEN
          NBLOCK=NBLOCK+1
          NSIZE(NBLOCK)=N
        END IF
        N=NRS3(ISY)
        IF(N.GT.0) THEN
          NBLOCK=NBLOCK+1
          NSIZE(NBLOCK)=N
        END IF
        CALL PART1(NDIMEN,NBLOCK,NSIZE,SXY(II),TRA1(II),TRA2(II),
     *             WORK(LSCRMAT),IWORK(LSCRPIV),WORK(LSCRBUF))
        II=II+NDIMEN**2
10      CONTINUE
      CALL GETMEM('SCRMAT','FREE','REAL',LSCRMAT,NOMAX*NOMAX)
      CALL GETMEM('SCRPIV','FREE','INTE',LSCRPIV,2*NOMAX)
      CALL GETMEM('SCRBUF','FREE','REAL',LSCRBUF,NOMAX)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Roland Lindh                                     *
!***********************************************************************
!***********************************************************************
!         MODULE for TRANSFORMATION of CHOLESKY VECTORS                *
!              and GENERATION of TWO-ELECTRONS INTEGRALS               *
!***********************************************************************

module Data_Structures

use Symmetry_Info, only: Mul
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
private

public :: Alloc1DiArray_Type, Alloc1DArray_Type, Alloc2DArray_Type, Allocate_DT, Deallocate_DT, DSBA_Type, G2_Type, &
          Integer_Pointer, L_Full_Type, Lab_Type, NDSBA_Type, SBA_Type, twxy_Type, V1, V2
! temporary subroutines for interface with old code
public :: Map_to_DSBA, Map_to_SBA, Map_to_twxy

type Integer_Pointer
  integer(kind=iwp), contiguous, pointer :: I1(:) => null()
end type Integer_Pointer

type SB_Type
  real(kind=wp), contiguous, pointer :: A3(:,:,:) => null()
  real(kind=wp), contiguous, pointer :: A2(:,:) => null()
  real(kind=wp), contiguous, pointer :: A1(:) => null()
end type SB_Type

type DSB_Type
  real(kind=wp), contiguous, pointer :: A2(:,:) => null()
  real(kind=wp), contiguous, pointer :: A1(:) => null()
end type DSB_Type

type V1
  real(kind=wp), contiguous, pointer :: A(:) => null()
end type V1

type V2
  real(kind=wp), contiguous, pointer :: A(:,:) => null()
end type V2

type G2_pointers
  real(kind=wp), contiguous, pointer :: A4(:,:,:,:) => null()
  real(kind=wp), contiguous, pointer :: A2(:,:) => null()
end type G2_pointers

type L_Full_Pointers
  real(kind=wp), contiguous, pointer :: A3(:,:,:) => null()
  real(kind=wp), contiguous, pointer :: A21(:,:) => null()
  real(kind=wp), contiguous, pointer :: A12(:,:) => null()
end type L_Full_Pointers

type NDSBA_Type
  integer(kind=iwp) :: iCase = 0
  integer(kind=iwp) :: nSym = 0
  real(kind=wp), allocatable :: A0(:)
  type(DSB_Type) :: SB(8,8)
end type NDSBA_Type

type DSBA_Type
  integer(kind=iwp) :: iCase = 0
  integer(kind=iwp) :: nSym = 0
  logical(kind=iwp) :: Fake = .false.
  logical(kind=iwp) :: Active = .false.
  real(kind=wp), allocatable :: A00(:)
  real(kind=wp), contiguous, pointer :: A0(:) => null()
  type(DSB_Type) :: SB(8)
end type DSBA_Type

type SBA_Type
  integer(kind=iwp) :: iCase = 0
  integer(kind=iwp) :: iSym = 0
  integer(kind=iwp) :: nSym = 0
  real(kind=wp), allocatable :: A0(:)
  type(SB_Type) :: SB(8)
end type SBA_Type

type twxy_type
  integer(kind=iwp) :: iCase = 0
  integer(kind=iwp) :: JSYM = 0
  integer(kind=iwp) :: nSym = 0
  real(kind=wp), allocatable :: twxy_full(:)
  type(V2) :: SB(8,8)
end type twxy_type

type G2_type
  integer(kind=iwp) :: iCase = 0
  integer(kind=iwp) :: nSym = 0
  real(kind=wp), allocatable :: A0(:)
  type(G2_Pointers) :: SB(8,8,8)
end type G2_type

type L_Full_Type
  integer(kind=iwp) :: iCase = 0
  integer(kind=iwp) :: iSym = 0
  integer(kind=iwp) :: nSym = 0
  integer(kind=iwp) :: nShell = 0
  real(kind=wp), allocatable :: A0(:)
  type(L_Full_Pointers), allocatable :: SPB(:,:,:)
end type L_Full_Type

type Lab_Type
  integer(kind=iwp) :: nSym = 0
  integer(kind=iwp) :: nDen = 0
  integer(kind=iwp) :: nShell = 0
  real(kind=wp), allocatable :: A0(:)
  logical(kind=iwp), allocatable :: Keep(:,:)
  type(V1), allocatable :: SB(:,:,:)
end type Lab_Type

type Alloc1DArray_Type
  real(kind=wp), allocatable :: A(:)
end type Alloc1DArray_Type

type Alloc2DArray_Type
  real(kind=wp), allocatable :: A(:,:)
end type Alloc2DArray_Type

type Alloc1DiArray_Type
  integer(kind=iwp), allocatable :: A(:)
end type Alloc1DiArray_Type

! Allocate/deallocate data types
interface Allocate_DT
  module procedure :: Allocate_DSBA, Allocate_SBA, Allocate_twxy, Allocate_NDSBA, Allocate_G2, Allocate_L_Full, Allocate_Lab, &
                      Alloc_Alloc_DSBA, Alloc_Alloc1DArray, Alloc2D_Alloc1DArray, Alloc_Alloc2DArray
end interface Allocate_DT
interface Deallocate_DT
  module procedure :: Deallocate_DSBA, Deallocate_SBA, Deallocate_twxy, Deallocate_NDSBA, Deallocate_G2, Deallocate_L_Full, &
                      Deallocate_Lab, Free_Alloc_DSBA, Free_Alloc1DArray, Free2D_Alloc1DArray, Free_Alloc2DArray
end interface Deallocate_DT

! Private extensions to mma interfaces
interface cptr2loff
  module procedure :: lfp_cptr2loff, v1_cptr2loff, dsba_cptr2loff, a1da_cptr2loff, a2da_cptr2loff
end interface
interface mma_allocate
  module procedure :: lfp_mma_allo_3D, lfp_mma_allo_3D_lim, v1_mma_allo_3D, v1_mma_allo_3D_lim, dsba_mma_allo_1D, &
                      dsba_mma_allo_1D_lim, a1da_mma_allo_1D, a1da_mma_allo_1D_lim, a1da_mma_allo_2D, a1da_mma_allo_2D_lim, &
                      a2da_mma_allo_1D, a2da_mma_allo_1D_lim
end interface
interface mma_deallocate
  module procedure :: lfp_mma_free_3D, v1_mma_free_3D, dsba_mma_free_1D, a1da_mma_free_1D, a1da_mma_free_2D, a2da_mma_free_1D
end interface

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!                N D S B A - T Y P E   S E C T I O N                   !
!                                                                      !
!                Non-Diagonal Symmetry Blocked Arrays                  !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Allocate_NDSBA(Adam,n,m,nSym,Label)

  type(NDSBA_Type), target, intent(out) :: Adam
  integer(kind=iwp), intent(in) :: nSym, n(nSym), m(nSym)
  character(len=*), intent(in), optional :: Label
  integer(kind=iwp) :: iE, iS, iSym, jSym, MemTot

  Adam%iCase = 1
  Adam%nSym = nSym

  MemTot = 0
  do jSym=1,nSym
    do iSym=jSym,nSym
      MemTot = MemTot+n(iSym)*m(jSym)
    end do
  end do
  if (present(Label)) then
    call mma_allocate(Adam%A0,MemTot,Label=Label)
  else
    call mma_allocate(Adam%A0,MemTot,Label='%A0')
  end if

  iE = 0
  do jSym=1,nSym
    do iSym=jSym,nSym
      iS = iE+1
      iE = iE+n(iSym)*m(jSym)

      Adam%SB(jSym,iSym)%A2(1:n(iSym),1:m(jSym)) => Adam%A0(iS:iE)
      Adam%SB(jSym,iSym)%A1(1:n(iSym)*m(jSym)) => Adam%A0(iS:iE)
      Adam%SB(iSym,jSym)%A2(1:n(iSym),1:m(jSym)) => Adam%A0(iS:iE)
      Adam%SB(iSym,jSym)%A1(1:n(iSym)*m(jSym)) => Adam%A0(iS:iE)
    end do
  end do

end subroutine Allocate_NDSBA

subroutine Deallocate_NDSBA(Adam)

  type(NDSBA_Type), intent(inout) :: Adam
  integer(kind=iwp) :: iSym, jSym

  do iSym=1,Adam%nSym
    do jSym=1,Adam%nSym
      Adam%SB(iSym,jSym)%A2 => null()
      Adam%SB(iSym,jSym)%A1 => null()
    end do
  end do
  call mma_deallocate(Adam%A0)
  Adam%nSym = 0
  Adam%iCase = 0

end subroutine Deallocate_NDSBA

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!                D S B A - T Y P E   S E C T I O N                     !
!                                                                      !
!                Diagonal Symmetry Blocked Arrays                      !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Allocate_DSBA(Adam,n,m,nSym,aCase,Ref,Label)

  type(DSBA_Type), target, intent(out) :: Adam
  integer(kind=iwp), intent(in) :: nSym, n(nSym), m(nSym)
  character(len=3), intent(in), optional :: aCase
  real(kind=wp), target, intent(in), optional :: Ref(*)
  character(len=*), intent(in), optional :: Label
  integer(kind=iwp) :: iE, iS, iSym, MemTot, iCase = 0
  character(len=3) :: aCase_

  if (Adam%Active) then
    write(u6,*) 'DSBA-Type double allocate'
    call abend()
  end if

  if (present(aCase)) then
    aCase_ = aCase
  else
    aCase_ = 'REC'
  end if
  select case (aCase_)
    case ('TRI')
      iCase = 2
      do iSym=1,nSym
        if (n(iSym) /= m(iSym)) then
          write(u6,*) 'Allocate_DSBA: n(iSym)/=m(iSym), illegal if aCase="TRI".'
          call Abend()
        end if
      end do
    case ('REC')
      iCase = 1
    case ('ONE')
      iCase = 0
    case default
      write(u6,*) 'Allocate_DSBA: Illegal aCase parameter, aCase=',aCase_
      write(u6,*) 'Allowed value are "TRI", "REC", and "ONE".'
      call Abend()
  end select
  Adam%iCase = iCase
  Adam%nSym = nSym

  MemTot = 0
  select case (iCase)
    case (0)
      do iSym=1,nSym
        MemTot = MemTot+n(iSym)
      end do
    case (1)
      do iSym=1,nSym
        MemTot = MemTot+n(iSym)*m(iSym)
      end do
    case (2)
      do iSym=1,nSym
        MemTot = MemTot+n(iSym)*(n(iSym)+1)/2
      end do
  end select
  if (present(Ref)) then
    Adam%Fake = .true.
    Adam%A0(1:MemTot) => Ref(1:MemTot)
  else
    Adam%A0 => null()
    if (present(Label)) then
      call mma_allocate(Adam%A00,MemTot,Label=Label)
    else
      call mma_allocate(Adam%A00,MemTot,Label='%A00')
    end if
    Adam%A0(1:MemTot) => Adam%A00(1:MemTot)
  end if

  Adam%Active = .true.
  iE = 0
  select case (iCase)
    case (0)
      do iSym=1,nSym
        iS = iE+1
        iE = iE+n(iSym)

        Adam%SB(iSym)%A1(1:n(iSym)) => Adam%A0(iS:iE)
      end do
    case (1)
      do iSym=1,nSym
        iS = iE+1
        iE = iE+n(iSym)*m(iSym)

        Adam%SB(iSym)%A2(1:n(iSym),1:m(iSym)) => Adam%A0(iS:iE)
        Adam%SB(iSym)%A1(1:n(iSym)*m(iSym)) => Adam%A0(iS:iE)
      end do
    case (2)
      do iSym=1,nSym
        iS = iE+1
        iE = iE+n(iSym)*(n(iSym)+1)/2

        Adam%SB(iSym)%A1(1:n(iSym)*(n(iSym)+1)/2) => Adam%A0(iS:iE)
      end do
  end select

end subroutine Allocate_DSBA

subroutine Deallocate_DSBA(Adam)

  type(DSBA_Type), intent(inout) :: Adam
  integer(kind=iwp) :: iSym

  if (.not. Adam%Active) return

  Adam%Active = .false.
  select case (Adam%iCase)
    case (0,2)
      do iSym=1,Adam%nSym
        Adam%SB(iSym)%A1 => null()
      end do
    case (1)
      do iSym=1,Adam%nSym
        Adam%SB(iSym)%A2 => null()
        Adam%SB(iSym)%A1 => null()
      end do
  end select
  if (Adam%Fake) then
    Adam%A0 => null()
    Adam%Fake = .false.
  else
    Adam%A0 => null()
    call mma_deallocate(Adam%A00)
  end if
  Adam%nSym = 0
  Adam%iCase = 0

end subroutine Deallocate_DSBA

subroutine Map_to_DSBA(Adam,ipAdam)

  type(DSBA_Type), intent(in) :: Adam
  integer(kind=iwp), intent(out) :: ipAdam(Adam%nSym)
  integer(kind=iwp) :: iSym
  integer(kind=iwp), external :: ip_of_Work

  do iSym=1,Adam%nSym
    ipAdam(iSym) = ip_of_Work(Adam%SB(iSym)%A1(1))
  end do

end subroutine Map_to_DSBA

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!                  S B A - T Y P E   S E C T I O N                     !
!                                                                      !
!                    Symmetry Blocked Arrays                           !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Allocate_SBA(Adam,n,m,NUMV,iSym,nSym,iCase,Memory,Label)

  type(SBA_Type), target, intent(out) :: Adam
  integer(kind=iwp), intent(in) :: nSym, n(nSym), m(nSym), NUMV, iSym, iCase
  integer(kind=iwp), intent(out), optional :: Memory
  character(len=*), intent(in), optional :: Label
  integer(kind=iwp) :: iE, iS, iSyma, iSymb, MemTot, n2Dim, n3Dim

  MemTot = 0

  select case (iCase)
    case (0)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        MemTot = MemTot+n(iSyma)*m(iSymb)*NUMV
      end do
    case (1)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        MemTot = MemTot+m(iSyma)*n(iSymb)*NUMV
      end do
    case (2)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        MemTot = MemTot+n(iSyma)*NUMV*m(iSymb)
      end do
    case (3)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        MemTot = MemTot+m(iSyma)*NUMV*n(iSymb)
      end do
    case (4)
      do iSyma=1,nSym
        if (n(iSyma) /= m(iSyma)) then
          write(u6,*) 'Allocate_SBA: iCase=4 only valid if n(:)=m(:).'
          call abend()
        end if
        iSymb = Mul(iSym,iSyma)
        if (iSyma == iSymb) then
          n2Dim = n(iSyma)*(n(iSyma)+1)/2
        else
          n2Dim = n(iSyma)*n(iSymb)
        end if
        MemTot = MemTot+n2dim*NUMV
      end do
    case (5)
      do iSyma=1,nSym
        if (n(iSyma) /= m(iSyma)) then
          write(u6,*) 'Allocate_SBA: iCase=5 only valid if n(:)=m(:).'
          call abend()
        end if
        iSymb = Mul(iSym,iSyma)
        if (iSyma == iSymb) then
          n2Dim = n(iSyma)*(n(iSyma)+1)/2
        else if (iSymb > iSyma) then
          n2Dim = n(iSyma)*n(iSymb)
        else
          n2Dim = 0
        end if
        MemTot = MemTot+n2dim*NUMV
      end do
    case (6)
      do iSyma=1,nSym
        if (n(iSyma) /= m(iSyma)) then
          write(u6,*) 'Allocate_SBA: iCase=6 only valid if n(:)=m(:).'
          call abend()
        end if
        iSymb = Mul(iSym,iSyma)
        if (iSyma >= iSymb) then
          n2Dim = n(iSyma)*n(iSymb)
        else
          n2Dim = 0
        end if
        MemTot = MemTot+n2dim*NUMV
      end do
    case default
      write(u6,*) 'Allocate_SBA: Illegal case.'
      call Abend()
  end select

  if (present(Memory)) then
    Memory = MemTot
    return
  end if

  Adam%iSym = iSym
  Adam%nSym = nSym
  Adam%iCase = iCase

  if (present(Label)) then
    call mma_allocate(Adam%A0,MemTot,Label=Label)
  else
    call mma_allocate(Adam%A0,MemTot,Label='%A0')
  end if

  iE = 0

  select case (iCase)
    case (0)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        iS = iE+1
        iE = iE+n(iSyma)*m(iSymb)*NUMV
        n2Dim = n(iSyma)*m(iSymb)
        n3Dim = n2Dim*NUMV
        Adam%SB(iSyma)%A1(1:n3Dim) => Adam%A0(iS:iE)
        Adam%SB(iSyma)%A2(1:n2Dim,1:NUMV) => Adam%A0(iS:iE)
        Adam%SB(iSyma)%A3(1:n(iSyma),1:m(iSymb),1:NUMV) => Adam%A0(iS:iE)
      end do
    case (1)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        iS = iE+1
        iE = iE+m(iSyma)*n(iSymb)*NUMV
        n2Dim = m(iSyma)*n(iSymb)
        n3Dim = n2Dim*NUMV
        Adam%SB(iSyma)%A1(1:n3Dim) => Adam%A0(iS:iE)
        Adam%SB(iSyma)%A2(1:n2Dim,1:NUMV) => Adam%A0(iS:iE)
        Adam%SB(iSyma)%A3(1:m(iSyma),1:n(iSymb),1:NUMV) => Adam%A0(iS:iE)
      end do
    case (2)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        iS = iE+1
        iE = iE+n(iSyma)*NUMV*m(iSymb)
        Adam%SB(iSyma)%A3(1:n(iSyma),1:NUMV,1:m(iSymb)) => Adam%A0(iS:iE)
      end do
    case (3)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        iS = iE+1
        iE = iE+m(iSyma)*NUMV*n(iSymb)
        Adam%SB(iSyma)%A3(1:m(iSyma),1:NUMV,1:n(iSymb)) => Adam%A0(iS:iE)
      end do
    case (4)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        iS = iE+1
        if (iSyma == iSymb) then
          n2Dim = n(iSyma)*(n(iSyma)+1)/2
        else
          n2Dim = n(iSyma)*n(iSymb)
        end if
        iE = iE+n2Dim*NUMV
        Adam%SB(iSymb)%A2(1:n2Dim,1:NUMV) => Adam%A0(iS:iE)
      end do
    case (5)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        if (iSymb > iSyma) cycle
        iS = iE+1
        if (iSyma == iSymb) then
          n2Dim = n(iSyma)*(n(iSyma)+1)/2
        else
          n2Dim = n(iSyma)*n(iSymb)
        end if
        iE = iE+n2Dim*NUMV
        Adam%SB(iSymb)%A2(1:n2Dim,1:NUMV) => Adam%A0(iS:iE)
      end do
    case (6)
      do iSyma=1,nSym
        iSymb = Mul(iSym,iSyma)
        if (iSymb > iSyma) cycle
        iS = iE+1
        n2Dim = n(iSyma)*n(iSymb)
        iE = iE+n2Dim*NUMV
        Adam%SB(iSymb)%A2(1:n2Dim,1:NUMV) => Adam%A0(iS:iE)
      end do
    case default
      write(u6,*) 'Allocate_SBA: Illegal case.'
      call Abend()
  end select

end subroutine Allocate_SBA

subroutine Deallocate_SBA(Adam)

  type(SBA_Type), intent(inout) :: Adam
  integer(kind=iwp) :: iSym

  do iSym=1,Adam%nSym
    Adam%SB(iSym)%A1 => null()
    Adam%SB(iSym)%A2 => null()
    Adam%SB(iSym)%A3 => null()
  end do
  call mma_deallocate(Adam%A0)
  Adam%iCase = 0
  Adam%iSym = 0
  Adam%nSym = 0

end subroutine Deallocate_SBA

subroutine Map_to_SBA(Adam,ipAdam,Tweak)

  type(SBA_Type), intent(in) :: Adam
  integer(kind=iwp), intent(out) :: ipAdam(Adam%nSym)
  logical(kind=iwp), optional :: Tweak
  integer(kind=iwp) :: iSym, jSym
  logical(kind=iwp) :: Swap
  integer(kind=iwp), external :: ip_of_Work

  if (Adam%iCase < 4) then
    do iSym=1,Adam%nSym
      ipAdam(iSym) = ip_of_Work(Adam%SB(iSym)%A3(1,1,1))
    end do
  else
    Swap = .false.
    if (present(Tweak)) Swap = Tweak
    if (Swap) then
      do iSym=1,Adam%nSym
        jsym = Mul(iSym,Adam%iSym)
        if (.not. associated(Adam%SB(jSym)%A2)) cycle

        ipAdam(iSym) = ip_of_Work(Adam%SB(jSym)%A2(1,1))

      end do
    else
      do iSym=1,Adam%nSym
        if (.not. associated(Adam%SB(iSym)%A2)) cycle

        ipAdam(iSym) = ip_of_Work(Adam%SB(iSym)%A2(1,1))
      end do
    end if
  end if

end subroutine Map_to_SBA

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!                  T W X Y - T Y P E   S E C T I O N                   !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Allocate_twxy(twxy,n,m,JSYM,nSym,iCase)

  type(twxy_type), target, intent(out) :: twxy
  integer(kind=iwp), intent(in) :: nSym, n(nSym), m(nSym), JSYM, iCase
  integer(kind=iwp) :: iSymx, iSymy, iSymt, iSymw, iSyma, mtwxy, iS, iE, n1, n2

  twxy%iCase = iCase
  twxy%JSYM = JSYM
  twxy%nSym = nSym
  ! *** memory for the (tw|xy) integrals --- temporary array
  mtwxy = 0
  select case (iCase)
    case (0)  ! twxy
      do iSymy=1,nSym
        if (n(iSymy) /= m(iSymy)) then
          write(u6,*) 'Allocate_twxy: iCase=0 only valid if n(:)=m(:).'
          call abend()
        end if
        iSymx = Mul(iSymy,JSYM)
        n2 = n(iSymx)*n(iSymy)
        do iSymw=iSymy,nSym    ! iSymw >= iSymy (particle symmetry)
          iSymt = Mul(isymw,JSYM)
          n1 = n(iSymt)*n(iSymw)
          mtwxy = mtwxy+n1*n2
        end do
      end do
    case (1) ! waxy
      do iSymy=1,nSym
        iSymx = Mul(iSymy,JSYM)
        n2 = n(iSymx)*n(iSymy)
        if (iSymx == iSymy) n2 = n(iSymx)*(n(iSymx)+1)/2
        if (iSymx <= iSymy) then
          do iSyma=1,nSym
            iSymw = Mul(iSyma,JSYM)
            n1 = n(iSymw)*m(iSyma)
            mtwxy = mtwxy+n1*n2
          end do
        end if
      end do
    case (2)  ! twxy
      do iSymy=1,nSym
        if (n(iSymy) /= m(iSymy)) then
          write(u6,*) 'Allocate_twxy: iCase=2 only valid if n(:)=m(:).'
          call abend()
        end if
        iSymx = Mul(iSymy,JSYM)
        n2 = n(iSymx)*n(iSymy)
        if (iSymx == iSymy) n2 = n(iSymx)*(n(iSymx)+1)/2
        if (iSymx >= iSymy) then
          do iSymw=iSymy,nSym
            iSymt = Mul(iSymw,JSYM)
            if (iSymt >= iSymw) then
              n1 = n(iSymt)*n(iSymw)
              if (iSymt == iSymw) n1 = n(iSymt)*(n(iSymt)+1)/2
              mtwxy = mtwxy+n1*n2
            end if
          end do
        end if
      end do
    case default
      write(u6,*) 'Allocate_twxy: Illegal case.'
      call Abend()
  end select

  call mma_allocate(twxy%twxy_full,mtwxy,Label='twxy')
  twxy%twxy_full(:) = Zero

  ! *** setup pointers to the symmetry blocks of (tw|xy)

  iE = 0
  select case (iCase)
    case (0)
      do iSymy=1,nSym
        iSymx = Mul(iSymy,JSYM)
        n2 = n(iSymx)*n(iSymy)
        do iSymw=iSymy,nSym   ! iSymw >= iSymy (particle symmetry)
          iSymt = Mul(isymw,JSYM)
          n1 = n(iSymt)*n(iSymw)
          iS = iE+1
          iE = iE+n1*n2
          twxy%SB(iSymw,iSymy)%A(1:n1,1:n2) => twxy%twxy_full(iS:iE)
        end do
      end do
    case (1)
      do iSymy=1,nSym
        iSymx = Mul(iSymy,JSYM)
        n2 = n(iSymx)*n(iSymy)
        if (iSymx == iSymy) n2 = n(iSymx)*(n(iSymx)+1)/2
        if (iSymx <= iSymy) then
          do iSyma=1,nSym
            iSymw = Mul(iSyma,JSYM)
            n1 = n(iSymw)*m(iSyma)
            iS = iE+1
            iE = iE+n1*n2
            twxy%SB(iSymw,iSymx)%A(1:n1,1:n2) => twxy%twxy_full(iS:iE)
          end do
        end if
      end do
    case (2) ! twxy
      do iSymy=1,nSym
        iSymx = Mul(iSymy,JSYM)
        n2 = n(iSymx)*n(iSymy)
        if (iSymx == iSymy) n2 = n(iSymx)*(n(iSymx)+1)/2
        if (iSymx >= iSymy) then
          do iSymw=iSymy,nSym ! iSymw >= iSymy
            iSymt = Mul(iSymw,JSYM)
            if (iSymt >= iSymw) then
              n1 = n(iSymt)*n(iSymw)
              if (iSymt == iSymw) n1 = n(iSymt)*(n(iSymt)+1)/2
              iS = iE+1
              iE = iE+n1*n2
              twxy%SB(iSymw,iSymy)%A(1:n1,1:n2) => twxy%twxy_full(iS:iE)
              twxy%SB(iSymy,iSymw)%A(1:n1,1:n2) => twxy%twxy_full(iS:iE) ! symmetrization
            end if
          end do
        end if
      end do
  end select

end subroutine Allocate_twxy

subroutine Deallocate_twxy(twxy)

  type(twxy_type), intent(inout) :: twxy
  integer(kind=iwp) :: iSymy, iSymw

  call mma_deallocate(twxy%twxy_full)

  ! *** setup pointers to the symmetry blocks of (tw|xy)

  do iSymy=1,8
    do iSymw=1,8
      twxy%SB(iSymw,iSymy)%A => null()
    end do
  end do

end subroutine Deallocate_twxy

subroutine Map_to_twxy(Adam,ipAdam)

  type(twxy_type), intent(in) :: Adam
  integer(kind=iwp), intent(out) :: ipAdam(8,8)
  integer(kind=iwp) :: iSymx, iSymy, iSymt, iSymw, iSyma
  integer(kind=iwp), external :: ip_of_Work

  ipAdam(:,:) = 0
  select case (Adam%iCase)
    case (0)
      do iSymy=1,Adam%nSym
        iSymx = Mul(iSymy,Adam%JSYM)
        do iSymw=iSymy,Adam%nSym   ! iSymw >= iSymy (particle symmetry)
          iSymt = Mul(isymw,Adam%JSYM)
          ipAdam(iSymw,iSymy) = ip_of_Work(Adam%SB(iSymw,iSymy)%A(1,1))
        end do
      end do
    case (1)
      do iSymy=1,Adam%nSym
        iSymx = Mul(iSymy,Adam%JSYM)
        if (iSymx <= iSymy) then
          do iSyma=1,Adam%nSym
            iSymw = Mul(iSyma,Adam%JSYM)
            ipAdam(iSymw,iSymx) = ip_of_Work(Adam%SB(iSymw,iSymx)%A(1,1))
          end do
        end if
      end do
    case (2)
      do iSymy=1,Adam%nSym
        iSymx = Mul(iSymy,Adam%JSYM)
        if (iSymx >= iSymy) then
          do iSymw=iSymy,Adam%nSym ! iSymw >= iSymy
            iSymt = Mul(iSymw,Adam%JSYM)
            if (iSymt >= iSymw) then
              ipAdam(iSymw,iSymy) = ip_of_Work(Adam%SB(iSymw,iSymy)%A(1,1))
              ipAdam(iSymy,iSymw) = ip_of_Work(Adam%SB(iSymw,iSymy)%A(1,1))
            end if
          end do
        end if
      end do
  end select

end subroutine Map_to_twxy

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!                      G 2 - T Y P E   S E C T I O N                   !
!                                                                      !
!              Symmetry block 2-particle-like arrays                   !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Allocate_G2(Adam,n,nSym,iCase)

  type(G2_Type), target, intent(out) :: Adam
  integer(kind=iwp), intent(in) :: nSym, n(nSym), iCase
  integer(kind=iwp) :: MemTot, ijSym, iSym, jSym, kSym, lSym, iE, iS, n1, n2, n3, n4, n12, n34

  Adam%nSym = nSym
  Adam%iCase = iCase

  MemTot = 0
  select case (iCase)

    case (1)

      do ijsym=1,nsym
        do isym=1,nsym
          jsym = ieor(isym-1,ijsym-1)+1
          n12 = n(iSym)*n(jSym)
          do kSym=1,nSym
            lSym = ieor(kSym-1,ijSym-1)+1
            n34 = n(kSym)*n(lSym)
            MemTot = MemTot+n12*n34
          end do
        end do
      end do

    case default

      write(u6,*) 'Allocate_G2: illegal case valeu=',iCase
      call Abend()

  end select

  call mma_allocate(Adam%A0,MemTot,Label='G2%A0')

  iE = 0
  select case (iCase)

    case (1)

      do ijsym=1,nsym
        do isym=1,nsym
          jsym = ieor(isym-1,ijsym-1)+1
          n1 = n(iSym)
          n2 = n(jSym)
          n12 = n1*n2
          do kSym=1,nSym
            lSym = ieor(kSym-1,ijSym-1)+1
            n3 = n(kSym)
            n4 = n(lSym)
            n34 = n3*n4
            iS = iE+1
            iE = iE+n12*n34
            Adam%SB(iSym,jSym,kSym)%A4(1:n1,1:n2,1:n3,1:n4) => Adam%A0(iS:iE)
            Adam%SB(iSym,jSym,kSym)%A2(1:n12,1:n34) => Adam%A0(iS:iE)
          end do
        end do
      end do

    case default

      write(u6,*) 'What?'
      call Abend()

  end select

end subroutine Allocate_G2

subroutine Deallocate_G2(Adam)

  type(G2_Type), intent(inout) :: Adam
  integer(kind=iwp) :: iSym, jSym, kSym

  Adam%iCase = 0

  call mma_deallocate(Adam%A0)

  do iSym=1,Adam%nSym
    do jSym=1,Adam%nSym
      do kSym=1,Adam%nSym
        Adam%SB(iSym,jSym,kSym)%A4 => null()
        Adam%SB(iSym,jSym,kSym)%A2 => null()
      end do
    end do
  end do
  Adam%nSym = 0

end subroutine Deallocate_G2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!                      L F u l l - T Y P E   S E C T I O N             !
!                                                                      !
!                      L  full storage shell-pair blocked              !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Allocate_L_Full(Adam,nShell,iShp_rs,JNUM,JSYM,nSym,Memory)

  use ChoArr, only: nBasSh
  use ChoSwp, only: nnBstRSh

  type(L_Full_Type), target, intent(out) :: Adam
  integer(kind=iwp) :: nShell, iShp_rs(nShell*(nShell+2)/2), JNUM, JSYM, nSym
  integer(kind=iwp), intent(out), optional :: Memory(2)
  integer(kind=iwp) :: iaSh, ibSh, iShp, iSyma, iSymb, LFULL, iS, iE, MemSPB, n1, n2

  LFULL = 0
  do iaSh=1,nShell
    do ibSh=1,iaSh
      iShp = iaSh*(iaSh-1)/2+ibSh

      if (iShp_rs(iShp) <= 0) cycle

      if (nnBstRSh(Jsym,iShp_rs(iShp),1) <= 0) cycle

      do iSymb=1,nSym
        iSyma = Mul(iSymb,Jsym)
        if (iSyma < iSymb) cycle

        LFULL = LFULL+nBasSh(iSyma,iaSh)*nBasSh(iSymb,ibSh)
        if (iaSh == ibSh) cycle

        LFULL = LFULL+nBasSh(iSyma,ibSh)*nBasSh(iSymb,iaSh)

      end do

    end do
  end do
  LFULL = LFULL*JNUM

  if (present(Memory)) then
    MemSPB = nSym*nShell*(nShell+1)
    MemSPB = (MemSPB*storage_size(Adam%SPB)-1)/storage_size(Adam%A0)+1
    Memory = [LFULL,MemSPB]
    return
  end if

  Adam%iCase = 1
  Adam%nSym = nSym
  Adam%iSym = JSYM
  Adam%nShell = nShell

  call mma_allocate(Adam%A0,LFULL,Label='Adam%A0')

  call mma_allocate(Adam%SPB,nSym,nShell*(nShell+1)/2,2,label='Adam%SPB')
# include "macros.fh"
  unused_proc(mma_allocate(Adam%SPB,[0,0],[0,0],[0,0]))

  iE = 0
  do iaSh=1,nShell
    do ibSh=1,iaSh
      iShp = iaSh*(iaSh-1)/2+ibSh

      if (iShp_rs(iShp) <= 0) cycle

      if (nnBstRSh(Jsym,iShp_rs(iShp),1) <= 0) cycle

      do iSymb=1,nSym
        iSyma = Mul(iSymb,Jsym)
        if (iSyma < iSymb) cycle

        iS = iE+1

        n1 = nBasSh(iSyma,iaSh)
        n2 = nBasSh(iSymb,ibSh)

        iE = iE+n1*JNUM*n2

        Adam%SPB(iSyma,iShp_rs(iShp),1)%A3(1:n1,1:JNUM,1:n2) => Adam%A0(iS:iE)
        Adam%SPB(iSyma,iShp_rs(iShp),1)%A21(1:n1*JNUM,1:n2) => Adam%A0(iS:iE)
        Adam%SPB(iSyma,iShp_rs(iShp),1)%A12(1:n1,1:JNUM*n2) => Adam%A0(iS:iE)

        if (iaSh == ibSh) cycle

        iS = iE+1

        n1 = nBasSh(iSyma,ibSh)
        n2 = nBasSh(iSymb,iaSh)

        iE = iE+n1*JNUM*n2

        Adam%SPB(iSyma,iShp_rs(iShp),2)%A3(1:n1,1:JNUM,1:n2) => Adam%A0(iS:iE)
        Adam%SPB(iSyma,iShp_rs(iShp),2)%A21(1:n1*JNUM,1:n2) => Adam%A0(iS:iE)
        Adam%SPB(iSyma,iShp_rs(iShp),2)%A12(1:n1,1:JNUM*n2) => Adam%A0(iS:iE)

      end do

    end do
  end do

end subroutine Allocate_L_Full

subroutine deallocate_L_Full(Adam)

  type(L_Full_Type), intent(inout) :: Adam
  integer(kind=iwp) :: iaSh, ibSh, iShp, iSyma

  do iaSh=1,Adam%nShell
    do ibSh=1,iaSh
      iShp = iaSh*(iaSh-1)/2+ibSh

      do iSyma=1,Adam%nSym

        Adam%SPB(iSyma,iShp,1)%A3 => null()
        Adam%SPB(iSyma,iShp,1)%A21 => null()
        Adam%SPB(iSyma,iShp,1)%A12 => null()
        Adam%SPB(iSyma,iShp,2)%A3 => null()
        Adam%SPB(iSyma,iShp,2)%A21 => null()
        Adam%SPB(iSyma,iShp,2)%A12 => null()

      end do

    end do
  end do

  call mma_deallocate(Adam%SPB)
  call mma_deallocate(Adam%A0)
  Adam%iCase = 0
  Adam%nSym = 0
  Adam%iSym = 0
  Adam%nShell = 0

end subroutine deallocate_L_Full

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                      !
!                      L a b - T Y P E   S E C T I O N                 !
!                                                                      !
!                      Lab storaged                                    !
!                                                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine Allocate_Lab(Lab,JNUM,nBasSh,nBas,nShell,nSym,nDen,Memory)

  type(Lab_Type), target, intent(out) :: Lab
  integer(kind=iwp), intent(in) :: JNUM, nShell, nSym, nBasSh(nSym,nShell), nBas(nSym), nDen
  integer(kind=iwp), intent(out), optional :: Memory(2)
  integer(kind=iwp) :: iSym, iDen, Lab_Memory, iE, iS, iSh, MemKeep, MemSB

  Lab_Memory = 0
  do iSym=1,nSym
    Lab_Memory = max(nBas(iSym),Lab_Memory)
  end do
  Lab_Memory = Lab_Memory*JNUM*nDen

  if (present(Memory)) then
    MemKeep = nShell*nDen
    MemKeep = (MemKeep*storage_size(Lab%Keep)-1)/storage_size(Lab%A0)+1
    MemSB = nShell*nSym*nDen
    MemSB = (MemSB*storage_size(Lab%SB)-1)/storage_size(Lab%A0)+1
    Memory = [Lab_Memory,MemKeep+MemSB]
    return
  end if

  Lab%nSym = nSym
  Lab%nDen = nDen
  Lab%nShell = nShell
  call mma_allocate(Lab%A0,Lab_Memory,Label='Lab%A0')
  call mma_allocate(Lab%Keep,nShell,nDen,Label='Lab%Keep')
  call mma_allocate(Lab%SB,nShell,nSym,nDen,Label='Lab%SB')
# include "macros.fh"
  unused_proc(mma_allocate(Lab%SB,[0,0],[0,0],[0,0]))

  do iSym=1,nSym
    iE = 0
    do iDen=1,nDen
      do iSh=1,nShell

        iS = iE+1
        iE = iE+nBasSh(iSym,iSh)*JNUM

        Lab%SB(iSh,iSym,iDen)%A(1:nBasSh(iSym,iSh)*JNUM) => Lab%A0(iS:iE)

      end do
    end do
  end do

end subroutine Allocate_Lab

subroutine Deallocate_Lab(Lab)

  type(Lab_Type), intent(inout) :: Lab
  integer(kind=iwp) :: iSym, iDen, iSh

  do iSym=1,Lab%nSym
    do iDen=1,Lab%nDen
      do iSh=1,Lab%nShell

        Lab%SB(iSh,iSym,iDen)%A => null()

      end do
    end do
  end do

  Lab%nSym = 0
  Lab%nDen = 0
  Lab%nShell = 0
  call mma_deallocate(Lab%A0)
  call mma_deallocate(Lab%Keep)
  call mma_deallocate(Lab%SB)

end subroutine Deallocate_Lab

subroutine Alloc_Alloc_DSBA(Array,n_Array,n,m,nSym,aCase,Label)

  type(DSBA_Type), allocatable, intent(out) :: Array(:)
  integer(kind=iwp), intent(in) :: n_Array, nSym, n(nSym), m(nSym)
  character(len=3), intent(in), optional :: aCase
  character(len=*), intent(in), optional :: Label
  integer(kind=iwp) :: i

  if (present(Label)) then
    call mma_allocate(Array,n_Array,label=Label)
  else
    call mma_allocate(Array,n_Array,label='DSBA(:)')
  end if

  if (present(aCase)) then
    do i=1,n_Array
      call Allocate_DT(Array(i),n,m,nSym,aCase)
    end do
  else
    do i=1,n_Array
      call Allocate_DT(Array(i),n,m,nSym)
    end do
  end if

# include "macros.fh"
  unused_proc(mma_allocate(Array,[0,0]))

end subroutine Alloc_Alloc_DSBA

subroutine Free_Alloc_DSBA(Array)

  type(DSBA_Type), allocatable, intent(inout) :: Array(:)
  integer(kind=iwp) :: i

  do i=lbound(Array,1),ubound(Array,1)
    call Deallocate_DT(Array(i))
  end do
  call mma_deallocate(Array)

end subroutine Free_Alloc_DSBA

subroutine Alloc_Alloc1DArray(Array,N,Label)

  type(Alloc1DArray_Type), allocatable, intent(inout) :: Array(:)
  integer(kind=iwp), intent(in) :: N(2)
  character(len=*), intent(in) :: Label
# ifdef _GARBLE_
  interface
    subroutine c_null_alloc(A)
      import :: wp
      real(kind=wp), allocatable :: A(:)
    end subroutine c_null_alloc
  end interface
  integer(kind=iwp) :: i
# endif

  call mma_allocate(Array,N,label=Label)
# ifdef _GARBLE_
  ! Garbling corrupts the allocation status of allocatable components, use a hack to reset it
  do i=N(1),N(2)
    call c_null_alloc(Array(i)%A)
  end do
# endif

# include "macros.fh"
  unused_proc(mma_allocate(Array,0))

end subroutine Alloc_Alloc1DArray

subroutine Alloc2D_Alloc1DArray(Array,N1,N2,Label)

  type(Alloc1DArray_Type), allocatable, intent(inout) :: Array(:,:)
  integer(kind=iwp), intent(in) :: N1(2), N2(2)
  character(len=*), intent(in) :: Label
# ifdef _GARBLE_
  interface
    subroutine c_null_alloc(A)
      import :: wp
      real(kind=wp), allocatable :: A(:)
    end subroutine c_null_alloc
  end interface
  integer(kind=iwp) :: i, j
# endif

  call mma_allocate(Array,N1,N2,label=Label)
# ifdef _GARBLE_
  ! Garbling corrupts the allocation status of allocatable components, use a hack to reset it
  do j=N2(1),N2(2)
    do i=N1(1),N1(2)
      call c_null_alloc(Array(i,j)%A)
    end do
  end do
# endif

# include "macros.fh"
  unused_proc(mma_allocate(Array,0,0))

end subroutine Alloc2D_Alloc1DArray

subroutine Alloc_Alloc2DArray(Array,N,Label)

  type(Alloc2DArray_Type), allocatable, intent(inout) :: Array(:)
  integer(kind=iwp), intent(in) :: N(2)
  character(len=*), intent(in) :: Label
# ifdef _GARBLE_
  interface
    subroutine c_null_alloc2(A)
      import :: wp
      real(kind=wp), allocatable :: A(:,:)
    end subroutine c_null_alloc2
  end interface
  integer(kind=iwp) :: i
# endif

  call mma_allocate(Array,N,label=Label)
# ifdef _GARBLE_
  ! Garbling corrupts the allocation status of allocatable components, use a hack to reset it
  ! (note c_null_alloc2 is just the same as c_null_alloc)
  do i=N(1),N(2)
    call c_null_alloc2(Array(i)%A)
  end do
# endif

# include "macros.fh"
  unused_proc(mma_allocate(Array,0))

end subroutine Alloc_Alloc2DArray

subroutine Free_Alloc1DArray(Array)

  type(Alloc1DArray_Type), allocatable, intent(inout) :: Array(:)
  integer(kind=iwp) :: i

  do i=lbound(Array,1),ubound(Array,1)
    if (allocated(Array(i)%A)) call mma_deallocate(Array(i)%A)
  end do
  call mma_deallocate(Array)

end subroutine Free_Alloc1DArray

subroutine Free2D_Alloc1DArray(Array)

  type(Alloc1DArray_Type), allocatable, intent(inout) :: Array(:,:)
  integer(kind=iwp) :: i, j

  do j=lbound(Array,2),ubound(Array,2)
    do i=lbound(Array,1),ubound(Array,1)
      if (allocated(Array(i,j)%A)) call mma_deallocate(Array(i,j)%A)
    end do
  end do
  call mma_deallocate(Array)

end subroutine Free2D_Alloc1DArray

subroutine Free_Alloc2DArray(Array)

  type(Alloc2DArray_Type), allocatable, intent(inout) :: Array(:)
  integer(kind=iwp) :: i

  do i=lbound(Array,1),ubound(Array,1)
    if (allocated(Array(i)%A)) call mma_deallocate(Array(i)%A)
  end do
  call mma_deallocate(Array)

end subroutine Free_Alloc2DArray

! Define lfp_cptr2loff, lfp_mma_allo_3D, lfp_mma_allo_3D_lim, lfp_mma_free_3D
!        v1_cptr2loff, v1_mma_allo_3D, v1_mma_allo_3D_lim, v1_mma_free_3D
!        dsba_cptr2loff, dsba_mma_allo_1D, dsba_mma_allo_1D_lim, dsba_mma_free_1D
!        a1da_cptr2loff, a1da_mma_allo_1D, a1da_mma_allo_1D_lim, a1da_mma_free_1D,
!                        a1da_mma_allo_2D, a1da_mma_allo_2D_lim, a1da_mma_free_2D
!        a2da_cptr2loff, a2da_mma_allo_1D, a2da_mma_allo_1D_lim, a2da_mma_free_1D
#define _TYPE_ type(L_Full_Pointers)
#  define _FUNC_NAME_ lfp_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ lfp_mma
#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'lfp_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

#define _TYPE_ type(V1)
#  define _FUNC_NAME_ v1_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ v1_mma
#  define _DIMENSIONS_ 3
#  define _DEF_LABEL_ 'v1_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

! (using _NO_GARBLE_ because all members are initialized)
#define _TYPE_ type(DSBA_Type)
#  define _NO_GARBLE_
#  define _FUNC_NAME_ dsba_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ dsba_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'dsba_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#  undef _NO_GARBLE_
#undef _TYPE_

#define _TYPE_ type(Alloc1DArray_Type)
#  define _FUNC_NAME_ a1da_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ a1da_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'a1da_mma'
#  include "mma_allo_template.fh"
#  undef _DIMENSIONS_
#  define _DIMENSIONS_ 2
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

#define _TYPE_ type(Alloc2DArray_Type)
#  define _FUNC_NAME_ a2da_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ a2da_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'a2da_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

end module Data_Structures

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE GETINC_ABS_td(XINT,ITP,ISM,JTP,JSM,KTP,KSM,LTP,LSM,
     &                  IKSM,JLSM,INTLST,IJKLOF,NSMOB,
     &                  ICTL)
*
* Obtain integrals
* ICOUL = 0 :      XINT(IK,JL) = (IJ!KL) for IXCHNG = 0
*                              = (IJ!KL)-(IL!KJ) for IXCHNG = 1
* ICOUL = 1 :      XINT(IJ,KL) = (IJ!KL)
*
* Version for integrals stored in INTLST
*
      IMPLICIT REAL*8(A-H,O-Z)
*
#include "detdim.fh"
#include "orbinp_mclr.fh"
      Real * 8 Intlst(*)
      Dimension IJKLof(NsmOB,NsmOb,NsmOB)
      DIMENSION XINT(*)
      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
      iOrb=NTSOB(ITP,ISM)
      jOrb=NTSOB(JTP,JSM)
      kOrb=NTSOB(KTP,KSM)
      lOrb=NTSOB(LTP,LSM)
      iOff=IBTSOB(ITP,ISM)
      jOff=IBTSOB(JTP,JSM)
      kOff=IBTSOB(KTP,KSM)
      lOff=IBTSOB(LTP,LSM)
      ntash=nacob
*
*     Collect Coulomb terms
*
      IF(ICTL.EQ.1) THEN
      iint=1
      Do lBas=lOff,lOff+lOrb-1
        jMin=jOff
        If ( JLSM.ne.0 ) jMin=lBas
        Do jBas=jMin,jOff+jOrb-1
          Do kBas=kOff,kOff+kOrb-1
            iMin=iOff
            If(IKSM.ne.0) iMin = kBas
            Do iBas=iMin,iOff+iOrb-1
              ij = jbas+ntash*(ibas-1)
              kl = lbas+ntash*(kbas-1)
              ijkl=itri(ij,kl)
              Xint(iInt) = Intlst(ijkl)
              iInt=iInt+1
            End Do
          End Do
        End Do
      End Do
      Else If (ICTL.eq.4) Then
*
*     Collect Coulomb-Exchange terms
*
        iint=1
        Do lBas=lOff,lOff+lOrb-1
          jMin=jOff
          If ( JLSM.ne.0 ) jMin=lBas
          Do jBas=jMin,jOff+jOrb-1
            Do kBas=kOff,kOff+kOrb-1
              iMin=iOff
              If(IKSM.ne.0) iMin = kBas
              Do iBas=iMin,iOff+iOrb-1
                 il = ibas+ntash*(lbas-1)
                 jk = kbas+ntash*(jbas-1)
                 iljk=itri(il,jk)
                 ij = ibas+ntash*(jbas-1)
                 kl = kbas+ntash*(lbas-1)
                 ijkl=itri(ij,kl)
                 XInt(iInt)=Intlst(ijkl)-Intlst(iljk)
                 iInt=iInt+1
              End Do
            End Do
          End Do
        End Do
      Else
       Call Abend()
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(IJKLOF)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine UpdFck(OneHam,TwoHam,Vxc,nDT,NumDT,Fock,niter_,nD)
************************************************************************
*                                                                      *
*     purpose: Update Fock matrix from actual OneHam & TwoHam matrices *
*                                                                      *
*     input:                                                           *
*       OneHam  : one-electron hamiltonian of length nDT               *
*       TwoHam  : a few last two-electron hamiltonians (nDT,NumDT)     *
*                                                                      *
*     output:                                                          *
*       Fock    : Fock matrix of length nFO (= OneHam+Optimal TwoHam)  *
*                                                                      *
*     called from: WfCtl                                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.Schuetz                                                        *
*     University of Lund, Sweden, 1995                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "mxdm.fh"
*
      Integer nDT,NumDT
      Real*8 OneHam(nDT),TwoHam(nDT,nD,NumDT),Vxc(nDT,nD,NumDT),
     &       Fock(nDT,nD)
*
*
      i2Hm=NumDT
      If (nIter_.eq.1) i2Hm=1
#ifdef _DEBUGPRINT_
      Write (6,*) 'i2Hm=',i2Hm
      Call NrmClc(OneHam,nDT,'UpdFck','OneHam')
      Call NrmClc(TwoHam(1,1,i2Hm),nDT*nD,'UpdFck','T in i2Hm')
      Call NrmClc(Fock            ,(nDT)*nD,'UpdFck','Fock')
      Call NrmClc(Vxc(1,1,i2Hm  ),nDT*nD,'UpdFck','V in i2Hm  ')
#endif
      Do iD = 1, nD
*
*        F = h + G(D), where D is the inter-/extra-polated
*        densitity matrix. This part is exact.
*
*        G(D) = Sum_i c_i G(D_i)
*
         Call DZAXPY(nDT,One,TwoHam(1,iD,i2Hm),1,OneHam,1,Fock(1,iD),1)
*
*        Here we add the contribution to the Fock matrix from
*        the external field (the none linear or bi-linear parts).
*        Note that Vxc(D_a+D_b)=/= Vxc(D_a) + Vxc(D_b). However,
*        using a first order Taylor expansion we can demonstate that
*        this is correct to first order. Hence, we pick up the
*        inter-/extra-polated external potential here as generated
*        by OptClc.f.
*
*        Proof:
*
*        D = Sum_i c_i * D_i; Sum_i c_i = 1
*
*        First order Taylor expansion of Vxc around D_0 (arbitrary)
*
*        Vxc(D) = Vxc(D_0) + dVxc(D_0)/dD (D-D_0)
*
*        Vxc(D) = Vxc(D_0) + Sum_i C_i dVxc(D_0)/dD (D_i_D_0)
*
*        Vxc(D) = Vxc(D_0) + Sum_i C_i (Vxc(D_i) - Vxc(D_0)
*
*        Vxc(D) = Sum_i c_i Vxc(D_i), which is produced by OptClc.f
*
         Call DaXpY_(nDT,One,Vxc(1,iD,i2Hm  ),1,Fock(1,iD),1)
*
#ifdef _DEBUGPRINT_
         write(6,*) 'Fock'
         write(6,'(5f12.6)') (Fock(ivv,iD),ivv=1,nDT)
         Call NrmClc(Fock(1,iD),nDT,'Fock  ','UpdFck ')
         Call NrmClc(TwoHam(1,iD,i2Hm),nDT,'TwoHam','UpdFck ')
         Call NrmClc(Vxc(1,iD,i2Hm),nDT,'Vxc','UpdFck ')
#endif
*
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine main_cvb()

use casvb_global, only: casvb_free, endvar, ifinish, ioptc_new, ipr, nmcscf, nort, service, variat
use Definitions, only: iwp, u6

implicit none
logical(kind=iwp), external :: loopcntr_iterate_cvb, up2date_cvb ! ... Make: up to date? ...

if (service) return
if (variat) nmcscf = nmcscf+1
call stat1_cvb()

! ---------  make objects  ---------
call makefile_cvb()
if (nmcscf <= 1) call touch_cvb('WRITEGS')
! ----------------------------------

call change0_cvb()

call loopcntr_init_cvb(2,.true.)
call input_cvb()
call loopcntr_init_cvb(2,.false.)
do while (loopcntr_iterate_cvb())
  call input_cvb()

  if (variat .and. (.not. endvar) .and. (ipr(6) < 2)) then
    ! Reduce output level for main variational iterations:
    ipr(:) = -1
  end if

  if (endvar .and. (.not. up2date_cvb('PRTSUM'))) then
    ! End of variational calculation
    if (ipr(1) >= 0) write(u6,'(/,a)') ' CASVB -- summary of results :'
    if (ipr(1) >= 0) write(u6,'(a)') ' -----------------------------'
    call make_cvb('PRTSUM')
  end if

  call make_cvb('STAT')

  call touch_cvb('ORBFREE')
  call touch_cvb('CIFREE')

  if (ifinish <= 2) call change_cvb()

  call casinfoprint_cvb()
  call cnfprint_cvb()
  call prtopt_cvb()

  if (ifinish <= 2) call make_cvb('INIT')

  ! -------  make dependencies -------
  if (nort > 0) then
    call depend_cvb('ORBFREE','ORBS')
  else
    call undepend_cvb('ORBFREE','ORBS')
  end if
  call depend_cvb('CIFREE','CVB')
  ! ----------------------------------

  if (ifinish == 0) then
    call opt_cvb()
    call ncset_cvb(ioptc_new)
  else if ((ifinish == 1) .or. (ifinish == 2)) then
    call reprt_cvb()
    call ncset_cvb(0)
  end if
  call writegs_cvb()
end do

call stat2_cvb()

call casvb_free()

return

end subroutine main_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Lowdin(S,C,nDim)
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "WrkSpc.fh"
      ReaL*8 C(nDim,nDim),S(nDim,nDim)
*
      Call Allocate_Work(ip_S,nDim*(nDim+1)/2)
      Call Allocate_Work(ip_B,nDim**2)
*
      Do i = 1, nDim
         Do j = 1, i
            ioff = ip_S -1 + i*(i-1)/2 + j
            Work(iOff)=S(i,j)
         End Do
      End Do
      call dcopy_(nDim**2,[Zero],0,Work(ip_B),1)
      call dcopy_(nDim,[One],0,Work(ip_B),nDim+1)
*
      Call Lowdin_(S,Work(ip_S),C,nDim,nDim,Work(ip_B))
*
      Call Free_Work(ip_B)
      Call Free_Work(ip_S)
      Return
      End

      Subroutine Lowdin_(S,Eval,C,nDim,nDim2,Blk)
*
*     S: full-storage overlap matrix (it will be destroyed!)
*     C: on exit, the S^-1/2 matrix
*
      Implicit ReaL*8 (A-H,O-Z)
#include "real.fh"
      Real*8 C(nDim,nDim),S(nDim,nDim), Blk(nDim,nDim),
     &       Eval(nDim*(nDim+1)/2)
*
C     NDim2=NDim2
C
      Data DIAGTH,DANGER/1.0D-12,1.0D3/
C
C          diagth  threshold for matrix diagonalization used in
C                     subroutine jacobi.  in jacobi, this  constant
C                     is called doneth.
C          danger  criterion for deciding that the job should be
C                     aborted due to numerical problems caused by near
C                     linear dependencies in the basis set.
C                     all eigenvalues of the weighted overlap
C                     matrix must be greater than DIAGTH*DANGER.
C
      toosml=diagth*danger

C  diagonalize overlap matrix
C
      Call Jacob(Eval,Blk,nDim,nDim)
C
c     Call RecPrt('Blk',' ',Blk,nDim,nDim)
c     Call TriPrt('Eval',' ',Eval,nDim)

C  form the inverse sqrt of the overlap matrix of the vectors:
C  (avoid numerical problems of linear dependence (too small eigenvals)
C  by prescreening
C  the  eigenvalues)
C
      Do i=1,nDim
         eigenv=eval(i*(i+1)/2)
         if(eigenv.lt.toosml) go to 900
         eval(i*(i+1)/2)=ONE/sqrt(eigenv)
      End Do
*
* --- Compute S^-1/2
*
      do i=1,nDim
        do  j=1,i
          sij=zero
          do  k=1,nDim
             sij=sij+eval(k*(k+1)/2)*blk(i,k)*blk(j,k)
          enddo
          C(i,j)=sij
          C(j,i)=sij
        enddo
      enddo
C
c     Call RecPrt('C',' ',C,nDim,nDim)
C
      Return
  900 write(6,910) eigenv,toosmL
  910 format(/1X,'An eigenvalue of the overlap matrix of the ',
     *   'symmetrized Jacobi transf. ',
     *   'matrix of ',E13.5,' has been found.'/1X,
     *   'This is lower than the allowed threshold of ',E13.5)
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(S)
         Call Unused_integer(nDim2)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine wr_mpprop(nAtoms,nCenters,nMltPl,iPol)

use MPprop_globals, only: AtBoMltPl, AtBoMltPlTot, AtMltPl, AtMltPlTot, AtPol, AtBoPol, BondMat, Cen_Lab, Cor, Title
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nCenters, nMltPl, iPol
integer(kind=iwp) :: i, iComp, iCount, ilab, iMltPl, iStdOut, ix, ixx, iy, iyy, iz, izz, j, jComp, mxComp, nComp
real(kind=wp) :: MolPol(6)
character(len=16) :: MltPlLab, PolString
character(len=16), allocatable :: MltPlLabs(:,:), String(:)

iStdOut = u6

mxComp = (nMltPl+1)*(nMltpl+2)/2
call mma_allocate(MltPlLabs,[0,max(nMltPl,2)],[1,mxComp],label='MltPlLabs')
call mma_allocate(String,[0,max(nMltPl,4)],label='String')

MolPol(:) = Zero
String(0) = 'Charge'
String(1) = 'Dipole'
String(2) = 'Quadrupole'
String(3) = 'Octupole'
String(4) = 'Hexadecapole'
do i=5,nMltPl
  write(String(i),'(i4,"th")') i
  if (String(i)(3:3) /= '1') then
    select case (String(i)(4:4))
      case ('1')
        String(i)(5:6) = 'st'
      case ('2')
        String(i)(5:6) = 'nd'
      case ('3')
        String(i)(5:6) = 'rd'
      case default
    end select
  end if
  String(i) = adjustl(String(i))
  String(i)(8:16) = 'Cartesian'
end do
PolString = 'Polarizability'

do iMltPl=0,max(nMltPl,2)
  ilab = 0
  do ix=iMltpl,0,-1
    do iy=iMltpl-ix,0,-1
      iz = iMltpl-ix-iy
      ilab = ilab+1
      MltPlLab = ' '
      do izz=iMltPl,iMltPl-iz+1,-1
        MltPlLab(izz:izz) = 'Z'
      end do
      do iyy=iMltPl-iz,iMltPl-iz-iy+1,-1
        MltPlLab(iyy:iyy) = 'Y'
      end do
      !max( ,1) added by EB
      do ixx=iMltPl-iz-iy,max(iMltPl-nMltPl+1,1),-1
        MltPlLab(ixx:ixx) = 'X'
      end do
      MltPlLabs(iMltPl,ilab) = MltPlLab
    end do
  end do
end do

write(iStdOut,*)
write(iStdOut,*) ' The name of the molecule will be',Title
write(iStdOut,*)
write(iStdOut,*) ' THE MULTIPOLES AND POLARIZABILITY FOR THE EXPANSION'
write(iStdOut,*) ' ****************************************************************'
write(iStdOut,*)
write(iStdOut,*) ' TOTAL NUMBER OF CENTERS   : ',nCenters
write(iStdOut,*) ' OF WHICH THERE ARE ATOMS  : ',nAtoms
write(iStdOut,*) ' AND BONDS IN THE MOLECULE : ',nCenters-nAtoms
write(iStdOut,*)

write(iStdOut,'(1x,a16,3a16)') 'Coord',(MltPlLabs(1,iComp),iComp=1,3)
do iMltPl=0,nMltPl
  nComp = (iMltPl+1)*(iMltPl+2)/2
  do iComp=1,nComp,6
    write(u6,'(1x,a,6a16)') String(iMltPl),(MltPlLabs(iMltPl,jComp),jComp=iComp,min(iComp+5,nComp))
  end do
end do
if (iPol > 0) then
  write(iStdOut,'(1x,a,6a16)') PolString,(MltPlLabs(2,iComp),iComp=1,6)
end if
iCount = 0
write(iStdOut,*)
write(iStdOut,*)
write(iStdOut,*)
write(iStdOut,*) 'Multipole expansion for Atoms and Bonds'
write(iStdOut,*) '***************************************'
do i=1,nAtoms
  iCount = iCount+1
  write(iStdOut,*)
  write(iStdOut,'(I5,A8,I5,A3,A10)') iCount,' Center ',i*(i+1)/2,'   ',CEN_LAB(i*(i+1)/2)
  write(iStdOut,*) '**************************************************'
  write(iStdOut,'(1x,a16,3f16.8)') 'Coord',Cor(1,I,I),Cor(2,I,I),Cor(3,I,I)
  do iMltPl=0,nMltPl
    nComp = (iMltPl+1)*(iMltPl+2)/2
    do iComp=1,nComp,6
      write(iStdOut,'(1x,a16,6f16.8)') String(iMltPl),(AtBoMltPl(iMltPl)%A(jComp,i*(i+1)/2),jComp=iComp,min(iComp+5,nComp))
    end do
  end do
  if (iPol > 0) then
    write(iStdOut,'(1x,a16,6f16.8)') PolString,AtBoPol(:,i*(i+1)/2)
  end if
end do
do i=1,nAtoms
  do j=1,i-1
    if (BondMat(i,j)) then
      iCount = iCount+1
      write(iStdOut,*)
      write(iStdOut,'(I5,A8,I5,A3,A10)') iCount,' Center ',i*(i-1)/2+j,'   ',CEN_LAB(i*(i-1)/2+j)
      write(iStdOut,*) '**************************************************'
      write(iStdOut,'(1x,a16,3f16.8)') 'Coord',Cor(1,i,j),Cor(2,i,j),Cor(3,i,j)
      do iMltPl=0,nMltPl
        nComp = (iMltPl+1)*(iMltPl+2)/2
        do iComp=1,nComp,6
          write(iStdOut,'(1x,a16,6f16.8)') String(iMltPl),(AtBoMltPl(iMltPl)%A(jComp,i*(i-1)/2+j),jComp=iComp,min(iComp+5,nComp))
        end do
      end do
      if (iPol > 0) then
        write(iStdOut,'(1x,a16,6f16.8)') PolString,AtBoPol(:,i*(i-1)/2+j)
      end if
    end if
  end do
end do
write(iStdOut,*)
write(iStdOut,*)
write(iStdOut,*)
write(iStdOut,*) 'Multipole expansion for Atoms'
write(iStdOut,*) '*****************************'

do i=1,nAtoms
  write(iStdOut,*)
  write(iStdOut,'(I5,A8,I5,A3,A10)') i,' Atom   ',i,'   ',CEN_LAB(i*(i+1)/2)
  write(iStdOut,*) '**************************************************'
  write(iStdOut,'(1x,a16,3f16.8)') 'Coord',Cor(1,i,i),Cor(2,i,i),Cor(3,i,i)
  do iMltPl=0,nMltPl
    nComp = (iMltPl+1)*(iMltPl+2)/2
    do iComp=1,nComp,6
      write(iStdOut,'(1x,a16,6f16.8)') String(iMltPl),(AtMltPl(iMltPl)%A(jComp,i),jComp=iComp,min(iComp+5,nComp))
    end do
  end do
  if (iPol > 0) then
    write(iStdOut,'(1x,a16,6f16.8)') PolString,AtPol(:,i)
    MolPol(:) = MolPol(:)+AtPol(:,i)
  end if
end do
write(iStdOut,*)
write(iStdOut,*)
write(iStdOut,*)
write(iStdOut,*) ' SUMMED MULTIPOLES AND POLARIZABILITY FOR THE MOLECULE'
write(iStdOut,*) ' *****************************************************'
write(iStdOut,*)
write(iStdOut,'(1x,a16,3f16.8)') 'Coord',Zero,Zero,Zero
do iMltPl=0,nMltPl
  nComp = (iMltPl+1)*(iMltPl+2)/2
  do iComp=1,nComp,6
    write(iStdOut,'(1x,a16,6f16.8)') String(iMltPl),(AtMltPlTot(iMltPl)%A(jComp),jComp=iComp,min(iComp+5,nComp))
  end do
end do
if (iPol > 0) write(iStdOut,'(1x,a16,6f16.8)') PolString,(MolPol(j),j=1,6)
write(iStdOut,*)
write(iStdOut,*)
write(iStdOut,'(1x,a16,3f16.8)') 'Coord',Zero,Zero,Zero
do iMltPl=0,nMltPl
  nComp = (iMltPl+1)*(iMltPl+2)/2
  do iComp=1,nComp,6
    write(iStdOut,'(1x,a16,6f16.8)') String(iMltPl),(AtBoMltPlTot(iMltPl)%A(jComp),jComp=iComp,min(iComp+5,nComp))
  end do
end do

call mma_deallocate(MltPlLabs)
call mma_deallocate(String)

return

!EB 10000 format(F16.6)
!EB 10003 format(3F16.6 )

end subroutine wr_mpprop

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine saverest2 (lunrst,energy,niter,iokey,daddr)
c
c     this routine save restart informations:
c     energy, niter
c     to prepaired possition in lunrst
c

#include "SysDef.fh"
       integer lunrst,niter,iokey,daddr,idum(1)
       real*8 energy,dum(1)
c
c1    write energy,niter
       if (iokey.eq.1) then
c      Fortran IO
       write (lunrst) energy,niter
c
       else
c      MOLCAS IO
       dum(1)=energy
       call ddafile (lunrst,1,dum,1,daddr)
       idum(1)=niter
       call idafile (lunrst,1,idum,1,daddr)
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
        subroutine summary (wrk,wrksize,NvGrp,LunAux,maxdim,E1,E2,E2os)
c
c        thsi routine do:
c        T1
c          - make T1o = T1n/Den
c          - calc E1 = FTau
c        T2:
c          - Join T2 form Tmp2files-(X,Y) and Tmp3files
c          - make T2o in T2files = T2n/Den
c          - make Tau from new amplitudes
c          - calc E2,E2os = WTau
c
c        Scheme of recreation of T2n:
c
c        1) contributions from X and Y matrices
c        T2n(be',ga',u,v) <<-
c         C1                + 1/2 X(be',u,ga',v)
c        C2                + 1/2 X(ga',v,be',u)
c         C3                - 1/2 Y(be',u,ga',v)
c        C4                - 1/2 Y(ga',v,be',u)
c         C5                - 1   Y(ga',u,be',v)
c        C6                - 1   Y(be',v,ga',u)
c
c        2) contributions from T2n1,T2n2 (T2+,T2-)
c        T2n(be',ga',u,v) <<-
c         C7                    T2+(be'ga',uv)
c        C8                    T2-(be'ga',uv)
c
c        Energy contributions:
c        E1  = sum(a,i)       [  2 Fvo(a,i) . T1(a,i)               ]
c        E2  = sum(a,b,i,j)   [ {2(ai|bj) - (aj|bi)} . Tau(a,b,i,j) ]
c        E2os= sum(a,b,i,j)   [   (ai|bj)            . Tau(a,b,i,j) ]
c
c        Memory requirements:
c        V1-3 - {v'ov'o}
c        H1,2 - {v'o}
c
        implicit none
#include "wrk.fh"
#include "chcc1.fh"
#include "o3v3.fh"
#include "o2v4.fh"
#include "chcc_files.fh"
#include "chcc_parcc.fh"
#include "para_info.fh"
c
        integer NvGrp,LunAux,maxdim
        real*8 E1,E2,E2os
c
c        help variables
        integer beGrp,gaGrp,dimbe,dimga,addbe,addga,dim1,dim2
        integer beSGrp,gaSGrp,addbepp,addgapp,dimbepp,dimgapp
        real*8 Ehlp,Eoshlp
        character*6 LunName
c
        integer PossH1,PossH2
        integer PossV1,PossV2,PossV3
        integer PossT
c
c*        Distribute Memory
        PossT=PossFree
        call DistMemSum (NvGrp,maxdim,
     c       PossV1,PossV2,PossV3,
     c       PossH1,PossH2,
     c       PossT)
c
c
c*        Operations on T1 amplitudes
c
c        Divide T1n by denominators
        call T1_div (wrk(PossT1n),wrk(PossOE),no,nv)
c
c        Set T1o <- T1n
        dim1=no*nv
        call mv0u (dim1,wrk(PossT1n),1,wrk(PossT1o),1)
c
c        Calc E1
        call Energy_E1 (wrk(PossT1n),wrk(PossFvo),no,nv,EHlp)
        E1=2.0d0*EHlp
cmp        E1=2.0d0*E1
c
c
c
c*        Operations on T2 amplitudes
c
c        cycle over be'=ga'
c
        E2=0.0d0
        E2os=0.0d0
c
        addbe=0
        do beGrp=1,NvGrp
        dimbe=DimGrpv(beGrp)
c
c         Extract H1(be',I) <- T1(be,I)
          call ExtT1 (wrk(PossH1),wrk(PossT1o),dimbe,addbe)
c
c          vanish V3
          dim1=dimbe*dimbe*no*no
          call mv0zero (dim1,dim1,wrk(PossV3))

c
c1.1          Add contribution C1-6
c
c          read V1(be',u,ga',v) <- X(be',u,ga',v)
c               V2(be',u,ga',v) <- Y(be',u,ga',v)
          LunName=Tmp2Name(beGrp,beGrp)
          dim1=dimbe*dimbe*no*no
          if (XYyes(beGrp,beGrp).eq.1) then
            call GetX (wrk(PossV1),dim1,LunAux,LunName,1,0)
            call GetX (wrk(PossV2),dim1,LunAux,LunName,0,1)
          else if (Xyes(beGrp,beGrp).eq.1) then
            call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
            call mv0zero (dim1,dim1,wrk(PossV2))
          else
            call mv0zero (dim1,dim1,wrk(PossV1))
            call mv0zero (dim1,dim1,wrk(PossV2))
          end if

c
c          V3(be',ga',u,v) <-
c            C1                + 1/2 V1(be',u,ga',v)
c           C2                + 1/2 V1(ga',v,be',u)
c            C3                - 1/2 V2(be',u,ga',v)
c           C4                - 1/2 V2(ga',v,be',u)
c            C5                - 1   V2(ga',u,be',v)
c           C6                - 1   V2(be',v,ga',u)
          call MkT_CAlld (wrk(PossV3),wrk(PossV1),wrk(PossV2),
     c                    dimbe,no)
c1.2          Add contribution C7,C8
c
c         cycle over all subgroups of (be">=ga")
c@c
c        goto 9911
c@c
          addbepp=0
          do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)
          dimbepp=DimSGrpbe(beSGrp)
          addgapp=0
          do gaSGrp=GrpbeLow(beGrp),beSGrp
          dimgapp=DimSGrpbe(gaSGrp)
c
          if (beSGrp.eq.gaSGrp) then
c            read V1(bega",uv+) <- T2+(bega",uv+)
c                 V2(bega",uv-) <- T2-(bega",uv-)
            LunName=Tmp3Name(beSGrp,beSGrp)
            dim1=dimbepp*(dimbepp+1)*no*(no+1)/4
            dim2=dimbepp*(dimbepp-1)*no*(no-1)/4
            if (T2o2v4yes(beSGrp,beSGrp).eq.1) then
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,0)
              call GetX (wrk(PossV2),dim2,LunAux,LunName,0,1)
            else
              call mv0zero (dim1,dim1,wrk(PossV1))
              call mv0zero (dim2,dim2,wrk(PossV2))
            end if

c            V3(be',ga',u,v) <<- T2+(bega",uv)
c                               T2-(bega",uv)
            call MkT_C78d (wrk(PossV3),wrk(PossV1),wrk(PossV2),
     c                      dimbe,dimbepp,addbepp,no)
          else
            LunName=Tmp3Name(beSGrp,gaSGrp)
c            read V1(be",ga",uv+) <- T2+(be",ga",uv+)
c                 V2(be",ga",uv-) <- T2-(be",ga",uv-)
            dim1=dimbepp*dimgapp*no*(no+1)/2
            dim2=dimbepp*dimgapp*no*(no-1)/2
            if (T2o2v4yes(beSGrp,gaSGrp).eq.1) then
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,0)
              call GetX (wrk(PossV2),dim2,LunAux,LunName,0,1)
            else
              call mv0zero (dim1,dim1,wrk(PossV1))
              call mv0zero (dim2,dim2,wrk(PossV2))
            end if
c            V3(be',ga',u,v) <<- T2+(be",ga",uv)
c                               T2-(be",ga",uv)
            call MkT_C78od (wrk(PossV3),wrk(PossV1),wrk(PossV2),
     c                   dimbe,dimbe,dimbepp,dimgapp,addbepp,addgapp,no)
          end if
c
          addgapp=addgapp+dimgapp
          end do
          addbepp=addbepp+dimbepp
          end do
c@c
c9911        continue
c@c
c
c
c1.3          T2 - V3(be',ga',u,v) are now reconstructed (for be'>=ga')
c          Divide by denominators and completed to be'<ga' also
           call T2d_div (wrk(PossV3),wrk(PossOE),
     c                  dimbe,dimbe,addbe,addbe,no,nv)
c
c          Prepair reduced Set V2(be'>=ga',u,v) <- V3(be',ga',u,v)
          call MkT_red (wrk(PossV2),wrk(PossV3),dimbe,no)
c
#ifdef _MOLCAS_MPP_
c##          Synchronizacny bod:
c          Allreduce V2
           dim1=dimbe*(dimbe+1)*no*no/2
          call gadgop (wrk(PossV2),dim1,'+')
c
c##          For parallel runs only:
c          Inverse expansion  V3(be',ga',u,v) <- V2(be'>=ga',u,v)
           if (nProcs.gt.1) then
             call MkT_exp (wrk(PossV2),wrk(PossV3),dimbe,no)
           end if
#endif
c@@
c        call Chck_T2n (wrk(PossV3),dimbe,addbe,dimbe,addbe,1)
c@@
c
c          Save into corresponding T2file
          LunName=T2Name(beGrp,beGrp)
          dim1=dimbe*(dimbe+1)*no*no/2
          call SaveX (wrk(PossV2),dim1,LunAux,LunName,1,1)
c
c          Make Tau in V3(be',ga',u,v)
c          (note, that T1 are already new ones)
c          @@ s tym 2x H1 to nieje celkom koser
               call MkTau_chcc (wrk(PossV3),wrk(PossH1),wrk(PossH1),
     c                     dimbe,dimbe,no,1.0d0,1.0d0)
c
c          read V1(be',I,ga',J) <- I2(be'I|ga'J)
           LunName=I2Name(beGrp,beGrp)
          dim1=dimbe*dimbe*no*no
          call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c          Calc E2 = sum(a,b,i,j) (2V1(ai|bj)-V1(aj|bi)) . V3(a,b,i,j)
          call Energy_E2d (wrk(PossV1),wrk(PossV3),Ehlp,Eoshlp,dimbe,no)

          E2=E2+1.0d0*Ehlp
          E2os=E2os+1.0d0*Eoshlp
c
        addbe=addbe+dimbe
        end do
c
c
c        cycle over be>ga
c        reserved files:
c          V3(be',ga',u,v) = T2n(be',ga',u,v)
c        free for use: V1,V2
c
        addbe=DimGrpv(1)
        do beGrp=2,NvGrp
        dimbe=DimGrpv(beGrp)
c
c         Extract H1(be',I) <- T1(be,I)
          call ExtT1 (wrk(PossH1),wrk(PossT1o),dimbe,addbe)
c
c
          addga=0
          do gaGrp=1,beGrp-1
          dimga=DimGrpv(gaGrp)
c
c           Extract H2(ga',I) <- T1(ga,I)
            call ExtT1 (wrk(PossH2),wrk(PossT1o),dimga,addga)
c
c            vanish V3
            dim1=dimbe*dimga*no*no
            call mv0zero (dim1,dim1,wrk(PossV3))
c
c            read V1(be',u,ga',v) <- X(be',u,ga',v)
c                 V2(be',u,ga',v) <- Y(be',u,ga',v)
            LunName=Tmp2Name(beGrp,gaGrp)
            dim1=dimbe*dimga*no*no
            if (XYyes(beGrp,gaGrp).eq.1) then
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,0)
              call GetX (wrk(PossV2),dim1,LunAux,LunName,0,1)
            else if (Xyes(beGrp,gaGrp).eq.1) then
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
              call mv0zero (dim1,dim1,wrk(PossV2))
            else
              call mv0zero (dim1,dim1,wrk(PossV1))
              call mv0zero (dim1,dim1,wrk(PossV2))
            end if
c
c            Add contribution C1,C3,C6
c            V3(be',ga',u,v) < - + 1/2 V1(be',u,ga',v)
c                                - 1/2 V2(be',u,ga',v)
c                               - 1   V2(be',v,ga',u)
            call MkT_C136od (wrk(PossV3),wrk(PossV1),wrk(PossV2),
     c                       dimbe,dimga,no)
c
c            read V1(ga',u,be',v) <- X(ga',u,be',v)
c                 V2(ga',u,be',v) <- Y(ga',u,be',v)
            LunName=Tmp2Name(gaGrp,beGrp)
            dim1=dimbe*dimga*no*no
            if (XYyes(gaGrp,beGrp).eq.1) then
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,0)
              call GetX (wrk(PossV2),dim1,LunAux,LunName,0,1)
            else if (Xyes(gaGrp,beGrp).eq.1) then
              call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
              call mv0zero (dim1,dim1,wrk(PossV2))
            else
              call mv0zero (dim1,dim1,wrk(PossV1))
              call mv0zero (dim1,dim1,wrk(PossV2))
            end if
c
c            Add contribution C2,C4,C5
c            V3(be',ga',u,v) <<- + 1/2 V1(ga',v,be',u)
c                               - 1/2 V2(ga',v,be',u)
c                                - 1   V2(ga',u,be',v)
            call MkT_C245od (wrk(PossV3),wrk(PossV1),wrk(PossV2),
     c                       dimbe,dimga,no)
c
c
c2.2            Add contribution C7,C8
c
c           cycle over all subgroups of (be">=ga")
            addbepp=0
            do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)
            dimbepp=DimSGrpbe(beSGrp)
            addgapp=0
            do gaSGrp=GrpbeLow(gaGrp),GrpbeUp(gaGrp)
            dimgapp=DimSGrpbe(gaSGrp)
c
c              read V1(be",ga",uv+) <- T2+(be",ga",uv+)
c                   V2(be",ga",uv-) <- T2-(be",ga",uv-)
              LunName=Tmp3Name(beSGrp,gaSGrp)
              dim1=dimbepp*dimgapp*no*(no+1)/2
              dim2=dimbepp*dimgapp*no*(no-1)/2
              if (T2o2v4yes(beSGrp,gaSGrp).eq.1) then
                call GetX (wrk(PossV1),dim1,LunAux,LunName,1,0)
                call GetX (wrk(PossV2),dim2,LunAux,LunName,0,1)
              else
                call mv0zero (dim1,dim1,wrk(PossV1))
                call mv0zero (dim2,dim2,wrk(PossV2))
              end if
c              V3(be',ga',u,v) <<- T2+(be",ga",uv)
c                                 T2-(be",ga",uv)
              call MkT_C78od (wrk(PossV3),wrk(PossV1),wrk(PossV2),
     c                   dimbe,dimga,dimbepp,dimgapp,addbepp,addgapp,no)
c
            addgapp=addgapp+dimgapp
            end do
            addbepp=addbepp+dimbepp
              end do
c
c
c
c            T2 - V3(be',ga',u,v) are now completely reconstructed
c            Divide by denominators
             call T2od_div (wrk(PossV3),wrk(PossOE),
     c                     dimbe,dimga,addbe,addga,no,nv)
c
c
#ifdef _MOLCAS_MPP_
c##            Synchronizacny bod:
c            Allreduce V3
            dim1=dimbe*dimga*no*no
            call gadgop (wrk(PossV3),dim1,'+')
#endif
c@@
c        call Chck_T2n (wrk(PossV3),dimbe,addbe,dimga,addga,0)
c@@
c
c
c            Save V3 into corresponding T2file
            LunName=T2Name(beGrp,gaGrp)
            dim1=dimbe*dimga*no*no
            call SaveX (wrk(PossV3),dim1,LunAux,LunName,1,1)
c
c            Map V1(ga',be',v,u) <- V3(be',ga',u,v)
            call Map4_2143 (wrk(PossV3),wrk(PossV1),dimbe,dimga,no,no)
c
c            Save V1 into corresponding T2file
            LunName=T2Name(gaGrp,beGrp)
            dim1=dimbe*dimga*no*no
            call SaveX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c
c            Make Tau in V3(be',ga',u,v)
c            (note, that T1 are already new ones)
               call MkTau_chcc (wrk(PossV3),wrk(PossH1),wrk(PossH2),
     c                       dimbe,dimga,no,1.0d0,1.0d0)
c
c            read V1(be',I,ga',J) <- I2(be'I|ga'J)
            LunName=I2Name(beGrp,gaGrp)
            dim1=dimbe*dimga*no*no
            call GetX (wrk(PossV1),dim1,LunAux,LunName,1,1)
c
c            Calc E2 = sum(a,b,i,j) (2V1(ai|bj)-V1(aj|bi)) . V3(a,b,i,j)
            call Energy_E2od (wrk(PossV1),wrk(PossV3),Ehlp,Eoshlp,
     c                        dimbe,dimga,no)

            E2=E2+2.0d0*Ehlp
            E2os=E2os+2.0d0*Eoshlp
c
          addga=addga+dimga
          end do
c
        addbe=addbe+dimbe
        end do
c
c@@
         return
c
c        Calc Energy from Chck
         call Chck_energ
c
c        upgrade checkeroo T1c and T2c
c
c        Upgrade T1
         call UpG_T1 (wrk(PossT1o))
c
c        Upgrade T2
        addbe=0
        do beGrp=1,NvGrp
        dimbe=DimGrpv(beGrp)
c
          addga=0
          do gaGrp=1,beGrp
          dimga=DimGrpv(gaGrp)
c
          if (beGrp.eq.gaGrp) then
            LunName=T2Name(beGrp,beGrp)
            dim1=dimbe*(dimbe+1)*no*no/2
            call GetX (wrk(PossV3),dim1,LunAux,LunName,1,1)
            call UpG_T2d (wrk(PossV3),dimbe,addbe)
          else
            LunName=T2Name(beGrp,gaGrp)
            dim1=dimbe*dimga*no*no
            call GetX (wrk(PossV3),dim1,LunAux,LunName,1,1)
            call UpG_T2od (wrk(PossV3),dimbe,addbe,dimga,addga)
          end if
c
          addga=addga+dimga
          end do
c
        addbe=addbe+dimbe
        end do
c
        return
        end
c
c        -----------------------------
c
        subroutine Chck_T2n (T2,dimbe,addbe,dimga,addga,key)
c
c        chek T2n bez menovatelov, nediagonalne
c
        implicit none
        integer dimbe,addbe,dimga,addga,key
#include "chcc1.fh"

         real*8 T2(1:dimbe,1:dimga,1:no,1:no)
c
        integer bstart,bup
        integer u,v,be,ga,bad,ntot
        integer i,j,a,b
        real*8 s,s1
c
        bad=0
        ntot=0
c
        do v=1,no
        do u=1,no
        do ga=addga+1,addga+dimga
        if (key.eq.1) then
             bstart=ga
          bup=addbe+dimbe
        else
          bstart=addbe+1
          bup=addbe+dimbe
        end if
        do be=bstart,bup
c
        ntot=ntot+1
        s=0.0d0
c
c1
          s1=Q21(be,u,ga,v)
          s=s+s1
c
c2
          s1=0.0d0
          do j=1,no
          do i=1,no
          s1=s1+Ac(i,j,u,v)*(T2c(be,ga,i,j)+T1c(be,i)*T1c(ga,j))
          end do
          end do
          s=s+s1
c
c3
          s1=0.0d0
          do b=1,nv
          do a=1,nv
           s1=s1+Bc(a,b,be,ga)*(T2c(a,b,u,v)+T1c(a,u)*T1c(b,v))
          end do
          end do
          s=s+s1
c
c4
          s1=0.0d0
          do a=1,nv
          s1=s1+Gvvc(be,a)*T2c(a,ga,u,v)
          s1=s1+Gvvc(ga,a)*T2c(a,be,v,u)
          end do
          s=s+s1
c
c5
          s1=0.0d0
          do i=1,no
          s1=s1+Gooc(i,u)*T2c(be,ga,i,v)
          s1=s1+Gooc(i,v)*T2c(ga,be,i,u)
          end do
          s=s-s1
c
c6
          s1=0.0d0
          do a=1,nv
          s1=s1+Q3(ga,a,be,u)*T1c(a,v)
          s1=s1+Q3(be,a,ga,v)*T1c(a,u)
          end do
          do i=1,no
          do a=1,nv
          s1=s1-(Q22(ga,a,i,u)*T1c(be,i))*T1c(a,v)
          s1=s1-(Q22(be,a,i,v)*T1c(ga,i))*T1c(a,u)
          end do
          end do
          s=s+s1
c
c7
          s1=0.0d0
          do i=1,no
          s1=s1+Q1(be,u,i,v)*T1c(ga,i)
          s1=s1+Q1(ga,v,i,u)*T1c(be,i)
          end do
          do i=1,no
          do a=1,nv
          s1=s1+(Q21(be,u,a,i)*T1c(a,v))*T1c(ga,i)
          s1=s1+(Q21(ga,v,a,i)*T1c(a,u))*T1c(be,i)
          end do
          end do
          s=s-s1
c
c8
          s1=0.0d0
          do i=1,no
          do a=1,nv
            s1=s1+(2.0d0*Jc(be,i,u,a)-Kc(i,be,u,a))*
     c          (2.0d0*T2c(a,ga,i,v)-T2c(ga,a,i,v))
            s1=s1+(2.0d0*Jc(ga,i,v,a)-Kc(i,ga,v,a))*
     c          (2.0d0*T2c(a,be,i,u)-T2c(be,a,i,u))

          end do
          end do
          s=s+0.5d0*s1
c
c9
          s1=0.0d0
          do i=1,no
          do a=1,nv
          s1=s1+Kc(i,be,u,a)*T2c(ga,a,i,v)
          s1=s1+Kc(i,ga,v,a)*T2c(be,a,i,u)
          end do
          end do
          s=s-0.5d0*s1
c
c10
          s1=0.0d0
          do i=1,no
          do a=1,nv
          s1=s1+Kc(i,ga,u,a)*T2c(be,a,i,v)
          s1=s1+Kc(i,be,v,a)*T2c(ga,a,i,u)
          end do
          end do
          s=s-s1
c
          s=s/(Oeo(u)+Oeo(v)-Oev(be)-Oev(ga))
c
             if  (abs(T2(be-addbe,ga-addga,u,v)-s).gt.1.0d-10) then
c          write (6,*) 'Bad', abs(T2(be-addbe,ga-addga,u,v)
          bad=bad+1
          end if
c
        end do
        end do
        end do
        end do
c
        if (key.eq.1) then
          write (6,*) ' Final test T2 dia',bad,ntot
        else
          write (6,*) ' Final test T2 off',bad,ntot
        end if
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SQUAR2(A,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(N,N)
      DO 10 I=1,N
      NI=N-I+1
      CALL DCOPY_(NI,A(I,I),1,A(I,I),N)
10    CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Print_Local(rMP,nij,nElem,Coor,nAtoms,C_o_C,Q_Nuc,lMax,Lbl_Center,rMPq,EC,Polar,NoField,Temp,xrMP,xxRMP,xnrMP,iANr, &
                       nOcOb,Energy_Without_FFPT,Ene_Occ,MpProp_Level,Bond_Threshold,ChPolBB,LIonize)

use Real_Spherical, only: Sphere, Sphere_Free
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, Half, auToeV
use Definitions, only: wp, iwp, u6, r8

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nij, nElem, nAtoms, lMax, iANr(nAtoms), nOcOb, MpProp_Level
real(kind=wp), intent(inout) :: rMP(nij,nElem), Temp(nij)
real(kind=wp), intent(in) :: Coor(3,nAtoms), C_o_C(3), Q_Nuc(nAtoms), rMPq(nElem), EC(3,nij), Polar(6,nij), Energy_Without_FFPT, &
                             Ene_Occ(nOcOb), Bond_Threshold, ChPolBB(6,nij)
character(len=LenIn), intent(in) :: Lbl_Center(nAtoms)
logical(kind=iwp), intent(in) :: NoField, LIonize
real(kind=wp), intent(out) :: xrMP(nij,nElem), xxrMP(nij,nElem), xnrMP(nij,nElem)
integer(kind=iwp) :: iAtom, i_Dim, iElem, iEnd, ij, iPol, iPrint, iStrt, ix, iy, iz, jAtom, l, nReal_Centers
real(kind=wp) :: A(3), Charge_center, CRN, CRX, CRY, CRZ, CX(3), Dip_Tot, DR, LA, LI, LI_MIN, LI_TOT, Pol_Tot, Polar_M(6), &
                 rMP_Tot, rMP_Tot_Electronic, rMP_Tot_Nuclear, rms, Sites, TP, TP_Q
character(len=80) :: Banner_Line(2)
logical(kind=iwp) :: Center_OK, Check_Bond, get_BasisType
real(kind=wp), allocatable :: Scratch_New(:), Scratch_Org(:)
real(kind=r8), external :: DDot_

Sites = Zero
LI_TOT = Zero
LI_MIN = huge(LI_MIN)
!                                                                      *
!***********************************************************************
!                                                                      *
Center_OK = .true.
call Sphere(lMax)
!                                                                      *
!***********************************************************************
!                                                                      *
! Make copy of rMP so we keep a copy of the
! electronic contributions to the multipoles.

i_Dim = nij*nElem
call dCopy_(i_Dim,rMP,1,xrMP,1)
!                                                                      *
!***********************************************************************
!                                                                      *
! Put info to check file.

!call RecPrt('Print_Local: rMP',' ',rMP,nij,nElem)
do iElem=1,nElem
  call Add_Info('LoProp MP',rMP(1,iElem),nij,4)
end do
if (.not. NoField) then
  do iPol=1,6
    call dcopy_(nij,Polar(iPol,1),6,Temp,1)
    call Add_Info('LoProp a',Temp,nAtoms*(nAtoms+1)/2,4)
  end do
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Binom()
!                                                                      *
!***********************************************************************
!                                                                      *
! Set up array for nuclear contributions.
!
call dCopy_(nij*nElem,[Zero],0,xnrMP,1)
ij = 0
do iAtom=1,nAtoms
  do jAtom=1,iAtom
    ij = ij+1
    if (iAtom == jAtom) then
      xnrMP(ij,1) = Q_nuc(iAtom)
      CX(1) = Coor(1,iAtom)
      CX(2) = Coor(2,iAtom)
      CX(3) = Coor(3,iAtom)
      call ReExpand(xnrMP,nij,nElem,CX,EC(1,ij),ij,lMax)
    end if
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
! Loop over all domains

write(u6,*)
Banner_Line(1) = 'The Localized properties'
call Banner(Banner_Line(1),1,80)
write(u6,*)

nReal_Centers = 0
ij = 0
do iAtom=1,nAtoms
  do jAtom=1,iAtom
    ij = ij+1
    if (iAtom == jAtom) then
      !--------Atomic domain
      Charge_center = Q_nuc(iAtom)
      CX(1) = Coor(1,iAtom)
      CX(2) = Coor(2,iAtom)
      CX(3) = Coor(3,iAtom)
      Center_OK = .true.
    else
      !--------Bond domain
      Charge_center = Zero
      CX(1) = (Coor(1,iAtom)+Coor(1,jAtom))*Half
      CX(2) = (Coor(2,iAtom)+Coor(2,jAtom))*Half
      CX(3) = (Coor(3,iAtom)+Coor(3,jAtom))*Half
      Center_OK = Check_Bond(Coor(1,iAtom),Coor(1,jAtom),iANr(iAtom),iANr(jAtom),Bond_Threshold)
    end if
    call dcopy_(3,EC(1,ij),1,A,1)

    !------ Print out values for each domain.

    if (Center_OK) then
      nReal_Centers = nReal_Centers+1
      write(u6,*)
      write(u6,*)
      if (iAtom == jAtom) then
        write(u6,*) '===================='
        write(u6,'(A,A)') ' ATOMIC DOMAIN: ',Lbl_Center(iAtom)
        write(u6,*) '===================='
      else
        write(u6,*) '========================='
        write(u6,'(A,A,A,A)') ' BOND DOMAIN: ',Lbl_Center(iAtom),',',Lbl_Center(jAtom)
        write(u6,*) '========================='
      end if
      write(u6,'(A,3F12.8,A)') ' Domain center:  :',CX,' / bohr'
      write(u6,'(A,3F12.8,A)') ' Expansion center:',A,' / bohr'
      write(u6,'(A, F12.8  )') ' Total charge    :',Charge_center+rMP(ij,1)
      !*
      if (LIonize) then
        if (.not. NoField) then
          TP = (Polar(1,ij)+Polar(3,ij)+Polar(6,ij))/Three
          TP_Q = Charge_center+rMP(ij,1)
          Sites = Sites+One
          if (TP > Zero) then
            LI = 0.623_wp*(TP_Q+1.742_wp)*(One/TP)**(One/Three)
            LA = LI*(TP_Q+0.258_wp)/(TP_Q+1.742_wp)
            write(u6,*)
            write(u6,'(A)') 'Local Ionization Energy'
            write(u6,'(10F12.8)') LI
            write(u6,*)
            if (LI < LI_MIN) LI_MIN = LI
            LI_TOT = LI_TOT+LI
            write(u6,'(A)') 'Local Electron Affinity'
            write(u6,'(10F12.8)') LA
            write(u6,'(A)') 'Local Electronegativity'
            write(u6,'(10F12.8)') (LI+LA)/Two
            write(u6,'(A)') 'Local Chemical Hardness'
            write(u6,'(10F12.8)') (LI-LA)/Two

          else
            write(u6,'(A)') 'Negative isotropic polarizability!'
            write(u6,'(A)') 'The local ionization energy will'
            write(u6,'(A)') 'not be computed for this site'
          end if
        end if
      end if
      !*
      write(u6,*)
      write(u6,'(A)') ' Electronic multipole moments:'
      iStrt = 1

      do l=0,lMax
        iEnd = iStrt+(l+1)*(l+2)/2-1
        if (l == 0) write(u6,'(A)') 'Electronic Charge'
        if (l == 1) write(u6,'(A)') 'Electronic Dipole'
        if (l == 2) write(u6,'(A)') 'Electronic Quadrupole'
        if (l == 3) write(u6,'(A)') 'Electronic Octupole'
        if (l == 4) write(u6,'(A)') 'Electronic Hexadecapole'
        if (l >= 5) write(u6,'(A,I2)') 'Electronic multipole moment with l = ',l
        write(u6,'(10F12.8)') (rMP(ij,iElem),iElem=iStrt,iEnd)
        !****************************************************
        if ((iAtom == jAtom) .and. (l >= 1)) then
          write(u6,'(A)') '... with nuclear contribution'
          write(u6,'(10F12.8)') (rMP(ij,iElem)+xnrMP(ij,iElem),iElem=iStrt,iEnd)
        end if
        !****************************************************
        iStrt = iEnd+1
        write(u6,*)
      end do
      if (lMax >= 1) then
        Dip_Tot = sqrt(rMP(ij,2)**2+rMP(ij,3)**2+rMP(ij,4)**2)
        write(u6,*)
        write(u6,'(A,F12.8)') 'Dipole magnitude:',Dip_Tot
        write(u6,*)
      end if
      if (.not. NoField) then
        write(u6,*)
        call TriPrt('Symmetrized Local Polarizability Tensor',' ',Polar(1,ij),3)
        Pol_Tot = (Polar(1,ij)+Polar(3,ij)+Polar(6,ij))/Three
        write(u6,*)
        write(u6,'(A,F12.8)') 'Isotropic Polarizability:',Pol_Tot
        write(u6,*)
      end if
    end if ! Center_OK

    !debug
    !call mma_allocate(EVec,9,label='EVec')
    !call mma_allocate(EVal,6,label='EVal')
    !call dcopy_(9,[Zero],0,EVec,1)
    !call dcopy_(3,[One],0,EVec,4)
    !call dcopy_(6,Polar(1,ij),1,EVal,1)
    !call Jacob(EVal,EVec,3,3)
    !call TriPrt('EVal',' ',EVal,3)
    !call RecPrt('EVec',' ',EVec,3,3)
    !call mma_deallocate(EVal)
    !call mma_deallocate(EVec)
    !debug
    ! Reexpand all multipole moments to the center of mass

    call ReExpand(rMP,nij,nElem,A,C_o_C,ij,lMax)
    !?? call ReExpand(xrMP,nij,nElem,A,C_o_C,ij,lMax)
    call ReExpand(xnrMP,nij,nElem,EC(1,ij),C_o_C,ij,lMax)

  end do
end do
! Write the charge capacitances for the bonds
if (.not. NoField) then
  write(u6,*) '=== Charge capacitance for bonds ==='
  ij = 0
  do jAtom=1,nAtoms
    do iAtom=jAtom+1,nAtoms
      ij = iAtom*(iAtom-1)/2+jAtom
      if (iAtom == jAtom) then
      else
        CX(1) = (Coor(1,iAtom)-Coor(1,jAtom))
        CX(2) = (Coor(2,iAtom)-Coor(2,jAtom))
        CX(3) = (Coor(3,iAtom)-Coor(3,jAtom))
        CRX = ChPolBB(1,ij)*CX(1)+ChPolBB(2,ij)*CX(2)+ChPolBB(4,ij)*CX(3)

        CRY = ChPolBB(2,ij)*CX(1)+ChPolBB(3,ij)*CX(2)+ChPolBB(5,ij)*CX(3)

        CRZ = ChPolBB(4,ij)*CX(1)+ChPolBB(5,ij)*CX(2)+ChPolBB(6,ij)*CX(3)

        CRN = sqrt(CRX*CRX+CRY*CRY+CRZ*CRZ)

        DR = sqrt(CX(1)*CX(1)+CX(2)*CX(2)+CX(3)*CX(3))
        if (0.001_wp < (CRN/(DR*DR*DR))) then
          write(u6,' (A, A, F12.8)') Lbl_Center(iAtom),Lbl_Center(jAtom),CRN/(DR*DR*DR)
        end if
      end if
    end do
  end do
  write(u6,*) '=== =========================== ==='
  write(u6,*)
end if
!*** Local ionizations are implemented by A. Holt
if (LIonize) then
  if (.not. NoField) then
    write(u6,'(A)') '===   Local Ionization energy   ==='
    write(u6,'(A)') 'The local ionization energies are'
    write(u6,'(A)') 'computed using the expression for atoms'
    write(u6,'(A)') 'found in: J.Phys.Chem. 1996, 100,4828'
    write(u6,'(A)')
    write(u6,'(A)') 'Average local ionization energy'
    write(u6,'(10F12.8)') LI_TOT/Sites*auToeV
    write(u6,'(A)') 'Lowest local ionization energy (eV)'
    write(u6,'(10F12.8)') LI_MIN*auToeV
    write(u6,'(A)') 'HOMO energy (absolute value, eV)'
    write(u6,'(10F12.8)') abs(Ene_Occ(nOcOb))*auToeV
    write(u6,'(A)') '=== =========================== ==='
    write(u6,'(A)')
  end if
end if

! Write out the molecular properties

write(u6,*)
write(u6,*)
write(u6,*)
Banner_Line(1) = 'The Molecular Multipole Moments'
call Banner(Banner_Line(1),1,80)
write(u6,'(A,3F12.8,A)') ' Expansion center:',C_o_C,' / bohr'
write(u6,*)
write(u6,*)
iElem = 0
do l=0,lMax
  write(u6,*)
  write(u6,'(A,I1)') 'l=',l
  write(u6,*)
  write(u6,'(A)') 'xyz    Nuclear        Electronic     Molecular   '
  write(u6,*)
  do ix=l,0,-1
    do iy=l-ix,0,-1
      iz = l-ix-iy
      iElem = iElem+1
      rMP_Tot_Electronic = DDot_(nij,[One],0,rMP(1,iElem),1)
      rMP_Tot_Nuclear = rMPq(iElem)
      rMP_Tot = rMP_Tot_Nuclear+rMP_Tot_Electronic
      write(u6,'(3I1,3F16.8)') ix,iy,iz,rMP_Tot_Nuclear,rMP_Tot_Electronic,rMP_Tot
    end do
  end do
end do
if (.not. NoField) then
  do iPol=1,6
    Polar_M(iPol) = DDot_(nij,[One],0,Polar(iPol,1),6)
  end do
  call TriPrt('Molecular Polarizability Tensor',' ',Polar_M,3)
  !debug
  !call mma_allocate(EVec,9,label='EVec')
  !call mma_allocate(EVal,6,label='EVal')
  !call dcopy_(9,Zero,0,EVec,1)
  !call dcopy_(3,One,0,EVec,4)
  !call dcopy_(6,Polar_M,1,EVal,1)
  !call Jacob(EVal,EVec,3,3)
  !call TriPrt('EVal',' ',EVal,3)
  !call RecPrt('EVec',' ',EVec,3,3)
  !call mma_deallocate(EVal)
  !call mma_deallocate(EVec)
  !debug
end if

!------ Generate mpprop file

call Print_MPPROP(rMP,xrMP,xnrMP,nij,nElem,lMax,EC,Polar,Lbl_Center,nAtoms,iANr,NoField,C_o_C,Coor,nOcOb,Energy_Without_FFPT, &
                  Ene_Occ,MpProp_Level,Bond_Threshold,nReal_Centers)

call mma_allocate(Scratch_New,nij*(2*lMax+1),label='Scratch_New')
call mma_allocate(Scratch_Org,nij*(2*lMax+1),label='Scratch_Org')

!------ Compare the molecular multipole moments to the ones arrising from truncation
!       xrMP contains the original multipole moments (electr. + nuclear)
!       xxrMP contains the approximate multipole moments.

call dCopy_(i_Dim,rMP,1,xrMP,1)
call daxpy_(i_Dim,One,xnrMP,1,xrMP,1)
call dCopy_(i_Dim,xrMP,1,xxrMP,1)

iPrint = 1
do l=lMax-1,0,-1
  call CutOff_Error(l,lMax,xrMP,xxrMP,nij,EC,C_o_C,nElem,Scratch_New,Scratch_Org,nAtoms,iPrint,rms)
end do

call mma_deallocate(Scratch_New)
call mma_deallocate(Scratch_Org)
call Sphere_Free()

!-- Print warning if non-ANO basis sets have been used

if (.not. get_BasisType('ANO')) then
  write(u6,*)
  write(u6,*) 'WARNING: The calculation were performed with at '
  write(u6,*) '         least one non-ANO basis! The results'
  write(u6,*) '         might therefore be erroneous.'
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine Print_Local

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Roland Lindh                                     *
************************************************************************
      SubRoutine Newq(q,nInter,nIter,dq,H,g,error,B,RHS,iPvt,dg,
     &                Scrt1,nScrt1,dqHdq,iOptC,
     &                Beta,nFix,iP,UpMeth,Energy,
     &                Line_Search,Step_Trunc,Thr_RS)
************************************************************************
*                                                                      *
* Object: Driver for optimization procedures.                          *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             December '94                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
#include "WrkSpc.fh"
      Logical Print
      Real*8 q(nInter,nIter+1), dq(nInter,nIter), g(nInter,nIter),
     &       error(nInter,nIter+1), B((nIter+1)*(nIter+1)),
     &       RHS(nIter+1), dg(nInter),
     &       Scrt1(nScrt1), Energy(nIter), H(nInter,nInter)
      Integer   iPvt(nIter+1), iP(nIter)
      Character*6 UpMeth
      Character*1 Step_Trunc
      Logical Line_Search
*     Logical Fail
*
      Lu=6
      iRout = 113
      iPrint = nPrint(iRout)
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (Lu,*) ' Newq: nIter,Beta=',nIter,Beta
      Call RecPrt(' Newq: q',' ',q,nInter,nIter+1)
      Call RecPrt(' Newq: dq',' ',dq,nInter,nIter)
      Call RecPrt(' Newq: g',' ',g,nInter,nIter)
      Call RecPrt(' Newq: H   ',' ',H   ,nInter,nInter)
#endif
*
*---- Print out of the Hessian and determination of the Hessian index.
*
      print=.true.
C     Call View(H,nInter,print)
*
      dqHdq=Zero
*
*---- Perform first a linear search for the last two points
*     to find minimum along the direction of the last step.
*
*     The new point will temporarily replace the last point!
*
      If (iPrint.ge.6) Write (Lu,*)
      If (Line_Search) Then
         If (nIter.ge.2) Then
            Call GetMem('tmp_q ','Allo','Real',ipt_q ,nInter)
            Call GetMem('tmp_g ','Allo','Real',ipt_g ,nInter)
            Call GetMem('tmp_dq','Allo','Real',ipt_dq,nInter)
*
            call dcopy_(nInter,dq(1,nIter-1),1,Work(ipt_dq),1)
            call dcopy_(nInter, q(1,nIter  ),1,Work(ipt_q ),1)
            call dcopy_(nInter, g(1,nIter  ),1,Work(ipt_g ),1)
*
            Call LnSrch(Energy,q,dq,g,nInter,nIter,dqHdq)
         Else
            If (iPrint.ge.6) Write (Lu,*)
     &          '-- First iteration no line search'
         End If
      Else
         If (iPrint.ge.6) Write (Lu,*) '-- Line search is disabled'
      End If
      If (iPrint.ge.6) Write (Lu,*)
*
*-----Invoke the quadratic optimization procedure
*
*     iOptC=0001   : quasi Newton-Raphson
*     iOptC=0010   : C1-DIIS
*     iOptC=0100   : C2-DIIS
*     iOptC=1000   : Rational Function
*
      call dcopy_(nInter,[Zero],0,Scrt1,1)
*                                                                      *
************************************************************************
*                                                                      *
      If (iOptC.eq.0) Then
*
*------- No update of the geometry
*
         Call FZero(dq,nInter)
*                                                                      *
************************************************************************
*                                                                      *
      Else If (iAnd(iOptC,1).eq.1) Then
*
*------- quasi Newton-Raphson
*
         UpMeth=' qNR  '
         Call QNR(nInter,nIter,dq,H,g)
         Beta_New=Sqrt(DDot_(nInter,dq(1,nIter),1,dq(1,nIter),1))
         If (Beta_New.gt.Beta) Then
            Call DScal_(nInter,Beta/Beta_New,dq(1,nIter),1)
            Step_Trunc='*'
         End If
*
*                                                                      *
************************************************************************
*                                                                      *
      Else If (iAnd(iOptC,2).eq.2) Then
*
*------- C1-DIIS
*
         UpMeth='c1DIIS'
         MinWdw=5
         Call C1DIIS(q,nInter,nIter,dq,H,g,error,B,RHS,iPvt,nFix,
     &               iP,iOptC,MinWdw)
         Beta_New=Sqrt(DDot_(nInter,dq(1,nIter),1,dq(1,nIter),1))
         If (Beta_New.gt.Beta) Then
            Call DScal_(nInter,Beta/Beta_New,dq(1,nIter),1)
            Step_Trunc='*'
         End If
*
*                                                                      *
************************************************************************
*                                                                      *
      Else If (iAnd(iOptC,4).eq.4) Then
*
*------- C2-DIIS
*
         UpMeth='c2DIIS'
         Call C2DIIS(q,nInter,nIter,dq,H,g,error,B,RHS,
     &               Scrt1,nScrt1,nFix,iP,iOptC)
         Beta_New=Sqrt(DDot_(nInter,dq(1,nIter),1,dq(1,nIter),1))
         If (Beta_New.gt.Beta) Then
            Call DScal_(nInter,Beta/Beta_New,dq(1,nIter),1)
            Step_Trunc='*'
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else If (iAnd(iOptC,8).eq.8) Then
*
*------- Rational Function Optimization (RFO)
*
         UpMeth='  RF  '
*
         If (iAnd(iOptC,128).ne.128) Then
*
*---------- TS optimization
*
            If (iAnd(iOptC,512).ne.512) Then
*
*------------- Restricted Step Partitioned RFO
*
               Call RS_P_RFO(H,g(1,nIter),nInter,dq(1,nIter),
     &                       UpMeth,dqHdq,Beta,Step_Trunc)
            Else
*
*------------- Restricted Step Image RFO
*
               Call RS_I_RFO(H,g(1,nIter),nInter,dq(1,nIter),
     &                       UpMeth,dqHdq,Beta,Step_Trunc,Thr_RS)
            End If
*
         Else
*
*---------- Restricted Step RFO
*
*
            Call RS_RFO(H,g(1,nIter),nInter,dq(1,nIter),
     &                  UpMeth,dqHdq,Beta,Step_Trunc,Thr_RS)
*
         End If
*                                                                      *
************************************************************************
*                                                                      *
      Else
         Call WarningMessage(2,'Error in NewQ')
         Write (6,*) ' Newq: Illegal setting of iOptC!'
         Write (6,*) '  iOptC=',iOptC
         Call Abend
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- In case of a line search restore some data and add the
*     replacements.
*
*
      If (Line_Search.and.nIter.ge.2) Then
         If (iPrint.ge.99) Then
            Call RecPrt(' Newq: q ',' ',q, nInter,nIter+1)
            Call RecPrt(' Newq: dq',' ',dq,nInter,nIter  )
            Call RecPrt(' Newq: g ',' ',g, nInter,nIter)
         End If
         call dcopy_(nInter,q(1,nIter),1,q(1,nIter+1),1)
         Call DaXpY_(nInter,One,dq(1,nIter),1,q(1,nIter+1),1)
         call dcopy_(nInter,Work(ipt_q ),1, q(1,nIter  ),1)
         call dcopy_(nInter,q(1,nIter+1),1,dq(1,nIter),1)
         Call DaXpY_(nInter,-One,q(1,nIter),1,dq(1,nIter),1)
*
         call dcopy_(nInter,Work(ipt_dq), 1,dq(1,nIter-1),1)
         call dcopy_(nInter,Work(ipt_g ),1, g(1,nIter  ),1)
         If (iPrint.ge.99) Then
            Call RecPrt(' Newq: q ',' ',q, nInter,nIter+1)
            Call RecPrt(' Newq: dq',' ',dq,nInter,nIter  )
            Call RecPrt(' Newq: g ',' ',g, nInter,nIter)
         End If
*
         Call GetMem('tmp_q ','Free','Real',ipt_q ,nInter)
         Call GetMem('tmp_g ','Free','Real',ipt_g ,nInter)
         Call GetMem('tmp_dq','Free','Real',ipt_dq,nInter)
      End If
*
*-----Estimate energy at the relaxed geometry
*
      If (iAnd(iOptC,8).ne.8) Then
*
*..... g(r)
*
         call dcopy_(nInter,g(1,nIter),1,Scrt1,1)
         Call DScal_(nInter,-One,Scrt1,1)
*
*.....1/2 H(r) (r -r)
*                0
*
         Call dGeMV_('N',nInter,nInter,
     &              Half,H,nInter,dq(1,nIter),1,
     &              One,Scrt1,1)
         dqHdq=DDot_(nInter,Scrt1,1,dq(1,nIter),1)
      End If
*
      Do i = 1, nInter
        q(i,nIter+1) = q(i,nIter) + dq(i,nIter)
      End Do
*
#ifdef _DEBUGPRINT_
      Write (Lu,*) ' dqHdq=',dqHdq
      Call RecPrt('Newq: q',' ',q,nInter,nIter+1)
      Call RecPrt('Newq: dq',' ',dq,nInter,nIter)
      Call RecPrt('Newq: g',' ',g,nInter,nIter)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(dg)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Roland Lindh                                     *
!***********************************************************************

subroutine Term_Ints()
!***********************************************************************
!                                                                      *
!     Object: to deallocate memory in association with two-electron    *
!             calculations.                                            *
!                                                                      *
!     Author: Roland Lindh, Chemical Physics, University of Lund,      *
!             Sweden. January '98.                                     *
!***********************************************************************

use k2_arrays, only: Aux, Destroy_BraKet_Base, FT, iSOSym
use iSD_Data, only: iCntr, iCntr, iSh2Sh, iShOff, iSO2Sh, nShBf
use stdalloc, only: mma_deallocate

implicit none

!                                                                      *
!***********************************************************************
!                                                                      *
! In case of semi-direct mode the memory is released externally.

call RlsMem_Ints()
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(FT,safe='*')

call Destroy_Braket_base()

call mma_deallocate(Aux,safe='*')

call mma_deallocate(iSOSym,safe='*')
!                                                                      *
!***********************************************************************
!                                                                      *
if (allocated(nShBf)) then
  call mma_deallocate(nShBF)
  call mma_deallocate(iShOff)
  call mma_deallocate(iSh2Sh)
  call mma_deallocate(iSO2Sh)
  call mma_deallocate(iCntr)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Free memory for K2 data

call FreeK2()
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Term_Ints

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LA_Morok(nAtom,CorG,iMode)
! Morokuma's scaling scheme:
!   k = (q_LA - q_QM)/(q_MM - q_QM), k = constant
!
! iMode = 1 => the LA gradient is distributed
! on the frontier QM and MM atoms according to:
! dE/dq_QM = dE/dq_QM + dE/dq_LA * dq_LA/dq_QM
! dE/dq_MM = dE/dq_MM + dE/dq_LA * dq_LA/dq_MM
!
! iMode = 2 => the LA position is updated
! q_LA = q_QM + k * (q_MM - q_QM)

use espf_global, only: MMI, MMO, QM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtom, iMode
real(kind=wp), intent(inout) :: CorG(3,nAtom)
integer(kind=iwp) :: iAt, iAtIn, iAtOut, iLA, iLink, iMM, iPL, IPotFl, iQM, ITkQMMM, nLink, nTot
real(kind=wp) :: Fact
logical(kind=iwp) :: DoGromacs, DoTinker, Exists, Exists2, isOkLA, isOkMM, isOkQM, lMorok
character(len=256) :: Message
character(len=180) :: Line
character(len=10) :: ESPFKey
integer(kind=iwp), allocatable :: AT(:), DefLA(:,:), GroToMol(:)
real(kind=wp), allocatable :: FactLA(:)
character(len=180), external :: Get_Ln
integer(kind=iwp), external :: iPL_espf, IsFreeUnit

iPL = iPL_espf()
lMorok = .false.
DoTinker = .false.
DoGromacs = .false.
call F_Inquire('ESPF.DATA',Exists)
if (Exists) then
  IPotFl = IsFreeUnit(1)
  call Molcas_Open(IPotFl,'ESPF.DATA')
  do
    Line = Get_Ln(IPotFl)
    ESPFKey = Line(1:10)
    if (ESPFKey == 'LA_MOROK  ') then
      lMorok = .true.
    else if (ESPFKey == 'TINKER    ') then
      DoTinker = .true.
    else if (ESPFKey == 'GROMACS   ') then
      DoGromacs = .true.
    else if (ESPFKey == 'ENDOFESPF ') then
      exit
    end if
  end do
  close(IPotFl)
end if
if (.not. lMorok) return
#ifdef _DEBUGPRINT_
iPL = 4
call RecPrt('LA_Morok: coord or grad:',' ',CorG,3,nAtom)
#endif

! Tinker part

Exists = .false.
if (DoTinker) then
  call F_Inquire('QMMM',Exists)
end if
if (Exists) then
  ITkQMMM = IsFreeUnit(25)
  call Molcas_Open(ITkQMMM,'QMMM')
  Line = ' '
  do while (index(Line,'TheEnd ') == 0)
    Line = Get_Ln(ITkQMMM)
    if (index(Line,'LAH') /= 0) then
      call Get_I1(2,iLA)
      call Get_I1(3,iMM)
      call Get_I1(4,iQM)
      call Get_F1(5,Fact)
      if ((iMM < 1) .or. (iQM < 1)) then
        write(u6,*) 'LA_Morok: link atoms badly defined'
        write(u6,*) '          check each LA connectivity'
        call Quit_OnUserError()
      end if
#     ifdef _DEBUGPRINT_
      write(u6,*)
      write(u6,*) 'LA_Morok: LAH ',iLA,' between ',iQM,' and ',iMM
      write(u6,*) '          scaling factor : ',Fact
#     endif
      if (iMode == 1) then
        if (iPL >= 2) write(u6,*) 'LA_Morok: scaling gradients'
        CorG(:,iQM) = CorG(:,iQM)+CorG(:,iLA)*(One-Fact)
        CorG(:,iMM) = CorG(:,iMM)+CorG(:,iLA)*Fact
        CorG(:,iLA) = Zero
      else if (iMode == 2) then
        if (iPL >= 2) write(u6,*) 'LA_Morok: updating positions'
        CorG(:,iLA) = CorG(:,iQM)+(CorG(:,iMM)-Corg(:,iQM))*Fact
      else
        write(u6,*) 'LA_Morok: wrong iMode'
        call Quit_OnUserError()
      end if
    end if
  end do
  close(ITkQMMM)
end if

! Gromacs part

Exists = .false.
if (DoGromacs) then
  call Qpg_iArray('LA Def',Exists,nLink)
end if
if (Exists) then
  nLink = nLink/3
  call mma_allocate(DefLA,3,nLink)
  call mma_allocate(FactLA,nLink)
  call Get_iArray('LA Def',DefLA,3*nLink)
  call Get_dArray('LA Fact',FactLA,nLink)
  ! Check for consistency
  call Qpg_iArray('Atom Types',Exists2,nTot)
  if (.not. Exists2) then
    Message = 'LA_Morok: no atom type info on runfile'
    call WarningMessage(2,Message)
    call Abend()
  end if
  call mma_allocate(AT,nTot)
  call Get_iArray('Atom Types',AT,nTot)
  do iLink=1,nLink
    isOkLA = AT(DefLA(1,iLink)) == QM
    isOkQM = AT(DefLA(2,iLink)) == QM
    isOkMM = AT(DefLA(3,iLink)) == MMI
    if (.not. (isOkLa .and. isOkQM .and. isOkMM)) then
      Message = 'Link atoms badly defined. Check input!'
      call WarningMessage(2,Message)
      call Abend()
    end if
  end do
  ! Generate vector for translating from Gromacs to Molcas numbering
  call mma_allocate(GroToMol,nTot)
  iAtIn = 1
  iAtOut = 1
  do iAt=1,nTot
    if ((AT(iAt) == QM) .or. (AT(iAt) == MMI)) then
      GroToMol(iAt) = iAtIn
      iAtIn = iAtIn+1
    else if (AT(iAt) == MMO) then
      GroToMol(iAt) = iAtOut
      iAtOut = iAtOut+1
    else
      Message = 'LA_Morok: unknown atom type'
      call WarningMessage(2,Message)
      call Abend()
    end if
  end do
  if (iMode == 1) then
    ! Apply Morokuma scheme to gradient...
    if (iPL >= 2) then
      write(u6,*) 'Applying Morokuma scheme to gradient'
    end if
    do iLink=1,nLink
      iLA = GroToMol(DefLA(1,iLink))
      iQM = GroToMol(DefLA(2,iLink))
      iMM = GroToMol(DefLA(3,iLink))
      Fact = FactLA(iLink)
      CorG(:,iQM) = CorG(:,iQM)+CorG(:,iLA)*(1-Fact)
      CorG(:,iMM) = CorG(:,iMM)+CorG(:,iLA)*Fact
      CorG(:,iLA) = Zero
    end do
  else if (iMode == 2) then
    ! ...or to position
    if (iPL >= 2) then
      write(u6,*) 'Applying Morokuma scheme to positions'
    end if
    do iLink=1,nLink
      iLA = GroToMol(DefLA(1,iLink))
      iQM = GroToMol(DefLA(2,iLink))
      iMM = GroToMol(DefLA(3,iLink))
      Fact = FactLA(iLink)
      CorG(:,iLA) = CorG(:,iQM)+(CorG(:,iMM)-CorG(:,iQM))*Fact
    end do
  else
    Message = 'LA_Morok: wrong iMode'
    call WarningMessage(2,Message)
    call Abend()
  end if
  call mma_deallocate(DefLA)
  call mma_deallocate(FactLA)
  call mma_deallocate(AT)
  call mma_deallocate(GroToMol)
end if

#ifdef _DEBUGPRINT_
call RecPrt('LA_Morok: coord or grad:',' ',CorG,3,nAtom)
#endif

end subroutine LA_Morok

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKMID(IDRT,IDAW,IRAW,LTV,IPRINT)
C     PURPOSE: FIND THE MIDLEVEL
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
#include "gugx.fh"
#include "rasdim.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter(Routine='MKMID')
C
      DIMENSION IDRT(NVERT,5)
      DIMENSION IDAW(NVERT,0:4)
      DIMENSION IRAW(NVERT,0:4)
      DIMENSION LTV(-1:NLEV)


C
C     SET UP A LEVEL-TO-VERTEX TABLE, LTV, AND IDENTIFY MIDVERTICES:
C
      LTAB=1
      DO LEV=-1,NLEV
        LTV(LEV)=0
      End Do
*
      DO IV=1,NVERT
        LEV=IDRT(IV,LTAB)
        LTV(LEV)=LTV(LEV)+1
      End Do
*
      DO LEV=NLEV,0,-1
        LTV(LEV-1)=LTV(LEV-1)+LTV(LEV)
      End Do
*
      DO LEV=-1,NLEV-1
        LTV(LEV)=1+LTV(LEV+1)
      End Do
C
C     USE IDAW,IRAW TABLES TO DETERMINE MIDLEV.
C     THE ASSUMPTION IS THAT A BALANCED NUMBER OF UPPER/LOWER WALKS
C     IS THE BEST CHOICE.
C
*hrl 980529 fix for nLev=0 (no orbitals in any active space)
*     Since LTV(-1:nLev)  and the statement after the loop
*     MidV1=LTV(MidLev) we have the condition MidLev>=nLev
*     Hence MidLev=1 is inappropriate for nLev=0
*     MIDLEV=1
*
      If (nLev.eq.0) Then
         MIDLEV=0
      Else
         MIDLEV=1
      End If
      MINW=1000000
      DO IL=1,NLEV-1
        NW=0
        DO IV=LTV(IL),LTV(IL-1)-1
          NW=NW+IRAW(IV,4)-IDAW(IV,4)
        END DO
        NW=ABS(NW)
        IF(NW.GE.MINW) GOTO 160
        MIDLEV=IL
        MINW=NW
160   CONTINUE
      END DO
      MIDV1=LTV(MIDLEV)
      MIDV2=LTV(MIDLEV-1)-1
      NMIDV=1+MIDV2-MIDV1
C
C     NOW FIND THE MAX NUMBERS OF UPPER AND LOWER WALKS. RESPECTIVELY
C     (DISREGARDING SYMMETRY)
C
      MXUP=0
      MXDWN=0
      DO MV=MIDV1,MIDV2
c        MXUP=MAX(MXUP,IRAW(MV,4))
        if(MXUP.lt.IRAW(MV,4)) MXUP=IRAW(MV,4)
c        MXDWN=MAX(MXDWN,IDAW(MV,4))
        if(MXDWN.lt.IDAW(MV,4)) MXDWN=IDAW(MV,4)
      END DO
C
      IF( IPRINT.GE.5 ) THEN
        Write(LF,*)
        Write(LF,'(A,I3)')' MIDLEVEL =             ',MIDLEV
        Write(LF,'(A,I3)')' NUMBER OF MIDVERTICES =',NMIDV
        Write(LF,'(A,I3)')' FIRST MIDVERTEX =      ',MIDV1
        Write(LF,'(A,I3)')' LAST MIDVERTEX =       ',MIDV2
        Write(LF,'(A,I3)')' MAX. NO UPPER WALKS=   ',MXUP
        Write(LF,'(A,I3)')' MAX. NO LOWER WALKS=   ',MXDWN
        Write(LF,*)
      ENDIF

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!               2021, Roland Lindh                                     *
!***********************************************************************

subroutine Mk_iShp_rs(iShp_rs,nShell)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nShell
integer(kind=iwp), intent(out) :: iShp_rs(nShell*(nShell+1)/2)
integer(kind=iwp) :: iaSh, ibSh, iShp
integer(kind=iwp), external :: Cho_F2SP

! *** Mapping shell pairs from the full to the reduced set

do iaSh=1,nShell
  do ibSh=1,iaSh
    iShp = iaSh*(iaSh-1)/2+ibSh
    iShp_rs(iShp) = Cho_F2SP(iShp)
  end do
end do

end subroutine Mk_iShp_rs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!***********************************************************************
!*                                                                     *
!*  CNFPRT   := Print configurations.                                  *
!*                                                                     *
!***********************************************************************
subroutine cnfprt_cvb(iconfs,nconf1,nel1)

use casvb_global, only: noe, norb
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nconf1, iconfs(noe,nconf1), nel1
integer(kind=iwp) :: iconf, ii, ioffs, iorb
integer(kind=iwp), allocatable :: tmp(:)

call mma_allocate(tmp,noe,label='tmp')
! Main loop over configurations:
do iconf=1,nconf1
  ! Prepare tmp for print
  ioffs = 0
  do iorb=1,norb
    if (iconfs(iorb,iconf) == 2) then
      tmp(1+ioffs) = iorb
      tmp(2+ioffs) = iorb
      ioffs = ioffs+2
    end if
  end do
  do iorb=1,norb
    if (iconfs(iorb,iconf) == 1) then
      tmp(1+ioffs) = iorb
      ioffs = ioffs+1
    end if
  end do
  write(u6,'(i8,a,20i3)') iconf,'   =>  ',(tmp(ii),ii=1,nel1)
end do
call mma_deallocate(tmp)

return

end subroutine cnfprt_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Roland Lindh                                     *
!***********************************************************************

subroutine Driver(KSDFA,Do_Grad,Func,Grad,nGrad,Do_MO,Do_TwoEl,D_DS,F_DFT,nh1,nD,DFTFOCK)

use libxc_parameters, only: Coeffs, func_id, initiate_libxc_functionals, libxc_functionals, nFuncs, nFuncs_max, &
                            remove_libxc_functionals
use xc_f03_lib_m, only: XC_CORRELATION, XC_EXCHANGE, xc_f03_func_end, xc_f03_func_get_info, xc_f03_func_info_get_kind, &
                        xc_f03_func_init, xc_f03_func_t, xc_f03_func_info_t, XC_GGA_K_TFVW, XC_LDA_K_TF, XC_UNPOLARIZED
use Functionals, only: Get_Funcs
use KSDFT_Info, only: Do_PDFTPOT
use OFembed, only: dFMD, Do_Core, KEOnly
use libxc, only: Only_exc
use nq_Grid, only: l_casdft
use nq_Info, only: Functional_type, GGA_Type, LDA_Type
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: KSDFA
logical(kind=iwp), intent(in) :: Do_Grad
integer(kind=iwp), intent(in) :: nGrad, nh1, nD
real(kind=wp), intent(inout) :: Func, Grad(nGrad), F_DFT(nh1,nD)
logical(kind=iwp), intent(inout) :: Do_MO, Do_TwoEl
real(kind=wp), intent(in) :: D_DS(nh1,nD)
character(len=4), intent(in) :: DFTFOCK
integer(kind=iwp) :: i, j
logical(kind=iwp) :: IsFT, LDTF, NDSD
character(len=80) :: FLabel
type(xc_f03_func_t) :: func_
type(xc_f03_func_info_t) :: info_
!***********************************************************************
! Define external functions not defined in LibXC. These are either
! accessed through the procedure pointer Sub or External_sub.
abstract interface
  subroutine DFT_FUNCTIONAL(mGrid,nD)
    import :: iwp
    integer(kind=iwp), intent(in) :: mGrid, nD
  end subroutine
end interface
procedure(DFT_FUNCTIONAL) :: Overlap, NucAtt, ndsd_ts
procedure(DFT_FUNCTIONAL), pointer :: Sub, External_sub
!***********************************************************************

!                                                                      *
!***********************************************************************
! Global variable for MCPDFT functionals                               *
FLabel = KSDFA ! The user could be passing an explicit string! Hence, the local copy.

! Set some flags and clean up the label to be just the label of the
! underlaying DFT functional.

l_casdft = (FLabel(1:2) == 'T:') .or. (FLabel(1:3) == 'FT:')

IsFT = FLabel(1:3) == 'FT:'

if (l_casdft) then
  FLabel = FLabel(index(FLabel,'T:')+2:)
  Do_MO = .true.
  Do_TwoEl = .true.
  if ((.not. Do_PDFTPOT) .and. (.not. DO_Grad)) Only_exc = .true.
end if

if (FLabel(1:5) == 'LDTF/') then
  LDTF = .true.
  FLabel = FLabel(6:)
else
  LDTF = .false.
end if
if (FLabel(1:5) == 'NDSD/') then
  NDSD = .true.
  FLabel = FLabel(6:)
else
  NDSD = .false.
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
! Default is to use the libxc interface
! Coefficient for the individual contibutions are defaulted to 1.0

Sub => libxc_functionals     ! Default
External_Sub => null()       ! Default
Coeffs(:) = One              ! Default
!                                                                      *
!***********************************************************************
!                                                                      *
select case (FLabel)
!                                                                      *
!***********************************************************************
!                                                                      *
! Overlap

  case ('Overlap')
    Functional_type = LDA_type
    Sub => Overlap
!                                                                      *
!***********************************************************************
!                                                                      *
! NucAtt

  case ('NucAtt')
    Functional_type = LDA_type
    Sub => NucAtt
!                                                                      *
!***********************************************************************
!                                                                      *
! The names TF_only and HUNTER are hardcoded in some parts of the code,*
! so we define them explicitly instead of relying on the external file *
!                                                                      *
!***********************************************************************
!                                                                      *
! Kinetic only (Thomas-Fermi)

  case ('TF_only')
    Functional_type = LDA_type

    nFuncs = 1
    func_id(1:nFuncs) = [XC_LDA_K_TF]
!                                                                      *
!***********************************************************************
!                                                                      *
!  HUNTER (von Weizsacker KE, no calc of potential)

  case ('HUNTER')
    Functional_type = GGA_type

    nFuncs = 1
    func_id(1:nFuncs) = [XC_GGA_K_TFVW]
    Only_exc = .true.
!                                                                      *
!***********************************************************************
!                                                                      *
  case default
    call Get_Funcs(FLabel)

end select
!                                                                      *
!***********************************************************************
!                                                                      *
if ((Functional_type /= LDA_type) .and. (Functional_type /= GGA_type) .and. l_CasDFT) then
  write(u6,*) ' MC-PDFT combined with invalid functional class'
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
if (Do_Core) then
  ! Keep only correlation
  do i=1,nFuncs
    call xc_f03_func_init(func_,func_id(i),XC_UNPOLARIZED)
    info_ = xc_f03_func_get_info(func_)
    if (xc_f03_func_info_get_kind(info_) == XC_CORRELATION) then
      Coeffs(i) = Coeffs(i)*dFMD
    else
      Coeffs(i) = Zero
    end if
    call xc_f03_func_end(func_)
  end do
else if (LDTF) then
  ! Add TF kinetic with same coeff as exchange
  ! and optionally kill everything else
  do i=1,nFuncs
    call xc_f03_func_init(func_,func_id(i),XC_UNPOLARIZED)
    info_ = xc_f03_func_get_info(func_)
    if (xc_f03_func_info_get_kind(info_) == XC_EXCHANGE) then
      if (nFuncs == nFuncs_max) then
        write(u6,*) ' Too many functionals for LDTF'
        call Abend()
      end if
      func_id(nFuncs+1) = XC_LDA_K_TF
      Coeffs(nFuncs+1) = Coeffs(i)
      nFuncs = nFuncs+1
    end if
    if (KEOnly) Coeffs(i) = Zero
    call xc_f03_func_end(func_)
  end do
else if (NDSD) then
  ! Add ndsd_ts, and optionally kill everything else
  if (KEOnly) then
    Coeffs(:) = Zero
    Sub => ndsd_ts
  else
    Only_exc = .true.
    External_Sub => ndsd_ts
  end if
end if
! Reduce list
j = 0
do i=1,nFuncs
  if (Coeffs(i) == Zero) cycle
  j = j+1
  if (j == i) cycle
  Coeffs(j) = Coeffs(i)
  func_id(j) = func_id(i)
end do
nFuncs = j
!                                                                      *
!***********************************************************************
!                                                                      *
! Now let's do some integration!
! If the libxc interface is used do the proper initialization and closure.

if (associated(Sub,libxc_functionals)) call Initiate_libxc_functionals(nD)

call DrvNQ(Sub,F_DFT,nD,Func,D_DS,nh1,nD,Do_Grad,Grad,nGrad,Do_MO,Do_TwoEl,DFTFOCK,IsFT)

if (associated(Sub,libxc_functionals)) call Remove_libxc_functionals()

if (associated(External_Sub)) call DrvNQ(External_Sub,F_DFT,nD,Func,D_DS,nh1,nD,Do_Grad,Grad,nGrad,Do_MO,Do_TwoEl,DFTFOCK,IsFT)

Only_exc = .false.
LDTF = .false.
NDSD = .false.
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Driver

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_XCV_Distrib_SP(mySP,l_mySP,N_mySP)
!
! Thomas Bondo Pedersen, April 2010.
!
! Determine distribution of Shell Pairs according to their
! dimension.

use Para_Info, only: MyRank, nProcs
use Cholesky, only: Cho_Real_Par, nnBstRSh, nnShl, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: l_mySP
integer(kind=iwp), intent(out) :: mySP(l_mySP), N_mySP
integer(kind=iwp) :: iNode, iSP, n
integer(kind=iwp), allocatable :: ProcDim(:)
integer(kind=iwp), external :: Cho_iFindSmallest

#ifdef _DEBUGPRINT_
if (l_mySP < nnShl) call Cho_Quit('Dimension error in Cho_XCV_Distrib_SP',103)
#endif

if (Cho_Real_Par) then
  call mma_allocate(ProcDim,nProcs,Label='ProcDim')
  ProcDim(:) = 0

  N_mySP = 0
  do iSP=1,nnShl
    n = sum(nnBstRSh(1:nSym,iSP,1))
    if (n > 0) then
      iNode = Cho_iFindSmallest(ProcDim,nProcs)
      ProcDim(iNode) = ProcDim(iNode)+n
      if (iNode-1 == myRank) then
        N_mySP = N_mySP+1
        mySP(N_mySP) = iSP
      end if
    end if
  end do

  call mma_deallocate(ProcDim)
else
  N_mySP = 0
  do iSP=1,nnShl
    n = sum(nnBstRSh(1:nSym,iSP,1))
    if (n > 0) then
      N_mySP = N_mySP+1
      mySP(N_mySP) = iSP
    end if
  end do
end if

end subroutine Cho_XCV_Distrib_SP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine DENS(IVEC,NDMAT,NSTATE,DMAT,UEFF,U0)

use Index_Functions, only: iTri, nTri_Elem
use CHOVEC_IO, only: nvloc_chobatch
use PrintLevel, only: DEBUG, VERBOSE
use EQSOLV, only: IVECC, IVECC2, IVECR, IVECW, IVECX
use ChoCASPT2, only: iALGO, MaxVec_PT2
use sguga, only: SGS
use caspt2_global, only: CLag, CLagFull, CMOPT2, DMIX, do_csf, do_grad, DPT2_AO_tot, DPT2_tot, DPT2C_AO_tot, DPT2C_tot, &
                         DPT2Canti_tot, DREF, FIFA, FIFA_all, FIMO, FIMO_all, IDCIEX, IDTCEX, if_invar, if_invaria, if_SSDM, &
                         imag_shift, iPrGlb, iRoot1, iRoot2, jStLag, NDREF, nOLag, OLag, OMGDER, real_shift, sigma_p_epsilon, &
                         SLag, TORB, Weight
use caspt2_module, only: DENORM, HZERO, IfChol, IFDENS, IFDW, IFMSCOUP, IFSADREF, iRlxRoot, JSTATE, MAXIT, NAES, NASH, NASHT, &
                         NBAS, NBAST, NBSQT, NCONF, NFROT, NISH, NORB, NOSQT, NRAS1T, NRAS2T, NRAS3T, NROOTS, NSYM, ORBIN, ZETA
use BDerNEV, only: BDerNEV_initial, BDerNEV_final1, BDerNEV_final2
use SC_NEVPT2, only: SC_prop
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par, King
use caspt2_global, only: nCLag
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC, NDMAT, NSTATE
real(kind=wp), intent(inout) :: DMAT(NDMAT)
real(kind=wp), intent(in) :: UEFF(nState,nState), U0(nState,nState)
integer(kind=iwp) :: I, iBasI, iBasSq, iBasTr, ibk, IDM, IDMOFF, IDRF, IDSOFF, IDSUM, IFF, II, IP, IQ, iSQ, iState, iStLag, ISYM, &
                     IT, ITABS, iTR, ITTOT, IU, IUABS, IUTOT, J, jBasI, liBasSq, liBasTr, lT2AO, NA, nBasI, nch, NDPT, nDPTAO, NI, &
                     NLEV, NO, nOcc, nOrbI
real(kind=wp) :: CPE, CPTF0, CPTF10, CPUT, Scal, TIOE, TIOTF0, TIOTF10, val, WALLT, wgt, X
integer(kind=iwp), allocatable :: ISAV(:)
real(kind=wp), allocatable :: A_PT2(:), CI1(:), CLagT(:,:), DEPSA(:,:), DEPSA_diag(:), DI(:), DIA(:), DPT(:), DPT2(:), DPT2_AO(:), &
                              DPT2C_AO(:), DSUM(:), EigT(:,:), FPT2(:), FPT2_AO(:), FPT2C(:), FPT2C_AO(:), OMGT(:,:), RDMEIG(:,:), &
                              RDMSA(:,:), T2AO(:), Trf(:), VECROT(:), WRK1(:), WRK2(:)
real(kind=wp), allocatable, target :: DPT2Canti_(:), DPT2C(:)
real(kind=wp), pointer :: DPT2Canti(:)

if (do_grad) then
  !! Set indices for densities and partial derivatives
  call mma_allocate(VECROT,nState,Label='VECROT')
  call GradPrep(nState,UEFF,VECROT)

  ! Compute total density matrix as symmetry-blocked array of
  ! triangular matrices in DMAT. Size of a triangular submatrix is
  !  nTri_Elem(NORB(ISYM)).
  NDPT = sum(NORB(1:nSym)**2)
  nDPTAO = sum(nBas(1:nSym)**2)
  ! shouldn't be necessary, is already done outside
  DMAT(1:NDMAT) = Zero
  ! First, put in the reference density matrix.
  IDMOFF = 0
  do ISYM=1,NSYM
    NI = NISH(ISYM)
    NA = NASH(ISYM)
    NO = NORB(ISYM)
    do II=1,NI
      IDM = IDMOFF+nTri_Elem(II)
      DMAT(IDM) = Two
    end do
    do IT=1,NA
      ITABS = NAES(ISYM)+IT
      ITTOT = NI+IT
      do IU=1,IT
        IUABS = NAES(ISYM)+IU
        IUTOT = NI+IU
        IDRF = iTri(ITABS,IUABS)
        IDM = IDMOFF+iTri(ITTOT,IUTOT)
        DMAT(IDM) = DREF(IDRF)
      end do
    end do
    IDMOFF = IDMOFF+nTri_Elem(NO)
  end do
  !write(u6,*) ' DENS. Initial DMAT:'
  !write(u6,'(1x,8f16.8)') (dmat(i),i=1,ndmat)
  ! Add the 1st and 2nd order density matrices:
  call mma_allocate(DPT,NDPT,Label='DPT')
  call mma_allocate(DSUM,NDPT,Label='DSUM')
  DPT(:) = Zero
  DSUM(:) = Zero

  !! Modify the solution (T; amplitude), if the real- or
  !! imaginary- shift is utilized. We need both the unmodified (T)
  !! and modified (T+\lambda) amplitudes. \lambda can be obtained
  !! by solving the CASPT2 equation, but it can alternatively
  !! obtained by a direct summation only if CASPT2-D.
  !! iVecX remains unchanged (iVecX = T)
  !! iVecR will be 2\lambda

  !! For MS-CASPT2, calling this subroutine is required.
  !! The lambda-equation is solved without iteration only when
  !! MS-CASPT2-D (shift?). Otherwise, solved iteratively.
  !! After this subroutine, iVecR has multi-state weighted (?)
  !! contributions.
  call TIMING(CPTF0,CPE,TIOTF0,TIOE)
  call CASPT2_Res(VECROT,nState)
  call TIMING(CPTF10,CPE,TIOTF10,TIOE)
  if (IPRGLB >= VERBOSE) then
    CPUT = CPTF10-CPTF0
    WALLT = TIOTF10-TIOTF0
    write(u6,'(a,2f10.2)') ' Lambda  : CPU/WALL TIME=',cput,wallt
  end if

  call TIMING(CPTF0,CPE,TIOTF0,TIOE)
  !! Diagonal part
  if (SC_prop) then
    call TRDNS2D(iVecW,iVecC,DPT,NDPT,VECROT(JSTATE))
  else
    call TRDNS2D(iVecX,iVecR,DPT,NDPT,VECROT(JSTATE))
  end if
  !! Remove the off-diagonal elements in inactive/secondary
  if (.not. if_invaria) call caspt2_grad_invaria1(NDPT,DPT)
  DSUM(:) = DSUM(:)+DPT(:)
  !write(u6,*) ' DPT after TRDNS2D.'
  !write(u6,'(1x,8f16.8)') (dpt(i),i=1,ndpt)
  !! Off-diagonal part, if full-CASPT2
  if (MAXIT /= 0) then
    !! off-diagonal are ignored for CASPT2-D
    DPT(:) = Zero
    call TRDNS2O(iVecX,iVecR,DPT,size(DPT),NDPT,VECROT(JSTATE))
    DSUM(:) = DSUM(:)+DPT(:)
  end if
  !write(u6,*) ' DPT after TRDNS2O.'
  !write(u6,'(1x,8f16.8)') (dpt(i),i=1,ndpt)
  call TIMING(CPTF10,CPE,TIOTF10,TIOE)
  if (IPRGLB >= VERBOSE) then
    CPUT = CPTF10-CPTF0
    WALLT = TIOTF10-TIOTF0
    write(u6,'(a,2f10.2)') ' TRDNS2DO: CPU/WALL TIME=',cput,wallt
  end if

  !! D^PT2 in MO
  call mma_allocate(DPT2,NBSQT,Label='DPT2')
  !! D^PT2(C) in MO
  call mma_allocate(DPT2C,NBSQT,Label='DPT2C')
  !! DPTAO1 (D^PT in AO, but not DPTA-01) couples with
  !! the CASSCF density (assume state-averaged) through ERIs.
  !! This density corresponds to the eigenvalue derivative.
  !! This is sometimes referred to as DPT2(AO) else where.
  call mma_allocate(DPT2_AO,NBSQT,Label='DPT2_AO')
  !! DPTAO2 couples with the inactive density.
  !! This density comes from derivative of the generalized
  !! Fock matrix (see for instance Eq. (24) in the 1990 paper).
  !! This is sometimes referred to as DPT2C(AO) else where.
  call mma_allocate(DPT2C_AO,NBSQT,Label='DPT2C_AO')
  !! DPTAO,DPTCAO,FPTAO,FPTCAO are in a block-squared form
  call mma_allocate(FPT2,NBSQT,Label='FPT2')
  call mma_allocate(FPT2C,NBSQT,Label='FPT2C')
  call mma_allocate(FPT2_AO,NBSQT,Label='FPT2_AO')
  call mma_allocate(FPT2C_AO,NBSQT,Label='FPT2C_AO')
  !! Transformation matrix
  call mma_allocate(Trf,NBSQT,Label='TRFMAT')
  nch = 0
  if (IfChol) nch = nvloc_chobatch(1)
  call mma_allocate(WRK1,max(nBasT**2,nch),Label='WRK1')
  call mma_allocate(WRK2,max(nBasT**2,nch),Label='WRK2')
  !! state-averaged density
  call mma_allocate(RDMSA,nAshT,nAshT,Label='RDMSA')
  !! Derivative of state-averaged density
  call mma_allocate(RDMEIG,nAshT,nAshT,Label='RDMEIG')
  NLEV = SGS%NLEV
  if (nAshT /= SGS%NLEV) then
    write(u6,*) 'Analytical gradients for nAshT /= SGS%NLEV (GASPT2?) does not work'
    call abend()
  end if
  !write(u6,*) 'olag before'
  !call sqprt(olag,nbast)

  DPT2(:) = Zero
  DPT2C(:) = Zero
  DPT2_AO(:) = Zero
  DPT2C_AO(:) = Zero
  FPT2(:) = Zero
  FPT2C(:) = Zero
  FPT2_AO(:) = Zero
  FPT2C_AO(:) = Zero
  if (.not. IfChol) then
    FIMO_all(:) = Zero
    FIFA_all(:) = Zero
  end if
  RDMSA(:,:) = Zero
  RDMEIG(:,:) = Zero

  CLag(:,:) = Zero
  OLag(:) = Zero

  if ((nFroT /= 0) .or. (.not. if_invaria)) then
    call mma_allocate(DIA,NBSQT,Label='DIA')
    call mma_allocate(DI,NBSQT,Label='DI')
  else
    call mma_allocate(DIA,1,Label='DIA')
    call mma_allocate(DI,1,Label='DI')
  end if

  if (do_csf) then
    call mma_allocate(DPT2Canti_,NBSQT,Label='DPT2Canti')
    DPT2Canti_(:) = Zero
    DPT2Canti => DPT2Canti_
  else
    DPT2Canti => DPT2C
  end if

  !! DPT -> DPT2
  !! Note that DPT2 has the index of frozen orbitals.
  !! Note also that unrelaxed (w/o Z-vector) dipole moments with
  !! frozen orbitals must be wrong.
  !dpt(:) = Zero
  if ((nFroT == 0) .and. if_invaria) then
    DPT2(1:nOsqT) = DSUM(1:nOsqT)
  else
    call OLagFro0(NOSQT,NBSQT,DSUM,DPT2)
  end if

  !! Construct the transformation matrix
  !! It seems that we have to transform quasi-canonical
  !! to CASSCF orbitals. The forward transformation has been
  !! done in ORBCTL.
  !!   C(PT2) = C(CAS)*X    ->    C(CAS) = C(PT2)*X^T
  !!   -> L(CAS) = X*L(PT2)*X^T
  !! inactive and virtual orbitals are not affected.
  Trf(:) = Zero
  call CnstTrf(NBSQT,TOrb,Trf)
  !call sqprt(trf,nbast)

  !! Construct the density matrix used in the Fock operator
  if (IFSADREF) then
    WRK1(1:nDRef) = Zero
    do iState=1,nState
      WRK1(1:nDRef) = WRK1(1:nDRef)+Weight(iState)*DMix(1:nDRef,iState)
    end do
  else
    WRK1(1:nDRef) = DMix(1:nDRef,jState)
  end if
  call SQUARE(WRK1,RDMSA,1,nAshT,nAshT)
  !write(u6,*) 'state-averaged density matrix'
  !call sqprt(rdmsa,nasht)

  ! ----- Construct configuration Lagrangian -----

  !! For CI coefficient derivatives (CLag)
  !! Calculate the configuration Lagrangian
  !! This is done in the quasi-canonical basis
  call mma_allocate(DEPSA,nAshT,nAshT,Label='DEPSA')
  DEPSA(:,:) = Zero
  !! Derivative of off-diagonal H0 of <Psi1|H0|Psi1>
  if (MAXIT /= 0) then
    call TIMING(CPTF0,CPE,TIOTF0,TIOE)
    call SIGDER(iVecX,iVecR,VECROT(jState))
    call TIMING(CPTF10,CPE,TIOTF10,TIOE)
    if (IPRGLB >= VERBOSE) then
      CPUT = CPTF10-CPTF0
      WALLT = TIOTF10-TIOTF0
      write(u6,'(a,2f10.2)') ' SIGDER  : CPU/WALL TIME=',cput,wallt
    end if
  end if
  IFF = 1
  if (HZero == 'DYALL') then
    IFF = 0
    call BDerNEV_initial()
  end if
  call CLagX(IFF,nConf,nRoots,nState,nAshT,CLag,DEPSA,VECROT)
  !call test3_dens(clag)
# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) call GADGOP(DEPSA,nAshT**2,'+')
# endif
  if (HZERO == 'DYALL') call BDerNEV_final1(NBSQT,DPT2C)
  !write(u6,*) 'original depsa'
  !call sqprt(depsa,nasht)
  !write(u6,*) 'original depsa (sym)'
  do i=1,nasht
    do j=1,i-1
      val = (DEPSA(i,j)+DEPSA(j,i))*Half
      DEPSA(i,j) = val
      DEPSA(j,i) = val
    end do
  end do
  !call sqprt(depsa,nasht)

  if (NRAS1T+NRAS3T /= 0) then
    !! The density of the independent pairs (off-diagonal blocks)
    !! should be determined by solving Z-vector, so these blocks
    !! should be removed...?
    ! write(u6,*) 'removing DEPSA of off-diagonal blocks'
    ! write(u6,*) 'before'
    ! call sqprt(depsa,nasht)
    DEPSA(1:nRAS1T,nRAS1T+1:) = Zero
    DEPSA(nRAS1T+1:,1:nRAS1T) = Zero
    DEPSA(nRAS1T+1:nRAS1T+nRAS2T,nRAS1T+nRAS2T+1:) = Zero
    DEPSA(nRAS1T+nRAS2T+1:,nRAS1T+1:nRAS1T+nRAS2T) = Zero
    !write(u6,*) 'after'
    !call sqprt(depsa,nasht)
    if (IPRGLB >= DEBUG) write(u6,*) 'depsa (sym) after removing off-diagonal blocks'
  else
    if (IPRGLB >= DEBUG) write(u6,*) 'depsa (sym)'
  end if
  if (IPRGLB >= VERBOSE) call sqprt(depsa,nasht)

  !! Configuration Lagrangian for MS-CASPT2
  !! This is the partial derivative of the transition reduced
  !! density matrices
  if (IFMSCOUP) then
    call TIMING(CPTF0,CPE,TIOTF0,TIOE)
    call DerHEff(nConf,nRoots,nState,CLag,VECROT)
    call TIMING(CPTF10,CPE,TIOTF10,TIOE)
    if (IPRGLB >= VERBOSE) then
      CPUT = CPTF10-CPTF0
      WALLT = TIOTF10-TIOTF0
      write(u6,'(a,2f10.2)') ' DerHEff : CPU/WALL TIME=',cput,wallt
      write(u6,*)
    end if
  end if

  !! I need to add the derivative of the effective Hamiltonian
  !! for MS-CASPT2, but this is done after orbital Lagrangian.
  !! I just have to have IVECC = T + lambda.

  !! If CASPT2 energy is not invariant to rotations in active
  !! orbitals, off-diagonal elements of the density obtained
  !! as DEPSA is incorrect, so remove them. The true density
  !! is computed after everything.
  if (.not. if_invar) then
    !! But, save the diagonal elements
    call mma_allocate(DEPSA_diag,nAshT,Label='DEPSA_diag')
    do i=1,nAshT
      DEPSA_diag(i) = DEPSA(i,i)
    end do
    !! Clear
    DEPSA(:,:) = Zero
  end if
  !write(u6,*) 'depsad'
  !call sqprt(depsa,nasht)

  !! Transform the quasi-variational amplitude (T+\lambda/2?)
  !! in SR (iVecX) to C (iVecC2)
  !! Note that the contribution is multiplied by two
  !! somewhere else (maybe in olagns?)
  if ((real_shift /= Zero) .or. (imag_shift /= Zero) .or. (sigma_p_epsilon /= Zero) .or. IFMSCOUP) then
    !! Have to weight the T-amplitude for MS-CASPT2
    if (IFMSCOUP) then
      if (.not. SC_prop) then
        !! add lambda
        call PLCVEC(VECROT(jState),Half,IVECX,IVECR)
        call PTRTOC(1,IVECR,IVECC2)
        !! T-amplitude
        do iStLag=1,nState
          if (iStLag == jState) cycle
          Scal = VECROT(iStLag)
          if (abs(Scal) <= 1.0e-12_wp) cycle
          call MS_Res(2,jStLag,iStLag,Scal*Half)
        end do
      end if
      if (do_csf) then
        !! Prepare for something <\Phi_K^{(1)}|Ers|L>
        ibk = IVECC2
        IVECC2 = 7
        call RHS_ZERO(IVECC2)
        do iStLag=1,nState
          if (iStLag == jState) cycle
          Scal = UEFF(iStLag,iRoot1)*UEFF(jStLag,iRoot2)-UEFF(jStLag,iRoot1)*UEFF(iStLag,iRoot2)
          Scal = Scal*Half
          if (abs(Scal) <= 1.0e-12_wp) cycle
          call MS_Res(2,jStLag,iStLag,Scal)
        end do
        IVECC2 = ibk
      end if
    else
      !! Add lambda to the T-amplitude
      call PLCVEC(Half,One,IVECR,IVECX)
      call PTRTOC(1,IVECX,IVECC2)
    end if
  end if

  !ipTrfL = 1+nAshT*nBasT+nAshT
  !Call DGemm_('n','N',nAshT,nAshT,nAshT,One,Trf(ipTrfL),nBasT,DEPSA,nAshT,Zero,dpt2c_ao,nAshT)
  !Call DGemm_('N','t',nAshT,nAshT,nAshT,One,dpt2c_ao,nAshT,Trf(ipTrfL),nBasT,Zero,DEPSA,nAshT)

  !! Just add DEPSA to DPT2
  call AddDEPSA(NBSQT,nAshT,DPT2,DEPSA)
  !! Just transform the density in MO to AO
  call DPT2_Trf(NBSQT,nAshT,DPT,DPT2_AO,CMOPT2,DEPSA,DSUM)
  !call mma_deallocate(DEPSA)
  !! Save the AO density
  !! ... write

  ! ----- Construct orbital Lagrangian -----

  if ((nFroT /= 0) .or. (.not. if_invaria)) then
    !! If frozen orbitals exist, we need to obtain
    !! electron-repulsion integrals with frozen orbitals to
    !! construct the orbital Lagrangian.
    if (.not. IfChol) call TRAFRO(1)

    !! Get density matrix (DIA) and inactive density
    !! matrix (DI) to compute FIFA and FIMO.
    call OLagFroD(NBSQT,nAshT,DIA,DI,RDMSA,Trf)
  end if

  !! Construct orbital Lagrangian that comes from the derivative
  !! of ERIs. Also, do the Fock transformation of the DPT2 and
  !! DPT2C densities.
  if (IfChol) then
    call mma_allocate(A_PT2,MaxVec_PT2**2,Label='A_PT2')
    A_PT2(:) = Zero
  else
    call mma_allocate(A_PT2,1,Label='A_PT2')
  end if
  do iSym=1,nSym
    nOcc = nIsh(iSym)+nAsh(iSym)
    lT2AO = 1
    if ((.not. IfChol) .or. (iALGO /= 1)) then
      lT2AO = nOcc*nOcc*nBasT*nBasT
      call mma_allocate(T2AO,lT2AO,Label='T2AO')
      T2AO(:) = Zero
    else
      call mma_allocate(T2AO,lT2AO,Label='T2AO')
    end if

    !! Orbital Lagrangian that comes from the derivative of ERIs.
    !! OLagNS computes only the particle orbitals.
    !write(u6,*) 'ialgo = ',ialgo
    call TIMING(CPTF0,CPE,TIOTF0,TIOE)
    if (IfChol .and. (iALGO == 1)) then
      call OLagNS_RI(iSym,NBSQT,MaxVec_PT2,DPT2C,DPT2Canti,A_PT2)
    else
      call OLagNS2(iSym,NBSQT,lT2AO,DPT2C,T2AO)
    end if
    call TIMING(CPTF10,CPE,TIOTF10,TIOE)
    if (IPRGLB >= VERBOSE) then
      CPUT = CPTF10-CPTF0
      WALLT = TIOTF10-TIOTF0
      write(u6,'(a,2f10.2)') ' OLagNS  : CPU/WALL TIME=',cput,wallt
    end if
    !write(u6,*) 'DPT2C'
    !call sqprt(dpt2c,nbast)

    !! MO -> AO transformations for DPT2 and DPT2C
    if (((.not. IfChol) .or. (iALGO /= 1)) .or. ((nFroT == 0) .and. if_invaria)) then
      call OLagTrf(1,iSym,NBSQT,CMOPT2,DPT2,DPT2_AO,WRK1)
      call OLagTrf(1,iSym,NBSQT,CMOPT2,DPT2C,DPT2C_AO,WRK1)
      !write(u6,*) 'dpt2'
      !call sqprt(dpt2,nbast)
      !write(u6,*) 'dpt2ao'
      !call sqprt(dpt2_ao,nbast)
    end if

    !! Do some transformations relevant to avoiding (VV|VO)
    !! integrals. Orbital Lagrangian for the hole orbitals are
    !! computed. At the same time, F = G(D) transformations are
    !! also performed for D = DPT2 and DPT2C
    !! The way implemented (what?) is just a shit. I cannot find
    !! FIFA and FIMO for frozen orbitals, so I have to construct
    !! them. Here is the transformation of G(D^inact) and G(D).
    !! FIFA_all and FIMO_all computed in this subroutine
    !! is not yet correct. They are just two-electron after this
    !! subroutine.
    call TIMING(CPTF0,CPE,TIOTF0,TIOE)
    call OLagVVVO(iSym,NBSQT,lT2AO,MaxVec_PT2,DPT2_AO,DPT2C_AO,FPT2_AO,FPT2C_AO,T2AO,DIA,DI,FIFA_all,FIMO_all,A_PT2)
    !write(u6,*) 'olag after vvvo'
    !call sqprt(olag,nbast)
    call TIMING(CPTF10,CPE,TIOTF10,TIOE)
    if (IPRGLB >= VERBOSE) then
      CPUT = CPTF10-CPTF0
      WALLT = TIOTF10-TIOTF0
      write(u6,'(a,2f10.2)') ' OLagVVVO: CPU/WALL TIME=',cput,wallt
    end if
    !write(u6,*) 'OLag'
    !do i=1,144
    !  write(u6,'(i3,f20.10)') i,olag(i)
    !end do
    !write(u6,*) 'fpt2ao'
    !call sqprt(fpt2_ao,12)
    !call abend()

    !! AO -> MO transformations for FPT2AO and FPT2CAO
    if (((.not. IfChol) .or. (iALGO /= 1)) .or. ((nFroT == 0) .and. if_invaria)) then
      call OLagTrf(2,iSym,NBSQT,CMOPT2,FPT2,FPT2_AO,WRK1)
      call OLagTrf(2,iSym,NBSQT,CMOPT2,FPT2C,FPT2C_AO,WRK1)
    end if

    call mma_deallocate(T2AO)
  end do
  call mma_deallocate(A_PT2)
  !! Add DPTC to DSUM for the correct unrelaxed density
  !! Also, symmetrize DSUM
  call AddDPTC(NBSQT,NDPT,DPT2C,DSUM)
  if (HZERO == 'DYALL') call BDerNEV_final2()

  !write(u6,*) 'fptao after olagns'
  !call sqprt(fpt2_ao,nbast)
  !write(u6,*) 'fptcao after olagns'
  !call sqprt(fpt2c_ao,nbast)
  !write(u6,*) 'olag after olagns'
  !call sqprt(olag,nbast)

  !! If frozen orbitals exist, frozen-inactive part of the
  !! unrelaxed PT2 density matrix is computed using the orbital
  !! Lagrangian. Additionally, Fock transformation is also
  !! required.
  if ((nFroT /= 0) .or. (.not. if_invaria)) then
    !! Compute DPT2 density for frozen-inactive
    !write(u6,*) 'dpt2 before frozen'
    !call sqprt(dpt2,nbast)
    if (.not. ifchol) then
      !! Construct FIFA and FIMO
      call OLagFro3(NBSQT,FIFA_all,FIMO_all,WRK1,WRK2)
      !! if possible, canonicalize frozen orbitals, and update
      !! FIMO and Trf
    end if
    !! Save DPT in order to subtract later
    WRK1(1:nDPTAO) = DPT2(1:nDPTAO)
    !! Add explicit FIMO and FIFA contributions. Implicit
    !! contributions are all symmetric in frozen + inactive
    !! orbitals, so they do not contribute to frozen density
    call DGEMM_('N','T',nBasT,nBasT,nBasT,One,FIMO_all,nBasT,DPT2C,nBasT,One,OLAG,nBasT)
    call DGEMM_('T','N',nBasT,nBasT,nBasT,One,FIMO_all,nBasT,DPT2C,nBasT,One,OLAG,nBasT)
    call DGEMM_('N','T',nBasT,nBasT,nBasT,One,FIFA_all,nBasT,DPT2,nBasT,One,OLAG,nBasT)
    call DGEMM_('T','N',nBasT,nBasT,nBasT,One,FIFA_all,nBasT,DPT2,nBasT,One,OLAG,nBasT)

    !! non-invariant in inactive and secondary
    if (.not. if_invaria) then
      !! Construct the density from orbital Lagrangian
      call caspt2_grad_invaria2(NBSQT,nOLag,DPT2,OLag)
      !! FIFA contributions from the non-invariant density
      DPT2(1:nDPTAO) = DPT2(1:nDPTAO)-WRK1(1:nDPTAO)
      !! Add the non-invariant contribution to unrelaxed density
      call AddDPTC(NBSQT,NDPT,DPT2,DSUM)
      call DGEMM_('N','T',nBasT,nBasT,nBasT,One,FIFA_all,nBasT,DPT2,nBasT,One,OLAG,nBasT)
      call DGEMM_('T','N',nBasT,nBasT,nBasT,One,FIFA_all,nBasT,DPT2,nBasT,One,OLAG,nBasT)
      !! Restore the second-order correlated density
      DPT2(1:nDPTAO) = DPT2(1:nDPTAO)+WRK1(1:nDPTAO)
      WRK1(1:nDPTAO) = DPT2(1:nDPTAO)
    end if
    !! Now, compute pseudo-density using orbital Lagrangian
    !! DSUM does not contain frozen orbitals,
    !! so the properties using this density may be inaccurate
    if (nFroT /= 0) call OLagFro1(NBSQT,nOLag,DPT2,OLag)

    !! Subtract the orbital Lagrangian added above.
    !! It is computed again in EigDer
    call DGEMM_('N','T',nBasT,nBasT,nBasT,-One,FIMO_all,nBasT,DPT2C,nBasT,One,OLAG,nBasT)
    call DGEMM_('T','N',nBasT,nBasT,nBasT,-One,FIMO_all,nBasT,DPT2C,nBasT,One,OLAG,nBasT)
    call DGEMM_('N','T',nBasT,nBasT,nBasT,-One,FIFA_all,nBasT,WRK1,nBasT,One,OLAG,nBasT)
    call DGEMM_('T','N',nBasT,nBasT,nBasT,-One,FIFA_all,nBasT,WRK1,nBasT,One,OLAG,nBasT)
    !write(u6,*) 'dpt after frozen'
    !call sqprt(dpt2,nbast)

    !! Fock transformation for frozen-inactive density
    if (IfChol) then
      iSym = 1
      !! MO -> AO transformations for DPT2 and DPT2C
      call OLagTrf(1,iSym,NBSQT,CMOPT2,DPT2,DPT2_AO,WRK1)
      call OLagTrf(1,iSym,NBSQT,CMOPT2,DPT2C,DPT2C_AO,WRK1)
      !! For DF-CASPT2, Fock transformation of DPT2, DPT2C, DIA,
      !! DA is done here, but not OLagVVVO
      !! It seems that it is not possible to do this
      !! transformation in OLagVVVO, because the frozen-part of
      !! the DPT2 is obtained after OLagVVVO.
      FPT2_AO(:) = Zero
      FPT2C_AO(:) = Zero
      call OLagFro4(NBSQT,1,1,1,1,1,DPT2_AO,DPT2C_AO,FPT2_AO,FPT2C_AO,WRK1)
      !! AO -> MO transformations for FPT2AO and FPT2CAO
      call OLagTrf(2,iSym,NBSQT,CMOPT2,FPT2,FPT2_AO,WRK1)
      call OLagTrf(2,iSym,NBSQT,CMOPT2,FPT2C,FPT2C_AO,WRK1)
    else
      !write(u6,*) 'dpt'
      !call sqprt(dpt2,nbast)
      call OLagFro2(NBSQT,DPT2,FPT2,WRK1,WRK2)
      !write(u6,*) 'fpt'
      !call sqprt(dpt2,nbast)
    end if
    !write(u6,*) 'fifa_all'
    !call sqprt(fifa_all,12)
    !write(u6,*) 'fimo_all'
    !call sqprt(fimo_all,12)
    !! Construct FIFA and FIMO
    !call OLagFro3(NBSQT,FIFA_all,FIMO_all,WRK1,WRK2)
  else ! there are no frozen orbitals
    iSQ = 0
    iTR = 0
    do iSym=1,nSym
      nOrbI = nOrb(iSym)
      call SQUARE(FIFA(1+iTR),FIFA_all(1+iSQ),1,nOrbI,nOrbI)
      call SQUARE(FIMO(1+iTR),FIMO_all(1+iSQ),1,nOrbI,nOrbI)
      iSQ = iSQ+nOrbI*nOrbI
      iTR = iTR+nTri_Elem(nOrbI)
    end do
  end if
  call mma_deallocate(DIA)
  call mma_deallocate(DI)
  !write(u6,*) 'fifa_all in dens'
  !call sqprt(fifa_all,nbast)
  !write(u6,*) 'fimo_all in dens'
  !call sqprt(fimo_all,nbast)
  !write(u6,*) 'FIFA in natural'
  !call DGemm_('N','N',nBasT,nBasT,nBasT,One,Trf,nBasT,fifa_all,nBasT,Zero,WRK1,nBasT)
  !call DGemm_('N','T',nBasT,nBasT,nBasT,One,WRK1,nBasT,Trf,nBasT,Zero,WRK2,nBasT)
  !call sqprt(wrk2,12)

  !! Do some post-process for the contributions that comes from
  !! the above two densities.
  !write(u6,*) 'olag before eigder'
  !call sqprt(olag,nbast)
  !write(u6,*) 'fpt2'
  !call sqprt(fpt2,nbast)
  call EigDer(NBSQT,nAshT,DPT2,DPT2C,FPT2_AO,FPT2C_AO,RDMEIG,CMOPT2,Trf,FPT2,FPT2C,FIFA_all,FIMO_all,RDMSA)
  !call test2_dens(olag,depsa)
  !write(u6,*) 'olag after eigder'
  !call sqprt(olag,nbast)
  !write(u6,*) 'Wlag after eigder'
  !call sqprt(wlag,nbast)
  !write(u6,*) 'rdmeig'
  !call sqprt(rdmeig,nasht)
  !call abend()

  !! Calculate the configuration Lagrangian again.
  !! The contribution comes from the derivative of eigenvalues.
  !! It seems that TRACI_RPT2 uses CI coefficients of RASSCF,
  !! so canonical -> natural transformation is required.
  !ipTrfL = 1+nAshT*nBasT+nAshT
  !call DGemm_('N','N',nAshT,nAshT,nAshT,One,Trf(ipTrfL),nBasT,RDMEIG,nAshT,Zero,WRK1,nAshT)
  !call DGemm_('N','T',nAshT,nAshT,nAshT,One,WRK1,nAshT,Trf(ipTrfL),nBasT,Zero,RDMEIG,nAshT)
  if (.not. if_invar) then !test
    call mma_allocate(CLagT,nConf,nState,Label='CLagT')
    call mma_allocate(EigT,nAshT,nAshT,Label='EigT')
    CLagT(:,:) = CLag(:,:)
    EigT(:,:) = RDMEIG(:,:)
    if (IFDW .and. (zeta >= Zero)) then
      call mma_allocate(OMGT,nState,nState,Label='OMGT')
      OMGT(:,:) = OMGDER(:,:)
    end if
  end if
  !! Use canonical CSFs rather than natural CSFs in CLagEig
  call mma_allocate(ISAV,size(IDCIEX),Label='ISAV')
  ISAV(:) = IDCIEX(:)
  IDCIEX(:) = IDTCEX(:)
  !! Now, compute the configuration Lagrangian
  call CLagEig(if_SSDM,.false.,nConf,nRoots,nState,NLEV,CLag,RDMEIG)
# ifdef _MOLCAS_MPP_
  if (Is_Real_Par()) call GADGOP(CLag,nCLag,'+')
# endif

  !! Now, here is the best place to compute the true off-diagonal
  !! active density for non-invariant CASPT2
  if (.not. if_invar) then
    SLag(:,:) = Zero
    !! Add the density that comes from CI Lagrangian
    call DEPSAOffC(nConf,nState,nAshT,nBasT,CLag,DEPSA,FIFA_all,FIMO_all,WRK1,WRK2,U0)
    !! Add the density that comes from orbital Lagrangian
    call DEPSAOffO(nOLag,nAshT,NBSQT,OLag,DEPSA,FIFA_all)
    !! Restore the diagonal elements
    do i=1,nAshT
      DEPSA(i,i) = DEPSA_diag(i)
    end do
    call mma_deallocate(DEPSA_diag)
    if (IPRGLB >= VERBOSE) then
      write(u6,*) 'DEPSA computed again'
      call sqprt(depsa,nasht)
    end if
    if (NRAS1T+NRAS3T /= 0) then
      !! Remove the off-diagonal blocks for RASPT2
      DEPSA(1:nRAS1T,nRAS1T+1:) = Zero
      DEPSA(nRAS1T+1:,1:nRAS1T) = Zero
      DEPSA(nRAS1T+1:nRAS1T+nRAS2T,nRAS1T+nRAS2T+1:) = Zero
      DEPSA(nRAS1T+nRAS2T+1:,nRAS1T+1:nRAS1T+nRAS2T) = Zero
    end if
    !depsa(:,:) = Zero

    !! We have to do many things again...
    !! Just add DEPSA to DPT2
    call AddDEPSA(NBSQT,nAshT,DPT2,DEPSA)
    !! Just transform the density in MO to AO
    call DPT2_Trf(NBSQT,nAshT,DPT,DPT2_AO,CMOPT2,DEPSA,DSUM)
    !! For IPEA shift with state-dependent density
    if (if_SSDM .and. ((jState == iRlxRoot) .or. IFMSCOUP)) then
      iSym = 1
      call OLagTrf(1,iSym,NBSQT,CMOPT2,DPT2,DPT2_AO,WRK1)
    end if
    !! Some transformations similar to EigDer
    call EigDer2(NBSQT,nAshT,RDMEIG,Trf,FIFA_all,RDMSA,DEPSA,WRK1,WRK2)

    CLag(:,:) = CLagT(:,:) !test
    ! test
    RDMEIG(:,:) = RDMEIG(:,:)+EigT(:,:)
    SLag(:,:) = Zero
    call mma_deallocate(CLagT)
    call mma_deallocate(EigT)
    if (IFDW .and. (zeta >= Zero)) then
      OMGDER(:,:) = OMGT(:,:)
      call mma_deallocate(OMGT)
    end if
    !! RDMEIG contributions
    !! Use canonical CSFs rather than natural CSFs
    !! Now, compute the configuration Lagrangian
    call CLagEig(if_SSDM,.false.,nConf,nRoots,nState,NLEV,CLag,RDMEIG)
#   ifdef _MOLCAS_MPP_
    if (Is_Real_Par()) call GADGOP(CLag,nCLag,'+')
#   endif
    !! Now, compute the state Lagrangian and do some projections
    !call CLagFinal(nConf,nState,CLag,SLag)
  end if

  !! Restore integrals without frozen orbitals, although not sure
  !! this operation is required.
  if (((nFroT /= 0) .or. (.not. if_invaria)) .and. (.not. IfChol)) call TRAFRO(2)

  IDCIEX(:) = ISAV(:)
  call mma_deallocate(ISAV)
  !! Canonical -> natural transformation
  if (ORBIN == 'TRANSFOR') then
    do iState=1,nState
      call CLagX_TrfCI(nConf,CLag(1,iState))
    end do
  end if
  ! accumulate configuration Lagrangian only for MS,XMS,XDW,RMS,
  ! but not for SS-CASPT2
  if ((jState == iRlxRoot) .or. IFMSCOUP) CLagFull(1:nConf,1:nState) = CLagFull(1:nConf,1:nState)+CLag(1:nConf,1:nState)
  !call CLagFinal(nConf,nState,CLag,SLag)

  !! Transformations of DPT2 in quasi-canonical to natural orbital
  !! basis and store the transformed density so that the MCLR
  !! module can use them.
  ! accumulate only if MS,XMS,XDW or RMS calculation
  !call RecPrt('DPT2 before', '', DPT2_tot, nBast, nBast)
  if ((jState == iRlxRoot) .or. IFMSCOUP) then
    call DPT2_TrfStore(One,NBSQT,DPT2,DPT2_tot,Trf,WRK1)
    call DPT2_TrfStore(Two,NBSQT,DPT2C,DPT2C_tot,Trf,WRK1)
    if (do_csf) call DPT2_TrfStore(One,NBSQT,DPT2Canti,DPT2Canti_tot,Trf,WRK1)
  end if
  !call RecPrt('DPT2 after','',DPT2_tot,nBast,nBast)
  !! Save MO densities for post MCLR
  !call DGemm_('N','N',nBasT,nBasT,nBasT,One,Trf,nBasT,DPT,nBasT,Zero,WRK1,nBasT)
  !call DGemm_('N','T',nBasT,nBasT,nBasT,One,WRK1,nBasT,Trf,nBasT,Zero,WRK2,nBasT)
  !iSQ = 0
  !do iSym=1,nSym
  !  nOrbI = nBas(iSym)-nDel(iSym)
  !  nSQ = nOrbI*nOrbI
  !  DPT2_tot(iSQ+1:iSQ+nSQ) = DPT2_tot(iSQ+1:iSQ+nSQ)+WRK2(iSQ+1:iSQ+nSQ)
  !  iSQ = iSQ+nSQ
  !end do

  !! Do the same for DPT2C Save MO densities for post MCLR
  !call DGemm_('N','N',nBasT,nBasT,nBasT,One,Trf,nBasT,DPT2C,nBasT,Zero,WRK1,nBasT)
  !call DGemm_('N','T',nBasT,nBasT,nBasT,One,WRK1,nBasT,Trf,nBasT,Zero,WRK2,nBasT)
  !iSQ = 0
  !do iSym=1,nSym
  !  nOrbI = nBas(iSym)-nDel(iSym)
  !  nSQ = nOrbI*nOrbI
  !  DPT2C_tot(iSQ+1:iSQ+nSQ) = DPT2C_tot(iSQ+1:iSQ+nSQ)+Two*WRK2(iSQ+1:iSQ+nSQ)
  !  iSQ = iSQ+nSQ
  !end do
  !call abend()
  !call sqprt(RDMEIG,nAshT)

  !! square -> triangle so that the MCLR module can use the AO
  !! densities. Do this for DPT2AO and DPT2CAO (defined in
  !! caspt2_grad).
  ! accumulate only if MS,XMS,XDW or RMS calculation
  if ((jState == iRlxRoot) .or. IFMSCOUP) then
    iBasTr = 1
    iBasSq = 1
    do iSym=1,nSym
      nBasI = nBas(iSym)
      liBasTr = iBasTr
      liBasSq = iBasSq
      do iBasI=1,nBasI
        do jBasI=1,iBasI
          liBasSq = iBasSq+iBasI-1+nBasI*(jBasI-1)
          if (iBasI == jBasI) then
            DPT2_AO_tot(liBasTr) = DPT2_AO(liBasSq)
            DPT2C_AO_tot(liBasTr) = DPT2C_AO(liBasSq)
          else
            DPT2_AO_tot(liBasTr) = DPT2_AO(liBasSq)*Two
            DPT2C_AO_tot(liBasTr) = DPT2C_AO(liBasSq)*Two
          end if
          liBasTr = liBasTr+1
        end do
      end do
      iBasTr = iBasTr+nTri_Elem(nBasI)
      iBasSq = iBasSq+nBasI**2
    end do
  end if

  !! If the density matrix used in the Fock operator is different
  !! from the averaged density in the SCF calculation, we need an
  !! additional term for electron-repulsion integral.
  !! Here prepares such densities.
  !! The first one is just DPT2AO, while the second one is the
  !! difference between the SS and SA density matrix. because the
  !! SA density-contribution will be added and should be
  !! subtracted
  ! This should be done only for iRlxRoot
  if (if_SSDM .and. ((jState == iRlxRoot) .or. IFMSCOUP)) then
    call TIMING(CPTF0,CPE,TIOTF0,TIOE)
    !if (.not. if_invar) then
    !  write(u6,*) 'SS density matrix with IPEA not implemented'
    !  call abend()
    !end if

    !! Construct the SCF density
    !! We first need to construct the density averaged over all
    !! roots involved in SCF.
    WRK1(1:nDRef) = Zero
    call mma_allocate(CI1,nConf,Label='CI1')
    do iState=1,nState
      call LoadCI_XMS('N',1,nConf,nState,CI1,iState,U0)
      call POLY1(CI1,nConf)
      call GETDREF(WRK2,nDRef)
      wgt = Weight(iState)
      WRK1(1:nDRef) = WRK1(1:nDRef)+Wgt*WRK2(1:nDRef)
    end do
    call mma_deallocate(CI1)
    !! WRK2 is the SCF density (for nstate=nroots)
    call SQUARE(WRK1,WRK2,1,nAshT,nAshT)
    RDMSA(:,:) = RDMSA(:,:)-reshape(WRK2(1:nAshT**2),[nAshT,nAshT])

    !! Construct the SS minus SA density matrix in WRK1
    call OLagFroD(NBSQT,nAshT,WRK1,WRK2,RDMSA,Trf)
    !! Subtract the inactive part
    WRK1(1:nBasT**2) = WRK1(1:nBasT**2)-WRK2(1:nBasT**2)
    !! Here we should use DPT2_AO??
    !! Save
    if (IfChol) then
      call CnstAB_SSDM(NBSQT,DPT2_AO,WRK1)
    else
      !! Well, it is not working any more. I need to use
      !! Position='APPEND', but it is not possible if I need to
      !! use molcas_open or molcas_open_ext2
      write(u6,*) 'It is not possible to perform this calculation'
      write(u6,*) '(non-state averaged density without'
      write(u6,*) 'density-fitting or Cholesky decomposition)'
      write(u6,*) 'Please use DF or CD'
      call abend()
    end if
    call TIMING(CPTF10,CPE,TIOTF10,TIOE)
    if (IPRGLB >= VERBOSE) then
      CPUT = CPTF10-CPTF0
      WALLT = TIOTF10-TIOTF0
      write(u6,'(a,2f10.2)') ' SSDM    : CPU/WALL TIME=',cput,wallt
    end if
  end if
  !write(u6,*) 'pt2ao'
  !call sqprt(DPT2_AO,12)
  call mma_deallocate(DEPSA)

  call mma_deallocate(DPT2)
  call mma_deallocate(DPT2C)
  call mma_deallocate(DPT2_AO)
  call mma_deallocate(DPT2C_AO)
  call mma_deallocate(FPT2)
  call mma_deallocate(FPT2C)
  call mma_deallocate(FPT2_AO)
  call mma_deallocate(FPT2C_AO)
  if (do_csf) call mma_deallocate(DPT2Canti_)
  nullify(DPT2Canti)

  !! Finalize OLag (anti-symmetrize) and construct WLag
  call OLagFinal(nOLag,NBSQT,OLag,Trf)

  call mma_deallocate(TRF)
  call mma_deallocate(WRK1)
  call mma_deallocate(WRK2)
  call mma_deallocate(RDMSA)
  call mma_deallocate(RDMEIG)
  call mma_deallocate(VECROT)
  DENORM = One
  !! end of with gradient
else
  !! without gradient
  ! Compute total density matrix as symmetry-blocked array of
  ! triangular matrices in DMAT. Size of a triangular submatrix is
  ! nTri_Elem(NORB(ISYM)).
  NDPT = sum(NORB(1:nSym)**2)
  DMAT(1:NDMAT) = Zero
  ! First, put in the reference density matrix.
  IDMOFF = 0
  do ISYM=1,NSYM
    NI = NISH(ISYM)
    NA = NASH(ISYM)
    NO = NORB(ISYM)
    do II=1,NI
      IDM = IDMOFF+nTri_Elem(II)
      DMAT(IDM) = Two
    end do
    do IT=1,NA
      ITABS = NAES(ISYM)+IT
      ITTOT = NI+IT
      do IU=1,IT
        IUABS = NAES(ISYM)+IU
        IUTOT = NI+IU
        IDRF = iTri(ITABS,IUABS)
        IDM = IDMOFF+iTri(ITTOT,IUTOT)
        DMAT(IDM) = DREF(IDRF)
      end do
    end do
    IDMOFF = IDMOFF+nTri_Elem(NO)
  end do
  !write(u6,*) ' DENS. Initial DMAT:'
  !write(u6,'(1x,8f16.8)') (dmat(i),i=1,ndmat)
  ! Add the 1st and 2nd order density matrices:
  call mma_allocate(DPT,NDPT,Label='DPT')
  call mma_allocate(DSUM,NDPT,Label='DSUM')
  DSUM(1:NDPT) = Zero

  ! The 1st order contribution to the density matrix
  DPT(1:NDPT) = Zero
  call TRDNS1(IVEC,DPT,NDPT)
  DSUM(1:NDPT) = DSUM(1:NDPT)+DPT(1:NDPT)
  !write(u6,*) ' DPT after TRDNS1.'
  !write(u6,'(1x,8f16.8)') (dpt(i),i=1,ndpt)
  DPT(1:NDPT) = Zero
  call TRDNS2D(IVEC,IVEC,DPT,NDPT,One)
  if (IFDENS) then
    ! The exact density matrix evaluation:
    call TRDTMP(DPT,NDPT)
  else
    ! The approximate density matrix evaluation:
    call TRDNS2A(IVEC,IVEC,DPT,NDPT)
  end if
  DSUM(1:NDPT) = DSUM(1:NDPT)+DPT(1:NDPT)
  !write(u6,*) ' DPT after TRDNS2D.'
  !write(u6,'(1x,8f16.8)') (dpt(i),i=1,ndpt)
  DPT(1:NDPT) = Zero
  call TRDNS2O(IVEC,IVEC,DPT,size(DPT),NDPT,One)
  DSUM(1:NDPT) = DSUM(1:NDPT)+DPT(1:NDPT)
  !write(u6,*) ' DPT after TRDNS2O.'
  !write(u6,'(1x,8f16.8)') (dpt(i),i=1,ndpt)
end if

call mma_deallocate(DPT)
IDMOFF = 0
IDSOFF = 0
do ISYM=1,NSYM
  NO = NORB(ISYM)
  do IP=1,NO
    do IQ=1,IP
      IDM = IDMOFF+iTri(IP,IQ)
      IDSUM = IDSOFF+IP+NO*(IQ-1)
      DMAT(IDM) = DMAT(IDM)+DSUM(IDSUM)
    end do
  end do
  IDMOFF = IDMOFF+nTri_Elem(NO)
  IDSOFF = IDSOFF+NO**2
end do
call mma_deallocate(DSUM)
! Scale with 1/DENORM to normalize
X = One/DENORM
if (do_grad) X = One
DMAT(1:NDMAT) = X*DMAT(1:NDMAT)

!SVC: For true parallel calculations, replicate the DMAT array
! so that the slaves have the same density matrix as the master.
#ifdef _MOLCAS_MPP_
if (Is_Real_Par()) then
  if (.not. KING()) DMAT(1:NDMAT) = Zero
  call GADGOP(DMAT,NDMAT,'+')
end if
#endif

end subroutine DENS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine ONECT(C,S,W,THET,ENP,EPP,FC,BUFIN,A,B,FK,DBK)

use cpf_global, only: ICASE, ICPF, IDENS, ILIM, INCPF, INDX, IRC, ISDCI, JSY
use Definitions, only: wp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: C(*), S(*), W(*), EPP(*), FC(*), FK(*)
real(kind=wp), intent(in) :: THET(*), ENP(*)
real(kind=wp), intent(_OUT_) :: BUFIN(*), A(*), B(*), DBK(*)

if ((ICPF /= 0) .or. (ISDCI /= 0) .or. (INCPF /= 0)) then
  ! CPF AND SDCI
  if (IDENS /= 1) then
    ! (AI/JK) INTEGRALS
    call AI_CPF(JSY,INDX,C,S,FC,BUFIN,A,B,FK,DBK,ENP,EPP,1)
  end if
  call FIJ_CPF(ICASE,JSY,INDX,C,S,FC,A,B,FK,DBK,ENP,EPP)
else
  ! MCPF
  if (IDENS /= 1) then
    ! (AI/JK) INTEGRALS
    call MAI(JSY,INDX,C,S,FC,BUFIN,A,B,FK,DBK,W,THET,ENP,EPP,IRC(ILIM),1)
  end if
  call MFIJ(ICASE,JSY,INDX,C,S,FC,A,B,FK,DBK,W,THET,ENP,EPP,IRC(ILIM))
end if

return

end subroutine ONECT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE AID(INTSYM,INDX,C,DMO,A,B,FK)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION INTSYM(*),INDX(*),C(*),DMO(*),
     *          A(*),B(*),FK(*)
      DIMENSION IPOB(9)
*
      JSYM(L)=JSUNP(INTSYM,L)
*
C SCRATCH AREAS: A(),B() AND FK().
      CALL CSCALE(INDX,INTSYM,C,SQ2)
      ICHK=0
      IJOLD=0
      NK=0
      NSK=1
      IADD10=IAD10(9)
C READ A COP BUFFER
100   CONTINUE
      CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 100
      IF(LEN.LT.0)GO TO 200
C LOOP THROUGH THE COP BUFFER:
      DO 10 II=1,LEN
      IND=ICOP1(II)
      IF(ICHK.NE.0)GO TO 460
      IF(IND.NE.0)GO TO 11
C IND=0 INDICATES END OF THIS BLOCK OF COUPLING COEFFS.
      ICHK=1
      GO TO 10
460   CONTINUE
C ICHK=1 INDICATES BEGINNING OF A NEW BLOCK OF COUPLING COEFFS.
      ICHK=0
      IF(IJOLD.NE.0) THEN
C PUT AWAY FK INTO DMO
        NA1=NVIRP(NSK)+1
        NA2=NVIRP(NSK)+NVIR(NSK)
        INK=0
        IF(NA2.LT.NA1)GO TO 10
        DO 113 NA=NA1,NA2
          INK=INK+1
          NAK=IROW(LN+NA)+NK
          DMO(NAK)=FK(INK)
113     CONTINUE
      END IF
      NK=IND
      IJOLD=NK
      NSK=NSM(NK)
C PICK OUT ELEMENTS FROM DMO AND PUT INTO FK:
      NA1=NVIRP(NSK)+1
      NA2=NVIRP(NSK)+NVIR(NSK)
      INK=0
      IF(NA2.LT.NA1)GO TO 10
      DO 13 NA=NA1,NA2
        INK=INK+1
        NAK=IROW(LN+NA)+NK
        FK(INK)=DMO(NAK)
13    CONTINUE
      GO TO 10
11    IF(INK.EQ.0)GO TO 10
*      ITYP=MOD(IND,2**6)
*      ICP2=MOD(IND/2**6,2**13)
*      ICP1=MOD(IND/2**19,2**13)
      ITYP=IBITS(IND, 0, 6)
      ICP2=IBITS(IND, 6,13)
      ICP1=IBITS(IND,19,13)
      IF(ITYP.GT.1)GO TO 12
      INDA=ICP1
      INDB=IRC(1)+ICP2
      INNY=INDX(INDB)+1
      COPI=C(INDA)*COP(II)/ENP
      CALL DAXPY_(INK,COPI,C(INNY),1,FK,1)
      GO TO 10
12    IF(ITER.EQ.1 .AND. IREST.EQ.0)GO TO 10
      INDA=IRC(1)+ICP1
      INDB=IRC(ITYP)+ICP2
      INMY=INDX(INDA)+1
      INNY=INDX(INDB)+1
      MYSYM=JSYM(INDA)
      NYSYM=MUL(MYSYM,NSK)
      MYL=MUL(MYSYM,LSYM)
      NYL=MUL(NYSYM,LSYM)
      IFT=0
      IF(ITYP.EQ.2)IFT=1
      CALL IPO(IPOB,NVIR,MUL,NSYM,NYL,IFT)
      NVM=NVIR(MYL)
      CALL FZERO(B,INK)
      COPI=COP(II)/ENP
      IF(NYL.NE.1) THEN
        IF(NSK.GT.MYL) THEN
          CALL FMMM(C(INMY),C(INNY+IPOB(NSK)),B,1,INK,NVM)
          CALL VSMA(B,1,COPI,FK,1,FK,1,INK)
        ELSE
          CALL FMMM(C(INNY+IPOB(MYL)),C(INMY),B,INK,1,NVM)
          IF(IFT.EQ.1)COPI=-COPI
          CALL VSMA(B,1,COPI,FK,1,FK,1,INK)
        END IF
      ELSE
        IF(IFT.EQ.0)CALL SQUAR(C(INNY+IPOB(MYL)),A,NVM)
        IF(IFT.EQ.1)CALL SQUARN(C(INNY+IPOB(MYL)),A,NVM)
        CALL FMMM(C(INMY),A,B,1,INK,NVM)
        CALL VSMA(B,1,COPI,FK,1,FK,1,INK)
      END IF
10    CONTINUE
      GO TO 100
200   CONTINUE
      NA1=NVIRP(NSK)+1
      NA2=NVIRP(NSK)+NVIR(NSK)
      INK=0
      DO 213 NA=NA1,NA2
        INK=INK+1
        NAK=IROW(LN+NA)+NK
        DMO(NAK)=FK(INK)
213   CONTINUE
      CALL CSCALE(INDX,INTSYM,C,SQ2INV)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CLagX_TrfCI(NCONF,CI)

use caspt2_global, only: TAT, TORB
use caspt2_module, only: NISH, NRAS1, NRAS2, NRAS3, NSSH, NSYM, STSYM
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NCONF
real(kind=wp), intent(inout) :: CI(NCONF)
integer(kind=iwp) :: I, IOFF1, IOFF2, ISYM, NI, NISH_SAVE(8), NR1, NR2, NR3, NS

TAT(:) = Zero

IOFF1 = 0
IOFF2 = 0
do ISYM=1,NSYM
  NI = NISH(ISYM)
  NR1 = NRAS1(ISYM)
  NR2 = NRAS2(ISYM)
  NR3 = NRAS3(ISYM)
  NS = NSSH(ISYM)
  ! Skip inactive transformation matrix:
  IOFF1 = IOFF1+NI**2
  ! Copy RAS1 transformation matrix transposed to TAT:
  do I=1,NR1
    TAT(IOFF2+NR1*(I-1)+1:IOFF2+NR1*I) = TORB(IOFF1+I:IOFF1+I+NR1*(NR1-1):NR1)
  end do
  IOFF1 = IOFF1+NR1**2
  IOFF2 = IOFF2+NR1**2
  ! Copy RAS2 transformation matrix transposed to TAT:
  do I=1,NR2
    TAT(IOFF2+NR2*(I-1)+1:IOFF2+NR2*I) = TORB(IOFF1+I:IOFF1+I+NR2*(NR2-1):NR2)
  end do
  IOFF1 = IOFF1+NR2**2
  IOFF2 = IOFF2+NR2**2
  ! Copy RAS2 transformation matrix transposed to TAT:
  do I=1,NR3
    TAT(IOFF2+NR3*(I-1)+1:IOFF2+NR3*I) = TORB(IOFF1+I:IOFF1+I+NR3*(NR3-1):NR3)
  end do
  IOFF1 = IOFF1+NR3**2
  IOFF2 = IOFF2+NR3**2
  ! Skip virtual transformation matrix:
  IOFF1 = IOFF1+NS**2
end do
! Transform SGM to use original MO:

! In difference to TORB TAT only includes the active orbitals. We trick
! MkTraCI to work with this by temporarily setting the number of inactive
! orbitals to zero.
NISH_SAVE(:) = NISH(:)
NISH(:) = 0
call mkTraCI(size(TAT),TAT,STSYM,nConf,CI)
NISH(:) = NISH_SAVE(:)

end subroutine CLagX_TrfCI

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mkRotMat(rotvec,rotmat)

use Constants, only: Zero, One, Two, Six, Twelve, Half
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: RotVec(3)
real(kind=wp), intent(out) :: RotMat(3,3)
integer(kind=iwp) :: i, j, k
real(kind=wp) :: c0, c1, c2, cs, Q, rsum, sn, XN

!call RecPrt('mkRotMat: RotVec',' ',RotVec,1,3)

Q = RotVec(1)**2+RotVec(2)**2+RotVec(3)**2
XN = sqrt(Q)
if (Q < 0.01_wp) then
  c0 = One-(Q/Two)*(One-(Q/Twelve)*(One-(Q/30.0_wp)*(One-(Q/56.0_wp))))
  c1 = One-(Q/Six)*(One-(Q/20.0_wp)*(One-(Q/42.0_wp)*(One-(Q/72.0_wp))))
  c2 = (One-(Q/Twelve)*(One-(Q/30.0_wp)*(One-(Q/56.0_wp)*(One-(Q/90.0_wp)))))*Half
else
  cs = cos(XN)
  sn = sin(XN)
  c0 = cs
  c1 = sn/XN
  c2 = (One-cs)/(XN**2)
end if
RotMat(1,1) = c0
RotMat(2,2) = c0
RotMat(3,3) = c0
RotMat(3,2) = c1*RotVec(1)
RotMat(1,3) = c1*RotVec(2)
RotMat(2,1) = c1*RotVec(3)
RotMat(2,3) = -c1*RotVec(1)
RotMat(3,1) = -c1*RotVec(2)
RotMat(1,2) = -c1*RotVec(3)
do j=1,3
  RotMat(:,j) = RotMat(:,j)+c2*RotVec(:)*RotVec(j)
end do
do i=1,3
  do j=1,3
    if (i == j) then
      rsum = -One
    else
      rsum = Zero
    end if
    do k=1,3
      rsum = rsum+RotMat(i,k)*RotMat(j,k)
    end do
    if (abs(rsum) > 1.0e-10_wp) then
      call WarningMessage(2,'Error in mkRotMat')
      write(6,*) ' MKROTMAT: ON check sum error=',rsum
      call Abend()
    end if
  end do
end do

return

end subroutine mkRotMat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Mk_tVtF(TInt,nTheta_All,tVtF,nTheta,List2,mData,
     &                   iPrm,nPrm,
     &                  iAng,jAng,nk,nl,Indkl,nkl,
     &                  nTheta_Full,
     &                   iAL,nA,nB)
      Implicit Real*8 (a-h,o-z)
      Real*8 TInt(nTheta_All,nTheta_All), tVtF(nTheta,nTheta_Full)
      Integer List2(mData,nTheta_All), Indkl(nkl), iPrm(nPrm),
     &        iAL(nA,nB)
*
#ifdef _DEBUGPRINT_
      Call RecPrt('TInt',' ',TInt,nTheta_all,nTheta_all)
      Call iVcPrt('Indkl',' ',Indkl,nkl)
#endif
      Call FZero(tVtF,nTheta*nTheta_Full)
      iA=iAng+1
      jA=jAng+1
      Do iTheta_All = 1, nTheta_All
         kComp= List2(3,iTheta_All)
         lComp= List2(4,iTheta_All)
         ik=    List2(5,iTheta_All)
         il=    List2(6,iTheta_All)
         If (iAng.eq.jAng) Then
            iTheta_Full = ik*(ik-1)/2+il
         Else
            iTheta_Full = (il-1)*nk + ik
         End If
         If (
     &       iPrm(iTheta_Full).eq.1
C    &       .and. iAL(kComp,lComp).eq.1
     &       .and. kComp.eq.iA .and. lComp.eq.jA
     &      ) Then
            iTheta=Indkl(iTheta_Full)
*
            Do jTheta_All = 1, nTheta_All
               mComp= List2(3,jTheta_All)
               nComp= List2(4,jTheta_All)
C              If (iAL(mComp,nComp).eq.1) Then
               If (mComp.eq.iA.and.nComp.eq.jA) Then
                  jk=List2(5,jTheta_All)
                  jl=List2(6,jTheta_All)
                  If (iAng.eq.jAng) Then
                     jTheta_Full = jk*(jk-1)/2+jl
                  Else
                     jTheta_Full = (jl-1)*nk + jk
                  End If
*
                  tVtF(iTheta,jTheta_Full)=tVtF(iTheta,jTheta_Full)
C    &                                 +Abs(TInt(iTheta_All,jTheta_All))
     &                                 +    TInt(iTheta_All,jTheta_All)
*
               End If
            End Do
*
         End If
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt('tVtF',' ',tVtF,nTheta,nTheta_Full)
#endif
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(nl)
         Call Unused_integer_array(iAL)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
      Module RASSI_AUX
      Logical :: AO_Mode=.False.
      Integer, Allocatable:: TocM(:), jDisk_TDM(:,:), JOB_INDEX(:)
      Real*8, Allocatable:: CMO1(:), CMO2(:), DMAB(:)
      Integer NASHT_Save, mTRA
      Integer :: JOB1_old=-1, JOB2_old=-1

      Contains

      Integer Function iDisk_TDM(I,J,K)
         Integer I, J, I_Max, J_Min, K
         I_Max=Max(I,J)
         J_Min=Min(I,J)
         iDisk_TDM=jDisk_TDM(K,I_Max*(I_Max-1)/2+J_Min)
      End Function iDisk_TDM

      End Module RASSI_AUX

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
      SUBROUTINE ProtoSD(NPELA,NPELB,NPSDSZ,IPSDMS)
      DIMENSION IPSDMS(NPELA+NPELB,NPSDSZ)
      DIMENSION ITMP(50)
      INTEGER ASPIN, BSPIN
      PARAMETER (ASPIN=1,BSPIN=0)
C Given NPELA and NPELB, returns a table of all possible
C Slater determinants with NPELA alpha electrons and NPELB
C beta electrons in NPELA+NPELB orbitals.
C The ordering of the resulting SD is consistent with the
C index function   Index=1+Sum(j) noverm(k-1,j), where the sum
C is over only the alpha spins, enumerated j=1..NPELA,
C while k is the orbital with the j-th alpha electron.

      IF(NPELA.LT.0) GOTO 999
      IF(NPELB.LT.0) GOTO 999
      NPORB=NPELA+NPELB
      IF(NPORB.EQ.0) RETURN
      DO K=1,NPELA
        ITMP(K)=K
        IPSDMS(K,1)=ASPIN
      END DO
      IF(NPELA.EQ.NPORB) RETURN
      DO K=NPELA+1,NPORB
        IPSDMS(K,1)=BSPIN
      END DO
      IF(NPELA.EQ.0) RETURN

      NDET=NOVERM(NPORB,NPELA)
      IF(NDET.GT.NPSDSZ) GOTO 998
CPAM      write(*,*)'PROTOSD. Nr of orbitals:',NPORB
CPAM      write(*,*)'         Nr of determin:',NDET
CPAM      write(*,*)'         Need array siz:',NPORB*NDET

      ITMP(NPELA+1)=NPORB+1
      NDET=1

  10  CONTINUE
      K=0
  20  CONTINUE
      K=K+1
      IF(K.GT.NPELA) GOTO 30
      IF(ITMP(K+1).EQ.1+ITMP(K)) GOTO 20
      ITMP(K)=ITMP(K)+1
      DO L=1,K-1
       ITMP(L)=L
      END DO
      NDET=NDET+1
      IF(NDET.GT.NPSDSZ) GOTO 997
CPAM      CALL GETMEM('E0','Chec','Dummy',LDUM,NDUM)
      DO J=1,NPORB
        IPSDMS(J,NDET)=BSPIN
      END DO
CPAM      CALL GETMEM('E1','Chec','Dummy',LDUM,NDUM)
      DO L=1,NPELA
        IPSDMS(ITMP(L),NDET)=ASPIN
      END DO
CPAM      CALL GETMEM('E2','Chec','Dummy',LDUM,NDUM)
      GOTO 10

  30  CONTINUE
      RETURN
 997  CONTINUE
      WRITE(6,*)' Serious error in PROTOSD. '//
     &            'Too many SD''s are produced.'
      CALL ABEND()
 998  CONTINUE
      WRITE(6,*)' Too small space allocated in PROTOSD. Input:'
      WRITE(6,'(1x,a,3i6)')' NPELA,NPELB,NPSDSZ:',NPELA,NPELB,NPSDSZ
      WRITE(6,'(1x,a,i12)')' Required NPSDSZ is',NDET
      CALL ABEND()
 999  CONTINUE
      WRITE(6,*)' Invalid input to ProtoSD.'
      WRITE(6,*)'  NPELA,NPELB:',NPELA,NPELB
      CALL ABEND()
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE DRT0_CP2(A0,B0,C0,NVERT,DRT,DOWN,NVCODE,VCODE)
      IMPLICIT INTEGER (A-Z)
      DIMENSION DRT(NVERT,5),DOWN(NVERT,0:3),VCODE(NVCODE)
      PARAMETER(LTAB=1,NTAB=2,ATAB=3,BTAB=4,CTAB=5)
      DIMENSION DA(0:3),DB(0:3),DC(0:3)
      DATA DA /0,0,1,1/, DB /0,1,-1,0/, DC /1,0,1,0/
      NACTEL=2*A0+B0
      NLEV=A0+B0+C0
      DRT(1,LTAB)=NLEV
      DRT(1,NTAB)=NACTEL
      DRT(1,ATAB)=A0
      DRT(1,BTAB)=B0
      DRT(1,CTAB)=C0
      VSTA=1
      VEND=1

* A long loop over levels
      DO LEV=NLEV,1,-1
        MXADDR=((LEV+1)*(LEV+2))/2
        DO I=1,MXADDR
          VCODE(I)=0
        END DO
        DO VUP=VSTA,VEND
          AUP=DRT(VUP,ATAB)
          BUP=DRT(VUP,BTAB)
          CUP=DRT(VUP,CTAB)
          DO STEP=0,3
            DOWN(VUP,STEP)=0
            ADWN=AUP-DA(STEP)
            IF(ADWN.LT.0) GOTO 20
            BDWN=BUP-DB(STEP)
            IF(BDWN.LT.0) GOTO 20
            CDWN=CUP-DC(STEP)
            IF(CDWN.LT.0) GOTO 20
            BC=BDWN+CDWN
            ADDR=1+(BC*(BC+1))/2 + CDWN
            VCODE(ADDR)=4*VUP+STEP
            DOWN(VUP,STEP)=ADDR
  20        CONTINUE
          END DO
        END DO
        VDWN=VEND
        DO ADDR=1,MXADDR
          VUPS=VCODE(ADDR)
          IF(VUPS.EQ.0) GOTO 40
          VUP=VUPS/4
          STEP=MOD(VUPS,4)
          VDWN=VDWN+1
          DRT(VDWN,ATAB)=DRT(VUP,ATAB)-DA(STEP)
          DRT(VDWN,BTAB)=DRT(VUP,BTAB)-DB(STEP)
          DRT(VDWN,CTAB)=DRT(VUP,CTAB)-DC(STEP)
          VCODE(ADDR)=VDWN
  40      CONTINUE
        END DO
        DO VUP=VSTA,VEND
          DO STEP=0,3
            DWN=DOWN(VUP,STEP)
            IF(DWN.NE.0) DOWN(VUP,STEP)=VCODE(DWN)
          END DO
        END DO
        VSTA=VEND+1
        VEND=VDWN
      END DO
* End of long loop over levels

      DO I=1,5
        DRT(VEND,I)=0
      END DO
      DO STEP=0,3
        DOWN(VEND,STEP)=0
      END DO
      DO VERT=1,VEND
        DRT(VERT,LTAB)=DRT(VERT,ATAB)+DRT(VERT,BTAB)+DRT(VERT,CTAB)
        DRT(VERT,NTAB)=2*DRT(VERT,ATAB)+DRT(VERT,BTAB)
      END DO
      IF(VEND.NE.NVERT) THEN
        WRITE(6,*)' ERROR. NVERT (CALC:D) IS   ',NVERT
        WRITE(6,*)' NR OF VERTICES PRODUCED IS ',VEND
        CALL ABEND()
      END IF
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_expand41(a,b,dimpq,dimr,dims,dimp)
! expand a(pq,r,s) -> - b(p,q,s,r)
! assumption: p>q + antisymmetry
! RISC version

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimpq, dimr, dims, dimp
real(kind=wp), intent(in) :: a(dimpq,dimr,dims)
real(kind=wp), intent(out) :: b(dimp,dimp,dims,dimr)
integer(kind=iwp) :: p, pq, r

if (dimp > 1) then

  do r=1,dimr
    pq = 0
    do p=2,dimp
      b(p,1:p-1,:,r) = -a(pq+1:pq+p-1,r,:)
      b(1:p-1,p,:,r) = a(pq+1:pq+p-1,r,:)
      pq = pq+p-1
    end do
  end do

end if

do p=1,dimp
  b(p,p,:,:) = Zero
end do

return

end subroutine cct3_expand41

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FULLTRNSF(NP,NW,NB,CMOBLK,NJ,BUF_HT,BUF_FT)
      IMPLICIT NONE
      INTEGER NP,NW,NB,NJ
      REAL*8 CMOBLK(NB,NP)
* In: Vectors of type HALF(W,J,B) = Sum(CHO(AB,J)*CMO(A,W),A=1,NBAS)
      REAL*8 BUF_HT(NW*NJ,NB)
      REAL*8 BUF_FT(NP,NW*NJ)
*      DO J=1,NJ
** Compute fully transformed Cholesky vector buffer:
**  FULL(P,W,J)=Sum(CMO(B,P)*HALF(W,J,B),B=1,NB)
*        CALL DGEMM_('T','T',NP,NW,NB,1.0D0,CMOBLK,NB,
*     &       BUF_HT(1,J,1),NW*NJ,0.0D0,BUF_FT(1,1,J),NP)
*      END DO
        CALL DGEMM_('T','T',NP,NW*NJ,NB,1.0D0,CMOBLK,NB,
     &       BUF_HT,NW*NJ,0.0D0,BUF_FT,NP)
      RETURN
      END

C =SVC= Special FULLTRNSF routine for boxed ordering with less
C efficiency than the original (except when we would take NWSZ=NW, which
C would make it possible to treat all J in one go)
      SUBROUTINE FULLTRNSF_BOXED(IPSTA,IWSTA,NPSZ,NWSZ,NP,NW,NB,
     &                           CMOBLK,NJ,BUF_HT,BUF_FT,BUFFY)
      IMPLICIT NONE
      INTEGER IPSTA,IWSTA,NPSZ,NWSZ,NP,NW,NB,NJ
      REAL*8 CMOBLK(NB,NPSZ)
C In: Vectors of type HALF(W,J,B) = Sum(CHO(AB,J)*CMO(A,W),A=1,NBAS)
      REAL*8 BUF_HT(NW,NJ,NB)
      REAL*8 BUF_FT(NP*NW,NJ)
      REAL*8 BUFFY(NPSZ,NWSZ)
      INTEGER IPW,J
C Compute fully transformed Cholesky vector buffer:
C FULL(P,W,J)=Sum(CMO(B,P)*HALF(W,J,B),B=1,NB)
      iPW=1+NW*(IPSTA-1)+NPSZ*(IWSTA-1)
      DO J=1,NJ
       CALL DGEMM_('T','T',NPSZ,NWSZ,NB,1.0D0,CMOBLK,NB,
     &      BUF_HT(IWSTA,J,1),NW*NJ,0.0D0,BUFFY,NPSZ)
       CALL DCOPY_(NPSZ*NWSZ,BUFFY,1,BUF_FT(iPW,J),1)
      ENDDO
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Bjorn O. Roos                                          *
*               Per Ake Malmqvist                                      *
*               1991, Jeppe Olsen                                      *
*               1991,1996, Markus P. Fuelscher                         *
************************************************************************
*  CICtl
*
*> @brief
*>   CI Control
*> @author B. O. Roos
*> @author P. &Aring;. Malmqvist
*> @modified_by P. &Aring;. Malmqvist
*>
*> @details
*> Depends on \p IFINAL, which is set in ::RASSCF. If \p IFINAL = ``0``, repeated
*> calculations with orbital optimization before each call. If \p IFINAL = ``1``,
*> there has been no orbital optimization, or the calculation is
*> converged. \p IFINAL = ``2`` means this is a final CI calculation, using the
*> final orbitals. For meaning of global variables \c NTOT1, \c NTOT2, \c NACPAR
*> and \c NACPR2, see src/Include/general.fh and src/Include/rasscf.fh.
*>
*> @param[in]     CMO    MO coefficients
*> @param[out]    D      Average 1-dens matrix
*> @param[out]    DS     Average spin 1-dens matrix
*> @param[out]    P      Average symm. 2-dens matrix
*> @param[out]    PA     Average antisymm. 2-dens matrix
*> @param[out]    FI     Fock matrix from inactive density
*> @param[in,out] D1I    Inactive 1-dens matrix
*> @param[in,out] D1A    Active 1-dens matrix
*> @param[in]     TUVX   Active 2-el integrals
*> @param[in]     IFINAL Calculation status switch
************************************************************************
      Subroutine CICtl(CMO,D,DS,P,PA,FI,FA,D1I,D1A,TUVX,IFINAL)
* ****************************************************************
* history:                                                       *
* updated to use determinant based CI-procedures                 *
* J. Olsen and M.P. Fuelscher, University of Lund, Sweden, 1991  *
* updated for MOLCAS version 3                                   *
* J. Olsen and M.P. Fuelscher, University of Lund, Sweden, 1991  *
* updated for integral direct and reaction field calculations    *
* M.P. Fuelscher, University of Lund, Sweden, 1996               *
* ****************************************************************
#ifdef _DMRG_
!     module dependencies
      use qcmaquis_interface_cfg
      use qcmaquis_interface_wrapper
      use qcmaquis_interface_main, only: file_name_generator
#endif

      Implicit Real* 8 (A-H,O-Z)

      Dimension CMO(*),D(*),DS(*),P(*),PA(*),FI(*),FA(*),D1I(*),D1A(*),
     &          TUVX(*)
      Logical Exist,Do_ESPF,l_casdft
*JB   variables for state rotation on final states
      Logical do_rotate
*JB   end of variables for state rotation calculation

#include "rasdim.fh"
#include "rasscf.fh"
#include "splitcas.fh"
#include "general.fh"
#include "gas.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='CICTL   ')
#include "csfbas.fh"
#include "gugx.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "rctfld.fh"
#include "timers.fh"
#include "casvb.fh"
#include "wadr.fh"
#include "rasscf_lucia.fh"
#include "pamint.fh"
#include "input_ras.fh"
#include "stdalloc.fh"
#ifdef _HDF5_
#  include "raswfn.fh"
      real*8, allocatable :: density_square(:,:)
#endif
      Common /IDSXCI/ IDXCI(mxAct),IDXSX(mxAct)

#ifndef _DMRG_
      logical :: doDMRG = .false.
#else
      character(len=2300) :: maquis_name_states
      character(len=2300) :: maquis_name_results
      logical             :: rfh5DMRG
      logical             :: twordm_qcm
#endif
      Dimension rdum(1)

*PAM05      SymProd(i,j)=1+iEor(i-1,j-1)
C Local print level (if any)
      IPRLEV=IPRLOC(3)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF

* PAM 2017-05-23 Modify TUVX by adding a shift vector to TUVX, which has
* the effect of adding a scalar times a projector for doubly-occupied
* core states.
          IF(IfCRPR) Then
*      write(6,*)' CICTL calling MKPROJ.'
*      call xflush(6)
            CALL MKPROJ(Work(LCRVEC),CMO,TUVX)
*      write(6,*)' CICTL back from MKPROJ.'
*      call xflush(6)
          END IF


* set up flag 'IFCAS' for GAS option, which is set up in gugatcl originally.
* IFCAS = 0: This is a CAS calculation
* IFCAS = 1: This is a RAS calculation
*
      if(iDoGas.or.ifcas.gt.2) call setsxci
      If ( IPRLEV.gt.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' Enter CI section, CICTL routine'
        Write(LF,*) ' ================'
        Write(LF,*)
        Write(LF,*) ' iteration count =',ITER
      End If
      if(ifinal.ne.0) PamGen1=.True.

!      do i=1,NTOT2  ! yma
!        write(*,*)"ifinal CMO",ifinal,i,CMO(i)
!      end do

*
* SOME DIRTY SETUPS
*
      S=0.5D0*DBLE(ISPIN-1)
*
* COMPUTE ONE ELECTRON INTEGRALS IN MO BASIS
* AND ADD CORE INTERACTION
*
* LW1: FOCK MATRIX IN MO-BASIS
* LW2: 1-PARTICLE DENSITY MATRIX ALSO USED IN MO/AO TRANSFORMATION
*
      CALL GETMEM('CICTL1','ALLO','REAL',LW1,NACPAR)
      IF (IPRLEV.GE.DEBUG) THEN
        Write(LF,*) ' WORK SPACE VARIABLES IN SUBR. CICTL: '
        Write(LF,*) ' SGFCIN ',LW1
      END IF
      Call DecideOnESPF(Do_ESPF)

*                                                                      *
************************************************************************
* Global variable for MCPDFT functionals                               *
      l_casdft = KSDFT(1:5).eq.'TLSDA'   .or.
     &           KSDFT(1:6).eq.'TLSDA5'  .or.
     &           KSDFT(1:5).eq.'TBLYP'   .or.
     &           KSDFT(1:6).eq.'TSSBSW'  .or.
     &           KSDFT(1:5).eq.'TSSBD'  .or.
     &           KSDFT(1:5).eq.'TS12G'  .or.
     &           KSDFT(1:4).eq.'TPBE'    .or.
     &           KSDFT(1:5).eq.'FTPBE'   .or.
     &           KSDFT(1:5).eq.'TOPBE'    .or.
     &           KSDFT(1:6).eq.'FTOPBE'   .or.
     &           KSDFT(1:7).eq.'TREVPBE' .or.
     &           KSDFT(1:8).eq.'FTREVPBE'.or.
     &           KSDFT(1:6).eq.'FTLSDA'  .or.
     &           KSDFT(1:6).eq.'FTBLYP'
*                                                                      *
************************************************************************
*                                                                      *

      If ( lRf .or. KSDFT.ne.'SCF' .or. Do_ESPF) THEN
*
* In case of a reaction field in combination with an average CAS
* select the potential of the appropriate state.
*
        jDisk = IADR15(3)
        Do i=1,IPCMROOT-1
          Call DDafile(JOBIPH,0,rdum,NACPAR,jDisk)
          Call DDafile(JOBIPH,0,rdum,NACPAR,jDisk)
          Call DDafile(JOBIPH,0,rdum,NACPR2,jDisk)
          Call DDafile(JOBIPH,0,rdum,NACPR2,jDisk)
        End Do
*
        CALL GETMEM('D1A_FULL','ALLO','REAL',LRCT_F,NTOT2)
        CALL GETMEM('D1S_FULL','ALLO','REAL',LRCT_FS,NTOT2)
        If (IFinal.eq.0) Then
*
* Use normal MOs
*
           CALL GETMEM('D1A_RCT','ALLO','REAL',LRCT,NACPAR)
           CALL GETMEM('P2MO','ALLO','REAL',ipP2MO,NACPR2)
*
* Get the total density in MOs
*
           Call DDafile(JOBIPH,2,Work(LRCT),NACPAR,jDisk)
           Call Put_D1MO(Work(LRCT),NACPAR)  ! Put it on the RUNFILE
           IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(LRCT))
* Transform to AOs
           Call Get_D1A_RASSCF(CMO,WORK(LRCT),WORK(LRCT_F))
*
* Get the spin density in MOs
*
           IF (NACTEL.EQ.0) THEN
             CALL DCOPY_(NTOT2,[0.0D0],0,WORK(LRCT_FS),1)
           ELSE
             CALL GETMEM('D1S_RCT','ALLO','REAL',LRCT_S,NACPAR)
             Call DDafile(JOBIPH,2,Work(LRCT_S),NACPAR,jDisk)
             IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(LRCT_S))
* Transform to AOs
             Call Get_D1A_RASSCF(CMO,WORK(LRCT_S),WORK(LRCT_FS))
             CALL GETMEM('D1S_RCT','FREE','REAL',LRCT_S,NACPAR)
           END IF
*
* Get the 2-particle density in MO
*
           Call DDafile(JOBIPH,2,Work(ipP2MO),NACPR2,jDisk)
           Call Put_P2MO(Work(ipP2MO),NACPR2) ! Put it on the RUNFILE
*
           CALL SGFCIN(CMO,WORK(LW1),FI,D1I,Work(LRCT_F),Work(LRCT_FS))
*
           CALL GETMEM('P2MO','FREE','REAL',ipP2MO,NACPR2)
           CALL GETMEM('D1A_RCT','FREE','REAL',LRCT,NACPAR)
*
        Else
*
* Here the pseudo-natural orbitals are in CMO and we need to
* get the D1A of the selected state in this basis.
*
*
* Compute the density of the particular state
*
           Call GetMem('CIVEC','ALLO','REAL',LW4,NCONF)
           If (NACTEL.EQ.0) THEN
             Work(LW4)=1.0D0
           Else
             if(.not.(doDMRG))then
!               write(*,*)"run the load back CI vector part" ! yma
               iDisk = IADR15(4)
               Do jRoot = 1,IPCMROOT
                   iOpt=0
                   If (jRoot.eq.IPCMROOT) iOpt=2
* load back one CI vector at the time
                   Call DDafile(JOBIPH,iOpt,Work(LW4),nConf,iDisk)
                  !call DVcPrt('BLUBB-start CI PCM',' ',Work(LW4),nConf)
               End Do
             end if
           End If

* compute density matrices

           Call GetMem('Dtmp ','ALLO','REAL',LW6,NACPAR)
           Call GetMem('DStmp','ALLO','REAL',LW7,NACPAR)
           Call GetMem('Ptmp ','ALLO','REAL',LW8,NACPR2)
           If ( NAC.ge.1 ) Then

              If (NACTEL.eq.0) THEN
                 call dcopy_(NACPAR,[0.0D0],0,WORK(LW6),1)
                 call dcopy_(NACPAR,[0.0D0],0,WORK(LW7),1)
                 call dcopy_(NACPR2,[0.0D0],0,WORK(LW8),1)
              Else

                if(doDMRG)then
#ifdef _DMRG_
                call dmrg_interface_ctl(
     &                                  task  = 'imp rdmX',
     &                                  x1    = work(lw6:lw6+NACPAR-1),
     &                                  x2    = work(lw8:lw8+NACPR2-1),
     &                                  ndim  = nacpar,
     &                                  mdim  = nacpr2,
     &                                  state = ipcmroot,
     &                                  rdm1  = .true.,
     &                                  rdm2  = (.not.KeyCION)
     &                                 )

                !> import 1p-spin density
                call dcopy_(NACPAR,[0.0D0],0,work(lw7),1)
                call dmrg_interface_ctl(
     &                                  task  = 'imp spdX',
     &                                  x1    = work(lw7:lw7+NACPAR-1),
     &                                  ndim  = nacpar,
     &                                  state = ipcmroot,
     &                                  rdm1  = .true.
     &                                 )
#endif
               else
                 Call GetMem('PAtmp','ALLO','REAL',LW9,NACPR2)
                 Call GetMem('Pscr','ALLO','REAL',LW10,NACPR2)
                 C_Pointer = Lw4
                 CALL Lucia_Util('Densi',0,iDummy,rdum)
                 If (IFCAS.GT.2 .OR. iDoGAS) Then
                   Call CISX(IDXSX,Work(LW6),Work(LW7),Work(LW8),
     &                     Work(LW9),Work(LW10))
                 End If
                 Call GetMem('Pscr','FREE','REAL',LW10,NACPR2)
                 Call GetMem('PAtmp','FREE','REAL',LW9,NACPR2)
               end if ! doDMRG/doBLOK or CI

             End If
           Else
              call dcopy_(NACPAR,[0.0D0],0,WORK(LW6),1)
              call dcopy_(NACPAR,[0.0D0],0,WORK(LW7),1)
              call dcopy_(NACPR2,[0.0D0],0,WORK(LW8),1)
           End If
* Modify the symmetric 2-particle density if only partial
* "exact exchange" is included.
c          n_Det=2
c          n_unpaired_elec=(iSpin-1)
c          n_paired_elec=nActEl-n_unpaired_elec
c          If(n_unpaired_elec+n_paired_elec/2.eq.nac) n_Det=1
*                  write(6,*) 'n_Det =', n_Det
           If (ExFac.ne.1.0D0.AND.(.not.l_casdft))
     &    Call Mod_P2(Work(LW8),NACPR2,
     &                                   Work(LW6),NACPAR,
     &                                   Work(LW7),ExFac,n_Det)
*
           Call Put_P2MO(Work(LW8),NACPR2) ! Put it on the RUNFILE
*
           Call GetMem('Ptmp ','FREE','REAL',LW8,NACPR2)
*
           Call Put_D1MO(Work(LW6),NACPAR) ! Put it on the RUNFILE
           IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(LW6))
           Call Get_D1A_RASSCF(CMO,Work(LW6),Work(LRCT_F))
*
           IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(LW7))
           Call Get_D1A_RASSCF(CMO,Work(LW7),Work(LRCT_FS))
*
!           do i=1,NACPAR  !yma
!              write(*,*)"i-rdms1 1",i,Work(LW6+i-1)
!           end do

           Call GetMem('DStmp','FREE','REAL',LW7,NACPAR)
           Call GetMem('Dtmp ','FREE','REAL',LW6,NACPAR)
           Call GetMem('CIVEC','FREE','REAL',LW4,NCONF)
*
           Call SGFCIN(CMO,Work(LW1),FI,D1I,Work(LRCT_F),Work(LRCT_FS))
*
        End If
        CALL GETMEM('D1S_FULL','FREE','REAL',LRCT_FS,NTOT2)
        CALL GETMEM('D1A_RCT','FREE','REAL',LRCT_F,NTOT1)
*
      ELSE
*********************************************************************************************
* Normal case: no reaction field, no ESP to be added to the Fock matrix or ksdft /= SCF
*********************************************************************************************
         IF (IPRLEV.GE.DEBUG) THEN
           CALL TRIPRT('DS input  ',' ',DS,NAC)
           CALL TRIPRT('D input  ',' ',D,NAC)
         END IF
        CALL GETMEM('TmpDS' ,'Allo','REAL',ipTmpDS ,NACPAR)
        CALL GETMEM('TmpD1S','Allo','REAL',ipTmpD1S,NTOT2 )
        call dcopy_(NACPAR,DS,1,Work(ipTmpDS),1)
        IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(ipTmpDS))
        Call Get_D1A_RASSCF(CMO,Work(ipTmpDS),Work(ipTmpD1S))

        CALL GETMEM('TmpDS' ,'Free','REAL',ipTmpDS ,NACPAR)
*
        CALL SGFCIN(CMO,WORK(LW1),FI,D1I,D1A,Work(ipTmpD1S))
        CALL GETMEM('TmpD1S','Free','REAL',ipTmpD1S,NTOT2 )
*
      END IF

!     stknecht: the core fock matrix (pointer lw1)
!               total core energy (emy) as output of sgfcin
!     task: write the FCIDUMP file
      if(doDMRG)then
#ifdef _DMRG_
        call dmrg_interface_ctl(
     &                          task   = 'fci dump',
     &                          x1     = work(lw1),
     &                          x2     = tuvx,
     &                          energy = emy
     &                         )
        if(dofcidump)then
          CALL GETMEM('CICTL1','FREE','REAL',LW1,NACPAR)
          goto 9000
        end if
#endif
      end if
*
      lw1_cvb=lw1
      If (IfVB.eq.2) GoTo 9000

*
* C
* DAVIDSON DIAGONALIZATION
* C
*
C     kh0_pointer is used in Lucia to retrieve H0 from Molcas.
      kh0_pointer = lw1
      if(IfVB.eq.1)then
        call cvbmn_rvb(max(ifinal,1))
      else
        If (KSDFT(1:3).ne.'SCF'
     &      .and.DFTFOCK(1:4).eq.'DIFF'.and.nac.ne.0) Then
          nTmpPUVX=nFint
          Call GetMem('TmpPUVX','Allo','Real',ipTmpPUVX,nTmpPUVX)
          Call GetMem('TmpTUVX','Allo','Real',ipTmpTUVX,NACPR2)
          Call dCopy_(NACPR2,[0.0d0],0,Work(ipTmpTUVX),1)
          Call Get_dArray('DFT_TwoEl',Work(ipTmpPUVX),nTmpPUVX)
          Call Get_TUVX(Work(ipTmpPUVX),Work(ipTmpTUVX))
          Call DaXpY_(NACPR2,1.0d0,TUVX,1,Work(ipTmpTUVX),1)
         if (DoSplitCAS) then  ! (GLMJ)
           Call SplitCtl(Work(LW1),Work(ipTmpTUVX),IFINAL,iErrSplit)
           Call GetMem('TmpTUVX','Free','Real',ipTmpTUVX,NACPR2)
           Call GetMem('TmpPUVX','Free','Real',ipTmpPUVX,nTmpPUVX)
           if (iErrSplit.eq.1) then
            write(LF,*) ('*',i=1,120)
            write(LF,*)'WARNING!!!'
            write(LF,*) 'SplitCAS iterations don''t converge.'
            write(LF,*) 'The program will continue'
            write(LF,*) 'Hopefully your calculation will converge',
     &                 'next iteration!'
            write(LF,*) ('*',i=1,120)
           end if
           if (iErrSplit.eq.2) then
            write(LF,*) ('*',i=1,120)
            write(LF,*)'WARNING!!!'
            write(LF,*) 'SplitCAS iterations don''t converge.'
          write(LF,*)'Try to increase MxIterSplit or SplitCAS threshold'
            write(LF,*) 'The program will STOP!!!'
            write(LF,*) ('*',i=1,120)
            call xQuit(96)
           end if
         end if
         If (.not.DoSplitCAS) then
           Call   DavCtl(Work(LW1),Work(ipTmpTUVX),IFINAL)
           Call GetMem('TmpTUVX','Free','Real',ipTmpTUVX,NACPR2)
           Call GetMem('TmpPUVX','Free','Real',ipTmpPUVX,nTmpPUVX)
         end if
        Else
         if (DoSplitCAS) then !(GLMJ)
           Call SplitCtl(Work(LW1),TUVX,IFINAL,iErrSplit)
           if (iErrSplit.eq.1) then
            write(LF,*) ('*',i=1,120)
            write(LF,*)'WARNING!!!'
            write(LF,*) 'SplitCAS iterations don''t converge.'
            write(LF,*) 'The program will continue'
            write(LF,*) 'Hopefully your calculation will converge',
     &                 'next iteration!'
            write(LF,*) ('*',i=1,120)
           end if
           if (iErrSplit.eq.2) then
            write(LF,*) ('*',i=1,120)
            write(LF,*)'WARNING!!!'
            write(LF,*) 'SplitCAS iterations don''t converge.'
            write(LF,*) 'MxIterSplit', MxIterSplit
            write(LF,*) 'SplitCAS ThreShold', ThrSplit
          write(LF,*)'Try to increase MxIterSplit or SplitCAS threshold'
            write(LF,*) 'The program will STOP'
            write(LF,*) ('*',i=1,120)
            call xQuit(96)
           end if
         end if
         if(.not.DoSplitCAS) then
! Call DMRG staff in Molcas - yingjin
           if(doDMRG)then
#ifdef _DMRG_
                                                  twordm_qcm = .true.
             if(KeyCION .and. .not. domcpdftDMRG) twordm_qcm = .false.
             call dmrg_interface_ctl(
     &                               task = 'run DMRG',
     &                               Key_CION = .not.twordm_qcm,
     &                               IterSCF  = Iter
     &                              )
! Keep the root energies
             Do jRoot = 1,lRoots
                ENER(jRoot,ITER)=dmrg_energy%dmrg_state_specific(jroot)
             End Do
#endif
           else
! Normal Davidson algorithm
             Call DavCtl(Work(LW1),TUVX,IFINAL)
           end if
         end if
        End If
      endif

*
* C
* CALCULATE DENSITY MATRICES
* SAVE DENSITY MATRICES ON FILE
* COMPUTE AVERAGE DENSITY MATRICES
* C
*
* LW6: ONE-BODY DENSITY
* LW7: ONE-BODY SPIN DENSITY
* LW8: SYMMETRIC TWO-BODY DENSITY
* LW9: ANTISYMMETRIC TWO-BODY DENSITY
*
      Call Timing(Rado_1,Swatch,Swatch,Swatch)
      Call dCopy_(NACPAR,[0.0D0],0,D,1)
      Call dCopy_(NACPAR,[0.0D0],0,DS,1)
      Call dCopy_(NACPR2,[0.0D0],0,P,1)
      Call dCopy_(NACPR2,[0.0D0],0,PA,1)
      CALL GETMEM('CIVEC','ALLO','REAL',LW4,NCONF)
      CALL GETMEM('Dtmp ','ALLO','REAL',LW6,NACPAR)
      CALL GETMEM('DStmp','ALLO','REAL',LW7,NACPAR)
      CALL GETMEM('Ptmp ','ALLO','REAL',LW8,NACPR2)
      CALL GETMEM('PAtmp','ALLO','REAL',LW9,NACPR2)
      CALL GETMEM('Pscr','ALLO','REAL',LW10,NACPR2)
#ifdef _HDF5_
      call mma_allocate(density_square, nac, nac)
#endif
      iDisk = IADR15(4)
      jDisk = IADR15(3)
      IF (.not.DoSplitCAS) THEN
*JB   Instead of RASSCF/RASCI energy, print out energy for rotated
*JB   states
       do_rotate=.False.
       If (ifinal.eq.2) Then
        IF(IXMSP.eq.1) THEN
         CALL XMSRot(CMO,FI,FA)
        End If
        IF(ICMSP.eq.1) THEN
         CALL XMSRot(CMO,FI,FA)
         CALL CMSRot(TUVX)
        END IF
        If(IRotPsi==1) Then
         CALL f_inquire('ROT_VEC',Do_Rotate)
        End If
        If(Do_Rotate) Then
         CALL RotState()
        Else
         If(IRotPsi==1) Then
          write(LF,'(6X,A,A)')'Do_Rotate.txt is not found. ',
     &   'MCSCF states will not be rotated'
         End If
        End If
*JB    End of condition 'Do_Rotate' to initialize rotated states
       End If
*JB    End If for ifinal=2
       Do jRoot = 1,lRoots
* load back one CI vector at the time
*JB      If do_rotate=.true., then we read CI vectors from Work(LRCIVec)
*JB      Otherwise we read if from JOBIPH
         Call DDafile(JOBIPH,2,Work(LW4),nConf,iDisk)
         IF (IPRLEV.GE.DEBUG) THEN
          call DVcPrt('CI-Vec in CICTL',' ',Work(LW4),nConf )
          Write(LF,*) ' WORK SPACE VARIABLES IN SUBR. CICTL: '
          Write(LF,'(1x,A,5I10)') 'DENSI',LW4,LW6,LW7,LW8,LW9
         END IF
* compute density matrices

         If ( NAC.ge.1 ) Then
           C_Pointer = Lw4
           if(.not.(doDMRG))
     &       CALL Lucia_Util('Densi',0,iDummy,rdum)
           IF ( IPRLEV.GE.INSANE  ) THEN
             write(6,*) 'At root number =', jroot
             CALL TRIPRT('D after lucia  ',' ',Work(LW6),NAC)
             CALL TRIPRT('DS after lucia  ',' ',Work(LW7),NAC)
             CALL TRIPRT('P after lucia',' ',Work(LW8),NACPAR)
             CALL TRIPRT('PA after lucia',' ',Work(LW9),NACPAR)
           END IF
         EndIf
         IF (.not.doDMRG .and. (IFCAS.GT.2 .OR. iDoGAS))
     &   CALL CISX(IDXSX,Work(LW6),Work(LW7),
     &               Work(LW8),Work(LW9),Work(LW10))
! 1,2-RDMs importing from DMRG calculation -- Stefan/Yingjin
         if(doDMRG)then
#ifdef _DMRG_
           call dmrg_interface_ctl(
     &                             task  = 'imp rdmX',
     &                             x1    = work(lw6:lw6+NACPAR-1),
     &                             x2    = work(lw8:lw8+NACPR2-1),
     &                             ndim  = nacpar,
     &                             mdim  = nacpr2,
     &                             state = jroot,
     &                             rdm1  = .true.,
     &                             rdm2  = twordm_qcm
     &                            )

           !> import 1p-spin density
           call dcopy_(NACPAR,[0.0D0],0,work(lw7),1)
           call dmrg_interface_ctl(
     &                             task  = 'imp spdX',
     &                             x1    = work(lw7:lw7+NACPAR-1),
     &                             ndim  = nacpar,
     &                             state = jroot,
     &                             rdm1  = .true.
     &                            )
#ifdef _DMRG_DEBUGPRINT_
           write(6,*)"==============================================="
           write(6,*)"  Set all elems in anti-symmetric 2-RDM to zero"
           write(6,*)"==============================================="
#endif
           call dcopy_(NACPR2,[0.0D0],0,work(lw9),1)

           IF ( IPRLEV.GE.INSANE  ) THEN
             CALL TRIPRT('D after  DMRG',' ',Work(LW6),NAC)
             CALL TRIPRT('DS after DMRG',' ',Work(LW7),NAC)
             CALL TRIPRT('P after  DMRG',' ',Work(LW8),NACPAR)
             CALL TRIPRT('PA after DMRG',' ',Work(LW9),NACPAR)
           END IF
#endif
         end if
* Modify the symmetric 2-particle density if only partial
* "exact exchange" is included.
c        n_Det=2
c        n_unpaired_elec=(iSpin-1)
c        n_paired_elec=nActEl-n_unpaired_elec
c        If(n_unpaired_elec+n_paired_elec/2.eq.nac) n_Det=1
c
c           Write(LF,*) ' iSpin=',iSpin
c           Write(LF,*) ' n_unpaired_elec',n_unpaired_elec
c           Write(LF,*) ' n_paired_elec',  n_paired_elec
c           Write(LF,*) ' n_unpaired_elec+n_paired_elec/2',
c     &                  n_unpaired_elec+n_paired_elec/2
c           Write(LF,*) ' n_Det=',n_Det
c
c

*          write(6,*) 'second call to Mod_P2'

           If (ExFac.ne.1.0D0.AND.(.not.l_casdft))
     &                     Call Mod_P2(Work(LW8),NACPR2,
     &                                 Work(LW6),NACPAR,
     &                                 Work(LW7),ExFac,n_Det)

* update average density matrices
         Scal = 0.0d0
         Do kRoot = 1,nRoots
           If ( iRoot(kRoot).eq.jRoot ) then
             Scal = Weight(kRoot)
           End If
         End Do
         Call daXpY_(NACPAR,Scal,Work(LW6),1,D,1)
         Call daXpY_(NACPAR,Scal,Work(LW7),1,DS,1)
         Call daXpY_(NACPR2,Scal,Work(LW8),1,P,1)
cGLM Put the D1MO and the P2MO values in RUNFILE
*
         Call Put_D1MO(Work(LW6),NACPAR) ! Put it on the RUNFILE
         Call Put_P2MO(Work(LW8),NACPR2) ! Put it on the RUNFILE
         Call daXpY_(NACPR2,Scal,Work(LW9),1,PA,1)
* save density matrices on disk
         Call DDafile(JOBIPH,1,Work(LW6),NACPAR,jDisk)
         Call DDafile(JOBIPH,1,Work(LW7),NACPAR,jDisk)
         Call DDafile(JOBIPH,1,Work(LW8),NACPR2,jDisk)
         Call DDafile(JOBIPH,1,Work(LW9),NACPR2,jDisk)
CSVC: store a single column instead of the whole array (which is for each root!)
C and for now don't bother with 2-electron active density matrices
#ifdef _HDF5_
         call square(work(lw6),density_square,1,nac,nac)
         call mh5_put_dset_array_real(wfn_dens, density_square,
     $           [nac,nac,1], [0,0,jRoot-1])
         call square(work(lw7),density_square,1,nac,nac)
         call mh5_put_dset_array_real(wfn_spindens, density_square,
     $           [nac,nac,1], [0,0,jRoot-1])
#endif
       End Do

      ELSE  ! SplitCAS run
        Call DDafile(JOBIPH,2,Work(LW4),nConf,iDisk)
        IF (IPRLEV.GE.DEBUG) then
          call DVcPrt('CI-Vec in CICTL SplitCAS sect',' ',
     &              Work(LW4),nConf)
        end if
* compute density matrices
        If ( NAC.ge.1 ) Then
           C_Pointer = Lw4
           CALL Lucia_Util('Densi',0,iDummy,rdum)
           IF ( IPRLEV.GE.INSANE  ) THEN
             CALL TRIPRT('D after lucia',' ',Work(LW6),NAC)
             CALL TRIPRT('DS after lucia',' ',Work(LW7),NAC)
             CALL TRIPRT('P after lucia',' ',Work(LW8),NACPAR)
             CALL TRIPRT('PA after lucia',' ',Work(LW9),NACPAR)
           END IF
        EndIf
        IF (IDoGAS.or.ifcas.gt.2) CALL CISX(IDXSX,Work(LW6),Work(LW7),
     &              Work(LW8),Work(LW9),Work(LW10))
           If (ExFac.ne.1.0D0.AND.(.not.l_casdft))
     &                      Call Mod_P2(Work(LW8),NACPR2,
     &                                Work(LW6),NACPAR,
     &                                Work(LW7),ExFac,n_Det)
        Scal = 1.0d0
        call daxpy_(NACPAR,Scal,Work(LW6),1,D,1)
        call daxpy_(NACPAR,Scal,Work(LW7),1,DS,1)
        call daxpy_(NACPR2,Scal,Work(LW8),1,P,1)
        call daxpy_(NACPR2,Scal,Work(LW9),1,PA,1)
* save density matrices on disk
        Call DDafile(JOBIPH,1,Work(LW6),NACPAR,jDisk)
        Call DDafile(JOBIPH,1,Work(LW7),NACPAR,jDisk)
        Call DDafile(JOBIPH,1,Work(LW8),NACPR2,jDisk)
        Call DDafile(JOBIPH,1,Work(LW9),NACPR2,jDisk)
      END IF

#ifdef _HDF5_
      call mma_deallocate(density_square)
#endif
      CALL GETMEM('Pscr','FREE','REAL',LW10,NACPR2)
      CALL GETMEM('PAtmp','FREE','REAL',LW9,NACPAR)
      CALL GETMEM('Ptmp ','FREE','REAL',LW8,NACPAR)
      CALL GETMEM('DStmp','FREE','REAL',LW7,NACPR2)
      CALL GETMEM('Dtmp ','FREE','REAL',LW6,NACPR2)
*
* print matrices
      IF ( IPRLEV.GE.INSANE  ) THEN
        CALL TRIPRT('Averaged one-body density matrix, D',
     &              ' ',D,NAC)
        CALL TRIPRT('Averaged one-body spin density matrix, DS',
     &              ' ',DS,NAC)
        CALL TRIPRT('Averaged two-body density matrix, P',
     &              ' ',P,NACPAR)
        CALL TRIPRT('Averaged antisymmetric two-body density matrix,PA',
     &              ' ',PA,NACPAR)
      END IF
      Call Put_D1MO(D,NACPAR) ! Put it on the RUNFILE
c
      IF ( NASH(1).NE.NAC ) CALL DBLOCK(D)
      Call Timing(Rado_2,Swatch,Swatch,Swatch)
      Rado_2 = Rado_2 - Rado_1
      Rado_3 = Rado_3 + Rado_2
*
* C
* IF FINAL ITERATION REORDER THE WAVEFUNCTION ACCORDING TO
* THE SPLIT GRAPH GUGA CONVENTIONS AND PRINT IT.
* C
*
* LW11: Temporary copy of a CI vector
*
      IF (IFINAL.EQ.2 .AND. NAC.GT.0 ) THEN
       IF (IPRLEV.ge.USUAL) THEN
        Write(LF,*)
        Write(LF,'(6X,120(1H*))')
        Write(LF,'(54X,A)') 'Wave function printout:'
        Write(LF,'(23X,A)') 'occupation of active orbitals, and '//
     &                      'spin coupling of open shells '//
     &                      '(u,d: Spin up or down)'
        Write(LF,'(6X,120(1H*))')
        Write(LF,*)
        Write(6,'(6x,A)') 'Note: transformation to natural orbitals'
        Write(6,'(6x,A)')
     &     'has been made, which may change the order of the CSFs.'
       END IF
       Call GetMem('PrSel','Allo','Inte',LW12,nConf)
       Call iCopy(nConf,[0],0,iWork(LW12),1)
       Call GetMem('CIVtmp','Allo','Real',LW11,nConf)
       iDisk = IADR15(4)

       IF (.Not.DoSplitCAS) THEN
        Do i = 1,lRoots
          jDisk=iDisk
* load back one CI vector at the time
*          Call DDafile(JOBIPH,2,Work(LW4),nConf,iDisk)
           Call DDafile(JOBIPH,2,Work(LW4),nConf,iDisk)
          IF (IPRLEV.GE.DEBUG) THEN
           call DVcPrt('CI-Vec in CICTL last cycle',' ',
     &        Work(LW4),nConf)
           Write(LF,*) ' WORK SPACE VARIABLES IN SUBR. CICTL: '
           Write(LF,'(1x,A,2I10)') 'REORD',LW4,LW11
          END IF
          call getmem('kcnf','allo','inte',ivkcnf,nactel)
         if(.not.iDoGas)then
          Call Reord2(NAC,NACTEL,LSYM,0,
     &                iWork(KICONF(1)),iWork(KCFTP),
     &                Work(LW4),Work(LW11),iWork(ivkcnf))
c        end if
c         call getmem('kcnf','free','inte',ivkcnf,nactel)

* save reorder CI vector on disk
c         if(.not.iDoGas)then
          Call DDafile(JOBIPH,1,Work(LW11),nConf,jDisk)
#ifdef _HDF5_
          call mh5_put_dset_array_real
     $            (wfn_cicoef,Work(LW11),[nconf,1],[0,i-1])

#endif
c         else
c         call DDafile(JOBIPH,1,Work(LW4),nConf,jDisk)
c         end if
* printout of the wave function
           if(doDMRG)then
             ! If DMRG, the SRCAS can give the CI-coefficients
           else
             IF (IPRLEV.GE.USUAL) THEN
              Write(LF,*)
              Write(LF,'(6X,A,F6.2,A,I3)')
     &                'printout of CI-coefficients larger than',
     &                 PRWTHR,' for root',i
              Write(LF,'(6X,A,F15.6)')
     &                 'energy=',ENER(I,ITER)
               CALL SGPRWF(iWork(LW12),IWORK(LNOCSF),IWORK(LIOCSF),
     &                  IWORK(LNOW),IWORK(LIOW),WORK(LW11))
             End If
           end if
         else ! for iDoGas
          Write(LF,'(1x,a)') 'WARNING: true GAS, JOBIPH not compatible!'
c.. save CI vector on disk
          Call DDafile(JOBIPH,1,Work(LW4),nconf,jDisk)
CSVC: store CI as a column array of the on-disk CI (which is for all roots!)
#ifdef _HDF5_
          call mh5_put_dset_array_real
     $            (wfn_cicoef,Work(LW4),[nconf,1],[0,i-1])
#endif
C.. printout of the wave function
          IF (IPRLEV.GE.USUAL) THEN
            Write(LF,*)
            Write(LF,'(6X,A,F6.2,A,I3)')
     c                'printout of CI-coefficients larger than',
     c                 prwthr,' for root', i
            Write(LF,'(6X,A,F15.6)')
     c                'energy=',ener(i,iter)
          call gasprwf(iwork(lw12),nac,nactel,lsym,iwork(kiconf(1)),
     c                 iwork(kcftp),work(lw4),iwork(ivkcnf))
          End If
         end if
          call getmem('kcnf','free','inte',ivkcnf,nactel)
*          END IF
        End Do

        ELSE !RUN SPLITCAS

          jDisk=iDisk
* load back one CI vector at the time
          Call DDafile(JOBIPH,2,Work(LW4),nConf,iDisk)
          IF (IPRLEV.GE.DEBUG) THEN
           call DVcPrt('CI-Vec in CICTL SplitCAS last cycle',' ',
     &        Work(LW4),nConf)
          END IF
          IF (IPRLEV.GE.DEBUG) THEN
           Write(LF,*) ' WORK SPACE VARIABLES IN SUBR. CICTL: '
           Write(LF,'(1x,A,2I10)') 'REORD',LW4,LW11
          END IF
* reorder it according to the split graph GUGA conventions
          call getmem('kcnf','allo','inte',ivkcnf,nactel)
          Call Reord2(NAC,NACTEL,LSYM,0,
     &                iWork(KICONF(1)),iWork(KCFTP),
     &                Work(LW4),Work(LW11),iWork(ivkcnf))
          call getmem('kcnf','free','inte',ivkcnf,nactel)
* save reorder CI vector on disk
          Call DDafile(JOBIPH,1,Work(LW11),nConf,jDisk)
#ifdef _HDF5_
          call mh5_put_dset_array_real
     $            (wfn_cicoef,Work(LW11),[nconf,1],[0,i-1])
#endif
          IF (IPRLEV.GE.DEBUG) THEN
           call DVcPrt('CI-Vec in CICTL after Reord',' ',
     &        Work(LW11),nConf)
          END IF
* printout of the wave function
          IF (IPRLEV.GE.USUAL) THEN
            Write(LF,*)
            Write(LF,'(6X,A,F6.2,A,I3)')
     &                'printout of CI-coefficients larger than',
     &                 PRWTHR,' for root',lRootSplit
            Write(LF,'(6X,A,F15.6)')
     &                'Split-energy=',ENER(lRootSplit,ITER)
            CALL SGPRWF(iWork(LW12),IWORK(LNOCSF),IWORK(LIOCSF),
     &                IWORK(LNOW),IWORK(LIOW),WORK(LW11))
          END IF
        END IF

        Call GetMem('PrSel','Free','Inte',LW12,nConf)
        Call GetMem('CIVtmp','Free','Real',LW11,nConf)
      ENDIF
#ifdef _DMRG_
          call mh5_put_dset_array_str
     &         (wfn_dmrg_checkpoint,dmrg_file%qcmaquis_checkpoint_file)
#endif

      CALL GETMEM('CIVEC','FREE','REAL',LW4,NCONF)
      CALL GETMEM('CICTL1','FREE','REAL',LW1,NACPAR)

 9000 Continue
*
*     For RF calculations make sure that the we are following the
*     correct root.
*
*     In the current implementation the overlap between the CI vectors
*     of different macro iterations is used. This criterion stricktly
*     only hold if the orbitals are not changed in between the
*     interations, to make sure that this approximately holds the
*     comparision is only to be considered to be valid if the rotmax
*     parameter is below an empirical threshold. In the future the
*     procedure for indentifying root flipping has to be made more
*     robust.
*
CSVC: if CISElect is used, roots should be traced regardless of orbital
C     rotation, so in that case ignore the automatic tracing and follow
C     the relative CISE root given in the input by the 'CIRF' keyword.
*
      If (lRF.and.KeyCISE.and.KeyCIRF) Then
        JPCMROOT=IPCMROOT
        IPCMROOT=IROOT(ICIRFROOT)
        Call Put_iScalar("RF CASSCF root",IPCMROOT)
        If (JPCMROOT.ne.IPCMROOT) Then
          Write (6,'(1X,A,I3,A,I3)') 'RF Root has flipped from ',
     &                 JPCMROOT, ' to ',IPCMROOT
        End If
      Else If (lRF) Then
        Call Qpg_iScalar('RF CASSCF root',Exist)
        If (.NOT.Exist) Then
*
*          We are here since we are using the default values.
*
           Call Put_iScalar("RF CASSCF root",IPCMROOT)
           Call Put_iScalar("RF0CASSCF root",IPCMROOT)
        End If
*
        mconf = 0
        Call Allocate_Work(ipRF,nConf)
        Call Qpg_dArray("RF CASSCF Vector",Exist,mConf)

        !> check whether the rf target h5 file exists (needed at this
        !point for numerical gradient calculations)
#ifdef _DMRG_
        if(doDMRG.and.exist)then
          inquire(file="rf.results_state.h5", exist=rfh5DMRG)
          if(.not.rfh5DMRG)then
            maquis_name_states  = ""
            maquis_name_results = ""
            call file_name_generator(IPCMROOT-1,"checkpoint_state.",
     &                               17,".h5",3,maquis_name_states)
            call file_name_generator(IPCMROOT-1,"results_state.",
     &                               14,".h5",3,maquis_name_results)

          !> copy current target wave function to local wave function
            call systemf(
     & "cp -f "//trim(maquis_name_results)//" rf.results_state.h5 && "//
     & "rm -rf rf.checkpoint_state.h5 && "//
     & "cp -r "//trim(maquis_name_states)//" rf.checkpoint_state.h5",
     &                 iErr)
          end if
        end if
#endif

        If (Exist
     &      .and. mConf .eq. nConf
     &      .and. iFinal.ne.2
     &      .and. (ABS(RotMax).lt.1.0D-3 .or. KeyCISE)
     &     ) Then

           if(doDMRG)then
#ifdef _DMRG_
             overlap = 0.0d0
             call dmrg_interface_ctl(
     &                               task   = 'overlapR',
     &                               energy = overlap,
     &                               stateL = -1
     &                              )
             rnorm = sqrt(overlap)
#endif
           else
             Call Get_dArray("RF CASSCF Vector",Work(ipRF),nConf)
             rNorm=Sqrt(DDot_(nConf,Work(ipRF),1,Work(ipRF),1))
           end if
*          Write (6,*) 'rNorm=',rNorm
           JPCMROOT=IPCMROOT
           If (rNorm.gt.1.0D-10) Then
              Call Allocate_Work(ipTemp,nConf)
              rMax=0.0D0
              jDisk = IADR15(4)
              Do i = 1, lRoots
                 if(doDMRG)then
#ifdef _DMRG_
                   overlap = 0.0d0
                   call dmrg_interface_ctl(
     &                                     task   = 'overlapR',
     &                                     energy = overlap,
     &                                     stateL = i
     &                                    )
                   qmax = abs(overlap)
#endif
                 else
                   Call DDafile(JOBIPH,2,Work(ipTemp),nConf,jDisk)
                   qMax=Abs(DDot_(nConf,Work(ipTemp),1,Work(ipRF),1))
                 end if
*                Write (6,*) 'qMax=',qMax
                 If (qMax.gt.rMax .and.
     &               qMax.gt.0.5D0) Then
                    rMax = qMax
                    JPCMROOT=i
                 End If
              End Do
              Call Free_Work(ipTemp)
           End If
        Else
           JPCMROOT=IPCMROOT
        End If
*
        If (JPCMROOT.ne.IPCMROOT) Then
           Write (6,*) ' RF Root has flipped from ',IPCMROOT, ' to ',
     &                                              JPCMROOT
           IPCMROOT=JPCMROOT
           Call Put_iScalar("RF CASSCF root",IPCMROOT)
        End If
*
        if(doDMRG)then
#ifdef _DMRG_
          maquis_name_states  = ""
          maquis_name_results = ""
          call file_name_generator(IPCMROOT-1,"checkpoint_state.",
     &                             17,".h5",3,maquis_name_states)
          call file_name_generator(IPCMROOT-1,"results_state.",
     &                             14,".h5",3,maquis_name_results)

!         print *, 'my string: ',
!    & "cp -f "//trim(maquis_name_results)//" rf.results_state.h5 && "//
!    & "rm -rf rf.checkpoint_state.h5 && "//
!    & "cp -r "//trim(maquis_name_states)//" rf.checkpoint_state.h5"

          !> copy current target wave function to local wave function
          call system(
     & "cp -f "//trim(maquis_name_results)//" rf.results_state.h5 && "//
     & "rm -rf rf.checkpoint_state.h5 && "//
     & "cp -r "//trim(maquis_name_states)//" rf.checkpoint_state.h5",
     &               iErr)
#endif
        else
          jDisk = IADR15(4)
          Do i=1,IPCMROOT-1
            Call DDafile(JOBIPH,0,rdum,nConf,jDisk)
          End Do
          Call DDafile(JOBIPH,2,Work(ipRF),nConf,jDisk)
        end if

        Call Put_dArray("RF CASSCF Vector",Work(ipRF),nConf)
        Call Free_Work(ipRF)
      End If

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993,1996, Roland Lindh                      *
!               1990, IBM                                              *
!               1995, Martin Schuetz                                   *
!***********************************************************************

subroutine Init_SemiDSCF(FstItr,Thize,Cutint)

use dEAF, only: dEAFARead, dEAFAWrite, dEAFRead
use IOBUF, only: Buffer, Disk, Disk_1, Disk_2, iBuf, ID, IODone, ipos, iStatIO, lBuf, LuTmp, Mode_Read, Mode_Write, nBuf, OnDisk
use Constants, only: Zero
use Definitions, only: wp, iwp, u6, RtoI

implicit none
logical(kind=iwp), intent(in) :: FstItr
real(kind=wp), intent(inout) :: Thize
real(kind=wp), intent(in) :: CutInt
integer(kind=iwp) :: lBufOld, nBufOld
real(kind=wp) :: control(4), CutIntOld, ThizeOld

!write(u6,*) 'Enter: Init_SemiDSCF'
!write(u6,*) 'Ondisk=',Ondisk
!write(u6,*) 'lBuf=',lBuf

! Initiate asynchronous double buffer I/O.

IODone = .false.
Disk = Zero
iBuf = 1
iPos = 1
if (FstItr) then
  iStatIO = Mode_Write
  !write(u6,*) 'write istatio=',istatio
  control(1) = real(lbuf,kind=wp)
  control(2) = real(nbuf,kind=wp)
  control(3) = thize
  control(4) = cutint
  !write(u6,*) 'control written:',control
  !write(u6,*) ' Initiate write @',Disk,'iBuf=',iBuf
  if (OnDisk) call dEAFAwrite(LuTmp,control,4*RtoI,Disk,id)
else
  iStatIO = Mode_Read
  !write(u6,*) 'read istatio=',istatio

  ! Initiate first read ahead of time.

  !write(u6,*) 'lBuf*RtoI=',lbuf*RtoI,' rtoi=',Rtoi
  if (OnDisk) then
    !write(u6,*) ' Initiate read @',Disk,'iBuf=',iBuf
    call dEAFread(LuTmp,control,4*RtoI,Disk)
    Disk_2 = Disk
    Disk_1 = Disk
    !write(u6,*) 'control read:',control
    lbufold = nint(control(1))
    nbufold = nint(control(2))
    thizeold = control(3)
    cutintold = control(4)
    if (lbufold < lbuf) then
      write(u6,*) 'Reducing the buffer size from ',lbuf,' to',lbufold
      lbuf = lbufold
    else if (lbufold > lbuf) then
      write(u6,*) 'Inconsistent buffer lengths. Old:',lbufold,'  current:',lbuf
      call Abend()
    end if
    if (nbuf /= nbufold) then
      write(u6,*) 'Inconsistent buffer number. Old:',nbufold,'  current:',nbuf
      call Abend()
    end if
    if (abs(thize-thizeold) > 1.0e-10_wp) then
      write(u6,*) 'Resetting thize from',thize,' to',thizeold
      thize = thizeold
    end if
    if (cutintold > cutint) then
      write(u6,*) 'Inconsistent Cutint. Old:',cutintold,'  current:',cutint
      call Abend()
    end if
    !write(u6,*) ' Initiate read @',Disk,'iBuf=',iBuf
    !if (OnDisk) write(u6,*) ' Initial EAFARead'
    call dEAFARead(LuTmp,Buffer(1,iBuf),lBuf*RtoI,Disk,id)
  end if
end if

!write(u6,*) 'Exit: Init_SemiDSCF'

end subroutine Init_SemiDSCF

***********************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994,2004,2014,2017,2019,2020, Roland Lindh            *
*               2014,2018, Ignacio Fdez. Galvan                        *
************************************************************************
      Subroutine RS_RFO(H,g,nInter,dq,UpMeth,dqHdq,StepMax,Step_Trunc,
     &                  Thr_RS)
************************************************************************
*                                                                      *
*     Object: Automatic restricted-step rational functional            *
*             optimization.                                            *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             December '94                                             *
*                                                                      *
*     Modified to the restricted-step RFO method of Besalu and Bofill. *
*     Ref: E. Besalu and J. M. Bofill, TCA, 100, 265-274 (1998), by    *
*     R. Lindh, Gyeongju, Korea.                                       *
*     Removed full diagonalizations, Ignacio Fdez. Galvan, Uppsala     *
*     Remove references to work, Roland Lindh                          *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Integer nInter
      Real*8 H(nInter,nInter), g(nInter), dq(nInter)
      Character UpMeth*6, Step_Trunc*1
      Real*8 StepMax
*
*     Local variables
      Real*8, Dimension(:), Allocatable:: Tmp, Val, Matrix
      Real*8, Dimension(:,:), Allocatable:: Vec
      Logical Iterate, Restart
      Real*8 Lambda
*
      UpMeth='RS-RFO'
      Lu=6
*#define _DEBUGPRINT_
*#define _DEBUG2_
#ifdef _DEBUGPRINT_
      Call RecPrt(' In RS_RFO: H',' ',H,nInter,nInter)
      Call RecPrt(' In RS_RFO: g',' ', g,nInter,1)
      Call RecPrt(' In RS_RFO: q',' ', q,nInter,1)
      Write (Lu,*) 'Trust radius=',StepMax
*
      Write (Lu,*)
      Write (Lu,*) 'RS-RF Optimization'
      Write (Lu,*) ' Iter   alpha          dqdq    StepMax     EigVal'
#endif
*
      A_RFO=One   ! Initial seed of alpha
      IterMx=25
      Iter=0
      Iterate=.False.
      Restart=.False.
      NumVal=Min(6,nInter)+1
      Call mma_allocate(Vec,(nInter+1),NumVal,Label='Vec')
      Call mma_allocate(Val,NumVal,Label='Val')
      Call mma_allocate(Matrix,(nInter+1)*(nInter+2)/2,Label='Matrix')
      Call mma_allocate(Tmp,nInter+1,Label='Tmp')
*
      Vec(:,:)=0.0D0
      Tmp(:)=0.0
 998  Continue
         Iter=Iter+1
#ifdef _DEBUG2_
         Write (Lu,*) 'Iter=',Iter
         Write (Lu,*) 'A_RFO=',A_RFO
#endif
*                                                                      *
************************************************************************
*                                                                      *
*        Execute step 1 of page 266                                    *
*                                                                      *
************************************************************************
*                                                                      *
*        Set up the augmented Hessian of Eq. (2)
*
*        Assume that the S-matrix is trivially diagonal
*
         Do i = 1, nInter
            Do j = 1, i
               ij = i*(i-1)/2 + j
               Matrix(ij)=Half*(H(i,j)+H(j,i))/A_RFO
            End Do
         End Do
         j=  nInter+1
         Do i = 1, nInter
            ij = j*(j-1)/2 + i
            Matrix(ij)=-g(i)/Sqrt(A_RFO) ! note sign
         End Do
         jj = j*(j+1)/2
         Matrix(jj)=Zero
#ifdef _DEBUG2_
         Call TriPrt('R_Tri',' ',Matrix,nInter+1)
#endif
*
*        Restore the vector from the previous iteration, if any
         call dcopy_(nInter+1,Tmp(1),1,Vec(1,1),1)
         Call Davidson(Matrix,nInter+1,NumVal,Val,Vec,iStatus)
         If (iStatus.gt.0) Then
           Call SysWarnMsg('RS_RFO',
     &       'Davidson procedure did not converge','')
         End If
*
*        Pick up the root which represents the shortest displacement.
*
#ifdef _DEBUGPRINT_
*        Call RecPrt('Val',' ',Val,1,NumVal)
*        Call RecPrt('Vec',' ',Vec,nInter+1,NumVal)
#endif
         iRoot=-1
         Dist=1.0D99
         Do iVal = 1, NumVal
            If (Vec(nInter+1,iVal).eq.0.0D0) Cycle
            VV=DDot_(nInter,Vec(1,iVal),1,Vec(1,iVal),1)
            ZZ = VV/A_RFO + Vec(nInter+1,iVal)**2
            Fact=Vec(nInter+1,iVal)/Sqrt(ZZ)
            dqdq=VV/(A_RFO*Fact**2*ZZ)
#ifdef _DEBUGPRINT_
*           Write (6,*)
*           Write (6,*) 'iVal,A_RFO=',iVal,A_RFO
*           Write (6,*) 'ZZ=',ZZ
*           Write (6,*) 'Fact=',Fact
*           Write (6,*) 'dqdq=',dqdq
#endif
            If (dqdq.lt.Dist) Then
               iRoot=iVal
               Dist=dqdq
            End If
         End Do
         If (iRoot.eq.-1) Then
            Write (6,*)
            Write (6,*) 'RS-RFO: Illegal iroot value!'
            Call Abend()
         End If
         call dcopy_(nInter+1,Vec(1,iRoot),1,Tmp,1)
         Call DScal_(nInter,One/Sqrt(A_RFO),Vec(1,iRoot),1)
*                                                                      *
************************************************************************
*                                                                      *
*        Execute step 2 on page 266                                    *
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUG2_
         Write (Lu,*) ' RF eigenvalue=',Val
#endif
         ZZ=DDot_(nInter+1,Vec(1,iRoot),1,Vec(1,iRoot),1)
         Call DScal_(nInter+1,One/Sqrt(ZZ),Vec(1,iRoot),1)
*                                                                      *
************************************************************************
*                                                                      *
*       Execute step 3 of page 266                                     *
*                                                                      *
************************************************************************
*                                                                      *
*        Copy v^k_{n,i}
*
         call dcopy_(nInter,Vec(1,iRoot),1,dq,1)
*
*        Pick v^k_{1,i}
*
         Fact=Vec(nInter+1,iRoot)
#ifdef _DEBUG2_
         Write (Lu,*) 'v^k_{1,i}=',Fact
#endif
*
*        Normalize according to Eq. (5)
*
         Call DScal_(nInter,One/Fact,dq,1)
#ifdef _DEBUGPRINT_
*           Write (6,*)
*           Write (6,*) 'iRoot=',iRoot
*           Write (6,*) 'ZZ=',ZZ
*           Write (6,*) 'Fact=',Fact
*           Write (6,*) 'dqdq=',Restriction(q,dq,nInter)
#endif
*
*        Compute lambda_i according to Eq. (8a)
*
         EigVal=-DDot_(nInter,dq,1,g,1) ! note sign
         Lambda = EigVal
*
*        Compute R^2 according to Eq. (8c)
*
         dqdq=Sqrt(DDot_(nInter,dq,1,dq,1))
#ifdef _DEBUGPRINT_
         Write (Lu,'(I5,5(E12.5,1x))') Iter,A_RFO,dqdq,StepMax,EigVal
*        Write (Lu,*) 'StepMax-dqdq=',StepMax-dqdq
*        Write (Lu,*) 'Thr_RS=',Thr_RS
#endif
*                                                                      *
************************************************************************
*                                                                      *
*------- Initialize data for iterative scheme (only at first iteration)
*
         If (.Not.Iterate.Or.Restart) Then
            A_RFO_long=A_RFO
            dqdq_long=dqdq
            A_RFO_short=Zero
            dqdq_short=dqdq_long+One
         End If
*                                                                      *
************************************************************************
*                                                                      *
*------- RF with constraints. Start iteration scheme if computed step
*        is too long.
*
         If ((Iter.eq.1.or.Restart).and.dqdq.gt.StepMax) Then
            Iterate=.True.
            Restart=.False.
         End If
*                                                                      *
************************************************************************
*                                                                      *
*        Procedure if the step length is not equal to the trust radius
*
         If (Iterate.and.Abs(StepMax-dqdq).gt.Thr_RS) Then
            Step_Trunc='*'
#ifdef _DEBUG2_
            Write (Lu,*) 'StepMax-dqdq=',StepMax-dqdq
#endif
*
*           Converge if small interval
*
            If ((dqdq.lt.StepMax).and.
     &          (Abs(A_RFO_long-A_RFO_short).lt.Thr_RS)) Go To 997
            Call Find_RFO_Root(A_RFO_long,dqdq_long,
     &                         A_RFO_short,dqdq_short,
     &                         A_RFO,dqdq,StepMax)
            If (A_RFO.eq.-One) Then
*              Write (Lu,*) 'reset Step_Trunc'
               A_RFO=One
               Step_Trunc=' '
               Restart=.True.
               Iterate=.False.
            End If
            If (Iter.gt.IterMx) Then
               Write (Lu,*) ' Too many iterations in RF'
               Go To 997
            End If
            Go To 998
         End If
*
 997  Continue
      Call mma_deallocate(Tmp)
      dqHdq=dqHdq+EigVal*Half
#ifdef _DEBUGPRINT_
      Write (Lu,*)
      Write (Lu,*) 'Rational Function Optimization, Lambda=',EigVal
      Write (Lu,*)
      Write (Lu,*) 'EigVal,dqHdq=',EigVal,dqHdq
      Call RecPrt(' In RS_RFO: g',' ', g,nInter,1)
      Call RecPrt(' In RS_RFO:dq',' ',dq,nInter,1)
#endif
#define _CHECK_UPDATE_
#ifdef _CHECK_UPDATE_
      Thr_Check=1.0D2
      Do i = 1, nInter
         If (ABS(dq(i)).gt.Thr_Check) Then
            Write (6,*) 'RS_RFO: ABS(dq(i)).gt.Thr_Check'
            Write (6,*) '        Probably an error.'
            Call Abend()
         End If
      End Do
#endif
*
      Call mma_deallocate(Vec)
      Call mma_deallocate(Val)
      Call mma_deallocate(Matrix)
*     Write (6,*) 'dqdq=',dqdq,dqdq**2
*     Write (6,*) 'StepMax=',StepMax,StepMax**2
*     Write (Lu,*) 'StepMax-dqdq=',StepMax-dqdq
*     Write (Lu,*) dqdq.lt.StepMax
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CI_KAP(ipcid,fock,fockOut,isym)
*     use ipPage, only: W
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
#include "dmrginfo_mclr.fh"
      Real*8 Fock(*),FockOut(*)
      Real*8, Allocatable:: De(:), Pe(:)

! Added for DMRG calculation
      real*8,allocatable::tmpDe(:,:),tmpP(:),tmpDeM(:,:),tmpPM(:,:,:,:)


      itri(i,j)=Max(i,j)*(Max(i,j)-1)/2+Min(i,j)

      irc=ipnout(-1)
      Call mma_allocate(De,ntash**2,Label='De')
      Call mma_allocate(Pe,n2dens,Label='Pe')

      Call CIDens_SA(.true.,ipCI,ipCid,State_sym,State_Sym,Pe,De)

! ====================================================================
      If(doDMRG)then
        call dmrg_dim_change_mclr(LRras2(1:8),ntash,0)
        call dmrg_dim_change_mclr(RGras2(1:8),ndim,0)

        Call mma_allocate(tmpDe,ndim,ndim,Label='tmpDe')
        Call mma_allocate(tmpP,ndim**2*(ndim**2+1)/2,Label='tmpP')
        Call mma_allocate(tmpDeM,ntash,ntash,Label='tmpDeM')
        Call mma_allocate(tmpPM,ntash,ntash,ntash,ntash,Label='tmpPM')
        tmpDe(:,:)=0.0d0
        tmpP(:)=0.0d0
        tmpDeM(:,:)=0.0d0
        tmpPM(:,:,:,:)=0.0d0

        ij=0
        do i=1,ntash
          do j=1,ntash
            ij=ij+1
            if(abs(De(ij)).lt.1.0e-12)then
              De(ij)=0.0d0
            end if
            tmpDeM(i,j)=De(ij)
          end do
        end do

        ij=0
        do i=1,ndim
          do j=1,ndim
            ij=ij+1
            if(i.gt.ntash.or.j.gt.ntash)then
              tmpDe(i,j)=0.0d0
            else
              tmpDe(i,j)=tmpDeM(i,j)
            end if
          end do
        end do

        Do i=1,ntash
          Do j=1,ntash
            Do k=1,ntash
              Do l=1,ntash
                ij1=ntash*(i-1)+j
                kl1=ntash*(k-1)+l
                if(ij1.ge.kl1)then
                  if(abs(Pe(itri(ij1,kl1))).lt.1.0e-12)then
                    Pe(itri(ij1,kl1))=0.0d0
                  end if
                  tmpPM(i,j,k,l)=Pe(itri(ij1,kl1))
                end if
              End Do
            End Do
          End Do
        End Do

        do i=1,ndim
          do j=1,ndim
            do k=1,ndim
              do l=1,ndim
                ij1=ndim*(i-1)+j
                kl1=ndim*(k-1)+l
                if(ij1.ge.kl1)then
            if(i.gt.ntash.or.j.gt.ntash.or.k.gt.ntash.or.l.gt.ntash)then
                  tmpP(itri(ij1,kl1))=0.0d0
                else
                  tmpP(itri(ij1,kl1))=tmpPM(i,j,k,l)
                end if
                end if
              end do
            end do
          end do
        end do

! ====================================================================
        call dmrg_dim_change_mclr(RGras2(1:8),ntash,0)
        call dmrg_dim_change_mclr(RGras2(1:8),nna,0)

*       irc=ipin(ipCID)
*       irc=ipin(ipci)
*       call projecter(W(ipCID)%Vec,W(ipci)%Vec,De,Pe)
        call dcopy_(ndens2,[0.0d0],0,Fock,1)
        call dcopy_(ndens2,[0.0d0],0,FockOut,1)
        d0=0.0d0

        Call FockGen(d0,tmpDe,tmpP,Fock,FockOut,isym) ! yma modified

      else

*
*       irc=ipin(ipCID)
*       irc=ipin(ipci)
*       call projecter(W(ipCID)%Vec,W(ipci)%Vec,De,Pe)
        call dcopy_(ndens2,[0.0d0],0,Fock,1)
        call dcopy_(ndens2,[0.0d0],0,FockOut,1)
        d0=0.0d0
        Call FockGen(d0,De,Pe,Fock,FockOut,isym)
      end if
      Call mma_deallocate(De)
      Call mma_deallocate(Pe)

! ===================================================================
      if(doDMRG)then  !yma
        call dmrg_dim_change_mclr(LRras2(1:8),nna,0)
        call dmrg_dim_change_mclr(LRras2(1:8),ntash,0)
        Call mma_deallocate(tmpDe)
        Call mma_deallocate(tmpDeM)
        Call mma_deallocate(tmpP)
        Call mma_deallocate(tmpPM)
      end if
! ===================================================================

      return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      end

#ifdef _NOTUSED_
      Subroutine Projecter(CID,CI,D,P)
      Implicit Real*8(a-h,o-z)

#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
      Real*8 CI(*),CID(*),P(*),D(*)
      Real*8, Allocatable:: De(:), Pe(:)

      Call mma_allocate(De,ntash**2,Label='De')
      Call mma_allocate(Pe,n2dens,Label='Pe')
      Do i=0,nroots-1
       Do j=0,nroots-1
        r=ddot_(nconf1,ci(1+nconf1*i),1,
     &                   cid(1+nconf1*j),1)
        Call CIDENS2(ci(1+nconf1*i),
     &               ci(1+nconf1*j),State_sym,State_sym,Pe,De)
       call daxpy_(ntash**2,-r*weight(1+i),De,1,d,1)
       call daxpy_(n2dens,-r*weight(1+i),Pe,1,p,1)
       End Do
      End Do
      Call mma_deallocate(Pe)
      Call mma_deallocate(De)
      Return
      End
#endif

!**********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2023, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on Oct. 20, 2023, created this file.               *
!*****************************************************************

subroutine CheckFuncParam(FileExtParam)

use Functionals, only: check_n_ext_params
use libxc_parameters, only: FuncExtParams, lExtParams
use Constants, only: Zero
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
character(len=128), intent(in) :: FileExtParam
integer(kind=iwp) :: iFunc, istat, LUFile, MaxParam, NFuncs
integer(kind=iwp), allocatable :: nParam(:)
integer(kind=iwp), external :: IsFreeUnit

LUFile = IsFreeUnit(100)
call Molcas_Open(LUFile,FileExtParam)

read(LUFile,*,iostat=istat) NFuncs
if (istat /= 0) then
  call WarningMessage(2,'Error Reading NFuncs in External Parameter File!')
  call Quit_OnUserError()
end if

call mma_allocate(nParam,nFuncs)
read(LUFile,*,iostat=istat) NParam(:)
if (istat /= 0) then
  call WarningMessage(2,'Error Reading NParam in External Parameter File!')
  call Quit_OnUserError()
end if

MaxParam = maxval(NParam(:))
call mma_allocate(FuncExtParams,MaxParam,nFuncs)
FuncExtParams(:,:) = Zero
do iFunc=1,nFuncs
  read(LUFile,*,iostat=istat) FuncExtParams(1:nParam(iFunc),iFunc)
  if (istat /= 0) then
    call WarningMessage(2,'Error Reading Parameters in Ext Param File!')
    call Quit_OnUserError()
  end if
end do
close(LUFile)

call check_n_ext_params(nFuncs,nParam)

lExtParams = .true.
!call mma_deallocate(FuncExtParams) !It will be freed in Set_External_Params.
call mma_deallocate(nParam)

end subroutine CheckFuncParam

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SOG(N,SS,SINV,P,G,A1)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION SS(N*(N+1)/2),P(N*(N+1)/2),G(N*(N+1)/2),A1(N),SINV(N,N)
C
C     SUBROUTINE TO CALCULATE TRANSFORMATION TO SCHMIDT-
C     ORTHOGONALIZED BASIS.
C     N              DIMENSION OF MATRICES. ISIZE=N*(N+1)/2
C     SS(ISIZE)      ORIGINAL OVERLAP MATRIX (LOWER TRIANGULAR)
C                    WILL NOT BE DESTROYED
C     P (ISIZE)      OUTPUT TRANSFORMATION MATRIX
C     G (ISIZE)      SCRATCH
C     A1(N)          SCRATCH
C
      JL=0
      IQ=0
      DO 340 J=1,N
         IL=JL
         JQ=IQ
         S1KK=SS(IQ+J)
         G(IL+J)=1.D0
         IF(J.EQ.1)GO TO 341
         J1=J-1
         JL=0
         DO 342 K=1,J1
            LG=JQ
            ETOT=0.D0
            DO 343 L=1,K
               LG=LG+1
               JL=JL+1
               ETOT=ETOT+SS(LG)*G(JL)
  343       CONTINUE
            S1KK=S1KK-ETOT*ETOT
            A1(K)=ETOT
  342    CONTINUE
         IF=1
         JL=IL
         DO 344 K=1,J1
         SUM=0.D0
         JL=JL+1
         IF=IF+K-1
         IH=IF
         DO 345 L=K,J1
         IH=IH+L-1
         SUM=SUM+A1(L)*G(IH)
  345    CONTINUE
         G(JL)=-SUM
  344    CONTINUE
  341    S1KK=1.D0/sqrt(S1KK)
         JL=IL
         DO 346 K=1,J
         JL=JL+1
         IQ=IQ+1
         G(JL)=G(JL)*S1KK
         P(IQ)=G(JL)
  346    CONTINUE
  340 CONTINUE
*
      IJ=0
      DO 1 I=1,N
         DO 2 J=1,I
            IJ=IJ+1
            SINV(I,J)=0.D0
            SINV(J,I)=P(IJ)
2        CONTINUE
1     CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRAONE(CMO,NCMO,HONE,nHONE)
! Objective: Transformation of one-electron integrals
! (effective one electron Hamiltonian) for CASPT2.

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use PrintLevel, only: VERBOSE
use caspt2_global, only: iPrGlb
use caspt2_module, only: ERFSELF, nBas, nBMX, nBSqT, nBTri, nDel, nFro, nFroT, nOrb, nOTri, nSym, PotNuc, RFPert
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: NCMO, nHONE
real(kind=wp), intent(in) :: CMO(NCMO)
real(kind=wp), intent(inout) :: HONE(nHONE)
integer(kind=iwp) :: I, iAO, IB, ICMO, ICOMP, IERR, IFTEST, IJ, IMO, IOFF, IOPT, IRC, ISTLT, ISTMO, ISTSQ, ISYLBL, ISYM, Keep(8), &
                     NB, nBasXX(8), NF, NSYMXX, nTemp, NWTMP
real(kind=wp) :: ECORE, EONE, ETWO, ExFac
logical(kind=iwp) :: Found, iSquar
character(len=8) :: Label
real(kind=wp), allocatable :: Temp(:), WDLT(:), WDSQ(:), WFLT(:), WFMO(:), WTMP(:)
real(kind=wp), external :: DDot_
#include "warnings.h"

#ifdef _DEBUGPRINT_
IFTEST = 1
#else
IFTEST = 0
#endif

call GetOrd(IRC,iSquar,nSymXX,nBasXX,Keep)
if (IPRGLB >= VERBOSE) then
  if (iSquar) then
    write(u6,*) 'TRAONE OrdInt status: squared'
  else
    write(u6,*) 'TRAONE OrdInt status: non-squared'
  end if
end if
if (any(NBAS(1:NSYM) /= NBASXX(1:NSYM))) then
  IERR = 1
else
  IERR = 0
end if
if (IERR /= 0) then
  write(u6,*) '     *** ERROR IN SUBROUTINE TRAONE ***'
  write(u6,*) '          INCOMPATIBLE BASIS DATA'
  write(u6,*)
  write(u6,*) ' JOBIPH NR OF SYMM:',NSYM
  write(u6,*) ' JOBIPH NR OF BASIS FUNCTIONS/SYMM:'
  write(u6,'(1x,8I5)') (NBAS(I),I=1,NSYM)
  write(u6,*)
  write(u6,*) ' ORDINT NR OF SYMM:',NSYMXX
  write(u6,*) ' ORDINT NR OF BASIS FUNCTIONS/SYMM:'
  write(u6,'(1x,8I5)') (NBASXX(I),I=1,NSYMXX)
  call ABEND()
end if
! Allocate FLT,DLT, and DSQ.
call mma_allocate(WFLT,NBTRI,Label='WFLT')
! Read nuclear repulsion energy:
IRC = -1
IOPT = 0
ICOMP = 0
ISYLBL = 1
if (IFTEST /= 0) write(u6,*) ' GET POTNUC FROM RUNFILE'
call Get_dScalar('PotNuc',PotNuc)
if (IFTEST /= 0) write(u6,*) ' POTNUC:',POTNUC
! Read one-electron hamiltonian matrix into FLT.
IRC = -1
IOPT = ibset(ibset(0,sNoOri),sNoNuc)
ICOMP = 1
ISYLBL = 1
Label = 'OneHam'
if (IFTEST /= 0) write(u6,*) ' CALLING RDONE (ONEHAM)'
call RDONE(IRC,IOPT,Label,ICOMP,WFLT,ISYLBL)
if (IFTEST /= 0) write(u6,*) ' BACK FROM RDONE'
if (IRC /= 0) then
  write(u6,*) 'TRAONE Error: RDONE failed reading OneHam.'
  call Quit(_RC_IO_ERROR_READ_)
end if

if (IFTEST /= 0) then
  write(u6,*) '     TEST PRINTS FROM TRAONE.'
  write(u6,*) '     NAKED 1-EL HAMILTONIAN IN AO BASIS'
  ISTLT = 1
  do ISYM=1,NSYM
    if (NBAS(ISYM) > 0) then
      write(u6,'(6X,A,I2)') ' SYMMETRY SPECIES:',ISYM
      call TRIPRT(' ',' ',WFLT(ISTLT),NBAS(ISYM))
      ISTLT = ISTLT+nTri_Elem(NBAS(ISYM))
    end if
  end do
end if

! If this is a perturbative reaction field calculation then
! modifiy the one-electron Hamiltonian by the reaction field and
! the nuclear attraction by the cavity self-energy

if (RFpert) then
  nTemp = sum(nTri_Elem(nBas(1:nSym)))
  call mma_allocate(Temp,nTemp,Label='Temp')

  call f_Inquire('RUNOLD',Found)
  if (Found) call NameRun('RUNOLD')
  call Get_dScalar('RF Self Energy',ERFSelf)
  call Get_dArray('Reaction field',Temp,nTemp)
  if (Found) call NameRun('#Pop')
  PotNuc = PotNuc+ERFself
  WFLT(1:nTemp) = WFLT(1:nTemp)+Temp(:)

  call mma_deallocate(Temp)
  if (IFTEST /= 0) then
    write(u6,*) ' 1-EL HAMILTONIAN INCLUDING REACTION FIELD'
    ISTLT = 1
    do ISYM=1,NSYM
      if (NBAS(ISYM) > 0) then
        write(u6,'(6X,A,I2)') ' SYMMETRY SPECIES:',ISYM
        call TRIPRT(' ',' ',WFLT(ISTLT),NBAS(ISYM))
        ISTLT = ISTLT+nTri_Elem(NBAS(ISYM))
      end if
    end do
  end if
end if

EONE = Zero
ETWO = Zero
! The following section is needed for frozen orbitals:
if (NFROT /= 0) then
  call mma_allocate(WDLT,NBTRI,LABEL='WDLT')
  call mma_allocate(WDSQ,NBSQT,LABEL='WDSQ')
  ! Compute the density matrix of the frozen orbitals
  ! The DLT matrix contains the same data as DSQ, but
  ! with symmetry blocks in lower triangular format, and
  ! with non-diagonal elements doubled.
  WDLT(:) = Zero
  WDSQ(:) = Zero
  ISTMO = 1
  ISTSQ = 1
  ISTLT = 1
  do ISYM=1,NSYM
    NF = NFRO(ISYM)
    NB = NBAS(ISYM)
    if (NB*NF > 0) then
      call DGEMM_('N','T',NB,NB,NF,Two,CMO(ISTMO),NB,CMO(ISTMO),NB,Zero,WDSQ(ISTSQ),NB)
      IJ = ISTLT-1
      do IB=1,NB
        WDLT(IJ+1:IJ+IB) = Two*WDSQ(ISTSQ+(IB-1)*NB:ISTSQ+(IB-1)*NB+IB-1)
        IJ = IJ+IB
        WDLT(IJ) = Half*WDLT(IJ)
      end do
    end if
    ISTMO = ISTMO+NB**2
    ISTSQ = ISTSQ+NB**2
    ISTLT = ISTLT+nTri_Elem(NB)
  end do

  ! One-electron contribution to the core energy.
  ! Note that FLT still contains only the naked
  !  one-electron hamiltonian.
  EONE = DDOT_(NBTRI,WDLT,1,WFLT,1)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Generate Fock-matrix for frozen orbitals
  ! and compute the total core energy
  ! Look out-- we temporarily allocate all available memory.

  ExFac = One
  call FTwo_Drv(nSym,nBas,nFro,KEEP,WDLT,WDSQ,WFLT,NBTRI,ExFac,nBMX,CMO)

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute the two-electron contribution to the core energy
  ETWO = Half*(DDOT_(NBTRI,WDLT,1,WFLT,1)-EONE)
  call mma_deallocate(WDSQ)
  call mma_deallocate(WDLT)
  ! Previous section was bypassed if NFROT == 0.
end if

ECORE = POTNUC+EONE+ETWO
if (IFTEST /= 0) then
  write(u6,'(6X,A,ES20.10)') 'NUCLEAR REPULSION ENERGY:',POTNUC
  write(u6,'(6X,A,ES20.10)') 'ONE-ELECTRON CORE ENERGY:',EONE
  write(u6,'(6X,A,ES20.10)') 'TWO-ELECTRON CORE ENERGY:',ETWO
  write(u6,'(6X,A,ES20.10)') '       TOTAL CORE ENERGY:',ECORE
end if

! Allocate FMO, TMP:
NWTMP = 2*NBMX**2
call mma_allocate(WFMO,notri,LABEL='WFMO')
call mma_allocate(WTMP,NWTMP,LABEL='WTMP')

! Transform one-electron effective Hamiltonian:
WFMO(:) = Zero
WTMP(:) = Zero
ICMO = 1
IAO = 1
IMO = 1
do ISYM=1,NSYM
  ICMO = ICMO+NBAS(ISYM)*NFRO(ISYM)
  IOFF = 1+NBAS(ISYM)*NBAS(ISYM)
  if (NORB(ISYM) > 0) then
    call SQUARE(WFLT(IAO),WTMP,1,NBAS(ISYM),NBAS(ISYM))

    call DGEMM_('T','N',NORB(ISYM),NBAS(ISYM),NBAS(ISYM),One,CMO(ICMO),NBAS(ISYM),WTMP,NBAS(ISYM),Zero,WTMP(IOFF),NORB(ISYM))

    call DGEMM_Tri('N','N',NORB(ISYM),NORB(ISYM),NBAS(ISYM),One,WTMP(IOFF),NORB(ISYM),CMO(ICMO),NBAS(ISYM),Zero,WFMO(IMO), &
                   NORB(ISYM))
  end if
  ICMO = ICMO+NBAS(ISYM)*(NORB(ISYM)+NDEL(ISYM))
  IAO = IAO+nTri_Elem(NBAS(ISYM))
  IMO = IMO+nTri_Elem(NORB(ISYM))
end do

if (IFTEST /= 0) then
  write(u6,*) '      EFFECTIVE 1-EL HAMILTONIAN IN MO BASIS'
  ISTLT = 1
  do ISYM=1,NSYM
    if (NORB(ISYM) > 0) then
      write(u6,'(6X,A,I2)') ' SYMMETRY SPECIES:',ISYM
      call TRIPRT(' ',' ',WFMO(ISTLT),NORB(ISYM))
      ISTLT = ISTLT+nTri_Elem(NORB(ISYM))
    end if
  end do
end if

HONE(:) = Zero
HONE(1:NoTri) = WFMO(:)

call mma_deallocate(WTMP)
call mma_deallocate(WFMO)
call mma_deallocate(WFLT)

end subroutine TRAONE

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_RstD_ChkSP2F(iSP2F,l_iSP2F,nErr)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: l_iSP2F, iSP2F(l_iSP2F)
integer(kind=iwp), intent(out) :: nErr
integer(kind=iwp) :: i
integer(kind=iwp), allocatable :: iChk(:)

call mma_allocate(iChk,l_iSP2F,Label='iChk')

call Cho_RstD_GetInd3(iChk,l_iSP2F)

nErr = 0
do i=1,l_iSP2F
  if (iChk(i) /= iSP2F(i)) nErr = nErr+1
end do

call mma_deallocate(iChk)

end subroutine Cho_RstD_ChkSP2F

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990-1992,1999, Roland Lindh                           *
************************************************************************
      Subroutine V_EF_PCM(nAt,nTs,DoPot,DoFld,AtmC,Tessera,V,EF_n,EF_e)
      Implicit Real*8 (a-h,o-z)
      Dimension AtmC(3,nAt)
      Dimension V(*),EF_n(3,*),EF_e(3,*),Tessera(4,*)
      Logical DoPot, DoFld
*
*---- Compute potential on tesserae
*
      If(DoPot) then
        Call FZero(V,nTs)
        nOrdOp = 0
        Call Mlt_PCM(nAt,nTs,nOrdOp,Tessera,AtmC,V,EF_n,EF_e)
      EndIf
*
*---- Compute electric field on tesserae
*
      If(DoFld) then
        Call FZero(EF_n,3*nTs)
        Call FZero(EF_e,3*nTs)
        nOrdOp = 1
        Call Mlt_PCM(nAt,nTs,nOrdOp,Tessera,AtmC,V,EF_n,EF_e)
      EndIf
      Return
      End
c----------------------------------------------------------------------
      Subroutine Mlt_PCM(nAt,nTs,nOrdOp,Tessera,AtmC,V,EF_n,EF_e)
      Implicit Real*8 (A-H,O-Z)
      Dimension V(*),EF_n(3,*),EF_e(3,*)
      Dimension Tessera(4,*)
      Dimension AtmC(3,*)
#include "real.fh"
#include "print.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
      Real*8 Temp(3)
      Real*8, Allocatable :: Chrg(:)
      Logical Found
      Real*8, Allocatable :: D1ao(:)
*                                                                      *
      Call mma_allocate(Chrg,nat)
      Call Get_dArray('Nuclear charge',Chrg,nAt)
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the desired multipole on the tiles
*
*     1) The nuclear contribution
*
      Do iTs = 1, nTs
         Call EFNuc(Tessera(1,iTs),Chrg,AtmC,nAt,Temp,nOrdOp)
         If(nOrdOp.eq.0) then
           V(iTs) = Temp(1)
         ElseIf(nOrdOp.eq.1) then
           EF_n(1,iTs) = Temp(1)
           EF_n(2,iTs) = Temp(2)
           EF_n(3,iTs) = Temp(3)
         EndIf
      End Do
*
      Call mma_deallocate(Chrg)
*
*     2) The electronic contribution
*
*
*     Get the total 1st order AO density matrix
*
      Call Qpg_dArray('D1ao',Found,nDens)
      If (Found .and. nDens/=0) Then
         Call mma_allocate(D1ao,nDens,Label='D1ao')
      Else
         Write (6,*) 'Mlt_pcm: D1ao not found.'
         Call Abend()
      End If
      Call Get_D1ao(D1ao,nDens)
*
      Call Allocate_Work(ipFactOp,nTs)
      Call Allocate_iWork(iplOper,nTs)
      call dcopy_(nTs,[One],0,Work(ipFactOp),1)
      Call ICopy(nTs,[255],0,iWork(iplOper),1)
*
      Call drv_ef_PCM(Work(ipFactOp),nTs,D1ao,nDens,
     &              Tessera,iWork(iplOper),
     &              EF_e,nOrdOp)
      If(nOrdOp.eq.0) then
        Do iTs = 1, nTs
          V(iTs) = Ef_e(1,iTs)
        EndDo
      EndIf
*
      Call Free_iWork(iplOper)
      Call Free_Work(ipFactOp)
      Call mma_deallocate(D1ao)
*
      Return
      End
*------------------------------------------------------------------------
      SubRoutine drv_ef_PCM(FactOp,nTs,FD,nFD,CCoor,lOper,VTessera,
     &                       nOrdOp)
************************************************************************
*                                                                      *
* Object: to compute the local multipole moment, desymmetrize the 1st  *
*         order density matrix and accumulate contributions to the     *
*         global multipole expansion.                                  *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January '90                                              *
*             Modified for Hermite-Gauss quadrature November '90       *
*             Modified for Rys quadrature November '90                 *
*             Modified for multipole moments November '90              *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified for general kernel routines January  91         *
*             Modified for nonsymmetrical operators February  91       *
*             Modified for gradients October  91                       *
*             Modified for reaction field calculations July  92        *
*             Modified loop structure  99                              *
************************************************************************
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only: S
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "angtp.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "nsd.fh"
#include "setup.fh"
      Real*8 A(3), B(3), C(3), FD(nFD), FactOp(nTs), CCoor(4,nTs),
     &       RB(3), TRB(3), TA(3), VTessera(3,nTs)
      Character ChOper(0:7)*3
      Integer   lOper(nTs), iStabO(0:7),
     &          iDCRR(0:7), iDCRT(0:7), iStabM(0:7), nOp(3)
      Logical AeqB
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement functions
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      iRout = 112
      iPrint = nPrint(iRout)
*
      iIrrep = 0
*
*     Auxiliary memory allocation.
*
      Call GetMem('Zeta','ALLO','REAL',iZeta,S%m2Max)
      Call GetMem('Zeta','ALLO','REAL',ipZI ,S%m2Max)
      Call GetMem('Kappa','ALLO','REAL',iKappa,S%m2Max)
      Call GetMem('PCoor','ALLO','REAL',iPCoor,S%m2Max*3)
*                                                                      *
************************************************************************
*                                                                      *
      Call Nr_Shells(nSkal)
*                                                                      *
************************************************************************
*                                                                      *
*-----Double loop over shells. These loops decide the integral type
*
      Do iS = 1, nSkal
         iShll  = iSD( 0,iS)
         iAng   = iSD( 1,iS)
         iCmp   = iSD( 2,iS)
         iBas   = iSD( 3,iS)
         iPrim  = iSD( 5,iS)
         iAO    = iSD( 7,iS)
         mdci   = iSD(10,iS)
         iShell = iSD(11,iS)
         iCnttp = iSD(13,iS)
         iCnt   = iSD(14,iS)
         A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
         Do jS = 1, iS
            jShll  = iSD( 0,jS)
            jAng   = iSD( 1,jS)
            jCmp   = iSD( 2,jS)
            jBas   = iSD( 3,jS)
            jPrim  = iSD( 5,jS)
            jAO    = iSD( 7,jS)
            mdcj   = iSD(10,jS)
            jShell = iSD(11,jS)
            jCnttp = iSD(13,jS)
            jCnt   = iSD(14,jS)
            B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
            iSmLbl = 1
            nSO = MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
            If (nSO.eq.0) Go To 131
            If (iPrint.ge.19) Write (6,'(A,A,A,A,A)')
     &        ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
*
*           Call kernel routine to get memory requirement.
*
            Call EFMmP(nOrder,MemKer,iAng,jAng,nOrdOp)
*           Write (*,*)nOrder,MemKer,iAng,jAng,nOrdOp
            MemKrn=MemKer*S%m2Max
            Call GetMem('Kernel','ALLO','REAL',iKern,MemKrn)
*
*           Allocate memory for the final integrals, all in the
*           primitive basis.
*
            nComp = (nOrdOp+1)*(nOrdOp+2)/2
            lFinal = S%MaxPrm(iAng) * S%MaxPrm(jAng)
     &             * nElem(iAng)*nElem(jAng)
     &             * nComp
            Call GetMem('Final','ALLO','REAL',ipFnl,lFinal)
*
*           Scratch area for contraction step
*
            nScr1 =  S%MaxPrm(iAng)*S%MaxPrm(jAng) *
     &               nElem(iAng)*nElem(jAng)
            Call GetMem('Scrtch','ALLO','REAL',iScrt1,nScr1)
*
*           Scratch area for the transformation to spherical gaussians
*
            nScr2=S%MaxPrm(iAng)*S%MaxPrm(jAng)*nElem(iAng)*nElem(jAng)
            Call GetMem('ScrSph','Allo','Real',iScrt2,nScr2)
*
            nDAO =iPrim*jPrim*nElem(iAng)*nElem(jAng)
            Call GetMem(' DAO ','Allo','Real',ipDAO,nDAO)
*
*           At this point we can compute Zeta.
*
            Call ZXia(Work(iZeta),Work(ipZI),
     &                iPrim,jPrim,Shells(iShll)%Exp,
     &                            Shells(jShll)%Exp)
*
            AeqB = iS.eq.jS
*
*           Find the DCR for A and B
*
            Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &                     dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
            If (iPrint.ge.49) Write (6,'(10A)')
     &         ' {R}=(',(ChOper(iDCRR(i)),i=0,nDCRR-1),')'
*
*-----------Find the stabilizer for A and B
*
            Call Inter(dc(mdci)%iStab,dc(mdci)%nStab,
     &                 dc(mdcj)%iStab,dc(mdcj)%nStab,
     &                 iStabM,nStabM)
*
*           Allocate memory for the elements of the Fock or 1st order
*           denisty matrix which are associated with the current shell
*           pair.
*
            Call GetMem('DSOpr ','ALLO','REAL',ipDSOp,nSO*iPrim*jPrim)
            Call GetMem('DSO ','ALLO','REAL',ipDSO,nSO*iPrim*jPrim)
*
*           Gather the elements from 1st order density / Fock matrix.
*
            Call SOGthr(Work(ipDSO),iBas,jBas,nSO,FD,
     &                  n2Tri(iSmLbl),iSmLbl,
     &                  iCmp,jCmp,iShell,jShell,
     &                  AeqB,iAO,jAO)
*
*           Project the Fock/1st order density matrix in AO
*           basis on to the primitive basis.
*
            If (iPrint.ge.99) Then
               Call RecPrt(' Left side contraction',' ',
     &                     Shells(iShll)%pCff,iPrim,iBas)
               Call RecPrt(' Right side contraction',' ',
     &                     Shells(jShll)%pCff,jPrim,jBas)
            End If
*
*           Transform IJ,AB to J,ABi
            Call DGEMM_('T','T',
     &                  jBas*nSO,iPrim,iBas,
     &                  1.0d0,Work(ipDSO),iBas,
     &                        Shells(iShll)%pCff,iPrim,
     &                  0.0d0,Work(ipDSOp),jBas*nSO)
*           Transform J,ABi to AB,ij
            Call DGEMM_('T','T',
     &                  nSO*iPrim,jPrim,jBas,
     &                  1.0d0,Work(ipDSOp),jBas,
     &                        Shells(jShll)%pCff,jPrim,
     &                  0.0d0,Work(ipDSO),nSO*iPrim)
*           Transpose to ij,AB
            Call DGeTmO(Work(ipDSO),nSO,nSO,iPrim*jPrim,Work(ipDSOp),
     &                  iPrim*jPrim)
            Call GetMem('DSO ','Free','Real',ipDSO,nSO*iBas*jBas)
*
            If (iPrint.ge.99) Call
     &         RecPrt(' Decontracted 1st order density/Fock matrix',
     &                ' ',Work(ipDSOp),iPrim*jPrim,nSO)
*
*           Loops over symmetry operations.
*
            Do lDCRR = 0, nDCRR-1
               Call OA(iDCRR(lDCRR),B,RB)
*
*--------------Loop over operators
*
               Do 5000 iTile = 1, nTs
                  If (FactOp(iTile).eq.Zero) Go To 5000
                  call dcopy_(3,Ccoor(1,iTile),1,C,1)
*
*-----------------Generate stabilizer of the operator.
*
                  Call SOS(iStabO,nStabO,lOper(iTile))
*
*-----------------Find the DCR for M and S
*
                  Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,
     &                     iDCRT,nDCRT)
                  If (iPrint.ge.49) Then
                     Write (6,'(10A)') ' {M}=(',(ChOper(iStabM(i)),
     &                     i=0,nStabM-1),')'
                     Write (6,'(10A)') ' {O}=(',(ChOper(iStabO(i)),
     &                     i=0,nStabO-1),')'
                     Write (6,'(10A)') ' {T}=(',(ChOper(iDCRT(i)),
     &                     i=0,nDCRT-1),')'
                  End If
*
*-----------------Compute normalization factor due the DCR symmetrization
*                 of the two basis functions and the operator.
*
                  iuv = dc(mdci)%nStab*dc(mdcj)%nStab
                  FactNd = DBLE(iuv*nStabO) / DBLE(nIrrep**2*LmbdT)
                  If (MolWgh.eq.1) Then
                     FactNd = FactNd * DBLE(nIrrep)**2 / DBLE(iuv)
                  Else If (MolWgh.eq.2) Then
                     FactNd = Sqrt(DBLE(iuv))*DBLE(nStabO) /
     &                        DBLE(nIrrep*LmbdT)
                  End If
                  FactNd = FactNd * FactOp(iTile)
*
                  Do lDCRT = 0, nDCRT-1
                     nOp(1) = NrOpr(iDCRT(lDCRT))
                     nOp(2) = NrOpr(iEor(iDCRT(lDCRT),iDCRR(lDCRR)))
                     nOp(3) = NrOpr(0)

                     Call OA(iDCRT(lDCRT),A,TA)
                     Call OA(iDCRT(lDCRT),RB,TRB)
                     If (iPrint.ge.49) Then
                        Write (6,'(A,/,3(3F6.2,2X))')
     &                  ' *** Centers A, B, C ***',
     &                  ( TA(i),i=1,3),
     &                  (TRB(i),i=1,3),
     &                  (C(i),i=1,3)
                        Write (6,*) ' nOp=',nOp
                     End If
*
*--------------------Desymmetrize the matrix with which we will
*                    contracte the trace.
*
                     Call DesymD(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                           iShell,jShell,iShll,jShll,
     &                           iAO,jAO,Work(ipDAO),iPrim,jPrim,
     &                           Work(ipDSOp),nSO,nOp,FactNd)
*
*--------------------Project the spherical harmonic space onto the
*                    cartesian space.
*
                     kk = nElem(iAng)*nElem(jAng)
                     If (Shells(iShll)%Transf.or.
     &                   Shells(jShll)%Transf) Then
*
*-----------------------ij,AB --> AB,ij
                        Call DGeTmO(Work(ipDAO),iPrim*jPrim,iPrim*jPrim,
     &                              iCmp*jCmp,Work(iScrt1),iCmp*jCmp)
*-----------------------AB,ij --> ij,ab
                        Call SphCar(Work(iScrt1),iCmp*jCmp,iPrim*jPrim,
     &                              Work(iScrt2),nScr2,
     &                              RSph(ipSph(iAng)),
     &                              iAng,Shells(iShll)%Transf,
     &                                   Shells(iShll)%Prjct,
     &                              RSph(ipSph(jAng)),
     &                              jAng,Shells(jShll)%Transf,
     &                                   Shells(jShll)%Prjct,
     &                              Work(ipDAO),kk)
                     End If
                     If (iPrint.ge.99) Call RecPrt(
     &                        ' Decontracted FD in the cartesian space',
     &                        ' ',Work(ipDAO),iPrim*jPrim,kk)
*
*--------------------Compute kappa and P.
*
                     Call Setup1(Shells(iShll)%Exp,iPrim,
     &                           Shells(jShll)%Exp,jPrim,
     &                   TA,TRB,Work(iKappa),Work(iPCoor),Work(ipZI))
*
*
*--------------------Compute the potential at a tessera.
*
cpcm_solvent
c        write(6,*)'Work(iExp),iPrim,Work(jExp),jPrim'
c        write(6,*)Shells(iShll)%Exp(1),iPrim,Shells(jShll)%Exp(1),jPrim
c        write(6,*)'Work(iZeta),Work(ipZI),Work(iKappa),Work(iPcoor)'
c        write(6,*)Work(iZeta),Work(ipZI),Work(iKappa),Work(iPcoor)
c        write(6,*)'Work(ipFnl),iPrim*jPrim,nComp,iAng,jAng,norder'
c        write(6,*)Work(ipFnl),iPrim*jPrim,nComp,iAng,jAng,norder
cpcm_solvent end
                     Call EFPrm(Shells(iShll)%Exp,iPrim,
     &                          Shells(jShll)%Exp,jPrim,
     &                          Work(iZeta),Work(ipZI),
     &                          Work(iKappa),Work(iPcoor),
     &                          Work(ipFnl),iPrim*jPrim,nComp,
     &                          iAng,jAng,TA,TRB,nOrder,Work(iKern),
     &                          MemKer,C,nOrdOp)
                     If (iPrint.ge.49) Call RecPrt(' Final Integrals',
     &                                 ' ',Work(ipFnl),nDAO,nComp)
*
*--------------------Trace with 1st order density matrix and accumulate
*                    to the potenital at tessera iTile
*
                     If (iPrint.ge.49) Call RecPrt(
     &                        ' Decontracted FD in the cartesian space',
     &                        ' ',Work(ipDAO),nDAO,1)
                     ipFnlc=ipFnl
                     Do iComp = 1, nComp
                        If (iPrint.ge.49)
     &                     Call RecPrt('VTessera(iComp,iTile)',' ',
     &                                  VTessera(iComp,iTile),1,1)
                        VTessera(iComp,iTile)=
     &                      VTessera(iComp,iTile) +
     &                      DDot_(nDAO,Work(ipDAO),1,Work(ipFnlc),1)
                        If (iPrint.ge.49)
     &                     Call RecPrt('VTessera(iComp,iTile)',' ',
     &                                  VTessera(iComp,iTile),1,1)
                        ipFnlc=ipFnlc+nDAO
                     End Do
*
                  End Do
 5000          Continue
            End Do
*
            Call GetMem('DSOpr ','Free','REAL',ipDSOp,nSO*iPrim*jPrim)
            Call GetMem(' DAO ','Free','Real',ipDAO,iPrim*jPrim*
     &                  nElem(iAng)*nElem(jAng))
            Call GetMem('ScrSph','Free','Real',iScrt2,nScr2)
            Call GetMem('Scrtch','Free','Real',iScrt1,nScr1)
            Call GetMem('Final','Free','Real',ipFnl,lFinal)
            Call GetMem('Kernel','Free','Real',iKern,MemKrn)
 131        Continue
         End Do
      End Do
*
      Call GetMem('PCoor','FREE','REAL',iPCoor,S%m2Max*3)
      Call GetMem('Kappa','FREE','REAL',iKappa,S%m2Max)
      Call GetMem('Zeta','FREE','REAL',ipZI ,S%m2Max)
      Call GetMem('Zeta','FREE','REAL',iZeta,S%m2Max)
*
c     Call GetMem('drv_ef_PCM','CHEC','REAL',iDum,iDum)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_UnsetAtomInfo(irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Purpose: Unset atom info stored in ldf_atom_info.fh
C              I.e. free memory allocated for this information and
C              garble the rest.
C
C     Return codes:
C       irc=0: success
C       irc=1: not set, i.e. info already unset and nothing is done
C
      Implicit None
      Integer irc
#include "ldf_atom_info.fh"
#include "WrkSpc.fh"

      Character*6 Label

      Integer iAtom, ip, l

      Integer i, j
      Integer A_Shells, A_AuxShells
      A_Shells(i,j)=iWork(ip_A_Shells-1+2*(j-1)+i)
      A_AuxShells(i,j)=iWork(ip_A_AuxShells-1+2*(j-1)+i)

      ! init return code
      irc=0

      ! Check status
      If (LDF_AtomInfo_Status.eq.LDF_AtomInfo_Unset) Then
         Call WarningMessage(1,'LDF_UnsetAtomInfo: Info already unset!')
         irc=1
         Return
      End If

      ! Deallocate auxiliary shell lists
      Do iAtom=1,NumberOfAtoms
         l=A_AuxShells(1,iAtom)
         If (l.gt.0) Then
            Write(Label,'(A,I4.4)') 'AA',iAtom-1
            ip=A_AuxShells(2,iAtom)
            Call GetMem(Label,'Free','Inte',ip,l)
         End If
      End Do

      ! Deallocate valence shell lists
      Do iAtom=1,NumberOfAtoms
         l=A_Shells(1,iAtom)
         If (l.gt.0) Then
            Write(Label,'(A,I4.4)') 'SA',iAtom-1
            ip=A_Shells(2,iAtom)
            Call GetMem(Label,'Free','Inte',ip,l)
         End If
      End Do

      ! Deallocate A_AuxShells
      Call GetMem('A_AuxShells','Free','Inte',ip_A_AuxShells,
     &                                         l_A_AuxShells)
      ip_A_AuxShells=0
      l_A_AuxShells=0

      ! Deallocate A_Shells
      Call GetMem('A_Shells','Free','Inte',ip_A_Shells,l_A_Shells)
      ip_A_Shells=0
      l_A_Shells=0

      ! Deallocate A_Unique
      Call GetMem('A_Unique','Free','Inte',ip_A_Unique,l_A_Unique)
      ip_A_Unique=0
      l_A_Unique=0

      ! Deallocate atomic coordinates
      Call GetMem('LDF_Coord','Free','Real',ip_Coord,l_Coord)
      ip_Coord=0
      l_Coord=0

      ! Zero NumberOfAtoms
      NumberOfAtoms=0

      ! Mark info unset
      LDF_AtomInfo_Status=LDF_AtomInfo_Unset

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Per-Olof Widmark                                 *
!               1993,1996,1997, Markus P. Fuelscher                    *
!               1996, Luis Serrano-Andres                              *
!               2012, Victor P. Vysotskiy                              *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
!                                                                      *
!     This file defines the module Fast_IO                             *
!     including all entries required for fast I/O system.              *
!                                                                      *
!     Following the list of entries and their usage:                   *
!     LuName    : Name of the file                                     *
!     isOpen    : open/close flag                                      *
!     FSCB      : file descriptors (C language)                        *
!     Addr      : pointer to the current position                      *
!     Trace     : enable/disable debugging output                      *
!     Query     : enable/disable the traceback facilities              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark, IBM Sweden, 1991                                   *
!     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
!     L. Serrano-Andres, University of Lund, Sweden, 1996              *
!                                                                      *
! History:                                                             *
!     New I/O Stat, V.P. Vysotskiy, University of Lund, Sweden, 2012   *
!     OpenMP,       V.P. Vysotskiy, University of Lund, Sweden, 2012   *
!     Cleanup and conversion to module,  I. Fdez. Galvan, 2021         *
!***********************************************************************

module Fast_IO

use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: MxFile = 199, MaxSplitFile = 20
integer(kind=iwp) :: Addr(MxFile), FlsSize(MxFile), FSCB(MxFile), isFiM(MxFile), isOpen(MxFile), MaxFileSize, MBL(MxFile), &
                     MPUnit(0:MaxSplitFile-1,MxFile), NProfFiles
logical(kind=iwp) :: Multi_File(MxFile), Query, Trace
real(kind=wp) :: ProfData(8,MxFile)
character(len=8) :: LuName(MxFile), LuNameProf(MxFile)
!-----------------------------------------------
! Error codes for AIX/IO and FIM/IO routines.
integer(kind=iwp), parameter :: eEof   = 1024, &
                                eNtOpn = 1025, &
                                eInErr = 1026, &
                                eTmF   = 1027, &
                                eTlFn  = 1028, &
                                eBlNme = 1029, &
                                eNoMsg = 1030, &
                                eFiMFo = 1031
!-----------------------------------------------
! Control blocks for AIX I/O routines.
integer(kind=iwp), parameter :: pHndle = 1, &
                                pWhere = 2, &
                                pDesc  = 3, &
                                pStat  = 4
integer(kind=iwp) :: CtlBlk(4,MxFile)
character(len=80) :: FCtlBlk(MxFile)
!-----------------------------------------------
! Define the largest file that can be handled by the IO system (units=Bytes)
#ifdef _I8_
integer(kind=iwp), parameter :: Max_File_Length = 214748364800
#else
integer(kind=iwp), parameter :: Max_File_Length = 2147483647
#endif
! Define minimal block size handled by the IO system (units=Bytes)
integer(kind=iwp), parameter :: MBl_wa = 8, MBl_nwa = 512

public :: Addr, CtlBlk, eBlNme, eEof, eFiMFo, eInErr, eNoMsg, eNtOpn, eTlFn, eTmF, FCtlBlk, FlsSize, FSCB, isFiM, isOpen, LuName, &
          LuNameProf, Max_File_Length, MaxFileSize, MaxSplitFile, MBL, MBl_nwa, MBl_wa, MPUnit, Multi_File, MxFile, NProfFiles, &
          pDesc, pHndle, ProfData, pStat, pWhere, Query, Trace

end module Fast_IO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MemRys_g(iSD4,nSD,nRys,MemPrm)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: nSD, iSD4(0:nSD,4)
integer(kind=iwp), intent(out) :: nRys, MemPrm
integer(kind=iwp) :: iAnga(4)

iAnga(:) = iSD4(1,:)
call MemRg1(iAnga,nRys,MemPrm)

return

end subroutine MemRys_g

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine asonc12s2_cvb(c,sxc,nvec,nprm,
     >   civb,civbs,
     >   orbs,gjorb,gjorb2,gjorb3,cvbdet,
     >   cvb,
     >   vec_all)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension c(nprm,nvec),sxc(nprm,nvec)
      dimension civb(ndet),civbs(ndet)
      dimension orbs(norb,norb),gjorb(*),gjorb2(*),gjorb3(*)
      dimension cvb(nvb),cvbdet(ndetvb)
      dimension vec_all(npr)
      save iter,ipp

      iter=iter+1
      if(ipp.ge.2)then
        write(6,'(/,a,i5,a,f10.3,a)')' Davidson iteration',iter,
     >    ' at',tim_cvb(cpu0),' CPU seconds'
        write(6,'(a)')
     >    ' -----------------------------------------------'
      endif

c  If no optimization of structure coefficients we are doing
c  "Augmented" calc:
      if(strucopt)then
        ic1=1
      else
        ic1=2
      endif

      do 100 ivec=1,nvec
      call free2all_cvb(c(ic1,ivec),vec_all,1)
      if(.not.strucopt)call daxpy_(nvb,c(1,ivec),cvb,1,
     >  vec_all(nprorb+1),1)
c  (CIVB set in O12SA :)
      call cizero_cvb(civbs)
      call oneexc_cvb(civb,civbs,vec_all,.false.,0)
      call str2vbf_cvb(vec_all(nprorb+1),cvbdet)
      call vb2ciaf_cvb(cvbdet,civbs)
      call applyts_cvb(civbs,orbs,gjorb,gjorb2,gjorb3)

      call ci2vbg_cvb(civbs,cvbdet)
      call vb2strg_cvb(cvbdet,vec_all(nprorb+1))
      call fzero(vec_all,nprorb)
      call onedens_cvb(civb,civbs,vec_all,.false.,0)
      call all2free_cvb(vec_all,sxc(ic1,ivec),1)
      if(.not.strucopt)sxc(1,ivec)=ddot_(nvb,cvb,1,vec_all(nprorb+1),1)
100   continue

      return
      entry asonc12sinit_cvb(ippinp)
      iter=0
      ipp=ippinp
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
      SUBROUTINE CHO_Fmat(rc,nDen,ipFLT,nMOs,ipMOs,
     &                       ExFac,ipDLT)

********************************************************************
*  Author : F. Aquilante
*
C ******************* AO-BASIS FOCK MATRIX *************************
C
C   F(ab) = sum_J  Lab,J * V(J)  -  ExFac * sum_Jk  Lka,J * Lkb,J
C
********************************************************************
C
C      V(J) = sum_gd  Lgd,J * D(gd)
C
C      a,b,g,d:  AO-index
C      k:        MO-index such that D(g,d) = sum_k  X(g,k) * X(d,k)
C
C      Lkb,J = sum_a  Lab,J * X(a,k)
C
********************************************************************

      Implicit Real*8 (a-h,o-z)


      Integer   rc,nDen,ipDLT(nDen),ipFLT(nDen),ipMOs(nDen)
      Integer   nMOs(8,nDen)
      Real*8    ExFac(nDen)

      Integer   iSkip(8),ISTLT(8)
      Real*8    tread(2),tcoul(2),texch(2)

      Character*50 CFmt
      Character*8 SECNAM
      Parameter (SECNAM = 'Cho_Fmat')

      Logical   Debug,timings,DoRead
      COMMON    /CHOTIME /timings

      parameter (zero = 0.0D0, one = 1.0D0, xone = -1.0D0)

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )
      Logical add
      Character*6 mode

************************************************************************
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
******
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
******
      ipOrb(i,j) = iWork(ip_Orb-1+8*(j-1)+i)
******
      ipLab(i,j) = iWork(ip_Lab-1+8*(j-1)+i)
******
      ipDr(i) = iWork(ipDab+i-1)
******
      ipFr(i) = iWork(ipFab+i-1)
************************************************************************

#ifdef _DEBUGPRINT_
c      Debug=.true.
      Debug=.false.! to avoid double printing in CASSCF-debug
#else
      Debug=.false.
#endif


      FactC = one

      DoRead  = .false.
      IREDC= -1  ! unknwn reduced set

      If (nDen.lt.1) then
         write(6,*)SECNAM//'Invalid parameter nDen= ',nDen
         call abend()
      EndIf


        CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

        do i=1,2            ! 1 --> CPU   2 --> Wall
           tread(i) = zero  !time read/transform vectors
           tcoul(i) = zero  !time for computing Coulomb
           texch(i) = zero  !time for computing Exchange
        end do

C ==================================================================

c --- Various offsets
c --------------------
        ISTLT(1)=0
      DO ISYM=2,NSYM
        NBB=NBAS(ISYM-1)*(NBAS(ISYM-1)+1)/2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NBB ! Inactive D and F matrices
      END DO

      Call GetMem('ipRedM','Allo','Inte',ipDab,2*nDen)
      ipFab = ipDab + nDen - 1

      Call GetMem('ip_Lab','Allo','Inte',ip_Lab,8*nDen)
      Call GetMem('ip_Orb','Allo','Inte',ip_Orb,8*nDen)

      DO jDen=1,nDen

         iWork(ip_Orb+8*(jDen-1)) = ipMOs(jDen)

         DO ISYM=2,NSYM

            iWork(ip_Orb-1+8*(jDen-1)+iSym) = ipOrb(iSym-1,jDen)
     &                       + nMOs(iSym-1,jDen)*nBas(iSym-1)
         END DO

      END DO

      iLoc = 3 ! use scratch location in reduced index arrays

C *************** BIG LOOP OVER VECTORS SYMMETRY *******************
      DO jSym=1,nSym

         If (NumCho(jSym).lt.1) GOTO 1000


C ****************     MEMORY MANAGEMENT SECTION    *****************
C ------------------------------------------------------------------
C --- compute memory needed to store at least 1 vector of JSYM
C --- and do all the subsequent calculations
C ------------------------------------------------------------------
         mTvec = 0  ! mem for storing the half-transformed vec

         do l=1,nSym
            k=Muld2h(l,JSYM)
            Mmax = 0
            do jDen=1,nDen
               if (ExFac(jDen).ne.zero) Mmax = Max(Mmax,nMOs(k,jDen))
            end do
            mTvec = mTvec + nBas(l)*Mmax
         end do

         mTvec=Max(mTvec,1)

C ------------------------------------------------------------------
C ------------------------------------------------------------------

         JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
         JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

         Do JRED=JRED1,JRED2

            CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

            If (nVrs.eq.0) GOTO 999  ! no vectors in that (jred,jsym)

            if (nVrs.lt.0) then
               Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
               call abend()
            endif

            Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
            if(irc.ne.0)then
              Write(6,*)SECNAM//'cho_X_setred non-zero return code.',
     &                       '    rc= ',irc
              call abend()
            endif

            IREDC=JRED

            nRS = nDimRS(JSYM,JRED)

            If(JSYM.eq.1)Then

              Do jDen=1,nDen
                Call GetMem('rsD','Allo','Real',iWork(ipDab+jDen-1),nRS)
                Call GetMem('rsF','Allo','Real',iWork(ipFab+jDen-1),nRS)
                Call Fzero(Work(ipDr(jDen)),nRS)
                Call Fzero(Work(ipFr(jDen)),nRS)
             End Do

            EndIf

            Call GetMem('MaxM','Max','Real',KDUM,LWORK)

            nVec  = Min(LWORK/(nRS+mTvec),nVrs)

            If (nVec.lt.1) Then
               WRITE(6,*) SECNAM//': Insufficient memory for batch'
               WRITE(6,*) 'LWORK= ',LWORK
               WRITE(6,*) 'min. mem. need= ',nRS+mTvec
               WRITE(6,*) 'jsym= ',jsym
               rc = 33
               CALL Abend()
               nBatch = -9999  ! dummy assignment
            End If

            LREAD = nRS*nVec

            Call GetMem('rsL','Allo','Real',ipLrs,LREAD)
            Call GetMem('ChoT','Allo','Real',ipChoT,mTvec*nVec)

            If(JSYM.eq.1)Then
C --- Transform the densities to reduced storage
              mode = 'toreds'
              add  = .false.
              Call swap_rs2full(irc,iLoc,nDen,JSYM,ISTLT,
     &                              ipDLT,iWork(ipDab),mode,add)
            EndIf

C --- BATCH over the vectors ----------------------------

            nBatch = (nVrs-1)/nVec + 1

            DO iBatch=1,nBatch

               If (iBatch.eq.nBatch) Then
                  JNUM = nVrs - nVec*(nBatch-1)
               else
                  JNUM = nVec
               endif

               JVEC = nVec*(iBatch-1) + iVrs
               IVEC2 = JVEC - 1 + JNUM

               CALL CWTIME(TCR1,TWR1)

               CALL CHO_VECRD(Work(ipLrs),LREAD,JVEC,IVEC2,JSYM,
     &                        NUMV,IREDC,MUSED)

               If (NUMV.le.0 .or.NUMV.ne.JNUM ) then
                  rc=77
                  RETURN
               End If

               CALL CWTIME(TCR2,TWR2)
               tread(1) = tread(1) + (TCR2 - TCR1)
               tread(2) = tread(2) + (TWR2 - TWR1)

               If(JSYM.eq.1)Then
C ************ (alpha+beta) COULOMB CONTRIBUTION  ****************
C
C --- Contraction with the density matrix
C ---------------------------------------
C --- V{#J} <- V{#J}  +  sum_rs  L(rs,{#J}) * DI(rs)
C==========================================================
C
                  CALL CWTIME(TCC1,TWC1)

                  ipVJ = ipChoT

                  Do jDen=1,nDen

                     CALL DGEMV_('T',nRS,JNUM,
     &                          ONE,Work(ipLrs),nRS,
     &                 Work(ipDr(jDen)),1,ZERO,Work(ipVJ),1)

C --- F(rs){#J} <- F(rs){#J} + FactC * sum_J L(rs,{#J})*V{#J}
C===============================================================

                     Fact = dble(min(jVec-iVrs,1))

                     CALL DGEMV_('N',nRS,JNUM,
     &                          FactC,Work(ipLrs),nRS,
     &                 Work(ipVJ),1,Fact,Work(ipFr(jDen)),1)


                  End Do

                  CALL CWTIME(TCC2,TWC2)
                  tcoul(1) = tcoul(1) + (TCC2 - TCC1)
                  tcoul(2) = tcoul(2) + (TWC2 - TWC1)

               EndIf  ! Coulomb contribution


C *************** EXCHANGE CONTRIBUTIONS  ***********************

C --- Set pointers (ipLab) to the half-transformed Cholesky vectors
               Do jDen=1,nDen

                  lChoT=0
                  Do iSymb=1,nSym

                     iSymp = MulD2h(JSYM,iSymb)

                     iWork(ip_Lab - 1 + 8*(jDen-1)
     &                                + iSymp) = ipChoT + lChoT ! LpJ,b

                     lChoT = lChoT + nMOs(iSymp,jDen)*JNUM*nBas(iSymb)

                  End Do

               End Do


               iSwap = 2  ! LpJ,b are returned

               Do jDen=1,nDen

                 CALL CWTIME(TCR3,TWR3)

                 IF (ExFac(jDen).ne.zero) THEN

                     FactX = xone*ExFac(jDen)

C --- Set up the skipping flags
C -------------------------------------------------------------
                  Do i=1,nSym

                     k = Muld2h(i,JSYM)
                     iSkip(k) = Min(1,nBas(i)*nMOs(k,jDen))

                  End Do
C -------------------------------------------------------------


C *********************** HALF-TRANSFORMATION  ****************

                  CALL CHO_X_getVtra(irc,Work(ipLrs),LREAD,jVEC,JNUM,
     &                         JSYM,iSwap,IREDC,jDen,jDen,iWork(ip_Orb),
     &                         nMOs,iWork(ip_Lab),iSkip,DoRead)

                  CALL CWTIME(TCR4,TWR4)
                  tread(1) = tread(1) + (TCR4 - TCR3)
                  tread(2) = tread(2) + (TWR4 - TWR3)

#ifdef _DEBUGPRINT_
      write(6,*) 'Half-transformation in the MO space: ',jDen
      write(6,*) 'Total allocated :     ',mTvec*nVec,' at ',ipChoT
      write(6,*) 'Mem pointers ipLab: ',((ipLab(i,j),i=1,nSym),j=1,jDen)
      write(6,*) 'iSkip :             ',(iSkip(k),k=1,nSym)
      write(6,*) 'LREAD: ',LREAD,' allocated at ',ipLrs
      write(6,*) 'JSYM :                ',JSYM
      write(6,*) 'JRED :                ',JRED
      write(6,*) 'JNUM :                ',JNUM
#endif

                  if (irc.ne.0) then
                     rc = irc
                     RETURN
                  endif


                  CALL CWTIME(TCX1,TWX1)

                  Do iSyma=1,nSym

                     iSymk = MulD2h(JSYM,iSyma)

C ---------------------------------------------------------------------
c *** Compute only the LT part of the Exchange matrix ********
C
C     F(ab) = F(ab) + FactX * sum_Jk  LkJ,a * LkJ,b
C ---------------------------------------------------------------------
                     NK = nMOs(iSymk,jDen)

                     If (iSkip(iSymk).ne.0) Then

                        ISFI = ipFLT(jDen) + ISTLT(iSyma)

                        CALL DGEMM_TRI('T','N',nBas(iSyma),nBas(iSyma),
     &                         NK*JNUM,FactX,Work(ipLab(iSymk,jDen)),
     &                         NK*JNUM,Work(ipLab(iSymk,jDen)),NK*JNUM,
     &                         One,Work(ISFI),nBas(iSyma))


c          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYMA
c          CALL TRIPRT('FI: jSym>1',' ',Work(ISFI),nBas(iSyma))

                     EndIf

C --------------------------------------------------------------------
                  End Do  !loop over MOs symmetries

                  CALL CWTIME(TCX2,TWX2)
                  texch(1) = texch(1) + (TCX2 - TCX1)
                  texch(2) = texch(2) + (TWX2 - TWX1)


                 ENDIF  ! ExFac(jDen)=0.0d0

               End Do   ! loop over densities

C --------------------------------------------------------------------
C --------------------------------------------------------------------

            END DO  ! end batch loop


            If(JSYM.eq.1)Then

             if (nVrs.gt.0) then
c --- backtransform fock matrix in full storage
               mode = 'tofull'
               add  = JRED.gt.JRED1
               Call swap_rs2full(irc,iLoc,nDen,JSYM,ISTLT,
     &                               ipFLT,iWork(ipFab),mode,add)
             endif

            EndIf


C --- free memory
            Call GetMem('ChoT','Free','Real',ipChoT,mTvec*nVec)
            Call GetMem('rsL','Free','Real',ipLrs,LREAD)

            If(JSYM.eq.1)Then
              Do jDen=nDen,1,-1
                Call GetMem('rsD','Free','Real',iWork(ipDab+jDen-1),nRS)
                Call GetMem('rsF','Free','Real',iWork(ipFab+jDen-1),nRS)
              End Do
            EndIf


999         Continue

         END DO   ! loop over red sets

1000     CONTINUE

      END DO   !loop over JSYM

      Call GetMem('ip_Orb','Free','Inte',ip_Orb,8*nDen)
      Call GetMem('ip_Lab','Free','Inte',ip_Lab,8*nDen)
      Call GetMem('ipRedM','Free','Inte',ipDab,2*nDen)

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1


*
*---- Write out timing information
      if(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky SCF timing from '//SECNAM
      Write(6,CFmt)'------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'

         Write(6,'(2x,A26,2f10.2)')'READ/TRANSFORM VECTORS           '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COULOMB                          '
     &                           //'         ',tcoul(1),tcoul(2)
         Write(6,'(2x,A26,2f10.2)')'EXCHANGE                         '
     &                           //'         ',texch(1),texch(2)
         Write(6,*)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif


c Print the Fock-matrix
#ifdef _DEBUGPRINT_

      if(Debug) then !to avoid double printing in SCF-debug

      WRITE(6,'(6X,A)')'TEST PRINT FROM '//SECNAM
      WRITE(6,'(6X,A)')
      Do jDen=1,nDen
       WRITE(6,'(6X,A)')'***** FOCK MATRIX AO-BASIS ***** '
       WRITE(6,'(6X,A)')'***** computed from Density #',jDen
        DO ISYM=1,NSYM
           ISFI=ipFLT(jDen)+ISTLT(ISYM)
           IF( NBAS(ISYM).GT.0 ) THEN
             WRITE(6,'(6X,A)')
             WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
             call TRIPRT('','',Work(ISFI),NBAS(ISYM))
           ENDIF
        END DO
      END DO

      endif

#endif

      rc  = 0


      Return
      END

**************************************************************
**************************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1994  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*
!> @brief Apply the resolvent of the diagonal of H0-E0 to a vector
!> @author Per-&Aring;ke Malmqvist, 1994
!>
!> @details
!> ::presdia stands for "parallel resolvent diagonal" and it applies
!> the resolvent of the diagonal of \f$ (H_0 - E_0) \f$ to a coefficient
!> vector stored at position \p IVEC on \p LUSOLV. The result is stored
!> in the vector at position \p JVEC. Furthremore, it computes the
!> "overlap" as \p IVEC squared divided by the resolvent.
!> The parallel part is thaken care of in subroutine calls \p RHS_.
!> Potential shifts and modification of \f$ H_0 \f$ are considered
!> in ::rhs_resdia
!>
!> @param[in]     IVEC   Vector position to which the res is applied
!> @param[out]    JVEC   Vector position where the result is saved
!> @param[in]     OVLAPS Array containing the overlaps
      SUBROUTINE PRESDIA(IVEC,JVEC,OVLAPS)
      use definitions, only: iwp, wp
      use caspt2_global, only: LUSBT
      use EQSOLV, only: IDBMAT
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: nISup, nASup, nInDep, MxCase, nSym
      IMPLICIT NONE


      INTEGER(kind=iwp), intent(in):: IVEC,JVEC
      REAL(kind=wp), intent(inout):: OVLAPS(0:8,0:MXCASE)

      INTEGER(kind=iwp) ICASE,ISYM
      INTEGER(kind=iwp) NAS,NIS,NIN
      INTEGER(kind=iwp) lg_V
      INTEGER(kind=iwp) JD

      REAL(kind=wp) OVL,DOVL,OVLSUM,OVLTOT
      REAL(kind=wp), ALLOCATABLE:: BD(:), ID(:)

C Apply the resolvent of the diagonal part of H0 to a coefficient
C vector in vector nr. IVEC on LUSOLV. Put the results in vector
C nr. JVEC. Also compute overlaps, see OVLVEC for structure.

      OVLTOT=0.0D0
      DO ISYM=1,NSYM
        OVLAPS(ISYM,0)=0.0D0
      END DO

      DO 200 ICASE=1,13
        OVLSUM=0.0D0
        DO 100 ISYM=1,NSYM
          OVL=0.0D0
          NIN=NINDEP(ISYM,ICASE)
          IF(NIN.EQ.0) GOTO 90
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
C Remember: NIN values in BDIAG, but must read NAS for correct
C positioning.
          CALL mma_allocate(BD,NAS,LABEL='BD')
          CALL mma_allocate(ID,NIS,LABEL='ID')
          JD=IDBMAT(ISYM,ICASE)
          CALL DDAFILE(LUSBT,2,BD,NAS,JD)
          CALL DDAFILE(LUSBT,2,ID,NIS,JD)

          CALL RHS_ALLO(NIN,NIS,lg_V)
          CALL RHS_READ(NIN,NIS,lg_V,ICASE,ISYM,IVEC)
          CALL RHS_RESDIA(NIN,NIS,lg_V,BD,ID,DOVL)
          OVL=OVL+DOVL
          CALL RHS_SAVE(NIN,NIS,lg_V,ICASE,ISYM,JVEC)
          CALL RHS_FREE(lg_V)

          CALL mma_deallocate(BD)
          CALL mma_deallocate(ID)
  90      CONTINUE
          OVLAPS(ISYM,0)=OVLAPS(ISYM,0)+OVL
          OVLSUM=OVLSUM+OVL
 100    CONTINUE
        OVLAPS(0,ICASE)=OVLSUM
        OVLTOT=OVLTOT+OVLSUM
 200  CONTINUE
      OVLAPS(0,0)=OVLTOT

      END SUBROUTINE PRESDIA

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007, Bingbing Suo                                     *
!***********************************************************************
! 26 feb 2007 -bsuo- revised by suo bing for multi-root calculation

subroutine gdv_sequence_extspace(ilw,irw)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: ilsegdownwei, indx, log_prod, mcroot, value_lpext, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ilw, irw
integer(kind=iwp) :: iij, irot, irtidx, mm, nn
real(kind=wp) :: valuelp, valuelptmp1, vlptmp

!write(u6,*) '  dv_test ','  vd_test '

! mrpt2
if (log_prod == 3) then
  call gdv_sequence_extspace_pt(ilw,irw)
  return
end if

do irot=1,mcroot
  irtidx = indx(irot)
  mm = ilw+irtidx
  nn = irw+1+irtidx
  valuelp = vector2(nn)
  valuelptmp1 = vector1(nn)
  do iij=1,ilsegdownwei
    vlptmp = value_lpext(iij)
    mm = mm+1
    vector2(mm) = vector2(mm)+valuelptmp1*vlptmp
    valuelp = valuelp+vector1(mm)*vlptmp
    !if ((mm == 86) .and. (nn == 5)) then
    !  write(u6,*) 'dv_test 1 ',vlptmp,vector2(mm)
    !end if
    !if ((mm == 5) .and. (nn == 86)) then
    !  write(u6,*) 'dv_test 2 ',valuelp,vector2(nn)
    !end if
  end do
  vector2(nn) = valuelp
end do

end subroutine gdv_sequence_extspace

subroutine gdv_sequence_extspace_pt(ilw,irw)  !log_prod=

use gugaci_global, only: ilsegdownwei, value_lpext, vcm, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ilw, irw
integer(kind=iwp) :: iij, mm, nn
real(kind=wp) :: wl

mm = ilw
nn = irw+1
do iij=1,ilsegdownwei
  mm = mm+1
  wl = value_lpext(iij)
  vector2(mm) = vector2(mm)+vcm(nn)*wl
  !if ((jpad == 1) .and. (ipae == 2)) then
  !  write(u6,'(a,4i6,3f18.8)') 'dv_test_pt 1 ',jpadl,ipael,mm,nn,wl,vcm(nn),vector2(mm)
  !end if
  !if ((jpadl == 1) .and. (ipael == 2)) then
  !  write(u6,'(a,4i6,3f18.8)') 'dv_test_pt 2 ',jpad,ipae,mm,nn,wl,vcm(nn),vector2(mm)
  !end if
end do

end subroutine gdv_sequence_extspace_pt

subroutine gtd_sequence_extspace(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: indx, iweista_g25, iweista_g28, logic_g25a, logic_g25b, logic_g28a, mcroot, nint_g25, nint_g28, nwei_g25, &
                         nwei_g28, value_lpext, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, ilpvalue, iplplwei, iplprwei, irot, irtidx, itmp, mm, nn, nn0
real(kind=wp) :: vlptmp, vlptmp1, vlptmp2

!write(u6,*) ' td_test _1/2',' dt_test '

do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ilpvalue = 0
  if (logic_g25a) then
    mm = iplplwei+iweista_g25-1
    nn0 = iplprwei
    do itmp=1,nint_g25
      ilpvalue = ilpvalue+1
      vlptmp = value_lpext(ilpvalue)
      nn = nn0
      do i=1,nwei_g25
        mm = mm+1
        nn = nn+1
        vector2(mm) = vector2(mm)+vector1(nn)*vlptmp
        vector2(nn) = vector2(nn)+vector1(mm)*vlptmp
      end do
    end do
  else if (logic_g25b) then
    mm = iplplwei+iweista_g25-1
    nn0 = iplprwei
    ilpvalue = ilpvalue+1
    do itmp=2,nint_g25
      ilpvalue = ilpvalue+1
      vlptmp = value_lpext(ilpvalue)
      nn = nn0
      do i=1,itmp-1
        mm = mm+1
        nn = nn+1
        vector2(mm) = vector2(mm)+vector1(nn)*vlptmp
        vector2(nn) = vector2(nn)+vector1(mm)*vlptmp
      end do
    end do
    mm = iplplwei+iweista_g28-1
    nn = iplprwei
    nn = nn+1
    do itmp=2,nwei_g28
      nn = nn+1
      vlptmp = vector2(nn)
      vlptmp1 = vector1(nn)
      ilpvalue = 0
      do i=1,itmp-1
        ilpvalue = ilpvalue+1
        vlptmp2 = -value_lpext(ilpvalue)
        mm = mm+1
        vector2(mm) = vector2(mm)+vlptmp1*vlptmp2
        vlptmp = vlptmp+vector1(mm)*vlptmp2
      end do
      vector2(nn) = vlptmp
    end do
  else if (logic_g28a) then
    mm = iplplwei+iweista_g28-1
    nn0 = iplprwei
    do nn=nn0+1,nn0+nwei_g28
      vlptmp = vector2(nn)
      vlptmp1 = vector1(nn)
      ilpvalue = 0
      do i=1,nint_g28
        ilpvalue = ilpvalue+1
        vlptmp2 = -value_lpext(ilpvalue)
        mm = mm+1
        vector2(mm) = vector2(mm)+vlptmp1*vlptmp2
        vlptmp = vlptmp+vector1(mm)*vlptmp2
      end do
      vector2(nn) = vlptmp
    end do
  end if
end do

end subroutine gtd_sequence_extspace

subroutine inn_ext_ss_loop_unpack(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, indx, ism_g2g4, iwt_sm_s_ext, logic_g1415, logic_g2g4a, &
                         logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, lpend34a, lpend34b, &
                         lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, &
                         lpsta36b, mcroot, ng_sm, nvalue_space_ss, value_lpext, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, iplplwei, iplprwei, irot, irtidx, &
                     irwtmp, isma, ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1, valuelp2, valuelptmp1, valuelptmp2, valuetmp

!write(u6,*) ' ss_test 1/2'
do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ii = 1
  if (logic_g1415) then
    mm = iplplwei
    nn = iplprwei
    do i=1,idownwei_g131415
      valuelp = value_lpext(ii)
      mm = mm+1
      nn = nn+1
      vector2(mm) = vector2(mm)+vector1(nn)*valuelp
      vector2(nn) = vector2(nn)+vector1(mm)*valuelp
      ii = ii+1
    end do
  end if

  ii0 = ii
  if (logic_g2g4a) then
    ii = ii0
    mm0 = iplplwei
    nn0 = iplprwei+iwt_sm_s_ext
    mm = mm0
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp1 = value_lpext(ii)
          valuelp2 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if
  if (logic_g2g4b) then
    ii = ii0
    mm0 = iplprwei
    nn0 = iplplwei+iwt_sm_s_ext
    mm = mm0
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp2 = value_lpext(ii)
          valuelp1 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if
  !iaddii = (ii-ii0)/2
  ii0 = ii-1

  do icle=1,2
    if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta36 = lpsta36a
        lpend36 = lpend36a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta36 = lpsta36b
        lpend36 = lpend36b
      end if
      do iii=lpsta36,lpend36,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        ii = ii0+lpext_wei(iii+2)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        do i=1,lpext_wei(iii+3)
          valuetmp = value_lpext(ii)
          vector2(mm) = vector2(mm)+vector1(nn)*valuetmp
          vector2(nn) = vector2(nn)+vector1(mm)*valuetmp
          mm = mm+1
          nn = nn+1
        end do
      end do
    end if

    if (((icle == 1) .and. logic_g35a) .or. ((icle == 2) .and. logic_g35b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta35 = lpsta35a
        lpend35 = lpend35a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta35 = lpsta35b
        lpend35 = lpend35b
      end if
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    end if

    !cycle

    if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta34 = lpsta34a
        lpend34 = lpend34a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta34 = lpsta34b
        lpend34 = lpend34b
      end if
      do iii=lpsta34,lpend34,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    end if

    ii0 = ii0+nvalue_space_ss
  end do

end do

end subroutine inn_ext_ss_loop_unpack

subroutine inn_ext_ss_drl_loop_unpack(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, indx, ism_g2g4, iwt_sm_s_ext, logic_g1415, logic_g2g4a, &
                         logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, lpend34a, lpend34b, &
                         lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, &
                         lpsta36b, mcroot, ng_sm, value_lpext, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, iplplwei, iplprwei, irot, irtidx, &
                     irwtmp, isma, ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1, valuelp2, valuelptmp1, valuelptmp2, valuetmp

!write(u6,*) ' ss_test 2/2'
do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ii = 1
  if (logic_g1415) then
    mm = iplplwei
    nn = iplprwei
    do i=1,idownwei_g131415
      valuelp = value_lpext(ii)
      mm = mm+1
      nn = nn+1
      vector2(mm) = vector2(mm)+vector1(nn)*valuelp
      vector2(nn) = vector2(nn)+vector1(mm)*valuelp
      ii = ii+1
    end do
  end if

  ii0 = ii
  if (logic_g2g4a) then
    ii = ii0
    mm0 = iplplwei
    nn0 = iplprwei+iwt_sm_s_ext
    mm = mm0
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp1 = value_lpext(ii)
          valuelp2 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp2+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp2
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if

  if (logic_g2g4b) then
    ii = ii0
    mm0 = iplprwei
    nn0 = iplplwei+iwt_sm_s_ext
    mm = mm0
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp2 = value_lpext(ii)
          valuelp1 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp1
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp1
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if
  !iaddii = (ii-ii0)/2
  ii0 = ii-1

  do icle=1,2
    if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta36 = lpsta36a
        lpend36 = lpend36a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta36 = lpsta36b
        lpend36 = lpend36b
      end if
      do iii=lpsta36,lpend36,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        ii = ii0+lpext_wei(iii+2)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        do i=1,lpext_wei(iii+3)
          valuetmp = value_lpext(ii)
          vector2(mm) = vector2(mm)+vector1(nn)*valuetmp
          vector2(nn) = vector2(nn)+vector1(mm)*valuetmp
          mm = mm+1
          nn = nn+1
        end do
      end do
    end if

    if (((icle == 1) .and. logic_g35a) .or. ((icle == 2) .and. logic_g35b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta35 = lpsta35a
        lpend35 = lpend35a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta35 = lpsta35b
        lpend35 = lpend35b
      end if
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    end if

    !cycle

    if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta34 = lpsta34a
        lpend34 = lpend34a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta34 = lpsta34b
        lpend34 = lpend34b
      end if
      do iii=lpsta34,lpend34,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    end if

  end do

end do

end subroutine inn_ext_ss_drl_loop_unpack

subroutine inn_ext_sv_loop_unpack(ilw,irw)   !,ilsegdownwei)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: ilsegdownwei, indx, log_prod, mcroot, value_lpext, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ilw, irw
integer(kind=iwp) :: iij, irot, irtidx, mm, nn
real(kind=wp) :: valuelp, valuelptmp1

!write(u6,*) 'sv_test,   tv_test '
if (log_prod == 3) then
  call inn_ext_svloop_unpack_pt(ilw,irw)
  return
end if

do irot=1,mcroot
  irtidx = indx(irot)
  mm = ilw+irtidx
  nn = irw+1+irtidx
  valuelp = vector2(nn)
  valuelptmp1 = vector1(nn)
  do iij=1,ilsegdownwei
    mm = mm+1
    vector2(mm) = vector2(mm)+valuelptmp1*value_lpext(iij)
    valuelp = valuelp+vector1(mm)*value_lpext(iij)
  end do
  vector2(nn) = valuelp
end do

end subroutine inn_ext_sv_loop_unpack

subroutine inn_ext_svloop_unpack_pt(ilw,irw)

use gugaci_global, only: ilsegdownwei, value_lpext, vcm, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ilw, irw
integer(kind=iwp) :: iij, mm, nn
real(kind=wp) :: wl
!character(len=16) :: loop_type

!loop_type = ' sv_test_pt, tv_test_pt'
mm = ilw
nn = irw+1
do iij=1,ilsegdownwei
  mm = mm+1
  wl = value_lpext(iij)
  vector2(mm) = vector2(mm)+vcm(nn)*wl
  !vector2(mm) = vector2(mm)+vcm0(nn)*wl
  !if (mm == mtest)then
  !  write(nf2,'(2i5,3f18.10)') 1, nn,vcm0(nn),wl,vector2(mm-ndim_h0)
  !end if
end do

end subroutine inn_ext_svloop_unpack_pt

subroutine inn_ext_tt_loop_unpack(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: idownwei_g131415, indx, logic_g1415, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, &
                         logic_g36b, lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, &
                         lpsta35a, lpsta35b, lpsta36a, lpsta36b, mcroot, nvalue_space_ss, value_lpext, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, icle, ii, ii0, iii, iij, ilwtmp, iplplwei, iplprwei, irot, irtidx, irwtmp, lpend34, lpend35, lpend36, &
                     lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0
real(kind=wp) :: valuelp, valuelptmp1, valuetmp

!write(u6,*) '  tt_test 1/2'

do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ii = 1
  if (logic_g1415) then
    mm = iplplwei
    nn = iplprwei
    do i=1,idownwei_g131415
      valuelp = value_lpext(ii)
      mm = mm+1
      nn = nn+1
      vector2(mm) = vector2(mm)+vector1(nn)*valuelp
      vector2(nn) = vector2(nn)+vector1(mm)*valuelp
      ii = ii+1
    end do
  end if

  ii0 = ii-1         !severe_error

  do icle=1,2
    if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta36 = lpsta36a
        lpend36 = lpend36a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta36 = lpsta36b
        lpend36 = lpend36b
      end if
      do iii=lpsta36,lpend36,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        ii = ii0+lpext_wei(iii+2)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        do i=1,lpext_wei(iii+3)
          valuelp = value_lpext(ii)
          vector2(mm) = vector2(mm)+vector1(nn)*valuelp
          vector2(nn) = vector2(nn)+vector1(mm)*valuelp
          mm = mm+1
          nn = nn+1
        end do
      end do
    end if

    if (((icle == 1) .and. logic_g35a) .or. ((icle == 2) .and. logic_g35b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta35 = lpsta35a
        lpend35 = lpend35a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta35 = lpsta35b
        lpend35 = lpend35b
      end if
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp      !severe_error_1202
      end do
    end if

    if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta34 = lpsta34a
        lpend34 = lpend34a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta34 = lpsta34b
        lpend34 = lpend34b
      end if
      do iii=lpsta34,lpend34,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          vector2(mm) = vector2(mm)+valuelptmp1*value_lpext(iij)
          valuelp = valuelp+vector1(mm)*value_lpext(iij)
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    end if
    ii0 = ii0+nvalue_space_ss
  end do

end do

end subroutine inn_ext_tt_loop_unpack

subroutine inn_ext_ts_loop_unpack(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, indx, ism_g2g4, iwt_sm_s_ext, logic_g1415, logic_g2g4a, &
                         logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, lpend34a, lpend34b, &
                         lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, &
                         lpsta36b, mcroot, ng_sm, nvalue_space_ss, value_lpext, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, iplplwei, iplprwei, irot, irtidx, &
                     irwtmp, isma, ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1, valuelp2, valuelptmp1, valuelptmp2, valuetmp

!write(u6,*) '  ts_test 1/2 '

do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ii = 1
  if (logic_g1415) then
    mm = iplplwei
    nn = iplprwei
    do i=1,idownwei_g131415
      valuelp = value_lpext(ii)
      mm = mm+1
      nn = nn+1
      vector2(mm) = vector2(mm)+vector1(nn)*valuelp
      vector2(nn) = vector2(nn)+vector1(mm)*valuelp
      ii = ii+1
    end do
  end if

  ii0 = ii
  if (logic_g2g4a) then
    ii = ii0
    mm0 = iplplwei
    nn0 = iplprwei+iwt_sm_s_ext
    mm = mm0            !severe_error
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp1 = value_lpext(ii)
          valuelp2 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2

        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if
  if (logic_g2g4b) then
    ii = ii0
    mm0 = iplprwei
    nn0 = iplplwei+iwt_sm_s_ext
    mm = mm0             !severe_error
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp2 = value_lpext(ii)
          valuelp1 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if
  ii0 = ii-1         !severe_error

  do icle=1,2
    if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta36 = lpsta36a
        lpend36 = lpend36a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta36 = lpsta36b
        lpend36 = lpend36b
      end if
      do iii=lpsta36,lpend36,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        ii = ii0+lpext_wei(iii+2)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        do i=1,lpext_wei(iii+3)
          vector2(mm) = vector2(mm)+vector1(nn)*value_lpext(ii)
          vector2(nn) = vector2(nn)+vector1(mm)*value_lpext(ii)
          mm = mm+1
          nn = nn+1
        end do
      end do
    end if

    if ((icle == 1) .and. logic_g35a) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta35 = lpsta35a
      lpend35 = lpend35a
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    else if ((icle == 2) .and. logic_g35b) then
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta35 = lpsta35b
      lpend35 = lpend35b
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)         !severe_error
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          vector2(mm) = vector2(mm)+valuelptmp1*value_lpext(iij)
          valuelp = valuelp+vector1(mm)*value_lpext(iij)
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp      !severe_error
      end do
    end if

    if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta34 = lpsta34a
        lpend34 = lpend34a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta34 = lpsta34b
        lpend34 = lpend34b
      end if
      do iii=lpsta34,lpend34,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp      !severe_error
      end do
    end if
    ii0 = ii0+nvalue_space_ss
  end do
end do

end subroutine inn_ext_ts_loop_unpack

subroutine inn_ext_ts_drl_loop_unpack(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, indx, ism_g2g4, iwt_sm_s_ext, logic_g1415, logic_g2g4a, &
                         logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, lpend34a, lpend34b, &
                         lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, &
                         lpsta36b, mcroot, ng_sm, value_lpext, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, iplplwei, iplprwei, irot, irtidx, &
                     irwtmp, isma, ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1, valuelp2, valuelptmp1, valuelptmp2, valuetmp

!write(u6,*) '  ts_test 2/2'

do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ii = 1
  if (logic_g1415) then
    mm = iplplwei
    nn = iplprwei
    do i=1,idownwei_g131415
      valuelp = value_lpext(ii)
      mm = mm+1
      nn = nn+1
      vector2(mm) = vector2(mm)+vector1(nn)*valuelp
      vector2(nn) = vector2(nn)+vector1(mm)*valuelp
      ii = ii+1
    end do
  end if

  ii0 = ii
  if (logic_g2g4a) then
    ii = ii0
    mm0 = iplplwei
    nn0 = iplprwei+iwt_sm_s_ext
    mm = mm0            !severe_error
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp1 = value_lpext(ii)
          valuelp2 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if

  if (logic_g2g4b) then
    ii = ii0
    mm0 = iplprwei
    nn0 = iplplwei+iwt_sm_s_ext
    mm = mm0             !severe_error
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp2 = value_lpext(ii)
          valuelp1 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if

  ii0 = ii-1         !severe_error

  do icle=1,2
    if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta36 = lpsta36a
        lpend36 = lpend36a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta36 = lpsta36b
        lpend36 = lpend36b
      end if
      do iii=lpsta36,lpend36,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        ii = ii0+lpext_wei(iii+2)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        do i=1,lpext_wei(iii+3)
          vector2(mm) = vector2(mm)+vector1(nn)*value_lpext(ii)
          vector2(nn) = vector2(nn)+vector1(mm)*value_lpext(ii)
          mm = mm+1
          nn = nn+1
        end do
      end do
    end if

    if ((icle == 1) .and. logic_g35a) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta35 = lpsta35a
      lpend35 = lpend35a
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    else if ((icle == 2) .and. logic_g35b) then
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta35 = lpsta35b
      lpend35 = lpend35b
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)         !severe_error
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          vector2(mm) = vector2(mm)+valuelptmp1*value_lpext(iij)
          valuelp = valuelp+vector1(mm)*value_lpext(iij)
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp      !severe_error
      end do
    end if

    if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta34 = lpsta34a
        lpend34 = lpend34a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta34 = lpsta34b
        lpend34 = lpend34b
      end if
      do iii=lpsta34,lpend34,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp      !severe_error
      end do
    end if
  end do

end do

end subroutine inn_ext_ts_drl_loop_unpack

subroutine inn_ext_st_loop_unpack(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, indx, ism_g2g4, iwt_sm_s_ext, logic_g1415, logic_g2g4a, &
                         logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, lpend34a, lpend34b, &
                         lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, &
                         lpsta36b, mcroot, ng_sm, nvalue_space_ss, value_lpext, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, iplplwei, iplprwei, irot, irtidx, &
                     irwtmp, isma, ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valtmp, valuelp, valuelp1, valuelp2, valuelptmp1, valuelptmp2, valuetmp

!write(u6,*) ' st_test 1/2'

do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ii = 1
  if (logic_g1415) then
    mm = iplplwei
    nn = iplprwei
    do i=1,idownwei_g131415
      valuelp = value_lpext(ii)
      mm = mm+1
      nn = nn+1
      vector2(mm) = vector2(mm)+vector1(nn)*valuelp
      vector2(nn) = vector2(nn)+vector1(mm)*valuelp
      ii = ii+1
    end do
  end if

  !write(u6,*) 'st_g2g4a',iplplwei,iplprwei,vector2(137)
  ii0 = ii
  if (logic_g2g4a) then
    ii = ii0
    mm0 = iplplwei
    nn0 = iplprwei+iwt_sm_s_ext
    mm = mm0            !severe_error
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp1 = value_lpext(ii)
          valuelp2 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if
  !write(u6,*) 'st_g2g4b',iplplwei,iplprwei,vector2(137)
  if (logic_g2g4b) then
    ii = ii0
    mm0 = iplprwei
    nn0 = iplplwei+iwt_sm_s_ext
    mm = mm0             !severe_error
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp2 = value_lpext(ii)
          valuelp1 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if
  ii0 = ii-1

  !write(u6,*) 'st_g36a',iplplwei,iplprwei,vector2(137)
  do icle=1,2
    if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta36 = lpsta36a
        lpend36 = lpend36a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta36 = lpsta36b
        lpend36 = lpend36b
      end if
      do iii=lpsta36,lpend36,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        ii = ii0+lpext_wei(iii+2)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        do i=1,lpext_wei(iii+3)
          vector2(mm) = vector2(mm)+vector1(nn)*value_lpext(ii)
          vector2(nn) = vector2(nn)+vector1(mm)*value_lpext(ii)
          mm = mm+1
          nn = nn+1
        end do
      end do
    end if

    !write(u6,*) 'st_g35a',iplplwei,iplprwei,vector2(137)
    if ((icle == 1) .and. logic_g35a) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta35 = lpsta35a
      lpend35 = lpend35a
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valtmp = value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valtmp
          valuelp = valuelp+vector1(mm)*valtmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    else if ((icle == 2) .and. logic_g35b) then
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta35 = lpsta35b
      lpend35 = lpend35b
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valtmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valtmp
          valuelp = valuelp+vector1(mm)*valtmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp      !severe_error
      end do
    end if

    !write(u6,*) 'st_g34',iplplwei,iplprwei,vector2(137)
    if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta34 = lpsta34a
        lpend34 = lpend34a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta34 = lpsta34b
        lpend34 = lpend34b
      end if
      do iii=lpsta34,lpend34,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    end if
    ii0 = ii0+nvalue_space_ss
  end do

end do

end subroutine inn_ext_st_loop_unpack

subroutine inn_ext_st_drl_loop_unpack(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: ibsm_ext, idownwei_g131415, iesm_ext, indx, ism_g2g4, iwt_sm_s_ext, logic_g1415, logic_g2g4a, &
                         logic_g2g4b, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, logic_g36b, lpend34a, lpend34b, &
                         lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, lpsta35a, lpsta35b, lpsta36a, &
                         lpsta36b, mcroot, ng_sm, value_lpext, vector1, vector2
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, icle, ii, ii0, iii, iij, ilwtmp, iplplwei, iplprwei, irot, irtidx, &
                     irwtmp, isma, ismb, lpend34, lpend35, lpend36, lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0, nna, nnb
real(kind=wp) :: valuelp, valuelp1, valuelp2, valuelptmp1, valuelptmp2, valuetmp

!write(u6,*) ' st_test 2/2'

do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ii = 1
  if (logic_g1415) then
    mm = iplplwei
    nn = iplprwei
    do i=1,idownwei_g131415
      valuelp = value_lpext(ii)
      mm = mm+1
      nn = nn+1
      vector2(mm) = vector2(mm)+vector1(nn)*valuelp
      vector2(nn) = vector2(nn)+vector1(mm)*valuelp
      ii = ii+1
    end do
  end if

  ii0 = ii
  if (logic_g2g4a) then
    ii = ii0
    mm0 = iplplwei
    nn0 = iplprwei+iwt_sm_s_ext
    mm = mm0            !severe_error
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp1 = value_lpext(ii)
          valuelp2 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if
  if (logic_g2g4b) then
    ii = ii0
    mm0 = iplprwei
    nn0 = iplplwei+iwt_sm_s_ext
    mm = mm0             !severe_error
    do ismb=1,ng_sm
      isma = Mul(ismb,ism_g2g4)
      if (isma > ismb) cycle
      ibsta = ibsm_ext(ismb)
      ibend = iesm_ext(ismb)
      iasta = ibsm_ext(isma)
      iaend = iesm_ext(isma)
      if (ismb == isma) ibsta = ibsta+1
      nna = nn0+ibsta-1
      do ib=ibsta,ibend
        nna = nna+1
        nnb = nn0+iasta-1
        valuelptmp1 = vector1(nna)
        valuelptmp2 = vector2(nna)
        do ia=iasta,min(iaend,ib-1)
          valuelp2 = value_lpext(ii)
          valuelp1 = value_lpext(ii+1)
          mm = mm+1
          nnb = nnb+1
          vector2(mm) = vector2(mm)+valuelptmp1*valuelp1+vector1(nnb)*valuelp2
          vector2(nnb) = vector2(nnb)+vector1(mm)*valuelp2
          valuelptmp2 = valuelptmp2+vector1(mm)*valuelp1
          ii = ii+2
        end do
        vector2(nna) = valuelptmp2
      end do
    end do
  end if
  ii0 = ii-1

  do icle=1,2
    if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta36 = lpsta36a
        lpend36 = lpend36a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta36 = lpsta36b
        lpend36 = lpend36b
      end if
      do iii=lpsta36,lpend36,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        ii = ii0+lpext_wei(iii+2)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        do i=1,lpext_wei(iii+3)
          valuetmp = value_lpext(ii)
          vector2(mm) = vector2(mm)+vector1(nn)*valuetmp
          vector2(nn) = vector2(nn)+vector1(mm)*valuetmp
          mm = mm+1
          nn = nn+1
        end do
      end do
    end if
    if ((icle == 1) .and. logic_g35a) then
      mm0 = iplplwei
      nn0 = iplprwei
      lpsta35 = lpsta35a
      lpend35 = lpend35a
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    else if ((icle == 2) .and. logic_g35b) then
      mm0 = iplprwei
      nn0 = iplplwei
      lpsta35 = lpsta35b
      lpend35 = lpend35b
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)         !severe_error
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp      !severe_error
      end do
    end if

    if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta34 = lpsta34a
        lpend34 = lpend34a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta34 = lpsta34b
        lpend34 = lpend34b
      end if
      do iii=lpsta34,lpend34,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    end if
  end do
end do

end subroutine inn_ext_st_drl_loop_unpack

subroutine gsd_sequence_extspace(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: indx, ivaluesta_g26, iweista_g25, iweista_g26, iweista_g28, logic_g25a, logic_g25b, logic_g26, &
                         logic_g28a, mcroot, nint_g25, nint_g28, nwei_g25, nwei_g26, nwei_g28, v_sqtwo, value_lpext, vector1, &
                         vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, ilpvalue, iplplwei, iplprwei, irot, irtidx, itmp, mm, nn, nn0
real(kind=wp) :: vlptmp, vlptmp1, vtmp

!write(u6,*) '  sd_test 1/2','  ds_test 011'

do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx
  ilpvalue = 0
  if (logic_g25a) then
    mm = iplplwei+iweista_g25-1
    nn0 = iplprwei
    do itmp=1,nint_g25
      ilpvalue = ilpvalue+1
      vlptmp = value_lpext(ilpvalue)
      nn = nn0
      do i=1,nwei_g25
        mm = mm+1
        nn = nn+1
        vector2(mm) = vector2(mm)+vector1(nn)*vlptmp
        vector2(nn) = vector2(nn)+vector1(mm)*vlptmp
      end do
    end do
  else if (logic_g25b) then
    mm = iplplwei+iweista_g25-1
    nn0 = iplprwei
    ilpvalue = ilpvalue+1
    do itmp=2,nint_g25
      ilpvalue = ilpvalue+1
      vlptmp = value_lpext(ilpvalue)
      nn = nn0
      do i=1,itmp-1
        mm = mm+1
        nn = nn+1
        vector2(mm) = vector2(mm)+vector1(nn)*vlptmp
        vector2(nn) = vector2(nn)+vector1(mm)*vlptmp
      end do
    end do

    mm = iplplwei+iweista_g28-1
    nn = iplprwei
    nn = nn+1
    do itmp=2,nwei_g28
      nn = nn+1
      vlptmp = vector2(nn)
      vlptmp1 = vector1(nn)
      ilpvalue = 0
      do i=1,itmp-1
        ilpvalue = ilpvalue+1
        vtmp = value_lpext(ilpvalue)
        mm = mm+1
        vector2(mm) = vector2(mm)+vlptmp1*vtmp
        vlptmp = vlptmp+vector1(mm)*vtmp
      end do
      vector2(nn) = vlptmp
    end do
  else if (logic_g28a) then
    mm = iplplwei+iweista_g28-1
    nn0 = iplprwei
    do nn=nn0+1,nn0+nwei_g28
      vlptmp = vector2(nn)
      vlptmp1 = vector1(nn)
      ilpvalue = 0
      do i=1,nint_g28
        ilpvalue = ilpvalue+1
        mm = mm+1
        vector2(mm) = vector2(mm)+vlptmp1*value_lpext(ilpvalue)
        vlptmp = vlptmp+vector1(mm)*value_lpext(ilpvalue)
      end do
      vector2(nn) = vlptmp
    end do
  end if

  if (logic_g26) then
    ilpvalue = ivaluesta_g26
    mm = iplplwei+iweista_g26
    nn0 = iplprwei
    do nn=nn0+1,nn0+nwei_g26
      ilpvalue = ilpvalue+1
      vlptmp = value_lpext(ilpvalue)*v_sqtwo   !for g26
      vector2(mm) = vector2(mm)+vector1(nn)*vlptmp
      vector2(nn) = vector2(nn)+vector1(mm)*vlptmp
      mm = mm+1
    end do
  end if
end do

end subroutine gsd_sequence_extspace

subroutine complete_sd_ar_ext_loop(ilweiin,irweiin,isdownwei)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: icano_nnend, icano_nnsta, indx, mcroot, value_lpext, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ilweiin, irweiin, isdownwei
integer(kind=iwp) :: ilpvalue, ilwei, irot, irtidx, irwei, mm, mm0, mmtmp, nn, nntmp
real(kind=wp) :: vlptmp, vlptmp1

!write(u6,*) 'sd_test 2/2','  td_test_2/2 012'

do irot=1,mcroot
  irtidx = indx(irot)
  ilwei = ilweiin+irtidx
  irwei = irweiin+irtidx

  ilpvalue = 0
  mm0 = ilwei
  nn = irwei+icano_nnsta-1
  do nntmp=icano_nnsta,icano_nnend
    nn = nn+1
    mm = mm0
    vlptmp1 = vector1(nn)
    vlptmp = vector2(nn)
    do mmtmp=1,isdownwei
      ilpvalue = ilpvalue+1
      mm = mm+1
      vector2(mm) = vector2(mm)+vlptmp1*value_lpext(ilpvalue)
      vlptmp = vlptmp+vector1(mm)*value_lpext(ilpvalue)
    end do
    vector2(nn) = vlptmp
  end do
end do

return

end subroutine complete_sd_ar_ext_loop

subroutine inn_ext_dd_loop_unpack(iplplweiin,iplprweiin)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: ildownwei_segdd, indx, int_dd_drl, irdownwei_segdd, logic_g49a, logic_g49b, logic_g50, mcroot, &
                         value_lpext, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin
integer(kind=iwp) :: i, icle, ii, ildownwei, iplplwei, iplprwei, irdownwei, irot, irtidx, j, mm, mm0, nn
real(kind=wp) :: valuelp, valuelptmp1, valuetmp

! 'dd_test '

do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ii = 1
  if (logic_g50) then         !arbl=.true.
    if (logic_g49b) then
      mm = iplplwei
      nn = iplprwei
      do i=1,ildownwei_segdd
        valuelp = value_lpext(ii)
        mm = mm+1
        nn = nn+1
        vector2(mm) = vector2(mm)+vector1(nn)*valuelp
        vector2(nn) = vector2(nn)+vector1(mm)*valuelp
        ii = ii+1
      end do
    end if

    ii = ii+int_dd_drl
    mm0 = iplplwei
    nn = iplprwei+1
    do icle=1,2
      do j=2,ildownwei_segdd
        nn = nn+1
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        mm = mm0
        do i=1,j-1
          mm = mm+1
          valuetmp = value_lpext(ii)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          ii = ii+1
        end do
        vector2(nn) = valuelp
      end do
      if (.not. logic_g49b) exit
      mm0 = iplprwei
      nn = iplplwei+1
    end do

  else               !drl=.true.

    ii = ii+int_dd_drl
    if (logic_g49a) then
      mm0 = iplplwei
      nn = iplprwei
      ildownwei = ildownwei_segdd
      irdownwei = irdownwei_segdd
    else
      mm0 = iplprwei
      nn = iplplwei
      ildownwei = irdownwei_segdd
      irdownwei = ildownwei_segdd
    end if
    do j=1,irdownwei
      nn = nn+1
      valuelp = vector2(nn)
      valuelptmp1 = vector1(nn)
      mm = mm0
      do i=1,ildownwei
        mm = mm+1
        valuetmp = value_lpext(ii)
        vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
        valuelp = valuelp+vector1(mm)*valuetmp
        ii = ii+1
      end do
      vector2(nn) = valuelp
    end do
  end if
end do

end subroutine inn_ext_dd_loop_unpack

subroutine inn_ext_tt_drl_loop_unpack(iplplweiin,iplprweiin,n1415)
!***********************************************************************
! 26 feb 2007 - revised

use gugaci_global, only: idownwei_g131415, indx, logic_g1415, logic_g34a, logic_g34b, logic_g35a, logic_g35b, logic_g36a, &
                         logic_g36b, lpend34a, lpend34b, lpend35a, lpend35b, lpend36a, lpend36b, lpext_wei, lpsta34a, lpsta34b, &
                         lpsta35a, lpsta35b, lpsta36a, lpsta36b, mcroot, value_lpext, vector1, vector2
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iplplweiin, iplprweiin, n1415
integer(kind=iwp) :: i, icle, ii, ii0, iii, iij, ilwtmp, iplplwei, iplprwei, irot, irtidx, irwtmp, lpend34, lpend35, lpend36, &
                     lpsta34, lpsta35, lpsta36, mm, mm0, nn, nn0
real(kind=wp) :: valuelp, valuelptmp1, valuetmp
logical(kind=iwp) :: logic_g14150, logic_g34b0, logic_g35b0, logic_g36b0

!write(u6,*) '  tt_test 2/2'

logic_g14150 = logic_g1415
logic_g36b0 = logic_g36b
logic_g35b0 = logic_g35b
logic_g34b0 = logic_g34b
if (iplplweiin == iplprweiin) then
  logic_g14150 = .false.
  logic_g36b0 = .false.
  logic_g35b0 = .false.
  logic_g34b0 = .false.
end if

do irot=1,mcroot
  irtidx = indx(irot)
  iplplwei = iplplweiin+irtidx
  iplprwei = iplprweiin+irtidx

  ii = 1
  if (logic_g14150) then
    mm = iplplwei
    nn = iplprwei
    do i=1,idownwei_g131415
      valuelp = value_lpext(ii)
      mm = mm+1
      nn = nn+1
      vector2(mm) = vector2(mm)+vector1(nn)*valuelp
      vector2(nn) = vector2(nn)+vector1(mm)*valuelp
      ii = ii+1
    end do
  end if

  ii0 = n1415         !severe_error

  do icle=1,2
    if (((icle == 1) .and. logic_g36a) .or. ((icle == 2) .and. logic_g36b0)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta36 = lpsta36a
        lpend36 = lpend36a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta36 = lpsta36b
        lpend36 = lpend36b
      end if
      do iii=lpsta36,lpend36,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        ii = ii0+lpext_wei(iii+2)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        do i=1,lpext_wei(iii+3)
          valuelp = value_lpext(ii)
          vector2(mm) = vector2(mm)+vector1(nn)*valuelp
          vector2(nn) = vector2(nn)+vector1(mm)*valuelp
          mm = mm+1
          nn = nn+1
        end do
      end do
    end if

    if (((icle == 1) .and. logic_g35a) .or. ((icle == 2) .and. logic_g35b0)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta35 = lpsta35a
        lpend35 = lpend35a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta35 = lpsta35b
        lpend35 = lpend35b
      end if
      do iii=lpsta35,lpend35,4
        mm = mm0+lpext_wei(iii)
        nn = nn0+lpext_wei(iii+1)
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          valuetmp = -value_lpext(iij)
          vector2(mm) = vector2(mm)+valuelptmp1*valuetmp
          valuelp = valuelp+vector1(mm)*valuetmp
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp      !severe_error_1202
      end do
    end if

    if (((icle == 1) .and. logic_g34a) .or. ((icle == 2) .and. logic_g34b0)) then
      if (icle == 1) then
        mm0 = iplplwei
        nn0 = iplprwei
        lpsta34 = lpsta34a
        lpend34 = lpend34a
      else
        mm0 = iplprwei
        nn0 = iplplwei
        lpsta34 = lpsta34b
        lpend34 = lpend34b
      end if
      do iii=lpsta34,lpend34,4
        ilwtmp = lpext_wei(iii)
        irwtmp = lpext_wei(iii+1)
        mm = mm0+ilwtmp
        nn = nn0+irwtmp
        iij = ii0+lpext_wei(iii+2)
        valuelp = vector2(nn)
        valuelptmp1 = vector1(nn)
        do i=1,lpext_wei(iii+3)
          vector2(mm) = vector2(mm)+valuelptmp1*value_lpext(iij)
          valuelp = valuelp+vector1(mm)*value_lpext(iij)
          iij = iij+1
          mm = mm+1
        end do
        vector2(nn) = valuelp
      end do
    end if
  end do
end do

end subroutine inn_ext_tt_drl_loop_unpack

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine ci2vb2_cvb(civec,cvbdet,iapr,ixapr,ret,ic)

use casvb_global, only: nda, ndb, ndetvb
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: civec(nda,ndb), cvbdet(ndetvb)
integer(kind=iwp), intent(in) :: iapr(ndetvb), ixapr(nda+1), ic
real(kind=wp), intent(_OUT_) :: ret
integer(kind=iwp) :: ia, ib, idetvb, ixa

if (ic == 0) then
  idetvb = 0
  do ia=1,nda
    do ixa=ixapr(ia),ixapr(ia+1)-1
      idetvb = idetvb+1
      ib = iapr(ixa)
      cvbdet(idetvb) = civec(ia,ib)
    end do
  end do
else if (ic == 1) then
  civec(:,:) = Zero
  idetvb = 0
  do ia=1,nda
    do ixa=ixapr(ia),ixapr(ia+1)-1
      idetvb = idetvb+1
      ib = iapr(ixa)
      civec(ia,ib) = cvbdet(idetvb)
    end do
  end do
else if (ic == 2) then
  idetvb = 0
  do ia=1,nda
    do ixa=ixapr(ia),ixapr(ia+1)-1
      idetvb = idetvb+1
      ib = iapr(ixa)
      civec(ia,ib) = civec(ia,ib)+cvbdet(idetvb)
    end do
  end do
else if (ic == 3) then
  ret = Zero
  idetvb = 0
  do ia=1,nda
    do ixa=ixapr(ia),ixapr(ia+1)-1
      idetvb = idetvb+1
      ib = iapr(ixa)
      ret = ret+civec(ia,ib)*cvbdet(idetvb)
    end do
  end do
end if

return

end subroutine ci2vb2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Francesco Aquilante                                    *
************************************************************************
*  CHO_get_VJ
*
*> @author F. Aquilante
*>
*> @details
*> Computes the Coulomb intermediate obtained
*> contracting the Cholesky vectors with the AO density matrix:
*>
*> \f[ \mathit{VJ}_k = \sum_{ab} L_{ab,k} D_{ab} \f]
*>
*> Reduced sets storage is used throughout the calculation.
*>
*> @note
*> Requires initialization of the Cholesky information.
*>
*> @param[out] irc     Return code
*> @param[in]  ipDLT   Pointer to density matrix, stored as packed LT, consecutive symmetry blocks
*> @param[out] VJ      Coulomb intermediate
*> @param[in]  Mvec    Number of Cholesky vectors (min. length of \p VJ)
*> @param[in]  timings Switch on/off timings printout
************************************************************************
      SUBROUTINE CHO_get_VJ(irc,ipDLT,VJ,Mvec,timings)
      Implicit Real*8 (a-h,o-z)
      Logical timings
      Integer ipDLT, Mvec
      Real*8  VJ(Mvec)
      Real*8  tread(2), tcalv(2)

      Logical  add
      Character*6  mode
      Character*10  SECNAM

      parameter (SECNAM = 'CHO_get_VJ')
      parameter (zero = 0.0d0, one = 1.0d0)

#include "cholesky.fh"
#include "choptr.fh"
#include "choorb.fh"
#include "WrkSpc.fh"

      parameter ( N2 = InfVec_N2 )

************************************************************************
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
******
      nDimRS(i,j) = iWork(ip_nDimRS-1+nSym*(j-1)+i)
************************************************************************

      IREDC = -1

      JSYM=1

      If (Mvec.ne.NumCho(jSym)) Then
         Write(6,*)SECNAM//': Mvec must be equal to NumCho(1) !!'
         irc = 77
         Return
      EndIf

      If (Mvec.lt.1) Then
         irc = 0
         Return  ! could happen in a parallel run
      EndIf

      CALL CWTIME(TOTCPU1,TOTWALL1) !start clock for total time

      do i=1,2            ! 1 --> CPU   2 --> Wall
         tread(i) = zero  !time for reading the vectors
         tcalv(i) = zero  !time for computing VJ
      end do

      iLoc = 3 ! use scratch location in reduced index arrays

C ------------------------------------------------------------------

      JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
      JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec

      Do JRED=JRED1,JRED2

       CALL Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

       if (nVrs.eq.0) goto 999

       if (nVrs.lt.0) then
         Write(6,*)SECNAM//': Cho_X_nVecRS returned nVrs < 0. STOP!!'
         call abend()
       endif

       Call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
       if(irc.ne.0)then
        Write(6,*)SECNAM//'cho_X_setred non-zero return code. rc= ',irc
        call abend()
       endif

       IREDC=JRED

       nRS = nDimRS(JSYM,JRED)

       Call GetMem('rsD','Allo','Real',ipDab,nRS)
       Call FZero(Work(ipDab),nRS)

       Call GetMem('MaxM','Max','Real',KDUM,LWORK)

       nVec  = Min(LWORK/nRS,nVrs)

       If (nVec.lt.1) Then
         WRITE(6,*) SECNAM//': Insufficient memory for batch'
         WRITE(6,*) 'LWORK= ',LWORK
         WRITE(6,*) 'min. mem. need= ',nRS+1
         irc = 33
         CALL Abend()
         nBatch = -9669  ! dummy assignment
       End If

       LREAD = nRS*nVec

       Call GetMem('rsL','Allo','Real',ipLab,LREAD)

C --- BATCH over the vectors in JSYM=1 ----------------------------

       nBatch = (nVrs-1)/nVec + 1

       DO iBatch=1,nBatch

         If (iBatch.eq.nBatch) Then
            JNUM = nVrs - nVec*(nBatch-1)
         else
            JNUM = nVec
         endif

         JVEC = nVec*(iBatch-1) + iVrs
         IVEC2 = JVEC - 1 + JNUM

         CALL CWTIME(TCR1,TWR1)

         CALL CHO_VECRD(Work(ipLab),LREAD,JVEC,IVEC2,JSYM,
     &                  NUMV,JRED,MUSED)

         If (NUMV.le.0 .or. NUMV.ne.JNUM) then
            irc=77
            RETURN
         End If

         CALL CWTIME(TCR2,TWR2)
         tread(1) = tread(1) + (TCR2 - TCR1)
         tread(2) = tread(2) + (TWR2 - TWR1)

         CALL CWTIME(TCI1,TWI1)

C --- Transform the density to reduced storage
         mode = 'toreds'
         add  = .false.
         Call switch_sto(irc,iLoc,ipDLT,ipDab,mode,add)

C ------------------------------------------------------------
C --- V{#J} <- V{#J} + sum_ab  L(ab,{#J}) * D(ab)
C=============================================================

         CALL DGEMV_('T',nRS,JNUM,
     &              One,Work(ipLab),nRS,
     &                  Work(ipDab),1,
     &              zero,VJ(jVec),1)


         CALL CWTIME(TCI2,TWI2)
         tcalv(1) = tcalv(1) + (TCI2 - TCI1)
         tcalv(2) = tcalv(2) + (TWI2 - TWI1)


       END DO  !end batch loop

C --- free memory
       Call GetMem('rsL','Free','Real',ipLab,LREAD)
       Call GetMem('rsD','Free','Real',ipDab,nRS)


999    Continue

      END DO   ! loop over red sets

      CALL CWTIME(TOTCPU2,TOTWALL2)
      TOTCPU = TOTCPU2 - TOTCPU1
      TOTWALL= TOTWALL2 - TOTWALL1

*
*---- Write out timing information
      if(timings)then

      Write(6,*)
      Write(6,*)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)'Timing from ', SECNAM,'            CPU      WALL '
      Write(6,*)'- - - - - - - - - - - - - - - - - - - - - - - - -'
         Write(6,'(2x,A26,2f10.2)')'READ VECTORS                  '
     &                           //'         ',tread(1),tread(2)
         Write(6,'(2x,A26,2f10.2)')'COMPUTE V^J                   '
     &                           //'         ',tcalv(1),tcalv(2)
         Write(6,'(2x,A26,2f10.2)')'TOTAL                         '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,*)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif

      irc=0

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Prim_Density_Matrix(D,nBas,D_p,nPrim,TM)

use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBas, nPrim
real(kind=wp), intent(inout) :: D(nBas*(nBas+1)/2)
real(kind=wp), intent(out) :: D_p(nPrim*(nPrim+1)/2)
real(kind=wp), intent(in) :: TM(nPrim,nBas)
integer(kind=iwp) :: i, j, k, l
real(kind=wp) :: Djl, TMij, TMkl, TmpDensity

D(:) = Half*D(:)
do i=1,nPrim
  do k=1,i
    TmpDensity = Zero
    do j=1,nBas
      do l=1,nBas
        TMij = TM(i,j)
        TMkl = TM(k,l)
        if (j < l) then
          Djl = D(l*(l-1)/2+j)
        else
          Djl = D(j*(j-1)/2+l)
        end if
        TmpDensity = TmpDensity+TMij*TMkl*Djl
      end do
    end do
    D_p(i*(i-1)/2+k) = TmpDensity
  end do
end do

return

end subroutine Get_Prim_Density_Matrix

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Alaska_Super_Driver(iRC)
      Implicit Real*8 (a-h,o-z)
      Character*8 Method
      Logical Do_Cholesky, Numerical, Do_DF, Do_ESPF, StandAlone, Exist,
     &        Do_Numerical_Cholesky, Do_1CCD, MCLR_Ready, Reduce_Prt
      External Reduce_Prt
      Character FileName*128, Line*180, KSDFT*16
      Character*16 StdIn
      Integer Columbus
      Character(Len=16) mstate1,mstate2
      Real*8, Allocatable:: Grad(:)
#include "warnings.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "nac.fh"
#include "alaska_root.fh"
#include "para_info.fh"
*                                                                      *
************************************************************************
*                                                                      *
      iPL=iPrintLevel(-1)
      If (Reduce_Prt().and.iPL.lt.3) iPL=0
*                                                                      *
************************************************************************
*                                                                      *
*
*     Check the input for the numerical keyword
*
*
*     copy STDINP to LuSpool
*
      LuSpool=37
      Call SpoolInp(LuSpool)
      Call Chk_Numerical(LuSpool,Numerical)
*
*     Call the numerical procedure if numerical option is available.
*     Otherwise hope that the analytic code know how to handle the
*     case.
*
      Call Get_cArray('Relax Method',Method,8)
      Call Get_iScalar('Columbus',Columbus)
*                                                                      *
************************************************************************
*                                                                      *
*     Default for Cholesky or RI/DF is to do the numerical procedure.
*     However, for pure DFT we have analytic gradients.
*
      Call DecideOnCholesky(Do_Cholesky)
      Call DecideOnDF      (Do_DF)
      Call DecideOn1CCD    (Do_1CCD)
      Call Get_iScalar('NSYM',nSym)
*
*     Default for MBPT2 is the numerical procedure but if variational
*     densities are calculated analytical gradients shall be used.
      iMp2Prpt = 0
      If(Method .eq. 'MBPT2   ') Then
         Call Get_iScalar('mp2prpt',iMp2Prpt)
*
*        Make sure that the analytic procedure is used if possible.
*
         If (nSym.eq.1 .and. iMp2Prpt.ne.2 .and..NOT.Numerical) Then
            Call WarningMessage(2,'Error in Alaska_Super_Driver')
            Write (6,*) 'Alaska: the MBPT2 module was run without the'
     &                      //' Grdt option!'
            Write (6,*) '   Correct the input and restart the'
     &                      //' calculation!'
            Call Abend()
         End If
      End If
*
      Do_Numerical_Cholesky = Do_Cholesky .or. Do_DF
      Call Get_iScalar('agrad',iForceAnalytical)
      If(iForceAnalytical .eq. 1) Do_Numerical_Cholesky=.False.
*
      ExFac=0.0D0
      If (Method.eq.'KS-DFT  '.and.Do_Numerical_Cholesky) Then
         Call Get_cArray('DFT functional',KSDFT,16)
         ExFac=Get_ExFac(KSDFT)
*
         If (Do_DF                 .or.                  ! RI/DF
     &       (Do_Cholesky.and.Do_1CCD.and.nSym.eq.1)      ! 1C-CD
     &                                ) Then
            Do_Numerical_Cholesky=.False.
         End If

      End If
*
      If (( Do_DF                    .or.
     &     (Do_Cholesky.and.Do_1CCD.and.nSym.eq.1))) Then
*
         If( (Method .eq. 'KS-DFT  ') .or.
     &       (Method .eq. 'UHF-SCF ') .or.
     &       (Method .eq. 'RHF-SCF ') .or.
     &       (Method .eq. 'CASSCF  ') .or.
     &       (Method .eq. 'RASSCF  ') .or.
     &       (Method .eq. 'GASSCF  ') .or.
     &       (Method .eq. 'DMRGSCF ') .or.
     &       (Method .eq. 'CASSCFSA') ) Then
            Do_Numerical_Cholesky= .False.
     &
         Else If(Method.eq.'MBPT2   ' .and.nSym.eq.1) Then
            Do_Numerical_Cholesky = .False.
*           Write(6,*) 'Do Numerical', Do_Numerical_Cholesky
         End If
*
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call DecideOnESPF(Do_ESPF)
*     No ESPF for NAC, right?
*     If (isNAC) Do_ESPF=.False.
*                                                                      *
************************************************************************
      if(Method .eq. 'DMRGSCFS')then
        Call Get_iScalar('SA ready',iGo)
      end if
*
      If (Numerical              .OR.
     &    Do_Numerical_Cholesky  .OR.
     &    Method .eq. 'RASSCFSA' .OR.
     &    Method .eq. 'GASSCFSA' .OR.
     &  ((Method .eq. 'DMRGSCFS').and.(iGo.ne.2)) .OR.
     &    Method .eq. 'CASPT2'   .OR.
     &  ((Method .eq. 'MBPT2').and.(iMp2Prpt.ne.2)) .OR.
     &    Method .eq. 'CCSDT'    .OR.
     &    Method .eq. 'EXTERNAL' ) Then
         If (isNAC) Then
           Call Store_Not_Grad(0,NACstates(1),NACstates(2))
           Call WarningMessage(2,'Numerical nonadiabatic coupling not'
     &                           //' implemented')
           If (Auto) Then
             iRC=0
             Return
           Else
             Call Abend()
           End If
         EndIf
*                                                                      *
************************************************************************
*                                                                      *
*        Numerical gradients to be used!
*        Alaska will automatically generate the input for CASPT2_Gradient
*        and signal to AUTO (iRC=2) to run the input file Stdin.x.
*
         If (iPL.ge.3) Then
            Write (6,*)
            Write (6,*) ' Alaska requests the Numerical_Gradient'
     &                //' module to be executed!'
            Write (6,*)
         End If
*
         LuInput=11
         LuInput=IsFreeUnit(LuInput)
         Call StdIn_Name(StdIn)
         Call Molcas_Open(LuInput,StdIn)
*
         Write (LuInput,'(A)') '>ECHO OFF'
         Write (LuInput,'(A)') '>export AL_OLD_TRAP=$MOLCAS_TRAP'
         Write (LuInput,'(A)') '>export MOLCAS_TRAP=ON'
*
         Write (LuInput,'(A)') ' &NUMERICAL_GRADIENT &End'
         Write (LuInput,'(A)') 'End of Input'
         Write (LuInput,'(A)') '>export MOLCAS_TRAP=$AL_OLD_TRAP'
         Write (LuInput,'(A)') '>ECHO ON'
         Close(LuInput)
         Call Finish(_RC_INVOKED_OTHER_MODULE_)
*                                                                      *
************************************************************************
*                                                                      *
*     These do not work in parallel. Warn and stop early, better than
*     crash or give wrong results
*
      Else If (Do_Cholesky.and.(Method.eq.'CASSCFSA')
     &        .and.(nProcs.gt.1)) Then
         Call WarningMessage(2,'Error in Alaska_Super_Driver')
         Write (6,*) 'RI SA-CASSCF analytical gradients do not work'
     &             //' correctly in parallel (yet).'
         Call Abend()
      Else If (Do_Cholesky.and.(Method.eq.'MBPT2')
     &        .and.(nProcs.gt.1)) Then
         Call WarningMessage(2,'Error in Alaska_Super_Driver')
         Write (6,*) 'RI MBPT2 analytical gradients do not work'
     &             //' correctly in parallel (yet).'
         Call Abend()
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Method.eq.'CASSCFSA' .or.
     &        (Method.eq.'DMRGSCFS' .and. iGo.ne.2)) Then
*                                                                      *
************************************************************************
*                                                                      *
*        State-Average CASSCF / DMRGSCF
*
         Call Get_iScalar('SA ready',iGo)
         Call Get_iScalar('Relax CASSCF root',iRlxRoot)

         If (iRlxRoot.eq.0) iRlxRoot=1
         If (isNAC) Then
            Write(mstate1,'(1X,I7,",",I7)') NACStates(1),NACStates(2)
         Else
            Write(mstate1,'(I16)') iRlxRoot
         End If

*        iGo=-1 non-equivalent multi state SA-CASSCF
*        iGo=0  equivalent multi state SA-CASSCF
*        iGo=2  single root SA-CASSCF
         mstate2=''
         if(iGo.ne.2)then
           Call Get_cArray('MCLR Root',mstate2,16)
         end if

* If an explicit root was requested in MCLR and none in ALASKA,
* go for it
         If (DefRoot) Then
            If (mstate2(1:1).eq.'+') Then
               mstate1=mstate2
               If (Index(mstate2,',').ne.0) Then
                  Read(mstate2,'(1X,I7,1X,I7)')
     &               NACStates(1),NACStates(2)
                  ForceNAC=.true.
               Else
                  Read(mstate2,'(1X,I15)') iRlxRoot
               End If
            End If
         End If
         mstate1(1:1)=mstate2(1:1)
         MCLR_Ready=(iGO.eq.1).and.(mstate1.eq.mstate2)

         If (MCLR_Ready.or.(iGO.gt.1)) Then
            Call Alaska(LuSpool,iRC)
*
*        Add ESPF contribution
*
            If (Do_ESPF) Then
               StandAlone=.False.
               Call ESPF(iReturn,StandAlone)
               If (iReturn.ne.0) Then
                  Call WarningMessage(2,'Error in Alaska_Super_Driver')
                  Write (6,*) 'Alaska: ESPF finish with non-zero return'
     &                      //' code!'
                  Call Abend()
               End If
            End If
*           Reset iGO to 0 to allow for new MCLR/ALASKA calculations
            If (iGo.eq.1) iGo=0
            Call Put_iScalar('SA ready',iGo)
         Else If (iGO.eq.-1) Then
            Call WarningMessage(2,'Error in Alaska_Super_Driver')
            Write (6,*) 'Gradients not implemented for SA-CASSCF'//
     &                  ' with non-equivalent weights!'
            Call Abend()
         Else
            If (iPL.ge.3) Then
               Write (6,*)
               Write (6,*)
     &           ' Alaska requests MCLR to be run before it starts'
     &           //' again!'
               Write (6,*)
            End If
*
            LuInput=11
            LuInput=IsFreeUnit(LuInput)
            Call StdIn_Name(StdIn)
            Call Molcas_open(LuInput,StdIn)
*
            Write (LuInput,'(A)') '>ECHO OFF'
            Write (LuInput,'(A)') '>export AL_OLD_TRAP=$MOLCAS_TRAP'
            Write (LuInput,'(A)') '>export MOLCAS_TRAP=ON'
*
            Write (LuInput,'(A)') ' &MCLR &End'
            If (isNAC) Then
              Write (LuInput,'(A)') 'NAC'
              Write (LuInput,'(I5,1X,I5)') NACstates(1),NACstates(2)
            EndIf
            Write (LuInput,'(A)') 'End of Input'
            Write (LuInput,'(A)') ' '
*
            FileName='ALASKINP'
            Call f_inquire(Filename,Exist)
*
            If (Exist) Then
               LuSpool2 = 77
               LuSpool2 = IsFreeUnit(LuSpool2)
               Call Molcas_Open(LuSpool2, Filename)
*
 100           Continue
               Read (LuSpool2,'(A)',End=900) Line
               Write(LuInput,'(A)') Line
               Go To 100
 900           Continue
*
               Close(LuSpool2)
*
            Else
*
               Write (LuInput,'(A)') ' &Alaska &End'
*              Write (LuInput,'(A)') 'Show'
               Write (LuInput,'(A)') 'CutOff'
               Write (LuInput,'(A)') '1.0D-7'
               Write (LuInput,'(A)') 'End of Input'
*
            End If
*
            Write (LuInput,'(A)') '>RM -FORCE $Project.MckInt'
            Write (LuInput,'(A)') '>export MOLCAS_TRAP=$AL_OLD_TRAP'
            Write (LuInput,'(A)') '>ECHO ON'
            Close(LuInput)
            Call Finish(_RC_INVOKED_OTHER_MODULE_)
*
           End If
*                                                                      *
************************************************************************
*                                                                      *
      Else If (Method.eq.'MCPDFT') Then
*                                                                      *
************************************************************************
*                                                                      *
*        MC-PDFT calculation
*
         Do_ESPF = .False.
         Call Get_iScalar('SA ready',iGo)
         Call Get_iScalar('Relax CASSCF root',iRlxRoot)

         !Andrew - I need to identify the root and make sure it is not a
         !state averaged calculation.  iGo=1 means do MCLR

         !iGo=99 means the potentials were not calculated during the
         !MCPDFT step, which is required for analytic gradients.
         If(iGO.eq.99) then
            Call WarningMessage(2,'Error in Alaska_Super_Driver')
            Write (6,*) 'MC-PDFT was run without the GRADient'//
     &                  ' keyword.  Analytic gradients require'//
     &                  ' this keyword.  Please use the GRADient'//
     &                  ' keyword in the preceeding MC-PDFT step.'
            Call Abend()
         End if

         If (iRlxRoot.eq.0) iRlxRoot=1
!         If (isNAC) Then
!            Write(mstate1,'(1X,I7,",",I7)') NACStates(1),NACStates(2)
!         Else
            Write(mstate1,'(I16)') iRlxRoot
!         End If

*        iGo=-1 non-equivalent multi state SA-CASSCF
*        iGo=0  equivalent multi state SA-CASSCF
*        iGo=2  single root SA-CASSCF
         mstate2=''
         if(iGo.ne.2)then
           Call Get_cArray('MCLR Root',mstate2,16)
         end if

* If an explicit root was requested in MCLR and none in ALASKA,
* go for it
         If (DefRoot) Then
            If (mstate2(1:1).eq.'+') Then
               mstate1=mstate2
               If (Index(mstate2,',').ne.0) Then
                  Read(mstate2,'(1X,I7,1X,I7)')
     &               NACStates(1),NACStates(2)
                  ForceNAC=.true.
               Else
                  Read(mstate2,'(1X,I15)') iRlxRoot
               End If
            End If
         End If
         mstate1(1:1)=mstate2(1:1)
         MCLR_Ready=(iGO.eq.1).and.(mstate1.eq.mstate2)

         If (MCLR_Ready.or.(iGO.gt.1)) Then
            Call Alaska(LuSpool,iRC)
*
*        Add ESPF contribution
*
!            If (Do_ESPF) Then
!               StandAlone=.False.
!               Call ESPF(iReturn,StandAlone)
!               If (iReturn.ne.0) Then
!                  Call WarningMessage(2,'Error in Alaska_Super_Driver')
!                  Write (6,*) 'Alaska: ESPF finish with non-zero return'
!     &                      //' code!'
!                  Call Abend()
!               End If
!            End If
*           Reset iGO to 0 to allow for new MCLR/ALASKA calculations
            If (iGo.eq.1) iGo=0
            Call Put_iScalar('SA ready',iGo)
         Else If (iGO.eq.-1) Then
            Call WarningMessage(2,'Error in Alaska_Super_Driver')
            Write (6,*) 'Gradients not implemented for SA-CASSCF'//
     &                  ' with non-equivalent weights!'
            Call Abend()
         Else
            If (iPL.ge.3) Then
               Write (6,*)
               Write (6,*)
     &           ' Alaska requests MCLR to be run before it starts'
     &           //' again!'
               Write (6,*)
            End If
*
            LuInput=11
            LuInput=IsFreeUnit(LuInput)
            Call StdIn_Name(StdIn)
            Call Molcas_open(LuInput,StdIn)
*
            Write (LuInput,'(A)') '>ECHO OFF'
            Write (LuInput,'(A)') '>export AL_OLD_TRAP=$MOLCAS_TRAP'
            Write (LuInput,'(A)') '>export MOLCAS_TRAP=ON'
*
            Write (LuInput,'(A)') ' &MCLR &End'
            Write (LuInput,'(A)') ' PRINT = 100'
!            If (isNAC) Then
!              Write (LuInput,'(A)') 'NAC'
!              Write (LuInput,'(I5,1X,I5)') NACstates(1),NACstates(2)
!            EndIf
            Write (LuInput,'(A)') 'End of Input'
            Write (LuInput,'(A)') ' '
*
            FileName='ALASKINP'
            Call f_inquire(Filename,Exist)
*
            If (Exist) Then
               LuSpool2 = 77
               LuSpool2 = IsFreeUnit(LuSpool2)
               Call Molcas_Open(LuSpool2, Filename)
*
 105           Continue
               Read (LuSpool2,'(A)',End=905) Line
               Write(LuInput,'(A)') Line
               Go To 105
 905           Continue
*
               Close(LuSpool2)
*
            Else
*
               Write (LuInput,'(A)') ' &Alaska &End'
*              Write (LuInput,'(A)') 'Show'
               Write (LuInput,'(A)') 'CutOff'
               Write (LuInput,'(A)') '1.0D-7'
               Write (LuInput,'(A)') 'End of Input'
*
            End If
*
            Write (LuInput,'(A)') '>RM -FORCE $Project.MckInt'
            Write (LuInput,'(A)') '>export MOLCAS_TRAP=$AL_OLD_TRAP'
            Write (LuInput,'(A)') '>ECHO ON'
            Close(LuInput)
            Call Finish(_RC_INVOKED_OTHER_MODULE_)
*
           End If


************ columbus interface ****************************************

       Else If (method.eq.'MR-CISD ' .and. Columbus.eq.1) Then

*
*       COLUMBUS MR-CI gradient:
*           effective density matrix on RUNFILE 'densao_var'
*           effective fock matrix  on RUNFILE   'FockOcc'
*           effective  D2          on GAMMA
*           G_TOC indices          on binary file gtoc
*           RUNFILE read in drvh1
*           GAMMA read in pget0
*           gtoc read in drvg1

*
*
           Call Get_iScalar('Relax CASSCF root',iRlxRoot)
           Call Alaska(LuSpool,iRC)
*                                                                      *
************************************************************************
*                                                                      *
      Else
*                                                                      *
************************************************************************
*                                                                      *
*        Read the root, as it could be a CASSCF state-specific excited
*        state calculation
*
         iRlxRoot=0
         Call Qpg_iScalar('Relax CASSCF root',Exist)
         If (Exist) Call Get_iScalar('Relax CASSCF root',iRlxRoot)
         If (iRlxRoot.eq.0) iRlxRoot=1
*
*        Go ahead and compute the gradients
*
         Call Alaska(LuSpool,iRC)
*
*        Add ESPF contribution
*
         If (Do_ESPF) Then
            StandAlone=.False.
            Call ESPF(iReturn,StandAlone)
            If (iReturn.ne.0) Then
               Call WarningMessage(2,'Error in Alaska_Super_Driver')
               Write (6,*) 'Alaska: ESPF finish with non-zero return'
     &                   //' code!'
               Call Abend()
            End If
         End If

*                                                                      *
************************************************************************
*                                                                      *
      End If
*                                                                      *
************************************************************************
*                                                                      *
* Read the gradient and store in the GRADS file
* It is done here because the gradient could have been modified by ESPF
* and we do not want to pass the root to ESPF (yet)
*
      Call Get_iScalar('Unique atoms',nsAtom)
      Call mma_Allocate(Grad,3*nsAtom,Label='Grad')
      nGrad=3*nsAtom
      Call Get_Grad(Grad,nGrad)
      If (isNAC) Then
        Call Store_Grad(Grad,nGrad,0,NACstates(1),NACstates(2))
      Else
        Call Store_Grad(Grad,nGrad,iRlxRoot,0,0)
      End If
      Call mma_deallocate(Grad)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine DMInvKap(rMFact,rIn,nrIn,rOut,nrOut,rtemp,nrtemp,
     &                    isym,iter)
************************************************************************
*                                                                      *
*     _____     -1                                                     *
*     Kappa  = M  Kappa                                                *
*          ip   pq     iq                                              *
*                                                                      *
*                                                                      *
*     In: rMFact        Factorized preconditioner (diagonal part       *
*                         of the electronic hessian that couple          *
*                         rotations with one common index)               *
*     In,Out rOut       Orbital rotaotion                              *
*                                                                      *
*     iSym              Symmetry of rotation                           *
*                                                                      *
************************************************************************

      Implicit Real*8 (a-h,o-z)
#include "Input.fh"
#include "standard_iounits.fh"
#include "Pointers.fh"
#include "dmrginfo_mclr.fh"
      Real*8 rOut(nrOut),rMFact(*),rIn(nrIn),rtemp(nrTemp)
*                                                                      *
************************************************************************
*                                                                      *
      Call DMInvKap_Internal(rMFact)
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine DMInvKap_Internal(rMFact)
      Use Iso_C_Binding
      Real*8, Target :: rMFact(*)
      Integer, Pointer :: iMFact(:)
      ip1=1
*
      if(doDMRG)then  ! yma
        call dmrg_spc_change_mclr(RGras2(1:8),nash)
        call dmrg_spc_change_mclr(RGras2(1:8),nrs2)
      end if

      Call Uncompress2(rIn,rtemp,isym)
*                                                                      *
************************************************************************
*                                                                      *
      Do jS=1,nSym
         iS=iEOr(js-1,iSym-1)+1
*                                                                      *
************************************************************************
*                                                                      *
*        kappa
*            ip
*                                                                      *
************************************************************************
*                                                                      *
         Do iI=1,nIsh(js)
            nD=nOrb(is)-nIsh(is)
            If (nd.ne.0) Then
               ip2=ipMat(is,js)+nOrb(is)*(iI-1)
               irc=0
               call c_f_pointer(c_loc(rMFact(ip1+nd**2)),iMFact,[ND])
               call dgetrs_('N',ND,1,rMFact(ip1),nd,
     &                       iMFact,rtemp(ip2),nd,irc)
               nullify(iMFact)
               If (irc.ne.0) then
                   Write(6,*) 'Error in DGETRS called from dminvkap'
                   Call Abend
               endif
               ip1=ip1+nD*(nD+1)
            End If
         End Do

*                                                                      *
************************************************************************
*                                                                      *
*        kappa
*             ap
*                                                                      *
************************************************************************
*                                                                      *
         Do iI=1,nAsh(js)
            nD=nOrb(is)-nAsh(is)
            If (nd.ne.0) Then
               ip2=ipMat(is,js)+nOrb(is)*(iI-1+nIsh(js))
               irc=0
               call c_f_pointer(c_loc(rMFact(ip1+nd**2)),iMFact,[ND])
               call dgetrs_('N',ND,1,rMFact(ip1),nd,
     &                      iMFact,rtemp(ip2),nd,irc)
               nullify(iMFact)
               If (irc.ne.0) then
                   Write(6,*) 'Error in DGETRS called from dminvkap'
                   Call Abend
               endif
               ip1=ip1+nD*(nD+1)
            End If
         End Do
*                                                                      *
************************************************************************
*                                                                      *
      End Do
*                                                                      *
************************************************************************
*
      Call Compress2(rtemp,nrtemp,rOut,nrOut,isym)

      if(doDMRG)then
        call dmrg_spc_change_mclr(LRras2(1:8),nash)
      end if
*                                                                      *
************************************************************************
*                                                                      *
*     Warn if the trail vector becomes large
*
      If ((ddot_(ndensc,rout,1,rout,1).gt.100.D0).and.(iter.eq.1)) Then
          write(LuWr,*)'****************************************'
          write(LuWr,*)'*                                      *'
          write(LuWr,*)'*           WARNING!!                  *'
          write(LuWr,*)'* Elements in the E^[2] matrix small!! *'
          write(LuWr,*)'* The calculation might diverge.       *'
          write(LuWr,*)'*                                      *'
          write(LuWr,*)'* Check your active space!!!!          *'
          write(LuWr,*)'*                                      *'
          write(LuWr,*)'* Make sure degenerate orbitals do not *'
          write(LuWr,*)'* belong to different spaces.          *'
          write(LuWr,*)'* Note that no LR code can handle      *'
          write(LuWr,*)'* 2.0d0 occupancy in active orbitals!! *'
          write(LuWr,*)'****************************************'
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End Subroutine DMInvKap_Internal
*
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2005, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine ChoMP2_Setup_Prt(irc)
!
! Thomas Bondo Pedersen, Nov. 2004 / Feb. 2005.
!
! Purpose: print setup for Cholesky MP2.

use Cholesky, only: nSym
use ChoMP2, only: ChoAlg, DecoMP2, ForceBatch, iFirst, Laplace, Laplace_nGridPoints, LnBatOrb, LnOcc, nBatch, nBatOrbT, nDel, &
                  nFro, nOcc, NumBatOrb, NumOcc, nVir, SOS_MP2
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp) :: iBatch, iCount(8), iSym

irc = 0

iCount(:) = 0

call Cho_Head('Cholesky MP2 Setup','=',80,u6)
! The values but not the names 'occupied' are updated to work
! also for batching over all orbitals
if (nBatch > 1) then
  write(u6,'(A,I6,A,I6,A)') 'The list of',nBatOrbT,' occupied orbitals has been split in',nBatch,' batches:'
else if (nBatch == 1) then
  write(u6,'(A,I6,A)') 'The list of',nBatOrbT,' occupied orbitals is not split:'
else
  write(u6,*) 'Oops, #batches over occupied orbitals is non-positive: ',nBatch
  irc = -101
  return
end if

write(u6,'(/,3X,A)') ' Batch  First   Last #Occ/irrep'
if (nSym == 1) then
  write(u6,'(3X,A)') '-------------------------------'
else if (nSym == 2) then
  write(u6,'(3X,A)') '-----------------------------------'
else if (nSym == 4) then
  write(u6,'(3X,A)') '-------------------------------------------------'
else if (nSym == 8) then
  write(u6,'(3X,A)') '-----------------------------------------------------------------------------'
else
  write(u6,*) 'Oops, #irreps is out of bounds: ',nSym
  irc = -102
  return
end if
do iBatch=1,nBatch
  if (.false.) then
    write(u6,'(3X,I6,1X,I6,1X,I6,8(1X,I6))') iBatch,iFirst(iBatch),iFirst(iBatch)+NumBatOrb(iBatch)-1, &
                                             (LnBatOrb(iSym,iBatch),iSym=1,nSym)
  else
    write(u6,'(3X,I6,1X,I6,1X,I6,8(1X,I6))') iBatch,iFirst(iBatch),iFirst(iBatch)+NumOcc(iBatch)-1,(LnOcc(iSym,iBatch),iSym=1,nSym)
  end if
  do iSym=1,nSym
    if (.false.) then
      iCount(iSym) = iCount(iSym)+LnBatOrb(iSym,iBatch)
    else
      iCount(iSym) = iCount(iSym)+LnOcc(iSym,iBatch)
    end if
  end do
end do
if (nSym == 1) then
  write(u6,'(3X,A)') '-------------------------------'
else if (nSym == 2) then
  write(u6,'(3X,A)') '-----------------------------------'
else if (nSym == 4) then
  write(u6,'(3X,A)') '-------------------------------------------------'
else if (nSym == 8) then
  write(u6,'(3X,A)') '-----------------------------------------------------------------------------'
end if
write(u6,'(3X,A,14X,8(1X,I6))') 'Total:',(iCount(iSym),iSym=1,nSym)
if (nSym == 1) then
  write(u6,'(3X,A)') '-------------------------------'
else if (nSym == 2) then
  write(u6,'(3X,A)') '-----------------------------------'
else if (nSym == 4) then
  write(u6,'(3X,A)') '-------------------------------------------------'
else if (nSym == 8) then
  write(u6,'(3X,A)') '-----------------------------------------------------------------------------'
end if
do iSym=1,nSym
  if (.false.) then
    if (iCount(iSym) /= nOcc(iSym)+nVir(iSym)+nFro(iSym)+nDel(iSym)) then
      write(u6,*) 'Oops, #Occ/irrep is incorrect....'
      irc = -103
      return
    end if
  else
    if (iCount(iSym) /= nOcc(iSym)) then
      write(u6,*) 'Oops, #Occ/irrep is incorrect....'
      irc = -103
      return
    end if
  end if
end do
if ((nBatch > 1) .and. ForceBatch) write(u6,'(/,A)') 'Notice: batching has been requested by user.'

write(u6,'(//,A)') 'The following tasks will be performed:'
write(u6,'(A)') ' * AO-to-MO transformation of original Cholesky vectors.'
if (DecoMP2) write(u6,'(A)') ' * Cholesky decomposition of (ai|bj) integrals.'
if (nBatch > 1) then
  if (DecoMP2) then
    write(u6,'(A)') ' * Presort of Cholesky vectors from (ai|bj) decomposition.'
  else
    write(u6,'(A)') ' * Presort of MO Cholesky vectors.'
  end if
end if
if (Laplace .and. SOS_MP2) then
  write(u6,'(A)') ' * Calculation of Laplace-SOS-MP2 correlation energy.'
  if (Laplace_nGridPoints == 0) then
    write(u6,'(A)') '   Numerical Laplace integration quadrature: default'
  else
    write(u6,'(A,I8)') '   Numerical Laplace integration quadrature:',Laplace_nGridPoints
  end if
else
  write(u6,'(A)') ' * On-the-fly assembly of (ai|bj) integrals and calculation of MP2 energy correction.'
  write(u6,'(A,I3,A)') '   [Cholesky algorithm:',ChoAlg,']'
end if

call xFlush(u6)

end subroutine ChoMP2_Setup_Prt

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine put_temp_data_on_intgrl(LUINTMZ_,NSYMZ_,NORBZ_)

use Intgrl, only: IAD2M, LUINTMZ, NORBZ, NSYMZ
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: LUINTMZ_, NSYMZ_, NORBZ_(8)
integer(kind=iwp) :: iAddress

iAddress = 0
IAD2M(:,:) = 0
! read the address list from the existing file
call iDaFile(LUINTMZ_,2,IAD2M,size(IAD2M),iAddress)
NSYMZ = NSYMZ_
LUINTMZ = LUINTMZ_
NORBZ(1:NSYMZ_) = NORBZ_(1:NSYMZ_)

end subroutine put_temp_data_on_intgrl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine dpgendet_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "malloc_cvb.fh"

      ibase=mstacki_cvb(0)

      iapr_add=ll(20)
      ixapr_add=ll(21)
      ibpr_add=ll(22)
      ixbpr_add=ll(23)
      iconfs_add=ll(15)
      idetvb_add=ll(17)
      do 100 ifrag=1,nfrag
      nalf_l=nalf_fr(1,ifrag)
      nbet_l=nbet_fr(1,ifrag)
      call icomb_cvb(norb,nalf_l,nda_l)
      call icomb_cvb(norb,nbet_l,ndb_l)

      nda_fr(1,ifrag)=nda_l
      nda_fr(1,ifrag)=nda_l

      call vbgendet_cvb(
     >  iw(iapr_add),iw(ixapr_add),iw(ibpr_add),iw(ixbpr_add),
     >  iw(iconfs_add),iw(idetvb_add),
     >  nconf_fr(ifrag),nconfion_fr(0,ifrag),
     >  nda_l,ndb_l,ndetvb_fr(ifrag),nel_fr(ifrag),
     >  noe,nalf_l,nbet_l,norb)
      iapr_add=iapr_add+ndetvb_fr(ifrag)
      ibpr_add=ibpr_add+ndetvb_fr(ifrag)
      ixapr_add=ixapr_add+nda_fr(1,ifrag)+1
      ixbpr_add=ixbpr_add+ndb_fr(1,ifrag)+1
      idetvb_add=idetvb_add+ndetvb_fr(ifrag)
      iconfs_add=iconfs_add+noe*nconf_fr(ifrag)
100   continue

      do 200 ifrag=1,nfrag
      iastr_fr(ifrag)=mstacki_cvb(nalf_fr(1,ifrag)*nda_fr(1,ifrag))
      ibstr_fr(ifrag)=mstacki_cvb(nbet_fr(1,ifrag)*ndb_fr(1,ifrag))
      call stringen_cvb(nel_fr(ifrag),nalf_fr(1,ifrag),
     >  iw(iastr_fr(ifrag)),iw(ibstr_fr(ifrag)),nda_fr(1,ifrag))
200   continue

      call izero(iw(ll(7)),naprodvb)
      call izero(iw(ll(8)),nbprodvb)
      k1 = mstacki_cvb((norb+1)*(nalf+1))
      k2 = mstacki_cvb(nfrag)
      k3 = mstacki_cvb(nfrag)
      k4 = mstacki_cvb(nfrag)
      k5 = mstacki_cvb(nfrag+1)
      k6 = mstacki_cvb(norb*nfrag)
      mxstack=100
      k7 = mstacki_cvb(mxstack)
      call detsort2_cvb(
     >  iw(k1),norb,nalf,nfrag,nda_fr(1,1),nalf_fr(1,1),
     >  iw(k2),iw(ll(7)),iw(k3),iw(k4),iw(k5),
     >  iw(1),iastr_fr,iw(k6),iw(k7),mxstack)
      call mfreei_cvb(k1)
      k1 = mstacki_cvb((norb+1)*(nbet+1))
      k2 = mstacki_cvb(nfrag)
      k3 = mstacki_cvb(nfrag)
      k4 = mstacki_cvb(nfrag)
      k5 = mstacki_cvb(nfrag+1)
      k6 = mstacki_cvb(norb*nfrag)
      mxstack=100
      k7 = mstacki_cvb(mxstack)
      call detsort2_cvb(
     >  iw(k1),norb,nbet,nfrag,ndb_fr(1,1),nbet_fr(1,1),
     >  iw(k2),iw(ll(8)),iw(k3),iw(k4),iw(k5),
     >  iw(1),ibstr_fr,iw(k6),iw(k7),mxstack)
      call mfreei_cvb(k1)

      call mfreei_cvb(ibase)
      call setiaprtot_cvb()
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine inisewm(prgnam,ndiff)
      Implicit Real*8 (A-H,O-Z)
      character*(*) prgnam
      character*16 pgnm_local
#include "unixinfo.fh"
      Logical DoRys

c      ProgName=prgnam
      pgnm_local=prgnam
      call locase(pgnm_local)
*
      If(pgnm_local.eq.'seward') then
      else if(pgnm_local.eq.'scf') then
        DoRys=.true.
        call inisew(DoRys,ndiff)
      else if(pgnm_local.eq.'mltpl') then
        DoRys=.true.  ! for Schwarz prescreening
        call inisew(DoRys,ndiff)
      else if(pgnm_local.eq.'alaska') then
        DoRys=.true.
        call inisew(DoRys,ndiff)
      else if(pgnm_local.eq.'mckinley') then
        DoRys=.true.
        call inisew(DoRys,ndiff)
      else if(pgnm_local.eq.'slapaf') then
      else if(pgnm_local.eq.'espf') Then
        DoRys=.true.
        call inisew(DoRys,ndiff)
      else
        DoRys=.false.
        call inisew(DoRys,ndiff)
      EndIf
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
function IWEYLF(NOPEN,MULTS)
! NUMBER OF CSF'S WITH NOPEN ORBITALS AND TOTAL MULTIPLICITY
! MULTS ACCORDING TO WEYLS FORMULAE
!
! (2S+1)/(NOPEN+1) * BION(NOPEN+1/0.5*NOPEN-S)

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp) :: IWEYLF
integer(kind=iwp), intent(in) :: NOPEN, MULTS
integer(kind=iwp) :: NCSF
integer(kind=iwp), external :: IBINOM

if ((NOPEN == 0) .and. (MULTS == 1)) then
  NCSF = 1
else if (mod(MULTS-1,2) /= mod(NOPEN,2)) then
  NCSF = 0
else if (mod(MULTS-1,2) == mod(NOPEN,2)) then
  NCSF = MULTS*IBINOM(NOPEN+1,(NOPEN+1-MULTS)/2)/(NOPEN+1)
end if

IWEYLF = NCSF

#ifdef _DEBUGPRINT_
write(u6,'(A,4I4)') '  IWEYLF SAYS : NOPEN MULTS NCSF : ',NOPEN,MULTS,NCSF
#endif

end function IWEYLF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  DEV2B  := calculate two-electron Hessian                         *
c  *                                                                   *
c  *********************************************************************
      subroutine dev2b_cvb(v1,v2,cfrom,hessorb,hesst,
     >  oaa2,aa1,gx,grad2)
c  Calculates V1 EijEkl CFROM and V2 EijEkl CFROM
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension hessorb(nprorb,nprorb),hesst(norb*norb,norb*norb)
      dimension gx(norb,norb),grad2(nprorb),v1(*),v2(*),cfrom(*)

      iv1=nint(v1(1))
      iv2=nint(v2(1))
      icfrom=nint(cfrom(1))
      n_2el=n_2el+2
      if(iform_ci(icfrom).ne.0)then
        write(6,*)' Unsupported format in DEV2B :',iform_ci(icfrom)
        call abend_cvb()
      endif

      call dev2b_2_cvb(w(iaddr_ci(iv1)),w(iaddr_ci(iv2)),
     >  w(iaddr_ci(icfrom)),
     >  hessorb,hesst,oaa2,aa1,nprorb,
     >  iw(ll(1)),iw(ll(2)),iw(ll(3)),iw(ll(4)),iw(ll(5)),iw(ll(6)),
     >  w(ll(9)),w(ll(10)),
     >  iw(ll(11)),iw(ll(12)),iw(ll(13)),iw(ll(14)),npvb,
     >  gx,grad2,
     >  nda,ndb,n1a,n1b,nam1,nbm1,norb,projcas,sc,absym(3))
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine t3dhlp4(w,v,dimp,dimpqr,denijk,ec,diagp,dimdiagp,addp)
! this routine realizes following procedure
! for symp=symq=symr
!
! ec = sum(pqr) [ W(pqr) . V(pqr) / Dijkpqr ]
!
! w        - W matrix (I)
! v        - V matrix (I)
! dimp     - dimension of p index (I)
! dimpqr   - dimension of q index (I)
! denijk   - sum of i,j,k diagonal (other) F parts (I)
! ec       - energy contribution
! diagp    - vector of diagonal parts of symmetry p (I)
! dimdiagp - dimension of diagonal parts in symmetry p (I)
! addp     - additional constant to p (Nocc) (I)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimpqr, dimdiagp, addp
real(kind=wp), intent(in) :: w(dimpqr), v(dimpqr), denijk, diagp(dimdiagp)
real(kind=wp), intent(out) :: ec
integer(kind=iwp) :: p, pqr, q, r
real(kind=wp) :: denijkp, denijkpq, denijkpqr

ec = Zero

pqr = 0
do p=3,dimp
  denijkp = denijk-diagp(p+addp)
  do q=2,p-1
    denijkpq = denijkp-diagp(q+addp)
    do r=1,q-1
      denijkpqr = denijkpq-diagp(r+addp)
      pqr = pqr+1
      ec = ec+w(pqr)*v(pqr)/denijkpqr
    end do
  end do
end do

return

end subroutine t3dhlp4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine LevMarquart(iPotte,nPick,ipPick,nEPP,ipEPCo,Coo
     &                      ,dMullig,lMax,A,iAtom,jAtom,chP
     &                      ,Thrs1,Thrs2,nThrs,Chi2B,iPrint,AboveMul)
      Implicit real*8 (a-h,o-z)

#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension Coo(3),A(2),B(2),dMullig((lMax*(lMax**2+6*lMax+11)+6)/6)
      Dimension AlfMat(4),AlfMatI(4),rStore(nPick),rinvStore(nPick)
      Dimension ARaw(2,2),BRaw(2),dA(2),Pout(nPick)
      Dimension xStore(nPick),yStore(nPick),zStore(nPick)

      Logical AboveMul(2)
      Logical lStop1,lStop2,lStop3,lStop4
      Logical lScreen1,lScreen2,lScreen3,lScreen4

      Character*60 UtChar

*
*-- Set iteration count to zero here at the top of the
*   Levenberg-Marquart thing. Initiate lambda and the exponents.
*   The exponents are not God-given, but these rather low values
*   have been found to work nicely in most cases. Set highest
*   and lowest allowed values of exponents. Set highest and lowest
*   allowed values of exponent steps.
*
      Iter=0
      nStep=0
      dLambda=1d-3
      A(1)=0.5d0
      A(2)=0.5d0
      dUpper=3.0d0
      dLower=1d-1
      ddUpper=0.7d0
      ddLower=-0.7d0

*
*-- Start loop, set zeros.
*
9901  Continue
      Iter=Iter+1
      Chi2=0.0d0
      Chi2B=0.0d0
      Do i=1,2
        BRaw(i)=0.0d0
        dA(i)=0.0d0
        Do j=1,2
          ARaw(i,j)=0.0d0
        Enddo
      Enddo

*
*-- Compute distances and store them.
*
      Do iP=1,nPick
        ind=iWork(ipPick+iP-1)
        x=Work(ipEPCo+(ind-1)*3+0)-Coo(1)
        y=Work(ipEPCo+(ind-1)*3+1)-Coo(2)
        z=Work(ipEPCo+(ind-1)*3+2)-Coo(3)
        xStore(iP)=x
        yStore(iP)=y
        zStore(iP)=z
        rStore(iP)=sqrt(x**2+y**2+z**2)
        rinvStore(iP)=1.0d0/rStore(iP)
      Enddo

*
*-- Compute the electric potential and the difference between true and
*   modelled potential. Also compute first derivatives. Formaly, there
*   are second derivatives as well, but they are neglected for
*   stability reasons. For this relatively simple non-linear problem,
*   it is probably not meaningful to code a more intelligent
*   routine that includes the second derivatives with some
*   stabalizing modifications.
*
      DerMax=0d0
      Do iP=1,nPick
        r=rStore(iP)
        rinv=rinvStore(iP)
        x=xStore(iP)
        y=yStore(iP)
        z=zStore(iP)
        Potte=ElPot(r,rinv,x,y,z,dMullig,lMax,A,chP,.true.,.true.)
        Diffo=Work(iPotte+iP-1)-Potte
        Der1=dMullig(1)*(1.0d0+2.0d0*A(1)*r)*exp(-2.0d0*A(1)*r)
        Der2=(dMullig(2)*x+dMullig(3)*y+dMullig(4)*z)
     &      *(A(2)**2+2.0d0*A(2)**3*r)*exp(-2.0d0*A(2)*r)
        If(abs(Der1).gt.DerMax)Dermax=abs(Der1)
        If(abs(Der2).gt.DerMax)Dermax=abs(Der2)
*
*---- Assemble the alpha-matrix, the beta-vector and the chi2 scalar.
*
        Chi2=Chi2+Diffo**2
        BRaw(1)=BRaw(1)+Diffo*Der1
        BRaw(2)=BRaw(2)+Diffo*Der2
        ARaw(1,1)=ARaw(1,1)+Der1*Der1
        ARaw(2,1)=ARaw(2,1)+Der2*Der1
        ARaw(2,2)=ARaw(2,2)+Der2*Der2
      Enddo
      Chi2=Chi2/dble(nPick)

*
*-- Check if numerical and statistical well-behaved calculations are
*   expected or not.
*
      If(nPick.lt.5) then
        Write(6,*)
        Write(6,'(A)')' Error in numerical fit for exponent!'
        Write(6,'(A)')'    Too few electric potential points have'
        Write(6,'(A,2I4)')'    been sampled for (At1,At2):'
     &                              ,iAtom,jAtom
        Write(6,*)
        Call Quit(_RC_GENERAL_ERROR_)
      Endif
      If(DerMax.lt.1d-4) then
        Write(6,*)
        Write(6,'(A)')' Error in numerical fit for exponent!'
        Write(6,'(A)')'    To small derivative for parameter'
        Write(6,'(A,2I4)')'    in centre (At1,At2):'
     &                              ,iAtom,jAtom
        Write(6,'(A,E12.4)')'    Maximal derivative:',DerMax
        Write(6,*)
        Write(6,'(A)')'    Either include closer points, give a'
        Write(6,'(A)')'    better initial estimate, or increase'
        Write(6,'(A)')'    multipole magnitude threshold.'
        Write(6,*)
        Call Quit(_RC_GENERAL_ERROR_)
      Endif

*
*-- Solve the linear system to get step, dA.
*
      Call SolveA(AlfMat,AlfMatI,dLambda,dMullig,lMax
     &           ,ARaw,BRaw,dA,iPrint,AboveMul,ddUpper,ddLower)

*
*-- Make a screening of dA: if the maximal or minimal exponent
*   has been reached, but the optimization still pushes on, screen
*   them by putting them as zero, and modifying abovemul.
*
      Do i=1,2
        If(AboveMul(i)) then
          lScreen1=(A(i)+1d-8).gt.dUpper
          lScreen2=(dA(i)+1d-8).gt.ddUpper
          lScreen3=(A(i)-1d-8).lt.dLower
          lScreen4=(dA(i)-1d-8).lt.ddLower
          If((lScreen1.and.lScreen2).or.(lScreen3.and.lScreen4)) then
            dA(i)=0.0d0
            AboveMul(i)=.false.
          Endif
        Endif
      Enddo
      If(iPrint.ge.7) then
        Call RecPrt('deltaA',' ',dA,2,1)
      Endif

*
*-- Construct trial parameters and compute the chi2-scalar for
*   the trial parameters. To keep things within reasonable bounds
*   do not exceed certain values.
*
      B(1)=A(1)+dA(1)
      B(2)=A(2)+dA(2)
      If(B(1).lt.dLower)B(1)=dLower
      If(B(2).lt.dLower)B(2)=dLower
      If(B(1).gt.dUpper)B(1)=dUpper
      If(B(2).gt.dUpper)B(2)=dUpper
      Do iP=1,nPick
        r=rStore(iP)
        rinv=rinvStore(iP)
        x=xStore(iP)
        y=yStore(iP)
        z=zStore(iP)
        Potte=ElPot(r,rinv,x,y,z,dMullig,lMax,B,chP,.true.,.true.)
        Diffo=Work(iPotte+iP-1)-Potte
        Chi2B=Chi2B+Diffo**2
      Enddo
      Chi2B=Chi2B/dble(nPick)

*
*-- Take appropriate action given the different Stop-criterion. They
*   measure the following: (1) The error should not change too much
*   between steps; observe that it is not meaningful to have a too
*   tight threshold in this regard due to the statistical nature of
*   the problem. (2) The modifier parameter has to stabalize and not
*   be far out in the linear region, rather in the second order regime.
*   (3) The last step should be a decrease. (4) A certain number of
*   steps should preceed that decreases the error; this threshold
*   'overlaps' some with second threshold. Halt the optimization if
*   no convergence is reached after 40 iterations. This is by far
*   a generous limit.
*
      lStop1=abs(Chi2-Chi2B).lt.Thrs1
      lStop2=dLambda.lt.Thrs2
      lStop3=Chi2.gt.Chi2B
      lStop4=nStep.ge.nThrs
      If(iPrint.ge.6) then
        Write(6,*)
        Write(6,790)Iter
        Write(6,794)'Chi2','Chi2, trial','Lambda'
        Write(6,791)Chi2,Chi2B,dLambda
        Write(6,795)'Exponents:','Charge','Dipole'
        Write(6,792)A(1),A(2)
      Endif
      If(lStop1.and.lStop2.and.lStop3.and.lStop4) then
        A(1)=B(1)
        A(2)=B(2)
        Go To 9902
      Endif
      If(Iter.gt.40) then
        Write(6,*)
        Write(6,*)'No convergence in the Levenberg-Marquart section.'
        Call Quit(_RC_NOT_CONVERGED_)
      Endif
      If(Chi2B.ge.Chi2) then
        dLambda=dLambda*10.0d0
        Go To 9901
      Else
        dLambda=dLambda*0.1d0
        nStep=nStep+1
        A(1)=B(1)
        A(2)=B(2)
        Go To 9901
      Endif

9902  Continue

*
*-- Optional printing when convergence is reached.
*
      If(iPrint.ge.5) then
        Write(6,*)
        Write(6,*)
        Write(6,793)Iter
        Write(6,794)'Chi2','Chi2, trial','Lambda'
        Write(6,791)Chi2,Chi2B,dLambda
        Write(6,795)'Exponents:','Charge','Dipole'
        Write(6,792)A(1),A(2)
        Do iP=1,nPick
          r=rStore(iP)
          rinv=rinvStore(iP)
          x=xStore(iP)
          y=yStore(iP)
          z=zStore(iP)
          Pout(iP)=ElPot(r,rinv,x,y,z,dMullig,lMax,A,chP,.true.,.true.)
        Enddo
        Write(UtChar,'(A,2I3)')'Approximate partial density potential,'
     &                       //' centre',iAtom,jAtom
        Call RecPrt(UtChar,' ',Pout,nPick,1)
        Call RecPrt('Distance to points',' ',rStore,nPick,1)
      Endif

790   Format('Levenberg-Marquart optimization. Iteration:',I3)
794   Format('   ',A,'          ',A,'   ',A)
791   Format(3(E13.6,' '))
795   Format(' ',A,' ',A,'      ',A)
792   Format('       ',2F12.6)
793   Format('Convergence reached in iteration ',I2)

*
*-- And yes, there is an end here as well.
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nEPP)
      End


*
*-- The electric potential with diffuse s- and p-functions. No
*   higher than d-functions (with non-zero trace).
*
      real*8 Function ElPot(r,rinv,x,y,z,dMullig,lMax,A,chP
     &                               ,lDOrNot1,lDOrNot2)
      Implicit real*8 (a-h,o-z)

#include "WrkSpc.fh"
#include "warnings.fh"

      Dimension A(2),dMullig((lMax*(lMax**2+6*lMax+11)+6)/6)
      Dimension dL2(6),dL3(10),dL4(15),dL5(21)

      Logical lDOrNot1,lDOrNot2

      ElPot=0.0d0
      If(lMax.ge.0) then
        If(lDOrNot1) then
          dCh=chP*rinv
          dCh=dCh+dMullig(1)*rinv*(1.0d0-(1.0d0+A(1)*r)
     &                          *exp(-2.0d0*A(1)*r))
          ElPot=dCh
        Else
          dL2(1)=dMullig(1)+chP
          ElPot=ElPot+ElPointPot(rinv,x,y,z,0,dL2)
        Endif
      Endif
      If(lMax.ge.1) then
        If(lDOrNot2) then
          ar=A(2)*r
          dM=(x*dMullig(2)+y*dMullig(3)+z*dMullig(4))
     &       *rinv**3*(1.0d0-(1.0d0+2.0d0*ar+2.0d0*ar**2+ar**3)
     &       *exp(-2.0d0*ar))
          ElPot=ElPot+dM
        Else
          dL2(1)=dMullig(2)
          dL2(2)=dMullig(3)
          dL2(3)=dMullig(4)
          ElPot=ElPot+ElPointPot(rinv,x,y,z,1,dL2)
        Endif
      Endif
      If(lMax.ge.2) then
        dL2(1)=dMullig(5)
        dL2(2)=dMullig(6)
        dL2(3)=dMullig(7)
        dL2(4)=dMullig(8)
        dL2(5)=dMullig(9)
        dL2(6)=dMullig(10)
        ElPot=ElPot+ElPointPot(rinv,x,y,z,2,dL2)
      Endif
      If(lMax.ge.3) then
        dL3(1)=dMullig(11)
        dL3(2)=dMullig(12)
        dL3(3)=dMullig(13)
        dL3(4)=dMullig(14)
        dL3(5)=dMullig(15)
        dL3(6)=dMullig(16)
        dL3(7)=dMullig(17)
        dL3(8)=dMullig(18)
        dL3(9)=dMullig(19)
        dL3(10)=dMullig(20)
        ElPot=ElPot+ElPointPot(rinv,x,y,z,3,dL3)
      Endif
      If(lMax.ge.4) then
        dL4(1)=dMullig(21)
        dL4(2)=dMullig(22)
        dL4(3)=dMullig(23)
        dL4(4)=dMullig(24)
        dL4(5)=dMullig(25)
        dL4(6)=dMullig(26)
        dL4(7)=dMullig(27)
        dL4(8)=dMullig(28)
        dL4(9)=dMullig(29)
        dL4(10)=dMullig(30)
        dL4(11)=dMullig(31)
        dL4(12)=dMullig(32)
        dL4(13)=dMullig(33)
        dL4(14)=dMullig(34)
        dL4(15)=dMullig(35)
        ElPot=ElPot+ElpointPot(rinv,x,y,z,4,dL4)
      Endif
      If(lMax.ge.5) then
        dL5(1)=dMullig(36)
        dL5(2)=dMullig(37)
        dL5(3)=dMullig(38)
        dL5(4)=dMullig(39)
        dL5(5)=dMullig(40)
        dL5(6)=dMullig(41)
        dL5(7)=dMullig(42)
        dL5(8)=dMullig(43)
        dL5(9)=dMullig(44)
        dL5(10)=dMullig(45)
        dL5(11)=dMullig(46)
        dL5(12)=dMullig(47)
        dL5(13)=dMullig(48)
        dL5(14)=dMullig(49)
        dL5(15)=dMullig(50)
        dL5(16)=dMullig(51)
        dL5(17)=dMullig(52)
        dL5(18)=dMullig(53)
        dL5(19)=dMullig(54)
        dL5(20)=dMullig(55)
        dL5(21)=dMullig(56)
        ElPot=ElPot+ElpointPot(rinv,x,y,z,5,dL5)
      Endif
      If(lMax.ge.6) then
        Write(6,*)
        Write(6,*)'Oops! You hit the roof with respect to angular'
     &          //' momentum. Lower that, or do some programming.'
        Call Quit(_RC_GENERAL_ERROR_)
      Endif

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2022, Jie J. Bao                                       *
************************************************************************
******************************************************************
* history:                                                       *
* Jie J. Bao, on Apr. 11, 2022, created this file.               *
******************************************************************


      Subroutine CMSNewton(R,GDorbit,GDstate,Dgorbit,Dgstate,nGD)
      use CMS, only:CMSNotConverged,CMSThres,NeedMoreStep,
     &              nPosHess,LargestQaaGrad,NCMSScale
      use stdalloc, only : mma_allocate, mma_deallocate
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.h"
      INTEGER nGD
      Real*8 R(lRoots**2),
     &       GDorbit(nGD),GDstate(nGD),
     &       Dgorbit(nGD),Dgstate(nGD)
      Real*8,DIMENSION(:),Allocatable::X,Hess,Grad,EigVal,deltaR,DDg,
     &                                 XScr,GScr,ScrDiag,
     &                                 RCopy,GDCopy,DgCopy

      Real*8,DIMENSION(:,:),Allocatable::RotMat
      INTEGER iStep,nDDg,lRoots2,NAC2,
     &        nSPair,nSPair2,nScr
      Real*8 Qnew,Qold
      Logical Saved

*     preparation
      lRoots2=lRoots**2
      NAC2=NAC**2
      nDDg=lRoots2**2
      nSPair=(lRoots-1)*lRoots/2
      nSPair2=nSPair**2
      CMSThres=CMSThreshold
      CALL mma_allocate(DDg    ,nDDg     )
      Call mma_allocate(X      ,nSPair   )
      Call mma_allocate(XScr   ,nSPair   )
      Call mma_allocate(GScr   ,nSPair   )
      Call mma_allocate(Grad   ,nSPair   )
      Call mma_allocate(Hess   ,nSPair2  )
      Call mma_allocate(EigVal ,nSPair   )
      CALL mma_allocate(DeltaR ,lRoots2  )
      CALL mma_allocate(GDCopy ,nGD      )
      CALL mma_allocate(DgCopy ,nGD      )
      CALL mma_allocate(RCopy  ,lRoots2  )
      CALL mma_allocate(RotMat ,lRoots,lRoots)
*     Step 0
      iStep=0
      Qold=0.0d0
*     Note that the following six lines appear as a group
      CALL RotGD(GDstate,R,nGD,lRoots,NAC2)
      CALL RotGD(Dgstate,R,nGD,lRoots,NAC2)
      CALL TransposeMat(Dgorbit,Dgstate,nGD,lRoots2,NAC2)
      CALL TransposeMat(GDorbit,GDstate,nGD,lRoots2,NAC2)
      CALL CalcDDg(DDg,GDorbit,Dgorbit,nDDg,nGD,lRoots2,NAC2)
      CALL CalcQaa(Qnew,DDg,lRoots,nDDg)
      nPosHess=0
      LargestQaaGrad=0.0d0
      Qold=Qnew
      CALL PrintCMSIter(iStep,Qnew,Qold,R,lRoots)
      CALL CalcGradCMS(Grad,DDg,nDDg,lRoots,nSPair)
      CALL CalcHessCMS(Hess,DDg,nDDg,lRoots,nSPair)
      CALL GetDiagScr(nScr,Hess,EigVal,nSPair)
      CALL mma_allocate(ScrDiag,nScr     )

*     Starting iteration
      DO WHILE(CMSNotConverged)
       iStep=iStep+1
       Qold=Qnew
       IF(iStep.gt.iCMSIterMax) THEN
         write(6,'(4X,A)')'NOT CONVERGED AFTER MAX NUMBER OF CYCLES'
         Exit
       END IF

       CALL DCopy_(lRoots2,R,1,RCopy,1)
       CALL DCopy_(nGD,GDState,1,GDCopy,1)
       CALL DCopy_(nGD,DgState,1,DgCopy,1)

       CALL CalcNewX(X,Hess,Grad,nSPair,
     &               XScr,GScr,EigVal,ScrDiag,nScr)
       CALL UpDateRotMat(R,DeltaR,X,lRoots,nSPair)

       CALL RotGD(GDstate,DeltaR,nGD,lRoots,NAC2)
       CALL RotGD(Dgstate,DeltaR,nGD,lRoots,NAC2)
       CALL TransposeMat(Dgorbit,Dgstate,nGD,lRoots2,NAC2)
       CALL TransposeMat(GDorbit,GDstate,nGD,lRoots2,NAC2)
       CALL CalcDDg(DDg,GDorbit,Dgorbit,nDDg,nGD,lRoots2,NAC2)
       CALL CalcQaa(Qnew,DDg,lRoots,nDDg)

       NCMSScale=0
       Saved=.true.
       IF((Qold-Qnew).gt.CMSThreshold) THEN
        If(iStep.gt.ICMSIterMin) Then
*        When Onew is less than Qold, scale the rotation matrix
         CALL CMSScaleX(X,R,DeltaR,Qnew,Qold,
     &                  RCopy,GDCopy,DgCopy,
     &                  GDstate,GDOrbit,Dgstate,DgOrbit,DDg,
     &                  nSPair,lRoots2,nGD,NAC2,nDDg,Saved)
        End If
       END IF
       CALL PrintCMSIter(iStep,Qnew,Qold,R,lRoots)
       CALL AntiOneDFoil(RotMat,R,lRoots,lRoots)
       CALL PrintMat('ROT_VEC','CMS-PDFT temp',
     &                RotMat,lroots,lroots,7,13,'T')

       IF(.not. Saved) THEN
        CMSNotConverged=.true.
*        Exit
       END IF
*      sanity check
       IF(abs(Qnew-Qold).lt.CMSThreshold) THEN
        CMSNotConverged=.false.
        If(NeedMoreStep)         CMSNotConverged=.true.
        If(iStep.lt.iCMSIterMin) CMSNotConverged=.true.
        If(NCMSScale.gt.0)       CMSNotConverged=.true.
       END IF
       IF(CMSNotConverged) THEN
        CALL CalcGradCMS(Grad,DDg,nDDg,lRoots,nSPair)
        CALL CalcHessCMS(Hess,DDg,nDDg,lRoots,nSPair)
       ELSE
        write(6,'(4X,A)')'CONVERGENCE REACHED'
       END IF
      END DO

      CALL mma_deallocate(DDg    )
      Call mma_deallocate(X      )
      Call mma_deallocate(XScr   )
      Call mma_deallocate(GScr   )
      Call mma_deallocate(Grad   )
      Call mma_deallocate(Hess   )
      Call mma_deallocate(EigVal )
      CALL mma_deallocate(DeltaR )
      CALL mma_deallocate(ScrDiag)
      CALL mma_deallocate(GDCopy )
      CALL mma_deallocate(DgCopy )
      CALL mma_deallocate(RCopy  )
      CALL mma_deallocate(RotMat )
      RETURN
      End Subroutine

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Sp_Mlt(W_In,ne,W_out,nVec,C,nab)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ne, nVec, nab
real(kind=wp), intent(in) :: W_In(ne,nVec), C(ne,nab)
real(kind=wp), intent(out) :: W_Out(nVec,nab)
integer(kind=iwp), parameter :: meMax = 10
integer(kind=iwp) :: iab, iAux(meMax+1), ie, me

do iab=1,nab
  me = 0
  do ie=1,ne
    if (C(ie,iab) /= Zero) then
      me = me+1
      iAux(me) = ie
      if (me > meMax) exit
    end if
  end do

  select case (me)

    case (1)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)
    case (2)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)
    case (3)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)+C(iAux(3),iab)*W_In(iAux(3),:)
    case (4)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)+C(iAux(3),iab)*W_In(iAux(3),:)+ &
                     C(iAux(4),iab)*W_In(iAux(4),:)
    case (5)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)+C(iAux(3),iab)*W_In(iAux(3),:)+ &
                     C(iAux(4),iab)*W_In(iAux(4),:)+C(iAux(5),iab)*W_In(iAux(5),:)
    case (6)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)+C(iAux(3),iab)*W_In(iAux(3),:)+ &
                     C(iAux(4),iab)*W_In(iAux(4),:)+C(iAux(5),iab)*W_In(iAux(5),:)+C(iAux(6),iab)*W_In(iAux(6),:)
    case (7)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)+C(iAux(3),iab)*W_In(iAux(3),:)+ &
                     C(iAux(4),iab)*W_In(iAux(4),:)+C(iAux(5),iab)*W_In(iAux(5),:)+C(iAux(6),iab)*W_In(iAux(6),:)+ &
                     C(iAux(7),iab)*W_In(iAux(7),:)
    case (8)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)+C(iAux(3),iab)*W_In(iAux(3),:)+ &
                     C(iAux(4),iab)*W_In(iAux(4),:)+C(iAux(5),iab)*W_In(iAux(5),:)+C(iAux(6),iab)*W_In(iAux(6),:)+ &
                     C(iAux(7),iab)*W_In(iAux(7),:)+C(iAux(8),iab)*W_In(iAux(8),:)
    case (9)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)+C(iAux(3),iab)*W_In(iAux(3),:)+ &
                     C(iAux(4),iab)*W_In(iAux(4),:)+C(iAux(5),iab)*W_In(iAux(5),:)+C(iAux(6),iab)*W_In(iAux(6),:)+ &
                     C(iAux(7),iab)*W_In(iAux(7),:)+C(iAux(8),iab)*W_In(iAux(8),:)+C(iAux(9),iab)*W_In(iAux(9),:)
    case (10)
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)+C(iAux(3),iab)*W_In(iAux(3),:)+ &
                     C(iAux(4),iab)*W_In(iAux(4),:)+C(iAux(5),iab)*W_In(iAux(5),:)+C(iAux(6),iab)*W_In(iAux(6),:)+ &
                     C(iAux(7),iab)*W_In(iAux(7),:)+C(iAux(8),iab)*W_In(iAux(8),:)+C(iAux(9),iab)*W_In(iAux(9),:)+ &
                     C(iAux(10),iab)*W_In(iAux(10),:)
    case default
      W_Out(:,iab) = C(iAux(1),iab)*W_In(iAux(1),:)+C(iAux(2),iab)*W_In(iAux(2),:)+C(iAux(3),iab)*W_In(iAux(3),:)+ &
                     C(iAux(4),iab)*W_In(iAux(4),:)+C(iAux(5),iab)*W_In(iAux(5),:)+C(iAux(6),iab)*W_In(iAux(6),:)+ &
                     C(iAux(7),iab)*W_In(iAux(7),:)+C(iAux(8),iab)*W_In(iAux(8),:)+C(iAux(9),iab)*W_In(iAux(9),:)+ &
                     C(iAux(10),iab)*W_In(iAux(10),:)
      do ie=iAux(meMax+1),ne
        if (C(ie,iab) /= Zero) W_Out(:,iab) = W_Out(:,iab)+C(ie,iab)*W_In(ie,:)
      end do
  end select
end do

return

end subroutine Sp_Mlt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE FRMDSCN(VEC,NREC,LBLK,LU)
*
* Read  VEC as multiple record file, NREC records read
*
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION LREC(1)
*. OUtput
      DIMENSION VEC(*)
*
      IOFF = 1
      DO IREC = 1, NREC
        CALL IFRMDS(LREC(1),1,LBLK,LU)
        CALL FRMDSC(VEC(IOFF),  LREC(1),     LBLK,       LU,   IMZERO,
     &                IAMPACK)
        IOFF = IOFF + LREC(1)
      END DO
*
      RETURN
      END
C !!! End trace !!!

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cartoneY(L,Lmax,onecontr,ncontrac,
     *MxcontL,onecartY)
      implicit real*8 (a-h,o-z)
      dimension onecontr(MxcontL,MxcontL,-Lmax:Lmax,3),
     *onecartY(MxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1))
cbs   arranges the cartesian one-electron integrals for Y
cbs   on a quadratic matrix
      ipnt(I,J)=(max(i,j)*(max(i,j)-1))/2+min(i,j)
cbs   + + Integrals    m || mprime     mprime=m+1
      do Mprime=2,L
      M=mprime-1
      iaddr=ipnt(Mprime+L+1,M+L+1)
      do jcont=1,ncontrac
      do icont=1,ncontrac
      onecartY(icont,jcont,iaddr)=
     *onecartY(icont,jcont,iaddr)
     *-0.25d0*(
     *onecontr(icont,jcont,Mprime,1)+
     *onecontr(icont,jcont,-Mprime,3))
      enddo
      enddo
      enddo
cbs   - - Integrals    m || mprime     mprime=m-1
      do Mprime=1,L-1
      M=mprime+1
      iaddr=ipnt(-Mprime+L+1,-M+L+1)
      do jcont=1,ncontrac
      do icont=1,ncontrac
      onecartY(icont,jcont,iaddr)=
     *onecartY(icont,jcont,iaddr)
     *+0.25d0*(
     *onecontr(icont,jcont,Mprime,3)+
     *onecontr(icont,jcont,-Mprime,1))
      enddo
      enddo
      enddo
cbs    0 || 1 integrals
      pre=-sqrt(0.125d0)
      iaddr=ipnt(L+1,L+2)
      do jcont=1,ncontrac
      do icont=1,ncontrac
      onecartY(icont,jcont,iaddr)=
     *onecartY(icont,jcont,iaddr)
     *+pre*
     *(onecontr(icont,jcont,1,1)+
     *onecontr(icont,jcont,-1,3))
      enddo
      enddo
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DecideonESPF(Do_ESPF)

use Definitions, only: iwp

implicit none
logical(kind=iwp), intent(out) :: Do_ESPF
integer(kind=iwp) :: iOption

call Get_iScalar('System BitSwitch',iOption)

! this is a logical variable (logical function)
Do_ESPF = btest(iOption,11)

return

end subroutine DecideonESPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReMap_U_k(U_k,nU_k,U_k_New,nU_k_New,iSO_ab)

use Index_Functions, only: nTri_Elem
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nU_k, nU_k_New, iSO_ab(2,nU_k)
real(kind=wp), intent(in) :: U_k(nU_k)
real(kind=wp), intent(out) :: U_k_New(nU_k_New)
integer(kind=iwp) :: i, ij, j, k

do k=1,nU_k
  i = iSO_ab(1,k)
  j = iSO_ab(2,k)
  ij = nTri_Elem(i-1)+j
  if (i == j) then
    U_k_New(ij) = U_k(k)
  else
    U_k_New(ij) = Half*U_k(k)
  end if
end do

return

end subroutine ReMap_U_k

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Ohrn                                            *
************************************************************************
*  SelectLoc
*
*> @brief
*>   Localize the perturbation LoProp-style. This way a perturbation can be applied selectively on parts of a molecule
*> @author A. Ohrn
*>
*> @details
*> Collect \p H0 as it is, clean the vacuum part so only perturbation
*> is there. Collect LoProp transformation and transform. Put zeros
*> according to user specification and transform back. The localized
*> perturbation is added to the one-electron Hamiltonian and \p H0 is
*> returned.
*>
*> @param[in,out] H0    The one-electron Hamiltonain with perturbations so far. On output the localized perturbed one-electron Hamiltonian
*> @param[in]     nSize Size of the triangular \p H0 with the additional origo and nuclear contribution
************************************************************************
      Subroutine SelectLoc(H0,nSize)
      Implicit Real*8 (a-h,o-z)

#include "input.fh"
#include "WrkSpc.fh"

      Parameter (ZERO=0.0D+0,ONE=1.0D+0)
      Real*8 H0(nSize)
      Character*8 Label
      Logical Debug,OneOrNot1,OneOrNot2,OneOrNot3,OneOrNot4,OneOrNot
      Logical CrazySet
      Data Debug /.false./
      Dimension idum(1)

*
*-- Commence!
*
      Write(6,*)
      Write(6,*)' The perturbation will be localized "LoProp style".'
      Write(6,*)
      Write(6,*)' -- Number of basis subsets:',nSets
      Do k=1,nSets
        Write(6,*)'    ',iSelection(1,k),iSelection(2,k)
      Enddo
      Write(6,*)' -- Atoms and bonds logical flags:'
      Do i=1,nSets
        Write(6,*)'      Set atom:  ',i,Atoms(i)
        Do j=i+1,nSets
          Write(6,*)'      Sets bond: ',i,j,Bonds(i,j)
        Enddo
      Enddo

*
*-- No symmetry allowed.
*
      Call Get_iScalar('nSym',nSym)
      If(nSym.ne.1) then
        Write(6,*)
      Write(6,*)' You have specified symmetry. The keyword "SELEctive"',
     & ' in FFPT is incompatible with this.'
        Write(6,*)' Aborting....'
        Call Abend()
      Endif

*
*-- Collect the overlap and some auxiliaries for LoProp.
*
      Call GetMem('Orbital_Type','Allo','Inte',ipType,nBas(1))
      Call GetMem('Center_Index','Allo','Inte',ipCenter,nBas(1))
      Call Get_iArray('Orbital Type',iWork(ipType),nBas(1))
      Call Get_iArray('Center Index',iWork(ipCenter),nBas(1))
      Do i=ipType,ipType+nBas(1)-1
        If(iWork(i).ne.1.and.iWork(i).ne.0) then
          Write(6,*)'Orbital type vector is corrupted!'
          Call Abend()
        Endif
      Enddo

      iOpt2=2
      iOpt1=1
      iOpt0=0
      Label='MltPl  0'
      iRc=-1
      iSymLbl=1
      nInts=0
      Call iRdOne(iRc,iOpt1,Label,1,idum,iSymLbl)
      If (iRc.eq.0) nInts=idum(1)
      Call GetMem('SMatTr','Allo','Real',ipSTr,nInts+4)
      Call RdOne(iRc,iOpt0,Label,1,Work(ipSTr),iSymLbl)
      If(iRc.ne.0) then
        Write(6,*)'Error reading overlap matrix in SELECTLOC!'
        Call Abend()
      Endif
*-- Lets be square.
      Call GetMem('SMatSq','Allo','Real',ipSSq,nBas(1)**2)
      Call Square(Work(ipSTr),Work(ipSSq),1,nBas(1),nBas(1))

*
*-- Call the localization utility and get the transformation matrix.
*
      Call GetMem('T','Allo','Real',ipT,nBas(1)**2)
      Call GetMem('Tinv','Allo','Real',ipTinv,nBas(1)**2)
      Call Localize_LoProp(Work(ipT),Work(ipTinv),nBas(1),Work(ipSSq)
     &                    ,iWork(ipCenter),iWork(ipType))
      If(DeBug) then
        Call RecPrt('Total transfMat',' ',Work(ipT),nBas(1),nBas(1))
      Endif

*
*-- Transform the perturbation to the LoProp basis. FFPT accumulates the
*   perturbation to H0, but we only want the perturbation V, hence first
*   a subtraction is necessary.
*
      Call GetMem('VacH0','Allo','Real',iHVac,nInts+4)
      If(LCumulate) Then
         Label='OneHam  '
      Else
         Label='OneHam 0'
      EndIf
      iRc=-1
      Call RdOne(iRc,iOpt2,Label,1,Work(iHVac),iSymLbl)
      If(iRc.ne.0) then
        Write(6,*)'Error reading H0 in SELECTLOC!'
        Call Abend()
      Endif
      Call GetMem('Pert','Allo','Real',iV,nInts)
      Do i=1,nInts
        Work(iV+i-1)=H0(i)-Work(iHVac+i-1)
      Enddo
      H01=H0(nInts+1)
      H02=H0(nInts+2)
      H03=H0(nInts+3)
      H04=H0(nInts+4)
*----But first translate the perturbation origo to the relevant centre
      Call TransNow(iV,ipSTr)
*----You may proceed.
      Call GetMem('PertSq','Allo','Real',iVS,nBas(1)**2)
      Call Square(Work(iV),Work(iVS),1,nBas(1),nBas(1))
      If(DeBug) then
        Call RecPrt('Pert:(Basis:ord)',' ',Work(iVS),nBas(1),nBas(1))
      Endif

      Call GetMem('TEMP','Allo','Real',iTEMP,nBas(1)**2)
      Call GetMem('PertL','Allo','Real',iVLoP,nBas(1)**2)
*----Go to basis where overlap matrix, S, is diagonal.
      Call DGEMM_('T','N',nBas(1),nBas(1),nBas(1),ONE,Work(ipT)
     &          ,nBas(1),Work(iVS),nBas(1),ZERO,Work(iTEMP),nBas(1))
      Call DGEMM_('N','N',nBas(1),nBas(1),nBas(1),ONE,Work(iTEMP),
     &    nBas(1),Work(ipT),nBas(1),ZERO,Work(iVLoP),nBas(1))
      If(DeBug) then
        Call RecPrt('Pert:(Basis:LoP)',' ',Work(iVLop),nBas(1),nBas(1))
      Endif

*
*-- Set elements to zero as designated in input. The routine below is
*   far from optimal, but we are not in need of great speed here so....
*

      kaunter=0
      Do i=1,nBas(1)
        Do j=1,nBas(1)
          Siff=0.0D+0
          Do k=1,nSets
            Do l=k,nSets
              If(k.ne.l) then
                If(.not.Bonds(k,l)) Goto 999
              Else
                If(.not.Atoms(k)) Goto 999
              Endif
              OneOrNot1=i.ge.iSelection(1,k).and.i.le.iSelection(2,k)
              OneOrNot2=j.ge.iSelection(1,l).and.j.le.iSelection(2,l)
              OneOrNot3=i.ge.iSelection(1,l).and.i.le.iSelection(2,l)
              OneOrNot4=j.ge.iSelection(1,k).and.j.le.iSelection(2,k)
              OneOrNot=(OneOrNot1.and.OneOrNot2).or.
     &                 (OneOrNot3.and.OneOrNot4)
              CrazySet=(OneOrNot1.and.OneOrNot2).and.
     &                 (OneOrNot3.and.OneOrNot4)
              If(CrazySet.and.Bonds(k,l).and..not.Atoms(k)) then
                Write(6,*)'Your set selection is not exclusive!'
              Endif
              If(OneOrNot) Siff=1.0D+0
*-- Here we enable to set the weight in the bond-domain to some
*   other number than one.
              If(OneOrNot.and.(Atoms(k).and.Bonds(k,l))) Siff=SiffBond
999           Continue
            Enddo
          Enddo
          Work(iVLop+kaunter)=Work(iVLop+kaunter)*Siff
          kaunter=kaunter+1
        Enddo
      Enddo

*
*-- Transform back. Due to the non-unitarian and non-orthogonal basis
*   the inverse is is contravariant (if the transformation was
*   covariant). See the Book by Lanczos.
*
      Call DGEMM_('T','N',nBas(1),nBas(1),nBas(1),ONE,Work(ipTinv)
     &          ,nBas(1),Work(iVLop),nBas(1),ZERO,Work(iTEMP),nBas(1))
      Call DGEMM_('N','N',nBas(1),nBas(1),nBas(1),ONE,Work(iTEMP),
     & nBas(1),Work(ipTinv),nBas(1),ZERO,Work(iVS),nBas(1))
      If(DeBug) then
        Call RecPrt('Pert.Zeroed',' ',Work(iVS),nBas(1),nBas(1))
      Endif

*
*-- Add this perturbation to the one-electron hamiltonian.
*
      kaunter=0
      Do i=1,nBas(1)
        Do j=1,i
          kaunter=kaunter+1
          ind=(i-1)*nBas(1)+j
          H0(kaunter)=Work(iHVac+kaunter-1)+Work(iVS+ind-1)
        Enddo
      Enddo
*----And don't forget the orgio and the nuclear repulsion.
      H0(nInts+1)=H01
      H0(nInts+2)=H02
      H0(nInts+3)=H03
      H0(nInts+4)=H04

*
*-- Deallocations en masse.
*
      Call GetMem('Orbital_Type','Free','Inte',ipType,nBas(1))
      Call GetMem('Center_Index','Free','Inte',ipCenter,nBas(1))
      Call GetMem('SMatSq','Free','Real',ipSSq,nBas(1)**2)
      Call GetMem('T','Free','Real',ipT,nBas(1)**2)
      Call GetMem('Tinv','Free','Real',ipTinv,nBas(1)**2)
      Call GetMem('VacH0','Free','Real',iHVac,nInts+4)
      Call GetMem('Pert','Free','Real',iV,nInts)
      Call GetMem('PertSq','Free','Real',iVS,nBas(1)**2)
      Call GetMem('TEMP','Free','Real',iTEMP,nBas(1)**2)
      Call GetMem('PertL','Free','Real',iVLoP,nBas(1)**2)
      Call GetMem('SMatTr','Free','Real',ipSTr,nInts+4)

*
*-- Exit
*
      Write(6,*)
      Write(6,*)'  ....Done!'
      Write(6,*)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine IAIBCM_MCLR(MNRS1,MXRS3,NOCTPA,NOCTPB,NEL1A,NEL3A,NEL1B,NEL3B,IOCOC)
! RAS allowed combinations of alpha and beta types
!
! =====
! Input
! =====
!
! NOCTPA : Number of alpha types
! NEL1A  : Number of electrons in RAS 1 for each alpha type
! NEL3A  : Number of electrons in RAS 3 for each alpha type
!
! NOCTPB : Number of beta types
! NEL1B  : Number of electrons in RAS 1 for each beta type
! NEL3B  : Number of electrons in RAS 3 for each beta type
!
! ======
! Output
! ======
! IOCOC(IATP,IBTP)  = 1 =>      allowed combination
! IOCOC(IATP,IBTP)  = 0 => not allowed combination

use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: MNRS1, MXRS3, NOCTPA, NOCTPB, NEL1A(NOCTPA), NEL3A(NOCTPA), NEL1B(NOCTPB), NEL3B(NOCTPB)
integer(kind=iwp), intent(out) :: IOCOC(NOCTPA,NOCTPB)
integer(kind=iwp) :: IAEL1, IAEL3, IATP, IBEL1, IBEL3, IBTP

IOCOC(:,:) = 0
do IATP=1,NOCTPA
  IAEL1 = NEL1A(IATP)
  IAEL3 = NEL3A(IATP)
  do IBTP=1,NOCTPB
    IBEL1 = NEL1B(IBTP)
    IBEL3 = NEL3B(IBTP)
    if ((IAEL1+IBEL1 >= MNRS1) .and. (IAEL3+IBEL3 <= MXRS3)) IOCOC(IATP,IBTP) = 1
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' Matrix giving allowed combinations of types'
write(u6,*)
call IWRTMA(IOCOC,NOCTPA,NOCTPB,NOCTPA,NOCTPB)
#endif

return

end subroutine IAIBCM_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine PLF_Cho_Diag(TInt,lInt,AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iAO,iAOst,iBas,jBas,kBas,lBas,kOp)
!***********************************************************************
!                                                                      *
!  object: to sift and index the petite list format integrals.         *
!                                                                      *
!          the indices has been scrambled before calling this routine. *
!          Hence we must take special care in order to regain the can- *
!          onical order.                                               *
!                                                                      *
!                                                                      *
!  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
!          May '90                                                     *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri
use SOAO_Info, only: iAOtSO
use Cholesky, only: iShlSO, iSOSHl, nBstSh, ShA, ShB
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Constants, only: One
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: lInt, ijkl, iCmp, jCmp, kCmp, lCmp, iAO(4), iAOst(4), iBas, jBas, kBas, lBas, kOp(4)
real(kind=wp), intent(inout) :: TInt(lInt)
real(kind=wp), intent(in) :: AOint(ijkl,iCmp,jCmp,kCmp,lCmp)
integer(kind=iwp) :: i1, i2, i3, i4, iAOi, iAOj, iAOk, iAOl, iAOsti, iAOstj, iAOstk, iAOstl, ISHLI, ISHLJ, iSO, iSOi, iSOij, &
                     iSOkl, iSOs(4), jSO, jSOj, KIJ, kSO, kSOk, lSO, lSOl, nijkl, NUMI, NUMJ
#ifdef _DEBUGPRINT_
real(kind=wp) :: r1, r2
real(kind=wp), external :: ddot_

r1 = DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,[One],0)
r2 = DDot_(ijkl*iCmp*jCmp*kCmp*lCmp,AOInt,1,AOInt,1)
write(u6,*) ' Sum=',r1
write(u6,*) ' Dot=',r2
call RecPrt(' In Plf_CD: AOInt',' ',AOInt,ijkl,iCmp*jCmp*kCmp*lCmp)
#endif

! Allocate space to store integrals to gether with their
! Symmetry batch and sequence number.
! To avoid conflicts in using memory this is done in the
! subroutine PSOAO

! quadruple loop over elements of the basis functions angular
! description. loops are reduced to just produce unique SO integrals
! observe that we will walk through the memory in AOint in a
! sequential way.

iAOsti = iAOst(1)
iAOstj = iAOst(2)
iAOstk = iAOst(3)
iAOstl = iAOst(4)
iAOi = iAO(1)
iAOj = iAO(2)
iAOk = iAO(3)
iAOl = iAO(4)

do i1=1,iCmp
  iSOs(1) = iAOtSO(iAOi+i1,kOp(1))+iAOsti
  do i2=1,jCmp
    iSOs(2) = iAOtSO(iAOj+i2,kOp(2))+iAOstj
    do i3=1,kCmp
      iSOs(3) = iAOtSO(iAOk+i3,kOp(3))+iAOstk
      do i4=1,lCmp
        iSOs(4) = iAOtSO(iAOl+i4,kOp(4))+iAOstl

        iSO = iSOs(1)
        jSO = iSOs(2)
        kSO = iSOs(3)
        lSO = iSOs(4)

        nijkl = 0
        do lSOl=lSO,lSO+lBas-1
          do kSOk=kSO,kSO+kBas-1
            iSOkl = iTri(kSOk,lSOl)
            do jSOj=jSO,jSO+jBas-1
              do iSOi=iSO,iSO+iBas-1
                nijkl = nijkl+1
                iSOij = iTri(iSOi,jSOj)

                if (iSOij == iSOkl) then
                  ISHLI = ISOSHL(ISOI)
                  ISHLJ = ISOSHL(JSOJ)
                  NUMI = NBSTSH(ISHLI)
                  NUMJ = NBSTSH(ISHLJ)
                  if ((ISHLI == ISHLJ) .and. (ISHLI == SHA)) then
                    KIJ = ITRI(ISHLSO(ISOI),ISHLSO(JSOJ))
                  else
                    if ((ISHLI == SHA) .and. (ISHLJ == SHB)) then
                      KIJ = NUMI*(ISHLSO(JSOJ)-1)+ISHLSO(ISOI)
                    else if ((ISHLJ == SHA) .and. (ISHLI == SHB)) then
                      KIJ = NUMJ*(ISHLSO(ISOI)-1)+ISHLSO(JSOJ)
                    else
                      call CHO_QUIT('Integral error',104)
                      KIJ = -999999
                    end if
                  end if
                  TInt(KIJ) = AOint(nijkl,i1,i2,i3,i4)
                end if

              end do
            end do
          end do
        end do

      end do
    end do
  end do
end do

return

end subroutine PLF_Cho_Diag

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SGInit(nSym,nActEl,iSpin,nRasPrt,nRas,nRasEl,
     &                  iSGStruct)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rassi.fh"
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='SGINIT')
      dimension nRas(8,nRasPrt),nRasEl(nRasPrt)
#include "Struct.fh"
      Dimension iSGStruct(nSGSize)
#include "WrkSpc.fh"




      NLEV=NASHT
C Allocate Level to Symmetry table ISm:
      Call GetMem('ISm','Allo','Integer',lISm,nLev)
      ITABS=0
      IT=0
      DO ISYM=1,NSYM
        DO IT=1,NASH(ISYM)
          ITABS=ITABS+1
          ILEV=LEVEL(ITABS)
          IWORK(LISM-1+ILEV)=ISYM
        END DO
      END DO

C Compute size of unrestricted DRT table:
      ib0=ispin-1
      ia0=(nActEl-ib0)/2
      ic0=nLev-ia0-ib0
CTEST      write(*,*)' ia0, ib0, ic0:'
CTEST      write(*,'(8i5)')ia0,ib0,ic0

      iErr=0
      If ((2*ia0+ib0).ne.nActEl) Then
        iErr=1
      Else If((ia0.lt.0).or.(ib0.lt.0).or.(ic0.lt.0)) Then
        iErr=1
      End If
      If(iErr.ne.0) then
        Write(6,*)' RASSI/SGINIT: Impossible input variables.'
        Write(6,*)'   nLev:',nLev
        Write(6,*)' nActEl:',nActEl
        Write(6,*)'  iSpin:',iSpin
        Write(6,*)'Program stops, sorry.'
        CALL ABEND()
      End If

      IAC=MIN(IA0,IC0)
      NVERT0=((IA0+1)*(IC0+1)*(2*IB0+IAC+2))/2-(IAC*(IAC+1)*(IAC+2))/6
CTEST      write(*,*)' NVERT0:',NVERT0
      NDRT0=5*NVERT0
      NDOWN0=4*NVERT0

C Compute unrestricted DRT tables:
      CALL GETMEM('DRT0  ','ALLO','INTEGER',LDRT0,NDRT0)
      CALL GETMEM('DOWN0 ','ALLO','INTEGER',LDOWN0,NDOWN0)
      NTMP=((NLEV+1)*(NLEV+2))/2
      CALL GETMEM('TMP   ','ALLO','INTEGER',LTMP,NTMP)
      CALL DRT0_RASSI (IA0,IB0,IC0,NVERT0,IWORK(LDRT0),IWORK(LDOWN0),
     &           NTMP,IWORK(LTMP))
CTEST      write(*,*)' SGINIT: Back from DRT0'

C Construct a restricted graph.
      Call GetMem('Lim  ','Allo','Inte',lLim,nLev)
      Do Lev=1,nLev
        IWork(lLim-1+Lev)=0
      End Do
CTEST      write(*,*)' Initialize Work(LLIM):'
CTEST      write(*,'(1x,10i5)')(IWork(llim-1+i),i=1,nlev)
C Fill in the occupation limit table:
      Lev=0
      Do iRO=1,nRasPrt
        Do iSy=1,nSym
          Lev=Lev+nRas(iSy,iRO)
        End Do
        if(Lev.gt.0) IWork(lLim-1+Lev)=nRasEl(iRO)
      End Do
CTEST      write(*,*)' After filling in first values, Work(LLIM):'
CTEST      write(*,'(1x,10i5)')(IWork(llim-1+i),i=1,nlev)
      Call GetMem('NwVer ','Allo','Inte',lNWV,nVert0)
      nVert=nVert0
      Call RmVert(nLev,nVert,IWork(lDRT0),IWork(lDown0),
     &              IWork(lLim),IWork(lNWV))
CTEST      write(*,*)' Back from RMVERT'
      Call GetMem('Lim  ','Free','Inte',lLim,nLev)
      Call GetMem('DRT','Allo','Inte',lDRT,5*nVert)
      Call GetMem('Down','Allo','Inte',lDown,4*nVert)
      Call DRT_RASSI(nVert0,IWork(lDRT0),IWork(lDown0),IWork(lNWV),
     &         nVert,IWork(lDRT),IWork(lDown))
CTEST      write(*,*)' Back from DRT. NVERT=',NVERT
      Call GetMem('NwVer ','Free','Inte',lNWV,NVERT0)
      CALL GETMEM('      ','FREE','Inte',LDRT0,NDRT0)
      CALL GETMEM('      ','FREE','Inte',LDOWN0,NDOWN0)

C Direct Arc Weights table and Level-To-Vertex table:
      Call GetMem('DAW','Allo','Inte',lDAW,5*nVert)
      Call GetMem('LTV','Allo','Inte',lLTV,nLev+2)
      Call MkDAW_RASSI(nLev,nVert,IWork(lDRT),IWork(lDown),IWork(lDAW),
     &           IWork(lLTV))

C Upchain Index table:
      Call GetMem('UP','Allo','Inte',lUp,4*nVert)
C Reverse Arc Weights table:
      Call GetMem('RAW','Allo','Inte',lRAW,5*nVert)
C Modified Arc Weights table:
      Call GetMem('MAW','Allo','Inte',lMAW,4*nVert)
      Call MkMAW(nLev,nVert,IWork(lDown),IWork(lDAW),iWork(lUp),
     &           IWork(lRAW),IWork(lMAW),IWork(lLTV),MidLev)
      MVSta=IWork(lLTV+1+MidLev)
      MVEnd=IWork(lLTV+MidLev)-1
C The DAW, RAW tables are no longer needed:
      Call GetMem('RAW','Free','Inte',lRAW,5*nVert)
      Call GetMem('DAW','Free','Inte',lDAW,5*nVert)
      CALL GETMEM('TMP   ','FREE','INTEGER',LTMP,NTMP)

C Put sizes and addresses in structure iSGStruct:
      iSGStruct(1) =nSym
      iSGStruct(2) =nLev
      iSGStruct(3) =lISm
      iSGStruct(4) =nVert
      iSGStruct(5) =lDRT
      iSGStruct(6) =lDown
      iSGStruct(7) =lUp
      iSGStruct(8) =MidLev
      iSGStruct(9) =MVSta
      iSGStruct(10) =MVEnd
      iSGStruct(11)=lMAW
      iSGStruct(12)=lLTV

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GetChVHlp3(L2,Tmp,cGrp,deGrp,LunAux)
! this routine does:
! read L2(m,c'de') into L2 from disk file
! structure of files: for each c',de' one file with
! name L2Name(cGrp,deGrp)
! @ citanie zatial odflaknute
!
! parameter description:
! L2     - Array for L2 (O)
! Tmp    - Temporary array of L2 size, used for mapping, if needed
! xGrp   - Groups of c, delta (I)
! LunAux - lun for auxiliary reading (I)

use chcc_global, only: DimGrpa, DimGrpbe, L2Name, nc
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: L2(*), Tmp(*)
integer(kind=iwp), intent(in) :: cGrp, deGrp, LunAux
integer(kind=iwp) :: length
character(len=6) :: LunName

! nacitanie (+expanzia, ak treba)
if (cGrp > deGrp) then
  LunName = L2Name(cGrp,deGrp)
  length = nc*DimGrpa(cGrp)*DimGrpbe(deGrp)
  call GetX(L2,length,LunAux,LunName,1,1)
else if (cGrp == deGrp) then
  LunName = L2Name(cGrp,deGrp)
  length = nc*DimGrpa(cGrp)*(DimGrpbe(deGrp)+1)/2
  call GetX(Tmp,length,LunAux,LunName,1,1)
  length = DimGrpa(cGrp)*(DimGrpbe(deGrp)+1)/2
  call Exp1(Tmp,L2,nc,length,DimGrpa(cGrp))
else
  LunName = L2Name(deGrp,cGrp)
  length = nc*DimGrpa(cGrp)*DimGrpbe(deGrp)
  call GetX(Tmp,length,LunAux,LunName,1,1)
  call Map3_132(Tmp,L2,nc,DimGrpbe(deGrp),DimGrpa(cGrp))
end if

return

end subroutine GetChVHlp3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE QUNE(NCALLS,ENOW,BK,XSX,VL,VM,XQN,XOLD,V1,V2,NDIM,
     &                LUQUNE,TMIN,QNSTEP,QNUPDT,KSDFT)
C
C     RASSCF PROGRAM VERSION IBM-3090: SX SECTION
C
C     PURPOSE: THIS SUBROUTINE MAKES A QUASI NEWTON UPDATE
C              OF THE ROTATION MATRIX X, OR A LINE SEARCH.
C
C

      IMPLICIT REAL*8 (A-H,O-Z)
#include "output_ras.fh"
      Parameter (ROUTINE='XXXXXXXX')

      CHARACTER*2 QNSTEP
      CHARACTER*3 QNUPDT
      Character*16 KSDFT
      DIMENSION BK(NDIM),XSX(NDIM),VL(NDIM),VM(NDIM)
      DIMENSION XQN(NDIM),XOLD(NDIM),V1(NDIM),V2(NDIM)
      SAVE ALPHA,BETA,ELAST,FPLAST,NVEC,NLS
CBOR 000906      PARAMETER (MXVEC=52)
CBOR 000906     DIMENSION ALPHA(MXVEC),BETA(MXVEC)

#include "rasdim.fh"
      DIMENSION ALPHA(mxiter+2),BETA(mxiter+2)
      NCALLS=NCALLS+1

      IF(NCALLS.EQ.1) THEN
       NVEC = 0
* NLS: Nr of consecutive line searches.
       NLS=0
       CALL DCOPY_(mxiter+2,[0.0d0],0,ALPHA,1)
       CALL DCOPY_(mxiter+2,[0.0d0],0,BETA,1)
       IAD=0
       CALL DDAFILE(LUQUNE,1,BK,NDIM,IAD)
       CALL DDAFILE(LUQUNE,1,XSX,NDIM,IAD)
       CALL DDAFILE(LUQUNE,1,XSX,NDIM,IAD)
       ELAST=ENOW
       FPLAST=2.0D0*DDOT_(NDIM,BK,1,XSX,1)
       TMIN=0.D0
       QNSTEP='SX'
       QNUPDT=' NO'
       RETURN
      ENDIF
C -- 1. CALC L AND M ARRAYS
* Read from the beginning of LUQUNE. There is the BLB gradient, the proposed optimal
* (QN) step at the previous iteration, and the actual step taken in that iteration.
* VM should be computed as the difference in QN steps, where the new one is computed
* without the new update vectors (which are still unknown).
      IAD=0
      CALL DDAFILE(LUQUNE,2,V1,NDIM,IAD)
      CALL DCOPY_(NDIM,BK,1,VL,1)
      CALL DAXPY_(NDIM,-1.0D00,V1,1,VL,1)
* VL is the difference between the old and the new BLB gradient array:
* Read old QN step into VM:
      CALL DDAFILE(LUQUNE,2,VM,NDIM,IAD)
      CALL DDAFILE(LUQUNE,2,XOLD,NDIM,IAD)
C -- FP WILL BE USED IN LINE SEARCH ANALYSIS LATER.
      FP=2.0D0*DDOT_(NDIM,BK,1,XOLD,1)
C -- QN VECTOR UPDATED WITHOUT NEWEST UPDATE VECTORS: XQN=-HINV*BK
      CALL DCOPY_(NDIM,XSX,1,XQN,1)
      DO IVEC=1,NVEC
        CALL DDAFILE(LUQUNE,2,V1,NDIM,IAD)
        CALL DDAFILE(LUQUNE,2,V2,NDIM,IAD)
        X=-DDOT_(NDIM,V1,1,BK,1)
        Y=-DDOT_(NDIM,V2,1,BK,1)
        P1=ALPHA(IVEC)*X+BETA(IVEC)*Y
        P2=BETA(IVEC)*X
        CALL DAXPY_(NDIM,P1,V1,1,XQN,1)
        CALL DAXPY_(NDIM,P2,V2,1,XQN,1)
      END DO
* Subtract. VM will now contain the difference in QN steps, where the new one
* is computed without the update (which we still do not know).
      CALL DAXPY_(NDIM,-1.0D00,XQN,1,VM,1)
C -- NOTE: M ARRAY = HK(INV)*LK
C -- 2. DECIDE ON WHICH ROTATION TO USE.
C -- A LINE SEARCH ANALYSIS.
      C0=ELAST
      C1=FPLAST
      C2=3.0D0*(ENOW-ELAST)-2.0D0*FPLAST-FP
      C3=-2.0D0*(ENOW-ELAST)+FPLAST+FP
C     Write(LF,*)('*',I=1,60)
C     Write(LF,*)' SEARCH FOR MINIMUM:'
C     Write(LF,*)' POLYNOMIAL COEFFICIENTS:'
C     Write(LF,'(A,4F16.8)') ' ENOW,ELAST,FP,FPLAST',ENOW,ELAST,FP,FPLAST
C     Write(LF,'(A,4F16.8)') ' C0,C1,C2,C3',C0,C1,C2,C3
      P=3.0D0*C1*C3
      Q=C2**2
C -- NLM=NR OF LOCAL MINIMA
      NLM=0
      TLM =  0.0D0
      IF(ABS(P).GT.0.001D00*Q) THEN
        IF(Q.GT.P) THEN
C         Write(LF,*)' THIS IS A 3RD DEGREE POLY WITH 2 STAT. POINTS.'
          NLM=1
          TLM=(SQRT(Q-P)-C2)/(3.0D0*C3)
C         Write(LF,*)' THERE IS A LOCAL MINIMUM AT'
C         Write(LF,*)' TLM=',TLM
        ELSE
C         Write(LF,*)' THIS IS A MONOTONOUS 3RD DEGREE POLY.'
        END IF
      ELSE IF(ABS(C2).GT.0.001D00*C1) THEN
        IF(C2.GT.0.0D00) THEN
C         Write(LF,*)' THIS IS A 2ND DEGREE POLY WITH A MINIMUM.'
          NLM=1
          TLM=-C1/(2.0D0*C2)
C         Write(LF,*)' THERE IS A LOCAL MINIMUM AT'
C         Write(LF,*)' TLM=',TLM
        ELSE
C         Write(LF,*)' THIS IS A 2ND DEGREE POLY WITH A MAXIMUM.'
        END IF
      END IF
C     IF(NLM.EQ.0)Write(LF,*)' NO LOCAL MINIMUM.'
      T0=-0.5D00
      T1=+2.5D00
      IF(NLM.EQ.1) THEN
        ELM=C0+TLM*(C1+TLM*(C2+TLM*C3))
C       Write(LF,*)' LOCAL MINIMUM AT TLM=',TLM
C       Write(LF,*)'     ENERGY AT TLM IS=',ELM
C --  DISREGARD LOCAL MINIMUM IF TOO FAR AWAY:
        IF(TLM.GT.T1) NLM=0
        IF(TLM.LT.T0) NLM=0
C       IF(NLM.EQ.0) Write(LF,*)' TOO FAR AWAY -- REJECTED.'
      END IF
C -- RULES: 1. IF THERE IS A LOCAL MINIMUM IN THE TRUST REGION
C              -0.4<TLM<1.4, THIS IS USED.
C --        2. ELSE, SELECT THE LOWEST MINIMUM IN -0.5..+2.5.
      IF((NLM.EQ.1).AND.(ABS(TLM-0.5D00).LT.0.9D00)) THEN
        TMIN=TLM
        EMIN=ELM
C       Write(LF,*)' THE LOCAL MINIMUM IS USED.'
      ELSE
        E0=C0+T0*(C1+T0*(C2+T0*C3))
        E1=C0+T1*(C1+T1*(C2+T1*C3))
C       Write(LF,*)' EXTRAP. ENERGIES IN T=-0.5 AND 2.5 ARE'
C       Write(LF,*) E0,E1
        IF(E0.LT.E1) THEN
          TMIN=T0
          EMIN=E0
        ELSE
          TMIN=T1
          EMIN=E1
        END IF
        IF(NLM.EQ.1) THEN
          ELM=C0+TLM*(C1+TLM*(C2+TLM*C3))
          IF(ELM.LT.EMIN) THEN
            TMIN=TLM
            EMIN=ELM
          ELSE
            NLM=0
          END IF
        END IF
      END IF
*      Write(LF,*)'  SELECTED TMIN:',TMIN
*      Write(LF,*)' PREDICTED EMIN:',EMIN
*      Write(LF,*)('*',I=1,60)

* Predicted energy lowering, depending on step taken.
* EPRED_LS should be quite exact, if step length is not too long.
* But EPRED_SX and EPRED_QN are much more uncertain.
      EPRED_LS=EMIN-ENOW
      EPRED_SX=0.5D0*DDOT_(NDIM,BK,1,XSX,1)
      EPRED_QN=0.5D0*DDOT_(NDIM,BK,1,XQN,1)
*      WRITE(LF,*)' Predicted QN energy change:', EPRED_QN
*      WRITE(LF,*)' Predicted SX energy change:', EPRED_SX
*      WRITE(LF,*)' Predicted LS energy change:', EPRED_LS

* Here follows decision whether to update inverse Hessian, or not:
      IF(NLM.EQ.1) THEN
        X=C3*(1.0D00-TMIN)/SQRT(Q-P)
        IF((ABS(X).LT.0.2D00).AND.(TMIN.GT.0.5D00)) THEN
CPAM THEN THE ERROR ARISING FROM NONLINEARITY OF GRADIENT ALONG THE
CPAM SEARCH DIRECTION IS SMALLER THAN ABOUT 25 PERCENT, SO IT IS
CPAM MEANINGFUL INFORMATION ABOUT GRADIENT HESSIAN. ALSO, THE
CPAM INFORMATION GIVEN BY THE LAST GRADIENT IS BETTER THAN THE ONE
CPAM FROM THE NEXT-TO-LAST. THEREFORE, UPDATE INVERSE HESSIAN.
C -- WE ARE PROBABLY IN A QUADRATIC MINIMUM REGION, SO UPDATE
C         Write(LF,*)' QUAD MINIMUM REGION -- UPDATE INVERSE HESSIAN.'
          QNUPDT='YES'
        ELSE
C -- WE ARE OUTSIDE QUADRATIC MINIMUM.
C         Write(LF,*)' NOT IN QUADRATIC MIN. INV HESSIAN NOT UPDATED.'
          QNUPDT=' NO'
        END IF
      ELSE
C -- DEFINITELY NON-QUADRATIC REGION.
*        Write(LF,*)' VERY NON-QUADRATIC REGION.'
*        Write(LF,*)' SHOULD WE SCRAP ALL THE UPDATE VECTORS??'
*        Write(LF,*)' NO, BUT DO NOT UPDATE.'
        QNUPDT=' NO'
*        If(KSDFT(1:3).ne.'SCF') Then
*           NVEC=0
*        End If
      END IF

* I strongly mistrust the above analysis. For the moment, decide to update
* always. The analysis should instead be based on if whether a large rotation
* remains (do not update) or has been done (scrap the vectors).
      IF(QNUPDT.NE.'YES') THEN
*        Write(LF,*)' DECIDE TO UPDATE ANYWAY! (PAM Dec 2006)'
        QNUPDT='YES'
      END IF

      IF(QNUPDT.EQ.'YES') THEN
* Determine new pair of update vectors, and also use it to correct XQN:
* Recall: VL is the difference between the old and the new BLB gradient array:
* VM is the difference between the old, and the new provisional, XQN arrays.
        NVEC=NVEC+1
C METHOD: BFGS
        CALL DCOPY_(NDIM,XOLD,1,V1,1)
        CALL DCOPY_(NDIM,  VM,1,V2,1)
        X=DDOT_(NDIM,V1,1,VL,1)
        Y=DDOT_(NDIM,V2,1,VL,1)
        ALPHA(NVEC)=(1.0D00+Y/X)/X
        BETA(NVEC)=-1.0D00/X
C METHOD: SYMMETRIZED POWELL 1-RANK:
*        CALL DCOPY_(NDIM,VL,1,V1,1)
*        CALL DCOPY_(NDIM,XOLD,1,V2,1)
*        CALL DAXPY_(NDIM,-1.0D00,VM,1,V2,1)
*        X=DDOT_(NDIM,V1,1,V1,1)
*        Y=DDOT_(NDIM,V2,1,V1,1)
*        ALPHA(NVEC)=-Y/(X**2)
*        BETA(NVEC)=1.0D00/X
C --  ADD THE NEWEST UPDATE CONTRIBUTION INTO XQN:
        X=-DDOT_(NDIM,V1,1,BK,1)
        Y=-DDOT_(NDIM,V2,1,BK,1)
        P1=ALPHA(NVEC)*X+BETA(NVEC)*Y
        P2=BETA(NVEC)*X
        CALL DAXPY_(NDIM,P1,V1,1,XQN,1)
        CALL DAXPY_(NDIM,P2,V2,1,XQN,1)
        CALL DDAFILE(LUQUNE,1,V1,NDIM,IAD)
        CALL DDAFILE(LUQUNE,1,V2,NDIM,IAD)
* We have added to XQN the two-rank update,
*  (alpha*|V1><V1| + beta*|v1><V2| + beta |V2><V1|)|BK>
      END IF

      EPRED_QN=0.5D0*DDOT_(NDIM,BK,1,XQN,1)
*      WRITE(LF,*)' Predicted QN energy change (revised):', EPRED_QN

C -- IF LINE SEARCH IS NEARLY CONVERGED, USE THE QN OR SX STEP
C -- TO GET NEW DIRECTION, ELSE CONTINUE LINE SEARCH:
      X=TMIN-1.0D00
      IF((ABS(X).LT.0.4D00).OR.(ABS(EPRED_LS).LT.1.0D-08).or.
     &                                    KSDFT(1:3).ne.'SCF') THEN
*        Write(LF,*)' THE LINE SEARCH MINIMUM IS PREDICTED TO BE'
*        Write(LF,*)' RATHER CLOSE TO THE CURRENT POINT.'
*        Write(LF,*)' THEREFORE, DO NOT CONTINUE BY LS.'
        IF(NVEC.EQ.0) QNSTEP='SX'
        IF(NVEC.GT.0) QNSTEP='QN'
      ELSE IF (NLS.GE.2) THEN
*        Write(LF,*)' WE HAVE ALREADY USED LINE SEARCHES CONSECUTIVELY'
*        Write(LF,*)'    FOR SEVERAL ITERATIONS. WE MUST TRY TO BREAK'
*        Write(LF,*)'    OUT FROM THIS LINE SEARCH: DISABLE IT.'
        IF(NVEC.EQ.0) QNSTEP='SX'
        IF(NVEC.GT.0) QNSTEP='QN'
      ELSE
C Else we should use a line search. But maybe check predicted effect:
C If predicted LS-energy minimum is not an improvement
C then do not use line search.
*        Write(LF,*)' THE LINE-SEARCH ANALYSIS PREDICTS A MINIMUM'
*        Write(LF,*)'    PRETTY FAR FROM WHERE WE GOT WITH THE LAST'
*        Write(LF,*)'    STEP. THEREFORE; WE MAY CONSIDER CONTINUING'
*        Write(LF,*)'    BY LS, ALONG THE SAME DIRECTION AS LAST STEP.'
*        Write(LF,*)' BUT WILL WE GAIN FROM THAT? LETS SEE!'
        IF(EPRED_LS.GT.EPRED_QN) THEN
*          Write(LF,*)' LS REJECTED -- GIVES TOO LITTLE.'
          IF(NVEC.EQ.0) QNSTEP='SX'
          IF(NVEC.GT.0) QNSTEP='QN'
        ELSE IF(EPRED_LS.GT.EPRED_SX) THEN
*          Write(LF,*)' USE SX.'
          QNSTEP='SX'
        ELSE
          QNSTEP='LS'
        END IF
      END IF
      IF (QNSTEP.EQ.'LS') THEN
*        Write(LF,*)' USE LINE SEARCH.'
        X=TMIN-1.0D00
        CALL DYAX(NDIM,X,XOLD,1,XSX,1)
      END IF
      IF (QNSTEP.EQ.'QN') THEN
*          Write(LF,*)' USE QN STEP.'
          CALL DCOPY_(NDIM,XQN,1,XSX,1)
      END IF
*      IF (QNSTEP.EQ.'SX') Write(LF,*)' USE SX STEP.'

* Often, use of qune results in getting caught in a cyclic or caotic
* attractor towards the end. As an attempt to break such a pattern,
* apply a scaling whenever energy goes up:
      IF(ENOW.gt.ELAST) THEN
        SCLFCT=0.7D0
        CALL DSCAL_(NDIM,SCLFCT,XSX,1)
      END IF

* Before committing the finally suggested step (which is now in XSX),
* also apply a step size limitation. The squared 2-norm of the vector XSX
* sum of squares of rotation angles, so the 2-norm is a strict limit on
* largest rotation angle, which we (arbitrarily) limit to 0.5 (say):
      XSXNRM=DNRM2_(NDIM,XSX,1)
      SCLFCT=1.0D0/(1.0D0+2.0D0*XSXNRM)
      CALL DSCAL_(NDIM,SCLFCT,XSX,1)

      ELAST=ENOW
      FPLAST=2.0D0*DDOT_(NDIM,BK,1,XSX,1)
      IAD=0
      CALL DDAFILE(LUQUNE,1,BK,NDIM,IAD)
      CALL DDAFILE(LUQUNE,1,XQN,NDIM,IAD)
      CALL DDAFILE(LUQUNE,1,XSX,NDIM,IAD)
      NLS=NLS+1
      IF(QNSTEP.NE.'LS') NLS=0
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_IntegralErrorStat(Mode,AB,CD,Stat)
C
C=======================================================================
C          WARNING: THIS ROUTINE MAY REQUIRE A LOT OF MEMORY !!!
C=======================================================================
C
C     Thomas Bondo Pedersen, October 2010.
C
C     Purpose: compute integral error statistics for LDF.
C              On exit, array Stat contains the following info:
C
C              Stat(1): min error
C              Stat(2): max error
C              Stat(3): min abs error
C              Stat(4): max abs error
C              Stat(5): average error
C              Stat(6): avrage abs error
C              Stat(7): std dev with respect to average error
C              Stat(8): std dev with respect to average abs error
C              Stat(9): RMS error
C
C     Input:
C       Mode   --- 1: robust, 2: nonrobust, 3: half-and-half
C       AB, CD --- atom pairs for which the statistics is to be computed
C
C     It is assumed that all integrals (AB|CD) can be stored in core (!)
C     LDF info must be properly set up before calling this routine.
C
      Implicit None
      Integer Mode
      Integer AB
      Integer CD
      Real*8  Stat(9)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nBas_Atom
      External LDF_nBas_Atom

      Logical Add

      Integer A, B, C, D
      Integer nAB, nCD
      Integer ip_Int, l_Int

      Real*8 xmin, xmax, xamin, xamax, average, abs_average
      Real*8 std, abs_std, rms

      Integer i, j
      Integer AP_Atoms
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Init Stat
      Call Cho_dZero(Stat,9)

      ! Get atoms
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      C=AP_Atoms(1,CD)
      D=AP_Atoms(2,CD)

      ! Get pair dimensions
      nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      nCD=LDF_nBas_Atom(C)*LDF_nBas_Atom(D)

      ! Return if nothing to do
      l_Int=nAB*nCD
      If (l_Int.lt.1) Return

      ! Allocate integrals (u_A v_B | k_C l_D)
      Call GetMem('IESInt','Allo','Real',ip_Int,l_Int)

      ! Compute integrals difference, exact - approximate
      Call LDF_ComputeValenceIntegrals(AB,CD,l_Int,Work(ip_Int))
      Call dScal_(l_Int,-1.0d0,Work(ip_Int),1)
      Add=.True.
      Call LDF_ComputeApproximateIntegrals(Mode,Add,AB,CD,l_Int,
     &                                     Work(ip_Int))

      ! Compute statistics
      xmin=9.9d99
      xmax=-9.9d99
      xamin=9.9d99
      xamax=-9.9d99
      average=0.0d0
      abs_average=0.0d0
      rms=0.0d0
      Do i=0,l_Int-1
         xmin=min(xmin,Work(ip_int+i))
         xmax=max(xmax,Work(ip_Int+i))
         xamin=min(xamin,abs(Work(ip_int+i)))
         xamax=max(xamax,abs(Work(ip_Int+i)))
         average=average+Work(ip_Int+i)
         abs_average=abs_average+abs(Work(ip_Int+i))
         rms=rms+Work(ip_Int+i)**2
      End Do
      average=average/dble(l_Int)
      abs_average=abs_average/dble(l_Int)
      rms=sqrt(rms/dble(l_Int))
      std=0.0d0
      abs_std=0.0d0
      Do i=0,l_int-1
         std=std+(Work(ip_Int+i)-average)**2
         abs_std=abs_std+(abs(Work(ip_Int+i))-abs_average)**2
      End Do
      std=sqrt(std/dble(l_int))
      abs_std=sqrt(abs_std/dble(l_int))

      Stat(1)=xmin
      Stat(2)=xmax
      Stat(3)=xamin
      Stat(4)=xamax
      Stat(5)=average
      Stat(6)=abs_average
      Stat(7)=std
      Stat(8)=abs_std
      Stat(9)=rms

      ! Deallocate
      Call GetMem('IESInt','Free','Real',ip_Int,l_Int)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
*               1993, Per-Olof Widmark                                 *
************************************************************************
      Subroutine RdOrd_(rc,iOpt,iSym,jSym,kSym,lSym,Buf,lBuf,nMat)
************************************************************************
*                                                                      *
*    Purpose: Read a buffer of ordered integrals of length lBuf        *
*             The subroutine returns the number of submatrices         *
*             it has picked up.                                        *
*                                                                      *
*    Calling parameters:                                               *
*    iSym   : irred. representation of first symmetry label            *
*    jSym   : irred. representation of second symmetry label           *
*    kSym   : irred. representation of third symmetry label            *
*    lSym   : irred. representation of fourth symmetry label           *
*    Buf    : containts on output the integrals                        *
*    lBuf   : length of the integral buffer                            *
*    nMat   : number of submatrices read in                            *
*    iOpt   : option code (iOpt=1:start reading at first integral)     *
*                         (iOpt=2:continue reading)                    *
*    rc     : return code                                              *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    TwoDat : table of contents and auxiliary information              *
*    TowRc  : Table of return code                                     *
*                                                                      *
*    Local data declarations:                                          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.O. Widmark                                 *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
#include "Molcas.fh"
#include "TwoDat.fh"
*
      Real*8 Buf(*)
      Logical Square
*----------------------------------------------------------------------*
*     Start the procedure                                              *
*----------------------------------------------------------------------*
      rc=rc0000
*----------------------------------------------------------------------*
*     Pick up the file definitions                                     *
*----------------------------------------------------------------------*
      Open=AuxTwo(isStat)
*----------------------------------------------------------------------*
*     Check the file status                                            *
*----------------------------------------------------------------------*
      If ( Open.ne.1 ) Then
        rc=rcRD08
        Write (6,*) 'RdOrd: ORDINT not opened yet!'
        Call Abend()
      End If
*----------------------------------------------------------------------*
*     Check if the packing table has been loaded                       *
*----------------------------------------------------------------------*
      If ( TocTwo(isPkPa).lt.0 .or. TocTwo(isPkPa).gt.1 .or.
     &     TocTwo(isPkAs).lt.0 .or. TocTwo(isPkAs).gt.1      ) then
        rc=rcRD09
        Write (6,*) 'RdOrd: the packing flags are spoiled'
        Call Abend()
      End If
*---------------------------------------------------------------------*
*     Check the symmetry labels                                       *
*---------------------------------------------------------------------*
      Square=TocTwo(isOrd).eq.1
      If ( ieor(iSym-1,jSym-1).ne.ieor(kSym-1,lSym-1) ) then
        rc=rcRD01
        Write (6,*) 'RdOrd: Wrong symmetry labels, direct product',
     &              ' is not total symmetric'
        Call Abend()
      End If
      If ( iSym.lt.jSym .or. kSym.lt.lSym ) then
        rc=rcRD02
        Write (6,*) 'RdOrd: invalid order of symmetry labels'
        Call Abend()
      End If
      ijS=jSym+iSym*(iSym-1)/2
      klS=lSym+kSym*(kSym-1)/2
      If ( ijS.lt.klS .and. .not.Square ) then
        rc=rcRD03
        Write (6,*) 'RdOrd: invalid combination of symmetry labels'
        Call Abend()
      End If
      nSym=TocTwo(isSym)
      nPairs=nSym*(nSym+1)/2
      iSyBlk=(ijS-1)*nPairs+klS
      iBatch=nBatch(iSyBlk)
*---------------------------------------------------------------------*
*     Check the skipping flags                                        *
*---------------------------------------------------------------------*
      iSkip=TocTwo(isSkip+iSym-1)
      jSkip=TocTwo(isSkip+jSym-1)
      kSkip=TocTwo(isSkip+kSym-1)
      lSkip=TocTwo(isSkip+lSym-1)
      If ( (iSkip+jSkip+kSkip+lSkip).ne.0 ) then
        rc=rcRD07
        Write (6,*) 'RdOrd: Requested symmetry block has not been',
     &              ' computed'
        Call Abend()
      End If
*---------------------------------------------------------------------*
*     Check options                                                   *
*---------------------------------------------------------------------*
      If ( iOpt.ne.1 .and. iOpt.ne.2 ) then
        rc=rcRD06
        Write (6,*) 'RdOrd: Invalid option'
        Write (6,*) 'iOpt=',iOpt
        Call Abend()
      End If
*---------------------------------------------------------------------*
*     Check the buffer size                                           *
*---------------------------------------------------------------------*
      If ( lBuf.le.0  ) then
        rc=rcRD04
        Write (6,*) 'RdOrd: invalid buffer size'
        Write (6,*) 'lbuf=',lBuf
        Call Abend()
      End If
*---------------------------------------------------------------------*
*     Compute matrix dimensions                                       *
*---------------------------------------------------------------------*
      iB=TocTwo(isBas+iSym-1)
      jB=TocTwo(isBas+jSym-1)
      kB=TocTwo(isBas+kSym-1)
      lB=TocTwo(isBas+lSym-1)
      ijB=iB*jB
      if ( iSym.eq.jSym ) ijB=jB*(iB+1)/2
      klB=kB*lB
      if ( kSym.eq.lSym ) klB=lB*(kB+1)/2
*---------------------------------------------------------------------*
*     Compute submatrix dimensions                                    *
*---------------------------------------------------------------------*
      If ( lBuf.le.0  ) then
        rc=rcRD04
        Write (6,*) 'RdOrd: invalid buffer size'
        Write (6,*) 'lbuf=',lBuf
        Call Abend()
      End If
      If (klB.le.0) Then
         nMat=0
         Return
      Else
         nMat=(lBuf-1)/klB
      End If
      If ( nMat.gt.ijB ) nMat=ijB
      If ( nMat.eq.0  ) then
        rc=rcRD05
        Write (6,*) 'RdOrd: too small buffer'
        Write (6,*) 'Buffer size is lBuf  =',lBuf
        Write (6,*) 'Size of submatrix klB=',klB
        Write (6,*) 'Call parameters to rdord are:'
        Write (6,*) 'iOpt=',iOpt
        Write (6,*) 'iSym=',iSym
        Write (6,*) 'jSym=',jSym
        Write (6,*) 'kSym=',kSym
        Write (6,*) 'lSym=',lSym
        Write (6,*) 'lBuf=',lBuf
        Write (6,*) 'nMat=',nMat
        Write (6,*) 'Symmetry block iSyBlk=',iSyBlk
        Write (6,*) 'Batch nr       iBatch=',iBatch
        Write (6,*) 'iB=TocTwo(isBas+iSym-1), etc:'
        Write (6,*) 'iB=',iB
        Write (6,*) 'jB=',jB
        Write (6,*) 'kB=',kB
        Write (6,*) 'lB=',lB
        Call Abend()
      End If
*---------------------------------------------------------------------*
*     Check that the number of submatrices do not run beyond          *
*     the last integral of a symmetry allowed batch                   *
*---------------------------------------------------------------------*
      Leftpq=AuxTwo(isNpq)
      If ( iOpt.eq.1 ) then
        Leftpq=ijB
      Else
        nMat=min(Leftpq,nMat)
      End If
      Leftpq=Leftpq-nMat
      AuxTwo(isNpq)=Leftpq
      nInts=nMat*klB
*---------------------------------------------------------------------*
*     Transfer integrals                                              *
*---------------------------------------------------------------------*
      If ( RAMD ) then
         Call ORDIN2(iOpt,Buf,nInts,iBatch)
      Else
         Call ORDIN1(iOpt,Buf,nInts,iBatch)
      End If
*---------------------------------------------------------------------*
*     exit                                                            *
*---------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
Subroutine Energy_Kriging(x0_,y_,ndimx)
  use kriging_mod
  Implicit None
  Integer nDimx
  Real*8 x0_(ndimx),y_
!
!x0 is the n-dimensional vector of the coordinates at which the energy is evaluated
! subroutine
  x0(:) = x0_(:)
!
  call covarvector(0) ! for: 0-GEK, 1-Gradient of GEK, 2-Hessian of GEK
  call predict(0)
  y_=pred
!
  return
End Subroutine Energy_Kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine main_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"

#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      external loopcntr_iterate_cvb
      logical loopcntr_iterate_cvb

      if(service) return
      ibase=mstackr_cvb(0)
      if(variat)nmcscf=nmcscf+1
      call stat1_cvb()

c ---------  make objects  ---------
      call makefile_cvb()
      if(nmcscf.le.1)call touch_cvb('WRITEGS')
c ----------------------------------

      call change0_cvb()

      call loopcntr_init_cvb(2,.true.)
      call input_cvb()
      call loopcntr_init_cvb(2,.false.)
1000  continue
      if(loopcntr_iterate_cvb())then
        call input_cvb()

        if(variat.and.(.not.endvar).and.ip(6).lt.2)then
c  Reduce output level for main variational iterations:
          do 1100 i=1,10
          ip(i)=-1
1100      continue
        endif

        if(endvar.and..not.up2date_cvb('PRTSUM'))then
c  End of variational calculation
          if(ip(1).ge.0)write(6,'(/,a)')' CASVB -- summary of results :'
          if(ip(1).ge.0)write(6,'(a)')  ' -----------------------------'
          call make_cvb('PRTSUM')
        endif

        call make_cvb('STAT')

        call touch_cvb('ORBFREE')
        call touch_cvb('CIFREE')

        if(ifinish.le.2)call change_cvb()

        call casinfoprint_cvb()
        call cnfprint_cvb()
        call prtopt_cvb()

        if(ifinish.le.2)call make_cvb('INIT')

c -------  make dependencies -------
        if(nort.gt.0)then
          call depend_cvb('ORBFREE','ORBS')
        else
          call undepend_cvb('ORBFREE','ORBS')
        endif
        call depend_cvb('CIFREE','CVB')
c ----------------------------------

        if(ifinish.eq.0)then
          call opt_cvb()
          call ncset_cvb(ioptc_new)
        elseif(ifinish.eq.1.or.ifinish.eq.2)then
          call reprt_cvb()
          call ncset_cvb(0)
        endif
        call writegs_cvb()
        goto 1000
      endif

      call stat2_cvb()

      call mfreer_cvb(ibase)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_T17g (V,dima,adda,dimbe,addbe)
c
c        check V(a',u) -
c        sum(be',b,i)  (b,i|be',a') . [ 2 Ta(b,be',i,u) - Ta(b,be',u,i)]
c
        implicit none
#include "chcc1.fh"
        integer dima,adda,dimbe,addbe
        real*8 V(1:dima,1:no)
c
c        help var
        integer a,u,be,b,i,bad,tot
        real*8 s
c
        tot=0
        bad=0
c
        do u=1,no
        do a=adda+1,adda+dima
c
          s=0.0d0
          do b=1,nv
          do be=1+addbe,addbe+dimbe
          do i=1,no
c
           s=s+Q3(be,a,b,i)*(2.0d0*(T2c(be,b,u,i)+T1c(be,u)*T1c(b,i))
     c                         -(T2c(be,b,i,u)+T1c(be,i)*T1c(b,u)))
          end do
          end do
          end do
c
          if (abs(V(a-adda,u)-s).gt.1.0d-10) then
          bad=bad+1
          end if
          tot=tot+1
c
        end do
        end do
c
        write (6,*) ' T17 Chck :',bad,tot
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Kurt Pfingst                                     *
************************************************************************
      SubRoutine Radlq(Zeta,nZeta,lsum,Rnr,icop)
************************************************************************
*                                                                      *
* Object: to compute the radial part of the continuum  Coulomb         *
*         integrals outside the  R-matrix sphere                       *
*                                                                      *
* Called from: KneInt                                                  *
*                                                                      *
* Author: K.Pfingst 21/5/93                                            *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "rmat.fh"
#include "real.fh"
#include "nrmf.fh"
      external fradf
      Character*80 Label
      Real*8 Zeta(nZeta), Rnr(nZeta,0:lsum)
      Parameter(limit=200,lenw=4*limit)
      Integer iScrt(limit)
      Real*8 Scrt(lenw)
*
      iRout = 122
      iPrint = nPrint(iRout)
ccccccccccccccccccccccccccccccccccccccc
c     iPrint = 99
ccccccccccccccccccccccccccccccccccccccc
*                                                                      *
************************************************************************
*                                                                      *
      Do ir=0,lsum
         Do iZeta=1,nZeta
            expsum=Zeta(iZeta)
            ier=0
            l=ir-icop
            Call dqagi(fradf,Rmatr,1,Epsabs,Epsrel,result,abser,neval,
     &                 ier,
     &                 limit,lenw,last,iScrt,Scrt)
            If (ier.gt.0) Then
               Call WarningMessage(1,
     &         ' WARNING in Radlq; Consult output for details!')
               write(6,*) ' ier=',ier,
     &                    ' Error in Dqagi called from Radlq.'
               write(6,*) ' result=',result
               write(6,*) ' abser =',abser
               write(6,*) ' neval =',neval
               write(6,*) ' WARNING in Radlq'
            End If
            Rnr(iZeta,ir)=result
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.99) Then
         Write (6,*) ' Result in Radlq'
         Write (Label,'(A)') ' Rnr'
         Call RecPrt(Label,' ',Rnr(1,0),nZeta,lsum+1)
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine unpckhelp6(a,b,dimp,dimq,dime,dimf,eadd,noe,fadd,nof)
! this routine does:
! b(e,f) = -a(pe,qf)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, dimq, dime, dimf, eadd, noe, fadd, nof
real(kind=wp), intent(in) :: a(dimp,dimq)
real(kind=wp), intent(inout) :: b(dime,dimf)

b(1:noe,1:nof) = -a(eadd+1:eadd+noe,fadd+1:fadd+nof)

return

end subroutine unpckhelp6

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Start(ModuleName)
! Initialization procedure for a program module.

use warnings, only: rc_msg_init
use Para_Info, only: MyRank, King
#ifdef _MOLCAS_MPP_
use Para_Info, only: Set_Do_Parallel
use Definitions, only: iwp
#endif
#ifdef _DEBUGPRINT_
use Para_Info, only: nProcs
#endif
use Definitions, only: u5, u6

implicit none
character(len=*), intent(in) :: ModuleName
character(len=8) :: Prin
#ifdef _MOLCAS_MPP_
logical(kind=iwp) :: parallelized
#endif
#include "standard_iounits.fh"

#ifdef _DEBUGPRINT_
write(u6,*) ' Start.'
#endif

! fill the returncode database with human-readable messages
call rc_msg_init()

! Initialize delayed BLAS+LAPACK

call Init_LinAlg()
#ifdef _DEBUGPRINT_
write(u6,*) ' BLAS+LAPACK initialized '
#endif

! Initialize Timing

call SetTim()
#ifdef _DEBUGPRINT_
write(u6,*) ' TIMING set'
#endif

! Initialize the parallel environment

call GAInit()
#ifdef _DEBUGPRINT_
write(u6,*) ' GA initialized: MyRank, nProcs = ',MyRank,nProcs
#endif

! Now that each process is in its own directory, we can read/write
! files that are local to the' work directory of each process.

call write_rc(-1)
call getenvinit()

! Enable proper functions to handle various signals (needs environment!)

call set_sighandlers(myrank)

! Unix-related information must be set or checked here or later, PID and
! master/slave status may not have been set before now.

call write_pid()

! Have processes print their PID and then sleep for an amount of seconds
! specified by the environment variable MOLCAS_NAP. This is to allow for
! attaching a debugger to multiple processes.
call nap_time()

! Check that binary was executed via molcas script (check $MOLCAS_STAMP)
! (DO NOT MOVE FROM HERE)

#ifdef _HAVE_EXTRA_
call CheckRun()
#ifdef _DEBUGPRINT_
write(u6,*) ' CHECKRUN passed'
#endif
#endif

!  Initialize Memory manager (MOLCAS_MEM)
!  (DO NOT MOVE FROM HERE)
!
call IniMem()
#ifdef _DEBUGPRINT_
write(u6,*) ' MEMORY MANAGER initialized'
#endif
!
!  Get various unix-related information :
!  (DO NOT MOVE FROM HERE)
!
call UnixInfo(ModuleName,ModuleName)
#ifdef _DEBUGPRINT_
write(u6,*) ' UNIXINFO passed '
#endif

call prgminit(ModuleName)
#ifdef _DEBUGPRINT_
write(u6,*) ' PRGM initialized'
#endif

! Now that prgm has been initialized, we know if a module is supposed to
! support parallel execution. If not, then we can serialize the
! processes, after which the slaves jump to the finish and wait there.

#ifdef _MOLCAS_MPP_
parallelized = .true.
if (.not. parallelized) then
  call Set_Do_Parallel(.false.)
  call GATerminate()
  if (.not. King()) then
    call Finish(-2)
  end if
end if
#endif

! Redirect standard input to a file 'stdin'.

LuRd = u5
close(LuRd)
call molcas_open(LuRd,'stdin')
#ifdef _DEBUGPRINT_
write(u6,*) ' STDIN opened '
#endif

! Redirect standard output for slaves to a file 'stdout'.

LuWr = u6
if (.not. King()) then
  close(LuWr)
  call molcas_open(LuWr,'stdout')
  call Append_file(LuWr)
end if
#ifdef _DEBUGPRINT_
write(u6,*) ' STDOUT opened '
#endif

! Initialize XML

call ColorizeInit()
call xml_Open('module',' ',' ',0,ModuleName)
#ifdef _DEBUGPRINT_
write(u6,*) ' XML initialized '
#endif

! Initiate spool mode to read from standard input

Spool = .true.

! Initiate I/O

call FIOInit()
#ifdef _DEBUGPRINT_
write(u6,*) ' I/O initialized '
#endif

! Initialize timings and statistics

call IniTim()
call IniStat()
#ifdef _DEBUGPRINT_
write(u6,*) ' TIMINGS/STATISTICS initialized'
#endif

! Set standard name for the runfile

call NameRun('RUNFILE')
#ifdef _DEBUGPRINT_
write(u6,*) ' RUNFILE initialized '
#endif
call Init_Run_Use()

! Initialize the peek/poke utility

call Init_ppu(.true.)
call poke_iScalar('xml opened',0)

! Set Grid Set

call NQ_Init()
#ifdef _DEBUGPRINT_
write(u6,*) ' GRID initialized '
#endif

!***********************************************************************
! At this point, everything should have been properly initialized!     *
!***********************************************************************
! Finally, print useful runtime information about the module
call getenvf('MOLCAS_PRINT',Prin)
if ((Prin(1:1) /= '0') .and. (Prin(1:1) /= 'S')) then
  call Print_Module_Header(ModuleName)
  ! Force output to be written to stdout, such that in case of problems
  ! later on, at least all the start info has been printed.
  call xFlush(u6)
end if
! Write to the status file that the moduel has started
call StatusLine(ModuleName,' properly started!')

return

end subroutine Start

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2008, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 2008  PER-AKE MALMQUIST                    *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine RDBLKC(ISYM,ICASE,IVEC,VEC,nVEC)

use EQSOLV, only: ModVec, MxSct
use caspt2_global, only: IDSCT, LUSOLV
use caspt2_module, only: MxCase, NASUP, NISUP
#ifdef _DEBUGPRINT_
use caspt2_module, only: CASES
use Definitions, only: u6
#endif
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iSym, iCase, iVec, nVec
real(kind=wp), intent(out) :: VEC(nVec)
integer(kind=iwp) :: IDV, IISTA, LVEC, MDVEC, NAS, NBLK, NCOEF, NCOL, NIS

! Read coefficient vector from LUSOLV (C repres).
#ifdef _DEBUGPRINT_
write(u6,*) ' RDBLKC (Normal repres.)'
write(u6,'(a,i2,a,a,a,i2)') ' Vector nr.',IVEC,'  Case ',CASES(ICASE),' Symm ',ISYM
#endif
NAS = NASUP(ISYM,ICASE)
NIS = NISUP(ISYM,ICASE)
NCOEF = NAS*NIS
if (NCOEF == 0) return
MDVEC = MODVEC(ISYM,ICASE)
!IDV = IDSCT(1,ISYM,ICASE,IVEC)
IDV = IDSCT(1+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1))))
LVEC = 1
do IISTA=1,NIS,MDVEC
  NCOL = min(NIS+1-IISTA,MDVEC)
  NBLK = NAS*NCOL
  call DDAFILE(LUSOLV,2,VEC(LVEC),NBLK,IDV)
  LVEC = LVEC+NBLK
end do
#ifdef _DEBUGPRINT_
write(u6,*) ' First few elements:'
write(u6,'(1x,5f15.6)') VEC(1:min(10,NCOEF))
#endif

end subroutine RDBLKC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991,1993,1995,1999,2000, Roland Lindh                 *
************************************************************************
      Subroutine Eval_Ints_New(iiS,jjS,kkS,llS,TInt,nTInt,
     &                         iTOffs,Integ_Proc,
     &                         Dens,Fock,lDens,ExFac,nDens,
     &                         FckNoClmb,FckNoExch)
************************************************************************
*                                                                      *
*  Object: driver for two-electron integrals, parallel region          *
*          contains memory partitioning and loops over uncontracted    *
*          functions...                                                *
*                                                                      *
*  Input:                                                              *
*          iiS,jjS,kkS,llS     : shell indices                         *
*          TInt                : Computed Integrals                    *
*          nTInt               : dimension of TInt                     *
*          iTOffs              : iTOffs holds symmetry block offsets   *
*                                                                      *
*          Dens                : 1-particle density matrix             *
*          Fock                : the Fock matrix                       *
*          lDens               : length of density/Fock matrices       *
*          nDens               : # of density/Fock matrices            *
*          ExFac               : another scaling factor passed to      *
*                                Integ_Proc                            *
*          Ind,nInd            : auxiliary index list for Fock matrix  *
*                                construction                          *
*          FckNoClmb           : no Coulomb contributions to Fock mat. *
*          FckNoExch           : no exchange contributions to Fock mat.*
*          Thize               : int threshold for disk write (SD)     *
*          W2Disc,PreSch       : booleans 1st iter / prescreening      *
*          Disc_Mx             : # ints to write on disk (semidirect)  *
*          iDisk               : act. position in file TMPINT          *
*                                                                      *
*  Output: Fock                : 2el Hamiltonian                       *
*          Disc                : # ints written to disk (semidirect)   *
*                                                                      *
*                                                                      *
*  Local:                                                              *
*                                                                      *
* Author:     Roland Lindh                                             *
*             Dept. of Theoretical Chemistry, University of Lund,      *
*             SWEDEN.                                                  *
*                                                                      *
*             Modified for k2 loop. August 1991                        *
*             Modified for direct SCF. January 1993                    *
*             Modified to minimize overhead for calculations with      *
*             small basis sets and large molecules. Sept. 1993         *
*             parallel region split off in drvtwo.f, April 1995        *
*             Total rehack May 1999                                    *
*             Wrapper with old parameter list, Jan 2000                *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      External Integ_Proc
#include "real.fh"
*     subroutine parameters
      Real*8  Dens(lDens,nDens), Fock(lDens,nDens)
      Real*8  Thize,Disc_Mx,Disc, TInt(nTInt),ExFac(nDens)
      Integer iTOffs(8,8,8)
      Logical W2Disc,PreSch,FckNoClmb(nDens),FckNoExch(nDens),
     &        DoIntegrals,DoFock
*                                                                      *
************************************************************************
*                                                                      *
*     Set the additional parameters for integrals only option.
*
*     Disable semi-direct option
*
      W2Disc=.False.
      Disc=Zero
      Thize=Zero
      Disc_Mx=Zero
*
      PreSch=.True.
      DoFock=.False.
      DoIntegrals=.True.
*
      nij=max(iis,jjs)*(max(iis,jjs)+1)/2+min(iis,jjs)
      nkl=max(kks,lls)*(max(kks,lls)+1)/2+min(kks,lls)
      pmax=dble(max(nij,nkl))
      pmin=dble(min(nij,nkl))
      Quad_ijkl=pmax*(pmax+One)/Two+Pmin
*                                                                      *
************************************************************************
*                                                                      *
*     Call to subroutine with extended parameter list.
*
      Call Eval_Ints_New_Internal
     &               (iiS,jjS,kkS,llS,TInt,nTInt,
     &                iTOffs,Integ_Proc,
     &                Dens,Fock,lDens,ExFac,nDens,
     &                FckNoClmb,FckNoExch,
     &                Thize,W2Disc,PreSch,Disc_Mx,Disc, ! New arguments
     &                Quad_ijkl,DoIntegrals,DoFock)     ! New arguments
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SYMCM1(ITASK,IOBJ,I1,I2,I12)
*
* Symmetries I1,I2,I12 are related as
* I1*I2 = 12
* IF(ITASK = 1 ) I2 and I12 are known, find I1
* IF(ITASK = 2 ) I1 and I12 are known, find I1
* IF(ITASK = 3 ) I1 and I2 are known , find I12
*
* D2h version , written for compatibility with general symmetry
*
      INTEGER SYMPRO(8,8)
      DATA  SYMPRO/1,2,3,4,5,6,7,8,
     &             2,1,4,3,6,5,8,7,
     &             3,4,1,2,7,8,5,6,
     &             4,3,2,1,8,7,6,5,
     &             5,6,7,8,1,2,3,4,
     &             6,5,8,7,2,1,4,3,
     &             7,8,5,6,3,4,1,2,
     &             8,7,6,5,4,3,2,1 /
*
      IF(ITASK.EQ.1) THEN
        I1 = SYMPRO(I2,I12)
*
C?    IF(I12.GT.8.OR.I2.GT.8.OR.I12.LE.0.OR.I2.LE.0) THEN
C?      WRITE(6,*) ' I12 and I2 = ', I12, I2
C?    END IF
*
      ELSE IF(ITASK.EQ.2) THEN
*
C?    IF(I12.GT.8.OR.I1.GT.8.OR.I12.LE.0.OR.I1.LE.0) THEN
C?      WRITE(6,*) ' I12 and I1 = ', I12, I1
C?    END IF
*
        I2 = SYMPRO(I1,I12)
      ELSE IF (ITASK.EQ.3) THEN
*
C?    IF(I2.GT.8.OR.I1.GT.8.OR.I2.LE.0.OR.I1.LE.0) THEN
C?      WRITE(6,*) ' I2 and I1 = ', I2, I1
C?    END IF
*
        I12 = SYMPRO(I1,I2)
*
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(IOBJ)
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine putci_cvb(civec)

use casvb_global, only: filename, iform_ci, ipr, istms2_d, istnel_d, istsy_d, mxirrep, ndet, nstats_d, nstsym_d, savvbci, strtci, &
                        variat, weight_d
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: civec(0:ndet)
integer(kind=iwp) :: ibf, icivec, istate, istsym_d, isyml, iwr, nci, ncix(mxirrep)
real(kind=wp) :: cnrm, fac
real(kind=wp), allocatable :: cim(:)
real(kind=wp), external :: dnrm2_
logical(kind=iwp), external :: valid_cvb ! ... Files/Hamiltonian available ...

icivec = nint(civec(0))
iwr = 1

if (iform_ci(icivec) /= 0) then
  write(u6,*) ' Unsupported format in GETCI :',iform_ci(icivec)
  call abend_cvb()
end if

if (iwr == 0) then
  if (ipr(1) >= 1) then
    write(u6,'(a)') ' '
    call prtfid_cvb(' Restoring CI vector from ',strtci)
  end if
  civec(1:) = Zero
else if (iwr == 1) then
  if ((ipr(5) >= 1) .and. valid_cvb(savvbci)) then
    write(u6,'(a)') ' '
    call prtfid_cvb(' Saving VB CI vector to ',savvbci)
  end if
end if

do istsym_d=1,nstsym_d
  isyml = istsy_d(istsym_d)
  call getnci_cvb(ncix,istnel_d(istsym_d),istms2_d(istsym_d),istsy_d(istsym_d))
  nci = ncix(1)
  call mma_allocate(cim,nci,label='cim')
  if (iwr == 0) then
    do istate=1,nstats_d(istsym_d)
      if (abs(weight_d(istate,istsym_d)) > 1.0e-20_wp) then
        call mkfn_cvb(strtci,ibf)
        call rdcivec_cvb(cim,filename(ibf),.true.)
        fac = sqrt(weight_d(istate,istsym_d))
        call mol2vbma_cvb(civec(1:),cim,isyml,fac)
      end if
    end do
  else if (iwr == 1) then
    do istate=1,nstats_d(istsym_d)
      if (abs(weight_d(istate,istsym_d)) > 1.0e-20_wp) then
        call vb2mol_cvb(civec(1:),cim,isyml)
        cnrm = One/dnrm2_(nci,cim,1)
        cim(:) = cnrm*cim(:)
        call mkfn_cvb(savvbci,ibf)
        call wrcivec_cvb(cim,filename(ibf),.not. variat)
      end if
    end do
  end if
  call mma_deallocate(cim)
end do

return

end subroutine putci_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!=======================================================================
! have computed vlop0 and vlop1, link to extern space
! (ss, st, ts, tt)
! lin type of the act-ext space node
! lri index of ar
! lrj index of bl
!=======================================================================
subroutine arbl_act_c_link_ext_ab(lin,lri,lrj)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lri, lrj

if (lin == 1) call ar_bl_ext_ss(lri,lrj,1)
if (lin == 2) call ar_bl_ext_st(lri,lrj,1)
if (lin == 3) call ar_bl_ext_ts(lri,lrj,1)
if (lin == 11) call ar_bl_ext_tt(lri,lrj,1)
if (lin == 10) call ar_br_sv_ext_br_ar(lri,lrj)
if (lin == 17) call ar_br_tv_ext_br_ar(lri,lrj)

return

end subroutine arbl_act_c_link_ext_ab

!=======================================================================
! have computed vlop0 and vlop1, link to extern space
! (ss, st, ts, tt)
! lin type of the act-ext space node
! lri index of drl
!=======================================================================
subroutine drl_act_c_link_ext_ab(lin,lri)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lri

if (lin == 1) call drl_ss_ext(lri)
if (lin == 2) call drl_st_ext(lri)
if (lin == 3) call drl_ts_ext(lri)
if (lin == 11) call drl_tt_ext(lri)

return

end subroutine drl_act_c_link_ext_ab

subroutine drl_act_c_link_ext_ab_sum(lin,lri,lrj)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lri, lrj

if (lin == 1) call drl_ss_sum(lri,lrj)
if (lin == 11) call drl_tt_sum(lri,lrj)

return

end subroutine drl_act_c_link_ext_ab_sum

subroutine sd_ar_act_bl_sgt0(lin,lra)
! sd(6-3) a&r(13)c'(22)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd3
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd3 = w0_sd(3)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd3 = -w0sd3
  end if
  ! sd(6-3) a&r(13)c'(22)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd3
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd3
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end do
end do

return

end subroutine sd_ar_act_bl_sgt0

!=======================================================================
! extern space -bl-ar or -br-al (ss,st,ts,tt)
! double occupied space ar-bl-  (ss)
! active space -c"-
! spin great than 0
!=======================================================================
subroutine ss_arbl_act_c_ext_ab_sgt0(lin)
!-----------------------------------------------------------------------
! ss(1-1)  ar(01)-bl(32)-        act -c"-
! ss(1-3)  ar(13)-bl(20)-        act -c"-
! ss(1-6)  (11)-ar(23)-bl(32)-   act -c"-
! ss(1-7)  ar(13)-c'(21)-bl(32)- act -c"-
! ss(1-8)  ar(13)-c'(22)-bl(31)- act -c"-
! ss(1-9)  ar(23)-c'(11)-bl(32)- act -c"-
! ss(1-11) ar(13)-bl(31)-c"(22)- act -c"-
! ss(1-12) ar(13)-bl(32)-c"(21)- act -c"-
! ss(1-13) ar(23)-bl(31)-c"(12)- act -c"-
!-----------------------------------------------------------------------

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0ss1, w0ss11, w0ss12, w0ss13, w0ss3, w0ss6, w0ss7, w0ss8, w0ss9, w1ss1, w1ss11, w1ss12, w1ss13, w1ss3, w1ss6, &
                 w1ss7, w1ss8, w1ss9
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    w0ss1 = w0_ss(1)
    w1ss1 = w1_ss(1)
    w0ss3 = w0_ss(3)
    w1ss3 = w1_ss(3)
    w0ss6 = w0_ss(6)
    w1ss6 = w1_ss(6)
    w0ss7 = w0_ss(7)
    w1ss7 = w1_ss(7)
    w0ss8 = w0_ss(8)
    w1ss8 = w1_ss(8)
    w0ss9 = w0_ss(9)
    w1ss9 = w1_ss(9)
    w0ss11 = w0_ss(11)
    w1ss11 = w1_ss(11)
    w0ss12 = w0_ss(12)
    w1ss12 = w1_ss(12)
    w0ss13 = w0_ss(13)
    w1ss13 = w1_ss(13)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0ss1 = -w0ss1
      w1ss1 = -w1ss1
      w0ss3 = -w0ss3
      w1ss3 = -w1ss3
      w0ss6 = -w0ss6
      w1ss6 = -w1ss6
      w0ss7 = -w0ss7
      w1ss7 = -w1ss7
      w0ss8 = -w0ss8
      w1ss8 = -w1ss8
      w0ss9 = -w0ss9
      w1ss9 = -w1ss9
      w0ss11 = -w0ss11
      w1ss11 = -w1ss11
      w0ss12 = -w0ss12
      w1ss12 = -w1ss12
      w0ss13 = -w0ss13
      w1ss13 = -w1ss13
    end if
    if ((jml == 1) .and. (lmij == jmr)) then
      ! ss(1-1)  ar(01)-bl(32)-        act -c"-
      iwdl = just(lri,lri)
      iwdr = just(lrj,lri)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss1
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss1
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end if
    if ((jmr == 1) .and. (lmij == jml)) then
      ! ss(1-3)  ar(13)-bl(20)-        act -c"-
      iwdl = just(lrj,lri)
      iwdr = just(lrj,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss3
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss3
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end if
    ! ss(1-6)  (11)-ar(23)-bl(32)-   act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss6
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss6
    end do
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmi,lmk)
      lmkj = Mul(lmj,lmk)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
    ! ss(1-7)  ar(13)-c'(21)-bl(32)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0ss7
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ss7
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmj,lmk)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
    ! ss(1-8)  ar(13)-c'(22)-bl(31)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0ss8
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ss8
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
    ! ss(1-9)  ar(23)-c'(11)-bl(32)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0ss9
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ss9
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
    ! ss(1-11) ar(13)-bl(31)-c"(22)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss11
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss11
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
    ! ss(1-12) ar(13)-bl(32)-c"(21)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss12
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmj,lmk)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
    ! ss(1-13) ar(23)-bl(31)-c"(12)- act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0ss13
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ss13
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmi,lmk)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
  end do
end do

return

end subroutine ss_arbl_act_c_ext_ab_sgt0

!=======================================================================
! extern space -bl-ar or -br-al (ss,st,ts,tt)
! double occupied space drl-  (ss)
! active space -c"-
! spin great than 0
!=======================================================================
subroutine ss_drl_act_c_ext_ab_sgt0(lin)
! ss(1-16) (11)-drl(22)-         act -c"-
! ss(1-18) drl(11)-c"(22)-       act -c"-
! ss(1-19) drl(12)-c"(21)-       act -c"-
! ss(1-20) (11)-drl(33)-c"(22)-  act -c"-
! ss(1-20) drl(33)-c"(11)-c"(22)-act -c"-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, lrk, mpl
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if ((lmij /= jml) .or. (lmij /= jmr)) cycle
    iwdl = just(lrj,lri)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    ! ss(1-16) (11)-drl(22)-         act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(16)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(16)
    end do
    call drl_act_c_link_ext_ab(lin,lrj)
    ! ss(1-18) drl(11)-c"(22)-       act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(18)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(18)
    end do
    call drl_act_c_link_ext_ab(lin,lri)
    ! ss(1-20) (11)-drl(33)-c"(22)-  act -c"-
    ! ss(1-20) drl(33)-c"(11)-c"(22)-act -c"-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(20)
      vplp_w1(mpl) = Zero
    end do
    do lrk=1,norb_dz
      if (lrk == lri) cycle
      if (lrk == lrj) cycle
      call drl_act_c_link_ext_ab(lin,lrk)
    end do
  end do
end do

return

end subroutine ss_drl_act_c_ext_ab_sgt0

!=======================================================================
! extern space -bl-ar or -br-al (ss,st,ts,tt)
! double occupied space drl-  (st)
! active space -c"-
! spin great than 0
!=======================================================================
subroutine st_drl_act_c_ext_ab_sgt0(lin)
! st(2-7) drl(12)-c"(22)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

if (jmr /= jml) return
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (jml /= lmij) cycle
    iwdl = just(lrj,lri)
    iwdr = just(lri,lrj)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_st(7)
    end do
    call drl_act_c_link_ext_ab(lin,lri)
  end do
end do

return

end subroutine st_drl_act_c_ext_ab_sgt0

!=======================================================================
! extern space -bl-ar or -br-al (ss,st,ts,tt)
! double occupied space ar-bl-  (st)
! active space -c"-
! spin great than 0
!=======================================================================
subroutine st_arbl_act_c_ext_ab_sgt0(lin)
! st(2-3) ar(13)-c'(22)-bl(32)-
! st(2-3) ar(13)-bl(32)-c'(22)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w1st3
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    w1st3 = w1_st(3)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w1st3 = -w1st3
    end if
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! st(2-3) ar(13)-c'(22)-bl(32)-
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = -vplpnew_w1(mpl)*w1st3
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do

    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        ! st(2-3) ar(13)-bl(32)-c'(22)-
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1st3
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
  end do
end do

return

end subroutine st_arbl_act_c_ext_ab_sgt0

subroutine stt_arbl_act_c_ext_ab_sgt1(lin)
! st1(4-1) ar(01)-bl(31)-
! st1(4-2) (11)ar(23)-bl(31)-
! st1(4-3) ar(13)-c'(21)-bl(31)-
! st1(4-3) ar(13)-bl(31)-c"(21)-
! st1(4-4) ar(23)-c'(11)-bl(31)-
! st1(4-4) ar(23)-bl(31)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_st1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lri, lrj, lrk, mpl
real(kind=wp) :: w1st1, w1st2, w1st3, w1st4
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    w1st1 = w1_st1(1)
    w1st2 = w1_st1(2)
    w1st3 = w1_st1(3)
    w1st4 = w1_st1(4)
    if (mod(lrj-lri,2) == 0) then
      w1st1 = -w1st1
      w1st2 = -w1st2
      w1st3 = -w1st3
      w1st4 = -w1st4
    end if
    ! st1(4-1) ar(01)-bl(31)-
    if ((jml == 1) .and. (jmr == Mul(lmi,lmj))) then
      iwdl = just(lri,lri)
      iwdr = just(lri,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = Zero
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1st1
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end if
    ! st1(4-2) (11)ar(23)-bl(31)-
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      if ((jml /= Mul(lmk,lmi)) .or. (jmr /= Mul(lmk,lmj))) cycle
      iwdl = just(lri,lrk)
      iwdr = just(lrk,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = Zero
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1st2
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end do
    ! st1(4-3) ar(13)-c'(21)-bl(31)-
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      if ((jml == Mul(lmi,lmk)) .and. (jmr == Mul(lmk,lmj))) then
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = -vplpnew_w1(mpl)*w1st3
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
        ! st1(4-4) ar(23)-c'(11)-bl(31)-
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = -vplpnew_w1(mpl)*w1st4
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      ! st1(4-4) ar(23)-bl(31)-c"(11)-
      if ((jml == Mul(lmi,lmk)) .and. (jmr == Mul(lmj,lmk))) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1st4
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
        ! st1(4-3) ar(13)-bl(31)-c"(21)-
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1st3
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
  end do
end do

return

end subroutine stt_arbl_act_c_ext_ab_sgt1

subroutine tts_arbl_act_c_ext_ab_sgt1(lin)
! t1s(5-1)   ar(13)-bl(10)-
! t1s(5-2)   ar(13)-bl(32)-
! t1s(5-2)   ar(13)-c'(11)-bl(32)-
! t1s(5-3)   ar(13)-bl(31)-c"(12)-
! t1s(5-4)   ar(13)-bl(32)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lri, lrj, lrk, mpl
real(kind=wp) :: w1ts1, w1ts2, w1ts3, w1ts4
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    w1ts1 = w1_t1s(1)
    w1ts2 = w1_t1s(2)
    w1ts3 = w1_t1s(3)
    w1ts4 = w1_t1s(4)
    if (mod(lrj-lri,2) == 0) then
      w1ts1 = -w1ts1
      w1ts2 = -w1ts2
      w1ts3 = -w1ts3
      w1ts4 = -w1ts4
    end if
    ! t1s(5-1)   ar(13)-bl(10)-
    if ((jml == Mul(lmi,lmj)) .and. (jmr == 1)) then
      iwdl = just(lri,lrj)
      iwdr = just(lrj,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = Zero
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts1
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end if
    ! t1s(5-2)   (11)ar(13)-bl(32)-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts2
    end do
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      if ((jml /= Mul(lmk,lmi)) .or. (jmr /= Mul(lmk,lmj))) cycle
      iwdl = just(lrk,lri)
      iwdr = just(lrj,lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end do
    ! t1s(5-2)   ar(13)-c'(11)-bl(32)-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ts2
    end do
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      if ((jml /= Mul(lmi,lmk)) .or. (jmr /= Mul(lmk,lmj))) cycle
      iwdl = just(lri,lrk)
      iwdr = just(lrj,lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end do
    ! t1s(5-3)   ar(13)-bl(31)-c"(12)-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts3
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      if ((jml /= Mul(lmi,lmk)) .or. (jmr /= Mul(lmj,lmk))) cycle
      iwdl = just(lri,lrk)
      iwdr = just(lrk,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end do
    ! t1s(5-4)   ar(13)-bl(32)-c"(11)-
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts4
    end do
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      if ((jml /= Mul(lmi,lmk)) .or. (jmr /= Mul(lmj,lmk))) cycle
      iwdl = just(lri,lrk)
      iwdr = just(lrj,lrk)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end do
  end do
end do

return

end subroutine tts_arbl_act_c_ext_ab_sgt1

subroutine tts_drl_act_c_ext_ab_sgt1(lin)
! t1s(5-5)   (11)drl(12)-
! t1s(5-6)   drl(11)-c"(12)-
! t1s(5-7)   drl(12)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

if (jml /= jmr) return
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (jml /= lmij) cycle
    ! t1s(5-5)   (11)drl(12)-
    iwdl = just(lri,lrj)
    iwdr = just(lrj,lri)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_t1s(5)
    end do
    call drl_act_c_link_ext_ab(lin,lrj)
    ! t1s(5-6)   drl(11)-c"(12)-
    iwdl = just(lri,lrj)
    iwdr = just(lrj,lri)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_t1s(6)
    end do
    call drl_act_c_link_ext_ab(lin,lri)
    ! t1s(5-7)   drl(12)-c"(11)-
    iwdl = just(lri,lrj)
    iwdr = just(lri,lrj)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_t1s(7)
    end do
    call drl_act_c_link_ext_ab(lin,lri)
  end do
end do

return

end subroutine tts_drl_act_c_ext_ab_sgt1

subroutine sdd_ar_act_bl_sgt0(lin,lra)
! sd1(8-1)    ar(01)-
! sd1(8-2)    (11)ar(23)-
! sd1(8-3)    ar(13)-c'(21)-
! sd1(8-4)    ar(23)-c'(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd3, w0sd4
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd1 = w0_sd1(1)
  w0sd2 = w0_sd1(2)
  w0sd3 = w0_sd1(3)
  w0sd4 = w0_sd1(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd3 = -w0sd3
    w0sd4 = -w0sd4
  end if
  if ((jml == 1) .and. (lmi == jmr)) then
    ! sd1(8-1)    ar(01)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
    end do
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end if
  ! sd1(8-2)    (11)ar(23)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
  end do
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)

  end do
  ! sd1(8-3)    ar(13)-c'(21)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd3
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd3
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end do
  ! sd1(8-4)    ar(23)-c'(11)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd4
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end do
end do

return

end subroutine sdd_ar_act_bl_sgt0

subroutine tttt_arbl_act_c_ext_ab_sgt0(lin)
! t1t1(12-1)  ar(13)-bl(31)-
! t1t1(12-1)  ar(13)-c'(11)-bl(31)-
! t1t1(12-1)  ar(13)-bl(31)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1t1, w1_t1t1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lmk, lmki, lmkj, lri, lrj, lrk, mpl, ni
real(kind=wp) :: w0tt1, w1tt1
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    w0tt1 = w0_t1t1(1)
    w1tt1 = w1_t1t1(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0tt1 = -w0tt1
      w1tt1 = -w1tt1
    end if
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0tt1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1tt1
    end do
    ! t1t1(12-1)  (11)ar(13)-bl(31)-
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lrk,lri)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
    ! t1t1(12-1)  ar(13)-bl(31)-c"(11)-
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = -vplp_w0(mpl)
      vplp_w1(mpl) = -vplp_w1(mpl)
    end do
    ! t1t1(12-1)  ar(13)-c'(11)-bl(31)-
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      lmki = Mul(lmk,lmi)
      lmkj = Mul(lmk,lmj)
      if ((lmki == jml) .and. (lmkj == jmr)) then
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        call arbl_act_c_link_ext_ab(lin,lri,lrj)
      end if
    end do
  end do
end do

return

end subroutine tttt_arbl_act_c_ext_ab_sgt0

subroutine tttt_drl_act_c_ext_ab_sgt0(lin)
! t1t1(12-2)  drl(11)-
! t1t1(12-2)  drl(11)-c"(11)-
! t1t1(12-3)  drl(33)-
! t1t1(12-3)  drl(33)-c"(11)-
! t1t1(12-3)  drl(33)-c"(11)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1t1, w1_t1t1
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
real(kind=wp) :: w0tt2, w0tt3, w1tt2
integer(kind=iwp), external :: iwalk_ad

w0tt2 = w0_t1t1(2)
w1tt2 = w1_t1t1(2)
w0tt3 = w0_t1t1(3)
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if ((lmij /= jml) .or. (lmij /= jmr)) cycle
    ! t1t1(12-2)  drl(11)-
    ! t1t1(12-2)  drl(11)-c"(11)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0tt2
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1tt2
    end do
    iwdl = just(lri,lrj)
    iwdr = iwdl
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call drl_act_c_link_ext_ab(lin,lri)
    call drl_act_c_link_ext_ab(lin,lrj)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0tt3
      vplp_w1(mpl) = Zero
    end do
    ! t1t1(12-3)  drl(33)-
    ! t1t1(12-3)  drl(33)-c"(11)-
    ! t1t1(12-3)  drl(33)-c"(11)-c"(11)-
    !do lrk=1,norb_dz
    !  if (lrk == lri) cycle
    !  if (lrk == lrj) cycle
    !  call drl_ss_ext(lrk)
    !end do
    call drl_act_c_link_ext_ab_sum(lin,lri,lrj)
  end do
end do

return

end subroutine tttt_drl_act_c_ext_ab_sgt0

subroutine ttdd_ar_act_bl_sgt1(lin,lra)
! t1d1(15-1)  ar(13)-
! t1d1(15-1)  ar(13)-c'(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_t1d1(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1
  !---------------------------------------------------------------------
  ! t1d1(15-1)  (11)ar(13)-
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end do
  !---------------------------------------------------------------------
  ! t1d1(15-1)  ar(13)-c'(11)-
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 1) call ar_bl_ext_ss(lri,lra,1)
    if (lin == 2) call ar_bl_ext_st(lri,lra,1)
    if (lin == 3) call ar_bl_ext_ts(lri,lra,1)
    if (lin == 11) call ar_bl_ext_tt(lri,lra,1)
  end do
end do

return

end subroutine ttdd_ar_act_bl_sgt1

subroutine d1d1_arbl_act_c_ext_ab_sgt0(lin)
! d1d1(20-1) ar(13)-bl(31)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d1, w1_d1d1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    if ((jml /= lmi) .and. (jmr /= lmj)) cycle
    w0dd1 = w0_d1d1(1)
    w1dd1 = w1_d1d1(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0dd1 = -w0dd1
      w1dd1 = -w1dd1
    end if
    if ((lmi == jml) .and. (lmj == jmr)) then
      ! d1d1(20-1) ar(13)-bl(31)-
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd1
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
      end do
      iwdl = jud(lri)
      iwdr = jud(lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end if
  end do
end do

return

end subroutine d1d1_arbl_act_c_ext_ab_sgt0

subroutine d1d1_drl_act_c_ext_ab_sgt0(lin)
! d1d1(20-2) drl(11)-
! d1d1(20-3) drl(33)-
! d1d1(20-3) drl(33)-c"(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d1, w1_d1d1
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lri, lrk, mpl
real(kind=wp) :: w0dd2, w0dd3, w1dd2
integer(kind=iwp), external :: iwalk_ad

if (jml /= jmr) return
w0dd2 = w0_d1d1(2)
w1dd2 = w1_d1d1(2)
w0dd3 = w0_d1d1(3)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jml) cycle
  ! d1d1(20-2) drl(11)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd2
  end do
  iwdl = jud(lri)
  iwdr = iwdl
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  call drl_act_c_link_ext_ab(lin,lri)
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd3
    vplp_w1(mpl) = Zero
  end do
  ! d1d1(20-3) drl(33)-
  ! d1d1(20-3) drl(33)-c"(11)-
  do lrk=1,norb_dz
    if (lrk == lri) cycle
    call drl_act_c_link_ext_ab(lin,lrk)
  end do
  !call drl_act_c_link_ext_ab_sum(lin,lri,0)
end do

return

end subroutine d1d1_drl_act_c_ext_ab_sgt0

subroutine dd1_arbl_act_c_ext_ab_sgt0(lin)
! dd1(21) ar(23)-bl(31)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_dd1, w1_dd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    w0dd1 = w0_dd1
    w1dd1 = w1_dd1
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0dd1 = -w0dd1
      w1dd1 = -w1dd1
    end if
    if ((lmi == jml) .and. (lmj == jmr)) then
      ! dd1(21)ar(23)-bl(31)-
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd1
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
      end do
      iwdl = jud(lri)
      iwdr = jud(lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end if
  end do
end do

return

end subroutine dd1_arbl_act_c_ext_ab_sgt0

subroutine d1d_arbl_act_c_ext_ab_sgt0(lin)
! d1d(22-1)   ar(13)-bl(32)-
! d1d(22-2)   drl(12)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d, w1_d1d
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0dd1, w1dd1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    w0dd1 = w0_d1d(1)
    w1dd1 = w1_d1d(1)
    ni = mod(lrj-lri,2)
    if (ni == 0) then
      w0dd1 = -w0dd1
      w1dd1 = -w1dd1
    end if
    if ((lmi == jml) .and. (lmj == jmr)) then
      ! d1d(22-1)   ar(13)-bl(32)-
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0dd1
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1dd1
      end do
      iwdl = jud(lri)
      iwdr = jud(lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      call arbl_act_c_link_ext_ab(lin,lri,lrj)
    end if
  end do
end do

return

end subroutine d1d_arbl_act_c_ext_ab_sgt0

subroutine d1d_drl_act_c_ext_ab_sgt0(lin)
! d1d(22-2)   drl(12)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1d, w1_d1d
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lri, mpl
integer(kind=iwp), external :: iwalk_ad

if (jmr /= jml) return
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (jml /= lmi) cycle
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0_d1d(2)
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1_d1d(2)
  end do
  iwdl = jud(lri)
  iwdr = jud(lri)
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  call drl_act_c_link_ext_ab(lin,lri)
end do

return

end subroutine d1d_drl_act_c_ext_ab_sgt0

subroutine d1v_ar_act_bl_ext_ab_sgt0(lin,lra)
! d1v(24-1)  ar(13)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_d1v
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lri, mpl, ni
real(kind=wp) :: w0dv1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0dv1 = w0_d1v(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0dv1 = -w0dv1
  ! d1v(24-1)  ar(13)-
  iwdl = jud(lri)
  iwdr = 0
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0dv1
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0dv1
  end do
  call arbl_act_c_link_ext_ab(lin,lri,lra)
end do

return

end subroutine d1v_ar_act_bl_ext_ab_sgt0

subroutine ar_br_stv_link_ext_brar(lin,lri,lrj)

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lri, lrj

if (lin == 17) call ar_br_tv_ext_br_ar(lri,lrj)
if (lin == 10) call ar_br_sv_ext_br_ar(lri,lrj)

end subroutine ar_br_stv_link_ext_brar

subroutine sd_ar_act_br_sgt0(lin,lra)
! sd(6-3) a&r(13)c'(22)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd3
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd3 = w0_sd(3)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0sd3 = -w0sd3

  ! sd(6-3) a&r(13)c'(22)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd3
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd3
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_stv_link_ext_brar(lin,lri,lra)
  end do
end do

return

end subroutine sd_ar_act_br_sgt0

subroutine sdd_ar_act_br_sgt0(lin,lra)
! sd1(8-1)    ar(01)-
! sd1(8-2)    (11)ar(23)-
! sd1(8-3)    ar(13)-c'(21)-
! sd1(8-4)    ar(23)-c'(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd3, w0sd4
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd1 = w0_sd1(1)
  w0sd2 = w0_sd1(2)
  w0sd3 = w0_sd1(3)
  w0sd4 = w0_sd1(4)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) then
    w0sd1 = -w0sd1
    w0sd2 = -w0sd2
    w0sd3 = -w0sd3
    w0sd4 = -w0sd4
  end if
  if ((jml == 1) .and. (lmi == jmr)) then
    ! sd1(8-1)    ar(01)-
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
    end do
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_stv_link_ext_brar(lin,lri,lra)
  end if
  ! sd1(8-2)    (11)ar(23)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
  end do
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_stv_link_ext_brar(lin,lri,lra)
  end do
  ! sd1(8-3)    ar(13)-c'(21)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd3
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd3
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_stv_link_ext_brar(lin,lri,lra)
  end do
  ! sd1(8-4)    ar(23)-c'(11)-
  do mpl=1,mtype
    vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4
    vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd4
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_stv_link_ext_brar(lin,lri,lra)
  end do
end do

return

end subroutine sdd_ar_act_br_sgt0

subroutine ttdd_ar_act_br_sgt1(lin,lra)
! t1d1(15-1)  ar(13)-
! t1d1(15-1)  ar(13)-c'(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0td1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0td1 = w0_t1d1(1)
  ni = mod(norb_dz-lri,2)
  if (ni == 1) w0td1 = -w0td1
  !---------------------------------------------------------------------
  ! t1d1(15-1)  (11)ar(13)-
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_stv_link_ext_brar(lin,lri,lra)
  end do
  !---------------------------------------------------------------------
  ! t1d1(15-1)  ar(13)-c'(11)-
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0td1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_stv_link_ext_brar(lin,lri,lra)
  end do
end do

return

end subroutine ttdd_ar_act_br_sgt1

subroutine ttv_arbr_act_c_stv_sgt1(lin)
! t1v(18) ar(13)-br(13)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1v
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w1
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmlr) cycle
    !-------------------------------------------------------------------
    iwdl = just(lri,lrj)
    iwdr = 0
    ni = mod(lrj-lri,2)
    w1 = w1_t1v
    if (ni == 0) w1 = -w1
    do mpl=1,mtype
      vplp_w0(mpl) = Zero
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_br_stv_link_ext_brar(lin,lri,lrj)
  end do
end do

return

end subroutine ttv_arbr_act_c_stv_sgt1

subroutine ss_s_drl_act_c_ext_ab_sgt0(lin)
! ss(1-19) drl(12)-c"(21)-       act -c"-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, mtype, &
                         norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_ss, w1_ss
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl
integer(kind=iwp), external :: iwalk_ad

if (jml /= jmr) return
do lri=norb_frz+1,norb_dz-1
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle
    ! ss(1-19) drl(12)-c"(21)-       act -c"-
    iwdl = just(lrj,lri)
    iwdr = just(lri,lrj)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0_ss(19)
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1_ss(19)
    end do
    call drl_act_c_link_ext_ab(lin,lri)
  end do
end do

return

end subroutine ss_s_drl_act_c_ext_ab_sgt0

subroutine ds_arblbr_act_c1_sgt0(lin)
!=======================================================================
! ds(7-2) ar(23)-bl(31)-br(32)-
!=======================================================================

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_ds
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmd, lmi, lmij, lmj, lrd, lri, lrj, mpl, ni
real(kind=wp) :: w1ds
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jmr) cycle
    ! ds(7-2) ar(23)-bl(31)-br(32)-
    do lrd=norb_frz+1,lri-1
      lmd = lsm_inn(lrd)
      if (lmd /= jml) cycle
      ijk = lrd-norb_frz+ngw2(lri-norb_frz)+ngw3(lrj-norb_frz)
      intpos = intind_ijka(ijk)
      w1ds = w1_ds(2)
      ni = mod(norb_dz-lrj+lri-lrd,2)
      if (ni == 0) w1ds = -w1ds

      iwdr = just(lrj,lri)
      iwdl = jud(lrd)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = Zero
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ds
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    end do
  end do
end do

return

end subroutine ds_arblbr_act_c1_sgt0

subroutine sdd_ar_act_dlr_sgt0(lin,lra)
! sd1(8-1)    ar(01)-
! sd1(8-2)    (11)ar(23)-
! sd1(8-3)    ar(13)-c'(21)-
! sd1(8-4)    ar(23)-c'(11)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd1, w1_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, mpl
real(kind=wp) :: w0sd1, w0sd2, w0sd3, w0sd4, w1sd1, w1sd2, w1sd3, w1sd4
integer(kind=iwp), external :: iwalk_ad

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  w0sd1 = w0_sd1(1)
  w1sd1 = w1_sd1(1)
  w0sd2 = w0_sd1(2)
  w1sd2 = w1_sd1(2)
  w0sd3 = w0_sd1(3)
  w1sd3 = w1_sd1(3)
  w0sd4 = w0_sd1(4)
  w1sd4 = w1_sd1(4)
  if (mod(norb_dz-lri,2) == 1) then
    w0sd1 = -w0sd1
    w1sd1 = -w1sd1
    w0sd2 = -w0sd2
    w1sd2 = -w1sd2
    w0sd3 = -w0sd3
    w1sd3 = -w1sd3
    w0sd4 = -w0sd4
    w1sd4 = -w1sd4
  end if
  ! sd1(8-1)    ar(01)-
  if ((jml == 1) .and. (jmr == lmi)) then
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd1
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end if
  ! sd1(8-2)    (11)ar(23)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd2
  end do
  do lrj=norb_frz+1,lri-1
    lmj = lsm_inn(lrj)
    if ((jml /= Mul(lmi,lmj)) .or. (jmr /= lmj)) cycle
    iwdl = just(lri,lrj)
    iwdr = jud(lrj)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end do
  ! sd1(8-3)    ar(13)-c'(21)-
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    if ((jml /= Mul(lmi,lmj)) .or. (jmr /= lmj)) cycle
    iwdl = just(lrj,lri)
    iwdr = jud(lrj)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd3
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1sd3
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
    ! sd1(8-4)    ar(23)-c'(11)-
    iwdl = just(lri,lrj)
    iwdr = jud(lrj)
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1sd4
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end do
end do

return

end subroutine sdd_ar_act_dlr_sgt0

!subroutine tts_arbl_act_c_sgt1(lin,lra)
!!=======================================================================
!! tts(5) a&r-b^l-  act -b&l ............................................
!! t1s(5-1)   ar(13)-bl(10)-
!! t1s(5-2)   ar(13)-bl(32)-
!! t1s(5-2)   ar(13)-c'(11)-bl(32)-
!! t1s(5-3)   ar(13)-bl(31)-c"(12)-
!! t1s(5-4)   ar(13)-bl(32)-c"(11)-
!
!use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
!                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1s
!use Symmetry_Info, only: Mul
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: lin, lra
!integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl
!real(kind=wp) :: w1ts1, w1ts2, w1ts3, w1ts4
!integer(kind=iwp), external :: iwalk_ad
!
!isma = Mul(iml,imr)
!do lri=norb_frz+1,norb_dz
!  lmi = lsm_inn(lri)
!  do lrj=lri+1,norb_dz
!    lmj = lsm_inn(lrj)
!    lmij = Mul(lmi,lmj)
!    w1ts1 = w1_t1s(1)
!    w1ts2 = w1_t1s(2)
!    w1ts3 = w1_t1s(3)
!    w1ts4 = w1_t1s(4)
!    if (mod(lrj-lri,2) == 0) then
!      w1ts1 = -w1ts1
!      w1ts2 = -w1ts2
!      w1ts3 = -w1ts3
!      w1ts4 = -w1ts4
!    end if
!    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz) !???
!    intpos = intind_ijka(ijk)                         !???
!    ! t1s(5-1)   ar(13)-bl(10)-
!    if ((jmr == 1) .and. (jml == lmij)) then
!      iwdl = just(lri,lrj)
!      iwdr = just(lrj,lrj)
!      do mpl=1,mhlp
!        iwal = lpnew_lwei(mpl)
!        iwar = lpnew_rwei(mpl)
!        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!      end do
!      do mpl=1,mtype
!        vplp_w0(mpl) = Zero
!        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts1
!      end do
!      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!    end if
!    ! t1s(5-2)   (11)ar(13)-bl(32)-
!    do lrk=norb_frz+1,lri-1
!      lmk = lsm_inn(lrk)
!      if ((jmr == Mul(lmk,lmi)) .and. (jml == Mul(lmk,lmj))) then
!        iwdl = just(lrk,lri)
!        iwdr = just(lrj,lrk)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        do mpl=1,mtype
!          vplp_w0(mpl) = Zero
!          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts2
!        end do
!        call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!      end if
!    end do
!    ! t1s(5-2)   ar(13)-c'(11)-bl(32)-
!    do lrk=lri+1,lrj-1
!      lmk = lsm_inn(lrk)
!      if ((jmr == Mul(lmi,lmk)) .and. (jml == Mul(lmk,lmj))) then
!        iwdl = just(lri,lrk)
!        iwdr = just(lrj,lrk)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        do mpl=1,mtype
!          vplp_w0(mpl) = Zero
!          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts2
!        end do
!        call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!      end if
!    end do
!    ! t1s(5-3)   ar(13)-bl(31)-c"(12)-
!    do lrk=lrj+1,norb_dz
!      lmk = lsm_inn(lrk)
!      if ((jmr == Mul(lmi,lmk)) .and. (jml == Mul(lmj,lmk))) then
!        iwdl = just(lri,lrk)
!        iwdr = just(lrk,lrj)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        do mpl=1,mtype
!          vplp_w0(mpl) = Zero
!          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts3
!        end do
!        call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!        ! t1s(5-4)   ar(13)-bl(32)-c"(11)-
!        iwdl = just(lri,lrk)
!        iwdr = just(lrj,lrk)
!        do mpl=1,mhlp
!          iwal = lpnew_lwei(mpl)
!          iwar = lpnew_rwei(mpl)
!          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
!          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
!        end do
!        do mpl=1,mtype
!          vplp_w0(mpl) = Zero
!          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts4
!        end do
!        call ar_bl_br_ext_al_new(lin,intpos,isma,1)
!      end if
!    end do
!  end do
!end do
!
!return
!
!end subroutine tts_arbl_act_c_sgt1

subroutine tts_arbl_act_br_sgt1(lin,lra)
!=======================================================================
! tts(5) a&r-b^l-  act -b&l ............................................
! t1s(5-1)   ar(13)-bl(10)-
! t1s(5-2)   ar(13)-bl(32)-
! t1s(5-2)   ar(13)-c'(11)-bl(32)-
! t1s(5-3)   ar(13)-bl(31)-c"(12)-
! t1s(5-4)   ar(13)-bl(32)-c"(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, ngw2, ngw3, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w1, w1_t1s
use Symmetry_Info, only: Mul
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lmk, lri, lrj, lrk, mpl
real(kind=wp) :: w1ts1, w1ts2, w1ts3, w1ts4
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    w1ts1 = w1_t1s(1)
    w1ts2 = w1_t1s(2)
    w1ts3 = w1_t1s(3)
    w1ts4 = w1_t1s(4)
    if (mod(lrj-lri,2) == 0) then
      w1ts1 = -w1ts1
      w1ts2 = -w1ts2
      w1ts3 = -w1ts3
      w1ts4 = -w1ts4
    end if
    ijk = lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz) !???
    intpos = intind_ijka(ijk)                         !???
    ! t1s(5-1)   ar(13)-bl(10)-
    if ((jmr == 1) .and. (jml == lmij)) then
      iwdl = just(lri,lrj)
      iwdr = just(lrj,lrj)
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      do mpl=1,mtype
        vplp_w0(mpl) = Zero
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts1
      end do
      call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    end if
    ! t1s(5-2)   (11)ar(13)-bl(32)-
    do lrk=norb_frz+1,lri-1
      lmk = lsm_inn(lrk)
      if ((jml == Mul(lmk,lmi)) .and. (jmr == Mul(lmk,lmj))) then
        iwdl = just(lrk,lri)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts2
        end do
        call ar_bl_br_ext_al_new(lin,intpos,isma,1)
      end if
    end do
    ! t1s(5-2)   ar(13)-c'(11)-bl(32)-
    do lrk=lri+1,lrj-1
      lmk = lsm_inn(lrk)
      if ((jml == Mul(lmi,lmk)) .and. (jmr == Mul(lmk,lmj))) then
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = -vplpnew_w1(mpl)*w1ts2
        end do
        call ar_bl_br_ext_al_new(lin,intpos,isma,1)
      end if
    end do
    ! t1s(5-3)   ar(13)-bl(31)-c"(12)-
    do lrk=lrj+1,norb_dz
      lmk = lsm_inn(lrk)
      if ((jml == Mul(lmi,lmk)) .and. (jmr == Mul(lmj,lmk))) then
        iwdl = just(lri,lrk)
        iwdr = just(lrk,lrj)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts3
        end do
        call ar_bl_br_ext_al_new(lin,intpos,isma,1)
        ! t1s(5-4)   ar(13)-bl(32)-c"(11)-
        iwdl = just(lri,lrk)
        iwdr = just(lrj,lrk)
        do mpl=1,mhlp
          iwal = lpnew_lwei(mpl)
          iwar = lpnew_rwei(mpl)
          lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
        end do
        do mpl=1,mtype
          vplp_w0(mpl) = Zero
          vplp_w1(mpl) = vplpnew_w1(mpl)*w1ts4
        end do
        call ar_bl_br_ext_al_new(lin,intpos,isma,1)
      end if
    end do
  end do
end do

return

end subroutine tts_arbl_act_br_sgt1

subroutine sd_ar_act_dlr_sgt0(lin,lra)
! sd(6-3) a&r(13)c'(22)-

use gugaci_global, only: ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, lsm_inn, mhlp, &
                         mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, lra
integer(kind=iwp) :: iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd3
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  w0sd3 = w0_sd(3)
  ni = mod(norb_dz-lri,2)
  if (ni == 0) then
    w0sd3 = -w0sd3
  end if
  !---------------------------------------------------------------------
  ! sd(6-3) a&r(13)c'(22)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd3
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd3
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_drl_ext_al_new(lin,lri,lra)
  end do
end do

return

end subroutine sd_ar_act_dlr_sgt0

subroutine sdd_ar_act_blbr_sgt0(lin,jk)
! sdd(8-1) a&r(01)-
! sdd(8-2) (11)a&(23)-
! sdd(8-3) a&r(13)c'(21)-
! sdd(8-4) a&r(23)c'(11)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd1, &
                         w1_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, lmi, lmk, lri, lrk, mpl
real(kind=wp) :: w0sd1, w0sd2, w0sd3, w0sd4, w1sd1, w1sd2, w1sd3, w1sd4
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  w0sd1 = w0_sd1(1)
  w1sd1 = w1_sd1(1)
  w0sd2 = w0_sd1(2)
  w1sd2 = w1_sd1(2)
  w0sd3 = w0_sd1(3)
  w1sd3 = w1_sd1(3)
  w0sd4 = w0_sd1(4)
  w1sd4 = w1_sd1(4)
  if (mod(norb_dz-lri,2) == 1) then
    w0sd1 = -w0sd1
    w1sd1 = -w1sd1
    w0sd2 = -w0sd2
    w1sd2 = -w1sd2
    w0sd3 = -w0sd3
    w1sd3 = -w1sd3
    w0sd4 = -w0sd4
    w1sd4 = -w1sd4
  end if
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  ! sdd(8-1) a&r(01)-
  if ((jml == 1) .and. (lmi == jmr)) then
    iwdl = just(lri,lri)
    iwdr = jud(lri)
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd1
    end do
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end if
  !---------------------------------------------------------------------
  ! sdd(8-2) c(11)a&(23)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
  end do
  do lrk=norb_frz+1,lri-1
    lmk = lsm_inn(lrk)
    if ((lmk /= jmr) .or. (jml /= Mul(lmk,lmi))) cycle
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end do
  !---------------------------------------------------------------------
  ! sdd(8-3) a&r(13)c'(21)-
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if ((lmk /= jmr) .or. (jml /= Mul(lmi,lmk))) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd3
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd3
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
    ! sdd(8-4) a&r(23)c'(11)-
    iwdl = just(lri,lrk)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0sd4
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w0sd4
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end do
end do

return

end subroutine sdd_ar_act_blbr_sgt0

subroutine sd_ar_act_blbr_sgt0(lin,jk)
! sd(6-3) a&r(13)c'(22)-

use gugaci_global, only: iml, imr, intind_ijka, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, &
                         lpnew_rwei, lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin, jk
integer(kind=iwp) :: ijk, intpos, isma, iwal, iwar, iwdl, iwdr, jmlr, lmi, lmk, lri, lrk, mpl, ni
real(kind=wp) :: w0sd3
integer(kind=iwp), external :: iwalk_ad

jmlr = Mul(jml,jmr)
isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if (lmi /= jmlr) cycle
  ijk = lri-norb_frz+jk
  intpos = intind_ijka(ijk)
  w0sd3 = w0_sd(3)
  ni = mod(norb_dz-lri,2)
  if (ni == 0) then
    w0sd3 = -w0sd3
  end if
  !---------------------------------------------------------------------
  ! sd(6-3) a&r(13)c'(22)-
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd3
    vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd3
  end do
  do lrk=lri+1,norb_dz
    lmk = lsm_inn(lrk)
    if (lmk /= jmr) cycle
    iwdl = just(lrk,lri)
    iwdr = jud(lrk)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    call ar_bl_br_ext_al_new(lin,intpos,isma,1)
  end do
end do

return

end subroutine sd_ar_act_blbr_sgt0

subroutine sdd_ar_act_c_sd_ext_sgt0(lin)
! sd1(8-1)    ar(01)-
! sd1(8-2)    (11)ar(23)-
! sd1(8-3)    ar(13)-c'(21)-
! sd1(8-4)    ar(23)-c'(11)-

use gugaci_global, only: iml, imr, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_sd1, w1_sd1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: isma, iwal, iwar, iwdl, iwdr, lmi, lmij, lmj, lri, lrj, mpl, ni
real(kind=wp) :: w0sd1, w0sd2, w0sd3, w0sd4, w1sd1, w1sd3, w1sd4
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  if ((jml /= 1) .or. (jmr /= lmi)) cycle
  w0sd1 = w0_sd1(1)
  w1sd1 = w1_sd1(1)
  if (mod(norb_dz-lri,2) == 1) then
    w0sd1 = -w0sd1
    w1sd1 = -w1sd1
  end if
  iwdl = just(lri,lri)
  iwdr = jud(lri)
  do mpl=1,mhlp
    iwal = lpnew_lwei(mpl)
    iwar = lpnew_rwei(mpl)
    lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
    lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
  end do
  do mpl=1,mtype
    vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd1
    vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd1
  end do
  if (lin == 6) then
    call ar_sd_ext_ar(26,lri,lrj,isma)
    call ar_sd_ext_rest(lri)
  end if
  if (lin == 13) then
    call ar_td_ext_ar(26,lri,lrj,isma)
    call ar_td_ext_rest(lri)
  end if
  if (lin == 23) then
    call ar_dv_ext_ar(26,isma,lri,lrj)   !ar_dv
  end if
end do

do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    lmij = Mul(lmi,lmj)
    if (lmij /= jml) cycle

    if (lmi == jmr) then
      iwdl = just(lrj,lri)
      iwdr = jud(lri)
      w0sd2 = w0_sd1(2)
      !w1sd2 = w0_sd1(2)
      ni = mod(norb_dz-lrj,2)
      if (ni == 1) then
        !w1sd2 = -w1sd2
        w0sd2 = -w0sd2
      end if
      ! sd1(8-2)    (11)ar(23)-
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd2
        vplp_w1(mpl) = vplpnew_w1(mpl)*w0sd2
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      if (lin == 6) then
        call ar_sd_ext_ar(25,lrj,lri,isma)
        call ar_sd_ext_rest(lrj)
      end if
      if (lin == 13) then
        call ar_td_ext_ar(25,lrj,lri,isma)
        call ar_td_ext_rest(lrj)
      end if
      if (lin == 23) then
        call ar_dv_ext_ar(25,isma,lrj,lri)   !ar_dv
      end if
    end if
    ! sd1(8-3)    ar(13)-c'(21)-
    ! sd1(8-4)    ar(23)-c'(11)-
    if (lmj /= jmr) cycle
    w0sd3 = w0_sd1(3)
    w1sd3 = w1_sd1(3)
    w0sd4 = w0_sd1(4)
    w1sd4 = w1_sd1(4)
    ni = mod(norb_dz-lri,2)
    if (ni == 0) then
      w0sd3 = -w0sd3
      w1sd3 = -w1sd3
      w0sd4 = -w0sd4
      w1sd4 = -w1sd4
    end if
    if (lmj == jmr) then
      iwdl = just(lrj,lri)
      iwdr = jud(lrj)
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd3
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd3
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      if (lin == 6) then
        call ar_sd_ext_ar(29,lri,lrj,isma)
        call ar_sd_ext_rest(lri)
      end if
      if (lin == 13) then
        call ar_td_ext_ar(29,lri,lrj,isma)
        call ar_td_ext_rest(lri)
      end if
      if (lin == 23) then
        call ar_dv_ext_ar(29,isma,lri,lrj)   !ar_dv
      end if
      iwdl = just(lri,lrj)
      iwdr = jud(lrj)
      do mpl=1,mtype
        vplp_w0(mpl) = vplpnew_w0(mpl)*w0sd4
        vplp_w1(mpl) = vplpnew_w1(mpl)*w1sd4
      end do
      do mpl=1,mhlp
        iwal = lpnew_lwei(mpl)
        iwar = lpnew_rwei(mpl)
        lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
        lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
      end do
      if (lin == 6) then
        call ar_sd_ext_ar(57,lri,lrj,isma)
        call ar_sd_ext_rest(lri)
      end if
      if (lin == 13) then
        call ar_td_ext_ar(57,lri,lrj,isma)
        call ar_td_ext_rest(lri)
      end if
      if (lin == 23) then
        call ar_dv_ext_ar(57,isma,lri,lrj)   !ar_dv
      end if
    end if
  end do
end do

return

end subroutine sdd_ar_act_c_sd_ext_sgt0

subroutine ttdd_ar_act_c_ttdd_ext_sgt1(lin)
! t1d1(15-1)  ar(13)-
! t1d1(15-1)  ar(13)-c'(11)-

use gugaci_global, only: iml, imr, ipae, ipael, jml, jmr, jpad, jpadl, jud, just, lp_lwei, lp_rwei, lpnew_lwei, lpnew_rwei, &
                         lsm_inn, mhlp, mtype, norb_dz, norb_frz, vplp_w0, vplp_w1, vplpnew_w0, vplpnew_w1, w0_t1d1, w1_t1d1
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lin
integer(kind=iwp) :: isma, iwal, iwar, iwdl, iwdr, lmi, lmj, lri, lrj, mpl
real(kind=wp) :: w0td1, w1td1
integer(kind=iwp), external :: iwalk_ad

isma = Mul(iml,imr)
do lri=norb_frz+1,norb_dz
  lmi = lsm_inn(lri)
  do lrj=norb_frz+1,lri-1
    lmj = lsm_inn(lrj)
    if ((jml /= Mul(lmi,lmj)) .or. (jmr /= lmj)) cycle
    w0td1 = w0_t1d1(1)
    w1td1 = w1_t1d1(1)
    if (mod(norb_dz-lri,2) == 1) then
      w0td1 = -w0td1
      w1td1 = -w1td1
    end if
    do mpl=1,mtype
      vplp_w0(mpl) = vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = vplpnew_w1(mpl)*w1td1
    end do
    ! t1d1(15-1)  (11)ar(13)-
    iwdl = just(lrj,lri)
    iwdr = jud(lrj)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 6) then
      call ar_sd_ext_ar(43,lri,lrj,isma)
      call ar_sd_ext_rest(lri)
    end if
    if (lin == 13) then
      call ar_td_ext_ar(43,lri,lrj,isma)
      call ar_td_ext_rest(lri)
    end if
    if (lin == 23) then
      call ar_dv_ext_ar(43,isma,lri,lrj)
    end if
  end do
  ! t1d1(15-1)  ar(13)-c'(11)-
  do lrj=lri+1,norb_dz
    lmj = lsm_inn(lrj)
    if ((jml /= Mul(lmi,lmj)) .or. (jmr /= lmj)) cycle
    w0td1 = w0_t1d1(1)
    w1td1 = w1_t1d1(1)
    if (mod(norb_dz-lri,2) == 1) then
      w0td1 = -w0td1
      w1td1 = -w1td1
    end if
    do mpl=1,mtype
      vplp_w0(mpl) = -vplpnew_w0(mpl)*w0td1
      vplp_w1(mpl) = -vplpnew_w1(mpl)*w1td1
    end do
    iwdl = just(lri,lrj)
    iwdr = jud(lrj)
    do mpl=1,mhlp
      iwal = lpnew_lwei(mpl)
      iwar = lpnew_rwei(mpl)
      lp_lwei(mpl) = iwalk_ad(jpadl,ipael,iwal,iwdl)
      lp_rwei(mpl) = iwalk_ad(jpad,ipae,iwar,iwdr)
    end do
    if (lin == 6) then
      call ar_sd_ext_ar(46,lri,lrj,isma)
      call ar_sd_ext_rest(lri)
    end if
    if (lin == 13) then
      call ar_td_ext_ar(46,lri,lrj,isma)
      call ar_td_ext_rest(lri)
    end if
    if (lin == 23) then
      call ar_dv_ext_ar(46,isma,lri,lrj)
    end if
  end do
end do

return

end subroutine ttdd_ar_act_c_ttdd_ext_sgt1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine InitB(nMult,natom,nAtQM,nGrdPt,ipCord,ipGrid,ipT,ipTT,
     &           ipTTT,ipExt,ipB,ipIsMM)
      Implicit Real*8 (A-H,O-Z)
*
*     Compute the electrostatic tensor matrix between QM atoms and
*     grid points
*     Then form the B = ExtPot[TtT^-1]Tt vector
*
#include "espf.fh"
*
      iPL = iPL_espf()
      nOrd = nMult/nAtQM
*
*     T
*
      Do iPnt = 1, nGrdPt
         iQM = 0
         Do jAt = 1, natom
            If (iWork(ipIsMM+jAt-1).eq.1) GoTo 1
            iQM = iQM + 1
            X = Work(ipGrid+(IPnt-1)*3  ) - Work(ipCord+(jAt-1)*3  )
            Y = Work(ipGrid+(IPnt-1)*3+1) - Work(ipCord+(jAt-1)*3+1)
            Z = Work(ipGrid+(IPnt-1)*3+2) - Work(ipCord+(jAt-1)*3+2)
            R = sqrt(X*X+Y*Y+Z*Z)
            iCur = ipT + (iPnt-1)*nMult+nOrd*(iQM-1)
            Work(iCur) = One / R
            If (nOrd.gt.1) Then
               R3 = R * R * R
               Work(iCur+1) = X / R3
               Work(iCur+2) = Y / R3
               Work(iCur+3) = Z / R3
            End If
1           Continue
         End Do
      End Do
      If (iQM.ne.nAtQM) Then
         Write(6,'(A,I4,A4,I4)') ' Error in espf/initb: iQM != nAtQM ',
     &                           iQM,' != ',nAtQM
         Call Abend()
      End If
*
*
*
*      Call RecPrt('T',' ',Work(ipT),nGrdPt,nMult)
*      nMax = Max(nGrdPt,nMult)
*      Call Allocate_Work(ipU,nMax*nMult)
*      Call Allocate_Work(ipW,nMult)
*      Call Allocate_Work(ipV,nMax*nMult)
*      Call Allocate_Work(ipScr,nMult)
*      Call SVD(nMax,nGrdPt,nMult,Work(ipT),Work(ipW),.True.,
*     &         Work(ipU),.True.,Work(ipV),iErr,Work(ipScr))
*      print*,'iErr=',iErr
*      Call RecPrt('U',' ',Work(ipU),nMax,nMult)
*      Call RecPrt('w',' ',Work(ipW),nMult,1)
*      Call RecPrt('V',' ',Work(ipV),nMax,nMult)
*
*      Call Free_Work(ipW)
*      Call Free_Work(ipU)
*      Call Free_Work(ipV)
*      Call Free_Work(ipScr)
*
*     TtT
*
      Do iMlt = 1, nMult
         Do jMlt = 1, nMult
            iCur = ipTT + (iMlt-1)*nMult + (jMlt-1)
            Work(iCur) = Zero
            Do kPnt = 1, nGrdPt
               Work(iCur) = Work(iCur)
     &                    + Work(ipT+(kPnt-1)*nMult+(iMlt-1))
     &                    * Work(ipT+(kPnt-1)*nMult+(jMlt-1))
            End Do
         End Do
      End Do
*
*     TtT^-1
*
      Call Allocate_Work(ipScr,nMult*nMult)
      Call minv(Work(ipTT),Work(ipScr),Ising,Det,nMult)
      Call dCopy_(nMult*nMult,Work(ipScr),1,Work(ipTT),1)
      Call Free_Work(ipScr)
*
*     [TtT^-1]Tt
*
      Do iMlt = 1, nMult
         Do jPnt = 1, nGrdPt
            iCur = ipTTT + (iMlt-1)*nGrdPt + (jPnt-1)
            Work(iCur) = Zero
            Do kMlt = 1, nMult
               Work(iCur) = Work(iCur)
     &                    + Work(ipTT+(iMlt-1)*nMult+(kMlt-1))
     &                    * Work(ipT+(jPnt-1)*nMult+(kMlt-1))
            End Do
         End Do
      End Do
      If (iPL.ge.4) Call RecPrt('(TtT)^(-1)Tt matrix in InitB',' ',
     &             Work(ipTTT),nMult,nGrdPt)
*
*     B = ExtPot[TtT^-1]Tt
*
      Do iPnt = 1, nGrdPt
         iQM = 0
         iCur = ipB + (iPnt-1)
         Work(iCur) = Zero
         Do jAt = 1, natom
            If (iWork(ipIsMM+jAt-1).eq.1) Goto 2
            iQM = iQM + 1
            Work(iCur) = Work(iCur) + Work(ipExt+(jAt-1)*10)
     &                 * Work(ipTTT+nOrd*(iQM-1)*nGrdPt+(iPnt-1))
            If (nOrd.gt.1) Then
               Work(iCur) = Work(iCur)
     &                    + Work(ipExt+(jAt-1)*10+1)
     &                    * Work(ipTTT+(nOrd*(iQM-1)+1)*nGrdPt+(iPnt-1))
     &                    + Work(ipExt+(jAt-1)*10+2)
     &                    * Work(ipTTT+(nOrd*(iQM-1)+2)*nGrdPt+(iPnt-1))
     &                    + Work(ipExt+(jAt-1)*10+3)
     &                    * Work(ipTTT+(nOrd*(iQM-1)+3)*nGrdPt+(iPnt-1))
            End If
2           Continue
         End Do
      End Do
      If (iPL.ge.4) Then
         Write(6,'(A)') ' In InitB (grid coordinates, B value)'
         Do iPnt = 1, nGrdPt
           Write(6,1234) iPnt,(Work(ipGrid+(iPnt-1)*3+J),J=0,2),
     &                        Work(ipB+iPnt-1)
1234       Format(I4,4F12.6)
         End do
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine Cho_X_RdRst(ifail)
C
C     T.B. Pedersen, july 2004.
C
C     Purpose: read decomposition info and store in common
C              block. If ifail != 0 on exit, some error occurred and,
C              most likely, some of the restart info is not
C              defined/initialized.
C
#include "implicit.fh"
#include "choorb.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Character*11 SecNam
      Parameter (SecNam = 'Cho_X_RdRst')

      Parameter (lScr = 8)
      Real*8  dScr(lScr)
      Integer jScr(lScr)

C     Set return code.
C     ----------------

      ifail = 0

C     Read molecular info.
C     --------------------

      iAdr = 0

      iOpt = 2
      nRd  = 4
      Call iDAFile(LuRst,iOpt,jScr,nRd,iAdr)
      nShell = jScr(2)
      nnShl  = jScr(3)
      If (jScr(2) .lt. 1) Then
         Write(6,'(A,A,I10)')
     &   SecNam,': #shells from restart file:',jScr(2)
         ifail = 1
         Go To 100
      End If
      nSP_UpLim = nShell*(nShell+1)/2
      If (jScr(3).lt.1 .or. jScr(3).gt.nSP_UpLim) Then
         Write(6,'(A,A,I10)')
     &   SecNam,': #shell pairs from restart file:',jScr(3)
         ifail = 1
         Go To 100
      End If
      If (jScr(1) .ne. nSym) Then
         Write(6,'(A,A,I10)')
     &   SecNam,': #irreps from restart file:',jScr(1)
         ifail = 1
         Go To 100
      Else
         iOpt = 2
         Call iDAFile(LuRst,iOpt,jScr,nSym,iAdr)
         Do iSym = 1,nSym
            If (jScr(iSym) .ne. nBas(iSym)) Then
               Write(6,'(A,A,I2,A,I10)')
     &         SecNam,': #basis functions in sym.',iSym,
     &         ' from restart file:',jScr(iSym)
               ifail = 2
               Go To 100
            End If
         End Do
      End If

C     Read decomposition configuration info.
C     --------------------------------------

      iOpt = 2
      nRd  = 2
      Call iDAFile(LuRst,iOpt,jScr,nRd,iAdr)
      If (jScr(1) .EQ. 0) Then
         XScDiag = .false.
      Else If (jScr(1) .EQ. 1) Then
         XScDiag = .true.
      Else
         WRITE(6,'(A,A,I10)')
     &   SECNAM,': integer flag for screening not recognized:',jScr(1)
         ifail = 2
         Go To 100
      End If
      If (jScr(2).gt.0 .and. jScr(2).lt.3) Then
         XCho_AdrVec = jScr(2)
      Else
         WRITE(6,'(A,A,I10)')
     &   SECNAM,': vector file address mode not recognized:',jScr(2)
         ifail = 3
         Go To 100
      End If
      If (XCho_AdrVec .ne. Cho_AdrVec) Then
         WRITE(6,'(A,A,I10)')
     &   SECNAM,': vector file address mode from restart file:',
     &   XCho_AdrVec
         WRITE(6,'(A,A,I10)')
     &   SECNAM,': vector file address mode from runfile     :',
     &   Cho_AdrVec
         ifail = 3
         Go To 100
      End If

      iOpt = 2
      nRd  = 8
      Call dDAFile(LuRst,iOpt,dScr,nRd,iAdr)
      XThrCom  = dScr(1)
      XThrDiag = dScr(2)
      XDamp(1) = dScr(3)
      XDamp(2) = dScr(4)
      XSpan    = dScr(5)
      XThrNeg  = dScr(6)
      XWarNeg  = dScr(7)
      XTooNeg  = dScr(8)
      ThrCom   = XThrCom
      ThrDiag  = XThrDiag
      Damp(1)  = XDamp(1)
      Damp(2)  = XDamp(2)
      Span     = XSpan
      ThrNeg   = XThrNeg
      WarNeg   = XWarNeg
      TooNeg   = XTooNeg

C     Allocate InfVec array.
C     ----------------------

      l_InfVec = MaxVec*InfVec_N2*nSym
      Call GetMem('InfVec','Allo','Inte',ip_InfVec,l_InfVec)

C     Allocate and initialize (read) InfRed array.
C     --------------------------------------------

      iOpt = 2
      nRd  = 1
      Call iDAFile(LuRst,iOpt,jScr,nRd,iAdr)
      MaxRed = jScr(1)
      XnPass = MaxRed
      IF (MaxRed .lt. 1) Then
         Write(6,'(A,A,I10)')
     &   SecNam,': #reduced sets from restart file:',MaxRed
         ifail = 4
         Go To 100
      Else
         l_InfRed = MaxRed
         Call GetMem('InfRed','Allo','Inte',ip_InfRed,l_InfRed)
         iOpt = 2
         Call iDAFile(LuRst,iOpt,iWork(ip_InfRed),l_InfRed,iAdr)
         If (iWork(ip_InfRed) .ne. 0) Then
            Write(6,'(A,A,I10)')
     &      SecNam,': disk address of 1st reduced set:',iWork(ip_InfRed)
            ifail = 5
            Go To 100
         End If
      End If

C     Read InfVec array.
C     ------------------

      Do iSym = 1,nSym
         iOpt = 2
         nRd  = 1
         Call iDAFile(LuRst,iOpt,jScr,nRd,iAdr)
         If (jScr(1) .ne. NumCho(iSym)) Then
            Write(6,'(A,A,I2,A,I10)')
     &      SecNam,': #Cholesky vectors (sym.',iSym,'): ',NumCho(iSym)
            Write(6,'(A,A,I10)')
     &      SecNam,': ....and from restart file: ',jScr(iSym)
            ifail = 6
            Go To 100
         Else
            If (NumCho(iSym) .lt. 1) Then
               kOff = ip_InfVec + MaxVec*InfVec_N2*(iSym-1)
               Call Cho_iZero(iWork(kOff),MaxVec*InfVec_N2)
            Else
               Do j = 1,InfVec_N2
                  iOpt = 2
                  kOff = ip_InfVec + MaxVec*InfVec_N2*(iSym-1)
     &                 + MaxVec*(j-1)
                  Call iDAFile(LuRst,iOpt,iWork(kOff),NumCho(iSym),iAdr)
                  nRest = MaxVec - NumCho(iSym)
                  If (nRest .gt. 0) Then
                     kOff = ip_InfVec + MaxVec*InfVec_N2*(iSym-1)
     &                    + MaxVec*(j-1) + NumCho(iSym)
                     Call Cho_iZero(iWork(kOff),nRest)
                  End If
               End Do
            End If
         End If
      End Do

C     Return.
C     -------

  100 If (ifail .ne. 0) Then  ! failures jump to this point
         Write(6,'(A,A)')
     &   SecNam,': refusing to read more restart info!'
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_ChkDia_A4(Diag,Dmax,iSym,nNeg,nNegT,nConv,xM,yM,zM)
!
! Purpose: check for negative diagonals.
!          Dmax is the max. diagonal (global), used for screening.
!          On exit,
!          nNeg = #negative zeroed diagonals.
!          nNegT = #negative diagonals
!          nConv = #diagonal elements < ThrCom
!          xM = max. element in Diag
!          yM = min. element in Diag
!          zM = max. abs. element in Diag

use Cholesky, only: Damp, iiBstR, IndRed, LuPri, nnBstR, SCDIAG, ThrCom, ThrNeg, TOONEG, WARNEG
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Diag(*)
real(kind=wp), intent(in) :: Dmax
integer(kind=iwp), intent(in) :: iSym
integer(kind=iwp), intent(out) :: nNeg, nNegT, nConv
real(kind=wp), intent(out) :: xM, yM, zM
integer(kind=iwp) :: i, j, j1, j2
real(kind=wp) :: Tst
character(len=*), parameter :: SecNam = 'Cho_ChkDia_A4'

nNeg = 0
nNegT = 0
nConv = 0
if (nnBstR(iSym,2) > 0) then
  xM = -9.9e9_wp
  yM = 9.9e9_wp
else
  xM = Zero
  yM = Zero
end if

j1 = iiBstR(iSym,2)+1
j2 = j1+nnBstR(iSym,2)-1
do j=j1,j2
  i = IndRed(j,2) ! addr in 1st reduced set
  xM = max(xM,Diag(i))
  yM = min(yM,Diag(i))
  if (Diag(i) < Zero) then
    nNegT = nNegT+1
    if (Diag(i) < ThrNeg) then
      nNeg = nNeg+1
      if (Diag(i) < TooNeg) then
        write(Lupri,'(A,A,I12,1X,ES16.8)') SecNam,': diagonal too negative: ',i,Diag(i)
        write(Lupri,'(A,A)') SecNam,': shutting down Cholesky decomposition!'
        call Cho_Quit('Diagonal too negative in '//SecNam,104)
      end if
      if (Diag(i) < WarNeg) write(Lupri,'(A,A,I12,1X,ES16.8,A)') SecNam,': Negative diagonal: ',i,Diag(i),' (zeroed)'
      Diag(i) = Zero
    end if
  end if
end do

zM = max(abs(xM),abs(yM))

do j=j1,j2
  i = IndRed(j,2)
  Tst = sqrt(abs(Diag(i))*Dmax)*Damp(2)
  if (Tst <= ThrCom) then
    nConv = nConv+1
    if (ScDiag) Diag(i) = Zero
  end if
end do

end subroutine Cho_ChkDia_A4

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_DEcorr(nh1,Grad,nGrad,DFTFOCK)

use Index_Functions, only: iTri, nTri_Elem
use SpinAV, only: Do_SpinAV, DSC
use InfSCF, only: addc_KSDFT, CMO, DE_KSDFT_c, nBas, nBT, nConstr, nOcc, nOrb, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nh1, nGrad
real(kind=wp), intent(inout) :: Grad(nGrad)
character(len=4), intent(in) :: DFTFOCK
integer(kind=iwp) :: i, iAB, iDij, iDSC, iOff, iSym, iXoX, j, ji, jOff, lOff, mAdCMOO, nXoX
real(kind=wp) :: Ec_AB(2)
real(kind=wp), allocatable :: D_DS(:,:), F_DFT(:,:)
integer(kind=iwp), parameter :: nD = 2

call mma_allocate(F_DFT,nBT,nD,Label='F_DFT')
call mma_allocate(D_DS,nBT,nD,Label='D_DS')

do iAB=1,2
  iOff = 1
  jOff = 1
  lOff = 0
  do iSym=1,nSym
    if (iAB == 1) then
      nXoX = nOcc(iSym,1)
      iXoX = 0
    else
      nXoX = nConstr(iSym)
      iXoX = nOcc(iSym,1)-nConstr(iSym)
    end if
    mAdCMOO = iOff+nBas(iSym)*iXoX
    call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nXoX, &
                   One,CMO(mAdCMOO,1),nBas(iSym), &
                   CMO(mAdCMOO,1),nBas(iSym), &
                   Zero,D_DS(jOff,1),nBas(iSym))
    if (iAB == 1) then
      nXoX = nOcc(iSym,2)
      iXoX = 0
    else
      nXoX = nConstr(iSym)
      iXoX = nOcc(iSym,2)-nConstr(iSym)
    end if
    mAdCMOO = iOff+nBas(iSym)*iXoX
    call DGEMM_tri('N','T',nBas(iSym),nBas(iSym),nXoX, &
                   One,CMO(mAdCMOO,2),nBas(iSym), &
                   CMO(mAdCMOO,2),nBas(iSym), &
                   Zero,D_DS(jOff,2),nBas(iSym))

    if (Do_SpinAV) then
      do j=1,nBas(iSym)
        do i=1,j
          iDSc = nBas(iSym)*(j-1)+i
          ji = iTri(j,i)
          iDij = jOff-1+ji
          D_DS(iDij,1) = D_DS(iDij,1)-DSc(iDSc)
          D_DS(iDij,2) = D_DS(iDij,2)+DSc(iDSc)
        end do
      end do
      lOff = lOff+nBas(iSym)**2
    end if

    do j=1,nBas(iSym)
      do i=1,j-1
        ji = iTri(j,i)
        iDij = jOff-1+ji
        D_DS(iDij,1) = Two*D_DS(iDij,1)
        D_DS(iDij,2) = Two*D_DS(iDij,2)
      end do
    end do
    iOff = iOff+nBas(iSym)*nOrb(iSym)
    jOff = jOff+nTri_Elem(nBas(iSym))
  end do

  call Get_Ecorr_dft(nh1,Grad,nGrad,DFTFOCK,F_DFT,D_DS,nBT,nD,ADDC_KSDFT,Ec_AB(iAB))
end do
!----------------------------------------------------------------------*
DE_KSDFT_c = Ec_AB(1)-Ec_AB(2)
!----------------------------------------------------------------------*

call mma_deallocate(D_DS)
call mma_deallocate(F_DFT)

return

end subroutine Get_DEcorr

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Jonas Bostrom                                          *
!***********************************************************************

subroutine Mult_RijK_QKL(iSO,nBas_aux,nIrrep)
!*************************************************************************
!     Author: Jonas Bostrom
!
!     Purpose: Computation of the DF coefficient vectors in MO-basis.
!
!     Equation:   C(il,K)  =  sum_J  R(il,J) * Q(K,J)
!
!     Input:
!            iSO : alpha (iSO=1) or beta (iSO=2) orbitals
!            nBas_aux : number of aux bsfs in each irrep.
!            nIrrep : number of irreps.
!*************************************************************************

use RI_glob, only: iAdrCVec, nChOrb, nIJ1, nIJR, NumAuxVec
use Symmetry_Info, only: Mul
use pso_stuff, only: lSA
use Para_Info, only: Is_Real_Par
use ChoSwp, only: InfVec
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iSO, nIrrep, nBas_Aux(1:nIrrep)
#include "cholesky.fh"
!#define _CD_TIMING_
#ifdef _CD_TIMING_
#include "temptime.fh"
#endif
#include "chotime.fh"
integer(kind=iwp) :: i, iAdrC, iAdrQ, iAdrR, iAux, iFirstCho, iJBat, indx, indx2, iRest, iSeed, iSeed2, iSym, jSym, kSym, &
                     l_CVector, l_Q, l_QVector, l_RVec, l_RVector, lSym, Lu_Q, LuCVec, LuRVec, MaxCho, MaxLocCho, MaxMOprod, &
                     MaxMOProdR, MemMax, nJbat, njVec, nJvec1, nJvecLast, nTotCho, nTotFIorb, NumAux, NumCV, nVec(1:nIrrep)
real(kind=wp) :: TotCPU, TotCPU1, TotCPU2, TotWall, TotWall1, TotWall2
character(len=50) :: CFmt
character(len=6) :: Fname, Fname2, Name_Q
real(kind=wp), allocatable :: CVector(:), QVector(:), RVector(:)
character(len=*), parameter :: SECNAM = 'MULT_RIJK_QKL'
integer(kind=iwp), external :: IsFreeUnit

call CWTime(TotCPU1,TotWall1)

nVec(1:nIrrep) = NumCho(1:nIrrep)
call GAIGOP(nVec,nIrrep,'+')

nTotCho = 0
MaxCho = 0
MaxLocCho = 0
do jSym=1,nIrrep
  nTotCho = nTotCho+nVec(jSym)
  MaxCho = max(MaxCho,nVec(jSym))
  MaxLocCho = max(MaxLocCho,NumCho(jSym))
end do
iAdrCVec(1:nIrrep,1:nIrrep,iSO) = 0

! Loop over the first cholesky symmetry

do jSym=1,nIrrep

  ! Check so the symmetry contains vectors
  !---------------------------------------
  NumCV = NumCho(jSym)
  NumAux = nBas_Aux(jSym)
  if (jSym == 1) NumAux = NumAux-1
  ! Save the number of auxiliary basis functions to be accessed later
  NumAuxVec(jSym) = NumAux

  call GAIGOP_SCAL(NumCV,'max')
  if (NumCV < 1) cycle

  nTotFIorb = 0
  MaxMOprod = 0
  MaxMOprodR = 0
  do iSym=1,nIrrep
    kSym = Mul(JSym,iSym)

    nTotFIorb = nTotFIorb+nIJ1(iSym,kSym,iSO)
    MaxMOprod = max(MaxMOprod,nIJ1(iSym,kSym,iSO))
    MaxMOProdR = max(MaxMOprodR,nIJR(iSym,kSym,iSO))
  end do

  call mma_maxDBLE(MemMax)
  nJvec1 = (MemMax-NumAux*MaxMOprod)/(MaxMOprod+NumAux)
  if (nJvec1 < 1) then
    write(u6,*) 'Too little memory in:',SECNAM
    call Abend()
  end if
  nJvec1 = min(nJvec1,NumCho(jSym))
  nJbat = NumCho(jSym)/nJvec1
  iRest = mod(NumCho(jSym),nJvec1)
  if (iRest /= 0) then
    nJbat = nJbat+1
    nJvecLast = iRest
  else
    nJvecLast = nJvec1
  end if

  if (Is_Real_Par()) then
    iFirstCho = InfVec(1,5,jSym)
  else
    iFirstCho = 1
  end if

  l_QVector = nJVec1*NumAux
  l_RVector = MaxMOprod*nJVec1
  l_CVector = MaxMOprodR*NumAux

  call mma_allocate(QVector,l_QVector,Label='QVector')
  call mma_allocate(RVector,l_RVector,Label='RVector')
  call mma_allocate(CVector,l_CVector,Label='CVector')

  iSeed2 = 8
  LuCVec = IsFreeUnit(iSeed2)
  if (iSO == 1) then
    write(Fname2,'(A4,I1,I1)') 'CVEA',jSym
  else if (iSO == 2) then
    write(Fname2,'(A4,I1,I1)') 'CVEB',jSym
  end if
  call DANAME_MF_WA(LuCVec,Fname2)
  iAdrC = 0

  ! Get Q Vectors from Disk
  !------------------------
  do iSym=1,nIrrep
    lSym = Mul(iSym,jSym)

    if (nIJ1(iSym,lSym,iSO) >= 1) then
      CVector(:) = Zero

      do iJBat=1,nJBat
        if (iJBat == nJBat) then
          njVec = nJVecLast
        else
          nJvec = nJvec1
        end if

        iSeed = 55+jSym-1
        Lu_Q = IsFreeUnit(iSeed)
        write(Name_Q,'(A4,I2.2)') 'QVEC',jSym-1
        call DaName_MF_WA(Lu_Q,Name_Q)
        l_Q = nJvec*NumAux
        iAdrQ = (iFirstCho-1)*NumAux+(iJBat-1)*nJVec*NumAux
        call dDaFile(Lu_Q,2,Qvector,l_Q,iAdrQ)

#       ifdef _DEBUGPRINT_
        call RecPrt('Q-vectors',' ',QVector,nJVec,NumAux)
#       endif

        iSeed = 7
        LuRVec = IsFreeUnit(iSeed)
        if (iSO == 1) then
          write(Fname,'(A4,I1,I1)') 'CHTA',iSym,lSym
        else if (iSO == 2) then
          write(Fname,'(A4,I1,I1)') 'CHTB',iSym,lSym
        end if
        call DANAME_MF_WA(LuRVec,Fname)

        ! Loop over all cholesky vectors on all nodes
        !--------------------------------------------

        ! Get R-Vectors from disk
        !------------------------

        iAdrR = nIJ1(iSym,lSym,iSO)*nJVec1*(iJBat-1)
        l_RVec = nJvec*nIJ1(iSym,lSym,iSO)
        call dDaFile(LuRVec,2,RVector,l_RVec,iAdrR)

        call dGemm_('N','T',nIJ1(iSym,lSym,iSO),NumAux,nJVec,One,RVector,nIJ1(iSym,lSym,iSO),QVector,NumAux,Zero,CVector, &
                    nIJ1(iSym,lSym,iSO))
      end do

#     ifdef _DEBUGPRINT_
      write(u6,*) 'jSym=',jSym
      call RecPrt('R-Vectors',' ',RVector,nIJ1(iSym,lSym,iSO),NumAux)
      call RecPrt('C-Vectors',' ',CVector,nIJ1(iSym,lSym,iSO),NumAux)
#     endif
      if ((.not. lSA) .and. (iSym == lSym)) then
        do iAux=1,NumAux
          indx = -1
          do i=1,nChOrb(iSym-1,iSO)
            indx = indx+i
            indx2 = indx+(iAux-1)*nIJ1(iSym,lSym,iSO)
            CVector(1+indx2) = CVector(1+indx2)/sqrt(Two)
          end do
        end do
      end if

      call DaClos(Lu_Q)
      call DACLOS(LuRVec)

    end if

    call GADGOP(CVector,l_CVector,'+')
    iAdrCVec(jSym,iSym,iSO) = iAdrC
    call dDaFile(LuCVec,1,CVector,nIJ1(iSym,lSym,iSO)*NumAux,iAdrC)
    if (nIJ1(iSym,lSym,iSO) < nIJR(iSym,lSym,iSO)) then
      iAdrC = iAdrC+(nIJR(iSym,lSym,iSO)-nIJ1(iSym,lSym,iSO))*NumAux
    end if

  end do !iSym

  call mma_deallocate(CVector)
  call mma_deallocate(RVector)
  call mma_deallocate(QVector)

  call DACLOS(LuCVec)

end do  ! jSym

call CWTime(TotCPU2,TotWall2)
TotCPU = TotCPU2-TotCPU1
TotWall = TotWall2-TotWall1
#ifdef _CD_TIMING_
rMult_CPU = TOTCPU
rMult_Wall = TOTWALL
#endif

if (timings) then

  CFmt = '(2x,A)'
  write(u6,*)
  write(u6,CFmt) 'Cholesky Gradients timing from '//SECNAM
  write(u6,CFmt) '----------------------------------------'
  write(u6,*)
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,CFmt) '                                CPU       WALL   '
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
  write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
  write(u6,*)

end if

return

end subroutine Mult_RijK_QKL

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!ifdef _DEBUPRINT_
subroutine frenkelexc(Frenkeltri,ndim,nst1,nst2)

use Index_Functions, only: nTri_Elem
use frenkel_global_vars, only: excl, iTyp, jTyp, nestla, nestlb, valst
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Three, auToEV
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndim, nst1, nst2
real(kind=wp), intent(inout) :: Frenkeltri(nTri_Elem(ndim))
integer(kind=iwp) :: a, b, d1lines, d2lines, I, IO, iPL, J, K, L, LUT1, ntrans, run, tri
real(kind=wp) :: DIPNORM, GS
character(len=13) :: filnam, filnam1, filnam2, filnam3
integer(kind=iwp), allocatable :: I1(:), I2(:), F1(:), F2(:)
real(kind=wp), allocatable :: D1X(:), D1Y(:), D1Z(:), D2X(:), D2Y(:), D2Z(:), Dip1(:,:,:), Dip2(:,:,:), DipFrintermx(:,:), &
                              DipFrintermx2(:,:), DipFrintermy(:,:), DipFrintermy2(:,:), DipFrintermz(:,:), DipFrintermz2(:,:), &
                              DipFrx(:,:), DipFry(:,:), DipFrz(:,:), E_FRENKEL(:), EDIFF(:), EigEn(:), EigEnHa(:), &
                              Freninterm(:,:), Freninterm2(:,:), Frenkeldia(:,:), Frenkelquad(:,:), OSCSTR(:), Rassi1(:), Rassi2(:)
character(len=8), allocatable :: Hamelembra(:), Hamelemket(:)
integer(kind=iwp), external :: iPrintLevel, isFreeUnit

call GETPRINTLEVEL()
iPL = iPrintLevel(-1)

call mma_allocate(Frenkeldia,ndim,ndim)
call mma_allocate(Freninterm,ndim,ndim)
call mma_allocate(Freninterm2,ndim,ndim)
call mma_allocate(Frenkelquad,ndim,ndim)
call mma_allocate(Rassi1,nst1)
call mma_allocate(Rassi2,nst2)
call mma_allocate(E_FRENKEL,ndim)

! read in rassi energies of both monomers to add them
! to the diagonal elements
#ifdef _DEBUGPRINT_
write(u6,*) 'iTyp=',iTyp,'jTyp=',jTyp
#endif

if (iTyp < jTyp) then
  write(u6,*) 'Monomer B was calculated first.'
  write(u6,*) 'Index 1 refers to A.'
else
  write(u6,*) 'Monomer A was calculated first.'
  write(u6,*) 'Index 1 refers to B.'
  iTyp = 2
  jTyp = 1
end if

write(filnam2,'(A,I1)') 'stE',iTyp
LuT1 = isFreeUnit(11)

call molcas_open(LuT1,filnam2)
write(u6,'(A,1X,I1,A,I3.3)') 'Number of states of system',iTyp,'=',nst1
write(u6,'(A,1X,I1,A,I3.3)') 'Number of states of system',jTyp,'=',nst2
do i=1,nst1
  read(LuT1,*) Rassi1(i)
end do
close(LuT1)

write(filnam3,'(A,I1)') 'stE',jTyp
LuT1 = isFreeUnit(11)

call molcas_open(LuT1,filnam3)
do i=1,nst2
  read(LuT1,*) Rassi2(i)
end do
close(LuT1)

! add rassi energies to diag of exciton coupl matrix
do i=1,nst1
  write(u6,*) 'State energy of system 1',Rassi1(i)
end do
do i=1,nst2
  write(u6,*) 'State energy of system 2',Rassi2(i)
end do

tri = 0
do a=1,nst1
  do b=1,nst2
    if ((a /= 1) .or. (b /= 1)) then
      if (EXCL) then
        if ((all(nestla /= a)) .or. (all(nestlb /= b))) cycle
      else
        if ((a <= valst) .and. (b <= valst)) cycle
        if ((a > valst) .and. (b > valst)) cycle
      end if
    end if
    tri = tri+1
    Frenkeltri(nTri_Elem(tri)) = Frenkeltri(nTri_Elem(tri))+Rassi1(a)+Rassi2(b)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'tri counter',tri
    write(u6,*) 'add energies 1 and 2',Rassi1(a),Rassi2(b)
#   endif
  end do
end do

! subtract gs energy
gs = Frenkeltri(1)
do i=1,ndim
  Frenkeltri(nTri_Elem(i)) = Frenkeltri(nTri_Elem(i))-gs
end do
! convert to eV
Frenkeltri(:) = Frenkeltri(:)*auToEV

! make a full Hamilton matrix from the lower triangular
call square(Frenkeltri,Frenkelquad,1,ndim,ndim)
#ifdef _DEBUGPRINT_
write(u6,*) 'Frenkelquad:'
do i=1,ndim
  write(u6,'(1000ES18.8)') (Frenkelquad(j,i),j=1,ndim)
end do
#endif

call mma_allocate(Hamelembra,ndim)
call mma_allocate(Hamelemket,ndim)
tri = 0
do a=1,nst1
  do b=1,nst2
    if ((a /= 1) .or. (b /= 1)) then
      if (EXCL) then
        if ((all(nestla /= a)) .or. (all(nestlb /= b))) cycle
      else
        if ((a <= valst) .and. (b <= valst)) cycle
        if ((a > valst) .and. (b > valst)) cycle
      end if
    end if
    tri = tri+1
    write(Hamelemket(tri),'(A,I3.3,I3.3,A)') '|',a,b,'>'
    write(Hamelembra(tri),'(A,I3.3,I3.3,A)') '<',a,b,'|'
  end do
end do

write(u6,*) 'Frenkel Hamiltonian [eV]:'
write(u6,'(11X)',advance='NO')
write(u6,'(100(A,8X))',advance='YES') (Hamelemket(i),i=1,ndim)

do i=1,ndim
  write(u6,'(A,1X,100(ES16.8))') Hamelembra(i),(Frenkelquad(i,j),j=1,ndim)
end do

write(u6,*) 'Frenkel eigenvectors (column wise):'
write(u6,'(11X)',advance='NO')
write(u6,'(100(I3.3,13X))',advance='YES') (i,i=1,ndim)

call NIdiag_New(Frenkeltri,Frenkeldia,ndim,ndim)

do i=1,ndim
  write(u6,'(A,1X,100(ES16.8))') Hamelembra(i),(Frenkeldia(i,j),j=1,ndim)
end do

write(u6,*) 'Hamiltonian eigenvalues [eV]:'
do i=1,ndim
  E_FRENKEL(i) = Frenkeltri(nTri_Elem(i))
  write(u6,*) Frenkeltri(nTri_ELem(i))
end do

call Add_Info('E_FRENKEL',E_FRENKEL,ndim,6)

call mma_deallocate(E_FRENKEL)
call mma_deallocate(Hamelembra)
call mma_deallocate(Hamelemket)

#ifdef _DEBUGPRINT_
call dgemm_('N','N',ndim,ndim,ndim,One,Frenkelquad,ndim,Frenkeldia,ndim,Zero,Freninterm,ndim)

write(u6,*) 'first trafo H*U'
do i=1,ndim
  write(u6,'(1000ES18.8)') (Freninterm(i,j),j=1,ndim)
end do
call dgemm_('T','N',ndim,ndim,ndim,One,Frenkeldia,ndim,Freninterm,ndim,Zero,Freninterm2,ndim)
write(u6,*) 'second trafo U^(t)HU (should be diagonal)'
do i=1,ndim
  write(u6,'(1000ES18.8)') (Freninterm2(i,j),j=1,ndim)
end do
#endif

ntrans = nTri_Elem(ndim-1)

d1lines = 0
d2lines = 0
! search for number of lines in the dipvec files
write(filnam,'(A,I1)') 'dip_vec',iTyp
LuT1 = isFreeUnit(11)
call molcas_open(LuT1,filnam)
do
  read(LuT1,*,iostat=io)
  if (io /= 0) exit
  d1lines = d1lines+1
end do
close(LuT1)

write(filnam1,'(A,I1)') 'dip_vec',jTyp
LuT1 = isFreeUnit(11)
call molcas_open(LuT1,filnam1)
do
  read(LuT1,*,iostat=io)
  if (io /= 0) exit
  d2lines = d2lines+1
end do
close(LuT1)

#ifdef _DEBUGPRINT_
write(u6,*) 'd1lines ',d1lines
write(u6,*) 'd2lines ',d2lines
write(u6,*) 'ntrans',ntrans
#endif

call mma_allocate(I1,d1lines)
call mma_allocate(F1,d1lines)
call mma_allocate(D1X,d1lines)
call mma_allocate(D1Y,d1lines)
call mma_allocate(D1Z,d1lines)
call mma_allocate(I2,d2lines)
call mma_allocate(F2,d2lines)
call mma_allocate(D2X,d2lines)
call mma_allocate(D2Y,d2lines)
call mma_allocate(D2Z,d2lines)
call mma_allocate(Dip1,nst1,nst1,3)
call mma_allocate(Dip2,nst2,nst2,3)
call mma_allocate(EigEn,ndim)
call mma_allocate(EigEnHa,ndim)
call mma_allocate(EDIFF,ntrans)
call mma_allocate(OSCSTR,ntrans)
call mma_allocate(DipFrx,ndim,ndim)
call mma_allocate(DipFry,ndim,ndim)
call mma_allocate(DipFrz,ndim,ndim)
call mma_allocate(DipFrintermx,ndim,ndim)
call mma_allocate(DipFrintermx2,ndim,ndim)
call mma_allocate(DipFrintermy,ndim,ndim)
call mma_allocate(DipFrintermy2,ndim,ndim)
call mma_allocate(DipFrintermz,ndim,ndim)
call mma_allocate(DipFrintermz2,ndim,ndim)

write(filnam,'(A,I1)') 'dip_vec',iTyp
LuT1 = isFreeUnit(11)
call molcas_open(LuT1,filnam)
do i=1,d1lines
  read(LuT1,222) I1(i),F1(i),D1X(i),D1Y(i),D1Z(i)
end do
close(LuT1)

write(filnam1,'(A,I1)') 'dip_vec',jTyp
LuT1 = isFreeUnit(11)
call molcas_open(LuT1,filnam1)
do i=1,d2lines
  read(LuT1,222) I2(i),F2(i),D2X(i),D2Y(i),D2Z(i)
end do
close(LuT1)

! fill dipole matrices and use symmetry
Dip1(:,:,:) = Zero
do i=1,d1lines
  Dip1(I1(i),F1(i),1) = D1X(i)
  Dip1(I1(i),F1(i),2) = D1Y(i)
  Dip1(I1(i),F1(i),3) = D1Z(i)
  Dip1(F1(i),I1(i),1) = D1X(i)
  Dip1(F1(i),I1(i),2) = D1Y(i)
  Dip1(F1(i),I1(i),3) = D1Z(i)
end do

write(u6,*) 'Transition dipole vectors of system 1:'
write(u6,551) 'from','to','x','y','z'
do i=1,d1lines
  write(u6,443) I1(i),F1(i),(Dip1(I1(i),F1(i),j),j=1,3)
end do

Dip2(:,:,:) = Zero
do i=1,d2lines
  Dip2(I2(i),F2(i),1) = D2X(i)
  Dip2(I2(i),F2(i),2) = D2Y(i)
  Dip2(I2(i),F2(i),3) = D2Z(i)
  Dip2(F2(i),I2(i),1) = D2X(i)
  Dip2(F2(i),I2(i),2) = D2Y(i)
  Dip2(F2(i),I2(i),3) = D2Z(i)
end do

write(u6,*) 'Transition dipole vectors of system 2:'
write(u6,551) 'from','to','x','y','z'
do i=1,d2lines
  write(u6,443) I2(i),F2(i),(Dip2(I2(i),F2(i),j),j=1,3)
end do

write(u6,*) 'relative excitonic state eigenenergies [eV]:'
do i=1,ndim
  EigEn(i) = Frenkeltri(nTri_Elem(i))-Frenkeltri(1)
  write(u6,*) 'EigEn:',i,EigEn(i)
end do

if (iPL >= 3) then
  write(u6,*) 'relative excitonic state eigenenergies in hartree:'
  do i=1,ndim
    EigEnHa(i) = (Frenkeltri(nTri_Elem(i))-Frenkeltri(1))/auToEV
    write(u6,*) 'EigEn:',i,EigEnHa(i)
  end do
end if

! create x
a = 0
b = 0
DipFrx(:,:) = Zero
do i=1,nst1
  do k=1,nst2
    if ((i /= 1) .or. (k /= 1)) then
      if (excl) then
        if ((all(nestla /= i)) .or. (all(nestlb /= k))) cycle
      else
        if ((i <= valst) .and. (k <= valst)) cycle
        if ((i > valst) .and. (k > valst)) cycle
      end if
    end if
    a = a+1
    b = 0
    do j=1,nst1
      do l=1,nst2
        if ((j /= 1) .or. (l /= 1)) then
          if (EXCL) then
            if ((all(nestla /= j)) .or. (all(nestlb /= l))) cycle
          else
            if ((j <= valst) .and. (l <= valst)) cycle
            if ((j > valst) .and. (l > valst)) cycle
          end if
        end if
        b = b+1
        if (k == l) DipFrx(a,b) = Dip1(i,j,1)
        if (i == j) DipFrx(a,b) = Dip2(k,l,1)
      end do
    end do
  end do
end do

if (iPL >= 3) then
  write(u6,*) 'DipFrx:'
  do i=1,ndim
    write(u6,'(100ES18.8)') (DipFrx(i,j),j=1,ndim)
  end do
end if
! transform dipole matrix in dipole basis
call dgemm_('N','N',ndim,ndim,ndim,One,DipFrx,ndim,Frenkeldia,ndim,Zero,DipFrintermx,ndim)

call dgemm_('T','N',ndim,ndim,ndim,One,Frenkeldia,ndim,DipFrintermx,ndim,Zero,DipFrintermx2,ndim)

if (iPL >= 3) then
  write(u6,*) 'trafo U^(t)DU, dipole mtx in exc. basis, X'
  do i=1,ndim
    write(u6,'(100ES18.8)') (DipFrintermx2(i,j),j=1,ndim)
  end do
end if
! create y
a = 0
b = 0
DipFry(:,:) = Zero
do i=1,nst1
  do k=1,nst2
    if ((i /= 1) .or. (k /= 1)) then
      if (EXCL) then
        if ((all(nestla /= i)) .or. (all(nestlb /= k))) cycle
      else
        if ((i <= valst) .and. (k <= valst)) cycle
        if ((i > valst) .and. (k > valst)) cycle
      end if
    end if
    a = a+1
    b = 0
    do j=1,nst1
      do l=1,nst2
        if ((j /= 1) .or. (l /= 1)) then
          if (EXCL) then
            if ((all(nestla /= j)) .or. (all(nestlb /= l))) cycle
          else
            if ((j <= valst) .and. (l <= valst)) cycle
            if ((j > valst) .and. (l > valst)) cycle
          end if
        end if
        b = b+1
        if (k == l) DipFry(a,b) = Dip1(I,J,2)
        if (i == j) DipFry(a,b) = Dip2(K,L,2)
      end do
    end do
  end do
end do

if (iPL >= 3) then
  write(u6,*) 'DipFry:'
  do i=1,ndim
    write(u6,'(100ES18.8)') (DipFry(i,j),j=1,ndim)
  end do
end if

! transform dipole matrix in dipole basis
call dgemm_('N','N',ndim,ndim,ndim,One,DipFry,ndim,Frenkeldia,ndim,Zero,DipFrintermy,ndim)

call dgemm_('T','N',ndim,ndim,ndim,One,Frenkeldia,ndim,DipFrintermy,ndim,Zero,DipFrintermy2,ndim)
if (iPL >= 3) then
  write(u6,*) 'trafo U^(t)DU, dipole mtx in exc. basis, Y'
  do i=1,ndim
    write(u6,'(100ES18.8)') (DipFrintermy2(i,j),j=1,ndim)
  end do
end if

! create z
a = 0
b = 0
DipFrz(:,:) = Zero
do i=1,nst1
  do k=1,nst2
    if ((i /= 1) .or. (k /= 1)) then
      if (excl) then
        if ((all(nestla /= i)) .or. (all(nestlb /= k))) cycle
      else
        if ((i <= valst) .and. (k <= valst)) cycle
        if ((i > valst) .and. (k > valst)) cycle
      end if
    end if
    a = a+1
    b = 0
    do j=1,nst1
      do l=1,nst2
        if ((j /= 1) .or. (l /= 1)) then
          if (excl) then
            if ((all(nestla /= j)) .or. (all(nestlb /= l))) cycle
          else
            if ((j <= valst) .and. (l <= valst)) cycle
            if ((j > valst) .and. (l > valst)) cycle
          end if
        end if
        b = b+1
        if (k == l) then
          if (k > 1) cycle
          DipFrz(a,b) = Dip1(I,J,3)
        end if
        if (i == j) DipFrz(a,b) = Dip2(K,L,3)
      end do
    end do
  end do
end do
if (iPL >= 3) then
  write(u6,*) 'DipFrz:'
  do i=1,ndim
    write(u6,'(100ES18.8)') (DipFrz(i,j),j=1,ndim)
  end do
end if

! transform dipole matrix in dipole basis
call dgemm_('N','N',ndim,ndim,ndim,One,DipFrz,ndim,Frenkeldia,ndim,Zero,DipFrintermz,ndim)

call dgemm_('T','N',ndim,ndim,ndim,One,Frenkeldia,ndim,DipFrintermz,ndim,Zero,DipFrintermz2,ndim)
if (iPL >= 3) then
  write(u6,*) 'trafo U^(t)DU, dipole mtx in exc. basis, Z'
  do i=1,ndim
    write(u6,'(100ES18.8)') (DipFrintermz2(i,j),j=1,ndim)
  end do
end if

! calc and print spectrum
run = 0
write(u6,*) 'Excitonic absorption spectrum'
write(u6,3) 'from','to','excitation energy [eV]','Dx','Dy','Dz','osc.str.'
do i=1,ndim
  do j=i+1,ndim
    run = run+1
    EDIFF(run) = EigEn(j)-EigEn(i)
    dipnorm = DipFrintermx2(i,j)*DipFrintermx2(i,j)+DipFrintermy2(i,j)*DipFrintermy2(i,j)+DipFrintermz2(i,j)*DipFrintermz2(i,j)
    OSCSTR(run) = (Two/Three)*EDIFF(run)*dipnorm
    OSCSTR(run) = OSCSTR(run)/auToEV
    write(u6,2) i,j,EDIFF(run),DipFrintermx2(i,j),DipFrintermy2(i,j),DipFrintermz2(i,j),OSCSTR(run)
  end do
end do

call Add_Info('FRENKEL_OSCSTR',OSCSTR,nTri_Elem(ndim-1),6)

if (iPL >= 3) then
  run = 0
  write(u6,*) 'Excitonic absorption spectrum'
  write(u6,3) 'from','to','excitation energy [Ha]','Dx','Dy','Dz','osc.str.'
  do i=1,ndim
    do j=i+1,ndim
      run = run+1
      EDIFF(run) = (EigEn(j)-EigEn(i))/auToEV
      dipnorm = DipFrintermx2(i,j)*DipFrintermx2(i,j)+DipFrintermy2(i,j)*DipFrintermy2(i,j)+DipFrintermz2(i,j)*DipFrintermz2(i,j)
      OSCSTR(run) = (Two/Three)*EDIFF(run)*dipnorm
      write(u6,2) i,j,EDIFF(run),DipFrintermx2(i,j),DipFrintermy2(i,j),DipFrintermz2(i,j),OSCSTR(run)
    end do
  end do
end if

call mma_deallocate(I1)
call mma_deallocate(F1)
call mma_deallocate(D1X)
call mma_deallocate(D1Y)
call mma_deallocate(D1Z)
call mma_deallocate(I2)
call mma_deallocate(F2)
call mma_deallocate(D2X)
call mma_deallocate(D2Y)
call mma_deallocate(D2Z)
call mma_deallocate(Dip1)
call mma_deallocate(Dip2)
call mma_deallocate(EigEn)
call mma_deallocate(EigEnHa)
call mma_deallocate(EDIFF)
call mma_deallocate(OSCSTR)
call mma_deallocate(Frenkeldia)
call mma_deallocate(Freninterm)
call mma_deallocate(Freninterm2)
call mma_deallocate(Frenkelquad)
call mma_deallocate(Rassi1)
call mma_deallocate(Rassi2)
call mma_deallocate(DipFrx)
call mma_deallocate(DipFry)
call mma_deallocate(DipFrz)
call mma_deallocate(DipFrintermx)
call mma_deallocate(DipFrintermx2)
call mma_deallocate(DipFrintermy)
call mma_deallocate(DipFrintermy2)
call mma_deallocate(DipFrintermz)
call mma_deallocate(DipFrintermz2)

2 format(5X,(1x,I4,3x,I4,3x,F18.8,3x,F18.8,3x,F18.8,3x,F18.8,3x,F18.8))
3 format(6X,A,5x,A,6x,A,6x,A,19x,A,19x,A,19x,A)
222 format(5X,2(1X,I4),5X,3(1X,ES18.8))
443 format(3x,I4,3x,I4,3x,F18.8,3x,F18.8,3x,F18.8)
551 format(5X,A,4x,A,10x,A,20x,A,20x,A)

end subroutine frenkelexc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine dev1b2_cvb(cfrom,cto,dmat,
     > i1alf,i1bet,iato,ibto,phato,phbto,
     > iparmx,nda,ndb,n1a,n1b,nam1,nbm1,norb,commut,sc,absym,diag)
c  Calculates all CTO Eij CFROM
      implicit real*8 (a-h,o-z)
      logical commut,sc,absym,diag
      dimension cfrom(nda,ndb),cto(nda,ndb),dmat(iparmx)
      dimension i1alf(n1a,norb),i1bet(n1b,norb)
      dimension iato(norb,0:nam1),ibto(norb,0:nbm1)
      dimension phato(norb,nam1),phbto(norb,nbm1)
      save two
      data two/2d0/

      call fzero(dmat,iparmx)

      iparm=0
      do 1100 iorb=1,norb
      do 1200 jorb=1,norb
      if(jorb.eq.iorb.and..not.diag)goto 1200
      iparm=iparm+1
      if(iparm.gt.iparmx)return

c  a) Alpha excitation
      do 2100 ia=1,n1a
      iaxtmp=i1alf(ia,iorb)
      jax=iato(jorb,iaxtmp)
      if(jax.ne.0)then
        iax=iato(iorb,iaxtmp)
        tcof=phato(iorb,iaxtmp)*phato(jorb,iaxtmp)
        dmat(iparm)=dmat(iparm)+tcof*
     >    ddot_(ndb,cto(jax,1),nda,cfrom(iax,1),nda)
      endif
2100  continue

      if(.not.absym)then
c  c) Beta excitation
        do 3100 ib=1,n1b
        ibxtmp=i1bet(ib,iorb)
        jbx=ibto(jorb,ibxtmp)
        if(jbx.ne.0)then
          ibx=ibto(iorb,ibxtmp)
          tcof=phbto(iorb,ibxtmp)*phbto(jorb,ibxtmp)
          dmat(iparm)=dmat(iparm)+tcof*
     >      ddot_(nda,cto(1,jbx),1,cfrom(1,ibx),1)
        endif
3100    continue
      else
        dmat(iparm)=two*dmat(iparm)
      endif
1200  continue
1100  continue
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_logical(commut)
        call Unused_logical(sc)
      end if
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
      REAL*8 FUNCTION DCLEBS(XJ1,XJ2,XJ3,XM1,XM2,XM3)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MAXJ=10, MAXF=3*MAXJ+1)
      DIMENSION DFACT(0:MAXF)
      SAVE ICALL,DFACT
      DATA ICALL / 0 /
C
C DCLEBS: REAL*8 Clebsch-Gordan coefficients. From a
C modification of Racah''s formula. Coded: Malmqvist 1998.
C
C Note carefully: The input values XJ1..XM3 are REAL*8, not
C integers. Half-integer spins are allowed. Half-integers
C are assumed exactly represented.

      IF(ICALL.EQ.0) THEN
        ICALL=ICALL+1
        DF=1.0D0
        DFACT(0)=DF
        DO I=1,MAXF
          DF=DBLE(I)*DF
          DFACT(I)=DF
        END DO
      END IF

      DCLEBS=0.0D0

      XJSUM=XJ1+XJ2+XJ3
      JSUM=NINT(XJSUM)
      IF(XJSUM.NE.DBLE(JSUM)) RETURN
      IF(XM1+XM2.NE.XM3) RETURN

      IA1=NINT(XJ1+XM1)
      IF(IA1.LT.0) RETURN
      IB1=NINT(XJ1-XM1)
      IF(IB1.LT.0) RETURN
      IA2=NINT(XJ2+XM2)
      IF(IA2.LT.0) RETURN
      IB2=NINT(XJ2-XM2)
      IF(IB2.LT.0) RETURN
      IA3=NINT(XJ3-XM3)
      IF(IA3.LT.0) RETURN
      IB3=NINT(XJ3+XM3)
      IF(IB3.LT.0) RETURN
      IF(JSUM-IA1-IB1.LT.0) RETURN
      IF(JSUM-IA2-IB2.LT.0) RETURN
      IF(JSUM-IA3-IB3.LT.0) RETURN

      PRE2=DBLE(1+IA3+IB3)*DFACT(JSUM-IA1-IB1)
     &          *DFACT(JSUM-IA2-IB2)*DFACT(JSUM-IA3-IB3)
     &          *DFACT(IA1)*DFACT(IA2)*DFACT(IA3)
     &          *DFACT(IB1)*DFACT(IB2)*DFACT(IB3)
     &          /DFACT(JSUM+1)
      PRE=SQRT(PRE2)

      IY0=(JSUM-IA3-IB3)
      IX1=(IA2+IB1-JSUM)+IB2
      IX2=(IA2+IB1-JSUM)+IA1
      IX=MAX(0,IX1,IX2)
      IY=MIN(IY0,IB1,IA2)

      SUMMA=0.0D0
      DO I=IX,IY
        DEN=DFACT(I)*DFACT(I-IX1)*DFACT(I-IX2)*DFACT(IY0-I)*
     &      DFACT(IB1-I)*DFACT(IA2-I)
        TERM=1.0D0/DEN
        SUMMA=SUMMA+DBLE((-1)**I)*TERM
      END DO

      DCLEBS=PRE*SUMMA

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine DEGVEC(VEC,NDIM,NDGVL,IDEG)
! A vector VEC is given with elements in ascending order
! group elements in degenerate pairs
!
!=======
! Input
!=======
! VEC : input vector
! NDIM : Number of elements in vec
!
!========
! Output
!========
! NDGVL : Number of degenerate values
! IDEG(I) : Number of elements in VEC with degenerate value I
!
! Jeppe Olsen, April 1990

use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(in) :: VEC(*)
integer(kind=iwp), intent(in) :: NDIM
integer(kind=iwp), intent(out) :: NDGVL, IDEG(NDIM)
integer(kind=iwp) :: I, NDEG
real(kind=wp) :: XDGVL
real(kind=wp), parameter :: THRES = 1.0e-8_wp

!? write(u6,*) ' Input vector to DEGVEC'
!? call wrtmat(VEC,1,NDIM,1,NDIM)
XDGVL = VEC(1)
NDEG = 1
NDGVL = 0
do I=2,NDIM
  if (abs(VEC(I)-XDGVL) <= THRES) then
    NDEG = NDEG+1
  else
    NDGVL = NDGVL+1
    IDEG(NDGVL) = NDEG
    XDGVL = VEC(I)
    NDEG = 1
  end if
end do
! Last group
NDGVL = NDGVL+1
IDEG(NDGVL) = NDEG

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from DEGVEC'
write(u6,*) ' =================='
write(u6,*)
write(u6,*) ' Number of degenerate values ',NDGVL
write(u6,*) ' Degenerencies of each value'
call IWRTMA(IDEG,1,NDGVL,1,NDGVL)
#endif

return

end subroutine DEGVEC

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CnstCLag(IFF,nLev,NG3,NCONF,CLag,DG1,DG2,DG3,DF1,DF2,DF3,DEPSA,G1,G2,G3)

use PrintLevel, only: VERBOSE
use sguga, only: L2ACT
use caspt2_global, only: IDTCEX, iPrGlb, LUCIEX, LUSOLV
use caspt2_module, only: CITHR, EPSA, ETA, ISCF, JSTATE, MSTATE, NSTATE, STSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, byte, u6

implicit none
integer(kind=iwp), intent(in) :: IFF, nLev, NG3, NCONF
real(kind=wp), intent(inout) :: CLag(nConf), DG1(nLev**2), DG2(nLev**4), DG3(NG3), DF1(nLev**2), DF2(nLev**4), DF3(NG3), &
                                DEPSA(nLev**2)
real(kind=wp), intent(in) :: G1(nLev**2), G2(nLev**4), G3(NG3)
integer(kind=iwp) :: IDCI, ILEV, ILUID
real(kind=wp) :: CPE, CPTF0, CPTF10, CPUT, TIOE, TIOTF0, TIOTF10, WALLT
integer(kind=byte), allocatable :: idxG3(:,:)
real(kind=wp), allocatable :: CI1(:)

if (IFF == 1) then
  ! ORBITAL ENERGIES IN CI-COUPLING ORDER:
  do ILEV=1,NLEV
    ETA(ILEV) = EPSA(L2ACT(ILEV))
  end do
end if

!-SVC20100831: allocate local G3 matrices
call mma_allocate(idxG3,6,NG3,label='idxG3')
iLUID = 0
call I1DAFILE(LUSOLV,2,idxG3,6*NG3,iLUID)

call mma_allocate(CI1,NCONF,LABEL='CI')
if (ISCF == 0) then
  IDCI = IDTCEX(JSTATE)
  call DDAFILE(LUCIEX,2,CI1,NCONF,IDCI)
  if (IPRGLB >= VERBOSE) then
    write(u6,*)
    if (NSTATE > 1) then
      write(u6,'(A,I4)') ' With new orbitals, the CI array of state ',MSTATE(JSTATE)
    else
      write(u6,*) ' With new orbitals, the CI array is:'
    end if
    call PRWF_CP2(STSYM,NCONF,CI1,CITHR)
  end if
else
  CI1(1) = One
end if

call TIMING(CPTF0,CPE,TIOTF0,TIOE)
if (ISCF == 0) then
  call DERFG3(IFF,NCONF,NLEV,NG3,CI1,CLAG,DG1,DG2,DG3,DF1,DF2,DF3,DEPSA,G1,G2)
else
  call DERSPE(NLEV,NG3,DF1,DF2,DF3,idxG3,DEPSA,G1,G2,G3)
end if
call TIMING(CPTF10,CPE,TIOTF10,TIOE)
if (IPRGLB >= VERBOSE) then
  CPUT = CPTF10-CPTF0
  WALLT = TIOTF10-TIOTF0
  write(u6,*)
  write(u6,'(a,2f10.2)') ' DERFG3  : CPU/WALL TIME=',cput,wallt
end if

call mma_deallocate(CI1)
call mma_deallocate(idxG3)

return

end subroutine CnstCLag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,2003, Roland Lindh                                *
!***********************************************************************

subroutine GeoNew_PC()
!***********************************************************************
!                                                                      *
! Object: to pick up the geometry from a special file. This will only  *
!         make any difference of there exist a file otherwise SEWARD   *
!         will use the geometry as specified by the standard input     *
!         file.                                                        *
!                                                                      *
!     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
!             University of Lund, SWEDEN                               *
!             March '91                                                *
!                                                                      *
!     Modified to work with point charges. RL 20030507                 *
!***********************************************************************

use External_Centers, only: nData_XF, XF
use stdalloc, only: mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: lBuf, nAtoms
real(kind=wp), allocatable :: CN(:)
interface
  subroutine Get_PC_Coord_New(CN,lBuf)
    import :: wp, iwp
    real(kind=wp), allocatable :: CN(:)
    integer(iwp) :: lBuf
  end subroutine
end interface

! Check if there is a data field called 'GeoNewPC'

call Get_PC_Coord_New(CN,lBuf)
nAtoms = lbuf/nData_XF

! Quit if the datafield 'NewGeom' is not available

if (lBuf == 0) then
  return
end if

! Replace coodinates read in subroutine input

call dcopy_(nAtoms*nData_XF,CN,1,XF,1)
write(u6,*)
write(u6,'(A)') '    Point Charge data read from RUNFILE'
write(u6,*)

! Epilogue, end

call mma_deallocate(CN)

return

end subroutine GeoNew_PC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      Subroutine EPEMem(nRys,MemEPE,la,lb,lr)
*
      Integer iAngV(4)
*
      Call mHrr(la,lb,nFlop,MemHrr)
*
      nRys=(la+lb+2)/2
      iAngV(1) = la
      iAngV(2) = lb
      iAngV(3) = 0
      iAngV(4) = 0
      Call MemRys(iAngV,MemEPE)
*
      MemEPE = Max(MemEPE,MemHrr)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(lr)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_MpProp(nPrim,nAtoms,nMltPl,D_p,ECENTX,ECENTY,ECENTZ,LNearestAtom,LFirstRun,LLumOrb)
! nOcOb,oNum,nOrb,oCof

use MPProp_globals, only: AtBoMltPl, AtBoMltPlCopy, AtMltPl, BondMat, Cor, CordMltPl, Frac, iAtPrTab, Labe, Method, MltPl, &
                          nAtomPBas, Qnuc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nPrim, nAtoms, nMltPl
real(kind=wp), intent(in) :: D_p(nPrim*(nPrim+1)/2), ECENTX(nPrim*(nPrim+1)/2), ECENTY(nPrim*(nPrim+1)/2), ECENTZ(nPrim*(nPrim+1)/2) !, oNum(nOrb), oCof(nBas,nPrim)
logical(kind=iwp), intent(in) :: LNearestAtom, LFirstRun, LLumOrb
integer(kind=iwp) :: i, iA, iComp, ii, ij, il, iMltpl, ip, iPBas, iq, iStdout, j, jj, jPBas, k, nA, nB, nl, np, nq
real(kind=wp) :: CorP(3), CorN(3), FracA, FracB, FracN, FracP, Qn, Qp, Qs, R, RA, RB, rnloveril, rnPoveriP, rnqoveriq, Rtot, Rwei, &
                 Smallest, rsum, sum_a, sum_b, xfac, xfac_a, xfac_b, yfac, yfac_a, yfac_b, zfac, zfac_a, zfac_b
integer(kind=iwp), allocatable :: iCompMat(:,:,:)
real(kind=wp), allocatable :: Qexp(:,:) !, DenMat(:,:)

call mma_allocate(iCompMat,[0,nMltPl],[0,nMltPl],[0,nMltPl],label='iCompMat')
call mma_allocate(Qexp,nPrim,nPrim,label='Qexp')
!call mma_allocate(DenMat,nPrim,nPrim,label='DenMat')

!                                                                      *
!***********************************************************************
!                                                                      *
! SOME KIND OF PROLOG

iStdout = u6
write(iStdOut,*)
if (LLumOrb) then
  write(iStdOut,*) ' Using the INPORB file'
  if (LFirstRun) then
    write(iStdOut,*) ' This is first run of Get_MpProp'
    !write(iStdOut,*)
    !if (Method == 'UHF-SCF') then
    !  write(iStdOut,*) ' Number of alpha electrons',nOcOB
    !else
    !  write(iStdOut,*) ' Occupation Number ',nOcOB
    !end if
    !write(iStdOut,*) ' Number of Orbitals' ,nOrb
  else
    write(iStdOut,*) ' Running Get_MpProp for the second time'
    !write(iStdOut,*)
    !write(iStdOut,*) ' Number beta electrons ',nOcOB
    !write(iStdOut,*) ' Number of Orbitals' ,nOrb
  end if
else
  write(iStdOut,*) ' Using the densities from a Molcas calculation'
end if
write(iStdOut,*)
! Set the variable that knows the component
do iMltpl=0,nMltPl
  iComp = 0
  do np=iMltpl,0,-1
    do nq=iMltpl-np,0,-1
      nl = iMltpl-np-nq
      iComp = iComp+1
      iCompMat(np,nq,nl) = iComp
    end do
  end do
end do
! Translate dipoles to the center for the quadrupoles
if (LFirstRun) then
  !do iMltpl=0,1
  ! An error written by me DH
  do i=1,nPrim
    do j=1,i
      ij = i*(i-1)/2+j
      do k=1,3
        MltPl(1)%A(ij,k) = MltPl(1)%A(ij,k)+(CordMltPl(k,0)-CordMltPl(k,2))*MltPl(0)%A(ij,1)
      end do
    end do
  end do
  CordMltPl(:,0) = CordMltPl(:,2)
  CordMltPl(:,1) = CordMltPl(:,2)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! GET THE DENSITY MATRIX
!
!if (LLumOrb) then
!  DenMat(:,:) = Zero
!  do K=1,nPrim
!    do L=1,K
!      do i=1,nOcOb
!        DenMat(K,L) = DenMat(K,L)+oNum(I)*oCof(I,K)*oCof(I,L)
!      end do
!      DenMat(L,K) = DenMat(K,L)
!    end do
!  end do
!else
!  do K=1,nPrim
!    do L=1,K
!      DenMat(L,K) = D_p(K*(K-1)/2+L)
!      if (K /= L) then
!        DenMat(K,L) = DenMat(L,K)
!      end if
!    end do
!  end do
!end if
!                                                                      *
!***********************************************************************
!                                                                      *
! GET THE INTERACTION SITES
do i=1,nPrim
  do j=1,i
    ij = i*(i-1)/2+j
    Qexp(i,j) = MltPl(0)%A(ij,1)*D_p(ij)
    Qexp(j,i) = Qexp(i,j)
  end do
end do

iA = -99
do nA=1,nAtoms

  ! NOW SUM UP THE OTHER MULTIPOLE MOMENTS

  do iMltpl=0,nMltPl
    iComp = 0
    do np=iMltpl,0,-1
      do nq=iMltpl-np,0,-1
        nl = iMltpl-np-nq
        iComp = iComp+1
        rsum = Zero
        do ip=0,np
          call NoverP(np,ip,rnPoveriP)
          if (np == ip) then
            xfac = rnpoverip
          else
            xfac = rnPoveriP*(CordMltPl(1,ip)-Cor(1,nA,nA))**(np-ip)
          end if
          do iq=0,nq
            call NoverP(nq,iq,rnqoveriq)
            if (nq == iq) then
              yfac = rnqoveriq
            else
              yfac = rnqoveriq*(CordMltPl(2,iq)-Cor(2,nA,nA))**(nq-iq)
            end if
            do il=0,nl
              call NoverP(nl,il,rnloveril)
              if (nl == il) then
                zfac = rnloveril
              else
                zfac = rnloveril*(CordMltPl(3,il)-Cor(3,nA,nA))**(nl-il)
              end if
              if ((xfac == Zero) .or. (yfac == Zero) .or. (zfac == Zero)) cycle
              do iPBas=1,nAtomPBas(nA)
                i = iAtPrTab(iPBas,nA)
                do jPBas=1,nAtomPBas(nA)
                  !!!! Check i>j
                  if (iAtPrTab(jPBas,nA) > i) then
                    jj = i
                    ii = iAtPrTab(jPBas,nA)
                  else
                    jj = iAtPrTab(jPBas,nA)
                    ii = i
                  end if
                  ij = ii*(ii-1)/2+jj
                  rsum = rsum+xfac*yfac*zfac*D_p(ij)*MltPl(ip+iq+il)%A(ij,iCompMat(ip,iq,il))
                end do
              end do
            end do
          end do
        end do
        ! minus from the negative sign of the electron
        AtBoMltPl(iMltpl)%A(iComp,nA*(nA+1)/2) = AtBoMltPl(iMltpl)%A(iComp,nA*(nA+1)/2)-rsum
        AtBoMltPlCopy(iMltpl)%A(iComp,nA*(nA+1)/2) = AtBoMltPl(iMltpl)%A(iComp,nA*(nA+1)/2)
        AtMltPl(iMltPl)%A(iComp,nA) = AtMltPl(iMltPl)%A(iComp,nA)-rsum
      end do
    end do
  end do

  ! THE NUCLEAR CHARGE IS ADDED ON

  if (LFirstRun) then
    AtMltPl(0)%A(1,nA) = AtMltPl(0)%A(1,nA)+Qnuc(nA)
    AtBoMltPl(0)%A(1,nA*(nA+1)/2) = AtBoMltPl(0)%A(1,nA*(nA+1)/2)+Qnuc(nA)
    AtBoMltPlCopy(0)%A(1,nA*(nA+1)/2) = AtBoMltPlCopy(0)%A(1,nA*(nA+1)/2)+Qnuc(nA)
  end if

  do nB=1,nA-1

    ! MULTIPOLE BETWEEN NA,NB

    Qp = Zero
    Qn = Zero
    CorP(:) = Zero
    CorN(:) = Zero
    do iPBas=1,nAtomPBas(NA)
      i = iAtPrTab(iPBas,NA)
      do jPBas=1,nAtomPBas(NB)
        j = iAtPrTab(jPBas,NB)
        !!!! Check i>j
        if (iAtPrTab(jPBas,nB) > i) then
          jj = i
          ii = iAtPrTab(jPBas,nB)
        else
          jj = iAtPrTab(jPBas,nB)
          ii = i
        end if
        if (Qexp(i,j) > Zero) then
          Qp = Qp+Qexp(i,j)
          CorP(1) = CorP(1)+QEXP(I,J)*ECENTX(ii*(ii-1)/2+jj)
          CorP(2) = CorP(2)+QEXP(I,J)*ECENTY(ii*(ii-1)/2+jj)
          CorP(3) = CorP(3)+QEXP(I,J)*ECENTZ(ii*(ii-1)/2+jj)
        else
          Qn = Qn+Qexp(i,j)
          CorN(1) = CorN(1)+QEXP(I,J)*ECENTX(ii*(ii-1)/2+J)
          CorN(2) = CorN(2)+QEXP(I,J)*ECENTY(ii*(ii-1)/2+J)
          CorN(3) = CorN(3)+QEXP(I,J)*ECENTZ(ii*(ii-1)/2+J)
        end if
      end do
    end do

    if (Qp /= Zero) CorP(:) = CorP(:)/Qp
    if (Qn /= Zero) CorN(:) = CorN(:)/Qn
    Qs = Qp-Qn
    if (Qs /= Zero) then
      FracP = Qp/Qs
      FracN = One-FracP
    else
      FracP = Zero
      FracN = Zero
    end if
    Cor(:,nA,nB) = CorP(:)*FracP+CorN(:)*FracN

    ! CALCULATE THE WEIGHT OF EACH ATOMIC CENTER BY A SIMPLE GEOMETRIC RATIO

    Rwei = sqrt((Cor(1,nA,nA)-Cor(1,nA,nB))**2+(Cor(2,nA,nA)-Cor(2,nA,nB))**2+(Cor(3,nA,nA)-Cor(3,nA,nB))**2)
    Rtot = sqrt((Cor(1,nA,nA)-Cor(1,nB,nB))**2+(Cor(2,nA,nA)-Cor(2,nB,nB))**2+(Cor(3,nA,nA)-Cor(3,nB,nB))**2)

    ! FRACTION OF MULTIPOLE EXPANSION TO BE RELATED TO THE PAIR ATOMS

    FracB = Rwei/Rtot
    FracA = One-FracB
    Frac(nA,nB) = FracA

    ! Find the closest atom
    if (LNearestAtom .and. (.not. BondMat(nA,nB))) then
      Smallest = huge(Smallest)
      do i=1,nAtoms
        R = sqrt((Cor(1,nA,nB)-Cor(1,i,i))**2+(Cor(2,nA,nB)-Cor(2,i,i))**2+(Cor(3,nA,nB)-Cor(3,i,i))**2)
        if (R < Smallest) then
          Smallest = R
          iA = i
        end if
      end do
      RA = sqrt((Cor(1,nA,nB)-Cor(1,nA,nA))**2+(Cor(2,nA,nB)-Cor(2,nA,nA))**2+(Cor(3,nA,nB)-Cor(3,nA,nA))**2)
      RB = sqrt((Cor(1,nA,nB)-Cor(1,nB,nB))**2+(Cor(2,nA,nB)-Cor(2,nB,nB))**2+(Cor(3,nA,nB)-Cor(3,nB,nB))**2)
      if (((iA /= nA) .and. (iA /= nB)) .and. ((Smallest < RA) .and. (Smallest < RB))) then
        iA = iA
        FracA = One
        FracB = Zero
        write(iStdOut,*)
        write(iStdOut,*) ' Moving bond between the atoms  ',Labe(nA),Labe(nB)
        write(iStdOut,*) ' to the atom                    ',Labe(iA)
        write(iStdOut,*)
      else
        iA = nA
      end if
    else
      iA = nA
    end if

    !                                                                  *
    !*******************************************************************
    !                                                                  *
    ! TRANSFORM THE MULTIPOLES TO BONDS AND ATOMS
    !
    ! Do multipoles

    do iMltpl=0,nMltPl
      iComp = 0
      do np=iMltpl,0,-1
        do nq=iMltpl-np,0,-1
          nl = iMltpl-np-nq
          iComp = iComp+1
          rsum = Zero
          do ip=0,np
            call NoverP(np,ip,rnPoveriP)
            if (np == ip) then
              xfac = rnpoverip
            else
              xfac = rnPoveriP*(CordMltPl(1,ip)-Cor(1,nA,nB))**(np-ip)
            end if
            do iq=0,nq
              call NoverP(nq,iq,rnqoveriq)
              if (nq == iq) then
                yfac = rnqoveriq
              else
                yfac = rnqoveriq*(CordMltPl(2,iq)-Cor(2,nA,nB))**(nq-iq)
              end if
              do il=0,nl
                call NoverP(nl,il,rnloveril)
                if (nl == il) then
                  zfac = rnloveril
                else
                  zfac = rnloveril*(CordMltPl(3,il)-Cor(3,nA,nB))**(nl-il)
                end if
                if ((xfac == Zero) .or. (yfac == Zero) .or. (zfac == Zero)) cycle
                do iPBas=1,nAtomPBas(nA)
                  i = iAtPrTab(iPBas,nA)
                  do jPBas=1,nAtomPBas(nB)
                    !!!! Check i>j
                    if (iAtPrTab(jPBas,nB) > i) then
                      jj = i
                      ii = iAtPrTab(jPBas,nB)
                    else
                      jj = iAtPrTab(jPBas,nB)
                      ii = i
                    end if
                    ij = ii*(ii-1)/2+jj
                    rsum = rsum+xfac*yfac*zfac*Two*D_p(ij)*MltPl(ip+iq+il)%A(ij,iCompMat(ip,iq,il))
                  end do
                end do
              end do
            end do
          end do
          ! minus from the negative sign of the electron
          AtBoMltPl(iMltpl)%A(iComp,nA*(nA-1)/2+nB) = AtBoMltPl(iMltpl)%A(iComp,nA*(nA-1)/2+nB)-rsum
          ! Copy the multipole arrays
          AtBoMltPlCopy(iMltpl)%A(iComp,nA*(nA-1)/2+nB) = AtBoMltPl(iMltpl)%A(iComp,nA*(nA-1)/2+nB)
        end do
      end do
    end do

    ! If one should move the bond to the closest atom iA would be equal to
    ! that otherwise iA should be equal to nA

    if (((Method == 'UHF-SCF') .and. (.not. LFirstRun)) .or. ((Method /= 'UHF-SCF') .and. LFirstRun)) then
      do iMltpl=0,nMltPl
        iComp = 0
        do np=iMltpl,0,-1
          do nq=iMltpl-np,0,-1
            nl = iMltpl-np-nq
            iComp = iComp+1
            sum_a = Zero
            sum_b = Zero
            do ip=0,np
              call NoverP(np,ip,rnPoveriP)
              if (np == ip) then
                xfac_a = rnPoveriP
                xfac_b = rnPoveriP
              else
                xfac_a = (Cor(1,nA,nB)-Cor(1,iA,iA))**(np-ip)*rnPoveriP
                xfac_b = (Cor(1,nA,nB)-Cor(1,nB,nB))**(np-ip)*rnPoveriP
              end if
              do iq=0,nq
                call NoverP(nq,iq,rnqoveriq)
                if (nq == iq) then
                  yfac_a = rnqoveriq
                  yfac_b = rnqoveriq
                else
                  yfac_a = (Cor(2,nA,nB)-Cor(2,iA,iA))**(nq-iq)*rnqoveriq
                  yfac_b = (Cor(2,nA,nB)-Cor(2,nB,nB))**(nq-iq)*rnqoveriq
                end if
                do il=0,nl
                  call NoverP(nl,il,rnloveril)
                  if (nl == il) then
                    zfac_a = rnloveril
                    zfac_b = rnloveril
                  else
                    zfac_a = (Cor(3,nA,nB)-Cor(3,iA,iA))**(nl-il)*rnloveril
                    zfac_b = (Cor(3,nA,nB)-Cor(3,nB,nB))**(nl-il)*rnloveril
                  end if
                  sum_a = sum_a+xfac_a*yfac_a*zfac_a*FracA*AtBoMltPl(ip+iq+il)%A(iCompMat(ip,iq,il),nA*(nA-1)/2+nB)
                  sum_b = sum_b+xfac_b*yfac_b*zfac_b*FracB*AtBoMltPl(ip+iq+il)%A(iCompMat(ip,iq,il),nA*(nA-1)/2+nB)
                end do
              end do
            end do
            if (BondMat(nA,nB)) then
              ! If bonding
              ! Do atoms
              AtMltPl(iMltpl)%A(iComp,iA) = AtMltPl(iMltpl)%A(iComp,iA)+sum_a
              AtMltPl(iMltpl)%A(iComp,nB) = AtMltPl(iMltpl)%A(iComp,nB)+sum_b
            else
              ! If not bonding
              ! Do atoms
              AtMltPl(iMltpl)%A(iComp,iA) = AtMltPl(iMltpl)%A(iComp,iA)+sum_a
              AtMltPl(iMltpl)%A(iComp,nB) = AtMltPl(iMltpl)%A(iComp,nB)+sum_b
              ! Do bonds
              AtBoMltPl(iMltpl)%A(iComp,iA*(iA+1)/2) = AtBoMltPl(iMltpl)%A(iComp,iA*(iA+1)/2)+sum_a
              AtBoMltPl(iMltpl)%A(iComp,nB*(nB+1)/2) = AtBoMltPl(iMltpl)%A(iComp,nB*(nB+1)/2)+sum_b
            end if
          end do
        end do
      end do
    end if
  end do
end do

!call mma_deallocate(DenMat)
call mma_deallocate(Qexp)
call mma_deallocate(iCompMat)

return

end subroutine Get_MpProp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FockTwo_Drv_scf(nSym,nBas,nAux,Keep,
     &                       DLT,DSQ,FLT,nFLT,
     &                       ExFac,nBSQT,nBMX,nD,
     &                       FLT_ab,nOcc,lOcc,iDummy_run)
      use OFembed, only: Do_OFemb,OFE_first,FMaux
      use OFembed, only: Rep_EN
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Integer nD
      Integer nSym,nBas(8), nAux(8), Keep(8)
      Integer nOcc(lOcc,nD)
      Logical DoCholesky,GenInt,DoLDF
      Real*8 FLT(nFLT)
      Real*8 FLT_ab(*)
      Real*8 DLT(nFLT,nD)
      Real*8 DSQ(nBSQT,nD)
      Character*50 CFmt

#include "choscf.fh"
#include "chotime.fh"
      Real*8, Allocatable :: FSQ(:,:)
      Real*8, Allocatable :: W1(:), W2(:)
      Real*8, Allocatable :: tFLT(:,:)
*
      GenInt=.false.
      DoCholesky=.false.
      if(ALGO.eq.0) GenInt=.true. !use GenInt to regenerate integrals
      Call DecideOnCholesky(DoCholesky)
      Call DecideOnLocalDF(DoLDF)
      If (DoLDF) GenInt=.false. ! regenerate ints not impl. for LDF

c      write(6,*)'*************************'
c      write(6,*)'ONLY COULOMB CONTRIBUTION'
c      write(6,*)'*************************'
c      exFac=0.d0
c      write(6,*)'ExFac= ',ExFac
*
      If (Do_OFemb) Then ! Coul. potential from subsys B
         If (OFE_first) Call mma_allocate(FMaux,nFlt,Label='FMaux')
         Call Coul_DMB(OFE_first,nD,Rep_EN,FMaux,DLT(:,1),DLT(:,nD),
     &                 nFlt)
         OFE_first=.false.
      End If
*
      Call mma_allocate(FSQ,nBSQT,nD,Label='FSQ')
      FSQ(:,:)=Zero

      if ((.not.DoCholesky).or.(GenInt)) then
         Call mma_Allocate(W2,NBMX*NBMX,Label='W2')
      end if
*
* nFlt is the total dimension of the LT fock matrix
      Call mma_allocate(tFLT,nFLT,nD,Label='tFLT')
      tFLT(:,:)=Zero
*
*
      Call mma_maxDBLE(LBUF)
*
* Standard building of the Fock matrix from Two-el integrals
*
      Call CWTIME(TotCPU1,TotWALL1)

      IF (.not.DoCholesky) THEN
         Call mma_allocate(W1,LBUF,Label='W1')
*
       If (LBUF.LT.NBMX**2) Then
         WRITE(6,*)'FockTwo_Drv_SCF Error: Too little memory remains'
     &     //' for the call to FOCKTWO_SCF.'
         WRITE(6,*)' Largest allocatable array size LBUF=',LBUF
         WRITE(6,*)' Max nr of bf in any symmetry,  NBMX=',NBMX
         WRITE(6,*)' Required minimum size       NBMX**2=',NBMX**2
         WRITE(6,*)'    (All in Real*8-size words)'
         Call  ABEND()
       End If
*
       Call FOCKTWO_scf(nSym,nBas,nAux,Keep,
     &                  DLT(:,1),DSQ(:,1),tFLT,nFlt,
     &                  FSQ,LBUF,W1,W2,ExFac,nD,nBSQT,
     &                  DLT(:,nD),DSQ(:,nD))

      ENDIF
*
* Building of the Fock matrix regenerating the integrals on the fly
*
      IF ((DoCholesky).and.(GenInt)) THEN ! save some space for GenInt
         LBUF = MAX(LBUF-LBUF/10,0)
         Call mma_allocate(W1,LBUF,Label='W1')
*
       If (LBUF.LT.NBMX**2) Then
         WRITE(6,*)' FockTwo_Drv Error: Too little memory remains for'
     &     //' the call to FOCKTWO_SCF.'
         WRITE(6,*)' Largest allocatable array size LBUF=',LBUF
         WRITE(6,*)' Max nr of bf in any symmetry,  NBMX=',NBMX
         WRITE(6,*)' Required minimum size       NBMX**2=',NBMX**2
         WRITE(6,*)'    (All in Real*8-size words)'
         Call  ABEND()
       End If
*
       Call FOCKTWO_scf(nSym,nBas,nAux,Keep,
     &                  DLT(:,1),DSQ(:,1),tFLT,nFlt,
     &                  FSQ,LBUF,W1,W2,ExFac,nD,nBSQT,
     &                  DLT(:,nD),DSQ(:,nD))

      ENDIF
*
      Call CWTIME(TotCPU2,TotWALL2)
      TOTCPU  = TotCPU2 - TotCPU1
      TOTWALL = TotWALL2 - TotWALL1

*---- Timings information for conventional or Cholesky with ALGO=0
      IF ( .not.DoCholesky .or. (DoCholesky.and.GenInt) ) THEN
      if(timings)then
      CFmt='(2x,A)'
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      if(DoCholesky)then
      Write(6,CFmt)'---    Cholesky SCF - Integral regeneration   ---'
      else
      Write(6,CFmt)'-----------     Conventional SCF     ------------'
      endif
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'Fock matrix construction        CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)
      endif
      ENDIF
*
*
* Building of the Fock matrix directly from Cholesky vectors
*

      IF (DoCholesky .and. .not.GenInt.and.iDummy_run.eq.1) THEN
       Write(6,*) '*** Warning: missing feature in Cholesky code'
       Write(6,*) 'Use the results with extra care!'
      endif

      IF (DoCholesky .and. .not.GenInt.and.iDummy_run.eq.0) THEN
*
         CALL CHOscf_drv(nBSQT,nD,nSym,nBas,DSQ(:,1),DLT(:,1),
     &                   DSQ(:,nD),DLT(:,nD),
     &                   tFLT(:,1),tFLT(:,nD),nFLT,ExFac,
     &                   FSQ,nOcc(:,1),nOcc(:,nD))

      ENDIF
*
      Call DaXpY_(nFlt,One,tFLT(:,1),1,FLT,1)
      if(nD==2) then
        Call DaXpY_(nFlt,One,tFLT(:,2),1,FLT_ab,1)
      endif
*
      Call mma_deallocate(tFLT)
*
      If (Do_OFemb) Then ! add FM from subsystem B
        Call DaXpY_(nFlt,One,FMaux,1,FLT,1)
        If (nD==2) Call DaXpY_(nFlt,One,FMaux,1,FLT_ab,1)
      EndIf
*
      IF ((.not.DoCholesky).or.(GenInt)) THEN
          Call mma_deallocate(W1)
          Call mma_deallocate(W2)
      END IF

      Call mma_deallocate(FSQ)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Coen de Graaf                                    *
*               1999, Anders Bernhardsson                              *
*               1999, Roland Lindh                                     *
************************************************************************
      Subroutine Molden_Interface(iUHF,FName,filename)
************************************************************************
*                                                                      *
*     Object: to generate MOLDEN input file                            *
*                                                                      *
*                                                                      *
*     Authors: Coen de Graaf, Anders Bernardsson and R. Lindh, 1999    *
*                                                                      *
************************************************************************
      use Real_Spherical
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, lIrrep
      use Sizes_of_Seward, only: S
      implicit real*8 (a-h,o-z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
*
*
c      Parameter (MaxOrb_Molden=400, MaxOrb_Do=100)
      Parameter (EorbThr = 50.D0 )
      Real*8 Coor(3,MxAtom),Znuc(MxAtom)
      Character shelllabel(7)
      Character*(LENIN) AtomLabel(MxAtom)
      Character*(LENIN8), Allocatable :: label(:)
      Character*8 MO_Label(maxbfn)
      Parameter (nNumber=61)
      Character Number(nNumber)
      Integer ibas_lab(MxAtom), nOrb(8)
      Character*(LENIN8+1) gtolabel(maxbfn)
      Real*8 r_Norm(maxbfn)
      Character*(*) Filename, FName
      Character VTitle*40, Env*8
      Logical Exist,y_cart,y_sphere, Found, Reduce_Prt
      External Reduce_Prt
      Character*100 Supername,Get_SuperName
      External Get_SuperName
      data shelllabel /'s','p','d','f','g','h','i'/
      data number /'1','2','3','4','5','6','7','8','9','0',
     &             'a','b','c','d','e','f','g','h','i','j',
     &             'k','l','m','n','o','p','q','r','s','t',
     &             'u','v','w','x','y','z','A','B','C','D',
     &             'E','F','G','H','I','J','K','L','M','N',
     &             'O','P','Q','R','S','T','V','W','X','Y',
     &             'Z'/
      data iRc/0/
      save iRc
      Dimension iDummy(1)
*
*     Statement function
*
      CC(ix,iy,iz)=SQRT(DblFac(2*ix-1)*DblFac(2*iy-1)*DblFac(2*iz-1))
*
      if(iRc.eq.1) Return
*
* Do nothing within numerical_gradient
      SuperName=Get_Supername()
      If (SuperName == 'numerical_gradient') Then
        Return
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Get the print level
*
      iPL=iPrintLevel(-1)
      jPL=iPL
      If (Reduce_Prt().and.iPL.lt.3) jPL=0
*                                                                      *
************************************************************************
*                                                                      *
      If (MolWgh.eq.1) Then
         If (jPL.ge.2) Then
            Write (6,*) 'Molden_Interface: '
     &                //'Unsupported normalization,Molwgh=1!'
         End If
         iRc=1
         Return
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Call GetEnvf('MOLCAS_MOLDEN',Env)
c      If (Env.eq.' '.or.Env.eq.'OFF') Then
      If (Env.eq.'OFF') Then
         If (jPL.ge.2) Then
            Write(6,*)
            Write(6,*) ' Molden files will not be produced'
            Write(6,*)
         End If
         iRC=1
         Return
      End If
cVV: current version of Molden has no clear limit for MaxOrb
c      If (MaxOrb.gt.MaxOrb_Molden) Then
c         If (jPL.ge.2) Then
c            Write(6,*)
c            Write(6,*) ' Molden_Interface: W A R N I N G !!!!'
c            Write(6,*)
c            Write(6,*) ' No Molden input file will be generated!'
c            Write(6,*)
c            Write(6,*) ' Calculation exceeds the max number of orbitals'
c     &               //' allowed for MOLDEN. To change this modify the '
c            Write(6,*) ' parameter MaxOrb_Molden in  src/util/molden_in'
c     &               //'terface.f and follow the instructions in Molden'
c            Write(6,*) ' on how to modify the parameter MaxOrb.'
c            Write(6,*)
c         End If
c         iRC=1
c         Return
c      End If
*                                                                      *
************************************************************************
*                                                                      *
      Check_CMO=Zero
      Check_Energy=Zero
      Check_Occupation=Zero
*                                                                      *
************************************************************************
*                                                                      *
      Call f_Inquire('RUNFILE',Exist)
      If (.Not.Exist) then
      iRC=1
      Return
      Endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Read the characteristics of all different basis sets,
*     provide each atom with a nuclear charge and establish
*     a link between an atom and its basis set ---
*
*     NOTICE!!!
*     This call will also fill info.fh and the Basis_Info.
*
      Call Inter1       (AtomLabel,iBas_Lab,Coor,Znuc,nAtom)
      Call Qpg_iArray('nOrb',Found,nData)
      If (Found) Then
         Call Get_iArray('nOrb',nOrb,nData)
      Else
         Call iCopy(nIrrep,nBas,1,nOrb,1)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      iAngMx_Valence=0
      Do iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%Aux .and.
     &       .Not.dbsc(iCnttp)%Frag ) Then
            nTest=dbsc(iCnttp)%nVal-1
            iAngMx_Valence=Max(iAngMx_Valence,nTest)
         End If
      End Do
      If (iAngMx_Valence.gt.4) Then
        If (jPL.ge.2) Then
           Write(6,*) 'Sorry, Molden does not know how to handle'
           Write(6,*) 'functions with angular momentum larger than g'
        End If
        Go To 999
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Unnormalize contraction coefficients for the valence shells
*
      Do iCnttp=1,nCnttp
        If (.Not.(dbsc(iCnttp)%Aux.or.dbsc(iCnttp)%Frag)) Then
         Do l=0,dbsc(iCnttp)%nVal-1
          ishell=dbsc(iCnttp)%iVal+l
          If (Shells(ishell)%Transf.and.
     &  .not. Shells(iShell)%Prjct) Then
           If (jPL.ge.2) Then
            Write(6,*) 'Sorry, Molden does not support contaminants'
           End If
           Go To 999
          End If
          Call Unnrmlz(Shells(ishell)%Exp,Shells(ishell)%nExp,
     &                 Shells(ishell)%pCff,Shells(ishell)%nBasis,l)
         End Do
        End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*     Compute memory requirements and allocate memory
*
      nB=0
      Do iS=0,nirrep-1
       nB=nB+nBas(is)
      End Do
      Call GetMem('ICENT','ALLO','INTE',ipCent,8*nB)
      Call GetMem('IPHASE','ALLO','INTE',ipPhase,8*nB)
      Call GetMem('nCENT','ALLO','INTE',ipCent2,nB)
      Call GetMem('ICENTER','ALLO','INTE',ipCent3,nB)
      Call GetMem('CMO2','ALLO','REAL',ipC2,nB**2)
      Call GetMem('VECTOR','ALLO','REAL',ipV,nB**2)
      call dcopy_(nB**2,[Zero],0,Work(ipV),1)
      If (iUHF.eq.1) Then
         Call GetMem('CMO2','ALLO','REAL',ipC2_ab,nB**2)
         Call GetMem('VECTOR','ALLO','REAL',ipV_ab,nB**2)
         call dcopy_(nB**2,[Zero],0,Work(ipV_ab),1)
      Else
         ipC2_ab=ip_Dummy
         ipV_ab =ip_Dummy
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Open input file for MOLDEN
*
      MF=9
      call molcas_open(MF,filename)
*                                                                      *
************************************************************************
*                                                                      *
*     Write the atom information in MOLDEN format to unit MF
*
*
      y_cart=.false.
      y_sphere=.false.
      Do iCnttp=1,nCnttp
        If (dbsc(iCnttp)%Aux.or.dbsc(iCnttp)%Frag) Go To 995
        Do iCntr=1,dbsc(iCnttp)%nCntr
          Do l=0,dbsc(iCnttp)%nVal-1
*           Test for the appearance of cartesian functions with l=2,3,4
            ishell=dbsc(iCnttp)%iVal+l
            if ((l.ge.2).and.(.not.y_cart)) Then
              if (.not.Shells(ishell)%Transf) y_cart=.true.
            End If
            if ((l.ge.2).and.(.not.y_sphere)) Then
              if (Shells(ishell)%Transf) y_sphere=.true.
            end if
            if (y_sphere.and.y_cart) Then
              If (jPL.ge.2) Then
                 Write (6,*)
                 Write (6,*) 'Failed to generate input file to MOLDEN'
                 Write (6,*) 'No mixing allowed of spherical and',
     &                       ' cartesian d, f, g-functions'
              End If
              Go to 991
            End If
          End Do
        End Do
 995    Continue
      End Do
      Write (MF,'(A)') '[Molden Format]'
*                                                                      *
************************************************************************
*                                                                      *
*     Write atomic information
*
      Write (MF,'(A)') '[N_ATOMS]'
      Write (MF,*) natom
      Write (MF,'(A)') '[ATOMS] (AU)'
      Do iatom=1,natom
        Write (MF,99) AtomLabel(iatom),iatom,int(Znuc(iatom)),
     &                (coor(i,iatom),i=1,3)
 99     Format(A,2(3x,I4),5x,3F16.8,3I4)
      End Do
      If (.not.y_cart) Then
        If (S%iAngMx.gt.1) Write (MF,'(A)') '[5D]'
        If (S%iAngMx.gt.2) Write (MF,'(A)') '[7F]'
        If (S%iAngMx.gt.3) Write (MF,'(A)') '[9G]'
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Write out charges and dipole moments
*
      Call qpg_dArray('Mulliken Charge',Found,nData)
      If (Found) Then
         Write (MF,'(A)') '[CHARGE] (MULLIKEN)'
         Call Allocate_Work(ipMull,nData)
         Call Get_dArray('Mulliken Charge',Work(ipMull),nData)
*
         iData = 0
         jData = 0
         Do iCnttp=1,nCnttp
            If (dbsc(iCnttp)%Aux.or.
     &          dbsc(iCnttp)%Frag.or.
     &          dbsc(iCnttp)%pChrg) Go To 775
            Do iCntr=1,dbsc(iCnttp)%nCntr
               iData=iData+1
               mdc = iCntr + dbsc(iCnttp)%mdci
               nDeg=nIrrep/dc(mdc)%nStab
               Do iDeg = 1, nDeg
                  jData=jData+1
                  Write (MF,*) Work(ipMull+iData-1)
               End Do
            End Do
 775        Continue
         End Do
         Call Free_Work(ipMull)
         If (iData.ne.nData) Then
            Write (6,*) 'Molden_Interface: iData.ne.nData'
            Write (6,*) 'iData,nData=',iData,nData
            Call Abend()
         End If
         If (jData.ne.nAtom) Then
            Write (6,*) 'Molden_Interface: jData.ne.nAtom'
            Write (6,*) 'jData,nAtom=',jData,nAtom
            Call Abend()
         End If
      End If
C     Write (MF,'(A)') '[NDIPOLE]'
C     Write (MF,'(A)') '[DIPOLE]'
*                                                                      *
************************************************************************
*                                                                      *
*     Write Gaussian basis set information to MOLDEN input file.
*
      Write (MF,'(A)') '[GTO] (AU)'
*
*     Read exponents and contraction coefficients of each unique basis.
*     Write the present basis set (iCnttp) to the molden.input file for
*     the appropriate atoms.
*     Moreover, a list is constructed which contains a label for each
*     GTO (gtolabel). This list follows the MOLDEN order of GTOs.
*     Later this list will be used in the transformation of sabf (the
*     symmetry adapted basis functions).
*
      iatom=0
      mdc=0
      kk=0
*
      Do iCnttp=1,nCnttp             ! loop over unique basis sets
        If (dbsc(iCnttp)%Aux.or.dbsc(iCnttp)%Frag) Go To 996
*
        Do iCntr=1,dbsc(iCnttp)%nCntr  ! loop over sym. unique centers
          mdc=mdc+1
          nDeg=nIrrep/dc(mdc)%nStab
          Do iDeg=1,nDeg             ! loop over centers
            iAtom=iAtom+1
            Write (MF,'(I4)') iAtom
*
            Do l=0,dbsc(iCnttp)%nVal-1
              ishell=dbsc(iCnttp)%iVal+l
              If (Shells(iShell)%nBasis.gt.nNumber) Then
                 Write (6,*) 'Interf: too many contracted functions!'
                 Write (6,*) 'nBasis(iShell)=',Shells(iShell)%nBasis
                 Call Abend()
              End If
*
*             Iterate over each contracted GTO
*
              Do icontr=1,Shells(ishell)%nBasis
*
*               Find the number of exponents with non-zero exponents
*
                isegm=0
                Do iprim=1,Shells(ishell)%nExp
                  coeff=Shells(ishell)%pCff(iprim,icontr)
                  If (coeff.ne.Zero) Then
                    isegm=isegm+1
                  End If
                End Do
*
                Write (MF,'(3x,A1,I4)') shelllabel(l+1),isegm
*
*               Write exponents and contraction coefficients.
*
                Do iprim=1,Shells(ishell)%nExp
                  coeff=Shells(ishell)%pCff(iprim,icontr)
                  prim=Shells(ishell)%Exp(iprim)
                  If (coeff.ne.Zero) Then
                    Write (MF,'(E17.9,E17.9)') prim,coeff
                  End If
                End Do
*
*               Construction of gtolabel
*               Molden order: for p-functions: px(1), py(1), pz(1),
*                                              px(2), py(2), pz(2), etc.
*               for d-, and f-functions: similar
*
                If (l.eq.0) Then
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'01s     '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                End If
                If (l.eq.1) Then
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'02px    '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'02py    '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'02pz    '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                End If
                If ((l.eq.2).and.(.not.y_cart)) Then
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'03d00   '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'03d01+  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'03d01-  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'03d02+  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'03d02-  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                End If
                If ((l.eq.2).and.(y_cart)) Then
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'d020000 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(2,0,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'d000200 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,2,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'d000002 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,0,2)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'d010100 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(1,1,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'d010001 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(1,0,1)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'d000101 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,1,1)
                  iWork(ipCent3+kk-1)=iAtom
                End If
                If ((l.eq.3).and.(.not.y_cart)) Then
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'04f00   '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'04f01+  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'04f01-  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'04f02+  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'04f02-  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'04f03+  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'04f03-  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                End If
                If ((l.eq.3).and.(y_cart)) Then
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f030000 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(3,0,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f000300 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,3,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f000003 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,0,3)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f010200 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(1,2,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f020100 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(2,1,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f020001 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(2,0,1)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f010002 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(1,0,2)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f000102 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,1,2)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f000201 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,2,1)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'f010101 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(1,1,1)
                  iWork(ipCent3+kk-1)=iAtom
                End If
                If ((l.eq.4).and.(.not.y_cart)) Then
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'05g00   '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'05g01+  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'05g01-  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'05g02+  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                 iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'05g02-  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'05g03+  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'05g03-  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'05g04+  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'05g04-  '//
     &                         number(icontr)
                  r_Norm(kk)=1.0D0
                  iWork(ipCent3+kk-1)=iAtom
                End If
                If ((l.eq.4).and.(y_cart)) Then
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g040000 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(4,0,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g000400 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,4,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g000004 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,0,4)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g030100 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(3,1,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g030001 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(3,0,1)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g010300 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(1,3,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g000301 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,3,1)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g010003 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(1,0,3)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g000103 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,1,3)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g020200 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(2,2,0)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g020002 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(2,0,2)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g000202 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(0,2,2)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g020101 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(2,1,1)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g010201 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(1,2,1)
                  iWork(ipCent3+kk-1)=iAtom
                  kk=kk+1
                  gtolabel(kk)=AtomLabel(iAtom)//'g010102 '//
     &                         number(icontr)
                  r_Norm(kk)=CC(1,1,2)
                  iWork(ipCent3+kk-1)=iAtom
                End If
              End Do
            End Do
            Write (MF,'(A)') ' '
          End Do
        End Do
 996    Continue
      End Do
      kk_Max=kk
      If (nB.gt.kk_max) Then
         If (jPL.ge.2) Then
            Write(6,*) 'Molden_Interface: nB.gt.kk_max'
            Write(6,*) 'nB,kk_Max=',nB,kk_Max
         End If
         Go To 991
      End If
*                                                                      *
************************************************************************
*                                                                      *
*
      nTot=0
      nTot2=0
      Do iS=0,nIrrep-1
         nTot=nTot+nBas(iS)
         nTot2=nTot2+nBas(iS)**2
      End Do
      Call GetMem('Occ','Allo','Real',mAdOcc,nTot )
      Call GetMem('Eor','Allo','Real',mAdEor,nTot )
      Call GetMem('CMO','Allo','Real',mAdCMO,nTot2)
      Call FZero(Work(mAdOcc),nTot)
      Call FZero(Work(mAdEor),nTot)
      Call FZero(Work(mAdCMO),nTot2)
      If (iUHF.eq.1) Then
         Call GetMem('Occ','Allo','Real',mAdOcc_ab,nTot )
         Call GetMem('Eor','Allo','Real',mAdEor_ab,nTot )
         Call GetMem('CMO','Allo','Real',mAdCMO_ab,nTot2)
         Call FZero(Work(mAdOcc_ab),nTot)
         Call FZero(Work(mAdEor_ab),nTot)
         Call FZero(Work(mAdCMO_ab),nTot2)
      Else
         mAdOcc_ab=ip_Dummy
         mAdEor_ab=ip_Dummy
         mAdCMO_ab=ip_Dummy
      End If
*
*
*---- Read HF CMOs from file
*
      Lu_=75
      Call RdVec_(FName,Lu_,'COE',iUHF,nIrrep,nBas,nBas,
     &                  Work(mAdCMO),Work(mAdCMO_ab),
     &            Work(mAdOcc),Work(mAdOcc_ab),
     &            Work(mAdEor),Work(mAdEor_ab),
     &            iDummy,VTitle,1,iErr,iWFtype)
*
*     Get the coeff. of sym adapted basis functions (ipC2)
*
      Call Dens_IF_SCF(Work(ipC2),Work(mAdCMO),'F')
      Call GetMem('CMO','Free','Real',mAdCMO,nTot2)
      If (iUHF.eq.1) Then
         Call Dens_IF_SCF(Work(ipC2_ab),Work(mAdCMO_ab),'F')
         Call GetMem('CMO','Free','Real',mAdCMO_ab,nTot2)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*      Back 'transformation' of the symmetry adapted basis functions.
*      Probably somewhat clumsy, but it seems to work.If someone
*      knows a more elegant way to do it, please improve this part!
*
*      PART 1: Obtain symmetry information (soout), construct a label
*              for each sabf, which will be used in part 2 to find the
*              corresponding GTO in the MOLDEN list by comparing with
*              gtolabel
*
*      nB       --- Total number of contracted basis functions
*      ipcent2  --- degeneracy of a basis function
*      ipCent   --- centres over which the basis function is
*                   delocalized
*      ipPhase  --- phase of the AO in the linear combination
*
      Call mma_allocate(label,MaxBfn+MaxBfn_Aux,label='label')
      Call icopy(8*nB,[0],0,iWork(ipPhase),1)
      Call icopy(8*nB,[0],0,iWork(ipCent),1)
      Call SOout(label,iWork(ipCent),iWork(ipPhase))
      ipc=0
      Do iContr=1,nB
        iWork(ipCent2+iContr-1)=0
        Do k=1,8
          If (iWork(ipCent+ipc).ne.0)
     &       iWork(ipcent2+iContr-1)=iWork(ipCent2+iContr-1)+1
          ipc=ipc+1
        End Do
cvv this statement prevents overoptimization
        if(nB.lt.-100) write(6, *) iWork(ipCent2+iContr-1)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
*
* Part 2: -Take a MOLCAS symmetry functions (loop i)
*         -Find the corresponding label in the MOLDEN list (loop j)
*         -Copy the coeff of the sabf in the MOLDEN MO (vector), multiply
*          by the appropriate factor (ipPhase),and divide by the number of
*          centres over which the sabf is delocalized (ipCent3).
*         -The vectors are copied by rows!
*
*     loop over MOLCAS symmetry functions
      i=0
      ik=0
      Do iIrrep=0,nIrrep-1
*
        Do iB=1,nBas(iIrrep)
          i=i+1
*
          If (iB.eq.1) Then
            ik=1
          else
            If (label(i-1).eq.label(i)) Then
              ik=ik+1
            else
              ik=1
            End If
          End If
          If (ik.gt.nNumber) Then
             Write (6,*) 'Molden_Interface: ik.gt.nNumber'
             Write (6,*) 'ik,nNumber=',ik,nNumber
             Write (6,*) 'List of labels'
             Do iD = 1, nB
                Write (6,'(A)') Label(i)
             End Do
             Go To 997
          End If
*
          Write (MO_Label(i),'(I5,A3)') iB,lirrep(iIrrep)
*
          Do j=1,nB
*
*
            If (gtolabel(j).eq.label(i)//number(ik)) Then
              Do k=1,8
                ipc=(i-1)*8+k-1
                ipp=ipc
                If (iWork(ipCent+ipc).eq.iWork(ipcent3+j-1)) Then
                  Do ii=1,nB
                    ic=(ii-1)*nB+(i-1)
                    iv=(ii-1)*nB+(j-1)
                    If (MolWgh.eq.0) Then
                       Work(ipV+iv) = Work(ipV+iv)
     &                              + (Work(ipC2+ic)*r_Norm(j))
     &                              * DBLE(iWork(ipPhase+ipp))
     &                              / DBLE(iWork(ipcent2+i-1))
                       If (iUHF.eq.1) Work(ipV_ab+iv) = Work(ipV_ab+iv)
     &                              + (Work(ipC2_ab+ic)*r_Norm(j))
     &                              * DBLE(iWork(ipPhase+ipp))
     &                              / DBLE(iWork(ipcent2+i-1))
                    Else
                       Work(ipV+iv) = Work(ipV+iv)
     &                              + (Work(ipC2+ic)*r_Norm(j))
     &                              * DBLE(iWork(ipPhase+ipp))
     &                              / Sqrt(DBLE(iWork(ipcent2+i-1)))
                       If (iUHF.eq.1) Work(ipV_ab+iv) = Work(ipV_ab+iv)
     &                              + (Work(ipC2_ab+ic)*r_Norm(j))
     &                              * DBLE(iWork(ipPhase+ipp))
     &                              / Sqrt(DBLE(iWork(ipcent2+i-1)))
                    End If
                  End Do
                End If
              End Do
            End If
          End Do
        End Do
      End Do
      Call mma_deallocate(label)
*                                                                      *
************************************************************************
*                                                                      *
*      Dump vector in the molden.input file
*
      Write (MF,'(A)') '[MO]'
      ii=0
      Do i=0,nB-1
        If (Work(mAdEOr+i).le.EorbThr) Then
          Write (MF,'(A,A)') 'Sym= ',MO_Label(i+1)
          Write (MF,103) Work(mAdEOr+i)
          Write (MF,'(A)') 'Spin= Alpha'
          Write (MF,104) Work(mAdOcc+i)
          If (Work(mAdEOr+i).lt.0.0D0) Then
          Check_Energy     = Check_Energy
     &                     + Work(mAdEOr+i)*DBLE(i)
          End If
          Check_Occupation = Check_Occupation
     &                     +Work(mAdOcc+i)*DBLE(i)
          Do j=1,nB
            Write (MF,100) j,Work(ipV+ii+j-1)
            Check_CMO = Check_CMO
     &                + Work(ipV+ii+j-1)**2
          End Do
        End If
*
        If (iUHF.eq.1) Then
           If (Work(mAdEOr_ab+i).le.EorbThr) Then
              Write (MF,'(A,A)') 'Sym= ',MO_Label(i+1)
              Write (MF,103) Work(mAdEOr_ab+i)
              Write (MF,'(A)') 'Spin= Beta'
              Write (MF,104) Work(mAdOcc_ab+i)
          Check_Energy     = Check_Energy
     &                     + Work(mAdEOr_ab+i)*DBLE(i)
          Check_Occupation = Check_Occupation
     &                     +Work(mAdOcc_ab+i)*DBLE(i)
              Do j=1,nB
                 Write (MF,100) j,Work(ipV_ab+ii+j-1)
                 Check_CMO = Check_CMO
     &                     + Work(ipV_ab+ii+j-1)**2
              End Do
           End If
        End If
*
        ii=ii+nB
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      if(Env.ne.'OFF') then
*     If (iUHF.lt.2)
*    & Call Add_Info('MOLDEN_CMO',       Check_CMO,       1,2)
*     Call Add_Info('MOLDEN_Occupation',Check_Occupation,1,2)
*     Call Add_Info('MOLDEN_Energy    ',Check_Energy    ,1,2)
      endif
*                                                                      *
************************************************************************
*                                                                      *
      Do iCnttp=1,nCnttp
        If (.Not.(dbsc(iCnttp)%Aux.or.dbsc(iCnttp)%Frag)) Then
         Do l=0,dbsc(iCnttp)%nVal-1
          ishell=dbsc(iCnttp)%iVal+l
          Call Unnrmlz2(Shells(ishell)%Exp, Shells(ishell)%nExp,
     &                  Shells(ishell)%pCff,Shells(ishell)%nBasis,l)
         End Do
        End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (jPL.ge.2) Then
         Write (6,*)
         Write (6,*) ' Input file to MOLDEN was generated!'
         Write (6,*)
      End If
*                                                                      *
************************************************************************
*                                                                      *
 997  Continue
      Call GetMem('Eor','Free','Real',mAdEor,nTot)
      Call GetMem('Occ','Free','Real',mAdOcc,nTot)
      If (iUHF.eq.1) Then
         Call GetMem('Eor','Free','Real',mAdEor_ab,nTot)
         Call GetMem('Occ','Free','Real',mAdOcc_ab,nTot)
      End If
 991  Continue
      Call GetMem('ICENT','FREE','INTE',ipCent,8*nB)
      Call GetMem('IPHASE','FREE','INTE',ipPhase,8*nB)
      Call GetMem('nCENT','FREE','INTE',ipCent2,nB)
      Call GetMem('ICENTER','FREE','INTE',ipCent3,nB)
      If (iUHF.eq.1) Then
         Call GetMem('CMO2','FREE','REAL',ipC2_ab,nB**2)
         Call GetMem('VECTOR','FREE','REAL',ipV_ab,nB**2)
      End If
      Call GetMem('CMO2','FREE','REAL',ipC2,nB**2)
      Call GetMem('VECTOR','FREE','REAL',ipV,nB**2)
      Close (MF)
 999  Call ClsSew
*
C -------------FORMATS-------------
 100  format(I4,3x,F16.8)
 103  format('Ene= ',F10.4)
 104  format('Occup= ',F10.5)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!***********************************************************************

module linalg_mod

#include "compiler_features.h"
#include "macros.fh"
#include "intent.fh"

use stdalloc, only: mma_allocate, mma_deallocate
use constants, only: Zero, One
use definitions, only: wp, iwp
#ifdef _ADDITIONAL_RUNTIME_CHECK_
use definitions, only: r8
#endif
use sorting, only: sort, argsort
use sorting_funcs, only: leq_i, leq_r, geq_r

implicit none
private

public :: mult, sym_diagonalize, is_close, operator(.isclose.), dot_product_, norm, canonicalize, Gram_Schmidt, Canonical, Lowdin, &
          symmetric
! TODO Move to different module
public :: abort_, verify_

type, abstract :: ParentCanonicalize_t
contains
  procedure :: canonicalize => base_canonicalize
  procedure(get_projections_t), deferred :: get_projections
end type

abstract interface
  subroutine get_projections_t(self,M,P)
    import :: wp, ParentCanonicalize_t
    class(ParentCanonicalize_t), intent(in) :: self
    real(kind=wp), intent(in) :: M(:,:)
    real(kind=wp), intent(out) :: P(:,:)
  end subroutine get_projections_t
end interface

type, extends(ParentCanonicalize_t) :: CanonicalBasisCanonicalize_t
contains
  procedure :: get_projections => project_canonical_unit_vectors
end type

type, extends(ParentCanonicalize_t) :: GeneralBasisCanonicalize_t
  real(kind=wp), pointer :: ref(:,:) => null()
contains
  procedure :: get_projections => project_general_unit_vectors
end type

!>  @brief
!>    Wrapper around dgemm.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  This is an overloaded wrapper around DGEMM which
!>  uses assumed shape arrays to deduce as much information
!>  as possible about the DGEMM calls automatically.
!>  The preferred way is to use arrays of actual rank 2
!>  instead of rank 1 arrays which are interpreted to be rank 2
!>  just by convention.
!>
!>  There are some run time checks to test for matching shapes.
interface mult
  module procedure :: mult_2D, mult_2D_1D, mult_2d_raw
end interface mult

!>  @brief
!>  Canonicalize Eigenvectors and Eigenvalues
!>
!>  @details
!>  This procedure can be used to make diagonalizations deterministic,
!>  by forcing the Eigenvectors to be as similar as possible to proj_B.
!>  The algorithm is as following:
!>
!>  1. Sort the Eigenvalues (and the Eigenvectors accordingly).
!>  2. Find degenerate Eigenvalues (up to float equality) and put
!>      corresponding Eigenvectors into separate Eigenspaces.
!>  For each Eigenspace
!>      1. Let $b_i$ be the basis vectors in `proj_B` and $E$ your Eigenspace of dimension $d$.
!>      2. Calculate all projections of $b_i$ onto $E$. Let's call them $p_i$
!>      3. Stable-sort the $p_i$ by their norm.
!>      4. Take the first $d$ projections and normalize them. These are your canonical Eigenvectors.
!>
!>  @param[in,out] V 2D matrix which contains the Eigenvectors.
!>      The j-th column corresponds to the j-th Eigenvalue.
!>  @param[in,out] lambda 1D vector of Eigenvalues.
!>  @param[in] proj_B Optional and overloaded argument.
!>      If it is ommited, the canonical unit vector basis is assumed.
!>      Otherwise it can be 2D orthogonal matrix that represents the reference basis for
!>      the canonicalization or a function pointer of type `get_matrix_t`
!>      that returns matrix elements (trading speed for memory).
!>  @param[out] info Optional error code. If calling code does not check the error
!>      code, then this routine crashes upon errors.
interface canonicalize
  module procedure :: canonicalize_canonical_basis, canonicalize_general
end interface canonicalize

interface operator(.isclose.)
  module procedure :: isclose_for_operator
end interface

contains

!>  @brief
!>    Wrapper around dgemm for matrix-matrix multiplication.
!>
!>  @author Oskar Weser
!>
!>  @details
!>
!>  @param[in] A
!>  @param[in] B
!>  @param[out] C The shape of the output array is usually
!>      [size(A, 1), size(B, 2)] which changes of course, if
!>      A or B are transposed.
!>  @param[in] transpA Optional argument to specify that A
!>      should be transposed.
!>  @param[in] transpB Optional argument to specify that B
!>      should be transposed.
subroutine mult_2D(A,B,C,transpA,transpB)
  real(kind=wp), intent(in) :: A(:,:), B(:,:)
  real(kind=wp), intent(out) :: C(:,:)
  logical(kind=iwp), intent(in), optional :: transpA, transpB
  logical(kind=iwp) :: transpA_, transpB_
  integer(kind=iwp) :: M, N, K_1, K
# ifdef _ADDITIONAL_RUNTIME_CHECK_
  integer(kind=iwp) :: K_2
# endif
  debug_function_name('mult_2D')

  if (present(transpA)) then
    transpA_ = transpA
  else
    transpA_ = .false.
  end if
  if (present(transpB)) then
    transpB_ = transpB
  else
    transpB_ = .false.
  end if

  M = size(A,merge(1,2,.not. transpA_))
  ASSERT(M == size(C,1))
  N = size(B,merge(2,1,.not. transpB_))
  ASSERT(N == size(C,2))
  K_1 = size(A,merge(2,1,.not. transpA_))
# ifdef _ADDITIONAL_RUNTIME_CHECK_
  K_2 = size(B,merge(1,2,.not. transpB_))
# endif
  ASSERT(K_1 == K_2)
  K = K_1

  ASSERT(wp == r8)
  call dgemm_(merge('T','N',transpA_),merge('T','N',transpB_),M,N,K,One,A,size(A,1),B,size(B,1),Zero,C,size(C,1))
end subroutine mult_2D

!>  @brief
!>    Wrapper around dgemm for matrix-vector multiplication.
!>
!>  @author Oskar Weser
!>
!>  @details
!>
!>  @param[in] A
!>  @param[in] x
!>  @param[out] y The shape of the output array is size(x)
!>  @param[in] transpA Optional argument to specify that A
!>      should be transposed.
subroutine mult_2D_1D(A,x,y,transpA)
  real(kind=wp), intent(in) :: A(:,:), x(:)
  real(kind=wp), intent(out) :: y(:)
  logical(kind=iwp), intent(in), optional :: transpA
  logical(kind=iwp) :: transpA_
  integer(kind=iwp) :: M, N, K

  if (present(transpA)) then
    transpA_ = transpA
  else
    transpA_ = .false.
  end if

  M = size(A,merge(1,2,.not. transpA_))
  ASSERT(M == size(y,1))
  N = 1
  K = size(A,merge(2,1,.not. transpA_))
  ASSERT(M == size(x,1))

  ASSERT(wp == r8)
  call dgemm_(merge('T','N',transpA_),'N',M,N,K,One,A,size(A,1),x,size(x,1),Zero,y,size(y,1))
end subroutine mult_2D_1D

!>  @brief
!>    Wrapper around dgemm for matrix-matrix multiplication with raw memory.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  It is important to note, that it is expected to pass in the
!>  actual vectors and not just the first element.
!>  So if `A_ptr` is the pointer to A in the work array
!>  it is necessary to call it with `Work(A_ptr : )`.
!>
!>  @param[in] A
!>  @param[in] shapeA The shape of A.
!>  @param[in] B
!>  @param[in] shapeB The shape of B.
!>  @param[out] C The shape of the output array is usually
!>      (shapeA(1) * shapeB(2)) which changes of course, if
!>      A or B are transposed.
!>  @param[in] transpA Optional argument to specify that A
!>      should be transposed.
!>  @param[in] transpB Optional argument to specify that B
!>      should be transposed.
subroutine mult_2D_raw(A,shapeA,B,shapeB,C,transpA,transpB)
  real(kind=wp), intent(in), target :: A(*)
  integer(kind=iwp), intent(in) :: shapeA(2)
  real(kind=wp), intent(in), target :: B(*)
  integer(kind=iwp), intent(in) :: shapeB(2)
  real(kind=wp), intent(_OUT_), target :: C(*)
  logical(kind=iwp), intent(in), optional :: transpA, transpB
  logical(kind=iwp) :: transpA_, transpB_
  integer(kind=iwp) :: shapeC(2)
  real(kind=wp), pointer :: ptr_A(:,:), ptr_B(:,:), ptr_C(:,:)

  if (present(transpA)) then
    transpA_ = transpA
  else
    transpA_ = .false.
  end if
  if (present(transpB)) then
    transpB_ = transpB
  else
    transpB_ = .false.
  end if

  shapeC = [merge(shapeA(1),shapeA(2),.not. transpA_),merge(shapeB(2),shapeB(1),.not. transpB_)]

  ptr_A(1:shapeA(1),1:shapeA(2)) => A(1:product(shapeA))
  ptr_B(1:shapeB(1),1:shapeB(2)) => B(1:product(shapeB))
  ptr_C(1:shapeC(1),1:shapeC(2)) => C(1:product(shapeC))

  call mult(ptr_A,ptr_B,ptr_C,transpA_,transpB_)
end subroutine mult_2D_raw

!>  @brief
!>  Diagonalize symmetric A.
!>
!>  @details
!>  Diagonalize A to fullfill `A V(:, j) = lambda(j) V(:, j)`.
!>  Wrapper around BLAS DSYEV.
!>
!>  @param[in] A Symmetric 2D matrix to be diagonalized.
!>  @param[out] V 2D matrix which contains the Eigenvectors.
!>      The j-th column corresponds to the j-th Eigenvalue.
!>  @param[out] lambda 1D vector of Eigenvalues.
!>  @param[in] info Error code. If calling code does not check the error
!>      code, then this routine crashes upon errors.
subroutine sym_diagonalize(A,V,lambda,info)
  real(kind=wp), intent(in) :: A(:,:)
  real(kind=wp), intent(out) :: V(:,:), lambda(:)
  integer(kind=iwp), optional, intent(out) :: info
  integer(kind=iwp), parameter :: do_worksize_query = -1
  integer(kind=iwp) :: info_
  real(kind=wp), allocatable :: work(:)
  real(kind=wp) :: dummy(2), query_result(2)

  ASSERT(symmetric(A))

  V(:,:) = A(:,:)
  info_ = 0
  call dsyev_('V','L',size(V,2),dummy,size(V,1),dummy,query_result,do_worksize_query,info_)

  if (info_ /= 0) then
    if (present(info)) then
      info = info_
    else
      call abort_('Error in diagonalize')
    end if
  end if

  call mma_allocate(work,int(query_result(1)))
  info_ = 0
  call dsyev_('V','L',size(V,2),V,size(V,1),lambda,work,size(work),info_)
  call mma_deallocate(work)

  if (info_ /= 0) then
    if (present(info)) then
      info = info_
    else
      call abort_('Error in diagonalize')
    end if
  end if
end subroutine sym_diagonalize

!>  @brief
!>  Order Eigenvectors by ascending eigenvalues.
subroutine order_eigenvectors(V,lambda)
  real(kind=wp), intent(inout) :: V(:,:), lambda(:)
  integer(kind=iwp), allocatable :: idx(:)
  call mma_allocate(idx,size(lambda))
  idx(:) = argsort(lambda,leq_r)
  V(:,:) = V(:,idx)
  lambda(:) = lambda(idx)
  call mma_deallocate(idx)
end subroutine order_eigenvectors

!>  @brief
!>  Determine the Eigenspaces.
!>
!>  @details
!>  Sort the eigenvalues and collect "equal" eigenvalues together.
!>  Equality of eigenvalues considers floating point error and is determined
!>  by `operator(.isclose.)`.
!>  For this reason all Eigenvalues of the same Eigenspace are replaced
!>  with their mean.
!>
!>  @param[in,out] lambda Eigenvalues are sorted ascendingly and
!>      Eigenvalues of the same Eigenspace (up to floating point error)
!>      are replaced with their mean.
!>  @param[out] dimensions The dimension of each Eigenspace.
!>      size(dimensions) is the number of Eigenspaces, i.e. the number
!>      of distinct Eigenvalues and sum(dimensions) is the number of Eigenvalues.
subroutine determine_eigenspaces(lambda,dimensions)
  real(kind=wp), intent(inout) :: lambda(:)
  integer(kind=iwp), allocatable, intent(out) :: dimensions(:)
  integer(kind=iwp), allocatable :: d_buffer(:)
  integer(kind=iwp) :: i, low
  integer(kind=iwp) :: n_spaces

# ifdef _ADDITIONAL_RUNTIME_CHECK_
  if (any(lambda(2:) < lambda(:size(lambda)-1))) then
    call abort_('Eigenvalues not sorted in'//__FILE__)
  end if
# endif

  call mma_allocate(d_buffer,size(lambda))
  d_buffer(:) = 0

  low = 1
  n_spaces = 1
  do i=1,size(lambda)
    d_buffer(n_spaces) = d_buffer(n_spaces)+1
    if (i+1 <= size(lambda)) then
      if (.not. is_close(lambda(i),lambda(i+1),epsilon(lambda)*1.0e3_wp,1.0e-8_wp)) then
        n_spaces = n_spaces+1
        lambda(low:i) = mean(lambda(low:i))
        low = i+1
      end if
    else
      lambda(low:i) = mean(lambda(low:i))
    end if
  end do

  call mma_allocate(dimensions,n_spaces)
  dimensions(:) = d_buffer(:n_spaces)
  call mma_deallocate(d_buffer)

contains
  pure function mean(X)
    real(kind=wp) :: mean
    real(kind=wp), intent(in) :: X(:)
    mean = sum(X)/size(X)
  end function mean
end subroutine determine_eigenspaces

subroutine base_canonicalize(self,V,lambda)
  class(ParentCanonicalize_t), intent(in) :: self
  real(kind=wp), intent(inout) :: V(:,:), lambda(:)
  !> The norms of the projections
  real(kind=wp), allocatable :: norms_projections(:)
  integer(kind=iwp) :: low, i, j, d, n_new
  integer(kind=iwp), allocatable :: idx(:), dimensions(:)
  real(kind=wp), allocatable :: projections(:,:), ONB(:,:)
  debug_function_name('canonicalize_factory')

  ASSERT(size(V,1) == size(V,2))
  call mma_allocate(projections,size(V,1),size(V,2))
  call mma_allocate(norms_projections,size(projections,2))
  call mma_allocate(idx,size(V,1))

  call order_eigenvectors(V,lambda)
  do j=1,size(V,2)
    V(:,j) = V(:,j)/norm(V(:,j))
  end do

  call determine_eigenspaces(lambda,dimensions)

  call mma_allocate(ONB,size(lambda),maxval(dimensions))

  low = 1
  do j=1,size(dimensions)
    d = dimensions(j)
    ! `self` "knows" which vectors are to be projected
    !  into V(:, low : low + d - 1)
    call self%get_projections(V(:,low:low+d-1),projections)

    do i=1,size(norms_projections)
      norms_projections(i) = norm(projections(:,i))
    end do
    idx(:) = argsort(norms_projections,geq_r)
    call sort(idx(:d),leq_i)

    ! Get the first d projections with the largest overlap.
    do i=1,d
      V(:,low+i-1) = projections(:,idx(i))/norms_projections(idx(i))
    end do

    ! reorthogonalize
    call Gram_Schmidt(V(:,low:low+d-1),d,ONB(:,:d),n_new)
    ASSERT(d == n_new)
    V(:,low:low+d-1) = ONB(:,:d)

    low = low+d
  end do

  call mma_deallocate(norms_projections)
  call mma_deallocate(idx)
  call mma_deallocate(ONB)
  call mma_deallocate(projections)
  call mma_deallocate(dimensions)
end subroutine base_canonicalize

subroutine project_canonical_unit_vectors(self,M,P)
  class(CanonicalBasisCanonicalize_t), intent(in) :: self
  real(kind=wp), intent(in) :: M(:,:)
  real(kind=wp), intent(out) :: P(:,:)
  integer(kind=iwp) :: i, j
  unused_var(self)

  P(:,:) = Zero
  ! calculate projections of basis b_j into eigenvectors v_i:
  ! p_j = sum_i < b_j | v_i > v_i
  ! if b_j are canonical unit vectors, the dot product is the j-th
  ! component of v_i
  do j=1,size(P,2)
    do i=1,size(M,2)
      P(:,j) = P(:,j)+M(j,i)*M(:,i)
    end do
  end do
end subroutine project_canonical_unit_vectors

subroutine project_general_unit_vectors(self,M,P)
  class(GeneralBasisCanonicalize_t), intent(in) :: self
  real(kind=wp), intent(in) :: M(:,:)
  real(kind=wp), intent(out) :: P(:,:)
  integer(kind=iwp) :: i, j

  P(:,:) = Zero
  ! calculate projections of basis b_j into eigenvectors v_i:
  ! p_j = sum_i < b_j | M_i > M_i
  do j=1,size(P,2)
    do i=1,size(M,2)
      P(:,j) = P(:,j)+dot_product_(self%ref(:,j),M(:,i))*M(:,i)
    end do
  end do
end subroutine project_general_unit_vectors

subroutine canonicalize_canonical_basis(V,lambda)
  real(kind=wp), intent(inout) :: V(:,:), lambda(:)
  type(CanonicalBasisCanonicalize_t) :: canonicalizer

  call canonicalizer%canonicalize(V,lambda)
end subroutine canonicalize_canonical_basis

subroutine canonicalize_general(V,lambda,ref)
  real(kind=wp), intent(inout) :: V(:,:), lambda(:)
  real(kind=wp), intent(in), target :: ref(:,:)
  type(GeneralBasisCanonicalize_t) :: canonicalizer

  canonicalizer%ref => ref
  call canonicalizer%canonicalize(V,lambda)
end subroutine canonicalize_general

!>  @brief
!>  Check for floating point equality.
!>
!>  @details
!>  Checks if \f[ | a - b | \leq max(rtol * max(|a|, |b|), atol)  \f].
!>
!>  @param[in] a A real number.
!>  @param[in] b A real number.
!>  @param[in] atol Absolute tolerance.
!>  @param[in] rtol Relative tolerance.
!>
!>  @author
!>    Oskar Weser
! Change name from isclose to is_close, for nvfortran's sake
! (https://forums.developer.nvidia.com/t/nvfortran-wrong-error-compiler-is-confused-by-similar-names/186146)
elemental function is_close(a,b,atol,rtol) result(res)
  real(kind=wp), intent(in) :: a, b
  real(kind=wp), intent(in) :: atol, rtol
  logical(kind=iwp) :: res
  res = abs(a-b) <= max(rtol*max(abs(a),abs(b)),atol)
end function is_close

! Operator functions may only have two arguments.
elemental function isclose_for_operator(a,b) result(res)
  real(kind=wp), intent(in) :: a, b
  logical(kind=iwp) :: res

  ! For real64, the epsilon is 2.3e-16 so that atol becomes roughly 2.3e-14 which is very tight.
  res = is_close(a,b,atol=epsilon(a)*1.0e2_wp,rtol=1.0e-9_wp)
end function isclose_for_operator

!>  @brief
!>    Calculates v1^T S v2.
!>
!>  @details
!>  Calculates \f[ v1^T S v2 \f]
!>  S has to be a symmetric positive definite matrix, which is not
!>  tested.
!>  If S is ommited, it defaults to the unit matrix,
!>  i.e. the Euclidean dot-product.
!>
!>  @param[in] v1 A vector.
!>  @param[in] v2 A vector.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
!>
!>  @author
!>    Oskar Weser
function dot_product_(v1,v2,S) result(dot)
  real(kind=wp), intent(in) :: v1(:), v2(:)
  real(kind=wp), intent(in), optional :: S(:,:)
  real(kind=wp), allocatable :: tmp(:)
  real(kind=wp) :: dot

  if (present(S)) then
    call mma_allocate(tmp,size(v2))
    call mult(S,v2,tmp)
    dot = dot_product(v1,tmp)
    call mma_deallocate(tmp)
  else
    dot = dot_product(v1,v2)
  end if
end function dot_product_

!>  @brief
!>    The induced norm from the dot product given by S.
!>
!>  @details
!>    It is assumed, that S is symmetric and positive definite.
!>
!>  @param[in] v A vector.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
!>
!>  @author
!>    Oskar Weser
function norm(v,S) result(L)
  real(kind=wp), intent(in) :: v(:)
  real(kind=wp), intent(in), optional :: S(:,:)
  real(kind=wp) :: L
  if (present(S)) then
    L = sqrt(dot_product_(v,v,S))
  else
    ! One could use norm2 here, but Sun and PGI compilers don't know this.
    L = sqrt(sum(v**2))
  end if
end function norm

!>  @brief
!>  Check if matrix is symmetric.
!>
!>  @param[in] M A matrix.
pure function symmetric(M)
  logical(kind=iwp) :: symmetric
  real(kind=wp), intent(in) :: M(:,:)
  integer(kind=iwp) :: i, j

  symmetric = .true.
  do j=1,size(M,2)
    do i=j,size(M,1)
      if (.not. (M(i,j) .isclose. M(j,i))) then
        symmetric = .false.
        return
      end if
    end do
  end do
end function symmetric

!>  @brief
!>  Loewdin-orthonormalize basis to get ONB using the overlap matrix S.
!>
!>  @details
!>  If the given basis is linear dependent, then this routine will abort.
!>    For a detailed explanation see \cite szabo_ostlund (p. 143).
!>
!>  @author
!>    Oskar Weser
!>
!>  @param[in] basis A matrix of full rank.
!>  @param[out] ONB The orthonormalized version of basis.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
subroutine Lowdin(basis,ONB,S)
  real(kind=wp), intent(in) :: basis(:,:)
  real(kind=wp), intent(out) :: ONB(:,:)
  real(kind=wp), intent(in), optional :: S(:,:)
  integer(kind=iwp) :: i
  real(kind=wp), allocatable :: U(:,:), s_diag(:), X(:,:), S_transf(:,:), tmp(:,:)

  call mma_allocate(S_transf,size(S,1),size(S,2))
  call mma_allocate(U,size(S,1),size(S,2))
  call mma_allocate(X,size(S,1),size(S,2))
  call mma_allocate(tmp,size(S,1),size(S,2))
  call mma_allocate(s_diag,size(S,2))

  ! Transform AO-overlap matrix S to the overlap matrix of basis.
  ! S_transf = basis^T S basis
  ! We search X that diagonalizes S_transf
  if (present(S)) then
    call mult(S,basis,tmp)
    call mult(basis,tmp,S_transf,transpA=.true.)
  else
    call mult(basis,basis,S_transf,transpA=.true.)
  end if

  call sym_diagonalize(S_transf,U,s_diag)
  call canonicalize(U,s_diag)

  call verify_(all(s_diag > 1.0e-10_wp), 'Linear dependency detected. Lowdin can''t cure it. '// &
                                         'Please use Gram_Schmidt or Canonical orthonormalization.')

  ! X = U s_diag^{-1/2} U^T
  do i=1,size(tmp,2)
    tmp(:,i) = U(:,i)/sqrt(s_diag(i))
  end do
  call mult(tmp,U,X,transpB=.true.)
  ! With this X the overlap matrix S_transf has diagonal form.
  ! X^T basis^T S basis X = 1
  ! We finally have to convert to get the form:
  ! ONB^T S ONB = 1
  call mult(basis,X,ONB)

  call mma_deallocate(tmp)
  call mma_deallocate(s_diag)
  call mma_deallocate(X)
  call mma_deallocate(U)
  call mma_deallocate(S_transf)
end subroutine Lowdin

!>  @brief
!>  Canonical-orthonormalize basis to get ONB using the overlap matrix S.
!>
!>  @details
!>  If the given basis is linear dependent, then this routine will still
!>  work. The out parameter `n_new` returns the number of valid
!>  column vectors. A valid orthonormalized basis is given by ONB(:, : n_new).
!>
!>  For a detailed explanation see \cite szabo_ostlund (p. 143).
!>
!>  @author
!>    Oskar Weser
!>
!>  @param[in] basis A matrix of full rank.
!>  @param[in] n_to_ON Number of columns that should be orthonormalized.
!>  @param[out] ONB The orthonormalized version of basis.
!>  @param[out] n_new The number of columns that could be orthonormalized.
!>     Note that `n_new <= n_to_ON`.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
subroutine Canonical(basis,n_to_ON,ONB,n_new,S)
  real(kind=wp), intent(in) :: basis(:,:)
  integer(kind=iwp), intent(in) :: n_to_ON
  real(kind=wp), intent(out) :: ONB(:,:)
  integer(kind=iwp), intent(out) :: n_new
  real(kind=wp), intent(in), optional :: S(:,:)
  logical(kind=iwp) :: lin_dep_detected
  integer(kind=iwp) :: i
  integer(kind=iwp), allocatable :: idx(:)
  real(kind=wp), allocatable :: U(:,:), s_diag(:), S_transf(:,:), X(:,:), tmp(:,:)

  call mma_allocate(S_transf,size(S,1),size(S,2))
  call mma_allocate(U,size(S,1),size(S,2))
  call mma_allocate(s_diag,size(S,2))
  call mma_allocate(X,size(S,1),size(S,2))
  call mma_allocate(idx,size(S,1))
  call mma_allocate(tmp,size(S,1),size(S,2))

  ! Transform AO-overlap matrix S to the overlap matrix of basis.
  ! We search X that diagonalizes basis^T S basis
  if (present(S)) then
    call mult(S,basis,tmp)
    call mult(basis,tmp,S_transf,transpA=.true.)
  else
    call mult(basis,basis,S_transf,transpA=.true.)
  end if

  call sym_diagonalize(S_transf,U,s_diag)
  call canonicalize(U,s_diag)

  idx(:) = argsort(s_diag,geq_r)
  U(:,:) = U(:,idx)
  s_diag(:) = s_diag(idx)

  i = 0
  lin_dep_detected = .false.
  do while ((.not. lin_dep_detected) .and. (i < n_to_ON))
    if (s_diag(i+1) < 1.0e-10_wp) then
      n_new = i
      lin_dep_detected = .true.
    end if
    i = i+1
  end do
  if (.not. lin_dep_detected) n_new = n_to_ON

  ! X = U s_diag^{-1/2}
  do i=1,n_new
    X(:,i) = U(:,i)/sqrt(s_diag(i))
  end do
  ! With this X the overlap matrix S_transf has diagonal form.
  ! X^T basis^T S basis X = 1
  ! We finally have to convert to get the form:
  ! ONB^T S ONB = 1
  ONB(:,n_new+1:) = basis(:,n_new+1:)
  call mult(basis,X(:,:n_new),ONB(:,:n_new))

  call mma_deallocate(tmp)
  call mma_deallocate(X)
  call mma_deallocate(idx)
  call mma_deallocate(s_diag)
  call mma_deallocate(U)
  call mma_deallocate(S_transf)
end subroutine Canonical

!>  @brief
!>  Gram-Schmidt-orthonormalize basis to get ONB using the overlap matrix S.
!>
!>  @details
!>  If the given basis is linear dependent, then this routine will still
!>  work. The out parameter `n_new` returns the number of valid
!>  column vectors. A valid orthonormalized basis is given by ONB(:, : n_new).
!>
!>  For a detailed explanation see \cite szabo_ostlund (p. 143).
!>
!>  @author
!>    Oskar Weser
!>
!>  @param[in] basis A matrix of full rank.
!>  @param[in] n_to_ON Number of columns that should be orthonormalized.
!>  @param[out] ONB The orthonormalized version of basis.
!>  @param[out] n_new The number of columns that could be orthonormalized.
!>     Note that `n_new <= n_to_ON`.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
subroutine Gram_Schmidt(basis,n_to_ON,ONB,n_new,S)
  real(kind=wp), intent(in) :: basis(:,:)
  integer(kind=iwp), intent(in) :: n_to_ON
  real(kind=wp), target, intent(out) :: ONB(:,:)
  integer(kind=iwp), intent(out) :: n_new
  real(kind=wp), intent(in), optional :: S(:,:)
  real(kind=wp) :: L
  integer(kind=iwp) :: i, j
  logical(kind=iwp) :: lin_dep_detected, improve_solution
  real(kind=wp), allocatable :: previous(:), correction(:), v(:)
  real(kind=wp), pointer :: curr(:)

  call mma_allocate(previous,size(basis,1))
  call mma_allocate(correction,size(basis,1))
  call mma_allocate(v,size(basis,1))

  n_new = 0
  ONB(:,n_to_ON+1:) = basis(:,n_to_ON+1:)
  do i=1,n_to_ON
    curr => ONB(:,n_new+1)
    curr = basis(:,i)

    improve_solution = .true.
    lin_dep_detected = .false.
    do while (improve_solution .and. (.not. lin_dep_detected))
      correction = Zero
      if (present(S)) then
        call mult(S,curr,v)
      else
        v(:) = curr(:)
      end if

      do j=1,n_new
        correction(:) = correction(:)+ONB(:,j)*dot_product(ONB(:,j),v)
      end do
      curr = curr-correction
      improve_solution = norm(correction,S=S) > 0.1_wp
      L = norm(curr,S=S)
      lin_dep_detected = L < 1.0e-10_wp
      if (.not. lin_dep_detected) then
        curr = curr/L
      end if
      if (.not. (improve_solution .or. lin_dep_detected)) then
        n_new = n_new+1
      end if
    end do
  end do
  ONB(:,n_new+1:n_to_ON) = basis(:,n_new+1:n_to_ON)

  call mma_deallocate(v)
  call mma_deallocate(correction)
  call mma_deallocate(previous)
end subroutine Gram_Schmidt

!> @brief
!>    Print error message and abort.
subroutine abort_(message)
  character(len=*), intent(in) :: message
  call WarningMessage(2,message)
  call pure_abort()
end subroutine abort_

!> @brief
!>    Abort.
pure subroutine pure_abort()
  ! I know, that these functions are not pure, but we are aborting anyway.
  interface
    pure subroutine Abend()
    end subroutine Abend
  end interface
  call Abend()
end subroutine pure_abort

!> @brief
!>    Runtime check, that is not switched off in Debug mode
subroutine verify_(test_expression,message)
  logical(kind=iwp), intent(in) :: test_expression
  character(len=*), intent(in) :: message
  if (.not. test_expression) then
    call abort_(message)
  end if
end subroutine verify_

end module linalg_mod

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Jonas Bostrom                                          *
************************************************************************
      Subroutine Mult_RijK_QKL(iSO,nBas_aux,nIrrep)
**************************************************************************
*     Author: Jonas Bostrom
*
*     Purpose: Computation of the DF coefficient vectors in MO-basis.
*
*     Equation:   C(il,K)  =  sum_J  R(il,J) * Q(K,J)
*
*     Input:
*            iSO : alpha (iSO=1) or beta (iSO=2) orbitals
*            nBas_aux : number of aux bsfs in each irrep.
*            nIrrep : number of irreps.
**************************************************************************
      use pso_stuff
      Implicit Real*8 (a-h,o-z)
      Integer nBas_Aux(1:nIrrep), nVec(1:nIrrep)
      Character  Fname*6, Fname2*6, Name_Q*6
      Character*50 CFmt
      Character*13 SECNAM
      Parameter (SECNAM = 'MULT_RIJK_QKL')
      Logical timings
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"
#include "exterm.fh"
*#define _DEBUGPRINT_
*#define _CD_TIMING_
#ifdef _CD_TIMING_
#include "temptime.fh"
#endif
#include "para_info.fh"
*
      parameter ( N2 = InfVec_N2 )
      COMMON  /CHOTIME /timings
*
*************************
*     Define some indeces
      MulD2h(i,j) = iEOR(i-1,j-1) + 1
      InfVec(i,j,k) = iWork(ip_InfVec-1+MaxVec*N2*(k-1)+MaxVec*(j-1)+i)
*************************

      CALL CWTime(TotCPU1,TotWall1)

      Do i = 1, nIrrep
         nVec(i) = NumCho(i)
      End Do
      Call GAIGOP(nVec,nIrrep,'+')

      nTotCho = 0
      MaxCho = 0
      MaxLocCho = 0
      Do jSym = 1, nIrrep
         nTotCho = nTotCho + nVec(jSym)
         MaxCho = Max(MaxCho,nVec(jSym))
         MaxLocCho= Max(MaxLocCho,NumCho(jSym))
         Do iSym = 1, nIrrep
            iAdrCVec(jSym,iSym,iSO) = 0
         End Do
      End Do


*     Loop over the first cholesky symmetry
*
      kCount=0
      Do jSym = 1, nIrrep
*
***      Check so the symmetry contains vectors
*-------------------------------------------------
         NumCV = NumCho(jSym)
         NumAux = nBas_Aux(jSym)
         If(jSym.eq.1) NumAux = NumAux - 1
*     Save the number of auxiliary basis functions to be
*     accessed later
         NumAuxVec(jSym) = NumAux


         Call GAIGOP_SCAL(NumCV,'max')
         If(NumCV .lt. 1) goto 1000
*
         nTotFIorb = 0
         MaxMOprod = 0
         MaxMOprodR = 0
         Do iSym = 1, nIrrep
            kSym = MulD2h(JSym,iSym)

            nTotFIorb=nTotFIorb + nIJ1(iSym,kSym,iSO)
            MaxMOprod = Max(MaxMOprod,nIJ1(iSym,kSym,iSO))
            MaxMOProdR = Max(MaxMOprodR,nIJR(iSym,kSym,iSO))
         End Do
*
         Call GetMem('MemChk','Max','Real',iDum,MemMax)
         nJvec1 = (MemMax-NumAux*MaxMOprod)/(MaxMOprod + NumAux)
         If(nJvec1.lt.1) Then
            Write(6,*) 'Too little memory in:',SECNAM
            Call Abend
         End If
         nJvec1 = min(nJvec1,NumCho(jSym))
         nJbat = NumCho(jSym)/nJvec1
         iRest = mod(NumCho(jSym),nJvec1)
         If(iRest.ne.0) Then
            nJbat = nJbat+1
            nJvecLast = iRest
         Else
            nJvecLast = nJvec1
         End If
*
         If(Is_Real_Par()) Then
            iFirstCho = InfVec(1,5,jSym)
         Else
            iFirstCho = 1
         End If
*
         l_QVector = nJVec1*NumAux
         l_RVector = MaxMOprod*nJVec1
         l_CVector = MaxMOprodR*NumAux
*
         Call GetMem('Q_Vector','Allo','Real',ip_QVector,l_QVector)
         Call GetMem('R_Vector','Allo','Real',ip_RVector,l_RVector)
         Call GetMem('C_Vector','Allo','Real',ip_CVector,l_CVector)
*

         iSeed2 = 8
         LuCVec = IsFreeUnit(iSeed2)
         If (iSO.eq.1) Then
            Write(Fname2,'(A4,I1,I1)') 'CVEA',jSym
         ElseIf (iSO.eq.2) Then
            Write(Fname2,'(A4,I1,I1)') 'CVEB',jSym
         EndIf
         Call DANAME_MF_WA(LuCVec,Fname2)
         iAdrC = 0
*
***   Get Q Vectors from Disk
*----------------------------------
      Do iSym = 1, nIrrep
         lSym = MulD2h(iSym,jSym)
*
         If(nIJ1(iSym,lSym,iSO).lt.1) Go To 2000
         Call FZero(Work(ip_CVector),l_CVector)
         Do iJBat = 1, nJBat
            If(iJBat.eq.nJBat) Then
               njVec = nJVecLast
            Else
               nJvec = nJvec1
            End If
*
            iSeed=55+jSym-1
            Lu_Q=IsFreeUnit(iSeed)
            Write(Name_Q,'(A4,I2.2)') 'QVEC',jSym-1
            Call DaName_MF_WA(Lu_Q,Name_Q)
            l_Q = nJvec*NumAux
            iAdrQ=(iFirstCho-1)*NumAux + (iJBat-1)*nJVec*NumAux
            Call dDaFile(Lu_Q,2,Work(ip_Qvector),l_Q,iAdrQ)

#ifdef _DEBUGPRINT_
            Call RecPrt('Q-vectors',' ',Work(ip_QVector),
     &                  nJVec,NumAux)
#endif
*
*
            iSeed=7
            LuRVec = IsFreeUnit(iSeed)
            If (iSO.eq.1) Then
               Write(Fname,'(A4,I1,I1)') 'CHTA',iSym,lSym
            ElseIf (iSO.eq.2) Then
               Write(Fname,'(A4,I1,I1)') 'CHTB',iSym,lSym
            EndIf
            Call DANAME_MF_WA(LuRVec,Fname)
*
***         Loop over all cholesky vectors on all nodes
*------------------------------------------------------

*
*                 Get R-Vectors from disk
*-------------------------------------------

            iAdrR = nIJ1(iSym,lSym,iSO)*nJVec1*(iJBat-1)
            l_RVec = nJvec * nIJ1(iSym,lSym,iSO)
            Call dDaFile(LuRVec,2,Work(ip_RVector),
     &                   l_RVec,iAdrR)

            Call dGemm_('N','T',nIJ1(iSym,lSym,iSO),NumAux,nJVec,1.0d0,
     &                 Work(ip_RVector),nIJ1(iSym,lSym,iSO),
     &                 Work(ip_QVector),NumAux,0.0d0,
     &                 Work(ip_CVector),nIJ1(iSym,lSym,iSO))
         End Do



#ifdef _DEBUGPRINT_
         Write (6,*) 'jSym=',jSym
         Call RecPrt('R-Vectors',' ',Work(ip_RVector),
     &               nIJ1(iSym,lSym,iSO),NumAux)
         Call RecPrt('C-Vectors',' ',Work(ip_CVector),
     &               nIJ1(iSym,lSym,iSO),NumAux)
#endif
         If ((.not.lSA).and.(iSym.eq.lSym)) Then
            Do iAux = 1, NumAux
               index = -1
               Do i = 1, nChOrb(iSym-1,iSO)
                  index = index+i
                  index2 = index + (iAux-1)*nIJ1(iSym,lSym,iSO)
                  Work(ip_Cvector+index2) =
     &                 Work(ip_Cvector+index2)/sqrt(2.0d0)
               End Do
            End Do
         End If

         Call DaClos(Lu_Q)
         Call DACLOS(LuRVec)
*
 2000    Continue
*
         Call GADGOP(Work(ip_CVector),l_CVector,'+')
         iAdrCVec(jSym,iSym,iSO) = iAdrC
         Call dDaFile(LuCVec,1,Work(ip_CVector),
     &                nIJ1(iSym,lSym,iSO)*NumAux,iAdrC)
         If(nIJ1(iSym,lSym,iSO) .lt. nIJR(iSym,lSym,iSO)) Then
            iAdrC = iAdrC +
     &          (nIJR(iSym,lSym,iSO)-nIJ1(iSym,lSym,iSO))*NumAux
         End If

         End Do !iSym
*
         Call GetMem('C_Vector','Free','Real',ip_CVector,l_CVector)
         Call GetMem('R_Vector','Free','Real',ip_RVector,l_RVector)
         Call GetMem('Q_Vector','Free','Real',ip_QVector,l_QVector)
*
         Call DACLOS(LuCVec)
 1000    Continue

      End Do  ! jSym
*
      CALL CWTime(TotCPU2,TotWall2)
      TotCPU = TotCPU2 - TotCPU1
      TotWall= TotWall2 - TotWall1
#ifdef _CD_TIMING_
      rMult_CPU = TOTCPU
      rMult_Wall = TOTWALL
#endif
*
      If(timings)then

      CFmt='(2x,A)'
      Write(6,*)
      Write(6,CFmt)'Cholesky Gradients timing from '//SECNAM
      Write(6,CFmt)'----------------------------------------'
      Write(6,*)
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,CFmt)'                                CPU       WALL   '
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
         Write(6,'(2x,A26,2f10.2)')'TOTAL                            '
     &                           //'         ',TOTCPU,TOTWALL
      Write(6,CFmt)'- - - - - - - - - - - - - - - - - - - - - - - - -'
      Write(6,*)

      endif

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine plot_MH_no_Exp(nH,H,nTempMagn,TempMagn,MHcalc)

use Constants, only: Zero, Five, Six
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nH, nTempMagn
real(kind=wp), intent(in) :: H(nH), TempMagn(nTempMagn), MHcalc(nH,nTempMagn)
integer(kind=iwp) :: file_number, file_size, ic, iErr, iH, ik, iSeed = 0, iTempMagn, Length, LuData, LuPlt
real(kind=wp) :: gnuplot_version, hmax, hmin, MHmax, MHmax_calc, MHmin, MHmin_calc, r
character(len=1023) :: gnuplot_CMD, realname_dat, realname_eps, realname_plt, realname_png
character(len=300) :: cdummy, datafile, epsfile, fmtline, imagefile, line1, line2, plotfile
logical(kind=iwp) :: execute_gnuplot_cmd, file_exist, is_file_open
character(len=*), parameter :: color(111) = ['#ffffff','#000000','#a0a0a0','#ff0000','#00c000','#0080ff','#c000ff','#00eeee', &
                                             '#c04000','#c8c800','#4169e1','#ffc020','#008040','#c080ff','#306080','#8b0000', &
                                             '#408000','#ff80ff','#7fffd4','#a52a2a','#ffff00','#40e0d0','#000000','#1a1a1a', &
                                             '#333333','#4d4d4d','#666666','#7f7f7f','#999999','#b3b3b3','#c0c0c0','#cccccc', &
                                             '#e5e5e5','#ffffff','#f03232','#90ee90','#add8e6','#f055f0','#e0ffff','#eedd82', &
                                             '#ffb6c1','#afeeee','#ffd700','#00ff00','#006400','#00ff7f','#228b22','#2e8b57', &
                                             '#0000ff','#00008b','#191970','#000080','#0000cd','#87ceeb','#00ffff','#ff00ff', &
                                             '#00ced1','#ff1493','#ff7f50','#f08080','#ff4500','#fa8072','#e9967a','#f0e68c', &
                                             '#bdb76b','#b8860b','#f5f5dc','#a08020','#ffa500','#ee82ee','#9400d3','#dda0dd', &
                                             '#905040','#556b2f','#801400','#801414','#804014','#804080','#8060c0','#8060ff', &
                                             '#808000','#ff8040','#ffa040','#ffa060','#ffa070','#ffc0c0','#ffff80','#ffffc0', &
                                             '#cdb79e','#f0fff0','#a0b6cd','#c1ffc1','#cdc0b0','#7cff40','#a0ff20','#bebebe', &
                                             '#d3d3d3','#d3d3d3','#a0a0a0','#a0b6cd','#000000','#1a1a1a','#333333','#4d4d4d', &
                                             '#666666','#7f7f7f','#999999','#b3b3b3','#cccccc','#e5e5e5','#ffffff']
integer(kind=iwp), external :: AixRm, IsFreeUnit
real(kind=wp), external :: Random_Molcas

#include "macros.fh"

if (iSeed == 0) call GetSeed(iSeed)

iErr = 0
hmin = Zero
hmax = Zero
MHmin_calc = Zero
MHmax_calc = Zero
MHmin = Zero
MHmax = Zero
hmin = minval(H(:))-0.02_wp*maxval(H(:))
hmax = maxval(H(:))+0.02_wp*maxval(H(:))
MHmin_calc = minval(MHcalc)
MHmax_calc = maxval(MHcalc)
MHmin = MHmin_calc-0.01_wp*MHmax_calc
MHmax = MHmax_calc+0.01_wp*MHmax_calc

#ifdef _DEBUGPRINT_
write(u6,*) 'nH        = ',nH
write(u6,*) 'hmin      = ',hmin
write(u6,*) 'hmax      = ',hmax
write(u6,*) 'MHmin_calc= ',MHmin_calc
write(u6,*) 'MHmax_calc= ',MHmax_calc
write(u6,*) 'MHmin     = ',MHmin
write(u6,*) 'MHmax     = ',MHmax
do iH=1,nH
  write(u6,*) H(iH),(MHcalc(iH,iTempMagn),iTempMagn=1,nTempMagn)
end do
#endif

! generate the GNUPLOT script in the $WorkDir
line1 = ' '
line2 = ' '
gnuplot_CMD = ' '
file_exist = .false.
is_file_open = .false.
file_size = 0
execute_gnuplot_cmd = .false.
gnuplot_version = Zero

! check if the file lineOUT exists
inquire(file='lineOUT',exist=file_exist,opened=is_file_open,number=file_number)

if (file_exist) then
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'file "lineOUT" exists in WorkDir'
# endif
  if (is_file_open) then
#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'file "lineOUT" is opened'
#   endif
    ! close the file:
    close(unit=file_number,status='DELETE')
  end if
  ! delete the file
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'deleting the file...'
# endif
  iErr = AixRm('lineOUT')
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
else
  write(u6,'(A)') 'file "lineOUT" does not exist in WorkDir'
# endif
end if

! find the gnuplot
#ifdef _DEBUGPRINT_
write(u6,'(A)') 'inquire which GNUPLOT'
#endif

call systemf('which gnuplot >> lineOUT',iErr)
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif

inquire(file='lineOUT',exist=file_exist,opened=is_file_open,number=file_number,size=file_size)

#ifdef _DEBUGPRINT_
write(u6,*) 'File_number =',file_number
write(u6,*) 'Is_file_open=',is_file_open
write(u6,*) 'File_exist  =',file_exist
write(u6,*) 'File_size   =',file_size
#endif

if (file_exist) then
  if (file_size > 0) then
#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'new file "lineOUT" exists in WorkDir'
#   endif

    file_number = IsFreeUnit(103)
    call molcas_open(file_number,'lineOUT')

    read(file_number,'(A)') line1

#   ifdef _DEBUGPRINT_
    write(u6,*) 'line1=',line1
    write(u6,*) trim(line1)
#   endif
    line2 = trim(line1)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'line2=',line2
#   endif

    close(file_number)
#   ifdef _DEBUGPRINT_
    write(u6,*) 'Closing lineOUT file'
    call xFlush(u6)
#   endif
    execute_gnuplot_cmd = .true.
  else
    ! file_size =0
    write(u6,'(A)') 'file "lineOUT" has a size=0. gnuplot was not found on the system.'
    write(u6,'(A)') 'plots will not be created.'
  end if
else
  write(u6,'(A)') 'file "lineOUT" does not exist in WorkDir'
end if
! remove file "lineOUT"
iErr = AixRm('lineOUT')
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif
!-----------------------------------------------------------------------

! check the version of the gnuplot:
if (execute_gnuplot_cmd) then
# ifdef _DEBUGPRINT_
  write(u6,'(A)') 'inquire which version of GNUPLOT is installed'
# endif
  ! attempt to execute the script
  write(gnuplot_CMD,'(2A)') trim(line2),' --version > lineOUT'
# ifdef _DEBUGPRINT_
  write(u6,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
# endif
  call systemf(gnuplot_CMD,iErr)
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif
  file_number = IsFreeUnit(102)
  call molcas_open(file_number,'lineOUT')
  read(file_number,*) cdummy,gnuplot_version
  unused_var(cdummy)
# ifdef _DEBUGPRINT_
  write(u6,'(A,F4.1)') 'gnuplot_version = ',gnuplot_version
# endif
  if (abs(gnuplot_version) < 0.1_wp) execute_gnuplot_cmd = .false.
  close(file_number)
  ! remove file "lineOUT"
  iErr = AixRm('lineOUT')
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif
end if

!-----------------------------------------------------------------------
! get the true real names of the files on disk:
write(datafile,'(3A)') 'MH.dat'
write(imagefile,'(3A)') 'MH.png'
write(epsfile,'(3A)') 'MH.eps'
write(plotfile,'(3A)') 'MH.plt'
call prgmtranslate(datafile,realname_dat,Length)
call prgmtranslate(imagefile,realname_png,Length)
call prgmtranslate(epsfile,realname_eps,Length)
call prgmtranslate(plotfile,realname_plt,Length)
#ifdef _DEBUGPRINT_
write(u6,'(3A)') 'realname_dat=',trim(realname_dat)
write(u6,'(3A)') 'realname_png=',trim(realname_png)
write(u6,'(3A)') 'realname_eps=',trim(realname_eps)
write(u6,'(3A)') 'realname_plt=',trim(realname_plt)
#endif

!-----------------------------------------------------------------------
! create the file "MH.dat"
inquire(file=datafile,exist=file_exist,opened=is_file_open,number=file_number)
if (file_exist) iErr = AixRm(trim(datafile))
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif
LuData = IsFreeUnit(104)
call molcas_open(LuData,datafile)
#ifdef _DEBUGPRINT_
write(u6,*) 'Opening "'//trim(datafile)//'" file'
write(u6,*) 'Opening "'//trim(realname_dat)//'" file'
#endif
write(fmtline,'(A,i0,A)') '(',nTempMagn+1,'ES24.14)'
do iH=1,nH
  write(LuData,fmtline) H(iH),(MHcalc(iH,iTempMagn),iTempMagn=1,nTempMagn)
end do
#ifdef _DEBUGPRINT_
write(u6,*) 'Writing into the "'//trim(datafile)//'"file'
write(u6,*) 'Writing into the "'//trim(realname_dat)//'"file'
#endif
close(LuData)
#ifdef _DEBUGPRINT_
write(u6,*) 'Closing the "'//trim(datafile)//'" file'
write(u6,*) 'Closing the "'//trim(realname_dat)//'" file'
call xFlush(u6)
#endif

!-----------------------------------------------------------------------
! generate the GNUPLOT script in the $WorkDir
inquire(file=plotfile,exist=file_exist,opened=is_file_open,number=file_number)
if (file_exist) iErr = AixRm(trim(plotfile))
#ifdef _DEBUGPRINT_
write(u6,*) 'iErr = ',iErr
#endif
LuPlt = IsFreeUnit(105)
call molcas_open(LuPlt,plotfile)
#ifdef _DEBUGPRINT_
write(u6,*) 'Opening "'//trim(plotfile)//'" file'
write(u6,*) 'Opening "'//trim(realname_plt)//'" file'
#endif

if (gnuplot_version < Five) then
  !===  GNUPLOT VERSION 4 and below ==>>  generate EPS
  write(LuPlt,'(A)') 'set terminal postscript eps enhanced color  size 3.0, 2.0 font "arial, 10"'
  write(LuPlt,'(A)') 'set output "'//trim(realname_eps)//'" '
  write(LuPlt,'(A)') 'set grid'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Axes'
  write(LuPlt,'(A)') '  set xlabel "Magnetic Field / tesla" font "Arial,14"'
  write(LuPlt,'(A)') '  set ylabel "M / {/Symbol m}_{B}" font "Arial,14"'
  write(LuPlt,'(A)')
  write(LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[',hmin,':',hmax,']'
  write(LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',MHmin,':',MHmax,']'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Tics for axes'
  write(LuPlt,'(A)') '  set xtics nomirror'
  write(LuPlt,'(A)') '  set ytics nomirror'
  write(LuPlt,'(A)') '  set mxtics'
  write(LuPlt,'(A)') '  set mytics'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Margins'
  write(LuPlt,'(A)') '  set bmargin at screen 0.20'
  write(LuPlt,'(A)') '  set lmargin at screen 0.15'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# legend'
  write(LuPlt,'(A)') '  set key right bottom'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# actual plotting'
  do iTempMagn=1,nTempMagn
    ik = iTempMagn+1
    r = Random_Molcas(iSeed)
    ic = floor(size(color)*r)+lbound(color,1)
    if ((iTempMagn == 1) .and. (nTempMagn > 1)) then
      write(LuPlt,'(A,i0,A,F7.3,A)') 'plot "'//trim(realname_dat)//'" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)// &
                                     '"  title "Calc. M at T=',TempMagn(iTempMagn),'K.", \'
    else if ((iTempMagn == 1) .and. (nTempMagn == 1)) then
      write(LuPlt,'(A,i0,A,F7.3,A)') 'plot "'//trim(realname_dat)//'" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)// &
                                     '"  title "Calc. M at T=',TempMagn(iTempMagn),'K."'
    end if
    if ((iTempMagn < nTempMagn) .and. (iTempMagn /= 1)) &
      write(LuPlt,'(A,i0,A,F7.3,A)') '     "'//trim(realname_dat)//'" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)// &
                                     '"  title "Calc. M at T=',TempMagn(iTempMagn),'K.", \'
    if ((iTempMagn == nTempMagn) .and. (nTempMagn > 1)) &
      write(LuPlt,'(A,i0,A,F7.3,A)') '     "'//trim(realname_dat)//'" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)// &
                                     '"  title "Calc. M at T=',TempMagn(iTempMagn),'K."'
  end do

else if ((gnuplot_version >= Five) .and. (gnuplot_version < Six)) then
  !===  GNUPLOT VERSION 5 and above ==>>  generate PNG
  write(LuPlt,'(A)') 'set terminal pngcairo transparent enhanced font "arial,10" fontscale 4.0 size 1800, 1200'
  write(LuPlt,'(A)') 'set output "'//trim(realname_png)//'" '
  write(LuPlt,'(A)') 'set grid'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Axes'
  write(LuPlt,'(A)') '  set xlabel "Magnetic Field / tesla" font "Arial,14"'
  write(LuPlt,'(A)') '  set ylabel "M / {/Symbol m}_{B}" font "Arial,14"'
  write(LuPlt,'(A)')
  write(LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[',hmin,':',hmax,']'
  write(LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',MHmin,':',MHmax,']'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Tics for axes'
  write(LuPlt,'(A)') '  set xtics nomirror'
  write(LuPlt,'(A)') '  set ytics nomirror'
  write(LuPlt,'(A)') '  set mxtics'
  write(LuPlt,'(A)') '  set mytics'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# Margins'
  write(LuPlt,'(A)') '  set bmargin at screen 0.20'
  write(LuPlt,'(A)') '  set lmargin at screen 0.15'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# legend'
  write(LuPlt,'(A)') '  set key right bottom'
  write(LuPlt,'(A)')
  write(LuPlt,'(A)') '# actual plotting'
  do iTempMagn=1,nTempMagn
    ik = iTempMagn+1
    r = Random_Molcas(iSeed)
    ic = floor(size(color)*r)+lbound(color,1)
    if ((iTempMagn == 1) .and. (nTempMagn > 1)) then
      write(LuPlt,'(A,i0,A,F7.3,A)') 'plot "'//trim(realname_dat)//'" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)// &
                                     '"  title "Calc. M at T=',TempMagn(iTempMagn),'K.", \'
    else if ((iTempMagn == 1) .and. (nTempMagn == 1)) then
      write(LuPlt,'(A,i0,A,F7.3,A)') 'plot "'//trim(realname_dat)//'" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)// &
                                     '"  title "Calc. M at T=',TempMagn(iTempMagn),'K."'
    end if
    if ((iTempMagn < nTempMagn) .and. (iTempMagn /= 1)) &
      write(LuPlt,'(A,i0,A,F7.3,A)') '     "'//trim(realname_dat)//'" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)// &
                                     '"  title "Calc. M at T=',TempMagn(iTempMagn),'K.", \'
    if ((iTempMagn == nTempMagn) .and. (nTempMagn > 1)) &
      write(LuPlt,'(A,i0,A,F7.3,A)') '     "'//trim(realname_dat)//'" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)// &
                                     '"  title "Calc. M at T=',TempMagn(iTempMagn),'K."'
  end do

else
  write(u6,*) 'GNUPLOT has version: ',gnuplot_version
  write(u6,*) 'This version of GNUPLOT is not known and thus, unsupported.'
  execute_gnuplot_cmd = .false.
end if
write(LuPlt,'(A)')
close(LuPlt)

if (execute_gnuplot_cmd) then
  ! attempt to execute the script
# ifdef _DEBUGPRINT_
  file_exist = .false.
  write(u6,*) trim(realname_plt)
  inquire(file=trim(realname_plt),exist=file_exist,opened=is_file_open,number=file_number)
  if (file_exist) then
    write(u6,'(A,i0,A)') 'File "'//trim(realname_plt)//'" exists.'
  else
    write(u6,'(A,i0,A)') 'File "'//trim(realname_plt)//'" does not exist.'
  end if
  file_exist = .false.
  write(u6,*) trim(realname_dat)
  inquire(file=trim(realname_dat),exist=file_exist,opened=is_file_open,number=file_number)
  if (file_exist) then
    write(u6,'(A,i0,A)') 'File "'//trim(realname_dat)//'" exists.'
  else
    write(u6,'(A,i0,A)') 'File "'//trim(realname_dat)//'" does not exist.'
  end if
# endif

  write(gnuplot_CMD,'(5A)') trim(line2),' < ',trim(realname_plt)
# ifdef _DEBUGPRINT_
  write(u6,'(A,A)') 'gnuplot_CMD=',trim(gnuplot_CMD)
# endif

  call systemf(gnuplot_CMD,iErr)
# ifdef _DEBUGPRINT_
  write(u6,*) 'iErr = ',iErr
# endif

  if (gnuplot_version < Five) then
    file_exist = .false.
    inquire(file=trim(realname_eps),exist=file_exist,opened=is_file_open,number=file_number)
    if (file_exist) then
      write(u6,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was created in Working directory.'
    else
      write(u6,'(A,i0,A)') 'File "'//trim(realname_eps)//'" was NOT created in Working directory.'
    end if
  else
    file_exist = .false.
    inquire(file=trim(realname_png),exist=file_exist,opened=is_file_open,number=file_number)
    if (file_exist) then
      write(u6,'(A,i0,A)') 'File "'//trim(realname_png)//'" was created in Working directory.'
    else
      write(u6,'(A,i0,A)') 'File "'//trim(realname_png)//'" was NOT created in Working directory.'
    end if
  end if
end if

return

end subroutine plot_MH_no_Exp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_MCA_INT_1_DBG2()
C
C     Purpose: test symmetry of integral matrix.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*18 SECNAM
      PARAMETER (SECNAM = 'CHO_MCA_INT_1_DBG2')

      LOGICAL PRTINT
      PARAMETER (PRTINT = .FALSE.)

      PARAMETER (THR = 1.0D-14)

      INTEGER  CHO_ISAOSH
      EXTERNAL CHO_ISAOSH

      MULD2H(I,J)=IEOR(I-1,J-1)+1
      ITRI(I,J) = MAX(I,J)*(MAX(I,J)-3)/2 + I + J
      NBSTSH(I)=IWORK(ip_NBSTSH-1+I)
      ISP2F(I)=IWORK(ip_iSP2F-1+I)

      WRITE(LUPRI,*)
      WRITE(LUPRI,*)
      WRITE(LUPRI,*) SECNAM,': testing integral matrix symmetry'
      WRITE(LUPRI,*)

C     Force computation of full shell quadruple.
C     ------------------------------------------

      IF (IFCSEW .NE. 1) THEN
         WRITE(LUPRI,*) SECNAM,': WARNING: resetting IFCSEW from ',
     &                  IFCSEW,' to 1.'
         IFCSEW = 1
      END IF

      LINTT = 2*MX2SH*MX2SH
      CALL GETMEM('Int1.dbg2.1','ALLO','REAL',KINT1,LINTT)
      CALL GETMEM('Int1.dbg2.2','MAX ','REAL',KSEW,LSEW)
      CALL XSETMEM_INTS(LSEW)

      NTST = 0
      NERR = 0
      DO ISHLAB = 1,NNSHL

         CALL CHO_INVPCK(ISP2F(ISHLAB),ISHLA,ISHLB,.TRUE.)
         IF (ISHLB .EQ. ISHLA) THEN
            NUMAB = NBSTSH(ISHLA)*(NBSTSH(ISHLB) + 1)/2
         ELSE
            NUMAB = NBSTSH(ISHLA)*NBSTSH(ISHLB)
         END IF

         DO ISHLCD = 1,ISHLAB

            CALL CHO_INVPCK(ISP2F(ISHLCD),ISHLC,ISHLD,.TRUE.)
            IF (ISHLD .EQ. ISHLC) THEN
               NUMCD = NBSTSH(ISHLC)*(NBSTSH(ISHLD) + 1)/2
            ELSE
               NUMCD = NBSTSH(ISHLC)*NBSTSH(ISHLD)
            END IF
            LINT  = NUMCD*NUMAB
            KINT2 = KINT1 + LINT

C           Calculate integrals (CD|AB).
C           ----------------------------

            CALL CHO_DZERO(WORK(KINT1),LINT)
            CALL CHO_MCA_INT_1(ISHLCD,ISHLAB,WORK(KINT1),LINT,
     &                         PRTINT)

C           Calculate integrals (AB|CD).
C           ----------------------------

            CALL CHO_DZERO(WORK(KINT2),LINT)
            CALL CHO_MCA_INT_1(ISHLAB,ISHLCD,WORK(KINT2),LINT,
     &                         PRTINT)

C           Compare.
C           --------

            ITST = 0
            IERR = 0
            CALL CHO_MCA_INT1_1_DBG2_CMP(WORK(KINT1),WORK(KINT2),
     &                                  NUMCD,NUMAB,ERRMIN,ICDMN,IABMN,
     &                                  ERRMAX,ICDMX,IABMX,ITST,IERR,
     &                                  THR,.FALSE.,LUPRI)
            NTST = NTST + ITST
            NERR = NERR + IERR

            WRITE(LUPRI,*) '#sym. errors for ',
     &      '(',ISHLC,ISHLD,'|',ISHLA,ISHLB,'): ',IERR,
     &      ' #tests: ',ITST
            IF (IERR .NE. 0) THEN
c              WRITE(LUPRI,*) '    Here is the shell quadruple in INT1:'
c              CALL CHO_OUTPUT(WORK(KINT1),1,NUMCD,1,NUMAB,NUMCD,NUMAB,
c    &                         1,LUPRI)
c              WRITE(LUPRI,*) '    And the shell quadruple in INT2:'
c              CALL CHO_OUTPUT(WORK(KINT1),1,NUMAB,1,NUMCD,NUMAB,NUMCD,
c    &                         1,LUPRI)
               DO IB = 1,NBSTSH(ISHLB)
                  ISYMB = CHO_ISAOSH(IB,ISHLB)
                  DO IA = 1,NBSTSH(ISHLA)
                     ISYMA  = CHO_ISAOSH(IA,ISHLA)
                     ISYMAB = MULD2H(ISYMA,ISYMB)
                     IF (ISHLB .EQ. ISHLA) THEN
                        IAB = ITRI(IA,IB)
                     ELSE
                        IAB = NBSTSH(ISHLA)*(IB - 1) + IA
                     END IF
                     DO ID = 1,NBSTSH(ISHLD)
                        ISYMD = CHO_ISAOSH(ID,ISHLD)
                        DO IC = 1,NBSTSH(ISHLC)
                           ISYMC = CHO_ISAOSH(IC,ISHLC)
                           ISYMCD = MULD2H(ISYMC,ISYMD)
                           IF (ISHLC .EQ. ISHLD) THEN
                              ICD = ITRI(IC,ID)
                           ELSE
                              ICD = NBSTSH(ISHLC)*(ID - 1) + IC
                           END IF
                           IABCD = NUMCD*(IAB - 1) + ICD
                           TST   = ABS(WORK(KINT1+IABCD-1))
                           IF ((TST.GT.0.0D0).AND.(ISYMCD.NE.ISYMAB))
     &                     THEN
                              WRITE(LUPRI,*) 'Symmetry break!!'
                              WRITE(LUPRI,*) 'element ',ICD,IAB,
     &                                       ' is non-zero: ',
     &                                       WORK(KINT1+IABCD-1)
                              WRITE(LUPRI,*) 'Symmetry is: ',
     &                                       MULD2H(ISYMCD,ISYMAB)
                           END IF
                        END DO
                     END DO
                  END DO
               END DO
            END IF

         END DO
      END DO

      CALL XRLSMEM_INTS
      CALL GETMEM('Int1.flsh','FLUSH','REAL',KINT1,LINTT)
      CALL GETMEM('Int1.free','FREE','REAL',KINT1,LINTT)

      WRITE(LUPRI,*) '***END OF ',SECNAM,': #tests: ',NTST,
     &               ' #errors: ',NERR

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2005, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Sort_Localisation_1(CMO,U,nBas,nOcc)
! Thomas Bondo Pedersen, November 2005.
!
! Purpose: sort CMO columns according to U.

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nBas, nOcc
real(kind=wp), intent(inout) :: CMO(nBas,nOcc)
real(kind=wp), intent(in) :: U(nOcc,nOcc)
integer(kind=iwp) :: i, j, jmax
real(kind=wp) :: Umax, Utst
integer(kind=iwp), allocatable :: I1(:), I2(:)
real(kind=wp), allocatable :: C(:,:)

! Allocations.
! ------------

call mma_allocate(I1,nOcc,label='Sr1I1')
call mma_allocate(I2,nOcc,label='Sr1I2')
call mma_allocate(C,nBas,nOcc,label='Sr1C')

! Find max U element in each row.
! -------------------------------

do i=1,nOcc
  I1(i) = i
end do

do i=1,nOcc
  jmax = 0
  Umax = -huge(Umax)
  do j=1,nOcc
    if (I1(j) == j) then
      Utst = abs(U(i,j))
      if (Utst > Umax) then
        jmax = j
        Umax = Utst
      end if
    end if
  end do
  if (jmax == 0) then
    call SysAbendMsg('Sort_Localisation_1','Error:','jmax=0')
  else
    I1(jmax) = 0
    I2(i) = jmax
  end if
end do

! Swap MOs according to I2.
! -------------------------

C(:,:) = CMO
do i=1,nOcc
  CMO(:,i) = C(:,I2(i))
end do

! De-allocate.
! ------------

call mma_deallocate(I1)
call mma_deallocate(I2)
call mma_deallocate(C)

end subroutine Sort_Localisation_1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine OutRAS_td(iKapDisp,iCiDisp)
!*******************************************************************
!                                                                  *
! Writes the response to a permenent file MCKINT - Instead of      *
! just a temporary one.                                            *
! Contracts the response coefficient to the hessian                *
!                                                                  *
! Input                                                            *
!       iKapDisp : Disk locations of solutions to respons equation *
!       iCIDisp  : Disk locations of CI Soulutions to response     *
!                                                                  *
! Author: Anders Bernhardsson, 1996                                *
!         Theoretical Chemistry, University of Lund                *
!*******************************************************************

use Symmetry_Info, only: Mul
use MckDat, only: sLength
use gugx, only: SGS, CIS, EXS
use MCLR_Data, only: DspVec, lDisp, LuTEMP, nConf1, nDens, nDensC
use input_mclr, only: iMethod, iSpin, kPrint, nActEl, nConf, nCSF, nDisp, nElec3, nHole1, nRS1, nRS2, nRS3, nSym, State_Sym, TimeDep
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iKapDisp(nDisp), iCiDisp(nDisp)
integer(kind=iwp) :: iDIs, iDisk, iDisp, iLen, iOpt, iPert, iRC, iSym, iSymL, jDisp, kDisp, Length, nConfm, Pstate_sym
logical(kind=iwp) :: CI
character(len=8) :: Label
real(kind=wp), allocatable :: CIp1(:,:), Kap1(:), Kap2(:), Kap3(:)

!----------------------------------------------------------------------*
!
! Ok construct hessian
!
!----------------------------------------------------------------------*

write(u6,*)
write(u6,*) '      Writing response to disk in Split guga GUGA format'
write(u6,*)
idisp = 0
do iSym=1,nSym
  call Setup_MCLR(iSym)
  PState_SYM = Mul(State_Sym,iSym)
  nconfM = ncsf(PState_Sym)
  nconf1 = ncsf(PState_Sym)
  CI = .false.
  if ((iMethod == 2) .and. (nconf1 > 0)) CI = .true.
  if (CI .and. (nconf1 == 1) .and. (isym == 1)) CI = .false.
  if (Timedep) nconfM = nconfM*2

  ! Allocate areas for scratch and state variables

  call mma_allocate(Kap1,nDens,Label='Kap1')
  call mma_allocate(Kap2,nDens,Label='Kap2')
  call mma_allocate(Kap3,nDens,Label='Kap3')
  if (CI) then
    if (TimeDep) then
      call mma_allocate(CIp1,nconf1,2,Label='CIp1')
    else
      call mma_allocate(CIp1,nconf1,1,Label='CIp1')
    end if
    call InCSFSD(Pstate_sym,State_sym)
  end if
  do jDisp=1,lDisp(iSym)
    iDisp = iDisp+1
    kdisp = DspVec(idisp)
    iDisk = iKapDisp(iDisp)
    Length = nDensC
    !---------------------------------------------------------
    ! LuTemp temp file in wfctl where the response is written
    !---------------------------------------------------------
    call dDaFile(LuTemp,2,Kap1,Length,iDisk)
    !if (nDensC /= 0) call RecPrt('K',' ',Kap1,nDensC,1)
    call Uncompress(Kap1,Kap3,isym)
    if (CI) then
      ilen = nconfM
      idis = iCIDisp(iDisp)
      call dDaFile(LuTemp,2,CIp1,iLen,iDis)
      !call RecPrt(' ',' ',CIp1,nconfM,1)
    end if
    call TCMO(Kap3,isym,-1)
    irc = nDens
    Label = 'KAPPA'
    iopt = ibset(0,sLength)
    isyml = ibset(0,isym-1)
    ipert = kdisp
    call dWrMCk(iRC,iOpt,Label,ipert,Kap3,isyml)
    if (irc /= 0) call Abend()
    irc = nconfM
    iopt = ibset(0,sLength)
    Label = 'CI'
    isyml = ibset(0,isym-1)
    ipert = kdisp

    if (btest(kprint,3)) write(u6,*) 'Perturbation ',ipert

    if (Timedep .and. CI) then
      call GugaNew(nSym,iSpin,nActEl,nHole1,nElec3,nRs1,nRs2,nRs3,SGS,CIS,EXS,CIp1(:,2),0,pstate_sym,State_Sym)
      NCSF(1:nSym) = CIS%NCSF(1:nSym)
      NCONF = CIS%NCSF(pstate_Sym)
      call mkGuga_Free(SGS,CIS,EXS)
      CIp1(:,2) = -CIp1(:,2)
    end if

    if (CI) then
      call GugaNew(nSym,iSpin,nActEl,nHole1,nElec3,nRs1,nRs2,nRs3,SGS,CIS,EXS,CIp1(:,1),0,pstate_sym,State_Sym)
      NCSF(1:nSym) = CIS%NCSF(1:nSym)
      NCONF = CIS%NCSF(pstate_Sym)
      call mkGuga_Free(SGS,CIS,EXS)
    end if
    if (Timedep) then
      if (CI) then
        !call RecPrt(' ',' ',CIp1,nconfM,1)
        call dWrMCk(iRC,iOpt,Label,ipert,CIp1,isyml)
      end if
    else
      if ((imethod == 2) .and. (.not. CI) .and. (nconf1 == 1)) CIp1(1,1) = Zero
      call dWrMCk(iRC,iOpt,Label,ipert,CIp1,isyml)
      if (irc /= 0) call Abend()
    end if
    !*******************************************************************

  end do

  ! Free areas for scratch and state variables

  if (CI) call mma_deallocate(CIp1)
  call mma_deallocate(Kap3)
  call mma_deallocate(Kap2)
  call mma_deallocate(Kap1)
end do

end subroutine OutRAS_td

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Gunnar Karlstrom                                 *
*               2000, Roland Lindh                                     *
************************************************************************
      Subroutine qlm(gx,gy,gz,qa,dax,day,daz,lmax_,Cavxyz)
************************************************************************
*                                                                      *
*     Object: to reexpand the charge and the dipole moment at a given  *
*             point as a multipole moment expansion at origin.         *
*                                                                      *
*     Authors: G. Karlstroem                                           *
*              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
*                                                                      *
*              and                                                     *
*                                                                      *
*              R. Lindh                                                *
*              Dept. of Chem. Phys., Univ. of Lund, Sweden.            *
*                                                                      *
*              March 2000                                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 Cavxyz((lMax_+1)*(lMax_+2)*(lMax_+3)/6)
*
*---- Statement function
*
      iOff(ix,iy,iz)=(ix+iy+iz)*(ix+iy+iz+1)*(ix+iy+iz+2)/6
      Index(ix,iy,iz) = iOff(ix,iy,iz) + (iy+iz)*(iy+iz+1)/2 + iz + 1
*
      lmax = lmax_ - 1
*
      Do ix=0,lmax
         If (ix.eq.0) Then
            xeff = One
         Else
            xeff = gx**ix
         End If
         ax=DBLE(ix)+One
         Do iy=0,lmax-ix
            If (iy.eq.0) Then
               xyeff = xeff
            Else
               xyeff = xeff* gy**iy
            End If
            ay=DBLE(iy)+One
            Do iz=0,lmax-ix-iy
               If (iz.eq.0) Then
                  xyzeff = xyeff * gz**iz
               Else
                  xyzeff = xyeff * gz**iz
               End If
               az=DBLE(iz)+One
*
*------------- Charge term
*
               Cavxyz(Index(ix,iy,iz)) = xyzeff*qa
     &                                 + Cavxyz(Index(ix,iy,iz))
*
*------------- Dipole terms
*
               Cavxyz(Index(ix+1,iy,iz)) = xyzeff*dax*ax
     &                                   + Cavxyz(Index(ix+1,iy,iz))
               Cavxyz(Index(ix,iy+1,iz)) = xyzeff*day*ay
     &                                   + Cavxyz(Index(ix,iy+1,iz))
               Cavxyz(Index(ix,iy,iz+1)) = xyzeff*daz*az
     &                                   + Cavxyz(Index(ix,iy,iz+1))
*
            End Do
         End Do
      End Do
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MkQ0(V)
! Q0(i,j,k,l) <- V(ij,kl)

use Index_Functions, only: nTri_Elem
use chcc_global, only: no, Q0
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: V(nTri_Elem(no),nTri_Elem(no))
integer(kind=iwp) :: i, ij, k, kl

call mma_allocate(Q0,no,no,no,no,label='Q0')

kl = 0
do k=1,no
  ij = 0
  do i=1,no
    Q0(i,1:i-1,k,1:k-1) = V(ij+1:ij+i-1,kl+1:kl+k-1)
    Q0(i,1:i-1,1:k,k) = V(ij+1:ij+i-1,kl+1:kl+k)
    Q0(1:i,i,k,1:k-1) = V(ij+1:ij+i,kl+1:kl+k-1)
    Q0(1:i,i,1:k,k) = V(ij+1:ij+i,kl+1:kl+k)
    ij = ij+i
  end do
  kl = kl+k
end do

return

end subroutine MkQ0

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine contract(
     *coeffs1, !(nprim(1),ncont(1)) modified contraction coefficients
     *coeffs2, !(nprim(2),ncont(2)) modified contraction coefficients
     *coeffs3, !(nprim(3),ncont(3)) modified contraction coefficients
     *coeffs4, !(nprim(4),ncont(4)) modified contraction coefficients
     *ncont,   ! i-th element is number of contracted functions i. index
     *nprim,   ! i-th element is number of primitive functions  i. index
cbs  array one contains at the beginning the uncontracted integrals
     *arr1,  ! array of size (nprim(1)*nprim(2)*nprim(3)*nprim(4))
     *arr2   ! array of size (nprim(1)*nprim(2)*nprim(3)*nprim(4))
     *)
      implicit real*8 (a-h,o-z)
      dimension coeffs1(*),coeffs2(*),coeffs3(*),coeffs4(*),
     *arr1(*),arr2(*),ncont(4),nprim(4),nolds(4),nnew(4)
C
cbs   makes four indextransformations in a row....
cbs   try to find out, which indices should be transformed first...
c
      ratio1=DBLE(nprim(1))/DBLE(ncont(1))
      ratio2=DBLE(nprim(2))/DBLE(ncont(2))
      ratio3=DBLE(nprim(3))/DBLE(ncont(3))
      ratio4=DBLE(nprim(4))/DBLE(ncont(4))
      do IBM=1,4
      nolds(IBM)=nprim(IBM)
      nnew(IBM)=nprim(IBM)
      enddo
cbs   determine first, second,third and last index
************************************************************************
cbs   determine the first
      xmax=max(ratio1,ratio2,ratio3,ratio4)
      if (xmax.eq.ratio1) then
         ifirst=1
         ratio1=0d0
         nnew(ifirst)=ncont(ifirst)
         call trans_amfi(coeffs1,nprim(1),ncont(1),1,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
      else if (xmax.eq.ratio2) then
         ifirst=2
         ratio2=0d0
         nnew(ifirst)=ncont(ifirst)
         call trans_amfi(coeffs2,nprim(2),ncont(2),2,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
      else if (xmax.eq.ratio3) then
         ifirst=3
         ratio3=0d0
         nnew(ifirst)=ncont(ifirst)
         call trans_amfi(coeffs3,nprim(3),ncont(3),3,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
      else if (xmax.eq.ratio4) then
         ifirst=4
         ratio4=0d0
         nnew(ifirst)=ncont(ifirst)
         call trans_amfi(coeffs4,nprim(4),ncont(4),4,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
      else
         ifirst=0
         write (6,*) 'Contract: you should not be here!'
         call abend()
      endif
      nolds(ifirst)=nnew(ifirst)
************************************************************************
cbs   determine the second
      xmax=max(ratio1,ratio2,ratio3,ratio4)
      if (xmax.eq.ratio1) then
         isec=1
         ratio1=0d0
         nnew(isec)=ncont(isec)
         call trans_amfi(coeffs1,nprim(1),ncont(1),1,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
      else if (xmax.eq.ratio2) then
         isec=2
         ratio2=0d0
         nnew(isec)=ncont(isec)
         call trans_amfi(coeffs2,nprim(2),ncont(2),2,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
      else if (xmax.eq.ratio3) then
         isec=3
         ratio3=0d0
         nnew(isec)=ncont(isec)
         call trans_amfi(coeffs3,nprim(3),ncont(3),3,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
      else if (xmax.eq.ratio4) then
         isec=4
         ratio4=0d0
         nnew(isec)=ncont(isec)
         call trans_amfi(coeffs4,nprim(4),ncont(4),4,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
      else
         isec=0
         write (6,*) 'Contract: you should not be here!'
         call abend()
      endif
      nolds(isec)=nnew(isec)
************************************************************************
cbs   determine the third
      xmax=max(ratio1,ratio2,ratio3,ratio4)
      if (xmax.eq.ratio1) then
         ithird=1
         ratio1=0d0
         nnew(ithird)=ncont(ithird)
         call trans_amfi(coeffs1,nprim(1),ncont(1),1,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
      else if (xmax.eq.ratio2) then
         ithird=2
         ratio2=0d0
         nnew(ithird)=ncont(ithird)
         call trans_amfi(coeffs2,nprim(2),ncont(2),2,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
      else if (xmax.eq.ratio3) then
         ithird=3
         ratio3=0d0
         nnew(ithird)=ncont(ithird)
         call trans_amfi(coeffs3,nprim(3),ncont(3),3,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
      else if (xmax.eq.ratio4) then
         ithird=4
         ratio4=0d0
         nnew(ithird)=ncont(ithird)
         call trans_amfi(coeffs4,nprim(4),ncont(4),4,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr1,arr2)
      else
         ithird=0
         write (6,*) 'Contract: you should not be here!'
         call abend()
      endif
      nolds(ithird)=nnew(ithird)
************************************************************************
cbs   determine the last
      xmax=max(ratio1,ratio2,ratio3,ratio4)
      if (xmax.eq.ratio1) then
         ifourth=1
         ratio1=0d0
         nnew(ifourth)=ncont(ifourth)
         call trans_amfi(coeffs1,nprim(1),ncont(1),1,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
      else if (xmax.eq.ratio2) then
         ifourth=2
         ratio2=0d0
         nnew(ifourth)=ncont(ifourth)
         call trans_amfi(coeffs2,nprim(2),ncont(2),2,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
      else if (xmax.eq.ratio3) then
         ifourth=3
         ratio3=0d0
         nnew(ifourth)=ncont(ifourth)
         call trans_amfi(coeffs3,nprim(3),ncont(3),3,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
      else if (xmax.eq.ratio4) then
         ifourth=4
         ratio4=0d0
         nnew(ifourth)=ncont(ifourth)
         call trans_amfi(coeffs4,nprim(4),ncont(4),4,nolds(1),nolds(2),
     *      nolds(3),nolds(4),nnew(1),nnew(2),nnew(3),nnew(4),arr2,arr1)
      else
         ifourth=0
         write (6,*) 'Contract: you should not be here!'
         call abend()
      endif
cbs   contracted integrals are now on
cbs   arr1(ncont1,ncont2,ncont3,ncont4)
*
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine bino(lmax)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "welcom.fh"
*
      Do 2 i=0,10
         Do 3 j=-1,10
            binom(i,j)=Zero
   3     Continue
   2  Continue
      binom(0,0)=One
      if(lmax.eq.0) go to 100
      Do 10 i=1,lmax
         Do 20 j=0,i
            binom(i,j)=binom(i-1,j-1)+binom(i-1,j)
20       Continue
10    Continue
*
100   Continue
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine BMtrx_Cartesian(nsAtom,nDimBC,nIter,mTtAtm,mTR,TRVec,EVal,Hss_x,nQQ,nWndw)

use Index_Functions, only: nTri_Elem
use Slapaf_Info, only: AtomLbl, BMx, BSet, Cx, Degen, dqInt, dqInt_Aux, Gx, Gx0, HSet, KtB, lOld, MaxItr, NAC, PrQ, qInt, &
                       Redundant, Smmtrc
use Kriging_Mod, only: nSet
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nsAtom, nDimBC, nIter, mTtAtm, mTR, nWndw
real(kind=wp), intent(in) :: TRVec(nDimBC,mTR)
real(kind=wp), intent(out) :: Eval(nTri_Elem(3*mTtAtm))
real(kind=wp), intent(inout) :: Hss_x((3*mTtAtm)**2)
integer(kind=iwp), intent(out) :: nQQ
integer(kind=iwp) :: i, iAtom, iInd, iInter, ij, ijTri, ik, ipFrom, iTR, ix, ixyz, j, jAtom, ji, jx, jxyz, k, kAtom, kx, kxyz
real(kind=wp) :: Hii, Omega, Temp
integer(kind=iwp), allocatable :: Ind(:)
real(kind=wp), allocatable :: Degen2(:), EVec(:), Hi(:,:), iHi(:)
real(kind=wp), external :: DDot_

!                                                                      *
!***********************************************************************
!                                                                      *
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
call RecPrt('BMtrx_Cartesian: TRVec',' ',TRVec,nDimBC,mTR)
call RecPrt('BMtrx_Cartesian: Degen',' ',Degen,3,size(Degen,2))
call RecPrt('BMtrx_Cartesian: Hss_x',' ',Hss_x,3*mTtAtm,3*mTtAtm)
#endif

! Recompute the B matrix once each macroIteration, this is
! not done if a numerical Hessian is computed.
!                                                                      *
!***********************************************************************
!                                                                      *
!     R E D U N D A N T  C A R T E S I A N  C O O R D S

if (Redundant) then
  nQQ = nDimBC
  if (allocated(qInt)) then
    if (size(qInt,1) /= nQQ) then
      call mma_deallocate(qInt)
      call mma_deallocate(dqInt)
    end if
  end if
  if (.not. allocated(qInt)) then
    call mma_allocate(qInt,nQQ,MaxItr,Label='qInt')
    call mma_allocate(dqInt,nQQ,MaxItr,Label='dqInt')
    qInt(:,:) = Zero
    dqInt(:,:) = Zero
  end if
  if (allocated(dqInt_Aux)) then
    if (size(dqInt_Aux,1) /= nQQ) call mma_deallocate(dqInt_Aux)
  end if
  if ((.not. allocated(dqInt_Aux)) .and. (nSet > 1)) then
    call mma_allocate(dqInt_Aux,nQQ,MaxItr,nSet-1,Label='dqInt_Aux')
    dqInt_Aux(:,:,:) = Zero
  end if
  call mma_allocate(EVec,nDimBC**2,Label='EVec')
  call unitmat(EVec,nDimBC)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Move over the eigenvectors putting to BMx

  call mma_allocate(BMx,3*nsAtom,nQQ,Label='BMx')
  BMX(:,:) = Zero
  ipFrom = 1
  call BPut(EVec(ipFrom),nDimBC,BMx,3*nsAtom,Smmtrc,nQQ,Degen)
# ifdef _DEBUGPRINT_
  call RecPrt('In Bmtrx: B',' ',BMx,3*nsAtom,nQQ)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (PrQ .and. (nsAtom <= 5)) call List2('Cartesian Redundant',AtomLbl,BMx,nsAtom,nQQ,Smmtrc)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Project the model Hessian with respect to rotations and
  ! translations. The eigenvalues are shifted to large positive
  ! eigenvalues to effectively remove any displacements in the
  ! rotational and translations directions and to make sure that
  ! the matrix is not singular.

  call mma_allocate(Ind,nDimBC,Label='Ind')
  iInd = 0
  do i=1,3*nsAtom
    iAtom = (i+2)/3
    ixyz = i-(iAtom-1)*3
    if (Smmtrc(ixyz,iAtom)) then
      iInd = iInd+1
      Ind(iInd) = i
    end if
  end do

  ! Compute H|i>

  call mma_allocate(Hi,nDimBC,mTR,Label='Hi')
  call mma_allocate(iHi,mTR,Label='iHi')
  Hi(:,:) = Zero

  do j=1,mTR
    do i=1,nDimBC
      Temp = Zero
      do k=1,nDimBC
        kx = Ind(k)
        iAtom = (kx+2)/3
        ixyz = kx-(iAtom-1)*3
        ik = (i-1)*nDimBC+k
        Temp = Temp+Hss_X(ik)*sqrt(Degen(ixyz,iAtom))*TRVec(k,j)
      end do
      Hi(i,j) = Temp
    end do
  end do
  !call RecPrt('Hi',' ',Hi,nDimBC,mTR)
  do iTR=1,mTR
    iHi(iTR) = DDot_(nDimBC,TRVec(1,iTR),1,Hi(:,iTR),1)
  end do
  !call RecPrt('iHi',' ',iHi,mTR,1)

  do i=1,nDimBC
    ix = Ind(i)
    iAtom = (ix+2)/3
    ixyz = ix-(iAtom-1)*3
    do j=1,i
      jx = Ind(j)
      jAtom = (jx+2)/3
      jxyz = jx-(jAtom-1)*3
      ij = (j-1)*nDimBC+i
      ji = (i-1)*nDimBC+j
      Temp = Half*(Hss_x(ij)+Hss_x(ji))
#     ifndef UNIT_MM

      ! Here we shift the eigenvectors corresponding to
      ! translations and rotations to a large positive values.

      do iTR=1,mTR
        Omega = 1.0e5_wp
        Hii = iHi(iTR)
        Temp = Temp+sqrt(Degen(ixyz,iAtom))* &
               (-TRVec(i,iTR)*Hi(j,iTR)-Hi(i,iTR)*TRVec(j,iTR)+TRVec(i,iTR)*(Omega+Hii)*TRVec(j,iTR))*sqrt(Degen(jxyz,jAtom))
      end do
#     endif

      Hss_X(ij) = Temp
      Hss_X(ji) = Temp
    end do
  end do
  call mma_deallocate(iHi)
  call mma_deallocate(Hi)
  call mma_deallocate(Ind)

  ! Clean up the gradient wrt translational and rotational component.
  !
  ! |g> = |g> - Sum(TR) |i><i|g>

  if (BSet) then

    !call RecPrt('Gx',' ',Gx(:,:,nIter),1,3*nsAtom)
    !call RecPrt('TRVec',' ',TRVec,nDimBC,mTR)

    do iTR=1,mTR

      ! <i|g>

      Temp = Zero
      iInd = 0
      do iAtom=1,nsAtom
        do j=1,3
          if (Smmtrc(j,iAtom)) then
            iInd = iInd+1
            Temp = Temp+Degen(j,iAtom)*Gx(j,iAtom,nIter)*TRVec(iInd,iTR)
          end if
        end do
      end do

      iInd = 0
      do iAtom=1,nsAtom
        do j=1,3
          if (Smmtrc(j,iAtom)) then
            iInd = iInd+1
            Gx(j,iAtom,nIter) = Gx(j,iAtom,nIter)-TRVec(iInd,iTR)*Temp
          end if
        end do
      end do

    end do

    !call RecPrt('Gx',' ',Gx(:,:,nIter),1,3*nsAtom)

  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  !   N O N - R E D U N D A N T  C A R T E S I A N  C O O R D S

  nQQ = nDimBC-mTR
  if (allocated(qInt)) then
    if (size(qInt,1) /= nQQ) then
      call mma_deallocate(qInt)
      call mma_deallocate(dqInt)
    end if
  end if
  if (.not. allocated(qInt)) then
    call mma_allocate(qInt,nQQ,MaxItr,Label='qInt')
    call mma_allocate(dqInt,nQQ,MaxItr,Label='dqInt')
    qInt(:,:) = Zero
    dqInt(:,:) = Zero
  end if
  if (allocated(dqInt_Aux)) then
    if (size(dqInt_Aux,1) /= nQQ) call mma_deallocate(dqInt_Aux)
  end if
  if ((.not. allocated(dqInt_Aux)) .and. (nSet > 1)) then
    call mma_allocate(dqInt_Aux,nQQ,MaxItr,nSet-1,Label='dqInt_Aux')
    dqInt_Aux(:,:,:) = Zero
  end if

  ! Project the model Hessian with respect to rotations and
  ! translations. The eigenvalues are shifted to negative eigenvalues.

  call mma_allocate(Ind,nDimBC,Label='Ind')
  iInd = 0
  do i=1,3*nsAtom
    iAtom = (i+2)/3
    ixyz = i-(iAtom-1)*3
    if (Smmtrc(ixyz,iAtom)) then
      iInd = iInd+1
      Ind(iInd) = i
    end if
  end do

  ! Compute H|i>

  call mma_allocate(Hi,nDimBC,mTR,Label='Hi')
  call mma_allocate(iHi,mTR,Label='iHi')
  Hi(:,:) = Zero

  do j=1,mTR
    do i=1,nDimBC
      Temp = Zero
      do k=1,nDimBC
        kx = Ind(k)
        kAtom = (kx+2)/3
        kxyz = kx-(kAtom-1)*3
        ik = (i-1)*nDimBC+k
        Temp = Temp+Hss_X(ik)*sqrt(Degen(kxyz,kAtom))*TRVec(k,j)
      end do
      Hi(i,j) = Temp
    end do
  end do
  do iTR=1,mTR
    iHi(iTR) = DDot_(nDimBC,TRVec(:,iTR),1,Hi(:,iTR),1)
  end do
# ifdef _DEBUGPRINT_
  call RecPrt('Hi',' ',Hi,nDimBC,mTR)
  call RecPrt('iHi',' ',iHi,mTR,1)
# endif

  do i=1,nDimBC
    ix = Ind(i)
    iAtom = (ix+2)/3
    ixyz = ix-(iAtom-1)*3
    do j=1,i
      jx = Ind(j)
      jAtom = (jx+2)/3
      jxyz = jx-(jAtom-1)*3
      ijTri = nTri_Elem(i-1)+j
      ij = (j-1)*nDimBC+i
      ji = (i-1)*nDimBC+j
      EVal(ijTri) = Half*(Hss_X(ij)+Hss_X(ji))

      ! Here we shift the eigenvectors corresponding to translations
      ! and rotations down to negative faked eigenvalues.

      do iTR=1,mTR
        Omega = -real(iTR,kind=wp)
        Hii = iHi(iTR)
        Eval(ijTri) = Eval(ijTri)+sqrt(Degen(ixyz,iAtom))* &
                      (-TRVec(i,iTR)*Hi(j,iTR)-Hi(i,iTR)*TRVec(j,iTR)+TRVec(i,iTR)*(Omega+Hii)*TRVec(j,iTR))*sqrt(Degen(jxyz,jAtom))
      end do

      Hss_X(ij) = EVal(ijTri)
      Hss_X(ji) = EVal(ijTri)
    end do
  end do
  call mma_deallocate(iHi)
  call mma_deallocate(Hi)
  call mma_deallocate(Ind)
# ifdef _DEBUGPRINT_
  call TriPrt(' The Projected Model Hessian','(5G20.10)',EVal,nDimBC)
  call RecPrt(' The Projected Model Hessian','(5G20.10)',Hss_x,nDimBC,nDimBC)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Compute the eigenvectors for the Cartesian Hessian

  call mma_allocate(EVec,(3*mTtAtm)**2,Label='EVec')
  call Hess_Vec(mTtAtm,EVal,EVec,nDimBC)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Move over the eigenvectors putting to BMx

  call mma_allocate(BMx,3*nsAtom,3*nsAtom,Label='BMx')
  BMx(:,:) = Zero
  ipFrom = 1+mTR*nDimBC
  call BPut(EVec(ipFrom),nDimBC,BMx,3*nsAtom,Smmtrc,nQQ,Degen)
# ifdef _DEBUGPRINT_
  call RecPrt('In Bmtrx: B',' ',BMx,3*nsAtom,nQQ)
# endif
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (PrQ .and. (nsAtom <= 5)) call List2('Cartesian Approximate Normal Modes',AtomLbl,BMx,nsAtom,nQQ,Smmtrc)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (HSet .and. (.not. lOld)) then
  call mma_allocate(KtB,nDimBC,nQQ,Label='KtB')

  call mma_allocate(Degen2,nDimBC,Label='Degen2')
  i = 0
  do ix=1,3*nsAtom
    iAtom = (ix+2)/3
    ixyz = ix-(iAtom-1)*3
    if (Smmtrc(ixyz,iAtom)) then
      i = i+1
      Degen2(i) = Degen(ixyz,iAtom)
    end if
  end do

  KtB(:,:) = reshape(EVec(ipFrom:ipFrom+nDimBC*nQQ-1),[nDimBC,nQQ])
  do iInter=1,nQQ
    KtB(:,iInter) = KtB(:,iInter)/sqrt(Degen2(:))
  end do
  call mma_deallocate(Degen2)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(EVec)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the value and gradient vectors in the new basis.

call ValANM(nsAtom,nQQ,nIter,BMx,Degen,qInt,Cx,'Values',nWndw)
if (BSet) then
  call ValANM(nsAtom,nQQ,nIter,BMx,Degen,dqInt,Gx,'Gradients',nWndw)
  if (nSet > 1) call ValANM(nsAtom,nQQ,nIter,BMx,Degen,dqInt_Aux(:,:,1),Gx0,'Gradients',nWndw)
  if (nSet > 2) call ValANM(nsAtom,nQQ,nIter,BMx,Degen,dqInt_Aux(:,:,2),NAC,'Gradients',nWndw)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
return

end subroutine BMtrx_Cartesian

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine io_init_cvb()
      implicit real*8(a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "io_cvb.fh"

      nrec=0
      thresh_io=1d-5
      call izero(iorder,mxunits)
      call daninit_cvb()

c  Preassign some file names to identifiers :
      call setfn_cvb(recn_jobold,'JOBOLD')
      call setfn_cvb(recn_jobiph,'JOBIPH')
      call setfn_cvb(recn_oneint,'ONEINT')
      call setfn_cvb(recn_vbwfn,'VBWFN')
      call setfn_cvb(recn_tmp01,'TMP01')
      call setfn_cvb(recn_tmp02,'TMP02')
      call setfn_cvb(recn_tmp03,'TMP03')
      call setfn_cvb(recn_tmp04,'TMP04')
      call setfn_cvb(recn_tmp05,'TMP05')
      call setfn_cvb(recn_tmp06,'TMP06')
      call setfn_cvb(recn_tmp07,'TMP07')
      call setfn_cvb(recn_tmp08,'TMP08')
      call setfn_cvb(recn_tmp09,'TMP09')
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Naoki Nakatani                                         *
************************************************************************
*  DMRGCtl
*
*> @brief
*>   DMRG Control
*> @author N. Nakatani
*>
*> @details
*> Many functionality is same as ::CICtl (copy most part of ::CICtl to here)
*> To use DMRG as CAS-CI solver.
*> \p IRst = ``0`` is used for the first and the last (DMRG-) CI calculations
*> to fully optimize the DMRG wavefunction.
*> \p IRst = ``1`` enables to restart DMRG calculation from last iteration
*>
*> @param[in]     CMO    MO coefficients
*> @param[out]    D      Average 1-dens matrix
*> @param[out]    DS     Average spin 1-dens matrix
*> @param[out]    P      Average symm. 2-dens matrix
*> @param[out]    PA     Average antisymm. 2-dens matrix
*> @param[out]    FI     Fock matrix from inactive density
*> @param[in,out] D1I    Inactive 1-dens matrix
*> @param[in,out] D1A    Active 1-dens matrix
*> @param[in]     TUVX   Active 2-el integrals
*> @param[in]     IFINAL Calculation status switch
*> @param[in]     IRst   DMRG restart status switch
************************************************************************
#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_
      Subroutine DMRGCtl(CMO,D,DS,P,PA,FI,D1I,D1A,TUVX,IFINAL,IRst)

      Implicit Real* 8 (A-H,O-Z)
      Dimension CMO(*),D(*),DS(*),P(*),PA(*),FI(*),D1I(*),D1A(*),
     &          TUVX(*)
c     Logical Exist
      Logical Do_ESPF

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='DMRGCTL ')
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "rctfld.fh"
#include "timers.fh"
#include "casvb.fh"
#include "wadr.fh"
#include "rasscf_lucia.fh"
#include "gas.fh"
#include "pamint.fh"
      Common /IDSXCI/ IDXCI(mxAct),IDXSX(mxAct)
*PAM05      SymProd(i,j)=1+iEor(i-1,j-1)
*
C Local print level (if any)
      IPRLEV=IPRLOC(3)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF

* set up flag 'IFCAS' for GAS option, which is set up in gugatcl originally.
* IFCAS = 0: This is a CAS calculation
* IFCAS = 1: This is a RAS calculation - This might cause an error in DMRG-CASSCF.
*
      if(iDoGas) call setsxci
      If(IPRLEV.gt.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' Enter DMRG section'
        Write(LF,*) ' =================='
        Write(LF,*)
        Write(LF,*) ' iteration count =',ITER
      End If
      if(ifinal.ne.0) PamGen1=.True.
*
* SOME DIRTY SETUPS
*
      S=0.5D0*DBLE(ISPIN-1)
*
* COMPUTE ONE ELECTRON INTEGRALS IN MO BASIS
* AND ADD CORE INTERACTION
*
* LW1: FOCK MATRIX IN MO-BASIS
* LW2: 1-PARTICLE DENSITY MATRIX ALSO USED IN MO/AO TRANSFORMATION
*
      CALL GETMEM('DMRGCTL1','ALLO','REAL',LW1,NACPAR)
      IF (IPRLEV.GE.DEBUG) THEN
        Write(LF,*) ' WORK SPACE VARIABLES IN SUBR. DMRGCTL: '
        Write(LF,*) ' SGFCIN ',LW1
      END IF
      Call DecideOnESPF(Do_ESPF)
      If ( lRf .or. KSDFT.ne.'SCF' .or. Do_ESPF) THEN
*
* In case of a reaction field in combination with an average CAS
* select the potential of the appropriate state.
*
        jDisk = IADR15(3)
        Do i=1,IPCMROOT-1
          Call DDafile(JOBIPH,0,rdum,NACPAR,jDisk)
          Call DDafile(JOBIPH,0,rdum,NACPAR,jDisk)
          Call DDafile(JOBIPH,0,rdum,NACPR2,jDisk)
          Call DDafile(JOBIPH,0,rdum,NACPR2,jDisk)
        End Do
*
        CALL GETMEM('D1A_FULL','ALLO','REAL',LRCT_F,NTOT2)
        CALL GETMEM('D1S_FULL','ALLO','REAL',LRCT_FS,NTOT2)
        If (IFINAL.eq.0) Then
*
* Use normal MOs
*
           CALL GETMEM('D1A_RCT','ALLO','REAL',LRCT,NACPAR)
           CALL GETMEM('P2MO','ALLO','REAL',ipP2MO,NACPR2)
*
* Get the total density in MOs
*
           Call DDafile(JOBIPH,2,Work(LRCT),NACPAR,jDisk)
           Call Put_D1MO(Work(LRCT),NACPAR)  ! Put it on the RUNFILE
           IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(LRCT))
* Transform to AOs
           Call Get_D1A_RASSCF(CMO,WORK(LRCT),WORK(LRCT_F))
*
* Get the spin density in MOs
*
           IF (NACTEL.EQ.0) THEN
             CALL DCOPY_(NTOT2,0.0D0,0,WORK(LRCT_FS),1)
           ELSE
             CALL GETMEM('D1S_RCT','ALLO','REAL',LRCT_S,NACPAR)
             Call DDafile(JOBIPH,2,Work(LRCT_S),NACPAR,jDisk)
             IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(LRCT_S))
* Transform to AOs
             Call Get_D1A_RASSCF(CMO,WORK(LRCT_S),WORK(LRCT_FS))
             CALL GETMEM('D1S_RCT','FREE','REAL',LRCT_S,NACPAR)
           END IF
*
* Get the 2-particle density in MO
*
           Call DDafile(JOBIPH,2,Work(ipP2MO),NACPR2,jDisk)
           Call Put_P2MO(Work(ipP2MO),NACPR2) ! Put it on the RUNFILE
*
           CALL SGFCIN(CMO,WORK(LW1),FI,D1I,Work(LRCT_F),Work(LRCT_FS))
*
           CALL GETMEM('P2MO','FREE','REAL',ipP2MO,NACPR2)
           CALL GETMEM('D1A_RCT','FREE','REAL',LRCT,NACPAR)
*
        Else
*
* Here the pseudo-natural orbitals are in CMO and we need to
* get the D1A of the selected state in this basis.
*
*
* Compute the density of the particular state
*

           Call GetMem('Dtmp ','ALLO','REAL',LW6,NACPAR)
           Call GetMem('DStmp','ALLO','REAL',LW7,NACPAR)
           Call GetMem('Ptmp ','ALLO','REAL',LW8,NACPR2)
           If ( NAC.ge.1 ) Then
              If (NACTEL.eq.0) THEN
                 call dcopy_(NACPAR,0.0D0,0,WORK(LW6),1)
                 call dcopy_(NACPAR,0.0D0,0,WORK(LW7),1)
                 call dcopy_(NACPR2,0.0D0,0,WORK(LW8),1)
              Else
* load back 1- and 2-RDMs from previous DMRG run
                 NACT4=NAC**4
                 Call GetMem('PAtmp','ALLO','REAL',LW9,NACPR2)
                 CALL GETMEM('PTscr','ALLO','REAL',LW10,NACT4)
#ifdef _ENABLE_BLOCK_DMRG_
                 CALL block_densi_rasscf(IPCMRoot,Work(LW6),Work(LW7),
     &                                   Work(LW8),Work(LW9),Work(LW10))
#elif _ENABLE_CHEMPS2_DMRG_
                 CALL chemps2_densi_rasscf(IPCMRoot,Work(LW6),Work(LW7),
     &                                 Work(LW8),Work(LW9),Work(LW10))
#endif

* NN.14 NOTE: IFCAS must be 0 for DMRG-CASSCF
c                If (IFCAS.GT.2) Call CISX(IDXSX,Work(LW6),
c    &                                     Work(LW7),Work(LW8),
c    &                                     Work(LW9),Work(LW10))
                 CALL GETMEM('PTscr','FREE','REAL',LW10,NACT4)
                 Call GetMem('PAtmp','FREE','REAL',LW9,NACPR2)
              EndIf
*
           Else
              call dcopy_(NACPAR,0.0D0,0,WORK(LW6),1)
              call dcopy_(NACPAR,0.0D0,0,WORK(LW7),1)
              call dcopy_(NACPR2,0.0D0,0,WORK(LW8),1)
           End If
* Modify the symmetric 2-particle density if only partial
* "exact exchange" is included.
c          n_Det=2
c          n_unpaired_elec=(iSpin-1)
c          n_paired_elec=nActEl-n_unpaired_elec
c          If(n_unpaired_elec+n_paired_elec/2.eq.nac) n_Det=1
           If (ExFac.ne.1.0D0) Call Mod_P2(Work(LW8),NACPR2,
     &                                   Work(LW6),NACPAR,
     &                                   Work(LW7),ExFac,n_Det)
*
           Call Put_P2MO(Work(LW8),NACPR2) ! Put it on the RUNFILE
*
           Call GetMem('Ptmp ','FREE','REAL',LW8,NACPR2)
*
           Call Put_D1MO(Work(LW6),NACPAR) ! Put it on the RUNFILE
           IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(LW6))
           Call Get_D1A_RASSCF(CMO,Work(LW6),Work(LRCT_F))
*
           IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(LW7))
           Call Get_D1A_RASSCF(CMO,Work(LW7),Work(LRCT_FS))
*
           Call GetMem('DStmp','FREE','REAL',LW7,NACPAR)
           Call GetMem('Dtmp ','FREE','REAL',LW6,NACPAR)
*
           Call SGFCIN(CMO,Work(LW1),FI,D1I,Work(LRCT_F),Work(LRCT_FS))
*
        End If
        CALL GETMEM('D1S_FULL','FREE','REAL',LRCT_FS,NTOT2)
        CALL GETMEM('D1A_RCT','FREE','REAL',LRCT_F,NTOT1)
*
      ELSE
*
* Normal case
*
*
*
*
        CALL GETMEM('TmpDS' ,'Allo','REAL',ipTmpDS ,NACPAR)
        CALL GETMEM('TmpD1S','Allo','REAL',ipTmpD1S,NTOT2 )
        call dcopy_(NACPAR,DS,1,Work(ipTmpDS),1)
        IF ( NASH(1).NE.NAC ) CALL DBLOCK(Work(ipTmpDS))
        Call Get_D1A_RASSCF(CMO,Work(ipTmpDS),Work(ipTmpD1S))
        CALL GETMEM('TmpDS' ,'Free','REAL',ipTmpDS ,NACPAR)
*
        CALL SGFCIN(CMO,WORK(LW1),FI,D1I,D1A,Work(ipTmpD1S))
        CALL GETMEM('TmpD1S','Free','REAL',ipTmpD1S,NTOT2 )
*
      END IF
*
      lw1_cvb=lw1
      If (IfVB.eq.2) GoTo 9000
*
* SOLVE DMRG WAVEFUNCTION
*
C     kh0_pointer is used in Lucia to retrieve H0 from Molcas.
      kh0_pointer = lw1
      if(IfVB.eq.1)then
* NN.14 FIXME: I'm not sure whether this option should work?
        call cvbmn_rvb(max(ifinal,1))
      else
        If (KSDFT(1:3).ne.'SCF'.
     &      and.DFTFOCK(1:4).eq.'DIFF'.and.nac.ne.0) Then
          nTmpPUVX=nFint
          Call GetMem('TmpPUVX','Allo','Real',ipTmpPUVX,nTmpPUVX)
          Call GetMem('TmpTUVX','Allo','Real',ipTmpTUVX,NACPR2)
          Call dCopy_(NACPR2,0.0d0,0,Work(ipTmpTUVX),1)
          Call Get_dArray('DFT_TwoEl',Work(ipTmpPUVX),nTmpPUVX)
          Call Get_TUVX(Work(ipTmpPUVX),Work(ipTmpTUVX))
          Call DaXpY_(NACPR2,1.0d0,TUVX,1,Work(ipTmpTUVX),1)
#ifdef _ENABLE_BLOCK_DMRG_
          Call BlockCtl(Work(LW1),Work(ipTmpTUVX),IFINAL,IRst)
#elif _ENABLE_CHEMPS2_DMRG_
          Call Chemps2Ctl(Work(LW1),Work(ipTmpTUVX),IFINAL,IRst)
#endif

          Call GetMem('TmpTUVX','Free','Real',ipTmpTUVX,NACPR2)
          Call GetMem('TmpPUVX','Free','Real',ipTmpPUVX,nTmpPUVX)
        Else
#ifdef _ENABLE_BLOCK_DMRG_
          Call BlockCtl(Work(LW1),TUVX,IFINAL,IRst)
#elif _ENABLE_CHEMPS2_DMRG_
          Call Chemps2Ctl(Work(LW1),TUVX,IFINAL,IRst)
#endif
        End If
      endif

*
* C
* CALCULATE DENSITY MATRICES
* SAVE DENSITY MATRICES ON FILE
* COMPUTE AVERAGE DENSITY MATRICES
* C
*
* LW6: ONE-BODY DENSITY
* LW7: ONE-BODY SPIN DENSITY
* LW8: SYMMETRIC TWO-BODY DENSITY
* LW9: ANTISYMMETRIC TWO-BODY DENSITY
*
      Call Timing(Rado_1,Swatch,Swatch,Swatch)
      Zero = 0.0d0
      Call dCopy_(NACPAR,Zero,0,D,1)
      Call dCopy_(NACPAR,Zero,0,DS,1)
      Call dCopy_(NACPR2,Zero,0,P,1)
      Call dCopy_(NACPR2,Zero,0,PA,1)
      CALL GETMEM('Dtmp ','ALLO','REAL',LW6,NACPAR)
      CALL GETMEM('DStmp','ALLO','REAL',LW7,NACPAR)
      CALL GETMEM('Ptmp ','ALLO','REAL',LW8,NACPR2)
      CALL GETMEM('PAtmp','ALLO','REAL',LW9,NACPR2)
      jDisk = IADR15(3)

      Do jRoot = 1,lRoots
        IF (IPRLEV.GE.DEBUG) THEN
          Write(LF,*) ' WORK SPACE VARIABLES IN SUBR. DMRGCTL: '
          Write(LF,'(1x,A,4I10)') 'DENSI',LW6,LW7,LW8,LW9
        END IF
* load density matrices from DMRG run
        If ( NAC.ge.1 ) Then
          NACT4=NAC**4
          CALL GETMEM('PTscr','ALLO','REAL',LW10,NACT4)
#ifdef _ENABLE_BLOCK_DMRG_
          CALL block_densi_rasscf(jRoot,Work(LW6),Work(LW7),
     &                            Work(LW8),Work(LW9),Work(LW10))
#elif _ENABLE_CHEMPS2_DMRG_
          CALL chemps2_densi_rasscf(jRoot,Work(LW6),Work(LW7),
     &                              Work(LW8),Work(LW9),Work(LW10))
#endif
          CALL GETMEM('PTscr','FREE','REAL',LW10,NACT4)
        EndIf
* Modify the symmetric 2-particle density if only partial
* "exact exchange" is included.
c        n_Det=2
c        n_unpaired_elec=(iSpin-1)
c        n_paired_elec=nActEl-n_unpaired_elec
c        If(n_unpaired_elec+n_paired_elec/2.eq.nac) n_Det=1
c
c           Write(LF,*) ' iSpin=',iSpin
c           Write(LF,*) ' n_unpaired_elec',n_unpaired_elec
c           Write(LF,*) ' n_paired_elec',  n_paired_elec
c           Write(LF,*) ' n_unpaired_elec+n_paired_elec/2',
c     &                  n_unpaired_elec+n_paired_elec/2
c           Write(LF,*) ' n_Det=',n_Det
c
c
        If (ExFac.ne.1.0D0) Call Mod_P2(Work(LW8),NACPR2,
     &                                Work(LW6),NACPAR,
     &                                Work(LW7),ExFac,n_Det)

* update average density matrices
        Scal = 0.0d0
        Do kRoot = 1,nRoots
          If ( iRoot(kRoot).eq.jRoot ) then
            Scal = Weight(kRoot)
          End If
        End Do
        call daxpy_(NACPAR,Scal,Work(LW6),1,D,1)
        call daxpy_(NACPAR,Scal,Work(LW7),1,DS,1)
        call daxpy_(NACPR2,Scal,Work(LW8),1,P,1)
        call daxpy_(NACPR2,Scal,Work(LW9),1,PA,1)
* save density matrices on disk
        Call DDafile(JOBIPH,1,Work(LW6),NACPAR,jDisk)
        Call DDafile(JOBIPH,1,Work(LW7),NACPAR,jDisk)
        Call DDafile(JOBIPH,1,Work(LW8),NACPR2,jDisk)
        Call DDafile(JOBIPH,1,Work(LW9),NACPR2,jDisk)
      End Do

      CALL GETMEM('PAtmp','FREE','REAL',LW9,NACPAR)
      CALL GETMEM('Ptmp ','FREE','REAL',LW8,NACPAR)
      CALL GETMEM('DStmp','FREE','REAL',LW7,NACPR2)
      CALL GETMEM('Dtmp ','FREE','REAL',LW6,NACPR2)
*
* C
* PREPARE DENSITY MATRICES AS USED BY THE SUPER CI SECTION
* C
*
* print matrices
      IF ( IPRLEV.GE.INSANE  ) THEN
        CALL TRIPRT('Averaged one-body density matrix, D',
     &              ' ',D,NAC)
        CALL TRIPRT('Averaged one-body spin density matrix, DS',
     &              ' ',DS,NAC)
        CALL TRIPRT('Averaged two-body density matrix, P',
     &              ' ',P,NACPAR)
        CALL TRIPRT('Averaged antisymmetric two-body density matrix,PA',
     &              ' ',PA,NACPAR)
      END IF
      IF ( NASH(1).NE.NAC ) CALL DBLOCK(D)
      Call Timing(Rado_2,Swatch,Swatch,Swatch)
      Rado_2 = Rado_2 - Rado_1
      Rado_3 = Rado_3 + Rado_2
*
      CALL GETMEM('DMRGCTL','FREE','REAL',LW1,NACPAR)

 9000 Continue
*
*     For RF calculations make sure that the we are following the
*     correct root.
*
*     In the current implementation the overlap between the CI vectors
*     of different macro iterations is used. This criterion stricktly
*     only hold if the orbitals are not changed in between the
*     interations, to make sure that this approximately holds the
*     comparision is only to be considered to be valid if the rotmax
*     parameter is below an empirical threshold. In the future the
*     procedure for indentifying root flipping has to be made more
*     robust.
*
CSVC: if CISElect is used, roots should be traced regardless of orbital
C     rotation, so in that case ignore the automatic tracing and follow
C     the relative CISE root given in the input by the 'CIRF' keyword.
*
* ======================================================================
* NN.14 FIXME:
*     The overlap b/w the DMRG wave of different macro iterations
*     hasn't yet been implemented. Eventually this must be fixed to
*     chose the correct root for RF calculation with DMRG-CASSCF.
*     For the time, just skip following.
* ======================================================================
*
c     If (lRF.and.KeyCISE.and.KeyCIRF) Then
c       JPCMROOT=IPCMROOT
c       IPCMROOT=IROOT(ICIRFROOT)
c       Call Put_iScalar("RF CASSCF root",IPCMROOT)
c       If (JPCMROOT.ne.IPCMROOT) Then
c         Write (6,'(1X,A,I3,A,I3)') 'RF Root has flipped from ',
c    &                 JPCMROOT, ' to ',IPCMROOT
c       End If
c     Else If (lRF) Then
c       Call Qpg_iScalar('RF CASSCF root',Exist)
c       If (.NOT.Exist) Then
*
*          We are here since we are using the default values.
*
c          Call Put_iScalar("RF CASSCF root",IPCMROOT)
c          Call Put_iScalar("RF0CASSCF root",IPCMROOT)
c       End If
*
c       Call Allocate_Work(ipRF,nConf)
c       Call Qpg_dArray("RF CASSCF Vector",Exist,mConf)
*       Write (6,*) 'Exist=',Exist
c       If (Exist
c    &      .and. mConf .eq. nConf
c    &      .and. iFinal.ne.2
c    &      .and. (ABS(RotMax).lt.1.0D-3 .or. KeyCISE)
c    &     ) Then
c          Call Get_dArray("RF CASSCF Vector",Work(ipRF),nConf)
c          rNorm=Sqrt(DDot_(nConf,Work(ipRF),1,Work(ipRF),1))
*          Write (6,*) 'rNorm=',rNorm
c          JPCMROOT=IPCMROOT
c          If (rNorm.gt.1.0D-10) Then
c             Call Allocate_Work(ipTemp,nConf)
c             rMax=0.0D0
c             jDisk = IADR15(4)
c             Do i = 1, lRoots
c                Call DDafile(JOBIPH,2,Work(ipTemp),nConf,jDisk)
c                qMax=Abs(DDot_(nConf,Work(ipTemp),1,Work(ipRF),1))
*                Write (6,*) 'qMax=',qMax
c                If (qMax.gt.rMax .and.
c    &               qMax.gt.0.5D0) Then
c                   rMax = qMax
c                   JPCMROOT=i
c                End If
c             End Do
c             Call Free_Work(ipTemp)
c          End If
c       Else
c          JPCMROOT=IPCMROOT
c       End If
*
c       If (JPCMROOT.ne.IPCMROOT) Then
c          Write (6,*) ' RF Root has flipped from ',IPCMROOT, ' to ',
c    &                                              JPCMROOT
c          IPCMROOT=JPCMROOT
c          Call Put_iScalar("RF CASSCF root",IPCMROOT)
c       End If
*
c       jDisk = IADR15(4)
c       Do i=1,IPCMROOT-1
c         Call DDafile(JOBIPH,0,rdum,nConf,jDisk)
c       End Do
c       Call DDafile(JOBIPH,2,Work(ipRF),nConf,jDisk)
c       Call Put_dArray("RF CASSCF Vector",Work(ipRF),nConf)
c       Call Free_Work(ipRF)
c     End If
*
      Return
      End

* _ENABLE_BLOCK_DMRG_
#elif defined (NAGFOR)
c Some compilers do not like empty files
      Subroutine empty_DMRGCtl()
      End
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine symweight_cvb(civec1,civec2,osym)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension osym(mxirrep),civec1(*),civec2(*)
c  *********************************************************************
c  *                                                                   *
c  *  SYMWEIGHT := CASSCF scalar product divided into irreps.          *
c  *                                                                   *
c  *********************************************************************

      icivec1=nint(civec1(1))
      icivec2=nint(civec2(1))
      call psym1_cvb(w(iaddr_ci(icivec1)),w(iaddr_ci(icivec2)),osym,2)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE BESSKA(AVAL,XVAL,KA,KA1)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 AVAL,XVAL,EPS,KA,KA1
C
C     SUBROUTINE TO CALCULATE MODIFIED BESSEL FUNCTION OF THE
C     THIRD KIND. FORTRAN SUBPROGRAM ADAPTED FROM ALGOL PROGRAM
C     IN: N.M.TEMME, J.COMP.PHYS 19 (1975) 324
C
C     MODIFICATIONS: RESULT IS EXP(X) TIMES BESSEL FUNCTION
C                    INSTEAD OF BESSEL FUNCTION ITSELF.
C     RELATIVE ACCURACY FIXED TO 5*1.D-14
C
      REAL*8 A1,B,C,D,E,F,G,H,P,PI,Q,S,A,X,RCPG,SINHX
culf      INTEGER*4 N,NA
      INTEGER N,NA
      LOGICAL REC,REV
*
      NA=0
      A=AVAL
      X=XVAL
      EPS=5.D-14
      PI=4.0D0*ATAN(1.0D0)
      REV=A.LT.-5D0
      IF (REV) A=-A-1.D0
      REC=A.GE.0.5D0
      IF (.NOT. REC) GOTO 1
      NA=INT(A+0.5D0)
      A=A-DBLE(NA)
1     CONTINUE
      IF (A.NE.-.5D0) GOTO 2
      F=sqrt(PI/X*.5D0)
      G=F
      GOTO 3
2     IF (X.GE.1.0D0) GOTO 4
      B=X*.5D0
      D=-LOG(B)
      E=A*D
      C=A*PI
      IF (abs(C).GE.1.D-15) GOTO 5
      C=1.D0
      GOTO 6
5     C=C/SIN(C)
6     CONTINUE
      IF (abs(E).GE.1.D-15) GOTO 7
      S=1.D0
      GOTO 8
7     S=SINHX(E)/E
8     CONTINUE
      E=EXP(E)
      A1=(E+1.0D0/E)*.5D0
      G=RCPG(A,P,Q)*E
      KA=C*(P*A1+Q*S*D)
      F=KA
      E=A*A
      P=0.5D0*G*C
      Q=0.5D0/G
      C=1.D0
      D=B*B
      KA1=P
      N=1
      GOTO 10
9     N=N+1
10    F=(F*DBLE(N)+P+Q)/(DBLE(N*N)-E)
      C=C*D/DBLE(N)
      P=P/(DBLE(N)-A)
      Q=Q/(DBLE(N)+A)
      G=C*(P-DBLE(N)*F)
      H=C*F
      KA=KA+H
      KA1=KA1+G
      IF (H/KA+abs(G)/KA.GT.EPS) GOTO 9
      F=KA*EXP(X)
      G=KA1*EXP(X)/B
      GOTO 3
4     C=0.25D0-A*A
      G=1.D0
      F=0.D0
      E=X*COS(A*PI)/PI/EPS
      N=1
      GOTO 13
12    N=N+1
13    H=(2.D0*(DBLE(N)+X)*G
     &   -(DBLE(N)-1.D0+C/DBLE(N))*F)/(DBLE(N)+1)
      F=G
      G=H
      IF (H*DBLE(N).LT.E) GOTO 12
      P=F/G
      Q=P
      B=X+X
      E=B-2.D0
15    P=(DBLE(N)-1.D0+C/DBLE(N)) / (E+(DBLE(N)+1.D0)*(2.D0-P))
      Q=P*(Q+1.D0)
      N=N-1
      IF (N.GT.0) GOTO 15
      F=sqrt(PI/B)/(1.D0+Q)
      G=F*(A+X+0.5D0-P)/X
3     CONTINUE
      IF (.NOT.REC) GOTO 16
      X=2.D0/X
      N=1
17    H=F+(A+DBLE(N))*X*G
      F=G
      G=H
      N=N+1
      IF (N.LE.NA) GOTO 17
16    IF (.NOT. REV) GOTO 18
      KA1=F
      KA=G
      GOTO 19
18    KA=F
      KA1=G
19    RETURN
      END
*                                                                      *
************************************************************************
*                                                                      *
      SUBROUTINE CHECK_DKH(ICORE,K,TEXT)
      CHARACTER*8 TEXT
      DATA MSK /0/, KSK /5000000/
C
C     GENUEGEND KERNSPEICHER VORHANDEN?
C
      IF (ICORE.EQ.0) GOTO 4
      L=IABS(ICORE)-K
      IF (KSK.GT.L) KSK=L
      IF (L .GE. 0) GOTO 1
      L=-L
      L=(L+1023)/1024
      WRITE (6,100) TEXT,K,ICORE,L
100   FORMAT(' ***'/,' *** NEED MORE CORE AT ',A8/,
     *       ' *** NEED ',I10,' IBM+ WORDS'/,
     *       ' *** HAVE ',I10,' IBM+ WORDS'/,
     *       ' *** NEED ',I10,' K WORDS MORE'/,
     *       ' ***')
      Call Abend
C
C     PRINTOUT,ENDE ODER RETURN?
C
1     IC=IABS(ICORE)
      IF (MSK.LT.IC) MSK=IC
      IF (ICORE.GT.0) GOTO 3
      L=MSK-KSK
      IC=(L+1023)/1024
      WRITE (6,101) L,IC
101   FORMAT(' DYNAMIC CORE USED SO FAR ',I10,' WORDS (',I10,
     *'K)')
3     RETURN
C
C     ENDE DER RECHNUNG
C
4     IC=(MSK+1023)/1024
      KSK=MSK-KSK
      L=(KSK+1023)/1024
      WRITE (6,102) MSK,IC,KSK,L
102   FORMAT(' DYNAMIC STORAGE: ',I8,' WORDS (',I5,'K ) - USED ',
     *I8,' WORDS (',I5,'K)'//,
     *' E N D   O F   C A L C U L A T I O N')
      Call Finish(0)
      END
*                                                                      *
************************************************************************
*                                                                      *
      SUBROUTINE CPLAB (A,B,L,M,N,IA,IB,C,IC,IER)
      implicit real*8(a-h,o-z)
Culf      INTEGER            L,M,N,IA,IB,IC,IER
Culf      real*8   A(IA,M),B(IB,N),C(IC,N)
Culf      real*8   TEMP
      DIMENSION   A(IA,M),B(IB,N),C(IC,N)
      IF (IA .GE. L .AND. IB .GE. M .AND. IC .GE. L) GO TO 5
      IER=129
      GO TO 9000
    5 IER = 0
      DO 15 I=1,L
         DO 16 J=1,N
            TEMP=0.0D0
            DO 10 K=1,M
               TEMP=A(I,K)*B(K,J)+TEMP
   10       CONTINUE
            C(I,J)=C(I,J)+TEMP
   16    CONTINUE
   15 CONTINUE
      GO TO 9005
 9000 CONTINUE
 9005 RETURN
      END
*                                                                      *
************************************************************************
*                                                                      *
      SUBROUTINE KBR(BETA,X,RESULT)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     PROGRAM TO CALCULATE CONTINUED FRACTION
C     1/1+ A1*X/1+ A2*X/1+ ...
C
C     V 1.0 - 12.5.86 - BERND HESS
C
C     A(2N+1) = N+BETA
C     A(2N)   = N-1/2
C
      THR=1.D-12
      THR1=1.D-8
      SUM=1.D0
      I=100
1     OLD=SUM
      SUM=1.D0
      J=I
3     SUM=X*(DBLE(J)-0.5D0)/SUM+1.D0
      SUM=X*(DBLE(J)+BETA )/SUM+1.D0
      J=J-1
      IF (J.GT.0) GOTO 3
      SUM=1.D0/(1.D0-0.5D0*X/SUM)
      IF (I.GT.2000) WRITE (6,991) I,BETA,X,SUM
  991 FORMAT(' KBR - I,BETA,X,SUM ',I5,F10.3,D20.10,D30.20)
      I=I+100
      IF (I.LT.300 .OR. abs(OLD-SUM).GT.THR.AND. I.LT.3000) GOTO 1
      RESULT=SUM
      IF (I.LT.3000) RETURN
      DEL=OLD-SUM
      WRITE (6,999) DEL,THR
999   FORMAT(' CONTINUED FRACTION DEL=',D20.10,' LARGER THAN THR=',
     *D20.10)
      IF (DEL.GT.THR1) Call Abend
      RETURN
      END
*                                                                      *
************************************************************************
*                                                                      *
      real*8 FUNCTION DCOF(E,LX,IX)
      IMPLICIT REAL*8(A-H,O-Z)
C
C     FUNCTION DCOF CALCULATES COEFFICIENT D NEEDED FOR FT
C     DCOF(E,LX,IX)= ((-E)**IX * FAK(LX))/(FAK(LX-2*IX)*FAK(IX))
C     V 1.0 - 12.3.86 - BERND HESS
C
      COMMON /CRELOP/ PI,ZWP,SQPI,VELIT,PREA,CSQ,ZWPH32,FAK(26),
     *ZWPH12,BCO(210),GA(20),IMAX
      SAVE /CRELOP/
      I=LX-2*IX
      D=1.D0
      IF (IX.EQ.0) GOTO 2
      DO 3 K=1,IX
      D=-D*E
3     CONTINUE
2     CONTINUE
      D=D*FAK(LX+1)/(FAK(I+1)*FAK(IX+1))
      DCOF=D
      RETURN
      END
*                                                                      *
************************************************************************
*                                                                      *
      real*8 FUNCTION RCPG(XVAL,ODD,EVEN)
      REAL*8 XVAL,ODD,EVEN
C
C     PROCEDURE TO CALCULATE RECIPROCAL OF GAMMA FUNCTION
C
      REAL*8 X,ALFA,BETA,X2,B(12)
      INTEGER I
      DATA B /-.28387 65422 76024D0, -.07685 28408 44786D0,
     *         .00170 63050 71096D0,  .00127 19271 36655D0,
     *         .00007 63095 97586D0, -.00000 49717 36704D0,
     *        -.00000 08659 20800D0, -.00000 00331 26120D0,
     *         .00000 00017 45136D0,  .00000 00002 42310D0,
     *         .00000 00000 09161D0, -.00000 00000 00170D0/
      X=XVAL
      X2=X*X*8.D0
      ALFA=-.00000 00000 00001D0
      BETA=0.D0
      I=12
1     BETA=-(ALFA*2.D0+BETA)
      ALFA=-BETA*X2-ALFA+B(I)
      I=I-2
      IF (I.GE.2) GOTO 1
      EVEN=(0.5D0*BETA+ALFA)*X2-ALFA+0.92187 02936 50453D0
      ALFA=-0.00000 00000 00034D0
      BETA=0.D0
      I=11
2     BETA=-(ALFA*2.D0+BETA)
      ALFA=-BETA*X2-ALFA+B(I)
      I=I-2
      IF (I.GE.1) GOTO 2
      ODD=(ALFA+BETA)*2.D0
      RCPG=ODD*X+EVEN
      RETURN
      END
*                                                                      *
************************************************************************
*                                                                      *
      real*8 FUNCTION SINHX(XVAL)
      REAL*8 XVAL
      REAL*8 AX,Y,X
      X=XVAL
      AX=abs(X)
      IF (AX.GE.0.3D0) GOTO 1
      IF (AX.GE.0.1D0) GOTO 2
      Y=X*X
      GOTO 3
2     Y=X*X/9.D0
3     CONTINUE
      X=(((1.D0/5040D0*Y+1.D0/120.D0)*Y+1.D0/6.D0)*Y+1.D0)*X
      IF (AX.GE.0.1D0) GOTO 5
      SINHX=X
      RETURN
5     SINHX=X*(1.D0+4.D0*X*X/27.D0)
      RETURN
1     AX=EXP(AX)
      SINHX=sign( (0.5D0*(AX-1.D0/AX)),X )
      RETURN
      END
*                                                                      *
************************************************************************
*                                                                      *
C      SQROPY - PROGRAM TO CALCULATE RELATIVISTIC ONE-ELECTRON
C      OPERATORS IN A BASIS SET OF GAUSSIAN FUNCTIONS
C      V 1.0 - 12.3.86 - BERND HESS
C      V 1.1 - 21.5.87 - BERND HESS - NORMALIZED FUNCTIONS
C      SUBROUTINE "RELOP" MUST BE CALLED TO INITITALIZE COMMON
C      BLOCK BEFORE FIRST EXECUTION OF THIS ROUTINE
C      INTEGRALS ARE CALCULATED BETWEEN   NORMALIZED FUNCTIONS
      real*8 FUNCTION SQROPY(AA,AB,LA,MA,NA,LB,MB,NB)
      IMPLICIT REAL*8(A-H,O-Z)
C
C     SUBROUTINE SQROPY CALCULATES MATRIXELEMENT BETWEEN FUNCTION
C     XA**LA * YA**MA * ZA**NA * EXP(-AA*RA**2) AND
C     XB**LB * YB**MB * ZB**NB * EXP(-AB*RB**2)
C     WITH XA=X ,YA=Y ZA=Z
C     V 1.1 - 1.6.86 - BERND HESS
C
      COMMON /CRELOP/ PI,ZWP,SQPI,VELIT,PREA,CSQ,ZWPH32,FAK(26),
     *ZWPH12,BCO(210),GAM(20),IMAX
C@    WRITE (6,922) LA,MA,NA,LB,MB,NB,AA,AB
C@922 FORMAT(' SQROPY ',3I2,2X,3I2,2X,3D14.6)
C
C     WE ALSO NEED OVERLAP. CALCULATE IT IN POSITION SPACE
C
      SQROPY=0.D0
      S=0.D0
      IMAX=LA+MA+NA+LB+MB+NB+3
      IF (IMAX.GT.20) GOTO 1100
      II=LA+LB
      JJ=MA+MB
      KK=NA+NB
      ANG=THETA(II+JJ,KK)*PHI(JJ,II)
C
C     AND USE ANGULAR PART TO DETERMINE IF IT VANISHES BY SYMMETRY
C
      IF (ANG.EQ.0.D0) THEN
       SQROPY=0.D0
       RETURN
      ENDIF
      EX=-0.5D0*DBLE(IMAX)
      OVL=0.5D0*ANG*GAM(IMAX)*((AA+AB)**EX)
C
C     CALCULATE SQR INTEGRAL IN MOMENTUM SPACE
C
      EA=1.D0/(4.D0*AA)
      EB=1.D0/(4.D0*AB)
      DELTA=EA+EB
      LLA=LA+MA+NA
      LLB=LB+MB+NB
      C=((2.D0*AA)**LLA * (2.D0*AB)**LLB)
      C=C*(4.D0*AA*AB)**1.5D0
      C=1.D0/C
      LAX=LA/2+1
      MAX=MA/2+1
      NAX=NA/2+1
      LBX=LB/2+1
      MBX=MB/2+1
      NBX=NB/2+1
C
C     COMPUTE VALUE OF BESSEL FUNCTION
C
      ARG=0.5D0*DELTA*CSQ
      CALL BESSKA(0.D0,ARG,X0,X1)
C#    WRITE (6,901) ARG,X0,X1
C#901 FORMAT(' ARG,X0,X1 ',3D20.10)
C
C     COMPUTE ARGUMENT OF CONTINUED FRACTION
C
      ARG=1.D0/(CSQ*DELTA)
C
C     AND RUN THE TEDIOUS SUM OVER SIMPLE FOURIER INTEGRALS ...
C
      DO 1 IA=1,LAX
      D1=DCOF(AA,LA,IA-1)
      DO 2 JA=1,MAX
      D2=D1*DCOF(AA,MA,JA-1)
      DO 3 KA=1,NAX
      D3=D2*DCOF(AA,NA,KA-1)
      DO 4 IB=1,LBX
      D4=D3*DCOF(AB,LB,IB-1)
      DO 5 JB=1,MBX
      D5=D4*DCOF(AB,MB,JB-1)
      DO 6 KB=1,NBX
      D6=D5*DCOF(AB,NB,KB-1)
      II=LA-2*IA+LB-2*IB+4
      JJ=MA-2*JA+MB-2*JB+4
      KK=NA-2*KA+NB-2*KB+4
C
C     ANGULAR PART OF FOURIER INTEGRAL
C
      IMAX=II+JJ+KK+3
      ANG=THETA(II+JJ,KK)*PHI(JJ,II)
      IF (ANG.EQ.0.D0) GOTO 6
C
C     RADIAL PART
C
      U=X1*D6
      IF (IMAX.EQ.3) GOTO 60
      JMAX=IMAX-1
      DO 70 I=3,JMAX,2
      BET=0.5D0*DBLE(I)
      CALL KBR(BET,ARG,R)
      U=U*R*BET/DELTA
70    CONTINUE
60    CONTINUE
      U=0.25D0*VELIT*U/DELTA
      S=S+U*ANG
6     CONTINUE
5     CONTINUE
4     CONTINUE
3     CONTINUE
2     CONTINUE
1     CONTINUE
      IF (MOD(LLA-LLB,4).EQ.2) S=-S
      S=S*C
      S=CSQ*(S-OVL)
C
C     NORMALIZATION

C
      II=LA+LA
      JJ=MA+MA
      KK=NA+NA
      ANG=THETA(II+JJ,KK)*PHI(JJ,II)
      EX=-0.5D0*DBLE(II+JJ+KK+3)
      OV1=0.5D0*ANG*GAM(II+JJ+KK+3)*((AA+AA)**EX)
C#    WRITE (6,*) ' SRQ  OV1',LA,MA,NA,AA,ANG,sqrt(1/OV1)
      II=LB+LB
      JJ=MB+MB
      KK=NB+NB
      ANG=THETA(II+JJ,KK)*PHI(JJ,II)
      EX=-0.5D0*DBLE(II+JJ+KK+3)
      OV2=0.5D0*ANG*GAM(II+JJ+KK+3)*((AB+AB)**EX)
C#    WRITE (6,*) ' SRQ  OV2',LB,MB,NB,AB,ANG,sqrt(1/OV2)
      SQROPY=S/sqrt(OV1*OV2)
      RETURN
C
C     ANGULAR MOMENTUM TOO LARGE
C
1100  WRITE (6,1101) LA,MA,NA,LB,MB,NB,AA,AB
1101  FORMAT(' *** ANGULAR MOMENTUM TOO LARGE ***'/,
     *6I3,3X,2D17.10)
      Call Abend
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine SECORD(A,B,C,FAC,NAL,NBL,NSIJ,IFT)

use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: A(*), B(*), FAC
real(kind=wp), intent(_OUT_) :: C(*)
integer(kind=iwp), intent(in) :: NAL, NBL, NSIJ, IFT
integer(kind=iwp) :: IAB, NA, NA1, NAA, NB, NBB

IAB = 0
NAA = 0
do NA=1,NAL
  NBB = 0
  NA1 = NBL
  if (NSIJ == 1) NA1 = NA-1
  do NB=1,NA1
    IAB = IAB+1
    if (IFT == 0) C(IAB) = B(NAA+NB)+A(NBB+NA)
    if (IFT == 1) C(IAB) = B(NAA+NB)-A(NBB+NA)
    NBB = NBB+NAL
  end do
  if (NSIJ == 1) then
    IAB = IAB+1
    C(IAB) = FAC*A(NAA+NA)
  end if
  NAA = NAA+NBL
end do

return

end subroutine SECORD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000,2022, Roland Lindh                                *
!               2022, Susi Lehtola                                     *
!***********************************************************************

module libxc_parameters

use xc_f03_lib_m, only: XC_CORRELATION, XC_EXCHANGE, xc_f03_aux_func_ids, xc_f03_aux_func_weights, xc_f03_func_end, &
                        xc_f03_func_get_info, xc_f03_func_info_get_kind, xc_f03_func_info_t, xc_f03_func_init, xc_f03_func_t, &
                        xc_f03_num_aux_funcs
use Constants, only: Zero
use Definitions, only: wp, iwp, LibxcInt

implicit none
private

integer(kind=iwp), parameter :: nFuncs_max = 4
integer(kind=iwp) :: nFuncs = 0
integer(kind=LibxcInt) :: func_id(nFuncs_Max) = 0_LibxcInt
real(kind=wp) :: Coeffs(nFuncs_Max) = Zero
type(xc_f03_func_t) :: xc_func(nFuncs_Max)      ! xc functional
type(xc_f03_func_info_t) :: xc_info(nFuncs_Max) ! xc functional info

public :: Coeffs, func_id, Initiate_Libxc_Functionals, libxc_functionals, nFuncs, nFuncs_max, Remove_Libxc_Functionals

!                                                                      *
!***********************************************************************
!                                                                      *
contains
!                                                                      *
!***********************************************************************
!                                                                      *
subroutine Initiate_Libxc_functionals(nD)

  use nq_Grid, only: l_casdft
  use KSDFT_Info, only: CoefR, CoefX

  integer(kind=iwp), intent(in) :: nD
  integer(kind=iwp) :: iFunc
  real(kind=wp) :: Coeff

  ! if it is a mixed functional and we do MC-PDFT split it up in the components for
  ! further analysis.
  if ((nFuncs == 1) .and. l_casdft) then
    call xc_f03_func_init(xc_func(1),func_id(1),int(nD,kind=LibxcInt))
    nFuncs = max(1,int(xc_f03_num_aux_funcs(xc_func(1))))

    if (nFuncs /= 1) then
      call xc_f03_aux_func_ids(xc_func(1),func_id)
      call xc_f03_aux_func_weights(xc_func(1),Coeffs)
    end if
    call xc_f03_func_end(xc_func(1))

  end if
  do iFunc=1,nFuncs
    ! Initialize libxc functional: nD = 2 means spin-polarized
    call xc_f03_func_init(xc_func(iFunc),func_id(iFunc),int(nD,kind=LibxcInt))
    ! Get the functional's information
    xc_info(iFunc) = xc_f03_func_get_info(xc_func(iFunc))

    ! Reset coefficients according to input

    Coeff = Coeffs(iFunc)
    select case (xc_f03_func_info_get_kind(xc_info(iFunc)))
      case (XC_EXCHANGE)
        Coeff = Coeff*CoefX
      case (XC_CORRELATION)
        Coeff = Coeff*CoefR
    end select
    Coeffs(iFunc) = Coeff

  end do

end subroutine Initiate_Libxc_functionals
!                                                                      *
!***********************************************************************
!                                                                      *
subroutine Remove_Libxc_functionals()

  integer(kind=iwp) :: iFunc

  do iFunc=1,nFuncs
    call xc_f03_func_end(xc_func(iFunc))
  end do
  Coeffs(:) = Zero
  func_id(:) = 0

end subroutine Remove_Libxc_functionals
!                                                                      *
!***********************************************************************
!                                                                      *
subroutine libxc_functionals(mGrid,nD)

  use nq_Grid, only: F_xc, F_xca, F_xcb, l_casdft, vLapl, vRho, vSigma, vTau

  integer(kind=iwp), intent(in) :: mGrid, nD
  integer(kind=iwp) :: iFunc
  real(kind=wp) :: Coeff

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  vRho(:,1:mGrid) = Zero
  if (allocated(vSigma)) vSigma(:,1:mGrid) = Zero
  if (allocated(vTau)) vTau(:,1:mGrid) = Zero
  if (allocated(vLapl)) vLapl(:,1:mGrid) = Zero
  F_xc(1:mGrid) = Zero
  if (l_casdft) then
    F_xca(1:mGrid) = Zero
    F_xcb(1:mGrid) = Zero
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *

  do iFunc=1,nFuncs
    Coeff = Coeffs(iFunc)
    call libxc_interface(xc_func(iFunc),xc_info(iFunc),mGrid,nD,F_xc,Coeff)
  end do

  return

end subroutine libxc_functionals
!                                                                      *
!***********************************************************************
!                                                                      *
end module libxc_parameters

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Inter_PCM(XE,YE,ZE,RE,P1,P2,P3,P4,NS,I,
     +                 IPRINT)
      IMPLICIT REAL*8 (A-H,O-Z)

      Dimension XE(*),YE(*),ZE(*),RE(*)
      DIMENSION P1(3),P2(3),P3(3),P4(3)
C
C     Trova il punto P4, sull`arco P1-P2 sotteso dal centro P3, che
C     si trova sulla superficie della sfera NS
C     P4 e' definito come combinazioe lineare di P1 e P2, con
C     il parametro ALPHA ottimizzato per tentativi.
C

      R2 = (P1(1)-P3(1))**2+(P1(2)-P3(2))**2+(P1(3)-P3(3))**2
      R = sqrt(R2)
      TOL = 1.D-12
      ALPHA = 0.5D0
      DELTA = 0.D0
      M = 1
  10  CONTINUE
      IF(M.GT.100) then
        IF(IPRINT.GT.0)
     +  Write(6,'(/,10X,'' INTER: too many iterations'')')
        Return
      EndIf
      ALPHA = ALPHA + DELTA
      DNORM = 0.D0
      DO 2000 JJ = 1,3
      P4(JJ)=P1(JJ)+ALPHA*(P2(JJ)-P1(JJ))-P3(JJ)
      DNORM = DNORM + P4(JJ)**2
 2000 continue
      DNORM = sqrt(DNORM)
      DO 2010 JJ = 1,3
      P4(JJ)= P4(JJ)*R/DNORM + P3(JJ)
 2010 continue
      DIFF2=(P4(1)-XE(NS))**2 + (P4(2)-YE(NS))**2 + (P4(3)-ZE(NS))**2
      DIFF = sqrt(DIFF2) - RE(NS)
      IF(abs(DIFF).LT.TOL) RETURN
      IF(I.EQ.0) THEN
      IF(DIFF.GT.0.D0) DELTA = 1.D0/(2.D0**(M+1))
      IF(DIFF.LT.0.D0) DELTA = - 1.D0/(2.D0**(M+1))
      M = M + 1
      GOTO 10
      ENDIF
      IF(I.EQ.1) THEN
      IF(DIFF.GT.0.D0) DELTA = - 1.D0/(2.D0**(M+1))
      IF(DIFF.LT.0.D0) DELTA = 1.D0/(2.D0**(M+1))
      M = M + 1
      GOTO 10
      ENDIF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReExpand(rMP,nij,nElem,A,B,ij,lMax)

use Index_Functions, only: nTri3_Elem
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nij, nElem, ij, lMax
real(kind=wp), intent(inout) :: rMP(nij,nElem)
real(kind=wp), intent(in) :: A(3), B(3)
integer(kind=iwp) :: iElem, ix, iy, iz, jElem, jx, jy, jz, k, l
real(kind=wp) :: ABx, ABx_, ABy, ABy_, ABz, ABz_, temp
#include "itmax.fh"
#include "binom.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
!call RecPrt('A',' ',A,1,3)
!call RecPrt('B',' ',B,1,3)
!call RecPrt('rMP',' ',rMP,nij,nElem)
do l=lMax,0,-1
  iElem = nTri3_Elem(l)
  do ix=l,0,-1
    ABx = A(1)-B(1)
    do iy=l-ix,0,-1
      ABy = A(2)-B(2)
      iz = l-ix-iy
      ABz = A(3)-B(3)
      iElem = iElem+1
      !write(u6,*)
      !write(u6,*)
      !write(u6,*) 'ix,iy,iz=',ix,iy,iz
      !write(u6,*)

      temp = Zero
      do jx=0,ix
        do jy=0,iy
          do jz=0,iz
            !write(u6,*) 'jx,jy,jz=',jx,jy,jz

            if (ix-jx == 0) then
              ABx_ = One
            else
              ABx_ = ABx**(ix-jx)
            end if
            if (iy-jy == 0) then
              ABy_ = One
            else
              ABy_ = ABy**(iy-jy)
            end if
            if (iz-jz == 0) then
              ABz_ = One
            else
              ABz_ = ABz**(iz-jz)
            end if
            k = jx+jy+jz
            jElem = nTri3_Elem(k)+(jy+jz)*(jy+jz+1)/2+jz+1
            !write(u6,*) 'jElem=',jElem
            !write(u6,*) binom(ix,jx),binom(iy,jy),binom(iz,jz),rMP(ij,jElem),ABx_,ABy_,ABz_
            temp = temp+binom(ix,jx)*binom(iy,jy)*binom(iz,jz)*rMP(ij,jElem)*ABx_*ABy_*ABz_

          end do
        end do
      end do
      rMP(ij,iElem) = temp

    end do
  end do
end do
!call RecPrt('rMP',' ',rMP,nij,nElem)

return

end subroutine ReExpand

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Per-Olof Widmark                                 *
*               1993,1996,1997, Markus P. Fuelscher                    *
*               1996, Luis Serrano-Andres                              *
*               2012, Victor P. Vysotskiy                              *
*               2016, Steven Vancoillie                                *
************************************************************************
#define MOLCASWRITE AixWr
#define MOLCASREAD  AixRd
      Subroutine DaFile(Lu,iOpt,Buf,lBuf,iDisk)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Control direct access I/O operations                             *
*                                                                      *
*     calling arguments:                                               *
*     Lu      : integer, input                                         *
*               logical unit number (Lu={1,2,...40,50,60,70,80,90}     *
*     iOpt    : integer, input                                         *
*               option code                                            *
*               iOpt= 0 Dummy write. No I/O is made. Disk address is   *
*               updated.                                               *
*               iOpt= 99 dummy read (return buf(1)=1 in success)       *
*               iOpt= 1 synchronous write                              *
*               iOpt= 2 synchronous read                               *
*               iOpt= 5 synchronous rewind                             *
*               iOpt= 6 asynchronous write                             *
*               iOpt= 7 asynchronous read                              *
*               iOpt= 8 position at the end of file (i.e. filesize)    *
*               iOpt=10 asynchronous rewind                            *
*               Note: At present the asynchronous modes are not        *
*                     supported and work identically the synchronous   *
*                     modes                                            *
*     Buf     : array of integers, input/output                        *
*               Buffer carrying/receiving the data to write/read       *
*     lBuf    : integer, input                                         *
*               length of the buffer Buf in bytes!!                    *
*     iDisk   : integer, input/output                                  *
*               disk address                                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, IBM Sweden, 1991                                   *
*     M.P. Fuelscher, University of Lund, Sweden, 1993, 1996, 1997     *
*     L. Serrano-Andres, University of Lund, Sweden, 1996              *
*     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
*----------------------------------------------------------------------*
*                                                                      *
* History:                                                             *
*     Steven Vancoillie: use of byte lengths/offests (2016)            *
*                                                                      *
************************************************************************

      Implicit Integer (A-Z)

#include "SysDef.fh"
#include "blksize.fh"
#include "fio.fh"
#ifdef _OLD_IO_STAT_
#include "ofio.fh"
#endif
#include "warnings.fh"
      Dimension Buf(*)
      Character*80 Text,HeadErr

      Character*16 TheName
      Data TheName/'DaFile'/
      Integer iRc
      Data    iRc/0/


      Call DaFile_checkarg(Lu,iOpt,lBuf,iDisk)
C****************** REAL I/O IS HERE **************
      lDisk    = iDisk
*     Write to  disk
      If ( (iOpt.eq.1) .or. (iOpt.eq.6) ) then
        HeadErr='Premature abort while writing buffer to disk'
*lock
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
        If(isFiM(Lu).eq.0) then
#endif
          iRc = MOLCASWRITE(FSCB(Lu),Buf,lBuf,lDisk)
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
        Else
          iRc = FimWr(FSCB(Lu),Buf,lBuf,lDisk)
          If(iRc.eq.-10)Then
            isFiM(Lu)=0
            iRc = MOLCASWRITE(FSCB(Lu),Buf,lBuf,lDisk)
          End If
        End If
#endif
*unlock
*     Read from disk
      Else If ( (iOpt.eq.2) .or. (iOpt.eq.7) .or. (iOpt.eq.99)) then
        HeadErr='Premature abort while reading buffer from disk'
C10    Continue
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
        If (isFiM(Lu).eq.0) then
#endif
           if(iOpt.ne.99) then
             iRc = MOLCASREAD(FSCB(Lu),Buf,lBuf,lDisk,0)
           else
             iRc = MOLCASREAD(FSCB(Lu),Buf,lBuf,lDisk,1)
             Buf(1)=0
             if(iRc.eq.0) Buf(1)=1
             return
           endif
#if defined (_HAVE_EXTRA_) && ! defined (_GA_)
        Else
           iRc = FimRd(FSCB(Lu),Buf,lBuf,lDisk)
        End If
#endif
      End if

      If ( iRc.ne.0 ) goto 1200

#ifdef _OLD_IO_STAT_
        MxAddr(Lu)  = Max(MxAddr(Lu),Addr(Lu))
        if(iOpt.ne.0) Then
           Count(3,Lu) = Count(3,Lu)+1
           Count(4,Lu) = Count(4,Lu)+dble(lBuf)/1024.0d0
        End if
#endif
      iDisk       = iDisk+lBuf
      Addr(Lu)    = iDisk
      If ( Trace ) Write (6,*) ' >>> Exit DaFile <<<'

      Return

1200  iRc = AixErr(Text)
      write (6,*) HeadErr
      write (6,*) Text
      write (6,*) ' Unit      :',Lu
      write (6,*) ' Option    :',iOpt
      write (6,*) ' Buffer    :',lBuf
      write (6,*) ' Address   :',iDisk
      call quit(_RC_IO_ERROR_WRITE_)
      End


      Subroutine DaFile_checkarg(Lu,iOpt,lBuf,iDisk)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Check arguments to iDafile                                       *
*                                                                      *
*     calling arguments:                                               *
*     Lu      : integer, input                                         *
*               logical unit number (Lu={1,2,...40,50,60,70,80,90}     *
*     iOpt    : integer, input                                         *
*               valid values: 0,1,2,5,6,7,8,10,99                      *
*     lBuf    : integer, input                                         *
*               length of the buffer Buf:   0<lBuf<2**29(2**60)        *
*     iDisk   : integer, input/output                                  *
*               disk address  >=0                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     V.P. Vysotskiy, University of Lund, Sweden, 2012                 *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
#include "fio.fh"
      Character*16 TheName
      Data TheName/'DaFile_checkarg'/
*2012
*VpV: a lot of checking is here.
*     Check arguments
      If ( (Lu.le.0) .or. (Lu.gt.MxFile) )
     * Call SysFileMsg(TheName,'MSG: unit', Lu,' ')

      If ( isOpen(Lu).eq.0 )
     * Call SysFileMsg(TheName,'MSG: not opened', Lu,' ')

      If ( lBuf.lt.0) then
          write (6,*) 'Invalid buffer size ',lBuf
          goto 1000
      End If

      If ( iDisk.lt.0 ) then
         write (6,*) 'Invalid disk address ',iDisk
         goto 1000
      endif

      If ( (iOpt.lt.0) .or. (iOpt.gt.10.and.iOpt.ne.99) ) then
         write (6,*) 'Invalid action code ',iOpt
         goto 1000
      endif

      If (iOpt.eq.3.or.iOpt.eq.4.or.iOpt.eq.9) then
        Write (6,*) 'DaFile: GSlist option is not in operation!'
        goto 1000
      End If

      return

1000  write (6,*) 'I/O error in ',TheName
      write (6,*) 'Unit = ',Lu
      Call Abend()

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE GSDNBB2(I12,RHO1,RHO2,
     &                  IASM,IATP,IBSM,IBTP,JASM,JATP,JBSM,JBTP,
     &                  NGAS,IAOC,IBOC,JAOC,JBOC,
     &                  NAEL,NBEL,
     &                  IJAGRP,IJBGRP,
     &                  SB,CB,C2,
     &                  ADSXA,SXSTST,STSTSX,DXSTST,STSTDX,SXDXSX,
     &                  MXPNGAS,NOBPTS,IOBPTS,MAXI,MAXK,
     &                  SSCR,CSCR,I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,
     &                  X,NSMOB,NSMST,NSMSX,NSMDX,
     &                  NIA,NIB,NJA,NJB,MXPOBS,IPRNT,NACOB,RHO1S,
     &                  ieaw,n1,n2)
*
* Contributions to density matrix from sigma block (iasm iatp, ibsm ibtp ) and
* C block (jasm jatp , jbsm, jbtp)
*
* =====
* Input
* =====
*
* IASM,IATP : Symmetry and type of alpha strings in sigma
* IBSM,IBTP : Symmetry and type of beta  strings in sigma
* JASM,JATP : Symmetry and type of alpha strings in C
* JBSM,JBTP : Symmetry and type of beta  strings in C
* NGAS : Number of As'es
* IAOC : Occpation of each AS for alpha strings in L
* IBOC : Occpation of each AS for beta  strings in L
* JAOC : Occpation of each AS for alpha strings in R
* JBOC : Occpation of each AS for beta  strings in R
* NAEL : Number of alpha electrons
* NBEL : Number of  beta electrons
* IJAGRP    : IA and JA belongs to this group of strings
* IJBGRP    : IB and JB belongs to this group of strings
* CB : Input c block
* ADASX : sym of a+, a => sym of a+a
* ADSXA : sym of a+, a+a => sym of a
* SXSTST : Sym of sx,!st> => sym of sx !st>
* STSTSX : Sym of !st>,sx!st'> => sym of sx so <st!sx!st'>
*          is nonvanishing by symmetry
* DXSTST : Sym of dx,!st> => sym of dx !st>
* STSTDX : Sym of !st>,dx!st'> => sym of dx so <st!dx!st'>
*          is nonvanishing by symmetry
* MXPNGAS : Largest number of As'es allowed by program
* NOBPTS  : Number of orbitals per type and symmetry
* IOBPTS : base for orbitals of given type and symmetry
* IBORB  : Orbitals of given type and symmetry
* MAXI   : Largest Number of ' spectator strings 'treated simultaneously
* MAXK   : Largest number of inner resolution strings treated at simult.
*
* ieaw=0 Singlet
* ieaw=1 Triplet
* ======
* Output
* ======
* Rho1, RHo2 : Updated density blocks
* =======
* Scratch
* =======
* SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the
*              largest number of orbital pairs of given symmetries and
*              types.
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* I1, XI1S   : at least MXSTSO : Largest number of strings of given
*              type and symmetry
* C2 : Must hold largest STT block of sigma or C
*
* XINT : Scratch space for integrals.
*
* Jeppe Olsen , Winter of 1991
*
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER ADSXA(*)
      INTEGER SXSTST(*),STSTSX(*),DXSTST(*),STSTDX(*),SXDXSX(*)
*. Input
      DIMENSION CB(*),SB(*)
*. Output
      DIMENSION RHO1(n1,*),RHO2(n2,*)
*. Scratch
      DIMENSION SSCR(*),CSCR(*)
      DIMENSION  I1(*),XI1S(*),I2(*),XI2S(*),I3(*),XI3S(*),I4(*),XI4S(*)
      DIMENSION C2(*),RHO1S(*),X(*)
      DIMENSION IAOC(*),IBOC(*),JAOC(*),JBOC(*),NOBPTS(*),IOBPTS(*)
      DIMENSION ITSOB(1)
*
      IACTIVE = 0
*
      iUseab=0
      ii=1
      If (ieaw.eq.1) ii=2
      IF(NBEL.GE.1.AND.IATP.EQ.JATP.AND.JASM.EQ.IASM) THEN
*
* =============================
*  beta contribution to RHO1
* =============================
*
        CALL GSBBD1(RHO1(1,ii),
     &       NACOB,IBSM,IBTP,JBSM,JBTP,IJBGRP,NIA,
     &       NGAS,IBOC,JBOC,
     &       SB,CB,
     &       ADSXA,SXSTST,STSTSX,MXPNGAS,
     &       NOBPTS,IOBPTS,ITSOB,MAXI,MAXK,
     &       SSCR,CSCR,I1,XI1S,I2,XI2S,X(1),
     &       NSMOB,NSMST,NSMSX,MXPOBS,RHO1S)
*
* ================================
* beta-beta contribution to RHO2
* ================================
*
        ii=1
        If (ieaw.eq.1) ii=2
        IF(I12.EQ.2.AND.NBEL.GE.2) THEN
          CALL GSBBD2A(RHO2(1,ii),
     &         NACOB,IBSM,IBTP,JBSM,JBTP,IJBGRP,NIA,
     &         NGAS,IBOC,JBOC,SB,CB,
     &         ADSXA,SXSTST,STSTSX,SXDXSX,MXPNGAS,
     &         NOBPTS,IOBPTS,MAXI,MAXK,
     &         SSCR,CSCR,I1,XI1S,I2,XI2S,X,
     &         NSMOB,NSMST,NSMSX,MXPOBS)
*
        END IF
      END IF
*
      IF(NAEL.GE.1.AND.IBTP.EQ.JBTP.AND.IBSM.EQ.JBSM) THEN
*
* =============================
*  alpha contribution to RHO1
* =============================
*
        ii=1
        CALL TRPMT3(CB,NJA,NJB,C2)
        CALL COPVEC(C2,CB,NJA*NJB)
        CALL TRPMT3(SB,NIA,NIB,C2)
        CALL COPVEC(C2,SB,NIA*NIB)
        CALL GSBBD1(RHO1(1,ii),
     &                   NACOB,IASM,IATP,JASM,JATP,IJAGRP,NIB,
     &                   NGAS,IAOC,JAOC,
     &                   SB,CB,
     &                   ADSXA,SXSTST,STSTSX,MXPNGAS,
     &                   NOBPTS,IOBPTS,ITSOB,MAXI,MAXK,
     &                   SSCR,CSCR,I1,XI1S,I2,XI2S,X(1),
     &                   NSMOB,NSMST,NSMSX,MXPOBS,RHO1S)
*
* ===================================
*  alpha-alpha contribution to RHO2
* ===================================
*
        ii=1
        IF(I12.EQ.2.AND.NAEL.GE.2) THEN
          CALL GSBBD2A(RHO2(1,ii),
     &         NACOB,IASM,IATP,JASM,JATP,IJAGRP,NIB,
     &         NGAS,IAOC,JAOC,SB,CB,
     &         ADSXA,SXSTST,STSTSX,SXDXSX,MXPNGAS,
     &         NOBPTS,IOBPTS,MAXI,MAXK,
     &         SSCR,CSCR,I1,XI1S,I2,XI2S,X,
     &         NSMOB,NSMST,NSMSX,MXPOBS)
        END IF
        CALL TRPMT3(CB,NJB,NJA,C2)
        CALL COPVEC(C2,CB,NJA*NJB)
        CALL TRPMAT(SB,NIB,NIA,C2)
        CALL COPVEC(C2,SB,NIB*NIA)
      END IF
*
* ===================================
*  alpha-beta contribution to RHO2
* ===================================
*
      ii=1
      If (ieaw.eq.1) ii=3
      IF(I12.EQ.2.AND.NAEL.GE.1.AND.NBEL.GE.1) THEN
*. Routine uses transposed blocks
        CALL TRPMT3(CB,NJA,NJB,C2)
        CALL COPVEC(C2,CB,NJA*NJB)
        CALL TRPMT3(SB,NIA,NIB,C2)
        CALL COPVEC(C2,SB,NIA*NIB)
        CALL GSBBD2B(RHO2(1,ii),
     &                    IASM,IATP,IBSM,IBTP,NIA,NIB,
     &                    JASM,JATP,JBSM,JBTP,NJA,NJB,
     &                    IJAGRP,IJBGRP,NGAS,
     &                    IAOC(1),IBOC(1),JAOC(1),JBOC(1),
     &                    SB,CB,ADSXA,STSTSX,MXPNGAS,
     &                    NOBPTS,IOBPTS,MAXK,
     &                    I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,X,
     &                    NSMOB,NSMST,NSMSX,NSMDX,MXPOBS,IUSEAB,
     &                    SSCR,CSCR,NACOB,NTEST,ieaw)
        CALL TRPMT3(CB,NJB,NJA,C2)
        CALL COPVEC(C2,CB,NJA*NJB)
        CALL TRPMAT(SB,NIB,NIA,C2)
        CALL COPVEC(C2,SB,NIB*NIA)
      END IF
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        Call Unused_integer_array(DXSTST)
        Call Unused_integer_array(STSTDX)
        Call Unused_integer(IPRNT)
      END IF
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

function Occ2Mrs(NO,IARRAY)

use Definitions, only: iwp

implicit none
integer(kind=iwp) :: Occ2Mrs
integer(kind=iwp), intent(in) :: NO, IARRAY(NO)
integer(kind=iwp) :: I, POW2

OCC2MRS = 0
POW2 = 1
do I=1,NO
  if (IARRAY(I) /= 0) OCC2MRS = OCC2MRS+POW2
  POW2 = 2*POW2
end do

return

end function Occ2Mrs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Roland Lindh                                     *
!***********************************************************************

subroutine CloseP()
!***********************************************************************
!                                                                      *
! Object: to close the handling of the 2nd order density matrix.       *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!***********************************************************************

use pso_stuff, only: B_PT2, Bin, Case_MP2, CMO, CMOPT2, D0, DS, DSVar, DVar, G1, G2, G_Toc, Gamma_On, iOffAO, lPSO, LuGam, &
                     LuGamma, LuGamma2, LuGamma_PT2, SO2cI, SSDM, WRK1, WRK2
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
logical(kind=iwp) :: DoCholesky
character(len=8) :: Method_chk

call Get_cArray('Relax Method',Method_chk,8)
if (Method_chk == 'CASPT2  ') then
  if (allocated(iOffAO)) then
    ! Conventional ERIs
    call mma_deallocate(iOffAO)
    close(LuGamma_PT2)
    call mma_deallocate(CMOPT2)
    if (allocated(SSDM)) call mma_deallocate(SSDM)
    call mma_deallocate(WRK1)
    call mma_deallocate(WRK2)
  else
    ! RI/Cholesky ERIs
    call mma_deallocate(B_PT2)
    close(LuGamma2)
  end if
end if

if (case_mp2) then
  call DecideOnCholesky(DoCholesky)
  if (.not. DoCholesky) call DaClos(LuGam)
end if
!*********** columbus interface ****************************************
if (Gamma_On) then
  call DaClos(LuGamma)
  call mma_deallocate(Bin)
  call mma_deallocate(G_Toc)
  call mma_deallocate(SO2cI)
end if

if (lPSO) then
  call mma_deallocate(G2)
  call mma_deallocate(G1)
end if

call mma_deallocate(CMO)
call mma_deallocate(DSVar)
call mma_deallocate(DS)
call mma_deallocate(DVar)
call mma_deallocate(D0)

end subroutine CloseP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!********************************************************
!** Public-domain library routines used by casvb only. **
!********************************************************
!**********************
!** EISPACK ROUTINES **
!**********************

subroutine tred1(nm,n,a,d,e,e2)
! this subroutine is a translation of the algol procedure tred1,
! num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
! handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
!
! this subroutine reduces a real symmetric matrix
! to a symmetric tridiagonal matrix using
! orthogonal similarity transformations.
!
! on input
!
!    nm must be set to the row dimension of two-dimensional
!      array parameters as declared in the calling program
!      dimension statement.
!
!    n is the order of the matrix.
!
!    a contains the real symmetric input matrix.  only the
!      lower triangle of the matrix need be supplied.
!
! on output
!
!    a contains information about the orthogonal trans-
!      formations used in the reduction in its strict lower
!      triangle.  the full upper triangle of a is unaltered.
!
!    d contains the diagonal elements of the tridiagonal matrix.
!
!    e contains the subdiagonal elements of the tridiagonal
!      matrix in its last n-1 positions.  e(1) is set to zero.
!
!    e2 contains the squares of the corresponding elements of e.
!      e2 may coincide with e if the squares are not needed.
!
! questions and comments should be directed to burton s. garbow,
! mathematics and computer science div, argonne national laboratory
!
! this version dated august 1983.
!
! Updated to Fortran 90+ (Sep. 2023)
! ----------------------------------------------------------------------

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nm, n
real(kind=wp), intent(inout) :: a(nm,n)
real(kind=wp), intent(out) :: d(n), e(n), e2(n)
integer(kind=iwp) :: i, ii, j, jp1, k, l
real(kind=wp) :: f, g, h, scl

d(:) = a(n,:)
do i=1,n
  a(n,i) = a(i,i)
end do
! .......... for i=n step -1 until 1 do -- ..........
do ii=1,n
  i = n+1-ii
  l = i-1
  h = Zero
  ! .......... scale row (algol tol then not needed) ..........
  scl = sum(abs(d(1:l)))

  if (scl == Zero) then

    do j=1,l
      d(j) = a(l,j)
      a(l,j) = a(i,j)
      a(i,j) = Zero
    end do

    e(i) = Zero
    e2(i) = Zero

  else

    do k=1,l
      d(k) = d(k)/scl
      h = h+d(k)*d(k)
    end do

    e2(i) = scl*scl*h
    f = d(l)
    g = -sign(sqrt(h),f)
    e(i) = scl*g
    h = h-f*g
    d(l) = f-g
    if (l /= 1) then
      ! .......... form a*u ..........
      e(1:l) = Zero

      do j=1,l
        f = d(j)
        g = e(j)+a(j,j)*f
        jp1 = j+1

        g = g+sum(a(jp1:l,j)*d(jp1:l))
        e(jp1:l) = e(jp1:l)+a(jp1:l,j)*f

        e(j) = g
      end do
      ! .......... form p ..........
      e(1:l) = e(1:l)/h
      f = sum(e(1:l)*d(1:l))

      h = f/(h+h)
      ! .......... form q ..........
      e(1:l) = e(1:l)-h*d(1:l)
      ! .......... form reduced a ..........
      do j=1,l
        f = d(j)
        g = e(j)

        a(j:l,j) = a(j:l,j)-f*e(j:l)-g*d(j:l)

      end do
    end if

    do j=1,l
      f = d(j)
      d(j) = a(l,j)
      a(l,j) = a(i,j)
      a(i,j) = f*scl
    end do

  end if

end do

return

end subroutine tred1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine LDF_ComputeCBar(iAtomPair,ip_CBar,l_CBar,ip_Z,l_Z,irc)
C
C     Thomas Bondo Pedersen, June 2010.
C
C     Input:
C        iAtomPair - index of atom pair in atom pair list
C
C     Output:
C        ip_CBar, l_CBar - pointer and dimension of array
C                          containing CBar
C        ip_Z, l_Z - pointer and dimension of array containing Z
C        irc - return code
C
C     Return codes:
C        irc=-1: input error (iAtomPair out of bounds)
C        irc=0:  all is fine
C        irc=1:  internal error
C
C     Purpose:
C
C     Compute
C
C        CBar[uv,J] = { (uv|J) - sum(I=1,J-1) CBar[uv,I]*Z[J,I] }/Z[J,J]
C
C     where
C
C        sum(K) Z[I,K]*Z[J,K] = G[I,J] = (I|J)
C
C     and u and v are basis functions centered on atom iAtom and jAtom,
C     respectively. (The atom pair iAtomPair implies iAtom and jAtom.)
C     The auxiliary basis functions are taken from the
C     union of the sets on atom iAtom and atom jAtom plus two-center
C     functions (if any, and if iAtom != jAtom). Z vectors are computed
C     locally and discarded. If iAtom=jAtom, the Cbar array is packed
C     according to u>=v (triangular storage), else it is rectangular.
C
C     If linear dependence in the auxiliary basis is detected, the
C     linearly dependent functions are removed (atom pair info will be
C     updated to reflect the changes).
C
      Implicit None
      Integer iAtomPair
      Integer ip_CBar, l_CBar
      Integer ip_Z, l_Z
      Integer irc
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

      Character*15 SecNam
      Parameter (SecNam='LDF_ComputeCBar')

      Integer iAtom, jAtom
      Integer nBas_iAtom, nBas_jAtom
      Integer M
      Integer ip_G, l_G
      Integer nuv, ip_this_vec

      Real*8 ZJJ_inv

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair

      Integer i, j
      Integer iTri, AP_Atoms
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Initializations
      irc=0
      ip_CBar=0
      l_CBar=0
      ip_Z=0
      l_Z=0
#if defined (_DEBUGPRINT_)
      If (iAtomPair.lt.1 .or. iAtomPair.gt.NumberOfAtomPairs) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': iAtomPair out of bounds:',iAtomPair
         irc=-1
         Return
      End If
#endif

      ! Get atoms corresponding to atom pair iAtomPair
      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)

      ! Get number of auxiliary basis functions
      M=LDF_nBasAux_Pair(iAtomPair)

      ! Get number of basis functions on each atom
      nBas_iAtom=LDF_nBas_Atom(iAtom)
      nBas_jAtom=LDF_nBas_Atom(jAtom)
      nuv=nBas_iAtom*nBas_jAtom

      ! Allocate CBar array
      l_CBar=nuv*M
      Call GetMem('CBar','Allo','Real',ip_CBar,l_CBar)

      ! Allocate G matrix
      l_G=M*M
      Call GetMem('GMatrix','Allo','Real',ip_G,l_G)

      ! Set index arrays (IndxG, IndxG2, 2CList)
      Call LDF_SetIndxG(iAtomPair)

      ! Compute G matrix
      Call LDF_ComputeGMat(iAtomPair,M,Work(ip_G))

      ! Compute Z vectors by CD of G
      ! (CBar may be used as work space)
      ! Linear dependence is handled here.
      ! Z vectors are stored as lower triangle.
      Call LDF_ComputeZVec(iAtomPair,ip_CBar,l_Cbar,ip_G,l_G,ip_Z,l_Z,
     &                     irc)
      If (irc.ne.0) Then
         Write(6,'(A,A,I8)')
     &   SecNam,': LDF_ComputeZVec returned code',irc
         irc=1
         Call LDF_UnsetIndxG()
         Call GetMem('GMatrix','Free','Real',ip_G,l_G)
         Call GetMem('CBar','Free','Real',ip_CBar,l_CBar)
         Return
      End If

      ! Unset index arrays for G
      Call LDF_UnsetIndxG()

      ! Deallocate G matrix
      Call GetMem('GMatrix','Free','Real',ip_G,l_G)

      ! Resize CBar array if needed
      If (LDF_nBasAux_Pair(iAtomPair).lt.M) Then
         Call GetMem('CBar','Free','Real',ip_CBar,l_CBar)
         M=LDF_nBasAux_Pair(iAtomPair)
         l_CBar=nuv*M
         Call GetMem('CBar','Allo','Real',ip_CBar,l_CBar)
      End If

      ! Set index arrays for G, including newly detected lin dep
      Call LDF_SetIndxG(iAtomPair)

      ! Compute integrals (uv|J), store in CBar
      Call LDF_ComputeIntegrals_uvJ(iAtomPair,l_Cbar,Work(ip_CBar))

      ! Unset index arrays for G
      Call LDF_UnsetIndxG()

      ! Compute CBar:
      ! CBar[uv,J] = { (uv|J) - sum(I=1,J-1) CBar[uv,I]*Z[J,I] }/Z[J,J]
      Do J=1,M
         ! Compute CBar[uv,J]
         ZJJ_inv=1.0d0/Work(ip_Z-1+iTri(J,J))
         ip_this_vec=ip_CBar+nuv*(J-1)
         Call dScal_(nuv,ZJJ_inv,Work(ip_this_vec),1)
         ! Subtract from all subsequent integrals
         Do I=J+1,M
            Call dAXPY_(nuv,-Work(ip_Z-1+iTri(I,J)),
     &                 Work(ip_this_vec),1,
     &                 Work(ip_CBar+nuv*(I-1)),1)
         End Do
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine undepend_cvb(chr1,chr2)
      implicit real*8 (a-h,o-z)
      character*(*) chr1,chr2
#include "make_cvb.fh"

      ic=3
50    continue

      iobj=0
      jobj=0
      do 100 i=1,nobj
      if(charobj(i).eq.chr1)iobj=i
      if(charobj(i).eq.chr2)jobj=i
100   continue
      if(iobj.eq.0)then
        if(mustdeclare)then
          write(6,*)' Make object not found :',chr1
          call abend_cvb()
        endif
        call decl_cvb(chr1)
        goto 50
      endif
      if(jobj.eq.0)then
        if(mustdeclare)then
          write(6,*)' Make object not found :',chr2
          call abend_cvb()
        endif
        call decl_cvb(chr2)
        goto 50
      endif

      if(iprint.ge.10)write(6,*)' Cancel I depends on J :',iobj,jobj
      n_cancelled=0
      if(mod(ic,2).eq.1)then
190     continue
        do 200 i=ioffs(iobj)+1,ioffs(iobj+1)
        if(i_dep_on_j(i).eq.jobj)then
          do 300 j=i,ioffs(nobj+1)-1
          i_dep_on_j(j)=i_dep_on_j(j+1)
300       continue
          do 400 ii=iobj+1,nobj+1
          ioffs(ii)=ioffs(ii)-1
400       continue
          n_cancelled=n_cancelled+1
          goto 190
        endif
200     continue
      endif

      m_cancelled=0
      if(ic.ge.2)then
490     continue
        do 500 i=joffs(jobj)+1,joffs(jobj+1)
        if(j_dep_on_i(i).eq.iobj)then
          do 600 j=i,joffs(nobj+1)-1
          j_dep_on_i(j)=j_dep_on_i(j+1)
600       continue
          do 700 ii=jobj+1,nobj+1
          joffs(ii)=joffs(ii)-1
700       continue
          m_cancelled=m_cancelled+1
          goto 490
        endif
500     continue
      endif

      ndep_ij=ndep_ij-n_cancelled
      ndep_ji=ndep_ji-m_cancelled
      return
      end

      subroutine undepend2_cvb(chr1,chr2,ic1)
      implicit real*8 (a-h,o-z)
      character*(*) chr1,chr2
#include "make_cvb.fh"
      ic=ic1
50    continue

      iobj=0
      jobj=0
      do 100 i=1,nobj
      if(charobj(i).eq.chr1)iobj=i
      if(charobj(i).eq.chr2)jobj=i
100   continue
      if(iobj.eq.0)then
        if(mustdeclare)then
          write(6,*)' Make object not found :',chr1
          call abend_cvb()
        endif
        call decl_cvb(chr1)
        goto 50
      endif
      if(jobj.eq.0)then
        if(mustdeclare)then
          write(6,*)' Make object not found :',chr2
          call abend_cvb()
        endif
        call decl_cvb(chr2)
        goto 50
      endif

      if(iprint.ge.10)write(6,*)' Cancel I depends on J :',iobj,jobj
      n_cancelled=0
      if(mod(ic,2).eq.1)then
190     continue
        do 200 i=ioffs(iobj)+1,ioffs(iobj+1)
        if(i_dep_on_j(i).eq.jobj)then
          do 300 j=i,ioffs(nobj+1)-1
          i_dep_on_j(j)=i_dep_on_j(j+1)
300       continue
          do 400 ii=iobj+1,nobj+1
          ioffs(ii)=ioffs(ii)-1
400       continue
          n_cancelled=n_cancelled+1
          goto 190
        endif
200     continue
      endif

      m_cancelled=0
      if(ic.ge.2)then
490     continue
        do 500 i=joffs(jobj)+1,joffs(jobj+1)
        if(j_dep_on_i(i).eq.iobj)then
          do 600 j=i,joffs(nobj+1)-1
          j_dep_on_i(j)=j_dep_on_i(j+1)
600       continue
          do 700 ii=jobj+1,nobj+1
          joffs(ii)=joffs(ii)-1
700       continue
          m_cancelled=m_cancelled+1
          goto 490
        endif
500     continue
      endif

      ndep_ij=ndep_ij-n_cancelled
      ndep_ji=ndep_ji-m_cancelled
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016,2017, Giovanni Li Manni                           *
*               2019-2021, Oskar Weser                                 *
*               2021, Werner Dobrautz                                  *
*               2021-2023, Arta Safari                                 *
************************************************************************

      module fciqmc_read_RDM
#ifdef _HDF5_
      use mh5, only: mh5_open_file_r, mh5_close_file, mh5_put_dset,
     &               mh5_open_group, mh5_close_group,
     &               mh5_open_dset, mh5_close_dset, mh5_fetch_dset,
     &               mh5_get_dset_dims
      use index_symmetry, only : one_el_idx
      use RASWFn, only: wfn_dens, wfn_spindens
#endif
      use fortran_strings, only: str
      use definitions, only: wp, u6
      use stdalloc, only: mma_allocate, mma_deallocate
      use para_info, only: myRank
      use rasscf_global, only : NRoots, iAdr15, NAc
      use general_data, only : nActEl
      use index_symmetry, only : two_el_idx_flatten,
     &                           one_el_idx_flatten
      use CI_solver_util, only: CleanMat, RDM_to_runfile
      use linalg_mod, only: abort_, verify_

      implicit none

#include "intent.fh"

      private
      public :: read_neci_RDM, cleanup, dump_fciqmc_mats,
     &          MCM7, WRMA
      logical, save :: MCM7 = .false., WRMA = .false.

      contains

!>  @brief
!>    Read NECI RDM files
!>
!>  @author Werner Dobrautz, Oskar Weser
!>
!>  @details
!>  Read the spin-free TwoRDM file written by the GUGA-NECI
!>  implementation and transfer them to Molcas.
!>  The spin density is set to zero, because spin projection
!>  is not properly defined in the GUGA framework.

!>  @param[in]  iroot
!>  @param[in]  weight
!>  @param[in]  tGUGA
!>  @param[in]  ifinal
!>  @param[out] DMAT Average spin-free 1 body density matrix
!>  @param[out] DSPN spin-dependent 1-RDM
!>  @param[out] PSMAT Average spin-free 2 body density matrix
!>  @param[out] PAMAT 'fake' Average antisymm. 2-dens matrix


      subroutine read_neci_RDM(
     &    iroot, weight, tGUGA, ifinal, DMAT, DSPN, PSMAT, PAMAT)

          ! wrapper around `read_single_neci_(GUGA)_RDM` to average
          ! normal and GUGA density matrices for stochastic SA-MCSCF.

          integer(wp), intent(in) :: iroot(:), ifinal
          real(wp), intent(in) :: weight(:)
          logical, intent(in) :: tGUGA
          real(wp), intent(out) :: dmat(:), dspn(:), psmat(:), pamat(:)
          integer :: i, j, jDisk
          real(wp), allocatable :: temp_dmat(:), temp_dspn(:),
     &                             temp_psmat(:), temp_pamat(:)
#ifdef _HDF5_
          real(wp) :: decompr_dmat(nac,nac), decompr_dspn(nac,nac)
#endif

          ! position in memory to write density matrices to JOBIPH
          jDisk = iAdr15(3)

          ! prevent stackoverflow
          call mma_allocate(temp_DMAT, size(DMAT))
          call mma_allocate(temp_DSPN, size(DSPN))
          call mma_allocate(temp_PSMAT, size(PSMAT))
          call mma_allocate(temp_PAMAT, size(PAMAT))

          DMAT(:) = 0.0_wp; DSPN(:) = 0.0_wp
          PSMAT(:) = 0.0_wp; PAMAT(:) = 0.0_wp

          do i = 1, NRoots
              do j = 1, size(iroot)
                  if (iroot(j) == i) then
                      if (tGUGA) then
                          call read_single_neci_GUGA_RDM(
     &                        iroot(j), temp_DMAT, temp_DSPN,
     &                        temp_PSMAT, temp_PAMAT
     &                    )
#ifdef _HDF5_
                      else if (MCM7) then
                          call read_hdf5_denmats(iroot(j), temp_DMAT,
     &                        temp_DSPN, temp_PSMAT, temp_PAMAT)
#endif
                      else
                          call read_single_neci_RDM(
     &                        iroot(j), temp_DMAT, temp_DSPN,
     &                        temp_PSMAT, temp_PAMAT
     &                    )
                      end if

                      DMAT  = DMAT  + weight(j) * temp_DMAT
                      DSPN  = DSPN  + weight(j) * temp_DSPN
                      PSMAT = PSMAT + weight(j) * temp_PSMAT
                      PAMAT = PAMAT + weight(j) * temp_PAMAT

                      ! state-specific Natural Occupation numbers
                      if (ifinal > 1) then
                          call RDM_to_runfile(
     &                       temp_DMAT, temp_DSPN, temp_PSMAT,
     &                       temp_PAMAT, jDisk
     &                    )
#ifdef _HDF5_
                          ! final iteration load decompressed 1PDMs in
                          ! HDF5 file.
                          decompr_dmat(:,:) = 0.0_wp
                          decompr_dspn(:,:) = 0.0_wp
                          decompr_dmat = expand_1rdm(temp_dmat)
                          decompr_dspn = expand_1rdm(temp_dspn)
                          call mh5_put_dset(wfn_dens,
     &                                      decompr_dmat,
     &                                      [nac, nac, 1],
     &                                      [0, 0, iroot(j) - 1])
                          call mh5_put_dset(wfn_spindens,
     &                                      decompr_dspn,
     &                                      [nac, nac, 1],
     &                                      [0, 0, iroot(j) - 1])
#endif

                      end if
                  end if
              end do
          end do

          call mma_deallocate(temp_DMAT)
          call mma_deallocate(temp_DSPN)
          call mma_deallocate(temp_PSMAT)
          call mma_deallocate(temp_PAMAT)

          ! Averaged RDM during orb rotation iterations
          if (ifinal == 0) then
              call RDM_to_runfile(
     &            DMAT, DSPN, PSMAT, PAMAT, jDisk
     &        )
          end if

      end subroutine read_neci_RDM


      subroutine read_single_neci_GUGA_RDM(
     &  iroot, DMAT, DSPN, PSMAT, PAMAT
     & )
          use PrintLevel, only: DEBUG
          use output_ras, only: IPRLOC
          integer, intent(in) :: iroot
          real(wp), intent(out) :: DMAT(:), DSPN(:), PSMAT(:), PAMAT(:)
          integer :: file_id, isfreeunit, i, norb, iprlev
          logical :: tExist
          real(wp) :: RDMval

          if (myRank /= 0) then
              call bcast_2RDM("PSMAT." // str(iroot))
              call bcast_2RDM("PAMAT." // str(iroot))
              call bcast_2RDM("DMAT."  // str(iroot))
          end if

          call f_Inquire('PSMAT.' // str(iroot), tExist)
          call verify_(tExist, 'PSMAT.' // str(iroot) //
     &                 ' does not exist')
          call f_Inquire('PAMAT.' // str(iroot), tExist)
          call verify_(tExist, 'PAMAT.' // str(iroot) //
     &                 ' does not exist')
          call f_Inquire('DMAT.'  // str(iroot), tExist)
          call verify_(tExist, 'DMAT.'  // str(iroot) //
     &                 ' does not exist')

          PSMAT(:) = 0.0_wp; PAMAT(:) = 0.0_wp
          DMAT(:) = 0.0_wp; DSPN(:) = 0.0_wp

          file_id = IsFreeUnit(11)
          call Molcas_Open(file_id, 'PSMAT.' // str(iroot))
              do while (read_line(file_id, i, RDMval))
                psmat(i) = RDMval
              end do
          close(file_id)

          file_id = IsFreeUnit(11)
          call Molcas_Open(file_id, 'PAMAT.' // str(iroot))
              do while (read_line(file_id, i, RDMval))
                pamat(i) = RDMval
              end do
          close(file_id)

          file_id = IsFreeUnit(11)
          call Molcas_Open(file_id, 'DMAT.'  // str(iroot))
              do while (read_line(file_id, i, RDMval))
                dmat(i) = RDMval
              end do
          close(file_id)

          ! Clean evil non-positive semi-definite matrices,
          ! by clamping the occupation numbers between 0 and 2.
          ! DMAT is intent(inout)
          call cleanMat(DMAT)

          ! calling cleanmat on DSPN makes no sense, since the
          ! eigenvalues are between -1 and 1. CleanMat
          ! was designed for the regular density matrix with
          ! eigenvalues between 0 and 2.
          dspn = dspn_from_2rdm(psmat, pamat, dmat)

          iprlev = iprloc(1)
          if (iprlev >= debug) then
              norb  = (int(sqrt(dble(1 + 8 * size(DMAT)))) - 1) / 2
              call triprt('DMAT in neci2molcas',' ',DMAT,norb)
              call triprt('DSPN in neci2molcas',' ',DSPN,norb)
          end if

      contains

          !> Read a line from GUGA NECI RDM file with
          !> `file_id` as unit and parse it into i and RDMval.
          !> Return true, if line was successfully read and false
          !> if EOF reached.
          !> Aborts if IO error happens.
          !> **i and RDMval are undefined, if functions returns false**
          logical function read_line(file_id, i, RDMval)
              ! changed variable names to prevent masking the parent
              ! scope
              integer, intent(in) :: file_id
              integer, intent(out) :: i
              real(wp), intent(out) :: RDMval
              integer :: iread
              read_line = .false.
              read(file_id, "(I6,G25.17)", iostat=iread) i, RDMval
              if (iread > 0) then
                  call abort_('Error in read_next')
              else if (is_iostat_end(iread)) then
                  ! Let's try to cause an error, if code uses undefined
                  ! values for i and RDMval
                  i = huge(i)
                  RDMval = huge(RDMval)
              else
                  read_line = .true.
              end if
          end function

      end subroutine read_single_neci_GUGA_RDM

!>  @brief
!>    Start and control FCIQMC.
!>
!>  @author Giovanni Li Manni, Oskar Weser
!>
!>  @details
!>  Read TwoRDM files written by NECI and transfer them to Molcas.
!>  Neci can have some intermediate spin-resolved/spin-free RDMs where
!>  basically aaaa contains average of aaaa and bbbb, abab contains
!>  average of abab and baba... This is ok for CASSCF but not ok
!>  for spin-resolved properties, in which case the completely
!>  spin-resolved RDMs need to be read-in. In principle, NECI could
!>  also evaluate and store completely spin-free matrices. In that
!>  case only a reordering following Molcas convention is necessary.
!>
!>  @param[in]  iroot
!>  @param[out] DMAT Average 1 body density matrix
!>  @param[out] DSPN Average spin 1-dens matrix
!>  @param[out] PSMAT Average symm. 2-dens matrix
!>  @param[out] PAMAT Average antisymm. 2-dens matrix
!>
      subroutine read_single_neci_RDM(iroot, DMAT, DSPN, PSMAT, PAMAT)
          use PrintLevel, only: DEBUG
          use output_ras, only: IPRLOC
          integer, intent(in) :: iroot
          real*8, intent(out) :: DMAT(:), DSPN(:), PSMAT(:), PAMAT(:)
          integer :: iUnit, isfreeunit, p, q, r, s, pq, rs, ps, rq,
     &               psrq, pqrs, iread, norb, iprlev
          logical :: tExist, switch
          real*8 :: fac, RDMval, fcnacte
          real*8 :: D_alpha(size(DMAT)), D_beta(size(DMAT))

          iprlev = iprloc(1)
          if(iprlev == debug) then
            write(u6,*) 'Rank of process: ', MyRank
          end if
          switch = .true.  ! spin-resolved

          if(myRank /= 0) then
            call bcast_2RDM("TwoRDM_aaaa." // str(iroot))
            call bcast_2RDM("TwoRDM_abab." // str(iroot))
            call bcast_2RDM("TwoRDM_abba." // str(iroot))
            call bcast_2RDM("TwoRDM_bbbb." // str(iroot))
            call bcast_2RDM("TwoRDM_baba." // str(iroot))
            call bcast_2RDM("TwoRDM_baab." // str(iroot))
          end if
          call f_Inquire('TwoRDM_aaaa.' // str(iroot),tExist)
          call verify_(tExist, 'TwoRDM_aaaa.' // str(iroot) //
     &                 ' does not exist')
          call f_Inquire('TwoRDM_abab.'// str(iroot),tExist)
          call verify_(tExist, 'TwoRDM_abab.' // str(iroot) //
     &                 ' does not exist')
          call f_Inquire('TwoRDM_abba.'// str(iroot),tExist)
          call verify_(tExist, 'TwoRDM_abba.' // str(iroot) //
     &                 ' does not exist')
          if(switch) then
            call f_Inquire('TwoRDM_bbbb.' // str(iroot),tExist)
            call verify_(tExist, 'TwoRDM_bbbb.' // str(iroot) //
     &                   ' does not exist')
            call f_Inquire('TwoRDM_baba.' // str(iroot),tExist)
            call verify_(tExist, 'TwoRDM_baba.' // str(iroot) //
     &                   ' does not exist')
            call f_Inquire('TwoRDM_baab.' // str(iroot),tExist)
            call verify_(tExist, 'TwoRDM_baab.' // str(iroot) //
     &                   ' does not exist')
          end if

        D_alpha(:) = 0.0d0
        D_beta(:) = 0.0d0
        PSMAT(:) = 0.0d0
        PAMAT(:) = 0.0d0

        fac = merge(0.5d0, 1.0d0, switch)
        fcnacte = 1.0d0 / dble(nactel - 1)

        iUnit = IsFreeUnit(11)
        call Molcas_Open(iUnit, 'TwoRDM_aaaa.' // str(iroot))
        Rewind(iUnit)
        IF(IPRLEV >= DEBUG) THEN
          write(u6,*) 'p   q   r   s  pq  rs  pqrs',
     &    'RDMval                PSMAT                   PAMAT'
          write(u6,*) '******* AAAA *******'
        end if
        do

            read(iUnit, "(4I6,G25.17)", iostat=iread)
     &          s, q, r, p, RDMval
            if(iread /= 0) exit
            pqrs = two_el_idx_flatten(p, q, r, s, pq, rs)
            ! Contribution to PSMAT and PAMAT:
            PSMAT(pqrs) = PSMAT(pqrs) + fac * RDMval
            if (r /= s.and.p == q) PSMAT(pqrs) = PSMAT(pqrs)
     &          + fac * RDMval
            if (p > q.and.r > s) PAMAT(pqrs) = PAMAT(pqrs)
     &          + fac * RDMval
            if (p > q.and.r < s) PAMAT(pqrs) = PAMAT(pqrs)
     &          - fac * RDMval
            IF(IPRLEV >= DEBUG) THEN
               write(u6,'(7I6,3G25.17)')
     &         p,q,r,s,pq,rs,pqrs, RDMval,PSMAT(pqrs),PAMAT(pqrs)
            END IF
            ! Contribution to D_alpha (not final):
            if (p == q) D_alpha(rs) = D_alpha(rs) + RDMval
            if (r == s) D_alpha(pq) = D_alpha(pq) + RDMval
            psrq = two_el_idx_flatten(p, s, r, q, ps, rq)
            ! Contribution to PSMAT and PAMAT:
            if (r <= q) then
              PSMAT(psrq) = PSMAT(psrq) - fac * RDMval
              if (r /= q) PAMAT(psrq) = PAMAT(psrq) + fac * RDMval
            end if
            if (r > q) then
              PSMAT(psrq) = PSMAT(psrq) - fac * RDMval
              PAMAT(psrq) = PAMAT(psrq) - fac * RDMval
            end if
            IF(IPRLEV >= DEBUG) THEN
              write(u6,'(7I6,3G25.17)')
     &          p,s,r,q,ps,rq,psrq, RDMval,PSMAT(psrq),PAMAT(psrq)
            END IF
            ! Contribution to D_alpha (not final): The minus sign comes
            ! from the fact that in NECI these elements have opposite
            ! sign compared to the element in normal order, that is
            ! d_pqrs = -d_psrq.
            if (p == s) D_alpha(rq) = D_alpha(rq) - RDMval
            if (r == q) D_alpha(ps) = D_alpha(ps) - RDMval
        end do
        close(iunit)

        ! Processing TwoRDM-BBBB
        if (switch) then
          iUnit=IsFreeUnit(11)
          Call Molcas_Open(iUnit,'TwoRDM_bbbb.' // str(iroot))
          Rewind(iUnit)
          if (IPRLEV >= DEBUG) then
           write(u6,*) '  p   q   r   s  pq  rs  pqrs',
     &     'RDMval                PSMAT                   PAMAT'
           write(u6,*) '******* BBBB *******'
          end if
          do
            ! processing as PQRS
            read(iUnit,"(4I6,G25.17)",iostat=iread) s, q, r, p, RDMval
            if(iread /= 0) exit
            pqrs = two_el_idx_flatten(p, q, r, s, pq, rs)
            ! Contribution to PSMAT and PAMAT:
            PSMAT(pqrs) = PSMAT(pqrs) + fac * RDMval
            if(r /= s.and.p == q) PSMAT(pqrs) = PSMAT(pqrs) + fac*RDMval
            if(p > q.and.r > s) PAMAT(pqrs) = PAMAT(pqrs) + fac * RDMval
            if(p > q.and.r < s) PAMAT(pqrs) = PAMAT(pqrs) - fac * RDMval
            IF(IPRLEV >= DEBUG) THEN
              write(u6,'(7I6,3G25.17)')
     &           p,q,r,s,pq,rs,pqrs, RDMval,PSMAT(pqrs),PAMAT(pqrs)
            END IF
            ! Contribution to D_beta (not final):
            if (p == q) D_beta(rs) = D_beta(rs) + RDMval
            if (r == s) D_beta(pq) = D_beta(pq) + RDMval
            ! processing as PSRQ
            psrq = two_el_idx_flatten(p, s, r, q, ps, rq)
            ! Contribution to PSMAT and PAMAT:
            if(r <= q) then
              PSMAT(psrq) = PSMAT(psrq) - fac*RDMval
              if(r /= q) PAMAT(psrq) = PAMAT(psrq) + fac*RDMval
            end if
            if(r > q) then
              PSMAT(psrq) = PSMAT(psrq) - fac*RDMval
              PAMAT(psrq) = PAMAT(psrq) - fac*RDMval
            end if
            IF(IPRLEV >= DEBUG) THEN
              write(u6,'(7I6,3G25.17)')
     &          p,s,r,q,ps,rq,psrq, RDMval,PSMAT(psrq),PAMAT(psrq)
            END IF
            ! Contribution to D_beta (not final): The minus sign comes
            ! from the fact that in NECI these elements have opposite
            ! sign compared to the element in normal order, that is
            ! d_pqrs = -d_psrq.
              if(p == s) D_beta(rq)=D_beta(rq)-RDMval
              if(r == q) D_beta(ps)=D_beta(ps)-RDMval
            end do
            close(iunit)
        end if ! End statement for spin-resolved RDMs.
        ! Processing TwoRDM-ABAB
        iUnit=IsFreeUnit(11)
        Call Molcas_Open(iUnit,'TwoRDM_abab.' // str(iroot))
        Rewind(iUnit)
        IF(IPRLEV >= DEBUG) THEN
         write(u6,*) '******* ABAB *******'
        END IF
        do
          read(iUnit,"(4I6,G25.17)",iostat=iread) s,q,r,p,RDMval
          if(iread /= 0) exit
          pqrs = two_el_idx_flatten(p, q, r, s, pq, rs)
        ! Contribution to PSMAT and PAMAT:
        PSMAT(pqrs) = PSMAT(pqrs) + fac*RDMval
        if(r > s.and.p /= q) PAMAT(pqrs) = PAMAT(pqrs) + fac*RDMval
        if(r < s.and.p /= q) PAMAT(pqrs) = PAMAT(pqrs) - fac*RDMval
        if(r /= s.and.p == q) PSMAT(pqrs) = PSMAT(pqrs) + fac*RDMval
        if (IPRLEV >= DEBUG) then
          write(u6,'(7I6,3G25.17)')
     &        p,q,r,s,pq,rs,pqrs, RDMval,PSMAT(pqrs),PAMAT(pqrs)
        end if
        ! Contribution to D_alpha and D_beta (not final):
        if (p == q) D_alpha(rs) = D_alpha(rs) + RDMval
        if (r == s .and. p /= r) D_beta(pq) = D_beta(pq) + RDMval
      end do

      ! Copy D_beta to D_alpha and clean D_beta again for further use:
      if (.not. switch) then
        D_alpha(:) = D_beta(:) + D_alpha(:)
        D_beta(:) = 0.0d0
      end if
      close(iunit)
      ! Processing TwoRDM-BABA
      if (switch) then
        iUnit = IsFreeUnit(11)
        Call Molcas_Open(iUnit,'TwoRDM_baba.' // str(iroot))
        rewind(iUnit)
        if (IPRLEV >= DEBUG) then
           write(u6,*) '******* BABA *******'
        end if
        do
          read(iUnit,"(4I6,G25.17)",iostat=iread) s,q,r,p,RDMval
          if(iread /= 0) exit
          pqrs = two_el_idx_flatten(p, q, r, s, pq, rs)
          ! Contribution to PSMAT and PAMAT:
          PSMAT(pqrs) = PSMAT(pqrs) + fac * RDMval
          if(r > s.and.p /= q) PAMAT(pqrs) = PAMAT(pqrs) + fac*RDMval
          if(r < s.and.p /= q) PAMAT(pqrs) = PAMAT(pqrs) - fac*RDMval
          if(r /= s.and.p == q) PSMAT(pqrs) = PSMAT(pqrs) + fac*RDMval
          IF(IPRLEV >= DEBUG) THEN
            write(u6,'(7I6,3G25.17)')
     &          p,q,r,s,pq,rs,pqrs, RDMval,PSMAT(pqrs),PAMAT(pqrs)
          END IF
          ! Contribution to D_alpha (not final):
          if(p == q) D_beta(rs) = D_beta(rs) + RDMval
          if(r == s.and.p /= r) D_alpha(pq) = D_alpha(pq)+RDMval
        end do
        close(iunit)
      end if ! End statement for spin-resolved RDMs.
      ! Processing TwoRDM-ABBA
      iUnit=IsFreeUnit(11)
      Call Molcas_Open(iUnit,'TwoRDM_abba.' // str(iroot))
      Rewind(iUnit)
      IF(IPRLEV >= DEBUG) THEN
        write(u6,*) '******* ABBA *******'
      END IF
      do
        read(iUnit,"(4I6,G25.17)",iostat=iread) q,s,r,p,RDMval
        if(iread /= 0) exit
        pqrs = two_el_idx_flatten(p, q, r, s, pq, rs)
        ! Contribution to PSMAT and PAMAT:
        PSMAT(pqrs) = PSMAT(pqrs) - fac*RDMval
        if(r < s) then
          PAMAT(pqrs) = PAMAT(pqrs) + fac*RDMval
        end if
        if(r > s) then
          PAMAT(pqrs) = PAMAT(pqrs) - fac*RDMval
        end if
        IF(IPRLEV >= DEBUG) THEN
          write(u6,'(7I6,3G25.17)')
     &        p,q,r,s,pq,rs,pqrs, RDMval,PSMAT(pqrs),PAMAT(pqrs)
        END IF
          ! Contribution to D_alpha (not final):
          if(r == s) D_alpha(pq)=D_alpha(pq)-RDMval
          if(p == q) D_beta(rs)=D_beta(rs)-RDMval
      end do
      if (.not. switch) then
        D_alpha(:) = D_beta(:) + D_alpha(:)
        D_beta(:) = 0.0d0
      end if
      close(iunit)
      ! Processing TwoRDM-BAAB
      if(switch) then
        iUnit=IsFreeUnit(11)
        Call Molcas_Open(iUnit,'TwoRDM_baab.' // str(iroot))
        Rewind(iUnit)
        IF(IPRLEV >= DEBUG) THEN
          write(u6,*) ' ******* BAAB *******'
        END IF
        do
          read(iUnit,"(4I6,G25.17)",iostat=iread) q,s,r,p,RDMval
          if(iread /= 0) exit
          pqrs = two_el_idx_flatten(p, q, r, s, pq, rs)
          ! Contribution to PSMAT and PAMAT:
          PSMAT(pqrs) = PSMAT(pqrs) - fac*RDMval
          if(r < s) then
            PAMAT(pqrs) = PAMAT(pqrs) + fac*RDMval
          end if
          if(r > s) then
            PAMAT(pqrs) = PAMAT(pqrs) - fac*RDMval
          end if
          IF(IPRLEV >= DEBUG) THEN
            write(u6,'(7I6,3G25.17)')
     &          p,q,r,s,pq,rs,pqrs, RDMval,PSMAT(pqrs),PAMAT(pqrs)
          END IF
          ! Contribution to D_alpha (not final):
          if(p == q) D_alpha(rs)=D_alpha(rs)-RDMval
          if(r == s) D_beta(pq)=D_beta(pq)-RDMval
        end do
        close(iunit)
      end if ! End statement for spin-resolved RDMs.
      ! Final Updates to RDMs
      if (.not.switch) D_beta(:) = D_alpha(:)
      D_alpha(:) = fcnacte * D_alpha(:)
      D_beta(:) = fcnacte * D_beta(:)
      DSPN(:) = D_Beta(:) - D_alpha(:)
      DMAT(:) = D_Beta(:) + D_alpha(:)

      ! Clean evil non-positive semi-definite matrices. DMAT is input
      ! and output.
      call cleanMat(DMAT)

      if (iprlev >= debug) then
          norb  = (int(sqrt(dble(1 + 8 * size(DMAT)))) - 1) / 2
          call triprt('D_alpha in neci2molcas',' ',D_alpha,norb)
          call triprt('D_beta  in neci2molcas',' ',D_beta ,norb)
          call triprt('DMAT in neci2molcas',' ',DMAT,norb)
          call triprt('DSPN in neci2molcas',' ',DSPN,norb)
      end if
      Return
      end subroutine read_single_neci_RDM


      subroutine bcast_2RDM(InFile)
        use filesystem, only : symlink_, strerror_, get_errno_
        character(len=*), intent(in) :: InFile
        character(len=1024) :: master
        integer :: lmaster1, err

        call prgmtranslate_master(InFile, master, lmaster1)
        call symlink_(trim(master), trim(InFile), err)
        if (err == 0) write(u6, *) strerror_(get_errno_())
      end subroutine bcast_2RDM


      subroutine dump_fciqmc_mats(dmat, dspn, psmat, pamat)
          ! Currently only one root per spin is supported.
          real(wp), intent(in) :: dmat(:), dspn(:), psmat(:), pamat(:)
          integer :: i, funit, isfreeunit

          funit = IsFreeUnit(11)
          call molcas_open(funit, 'DMAT.1')
          do i = 1, size(dmat)
              if (abs(dmat(i)) > 1e-10) write(funit,'(i6,g25.17)')
     &        i, dmat(i)
          end do
          close(funit)

          funit = IsFreeUnit(11)
          call molcas_open(funit, 'DSPN.1')
          do i = 1, size(dspn)
              if (abs(dspn(i)) > 1e-10) write(funit,'(i6,g25.17)')
     &        i, dspn(i)
          end do
          close(funit)

          funit = IsFreeUnit(11)
          call molcas_open(funit, 'PSMAT.1')
          do i = 1, size(psmat)
              if (abs(psmat(i)) > 1e-10) write(funit,'(i6,g25.17)')
     &        i,psmat(i)
          end do
          close(funit)

          funit = IsFreeUnit(11)
          call molcas_open(funit, 'PAMAT.1')
          do i = 1, size(pamat)
              if (abs(pamat(i)) > 1e-10)write(funit,'(i6,g25.17)')
     &        i,pamat(i)
          end do
          close(funit)
      end subroutine


      function dspn_from_2rdm(psmat, pamat, dmat) result(dspn)
          ! Implementation following the Columbus paper:
          ! 10.1080/00268976.2022.2091049, assuming S = m_s.
          use general_data, only: ispin
          real(wp), intent(in) :: psmat(:), pamat(:), dmat(:)
          real(wp) :: dspn(size(dmat))
          real(wp) :: intermed, Spin, AcEl
          integer :: p, k, s, pk, ks, ps, pkks, fac, n

          Spin = (real(ispin, wp) - 1)/2  ! integer by default
          AcEl = real(nActEl, wp)
          ! the cycle statements ensure proper handling of the logic
          ! for values connected to index pairs "pprs" and "rspp"
          do s = 1, nAc
              do p = 1, nAc
                  if (.not. p >= s) cycle
                  intermed = 0.0_wp
                  do k = 1, nAc
                      pk = one_el_idx_flatten(p, k)
                      ks = one_el_idx_flatten(k, s)
                      pkks = one_el_idx_flatten(pk, ks)
                      ! PAMAT is antisymmetric under single permutations
                      fac = merge(-1, 1, p < k .neqv. k < s)
                      if (pk < ks) then
                          cycle
                      else
                          ! off-diagonal counts twice
                          n = merge(1, 2, (k == s))
                          intermed = intermed
     &                  + (2/n * psmat(pkks) + fac*pamat(pkks))
                      end if
                  end do
                  ps = one_el_idx_flatten(p, s)
                  dspn(ps) = 1/(Spin+1)*((2-AcEl/2) * dmat(ps)-intermed)
              end do
          end do
          if (ispin == 1) dspn(:) = dspn(:) * 0
      end function dspn_from_2rdm


#ifdef _HDF5_
      pure function expand_1rdm(dmat) result(decompr_dmat)
        ! Decompresses DMAT from subroutine read_neci_RDM from a
        ! linearised vector with symmetry into the full, redundant, 1RDM
        ! matrix for HDF5 writing.
        real(wp), intent(in) :: dmat(:)
        real(wp) :: decompr_dmat(nAc,nAc)
        integer :: pq, p, q

        do pq = 1, size(dmat)
          call one_el_idx(pq, p, q)
          decompr_dmat(p,q) = dmat(pq)
          decompr_dmat(q,p) = dmat(pq)  ! hermiticity
        end do
      end function expand_1rdm


      subroutine read_hdf5_denmats(iroot, dmat, dspn, psmat, pamat)
          use PrintLevel, only: DEBUG
          use output_ras, only: IPRLOC
          integer, intent(in) :: iroot
          real(wp), intent(_OUT_) :: dmat(:), dspn(:),psmat(:),pamat(:)
          integer, allocatable :: indices(:,:)
          real(wp), allocatable :: values(:)
          integer :: len4index(2), pqrs, pq, rs,  p, q, r, s, i,
     &               fac, n_rs, hdf5_file, hdf5_group, hdf5_dset
          real(wp) :: rdm2_temp(nAc, nAc, nAc, nAc), rdm1_temp(nAc, nAc)
          logical :: tExist
          integer :: iprlev

          if (myRank /= 0) then
              call bcast_2RDM('M7.'//str(iroot)//'.h5')
          end if

          ! TODO: no multi-root functionality yet
          call f_Inquire('M7.rdm.'//str(iroot)//'.h5', tExist)
          call verify_(tExist, 'M7.rdm.'//str(iroot)//'.h5 not found.')
          hdf5_file = mh5_open_file_r('M7.rdm.'//str(iroot)//'.h5')
          hdf5_group = mh5_open_group(hdf5_file, 'spinfree/2200')
          hdf5_dset = mh5_open_dset(hdf5_group, 'indices')
          len4index(:) = 0
          call mh5_get_dset_dims(hdf5_dset, len4index)
          call mh5_close_dset(hdf5_dset)
          call mma_allocate(indices, 4, len4index(2))
          call mma_allocate(values, len4index(2))
          indices(:,:) = 0
          values(:) = 0.0_wp
          call mh5_fetch_dset(hdf5_group, 'values', values)
          call mh5_fetch_dset(hdf5_group, 'indices', indices)
          call mh5_close_group(hdf5_group)
          call mh5_close_file(hdf5_file)

          rdm1_temp(:,:) = 0.0_wp
          rdm2_temp(:,:,:,:) = 0.0_wp
          do i = 1, len4index(2)
              p = indices(1, i) + 1; q = indices(2, i) + 1
              r = indices(3, i) + 1; s = indices(4, i) + 1
              rdm2_temp(p, r, q, s) = values(i)
          end do
          call mma_deallocate(indices)
          call mma_deallocate(values)

          dmat(:) = 0.0_wp
          dspn(:) = 0.0_wp
          psmat(:) = 0.0_wp
          pamat(:) = 0.0_wp
          do s = 1, nAc
            do r = 1, nAc
              do q = 1, nAc
                do p = 1, nAc
                  pq = one_el_idx_flatten(p, q)
                  rs = one_el_idx_flatten(r, s)
                  if (pq < rs) then
                    cycle
                  else
                    pqrs = one_el_idx_flatten(pq, rs)
                    fac = merge(-1, 1, p < q .neqv. r < s)
                    n_rs = merge(2, 1, r /= s)
                    psmat(pqrs) = 0.5_wp * n_rs
     &                * (rdm2_temp(p,q,r,s) + rdm2_temp(q,p,r,s))/2
                    pamat(pqrs) = 0.5_wp * n_rs * fac
     &                * (rdm2_temp(p,q,r,s) - rdm2_temp(q,p,r,s))/2
                  end if
                end do
              end do
            end do
          end do

          do r = 1, nAc
            do q = 1, nAc
              do p = 1, nAc
                rdm1_temp(p, q) = rdm1_temp(p,q) + rdm2_temp(p,q,r,r)
              end do
            end do
          end do
          rdm1_temp(:, :) = rdm1_temp(:, :) / (nActEl - 1)

          do q = 1, nAc
            do p = 1, nAc
              pq = one_el_idx_flatten(p, q)
              dmat(pq) = rdm1_temp(p, q)
            end do
          end do

          call cleanMat(dmat)  ! cleanse non-PSD elements
          dspn = dspn_from_2rdm(psmat, pamat, dmat)

          iprlev = iprloc(1)
          if (iprlev >= debug) then
              write(u6,'(a)') 'PSMAT:'
              do p = 1, size(psmat)
                if (abs(psmat(p)) > 1e-7) write(u6,'(i6,g25.17)')
     &              p,psmat(p)
              end do
              write(u6,'(a)') 'PAMAT:'
              do p = 1, size(pamat)
                if (abs(pamat(p)) > 1e-7) write(u6,'(i6,g25.17)')
     &              p,pamat(p)
              end do
              call triprt('DMAT ',' ', dmat, nAc)
              call triprt('DSPN ',' ', dspn, nAc)
          end if
      end subroutine read_hdf5_denmats
#endif


      ! Add your deallocations here. Called when exiting rasscf.
      subroutine cleanup()
      end subroutine


      end module fciqmc_read_RDM

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DGETMO(A,ldA,M,N,B,ldB)
! TRANSPOSE A REGULAR MATRIX (OUT-OF-PLACE)

#include "intent.fh"

use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ldA, M, N, ldB
real(kind=wp), intent(in) :: A(ldA,N)
real(kind=wp), intent(_OUT_) :: B(ldB,M)
integer(kind=iwp) :: i, INC, j, jj

if (M <= 0) then
  write(u6,*)
  write(u6,*) '  *** Error in subroutine DGETMO ***'
  write(u6,*) '  Invalid dimension of matrix A :'
  write(u6,*) '  The number of columns, M, must be greater than zero'
  write(u6,*)
end if
if (N <= 0) then
  write(u6,*)
  write(u6,*) '  *** Error in subroutine DGETMO ***'
  write(u6,*) '  Invalid leading dimension of matrix B :'
  write(u6,*) '  The number of rows, N, must be greater than zero'
  write(u6,*)
end if
if (ldA < M) then
  write(u6,*)
  write(u6,*) '  *** Error in subroutine DGETMO ***'
  write(u6,*) '  Invalid leading dimension of matrix A :'
  write(u6,*) '  ldA must be equal to M or greater'
  write(u6,*)
end if
if (ldB < N) then
  write(u6,*)
  write(u6,*) '  *** Error in subroutine DGETMO ***'
  write(u6,*) '  Invalid leading dimension of matrix B :'
  write(u6,*) '  ldB must be equal to N or greater'
  write(u6,*)
end if
INC = 8
do j=1,M,INC
  jj = min(M-j+1,INC)
  select case (jj)
    case (1)
      do i=1,N
        B(i,j) = A(j,i)
      end do
    case (2)
      do i=1,N
        B(i,j) = A(j,i)
        B(i,j+1) = A(j+1,i)
      end do
    case (3)
      do i=1,N
        B(i,j) = A(j,i)
        B(i,j+1) = A(j+1,i)
        B(i,j+2) = A(j+2,i)
      end do
    case (4)
      do i=1,N
        B(i,j) = A(j,i)
        B(i,j+1) = A(j+1,i)
        B(i,j+2) = A(j+2,i)
        B(i,j+3) = A(j+3,i)
      end do
    case (5)
      do i=1,N
        B(i,j) = A(j,i)
        B(i,j+1) = A(j+1,i)
        B(i,j+2) = A(j+2,i)
        B(i,j+3) = A(j+3,i)
        B(i,j+4) = A(j+4,i)
      end do
    case (6)
      do i=1,N
        B(i,j) = A(j,i)
        B(i,j+1) = A(j+1,i)
        B(i,j+2) = A(j+2,i)
        B(i,j+3) = A(j+3,i)
        B(i,j+4) = A(j+4,i)
        B(i,j+5) = A(j+5,i)
      end do
    case (7)
      do i=1,N
        B(i,j) = A(j,i)
        B(i,j+1) = A(j+1,i)
        B(i,j+2) = A(j+2,i)
        B(i,j+3) = A(j+3,i)
        B(i,j+4) = A(j+4,i)
        B(i,j+5) = A(j+5,i)
        B(i,j+6) = A(j+6,i)
      end do
    case (8)
      do i=1,N
        B(i,j) = A(j,i)
        B(i,j+1) = A(j+1,i)
        B(i,j+2) = A(j+2,i)
        B(i,j+3) = A(j+3,i)
        B(i,j+4) = A(j+4,i)
        B(i,j+5) = A(j+5,i)
        B(i,j+6) = A(j+6,i)
        B(i,j+7) = A(j+7,i)
      end do
    case default
      write(u6,*) 'Error in DGETMO!'
  end select
end do

return

end subroutine DGETMO

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine getLIMIT(l1,l2,l3,l4,Lanf,Lend)
!bs get the minimum and maximum L-values
!bs of the the coulomb-potential to interact
!bs with l1-l4

use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: l1, l2, l3, l4
integer(kind=iwp), intent(out) :: Lanf, Lend
integer(kind=iwp) :: lower1, lower2, lsum, lupper1, lupper2

lower1 = abs(l1-l3)
lower2 = abs(l2-l4)
lupper1 = l1+l3
lupper2 = l2+l4
Lanf = max(lower1,lower2)
Lend = min(lupper1,lupper2)
!bs check for parity
lsum = Lanf+l1+l3
if (mod(lsum,2) == 1) Lanf = Lanf+1
lsum = Lend+l1+l3
if (mod(lsum,2) == 1) Lend = Lend-1
!bs check the other parity
lsum = Lanf+l2+l4
if (mod(lsum,2) == 1) then
  write(u6,*) ' error in getLIMIT: '
  write(u6,*) ' parity inconsistency for '
  write(u6,*) 'l1,l2,l3,l4= ',l1,l2,l3,l4
  call Abend()
end if

return

end subroutine getLIMIT

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*  A subroutine that calculates A*p_k in the PCG-algorithm
*
      Subroutine MP2Ap(iSymIA,iSymJB,ip_AP,ip_P)
*
      Implicit real*8 (a-h,o-z)
*defining One etc.
#include "real.fh"
#include "WrkSpc.fh"
#include "mp2grad.fh"
#include "trafo.fh"
#include "files_mbpt2.fh"
#include "corbinf.fh"

*
      nMaxOrb=0
      Do iSym1 = 1,nSym
         Do iSym2 = 1,nSym
            nMaxOrb = Max(nMaxOrb,(nOrb(iSym1)+nDel(iSym1))
     &                               *(nOrb(iSym2)+nDel(iSym2)))
         End Do
      End Do
      lint = nMaxOrb
      Call GetMem('Int1','Allo','Real',ipInt1,lInt)
      Call GetMem('Int2','Allo','Real',ipInt2,lInt)
      Call GetMem('IntC','Allo','Real',ipIntC,lInt)
      Call GetMem('Scr1','Allo','Real',ipScr1,lInt)

      nB = nExt(iSymJB) + nDel(iSymJB)
      Do iA = 1, nExt(iSymIA) + nDel(iSymIA)
         if(iSymIA.eq.iSymJB) nB = iA
         Do iB = 1, nB
            Call Exch(iSymIA,iSymIA,iSymJB,iSymJB,
     &                iA + nFro(iSymIA) + nOcc(iSymIA),
     &                iB + nFro(iSymJB) + nOcc(iSymJB),
     &                Work(ipInt1), Work(ipScr1))
            If(iSymIA.Ne.iSymJB) Then
               Call Exch(iSymJB, iSymIA, iSymIA, iSymJB,
     &                   iA + nFro(iSymIA) + nOcc(iSymIA),
     &                   iB + nFro(iSymJB) + nOcc(iSymJB),
     &                   Work(ipInt2), Work(ipScr1))
            End If
            Call Coul(iSymIA,iSymJB,iSymIA,iSymJB,
     &                iA + nFro(iSymIA) + nOcc(iSymIA),
     &                iB + nFro(iSymJB) + nOcc(iSymJB),
     &                Work(ipIntC), Work(ipScr1))
*            Write(6,*)
*            Write(6,*) ' *  A,B = ',iA,iB
*            Call RecPrt('Int1:','(8F10.6)',Work(ipInt1),
*     &                  nOrb(iSymIA)+nDel(iSymIA),
*     &                  nOrb(iSymJB)+nDel(iSymJB))
*            If (iSymIA.Ne.iSymJB) Then
*               Call RecPrt('Int2:','(8F10.6)',Work(ipInt2),
*     &                     nOrb(iSymJB)+nDel(iSymJB),
*     &                     nOrb(iSymIA)+nDel(iSymIA))
*            End If
*            Call RecPrt('IntC:','(8F10.6)',Work(ipIntC),
*     &                  nOrb(iSymIA)+nDel(iSymIA),
*     &                  nOrb(iSymJB)+nDel(iSymJB))
**********************************************************************
*
*
*           This loop will traverse an triangular AIxBJ-matrix
            Do iI= 1,nFro(iSymIA) + nOcc(iSymIA)
               nJ=nFro(iSymJB) + nOcc(iSymJB)
               If((iA.eq.iB).and.(iSymIA.eq.iSymJB)) nJ=iI
               Do iJ=1,nJ
                  Fac = One
*                 We will count the diagonal twice so the factor
*                 half will get it right
                  If((iA.eq.iB).and.(iI.eq.iJ)
     &                .and.(iSymIA.eq.iSymJB)) Then
                     Fac = Half
                  Endif
*                  For multiplication with the BJ element of P
                  index1 = ip_Ap + iPoVec(iSymJB) +iJ-1 +
     &                      (nFro(iSymJB) + nOcc(iSymJB))*(iB-1)
                  index2 = ip_Ap + iPoVec(iSymIA) + iI-1 +
     &                      (nFro(iSymIA) +nOcc(iSymIA))*(iA-1)
                  xiajb = Work(ipInt1  + iI-1 + (iJ-1)*
     &                         (nOrb(iSymIA)+nDel(iSymIA)))
                  xijab = Work(ipIntC  + iI-1 +
     &                        (iJ-1)*(nOrb(iSymIA)+nDel(iSymIA)))
                  If (iSymIA.eq.iSymJB) then
                  xibja = Work(ipInt1 + iJ-1 +
     &                        (iI-1)*(nOrb(iSymJB)+nDel(iSymJB)))


                  Else
                     xibja = Work(ipInt2 + iJ-1 +
     &                     (iI-1)*(nOrb(iSymJB)+nDel(iSymJB)))
                  EndIf
*
                  Work(index1)=Work(index1) +
     &                          Fac*(Four*xiajb-xibja-xijab)*
     &                          work(ip_P + iPoVec(iSymIA) +
     &                           iI-1 +
     &                          (nFro(iSymIA) + nOcc(iSymIA))*(iA-1))
*------------ Debug comments -------------------------------------------
*                        Write(6,*) 'Symm A B', iSymIA, iSymJB
*                        Write(6,*) 'IAJB', iI,iA,iJ,iB
*                        Write(6,*) 'jiba', xijab
*                        Write(6,*) 'adress AP',
*     &                             iPoVec(iSymJB) +iJ-1 +
*     &                       (nFro(iSymJB) + nOcc(iSymJB))*(iB-1)
*                        Write(6,*) 'Contr coul',
*     &                             Fac*(xijab)*
*     &                          work(ip_P + iPoVec(iSymIA) +
*     &                           iI-1 +
*     &                          (nFro(iSymIA) + nOcc(iSymIA))*(iA-1))
*------------------------------------------------------------------------
*                  write(6,*) 'IA JB',iOrbI,iVirA,iOrbJ,iVirB
*                  write(6,*) 'Index1:',index1-iAp
*                  write(6,*) 'A-elementet', Fac*(Four*xijab-xijba-xibja)
*                  write(6,*) 'P-vector',work(iP+ iPoVec(JB) + iOrbJ-1+
*     &                          nOcc(JB)*(iVirB-1))
*                  write(6,*) 'Index2:',index2-iAp
*                  write(6,*) 'A-elementet', Fac*(Four*xijab-xijba-xibja)
*                  write(6,*) 'P-vector',work(iP+ iPoVec(IA) + iOrbI-1+
*     &                          nOcc(IA)*(iVirA-1))

                  Work(index2)= Work(index2) +
     &                           Fac*(Four*xiajb-xibja-xijab)*
     &                           work(ip_P + iPoVec(iSymJB) +
     &                            iJ-1 +
     &                           (nFro(iSymJB) + nOcc(iSymJB))*(iB-1))
                  If((iA.eq.iB).and.(iI.eq.iJ).and.
     &                (iSymIA.eq.iSymJB)) then
                     If(iA .le. nExt(iSymIA)) Then
                        E_a = Work(mAdVir(iSymIA) + iA -1)
                     Else
                        E_a = Work(mAdDel(iSymIA) + iA - nExt(iSymIA)-1)
                     End If
                     If(iI.gt.nFro(iSymIA)) Then
                        E_i = Work(mAdOcc(iSymIA) + iI - nFro(iSymIA)-1)
                     Else
                        E_i = Work(mAdFro(iSymIA) + iI -1)
                     End If
                     Ediff = E_a - E_i
                     Work(index1) = Work(index1) + EDiff *
     &                          work(ip_P + iPoVec(iSymJB) +
     &                           iJ-1 +
     &                          (nFro(iSymJB) + nOcc(iSymJB))*(iB-1))

                  Endif
               EndDo            !iOrbJ
            EndDo               !iOrbI
*

         EndDo                  !iOrbB
      EndDo                     !iOrbA
*
      Call GetMem('Int1','Free','Real',ipInt1,lInt)
      Call GetMem('Int2','Free','Real',ipInt2,lInt)
      Call GetMem('IntC','Free','Real',ipIntC,lInt)
      Call GetMem('Scr1','Free','Real',ipScr1,lInt)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_S(icol,str,n)

use getline_mod, only: iend, istrt, line, ncol
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iCol, n
character(len=*), intent(out) :: str(n)
integer(kind=iwp) :: i, ic

ic = icol
do i=1,n
  if (ic <= ncol) then
    if (iend(ic) >= istrt(ic)) then
      str(i) = line(istrt(ic):iend(ic))
    else
      str(i) = ' '
    end if
    ic = ic+1
  else
    write(u6,210) icol+n-1,line
    call FindErrorLine()
    call WarningMessage(2,'Error in Get_S')
    call Quit_OnUserError()
  end if
end do

210 format(/' ERROR IN GET_S: TRYING TO READ',i4,' STRINGS'/1x,a)

end subroutine Get_S

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Valera Veryazov                                        *
************************************************************************
*  handle2name
*
*> @brief
*>   Retrieve the file name from molcas I/O
*> @author Valera Veryazov
*>
*> @details
*> The routine can be called from ::aixrd or ::aixwr.
*> Return the file name, or '``Unknown``'.
*>
*> @param[in]  handle file handle
*> @param[out] name   file name
************************************************************************
      subroutine handle2name(handle,name)
      Implicit Integer (a-z)
#include "switch.fh"
#include "ctl.fh"
      Character*(*) name
*----------------------------------------------------------------------*
       name='Unknown'
       do i=1,MxFile
        if(CtlBlk(pHndle,i).eq.handle) then
          name=FCtlBlk(i)
          return
        endif
       enddo
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RFMmG( &
#                define _CALLING_
#                include "mem_interface.fh"
                )

use Definitions, only: iwp

implicit none
#include "mem_interface.fh"

nHer = (la+lb+lr+1+2)/2
Mem = 3*nHer*(la+2)+ &
      3*nHer*(lb+2)+ &
      3*nHer*(lr+1)+ &
      3*(la+2)*(lb+2)*(lr+1)+4+3*nHer

return

end subroutine RFMmG

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Markus P. Fuelscher                              *
************************************************************************
      SubRoutine Guess(CMO)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Diagonalize core Hamiltonian to get starting orbitals.           *
*                                                                      *
*     calling arguments:                                               *
*     CMO     : real*8, output                                         *
*               starting vectors                                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1998                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)

*     global definitions

#include "rasdim.fh"
#include "warnings.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='GUESS   ')
#include "rasscf.fh"
#include "WrkSpc.fh"

*     calling arguments

      Real*8 CMO(*)

*     local definitions

      Character*8 Label
      Parameter ( zero = 0.0d0 , one = 1.0d0 )

*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*

*     allocate work space
      Call GetMem('scr1','Allo','Real',iTmp1,nTot1)

*     load bare nuclei Hamiltonian

      iRc    = -1
      iOpt   =  6
      iComp  =  1
      iSyLbl =  1
      Label  = 'OneHam  '
      Call RdOne(iRc,iOpt,Label,iComp,Work(iTmp1),iSyLbl)
      If ( iRc.ne.0 ) Then
        Write(LF,*)' RASSCF tried to construct start orbitals from'
        Write(LF,*)' diagonalization of core Hamiltonian, but ran into'
        Write(LF,*)' a severe error: Failed to read the Hamiltonian'
        Write(LF,*)' from the ONEINT file. Something may be wrong with'
        Write(LF,*)' the file.'
        Call Quit(_RC_IO_ERROR_READ_)
      End If

*     diagonalize bare nuclei Hamiltonian

      i1 = iTmp1
      i2 = 1
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        Call dCopy_(iBas*iBas,[zero],0,CMO(i2),1)
        Call dCopy_(iBas,[one],0,CMO(i2),iBas+1)
        Call Jacob(Work(i1),CMO(i2),iBas,iBas)
        Call JacOrd(Work(i1),CMO(i2),iBas,iBas)
        i1 = i1+(iBas*iBas+iBas)/2
        i2 = i2+iBas*iBas
      End Do

*     deallocate work space
      Call GetMem('scr1','Free','Real',iTmp1,nTot1)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_Density_Matrix(D,nBas1,nBas2,nBasMax,nBas,nSym,P,UserDen,PrintDen,SubtractDen,SubScale,Q_Nuc,nAtoms,iPert,Restart, &
                              Utility,TDensity,nStateI,nStateF)

use Data_Structures, only: Alloc1DArray_Type
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
type(Alloc1DArray_Type), intent(out) :: D
integer(kind=iwp), intent(in) :: nBas1, nBas2, nBasMax, nSym, nBas(nSym), nAtoms, iPert, nStateI, nStateF
real(kind=wp), intent(in) :: P(*), SubScale
logical(kind=iwp), intent(in) :: UserDen, PrintDen, SubtractDen, Restart, Utility, TDensity
real(kind=wp), intent(inout) :: Q_Nuc(nAtoms)
integer(kind=iwp) :: iDisk, iMp2Prpt, iOffs, iOfft, iS1, iS2, iSyLbl, iSym, k, kaunter, Lu_Ud, LuIn, nDens, nScr, nSize, nStateM
character(len=16) :: Label, filename
character(len=8) :: Method
logical(kind=iwp) :: Exists, Found, ok1, ok2
integer(kind=iwp), allocatable :: iToc(:)
real(kind=wp), allocatable :: D_sq(:,:), DTmp(:), DSym(:), Scr(:), TDMden(:), Tmp(:), User(:)
! OBSERVE! MxState has to be the same as MxStat in cntrl.fh in src/rassi.
!          (but there's no such variable)
integer(kind=iwp), parameter :: MxState = 200, MxStOT = MxState*(MxState+1)/2
integer(kind=iwp), external :: IsFreeUnit

write(Label,'(A,I1)') 'LoProp Dens ',iPert
if (Restart) then

  ! Retrieve density matrix from the runfile

  call qpg_dArray(Label,Exists,nDens)
  if ((.not. Exists) .or. (nDens == 0)) then
    call SysAbendMsg('get_density_matrix','Could not locate:',Label)
  end if
  call mma_allocate(D%A,nDens,label='D')
  call Get_dArray(Label,D%A,nDens)

  nSize = nDens

else if (nSym == 1) then

  nSize = nBas(1)*(nBas(1)+1)/2

  if (UserDen) then
    ! Additions made by A.Ohrn to enable LoProp to read in a density matrix
    ! provided by the user. Generalized by P. Soderhjelm so that also
    ! perturbed density matrices may be read for polarizability calculation
    Lu_Ud = 56
    Lu_Ud = IsFreeUnit(Lu_Ud)
    if (ipert == 0) then
      filename = 'USERDEN'
    else
      write(filename,'(A7,I1)') 'USERDEN',ipert
    end if
    call OpnFl(filename,Lu_Ud,Exists)
    if (.not. Exists) then
      write(u6,*)
      write(u6,*) ' Unable to locate user density matrix.'
      call Abend()
    end if
    call mma_allocate(User,nSize,label='UserDen')
    read(Lu_Ud,*) User(:)
    call Put_D1ao(User,nSize)
    call mma_deallocate(User)
    close(Lu_Ud)
  end if
  ! Addition of A.Ohrn, to collect transition density matrix from ToFile.
  if (TDensity) then
    LuIn = 57
    LuIn = IsFreeUnit(LuIn)
    call DaName(LuIn,'TOFILE')
    iDisk = 0
    ! Table-of-contents
    call mma_allocate(iToc,MxStOT,label='iToc')
    call iDaFile(LuIn,2,iToc,MxStOT,iDisk)
    ! Allocation of density
    call mma_allocate(TDMden,nSize,label='TDMden')
    ! Loop to 'suck-out' the relevant matrix from the ToFile.
    nStateM = max(nStateI,nStateF)
    kaunter = 0
    do iS1=1,nStateM
      do iS2=1,iS1
        kaunter = kaunter+1
        iDisk = iToc(kaunter)
        call dDaFile(LuIn,2,TDMden,nSize,iDisk)
        ok1 = (iS1 == nStateI) .and. (iS2 == nStateF)
        ok2 = (iS1 == nStateF) .and. (iS2 == nStateI)
        if (ok1 .or. ok2) then
          call Put_D1ao(TDMden,nSize)
        end if
      end do
    end do
    call mma_deallocate(iToc)
    call mma_deallocate(TDMden)
    call DaClos(LuIn)
  end if
  ! End addition A.Ohrn.

  ! Additions made by P.Soderhjelm to enable LoProp to read in a density matrix
  ! provided by the user and subtract that from the current one (which could
  ! in fact be provided by the Userdens keyword. After subtraction the matrix
  ! is scaled by a constant SubScale. Nuclear charges are set to zero.
  if (SubtractDen) then
    Lu_Ud = 56
    Lu_Ud = IsFreeUnit(Lu_Ud)
    call OpnFl('SUBDEN',Lu_Ud,Exists)
    if (.not. Exists) then
      write(u6,*)
      write(u6,*) ' Unable to locate density matrix to subtract.'
      call Abend()
    end if
    call mma_allocate(User,nSize,label='UserDen')
    read(Lu_Ud,*) User(:)
    call mma_allocate(DTmp,nSize)
    call Get_D1ao(Dtmp,nSize)
    Dtmp(:) = SubScale*(Dtmp(:)-User(:))
    call Put_D1ao(Dtmp,nSize)
    call mma_deallocate(DTmp)
    call mma_deallocate(User)
    close(Lu_Ud)
    do k=1,nAtoms
      Q_Nuc(k) = Zero
    end do
  end if
  ! End addition P.Soderhjelm.

  ! Addition by J.Bostrom to check if loprop should pick
  ! the variational density instead.
  call Get_cArray('Relax Method',Method,8)
  iMp2Prpt = 0
  if (Method == 'MBPT2   ') then
    call Get_iScalar('mp2prpt',iMp2Prpt)
  end if
  call mma_allocate(D%A,nSize,label='D')
  if (iMp2Prpt /= 0) then
    call Get_D1ao_var(D%A,nSize)
  else
  ! End Addition J.Bostrom (well, the End If too ofc.)
    call Get_D1ao(D%A,nSize)
  end if
  nDens = nSize
# ifdef _DEBUGPRINT_
  call RecPrt('D',' ',D%A,1,nDens)
# endif
  if (PrintDen) then
    ! Addition made by P.Soderhjelm to enable LoProp to print the density matrix
    ! to a text file for later use.
    Lu_Ud = 56
    Lu_Ud = IsFreeUnit(Lu_Ud)
    call OpnFl('PRDEN',Lu_Ud,Exists)
    write(Lu_Ud,'(10F25.16)') D%A(:)
    close(Lu_Ud)
  end if

else

  call mma_allocate(D%A,nBas1*(nBas1+1)/2,label='D')
  call mma_allocate(D_sq,nBas1,nBas1,label='D_sq')
  call mma_allocate(Tmp,nBas2,label='Tmp')

  call Qpg_darray('D1ao',Found,nDens)
  if (Found .and. (nDens /= 0)) then
    call mma_allocate(DSym,nDens,Label='DSym')
    call Get_D1ao(DSym,nDens)
  else
    write(u6,*) 'Get_density_matrix: not found.'
    call Abend()
  end if
  iSyLbl = 1
# ifdef _DEBUGPRINT_
  call RecPrt('DSym',' ',DSym,1,nDens)
# endif
  iOfft = 1
  iOffs = 1
  do iSym=1,nSym
    if (nBas(iSym) == 0) cycle
#   ifdef _DEBUGPRINT_
    call TriPrt('DSym',' ',DSym(iOfft),nBas(iSym))
#   endif
    call Square(DSym(iOfft),Tmp(iOffs),1,nBas(iSym),nBas(iSym))
    call DScal_(nBas(iSym)**2,Half,Tmp(iOffs),1)
    call DScal_(nBas(iSym),Two,Tmp(iOffs),nBas(iSym)+1)
#   ifdef _DEBUGPRINT_
    call RecPrt('DSym',' ',Tmp(iOffs),nBas(iSym),nBas(iSym))
#   endif
    iOfft = iOfft+nBas(iSym)*(nBas(iSym)+1)/2
    iOffs = iOffs+nBas(iSym)**2
  end do
  call mma_deallocate(DSym)

  nScr = nBasMax*nBas1
  call mma_allocate(Scr,nScr,label='Scr')
  call Desymmetrize(Tmp,nBas2,Scr,nScr,D_sq,nBas,nBas1,P,nSym,iSyLbl)
  call mma_deallocate(Scr)
  call mma_deallocate(Tmp)

  call Triangularize(D_sq,D%A,nBas1,.true.)
  call mma_deallocate(D_sq)
end if
#ifdef _DEBUGPRINT_
call TriPrt('Density Matrix',' ',D%A,nBas1)
#endif

! Copy Density Matrix to the runfile

if ((.not. Restart) .and. (.not. Utility)) then
  !call put_dArray(Label,D%A,nDens)
  call put_dArray(Label,D%A,nBas1*(nBas1+1)/2)
end if

return

end subroutine Get_Density_Matrix

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADAST_GASSM(NSTB,NSTA,IOFFK,IOFFI,IOFFISP,IOFFKSP,ICREORB,ICRESTR,IORBTSF,IORBTF,NORBTS,NSTAK,NSTAI,NSTAKTS,NELB, &
                       ISTMAP,SGNMAP,SCLFAC,IAC,LROW_IN,IEC)
! Annihilation/Creation mappings from K-strings of given sym in each gasspace
!
! Input
! NSTB    : Number of strings before active gasspace
! NSTA    : Number of strings after accive gasspace
! IOFFK   : Offset for K group of strings in active gasspace, i.e. start of
!           this symmetry of active K group strings
! IOFFI   : Offset for I group of strings in active gasspace, i.e. start of
!           this symmetry of active I group strings
! IOFFISP : Offset for this symmetrydistribution of active I supergroup strings
! IOFFKSP : Offset for this symmetrydistribution of active K supergroup strings
! ICREORB : Orbital part of creation map for active K groupstrings
! ICRESTR : String  part of creation map for active K groupstrings
! IORBTSF : First active orbital (first orbital in in active GASspace
!           with required sym)
! IORBTF  : First orbital in active gas space, (can have any sym)
! NORBTS  : Number of orbitals of given symmetry and type
! NSTAK   : Number of K groupstrings with given correct symmetry
! NSTAKTS : Total Number of K supergroup strings with correct symmetry
! NSTAI   : Number of I groupstrings in active gasspace

use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NSTB, NSTA, IOFFK, IOFFI, IOFFISP, IOFFKSP, LROW_IN, NSTAK, ICREORB(LROW_IN,NSTAK+IOFFK-1), &
                                 ICRESTR(LROW_IN,NSTAK+IOFFK-1), IORBTSF, IORBTF, NORBTS, NSTAI, NSTAKTS, NELB, IAC, IEC
integer(kind=iwp), intent(inout) :: ISTMAP(NSTAKTS,NORBTS)
real(kind=wp), intent(inout) :: SGNMAP(NSTAKTS,NORBTS)
real(kind=wp), intent(in) :: SCLFAC
integer(kind=iwp) :: I_AM_ACTIVE, IA, IADRI0, IADRK0, IB, IORB, IORBRT, IORBRTS, IROW, ISTR, KSTR, NSTAINSTA, NSTAKNSTA
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IORBR, NK
#endif
real(kind=wp) :: SIGN0, SGN

! Some dummy initializations
SGN = Zero ! jwk-cleanup
ISTR = 0 ! jwk-cleanup

!write(u6,*) ' ICRESTR'
!call IWRTMA(ICRESTR,LROW_IN,NSTAK,LROW_IN,NSTAK)
!write(u6,*) ' IOFFI = ',IOFFI
!PAM2009 SIGN0 = SCLFAC*(-One)**NELB
if (mod(NELB,2) == 0) then
  SIGN0 = SCLFAC
else
  SIGN0 = -SCLFAC
end if
do KSTR=IOFFK,NSTAK+IOFFK-1
  do IORB=IORBTSF,IORBTSF-1+NORBTS
    ! Relative to Type-symmetry start
    IORBRTS = IORB-IORBTSF+1
    ! Relative to type start
    IORBRT = IORB-IORBTF+1
    !write(u6,*) ' IORBRTS IORBRT',IORBRTS,IORBRT
    ! Change of active group
    I_AM_ACTIVE = 0
    if (IAC == 2) then
      !write(u6,*) ' ICREORB = ',ICREORB(IORBRT,KSTR)
      !write(u6,*) ' ICRESTR = ',ICRESTR(IORBRT,KSTR)
      if (ICREORB(IORBRT,KSTR) > 0) then
        ! Creation is nonvanishing
        I_AM_ACTIVE = 1
        if (ICRESTR(IORBRT,KSTR) > 0) then
          SGN = SIGN0
          ISTR = ICRESTR(IORBRT,KSTR)
        else
          SGN = -SIGN0
          ISTR = -ICRESTR(IORBRT,KSTR)
        end if
      end if
    else if (IAC == 1) then
      if (IEC == 1) then
        ! Expanded map
        if (ICREORB(IORBRT,KSTR) < 0) then
          ! Annihilation is non-vanishing
          I_AM_ACTIVE = 1
          if (ICRESTR(IORBRT,KSTR) > 0) then
            SGN = SIGN0
            ISTR = ICRESTR(IORBRT,KSTR)
          else
            SGN = -SIGN0
            ISTR = -ICRESTR(IORBRT,KSTR)
          end if
        end if
      else
        ! Compressed map
        do IROW=1,LROW_IN
          !write(u6,*) ' IROW, ICREORB(IROW,KSTR)',IROW,ICREORB(IROW,KSTR)
          !OLD if (ICREORB(IROW,KSTR)  == -IORBRT) then
          if (ICREORB(IROW,KSTR) == -IORB) then
            ! Annihilation is non-vanishing
            I_AM_ACTIVE = 1
            if (ICRESTR(IROW,KSTR) > 0) then
              SGN = SIGN0
              ISTR = ICRESTR(IROW,KSTR)
            else
              SGN = -SIGN0
              ISTR = -ICRESTR(IROW,KSTR)
            end if
          end if
        end do
      end if
      ! End of expanded/compact switch
    end if
    ! End of Creation/annihilation switch

    if (I_AM_ACTIVE == 1) then
      ! Excitation is open, corresponding active I string
      ! Relative to start of given symmetry for this group
      ISTR = ISTR-IOFFI+1
      !write(u6,*) ' ISTR, relative = ',ISTR
      ! This Creation is active for all choices of strings in supergroup
      ! before and after the active type. Store the corrsponding mappings
      IADRK0 = (KSTR-IOFFK)*NSTA+IOFFKSP-1
      IADRI0 = (ISTR-1)*NSTA+IOFFISP-1
      !write(u6,*) ' IADRK0 IOFFK IOFFKSP ',IADRK0,IOFFK,IOFFKSP
      !write(u6,*) ' IADRI0, IOFFISP ',IADRI0,IOFFISP

      NSTAINSTA = NSTAI*NSTA
      NSTAKNSTA = NSTAK*NSTA

      !write(u6,*) ' ISTR NSTA NSTB ',ISTR,NSTA,NSTB
      !write(u6,*) ' NSTAI,NSTAK',NSTAI,NSTAK
      do IB=1,NSTB
        ISTMAP(IADRK0+1:IADRK0+NSTA,IORBRTS) = [(IADRI0+IA,IA=1,NSTA)]
        SGNMAP(IADRK0+1:IADRK0+NSTA,IORBRTS) = SGN
        IADRI0 = IADRI0+NSTAINSTA
        IADRK0 = IADRK0+NSTAKNSTA
      end do
    end if
  end do
end do

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from ADAST_GASSM'
write(u6,*) ' ======================='
NK = NSTB*NSTAK*NSTA
write(u6,*) ' Number of K strings accessed ',NK
if (NK /= 0) then
  do IORB=IORBTSF,IORBTSF+NORBTS-1
    IORBR = IORB-IORBTSF+1
    write(u6,*) ' Update Info for orbital ',IORB
    write(u6,*) ' Mapped strings and sign'
    call IWRTMA(ISTMAP(1,IORBR),1,NK,1,NK)
    call WRTMAT(SGNMAP(1,IORBR),1,NK,1,NK)
  end do
end if
#endif

end subroutine ADAST_GASSM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine termCF( ANGMOM, AMFI, ESFS, ldimcf, iDIM, maxes2, iopt,
     &                   nlanth, iprint )
c
c this Subroutine calculates the parameters of term-specific crystal field
c for lanthanides:
c
c  nstate                      -- total number of spin free states
c                                 mixed in RASSI
c  lDIMcf                      -- number of orbital states in the
c                                 considered term (LS term)
c  ANGMOM ( 3, nstate, nstate) -- a real array holding the matrix
c                                 elements of L in this basis
c                                 (read from RASSI):
c  ESFS (nstate)               -- energy of the orbital states form the LS term
c  maxes2(3,3)                 -- rotation matrix needed to choose the
c                                 main quantization axis
c                                 ( determinant(maxes)=1.0_wp, orthogonal vectors )
c  iopt                        -- option for choosing the main quanization axis
c                   iopt = 1   -- axis of the ground orbital multiplet,
c                                 iDIM specifies the size of pseudo L
c                   iopt = 2   -- axis of the entire L manifold
c                   iopt = 3   -- maxes is defined by the user
c                                 ( maxes2 is given as input )
c                   iopt = 4   -- maxes is the unity matrix ( original Z
c                                 is the quantization axis )
c
      Implicit None
      Integer, Parameter  :: wp=selected_real_kind(p=15,r=307)
#include "stdalloc.fh"
      Integer, intent(in)       :: ldimcf, iprint, iopt, nlanth, iDIM
      Real(kind=8), intent(in) :: esfs(ldimcf)
      Real(kind=8), intent(in) :: angmom(3,ldimcf,ldimcf)
      Real(kind=8), intent(in) :: amfi(3,ldimcf,ldimcf)
      Real(kind=8), intent(in) :: maxes2(3,3)

      Real(kind=8)                 :: finddetr, dnrm2
!      Real(kind=8)                 :: knm(12,0:12)
      Real(kind=8), allocatable    :: maxes(:,:)
      Real(kind=8), allocatable    :: gtens(:)
      Real(kind=8), allocatable    :: eloc(:) ! lDIMcf
      Real(kind=8), allocatable    :: Winit(:) ! lDIMcf

      Real(kind=8)                 :: BNC(lDIMcf,0:lDIMcf)
      Real(kind=8)                 :: BNS(lDIMcf,0:lDIMcf)
      Real(kind=8)                 :: Bstev(lDIMcf,-lDIMcf:lDIMcf)
      Complex(kind=8)              ::
     &                            Akq((lDIMcf-1),-(lDIMcf-1):(lDIMcf-1))
      Complex(kind=8)              :: trace
      Complex(kind=8), allocatable :: Angm(:,:,:) ! 3,ldimcf,ldimcf
      Complex(kind=8), allocatable :: dipso(:,:,:) ! 3,ldimcf,ldimcf
      Complex(kind=8), allocatable :: amfi_c(:,:,:) ! 3,ldimcf,ldimcf
      Complex(kind=8), allocatable :: amfi2(:,:,:) ! 3,ldimcf,ldimcf
      Complex(kind=8), allocatable :: amfi_l(:,:,:) ! 3,ldimcf,ldimcf
      Complex(kind=8), allocatable :: Z(:,:) !ldimcf,ldimcf
      Complex(kind=8), allocatable :: tmp(:,:) !ldimcf,ldimcf
      Complex(kind=8), allocatable :: HCF(:,:) !ldimcf,ldimcf
      Complex(kind=8), allocatable :: Zinit(:,:) !ldimcf,ldimcf

      Integer       :: i, j, l, info, i1, i2
      External      :: finddetr, trace, dnrm2
      Logical       :: debug =.false.
      Real(kind=8) :: au2cm=2.194746313705d5

!
      Real(kind=8) :: tS, tL, tJ, coeffCG, spinM, orbM,tJM,CF(100,100)
      Integer       :: MS, ML, MJ
      Integer       :: ij, iLS, nLS, ibasS(100), ibasL(100), ibasJ(100)
      Integer       :: irootL(100), ir, icas, k
      complex(kind=8) :: CFC(100,100),zl(lDIMcf,lDIMcf)
!============== End of variable declarations ==========================
      Call mma_allocate(maxes,3,3,'maxes')
      Call mma_allocate(gtens,3,'gtens')
      Call mma_allocate(eloc,lDIMcf,'eloc')
      Call mma_allocate(Winit,lDIMcf,'Winit')

      Call mma_allocate(Angm,3,ldimcf,ldimcf,'angm')
      Call mma_allocate(dipso,3,ldimcf,ldimcf,'dipso')
      Call mma_allocate(amfi_c,3,ldimcf,ldimcf,'amfi_c')
      Call mma_allocate(amfi2,3,ldimcf,ldimcf,'amfi2')
      Call mma_allocate(amfi_l,3,ldimcf,ldimcf,'amfi_l')
      Call mma_allocate(Z,ldimcf,ldimcf,'Z')
      Call mma_allocate(Zinit,ldimcf,ldimcf,'Zinit')
      Call mma_allocate(tmp,ldimcf,ldimcf,'tmp')
      Call mma_allocate(HCF,ldimcf,ldimcf,'HCF')

      Call dcopy_(3,[0.0_wp],0,gtens,1)
      Call dcopy_(3*3,[0.0_wp],0,maxes,1)
      Call dcopy_(lDIMcf,[0.0_wp],0,eloc,1)
      Call dcopy_(lDIMcf,[0.0_wp],0,Winit,1)

      Call zcopy_(3*ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,Angm,1)
      Call zcopy_(3*ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,dipso,1)
      Call zcopy_(3*ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,amfi_c,1)
      Call zcopy_(3*ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,amfi2,1)
      Call zcopy_(3*ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,amfi_l,1)
      Call zcopy_(  ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,Z,1)
      Call zcopy_(  ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,Zinit,1)
      Call zcopy_(  ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,tmp,1)
      Call zcopy_(  ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,HCF,1)
!----------------------------------------------------------------------
      Write(6,'(/)')
      Write(6,'(100A)') ('%',i=1,95)
      If(MOD(lDIMcf,2)==1) Then
        Write(6,'(5x,A,I2,A)') 'CALCULATION OF CRYSTAL-FIELD '//
     &                         'PARAMETERS OF THE GROUND ATOMIC '//
     &                         'TERM, L = ', (lDIMcf-1)/2, '.'
      Else
        Write(6,'(5x,A,I2,A)') 'CALCULATION OF CRYSTAL-FIELD '//
     &                         'PARAMETERS OF THE GROUND ATOMIC '//
     &                         'TERM, L = ', (lDIMcf-1),'/2.'
      End If
      Write(6,'(100A)') ('%',i=1,95)
      Write(6,*)

      Do l=1,3
        Do i=1,ldimcf
          Do j=1,ldimcf
            dipso(l,i,j)=-CMPLX(0.0_wp,angmom(l,i,j),wp)
            amfi_c(l,i,j)=CMPLX(amfi(l,i,j),0.0_wp,wp)
          End Do
        End Do
      End Do
c  find the main anisotropy direction of the
c  diagonalize the angmom
      If ( iopt .eq. 1 ) Then
c                   iopt = 1   -- axis of the ground orbital Doublet
         Call atens( dipso(1:3,1:iDIM,1:iDIM), iDIM, gtens, maxes,
     &               iprint)
         Write(6,'(a)') 'The parameters of the Crystal Field matrix '//
     &                  'are written in the coordinate system:'
         If(MOD(iDIM,2) == 0) Then
           Write(6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic '//
     &                         'axes of the ground pseudo-L = |',
     &                          iDIM-1,'/2> orbital multiplet.'
         Else
           Write(6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic '//
     &                         'axes of the ground pseudo-L = |',
     &                         (iDIM-1)/2,'> orbital multiplet.'
         End If

      Else If ( iopt .eq. 2 ) Then
c                   iopt = 2   -- axis of the entire L manIfold
         Call atens( dipso(1:3,1:ldimcf,1:ldimcf), lDIMcf, gtens, maxes,
     &               iprint)
         If(MOD(lDIMCF,2).eq.0) Then
           Write(6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic '//
     &                         'axes of the ground atomic L = |',
     &                          lDIMCF-1,'/2> multiplet'
         Else
           Write(6,'(a,i2,a)') '(Xm, Ym, Zm) --  the main magnetic '//
     &                         'axes of the ground atomic L = |',
     &                         (lDIMCF-1)/2,'> multiplet'
         End If

      Else If ( iopt .eq. 3 ) Then
c                   iopt = 3   -- maxes is defined by the user ( maxes is given as input )
         Write(6,'(a)') 'The parameters of the Crystal Field matrix '//
     &                  'are written in the coordinate system:'
         Write(6,'(a)') '(Xm, Ym, Zm) -- defined in the input file.'
         If( finddetr(maxes2(1:3,1:3),3).eq.0.0_wp) Then
            Write(6,'(A)') 'TermCF:   iopt=3, while  DET(maxes)= 0.0'
            Call AbEnd()
         End If
         If( finddetr(maxes2(1:3,1:3),3).lt.0.0_wp) Then
           Do i=1,3
              maxes(i,1)=-maxes2(i,1)
           End Do
           If(iprint.gt.2) Write(6,'(a)')
     &                           'The original coordinate system '//
     &                           'was LEFT-handed. It has been '//
     &                           'changed to the RIGHT-handed'
         Else
           ! copy the maxes2 to maxes
           Do i=1,3
             Do j=1,3
               maxes(i,j)=maxes2(i,j)
             End Do
           End Do

         End If

      Else If ( iopt .eq. 4 ) Then
c                   iopt = 4   -- maxes is the unity matrix ( original Z is the quantization axis )
         Do i=1,3
            maxes(i,i)=1.0_wp
         End Do
      Else
         Call AbEnd()
      End If

      ! print out the rotation matrix:
      Write(6,'(a)') 'Rotation matrix from the initial coordinate '//
     &               'system to the employed coordinate system is:'

      If((iopt.eq.1).OR.(iopt.eq.2)) Then
         Write(6,'(70a)') ('-',i=1,67),'|'
         Write(6,'(A,31x,A)') 'x , y , z  -- initial Cartesian axes','|'
         Write(6,'(A,35x,A)') 'Xm, Ym, Zm -- main magnetic axes','|'
         Write(6,'(4x,3(17x,a),9x,a)') 'x','y','z','|'
         Write(6,'(6x,A,3F18.14,1x,A)')
     &                     '| Xm |',(maxes(j,1),j=1,3),'|'
         Write(6,'( A,A,3F18.14,1x,A)') ' R =  ',
     &                     '| Ym |',(maxes(j,2),j=1,3),'|'
         Write(6,'(6x,A,3F18.14,1x,A)')
     &                     '| Zm |',(maxes(j,3),j=1,3),'|'
         Write(6,'(83a)') ('-',i=1,67),'|'
         Write(6,'(A,I3)') 'Quantization axis is Zm.'

      Else If(iopt.eq.3) Then

         Write(6,'(70a)') ('-',i=1,67),'|'
         Write(6,'(A,31x,A)') 'x , y , z  -- initial Cartesian axes','|'
         Write(6,'(A,11x,A)') 'Xm, Ym, Zm -- the coordinate system '//
     &                        'defined in the input','|'
         Write(6,'(4x,3(17x,a),9x,a)') 'x','y','z','|'
         Write(6,'(6x,A,3F18.14,1x,A)')
     &                     '| Xm |',(maxes(j,1),j=1,3),'|'
         Write(6,'( A,A,3F18.14,1x,A)') ' R =  ',
     &                     '| Ym |',(maxes(j,2),j=1,3),'|'
         Write(6,'(6x,A,3F18.14,1x,A)')
     &                     '| Zm |',(maxes(j,3),j=1,3),'|'
         Write(6,'(83a)') ('-',i=1,67),'|'
         Write(6,'(A,I3)') 'Quantization axis is Zm.'

      Else

         Write(6,'(A)') 'IDENTITY matrix.'
         Write(6,'(A,I3)') 'Quantization axis is the initial z axis.'
      End If


!  rotate the angular momentum to the new axes, using "maxes"
      Call zcopy_(3*ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,amfi2,1)
      Call zcopy_(3*ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,angm,1)
      Call rotmom2( dipso(1:3,1:ldimcf,1:ldimcf), ldimcf,
     &              maxes, angm )
      Call rotmom2( amfi_c(1:3,1:ldimcf,1:ldimcf), ldimcf,
     &              maxes, amfi2 )
      If (debug) Call prmom('TERMCF:: ANGM',angm,ldimcf)
      If (debug) Call prmom('TERMCF:: AMFI2',amfi2,ldimcf)

!-----------------------------------------------------------------------
!  Find the pseudo-L basis of the LS manifold
      Call pseudospin(angm,ldimcf,Z,3,1,iprint)

      If ((iprint >= 4).or.debug) Then
        Write(6,*)
        Write(6,'(5X,A)') 'PSEUDO-L EIGENFUNCTIONS:'
        Write(6,*)
        If(MOD(lDIMcf,2).eq.1) Then
          Do I=1,lDIMcf
            Write(6,'(A,I3,A,3X,20(2F9.6,1X))') '|',
     &                 (lDIMcf-1)/2+(1-I),' > :',(Z(j,I),j=1,lDIMcf)
             do k=1,lDIMcf
                zl( (lDIMcf-1)/2+(1-I),k)=Z(k,I)
             enddo
          End Do
        Else
          Do I=1,lDIMcf
            Write(6,'(A,I3,A,3X,20(2F9.6,1X))') '|',
     &                 (lDIMcf-1)-2*(I-1),'/2 > :',(Z(j,I),j=1,lDIMcf)
          End Do
        End If
      End If
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  decompose the orbital moment AMSL in ITOs
C  transform AMFI integrals to pseudo-L basis:
      ! calculate the matrix elements of the spin and magnetic moment
      ! in the spin-orbit basis:
      Call zcopy_(3*ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,amfi_l,1)
      Do L=1,3
         Call zcopy_(  ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,tmp,1)
         ! amfi:
         Call ZGEMM_('C', 'N', lDIMcf, lDIMcf, lDIMcf, (1.0_wp,0.0_wp),
     &                     Z, lDIMcf,
     &          AMFI2(L,:,:), lDIMcf,           (0.0_wp,0.0_wp),
     &                   TMP, lDIMcf )
         Call ZGEMM_('N', 'N', lDIMcf, lDIMcf, lDIMcf, (1.0_wp,0.0_wp),
     &                    TMP, lDIMcf,
     &                      Z, lDIMcf,          (0.0_wp,0.0_wp),
     &          AMFI_L(L,:,:), lDIMcf )

      End Do !L

      If (debug) Call prMom_herm('TERMCF:: AMFI_L',amfi_l*au2cm,ldimcf)


!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!c  calculate the RASSI Crystal Field matrix
      Call dcopy_(lDIMcf,[0.0_wp],0,eloc,1)
      Call rtrace(lDIMcf,ESFS,ELOC)
      Call zcopy_(ldimcf*ldimcf,[(0.0_wp,0.0_wp)],0,HCF,1)
      Do i=1,lDIMcf
        Do I1=1,lDIMcf
          Do I2=1,lDIMcf
            HCF(I1,I2)=HCF(I1,I2)+ELOC(i)*conjg(Z(i,I1))*Z(i,I2)
          End Do
        End Do
      End Do

      info=0
      Call dcopy_(lDIMcf,[0.0_wp],0,Winit,1)
      Call zcopy_(lDIMcf*lDIMcf,[(0.0_wp,0.0_wp)],0,Zinit,1)
      Call DIAG_C2( HCF,lDIMcf,info,Winit,Zinit)
      Call print_ZFS('Ab Initio Calculated Crystal-Field Splitting '//
     &               'Matrix written in the basis of Pseudo-L '//
     &               'Eigenfunctions',HCF,lDIMCF)

      Call NEWCF(HCF,lDIMcf,Akq,BNC,BNS,BStev)
!ccccccccccc   print CF parameter ccccccccccccccccccccccccccccccc
      If((iprint>=4).or.debug) Then
         Call print_CFP_LCLU(lDIMCF,BNC,BNS,.true.)
         Call print_CFP_stev(lDIMCF,Bstev,.true.)
         Call print_CFP_naoya(lDIMcf,Akq,.true.)
      Else
         Call print_CFP_LCLU(lDIMCF,BNC,BNS,.false.)
         Call print_CFP_stev(lDIMCF,Bstev,.false.)
         Call print_CFP_naoya(lDIMcf,Akq,.false.)
      End If

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      Write(6,'(/)')
      If(MOD(lDIMCF,2)==1) Then
         Write(6,'(A,I0)') 'DECOMPOSITION OF THE RASSCF WAVE '//
     &                     'FUNCTIONS CORRESPONDING TO THE '//
     &                     'LOWEST ATOMIC MULTIPLET L =',
     &                      (lDIMCF-1)/2
      Else
         Write(6,'(A,I0,A)') 'DECOMPOSITION OF THE RASSCF WAVE '//
     &                       'FUNCTIONS CORRESPONDING TO THE '//
     &                       'LOWEST ATOMIC MULTIPLET L = ',
     &                       (lDIMCF-1), '/2'
      End If
         Write(6,'(A,I0)') 'IN WAVE FUNCTIONS WITH DEFINITE '//
     &                     'PROJECTION OF THE TOTAL MOMENT '//
     &                     'ON THE QUANTIZATION AXIS'
      Call print_ZFS_naoya('L',Zinit,lDIMcf)
      Call individual_ranks(lDIMCF,BNC,BNS,HCF,'L',iprint)

!  saving some information for tests:
      Call Add_Info('CRYS_TERM_BNMC_20',BNC(2,0),1,4)
      Call Add_Info('CRYS_TERM_BNMC_40',BNC(4,0),1,4)
      Call Add_Info('CRYS_TERM_BNMC_60',BNC(6,0),1,4)
      goto 999
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      generate |J,MJ> states using the spin |S,MS> and |L,ML> states
c
      tS=0.d0
      tL=0.d0
      tJ=0.d0
      MS=0
      ML=0
      MJ=0
      If (nlanth== 1)      then  ! Ce  J=5/2
          tS=0.5d0
          tJ=2.5d0
      else if (nlanth== 2) then  ! Pr  J=4
          tS=1.d0
          tJ=4.d0
      else if (nlanth== 3) then ! Nd  J=9/2
          tS=1.5d0
          tJ=4.5d0
      else if (nlanth== 4) then ! Pm  J=4
          tS=2.0d0
          tJ=4.d0
      else if (nlanth== 5) then ! Sm  J=5/2
          tS=2.5d0
          tJ=2.5d0
      else if (nlanth== 6) then ! Eu  J=0
          tS=3.0d0
          tJ=0.0d0
      else if (nlanth== 7) then ! Gd  J=7/2; S=7/2
          tS=3.5d0
          tJ=3.5d0
      else if (nlanth== 8) then ! Tb  J=6
          tS=3.0d0
          tJ=6.0d0
      else if (nlanth== 9) then ! Dy  J=15/2
          tS=2.5d0
          tJ=7.5d0
      else if (nlanth==10) then ! Ho  J=8
          tS=2.0d0
          tJ=8.0d0
      else if (nlanth==11) then ! Er  J=15/2
          tS=1.5d0
          tJ=7.5d0
      else if (nlanth==12) then ! Tm  J=6
          tS=1.0d0
          tJ=6.0d0
      else if (nlanth==13) then ! Yb  J=7/2
          tS=0.5d0
          tJ=3.5d0
      else
          write (6,'(A)') 'not implemented yet'
      endif
      tL =(dble(lDIMcf)-1.d0)/2.d0
      ML=lDIMcf
      MS=nint(2.d0*tS+1.d0)
      MJ=nint(2.d0*tJ+1.d0)

c      print *,'nlanth=', nlanth, '  S,  L,  J =', tS, tL, tJ,
c     &                           ' MS, ML, MJ =', MS, ML, MJ

c      print *, 'build coupled basis |L,ML>|S,MS>'
      nLS=ML*MS
      ij=0
      ir=0
      do i=-ML+1,ML-1,2
         ir=ir+1
         do j=-MS+1,MS-1,2
            ij=ij+1
            ibasL(ij)=i
            ibasS(ij)=j
            irootL(ij)=ir
         enddo
      enddo
      do iLS=1,nLS
         write(6,'(A,3I4,2x,A,2F6.1)')
     &        'nLS,  ML,  MS =', iLS, ibasL(iLS), ibasS(iLS),
     &        'ML, MS =', dble(ibasL(iLS))/2.d0, dble(ibasS(iLS))/2.d0
      enddo

      write(6,*) 'proceed to build |J,MJ> states'
      ij=0
      do i=-MJ+1,MJ-1,2
        ij=ij+1
        ibasJ(ij)=i
      enddo

      do i=1,MJ
         write(6,'(i3,i6,F6.1)') i, ibasJ(i), dble(ibasJ(i))/2.d0
      enddo

      Cf=0.0_wp
      CfC=(0.0_wp,0.0_wp)

      do ij=1,MJ
         tJM=dble(ibasJ(ij))/2.d0
         do iLS=1,nLS
              ! set projections
              spinM=dble(ibasS(iLS))/2.d0
              orbM=dble(ibasL(iLS))/2.d0

              Call Clebsh_Gordan(tL,orbM,tS,spinM,tJ,tJM, coeffCG)
              Cf(iJ,iLS)=coeffCG

              If(abs(coeffCG)>1.d-20) write(6,*) 'ij,iLS,coeffCG',
     *                                            ij,iLS,coeffCG
         enddo
      enddo

      Write(6,*) 'MJ ->  (1,16), (2,15), (3,14), (4,13), '//
     *                   '(5,12), (6,11), (7,10), (8,9)'
      do iLS=1,nLS
        Write(6,'(A,2F6.1,16F11.8)') 'ML,MS: ',dble(ibasL(iLS))/2.d0,
     *   dble(ibasS(iLS))/2.d0,
     &   Cf(1,iLS), Cf(MJ,iLS),
     &   Cf(2,iLS), Cf(MJ-1,iLS),
     &   Cf(3,iLS), Cf(MJ-2,iLS),
     &   Cf(4,iLS), Cf(MJ-3,iLS),
     &   Cf(5,iLS), Cf(MJ-4,iLS),
     &   Cf(6,iLS), Cf(MJ-5,iLS),
     &   Cf(7,iLS), Cf(MJ-6,iLS),
     &   Cf(8,iLS), Cf(MJ-7,iLS)
      enddo


      Write(6,*) 're-write initial CASSCF states into |J,MJ>, using '
     &        //'( Z(j,I),j=1,lDIMcf)  coefficients'



      Do ij=1,MJ
        Do iLS=1,nLS

          k=ibasL(iLS)/2

           do iCAS=1,ML
              CFC(iJ,iLS) = CFC(iJ,iLS) + Z(k,iCAS)*Cf(iJ,iLS)
           enddo


        End Do
      End Do


      Write(6,*)  'MJ ->  (1,16), (2,15), (3,14), (4,13), '//
     *                   '(5,12), (6,11), (7,10), (8,9)'
      do iLS=1,nLS
         write(6,'(A,i2,F6.1,16(2F8.4,2x))') 'iCAS,MS: ',
     &           irootL(iLS), dble(ibasS(iLS))/2.d0,
     &   CfC(1,iLS), CfC(MJ,  iLS),
     &   CfC(2,iLS), CfC(MJ-1,iLS),
     &   CfC(3,iLS), CfC(MJ-2,iLS),
     &   CfC(4,iLS), CfC(MJ-3,iLS)
c     &   CfC(5,iLS), CfC(MJ-4,iLS)
c     &   CfC(6,iLS), CfC(MJ-5,iLS),
c     &   CfC(7,iLS), CfC(MJ-6,iLS),
c     &   CfC(8,iLS), CfC(MJ-7,iLS)
      enddo


 999  Continue
!-----------------------------------------------------------------------
      Call mma_deallocate(maxes)
      Call mma_deallocate(gtens)
      Call mma_deallocate(eloc)
      Call mma_deallocate(Winit)

      Call mma_deallocate(Angm)
      Call mma_deallocate(dipso)
      Call mma_deallocate(amfi_c)
      Call mma_deallocate(amfi2)
      Call mma_deallocate(amfi_l)
      Call mma_deallocate(Z)
      Call mma_deallocate(Zinit)
      Call mma_deallocate(tmp)
      Call mma_deallocate(HCF)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine find_aniso_format(old_aniso_format)

      Implicit None
      Logical :: old_aniso_format
      Character(Len=280) :: line
      Integer :: LINENR, Input

      Input=5
      old_aniso_format=.false.

C=========== End of default settings====================================
      REWIND(Input)
50    READ(Input,'(A280)',End=998) LINE
      Call NORMAL(LINE)
      If(LINE(1:11).ne.'&POLY_ANISO') Go To 50
      LINENR=0
100   READ(Input,'(A280)',End=998) line
      LINENR=LINENR+1
      Call NORMAL(LINE)
      If (LINE(1:1).eq.'*') Go To 100
      If (LINE.eq.' ') Go To 100
      If( LINE(1:4).ne.'OLDA') Go To 100
      If((LINE(1:4).eq.'END ').OR.(LINE(1:4).eq.'    ' )) Go To 200

      If (line(1:4).eq.'OLDA') Then

          old_aniso_format=.true.

          LINENR=LINENR+1
          Go To 100
      End If

200   Continue

      Go To 190
C------ errors ------------------------------
998   continue
      Write(6,*)' READIN: Unexpected End of input file.'

190   Continue
      Write(6,*) 'find_aniso_format::  old_aniso_format=',
     &  old_aniso_format
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007,2009, Bingbing Suo                                *
************************************************************************
c Jul. 3, 2009 -bsuo- subroutines are used in davidson diagonalization
c
c******************************************************
      subroutine cidiagonalize(mxvec)
c******************************************************
c     this subroutine does diagonalization of
c     ci matrix for multi-root mrci program
c     26 feb 2007 - write by suo bing
c------------------------------------------------------
c
#include "drt_h.fh"
#include "files_gugaci.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      common /thresh/ vthreen,vthrealp,vthreresid
      dimension idxvec(max_iter)
      dimension valpha(max_root),vcien(max_root),vcienold(max_root),
     *          difeci(max_root),vresid(max_root)
c      dimension vad(max_vector),th(max_vector)
      logical log_convergance,log_muliter
      data dzero/0.d0/,depc/1.0d-7/,ecrita/1.0d-8/,dcrita/1.0d-7/
      data vortho_criterion/1.d-8/,vreth/1.d-4/
c      data venergy_criterion/1.d-8/
c     *     valpha_criterion/1.d-7/,vresid_criterion/1.d-8/,
c     *     vreth/1.d-4/


      venergy_criterion=vthreen
      valpha_criterion=vthrealp
      vresid_criterion=vthreresid
      write(6,*) " threshhold for convergence is set as"
      write(6,*) venergy_criterion,valpha_criterion,vresid_criterion

c      write(6,*) vthreen,vthrealp,vthreresid
      log_convergance=.false.
      log_muliter=.false.
      if(mroot*nci_dim.le.mxvec) log_muliter=.true.
      mcroot=mroot
c*********************************************************************
c     for debug use only
c
      id=1
      if(id.eq.2) then

        indx(1)=0
        indx(2)=nci_dim
        vector1(1:nci_dim)=0.d0
        vector2(1:nci_dim)=0.d0
        !call cielement
        vector1=0.d0; vector2=0.d0
        vector1(55)=1.d0
        call readint(2,vint_ci)
        call vd_drt_ci_new()
        call dv_drt_ci_new()
        !call matrix_vector_multi_parellel_drt(sechc)
        do i=1,3450
          write(11,"(i8,1x,f18.8)") i,vector2(i)
        enddo
c        stop 888
      call abend
      endif
c***********************************************************************

      mth_eigen=0
      numroot=mroot
10    continue
      sc0=c_time()
      vector1=0.d0
      vector2=0.d0
      if(log_muliter) then
        msroot=1
        mcroot=mroot
        call mrcibasis(nci_dim,mroot,mjn,indx,vector1,vector2,vcien,
     *                 mth_eigen,mroot)
!        call mrcibasis_init(nci_dim,mroot,mjn,indx,vector1,vector2,
!     *       vcien,mth_eigen,mroot)
      else
        msroot=1
        mcroot=1
        if(mth_eigen.eq.0) then
          mth_eigen=1
        else
          mth_eigen=mth_eigen+1
        endif
        if(mth_eigen.eq.1) then
          call mrcibasis(nci_dim,mroot,mjn,indx,vector1,vector2,vcien,
     *                   mth_eigen,1)
        else
          msroot=1
          mcroot=1
          call mrcibasis_rest(nci_dim,numroot,mjn,indx,vector1,
     *                        vector2,vcien,mth_eigen,1)
        endif
      endif
c      stop 888
      sc1=c_time()
      sct=sc1-sc0
      write(6,890) 2*mroot,sct

      idxvec(1)=mroot
      idxvec(2)=2*mroot
      idxvec(3:max_iter)=0
      vcienold(1:max_root)=dzero
      vresid(1:max_root)=dzero
      valpha(1:max_root)=dzero
      iiter=2
      kval=2*mroot
      msroot=1
      mcroot=mroot
      mtsta=1
      iciter=0
      irset=0

      write(6,901)
      do while (.not.log_convergance)
        iciter=iciter+1
        sc0=c_time()
        call matrmkmul(kval,mtsta,iiter,idxvec,irset)
        call hotred(max_kspace,kval,vp,vd,ve,vu)
        call qlcm(max_kspace,kval,vd,ve,vu)
!        if(iciter.eq.3) stop 888

        vcienold(1:mroot)=vcien(1:mroot)
        valpha(mtsta:mroot)=dzero
        do m=mtsta,mroot
          vcien(m)=vd(m)
          valpha(m)=abs(vu(kval,m))
          difeci(m)=abs(vcien(m)-vcienold(m))
        enddo

        call compute_residual_vector_mroot(kval,mtsta,iiter,idxvec,
     *                                     vresid,vcien)
!        write(6,900) iciter
!        write(6,901)
        if(iciter.eq.1) then
          sechc=0.d0
          scvp=0.d0
        endif
        do mt=1,mroot
          write(6,902) iciter,mt,vcien(mt),difeci(mt),
     *                 valpha(mt),vresid(mt),
     *                 sechc,scvp
        enddo
        call xflush(6)

!        write(6,903) sechc,scvp
!        write(nf2,903) sechc,scvp
        mtsta0=mtsta
        do mt=mtsta0,mroot
          if((valpha(mt).lt.valpha_criterion.or.
     *       vresid(mt).lt.vresid_criterion).and.
     *       abs(difeci(mt)).lt.venergy_criterion) then
            if(mt.eq.mtsta) then
              mtsta=mtsta+1
              mcroot=mcroot-1
            endif
            if(mtsta.eq.mroot+1) then
              if(log_muliter) then
                log_convergance=.true.
                call get_eigvector(mtsta0,vcien,valpha,diffci,vresid,
     *                             mth_eigen,log_muliter)
                return
              else
                if(mth_eigen.lt.numroot) then
                  call get_eigvector(mtsta0,vcien,valpha,diffci,vresid,
     *                               mth_eigen,log_muliter)
                  log_convergance=.false.
                  goto 10
                else
                  log_convergance=.true.
                  call get_eigvector(mtsta0,vcien,valpha,diffci,vresid,
     *                               mth_eigen,log_muliter)
                  return
                endif
              endif
            endif
          endif
        enddo

        if(iciter.gt.maxciiter) then
          write(6,*) " warning! mrci fail to converged! program stop!"
          write(6,"(a30,1x,i3)") " number of converged roots is=",mtsta0
          mtsta0=mroot
          call get_eigvector(mtsta0,vcien,valpha,diffci,vresid,
     *                       mth_eigen,log_muliter)
          return
        endif

        if(mtsta.ne.mtsta0) then
          nd=nci_dim*(mroot-mtsta0+1)
          call read_ml(lucidia,1,vector2,nd,2)
c write converged cm into file 7
          do mt=mtsta0,mtsta-1
            mtidx=indx(mt-mtsta0+1)
            call write_ml(lucivec,1,vector2(mtidx+1:mtidx+nci_dim),
     &                    nci_dim,mt)
          enddo
          nd=(mroot-mtsta0+1)*nci_dim
          vector2(1:nd)=vector1(1:nd)
          vector1(1:nd)=dzero
          mi=indx(mtsta-mtsta0+1)
          nd=(mroot-mtsta+1)*nci_dim
          do i=1,nd
            vector1(i)=vector2(i+mi)
          enddo
        endif
!        write(6,910) mtsta-1

c***********************************************************************
c    reset kspace
c
        if(kval+mcroot.gt.max_kspace-1) then
          write(6,911)

          nd=mroot*nci_dim
          vector1(1:nd)=dzero
          nd=(mroot-mtsta0+1)*nci_dim
          call read_ml(lucidia,1,vector2,nd,2)
          nda=nci_dim*mroot
          call read_bv(lucitv1,1,vector1,nda)
          vsum=dzero
!          rewind 7
          do mt=1,mtsta-1
            mtidx=indx(mt)
            call read_ml(lucivec,1,vector1(mtidx+1:mtidx+nci_dim),
     &                   nci_dim,mt)
!            read(7) vector1(mtidx+1:mtidx+nci_dim)
          enddo

          nda=nci_dim*mroot
          nd=(mroot-mtsta+1)*nci_dim
          mtidx=indx(mtsta)
          mid=indx(mtsta-mtsta0+1)
          vector1(mtidx+1:mtidx+nd)=vector2(mid+1:mid+nd)
          call write_bv(lucitv1,1,vector1,nda)
          vsum=dzero
          do mt=1,mtsta-1
            vet=vcien(mt)
            mtidx=indx(mt)
            do l=1,nci_dim
              vector1(l+mtidx)=vet*vector1(l+mtidx)
            enddo
          enddo

          nda=mroot*nci_dim
          vector1(1:nda)=dzero
          do jiter=1,iiter
            if(jiter.eq.1) then
              irts=1
            else
              irts=idxvec(jiter-1)+1
            endif
            irte=idxvec(jiter)
            nd=(irte-irts+1)*nci_dim
            call read_bv(lucitv2,jiter,vector2,nd)
            do mt=mtsta,mroot
              mtidx=indx(mt)
              do irot=irts,irte
                itidx=indx(irot-irts+1)
                vuim=vu(irot,mt)
                do l=1,nci_dim
                  vector1(mtidx+l)=vector1(mtidx+l)
     *                            +vuim*vector2(itidx+l)
                enddo
              enddo
            enddo
          enddo

          nda=mroot*nci_dim
          vector2(1:nda)=vector1(1:nda)
          call write_bv(lucitv2,1,vector2,nda)

c  start new trial vector
          nda=nci_dim*mroot
          nd=nci_dim*(mroot-mtsta+1)
          mtidx=indx(mtsta)
          vector2(1:nda)=dzero
          vector2(1:nd)=vector1(mtidx+1:mtidx+nd)

          nd=(mroot-mtsta0+1)*nci_dim
          call read_ml(lucidia,1,vector1,nd,2)
c          rewind nf22
c          read(nf22) vector1(1:nd)
          do mt=mtsta,mroot
            mtidx=indx(mt-mtsta+1)
            mtid=indx(mt-mtsta0+1)
            do l=1,nci_dim
              vector1(l+mtidx)=vector1(mtid+l)
            enddo
          enddo

          do mt=mtsta,mroot
            mtidx=indx(mt-mtsta+1)
            venergy=vcien(mt)
            do l=1,nci_dim
              vector1(mtidx+l)=venergy*vector1(mtidx+l)
     *                        -vector2(mtidx+l)
            enddo
          enddo

c          call read_bv(nf8,1,vector2,nci_dim)
          call read_ml(lucidia,1,vector2,nci_dim,1)
          do mt=mtsta,mroot
            mtidx=indx(mt-mtsta+1)
            do l=1,nci_dim
              depff=vector2(l)-vcien(mt)
              if(abs(depff).le.depc) depff=depc
              vector1(mtidx+l)=vector1(mtidx+l)/depff
            enddo
          enddo

          iiter=1
          kval=mroot
          mcroot=mroot-mtsta+1
          call orthog(kval,iiter,mtsta,idxvec)

          idxvec(iiter)=kval

          mcroot=mroot-mtsta+1
          iiter=2
          if(.not.log_muliter) then
            if(mth_eigen.gt.1) then
              call orthogwconvec()
            endif
          endif
          nd=(mroot-mtsta+1)*nci_dim
          call write_bv(lucitv1,iiter,vector1,nd)
          idxvec(iiter)=kval
          mn=mroot*(mroot+1)/2
          vp(1:mn)=dzero
          mn=0
          do m=1,mroot
            mn=mn+m
            vp(mn)=vcien(m)
          enddo
          irset=1
        else
c
c****************************************************
c-- compute revised new appoximate vector --
c
!          call read_ml(lucidia,1,vector2,nci_dim,1)
!          irset=1
!          do mt=mtsta,mroot
!            mtidx=indx(mt-mtsta+1)
!c            logic_tdav=.false.
!            if(logic_tdav) then
!c traditional davidson diagnolization method is used
!              do l=1,nci_dim
!                depff=vector2(l)-vcien(mt)
!c               if(abs(depff).le.depc) depff=depc
!                vector1(mtidx+l)=vector1(mtidx+l)/depff
!              enddo
!            else
!c generalized davidson diagnolization method is used
!              call gdavdiag(mt,mtidx,vcien(mt))
!            endif
!          enddo

          mcroot=mroot-mtsta+1
          call orthog(kval,iiter,mtsta,idxvec)
          if(.not.log_muliter) then
            if(mth_eigen.gt.1) then
              call orthogwconvec()
            endif
          endif
          idxvec(iiter)=kval
          nd=(mroot-mtsta+1)*nci_dim
          call write_bv(lucitv1,iiter,vector1,nd)
        endif

        sc1=c_time()
        scvp=sc1-sc0

        nd=nci_dim*mroot
        vector2(1:nd)=dzero
c -- start h*c

        call read_ml(lucidia,1,vector2,nci_dim,1)
        do mt=mtsta+1,mroot
         mtidx=indx(mt-mtsta+1)
         do l=1,nci_dim
           vector2(mtidx+l)=vector2(l)
         enddo
        enddo

        do mt=mtsta,mroot
          mtidx=indx(mt-mtsta+1)
          do l=1,nci_dim
            ni=mtidx+l
            vector2(ni)=vector2(ni)*vector1(ni)
          enddo
        enddo

        call matrix_vector_multi_parellel_drt(sechc)
        nd=nci_dim*(mroot-mtsta+1)
        call write_bv(lucitv2,iiter,vector2,nd)

      enddo

890   format(/,1x,"number of inital trial vectors is",i3,
     *       /,1x,"total wall clock time=",f9.2," seconds")
c900   format(/,1x,"no.",i3,1x,"iter",/)
901   format(2x,"NITER",1x,"NROOT",3x,"TOTAL ENERGY",4x,
     *          "ENERGY DIFF",4x,"VALPHA",7x,"VRESIDE",1x,"T HC(s)",
     *          1x,"T KSPACE(s)")
902   format(2(2x,i3),2x,f16.9,1x,f12.9,1x,f12.8,1x,f12.8,1x,
     *       2(f8.2,1x))
c903   format(/,1x,"total wall time for h*c=",f8.2,1x,"seconds",/
c     *       1x,"total wall time for",
c     *       " k space calculation=",f8.2,1x,"senconds")
c910   format(/,1x,"number of converganced roots is ",i4)
911   format(/,1x,"number of kspace exceeds maxium kspace dimension,",
     *       /,1x,"kspace is reseted ",/)
c...end of dav_diagonalize
      end

c*******************************************************
      subroutine mrcibasis_rest(ndim,mroot,mjn,indx,vb1,vb2,
     *                          vcien,mth_eigen,ncivec)
c*******************************************************
c  this subroutine is revised by suo bing. the initial trial
c  vectors are calculated.
c  on entry:
c-------------------------------------------------------
c     ndim  - dimention of ci space
c     mroot - number of roots are calculated
c     mjn
c     indx  - index of mth vector in vb1 vectoer
c     vb1   - vector1
c     vb2   - vecotr2
c
c  on out:
c-------------------------------------------------------
c     vb1   - trial vectors
c
      implicit real*8 (a-h,o-z)
#include "ci_parameter.fh"
#include "files_gugaci.fh"
!      common /file_descript/nf1,nf2,nf3,nf4,nf7,nf8,nf9,nf10,
!     *                      nf11,nf13,nf15,nf20,nf21,nf22,nf23
!
!      logical logic_tdav,logic_inivec_read
!      common /program_control/ logic_tdav,logic_inivec_read
!      common /scratch/ tmpdir,len_str
!      character*256 tmpdir,filename
      logical logic_tdav,logic_inivec_read,logic_mr,
     *        logic_mrelcas,logic_calpro,logic_assign_actorb
      common /program_control/ logic_tdav,logic_inivec_read,
     *               logic_mr,logic_mrelcas,logic_calpro,
     *               logic_assign_actorb
      data dzero/0.d0/,dcrita/1.0d-6/,epc/5.0d-3/
      dimension vb1(ncivec*ndim),vb2(ncivec*ndim)
      dimension indx(max_kspace),mjn(2*max_root),vcien(mroot)
      dimension vdiatmp(2*mroot)

c      write(6,*) "indx",indx(1:2*mroot)
c      call read_bv(nf8,1,vb2,ndim)
      call read_ml(lucidia,1,vb2,ndim,1)

      i=mth_eigen
      write(6,'(2x,2i8,f18.8)') i,mjn(i),vb2(mjn(i)),mth_eigen

c initial vb1-vector1 and th-vector2 to zero
      numdim=ndim
      do m=1,numdim
        vb1(m)=dzero
        vb2(m)=dzero
      enddo

      j=mth_eigen
      if(.not.logic_inivec_read) then
        ij=indx(1)
        vb1(ij+mjn(j))=1.0d0
      else
        call read_bv(nf23,j,vb1,ndim)
      endif
c      rewind nf7
      do i=1,mth_eigen-1
c        read(nf7) vb2(1:ndim)
        call read_ml(lucivec,1,vb2,ndim,i)
        call orth_ab(ndim,vb1,vb2)
      enddo
      call norm_a(ndim,vb1)

      write(6 ,'(2x,2i8,f18.8)') i,mjn(i),vb1(mjn(i))

      call read_ml(lucidia,1,vb2,ndim,1)
c      call read_bv(nf8,1,vb2,ndim)
c      vcien(1)=vb2(mjn(j))
      do i=1,ndim
        vb2(i)=vb1(i)*vb2(i)
      enddo

c      write(6 ,*) "bbs debug 1"


      call matrix_vector_multi_parellel_drt(sechc)
      vsum=0.d0
      do i=1,ndim
        vsum=vsum+vb1(i)*vb2(i)
      enddo
      vcien(1)=vsum

      call write_bv(lucitv1,1,vb1,ndim)
      call write_bv(lucitv2,1,vb2,ndim)

c      write(6 ,*) "bbs debug 2"

      vad=0.d0
      idx=0
      l=mth_eigen
      do m=1,ndim
        do k=1,mth_eigen
          if(m.eq.mjn(k)) goto 30
        enddo
        if(abs(vb2(m)).gt.vad) then
          vad=abs(vb2(m))
          idx=m
        endif
30      continue
      enddo
      mjntm=idx
c      write(6,*) "mjn(kk)",idx,vb1(idx),vb2(idx)
c      write(6 ,*) "bbs debug 3"

      numdim=ndim
      vb1(1:numdim)=dzero
      vb2(1:numdim)=dzero

      vb2(mjntm)=1.d0
c      rewind nf7
      do i=1,mth_eigen-1
c        read(nf7) vb1(1:ndim)
        call read_ml(lucivec,1,vb1,ndim,i)
        call orth_ab(ndim,vb2,vb1)
      enddo
      call read_bv(lucitv1,1,vb1,ndim)
      call orth_ab(ndim,vb2,vb1)
      call norm_a(ndim,vb2)
      vb1(1:ndim)=vb2(1:ndim)

c      write(6 ,*) "bbs debug 4"
      call read_ml(lucidia,1,vb2,ndim,1)
c      call read_bv(nf8,1,vb2,ndim)
      vdiatmp(2)=vb2(mjntm)
      do i=1,ndim
        vb2(i)=vb1(i)*vb2(i)
      enddo
c      write(6 ,*) "bbs debug 5"

      call matrix_vector_multi_parellel_drt(sechc)
      call write_bv(lucitv1,2,vb1,ndim)
      call write_bv(lucitv2,2,vb2,ndim)
c      write(6,*) " initial vector 5"
c      stop 888
c      write(6 ,*) "bbs debug 6"

      return
c...end of mrcibasis_rest
      end

c*******************************************************
      subroutine mrcibasis(ndim,mroot,mjn,indx,vb1,vb2,vcien,mth_eigen,
     *                     ncivec)
c*******************************************************
c  this subroutine is reviesd by suo bing. the initial trial
c  vectors are calculated.
c  on entry:
c-------------------------------------------------------
c     ndim  - dimention of ci space
c     mroot - number of roots are calculated
c     mjn
c     indx  - index of mth vector in vb1 vectoer
c     vb1   - vector1
c     vb2   - vecotr2
c     mth_eigen - 0 or 1
c  on out:
c-------------------------------------------------------
c     vb1   - trial vectors
c
      implicit real*8 (a-h,o-z)
#include "ci_parameter.fh"
#include "files_gugaci.fh"
!      common /file_descript/nf1,nf2,nf3,nf4,nf7,nf8,nf9,nf10,
!     *                      nf11,nf13,nf15,nf20,nf21,nf22,nf23
!      logical logic_tdav,logic_inivec_read
!      common /program_control/ logic_tdav,logic_inivec_read
!      common /scratch/ tmpdir,len_str
!      character*256 tmpdir,filename
      logical logic_tdav,logic_inivec_read,logic_mr,
     *        logic_mrelcas,logic_calpro,logic_assign_actorb

      common /program_control/ logic_tdav,logic_inivec_read,
     *               logic_mr,logic_mrelcas,logic_calpro,
     *               logic_assign_actorb

      data dzero/0.d0/,dcrita/1.0d-6/,epc/5.0d-3/
      dimension vb1(ncivec*ndim),vb2(ncivec*ndim),vdia(2*mroot)
      dimension indx(max_kspace),mjn(2*max_root),vcien(mroot)
      dimension mjntmp(mroot*2),vdiatmp(2*mroot)

      call read_ml(lucidia,1,vb2,ndim,1)
c
c      call read_bv(nf8,1,vb2,ndim)
      indx(1:max_kspace)=0
      indx0=0
      do i=1,mroot
        indx(i)=indx0
        indx0=indx0+ndim
        vdia(i)=vb2(mjn(i))
      enddo

      do i=1,mroot
        write(6,'(2x,2i8,f18.8)') i,mjn(i),vb2(mjn(i))
      enddo
      mjntmp(1:mroot)=mjn(1:mroot)

c initial vb1-vector1 and th-vector2 to zero
      if(mth_eigen.eq.0) then
        if(logic_inivec_read) then
          numdim=ndim*mroot
          do m=1,numdim
            vb1(m)=dzero
            vb2(m)=dzero
          enddo
          call read_bv(nf23,1,vb1,numdim)
        else
          numdim=ndim*mroot
          do m=1,numdim
            vb1(m)=dzero
            vb2(m)=dzero
          enddo
          do j=1,mroot
            ij=indx(j)
            vb1(ij+mjn(j))=1.0d0
            vb2(ij+mjn(j))=vdia(j)
            vcien(j)=vdia(j)
          enddo
        endif
      else
        if(logic_inivec_read) then
          vb1(1:ndim)=dzero
          vb2(1:ndim)=dzero
          call read_bv(nf23,mth_eigen,vb1(1),ndim)
        else
          vb1(1:ndim)=dzero
          vb2(1:ndim)=dzero
          j=mth_eigen
          ij=indx(1)
          vb1(ij+mjn(j))=1.0d0
          vb2(ij+mjn(j))=vdia(j)
          vcien(1)=vdia(j)
          mroot=1
        endif
      endif

!      write(6,*) " initial basis vector 0",nf23

      if(logic_inivec_read) then
        call read_ml(lucidia,1,vb2,ndim,1)
c        call read_bv(nf8,1,vb2,ndim)
        if(mth_eigen.eq.0) then
          do j=2,mroot
            idx=indx(j)
            do k=idx+1,idx+ndim
              vb2(k)=vb1(k)*vb2(k-idx)
            enddo
          enddo
          do k=1,ndim
            vb2(k)=vb1(k)*vb2(k)
          enddo
        else
          do k=1,ndim
            vb2(k)=vb1(k)*vb2(k)
          enddo
        endif
!        do i=1,100
!          write(6,"(2(f18.9,1x))") vb1(i),vb2(i)
!        enddo
c        stop 888

        call matrix_vector_multi_parellel_drt(sechc)

        if(mth_eigen.eq.0) then
          do j=1,mroot
            vsum=0.d0
            idx=indx(j)
            do k=idx+1,idx+ndim
              vsum=vsum+vb1(k)*vb2(k)
            enddo
            vcien(j)=vsum
            write(6,*) "vcien(j)",vsum
          enddo
        else
          vsum=0.d0
          do k=1,ndim
            vsum=vsum+vb1(k)*vb2(k)
          enddo
          vcien(1)=vsum
        endif
      else
        call matrix_vector_multi_v(sechc)
      endif
c write vector1 and vector2 to fort3 and fort4
      call write_bv(lucitv1,1,vb1,ndim*mroot)
      call write_bv(lucitv2,1,vb2,ndim*mroot)

      call read_ml(lucidia,1,vb1,ndim,1)
c      call read_bv(nf8,1,vb1,ndim)
      if(mth_eigen.eq.0) then
        do kk=mroot+1,2*mroot
          ij=indx(kk-mroot)
          vad=0.d0
          idx=0
          do m=1,ndim
            do l=1,kk-1
              if(m.eq.mjntmp(l)) goto 20
            enddo
            if(abs(vb2(m+ij)).gt.vad) then
              vad=abs(vb2(m+ij))
              idx=m
            endif
20          continue
          enddo
          mjntmp(kk)=idx
          vdiatmp(kk)=vb1(idx)
          write(6,*) "mjn(kk)",idx,vb1(idx+ij),vb2(idx+ij)
        enddo
      else
        kk=2
        ij=indx(kk-mroot)
        vad=0.d0
        idx=0
        l=mth_eigen
        do m=1,ndim
          do k=1,mth_eigen
            if(m.eq.mjn(k)) goto 30
          enddo
          if(abs(vb2(m)).gt.vad) then
            vad=abs(vb2(m))
            idx=m
          endif
30        continue
        enddo
        mjntmp(kk)=idx
        vdiatmp(kk)=vb1(idx)
        write(6,*) "mjn(kk)",idx,vb1(idx),vb2(idx)
      endif

      numdim=ndim*mroot
      do m=1,numdim
        vb1(m)=dzero
        vb2(m)=dzero
      enddo
c     write(6,*) " initial vector 3",vdia(2),mroot


      if(mth_eigen.eq.0) then
        do m=mroot+1,2*mroot
          im=indx(m-mroot)
          vb1(im+mjntmp(m))=1.d0
          vb2(im+mjntmp(m))=vdiatmp(m)
        enddo

        if(logic_inivec_read) then
          call read_bv(lucitv1,1,vb2,numdim)
          do i=mroot+1,2*mroot
            idx=indx(i-mroot)+1
            do j=1,mroot
              jdx=indx(j)+1
              call orth_ab(ndim,vb1(idx),vb2(jdx))
            enddo
            do j=mroot+1,i-1
              jdx=indx(j-mroot)+1
              call orth_ab(ndim,vb1(idx),vb1(jdx))
            enddo
            call norm_a(ndim,vb1(idx))
          enddo
        endif
      else
        vb1(mjntmp(2))=1.d0
        vb2(mjntmp(2))=vdiatmp(2)

        if(logic_inivec_read) then
          call read_bv(lucitv1,mth_eigen,vb2,ndim)
          call orth_ab(ndim,vb1,vb2)
          call norm_a(ndim,vb1)
        endif
      endif


      if(logic_inivec_read) then
        call read_ml(lucidia,1,vb2,ndim,1)
c
c        call read_bv(nf8,1,vb2,ndim)
        if(mth_eigen.eq.0) then
          do j=2,mroot
            idx=indx(j)
            do k=idx+1,idx+ndim
              vb2(k)=vb1(k)*vb2(k-idx)
            enddo
          enddo
          do k=1,ndim
            vb2(k)=vb1(k)*vb2(k)
          enddo
        else
          do k=1,ndim
            vb2(k)=vb1(k)*vb2(k)
          enddo
        endif

!        do i=1,100
!          write(6,"(2(f18.9,1x))") vb1(i),vb2(i)
!        enddo
c        stop 888

        call matrix_vector_multi_parellel_drt(sechc)
      else
        call matrix_vector_multi_parellel_drt(sechc)
      endif

      call write_bv(lucitv1,2,vb1,ndim*mroot)
      call write_bv(lucitv2,2,vb2,ndim*mroot)
      return
c...end of mrcibasis
      end

c*******************************************************
      subroutine mrcibasis_init(ndim,mroot,mjn,indx,
     *   vb1,vb2,vcien,mth_eigen,ncivec)
c*******************************************************
c  this subroutine is reviesd by suo bing. the initial trial
c  vectors are calculated.
c  on entry:
c-------------------------------------------------------
c     ndim  - dimention of ci space
c     mroot - number of roots are calculated
c     mjn
c     indx  - index of mth vector in vb1 vectoer
c     vb1   - vector1
c     vb2   - vecotr2
c     mth_eigen - 0 or 1
c  on out:
c-------------------------------------------------------
c     vb1   - trial vectors
c
      implicit real*8 (a-h,o-z)
#include "ci_parameter.fh"
#include "files_gugaci.fh"
      logical logic_tdav,logic_inivec_read,logic_mr,
     *        logic_mrelcas,logic_calpro,logic_assign_actorb

      common /program_control/ logic_tdav,logic_inivec_read,
     *               logic_mr,logic_mrelcas,logic_calpro,
     *               logic_assign_actorb

      data dzero/0.d0/,dcrita/1.0d-6/,epc/5.0d-3/
      dimension vb1(ncivec*ndim),vb2(ncivec*ndim),vdia(2*mroot)
      dimension indx(max_kspace),mjn(2*max_root),vcien(mroot)
      real*8, allocatable :: diagelement(:)

      allocate(diagelement(ndim))

      call read_ml(lucidia,1,diagelement,ndim,1)
c
c      call read_bv(nf8,1,vb2,ndim)
      indx(1:max_kspace)=0
      indx0=0
      do i=1,mroot
        indx(i)=indx0
        indx0=indx0+ndim
        vdia(i)=diagelement(mjn(i))
      enddo

      do i=1,mroot
        write(6,'(2x,2i8,f18.8)') i,mjn(i),diagelement(mjn(i))
      enddo

c initial vb1-vector1 and th-vector2 to zero
      if(mth_eigen.eq.0) then
        numdim=ndim*mroot
        vb1(1:numdim)=dzero
        vb2(1:numdim)=dzero
        do j=1,mroot
          ij=indx(j)
          vb1(ij+mjn(j))=1.0d0
          vb2(ij+mjn(j))=vdia(j)
          vcien(j)=vdia(j)
        enddo
      else
        vb1(1:ndim)=dzero
        vb2(1:ndim)=dzero
        j=mth_eigen
        vb1(mjn(j))=1.0d0
        vb2(mjn(j))=vdia(j)
        vcien(1)=vdia(j)
        mroot=1
      endif

!      write(6,*) " initial basis vector 0",nf23
      call matrix_vector_multi_parellel_drt(sechc)
c write vector1 and vector2 to fort3 and fort4
      call write_bv(lucitv1,1,vb1,ndim*mroot)
      call write_bv(lucitv2,1,vb2,ndim*mroot)

      ! init second vector
c      call read_bv(nf8,1,vb1,ndim)
      if(mth_eigen.eq.0) then
        vb1(1:ndim*mroot)=0.d0
        do kk=1,mroot
          ioff=indx(kk)
          ij=mjn(kk)
          vadi=diagelement(ij)
          do m=1,ij-1
            fenmu=vadi-diagelement(m)
            if(abs(fenmu).lt.epc) fenmu=epc
            vb1(ioff+m)=vb2(ioff+m)/fenmu
            !write(6,"(i8,2f18.8)") m,vb2(ioff+m),fenmu
          enddo
          do m=ij+1,ndim
            fenmu=vadi-diagelement(m)
            if(abs(fenmu).lt.epc) fenmu=epc
            vb1(ioff+m)=vb2(ioff+m)/fenmu
            !write(6,"(i8,2f18.8)") m,vb2(ioff+m),fenmu
          enddo
        enddo


        call read_bv(lucitv1,1,vb2,ndim*mroot)
        do m=1,mroot
          ! orth with vb1
          do n=1,mroot
            call orth_ab(ndim,vb1(indx(m)+1),vb2(indx(n)+1))
          enddo
          ! orth with previous vector
          do n=1,m-1
            call orth_ab(ndim,vb1(indx(m)+1),vb1(indx(n)+1))
          enddo
          call norm_a(ndim,vb1(indx(m)+1))
        enddo

        !write(6,*)
        !do m=1,ndim
        !  write(6,"(2x,i5,f18.8)") m,vb1(m)
        !enddo
        !stop 888
      else
c        stop 888
      call abend
      endif

      numdim=ndim*mroot
      vb2(1:numdim)=dzero
      do m=1,mroot
        kk=indx(m)
        do i=1,ndim
          vb2(i+kk)=vb1(i+kk)*diagelement(i)
        enddo
      enddo

      call matrix_vector_multi_parellel_drt(sechc)
      call write_bv(lucitv1,2,vb1,ndim*mroot)
      call write_bv(lucitv2,2,vb2,ndim*mroot)

      deallocate(diagelement)
      return
c...end of mrcibasis
      end


c****************************************************************
      subroutine get_eigvector(mtsta0,vcien,valpha,diffci,vresid,
     *                         mtheigen,log_muliter)
c****************************************************************
#ifdef _XIANEST_
      use control,only : toptask
#endif
#include "drt_h.fh"
#include "files_gugaci.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      dimension valpha(max_root),vcien(max_root),vresid(max_root)
      dimension dav1(max_root),dav2(max_root),dav3(max_root),
     *          vcml(max_root),remei(max_root)
      logical log_muliter

      vector1=0.d0
      nd=nci_dim*(mroot-mtsta0+1)
      call read_ml(lucidia,1,vector2,nd,2)
      if(log_muliter) then
        nc=1
        do i=1,mtsta0-1
          mtidx=indx(i)
          call read_ml(lucivec,1,vector1(nc:nc+nci_dim-1),nci_dim,i)
          nc=nc+nci_dim
        enddo
        vector1(nc:nc+nd-1)=vector2(1:nd)
        eci(1:mroot)=vcien(1:mroot)

c  write eigenvector into fort7
        nc=1
        do i=1,mroot
          call write_ml(lucivec,1,vector1(nc:nc+nci_dim-1),nci_dim,i)
          nc=nc+nci_dim
        enddo
!        print*, "xxx cof"
!        print*, vector1(nci_dim+1:nci_dim+5)
!        stop 888
      else
        call write_ml(lucivec,1,vector2,nci_dim,mth_eigen)
      endif
c      rewind nf7

      call memcidiag_alloc()
      do mt=1,mroot
c*********************************************************************
c     do davidson correction
c
!        if(.not.log_muliter) then
        call read_ml(lucivec,1,vector1,nci_dim,mt)
!        endif
!        mtidx=indx(mt)
        vcml(mt)=0.d0
        do j=1,ndim_h0
          jr=j
          if(logic_mr) jr=irfno(j)
          vcml(mt)=vcml(mt)+vector1(jr)*vector1(jr)
        enddo
        if(log_muliter) then
          de=ecih0(mt)-vcien(mt)
        else
          de=ecih0(mth_eigen)-vcien(mt)
        endif

        dedav1=(1.d0-vcml(mt))*de
        dedav2=dedav1/(vcml(mt))
        dedav3=dedav1/(2*vcml(mt)-1)
        demei=dedav2*(n_electron*(n_electron-5)+6)
     *       /(n_electron*(n_electron-1))
c        demei=dedav2*(n_electron*(n_electron-5)+6)
c     :       /(n_electron*(n_electron-1))
        dav1(mt)=vcien(mt)-dedav1
        dav2(mt)=vcien(mt)-dedav2
        dav3(mt)=vcien(mt)-dedav3
        remei(mt)=vcien(mt)-demei

        write(6,900)
c        write(6,901) mt,vcien(mt),dav1(mt),dav2(mt),dav3(mt),remei(mt)
c        write(nf2,901) mt,vcien(mt),dav1(mt),dav2(mt),dav3(mt),
c     *                 remei(mt)
        write(6,901) mt,vcien(mt),dav1(mt),vcml(mt)
c        read(nf7) vector2(1:nci_dim)
        write(6,810) mt
!        mtidx=indx(mt)
        do i=1,nci_dim
          vcof=vector1(i)
          if(abs(vcof).gt.cm_cri) then
            call found_a_config(i,vcof,2)
          endif
        enddo
      enddo
      call memcidiag_dealloc()

      if(log_muliter) then
        write(6,800)
        write(6,900)
        do mt=1,mroot
          write(6,901) mt,vcien(mt),dav1(mt),vcml(mt)
        enddo
      endif

#ifdef MOLPRO
      if(toptask%task(8).eq.1) then
        write(6,*)
        write(6,*) "++++++++  DATA CHECK +++++++++++++++++++++++++++++"
        call checkdata("r",mroot,8,0,vcien,"MRCI","ECI")
        call checkdata("r",mroot,8,0,dav1,"MRCI","ECI_DAV")
        write(6,*) "++++++++++ END DATA CHECK ++++++++++++++++++++++++"
        write(6,*)
      endif
#else
      call add_info("ECI",vcien,mroot,8)
      call add_info("ECI_DAV",dav1,mroot,8)
#endif

      return
800   format(/,1x,"mrsdci calculation converged")
810   format(/,1x,"the main references for root ",i3,/)
900   format(/1x,"nroot",6x,"ci energy",10x,"dav energy",8x,"coef")
901   format(1x,i3,2x,2(1x,f18.9),3x,f8.6)
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real_array(valpha)
        call Unused_real(diffci)
        call Unused_real_array(vresid)
        call Unused_integer(mtheigen)
      end if
c...end of get_eigvector
      end

      subroutine matrix_vector_multi_v(sechc)
#include "drt_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      external inn_ext_ss_loop_unpack
      external inn_ext_st_loop_unpack
      external inn_ext_ts_loop_unpack
      external inn_ext_tt_loop_unpack
      external inn_ext_st_drl_loop_unpack
      external inn_ext_ts_drl_loop_unpack

      sc1=c_time()
      log_prod=1
      call readint(1,vint_ci)
      call inner_space_loop()

      call readint(2,vint_ci)
      call dv_drt_ci_new()
      call vd_drt_ci_new()

      call readint(3,vint_ci)
      call sv_drt_ci_new()
      call tv_drt_ci_new()
      sc2=c_time()
      sechc=sc2-sc1
      return
      end

      subroutine matrix_vector_multi_d(sechc)
#include "drt_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      external inn_ext_ss_loop_unpack
      external inn_ext_st_loop_unpack
      external inn_ext_ts_loop_unpack
      external inn_ext_tt_loop_unpack
      external inn_ext_st_drl_loop_unpack
      external inn_ext_ts_drl_loop_unpack

      log_prod=1
      sc1=c_time()

      call readint(1,vint_ci)
      call inner_space_loop()

      call readint(2,vint_ci)
      call sd_drt_ci_new()
      call td_drt_ci_new()
      call ds_drt_ci_new()
      call dt_drt_ci_new()
      call dv_drt_ci_new()
      call vd_drt_ci_new()

      call readint(3,vint_ci)
      call dd_drt_ci_new()

      call readint(4,vint_ci)
      call ext_space_loop()

      sc2=c_time()
      sechc=sc2-sc1
      return
      end

      subroutine matrix_vector_multi_parellel_drt(sechc)
#include "drt_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      external inn_ext_ss_loop_unpack
      external inn_ext_st_loop_unpack
      external inn_ext_ts_loop_unpack
      external inn_ext_tt_loop_unpack
      external inn_ext_st_drl_loop_unpack
      external inn_ext_ts_drl_loop_unpack
      data zero/0.d0/
*ia32 data zero/0.d0/
*ia64 data zero/0.e0/

      log_prod=1
      sc1=c_time()

      call readint(1,vint_ci)
      call inner_space_loop()

      call readint(2,vint_ci)
      call sd_drt_ci_new()
      call td_drt_ci_new()
      call ds_drt_ci_new()
      call dt_drt_ci_new()
      call vd_drt_ci_new()
      call dv_drt_ci_new()

      call readint(3,vint_ci)
      call dd_drt_ci_new()
      call sv_drt_ci_new()
      call tv_drt_ci_new()
      call ss_drt_ci_new()
      call st_drt_ci_new()
      call tt_drt_ci_new()
      call ts_drt_ci_new()

      call readint(4,vint_ci)
      call ext_space_loop()

      sc2=c_time()
      sechc=sc2-sc1
      return
      end

      subroutine matrix_vector_multi_parellel_prt(sc3)
#include "drt_h.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      external inn_ext_ss_loop_unpack
      external inn_ext_st_loop_unpack
      external inn_ext_ts_loop_unpack
      external inn_ext_tt_loop_unpack
      external inn_ext_st_drl_loop_unpack
      external inn_ext_ts_drl_loop_unpack
c      write(6,*)  "error stop"
c      stop 888
      sc1=c_time()

      mtest=1482
      log_prod=1

      call readint(1,vint_ci)
      call inner_space_loop()
      write(6,*) ' inner',vector2(mtest)

      call readint(2,vint_ci)
      call sd_drt_ci_new()
      write(6,*) ' sd',vector2(mtest)
      call td_drt_ci_new()
      write(6,*) ' td',vector2(mtest)
      call ds_drt_ci_new()
      write(6,*) ' ds',vector2(mtest)
      call dt_drt_ci_new()
      write(6,*) ' dt',vector2(mtest)
      call vd_drt_ci_new()
      write(6,*) ' vd',vector2(mtest)
      call dv_drt_ci_new()
      write(6,*) ' dv',vector2(mtest)

      call readint(3,vint_ci)
      call dd_drt_ci_new()
      write(6,*) ' dd',vector2(mtest)
      call sv_drt_ci_new()
      write(6,*) ' sv',vector2(mtest)
      call tv_drt_ci_new()
      write(6,*) ' tv',vector2(mtest)
      call ss_drt_ci_new()
      write(6,*) ' ss',vector2(mtest)
      call st_drt_ci_new()
      write(6,*) ' st',vector2(mtest)
      call tt_drt_ci_new()
      write(6,*) ' tt',vector2(mtest)
      call ts_drt_ci_new()
      write(6,*) ' ts',vector2(mtest)

      call readint(4,vint_ci)
      call ext_space_loop()
      write(6,*) ' exter',vector2(mtest)

      sc2=c_time()
      write(6,*) '  end this matrix_vector_multi_parellel_drt, takes',
     :          sc2-sc1,'s'
      sc3=sc2-sc1
      end

c**************************************************************
      subroutine orthog(kval,iiter,msta,idxvec)
c**************************************************************
c on entry:
c   kval - dimension of current k space
c on out:
c   kval - dimension of new k space
c   iiter - iiter+1
#include "drt_h.fh"
#include "files_gugaci.fh"
      dimension idxvec(max_iter)
      data dzero/0.d0/

      do jiter=1,iiter
        if(jiter.eq.1) then
          jrst=1
        else
          jrst=idxvec(jiter-1)+1
        endif
        jren=idxvec(jiter)
        nd=(jren-jrst+1)*nci_dim
        call read_bv(lucitv1,jiter,vector2,nd)
        do mt=msta,mroot
          mtidx=indx(mt-msta+1)
          do nt=jrst,jren
            ntidx=indx(nt-jrst+1)
            vsum=dzero
            do l=1,nci_dim
              vsum=vsum+vector1(mtidx+l)*vector2(ntidx+l)
            enddo
            do l=1,nci_dim
              vector1(mtidx+l)=vector1(mtidx+l)
     *                        -vsum*vector2(ntidx+l)
            enddo
          enddo
        enddo
      enddo

c     normalization of vector msta
      vsum=dzero
      call norm_a(nci_dim,vector1)
      kval=kval+1

      do mt=msta+1,mroot
        mtidx=indx(mt-msta+1)
        do nt=msta,mt
          ntidx=indx(nt-msta+1)
          vsum=dzero
          do l=1,nci_dim
            vsum=vsum+vector1(mtidx+l)*vector1(ntidx+l)
          enddo
          do l=1,nci_dim
            vector1(mtidx+l)=vector1(mtidx+l)
     *                      -vsum*vector1(ntidx+l)
          enddo
        enddo
        call norm_a(nci_dim,vector1(mtidx+1:mtidx+nci_dim))
        kval=kval+1
      enddo

      iiter=iiter+1

      return
c...end of orthog
      end

      subroutine orthogonalization(j,n,m,ir)
#include "drt_h.fh"
#include "files_gugaci.fh"
      ir=1
      vsmax2=1.d10
      do while ( j .gt. 1 )
         vsmax1=0.d0
         do i=1,j-1
            vsumtmp=0.d0
            call read_bv(lucitv1,i,vector2,n)

            do l=1,n
               vsumtmp=vsumtmp+vector1(l)*vector2(l)
            enddo
            do l=1,n
               vector1(l)=vector1(l)-vsumtmp*vector2(l)
            enddo
             vsmax1=max(vsmax1,abs(vsumtmp))
         enddo
         if ( vsmax1 .lt. vortho_criterion ) exit
         if ( vsmax1 .gt. vsmax2 ) then
            ir=-1
            return
         endif
         vsmax2=vsmax1
      enddo

      vsumtmp=0.d0
      do l=1,n
         vsumtmp=vsumtmp+vector1(l)*vector1(l)
      enddo

      do m=1,mth_eigen-1
c        call read_bv(nf7,m,vector2,nci_dim)
        call read_ml(lucivec,1,vector2,nci_dim,m)
        call orth_ab(nci_dim,vector1,vector2)
      enddo
      call norm_a(nci_dim,vector1)
!     vsumtmp=1.d0/sqrt(vsumtmp)
!      do l=1,n
!         vector1(l)=vector1(l)*vsumtmp
!      enddo

      call write_bv(lucitv1,j,vector1,n)

      end

      subroutine compute_vp_matrix(j,n) !nf3
#include "drt_h.fh"
#include "files_gugaci.fh"
      ij=j*(j-1)/2
      vsumtmp=0.d0
      do l=1,n
         vsumtmp=vsumtmp+vector1(l)*vector2(l)
      enddo
      vp(ij+j)=vsumtmp
!     rewind(nf3)
      do i=1,j-1
        call read_bv(lucitv1,i,vector1,n)

         vsumtmp=0.d0
         do l=1,n
           vsumtmp=vsumtmp+vector1(l)*vector2(l)
         enddo
         vp(ij+i)=vsumtmp
      enddo
      call read_bv(lucitv1,i,vector1,n)

      end

c*********************************************************
      subroutine compute_residual_vector_mroot(kval,mtsta,iiter,idxvec,
     *                                         vresid,vcien)
c*********************************************************
c     2 mar 2007 - revised
c     calculate residual vector
c          e|ck>-h|ck>
c          |ck>=\sigma(vu(i,m)*vector_i),i=1,j
#include "drt_h.fh"
#include "files_gugaci.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      dimension idxvec(max_kspace)
      dimension vresid(max_root),vcien(max_root)
      data dzero/0.d0/
      real*8, allocatable :: diagelement(:)

      depc=1.d-3
      nd=nci_dim*(mroot-mtsta+1)
      vector1(1:nd)=dzero

      do jiter=1,iiter
        if(jiter.eq.1) then
          irts=1
        else
          irts=idxvec(jiter-1)+1
        endif
        irte=idxvec(jiter)
        nd=(irte-irts+1)*nci_dim
        call read_bv(lucitv1,jiter,vector2,nd)
        do mt=mtsta,mroot
          mtidx=indx(mt-mtsta+1)
          do irot=irts,irte
            vuim=vu(irot,mt)
            itidx=indx(irot-irts+1)
            do l=1,nci_dim
              vector1(mtidx+l)=vector1(mtidx+l)
     *                        +vuim*vector2(itidx+l)
            enddo
          enddo
        enddo
      enddo

      ! present ci vector, second record in lucidia
      nd=nci_dim*(mroot-mtsta+1)
      call write_ml(lucidia,1,vector1,nd,2)

      do mt=mtsta,mroot
        mtidx=indx(mt-mtsta+1)
        venergy=vcien(mt)
        do l=1,nci_dim
          !vector1(mtidx+l)=venergy*vector1(mtidx+l)
          vector1(mtidx+l)=0.d0
        enddo
      enddo

      do jiter=1,iiter
        if(jiter.eq.1) then
          irts=1
        else
          irts=idxvec(jiter-1)+1
        endif
        irte=idxvec(jiter)
        nd=(irte-irts+1)*nci_dim
        call read_bv(lucitv2,jiter,vector2,nd)
        do mt=mtsta,mroot
          mtidx=indx(mt-mtsta+1)
          do irot=irts,irte
            itidx=indx(irot-irts+1)
            vuim=vu(irot,mt)
            do l=1,nci_dim
              vector1(mtidx+l)=vector1(mtidx+l)
     *                        +vuim*vector2(itidx+l)
            enddo
          enddo
        enddo
      enddo

      allocate(diagelement(nci_dim))
      call read_ml(lucidia,2,diagelement,nci_dim,1)
      call read_ml(lucidia,2,vector2,nd,2)

      ! new approximation vector
      ij=0
      do mt=mtsta,mroot
        mtidx=indx(mt-mtsta+1)
        vtmp=dzero
        do i=1,nci_dim
          depcc=vcien(mt)-diagelement(i)
          if(abs(depcc).lt.depc) depcc=depc
          vector1(mtidx+i)=
     *      (vector1(mtidx+i)-vector2(ij+i)*vcien(mt))/depcc
          vtmp=vtmp+vector1(ij+i)*vector1(ij+i)
        enddo
        vresid(mt)=vtmp
        ij=ij+nci_dim
      enddo

      deallocate(diagelement)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(kval)
c...end of compute_residule_vector
      end

c*********************************************************
      subroutine compute_residual_vector(kval,mtsta,iiter,idxvec,
     *                                         vresid,vcien)
c*********************************************************
c     2 mar 2007 - revised
c     calculate residual vector
c          e|ck>-h|ck>
c          |ck>=\sigma(vu(i,m)*vector_i),i=1,j
#include "drt_h.fh"
#include "files_gugaci.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
      dimension idxvec(max_kspace)
      dimension vresid(max_root),vcien(max_root)
      data dzero/0.d0/

      nd=nci_dim*(mroot-mtsta+1)
      vector1(1:nd)=dzero

      do jiter=1,iiter
        if(jiter.eq.1) then
          irts=1
        else
          irts=idxvec(jiter-1)+1
        endif
        irte=idxvec(jiter)
        nd=(irte-irts+1)*nci_dim
        call read_bv(lucitv1,jiter,vector2,nd)
        do mt=mtsta,mroot
          mtidx=indx(mt-mtsta+1)
          do irot=irts,irte
            vuim=vu(irot,mt)
            itidx=indx(irot-irts+1)
            do l=1,nci_dim
              vector1(mtidx+l)=vector1(mtidx+l)
     *                        +vuim*vector2(itidx+l)
            enddo
          enddo
        enddo
      enddo

      nd=nci_dim*(mroot-mtsta+1)
      call write_ml(lucidia,1,vector1,nd,2)

      do mt=mtsta,mroot
        mtidx=indx(mt-mtsta+1)
        venergy=vcien(mt)
        do l=1,nci_dim
          vector1(mtidx+l)=venergy*vector1(mtidx+l)
        enddo
      enddo

      do jiter=1,iiter
        if(jiter.eq.1) then
          irts=1
        else
          irts=idxvec(jiter-1)+1
        endif
        irte=idxvec(jiter)
        nd=(irte-irts+1)*nci_dim
        call read_bv(lucitv2,jiter,vector2,nd)
        do mt=mtsta,mroot
          mtidx=indx(mt-mtsta+1)
          do irot=irts,irte
            itidx=indx(irot-irts+1)
            vuim=vu(irot,mt)
            do l=1,nci_dim
              vector1(mtidx+l)=vector1(mtidx+l)
     *                        -vuim*vector2(itidx+l)
            enddo
          enddo
        enddo
      enddo

      do mt=mtsta,mroot
        mtidx=indx(mt-mtsta+1)
        vtmp=dzero
        do l=1,nci_dim
          li=l+mtidx
          vtmp=vtmp+vector1(li)*vector1(li)
        enddo
        vresid(mt)=vtmp
      enddo

      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(kval)
c...end of compute_residule_vector
      end

      subroutine read_ref_state(nf)
#include "drt_h.fh"
      character*32  refstring

      do i=1,n_ref
        do j=1,norb_dz
           iref_occ(j,i)=2
        enddo
        read(nf,*) refstring(1:norb_act)
        do j=1,norb_act
          if(refstring(j:j).eq.'0') iref_occ(j+norb_dz,i)=0
          if(refstring(j:j).eq.'1') iref_occ(j+norb_dz,i)=1
          if(refstring(j:j).eq.'2') iref_occ(j+norb_dz,i)=2
        enddo
      enddo

      write(6,*) "    multireference mode"
      write(6,*) "    the reference states are:"
      do i=1,n_ref
        write(6,'(12x,60(i1))') (iref_occ(j,i),j=1,norb_inn)
      enddo

      end

      function maxind(m,vector)
      implicit real*8 (a-h,o-z)
      dimension vector(m)
      l=1
      am=abs(vector(l))
      do j=1,m
        if (abs(vector(j)).gt.am)then
          l=j
          am=abs(vector(j))
        endif
      enddo
      maxind=l
      end

c******************************************************
      subroutine matrmkmul(kval,mtsta,iiter,idxvec,irset)
c******************************************************
c     27 feb 2007 - writed by suo bing
c     construct p matrix in b and h*b space
c on entry:
c   msta - start index of b space
c   mend - end index of b space
c   iiter - ith iteration
c
#include "drt_h.fh"
#include "files_gugaci.fh"
      dimension idxvec(max_iter)
      data dzero/0.d0/
*i64  data dzero/0.e0/

      if(iiter.eq.2.and.irset.eq.0) then
        nroot=mroot-mtsta+1
c     the first iteration
        call read_bv(lucitv1,1,vector1,nci_dim*mroot)
        call read_bv(lucitv2,1,vector2,nci_dim*mroot)
        do irot=1,mroot+nroot
          if(irot.eq.mroot+1) then
            call read_bv(lucitv1,2,vector1,nci_dim*mroot)
          endif
          ij=irot*(irot-1)/2
          if(irot.le.mroot) then
            iidx=indx(irot)
          else
            iidx=indx(irot-mroot)
          endif
          jend=min(irot,mroot)
          do jrot=1,jend
            jidx=indx(jrot)
            valsum=dzero
            do i=1,nci_dim
              valsum=valsum+vector1(iidx+i)*vector2(jidx+i)
            enddo
            vp(ij+jrot)=valsum
          enddo
        enddo
        call read_bv(lucitv2,2,vector2,nci_dim*mroot)
        do irot=mroot+1,mroot+nroot
          ij=irot*(irot-1)/2
          iidx=indx(irot-mroot)
          do jrot=mroot+1,irot
            jidx=indx(jrot-mroot)
            valsum=dzero
            do i=1,nci_dim
              valsum=valsum+vector1(iidx+i)*vector2(jidx+i)
            enddo
            vp(ij+jrot)=valsum
          enddo
        enddo
      else
c     other iteration
        msta=idxvec(iiter-1)+1
        mend=idxvec(iiter)
        do iit=1,iiter
          if(iit.eq.1) then
            jrs=1
          else
            jrs=idxvec(iit-1)+1
          endif
          jre=idxvec(iit)
          nd=(jre-jrs+1)*nci_dim
          call read_bv(lucitv2,iit,vector2,nd)
          do jrot=jrs,jre
            jidx=indx(jrot-jrs+1)
            do irot=msta,mend
              iidx=indx(irot-msta+1)
              vsum=dzero
              do l=1,nci_dim
                vsum=vsum+vector1(iidx+l)*vector2(jidx+l)
              enddo
              if(irot.gt.jrot) then
                ij=irot*(irot-1)/2
                vp(ij+jrot)=vsum
              else
                ij=jrot*(jrot-1)/2
                vp(ij+irot)=vsum
              endif
            enddo
          enddo
        enddo
      endif

!      write(6,*) "vp"
!      do i=1,kval
!        nd=i*(i-1)/2
!        write(6,"(5(1x,f15.8))") vp(nd+1:nd+i)
!      enddo

      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(kval)
c...end of matrmkmul
      end

      subroutine orthogwconvec()
#include "drt_h.fh"
#include "files_gugaci.fh"
c
c      rewind nf7
      do i=1,mth_eigen-1
c        read(nf7) vector2(1:nci_dim)
        call read_ml(lucivec,1,vector1,nci_dim,i)
        call orth_ab(nci_dim,vector1,vector2)
      enddo
      call norm_a(nci_dim,vector1)

      return
c...end of orthogwconvec
      end

      subroutine cielement()
      ! print a Row of CI matrix
#include "drt_h.fh"
      write(6,*) "mcroot",mcroot
      indx(1)=0
      indx(2)=nci_dim
      mcroot=1

      icolum=807
      vector1(1:nci_dim)=0.d0
      vector2(1:nci_dim)=0.d0
      vector1(icolum)=1.d0
      call matrix_vector_multi_parellel_drt(sc1)

      !do i=1,nci_dim
      !  write(21,"(i8,1x,f18.8)") i,vector2(i)
      !enddo
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RToSph(F,nBeta,ishll,lb,iAng,nveccb)
!***********************************************************************
!
!   Transform <core|B> from Cartesian components to Sperical harmonics
!
!***********************************************************************
! @parameter F The cartesian components of <core|B>(in)
!              The spherical components of <core|B>(out)
! @parameter nBeta Number of exponents
! @parameter ishll Shell number for ECP
! @parameter lb angular momenta Ket
! @parameter iAng angular momenta core
! @parameter Number of derivatives
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Real_Spherical, only: ipSph, RSph
use Basis_Info, only: Shells
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: F(*)
integer(kind=iwp), intent(in) :: nBeta, ishll, lb, iAng, nveccb
integer(kind=iwp) :: ncb, nExpi
real(kind=wp), allocatable :: Tmp1(:), Tmp2(:)

!***********************************************************************

ncb = nTri_Elem1(lb)*nTri_Elem1(iang)
nExpi = Shells(iShll)%nExp
call mma_allocate(TMP1,nExpi*ncb*nVecCB*nBeta,Label='Tmp1')
call mma_allocate(TMP2,nExpi*ncb*nVecCB*nBeta,Label='Tmp2')

! ) kj,cbx -> cbx,kj

call DgeTMo(F,nBeta*nExpi,nBeta*nExpi,ncb*nVecCB,Tmp1,ncb*nVecCB)

! 2) bxkj,C = c,bxkj * c,C

call DGEMM_('T','N',nTri_Elem1(lb)*nVecCB*nExpi*nBeta,(2*iAng+1),nTri_Elem1(iAng),One,Tmp1,nTri_Elem1(iAng),RSph(ipSph(iAng)), &
            nTri_Elem1(iAng),Zero,Tmp2,nTri_Elem1(lb)*nVecCB*nExpi*nBeta)

! 3) bx,kjC -> kjC,bx

call DgeTMo(Tmp2,nTri_Elem1(lb)*nVecCB,nTri_Elem1(lb)*nVecCB,nExpi*nBeta*(2*iAng+1),F,nExpi*nBeta*(2*iAng+1))

call mma_deallocate(Tmp1)
call mma_deallocate(Tmp2)

return

end subroutine RToSph

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C----------------------------------------------------------------------|
      subroutine XDR_Local_Ham(nbas,isize,jsize,imethod,paratyp,
     & dkhorder,xorder,inS,inK,inV,inpVp,inUL,inUS,inDX,nbl,ibl,
     & Lmap,DoFullLT,clight)
C
C Local (Atom/Block) relativistic transformation of Hamiltonian
C
      implicit none
#include "WrkSpc.fh"
C Input variables
      integer nbas,isize,jsize,imethod,paratyp,dkhorder,xorder,nbl
      integer inDX(nbas),ibl(nbl),Lmap(nbas)
      Real*8 clight
      Real*8 inS(isize),inV(isize),inpVp(isize)
      logical doFullLT
C Input/Output variables
      Real*8 inK(isize)
C Output variables
      Real*8 inUL(jsize),inUS(jsize)
C Local variables
      integer nn,i,j,k,iblock,mbl,ks,kL
      integer jS,jK,jV,jpVp,jSL,jKL,jVL,jpVpL,jULL,jUSL,jH,jtmp,jB
C
C Convert triangle matrices to square matrices
C
      nn = nbas*nbas+4
      call getmem('skin ','ALLOC','REAL',jK   ,nn)
      call getmem('sSS  ','ALLOC','REAL',jS   ,nn)
      call getmem('sV   ','ALLOC','REAL',jV   ,nn)
      call getmem('spVp ','ALLOC','REAL',jpVp ,nn)
      call getmem('sHam ','ALLOC','REAL',jH   ,nn)
      call getmem('sSav ','ALLOC','REAL',jB   ,nn)
      k = 0
      do i=1,nbas
        do j=1,i
          k = k + 1
          Work(jK + j-1 + (i-1)*nbas ) = inK(k)
          Work(jS + j-1 + (i-1)*nbas ) = inS(k)
          Work(jV + j-1 + (i-1)*nbas ) = inV(k)
          Work(jpVp + j-1 + (i-1)*nbas ) = inpVp(k)
          if(i.ne.j)then
            Work(jK + i-1 + (j-1)*nbas ) = inK(k)
            Work(jS + i-1 + (j-1)*nbas ) = inS(k)
            Work(jV + i-1 + (j-1)*nbas ) = inV(k)
            Work(jpVp + i-1 + (j-1)*nbas ) = inpVp(k)
          end if
        end do
      end do
      do i=1,jsize
        inUL(i)=0.d0
        inUS(i)=0.d0
      end do
      if(.not.DoFullLT)then
        do i=0,nbas*nbas-1
          Work(jH+i) = Work(jK+i) + Work(jV+i)
        end do
      end if
C
C Cycle for each local blocks
C
      ks = 0
      do iblock = 1,nbl
        mbl = ibl(iblock)
        call getmem('skinL','ALLOC','REAL',jKL  ,mbl*mbl+4)
        call getmem('sSSL ','ALLOC','REAL',jSL  ,mbl*mbl+4)
        call getmem('sVL  ','ALLOC','REAL',jVL  ,mbl*mbl+4)
        call getmem('spVpL','ALLOC','REAL',jpVpL,mbl*mbl+4)
        call getmem('ULlco','ALLOC','REAL',jULL ,mbl*mbl+4)
        call getmem('USlco','ALLOC','REAL',jUSL ,mbl*mbl+4)
C
C Copy block matrices
C
        do i=1,mbl
          do j=1,mbl
            k = (j-1)+(i-1)*mbl
            kL = Lmap(j+ks)-1 + (Lmap(i+ks)-1)*nbas
            Work(jKL   + k ) = Work(jK   + kL )
            Work(jSL   + k ) = Work(jS   + kL )
            Work(jVL   + k ) = Work(jV   + kL )
            Work(jpVpL + k ) = Work(jpVp + kL )
          end do
        end do
C
C Calculate relativistic one-electron Hamiltonian for each blocks
C
        if(imethod.eq.2)then
C
C Call X2C driver
C
          call x2c_ts1e(mbl,Work(jSL),Work(jKL),Work(jVL),Work(jpVpL),
     &                  Work(jULL),Work(jUSL),clight )
        else if(imethod.eq.3)then
C
C Call BSS driver
C
          call bss_ts1e(mbl,Work(jSL),Work(jKL),Work(jVL),Work(jpVpL),
     &                  Work(jULL),Work(jUSL),clight )
        else if(imethod.eq.1)then
C
C Call arbitrary order DKH driver
C
          call dkh_ts1e(mbl,Work(jSL),Work(jKL),Work(jVL),Work(jpVpL),
     &                  Work(jULL),Work(jUSL),clight,
     &                  dkhorder,xorder,paratyp )
        end if
C
C Copy back to full matrix
C
        do i=1,mbl
          do j=1,mbl
            k = (j-1)+(i-1)*mbl
            kL = Lmap(j+ks)-1 + (Lmap(i+ks)-1)*nbas
            inUL( kL+1 ) = Work(jULL + k)
            inUS( kL+1 ) = Work(jUSL + k)
            if(.not.DoFullLT)then
              Work(jH + kL) = Work(jVL + k)
            else
              Work(jB + kL) = Work(jVL + k)
            end if
          end do
        end do
C
C End cycle for blocks
C
        call getmem('skinL','FREE','REAL',jKL  ,mbl*mbl+4)
        call getmem('sSSL ','FREE','REAL',jSL  ,mbl*mbl+4)
        call getmem('sVL  ','FREE','REAL',jVL  ,mbl*mbl+4)
        call getmem('spVpL','FREE','REAL',jpVpL,mbl*mbl+4)
        call getmem('ULlco','FREE','REAL',jULL ,mbl*mbl+4)
        call getmem('USlco','FREE','REAL',jUSL ,mbl*mbl+4)
        ks = ks + mbl
      end do
C
C Apply transformation construct from each blocks
C
      if(DoFullLT)then
        call getmem('Tempm ','ALLOC','REAL',jtmp,nn)
        call dmxma(nbas,'C','N',inUS,Work(jK),Work(jS),2.d0*clight)
        call dmxma(nbas,'N','N',Work(jS),inUS,Work(jH),-2.d0*clight)
        call dmxma(nbas,'N','N',Work(jS),inUL,Work(jtmp),1.d0)
        call daxpy_(nbas*nbas,1.d0,Work(jtmp),1,Work(jH),1)
        call dmxma(nbas,'C','N',inUL,Work(jK),Work(jS),1.d0)
        call dmxma(nbas,'N','N',Work(jS),inUS,Work(jtmp),2.d0*clight)
        call daxpy_(nbas*nbas,1.d0,Work(jtmp),1,Work(jH),1)
C
        call dmxma(nbas,'C','N',inUL,Work(jV),Work(jS),1.d0)
        call dmxma(nbas,'N','N',Work(jS),inUL,Work(jtmp),1.d0)
        call daxpy_(nbas*nbas,1.d0,Work(jtmp),1,Work(jH),1)
        call dmxma(nbas,'C','N',inUS,Work(jpVp),Work(jS),1.d0)
        call dmxma(nbas,'N','N',Work(jS),inUS,Work(jtmp),1.d0)
        call daxpy_(nbas*nbas,1.d0,Work(jtmp),1,Work(jH),1)
        call getmem('Tempm ','FREE','REAL',jtmp,nn)
        ks = 0
        do iblock = 1,nbl
          mbl = ibl(iblock)
          do i=1,mbl
            do j=1,mbl
              kL = Lmap(j+ks)-1 + (Lmap(i+ks)-1)*nbas
              Work(jH + kL) = Work(jB + kL)
            end do
          end do
          ks = ks + mbl
        end do
      end if
      do i=0,nbas*nbas-1
        Work(jV+i) = Work(jH+i)
      end do
C
C Copy relativistic one-electron Hamiltonian back to inK
C
      k=0
      do i=1,nbas
        do j=1,i
          k=k+1
          inK(k)=Work(jV+j-1+(i-1)*nbas)
        end do
      end do
C
C Free temp memories
C
      call getmem('skin ','FREE','REAL',jK   ,nn)
      call getmem('sSS  ','FREE','REAL',jS   ,nn)
      call getmem('sV   ','FREE','REAL',jV   ,nn)
      call getmem('spVp ','FREE','REAL',jpVp ,nn)
      call getmem('sHam ','FREE','REAL',jH   ,nn)
      call getmem('sSav ','FREE','REAL',jB   ,nn)
C
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(inDX)
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine poly_aniso_open(iReturn)

      Implicit None
#include "warnings.fh"
      Integer       :: nneq, exch, neqv, nmax, nLoc, nCenter,
     &                 nT, nH, nTempMagn, nDir, nDirZee,
     &                 nMult, nPair, MxRank1, MxRank2
      Integer       :: iReturn
      Logical       :: dbg

      iReturn=0
      dbg=.false.

      Write(6,'(A)') 'POLY_ANISO (OPEN):'
      Write(6,'(A)') 'by:   Liviu Unugur       '//
     &               '(chmlu@nus.edu.sg)'
      Write(6,'(A)') 'and   Liviu F. Chibotaru '//
     &               '(Liviu.Chibotaru@kuleuven.be)'
      Write(6,'(A)') 'Last updated - 2 July 2018'

      ! initialize some important variables
      If(dbg) Write(6,*) 'Enter fetch_init_const'
      Call fetch_init_const( nneq, neqv, nmax, exch, nLoc,
     &                       nCenter, nT, nH, nTempMagn, nDir,
     &                       nDirZee, nMult, nPair, MxRank1, MxRank2,
     &                       iReturn )
      If(dbg) Write(6,*) 'Exit fetch_init_const'
      If(dbg) Write(6,*) '     nneq=',     nneq
      If(dbg) Write(6,*) '     neqv=',     neqv
      If(dbg) Write(6,*) '     nmax=',     nmax
      If(dbg) Write(6,*) '     exch=',     exch
      If(dbg) Write(6,*) '     nLoc=',     nLoc
      If(dbg) Write(6,*) '  nCenter=',  nCenter
      If(dbg) Write(6,*) '       nT=',       nT
      If(dbg) Write(6,*) '       nH=',       nH
      If(dbg) Write(6,*) 'nTempMagn=',nTempMagn
      If(dbg) Write(6,*) '     nDir=',     nDir
      If(dbg) Write(6,*) '  nDirZee=',  nDirZee
      If(dbg) Write(6,*) '    nMult=',    nMult
      If(dbg) Write(6,*) '    nPair=',    nPair
      If(dbg) Write(6,*) '  MxRank1=',  MxRank1
      If(dbg) Write(6,*) '  MxRank2=',  MxRank2
      If(dbg) Write(6,*) '  iReturn=',  iReturn
      If(dbg) Call xFlush(6)


      If (iReturn.ne.0) Then
         Write(6,*) 'ERROR: something went wrong during '//
     &              'initialization of main variables'
         Write(6,*) 'Have to quit now'
         Call Quit(_RC_GENERAL_ERROR_)
      End If

      ! main program
      If(dbg) Write(6,*) 'Enter poly_aniso_1'
      If(dbg) Call xFlush(6)
      Call POLY_ANISO_1( nneq, neqv, nmax, exch, nLoc,
     &                   nCenter, nT, nH, nTempMagn, nDir,
     &                   nDirZee, nMult, nPair, MxRank1, MxRank2,
     &                   iReturn )
      If(dbg) Write(6,*) 'Exit poly_aniso_1'

      If (iReturn.ne.0) Then
         Write(6,*) 'ERROR: something went wrong during '//
     &              'the execution of the POLY_ANISO_1'
         Call Quit(_RC_GENERAL_ERROR_)
      End If
      If(dbg) Call xFlush(6)

      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine CrSph2(Win,ijkl,ncd,Scrt,nScrt,Coeff1,iCar,iSph,Tr1,Coeff2,jCar,jSph,Tr2,Wout,mab)
!***********************************************************************
!                                                                      *
! Object : to transform the two-electron integrals from cartesian      *
!          gaussians to spherical gaussians.                           *
!                                                                      *
!          Observe that most of the time Win and Wout will overlap.    *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!***********************************************************************

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: ijkl, ncd, nScrt, iCar, iSph, jCar, jSph, mab
real(kind=wp), intent(in) :: Win(ijkl*ncd*iCar*jCar), Coeff1(iCar,iCar), Coeff2(jCar,jCar)
real(kind=wp), intent(out) :: Scrt(nScrt)
real(kind=wp), intent(inout) :: Wout(ijkl*ncd*mab)
logical(kind=iwp), intent(in) :: Tr1, Tr2

if (Tr1 .and. Tr2) then
  !call RecPrt(' Right contraction',' ',Coeff2,jCar,jSph)
  ! Starting with CD,IJKL,a,b transform to B,CD,IJKL,a
  !call xxDGeMul(Coeff2,jCar,'T',Win,ijkl*ncd*iCar,'T',Scrt,jSph,jSph,jCar,ijkl*ncd*iCar)
  call TTMul(Coeff2,Win,Scrt,jCar,jSph,ijkl*ncd*iCar)

  !call RecPrt(' Left contraction',' ',Coeff1,iCar,iSph)
  ! Transform B,CD,IJKL,a to AB,CD,IJKL
  !call xxDGeMul(Coeff1,iCar,'T',Scrt,jSph*ncd*ijkl,'T',Wout,iSph,iSph,iCar,jSph*ncd*ijkl)
  call TTMul(Coeff1,Scrt,Wout,iCar,iSph,jSph*ncd*ijkl)
  ! Transpose AB,CD,IJKL to IJKL,AB,CD
  Scrt(1:mab*ncd*ijkl) = Wout(:)
  call dGeTMO(Scrt,mab*ncd,mab*ncd,ijkl,Wout,ijkl)
else if (Tr2) then
  !call RecPrt(' Right contraction',' ',Coeff2,jCar,jSph)
  ! Starting with CD,IJKL,a,b transform to B,CD,IJKL,a
  !call xxDGeMul(Coeff2,jCar,'T',Win,ncd*ijkl*iCar,'T',Scrt,jSph,jSph,jCar,ncd*ijkl*iCar)
  call TTMul(Coeff2,Win,Scrt,jCar,jSph,ijkl*ncd*iCar)
  ! Transpose B,CD,IJKL,a to IJKL,aB,CD
  call DGeTMO(Scrt,jSph*ncd,jSph*ncd,ijkl*iCar,Wout,ijkl*iCar)
else if (Tr1) then
  ! Transpose CD,IJKL,a,b to b,CD,IJKL,a
  call DGeTMO(Win,ncd*ijkl*iCar,ncd*ijkl*iCar,jCar,Scrt,jCar)

  !call RecPrt(' Left contraction',' ',Coeff1,iCar,iSph)
  ! Transform b,CD,IJKL,a to Ab,CD,IJKL
  !call xxDGeMul(Coeff1,iCar,'T',Scrt,jCar*ncd*ijkl,'T',Wout,iSph,iSph,iCar,jCar*ncd*ijkl)
  call TTMul(Coeff1,Scrt,Wout,iCar,iSph,jCar*ncd*ijkl)
  ! Transpose Ab,CD,IJKL to IJKL,Ab,CD
  Scrt(1:iSph*jCar*ncd*ijkl) = Wout(1:iSph*jCar*ncd*ijkl)
  call DGeTMO(Scrt,iSph*jCar*ncd,iSph*jCar*ncd,ijkl,Wout,ijkl)
else
  ! Transpose CD,IJKL,a,b to IJKL,ab,CD
  Scrt(1:ncd*ijkl*iCar*jCar) = Win(:)
  if (ncd /= 1) then
    call DGeTMO(Scrt,ncd,ncd,ijkl*iCar*jCar,Wout,ijkl*iCar*jCar)
  else
    Wout(1:ncd*ijkl*iCar*jCar) = Scrt(1:ncd*ijkl*iCar*jCar)
  end if
end if

!call RecPrt(' In CrSph2: (AB|CD)',' ',Wout,ijkl,ncd*mab)

return

end subroutine CrSph2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Bernd Schimmelpfennig                            *
************************************************************************
      REAL*8 function LMdepang(
     *L,M,l1,l2,l3,l4,m1,m2,m3,m4,cheater)
cbs   l1-l4 and m1-m4 are already shifted !!
cbs   purpose: calculates the angular part of the
cbs   coulomb-type integrals. See documentation for details...
cbs   LMdepang= LM dependent angular factors
cbs   cheater included for a correcting signs, as there were some
cbs   signs (only signs!!!!) missing when compared to HERMIT
cbs                                        B.S.  08.10.96
      implicit REAL*8 (a-h,o-z)
#include "real.fh"
      LMdepang=0d0
cbs   some quick checks
      if (L.lt.abs(M)) return
      if (l1.lt.abs(m1)) return
      if (l2.lt.abs(m2)) return
      if (l3.lt.abs(m3)) return
      if (l4.lt.abs(m4)) return
cbs   prefactor
      fact1=4d0*pi/DBLE(L+L+1)
cbs   determining the sign
      isum=-l3-l1-l4-l2+2*(M+m3+m4)   !???? I am not sure
      if (mod(isum,4).eq.0) then
         isign=1
      elseif (iabs(mod(isum,4)).eq.2) then
         isign=-1
      else
         isign=0
         write(6,*) 'L,l1,l2,l3,l4,M,m1,m2,m3,m4'
         write(6,'(10I3)') L,l1,l2,l3,l4,M,m1,m2,m3,m4
         write(6,*) 'isum= ',isum,' mod = ',mod(isum,4)
         Call SysHalt( 'lmdepang' )
      endif
      fact2=couple3J(L,l3,l1,-M,m3,-m1)
      fact3=couple3J(L,l4,l2,M,m4,-m2)
C     write(6,*) 'fact2,fact3 ',fact2,fact3
      LMdepang=cheater*DBLE(isign)*fact1*fact2*fact3
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SqToTri_Q(SqMat,TriMat,iDi)

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iDi
real(kind=wp), intent(in) :: SqMat(iDi,iDi)
real(kind=wp), intent(out) :: TriMat(nTri_Elem(iDi))
integer(kind=iwp) :: i, j, kaunter

kaunter = 0
do i=1,iDi
  do j=1,i
    kaunter = kaunter+1
    TriMat(kaunter) = SqMat(i,j)
  end do
end do

return

end subroutine SqToTri_Q

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990,1991,1993, Roland Lindh                           *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine TwoEl_NoSym( &
#                      define _CALLING_
#                      include "twoel_interface.fh"
                      )
!***********************************************************************
!                                                                      *
! Object: to generate the SO integrals for four fixed centers and      *
!         fixed basis set types.                                       *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March '90                                                *
!                                                                      *
!          Roland Lindh, Dept. of Theoretical Chemistry, University of *
!          Lund, SWEDEN. Modified to use Schwarz inequality for pre-   *
!          screening, July 1991.                                       *
!          Modified for direct SCF, January '93                        *
!***********************************************************************

use Index_Functions, only: iTri, nTri3_Elem1
use Basis_Info, only: Shells
use iSD_data, only: nSD
use Gateway_Info, only: CutInt, ThrInt
use Symmetry_Info, only: nIrrep
use Int_Options, only: Disc, Disc_Mx, DoFock, DoIntegrals, ExFac, FckNoClmb, FckNoExch, PreSch, Quad_ijkl, Thize, W2Disc
use k2_arrays, only: DeDe, pDq, pFq
use k2_structure, only: IndK2, k2_type, k2data
use Breit, only: nComp
use NDDO, only: twoel_NDDO
use Dens_stuff, only: ipDDij, ipDDik, ipDDil, ipDDjk, ipDDjl, ipDDkl, mDCRij, mDCRik, mDCRil, mDCRjk, mDCRjl, mDCRkl, mDij, mDik, &
                      mDil, mDjk, mDjl, mDkl
use Constants, only: Zero, One, Four, Eight
use Definitions, only: wp, iwp, u6, RtoB, RtoI

implicit none
#include "twoel_interface.fh"
integer(kind=iwp) :: i_Int, iAng(4), iAO(4), iAOst(4), iBasi, iCmp(4), iEta, ijS, ik2, IncEta, IncZet, iOpt, ipAOInt, ipAOInt_, &
                     iPer, iS, iShell(4), iShll(4), ISMAng, iW3, iW4, iW4_, iWR(2), iZeta, jBasj, jk2, jPrInc, jS, kabcd, kBask, &
                     kInts, klS, kS, la, lb, lBasl, lc, ld, lPrInc, lS, mabcd, mabMax, mabMin, mcdMax, mcdMin, mEta, mInts, &
                     mWork2, mZeta, nab, nabcd, nAlpha, nBeta, nByte, ncd, nDCRR, nDCRS, nDelta, nEta, nEta_Tot, nGamma, nInts, &
                     nZeta, nZeta_Tot
real(kind=wp) :: CoorAC(3,2), q4, QInd(2), RST_Triplet, vij, vijkl, vik, vil, vjk, vjl, vkl
logical(kind=iwp) :: ABeqCD, AeqB, AeqC, All_Spherical, Batch_On_Disk, CeqD, Do_TnsCtl, DoAOBatch, DoCoul, DoExch, NoPInts, Pij, &
                     Pijkl, Pik, Pjl, Pkl, Prescreen_On_Int_Only, Scrij, Scrik, Scril, Scrjk, Scrjl, Scrkl, Shijij
real(kind=wp), pointer :: Coeff1(:,:), Coeff2(:,:), Coeff3(:,:), Coeff4(:,:), Dij(:,:), Dik(:,:), Dil(:,:), Djk(:,:), Djl(:,:), &
                          Dkl(:,:)
type(k2_type), pointer :: k2data1(:), k2data2(:)
logical(kind=iwp), parameter :: Copy = .true., NoCopy = .false.
logical(kind=iwp), external :: EQ

#include "macros.fh"
unused_var(SoInt)

nZeta = iSD4(5,1)*iSD4(5,2)
nEta = iSD4(5,3)*iSD4(5,4)

Shijij = ((iSD4(11,1) == iSD4(11,3)) .and. (iSD4(11,2) == iSD4(11,4)))

iShell(:) = iSD4(11,:)
iShll(:) = iSD4(0,:)
iAng(:) = iSD4(1,:)
iAO(:) = iSD4(7,:)
iAOst(:) = iSD4(8,:)

jPrInc = iSD4(6,2)
lPrInc = iSD4(6,4)

!                                                                      *
!***********************************************************************
!                                                                      *
! Pick up pointers to k2 entities.

iS = iShell(1)
jS = iShell(2)
kS = iShell(3)
lS = iShell(4)
ijS = iTri(iS,jS)
klS = iTri(kS,lS)
nDCRR = IndK2(2,ijS)
ik2 = IndK2(3,ijS)
nDCRS = IndK2(2,klS)
jk2 = IndK2(3,klS)
k2data1(1:nDCRR) => k2Data(1:nDCRR,ik2)
k2data2(1:nDCRS) => k2Data(1:nDCRS,jk2)

if (DoFock) then
  Dij(1:mDij,1:mDCRij) => DeDe(ipDDij:ipDDij+mDij*mDCRij-1)
  Dkl(1:mDkl,1:mDCRkl) => DeDe(ipDDkl:ipDDkl+mDkl*mDCRkl-1)
  Dik(1:mDik,1:mDCRik) => DeDe(ipDDik:ipDDik+mDik*mDCRik-1)
  Dil(1:mDil,1:mDCRil) => DeDe(ipDDil:ipDDil+mDil*mDCRil-1)
  Djk(1:mDjk,1:mDCRjk) => DeDe(ipDDjk:ipDDjk+mDjk*mDCRjk-1)
  Djl(1:mDjl,1:mDCRjl) => DeDe(ipDDjl:ipDDjl+mDjl*mDCRjl-1)
else
  ! Dummy association
  Dij(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Dkl(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Dik(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Dil(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Djk(1:1,1:1) => DeDe(lbound(DeDe,1):)
  Djl(1:1,1:1) => DeDe(lbound(DeDe,1):)
end if

All_Spherical = (Shells(iShll(1))%Prjct .and. Shells(iShll(2))%Prjct .and. Shells(iShll(3))%Prjct .and. Shells(iShll(4))%Prjct)

nAlpha = iSD4(5,1)
nBeta = iSD4(5,2)
nGamma = iSD4(5,3)
nDelta = iSD4(5,4)
iBasi = iSD4(19,1)
jBasj = iSD4(19,2)
kBask = iSD4(19,3)
lBasl = iSD4(19,4)

Coeff1(1:nAlpha,1:iBasi) => Shells(iShll(1))%pCff(:,iAOst(1)+1:)
Coeff2(1:nBeta,1:jBasj) => Shells(iShll(2))%pCff(:,iAOst(2)+1:)
Coeff3(1:nGamma,1:kBask) => Shells(iShll(3))%pCff(:,iAOst(3)+1:)
Coeff4(1:nDelta,1:lBasl) => Shells(iShll(4))%pCff(:,iAOst(4)+1:)

#ifdef _DEBUGPRINT_
call RecPrt('Coeff1',' ',Coeff1,nAlpha,iBasi)
call RecPrt('Coeff2',' ',Coeff2,nBeta,jBasj)
call RecPrt('Coeff3',' ',Coeff3,nGamma,kBask)
call RecPrt('Coeff4',' ',Coeff4,nDelta,lBasl)
#endif

RST_triplet = One
QInd(2) = RST_triplet

la = iAng(1)
lb = iAng(2)
lc = iAng(3)
ld = iAng(4)
iSmAng = la+lb+lc+ld

! switch (to generate better start orbitals...)
AeqB = EQ(Coor(:,1),Coor(:,2))
if (twoel_NDDO .and. (.not. AeqB)) return
CeqD = EQ(Coor(:,3),Coor(:,4))
if (twoel_NDDO .and. (.not. CeqD)) return
! switch

AeqC = EQ(Coor(:,1),Coor(:,3))
ABeqCD = AeqB .and. CeqD .and. AeqC
if (ABeqCD .and. (mod(iSmAng,2) == 1)) return
! For Spherical Gaussians, batches like
!(DS|SS), (FP|SS) and (FS|PS) vanish as well
if (ABeqCD .and. All_Spherical .and. (2*max(la,lb,lc,ld) > iSmAng)) return

iCmp(:) = iSD4(2,:)
nab = iCmp(1)*iCmp(2)
ncd = iCmp(3)*iCmp(4)
nabcd = nab*ncd
nInts = nijkl*nabcd
ipAOInt = 1
iW3 = 1+nInts
iW4 = 1

vijkl = k2Data1(1)%abConMax*k2Data2(1)%abConMax

Batch_On_Disk = (vijkl > Thize) .and. (Disc+real(nInts+2+2/RtoI,kind=wp) <= Disc_Mx)

Prescreen_On_Int_Only = PreSch
if (DoIntegrals) Prescreen_On_Int_Only = .true.
if (Batch_On_Disk) Prescreen_On_Int_Only = .true.

if (DoFock) then
  vij = Dij(mDij,1)
  vkl = Dkl(mDkl,1)
  ! Coulomb contributions
  Scrkl = vij*vijkl >= ThrInt
  Scrij = vkl*vijkl >= ThrInt
  DoCoul = Scrij .or. Scrkl

  ! Exchange contributions
  vik = Dik(mDik,1)/Four
  vil = Dil(mDil,1)/Four
  vjk = Djk(mDjk,1)/Four
  vjl = Djl(mDjl,1)/Four
  Scrjl = vik*vijkl >= ThrInt
  Scrjk = vil*vijkl >= ThrInt
  Scril = vjk*vijkl >= ThrInt
  Scrik = vjl*vijkl >= ThrInt
  DoExch = Scrjl .or. Scrjk .or. Scril .or. Scrik
  if (FckNoClmb) DoCoul = .false.
  if (FckNoExch) DoExch = .false.
else
  DoCoul = .false.
  DoExch = .false.
end if
DoAOBatch = (DoIntegrals .and. (vijkl > CutInt)) .or. (DoFock .and. (DoCoul .or. DoExch)) .or. (Batch_On_Disk .and. W2Disc)

! Branch out if crude estimate indicates no contributions!

if (.not. DoAOBatch) then
  if (.not. Batch_On_Disk) return
  if (.not. W2Disc) then
    do
      call iRBuf(iWR,2,Copy)
      call dRBuf(QInd,2,Copy)
      call Store_QLast(QInd)
      kInts = iWR(1)
      mInts = iWR(2)
      if (QInd(1) == Quad_ijkl) then
        if (kInts /= nInts) then
          call WarningMessage(2,'Twoel: kInts /= nInts!')
          write(u6,*) 'Twoel: kInts,mInts,nInts=',kInts,mInts,nInts
          write(u6,*) 'Index,1:',QInd(1),Quad_ijkl
          call Abend()
        end if
        if (mInts > 0) call dRBuf(Wrk(iW3),mInts,NoCopy)
        Disc = Disc+real(2/RtoI+2+mInts,kind=wp)
        return
      else if (QInd(1) < Quad_ijkl) then
        if (mInts > 0) call dRBuf(Wrk(iW3),mInts,NoCopy)
        Disc = Disc+real(2/RtoI+2+mInts,kind=wp)
      else
        call WarningMessage(2,'Twoel: batch is lost!')
        write(u6,*) 'Index,1:',QInd(1),QInd(2),Quad_ijkl,RST_triplet
        call Abend()
      end if
    end do
  end if
end if

! Branch point for partial integral storage

if ((.not. Batch_On_Disk) .or. W2Disc) then
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Here if the AO batch will be computed!

  ! Compute actual size of the {a0|c0} block

  mabMin = nTri3_Elem1(max(la,lb)-1)
  if (EQ(Coor(:,1),Coor(:,2))) mabMin = nTri3_Elem1(la+lb-1)
  mabMax = nTri3_Elem1(la+lb)-1
  mcdMin = nTri3_Elem1(max(lc,ld)-1)
  if (EQ(Coor(:,3),Coor(:,4))) mcdMin = nTri3_Elem1(lc+ld-1)
  mcdMax = nTri3_Elem1(lc+ld)-1
  mabcd = (mabMax-mabMin+1)*(mcdMax-mcdMin+1)

  ! Find the proper centers to start of with the angular
  ! momentum on. If la == lb there will exist an
  ! ambiguity to which center that angular momentum should
  ! be accumulated on. In that case we will use A and C of
  ! the order as defined by the basis functions types.

  if (la >= lb) then
    CoorAC(:,1) = Coor(:,1)
  else
    CoorAC(:,1) = Coor(:,2)
  end if
  if (lc >= ld) then
    CoorAC(:,2) = Coor(:,3)
  else
    CoorAC(:,2) = Coor(:,4)
  end if

  ! Loops to partition the primitives

  IncZet = nAlpha*jPrInc
  IncEta = nGamma*lPrInc
  if ((nZeta /= IncZet) .or. (nEta /= IncEta)) then
    mWork2 = nWork2-nijkl*mabcd
    ipAOInt = 1+nijkl*mabcd
  else
    mWork2 = nWork2
    ipAOInt = 1
  end if

  nZeta_Tot = k2Data1(1)%IndZ(nZeta+1)
  nEta_Tot = k2Data2(1)%IndZ(nEta+1)
# ifdef _DEBUGPRINT_
  write(u6,*) 'nZeta=',nZeta
  write(u6,*) 'nEta=',nEta
  write(u6,*) 'nZeta_Tot, IncZet=',nZeta_Tot,IncZet
  write(u6,*) 'nEta_Tot,  IncEta=',nEta_Tot,IncEta
# endif

  kabcd = 0
  Do_TnsCtl = .false.
  NoInts = .true.
  NoPInts = .true.
  ipAOInt_ = ipAOInt
  iW4_ = iW4

  do iZeta=1,nZeta_Tot,IncZet
    mZeta = min(IncZet,nZeta_Tot-iZeta+1)
    if (all(Coeff2(:,:) == Zero)) cycle

    do iEta=1,nEta_Tot,IncEta
      mEta = min(IncEta,nEta_Tot-iEta+1)
      if (all(Coeff4(:,:) == Zero)) cycle

      call DrvRys(iZeta,iEta,nZeta,nEta,mZeta,mEta,nZeta_Tot,nEta_Tot,k2data1(1),k2data2(1),nAlpha,nBeta,nGamma,nDelta,1,1,1,1,1, &
                  1,ThrInt,CutInt,vij,vkl,vik,vil,vjk,vjl,Prescreen_On_Int_Only,NoInts,iAng,Coor,CoorAC,mabMin,mabMax,mcdMin, &
                  mcdMax,nijkl/nComp,nabcd,mabcd,Wrk,ipAOInt_,iW4_,nWork2,mWork2,k2Data1(1)%HrrMtrx(:,1),k2Data2(1)%HrrMtrx(:,1), &
                  la,lb,lc,ld,iCmp,iShll,NoPInts,Dij(:,1),mDij,Dkl(:,1),mDkl,Do_TnsCtl,kabcd,Coeff1,iBasi,Coeff2,jBasj,Coeff3, &
                  kBask,Coeff4,lBasl)

    end do
  end do

  if (NoPInts) then
    if (W2Disc) then
      if (Batch_On_Disk) then
        iOpt = 0
        mInts = 0

        iWR(1) = nInts
        iWR(2) = mInts
        call iWBuf(iWR,2)
        QInd(1) = Quad_ijkl
        call dWBuf(QInd,2)
        call Store_QLast(QInd)

        Disc = Disc+real(2/RtoI+2+mInts,kind=wp)
      end if
    end if
    return
  end if

  ! Apply the transfer equation and transform the spherical
  ! harmonic gaussian.

  if (Do_TnsCtl) then
    call TnsCtl(Wrk(iW4),nWork2,nijkl,mabMax,mabMin,mcdMax,mcdMin,k2Data1(1)%HrrMtrx(:,1),k2Data2(1)%HrrMtrx(:,1),la,lb,lc,ld, &
                iCmp(1),iCmp(2),iCmp(3),iCmp(4),iShll(1),iShll(2),iShll(3),iShll(4),i_Int)
    ipAOInt = i_Int
    if (i_Int == 1) then
      iW3 = 1+nijkl*nabcd
    else
      iW3 = 1
    end if
  else

    ! Undo the late Cntrct

    Wrk(iW3:iW3+nijkl*nabcd-1) = Wrk(ipAOInt:ipAOInt+nijkl*nabcd-1)
    call DGeTMO(Wrk(iW3),nabcd,nabcd,nijkl,Wrk(ipAOInt),nijkl)

  end if
# ifdef _DEBUGPRINT_
  call RecPrt('(AB|CD)',' ',Wrk(ipAOInt),nijkl/nComp,nComp*iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4))
# endif

  ! Branch point for partial integral storage

  if (Batch_On_Disk .and. W2Disc) then

    ! Write integrals to current position on disc.

    iOpt = 0
    call PkR8(iOpt,nInts,nByte,Wrk(ipAOInt),Wrk(iW3))
    mInts = (nByte+RtoB-1)/RtoB

    iWR(1) = nInts
    iWR(2) = mInts
    !write(u6,*) 'nInts,mInts=',nInts,mInts
    call iWBuf(iWR,2)
    QInd(1) = Quad_ijkl
    call dWBuf(QInd,2)
    call Store_QLast(QInd)
    call dWBuf(Wrk(iW3),mInts)

    Disc = Disc+real(2/RtoI+2+mInts,kind=wp)

  end if
end if

if (Batch_On_Disk .and. (.not. W2Disc)) then
  do
    call iRBuf(iWR,2,Copy)
    call dRBuf(QInd,2,Copy)
    call Store_QLast(QInd)
    kInts = iWR(1)
    mInts = iWR(2)
    if (QInd(1) == Quad_ijkl) then
      if (kInts /= nInts) then
        call WarningMessage(2,'Twoel: kInts /= nInts!')
        write(u6,*) 'Twoel: kInts,mInts,nInts=',kInts,mInts,nInts
        write(u6,*) 'Index,1:',QInd(1),Quad_ijkl
        call Abend()
      end if
      if (mInts > 0) call dRBuf(Wrk(iW3),mInts,Copy)
      Disc = Disc+real(2/RtoI+2+mInts,kind=wp)
      if (mInts == 0) return
      exit
    else if (QInd(1) < Quad_ijkl) then
      if (mInts > 0) call dRBuf(Wrk(iW3),mInts,NoCopy)
      Disc = Disc+real(2/RtoI+2+mInts,kind=wp)
    else
      call WarningMessage(2,'Twoel: batch is lost!')
      write(u6,*) 'Index,1:',QInd(1),QInd(2),Quad_ijkl,RST_triplet
      call Abend()
    end if
  end do

  iOpt = 0
  call UpkR8(iOpt,nInts,nByte,Wrk(iW3),Wrk(ipAOInt))
end if

! Accumulate contributions directly to the Fock matrix.

if (DoFock) call FckAcc_NoSymq(iCmp(1),iCmp(2),iCmp(3),iCmp(4),Shijij,iShell,nijkl,Wrk(ipAOInt),pFq,pDq,size(pFq),iAO,iAOst, &
                               iBasi,jBasj,kBask,lBasl,DoCoul,DoExch,vij,vkl,vik,vil,vjk,vjl,ExFac)

if (DoIntegrals) then
  if (ipAOInt /= 1) then
    Wrk(1:nijkl*nabcd) = Wrk(ipAOInt:ipAOInt+nijkl*nabcd-1)
    ipAOInt = 1
  end if
  iPer = 1
  Pij = (iSD4(20,1) == iSD4(20,2))
  Pkl = (iSD4(20,3) == iSD4(20,4))
  Pik = (iSD4(20,1) == iSD4(20,3))
  Pjl = (iSD4(20,2) == iSD4(20,4))
  Pijkl = (Pij .and. Pkl .and. Pik .and. Pjl)
  if (Pij) iPer = iPer*2
  if (Pkl) iPer = iPer*2
  if (Pijkl) iPer = iPer*2
  q4 = Eight/real(iPer,kind=wp)
  if (nIrrep == 1) q4 = One
  if (q4 /= One) Wrk(ipAOInt:ipAOInt+nijkl*nabcd-1) = q4*Wrk(ipAOInt:ipAOInt+nijkl*nabcd-1)
end if

end subroutine TwoEl_NoSym

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine CiSelector(nEqState,nState,iSTC,nCIRef,iCIInd,dCIRef)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "WrkSpc.fh"

      Dimension iCIInd(MxState)
      Dimension dCIRef(MxState)

*
*-- Initial stuff
*
      dScalMAX=0.0d0
      indMAX=1
*
*-- Compute relevant scalar products
*
      Do 501, iState=1,nState
        dScal=0.0d0
        Do 502, iRef=1,nCIRef
          indBase=nState*(iState-1)
          indx=indBase+iCIInd(iRef)-1
          dScal=dScal+Work(iSTC+indx)*dCIRef(iRef)
502     Continue
        dScal=abs(dScal)
*
*---- Test if largest
*
        If(dScal.gt.dScalMAX) then
          dScalMAX=dScal
          indMAX=iState
        Endif
501   Continue

*
*-- If maximum overlap is small, scream!
*
      If(dScalMAX.lt.0.7071067811d0) then
        Write(6,*)
        Write(6,*)'   WARNING! Less than 50% of CISElect reference'
     &//'found. Consider to redefine reference!'
      Endif

*
*-- Now set nEqState
*
      nEqState=indMAX

*
*-- Auf Wiedersehen
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Integral_WrOut2(iCmp,iShell,MapOrg,
     &                           iBas,jBas,kBas,lBas,kOp,
     &                           Shijij,IJeqKL,iAO,iAOst,ijkl,
     &                           AOInt,SOInt,nSOint,
     &                           iSOSym,nSkal,nSOs,
     &                           TInt,nTInt,itOffs,nSym)
*     calls the proper routines IndSft/PLF
*     if IntOrd_jikl==.TRUE. integral order within symblk: jikl
*                      else  integral order within symblk: ijkl
      Implicit Real*8 (A-H,O-Z)
*
      Real*8 AOInt(*), SOInt(*), TInt(nTInt)
      Integer iCmp(4), iShell(4), iAO(4),
     &        iAOst(4), kOp(4), iSOSym(2,nSOs),
     &        itOffs(0:nSym-1,0:nSym-1,0:nSym-1), MapOrg(4)
      Logical Shijij,IJeqKL
*
      If (nSym.eq.1) Then
        Call PLF2(AOInt,ijkl,iCmp(1),iCmp(2),iCmp(3),iCmp(4),
     &           iShell,iAO,iAOst,Shijij.and.IJeqKL,
     &           iBas,jBas,kBas,lBas,kOp)
      Else
        Call IndSft2(iCmp,iShell,
     &               iBas,jBas,kBas,lBas,Shijij,
     &               iAO,iAOst,ijkl,SOInt,nSOint,iSOSym,nSOs)
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer_array(MapOrg)
         Call Unused_integer(nSkal)
         Call Unused_real_array(TInt)
         Call Unused_integer_array(itOffs)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine initintabc1()
! this routine writes corresponding mapd and mapi to INTAB
! for nonsymmetrical (C1) case

use ccsort_global, only: lunab, mapd3, mapi3, NORB, NSYM, pos30
use Symmetry_Info, only: Mul
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: ii, length, pos, rc, syma, symab, symb, symp, symq

! def symab
syma = 1
symb = 1
symab = mul(syma,symb)

! make mapd3,mapi3 for <_a_b|pq>

! set mapi3=0 (partly)

mapi3(1:nsym,1:nsym,1:nsym) = 0

! def 0-th row

mapd3(0,1) = 5
mapd3(0,2) = 5
mapd3(0,3) = 0
mapd3(0,4) = 0
mapd3(0,5) = nsym
mapd3(0,6) = 0

! def other rows

pos = pos30
do ii=1,nsym

  symp = ii
  symq = mul(symab,symp)
  length = norb(symp)*norb(symq)
  mapd3(ii,1) = pos
  mapd3(ii,2) = length
  mapd3(ii,3) = symp
  mapd3(ii,4) = symq
  mapd3(ii,5) = 1
  mapd3(ii,6) = 1
  mapi3(symp,1,1) = ii
  pos = pos+length

end do

! write mapd,mapi to INTAB
call dawrtmap(lunab,mapd3,mapi3,rc)

return

end subroutine initintabc1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DefParo3v3Hlp2(i,Schem,Nomen)
! help routine to DefParo2v4, producing names of Disc files
! ex: Schem='XYZQ', i=1  ->  Nomen='XYZQ01'

use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: i
character(len=4), intent(in) :: Schem
character(len=6), intent(out) :: Nomen

write(Nomen,'(a4,i2.2)') Schem,i

return

end subroutine DefParo3v3Hlp2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine setiaprtot2_cvb(civec,
     >  iapr,ixapr,ibpr,ixbpr,npvb,
     >  nda,ndb)
      implicit real*8 (a-h,o-z)
      dimension civec(nda,ndb)
      dimension iapr(npvb),ixapr(nda+1),ibpr(npvb),ixbpr(ndb+1)


      idetvb=0
      ixapr(1)=1
      do 100 ia=1,nda
      do 200 ib=1,ndb
      if(civec(ia,ib).eq.1d0)then
        idetvb=idetvb+1
        if(idetvb.gt.npvb)then
          write(6,*)' Error in setiaprtot!',npvb
          call abend_cvb()
        endif
        iapr(idetvb)=ib
      endif
200   continue
      ixapr(ia+1)=idetvb+1
100   continue

      idetvb=0
      ixbpr(1)=1
      do 300 ib=1,ndb
      do 400 ia=1,nda
      if(civec(ia,ib).eq.1d0)then
        idetvb=idetvb+1
        if(idetvb.gt.npvb)then
          write(6,*)' Error in setiaprtot!',npvb
          call abend_cvb()
        endif
        ibpr(idetvb)=ia
      endif
400   continue
      ixbpr(ib+1)=idetvb+1
300   continue

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine VPMem( &
#                define _CALLING_
#                include "mem_interface.fh"
                )

use Index_Functions, only: nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: iAngV(4), MemNA1, MemNA2, nFlop, nMem

call mHrr(la,lb+1,nFlop,nMem)

nHer = (la+lb+1+lr+2)/2
iAngV(1) = la
iAngV(2) = lb+1
iAngV(3) = 0
iAngV(4) = 0
call MemRys(iAngV,MemNA1)

MemNA1 = max(nMem,MemNA1)

if (lb /= 0) then
  call mHrr(la,lb-1,nFlop,nMem)

  nHer = (la+lb-1+lr+2)/2
  iAngV(1) = la
  iAngV(2) = lb-1
  iAngV(3) = 0
  iAngV(4) = 0
  call MemRys(iAngV,MemNA2)

  MemNA2 = max(nMem,MemNA2)
else
  MemNA2 = 0
end if

Mem = max(MemNA1,MemNA2)

Mem = Mem+1

Mem = Mem+nTri_Elem1(la)*nTri_Elem1(lb+1)
if (lb /= 0) Mem = Mem+nTri_Elem1(la)*nTri_Elem1(lb-1)

return

end subroutine VPMem

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2022, Jie J. Bao                                       *
!***********************************************************************
!*****************************************************************
! history:                                                       *
! Jie J. Bao, on Apr. 12, 2022, created this file.               *
!*****************************************************************

subroutine CalcHessCMS(Hess,DDg,lRoots,nSPair)

use Index_Functions, only: iTri
use Constants, only: Zero, Two, Four
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lRoots, nSPair
real(kind=wp), intent(out) :: Hess(nSPair,nSPair)
real(kind=wp), intent(in) :: DDg(lRoots,lRoots,lRoots,lRoots)
integer(kind=iwp) :: K, L, M, N, iKL, iMN

Hess(:,:) = Zero
do K=2,lRoots
  do L=1,K-1
    iKL = iTri(K-1,L)
    do M=2,lRoots
      do N=1,M-1
        iMN = iTri(M-1,N)
        if (L == M) Hess(iMN,iKL) = Hess(iMN,iKL)+DDg(K,N,K,K)+DDg(K,N,N,N)-Two*DDg(K,N,L,L)-Four*DDg(K,L,M,N)
        if (K == N) Hess(iMN,iKL) = Hess(iMN,iKL)+DDg(L,M,L,L)+DDg(L,M,M,M)-Two*DDg(L,M,K,K)-Four*DDg(K,L,M,N)
        if (K == M) Hess(iMN,iKL) = Hess(iMN,iKL)-DDg(L,N,L,L)-DDg(L,N,N,N)+Two*DDg(L,N,K,K)+Four*DDg(K,L,M,N)
        if (L == N) Hess(iMN,iKL) = Hess(iMN,iKL)-DDg(K,M,K,K)-DDg(K,M,M,M)+Two*DDg(K,M,L,L)+Four*DDg(K,L,M,N)
      end do
    end do
  end do
end do

return

end subroutine CalcHessCMS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1998  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE TRDACT(IVEC,JVEC,DTU)
      IMPLICIT NONE

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "pt2_guga.fh"
#include "stdalloc.fh"
#include "SysDef.fh"

      INTEGER IVEC, JVEC
      REAL*8 DTU(NASHT,NASHT)
C Local array:
      INTEGER IATOG(MXLEV)

      REAL*8, ALLOCATABLE :: TRDOP1(:), TRDOP2(:), TRDOP3(:)
      INTEGER :: NOP1, NOP2, NOP3

      REAL*8, ALLOCATABLE :: TRDTMP(:), TRDCI(:), TRDSGM(:)
      INTEGER :: NTMP, NSGM

      INTEGER :: I, J, ID
      INTEGER :: ISYM, ISYMT
      INTEGER :: ITABS, ITLEV, IU, IUABS, IULEV
      REAL*8 :: OP0, OCCNUM, SCP, DDOT_

C Add to the active-active block of transition density matrix,
C    D(t,u) = Add <IVEC| E(t,u) |JVEC> = <0| W1T E(t,u) W2 |0>
C where t,u are active indices. IVEC and JVEC are integer labels,
C denoting sets of coefficients stored on LUSOLV. These are assumed
C to be contravariant representations of the wave operators W1 and W2,
C in the notation of the comments.


CTEST      WRITE(*,*)' Memory list, TRDACT point A:'
CTEST      call getmem('TRDACT A','LIST','REAL',LDUM,NDUM)

C (1): Compute a representation of the operator PCAS*W1T*W2
      NOP1=NASHT**2
      NOP2=(NOP1*(NOP1+1))/2
      NOP3=(NOP2*(NOP1+2))/3
      CALL MMA_ALLOCATE(TRDOP1,NOP1)
      CALL MMA_ALLOCATE(TRDOP2,NOP2)
      CALL MMA_ALLOCATE(TRDOP3,NOP3)
      CALL MKWWOP(IVEC,JVEC,OP0,TRDOP1,NOP2,TRDOP2,NOP3,TRDOP3)
CTEST      WRITE(*,*)' TRDACT, back from MKWWOP.'
CTEST      WRITE(*,*)' OP0:'
CTEST      WRITE(*,'(1x,5f16.8)') OP0
CTEST      WRITE(*,*)' OP1:'
CTEST      WRITE(*,'(1x,5f16.8)')(TRDOP1(I),I=1,NOP1)
CTEST      WRITE(*,*)' OP2:'
CTEST      WRITE(*,'(1x,5f16.8)')(TRDOP2(I),I=1,NOP2)
CTEST      WRITE(*,*)' OP3:'
CTEST      WRITE(*,'(1x,5f16.8)')(TRDOP3(I),I=1,NOP3)

CTEST      WRITE(*,*)' Memory check, TRDACT point B:'
CTEST      call getmem('TRDACT B','CHEC','REAL',LDUM,NDUM)

C (2): Compute the state vector |Temp> = (PCAS*W1T*W2) |0>
C First modify the coefficients, see subroutine MODOP.
      CALL MODOP(TRDOP1,NOP2,TRDOP2,NOP3,TRDOP3)
CTEST      WRITE(*,*)' TRDACT, back from MODOP.'
CTEST      WRITE(*,*)' OP0:'
CTEST      WRITE(*,'(1x,5f16.8)') OP0
CTEST      WRITE(*,*)' OP1:'
CTEST      WRITE(*,'(1x,5f16.8)')(TRDOP1(I),I=1,NOP1)
CTEST      WRITE(*,*)' OP2:'
CTEST      WRITE(*,'(1x,5f16.8)')(TRDOP2(I),I=1,NOP2)
CTEST      WRITE(*,*)' OP3:'
CTEST      WRITE(*,'(1x,5f16.8)')(TRDOP3(I),I=1,NOP3)
      NTMP=NCONF
      CALL MMA_ALLOCATE(TRDTMP,NTMP)
      CALL MMA_ALLOCATE(TRDCI,NCONF)
      IF(ISCF.EQ.0) THEN
*PAM07 Eliminate the unsafe IPOSFILE call
*        ID=IDTCEX+iPosFile(NCONF)*(JSTATE-1)
*PAM07 Use instead dummy operations:
        ID=IDTCEX
        DO J=1,JSTATE-1
         CALL DDAFILE(LUCIEX,0,TRDCI,NCONF,ID)
        END DO
        CALL DDAFILE(LUCIEX,2,TRDCI,NCONF,ID)
CTEST      WRITE(*,*)' Before HAM3, the CI array:'
CTEST      CALL PRWF_CP2(LSYM,NCONF,TRDCI,0.0D0)
CTEST      WRITE(*,*)' Norm:',DNRM2_(NCONF,TRDCI,1)
      ELSE
        TRDCI=1.0D0
      END IF
      CALL DCOPY_(NTMP,[0.0D0],0,TRDTMP,1)
      CALL HAM3(OP0,TRDOP1,NOP2,TRDOP2,NOP3,TRDOP3,LSYM,TRDCI,TRDTMP)
CTEST      WRITE(*,*)' After HAM3, the wave function W(+)*W*(PSI0):'
CTEST      CALL PRWF_CP2(LSYM,NCONF,TRDTMP,0.0D0)
CTEST      WRITE(*,*)' Ovlp with CI:',DDOT_(NCONF,TRDCI,1,TRDTMP,1)
C No more need for the operators:
      CALL MMA_DEALLOCATE(TRDOP1)
      CALL MMA_DEALLOCATE(TRDOP2)
      CALL MMA_DEALLOCATE(TRDOP3)

CTEST      WRITE(*,*)' Memory check, TRDACT point C:'
CTEST      call getmem('TRDACT C','CHEC','REAL',LDUM,NDUM)

C (3) compute <0| E(t,u) W1T W2 |0> as <Sigma_ut| Temp>, and add to DTU

      IF(ISCF.EQ.0) THEN
C Create reorder table giving the GUGA level, i.e. CI-coupling
C ordinal number of each active orbital.
        ITABS=0
        DO ISYM=1,NSYM
          DO I=1,NLEV
            IF(ISM(I).EQ.ISYM) THEN
              ITABS=ITABS+1
              IATOG(ITABS)=I
            END IF
          END DO
        END DO
CTEST      WRITE(*,*)' At point 3 in TRDACT. The scalar products:'
        NSGM=NCONF
        CALL MMA_ALLOCATE(TRDSGM,MXCI)
        DO ITABS=1,NASHT
          ISYMT=IASYM(ITABS)
          ITLEV=IATOG(ITABS)
          DO IU=1,NASH(ISYMT)
            IUABS=NAES(ISYMT)+IU
            IULEV=IATOG(IUABS)
CPAM00          CALL GETSGM(IULEV,ITLEV,IDEX,TRDSGM)
CPAM00 GETSGM replaced by GETSGM2
            CALL GETSGM2(IULEV,ITLEV,LSYM,TRDCI,TRDSGM)
            SCP=DDOT_(NCONF,TRDSGM,1,TRDTMP,1)
CTEST      WRITE(*,*)' ITABS,IUABS,SCP:',ITABS,IUABS,SCP
            DTU(ITABS,IUABS)=DTU(ITABS,IUABS)+SCP
          END DO
        END DO
        CALL MMA_DEALLOCATE(TRDSGM)
      ELSE
        OCCNUM=2.0D0
        IF(ISCF.EQ.2) OCCNUM=1.0D0
        DO ITABS=1,NASHT
          DTU(ITABS,ITABS)=DTU(ITABS,ITABS)+OCCNUM
        END DO
      END IF
CPAM00 No more need for CI array
      CALL MMA_DEALLOCATE(TRDCI)
C No more need for the TMP state vector
      CALL MMA_DEALLOCATE(TRDTMP)

CTEST      WRITE(*,*)' After point 3 in TRDACT, the array DTU is:'
CTEST      do i=1,nasht
CTEST        WRITE(*,'(1x,6f12.6)')(dtu(i,j),j=1,nasht)
CTEST      end do

CTEST      WRITE(*,*)' Memory check, TRDACT point D:'
CTEST      call getmem('TRDACT D','CHEC','REAL',LDUM,NDUM)

C (4): Add the correction <0| [W1T,E(tu)] W2 |0>.
      CALL COMMWEW(IVEC,JVEC,DTU)

CTEST      WRITE(*,*)' After point 4 in TRDACT, the array DTU is:'
CTEST      do i=1,nasht
CTEST        WRITE(*,'(1x,6f12.6)')(dtu(i,j),j=1,nasht)
CTEST      end do

CTEST      WRITE(*,*)' Memory check, TRDACT point E:'
CTEST      call getmem('TRDACT E','CHEC','REAL',LDUM,NDUM)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Put_Chunk(ip_ChoVec,MuNu_s,MuNu_e,j_s,j_e,Rv,nMuNu,
     &                     LenVec)
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "para_info.fh"
      Real*8 Rv(nMuNu,(j_e-j_s+1))
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _MOLCAS_MPP_
*
      NumVec_ = j_e - j_s + 1
      If (NumVec_ .gt. 0) Then
         If (Is_Real_Par()) Then
            Call GA_Put(ip_ChoVec,MuNu_s,MuNu_e,j_s,j_e,Rv,nMuNu)
         Else
            mMuNu=MuNu_s-1
            jp_ChoVec=ip_ChoVec+mMuNu
            Do jVec = 1, NumVec_
               call dcopy_(nMuNu,Rv(1,jVec),1,Work(jp_ChoVec),1)
               jp_ChoVec = jp_ChoVec + LenVec
            End Do
         End If
      End If
*
#else
*
      mMuNu=MuNu_s-1
      NumVec_ = j_e - j_s + 1
*
      jp_ChoVec=ip_ChoVec+mMuNu
      Do jVec = 1, NumVec_
         call dcopy_(nMuNu,Rv(1,jVec),1,Work(jp_ChoVec),1)
         jp_ChoVec = jp_ChoVec + LenVec
      End Do
*
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(MuNu_e)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine Anasize_Localisation(Den,CMO,XMO,nShell,nOrb,iSym)
! Author: T.B. Pedersen
!
! Purpose: sparsity analysis of shell-based matrices.

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nShell, nOrb, iSym
real(kind=wp), intent(in) :: Den(nShell,nShell), CMO(nShell,nOrb), XMO(nShell,nOrb)
integer(kind=iwp), parameter :: lBin = 9
integer(kind=iwp) :: i, iBin, lDLT
real(kind=wp) :: Bin(lBin), StpSiz
character(len=36) :: DHead
character(len=20) :: CHead
character(len=17) :: XHead
real(kind=wp), allocatable :: DLT(:)

! Return if nothing to do.
! ------------------------

if (nShell < 0) return

! Set up bins.
! ------------

StpSiz = 0.1_wp
Bin(1) = One
do iBin=2,lBin
  Bin(iBin) = Bin(iBin-1)*StpSiz
end do

! Density.
! --------

lDLT = nShell*(nShell+1)/2
call mma_allocate(DLT,lDLT,label='LTDen')
call Sq2Tri(Den,DLT,nShell)
write(DHead,'(A34,I2)') 'Histogram of density matrix , sym.',iSym
call Cho_Head(DHead,'=',80,u6)
call Cho_Anasize(DLT,lDlt,Bin,lBin,u6)
call mma_deallocate(DLT)

if (nOrb >= 1) then

  ! Original MOs.
  ! -------------

  write(CHead,'(A18,I2)') 'Original MOs, sym.',iSym
  call Cho_Head(CHead,'=',80,u6)
  do i=1,nOrb
    write(u6,'(/,2X,A,I5)') 'Original MO no.',i
    call Cho_Anasize(CMO(1,i),nShell,Bin,lBin,u6)
  end do

  ! Local MOs.
  ! ----------

  write(XHead,'(A15,I2)') 'Local MOs, sym.',iSym
  call Cho_Head(XHead,'=',80,u6)
  do i=1,nOrb
    write(u6,'(/,2X,A,I5)') 'Local MO no.',i
    call Cho_Anasize(XMO(1,i),nShell,Bin,lBin,u6)
  end do

end if

end subroutine Anasize_Localisation

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2017, Ignacio Fdez. Galvan                             *
!***********************************************************************
!
! Isotope numbers and masses
!
! Each item in the the array ElementList contains data for an element:
!  - %Symbol: symbol
!  - %Natural: number of natural ocurring isotopes
!  - %Isotopes: array with all the isotopes for the element, sorted
!               by order of abundance (most to least, artificial
!               sorted by increasing mass number); elements with no
!               natural isotopes have the most stable first. Each item
!               in this array contains:
!    - %A: mass number (protons + neutrons)
!    - %m: isotopic mass in Da
!
! The "default" isotope for each element is simply the first item in
! the %Isotopes member.

module Isotopes

use stdalloc, only: mma_Allocate, mma_Deallocate
use Definitions, only: wp, iwp, u6

implicit none
private
type Iso_t
  integer(kind=iwp) :: A
  real(kind=wp) :: m
end type Iso_t
type Element_t
  character(len=2) :: Symbol
  integer(kind=iwp) :: Natural
  type(Iso_t), allocatable :: Isotopes(:)
end type Element_t
integer(kind=iwp), parameter :: MaxAtomNum = 118
type(Element_t), allocatable :: ElementList(:)
character(len=2), parameter :: PTab(0:MaxAtomNum) = [' X', &
                                                     ' H','He','Li','Be',' B',' C',' N',' O',' F','Ne', &
                                                     'Na','Mg','Al','Si',' P',' S','Cl','Ar',' K','Ca', &
                                                     'Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn', &
                                                     'Ga','Ge','As','Se','Br','Kr','Rb','Sr',' Y','Zr', &
                                                     'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn', &
                                                     'Sb','Te',' I','Xe','Cs','Ba','La','Ce','Pr','Nd', &
                                                     'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb', &
                                                     'Lu','Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg', &
                                                     'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th', &
                                                     'Pa',' U','Np','Pu','Am','Cm','Bk','Cf','Es','Fm', &
                                                     'Md','No','Lr','Rf','Db','Sg','Bh','Hs','Mt','Ds', &
                                                     'Rg','Cn','Nh','Fl','Mc','Lv','Ts','Og' &
                                                    ]
#include "constants2.fh"

interface Isotope
  module procedure Isotope_sym, Isotope_num
end interface Isotope

protected :: ElementList
public :: MaxAtomNum, Isotope, ElementList, Initialize_Isotopes, Free_Isotopes, NuclideMass, PTab

! Private extensions to mma interfaces

interface cptr2loff
  module procedure elm_cptr2loff
  module procedure iso_cptr2loff
end interface
interface mma_Allocate
  module procedure element_mma_allo_1D, element_mma_allo_1D_lim
  module procedure isotope_mma_allo_1D, isotope_mma_allo_1D_lim
end interface
interface mma_Deallocate
  module procedure element_mma_free_1D
  module procedure isotope_mma_free_1D
end interface

contains

! This subroutine allocates and fills the data in ElementList
! Since each array has a different size, it has to be done dynamically

subroutine Initialize_Isotopes()
  use Constants, only: Zero, One
  use Definitions, only: u6
  integer(kind=iwp) :: Err, i, Lu_iso, Most, NumElem, NumIso, NumNat, n1, n2
  logical(kind=iwp) :: Found
  character(len=180) :: Line
  character(len=20) :: Word
  real(kind=wp), allocatable :: Swap(:), Tab(:,:), Tmp(:,:)
  character(len=*), parameter :: ISODATA_NAME = 'ISODATA'
  integer(kind=iwp), external :: IsFreeUnit
# ifdef _GARBLE_
  interface
    subroutine c_null_alloc(A)
      import :: Iso_t
      type(Iso_t), allocatable :: A(:)
    end subroutine c_null_alloc
  end interface
# endif

  if (allocated(ElementList)) return
  call mma_Allocate(ElementList,MaxAtomNum,'ElmList')
# ifdef _GARBLE_
  ! Garbling corrupts the allocation status of allocatable components, use a hack to reset it
  do NumElem=1,size(ElementList,1)
    call c_null_alloc(ElementList(NumElem)%Isotopes)
  end do
# endif

# include "macros.fh"
  unused_proc(mma_allocate(ElementList,[0,0]))
  unused_proc(mma_allocate(ElementList(0)%Isotopes,[0,0]))

  call f_Inquire(ISODATA_NAME,Found)
  if (.not.Found) then
    write(u6,*) 'Isotope: The isotope data file does not exist'
    call abend()
  end if
  Lu_iso = IsFreeUnit(10)
  call molcas_open(Lu_iso,ISODATA_NAME)

  ! The data is read from the ISODATA file (see that file for source)

  ! guess for max isotopes per element: 10
  ! but don't worry, it will be increased when needed
  call mma_allocate(Tab,3,10,label='Tab')
  call mma_allocate(Swap,3,label='Swap')

  NumElem = 0
  NumIso = 0
  NumNat = 0
  Most = 0
  do
    read(Lu_iso,'(A)',iostat=Err) Line
    if (Err < 0) then
      exit
    else if (Err > 0) then
      write(u6,*) 'Isotope: Error reading the isotope data file'
      call abend()
    end if
    if ((Line(1:1) == '#') .or. (Line == '')) cycle
    ! A new element starts with the atomic number in columns 1:3
    read(Line(1:3),*,iostat=Err) i
    if (Err == 0) then
      if ((i < lbound(ElementList,1)) .or. (i > ubound(ElementList,1))) then
        write(u6,*) 'Isotope: Error reading the isotope data file'
        write(u6,*) 'Num: ',i
        call abend()
      end if
      NumElem = i
      if (allocated(ElementList(NumElem)%Isotopes)) then
        write(u6,*) 'Isotope: Error reading the isotope data file'
        write(u6,*) 'Duplicate: ',NumElem
        call abend()
      end if
      ! Columns 47:51 may contain the most stable isotope between brackets
      Word = Line(47:51)
      n1 = index(Word,'[')
      n2 = index(Word,']')
      if ((n1 > 0) .and. (n2 > 0)) then
        read(Word(n1+1:n2-1),*,iostat=Err) Most
        if (Err /= 0) then
          write(u6,*) 'Isotope: Error reading the isotope data file'
          write(u6,*) 'Word: ',Word
          call abend()
        end if
      else
        Most = 0
      end if
      NumIso = 0
      NumNat = 0
      Tab(:,:) = Zero
    else if (NumElem == 0) then
      cycle
    end if
    ! When all the isotopes for an element have been read, store them
    if (Line(1:1) == '_') then
      ElementList(NumElem)%Symbol = adjustl(PTab(NumElem))
      ElementList(NumElem)%Natural = NumNat
      call mma_Allocate(ElementList(NumElem)%Isotopes,NumIso)
      do i=1,NumIso
        ElementList(NumElem)%Isotopes(i) = Iso_t(nint(Tab(1,i)),Tab(2,i))
      end do
      cycle
    end if
    ! Now reading the data for each isotope
    NumIso = NumIso+1
    ! Increase the Tab size if needed
    if (NumIso > size(Tab,2)) then
      call mma_allocate(Tmp,size(Tab,1),2*size(Tab,2),label='Tmp')
      Tmp(:,:size(Tab,2)) = Tab
      Tmp(:,size(Tab,2)+1) = Zero
      call mma_deallocate(Tab)
      call move_alloc(Tmp,Tab)
    end if
    ! Columns 9:11 contain the mass number
    read(Line(9:11),*,iostat=Err) i
    if (Err /= 0) then
      write(u6,*) 'Isotope: Error reading the isotope data file'
      write(u6,*) 'Num: ',i
      call abend()
    end if
    Tab(1,NumIso) = real(i,kind=wp)
    ! Columns 14:31 contain the mass (with uncertainty)
    ! NB: nint(%m) should equal to %A, but you never know...
    Word = Line(14:31)
    n1 = index(Word,'(')
    if (n1 > 0) Word = Word(1:n1-1)
    read(Word,*,iostat=Err) Tab(2,NumIso)
    if (Err /= 0) then
      write(u6,*) 'Isotope: Error reading the isotope data file'
      write(u6,*) 'Word: ',Word
      call abend()
    end if
    ! Columns 33:46 may contain the abundance (with uncertainty)
    Word = Line(33:46)
    if (Word == '') then
      if (nint(Tab(1,NumIso)) == Most) then
        ! assign a small non-zero abundance to the most stable isotope
        Tab(3,NumIso) = tiny(Tab)
      else
        Tab(3,NumIso) = -One
      end if
    else
      n1 = index(Word,'(')
      if (n1 > 0) Word = Word(1:n1-1)
      read(Word,*,iostat=Err) Tab(3,NumIso)
      if (Err /= 0) then
        write(u6,*) 'Isotope: Error reading the isotope data file'
        write(u6,*) 'Word: ',Word
        call abend()
      end if
      if (Tab(3,NumIso) > Zero) NumNat = NumNat+1
    end if
    ! sort this isotope by order of abundance
    do i=1,NumIso-1
      if (Tab(3,NumIso) > Tab(3,i)) then
        Swap(:) = Tab(:,NumIso)
        Tab(:,i+1:NumIso) = Tab(:,i:NumIso-1)
        Tab(:,i) = Swap
        exit
      end if
    end do
  end do

  call mma_deallocate(Tab)
  call mma_deallocate(Swap)

  close(Lu_iso)

end subroutine Initialize_Isotopes

! This subroutine frees up the memory

subroutine Free_Isotopes()
  integer(kind=iwp) :: i
  if (.not. allocated(ElementList)) return
  do i=1,size(ElementList,1)
    call mma_Deallocate(ElementList(i)%Isotopes)
  end do
  call mma_Deallocate(ElementList)
end subroutine Free_Isotopes

! Subroutine(s) to get the Mass of the isotope IsNr belonging to the
! element Atom. If IsNr=0, the most abundant isotope (or the most
! stable if all are radioactive) is selected. The mass is returned
! in atomic units (m_e).
! Atom can be an atomic symbol or an atomic number.

subroutine Isotope_sym(IsNr,Atom,Mass)
  integer(kind=iwp), intent(inout) :: IsNr
  character(len=2), intent(in) :: Atom
  real(kind=wp), intent(out) :: Mass
  integer(kind=iwp) :: i, This
  character(len=2) :: Sym, Sym2

  call Initialize_Isotopes()

  Sym2 = adjustl(Atom)
  call UpCase(Sym2)
  if ((Sym2 == 'D') .or. (Sym2 == 'T')) Sym2 = 'H'
  This = 0
  do i=1,MaxAtomNum
    Sym = adjustl(ElementList(i)%Symbol)
    call UpCase(Sym)
    if (Sym == Sym2) then
      This = i
      exit
    end if
  end do

  if (This == 0) then
    write(u6,*) 'Isotope: Did not find atom!'
    write(u6,*) 'Atom=',Atom
    call Abend()
  end if

  if (IsNr == 0) IsNr = ElementList(This)%Isotopes(1)%A
  if (Sym2 == 'D') IsNr = 2
  if (Sym2 == 'T') IsNr = 3
  do i=1,size(ElementList(This)%Isotopes,1)
    if (ElementList(This)%Isotopes(i)%A == IsNr) then
      Mass = uToau*ElementList(This)%Isotopes(i)%m
      return
    end if
  end do

  write(u6,*) 'Isotope: Did not find isotope!'
  write(u6,*) 'IsNr=',IsNr
  write(u6,*) 'Atom=',Atom
  call Abend()

end subroutine Isotope_sym

subroutine Isotope_num(IsNr,Atom,Mass)
  integer(kind=iwp), intent(inout) :: IsNr
  integer(kind=iwp), intent(in) :: Atom
  real(kind=wp), intent(out) :: Mass
  integer(kind=iwp) :: i

  call Initialize_Isotopes()

  if ((Atom < 0) .or. (Atom > MaxAtomNum)) then
    write(u6,*) 'Isotope: Did not find atom!'
    write(u6,*) 'Atom=',Atom
    call Abend()
  end if

  if (IsNr == 0) IsNr = ElementList(Atom)%Isotopes(1)%A
  do i=1,size(ElementList(Atom)%Isotopes,1)
    if (ElementList(Atom)%Isotopes(i)%A == IsNr) then
      Mass = uToau*ElementList(Atom)%Isotopes(i)%m
      return
    end if
  end do

  write(u6,*) 'Isotope: Did not find isotope!'
  write(u6,*) 'IsNr=',IsNr
  write(u6,*) 'Atom=',Atom
  call Abend()

end subroutine Isotope_num

! Function that returns the mass in atomic units (m_e) of a particular
! nuclide with Z protons and A-Z neutrons. Returns -1.0 if the nuclide
! is unknown.

function NuclideMass(Z,A)
  use Constants, only: One
  real(kind=wp) :: NuclideMass
  integer(kind=iwp), intent(in) :: Z, A
  integer(kind=iwp) :: i

  call Initialize_Isotopes()

  NuclideMass = -One
  if ((Z < 1) .or. (Z > MaxAtomNum)) return
  do i=1,size(ElementList(Z)%Isotopes,1)
    if (ElementList(Z)%Isotopes(i)%A == A) then
      NuclideMass = uToau*ElementList(Z)%Isotopes(i)%m
      exit
    end if
  end do

end function NuclideMass

! Private extensions to mma_interfaces, using preprocessor templates
! (see src/mma_util/stdalloc.f)

! Define elm_cptr2loff, element_mma_allo_1D, element_mma_allo_1D_lim, element_mma_free_1D
#define _TYPE_ type(element_t)
#  define _FUNC_NAME_ elm_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ element_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'elm_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

! Define iso_cptr2loff, isotope_mma_allo_1D, isotope_mma_allo_1D_lim, isotope_mma_free_1D
#define _TYPE_ type(iso_t)
#  define _FUNC_NAME_ iso_cptr2loff
#  include "cptr2loff_template.fh"
#  undef _FUNC_NAME_
#  define _SUBR_NAME_ isotope_mma
#  define _DIMENSIONS_ 1
#  define _DEF_LABEL_ 'iso_mma'
#  include "mma_allo_template.fh"
#  undef _SUBR_NAME_
#  undef _DIMENSIONS_
#  undef _DEF_LABEL_
#undef _TYPE_

end module Isotopes

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1994-1997, Jeppe Olsen                            *
!               2012, Giovanni Li Manni                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADAST_GAS(IOBSM,IOBTP,NIGRP,IGRP,ISPGPSM,I1,XI1S,NKSTR,KACT,SCLFAC,IAC)
! Obtain creation or annihilation mapping
!
! IAC = 2 : Creation map
! a+IORB !KSTR> = +/-!ISTR>
!
! IAC = 1 : Annihilation map
! a IORB !KSTR> = +/-!ISTR>
!
! for orbitals of symmetry IOBSM and type IOBTP
! and Istrings defined by the NIGRP groups IGRP and symmetry ISPGPSM
!
! The results are given in the form
! I1(KSTR,IORB) =  ISTR if A+IORB !KSTR> = +/-!ISTR>
! (numbering relative to TS start)
! Above +/- is stored in XI1S
!
! if some nonvanishing excitations were found, KACT is set to 1,
! else it is zero
!
!
! Jeppe Olsen, Winter of 1991
!              January 1994 : modified to allow for several orbitals
!              August 95    : GAS version
!              October 96   : Improved version
!              September 97 : annihilation mappings added
!                             I groups defined by IGRP
!
! Giovanni Li Manni, February 2012
! Smart Loop over symmetry distributions
! in order to make the code faster

use Symmetry_Info, only: Mul
use lucia_data, only: IBGPSTR, IGSFGP, IOBPTS, ISMDFGP, ISMSCR, ISTAC, ISTSGP, LOFFI, MXPNGAS, MXPNSMST, NACTSYM, NELFGP, NGPSTR, &
                      NGRP, NIRREP, NOBPT, NOBPTS, NSTSGP, STSTM
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IOBSM, IOBTP, NIGRP, IGRP(NIGRP), ISPGPSM, IAC
integer(kind=iwp), intent(inout) :: I1(*)
real(kind=wp), intent(inout) :: XI1S(*)
integer(kind=iwp), intent(out) :: NKSTR, KACT
real(kind=wp), intent(in) :: SCLFAC
integer(kind=iwp) :: I, IACGAS, IACGRP, IACIST(MXPNSMST), IACSM, IBORBSP, IBORBSPS, IBSTRINI, IDELTA, IEC, IGAS, IIAC, &
                     IISTSGP(MXPNSMST,MXPNGAS), IKAC, ISAVE, ISMFGS(MXPNGAS), JGRP, KACGRP, KFIRST, KGRP(MXPNGAS), KSM, KSTRBS, &
                     LROW_IN, MNVLI(MXPNGAS), MXVLI(MXPNGAS), NACIST(MXPNSMST), NELB, NGASL, NIAC, NIEL, NIGASL, NKAC, NKDIST, &
                     NKEL, NKSD, NNSTSGP(MXPNSMST,MXPNGAS), NONEW, NORBT, NORBTS, NSTA, NSTB, NSTRIK
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IORB, IORBR
#endif
integer(kind=iwp), allocatable :: IOFFI(:)
integer(kind=iwp), external :: IOFF_SYM_DIST

! Will be stored as a matrix of dimension
! (NKSTR,*), Where NKSTR is the number of K-strings of
! correct symmetry . Nk is provided by this routine.

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ===================='
write(u6,*) ' ADAST_GAS in service'
write(u6,*) ' ===================='
write(u6,*)
write(u6,*) 'GAS space (IOBTP), Symm of it (IOBSM) :',IOBTP,IOBSM
write(u6,*) ' Supergroup in action :'
write(u6,'(A,I3  )') ' Number of active spaces ',NIGRP
write(u6,'(A,20I3)') ' The active groups       ',(IGRP(I),I=1,NIGRP)
write(u6,*) '  Symmetry of supergroup : ',ISPGPSM
write(u6,*) ' SCLFAC = ',SCLFAC
if (IAC == 1) then
  write(u6,*) ' Annihilation mapping'
else if (IAC == 2) then
  write(u6,*) ' Creation mapping'
else
  write(u6,*) ' Unknown IAC parameter in ADAST ',IAC
  call SYSABENDMSG('lucia_util/adast_gas','Internal error','')
end if
#endif
! A few preparations
NORBTS = NOBPTS(IOBTP,IOBSM)
NORBT = NOBPT(IOBTP)
IACGAS = IOBTP
! First orbital of given GASpace
IBORBSP = sum(NOBPT(1:IOBTP-1))+1
! First orbital of given GASpace and Symmetry
IBORBSPS = IOBPTS(IOBTP,IOBSM)
#ifdef _DEBUGPRINT_
write(u6,*) ' NORBTS per GAS and sym          :',NORBTS
write(u6,*) ' NORBT per GAS                   :',NORBT
write(u6,*) ' IACGAS GAS involved             :',IACGAS
write(u6,*) ' IBORBSP 1st orb per GAS         :',IBORBSP
write(u6,*) ' IBORBSPS 1st orb per GAS and sym:',IBORBSPS
#endif

!===================================================
! K strings : Supergroup, symmetry and distributions
!===================================================
if (IAC == 1) then
  IDELTA = +1
else
  IDELTA = -1
end if
! Is required mapping contained within current set of maps?
! a:) Is active GASpace included in IGRP - must be
IACGRP = 0
do JGRP=1,NIGRP
  if (IGSFGP(IGRP(JGRP)) == IACGAS) IACGRP = JGRP
end do
! Note : IACGRP is not the actual active group, it is the address of the
!        active group in IGRP
if (IACGRP == 0) then
  write(u6,*) ' ADAST in problems'
  write(u6,*) ' Active GASpace not included in IGRP'
  write(u6,*) ' Active GASpace : ',IACGAS
  write(u6,'(A,20I3)') ' The active groups       ',(IGRP(I),I=1,NIGRP)
  call SYSABENDMSG('lucia_util/adast_gas','Internal error','')
end if
! b:) active group in K strings
NIEL = NELFGP(IGRP(IACGRP))
NKEL = NIEL+IDELTA
#ifdef _DEBUGPRINT_
write(u6,*) ' NIEL and NKEL ',NIEL,NKEL
#endif
if ((NKEL == -1) .or. (NKEL == NOBPT(IACGAS)+1)) then
  ! No strings with this number of elecs - be happy : No work
  NKSTR = 0
  KACT = 0
  KACGRP = 0
else
  ! Find group with NKEL electrons in IACGAS
  KACGRP = 0
  do JGRP=IBGPSTR(IACGAS),IBGPSTR(IACGAS)+NGPSTR(IACGAS)-1
    if (NELFGP(JGRP) == NKEL) KACGRP = JGRP
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) ' KACGRP = ',KACGRP
# endif
  ! KACGRP is the Active group itself
  if (KACGRP == 0) then
    write(u6,*) ' ADAST : cul de sac, active K group not found'
    write(u6,*) ' GAS space and number of electrons ',IACGAS,NKEL
    call SYSABENDMSG('lucia_util/adast_gas','Internal error','')
  end if
  ! Okay active K group was found and is nontrivial
  KSM = Mul(IOBSM,ISPGPSM)
  ! The K supergroup
  KGRP(1:NIGRP) = IGRP(:)
  KGRP(IACGRP) = KACGRP
  ! Number of strings and symmetry distributions of K strings
  call NST_SPGRP(NIGRP,KGRP,KSM,NSTSGP,NIRREP,NKSTR,NKDIST)
# ifdef _DEBUGPRINT_
  write(u6,*) 'KSM,NKSTR,NKDIST:',KSM,NKSTR,NKDIST
# endif
  if (NKSTR /= 0) then
    ! Last active space in K strings and number of strings per group and sym
    NGASL = 1
    do JGRP=1,NIGRP
      if (NELFGP(KGRP(JGRP)) > 0) NGASL = JGRP
      NNSTSGP(1:NIRREP,JGRP) = NSTSGP((KGRP(JGRP)-1)*NIRREP+1:KGRP(JGRP)*NIRREP)
      IISTSGP(1:NIRREP,JGRP) = ISTSGP((KGRP(JGRP)-1)*NIRREP+1:KGRP(JGRP)*NIRREP)
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) 'NGASL',NGASL
#   endif
    ! MIN/MAX for Kstrings
    !call MINMAX_FOR_SYM_DIST(NIGRP,KGRP,MNVLK,MXVLK,NKDIST_TOT)
#   ifdef _DEBUGPRINT_
    !write(u6,*) 'MNVLK and MXVLK'
    !call IWRTMA(MNVLK,1,NIGRP,1,NIGRP)
    !call IWRTMA(MXVLK,1,NIGRP,1,NIGRP)
#   endif
    ! (NKDIST_TOT is number of distributions, all symmetries)
    ! =========
    ! I Strings
    ! =========
    call mma_allocate(IOFFI,LOFFI,label='IOFFI')
    ! Generate symmetry distributions of I strings with given symmetry
    call TS_SYM_PNT2(IGRP,NIGRP,MXVLI,MNVLI,ISPGPSM,IOFFI,LOFFI)
    ! Offset and dimension for active group in I strings
    IACIST(1:NIRREP) = ISTSGP((IGRP(IACGRP)-1)*NIRREP+1:IGRP(IACGRP)*NIRREP)
    NACIST(1:NIRREP) = NSTSGP((IGRP(IACGRP)-1)*NIRREP+1:IGRP(IACGRP)*NIRREP)
    ! Last entry in IGRP with a nonvanisking number of strings
    NIGASL = 1
    do JGRP=1,NIGRP
      if (NELFGP(IGRP(JGRP)) > 0) NIGASL = JGRP
    end do
    ! Number of electrons before active space
    NELB = 0
    do JGRP=1,IACGRP-1
      NELB = NELB+NELFGP(IGRP(JGRP))
    end do
#   ifdef _DEBUGPRINT_
    write(u6,*) ' NELB = ',NELB
#   endif
    I1(1:NORBTS*NKSTR) = 0
    ! Loop over symmetry distribtions of K strings
    KFIRST = 1
    KSTRBS = 1
    ISMFGS(1:NIGRP) = 1
    do
      !GLM if (KFIRST == 1) ISMFGS(1:NIGRP) = MNVLI(IGAS)
      ! Next distribution
      call NEXT_SYM_DISTR_NEW(NIRREP,NGRP,KGRP,NIGRP,ISMFGS,KSM,KFIRST,NONEW,ISMDFGP,NACTSYM,ISMSCR)
      !GLM   if (NONEW == 1) exit
      !GLM end if
#     ifdef _DEBUGPRINT_
      write(u6,*) ' Symmetry distribution'
      call iwrtma(ISMFGS,1,NIGRP,1,NIGRP)
#     endif
      if (NONEW == 1) exit
      KFIRST = 0
      ! Number of strings of this symmetry distribution
      NSTRIK = 1
      do IGAS=1,NGASL
        NSTRIK = NSTRIK*NNSTSGP(ISMFGS(IGAS),IGAS)
      end do
      ! Offset for corresponding I strings
      ISAVE = ISMFGS(IACGRP)
      IACSM = Mul(IOBSM,ISMFGS(IACGRP))
      ISMFGS(IACGRP) = IACSM
      IBSTRINI = IOFF_SYM_DIST(ISMFGS,NIGASL,IOFFI,MXVLI,MNVLI)
      !write(u6,*) 'IBSTRINI :',IBSTRINI
      ISMFGS(IACGRP) = ISAVE
      ! Number of strings before active GAS space
      NSTB = 1
      !do IGAS=1,IOBTP-1
      do IGAS=1,IACGRP-1
        NSTB = NSTB*NNSTSGP(ISMFGS(IGAS),IGAS)
      end do
      ! Number of strings After active GAS space
      NSTA = 1
      !do IGAS=IOBTP+1,NIGRP
      do IGAS=IACGRP+1,NIGRP
        NSTA = NSTA*NNSTSGP(ISMFGS(IGAS),IGAS)
      end do
      ! Number and offset for active group
      NIAC = NACIST(IACSM)
      IIAC = IACIST(IACSM)
      NKAC = NNSTSGP(ISMFGS(IACGRP),IACGRP)
      IKAC = IISTSGP(ISMFGS(IACGRP),IACGRP)
      ! I and K strings of given symmetry distribution
      NKSD = NSTB*NKAC*NSTA
#     ifdef _DEBUGPRINT_
      write(u6,*) ' nstb nsta niac nkac ',nstb,nsta,niac,nkac
#     endif
      ! Obtain annihilation/creation mapping for all strings of this type
      ! Are group mappings in expanded or compact form
      if ((IAC == 1) .and. (ISTAC(KACGRP,2) == 0)) then
        IEC = 2
        LROW_IN = NKEL
      else
        IEC = 1
        LROW_IN = NORBT
      end if

      if (NSTA*NSTB*NIAC*NKAC /= 0) &
        call ADAST_GASSM(NSTB,NSTA,IKAC,IIAC,IBSTRINI,KSTRBS,STSTM(KACGRP,1)%A,STSTM(KACGRP,2)%A,IBORBSPS,IBORBSP,NORBTS,NKAC, &
                         NIAC,NKSTR,NELB,I1,XI1S,SCLFAC,IAC,LROW_IN,IEC)
      KSTRBS = KSTRBS+NKSD
    end do

    call mma_deallocate(IOFFI)
  end if
end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from ADAST_GAS'
write(u6,*) ' ====================='
write(u6,*) ' Total number of K strings ',NKSTR
if (NKSTR /= 0) then
  do IORB=IBORBSPS,IBORBSPS+NORBTS-1
    IORBR = IORB-IBORBSPS+1
    write(u6,*) ' Info for orbital ',IORB
    write(u6,*) ' Excited strings and sign'
    call IWRTMA(I1((IORBR-1)*NKSTR+1),1,NKSTR,1,NKSTR)
    call WRTMAT(XI1S((IORBR-1)*NKSTR+1),1,NKSTR,1,NKSTR)
  end do
end if
#endif

end subroutine ADAST_GAS

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MXMNOC_SPGP(  MINEL,  MAXEL, NORBTP,NORBFTP, NELFTP,
     &                           NTESTG)
*
* Construct accumulated MAX and MIN arrays for a GAS supergroup
*
      IMPLICIT REAL*8           ( A-H,O-Z)
*. Output
      DIMENSION  MINEL(*),MAXEL(*)
*. Input
      INTEGER NORBFTP(*),NELFTP(*)
*
* Some dummy initializations
      IORB_START = 1 ! jwk-cleanup
*
      NTESTL = 00
      NTEST = MAX(NTESTG,NTESTL)
*
      IF(NTEST.GE.100) THEN
        WRITE(6,*)
        WRITE(6,*) ' ==========='
        WRITE(6,*) ' MXMNOC_SPGP'
        WRITE(6,*) ' ==========='
        WRITE(6,*)
C?      WRITE(6,*) ' NORBFTP : '
C?      CALL IWRTMA(NORBFTP,1,NORBTP,1,NORBTP)
      END IF
*
      DO IORBTP = 1, NORBTP
*. Max and min at start of this type and at end of this type
        IF(IORBTP.EQ.1) THEN
          IORB_START = 1
          IORB_END = NORBFTP(1)
          NEL_START = 0
          NEL_END   = NELFTP(1)
        ELSE
          IORB_START =  IORB_START + NORBFTP(IORBTP-1)
          IORB_END   =  IORB_START + NORBFTP(IORBTP)-1
          NEL_START = NEL_END
          NEL_END   = NEL_START + NELFTP(IORBTP)
        END IF
        IF(NTEST.GE.1000) THEN
          WRITE(6,*) ' IORBTP,IORB_START-IORB_END,NEL_START,NEL_END '
          WRITE(6,*)   IORBTP,IORB_START-IORB_END,NEL_START,NEL_END
        END IF
*
        DO IORB = IORB_START, IORB_END
          MAXEL(IORB) = MIN(IORB,NEL_END)
          MINEL(IORB) = NEL_START
          IF(NEL_END-MINEL(IORB).GT. IORB_END-IORB)
     &    MINEL(IORB) = NEL_END - ( IORB_END - IORB )
        END DO
      END DO
*
      IF( NTEST .GE. 100 ) THEN
        NORB = IELSUM(NORBFTP,NORBTP)
        WRITE(6,*) ' MINEL : '
        CALL IWRTMA(MINEL,1,NORB,1,NORB)
        WRITE(6,*) ' MAXEL : '
        CALL IWRTMA(MAXEL,1,NORB,1,NORB)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine OLagFro1(NBSQT,nOLag,DPT2,OLag)

use caspt2_global, only: FIFA_all
use caspt2_module, only: NBAS, NDEL, NFRO, NISH, NSYM
use Constants, only: Zero, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NBSQT, nOLag
real(kind=wp), intent(inout) :: DPT2(NBSQT), OLag(nOLag)
integer(kind=iwp) :: iMO, iOrb, iSym, jOrb, nBasI, nFroI, nIshI, nOrbI
real(kind=wp) :: Tmp

iMO = 1
do iSym=1,nSym
  nOrbI = nBas(iSym)-nDel(iSym)
  nFroI = nFro(iSym)
  if ((nOrbI > 0) .and. (nFroI > 0)) then
    nIshI = nIsh(iSym)
    nBasI = nBas(iSym)
    !! Make sure that the frozen orbital derivative is zero
    !! (it does not appear in the PT2 energy)
    OLag(1:nOrbI*nFroI) = Zero
    do iOrb=1,nFroI
      do jOrb=nFroI+1,nFroI+nIshI
        Tmp = -Half*(OLag(iMO+iOrb-1+nOrbI*(jOrb-1))-OLag(iMO+jOrb-1+nOrbI*(iOrb-1)))/ &
              (FIFA_all(iOrb+nBasI*(iOrb-1))-FIFA_all(jOrb+nBasI*(jOrb-1)))
        DPT2(iMO+iOrb-1+nOrbI*(jOrb-1)) = DPT2(iMO+iOrb-1+nOrbI*(jOrb-1))+Tmp
        DPT2(iMO+jOrb-1+nOrbI*(iOrb-1)) = DPT2(iMO+jOrb-1+nOrbI*(iOrb-1))+Tmp
      end do
    end do
  end if
  iMO = iMO+nOrbI*nOrbI
end do
!write(u6,*) 'DPT2 after frozen orbital'
!call sqprt(dpt2,nbast)

end subroutine OLagFro1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine SOS(iStabO,nStabO,lOper)
************************************************************************
*                                                                      *
* Object: to generate the stabilizer S for the operator O.             *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             February '91                                             *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChTbl, iOper
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Integer iStabO(8)
*
#ifdef _DEBUGPRINT_
      Write (6,*) ' In SOS'
      Write (6,*) ' lOper=',lOper
      Do 1 iS = 0, nIrrep-1
         Write(6,'(8I5)') (iChTbl(iIrrep,iS),iIrrep=0,nIrrep-1)
 1    Continue
#endif
      If (lOper.lt.0.or.lOper.gt.255) Then
         Call WarningMessage(2,'SOS: Symmetry label is corrupted.')
         Write (6,*) 'lOper=',lOper
         Call Abend()
      End If
      nStabO = 0
      Do 10 iS = 0, nIrrep-1
         Do 20 iIrrep = 0, nIrrep-1
            If (iAnd(lOper,2**iIrrep).eq.0) Go To 20
            If (iChTbl(iIrrep,iS).ne.1) Go To 10
 20      Continue
         nStabO = nStabO + 1
         iStabO(nStabO) = iOper(iS)
 10   Continue
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine priwel(k,alfa,beta,r0,a,gri,nz,isum,grin)
      Implicit Real*8(A-H,O-Z)
#include "real.fh"
#include "welcom.fh"
      Real*8 gri(nz,isum), grin(nz,0:k,k/2+1,k/4+1), alfa(nz), a(nz)
      Integer iv(kmax)
*
*     iQ = 1
      Call binte(k,alfa,beta,r0,a,grin,nz)
*     Call RecPrt(' In PriWel: Grin',' ',Grin,nz,(k+1)*(k/2+1)*(k/4+1))
*
c.....distribute the integrals into gri
*
      indst=1
      isum=ipot3(k+1)
      Do 115 iz=1,nz
         gri(iz,1)=grin(iz,0,1,1)
 115  Continue
      if (k.eq.0) Go To 99
      Do 10 i=1,k
         ipot3i=ipot3(i)
         call dcopy_(iPot3i*nz,[Zero],0,gri(1,indst+1),1)
         Do 11 j=1,ipot3i
            jj=j
            Do 12 l=i,1,-1
               idiv=ipot3(l-1)
               ixyz=(jj-1)/idiv+1
               iv(l)=ixyz
               jj=jj-(ixyz-1)*idiv
12          Continue
*
c.....the potency vector for this integral is now ready
c .....now analyze it
*
            ix=0
            iy=0
            iz=0
            Do 13 l=1,i
               if(iv(l).eq.1)ix=ix+1
               if(iv(l).eq.2)iy=iy+1
               if(iv(l).eq.3)iz=iz+1
 13         Continue
            ix2=(ix/2)*2
            if(ix2.ne.ix) go to 11
            iy2=(iy/2)*2
            if(iy2.ne.iy)go to 11
            ixs=max(ix,iy)
            iys=min(ix,iy)
            ixys=(ixs+iys)/2+1
            iys=iys/2+1
            Do 14 mz=1,nz
               gri(mz,j+indst)=grin(mz,i,ixys,iys)
 14         Continue
 11      Continue
         indst=indst+ipot3i
 10   Continue
 99   Continue
*     Call RecPrt(' In PriWel:gri',' ',gri,nz,isum)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Ext_L1(V1,V2,no,dima,dimc,adda,nbs)
! this routine does:
! V2(i,a',m') <- V1(p,q,m')

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: no, dima, dimc, adda, nbs
real(kind=wp), intent(in) :: V1(nbs,nbs,dimc)
real(kind=wp), intent(out) :: V2(no,dima,dimc)

V2(:,:,:) = V1(1:no,adda+1:adda+dima,:)

return

end subroutine Ext_L1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dBPrint(nQQ,nDim)

use Slapaf_Info, only: dBM, idBM, mq, nqBM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nQQ, nDim
integer(kind=iwp) :: i_Dim, idB, iElem, iq, iQQ, jDim, nElem
real(kind=wp) :: dBqR, rK
real(kind=wp), allocatable :: dBQQ(:,:), K(:,:)

if (.not. allocated(dBM)) return
call mma_allocate(dBQQ,nDim,nDim,Label='dBQQ')
call mma_allocate(K,mq,nQQ,Label='K')
call Get_dArray('K',K,mq*nQQ)
do iQQ=1,nQQ
  dBQQ(:,:) = Zero
  idB = 1
  do iq=1,mq
    nElem = nqBM(iq)
    rK = K(iq,iQQ)
    do iElem=idB,idB+(nElem**2)-1
      dBqR = dBM(iElem)
      i_Dim = idBM(1+(iElem-1)*2)
      jDim = idBM(2+(iElem-1)*2)
      dBQQ(i_Dim,jDim) = dBQQ(i_Dim,jDim)+rK*dBqR
    end do
    idB = idB+nElem**2
  end do
  call RecPrt('dBQQ',' ',dBQQ,nDim,nDim)
end do
call mma_deallocate(dBQQ)
call mma_deallocate(K)

return

end subroutine dBPrint

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine rad2_molcas( a,          ccr,        ipt,        kcrl,
     &                 kcru,       l,          lambu,      lmahi,
     &                 lmalo,      lmbhi,      lmblo,      ltot1,
     &                 ncr,        qsum,       rka,        rkb,
     &                 zcr,        lit,        ljt,        ca,
     &                 cb,         tai,        taj,        aa,
     &                 aarr2,      fctr2 )
c
c  compute type 2 radial integrals.
c
c  28-nov-90 new version replaced old version. -rmp
c  19-jan-97 put bessel formula into a separate subroutine, qbess. -rmp
c
      implicit real*8 (a-h,o-z)
      parameter (a0=0.0d0, eps1=1.0d-15, a1=1.0d0, a2=2.0d0,
     1  a4=4.0d0, a50=50.0d0)
      dimension a(*), ccr(*), ipt(*), ncr(*), qsum(ltot1,lambu,*),
     &  zcr(*)
c
      tol=20.*log(10.d0)
      call wzero(ltot1*lambu*lmahi,qsum,1)
c     # sum over potential terms
      do 68 kcr=kcrl,kcru
      npi=ncr(kcr)
      alpha=aa+zcr(kcr)
      rc=(rka+rkb)/(alpha+alpha)
      arc2=alpha*rc*rc
      dum=aarr2+zcr(kcr)*arc2/aa
      if(dum.gt.tol) go to 68
      prd=fctr2*ccr(kcr)*exp(-dum)
c
      if(rka.eq.a0.and.rkb.eq.a0) then
c       # rka=0 and rkb=0
        rk=a0
        t=a0
        qsum(ltot1,1,1)=qsum(ltot1,1,1)+prd*
     &             qcomp(alpha,a(ipt(11)),npi+ltot1-1,0,t,rk)
      elseif(rka.eq.a0) then
c       # rka=0 and rkb>0
        rk=rkb
        t=arc2
        do 12 lamb=l,lmbhi
          qsum(lamb-l+lit,lamb,1)=qsum(lamb-l+lit,lamb,1)+prd*
     1             qcomp(alpha,a(ipt(11)),npi+lamb-l+lit-1,lamb-1,t,rk)
   12   continue
      elseif(rkb.eq.a0) then
c       # rka>0 and rkb=0
        rk=rka
        t=arc2
        do 16 lama=l,lmahi
          qsum(lama-l+ljt,1,lama)=qsum(lama-l+ljt,1,lama)+prd*
     1             qcomp(alpha,a(ipt(11)),npi+lama-l+ljt-1,lama-1,t,rk)
   16   continue
      elseif(npi.eq.2) then
c       # rka>0 and rkb>0; use bessel function formula.
c       # to be applicable for a set of integrals, must have nu.le.l and
c       # nu.eq.(integer), where nu=l+1-npi/2, so it is used here only
c       # for the npi=2 case.  It can't be used at all for npi=(odd) and
c       # only for partial sets for npi=0
        nu=l
            call qbess( alpha,      a(ipt(40)), a(ipt(41)), a(ipt(42)),
     &      a(ipt(12)), a(ipt(43)), a(ipt(44)), a(ipt(45)), a(ipt(11)),
     &      l,          lambu,      lmahi,      lmbhi,      ltot1,
     &      nu,         prd,        qsum,       rka,        rkb,
     &      a(ipt(46)) )
      elseif(arc2.ge.a50) then
c       # rka>0 and rkb>0; use pts and wts method
c       # estimate radial integrals and compare to threshold
        qlim=abs(prd)/(max(a1,(rc+rc)*rka)*max(a1,(rc+rc)*rkb))*
     1    sqrt(a4*(tai+tai)**lit*(taj+taj)**ljt*sqrt(tai*taj)/alpha)
        if(rc.lt.ca) then
          nlim=npi
          qlim=qlim*ca**(lit-1)
        else
          nlim=npi+(lit-1)
        endif
        if(rc.lt.cb) then
          qlim=qlim*cb**(ljt-1)
        else
          nlim=nlim+(ljt-1)
        endif
        if(qlim*rc**nlim.ge.eps1) then
          call ptwt(a(ipt(47)),arc2,a(ipt(48)),a(ipt(11)),npi,l,lambu,
     &      ltot1,lmahi,lmbhi,alpha,a(ipt(49)),a(ipt(50)),rc,rka,rkb,
     &      prd,a(ipt(9)),a(ipt(10)),qsum)
        endif
      else
c       # rka>0 and rkb>0; use partially asymptotic method
        call qpasy(alpha,a(ipt(11)),npi,l,lambu,lmahi,lmbhi,ltot1,rka,
     &    rkb,fctr2*ccr(kcr),dum+arc2,qsum)
      endif
   68 continue
c
      if(rka.eq.a0.and.rkb.ne.a0) then
c       # rka=0 and rkb>0
        f2lmb3=dble(2*lmbhi-3)
        do 76 lamb=lmbhi-2,lmblo,-1
          nlo=abs(lamb-l+1)+lit+1
          nhi=ljt-mod((ljt-1)-abs(lamb-l),2)+lit-1
          do 72 n=nlo,nhi,2
            qsum(n,lamb,1)=qsum(n,lamb+2,1)+
     &                     (f2lmb3/rkb)*qsum(n-1,lamb+1,1)
   72     continue
          f2lmb3=f2lmb3-a2
   76   continue
      elseif(rka.ne.a0.and.rkb.eq.a0) then
c       # rka>0 and rkb=0
        f2lma3=dble(2*lmahi-3)
        do 84 lama=lmahi-2,lmalo,-1
          nlo=abs(lama-l+1)+ljt+1
          nhi=lit-mod((lit-1)-abs(lama-l),2)+ljt-1
          do 80 n=nlo,nhi,2
            qsum(n,1,lama)=qsum(n,1,lama+2)+
     &                     (f2lma3/rka)*qsum(n-1,1,lama+1)
   80     continue
          f2lma3=f2lma3-a2
   84   continue
      elseif(rka.ne.a0.and.rkb.ne.a0) then
c       # rka>0 and rkb>0
        f2lma3=dble(lmahi+lmahi+1)
        do 96 lama=lmahi,lmalo,-1
          ldifa1=abs(l-lama)+1
          f2lmb3=dble(2*lmbhi+1)
          do 92 lamb=lmbhi,lmblo,-1
            ldifb=abs(l-lamb)
            nlo=ldifa1+ldifb
            nhi=(ltot1-mod(lit-ldifa1,2))-mod((ljt-1)-ldifb,2)
            do 88 n=nlo,nhi,2
              if(n-(lama+lamb).eq.(1-l-l)) go to 88
              if(lama.gt.(lmahi-2).or.n.le.(abs(l-lama-2)+ldifb)) then
c               # lamb recursion
                qsum(n,lamb,lama)=qsum(n,lamb+2,lama)+
     1                            (f2lmb3/rkb)*qsum(n-1,lamb+1,lama)
              else
c               # lama recursion
                qsum(n,lamb,lama)=qsum(n,lamb,lama+2)+
     1                            (f2lma3/rka)*qsum(n-1,lamb,lama+1)
              endif
   88       continue
            f2lmb3=f2lmb3-a2
   92     continue
          f2lma3=f2lma3-a2
   96   continue
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Markus P. Fuelscher                              *
*               2014, Ignacio Fdez. Galvan (modified from RecPrt)      *
************************************************************************
* SubRecPrt
*
*> @brief
*>   Write out part of a matrix on standard output
*> @author M. P. F&uuml;lscher, Lund, 1992
*> @modified_by Ignacio Fdez. Galv&aacute;n, Uppsala, Feb. 2014 (modified from ::RecPrt)
*>
*> @details
*> The first \p nRowSub rows of a matrix \p A of dimension \p nRow &times; \p nCol are printed
*> in output preceded by the character line \p Title. Format of the numerical
*> output is given by \p FmtIn. If \p FmtIn = ``''`` the utility will decide on format
*> for optimal output.
*>
*> @param[in] Title   Title card
*> @param[in] FmtIn   Format statement
*> @param[in] A       A matrix
*> @param[in] nRow    number of rows of \p A
*> @param[in] nCol    number of columns of \p A
*> @param[in] nRowSub number of rows of \p A to print
*>
*> @see ::RecPrt
************************************************************************
      Subroutine SubRecPrt(Title,FmtIn,A,nRow,nCol,nRowSub)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Print a rectangular submatrix                                    *
*                                                                      *
*     calling arguments                                                *
*     Title  : character string containing a title                     *
*              If the string is empty no title will be printed         *
*     A      : rectangular matrix of double precision reals            *
*     nRow   : row dimension of matrix A                               *
*     nCol   : column dimension of matrix A                            *
*     nRowSub: number of rows of A to print                            *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher                                                  *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     Feb. 2014: Modified from RecPrt                                  *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "standard_iounits.fh"
      Character*(*) Title
      Character*(*) FmtIn
      Dimension A(nRow,nCol)
      Integer StrnLn
      Parameter (lPaper=120,lMaxTitle=60)
      Character*(lMaxTitle) Line
      Character*20 FMT
*----------------------------------------------------------------------*
      If (nRowSub*nCol.eq.0) Return
#ifdef _DEBUGPRINT_
      Call TrcPrt(Title,FmtIn,A,nRow,nCol)
      Return
#endif
*----------------------------------------------------------------------*
*     print the title                                                  *
*----------------------------------------------------------------------*
      lTitle=StrnLn(Title)
      If ( lTitle.gt.0 ) then
         Do 10 i=1,lMaxTitle
             Line(i:i)=' '
10       Continue
         lLeft=1
         Do 20 i=lTitle,1,-1
            If ( Title(i:i).ne.' ' ) lLeft=i
20       Continue
         lLeft=lLeft-1
         Do 25 i=1,lMaxTitle
            If ( i+lLeft.le.lTitle ) Line(i:i)=Title(i+lLeft:i+lLeft)
25       Continue
         Write(LuWr,*)
         Write(LuWr,'(2X,A)') Line
c         Do 30 i=1,StrnLn(Line)
c            Line(i:i)='-'
c30       Continue
c         Write(LuWr,'(2X,A)') Line
         Write(LuWr,'(2X,A,I5,A,I5)') 'mat. size = ',nRowSub,'x',nCol
      End If
*----------------------------------------------------------------------*
*     determine the printing format                                    *
*----------------------------------------------------------------------*
      lFmt=Strnln(FmtIn)
      If ( lFmt.ne.0 ) then
         FMT=FmtIn
      Else
         Amax=A(1,1)
         Amin=A(1,1)
         Do 40 j=1,nCol
            Do 50 i=1,nRowSub
               Amax=Max(Amax,A(i,j))
               Amin=Min(Amin,A(i,j))
50          Continue
40       Continue
         Pmax=0.0D0
         If ( Abs(Amax).gt.1.0D-72 ) Pmax=Log10(Abs(Amax))
         iPmax=1+INT(Pmax)
         iPmax=Max(1,iPmax)
         Pmin=0.0D0
         If ( Abs(Amin).gt.1.0D-72 ) Pmin=Log10(Abs(Amin))
         iPmin=1+INT(Pmin)
         iPmin=Max(1,iPmin)
         nDigit=14
         nDecim=Min(8,nDigit-Max(iPmin,iPmax))
         nDecim=Max(nDecim,1)
         If ( Amax.lt.0.0D0 ) iPmax=iPmax+1
         If ( Amin.lt.0.0D0 ) iPmin=iPmin+1
         lNumbr=Max(iPmin,iPmax)+nDecim+2
         nCols=10
         lLine=nCols*lNumbr
         If ( lLine.gt.lPaper ) then
            If ( lLine.le.lPaper+nCols .and. nDecim.gt.1 ) then
               nDecim=nDecim-1
               lNumbr=Max(iPmin,iPmax)+nDecim
               lItem=Max(lNumbr,lPaper/nCols)
            Else
               nCols=5
               lItem=Max(lNumbr,lPaper/nCols)
            End If
         Else
            lItem=lNumbr
         End If
         Write(FMT,'(A,   I4.4,  A, I4.4,  A, I4.4,   A)')
     &             '(2X,',nCols,'F',lItem,'.',nDecim,')'
      End if
*----------------------------------------------------------------------*
*     print the data                                                   *
*----------------------------------------------------------------------*
c      Write(LuWr,*)
      Do 60 i=1,nRowSub
         Write(LuWr,FMT)(A(i,j),j=1,nCol)
60    Continue
*----------------------------------------------------------------------*
*     End procedure                                                    *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine read_formatted_aniso_poly_NEW(input_file_name,nss,nstate,eso,MM,MS,iReturn)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, cZero, auTocm
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
character(len=180), intent(in) :: input_file_name
integer(kind=iwp), intent(inout) :: nss, nstate
real(kind=wp), intent(out) :: eso(nss)
complex(kind=wp), intent(out) :: MM(3,nss,nss), MS(3,nss,nss)
integer(kind=iwp), intent(out) :: iReturn
integer(kind=iwp) :: LuAniso
real(kind=wp), allocatable :: eso_au(:)
complex(kind=wp), allocatable :: MTMP(:,:,:)
#ifdef _DEBUGPRINT_
#  define _DBG_ .true.
integer(kind=iwp) :: i, j, l
#else
#  define _DBG_ .false.
#endif
logical(kind=iwp), parameter :: dbg = _DBG_
integer(kind=iwp), external :: IsFreeUnit

iReturn = 0
MM(:,:,:) = cZero
MS(:,:,:) = cZero
call mma_allocate(eso_au,nss,'eso_au')
eso_au(:) = Zero

LuAniso = IsFreeUnit(81)
call molcas_open(LuAniso,input_file_name)

call read_nss(LuAniso,nss,dbg)
#ifdef _DEBUGPRINT_
write(u6,*) 'read_formatted_aniso_poly_NEW: nss=',nss
#endif
call read_nstate(LuAniso,nstate,dbg)
#ifdef _DEBUGPRINT_
write(u6,*) 'read_formatted_aniso_poly_NEW: nstate=',nstate
#endif
call read_eso(LuAniso,nss,eso_au,dbg)
#ifdef _DEBUGPRINT_
write(u6,*) 'read_formatted_aniso_poly_NEW: eso_au=',(eso_au(i),i=1,nss)
#endif
call mma_allocate(MTMP,3,nss,nss)
call read_magnetic_moment(LuAniso,nss,MTMP,dbg)
MM(:,1:nss,1:nss) = MTMP(:,:,:)
#ifdef _DEBUGPRINT_
write(u6,*) 'Call read_spin_moment'
call xFlush(u6)
#endif
call read_spin_moment(LuAniso,nss,MTMP,dbg)
MS(:,1:nss,1:nss) = MTMP(:,:,:)
call mma_deallocate(MTMP)

! compute the relative spin-orbit energies in cm-1
eso(:) = (eso_au(:)-eso_au(1))*auTocm
call mma_deallocate(eso_au)
close(LuAniso)

#ifdef _DEBUGPRINT_
write(u6,*) 'read_formatted_aniso_poly_NEW:  nss: ',nss
write(u6,*) 'read_formatted_aniso_poly_NEW:   MM: '
do l=1,3
  write(u6,'(A,I0)') 'projection: L=',l
  do i=1,nss
    write(u6,'(10(2F8.4,2x))') (MM(l,i,j),j=1,nss)
  end do
end do

write(u6,*) 'read_formatted_aniso_poly_NEW:   MS'
do l=1,3
  write(u6,'(A,I0)') 'projection: L=',l
  do i=1,nss
    write(u6,'(10(2F8.4,2x))') (MS(l,i,j),j=1,nss)
  end do
end do
#endif

return

end subroutine read_formatted_aniso_poly_NEW

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Kap_CI(h1,nh1,h2,nh2,ipS1)
      use ipPage, only: W
      Implicit Real*8(a-h,o-z)

#include "real.fh"
#include "Input.fh"
#include "Pointers.fh"
#include "stdalloc.fh"
      Real*8, Allocatable :: R(:,:)
      Real*8 h1(nh1), h2(nh2)
      Real*8 rDum(1)
*                                                                      *
************************************************************************
*                                                                      *
       Interface
       SubRoutine CISigma_sa(iispin,iCsym,iSSym,Int1,nInt1,Int2s,nInt2s,
     &                       Int2a,nInt2a,ipCI1,ipCI2, Have_2_el)
       Integer iispin, iCsym, iSSym
       Integer nInt1, nInt2s, nInt2a
       Real*8, Target:: Int1(nInt1), Int2s(nInt2s), Int2a(nInt2a)
       Integer ipCI1, ipCI2
       Logical Have_2_el
       End SubRoutine CISigma_sa
       End Interface
*                                                                      *
************************************************************************
*                                                                      *
      Call CISigma_sa(0,state_sym,state_sym,h1,nh1,h2,nh2,rdum,1,ipCI,
     &                ipS1,.True.)

      irc=ipin(ipS1)
      irc=ipin(ipCI)

      Call DSCAL_(nroots*ncsf(STATE_SYM),Two,W(ipS1)%Vec,1)
      Call mma_allocate(R,[0,nroots-1],[0,nroots-1],label='R')

      Do i=0,nroots-1
       Do j=0,nroots-1
        R(i,j)=ddot_(nconf1,W(ipS1)%Vec(1+nconf1*i),1,
     &                     W(ipCI)%Vec(1+nconf1*j),1)
       End Do
      End Do

      Do i=0,nroots-1
       Do j=0,nroots-1
       call daxpy_(nconf1,-R(i,j),
     &                   W(ipCI)%Vec(1+i*nconf1),1,
     *                   W(ipS1)%Vec(1+j*nconf1),1)
       End Do
      End Do

      Call mma_deallocate(R)

      Return
#ifdef _WARNING_WORKAROUND_
      If (.False.) Call Unused_integer(irc)
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Jonas Bostrom                                    *
************************************************************************
      Subroutine Compute_B_1(irc,jDen,jSym,kSym,lSym,jVec1,nVec,
     &                       nBasFnc)
******************************************************************
*                                                                *
*     Author Jonas Bostrom, June 2010                            *
*                                                                *
*     Purpose: To pickup C_lk^J for a specific J from disk and   *
*              Rectangularize.                                   *
*                                                                *
******************************************************************

      Implicit Real*8 (a-h,o-z)
#include "exterm.fh"
#include "chomp2g_alaska.fh"
#include "WrkSpc.fh"

      If(imp2prpt .eq. 2) Then
         lBVec = nBasFnc*nBasFnc*nVec
         Do i = 1, 2
            iAdr = 1 + nBasFnc*nBasFnc*(jVec1-1)
            Call dDaFile(LuBVector(i),2,Work(ip_B_mp2(i)),lBVec,iAdr)
         End Do
      End If

      lCVec = nIJR(kSym,lSym,1)*nVec
      iAdr = nIJR(kSym,lSym,1)*(jVec1-1) + iAdrCVec(jSym,kSym,jDen)
      Call dDaFile(LuCVector(jSym,jDen),2,Work(ip_CijK),lCVec,iAdr)
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(irc)
      End
*
******************************************************************
******************************************************************
******************************************************************
*
      Subroutine Compute_B_2(irc,lSOl,jVec1,kSym,lSym,nVec)
******************************************************************
*                                                                *
*     Author Jonas Bostrom, June 2010                            *
*                                                                *
*     Purpose: To do the first halftransformation                *
*              Ckl^J -> Cml^J .                                  *
*                                                                *
******************************************************************

      Implicit Real*8 (a-h,o-z)
#include "exterm.fh"
#include "WrkSpc.fh"
*
      ijList(iSym,jSym,i,j) = ipijList + iChOrbR(iSym,jSym,1)
     &                 + i + (j-1)*(nChOrb(iSym-1,1)+1)
*
      jDen = 1
      ipMO = ip_CMOi(jDen) + iOff_CMOi(lSym,jDen) +
     &       (lSOl-1)*nChOrb(lSym-1,jDen)
      ip_CijK_Rec = ip_CijK +
     &              jVec1*nChOrb(lSym-1,jDen)*nChOrb(kSym-1,jDen)
      ip_CmjK = ip_VJ
      Call FZero(Work(ip_CmjK),nChOrb(kSym-1,jDen))
      Do iI = 1, nChOrb(kSym-1,1)
         Do iJ = 1, iWork(ijList(lSym,kSym,0,iI))
            iJ1 = iWork(ijList(lSym,kSym,iJ,iI))
            Work(ip_CmjK+iI-1) = Work(ip_CmjK+iI-1) +
     &           Work(ip_CijK_Rec+iJ1-1 + (iI-1)*nChOrb(lSym-1,1))
     &           * Work(ipMO + iJ1-1)
         End Do
      End Do

c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(irc)
         Call Unused_integer(nVec)
      End If
      End
*
******************************************************************
******************************************************************
******************************************************************
*
      Real*8 Function Compute_B_3(irc,kSym,lSym,kSOk)
******************************************************************
*                                                                *
*     Author Jonas Bostrom, June 2010                            *
*                                                                *
*     Purpose: To do the second halftransformation               *
*              Cmj^K -> Bmd^K .                                  *
*                                                                *
******************************************************************

      Implicit Real*8 (a-h,o-z)
#include "exterm.fh"
#include "WrkSpc.fh"

      jDen = 1
*
      ipMO = ip_CMOi(jDen) + iOff_CMOi(kSym,jDen) +
     &       (kSOk-1)*nChOrb(kSym-1,jDen)
      ip_CmjK = ip_VJ
      Compute_B_3=ddot_(nChOrb(kSym-1,jDen),Work(ipMO),1,
     &                                      Work(ip_CmjK),1)
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(irc)
         Call Unused_integer(lSym)
      End If
      End
*
******************************************************************
******************************************************************
*
      Real*8 Function Compute_B_4(irc,kSOk,lSOl,jAOj,nBasFnc,iOpt)
******************************************************************
*                                                                *
*     Author Jonas Bostrom, June 2010                            *
*                                                                *
*     Purpose: To do part of MP2 gradient.                       *
*                                                                *
******************************************************************
      Implicit Real*8 (a-h,o-z)
#include "exterm.fh"
#include "chomp2g_alaska.fh"
#include "WrkSpc.fh"


      B_mp2 = 0.0d0
      iOff1 = (jAOj)*nBasFnc*nBasFnc + (kSOk-1)*nBasFnc + lSOl-1
      iOff2 = (jAOj)*nBasFnc*nBasFnc + (lSOl-1)*nBasFnc + kSOk-1
      B_mp2 = B_mp2 + (Work(ip_B_mp2(iOpt)+iOff1)+
     &                 Work(ip_B_mp2(iOpt)+iOff2))/2.0d0
      Compute_B_4 = B_mp2
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(irc)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine FIJ_CPF(ICASE,JSY,INDX,C,S,FC,A,B,FK,DBK,ENP,EPP)

use cpf_global, only: IDENS, IRC, IREF0, IROW, ITER, IV0, LSYM, Lu_25, Lu_CIGuga, NNS, NORBT, NVIR
use guga_util_global, only: COP, IAD10, ICOP1, nCOP
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp, r8

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: ICASE(*), JSY(*), INDX(*)
real(kind=wp), intent(inout) :: C(*), S(*), FC(*), FK(*), EPP(*)
real(kind=wp), intent(_OUT_) :: A(*), B(*), DBK(*)
real(kind=wp), intent(in) :: ENP(*)
integer(kind=iwp) :: IADD10, IADD25, IC1, IC2, ICHK, IIN, IK, ILEN, IND, INDA, INDB, INDI, INUM, IVL, NA, NB, NI, NK, NOB2, NS1, &
                     NS1L
real(kind=wp) :: COPI, TERM
integer(kind=iwp), external :: JSUNP
real(kind=r8), external :: DDOT_

IK = 0 ! dummy initialize
NOB2 = IROW(NORBT+1)
!if (IDENS == 1) write(u6,876) (FC(I),I=1,NOB2)
ICHK = 0
if (IDENS /= 1) then
  NOB2 = IROW(NORBT+1)
  IADD25 = 0
  call dDAFILE(Lu_25,2,FC,NOB2,IADD25)
end if
if ((IDENS == 1) .or. (ITER /= 1)) then
  IADD10 = IAD10(8)
  do
    call dDAFILE(Lu_CIGuga,2,COP,nCOP,IADD10)
    call iDAFILE(Lu_CIGuga,2,iCOP1,nCOP+1,IADD10)
    ILEN = ICOP1(nCOP+1)
    if (ILEN == 0) cycle
    if (ILEN < 0) exit
    do IIN=1,ILEN
      IND = ICOP1(IIN)
      if (ICHK == 0) then
        if (IND /= 0) then
          IVL = ibits(IND,0,6)
          IC2 = ibits(IND,6,13)
          IC1 = ibits(IND,19,13)
          COPI = COP(IIN)*FC(IK)
          if (IVL == IV0) then
            if (IC1 == IREF0) then
              if (IDENS /= 1) then
                COPI = COPI/sqrt(ENP(IC2))
                S(IC2) = S(IC2)+COPI
                if (ITER /= 1) EPP(IC2) = EPP(IC2)+COPI*C(IC2)
              else
                FC(IK) = FC(IK)+COP(IIN)*C(IC1)*C(IC2)/ENP(IC2)
              end if
            else if (IC2 == IREF0) then
              if (IDENS /= 1) then
                COPI = COPI/sqrt(ENP(IC1))
                S(IC1) = S(IC1)+COPI
                if (ITER /= 1) EPP(IC1) = EPP(IC1)+COPI*C(IC1)
              else
                FC(IK) = FC(IK)+COP(IIN)*C(IC1)*C(IC2)/ENP(IC1)
              end if
            else if (IDENS /= 1) then
              S(IC1) = S(IC1)+COPI*C(IC2)
              S(IC2) = S(IC2)+COPI*C(IC1)
            else
              FC(IK) = FC(IK)+COP(IIN)*C(IC1)*C(IC2)/(sqrt(ENP(IC1))*sqrt(ENP(IC2)))
            end if
          else
            INDA = IRC(IVL)+IC1
            INDB = IRC(IVL)+IC2
            NA = INDX(INDA)
            NB = INDX(INDB)
            NS1 = JSUNP(JSY,INDA)
            NS1L = MUL(NS1,LSYM)
            INUM = NVIR(NS1L)
            if (IVL >= 2) INUM = NNS(NS1L)
            if (IDENS /= 1) then
              S(NA+1:NA+INUM) = S(NA+1:NA+INUM)+COPI*C(NB+1:NB+INUM)
              S(NB+1:NB+INUM) = S(NB+1:NB+INUM)+COPI*C(NA+1:NA+INUM)
            else
              TERM = DDOT_(INUM,C(NA+1),1,C(NB+1),1)
              FC(IK) = FC(IK)+COP(IIN)*TERM/(sqrt(ENP(INDA))*sqrt(ENP(INDB)))
            end if
          end if
        else
          ICHK = 1
        end if
      else
        ICHK = 0
        INDI = IND
        NI = ibits(INDI,0,10)
        NK = ibits(INDI,10,10)
        IK = IROW(NK)+NI
      end if
    end do
  end do
end if
!if (IDENS == 1) write(u6,876) (FC(I),I=1,NOB2)
call AI_CPF(JSY,INDX,C,S,FC,C,A,B,FK,DBK,ENP,EPP,0)
if (ITER /= 1) call AB_CPF(ICASE,JSY,INDX,C,S,FC,A,B,FK,ENP)

return

!876 format(1X,'FIJ',5F12.6)

end subroutine FIJ_CPF

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mxunfold_cvb(avec,a,n)

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(in) :: avec(n*(n-1))
real(kind=wp), intent(out) :: a(n,n)
integer(kind=iwp) :: i, iprm, j

a(:,:) = Zero
iprm = 0
do i=1,n
  do j=1,n
    if (j /= i) then
      iprm = iprm+1
      a(j,i) = avec(iprm)
    end if
  end do
end do

return

end subroutine mxunfold_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine NEWSCTAB(MINOP,MAXOP,MLTPL,MS2,ICASE)

use rassi_global_arrays, only: SPNTAB1, SPNTAB2, TRANS1, TRANS2
use stdalloc, only: mma_allocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: MINOP, MAXOP, MLTPL, MS2, ICASE
integer(kind=iwp) :: IBLK, IOPEN, KSPCPL, KSPDET, LTRANS, LTRANS0, NA, NB, NBLK, NCP, ND, NSPCPL, NSPDET, NTAB, NTRANS
integer(kind=iwp), pointer :: SPNTAB(:)
real(kind=wp), pointer :: TRANS(:)
integer(kind=iwp), parameter :: ASPIN = 1, BSPIN = 0, DWNCPL = 0, NULLPTR = -1, UPCPL = 1
integer(kind=iwp), external :: NGENE, NOVERM

if ((MLTPL-MS2 < 1) .or. (MLTPL+MS2 < 1)) then
  write(u6,*) 'NewSCTab: Contradictory values of MLTPL vs. MS2.'
  write(u6,*) 'The function was invoked with the following arguments:'
  write(u6,'(1X,A,I9)') ' MINOP:',MINOP
  write(u6,'(1X,A,I9)') ' MAXOP:',MAXOP
  write(u6,'(1X,A,I9)') ' MLTPL:',MLTPL
  write(u6,'(1X,A,I9)') ' MS2  :',MS2
  call ABEND()
end if

! Run through construction loop twice. First get size of table
! and total nr of transformation coefficients:
NSPCPL = 0
NSPDET = 0
NTRANS = 0
IBLK = 0
do IOPEN=MINOP,MAXOP
  IBLK = IBLK+1
  NCP = NGENE(IOPEN,MLTPL)
  if (NCP == 0) cycle
  NA = (IOPEN+MS2)/2
  ND = NOVERM(IOPEN,NA)
  NSPCPL = NSPCPL+IOPEN*NCP
  NSPDET = NSPDET+IOPEN*ND
  NTRANS = NTRANS+ND*NCP
end do
NBLK = IBLK
NTAB = 8+6*NBLK+NSPCPL+NSPDET
! The spincoupling table will be NTAB integers long, and there
! will be NTRANS spin-coupling coefficients (real*8).
! The table consists of 8 header words, then an array (6,NBLK)
! with pointers and sizes to the spin coupling, spin determinant
! and spin-coupling coefficient arrays, and finally the
! spin coupling and spin determinant arrays themselves.
! The transformation coefficients are real*8 data and stored
! in a separate array.
select case (ICASE)
  case (1)
    call mma_allocate(SPNTAB1,NTAB,Label='SPNTAB1')
    SPNTAB => SPNTAB1(:)
    call mma_allocate(TRANS1,NTRANS,Label='TRANS1')
    TRANS => TRANS1(:)
  case (2)
    call mma_allocate(SPNTAB2,NTAB,Label='SPNTAB2')
    SPNTAB => SPNTAB2(:)
    call mma_allocate(TRANS2,NTRANS,Label='TRANS2')
    TRANS => TRANS2(:)
  case default
    call Abend()
    SPNTAB => SPNTAB1(:) !dummy
    TRANS => TRANS1(:) !dummy
end select
KSPCPL = 9+6*NBLK
KSPDET = KSPCPL+NSPCPL
! Table size
SPNTAB(1) = NTAB
! Table type identifier
SPNTAB(2) = 47
! Spin multiplicity
SPNTAB(3) = MLTPL
! Spin projection
SPNTAB(4) = MS2
! Min and max nr of open shells
SPNTAB(5) = MINOP
SPNTAB(6) = MAXOP
! Associated workspace array for Re*8 data (transf matrices)
SPNTAB(7) = -1 ! not used
SPNTAB(8) = NTRANS
! Individual information for each separate nr of open shells:
NTAB = 6
NTRANS = 0
IBLK = 0
LTRANS0 = 1
LTRANS = 1
do IOPEN=MINOP,MAXOP
  IBLK = IBLK+1
  NCP = NGENE(IOPEN,MLTPL)
  NA = (IOPEN+MS2)/2
  NB = IOPEN-NA
  if (NCP > 0) then
    ND = NOVERM(IOPEN,NA)
    SPNTAB(9+(IBLK-1)*6) = IOPEN
    SPNTAB(10+(IBLK-1)*6) = NCP
    SPNTAB(11+(IBLK-1)*6) = ND
    ! Compute spin couplings:
    call PROTOCSF(IOPEN,MLTPL,NCP,SPNTAB(KSPCPL:))
    SPNTAB(12+(IBLK-1)*6) = KSPCPL
    ! Compute spin determinants:
    call PROTOSD(NA,NB,ND,SPNTAB(KSPDET:))
    SPNTAB(13+(IBLK-1)*6) = KSPDET
    ! Compute spin coupling coefficients:
    call PROTOT(IOPEN,ND,SPNTAB(KSPDET:),NCP,SPNTAB(KSPCPL:),TRANS(LTRANS:))
    SPNTAB(14+(IBLK-1)*6) = LTRANS-LTRANS0+1
    KSPCPL = KSPCPL+IOPEN*NCP
    KSPDET = KSPDET+IOPEN*ND
    LTRANS = LTRANS+ND*NCP
  else
    SPNTAB(9+(IBLK-1)*6) = IOPEN
    SPNTAB(10+(IBLK-1)*6) = 0
    SPNTAB(11+(IBLK-1)*6) = 0
    SPNTAB(12+(IBLK-1)*6) = NULLPTR
    SPNTAB(13+(IBLK-1)*6) = NULLPTR
    SPNTAB(14+(IBLK-1)*6) = NULLPTR
  end if
end do

nullify(TRANS,SPNTAB)

end subroutine NEWSCTAB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TransNow(V,S)

use FFPT_Global, only: nBas, TranCoo, ComStk, ComVal
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(inout) :: V(nBas(1)*(nBas(1)+1)/2)
real(kind=wp), intent(in) :: S(nBas(1)*(nBas(1)+1)/2)
integer(kind=iwp) :: i, iXYZ, j, kaunter
real(kind=wp) :: Trana

!-- Be informative.

if (ComStk(2,1,1,0)) then
  write(u6,*)
  write(u6,*) '    The DIPO perturbation is translated.'
else
  write(u6,*)
  write(u6,*) '    No translation of the perturbation (only implemented for DIPO.'
  write(u6,*) 'OBSERVE! Your result can be origo dependent!'
end if

!-- Translate the perturbation. Why, oh why, is the sign of Trana
!   the opposite of what it should be according to the formula?
!   Answer: Our charge is positive in the MLTPL integrals, hence
!   the field strength should be of opposite sign, see ptdipo.f
!   for example. Hence the minus in the translation formula becomes
!   a plus. Oh yeah!

if ((.not. ComStk(2,1,1,1)) .and. (.not. ComStk(2,1,1,2)) .and. (.not. ComStk(2,1,1,3))) then
  write(u6,*)
  write(u6,*) 'A strange error has occured. ComStk modified?'
  call Abend()
end if
kaunter = 1
!write(u6,*) 'TranCoo',(TranCoo(i),i=1,3)
do i=1,nBas(1)
  do j=1,i
    do iXYZ=1,3
      if (ComStk(2,1,1,iXYZ)) then
        Trana = ComVal(2,1,1,iXYZ)*TranCoo(iXYZ)*S(kaunter)
        !-----Sign of Trana? See source code comment above.
        V(kaunter) = V(kaunter)+Trana
      end if
    end do
    kaunter = kaunter+1
  end do
end do

return

end subroutine TransNow

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine IndSft_Cho_Diag(TInt,nInt,
     &                   iCmp,iShell,iBas,jBas,kBas,lBas,
     &                   Shijij, iAO, iAOst, ijkl,SOint,nSOint,
     &                   iSOSym,nSOs)
************************************************************************
*  object: to sift and index the SO integrals.                         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          april '90                                                   *
*                                                                      *
************************************************************************
      use Symmetry_Info, only: nIrrep
      use SOAO_Info, only: iAOtSO, iOffSO
      use ChoArr, only: iSOShl, iShlSO, nBstSh
      use sort_data, only: nSkip
      Implicit Real*8 (A-H,O-Z)
#include "cholesky.fh"
#include "real.fh"
#include "print.fh"
*
      Real*8 SOint(ijkl,nSOint), TInt(nInt)
      Integer iCmp(4), iShell(4), iAO(4), iAOst(4), iSOSym(2,nSOs)
      Logical Shijij, Shij, Shkl, qijij, qij, qkl
*     local array
      Integer iSym(0:7), jSym(0:7), kSym(0:7), lSym(0:7)
      Data tr1,tr2/0.0d0,0.0d0/
      Save tr1,tr2

      external ddot_
*
*     statement function
*
      iTri(i,j)=Max(i,j)*(Max(i,j)-3)/2 + i + j
*
      irout = 39
      jprint = nprint(irout)
      k12=0
      k34=0
      If (jPrint.ge.49) Then
         r1=DDot_(ijkl*nSOInt,SOInt,1,[One],0)
         r2=DDot_(ijkl*nSOInt,SOInt,1,SOInt,1)
         tr1=tr1+r1
         tr2=tr2+r2
         Write (6,*) ' Sum=',r1,tr1
         Write (6,*) ' Dot=',r2,tr2
      End If
      If (jprint.ge.99)
     &   Call RecPrt(' in indsft:SOint ',' ',SOint,ijkl,nSOint)
      memSO2 = 0
*
*     allocate space to store integrals to gether with their
*     Symmetry batch and sequence number
*     To avoid conflicts in using memory this is done in the
*     subroutine PSOAO
*
*
*     quadruple loop over elements of the basis functions angular
*     description. loops are reduced to just produce unique SO integrals
*     observe that we will walk through the memory in AOint in a
*     sequential way.
*
      Shij = iShell(1).eq.iShell(2)
      Shkl = iShell(3).eq.iShell(4)
      Do 100 i1 = 1, iCmp(1)
         Do 101 j = 0, nIrrep-1
            ix = 0
            If (iAOtSO(iAO(1)+i1,j)>0) ix = 2**j
            iSym(j) = ix
101      Continue
         jCmpMx = iCmp(2)
         If (Shij) jCmpMx = i1
         Do 200 i2 = 1, jCmpMx
            Do 201 j = 0, nIrrep-1
               ix = 0
               If (iAOtSO(iAO(2)+i2,j)>0) ix = 2**j
               jSym(j) = ix
201         Continue
            qij = i1.eq.i2
            If (iShell(2).gt.iShell(1)) then
               i12 = iCmp(2)*(i1-1) + i2
            else
               i12 = iCmp(1)*(i2-1) + i1
            End If
            Do 300 i3 = 1, iCmp(3)
               Do 301 j = 0, nIrrep-1
                  ix = 0
                  If (iAOtSO(iAO(3)+i3,j)>0) ix = 2**j
                  kSym(j) = ix
301            Continue
               lCmpMx = iCmp(4)
               If (Shkl) lCmpMx = i3
               Do 400 i4 = 1, lCmpMx
                  Do 401 j = 0, nIrrep-1
                     ix = 0
                     If (iAOtSO(iAO(4)+i4,j)>0) ix = 2**j
                     lSym(j) = ix
401               Continue
                  qkl = i3.eq.i4
                  If (iShell(4).gt.iShell(3)) then
                     i34 = iCmp(4)*(i3-1) + i4
                  else
                     i34 = iCmp(3)*(i4-1) + i3
                  End If
                  If (Shijij .and. i34.gt.i12) go to 400
                  qijij = Shijij .and. i12.eq.i34
*
*      loop over Irreps which are spanned by the basis function.
*      again, the loop structure is restricted to ensure unique
*      integrals.
*
       Do 110 j1 = 0, nIrrep-1
          If (iSym(j1).eq.0) go to 110
          j2max = nIrrep-1
          If (Shij .and. qij) j2max = j1
          Do 210 j2 = 0, j2max
             If (jSym(j2).eq.0) go to 210
             j12 = ieor(j1,j2)
             If (qijij) then
                If (Shij .and. qij) then
                    k12 = j1*(j1+1)/2 + j2+1
                else If (Shij) then
                    k12 = nIrrep*j1 + j2+1
                else If (iShell(1).gt.iShell(2)) then
                    k12 = nIrrep*j1 + j2+1
                else
                    k12 = nIrrep*j2 + j1+1
                End If
             End If
*
             Do 310 j3 = 0, nIrrep-1
                If (kSym(j3).eq.0) go to 310
                j4 = ieor(j12,j3)
                If (lSym(j4).eq.0) go to 310
                If (Shkl .and. qkl .and. j4.gt.j3) go to 310
                If (qijij) then
                   If (Shkl .and. qkl) then
                      k34 = j3*(j3+1)/2 + j4+1
                   else If (Shkl) then
                      k34 = nIrrep*j3 + j4+1
                   else If (iShell(3).gt.iShell(4)) then
                      k34 = nIrrep*j3 + j4+1
                   else
                      k34 = nIrrep*j4 + j3+1
                   End If
                   If (k34.gt.k12) go to 310
                End If
*
                memSO2 = memSO2 + 1
                If ( (nSkip(j1+1)+nSkip(j2+1)+
     &                nSkip(j3+1)+nSkip(j4+1) ).ne.0 ) GoTo 310
*
*               Compute absolute starting SO index
                iSO = iAOtSO(iAO(1)+i1,j1)+iAOst(1)+iOffSO(j1)
                jSO = iAOtSO(iAO(2)+i2,j2)+iAOst(2)+iOffSO(j2)
                kSO = iAOtSO(iAO(3)+i3,j3)+iAOst(3)+iOffSO(j3)
                lSO = iAOtSO(iAO(4)+i4,j4)+iAOst(4)+iOffSO(j4)
*
                nijkl = 0
                Do lSOl = lSO, lSO+lBas-1
                   Do kSOk = kSO, kSO+kBas-1
                      iSOkl=iTri(kSOk,lSOl)
                      Do jSOj = jSO, jSO+jBas-1
                         Do iSOi = iSO, iSO+iBas-1
                            nijkl = nijkl + 1
                            iSOij=iTri(iSOi,jSOj)
*
                            If (iSOij.eq.iSOkl) Then
                               ISHLI = ISOSHL(ISOI)
                               ISHLJ = ISOSHL(JSOJ)
                               NUMI  = NBSTSH(ISHLI)
                               NUMJ  = NBSTSH(ISHLJ)
                               IF (ISHLI.EQ.ISHLJ.AND.ISHLI.EQ.SHA) THEN
                                  KIJ = ITRI(ISHLSO(ISOI),ISHLSO(JSOJ))
                               ELSE
                                 IF (ISHLI.EQ.SHA.AND.ISHLJ.EQ.SHB)
     &                           THEN
                                    KIJ = NUMI*(ISHLSO(JSOJ) - 1)
     &                                  + ISHLSO(ISOI)
                                 ELSE IF (ISHLJ.EQ.SHA.AND.ISHLI.EQ.SHB)
     &                           THEN
                                    KIJ = NUMJ*(ISHLSO(ISOI) - 1)
     &                                  + ISHLSO(JSOJ)
                                 ELSE
                                    CALL CHO_QUIT('Integral error',104)
                                    KIJ = -999999
                                 END IF
                               END IF
                               TInt(KIJ)=SOint(nijkl,memSO2)
                            End If
*
                         End Do
                      End Do
                   End Do
                End Do
*
310          Continue
210       Continue
110    Continue
*
400            Continue
300         Continue
200      Continue
100   Continue
*
      Return
* Avoid unused argument warnings
      If (.False.) Call Unused_integer_array(iSOSym)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mktau(wrk,wrksize,t2,t1a,t1b,fact,rc)
! this routine does:
! t2(abij) = t2(abij) + fact. (t1(ai).t1(bj)-t1(bi).t1(aj))
! N.B. T24a,4b must be of type 4, T2abab of type 0
!
! t2   - map type of T2 (I)
! t1a  - map type of T1aa (I)
! t1b  - map type of T1bb (I)
! fact - numerical factor (I)
! rc   - return (error) code

use ccsd_global, only: Map_Type, noa, nob, nva, nvb
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: t2, t1a, t1b
real(kind=wp), intent(in) :: fact
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: dima, dimab, dimb, dimi, dimij, dimj, iit11, iit12, iit1a, iit1b, iit2, post11, post12, post1a, post1b, &
                     post2, syma, symb, symi, symj

rc = 0

if (t2%d(0,6) == 0) then
  !I.1 T2abab case

  do iit2=1,t2%d(0,5)

    post2 = t2%d(iit2,1)
    syma = t2%d(iit2,3)
    symb = t2%d(iit2,4)
    symi = t2%d(iit2,5)
    symj = t2%d(iit2,6)
    dima = nva(syma)
    dimb = nvb(symb)
    dimi = noa(symi)
    dimj = nob(symj)
    iit1a = t1a%i(syma,1,1)
    iit1b = t1b%i(symb,1,1)
    post1a = t1a%d(iit1a,1)
    post1b = t1b%d(iit1b,1)

    if ((syma == symi) .and. (symb == symj) .and. (t2%d(iit2,2) > 0)) &
      call mktauhelp1(wrk(post2),wrk(post1a),wrk(post1b),dima,dimb,dimi,dimj,fact)

  end do

else if ((t2%d(0,6) == 4) .and. (t2%d(0,1) == 3)) then
  !I.2 T2aaaa case

  do iit2=1,t2%d(0,5)

    post2 = t2%d(iit2,1)
    syma = t2%d(iit2,3)
    symb = t2%d(iit2,4)
    symi = t2%d(iit2,5)
    symj = t2%d(iit2,6)
    dima = nva(syma)
    dimb = nva(symb)
    dimi = noa(symi)
    dimj = noa(symj)
    iit11 = t1a%i(syma,1,1)
    iit12 = t1a%i(symb,1,1)
    post11 = t1a%d(iit11,1)
    post12 = t1a%d(iit12,1)

    if ((syma == symi) .and. (symb == symj) .and. (syma /= symj) .and. (t2%d(iit2,2) > 0)) then
      !I.2.* case T2(sym1,sym2,sym1,sym2)

      call mktauhelp1(wrk(post2),wrk(post11),wrk(post12),dima,dimb,dimi,dimj,fact)

    else if ((syma == symi) .and. (symb == symj) .and. (syma == symj) .and. (t2%d(iit2,2) > 0)) then
      !I.2.* case T2(sym1,sym1,sym1,sym1)

      dimab = (dima*(dima-1))/2
      dimij = (dimi*(dimi-1))/2
      call mktauhelp2(wrk(post2),wrk(post11),dimab,dimij,dima,dimi,fact)

    end if

  end do

else if ((t2%d(0,6) == 4) .and. (t2%d(0,1) == 4)) then
  !I.3 T2bbbb case

  do iit2=1,t2%d(0,5)

    post2 = t2%d(iit2,1)
    syma = t2%d(iit2,3)
    symb = t2%d(iit2,4)
    symi = t2%d(iit2,5)
    symj = t2%d(iit2,6)
    dima = nvb(syma)
    dimb = nvb(symb)
    dimi = nob(symi)
    dimj = nob(symj)
    iit11 = t1b%i(syma,1,1)
    iit12 = t1b%i(symb,1,1)
    post11 = t1b%d(iit11,1)
    post12 = t1b%d(iit12,1)

    if ((syma == symi) .and. (symb == symj) .and. (syma /= symj) .and. (t2%d(iit2,2) > 0)) then
      !I.3.* case T2(sym1,sym2,sym1,sym2)

      call mktauhelp1(wrk(post2),wrk(post11),wrk(post12),dima,dimb,dimi,dimj,fact)

    else if ((syma == symi) .and. (symb == symj) .and. (syma == symj) .and. (t2%d(iit2,2) > 0)) then
      !I.3.* case T2(sym1,sym1,sym1,sym1)

      dimab = (dima*(dima-1))/2
      dimij = (dimi*(dimi-1))/2
      call mktauhelp2(wrk(post2),wrk(post11),dimab,dimij,dima,dimi,fact)

    end if

  end do

else
  !I.4 RC=1 : incorrect %d for T2
  rc = 1
  return
end if

return

end subroutine mktau

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine YouGetThis(nAt,EC,Pot_Expo,Pot_Point,Pot_Fac,Diffed
     &                     ,ipMP,lMax,lMaxF,nij,LuYou)
      Implicit Real*8 (a-h,o-z)

#include "WrkSpc.fh"

      Dimension EC(3,nij),Pot_Expo(nij*4),Pot_Point(nij),Pot_Fac(nij*4)

      Logical Diffed(nij*4)

*
*-- Number of centres and maximal angular momentum.
*
      Write(LuYou,101)nij
      Write(LuYou,102)lMax,lMaxF
      kauntA=0
*
*-- Loop over centres.
*
      Do i=1,nij
        kauntA=kauntA+1
*
*---- Coordinates of centre.
*
        Write(LuYou,103)(EC(k,i),k=1,3)
        kaunt=0
        Do l=0,lMax
          nS=l*(l+1)*(l+2)/6
          nT=(l+1)*(l+2)*(l+3)/6
          If(l.le.lMaxF) then
            If(Diffed(2*(kauntA-1)+l+1)) then
*
*---- Factor and exponent.
*
              Write(LuYou,104)2.0d0*Pot_Expo(2*(kauntA-1)+l+1)
              Write(LuYou,105)(Pot_Fac(4*(kauntA-1)+kk),kk=nS+1,nT)
            Else
*
*---- Factor and dummy-exponent, if this multipole should not be
*     made diffuse.
*

              Write(LuYou,104)-7.91204d0
              Write(LuYou,105)(Pot_Fac(4*(kauntA-1)+kk),kk=nS+1,nT)
            Endif
          Else
*
*---- The pure multipole, which under no circumstance can be diffuse.
*
            Write(LuYou,104)-7.91204d0
            Write(LuYou,105)(Work(ipMP+nij*kk+kauntA-1),kk=nS,nT-1)
          Endif
        Enddo
*
*---- Throw in the point-part.
*
        Write(LuYou,104)Pot_Point(kauntA)
      Enddo

101   Format(I5)
102   Format(2I5)
103   Format(3(F20.14))
104   Format(F20.14)
105   Format(3(F20.14))

      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nAt)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Tranca(Cavxyz,Cavsph,lMax,CarSph)

use Index_Functions, only: nTri_Elem1, nTri3_Elem1
use Real_Spherical, only: ipSph, RSph
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lMax
real(kind=wp), intent(inout) :: Cavxyz(nTri3_Elem1(lMax)), Cavsph((lMax+1)**2)
logical(kind=iwp), intent(in) :: CarSph
integer(kind=iwp) :: iOff1, iOff2, m, nElem

iOff1 = 1
iOff2 = 1
do m=0,lMax
  nElem = nTri_Elem1(m)
  !call RecPrt('Car-->Sph',' ',RSph(ipSph(m)),nElem,nElem)
  if (CarSph) then
    Cavsph(iOff2:iOff2+2*m) = Zero
    !call RecPrt('Cartesian',' ',Cavxyz(iOff1),1,nElem)
    call dGeMV_('T',nElem,2*m+1,One,RSph(ipSph(m)),nElem,Cavxyz(iOff1),1,Zero,CavSph(iOff2),1)
    !call RecPrt('Spherical',' ',Cavsph(iOff2),1,2*m+1)
  else
    Cavxyz(iOff1:iOff1+nElem-1) = Zero
    !call RecPrt('Spherical',' ',Cavsph(iOff2),1,2*m+1)
    call dGeMV_('N',nElem,2*m+1,One,RSph(ipSph(m)),nElem,Cavsph(iOff2),1,Zero,Cavxyz(iOff1),1)
    !call RecPrt('Cartesian',' ',Cavxyz(iOff1),1,nElem)
  end if
  iOff1 = iOff1+nElem
  iOff2 = iOff2+2*m+1
end do

end subroutine Tranca

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine LOOP3(KM,ISTOP,IT1,IT2)

use guga_global, only: BS3, BS4, COUP, IA, IB, ICOUP, ICOUP1, IWAY, IY, J1, J2, K0, K1, K2, K3
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: KM, IT1, IT2
integer(kind=iwp), intent(out) :: ISTOP
integer(kind=iwp) :: IDIF, IWAYKM, KM1

ISTOP = 0
! STOP THE LOOP
KM1 = KM+1
IDIF = IA(J1(KM1))-IA(J2(KM1))
if ((IDIF < 0) .or. (IDIF > 1)) then
  ISTOP = 1
else if (IDIF /= 0) then
  ! CASE E-F
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    IWAY(KM) = 2
    if ((K2(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else
      COUP(KM) = COUP(KM1)
      J2(KM) = K2(IT1+J1(KM1))
      J1(KM) = J2(KM)
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM) = ICOUP(KM1)
    end if
  end if
  if (IWAYKM == 2) then
    IWAY(KM) = 3
    if ((K3(IT1+J1(KM1)) == 0) .or. (K1(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else
      COUP(KM) = COUP(KM1)*BS3(IB(J2(KM1))+1)
      J2(KM) = K3(IT1+J1(KM1))
      J1(KM) = J2(KM)
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),1)
    end if
  end if
  if (IWAYKM == 3) ISTOP = 1
else
  ! CASE G-H
  IWAYKM = IWAY(KM)
  if (IWAYKM == 1) then
    IWAY(KM) = 2
    if ((K1(IT1+J1(KM1)) == 0) .or. (K0(IT2+J2(KM1)) == 0)) then
      IWAYKM = 2
    else
      COUP(KM) = COUP(KM1)
      J2(KM) = K1(IT1+J1(KM1))
      J1(KM) = J2(KM)
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM) = ICOUP(KM1)
    end if
  end if
  if (IWAYKM == 2) then
    IWAY(KM) = 3
    if ((K3(IT1+J1(KM1)) == 0) .or. (K2(IT2+J2(KM1)) == 0)) then
      IWAYKM = 3
    else
      COUP(KM) = COUP(KM1)*BS4(IB(J2(KM1))+1)
      J2(KM) = K3(IT1+J1(KM1))
      J1(KM) = J2(KM)
      ICOUP1(KM) = ICOUP1(KM1)+IY(IT1+J1(KM1),3)
      ICOUP(KM) = ICOUP(KM1)+IY(IT2+J2(KM1),2)
    end if
  end if
  if (IWAYKM == 3) ISTOP = 1
end if

return

end subroutine LOOP3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Logical Function LDF_X_IsSet()
      Implicit None
#include "localdf.fh"
      Integer LDF_Status
      Call Get_iScalar('LDF Status',LDF_Status)
      LDF_X_IsSet=LDF_Status.eq.LDF_Set
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993,1999, Roland Lindh                                *
!***********************************************************************

subroutine TnsCtl(Wrk,nWrk,nijkl,mabMax,mabMin,mcdMax,mcdMin,HMtrxAB,HMtrxCD,la,lb,lc,ld,iCmpa,jCmpb,kCmpc,lCmpd,iShlla,jShllb, &
                  kShllc,lShlld,i_out)
!***********************************************************************
!                                                                      *
! Object: to transform the intermediate integral set directly to       *
!         the final integral set.                                      *
!         Note that the position in memory of the final set is not     *
!         fixed.                                                       *
!                                                                      *
!     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
!             University of Lund, SWEDEN                               *
!             Modified by R.L Februrary, 1999.                         *
!***********************************************************************

use Basis_Info, only: Shells
use Breit, only: nComp
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nWrk, nijkl, mabMax, mabMin, mcdMax, mcdMin, la, lb, lc, ld, iCmpa, jCmpb, kCmpc, lCmpd, iShlla, &
                                 jShllb, kShllc, lShlld
real(kind=wp), intent(inout) :: Wrk(nWrk)
real(kind=wp), intent(in) :: HMtrxAB(*), HMtrxCD(*)
integer(kind=iwp), intent(out) :: i_out

! If nComp==1
!   Integral are stored as e,f,IJKL in Wrk
! If nComp/=1
!   Integral are stored as ncomp,e,f,IJKL in Wrk

! Observe that Transf is false for s and p functions.

call TnsCtl_Internal(Wrk,nWrk)

contains

subroutine TnsCtl_Internal(Wrk,nWrk)

  integer(kind=iwp), intent(in) :: nWrk
  real(kind=wp), target, intent(inout) :: Wrk(nWrk)
  real(kind=wp), pointer :: W2(:), W3(:), W_in(:), W_out(:)
  integer(kind=iwp) :: i_In, iW2, iW3, nab, ncd, nDim, ne, nf, nfijkl, nijklab

  ne = (mabMax-mabMin+1)
  nf = (mcdMax-mcdMin+1)
  nab = iCmpa*jCmpb
  ncd = kCmpc*lCmpd
  nDim = max(ne*nf,nab*nf,nab*ncd)

  iW2 = 1
  iW3 = 1+nijkl*nDim
  W2(1:nijkl*nDim) => Wrk(1:nijkl*nDim)
  W3(1:(nWrk-nijkl*nDim)) => Wrk(nijkl*nDim+1:nWrk)

  if (nComp /= 1) then
    W3(1:ne*nf*nijkl) = W2(1:ne*nf*nijkl)
    call DGetMO(W3,nComp,nComp,ne*nf*(nijkl/nComp),W2,ne*nf*(nijkl/nComp))
  end if

  ! If (ss|ss) integral exit.

  if (la+lb+lc+ld == 0) then
    i_out = 1
    nullify(W2,W3)
    return
  end if

  ! Transpose if no transformation is needed.

  if ((la*lb == 0) .and. (lc*ld == 0) .and. (.not. Shells(iShlla)%Transf) .and. (.not. Shells(jShllb)%Transf) .and. &
      (.not. Shells(kShllc)%Transf) .and. (.not. Shells(lShlld)%Transf)) then
    call DGeTMO(W2,ne*nf,ne*nf,nijkl,W3,nijkl)
    i_out = iW3
    nullify(W2,W3)
    return
  end if

  ! Form matrix corresponding to the transfer equation, le,la,lb.
  ! The matrix transforms directly from e0 cartesians to real
  ! spherical harmonics.

  if (la+lb == 0) then
    W_in => W2
    W_out => W3
    i_in = iW2
    i_out = iW3
  else if ((la*lb == 0) .and. (.not. Shells(iShlla)%Transf) .and. (.not. Shells(jShllb)%Transf)) then
    call DGeTMO(W2,ne,ne,nf*nijkl,W3,nf*nijkl)
    W_in => W3
    W_out => W2
    i_in = iW3
    i_out = iW2
  else

    ! Now transform directly (e,[f,IJKL]) to ([f,IJKL],AB)
    ! Int(lf*IJKL,lA*lB)=Int(le,lf*IJKL)*HMtrx(le,lA*lB)

    nfijkl = nf*nijkl
    call Sp_Mlt(W2,ne,W3,nfijkl,HMtrxAB,nab)
    W_in => W3
    W_out => W2
    i_in = iW3
    i_out = iW2
  end if

  ! Form matrix corresponding to the transfer equation, lf,lC,lD

  if (lc+ld == 0) then
    i_out = i_in
  else if ((lc*ld == 0) .and. (.not. Shells(kShllc)%Transf) .and. (.not. Shells(lShlld)%Transf)) then
    call DGeTMO(W_in,nf,nf,nijkl*nab,W_out,nijkl*nab)
  else

    ! Now transform directly (f,[IJKL,AB]) to ([IJKL,AB],CD)
    ! Int(IJKL*lA*lB,lC*lD)=Int(lf,IJKL*lA*lB)*HMtrx(lf,lC*lD)

    nijklAB = nijkl*nab
    call Sp_Mlt(W_in,nf,W_out,nijklAB,HMtrxCD,ncd)
  end if
  nullify(W2,W3,W_in,W_out)

end subroutine TnsCtl_Internal

end subroutine TnsCtl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2015,2016, Ignacio Fdez. Galvan                        *
************************************************************************
      Subroutine Process_Gradients()
      use Slapaf_Info, only: Gx, Gx0, NAC, Energy, Energy0, RootMap
      use Slapaf_Parameters, only: Request_Alaska, TwoRunFiles, iter,
     &                             NADC, ApproxNADC, iState
      Implicit None
#include "real.fh"
#include "stdalloc.fh"
      Logical Found, Exist
      Integer i,nRoots,RC,Read_Grad,Columbus, nsAtom
      Real*8, Allocatable :: Grads(:,:), Ener(:)
      Real*8 E0, E1
      External Read_Grad
*
      Request_Alaska=.False.
      nsAtom=SIZE(Gx,2)
      Call mma_Allocate(Grads,3*nsAtom,3)
*
*     First check that all the needed gradients are available
*     and stop to compute them if they are not.
*     For a two-RunFile job, this behaves as if it's one state.
*
      If (TwoRunFiles) Then
        iState(1)=0
        iState(2)=0
      End If
*
      IF (iState(1).NE.0) iState(1)=RootMap(iState(1))
      IF (iState(2).NE.0) iState(2)=RootMap(iState(2))
      i=MAX(iState(1),iState(2))
      iState(2)=MIN(iState(1),iState(2))
      iState(1)=i
*
*     Two states
*
      If ((iState(1).ne.0).and.(iState(2).ne.0)) Then
        Do i=2,1,-1
          RC=Read_Grad(Grads(1,i),3*nsAtom,iState(i),0,0)
          If (RC.eq.0) Then
            Request_Alaska=.True.
            Call Put_iScalar('Relax CASSCF root',iState(i))
            Call Put_iScalar('NumGradRoot',iState(i))
            iState(1)=iState(i)
            iState(2)=0
            Exit
          End If
        End Do
        If ((.Not.Request_Alaska).And.NADC) Then
          RC=Read_Grad(Grads(1,3),3*nsAtom,0,iState(1),iState(2))
          If (RC.eq.0) Request_Alaska=.True.
        End If
*
*     One state
*
      Else
        iState(1)=0
        iState(2)=0
        Call Qpg_iScalar('Relax CASSCF root',Exist)
        If (Exist) Call Get_iScalar('Relax CASSCF root',iState(1))
        If (iState(1).eq.0) iState(1)=1
        RC=Read_Grad(Grads(1,1),3*nsAtom,iState(1),0,0)
        If (RC.eq.0) Request_Alaska=.True.
      End If
*
      If (Request_Alaska) Then
        Call mma_Deallocate(Grads)
        NADC=.False.
        Return
      End If
*
*     Once the gradients are read, convert them to forces
*     and store them as appropriate.
*
*     Energy and gradient of the first (higher) state
*
      nRoots=1
      Call Qpg_iScalar('Number of roots',Found)
      If (Found) Call Get_iScalar('Number of roots',nRoots)
      Call mma_Allocate(Ener,nRoots)
      Call Get_dArray('Last energies',Ener,nRoots)
      If (Max(iState(1),iState(2)).gt.nRoots) Then
        Call WarningMessage(2,'Too few energies in RUNFILE')
        Call Abend()
      End If
      Energy(iter)=Ener(iState(1))
      E1=Ener(iState(1))
      Call dCopy_(3*nsAtom,Grads(1,1),1,Gx(1,1,iter),1)
      Gx(:,:,iter) = -Gx(:,:,iter)
*
*     For a two-RunFile job, read the second (lower) energy
*     and gradient from RUNFILE2
*
      If (TwoRunFiles) Then
        Call NameRun('RUNFILE2')
        iState(2)=0
        Call Qpg_iScalar('Relax CASSCF root',Exist)
        If (Exist) Call Get_iScalar('Relax CASSCF root',iState(2))
        If (iState(1).eq.0) iState(2)=1
        nRoots=1
        Call Qpg_iScalar('Number of roots',Found)
        If (Found) Call Get_iScalar('Number of roots',nRoots)
        Call mma_Deallocate(Ener)
        Call mma_Allocate(Ener,nRoots)
        Call Get_dArray('Last energies',Ener,nRoots)
        Call Get_dArray('GRAD',Grads(1,2),3*nsAtom)
        Call NameRun('RUNFILE')
        RC=-1
      End If
*
      If (iState(2).gt.0) Then
        E0=Ener(iState(2))
*
*       In case of a true conical intersection the Lagrangian is different!
*       In that case we will have that the energy is the average energy
*       and that the constraint is the squared energy difference. We
*       change the energies and gradients here on-the-fly.
*
        If (NADC) Then
          Energy (iter)=(E1+E0)*Half
          Energy0(iter)=E1-E0
          Call daXpY_(3*nsAtom,-One,Grads(1,2),1,Gx(1,1,iter),1)
          Gx(:,:,iter) = Half * Gx(:,:,iter)
          Call dCopy_(3*nsAtom,Grads(1,2),1,Gx0(1,1,iter),1)
          Call daXpY_(3*nsAtom,-One,Grads(1,1),1,Gx0(1,1,iter),1)
          Call Get_iScalar('Columbus',Columbus)
          If (Columbus.ne.1) Then
            Call mma_allocate(NAC,3,nsAtom,Label='NAC')
            Call dCopy_(3*nsAtom,Grads(1,3),1,NAC,1)
*
*           If the coupling derivative vector could not be calculated,
*           use an approximate one.
*
            If (RC.lt.0) Then
              ApproxNADC=.True.
              Call Branching_Plane_Update(Gx,Gx0,NAC,3*nsAtom,iter)
            End If
          End If
        Else
          Energy0(iter)=E0
          Call dCopy_(3*nsAtom,Grads(1,2),1,Gx0(1,1,iter),1)
          Gx0(:,:,iter) = -Gx0(:,:,iter)
        End If
      End If
*
      Call mma_Deallocate(Ener)
      Call mma_Deallocate(Grads)
      Return
*
      End Subroutine Process_Gradients

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE LOOP26(KM,ISTOP,IFAI,IT1,IT2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      ISTOP=0
      KM1=KM+1
      J2F=IPO(J2(KM1))
C     FOUR POSSIBLE STARTS
      IWAYKM=IWAY(KM)
      GO TO (34,35,36,37,55),IWAYKM
C     (CC+,AA+)
34    IWAY(KM)=2
      IF(K0(IT1+J1(KM1)).EQ.0.OR.K0(IT2+J2(KM1)).EQ.0)GO TO 35
      IF(K1F(J2F).EQ.0)GO TO 135
      J1(KM)=K0(IT1+J1(KM1))
      J2(KM)=K0(IT2+J2(KM1))
      ICOUP1(KM)=0
      ICOUP(KM)=0
      COUP1(KM)=D1
      JM1(KM)=K1F(J2F)
      IF(K2F(J2F).EQ.0)GO TO 40
      GO TO 136
135   IF(K2F(J2F).EQ.0)GO TO 137
      J1(KM)=K0(IT1+J1(KM1))
      J2(KM)=K0(IT2+J2(KM1))
      ICOUP1(KM)=0
      ICOUP(KM)=0
136   COUP(KM)=D1
      JM(KM)=K2F(J2F)
      GO TO 40
137   IF(IFAI.EQ.0)GO TO 35
      J1(KM)=K0(IT1+J1(KM1))
      J2(KM)=K0(IT2+J2(KM1))
      ICOUP1(KM)=0
      ICOUP(KM)=0
      COUP1(KM)=D0
      COUP(KM)=D0
      GO TO 40
C     BB+
35    IWAY(KM)=3
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 36
      IF(K3F(J2F).EQ.0)GO TO 138
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      JM(KM)=K3F(J2F)
      ICOUP1(KM)=IY(IT1+J1(KM1),1)
      ICOUP(KM)=IY(IT2+J2(KM1),1)
      COUP(KM)=BS1(IB(J2(KM1))+1)**2
      GO TO 40
138   IF(IFAI.EQ.0)GO TO 36
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K1(IT2+J2(KM1))
      ICOUP1(KM)=IY(IT1+J1(KM1),1)
      ICOUP(KM)=IY(IT2+J2(KM1),1)
      COUP1(KM)=D0
      COUP(KM)=D0
      GO TO 40
C     DD+
36    IWAY(KM)=4
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 37
      IF(K3F(J2F).EQ.0)GO TO 139
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      JM1(KM)=K3F(J2F)
      ICOUP1(KM)=IY(IT1+J1(KM1),2)
      ICOUP(KM)=IY(IT2+J2(KM1),2)
      COUP1(KM)=BS2(IB(J2(KM1))+1)**2
      GO TO 40
139   IF(IFAI.EQ.0)GO TO 37
      J1(KM)=K2(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      ICOUP1(KM)=IY(IT1+J1(KM1),2)
      ICOUP(KM)=IY(IT2+J2(KM1),2)
      COUP1(KM)=D0
      COUP(KM)=D0
      GO TO 40
C     BD+
37    IWAY(KM)=5
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 55
      IF(K3F(J2F).EQ.0)GO TO 55
      J1(KM)=K1(IT1+J1(KM1))
      J2(KM)=K2(IT2+J2(KM1))
      JM1(KM)=K3F(J2F)
      ICOUP1(KM)=IY(IT1+J1(KM1),1)
      ICOUP(KM)=IY(IT2+J2(KM1),2)
      COUP1(KM)=BS1(IB(J2(KM1))+1)*BS2(IB(J2(KM1))+1)
      GO TO 40
55    ISTOP=1
40      Continue
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine Cho_GetZ(irc,NVT,l_NVT,nBlock,l_nBlock,nV,l_nV1,l_nV2,iV1,l_iV11,l_iV12,ip_Z,l_Z1,l_Z2,Z,l_Z)
!
! Thomas Bondo Pedersen, April 2010.
!
! Purpose: get the Z vectors in core.
!
! Input:
!    NVT(i): total no. of vectors in symmetry i
!    nBlock(i): no. of vector blocks in symmetry i
!    nV(j,i): number of vectors in block j of symmetry i
!    iV1(j,i): first vector in block j of symmetry i
!    ip_Z(j,i): pointer to triangular block j of symmetry i
!               (here, j is a compound index j=iTri(k,l) for
!                block k,l)
!
! On exit, the Z vector blocks are stored in memory according to ip_Z.

use Index_Functions, only: iTri, nTri_Elem
use Cholesky, only: iiBstR, InfVec, LuPri, nnBstR, nSym, nSys_call, NumCho, TDECOM
#ifdef _DEBUGPRINT_
use Cholesky, only: iPrint
#endif
use Cholesky_procedures, only: Cho_X_GetIP_InfVec
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(out) :: irc
integer(kind=iwp), intent(in) :: l_NVT, NVT(l_NVT), l_nBlock, nBlock(l_nBlock), l_nV1, l_nV2, nV(l_NV1,l_NV2), l_iV11, l_iV12, &
                                 iV1(l_IV11,l_iV12), l_Z1, l_Z2, ip_Z(l_Z1,l_Z2), l_Z
real(kind=wp), intent(out) :: Z(l_Z)
integer(kind=iwp) :: idRS2RS, iJ, iLoc, iRed, iRedC, iSym, j, J_inBlock, jBlock, k, K_inBlock, kBlock, KK, KK1, KKK, kOffV, kOffZ, &
                     l_Wrk, mUsed, nVRead
real(kind=wp) :: C0, C1, W0, W1
integer(kind=iwp), pointer :: InfVct(:,:,:)
integer(kind=iwp), allocatable :: iRS2RS(:)
real(kind=wp), allocatable :: Wrk(:)
character(len=*), parameter :: SecNam = 'Cho_GetZ'
integer(kind=iwp), external :: Cho_iRange
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i, n, nBlock_Max, nnB
integer(kind=iwp), parameter :: myDebugInfo = 100
real(kind=wp), parameter :: Tol = 1.0e-14_wp
#endif

#ifndef _DEBUGPRINT_
#include "macros.fh"
unused_var(NVT)
#endif

! Set return code.
! ----------------

irc = 0

#ifdef _DEBUGPRINT_
! Check input variables
if ((l_NVT < nSym) .or. (l_nBlock < nSym) .or. (l_nV2 < nSym) .or. (l_iV12 < nSym) .or. (l_Z2 < nSym)) then
  irc = -1
  return
end if
nBlock_Max = nBlock(1)
do iSym=2,nSym
  nBlock_Max = max(nBlock_Max,nBlock(iSym))
end do
nnB = nTri_Elem(nBlock_Max)
if ((l_nV1 < nBlock_Max) .or. (l_iV11 < nBlock_Max) .or. (l_Z1 < nnB)) then
  irc = -2
  return
end if
if (iPrint >= myDebugInfo) then
  call Cho_Head('Entering '//SecNam//':','*',80,LuPri)
  write(LuPri,'(A,8I6)') 'NVT   :',(NVT(iSym),iSym=1,nSym)
  write(LuPri,'(A,8I6)') 'nBlock:',(nBlock(iSym),iSym=1,nSym)
end if
n = 0
do iSym=1,nSym
  if (iPrint >= myDebugInfo) then
    do i=1,nBlock(iSym)
      write(LuPri,'(2X,A,I6,A,I2,A,I6,A,I6)') 'Block',i,' of sym.',iSym,': nV=',nV(i,iSym),' iV1=',iV1(i,iSym)
    end do
  end if
  do j=1,nBlock(iSym)
    do i=j,nBlock(iSym)
      if (i == j) then
        k = nTri_Elem(nV(i,iSym))
      else
        k = nV(i,iSym)*nV(j,iSym)
      end if
      n = n+k
      if (iPrint >= myDebugInfo) then
        write(Lupri,'(5X,A,I6,A,I6,A,I2,A,I9)') 'iBlock',i,' jBlock',j,' of Sym.',iSym,': ip_Z=',ip_Z(iTri(i,j),iSym)
        write(LuPri,'(5X,A,I6,A,I9)') '--> Block dimension:',k,'  Block ends at:',ip_Z(iTri(i,j),iSym)+k-1
      end if
    end do
  end do
end do
k = nTri_Elem(NVT(1))
do iSym=2,nSym
  k = k+nTri_Elem(NVT(iSym))
end do
if (iPrint >= myDebugInfo) then
  write(Lupri,'(A,I8)') 'Total dimension of Z (from blocks):',n
  write(Lupri,'(A,I8)') 'Total dimension of Z (from NVT)   :',k
  write(Lupri,'(A,I8)') '                        Difference:',n-k
end if
if (n /= k) then
  irc = -3
  if (iPrint >= myDebugInfo) then
    write(LuPri,'(A)') 'Ooops! They disagree....'
    write(LuPri,'(A,I4)') 'Returning with code:',irc
  end if
  return
end if
#endif

! Zero result array.
! ------------------

do iSym=1,nSym
  do kBlock=1,nBlock(iSym)
    Z(ip_Z(iTri(kBlock,kBlock),iSym):ip_Z(iTri(kBlock,kBlock),iSym)+nTri_Elem(nV(kBlock,iSym))-1) = Zero
    do jBlock=kBlock+1,nBlock(iSym)
      Z(ip_Z(iTri(jBlock,kBlock),iSym):ip_Z(iTri(jBlock,kBlock),iSym)+nV(jBlock,iSym)*nV(kBlock,iSym)-1) = Zero
    end do
  end do
end do

! Scratch location in index arrays.
! ---------------------------------

iLoc = 3 ! do NOT change (used implicitly by reading routine)

! Get pointer to InfVec array for all vectors.
! Needed for parallel runs.
! --------------------------------------------

call Cho_X_GetIP_InfVec(InfVcT)

! Copy rs1 to location 2.
! -----------------------

! Note: location 2 must contain rs1 throughout this routine! It is
! an assumption which is never checked, so do NOT change this call
! or modify contents of location 2.
call Cho_X_RSCopy(irc,1,2)
if (irc /= 0) then
  write(LuPri,'(A,A,I5)') SecNam,': Cho_X_RSCopy returned code',irc
  irc = 1
  return ! exit
end if

! Get Z vectors.
! --------------

iRedC = -1
do iSym=1,nSym

  call mma_allocate(iRS2RS,nnBstR(iSym,1),Label='iRS2RS')
  call mma_maxDBLE(l_Wrk)
  call mma_allocate(Wrk,l_Wrk,Label='Wrk')
  iRS2RS(:) = 0
  idRS2RS = -2
  KK1 = 1
  do while (KK1 <= NumCho(iSym))
    nVRead = 0
    mUsed = 0
    call CWTime(C0,W0)
    call Cho_X_VecRd(Wrk,size(Wrk),KK1,NumCho(iSym),iSym,nVRead,iRedC,mUsed)
    if (nVRead < 1) then
      irc = 2
      return ! exit
    end if
    call CWTime(C1,W1)
    tDecom(1,2) = tDecom(1,2)+(C1-C0)
    tDecom(2,2) = tDecom(2,2)+(W1-W0)
    nSys_Call = nSys_Call+1
    kOffV = 0
    do KKK=0,nVRead-1
      KK = KK1+KKK
      iRed = InfVec(KK,2,iSym)
      if (iRedC /= iRed) then
        call Cho_X_SetRed(irc,iLoc,iRed)
        if (irc /= 0) then
          irc = 3
          return ! exit
        end if
        iRedC = iRed
      end if
      if (idRS2RS /= iRedC) then
        call Cho_RS2RS(iRS2RS,size(iRS2RS),2,iLoc,iRedC,iSym)
        idRS2RS = iRedC
      end if
      K = InfVec(KK,5,iSym)
      kBlock = Cho_iRange(K+1,iV1(1,iSym),nBlock(iSym),.true.)
#     ifdef _DEBUGPRINT_
      if ((kBlock < 1) .or. (kBlock > nBlock(iSym))) then
        call Cho_Quit('[BLOCK] Error detected in '//SecNam,104)
      end if
#     endif
      K_inBlock = K-iV1(kBlock,iSym)+1
      kOffZ = ip_Z(iTri(kBlock,kBlock),iSym)-1
      do J_inBlock=K_inBlock,nV(kBlock,iSym)
        J = iV1(kBlock,iSym)+J_inBlock-1
        iJ = iRS2RS(InfVcT(J,1,iSym)-iiBstR(iSym,1))
        Z(kOffZ+iTri(J_inBlock,K_inBlock)) = Wrk(kOffV+iJ)
      end do
      do jBlock=kBlock+1,nBlock(iSym)
        kOffZ = ip_Z(iTri(jBlock,kBlock),iSym)-1+nV(jBlock,iSym)*(K_inBlock-1)
        do J_inBlock=1,nV(jBlock,iSym)
          J = iV1(jBlock,iSym)+J_inBlock-1
          iJ = iRS2RS(InfVcT(J,1,iSym)-iiBstR(iSym,1))
          Z(kOffZ+J_inBlock) = Wrk(kOffV+iJ)
        end do
      end do
      kOffV = kOffV+nnBstR(iSym,iLoc)
    end do
    KK1 = KK1+nVRead
  end do
  call mma_deallocate(Wrk)
  call mma_deallocate(iRS2RS)

end do

! Synchronize result array across nodes.
! --------------------------------------

do iSym=1,nSym
  do kBlock=1,nBlock(iSym)
    call Cho_GAdGOp(Z(ip_Z(iTri(kBlock,kBlock),iSym)),nTri_Elem(nV(kBlock,iSym)),'+')
    do jBlock=kBlock+1,nBlock(iSym)
      call Cho_GAdGOp(Z(ip_Z(iTri(jBlock,kBlock),iSym)),nV(jBlock,iSym)*nV(kBlock,iSym),'+')
    end do
  end do
end do

#ifdef _DEBUGPRINT_
! Check that diagonal elements of Z are strictly positive.
! --------------------------------------------------------

if (iPrint >= myDebugInfo) then
  call Cho_Head(SecNam//': Diagonal of Z Vector Matrix','=',80,LuPri)
  write(Lupri,'(A)') ' '
end if
n = 0
do iSym=1,nSym
  do jBlock=1,nBlock(iSym)
    kOffZ = ip_Z(iTri(jBlock,jBlock),iSym)-1
    do J_inBlock=1,nV(jBlock,iSym)
      if (iPrint >= myDebugInfo) then
        write(LuPri,'(A,I2,A,I6,A,ES15.6,A,ES15.6)') 'Sym=',iSym,'  J=',iV1(jBlock,iSym)+J_inBlock-1,'  Z(J,J)=', &
                                                     Z(kOffZ+iTri(J_inBlock,J_inBlock)),'  Squared=', &
                                                     Z(kOffZ+iTri(J_inBlock,J_inBlock))**2
      end if
      if ((abs(Z(kOffZ+iTri(J_inBlock,J_inBlock))) < Tol) .or. (Z(kOffZ+iTri(J_inBlock,J_inBlock)) < -Tol)) then
        n = n+1
        if (iPrint >= myDebugInfo) write(LuPri,'(A)') '  --> Small or negative Z diagonal!'
      end if
    end do
  end do
end do
if (n /= 0) then
  irc = 20
  return ! return
end if
! Check diagonal elements
call Cho_CheckDiagFromZ(irc,NVT,l_NVT,nBlock,l_nBlock,nV,l_nV1,l_nV2,iV1,l_iV11,l_iV12,ip_Z,l_Z1,l_Z2,Z,l_Z,iPrint >= myDebugInfo)
if (irc /= 0) return ! return
#endif

end subroutine Cho_GetZ

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine projspn_cvb(bikcof,nel,nalf,nbet,ndet,ifns)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nel, nalf, nbet, ndet, ifns
real(kind=wp), intent(inout) :: bikcof(ndet,ifns)
integer(kind=iwp) :: i, inddet, indx, iorb, iswp, rc
logical(kind=iwp) :: done, first
integer(kind=iwp), allocatable :: ialfa(:), iw(:), lnocca(:), lnoswp(:), locca(:), locswp(:), maxalf(:), maxspn(:), minalf(:), &
                                  minspn(:), nkalf(:), nkspn(:), xdet(:,:), xspin(:)
real(kind=wp), allocatable :: detphase(:)
integer(kind=iwp), external :: minind_cvb

call mma_allocate(minalf,[0,nel],label='minalf')
call mma_allocate(maxalf,[0,nel],label='maxalf')
call mma_allocate(nkalf,[0,nel],label='nkalf')
call mma_allocate(minspn,[0,nel],label='minspn')
call mma_allocate(maxspn,[0,nel],label='maxspn')
call mma_allocate(nkspn,[0,nel],label='nkspn')
call mma_allocate(locswp,2*nbet,label='locswp')
call mma_allocate(lnoswp,2*nbet,label='lnoswp')
call mma_allocate(locca,nel,label='locca')
call mma_allocate(lnocca,nel,label='lnocca')
call mma_allocate(ialfa,nalf,label='ialfa')
call mma_allocate(xdet,[0,nel],[0,nalf],label='xdet')
call mma_allocate(xspin,(nel+1)*(nalf+1),label='xspin')
call mma_allocate(iw,nel,label='iw')
call mma_allocate(detphase,ndet,label='detphase')

! Phase factors between alpha-beta separated determinants
! and determinants with ascending orbital numbers
detphase(:) = One
call asc2ab_cvb(detphase,1,nel,nalf)

! Projected spin functions (generated by orbital permutations on the first Kotani function)

! Set up maximum and minimum of spin functions:
do iorb=0,nel
  minspn(iorb) = iorb-min(iorb/2,nbet)
  maxspn(iorb) = min(iorb,nalf)
end do
call weight_cvb(xspin,minspn,maxspn,nalf,nel)

nkspn(:) = maxspn(:)
call occupy_cvb(nkspn,nel,iw,iw(nalf+1))
! Set up maximum and minimum for determinants:
do iorb=0,nel
  minalf(iorb) = max(iorb-nbet,0)
  maxalf(iorb) = min(iorb,nalf)
end do
call weight_cvb(xdet,minalf,maxalf,nalf,nel)
nkalf(:) = maxalf(:)
call occupy_cvb(nkalf,nel,locca,lnocca)
call mma_deallocate(locca)
call mma_deallocate(lnocca)
! Loop:
indx = 1
first = .true.
do
  ! Skip first function
  if (first) then
    first = .false.
  else
    inddet = 1
    ! MAXSPN contains same elements as MAXALF
    nkalf(:) = maxspn(:)
    call occupy_cvb(nkalf,nel,locswp,lnoswp)
    do
      do i=1,nalf
        ialfa(i) = iw(locswp(i))
      end do
      do
        done = .false.
        do i=2,nalf
          if (ialfa(i) < ialfa(i-1)) then
            iswp = ialfa(i-1)
            ialfa(i-1) = ialfa(i)
            ialfa(i) = iswp
            done = .true.
            exit
          end if
        end do
        if (.not. done) exit
      end do
      bikcof(minind_cvb(ialfa,nalf,nel,xdet),indx) = bikcof(inddet,1)*detphase(inddet)*detphase(minind_cvb(ialfa,nalf,nel,xdet))
      call loind_cvb(nel,nalf,nkalf,minalf,maxalf,locswp,lnoswp,inddet,xdet,rc)
      if (rc == 0) exit
    end do
  end if
  call loind_cvb(nel,nalf,nkspn,minspn,maxspn,iw,iw(nalf+1),indx,xspin,rc)
  if (rc == 0) exit
end do

call mma_deallocate(minalf)
call mma_deallocate(maxalf)
call mma_deallocate(nkalf)
call mma_deallocate(minspn)
call mma_deallocate(maxspn)
call mma_deallocate(nkspn)
call mma_deallocate(locswp)
call mma_deallocate(lnoswp)
call mma_deallocate(ialfa)
call mma_deallocate(xdet)
call mma_deallocate(xspin)
call mma_deallocate(iw)
call mma_deallocate(detphase)

return

end subroutine projspn_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DIAGCT()

use mrci_global, only: CSPCK, FOCK, IFIRST, INTSY, IRC, ISAB, ISMAX, KBUFF1, NBITM1, NBITM2, NBITM3, NBTRI, NCHN1, NCHN2, NCHN3, &
                       NVIRT
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: NHDIAG, NINTGR, NVT
integer(kind=iwp), allocatable :: Inds(:,:)
real(kind=wp), allocatable :: ACBDS(:), ACBDT(:), BACBD(:), BIAC1(:), BICA1(:), BUFBI(:), Bufs(:,:), FIIJJ(:), FIJIJ(:), HDIAG(:)

! ----------------------------------------------------------------------
call mma_allocate(Bufs,NBITM1,NCHN1,label='Bufs')
call mma_allocate(Inds,NBITM1+2,NCHN1,label='Inds')
call mma_allocate(BUFBI,KBUFF1,label='BUFBI')
call mma_allocate(BIAC1,ISMAX,label='BIAC1')
call mma_allocate(BICA1,ISMAX,label='BICA1')
Bufs(:,:) = Zero
Inds(:,:) = 0
call SORTA(Bufs,Inds,ISAB,BUFBI,BIAC1,BICA1,NINTGR)
call mma_deallocate(Bufs)
call mma_deallocate(Inds)
call mma_deallocate(BUFBI)
call mma_deallocate(BIAC1)
call mma_deallocate(BICA1)
! ----------------------------------------------------------------------

if (IFIRST == 0) then
  call mma_allocate(Bufs,NBITM2,NCHN2,label='Bufs')
  call mma_allocate(Inds,NBITM2+2,NCHN2,label='Bufs')
  call mma_allocate(BACBD,KBUFF1,label='BACBD')
  call mma_allocate(ACBDT,ISMAX,label='ACBDT')
  call mma_allocate(ACBDS,ISMAX,label='ACBDS')
  Bufs(:,:) = Zero
  Inds(:,:) = 0
  call SORTB(Bufs,Inds,ACBDS,ACBDT,ISAB,BACBD)
  call mma_deallocate(Bufs)
  call mma_deallocate(Inds)
  call mma_deallocate(BACBD)
  call mma_deallocate(ACBDT)
  call mma_deallocate(ACBDS)
end if
! ------------------- SORT --------------------------------------------
call mma_allocate(Bufs,NBITM3,NCHN3,label='Bufs')
call mma_allocate(Inds,NBITM3+2,NCHN3,label='Inds')
call mma_allocate(FIIJJ,NBTRI,label='FIIJJ')
call mma_allocate(FIJIJ,NBTRI,label='FIJIJ')
Bufs(:,:) = Zero
Inds(:,:) = 0
call SORT_MRCI(Bufs,Inds,FOCK,FIIJJ,FIJIJ)
call mma_deallocate(Bufs)
call mma_deallocate(Inds)
! ----------------------------------------------------------------------
NVT = (NVIRT*(NVIRT+1))/2
NHDIAG = max(NVT,IRC(1))
call mma_allocate(HDIAG,NHDIAG,label='HDIAG')
call IIJJ(CSPCK,INTSY,HDIAG,FOCK,FIIJJ,FIJIJ)
call IJIJ(INTSY,HDIAG,FIJIJ)
call mma_deallocate(FIIJJ)
call mma_deallocate(FIJIJ)
call mma_deallocate(HDIAG)

return

end subroutine DIAGCT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991,1994-1996, Jeppe Olsen                            *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ADSTN_GAS(OFFI,IOBSM,IOBTP,ISPGP,ISPGPSM,ISPGPTP,I1,XI1S,NKSTR,SCLFAC)
! Obtain mappings
! a+IORB !KSTR> = +/-!ISTR> for orbitals of symmetry IOBSM and type IOBTP
! and I strings belonging to supergroup ISPGP wih symmetry ISPGPSM
! and type ISPGPTP(=1=>alpha,=2=>beta)
!
! The results are given in the form
! I1(KSTR,IORB) =  ISTR if A+IORB !KSTR> = +/-!ISTR>
! (numbering relative to TS start)
! Above +/- is stored in XI1S
!
! Jeppe Olsen, Winter of 1991
!              January 1994 : modified to allow for several orbitals
!              August 95    : GAS version
!              October 96   : Improved version

use Symmetry_Info, only: Mul
use lucia_data, only: IBSPGPFTP, IOBPTS, ISPGPFTP, ISTSGP, MXPNGAS, MXPNSMST, NELFGP, NGAS, NIRREP, NOBPT, NOBPTS, NSTFSMSPGP, &
                      NSTSGP, STSTM
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: OFFI(*), XI1S(*)
integer(kind=iwp), intent(in) :: IOBSM, IOBTP, ISPGP, ISPGPSM, ISPGPTP
integer(kind=iwp), intent(_OUT_) :: I1(*)
integer(kind=iwp), intent(out) :: NKSTR
real(kind=wp), intent(in) :: SCLFAC
integer(kind=iwp) :: IACIST(MXPNSMST), IACSM, IBORBSP, IBORBSPS, IBSTRINI, IFIRST, IGAS, IIAC, IISTSGP(MXPNSMST,MXPNGAS), IKAC, &
                     IOFF, ISAVE, ISMFGS(MXPNGAS), ISMST, ISPGRPABS, ISTSMM1, ITPFGS(MXPNGAS), KACGRP, KFIRST, KSM, KSPGRPABS, &
                     KSTRBS, MNVAL(MXPNGAS), MULT, MXVAL(MXPNGAS), NACGSOB, NACIST(MXPNSMST), NELB, NELFGS(MXPNGAS), NGASL, NIAC, &
                     NKAC, NKSD, NNSTSGP(MXPNSMST,MXPNGAS), NONEW, NORBTS, NSTA, NSTB, NSTRII, NSTRIK, NSTRINT
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: IORB, IORBR
#endif
integer(kind=iwp), parameter :: MXLNGAS = 20

! Will be stored as an matrix of dimension
! (NKSTR,*), Where NKSTR is the number of K-strings of
! correct symmetry . Nk is provided by this routine.

if (NGAS > MXLNGAS) then
  write(u6,*) ' Ad hoc programming in ADSTN (IOFFI)'
  write(u6,*) ' Must be changed - or redimensioned'
  !stop 'ADST : IOFFI problem'
  call SYSABENDMSG('lucia_util/adstn_gas','Internal error','')
end if

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ===================='
write(u6,*) ' ADSTN_GAS in service'
write(u6,*) ' ===================='
write(u6,*)
write(u6,*) '  IOBTP IOBSM : ',IOBTP,IOBSM
write(u6,*) '  ISPGP ISPGPSM ISPGPTP :  ',ISPGP,ISPGPSM,ISPGPTP
#endif

!if (SCLFAC /= One) then
!  write(u6,*) ' Problemo : ADSTN_GAS'
!  write(u6,*) ' SCLFAC /= 1'
!end if

! Supergroup and symmetry of K strings

ISPGRPABS = IBSPGPFTP(ISPGPTP)-1+ISPGP
call NEWTYP(ISPGRPABS,1,IOBTP,KSPGRPABS)
KSM = Mul(IOBSM,ISPGPSM)
NKSTR = NSTFSMSPGP(KSM,KSPGRPABS)
#ifdef _DEBUGPRINT_
write(u6,*) ' KSM, KSPGPRABS, NKSTR : ',KSM,KSPGRPABS,NKSTR
#endif
if (NKSTR /= 0) then

  NORBTS = NOBPTS(IOBTP,IOBSM)
  XI1S(1:NORBTS*NKSTR) = Zero
  I1(1:NORBTS*NKSTR) = 0

  ! First orbital of given GASSpace
  IBORBSP = sum(NOBPT(1:IOBTP-1))+1
  ! First orbital of fiven GASSPace and Symmetry
  IBORBSPS = IOBPTS(IOBTP,IOBSM)

  ! Information about I strings
  ! ===========================

  ! structure of group of strings defining I strings
  NGASL = 1
  ITPFGS(:) = 0
  do IGAS=1,NGAS
    ITPFGS(IGAS) = ISPGPFTP(IGAS,ISPGRPABS)
    NELFGS(IGAS) = NELFGP(ITPFGS(IGAS))
    if (NELFGS(IGAS) > 0) NGASL = IGAS
  end do
  ! Number of electrons before active type
  NELB = sum(NELFGS(1:IOBTP-1))
  ! Number of electrons in active space
  NACGSOB = NOBPT(IOBTP)

  ! Number of strings per symmetry for each symmetry
  do IGAS=1,NGAS
    NNSTSGP(1:NIRREP,IGAS) = NSTSGP((ITPFGS(IGAS)-1)*NIRREP+1:ITPFGS(IGAS)*NIRREP)
  end do
  ! Offset and dimension for active group in I strings
  IACIST(1:NIRREP) = ISTSGP((ITPFGS(IOBTP)-1)*NIRREP+1:ITPFGS(IOBTP)*NIRREP)
  NACIST(1:NIRREP) = NSTSGP((ITPFGS(IOBTP)-1)*NIRREP+1:ITPFGS(IOBTP)*NIRREP)
  !write(u6,*) ' IACIST and NACIST arrays'
  !call IWRTMA(IACIST,1,NIRREP,1,NIRREP)
  !call IWRTMA(NACIST,1,NIRREP,1,NIRREP)

  ! Generate offsets for I strings with given symmetry in each space

  do IGAS=1,NGAS
    do ISMST=1,NIRREP
      if (NNSTSGP(ISMST,IGAS) > 0) MXVAL(IGAS) = ISMST
    end do
    do ISMST=NIRREP,1,-1
      if (NNSTSGP(ISMST,IGAS) > 0) MNVAL(IGAS) = ISMST
    end do
  end do
  IFIRST = 1
  NSTRINT = 0
  do
    if (IFIRST == 1) then
      ISMFGS(1:NGASL-1) = MNVAL(1:NGASL-1)
    else
      ! Next distribution of symmetries in NGAS -1
      call NXTNUM3(ISMFGS,NGASL-1,MNVAL,MXVAL,NONEW)
      if (NONEW /= 0) exit
    end if
    IFIRST = 0
    ! Symmetry of NGASL -1 spaces given, symmetry of full space
    ISTSMM1 = 1
    do IGAS=1,NGASL-1
      ISTSMM1 = Mul(ISTSMM1,ISMFGS(IGAS))
    end do
    ! sym of SPACE NGASL
    ISMFGS(NGASL) = Mul(ISTSMM1,ISPGPSM)
#   ifdef _DEBUGPRINT_
    write(u6,*) ' next symmetry of NGASL spaces'
    call IWRTMA(ISMFGS,1,NGASL,1,NGASL)
#   endif
    ! Number of strings with this symmetry combination
    NSTRII = 1
    do IGAS=1,NGASL
      NSTRII = NSTRII*NNSTSGP(ISMFGS(IGAS),IGAS)
    end do
    ! Offset for this symmetry distribution in IOFFI
    IOFF = 1
    MULT = 1
    do IGAS=1,NGASL
      IOFF = IOFF+(ISMFGS(IGAS)-1)*MULT
      MULT = MULT*NIRREP
    end do

#   ifdef _DEBUGPRINT_
    write(u6,*)
    write(u6,*) ' ============================'
    write(u6,*) ' If program is crashing here,'
    write(u6,*) ' LOFFI needs to be increased.'
    write(u6,*) ' ============================'
    write(u6,*)
#   endif
    OFFI(IOFF) = real(NSTRINT,kind=wp)+1.001_wp
    NSTRINT = NSTRINT+NSTRII
#   ifdef _DEBUGPRINT_
    write(u6,*) ' IOFF, OFFI(IOFF) NSTRII ',IOFF,OFFI(IOFF),NSTRII
#   endif

    if (NGASL <= 1) exit
  end do

  ! Supergroup and symmetry of K strings

  !M call NEWTYP(ISPGRPABS,1,IOBTP,KSPGRPABS)
  !M KSM = Mul(IOBSM,ISPGPSM)
  !M NKSTR = NSTFSMSPGP(KSM,KSPGRPABS)
# ifdef _DEBUGPRINT_
  !M write(u6,*) ' KSM, KSPGPRABS, NKSTR : ',KSM,KSPGRPABS,NKSTR
# endif

  ! Gas structure of K strings

  NGASL = 1
  do IGAS=1,NGAS
    ITPFGS(IGAS) = ISPGPFTP(IGAS,KSPGRPABS)
    NELFGS(IGAS) = NELFGP(ITPFGS(IGAS))
    if (NELFGS(IGAS) > 0) NGASL = IGAS
  end do
  ! Active group of K-strings
  KACGRP = ITPFGS(IOBTP)
  ! Number of strings per symmetry distribution
  do IGAS=1,NGAS
    IISTSGP(1:NIRREP,IGAS) = ISTSGP((ITPFGS(IGAS)-1)*NIRREP+1:ITPFGS(IGAS)*NIRREP)
    NNSTSGP(1:NIRREP,IGAS) = NSTSGP((ITPFGS(IGAS)-1)*NIRREP+1:ITPFGS(IGAS)*NIRREP)
  end do

  do IGAS=1,NGAS
    do ISMST=1,NIRREP
      if (NNSTSGP(ISMST,IGAS) > 0) MXVAL(IGAS) = ISMST
    end do
    do ISMST=NIRREP,1,-1
      if (NNSTSGP(ISMST,IGAS) > 0) MNVAL(IGAS) = ISMST
    end do
  end do

  ! Loop over symmetry distribtions of K strings

  KFIRST = 1
  KSTRBS = 1
  do
    if (KFIRST == 1) then
      ISMFGS(1:NGASL-1) = MNVAL(1:NGASL-1)
    else
      ! Next distribution of symmetries in NGAS -1
      call NXTNUM3(ISMFGS,NGASL-1,MNVAL,MXVAL,NONEW)
      if (NONEW /= 0) exit
    end if
    KFIRST = 0
#   ifdef _DEBUGPRINT_
    write(u6,*) ' next symmetry of NGASL-1 spaces'
    call IWRTMA(ISMFGS,NGASL-1,1,NGASL-1,1)
#   endif
    ! Symmetry of NGASL -1 spaces given, symmetry of total space
    ISTSMM1 = 1
    do IGAS=1,NGASL-1
      ISTSMM1 = Mul(ISTSMM1,ISMFGS(IGAS))
    end do
    ! required sym of SPACE NGASL
    !write(u6,*) ' after  SYMCOM'
    !write(u6,*) ' ngasl istsmm1 ksm',ngasl,istsmm1,ksm
    ISMFGS(NGASL) = Mul(ISTSMM1,KSM)

    ISMFGS(NGASL+1:NGAS) = 1
#   ifdef _DEBUGPRINT_
    write(u6,*) ' Next symmetry distribution'
    call IWRTMA(ISMFGS,1,NGAS,1,NGAS)
#   endif
    ! Number of strings of this symmetry distribution
    NSTRIK = 1
    do IGAS=1,NGASL
      NSTRIK = NSTRIK*NNSTSGP(ISMFGS(IGAS),IGAS)
    end do
    ! Offset for corresponding I strings
    ISAVE = ISMFGS(IOBTP)
    IACSM = Mul(IOBSM,ISMFGS(IOBTP))
    ISMFGS(IOBTP) = IACSM
    IOFF = 1
    MULT = 1
    do IGAS=1,NGAS
      IOFF = IOFF+(ISMFGS(IGAS)-1)*MULT
      MULT = MULT*NIRREP
    end do
    ISMFGS(IOBTP) = ISAVE
    IBSTRINI = int(OFFI(IOFF))
    !write(u6,*) ' IOFF IBSTRINI ',IOFF,IBSTRINI
    ! Number of strings before active GAS space
    NSTB = 1
    do IGAS=1,IOBTP-1
      NSTB = NSTB*NNSTSGP(ISMFGS(IGAS),IGAS)
    end do
    ! Number of strings before active GAS space
    NSTA = 1
    do IGAS=IOBTP+1,NGAS
      NSTA = NSTA*NNSTSGP(ISMFGS(IGAS),IGAS)
    end do
    ! Number and offset for active group
    !write(u6,*) ' IACSM = ',IACSM
    NIAC = NACIST(IACSM)
    IIAC = IACIST(IACSM)

    NKAC = NNSTSGP(ISMFGS(IOBTP),IOBTP)
    IKAC = IISTSGP(ISMFGS(IOBTP),IOBTP)
    ! I and K strings of given symmetry distribution
    NKSD = NSTB*NKAC*NSTA
    !write(u6,*) ' nstb nsta niac nkac ',nstb,nsta,niac,nkac
    ! Obtain annihilation n mapping for all strings of this type

    NORBTS = NOBPTS(IOBTP,IOBSM)

    !write(u6,*) ' KACGRP ',KACGRP
    call ADSTN_GASSM(NSTB,NSTA,IKAC,IIAC,IBSTRINI,KSTRBS,STSTM(KACGRP,1)%A,STSTM(KACGRP,2)%A,IBORBSPS,IBORBSP,NORBTS,NKAC,NIAC, &
                     NKSTR,NELB,NACGSOB,I1,XI1S,SCLFAC)
    KSTRBS = KSTRBS+NKSD
    if (NGASL <= 1) exit
  end do

end if

#ifdef _DEBUGPRINT_
write(u6,*) ' Output from ADSTN_GAS'
write(u6,*) ' ====================='
write(u6,*) ' Total number of K strings ',NKSTR
if (NKSTR /= 0) then
  do IORB=IBORBSPS,IBORBSPS+NORBTS-1
    IORBR = IORB-IBORBSPS+1
    write(u6,*) ' Info for orbital ',IORB
    write(u6,*) ' Excited strings and sign'
    call IWRTMA(I1((IORBR-1)*NKSTR+1),1,NKSTR,1,NKSTR)
    call WRTMAT(XI1S((IORBR-1)*NKSTR+1),1,NKSTR,1,NKSTR)
  end do
end if
#endif

! PAM Mars-2006: This flush moved outside of this subroutine
!call MEMMAN(IDUM,IDUM,'FLUSM',IDUM,'ADSTN ')

end subroutine ADSTN_GAS

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This module contains procedures that need an interface
module RI_procedures

implicit none
private

public :: Drv2El_2Center_RI, Drv2el_Atomic_Nosym, Effective_CD_Pairs, Fix_Exponents

contains

#define _IN_MODULE_
#include "drv2el_2center_ri.F90"
#include "drv2el_atomic_nosym.F90"
#include "effective_cd_pairs.F90"
#include "fix_exponents.F90"

end module RI_procedures

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*      SUBROUTINE AI(INTSYM,INDX,C,S,FC,BUFIN,IBUFIN,A,B,FK,DBK,KTYP)
*      SUBROUTINE AI_MRCI(INTSYM,INDX,C,S,FC,BUF,IBUF,A,B,FK,DBK,KTYP)
      SUBROUTINE AI_MRCI(INTSYM,INDX,C,S,FC,A,B,FK,DBK,KTYP)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "mrci.fh"
      DIMENSION INTSYM(*),INDX(*),C(*),S(*),
*     *          FC(*),BUFIN(*),IBUFIN(*),
*     *          FC(*),BUF(NBITM3),IBUF(NBITM3+2),
     *          FC(*),
     *          A(*),B(*),FK(*),DBK(*)
      DIMENSION IPOB(9)
      PARAMETER (ONE=1.0D00)
*
      JSYM(L)=JSUNP(INTSYM,L)
*
C KTYP=0,  (A/I)   INTEGRALS
C KTYP=1,  (AI/JK) INTEGRALS

      CALL GETMEM('BUF','ALLO','REAL',LBUF,NBITM3)
      CALL GETMEM('IBUF','ALLO','INTE',LIBUF,NBITM3+2)

      INUM=IRC(4)-IRC(3)
      CALL CSCALE(INDX,INTSYM,C,SQ2)
      CALL CSCALE(INDX,INTSYM,S,SQ2INV)
      NVT=IROW(NVIRT+1)
      ICHK=0
      IJOLD=0
      NK=0
      NSA=1
      NOTT=LN*(LN+1)
      NOVST=LN*NVIRT+1+NVT
CPAM97 New portable code:
      NBCMX3=(RTOI*NBSIZ3-2)/(RTOI+1)
      IBOFF3=RTOI*NBCMX3
      IBBC3=IBOFF3+NBCMX3+1
      IBDA3=IBBC3+1

      IF(KTYP.EQ.0)IADD10=IAD10(9)
      IF(KTYP.EQ.1)IADD10=IAD10(7)
C READ A COP BUFFER
100   CONTINUE
      CALL dDAFILE(LUSYMB,2,COP,nCOP,IADD10)
      CALL iDAFILE(LUSYMB,2,iCOP1,nCOP+1,IADD10)
      LEN=ICOP1(nCOP+1)
      IF(LEN.EQ.0)GO TO 100
      IF(LEN.LT.0)GO TO 200
C LOOP THROUGH THE COP BUFFER:
      DO 10 II=1,LEN
      IND=ICOP1(II)
      IF(ICHK.NE.0) THEN
C BEGIN A RATHER LONG IF-BLOCK.
C ICHK FLAG IS SET. THIS SIGNALS THAT PREVIOUS IND WAS 0, WHICH IS
C USED TO INDICATE CHANGE TO A NEW BLOCK OF COUPLING COEFFICIENTS.
C RESET ICHK FLAG.
        ICHK=0
        IF(KTYP.EQ.0) THEN
C AI CASE. SAVE INTERNAL ORBITAL INDEX IN NK:
          NK=IND
          IJOLD=NK
          NSK=NSM(NK)
          NSA=NSK
          GO TO 20
        END IF
C AIJK CASE. UNPACK INTERNAL ORBITAL INDICES INTO NI,NJ,NK:
        INDI=IND
*        NI=MOD(INDI,2**10)
*        NJ=MOD(INDI/2**10,2**10)
*        NK=MOD(INDI/2**20,2**10)
        NI=IBITS(INDI, 0,10)
        NJ=IBITS(INDI,10,10)
        NK=IBITS(INDI,20,10)
        NSI=NSM(NI)
        NSJ=NSM(NJ)
        NSK=NSM(NK)
        NSIJ=MUL(NSI,NSJ)
        NSA=MUL(NSIJ,NSK)
        IJ=IROW(NI)+NJ
        IF(IJ.NE.IJOLD) THEN
C NEW INTERNAL PAIR IJ. LOAD A NEW SET OF INTEGRALS INTO FC:
          IJOLD=IJ
          IADR=LASTAD(NOVST+NOTT+IJ)
          CALL FZERO(FC,NBTRI)

90        CONTINUE
*PAM04          CALL dDAFILE(Lu_60,2,IBUFIN,NBSIZ3,IADR)
          CALL iDAFILE(Lu_60,2,iWORK(LIBUF),NBITM3+2,IADR)
          CALL dDAFILE(Lu_60,2,WORK(LBUF),NBITM3,IADR)
          LENGTH=iWORK(LIBUF+NBITM3)
          IADR  =iWORK(LIBUF+NBITM3+1)
*PAM04          LENGTH=IBUFIN(IBBC3)
*PAM04          IADR=IBUFIN(IBDA3)
          IF(LENGTH.EQ.0)GO TO 91
*          CALL SCATTER(LENGTH,FC,IBUFIN(IBOFF3+1),BUFIN)
          do i=0,length-1
*PAM04            fc(IBUFIN(IBOFF3+i))=bufin(i)
            fc(iWORK(LIBUF+i))=WORK(LBUF+i)
          end do
91        IF(IADR.NE.-1) GO TO 90
        END IF
20      CONTINUE
C FOR THIS PARTICULAR K, TRANSFER FC(NK,NA) TO ARRAY FK:
        NVIRA=NVIR(NSA)
        IF(NVIRA.EQ.0) GOTO 10
        DO 13 I=1,NVIRA
          NA=NVIRP(NSA)+I
          NAK=IROW(LN+NA)+NK
          FK(I)=FC(NAK)
13      CONTINUE
        GOTO 10
      END IF
C END OF THE LONG IF-BLOCK.
      IF(IND.EQ.0) THEN
C IND=0 SIGNALS SWITCH TO A NEW SET OF INTEGRALS.
        ICHK=1
        GO TO 10
      END IF
C WE ARE PROCESSING A COUPLING COEFFICIENT AS USUAL.
      IF(NVIRA.EQ.0)GO TO 10
*      ITYP=MOD(IND,2**6)
*      ICP2=MOD(IND/2**6,2**13)
*      ICP1=MOD(IND/2**19,2**13)
      ITYP=IBITS(IND, 0, 6)
      ICP2=IBITS(IND, 6,13)
      ICP1=IBITS(IND,19,13)
      IF(ITYP.GT.1)GO TO 12
C ITYP=1. VALENCE-SINGLES CASE.
      INDA=ICP1
      INDB=IRC(1)+ICP2
      INNY=INDX(INDB)+1
      COPI=COP(II)*C(INDA)
      CALL DAXPY_(NVIRA,COPI,FK,1,S(INNY),1)
      TERM=DDOT_(NVIRA,FK,1,C(INNY),1)
      S(INDA)=S(INDA)+COP(II)*TERM
      GO TO 10
12    IF(ITER.EQ.1 .AND. IREST.EQ.0)GO TO 10
      INDA=IRC(1)+ICP1
      INDB=IRC(ITYP)+ICP2
      INMY=INDX(INDA)+1
      INNY=INDX(INDB)+1
      MYINTS=JSYM(INDA)
      NYINTS=MUL(MYINTS,NSA)
      MYEXTS=MUL(MYINTS,LSYM)
      NYEXTS=MUL(NYINTS,LSYM)
      IFT=0
      IF(ITYP.EQ.2)IFT=1
      CALL IPO(IPOB,NVIR,MUL,NSYM,NYEXTS,IFT)
      NVM=NVIR(MYEXTS)
      CALL FZERO(DBK,NVIRA)
      CALL DAXPY_(NVIRA,COP(II),FK,1,DBK,1)
      IF(NYEXTS.NE.1)GO TO 25
      IF(IFT.EQ.0)CALL SQUAR(C(INNY+IPOB(MYEXTS)),A,NVM)
      IF(IFT.EQ.1)CALL SQUARM(C(INNY+IPOB(MYEXTS)),A,NVM)
      CALL FZERO(B,NVM)
      CALL FMMM(DBK,A,B,1,NVM,NVIRA)
      CALL DAXPY_(NVM,ONE,B,1,S(INMY),1)
      SIGN=1.0D00
      IF(IFT.EQ.1)SIGN=-1.0D00
      IOUT=INNY+IPOB(MYEXTS)-1
      DO 125 I=1,NVM
      DO 130 J=1,I
      IOUT=IOUT+1
      TERM=DBK(I)*C(INMY+J-1)+SIGN*DBK(J)*C(INMY+I-1)
      S(IOUT)=S(IOUT)+TERM
130   CONTINUE
      IF(IFT.EQ.1)GO TO 125
      TERM=DBK(I)*C(INMY+I-1)
      S(IOUT)=S(IOUT)-TERM
125   CONTINUE
      GO TO 10
25    NKM=NVIRA*NVM
      CALL FZERO(B,NVM)
      IF(NSA.GT.MYEXTS)GO TO 26
      IF(IFT.EQ.1)CALL VNEG(DBK,1,DBK,1,NVIRA)
      CALL FMMM(DBK,C(INNY+IPOB(MYEXTS)),B,1,NVM,NVIRA)
      CALL DAXPY_(NVM,ONE,B,1,S(INMY),1)
      CALL FZERO(B,NKM)
      CALL FMMM(DBK,C(INMY),B,NVIRA,NVM,1)
      CALL DAXPY_(NKM,ONE,B,1,S(INNY+IPOB(MYEXTS)),1)
      GO TO 10
26    CALL FMMM(C(INNY+IPOB(NSA)),DBK,B,NVM,1,NVIRA)
      CALL DAXPY_(NVM,ONE,B,1,S(INMY),1)
      CALL FZERO(B,NKM)
      CALL FMMM(C(INMY),DBK,B,NVM,NVIRA,1)
      CALL DAXPY_(NKM,ONE,B,1,S(INNY+IPOB(NSA)),1)
      GO TO 10
10    CONTINUE
      GO TO 100
200   CONTINUE
      CALL CSCALE(INDX,INTSYM,C,SQ2INV)
      CALL CSCALE(INDX,INTSYM,S,SQ2)
      CALL GETMEM('BUF','FREE','REAL',LBUF,NBITM3)
      CALL GETMEM('IBUF','FREE','INTE',LIBUF,NBITM3+2)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************
Subroutine Start_Kriging(nPoints_In,nD_In,nInter_In,x_,dy_,y_)
  use kriging_mod
  Implicit None
#include "stdalloc.fh"
!
!    nPoints: the number of sample points, n
!    nInter: the dimensionality of the function, d
!    y_: the values of the function at the sample points
!    dy_: the gradient of the function at the sample points
!    x_: the coordinates of the sample points
!
  Integer nInter_In,nPoints_In,nD_In
  Real*8 x_(nInter_In,nPoints_In)
  Real*8 y_(nPoints_In)
  Real*8 dy_(nInter_In,nPoints_In)
!
!
#ifdef _DEBUGPRINT_
  Call RecPrt('Start_Kriging: x',' ',x_,nInter_In,nPoints_In)
  Call RecPrt('Start_Kriging: y',' ',y_,     1,nPoints_In)
  Call RecPrt('Start_Kriging: dy',' ',dy_,nInter,nPoints_In)
#endif
!
! Call Setup_Kriging to store the data in some internally protected arrays and scalars.
!
  Call Setup_Kriging(nPoints_In,nD_In,nInter_In,x_,dy_,y_)
!
!If (nPoints>2) Call PGEK()
!
!
! m_t is the dimentionality of the square correlation matrix Gradient-Psi
! (equation (2) on:
!-------- ref. = doi:10.1007/s00366-015-0397-y)-------
!
!
! In the case the nPoint_v last energies and nPoint_g last gradients were use
! m_t would be computed as
!
  m_t=nPoints + nInter*(nPoints-nD)
!
! full_R correspond to the gradient of Psi (eq. (2) ref.)
!
  Call mma_Allocate(full_R,m_t,m_t,Label="full_R")
  Call mma_Allocate(full_RInv,m_t,m_t,Label="full_RInv")
!
  If (mblAI) sbmev = y(maxloc(y,dim=1))

! Allocate x0, which is a n-dimensional vector of the coordinats of the last iteration computed
!
  Call mma_Allocate(x0,nInter,Label="nx")
!
! rl and dl are temporary matrices for the contruction of Psi which is inside of
! Grad-Psi (eq.(2) ref.) dl=rl^2=Sum[i] [(x_i-x0_i)/l)^2]
! more inoformation is given in subsequen files.
! Mat is the final matrix after the distance (between source data rl and dl) has
! passed through the Matern correlation function (ISBN 0-486-61272-4 & eq. (11-12)
! ref.).
!Iden is just an identity matrix necesary to avoid that the Grad-Psi becomes
! Singular after been multiplied by EPS factor
!
  Call mma_Allocate(rl,nPoints,nInter,Label="rl")
  Call mma_Allocate(dl,nPoints,Label="dl")
  Call mma_Allocate(Rones,m_t,Label="Rones")
!
!kv is the vector that contains the dot product of the inverse of Grad-Psi and
!Grad-y minus the dot product of the inverse of Grad-Psi and f-ones multiplied
! by the constant Grad-Trend function (eq. (3), (5), (6) and (7)
!ref.).
!Pred, gpred and hpred are the predicted energy, gradient and hessian according
! to the coordinates given by update_sl
!var is part of the GEK variance and the concentrated Likelihood function (eq.
! (8) and (9) ref.).
!Sigma is a dispersion function +-sigma=1.96*sqrt(abs(var*variance)) (need reference).
!cv is the covariant vector that contains the correlation function values and
! gradients between the sample data and the prediction
! (eq. 4 ref.).
!l is a n-dimensional vector of the width of the Matern function.
!ll is the likelihood function.
!
! Allocate additional variables needed for the kriging.
!
  Call mma_allocate(kv,m_t,Label="kv")
  Call mma_allocate(gpred,nInter,Label="gpred")
  Call mma_allocate(hpred,nInter,nInter,Label="hpred")
  Call mma_allocate(l,nInter,Label="l")
  Call mma_allocate(ll,int(lb(3)),Label="ll")
!
  Call mma_allocate(cv,m_t,nInter,nInter,Label="cv")
  Call mma_allocate(cvMatFder,nPoints,Label="cvMatFder")
  Call mma_allocate(cvMatSder,nPoints,Label="cvMatSder")
  Call mma_allocate(cvMatTder,nPoints,Label="cvMatTder")
!
  return
End Subroutine Start_Kriging

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine gen_oovo(w,l0,l1,tmp)
! this routine genetates (ij,a,k) integrals from
! blocked MO cholesky vectors
!
! --------
!
!       L0(m,IJ)    L0vctr  I>=J
!       L1(m,I ,A') L1vcxx xx - Group of A'

use ChT3_global, only: DimGrpaR, L1Name, LunAux, nc, no, nv, NvGrp
use Index_Functions, only: nTri_Elem
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: w(*), l0(*), tmp(*)
real(kind=wp), intent(inout) :: l1(*)
integer(kind=iwp) :: a, a_tmp, dima, last, length

!1 read tmp(m,IJ)

length = nc*nTri_Elem(no)

!mp !write(u6,'(A,A6)') 'L0vcrt ','L0vcrt'
!mp !write(u6,*) 'length = ',length
!mp !write(u6,*) 'file size (ifort) = ',8+8*length

call GetX_t3(tmp,length,LunAux,'L0vctr',1,1)

!2 map l0(IJ,m)   <- tmp(m,IJ)

call Map2_21_t3(tmp,l0,nc,nTri_Elem(no))

!3 loop over A'

do a=1,NvGrp
  !mp@@ dima = nv/NvGrp
  dima = DimGrpaR(a)

  !4 read tmp(m,I,A')

  !mp !write(u6,'(A,i3,2x,A6)') 'a,L1Name(a) ',a,L1Name(a)

  !mp@@ if (a == NvGrp) dima = nv-((NvGrp-1)*dima)

  !mp !write(u6,*) 'dima = ',dima
  length = nc*no*dima
  !mp !write(u6,*) 'length = ',length
  !mp !write(u6,*) 'file size (ifort) = ',8+8*length

  call GetX_t3(tmp,length,LunAux,L1Name(a),1,1)

  !5 grow l1(m,I,A)

  !mp last = (a-1)*(nv/NvGrp)

  last = 0
  if (a > 1) then
    do a_tmp=1,a-1
      last = last+DimGrpaR(a_tmp)
    end do
  end if

  call grow_l1(l1,tmp,dima,nc,no,nv,last)

  !6 end loop over A'

end do

!7 map tmp(m,A,I) <- l1(m,I,A)

call Map3_132_t3(l1,tmp,nc,no,nv)

!7.1 zero w

w(1:nTri_Elem(no)*nv*no) = Zero

!8  mult w(IJ,A,I)  <- l0(IJ,m) . tmp(m,A,I)

call mc0c1a3b(nTri_Elem(no),nc,nc,nv*no,nTri_Elem(no),nv*no,nTri_Elem(no),nc,nv*no,l0,tmp,w)

return

end subroutine gen_oovo

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Roland Lindh                                     *
************************************************************************
      Subroutine Gateway(iReturn)
************************************************************************
*                                                                      *
*     In the fall of 2006 Seward, Alaska and McKinley were in need     *
*     of a sibling. The new code would be the gateway into the         *
*     MOLCAS world for our future GUI. After some thoughts we          *
*     desided to call the gateway Gateway after the small village      *
*     Gateway, Alaska.                                                 *
*                                                                      *
*     Roland Lindh, 26th September 2006.                               *
*                                                                      *
************************************************************************
      use Period
      use GeoList
      use MpmC
      use Basis_Info
      use Center_Info
      use external_centers, only: iXPolType, XF
      use Temporary_parameters, only: Primitive_Pass, Expert, VarR,
     &                                VarT, DirInt
      use Sizes_of_Seward, only: S
      use RICD_Info, only: Do_RI, Cholesky, Cho_OneCenter
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      Integer AixRm
      External Get_Cho_1Center,AixRm
#include "Molcas.fh"
#include "status.fh"
#include "gateway.fh"
#include "rctfld.fh"
#include "stdalloc.fh"
#include "print.fh"
#include "vrsn_gateway.fh"
      Character xLblCnt(MxAtom)*(LENIN)
      Parameter (nMamn=MaxBfn+MaxBfn_Aux)
      Character*(LENIN8), Allocatable :: Mamn(:)
      Logical lOPTO, Pseudo, Do_OneEl
      Logical Get_Cho_1Center, Cho_1Center
CVV      LOGICAL GA_USES_MA,GA_MEMORY_LIMITED
C-SVC: identify runfile with a fingerprint
      Character cDNA*256
      Logical IsBorn, Found
      Real*8, Allocatable :: DCo(:,:), DCh(:), DCh_Eff(:)
      Integer, Allocatable :: nStab(:)
*                                                                      *
************************************************************************
*                                                                      *
C     Call Gateway_banner()
      iReturn = 0
*
*     If Gateway is running the Run_Mode on the runfile should always
*     be G_Mode.
*
      Run_Mode=G_Mode
      Call MkRun(iRC,0)
      Call Put_iScalar('Run_Mode',Run_Mode)
*
*     Determine and save the fingerprint of the runfile in a field with
*     label 'BirthCertificate' if it is empty.  This allows us to
*     uniquely identify the runfile and any later associated files.
*
      Call qpg_cArray('BirthCertificate',IsBorn,nDNA)
      IF (.NOT.IsBorn) THEN
        Call Get_Genome(cDNA,nDNA)
        Call Put_cArray('BirthCertificate',cDNA,nDNA)
      END IF
*                                                                      *
************************************************************************
*                                                                      *
*     Get the memory size available
*
      Call SetMem('Clear=Off')
*                                                                      *
************************************************************************
*                                                                      *
*     Initialize common blocks and start from scratch
*
      Call Seward_Init()
      Call Funi_Init()
      Call NQGrid_Init()
      Call Basis_Info_Init()
      Call Center_Info_Init()
*                                                                      *
************************************************************************
*                                                                      *
*     Spool the input
*
      LuSpool=21
      Call SpoolInp(LuSpool)
*                                                                      *
************************************************************************
*                                                                      *
*     Remove possible leftover files
*
      Call f_Inquire('UDC.Gateway',Found)
      If (Found) iRC = AixRm('UDC.Gateway')
      Call f_Inquire('UDC.NG',Found)
      If (Found) iRC = AixRm('UDC.NG')
*                                                                      *
************************************************************************
*                                                                      *
*     Read the input.
*
      lOPTO = .False.
      Call RdCtl_Seward(LuSpool,lOPTO,Do_OneEl)
*
*     Write the Basis_Info data to file. Release the arrays and read
*     them back from the runfile now allocating them to the proper
*     size.
*
      Call Basis_Info_Dmp()
      Call Basis_Info_Free()
      Call Basis_Info_Get()
      Call Center_Info_Dmp()
      Call Center_Info_Free()
      Call Center_Info_Get()
*                                                                      *
************************************************************************
*                                                                      *
*     Close Spool file
*
      Call Close_LuSpool(LuSpool)
*                                                                      *
************************************************************************
*                                                                      *
*     Print out section
*
      Call Print_Symmetry()
      Call Flip_Flop(.False.)
      Call Print_Basis(lOPTO)
      Call Print_Geometry(0)
      Call Print_Isotopes()
      If (nPrint(2).gt.0) nPrint(117)=6
      Call RigRot(Centr,Mass,S%kCentr)
      Call Print_Basis2()
      Call Print_OpInfo()
*                                                                      *
************************************************************************
*                                                                      *
*     Genetate the SO/AO basis set here.
*
      Primitive_Pass=.False.
      Call Flip_Flop(Primitive_Pass)
      Call mma_allocate(Mamn,nMamn,label='Mamn')
      Call SOCtl_Seward(Mamn,nMamn)
*                                                                      *
************************************************************************
*                                                                      *
      Call DmpInf()
*                                                                      *
************************************************************************
*                                                                      *
*     Produce minimal set of entries on the runfile to facilitate
*     Grid_It's and ExpBas's needs.
*
      Call Drvn0()
*
      Call Put_cArray('Unique Basis Names',Mamn(1),(LENIN8)*S%nDim)
      Call Put_iArray('NBAS',nBas,nIrrep)
      call basis2run()
      Call mma_deallocate(Mamn)
*
*     Generate list of unique atoms
*
      nNuc = 0
      Do iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%pChrg.and.
     &       .Not.dbsc(iCnttp)%Frag.and.
     &       .Not.dbsc(iCnttp)%Aux) nNuc = nNuc + dbsc(iCnttp)%nCntr
      End Do
*
      Call mma_allocate(DCo,3,nNuc)
      Call mma_allocate(DCh,nNuc)
      Call mma_allocate(DCh_Eff,nNuc)
      Call mma_allocate(nStab,nNuc)
      iDCo = 1
      iDCh = 1
      iDChE= 1
      mdc = 0
      iNuc = 0
      Do iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%pChrg.and.
     &       .Not.dbsc(iCnttp)%Frag.and.
     &       .Not.dbsc(iCnttp)%Aux) Then
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               mdc = mdc + 1
               iNuc = iNuc+ 1
               DCo(1:3,iNuc)=dbsc(iCnttp)%Coor(1:3,iCnt)
               DCh_Eff(iNuc)=dbsc(iCnttp)%Charge
               DCh(iNuc)=DBLE(dbsc(iCnttp)%AtmNr)
               xLblCnt(iNuc)=dc(mdc)%LblCnt(1:LENIN)
               nStab(iNuc)=dc(mdc)%nStab
            End Do
         Else
            mdc  = mdc + dbsc(iCnttp)%nCntr
         End If
      End Do
      Call Put_iScalar('Unique atoms',nNuc)
      Call Put_dArray('Unique Coordinates',DCo,3*nNuc)
      Call Put_dArray('Nuclear charge',DCh,nNuc)
      Call Put_dArray('Effective nuclear Charge',DCh_Eff,nNuc)
      Call Put_cArray('Unique Atom Names',xLblCnt(1),LENIN*nNuc)
      Call Put_iArray('nStab',nStab,nNuc)
*
      Call mma_deallocate(nStab)
      Call mma_deallocate(DCo)
      Call mma_deallocate(DCh)
      Call mma_deallocate(DCh_Eff)
*
*     Manipulate the option flag
*
      iOption=0
      If (DirInt) iOption=iOr(iOption,1)
      If (Expert) iOption=iOr(iOption,2)
      If (lRF) iOption=iOr(iOption,4)
      If (lLangevin.or.iXPolType.gt.0) iOption=iOr(iOption,8)
      If (PCM) Then
         iOption=iOr(iOption,16)
         nPCM_Info=0
         Call Put_iScalar('PCM info length',nPCM_Info)
      End If
      iOption=iOr(iOption,32)
      If (lRF.and..not.PCM) iOption=iOr(iOption,2**7)
      Pseudo=.False.
      Do iCnttp = 1, nCnttp
         Pseudo = Pseudo .or. (dbsc(iCnttp)%pChrg .and.
     &                         dbsc(iCnttp)%Fixed)
      End Do
      If (Allocated(XF).or.Pseudo) Then
         iOption=iOr(iOption,2**7)
         iOption=iOr(iOption,2**8)
      End If
      If (VarT) iOption=iOr(iOption,2**7)
      If (VarR) iOption=iOr(iOption,2**8)
* 2el-integrals from the Cholesky vectors
      If (Cholesky.or.Do_RI) iOption=iOr(iOption,2**9)
*     RI-Option
      If (Do_RI) iOption=iOr(iOption,2**10)
*     1C-CD
      Cho_1Center=Get_Cho_1Center()
      If (Cholesky.and.Cho_1Center) iOption=iOr(iOption,2**12)
      Cho_OneCenter=Cho_1Center
      Call Put_iScalar('System BitSwitch',iOption)
      iter_S=0
      Call Put_iScalar('Saddle Iter',iter_S)
*                                                                      *
************************************************************************
*                                                                      *
      Call ClsSew()
      If (Allocated(AdCell)) Call mma_deallocate(AdCell)
      Call mma_deallocate(Coor_MPM)
      Call mma_deallocate(Chrg)
      Call mma_deallocate(Mass)
      Call mma_deallocate(Centr)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      Logical Function Get_Cho_1Center()
#include "cholesky.fh"
      Get_Cho_1Center=Cho_1Center
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Markus P. Fuelscher                              *
!***********************************************************************

function PageNo(iRoot)
!***********************************************************************
!                                                                      *
!     purpose:                                                         *
!     Compute the page number of a vector                              *
!                                                                      *
!     calling arguments:                                               *
!     iRoot   : integer                                                *
!               root number                                            *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M.P. Fuelscher                                                   *
!     University of Lund, Sweden, 1996                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use davctl_mod, only: istart, n_Roots, nvec
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: PageNo
integer(kind=iwp), intent(in) :: iRoot
integer(kind=iwp) :: itmp1
#include "rasdim.fh"

itmp1 = iRoot
if (iRoot > n_Roots) then
  itmp1 = n_Roots+mod(istart+iRoot-n_Roots-1,nvec-n_Roots)+1
end if
PageNo = itmp1

return

end function PageNo

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2016, Ignacio Fdez. Galvan                             *
!***********************************************************************

subroutine Process_Track()

use Slapaf_Info, only: Request_RASSI, RootMap
use PrintLevel, only: nPrint
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, MaxId(2), nOv, nRoots
logical(kind=iwp) :: Done, Found
character(len=8) :: Method
integer(kind=iwp), allocatable :: OldMap(:), RootIdx(:)
real(kind=wp), allocatable :: Overlaps(:,:), Ovlp(:)

call Get_cArray('Relax Method',Method,8)
if ((Method /= 'CASSCF') .and. (Method /= 'RASSCF') .and. (Method /= 'CASSCFSA') .and. (Method /= 'RASSCFSA') .and. &
    (Method /= 'CASPT2') .and. (Method /= 'RASPT2')) then
  call WarningMessage(2,'Error in Process_Track')
  write(u6,*) '***************** ERROR ********************'
  write(u6,*) ' The TRACK keyword can only be used with'
  write(u6,*) ' states computed by the RASSCF or CASPT2'
  write(u6,*) ' programs.'
  write(u6,*) '********************************************'
  call Quit_OnUserError()
end if

! Find the number of roots, and whether state overlaps are available

nRoots = 1
call Qpg_iScalar('Number of roots',Found)
if (Found) call Get_iScalar('Number of roots',nRoots)
call qpg_dArray('State Overlaps',Found,nOv)
if (Found .and. (nOv == (2*nRoots)**2)) then
  Request_RASSI = .false.
else
  Request_RASSI = .true.
end if

! Make sure that the root mapping is only done once per iteration

call Qpg_iScalar('Track Done',Done)
call Get_lScalar('Track Done',Done)
if (Request_RASSI .or. Done) return

! Modify the root map according to the overlaps:
!
!   RootMap(i) = N
!
! where i is the original root number (at iter=1), and N is the
! root number at the current iteration.

call mma_allocate(Ovlp,nOv)
call mma_allocate(Overlaps,nRoots,nRoots)
call get_dArray('State Overlaps',Ovlp,nOv)
do i=1,nRoots
  Overlaps(:,i) = Ovlp((2*i-1)*nRoots+1:2*i*nRoots)
end do
call mma_deallocate(Ovlp)
if (nPrint(1) >= 5) then
  call RecPrt('Overlaps with previous states','',Overlaps,nRoots,nRoots)
  call mma_allocate(OldMap,nRoots)
  OldMap(:) = RootMap(1:nRoots)
end if
call mma_allocate(RootIdx,nRoots)
do i=1,nRoots
  MaxId = maxloc(abs(Overlaps))
  RootIdx(MaxId(1)) = MaxId(2)
  Overlaps(MaxId(1),:) = Zero
  Overlaps(:,MaxId(2)) = Zero
end do
do i=1,nRoots
  RootMap(i) = RootIdx(RootMap(i))
end do
call Put_iArray('Root Mapping',RootMap,nRoots)
if (nPrint(1) >= 5) then
  write(u6,*)
  write(u6,100) 'Root map'
  write(u6,*)
  write(u6,100) 'Original  Prev.  This'
  write(u6,100) '  root    iter.  iter.'
  write(u6,100) '----------------------'
  do i=1,nRoots
    write(u6,101) i,OldMap(i),RootMap(i)
  end do
  write(u6,100) '----------------------'
  write(u6,*)
  call mma_deallocate(OldMap)
end if

call mma_deallocate(RootIdx)
call mma_deallocate(Overlaps)

! Update the RunFile for automatic gradients

call Qpg_iScalar('Relax CASSCF root',Found)
if (Found) then
  call Get_iScalar('Relax CASSCF root',i)
  if (RootMap(i) /= i) then
    call Put_iScalar('Relax CASSCF root',RootMap(i))
    call Put_iScalar('Relax Original root',RootMap(i))
  end if
end if
call Qpg_iScalar('NumGradRoot',Found)
if (Found) then
  call Get_iScalar('NumGradRoot',i)
  if (RootMap(i) /= i) call Put_iScalar('NumGradRoot',RootMap(i))
end if
call Put_lScalar('Track Done',.true.)

return

100 format(3X,A)
101 format(3X,I6,1X,I6,1X,I6)

end subroutine Process_Track

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_RSTMOL(NERR)
C
C     Purpose: check restart molecular info.
C
      IMPLICIT NONE
      INTEGER NERR
#include "cholesky.fh"
#include "choorb.fh"

      INTEGER ISYM

      NERR = 0

      IF (XNSYM .NE. NSYM) THEN
         WRITE(LUPRI,'(A,I3,A,I3)')
     &   'RESTART ERROR: #irreps from restart file:',XNSYM,
     &   ' Expected:',NSYM
         NERR = NERR + 1
      ELSE
         DO ISYM = 1,NSYM
            IF (XNBAS(ISYM) .NE. NBAS(ISYM)) THEN
               WRITE(LUPRI,'(A,I2,A,I9,A,I9)')
     &         'RESTART ERROR: #basis functions (sym.',ISYM,
     &         ') from restart file:',XNBAS(ISYM),
     &         ' Expected:',NBAS(ISYM)
               NERR = NERR + 1
            END IF
         END DO
      END IF

      IF (XNSHELL .NE. NSHELL) THEN
         WRITE(LUPRI,'(A,I9,A,I9)')
     &   'RESTART ERROR: #shells from restart file:',XNSHELL,
     &   ' Expected:',NSHELL
         NERR = NERR + 1
      END IF

      IF (XNNSHL .NE. NNSHL) THEN
         WRITE(LUPRI,'(A,I9,A,I9)')
     &   'RESTART ERROR: #shell pairs from restart file:',XNNSHL,
     &   ' Expected:',NNSHL
         NERR = NERR + 1
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989,1991,1993, Jeppe Olsen                            *
************************************************************************
      SUBROUTINE CNFSTR_MCLR(ICONF,ITYP,IASTR,IBSTR,NORB,NAEL,NBEL,
     &                  IDET,IPRODT,IAGRP,IBGRP,ISCR,SIGN,NTEST)
*
* An orbital configuration ICONF is given,
* Obtain the corresponding alpha strings,IASTR
*        the corresponding beta  strings,IBSTR
*        the corresponding sign array   ,ISIGN
*
* Jeppe Olsen , Summer of 89
*
* Ninob added , October 1991
*
* Modified September 1993 for LUCIA
*
      IMPLICIT REAL*8 ( A-H,O-Z)
*. Specific input
      INTEGER ICONF(*)
*. General input
      INTEGER IPRODT(*)
*
*. Scratch : required length : IDET * ( NAEL + NBEL ) + 2(NAEL+NBEL)
* ( this includes NAEL+NBEL words needed in DETSTR )
      INTEGER ISCR(*)
*. Output
      DIMENSION IASTR(*),IBSTR(*), SIGN(*)
*
#include "detdim.fh"
#include "spinfo_mclr.fh"
*
*
      NEL = NAEL + NBEL
      IOPEN = ITYP-1+MINOP
      ICLOS = (NAEL + NBEL - IOPEN) / 2
*
** Spin orbital occupations of determinants of configuration
*
      KLFREE = 1
*
      KLDETS = KLFREE
      KLFREE = KLDETS + IDET*(NAEL+NBEL)
*
      KLIA = KLFREE
      KLFREE = KLFREE + NAEL
*
      KLIB = KLFREE
      KLFREE = KLFREE + NBEL
*
      KLDET  = KLFREE
      KLFREE = KLFREE + NAEL + NBEL
*

* Pointer for determinants of prototype ITYP

      IP = 1
      DO 10 JTYP = 1, ITYP - 1
        IP = IP + NDPCNT(JTYP)*(JTYP-1+MINOP)
   10 CONTINUE
*. Expand into determinants
*
      CALL CNDET_MCLR(ICONF,IPRODT(IP),IDET,NAEL+NBEL,NORB,
     &           IOPEN,ICLOS,ISCR(KLDETS),NTEST)
*
** Separate determinants into strings and determine sign change
*
      DO 100 JDET = 1, IDET
        CALL DETSTR_MCLR(ISCR(KLDETS+(JDET-1)*NEL),
     &              ISCR(KLIA),ISCR(KLIB),
     &              NEL,NAEL,NBEL,
     &              NORB,ISIGN,ISCR(KLDET),NTEST)
*. Actual numbers of alpha and beta string
        IASTR(JDET) = ISTRN_MCLR(ISCR(KLIA),IAGRP)
        IBSTR(JDET) = ISTRN_MCLR(ISCR(KLIB),IBGRP)
        SIGN(JDET) = DBLE(ISIGN)
  100 CONTINUE
*
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Per Ake Malmqvist                                *
************************************************************************
*****************************************************************
*  PROGRAM RASSI        PER-AAKE MALMQVIST 2000-06-30
*  SUBROUTINE TRAINT
*  TRANSFORM TWO-ELECTRON INTEGRALS TO A MIXED ACTIVE ORBITAL
*  BASIS. THE RESULTING INTEGRALS ARE STORED IN ARRAY TUVX IN
*  THE SAME FORMAT AS THE 2-EL TRANSITION DENSITY MATRICES.
*****************************************************************
      SUBROUTINE TRAINT(CMO1,CMO2,NGAM2,TUVX)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CMO1(NCMO),CMO2(NCMO),TUVX(NGAM2)
#include "rassi.fh"
#include "symmul.fh"
#include "WrkSpc.fh"
      COMMON/TRNSFRM/ NPQ,NBPQ,NBRS,LADX,NAVX,NAP,NAQ,NAR,NAS,
     *               NBP,NBQ,NBR,NBS,ISP,ISQ,ISR,ISS,IAPR(8),
     *               LMOP1,LMOQ1,LMOR1,LMOS1,NX1MX,NX2MX,
     *               NX3MX,NVXPQ
      DIMENSION KEEP(8),NBSX(8)
      LOGICAL   ISQARX
C CLEAR THE ARRAY OF TRANSFORMED INTEGRALS.
      CALL FZERO(TUVX,NGAM2)
C RETRIEVE STRUCTURE DATA FOR THE ORDERED INTEGRAL FILE.
C KEEP(IS) IS POSITIVE TO INDICATE THAT BASIS FUNCTIONS WITH
C SYMMETRY LABEL IS SHOULD BE SKIPPED. KEEP(2)=0 OR 1 TO SHOW
C IF SYMMETRY LABELS IJKL OF EACH SYMMETRY BLOCK ARE CANONICAL
C (ONLY CASES I>=J,K>=L,IJ>=KL PRESENT) OR IF LEFT AND RIGHT HAND
C PAIR ARE INDIVIDUALLY TREATED (I>=J,K>=L), RESPECTIVELY.
C THE IDATA ARRAY GIVES DISK ADDRESS, AND NUMBER OF INTEGRAL MATRICES
C PER BUFFER, FOR EACH SYMMETRY BLOCK. THERE ARE AT MOST 176 SUCH
C BLOCKS, AND THEIR ORDERING IS DETERMINED BY THE SYMMETRY
C LOOPS, WHICH MUST BE THE SAME AS IN THE ORDERING PROGRAM.
C RETRIEVE BASE DATA FROM UNIT LUORD:
C RETRIEVE BASE DATA FROM UNIT LUORD:
      IRC=0
      CALL GETORD(IRC,ISQARX,NSYMX,NBSX,KEEP)
C SET UP IAPR(IS)=NR OF ACTIVES WITH PREVIOUS SYMMETRY LABEL.
      IA=0
      DO 10 IS=1,NSYM
        IAPR(IS)=IA
        IA=IA+NASH(IS)
10    CONTINUE
C LOOP OVER QUADRUPLES OF SYMMETRIES (NSP,NSQ,NSR,NSS) NSR>=NSS
C IN THE SAME ORDER AS IN THE INTORD PROGRAM.
      INTBUF=MAX(NBMX**2,256*256)
      LMOP=1
      DO 104 NSP=1,NSYM
       IF(NSP.NE.1) LMOP=LMOP+NBASF(NSP-1)*NOSH(NSP-1)
       NAP=NASH(NSP)
C      KEEPP=KEEP(NSP)
       NBP=NBASF(NSP)
       ISP=NSP
       LMOP1=LMOP+NISH(NSP)*NBP
       LMOQ=1
       DO 103 NSQ=1,NSP
        IF(NSQ.NE.1) LMOQ=LMOQ+NBASF(NSQ-1)*NOSH(NSQ-1)
        NAQ=NASH(NSQ)
C       KEEPQ=KEEP(NSQ)
        NBQ=NBASF(NSQ)
        NSPQ=MUL(NSP,NSQ)
        ISQ=NSQ
        ISPQ=(ISP**2-ISP)/2+ISQ
        LMOQ1=LMOQ+NISH(NSQ)*NBQ
        LMOR=1
        NSRM=NSYM
        IF(ISQARX) NSRM=NSP
        DO 102 NSR=1,NSRM
         IF(NSR.NE.1) LMOR=LMOR+NBASF(NSR-1)*NOSH(NSR-1)
         NAR=NASH(NSR)
C        KEEPR=KEEP(NSR)
         NBR=NBASF(NSR)
         LMOR1=LMOR+NBR*NISH(NSR)
         NSPQR=MUL(NSPQ,NSR)
         ISR=NSR
         LMOS=1
         NSSM=NSR
         DO 101 NSS=1,NSSM
          IF(NSS.NE.1) LMOS=LMOS+NBASF(NSS-1)*NOSH(NSS-1)
          IF(NSPQR.NE.NSS) GO TO 101
          NAS=NASH(NSS)
C         KEEPS=KEEP(NSS)
          NBS=NBASF(NSS)
          LMOS1=LMOS+NBS*NISH(NSS)
          ISS=NSS
          ISRS=(ISR**2-ISR)/2+ISS
C SHOULD THIS SYMMETRY BLOCK BE USED...?
C         KEEPT=KEEPP+KEEPQ+KEEPR+KEEPS
          NACT=NAP*NAQ*NAR*NAS
C ...WELL, IT IS PRESENT ON THE FILE
          IF(ISPQ.LT.ISRS) GO TO 101
          IF(NACT.EQ.0) GO TO 101
C ALLOCATE WORK AREAS FOR IN-CORE TRANSFORMATION ROUTINE TRACR:
          IF(ISR.EQ.ISS) THEN
            NBPQ=(NBP+NBP**2)/2
            NBRS=(NBR+NBR**2)/2
          ELSE
            NBPQ=NBP*NBQ
            NBRS=NBR*NBS
          ENDIF
          NAVX=NAR*NAS
          NX1MX=MAX(INTBUF,NBP*NAQ,NBQ*NAP)
          NX2MX=MAX(NBR*NBS,NAP*NAQ)
          NX3MX=MAX(NBR*NAS,NAR*NBS,NBP*NBQ)
          NVXPQ=NAVX*NBPQ
          CALL GETMEM('X1    ','ALLO','REAL',LX1,NX1MX)
          CALL GETMEM('X2    ','ALLO','REAL',LX2,NX2MX)
          CALL GETMEM('X3    ','ALLO','REAL',LX3,NX3MX)
          CALL GETMEM('VXPQ  ','ALLO','REAL',LVXPQ,NVXPQ)
          CALL TRACR( INTBUF,CMO1,CMO2,NGAM2,TUVX,
     *                WORK(LX1),WORK(LX2),WORK(LX3),WORK(LVXPQ))
          CALL GETMEM('      ','FREE','REAL',LX1,NX1MX)
          CALL GETMEM('      ','FREE','REAL',LX2,NX2MX)
          CALL GETMEM('      ','FREE','REAL',LX3,NX3MX)
          CALL GETMEM('      ','FREE','REAL',LVXPQ,NVXPQ)
101      CONTINUE
102     CONTINUE
103    CONTINUE
104   CONTINUE
      Call GADSum(TUVX,NGAM2)
C     WRITE(6,3000) (TUVX(I),I=1,NGAM2)
C3000 FORMAT(/1X,'TRANSFORMED TWO-ELECTRON INTEGRALS'/(1X,7F10.6))
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2004,2008, Thomas Bondo Pedersen                       *
!***********************************************************************

subroutine ChoMP2_DecDrv(irc,DelOrig,Diag,CD_Type)
!
! Thomas Bondo Pedersen, Dec. 2004.
! * Amplitude extension, Thomas Bondo Pedersen, Dec. 2007/Jan. 2008.
!
! Purpose: decompose (ai|bj) integrals or
!          amplitudes [(ai|bj)/e(a)-e(i)+e(b)-e(j)]
!          for use in Cholesky MP2 program.
!
! Arguments:
! irc...... OUT: return code - if non-zero, decomposition failed.
!           Caller MUST check this!
! DelOrig.. INP: flag for deleting files with original vectors after
!           decomposition completes.
! Diag..... INP: integral diagonal (ai|ai) or
!           amplitude diagonal (ai|ai)/2[e(a)-e(i)]
! CD_Type.. INP: string
!           'Integrals'  - integral decomposition
!           'Amplitudes' - amplitude decomposition
!
! Other input such as orbital energies are read from mbpt2 include
! files.

use Cholesky, only: lBuf, nSym, NumCho, Span
use Cho_interfaces, only: cdcol_kernel, cdvec_kernel
use ChoMP2, only: ChkDecoMP2, Incore, iOption_MP2CD, lUnit_F, MxQual_Def, MxQualMP2, nMP2Vec, NowSym, nT1am, OldVec, SpanMP2, &
                  ThrMP2, Verbose
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(out) :: irc
logical(kind=iwp), intent(in) :: DelOrig
real(kind=wp), intent(in) :: Diag(*)
character(len=*) :: CD_Type
integer(kind=iwp) :: iAdr, iBin, iClos(2), iOpt, IOPTION, ISYM, iTyp, kOffD, lB, LEFT, LERRSTAT, lTot, MxCDVec(8), MxQual, nBin, &
                     nDim, nInc
real(kind=wp) :: THR, XMN, XMX, RMS
logical(kind=iwp) :: Failed, ConventionalCD
character(len=18) :: Option
integer(kind=iwp), allocatable :: iPivot(:), iQual(:)
real(kind=wp), allocatable :: Bin(:), Buf(:), ErrStat(:), Qual(:)
integer(kind=iwp), parameter :: nOption = 2
logical(kind=iwp), parameter :: Restart = .false.
character(len=*), parameter :: SecNam = 'ChoMP2_DecDrv'
procedure(cdcol_kernel) :: ChoMP2_Col
procedure(cdvec_kernel) :: ChoMP2_Vec

! Initializations.
! ----------------

irc = 0

#ifdef _DEBUGPRINT_
ChkDecoMP2 = .true.
#endif

if (len(CD_Type) < 1) then ! input error
  iOption = 0
  Option = 'Unknown !?!?!     '
else
  if ((CD_Type(1:1) == 'i') .or. (CD_Type(1:1) == 'I')) then
    iOption = 1
    Option = '(ai|bj) integrals '
  else if ((CD_Type(1:1) == 'a') .or. (CD_Type(1:1) == 'A')) then
    iOption = 2
    Option = 'MP2 amplitudes    '
  else
    iOption = nOption+1
    Option = 'Unknown !?!?!     '
  end if
end if
if ((iOption < 1) .or. (iOption > nOption)) then
  irc = -98
  write(u6,*) SecNam,': illegal input option (argument CD_Type)'
  return
end if
iOption_MP2CD = iOption  ! copy to include file chomp2_dec.fh
!-TBP:
! Frankie,
! I use the array MxCDVec(iSym) to decide whether the decomposition
! of a given symmetry block is conventional or "MaxVec":
!ConventionalCD = (MxCDVec(iSym) < 1) .or. (MxCDVec(iSym) >= nT1Am(iSym))
! You may want to calculate the MxCDVec values somewhere else and store
! them in an include-file (say, chomp2_dec.fh).
! For now, I simply define the array here:
MxCDVec(1:nSym) = nT1Am(1:nSym)

lErrStat = 3
call mma_allocate(ErrStat,lErrStat,Label='ErrStat')
if (Verbose) then
  nBin = 18
  call mma_allocate(Bin,nBin,Label='Bin')
else
  nBin = 0
  call mma_allocate(Bin,1,Label='Bin')
end if

nMP2Vec(1:nSym) = 0
InCore(1:nSym) = .false.
NowSym = -999999

if (DelOrig) then
  iClos(1) = 3  ! signals close and delete original vectors
else
  iClos(1) = 2  ! signals close and keep original vectors
end if
iClos(2) = 2     ! signals close and keep result vectors

! Print.
! ------

if (Verbose) then
  write(u6,*)
  call Cho_Head('Cholesky decomposition of '//Option,'=',80,u6)
  write(u6,'(/,1X,A)') 'Configuration of decomposition:'
  write(u6,'(1X,A,ES15.6)') 'Threshold: ',ThrMP2
  write(u6,'(1X,A,ES15.6)') 'Span     : ',SpanMP2
  if (ChkDecoMP2) write(u6,'(1X,A)') 'Full decomposition check activated.'
end if

! Start symmetry loop.
! --------------------

kOffD = 1
do iSym=1,nSym

  nDim = nT1am(iSym)
  if ((nDim > 0) .and. (NumCho(iSym) > 0)) then

    ConventionalCD = (MxCDVec(iSym) < 1) .or. (MxCDVec(iSym) >= nDim)
    if (Verbose .and. (nBin > 0)) then
      Bin(1) = 1.0e2_wp
      do iBin=2,nBin
        Bin(iBin) = Bin(iBin-1)*1.0e-1_wp
      end do
      if (ConventionalCD) then
        write(u6,'(//,1X,A,I2,A,I9)') '>>> Conventional Cholesky decomposition of symmetry block ',iSym,', dimension: ',nDim
      else
        write(u6,'(//,1X,A,I2,A,I9)') '>>> MaxVec Cholesky decomposition of symmetry block ',iSym,', dimension: ',nDim
      end if
      write(u6,'(/,1X,A)') 'Analysis of initial diagonal:'
      call Cho_AnaSize(Diag(kOffD),nDim,Bin,nBin,u6)
    end if

    ! Open files.
    ! -----------

    do iTyp=1,2
      call ChoMP2_OpenF(1,iTyp,iSym)
    end do

    ! Setup decomposition.
    ! --------------------

    NowSym = iSym

    if (MxQualMP2 /= MxQual_Def) then ! user-defined
      MxQual = min(max(MxQualMP2,1),nDim)
    else ! default
      if (nDim > 10) then
        MxQual = max(min(nDim/10,MxQualMP2),1)
      else
        MxQual = max(min(nDim,MxQualMP2),1)
      end if
    end if
#   ifndef _I8_
    lTstBuf = (nDim+MxQual)*MxQual
    lTstQua = nDim*(MxQual+1)
    do while (((lTstBuf < 0) .or. (lTstQua < 0)) .and. (MxQual > 0))
      MxQual = MxQual-1
      lTstBuf = (nDim+MxQual)*MxQual
      lTstQua = nDim*(MxQual+1)
    end do
    if (MxQual < 1) then
      write(u6,*) SecNam,': MxQual causes integer overflow!'
      write(u6,*) SecNam,': parameters:'
      write(u6,*) 'Symmetry block: ',iSym
      write(u6,*) 'Dimension     : ',nDim
      write(u6,*) 'MxQual        : ',MxQual
      irc = -99
      call Finish_this()
      return
    end if
#   endif

    call mma_allocate(Qual,nDim*(MxQual+1),Label='Qual')
    call mma_allocate(iQual,MxQual,Label='iQual')
    call mma_allocate(iPivot,nDim,Label='iPivot')

    call mma_maxDBLE(lB)
    lBuf = min((nDim+MxQual)*MxQual,lB)
    Left = lB-lBuf
    nInC = Left/nDim
    if (nInC >= NumCho(iSym)) then
      InCore(iSym) = .true.
      lTot = nDim*NumCho(iSym)
      call mma_allocate(OldVec,lTot,Label='OldVec')
      iOpt = 2
      iAdr = 1
      call ddaFile(lUnit_F(iSym,1),iOpt,OldVec,lTot,iAdr)
    end if
    call mma_maxDBLE(lBuf)
    call mma_allocate(Buf,lBuf,Label='Buf')

    ! Decompose this symmetry block.
    ! ------------------------------

    Thr = ThrMP2
    Span = SpanMP2
    if (ConventionalCD) then
      call ChoDec(ChoMP2_Col,ChoMP2_Vec,Restart,Thr,Span,MxQual,Diag(kOffD),Qual,Buf,iPivot,iQual,nDim,lBuf,ErrStat,nMP2Vec(iSym), &
                  irc)
      if (irc /= 0) then
        write(u6,*) SecNam,': ChoDec returned ',irc,'   Symmetry block: ',iSym
        call Finish_this()
        return
      end if
    else
      call ChoDec_MxVec(ChoMP2_Col,ChoMP2_Vec,MxCDVec(iSym),Restart,Thr,Span,MxQual,Diag(kOffD),Qual,Buf,iPivot,iQual,nDim,lBuf, &
                        ErrStat,nMP2Vec(iSym),irc)
      if (irc /= 0) then
        write(u6,*) SecNam,': ChoDec_MxVec returned ',irc,'   Symmetry block: ',iSym
        call Finish_this()
        return
      end if
    end if
    XMn = ErrStat(1)
    XMx = ErrStat(2)
    RMS = ErrStat(3)
    if (Verbose) then
      write(u6,'(/,1X,A)') '- decomposition completed!'
      write(u6,'(1X,A,I9,A,I9,A)') 'Number of vectors needed: ',nMP2Vec(iSym),' (number of AO vectors: ',NumCho(iSym),')'
      if (.not. ConventionalCD) write(u6,'(1X,A,I9)') 'Max. number of vectors allowed: ',MxCDVec(iSym)
      write(u6,'(1X,A)') 'Error statistics for diagonal [min,max,rms]:'
      write(u6,'(1X,3(ES15.6,1X))') XMn,XMx,RMS
    end if
    if (ConventionalCD) then
      Failed = (abs(Xmn) > Thr) .or. (abs(XMx) > thr) .or. (RMS > Thr)
    else
      Failed = abs(Xmn) > Thr
    end if
    if (Failed) then
      if (.not. Verbose) then
        write(u6,'(1X,A)') 'Error statistics for diagonal [min,max,rms]:'
        write(u6,'(1X,3(ES15.6,1X))') XMn,XMx,RMS
      end if
      write(u6,'(A,A,A,A)') SecNam,': decomposition of ',Option,' failed!'
      irc = -9999
      call Finish_this()
      return
    end if

    ! If requested, check decomposition.
    ! ----------------------------------

    if (ChkDecoMP2) then
      write(u6,*)
      write(u6,'(A,A,A)') SecNam,': Checking decomposition of ',Option
      write(u6,*) 'Symmetry block: ',iSym
      write(u6,*) 'Threshold, Span, MxQual: ',Thr,Span,MxQual
      write(u6,*) 'Error statistics for diagonal [min,max,rms]:'
      write(u6,*) ErrStat(:)
      call ChoMP2_DecChk(irc,iSym,Qual,nDim,MxQual,Buf,lBuf,ErrStat)
      if (irc /= 0) then
        if (irc == -123456) then
          write(u6,*) ' -- Sorry, full decomposition check not yet implemented --'
          irc = 0
        else
          write(u6,*) SecNam,': ChoMP2_DecChk returned ',irc,'   Symmetry block: ',iSym
          call SysAbendMsg(SecNam,'decomposition failed!',' ')
        end if
      else
        XMn = ErrStat(1)
        XMx = ErrStat(2)
        RMS = ErrStat(3)
        write(u6,'(A,A,A)') 'Error statistics for ',Option,' [min,max,rms]:'
        write(u6,*) XMn,XMx,RMS
        Failed = Failed .or. (abs(Xmn) > Thr) .or. (abs(XMx) > Thr) .or. (RMS > Thr)
        if (ConventionalCD) then
          if (Failed) then
            write(u6,*) '==> DECOMPOSITION FAILURE <=='
            irc = -9999
            call Finish_this()
            return
          else
            write(u6,*) '==> DECOMPOSITION SUCCESS <=='
          end if
        else
          if (Failed) then
            write(u6,*) '==> DECOMPOSITION SUCCESS <== (by definition)'
          else
            write(u6,*) '==> DECOMPOSITION SUCCESS <=='
          end if
        end if
        call xFlush(u6)
      end if
    end if

    ! Free memory.
    ! ------------

    call mma_deallocate(Buf)
    if (InCore(iSym)) call mma_deallocate(OldVec)
    call mma_deallocate(iPivot)
    call mma_deallocate(iQual)
    call mma_deallocate(Qual)

    ! Close (possibly deleting original) files.
    ! -----------------------------------------

    do iTyp=1,2
      call ChoMP2_OpenF(iClos(iTyp),iTyp,iSym)
    end do

    ! Update pointer to diagonal block.
    ! ---------------------------------

    kOffD = kOffD+nT1am(iSym)

  else

    if (Verbose) write(u6,'(//,1X,A,I2,A)') '>>> Symmetry block',iSym,' is empty!'

  end if

end do

call Finish_this()

contains

subroutine Finish_this()

  integer(kind=iwp) :: iSym, iTyp

  if (irc /= 0) then ! make sure files are closed before exit
    do iSym=1,nSym
      do iTyp=1,2
        call ChoMP2_OpenF(2,iTyp,iSym)
      end do
    end do
  end if

  call mma_deallocate(Bin)
  call mma_deallocate(ErrStat)

end subroutine Finish_this

end subroutine ChoMP2_DecDrv

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine hini_cvb()
      implicit real*8(a-h,o-z)
#include "inpmod_cvb.fh"
#include "WrkSpc.fh"
#include "seth_cvb.fh"
#include "loopcntr_cvb.fh"
#include "files_cvb.fh"

      loopstep=0
      joptstep=0
      if(inputmode.eq.1)then
        ncnt=0
        recn=recn_tmp03
        call bufio_init_cvb(recn)
      elseif(inputmode.eq.2)then
        icnt=0
        call bufio_init_cvb(recn)
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dRBuf(Array,nArray,Copy)

use dEAF, only: dEAFARead
use IOBUF, only: Buffer, Disk, Disk_1, Disk_2, DiskMX_Byte, iBuf, iD, InCore, iPos, lBuf, LuTmp, OnDisk
use Definitions, only: wp, iwp, RtoB, RtoI

implicit none
integer(kind=iwp), intent(in) :: nArray
real(kind=wp), intent(inout) :: Array(nArray)
logical(kind=iwp), intent(in) :: Copy
integer(kind=iwp) :: iArray, jBuf, Left, mArray
real(kind=wp) :: Temp

!write(u6,*) 'Enter RBuf: iPos @',iPos,'iBuf=,lBuf',iBuf,lBuf
if (InCore .and. (iBuf == 2)) then
  call WarningMessage(2,'Error in in-core semi-direct implementation')
  call Abend()
end if
iArray = 1
mArray = nArray
do while (mArray >= 1)
  if (iPos == 1) then

    ! Wait for pending buffer.

    !write(u6,*) 'In drbuf.'
    if (OnDisk) call EAFWait(LuTmp,id)

    ! Get the next buffer, make sure that request is not beyond
    ! the disc limitation.

    temp = Disk+real(lBuf*RtoB,kind=wp)
    !write(u6,*) 'temp=',temp
    if (temp <= DiskMx_Byte) then
      if (iBuf == 1) then
        jBuf = 2
      else
        jBuf = 1
      end if
      Disk_2 = Disk_1
      Disk_1 = Disk
      !write(u6,*) 'RBuf aread on disk @',Disk,'jBuf=',jBuf
      if (OnDisk) call dEAFARead(LuTmp,Buffer(1,jBuf),lBuf*RtoI,Disk,id)
    end if
  end if
  Left = lBuf-iPos+1
  if (mArray > Left) then
    if (Copy) Array(iArray:iArray+Left-1) = Buffer(iPos:,iBuf)
    iArray = iArray+Left
    mArray = mArray-Left
    iPos = 1
    !write(u6,*) 'LuTmp,Disk=',LuTmp,Disk
    ! Swap buffer
    if (iBuf == 1) then
      iBuf = 2
    else
      iBuf = 1
    end if
  else
    !write(u6,*) ' Copy ',mArray,'elements from buffer',iPos
    if (Copy) Array(iArray:iArray+mArray-1) = Buffer(iPos:iPos+mArray-1,iBuf)
    iPos = iPos+mArray
    mArray = 0
  end if
end do

!write(u6,*) 'Exit RBuf: iPos @',iPos,'iBuf=',iBuf
return

end subroutine dRBuf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SetPos_m(LUnit,KeyIn,Line,iRc)
      Implicit Real*8 (A-H,O-Z)
      Character*(*) KeyIn
      Character*(*) Line
      Character*16 Command
      Character*16 Key
#include "warnings.fh"
#include "rasdim.fh"
#include "input_ras.fh"
#include "output_ras.fh"
      Parameter(ROUTINE='SetPos  ')
      Intrinsic len, min
* Read until, and including, a line beginning with a particular
* string in an ASCII file, assumed already opened, with unit
* number LUnit. That line is returned.
* Key lengths up to 16 bytes can be used, it is determined by
* the size of the input variable.
*
      IPRLEV=IPRLOC(1)
      iRc=_RC_ALL_IS_WELL_
      KLen=MIN(16,LEN(KeyIn))
      Key=' '
      Command=' '
      Rewind(LUnit)

      Key(1:KLen)=KeyIn(1:KLen)
      call upcase(Key)
10    Continue
      Read(LUnit,'(A)',End=9910,Err=9920) Line
      Command(1:KLen)=Line(1:KLen)
      call upcase(Command)
      If (Command.ne.Key) GoTo 10
      Return

*---  Error exits ----------------------
9910  CONTINUE
      If(IPRLEV.ge.TERSE) Then
       write(6,*)' SETPOS: Attempt to find an input line beginning'
       write(6,*)' with the keyword ''',KeyIn,''' failed.'
      End If
*      Call Quit(_RC_INPUT_ERROR_)
      iRc=_RC_INPUT_ERROR_
      Return
9920  CONTINUE
      If(IPRLEV.ge.TERSE) Then
       write(6,*)' SETPOS: Attempt to find an input line beginning'
       write(6,*)' with the keyword ''',KeyIn,''' failed.'
      End If
*      Call Quit(_RC_INPUT_ERROR_)
      iRc=_RC_INPUT_ERROR_
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PREPSD(WFTP,SGS,CIS,LSYM,ICNFTAB,ISPNTAB,ISSTAB,IFSBTAB,NCONF,CI,DET,detocc,detcoeff,SPTRA)
! Purpose: Given a RASSCF wave function in Split-GUGA format
! and an orbital transformation matrix for the purpose of
! getting biorthonormal orbitals, prepare a wave function
! in the general SD format, using transformed orbitals.

use sguga, only: CIStruct, SGStruct
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
character(len=8), intent(in) :: WFTP
type(SGStruct), intent(in) :: SGS
type(CIStruct), intent(in) :: CIS
integer(kind=iwp), intent(in) :: LSYM, ICNFTAB(*), ISPNTAB(*), ISSTAB(*), IFSBTAB(*), NCONF
real(kind=wp), intent(in) :: CI(*), SPTRA(*)
real(kind=wp), intent(_OUT_) :: DET(*)
character(len=*), intent(out) :: detocc(NCONF)
real(kind=wp), intent(out) :: detcoeff(NCONF)
integer(kind=iwp) :: IMODE
real(kind=wp), allocatable :: CTMP(:)

if (WFTP == 'GENERAL') then
  ! Transform SGUGA to SymmG:
  call mma_allocate(CTMP,NCONF,Label='CTMP')
  IMODE = 1
  call SYG2SGU(IMODE,SGS,CIS,LSYM,ICNFTAB,ISPNTAB,CI,CTMP)
  ! Transform SymmG to Slater Dets:
  call SYGTOSD(ICNFTAB,ISPNTAB,ISSTAB,IFSBTAB,CTMP,DET,detocc,detcoeff,SPTRA)
  call mma_deallocate(CTMP)
else
  DET(1) = CI(1)
end if

end subroutine PREPSD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine dkh_cofu_spec(n,a,m,c)
! Special combination coefficients

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n, m
real(kind=wp), intent(in) :: a(n)
real(kind=wp), intent(out) :: c(m)
integer(kind=iwp) :: i
real(kind=wp), allocatable :: b(:)

c(1) = a(m-1)
do i=2,m-1
  c(i) = a(i-1)*a(m-i)*(-1)**(i-1)
end do
c(m) = a(m-1)*(-1)**(m-1)

call mma_allocate(b,m+1,label='b')

b(1) = a(m)
do i=2,m
  b(i) = a(i-1)*a(m-i+1)*(-1)**(i-1)
end do
b(m+1) = a(m)*(-1)**m

do i=1,m
  c(i) = c(i)-b(i)
  b(i+1) = b(i+1)+b(i)
end do
if (abs(b(m+1)) > 1.0e-12_wp) then
  write(u6,*) 'Error in dkh_dkcof_sp ',b(m+1)
  call Abend()
end if

call mma_deallocate(b)

end subroutine dkh_cofu_spec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1997, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE NEXT_SYM_DISTR(  NGAS, MINVAL, MAXVAL,   ISYM,ISYM_TOT,
     &                           IFIRST,  NONEW)
*
* Obtain next distribution of symmetries with given total
* Symmetry.
*
* Loop over first NGAS-1 spaces are performed, and the symmetry
* of the last space is then fixed by the required total sym
*
* Jeppe Olsen, Sept 97
* Obtain next distribution of symmetries with given total
* Symmetry.
*
* Loop over first NGAS-1 spaces are performed, and the symmetry
* of the last space is then fixed by the required total sym
*
* Jeppe Olsen, Sept 97
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION MINVAL(NGAS),MAXVAL(NGAS)
*. Input and output
      DIMENSION ISYM(NGAS)
*
*. Symmetry of first NGAS -1 spaces
*
      IF(IFIRST.EQ.1) THEN
        DO IGAS = 1, NGAS-1
          ISYM(IGAS) = MINVAL(IGAS)
        END DO
        NONEW = 0
      END IF
 1001 CONTINUE
      IF(IFIRST.EQ.0) CALL NXTNUM3(ISYM,NGAS-1,MINVAL,MAXVAL,NONEW)
      IFIRST = 0
*
*. Symmetry of last space
*
      IF(NONEW.EQ.0) THEN
C       JSYM = 1
C       DO IGAS = 1, NGAS-1
C         CALL SYMCOM(3,0,JSYM,ISYM(IGAS),KSYM)
C         JSYM = KSYM
C       END DO
        JSYM = ISYMSTR(ISYM,NGAS-1)
        CALL SYMCOM(2,0,JSYM,ISYM(NGAS),ISYM_TOT)
*
        IF(MINVAL(NGAS).GT.ISYM(NGAS).OR.
     &     MAXVAL(NGAS).LT.ISYM(NGAS)    )GOTO 1001
      END IF
*
      NTEST = 000
      IF(NTEST.GE.100) THEN
        IF(NONEW.EQ.1) THEN
         WRITE(6,*) ' No new symmetry distributions '
        ELSE
         WRITE(6,*) ' Next symmetry distribution '
         CALL IWRTMA(ISYM,1,NGAS,1,NGAS)
        END IF
      END IF
*
      RETURN
      END
*

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SDCI_MRCI()
      IMPLICIT REAL*8 (A-H,O-Z)

#include "SysDef.fh"

#include "mrci.fh"
#include "WrkSpc.fh"
c      DIMENSION H(MAXMEM), iH(RtoI*MAXMEM)
C PUT THE SUBROUTINE NAME ONTO THE ENTRY NAME STACK
C INPUT AND MEMORY ALLOCATION:
*      CALL READIN(HWork,iHWork)
      CALL READIN_MRCI()
C INTEGRAL SORTING AND DIAGONAL ELEMENTS:
C USE COUPLING COEFFS FROM UNIT 10, TRANSFORMED INTEGRALS FROM 13 AND 17
C PRODUCE FILES UNIT 14, 15 AND 16 WITH SORTED INTEGRALS.
C ALSO FOCK MATRIX TO UNIT 25 AND DIAGONAL ELEMENTS TO UNIT 27.
*PAM04 ALLOCATION OF FOCK MATRIX MOVED HERE FROM ALLOC.
      CALL GETMEM('FOCK','ALLO','REAL',LFOCK,NBTRI)
      CALL DIAGCT()
C CREATE REFERENCE CI HAMILTONIAN:
*PAM04      CALL MKHREF (HWork(LHREF),Hwork(LFOCK),HWork(LFIJKL),
*PAM04     &             HWork(LJREFX))
      NHREF=(NREF*(NREF+1))/2
      CALL GETMEM('HREF','ALLO','REAL',LHREF,NHREF)
      NIJ=(LN*(LN+1))/2
      NIJKL=(NIJ*(NIJ+1))/2
      CALL GETMEM('FIJKL','ALLO','REAL',LFIJKL,NIJKL)
      CALL MKHREF (Work(LHREF),Work(LFOCK),Work(LFIJKL),
     &             IWork(LJREFX))
C SOLVE REFERENCE CI EQUATIONS:
*PAM04      CALL REFCI (HWork(LHREF),HWork(LAREF),HWork(LEREF),HWork(LCSPCK),
*PAM04     *            HWork(LCISEL),HWork(LPLEN))
      CALL GETMEM('AREF','ALLO','REAL',LAREF,NREF**2)
      CALL GETMEM('EREF','ALLO','REAL',LEREF,NREF)
      CALL GETMEM('PLEN','ALLO','REAL',LPLEN,NREF)
      CALL REFCI (Work(LHREF),Work(LAREF),Work(LEREF),IWork(LCSPCK),
     *            Work(LCISEL),Work(LPLEN))
      CALL GETMEM('PLEN','FREE','REAL',LPLEN,NREF)
      CALL GETMEM('HREF','FREE','REAL',LHREF,NHREF)
      IF(IREFCI.EQ.1) THEN
       CALL GETMEM('FOCK','FREE','REAL',LFOCK,NBTRI)
       CALL GETMEM('FIJKL','FREE','REAL',LFIJKL,NIJKL)
       GOTO 900
      END IF
C SOLVE MRCI OR ACPF EQUATIONS:
C FIRST, SET UP START CI ARRAYS, AND ALSO TRANSFORM DIAGONAL ELEMENTS:
*------
* POW: Initialize HSMALL(1,1)
      HSMALL(1,1)=0.0d0
*------
      CALL GETMEM('ICI','ALLO','INTE',LICI,MBUF)
      CALL GETMEM('CI','ALLO','REAL',LCI,NCONF)
      CALL GETMEM('SGM','ALLO','REAL',LSGM,NCONF)
      CALL CSTART(Work(LAREF),Work(LEREF),Work(LCI),IWork(LICI))
      CALL MQCT(WORK(LAREF),WORK(LEREF),Work(LCI),Work(LSGM),
     &          IWork(LICI))
      CALL GETMEM('SGM','FREE','REAL',LSGM,NCONF)
      CALL GETMEM('CI','FREE','REAL',LCI,NCONF)
      CALL GETMEM('ICI','FREE','INTE',LICI,MBUF)
*PAM04 EXPLICIT DEALLOCATION OF FOCK MATRIX
      CALL GETMEM('FOCK','FREE','REAL',LFOCK,NBTRI)
C DENSITY (AND MAYBE TRANSITION DENSITY) MATRICES IN AO BASIS:
*PAM04 ALLOCATION OF DMO AND TDMO MOVED HERE FROM ALLOC:
      CALL GETMEM('DMO','ALLO','REAL',LDMO,NBTRI)
      IF(ITRANS.EQ.1) CALL GETMEM('TDMO','ALLO','REAL',LTDMO,NBAST**2)
*PAM04 End of addition
      CALL DENSCT(WORK(LAREF))
      CALL GETMEM('AREF','FREE','REAL',LAREF,NREF**2)
      CALL GETMEM('EREF','FREE','REAL',LEREF,NREF)
C NATURAL ORBITALS AND PROPERTIES (AND MAYBE TRANSITION PROPS):
      CALL PROPCT()
*PAM04 EXPLICIT DEALLOCATION ADDED:
      CALL GETMEM('DMO','FREE','REAL',LDMO,NBTRI)
      IF(ITRANS.EQ.1) CALL GETMEM('TDMO','FREE','REAL',LTDMO,NBAST**2)
*PAM04 End of addition
 900  CONTINUE
      CALL GETMEM('FIJKL','FREE','REAL',LFIJKL,NIJKL)
      CALL GETMEM('CISEL','FREE','REAL',LCISEL,NSEL*NREF)
      CALL GETMEM('JREFX','FREE','INTE',LJREFX,NCVAL)
      CALL GETMEM('ISAB','FREE','INTE',LISAB,NVIRT**2)
      CALL GETMEM('INDX','FREE','INTE',LINDX,NIWLK)
      CALL GETMEM('INTSY','FREE','INTE',LINTSY,NINTSY)
      CALL GETMEM('CSPCK','FREE','INTE',LCSPCK,NCSPCK)
C POP THE SUBROUTINE NAME FROM THE ENTRY NAME STACK
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3initfiles (length)
c
c     this routine distribute work space WRK for required files
c     for fix mediates it defines also mapd and mapi, for help mediates
c     it estimates their length and distribute WRK (i.e. def poss0 parameters)
c
c     length - overal requirements of work space (O)
c
c     !N.B. This routine cannot run with +OP2 level
c
       integer length
c
#include "t31.fh"
#include "t32.fh"
c
c     help variable
c
       integer posst,symp,symq,symr
       integer sizew,sizem,sizeh,sizen,sizel,sizer
       integer maxnoa,maxnvb,maxnorb
       integer nhelp1,nhelp2
c
c1    maps and possitions for fix mediated
c
c1.0  maps for DP - diagonal part
c     N.B. DP has one degree of freedom, while other 1 index has none
c     DP1 - dp(p)a
c     DP2 - dp(p)b
c
       do symp=1,nsym
       do symq=1,nsym
       do symr=1,nsym
       mapidp1(symp,symq,symr)=0
       mapidp2(symp,symq,symr)=0
       end do
       end do
       end do
c
       posst=1
c
       possdp10=posst
       mapddp1(0,1)=5
       mapddp1(0,2)=0
       mapddp1(0,3)=0
       mapddp1(0,4)=0
       mapddp1(0,5)=nsym
       mapddp1(0,6)=0
c
       do symp=1,nsym
       mapddp1(symp,1)=posst
       mapddp1(symp,2)=norb(symp)
       mapddp1(symp,3)=symp
       mapddp1(symp,4)=1
       mapddp1(symp,5)=1
       mapddp1(symp,6)=1
       mapidp1(symp,1,1)=symp
       posst=posst+norb(symp)
       end do
c
       possdp20=posst
       mapddp2(0,1)=5
       mapddp2(0,2)=0
       mapddp2(0,3)=0
       mapddp2(0,4)=0
       mapddp2(0,5)=nsym
       mapddp2(0,6)=0
c
       do symp=1,nsym
       mapddp2(symp,1)=posst
       mapddp2(symp,2)=norb(symp)
       mapddp2(symp,3)=symp
       mapddp2(symp,4)=1
       mapddp2(symp,5)=1
       mapddp2(symp,6)=1
       mapidp2(symp,1,1)=symp
       posst=posst+norb(symp)
       end do
c
c
c1.1  maps for T1
c     T11 - t1oaa(a,i)
c     T12 - t1obb(a,i)
c
       posst110=posst
       call cct3_grc0 (2,0,3,1,0,0,1,
     & posst110,posst,mapdt11,mapit11)
       posst120=posst
       call cct3_grc0 (2,0,4,2,0,0,1,
     & posst120,posst,mapdt12,mapit12)
c
c
c1.5  maps for FK
c     FK1 - f(a,b)aa
c     FK2 - f(a,b)bb
c     FK3 - f(a,i)aa
c     FK4 - f(a,i)bb
c     FK5 - f(i,j)aa
c     FK6 - f(i,j)bb
c
       possfk10=posst
       call cct3_grc0 (2,0,3,3,0,0,1,
     & possfk10,posst,mapdfk1,mapifk1)
       possfk20=posst
       call cct3_grc0 (2,0,4,4,0,0,1,
     & possfk20,posst,mapdfk2,mapifk2)
       possfk30=posst
       call cct3_grc0 (2,0,3,1,0,0,1,
     & possfk30,posst,mapdfk3,mapifk3)
       possfk40=posst
       call cct3_grc0 (2,0,4,2,0,0,1,
     & possfk40,posst,mapdfk4,mapifk4)
       possfk50=posst
       call cct3_grc0 (2,0,1,1,0,0,1,
     & possfk50,posst,mapdfk5,mapifk5)
       possfk60=posst
       call cct3_grc0 (2,0,2,2,0,0,1,
     & possfk60,posst,mapdfk6,mapifk6)
c
c
c1.6  maps for T2
c     T21 - t2o(ab,ij)aaaa
c     T22 - t2o(ab,ij)bbbb
c     T23 - t2o(a,b,i,j)abab
c
       posst210=posst
       call cct3_grc0 (4,4,3,3,1,1,1,
     & posst210,posst,mapdt21,mapit21)
       posst220=posst
       call cct3_grc0 (4,4,4,4,2,2,1,
     & posst220,posst,mapdt22,mapit22)
       posst230=posst
       call cct3_grc0 (4,0,3,4,1,2,1,
     & posst230,posst,mapdt23,mapit23)
c
c
c1.8  maps for W1
c     W11 - <ie||mn>aaaa
c     W12 - <ie||mn>bbbb
c     W13 - <ie||mn>abab
c     W14 - <ie||mn>baab
c
       possw110=posst
       call cct3_grc0 (4,3,1,3,1,1,1,
     & possw110,posst,mapdw11,mapiw11)
       possw120=posst
       call cct3_grc0 (4,3,2,4,2,2,1,
     & possw120,posst,mapdw12,mapiw12)
       possw130=posst
       call cct3_grc0 (4,0,1,4,1,2,1,
     & possw130,posst,mapdw13,mapiw13)
       possw140=posst
       call cct3_grc0 (4,0,2,3,1,2,1,
     & possw140,posst,mapdw14,mapiw14)
c
c
c1.9  maps for W2
c     W21 - <ab||ij>aaaa
c     W22 - <ab||ij>bbbb
c     W23 - <a,b|i,j>abab
c
       possw210=posst
       call cct3_grc0 (4,4,3,3,1,1,1,
     & possw210,posst,mapdw21,mapiw21)
       possw220=posst
       call cct3_grc0 (4,4,4,4,2,2,1,
     & possw220,posst,mapdw22,mapiw22)
       possw230=posst
       call cct3_grc0 (4,0,3,4,1,2,1,
     & possw230,posst,mapdw23,mapiw23)
c
c
c2    for help files mapps are irrelevant,
c     here only estimation of maximal length is done to
c     define poss0 of help files
c     we have:
c     2  W,V files - of vv2 type
c     2    L files - of vvv (vvo) type
c     3    R files - of vv2+ type
c     3    M files - of vv (vo)  type
c     3    H files - of v (o)  type
c     2  N,P files - of nn   type
c
c
       possw0=posst
c
c2.*  find maxsize of W,L,M,H
       sizew=0
       sizel=0
       sizer=0
       sizem=0
       sizeh=0
c
       do 50 nhelp1=1,nsym
c
c     W,V files
       call cct3_t3grc0 (3,2,4,4,4,0,nhelp1,possw0,posst,mapdw,mapiw)
       nhelp2=posst-possw0
       if (nhelp2.gt.sizew) then
       sizew=nhelp2
       end if
c
c     L files
       call cct3_t3grc0 (3,0,4,4,4,0,nhelp1,possw0,posst,mapdw,mapiw)
       nhelp2=posst-possw0
       if (nhelp2.gt.sizel) then
       sizel=nhelp2
       end if
       call cct3_t3grc0 (3,0,1,4,4,0,nhelp1,possw0,posst,mapdw,mapiw)
       nhelp2=posst-possw0
       if (nhelp2.gt.sizel) then
       sizel=nhelp2
       end if
c
c     R files
       call cct3_t3grc0 (3,8,4,4,4,0,nhelp1,possw0,posst,mapdw,mapiw)
       nhelp2=posst-possw0
       if (nhelp2.gt.sizer) then
       sizer=nhelp2
       end if
c
c     M files
       call cct3_t3grc0 (2,0,4,4,0,0,nhelp1,possw0,posst,mapdw,mapiw)
       nhelp2=posst-possw0
       if (nhelp2.gt.sizem) then
       sizem=nhelp2
       end if
       call cct3_t3grc0 (2,0,1,4,0,0,nhelp1,possw0,posst,mapdw,mapiw)
       nhelp2=posst-possw0
       if (nhelp2.gt.sizem) then
       sizem=nhelp2
       end if
c
c     H files
       call cct3_t3grc0 (1,0,4,0,0,0,nhelp1,possw0,posst,mapdw,mapiw)
       nhelp2=posst-possw0
       if (nhelp2.gt.sizeh) then
       sizeh=nhelp2
       end if
       call cct3_t3grc0 (1,0,1,0,0,0,nhelp1,possw0,posst,mapdw,mapiw)
       nhelp2=posst-possw0
       if (nhelp2.gt.sizeh) then
       sizeh=nhelp2
       end if
c
 50     continue
c
c
c2.*  def max{noa}, max{norb} ,max{nvb}
c
       maxnoa=noa(1)
       maxnvb=nvb(1)
       maxnorb=norb(1)
       do 100 symp=1,nsym
       if (noa(symp).gt.maxnoa) then
       maxnoa=noa(symp)
       end if
       if (norb(symp).gt.maxnorb) then
       maxnorb=norb(symp)
       end if
       if (nvb(symp).gt.maxnvb) then
       maxnvb=nvb(symp)
       end if
 100    continue
c
c
c2.*  def lengths of N fils
c
       sizen=0
c
       do 200 symp=1,nsym
c     symq is not known for N file
c     instead of norb(symr) maxnorb will be used so that reallength<=length
       sizen=sizen+norb(symp)*maxnorb
 200    continue
c
c2.1  W,V - files
c
c     possw0 is defined
       posst=possw0+sizew
       possv0=posst
       posst=posst+sizew
c
c2.2  L - files
c
       possl10=posst
       posst=posst+sizel
       possl20=posst
       posst=posst+sizel
c
c2.3  R - files
c
       possr10=posst
       posst=posst+sizer
       possr20=posst
       posst=posst+sizer
       possr30=posst
       posst=posst+sizer
c
c2.4  M - files
c
       possm10=posst
       posst=posst+sizem
       possm20=posst
       posst=posst+sizem
       possm30=posst
       posst=posst+sizem
c
c2.5  H - files
c
       possh10=posst
       posst=posst+sizeh
       possh20=posst
       posst=posst+sizeh
       possh30=posst
       posst=posst+sizeh
c
c2.6  N,P - files
c
       possn0=posst
       posst=posst+sizen
       possp0=posst
       posst=posst+sizen
c
c2.7  dedlare space for help matrix D in for matrix multiplication C=AT*B if
c     mchntyp=2
c
       if (mchntyp.eq.2) then
       possd0=posst
       if (maxnoa.le.maxnvb) then
       posst=posst+maxnoa*maxnoa*maxnvb*maxnvb
       else
       posst=posst+maxnoa*maxnoa*maxnoa*maxnoa
       end if
       end if
c
       length=posst-1
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1995,1996, Anders Bernhardsson                         *
!***********************************************************************

subroutine Drvg2(Hess,nHess,lGrad,lHess)
!***********************************************************************
!                                                                      *
!  Object: driver for two-electron integrals. The four outermost loops *
!          will controll the type of the two-electron integral, eg.    *
!          (ss|ss), (sd|pp), etc. The next four loops will generate    *
!          list of symmetry distinct centers that do have basis func-  *
!          tions of the requested type.                                *
!                                                                      *
! Input:                                                               *
!              nHess         : Size of gradient and hessian            *
!              lGrad,lHess   : Boolean on/off for gradient/hessian     *
!                              generation                              *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             March 1990                                               *
!             Anders Bernhardsson 1995-1996                            *
!***********************************************************************

use setup, only: MxPrm
use McKinley_global, only: ipDisp, ipDisp2, ipDisp3, ipMO, nFck, nMethod, RASSCF
use Index_Functions, only: nTri_Elem, nTri_Elem1
use iSD_data, only: iSD, nSD
use k2_arrays, only: DeDe, DeDe2, DoHess_, ipDijS, ipDijS2, ipOffD, ipOffDA, MxDij, nDeDe, Sew_Scr
use Disp, only: lDisp
use Etwas, only: nAsh
use pso_stuff, only: nDens
use Basis_Info, only: dbsc, nBas, nCnttp, Shells
use Symmetry_Info, only: iOper, nIrrep
use Sizes_of_Seward, only: S
use Gateway_Info, only: CutInt
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Two, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nHess
real(kind=wp), intent(out) :: Hess(nHess)
logical(kind=iwp), intent(in) :: lGrad, lHess
integer(kind=iwp) :: i, iAng, iBas, iCmp, iCnttp, id, id_Tsk, idd, iDisk, iDisp, iIrr, iIrrep, ij, ijSh, ip, iPrim, iS, iShll, &
                     jBas, jCmp, jDisp, jIrr, js, kIrr, klSh, ks, ls, mDeDe, mIndij, mmdede, moip(0:7), MxBsC, n_Int, nAco, &
                     nBuffer, ndisp, nij, nIndij, nMO, nPairs, nQuad, nSkal, nTemp
real(kind=wp) :: A_int, ThrAO, TMax_all
logical(kind=iwp) :: DoFock, DoGrad, Indexation, lpick, Post_Process
integer(kind=iwp), allocatable :: Pair_Index(:,:)
real(kind=wp), allocatable :: DInAc(:), DTemp(:), iInt(:), TMax(:,:), Buffer(:)
real(kind=wp), pointer :: Temp(:)
integer(kind=iwp), parameter :: Nr_of_Densities = 1
logical(kind=iwp), parameter :: Int_Direct = .true.
integer(kind=iwp), external :: NrOpr
logical(kind=iwp), external :: Rsv_Tsk

!                                                                      *
!***********************************************************************
!                                                                      *
! PROLOGUE

call StatusLine('McKinley: ','Computing 2-electron 2nd order derivatives')

ipDijS = 0
ipDijS2 = 0
lpick = lgrad .and. (nIrrep /= 1)

ndisp = 0
nACO = 0
do iS=0,nIrrep-1
  moip(iS) = nACO
  nDisp = nDisp+ldisp(is)
  nACO = naco+nAsh(is)
end do

Hess(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
call Set_Basis_Mode('Valence')
call Setup_iSD()

Indexation = .false.
ThrAO = Zero
DoFock = .false.
DoGrad = .false.
DoHess_ = .true.
call Setup_Ints(nSkal,Indexation,ThrAO,DoFock,DoGrad)
!                                                                      *
!***********************************************************************
!                                                                      *
! Allocate working area

MxPrm = 0
MxDij = 0
MxBsC = 0
do iAng=0,S%iAngMx
  MxPrm = max(MxPrm,S%MaxPrm(iAng))
  do iCnttp=1,nCnttp
    iShll = dbsc(iCnttp)%iVal+iAng
    iPrim = Shells(iShll)%nExp
    if (iPrim == 0) cycle
    if (Shells(iShll)%nBasis == 0) cycle
    iBas = Shells(iShll)%nBasis
    iCmp = nTri_Elem1(iAng)
    MxBsC = max(MxBsC,iBas*iCmp)
    MxDij = max(MxDij,(iBas**2+1)*iCmp**2+iPrim**2+1)
  end do
end do
MxDij = 6*nIrrep*MxDij

!                                                                      *
!***********************************************************************
!                                                                      *
if (lGrad) then

  ! Calculate the size of memory needed for storing fock matrices and
  ! MO integrals and allocate it.

  nMO = nTri_Elem(nTri_Elem(naco))

  call mma_allocate(ipDisp,nDisp,label='ipDisp')
  if (nMethod == RASSCF) then
    call mma_allocate(ipMO,nDisp,label='ipMO')
    call mma_allocate(ipDisp2,nDisp,label='ipDisp2')
    call mma_allocate(ipDisp3,nDisp,label='ipDisp3')
  end if

  nIndij = nTri_Elem(S%nShlls)
  n_Int = 0
  jDisp = 0
  do iIrrep=0,nIrrep-1
    do iDisp=1,lDisp(iIrrep)

      jDisp = jDisp+1
      ipDisp(jDisp) = n_Int+1

      do jIrr=0,nIrrep-1
        kIrr = nrOpr(ieor(iOper(iIrrep),iOper(jIrr)))
        if (jIrr == kIrr) then
          n_Int = n_Int+nTri_Elem(nBas(jIrr))
        else if (kIrr < jIrr) then
          n_Int = n_Int+nBas(jIrr)*nBas(kIrr)
        end if
      end do

      if (nMethod == RASSCF) then
        ipMO(jDisp) = n_Int+1
        n_Int = n_Int+nMO
        ipDisp2(jDisp) = n_Int+1

        do jIrr=0,nIrrep-1
          kIrr = nrOpr(ieor(iOper(iIrrep),iOper(jIrr)))
          if (jIrr == jIrr) then
            n_Int = n_Int+nTri_Elem(nBas(jIrr))
          else if (kIrr < jIrr) then
            n_Int = n_Int+nBas(jIrr)*nBas(kIrr)
          end if
        end do

      end if

    end do
  end do
  if (nMethod == RASSCF) then
    jDisp = 0
    do iIrrep=0,nIrrep-1
      do iDisp=1,lDisp(iIrrep)
        jDisp = jDisp+1
        ipDisp3(jDisp) = n_Int+1
        do iS=0,nirrep-1
          js = nrOpr(ieor(iOper(is),iOper(iIrrep)))
          n_Int = n_Int+nBas(iS)*nAsh(jS)
        end do
      end do
    end do
  end if
  call mma_allocate(iInt,n_Int,Label='iInt')
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Desymmetrize  densities.
  ! Observe that the desymmetrized 1st order density matrices are canonical,
  ! i.e. the relative order of the indices are canonically ordered.

  iInt(:) = Zero
  call mma_allocate(DTemp,nDens,Label='DTemp')
  DTemp(:) = Zero
  call mma_allocate(DInAc,nDens,Label='DInAc')
  DInAc(:) = Zero
  if (nIrrep == 1) then
    if (nmethod /= RASSCF) then
      call Get_D1ao_Var(DTemp,nDens)
      DTemp(:) = Half*DTemp
      ij = 0
      do i=1,nBas(0)
        ij = ij+i
        DTemp(ij) = Two*DTemp(ij)
      end do
    else
      call Din(DInAc)
      DInAc(:) = Half*DInAc
      ij = 0
      do i=1,nBas(0)
        ij = ij+i
        DInAc(ij) = Two*DInAc(ij)
      end do
      call Dan(DTemp)
      DTemp(:) = Half*DTemp
      ij = 0
      do i=1,nBas(0)
        ij = ij+i
        DTemp(ij) = Two*DTemp(ij)
      end do
    end if
  else
    mmDeDe = nDeDe
    call mma_allocate(ipOffD,3,nIndij,label='ipOffD')
    call mma_allocate(DeDe,mmDeDe+MxDij,label='DeDe')
    ipDijS = 1+mmDeDe
    if (nMethod /= RASSCF) then
      call Get_D1ao_Var(DTemp,nDens)
      call DeDe_mck(DTemp,nFck(0),ipOffD,nIndij,Dede,mmDeDe,mDeDe,mIndij)
    else
      call mma_allocate(ipOffDA,3,nIndij,Label='ipOffDA')
      call mma_allocate(DeDe2,mmDeDe+MxDij,label='DeDe2')
      ipDijS2 = 1+mmDeDe

      call Dan(DTemp)
      call DeDe_mck(DTemp,nFck(0),ipOffD,nIndij,DeDe,mmDeDe,mDeDe,mIndij)

      call Din(DInAc)
      call DeDe_mck(DInAc,nFck(0),ipOffDA,nIndij,DeDe2,mmDeDe,mDeDe,mIndij)

      if (mDeDe /= nDeDe) then
        write(u6,*) 'DrvG2: mDeDe /= nDeDe'
        write(u6,*) 'mDeDe,nDeDe=',mDeDe,nDeDe
        call Abend()
      end if
    end if
  end if

  call mma_allocate(DeDe,[-1,-1],label='DeDe',safe='*') ! Dummy allocation
  call mma_allocate(DeDe2,[-1,-1],label='DeDe2',safe='*') ! Dummy allocation

end if ! lGrad
!                                                                      *
!***********************************************************************
!                                                                      *
call Free_iSD()
call Set_Basis_Mode('Valence')
call Nr_Shells(nSkal)
call Setup_iSD()

nPairs = nTri_Elem(nSkal)
nQuad = nTri_Elem(nPairs)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute entities for prescreening at shell level

call mma_allocate(TMax,nSkal,nSkal,Label='TMax')
call Shell_MxSchwz(nSkal,TMax)

TMax_all = Zero
do iS=1,nSkal
  do jS=1,iS
    TMax_all = max(TMax_all,TMax(iS,jS))
  end do
end do

!                                                                      *
!***********************************************************************
!                                                                      *
! Create list of non-vanishing pairs

call mma_allocate(Pair_Index,2,nPairs,Label='Ind_ij')
nij = 0
nBuffer = 1  ! Dummy length
do iS=1,nSkal
  iCmp = iSD(2,iS)
  iBas = iSD(3,iS)
  do jS=1,iS
    jCmp = iSD(2,jS)
    jBas = iSD(3,jS)
    if (TMax_All*TMax(iS,jS) >= CutInt) then
      nij = nij+1
      Pair_Index(1,nij) = iS
      Pair_Index(2,nij) = jS
      if ((nMethod == RASSCF) .and. lGrad) nBuffer = max(nBuffer,nTri_Elem(nACO)*iCmp*iBas*jCmp*jBas*nDisp*nIrrep)
    end if
  end do
end do
call mma_allocate(Buffer,nBuffer,Label='Buffer')
!                                                                      *
!***********************************************************************
!                                                                      *
call Init_Tsk(id_Tsk,nij)
!                                                                      *
!***********************************************************************
!                                                                      *
! big loop over individual tasks, distributed over individual nodes

! make reservation of a task on global task list and get task range
! in return. Function will be false if no more tasks to execute.
do while (Rsv_Tsk(id_Tsk,ijSh))
  iS = Pair_Index(1,ijSh)
  jS = Pair_Index(2,ijSh)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Outer loops (ij) over angular momenta and centers

  Buffer(:) = Zero

  !                                                                    *
  !*********************************************************************
  !                                                                    *
  Post_Process = .false.
  do klSh=1,nij
    ks = Pair_Index(1,klSh)
    ls = Pair_Index(2,klSh)

    A_int = TMax(iS,jS)*TMax(kS,lS)
    if (A_Int < CutInt) cycle

    call Eval_g2_ijkl(iS,jS,kS,lS,Hess,nHess,Post_Process,iInt,n_Int,nACO,lGrad,lHess,lPick,nBuffer,Buffer,nDens,DTemp,DInAc,moip, &
                      n_Int,nQuad)

  end do ! klS

  if ((nMethod == RASSCF) .and. Post_Process) then
    nTemp = size(Sew_Scr)
    Temp(1:nTemp) => Sew_Scr(1:nTemp)
    call CLR2(Buffer,iInt,nACO,nSD,iSD(:,iS),iSD(:,jS),nDisp,nTemp,Temp)
    nullify(Temp)
  end if

end do
call mma_deallocate(Buffer)
! End of big task loop
!                                                                      *
!***********************************************************************
!                                                                      *
! EPILOGUE
!                                                                      *
!***********************************************************************
!                                                                      *
if (nIrrep == 1) then
  idd = 0
  do iS=0,nirrep-1
    do iD=1,ldisp(is)
      idd = idd+1
      ip = ipDisp(idd)
      iInt(ip:ip+nDens-1) = Half*iInt(ip:ip+nDens-1)
      ij = ip-1
      do i=1,nBas(0)
        ij = ij+i
        iInt(ij) = Two*iInt(ij)
      end do
    end do
  end do
  if (nmethod == RASSCF) then
    idd = 0
    do iS=0,nirrep-1
      do iD=1,ldisp(is)
        idd = idd+1
        ip = ipDisp2(idd)
        iInt(ip:ip+nDens-1) = Half*iInt(ip:ip+nDens-1)
        ij = ip-1
        do i=1,nBas(0)
          ij = ij+i
          iInt(ij) = Two*iInt(ij)
        end do
      end do
    end do

  end if
end if
call mma_deallocate(Sew_Scr,safe='*')
call Free_Tsk(id_Tsk)

! YIPPIEEEE Finished OK fill it UP!!

call GADSum(iInt,n_Int)
jDisp = 0
do iIrr=0,nIrrep-1
  do iDisk=1,lDisp(iIrr)
    jDisp = jDisp+1
    call WrDisk(iInt,n_Int,jDisp,iIrr)
  end do
end do

call mma_deallocate(Pair_Index)
call mma_deallocate(TMax)
call Free_iSD()

call mma_deallocate(DeDe)
call mma_deallocate(DeDe2)
if (nIrrep /= 1) then
  call mma_deallocate(ipOffD)
  if (nMethod == RASSCF) then
    call mma_deallocate(ipOffDA)
  end if
end if

call mma_deallocate(DInAc)
call mma_deallocate(DTemp)
call mma_deallocate(iInt)

call Term_Ints()

call mma_deallocate(ipDisp,safe='*')
call mma_deallocate(ipDisp2,safe='*')
call mma_deallocate(ipDisp3,safe='*')
call mma_deallocate(ipMO,safe='*')

end subroutine Drvg2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992,2020, Roland Lindh                                *
************************************************************************
      SubRoutine Get_Info_Dynamic()
************************************************************************
*                                                                      *
* Object: to read all input information on the file INFO.              *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             January 1992                                             *
************************************************************************
*                                                                      *
      Use Basis_Info
      Use Center_Info
      Use SOAO_Info
*                                                                      *
************************************************************************
*                                                                      *
      Call Basis_Info_Get()
      Call Center_Info_Get()
      Call SOAO_Info_Get()
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Markus P. Fuelscher                              *
!               1991, Per Ake Malmqvist                                *
!***********************************************************************

subroutine MkSrt0(iSquar,nIrrep,nBas,iSkip)
!***********************************************************************
!                                                                      *
!     Purpose: Set up all information needed to compute 2el integral   *
!              adresses in the subroutine PLF2 and INDSFT2.            *
!                                                                      *
!     Called from: Sort0                                               *
!                                                                      *
!     Calls to : none                                                  *
!                                                                      *
!     Calling parameters:                                              *
!     iSquar  : ordering flag                                          *
!     nIrrep  : number of irreducible representations                  *
!     nBas    : number of basis functions per irred. rep.              *
!     iSkip   : flag to exlude symmetry combinations                   *
!                                                                      *
!*** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****

use sort_data, only: DimSyB, TriSyB, mxSyP, nBs, nSkip, nSyOp, Square
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: iSquar, nIrrep, nBas(nIrrep), iSkip(nIrrep)
#include "print.fh"
integer(kind=iwp) :: iBsi, iPrint, iRout, iSymi, jBsj, jSymj

iRout = 80
iPrint = nPrint(iRout)
if (iPrint > 10) write(u6,*) ' >>> Enter MKSRT0 <<<'
!----------------------------------------------------------------------*
!     Gather information on desired ordering scheme                    *
!----------------------------------------------------------------------*

Square = .true.
if (iSquar == 0) Square = .false.

!----------------------------------------------------------------------*
!     Gather data on the number of symmetry operations                 *
!----------------------------------------------------------------------*

nSyOp = nIrrep
mxSyP = nSyOp*(nSyOp+1)/2

!----------------------------------------------------------------------*
!     Gather data on the number of basis functions                     *
!----------------------------------------------------------------------*

do iSymi=1,nSyOp
  nBs(iSymi) = nBas(iSymi)
end do

!----------------------------------------------------------------------*
!     Put flags to exclude symmetry combinations into common block     *
!----------------------------------------------------------------------*

do iSymi=1,nSyOp
  nSkip(iSymi) = iSkip(iSymi)
end do

!----------------------------------------------------------------------*
!     Precompute the dimension of the symmetry blocks                  *
!     and symmetry block numbers for pairs of symmtry indices          *
!----------------------------------------------------------------------*

do iSymi=1,nSyOp
  iBsi = nBs(iSymi)
  DimSyB(iSymi,iSymi) = iBsi*(iBsi+1)/2
  TriSyB(iSymi,iSymi) = iSymi*(iSymi+1)/2
  do jSymj=1,iSymi-1
    jBsj = nBs(jSymj)
    DimSyB(iSymi,jSymj) = iBsi*jBsj
    DimSyB(jSymj,iSymi) = jBsj*iBsi
    TriSyB(iSymi,jSymj) = jSymj+iSymi*(iSymi-1)/2
    TriSyB(jSymj,iSymi) = jSymj+iSymi*(iSymi-1)/2
  end do
end do

return

end subroutine MkSrt0

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine TRANSFOCK(TORB,NTORB,F,NF,IDIR)
! Purpose: given an orbital transformation array and some
! one-electron matrix in storage format as e.g. FIFA and FIMO
! transform the matrix to use the new orbital basis.

use Index_Functions, only: nTri_Elem
use caspt2_module, only: nIsh, nOMx, nRas1, nRas2, nRas3, nSsh, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NTORB, NF, IDIR
real(kind=wp), intent(in) :: TORB(NTORB)
real(kind=wp), intent(inout) :: F(NF)
integer(kind=iwp) :: NI, NR1, NR2, NR3, NS, NO, IJOFF, ITOFF, I, J, JJ, IJ, ISYM, IOFF
real(kind=wp), allocatable :: FSQ(:), TMP(:), TSQ(:)

NOMX = maxval(NISH(1:NSYM)+NRAS1(1:NSYM)+NRAS2(1:NSYM)+NRAS3(1:NSYM)+NSSH(1:NSYM))

call mma_allocate(FSQ,NOMX**2,LABEL='FSQ')
call mma_allocate(TSQ,NOMX**2,LABEL='TSQ')
call mma_allocate(TMP,NOMX**2,LABEL='TMP')

IJOFF = 0
ITOFF = 0
do ISYM=1,NSYM
  NI = NISH(ISYM)
  NR1 = NRAS1(ISYM)
  NR2 = NRAS2(ISYM)
  NR3 = NRAS3(ISYM)
  NS = NSSH(ISYM)
  NO = NI+NR1+NR2+NR3+NS
  if (NO == 0) cycle

  ! Copy the matrices to square storage: first fill with zeroes.
  TSQ(1:NO**2) = Zero
  ! Copy inactive TORB block to TSQ
  IOFF = 0
  do J=1,NI
    JJ = IOFF+J
    TSQ(IOFF+NO*(JJ-1)+1:IOFF+NO*(JJ-1)+NI) = TORB(ITOFF+NI*(J-1)+1:ITOFF+NI*J)
  end do
  ! Copy ras1 T block to TSQ, and so on..
  ITOFF = ITOFF+NI**2
  IOFF = IOFF+NI
  do J=1,NR1
    JJ = IOFF+J
    TSQ(IOFF+NO*(JJ-1)+1:IOFF+NO*(JJ-1)+NR1) = TORB(ITOFF+NR1*(J-1)+1:ITOFF+NR1*J)
  end do

  ITOFF = ITOFF+NR1**2
  IOFF = IOFF+NR1
  do J=1,NR2
    JJ = IOFF+J
    TSQ(IOFF+NO*(JJ-1)+1:IOFF+NO*(JJ-1)+NR2) = TORB(ITOFF+NR2*(J-1)+1:ITOFF+NR2*J)
  end do

  ITOFF = ITOFF+NR2**2
  IOFF = IOFF+NR2
  do J=1,NR3
    JJ = IOFF+J
    TSQ(IOFF+NO*(JJ-1)+1:IOFF+NO*(JJ-1)+NR3) = TORB(ITOFF+NR3*(J-1)+1:ITOFF+NR3*J)
  end do
  ! Finally, the secondary orbitals (non-deleted, virtual).
  ITOFF = ITOFF+NR3**2
  IOFF = IOFF+NR3
  do J=1,NS
    JJ = IOFF+J
    TSQ(IOFF+NO*(JJ-1)+1:IOFF+NO*(JJ-1)+NS) = TORB(ITOFF+NS*(J-1)+1:ITOFF+NS*J)
  end do
  ITOFF = ITOFF+NS**2
  ! Now transfer the Fock matrix block to square storage:
  IJ = 0
  do I=1,NO
    do J=1,I
      IJ = IJ+1
      FSQ(J+NO*(I-1)) = F(IJOFF+IJ)
      FSQ(I+NO*(J-1)) = F(IJOFF+IJ)
    end do
  end do
  if (IDIR >= 0) then
    ! T^T F T
    ! Transform, first do FSQ*TSQ -> TMP...
    call DGEMM_('N','N',NO,NO,NO,One,FSQ,NO,TSQ,NO,Zero,TMP,NO)
    ! ... and then do TSQ(transpose)*TMP -> FSQ.
    call DGEMM_('T','N',NO,NO,NO,One,TSQ,NO,TMP,NO,Zero,FSQ,NO)
  else
    ! T F T^T
    ! Or inverse transformation
    call DGEMM_('N','T',NO,NO,NO,One,FSQ,NO,TSQ,NO,Zero,TMP,NO)
    call DGEMM_('N','N',NO,NO,NO,One,TSQ,NO,TMP,NO,Zero,FSQ,NO)
  end if
  ! Transfer FSQ values back to F, in triangular storage.
  IJ = IJOFF
  do I=1,NO
    F(IJ+1:IJ+I) = FSQ(I:I+NO*(I-1):NO)
    IJ = IJ+I
  end do
  IJOFF = IJOFF+nTri_Elem(NO)
  ! and repeat, using next symmetry block.
end do
call mma_deallocate(FSQ)
call mma_deallocate(TSQ)
call mma_deallocate(TMP)

end subroutine TRANSFOCK

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine ChoMP2_GetInf(lnOrb,lnOcc,lnFro,lnDel,lnVir)
C
C     Thomas Bondo Pedersen, Dec. 2004.
C
C     Purpose: get info from conventional MP2 common blocks.
C
#include "implicit.fh"
      Integer lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
#include "corbinf.fh"

      Do iSym = 1,nSym
         lnOrb(iSym) = nOrb(iSym)
         lnOcc(iSym) = nOcc(iSym)
         lnFro(iSym) = nFro(iSym)
         lnDel(iSym) = nDel(iSym)
         lnVir(iSym) = nExt(iSym)
      End Do

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine LnSrch(Energy,q,dq,g,nInter,nIter,dqHdq)

use PrintLevel, only: nPrint
use Constants, only: Zero, One, Two, Three, Four, Half
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nInter, nIter
real(kind=wp), intent(in) :: Energy(nIter)
real(kind=wp), intent(inout) :: q(nInter,nIter), dq(nInter,nIter), g(nInter,nIter), dqHdq
integer(kind=iwp) :: i, ii, iNew, iOld, iPrint, iRout, jj, nOrder
real(kind=wp) :: A(0:4), B(4,0:3), dqdq, ENew, Fact, FVal(4), gdq, Projg(2), Test1, Test2, x0, x0g, x1, x1g, x2, x2g, x3, x3g, &
                 XHi, XLow, XMin, XStart
logical(kind=iwp) :: Cubic, RC
real(kind=wp), parameter :: Thr = 1.0e-12_wp
real(kind=wp), external :: DDot_

iRout = 200
iPrint = nPrint(iRout)
#ifdef _DEBUGPRINT_
write(u6,*) ' Enter LnSrch'
write(u6,*) 'dqHdq=',dqHdq
call RecPrt('LnSrch: Energy',' ',Energy,1,nIter)
call RecPrt('LnSrch: q',' ',q,nInter,nIter)
call RecPrt('LnSrch:dq',' ',dq,nInter,nIter)
call RecPrt('LnSrch: g',' ',g,nInter,nIter)
#endif

A(0) = Zero

iNew = nIter
iOld = nIter-1

! 1) Quartic search, -0.5 <= Xmin <= 0.5
! 2) Cubic search, -1.5 <= Xmin <= 1.5
! 3) E(iNew) is the best, no action
! 4) E(iNew) is not the best,
!    XMin=0.0 between iNew and the Best point

! Quartic line search

Projg(1) = -DDot_(nInter,q(1,iNew),1,g(1,iOld),1)+DDot_(nInter,q(1,iOld),1,g(1,iOld),1)
Projg(2) = -DDot_(nInter,q(1,iNew),1,g(1,iNew),1)+DDot_(nInter,q(1,iOld),1,g(1,iNew),1)
A(3) = -(Two*(Energy(iNew)-Energy(iOld))+(Projg(2)+Projg(1)))
A(1) = (Energy(iNew)-Energy(iOld))-(One/Four)*A(3)
!write(u6,*) ' Projg(1),Projg(2),A(3),A(1)=',Projg(1),Projg(2),A(3),A(1)

! Test the gradient difference

Test1 = Projg(2)-Projg(1)
!write(u6,*) ' Test1=',Test1
if (Test1 < Thr) then
  if (iPrint >= 6) write(u6,*) '-- Line search failed, negative curvature'
  return
end if

! Now check if data is consistent with the condition that
! the second derivative is zero at the minimum.

Cubic = .false.
Test2 = Test1**2-Three*A(3)**2
!write(u6,*) ' Test2=',Test2
if (Test2 < Zero) then
  if (iPrint >= 6) write(u6,*) '-- Quartic line search failed, nonzero 2nd derivative'
  Cubic = .true.
else
  A(2) = (sqrt(Test2)+Test1)/Four
  if (A(2) < Thr) then
    if (iPrint >= 6) write(u6,*) '-- Quartic line search failed, A(2) too small'
    Cubic = .true.
  end if
end if

if (Cubic) then
  ! Cubic line search

  ! Range: -0.5 - 0.5

  if (iPrint >= 6) write(u6,*) '-- Cubic line search'
  FVal(1) = Energy(iOld)
  FVal(2) = Energy(iNew)
  FVal(3) = Projg(1)
  FVal(4) = Projg(2)
  !B = Zero
  x0 = One
  x1 = Half
  x2 = x1*Half
  x3 = x2*Half
  x0g = Zero
  x1g = One
  x2g = Two*x1
  x3g = Three*x2
  Fact = One
  ii = 1
  jj = 3
  do i=1,2
    Fact = -One*Fact
    B(ii,0) = x0
    B(ii,1) = Fact*x1
    B(ii,2) = x2
    B(ii,3) = Fact*x3
    B(jj,0) = x0g
    B(jj,1) = x1g
    B(jj,2) = Fact*x2g
    B(jj,3) = x3g
    ii = ii+1
    jj = jj+1
  end do
  nOrder = 3
  !call RecPrt('B-Matrix',' ',B,4,4)
  !call RecPrt('FVal',' ',FVal,4,1)
  call Gauss(nOrder+1,nOrder+1,B,A,FVal)
  !call RecPrt('A-Coefficients',' ',A,4,1)
  XStart = Zero
  XLow = -One
  XHi = Two+Half
else
  A(4) = Half*(Test1-Test2)
  nOrder = 4
  XStart = Zero
  XLow = -Half
  XHi = Half
end if

call Find_Min(nOrder,XStart,A,XMin,RC,XLow,XHi,ENew)
!write(u6,*) 'ENew=',ENew
if (.not. RC) then
  !write(u6,*) 'RC=.False.'
  return
end if
if (Test2 < Zero) then
  dqHdq = ENew-Energy(nIter)
else
  dqHdq = ENew
end if
XMin = XMin+Half
if (iPrint >= 6) write(u6,*) 'Minimum found at -->',XMin,'<--'
!                                                                      *
!***********************************************************************
!                                                                      *
! Update vectors in accordance with the result

! Compute the displacement iOld -> iNew

dq(:,iNew-1) = XMin*(q(:,iNew)-q(:,iOld))
dqdq = DDot_(nInter,dq(:,iNew-1),1,dq(:,iNew-1),1)

! Compute the new q

q(:,iNew) = q(:,iOld)+dq(:,iNew-1)

! Update the gradient

g(:,iNew) = XMin*g(:,iNew)+(One-XMin)*g(:,iOld)
gdq = -DDot_(nInter,g(:,iNew),1,dq(:,iNew-1),1)
g(:,iNew) = g(:,iNew)+gdq/dqdq*dq(:,iNew-1)

! Update the displacement nIter-1 -> nIter

dq(:,iNew-1) = q(:,iNew)-q(:,iNew-1)
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
call RecPrt('LnSrch: q',' ',q,nInter,nIter)
call RecPrt('LnSrch:dq',' ',dq,nInter,nIter)
call RecPrt('LnSrch: g',' ',g,nInter,nIter)
write(u6,*) ' Exit LnSrch'
#endif

end subroutine LnSrch

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine expand2 (a,b,dimp,dimqr,dims,dimq)
c
c     expand a(p,qr,s) -> b(p,q,r,s)
c     assumption: p>q, a(p,q,r,s)=-a(p,r,q,s)
c     RISC version
c
       integer dimp,dimqr,dims,dimq
       real*8 a(1:dimp,1:dimqr,1:dims)
       real*8 b(1:dimp,1:dimq,1:dimq,1:dims)
c
c     help variables
c
       integer p,q,r,s,qr
       real*8 scalar
c      To fix annoying warnings
       s=0
       if (dimq.gt.1) then
c
       do s=1,dims
       qr=0
       do 100 q=2,dimq
       do 101 r=1,q-1
       qr=qr+1
       do p=1,dimp
       scalar=a(p,qr,s)
       b(p,q,r,s)=scalar
       b(p,r,q,s)=-scalar
       end do
 101    continue
 100    continue
       end do
c
       end if
c
       do r=1,dimq
       do q=1,dimq
       do p=1,dimp
       b(p,q,q,s)=0.0d0
       end do
       end do
       end do
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cpinp_(LUnit,iRc)
      implicit integer (a-z)
      character*180 line
      character*1 ch
#include "warnings.h"
      iRc=_RC_ALL_IS_WELL_
* The following code will open, and return the unit number LUSpool,
* of an ASCII file with a copy of the presently used input.
* The records are strings of 180 characters, conforming to the
* standards set e.g. in src/util/inputil.f. This may change in the
* future, so look out!

      Call SpoolInp(LUSpool)
      Call Disable_Spool()
      Rewind(LUSpool)
* Now open a new file, and copy only the input between the '&RASSCF'
* and the 'End of Input' markers, inclusive, and skipping any commented
* lines. (The latter is put there by sbin/auto.plx, so it is safe to
* assume it is not abbreviated). The copied lines are left adjusted.
* Positioning LUSpool after the '&RASSCF' marker.
      Call RdNLst(LuSpool,'MCPDFT')
* Opening a new file:
      LUnit=99
      LUnit=IsFreeUnit(LUnit)
      Call Molcas_Open (LUnit,'CleanInput')
* Copy only the relevant lines of input:
      line=' '
      line(1:7)='&MCPDFT'
      write(LUnit,'(A180)') line
  10  continue
      read(luspool,'(A180)',err=9910,end=9910) line
      line = adjustl(line)
      ch=line(1:1)
      if(ch.ne.' ' .and. ch.ne.'*' .and. ch.ne.'!') then
       write(LUnit,'(A180)') line
      end if
      call upcase(line(1:12))
      if (line(1:12).ne.'END OF INPUT') goto 10
      call close_luspool(LUSpool)
      return
 9910 continue
* Something went wrong...Let the caller handle it:
      iRc=_RC_INPUT_ERROR_
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine defvhlp81(r2,v,dimr2b,dimr2a,dimr2c,dimva,dimvb,dimvc,adda,addc)
! this routine does
! V(a,b,c)aba = - R2(b,a,c)
! for syma>symc
!
! r2     - r2 matrix (I)
! v      - v matrix (O)
! dimr2b - dimension of b in R2 (I)
! dimr2a - dimension of a in R2 (I)
! dimr2c - dimension of c in R2 (I)
! dimva  - dimension of a in V (I)
! dimvb  - dimension of b in V (I)
! dimvc  - dimension of c in V (I)
! adda   - additional constant to a (I)
! addc   - additional constant to c (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimr2b, dimr2a, dimr2c, dimva, dimvb, dimvc, adda, addc
real(kind=wp), intent(in) :: r2(dimr2b,dimr2a,dimr2c)
real(kind=wp), intent(out) :: v(dimva,dimvb,dimvc)
integer(kind=iwp) :: a, ar2, c, cr2

do c=1,dimvc
  cr2 = c+addc
  do a=1,dimva
    ar2 = a+adda
    v(a,:,c) = -r2(1:dimvb,ar2,cr2)
  end do
end do

return

end subroutine defvhlp81

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine MltInt(
#define _CALLING_
#include "int_interface.fh"
     &                 )
************************************************************************
*                                                                      *
* Object: to compute the multipole moments integrals with the          *
*         Gauss-Hermite quadrature.                                    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
*             Modified to multipole moments November '90               *
************************************************************************
      use Her_RW
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
*
#include "rmat_option.fh"
*
#include "oneswi.fh"
#include "print.fh"

#include "int_interface.fh"

*     Local variable
      Real*8 TC(3), Origin(3)
      Integer iStabO(0:7), iDCRT(0:7)
      Logical ABeq(3), EQ
      Character*80 Label, ChOper(0:7)*3
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
      Data Origin/0.0D0,0.0D0,0.0D0/
*
*     Statement function for Cartesian index
*
      nElem(i) = (i+1)*(i+2)/2
*
      iRout = 122
      iPrint = nPrint(iRout)
*
      call dcopy_(nZeta*nElem(la)*nElem(lb)*nIC,[Zero],0,Final,1)
*
*     Call GetMem(' Enter MltInt','LIST','REAL',iDum,iDum)
      ABeq(1) = A(1).eq.RB(1)
      ABeq(2) = A(2).eq.RB(2)
      ABeq(3) = A(3).eq.RB(3)
*     switch (only single center overlap matrix...)
      If (NDDO.AND.
     &    .NOT.(ABeq(1).AND.ABeq(2).AND.ABeq(3))) Then
        call dcopy_(nZeta*nIC*nElem(la)*nElem(lb),[Zero],0,Final,1)
        Return
      End If
*     switch
      nip = 1
      ipAxyz = nip
      nip = nip + nZeta*3*nHer*(la+1)
      ipBxyz = nip
      nip = nip + nZeta*3*nHer*(lb+1)
      ipRxyz = nip
      nip = nip + nZeta*3*nHer*(nOrdOp+1)
      ipQxyz = nip
      nip = nip + nZeta*3*(la+1)*(lb+1)*(nOrdOp+1)
      ipFnl = nip
      nip = nip + nZeta*nElem(la)*nElem(lb)*nComp
*                                                                      *
************************************************************************
*                                                                      *
      If (RMat_type_integrals) Then
         ipRnr  =  nip
         nip = nip + nZeta*(la+lb+nOrdOp+1)
      Else
         ipRnr=-1
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (nip-1.gt.nArr*nZeta) Then
         Call WarningMessage(2,'MltInt: nip-1.gt.nArr*nZeta')
         Write (6,*) ' nArr is Wrong! ', nip-1,' > ',nArr*nZeta
         Write (6,*) ' Abend in MltInt'
         Call Abend()
      End If
*
      If (iPrint.ge.49) Then
         Call RecPrt(' In MltInt: A',' ',A,1,3)
         Call RecPrt(' In MltInt: RB',' ',RB,1,3)
         Call RecPrt(' In MltInt: Ccoor',' ',Ccoor,1,3)
         Call RecPrt(' In MltInt: Kappa',' ',rKappa,nAlpha,nBeta)
         Call RecPrt(' In MltInt: Zeta',' ',Zeta,nAlpha,nBeta)
         Call RecPrt(' In MltInt: P',' ',P,nZeta,3)
         Write (6,*) ' In MltInt: la,lb=',la,lb
      End If
*
      llOper = lOper(1)
      Do 90 iComp = 2, nComp
         llOper = iOr(llOper,lOper(iComp))
 90   Continue
*                                                                      *
************************************************************************
*                                                                      *
      If (RMat_type_integrals) Then
*
         If (.Not.EQ(CCoor,Origin)) Then
            Call WarningMessage(2,'MltInt: R-matrix error')
            Write (6,*) 'MltInt: Wrong center of origin in case of',
     &                   ' R-matrix type of integrals!'
            Write (6,*) ' Origin should always be (0.0,0.0,0.0)!'
            Write (6,*) ' User the CENTER option to do this',
     &                  ' (see the SEWARD input sectio in the manual).'
            Write (6,'(A,I3)') 'nOrdOp=',nOrdOp
            Call Abend()
         End If
*
*        R-matrix calculations: continuum basis functions (A=B=P=0)
*        Compute the contributions of the basis functions and multipole
*        radial part
*
         lsum=la+lb+nOrdOp
         Call radlc(Zeta,nZeta,lsum,Array(ipRnr))
*
*       Combine the radial and angular component to the full one electron
*       integral.
*
         Call CmbnMPr(Array(ipRnr),nZeta,la,lb,nOrdOp,Zeta,
     &                Array(ipFnl),nComp)
*
         Call SOS(iStabO,nStabO,llOper)
         Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
         If (iPrint.ge.99) Then
            Write (6,*) ' m      =',nStabM
            Write (6,'(9A)') '{M}=',
     &                       (ChOper(iStabM(ii)),ii = 0, nStabM-1)
            Write (6,*) ' s      =',nStabO
            Write (6,'(9A)') '{S}=',
     &                       (ChOper(iStabO(ii)),ii = 0, nStabO-1)
            Write (6,*) ' LambdaT=',LmbdT
            Write (6,*) ' t      =',nDCRT
            Write (6,'(9A)') '{T}=',(ChOper(iDCRT(ii)),ii = 0, nDCRT-1)
         End If
*
         Do lDCRT = 0, nDCRT-1
*
*           Accumulate contributions
*
            nOp = NrOpr(iDCRT(lDCRT))
            Call SymAdO(Array(ipFnl),nZeta,la,lb,nComp,Final,nIC,
     &                  nOp         ,lOper,iChO,One)
         End Do
*
      Else
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the cartesian values of the basis functions angular part
*
      Call CrtCmp(Zeta,P,nZeta,A,Array(ipAxyz),
     &               la,HerR(iHerR(nHer)),nHer,ABeq)
      Call CrtCmp(Zeta,P,nZeta,RB,Array(ipBxyz),
     &               lb,HerR(iHerR(nHer)),nHer,ABeq)
*
      Call SOS(iStabO,nStabO,llOper)
      Call DCR(LmbdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
      If (iPrint.ge.99) Then
         Write (6,*) ' m      =',nStabM
         Write (6,'(9A)') '{M}=',(ChOper(iStabM(ii)),ii = 0, nStabM-1)
         Write (6,*) ' s      =',nStabO
         Write (6,'(9A)') '{S}=',(ChOper(iStabO(ii)),ii = 0, nStabO-1)
         Write (6,*) ' LambdaT=',LmbdT
         Write (6,*) ' t      =',nDCRT
         Write (6,'(9A)') '{T}=',(ChOper(iDCRT(ii)),ii = 0, nDCRT-1)
      End If
*
      Do lDCRT = 0, nDCRT-1
         Call OA(iDCRT(lDCRT),CCoor,TC)
*
*        Compute the contribution from the multipole moment operator
*
         ABeq(1) = .False.
         ABeq(2) = .False.
         ABeq(3) = .False.
         Call CrtCmp(Zeta,P,nZeta,TC,Array(ipRxyz),
     &               nOrdOp,HerR(iHerR(nHer)),nHer,ABeq)
*
*        Compute the cartesian components for the multipole moment
*        integrals. The integrals are factorized into components.
*
          Call Assmbl(Array(ipQxyz),
     &                Array(ipAxyz),la,
     &                Array(ipRxyz),nOrdOp,
     &                Array(ipBxyz),lb,
     &                nZeta,HerW(iHerW(nHer)),nHer)
*
*        Combine the cartesian components to the full one electron
*        integral.
*
         Call CmbnMP(Array(ipQxyz),nZeta,la,lb,nOrdOp,Zeta,rKappa,
     &               Array(ipFnl),nComp)
*
*        Accumulate contributions
*
         nOp = NrOpr(iDCRT(lDCRT))
         Call SymAdO(Array(ipFnl),nZeta,la,lb,nComp,Final,nIC,
     &               nOp         ,lOper,iChO,One)
*
      End Do
*
      End If
*
*
      If (iPrint.ge.99) Then
         Write (6,*)
         Write (6,*) ' Result in MltInt'
         Write (6,*)
         Write (6,*)  'la,lb,nHer=',la,lb,nHer
         Write (6,*)  'nComp=',nComp
         Write (6,*)
         Do iIC = 1, nIC
            Write (Label,'(A,I2,A)')
     &         ' MltInt(iIC=',iIC,')'
            Call RecPrt(Label,'(10G15.8) ',Final(1,1,1,iIC),nZeta,
     &                  nElem(la)*nElem(lb))
         End Do
      End If
*
*     Call GetMem(' Exit MltInt','LIST','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(Alpha)
         Call Unused_real_array(Beta)
         Call Unused_real_array(ZInv)
         Call Unused_real_array(PtChrg)
         Call Unused_integer(nGrid)
         Call Unused_integer(iAddPot)
      End If
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_SimRI_Z1CDia(Diag,Thr,Indx)
!
! Purpose: Zero 1-center diagonals smaller then Thr.
!          Diag is the diagonal (1st reduced set).
!          On exit, Indx(i)=1 if diagonal i was zeroed, else
!          Indx(i)=0 (thus, Indx must have same dimension as Diag).

use Cholesky, only: iAtomShl, iiBstR, iiBstRSh, IPRINT, iSP2F, LuPri, nnBstR, nnBstRSh, nnShl
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: Diag(*)
real(kind=wp), intent(in) :: Thr
integer(kind=iwp), intent(_OUT_) :: Indx(*)
integer(kind=iwp) :: iAB, iAB1, iAB2, iShlA, iShlAB, iShlB, n
real(kind=wp) :: zmx
integer(kind=iwp), parameter :: Inf_SimRI = 0

Indx(1:nnBstR(1,1)) = 0

zmx = Zero
n = 0
do iShlAB=1,nnShl
  call Cho_InvPck(iSP2F(iShlAB),iShlA,iShlB,.true.)
  if (iAtomShl(iShlA) == iAtomShl(iShlB)) then
    iAB1 = iiBstR(1,1)+iiBstRSh(1,iShlAB,1)+1
    iAB2 = iAB1+nnBstRSh(1,iShlAB,1)-1
    do iAB=iAB1,iAB2
      if (Diag(iAB) < Thr) then
        zmx = max(zmx,Diag(iAB))
        n = n+1
        Indx(iAB) = 1
        Diag(iAB) = Zero
      end if
    end do
  end if
end do

if (iPrint > Inf_SimRI) then
  write(LuPri,'(/,A,I7,A,ES10.2,A)') 'Simulating RI:',n,' 1-center diagonals < ',Thr,' have been zeroed'
  if (n > 0) write(LuPri,'(A,ES15.7)') 'Largest zeroed diagonal: ',zmx
end if

end subroutine Cho_SimRI_Z1CDia

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Yannick Carissan                                       *
************************************************************************
      subroutine RotateGeoms(Q)
      implicit none
#include "geoms.fh"
#include "debug.fh"
#include "WrkSpc.fh"
#include "options.fh"
      Real*8 Q(0:3)
      integer igeom

      Do igeom=3,ngeoms+2
        if (debug) then
          Write(6,*) "Before rotation"
          call PrintGeom(6,nat(igeom),title(igeom),
     &           Work(ipgeo(igeom)),geolbl(1,igeom))
        End If
        Call RotateGeom(Q,nat(igeom),
     &           Work(ipgeo(igeom)),Work(ipgeo(igeom)))
        if (debug) then
          Write(6,*) "After rotation"
          call PrintGeom(6,nat(igeom),title(igeom),
     &           Work(ipgeo(igeom)),geolbl(1,igeom))
        End If
      End Do
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ABTOR2(    SKII,    CKJJ,     NKA,     NIB,     NJB,
     &                       NKB,   RHO2B,      NI,      NJ,      NK,
     &                        NL,    MAXK,    KBIB,   XKBIB,    KBJB,
     &                     XKBJB,   IKORD)
*
* Obtain contributions alpha-beta contributions to two-particle
* density matrix
*
* Rho2b(ij,kl)  = RHo2b(ij,kl)
*               + sum(Ka) Skii(Ka,i,Ib)<Ib!Eb(kl)!Jb> Ckjj(Ka,j,Jb)
*
*
* Jeppe Olsen, Fall of 96
*
      IMPLICIT REAL*8(A-H,O-Z)
*. Input
      DIMENSION CKJJ(*),SKII(*)
      DIMENSION RHO2B(*)
      DIMENSION KBIB(MAXK,*),XKBIB(MAXK,*)
      DIMENSION KBJB(MAXK,*),XKBJB(MAXK,*)
*
      IF(IKORD.NE.0) THEN
        WRITE(6,*) ' ABTOR2 : IKORD .NE. 0 '
        WRITE(6,*) ' I am not ready for this '
*        STOP     ' ABTOR2 : IKORD .NE. 0 '
        CALL SYSABENDMSG('lucia_util/abtor2_gas',
     &                          'Internal error',' ')
      END IF
*
*. Excitations <Ib!Eb(kl)!Jb>
        DO KB = 1, NKB
*. Number of nonvanishing connections from KB
         LL = 0
         KK = 0
         DO L = 1, NL
           IF(KBJB(KB,L).NE.0) LL = LL + 1
         END DO
         DO K = 1, NK
           IF(KBIB(KB,K).NE.0) KK = KK + 1
         END DO
*
         IF(KK.NE.0.AND.LL.NE.0) THEN
           DO K = 1, NK
             IB = KBIB(KB,K)
             IF(IB.NE.0) THEN
               SGNK = XKBIB(KB,K)
               DO L = 1, NL
                 JB = KBJB(KB,L)
                 IF(JB.NE.0) THEN
                   SGNL = XKBJB(KB,L)
                   FACTOR = SGNK*SGNL
*. We have now a IB and Jb string, let's do it
                   ISOFF = (IB-1)*NI*NKA + 1
                   ICOFF = (JB-1)*NJ*NKA + 1
                   KLOFF= ((L-1)*NK + K - 1 )*NI*NJ + 1
                   IMAX = NI
*
C                  IF(IKORD.NE.0) THEN
*. Restrict so (ij) .le. (kl)
C                    IMAX  = K
C                    JKINTOF = INTOF + (K-1)*NJ
C                    DO J = L,NL
C                      XIJILS(J) = XIJKL(JKINTOF-1+J)
C                    END DO
C                    XIJKL(JKINTOF-1+L) = 0.5D0*XIJKL(JKINTOF-1+L)
C                    DO J = L+1, NL
C                     XIJKL(JKINTOF-1+J) = 0.0D0
C                    END DO
C                  END IF
                   ONE = 1.0D0
                   CALL MATML7(RHO2B(KLOFF),
     &                         SKII(ISOFF),CKJJ(ICOFF),NI,  NJ, NKA,
     &                            IMAX,    NKA,     NJ,    ONE,FACTOR ,
     &                               1)
C                  IF(IKORD.NE.0) THEN
C                     DO J = L,NL
C                       XIJKL(JKINTOF-1+J) =  XIJILS(J)
C                     END DO
C                  END IF
*
                 END IF
               END DO
*
             END IF
           END DO
         END IF
       END DO
*. (end over loop over Kb strings )
*
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(NIB)
        CALL Unused_integer(NJB)
      END IF
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
C Procedure for computing 1-body, 2-body, and 3-body
C density elements with active indices only,
C and related matrices obtained from contractions with
C the diagonal one-electron Hamiltonian.
C
C Out: density matrices, denoted here G1, G2 and G3.
C Storage: G1 and G2 are simple two- and four-index arrays, and
C includes also such zeroes that are implied by symmetry.
C But G3 is quite large, and while it is stored with zeroes, it
C is made more compact by calculating only the minimum amount of unique values and storing the
C active indices in the array idxG3.  Later, the full matrix can be restored
C on the fly by using the full permutational symmetry.
C
C ----
C
C.NN15 NOTE:
C In DMRG-CASPT2, full G3 is computed from BLOCK code
C and F3 is approximated by cumulant reconstruction scheme from G1, G2, and G3 (cu4),
C to avoid computation of 4-particle density matrix.
C However, because this introduces instability of CASPT2 calculation
C (lots of negative denominators appear), relatively large IPEA and imaginary shifts
C are required to converge CASPT2 iteration.
C
#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_
      SUBROUTINE MKFG3DM(IFF,G1,F1,G2,F2,G3,F3,idxG3)
      use output_caspt2, only:iPrGlb,verbose,debug
#if defined (_MOLCAS_MPP_) && !defined (_GA_)
      USE Para_Info, ONLY: nProcs, Is_Real_Par, King
#endif
      IMPLICIT NONE
#include "rasdim.fh"
#include "caspt2.fh"
#include "SysDef.fh"
#include "WrkSpc.fh"
#include "pt2_guga.fh"

      INTEGER, INTENT(IN) :: IFF
      REAL*8, INTENT(OUT) :: G1(NLEV,NLEV),G2(NLEV,NLEV,NLEV,NLEV)
      REAL*8, INTENT(OUT) :: F1(NLEV,NLEV),F2(NLEV,NLEV,NLEV,NLEV)
      REAL*8, INTENT(OUT) :: G3(*), F3(*)
      INTEGER*1, INTENT(OUT) :: idxG3(6,*)

      LOGICAL RSV_TSK

      INTEGER, PARAMETER :: I1=KIND(idxG3)

      REAL*8 DG1,DG2,DG3,DF1,DF2,DF3
*     REAL*8 F1SUM,F2SUM

      INTEGER I,J,IDX,JDX
      INTEGER IB,IBMN,IBMX,IBUF,NB,NBTOT,IBUF1
      INTEGER IP1,IP2,IP3,IP1MN,IP1MX,IP1I,IP1STA,IP1END,IP3MX,IQ1
      INTEGER IG3,IG3OFF
      INTEGER ISTU,ISVX,ISYZ
      INTEGER IT,IU,IV,IX,IY,IZ
      INTEGER ITLEV,IULEV,IVLEV,IXLEV,IYLEV,IZLEV
      INTEGER LBUF1,LBUF2,LBUFD,LBUFT
      INTEGER NBUF1,NBUF2,NBUFD,NBUFT
      INTEGER LIBUF1,LIP1STA,LIP1END,LOFFSET,IOFFSET
      INTEGER ISSG1,ISSG2,ISP1
      INTEGER ITASK,ISUBTASK,ID,NTASKS,NSUBTASKS,
     &        LTASK_LIST,MXTASK,MYTASK,MYBUFFER
*     INTEGER NSGM1,NSGM2
      INTEGER NTRI1,NTRI2
*     INTEGER L1,LTO,LFROM
      INTEGER MEMMAX, MEMMAX_SAFE
      INTEGER NLEV2
#ifdef _ENABLE_BLOCK_DMRG_
      INTEGER NLEV4,LG3TMP
#endif
      INTEGER LDUM,NDUM
      INTEGER NCI
*     INTEGER ICSF

      REAL*8, EXTERNAL :: DDOT_,DNRM2_

      ! translation tables for levels i,j to and from pair indices idx
      INTEGER IJ2IDX(MXLEV,MXLEV)
      INTEGER IDX2IJ(2,MXLEV**2)
      INTEGER ICNJ(MXLEV**2)
      INTEGER IP1_BUF(MXLEV**2)

      ! result buffer, maximum size is the largest possible ip1 range,
      ! which is set to nbuf1 later, i.e. a maximum of nlev2 <= mxlev**2
*     REAL*8 BUFR(MXLEV**2)


C Put in zeroes. Recognize special cases:
      IF(nlev.EQ.0) GOTO 999

      CALL DCOPY_(NG1,[0.0D0],0,G1,1)
      CALL DCOPY_(NG2,[0.0D0],0,G2,1)
      CALL DCOPY_(NG3,[0.0D0],0,G3,1)
      IF(IFF.ne.0) THEN
        CALL DCOPY_(NG1,[0.0D0],0,F1,1)
        CALL DCOPY_(NG2,[0.0D0],0,F2,1)
        CALL DCOPY_(NG3,[0.0D0],0,F3,1)
      END IF

      IF(NACTEL.EQ.0) GOTO 999

      NCI=NCSF(STSYM)
* This should not happen, but...
      IF(NCI.EQ.0) GOTO 999

C Here, for regular CAS or RAS cases.

C Special pair index idx2ij allows true RAS cases to be handled:
      nlev2=nlev**2
      ntri1=(nlev2-nlev)/2
      ntri2=(nlev2+nlev)/2
      idx=0
      do i=1,nlev-1
        do j=i+1,nlev
          idx=idx+1
          ij2idx(i,j)=idx
          idx2ij(1,idx)=i
          idx2ij(2,idx)=j
          jdx=nlev2+1-idx
          ij2idx(j,i)=jdx
          idx2ij(1,jdx)=j
          idx2ij(2,jdx)=i
        end do
      end do
      do i=1,nlev
        idx=ntri1+i
        ij2idx(i,i)=idx
        idx2ij(1,idx)=i
        idx2ij(2,idx)=i
      end do
      do idx=1,nlev2
        i=idx2ij(1,idx)
        j=idx2ij(2,idx)
        jdx=ij2idx(j,i)
        icnj(idx)=jdx
      end do

* Dummy values necessary for fooling syntax checkers:
      ldum=1
      ndum=1
      call getmem('memmx','max','real',ldum,memmax)

* Use *almost* all remaining memory:
      memmax_safe=int(dble(memmax)*0.95D0)

* Buffers to compute CI expansion vectors into:
*
*
*
*
*
*
      nbuf1=max(1,min(nlev2,(memmax_safe-3*mxci)/mxci)) ! -> 1 w/ DMRG?
      nbuf2= 1
      nbuft= 1
      nbufd= 1
      CALL GETMEM('BUF1','ALLO','REAL',LBUF1,NBUF1*MXCI)
      CALL GETMEM('BUF2','ALLO','REAL',LBUF2,NBUF2*MXCI)
      CALL GETMEM('BUFT','ALLO','REAL',LBUFT,NBUFT*MXCI)
      CALL GETMEM('BUFD','ALLO','REAL',LBUFD,NBUFD*MXCI)

C-SVC20100301: calculate maximum number of tasks possible
      MXTASK=(NTRI2-1)/NBUF1+1+(NTRI1-1)/NBUF1+1
      CALL GETMEM ('TASKLIST','ALLO','INTE',lTask_List,4*mxTask)
      lip1sta=lTask_List
      lip1end=lTask_List+mxTask
      libuf1=lTask_List+2*mxTask
      lOffSet=lTask_List+3*mxTask

      IF(iPrGlb.GE.VERBOSE) THEN
        WRITE(6,*)
        WRITE(6,'(2X,A)') 'Constructing G3/F3'
        WRITE(6,'(2X,A,F16.9,A)') ' memory avail: ',
     &    (memmax*RtoB)/1.0D9, ' GB'
        WRITE(6,'(2X,A,F16.9,A)') ' memory used:  ',
     &    (((nbuf1+3)*MXCI)*RtoB)/1.0D9, ' GB'
        call xFlush(6)
      ENDIF

      iG3OFF=0
* A *very* long loop over the symmetry of Sgm1 = E_ut Psi as segmentation.
*
      DO issg1=1,nsym
       isp1=mul(issg1,stsym)
*      nsgm1=ncsf(issg1)
*      CALL H0DIAG_CASPT2(ISSG1,WORK(LBUFD),IWORK(LNOW),IWORK(LIOW))

C-SVC20100301: calculate number of larger tasks for this symmetry, this
C-is basically the number of buffers we fill with sigma1 vectors.
      iTask=1
      ibuf1=0
      DO ip1=1,nlev2
        itlev=idx2ij(1,ip1)
        iulev=idx2ij(2,ip1)
        istu=mul(ism(itlev),ism(iulev))
        IF (istu.EQ.isp1) THEN
          ibuf1=ibuf1+1
          ip1_buf(ibuf1)=ip1
          IF (ibuf1.EQ.1) iwork(lip1sta+iTask-1)=ip1
        ENDIF
        IF (ibuf1.EQ.nbuf1.OR.(ibuf1.GT.0.AND.
     &         (ip1.EQ.ntri2.OR.ip1.EQ.nlev2))) THEN
            iwork(lip1end+iTask-1)=ip1_buf(ibuf1)
            iwork(libuf1+iTask-1)=ibuf1
            iTask=iTask+1
            ibuf1=0
        ENDIF
      ENDDO
      nTasks=iTask
      IF (ibuf1.EQ.0) nTasks=nTasks-1
C-SVC20100309: calculate number of inner loop iteration tasks.
      iOffSet=0
      DO iTask=1,nTasks
        iWork(lOffSet+iTask-1)=iOffSet
        ip1sta=iwork(lip1sta+iTask-1)
        ip1end=iwork(lip1end+iTask-1)
        ip3mx=ntri2
        if(ip1end.le.ntri2) ip3mx=ip1end
        if(ip1sta.gt.ntri2) ip3mx=ntri1
C-SVC20100309: Currently -we are going to limit this to the ip3-loop and
C-leave the ip2-loop intact.  This was based on the large overhead which
C-was observed for a very large number of small tasks.
C       iOffSet=iOffSet+ip3mx*ntri2-((ip3mx**2-ip3mx)/2)
        iOffSet=iOffSet+ip3mx
      ENDDO
      nSubTasks=iOffSet

      IF(iPrGlb.GE.VERBOSE) THEN
        WRITE(6,'(2X,A,I3,A,I6)') 'Sym: ',issg1,', #Tasks: ',nSubTasks
        call xFlush(6)
      ENDIF

      IF(iPrGlb.GE.DEBUG) THEN
        IF (nSubTasks .GT. 0) THEN
          WRITE(6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
C-position 12345678901234567890
     &    "--------",
     &    "------------",
     &    "----",
     &    "---------"
          WRITE(6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
C-position 12345678901234567890
     &    "task ID ",
     &    " ip1 range  ",
     &    "ip3 ",
     &    "#elements"
          WRITE(6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
C-position 12345678901234567890
     &    "--------",
     &    "------------",
     &    "----",
     &    "---------"
          call xFlush(6)
        END IF
      END IF

C-SVC20100301: initialize the series of subtasks
      Call Init_Tsk(ID, nSubTasks)

      myBuffer=0

 500  CONTINUE
C-SVC20100908: first check: can I actually do any task?
      IF ((NG3-iG3OFF).LT.nbuf1*ntri2) GOTO 501
C-SVC20100831: initialize counter for offset into G3
C-SVC20100302: BEGIN SEPARATE TASK EXECUTION
      If (.NOT.Rsv_Tsk(ID,iSubTask)) GOTO 501

      myTask=nTasks
      DO iTask=1,nTasks
        iBuf=iSubTask-iWork(lOffSet+iTask-1)
        IF (iBuf.LE.0) THEN
          myTask=iTask-1
          goto 666
        ENDIF
      ENDDO
666   continue
      iTask=myTask

      iOffSet=iWork(lOffSet+iTask-1)

C-SVC20100310: one task handles a range of ip1 values
C-that are in the buffer and one ip3 value, for which
C-a loop over ip2 values is then executed.
      ip1sta=iWork(lip1sta+iTask-1)
      ip1end=iWork(lip1end+iTask-1)
      ip3=iSubTask-iOffSet

C-SVC20100301: fill the buffer with sigma vectors if they
C-have not been computed yet, else just get the number of
C-sigma vectors in the buffer.
      IF (myBuffer.NE.iTask) THEN
        ibuf1=0
        do ip1i=ip1sta,ip1end
         itlev=idx2ij(1,ip1i)
         iulev=idx2ij(2,ip1i)
         istu=mul(ism(itlev),ism(iulev))
         it=L2ACT(itlev)
         iu=L2ACT(iulev)
         if(istu.eq.isp1) then
          ibuf1=ibuf1+1
          ip1_buf(ibuf1)=ip1i
*         lto=lbuf1+mxci*(ibuf1-1)
*         call dcopy_(nsgm1,0.0D0,0,work(lto),1)
*         CALL SIGMA1_CP2(IULEV,ITLEV,1.0D00,STSYM,CI,WORK(LTO),
*    &     IWORK(LNOCSF),IWORK(LIOCSF),IWORK(LNOW),IWORK(LIOW),
*    &     IWORK(LNOCP),IWORK(LIOCP),IWORK(LICOUP),
*    &     WORK(LVTAB),IWORK(LMVL),IWORK(LMVR))
         end if
        end do
        myBuffer=iTask
      ELSE
        ibuf1=iWork(libuf1+iTask-1)
      ENDIF
C-SVC20100301: necessary batch of sigma vectors is now in the buffer

*     ! The ip1 buffer could be the same on different processes
*     ! so only compute the G1 contribution when ip3 is 1, as
*     ! this will only be one task per buffer.
*     if (issg1.eq.stsym.AND.ip3.eq.1) then
*       do ib=1,ibuf1
*         idx=ip1_buf(ib)
*         itlev=idx2ij(1,idx)
*         iulev=idx2ij(2,idx)
*         it=L2ACT(itlev)
*         iu=L2ACT(iulev)
*         lto=lbuf1+mxci*(ib-1)
*         G1(it,iu)=DDOT_(nsgm1,ci,1,work(lto),1)
*         IF(IFF.ne.0) then
*           F1sum=0.0D0
*           do i=1,nsgm1
*             F1sum=F1sum+CI(i)*work(lto-1+i)*work(lbufd-1+i)
*           end do
*           F1(it,iu)=F1sum-EPSA(iu)*G1(it,iu)
*         end if
*       end do
*     end if

C     ip3mx=ntri2
C     if(ip1end.le.ntri2) ip3mx=ip1end
C     if(ip1sta.gt.ntri2) ip3mx=ntri1
C-SVC20100309: loop over ip3, ip2
C     do ip3=1,ip3mx

C-SVC20100309: PAM's magic formula
*     iCnt=iSubTask-iOffSet
*     ip3=int(dble(ntri2)+1.5D0 -
*    &     sqrt((dble(ntri2)+0.5d0)**2-2*iCnt+0.000001D0))
*     ip2=iCnt-((ip3-1)*ntri2-((ip3-1)*(ip3-2))/2 )+ip3-1

C-SVC20100309: use simpler procedure by keeping inner ip2-loop intact

C NN.14 TODO:
C To avoid storing full G3(tmp) in memory, need to store
C G3(:,:,it,iu,iy,iz) loaded from disk, for each process...

      iq1=icnj(ip3)
* The indices corresponding to pair index p3:
      iylev=idx2ij(1,ip3)
      izlev=idx2ij(2,ip3)
      isyz=mul(ism(iylev),ism(izlev))
      issg2=mul(isyz,stsym)
*     nsgm2=ncsf(issg2)
      iy=L2ACT(iylev)
      iz=L2ACT(izlev)
*     lto=lbuf2
*     call dcopy_(nsgm2,0.0D0,0,work(lto),1)
*     CALL SIGMA1_CP2(IYLEV,IZLEV,1.0D00,STSYM,CI,WORK(LTO),
*    &     IWORK(LNOCSF),IWORK(LIOCSF),IWORK(LNOW),IWORK(LIOW),
*    &     IWORK(LNOCP),IWORK(LIOCP),IWORK(LICOUP),
*    &     WORK(LVTAB),IWORK(LMVL),IWORK(LMVR))
*     if(issg2.eq.issg1) then
*       do ib=1,ibuf1
*         idx=iwork(lip1buf-1+ib)
*         itlev=idx2ij(1,idx)
*         iulev=idx2ij(2,idx)
*         it=L2ACT(itlev)
*         iu=L2ACT(iulev)
*         G2(it,iu,iy,iz)=DDOT_(nsgm1,work(lto),1,
*    &         work(lbuf1+mxci*(ib-1)),1)
*         IF(IFF.ne.0) THEN
*           F2sum=0.0D0
*           do i=1,nlev
*             F2sum=F2sum+work(lto-1+i)*work(lbufd-1+)*
*    &             work(lbuf1-1+i+mxci*(ib-1))
*           end do
*           F2(it,iu,iy,iz)=F2sum
*         END IF
*       end do
*     end if
      nbtot=0
      do ip2=ip3,ntri2
        ivlev=idx2ij(1,ip2)
        ixlev=idx2ij(2,ip2)
        isvx=mul(ism(ivlev),ism(ixlev))
        iv=L2ACT(ivlev)
        ix=L2ACT(ixlev)
        if(isvx.ne.mul(issg1,issg2)) goto 99
*       lfrom=lbuf2
*       lto=lbuft
*       call dcopy_(nsgm1,0.0D0,0,work(lto),1)
*       CALL SIGMA1_CP2(IVLEV,IXLEV,1.0D00,ISSG2,WORK(LFROM),WORK(LTO),
*    &       IWORK(LNOCSF),IWORK(LIOCSF),IWORK(LNOW),IWORK(LIOW),
*    &       IWORK(LNOCP),IWORK(LIOCP),IWORK(LICOUP),
*    &       WORK(LVTAB),IWORK(LMVL),IWORK(LMVR))
*-----------
* Max and min values of index p1:
        ip1mx=ntri2
        if(ip3.le.ntri1) then
          ip1mx=nlev2
          if(ip2.gt.ntri1) ip1mx=iq1
        end if
        ip1mn=max(ip2,ip1sta)
        ip1mx=min(ip1mx,ip1end)
* The corresponding locations in the Sgm1 buffer:
        ibmn=999999
        ibmx=-999999
        do ib=ibuf1,1,-1
          ip1=ip1_buf(ib)
          if(ip1.ge.ip1mn)ibmn=ib
        end do
        do ib=1,ibuf1
          ip1=ip1_buf(ib)
          if(ip1.le.ip1mx)ibmx=ib
        end do
        nb=ibmx-ibmn+1
        if(nb.le.0) goto 99

*-----------
* Contract the Sgm1 wave functions with the Tau wave function.
*       l1=lbuf1+mxci*(ibmn-1)
*       call DGEMV_('T',nsgm1,nb,1.0D0,work(l1),mxci,
*    &       work(lbuft),1,0.0D0,bufr,1)
* and distribute this result into G3:
*       call DCOPY_(nb,bufr,1,G3(iG3OFF+1),1)
* and copy the active indices into idxG3:
        do ib=1,nb
         iG3=iG3OFF+ib
         idx=ip1_buf(ibmn-1+ib)
         itlev=idx2ij(1,idx)
         iulev=idx2ij(2,idx)
         iT=l2act(itlev)
         iU=l2act(iulev)
         idxG3(1,iG3)=int(iT,I1)
         idxG3(2,iG3)=int(iU,I1)
         idxG3(3,iG3)=int(iV,I1)
         idxG3(4,iG3)=int(iX,I1)
         idxG3(5,iG3)=int(iY,I1)
         idxG3(6,iG3)=int(iZ,I1)
        end do
*       IF(IFF.ne.0) THEN
* Elementwise multiplication of Tau with H0 diagonal - EPSA(IV):
*         do icsf=1,nsgm1
*           work(lbuft-1+icsf)=
*    &           (work(lbufd-1+icsf)-epsa(iv))*work(lbuft-1+icsf)
*         end do
* so Tau is now = Sum(eps(w)*E_vxww) Psi. Contract and distribute:
*         call DGEMV_('T',nsgm1,nb,1.0D0,work(l1),mxci,
*    &         work(lbuft),1,0.0D0,bufr,1)
*         call dcopy_(nb,bufr,1,F3(iG3OFF+1),1)
*       END IF
        iG3OFF=iG3OFF+nb
        nbtot=nbtot+nb
 99     continue
      end do
*     end do

      IF(iPrGlb.GE.DEBUG) THEN
        WRITE(6,'("DEBUG> ",I8,1X,"[",I4,"..",I4,"]",1X,I4,1X,I9)')
     &    iSubTask, ip1sta, ip1end, ip3, nbtot
        call xFlush(6)
      END IF

CSVC: The master node now continues to only handle task scheduling,
C     needed to achieve better load balancing. So it exits from the task
C     list.  It has to do it here since each process gets at least one
C     task.
#if defined (_MOLCAS_MPP_) && !defined (_GA_)
      IF (IS_REAL_PAR().AND.KING().AND.(NPROCS.GT.1)) GOTO 501
#endif

C-SVC20100301: end of the task
      GOTO 500

 501  CONTINUE

C-SVC20100302: no more tasks, wait here for the others, then proceed
C with next symmetry
      CALL Free_Tsk(ID)

      IF(iPrGlb.GE.DEBUG) THEN
        IF (nSubTasks .GT. 0) THEN
          WRITE(6,'("DEBUG> ",A8,1X,A12,1X,A4,1X,A9)')
C-position 12345678901234567890
     &    "--------",
     &    "------------",
     &    "----",
     &    "---------"
        END IF
      END IF

* End of sectioning loop over symmetry of Sgm1 wave functions.
      END DO
C-SVC20100831: set correct number of elements in new G3
      NG3=iG3OFF

      CALL GETMEM ('TASKLIST','FREE','INTE',lTask_List,4*mxTask)
      ! free CI buffers
      CALL GETMEM('BUF1','FREE','REAL',LBUF1,NBUF1*MXCI)
      CALL GETMEM('BUF2','FREE','REAL',LBUF2,NBUF2*MXCI)
      CALL GETMEM('BUFT','FREE','REAL',LBUFT,NBUFT*MXCI)
      CALL GETMEM('BUFD','FREE','REAL',LBUFD,NBUFD*MXCI)

C-SVC20100302: Synchronized add into the densitry matrices
C  only for the G1 and G2 replicate arrays
      CALL GADSUM(G1,NG1)
      CALL GADSUM(G2,NG2)

      CALL GADSUM(F1,NG1)
      CALL GADSUM(F2,NG2)

#ifdef _ENABLE_BLOCK_DMRG_
      NLEV4=NLEV2**2
C
C allocate work space to store 3RDM
      Call GETMEM('G3TMP','ALLO','REAL',LG3TMP,NLEV4)
C
C TODO: Here, several options to compute F3.
C Currently implemented only cu4, but cu34 and F3 from DMRG-sweep
C will be possible. They should be implemented at this section.
C
C MKFG3CU4 is located under block_dmrg_util/
      Call MKFG3CU4(IFF,G1,F1,G2,F2,G3,F3,idxG3,Work(LG3TMP))
C
      Call GETMEM('G3TMP','FREE','REAL',LG3TMP,NLEV4)
#endif

#ifdef _ENABLE_CHEMPS2_DMRG_
      Call mkfg3chemps2(IFF,G1,F1,G2,F2,G3,F3,idxG3)
#endif

      IF(iPrGlb.GE.DEBUG) THEN
CSVC: if running parallel, G3/F3 are spread over processes,
C     so make sure that the _total_ fingerprint is computed
        dG1=DNRM2_(NG1,G1,1)
        dG2=DNRM2_(NG2,G2,1)
        dG3=DDOT_(NG3,G3,1,G3,1)
        CALL GADGOP_SCAL(dG3,'+')
        dG3=SQRT(dG3)
        dF1=DNRM2_(NG1,F1,1)
        dF2=DNRM2_(NG2,F2,1)
        dF3=DDOT_(NG3,F3,1,F3,1)
        CALL GADGOP_SCAL(dF3,'+')
        dF3=SQRT(dF3)

        WRITE(6,'("DEBUG> ",A)') "norms of the density matrices:"
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G1:", dG1
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G2:", dG2
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "G3:", dG3
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "F1:", dF1
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "F2:", dF2
        WRITE(6,'("DEBUG> ",A,1X,ES21.14)') "F3:", dF3
      ENDIF

 999  continue
      RETURN
      END
#elif defined (NAGFOR)
c Some compilers do not like empty files
      Subroutine empty_MKFG3DM()
      End
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       Integer Function nMemAm(nShBF,nIrrep,nS,jS,iOffA,Out_of_Core)
       Integer nShBf(0:nIrrep-1,nS), iOffA(4,0:nIrrep-1)
       Logical Out_of_Core
*
       If (Out_Of_Core) Then
*
*         Only a subblock of the upper trianular storage.
*
          nMemAm=0
          Do iIrrep = 0, nIrrep-1
             nj = nShBf(iIrrep,jS)
             nl = 0
             Do lS = 1, jS
                nl = nl+ nShBf(iIrrep,lS)
             End Do
*            Offset to where this block starts
             iOffA(1,iIrrep)=nMemAm
*            # of basis functions for the jSs shell
             iOffA(2,iIrrep)=nj
*            max # number of basis functions for this block
             iOffA(4,iIrrep)=nl
*            Update nMemAm with the sise of this subblock.
             nn = nl-nj
             nMemAm = nMemAm + nl*(nl+1)/2 - nn*(nn+1)/2
          End Do
       Else
*
*         The whole A matrix is in core! Upper triangular storage.
*
          nMemAm=0
          Do iIrrep = 0, nIrrep-1
             nj = nShBf(iIrrep,jS)
             ni = 0
             Do lS = 1, jS-1
                ni = ni + nShBf(iIrrep,lS)
             End Do
             nl = ni + nj
*            Offset to where this block starts
             iOffA(1,iIrrep)=nMemAm+ni*(ni+1)/2
*            # of basis functions for the jSs shell
             iOffA(2,iIrrep)=nj
             iOffA(4,iIrrep)=nl
*            Update nMemAm with the size of the whole block for this irrep.
             Do lS = jS+1,nS
                nl = nl + nShBf(iIrrep,lS)
             End Do
             nMemAm = nMemAm + nl*(nl+1)/2
          End Do
       End If
*
       Return
       End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine CnstFIFAFIMO(MODE)

use Index_Functions, only: nTri_Elem
use caspt2_global, only: CMOPT2, FIFA, FIFA_all, FIFASA_all, FIMO, FIMO_all, OLag, TraFro
use caspt2_module, only: IfChol, IFDW, IFRMS, IFXMS, NBAS, NBSQT, NFRO, NFROT, NSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: MODE
integer(kind=iwp) :: iSQ, iSym, iTr, nBasI
real(kind=wp), allocatable :: WRK1(:), WRK2(:)

if (IfChol) then
  !! For DF or CD, we already have FIFA and FIMO in AO,
  !! so just do AO -> MO transformation
  call mma_allocate(WRK1,NBSQT,Label='WRK1')
  call mma_allocate(WRK2,NBSQT,Label='WRK2')
  WRK1(:) = Zero
  WRK2(:) = Zero

  iSQ = 0
  iTR = 0
  do iSym=1,nSym
    ! nOrbI = nOrb(iSym)
    nBasI = nBas(iSym)
    !! FIFA
    if (nFroT == 0) then
      if ((MODE == 0) .and. (IFDW .or. IFRMS)) then
        call SQUARE(FIFA(1+iTr),FIFASA_all(1+iSQ),1,nBasI,nBasI)
      else if (MODE == 1) then
        call SQUARE(FIFA(1+iTr),FIFA_all(1+iSQ),1,nBasI,nBasI)
        !write(u6,*) 'fifa in MO'
        !call sqprt(fifa_all(1+isq),nbasi)
      end if
    else
      call SQUARE(FIFA_all(1+iTr),WRK1,1,nBasI,nBasI)
      !write(u6,*) 'fifasa in AO'
      !call sqprt(wrk1,nbasi)
      if ((MODE == 0) .and. (IFDW .or. IFRMS)) then
        !! with the state-average
        !! FIFASA_all will be natural basis
        call OLagTrf(2,iSym,NBSQT,CMOPT2,FIFASA_all(1+iSQ),WRK1,WRK2)
        !write(u6,*) 'fifasa in MO'
        !call sqprt(fifasa_all(1+isq),nbasi)
      else if (MODE == 1) then
        !! with the state-specific or dynamically weighted
        !! FIFA will be quasi-canonical basis
        call OLagTrf(2,iSym,NBSQT,CMOPT2,FIFA_all(1+iSQ),WRK1,WRK2)
        !write(u6,*) 'fifa in MO'
        !call sqprt(fifa_all(1+isq),nbasi)
        !! canonicalize frozen orbitals
        !! still under investigation, but this is something we
        !! should do to obtain "better" orbital enegies for
        !! methods using state-dependent Fock operators.
        !! We actually need to canonicalize frozen and inactive
        !! orbitals simultaneously?
        if (nFroT /= 0) then
          WRK2(1:nBasI*nBasI) = WRK1(1:nBasI*nBasI)
          call DIAFCK(NBAS(ISYM),FIFA_all,1,NFRO(ISYM),TraFro,NBAS(ISYM),CMOPT2,WRK2)
          CMOPT2(1:NBAS(ISYM)*NFRO(ISYM)) = WRK2(1:NBAS(ISYM)*NFRO(ISYM))
          call OLagTrf(2,iSym,NBSQT,CMOPT2,FIFA_all(1+iSQ),WRK1,WRK2)
        end if
      end if
    end if

    !! FIMO
    !if (MODE == 0) then
    if (nFroT == 0) then
      call SQUARE(FIMO(1+iTr),FIMO_all(1+iSQ),1,nBasI,nBasI)
    else
      call SQUARE(FIMO_all(1+iTr),WRK1,1,nBasI,nBasI)
      call OLagTrf(2,iSym,NBSQT,CMOPT2,FIMO_all(1+iSQ),WRK1,OLag)
      !write(u6,*) 'fimo in MO'
      !call sqprt(fimo_all(1+isq),nbasi)
    end if
    !end if
    iSQ = iSQ+nBasI*nBasI
    iTR = iTR+nTri_Elem(nBasI)
  end do
  call mma_deallocate(WRK1)
  call mma_deallocate(WRK2)

  if (IFXMS .and. (.not. IFDW)) FIFASA_all(1:NBSQT) = FIFA_all(1:NBSQT)
else
  if (nFroT == 0) then
    iSQ = 0
    iTR = 0
    do iSym=1,nSym
      ! nOrbI = nOrb(iSym)
      nBasI = nBas(iSym)
      call SQUARE(FIFA(1+iTr),FIFA_all(1+iSQ),1,nBasI,nBasI)
      call SQUARE(FIMO(1+iTr),FIMO_all(1+iSQ),1,nBasI,nBasI)
      iSQ = iSQ+nBasI*nBasI
      iTR = iTR+nTri_Elem(nBasI)
    end do
    if (IFXMS .and. (.not. IFDW)) FIFASA_all(1:NBSQT) = FIFA_all(1:NBSQT)
  end if

  !! XDW or RMS case: call after XDWINI
  !if (MODE == 0) then
  !end if

  !! XMS case: call after GRPINI
  !if (MODE == 1) then
  !end if

  !! SS or MS case: call in dens
  !if (MODE == 2) then
  !  if (IFSADREF) then
  !  else
  !  end if
  !end if
end if

return

end subroutine CnstFIFAFIMO

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine OutCoor(TEXT,Char,nDim,FI,N1,N2,lAngstroms)
************************************************************************
*                                                                      *
*     Object: To generate a cartesian output with atomic labels        *
*             N1 and N2 are the real limits of dummy FI                *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "angstr.fh"
      Character*(*) TEXT
      Character*(*) Char(nDim)
      Logical lAngstroms
      Real*8 FI(N1,N2)
*
*
      Lu=6
      Write (Lu,*)
      Write (Lu,*) '******************************************'//
     &             '***************'
      Write (Lu,*) Text
      Write (Lu,*) '******************************************'//
     &             '***************'
      Write (Lu,*) ' ATOM              X               Y      '//
     &             '         Z     '
      Do 10 I = 1, NDIM
         If (lAngstroms) then
            Write (Lu,300) Char(I),(FI(J,I)*angstr,J=1,3)
         else
            Write (Lu,300) Char(I),(FI(J,I),J=1,3)
         EndIf
300      Format (2X,A,3X,3F16.6)
10    Continue
*
      Write (Lu,*)
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2007,2009, Bingbing Suo                                *
!***********************************************************************
! Jul. 3, 2009 -bsuo- subroutines are used in davidson diagonalization

subroutine cidiagonalize(mxvec)
!******************************************************
! this subroutine does diagonalization of
! ci matrix for multi-root mrci program
! 26 feb 2007 - write by suo bing
!------------------------------------------------------

use gugaci_global, only: indx, LuCiDia, LuCiTv1, LuCiTv2, LuCiVec, max_iter, max_kspace, max_root, maxciiter, mcroot, mjn, mroot, &
                         mth_eigen, nci_dim, vd, ve, vector1, vector2, vint_ci, vp, vthrealp, vthreen, vthreresid, vu
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mxvec
integer(kind=iwp) :: i, iciter, id, iiter, irot, irset, irte, irts, itidx, jiter, kval, l, m, mi, mid, mn, mt, mtid, mtidx, mtsta, &
                     mtsta0, nd, nda, ni, numroot
real(kind=wp) :: depff, sc0, sc1, sct, scvp, sechc, valpha_criterion, venergy, venergy_criterion, vet, vresid_criterion, vuim
logical(kind=iwp) :: log_convergence, log_muliter, restart
integer(kind=iwp), allocatable :: idxvec(:)
real(kind=wp), allocatable :: difeci(:), valpha(:), vcien(:), vcienold(:), vresid(:)
real(kind=wp), parameter :: depc = 1.0e-7_wp
                            !, valpha_criterion = 1.0e-7_wp, venergy_criterion = 1.0e-8_wp, vresid_criterion = 1.0e-8_wp
real(kind=wp), external :: c_time

venergy_criterion = vthreen
valpha_criterion = vthrealp
vresid_criterion = vthreresid
write(u6,*) ' threshold for convergence is set as'
write(u6,*) venergy_criterion,valpha_criterion,vresid_criterion

!write(u6,*) vthreen,vthrealp,vthreresid
log_convergence = .false.
log_muliter = .false.
if (mroot*nci_dim <= mxvec) log_muliter = .true.
mcroot = mroot
!*********************************************************************
! for debug use only

id = 1
if (id == 2) then

  indx(1) = 0
  indx(2) = nci_dim
  !vector1(1:nci_dim) = Zero
  !vector2(1:nci_dim) = Zero
  !call cielement()
  vector1(:) = Zero
  vector2(:) = Zero
  vector1(55) = One
  call readint(2,vint_ci)
  call vd_drt_ci_new()
  call dv_drt_ci_new()
  !call matrix_vector_multi_parallel_drt(sechc)
  do i=1,3450
    write(11,'(i8,1x,f18.8)') i,vector2(i)
  end do
  call abend()
end if
!***********************************************************************

mth_eigen = 0
numroot = mroot
call mma_allocate(idxvec,max_iter,label='idxvec')
call mma_allocate(difeci,max_root,label='difeci')
call mma_allocate(valpha,max_root,label='valpha')
call mma_allocate(vcien,max_root,label='vcien')
call mma_allocate(vcienold,max_root,label='vcienold')
call mma_allocate(vresid,max_root,label='vresid')
outer: do
  restart = .false.
  sc0 = c_time()
  vector1(:) = Zero
  vector2(:) = Zero
  if (log_muliter) then
    mcroot = mroot
    call mrcibasis(nci_dim,mroot,mjn,indx,vector1,vector2,vcien,mth_eigen,mroot)
    !call mrcibasis_init(nci_dim,mroot,mjn,indx,vector1,vector2,vcien,mth_eigen,mroot)
  else
    mcroot = 1
    if (mth_eigen == 0) then
      mth_eigen = 1
    else
      mth_eigen = mth_eigen+1
    end if
    if (mth_eigen == 1) then
      call mrcibasis(nci_dim,mroot,mjn,indx,vector1,vector2,vcien,mth_eigen,1)
    else
      mcroot = 1
      call mrcibasis_rest(nci_dim,numroot,mjn,indx,vector1,vector2,vcien,mth_eigen,1)
    end if
  end if
  !call abend()
  sc1 = c_time()
  sct = sc1-sc0
  write(u6,890) 2*mroot,sct

  idxvec(1) = mroot
  idxvec(2) = 2*mroot
  idxvec(3:max_iter) = 0
  vcienold(1:max_root) = Zero
  vresid(1:max_root) = Zero
  valpha(1:max_root) = Zero
  iiter = 2
  kval = 2*mroot
  mcroot = mroot
  mtsta = 1
  iciter = 0
  irset = 0

  write(u6,901)
  do while (.not. log_convergence)
    iciter = iciter+1
    sc0 = c_time()
    call matrmkmul(mtsta,iiter,idxvec,irset)
    call hotred(max_kspace,kval,vp,vd,ve,vu)
    call qlcm(max_kspace,kval,vd,ve,vu)
    !if (iciter == 3) call abend()

    vcienold(1:mroot) = vcien(1:mroot)
    valpha(mtsta:mroot) = Zero
    do m=mtsta,mroot
      vcien(m) = vd(m)
      valpha(m) = abs(vu(kval,m))
      difeci(m) = abs(vcien(m)-vcienold(m))
    end do

    call compute_residual_vector_mroot(mtsta,iiter,idxvec,vresid,vcien)
    !write(u6,900) iciter
    !write(u6,901)
    if (iciter == 1) then
      sechc = Zero
      scvp = Zero
    end if
    do mt=1,mroot
      write(u6,902) iciter,mt,vcien(mt),difeci(mt),valpha(mt),vresid(mt),sechc,scvp
    end do
    call xflush(u6)

    !write(u6,903) sechc,scvp
    !write(nf2,903) sechc,scvp
    mtsta0 = mtsta
    do mt=mtsta0,mroot
      if (((valpha(mt) < valpha_criterion) .or. (vresid(mt) < vresid_criterion)) .and. (abs(difeci(mt)) < venergy_criterion)) then
        if (mt == mtsta) then
          mtsta = mtsta+1
          mcroot = mcroot-1
        end if
        if (mtsta == mroot+1) then
          if (log_muliter) then
            log_convergence = .true.
            call get_eigvector(mtsta0,vcien,log_muliter)
            exit outer
          else
            if (mth_eigen < numroot) then
              call get_eigvector(mtsta0,vcien,log_muliter)
              log_convergence = .false.
              restart = .true.
            else
              log_convergence = .true.
              call get_eigvector(mtsta0,vcien,log_muliter)
              exit outer
            end if
          end if
        end if
      end if
    end do

    if (iciter > maxciiter) then
      write(u6,*) ' warning! mrci fail to converged! program stop!'
      write(u6,'(a30,1x,i3)') ' number of converged roots is=',mtsta0
      mtsta0 = mroot
      call get_eigvector(mtsta0,vcien,log_muliter)
      exit outer
    end if

    if (mtsta /= mtsta0) then
      nd = nci_dim*(mroot-mtsta0+1)
      call read_ml(lucidia,vector2,nd,2)
      ! write converged cm into file 7
      do mt=mtsta0,mtsta-1
        mtidx = indx(mt-mtsta0+1)
        call write_ml(lucivec,vector2(mtidx+1:mtidx+nci_dim),nci_dim,mt)
      end do
      nd = (mroot-mtsta0+1)*nci_dim
      vector2(1:nd) = vector1(1:nd)
      vector1(1:nd) = Zero
      mi = indx(mtsta-mtsta0+1)
      nd = (mroot-mtsta+1)*nci_dim
      do i=1,nd
        vector1(i) = vector2(i+mi)
      end do
    end if
    !write(u6,910) mtsta-1

    !*******************************************************************
    ! reset kspace

    if (kval+mcroot > max_kspace-1) then
      write(u6,911)

      nd = mroot*nci_dim
      vector1(1:nd) = Zero
      nd = (mroot-mtsta0+1)*nci_dim
      call read_ml(lucidia,vector2,nd,2)
      nda = nci_dim*mroot
      call read_ml(lucitv1,vector1,nda,1)
      !rewind(7)
      do mt=1,mtsta-1
        mtidx = indx(mt)
        call read_ml(lucivec,vector1(mtidx+1:mtidx+nci_dim),nci_dim,mt)
        !read(7) vector1(mtidx+1:mtidx+nci_dim)
      end do

      nda = nci_dim*mroot
      nd = (mroot-mtsta+1)*nci_dim
      mtidx = indx(mtsta)
      mid = indx(mtsta-mtsta0+1)
      vector1(mtidx+1:mtidx+nd) = vector2(mid+1:mid+nd)
      call write_ml(lucitv1,vector1,nda,1)
      do mt=1,mtsta-1
        vet = vcien(mt)
        mtidx = indx(mt)
        do l=1,nci_dim
          vector1(l+mtidx) = vet*vector1(l+mtidx)
        end do
      end do

      nda = mroot*nci_dim
      vector1(1:nda) = Zero
      do jiter=1,iiter
        if (jiter == 1) then
          irts = 1
        else
          irts = idxvec(jiter-1)+1
        end if
        irte = idxvec(jiter)
        nd = (irte-irts+1)*nci_dim
        call read_ml(lucitv2,vector2,nd,jiter)
        do mt=mtsta,mroot
          mtidx = indx(mt)
          do irot=irts,irte
            itidx = indx(irot-irts+1)
            vuim = vu(irot,mt)
            do l=1,nci_dim
              vector1(mtidx+l) = vector1(mtidx+l)+vuim*vector2(itidx+l)
            end do
          end do
        end do
      end do

      nda = mroot*nci_dim
      vector2(1:nda) = vector1(1:nda)
      call write_ml(lucitv2,vector2,nda,1)

      ! start new trial vector
      nda = nci_dim*mroot
      nd = nci_dim*(mroot-mtsta+1)
      mtidx = indx(mtsta)
      vector2(1:nda) = Zero
      vector2(1:nd) = vector1(mtidx+1:mtidx+nd)

      nd = (mroot-mtsta0+1)*nci_dim
      call read_ml(lucidia,vector1,nd,2)
      !rewind(nf22)
      !read(nf22) vector1(1:nd)
      do mt=mtsta,mroot
        mtidx = indx(mt-mtsta+1)
        mtid = indx(mt-mtsta0+1)
        do l=1,nci_dim
          vector1(l+mtidx) = vector1(mtid+l)
        end do
      end do

      do mt=mtsta,mroot
        mtidx = indx(mt-mtsta+1)
        venergy = vcien(mt)
        do l=1,nci_dim
          vector1(mtidx+l) = venergy*vector1(mtidx+l)-vector2(mtidx+l)
        end do
      end do

      !call read_ml(nf8,vector2,nci_dim,1)
      call read_ml(lucidia,vector2,nci_dim,1)
      do mt=mtsta,mroot
        mtidx = indx(mt-mtsta+1)
        do l=1,nci_dim
          depff = vector2(l)-vcien(mt)
          if (abs(depff) <= depc) depff = depc
          vector1(mtidx+l) = vector1(mtidx+l)/depff
        end do
      end do

      iiter = 1
      kval = mroot
      mcroot = mroot-mtsta+1
      call orthog(kval,iiter,mtsta,idxvec)

      idxvec(iiter) = kval

      mcroot = mroot-mtsta+1
      iiter = 2
      if (.not. log_muliter) then
        if (mth_eigen > 1) then
          call orthogwconvec()
        end if
      end if
      nd = (mroot-mtsta+1)*nci_dim
      call write_ml(lucitv1,vector1,nd,iiter)
      idxvec(iiter) = kval
      mn = mroot*(mroot+1)/2
      vp(1:mn) = Zero
      mn = 0
      do m=1,mroot
        mn = mn+m
        vp(mn) = vcien(m)
      end do
      irset = 1
    else

      !*****************************************************************
      ! compute revised new appoximate vector
      !
      !call read_ml(lucidia,vector2,nci_dim,1)
      !irset=1
      !do mt=mtsta,mroot
      !  mtidx = indx(mt-mtsta+1)
      !  !logic_tdav = .false.
      !  if (logic_tdav) then
      !    ! traditional davidson diagonalization method is used
      !    do l=1,nci_dim
      !      depff = vector2(l)-vcien(mt)
      !      !if (abs(depff) <= depc) depff = depc
      !      vector1(mtidx+l) = vector1(mtidx+l)/depff
      !    end do
      !  else
      !    ! generalized davidson diagonalization method is used
      !    call gdavdiag(mt,mtidx,vcien(mt))
      !  end if
      !end do

      mcroot = mroot-mtsta+1
      call orthog(kval,iiter,mtsta,idxvec)
      if (.not. log_muliter) then
        if (mth_eigen > 1) then
          call orthogwconvec()
        end if
      end if
      idxvec(iiter) = kval
      nd = (mroot-mtsta+1)*nci_dim
      call write_ml(lucitv1,vector1,nd,iiter)
    end if

    sc1 = c_time()
    scvp = sc1-sc0

    nd = nci_dim*mroot
    vector2(1:nd) = Zero
    ! start h*c

    call read_ml(lucidia,vector2,nci_dim,1)
    do mt=mtsta+1,mroot
      mtidx = indx(mt-mtsta+1)
      do l=1,nci_dim
        vector2(mtidx+l) = vector2(l)
      end do
    end do

    do mt=mtsta,mroot
      mtidx = indx(mt-mtsta+1)
      do l=1,nci_dim
        ni = mtidx+l
        vector2(ni) = vector2(ni)*vector1(ni)
      end do
    end do

    call matrix_vector_multi_parallel_drt(sechc)
    nd = nci_dim*(mroot-mtsta+1)
    call write_ml(lucitv2,vector2,nd,iiter)

  end do
  if (.not. restart) exit
end do outer
call mma_deallocate(idxvec)
call mma_deallocate(difeci)
call mma_deallocate(valpha)
call mma_deallocate(vcien)
call mma_deallocate(vcienold)
call mma_deallocate(vresid)

return

890 format(/,1x,'number of initial trial vectors is',i3,/,1x,'total wall clock time=',f9.2,' seconds')
!900 format(/,1x,'no.',i3,1x,'iter',/)
901 format(2x,'NITER',1x,'NROOT',3x,'TOTAL ENERGY',4x,'ENERGY DIFF',4x,'VALPHA',7x,'VRESIDE',1x,'T HC(s)',1x,'T KSPACE(s)')
902 format(2(2x,i3),2x,f16.9,1x,f12.9,1x,f12.8,1x,f12.8,1x,2(f8.2,1x))
!903 format(/,1x,'total wall time for h*c=',f8.2,1x,'seconds',/1x,'total wall time for k space calculation=',f8.2,1x,'seconds')
!910   format(/,1x,'number of converged roots is ',i4)
911 format(/,1x,'number of kspace exceeds maxium kspace dimension,',/,1x,'kspace is reseted ',/)
!...end of dav_diagonalize

end subroutine cidiagonalize

subroutine mrcibasis_rest(ndim,mroot,mjn,indx,vb1,vb2,vcien,mth_eigen,ncivec)
!***********************************************************************
! this subroutine is revised by suo bing. the initial trial
! vectors are calculated.
! on entry:
!-----------------------------------------------------------------------
!     ndim  - dimension of ci space
!     mroot - number of roots are calculated
!     mjn
!     indx  - index of mth vector in vb1 vector
!     vb1   - vector1
!     vb2   - vector2
!
!  on out:
!-----------------------------------------------------------------------
!     vb1   - trial vectors

use gugaci_global, only: logic_inivec_read, LuCiDia, LuCiTv1, LuCiTv2, LuCiVec, max_kspace, max_root
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndim, mroot, mjn(2*max_root), indx(max_kspace), mth_eigen, ncivec
real(kind=wp), intent(out) :: vb1(ncivec*ndim), vb2(ncivec*ndim)
real(kind=wp), intent(inout) :: vcien(mroot)
integer(kind=iwp) :: i, idx, ij, j, k, m, mjntm, nf23
real(kind=wp) :: sechc, vad, vsum

!write(u6,*) 'indx',indx(1:2*mroot)
!call read_ml(nf8,vb2,ndim,1)
call read_ml(lucidia,vb2,ndim,1)

i = mth_eigen
write(u6,'(2x,2i8,f18.8)') i,mjn(i),vb2(mjn(i)),mth_eigen

! initialize vb1-vector1 and th-vector2 to zero
vb1(1:ndim) = Zero
vb2(1:ndim) = Zero

j = mth_eigen
if (.not. logic_inivec_read) then
  ij = indx(1)
  vb1(ij+mjn(j)) = One
else
  call read_ml(nf23,vb1,ndim,j)
end if
!rewind(nf7)
do i=1,mth_eigen-1
  !read(nf7) vb2(1:ndim)
  call read_ml(lucivec,vb2,ndim,i)
  call orth_ab(ndim,vb1,vb2)
end do
call norm_a(ndim,vb1)

write(u6,'(2x,2i8,f18.8)') i,mjn(i),vb1(mjn(i))

call read_ml(lucidia,vb2,ndim,1)
!call read_ml(nf8,vb2,ndim,1)
!vcien(1) = vb2(mjn(j))
do i=1,ndim
  vb2(i) = vb1(i)*vb2(i)
end do

!write(u6,*) 'bbs debug 1'

call matrix_vector_multi_parallel_drt(sechc)
vsum = Zero
do i=1,ndim
  vsum = vsum+vb1(i)*vb2(i)
end do
vcien(1) = vsum

call write_ml(lucitv1,vb1,ndim,1)
call write_ml(lucitv2,vb2,ndim,1)

!write(u6,*) 'bbs debug 2'

vad = Zero
idx = 0
outer: do m=1,ndim
  do k=1,mth_eigen
    if (m == mjn(k)) cycle outer
  end do
  if (abs(vb2(m)) > vad) then
    vad = abs(vb2(m))
    idx = m
  end if
end do outer
mjntm = idx
!write(u6,*) 'mjn(kk)',idx,vb1(idx),vb2(idx)
!write(u6,*) 'bbs debug 3'

vb1(1:ndim) = Zero
vb2(1:ndim) = Zero

vb2(mjntm) = One
!rewind(nf7)
do i=1,mth_eigen-1
  !read(nf7) vb1(1:ndim)
  call read_ml(lucivec,vb1,ndim,i)
  call orth_ab(ndim,vb2,vb1)
end do
call read_ml(lucitv1,vb1,ndim,1)
call orth_ab(ndim,vb2,vb1)
call norm_a(ndim,vb2)
vb1(1:ndim) = vb2(1:ndim)

!write(u6,*) 'bbs debug 4'
call read_ml(lucidia,vb2,ndim,1)
!call read_ml(nf8,vb2,ndim,1)
do i=1,ndim
  vb2(i) = vb1(i)*vb2(i)
end do
!write(u6,*) 'bbs debug 5'

call matrix_vector_multi_parallel_drt(sechc)
call write_ml(lucitv1,vb1,ndim,2)
call write_ml(lucitv2,vb2,ndim,2)
!write(u6,*) ' initial vector 5'
!call abend()
!write(u6,*) 'bbs debug 6'

return
!...end of mrcibasis_rest

end subroutine mrcibasis_rest

subroutine mrcibasis(ndim,mroot,mjn,indx,vb1,vb2,vcien,mth_eigen,ncivec)
!***********************************************************************
! this subroutine is revised by suo bing. the initial trial
! vectors are calculated.
! on entry:
!-----------------------------------------------------------------------
!     ndim  - dimension of ci space
!     mroot - number of roots are calculated
!     mjn
!     indx  - index of mth vector in vb1 vector
!     vb1   - vector1
!     vb2   - vector2
!     mth_eigen - 0 or 1
!  on out:
!-----------------------------------------------------------------------
!     vb1   - trial vectors

use gugaci_global, only: logic_inivec_read, LuCiDia, LuCiTv1, LuCiTv2, max_kspace, max_root !, logic_tdav
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndim, mjn(2*max_root), mth_eigen, ncivec
integer(kind=iwp), intent(out) :: indx(max_kspace)
integer(kind=iwp), intent(inout) :: mroot
real(kind=wp), intent(out) :: vb1(ncivec*ndim), vb2(ncivec*ndim), vcien(mroot)
integer(kind=iwp) :: i, idx, ij, im, indx0, j, jdx, k, kk, l, m, nf23, numdim
real(kind=wp) :: sechc, vad, vsum
integer(kind=iwp), allocatable :: mjntmp(:)
real(kind=wp), allocatable :: vdia(:), vdiatmp(:)

call read_ml(lucidia,vb2,ndim,1)

!call read_ml(nf8,vb2,ndim,1)
indx(1:max_kspace) = 0
indx0 = 0
call mma_allocate(vdia,2*mroot,label='vdia')
do i=1,mroot
  indx(i) = indx0
  indx0 = indx0+ndim
  vdia(i) = vb2(mjn(i))
end do

do i=1,mroot
  write(u6,'(2x,2i8,f18.8)') i,mjn(i),vb2(mjn(i))
end do
call mma_allocate(mjntmp,2*mroot,label='mjntmp')
mjntmp(1:mroot) = mjn(1:mroot)

! initialize vb1-vector1 and th-vector2 to zero
if (mth_eigen == 0) then
  if (logic_inivec_read) then
    numdim = ndim*mroot
    do m=1,numdim
      vb1(m) = Zero
      vb2(m) = Zero
    end do
    call read_ml(nf23,vb1,numdim,1)
  else
    numdim = ndim*mroot
    vb1(1:numdim) = Zero
    vb2(1:numdim) = Zero
    do j=1,mroot
      ij = indx(j)
      vb1(ij+mjn(j)) = One
      vb2(ij+mjn(j)) = vdia(j)
      vcien(j) = vdia(j)
    end do
  end if
else
  if (logic_inivec_read) then
    vb1(1:ndim) = Zero
    vb2(1:ndim) = Zero
    call read_ml(nf23,vb1(1),ndim,mth_eigen)
  else
    vb1(1:ndim) = Zero
    vb2(1:ndim) = Zero
    j = mth_eigen
    ij = indx(1)
    vb1(ij+mjn(j)) = One
    vb2(ij+mjn(j)) = vdia(j)
    vcien(1) = vdia(j)
    mroot = 1
  end if
end if

!write(u6,*) ' initial basis vector 0',nf23

if (logic_inivec_read) then
  call read_ml(lucidia,vb2,ndim,1)
  !call read_ml(nf8,vb2,ndim,1)
  if (mth_eigen == 0) then
    do j=2,mroot
      idx = indx(j)
      do k=idx+1,idx+ndim
        vb2(k) = vb1(k)*vb2(k-idx)
      end do
    end do
    do k=1,ndim
      vb2(k) = vb1(k)*vb2(k)
    end do
  else
    do k=1,ndim
      vb2(k) = vb1(k)*vb2(k)
    end do
  end if
  !do i=1,100
  !  write(u6,'(2(f18.9,1x))') vb1(i),vb2(i)
  !end do
  !call abend()

  call matrix_vector_multi_parallel_drt(sechc)

  if (mth_eigen == 0) then
    do j=1,mroot
      vsum = Zero
      idx = indx(j)
      do k=idx+1,idx+ndim
        vsum = vsum+vb1(k)*vb2(k)
      end do
      vcien(j) = vsum
      write(u6,*) 'vcien(j)',vsum
    end do
  else
    vsum = Zero
    do k=1,ndim
      vsum = vsum+vb1(k)*vb2(k)
    end do
    vcien(1) = vsum
  end if
else
  call matrix_vector_multi_v(sechc)
end if
! write vector1 and vector2 to fort3 and fort4
call write_ml(lucitv1,vb1,ndim*mroot,1)
call write_ml(lucitv2,vb2,ndim*mroot,1)

call read_ml(lucidia,vb1,ndim,1)
!call read_ml(nf8,vb1,ndim,1)
call mma_allocate(vdiatmp,2*mroot,label='vdiatmp')
if (mth_eigen == 0) then
  do kk=mroot+1,2*mroot
    ij = indx(kk-mroot)
    vad = Zero
    idx = 0
    outer1: do m=1,ndim
      do l=1,kk-1
        if (m == mjntmp(l)) cycle outer1
      end do
      if (abs(vb2(m+ij)) > vad) then
        vad = abs(vb2(m+ij))
        idx = m
      end if
    end do outer1
    mjntmp(kk) = idx
    vdiatmp(kk) = vb1(idx)
    write(u6,*) 'mjn(kk)',idx,vb1(idx+ij),vb2(idx+ij)
  end do
else
  kk = 2
  ij = indx(kk-mroot)
  vad = Zero
  idx = 0
  l = mth_eigen
  outer2: do m=1,ndim
    do k=1,mth_eigen
      if (m == mjn(k)) cycle outer2
    end do
    if (abs(vb2(m)) > vad) then
      vad = abs(vb2(m))
      idx = m
    end if
  end do outer2
  mjntmp(kk) = idx
  vdiatmp(kk) = vb1(idx)
  write(u6,*) 'mjn(kk)',idx,vb1(idx),vb2(idx)
end if

numdim = ndim*mroot
vb1(1:numdim) = Zero
vb2(1:numdim) = Zero
!write(u6,*) ' initial vector 3',vdia(2),mroot
call mma_deallocate(vdia)

if (mth_eigen == 0) then
  do m=mroot+1,2*mroot
    im = indx(m-mroot)
    vb1(im+mjntmp(m)) = One
    vb2(im+mjntmp(m)) = vdiatmp(m)
  end do

  if (logic_inivec_read) then
    call read_ml(lucitv1,vb2,numdim,1)
    do i=mroot+1,2*mroot
      idx = indx(i-mroot)+1
      do j=1,mroot
        jdx = indx(j)+1
        call orth_ab(ndim,vb1(idx),vb2(jdx))
      end do
      do j=mroot+1,i-1
        jdx = indx(j-mroot)+1
        call orth_ab(ndim,vb1(idx),vb1(jdx))
      end do
      call norm_a(ndim,vb1(idx))
    end do
  end if
else
  vb1(mjntmp(2)) = One
  vb2(mjntmp(2)) = vdiatmp(2)

  if (logic_inivec_read) then
    call read_ml(lucitv1,vb2,ndim,mth_eigen)
    call orth_ab(ndim,vb1,vb2)
    call norm_a(ndim,vb1)
  end if
end if
call mma_deallocate(mjntmp)
call mma_deallocate(vdiatmp)

if (logic_inivec_read) then
  call read_ml(lucidia,vb2,ndim,1)

  !call read_ml(nf8,vb2,ndim,1)
  if (mth_eigen == 0) then
    do j=2,mroot
      idx = indx(j)
      do k=idx+1,idx+ndim
        vb2(k) = vb1(k)*vb2(k-idx)
      end do
    end do
    do k=1,ndim
      vb2(k) = vb1(k)*vb2(k)
    end do
  else
    do k=1,ndim
      vb2(k) = vb1(k)*vb2(k)
    end do
  end if

  !do i=1,100
  !  write(u6,'(2(f18.9,1x))') vb1(i),vb2(i)
  !end do
  !call abend()

  call matrix_vector_multi_parallel_drt(sechc)
else
  call matrix_vector_multi_parallel_drt(sechc)
end if

call write_ml(lucitv1,vb1,ndim*mroot,2)
call write_ml(lucitv2,vb2,ndim*mroot,2)

return
!...end of mrcibasis

end subroutine mrcibasis

!subroutine mrcibasis_init(ndim,mroot,mjn,indx,vb1,vb2,vcien,mth_eigen,ncivec)
!!***********************************************************************
!! this subroutine is revised by suo bing. the initial trial
!! vectors are calculated.
!! on entry:
!!-----------------------------------------------------------------------
!!     ndim  - dimension of ci space
!!     mroot - number of roots are calculated
!!     mjn
!!     indx  - index of mth vector in vb1 vector
!!     vb1   - vector1
!!     vb2   - vector2
!!     mth_eigen - 0 or 1
!!  on out:
!!-----------------------------------------------------------------------
!!     vb1   - trial vectors
!
!use gugaci_global, only: LuCiDia, LuCiTv1, LuCiTv2, max_kspace, max_root
!use stdalloc, only: mma_allocate, mma_deallocate
!use Constants, only: Zero, One
!use Definitions, only: wp, iwp, u6
!
!implicit none
!integer(kind=iwp), intent(in) :: ndim, mjn(2*max_root), mth_eigen, ncivec
!integer(kind=iwp), intent(inout) :: mroot
!integer(kind=iwp), intent(out) :: indx(max_kspace)
!real(kind=wp), intent(out) :: vb1(ncivec*ndim), vb2(ncivec*ndim), vcien(mroot)
!integer(kind=iwp) :: i, ij, indx0, ioff, j, kk, m, n, numdim
!real(kind=wp) :: fenmu, sechc, vadi
!real(kind=wp), allocatable :: diagelement(:), vdia(:)
!real(kind=wp), parameter :: epc = 5.0e-3_wp
!
!call mma_allocate(diagelement,ndim,label='diagelement')
!
!call read_ml(lucidia,diagelement,ndim,1)
!
!!call read_ml(nf8,vb2,ndim,1)
!indx(1:max_kspace) = 0
!indx0 = 0
!call mma_allocate(vdia,2*mroot,label='vdia')
!do i=1,mroot
!  indx(i) = indx0
!  indx0 = indx0+ndim
!  vdia(i) = diagelement(mjn(i))
!end do
!
!do i=1,mroot
!  write(u6,'(2x,2i8,f18.8)') i,mjn(i),diagelement(mjn(i))
!end do
!
!! initialize vb1-vector1 and th-vector2 to zero
!if (mth_eigen == 0) then
!  numdim = ndim*mroot
!  vb1(1:numdim) = Zero
!  vb2(1:numdim) = Zero
!  do j=1,mroot
!    ij = indx(j)
!    vb1(ij+mjn(j)) = One
!    vb2(ij+mjn(j)) = vdia(j)
!    vcien(j) = vdia(j)
!  end do
!else
!  vb1(1:ndim) = Zero
!  vb2(1:ndim) = Zero
!  j = mth_eigen
!  vb1(mjn(j)) = One
!  vb2(mjn(j)) = vdia(j)
!  vcien(1) = vdia(j)
!  mroot = 1
!end if
!call mma_deallocate(vdia)
!
!!write(u6,*) ' initial basis vector 0',nf23
!call matrix_vector_multi_parallel_drt(sechc)
!! write vector1 and vector2 to fort3 and fort4
!call write_ml(lucitv1,vb1,ndim*mroot,1)
!call write_ml(lucitv2,vb2,ndim*mroot,1)
!
!! init second vector
!!call read_ml(nf8,vb1,ndim,1)
!if (mth_eigen == 0) then
!  vb1(1:ndim*mroot) = Zero
!  do kk=1,mroot
!    ioff = indx(kk)
!    ij = mjn(kk)
!    vadi = diagelement(ij)
!    do m=1,ij-1
!      fenmu = vadi-diagelement(m)
!      if (abs(fenmu) < epc) fenmu = epc
!      vb1(ioff+m) = vb2(ioff+m)/fenmu
!      !write(u6,'(i8,2f18.8)') m,vb2(ioff+m),fenmu
!    end do
!    do m=ij+1,ndim
!      fenmu = vadi-diagelement(m)
!      if (abs(fenmu) < epc) fenmu = epc
!      vb1(ioff+m) = vb2(ioff+m)/fenmu
!      !write(u6,'(i8,2f18.8)') m,vb2(ioff+m),fenmu
!    end do
!  end do
!
!  call read_ml(lucitv1,vb2,ndim*mroot,1)
!  do m=1,mroot
!    ! orth with vb1
!    do n=1,mroot
!      call orth_ab(ndim,vb1(indx(m)+1),vb2(indx(n)+1))
!    end do
!    ! orth with previous vector
!    do n=1,m-1
!      call orth_ab(ndim,vb1(indx(m)+1),vb1(indx(n)+1))
!    end do
!    call norm_a(ndim,vb1(indx(m)+1))
!  end do
!
!  !write(u6,*)
!  !do m=1,ndim
!  !  write(u6,'(2x,i5,f18.8)') m,vb1(m)
!  !end do
!  !call abend()
!else
!  call abend()
!end if
!
!numdim = ndim*mroot
!vb2(1:numdim) = Zero
!do m=1,mroot
!  kk = indx(m)
!  do i=1,ndim
!    vb2(i+kk) = vb1(i+kk)*diagelement(i)
!  end do
!end do
!
!call matrix_vector_multi_parallel_drt(sechc)
!call write_ml(lucitv1,vb1,ndim*mroot,2)
!call write_ml(lucitv2,vb2,ndim*mroot,2)
!
!call mma_deallocate(diagelement)
!
!return
!!...end of mrcibasis_init
!
!end subroutine mrcibasis_init

subroutine get_eigvector(mtsta0,vcien,log_muliter)

use gugaci_global, only: cm_cri, ecih0, irfno, logic_mr, LuCiDia, LuCiVec, max_root, mroot, mth_eigen, nci_dim, ndim_h0, vector1, &
                         vector2
#ifdef _XIANEST_
use control, only: toptask
#endif
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: mtsta0
real(kind=wp), intent(in) :: vcien(max_root)
logical(kind=iwp), intent(in) :: log_muliter
integer(kind=iwp) :: i, j, jr, mt, nc, nd
real(kind=wp) :: de, dedav1, vcof
real(kind=wp), allocatable :: dav1(:), vcml(:) !, dav2(:), dav3(:), remei(:)

vector1(:) = Zero
nd = nci_dim*(mroot-mtsta0+1)
call read_ml(lucidia,vector2,nd,2)
if (log_muliter) then
  nc = 1
  do i=1,mtsta0-1
    !mtidx = indx(i)
    call read_ml(lucivec,vector1(nc:nc+nci_dim-1),nci_dim,i)
    nc = nc+nci_dim
  end do
  vector1(nc:nc+nd-1) = vector2(1:nd)

  ! write eigenvector into fort7
  nc = 1
  do i=1,mroot
    call write_ml(lucivec,vector1(nc:nc+nci_dim-1),nci_dim,i)
    nc = nc+nci_dim
  end do
  !write(u6,*) 'xxx cof'
  !write(u6,*) vector1(nci_dim+1:nci_dim+5)
  !call abend()
else
  call write_ml(lucivec,vector2,nci_dim,mth_eigen)
end if
!rewind(nf7)

call memcidiag_alloc()
call mma_allocate(dav1,max_root,label='dav1')
call mma_allocate(vcml,max_root,label='vcml')
!call mma_allocate(dav2,max_root,label='dav2')
!call mma_allocate(dav3,max_root,label='dav3')
!call mma_allocate(remei,max_root,label='remei')
do mt=1,mroot
  !*********************************************************************
  ! do davidson correction

  !if (.not. log_muliter) then
  call read_ml(lucivec,vector1,nci_dim,mt)
  !end if
  !mtidx = indx(mt)
  vcml(mt) = Zero
  do j=1,ndim_h0
    jr = j
    if (logic_mr) jr = irfno(j)
    vcml(mt) = vcml(mt)+vector1(jr)*vector1(jr)
  end do
  if (log_muliter) then
    de = ecih0(mt)-vcien(mt)
  else
    de = ecih0(mth_eigen)-vcien(mt)
  end if

  dedav1 = (One-vcml(mt))*de
  !dedav2=dedav1/(vcml(mt))
  !dedav3=dedav1/(2*vcml(mt)-1)
  !demei=dedav2*(n_electron*(n_electron-5)+6)/(n_electron*(n_electron-1))
  !demei=dedav2*(n_electron*(n_electron-5)+6)/(n_electron*(n_electron-1))
  dav1(mt) = vcien(mt)-dedav1
  !dav2(mt) = vcien(mt)-dedav2
  !dav3(mt) = vcien(mt)-dedav3
  !remei(mt) = vcien(mt)-demei

  write(u6,900)
  !write(u6,901) mt,vcien(mt),dav1(mt),dav2(mt),dav3(mt),remei(mt)
  !write(nf2,901) mt,vcien(mt),dav1(mt),dav2(mt),dav3(mt),remei(mt)
  write(u6,901) mt,vcien(mt),dav1(mt),vcml(mt)
  !read(nf7) vector2(1:nci_dim)
  write(u6,810) mt
  !mtidx = indx(mt)
  do i=1,nci_dim
    vcof = vector1(i)
    if (abs(vcof) > cm_cri) then
      call found_a_config(i,vcof,2)
    end if
  end do
end do
call memcidiag_dealloc()
!call mma_deallocate(dev2)
!call mma_deallocate(dev3)
!call mma_deallocate(remei)

if (log_muliter) then
  write(u6,800)
  write(u6,900)
  do mt=1,mroot
    write(u6,901) mt,vcien(mt),dav1(mt),vcml(mt)
  end do
end if

#ifdef MOLPRO
if (toptask%task(8) == 1) then
  write(u6,*)
  write(u6,*) '++++++++  DATA CHECK +++++++++++++++++++++++++++++'
  call checkdata('r',mroot,8,0,vcien,'MRCI','ECI')
  call checkdata('r',mroot,8,0,dav1,'MRCI','ECI_DAV')
  write(u6,*) '++++++++++ END DATA CHECK ++++++++++++++++++++++++'
  write(u6,*)
end if
#else
call add_info('ECI',vcien,mroot,8)
call add_info('ECI_DAV',dav1,mroot,8)
#endif
call mma_deallocate(dav1)
call mma_deallocate(vcml)

return

800 format(/,1x,'mrsdci calculation converged')
810 format(/,1x,'the main references for root ',i3,/)
900 format(/1x,'nroot',6x,'ci energy',10x,'dav energy',8x,'coef')
901 format(1x,i3,2x,2(1x,f18.9),3x,f8.6)
!...end of get_eigvector

end subroutine get_eigvector

subroutine matrix_vector_multi_v(sechc)

use gugaci_global, only: log_prod, vint_ci
use Definitions, only: wp

implicit none
real(kind=wp), intent(out) :: sechc
real(kind=wp) :: sc1, sc2
real(kind=wp), external :: c_time

sc1 = c_time()
log_prod = 1
call readint(1,vint_ci)
call inner_space_loop()

call readint(2,vint_ci)
call dv_drt_ci_new()
call vd_drt_ci_new()

call readint(3,vint_ci)
call sv_drt_ci_new()
call tv_drt_ci_new()
sc2 = c_time()
sechc = sc2-sc1

return

end subroutine matrix_vector_multi_v

!subroutine matrix_vector_multi_d(sechc)
!
!use gugaci_global, only: log_prod, vint_ci
!use Definitions, only: wp
!
!implicit none
!real(kind=wp), intent(out) :: sechc
!real(kind=wp) :: sc1, sc2
!real(kind=wp), external :: c_time
!
!log_prod = 1
!sc1 = c_time()
!
!call readint(1,vint_ci)
!call inner_space_loop()
!
!call readint(2,vint_ci)
!call sd_drt_ci_new()
!call td_drt_ci_new()
!call ds_drt_ci_new()
!call dt_drt_ci_new()
!call dv_drt_ci_new()
!call vd_drt_ci_new()
!
!call readint(3,vint_ci)
!call dd_drt_ci_new()
!
!call readint(4,vint_ci)
!call ext_space_loop()
!
!sc2 = c_time()
!sechc = sc2-sc1
!
!return
!
!end subroutine matrix_vector_multi_d

subroutine matrix_vector_multi_parallel_drt(sechc)

use gugaci_global, only: log_prod, vint_ci
use Definitions, only: wp

implicit none
real(kind=wp), intent(out) :: sechc
real(kind=wp) :: sc1, sc2
real(kind=wp), external :: c_time

log_prod = 1
sc1 = c_time()

call readint(1,vint_ci)
call inner_space_loop()

call readint(2,vint_ci)
call sd_drt_ci_new()
call td_drt_ci_new()
call ds_drt_ci_new()
call dt_drt_ci_new()
call vd_drt_ci_new()
call dv_drt_ci_new()

call readint(3,vint_ci)
call dd_drt_ci_new()
call sv_drt_ci_new()
call tv_drt_ci_new()
call ss_drt_ci_new()
call st_drt_ci_new()
call tt_drt_ci_new()
call ts_drt_ci_new()

call readint(4,vint_ci)
call ext_space_loop()

sc2 = c_time()
sechc = sc2-sc1

return

end subroutine matrix_vector_multi_parallel_drt

!subroutine matrix_vector_multi_parallel_prt(sc3)
!
!use gugaci_global, only: log_prod, vector2, vint_ci
!use Constants, only: Zero
!use Definitions, only: wp, iwp, u6
!
!implicit none
!real(kind=wp), intent(out) :: sc3
!integer(kind=iwp) :: mtest
!real(kind=wp) :: sc1, sc2
!real(kind=wp), external :: c_time
!
!!write(u6,*) 'error stop'
!!call abend()
!sc1 = c_time()
!
!mtest = 1482
!log_prod = 1
!
!call readint(1,vint_ci)
!call inner_space_loop()
!write(u6,*) ' inner',vector2(mtest)
!
!call readint(2,vint_ci)
!call sd_drt_ci_new()
!write(u6,*) ' sd',vector2(mtest)
!call td_drt_ci_new()
!write(u6,*) ' td',vector2(mtest)
!call ds_drt_ci_new()
!write(u6,*) ' ds',vector2(mtest)
!call dt_drt_ci_new()
!write(u6,*) ' dt',vector2(mtest)
!call vd_drt_ci_new()
!write(u6,*) ' vd',vector2(mtest)
!call dv_drt_ci_new()
!write(u6,*) ' dv',vector2(mtest)
!
!call readint(3,vint_ci)
!call dd_drt_ci_new()
!write(u6,*) ' dd',vector2(mtest)
!call sv_drt_ci_new()
!write(u6,*) ' sv',vector2(mtest)
!call tv_drt_ci_new()
!write(u6,*) ' tv',vector2(mtest)
!call ss_drt_ci_new()
!write(u6,*) ' ss',vector2(mtest)
!call st_drt_ci_new()
!write(u6,*) ' st',vector2(mtest)
!call tt_drt_ci_new()
!write(u6,*) ' tt',vector2(mtest)
!call ts_drt_ci_new()
!write(u6,*) ' ts',vector2(mtest)
!
!call readint(4,vint_ci)
!call ext_space_loop()
!write(u6,*) ' exter',vector2(mtest)
!
!sc2 = c_time()
!write(u6,*) '  end this matrix_vector_multi_parallel_drt, takes',sc2-sc1,'s'
!sc3 = sc2-sc1
!
!end subroutine matrix_vector_multi_parallel_prt

subroutine orthog(kval,iiter,msta,idxvec)
!***********************************************************************
! on entry:
!   kval - dimension of current k space
! on out:
!   kval - dimension of new k space
!   iiter - iiter+1

use gugaci_global, only: indx, LuCiTv1, max_iter, mroot, nci_dim, vector1, vector2
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(inout) :: kval, iiter
integer(kind=iwp), intent(in) :: msta, idxvec(max_iter)
integer(kind=iwp) :: jiter, jren, jrst, l, mt, mtidx, nd, nt, ntidx
real(kind=wp) :: vsum

do jiter=1,iiter
  if (jiter == 1) then
    jrst = 1
  else
    jrst = idxvec(jiter-1)+1
  end if
  jren = idxvec(jiter)
  nd = (jren-jrst+1)*nci_dim
  call read_ml(lucitv1,vector2,nd,jiter)
  do mt=msta,mroot
    mtidx = indx(mt-msta+1)
    do nt=jrst,jren
      ntidx = indx(nt-jrst+1)
      vsum = Zero
      do l=1,nci_dim
        vsum = vsum+vector1(mtidx+l)*vector2(ntidx+l)
      end do
      do l=1,nci_dim
        vector1(mtidx+l) = vector1(mtidx+l)-vsum*vector2(ntidx+l)
      end do
    end do
  end do
end do

! normalization of vector msta
vsum = Zero
call norm_a(nci_dim,vector1)
kval = kval+1

do mt=msta+1,mroot
  mtidx = indx(mt-msta+1)
  do nt=msta,mt
    ntidx = indx(nt-msta+1)
    vsum = Zero
    do l=1,nci_dim
      vsum = vsum+vector1(mtidx+l)*vector1(ntidx+l)
    end do
    do l=1,nci_dim
      vector1(mtidx+l) = vector1(mtidx+l)-vsum*vector1(ntidx+l)
    end do
  end do
  call norm_a(nci_dim,vector1(mtidx+1:mtidx+nci_dim))
  kval = kval+1
end do

iiter = iiter+1

return
!...end of orthog

end subroutine orthog

!subroutine orthogonalization(j,n,m,ir)
!
!use gugaci_global, only: LuCiTv1, LuCiVec, mth_eigen, nci_dim, vector1, vector2
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: j, n, m
!integer(kind=iwp), intent(out) :: ir
!integer(kind=iwp) :: i, l
!real(kind=wp) :: vsmax1, vsmax2, vsumtmp
!real(kind=wp), parameter :: vortho_criterion = 1.0e-8_wp
!
!ir = 1
!vsmax2 = 1.0e10_wp
!do while (j > 1)
!  vsmax1 = Zero
!  do i=1,j-1
!    vsumtmp = Zero
!    call read_ml(lucitv1,vector2,n,i)
!
!    do l=1,n
!      vsumtmp = vsumtmp+vector1(l)*vector2(l)
!    end do
!    do l=1,n
!      vector1(l) = vector1(l)-vsumtmp*vector2(l)
!    end do
!    vsmax1 = max(vsmax1,abs(vsumtmp))
!  end do
!  if (vsmax1 < vortho_criterion) exit
!  if (vsmax1 > vsmax2) then
!    ir = -1
!    return
!  end if
!  vsmax2 = vsmax1
!end do
!
!vsumtmp = Zero
!do l=1,n
!  vsumtmp = vsumtmp+vector1(l)*vector1(l)
!end do
!
!do m=1,mth_eigen-1
!  !call read_ml(nf7,vector2,nci_dim,m)
!  call read_ml(lucivec,vector2,nci_dim,m)
!  call orth_ab(nci_dim,vector1,vector2)
!end do
!call norm_a(nci_dim,vector1)
!!vsumtmp = One/sqrt(vsumtmp)
!!do l=1,n
!!  vector1(l) = vector1(l)*vsumtmp
!!end do
!
!call write_ml(lucitv1,vector1,n,j)
!
!end subroutine orthogonalization

!subroutine compute_vp_matrix(j,n) !nf3
!
!use gugaci_global, only: LuCiTv1, vector1, vector2, vp
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: j, n
!integer(kind=iwp) :: i, ij, l
!real(kind=wp) :: vsumtmp
!
!ij = j*(j-1)/2
!vsumtmp = Zero
!do l=1,n
!  vsumtmp = vsumtmp+vector1(l)*vector2(l)
!end do
!vp(ij+j) = vsumtmp
!!rewind(nf3)
!do i=1,j-1
!  call read_ml(lucitv1,vector1,n,i)
!
!  vsumtmp = Zero
!  do l=1,n
!    vsumtmp = vsumtmp+vector1(l)*vector2(l)
!  end do
!  vp(ij+i) = vsumtmp
!end do
!call read_ml(lucitv1,vector1,n,i)
!
!end subroutine compute_vp_matrix

subroutine compute_residual_vector_mroot(mtsta,iiter,idxvec,vresid,vcien)
!***********************************************************************
! 2 mar 2007 - revised
! calculate residual vector
!      e|ck>-h|ck>
!      |ck>=\sigma(vu(i,m)*vector_i),i=1,j

use gugaci_global, only: indx, LuCiDia, LuCiTv1, LuCiTv2, max_kspace, max_root, mroot, nci_dim, vector1, vector2, vu
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mtsta, iiter, idxvec(max_kspace)
real(kind=wp), intent(inout) :: vresid(max_root)
real(kind=wp), intent(in) :: vcien(max_root)
integer(kind=iwp) :: i, ij, irot, irte, irts, itidx, jiter, l, mt, mtidx, nd
real(kind=wp) :: depc, depcc, vtmp, vuim
real(kind=wp), allocatable :: diagelement(:)

depc = 1.0e-3_wp
nd = nci_dim*(mroot-mtsta+1)
vector1(1:nd) = Zero

do jiter=1,iiter
  if (jiter == 1) then
    irts = 1
  else
    irts = idxvec(jiter-1)+1
  end if
  irte = idxvec(jiter)
  nd = (irte-irts+1)*nci_dim
  call read_ml(lucitv1,vector2,nd,jiter)
  do mt=mtsta,mroot
    mtidx = indx(mt-mtsta+1)
    do irot=irts,irte
      vuim = vu(irot,mt)
      itidx = indx(irot-irts+1)
      do l=1,nci_dim
        vector1(mtidx+l) = vector1(mtidx+l)+vuim*vector2(itidx+l)
      end do
    end do
  end do
end do

! present ci vector, second record in lucidia
nd = nci_dim*(mroot-mtsta+1)
call write_ml(lucidia,vector1,nd,2)

do mt=mtsta,mroot
  mtidx = indx(mt-mtsta+1)
  !venergy = vcien(mt)
  do l=1,nci_dim
    !vector1(mtidx+l) = venergy*vector1(mtidx+l)
    vector1(mtidx+l) = Zero
  end do
end do

do jiter=1,iiter
  if (jiter == 1) then
    irts = 1
  else
    irts = idxvec(jiter-1)+1
  end if
  irte = idxvec(jiter)
  nd = (irte-irts+1)*nci_dim
  call read_ml(lucitv2,vector2,nd,jiter)
  do mt=mtsta,mroot
    mtidx = indx(mt-mtsta+1)
    do irot=irts,irte
      itidx = indx(irot-irts+1)
      vuim = vu(irot,mt)
      do l=1,nci_dim
        vector1(mtidx+l) = vector1(mtidx+l)+vuim*vector2(itidx+l)
      end do
    end do
  end do
end do

call mma_allocate(diagelement,nci_dim,label='diagelement')
call read_ml(lucidia,diagelement,nci_dim,1)
call read_ml(lucidia,vector2,nd,2)

! new approximation vector
ij = 0
do mt=mtsta,mroot
  mtidx = indx(mt-mtsta+1)
  vtmp = Zero
  do i=1,nci_dim
    depcc = vcien(mt)-diagelement(i)
    if (abs(depcc) < depc) depcc = depc
    vector1(mtidx+i) = (vector1(mtidx+i)-vector2(ij+i)*vcien(mt))/depcc
    vtmp = vtmp+vector1(ij+i)*vector1(ij+i)
  end do
  vresid(mt) = vtmp
  ij = ij+nci_dim
end do

call mma_deallocate(diagelement)

return
!...end of compute_residule_vector

end subroutine compute_residual_vector_mroot

!subroutine compute_residual_vector(mtsta,iiter,idxvec,vresid,vcien)
!!***********************************************************************
!! 2 mar 2007 - revised
!! calculate residual vector
!!      e|ck>-h|ck>
!!      |ck>=\sigma(vu(i,m)*vector_i),i=1,j
!
!use gugaci_global, only: indx, LuCiDia, LuCiTv1, LuCiTv2, max_kspace, max_root, mroot, nci_dim, vector1, vector2, vu
!use Constants, only: Zero
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: mtsta, iiter, idxvec(max_kspace)
!real(kind=wp), intent(inout) :: vresid(max_root)
!real(kind=wp), intent(in) :: vcien(max_root)
!integer(kind=iwp) :: irot, irte, irts, itidx, jiter, l, li, mt, mtidx, nd
!real(kind=wp) :: venergy, vtmp, vuim
!
!nd = nci_dim*(mroot-mtsta+1)
!vector1(1:nd) = Zero
!
!do jiter=1,iiter
!  if (jiter == 1) then
!    irts = 1
!  else
!    irts = idxvec(jiter-1)+1
!  end if
!  irte = idxvec(jiter)
!  nd = (irte-irts+1)*nci_dim
!  call read_ml(lucitv1,vector2,nd,jiter)
!  do mt=mtsta,mroot
!    mtidx = indx(mt-mtsta+1)
!    do irot=irts,irte
!      vuim = vu(irot,mt)
!      itidx = indx(irot-irts+1)
!      do l=1,nci_dim
!        vector1(mtidx+l) = vector1(mtidx+l)+vuim*vector2(itidx+l)
!      end do
!    end do
!  end do
!end do
!
!nd = nci_dim*(mroot-mtsta+1)
!call write_ml(lucidia,vector1,nd,2)
!
!do mt=mtsta,mroot
!  mtidx = indx(mt-mtsta+1)
!  venergy = vcien(mt)
!  do l=1,nci_dim
!    vector1(mtidx+l) = venergy*vector1(mtidx+l)
!  end do
!end do
!
!do jiter=1,iiter
!  if (jiter == 1) then
!    irts = 1
!  else
!    irts = idxvec(jiter-1)+1
!  end if
!  irte = idxvec(jiter)
!  nd = (irte-irts+1)*nci_dim
!  call read_ml(lucitv2,vector2,nd,jiter)
!  do mt=mtsta,mroot
!    mtidx = indx(mt-mtsta+1)
!    do irot=irts,irte
!      itidx = indx(irot-irts+1)
!      vuim = vu(irot,mt)
!      do l=1,nci_dim
!        vector1(mtidx+l) = vector1(mtidx+l)-vuim*vector2(itidx+l)
!      end do
!    end do
!  end do
!end do
!
!do mt=mtsta,mroot
!  mtidx = indx(mt-mtsta+1)
!  vtmp = Zero
!  do l=1,nci_dim
!    li = l+mtidx
!    vtmp = vtmp+vector1(li)*vector1(li)
!  end do
!  vresid(mt) = vtmp
!end do
!
!return
!!...end of compute_residule_vector
!
!end subroutine compute_residual_vector

!subroutine read_ref_state(nf)
!
!use gugaci_global, only: iref_occ, n_ref, norb_act, norb_dz, norb_inn
!use Definitions, only: iwp, u6
!
!implicit none
!integer(kind=iwp), intent(in) :: nf
!integer(kind=iwp) :: i, j
!character(len=32) :: refstring
!
!do i=1,n_ref
!  do j=1,norb_dz
!    iref_occ(j,i) = 2
!  end do
!  read(nf,*) refstring(1:norb_act)
!  do j=1,norb_act
!    if (refstring(j:j) == '0') iref_occ(j+norb_dz,i) = 0
!    if (refstring(j:j) == '1') iref_occ(j+norb_dz,i) = 1
!    if (refstring(j:j) == '2') iref_occ(j+norb_dz,i) = 2
!  end do
!end do
!
!write(u6,*) '    multireference mode'
!write(u6,*) '    the reference states are:'
!do i=1,n_ref
!  write(u6,'(12x,60(i1))') (iref_occ(j,i),j=1,norb_inn)
!end do
!
!end subroutine read_ref_state

!function maxind(m,vector)
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp) :: maxind
!integer(kind=iwp), intent(in) :: m
!real(kind=wp), intent(in) :: vector(m)
!integer(kind=iwp) :: j, l
!real(kind=wp) :: am
!
!l = 1
!am = abs(vector(l))
!do j=1,m
!  if (abs(vector(j)) > am) then
!    l = j
!    am = abs(vector(j))
!  end if
!end do
!
!maxind = l
!
!end function maxind

subroutine matrmkmul(mtsta,iiter,idxvec,irset)
!***********************************************************************
! 27 feb 2007 - written by suo bing
! construct p matrix in b and h*b space
! on entry:
!   msta - start index of b space
!   mend - end index of b space
!   iiter - ith iteration

use gugaci_global, only: indx, LuCiTv1, LuCiTv2, max_iter, mroot, nci_dim, vector1, vector2, vp
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: mtsta, iiter, idxvec(max_iter), irset
integer(kind=iwp) :: i, iidx, iit, ij, irot, jend, jidx, jre, jrot, jrs, l, mend, msta, nd, nroot
real(kind=wp) :: valsum, vsum

if ((iiter == 2) .and. (irset == 0)) then
  nroot = mroot-mtsta+1
  ! the first iteration
  call read_ml(lucitv1,vector1,nci_dim*mroot,1)
  call read_ml(lucitv2,vector2,nci_dim*mroot,1)
  do irot=1,mroot+nroot
    if (irot == mroot+1) then
      call read_ml(lucitv1,vector1,nci_dim*mroot,2)
    end if
    ij = irot*(irot-1)/2
    if (irot <= mroot) then
      iidx = indx(irot)
    else
      iidx = indx(irot-mroot)
    end if
    jend = min(irot,mroot)
    do jrot=1,jend
      jidx = indx(jrot)
      valsum = Zero
      do i=1,nci_dim
        valsum = valsum+vector1(iidx+i)*vector2(jidx+i)
      end do
      vp(ij+jrot) = valsum
    end do
  end do
  call read_ml(lucitv2,vector2,nci_dim*mroot,2)
  do irot=mroot+1,mroot+nroot
    ij = irot*(irot-1)/2
    iidx = indx(irot-mroot)
    do jrot=mroot+1,irot
      jidx = indx(jrot-mroot)
      valsum = Zero
      do i=1,nci_dim
        valsum = valsum+vector1(iidx+i)*vector2(jidx+i)
      end do
      vp(ij+jrot) = valsum
    end do
  end do
else
  ! other iteration
  msta = idxvec(iiter-1)+1
  mend = idxvec(iiter)
  do iit=1,iiter
    if (iit == 1) then
      jrs = 1
    else
      jrs = idxvec(iit-1)+1
    end if
    jre = idxvec(iit)
    nd = (jre-jrs+1)*nci_dim
    call read_ml(lucitv2,vector2,nd,iit)
    do jrot=jrs,jre
      jidx = indx(jrot-jrs+1)
      do irot=msta,mend
        iidx = indx(irot-msta+1)
        vsum = Zero
        do l=1,nci_dim
          vsum = vsum+vector1(iidx+l)*vector2(jidx+l)
        end do
        if (irot > jrot) then
          ij = irot*(irot-1)/2
          vp(ij+jrot) = vsum
        else
          ij = jrot*(jrot-1)/2
          vp(ij+irot) = vsum
        end if
      end do
    end do
  end do
end if

!write(u6,*) 'vp'
!do i=1,kval
!  nd = i*(i-1)/2
!  write(u6,'(5(1x,f15.8))') vp(nd+1:nd+i)
!end do

return
!...end of matrmkmul

end subroutine matrmkmul

subroutine orthogwconvec()

use gugaci_global, only: LuCiVec, mth_eigen, nci_dim, vector1, vector2
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: i

!rewind(nf7)
do i=1,mth_eigen-1
  !read(nf7) vector2(1:nci_dim)
  call read_ml(lucivec,vector1,nci_dim,i)
  call orth_ab(nci_dim,vector1,vector2)
end do
call norm_a(nci_dim,vector1)

return
!...end of orthogwconvec

end subroutine orthogwconvec

!subroutine cielement()
!! print a Row of CI matrix
!
!use gugaci_global, only: indx, mcroot, nci_dim, vector1, vector2
!use Constants, only: Zero, One
!use Definitions, only: wp, iwp, u6
!
!implicit none
!integer(kind=iwp) :: icolum
!real(kind=wp) :: sc1
!
!write(u6,*) 'mcroot',mcroot
!indx(1) = 0
!indx(2) = nci_dim
!mcroot = 1
!
!icolum = 807
!vector1(1:nci_dim) = Zero
!vector2(1:nci_dim) = Zero
!vector1(icolum) = One
!call matrix_vector_multi_parallel_drt(sc1)
!
!!do i=1,nci_dim
!!  write(21,'(i8,1x,f18.8)') i,vector2(i)
!!end do
!
!end subroutine cielement

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine EdmistonRuedenberg(Functional,CMO,Thrs,ThrRot,ThrGrad,nBas,nOrb2Loc,nFro,nSym,nMxIter,Maximisation,Converged,Debug, &
                              Silent)
! Author: T.B. Pedersen
!
! Purpose: Edmiston-Ruedenberg localisation of occupied orbitals.

use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: Functional
real(kind=wp), intent(inout) :: CMO(*)
real(kind=wp), intent(in) :: Thrs, ThrRot, ThrGrad
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb2Loc(nSym), nFro(nSym), nMxIter
logical(kind=iwp), intent(in) :: Maximisation, Debug, Silent
logical(kind=iwp), intent(out) :: Converged
integer(kind=iwp) :: irc, kOffC, nBasT, nFroT, nOrb2LocT
real(kind=wp) :: FracMem
character(len=80) :: Txt
character(len=*), parameter :: SecNam = 'EdmistonRuedenberg'

! Symmetry is NOT allowed.
! ------------------------

if (nSym /= 1) then
  call SysAbendMsg(SecNam,'Symmetry not implemented!','Sorry!')
end if

! Initializations.
! ----------------

Functional = -huge(Functional)

nBasT = nBas(1)
nOrb2LocT = nOrb2Loc(1)
nFroT = nFro(1)

Converged = .false.

irc = -1
FracMem = 0.3_wp ! 30 percent of memory used as vector buffer
call Cho_X_Init(irc,FracMem)
if (irc /= 0) then
  write(Txt,'(A,I6)') 'Cho_X_Init returned',irc
  call SysAbendMsg(SecNam,'Cholesky initialization error:',Txt)
end if

! Localise orbitals.
! ------------------

kOffC = nBasT*nFroT+1
call EdmistonRuedenberg_Iter(Functional,CMO(kOffC),Thrs,ThrRot,ThrGrad,nBasT,nOrb2LocT,nMxIter,Maximisation,Converged,Debug,Silent)

! Finalizations.
! --------------

irc = -1
call Cho_X_Final(irc)
if (irc /= 0) then
  write(Txt,'(A,I6)') 'Cho_X_Final returned',irc
  call SysAbendMsg(SecNam,'Cholesky finalization error:',Txt)
end if

end subroutine EdmistonRuedenberg

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine RBufF_tra2(LUHLFX,W,LL,LBuf,NOTU,KKTU,IST,IADXS,MEMX)
      Implicit real*8(a-h,o-z)
      Integer  MEMX,KBUF,BLKSZ,NBLCK,NPASS,BPASS,BSIZE,NRST
      Integer  i,j

#include "SysDef.fh"
#include "WrkSpc.fh"
      Dimension W(*)

      BLKSZ=(NOTU-1)*IADXS+LBuf
      NBLCK=MEMX/BLKSZ
      BSIZE=BLKSZ*NBLCK

      Call GetMem('TRABF','Allo','REAL',KBUF,BSIZE)

      BPASS=(LL+LBuf-1)/Lbuf
      NPASS=(BPASS+NBLCK-1)/NBLCK

C      WRITE(6,*) "LL=",LL
C      WRITE(6,*) "LBUF=",LBUF
C      WRITE(6,*) "MEMX=",MEMX
C      WRITE(6,*) "BLKSZ=",BLKSZ
C      WRITE(6,*) "NBLCK=",NBLCK
C      WRITE(6,*) "BPASS=",BPASS
C      WRITE(6,*) "NPASS=",NPASS

      IADX=(KKTU-1)*IADXS
      IST=1

      DO I=1,NPASS-1
         CALL dDAFILE(LUHLFX,2,Work(KBUF),BSIZE,IADX)

         DO J=1,NBLCK
            call dcopy_(LBuf,Work(KBUF+(J-1)*BLKSZ),1,W(IST),1)
            IST=IST+LBuf
         END DO

         BPASS=BPASS-NBLCK
      END DO

      NRST=(BPASS-1)*BLKSZ+mod(LL,LBuf)
      Call dDAFILE(LUHLFX,2,Work(KBUF),NRST,IADX)

      DO J=1,BPASS-1
         call dcopy_(LBuf,Work(KBUF+(J-1)*BLKSZ),1,W(IST),1)
         IST=IST+LBuf
      END DO

      NRST=mod(LL,LBuf)

      call dcopy_(NRST,Work(KBUF+(BPASS-1)*BLKSZ),1,W(IST),1)

      IST=1

      Call GetMem('TRABF','Free','REAL',KBUF,MEMX)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
*               1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine IniSew_scf(DSCF,EThr,DThr,FThr,
     &                  DltNTh,SIntTh,KSDFT)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             modified by M.Schuetz @teokem.lu.se, 1995                *
* input:      EThr,DThr,FThr,DltNTh: div. Threshold values for         *
*               of SCF WF. (only relevant for direct SCF, DSCF=TRUE)   *
*             iPrLV(2*MxPrLv): int vector with routes and corres-      *
*               ponding print levels for SEWARD integral routines      *
* output:     SIntTh: computed cutoff for integrals (prescreening)     *
*                                                                      *
*                                                                      *
* Note :  the corresponding finalization subroutine is ClsSew          *
************************************************************************
      use Sizes_of_Seward, only: S
      use Real_Info, only: ThrInt, CutInt
      Implicit Real*8 (A-H,O-Z)
      External EFP_On
#include "print.fh"
#include "iprlv.fh"
      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
      Logical Do_Tw
      COMMON  / Tw_corr_L   / Do_Tw
      Logical Do_Addc
      COMMON  / ADDcorr_L   / Do_Addc
*
*
      Logical DSCF, RF_On, Langevin_On, PCM_On, EFP_On
      Character*(*) KSDFT
      Real*8 EThr,DThr,FThr,DltNTh
*
      If (DSCF.or.RF_On().or.Langevin_On().or.KSDFT.ne.'SCF'
     &                                    .or.Do_Addc
     &                                    .or.Do_Tw
     &                                    .or.Do_OFemb
     &                                    .or.EFP_On()) Then
         nDiff=0
         If (Langevin_On().and.S%iAngMx.eq.0) nDiff=1
         Call IniSew(DSCF.or.Langevin_On().or.PCM_On(),nDiff)
      End If
*
      If (DSCF) Then
C        CutInt=Min(EThr,DThr,FThr,DltNTh)*1.0d-5
         CutInt=EThr*Min(1.0D-7,1.0D0/DBLE(S%nDim)**2)
         ThrInt=Cutint
         SIntTh=CutInt
      End If
      i=1
  100 If (iPrLV(i).le.0) Go To 110
       If (iPrLV(i).le.nRout) nPrint(iPrLV(i))=iPrLV(i+1)
       i=i+2
       Go To 100
  110 Continue
*
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real(DThr)
         Call Unused_real(FThr)
         Call Unused_real(DltNTh)
      End If
      End
      Function Get_ThrInt()
      use Real_Info, only: ThrInt
      Implicit Real*8 (A-H,O-Z)
      Real*8 Get_ThrInt
      Get_ThrInt=ThrInt
      Return
      End
      Subroutine xSet_ThrInt(tmp)
      use Real_Info, only: ThrInt
      Implicit Real*8 (A-H,O-Z)
      ThrInt=tmp
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine cvprt_cvb(a,l)

use Definitions, only: iwp, u6

implicit none
character(len=20), intent(in) :: a
logical(kind=iwp), intent(in) :: l

if (l) then
  write(u6,'(2a)') a,'     Converged.'
else
  write(u6,'(2a)') a,' Not converged.'
end if

return

end subroutine cvprt_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine SOrbChk(OneHam,Ovrlp,Fock,mBT,nD,CMO,mBB)
      Implicit Real*8 (a-h,o-z)
*
      Real*8 OneHam(mBT), Ovrlp(mBT),Fock(mBT,nD), CMO(mBB,nD)
*
      Do iD = 1, nD
*----    Check orthonormality of start orbitals
         Call ChkOrt(CMO(1,iD),mBB,Ovrlp,nBT,Whatever)
*
*----    Form the first Fock matrix
         Call DCopy_(mBT,OneHam,1,Fock(1,iD),1)
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_VecDsk_GetLQ(QVec,l_QVec,LstQSP,nQSP,iV1,nV,mSym)
C
C     Purpose: extract elements corresponding to qualified columns of
C              vectors on disk.
C
      use ChoSwp, only: nnBstRSh
      Implicit Real*8 (a-h,o-z)
      Real*8  QVec(l_QVec)
      Integer LstQSP(nQSP)
      Integer iV1(mSym), nV(mSym)
#include "cholesky.fh"
#include "stdalloc.fh"

      Character(LEN=16), Parameter:: SecNam = 'Cho_VecDsk_GetLQ'

      Integer nVecTot(8)

      Integer, External:: Cho_P_LocalSP

      Real*8, Allocatable:: Scr(:)
      Integer, Allocatable:: iQuAB_2(:)

C     Check input.
C     ------------

      If (nQSP .lt. 1) Return

      If (mSym .lt. nSym) Then
         Call Cho_Quit('mSym<nSym in '//SecNam,104)
      End If

      nVT = nV(1)
      Do iSym = 2,nSym
         nVT = nVT + nV(iSym)
      End Do
      If (nVT .lt. 1) Return

      Do iSym = 1,nSym
         If (nV(iSym) .gt. 0) Then
            If (iV1(iSym) .lt. 1) Then
               Call Cho_Quit('iV1<1 in '//SecNam,104)
            End If
         End If
      End Do

C     Allocate memory for reading.
C     ----------------------------

      l_Scr = 0
      Do iSym = 1,nSym
         If (nV(iSym).gt.0 .and. nQual(iSym).gt.0) Then
            lDim = 0
            Do iQSP = 1,nQSP
               iShlAB = Cho_P_LocalSP(LstQSP(iQSP))
               lDim = lDim + nnBstRSh(iSym,iShlAB,1)
            End Do
            l_Scr = max(l_Scr,lDim)
         End If
      End Do
      Call mma_allocate(Scr,l_Scr,Label='Scr')

C     Allocate extra mapping from qualified to reduced set.
C     -----------------------------------------------------

      l_iQuAB_2 = nQual(1)
      Do iSym = 2,nSym
         l_iQuAB_2 = max(l_iQuAB_2,nQual(iSym))
      End Do
      Call mma_allocate(iQuAB_2,l_iQuAB_2,Label='iQuAB_2')

C     Extract in each symmetry block.
C     -------------------------------

      Call Cho_P_GetGV(nVecTot,nSym)

      jLoc = 2
      iLoc = 3
      iRedC = -1
      kOffQ = 0
      Do iSym = 1,nSym
         iRedQ = -2
         If (nV(iSym).gt.0 .and. nQual(iSym).gt.0) Then
            iV2 = iV1(iSym) + nV(iSym) - 1
            Do jV = iV1(iSym),iV2
               Call Cho_1VecRd_SP(Scr,l_Scr,jV,iSym,LstQSP,nQSP,iRedC,
     &                            iLoc)
               If (iRedQ .ne. iRedC) Then
                  Call Cho_SetQ2(iQuAB_2,LstQSP,nQSP,iSym,jLoc,iLoc)
                  iRedQ = iRedC
               End If
               kQ = kOffQ + nQual(iSym)*(jV-1)
               Do iQ = 1,nQual(iSym)
                  iAB = iQuAB_2(iQ)
                  QVec(kQ+iQ) = Scr(iAB)
               End Do
            End Do
         End If
         kOffQ = kOffQ + nQual(iSym)*nVecTot(iSym)
      End Do

C     Deallocations.
C     --------------

      Call mma_deallocate(iQuAB_2)
      Call mma_deallocate(Scr)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine SINGLE_ANISO_OPEN(IReturn)

      Implicit None

      Integer ::  iReturn,NSS,NSTATE
      Integer ::  i, input_to_read, nH, nT, nTempMagn
      Integer ::  nDir, nDirZee, nMult
      Logical ::  ifrestart,GRAD
      Character(Len=180) :: input_file_name
      Logical :: dbg

C----------------------------------------------------------------------
C*  initializations
      ireturn  =0
      ifrestart=.false.
      GRAD     =.false.
      nT       =0
      nH       =0
      nTempMagn=0
      nDir     =0
      nDirZee  =0
      nMult    =0
      nss      =0
      nstate   =0
      dbg = .false.

      ! check for the "restart" option:
      If(dbg) Write(6,*) 'Enter restart_check'
      Call restart_check( ifrestart, input_to_read, input_file_name,
     &                    nT, nH, nTempMagn, nDir, nDirZee, nMult,
     &                    GRAD )
      If(dbg) Write(6,*) 'Exit restart_check'

      If ( ifrestart ) Then
         Call restart_sa( input_to_read, input_file_name,
     &                    nss, nstate )
      Else ! not a restart job -- take all data form RUNFILE
         Call fetch_data_RunFile_init( nss, nstate )
      End If !Ifrestart

      Write(6,'(120A)') ('@',i=1,95)
      Write(6,'(A)') '   SINGLE_ANISO (OPEN)'
      Write(6,'(A)') '(last updated on 12-March-2018)'
      Write(6,'(A)') '   New features: '
      Write(6,*)
      Write(6,'(A)') '1.  Calculation of the SIGN of the product '//
     &               'gX * gY * gZ for any moment;'
      Write(6,'(A)') '2.  Calculation of the parameters of the '//
     &               'Crystal-Field for lanthanides (CRYS).'
      Write(6,'(A)') '3.  Automatic generation of various plot: (PLOT)'
      Write(6,'(A)') '     -- Powder magnetic susceptibilty:  XT=f(T)'
      Write(6,'(A)') '     -- Powder molar magnetization:  M=f(H,T)'
      Write(6,'(A)') '4.  Support for various restart options: (REST)'
      Write(6,'(A)') '     -- from  $Project.rassi.h5 file.'
      Write(6,'(A)') '     -- from  $Project.aniso (binary) file.'
      Write(6,'(A)') '     -- from  ANISOINPUT (ascii) file.'
      Write(6,'(A)') '     -- from  $Project.RunFile file.'
      Write(6,'(A)') '5.  RASSI was adjusted to provide more '//
     &               'accurate tunnelling gaps between near-'//
     &               'degenerate states'
      Write(6,'(A)') 'Check the MOLCAS manual for details and input '//
     &               'examples.'
      Write(6,*)
      Write(6,'(120A)') ('@',i=1,95)
      Call xFlush(6)

      Call SINGLE_ANISO2(nH,nT,nTempMagn,nDir,nDirZee,nss,nstate,
     &                   nMult,input_file_name,
     &                   Ifrestart,IReturn,GRAD)

      Return
      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine SINGLE_ANISO2(nH,nT,nTempMagn,nDir,nDirZee,nss,nstate,
     &                         nMult,input_file_name,
     &                         Ifrestart,IReturn,GRAD)

      Implicit None
      Integer, Parameter :: wp=selected_real_kind(p=15,r=307)
#include "cntrl.fh"
#include "stdalloc.fh"
      Integer                   :: mem,RtoB,CtoB,ItoB
      Integer, intent(in)       :: nss,nstate
      Integer                   :: i,j,iReturn
      Integer                   :: idim,Ifunct,imltpl,iprint
      Integer                   :: axisoption
      Integer                   :: ndimcf,ldimcf
      Integer                   :: input_to_read,nK,MG,nm
      Integer                   :: encut_definition
      Integer                   :: ncut,nDirTot
      Integer                   :: nBlock
      Integer                   :: imanIfold
      Integer                   :: i1,i2,ldim2,lDIM
      Integer                   :: AngPoints
      Integer                   :: nlanth
      Real(kind=8)             :: zmagn(3,3)
      Real(kind=8)             :: rdiff(nstate)
      Real(kind=8)             :: a(6),HMIN,HMAX
      Real(kind=8)             :: cryst(6),coord(3)
      Real(kind=8)             :: encut_rate,em,Boltz_k,mu_Bohr
      Real(kind=8)             :: zJ, thrs
      Integer, allocatable      :: multiplicity(:)
      !---g-tens-------------------
      Integer, intent(in)        :: nMult
      Integer, allocatable       :: ndim(:)
      Real(kind=8), allocatable :: gtens(:,:), maxes(:,:,:)
      !---M-------------------
      Integer       :: nH, nTempMagn
      !---MVEC and ZEEM-------------------
      Integer       :: nDir, nDirZee
      Integer, allocatable :: LuZee(:)
      Real(kind=8), allocatable :: dir_weight(:,:)
      Real(kind=8), allocatable :: dirX(:), dirY(:), dirZ(:)
      !---XT-------------------
      Integer       :: nT
      Real(kind=8), allocatable :: Texp(:)
      Real(kind=8), allocatable :: chit_exp(:)
      Real(kind=8) :: xfield
      Real(kind=8) :: tmin, tmax
      !---Oscillator strength----------
c      Real(kind=8) :: F, Fx,Fy,Fz, AT, Ax,Ay,Az, AF, dnrm, dE
      Real(kind=8) :: DZNRM2
      External      :: DZNRM2
      Real(kind=8) :: H_torq, T_torq
      !----BIG ARRAYS------------------
      Real(kind=8), allocatable :: eso(:)
      Real(kind=8), allocatable :: esfs(:)
      Real(kind=8), allocatable :: t(:)
      Real(kind=8), allocatable :: XTexp(:)
      Real(kind=8), allocatable :: XT_no_field(:)
      Real(kind=8), allocatable :: hexp(:)
      Real(kind=8), allocatable :: magn_exp(:,:)
      Real(kind=8), allocatable :: angmom(:,:,:)
      Real(kind=8), allocatable ::  eDmom(:,:,:)
      Real(kind=8), allocatable ::   amfi(:,:,:)
      Real(kind=8), allocatable :: TempMagn(:)
      Complex(kind=8), allocatable :: MM(:,:,:), MS(:,:,:), HSO(:,:),
     &                                 ML(:,:,:), DM(:,:,:), U(:,:)
      Character(Len=180), intent(in) :: input_file_name

      Logical :: poly_file
      Logical :: ifrestart
      Logical :: Do_structure_abc
      Logical :: compute_magnetization
      Logical :: m_paranoid
      Logical :: compute_Mdir_vector
      Logical :: zeeman_energy
      Logical :: compute_torque
      Logical :: smagn
      Logical :: compute_cf
      Logical :: compute_g_tensors
      Logical :: compute_barrier
      Logical :: tinput, hinput
      Logical :: GRAD
      Logical :: DoPlot
      Logical :: DBG
      Integer :: l
      Integer                   :: nss2,nstate2

      DBG=.false.

      Boltz_k=0.6950356_wp                    !   in cm-1*K-1
      mu_Bohr=0.466864374_wp                  !   in cm-1*T-1

c---------------------------------------------------------------------
      ! Allocate memory for all arrays:
c---------------------------------------------------------------------
      If(dbg) Write(6,*) 'S_A2:: Memory Allocation Parameters'
      If(dbg) Write(6,*) 'S_A2:: nss             =',nss
      If(dbg) Write(6,*) 'S_A2:: nstate          =',nstate
      If(dbg) Write(6,*) 'S_A2:: nH              =',nH
      If(dbg) Write(6,*) 'S_A2:: nT              =',nT
      If(dbg) Write(6,*) 'S_A2:: nTempMagn       =',nTempMagn
      If(dbg) Write(6,*) 'S_A2:: nMult           =',nMult
      If(dbg) Write(6,*) 'S_A2:: nDir            =',nDir
      If(dbg) Write(6,*) 'S_A2:: nDirZee         =',nDirZee
      If(dbg) Write(6,*) 'S_A2:: input_file_name =',input_file_name
      If(dbg) Write(6,*) 'S_A2:: GRAD            =',GRAD

      mem=0
      RtoB=8
      CtoB=16
      ItoB=8

      If(nstate>=0) Then
         ! spin free energies
         Call mma_allocate(esfs,nstate,'esfs')
         Call dcopy_(nstate,[0.0_wp],0,ESFS,1)
         mem=mem+nstate*RtoB
         ! angular momentum
         Call mma_allocate(ANGMOM,3,nstate,nstate,'angmom')
         Call dcopy_(3*nstate*nstate,[0.0_wp],0,ANGMOM,1)
         mem=mem+3*nstate*nstate*RtoB
         ! electric dipole moment
         Call mma_allocate( EDMOM,3,nstate,nstate,'edmom')
         Call dcopy_(3*nstate*nstate,[0.0_wp],0, EDMOM,1)
         mem=mem+3*nstate*nstate*RtoB
         ! amfi integrals
         Call mma_allocate( AMFI,3,nstate,nstate,'amfi')
         Call dcopy_(3*nstate*nstate,[0.0_wp],0, AMFI,1)
         mem=mem+3*nstate*nstate*RtoB
         ! multiplicity of each state
         Call mma_allocate(multiplicity,nstate,'multiplicity')
         Call icopy(nstate,[0],0,multiplicity,1)
         mem=mem+nstate*ItoB
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 1 =',mem
      End If

      If(nss>=0) Then
         ! spin orbit energies
         Call mma_allocate(eso,nss,'eso')
         Call dcopy_(nss,[0.0_wp],0,eso,1)
         mem=mem+nss*RtoB
         ! spin orbit eigenstates
         Call mma_allocate(U,nss,nss,'U')
         Call zcopy_(nss*nss,[(0.0_wp,0.0_wp)],0,U,1)
         mem=mem+nss*nss*CtoB
         ! spin orbit hamiltonian
         Call mma_allocate(HSO,nss,nss,'HSO')
         Call zcopy_(nss*nss,[(0.0_wp,0.0_wp)],0,HSO,1)
         mem=mem+nss*nss*CtoB
         ! magnetic moment
         Call mma_allocate(MM,3,nss,nss,'MM')
         Call zcopy_(3*nss*nss,[(0.0_wp,0.0_wp)],0,MM,1)
         mem=mem+3*nss*nss*CtoB
         ! spin moment
         Call mma_allocate(MS,3,nss,nss,'MS')
         Call zcopy_(3*nss*nss,[(0.0_wp,0.0_wp)],0,MS,1)
         mem=mem+3*nss*nss*CtoB
         ! orbital mooment
         Call mma_allocate(ML,3,nss,nss,'ML')
         Call zcopy_(3*nss*nss,[(0.0_wp,0.0_wp)],0,ML,1)
         mem=mem+3*nss*nss*CtoB
         ! electric dipole moment
         Call mma_allocate(DM,3,nss,nss,'DM')
         Call zcopy_(3*nss*nss,[(0.0_wp,0.0_wp)],0,DM,1)
         mem=mem+3*nss*nss*CtoB
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 2 =',mem
      End If

      If( (nH>=0).and.(nTempMagn>=0) ) Then
         ! experimental magnetic field points
         Call mma_allocate(Hexp,nH,'Hexp')
         Call dcopy_(nH,[0.0_wp],0,Hexp,1)
         mem=mem+nH*RtoB
         ! experiemental magnetization
         Call mma_allocate(magn_exp,nH,nTempMagn,'magn_exp')
         Call dcopy_(nH*nTempMagn,[0.0_wp],0,magn_exp,1)
         mem=mem+nH*nTempMagn*RtoB
         ! temperature points for magnetization
         Call mma_allocate(TempMagn,nTempMagn,'TempMagn')
         Call dcopy_(nTempMagn,[0.0_wp],0,TempMagn,1)
         mem=mem+nTempMagn*RtoB
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 3 =',mem
      Else If(nH>0) Then
         Call mma_allocate(Hexp,nH,'Hexp')
         mem=mem+nH*RtoB
         Call dcopy_(nH,[0.0_wp],0,Hexp,1)
         Call mma_allocate(magn_exp,nH,0,'magn_exp')
         Call mma_allocate(TempMagn,0,'TempMagn')
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 3 =',mem
      Else If(nTempMagn>0) Then
         Call mma_allocate(Hexp,0,'Hexp')
         Call mma_allocate(magn_exp,0,nTempMagn,'magn_exp')
         Call mma_allocate(TempMagn,nTempMagn,'TempMagn')
         Call dcopy_(nTempMagn,[0.0_wp],0,TempMagn,1)
         mem=mem+nTempMagn*RtoB
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 3 =',mem
      Else
         Call mma_allocate(Hexp,0,'Hexp')
         Call mma_allocate(magn_exp,0,0,'magn_exp')
         Call mma_allocate(TempMagn,0,'TempMagn')
      End If

      If(nMult>=0) Then
         ! dimensions of pseudospins
         Call mma_allocate(ndim,nMult,'ndim')
         Call icopy(nMult,[0],0,ndim,1)
         mem=mem+nMult*ItoB
         ! temperature points for magnetization
         Call mma_allocate(gtens,nMult,3,'gtens')
         Call dcopy_(3*nMult,[0.0_wp],0,gtens,1)
         mem=mem+3*nMult*RtoB
         ! temperature points for magnetization
         Call mma_allocate(maxes,nMult,3,3,'maxes')
         Call dcopy_(3*3*nMult,[0.0_wp],0,maxes,1)
         mem=mem+3*3*nMult*RtoB
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 4 =',mem
      End If

      If((nT+nTempMagn)>0) Then
         Call mma_allocate(T,(nT+nTempMagn),'Temperature')
         Call dcopy_((nT+nTempMagn),[0.0_wp],0,T,1)
         mem=mem+(nT+nTempMagn)*RtoB
         Call mma_allocate(XTexp,(nT+nTempMagn),'XTexp')
         Call dcopy_((nT+nTempMagn),[0.0_wp],0,XTexp,1)
         mem=mem+(nT+nTempMagn)*RtoB
         Call mma_allocate(XT_no_field,(nT+nTempMagn),'XT_no_field')
         Call dcopy_((nT+nTempMagn),[0.0_wp],0,XT_no_field,1)
         mem=mem+(nT+nTempMagn)*RtoB
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 5 =',mem
      End If

      If(nDirZee>=0) Then
         ! unit numbers for the files with Zeeman energies
         Call mma_allocate(LuZee,nDirZee,'LUZee')
         Call icopy(nDirZee,[0],0,LuZee,1)
         mem=mem+nDirZee*ItoB
         ! directions for applied field for Zeeman states
         Call mma_allocate(dir_weight,nDirZee,3,'dir_weight')
         Call dcopy_(3*nDirZee,[0.0_wp],0,dir_weight,1)
         mem=mem+3*nDirZee*RtoB
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 6 =',mem
      Else
         Call mma_allocate(LuZee,0,'LUZee')
         Call mma_allocate(dir_weight,0,3,'dir_weight')
      End If

      If(nDir>=0) Then
         ! magnetization vectors
         Call mma_allocate(dirX,nDir,'dirX')
         Call mma_allocate(dirY,nDir,'dirY')
         Call mma_allocate(dirZ,nDir,'dirZ')
         mem=mem+3*nDir*RtoB
         Call dcopy_(nDir,[0.0_wp],0,dirX,1)
         Call dcopy_(nDir,[0.0_wp],0,dirY,1)
         Call dcopy_(nDir,[0.0_wp],0,dirZ,1)
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 7 =',mem
      Else
         Call mma_allocate(dirX,0,'dirX')
         Call mma_allocate(dirY,0,'dirY')
         Call mma_allocate(dirZ,0,'dirZ')
      End If

      If(nT>=0) Then
        ! T expeirimental given by user in the input
        Call mma_allocate(Texp,nT,'Texp')
        Call dcopy_(nT,[0.0_wp],0,Texp,1)
        mem=mem+nT*RtoB
        ! XT expeirimental given by user in the input
        Call mma_allocate(chit_exp,nT,'chit_exp')
        Call dcopy_(nT,[0.0_wp],0,chit_exp,1)
        mem=mem+nT*RtoB
         ! allocated memory counter
         If(dbg) Write(6,'(A,I16)') 'mem 8 =',mem
      End If

      Write(6,'(A,I16,A)') 'The code allocated initially:',mem,
     &                     ' bytes of memory for this run.'
      Call xFlush(6)
c---------------------------------------------------------------------
      IReturn=0
      IPRINT=2
      lDIM=1
      iDIM=1
      NM=0
      EM=0.0_wp
      POLY_FILE=.FALSE.
      compute_CF=.FALSE.
      axisoption=1
      nDIMcf=1
      lDIMcf=1
      a(:)=0.0_wp
      H_torq=0.1_wp ! in Tesla
      T_torq=2.0_wp ! in K
C  read the input
      IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter readin_single'
      Call readin_single(iprint,nmult,ndim,ldim,ndimcf,ldimcf,
     & nlanth,axisoption,poly_file,Ifrestart,input_to_read,nk,mg,
     & zmagn,Do_structure_abc,cryst,coord,encut_definition,
     & compute_g_tensors,compute_CF,nDirTot,nss,nstate,
     & compute_magnetization, compute_torque, smagn, tinput, hinput,
     & compute_Mdir_vector, zeeman_energy, LUZee, doplot,
     & encut_rate,ncut,nTempMagn,TempMagn, m_paranoid,
     & compute_barrier,nBlock,AngPoints,input_file_name,
     & nT,nH,texp,chit_exp,zJ,hexp,magn_exp,hmin,hmax,
     & nDir,nDirZee,dirX,dirY,dirZ,dir_weight,xfield,tmin,tmax,thrs,
     & H_torq,T_torq )
      IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit readin_single'

      If ( ifrestart ) Then
         ! if restart, fetch "big data" from the input file
         If ( input_to_read .eq. 1 ) Then
            Call read_binary_aniso( nss, nstate, multiplicity, eso,
     &                              esfs, U, MM, MS, ML, DM, ANGMOM,
     &                              EDMOM, AMFI, HSO )

         Else If ( input_to_read .eq. 2 ) Then
            ! get the information from formatted aniso.input file:
            IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter '//
     &                         'read_formatted_aniso'
            IF(DBG) Write(6,*) 'SA:',input_file_name
            nss2=nss
            nstate2=nstate
            Call read_formatted_aniso( input_file_name, nss2, nstate2,
     &                                 multiplicity, eso, esfs, U, MM,
     &                                 MS, ML, DM, ANGMOM, EDMOM,
     &                                 AMFI, HSO )
            IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit  '//
     &                         'read_formatted_aniso'

         Else If ( input_to_read .eq. 3 ) Then
            ! get the information from RASSI-HDF5 file:
            IF(DBG) Write(6,*) 'SA:',input_file_name
#ifdef _HDF5_
            Call read_hdf5_all( input_file_name, nss, nstate,
     &                         multiplicity, eso, esfs,  U, MM,
     &                         MS, ML, DM, ANGMOM, EDMOM, AMFI, HSO )
#else
            Call WarningMessage(2,'File '//trim(input_file_name)//
     &                          ' cannot be opened. Molcas was'//
     &                          ' compiled without HDF5 option.')
            Call Quit_OnUserError()
#endif

         Else If ( input_to_read .eq. 4 ) Then
            IF(DBG) Write(6,*) 'SA:',input_file_name
            ! get the information from formatted aniso.input file:
            nss2=nss
            nstate2=nstate
            Call read_formatted_aniso_old( input_file_name,nss2,nstate2,
     &                                multiplicity, eso, MM, MS, ML )
         End If ! input_to_read

      Else
         ! ifrestart = .false., i.e. usual S-A calculation
         Call fetch_data_RunFile_all( nss, nstate, multiplicity, eso,
     &                                esfs, U, MM, MS, ML, DM,
     &                                ANGMOM, EDMOM, AMFI, HSO )
         If (DBG) Then
            Write(6,'(A)') 'SA: ANGMOM(x,y,z)'
            Do i=1,nstate
               Do j=1,nstate
                  Write(6,'(2i4,A,3ES24.14)') i,j,' |',
     &                                       (ANGMOM(l,i,j),l=1,3)
               End Do
            End Do
            Write(6,'(/)')
            Write(6,'(A)') 'SA: EDMOM(x,y,z)'
            Do i=1,nstate
               Do j=1,nstate
                  Write(6,'(2i4,A,3ES24.14)') i,j,' |',
     &                                       (EDMOM(l,i,j),l=1,3)
               End Do
            End Do
            Write(6,'(/)')
            Write(6,'(A)') 'SA: AMFI(x,y,z)'
            Do i=1,nstate
               Do j=1,nstate
                  Write(6,'(2i4,A,3ES24.14)') i,j,' |',
     &                                       (AMFI(l,i,j),l=1,3)
               End Do
            End Do
            Write(6,'(/)')
            Write(6,'(A)') 'SA: HSO(i,j)'
            Do i=1,nss
               Do j=1,nss
                  Write(6,'(2i4,A,4ES24.14)') i,j,' |',HSO(i,j),HSO(j,i)
               End Do
            End Do
         End If !DBG

      End If ! Ifrestart

      ! print some input data in the beginning of the output:
      ! so that the user knows which ws the input ...
          Write(6,'(A)') 'LOW-LYING SPIN-ORBIT ENERGIES:'
          Do i=1,nss
            Write(6,'(A,I4,A,F25.14)')
     &               'ENERGY OF THE SPIN-ORBIT STATE (',i,') =',ESO(i)
          End Do
          Write(6,'(A)') 'LOW-LYING SPIN-FREE ENERGIES:'
          Do i=1,nstate
            Write(6,'(A,I4,A,F25.14)')
     &               'ENERGY OF THE SPIN-FREE STATE  (',i,') =',ESFS(i)
          End Do
          rdiff=0.0_wp
          lDIM2=1 ! the same as the defult for lDIM
          Do i=2,nstate
            rdiff(i)=ABS(ESFS(i)-ESFS(i-1))
            If( rdiff(i) < 20.0_wp ) Then
              lDIM2=lDIM2+1
            Else
            goto 107
            End If
          End Do
107       Continue
          ! set the lDIM:
          If (lDIM2>lDIM) lDIM=lDIM2


!----- input processing finished -----
! save some important data, regardless of the following execution
      ! -- binary $Project.aniso
      Call write_binary_aniso( nss, nstate, multiplicity, eso,
     &                         esfs, U, MM, MS, DM, ANGMOM, EDMOM, AMFI,
     &                         HSO )
      ! ASCII -- anisoinput:
      Call write_formatted_aniso(
     &                         nss, nstate, multiplicity, eso,
     &                         esfs, U, MM, MS, DM, ANGMOM, EDMOM, AMFI,
     &                         HSO )
!
!----- compute various properties ----------|
! calculation of magnetic Hamiltonians:
!      IDIM=0
      IFUNCT=0
      If ( compute_g_tensors .AND. nMult>0 ) Then
         Do IMLTPL=1,NMULT
           IReturn=0
           If(ndim(imltpl).eq.1) Then
             Write(6,'(5X,A,I2,A)') 'THE DIMENSION OF THE ',IMLTPL,
     &                              ' MULTIPLET IS 1.'
             Write(6,'(5X,A)') 'THERE IS NO G TENSOR FOR '//
     &                         'EFFECTIVE S = 0.'
             Go To 10
           End If

           i1=1           +Ifunct
           i2=ndim(imltpl)+Ifunct

           If ( i2<=nss) then
              IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter g_high',IMLTPL
              Call g_high( eso(i1:i2), GRAD,
     &                      MS(1:3, i1:i2, i1:i2 ),
     &                      MM(1:3, i1:i2, i1:i2 ),
     &                     imltpl,
     &                     ndim(imltpl),
     &                     Do_structure_abc,
     &                     cryst,
     &                     coord,
     &                     gtens(imltpl,1:3), maxes(imltpl,1:3,1:3),
     &                     iprint )
              IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit g_high',IMLTPL
              Call Add_Info('GTENS_MAIN', gtens(imltpl,1:3), 3, 4)
           End If
10         Continue

           IFUNCT=IFUNCT+NDIM(IMLTPL)
           If(IReturn.ne.0) Call ABEnd()
         End Do
      End If

!----------------------------------------------------------------------|
      !   >> AB INITIO CRYSTAL-FIELD <<

      If(compute_CF .AND. nDIMCF>0 ) Then
        If(axisoption==1 .AND. nMult>0 .AND. nDIM(1)>1 ) Then
          iDIM=NDIM(1)
          lDIM=NDIM(1)
        Else
          iDIM=nDIMCF
          lDIM=lDIMCF
        End If

        ! compute the CF of the ground |J,MJ> multiplet:
        If((nDIMCF>1).AND.(nDIMCF<=nss)) Then
          IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter CF',nDIMCF
          Call CRYSTALFIELD( ESO(1:nDIMCF),
     &                        MM(1:3,1:nDIMCF,1:nDIMCF),
     &                        MS(1:3,1:nDIMCF,1:nDIMCF),
     &                       nDIMcf, iDIM, nlanth,
     &                       zmagn, axisoption, GRAD,
     &                       iPrint)
          IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit CF',nDIMCF
        End If
      End If

      IF(DBG) Write(6,*) 'SINGLE_ANISO2:: nlanth=', nlanth
      IF(DBG) Write(6,*) 'SINGLE_ANISO2:: lDIMCF=', lDIMCF
      IF(DBG) Write(6,*) 'SINGLE_ANISO2:: nstate=', nstate


      If(compute_CF .AND. ( (lDIMCF>0).AND.(lDIMCF<=nstate) )) Then
        If(axisoption==1 .AND. nMult>0 .AND. nDIM(1)>1 ) Then
          iDIM=NDIM(1)
          lDIM=NDIM(1)
        Else
          iDIM=nDIMCF
          lDIM=lDIMCF
        End If
        ! compute the CF of the ground |L,ML> term:
        If( .not.(ifrestart.and.(input_to_read.eq.4)) ) Then
             IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter t-CF',lDIMCF
             Call termCF( angmom(1:3,1:lDIMCF,1:lDIMCF),
     &                    AMFI(1:3,1:lDIMCF,1:lDIMCF),
     &                    esfs(1:lDIMCF),
     &                    lDIMCF, lDIM,
     &                    zmagn, axisoption, nlanth,
     &                    iPrint )
             IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit t-CF',lDIMCF
        End If !ifrestart
      End If !compute_CF



!----------------------------------------------------------------------|
      !   >> AB INITIO BLOCKING BARRIER FOR SMMs <<
      If ( compute_barrier ) Then
        If ( nBlock.ne.0 ) Then
          imanifold=1

          IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter barrier',nBlock
          Call  BARRIER( nBlock, MM(1:3,1:nBlock,1:nBlock),
     &                   eso(1:nBlock), imanIfold, nMult, nDim,
     &                   doplot, iPrint )
          IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit barrier',nBlock

        Else
           Write(6,'(A)') 'nBlock parameter is not defined. '
           Write(6,'(A)') 'Did you specify the MLTP keyword in the '//
     &                    'input?'
           Write(6,'(A)') 'If the problem persists, please, '//
     &                    'submit a bug report.'
        End If
      End If

!----------------------------------------------------------------------|

      Call set_T( nT, nTempMagn, TINPUT, TempMagn, Tmin, Tmax,
     &            chit_exp, Texp, T, XTexp )

      If( compute_torque .OR. compute_magnetization .OR.
     &    (Xfield .ne. 0.0_wp) ) Then
         ! set the NM- number of states to be exactly diagonalized
         ! in Zeeman Interaction
         IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter set_nm'
         Call set_nm( nss, ncut, encut_definition, nk, mg,
     &                nTempMagn, hmax, ESO, encut_rate, TempMagn,
     &                nM, EM, dbg )
         IF(DBG) Write(6,*) 'SINGLE_ANISO2::  exit set_nm'

      End If


!----------------------------------------------------------------------|
      !   >> MAGNETIC SUSCEPTIBILITY <<
      iReturn=0
      IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter SUSCEPTIBILITY'
      Call SUSCEPTIBILITY( NSS, ESO, MS, MM, nT, nTempMagn, T, tmin,
     &                     tmax, XTexp, zJ, tinput, XT_no_field,
     &                     doplot, iPrint, mem)
      IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit SUSCEPTIBILITY'

      If (Xfield .ne. 0.0_wp ) Then
         IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter XT_dMoverdH_single'
         ! nM = nss
         Call XT_dMoverdH_single( nss, nTempMagn, nT, nss, Tmin, Tmax,
     &                            XTexp, ESO, T, zJ, Xfield, EM, MM, MS,
     &                            XT_no_field, tinput, smagn, mem )
         IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit XT_dMoverdH_single'
      End If
!----------------------------------------------------------------------|
      !           >>  TORQUE  <<
      If( compute_torque ) Then

        IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter TORQUE'
         ! nM = nss
        Call torque( Nss, Nss, AngPoints, EM, eso, mm, ms, zJ, thrs,
     &               mem, m_paranoid, smagn, H_torq, T_torq, zmagn, dbg)
        IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit TORQUE'

      End If
!----------------------------------------------------------------------|
      !           >>  MAGNETIZATION <<

      If( compute_magnetization ) Then

        IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Enter magnetization'
      Call magnetization( nss, nM, nTempMagn, nDirTot, nDir, nDirZee,
     &                    nH, iPrint, LUZee, mem, compute_Mdir_vector,
     &                    zeeman_energy, hinput, m_paranoid, smagn,
     &                    doplot, TempMagn, eso, dirX, dirY, dirZ,
     &                    dir_weight, hexp, magn_exp, zJ, hmin, hmax,
     &                    EM, thrs,  mm, ms, dbg )
        IF(DBG) Write(6,*) 'SINGLE_ANISO2::  Exit magnetization'

      Else
        Write(6,*)
        Write(6,'(5X,A)') 'ON USER REQUEST, THE MAGNETIZATION VECTOR '//
     &                    'AND THE MEAN MAGNETIZATION WAS NOT '//
     &                    'CALCULATED'
      End If


c---------------------------------------------------------------------
      ! Deallocate memory for all arrays:
c---------------------------------------------------------------------
      If(nstate>=0) Then
         Call mma_deallocate(esfs)
         Call mma_deallocate(ANGMOM)
         Call mma_deallocate( EDMOM)
         Call mma_deallocate(  AMFI)
         Call mma_deallocate(multiplicity)
      End If

      If(nss>=0) Then
         Call mma_deallocate(eso)
         Call mma_deallocate(U)
         Call mma_deallocate(HSO)
         Call mma_deallocate(MM)
         Call mma_deallocate(MS)
         Call mma_deallocate(ML)
         Call mma_deallocate(DM)
      End If

      Call mma_deallocate(Hexp)
      Call mma_deallocate(magn_exp)
      Call mma_deallocate(TempMagn)

      If(nMult>=0) Then
         Call mma_deallocate(ndim)
         Call mma_deallocate(gtens)
         Call mma_deallocate(maxes)
      End If

      If((nT+nTempMagn)>=0) Then
         Call mma_deallocate(T)
         Call mma_deallocate(XTexp)
         Call mma_deallocate(XT_no_field)
      End If

      Call mma_deallocate(LuZee)
      Call mma_deallocate(dir_weight)

      Call mma_deallocate(dirX)
      Call mma_deallocate(dirY)
      Call mma_deallocate(dirZ)

      If(nT>=0) Then
         Call mma_deallocate(Texp)
         Call mma_deallocate(chit_exp)
      End If


      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mksyminit_cvb()

use casvb_global, only: corth, idelstr, ifxorb, ifxstr, iorbrel, iorts, irels, irots, izeta, ndimrel, ndrot, nfxvb, nijrel, &
                        niorth, norb, norbrel, nort, north, nsyme, nzrvb, recinp, relorb, symelm
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, iaddr, icnt, ieig, ifail, ii, iior, ijrel, ijrel2, il, ioffs, iorb, iorb2, ir, irel, ishift, ishift2, j, &
                     jj, jl, jor, jorb, jorb2, korb, nciorth, ncount, nrel
real(kind=wp) :: dum(1)
logical(kind=iwp) :: found
integer(kind=iwp), allocatable :: intger(:), io(:,:), iorder(:,:), iorbs(:)
real(kind=wp), allocatable :: a(:,:), b(:,:), ri(:), rr(:), vi(:,:), vr(:,:)
real(kind=wp), parameter :: thresh = 1.0e-8_wp

! Restore arrays:
call rdioff_cvb(9,recinp,ioffs)
call rdis_cvb(iorbrel,ndimrel,recinp,ioffs)
call rdis_cvb(ifxorb,norb,recinp,ioffs)
call rdis_cvb(ifxstr,nfxvb,recinp,ioffs)
call rdis_cvb(idelstr,nzrvb,recinp,ioffs)
call rdis_cvb(iorts,2*nort,recinp,ioffs)
call rdis_cvb(irots,2*ndrot,recinp,ioffs)
call rdis_cvb(izeta,nsyme,recinp,ioffs)

call mma_allocate(iorbs,norb,label='iorbs')
call mma_allocate(intger,norb,label='intger')

! First check that minimum number of orbital relations has been given
! (no cycle should be complete):
ishift = 0
do ijrel=1,nijrel
  iorb = abs(iorbrel(1+ishift))
  jorb = abs(iorbrel(2+ishift))
  if (iorb /= jorb) then
    iorbs(:) = 0
    iorbs(iorb) = 1
    iorbs(jorb) = 1
    ishift2 = 0
    do ijrel2=1,nijrel
      iorb2 = abs(iorbrel(1+ishift2))
      jorb2 = abs(iorbrel(2+ishift2))
      if ((ijrel2 /= ijrel) .and. (iorb2 /= jorb2)) then
        if (iorbs(iorb2) == 1) then
          if (iorbs(jorb2) == 1) then
            ncount = 0
            do i=1,norb
              if (iorbs(i) == 1) then
                ncount = ncount+1
                intger(ncount) = i
              end if
            end do
            write(u6,'(a,/,20i4)') ' Too many orbital relations involving orbitals :',(intger(ii),ii=1,ncount)
            write(u6,'(a)') ' Please reduce number of ORBREL cards.'
            call abend_cvb()
          else
            iorbs(jorb2) = 1
          end if
        else if (iorbs(jorb2) == 1) then
          iorbs(iorb2) = 1
        end if
      end if
      ishift2 = ishift2+3+iorbrel(3+ishift2)
    end do
  end if
  ishift = ishift+3+iorbrel(3+ishift)
end do

call mma_allocate(a,norb,norb,label='a')
call mma_allocate(b,norb,norb,label='b')
call mma_allocate(rr,norb,label='rr')
call mma_allocate(ri,norb,label='ri')
call mma_allocate(vr,norb,norb,label='vr')
call mma_allocate(vi,norb,norb,label='vi')

! Diagonal orbital relations:
nciorth = 0
north(:) = 0
do iorb=1,norb
  ! Orbital conditions on IORB:
  call span0_cvb(norb,norb)
  ishift = 0
  do i=1,norbrel
    iior = iorbrel(1+ishift)
    jor = iorbrel(2+ishift)
    nrel = iorbrel(3+ishift)
    if ((iorb == iior) .and. (iorb == jor)) then
      call unitmat(b,norb)
      do ir=nrel,1,-1
        irel = iorbrel(ir+3+ishift)
        call mxatb_cvb(symelm(:,:,irel),b,norb,norb,norb,a)
        b(:,:) = a(:,:)
      end do
      ! Everything that hasn't got eigenvalue +1 will be orthogonalised away
      ! Unsymmetric diagonalisation:
      ifail = 0
      call f02agf(b,norb,norb,rr,ri,vr,norb,vi,norb,intger,ifail)
      if (ifail /= 0) then
        write(u6,*) ' Error in diagonalisation, IFAIL :',ifail
        call abend_cvb()
      end if
      do ieig=1,norb
        if ((abs(rr(ieig)-One) > thresh) .or. (abs(ri(ieig)) > thresh)) then
          vr(:,ieig) = vr(:,ieig)+vi(:,ieig)
          call span1_cvb(vr(1,ieig),1,dum,norb,0)
        end if
      end do
    end if
    ishift = ishift+3+nrel
  end do
  !if (plc_const) call rconstr_plc(iorb)
  call span2_cvb(corth(1,1+nciorth),north(iorb),dum,norb,0)
  nciorth = nciorth+north(iorb)
end do
niorth = nciorth

call mma_deallocate(rr)
call mma_deallocate(ri)
call mma_deallocate(vr)
call mma_deallocate(vi)
call mma_deallocate(intger)
call mma_allocate(io,4,norbrel,label='io')
call mma_allocate(iorder,norb,norbrel,label='iorder')

! Off-diagonal relations:
io(:,:) = 0
iorder(:,:) = 0
ijrel = 0
ishift = 0
do i=1,norbrel
  iorb = iorbrel(1+ishift)
  jorb = iorbrel(2+ishift)
  nrel = iorbrel(3+ishift)
  if (iorb /= jorb) then
    ijrel = ijrel+1
    io(1,ijrel) = iorb
    io(2,ijrel) = jorb
    io(3,ijrel) = nrel
    io(4,ijrel) = 3+ishift
    iorder(1,ijrel) = iorb
    iorder(2,ijrel) = jorb
    irel = iorbrel(4+ishift)
  end if
  ishift = ishift+3+nrel
end do
nijrel = ijrel

! Orbitals with constraints should be generating orbitals if possible:
icnt = 0
do iorb=1,norb
  if (north(iorb) > 0) then
    icnt = icnt+1
    iorbs(icnt) = iorb
  end if
end do
do iorb=1,norb
  if (north(iorb) == 0) then
    icnt = icnt+1
    iorbs(icnt) = iorb
  end if
end do
do
  ! Sort relations and define generating orbitals:
  loop1: do i=1,norb
    iorb = iorbs(i)
    loop2: do ii=1,nijrel
      if ((iorder(1,ii) /= iorb) .and. (iorder(2,ii) /= iorb)) cycle loop2
      ! Has IORB already been generated from KORB?:
      do j=1,i-1
        korb = iorbs(j)
        if ((iorder(1,ii) == korb) .or. (iorder(2,ii) == korb)) cycle loop2
      end do
      if (iorder(1,ii) == iorb) then
        iorder(1,ii) = iorder(2,ii)
        iorder(2,ii) = iorb
      end if
      jorb = iorder(1,ii)
      ! JORB will be generated from IORB
      if (north(jorb) /= 0) then
        write(u6,'(2(a,i4),a)') ' Attempting to generate orbital',jorb,' from orbital',iorb,'  ---'
        write(u6,'(a,i4,a)') ' the orbital conditions for orbital',jorb,' cannot be enforced.'
        write(u6,'(a)') ' Please reduce number of ORBREL cards.'
        call abend_cvb()
      end if
      found = .false.
      loop3: do jj=1,nijrel
        if ((jj == ii) .or. ((iorder(1,jj) /= jorb) .and. (iorder(2,jj) /= jorb))) cycle loop3
        ! Is JORB involved in any other orbital relations?:
        do j=1,i-1
          korb = iorbs(j)
          if ((iorder(1,jj) == korb) .or. (iorder(2,jj) == korb)) cycle loop3
        end do
        found = .true.
        if (iorder(1,jj) == jorb) then
          iorder(1,jj) = iorder(2,jj)
          iorder(2,jj) = jorb
        end if
        iorder(3,jj) = iorder(2,jj)
        iorder(4:,jj) = iorder(3:norb-1,ii)
        ! KORB will be generated from IORB (via JORB):
        iorder(2,jj) = iorder(2,ii)
      end do loop3
      if (found) exit loop1
    end do loop2
  end do loop1
  if (i > norb) exit
end do
! Generate transformation matrix for each relation:
irels(1:2,1:nijrel) = iorder(1:2,1:nijrel)
do ijrel=1,nijrel
  call unitmat(relorb(:,:,ijrel),norb)
  do i=1,norb-1
    il = norb+2-i
    if (i == 1) il = 2
    if (i == norb) il = 1
    if (iorder(il,ijrel) == 0) cycle
    iorb = iorder(il,ijrel)
    j = i
    do
      j = j+1
      jl = norb+2-j
      if (j == 1) jl = 2
      if (j == norb) jl = 1
      if (iorder(jl,ijrel) /= 0) exit
    end do
    jorb = iorder(jl,ijrel)
    do ii=1,nijrel
      if (((iorb == io(1,ii)) .or. (iorb == io(2,ii))) .and. ((jorb == io(1,ii)) .or. (jorb == io(2,ii)))) then
        nrel = io(3,ii)
        iaddr = io(4,ii)
        ! Operate right-to-left:
        do ir=nrel,1,-1
          irel = iorbrel(ir+iaddr)
          if (jorb == io(1,ii)) then
            call mxatb_cvb(symelm(:,:,irel),relorb(:,:,ijrel),norb,norb,norb,a)
          else
            call mxattb_cvb(symelm(:,:,irel),relorb(:,:,ijrel),norb,norb,norb,a)
          end if
          relorb(:,:,ijrel) = a(:,:)
        end do
      end if
    end do
  end do
end do

call mma_deallocate(io)
call mma_deallocate(iorder)
call mma_deallocate(iorbs)
call mma_deallocate(a)
call mma_deallocate(b)

return

end subroutine mksyminit_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine vCrtCmp(Zeta12,P,nZeta,A,Axyz,na,HerR,nHer,ABeq)
************************************************************************
*                                                                      *
* Object: to compile the value of the angular part of a basis function *
*         evaluated at a root of the quadrature.                       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             November '90                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Zeta12(nZeta), P(nZeta,3), A(3), HerR(nHer),
     &       Axyz(nZeta,3,nHer,0:na)
      Logical ABeq(3)
*
      iRout = 116
      iPrint = nPrint(iRout)
*     iPrint = 99
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In vCrtCmp: HerR',' ',HerR,1,nHer)
         Call RecPrt(' In vCrtCmp: Zeta',' ',Zeta12,nZeta,1)
         Call RecPrt(' In vCrtCmp: A   ',' ',A   ,1    ,3)
         Call RecPrt(' In vCrtCmp: P   ',' ',P   ,nZeta,3)
      End If
      call dcopy_(nZeta*3*nHer,[One],0,Axyz(1,1,1,0),1)
      If (na.eq.0) Go To 999
*
      Do 10 iHer = 1, nHer
         Do 20 iCar = 1, 3
*
            If (ABeq(iCar)) Then
               Do 31 iZeta = 1, nZeta
                  Axyz(iZeta,iCar,iHer,1) =
     &                   HerR(iHer)*Zeta12(iZeta)
 31            Continue
            Else
               Do 30 iZeta = 1, nZeta
                  Axyz(iZeta,iCar,iHer,1) =
     &                   HerR(iHer)*Zeta12(iZeta) +
     &                   P(iZeta,iCar) - A(iCar)
 30            Continue
            End If
*
            Do 40 ia = 2, na
               Do 50 iZeta = 1, nZeta
                  Axyz(iZeta,iCar,iHer,ia) = Axyz(iZeta,iCar,iHer,1) *
     &                                       Axyz(iZeta,iCar,iHer,ia-1)
 50            Continue
 40         Continue
*
 20      Continue
 10   Continue
*
 999  Continue
*     If (iPrint.ge.99) Then
*        Do 100 ia = 0, na
*           Do 110 iHer = 1, nHer
*              Write (Label,'(A,I2,A,I2,A)') ' In vCrtCmp: Axyz (iHer=',
*    &               iHer,',ia=',ia,')'
*              Call RecPrt(Label,' ',Axyz(1,1,iHer,ia),nZeta,3)
*110        Continue
*100     Continue
*     End If
*     Call GetMem(' Exit vCrtCmp','CHECK','REAL',iDum,iDum)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE TSHinit(Energy)
      use rassi_global_arrays, only: JBNUM, LROOT
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='TSHINIT')
#include "rasdef.fh"
#include "symmul.fh"
#include "rassi.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "Files.fh"
#include "Struct.fh"
#include "tshcntrl.fh"
      DIMENSION ISGSTR1(NSGSIZE), ISGSTR2(NSGSIZE)
      DIMENSION ICISTR1(NCISIZE), ICISTR2(NCISIZE)
      DIMENSION IXSTR1(NXSIZE), IXSTR2(NXSIZE),ENERGY(NSTATE)
      INTEGER      I,JOB1,JOB2,iRlxRoot
      CHARACTER*8  WFTYP1,WFTYP2
      LOGICAL   LOWROOT, UPROOT
*


C
C Print a banner
C
      IF (IPGLOB.GE.USUAL) THEN
        WRITE(6,*)
        WRITE(6,*)
        WRITE(6,'(6X,100A1)') ('*',i=1,100)
        WRITE(6,'(6X,A,98X,A)') '*','*'
        WRITE(6,'(6X,A,36X,A,37X,A)')
     &       '*',' Surface hopping section ','*'
        WRITE(6,'(6X,A,98X,A)') '*','*'
        WRITE(6,'(6X,100A1)') ('*',i=1,100)
        WRITE(6,*)
        WRITE(6,*)

        WRITE(6,'(6X,A)')'Surface hopping section'
        WRITE(6,'(6X,A)')'-----------------------'
      END IF
C
C Get the current state and print it's energy
C
      CALL Get_iScalar('Relax CASSCF root',iRlxRoot)
      IF (IPGLOB.GE.USUAL) THEN
        WRITE(6,'(6X,A,I14)')'The current state is:',iRlxRoot
        WRITE(6,'(6X,A,6X,E15.6,A,/)')'Its energy is:',ENERGY(iRlxRoot),
     &                              ' a.u.'
      END IF
C
C Get wave function parameters for current state
C
      ISTATE1=iRlxRoot
      JOB1=JBNUM(ISTATE1)
      NACTE1=NACTE(JOB1)
      MPLET1=MLTPLT(JOB1)
      LSYM1=IRREP(JOB1)
      NHOL11=NHOLE1(JOB1)
      NELE31=NELE3(JOB1)
      WFTYP1=RASTYP(JOB1)
C
C Set the variables for the wave function of the current state
C
      IF(WFTYP1.EQ.'GENERAL ') THEN
          NRSPRT=3
          DO I=1,8
             NRAS(I,1)=NRS1(I)
             NRAS(I,2)=NRS2(I)
             NRAS(I,3)=NRS3(I)
          END DO
          NRASEL(1)=2*NRS1T-NHOL11
          NRASEL(2)=NACTE1-NELE31
          NRASEL(3)=NACTE1
          CALL SGINIT(NSYM,NACTE1,MPLET1,NRSPRT,NRAS,NRASEL,ISGSTR1)
          IF(IPGLOB.GT.DEBUG) THEN
             WRITE(6,*)'Split-graph structure for JOB1=',JOB1
             CALL SGPRINT(ISGSTR1)
          END IF
          CALL SGSVAL(ISGSTR1,NSYM,NASHT,LISM,NVERT,LDRT,
     &               LDOWN,LUP,MIDLEV,MVSTA,MVEND,LMAW,LLTV)
          CALL CXINIT(ISGSTR1,ICISTR1,IXSTR1)
          CALL CXSVAL(ICISTR1,IXSTR1,NMIDV,NIPWLK,LNOW,LIOW,LNCSF,
     &               LNOCSF,LIOCSF,NWALK,LICASE,
     &               MXEO,LNOCP,LIOCP,NICOUP,LICOUP,NVTAB,
     &               LVTAB,LMVL,LMVR,NT1MX,NT2MX,NT3MX,NT4MX,NT5MX)
C CI sizes, as function of symmetry, are now known.
          NCI1=IWORK(LNCSF-1+LSYM1)
      ELSE
* The only other cases are HISPIN, CLOSED or EMPTY.
* NOTE: The HISPIN case is suspected to be buggy. Not used now.
          NCI1=1
      END IF
      CALL GETMEM('GTDMCI1','ALLO','REAL',LCI1,NCI1)

C
C Check for the possibility to hop to a lower root
C
      IF ((ISTATE1-1).GE.1) THEN
         LOWROOT=.TRUE.
         IF (IPGLOB.GE.USUAL) THEN
           WRITE(6,'(6X,A,I2)') "There is a lower root, which is: "
     &     ,LROOT(ISTATE1-1)
         END IF
      ELSE
         LOWROOT=.FALSE.
         IF (IPGLOB.GE.USUAL) THEN
           WRITE(6,'(6X,A)') "There is no lower root"
         END IF
      END IF
C
C Check for the possibility to hop to an upper root
C
      IF ((ISTATE1+1).LE.NSTATE) THEN
         UPROOT=.TRUE.
         IF (IPGLOB.GE.USUAL) THEN
           WRITE(6,'(6X,A,I2,/)') "There is an upper root, which is: "
     &     ,LROOT(ISTATE1+1)
         END IF
      ELSE
         UPROOT=.FALSE.
         IF (IPGLOB.GE.USUAL) THEN
           WRITE(6,'(6X,A,/)') "There is no upper root"
         END IF
      END IF
C
C Check surface hopping to a root lower than the current one
C
      IF (LOWROOT) THEN
         ISTATE2=ISTATE1-1
         IF (IPGLOB.GE.USUAL) THEN
           WRITE(6,'(6X,A,I3)') 'The lower state is:',ISTATE2
           WRITE(6,'(6X,A,6X,E15.6,A)') 'Its energy is:',
     &          ENERGY(ISTATE2),' a.u.'
           WRITE(6,'(6X,A,12X,E15.6,A,/)') 'Ediff = ',
     &          ENERGY(iRlxRoot)-ENERGY(ISTATE2),' a.u.'
         END IF
*---------------------------------------------------------------------*
* Adapted from RASSI subroutines GTMCTL and READCI                    *
*                                                                     *
C Get wave function parameters for ISTATE2
         JOB2=JBNUM(ISTATE2)
         NACTE2=NACTE(JOB2)
         MPLET2=MLTPLT(JOB2)
         LSYM2=IRREP(JOB2)
         NHOL12=NHOLE1(JOB2)
         NELE32=NELE3(JOB2)
         WFTYP2=RASTYP(JOB2)
         LPART=NEWPRTTAB(NSYM,NFRO,NISH,NRS1,NRS2,NRS3,NSSH,NDEL)
         IF(IPGLOB.GE.DEBUG) CALL PRPRTTAB(IWORK(LPART))
C For the second wave function
         IF(WFTYP2.EQ.'GENERAL ') THEN
            NRSPRT=3
            DO I=1,8
               NRAS(I,1)=NRS1(I)
               NRAS(I,2)=NRS2(I)
               NRAS(I,3)=NRS3(I)
            END DO
            NRASEL(1)=2*NRS1T-NHOL12
            NRASEL(2)=NACTE2-NELE32
            NRASEL(3)=NACTE2
            CALL SGINIT(NSYM,NACTE2,MPLET2,NRSPRT,NRAS,
     &           NRASEL,ISGSTR2)
            IF(IPGLOB.GT.DEBUG) THEN
               WRITE(6,*)'Split-graph structure for JOB2=',JOB2
               CALL SGPRINT(ISGSTR2)
            END IF
            CALL SGSVAL(ISGSTR2,NSYM,NASHT,LISM,NVERT,LDRT,
     &           LDOWN,LUP,MIDLEV,MVSTA,MVEND,LMAW,LLTV)
            CALL CXINIT(ISGSTR2,ICISTR2,IXSTR2)
            CALL CXSVAL(ICISTR2,IXSTR2,NMIDV,NIPWLK,LNOW,LIOW,
     &           LNCSF,LNOCSF,LIOCSF,NWALK,LICASE,MXEO,
     &           LNOCP,LIOCP,NICOUP,LICOUP,NVTAB,LVTAB,
     &           LMVL,LMVR,NT1MX,NT2MX,NT3MX,NT4MX,NT5MX)
C     CI sizes, as function of symmetry, are now known.
            NCI2=IWORK(LNCSF-1+LSYM2)
         ELSE
C     Presently, the only other cases are HISPIN, CLOSED or EMPTY.
            NCI2=1
         END IF
         CALL GETMEM('GTDMCI2','ALLO','REAL',LCI2,NCI2)
C     Check if the Energy gap is smaller than the threshold.
         Ediff=ABS(ENERGY(ISTATE2)-ENERGY(ISTATE1))
         Ethr=3.0D-2
         IF (Ediff.le.Ethr) THEN
            ChkHop=.TRUE.
         ELSE
            ChkHop=.FALSE.
         END IF
         IF (IPGLOB.GE.USUAL) THEN
           WRITE(6,'(6X,A,I8,4X,A,I8)')'ISTATE1=',iRlxRoot,'ISTATE2=',
     &          ISTATE2
           WRITE(6,'(6X,A,I11,4X,A,I11)')'NCI1=',NCI1,'NCI2=',NCI2
         END IF
#ifdef _DEBUGPRINT_
         WRITE(6,*)' TSHinit calls TSHop.'
#endif
         CALL TSHop(WORK(LCI1),WORK(LCI2))
#ifdef _DEBUGPRINT_
         WRITE(6,*)' TSHinit back from TSHop.'
#endif
         IF(WFTYP2.EQ.'GENERAL ') THEN
           CALL CXCLOSE(ISGSTR2,ICISTR2,IXSTR2)
           CALL SGCLOSE(ISGSTR2)
         END IF
         CALL GETMEM('GTDMCI2','FREE','REAL',LCI2,NCI2)
         CALL KILLOBJ(LPART)
      END IF
C
C Check surface hopping to a root higher than the current one
C
      IF (UPROOT) THEN
         ISTATE2=ISTATE1+1
         IF (IPGLOB.GE.USUAL) THEN
           WRITE(6,'(6X,A,I3)') 'The upper state is:',ISTATE2
           WRITE(6,'(6X,A,6X,E15.6,A)') 'Its energy is:',
     &          ENERGY(ISTATE2),' a.u.'
           WRITE(6,'(6X,A,12X,E15.6,A,/)') 'Ediff = ',
     &          ENERGY(ISTATE2)-ENERGY(iRlxRoot),' a.u.'
         END IF
*---------------------------------------------------------------------*
* Adapted from RASSI subroutines GTMCTL and READCI                    *
*                                                                     *
C Get wave function parameters for ISTATE2
         JOB2=JBNUM(ISTATE2)
         NACTE2=NACTE(JOB2)
         MPLET2=MLTPLT(JOB2)
         LSYM2=IRREP(JOB2)
         NHOL12=NHOLE1(JOB2)
         NELE32=NELE3(JOB2)
         WFTYP2=RASTYP(JOB2)
         LPART=NEWPRTTAB(NSYM,NFRO,NISH,NRS1,NRS2,NRS3,NSSH,NDEL)
         IF(IPGLOB.GE.DEBUG) CALL PRPRTTAB(IWORK(LPART))
C For the second wave function
         IF(WFTYP2.EQ.'GENERAL ') THEN
            NRSPRT=3
            DO I=1,8
               NRAS(I,1)=NRS1(I)
               NRAS(I,2)=NRS2(I)
               NRAS(I,3)=NRS3(I)
            END DO
            NRASEL(1)=2*NRS1T-NHOL12
            NRASEL(2)=NACTE2-NELE32
            NRASEL(3)=NACTE2
            CALL SGINIT(NSYM,NACTE2,MPLET2,NRSPRT,NRAS,
     &           NRASEL,ISGSTR2)
            IF(IPGLOB.GT.DEBUG) THEN
               WRITE(6,*)'Split-graph structure for JOB2=',JOB2
               CALL SGPRINT(ISGSTR2)
            END IF
            CALL SGSVAL(ISGSTR2,NSYM,NASHT,LISM,NVERT,LDRT,
     &           LDOWN,LUP,MIDLEV,MVSTA,MVEND,LMAW,LLTV)
            CALL CXINIT(ISGSTR2,ICISTR2,IXSTR2)
            CALL CXSVAL(ICISTR2,IXSTR2,NMIDV,NIPWLK,LNOW,LIOW,
     &           LNCSF,LNOCSF,LIOCSF,NWALK,LICASE,MXEO,
     &           LNOCP,LIOCP,NICOUP,LICOUP,NVTAB,LVTAB,
     &           LMVL,LMVR,NT1MX,NT2MX,NT3MX,NT4MX,NT5MX)
C     CI sizes, as function of symmetry, are now known.
            NCI2=IWORK(LNCSF-1+LSYM2)
         ELSE
C     Presently, the only other cases are HISPIN, CLOSED or EMPTY.
            NCI2=1
         END IF
         CALL GETMEM('GTDMCI2','ALLO','REAL',LCI2,NCI2)
C     Check if the Energy gap is smaller than the threshold.
         Ediff=ABS(ENERGY(ISTATE2)-ENERGY(ISTATE1))
         Ethr=3.0D-2
         IF (Ediff.le.Ethr) THEN
            ChkHop=.TRUE.
         ELSE
            ChkHop=.FALSE.
         END IF
         IF (IPGLOB.GE.USUAL) THEN
           WRITE(6,'(6X,A,I8,4X,A,I8)')'ISTATE1=',iRlxRoot,'ISTATE2=',
     &          ISTATE2
           WRITE(6,'(6X,A,I11,4X,A,I11)')'NCI1=',NCI1,'NCI2=',NCI2
         END IF
#ifdef _DEBUGPRINT_
         WRITE(6,*)' TSHinit calls TSHop.'
#endif
         CALL TSHop(WORK(LCI1),WORK(LCI2))
#ifdef _DEBUGPRINT_
         WRITE(6,*)' TSHinit back from TSHop.'
#endif
         IF(WFTYP2.EQ.'GENERAL ') THEN
           CALL CXCLOSE(ISGSTR2,ICISTR2,IXSTR2)
           CALL SGCLOSE(ISGSTR2)
         END IF
         CALL GETMEM('GTDMCI2','FREE','REAL',LCI2,NCI2)
         CALL KILLOBJ(LPART)
      END IF
*
C      ELSE
C         LCI2=LCI1
C         NCI2=NCI1
C         CALL GETMEM('GTDMCI2','ALLO','REAL',LCI2,NCI2)
C      END IF
      IF(WFTYP1.EQ.'GENERAL ') THEN
        CALL CXCLOSE(ISGSTR1,ICISTR1,IXSTR1)
        CALL SGCLOSE(ISGSTR1)
      END IF
      CALL GETMEM('GTDMCI1','FREE','REAL',LCI1,NCI1)
      RETURN
*
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MECTL(PROP,OVLP,HAM,ESHFT)
      use rassi_global_arrays, only: HDIAG
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='MECTL')
#include "symmul.fh"
#include "rassi.fh"
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "Files.fh"
#include "SysDef.fh"
      REAL*8 PROP(NSTATE,NSTATE,NPROP),OVLP(NSTATE,NSTATE),
     &       HAM(NSTATE,NSTATE),ESHFT(NSTATE)
*

C Print results:
      NCOL=4
      IF(PRXVR.and.IPGLOB.ge.SILENT) THEN
      WRITE(6,*)
      Call CollapseOutput(1,'Expectation values for input states')
      WRITE(6,'(3X,A)')     '-----------------------------------'
      WRITE(6,*)
      WRITE(6,*)' EXPECTATION VALUES OF 1-ELECTRON OPERATORS'
      WRITE(6,*)' FOR THE RASSCF INPUT WAVE FUNCTIONS:'
      WRITE(6,*)
      DO IPROP=1,NPROP
       IF(IPUSED(IPROP).NE.0) THEN

* Skip printing if all the diagonal values are very small
*  (presumed zero for reasons of selection rules)
        PLIMIT=1.0D-10
        PMAX=0.0D0
        DO I=1,NSTATE
         PMAX=MAX(PMAX,ABS(PROP(I,I,IPROP)+PNUC(IPROP)*OVLP(I,I)))
        END DO
        IF(PMAX.GE.PLIMIT) THEN

        DO ISTA=1,NSTATE,NCOL
          IEND=MIN(NSTATE,ISTA+NCOL-1)
          WRITE(6,*)
        WRITE(6,'(1X,A,A8,A,I4)')
     &  'PROPERTY: ',PNAME(IPROP),'   COMPONENT:**',ICOMP(IPROP)
          WRITE(6,'(1X,A,3D17.8)')
     &'ORIGIN    :',(PORIG(I,IPROP),I=1,3)
          WRITE(6,'(1X,A,I8,3I17)')
     &'STATE     :',(I,I=ISTA,IEND)
          WRITE(6,*)
          WRITE(6,'(1X,A,4(1x,G16.9))')
     &'ELECTRONIC:',(PROP(I,I,IPROP),I=ISTA,IEND)
          WRITE(6,'(1X,A,4(1x,G16.9))')
     &'NUCLEAR   :',(PNUC(IPROP)*OVLP(I,I),I=ISTA,IEND)
          WRITE(6,'(1X,A,4(1x,G16.9))')
     &'TOTAL     :',(PROP(I,I,IPROP)+PNUC(IPROP)*OVLP(I,I),I=ISTA,IEND)
          WRITE(6,*)
        END DO

        END IF
       END IF
      END DO
      Call CollapseOutput(0,'Expectation values for input states')
      END IF

      IFON=1
      X=0.0D0
      DO I=2,NSTATE
       DO J=1,I-1
        X=MAX(X,ABS(OVLP(I,J)))
       END DO
      END DO
      IF (X.GE.1.0D-6) IFON=0
      IFHD=1
      X=0.0D0
      DO I=2,NSTATE
       DO J=1,I-1
        X=MAX(X,ABS(HAM(I,J)))
       END DO
      END DO
      IF (X.GE.1.0D-6) IFHD=0
      IF(IFON.eq.0) IFHD=0

      IF(IPGLOB.GE.USUAL) THEN
       IF(IFHAM) THEN
         WRITE(6,*)
         WRITE(6,*)' HAMILTONIAN MATRIX FOR THE ORIGINAL STATES:'
         WRITE(6,*)
         IF(IFHD.eq.1) THEN
          WRITE(6,*)' Diagonal, with energies'
          WRITE(6,'(5(1X,F15.8))')(HAM(J,J),J=1,NSTATE)
         !do J=1,NSTATE
         !WRITE(6,*) HAM(J,J)
         !enddo
         ELSE
          DO ISTA=1,NSTATE,5
            IEND=MIN(ISTA+4,NSTATE)
            WRITE(6,'(10X,5(8X,A3,I4,A3))')
     &         (' | ', I, ' > ',I=ISTA,IEND)
            DO J=1,NSTATE
              WRITE(6,'(A3,I4,A3,5(2X,F16.8))')
     &           ' < ',J,' | ', (HAM(I,J),I=ISTA,IEND)
            END DO
          ENDDO
         END IF
       END IF
      END IF

      IF(IPGLOB.GE.USUAL) THEN
        WRITE(6,*)
        WRITE(6,*)'     OVERLAP MATRIX FOR THE ORIGINAL STATES:'
        WRITE(6,*)
        IF(IFON.eq.1) THEN
         WRITE(6,*)' Diagonal, with elements'
         WRITE(6,'(5(1X,F15.8))')(OVLP(J,J),J=1,NSTATE)
        ELSE
         DO ISTATE=1,NSTATE
          WRITE(6,'(5(1X,F15.8))')(OVLP(ISTATE,J),J=1,ISTATE)
         END DO
        END IF
      END IF

* Addition by A.Ohrn. If ToFile keyword has been specified, we put
* numbers on the auxiliary rassi-to-qmstat file.
      If(ToFile) then
        If(.not.IfHam) then
          Write(6,*)
          Write(6,*)'You ask me to print hamiltonian, but there is '
     &//'none to print!'
          Call Abend()
        Endif
        Call DaName(LuEig,FnEig)
        iDisk=0
        Do iState=1,nState
          Do jState=1,iState
            Call dDaFile(LuEig,1,Ham(iState,jState),1,iDisk)
          Enddo
        Enddo
        Do iState=1,nState
          Do jState=1,iState
            Call dDaFile(LuEig,1,OvLp(iState,jState),1,iDisk)
          Enddo
        Enddo
*-- File is closed in eigctl.
        Call DaClos(LuEig)
      Endif
* End of addition by A.Ohrn.

      IF(IFHAM .AND. (IFHDIA.OR.IFSHFT)) THEN
        DO ISTATE=1,NSTATE
          IF(.NOT.IFSHFT) ESHFT(ISTATE)=0.0D0
          IF(IFHDIA) ESHFT(ISTATE)=ESHFT(ISTATE)+
     &              (HDIAG(ISTATE)-HAM(ISTATE,ISTATE))
        END DO
        DO ISTATE=1,NSTATE
         DO JSTATE=1,NSTATE
          HAM(ISTATE,JSTATE)=HAM(ISTATE,JSTATE)+
     &      0.5D0*(ESHFT(ISTATE)+ESHFT(JSTATE))*OVLP(ISTATE,JSTATE)
         END DO
        END DO
        IFHD=1
        DO I=2,NSTATE
         DO J=1,J-1
          IF(ABS(HAM(I,J)).GE.1.0D-10) IFHD=0
         END DO
        END DO
        IF(IFON.eq.0) IFHD=0
        IF(IPGLOB.GE.USUAL) THEN
         WRITE(6,*)
         WRITE(6,*)' USER-MODIFIED HAMILTONIAN FOR THE ORIGINAL STATES:'
         WRITE(6,*)'(With user shifts, and/or replaced diagonal'
         WRITE(6,*)' elements, including overlap corrections.)'
         IF(IFHD.eq.1) THEN
          WRITE(6,*)' Diagonal, with energies'
          WRITE(6,'(5(1X,F15.8))')(HAM(J,J),J=1,NSTATE)
         !do J=1,NSTATE
         !WRITE(6,*) HAM(J,J)
         !enddo
         ELSE
          DO ISTATE=1,NSTATE
            WRITE(6,'(5(1X,F15.8))')(HAM(ISTATE,J),J=1,ISTATE)
          END DO
         END IF
        END IF
      END IF
CPAM00 End of updated HDIA/SHIFT section.

      IF(IPGLOB.GT.SILENT .and. PRMER) THEN
      WRITE(6,*)
      Call CollapseOutput(1,'Matrix elements for input states')
      WRITE(6,'(3X,A)')     '--------------------------------'
      WRITE(6,*)
      WRITE(6,*)' MATRIX ELEMENTS OF 1-ELECTRON OPERATORS'
      WRITE(6,*)' FOR THE RASSCF INPUT WAVE FUNCTIONS:'
      WRITE(6,*)
      DO IPROP=1,NPROP
       IF(IPUSED(IPROP).NE.0) THEN
        DO ISTA=1,NSTATE,NCOL
          IEND=MIN(NSTATE,ISTA+NCOL-1)
          WRITE(6,*)
          WRITE(6,'(1X,A,A8,A,I4)')
     &  'PROPERTY: ',PNAME(IPROP),'   COMPONENT:*',ICOMP(IPROP)
          WRITE(6,'(1X,A,3D17.8)')
     &'ORIGIN    :',(PORIG(I,IPROP),I=1,3)
          WRITE(6,'(1X,A,I8,3I17)')
     &'STATE     :',(I,I=ISTA,IEND)
          WRITE(6,*)
          DO J=1,NSTATE
            WRITE(6,'(1X,I5,6X,4(1x,G16.9))')
     & J,(PROP(J,I,IPROP)+PNUC(IPROP)*OVLP(J,I),I=ISTA,IEND)
          END DO
          WRITE(6,*)
        END DO
       END IF
      END DO
      Call CollapseOutput(0,'Matrix elements for input states')
      END IF
cnf
      If (IfDCpl) Then
         Call Get_iScalar('Unique atoms',natom)
         Call Allocate_Work(iNucChg,natom)
         Call Get_dArray('Effective nuclear Charge',Work(iNucChg),nAtom)
         nST = nState*(nState+1)/2
         Call Allocate_Work(iDerCpl,3*natom*nST)
         Call AppDerCpl(natom,nST,Work(iNucChg),Prop,
     &                  Work(iDerCpl),HAM)
         Call Free_Work(iDerCpl)
         Call Free_Work(iNucChg)
      End If
cnf

      WRITE(6,*)
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1984,1989-1993, Jeppe Olsen                            *
!***********************************************************************

subroutine SPNCOM_MCLR(iwork,NOPEN,MS2,NDET,IABDET,IABUPP,IFLAG,PSSIGN)
! Combinations of nopen unpaired electrons.Required
! spin projection MS2/2.
! JO 21-7-84
!    IFLAG = 1 : Only combinations (in IABDET)
!    IFLAG = 2 : combinations and upper dets
!    IFLAG = 3 : Only upper dets
! A few revisions october 1988
! Upper dets added feb 1989
! Changed to combinations June 1992
!
! If PSSIGN differs from 0, spin combinations are assumed.
! we select as the unique determinants those with first electron
! having alpha spin

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NOPEN, MS2, IFLAG
integer(kind=iwp), intent(out) :: IWORK(NOPEN+1), NDET
integer(kind=iwp), intent(inout) :: IABDET(NOPEN,*), IABUPP(NOPEN,*)
real(kind=wp) :: PSSIGN
integer(kind=iwp) :: ADD, I, IEL, J, lUPPER, MS2L, NALPHA, NUPPER

! LENGTH OF IWORK MUST BE AT LEAST NOPEN+1

NDET = 0
NUPPER = 0

! Determinants are considered as binary numbers,1=alpha,0=beta

IWORK(:) = 0
! Loop over all possible binary numbers
do I=1,2**NOPEN
  ! 1 : NEXT BINARY NUMBER
  ADD = 1
  J = 0
  do while (ADD == 1)
    J = J+1
    if (IWORK(J) == 1) then
      IWORK(J) = 0
    else
      IWORK(J) = 1
      ADD = 0
    end if
  end do

  ! 2 :  CORRECT SPIN PROJECTION ?
  NALPHA = sum(IWORK(1:NOPEN))

  if ((2*NALPHA-NOPEN == MS2) .and. ((PSSIGN == Zero) .or. (IWORK(1) /= 0))) then
    if (IFLAG < 3) then
      NDET = NDET+1
      IABDET(:,NDET) = IWORK(1:NOPEN)
    end if
    if (IFLAG > 1) then
      ! UPPER DET ?
      MS2L = 0
      LUPPER = 1

      do IEL=1,NOPEN
        if (IWORK(IEL) == 1) then
          MS2L = MS2L+1
        else
          MS2L = MS2L-1
        end if
        if (MS2L < 0) LUPPER = 0
      end do
      if (LUPPER == 1) then
        NUPPER = NUPPER+1
        IABUPP(:,NUPPER) = IWORK(1:NOPEN)
      end if
    end if
  end if

end do

!XMSD2 = real(MS2,kind=wp)*Half

end subroutine SPNCOM_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Get_NVnode(NVEC)

use Cholesky, only: nSym, NumCho
use Definitions, only: iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(_OUT_) :: NVEC(*)
integer(kind=iwp) :: i

do i=1,nSym
  NVEC(i) = NumCho(i)
end do

return

end subroutine Get_NVnode

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#ifdef _DMRG_
!***********************************************************************
!                                                                      *
!  Purpose:  read (and check) DMRG input in QCMaquis style             *
!                                                                      *
!***********************************************************************
      subroutine qcmaquis_rdinp(luinput,switch,nr_lines)

      use qcmaquis_interface_cfg
      use qcmaquis_interface_utility_routines, only:
     &    lower_to_upper, find_qcmaquis_keyword

      implicit none

      integer, intent(in)    :: luinput
      integer, intent(in)    :: switch
      integer, intent(inout) :: nr_lines

      character(len=500)     :: line, line2
      integer                :: i, io, j

      ! Leon: flags for the compression keyword parsing
      logical                :: compr_flag, donotdelete_flag
      ! Leon: the evil common block that contains the MPSCompressM
      ! option for the MPS compression and the do not delete checkpoints flag
#include "nevptp.fh"
      donotdelete_flag = .false.

      select case(switch)
        !> find maximum number of input lines
        case(1)
          nr_lines = 0
          do
            line(1:500) = ' '
            read(luinput,*,IOSTAT=io) line
            if (is_iostat_end(io)) exit
            if (io>0) stop 'problem reading QCMaquis input'
            call lower_to_upper(line(1:5))
            if(line(1:5) == 'ENDRG' .or. line(1:5) == 'ENDDM') exit
            nr_lines = nr_lines + 1
          end do
          dmrg_input%nr_qcmaquis_input_lines = nr_lines
        !> read input lines
        case(2)
          if(nr_lines == 0) return
          allocate(dmrg_input%qcmaquis_input(nr_lines))

          compr_flag = .false.
          DoDelChk = .false.

          dmrg_input%qcmaquis_input = ' '

          do i = 1, nr_lines
            read(luinput,*,IOSTAT=io) line
            if (is_iostat_end(io)) exit
            if (io>0) then
              write (6,*) "Problem reading QCMaquis input"
              call Quit_OnUserError()
            end if
            ! Leon: handle a special case where we input the MPS compression
            ! parameter in the RGINPUT block but it does not get passed to
            ! QCMaquis at all

            dmrg_input%qcmaquis_input(i) = trim(line)
            if (.not.compr_flag) then
              line2=adjustl(trim(line))
              call lower_to_upper(line2(1:5))
              if (line2(1:5) == 'COMPR') then
                ! process the compression keyword
                ! set the compression flag to true and read the next line.
                compr_flag = .true.
              end if
            else
              read(line,*,IOSTAT=io) MPSCompressM
              if (io /= 0) then
                write (6,*) "Problem reading QCMaquis input"
                call Quit_OnUserError()
              end if
              compr_flag = .false.
            end if

            !! Handle a "do not delete" flag in QCMaquis input, which prevents
            !! deleting old MPS checkpoint files (in case we want a restart)
            if (.not.donotdelete_flag) then
              line2=adjustl(trim(line))
              call lower_to_upper(line2(1:6))
              if (line2(1:6) == 'DONOTD') then
                ! process the do not delete keyword
                ! set the do not delete flag to true and read the next line.
                donotdelete_flag = .true.
              end if
            else
              line2=adjustl(trim(line))
              call lower_to_upper(line2(1:4))
              if ((line2(1:1) == '1').or.(line2(1:4) == 'TRUE')) then
                DoDelChk = .true.
              end if
              if (io /= 0) then
                write (6,*) "Problem reading QCMaquis input"
                call Quit_OnUserError()
              end if
              donotdelete_flag = .false.
            end if

          end do

        !> sanity check input for ALL mandatory keywords
        case(3)
          do j = 1,2
            line(1:500) = ' '
            select case(j)
              case(1)
                line = 'NSWEEPS'
              case(2)
                line = 'MAX_BOND_DIMENSION'
              case(3)
                line = 'CONV_THRESH'
            end select
            i = 0
            call find_qcmaquis_keyword(dmrg_input%qcmaquis_input,
     &                                 nr_lines,
     &                                 line,
     &                                 i
     &                                )
            if(i <= 0)then
              !> check for keyword sweep_bond_dimension which is an alternative
              !conv_thresh is not mandatory
              if(trim(line) == 'CONV_THRESH') cycle
              if(trim(line) == 'MAX_BOND_DIMENSION')then
                line2(1:500) = ' '
                line2        = 'SWEEP_BOND_DIMENSIONS'
                i = 0
                call find_qcmaquis_keyword(dmrg_input%qcmaquis_input,
     &                                     nr_lines,
     &                                     line2,
     &                                     i
     &                                    )
                if(i > 0) cycle
              end if
              Call WarningMessage(2,'Error in input preprocessing.')
              write(6,*)' qcmaquis_rdinp: mandatory keyword ',
     &        trim(line),' missing in QCMaquis DMRG input section'
              nr_lines = -1; return

            else
              select case(j)
                case(1)
                ! read in nsweeps
                  read(dmrg_input%qcmaquis_input(i+1),*)
     &                                     qcmaquis_param%num_sweeps
                case(2)
                  ! read in max_bond_dimension
                  read(dmrg_input%qcmaquis_input(i+1),*)
     &                                     qcmaquis_param%M
                case(3)
                  ! read in conv_thresh
                  read(dmrg_input%qcmaquis_input(i+1),*)
     &                                     qcmaquis_param%conv_thresh
              end select
            end if

          end do
        case default
          write(6,*) ' QCMaquis input reader - you should have never'//
     &             ' reached this spot...'
          call Quit_OnUserError()
      end select

      end subroutine qcmaquis_rdinp
#elif defined (NAGFOR)
c Some compilers do not like empty files
      subroutine empty_qcmaquis_rdinp()
      end subroutine empty_qcmaquis_rdinp
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine mol2vb2_cvb(vecvb,vecmol,isyml,fac,iwr,nsa,nsb)

use Symmetry_Info, only: Mul
use casvb_global, only: mxirrep, nda, ndet
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: vecvb(ndet), vecmol(*)
integer(kind=iwp), intent(in) :: isyml, iwr, nsa, nsb
real(kind=wp), intent(in) :: fac
integer(kind=iwp) :: idet, indbet, indx, ioffsa, ioffsb, isa, isb, isyma, isymb, nnsa, nnsb, nstra(mxirrep), nstrb(mxirrep)
integer(kind=iwp), allocatable :: indxa(:), indxb(:)

call mma_allocate(indxa,nsa,label='indxa')
call mma_allocate(indxb,nsb,label='indxb')

call indxab_cvb(indxa,indxb,nstra,nstrb,nsa,nsb)

! Now loop casvb -> molcas
idet = 0
do isyma=1,mxirrep
  isymb = Mul(isyma,isyml)
  nnsa = nstra(isyma)
  nnsb = nstrb(isymb)
  if ((nnsa <= 0) .or. (nnsb <= 0)) cycle

  ioffsa = sum(nstra(1:isyma-1))
  ioffsb = sum(nstrb(1:isymb-1))

  do isb=1,nnsb
    indbet = indxb(isb+ioffsb)
    do isa=1,nnsa
      indx = indxa(isa+ioffsa)+(indbet-1)*nda
      idet = idet+1
      if (iwr == 0) then
        vecmol(idet) = vecvb(indx)
      else if (iwr == 1) then
        vecvb(indx) = vecmol(idet)
      else if (iwr == 2) then
        vecvb(indx) = vecvb(indx)+fac*vecmol(idet)
      end if
    end do
  end do
end do

call mma_deallocate(indxa)
call mma_deallocate(indxb)

return

end subroutine mol2vb2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine stat_cvb()
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


      if(ip(3).ge.1)then
        write(6,'(/,a,i16)')
     >    ' Total number of structure transformations :',n_applyt
        write(6,'(a,i17)')
     >    ' Total number of Hamiltonian applications :',n_applyh
        write(6,'(a,i11)')
     >    ' Total number of 2-electron density evaluations :',n_2el
        write(6,'(a,i21)')
     >    ' Total number of Hessian applications :',n_hess
        if(n_orbhess.gt.0)write(6,'(a,i8)')
     >    ' Total number of pure orbital Hessian applications :',
     >    n_orbhess
        if(n_cihess.gt.0)write(6,'(a,i13)')
     >    ' Total number of pure CI Hessian applications :',n_cihess
        write(6,'(a,i18,/)')
     >    ' Approximate memory usage (8-byte words) :',ibasemx
     >      -ibase0
        write(6,'(a,f10.3,a)')' CASVB at ',tim_cvb(cpu0),' CPU seconds'
        memused=0
        call stat1_cvb()
      endif
      return
      end
c  Format statement settings :

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      real*8 function  couple3J(
     *l1,     ! integer  l1
     *l2,     ! integer  l2
     *l3,     ! integer  l3
     *m1,     ! integer  m1
     *m2,     ! integer  m2
     *m3)     ! integer  m3
cbs this routine calculates the coupling of three angular momenta to  zero
cbs
cbs
cbs   Int dOmega i^(l1+l2+l3) Y^l1_m1 (Omega) Y^l2_m2 (Omega) Y^l3_m3 (Omega) =
cbs   sqrt( (2l1+1)(2l2+1)(2l2+3)/ 4Pi)  * 3J(l1,l2,l3,0,0,0) *
cbs   3J(l1,l2,l3,m1,m2,m3)
cbs
cbs
      implicit real*8(a-h,o-z)
#include "real.fh"
      real*8 inv4pi
cbs   (4*PI)**-1
      inv4pi=0.25d0/pi
cbs   initialize couple3J-coefficient
      couple3J=0d0
cbs   quick check
      if (m1+m2+m3.ne.0) return
cbs   double all values for regge3j
      l1d=l1+l1
      l2d=l2+l2
      l3d=l3+l3
      m1d=m1+m1
      m2d=m2+m2
      m3d=m3+m3
      fac1=sqrt(DBLE(l1d+1)*DBLE(l2d+1)*DBLE(l3d+1)*inv4pi)
      fac2=regge3j(l1d,l2d,l3d,0,0,0)
      fac3=regge3j(l1d,l2d,l3d,m1d,m2d,m3d)
      couple3J=fac1*fac2*fac3
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! SUBROUTINE lp10_arbrbr_ext_calcuvalue(intentry,isma,nlp_value)
! SUBROUTINE lp11_arblbr_ext_calcuvalue(intentry,isma,nlp_value)
! SUBROUTINE lp12_arblbl_ext_calcuvalue(intentry,isma,nlp_value)
! SUBROUTINE lp9_drlbl_ext_calcuvalue(lri,lrk,isma)
! SUBROUTINE lp8_drlbr_sum_calcuvalue(lri,lrp,lrq,isma,nv)
! SUBROUTINE lp9_drlbl_sum_calcuvalue(lri,lrp,lrq,isma,nv)
! SUBROUTINE lp_arbl_ext_dd_calcuvalue(lri,lrj,iml,imr,nlp_value)
! SUBROUTINE lp_ar_coe_calcuvalue(idtu,isma,lri,lrj,nlp_value,lpcoe
! SUBROUTINE lp_drl_ext_SS_calcuvalue(lri,nlp_value)
! SUBROUTINE lp_drl_sum_SS_calcuvalue(lri,lrj,nlp_value)
! SUBROUTINE lp_drl_ext_ST_calcuvalue(lri,nlp_value)
! SUBROUTINE lp_drl_ext_TT_calcuvalue(lri,n1415_value,nlp_value)
! SUBROUTINE lp_drl_sum_TT_calcuvalue(lri,lrj,n1415,nlp_value)
! SUBROUTINE lp_arbr_ext_svtv_calcuvalue(LRI,LRJ,nlp_value)
! SUBROUTINE lp_drr_ext_svtv_calcuvalue(lri,nlp_value)
! SUBROUTINE lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)
! SUBROUTINE lp678_ext_calcuvalue(lri,lrk,isma,nlp_value)

subroutine lp_drl_ext_TS_calcuvalue(lri,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_abkk, intspace_abkk, ism_g1415, logic_g1415, logic_g2g4a, ng_sm, norb_number, &
                         value_lpext, vint_ci, voint, w0_plp, w0g2a, w0g36a, w1_plp, w1g14a, w1g2a, w1g36a
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, intpos, intspace, isma, ismb, ivalue, lra, lrb
real(kind=wp) :: w0lp, w1lp

intpos = intind_abkk(lri)
intspace = intspace_abkk(lri)
ivalue = 0
! G1415
if (logic_g1415) then

  w1lp = w1_plp*w1g14a

  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        lra = norb_number(ia)
        ivalue = ivalue+1
        !value_lpext(ivalue) = vint_ci(intposia)*ww0lp+vint_ci(intposia+1)*ww1lp+valuelpib
        ! OK,only for Spin=0
        value_lpext(ivalue) = (voint(lra,lri)-voint(lrb,lri))*w1lp
      end do
    end do
  end do
end if

! G2G4b
if (logic_g2g4a) then
  w0lp = w0_plp*w0g2a
  w1lp = w1_plp*w1g2a

! valuelptmp1 = w0lp
! w0lp = w0lp-w1lp
! w1lp = -valuelptmp1*Two
! valuelptmp1 = ww0lp
! ww0lp = ww0lp-ww1lp
! ww1lp = -valuelptmp1*Two

  do i=1,intspace
    ivalue = ivalue+2
    ! Drl -- B^rA^l =4_2
    value_lpext(ivalue) = w1lp*vint_ci(intpos)
    ! Drl -- B^lA^r =4_3
    value_lpext(ivalue-1) = -value_lpext(ivalue)
    intpos = intpos+2
  end do
end if

intpos = intind_abkk(lri)
w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a

do I=1,intspace
  ivalue = ivalue+1
  value_lpext(ivalue) = vint_ci(intpos+1)*w0lp-vint_ci(intpos)*w1lp
  intpos = intpos+2
end do
nlp_value = ivalue

end subroutine lp_drl_ext_TS_calcuvalue

!subroutine lp9_drlbl_ext_sd_calcuvalue(intentry,isma)   ! ,nlp_value)
!
!use gugaci_global, only: nlsm_ext, norb_act, value_lpext, vint_ci, w0_sdplp, w0_sdplp25, w0g25, w1_sdplp, w1_sdplp25
!use Constants, only: Two
!use Definitions, only: iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: intentry, isma
!integer(kind=iwp) :: iaddpos, ilpvalue, intpos, m_ia
!
!w0_sdplp25 = (w0_sdplp-w1_sdplp)*w0g25
!w1_sdplp25 = -Two*w0_sdplp*w0g25
!intpos = intentry
!iaddpos = norb_act*2            !severe_new_error_1020
!ilpvalue = 0
!do m_ia=1,nlsm_ext(isma)
!  ilpvalue = ilpvalue+1
!  value_lpext(ilpvalue) = w0_sdplp25*vint_ci(intpos)+w1_sdplp25*vint_ci(intpos+1)
!  intpos = intpos+iaddpos      !ip3ad_intspace   !severe_new_error_
!end do
!
!end subroutine lp9_drlbl_ext_sd_calcuvalue

subroutine lp10_arbrbr_ext_calcuvalue(intentry,isma,nlp_value)

use gugaci_global, only: nlsm_ext, value_lpext, vint_ci, w0_sdplp, w0_sdplp25, w0g25, w1_sdplp, w1_sdplp25
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: intentry, isma
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ilpvalue, intpos, m_ia

w0_sdplp25 = (w0_sdplp-w1_sdplp)*w0g25
w1_sdplp25 = (w0_sdplp+w1_sdplp)*w0g25
intpos = intentry
ilpvalue = 0
do m_ia=1,nlsm_ext(isma)
  ilpvalue = ilpvalue+1
  value_lpext(ilpvalue) = w0_sdplp25*vint_ci(intpos+2)+w1_sdplp25*vint_ci(intpos+1)
  intpos = intpos+3
end do
nlp_value = ilpvalue

end subroutine lp10_arbrbr_ext_calcuvalue

subroutine lp11_arblbr_ext_calcuvalue(intentry,isma,nlp_value)

use gugaci_global, only: nlsm_ext, value_lpext, vint_ci, w0_sdplp, w0_sdplp25, w0g25, w1_sdplp, w1_sdplp25
use Constants, only: Two
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: intentry, isma
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ilpvalue, intpos, m_ia

w0_sdplp25 = (w0_sdplp-w1_sdplp)*w0g25
w1_sdplp25 = -Two*w0_sdplp*w0g25
intpos = intentry
ilpvalue = 0
do m_ia=1,nlsm_ext(isma)
  ilpvalue = ilpvalue+1
  value_lpext(ilpvalue) = w0_sdplp25*vint_ci(intpos+1)+w1_sdplp25*vint_ci(intpos)
  intpos = intpos+3
end do
nlp_value = ilpvalue

end subroutine lp11_arblbr_ext_calcuvalue

subroutine lp12_arblbl_ext_calcuvalue(intentry,isma,nlp_value)

use gugaci_global, only: nlsm_ext, value_lpext, vint_ci, w0_sdplp, w0_sdplp25, w0g25, w1_sdplp, w1_sdplp25
use Constants, only: Two
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: intentry, isma
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ilpvalue, intpos, m_ia

w0_sdplp25 = (w0_sdplp-w1_sdplp)*w0g25
w1_sdplp25 = -Two*w0_sdplp*w0g25
intpos = intentry
ilpvalue = 0
do m_ia=1,nlsm_ext(isma)
  ilpvalue = ilpvalue+1
  value_lpext(ilpvalue) = w0_sdplp25*vint_ci(intpos+2)+w1_sdplp25*vint_ci(intpos)
  intpos = intpos+3

end do
nlp_value = ilpvalue

end subroutine lp12_arblbl_ext_calcuvalue

!subroutine lp_arbr_ext_svtv_calcuvalue(intentry,nlp_value)
!
!use gugaci_global, only: logic_g13, norb_ext, value_lpext, vint_ci, w0_plp, w0g13a, w0g36a, w1_plp, w1g36a
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: intentry
!integer(kind=iwp), intent(out) :: nlp_value
!integer(kind=iwp) :: ia, intpos, ivalue
!real(kind=wp) :: valuelptmp1, w0lp, w1lp
!
!ivalue = 0
!! G36a
!w0lp = w0_plp*w0g36a
!w1lp = w1_plp*w1g36a
!valuelptmp1 = w0lp
!w0lp = w0lp-w1lp
!w1lp = valuelptmp1+w1lp
!do intpos=intentry,intentry+ip2_intsymspace-3,3
!  !intpos = intentry+lpext_int_index(ii)*3-3
!  ivalue = ivalue+1
!  ! ArBr -- B^rA^r =10
!  value_lpext(ivalue) = vint_ci(intpos+2)*w0lp+vint_ci(intpos+1)*w1lp
!end do
!! G36b
!! G1415
!if (logic_g13) then
!  w0lp = w0g13a*(w0_plp+w1_plp)
!  intpos = intentry+ip2_intsymspace
!  do ia=1,norb_ext
!    ivalue = ivalue+1
!    value_lpext(ivalue) = w0lp*vint_ci(intpos) !-vint_ci(intpos+1)*Two)
!    intpos = intpos+2
!  end do
!end if
!nlp_value = ivalue
!
!end subroutine lp_arbr_ext_svtv_calcuvalue

!subroutine lp_drr_ext_svtv_calcuvalue(intentry,nlp_value)
!
!use gugaci_global, only: logic_g13, value_lpext, vint_ci, w0_plp, w0g13a, w0g36a, w1_plp
!use Constants, only: Half
!use Definitions, only: wp, iwp
!
!implicit none
!integer(kind=iwp), intent(in) :: intentry
!integer(kind=iwp), intent(out) :: nlp_value
!integer(kind=iwp) :: intpos, ivalue
!real(kind=wp) :: w0lp
!
!ivalue = 0
!!G36a
!w0lp = (w0_plp+w1_plp)*w0g36a
!do intpos=intentry,intentry+ip2_drl_drl_intspace-2,2         !seve
!  !intpos = intentry+lpext_int_index(ii)*3-3
!  ivalue = ivalue+1
!  value_lpext(ivalue) = vint_ci(intpos)*w0lp !-vint_ci(intpos)*w1lp      !severe_error_1111
!end do
!
!if (logic_g13) then
!  !intpos = intentry+ip2_drl_drlintstart
!  w0lp = Half*w0_plp*w0g13a
!  !isma = ism_g1415
!  !na_tmp = nlsm_ext(isma)
!  do intpos=intentry+ip2_drl_drl_intspace,intentry+ip2_drl_intspace-2,2         !severe_new_e
!    !do ia=1,na_tmp
!    ivalue = ivalue+1
!    value_lpext(ivalue) = vint_ci(intpos+1)*w0lp !+vint_ci(intpos+1)*w1lp
!    !intpos = intpos+2
!  end do
!end if
!nlp_value = ivalue
!
!end subroutine lp_drr_ext_svtv_calcuvalue

subroutine lp9_drlbl_ext_calcuvalue_wyb(lri,lrk,isma)

use gugaci_global, only: ibsm_ext, intind_iaqq, nlsm_ext, norb_ext, value_lpext, vint_ci, w0_sdplp, w0_sdplp25, w0g25, w1_sdplp, &
                         w1_sdplp25
use Constants, only: Two
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrk, isma
integer(kind=iwp) :: ia, ia0, idorbint, ilpvalue, intpos, intposbase, ira, m_ia, next_sta

next_sta = ibsm_ext(isma)-1
w0_sdplp25 = (w0_sdplp-w1_sdplp)*w0g25
w1_sdplp25 = -Two*w0_sdplp*w0g25
ia0 = (lri-1)*norb_ext
idorbint = lrk*2-2
ilpvalue = 0
do m_ia=1,nlsm_ext(isma)
  ilpvalue = ilpvalue+1
  ira = m_ia+next_sta
  ia = ia0+ira
  intposbase = intind_iaqq(ia)
  intpos = intposbase+idorbint
  value_lpext(ilpvalue) = w0_sdplp25*vint_ci(intpos)+w1_sdplp25*vint_ci(intpos+1)
end do

end subroutine lp9_drlbl_ext_calcuvalue_wyb

subroutine lp8_drlbr_sum_calcuvalue_wyb(lri,lrp,lrq,isma,nv)

use gugaci_global, only: ibsm_ext, intind_iaqq, nlsm_ext, norb_ext, norb_inn, value_lpext, viasum_0, viasum_1, vint_ci, w0_sdplp, &
                         w0_sdplp25, w0g25, w1_sdplp25
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrp, lrq, isma
integer(kind=iwp), intent(out) :: nv
integer(kind=iwp) :: ia, ia0, idorbint_p, idorbint_q, ilpvalue, intpos, intposbase, ira, m_ia, next_sta
real(kind=wp), allocatable :: vint_0(:,:), vint_1(:,:)

call mma_allocate(vint_0,norb_inn,norb_ext,label='vint_0')
call mma_allocate(vint_1,norb_inn,norb_ext,label='vint_1')
vint_0(1:norb_inn,1:norb_ext) = viasum_0(1:norb_inn,1:norb_ext)
vint_1(1:norb_inn,1:norb_ext) = viasum_1(1:norb_inn,1:norb_ext)

next_sta = ibsm_ext(isma)-1
ia0 = (lri-1)*norb_ext
idorbint_q = lrq*2-2
do m_ia=1,nlsm_ext(isma)
  ira = m_ia+next_sta
  ia = ia0+ira
  intposbase = intind_iaqq(ia)
  if (lrp /= 0) then
    idorbint_p = lrp*2-2
    intpos = intposbase+idorbint_p
    vint_0(lri,ira) = vint_0(lri,ira)-vint_ci(intpos)
    vint_1(lri,ira) = vint_1(lri,ira)-vint_ci(intpos+1)
  end if
  if (lrq /= 0) then
    idorbint_q = lrq*2-2
    intpos = intposbase+idorbint_q
    vint_0(lri,ira) = vint_0(lri,ira)-vint_ci(intpos)
    vint_1(lri,ira) = vint_1(lri,ira)-vint_ci(intpos+1)
  end if
end do

w0_sdplp25 = w0_sdplp*w0g25
w1_sdplp25 = 2*w0_sdplp*w0g25

ilpvalue = 0
do m_ia=1,nlsm_ext(isma)
  ilpvalue = ilpvalue+1
  ira = m_ia+next_sta
  value_lpext(ilpvalue) = w0_sdplp25*vint_0(lri,ira)-w1_sdplp25*vint_1(lri,ira) !value_lptm
end do
nv = ilpvalue
call mma_deallocate(vint_0)
call mma_deallocate(vint_1)

end subroutine lp8_drlbr_sum_calcuvalue_wyb

subroutine lp9_drlbl_sum_calcuvalue_wyb(lri,lrp,lrq,isma,nv)

use gugaci_global, only: ibsm_ext, intind_iaqq, nlsm_ext, norb_ext, norb_inn, value_lpext, viasum_0, viasum_1, vint_ci, w0_sdplp, &
                         w0_sdplp25, w0g25, w1_sdplp25
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrp, lrq, isma
integer(kind=iwp), intent(out) :: nv
integer(kind=iwp) :: ia, ia0, idorbint_p, idorbint_q, ilpvalue, intpos, intposbase, ira, m_ia, next_sta
real(kind=wp), allocatable :: vint_0(:,:), vint_1(:,:)

call mma_allocate(vint_0,norb_inn,norb_ext,label='vint_0')
call mma_allocate(vint_1,norb_inn,norb_ext,label='vint_1')
vint_0(1:norb_inn,1:norb_ext) = viasum_0(1:norb_inn,1:norb_ext)
vint_1(1:norb_inn,1:norb_ext) = viasum_1(1:norb_inn,1:norb_ext)

next_sta = ibsm_ext(isma)-1
ia0 = (lri-1)*norb_ext
idorbint_q = lrq*2-2
do m_ia=1,nlsm_ext(isma)
  ira = m_ia+next_sta
  ia = ia0+ira
  intposbase = intind_iaqq(ia)
  if (lrp /= 0) then
    idorbint_p = lrp*2-2
    intpos = intposbase+idorbint_p
    vint_0(lri,ira) = vint_0(lri,ira)-vint_ci(intpos)
    vint_1(lri,ira) = vint_1(lri,ira)-vint_ci(intpos+1)
  end if
  if (lrq /= 0) then
    idorbint_q = lrq*2-2
    intpos = intposbase+idorbint_q
    vint_0(lri,ira) = vint_0(lri,ira)-vint_ci(intpos)
    vint_1(lri,ira) = vint_1(lri,ira)-vint_ci(intpos+1)
  end if
end do

next_sta = ibsm_ext(isma)-1
w0_sdplp25 = w0_sdplp*w0g25
w1_sdplp25 = -Two*w0_sdplp*w0g25

ilpvalue = 0
do m_ia=1,nlsm_ext(isma)
  ilpvalue = ilpvalue+1
  ira = m_ia+next_sta
  value_lpext(ilpvalue) = w0_sdplp25*vint_0(lri,ira)+w1_sdplp25*vint_1(lri,ira)
end do
nv = ilpvalue
call mma_deallocate(vint_0)
call mma_deallocate(vint_1)

end subroutine lp9_drlbl_sum_calcuvalue_wyb

subroutine lp_drl_ext_dd_calcuvalue_wyb(lri,iml,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, int_dd_drl, intind_abkk, logic_g49b, nlsm_ext, norb_number, value_lpext, vint_ci, &
                         voint, w0_plp, w0gdd, w1_plp, w1gdd
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, iml
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: i, iaend, iasta, intpos, intpos0, ira, ivalue, jvalue, lra, mloop, nliml
real(kind=wp) :: w0lp, w1lp

w0lp = w0_plp*w0gdd
w1lp = w1_plp*w1gdd
nliml = nlsm_ext(iml)
iasta = ibsm_ext(iml)
iaend = iesm_ext(iml)
intpos0 = intind_abkk(lri)
ivalue = 0
jvalue = 0
if (logic_g49b) then
  do ira=iasta,iaend
    ivalue = ivalue+1
    lra = norb_number(ira)
    value_lpext(ivalue) = -w1lp*voint(lra,lri)
  end do
end if
mloop = nliml*(nliml-1)/2
intpos = intpos0+int_dd_drl*2
ivalue = ivalue+int_dd_drl
do I=1,mloop
  ivalue = ivalue+1
  jvalue = ivalue+mloop
  value_lpext(ivalue) = w0lp*vint_ci(intpos+1)-w1lp*vint_ci(intpos)
  value_lpext(jvalue) = value_lpext(ivalue)
  intpos = intpos+2
end do
nlp_value = jvalue

end subroutine lp_drl_ext_dd_calcuvalue_wyb

subroutine lp_arbl_ext_dd_calcuvalue(lri,lrj,iml,imr,nlp_value)

use gugaci_global, only: ibsm_ext, int_dd_drl, intind_ijab, intind_ijcc, logic_g49a, logic_g49b, logic_g50, ngw2, nlsm_ext, &
                         norb_frz, value_lpext, vint_ci, w0_plp, w0gdd, w1_plp, w1gdd
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj, iml, imr
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: i, ij, intentry, intoffset, intpos, ivalue, mcloop, nlbf, nliml, nlimr
real(kind=wp) :: valuetmp1, w0lp, w1lp

ij = lri-norb_frz+ngw2(lrj-norb_frz)
nliml = nlsm_ext(iml)
nlbf = ibsm_ext(iml)-1
intoffset = 2*nlbf
nlimr = nlsm_ext(imr)
w0lp = w0_plp*w0gdd
w1lp = w1_plp*w1gdd
valuetmp1 = w0lp
w0lp = w0lp-w1lp
w1lp = -valuetmp1*Two
ivalue = 0
! G50
if (logic_g50) then
  intentry = intind_ijcc(ij)

  mcloop = nliml
  intpos = intentry+intoffset
  do I=1,mcloop
    ivalue = ivalue+1
    value_lpext(ivalue) = vint_ci(intpos)*w0lp+vint_ci(intpos+1)*w1lp
    intpos = intpos+2
  end do
end if

intentry = intind_ijab(ij)
mcloop = nliml*nlimr
if (iml == imr) mcloop = nliml*(nliml-1)/2
intpos = intentry
ivalue = ivalue
intoffset = int_dd_drl*3
intpos = intentry+intoffset
ivalue = ivalue+int_dd_drl
if (logic_g49a) then
  ! G49a:Bl_Ar  line=12
  do i=1,mcloop
    ivalue = ivalue+1
    value_lpext(ivalue) = vint_ci(intpos+2)*w0lp+vint_ci(intpos)*w1lp
    intpos = intpos+3
  end do
end if
! G49b:Br_Al  line=11
intpos = intentry+intoffset
if (logic_g49b) then
  do i=1,mcloop
    ivalue = ivalue+1
    value_lpext(ivalue) = vint_ci(intpos+1)*w0lp+vint_ci(intpos)*w1lp
    intpos = intpos+3
  end do
end if
nlp_value = ivalue

end subroutine lp_arbl_ext_dd_calcuvalue

subroutine lp_ar_coe_calcuvalue_wyb(idtu,isma,lri,lrj,nlp_value,lpcoe)

use gugaci_global, only: ibsm_ext, intind_iaqq, jb_sys, logic_dh, nlsm_ext, norb_dz, norb_ext, norb_inn, norb_number, value_lpext, &
                         vint_ci, voint, w0_sdplp, w0_sdplp25, w0g25
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: idtu, isma, lri, lrj, lpcoe(norb_dz+1:norb_inn)
integer(kind=iwp), intent(out) :: nlp_value
real(kind=wp) :: valuetmp
integer(kind=iwp) :: ia, ia0, icoe, idorb, idorbint, ilpvalue, intpos, intposbase, iorb, iorbs, ira, kcoe, lend, lra, lsta, m_ia, &
                     ndorb, next_sta, nocc, nsorb
real(kind=wp) :: tcoe

! idtu=25,26,28,25(43),46,51,100(in act_space)

next_sta = ibsm_ext(isma)-1
w0_sdplp25 = w0_sdplp*w0g25
ia0 = (lri-1)*norb_ext
!idorbint = lri*2-2
!intpos = intposbase+idorbint
ilpvalue = 0
!intposbase = intentry

if (idtu == 100) then
  lsta = lri
  lend = norb_inn
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    valuetmp = voint(lri,lra)
    !valuetmp = Zero
    ia = ia0+ira
    intposbase = intind_iaqq(ia)
    do iorb=lsta,lend
      kcoe = lpcoe(iorb)
      call neoc(kcoe,nocc,tcoe)
      idorbint = (iorb-1)*2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
      !wl = wl+neoc(k)*vlop0*(vint(list+2)+coe(k)*vint(list+1))
    end do
    ilpvalue = ilpvalue+1
    value_lpext(ilpvalue) = w0_sdplp25*valuetmp
  end do
  nlp_value = nlsm_ext(isma)
  return
end if

if (idtu == 51) then
  ndorb = norb_dz-lri
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    valuetmp = voint(lri,lra)
    !valuetmp = Zero
    ia = ia0+ira
    intposbase = intind_iaqq(ia)
    idorbint = -2
    if (logic_dh) then
      idorbint = lri*2-2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+vint_ci(intpos)
      do idorb=1,ndorb
        idorbint = idorbint+2
        intpos = intposbase+idorbint
        valuetmp = valuetmp+Two*vint_ci(intpos+1)-vint_ci(intpos)
      end do
    end if
    iorbs = max(norb_dz+1,lri)
    do iorb=iorbs,norb_inn
      kcoe = lpcoe(iorb)
      call neoc(kcoe,nocc,tcoe)
      idorbint = iorb*2-2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
      !wl = wl+neoc(k)*vlop0*(vint(list+2)+coe(k)*vint(list+1))
    end do
    ilpvalue = ilpvalue+1
    value_lpext(ilpvalue) = w0_sdplp25*valuetmp
  end do
  nlp_value = nlsm_ext(isma)
  return
end if

if ((idtu == 25) .or. (idtu == 43)) then
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    valuetmp = voint(lri,lra)
    !valuetmp = Zero
    ia = ia0+ira
    intposbase = intind_iaqq(ia)
    idorbint = lri*2-2
    intpos = intposbase+idorbint
    valuetmp = valuetmp+vint_ci(intpos)
    do idorb=lri+1,norb_dz
      idorbint = idorbint+2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+Two*vint_ci(intpos+1)-vint_ci(intpos)
    end do
    iorbs = max(norb_dz+1,lri)
    do iorb=iorbs,norb_inn
      kcoe = lpcoe(iorb)
      call neoc(kcoe,nocc,tcoe)
      idorbint = iorb*2-2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
      !wl = wl+neoc(k)*vlop0*(vint(list+2)+coe(k)*vint(list+1))
    end do
    ilpvalue = ilpvalue+1
    value_lpext(ilpvalue) = w0_sdplp25*valuetmp
  end do
  nlp_value = nlsm_ext(isma)
  return
end if

if (idtu == 26) then
  ndorb = norb_dz-lri
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    valuetmp = voint(lri,lra)              !310
    ia = ia0+ira
    intposbase = intind_iaqq(ia)
    idorbint = lri*2-2
    if (logic_dh) then
      do idorb=1,ndorb
        idorbint = idorbint+2
        intpos = intposbase+idorbint
        valuetmp = valuetmp+2.d0*vint_ci(intpos+1)-vint_ci(intpos)
      end do
    end if
    do iorb=norb_dz+1,norb_inn
      kcoe = lpcoe(iorb)
      call neoc(kcoe,nocc,tcoe)
      idorbint = idorbint+2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
      !wl = wl+neoc(k)*vlop0*(vint(list+2)+coe(k)*vint(list+1))
    end do

    ilpvalue = ilpvalue+1
    value_lpext(ilpvalue) = w0_sdplp25*valuetmp
  end do
  nlp_value = nlsm_ext(isma)
  return
end if

if ((idtu == 28) .or. (idtu == 46)) then
  nsorb = 1
  ndorb = norb_dz-lri-1
  if (ndorb > 0) nsorb = 1
  if (idtu == 28) then
    icoe = -(jb_sys+2)
  else !if (idtu == 46)
    icoe = 0
  end if
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    ia = ia0+ira
    intposbase = intind_iaqq(ia)
    idorbint = lri*2-2
    intpos = intposbase+idorbint
    valuetmp = voint(lri,lra)+vint_ci(intpos)        ! 310+710
    if (nsorb > 0) then
      do iorb=lri+1,norb_dz
        idorbint = idorbint+2
        intpos = intposbase+idorbint
        if (iorb == lrj) valuetmp = valuetmp+vint_ci(intpos+1)+icoe*vint_ci(intpos)
        if (iorb /= lrj) valuetmp = valuetmp+Two*vint_ci(intpos+1)-vint_ci(intpos)
      end do
    end if
    do iorb=norb_dz+1,norb_inn
      kcoe = lpcoe(iorb)
      call neoc(kcoe,nocc,tcoe)
      idorbint = idorbint+2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
      !wl = wl+neoc(k)*vlop0*(vint(list+2)+coe(k)*vint(list+1))
    end do

    ilpvalue = ilpvalue+1
    value_lpext(ilpvalue) = w0_sdplp25*valuetmp
    intposbase = intposbase+norb_inn*2
  end do
  nlp_value = nlsm_ext(isma)
  return
end if

if ((idtu == 57) .or. (idtu == 29)) then
  nsorb = 1
  ndorb = norb_dz-lri-1
  if (ndorb > 0) nsorb = 1
  if (idtu == 29) then
    icoe = jb_sys
  else !if (idtu == 57)
    icoe = -1
  end if
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    ia = ia0+ira
    intposbase = intind_iaqq(ia)
    idorbint = lri*2-2
    intpos = intposbase+idorbint
    valuetmp = voint(lri,lra)+vint_ci(intpos)        ! 310+710
    if (nsorb > 0) then
      do iorb=lri+1,norb_dz
        idorbint = idorbint+2
        intpos = intposbase+idorbint
        if (iorb == lrj) valuetmp = valuetmp+vint_ci(intpos+1)+icoe*vint_ci(intpos)
        if (iorb /= lrj) valuetmp = valuetmp+Two*vint_ci(intpos+1)-vint_ci(intpos)
      end do
    end if
    do iorb=norb_dz+1,norb_inn
      kcoe = lpcoe(iorb)
      call neoc(kcoe,nocc,tcoe)
      idorbint = idorbint+2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
      !wl = wl+neoc(k)*vlop0*(vint(list+2)+coe(k)*vint(list+1))
    end do

    ilpvalue = ilpvalue+1
    value_lpext(ilpvalue) = w0_sdplp25*valuetmp
    intposbase = intposbase+norb_inn*2
  end do
  nlp_value = nlsm_ext(isma)
  return
end if
!=======================================================================
if ((idtu == 55) .or. (idtu == 73)) then    !(11)(23)=55 (11)(13)=75
  do m_ia=1,nlsm_ext(isma)
    ira = m_ia+next_sta
    lra = norb_number(ira)
    valuetmp = voint(lri,lra)
    !valuetmp = Zero
    ia = ia0+ira
    intposbase = intind_iaqq(ia)
    idorbint = lri*2-2
    intpos = intposbase+idorbint
    valuetmp = valuetmp+vint_ci(intpos)
    do idorb=lri+1,norb_dz
      idorbint = idorbint+2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+Two*vint_ci(intpos+1)-vint_ci(intpos)
    end do
    iorbs = max(norb_dz+1,lri)
    do iorb=iorbs,norb_inn
      kcoe = lpcoe(iorb)
      call neoc(kcoe,nocc,tcoe)
      idorbint = iorb*2-2
      intpos = intposbase+idorbint
      valuetmp = valuetmp+nocc*(vint_ci(intpos+1)+tcoe*vint_ci(intpos))
      !wl = wl+neoc(k)*vlop0*(vint(list+2)+coe(k)*vint(list+1))
    end do
    ilpvalue = ilpvalue+1
    value_lpext(ilpvalue) = w0_sdplp25*valuetmp
  end do
  nlp_value = nlsm_ext(isma)
  return
end if

end subroutine lp_ar_coe_calcuvalue_wyb

subroutine lp_drl_ext_SS_calcuvalue(lri,nlp_value)

use gugaci_global, only: intind_abkk, intspace_abkk, logic_g2g4a, value_lpext, vint_ci, w0_plp, w0g2a, w0g36a, w1_plp, w1g2a, w1g36a
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: i, intpos, intspace, ivalue
real(kind=wp) :: w0lp, w1lp

intpos = intind_abkk(lri)
intspace = intspace_abkk(lri)
ivalue = 0

! G2G4b
if (logic_g2g4a) then
  w0lp = w0_plp*w0g2a
  w1lp = w1_plp*w1g2a
  !ww0lp = w0_plp*w0g4a
  !ww1lp = w1_plp*w1g4a

  !valuelptmp1 = w0lp
  !w0lp = w0lp-w1lp
  !w1lp = -valuelptmp1*Two
  !valuelptmp1 = ww0lp
  !ww0lp = ww0lp-ww1lp
  !ww1lp = -valuelptmp1*Two

  do i=1,intspace
    ivalue = ivalue+2
    ! Drl -- B^lA^r =4_3
    value_lpext(ivalue) = vint_ci(intpos+1)*w0lp-vint_ci(intpos)*w1lp
    ! Drl -- B^rA^l =4_2
    value_lpext(ivalue-1) = (w0lp-w1lp)*vint_ci(intpos)
    intpos = intpos+2
  end do
end if

intpos = intind_abkk(lri)
w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a

do I=1,intspace
  ivalue = ivalue+1
  value_lpext(ivalue) = vint_ci(intpos+1)*w0lp-vint_ci(intpos)*w1lp
  intpos = intpos+2
end do
nlp_value = ivalue

end subroutine lp_drl_ext_SS_calcuvalue

subroutine lp_drl_sum_SS_calcuvalue(lri,lrj,nlp_value)

use gugaci_global, only: intind_abkk, intspace_abkk, logic_g2g4a, value_lpext, vijkk_0sum, vijkk_1sum, vint_ci, w0_plp, w0g2a, &
                         w0g36a, w1_plp, w1g2a, w1g36a
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: i, intpos, intspace, ivalue
real(kind=wp) :: w0lp, w1lp
real(kind=wp), allocatable :: vint_0(:), vint_1(:)

intspace = intspace_abkk(1)
call mma_allocate(vint_0,intspace,label='vint_0')
call mma_allocate(vint_1,intspace,label='vint_1')
vint_0(1:intspace) = vijkk_0sum(1:intspace)
vint_1(1:intspace) = vijkk_1sum(1:intspace)

if (lri /= 0) then
  intpos = intind_abkk(lri)
  do I=1,intspace
    vint_0(I) = vint_0(I)-vint_ci(intpos)
    vint_1(I) = vint_1(I)-vint_ci(intpos+1)
    intpos = intpos+2
  end do
end if
if (lrj /= 0) then
  intpos = intind_abkk(lrj)
  do I=1,intspace
    vint_0(I) = vint_0(I)-vint_ci(intpos)
    vint_1(I) = vint_1(I)-vint_ci(intpos+1)
    intpos = intpos+2
  end do
end if

ivalue = 0
! G2G4b
if (logic_g2g4a) then
  w0lp = w0_plp*w0g2a
  w1lp = w1_plp*w1g2a
  do i=1,intspace
    ivalue = ivalue+2
    ! Drl -- B^lA^r =4_3
    value_lpext(ivalue) = vint_1(i)*w0lp-vint_0(i)*w1lp
    ! Drl -- B^rA^l =4_2
    value_lpext(ivalue-1) = (w0lp-w1lp)*vint_0(i)
  end do
end if

w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a

do I=1,intspace
  ivalue = ivalue+1
  value_lpext(ivalue) = vint_1(i)*w0lp-vint_0(i)*w1lp
end do

w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a

do I=1,intspace
  ivalue = ivalue+1
  value_lpext(ivalue) = vint_1(i)*w0lp-vint_0(i)*w1lp
end do
nlp_value = ivalue
call mma_deallocate(vint_0)
call mma_deallocate(vint_1)

end subroutine lp_drl_sum_SS_calcuvalue

subroutine lp_drl_ext_ST_calcuvalue(lri,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_abkk, intspace_abkk, ism_g1415, logic_g1415, logic_g2g4b, ng_sm, norb_number, &
                         value_lpext, vint_ci, voint, w1_plp, w1g14a, w1g36a, w1g4b
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, intpos, intspace, isma, ismb, ivalue, lra, lrb
real(kind=wp) :: w1lp

ivalue = 0
! G1415
if (logic_g1415) then

  w1lp = w1_plp*w1g14a

  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        lra = norb_number(ia)
        ivalue = ivalue+1
        !value_lpext(ivalue) = vint_ci(intposia)*ww0lp+vint_ci(intposia+1)*ww1lp+valuelpib
        ! OK,only for Spin=0
        value_lpext(ivalue) = (voint(lra,lri)-voint(lrb,lri))*w1lp
      end do
    end do
  end do
end if

intpos = intind_abkk(lri)
intspace = intspace_abkk(lri)
! G2G4b
if (logic_g2g4b) then
  w1lp = w1_plp*w1g4b

  do i=1,intspace
    ivalue = ivalue+2
    ! Drl -- B^lA^r =4_3
    value_lpext(ivalue) = w1lp*vint_ci(intpos)
    ! Drl -- B^rA^l =4_2
    value_lpext(ivalue-1) = -value_lpext(ivalue)
    intpos = intpos+2
  end do
end if

intpos = intind_abkk(lri)
w1lp = w1_plp*w1g36a

do I=1,intspace
  ivalue = ivalue+1
  value_lpext(ivalue) = -vint_ci(intpos)*w1lp
  intpos = intpos+2
end do
nlp_value = ivalue

end subroutine lp_drl_ext_ST_calcuvalue

subroutine lp_drl_ext_TT_calcuvalue(lri,n1415_value,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_abkk, intspace_abkk, ism_g1415, logic_g1415, ng_sm, norb_number, value_lpext, &
                         vint_ci, voint, w0_plp, w0g14a, w0g15a, w0g36a, w1_plp, w1g14a, w1g15a, w1g36a
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: n1415_value, nlp_value
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, intpos, intspace, isma, ismb, ivalue, lra, lrb
real(kind=wp) :: w014, w015, w0lp, w114, w115, w14lp, w15lp, w1lp

ivalue = 0
! G1415
if (logic_g1415) then

  w014 = w0_plp*w0g14a
  w114 = w1_plp*w1g14a
  w015 = w0_plp*w0g15a
  w115 = w1_plp*w1g15a

  w14lp = w014-w114
  w15lp = w015-w115

  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        lra = norb_number(ia)
        ivalue = ivalue+1
        value_lpext(ivalue) = w15lp*voint(lra,lri)+w14lp*voint(lrb,lri)
      end do
    end do
  end do
end if

n1415_value = ivalue
intpos = intind_abkk(lri)
intspace = intspace_abkk(lri)

w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a

do I=1,intspace
  ivalue = ivalue+1
  value_lpext(ivalue) = vint_ci(intpos+1)*w0lp-vint_ci(intpos)*w1lp
  intpos = intpos+2
end do
nlp_value = ivalue

end subroutine lp_drl_ext_TT_calcuvalue

subroutine lp_drl_sum_TT_calcuvalue(lri,lrj,n1415,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_abkk, intspace_abkk, ism_g1415, logic_g1415, ng_sm, norb_dz, norb_number, &
                         value_lpext, vijkk_0sum, vijkk_1sum, vint_ci, voint, w0_plp, w0g14a, w0g15a, w0g36a
use stdalloc, only: mma_allocate, mma_deallocate
use Symmetry_Info, only: Mul
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: n1415, nlp_value
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, intpos, intspace, isma, ismb, ivalue, lra, lrb, lrk, lrk0
real(kind=wp) :: w014, w015, w0lp, w14lp, w15lp
real(kind=wp), allocatable :: vint_0(:), vint_1(:)

intspace = intspace_abkk(1)
call mma_allocate(vint_0,intspace,label='vint_0')
call mma_allocate(vint_1,intspace,label='vint_1')
vint_0(1:intspace) = vijkk_0sum(1:intspace)
vint_1(1:intspace) = vijkk_1sum(1:intspace)

if (lri /= 0) then
  intpos = intind_abkk(lri)
  do I=1,intspace
    vint_0(I) = vint_0(I)-vint_ci(intpos)
    vint_1(I) = vint_1(I)-vint_ci(intpos+1)
    intpos = intpos+2
  end do
end if
if (lrj /= 0) then
  intpos = intind_abkk(lrj)
  do I=1,intspace
    vint_0(I) = vint_0(I)-vint_ci(intpos)
    vint_1(I) = vint_1(I)-vint_ci(intpos+1)
    intpos = intpos+2
  end do
end if

lrk0 = 1
if (lri == 1) lrk0 = 2
if (lrj == 2) lrk0 = 3
ivalue = 0
! G1415
if (logic_g1415) then

  w014 = w0_plp*w0g14a
  w015 = w0_plp*w0g15a

  w14lp = w014
  w15lp = w015

  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      lrb = norb_number(ib)
      do ia=iasta,min(iaend,ib-1)
        lra = norb_number(ia)
        ivalue = ivalue+1
        value_lpext(ivalue) = w15lp*voint(lra,lrk0)+w14lp*voint(lrb,lrk0)
        do lrk=lrk0+1,norb_dz
          if (lrk == lri) cycle
          if (lrk == lrj) cycle
          value_lpext(ivalue) = value_lpext(ivalue)+w15lp*voint(lra,lrk)+w14lp*voint(lrb,lrk)
        end do
      end do
    end do
  end do
end if

n1415 = ivalue
w0lp = w0_plp*w0g36a

do I=1,intspace
  ivalue = ivalue+1
  value_lpext(ivalue) = vint_1(I)*w0lp
end do
nlp_value = ivalue
call mma_deallocate(vint_0)
call mma_deallocate(vint_1)

end subroutine lp_drl_sum_TT_calcuvalue

subroutine lp_arbr_ext_svtv_calcuvalue_wyb(lri,lrj,nlp_value)

use gugaci_global, only: intind_ijab, intind_ijcc, intspace_ijab, intspace_ijcc, logic_g13, ngw2, norb_frz, value_lpext, vint_ci, &
                         w0_plp, w0g13a, w0g36a, w1_plp, w1g36a
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: i, ij, intentry, intpos, intspace, ivalue
real(kind=wp) :: valuelptmp1, w0lp, w1lp

ij = lri-norb_frz+ngw2(lrj-norb_frz)
intentry = intind_ijab(ij)
intspace = intspace_ijab(ij)
ivalue = 0
intpos = intentry
! G36a
w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a
valuelptmp1 = w0lp
w0lp = w0lp-w1lp
w1lp = valuelptmp1+w1lp
! ArBr -- B^rA^r =10
do i=1,intspace
  ivalue = ivalue+1
  value_lpext(ivalue) = vint_ci(intpos+2)*w0lp+vint_ci(intpos+1)*w1lp
  intpos = intpos+3
end do
! G36b
! G1415
if (logic_g13) then
  intentry = intind_ijcc(ij)
  intpos = intentry
  intspace = intspace_ijcc(ij)
  w0lp = w0g13a*(w0_plp+w1_plp)
  do i=1,intspace
    ivalue = ivalue+1
    ! ArBr -- D^r^r
    value_lpext(ivalue) = w0lp*vint_ci(intpos)
    intpos = intpos+2
  end do
end if
nlp_value = ivalue

end subroutine lp_arbr_ext_svtv_calcuvalue_wyb

subroutine lp_drr_ext_svtv_calcuvalue_wyb(lri,nlp_value)

use gugaci_global, only: intind_abkk, intspace_abkk, logic_g13, norb_all, norb_inn, value_lpext, vint_ci, voint, w0_plp, w0g13a, &
                         w0g36a, w1_plp
use Constants, only: Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: i, intpos, intspace, ivalue, lra
real(kind=wp) :: w0lp

intpos = intind_abkk(lri)
intspace = intspace_abkk(lri)
ivalue = 0
! G36a
w0lp = (w0_plp+w1_plp)*w0g36a
do I=1,intspace
  ivalue = ivalue+1
  value_lpext(ivalue) = vint_ci(intpos)*w0lp
  intpos = intpos+2
end do

if (logic_g13) then
  w0lp = Half*w0_plp*w0g13a
  do lra=norb_all,norb_inn+1,-1
    ivalue = ivalue+1
    value_lpext(ivalue) = voint(lra,lri)*w0lp
  end do
end if
nlp_value = ivalue

end subroutine lp_drr_ext_svtv_calcuvalue_wyb

subroutine lp_arbl_ext_st_calcuvalue(lri,lrj,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_ijab, intind_ijcc, intspace_ijab, intspace_ijcc, ism_g1415, logic_g13, &
                         logic_g1415, logic_g2g4a, logic_g2g4b, ng_sm, ngw2, norb_ext, norb_frz, value_lpext, vint_ci, w0_plp, &
                         w0g13a, w0g14a, w0g15a, w0g2a, w0g2b, w0g36a, w0g36b, w0g4a, w0g4b, w1_plp, w1g14a, w1g15a, w1g2a, w1g2b, &
                         w1g36a, w1g36b, w1g4a, w1g4b
use Symmetry_Info, only: Mul
use Constants, only: Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrj
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: i, ia, iaend, iasta, ib, ibend, ibsta, ij, intpos, intpos13, intposia, intposib, intspace, isma, ismb, ivalue
real(kind=wp) :: valp, valuelpib, valuelptmp1, w0lp, w1lp, ww0lp, ww1lp

ivalue = 0
ij = lri-norb_frz+ngw2(lrj-norb_frz)
intpos = intind_ijcc(ij)
intspace = intspace_ijcc(ij)
!lmij = Mul(lsm_inn(lri),lsm_inn(lrj))
! G1415
if (logic_g1415) then

  w0lp = w0_plp*w0g14a
  w1lp = w1_plp*w1g14a
  ww0lp = w0_plp*w0g15a
  ww1lp = w1_plp*w1g15a

  valuelptmp1 = w0lp
  w0lp = w0lp-w1lp
  w1lp = -valuelptmp1*Two
  valuelptmp1 = ww0lp
  ww0lp = ww0lp-ww1lp
  ww1lp = -valuelptmp1*Two

  do ismb=1,ng_sm
    isma = Mul(ismb,ism_g1415)
    if (isma > ismb) cycle
    !lmab = Mul(isma,ismb)
    !if (lmab /= lmij) cycle
    ibsta = ibsm_ext(ismb)
    ibend = iesm_ext(ismb)
    iasta = ibsm_ext(isma)
    iaend = iesm_ext(isma)
    if (ismb == isma) ibsta = ibsta+1
    do ib=ibsta,ibend
      intposib = intpos+ib*2-2
      valuelpib = vint_ci(intposib)*w0lp+vint_ci(intposib+1)*w1lp
      do ia=iasta,min(iaend,ib-1)
        intposia = intpos+ia*2-2
        ivalue = ivalue+1
        valp = vint_ci(intposia)*ww0lp+vint_ci(intposia+1)*ww1lp
        value_lpext(ivalue) = valp+valuelpib
      end do
    end do
  end do
end if
! G13
if (logic_g13) then
  w0lp = w0g13a*w0_plp
  do ia=1,norb_ext
    intpos13 = intpos+ia*2-2
    ivalue = ivalue+1
    value_lpext(ivalue) = w0lp*(vint_ci(intpos13)-vint_ci(intpos13+1)*Two)
    intpos13 = intpos13+2
  end do
end if

intspace = intspace_ijab(ij)
! G2G4a
if (logic_g2g4a) then
  intpos = intind_ijab(ij)

  w0lp = w0_plp*w0g2a
  w1lp = w1_plp*w1g2a
  ww0lp = w0_plp*w0g4a
  ww1lp = w1_plp*w1g4a

  valuelptmp1 = w0lp
  w0lp = w0lp-w1lp
  w1lp = -valuelptmp1*Two
  valuelptmp1 = ww0lp
  ww0lp = ww0lp-ww1lp
  ww1lp = -valuelptmp1*Two

  do i=1,intspace
    ivalue = ivalue+2
    ! ArBl -- B^lA^r =12
    value_lpext(ivalue-1) = vint_ci(intpos+2)*w0lp+vint_ci(intpos)*w1lp
    ! ArBl -- B^rA^l =11
    value_lpext(ivalue) = vint_ci(intpos+1)*ww0lp+vint_ci(intpos)*ww1lp
    intpos = intpos+3
  end do
else
  ! G2G4b
  if (logic_g2g4b) then
    intpos = intind_ijab(ij)
    w0lp = w0_plp*w0g2b
    w1lp = w1_plp*w1g2b
    ww0lp = w0_plp*w0g4b
    ww1lp = w1_plp*w1g4b

    valuelptmp1 = w0lp
    w0lp = w0lp-w1lp
    w1lp = -valuelptmp1*Two
    valuelptmp1 = ww0lp
    ww0lp = ww0lp-ww1lp
    ww1lp = -valuelptmp1*Two

    do i=1,intspace
      ivalue = ivalue+2
      ! ArBl -- B^lA^r =12
      value_lpext(ivalue-1) = vint_ci(intpos+2)*ww0lp+vint_ci(intpos)*ww1lp
      ! ArBl -- B^rA^l =11
      value_lpext(ivalue) = vint_ci(intpos+1)*w0lp+vint_ci(intpos)*w1lp
      intpos = intpos+3
    end do
  end if

end if
! G36a
intpos = intind_ijab(ij)
w0lp = w0_plp*w0g36a
w1lp = w1_plp*w1g36a
valuelptmp1 = w0lp
w0lp = w0lp-w1lp
w1lp = -valuelptmp1*Two
do i=1,intspace
  ivalue = ivalue+1
  ! ArBl -- B^lA^r =12
  value_lpext(ivalue) = vint_ci(intpos+2)*w0lp+vint_ci(intpos)*w1lp
  intpos = intpos+3
end do
! G36b
intpos = intind_ijab(ij)
w0lp = w0_plp*w0g36b
w1lp = w1_plp*w1g36b
valuelptmp1 = w0lp
w0lp = w0lp-w1lp
w1lp = -valuelptmp1*Two
do i=1,intspace
  ivalue = ivalue+1
  ! ArBl -- B^rA^l =11
  value_lpext(ivalue) = vint_ci(intpos+1)*w0lp+vint_ci(intpos)*w1lp
  intpos = intpos+3
end do
nlp_value = ivalue

end subroutine lp_arbl_ext_st_calcuvalue

! lp7_ar_drl,lp7_drr_br,lp8_drl_br

subroutine lp678_ext_wyb_calcuvalue(lri,lrk,isma,nlp_value)

use gugaci_global, only: ibsm_ext, iesm_ext, intind_iaqq, nlsm_ext, norb_ext, value_lpext, vint_ci, w0_sdplp, w0_sdplp25, w0g25
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: lri, lrk, isma
integer(kind=iwp), intent(out) :: nlp_value
integer(kind=iwp) :: ia, ia0, iaend, iaqq, iasta, ilpvalue, intoffset, intpos, iposint

w0_sdplp25 = w0_sdplp*w0g25
ia0 = (lri-1)*norb_ext
intoffset = (lrk-1)*2
ilpvalue = 0
iasta = ibsm_ext(isma)
iaend = iesm_ext(isma)
do ia=iasta,iaend
  iaqq = ia0+ia
  intpos = intind_iaqq(iaqq)
  iposint = intpos+intoffset
  ilpvalue = ilpvalue+1
  value_lpext(ilpvalue) = w0_sdplp25*vint_ci(iposint)
end do
nlp_value = nlsm_ext(isma)

end subroutine lp678_ext_wyb_calcuvalue

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine OFE_print(Energy_A)

use OFembed, only: dFMD, Energy_NAD, Func_A, Func_AB, Func_B, Rep_EN, V_emb, V_Nuc_AB, V_Nuc_BA
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
real(kind=wp), intent(in) :: Energy_A
integer(kind=iwp) :: iTol, nAtoms, nSym
real(kind=wp) :: Ec_A, Energy_B, ZRE_nad
character(len=16) :: NamRfil
real(kind=wp), allocatable :: ReCharge(:)
integer(kind=iwp), external :: Cho_X_GetTol

call Get_iScalar('nSym',nSym)
call Get_iScalar('Unique atoms',nAtoms)
call mma_allocate(ReCharge,nAtoms,label='ReCharge')
call Get_dArray('Effective nuclear Charge',ReCharge,nAtoms)

call Get_NameRun(NamRfil)
call NameRun('AUXRFIL')
call PotNuc_nad(nSym,nAtoms,ReCharge,ZRE_nad)
call mma_deallocate(ReCharge)

call Get_dEnergy(Energy_B)
if (dFMD > Zero) call Get_dScalar('KSDFT energy',Ec_A)

call NameRun(NamRfil)

iTol = Cho_X_GetTol(8)
call Add_Info('V_OFE',[V_emb],1,iTol)
call Add_Info('V_NUC',[V_Nuc_AB],1,iTol)
call Add_Info('E_NAD',[Energy_NAD],1,iTol)
call Add_Info('RP_EN',[Rep_EN],1,iTol)

write(u6,*)
write(u6,*) '     -----------------------------------------------'
write(u6,*) '      Orbital-Free Embedding Calculation : Results  '
write(u6,*) '     -----------------------------------------------'
write(u6,100) '        DFT energy  (A)    : ',Func_A
write(u6,100) '        DFT energy  (B)    : ',Func_B
write(u6,100) '        DFT energy (A+B)   : ',Func_AB
write(u6,*)
write(u6,100) '        Nonelectr. Vemb    : ',V_emb ! for <A|Vq|A>
write(u6,*)
write(u6,100) '        Energy (A)         : ',Energy_A
write(u6,100) '        Energy (B)         : ',Energy_B
write(u6,100) '        DFT energy (NAD)   : ',Energy_NAD
write(u6,100) '        Vnuc(B)*rhoA       : ',V_Nuc_AB
write(u6,100) '        Vnuc(A)*rhoB       : ',V_Nuc_BA
write(u6,100) '        Electr. repulsion  : ',Rep_EN
write(u6,*) '     -----------------------------------------------'
write(u6,100) '       Nuclear rep. (A--B) : ',ZRE_nad
write(u6,100) '       Energy (A+B)        : ',Energy_B+Energy_A+Energy_NAD+V_Nuc_AB+V_Nuc_BA+Rep_EN+ZRE_nad
if (dFMD > Zero) write(u6,100) '       SCF restoring Ec(A) : ',Ec_A
write(u6,*) '     -----------------------------------------------'
write(u6,*)
write(u6,*)

call Put_dScalar('NAD dft energy',Energy_NAD)

return

100 format(A,F19.10)

end subroutine OFE_print

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2019, Ignacio Fdez. Galvan                             *
************************************************************************
      Subroutine NewCar_Kriging(kIter,nLines,nAtom,nDim,nInter,BMx,
     &                          dMass,Lbl,kShift,qInt,dqInt,Name,Cx,
     &                          SaveBMx,RefIter)
      Implicit None
#include "info_slapaf.fh"
#include "db.fh"
#include "stdalloc.fh"
#include "WrkSpc.fh"
      Integer :: kIter,nLines,nAtom,nDim,nInter,RefIter
      Real*8 :: BMx(3*nAtom,nInter),dMass(nAtom),kShift(nInter,kIter),
     &          qInt(nInter,MaxItr),dqInt(nInter,MaxItr),
     &          Cx(3*nAtom,kIter+1)
      Character :: Lbl(nInter)*8,Name(nAtom)*(LENIN)

      Real*8, Allocatable :: DFC(:),dss(:),qTemp(:)
      Integer :: ipBMx,ip_qInt,ip_dqInt,ipShift
      Logical :: Numerical,PrQ,SaveBMx
      Integer, External :: ip_of_Work
*
      Call GetMem('BMx','ALLO','REAL',ipBMx,(3*nAtom)*nInter)
      Call dCopy_((3*nAtom)*nInter,BMx,1,Work(ipBMx),1)
*
      ip_qInt=ip_of_Work(qInt(1,1))
      ip_dqInt=ip_of_Work(dqInt(1,1))
      ipShift=ip_of_Work(kShift(1,1))
*
      Numerical=.False.
      PrQ=.False.
*
      Call mma_allocate(DFC,3*nAtom,Label='DFC')
      Call mma_allocate(dss,nInter,Label='dss')
      Call mma_allocate(qTemp,nInter,Label='qTemp')
      Force_dB=SaveBMx
*
      Call NewCar(kIter,nBVec,nLines,nAtom,nDim,nInter,Work(ipCoor),
     &            ipBMx,dMass,Lbl,kShift,ip_qInt,ip_dqInt,DFC,dss,
     &            qTemp,Name,iSym,Smmtrc,Degen,
     &            Work(ipGx),Cx,mTtAtm,iWork(ipANr),iOptH,
     &            User_Def,nStab,jStab,Curvilinear,Numerical,
     &            DDV_Schlegel,HWRS,Analytic_Hessian,iOptC,PrQ,mxdc,
     &            iCoSet,rHidden,ipRef,Redundant,nqInt,MaxItr,
     &            RefIter)
*
      Force_dB=.False.
      Call mma_deallocate(DFC)
      Call mma_deallocate(dss)
      Call mma_deallocate(qTemp)
      If (SaveBMx) Call dCopy_((3*nAtom)*nInter,Work(ipBMx),1,BMx,1)
      Call GetMem('BMx','FREE','REAL',ipBMx,(3*nAtom)**2)
*
      End Subroutine NewCar_Kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE tpidx2orb(NSYM,NB,
     $        TYPEINDEX,
     $        NF,NI,N1,N2,N3,NS,ND)
      IMPLICIT NONE
      integer :: NSYM, NB(NSYM)
      integer :: TYPEINDEX(*)
      integer :: NF(*), NI(*), N1(*), N2(*), N3(*), NS(*), ND(*)
      integer :: iSym, iStart
      iStart=1
      do isym=1,nsym
        call tpidx2orb_sym(
     $          TYPEINDEX(iStart),NB(iSym),
     $          NF(iSym),NI(iSym),
     $          N1(iSym),N2(iSym),N3(iSym),
     $          NS(iSym),ND(iSym))
        iStart=iStart+nB(iSym)
      end do
      END

      SUBROUTINE orb2tpidx(NSYM,NB,
     $        NF,NI,N1,N2,N3,NS,ND,
     $        TYPEINDEX)
      IMPLICIT NONE
      integer :: NSYM, NB(NSYM)
      integer :: NF(*), NI(*), N1(*), N2(*), N3(*), NS(*), ND(*)
      integer :: TYPEINDEX(*)
      integer :: iSym, iStart
      iStart=1
      do isym=1,nsym
        call orb2tpidx_sym(
     $          NF(iSym),NI(iSym),
     $          N1(iSym),N2(iSym),N3(iSym),
     $          NS(iSym),ND(iSym),
     $          TYPEINDEX(iStart))
        iStart=iStart+nB(iSym)
      end do
      END

      SUBROUTINE tpstr2tpidx(TYPESTRING,TYPEINDEX,NB)
      IMPLICIT NONE
      character :: TYPESTRING(*)
      integer :: TYPEINDEX(*),NB,i
      do i=1,NB
        select case (TYPESTRING(i))
          case ('F','f')
            TYPEINDEX(i)=1
          case ('I','i')
            TYPEINDEX(i)=2
          case ('1')
            TYPEINDEX(i)=3
          case ('2')
            TYPEINDEX(i)=4
          case ('3')
            TYPEINDEX(i)=5
          case ('S','s')
            TYPEINDEX(i)=6
          case ('D','d')
            TYPEINDEX(i)=7
        end select
      end do
      END

      SUBROUTINE tpidx2tpstr(TYPEINDEX,TYPESTRING,NB)
      IMPLICIT NONE
      character :: TYPESTRING(*)
      integer :: TYPEINDEX(*),NB,i
      do i=1,NB
        select case (TYPEINDEX(i))
          case (1)
            TYPESTRING(i)='F'
          case (2)
            TYPESTRING(i)='I'
          case (3)
            TYPESTRING(i)='1'
          case (4)
            TYPESTRING(i)='2'
          case (5)
            TYPESTRING(i)='3'
          case (6)
            TYPESTRING(i)='S'
          case (7)
            TYPESTRING(i)='D'
        end select
      end do
      END

      SUBROUTINE tpstr2orb(NSYM,NB,
     $        TYPESTRING,
     $        NF,NI,N1,N2,N3,NS,ND)
      IMPLICIT NONE
      integer :: NSYM, NB(NSYM)
      character :: typestring(*)
      integer :: NF(*), NI(*), N1(*), N2(*), N3(*), NS(*), ND(*)
      integer :: iSym, iStart
      iStart=1
      do isym=1,nsym
        call tpstr2orb_sym(
     $          TYPESTRING(iStart),NB(iSym),
     $          NF(iSym),NI(iSym),
     $          N1(iSym),N2(iSym),N3(iSym),
     $          NS(iSym),ND(iSym))
        iStart=iStart+nB(iSym)
      end do
      END

      SUBROUTINE orb2tpstr(NSYM,NB,
     $        NF,NI,N1,N2,N3,NS,ND,
     $        TYPESTRING)
      IMPLICIT NONE
      integer :: NSYM, NB(NSYM)
      integer :: NF(*), NI(*), N1(*), N2(*), N3(*), NS(*), ND(*)
      character :: typestring(*)
      integer :: iSym, iStart
      iStart=1
      do isym=1,nsym
        call orb2tpstr_sym(
     $          NF(iSym),NI(iSym),
     $          N1(iSym),N2(iSym),N3(iSym),
     $          NS(iSym),ND(iSym),
     $          TYPESTRING(iStart))
        iStart=iStart+nB(iSym)
      end do
      END

      SUBROUTINE tpidx2orb_sym(TYPEINDEX,NB,NF,NI,N1,N2,N3,NS,ND)
*SVC: read orbital partition info from a typeindex array
*     corresponding to a _specific_symmetry_ (so these variables are
*     scalars!!
*     A typeindex array consists of integers with 7 possible values
*     corresponding to the types 'fi123sd' -> '1234567'.
      implicit none
      integer :: typeindex(*), NB
      integer :: NF, NI, N1, N2, N3, NS, ND

      integer :: IB, ITYPE
*
      NF=0
      NI=0
      N1=0
      N2=0
      N3=0
      NS=0
      ND=0
* switch typeindex:
      DO IB=1,NB
        ITYPE=TYPEINDEX(IB)
        IF     (ITYPE.EQ.1) THEN
          NF = NF + 1
        ELSE IF(ITYPE.EQ.2) THEN
          NI = NI + 1
        ELSE IF(ITYPE.EQ.3) THEN
          N1 = N1 + 1
        ELSE IF(ITYPE.EQ.4) THEN
          N2 = N2 + 1
        ELSE IF(ITYPE.EQ.5) THEN
          N3 = N3 + 1
        ELSE IF(ITYPE.EQ.6) THEN
          NS = NS + 1
        ELSE IF(ITYPE.EQ.7) THEN
          ND = ND + 1
        ELSE
          WRITE (6,*) 'TPIDX2ORB_SYM: unknown type index number'
          call AbEnd
        END IF
      END DO

      End

      SUBROUTINE orb2tpidx_sym(NF,NI,N1,N2,N3,NS,ND,TYPEINDEX)
*SVC: convert orbital partition info to a typeindex array
*     corresponding to a _specific_symmetry_ (so these variables are
*     scalars!!
*     A typeindex array consists of integers with 7 possible values
*     corresponding to the types 'fi123sd' -> '1234567'.
      implicit none
      integer :: typeindex(*)
      integer :: NF, NI, N1, N2, N3, NS, ND

      integer :: IB, iOff

      iOff=0
*
      DO IB=1,NF
        TYPEINDEX(iOff+IB)=1
      END DO
      iOff=iOff+NF

      DO IB=1,NI
        TYPEINDEX(iOff+IB)=2
      END DO
      iOff=iOff+NI

      DO IB=1,N1
        TYPEINDEX(iOff+IB)=3
      END DO
      iOff=iOff+N1

      DO IB=1,N2
        TYPEINDEX(iOff+IB)=4
      END DO
      iOff=iOff+N2

      DO IB=1,N3
        TYPEINDEX(iOff+IB)=5
      END DO
      iOff=iOff+N3

      DO IB=1,NS
        TYPEINDEX(iOff+IB)=6
      END DO
      iOff=iOff+NS

      DO IB=1,ND
        TYPEINDEX(iOff+IB)=7
      END DO

      End

      SUBROUTINE tpstr2orb_sym(TYPESTRING,NB,NF,NI,N1,N2,N3,NS,ND)
*SVC: read orbital partition info from a typestring array
*     corresponding to a _specific_symmetry_ (so these variables are
*     scalars!!
*     A typestring array consists of characters of 'fi123sd'
      implicit none
      character :: typestring(*)
      integer :: NB
      integer :: NF, NI, N1, N2, N3, NS, ND

      integer :: IB
      character :: CTYPE
*
      NF=0
      NI=0
      N1=0
      N2=0
      N3=0
      NS=0
      ND=0
* switch typeindex:
      DO IB=1,NB
        CTYPE=TYPESTRING(IB)
        CALL UPCASE(CTYPE)
        IF     (CTYPE.EQ.'F') THEN
          NF = NF + 1
        ELSE IF(CTYPE.EQ.'I') THEN
          NI = NI + 1
        ELSE IF(CTYPE.EQ.'1') THEN
          N1 = N1 + 1
        ELSE IF(CTYPE.EQ.'2') THEN
          N2 = N2 + 1
        ELSE IF(CTYPE.EQ.'3') THEN
          N3 = N3 + 1
        ELSE IF(CTYPE.EQ.'S') THEN
          NS = NS + 1
        ELSE IF(CTYPE.EQ.'D') THEN
          ND = ND + 1
        ELSE
          WRITE (6,*) 'TPSTR2ORB_SYM: unknown type index character '
     $            //CTYPE
          call AbEnd
        END IF
      END DO

      End

      SUBROUTINE orb2tpstr_sym(NF,NI,N1,N2,N3,NS,ND,TYPESTRING)
*SVC: convert orbital partition info to a typestring array
*     corresponding to a _specific_symmetry_ (so these variables are
*     scalars!!
*     A typestring array consists of characters of 'fi123sd'
      implicit none
      character :: typestring(*)
      integer :: NF, NI, N1, N2, N3, NS, ND

      integer :: IB, iOff

      iOff=0
*
      DO IB=1,NF
        TYPESTRING(iOff+IB)='F'
      END DO
      iOff=iOff+NF

      DO IB=1,NI
        TYPESTRING(iOff+IB)='I'
      END DO
      iOff=iOff+NI

      DO IB=1,N1
        TYPESTRING(iOff+IB)='1'
      END DO
      iOff=iOff+N1

      DO IB=1,N2
        TYPESTRING(iOff+IB)='2'
      END DO
      iOff=iOff+N2

      DO IB=1,N3
        TYPESTRING(iOff+IB)='3'
      END DO
      iOff=iOff+N3

      DO IB=1,NS
        TYPESTRING(iOff+IB)='S'
      END DO
      iOff=iOff+NS

      DO IB=1,ND
        TYPESTRING(iOff+IB)='D'
      END DO

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine normal(line)

use Definitions, only: iwp

implicit none
character(len=*), intent(inout) :: line
character :: ch
integer(kind=iwp), save :: ifirst = 1, inew(0:255)
integer(kind=iwp) :: i, iflag, iold, ipos
character(len=*), parameter :: upper = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', &
                               lower = 'abcdefghijklmnopqrstuvwxyz'

if (ifirst == 1) then
  ifirst = 0
  do i=0,255
    inew(i) = i
  end do
  do i=1,26
    iold = ichar(lower(i:i))
    inew(iold) = ichar(upper(i:i))
  end do
end if

ipos = 0
iflag = 1
do i=1,len(line)
  ch = line(i:i)
  if (ch /= ' ') then
    ipos = ipos+1
    iflag = 0
    line(ipos:ipos) = char(inew(ichar(ch)))
  else
    if (iflag == 0) then
      ipos = ipos+1
      line(ipos:ipos) = ' '
      iflag = 1
    end if
  end if
end do
do i=ipos+1,len(line)
  line(i:i) = ' '
end do

return

end subroutine normal

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MKTDAO(CMO,TDMO,TDAO,SCR)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION CMO(NCMO),TDMO(NBAST,NBAST),TDAO(NBAST,NBAST)
      DIMENSION SCR(NBMAX,NBMAX)

#include "SysDef.fh"

#include "mrci.fh"
C REORDER TDMO (USE TDAO AS TEMPORARY STORAGE):
      CALL FZERO(TDAO,NBAST**2)
      DO 10 I=1,NORBT
        II=ICH(I)
        IF(II.LE.0) GOTO 10
        DO 5 J=1,NORBT
          JJ=ICH(J)
          IF(JJ.LE.0) GOTO 5
          TDAO(I,J)=TDMO(II,JJ)
5       CONTINUE
10    CONTINUE
      CALL DCOPY_(NBAST**2,TDAO,1,TDMO,1)
      CALL FZERO(TDAO,NBAST**2)
      IECMO=0
      IEO=0
      IEB=0
      DO 100 ISYM=1,NSYM
        ISO=IEO+1
        ISB=IEB+1
        NO=NORB(ISYM)
        NB=NBAS(ISYM)
        IEO=IEO+NO
        IEB=IEB+NB
C ORBITALS PRE-FROZEN IN MOTRA, OR FROZEN IN MRCI:
        NF=NFMO(ISYM)+NFRO(ISYM)
        NBF=NB*NF
        ISCMO=IECMO+1
        IECMO=IECMO+NBF
C ORBITALS EXPLICITLY USED IN CI:
        NCO=NO-NFRO(ISYM)-NDEL(ISYM)
        ISCO=ISO+NFRO(ISYM)
        NBCO=NB*NCO
        ISCMO=IECMO+1
        IECMO=IECMO+NBCO
        IF(NCO.GT.0) THEN
          CALL DGEMM_('N','N',
     &                NB,NCO,NCO,
     &                1.0d0,CMO(ISCMO),NB,
     &                TDMO(ISCO,ISCO),NBAST,
     &                0.0d0,SCR,NB)
          CALL DGEMM_('N','T',NB,NB,NCO,1.0D00,SCR,NB,
     *               CMO(ISCMO),NB,1.0D00,TDAO(ISB,ISB),NBAST)
        END IF
C ORBITALS PRE-DELETED IN MOTRA OR DELETED IN MRCI:
        ND=NDMO(ISYM)+NDEL(ISYM)
        NBD=NB*ND
        ISCMO=IECMO+1
        IECMO=IECMO+NBD
100   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine MS_Res(MODE,IST,JST,Scal)
! Compute the derivative of E^PT2 with respct to the T amplitude

use Index_Functions, only: nTri3_Elem
use EQSOLV, only: IVECC, IVECC2, IVECW
use caspt2_global, only: IDTCEX, LUCIEX
use caspt2_module, only: ISCF, MXCI, NASHT, NCONF, NSTATE, STSYM
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: MODE, IST, JST
real(kind=wp), intent(in) :: Scal
integer(kind=iwp) :: I, IDCI, NTG1, NTG2, NTG3
real(kind=wp) :: DUMMY(1), DVALUE, OVL
real(kind=wp), allocatable :: CI1(:), CI2(:), TG1(:), TG2(:), TG3(:)

! We evaluate the effective Hamiltonian matrix element in two steps.

NTG1 = NASHT**2
NTG2 = NASHT**4
NTG3 = nTri3_Elem(NTG1)
! Note: Need proper allocation even if unused, sinced allocated
! arrays are in subroutine parameter lists of MKTG3, HCOUP.
NTG1 = max(1,NTG1)
NTG2 = max(1,NTG2)
NTG3 = max(1,NTG3)
call mma_allocate(TG1,NTG1,Label='TG1')
call mma_allocate(TG2,NTG2,Label='TG2')
call mma_allocate(TG3,NTG3,Label='TG3')
TG1(:) = Zero
TG2(:) = Zero
TG3(:) = Zero

call mma_allocate(CI1,MXCI,Label='MCCI1')
call mma_allocate(CI2,MXCI,Label='MCCI2')
if (ISCF == 0) then
  ! Read root vectors nr. IST and JST from LUCI.
  do I=1,NSTATE
    IDCI = IDTCEX(I)
    if (I == IST) then
      call DDAFILE(LUCIEX,2,CI1,NCONF,IDCI)
      if (I == JST) CI2(1:NCONF) = CI1(1:NCONF)
    else if (I == JST) then
      call DDAFILE(LUCIEX,2,CI2,NCONF,IDCI)
    else
      call DDAFILE(LUCIEX,0,DUMMY,NCONF,IDCI)
    end if
  end do
end if

call MKTG3(STSYM,STSYM,CI1,CI2,OVL,TG1,TG2,NTG3,TG3)
call mma_deallocate(CI1)
call mma_deallocate(CI2)

!! Do similar to RHS_STRANS. Multiply the solution vector (T) with
!! the overlap-like term constructe with transition density
!! matrices. The output is IVECC (MODE=1) or IVECC2 (MODE=2)
if (MODE == 1) then
  call MS_STRANS(IVECW,IVECC,NASHT,NTG3,OVL,TG1,TG2,TG3,DVALUE,SCAL)
else if (MODE == 2) then
  call MS_STRANS(IVECC,IVECC2,NASHT,NTG3,OVL,TG1,TG2,TG3,DVALUE,SCAL)
else if (MODE == 3) then
  call MS_STRANS(IVECW,IVECC,NASHT,NTG3,OVL,TG1,TG2,TG3,DVALUE,SCAL)
end if

call mma_deallocate(TG1)
call mma_deallocate(TG2)
call mma_deallocate(TG3)

end subroutine MS_Res

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1988, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine TRACI_LUCIA(X,LUCIN,LUCOUT,IXSPC,IXSM,VEC1,VEC2)
! A rotation matrix X is defining expansion from
! old to new orbitals
!        PHI(NEW) = PHI(OLD) * X
!
! change CI coefficients (sym IXSM, space IXSPC)
! so they corresponds to PHI(NEW) basis
!
! The input CI vector is on LUCIN and the transformed CI vector
! will be delivered on LUCOUT.
!
! Transformation as conceived by Per-AAke Malmquist
! (I.J.Q.C. vol XXX, p479, 1986 (OCTOBER ISSUE))
!
!  Jeppe Olsen 1988
!
! New LUCIA version of Jan 1998
!
! note The transformation matrix X is supposed to be in complete form
! as a matrix over NTOOB orbitals.

use Index_Functions, only: nTri_Elem
use CandS, only: ICSM, ICSPC, ISSM, ISSPC
use lucia_data, only: LUSC1, LUSC2, LUSC3, NSMOB, NTOOB, NTOOBS
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: X(*)
integer(kind=iwp), intent(in) :: LUCIN, LUCOUT, IXSPC, IXSM
real(kind=wp), intent(_OUT_) :: VEC1(*), VEC2(*)
real(kind=wp), allocatable :: SCR(:), LT(:)
integer(kind=iwp) :: IOFF, ISM

! Some dummy initializations
IOFF = 0 ! jwk-cleanup

#ifdef _DEBUGPRINT_
write(u6,*) ' ================'
write(u6,*) ' Welcome to TRACI'
write(u6,*) ' ================'
write(u6,*)
write(u6,*) ' IXSPC,IXSM = ',IXSPC,IXSM
#endif
! Memory allocation
! for a matrix T
call mma_allocate(LT,NTOOB**2,Label='LT')
! Scratch in PAMTMT
call mma_allocate(SCR,NTOOB**2+nTri_Elem(NTOOB),Label='SCR')
! Obtain T matrix used for transformation, for each symmetry separately
do ISM=1,NSMOB
  if (ISM == 1) then
    IOFF = 1
  else
    IOFF = IOFF+NTOOBS(ISM-1)**2
  end if
  if (NTOOBS(ISM) > 0) call PAMTMT(X(IOFF),LT(IOFF),SCR,NTOOBS(ISM))
end do
! Transform CI-vector
ICSPC = IXSPC
ICSM = ICSM
ISSPC = IXSPC
ISSM = IXSM

call TRACID(LT,LUCIN,LUCOUT,LUSC1,LUSC2,LUSC3,VEC1,VEC2)

call mma_deallocate(SCR)
call mma_deallocate(LT)

end subroutine TRACI_LUCIA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
************************************************************************
      SUBROUTINE LOOP18(KM,ISTOP,IT1,IT2)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "real_guga.fh"
#include "integ.fh"
      COMMON/CNSTS/D0,D1,D2
      ISTOP=0
      KM1=KM+1
      IDIF=IA(J1(KM1))-IA(J2(KM1))
      IF(IDIF.LT.-1.OR.IDIF.GT.1)GO TO 55
      IF (IDIF.LT.0) THEN
        GO TO 51
      ELSE IF (IDIF.EQ.0) THEN
        GO TO 52
      ELSE
        GO TO 53
      END IF
51    IF(IWAY(KM).EQ.2)GO TO 55
      IWAY(KM)=2
C     F+H
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 55
      IF(K3F(JM(KM1)).EQ.0)GO TO 55
      J2(KM)=K2(IT2+J2(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM)=BS3(IB(J2(KM1))+3)*BS4(IB(J2(KM1))+1)*COUP(KM1)
      GO TO 40
52    IWAYKM=IWAY(KM)
      GO TO (59,61,62,55),IWAYKM
59    IWAY(KM)=2
C     (E+E,G+G)
      IF(K0(IT1+J1(KM1)).EQ.0.OR.K0(IT2+J2(KM1)).EQ.0)GO TO 61
      WM0=D0
      WP0=D0
      IF(K2F(JM1(KM1)).EQ.0)GO TO 161
      J2(KM)=K0(IT2+J2(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)
      ICOUP(KM)=ICOUP(KM1)
      WM0=D1
      IF(K1F(JM(KM1)).EQ.0)GO TO 162
      GO TO 163
161   IF(K1F(JM(KM1)).EQ.0)GO TO 61
      J2(KM)=K0(IT2+J2(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)
      ICOUP(KM)=ICOUP(KM1)
163   WP0=D1
162   COUP(KM)=WM0*COUP1(KM1)+WP0*COUP(KM1)
      GO TO 40
C     F+F
61    IWAY(KM)=3
      IF(K1(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 62
      IF(K3F(JM1(KM1)).EQ.0)GO TO 62
      J2(KM)=K1(IT2+J2(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),1)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM)=COUP1(KM1)*BS3(IB(J2(KM1))+1)**2
      GO TO 40
C     H+H
62    IWAY(KM)=4
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K2(IT2+J2(KM1)).EQ.0)GO TO 55
      IF(K3F(JM(KM1)).EQ.0)GO TO 55
      J2(KM)=K2(IT2+J2(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),2)
      COUP(KM)=COUP(KM1)*BS4(IB(J2(KM1))+1)**2
      GO TO 40
53    IF(IWAY(KM).EQ.2)GO TO 55
      IWAY(KM)=2
C     H+F
      IF(K2(IT1+J1(KM1)).EQ.0.OR.K1(IT2+J2(KM1)).EQ.0)GO TO 55
      IF(K3F(JM1(KM1)).EQ.0)GO TO 55
      J2(KM)=K1(IT2+J2(KM1))
      J1(KM)=J2(KM)
      ICOUP1(KM)=ICOUP1(KM1)+IY(IT1+J1(KM1),2)
      ICOUP(KM)=ICOUP(KM1)+IY(IT2+J2(KM1),1)
      COUP(KM)=BS4(IB(J2(KM1))-1)*BS3(IB(J2(KM1))+1)*COUP1(KM1)
      GO TO 40
55    ISTOP=1
40      Continue
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine span_cvb(a,nvec,nlin,s,n,metr)
c  Creates span of a vector set.
c  On entry : A is NVEC by N
c  On exit  : NLIN is the number of linearly independent vectors
c               (NVEC and NLIN may coincide in calling sequence)
c             A contains set of NLIN linearly independent vectors
c               spanning the same set as the NVEC input vectors
c               Vectors will be orthonormal on exit
      implicit real*8 (a-h,o-z)
      dimension a(n,nvec),s(*)
      save thresh
      data thresh/1.d-10/
      nvect=nvec
      ierr=1
      call nize_cvb(a,nvect,s,n,metr,ierr)
      call schmidt_cvb(a,nvect,s,n,metr)
      nlin=0
      do 100 i=1,nvect
      cnrm=dnrm2_(n,a(1,i),1)
      if(cnrm.gt.thresh)then
        nlin=nlin+1
        call fmove_cvb(a(1,i),a(1,nlin),n)
      endif
100   continue
      ierr=1
      call nize_cvb(a,nlin,s,n,metr,ierr)
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1999, Roland Lindh                                     *
************************************************************************
      Subroutine Set_binom
************************************************************************
*                                                                      *
*     Object: to set up a table of binomial coefficients.              *
*                                                                      *
*     Author: Roland Lindh                                             *
*             Dept of Chem. Phys.                                      *
*             Univ. of Lund, Sweden                                    *
*             February 1999                                            *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "itmax.fh"
#include "binom.fh"
#include "real.fh"
*
      Do i = 0, 2*iTabMx
         Do j = -1, 2*iTabMx
            binom(i,j)=Zero
         End Do
      End Do
      binom(0,0)=One
*
*---- Do recurrence according to Pascal's triangle!
*
      Do n = 1, 2*iTabMx
         Do i = 0, n
            binom(n,i)=binom(n-1,i-1)+binom(n-1,i)
         End Do
      End Do
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE NXT_CONF(ICONF,NEL,NORB,INI,NONEW)
*
* Next configuration of NEL electrons distributed in NORB orbitals
*
* A configuration is stored as the occupied orbitals
* in nonstrict ascending order - two consecutivw orbitals are allowed
* to be identical
* allowing two
*
* IF INI = 1 : Generate initial configuration
*    NONOEW = 1 : No new configuration could be generated
*
* Jeppe Olsen, November 2001
*
#include "implicit.fh"
      INTEGER ICONF(NEL)
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Input configuration to NXT_CONF '
        CALL IWRTMA(ICONF,1,NEL,1,NEL)
        WRITE(6,*) ' NEL, NORB = ',  NEL, NORB
      END IF
      IF(INI.EQ.1) THEN
*. Check that NEL electrons can be distributed in NORB orbitals
        IF(NEL.LE.2*NORB) THEN
          NONEW = 0
          N_DOUBLE = NEL/2
          DO I = 1, N_DOUBLE
            ICONF(2*I-1) = I
            ICONF(2*I)   = I
          END DO
          IF(2*N_DOUBLE.NE.NEL) ICONF(2*N_DOUBLE+1) = N_DOUBLE + 1
        ELSE
          NONEW = 1
        END IF
*
      ELSE IF(INI.EQ.0) THEN
*
        IADD  = 1
        IEL = 0
*. Increase orbital number of next electron
 1000   CONTINUE
          IEL = IEL + 1
*. Can orbital number be increased for electron IEL ?
          INCREASE = 0
          IF(IEL.LT.NEL) THEN
            IF(ICONF(IEL).LT.ICONF(IEL+1)-1)  INCREASE = 1
            IF(ICONF(IEL).EQ.ICONF(IEL+1)-1) THEN
*. If ICONF(IEL) is increased, ICONF(IEL) = ICONF(IEL+1), check if this is ok
              IF(IEL.EQ.NEL-1) THEN
                 INCREASE = 1
              ELSE IF (ICONF(IEL+1).NE.ICONF(IEL+2)) THEN
                 INCREASE = 1
              END IF
            END IF
          ELSE
C-jwk new            IF(ICONF(IEL).LT.NORB) THEN
            IF(IEL .EQ. NEL .AND. ICONF(IEL) .LT. NORB) THEN
              INCREASE = 1
            ELSE
*. Nothing more to do
              NONEW = 1
              GOTO 1001
            END IF
          END IF
*
          IF(INCREASE.EQ.1) THEN
*. Increase orbital for elec IEL
            NONEW = 0
            ICONF(IEL) = ICONF(IEL)+1
*. Minimize orbital occupations
            NDOUBLE = (IEL-1)/2
            DO JORB = 1, NDOUBLE
              ICONF(2*JORB-1) = JORB
              ICONF(2*JORB  ) = JORB
            END DO
            IF(2*NDOUBLE.LT.IEL-1) ICONF(IEL-1) = NDOUBLE+1
            IADD = 0
          END IF
        IF(IADD.EQ.1)  GOTO 1000
      END IF
*     ^ End if INI = 0
*
 1001 CONTINUE
*
      IF(NTEST.GE.100) THEN
        IF(NONEW.EQ.1) THEN
          WRITE(6,*) ' No new configurations '
          WRITE(6,*) ' Input configuration '
          CALL IWRTMA(ICONF,1,NEL,1,NEL)
        ELSE
          WRITE(6,*) ' Next configurations '
          CALL IWRTMA(ICONF,1,NEL,1,NEL)
        END IF
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE ZSPGPIB(NSTSO,ISTSO,NSPGP,NSMST)
*
* Offset for supergroups of strings with given sym.
*. Each supergroup is given start address 1
*
* Jeppe Olsen, Still summer of 95
*
      IMPLICIT REAL*8 (A-H,O-Z)
*. Input
      INTEGER NSTSO(NSMST,NSPGP)
*. Output
      INTEGER ISTSO(NSMST,NSPGP)
*
      DO ISPGP = 1, NSPGP
        ISTSO(1,ISPGP) = 1
        DO ISMST = 2, NSMST
          ISTSO(ISMST,ISPGP) = ISTSO(ISMST-1,ISPGP) + NSTSO(ISMST,ISPGP)
        END DO
      END DO
*
      NTEST = 000
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Output from ZSPGPIB '
        WRITE(6,*) ' =================== '
        WRITE(6,*)
        CALL IWRTMA(ISTSO,NSMST,NSPGP,NSMST,NSPGP)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2011, Francesco Aquilante                              *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

!#define _DEBUGPRINT_
subroutine DOne_SCF(nSym,nBas,nOrb,nFro,CMO,nCMO,Occ,Dlt,alpha_density)
!***********************************************************************
!                                                                      *
!     purpose: Compute density matrix in AO basis                      *
!                                                                      *
!     input:                                                           *
!       nSym    : number of symmetries                                 *
!       nBas(i) : number of basis functions (i = 1, nSym)              *
!       nOrb(i) : number of orbitals (i = 1, nSym)                     *
!       nFro(i) : number of frozen orbitals (i = 1, nSym)              *
!       CMO     : molecular orbitals                                   *
!       Occ     : occupation numbers                                   *
!                                                                      *
!       alpha_density: .true. iff alpha MOs were sent in               *
!                                                                      *
!     output:                                                          *
!       Dlt     : density matrix in triangular storage                 *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use SpinAV, only: Do_SpinAV, DSc
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nOrb(nSym), nFro(nSym), nCMO
real(kind=wp), target, intent(in) :: CMO(nCMO), Occ(*)
real(kind=wp), target, intent(_OUT_) :: Dlt(*)
logical(kind=iwp), intent(in) :: alpha_density
integer(kind=iwp) :: i, iCol, iDSc, iOff, iOffD, ipCMO, ipDlt, ipDScc, ipOcc, iROw, iSym, j, ji, jj, lOff, lth, nBs, nFr, nOr
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: nOcc
#endif
real(kind=wp) :: rSum, xsign
real(kind=wp), pointer :: pCMO(:,:), pOcc(:), pDlt(:)

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

#ifdef _DEBUGPRINT_
call NrmClc(CMO,nCMO,'DOne_SCF','CMO')
nOcc = sum(nOrb(:))
call NrmClc(Occ,nOcc,'DOne_SCF','Occ')
#endif

ipCMO = 1
ipDlt = 1
ipOcc = 1
do iSym=1,nSym

  nBs = nBas(iSym)
  nOr = nOrb(iSym)
  nFr = nFro(iSym)

  lth = nTri_Elem(nBs)
  Dlt(ipDlt:ipDlt+lth-1) = Zero

  if (nOr /= 0) then
    pCMO(1:nBs,1:nBs) => CMO(ipCMO:ipCMO+nBs**2-1)
    pOcc => Occ(ipOcc:ipOcc+nOr-1)
    pDlt => Dlt(ipDlt:ipDlt+lth-1)

    do iRow=1,nBs
      do iCol=1,iRow
        rSum = sum(pOcc(nFr+1:nOr)*pCMO(iRow,nFr+1:nOr)*pCMO(iCol,nFr+1:nOr))
        if (iCol == iRow) then
          pDlt(iTri(iRow,iRow)) = rSum
        else
          pDlt(iTri(iRow,iCol)) = Two*rSum
        end if
      end do
    end do
#   ifdef _DEBUGPRINT_
    call NrmClc(pDlt,nTri_Elem(nBs),'DOne_SCF','Dlt')
    !call RecPrt('CMO',' ',pCMO,nBs,nBs)
    !call RecPrt('Occ',' ',pOcc,1,nOr)
    !call TriPrt('Dlt',' ',pDlt,nBs)
#   endif
    nullify(pCMO,pOcc,pDlt)
  end if

  ipCMO = ipCMO+nBs**2
  ipDlt = ipDlt+lth
  ipOcc = ipOcc+nOr
end do

xsign = One
if (Do_SpinAV) then

  if (alpha_density) xsign = -One
  iOffD = 1
  lOff = 0
  do iSym=1,nSym
    lth = nTri_Elem(nBas(iSym))

    pDlt => Dlt(iOffD:iOffD+lth-1)

    ipDScc = 1+lOff
    do j=1,nBas(iSym)
      do i=1,j-1
        ji = iTri(j,i)
        iDSc = ipDScc-1+nBas(iSym)*(j-1)+i
        pDlt(ji) = pDlt(ji)+xsign*Two*DSc(iDSc)
      end do
      jj = nTri_Elem(j)
      iDSc = ipDScc-1+nBas(iSym)*(j-1)+j
      pDlt(jj) = pDlt(jj)+xsign*DSc(iDSc)
    end do
    iOff = iOff+lth
    lOff = lOff+nBas(iSym)**2
  end do

  nullify(pDlt)

end if

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

#undef _DEBUGPRINT_
end subroutine DOne_SCF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function nCoBond(iAtom,nAtoms,nMax,iTabBonds,nBonds,
     &                         nBondMax,iTabAtoms)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Integer iTabBonds(3,nBondMax), iTabAtoms(2,0:nMax,nAtoms)
#include "bondtypes.fh"
*                                                                      *
************************************************************************
*                                                                      *
      nCoBond=0
      nn=iTabAtoms(1,0,iAtom)
      Do i = 1, nn
         If(iTabBonds(3,iTabAtoms(2,i,iAtom)).eq.Covalent_Bond)
     &      nCoBond=nCoBond+1
      End Do
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nBonds)
      End
      Integer Function nFgBond(iAtom,nAtoms,nMax,iTabBonds,nBonds,
     &                         nBondMax,iTabAtoms)
      Implicit Real*8 (a-h,o-z)
#include "WrkSpc.fh"
      Integer iTabBonds(3,nBondMax), iTabAtoms(2,0:nMax,nAtoms)
#include "bondtypes.fh"
*                                                                      *
************************************************************************
*                                                                      *
      nFgBond=0
      nn=iTabAtoms(1,0,iAtom)
      Do i = 1, nn
         If(iTabBonds(3,iTabAtoms(2,i,iAtom)).eq.Fragments_Bond)
     &      nFgBond=nFgBond+1
      End Do
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(nBonds)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine LinDepLag(BDer,SDer,nAS,nIN,iSym,iCase)
! Compute contributions that arise from the non-invariance effect
! in non-orthogonal -> orthogonal ICB rotations
! See J. Chem. Phys. 2023, 158, 174112. for details, in particular,
! Section II C 3 "Non-invariance with respect to orthogonal..."

use Index_Functions, only: nTri_Elem
use EQSOLV, only: idSMAT
use caspt2_global, only: idBoriMat, LUSBT, LUSTD
use caspt2_module, only: IFDORTHO, THRSHN, THRSHS
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAS, nIN, iSym, iCase
real(kind=wp), intent(inout) :: BDer(nAS,nAS), SDer(nAS,nAS)
integer(kind=iwp) :: I, IDB, IDIAG, idS, IJ, INFO, J, NB, NS, NSCRATCH
real(kind=wp) :: SD, WGRONK(2)
real(kind=wp), allocatable :: B(:), EIG(:), F(:,:), LAG(:,:), S(:), SCA(:), SCRATCH(:), SS(:,:), VEC(:,:)

!! Obtain the X matrix
!! First, read S
NS = nTri_Elem(NAS)
call mma_allocate(S,NS,Label='S')
call mma_allocate(SS,NAS,NAS,Label='SS')
idS = idSMAT(iSym,iCase)
call DDAFILE(LUSBT,2,S,NS,idS)
IJ = 0
do J=1,NAS
  SS(1:J,J) = S(IJ+1:IJ+J)
  SS(J,1:J) = S(IJ+1:IJ+J)
  IJ = IJ+J
end do

call mma_allocate(VEC,NAS,NAS,Label='VEC')
call mma_allocate(EIG,NAS,Label='EIG')
call mma_allocate(SCA,NAS,Label='SCA')
IDIAG = 0
do I=1,NAS
  IDIAG = IDIAG+I
  SD = S(IDIAG)
  if (IFDORTHO) then
    SCA(I) = One
  else
    if (SD > THRSHN) then
      ! Small variations of the scale factor were beneficial
      SCA(I) = (One+real(I,kind=wp)*3.0e-6_wp)/sqrt(SD)
    else
      SCA(I) = Zero
    end if
  end if
end do
IJ = 0
do J=1,NAS
  S(IJ+1:IJ+J) = S(IJ+1:IJ+J)*SCA(1:J)*SCA(J)
  IJ = IJ+J
end do

IJ = 0
do J=1,NAS
  VEC(1:J,J) = S(IJ+1:IJ+J)
  IJ = IJ+J
end do
INFO = 0
call dsyev_('V','L',NAS,VEC,NAS,EIG,WGRONK,-1,INFO)
NSCRATCH = int(WGRONK(1))
call mma_allocate(SCRATCH,NSCRATCH,Label='SCRATCH')
call dsyev_('V','U',NAS,VEC,NAS,EIG,SCRATCH,NSCRATCH,INFO)
call mma_deallocate(SCRATCH)

do I=1,NAS
  VEC(I,:) = SCA(I)*VEC(I,:)
end do
call mma_deallocate(SCA)
call mma_deallocate(S)

!! Scale only the independent vectors to avoid
!! any numerically unstable computation
do I=1,NAS
  if (EIG(I) > THRSHS) VEC(:,I) = VEC(:,I)/sqrt(EIG(I))
end do

call mma_allocate(LAG,NAS,NAS,Label='LAG')
IDB = IDBoriMat(ISYM,ICASE)
NB = NS
call mma_allocate(B,NB,Label='B')
call DDAFILE(LUSTD,2,B,NB,IDB)
call mma_allocate(F,NAS,NAS,Label='F')
IJ = 0
do J=1,NAS
  F(1:J,J) = B(IJ+1:IJ+J)
  F(J,1:J) = B(IJ+1:IJ+J)
  IJ = IJ+J
end do

!! Compute the partial derivative
!! F   : B
!! BDER: D
!! VEC : X^0 and X
call DGEMM_('N','T',NAS,NAS,NAS,Two,F,NAS,BDER,NAS,Zero,LAG,NAS)
call DGEMM_('N','N',NAS,NAS,NAS,One,LAG,NAS,VEC,NAS,Zero,F,NAS)
LAG(1:NAS,1:NAS) = F(1:NAS,1:NAS)

call DGEMM_('T','N',NAS,NAS,NAS,One,VEC,NAS,LAG,NAS,Zero,F,NAS)
!! At this point,
!! F = 2 \mathcal{X}^0 * B * D * \mathcal{X}

!! remove dependent part
!! (linearly indep-indep and dep-dep)
F(1:nAS-nIN,1:nAS-nIN) = Zero
F(nAS-nIN+1:nAS,nAS-nIN+1:nAS) = Zero

!! orthogonal -> non-orthogonal
!! Finalize Eq. (62)
call DGEMM_('N','N',NAS,NAS,NAS,One,VEC,NAS,F,NAS,Zero,LAG,NAS)
call DGEMM_('N','T',NAS,NAS,NAS,One,LAG,NAS,VEC,NAS,Zero,F,NAS)

SDER(:,:) = SDER(:,:)+F(:,:)

call mma_deallocate(LAG)
call mma_deallocate(B)
call mma_deallocate(F)

call mma_deallocate(SS)
call mma_deallocate(EIG)
call mma_deallocate(VEC)

return

end subroutine LinDepLag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine defs2_cvb(ifxorb)

use casvb_global, only: iciweights, icrit, imethod, isaddle, ishstruc, iunset, ivbweights, lfxvb, lzrvb, mxiter, mxorb_cvb, nfrag, &
                        nfxorb, nfxvb, norb, npcf, nvb, nzrvb, projcas, strucopt, variat
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(inout) :: ifxorb(mxorb_cvb)
integer(kind=iwp) :: i, nfxvbr, nzrvbr

if (icrit == iunset) then
  if ((.not. variat) .and. (imethod /= 6)) then
    icrit = 1
  else
    icrit = 2
  end if
end if
! Set ifxorb
nfxorb = 0
do i=1,norb
  if (ifxorb(i) == 1) nfxorb = nfxorb+1
end do
ifxorb(norb+1:) = 0

! Set STRUCOPT:
if (projcas) then
  strucopt = .false.
else if (imethod == 11) then
  strucopt = .false.
else if (nvb == 1) then
  strucopt = .false.
else
  nfxvbr = nfxvb
  if (lfxvb == 1) nfxvbr = nvb-nfxvb
  nzrvbr = nzrvb
  if (lzrvb == 1) nzrvbr = nvb-nzrvb
  if (nfxvbr >= nvb) then
    strucopt = .false.
  else if (nfxvbr+nzrvbr >= nvb) then
    write(u6,*) ' Should check!'
    call abend_cvb()
  else
    strucopt = .true.
  end if
end if
if (isaddle == iunset) isaddle = 0
! If unset, set default for IMETHOD:
if (imethod == iunset) then
  if (isaddle == 0) then
    imethod = 10
  else
    imethod = 7
  end if
  if ((nfxorb == norb) .and. strucopt .and. (nfrag <= 1)) imethod = 4
else if ((isaddle /= 0) .and. (imethod == 1)) then
  call abend_cvb()
end if
! If unset, set default for MXITER:
if (mxiter == iunset) then
  if (imethod /= 4) then
    mxiter = 50
  else
    mxiter = 200
  end if
end if
if (ishstruc == iunset) ishstruc = 0
if (npcf == iunset) npcf = -2
if (ivbweights == iunset) ivbweights = -1
if (iciweights == iunset) iciweights = 0
call tunedefs2_cvb(imethod,.false.)

return

end subroutine defs2_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine gaussj2_cvb(a,lrow,irows,ijs,oijs,n)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: n
real(kind=wp), intent(inout) :: a(n,n)
integer(kind=iwp), intent(out) :: lrow(n), irows(n), ijs(2,n*n)
real(kind=wp), intent(out) :: oijs(n*n)
integer(kind=iwp) :: i, idum, ihad, ii, ii2, imain, imx, j, jmx, nij
real(kind=wp) :: amx, dum, oneovamx
logical(kind=iwp) :: done
integer(kind=iwp), allocatable :: lcol(:), ibook(:)
real(kind=wp), parameter :: thresh = 1.0e-10_wp

call mma_allocate(lcol,n,label='lcol')
call mma_allocate(ibook,n,label='ibook')

! initialize imx & jmx to suppress compiler warnings ...
imx = 0
jmx = 0

nij = n*n
do i=1,n
  irows(i) = i
end do
ibook(:) = 0
done = .false.
do imain=1,n
  amx = Zero
  do i=1,n
    if (ibook(i) /= 1) then
      do j=1,n
        if (ibook(j) == 0) then
          if (abs(a(i,j)) >= amx) then
            amx = abs(a(i,j))
            imx = i
            jmx = j
          end if
        else if (ibook(j) > 1) then
          write(u6,*) ' Singular matrix in GAUSSJ !'
          call abend_cvb()
        end if
      end do
    end if
  end do
  ibook(jmx) = ibook(jmx)+1
  if (imx /= jmx) then
    do ii=1,n
      dum = a(imx,ii)
      a(imx,ii) = a(jmx,ii)
      a(jmx,ii) = dum
    end do
    idum = irows(imx)
    irows(imx) = irows(jmx)
    irows(jmx) = idum
  end if
  lrow(imain) = imx
  lcol(imain) = jmx
  if (abs(a(jmx,jmx)) < thresh) then
    ihad = imain-1
    done = .true.
    exit
  end if
  ijs(1,nij) = irows(jmx)
  ijs(2,nij) = irows(jmx)
  oijs(nij) = a(jmx,jmx)
  nij = nij-1
  oneovamx = One/a(jmx,jmx)
  a(jmx,jmx) = One
  a(jmx,:) = oneovamx*a(jmx,:)
  do ii2=1,n
    if (ii2 /= jmx) then
      dum = a(ii2,jmx)
      a(ii2,jmx) = Zero
      a(ii2,:) = a(ii2,:)-dum*a(jmx,:)
      ijs(1,nij) = irows(ii2)
      ijs(2,nij) = irows(jmx)
      oijs(nij) = dum
      nij = nij-1
    end if
  end do
end do
if (done) then
  outer: do i=1,n
    do j=1,ihad
      if (lcol(j) == i) cycle outer
    end do
    ijs(1,nij) = irows(i)
    ijs(2,nij) = irows(i)
    oijs(nij) = Zero
    nij = nij-1
    do j=1,n
      if (j /= i) then
        ijs(1,nij) = irows(j)
        ijs(2,nij) = irows(i)
        oijs(nij) = a(j,i)
        nij = nij-1
      end if
    end do
  end do outer
else
  do ii=n,1,-1
    if (lrow(ii) /= lcol(ii)) then
      do ii2=1,n
        dum = a(ii2,lrow(ii))
        a(ii2,lrow(ii)) = a(ii2,lcol(ii))
        a(ii2,lcol(ii)) = dum
      end do
    end if
  end do
end if

call mma_deallocate(lcol)
call mma_deallocate(ibook)

return

end subroutine gaussj2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Transverse(xyz,nCent,HDist,Bf,l_write,Label,dBf,ldB)
      use Slapaf_Info, only: Weights, RefGeo, R12, GradRef
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "stdalloc.fh"
      Real*8 Bf(3,nCent), xyz(3,nCent), dBf(3,nCent,3,nCent)
      Logical l_Write, ldB, lTrans
      Character(LEN=8) Label
      Real*8, Allocatable, Target:: TV(:,:)
      Real*8, Pointer:: r12_p(:,:)
*                                                                      *
************************************************************************
*                                                                      *
*     The reference direction (normal to the hyperplane) is taken from
*     the input (GradRef) if allocated, or from the stored
*     transverse direction if there is one, or from the R-P vector
*     (R12) otherwise
*
      If (Allocated(GradRef)) Then
         lTrans = .False.
         r12_p => GradRef
c        write(6,*), 'Using Reference Gradient'
      Else
         Call qpg_dArray('Transverse',lTrans,nTrans)
         If (lTrans) Then
            Call mma_allocate(TV,3,nCent,Label='TV')
            Call Get_dArray('Transverse',TV,3*nCent)
            r12_p => TV
c           write(6,*), 'Using stored Transverse'
         Else
            r12_p => R12
c           write(6,*), 'Using R-P Vector'
         End If
      End If
*                                                                      *
************************************************************************
*                                                                      *
c     Call RecPrt('Ref',' ',RefGeo,3,nCent)
c     Call RecPrt('R12',' ',r12_p,3,nCent)
*
*     Length of the direction vector (weighted)
*
      RR_R12 = Zero
      TWeight = Zero
      Do iCent = 1, nCent
         Fact = Dble(iDeg(xyz(1,iCent)))
         xWeight = Fact*Weights(iCent)
         TWeight = TWeight+xWeight
         Do i = 1, 3
            RR_R12 = RR_R12 + xWeight*(r12_p(i,iCent))**2
         End Do
      End Do
      RR_R12=Sqrt(RR_R12)
*
*     The distance scaling will be 1/Sqrt(TWeight)
*
      SqInvTWeight=One/Sqrt(TWeight)
*
*     Dot product between the x-x0 vector and the direction (weighted)
*
      f=Zero
      Do iCent = 1, nCent
         Fact = Dble(iDeg(xyz(1,iCent)))
         xWeight = Fact*Weights(iCent)
         Do i = 1, 3
            f = f + xWeight*(xyz(i,iCent)-RefGeo(i,iCent))
     &        *  r12_p(i,iCent)
         End Do
      End Do
*
*     The distance to the plane is the dot product / direction length
*
      If (RR_R12.eq.Zero) Then
         HDist = Zero
      Else
         HDist = f / RR_R12 * SqInvTWeight
      End If
c     Write (6,*) 'f, RR_R12=',f,RR_R12
*
      If (l_Write) Then
         Write (6,'(2A,F18.8,A)') Label,' : Hyperplane distance =',
     &                            HDist,
     &                            ' au (weighted/sqrt(total weight)'
      End If
*
*                                                                      *
************************************************************************
*                                                                      *
*     Compute the WDC B-matrix
*     If the direction is null, the derivative is not defined
*
      Call FZero(Bf,3*nCent)
      If (RR_R12.gt.Zero) Then
*
*        The derivative is simply the unit direction vector
*        (with weighting and scaling accounted for)
*
         Do iCent = 1, nCent
            Fact = Dble(iDeg(xyz(1,iCent)))
            xWeight = Fact*Weights(iCent)
            Do i = 1, 3
               Bf(i,iCent) = xWeight*r12_p(i,iCent)/RR_R12*SqInvTWeight
            End Do
         End Do
      End If
c     Call RecPrt('Bf',' ',Bf,3,nCent)
*                                                                      *
************************************************************************
*                                                                      *
*     The second derivative is null, as the derivative is constant
*
      If (ldB) Then
         Call FZero(dBf,(3*nCent)**2)
      End If
*
      If (lTrans) Call mma_deallocate(TV)
      r12_p => Null()
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Bernd Artur Hess                                 *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine PVInt( &
#                define _CALLING_
#                include "int_interface.fh"
                 , Kernel)

!***********************************************************************
!                                                                      *
! Object: kernel routine for the computation of  pX integrals          *
!                                                                      *
!   (See arguments in int_interface.fh)                                *
!                                                                      *
!     Author: Bernd Hess, Institut fuer Physikalische und Theoretische *
!             Chemie, University of Bonn, Germany, April 1993          *
!***********************************************************************

use Index_Functions, only: nTri_Elem1
use Integral_interfaces, only: int_kernel
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
#include "int_interface.fh"
procedure(int_kernel) :: Kernel
integer(kind=iwp) :: iBeta, ipA, ipArr, ipOff, ipS1, ipS2, kRys, mArr, nip
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i
#endif

#include "macros.fh"
unused_var(nHer)
!                                                                      *
!***********************************************************************
!                                                                      *

#ifdef _DEBUGPRINT_
write(u6,*) 'PVInt: nIC,nComp=',nIC,nComp
call RecPrt(' In pvint: Alpha','(5ES20.13)',Alpha,nAlpha,1)
call RecPrt(' In pvint: Beta','(5ES20.13)',Beta,nBeta,1)
#endif

nip = 1
ipA = nip
nip = nip+nZeta
ipS1 = nip
nip = nip+nZeta*nTri_Elem1(la+1)*nTri_Elem1(lb)*nIC
ipS2 = 1
if (la > 0) then
  ipS2 = nip
  nip = nip+nZeta*nTri_Elem1(la-1)*nTri_Elem1(lb)*nIC
else
  ipS2 = ipS1
end if
ipArr = nip
mArr = nArr-(nip-1)/nZeta
if (mArr < 0) then
  call WarningMessage(2,'pVInt: mArr<0!')
  call Abend()
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute contribution from a+1,b

kRys = ((la+1)+lb+2)/2
call Kernel(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS1:ipS2-1),nZeta,nIC,nComp,la+1,lb,A,RB,kRys,Array(ipArr:),mArr, &
            CoorO,nOrdOp,lOper,iChO,iStabM,nStabM,PtChrg,nGrid,iAddPot)
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute contribution from a-1,b

if (la > 0) then
  kRys = ((la-1)+lb+2)/2
  call Kernel(Alpha,nAlpha,Beta,nBeta,Zeta,ZInv,rKappa,P,Array(ipS2:ipArr-1),nZeta,nIC,nComp,la-1,lb,A,RB,kRys,Array(ipArr:),mArr, &
              CoorO,nOrdOp,lOper,iChO,iStabM,nStabM,PtChrg,nGrid,iAddPot)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
ipOff = ipA-1
do iBeta=1,nBeta
  Array(ipOff+1:ipOff+nAlpha) = Alpha
  ipOff = ipOff+nAlpha
end do
#ifdef _DEBUGPRINT_
call RecPrt(' In pvint: Alpha (expanded)','(5ES20.13)',Array(ipA),nZeta,1)
#endif
!                                                                      *
!***********************************************************************
!                                                                      *
! Assemble final integral from the derivative integrals

call Ass_pX(Array(ipA),nZeta,rFinal,la,lb,Array(ipS1),Array(ipS2),nIC)
!                                                                      *
!***********************************************************************
!                                                                      *
#ifdef _DEBUGPRINT_
do i=1,3
  call RecPrt('pVInt: rFinal',' ',rFinal(:,:,:,i),nZeta,nTri_Elem1(la)*nTri_Elem1(lb))
end do
#endif

end subroutine PVInt

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE PRIMSGM(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB1,
     &                   IFSBTAB2,COEFF,SGM,PSI)
      IMPLICIT NONE
      REAL*8 PSI(*),SGM(*)
      REAL*8 COEFF,CFFPHS,SCALE
      INTEGER IORBTAB(*),NASPRT
      INTEGER ISSTAB(*)
      INTEGER IFSBTAB1(*),IFSBTAB2(*)
      INTEGER IFSB1,IBLKPOS1,ISST1,KSTARR1,NSBS1
      INTEGER IFSB2,IBLKPOS2,ISST2,KSTARR2,NSBS2
      INTEGER NSSTP,NHSH2,KHSH2,NFSB1,ISST,NSBS
      INTEGER NPOP1,IMODE,KSSTOP,KSBSOP
      INTEGER NDI,NDJ,KPOS,ISPART,KSSTTB
      INTEGER I,J,IPOS1,IPOS2,ISUM,LSBSET,ISP
      INTEGER ISSTARR(50)
      INTEGER ISBS1,ISBS2,ISORB,KOINFO,KSBSCR,KSBSAN
      INTEGER KSBS1,KSBS2,KSORB,KSSTCR,KSSTAN,MORSBITS
C     INTEGER NBLKDET1,NBLKDET2,NDETS1,NDETS2,IERR
      INTEGER NBLKDET1,NBLKDET2,NDETS1,NDETS2
C     INTEGER LDUM,NDUM
#include "WrkSpc.fh"
C Purpose: Add to the wave function SGM the result of applying
C an operator to PSI. The operator is a single creator (IMODE=1)
C or annihilator (IMODE=-1) multiplied by COEFF. Only the
C sector of SGM described by IFSBTAB1 will be updated.
      IF(COEFF.EQ.0.0D0) RETURN
C The orbital table:
      NASPRT= IORBTAB(9)
      KOINFO=19
      ISPART=IORBTAB(KOINFO+6+8*(ISORB-1))
      KSORB =IORBTAB(KOINFO+7+8*(ISORB-1))
C The substring table:
      MORSBITS=ISSTAB(6)
      NSSTP   =ISSTAB(7)
      KSSTTB=15
      KSSTAN=ISSTAB( 9)
      KSSTCR=ISSTAB(10)
      KSBSAN=ISSTAB(13)
      KSBSCR=ISSTAB(14)
      IF(IMODE.EQ.1) THEN
        KSSTOP=KSSTAN
        KSBSOP=KSBSAN
      ELSE
        KSSTOP=KSSTCR
        KSBSOP=KSBSCR
      END IF
C The FS blocks of the SGM wave function:
      NFSB1=IFSBTAB1(3)
      NDETS1=IFSBTAB1(5)
      KSTARR1=8
C The FS blocks of the PSI wave function:
      NDETS2=IFSBTAB2(5)
      NHSH2=IFSBTAB2(6)
      KHSH2=IFSBTAB2(7)
      KSTARR2=8
C Make an array with nr of earlier substrings for each
C substring type:
      CALL GETMEM('NSBSET','Allo','Inte',LSBSET,NSSTP)
      ISUM=0
      DO ISST=1,NSSTP
        IWORK(LSBSET-1+ISST)=ISUM
        NSBS=ISSTAB(KSSTTB+5*(ISST-1))
        ISUM=ISUM+NSBS
      END DO

C Loop over FS blocks of the SGM wave function
      DO IFSB1=1,NFSB1
        KPOS=KSTARR1+(NASPRT+2)*(IFSB1-1)
        DO ISP=1,NASPRT
          ISSTARR(ISP)=IFSBTAB1(KPOS-1+ISP)
        END DO
        NBLKDET1 =IFSBTAB1(KPOS+NASPRT  )
        IBLKPOS1 =IFSBTAB1(KPOS+NASPRT+1)
C Initial values for lower and higher dimensions.
C Also, extra phase factor due to spin orbitals in higher substrings.
        NDI=1
        DO ISP=1,ISPART-1
          ISST1=ISSTARR(ISP)
          NSBS1=ISSTAB(KSSTTB+5*(ISST1-1))
          NDI=NDI*NSBS1
        END DO
        NDJ=1
        CFFPHS=COEFF
        DO ISP=ISPART+1,NASPRT
          ISST1=ISSTARR(ISP)
          NSBS1=ISSTAB(KSSTTB+0+5*(ISST1-1))
          NPOP1=ISSTAB(KSSTTB+1+5*(ISST1-1))
          NDJ=NDJ*NSBS1
          IF(NPOP1.NE.2*(NPOP1/2)) CFFPHS=-CFFPHS
        END DO
        ISST1=ISSTARR(ISPART)
        NSBS1=ISSTAB(KSSTTB+5*(ISST1-1))

C Modify the bra substring type by annih or creating ISORB
        ISST2=ISSTAB(KSSTOP-1+KSORB+MORSBITS*(ISST1-1))
        IF(ISST2.EQ.0) GOTO 200

C Determine dimensions for multiple daxpy:
C Dimension for earlier subpartitions is NDI
C Dimension for later   subpartitions is NDJ
C Dimensions for present subpartition are NSBS1,NSBS2

        NSBS2=ISSTAB(KSSTTB+5*(ISST2-1))
        ISSTARR(ISPART)=ISST2
C Get the corresponding FS block number
        CALL HSHGET(ISSTARR,NASPRT,NASPRT+2,IFSBTAB2(KSTARR2),
     &                NHSH2,IFSBTAB2(KHSH2),IFSB2)
        ISSTARR(ISPART)=ISST1
        IF(IFSB2.EQ.0) GOTO 200
        KPOS=KSTARR2+(NASPRT+2)*(IFSB2-1)
        NBLKDET2 =IFSBTAB2(KPOS+NASPRT  )
        IBLKPOS2 =IFSBTAB2(KPOS+NASPRT+1)
C Now loop over ket substrings in this subpartition
        DO KSBS1=1,NSBS1
          ISBS1=KSBS1+IWORK(LSBSET-1+ISST1)
          ISBS2=ISSTAB(KSBSOP-1+KSORB+MORSBITS*(ISBS1-1))
          IF(ISBS2.EQ.0) GOTO 100
          IF(ISBS2.GT.0) THEN
            SCALE= CFFPHS
            ISBS2= ISBS2
          ELSE
            SCALE=-CFFPHS
            ISBS2=-ISBS2
          END IF
          KSBS2=ISBS2-IWORK(LSBSET-1+ISST2)

C CALL some multiple daxpy...
          IF (NDI.EQ.1) THEN
           IF (NDJ.EQ.1) THEN
            IPOS1=IBLKPOS1+(KSBS1-1)
            IPOS2=IBLKPOS2+(KSBS2-1)
            SGM(IPOS1)=SGM(IPOS1)+SCALE*PSI(IPOS2)
           ELSE
            DO J=0,NDJ-1
             IPOS1=IBLKPOS1+(KSBS1-1+NSBS1*J)
             IPOS2=IBLKPOS2+(KSBS2-1+NSBS2*J)
             SGM(IPOS1)=SGM(IPOS1)+SCALE*PSI(IPOS2)
            END DO
           END IF
          ELSE
           IF (NDJ.EQ.1) THEN
            DO I=0,NDI-1
             IPOS1=IBLKPOS1+I+NDI*(KSBS1-1)
             IPOS2=IBLKPOS2+I+NDI*(KSBS2-1)
             SGM(IPOS1)=SGM(IPOS1)+SCALE*PSI(IPOS2)
            END DO
           ELSE
            DO J=0,NDJ-1
             DO I=0,NDI-1
              IPOS1=IBLKPOS1+I+NDI*(KSBS1-1+NSBS1*J)
              IPOS2=IBLKPOS2+I+NDI*(KSBS2-1+NSBS2*J)
              SGM(IPOS1)=SGM(IPOS1)+SCALE*PSI(IPOS2)
             END DO
            END DO
           END IF
          END IF

 100      CONTINUE
        END DO

C End of loop over FS blocks
 200    CONTINUE
      END DO
      CALL GETMEM('NSBSET','Free','Inte',LSBSET,NSSTP)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2008, Francesco Aquilante                              *
************************************************************************
      SubRoutine LovMP2_Drv(irc,EMP2,CMO,EOcc,EVir,NamAct,nActa,
     &                          Thrs,DoMP2,all_Vir)

************************************************************************
*                                                                      *
* Purpose:  setup of Localized occupied-virtual MP2  (LovMP2)          *
*           The MP2 correction to the energy will later be computed    *
*           only for the "active region" of the molecule.              *
*           The MP2 correction due to the remaining frozen region      *
*           is computed here if DoMP2=.true.                           *
*                                                                      *
* Author:   F. Aquilante  (Geneva, Jun. 2008)                          *
*                                                                      *
************************************************************************
#include "implicit.fh"
#include "itmax.fh"
#include "Molcas.fh"
#include "real.fh"
#include "corbinf.fh"
#include "orbinf2.fh"
#include "WrkSpc.fh"
      Real*8 OED_Thr, EOSMP2, C_os, XEMP2, Wref
      Common / ChSOS2 / OED_Thr, EOSMP2, C_os
      Common / ChMP24 / XEMP2, Wref

      Dimension CMO(*), EOcc(*), EVir(*)
      Real*8  Thrs
      Logical DoMP2, all_Vir
      Character*(LENIN8) Name(mxBas)
      Character*(LENIN) NamAct(*)
      Logical ortho
      Real*8  TrA(8), TrF(8), TrX(8)
      Integer ns_O(8), ns_V(8), nZero(8)
      Integer lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
      Integer lnOcc2(8), lnFro2(8), lnDel2(8), lnVir2(8), nAuxO(8)

      Character*3  ThisNm
      Character*10 SecNam
      Parameter (SecNam = 'LovMP2_Drv', ThisNm = 'Dry')


      irc=0
      EMP2=0.0d0
      EFRO=0.0d0
      EOSF=0.0d0
      iDo=0
      jDo=0
*
*----------------------------------------------------------------------*
*     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
*----------------------------------------------------------------------*
*
      nxBasT=0
      ntri=0
      nSQ=0
      nBmx=0
      nxOrb=0
      Do i=1,nSym
        TrA(i)=0.0d0
        TrF(i)=0.0d0
        TrX(i)=0.0d0
        nZero(i)=0
        nxBasT=nxBasT+nBas(i)
        nxOrb=nxOrb+nFro(i)+nOcc(i)+nExt(i)+nDel(i)
        ntri=ntri+nBas(i)*(nBas(i)+1)/2
        nSQ=nSQ+nBas(i)**2
        nBmx=Max(nBmx,nBas(i))
      End Do
      IF(nxBasT.GT.mxBas) then
       Write(6,'(/6X,A)')
     & 'The number of basis functions exceeds the present limit'
       Call Abend
      Endif
*
      Call Get_cArray('Unique Basis Names',Name,(LENIN8)*nxBasT)
*
*----------------------------------------------------------------------*
*     Read the overlap matrix                                          *
*----------------------------------------------------------------------*
      CALL GetMem('SMAT','ALLO','REAL',ipSQ,nSQ)
      CALL GetMem('SLT','ALLO','REAL',ipS,nTri)
      isymlbl=1
      Call RdOne(irc,6,'Mltpl  0',1,Work(ipS),isymlbl)
      If(irc.ne.0) Then
        return
      End If
      ltri=0
      lsq=0
      Do iSym=1,nSym
         Call Square(Work(ipS+ltri),Work(ipSQ+lsq),1,nBas(iSym),
     &                                               nBas(iSym))
         ltri=ltri+nBas(iSym)*(nBas(iSym)+1)/2
         lsq=lsq+nBas(iSym)**2
      End Do
      CALL GetMem('SLT','FREE','REAL',ipS,nTri)
*
      Write(6,'(A,F15.6)') ' Threshold for atom selection: ',Thrs
      Write(6,*)
      If (nActa.ne.0) Then
         Write(6,'(A,I3,A)') ' Selected ',nActa,' atoms: '
         Write(6,*)
         Write(6,*) (NamAct(i),i=1,nActa)
         Write(6,*)
      ElseIf (.not.DoMP2) Then
         Write(6,'(A,18A4)') ' Selected atoms: *** None *** '
         Go To 2000
      Else
         Write(6,'(A,18A4)') ' Selected atoms: *** None *** '
      EndIf

*----------------------------------------------------------------------*
      Call Get_Tr_Dab(nSym,nBas,nFro,nOcc,nExt,nDel,
     &                CMO,EOcc,EVir,TrX)
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
*     Localize the inactive and virtual orbitals                       *
*                                                                      *
*        1) inactive orbitals ---> cholesky orbitals (orthonormal)     *
*        2) virtual orbitals ---> lin. indep. PAOs (non-orthonormal)   *
*                                                                      *
*----------------------------------------------------------------------*
      CALL GetMem('LCMO','ALLO','REAL',iCMO,3*nSQ)
      ipXMO=iCMO+nSQ
      iXMO=ipXMO+nSQ
      call dcopy_(nSQ,CMO,1,Work(ipXMO),1)
      Thrd=1.0d-06
      Call GetMem('ID_vir','Allo','Inte',iD_vir,nxBasT)
      Call Cho_ov_Loc(irc,Thrd,nSym,nBas,nFro,nOcc,
     &                    nZero,nExt,Work(ipXMO),Work(ipSQ),
     &                    iWork(iD_vir))

      If(irc.ne.0) then
       write(6,*) 'Localization failed in LovMP2'
       Call Abend
      Endif

      Call GetMem('Eorb','Allo','Real',kEOcc,2*nxOrb)
      kEVir=kEOcc+nxOrb
      call dcopy_(nxOrb,EOcc,1,Work(kEOcc),1)
      call dcopy_(nxOrb,EVir,1,Work(kEVir),1)

      Call GetMem('Saa','Allo','Real',ipSaa,nxOrb)
      call dcopy_(nxOrb,[1.0d0],0,Work(ipSaa),1)


*     Occupied orbital selection                                       *
*----------------------------------------------------------------------*
      iOff=0
      kOff=0
      Do iSym=1,nSym
         jOff=iOff+nBas(iSym)*nFro(iSym)
         call dcopy_(nBas(iSym)*nOcc(iSym),Work(ipXMO+jOff),1,
     &                                    Work(iXMO+kOff),1)
         call dcopy_(nBas(iSym)*nOcc(iSym),CMO(1+jOff),1,
     &                                    Work(iCMO+kOff),1)
         iOff=iOff+nBas(iSym)**2
         kOff=kOff+nBas(iSym)*nOcc(iSym)
      End Do
      ortho=.true.
*
      Call get_Orb_select(irc,Work(iCMO),Work(iXMO),Work(kEOcc),
     &                        Work(ipSQ),Work(ipSaa),Name,NamAct,
     &                        nSym,nActa,nOcc,nBas,ortho,Thrs,ns_O)
      If(irc.ne.0) Then
        Return
      End If
      iOff=0
      kOff=0
      Do iSym=1,nSym
         lOff=iOff+nBas(iSym)*nFro(iSym)
         Do ik=nOcc(iSym),1,-1
            jOff=kOff+nBas(iSym)*(ik-1)
            call dcopy_(nBas(iSym),Work(iCMO+jOff),1,
     &                            CMO(1+lOff),1)
            lOff=lOff+nBas(iSym)
         End Do
         iOff=iOff+nBas(iSym)**2
         kOff=kOff+nBas(iSym)*nOcc(iSym)
      End Do
      iloc=0
      loff=0
      Do iSym=1,nSym
         Do ik=nOcc(iSym),1,-1
            ie=kEOcc+loff+ik-1
            iloc=iloc+1
            EOcc(iloc)=Work(ie)
         End Do
         loff=loff+nOcc(iSym)
      End Do
*
      If (all_Vir) Then
         Do iSym=1,nSym
            ns_V(iSym)=nExt(iSym)
         End Do
         goto 999
      EndIf
*
*     Virtual orbital selection                                        *
*----------------------------------------------------------------------*
      iOff=0
      kOff=0
      Do iSym=1,nSym
         jOff=iOff+nBas(iSym)*(nFro(iSym)+nOcc(iSym))
         call dcopy_(nBas(iSym)*nExt(iSym),Work(ipXMO+jOff),1,
     &                                    Work(iXMO+kOff),1)
         call dcopy_(nBas(iSym)*nExt(iSym),CMO(1+jOff),1,
     &                                    Work(iCMO+kOff),1)
         iOff=iOff+nBas(iSym)**2
         kOff=kOff+nBas(iSym)*nExt(iSym)
      End Do
      ortho=.false.
*
      Call get_Vir_select(irc,Work(iCMO),Work(iXMO),Work(kEVir),
     &                        Work(ipSQ),Name,NamAct,iWork(iD_vir),
     &                        nSym,nActa,nExt,nBas,ortho,ns_V)
      If(irc.ne.0) Then
        Return
      End If
      Call GetMem('ID_vir','Free','Inte',iD_vir,nxBasT)
      iOff=0
      kOff=0
      Do iSym=1,nSym
         jOff=iOff+nBas(iSym)*(nFro(iSym)+nOcc(iSym))
         call dcopy_(nBas(iSym)*nExt(iSym),Work(iCMO+kOff),1,
     &                                    CMO(1+jOff),1)
         iOff=iOff+nBas(iSym)**2
         kOff=kOff+nBas(iSym)*nExt(iSym)
      End Do
      iloc=0
      loff=0
      Do iSym=1,nSym
         Do ik=1,nExt(iSym)
            ie=kEVir+loff+ik-1
            iloc=iloc+1
            EVir(iloc)=Work(ie)
         End Do
         loff=loff+nExt(iSym)
      End Do

999   Continue
      iDo=0
      jDo=0
      Do iSym=1,nSym  ! setup info
         lnOcc2(iSym)=nOcc(iSym)
         lnFro2(iSym)=nFro(iSym)
         lnDel2(iSym)=nDel(iSym)
         lnVir2(iSym)=nExt(iSym)
         lnOrb(iSym)=nBas(iSym)
         lnOcc(iSym)=nOcc(iSym)-ns_O(iSym)
         lnFro(iSym)=nFro(iSym)+ns_O(iSym)
         lnDel(iSym)=nDel(iSym)+ns_V(iSym)
         lnVir(iSym)=nExt(iSym)-ns_V(iSym)
         iDo=Max(iDo,lnOcc(iSym))
         jDo=Max(jDo,lnVir(iSym))
      End Do
      If (Min(iDo,jDo).eq.0) goto 1000

*     MP2 calculation on the Frozen region                             *
*----------------------------------------------------------------------*
      If (DoMP2) Then
*
         iloc=0
         jloc=0
         loff=0
         joff=0
         Do iSym=1,nSym
            Do ik=ns_V(iSym)+1,nExt(iSym)
               ie=loff+ik
               Work(kEVir+iloc)=EVir(ie)
               iloc=iloc+1
            End Do
            loff=loff+nExt(iSym)
            Do ik=1,lnOcc(iSym)
               ie=joff+ik
               Work(kEOcc+jloc)=EOcc(ie)
               jloc=jloc+1
            End Do
            joff=joff+nOcc(iSym)
         End Do
         iOff=0
         nVV=0
         nOA=0
         Do iSym=1,nSym
            kfr=1+iOff+nBas(iSym)*nFro(iSym)
            kto=iCMO+iOff+nBas(iSym)*lnFro(iSym)
            call dcopy_(nBas(iSym)*lnOcc(iSym),CMO(kfr),1,Work(kto),1)
            kfr=1+iOff+nBas(iSym)*(nFro(iSym)+nOcc(iSym)+ns_V(iSym))
            kto=kto+nBas(iSym)*lnOcc(iSym)
            call dcopy_(nBas(iSym)*lnVir(iSym),CMO(kfr),1,Work(kto),1)
            iOff=iOff+nBas(iSym)**2
            nVV=nVV+lnVir(iSym)**2
            nOA=nOA+lnOcc(iSym)
         End Do
         Call Check_Amp2(nSym,lnOcc,lnVir,iSkip)
         If (iSkip.gt.0) Then
          Call GetMem('Dmat','Allo','Real',ip_X,nVV+nOA)
          ip_Y=ip_X+nVV
          Call FZero(Work(ip_X),nVV+nOA)
          Call LovMP2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,ip_X,
     &                       ip_Y,.true.)
          Call ChoMP2_Drv(irc,Dummy,Work(iCMO),Work(kEOcc),Work(kEVir))
          Call LovMP2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,ip_X,
     &                       ip_Y,.false.) ! compute energy and not Dab
          Call ChoMP2_Drv(irc,EFRO,Work(iCMO),Work(kEOcc),Work(kEVir))
          If(irc.ne.0) then
            write(6,*) 'Frozen region MP2 failed'
            Call Abend
          Else
            Write (6,'(A,F20.10,A)')
     &    ' Frozen region E2 contrib. = ',EFRO,' a.u.'
            EOSF=EOSMP2
            Write (6,'(A,F20.10,A)')
     &    ' (Opposite-Spin contrib.   = ',-EOSF,' )'
            Write (6,*)
          Endif
          iV=ip_X
          Do iSym=1,nSym
            TrF(iSym)=ddot_(lnVir(iSym),Work(iV),1+lnVir(iSym),
     &                      [1.0d0],0)
            iV=iV+lnVir(iSym)**2
          End Do
          Call GetMem('Dmat','Free','Real',ip_X,nVV+nOA)
          Do iSym=1,nSym
             nOcc(iSym)=lnOcc2(iSym)
             nFro(iSym)=lnFro2(iSym)
             nDel(iSym)=lnDel2(iSym)
             nExt(iSym)=lnVir2(iSym)
          End Do
         EndIf

      EndIf
1000  Continue
*                                                                      *
*----------------------------------------------------------------------*
*
*     Update the nFro, nOcc, nExt, nDel for the Active site MP2
      Do iSym=1,nSym
         nFro(iSym)=nFro(iSym)+nOcc(iSym)-ns_O(iSym)
         nOcc(iSym)=ns_O(iSym)
         nDel(iSym)=nDel(iSym)+nExt(iSym)-ns_V(iSym)
         nExt(iSym)=ns_V(iSym)
         iDo=Max(iDo,nOcc(iSym))
         jDo=Max(jDo,nExt(iSym))
         nAuxO(iSym)=nBas(iSym)-nDel(iSym)
      End Do
      Call Put_iArray('nFroPT',nFro,nSym)
      Call Put_iArray('nDelPT',nDel,nSym)
      Call Put_iArray('nOrb',nAuxO,nSym)
*
      Call Check_Amp2(nSym,nOcc,nExt,iSkip)
      If (iSkip.gt.0) Then
         iOff=0
         lOff=0
         jk=1
         ja=1
         nVV=0
         nOA=0
         Do iSym=1,nSym
            Do ik=1,nOcc(iSym)
               kk=ik+iOff+lnOcc(iSym)
               EOcc(jk)=EOcc(kk)
               jk=jk+1
            End Do
            iOff=iOff+lnOcc(iSym)+nOcc(iSym)
            Do ia=1,nExt(iSym)
               ka=ia+lOff
               EVir(ja)=EVir(ka)
               ja=ja+1
            End Do
            lOff=lOff+lnVir(iSym)+nExt(iSym)
            nVV=nVV+nExt(iSym)**2
            nOA=nOA+nOcc(iSym)
         End Do
*
         Write(6,*)
         Write(6,'(A,8I4)')
     & ' Frozen orbitals after selection :  ',(nFro(i),i=1,nSym)
         Write(6,'(A,8I4)')
     & ' Occupied orbitals after selection: ',(nOcc(i),i=1,nSym)
         Write(6,*)
         Write(6,*) 'Energies of the active occupied orbitals '
         ii=0
         Do iSym=1,nSym
            If ( nOcc(iSym).ne.0 ) then
               Write(6,*)
               Write(6,'(A,I2,(T40,5F14.6))')
     &            ' symmetry species',iSym,(EOcc(ii+k),k=1,nOcc(iSym))
               ii=ii+nOcc(iSym)
            End If
         End Do
         Write(6,*)
*
         Write(6,*)
         Write(6,'(A,8I4)')
     & ' Secondary orbitals after selection:',(nExt(i),i=1,nSym)
         Write(6,'(A,8I4)')
     & ' Deleted orbitals after selection:  ',(nDel(i),i=1,nSym)
         Write(6,*)
         Write(6,*) 'Energies of the active virtual orbitals '
         ii=0
         Do iSym=1,nSym
            If ( nExt(iSym).ne.0 ) then
               Write(6,*)
               Write(6,'(A,I2,(T40,5F14.6))')
     &            ' symmetry species',iSym,(EVir(ii+k),k=1,nExt(iSym))
               ii=ii+nExt(iSym)
            End If
         End Do
         Write(6,*)
*
         Call GetMem('Dmat','Allo','Real',ip_X,nVV+nOA)
         ip_Y=ip_X+nVV
         Call FZero(Work(ip_X),nVV+nOA)
         Call LovMP2_putInf(nSym,lnOrb,nOcc,nFro,nDel,nExt,ip_X,ip_Y,
     &                      .true.)
         Call ChoMP2_Drv(irc,Dummy,CMO,EOcc,EVir)
         Call LovMP2_putInf(nSym,lnOrb,nOcc,nFro,nDel,nExt,ip_X,ip_Y,
     &                      .false.)
         Wref=0.0d0
         Call ChoMP2_Drv(irc,EMP2,CMO,EOcc,EVir)
         If(irc.ne.0) then
           write(6,*) 'LovMP2 failed'
           Call Abend
         Endif
         iV=ip_X
         Do iSym=1,nSym
           TrA(iSym)=ddot_(nExt(iSym),Work(iV),1+nExt(iSym),[1.0d0],0)
           iV=iV+nExt(iSym)**2
         End Do
         Call GetMem('Dmat','Free','Real',ip_X,nVV+nOA)
      EndIf
      write(6,*)'------------------------------------------------------'
      write(6,*)' Symm.   Tr(D):  Active        Frozen         Full    '
      write(6,*)'------------------------------------------------------'
      STrA=0.0d0
      STrF=0.0d0
      STrX=0.0d0
      Do iSym=1,nSym
        write(6,'(2X,I4,9X,G11.4,3X,G11.4,3X,G11.4)') iSym,TrA(iSym),
     &       TrF(iSym),TrX(iSym)
        STrA=STrA+TrA(iSym)
        STrF=STrF+TrF(iSym)
        STrX=STrX+TrX(iSym)
      End Do
      write(6,*)'------------------------------------------------------'
      write(6,'(A,G11.4,3X,G11.4,3X,G11.4)')'          Sum: ',
     & STrA,STrF,STrX
      write(6,*)'------------------------------------------------------'
      write(6,*)
*
      Write (6,'(A,F20.10,A)')
     &    ' Active region E2 contrib. = ',EMP2,' a.u.'
            Write (6,'(A,F20.10,A)')
     &    ' (Opposite-Spin contrib.   = ',-EOSMP2,' )'
      Write (6,*)
*
      XEMP2= EFRO
      EMP2 = EMP2 + EFRO
      EOSMP2 = EOSMP2 + EOSF
*
*     Update runfile for subsequent calcs (e.g., CHCC)
      ioff=0
      joff=0
      koff=0
      Do iSym=1,nSym
         ifr=1+ioff
         ito=kEOcc+koff+nFro(iSym)
         call dcopy_(nOcc(iSym),EOcc(ifr),1,Work(ito),1)
         ifr=1+joff
         ito=ito+nOcc(iSym)
         call dcopy_(nExt(iSym),EVir(ifr),1,Work(ito),1)
         ioff=ioff+nOcc(iSym)
         joff=joff+nExt(iSym)
         koff=koff+nBas(iSym)
      End Do
      Call Put_dArray('OrbE',Work(kEOcc),nxOrb)
      Call Put_dArray('Last orbitals',CMO,nSQ)
*
      Call GetMem('LCMO','Free','Real',iCMO,3*nSQ)
      Call GetMem('Saa','Free','Real',ipSaa,nxOrb)
      Call GetMem('Eorb','Free','Real',kEOcc,2*nxOrb)

2000  Continue
      If (Min(iDo,jDo).eq.0) Then
         Write(6,*)
         Write(6,*)' None of the occupied or virtual orbitals has been '
         Write(6,*)' assigned to the Active region of the molecule.    '
         Write(6,*)' This is presumably NOT what you want !!!          '
         Write(6,*)' MP2 will Stop here. Bye Bye !! '
         Write(6,*)
         Call Abend
      EndIf

      CALL GetMem('SMAT','FREE','REAL',ipSQ,nSQ)
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine Check_Amp2(nSym,nOcc,nVir,iSkip)

      Implicit Real*8 (a-h,o-z)
      Integer nSym, nOcc(nSym), nVir(nSym), iSkip
      Integer nT1amTot, nT1am(8)

      MulD2h(i,j)=iEor(i-1,j-1) + 1

      iSkip=0
      nT1amTot=0
      Do iSym = 1,nSym
         nT1am(iSym) = 0
         Do iSymi = 1,nSym
            iSyma = MulD2h(iSymi,iSym)
            nT1am(iSym) = nT1am(iSym)
     &                  + nVir(iSyma)*nOcc(iSymi)
         End Do
         nT1amTot = nT1amTot + nT1am(iSym)
      End Do

      If (nT1amTot .gt. 0) iSkip=1
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      SubRoutine LovMP2_putInf(mSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,
     &                         ip_X,ip_Y,isFNO)
C
C     Purpose: put info in MP2 common blocks.
C
#include "implicit.fh"
      Integer lnOrb(8), lnOcc(8), lnFro(8), lnDel(8), lnVir(8)
      Integer ip_X, ip_Y
      Logical isFNO
C
#include "corbinf.fh"
#include "chomp2_cfg.fh"
C
C
      nSym = mSym
C
      Do iSym = 1,nSym
         nOrb(iSym) = lnOrb(iSym)
         nOcc(iSym) = lnOcc(iSym)
         nFro(iSym) = lnFro(iSym)
         nDel(iSym) = lnDel(iSym)
         nExt(iSym) = lnVir(iSym)
      End Do
C
      ChoAlg=2
      DecoMP2=Decom_Def
      ThrMP2=-9.9D9
      SpanMP2=Span_Def
      MxQualMP2=MxQual_Def
      ChkDecoMP2=.false.
      ForceBatch=.false.
      Verbose=.false.
      SOS_mp2=.false.
      set_cd_thr=.true.
      OED_Thr=1.0d-8
      C_os=1.3d0
      EOSMP2=0.0d0
C
      DoFNO=isFNO
      ip_Dab=ip_X
      ip_Dii=ip_Y
      l_Dab=nExt(1)
      l_Dii=nOcc(1)
      Do iSym=2,nSym
         l_Dab=l_Dab+nExt(iSym)**2
         l_Dii=l_Dii+nOcc(iSym)
      End Do
C
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine Get_Tr_Dab(nSym,nBas,nFro,nIsh,nSsh,nDel,
     &                      CMO,EOcc,EVir,TrD)

      Implicit Real*8 (a-h,o-z)
      Integer nSym, nBas(nSym), nFro(nSym), nIsh(nSym)
      Integer nSsh(nSym), nDel(nSym)
      Real*8  CMO(*), EOcc(*), EVir(*), TrD(nSym)
#include "WrkSpc.fh"
      Integer lnOrb(8), lnFro(8), lnOcc(8), lnVir(8), lnDel(8)
*
*
*
      nVV=0
      nBB=0
      nOA=0
      Do iSym=1,nSym  ! setup info
         lnOrb(iSym)=nBas(iSym)
         lnFro(iSym)=nFro(iSym)
         lnOcc(iSym)=nIsh(iSym)
         lnVir(iSym)=nSsh(iSym)
         lnDel(iSym)=nDel(iSym)
         nVV=nVV+lnVir(iSym)**2
         nBB=nBB+nBas(iSym)**2
         nOA=nOA+lnOcc(iSym)
      End Do
*
      Call GetMem('Dmat','Allo','Real',ip_X,nVV+nOA)
      ip_Y=ip_X+nVV
      Call FZero(Work(ip_X),nVV+nOA)
*
      Call LovMP2_putInf(nSym,lnOrb,lnOcc,lnFro,lnDel,lnVir,ip_X,ip_Y,
     &                   .true.)
      Call GetMem('CMON','Allo','Real',iCMO,nBB)
      Call FZero(Work(iCMO),nBB)
      iOff=0
      Do iSym=1,nSym
         kfr=1+iOff+nBas(iSym)*nFro(iSym)
         kto=iCMO+iOff+nBas(iSym)*lnFro(iSym)
         call dcopy_(nBas(iSym)*lnOcc(iSym),CMO(kfr),1,Work(kto),1)
         kfr=1+iOff+nBas(iSym)*(nFro(iSym)+nIsh(iSym))
         kto=kto+nBas(iSym)*lnOcc(iSym)
         call dcopy_(nBas(iSym)*lnVir(iSym),CMO(kfr),1,Work(kto),1)
         iOff=iOff+nBas(iSym)**2
      End Do
*
      Call Check_Amp2(nSym,lnOcc,lnVir,iSkip)
      If (iSkip.gt.0) Then
         Call ChoMP2_Drv(irc,Dummy,Work(iCMO),EOcc,EVir)
         If(irc.ne.0) then
           write(6,*) 'MP2 pseudodensity calculation failed !'
           Call Abend
         Endif
      Else
         write(6,*)
         write(6,*)'There are ZERO amplitudes T(ai,bj) with the given '
         write(6,*)'combinations of occupied and virtual orbitals !! '
         write(6,*)'Check your input and rerun the calculation! Bye!!'
         Call Abend
      Endif
      Call GetMem('CMON','Free','Real',iCMO,nBB)
*
      iV=ip_X
      Do iSym=1,nSym
        TrD(iSym)=ddot_(lnVir(iSym),Work(iV),1+lnVir(iSym),[1.0d0],0)
        iV=iV+lnVir(iSym)**2
      End Do
      Call GetMem('Dmat','Free','Real',ip_X,nVV+nOA)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      FUNCTION ILEX_FOR_CONF_NEW(ICONF,NOCC_ORB,NORB,NEL,IARCW,
     &       IDOREO,IREO_new,nconf_op,ib_occls)
*
* A configuration ICONF of NOCC_ORB orbitals are given
* ICONF(I) = IORB implies  IORB is singly occupied
* ICONF(I) = -IORB  implies that IORB is doubly occupied
*
* Find lexical address
*
* IF IDOREO .ne. 0, IREO is used to reorder lexical number
* Jeppe Olsen, November 2001
*
#include "implicit.fh"
*. Arcweights for single and doubly occupied arcs
      INTEGER IARCW(NORB,NEL,2)
*. Reorder array
      INTEGER IREO_new(*)
c     integer nconf_per_open(1,*)
*. Configuration
      INTEGER ICONF(NOCC_ORB)
*
      IEL = 0
      ILEX = 1

      DO IOCC = 1, NOCC_ORB
       IF(ICONF(IOCC).GT.0) THEN
         IEL = IEL + 1
         ILEX = ILEX + IARCW(ICONF(IOCC),IEL,1)
       ELSE IF(ICONF(IOCC).LT.0) THEN
         IEL = IEL + 2
         ILEX = ILEX + IARCW(-ICONF(IOCC),IEL,2)
       END IF
      END DO
*
      IF(IDOREO.NE.0) THEN
c
c     length=nconf_per_open(2*nocc_orb-nel+1,1)
      length=nconf_op
      ntest =  0
      if(ntest.ge.10) then
      write(6,*)'in ilex_for_conf_new, check if all is right'
      write(6,*)'iconf:',(iconf(i),i=1,nocc_orb)
      write(6,*)'ilex and offset:',ilex,ib_occls
      write(6,*)'nconf_op =', nconf_op
      write(6,*)'ireo_new:'
      call iwrtma(ireo_new,1,length,1,length)
      endif
c      call iwrtma(nconf_per_open,1,4,1,4)
c.. look for the position where the value is ilex
        if (ireo_new(1).eq.ilex+ib_occls-1) then
          n_fin=1
        elseif (ireo_new(length).eq.ilex+ib_occls-1) then
          n_fin=length
        else
          n_ini = 1
          n_end = length
666          continue
            n_ave = (n_ini + n_end)/2
            if (ireo_new(n_ave).eq.ilex+ib_occls-1) goto 100
            if (ireo_new(n_ave).lt.ilex+ib_occls-1) n_ini = n_ave
            if (ireo_new(n_ave).gt.ilex+ib_occls-1) n_end = n_ave
          goto 666
100     continue
        n_fin = n_ave
        end if
        ilex_for_conf_new = n_fin

      ELSE
       ILEX_FOR_CONF_NEW = ILEX
      END IF
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Configuration '
        CALL IWRTMA(ICONF,1,NOCC_ORB,1,NOCC_ORB)
        WRITE(6,*) ' new Lexical number = ', ILEX
        IF(IDOREO.NE.0)
     &  WRITE(6,*) ' new Reordered number = ', ILEX_FOR_CONF_NEW
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine charinsert_cvb(cinsert,linsert,c,lc,ipos,idel)

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: cinsert
integer(kind=iwp), intent(in) :: linsert, ipos, idel
character(len=*), intent(inout) :: c
integer(kind=iwp), intent(inout) :: lc
character(len=300) :: buff

buff(1:lc-(ipos+idel)+1) = c(ipos+idel:lc)
c(ipos:ipos+linsert-1) = cinsert(1:linsert)
c(ipos+linsert:lc+linsert) = buff(1:lc-(ipos+idel)+1)
lc = lc+linsert-idel

return

end subroutine charinsert_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
      INTEGER FUNCTION NGENE(NEL,MLTPL)
C Nr of genealogical spin couplings
      NGENE=0
      IF(MLTPL.LE.0) RETURN
      IS2=MLTPL-1
      IF(NEL.LT.IS2) RETURN
      NU=(NEL+IS2)/2
      ND=(NEL-IS2)/2
      IF(NU+ND.NE.NEL) RETURN
      NGENE=NOVERM(NEL,NU)-NOVERM(NEL,NU+1)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Gamma_Blocks(iTable,nBlocks,nIrrep)
      Integer idid(8), iTable(6,nBlocks)
*
      iBlock=0
*
*----- Observe the loop ordering straight from GAMSRT in Aces 2.
*      THIS LOOP ORDER DOES NOT COMPLY WITH THE MANUAL!
*
*----- AAAA
*
c     Write (*,*) 'AAAA'
      IND=0
      DO 11 IRREP=1,NIRREP
       IND=IND+1
       iBlock=iBlock+1
       iTable(1,iBlock)=1
       iTable(2,iBlock)=IRREP-1
       iTable(3,iBlock)=IRREP-1
       iTable(4,iBlock)=IRREP-1
       iTable(5,iBlock)=IRREP-1
       iTable(6,iBlock)=IND
c      Write (*,*) IND,IRREP-1,IRREP-1,IRREP-1,IRREP-1
 11   CONTINUE
*
*----- AABB
*
c     Write (*,*) 'AABB'
      IND=0
      DO 12 IRREP1=2,NIRREP
      DO 120 IRREP2=1,IRREP1-1
       IND=IND+1
       iBlock=iBlock+1
       iTable(1,iBlock)=2
       iTable(2,iBlock)=IRREP2-1
       iTable(3,iBlock)=IRREP2-1
       iTable(4,iBlock)=IRREP1-1
       iTable(5,iBlock)=IRREP1-1
       iTable(6,iBlock)=IND
c      Write (*,*) IND,IRREP2-1,IRREP2-1,IRREP1-1,IRREP1-1
120    CONTINUE
12    CONTINUE
*
*----- ABAB
*
*     Write (*,*) 'ABAB'
      IND=0
      DO 13 IRREP=2,NIRREP
      DO 130 IRREP1=1,NIRREP
       IRREP2=IEor(IRREP-1,IRREP1-1)+1
       IF(IRREP2.GT.IRREP1) THEN
        IND=IND+1
        iBlock=iBlock+1
        iTable(1,iBlock)=3
        iTable(2,iBlock)=IRREP1-1
        iTable(3,iBlock)=IRREP2-1
        iTable(4,iBlock)=IRREP1-1
        iTable(5,iBlock)=IRREP2-1
        iTable(6,iBlock)=IND
*       Write (*,*) IND,IRREP1-1,IRREP2-1,IRREP1-1,IRREP2-1
       ENDIF
130    CONTINUE
13    CONTINUE
*
*----- ABCD
*
c     Write (*,*) 'ABCD'
      IND=0
      DO 313 IRREP=2,NIRREP
       DO 314 IRREP1=1,NIRREP
        IRREP2=iEor(IRREP-1,IRREP1-1)+1
        IF(IRREP2.LT.IRREP1)GOTO 314
        IBOT=MAX(IRREP1,IRREP2)+1
        CALL IZERO(IDID,8)
        DO 315 ITMP=IBOT,NIRREP
         IRREP4=iEor(ITMP-1,IRREP-1)+1
         IRREP3=MIN(ITMP,IRREP4)
         IRREP4=MAX(ITMP,IRREP4)
         IF(MAX(IDID(IRREP4),IDID(IRREP3)).NE.0)GOTO 315
         IDID(IRREP3)=1
         IDID(IRREP4)=1
         IND=IND+1
         iBlock=iBlock+1
         iTable(1,iBlock)=4
         iTable(2,iBlock)=IRREP3-1
         iTable(3,iBlock)=IRREP4-1
         iTable(4,iBlock)=IRREP1-1
         iTable(5,iBlock)=IRREP2-1
         iTable(6,iBlock)=IND
c        Write (*,*) IND,IRREP3-1,IRREP4-1,IRREP1-1,IRREP2-1
315     CONTINUE
314    CONTINUE
313   CONTINUE
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Roland Lindh                                     *
************************************************************************
      SubRoutine Print_Basis(lOPTO)
************************************************************************
*                                                                      *
*     Object: to print the basis set                                   *
*                                                                      *
*     Author: Roland Lindh, Dept Chem. Phys., Lund University, Sweden  *
*             September 2006                                           *
************************************************************************
      use Basis_Info
      use Center_Info
      use RICD_Info, only: Thrshld_CD
      Implicit Real*8 (A-H,O-Z)
#include "angtp.fh"
#include "relmp.fh"
#include "real.fh"
#include "print.fh"
      Character DBas*4
      Character ChCo*1, ChCa*1, ChSph*1
      Logical Output, Type(0:7), lOPTO
*                                                                      *
************************************************************************
*                                                                      *
      iRout=2
      iPrint = nPrint(iRout)
      If (iPrint.eq.0) Return
      LuWr = 6
*                                                                      *
************************************************************************
*                                                                      *
      If (Show) Then
         Write (LuWr,*)
         Call CollapseOutput(1,'   Basis set information:')
         Write (LuWr,'(3X,A)') '   ----------------------'
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Write out basis set information
*                                                                      *
************************************************************************
*                                                                      *
*     Valence basis set
*
      Do iCnttp = 1, nCnttp
         mdc = dbsc(iCnttp)%mdci
         lSh= 0
         output=Show
         If (dbsc(iCnttp)%Aux.or.dbsc(iCnttp)%Frag)
     &     output = output .and. iPrint.ge.10
     &                     .and. iCnttp.ne.iCnttp_Dummy
         If (output) Then
            Write (LuWr,*)
            Write (LuWr,*)
            Write (LuWr,'(6X,A,1X,A)') 'Basis set label:',
     *        Trim(dbsc(iCnttp)%Bsl)
            If (lOPTO) GoTo 100
            Write (LuWr,*)
            dbas=dc(mdc+1)%LblCnt(1:4)
            Call Upcase(dbas)
            If (dbas.eq.'DBAS') Then
               Write (LuWr,'(6X,A)') 'Diffuse basis set for R-matrix:'
               Write (LuWr,'(6X,A)') '==============================='
               If (dbsc(iCnttp)%nCntr.ne.1) Then
                  Call WarningMessage(2,
     &                        'Too many centers, should only be one!')
                  Call Quit_OnUserError()
               End If
            Else
               If (dbsc(iCnttp)%Aux) Then
                  Write (LuWr,'(6X,A)') 'Auxiliary basis set:'
                  Write (LuWr,'(6X,A)') '=================='
                  If (dbsc(iCnttp)%aCD_Thr.ne.One) Then
                     Write (LuWr,'(6X,A,G9.2)') 'Threshold in the '
     &                    //'auxiliary basis set generation is '
     &                    //'modified to ',
     &                    dbsc(iCnttp)%aCD_Thr*Thrshld_CD
                  End If
               Else If (dbsc(iCnttp)%Frag) Then
                  Write (LuWr,'(6X,A)') 'Fragment basis set:'
                  Write (LuWr,'(6X,A)') '=================='
               Else
                  If (dbsc(iCnttp)%fMass.eq.One) Then
                     Write (LuWr,'(6X,A)')
     &                      'Electronic valence basis set:'
                     Write (LuWr,'(6X,A)') '------------------'
                  Else
                     Write (LuWr,'(6X,A)') 'Muonic valence basis set:'
                     Write (LuWr,'(6X,A)') '------------------'
                  End If
               End If
            End If
            If (dbsc(iCnttp)%Fixed) Write (LuWr,'(6X,A)')
     &          'Centers of this basis set are frozen!'
            If (dbsc(iCnttp)%IsMM.eq.1) Then
               Write (LuWr,'(6X,A)') 'This is a MM atom: no basis set'
            Else
               If (dbsc(iCnttp)%pChrg) Then
                  Write (LuWr,'(6X,A,F10.6,A)')
     &                'Associated Effective Charge ',
     &               dbsc(iCnttp)%Charge,
     &                ' au (this is a pseudo charge)'
               Else
                  Write (LuWr,'(6X,A,F10.6,A)')
     &                'Associated Effective Charge ',
     &               dbsc(iCnttp)%Charge, ' au'
               End If
               Write (LuWr,'(6X,A,F10.6,A)')
     &               'Associated Actual Charge    ',
     &               Max(Zero,DBLE(dbsc(iCnttp)%AtmNr)), ' au'
*
               If (Nuclear_Model.eq.Point_Charge) Then
                  Write (LuWr,'(6X,A)') 'Nuclear Model: Point charge'
               Else If (Nuclear_Model.eq.Gaussian_type) Then
                  Write (LuWr,'(6X,A)')
     &                  'Nuclear Model: Finite nucleus - '
     &                             //'Gaussian distribution'
                  Write (LuWr,'(6X,A,E12.5)')
     &               '  Gaussian exponent, Xi/bohr**(-2): ',
     &               dbsc(iCnttp)%ExpNuc
               Else If (Nuclear_Model.eq.mGaussian_type) Then
                  Write (LuWr,'(6X,A)')
     &                'Nuclear Model: Finite nucleus - '
     &                             //'Modified Gaussian distribution'
                  Write (LuWr,'(6X,A,E12.5,A,E12.5)')
     &               '  Parameters, Xi/bohr**(-2), w/bohr**(-2): ',
     &               dbsc(iCnttp)%ExpNuc,', ',dbsc(iCnttp)%w_mGauss
               Else
                  Call WarningMessage(2,'Illegal Nuclear Model!')
                  Call Abend()
               End If
            End If
            Write (LuWr,*)
  100    Continue
*
         End If
         kShStr = dbsc(iCnttp)%iVal
         kShEnd = dbsc(iCnttp)%iVal+dbsc(iCnttp)%nVal-1
         Type(0) = .False.
         Do kSh = kShStr, kShEnd
            nExpk=Shells(kSh)%nExp
            Type(0) = Type(0) .or. nExpk*Shells(kSh)%nBasis.ne.0
         End Do
         If (output.and.Type(0) .AND..NOT.lOPTO) Then
            Write (LuWr,'(6X,A)')
     &          'Shell  nPrim  nBasis  Cartesian Spherical Contaminant'
         End If
         Do kSh = kShStr, kShEnd
            nExpk=Shells(kSh)%nExp
            ChCa=' '
            ChSph='X'
            ChCo=' '
            If (.not.Shells(kSh)%Transf) Then
               ChCa='X'
               ChSph=' '
            End if
            If (Shells(kSh)%Transf .and.
     &    .not. Shells(kSh)%Prjct ) ChCo='X'
            If (output.and.nExpk*Shells(kSh)%nBasis.ne.0.AND..NOT.lOPTO)
     &         Write (LuWr,'(9X,A,5X,I3,5X,I3,8X,A,8X,A,8X,A)')
     &            AngTp(lSh),nExpk,Shells(kSh)%nBasis,ChCa,ChSph,ChCo
            If (Shells(kSh)%Prjct) Then
               kComp = 2*lSh + 1
            Else
               kComp = (lSh+1)*(lSh+2)/2
            End If
            lSh = lSh + 1
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*        Process PP part, if any.
*
         kShStr=dbsc(iCnttp)%iPP
         kShEnd = kShStr + dbsc(iCnttp)%nPP-1
         If (output.and.dbsc(iCnttp)%nPP.ne.0 .AND..NOT.lOPTO) Then
            Write (LuWr,*)
            Write (LuWr,'(6X,A)')
     &             'Pseudo Potential specification:'
            Write (LuWr,'(6X,A)')
     &             '======================================='
            Type(0)=.False.
            Do kSh = kShStr, kShEnd
               nExpk=Shells(kSh)%nExp/3
               Type(0)=Type(0).or.nExpk.ne.0
            End Do
            If (Type(0)) Then
               Write (LuWr,*)
               Write (LuWr,'(6X,A)') 'Potential  nTerms    '
            End If
         End If
         lSh= 0
         Do kSh = kShStr, kShEnd
            nExpk=Shells(kSh)%nExp/3
C           Write (*,*) 'kSh,lSh=',kSh,lSh
            If (output.and.nExpk.ne.0 .AND..NOT.lOPTO) Then
               If (lSh.eq.0) Then
                  Write (LuWr,'(9X,A,6X,I2)')
     &               '  H',nExpk
               Else
                  Write (LuWr,'(9X,A,6X,I2)')
     &               AngTp(lSh-1)//'-H',nExpk
               End If
            End If
            lSh = lSh + 1
         End Do
*                                                                      *
************************************************************************
*                                                                      *
*        Process ECP part, if any.
*
         kShStr = dbsc(iCnttp)%iPrj
         kShEnd = kShStr + dbsc(iCnttp)%nPrj-1
         If (output.and.dbsc(iCnttp)%ECP .AND..NOT.lOPTO) Then
            Write (LuWr,*)
            Write (LuWr,'(6X,A)')
     &             'Effective Core Potential specification:'
            Write (LuWr,'(6X,A)')
     &             '======================================='
            If (dbsc(iCnttp)%nM1.gt.0) Then
               Write (LuWr,*)
               Write (LuWr,'(6X,A,I5)')
     &               ' Number of M1 terms:',dbsc(iCnttp)%nM1
            End If
            If (dbsc(iCnttp)%nM2.gt.0) Then
               Write (LuWr,*)
               Write (LuWr,'(6X,A,I5)')
     &               ' Number of M2 terms:',dbsc(iCnttp)%nM2
            End If
            Type(0)=.False.
            Do kSh = kShStr, kShEnd
               nExpk=Shells(kSh)%nExp
               nBasisk=Shells(kSh)%nBasis
               Type(0)=Type(0).or.nExpk*nBasisk.ne.0
            End Do
            If (Type(0)) Then
               Write (LuWr,*)
               Write (LuWr,'(6X,A)') 'Projection basis set '
               Write (LuWr,'(6X,A)') 'Shell  nPrim  nBasis '
            End If
         End If
         lSh= 0
         Do kSh = kShStr, kShEnd
            nExpk=Shells(kSh)%nExp
            nBasisk=Shells(kSh)%nBasis
            If (output.and.nExpk*nBasisk.ne.0 .AND..NOT.lOPTO)
     &         Write (LuWr,'(9X,A,6X,I2,6X,I2)')
     &            AngTp(lSh),nExpk,nBasisk
            kComp = 2*lSh + 1
            lSh = lSh + 1
         End Do
*--------Spectral resolution basis set
         kShStr = dbsc(iCnttp)%iSRO
         kShEnd = kShStr + dbsc(iCnttp)%nSRO-1
         If (output.and.dbsc(iCnttp)%ECP .AND..NOT.lOPTO) Then
            Type(0)=.False.
            Do kSh = kShStr, kShEnd
               nExpk=Shells(kSh)%nExp
               Type(0)=Type(0).or.nExpk.ne.0
            End Do
            If (Type(0)) Then
               If (dbsc(iCnttp)%nOpt.ne.0) Then
                  Write (LuWr,*)
                  Write (LuWr,'(6X,A)') 'Spectral Resolvent Operators :'
                  If (iAnd(2**0,dbsc(iCnttp)%nOpt).ne.0)
     &               Write (LuWr,'(8X,A)') ' Exchange'
                  If (iAnd(2**1,dbsc(iCnttp)%nOpt).ne.0)
     &               Write (LuWr,'(8X,A)') ' Mass-Velocity'
                  If (iAnd(2**2,dbsc(iCnttp)%nOpt).ne.0)
     &               Write (LuWr,'(8X,A)') ' Darwin 1-electron'
     &                      //' contact term'
                  If (iAnd(2**3,dbsc(iCnttp)%nOpt).ne.0) Then
                     If (IRELMP.EQ.0) Then
                        Write (LuWr,'(8X,A)') ' No-Pair approximation'
                     Else If (IRELMP.EQ.1) Then
                        Write (LuWr,'(8X,A)')
     &                        ' No-Pair approximation (DK1)'
                     Else If (IRELMP.EQ.2) Then
                        Write (LuWr,'(8X,A)')
     &                        ' No-Pair approximation (DK2)'
                     Else If (IRELMP.EQ.3) Then
                        Write (LuWr,'(8X,A)')
     &                        ' No-Pair approximation (DK3)'
                     Else If (IRELMP.EQ.4) Then
                        Write (LuWr,'(8X,A)')
     &                        ' No-Pair approximation (DK3)'
                     Else If (IRELMP.EQ.11) Then
                        Write (LuWr,'(8X,A)')
     &                        ' RESC approximation'
                     Else If (IRELMP.EQ.21) Then
                        Write (LuWr,'(8X,A)')
     &                        ' ZORA approximation'
                     Else If (IRELMP.EQ.22) Then
                        Write (LuWr,'(8X,A)')
     &                        ' ZORA-FP approximation'
                     Else If (IRELMP.EQ.23) Then
                        Write (LuWr,'(8X,A)')
     &                        ' IORA approximation'
                     End If
                  End If
               End If
               Write (LuWr,*)
               Write (LuWr,'(6X,A)') 'Spectral Resolvent basis set '
               Write (LuWr,'(6X,A)') 'Shell  nPrim '
            End If
         End If
         lSh= 0
         Do kSh = kShStr, kShEnd
            nExpk=Shells(kSh)%nExp
            If (output.and.nExpk.ne.0 .AND..NOT.lOPTO)
     &         Write (LuWr,'(9X,A,6X,I2)')
     &            AngTp(lSh),nExpk
            kComp = 2*lSh + 1
            lSh = lSh + 1
         End Do
*
*--------Auxilliary SO core
*
         kShStr = dbsc(iCnttp)%iSOC
         kShEnd = kShStr + dbsc(iCnttp)%nSOC-1
         If (output.and.dbsc(iCnttp)%ECP .AND..NOT.lOPTO) Then
            Type(0)=.False.
            Do kSh = kShStr, kShEnd
               nExpk=Shells(kSh)%nExp
               Type(0)=Type(0).or.nExpk.ne.0
            End Do
            If (Type(0)) Then
               If (dbsc(iCnttp)%nOpt.ne.0) Then
                  Write (LuWr,*)
                  Write (LuWr,'(6X,A)') 'Auxilliary core basis'
               End If
               Write (LuWr,*)
               Write (LuWr,'(6X,A)') 'SOC basis set '
               Write (LuWr,'(6X,A)') 'Shell  nPrim '
            End If
         End If
         lSh= 0
         Do kSh = kShStr, kShEnd
            nExpk=Shells(kSh)%nExp
            If (output.and.nExpk.ne.0)
     &         Write (LuWr,'(9X,A,6X,I2)')
     &            AngTp(lSh),nExpk
            kComp = 2*lSh + 1
            lSh = lSh + 1
         End Do
*
         If (output.and.iPrint.ge.6) Then
            Write (LuWr,*)
            Write (LuWr,'(6X,A)')
     &              ' Label   Cartesian Coordinates / Bohr'
            Write (LuWr,*)
            Do iCnt = 1, dbsc(iCnttp)%nCntr
               Write (LuWr,'(1X,A,1X,3F20.10)') dc(mdc+iCnt)%LblCnt,
     &                                    dbsc(iCnttp)%Coor(1:3,iCnt)
            End Do
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      If (Show) Then
         Call CollapseOutput(0,'   Basis set information:')
         Write (LuWr,*)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1986, Per E. M. Siegbahn                               *
*               1986, Margareta R. A. Blomberg                         *
************************************************************************
      SUBROUTINE COUNT_CPF(NINTGR,NSYM,NORB,MUL)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION NORB(*),MUL(8,8)
C     COUNT TWO-ELECTRON INTEGRALS
      NINTGR=0
      DO 313 NSP=1,NSYM
      NOP=NORB(NSP)
      DO 312 NSQ=1,NSP
      NSPQ=MUL(NSP,NSQ)
      NOQ=NORB(NSQ)
      DO 311 NSR=1,NSP
      NSPQR=MUL(NSPQ,NSR)
      NOR=NORB(NSR)
      NSSM=NSR
      IF(NSR.EQ.NSP)NSSM=NSQ
      DO 310 NSS=1,NSSM
      IF(NSS.NE.NSPQR)GO TO 310
      NOS=NORB(NSS)
      NORBP=NOP*NOQ*NOR*NOS
      IF(NORBP.EQ.0)GO TO 310
      DO 309 NV=1,NOR
      NXM=NOS
      IF(NSR.EQ.NSS)NXM=NV
      DO 308 NX=1,NXM
      NTM=1
      IF(NSP.EQ.NSR)NTM=NV
      DO 307 NT=NTM,NOP
      NUMIN=1
      IF(NSP.EQ.NSR.AND.NT.EQ.NV)NUMIN=NX
      NUMAX=NOQ
      IF(NSP.EQ.NSQ)NUMAX=NT
      DO 306 NU=NUMIN,NUMAX
      NINTGR=NINTGR+1
306   CONTINUE
307   CONTINUE
308   CONTINUE
309   CONTINUE
310   CONTINUE
311   CONTINUE
312   CONTINUE
313   CONTINUE
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_getint(wrk,wrksize,i,symi,r,rc)
! this routine reads integrals R_i(a,bc) for given i in given symi
!
! i    - number of orbital (I)
! symi - irrep of i (I)
! r    - R (I/O)
! rc   - return (error) code (O)

use CCT3_global, only: daddr, Map_Type, noa, T3IntPos, t3nam
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, i, symi
real(kind=wp), intent(_OUT_) :: wrk(wrksize)
type(Map_Type), intent(inout) :: r
integer(kind=iwp), intent(inout) :: rc
integer(kind=iwp) :: iadd, im, isym, length, lun, num, pos !, rc1

!1 some tests

if (i > noa(symi)) then
  ! RC=1 : i is higher than occipied in this irrep (Stup)
  rc = 1
  return
end if

if (i < 1) then
  ! RC=2 : i is less than 1 (Stup)
  rc = 2
  return
end if

!2 calc number for this orbital

iadd = 0
if (symi > 1) then
  do isym=1,symi-1
    iadd = iadd+noa(isym)
  end do
end if

num = iadd+i

!3 get R

lun = 1
daddr(lun) = T3IntPos(num)

call daname(lun,t3nam)

call idafile(lun,2,r%d,513*6,daddr(lun))
call idafile(lun,2,r%i,8*8*8,daddr(lun))

pos = r%pos0
length = 0
do im=1,r%d(0,5)
  r%d(im,1) = pos
  pos = pos+r%d(im,2)
  length = length+r%d(im,2)
  !write(u6,99) ' MAP',(r%d(im,k),k=1,6)
end do

if (length > 0) call ddafile(lun,2,wrk(r%pos0),length,daddr(lun))
!call cct3_getmediate(wrk,wrksize,lun,r,rc1)

call daclos(lun)

return

!99 format(a3,i8,2x,i8,4(2x,i2))

end subroutine cct3_getint

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Thomas Bondo Pedersen                                  *
!***********************************************************************

subroutine RotateOrbB(CMO,Col,Lbl,nComp,nBas,nOrb2Loc,Maximisation,ThrRot,PctSkp,Debug)
! Author: T.B. Pedersen
!
! Purpose: rotate orbitals (Jacobi Sweeps) for Boys localisation.

use Constants, only: Zero, One, Half, Quart, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nComp, nBas, nOrb2Loc
real(kind=wp), intent(inout) :: CMO(nBas,*), Lbl(nOrb2Loc,nOrb2Loc,nComp)
real(kind=wp), intent(out) :: Col(nOrb2Loc,2), PctSkp
logical(kind=iwp), intent(in) :: Maximisation, Debug
real(kind=wp), intent(in) :: ThrRot
integer(kind=iwp) :: iComp, iCouple, iMO1, iMO2, iMO_s, iMO_t
real(kind=wp) :: Alpha, Alpha1, Alpha2, Ast, Bst, cos4alpha, Gamma_rot, sin4alpha, Tst, Tstc, Tsts, xDone, xOrb2Loc, xTotal
character(len=80) :: Txt
character(len=*), parameter :: SecNam = 'RotateOrbB'

xDone = Zero
if (Debug) iCouple = 0
do iMO1=1,nOrb2Loc-1
  do iMO2=iMO1+1,nOrb2Loc

    if (Debug) then
      iCouple = iCouple+1
      write(u6,'(A9,I5)') 'Couple n:',iCouple
      write(u6,'(A9,I5)') '    MO1 :',iMO1
      write(u6,'(A9,I5)') '    MO2 :',iMO2
    end if

    iMO_s = iMO1
    iMO_t = iMO2

    Ast = Zero
    Bst = Zero
    do iComp=1,nComp
      Ast = Ast+Lbl(iMO_s,iMO_t,iComp)**2-Quart*(Lbl(iMO_s,iMO_s,iComp)-Lbl(iMO_t,iMO_t,iComp))**2
      Bst = Bst+Lbl(iMO_s,iMO_t,iComp)*(Lbl(iMO_s,iMO_s,iComp)-Lbl(iMO_t,iMO_t,iComp))
    end do

    if ((Ast == Zero) .and. (Bst == Zero)) then
      cos4alpha = -One
      sin4alpha = Zero
    else
      cos4alpha = -Ast/sqrt(Ast**2+Bst**2)
      sin4alpha = Bst/sqrt(Ast**2+Bst**2)
    end if
    Tst = abs(cos4alpha)-One
    if (Tst > Zero) then
      if (Tst > 1.0e-10_wp) then
        write(Txt,'(A,D18.10)') 'Actual: cos4alpha = ',cos4alpha
        call SysAbendMsg(SecNam,'-1.0 < cos4alpha < 1.0',Txt)
      else
        if (cos4alpha < Zero) then
          cos4alpha = -One
        else
          cos4alpha = One
        end if
      end if
    end if

    Alpha1 = acos(cos4alpha)*Quart
    Alpha2 = asin(sin4alpha)*Quart
    if (Alpha2 < Zero) Alpha1 = Alpha2+Pi
    Alpha = Alpha1
    if (.not. Maximisation) then
      Gamma_rot = Alpha-Pi*Quart
    else
      Gamma_rot = Alpha
    end if
    if (Debug) then
      write(u6,'(A9,F10.5)') '   Ast :',Ast
      write(u6,'(A9,F10.5)') '   Bst :',Bst
      write(u6,'(A9,F10.5)') 'Alpha1 :',Alpha1
      write(u6,'(A9,F10.5)') 'Alpha2 :',Alpha2
      write(u6,'(A9,F10.5)') ' Gamma :',Gamma_rot
    end if

    Tsts = sin(Gamma_rot)
    Tstc = One-cos(Gamma_rot)
    if ((abs(Tsts) > ThrRot) .or. (abs(Tstc) > ThrRot)) then
      call Rot_st(CMO(1,iMO_s),CMO(1,iMO_t),nBas,Gamma_rot,Debug)
      call UpdateB(Col,nOrb2Loc,Lbl,nComp,Gamma_rot,iMO_s,iMO_t,Debug)
      xDone = xDone+One
    end if

  end do
end do

if (nOrb2Loc > 1) then
  xOrb2Loc = real(nOrb2Loc,kind=wp)
  xTotal = xOrb2Loc*(xOrb2Loc-One)*Half
  PctSkp = 1.0e2_wp*(xTotal-xDone)/xTotal
else
  PctSkp = Zero
end if

end subroutine RotateOrbB

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_sort_paras

! Sorting module with a very simple O(N^2) insertion sort
! algorithm or using the average O(NlogN) Quicksort algorithm
!
! Sort multipole moment parameters wrt
!     (a) expansion centre component
!     (b) box component
!     (c) branch

   USE fmm_global_paras
   IMPLICIT NONE
   PRIVATE
   ! Public procedures
   PUBLIC :: fmm_quicksort_wrt_branches,      &
             fmm_quicksort_wrt_vector,        &
             fmm_quicksort_wrt_boxes

   ! criteria for switching from Quicksort to Insertion-Sort algorithms
   INTEGER(INTK), PARAMETER :: quicksort_CUTOFF = 10

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE insertion_sort_wrt_branches(arr)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: arr(:)
      TYPE(box_mm_paras) :: tmp
      INTEGER(INTK) :: i, j

      iloop: DO i = 1, SIZE(arr)
         tmp = arr(i)
         DO j = (i-1), 1, -1
            IF (arr(j)%bra > tmp%bra) THEN
               arr(j+1) = arr(j)
            ELSE
               arr(j+1) = tmp
               CYCLE iloop
            END IF
         END DO
         arr(1) = tmp
      END DO iloop

   END SUBROUTINE insertion_sort_wrt_branches

!-------------------------------------------------------------------------------

   SUBROUTINE bra_swap_elements(arr,i,j)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: i, j
      TYPE(box_mm_paras) :: tmp

      tmp = arr(i)
      arr(i) = arr(j)
      arr(j) = tmp

   END SUBROUTINE bra_swap_elements

!-------------------------------------------------------------------------------
! Subroutine to return the median of first, last, and centre array elements.
! order these and hide the pivot (median) as the second to last array element
! (acts as a sentinel whilst the last is the largest and put in correct place.)

   FUNCTION bra_median_of_three(arr,left,right)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: left, right
      INTEGER(INTK) :: bra_median_of_three
      INTEGER(INTK) :: cntr

      cntr = (left + right)/2
      IF(arr(left)%bra > arr(cntr)%bra)  CALL bra_swap_elements(arr,left,cntr)
      IF(arr(left)%bra > arr(right)%bra) CALL bra_swap_elements(arr,left,right)
      IF(arr(cntr)%bra > arr(right)%bra) CALL bra_swap_elements(arr,cntr,right)
      CALL bra_swap_elements(arr,cntr,right-1_INTK)
      bra_median_of_three = arr(right-1)%bra

   END FUNCTION bra_median_of_three

!-------------------------------------------------------------------------------

   RECURSIVE SUBROUTINE fmm_quicksort_wrt_branches(arr)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: arr(:)

      INTEGER(INTK) :: left, right
      INTEGER(INTK) :: i,j, pivot

      left = 1
      right = SIZE(arr)

      IF (left + quicksort_CUTOFF > right) THEN
         ! array too small for Quicksort to be efficient, so don't use it
         CALL insertion_sort_wrt_branches(arr)
         RETURN
      END IF

      pivot = bra_median_of_three(arr,left,right)
      ! partition array elements about chosen pivot
      i = left
      j = right-2
      DO ! until left, right pointers cross
         ! increment left until large element found
         DO WHILE ( arr(i)%bra < pivot )
            i = i+1
         END DO
         ! increment right until small element found
         DO WHILE ( arr(j)%bra > pivot )
            j = j-1
         END DO
         IF (i < j) THEN
            ! swap items (i,j)
            CALL bra_swap_elements(arr,i,j)
            ! now increment (i,j) to avoid infinite loop if both = pivot
            i = i+1
            j = j-1
         ELSE
            EXIT
         END IF
      END DO
      ! i is now the position where the pivot should be
      ! swap pivot back to middle of array
      CALL bra_swap_elements(arr,i,right-1_INTK)

      ! now sort sub-arrays either side of pivot
      CALL fmm_quicksort_wrt_branches( arr( left:(i-1) ) )
      CALL fmm_quicksort_wrt_branches( arr( (i+1):right ) )

   END SUBROUTINE fmm_quicksort_wrt_branches

!-------------------------------------------------------------------------------
! Insertion sort for sorting of multipole moment centres
!-----------------------------------------------------------------------

   SUBROUTINE insertion_sort_wrt_vector(arr,xyz)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: xyz

      TYPE(raw_mm_paras) :: tmp
      INTEGER(INTK) :: i, j

      iloop: DO i = 1, SIZE(arr)
         tmp = arr(i)
         DO j = (i-1), 1, -1
            IF (arr(j)%cntr(xyz) > tmp%cntr(xyz)) THEN
               arr(j+1) = arr(j)
            ELSE
               arr(j+1) = tmp
               CYCLE iloop
            END IF
         END DO
         arr(1) = tmp
      END DO iloop

   END SUBROUTINE insertion_sort_wrt_vector

!-------------------------------------------------------------------------------
! Quicksort for sorting of T-pair batch wrt 1 component of T-vector
!------------------------------------------------------------------

   SUBROUTINE vector_swap_elements(arr,i,j)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: i, j
      TYPE(raw_mm_paras) :: tmp

      tmp = arr(i)
      arr(i) = arr(j)
      arr(j) = tmp

   END SUBROUTINE vector_swap_elements

!-------------------------------------------------------------------------------
! subroutine to return the median of first, last, and centre array elements.
! order these and hide the pivot (median) as the second to last array element
! (acts as a sentinel whilst the last is the largest and put in correct place.)

   FUNCTION vector_median_of_three(arr,left,right,xyz)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: left, right
      INTEGER(INTK),      INTENT(IN)    :: xyz

      REAL(REALK)   :: vector_median_of_three
      INTEGER(INTK) :: cntr

      cntr = (left + right)/2

      IF (arr(left)%cntr(xyz) > arr(cntr)%cntr(xyz))  &
         CALL vector_swap_elements(arr,left,cntr)
      IF (arr(left)%cntr(xyz) > arr(right)%cntr(xyz))  &
         CALL vector_swap_elements(arr,left,right)
      IF (arr(cntr)%cntr(xyz) > arr(right)%cntr(xyz))  &
         CALL vector_swap_elements(arr,cntr,right)

      CALL vector_swap_elements(arr,cntr,right-1_INTK)
      vector_median_of_three = arr(right-1)%cntr(xyz)

   END FUNCTION vector_median_of_three

!-------------------------------------------------------------------------------

   RECURSIVE SUBROUTINE fmm_quicksort_wrt_vector(arr,xyz)

      IMPLICIT NONE
      TYPE(raw_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: xyz

      INTEGER(INTK) :: left, right
      INTEGER(INTK) :: i,j
      REAL(REALK)   :: pivot

      left = 1
      right = SIZE(arr)

      IF (left + quicksort_CUTOFF > right) THEN
         ! array too small for Quicksort to be efficient, so don't use it
         CALL insertion_sort_wrt_vector(arr,xyz)
         RETURN
      END IF

      pivot = vector_median_of_three(arr,left,right,xyz)
      ! partition array elements about chosen pivot
      i = left
      j = right-2
      DO ! until left, right pointers cross
         ! increment left until large element found
         DO WHILE ( arr(i)%cntr(xyz) < pivot )
            i = i+1
         END DO
         ! increment right until small element found
         DO WHILE ( arr(j)%cntr(xyz) > pivot )
            j = j-1
         END DO
         IF (i < j) THEN
            ! swap items (i,j)
            CALL vector_swap_elements(arr,i,j)
            ! now increment (i,j) to avoid infinite loop if both = pivot
            i = i+1
            j = j-1
         ELSE
            EXIT
         END IF
      END DO
      ! i is now the position where the pivot should be
      ! swap pivot back to middle of array
      CALL vector_swap_elements(arr,i,right-1_INTK)

      ! now sort sub-arrays either side of pivot
      CALL fmm_quicksort_wrt_vector( arr( left:(i-1) ),xyz )
      CALL fmm_quicksort_wrt_vector( arr( (i+1):right ),xyz )

   END SUBROUTINE fmm_quicksort_wrt_vector

!-------------------------------------------------------------------------------
! Insertion sort for sorting wrt one box index
!-----------------------------------------------------------------------

   SUBROUTINE insertion_sort_wrt_boxes(arr,xyz)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: xyz

      TYPE(box_mm_paras) :: tmp
      INTEGER(INTK) :: i, j

      iloop: DO i = 1, SIZE(arr)
         tmp = arr(i)
         DO j = (i-1), 1, -1
            IF (arr(j)%box(xyz) > tmp%box(xyz)) THEN
               arr(j+1) = arr(j)
            ELSE
               arr(j+1) = tmp
               CYCLE iloop
            END IF
         END DO
         arr(1) = tmp
      END DO iloop

   END SUBROUTINE insertion_sort_wrt_boxes

!-------------------------------------------------------------------------------
! Quicksort for sorting wrt one box index
!------------------------------------------------------------------

   SUBROUTINE boxes_swap_elements(arr,i,j)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: i, j
      TYPE(box_mm_paras) :: tmp

      tmp = arr(i)
      arr(i) = arr(j)
      arr(j) = tmp

   END SUBROUTINE boxes_swap_elements

!-------------------------------------------------------------------------------
! subroutine to return the median of first, last, and centre array elements.
! order these and hide the pivot (median) as the second to last array element
! (acts as a sentinel whilst the last is the largest and put in correct place.)

   FUNCTION boxes_median_of_three(arr,left,right,xyz)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: left, right
      INTEGER(INTK),      INTENT(IN)    :: xyz

      INTEGER(INTK) :: boxes_median_of_three
      INTEGER(INTK) :: box

      box = (left + right)/2

      IF (arr(left)%box(xyz) > arr(box)%box(xyz))  &
         CALL boxes_swap_elements(arr,left,box)
      IF (arr(left)%box(xyz) > arr(right)%box(xyz))  &
         CALL boxes_swap_elements(arr,left,right)
      IF (arr(box)%box(xyz) > arr(right)%box(xyz))  &
         CALL boxes_swap_elements(arr,box,right)

      CALL boxes_swap_elements(arr,box,right-1_INTK)
      boxes_median_of_three = arr(right-1)%box(xyz)

   END FUNCTION boxes_median_of_three

!-------------------------------------------------------------------------------

   RECURSIVE SUBROUTINE fmm_quicksort_wrt_boxes(arr,xyz)

      IMPLICIT NONE
      TYPE(box_mm_paras), INTENT(INOUT) :: arr(:)
      INTEGER(INTK),      INTENT(IN)    :: xyz

      INTEGER(INTK) :: left, right
      INTEGER(INTK) :: i,j
      INTEGER(INTK) :: pivot

      left = 1
      right = SIZE(arr)

      IF (left + quicksort_CUTOFF > right) THEN
         ! array too small for Quicksort to be efficient, so don't use it
         CALL insertion_sort_wrt_boxes(arr,xyz)
         RETURN
      END IF

      pivot = boxes_median_of_three(arr,left,right,xyz)
      ! partition array elements about chosen pivot
      i = left
      j = right-2
      DO ! until left, right pointers cross
         ! increment left until large element found
         DO WHILE ( arr(i)%box(xyz) < pivot )
            i = i+1
         END DO
         ! increment right until small element found
         DO WHILE ( arr(j)%box(xyz) > pivot )
            j = j-1
         END DO
         IF (i < j) THEN
            ! swap items (i,j)
            CALL boxes_swap_elements(arr,i,j)
            ! now increment (i,j) to avoid infinite loop if both = pivot
            i = i+1
            j = j-1
         ELSE
            EXIT
         END IF
      END DO
      ! i is now the position where the pivot should be
      ! swap pivot back to middle of array
      CALL boxes_swap_elements(arr,i,right-1_INTK)

      ! now sort sub-arrays either side of pivot
      CALL fmm_quicksort_wrt_boxes( arr( left:(i-1) ),xyz )
      CALL fmm_quicksort_wrt_boxes( arr( (i+1):right ),xyz )

   END SUBROUTINE fmm_quicksort_wrt_boxes

!-------------------------------------------------------------------------------

END MODULE fmm_sort_paras

!==============================================================================
!
!MODULE fmm_sort_sh_pairs
!
!! Sorting module with a very simple O(N^2) insertion sort
!! algorithm or using the average O(NlogN) Quicksort algorithm
!!
!! Sort shell pair array wrt
!!     (a) box component
!
!   USE fmm_global_paras
!   IMPLICIT NONE
!   PRIVATE
!   ! Public procedures
!   PUBLIC :: fmm_quicksort_wrt_boxes
!
!   ! criteria for switching from Quicksort to Insertion-Sort algorithms
!   INTEGER(INTK), PARAMETER :: quicksort_CUTOFF = 10
!
!CONTAINS
!
!!-------------------------------------------------------------------------------
!! Insertion sort for sorting wrt one box index
!!-----------------------------------------------------------------------
!
!   SUBROUTINE insertion_sort_wrt_boxes(arr,xyz)
!
!      IMPLICIT NONE
!      TYPE(fmm_shell_pair_node), INTENT(INOUT) :: arr(:)
!      INTEGER(INTK),             INTENT(IN)    :: xyz
!
!      TYPE(fmm_shell_pair_node) :: tmp
!      INTEGER(INTK) :: i, j
!
!      iloop: DO i = 1, SIZE(arr)
!         tmp = arr(i)
!         DO j = (i-1), 1, -1
!            IF (arr(j)%box(xyz) > tmp%box(xyz)) THEN
!               arr(j+1) = arr(j)
!            ELSE
!               arr(j+1) = tmp
!               CYCLE iloop
!            END IF
!         END DO
!         arr(1) = tmp
!      END DO iloop
!
!   END SUBROUTINE insertion_sort_wrt_boxes
!
!!-------------------------------------------------------------------------------
!! Quicksort for sorting wrt one box index
!!------------------------------------------------------------------
!
!   SUBROUTINE boxes_swap_elements(arr,i,j)
!
!      IMPLICIT NONE
!      TYPE(fmm_shell_pair_node), INTENT(INOUT) :: arr(:)
!      INTEGER(INTK),             INTENT(IN)    :: i, j
!      TYPE(fmm_shell_pair_node) :: tmp
!
!      tmp = arr(i)
!      arr(i) = arr(j)
!      arr(j) = tmp
!
!   END SUBROUTINE boxes_swap_elements
!
!!-------------------------------------------------------------------------------
!! subroutine to return the median of first, last, and centre array elements.
!! order these and hide the pivot (median) as the second to last array element
!! (acts as a sentinel whilst the last is the largest and put in correct place.)
!
!   FUNCTION boxes_median_of_three(arr,left,right,xyz)
!
!      IMPLICIT NONE
!      TYPE(fmm_shell_pair_node), INTENT(INOUT) :: arr(:)
!      INTEGER(INTK),             INTENT(IN)    :: left, right
!      INTEGER(INTK),             INTENT(IN)    :: xyz
!
!      INTEGER(INTK) :: boxes_median_of_three
!      INTEGER(INTK) :: box
!
!      box = (left + right)/2
!
!      IF (arr(left)%box(xyz) > arr(box)%box(xyz))  &
!         CALL boxes_swap_elements(arr,left,box)
!      IF (arr(left)%box(xyz) > arr(right)%box(xyz))  &
!         CALL boxes_swap_elements(arr,left,right)
!      IF (arr(box)%box(xyz) > arr(right)%box(xyz))  &
!         CALL boxes_swap_elements(arr,box,right)
!
!      CALL boxes_swap_elements(arr,box,right-1_INTK)
!      boxes_median_of_three = arr(right-1)%box(xyz)
!
!   END FUNCTION boxes_median_of_three
!
!!-------------------------------------------------------------------------------
!
!   RECURSIVE SUBROUTINE fmm_quicksort_wrt_boxes(arr,xyz)
!
!      IMPLICIT NONE
!      TYPE(fmm_shell_pair_node), INTENT(INOUT) :: arr(:)
!      INTEGER(INTK),             INTENT(IN)    :: xyz
!
!      INTEGER(INTK) :: left, right
!      INTEGER(INTK) :: i,j
!      INTEGER(INTK) :: pivot
!
!      left = 1
!      right = SIZE(arr)
!
!      IF (left + quicksort_CUTOFF > right) THEN
!         ! array too small for Quicksort to be efficient, so don't use it
!         CALL insertion_sort_wrt_boxes(arr,xyz)
!         RETURN
!      END IF
!
!      pivot = boxes_median_of_three(arr,left,right,xyz)
!      ! partition array elements about chosen pivot
!      i = left
!      j = right-2
!      DO ! until left, right pointers cross
!         ! increment left until large element found
!         DO WHILE ( arr(i)%box(xyz) < pivot )
!            i = i+1
!         END DO
!         ! increment right until small element found
!         DO WHILE ( arr(j)%box(xyz) > pivot )
!            j = j-1
!         END DO
!         IF (i < j) THEN
!            ! swap items (i,j)
!            CALL boxes_swap_elements(arr,i,j)
!            ! now increment (i,j) to avoid infinite loop if both = pivot
!            i = i+1
!            j = j-1
!         ELSE
!            EXIT
!         END IF
!      END DO
!      ! i is now the position where the pivot should be
!      ! swap pivot back to middle of array
!      CALL boxes_swap_elements(arr,i,right-1_INTK)
!
!      ! now sort sub-arrays either side of pivot
!      CALL fmm_quicksort_wrt_boxes( arr( left:(i-1) ),xyz )
!      CALL fmm_quicksort_wrt_boxes( arr( (i+1):right ),xyz )
!
!   END SUBROUTINE fmm_quicksort_wrt_boxes
!
!!-------------------------------------------------------------------------------
!
!END MODULE fmm_sort_sh_pairs
!

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine max5h2(wrk,wrksize,nind,v,rmax,imax,text)
! this routine writes:
! a) note
! b) 5 maximal elements with their indices in given vector V
! c) euclidian norm
!
! nind - number of indices in V (I)
! v    - map type of V (I)
! rmax - store of maximal values (I)
! imax - store of corr. indices (I)
! text - notice (I)

use ccsd_global, only: Map_Type
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, nind, imax(8,5)
real(kind=wp), intent(in) :: wrk(wrksize), rmax(5)
type(Map_Type), intent(in) :: v
character(len=8), intent(in) :: text
integer(kind=iwp) :: nhelp1, rc
real(kind=wp) :: scalar

!1 write notice

write(u6,101) text

!2 write 5 maximal amplitudes

write(u6,102)
do nhelp1=1,5
  write(u6,103) imax(:,nhelp1),rmax(nhelp1)
end do

!3 write euclidian norm

!3.1 calc euclidian norm
call multdot(wrk,wrksize,nind,v,1,v,1,scalar,rc)
scalar = sqrt(scalar)

write(u6,104) scalar

write(u6,*)

return

101 format(' Five largest amplitudes of :',a8)
102 format('  SYMA   SYMB   SYMI   SYMJ     A      B      I      J     VALUE')
103 format(8(2x,i3,2x),f15.10)
104 format(' Euclidian norm is :',f17.10)

end subroutine max5h2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_CALCDIAG(BUF,IBUF,LENBUF,SCR,LENSCR,NDUMP)
C
C     Purpose: shell-driven calculation of the integral diagonal and
C              setup of the first reduced set.
C
      use ChoArr, only: iBasSh, nBasSh, nBstSh, iSP2F, iAtomShl
      use ChoArr, only: MySP, n_MySP
      use ChoSwp, only: nnBstRSh
#include "implicit.fh"
      INTEGER LENBUF, LENSCR
      REAL*8 BUF(LENBUF), SCR(LENSCR)
      INTEGER   IBUF(4,LENBUF)
#include "cholesky.fh"
#include "choprint.fh"
#include "choorb.fh"
#include "stdalloc.fh"

      CHARACTER(LEN=12), PARAMETER:: SECNAM = 'CHO_CALCDIAG'

      Integer, PARAMETER:: INFO_DEBUG = 4, INFO_INSANE = 10

      Real*8 SCRMAX(8), XNCD(1)

      INTEGER, EXTERNAL:: CHO_ISAOSH

      Real*8, Allocatable:: NegCalcDiag(:)

      MULD2H(I,J)=IEOR(I-1,J-1)+1
      ITRI(I,J)=MAX(I,J)*(MAX(I,J)-3)/2+I+J

C     Check dimensions.
C     -----------------

      IF (LENBUF .LT. LBUF) THEN
         WRITE(LUPRI,'(//,1X,A,A)') SECNAM,': LENBUF >= LBUF required!'
         WRITE(LUPRI,'(1X,A,I10)')    'LENBUF = ',LENBUF
         WRITE(LUPRI,'(1X,A,I10,/)')  'LBUF   = ',LBUF
         CALL CHO_QUIT('Buffer error in '//SECNAM,102)
      END IF
      LSCR = MX2SH
      IF (LENSCR .LT. LSCR) THEN
         WRITE(LUPRI,'(//,1X,A,A)') SECNAM,
     &   ': LENSCR >= MX2SH required!'
         WRITE(LUPRI,'(1X,A,I10)')    'LENSCR = ',LENSCR
         WRITE(LUPRI,'(1X,A,I10,/)')  'MX2SH  = ',LSCR
         CALL CHO_QUIT('Scratch space error in '//SECNAM,102)
      END IF

C     Open scratch files.
C     -------------------

      IUNIT = -1
      CALL CHO_OPEN(IUNIT,'_CHO_DIASCR2')
      JUNIT = -1
      CALL CHO_OPEN(JUNIT,'_CHO_DIASCR1')
      REWIND(IUNIT)
      REWIND(JUNIT)

C     Make JUNIT available outside this routine.
C     ------------------------------------------

      LUSCR = JUNIT

C     Initialize abs. max. diag. array.
C     ---------------------------------

      CALL FZERO(DIAMAX,NSYM)

C     Allocate array for storing 10 most negative diagonals
C     (there should be none, of course, but they do show up)
C     ------------------------------------------------------

      Call mma_allocate(NegCalcDiag,10,Label='NegCalcDiag')
      NegCalcDiag(:)=0.0D0
      n_NegCalcDiag=0

C     Calculate diagonal in loop over shell-pairs.
C     CHO_NO2CENTER on: skip all 2-center diagonals.
C     ----------------------------------------------

      IF (CHO_NO2CENTER .AND. SIZE(IATOMSHL).LT.NSHELL) THEN
         CALL CHO_QUIT(SECNAM//': iAtomShl not allocated correctly!',
     &                 103)
      END IF

      XLDIAG = 0.0D0
      ICOUNT = 0
      NDUMP  = 0
      N_MYSP = 0
      IOPT = 2
      CALL CHO_P_DISTRIB_SP(IOPT,MYSP,N_MYSP)
      Call mma_maxDBLE(LINTD)
      CALL XSETMEM_INTS(LINTD) ! set memory for seward
      DO I_MYSP = 1,N_MYSP

         ISAB = MYSP(I_MYSP)

         ISHLAB = ISP2F(ISAB)
         CALL CHO_INVPCK(ISHLAB,ISHLA,ISHLB,.TRUE.)

         IF (CHO_NO2CENTER) THEN
            IF (IATOMSHL(ISHLA) .NE. IATOMSHL(ISHLB)) THEN
               GO TO 1 ! cycle loop
            END IF
         END IF

         NUMA = NBSTSH(ISHLA)
         NUMB = NBSTSH(ISHLB)
         IF (ISHLA .EQ. ISHLB) THEN
            NUMAB = NUMA*(NUMA + 1)/2
         ELSE
            NUMAB = NUMA*NUMB
         END IF

         SHA = ISHLA
         SHB = ISHLB

         CALL CHO_MCA_DIAGINT(ISHLA,ISHLB,SCR,NUMAB)

         IF (IPRINT .GE. INFO_INSANE) THEN
            IF ((ISHLA.EQ.1) .AND. (ISHLB.EQ.1)) THEN
               IF (CHO_PRESCREEN) THEN
                  CALL CHO_HEAD(SECNAM//': Prescreened Diagonal',
     &                          '=',80,LUPRI)
               ELSE
                  CALL CHO_HEAD(SECNAM//': Unscreened Diagonal',
     &                          '=',80,LUPRI)
               END IF
            END IF
            WRITE(LUPRI,'(/,2X,A,I10,1X,I10,1X,I10)')
     &      'Diagonal shell block A,B,AB = ',ISHLA,ISHLB,
     &                                       ITRI(ISHLA,ISHLB)
            IF (ISHLA .EQ. ISHLB) THEN
               CALL CHO_OUTPAK(SCR,NUMA,1,LUPRI)
            ELSE
               CALL CHO_OUTPUT(SCR,1,NUMA,1,NUMB,NUMA,NUMB,1,LUPRI)
            END IF
         END IF

         IF (ISHLA .EQ. ISHLB) THEN
            DO IA = 1,NUMA
               ISYMA  = CHO_ISAOSH(IA,ISHLA)
               DO IB = 1,IA
                  ISYMB  = CHO_ISAOSH(IB,ISHLB)
                  ISYMAB = MULD2H(ISYMB,ISYMA)
                  IAB    = ITRI(IA,IB)
                  DIAAB  = SCR(IAB)
                  IF (DIAAB .LT. 0.0D0) THEN
                     n_NegCalcDiag=n_NegCalcDiag+1
                     Call UpdateMostNegative(SIZE(NegCalcDiag),
     *                                       NegCalcDiag,DIAAB)
                  END IF
                  IF (DIAAB .GT. THRDIAG) THEN
                     DIAMAX(ISYMAB) = MAX(DIAMAX(ISYMAB),DIAAB)
                     ICOUNT = ICOUNT + 1
                     BUF(ICOUNT)    = SCR(IAB)
                     IBUF(1,ICOUNT) = ISAB
                     IBUF(2,ICOUNT) = IAB
                     IBUF(3,ICOUNT) = ISYMAB
                     IBUF(4,ICOUNT) = IAB
                     IF (ICOUNT .EQ. LBUF) THEN
                        CALL CHO_WRBUF(LBUF,BUF,IBUF,LBUF,IUNIT)
                        XLDIAG = XLDIAG + DBLE(LBUF)
                        ICOUNT = 0
                        NDUMP  = NDUMP + 1
                     END IF
                  END IF
               END DO
            END DO
         ELSE
            DO ISYMB = 1,NSYM
               DO IBB = 1,NBASSH(ISYMB,ISHLB)
                  IB = IBASSH(ISYMB,ISHLB) + IBB
                  DO ISYMA = 1,NSYM
                     DO IAA = 1,NBASSH(ISYMA,ISHLA)
                        IA = IBASSH(ISYMA,ISHLA) + IAA
                        ISYMAB = MULD2H(ISYMA,ISYMB)
                        IAB    = NUMA*(IB - 1) + IA
                        DIAAB  = SCR(IAB)
                        IF (DIAAB .LT. 0.0D0) THEN
                           n_NegCalcDiag=n_NegCalcDiag+1
                           Call UpdateMostNegative(SIZE(NegCalcDiag),
     *                                       NegCalcDiag,DIAAB)
                        END IF
                        IF (DIAAB .GT. THRDIAG) THEN
                           DIAMAX(ISYMAB) = MAX(DIAMAX(ISYMAB),DIAAB)
                           ICOUNT = ICOUNT + 1
                           BUF(ICOUNT)    = SCR(IAB)
                           IBUF(1,ICOUNT) = ISAB
                           IBUF(2,ICOUNT) = IAB
                           IBUF(3,ICOUNT) = ISYMAB
                           IBUF(4,ICOUNT) = IAB
                           IF (ICOUNT .EQ. LBUF) THEN
                              CALL CHO_WRBUF(LBUF,BUF,IBUF,LBUF,
     &                                       IUNIT)
                              XLDIAG = XLDIAG + DBLE(LBUF)
                              ICOUNT = 0
                              NDUMP  = NDUMP + 1
                           END IF
                        END IF
                     END DO
                  END DO
               END DO
            END DO
         END IF

    1    CONTINUE ! for cycling loop

      END DO
      IF (ICOUNT .GT. 0) THEN ! flush buffer
         IF (ICOUNT .GT. LBUF) THEN
            CALL CHO_QUIT('Logical error in '//SECNAM,103)
         END IF
         CALL CHO_WRBUF(ICOUNT,BUF,IBUF,LBUF,IUNIT)
         XLDIAG = XLDIAG + DBLE(ICOUNT)
         ICOUNT = 0
         NDUMP  = NDUMP + 1
      END IF
      CALL XRLSMEM_INTS ! release memory (seward)
      CALL CHO_GADGOP(DIAMAX,NSYM,'max') ! sync abs. max. diag.
      n_NegCalcDiag_local=n_NegCalcDiag
      XNCD(1)=dble(n_NegCalcDiag)
      CALL CHO_GADGOP(XNCD,1,'+')
      n_NegCalcDiag=int(XNCD(1))
      If (n_NegCalcDiag.gt.0) Then
         Call WarningMessage(1,
     *          'WARNING: negative integral diagonal elements computed')
         Write(LuPri,'(3X,A,A)')
     *   'All negative integral diagonal elements have been',
     *   ' removed (zeroed) - they are considered irrelevant!'
         Write(LuPri,'(3X,A,I10)')
     *   'Number of negative elements computed:   ',n_NegCalcDiag
         Write(LuPri,'(3X,A,I10)')
     *   'Number of negative elements (this node):',n_NegCalcDiag_local
         If (n_NegCalcDiag_local.gt.0) Then
            ll=min(n_NegCalcDiag_local,SIZE(NegCalcDiag))
            Write(LuPri,'(I5,A)')
     *      ll,' most negative elements (this node):'
            Write(LuPri,'(1P,10D12.4)')
     *      (NegCalcDiag(i),i=1,ll)
         End If
         Call CHO_GADGOP(NegCalcDiag,1,'min')
         Write(LuPri,'(3X,A,1P,D12.4)')
     *   'Most negative element overall: ',NegCalcDiag(1)
      End If
      Call mma_deallocate(NegCalcDiag)

      IF (IPRINT .GE. INFO_DEBUG) THEN
         CALL CHO_HEAD(SECNAM//': Diagonal Info','=',80,LUPRI)
         XXX   = DBLE(NBAST)
         XMDIA = XXX*(XXX + 1.0D0)/2.0D0
         XLDIA = XLDIAG
         SAVD  = 1.0D2*(XMDIA - XLDIA)/XMDIA
         WRITE(LUPRI,'(/,2X,A,1P,D15.6)')
     &   'Screening threshold for initial diagonal: ',THRDIAG
         WRITE(LUPRI,'(2X,A,F15.1,/,2X,A,F15.1)')
     &   'Dimension of unscreened initial diagonal: ',XMDIA,
     &   'Dimension of   screened initial diagonal: ',XLDIA
         WRITE(LUPRI,'(2X,A,7X,F8.3,A)')
     &   'Saving from screening                   : ',SAVD,'%'
         DO ISYM = 1,NSYM
            WRITE(LUPRI,'(2X,A,I2,12X,A,1P,D15.6)')
     &      'Maximum diagonal, symmetry',ISYM,': ',DIAMAX(ISYM)
         END DO
         WRITE(LUPRI,'(2X,A,5X,I10)')
     &   'Number of negative diagonals computed   : ',n_NegCalcDiag
      END IF

C     Read through the file to get first reduced set.
C     -----------------------------------------------

      nnBstRSh(:,:,1) = 0

      REWIND(IUNIT)
      REWIND(JUNIT)
      IF (SCDIAG) THEN ! screen diagonal
         DEL1 = THRCOM*THRCOM/DAMP(1)
         DO ISYM = 1,NSYM
            IF (ABS(DIAMAX(ISYM)) .GT. 0.0D0) THEN
               SCRMAX(ISYM) = DEL1/DIAMAX(ISYM)
            ELSE
               SCRMAX(ISYM) = 1.0D15
            END IF
         END DO
         IF (CHO_USEABS) THEN
            DO IDUMP = 1,NDUMP
               CALL CHO_RDBUF(LENGTH,BUF,IBUF,LBUF,IUNIT)
               IF (IDUMP .EQ. NDUMP) THEN
                  CALL CHO_CLOSE(IUNIT,'DELETE')
               END IF
               DO L = 1,LENGTH
                  DIAGAB = BUF(L)
                  ISYMAB = IBUF(3,L)
                  IF (ABS(DIAGAB) .LT. SCRMAX(ISYMAB)) THEN
                     BUF(L)    = 0.0D0
                     IBUF(2,L) = -1
                  ELSE
                     ISHLAB = IBUF(1,L)
                     NNBSTRSH(ISYMAB,ISHLAB,1) =
     &                                     NNBSTRSH(ISYMAB,ISHLAB,1) + 1
                     IBUF(2,L) = NNBSTRSH(ISYMAB,ISHLAB,1)
                  END IF
               END DO
               CALL CHO_WRBUF(LENGTH,BUF,IBUF,LBUF,JUNIT)
            END DO
         ELSE
            DO IDUMP = 1,NDUMP
               CALL CHO_RDBUF(LENGTH,BUF,IBUF,LBUF,IUNIT)
               IF (IDUMP .EQ. NDUMP) THEN
                  CALL CHO_CLOSE(IUNIT,'DELETE')
               END IF
               DO L = 1,LENGTH
                  DIAGAB = BUF(L)
                  ISYMAB = IBUF(3,L)
                  IF (DIAGAB .LT. SCRMAX(ISYMAB)) THEN
                     BUF(L)    = 0.0D0
                     IBUF(2,L) = -1
                  ELSE
                     ISHLAB = IBUF(1,L)
                     NNBSTRSH(ISYMAB,ISHLAB,1) =
     &                                     NNBSTRSH(ISYMAB,ISHLAB,1) + 1
                     IBUF(2,L) = NNBSTRSH(ISYMAB,ISHLAB,1)
                  END IF
               END DO
               CALL CHO_WRBUF(LENGTH,BUF,IBUF,LBUF,JUNIT)
            END DO
         END IF
      ELSE ! no screening at all
         DO IDUMP = 1,NDUMP
            CALL CHO_RDBUF(LENGTH,BUF,IBUF,LBUF,IUNIT)
            IF (IDUMP .EQ. NDUMP) THEN
               CALL CHO_CLOSE(IUNIT,'DELETE')
            END IF
            DO L = 1,LENGTH
               ISHLAB = IBUF(1,L)
               ISYMAB = IBUF(3,L)
               NNBSTRSH(ISYMAB,ISHLAB,1) = NNBSTRSH(ISYMAB,ISHLAB,1) + 1
               IBUF(2,L) = NNBSTRSH(ISYMAB,ISHLAB,1)
            END DO
            CALL CHO_WRBUF(LENGTH,BUF,IBUF,LBUF,JUNIT)
         END DO
      END IF

      CALL CHO_GAIGOP(NNBSTRSH(:,:,1),NSYM*NNSHL,'+') ! sync
      CALL CHO_SETREDIND(1)

      END
      Subroutine UpdateMostNegative(n,X,Val)
      Implicit None
      Integer n
      Real*8  X(n)
      Real*8  Val

      Integer i, j

      If (Val.ge.X(n)) Return
      i=0
      Do While (i.lt.n)
         i=i+1
         If (Val.lt.X(i)) Then
            Do j=n,i+1,-1
               X(j)=X(j-1)
            End Do
            X(i)=Val
            i=n+1 ! break while loop
         End If
      End Do

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#ifdef _GROMACS_
      SUBROUTINE Fetch_QMMM(CastMM,nCastMM)

      IMPLICIT NONE

#include "Molcas.fh"
#include "periodic_table.fh"
#include "qmmm.fh"
#include "real.fh"
#include "stdalloc.fh"

      INTEGER, INTENT(IN) :: nCastMM
      INTEGER, DIMENSION(nCastMM), INTENT(IN) :: CastMM

      INTEGER :: iAtGMX,iAtNmbGMX,iAtOut,iCastMM,iFirst,iGrpGMX,iLast
      INTEGER :: iOk,ipCR,ipGMS,iXYZ,LuWr,LuXYZ,nAtGMX,nAtIn,nAtOut
      INTEGER, DIMENSION(:), ALLOCATABLE :: AT
      REAL*8, DIMENSION(:,:), ALLOCATABLE :: CoordGMX,CoordMMO
      CHARACTER(LEN=256) :: LogFileName, Message, TPRFileName
      CHARACTER(LEN=LENIN) :: Symbol
      CHARACTER(LEN=LENIN), DIMENSION(:), ALLOCATABLE :: LabMMO
      LOGICAL :: Exist

      INTEGER, EXTERNAL :: init_commrec,isFreeUnit,mmslave_copyx
      INTEGER, EXTERNAL :: mmslave_get_atomnumber,mmslave_get_group_id
      INTEGER, EXTERNAL :: mmslave_init,mmslave_natoms,mmslave_read_tpr

      LuWr = 6

! Initialize Gromacs mmslave
      ipCR = init_commrec()
      CALL prgmtranslate('GMX.LOG',LogFileName,iLast)
      LogFileName(iLast+1:iLast+1) = CHAR(0)
      ipGMS = mmslave_init(%val(ipCR),LogFileName)

! Tell Gromacs to read tpr file
      TPRFileName = TPRDefName
      iLast = LEN_TRIM(TPRFileName)
      CALL f_inquire(TPRFileName,Exist)
      IF (.NOT.Exist) THEN
         Message = 'File '//TPRFileName(1:iLast)//' not found'
         CALL WarningMessage(2,Message)
         CALL Quit_OnUserError()
      END IF
      TPRFileName(iLast+1:iLast+1) = CHAR(0)
      iOk = mmslave_read_tpr(TPRFileName,%val(ipGMS))
      IF (iOk.NE.1) THEN
         Message = 'Error reading tpr file'
         CALL WarningMessage(2,Message)
         CALL Quit_OnUserError()
      END IF

! Fetch coordinates from Gromacs
      nAtGMX = mmslave_natoms(%val(ipGMS))
      CALL mma_allocate(CoordGMX,3,nAtGMX)
      CALL dcopy_(3*nAtGMX,Zero,0,CoordGMX,1)
      iOk = mmslave_copyX(%val(ipGMS),%val(nAtGMX),CoordGMX)
      IF (iOk.NE.1) THEN
         Message = 'Fetch_QMMM: mmslave_copyx is not ok'
         CALL WarningMessage(2,Message)
         CALL Abend()
      END IF

! Find out and count atom types
      nAtIn = 0
      nAtOut = 0
      CALL mma_allocate(AT,nAtGMX)
      DO iAtGMX = 1,nAtGMX
         iGrpGMX = mmslave_get_group_id(%val(ipGMS),%val(iAtGMX-1))
         IF (iGrpGMX==QMGMX) THEN
            AT(iAtGMX) = QM
         ELSE IF (iGrpGMX==MMGMX) THEN
            AT(iAtGMX) = MMO
         ELSE
            Message = 'Fetch_QMMM: unknown index group'
            CALL WarningMessage(2,Message)
            CALL Abend()
         END IF
      END DO
      DO iCastMM = 1,nCastMM
         IF (AT(CastMM(iCastMM))==QM) THEN
            Message = 'Attempting to cast atom of QM type'
            CALL WarningMessage(2,Message)
            CALL Quit_OnUserError()
         ELSE IF (AT(CastMM(iCastMM))==MMI) THEN
            Message = 'Attempting to cast atom of MMI type'
            CALL WarningMessage(2,Message)
            CALL Quit_OnUserError()
         END IF
         AT(CastMM(iCastMM)) = MMI
      END DO
      DO iAtGMX = 1,nAtGMX
         IF (AT(iAtGMX)==QM.OR.AT(iAtGMX)==MMI) THEN
            nAtIn = nAtIn+1
         ELSE
            nAtOut = nAtOut+1
         END IF
      END DO

! Put QM and inner MM atoms in xyz file and outer MM atoms on runfile
      LuXYZ = 1
      LuXYZ = isFreeUnit(LuXYZ)
      CALL molcas_open(LuXYZ,'GMX.XYZ')
      WRITE(LuXYZ,'(i5,/)') nAtIn
      CALL mma_allocate(CoordMMO,3,nAtOut)
      CALL mma_allocate(LabMMO,nAtOut)
      iAtOut = 1
      DO iAtGMX = 1,nAtGMX
         iAtNmbGMX = mmslave_get_atomnumber(%val(ipGMS),%val(iAtGMX-1))
         iFirst = INDEX(PTab(iAtNmbGMX),' ')+1
         IF (AT(iAtGMX)==QM) THEN
            Symbol = PTab(iAtNmbGMX)(iFirst:2)
         ELSE
            Symbol = PTab(iAtNmbGMX)(iFirst:2)//'_MM'
         END IF
         IF (AT(iAtGMX)==QM.OR.AT(iAtGMX)==MMI) THEN
            WRITE(LuXYZ,'(a8,3E24.15E3)') Symbol(1:5),
     &           (CoordGMX(iXYZ,iAtGMX)*NmToAng,iXYZ=1,3)
         ELSE
            DO iXYZ = 1,3
               CoordMMO(iXYZ,iAtOut) = CoordGMX(iXYZ,iAtGMX)
            END DO
            LabMMO(iAtOut) = Symbol
            iAtOut = iAtOut+1
         END IF
      END DO
      CLOSE(LuXYZ)
      CALL Put_iArray('Atom Types',AT,nAtGMX)
      CALL dscal_(3*nAtOut,One/AuToNm,CoordMMO,1)
      CALL Put_dArray('MMO Coords',CoordMMO,3*nAtOut)
      CALL Put_cArray('MMO Labels',LabMMO,LENIN*nAtOut)

! Clean up
      CALL mma_deallocate(CoordGMX)
      CALL mma_deallocate(AT)
      CALL mma_deallocate(CoordMMO)
      CALL mma_deallocate(LabMMO)
      CALL mmslave_done(%val(ipGMS))

      RETURN
      END
#elif defined (NAGFOR)
      SUBROUTINE empty_Fetch_QMMM()
      END
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Roland Lindh                                     *
!***********************************************************************

subroutine Update_sl(Step_Trunc,nWndw,kIter)
!***********************************************************************
!                                                                      *
!     Object: to update coordinates                                    *
!                                                                      *
!    OutPut:                                                           *
!      Step_Trunc     : character label to denote truncation type      *
!                                                                      *
!                                                                      *
!     Author: Roland Lindh                                             *
!             2000                                                     *
!***********************************************************************

use Slapaf_Info, only: Beta, Beta_disp, iter, NmIter, qInt, Shift
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
character, intent(inout) :: Step_Trunc
integer(kind=iwp), intent(in) :: nWndw, kIter
integer(kind=iwp) :: iOpt_RS, iter_, nQQ
real(kind=wp) :: Dummy(1), qBeta, qBeta_Disp
logical(kind=iwp) :: Kriging_Hessian, Hide
real(kind=wp), allocatable :: t_qInt(:,:), t_Shift(:,:), tmp(:)

!                                                                      *
!***********************************************************************
!                                                                      *
nQQ = size(qInt,1)

#ifdef _DEBUGPRINT_
call RecPrt('Update_sl: qInt',' ',qInt,nQQ,Iter)
call RecPrt('Update_sl: Shift',' ',Shift,nQQ,Iter-1)
#endif

iOpt_RS = 0
qBeta = Beta
qBeta_Disp = Beta_Disp
!                                                                      *
!***********************************************************************
!                                                                      *
call Mk_Hss_Q()
Kriging_Hessian = .false.
!                                                                      *
!***********************************************************************
!                                                                      *
! Select between numerical evaluation of the Hessian or a molcular
! geometry optimization.

Hide = Step_Trunc == '#'
Step_Trunc = ' '
if ((iter == NmIter) .and. (NmIter /= 1)) then
!                                                                      *
!***********************************************************************
!                                                                      *
! On the first iteration after a numerical evaluation of the
! Hessian we like the step to be relative to the initial structure.

# ifdef _DEBUGPRINT_
  write(u6,*) 'UpDate_SL: first iteration'
# endif
  iter_ = 1
  call mma_Allocate(t_Shift,nQQ,size(Shift,2),Label='t_Shift')
  t_Shift(:,:) = Shift(:,:)
  Shift(:,:) = Zero

  call mma_Allocate(t_qInt,nQQ,size(qInt,2),Label='t_qInt')
  t_qInt(:,:) = qInt(:,:)
  qInt(:,:) = Zero
  qInt(:,1) = t_qInt(:,1)

  call Update_inner(iter_,Beta,Beta_Disp,Step_Trunc,nWndw,kIter,Kriging_Hessian,qBeta,iOpt_RS,.true.,iter_,qBeta_Disp,Hide)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Move new coordinates to the correct position and compute the
  ! corresponding shift.

  call mma_allocate(Tmp,size(qInt,1),Label='tmp')
  tmp(:) = qInt(:,2)
  qInt(:,:) = t_qInt(:,:)
  qInt(:,iter+1) = tmp(:)
  Shift(:,:) = t_Shift(:,:)
  Shift(:,iter) = tmp(:)-qInt(:,iter)

  call mma_deallocate(tmp)
  call mma_deallocate(t_qInt)
  call mma_deallocate(t_Shift)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
else
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  ! Conventional optimization.

  call Update_inner(iter,Beta,Beta_Disp,Step_Trunc,nWndw,kIter,Kriging_Hessian,qBeta,iOpt_RS,.true.,iter,qBeta_Disp,Hide)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out the shift in internal coordinates basis.

#ifdef _DEBUGPRINT_
call RecPrt('Shifts in internal coordinate basis / au or rad',' ',Shift,nQQ,Iter)
call RecPrt('qInt in internal coordinate basis / au or rad',' ',qInt,nQQ,Iter+1)
#endif

! Remove unneeded fields from the runfile
Dummy(1) = -Zero
call Put_dArray('BMxOld',Dummy,0)
call Put_dArray('TROld',Dummy,0)

return

end subroutine Update_sl

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_VecDsk_GetLQ(QVec,l_QVec,LstQSP,nQSP,iV1,nV,mSym)
!
! Purpose: extract elements corresponding to qualified columns of
!          vectors on disk.

use Cholesky, only: nnBstRSh, nQual, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: l_QVec, nQSP, LstQSP(nQSP), mSym, iV1(mSym), nV(mSym)
real(kind=wp), intent(inout) :: QVec(l_QVec)
integer(kind=iwp) :: iAB, iLoc, iQ, iQSP, iRedC, iRedQ, iShlAB, iSym, iV2, jLoc, jV, kOffQ, kQ, l_iQuAB_2, l_Scr, lDim, &
                     nVecTot(8), nVT
integer(kind=iwp), allocatable :: iQuAB_2(:)
real(kind=wp), allocatable :: Scr(:)
character(len=*), parameter :: SecNam = 'Cho_VecDsk_GetLQ'
integer(kind=iwp), external :: Cho_P_LocalSP

! Check input.
! ------------

if (nQSP < 1) return

if (mSym < nSym) call Cho_Quit('mSym<nSym in '//SecNam,104)

nVT = sum(nV(1:nSym))
if (nVT < 1) return

do iSym=1,nSym
  if (nV(iSym) > 0) then
    if (iV1(iSym) < 1) call Cho_Quit('iV1<1 in '//SecNam,104)
  end if
end do

! Allocate memory for reading.
! ----------------------------

l_Scr = 0
do iSym=1,nSym
  if ((nV(iSym) > 0) .and. (nQual(iSym) > 0)) then
    lDim = 0
    do iQSP=1,nQSP
      iShlAB = Cho_P_LocalSP(LstQSP(iQSP))
      lDim = lDim+nnBstRSh(iSym,iShlAB,1)
    end do
    l_Scr = max(l_Scr,lDim)
  end if
end do
call mma_allocate(Scr,l_Scr,Label='Scr')

! Allocate extra mapping from qualified to reduced set.
! -----------------------------------------------------

l_iQuAB_2 = nQual(1)
do iSym=2,nSym
  l_iQuAB_2 = max(l_iQuAB_2,nQual(iSym))
end do
call mma_allocate(iQuAB_2,l_iQuAB_2,Label='iQuAB_2')

! Extract in each symmetry block.
! -------------------------------

call Cho_P_GetGV(nVecTot,nSym)

jLoc = 2
iLoc = 3
iRedC = -1
kOffQ = 0
do iSym=1,nSym
  iRedQ = -2
  if ((nV(iSym) > 0) .and. (nQual(iSym) > 0)) then
    iV2 = iV1(iSym)+nV(iSym)-1
    do jV=iV1(iSym),iV2
      call Cho_1VecRd_SP(Scr,l_Scr,jV,iSym,LstQSP,nQSP,iRedC,iLoc)
      if (iRedQ /= iRedC) then
        call Cho_SetQ2(iQuAB_2,LstQSP,nQSP,iSym,jLoc,iLoc)
        iRedQ = iRedC
      end if
      kQ = kOffQ+nQual(iSym)*(jV-1)
      do iQ=1,nQual(iSym)
        iAB = iQuAB_2(iQ)
        QVec(kQ+iQ) = Scr(iAB)
      end do
    end do
  end if
  kOffQ = kOffQ+nQual(iSym)*nVecTot(iSym)
end do

! Deallocations.
! --------------

call mma_deallocate(iQuAB_2)
call mma_deallocate(Scr)

end subroutine Cho_VecDsk_GetLQ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_RDRSTC(IFAIL)
C
C     Purpose: read decomposition restart info and store in common
C              block. If IFAIL != 0 on exit, some error occurred and,
C              most likely, some of the restart info is not
C              defined/initialized.
C
C     NB!!!! the restart files MUST be open on entry...
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_RDRSTC')

      CHARACTER*6 FRST
      PARAMETER (FRST = 'CHORST')

      PARAMETER (LSCR = 8)
      REAL*8  DSCR(LSCR)
      INTEGER JSCR(LSCR)

      INFRED(I)=IWORK(ip_INFRED-1+I)

C     Set return code.
C     ----------------

      IFAIL = 0

C     Read molecular info.
C     --------------------

      IADR = 0

      IOPT = 2
      NRD  = 4
      CALL IDAFILE(LURST,IOPT,JSCR,NRD,IADR)
      XNSYM   = JSCR(1)
      XNSHELL = JSCR(2)
      XNNSHL  = JSCR(3)
      IF (XNSYM.LT.1 .OR. XNSYM.GT.8) THEN
         WRITE(LUPRI,'(A,A,I10)')
     &   SECNAM,': #irreps from restart file: ',XNSYM
         IFAIL = 1
         GO TO 100
      ELSE
         IOPT = 2
         CALL IDAFILE(LURST,IOPT,XNBAS,XNSYM,IADR)
      END IF

C     Read decomposition configuration info.
C     --------------------------------------

      IOPT = 2
      NRD  = 2
      CALL IDAFILE(LURST,IOPT,JSCR,NRD,IADR)
      IF (JSCR(1) .EQ. 0) THEN
         XSCDIAG = .FALSE.
      ELSE IF (JSCR(1) .EQ. 1) THEN
         XSCDIAG = .TRUE.
      ELSE
         WRITE(LUPRI,'(A,A,I10)')
     &   SECNAM,': integer flag for screening not recognized:',JSCR(1)
         IFAIL = 2
         GO TO 100
      END IF
      XCHO_ADRVEC = JSCR(2)

      IOPT = 2
      NRD  = 8
      CALL DDAFILE(LURST,IOPT,DSCR,NRD,IADR)
      XTHRCOM  = DSCR(1)
      XTHRDIAG = DSCR(2)
      XDAMP(1) = DSCR(3)
      XDAMP(2) = DSCR(4)
      XSPAN    = DSCR(5)
      XTHRNEG  = DSCR(6)
      XWARNEG  = DSCR(7)
      XTOONEG  = DSCR(8)

C     Read decomposition info.
C     ------------------------

      IOPT = 2
      NRD  = 1
      CALL IDAFILE(LURST,IOPT,JSCR,NRD,IADR)
      XNPASS = JSCR(1)
      IF (XNPASS.LT.1 .OR. XNPASS.GT.MAXRED) THEN
         WRITE(LUPRI,'(A,A,I10)')
     &   SECNAM,': #reduced sets in restart:',XNPASS
         IFAIL = 3
         GO TO 100
      ELSE
         IOPT = 2
         CALL IDAFILE(LURST,IOPT,IWORK(ip_INFRED),XNPASS,IADR)
         IF (INFRED(1) .NE. 0) THEN
            WRITE(LUPRI,'(A,A,I10)')
     &      SECNAM,': disk address of 1st reduced set:',IWORK(ip_INFRED)
            IFAIL = 4
            GO TO 100
         END IF
         LREST = MAXRED - XNPASS
         IF (LREST .GT. 0) CALL CHO_IZERO(IWORK(ip_INFRED+XNPASS),LREST)
      END IF
      DO ISYM = 1,NSYM
         IOPT = 2
         NRD  = 1
         CALL IDAFILE(LURST,IOPT,JSCR,NRD,IADR)
         NUMCHO(ISYM) = JSCR(1)
         IF (NUMCHO(ISYM).LT.0 .OR. NUMCHO(ISYM).GT.MAXVEC) THEN
            WRITE(LUPRI,'(A,A,I2,A,I10)')
     &      SECNAM,': #Cholesky vectors (sym.',ISYM,'): ',NUMCHO(ISYM)
            IFAIL = 5
            GO TO 100
         ELSE IF (NUMCHO(ISYM) .EQ. 0) THEN
            NDIM = MAXVEC*INFVEC_N2
            KOFF = ip_INFVEC + NDIM*(ISYM-1)
            CALL CHO_IZERO(IWORK(KOFF),NDIM)
         ELSE
            DO J = 1,INFVEC_N2
               IOPT = 2
               KOFF = ip_INFVEC + MAXVEC*INFVEC_N2*(ISYM-1)
     &              + MAXVEC*(J-1)
               CALL IDAFILE(LURST,IOPT,IWORK(KOFF),NUMCHO(ISYM),IADR)
               LREST = MAXVEC - NUMCHO(ISYM)
               IF (LREST .GT. 0) THEN
                  KOFF = ip_INFVEC + MAXVEC*INFVEC_N2*(ISYM-1)
     &                 + MAXVEC*(J-1) + NUMCHO(ISYM)
                  CALL CHO_IZERO(IWORK(KOFF),LREST)
               END IF
            END DO
         END IF
      END DO

  100 IF (IFAIL .NE. 0) THEN  ! failures jump to this point
         WRITE(LUPRI,'(A,A)')
     &   SECNAM,': refusing to read more restart info!'
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE REFORM_CONF_OCC(IOCC_EXP,IOCC_PCK,NEL,NOCOB,IWAY)
*
* Reform between two ways of writing occupations
*
* IOCC_EXP : Occupation in expanded form, i.e. the orbital for each
*            electron is given
*
* IOCC_PCK  : Occupation is given in packed form, i.e. each occupied
*             orbitals is given once, and a negative index indicates
*             a double occupattion
*
* IWAY = 1 Expanded to Packed form
* IWAY = 2 Packed to expanded form
*
* Jeppe Olsen, Nov. 2001
*
#include "implicit.fh"
*. Input/Output
      INTEGER IOCC_EXP(NEL),IOCC_PCK(NOCOB)
*
      IF(IWAY.EQ.1) THEN
*
*. Expanded => Packed form
*
*. Loop over electrons
        IEL = 1
        IOCC = 0
 1000   CONTINUE
C         IEL = IEL + 1
          IF(IEL.LT.NEL) THEN
            IF(IOCC_EXP(IEL).EQ.IOCC_EXP(IEL+1)) THEN
              IOCC = IOCC + 1
              IOCC_PCK(IOCC) = -IOCC_EXP(IEL)
              IEL = IEL + 2
            ELSE
              IOCC = IOCC + 1
              IOCC_PCK(IOCC) =  IOCC_EXP(IEL)
              IEL = IEL + 1
            END IF
          ELSE
*. Last occupation was not identical to previous, so single occupied
            IOCC = IOCC + 1
            IOCC_PCK(IOCC) =  IOCC_EXP(IEL)
            IEL = IEL + 1
          END IF
        IF(IEL.LE.NEL) GOTO 1000
*
      ELSE IF( IWAY.EQ.2) THEN
*
* Packed to expanded form
*
        IEL = 0
        DO IORB = 1, NOCOB
          IF(IOCC_PCK(IORB).LT.0) THEN
            JORB = - IOCC_PCK(IORB)
            IEL = IEL +1
            IOCC_EXP(IEL) = JORB
            IEL = IEL + 1
            IOCC_EXP(IEL) = JORB
          END IF
        END DO
      ELSE
        WRITE(6,*) ' REFORM_CONF... in error, IWAY = ', IWAY
*        STOP       ' REFORM_CONF... in error, IWAY '
         CALL SYSABENDMSG('lucia_util/reform_conv',
     &                    'Internal error',' ')
      END IF
*     ^ End of IWAY switch
*
      NTEST = 00
      IF(NTEST.GE.100) THEN
        WRITE(6,*) ' Reforming form of configuration '
        IF(IWAY.EQ.1) THEN
           WRITE(6,*) ' Expanded to packed form '
        ELSE
           WRITE(6,*) ' Packed to expanded form '
        END IF
        WRITE(6,*) ' IOCC_EXP : '
        CALL IWRTMA(IOCC_EXP,1,NEL,1,NEL)
        WRITE(6,*) ' IOCC_PCK : '
        CALL IWRTMA(IOCC_PCK,1,NOCOB,1,NOCOB)
      END IF
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FockTwo_Drv_scf(nSym,nBas,nAux,Keep,DLT,DSQ,FLT,nFLT,ExFac,nBSQT,nBMX,nD,nOcc,lOcc,iDummy_run)

use OFembed, only: Do_OFemb, FMaux, OFE_first, Rep_EN
use InfSCF, only: ALGO
use Cholesky, only: timings
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nSym, nBas(nSym), nAux(nSym), Keep(nSym), nFLT, nBSQT, nBMX, nD, lOcc, nOcc(lOcc,nD), iDummy_run
real(kind=wp), intent(inout) :: DLT(nFLT,nD), FLT(nFLT,nD)
real(kind=wp), intent(in) :: DSQ(nBSQT,nD), ExFac
integer(kind=iwp) :: iRC, lBuf
real(kind=wp) :: TotCPU, TotCPU1, TotCPU2, TotWall, TotWall1, TotWall2
logical(kind=iwp) :: DoCholesky, GenInt
character(len=50) :: CFmt
real(kind=wp), allocatable :: FSQ(:,:), tFLT(:,:), W1(:), W2(:)

GenInt = .false.
DoCholesky = .false.
if (ALGO == 0) GenInt = .true. !use GenInt to regenerate integrals
call DecideOnCholesky(DoCholesky)

!write(u6,*) '*************************'
!write(u6,*) 'ONLY COULOMB CONTRIBUTION'
!write(u6,*) '*************************'
!ExFac = Zero
!write(u6,*) 'ExFac= ',ExFac

if (Do_OFemb) then ! Coul. potential from subsys B
  if (OFE_first) call mma_allocate(FMaux,nFlt,Label='FMaux')

  call Coul_DMB(OFE_first,nD,Rep_EN,FMaux,DLT(:,1),DLT(:,nD),nFlt)
  OFE_first = .false.
end if

call mma_allocate(FSQ,nBSQT,nD,Label='FSQ')
FSQ(:,:) = Zero

if ((.not. DoCholesky) .or. GenInt) call mma_Allocate(W2,NBMX*NBMX,Label='W2')

! nFlt is the total dimension of the LT fock matrix
call mma_allocate(tFLT,nFLT,nD,Label='tFLT')
tFLT(:,:) = Zero

call mma_maxDBLE(LBUF)

! Standard building of the Fock matrix from Two-el integrals
! or
! Building of the Fock matrix regenerating the integrals on the fly

call CWTIME(TotCPU1,TotWALL1)

if ((.not. DoCholesky) .or. GenInt) then

  if (DoCholesky) then
    ! save some space for GenInt
    LBUF = max(LBUF-LBUF/10,0)
    ! Make sure that the ri/ch vectors are in reordered mode
    call Cho_X_ReOVec(irc)
  end if
  call mma_allocate(W1,LBUF,Label='W1')

  if (LBUF < NBMX**2) then
    write(u6,*) 'FockTwo_Drv_SCF Error: Too little memory remains for the call to FOCKTWO_SCF.'
    write(u6,*) ' Largest allocatable array size LBUF=',LBUF
    write(u6,*) ' Max nr of bf in any symmetry,  NBMX=',NBMX
    write(u6,*) ' Required minimum size       NBMX**2=',NBMX**2
    write(u6,*) '    (All in Real words)'
    call ABEND()
  end if

  call FOCKTWO_scf(nSym,nBas,nAux,Keep,DLT,DSQ,tFLT,nFlt,FSQ,W1,size(W1),W2,size(W2),ExFac,nD,nBSQT)

end if

call CWTIME(TotCPU2,TotWALL2)
TOTCPU = TotCPU2-TotCPU1
TOTWALL = TotWALL2-TotWALL1

! Timings information for conventional or Cholesky with ALGO=0
if ((.not. DoCholesky) .or. GenInt) then
  if (timings) then
    CFmt = '(2x,A)'
    write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
    if (DoCholesky) then
      write(u6,CFmt) '---    Cholesky SCF - Integral regeneration   ---'
    else
      write(u6,CFmt) '-----------     Conventional SCF     ------------'
    end if
    write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
    write(u6,CFmt) 'Fock matrix construction        CPU       WALL   '
    write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
    write(u6,'(2x,A26,2f10.2)') 'TOTAL                                     ',TOTCPU,TOTWALL
    write(u6,CFmt) '- - - - - - - - - - - - - - - - - - - - - - - - -'
    write(u6,*)
  end if
end if

! Building of the Fock matrix directly from Cholesky vectors

if (DoCholesky .and. (.not. GenInt) .and. (iDummy_run == 1)) then
  write(u6,*) '*** Warning: missing feature in Cholesky code'
  write(u6,*) 'Use the results with extra care!'
end if

if (DoCholesky .and. (.not. GenInt) .and. (iDummy_run == 0)) &
  call CHOscf_drv(nBSQT,nD,nSym,nBas,DSQ(:,1),DLT(:,1),DSQ(:,nD),DLT(:,nD),tFLT(:,1),tFLT(:,nD),nFLT,ExFac,FSQ,nOcc(:,1),nOcc(:,nD))

FLT(:,:) = FLT(:,:)+tFLT(:,:)

call mma_deallocate(tFLT)

if (Do_OFemb) then ! add FM from subsystem B
  FLT(:,1) = FLT(:,1)+FMaux(:)
  if (nD == 2) FLT(:,2) = FLT(:,2)+FMaux(:)
end if

if ((.not. DoCholesky) .or. GenInt) then
  call mma_deallocate(W1)
  call mma_deallocate(W2)
end if

call mma_deallocate(FSQ)

return

end subroutine FockTwo_Drv_scf

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*PAM04      SUBROUTINE SORT (BUFOUT,INDOUT,FC,FIIJJ,FIJIJ,NINTGR)
      SUBROUTINE SORT_MRCI (BUFS,INDS,FC,FIIJJ,FIJIJ,NINTGR)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTRINSIC ABS,LOG10
#include "SysDef.fh"
#include "warnings.fh"
#include "mrci.fh"
c      DIMENSION BUFOUT(NBSIZ3,NCHN3)
c      DIMENSION INDOUT(RTOI*NBSIZ3,NCHN3)
*PAM04      DIMENSION BUFOUT(*)
*PAM04      DIMENSION INDOUT(*)
      DIMENSION BUFS(NBITM3,NCHN3)
      DIMENSION INDS(NBITM3+2,NCHN3)
      DIMENSION FC(NBTRI),FIIJJ(*),FIJIJ(*)
      DIMENSION IVEC(20),IPOF(65)
      DIMENSION NORB0(9)
      IAD50=0
      CALL iDAFILE(LUTRA,2,iTraToc,nTraToc,IAD50)
      NVT=IROW(NVIRT+1)
      DO 50 I=1,20
        IVEC(I)=0
50    CONTINUE
      IN=1
      DO 3 I=1,NSYM
        CALL IPO(IPOF(IN),NVIR,MUL,NSYM,I,-1)
        IN=IN+NSYM
3     CONTINUE
C ORDER OF RECORD-CHAINS IS
C 1.  NOT2 CHAINS (AB/IJ)
C 2.  NOT2 CHAINS (AI/BJ)
C 3.  NOT2 CHAINS (AI/JK)
C RECORD STRUCTURE IS
C 1.  NBITM3 INTEGRALS
C 2.  NBITM3 INDICES
C 3.  NUMBER OF INTEGRALS IN THIS RECORD
C 4.  ADDRESS OF LAST RECORD
      NOT2=IROW(LN+1)
      NOTT=2*NOT2
      NOVST=LN*NVIRT+1+NVT
      IDISK=0
CPAM97 The portable code should then be:
*PAM04      NBITM3=(RTOI*NBSIZ3-2)/(RTOI+1)
*PAM04      IBOFF3=RTOI*NBITM3
*PAM04      IBBC3=IBOFF3+NBITM3+1
*PAM04      IBDA3=IBBC3+1

      DO 5 IREC=1,NCHN3
*PAM04        INDOUT(IBBC3+(IREC-1)*RTOI*NBSIZ3)= 0
*PAM04        INDOUT(IBDA3+(IREC-1)*RTOI*NBSIZ3)=-1
        INDS(NBITM3+1,IREC)=0
        INDS(NBITM3+2,IREC)=-1
5     CONTINUE
      NORB0(1)=0
      DO 2 I=1,NSYM
        NORB0(I+1)=NORB0(I)+NORB(I)
2     CONTINUE
C READ ONE-ELECTRON ORBITALS. USE FIIJJ TEMPORARILY AS READ BUFFER.
      NORBTT=0
      DO 7654 ISYM=1,nsym
        NORBTT=NORBTT+(NORB(ISYM)*(NORB(ISYM)+1))/2
 7654 CONTINUE
      EFROZ=POTNUC
      CALL FZERO(FC,NBTRI)
      IADD17=ITOC17(2)
      CALL dDAFILE(LUONE,2,FIIJJ,NORBTT,IADD17)
      IBUF=0
      KORBI=0
      DO 200 ISYM=1,NSYM
        DO 199 JORBI=KORBI+1,KORBI+NORB(ISYM)
          DO 198 IORBI=KORBI+1,JORBI
            IBUF=IBUF+1
            ONEHAM=FIIJJ(IBUF)
            NI=ICH(IORBI)
            NJ=ICH(JORBI)
            IF(NI.EQ.0.OR.NJ.EQ.0)GO TO 198
            IF(NI.LT.NJ) THEN
              NTMP=NI
              NI=NJ
              NJ=NTMP
            END IF
            IF(NJ.GT.0) THEN
              IJT=IROW(NI)+NJ
              FC(IJT)=FC(IJT)+ONEHAM
            ELSE IF(NI.EQ.NJ) THEN
              EFROZ=EFROZ+2*ONEHAM
            END IF
198       CONTINUE
199     CONTINUE
        KORBI=KORBI+NORB(ISYM)
200   CONTINUE
      IF(IPRINT.GE.20) THEN
         CALL TRIPRT('FC IN SORT_MRCI BEFORE TWOEL',' ',FC,NORBT)
         WRITE(6,'(A,F20.8)') ' EFROZ:',EFROZ
      CALL XFLUSH(6)
      END IF
      CALL FZERO(FIIJJ,NBTRI)
      CALL FZERO(FIJIJ,NBTRI)
C TWO-ELECTRON INTEGRALS
      DO 313 NSP=1,NSYM
      NOP=NORB(NSP)
      DO 312 NSQ=1,NSP
      NSPQ=MUL(NSP,NSQ)
      NOQ=NORB(NSQ)
      DO 311 NSR=1,NSP
      NSPQR=MUL(NSPQ,NSR)
      NOR=NORB(NSR)
      NSSM=NSR
      IF(NSR.EQ.NSP)NSSM=NSQ
      DO 310 NSS=1,NSSM
      IF(NSS.NE.NSPQR)GO TO 310
      NOS=NORB(NSS)
      NORBP=NOP*NOQ*NOR*NOS
      IF(NORBP.EQ.0)GO TO 310
      CALL dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
      IOUT=0
      DO 309 NV=1,NOR
      NXM=NOS
      IF(NSR.EQ.NSS)NXM=NV
      DO 308 NX=1,NXM
      NTM=1
      IF(NSP.EQ.NSR)NTM=NV
      DO 307 NT=NTM,NOP
      NUMIN=1
      IF(NSP.EQ.NSR.AND.NT.EQ.NV)NUMIN=NX
      NUMAX=NOQ
      IF(NSP.EQ.NSQ)NUMAX=NT
      DO 306 NU=NUMIN,NUMAX
      IOUT=IOUT+1
      IF(IOUT.GT.NTIBUF) THEN
         CALL dDAFILE(LUTRA,2,TIBUF,NTIBUF,IAD50)
         IOUT=1
      END IF
      M1=ICH(NORB0(NSP)+NT)
      M2=ICH(NORB0(NSQ)+NU)
      M3=ICH(NORB0(NSR)+NV)
      M4=ICH(NORB0(NSS)+NX)
      IF(M1.EQ.0.OR.M2.EQ.0)GO TO 306
      IF(M3.EQ.0.OR.M4.EQ.0)GO TO 306
C ORDER THESE INDICES CANONICALLY
      N1=M1
      N2=M2
      IF(M1.GT.M2)GO TO 11
      N1=M2
      N2=M1
11    N3=M3
      N4=M4
      IF(M3.GT.M4)GO TO 12
      N3=M4
      N4=M3
12    NI=N1
      NJ=N2
      NK=N3
      NL=N4
      IF(NI.GT.NK)GO TO 502
      IF(NI.EQ.NK)GO TO 14
      NI=N3
      NJ=N4
      NK=N1
      NL=N2
      GO TO 502
14    IF(NJ.GT.NL)GO TO 502
      NL=N2
      NJ=N4
502   FINI=TIBUF(IOUT)
      IF(NI.LE.0 .OR. NJ.LE.0)GO TO 41
      IF(NK.LE.0 .OR. NL.LE.0)GO TO 41
      DFINI=ABS(FINI)+1.D-20
      IEXP=INT(-LOG10(DFINI))+5
      IF(IEXP.LE.20)IVEC(IEXP)=IVEC(IEXP)+1
      IF(NI.NE.NJ.OR.NK.NE.NL)GO TO 42
      IJ=IROW(NI)+NK
      FIIJJ(IJ)=FINI
C SKIP (AA/II) INTEGRALS
      GO TO 306
42    IF(NI.NE.NK.OR.NJ.NE.NL)GO TO 43
      IJ=IROW(NI)+NJ
      FIJIJ(IJ)=FINI
43    IF(NI.LE.LN)GO TO 306
      IF(NJ.GT.LN)GO TO 102
      IF(NK.GT.LN)GO TO 103
C AIJK
      JK=NOTT+IROW(NK)+NL
*PAM04      IPOS=INDOUT(IBBC3+(JK-1)*RTOI*NBSIZ3)+1
*PAM04      INDOUT(IBBC3+(JK-1)*RTOI*NBSIZ3)=IPOS
      IPOS=INDS(NBITM3+1,JK)+1
      INDS(NBITM3+1,JK)=IPOS
c      BUFOUT(IPOS,JK)=FINI
*PAM04      BUFOUT(IPOS+(JK-1)*NBSIZ3)=FINI
      BUFS(IPOS,JK)=FINI
*PAM04      INDOUT(IBOFF3+IPOS+(JK-1)*RTOI*NBSIZ3)=IROW(NI)+NJ
      INDS(IPOS,JK)=IROW(NI)+NJ
      IF(IPOS.LT.NBITM3)GO TO 306
      JDISK=IDISK
*PAM04      CALL dDAFILE(Lu_60,1,INDOUT(1+(JK-1)*RTOI*NBSIZ3),NBSIZ3,IDISK)
      CALL iDAFILE(Lu_60,1,INDS(1,JK),NBITM3+2,IDISK)
      CALL dDAFILE(Lu_60,1,BUFS(1,JK),NBITM3,IDISK)
*PAM04      INDOUT(IBBC3+(JK-1)*RTOI*NBSIZ3)=0
*PAM04      INDOUT(IBDA3+(JK-1)*RTOI*NBSIZ3)=JDISK
      INDS(NBITM3+1,JK)=0
      INDS(NBITM3+2,JK)=JDISK
      GO TO 306
103   IF(NL.GT.LN)GO TO 306
C AIBJ
      IIJ=NOT2+IROW(NJ)+NL
      IF(NL.GT.NJ)IIJ=NOT2+IROW(NL)+NJ
*PAM04      IPOS=INDOUT(IBBC3+(IIJ-1)*RTOI*NBSIZ3)+1
*PAM04      INDOUT(IBBC3+(IIJ-1)*RTOI*NBSIZ3)=IPOS
      IPOS=INDS(NBITM3+1,IIJ)+1
      INDS(NBITM3+1,IIJ)=IPOS
c      BUFOUT(IPOS,IIJ)=FINI
*PAM04      BUFOUT(IPOS+(IIJ-1)*NBSIZ3)=FINI
      BUFS(IPOS,IIJ)=FINI
      NSA=NSM(NI)
      NAV=NI-LN-NVIRP(NSA)
      NSB=NSM(NK)
      NBV=NK-LN-NVIRP(NSB)
      NSIJT=(MUL(NSM(NJ),NSM(NL))-1)*NSYM
      IF(NL.GT.NJ)GO TO 105
      INAV=IPOF(NSIJT+NSA)+(NBV-1)*NVIR(NSA)+NAV
      GO TO 104
105   INAV=IPOF(NSIJT+NSB)+(NAV-1)*NVIR(NSB)+NBV
104   CONTINUE
*PAM04      INDOUT(IPOS+IBOFF3+(IIJ-1)*RTOI*NBSIZ3)=INAV
      INDS(IPOS,IIJ)=INAV
      IF(IPOS.LT.NBITM3)GO TO 108
      JDISK=IDISK
*PAM04      CALL dDAFILE(Lu_60,1,INDOUT(1+(IIJ-1)*RTOI*NBSIZ3),NBSIZ3,IDISK)
      CALL iDAFILE(Lu_60,1,INDS(1,IIJ),NBITM3+2,IDISK)
      CALL dDAFILE(Lu_60,1,BUFS(1,IIJ),NBITM3,IDISK)
*PAM04      INDOUT(IBBC3+(IIJ-1)*RTOI*NBSIZ3)=0
*PAM04      INDOUT(IBDA3+(IIJ-1)*RTOI*NBSIZ3)=JDISK
      INDS(NBITM3+1,IIJ)=0
      INDS(NBITM3+2,IIJ)=JDISK
108   IF(NJ.NE.NL)GO TO 306
      IF(NI.EQ.NK)GO TO 306
      IKT=IROW(NI)+NK
      FC(IKT)=FC(IKT)-FINI
      GO TO 306
102   IF(NK.GT.LN)GO TO 306
C ABIJ
      IIJ=IROW(NK)+NL
*PAM04      IPOS=INDOUT(IBBC3+(IIJ-1)*RTOI*NBSIZ3)+1
*PAM04      INDOUT(IBBC3+(IIJ-1)*RTOI*NBSIZ3)=IPOS
      IPOS=INDS(NBITM3+1,IIJ)+1
      INDS(NBITM3+1,IIJ)=IPOS
*PAM04      BUFOUT(IPOS+(IIJ-1)*NBSIZ3)=FINI
      BUFS(IPOS,IIJ)=FINI
      NSA=NSM(NI)
      NAV=NI-LN-NVIRP(NSA)
      NSB=NSM(NJ)
      NBV=NJ-LN-NVIRP(NSB)
      NSIJT=(MUL(NSM(NK),NSM(NL))-1)*NSYM
      INAV=IPOF(NSIJT+NSA)+(NBV-1)*NVIR(NSA)+NAV
*PAM04      INDOUT(IBOFF3+IPOS+(IIJ-1)*RTOI*NBSIZ3)=INAV
      INDS(IPOS,IIJ)=INAV
      IF(IPOS.LT.NBITM3)GO TO 106
      JDISK=IDISK
*PAM04      CALL dDAFILE(Lu_60,1,INDOUT(1+(IIJ-1)*RTOI*NBSIZ3),NBSIZ3,IDISK)
      CALL iDAFILE(Lu_60,1,INDS(1,IIJ),NBITM3+2,IDISK)
      CALL dDAFILE(Lu_60,1,BUFS(1,IIJ),NBITM3,IDISK)
*PAM04      INDOUT(IBBC3+(IIJ-1)*RTOI*NBSIZ3)=0
*PAM04      INDOUT(IBDA3+(IIJ-1)*RTOI*NBSIZ3)=JDISK
      INDS(NBITM3+1,IIJ)=0
      INDS(NBITM3+2,IIJ)=JDISK
106   IF(NK.NE.NL)GO TO 306
      IF(NI.EQ.NJ)GO TO 306
      IJT=IROW(NI)+NJ
      FC(IJT)=FC(IJT)+2*FINI
      GO TO 306
C CHECK FOR FOCK-MATRIX, AND FROZEN ENERGY, CONTRIBUTIONS
41    CONTINUE
      IF(NI.LT.0) THEN
        IF((NI.EQ.NJ).AND.(NK.EQ.NL)) EFROZ=EFROZ+4*FINI
        IF((NI.EQ.NK).AND.(NJ.EQ.NL)) EFROZ=EFROZ-2*FINI
      ELSE IF(NL.LT.0) THEN
        IF((NK.EQ.NL).AND.(NJ.GT.0)) THEN
          IJT=IROW(NI)+NJ
          FC(IJT)=FC(IJT)+2*FINI
        ELSE IF((NJ.EQ.NL).AND.(NK.GT.0)) THEN
          IKT=IROW(NI)+NK
          FC(IKT)=FC(IKT)-FINI
        END IF
      END IF
306   CONTINUE
307   CONTINUE
308   CONTINUE
309   CONTINUE
310   CONTINUE
311   CONTINUE
312   CONTINUE
313   CONTINUE
C EMPTY LAST BUFFERS
      If ( (NOVST+NCHN3).gt.mChain ) then
         WRITE(6,*)'SORT_MRCI Error: NOVST+NCHN3>MCHAIN (See code).'
         CALL QUIT(_RC_GENERAL_ERROR_)
      End If
      DO 150 I=1,NCHN3
      JDISK=IDISK
*PAM04      CALL dDAFILE(Lu_60,1,INDOUT(1+(I-1)*RTOI*NBSIZ3),NBSIZ3,IDISK)
      CALL iDAFILE(Lu_60,1,INDS(1,I),NBITM3+2,IDISK)
      CALL dDAFILE(Lu_60,1,BUFS(1,I),NBITM3,IDISK)
      LASTAD(NOVST+I)=JDISK
150   CONTINUE
      DO 95 J=1,NORBT
      IND=IROW(J+1)
      FC(IND)=FC(IND)+EFROZ/NELEC
95    CONTINUE
      IADD25=0
      CALL dDAFILE(Lu_25,1,FC,NBTRI,IADD25)
      IAD25S=IADD25
      NOVS=NOVST+NCHN3
*      IF(IPRINT.GE.2) THEN
        WRITE(6,154)
        CALL XFLUSH(6)
        WRITE(6,155)(IVEC(I),I=1,20)
154     FORMAT(//6X,'STATISTICS FOR INTEGRALS, FIRST ENTRY 10**3-10**4',
     *  /)
        CALL XFLUSH(6)
155     FORMAT(6X,5I10)
*      END IF
      RETURN
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NINTGR)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      Subroutine PLF_LDF_3(AOint,ijkl,iCmp,jCmp,kCmp,lCmp,iShell,
     &                     iAO,iAOst,Shijij,iBas,jBas,kBas,lBas,kOp,
     &                     TInt,nTInt,iOff,iShlSO,nBasSh,iSOShl,
     &                     nSO,nShell,nSym,iSSOff)
************************************************************************
*                                                                      *
*  object: to sift and index the petite list format integrals.         *
*                                                                      *
*          the indices has been scrambled before calling this routine. *
*          Hence we must take special care in order to regain the can- *
*          onical order.                                               *
*                                                                      *
*                                                                      *
*  Author: Roland Lindh, IBM Almaden Research Center, San Jose, Ca     *
*          May '90                                                     *
*                                                                      *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use Basis_Info, only: nBas
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "lRI.fh"
#include "real.fh"
#include "print.fh"
#include "WrkSpc.fh"
*
      Real*8 AOint(ijkl,jCmp,kCmp,lCmp), TInt(nTInt)
      Integer iSOShl(nSO), iShlSO(nSO), nBasSh(0:nSym-1,nShell)
      Integer iShell(4), iAO(4), kOp(4), iAOst(4), iSOs(4), iOff(3)
      Logical Shijij, Shkl
*                                                                      *
************************************************************************
*                                                                      *
*define _DEBUGPRINT_
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2 + Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
      Shkl = iShell(3).eq.iShell(4)
      iOff1 = nBas(0)
      n3C= iOff(3)
      If (iShell(4).gt.iShell(3)) Then
         Write (6,*) 'iShell(4).gt.iShell(3)'
         Call Abend()
      End If
#ifdef _DEBUGPRINT_
      Call RecPrt('AOInt',' ',AOInt,ijkl,jCmp*kCmp*lCmp)
      Call RecPrt('Work(ipLocal_A)',' ',Work(ipLocal_A),nAB,nAB)
      n1=nTInt/n3C
      Write (6,*) 'n1,nTInt,n3C=',n1,nTInt,n3C
      Call RecPrt('TInt',' ',TInt,n3C,n1)
      Call IVcPrt('ISO2LO',' ',iSO2LO,2*nSO_Aux)
#endif
*
      Do i2 = 1, jCmp
         iSOs(2)=iAOtSO(iAO(2)+i2,kOp(2))+iAOst(2)
         Do i3 = 1, kCmp
            iSOs(3)=iAOtSO(iAO(3)+i3,kOp(3))+iAOst(3)
            lCmp_Max=lCmp
            If (Shkl) lCmp_Max=i3
            Do i4 = 1, lCmp_Max
               iSOs(4)=iAOtSO(iAO(4)+i4,kOp(4))+iAOst(4)
C              Write (*,*) 'i2,i3,i4=',i2,i3,i4
*                                                                      *
************************************************************************
*                                                                      *
               If (Shkl.and.i3.eq.i4) Then
*                                                                      *
************************************************************************
*                                                                      *
                  nijkl = 0
                  Do lSOl = iSOs(4), iSOs(4)+lBas-1
                     iD = iShlSO(lSOl)                  ! Relative index
                     Do kSOk = iSOs(3), iSOs(3)+kBas-1
                        iC = iShlSO(kSOk)
                        iShC=iSOShl(kSOk)
                        nC = nBasSh(0,iShC)
*
                        kl = iTri(iC,iD) + iSSOff
*
                        Do jSOj = iSOs(2), iSOs(2)+jBas-1
                           nijkl = nijkl + 1
                           If (lSOl.gt.kSOk) Go To 99
                           iAux = jSOj - iOff1
                           AInt_mnK=AOint(nijkl,i2,i3,i4)
C                          Write (*,*) 'iAux,AInt_mnK=',
C    &                                  iAux,AInt_mnK
*
*                          Multiply on-the-fly
*
*                          (mn|K)(K|L)^{-1} and accumulate in (mn|L)
*
                           iLO=ISO2LO(1,iAux)
                           Do jLO = 1, nAB
                              jAux= ISO2LO(2,jLO)
C                             Write (6,*) 'jLO,jAux=',jLO,jAux
                              ijLO=(jLO-1)*nAB+iLO-1
                              AInt_KL_Inv=Work(ipLocal_A+ijLO)
C                             Write (6,*) 'AInt_KL_Inv=',AInt_KL_Inv
                              kl_B = (jAux-1)*n3C + kl
C                             Write (6,*) 'kl_B=',kl_B
                              TInt(kl_B) = TInt(kl_B)
     &                                   + AInt_mnK
     &                                   * AInt_KL_Inv
                           End Do
*
 99                        Continue
*
                        End Do
                     End Do
                  End Do
*                                                                      *
************************************************************************
*                                                                      *
               Else
*                                                                      *
************************************************************************
*                                                                      *
                  nijkl = 0
                  Do lSOl = iSOs(4), iSOs(4)+lBas-1
                     iD = iShlSO(lSOl)
                     Do kSOk = iSOs(3), iSOs(3)+kBas-1
                        iC = iShlSO(kSOk)
                        iShC=iSOShl(kSOk)
                        nC = nBasSh(0,iShC)
*
                        If (Shkl) Then
                           kl = iTri(iC,iD)
                        Else
                           kl = (iD-1)*nC + iC
                        End If
                        kl = kl + iSSOff
*
                        Do jSOj = iSOs(2), iSOs(2)+jBas-1
                           iAux = jSOj - iOff1
                           nijkl = nijkl + 1
                           AInt_mnK=AOint(nijkl,i2,i3,i4)
C                          Write (*,*) 'iAux,AInt_mnK=',
C    &                                  iAux,AInt_mnK
*
*                          Multiply on-the-fly
*
*                          (mn|K)(K|L)^{-1} and accumulate in (mn|L)
*
                           iLO=ISO2LO(1,iAux)
                           Do jLO = 1, nAB
                              jAux= ISO2LO(2,jLO)
C                             Write (6,*) 'jLO,jAux=',jLO,jAux
                              ijLO=(jLO-1)*nAB+iLO-1
                              AInt_KL_Inv=Work(ipLocal_A+ijLO)
C                             Write (6,*) 'AInt_KL_Inv=',AInt_KL_Inv
                              kl_B = (jAux-1)*n3C + kl
C                             Write (6,*) 'kl_B=',kl_B
                              TInt(kl_B) = TInt(kl_B)
     &                                   + AInt_mnK
     &                                   * AInt_KL_Inv
                           End Do
*
                        End Do
                     End Do
                  End Do
*                                                                      *
************************************************************************
*                                                                      *
               End If
*                                                                      *
************************************************************************
*                                                                      *
            End Do
         End Do
      End Do
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Call RecPrt('TInt',' ',TInt,n3C,n1)
C     Call RecPrt('TInt',' ',TInt,1,nTInt)
#endif
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_integer(iCmp)
         Call Unused_logical(Shijij)
         Call Unused_integer(iBas)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014, Naoki Nakatani                                   *
************************************************************************
      SubRoutine Molpro_ChTab_BIS(nIrrep,Label,iChMolpro)
************************************************************************
*                                                                      *
* Object: To convert MOLCAS character table to MOLPRO format           *
*         This is a part of integral_util/chtab.f                      *
*                                                                      *
*         Written by N.Nakatani Nov. 2014                              *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      Integer iChMolpro(8)
      Integer iOper(nIrrep)
      Character*3 Label
      Logical Rot
************************************************************************
      Call Get_iArray('Symmetry operations',iOper,nIrrep)

      Do i=1,8
        iChMolpro(i)=0
      End Do

****** C1  symmetry ******
      If (nIrrep.eq.1) Then
        Label='c1 '
        iChMolpro(1)=1
      Else If (nIrrep.eq.2) Then
****** Ci  symmetry ******
        If (iOper(2).eq.7) Then
          Label='ci '
****** Cs  symmetry ******
        Else If (iOper(2).eq.1.or.iOper(2).eq.2.or.iOper(2).eq.4) Then
          Label='cs '
****** C2  symmetry ******
        Else
          Label='c2 '
        End If
        iChMolpro(1)=1
        iChMolpro(2)=2
      Else If (nIrrep.eq.4) Then
****** C2h symmetry ******
        If (iOper(2).eq.7.or.iOper(3).eq.7.or.iOper(4).eq.7) Then
          Label='c2h'
* MOLCAS::[ ag, bg, au, bu ] => MOLPRO::[ ag, au, bu, bg ]
          iChMolpro(1)=1
          iChMolpro(2)=4
          iChMolpro(3)=2
          iChMolpro(4)=3
        Else
          Rot = .True.
          Do i=1,nIrrep
            If (iOper(i).eq.1.or.iOper(i).eq.2.or.iOper(i).eq.4)
     &        Rot=.False.
          End Do
****** D2  symmetry ******
          If (Rot) Then
            Label='d2 '
* MOLCAS::[ a, b2, b1, b3 ] => MOLPRO::[ a, b3, b2, b1 ]
            iChMolpro(1)=1
            iChMolpro(2)=3
            iChMolpro(3)=4
            iChMolpro(4)=2
****** C2v symmetry ******
          Else
            Label='c2v'
* MOLCAS::[ a1, b1, a2, b2 ] => MOLPRO::[ a1, b1, b2, a2 ]
            iChMolpro(1)=1
            iChMolpro(2)=2
            iChMolpro(3)=4
            iChMolpro(4)=3
          End If
        End If
****** D2h symmetry ******
      Else If (nIrrep.eq.8) Then
        Label='d2h'
* MOLCAS::[ ag, b2g, b1g, b3g, au, b2u, b1u, b3u ] => MOLPRO::[ ag, b3u, b2u, b1g, b1u, b2g, b3g, au ]
        iChMolpro(1)=1
        iChMolpro(2)=6
        iChMolpro(3)=4
        iChMolpro(4)=7
        iChMolpro(5)=8
        iChMolpro(6)=3
        iChMolpro(7)=5
        iChMolpro(8)=2
      Else
         Call WarningMessage(2,'MOLPRO_ChTab: Illegal value of nIrrep')
         Write (6,*) 'nIrrep=',nIrrep
         Call Abend()
      End If

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines:
c     init
c
c     ---------------------------------------------------
c
       subroutine init (wrk,wrksize,
     & lunabij1,lunabij2,lunabij3)
c
c     this routine do FI1,FII1,FIII1,T11,T21
c     1) def F1(a,e) = fok(a,e)
c     2) def F2(m,i) = fok(m,i)
c     3) def F3(e,m) = fok(e,m)
c     4) def T1n(a,i) = fok(a,i)
c     5) def T2m(abij)= <ab||ij>
c
c     lunabij1 - lun of file, where <ab||ij>aaaa is stored (I)
c     lunabij2 - lun of file, where <ab||ij>bbbb is stored (I)
c     lunabij3 - lun of file, where <ab||ij>abab is stored (I)
c
c     N.B. this routine use and destry help files : none
c
#include "ccsd1.fh"
#include "ccsd2.fh"
#include "wrk.fh"
#include "paralell.fh"
       integer lunabij1,lunabij2,lunabij3
c
c     help variables
c
       integer posst,rc
c
c1.1  map fok(a,b)aa to f1(a,e)aa
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdfk1,mapifk1,1,mapdf11,mapif11,possf110,
     &           posst,rc)
c
c1.2  map fok(a,b)bb to f1(a,e)bb
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdfk2,mapifk2,1,mapdf12,mapif12,possf120,
     &           posst,rc)
c
c
c2.1  map fok(i,j)aa to f2(i,j)aa
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdfk5,mapifk5,1,mapdf21,mapif21,possf210,
     &           posst,rc)
c
c2.2  map fok(i,j)bb to f2(i,j)bb
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdfk6,mapifk6,1,mapdf22,mapif22,possf220,
     &           posst,rc)
c
c
c3.1  map fok(a,i)aa to f3(a,i)aa
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdfk3,mapifk3,1,mapdf31,mapif31,possf310,
     &           posst,rc)
c
c3.2  map fok(a,i)bb to f3(a,i)bb
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdfk4,mapifk4,1,mapdf32,mapif32,possf320,
     &           posst,rc)
c
c
        if (myRank.eq.0) then
c
c4.1  map fok(a,i)aa to t1n(a,i)aa
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdfk3,mapifk3,1,mapdt13,mapit13,posst130,
     &           posst,rc)
c
c4.2  map fok(a,i)bb to t1n(a,i)bb
       call map (wrk,wrksize,
     & 2,1,2,0,0,mapdfk4,mapifk4,1,mapdt14,mapit14,posst140,
     &           posst,rc)
c
        else
c
c4.3  set t1naa (t13) =0
        call set0 (wrk,wrksize,
     &             mapdt13,mapit13)
c
c4.4  set t1nbb (t14) =0
        call set0 (wrk,wrksize,
     &             mapdt14,mapit14)
c
        end if
c
c
        if (myRank.eq.0) then
c
c5.1  load <ab||ij>aaaa from lunabij1 to t2n(ab,ij)aaaa
       call filemanager (2,lunabij1,rc)
       call getmediate (wrk,wrksize,
     & lunabij1,posst210,mapdt21,mapit21,rc)
c
c5.2  load <ab||ij>bbbb from lunabij2 to t2n(ab,ij)bbbb
       call filemanager (2,lunabij2,rc)
       call getmediate (wrk,wrksize,
     & lunabij2,posst220,mapdt22,mapit22,rc)
c
c5.3  load <ab||ij>abab from lunabij3 to t2n(ab,ij)abab
       call filemanager (2,lunabij3,rc)
       call getmediate (wrk,wrksize,
     & lunabij3,posst230,mapdt23,mapit23,rc)
c
        else
c
c5.4  set t2naaaa (t21) =0
        call set0 (wrk,wrksize,
     &             mapdt21,mapit21)
c
c5.5  set t2nbbbb (t22) =0
        call set0 (wrk,wrksize,
     &             mapdt22,mapit22)
c
c5.6  set t2nabab (t23) =0
        call set0 (wrk,wrksize,
     &             mapdt23,mapit23)
c
        end if
c
c
       return
       end
c
c     --------------------------------------
c

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_LT2Q(A,LT,Q)
C
C     Thomas Bondo Pedersen, March 2011.
C
      Implicit None
      Integer A
      Real*8  LT(*)
      Real*8  Q(*)
#include "WrkSpc.fh"
#include "localdf_bas.fh"

      Character*8 SecNam
      Parameter (SecNam='LDF_LT2Q')

      Integer  LDF_nShell_Atom, LDF_lShell_Atom, LDF_nBas_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom, LDF_nBas_Atom

      Integer nS, ipS
      Integer ip_iOff, l_iOff
      Integer iS, jS
      Integer iShell, jShell
      Integer n, ip0, ip1
      Integer ipLT, ipQ, l
      Integer ii, jj

      Integer i, j
      Integer nBasSh
      Integer iOff
      Integer iTri
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iOff(i,j)=iWork(ip_iOff-1+nS*(j-1)+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      nS=LDF_nShell_Atom(A)
      ipS=LDF_lShell_Atom(A)-1
      l_iOff=nS**2
      Call GetMem('iOff','Allo','Inte',ip_iOff,l_iOff)
      n=0
      ip0=ip_iOff-1
      Do jS=1,nS
         jShell=iWork(ipS+jS)
         ip1=ip0+nS*(jS-1)
         Do iS=1,nS
            iShell=iWork(ipS+iS)
            iWork(ip1+iS)=n
            n=n+nBasSh(iShell)*nBasSh(jShell)
         End Do
      End Do
      If (n.ne.LDF_nBas_Atom(A)**2) Then
         Call WarningMessage(2,SecNam//': dimension error')
         Call LDF_Quit(1)
      End If
      ipLT=1
      Do iS=1,nS
         iShell=iWork(ipS+iS)
         Do jS=1,iS-1
            jShell=iWork(ipS+jS)
            l=nBasSh(iShell)*nBasSh(jShell)
            ipQ=iOff(iS,jS)+1
            Call dCopy_(l,LT(ipLT),1,Q(ipQ),1)
            ipQ=iOff(jS,iS)+1
            Do ii=0,nBasSh(iShell)-1
               Call dCopy_(nBasSh(jShell),LT(ipLT+ii),nBasSh(iShell),
     &                                   Q(ipQ+nBasSh(jShell)*ii),1)
            End Do
            ipLT=ipLT+l
         End Do
         ipLT=ipLT-1
         Do jj=1,nBasSh(iShell)
            ipQ=iOff(iS,iS)+nBasSh(iShell)*(jj-1)
            Do ii=1,nBasSh(iShell)
               Q(ipQ+ii)=LT(ipLT+iTri(ii,jj))
            End Do
         End Do
         ipLT=ipLT+1+nBasSh(iShell)*(nBasSh(iShell)+1)/2
      End Do
      ipLT=ipLT-1
      l=LDF_nBas_Atom(A)*(LDF_nBas_Atom(A)+1)/2
      If (ipLT.ne.l) Then
         Call WarningMessage(2,SecNam//': ipLT != l')
         Call LDF_Quit(1)
      End If
#if defined (_DEBUGPRINT_)
      n=0
      Do jS=1,nS
         jShell=iWork(ipS+jS)
         Do iS=jS,nS
            iShell=iWork(ipS+iS)
            Do jj=1,nBasSh(jShell)
               Do ii=1,nBasSh(iShell)
                  ip0=iOff(iS,jS)+nBasSh(iShell)*(jj-1)+ii
                  ip1=iOff(jS,iS)+nBasSh(jShell)*(ii-1)+jj
                  If (abs(Q(ip0)-Q(ip1)).gt.1.0d-15) Then
                     n=n+1
                  End If
               End Do
            End Do
         End Do
      End Do
      If (n.ne.0) Then
         Call WarningMessage(2,SecNam//': Q not symmetric')
         Call LDF_Quit(1)
      End If
#endif
      Call GetMem('iOff','Free','Inte',ip_iOff,l_iOff)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1992, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine SphCr2(Win,ijkl,ncd,
     &                  Scrt,nScrt,
     &                  Coeff1,iCar,iSph,Tr1,Pr1,
     &                  Coeff2,jCar,jSph,Tr2,Pr2,Wout,mab)
************************************************************************
*                                                                      *
* Object : to transform the two-electron integrals from cartesian      *
*          gaussians to real spherical harmonic gaussians.             *
*                                                                      *
*          Observe that most of the time Win and Wout will overlap.    *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Roland Lindh, Dept. of Theoretical Chemistry, University *
*             of Lund, SWEDEN.                                         *
*             Modified to back projection to cartesian gaussians,      *
*             January '92.                                             *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
      Real*8 Win(ijkl*ncd*iSph*jSph), Scrt(nScrt),
     &       Coeff1(iCar,iCar), Coeff2(jCar,jCar),
     &       Wout(ijkl*ncd*mab)
      Logical Tr1, Pr1, Tr2, Pr2
*
      iRout = 60
      iPrint = nPrint(iRout)
*     Call RecPrt(' In SphCr2: P(AB|cd) ',' ',Win,ncd*ijkl,iSph*jSph)
      If (Tr1.and.Tr2) Then
*        Call RecPrt(' Right contraction',' ',Coeff2,jCar,jSph)
*--------Starting with cd,IJKL,A,B transform to b,cd,IJKL,A
*        Call xxDGeMul(Coeff2,jCar,'N',
*    &               Win,ijkl*ncd*iSph,'T',
*    &               Scrt,jCar,
*    &               jCar,jSph,ijkl*ncd*iSph)
         Call NTMul(Coeff2,Win,Scrt,jCar,jSph,ijkl*ncd*iSph)
*
*        Call RecPrt(' Left contraction',' ',Coeff1,iCar,iSph)
*--------Transform b,cd,IJKL,A to ab,cd,IJKL
*        Call xxDGeMul(Coeff1,iCar,'N',
*    &               Scrt,jCar*ncd*ijkl,'T',
*    &               Wout,iCar,
*    &               iCar,iSph,jCar*ncd*ijkl)
         Call NTMul(Coeff1,Scrt,Wout,iCar,iSph,jCar*ncd*ijkl)
*        Transpose ab,cd,IJKL to IJKL,ab,cd
         call dcopy_(mab*ncd*ijkl,Wout,1,Scrt,1)
         Call DGeTMO(Scrt,mab*ncd,mab*ncd,ijkl,Wout,ijkl)
      Else If (Tr2) Then
*        Call RecPrt(' Right contraction',' ',Coeff2,jCar,jSph)
*--------Starting with cd,IJKL,a,B transform to b,cd,IJKL,a
*        Call xxDGeMul(Coeff2,jCar,'N',
*    &               Win,ncd*ijkl*iCar,'T',
*    &               Scrt,jCar,
*    &               jCar,jSph,ncd*ijkl*iCar)
         Call NTMul(Coeff2,Win,Scrt,jCar,jSph,ncd*ijkl*iCar)
*--------Transpose b,cd,IJKL,a to IJKL,ab,cd
         Call DGeTMO(Scrt,jCar*ncd,jCar*ncd,ijkl*iCar,Wout,ijkl*iCar)
      Else If (Tr1) Then
*--------Transpose cd,IJKL,A,b to b,cd,IJKL,A
         Call DGeTMO(Win,ncd*ijkl*iSph,ncd*ijkl*iSph,jCar,Scrt,jCar)
*
*        Call RecPrt(' Left contraction',' ',Coeff1,iCar,iSph)
*--------Transform b,cd,IJKL,A to ab,cd,IJKL
*        Call xxDGeMul(Coeff1,iCar,'N',
*    &               Scrt,jCar*ncd*ijkl,'T',
*    &               Wout,iCar,
*    &               iCar,iSph,jCar*ncd*ijkl)
         Call NTMul(Coeff1,Scrt,Wout,iCar,iSph,jCar*ncd*ijkl)
*--------Transpose ab,cd,IJKL to IJKL,ab,cd
         call dcopy_(iCar*jCar*ncd*ijkl,Wout,1,Scrt,1)
         Call DGeTMO(Scrt,iCar*jCar*ncd,iCar*jCar*ncd,ijkl,Wout,ijkl)
      Else
*---------Transpose cd,IJKL,ab to IJKL,ab,cd
          If (ncd.ne.1) Then
             call dcopy_(ncd*ijkl*iCar*jCar,Win,1,Scrt,1)
             Call DGeTMO(Scrt,ncd,ncd,ijkl*iCar*jCar,Wout,
     &                                ijkl*iCar*jCar)
          Else
             call dcopy_(ncd*ijkl*iCar*jCar,Win,1,Scrt,1)
             call dcopy_(ncd*ijkl*iCar*jCar,Scrt,1,Wout,1)
          End If
      End If
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In SphCr2: P(ab|cd)',' ',Wout,ijkl,ncd*mab)
      End If
*     Call GetMem(' Exit SphCr2','CHECK','REAL',iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_logical(Pr1)
         Call Unused_logical(Pr2)
      End If
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_SetIntegralPrescreeningInfo()
C
C     Thomas Bondo Pedersen, November 2010.
C
C     Purpose: Allocate and Set LDF integral prescreening info.
C              To deallocate, call LDF_UnsetIntegralPrescreeningInfo().
C
C     LDF info must be properly set up before calling this routine.
C
      Implicit None
#include "WrkSpc.fh"
#include "localdf.fh"
#include "localdf_int.fh"
#include "localdf_bas.fh"
#include "ldf_integral_prescreening_info.fh"
#include "ldf_atom_pair_info.fh"

#if defined (_DEBUGPRINT_)
      Character*31 SecNam
      Parameter (SecNam='LDF_SetIntegralPrescreeningInfo')
#endif

      Integer  LDF_nAtom, LDF_nAuxShell_Atom, LDF_nShell_Atom
      Integer  LDF_lShell_Atom, LDF_nBas_Atom
      External LDF_nAtom, LDF_nAuxShell_Atom, LDF_nShell_Atom
      External LDF_lShell_Atom, LDF_nBas_Atom

      Integer LDF_GlobalToAtomicShell

      Character*8 Label

      Integer nAtom
      Integer A, B, AB
      Integer ip, l
      Integer ip_myOffset, l_myOffset, l_myOffset_1
      Integer nnShl
      Integer iS, jS, ijS
      Integer iShell, jShell
      Integer ii, jj, ij0, ij
      Integer n1, n2
      Integer nSA, nSB, ipA, ipB
      Integer ip_D, l_D
      Integer ipD

      Real*8  Tmax, Tsum
      Real*8  CutInt_, CutInt

      Integer i, j
      Integer nBasSh
      Integer AP_Atoms
      Integer AP_2CFunctions
      Integer IndxG2
      Integer myOffset
      Integer iTri
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)
      IndxG2(i,j)=iWork(ip_IndxG2-1+l_IndxG2_1*(j-1)+i)
      myOffset(i,j)=iWork(ip_myOffset-1+l_myOffset_1*(j-1)+i)
      iTri(i,j)=max(i,j)*(max(i,j)-3)/2+i+j

      ! Get number of atoms
      nAtom=LDF_nAtom()

      ! Allocate GDiag 1C arrays
      l_GDiag_1C=2*nAtom
      Call GetMem('GD1C','Allo','Inte',ip_GDiag_1C,l_GDiag_1C)
      Do A=1,nAtom
         l=LDF_nAuxShell_Atom(A)
         If (l.gt.0) Then
            Write(Label,'(A,I5.5)') 'GD1',A-1
            Call GetMem(Label,'Allo','Real',ip,l)
            iWork(ip_GDiag_1C+2*(A-1))=l
            iWork(ip_GDiag_1C+2*(A-1)+1)=ip
         Else
            iWork(ip_GDiag_1C+2*(A-1))=0
            iWork(ip_GDiag_1C+2*(A-1)+1)=0
         End If
      End Do
      l_GDiag_1C_Mx=nAtom
      Call GetMem('GD1CMx','Allo','Real',ip_GDiag_1C_Mx,l_GDiag_1C_Mx)
      l_GDiag_1C_Sm=nAtom
      Call GetMem('GD1CSm','Allo','Real',ip_GDiag_1C_Sm,l_GDiag_1C_Sm)

      ! Set GDiag 1C info
      Call LDF_GetCutInt(CutInt_)
      CutInt=1.0d-99
      Call LDF_SetCutInt(CutInt)
      Call GetMem('GetMax','Max ','Real',ip,l)
      Call xSetMem_Ints(l)
      Do A=1,nAtom
         l=iWork(ip_GDiag_1C+2*(A-1))
         If (l.gt.0) Then
            ip=iWork(ip_GDiag_1C+2*(A-1)+1)
            Call LDF_SIPI_G1C(A,l,Work(ip),Work(ip_GDiag_1C_Mx-1+A),
     &                                     Work(ip_GDiag_1C_Sm-1+A))
#if defined (_DEBUGPRINT_)
            If (Work(ip_GDiag_1C_Sm-1+A).lt.0.0d0) Then
               Call WarningMessage(2,SecNam//': [1] sum < 0')
               Call LDF_Quit(1)
            End If
#endif
            Work(ip_GDiag_1C_Sm-1+A)=sqrt(Work(ip_GDiag_1C_Sm-1+A))
         Else
            Work(ip_GDiag_1C_Mx-1+A)=0.0d0
            Work(ip_GDiag_1C_Sm-1+A)=0.0d0
         End If
      End Do
      Call xRlsMem_Ints()
      Call LDF_SetCutInt(CutInt_) ! restore CutInt

      ! Allocate and set GDiag 2C arrays
      If (LDF2) Then
         l_GDiag_2C_Mx=NumberOfAtompairs
         Call GetMem('GD2CMx','Allo','Real',ip_GDiag_2C_Mx,
     &                                       l_GDiag_2C_Mx)
         l_GDiag_2C_Sm=NumberOfAtompairs
         Call GetMem('GD2CSm','Allo','Real',ip_GDiag_2C_Sm,
     &                                       l_GDiag_2C_Sm)
         l_GDiag_2C=2*NumberOfAtomPairs
         Call GetMem('GD2C','Allo','Inte',ip_GDiag_2C,l_GDiag_2C)
         Do AB=1,NumberOfAtomPairs
            If (AP_Atoms(1,AB).eq.AP_Atoms(2,AB)) Then
               l_D=LDF_nBas_Atom(AP_Atoms(1,AB))
               l_D=l_D*(l_D+1)/2
               Call GetMem('DiaLT','Allo','Real',ip_D,l_D)
               Call LDF_Q2LT(AP_Atoms(1,AB),
     &                       Work(iWork(ip_AP_DiagBak-1+AB)),Work(ip_D))
            Else
               l_D=0
               ip_D=iWork(ip_AP_DiagBak-1+AB)
            End If
            If (AP_2CFunctions(1,AB).gt.0) Then
               Call LDF_SetIndxG(AB)
               nnShl=l_2CList_2
               l=nnShl
               Write(Label,'(A,I5.5)') 'GD2',AB-1
               Call GetMem(Label,'Allo','Real',ip,l)
               iWork(ip_GDiag_2C+2*(AB-1))=l
               iWork(ip_GDiag_2C+2*(AB-1)+1)=ip
               A=AP_Atoms(1,AB)
               B=AP_Atoms(2,AB)
               nSA=LDF_nShell_Atom(A)
               ipA=LDF_lShell_Atom(A)-1
               nSB=LDF_nShell_Atom(B)
               ipB=LDF_lShell_Atom(B)-1
               l_myOffset_1=nSA
               l_myOffset=l_myOffset_1*nSB
               Call GetMem('myOffset','Allo','Inte',ip_myOffset,
     &                                               l_myOffset)
               Tsum=0.0d0
               If (A.eq.B) Then
                  ii=0
                  Do iS=1,l_myOffset_1
                     n1=nBasSh(iWork(ipA+iS))
                     Do jS=1,iS-1
                        iWork(ip_myOffset-1+l_myOffset_1*(jS-1)+iS)=ii
                        iWork(ip_myOffset-1+l_myOffset_1*(iS-1)+jS)=ii
                        ii=ii+n1*nBasSh(iWork(ipA+jS))
                     End Do
                     iWork(ip_myOffset-1+l_myOffset_1*(iS-1)+iS)=ii
                     ii=ii+n1*(n1+1)/2
                  End Do
                  Do ijS=0,nnShl-1
                     iShell=iWork(ip_2CList+3*ijS)
                     iS=LDF_GlobalToAtomicShell(A,iShell)
                     jShell=iWork(ip_2CList+3*ijS+1)
                     jS=LDF_GlobalToAtomicShell(B,jShell)
                     SPAB=iWork(ip_2CList+3*ijS+2)
                     Tmax=0.0d0
                     If (iS.eq.jS) Then
                        Do jj=1,nBasSh(jShell)
                           ij0=nBasSh(iShell)*(jj-1)
                           Do ii=1,nBasSh(iShell)
                              ij=ij0+ii
                              If (IndxG2(ij,SPAB).gt.0) Then
                                 ipD=ip_D-1+myOffset(iS,jS)
     &                              +iTri(ii,jj)
                                 Tmax=max(Tmax,Work(ipD))
                                 Tsum=Tsum+Work(ipD)
                              End If
                           End Do
                        End Do
                     Else If (iS.gt.jS) Then
                        Do jj=1,nBasSh(jShell)
                           ij0=nBasSh(iShell)*(jj-1)
                           Do ii=1,nBasSh(iShell)
                              ij=ij0+ii
                              If (IndxG2(ij,SPAB).gt.0) Then
                                 ipD=ip_D-1+myOffset(iS,jS)+ij
                                 Tmax=max(Tmax,Work(ipD))
                                 Tsum=Tsum+Work(ipD)
                              End If
                           End Do
                        End Do
                     Else ! iS < jS
                        Do jj=1,nBasSh(iShell)
                           ij0=nBasSh(jShell)*(jj-1)
                           Do ii=1,nBasSh(jShell)
                              ij=ij0+ii
                              If (IndxG2(ij,SPAB).gt.0) Then
                                 ipD=ip_D-1+myOffset(jS,iS)+ij
                                 Tmax=max(Tmax,Work(ipD))
                                 Tsum=Tsum+Work(ipD)
                              End If
                           End Do
                        End Do
                     End If
                     Work(ip+ijS)=Tmax
                  End Do
               Else
                  ii=0
                  Do jS=1,nSB
                     n2=nBasSh(iWork(ipB+jS))
                     Do iS=1,nSA
                        iWork(ip_myOffset-1+l_myOffset_1*(jS-1)+iS)=ii
                        ii=ii+nBasSh(iWork(ipA+iS))*n2
                     End Do
                  End Do
                  Do ijS=0,nnShl-1
                     iShell=iWork(ip_2CList+3*ijS)
                     iS=LDF_GlobalToAtomicShell(A,iShell)
                     jShell=iWork(ip_2CList+3*ijS+1)
                     jS=LDF_GlobalToAtomicShell(B,jShell)
                     SPAB=iWork(ip_2CList+3*ijS+2)
                     Tmax=0.0d0
                     Do jj=1,nBasSh(jShell)
                        ij0=nBasSh(iShell)*(jj-1)
                        Do ii=1,nBasSh(iShell)
                           ij=ij0+ii
                           If (IndxG2(ij,SPAB).gt.0) Then
                              ipD=ip_D-1+myOffset(iS,jS)+ij
                              Tmax=max(Tmax,Work(ipD))
                              Tsum=Tsum+Work(ipD)
                           End If
                        End Do
                     End Do
                     Work(ip+ijS)=Tmax
                  End Do
               End If
               Call GetMem('myOffset','Free','Inte',ip_myOffset,
     &                                               l_myOffset)
               l_myOffset=0
               l_myOffset_1=0
               Call LDF_UnsetIndxG()
               Tmax=Work(ip)
               Do ijS=1,nnShl-1
                  Tmax=max(Tmax,Work(ip+ijS))
               End Do
               Work(ip_GDiag_2C_Mx-1+AB)=Tmax
#if defined (_DEBUGPRINT_)
               If (Tsum.lt.0.0d0) Then
                  Call WarningMessage(2,SecNam//': [2] sum < 0')
                  Call LDF_Quit(1)
               End If
#endif
               Work(ip_GDiag_2C_Sm-1+AB)=sqrt(Tsum)
            Else
               iWork(ip_GDiag_2C+2*(AB-1))=0
               iWork(ip_GDiag_2C+2*(AB-1)+1)=0
               Work(ip_GDiag_2C_Mx-1+AB)=0.0d0
               Work(ip_GDiag_2C_Sm-1+AB)=0.0d0
            End If
            If (l_D.gt.0) Then
               Call GetMem('DiaLT','Free','Real',ip_D,l_D)
            End If
         End Do
      Else
         ip_GDiag_2C=0
         l_GDiag_2C=0
         ip_GDiag_2C_Mx=0
         l_GDiag_2C_Mx=0
         ip_GDiag_2C_Sm=0
         l_GDiag_2C_Sm=0
      End If

      ! Allocate and set IDiag arrays
      l_IDiag_Mx=NumberOfAtomPairs
      Call GetMem('IDiag_Mx','Allo','Real',ip_IDiag_Mx,l_IDiag_Mx)
      l_IDiag_Sm=NumberOfAtomPairs
      Call GetMem('IDiag_Sm','Allo','Real',ip_IDiag_Sm,l_IDiag_Sm)
      l_IDiag=2*NumberOfAtomPairs
      Call GetMem('IDiag','Allo','Inte',ip_IDiag,l_IDiag)
      Do AB=1,NumberOfAtomPairs
         l=LDF_nShell_Atom(AP_Atoms(1,AB))
     &    *LDF_nShell_Atom(AP_Atoms(2,AB))
         If (l.gt.0) Then
            Write(Label,'(A,I5.5)') 'IDI',AB-1
            Call GetMem(Label,'Allo','Real',ip,l)
            iWork(ip_IDiag+2*(AB-1))=l
            iWork(ip_IDiag+2*(AB-1)+1)=ip
            A=AP_Atoms(1,AB)
            B=AP_Atoms(2,AB)
            If (A.eq.B) Then
               l_D=LDF_nBas_Atom(A)
               l_D=l_D*(l_D+1)/2
               Call GetMem('DiaLT','Allo','Real',ip_D,l_D)
               Call LDF_Q2LT(AP_Atoms(1,AB),
     &                       Work(iWork(ip_AP_DiagBak-1+AB)),Work(ip_D))
            Else
               l_D=0
               ip_D=iWork(ip_AP_DiagBak-1+AB)
            End If
            nSA=LDF_nShell_Atom(A)
            ipA=LDF_lShell_Atom(A)-1
            nSB=LDF_nShell_Atom(B)
            ipB=LDF_lShell_Atom(B)-1
            Tsum=0.0d0
            If (A.eq.B) Then
               ipD=ip_D-1
               Do iS=1,nSA
                  Do jS=1,iS-1
                     Tmax=0.0d0
                     n1=nBasSh(iWork(ipA+iS))*nBasSh(iWork(ipB+jS))
                     Do ij=1,n1
                        Tmax=max(Tmax,Work(ipD+ij))
                        Tsum=Tsum+Work(ipD+ij)
                     End Do
                     ipD=ipD+n1
                     Work(ip-1+nSA*(jS-1)+iS)=Tmax
                     Work(ip-1+nSA*(iS-1)+jS)=Tmax
                  End Do
                  Tmax=0.0d0
                  n1=nBasSh(iWork(ipA+iS))*(nBasSh(iWork(ipA+iS))+1)/2
                  Do ij=1,n1
                     Tmax=max(Tmax,Work(ipD+ij))
                     Tsum=Tsum+Work(ipD+ij)
                  End Do
                  ipD=ipD+n1
                  Work(ip-1+nSA*(iS-1)+iS)=Tmax
               End Do
            Else
               ipD=ip_D-1
               Do jS=1,nSB
                  Do iS=1,nSA
                     Tmax=0.0d0
                     n1=nBasSh(iWork(ipA+iS))*nBasSh(iWork(ipB+jS))
                     Do ij=1,n1
                        Tmax=max(Tmax,Work(ipD+ij))
                        Tsum=Tsum+Work(ipD+ij)
                     End Do
                     ipD=ipD+n1
                     Work(ip-1+nSA*(jS-1)+iS)=Tmax
                  End Do
               End Do
            End If
            Tmax=Work(ip)
            Do ijS=1,nSA*nSB-1
               Tmax=max(Tmax,Work(ip+ijS))
            End Do
            Work(ip_IDiag_Mx-1+AB)=Tmax
#if defined (_DEBUGPRINT_)
            If (Tsum.lt.0.0d0) Then
               Call WarningMessage(2,SecNam//': [3] sum < 0')
               Call LDF_Quit(1)
            End If
#endif
            Work(ip_IDiag_Sm-1+AB)=sqrt(Tsum)
            If (l_D.gt.0) Then
               Call GetMem('DiaLT','Free','Real',ip_D,l_D)
            End If
         Else
            iWork(ip_IDiag+2*(AB-1))=0
            iWork(ip_IDiag+2*(AB-1)+1)=0
            Work(ip_IDiag_Mx-1+AB)=0.0d0
            Work(ip_IDiag_Sm-1+AB)=0.0d0
         End If
      End Do

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer Function LDF_GlobalToAtomicShell(A,iShell)
      Implicit None
      Integer A, iShell
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"

      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom

      Integer iS, iS_, nS, ip

      nS=LDF_nShell_Atom(A)
      ip=LDF_lShell_Atom(A)-1
      iS=0
      iS_=0
      Do While (iS_.lt.nS)
         iS_=iS_+1
         If (iWork(ip+iS_).eq.iShell) Then
            iS=iS_
            iS_=nS+1 ! break loop
         End If
      End Do
      If (iS.eq.0) Then
         Call WarningMessage(2,
     &   'LDF_GlobalToAtomicShell: shell not found!')
         Call LDF_Quit(1)
      End If

      LDF_GlobalToAtomicShell=iS

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_SIPI_G1C(A,l,Gmax_S,Gmax,Gsum)
      Implicit None
      Integer A
      Integer l
      Real*8  Gmax_S(l)
      Real*8  Gmax
      Real*8  Gsum
#include "WrkSpc.fh"
#include "localdf_bas.fh"
#include "localdf_int3.fh"

      External Int_LDF_Gmax_S

      Integer  LDF_nAuxShell_Atom, LDF_lAuxShell_Atom
      External LDF_nAuxShell_Atom, LDF_lAuxShell_Atom

      Integer l_Res
      Parameter (l_Res=2)
      Real*8 Res(l_Res)

      Integer nAuxShellA, ipA
      Integer iS, iShell, dShell

      nAuxShellA=LDF_nAuxShell_Atom(A)
      If (l.ne.nAuxShellA) Then
         Call WarningMessage(2,'LDF_SIPI_G1C: dimension error!')
         Call LDF_Quit(1)
      End If
      ipA=LDF_lAuxShell_Atom(A)-1

      Gmax=0.0d0
      Gsum=0.0d0

      dShell=nShell_Valence+nShell_Auxiliary+1
      SHA=dShell
      SHC=dShell
      Do iS=1,nAuxShellA
         iShell=iWork(ipA+iS)
         SHB=iShell
         SHD=iShell
         Call Eval_IJKL(dShell,iShell,dShell,iShell,Res,l_Res,
     &                  Int_LDF_Gmax_S)
         Gmax_S(iS)=Res(1)
         Gmax=max(Gmax,Res(1))
         Gsum=Gsum+Res(2)
      End Do

      SHA=0
      SHB=0
      SHC=0
      SHD=0

      End
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Subroutine LDF_UnsetIntegralPrescreeningInfo()
C
C     Thomas Bondo Pedersen, November 2010.
C
C     Purpose: Deallocate LDF integral prescreening info.
C
      Implicit None
#include "WrkSpc.fh"
#include "ldf_integral_prescreening_info.fh"

      Integer  LDF_nAtomPair, LDF_nAtom
      External LDF_nAtomPair, LDF_nAtom

      Character*8 Label

      Integer A, AB
      Integer ip, l

      If (l_GDiag_1C.gt.0) Then
         Do A=1,LDF_nAtom()
            l=iWork(ip_GDiag_1C+2*(A-1))
            If (l.gt.0) Then
               ip=iWork(ip_GDiag_1C+2*(A-1)+1)
               Write(Label,'(A,I5.5)') 'GD1',A-1
               Call GetMem(Label,'Free','Real',ip,l)
            End If
         End Do
         Call GetMem('GD1C','Free','Inte',ip_GDiag_1C,l_GDiag_1C)
         ip_GDiag_1C=0
         l_GDiag_1C=0
      End If
      If (l_GDiag_1C_Mx.gt.0) Then
         Call GetMem('GD1CMx','Free','Real',ip_GDiag_1C_Mx,
     &                                       l_GDiag_1C_Mx)
         ip_GDiag_1C_Mx=0
         l_GDiag_1C_Mx=0
      End If
      If (l_GDiag_1C_Sm.gt.0) Then
         Call GetMem('GD1CSm','Free','Real',ip_GDiag_1C_Sm,
     &                                       l_GDiag_1C_Sm)
         ip_GDiag_1C_Sm=0
         l_GDiag_1C_Sm=0
      End If

      If (l_GDiag_2C.gt.0) Then
         Do AB=1,LDF_nAtomPair()
            l=iWork(ip_GDiag_2C+2*(AB-1))
            If (l.gt.0) Then
               ip=iWork(ip_GDiag_2C+2*(AB-1)+1)
               Write(Label,'(A,I5.5)') 'GD2',AB-1
               Call GetMem(Label,'Free','Real',ip,l)
            End If
         End Do
         Call GetMem('GD2C','Free','Inte',ip_GDiag_2C,l_GDiag_2C)
         ip_GDiag_2C=0
         l_GDiag_2C=0
      End If
      If (l_GDiag_2C_Mx.gt.0) Then
         Call GetMem('GD2CMx','Free','Real',ip_GDiag_2C_Mx,
     &                                       l_GDiag_2C_Mx)
         ip_GDiag_2C_Mx=0
         l_GDiag_2C_Mx=0
      End If
      If (l_GDiag_2C_Sm.gt.0) Then
         Call GetMem('GD2CSm','Free','Real',ip_GDiag_2C_Sm,
     &                                       l_GDiag_2C_Sm)
         ip_GDiag_2C_Sm=0
         l_GDiag_2C_Sm=0
      End If

      If (l_IDiag.gt.0) Then
         Do AB=1,LDF_nAtomPair()
            l=iWork(ip_IDiag+2*(AB-1))
            If (l.gt.0) Then
               ip=iWork(ip_IDiag+2*(AB-1)+1)
               Write(Label,'(A,I5.5)') 'IDI',AB-1
               Call GetMem(Label,'Free','Real',ip,l)
            End If
         End Do
         Call GetMem('IDiag','Free','Inte',ip_IDiag,l_IDiag)
         ip_IDiag=0
         l_IDiag=0
      End If
      If (l_IDiag_Mx.gt.0) Then
         Call GetMem('IDiag_Mx','Free','Real',ip_IDiag_Mx,l_IDiag_Mx)
         ip_IDiag_Mx=0
         l_IDiag_Mx=0
      End If
      If (l_IDiag_Sm.gt.0) Then
         Call GetMem('IDiag_Sm','Free','Real',ip_IDiag_Sm,l_IDiag_Sm)
         ip_IDiag_Sm=0
         l_IDiag_Sm=0
      End If

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c      this file contains following routines:
c
c      getmediate
c      wrtmediate
c      getmap
c      wrtmap
c      rea
c      wri
c      filemanager
c      mkfilemgrcom
c
c      -------------------------------------------------------------
c
       subroutine getmediate (wrk,wrksize,
     & lun,poss0,mapd,mapi,rc)
c
c     this routine read required mediate from opened unformatted file
c     with number lun, and place it statring with the poss0
c     it also reads mapd and mapi of the given mediade, and reconstruct
c     mapd to actual possitions
c
c     lun   - Logical unit number of file, where mediate is stored (Input)
c     poss0 - initial possition in WRK, where mediate will be stored (Input)
c     mapd  - direct map matrix corresponding to given mediate (Output)
c     mapi  - inverse map matrix corresponding to given mediate (Output)
c     rc    - return (error) code (Output)
c
c     N.B.
c     all mediates are storred as follows
c     1 - mapd, mapi
c     2 - one record with complete mediate
c
#include "wrk.fh"
       integer lun,poss0,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer lenght,rc1
c
       rc=0
c
c1    read mapd
c
      call getmap (lun,poss0,lenght,mapd,mapi,rc1)
c
c2    read mediate in one block
c
       if (lenght.eq.0) then
c     RC=1 : there is nothing to read, lenght of mediate is 0
       rc=1
       return
       end if
c
       call rea (lun,lenght,wrk(poss0))
c
       return
       end
c
c     ----------------------------
c
       subroutine wrtmediate (wrk,wrksize,
     & lun,mapd,mapi,rc)
c
c     this routine write required mediate to opened unformatted file
c     with number lun
c     it also store mapd and mapi of the given mediade
c
c     lun   - Logical unit number of file, where mediate will be stored (Input)
c     mapd  - direct map matrix corresponding to given mediate (Input)
c     mapi  - inverse map matrix corresponding to given mediate (Input)
c     rc    - return (error) code (Output)
c
c     N.B.
c     all mediates are storred as follows
c     1 - mapd, mapi
c     2 - one record with complete mediate
c
#include "wrk.fh"
       integer lun,rc,rc1
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer im,lenght,poss0
c
       rc=0
c
c1    write mapd
c
      call wrtmap (lun,mapd,mapi,rc1)
c
c2    calculate overall lenght
c
       lenght=0
c
       do 100 im=1,mapd(0,5)
       lenght=lenght+mapd(im,2)
 100    continue
c
c     write mediate in one block
c
       if (lenght.eq.0) then
c     RC=1 : there is nothing to write, lenght of mediate is 0
       rc=1
       return
       end if
c
       poss0=mapd(1,1)
       call wri (lun,lenght,wrk(poss0))
c
       return
       end
c
c     ----------------------------
c
       subroutine getmap (lun,poss0,lenght,mapd,mapi,rc)
c
c     this routine reads mapd and mapi of the given mediade
c     from lun and reconstruct mapd to actual possitions poss0
c
c     lun   - Logical unit number of file, where mediate is stored (Input)
c     poss0 - initial possition in WRK, where mediate will be stored (Input)
c     lenght- overall lenght of mediate (Output)
c     mapd  - direct map matrix corresponding to given mediate (Output)
c     mapi  - inverse map matrix corresponding to given mediate (Output)
c     rc    - return (error) code (Output)
c
c     N.B.
c     all mediates are storred as follows
c     1 - mapd, mapi
c     2 - one record with complete mediate
c
#include "filemgr.fh"
#include "ccsd1.fh"

#include "SysDef.fh"
c
       integer lun,poss0,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
c     help variables
c
       integer poss,im,lenght
c
       rc=0
c
c1    read mapd
c
       if (iokey.eq.1) then
c      Fortran IO
       read (lun) ((mapd(i,j),i=0,512),j=1,6),
     & (((mapi(l,m,n),l=1,8),m=1,8),n=1,8)
c workaround for a bug in some Intel versions
#ifdef __INTEL_COMPILER
       else if (iokey.lt.0) then
       write(6,*) "this should never happen"
#endif
c
       else
c      MOLCAS IO
       call idafile (lun,2,mapd,513*6,daddr(lun))
       call idafile (lun,2,mapi,8*8*8,daddr(lun))
       end if
c
c2    change possitions in mapd to proper one and calculate overall lenght
c
       poss=poss0
       lenght=0
c
       do 100 im=1,mapd(0,5)
c
       mapd(im,1)=poss
       poss=poss+mapd(im,2)
       lenght=lenght+mapd(im,2)
c
 100    continue
c
       return
       end
c
c     ----------------------------
c
       subroutine wrtmap (lun,mapd,mapi,rc)
c
c     this routine write required mapd and mapi to opened unformatted file
c     with number lun
c
c     lun   - Logical unit number of file, where mediate will be stored (Input)
c     mapd  - direct map matrix corresponding to given mediate (Input)
c     mapi  - inverse map matrix corresponding to given mediate (Input)
c     rc    - return (error) code (Output)
c
#include "filemgr.fh"
#include "ccsd1.fh"

#include "SysDef.fh"
c
       integer lun,rc
       integer mapd(0:512,1:6)
       integer mapi(1:8,1:8,1:8)
c
       rc=0
c
c1    write mapd
c
       if (iokey.eq.1) then
c      Fortran IO
       write (lun) mapd,mapi
c
       else
c      MOLCAS IO
       call idafile (lun,1,mapd,513*6,daddr(lun))
       call idafile (lun,1,mapi,8*8*8,daddr(lun))
       end if
c
       return
       end
c
c     ----------------------------
c
       subroutine rea (lun,lenght,vector)
c
c     this routine read lenght-R8 numbers from opened unformatted file
c     with number lun form the given possition as one record
c
c     lun    - Logical unit number of file, where mediate is stored (Input)
c     lenght - # of R8 numbers to be read  (Input)
c     vector - space, where numbers are stored after reading  (Output)

c
#include "filemgr.fh"
#include "ccsd1.fh"

#include "SysDef.fh"
c
       integer lun,lenght
       real*8 vector(1:lenght)
c
       if (iokey.eq.1) then
c      Fortran IO
       read (lun) (vector(i),i=1,lenght)
c
       else
c      MOLCAS IO
       call ddafile (lun,2,vector,lenght,daddr(lun))
       end if
c
       return
       end
c
c     ----------------------------
c
       subroutine wri (lun,lenght,vector)
c
c     this routine write lenght-R8 numbers to opened unformatted file
c     with number lun at the given possition as one record
c
c     lun    - Logical unit number of file, where mediate will be stored (Input)
c     lenght - # of R8 numbers to be written  (Input)
c     vector - space, where numbers are stored  (Input)

c
#include "filemgr.fh"
#include "ccsd1.fh"

#include "SysDef.fh"
c
       integer lun,lenght
       real*8 vector(1:lenght)
c
       if (iokey.eq.1) then
c      Fortran IO
       write (lun) vector
c
       else
c      MOLCAS IO
       call ddafile (lun,1,vector,lenght,daddr(lun))
       end if
c
       return
       end
c
c     ----------------------------
c
       subroutine filemanager (request,lun,rc)
c
c     request - specification of service (Input)
c     1 - open temporary file and give lun (minfiles-maxfiles)
c     2 - rewind file lun
c     3 - close file lun (and delete it if it is temporrary one)
c     4 - open file with given lun (used for fixed files 10-minfiles)
c     5 - close without deleting (for any file)
c     lun     - Logical unit number (Input, Output)
c     rc      - return (error) code (Output)
c
c     This routine is a manager of temporarry disk files, used durring
c     the calculations.
c     if request=1 it finds free lun number if it is possible
c     and open file as unformatted
c     if request=2 it rewinds lun file if it is opened
c     if request=3 if close given lun file if it is opened
c
#include "filemgr.fh"
#include "ccsd1.fh"
c
       integer lun,request,rc
c
c     help variables
c
       integer nhelp,mhelp,ierr
       logical is_error
c
       rc=0
c
c
       if (request.eq.1) then
c
cI    open new file
c
cI.1  look for lowest free lun
c
       do 100 nhelp=minfiles,maxfiles
        mhelp = nhelp
        if (filestatus(nhelp).eq.0) goto 101
 100    continue
c
cI.2  RC=1 : there is not enough Temporarry files allowed
       rc=1
       return
c
cI.3  open file
c
 101    lun=mhelp
c
       if (iokey.eq.1) then
c      Fortran IO
       call molcas_open_ext2(lun,filename(lun),'sequential',
     &  'unformatted',
     &      ierr,.false.,1,'unknown',is_error)
c       open (unit=lun,
c     &       file=filename(lun),
c     &       status='unknown',
c     &       form='unformatted',
c     &       iostat=ierr)
c
       else
c      MOLCAS IO
       call daname (lun,filename(lun))
       daddr(lun)=0
       end if
c
       filestatus(lun)=1
c
c
       else if (request.eq.2) then
c
cII   rewind given file
c
cII.1 test lun, if it is not too large
c
       if ((lun.lt.10).or.(lun.gt.maxfiles)) then
c     RC=2 : lun is out of range
       rc=2
       return
       end if
c
cII.2 test, if lun is opened
c
       if (filestatus(lun).ne.1) then
c     RC=3 : file with logical unit lun is not opened, it can't be rewined
       rc=3
       return
       end if
c
cII.3 rewind lun file
c
       if (iokey.eq.1) then
c      Fortran IO
       rewind (lun)
c
       else
c      MOLCAS IO
       nhelp=0
       call idafile (lun,5,[nhelp],1,daddr(lun))
       end if
c
c
       else if (request.eq.3) then
c
cIII  close given file + scratch if it is Temp
c
cIII.1test lun, if it is not too large
c
       if ((lun.lt.10).or.(lun.gt.maxfiles)) then
c     RC=4 : lun is out of range
       rc=4
       return
       end if
c
cIII.2test, if lun is opened
c
       if (filestatus(lun).ne.1) then
c     RC=5 : file with logical unit lun is not opened,it can't be closed
       rc=5
       return
       end if
c
cIII.3 close ; scratch file, if it was a temporarry one
c
       if (iokey.eq.1) then
c      Fortran IO
         if (lun.ge.minfiles) then
c        close and scratch
         close (lun)
         call molcas_open(lun,filename(lun))
c         open (unit=lun,file=filename(lun))
         write (lun,*) ' File scratched'
         close (lun)
c        call sqname (lun,filename'lun')
c        call sqeras (lun)
         else
c        close only
         close (lun)
         end if
c
       else
c      MOLCAS IO
         if (lun.ge.minfiles) then
c        close and scratch
         call daeras (lun)
         else
c        close only
         call daclos (lun)
         end if
c
       end if
c
       filestatus(lun)=0
c
c
       else if (request.eq.4) then
c
cIV   open file with given lun
c
c
cIV.1 test lun, if it is not too large
c
       if ((lun.lt.10).or.(lun.gt.maxfiles)) then
c     RC=6 : lun is out of range
       rc=6
       return
       end if
c
cIV.2  test if file is not already opened
       if (filestatus(lun).eq.1) then
c     RC=7 : file is already opened
       rc=7
       return
       end if
c
cIV.3 open file
c
       if (iokey.eq.1) then
c      Fortran IO
       call molcas_open_ext2(lun,filename(lun),
     &     'sequential','unformatted',
     &      ierr,.false.,1,'unknown',is_error)
c       open (unit=lun,
c     &       file=filename(lun),
c     &       status='unknown',
c     &       form='unformatted',
c     &       iostat=ierr)
c
       else
c      MOLCAS IO
       call daname (lun,filename(lun))
       daddr(lun)=0
       end if
c
       filestatus(lun)=1
c
       else if (request.eq.5) then
c
cV     close file with given lun (without deleting)
c
cV.1   test lun, if it is not too large
c
       if ((lun.lt.10).or.(lun.gt.maxfiles)) then
c     RC=8 : lun is out of range
       rc=8
       return
       end if
c
cV.2  test, if lun is opened
c
       if (filestatus(lun).ne.1) then
c     RC=9 : file with logical unit lun is not opened,it can't be closed
       rc=9
       return
       end if
c
cV.3  close
c
       if (iokey.eq.1) then
c      Fortran IO
       close (lun)
c
       else
c      MOLCAS IO
       call daclos (lun)
       end if
c
       filestatus(lun)=0
c
c
       else
c     RC=10 : incorect value of request
       rc=10
       return
       end if
c
       return
       end
c
c     ----------------------------
c
       subroutine mkfilemgrcom
c
c     this routine make names of temp files and define initial values
c     of filestatus
c
#include "filemgr.fh"
#include "ccsd1.fh"
c
c     help variable
c
       integer nhelp
c
c1    def filestatus
c
       do 100 nhelp=10,maxfiles
       filestatus(nhelp)=0
 100    continue
c
c2    def disk addresses
c
       do 200 nhelp=10,maxfiles
       daddr(nhelp)=0
 200    continue
c
c3    def filenames
c
       filename(10)='INTAB'
       filename(11)='INTA1'
       filename(12)='INTA2'
       filename(13)='INTA3'
       filename(14)='INTA4'
       filename(15)='INTSTA'
       filename(16)=filerst
       filename(17)='Temp17'
       filename(18)='Temp18'
       filename(19)='Temp19'
       filename(20)='Temp20'
       filename(21)='Temp21'
       filename(22)='Temp22'
       filename(23)='Temp23'
       filename(24)='Temp24'
       filename(25)='Temp25'
       filename(26)='Temp26'
       filename(27)='Temp27'
       filename(28)='Temp28'
       filename(29)='Temp29'
       filename(30)='Temp30'
       filename(31)='Temp31'
       filename(32)='Temp32'
       filename(33)='Temp33'
       filename(34)='Temp34'
       filename(35)='Temp35'
       filename(36)='Temp36'
       filename(37)='Temp37'
       filename(38)='Temp38'
       filename(39)='Temp39'
       filename(40)='Temp40'
       filename(41)='Temp41'
       filename(42)='Temp42'
       filename(43)='Temp43'
       filename(44)='Temp44'
       filename(45)='Temp45'
       filename(46)='Temp46'
       filename(47)='Temp47'
       filename(48)='Temp48'
       filename(49)='Temp49'
       filename(50)='Temp50'
c

       return
       end
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA_Cleanup(irc)

! Thomas Bondo Pedersen (CTCC,UiO), July 2013.
!
! Clean up after RPA run (deallocate etc.)

use RPA_globals, only: CMO, EMO, l_CMO, l_EMO, l_OccEn, l_VirEn, OccEn, RPAModel, VirEn
use stdalloc, only: mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: irc

irc = 0

! Set "Relax Method" on Runfile
call Put_cArray('Relax Method',RPAModel,8)

! Deallocate memory
call mma_deallocate(CMO)
l_CMO = 0
call mma_deallocate(EMO)
l_EMO = 0
call mma_deallocate(OccEn)
l_OccEn(:) = 0
call mma_deallocate(VirEn)
l_VirEn(:) = 0

end subroutine RPA_Cleanup

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine mat2vec(RotMat,RotVec,RotAng)

use Constants, only: Zero, One, Half, Pi
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: RotMat(3,3)
real(kind=wp), intent(out) :: RotVec(3), RotAng
real(kind=wp) :: C, cr, Pimth, sr, tn, tn2, trace, x(3)

trace = RotMat(1,1)+RotMat(2,2)+RotMat(3,3)
x(1) = Half*(RotMat(3,2)-RotMat(2,3))
x(2) = Half*(RotMat(1,3)-RotMat(3,1))
x(3) = Half*(RotMat(2,1)-RotMat(1,2))
sr = sqrt(x(1)**2+x(2)**2+x(3)**2)
cr = Half*(trace-One)
if (0.05_wp*cr > sr) then
  tn = sr/cr
  tn2 = tn**2
  ! cos(theta) is positive, C is theta/sin(theta)
  C = (45045.0_wp-tn2*(15015.0_wp-tn2*(9009.0_wp-tn2*(6435.0_wp-tn2*(5005.0_wp-tn2*(4095.0_wp-tn2*3465.0_wp))))))/(45045.0_wp*cr)
  RotAng = sr*C
  RotVec(:) = x(:)*C
else if ((-0.05_wp*abs(cr) > sr) .and. (sr > Zero)) then
  tn = -sr/cr
  tn2 = tn**2
  ! cos(theta) is negative, sin(theta) is positive (always),
  ! Pimth is (Pi-theta)
  Pimth = tn*(45045.0_wp-tn2*(15015.0_wp-tn2*(9009.0_wp-tn2*(6435.0_wp-tn2*(5005.0_wp-tn2*(4095.0_wp-tn2*3465.0_wp))))))/45045.0_wp
  RotAng = Pi-Pimth
  RotVec(:) = (x(:)/sr)*RotAng
else if (sr /= Zero) then
  RotAng = atan2(sr,cr)
  RotVec(:) = RotAng*(x(:)/sr)
else
  RotAng = Zero
  RotVec(:) = Zero
end if

return

end subroutine mat2vec

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ReadIn_ESPF(natom,Cord,Ext,MltOrd,iRMax,DeltaR,Forces,Show_espf,IsMM,StandAlone,iGrdTyp,DoTinker,DoGromacs,DynExtPot, &
                       Mltp,nAtMM,lMorok,DoDirect,GradCl,EnergyCl)

use espf_global, only: ConvF, MMIterMax, MxExtPotComp
use Index_Functions, only: nTri_Elem1
use external_centers, only: iXPolType, nData_XF, nOrd_XF, nXF, nXMolnr, XF
use Data_Structures, only: Alloc1DArray_Type, Alloc2DArray_Type
use spool, only: Spoolinp
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Three, Nine, Angstrom, auTokJmolnm
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: natom, IsMM(natom)
real(kind=wp), intent(in) :: Cord(3,natom)
real(kind=wp), intent(inout) :: Ext(MxExtPotComp,natom)
integer(kind=iwp), intent(out) :: MltOrd, iRMax, iGrdTyp, nAtMM
real(kind=wp), intent(out) :: DeltaR, EnergyCl
logical(kind=iwp), intent(out) :: Forces, Show_espf, DoTinker, DoGromacs, DynExtPot, lMorok, DoDirect
logical(kind=iwp), intent(in) :: StandAlone
type(Alloc1DArray_Type), intent(out) :: Mltp
type(Alloc2DArray_Type), intent(out) :: GradCl
integer(kind=iwp) :: iAt, ibla, iChg, iErr, iGrdTyp_old, ii, iMlt, iPL, IPotFl, iQMChg, iRMax_old, iShift, jAt, LuSpool, &
                     MltOrd_old, nChg, nMult, nOrd_ext
real(kind=wp) :: DeltaR_old, dpxChg, dpyChg, dpzChg, dx, dy, dz, qChg, rAC2, rAC3, rAC5, rAC7, rAtChg
#ifdef _GROMACS_
real(kind=wp) :: Dum(1)
#endif
logical(kind=iwp) :: Convert, DoDirect_old, DoFirst, DoGromacs_old, DoTinker_old, Exists, lMorok_old, NoExt
character(len=180) :: Key, Line, PotFile, UpKey
character(len=12) :: ExtPotFormat
character(len=10) :: ESPFKey
real(kind=wp), parameter :: fift = 15.0_wp
integer(kind=iwp), external :: iPL_espf, IsFreeUnit
character(len=180), external :: Get_Ln

!                                                                      *
!***********************************************************************
!                                                                      *
! If some keywords are not given, what are the defauts ?
! 3 cases:
!   1) ESPF.DATA does not exist:
!      MULT: MltOrd = 0 (monopole)
!      GRID: Type = PNT ; iRMax = 4 shells ; DeltaR = 1 angstrom
!      EXTE: MANDATORY
!   2) ESPF.DATA exists:
!      Get back all values from ESPF.DATA
!      a) If the keyword "Forces" is read, only the old values
!      are retained, so it is clever not to include any other
!      ESPF keyword
!      b) If the keyword "Forces" is not read, all the new values
!      are compared to the old ones.

! Initialize values

write(ExtPotFormat,'(a4,i2,a6)') '(I4,',MxExtPotComp,'F10.5)'
MltOrd = 1
MltOrd_old = MltOrd
nChg = -1
iGrdTyp = 1
iRMax = 4
!iGrdTyp = 2
!iRMax = 1
DeltaR = One/Angstrom
Convert = .false.
DoTinker = .false.
DoTinker_old = DoTinker
DoGromacs = .false.
DoGromacs_old = DoGromacs
Forces = .not. StandAlone
Show_espf = .false.
nMult = 0
DynExtPot = .false.
iQMChg = 1
nAtMM = 0
lMorok = .false.
lMorok_old = lMorok
NoExt = .false.
DoDirect = .false.
DoDirect_old = DoDirect
nOrd_ext = 0
MMIterMax = 0
ConvF = 2.0e-4_wp*auTokJmolnm

! Print level

iPL = iPL_espf()

! If the ESPF.DATA file exists, retrieve all data
! from it in "*_old" variables and arrays.

IPotFl = 15
PotFile = '***'
call F_Inquire('ESPF.DATA',Exists)
if (Exists) then
  IPotFl = IsFreeUnit(IPotFl)
  call Molcas_Open(IPotFl,'ESPF.DATA')
  do
    Line = Get_Ln(IPotFl)
    ESPFKey = Line(1:10)
    if (ESPFKey == 'MLTORD    ') then
      call Get_I1(2,MltOrd_old)
      ibla = 0
      do ii=0,MltOrd_old
        ibla = ibla+nTri_Elem1(ii)
      end do
      MltOrd_old = ibla
    else if (ESPFKey == 'IRMAX     ') then
      call Get_I1(2,iRMax_old)
    else if (ESPFKey == 'DELTAR    ') then
      call Get_F1(2,DeltaR_old)
    else if (ESPFKey == 'GRIDTYPE  ') then
      call Get_I1(2,iGrdTyp_old)
    else if (ESPFKey == 'MULTIPOLE ') then
      call Get_I1(2,nMult)
      call mma_allocate(Mltp%A,nMult,label='ESPFMltp')
      do iMlt=1,nMult,MltOrd_old
        Line = Get_Ln(IPotFl)
        call Get_I1(1,iAt)
        call Get_F(2,Mltp%A(iMlt:iMlt+MltOrd_old-1),MltOrd_old)
      end do
    else if (ESPFKey == 'TINKER    ') then
      DoTinker_old = .true.
    else if (ESPFKey == 'GROMACS   ') then
      DoGromacs_old = .true.
    else if (ESPFKey == 'DIRECT    ') then
      DoDirect_old = .true.
    else if (ESPFKey == 'LA_MOROK  ') then
      lMorok_old = .true.
    else if (ESPFKey == 'ENDOFESPF ') then
      exit
    end if
  end do
  close(IPotFl)
  iRMax = iRMax_old
  DeltaR = DeltaR_old
  MltOrd = MltOrd_old
  iGrdTyp = iGrdTyp_old
  DoTinker = DoTinker_old
  DoGromacs = DoGromacs_old
  lMorok = lMorok_old
end if

if (StandAlone) then

  ! Copy input from standard input to a local scratch file

  LuSpool = isFreeUnit(IPotFl)
  call SpoolInp(LuSpool)

  ! Locate "start of input"
  rewind(LuSpool)
  call RdNLst(LuSpool,'espf')

  do
    Key = Get_Ln(LuSpool)
    Line = Key
    call UpCase(Line)
    select case (Line(1:4))
      case ('MULT')
        !>>>>>>>>>>>>> MULT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        Key = Get_Ln(LuSpool)
        call Get_I1(1,MltOrd)
        if (MltOrd < 0) then
          write(u6,'(A)') ' Error in espf/readin: MltOrd < 0!'
          call Quit_OnUserError()
        end if
        if (DoGromacs .and. (MltOrd > 0)) then
          write(u6,'(A)') ' Error in espf/readin: Gromacs calculation requested with MltOrd > 0'
          write(u6,'(A)') ' Only MltOrd = 0 is currently allowed'
          call Quit_OnUserError()
        end if
        if (MltOrd > 1) then
          write(u6,'(A)') ' Error in espf/readin: MltOrd > 1 NYI!'
          call Quit_OnUserError()
        end if
        ibla = 0
        do ii=0,MltOrd
          ibla = ibla+nTri_Elem1(ii)
        end do
        MltOrd = ibla

      case ('EXTE')
        !>>>>>>>>>>>>> EXTE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        if (Forces) cycle
        Key = Get_Ln(LuSpool)
        UpKey = Key
        call Upcase(UpKey)
        call Get_iNumber(Key(1:(index(Key,' ')-1)),ibla,iErr)
        if (iErr == 0) then
          PotFile = '* *'
          nChg = ibla

          ! nChg < 0: error
          ! nChg > 0: external potential is given as point charges and dipoles,
          ! like for the seward xfield keyword
          ! nchg = 0: external potential directly given on atom centers as:
          ! pot field_x field_y field_z dfield_xx dfield_yy dfield_zz
          ! dfield_xy dfield_xz dfield_yz (ONE LINE per CENTER)

          if (nChg < 0) then
            write(u6,*) 'Error in readin_espf: nChg < 0!'
            call Quit_OnUserError()
          else if (nChg > 0) then
            Convert = (index(UpKey,'ANGSTROM') /= 0)
            nXF = nChg
            nData_XF = 7
            call mma_allocate(XF,nData_XF,nXF,Label='XF')
            do iChg=1,nChg
              Key = Get_Ln(LuSpool)
              call Get_F(1,XF(1,iChg),7)
              if (Convert) then
                XF(1:3,iChg) = XF(1:3,iChg)/Angstrom
                XF(5:7,iChg) = XF(5:7,iChg)/Angstrom
              end if
            end do
            Convert = .false.
          else
            do iAt=1,natom
              Key = Get_Ln(LuSpool)
              call Get_I1(1,jAt)
              if ((jAt < 1) .or. (jAt > natom)) then
                write(u6,'(A)') ' Error in espf/readin: atom out of range.'
                call Quit_OnUserError()
              end if
              call Get_F(2,Ext(:,jAt),MxExtPotComp)
            end do
          end if
        else
          iAt = index(UpKey,'NONE ')
          NoExt = (iAt /= 0)

          ! Is it a QM/MM computation ?

          iAt = index(UpKey,'TINKER ')
          DoTinker = (iAt /= 0)

          iAt = index(UpKey,'GROMACS ')
          if (iAt /= 0) then
#           ifdef _GROMACS_
            DoGromacs = .true.
#           else
            write(u6,*) 'Interface to Gromacs not installed'
            call Quit_OnUserError()
#           endif
          end if

          DoDirect = (index(UpKey(iAt+7:120),'DIRECT') /= 0)
          ! tmp
          if (DoDirect) then
            write(u6,*) 'Direct not yet implemented, abort.'
            call Quit_OnUserError()
          end if
          ! tmp

          ! What kind of charges Tinker or Gromacs will use in the microiterations

          if (NoExt) then
            PotFile = '* *'
          else if (DoTinker .or. DoGromacs) then
            PotFile = 'ESPF.EXTPOT'
            if (index(UpKey(iAt+7:120),'MULL') /= 0) then
              iQMChg = 2
            else if (index(UpKey(iAt+7:120),'LOPR') /= 0) then
              iQMChg = 3
            end if
            if (DoDirect .and. (iQMChg == 1)) iQMChg = 2
          else
            PotFile = Key(1:len(Key))
          end if
        end if

      case ('GRID')
        !>>>>>>>>>>>>> GRID <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        Key = Get_Ln(LuSpool)
        call Upcase(Key)
        if (index(Key,'GEPOL') /= 0) then
          iGrdTyp = 2
          call Get_I1(2,iRMax)
          if ((iRMax <= 0) .or. (iRMax > 4)) then
            write(u6,'(A)') 'Error in readin_espf: 1 <= iRMax <= 4 !!!'
            call Quit_OnUserError()
          end if
        else if (index(Key,'PNT') /= 0) then
          iGrdTyp = 1
          call Get_I1(2,iRMax)
          if (iRMax <= 0) then
            write(u6,'(A)') 'Error in espf/readin: iRMax < 1 !!!'
            call Quit_OnUserError()
          end if
          call Get_F1(3,DeltaR)
          if (DeltaR <= Zero) then
            write(u6,'(A)') 'Error in espf/readin: DeltaR < 0.0 !!!'
            call Quit_OnUserError()
          end if
          if (index(Key,'ANGSTROM') /= 0) Convert = .true.
          if (Convert) DeltaR = DeltaR/Angstrom
          Convert = .false.
        else
          write(u6,'(A)') 'Unrecognized GRID: GEPOL or PNT(default)'
          call Quit_OnUserError()
        end if

      case ('FORC')
        !>>>>>>>>>>>>> FORC <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        if (.not. Exists) then
          write(u6,*) 'Error! Forces: the ESPF data are missing'
          call Quit_OnUserError()
        end if
        if (DoTinker) then
          write(u6,*) 'Please erase the @Tinker call together with Forces'
          call Quit_OnUserError()
        end if
        Forces = .true.
        write(u6,'(/,A,/,A)') ' This ESPF run will compute energy gradient',' Any other keyword is ignored !'

        ! Here I assume all I need can be retrieved from the $Project.espf file

      case ('SHOW')
        !>>>>>>>>>>>>> SHOW <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        Show_espf = .true.

      case ('LAMO')
        !>>>>>>>>>>>>> LAMO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        lMorok = .true.
        if (iPL >= 2) write(u6,'(A)') ' Morokuma scheme on'

      case ('MMIT')
        !>>>>>>>>>>>>> MMIT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        if (.not. DoGromacs) then
          write(u6,'(A)') ' MM microiterations only available with Gromacs'
          call Quit_OnUserError()
        end if
        Line = Get_Ln(LuSpool)
        call Get_I1(1,MMIterMax)

      case ('MMCO')
        !>>>>>>>>>>>>> MMCO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        Line = Get_Ln(LuSpool)
        call Get_F1(1,ConvF)
        ConvF = ConvF*auTokJmolnm

      case ('END ')
        !>>>>>>>>>>>>> END  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        exit

      case default
        if (.not. Exists) then
          write(u6,*) ' Unidentified keyword:',Key
          call FindErrorLine()
          call Quit_OnUserError()
        end if

    end select
  end do
end if

! Remove local copy of standard input

if (StandAlone) close(LuSpool)

! "Forces" case: retrieve all the data and update the MM gradient

if (Forces) then
  MltOrd = MltOrd_old
  iRMax = iRMax_old
  DeltaR = DeltaR_old
  iGrdTyp = iGrdTyp_old
  DoTinker = DoTinker_old
  DoGromacs = DoGromacs_old
  iQMChg = 0
  DoFirst = .not. allocated(Mltp%A)
  if (DoFirst) call mma_allocate(Mltp%A,0,label='ESPFMltp')
  if (DoTinker) call RunTinker(natom,Cord,Mltp%A,DoFirst,IsMM,MltOrd,DynExtPot,iQMchg,nAtMM,StandAlone,DoDirect)
# ifdef _GROMACS_
  if (DoGromacs) then
    call mma_allocate(GradCl%A,3,natom,label='GradCl')
    call RunGromacs(natom,Cord,Mltp%A,DoFirst,MltOrd,Forces,GradCl%A,EnergyCl)
  end if
# else
  ! This is dummy, since it should never happen
  if (DoGromacs) then
    call mma_allocate(GradCl%A,0,0,label='GradCl')
    call mma_deallocate(GradCl%A)
    EnergyCl = Zero
  end if
# endif
  if (DoFirst) call mma_deallocate(Mltp%A)
  if (nAtMM /= 0) write(u6,*) 'MM gradients have been updated'
  lMorok = lMorok_old
  IPotFl = IsFreeUnit(IPotFl)
  call Molcas_Open(IPotFl,'ESPF.EXTPOT')
  Line = Get_Ln(IPotFl)
  call Get_I1(1,nChg)
  do iAt=1,natom
    Line = Get_Ln(IPotFl)
    call Get_I1(1,jAt)
    call Get_F(2,Ext(:,jAt),MxExtPotComp)
  end do
  close(IPotFl)

else if (NoExt) then

  ! No external potential

  nChg = -1
  write(u6,'(/,A)') ' No external electrostatic potential'

else if (nChg == -1) then

  ! External potential read from a file

  DoFirst = .not. allocated(Mltp%A)
  if (DoFirst) call mma_allocate(Mltp%A,0,label='ESPFMltp')
  if (DoTinker) call RunTinker(natom,Cord,Mltp%A,DoFirst,IsMM,MltOrd,DynExtPot,iQMChg,nAtMM,StandAlone,DoDirect)
# ifdef _GROMACS_
  if (DoGromacs) call RunGromacs(natom,Cord,Mltp%A,DoFirst,MltOrd,Forces,Dum,EnergyCl)
# endif
  if (DoFirst) call mma_deallocate(Mltp%A)
  LuSpool = IsFreeUnit(1)
  call Molcas_Open(LuSpool,PotFile(1:(index(PotFile,' ')-1)))
  if (iPL >= 3) write(u6,'(/,A,A)') ' External potential read in ',PotFile(1:(index(PotFile,' ')-1))
  Key = Get_Ln(LuSpool)
  UpKey = Key
  call Upcase(UpKey)
  call Get_I1(1,nChg)
  if (nChg < 0) then
    write(u6,*) 'Error in readin_espf: nChg < 0!'
    call Quit_OnUserError()
  else if (nChg > 0) then
    call Get_I1(2,nOrd_ext)
    Convert = (index(UpKey,'ANGSTROM') /= 0)
    nData_XF = 4+3*nOrd_ext
    nXF = nChg
    call mma_allocate(XF,nData_XF,nXF,Label='XF')
    do iChg=1,nChg
      Key = Get_Ln(LuSpool)
      call Get_F(1,XF(1,iChg),iShift)
      if (Convert) then
        XF(1:3,iChg) = XF(1:3,iChg)/Angstrom
        if (nOrd_ext /= 0) XF(5:7,iChg) = XF(5:7,iChg)*Angstrom
      end if
    end do
    Convert = .false.
  else
    do iAt=1,natom
      Key = Get_Ln(LuSpool)
      call Get_I1(1,jAt)
      if ((jAt < 1) .or. (jAt > natom)) then
        write(u6,'(A)') ' Error in espf/readin: atom out of range.'
        call Quit_OnUserError()
      end if
      call Get_F(2,Ext(:,jAt),MxExtPotComp)
    end do
  end if
  close(LuSpool)
end if

! If nChg > 0, 2 possibilities:
! a) read external point charges (only, no dipoles) for a direct
!    QM/MM electrostatic coupling
! b) external potential calculated from point charges and dipoles

if ((nChg > 0) .and. DoDirect) then
  nXF = nChg
  nOrd_XF = nOrd_ext
  iXPolType = 0
  nXMolnr = 0
  call mma_deallocate(XF)
else if (nChg > 0) then
  do iAt=1,natom
    do iChg=1,nChg
      dx = Cord(1,iAt)-XF(1,iChg)
      dy = Cord(2,iAt)-XF(2,iChg)
      dz = Cord(3,iAt)-XF(3,iChg)
      qChg = XF(4,iChg)
      dpxChg = XF(5,iChg)
      dpyChg = XF(6,iChg)
      dpzChg = XF(7,iChg)
      rAtChg = sqrt(dx*dx+dy*dy+dz*dz)

      rAC2 = rAtChg*rAtChg
      rAC3 = rAtChg*rAC2
      rAC5 = rAC2*rAC3
      rAC7 = rAC2*rAC5
      ! Potential E
      Ext(1,iAt) = Ext(1,iAt)+qChg/rAtChg-(dpxChg*dx+dpyChg*dy+dpzChg*dz)/rAC3
      ! Field F / x
      Ext(2,iAt) = Ext(2,iAt)-qChg*dx/rAC3+(dpxChg*(three*dx*dx-rAC2)+dpyChg*(three*dx*dy)+dpzChg*(three*dx*dz))/rAC5
      ! Field F / y
      Ext(3,iAt) = Ext(3,iAt)-qChg*dy/rAC3+(dpxChg*(three*dy*dx)+dpyChg*(three*dy*dy-rAC2)+dpzChg*(three*dy*dz))/rAC5
      ! Field F / z
      Ext(4,iAt) = Ext(4,iAt)-qChg*dz/rAC3+(dpxChg*(three*dz*dx)+dpyChg*(three*dz*dy)+dpzChg*(three*dz*dz-rAC2))/rAC5
      ! Gradient G / xx
      Ext(5,iAt) = Ext(5,iAt)+qChg*(three*dx*dx-rAC2)/rAC5-(dpxChg*(fift*dx*dx*dx-nine*dx*rAC2)+ &
                                                            dpyChg*(fift*dx*dx*dy-three*dy*rAC2)+ &
                                                            dpzChg*(fift*dx*dx*dz-three*dz*rAC2))/rAC7
      ! Gradient G / yy
      Ext(6,iAt) = Ext(6,iAt)+qChg*(three*dy*dy-rAC2)/rAC5-(dpxChg*(fift*dy*dy*dx-three*dx*rAC2)+ &
                                                            dpyChg*(fift*dy*dy*dy-nine*dy*rAC2)+ &
                                                            dpzChg*(fift*dy*dy*dz-three*dz*rAC2))/rAC7
      ! Gradient G / zz
      Ext(7,iAt) = Ext(7,iAt)+qChg*(three*dz*dz-rAC2)/rAC5-(dpxChg*(fift*dz*dz*dx-three*dx*rAC2)+ &
                                                            dpyChg*(fift*dz*dz*dy-three*dy*rAC2)+ &
                                                            dpzChg*(fift*dz*dz*dz-nine*dz*rAC2))/rAC7
      ! Gradient G / xy
      Ext(8,iAt) = Ext(8,iAt)+qChg*(three*dx*dy)/rAC5-(dpxChg*(fift*dx*dy*dx-three*dx*rAC2)+ &
                                                       dpyChg*(fift*dx*dy*dy-three*dy*rAC2)+ &
                                                       dpzChg*(fift*dx*dy*dz))/rAC7
      ! Gradient G / xz
      Ext(9,iAt) = Ext(9,iAt)+qChg*(three*dx*dz)/rAC5-(dpxChg*(fift*dx*dz*dx-three*dx*rAC2)+ &
                                                       dpyChg*(fift*dx*dz*dy)+ &
                                                       dpzChg*(fift*dx*dz*dz-three*dz*rAC2))/rAC7
      ! Gradient G / yz
      Ext(10,iAt) = Ext(10,iAt)+qChg*(three*dy*dz)/rAC5-(dpxChg*(fift*dy*dz*dx)+ &
                                                         dpyChg*(fift*dy*dz*dy-three*dy*rAC2)+ &
                                                         dpzChg*(fift*dy*dz*dz-three*dz*rAC2))/rAC7
    end do
  end do
  call mma_deallocate(XF)
end if

! Check the compatibility between old and new keywords

if (Exists) then
  if ((.not. Forces) .and. ((MltOrd /= MltOrd_old) .or. (iRMax /= iRMax_old) .or. (iGrdTyp /= iGrdTyp_old) .or. &
                            (lMorok .neqv. lMorok_old) .or. (DoDirect .neqv. DoDirect_old) .or. &
                            (abs(DeltaR-DeltaR_old) > 1.0e-6_wp))) then
    write(u6,*) 'Conficts between some old and new ESPF keywords'
    write(u6,*) '      ','MltOrd     iRMax    DeltaR    iGrdTyp   lMorok   DoDirect'
    write(u6,*) ' OLD: ',MltOrd_old,iRMax_old,DeltaR_old,iGrdTyp_old,lMorok_old,DoDirect_Old
    write(u6,*) ' NEW: ',MltOrd,iRMax,DeltaR,iGrdTyp,lMorok,DoDirect
    write(u6,'(A)') ' Check these values or erase ESPF.DATA'
  end if
else
  if (PotFile(1:(index(PotFile,' ')-1)) == '***') then
    write(u6,*) 'Error! The EXTE data are missing'
    call Quit_OnUserError()
  end if
end if

! Some output

if (iPL >= 2) then
  if (DoDirect) then
    write(u6,'(A)') ' DIRECT keyword found',' The ESPF scheme is switched off'
    write(u6,'(A,I5,A)') ' External potential due to',nChg,' point charges'
  else
    if (nChg == 0) then
      write(u6,'(A)') ' External potential:'
    else if (nChg > 0) then
      write(u6,'(A,I5,A)') ' External potential due to',nChg,' point charges:'
    end if
    if (nChg >= 0) &
      write(u6,'(A)') ' Atom     E         Fx        Fy        Fz        Gxx       Gyy       Gzz       Gxy       Gxz       Gyz'
  end if
end if

! Write the external potential in ESPF.EXTPOT for later use

IPotFl = IsFreeUnit(IPotFl)
call Molcas_Open(IPotFl,'ESPF.EXTPOT')
write(IPotFl,'(I1)') 0
do iAt=1,natom
  if ((.not. DoDirect) .and. (nChg >= 0) .and. (iPL >= 2)) write(u6,ExtPotFormat) iAt,Ext(:,iAt)
  write(IPotFl,ExtPotFormat) iAt,Ext(:,iAt)
end do
close(IPotFl)
write(u6,*)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

return

end subroutine ReadIn_ESPF

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      Subroutine FragPMem(nHer,MemFrag,la,lb,lr)
************************************************************************
*  Object: to compute the number of real*8 the kernel routine will     *
*          need for the computation of a matrix element between two    *
*          cartesian Gaussin functions with the total angular momentum *
*          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
*          lr is the order of the operator (this is only used when the *
*          integrals are computed with the Hermite-Gauss quadrature).  *
*                                                                      *
*  Called from: OneEl                                                  *
*                                                                      *
*                R. Lindh, Dept. of Theor. Chem. Univ. of Lund, Sweden *
************************************************************************
      Use Basis_Info
      Implicit None
      Integer nHer, MemFrag, la, lb, lr, nExpi, nExpj,
     &        i, nElem, maxDensSize, iCnttp, jCnttp, iAng, jAng,
     &        iShll, jShll, ip, nac, ncb, MemMlt, nH,
     &        nBasisi, nBasisj
* statement function
      nElem(i) = (i+1)*(i+2)/2
*
      MemFrag = 0
      maxDensSize = 0
c        largest possible fragment energy weighted density matrix
      Do iCnttp = 1, nCnttp
        If(dbsc(iCnttp)%nFragType.gt.0) maxDensSize = Max(maxDensSize,
     &                        dbsc(iCnttp)%nFragDens
     &                      *(dbsc(iCnttp)%nFragDens+1)/2)
      End Do
c
      Do iCnttp = 1, nCnttp
      If (.Not.dbsc(iCnttp)%Frag) cycle
c
         Do iAng = 0, dbsc(iCnttp)%nVal-1
         iShll = dbsc(iCnttp)%iVal + iAng
         nExpi=Shells(iShll)%nExp
         nBasisi=Shells(iShll)%nBasis
         If (nExpi.eq.0 .or. nBasisi.eq.0) cycle
*
            Do jCnttp = iCnttp, nCnttp
* still figure out how to loop only over the centers belonging to the
* same fragment (keep track of mdc?) ! still to be done !!!
            If (.Not.dbsc(jCnttp)%Frag) cycle
c
               Do jAng = 0, dbsc(jCnttp)%nVal-1
               jShll = dbsc(jCnttp)%iVal + jAng
               nExpj=Shells(jShll)%nExp
               nBasisj=Shells(jShll)%nBasis
               If (nExpj.eq.0 .or. nBasisj.eq.0) cycle
!              Go To 1976
*
               ip = 2 * maxDensSize
              nac = nElem(la)*nElem(iAng)
               ip = ip + nExpi*nac
               ip = ip + 3 * nExpi
               ip = ip + nExpi
               ip = ip + nExpi
               ip = ip + nExpi
*
              Call MltMmP(nH,MemMlt,la,iAng,lr)
             nHer = Max(nH,nHer)
          MemFrag = Max(MemFrag,ip+nExpi*MemMlt)
               ip = ip - 6 * nExpi
*
              ncb = nElem(jAng)*nElem(lb)
               ip = ip + nExpj*ncb
               ip = ip + 3 * nExpj
               ip = ip + nExpj
               ip = ip + nExpj
               ip = ip + nExpj
*
              Call MltMmP(nH,MemMlt,jAng,lb,lr)
             nHer = Max(nH,nHer)
          MemFrag = Max(MemFrag,ip+nExpj*MemMlt)
               ip = ip - 6 * nExpj
*
               ip = ip + Max( nac * Max(nExpi,nBasisj),
     &                        ncb * nBasisj )
          MemFrag = Max(MemFrag,ip)
*
c 1976          Continue
               Enddo
c
c 1970       Continue
            Enddo
c
c 1966    Continue
         Enddo
c
c 1960 Continue
      Enddo
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine DeDe_Funi(Dens,nDens,nr_of_Densities)

use k2_arrays, only: DeDe, ipD00, ipDeDe, ipDijs, ipOffD, MaxDE, nDeDe_DFT
use Sizes_of_Seward, only: S
use Symmetry_Info, only: nIrrep
use stdalloc, only: mma_allocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDens, nr_of_Densities
real(kind=wp), intent(in) :: Dens(nDens,nr_of_Densities)
integer(kind=iwp) :: mDeDe, mIndij, nField, nIndij
logical(kind=iwp) :: DFT_Storage, Special_NoSym

nIndij = S%nShlls*(S%nShlls+1)/2
nField = 2+nr_of_Densities

call mma_allocate(ipOffD,nField,nIndij,label='ipOffD')
call mma_allocate(DeDe,nDeDe_DFT+MaxDe*nIrrep,Label='DeDe')
ipDeDe = 1
ipD00 = ipDeDe+nDeDe_DFT
ipDijs = -1  ! Dummy value
DeDe(:) = Zero

Special_NoSym = .false.
DFT_Storage = .true.
call mk_DeDe(Dens,nDens,nr_of_Densities,ipOffD,nIndij,ipDeDe,ipD00,MaxDe,mDeDe,mIndij,Special_NoSym,DFT_Storage,DeDe,nDeDe_DFT)
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine DeDe_Funi

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine Chck_T2p (T21,aSGrp,bSGrp)
c
c        test T2+
c
        implicit none
#include "chcc1.fh"
        real*8 T21(1:16*31,1:no*(no+1)/2)
        integer aSGrp,bSGrp
        integer u,v,a,b,ab,uv,bad,ap,bp
        real*8 s
c
c
        if (aSGrp.eq.2) then
          ap=nv/2
        else
          ap=0
        end if
c
        if (bSGrp.eq.2) then
          bp=nv/2
        else
          bp=0
        end if
c
        bad=0
c
        uv=0
        do u=1,no
        do v=1,u
        uv=uv+1
c
          ab=0
          do a=2,nv/2
          do b=1,a-1
          ab=ab+1
c
            s=(T2c(bp+b,ap+a,v,u)+T2c(bp+b,ap+a,u,v))/2
c
          if (abs(T21(ab,uv)-s).gt.1.0d-10) then
            bad=bad+1
          end if
          T21(ab,uv)=s
c
          end do
          end do
c
        end do
        end do
c
c
        if (bad.eq.0) then
        write (6,*) ' Chck T2+ OK ', bad
        else
        write (6,*) ' Chck T2+ Bug !!!!!!! ', bad
        end if
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine xRlsMem_Ints
      implicit real*8 (a-h,o-z)
#include "status.fh"
c
      If (XMem_Status.eq.InActive) Then
C        Write (6,*)
C        Write (6,*) 'xRlsMem_Ints:',
C    &               'No external scratch handling to deactivate!'
C        Write (6,*)
      Else
C        Write (6,*)
C        Write (6,*) 'xRlsMem_Ints:','External allocation deactivate!'
C        Write (6,*)
         XMem_Status=InActive
         Call RlsMem_Ints()
C        Write (6,*) 'xRlsMem_Ints:','External allocation released!'
      End If
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine wrheader_cvb(recn,norb1,nbas_mo1,nvb1,kbasiscvb1,ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)

use Definitions, only: wp, iwp, u6, RtoI

implicit none
real(kind=wp), intent(in) :: recn
integer(kind=iwp), intent(in) :: norb1, nbas_mo1, nvb1, kbasiscvb1
integer(kind=iwp), intent(out) :: ioffs_orbs, ioffs_cvb, ioffs_orbsao, ioffs_orbslao
integer(kind=iwp) :: iheader(10)
logical(kind=iwp), parameter :: debug = .false.

ioffs_orbs = (10+RtoI-1)/RtoI
ioffs_cvb = ioffs_orbs+norb1*norb1
ioffs_orbsao = ioffs_cvb+nvb1
ioffs_orbslao = ioffs_orbsao+norb1*nbas_mo1
!call reserv_cvb(ioffs_orbslao+norb1*nbas_mo1,recn)
iheader(:) = 0
iheader(1) = norb1
iheader(2) = nbas_mo1
iheader(3) = nvb1
iheader(4) = kbasiscvb1
iheader(6) = ioffs_orbs
iheader(7) = ioffs_cvb
iheader(8) = ioffs_orbsao
iheader(9) = ioffs_orbslao
call wri_cvb(iheader,10,recn,0)
if (debug) then
  write(u6,*) ' wrheader :'
  write(u6,*) ' ----------'
  write(u6,*) ' norb1         :',norb1
  write(u6,*) ' nbas_mo1      :',nbas_mo1
  write(u6,*) ' nvb1          :',nvb1
  write(u6,*) ' kbasiscvb1    :',kbasiscvb1
  write(u6,*) ' ioffs_orbs    :',ioffs_orbs
  write(u6,*) ' ioffs_cvb     :',ioffs_cvb
  write(u6,*) ' ioffs_orbsao  :',ioffs_orbsao
  write(u6,*) ' ioffs_orbslao :',ioffs_orbslao
end if

return

end subroutine wrheader_cvb

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************

subroutine set_l_kriging(lv,nInter_In)

use kriging_mod, only: l, nInter
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nInter_In
real(kind=wp) :: lv(nInter_In)

! Set the characteristic length of all the components of the coordintes.

if (nInter_In == nInter) then
  l(:) = lv(:)
else if (nInter == 1) then
  l(:) = lv(1)
else
  write(u6,*) 'setlkriging: illegal nInter value.'
  call Abend()
end if

! Generate the covariance matrix

call covarMatrix()

! Form the inverse of the covariance matrix times the generalized value vector.

call kriging_model()

end subroutine set_l_kriging

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2003, Per-Olof Widmark                                 *
*               2017, Roland Lindh                                     *
************************************************************************
      SubRoutine Optim2(E_Pred,G,H,D,C,n,nDim,n0,n1,r2)
************************************************************************
*                                                                      *
*    purpose: Solve a set of non-linear equations to get interpolation *
*             coefficients for damping                                 *
*                                                                      *
*     input:                                                           *
*       G       : linear energy terms                                  *
*       H       : bilinear energy terms                                *
*       D       : bilinear density terms                               *
*       n       : size of matrices                                     *
*       nDim    : leading dimension for H                              *
*       n0      : index number of the lowest energy                    *
*       n1      : index number of the second lowest energy             *
*       r2      : square of density change constraint                  *
*                                                                      *
*     output:                                                          *
*       C       : interpolation coefficients                           *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* The KISS method is employed here. Do a scan of the energy surface    *
* along lines parallel to the edges. Reduce the steplength gradually.  *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark                                                     *
*     University of Lund, Sweden, 2003                                 *
*                                                                      *
*     hacked for optimization on a sphere by:                          *
*     Roland Lindh                                                     *
*     Uppsala University, Uppsala, Sweden, 2017.                       *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit None
*----------------------------------------------------------------------*
* Dummy arguments.                                                     *
*----------------------------------------------------------------------*
      Integer n,nDim,n0,n1
      Real*8  G(nDim),H(nDim,nDim),C(nDim),D(nDim,nDim)
*----------------------------------------------------------------------*
* Local variables.                                                     *
*----------------------------------------------------------------------*
      Real*8  Step,Eref,E_Pred
      Real*8  Step_pi,Step_mi,Step_pj,Step_mj,Step_pk,Step_mk
      Real*8  Optim_E
*define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Real*8  sum
#endif
      Logical DidChange
      Integer Iter
      Integer i,j,k,l,nLow
      Real*8  A, B, r2
      Real*8  AI, AJ1, AK1, AJK, AJ2, AK2
      Real*8  BI, BJ1, BJ2
      Real*8  Steps(3,4), Es(4)
*----------------------------------------------------------------------*
* Initialize                                                           *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
* Make first guess.                                                    *
*----------------------------------------------------------------------*
*
*     The initial guessed values of the Cs are set by finding the
*     coeffcients for the densities with the two lowest energies,
*     n0 and n1. All other coefficients are assumed to be zero.
*     The coefficient are found by solving the two simultaneous
*     equations,
*
*     Sum_i C(i) = 0
*
*     Sum_i C(i) C(j) D(i,j) = r2
*
      Do i=1,n
         C(i)=0.0d0
      End Do
      A=2.0D0*(D(n0,n1)-D(n1,n1))/(D(n0,n0)-2.0D0*D(n0,n1)+D(n1,n1))
      B=(D(n1,n1)-r2)/(D(n0,n0)-2.0D0*D(n0,n1)+D(n1,n1))
      C(n0) = -(A/2.0D0) + Sqrt((A/2.0D0)**2-B)
      If (C(n0).gt.1.0D0) C(n0) = -(A/2.0D0) - Sqrt((A/2.0D0)**2-B)
      If (C(n0).lt.0.0D0) Then
         Write (6,*) 'C(n0).lt.0.0D0'
         Call Abend()
      End If
      C(n1)=1.0D0-C(n0)
      If (C(n1).gt.1.0D0) Then
         Write (6,*) 'C(n1).gt.1.0D0'
         Call Abend()
      End If
      If (C(n1).lt.0.0D0) Then
         Write (6,*) 'C(n1).lt.0.0D0'
         Call Abend()
      End If
*
*     At this point we have a set of Cs which fulfil the two contraints.
#ifdef _DEBUGPRINT_
      Write(6,'(a)') 'Start C:'
      Write(6,'(6F15.6)') (C(i),i=1,n)
      Write(6,'(a)') 'Start G:'
      Write(6,'(6F15.6)') (G(i),i=1,n)
      Call RecPrt('H',' ',H,nDim,nDim)
      Call RecPrt('D',' ',D,nDim,nDim)
#endif
*----------------------------------------------------------------------*
* Compute start energy.                                                *
*----------------------------------------------------------------------*
      Eref=0.0d0
      Do i=1,n
         Eref=Eref+C(i)*G(i)
         Do j=1,n
            Eref=Eref+0.5d0*C(i)*C(j)*H(i,j)
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Write(6,'(a,F15.6)') 'Eref = ',Eref
#endif
*----------------------------------------------------------------------*
* Do a scan in all tripletwise directions.                             *
*----------------------------------------------------------------------*
      Iter=0
      DidChange=.true.
      Step=0.10d0
      Call Abend()
*
*     Below we explore changes to all triplets that are consistent with
*     that the constrains are not broken.
*
100   If(Iter.lt.500 .and. DidChange) Then
*
         Iter=Iter+1
         DidChange=.false.
*
         Do i=1,n-2
*
            Do j=i+1,n-1
*
               Do k=j+1, n
*
*                 Make sure that step trivially is within the range.
*                 The first constraint. Now we vary d(j) and d(k)
*                 such that the constraints are not broken.
*
                  Step_pi= Min(Step,1.0D0-C(i))
                  Steps(1,1) = Step_pi
                  Steps(1,2) = Step_pi
*
*                 Given the change d(i) compute d(k) and d(l),
*                 subjects to the simultaneous equations.
*
*                 Sum_i d(i) = 0
*
*                 Sum_ij (2(C(i)+d(i))*d(j)*D(i,j) = 0
*
                  AI=2.0D0*(C(i)+Step_pi)*Step_pi*D(i,i)
     &              +C(k)*Step_pi*D(k,i)
     &              +C(j)*Step_pi*D(j,i)
                  AJ1=(C(i)+2.0D0*Step_pi)*D(i,j)
     &               +C(j)*D(j,j) + C(k)*D(k,j)
                  AK1=(C(i)+2.0D0*Step_pi)*D(i,k)
     &               +C(k)*D(k,k) + C(j)*D(j,k)
                  AJK=2.0D0*D(j,k)
                  AJ2=D(j,j)
                  AK2=D(k,k)
*
                  BI = AI - AJ1*Step_pi+AJ2*Step_pi**2
                  BJ1= -AJ1 + AK1 - (AJK - 2.0D0*AJ2)*Step_pi
                  BJ2= -AJK + AJ2 + AK2
*
                  A = BJ1/(2.0D0*BJ2)
                  B = BI/BJ2
*
                  Step_pk = - A + Sqrt(A**2-B)
                  Step_mk = - A - Sqrt(A**2-B)
*
                  Step_pj=-(Step_pi+Step_pk)
                  Step_mj=-(Step_pi+Step_mk)
*
                  C(i)=C(i) + Step_pi
*
                  C(j)=C(j) + Step_mj
                  C(k)=C(k) + Step_mk
                  Steps(2,1)=Step_mj
                  Steps(3,1)=Step_mk
*
                  Es(1)=optim_E(C,G,H,n,nDim)
*
                  C(j)=C(j) - Step_mj
                  C(k)=C(k) - Step_mk
*
                  C(j)=C(j) + Step_pj
                  C(k)=C(k) + Step_pk
                  Steps(2,2)=Step_pj
                  Steps(3,2)=Step_pk
*
                  Es(2)=optim_E(C,G,H,n,nDim)
*
                  C(j)=C(j) - Step_pj
                  C(k)=C(k) - Step_pk
*
                  C(i)=C(i) - Step_pi
*
                  Step_mi= Min(C(i),Step)
                  Steps(1,3) = Step_mi
                  Steps(1,4) = Step_mi
*
                  AI=2.0D0*(C(i)+Step_mi)*Step_mi*D(i,i)
     &              +C(k)*Step_mi*D(k,i)
     &              +C(j)*Step_mi*D(j,i)
                  AJ1=(C(i)+2.0D0*Step_mi)*D(i,j)
     &               +C(j)*D(j,j) + C(k)*D(k,j)
                  AK1=(C(i)+2.0D0*Step_mi)*D(i,k)
     &               +C(k)*D(k,k) + C(j)*D(j,k)
                  AJK=2.0D0*D(j,k)
                  AJ2=D(j,j)
                  AK2=D(k,k)
*
                  BI = AI - AJ1*Step_mi+AJ2*Step_mi**2
                  BJ1= -AJ1 + AK1 - (AJK - 2.0D0*AJ2)*Step_mi
                  BJ2= -AJK + AJ2 + AK2
*
                  A = BJ1/(2.0D0*BJ2)
                  B = BI/BJ2
*
                  Step_pk = - A + Sqrt(A**2-B)
                  Step_mk = - A - Sqrt(A**2-B)
*
                  Step_pj=-(Step_mi+Step_pk)
                  Step_mj=-(Step_mi+Step_mk)
*
                  C(i)=C(i) + Step_mi
*
                  C(j)=C(j) + Step_mj
                  C(k)=C(k) + Step_mk
                  Steps(2,3)=Step_mj
                  Steps(3,3)=Step_mk
*
                  Es(3)=optim_E(C,G,H,n,nDim)
*
                  C(j)=C(j) - Step_mj
                  C(k)=C(k) - Step_mk
*
                  C(j)=C(j) + Step_pj
                  C(k)=C(k) + Step_pk
                  Steps(2,4)=Step_pj
                  Steps(3,4)=Step_pk
*
                  Es(4)=optim_E(C,G,H,n,nDim)
*
                  C(j)=C(j) - Step_pj
                  C(k)=C(k) - Step_pk
*
                  C(i)=C(i) - Step_mi
*
#ifdef _DEBUGPRINT_
                  Write(6,'(a,3I3,4F20.10)')
     &                  'i,j,k,Es(i),i=1,4)=',
     &                   i,j,k,(Es(l),l=1,4)
#endif
                  nLow=0
                  Do l = 1, 4
                     If (Es(l).lt.Eref) Then
                        nLow=l
                        Eref=Es(l)
                        DidChange=.true.
                     End If
                  End Do
                  If (nLow.ne.0) Then
                     C(i) = C(i) + Steps(1,nLow)
                     C(j) = C(j) + Steps(2,nLow)
                     C(k) = C(k) + Steps(3,nLow)
                  End If
*
               End Do
            End Do
         End Do
*
         If (.not.DidChange) Then
            If (Step.gt.0.9d-4) Then
               Step=0.1d0*Step
               DidChange=.true.
#ifdef _DEBUGPRINT_
               Write(6,*) 'Step is',Step
#endif
            End If
         End If
#ifdef _DEBUGPRINT_
*
*        Check that the constraint is fullfilled.
*
         sum=0.0d0
         Do i=1,n
            sum=sum+C(i)
         End Do
         Write(6,*) 'optim: sum-1',sum-1.0d0
*
         sum=0.0D0
         Do i = 1, n
            Do j = 1, n
               sum=sum+C(i)*C(j)*D(i,j)
            End Do
         End Do
         Write(6,*) 'optim: sum-r2',sum-r2
#endif
         Go To 100
      End If
#ifdef _DEBUGPRINT_
      Write (6,*) 'ERef=',ERef
#endif
      E_Pred=ERef

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
************************************************************************
      Subroutine Do_NewFunctional(Rho,nRho,mGrid,
     &                   dF_dRho,ndF_dRho,
     &                   Coeff,nD,F_xc,
     &                   P2_ontop,nP2_ontop,
     &                   dF_dP2ontop,ndF_dP2ontop,T_X)
************************************************************************
*                                                                      *
* Object:  Lyp Functional(Formula taken from Molpro Manual)            *
*                                                                      *
*      Author: Per-AAke Malmquist,Department of Theoretical Chemistry  *
*              University of LUnd, SWEDEN                              *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
      Real*8 dF_dRho(ndF_dRho,mGrid),
     &       Rho(nRho,mGrid),P2_ontop(nP2_ontop,mGrid),
     &       F_xc(mGrid),
     &       dF_dP2ontop(ndF_dP2ontop,mGrid)
      Common /points/ GGrid(3,6000)
      Common /ipoints/ iiGrid
#include "nq_index.fh"
*
      aConst=0.049180d0
      bConst=0.1320d0
      dConst=0.3490d0
      cConst=0.25330d0
      Cf=2.8712340001881918D0
      Rho_min=T_X*1.0D-2
*
      Do iGrid=1,mGrid
*
       If(nD.eq.1) Then
         Rho_tot=2.0d0*Rho(1,iGrid)
         If (Rho_tot.lt.T_X) Go To 199
         Rhox=2.0d0*Rho(2,iGrid)
         Rhoy=2.0d0*Rho(3,iGrid)
         Rhoz=2.0d0*Rho(4,iGrid)
         gradRho2=Rhox*Rhox+Rhoy*Rhoy+Rhoz*Rhoz
         grad2Rho=2.0d0*Rho(5,iGrid)
         P2=P2_ontop(1,iGrid)
         P2x=P2_ontop(2,iGrid)
         P2y=P2_ontop(3,iGrid)
         P2z=P2_ontop(4,iGrid)
         gradP22=P2x*P2x+P2y*P2y+P2z*P2z
         grad2P2=P2_ontop(5,iGrid)
         P2sp=P2_ontop(6,iGrid)
         gradP2gradRho=Rhox*P2x+Rhoy*P2y+Rhoz*P2z
       Else
         Rho_tot=Max(Rho_min,Rho(1,iGrid))+Max(Rho_min,Rho(2,iGrid))
         If (Rho_tot.lt.T_X) Go To 199
         Rhox=Rho(3,iGrid)+Rho(6,iGrid)
         Rhoy=Rho(4,iGrid)+Rho(7,iGrid)
         Rhoz=Rho(5,iGrid)+Rho(8,iGrid)
         gradRho2=Rhox*Rhox+Rhoy*Rhoy+Rhoz*Rhoz
         grad2Rho=Rho(9,iGrid)+Rho(10,iGrid)
         P2 =P2_ontop(1,iGrid)
         P2x=P2_ontop(2,iGrid)
         P2y=P2_ontop(3,iGrid)
         P2z=P2_ontop(4,iGrid)
         gradP22=P2x*P2x+P2y*P2y+P2z*P2z
         grad2P2=P2_ontop(5,iGrid)
         P2sp=P2_ontop(6,iGrid)
         gradP2gradRho=Rhox*P2x+Rhoy*P2y+Rhoz*P2z
       End If
*
*    T2 term:
*
      t1 = Rho_tot**(1.D0/3.D0)
      t2 = 1/t1
      t4 = 1+dConst*t2
      t5 = 1/t4
      denom = 1.D0*t5
      T2_term = -aConst*Rho_tot*t5
      t10 = t4**2
      dT2_dRho = -aConst*t5-aConst*t2/t10*dConst/3
*
*   T3 term:
*
      t1 = aConst*bConst
      t2 = Rho_tot**(1.D0/3.D0)
      t3 = 1/t2
      t5 = exp(-cConst*t3)
      t7 = 1+dConst*t3
      t8 = 1/t7
      t9 = t5*t8
      t10 = t2**2
      t12 = 1/t10/Rho_tot
      t14 = t1*t9*t12
      Z_term = -t14
      t15 = t1*cConst
      t16 = Rho_tot**2
      t17 = t16*Rho_tot
      t18 = 1/t17
      t23 = t1*t5
      t24 = t7**2
      t25 = 1/t24
      t35 = -t15*t18*t5*t8/3-t23*t25*t18*dConst/3+5.D0/3.D0*t1*
     &        t9/t10/t16
      T3_term = -t35*gradP2gradRho/4+t23*t8*t12*P2sp
      dT3_dRho = t35*(grad2P2/4-P2sp)
      t43 = t16**2
      t44 = 1/t43
      t49 = cConst**2
      t52 = 1/t2/t43
      t53 = t52*t5
      t64 = dConst**2
      dT3_dP2 = (14.D0/9.D0*t15*t44*t5*t8-t1*t49*t53*t8/9-2.D0/9.D0*t15*
     &t53*t25*dConst-2.D0/9.D0*t23/t24/t7*t52*t64+14.D0/9.D0*t23*t25*t44
     &*dConst-40.D0/9.D0*t1*t9/t10/t17)*gradRho2/4+t35*grad2Rho/4
      dT3_dP2sp = t14
*
      Functional= T2_term   +   T3_term
      F_xc(iGrid)=F_xc(iGrid)+Coeff*Functional
*
      dF_dRho(ipR,iGrid)= dT2_dRho + dT3_dRho
      dF_dP2ontop(1,iGrid)=dT3_dP2
      dF_dP2ontop(2,iGrid)=0.0D0
      dF_dP2ontop(3,iGrid)=0.0D0
      dF_dP2ontop(4,iGrid)=0.0D0
      dF_dP2ontop(5,iGrid)=0.0D0
      dF_dP2ontop(6,iGrid)= dT3_dP2sp
*
 199  Continue
      End Do  ! iGrid
c
c
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Compute_d2Mdx2(ZA,nAtoms,iAtom,iCar,dTdRAi,
     &                                    jAtom,jCar,dTdRaj,d2Mdx2)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
      Real*8 ZA(nAtoms),d2Mdx2(3,3)
*                                                                      *
************************************************************************
*                                                                      *
      Call FZero(d2Mdx2,9)
      Do kAtom = 1, nAtoms
         ZB=ZA(kAtom)
         If (kAtom.eq.iAtom) Then
            tmpi=One-dTdRAi
         Else
            tmpi=   -dtdRAi
         End If
         If (kAtom.eq.jAtom) Then
            tmpj=One-dTdRAi
         Else
            tmpj=   -dtdRAi
        End If
*
        If (iCar.eq.1.and.jCar.eq.1) Then
           d2Mdx2(2,2) = d2Mdx2(2,2) + Two*ZB*tmpi*tmpj
           d2Mdx2(3,3) = d2Mdx2(3,3) + Two*ZB*tmpi*tmpj
        End If
        If (iCar.eq.1.and.jCar.eq.2) Then
           d2Mdx2(1,2) = d2Mdx2(1,2) -     ZB*tmpi*tmpj
           d2Mdx2(2,1) = d2Mdx2(2,1) -     ZB*tmpj*tmpi
         End If
         If (iCar.eq.1.and.jCar.eq.3) Then
            d2Mdx2(1,3) = d2Mdx2(1,3) -     ZB*tmpi*tmpj
            d2Mdx2(3,1) = d2Mdx2(3,1) -     ZB*tmpj*tmpi
         End If
         If (iCar.eq.2.and.jCar.eq.1) Then
            d2Mdx2(1,2) = d2Mdx2(1,2) -     ZB*tmpj*tmpi
            d2Mdx2(2,1) = d2Mdx2(2,1) -     ZB*tmpi*tmpj
         End If
         If (iCar.eq.2.and.jCar.eq.2) Then
            d2Mdx2(1,1) = d2Mdx2(1,1) + Two*ZB*tmpi*tmpj
            d2Mdx2(3,3) = d2Mdx2(3,3) + Two*ZB*tmpi*tmpj
         End If
         If (iCar.eq.2.and.jCar.eq.3) Then
            d2Mdx2(2,3) = d2Mdx2(2,3) -     ZB*tmpi*tmpj
            d2Mdx2(3,2) = d2Mdx2(3,2) -     ZB*tmpj*tmpi
         End If
         If (iCar.eq.3.and.iCar.eq.1) Then
            d2Mdx2(1,3) = d2Mdx2(1,3) -     ZB*tmpj*tmpi
            d2Mdx2(3,1) = d2Mdx2(3,1) -     ZB*tmpi*tmpj
         End If
         If (iCar.eq.3.and.jCar.eq.2) Then
            d2Mdx2(2,3) = d2Mdx2(2,3) -     ZB*tmpj*tmpi
            d2Mdx2(3,2) = d2Mdx2(3,2) -     ZB*tmpi*tmpj
         End If
         If (iCar.eq.3.and.jCar.eq.3) Then
            d2Mdx2(1,1) = d2Mdx2(1,1) + Two*ZB*tmpi*tmpj
            d2Mdx2(2,2) = d2Mdx2(2,2) + Two*ZB*tmpi*tmpj
         End If
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real(dTdRaj)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2000, Gunnar Karlstrom                                 *
*               2000, Roland Lindh                                     *
************************************************************************
      Subroutine ener(h1,TwoHam,D,RepNuc,nh1,First,Dff,D_Tot,Grid,
     &                nGrid_,DipMom,EField,DipEff,PolEff,
     &                Cord,MaxAto,Z_Nuc,nPolComp,nAnisopol,pField,tmpF)
************************************************************************
*                                                                      *
*     Object: to compute the needed terms from the interaction between *
*             the charge of the QM system, the dipole moments on the   *
*             grid, and the counter charge on the boundary of the      *
*             cavity. The latter can be divided into three terms,      *
*             nuclear, electronic and Langevin dipole moment terms.    *
*                                                                      *
*     Authors: G. Karlstroem                                           *
*              Dept. of Theor. Chem., Univ. of Lund, Sweden.           *
*                                                                      *
*              and                                                     *
*                                                                      *
*              R. Lindh                                                *
*              Dept. of Chem. Phys., Univ. of Lund, Sweden.            *
*                                                                      *
*              March 2000                                              *
************************************************************************
      use Symmetry_Info, only: nIrrep, iChBas
      use Basis_Info, only: nBas
      use Temporary_Parameters, only: PrPrt
      Implicit Real*8 (a-h,o-z)
      External EFInt,EFMem
#include "real.fh"
#include "rctfld.fh"
#include "stdalloc.fh"
      Real*8 h1(nh1), TwoHam(nh1), D(nh1), D_tot(nh1), EF_Grid(3),
     &       Grid(3,nGrid_), DipMom(3,nGrid_), EField(4,nGrid_),
     &       DipEff(nGrid_), PolEff(nPolComp,nGrid_), CCoor(3),
     &       Cord(3,MaxAto), Z_Nuc(MaxAto),pField(4,nGrid_),
     &     tmpF(4,nGrid_)
      Logical First, Dff, Save_tmp , NonEq
      Character*8 Label
      Integer, Allocatable:: ips(:), lOper(:), kOper(:)
      Real*8, Allocatable::  C_Coor(:,:)
      Real*8, Allocatable:: Integrals(:)
*
#include "oneel_interface.fh"
*                                                                      *
************************************************************************
*                                                                      *
*---- First compute contributions due to the interaction of the QM
*     charge distributions with the corresponding counter charges on
*     the surface of the cavity.
*
*     Here we have three terms
*     1) nuclear-nuclear, constant: added to RepNuc once
*     2) nuclear-electronic, constant: added to h1 once
*     3) electronic-electronic, linearly dependent of the density: TwoHam
*
      tmp_RepNuc=RepNuc
      NonEq=.False.
      If(lRFCav) Call RctFld(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq)
*                                                                      *
************************************************************************
*                                                                      *
*1)   Compute interaction between the dipole moment on the grid and
*     the EF on the grid (Edip2). Eself is the self interaction term
*     of the dipole moments on the grid.
*
*     Both terms depend on D_tot and the modifies RepNuc each iteration.
*
*2)   Compute interaction term between the EF of the nuclear charges
*     and the dipole moments on the grid (EnucDip). This scalar terms
*     depends also on D_tot and modifies RepNuc at each iteration.
*
      qq0=Zero
*
      Edip2=Zero
      Eint=Zero
      Eself=Zero
      Enucdip=Zero
      Esimple=Zero
      iMax=1
      agsum=Zero

*
      Do iGrid=1,nGrid_
*------- Grid coordinates
         ghx=Grid(1,iGrid)
         ghy=Grid(2,iGrid)
         ghz=Grid(3,iGrid)
*------- Langevin dipol moment
         dx=DipMom(1,iGrid)
         dy=DipMom(2,iGrid)
         dz=DipMom(3,iGrid)
*------- Total Electric Field
         fx=EField(1,iGrid)
         fy=EField(2,iGrid)
         fz=EField(3,iGrid)
*------- Electric Field from permanent multipoles
         pfx=pField(1,iGrid)
         pfy=pField(2,iGrid)
         pfz=pField(3,iGrid)

*
*------- Twice the energy of Langevin dipole moments in EF
*
         Edip2=Edip2-fx*dx-fy*dy-fz*dz

         fDd=fx*dx+fy*dy+fz*dz   ! f dot d

*        Do NOT halve the contribution from permanent multipoles
         Eint=Eint-Half*(fDd + pfx*dx+pfy*dy+pfz*dz)

         Esimple=Esimple-Half*(tmpF(1,iGrid)*dx+tmpF(2,iGrid)*dy+
     &        tmpF(3,iGrid)*dz)

*
*------- Compute self energies of dipole moments
*
         ftot2=fx*fx+fy*fy+fz*fz
         ftot=sqrt(ftot2)
         x=ftot*DipEff(iGrid)*tk
         If (x.le.0.0000001d0) Then
            ag=Zero
            alang=Zero
         Else
            ex=exp(x)
            emx=One/ex
            alang=(ex+emx)/(ex-emx)-One/x
            ag=-log((ex-emx)/(Two*x))/tk
         End If
*

         If(iGrid.gt.nAnisopol) Then  ! isotropic
c            uind=DipEff(iGrid)*alang+ftot*PolEff(1,iGrid)
c            Eself=Eself+ftot*uind+ag-Half*ftot**2*PolEff(1,iGrid)
            Eself=Eself+fDd-Half*ftot2*PolEff(1,iGrid)
            agsum=agsum+ag
         Else ! anisotropic
            Eself=Eself+Half*(fx*dx+fy*dy+fz*dz)
         EndIf
*
*------- Compute the EF at the grid point due to the nucleus
*
         nOrdOp=1
         Call EFNuc(Grid(1,iGrid),Z_Nuc,Cord,MaxAto,
     &              EF_Grid,nOrdOp)
*
         Enucdip=Enucdip-EF_Grid(1)*dx
     &                  -EF_Grid(2)*dy
     &                  -EF_Grid(3)*dz
*
      End Do          ! iGrid
*
#ifdef _DEBUGPRINT_
      Write(6,*)'Esimple             =',Esimple
      Write(6,*)'EnucRctfld          =',RepNuc-tmp_RepNuc
      Write(6,*)'Eself               =',Eself
      Write(6,*)'Ag term             =',agsum
      Write(6,*)'Electrostatic energy=',Eint
      Write(6,*)'EnucDip (half)      =',Half*Enucdip
#endif

      RepNuc = RepNuc + Eself + agsum + Eint + Half*Enucdip
*
c     Note:Before PS made this code compatible with XFIE, the following
c     quantity was reported as Electrostatic energy: Half*Edip2
c     and: RepNuc = RepNuc + Eself + Half*Edip2 + Half*Enucdip


*                                                                      *
************************************************************************
*                                                                      *
*---- Compute interaction term between the field of the electronic
*     charge and the dipole moments. This term is modified on each
*     iteration.
*
*---- Retrieve the statatic h1
*
      Label='h1_raw  '
      Call Get_Temp(Label,h1,nh1)

*
*---- Compute the modification to h1
*
*     Evaluate electronic EF integrals at each point and add to h1
*
*
      rHrmt=One
      nOrdOp = 1
      nComp = 3
      Sig=-One
      ixyz=1
      iSymX = 2**IrrFnc(ixyz)
      ixyz=2
      iSymY = 2**IrrFnc(ixyz)
      ixyz=4
      iSymZ = 2**IrrFnc(ixyz)
      ixyz=3
      iSymXY = 2**IrrFnc(ixyz)
      ixyz=5
      iSymXZ = 2**IrrFnc(ixyz)
      ixyz=6
      iSymYZ = 2**IrrFnc(ixyz)
      ixyz=7
      iSyXYZ = 2**IrrFnc(ixyz)
*
      Call mma_allocate(ips,nComp,Label='ips')
      Call mma_allocate(lOper,nComp,Label='lOper')
      Call mma_allocate(kOper,nComp,Label='kOper')
      Call mma_allocate(C_Coor,3,nComp,Label='CCoor')
*
      Save_tmp=PrPrt
      PrPrt=.True.
*
      RepHlp=Zero
      Do iGrid = 1, nGrid_
         Write (Label,'(A,I5)') 'EF ',iGrid
         call dcopy_(3,Grid(1,iGrid),1,CCoor,1)
         iSymC = 1
         If (Ccoor(1).ne.Zero) iSymC = iOr(iSymC,iSymX)
         If (Ccoor(2).ne.Zero) iSymC = iOr(iSymC,iSymY)
         If (Ccoor(3).ne.Zero) iSymC = iOr(iSymC,iSymZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero)
     &      iSymC = iOr(iSymC,iSymXY)
         If (Ccoor(1).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymC = iOr(iSymC,iSymXZ)
         If (Ccoor(2).ne.Zero .and. Ccoor(3).ne.Zero)
     &      iSymC = iOr(iSymC,iSymYZ)
         If (Ccoor(1).ne.Zero .and. Ccoor(2).ne.Zero .and.
     &       Ccoor(3).ne.Zero) iSymC = iOr(iSymC,iSyXYZ)
*
         iComp=0
         Do ix = nOrdOp, 0, -1
            Do iy = nOrdOp-ix, 0, -1
               iComp = iComp + 1
               iz = nOrdOp-ix-iy
               ixyz=0
               If (Mod(ix,2).ne.0) ixyz=iOr(ixyz,1)
               If (Mod(iy,2).ne.0) ixyz=iOr(ixyz,2)
               If (Mod(iz,2).ne.0) ixyz=iOr(ixyz,4)
               iSym = 2**IrrFnc(ixyz)
               If (Ccoor(iComp).ne.Zero ) iSym = iOr(iSym,1)
               lOper(iComp) = MltLbl(iSymC,iSym)
               kOper(iComp) = iChBas(iComp+1)
               call dcopy_(3,Ccoor,1,C_Coor(1,iComp),1)
            End Do
         End Do
*
         Call OneEl_Integrals(EFInt,EFMem,Label,
     &                        ips,lOper,nComp,C_Coor,
     &                        nOrdOp,rHrmt,kOper,Integrals)
*
         Eeldip=Zero
         Do iComp = 1, nComp
            ip=ips(iComp)
            iSmLbl = lOper(iComp)
*                                                                      *
************************************************************************
*                                                                      *
*-----------Compute properties directly from integrals
*
            nInt=n2Tri(iSmLbl)
            If (nInt.ne.0.and.Abs(DipMom(iComp,iGrid)).gt.1.0D-20) Then
               Call CmpInt(Integrals(ip),nInt,nBas,nIrrep,iSmLbl)
               If (nInt.ne.nh1) Then
                  Call WarningMessage(2,'Ener: nInt.ne.nh1')
                  Write (6,*) 'nInt=',nInt
                  Write (6,*) 'nh1=',nh1
                  Call Abend()
               End If
*
*------------- Accumulate contribution to h1
*
               alfa=Sig*DipMom(iComp,iGrid)
               Call DaXpY_(nInt,alfa,Integrals(ip),1,h1,1)
               EelDip=EelDip-alfa*DDot_(nh1,D_tot,1,Integrals(ip),1)
*
            End If
*
*                                                                      *
************************************************************************
*                                                                      *
*
         End Do ! iComp
*
*------- Deallocate memory for integral
*
         Call mma_deallocate(Integrals)
*
         RepHlp=RepHlp+EelDip*half
!        Write (6,*) 'Eeldip=',Eeldip,RepHlp
*
      End Do    ! iGrid
      RepNuc=RepNuc+RepHlp
#ifdef _DEBUGPRINT_
      Write(6,*)'RepHlp              =',RepHlp
#endif

*
      PrPrt=Save_tmp
*
      Call mma_deallocate(C_Coor)
      Call mma_deallocate(kOper)
      Call mma_deallocate(lOper)
      Call mma_deallocate(ips)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine NACInt(xyz,nCent,H12,Bf,lWrite_,Label,dBf,ldB)
      use Slapaf_Info, only: NAC
      Implicit Real*8  (a-h,o-z)
#include "real.fh"
#include "constants.fh"
      Real*8   Bf(3,nCent), xyz(3,nCent), dBf(3*nCent,3*nCent)
      Logical lWrite_, ldB
      Character*8 Label
*
*
      H12=Zero
      If (lWrite_) Then
         Write (6,'(2A,F18.8,A,F18.8,A)')
     &             Label,' : H12               = ',
     &             H12, ' hartree '
      End If
*
*---- Compute the WDC B-matrix
*
C     Call RecPrt('NAC',' ',NAC,3,nCent)
      Do iCent = 1, nCent
         Fact=DBLE(iDeg(xyz(1,iCent)))
C        Write (6,*) 'Fact=',Fact
         Do iCar = 1, 3
            Bf(iCar,iCent)=Fact*NAC(iCar,iCent)
         End Do
      End Do
C     Call RecPrt('Bf',' ',Bf,3,nCent)
*
*---- Compute the cartesian derivative of the B-Matrix.
*
      If (ldB) Then
         Call FZero(dBf,(3*nCent)**2)
*        Call RecPrt('dBf','(9F9.1)',dBf,3*nCent,3*nCent)
*
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine rlsmem_ints()
      use k2_arrays, only: Sew_Scr
      implicit real*8 (a-h,o-z)
#include "setup.fh"
#include "stdalloc.fh"
#include "status.fh"
c
      If (XMem_Status.eq.Active) Then
C        Write (6,*) 'RlsMem_Ints: External scratch handling active!'
      Else If (XMem_Status.eq.InActive) Then
         If (Allocated(Sew_Scr)) Then
C           Write (6,*) 'RlsMem_Ints: Memory released!'
            Call mma_deallocate(Sew_Scr)
C        Else
C           Write (6,*) 'RlsMem_Ints: No memory to release!'
         End If
      End If
*
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2010, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine LDF_Fock_CoulombOnly0_3(Const,nD,ip_VBlocks,ip_WBlocks,AB,CD)
! Thomas Bondo Pedersen, September 2010.
!
!          OLD CODE
!
! Purpose: Compute
!
!      W(J_AB) = W(J_AB) + Const * sum_[K_CD] (J_AB | K_CD)*V(K_CD)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(in) :: Const
integer(kind=iwp), intent(in) :: nD, ip_VBlocks(nD), ip_WBlocks(nD), AB, CD
integer(kind=iwp) :: MAB, MCD, l_Int, iD, ipV, ipW
real(kind=wp), allocatable :: FJK(:)
integer(kind=iwp), external :: LDF_nBasAux_Pair
#include "WrkSpc.fh"

! Get row and column dimension of integrals
MAB = LDF_nBasAux_Pair(AB)
MCD = LDF_nBasAux_Pair(CD)

! Return if nothing to do
if ((MAB < 1) .or. (MCD < 1)) return

! Allocate integrals (J_AB | K_CD)
l_Int = MAB*MCD
call mma_allocate(FJK,l_Int,label='LDFFJK')

! Compute integrals (J_AB | K_CD)
call LDF_ComputeIntegrals_JK_2P(AB,CD,l_Int,FJK)

! Compute contributions
do iD=1,nD
  ipV = iWork(ip_VBlocks(iD)-1+CD)
  ipW = iWork(ip_WBlocks(iD)-1+AB)
  call dGeMV_('N',MAB,MCD,Const,FJK,MAB,Work(ipV),1,One,Work(ipW),1)
end do

! Deallocate integrals
call mma_deallocate(FJK)

end subroutine LDF_Fock_CoulombOnly0_3

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2019, Gerardo Raggi                                    *
!***********************************************************************

subroutine kriging_model()

!#define _DPOSV_
use kriging_mod, only: blaAI, blAI, blavAI, blvAI, detR, dy, full_R, Index_PGEK, Kv, lh, m_t, mblAI, Model_Type, nD, nInter_Eff, &
                       nPoints, nSet, ordinary, Rones, sb, sbmev, sbO, variance, y
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
#ifdef _DPOSV_
use Constants, only: Two
#endif
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i_eff, is, ie, ise, iee, i, iSet, INFO, mt
integer(kind=iwp), allocatable :: IPIV(:) ! ipiv the pivot indices that define the permutation matrix
real(kind=wp), allocatable :: B(:), A(:,:)
real(kind=wp), external :: dDot_

call mma_Allocate(B,m_t,label='B')      ! the f vector
call mma_Allocate(A,m_t,m_t,label='A')  ! the correlation matrix
call mma_Allocate(IPIV,m_t,label='IPIV')

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

B(1:nPoints) = One    ! the f vector, the value part
B(nPoints+1:) = Zero  ! the f vector, the gradient part

A(:,:) = full_r(:,:)  ! the correlation matrix

#ifdef _DEBUGPRINT_
call RecPrt('f',' ',B,1,m_t)
call RecPrt('PSI',' ',A,m_t,m_t)
#endif

! Now form (A^{-1} f) (to be used for the computation of the dispersion)

#ifdef _DPOSV_
call DPOSV_('U',m_t,1,A,m_t,B,m_t,INFO)
#else
call DGESV_(m_t,1,A,m_t,IPIV,B,m_t,INFO)
#endif

if (INFO /= 0) then
  write(u6,*) 'kriging_model: INFO /= 0'
  write(u6,*) 'kriging_model: INFO=',INFO
  call Abend()
end if

#ifdef _DEBUGPRINT_
write(u6,*) 'Info=',Info
write(u6,*) 'nPoints=',nPoints
call RecPrt('PSI^{-1}',' ',A,m_t,m_t)
call RecPrt('X=PSI^{-1}f',' ',B,1,m_t)
#endif

rones(:) = B(:)  ! Move result over to storage for later use, (R^{-1} f)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Compute contribution to the expression for the liklihood function.
!
! Now A contains the factors L and U from the factorization A = P*L*U as computed by DGESV
! Where L in the lower triangular matrix with 1 in the diagonal and U is the upper
! triangular matrix of A thus the determinant of A is giving by multipling its diagonal

detR = Zero
do i=1,m_t
# ifdef _DPOSV_
  detR = detR+Two*log(A(i,i))
# else
  detR = detR+log(abs(A(i,i)))
# endif
end do

! Now work on the trend function and the vector with the values and gradients, the generalized y vector
!
!  sb   : mu, the trend function
!  rones: (R^{-1} f)
!  kv   :  R^{-1} (y - mu f)

!***********************************************************************
!
! 1) Establish the trend function (baseline), mu.
!
!***********************************************************************

if (blaAI) then  ! This is the default.

  ! Make sure the base line is above any data point, this to make sure the surrogate model is bound.

  sb(:) = -huge(sb(1))
  do iSet=1,nSet
    if (allocated(Model_Type)) then
      mt = Model_Type(iSet)
    else
      mt = 1
    end if
    select case (mt)
      case (1) ! default
        do i=1,nPoints
          sb(iSet) = max(sb(iSet),y(i,iSet)+blavAI)
        end do
      case (2) ! coupling
        sb(iSet) = Zero
    end select
  end do

else if (mblAI) then

  if (nSet > 1) call Abend()
  sb(1) = sbmev

else if (blAI) then

  if (nSet > 1) call Abend()
  sb(1) = blvAI

else

  if (nSet > 1) call Abend()
  ! Derived according to ordinary kriging

  ordinary = .true.

  ! Note dy only contains gradients for the set of points which we are considering
  ! B(:) = [y(:),dy(:)]  original code before PGEK implementation

  B(1:nPoints) = y(1:nPoints,1)
  do i_eff=1,nInter_eff
    i = Index_PGEK(i_eff)
    is = (i-1)*(nPoints-nD)+1
    ise = nPoints+(i_eff-1)*(nPoints-nD)+1
    ie = is+(nPoints-nD)-1
    iee = ise+(nPoints-nD)-1
    B(ise:iee) = dy(is:ie,1)
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) DDot_(m_t,rones,1,B,1),DDot_(nPoints,rones,1,[One],0)
# endif
  ! mu = (f R^{-1} y) /(f R^{-1} f)
  sbO = DDot_(m_t,rones,1,B,1)/DDot_(nPoints,rones,1,[One],0)

  sb(1) = sbO
end if

!***********************************************************************
!
! 2) form the value vector, kv = (y - mu f)
!
!***********************************************************************
!
! B(1:m_t) = [y(1:nPoints)-sb,dy(1:nInter*(nPoints-nD))]

do iSet=1,nSet
  ! the values
  B(1:nPoints) = y(1:nPoints,iSet)-sb(iSet)
  ! the gradients
  do i_eff=1,nInter_eff
    i = Index_PGEK(i_eff)
    is = +(i-1)*(nPoints-nD)+1
    ise = nPoints+(i_eff-1)*(nPoints-nD)+1
    ie = is+(nPoints-nD)-1
    iee = ise+(nPoints-nD)-1
    B(ise:iee) = dy(is:ie,iSet)
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) 'sb,ln(det|PSI|)=',sb(iSet),detR
  call RecPrt('[y-sb,dy]','(12(1x,ES10.3))',B,1,m_t)
# endif

  Kv(:,iSet) = B(:)  ! The value vector

# ifdef _DEBUGPRINT_
  write(u6,*) 'iSet=',iSet
  call RecPrt('Kv',' ',Kv(:,iSet),1,m_t)
# endif

  !*********************************************************************
  !
  ! Solve R x = (y - mu f), i.e. x = R^{-1} (y - mu f)

  A(:,:) = full_R(:,:)

# ifdef _DPOSV_
  call DPOSV_('U',m_t,1,A,m_t,Kv(:,iSet),m_t,INFO)
# else
  call DGESV_(m_t,1,A,m_t,IPIV,Kv(:,iSet),m_t,INFO)
# endif

  ! Compute the dispersion
  !
  ! s^2 = (y - mu f) R^{-1} (y - mu f) / n

  variance(iSet) = dot_product(B,Kv(:,iSet))/real(m_t,kind=wp)

  ! compute the value of the likelihood function

  lh(iSet) = variance(iSet)*exp(detR/real(m_t,kind=wp))

# ifdef _DEBUGPRINT_
  write(u6,*) 'Variance=',Variance(iSet)
  write(u6,*) 'Info=',Info
  write(u6,*) 'lh=',lh
  call RecPrt('X=A^{-1}Kv','(5(ES15.7,2X))',Kv(:,iSet),1,m_t)
# endif

end do

call mma_Deallocate(B)
call mma_Deallocate(A)
call mma_Deallocate(IPIV)

end subroutine kriging_model

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
*               1993, Per-Olof Widmark                                 *
************************************************************************
      Subroutine MkSrt3(iRc,iSquar,nIrrep,nBas,nSkip)
************************************************************************
*                                                                      *
*    Purpose: Prepare the address table for the virtual disk and       *
*             initialize the memory                                    *
*                                                                      *
*    Global data declarations (Include files) :                        *
*    TwoDat : table of contents and auxiliary information              *
*    TowRc  : Table of return code                                     *
*                                                                      *
*    calling arguments:                                                *
*    iRc    : return code                                              *
*             A value of 0 (zero) is returned upon successful          *
*             completion of the request. A nonzero value indi-         *
*             cates an error.                                          *
*    iSquar  : ordering flag                                           *
*    nIrrep  : number of irreducible representations                   *
*    nBas    : number of basis functions per irred. rep.               *
*    nSkip   : flag to exlude symmetry combinations                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. P. Fuelscher and P.O. Widmark                                 *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Integer (A-Z)
*
      Dimension nBas(nIrrep),nSkip(nIrrep)
*
#include "srt1.fh"
#include "Molcas.fh"
#include "TwoDat.fh"
#include "print.fh"
      Integer nSln_Temp(mSyBlk), lSll_Temp(mSyBlk)
      Logical Square

      iRout = 80
      iPrint = nPrint(iRout)
      If ( iPrint.gt.5 ) Write(6,*) ' >>> Enter MKSRT3 <<<'

      Square = .true.
      If( iSquar.eq.0 )  Square=.false.
*
      Call iCopy(mSyBlk,nSln,1,nSln_Temp,1)
      Call iCopy(mSyBlk,lSll,1,lSll_Temp,1)
      Do iSyBlk=1,mSyBlk
        nSln(iSyBlk)=0
        lSll(iSyBlk)=0
      End Do
*
*     loop over all symmetry blocks
*
*     Write(*,*)
*     Write(*,'(2X,A,I3.3,A)') '*** (I)-level message MKSRT3 ***'
*     Write(*,'(2X,A,I8    )') 'RAMD_size   =',RAMD_size
*     Write(*,'(2X,A,I8    )') 'RAMD_anchor =',RAMD_anchor
*     Write(*,*)
*     Write (*,'(2X,84A1)') ('*',i=1,84)
*
      iRc   = 0
      iOff  = RAMD_anchor
      nInts = 0
      nSym=TocTwo(isSym)
      mxSyP=nSym*(nSym+1)/2
      Do iSymi=1,nSym
        ib=nBas(iSymi)
        iSkip=nSkip(iSymi)
        Do jSymj=1,iSymi
          iSymj=1+ieor(iSymi-1,jSymj-1)
          iSyblj=jSymj+iSymi*(iSymi-1)/2
          jb=nBas(jSymj)
          ibj=ib*jb
          If( iSymi.eq.jSymj ) ibj=ib*(ib+1)/2
          jSkip=nSkip(jSymj)
          kSymMx=iSymi
          If( Square ) kSymMx=nSym
          Do kSymk=1,kSymMx
            kb=nBas(kSymk)
            kSkip=nSkip(kSymk)
            lSymMx=jSymj
            If( kSymk.ne.iSymi .or. Square ) lSymMx=kSymk
            Do lSyml=1,lSymMx
              kSyml=1+ieor(kSymk-1,lSyml-1)
              kSybll=lSyml+kSymk*(kSymk-1)/2
              If( ieor(iSymj-1,kSyml-1).eq.0 ) then
                lb=nBas(lSyml)
                kbl=kb*lb
                If( kSymk.eq.lSyml ) kbl=kb*(kb+1)/2
                lSkip=nSkip(lSyml)
                iSyBlk=kSybll+mxSyP*(iSyblj-1)
                If ( (iSkip+jSkip+kSkip+lSkip).eq.0 .and.
     &               (ibj*kbl).ne.0 ) then
C                  Write (6,*) 'iSymi,jSymj,kSymk,lSyml=',
C    &                          iSymi,jSymj,kSymk,lSyml
C                  Write (6,*) 'iSyBlk=',iSyBlk
C                  Write (6,*) 'nBatch(iSyBlk)=',nBatch(iSyBlk)
*     check if there is enough space available
*
                   lBuf = ibj*kbl
                   nInts = nInts + lBuf
                   If ( nInts.ge.RAMD_size ) then
                      iRc = 001
                      Write(6,*)
                      Write(6,'(2X,A,I3.3,A)')
     &                '*** (W)-level message MKSRT3',iRc,' ***'
                      Write(6,'(2X,A)')
     &                'There is not enough space on the RAM disk'
                      Write(6,'(2X,A)')
     &                'The program will resume normal activity'
                      Write(6,*)
                      Call iCopy(mSyBlk,nSln_Temp,1,nSln,1)
                      Call iCopy(mSyBlk,lSll_Temp,1,lSll,1)
                      Return
                   End If
*
*     save start address of this symmetry block
*
                   iBatch = nBatch(iSyBlk)
                   RAMD_adr(iBatch) = iOff
                   nSln(iSyBlk)=1
                   lSll(iSyBlk)=lBuf
*                  Write (*,'(2X,A,4I2,A,2I8,A,2I8)')
*    &                   ' iSym,jSym,kSym,lSym',
*    &                     iSymi,jSymj,kSymk,lSyml,
*    &                   ' lBuf,nInts',
*    &                     lBuf,nInts,
*    &                   ' iBatch,iOff',
*    &                     iBatch,iOff
*
*     Init integrals
*
                   Call dCopy_(lBuf,[0.0d0],0,RAMD_ints(iOff),1)
*
*     update pointers
*
                   iOff = iOff + lBuf

                End If
              End If
            End Do
          End Do
        End Do
      End Do
*     Write (*,'(2X,84A1)') ('*',i=1,84)
*
*----------------------------------------------------------------------*
*     compute offsets                                                  *
*----------------------------------------------------------------------*
*
*     Note that we fake the information so that the iSyBlk index is
*     really the iSyBlk index as it will be needed in Sort1c!
*
      Do iSyBlk=1,mSyBlk
         iStBin(iSyBlk)=iSyBlk
      End Do
*
*     define initial load point
*
*     RAMD_next=RAMD_adr(1)
*
      If ( iPrint.gt.5 ) Write(6,*) ' >>> Exit MKSRT3 <<<'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2015, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Read_Grad
!
!> @brief Read a vector from the gradients file
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Reads a gradient or coupling vector from the gradients file (GRADS).
!> For a gradient use \p iNAC, \p jNAC = 0. For a coupling vector use
!> \p iRoot = 0.
!>
!> @param[out] Grad  Gradient vector to read
!> @param[in]  nGrad Length of \p Grad
!> @param[in]  iRoot Root number to which the gradient belongs
!> @param[in]  iNAC  First root of a coupling vector
!> @param[in]  jNAC  Second root of a coupling vector
!>
!> @return \p 0 if the vector was not found, \p 1 if the vector was
!>         found, \p -1 if the vector was marked as non-computable
!***********************************************************************

function Read_Grad(Grad,nGrad,iRoot,iNAC,jNAC)

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: Read_Grad
integer(kind=iwp), intent(in) :: nGrad, iRoot, iNAC, jNAC
real(kind=wp), intent(out) :: Grad(nGrad)
integer(kind=iwp) :: iAd, iDum(1), idx, iSt, jSt, LuGrad, nCoup, nRoots, TOC(5)
logical(kind=iwp) :: Found
integer(kind=iwp), allocatable :: i_grad(:), i_nac(:)
character(len=5), parameter :: Filename = 'GRADS'

! If the GRADS file does not exist, there is no gradient

call f_Inquire(Filename,Found)
if (.not. Found) then
  Read_Grad = 0
else

  ! Read the header

  LuGrad = 20
  call DaName(LuGrad,Filename)
  iAd = 0
  call iDaFile(LuGrad,2,TOC,size(TOC),iAd)
  call iDaFile(LuGrad,2,iDum,1,iAd)
  nRoots = iDum(1)
  if (max(iRoot,iNAC,jNAC) > nRoots) then
    call WarningMessage(2,'Bad number of roots in GRADS file')
    call Abend()
  end if
  call iDaFile(LuGrad,2,iDum,1,iAd)
  if (iDum(1) /= nGrad) then
    call WarningMessage(2,'Bad length in GRADS file')
    call Abend()
  end if
  nCoup = max(1,nRoots*(nRoots-1)/2)
  call mma_allocate(i_grad,nRoots)
  call mma_allocate(i_nac,nCoup)
  call iDaFile(LuGrad,2,i_grad,nRoots,iAd)
  call iDaFile(LuGrad,2,i_nac,nCoup,iAd)

  ! Read the gradient or NAC vector

  if (iRoot == 0) then
    if ((iNAC /= 0) .and. (jNAC /= 0)) then
      iSt = max(iNAC,jNAC)-1
      jSt = min(iNAC,jNAC)
      idx = iSt*(iSt-1)/2+jSt
      iAd = i_nac(idx)
    else
      iAd = -1
    end if
  else
    idx = iRoot
    iAd = i_grad(idx)
  end if

  if (iAd == 0) then
    Read_Grad = 0
  else if (iAd < 0) then
    Read_Grad = -1
  else
    call dDaFile(LuGrad,2,Grad,nGrad,iAd)
    Read_Grad = 1
  end if

  call DaClos(LuGrad)
  call mma_deallocate(i_grad)
  call mma_deallocate(i_nac)

end if
if (Read_Grad <= 0) call FZero(Grad,nGrad)

end function Read_Grad

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               1986, Margareta R. A. Blomberg                         *
!***********************************************************************

subroutine NEXT(P,DPS,CN)

use cpf_global, only: IADDP, IPRINT, ITPUL, Lu_CI, NCONF
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: P(*), DPS(*)
real(kind=wp), intent(in) :: CN(*)
integer(kind=iwp) :: I, IAD, IIN, ITM, J
real(kind=wp) :: CTOT

IAD = IADDP(1)
call dDAFILE(Lu_CI,2,P,NCONF,IAD)
ITM = ITPUL-1
do I=1,ITM
  IIN = I+1
  CTOT = Zero
  do J=IIN,ITPUL
    CTOT = CTOT+CN(J)
  end do
  IAD = IADDP(I+1)
  call dDAFILE(Lu_CI,2,DPS,NCONF,IAD)
  P(1:NCONF) = P(1:NCONF)+CTOT*DPS(1:NCONF)
end do
if (IPRINT >= 15) write(u6,19) (P(I),I=1,NCONF)

return

19 format(6X,'C(NEXT)',5F10.6)

end subroutine NEXT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module mma_module

use, intrinsic :: iso_c_binding, only: c_char, c_ptr
use Definitions, only: wp, iwp, MOLCAS_C_INT

implicit none
private

logical(kind=iwp) :: MemStat = .false.

! Fortran interfaces for C functions

interface

  function allocmem(size_) bind(C,name='allocmem_')
    import :: MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: allocmem
    integer(kind=MOLCAS_C_INT), intent(out) :: size_
  end function allocmem

  function c_getmem(name_,Op,dtyp,offset,len_) bind(C,name='c_getmem_')
    import :: c_char, MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: c_getmem
    character(kind=c_char), intent(in) :: name_(*), Op(*), dtyp(*)
    integer(kind=MOLCAS_C_INT), intent(inout) :: offset
    integer(kind=MOLCAS_C_INT), intent(in) :: len_
  end function c_getmem

  function cptr2woff(ptr) bind(C,name='cptr2woff_')
    import :: c_ptr, MOLCAS_C_INT
    integer(kind=MOLCAS_C_INT) :: cptr2woff
    type(c_ptr), value, intent(in) :: ptr
  end function cptr2woff

  function woff2cptr(offset) bind(C,name='woff2cptr_')
    import :: c_ptr, MOLCAS_C_INT
    type(c_ptr) :: woff2cptr
    integer(kind=MOLCAS_C_INT), value, intent(in) :: offset
  end function woff2cptr

end interface

public :: allocmem, c_getmem, cptr2woff, MemStat
#ifdef _GARBLE_
public :: garble

contains

subroutine garble(ipos,length,vartyp)

  use, intrinsic :: iso_c_binding, only: c_f_pointer
# ifdef _FPE_TRAP_
  use, intrinsic :: IEEE_Arithmetic, only: IEEE_signaling_NaN, IEEE_value
# endif
  use Definitions, only: byte, RtoB

  integer(kind=iwp), intent(in) :: ipos, length
  character(len=*), intent(in) :: vartyp
  integer(kind=iwp) :: ioff1, ioff2, foff1
  type(c_ptr) :: cptr
  integer(kind=iwp), pointer :: ibuf(:)
  integer(kind=byte), pointer :: i1buf(:)
  real(kind=wp), pointer :: rbuf(:)
  integer(kind=iwp), parameter :: igarbage = huge(igarbage)
  integer(kind=byte), parameter :: i1garbage = huge(i1garbage)
# ifndef _FPE_TRAP_
  real(kind=wp), parameter :: dgarbage = huge(dgarbage)
# else
  real(kind=wp) :: dgarbage

  dgarbage = IEEE_value(dgarbage,IEEE_signaling_NaN)
# endif

  ! Here we overwrite the underlying memory, using C pointers
  ! Do not try this at home!

  select case (vartyp)
    case ('REAL')
      cptr = woff2cptr(ipos-1)
      call c_f_pointer(cptr,rbuf,[length])
      rbuf(1:length) = dgarbage
      nullify(rbuf)
    case ('INTE')
      cptr = woff2cptr(ipos-1)
      call c_f_pointer(cptr,ibuf,[length])
      ibuf(1:length) = igarbage
      nullify(ibuf)
    case ('CHAR')
      ioff1 = (ipos-1)/RtoB+1
      ioff2 = mod(ipos-1,RtoB)+1
      foff1 = (ipos+length-2)/RtoB+1
      cptr = woff2cptr(ipos-1)
      call c_f_pointer(cptr,i1buf,[(foff1-ioff1+1)*RtoB])
      i1buf(ioff2:ioff2+length-1) = i1garbage
      nullify(i1buf)
    case default
      call Abend()
  end select

end subroutine garble

#endif

end module mma_module

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine UrobTau (Tau,NaGrp,LunTau)
c
c       vyraba subor LunTau so simulovanymi Tau amplitudami
c       so spravnou strukturou
c
        implicit none
#include "chcc1.fh"
c@@     include 'o2v4.fh' stare
#include "o3v3.fh"
c
        integer NaGrp,LunTau
        real*8 Tau(1)
c
c       help variables
        integer length
        integer aGrp,bGrp
c
c
c1      cycle over Groups a,b
c
        do aGrp=1,NaGrp
        do bGrp=1,aGrp
c
c1.1    def legth
c
        if (aGrp.eq.bGrp) then
c       groups of a and b are equal, reading for a'>=b'
          length=no*no*DimGrpv(aGrp)*(DimGrpv(bGrp)+1)/2
        else
c       aGrp>bGrp, reading for a',b' in given groups
          length=no*no*DimGrpv(aGrp)*DimGrpv(bGrp)
        end if
c
c
c1.2    full Tau with random numbers
c
        call RNFill (length,Tau(1),1.0d-2)
c
c1.3    read block
c
        write (6,*) aGrp,bGrp,length
        call wri_chcc (lunTau,length,Tau(1))
c
        end do
        end do
c
c
c2      rewind file
        rewind (LunTau)
c
        return
        end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine tv_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)
      dsq3=1.732050807568877d0
      iltype =3
      irtype =1
      w0_d48=0.0d0
      w1_d48=dsq3

      idisk_lp=idisk_array(6)

      do lpblock=1,lpblock_tv
        call read_lp()
        ipael=iml+9
        ipae=1
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
c        jmlr=mul_tab(jml,jmr)
        if(linelp.le.12)   then
          call tv_ext_head_in_act()
        else
          call tv_ext_head_in_dbl()
        endif
      enddo
      return
      end

      subroutine tv_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.true.
      isma=iml
      lpok=jpadlr
      jmlr=mul_tab(jml,jmr)
      goto(10,10,10,10,10,106,10,108,10,110,10,10,
     :     113,10,115,10,117,118,10,10,10,10,123,124,10,10),lpok
!=======================================================
!sd1(8) ar- act -br-
108   if(linelp.ne.18) return
      lra=nlg1
      call sdd_ar_act_br_sgt0(17,lra)
      return
!=======================================================
!t1d1(15) ar- act -br-
115   if(linelp.ne.18) return
      lra=nlg1
      call ttdd_ar_act_br_sgt1(17,lra)
      return
!=======================================================
!t1v(18) ar-br- act -c"-
118   if(linelp.ne.14.or.nlg2.ne.2) return
      call ttv_arbr_act_c_stv_sgt1(17)
      return
!=================================================
!d1v(24-1) ar- act -br-
124   if(linelp.ne.18) return
      lra=nlg1
      call d1v_ar_act_bl_ext_ab_sgt0(17,lra)
      return
!=======================================================
!sd(6-1) ar(02)-    act: -b&r-  ext tv: -b^r-a^r
!sd(6-2) c(22)-ar(13)-
!sd(6-3) ar(13)-c'(22)-
!sd(6-4) ar(23)-c'(12)-
106   if(linelp.ne.18) return
      lra=nlg1
      if(jb_sys.gt.0) call sd_ar_act_br_sgt0(17,lra)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1=w0_sd(1)
        w0sd2=w0_sd(2)
        w0sd4=w0_sd(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0sd1=-w0sd1
        if(ni.eq.1) w0sd2=-w0sd2
        if(ni.eq.1) w0sd4=-w0sd4
!sd(6-1) ar(02)-         act: -br-  ext tv: -br-ar
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_tv_ext_br_ar(lri,lra)
        endif

!sd(6-2) c(22)-ar(13)-
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
        enddo
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_tv_ext_br_ar(lri,lra)
        enddo
!sd(6-4)   ar(23)-c'(12)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_tv_ext_br_ar(lri,lra)
        enddo
      enddo
      goto 10
!td(13-1) (22)-ar(23)-         act: -b&r-  ext tv: -br-ar
!td(13-2) ar(23)-c'(22)-
113   if(linelp.ne.18) return
      lra=nlg1
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_td(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
!td(13-1) (22)-ar(23)-        act: -br-  ext tv: -br-ar
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)     !
          iwdr=jud(lrk)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_tv_ext_br_ar(lri,lra)
        enddo
!td(13-1)   ar(23)-c'(22)-
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)    !
          iwdr=jud(lrk)
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_tv_ext_br_ar(lri,lra)
        enddo
      enddo
      goto 10
!=======================================================================
!dv(23-1)  ar(23)-    act: -b&r-  ext tv: -br-ar
123   if(linelp.ne.18) return
      lra=nlg1
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle
        iwdl=jud(lri)
        iwdr=0
        ni=mod(norb_dz-lri,2)
        w0=w0_dv(1)
        if(ni.eq.1) w0=-w0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_br_tv_ext_br_ar(lri,lra)
      enddo
      goto 10
!=======================================================================
!sv(10-1) ar(13)br(23)  act -c"-  tv_ext -br-ar
!sv(10-2) ar(23)br(13)  act -c"-  tv_ext -br-ar
!sv(10-3) dr(03)        act -c"-  tv_ext -br-ar
110   if(linelp.ne.14.or.nlg2.ne.2) return
      if(jb_sys.gt.0) then
        call sv_arbr_act_c_ext_stv_sgt0(17)
      endif
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
!-------------------------------------------------------------------
          w0sv2=w0_sv(2)
          w1sv2=w1_sv(2)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0sv2=-w0sv2
            w1sv2=-w1sv2
         endif
          iwdl=just(lri,lrj)
          iwdr=0
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lri.ne.lrj) then
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sv2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sv2
            enddo
            call ar_br_tv_ext_br_ar(lri,lrj)
          else
!sv(10-3) dr(03)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_sv(3)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_sv(3)
            enddo
            call drr_tv_ext_br_ar(lri)
          endif
        enddo
      enddo
      goto 10
!=======================================================================
!tv(17) ar(23)br(23) act -c"- tv_ext -br-ar
117   if(linelp.ne.14.or.nlg2.ne.2) return
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
!-------------------------------------------------------------------
          iwdl=just(lri,lrj)     !
          iwdr=0
          ni=mod(lrj-lri,2)
          w1=w1_tv
          if(ni.eq.0) w1=-w1
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_tv_ext_br_ar(lri,lrj)
        enddo
      enddo
      goto 10
!=======================================================================
10    return
      end

      subroutine tv_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.false.
      lri=nlg1
      lrj=nlg2
      intpos=nlg1
      isma=iml

      if(linelp.eq.3) then
!line=3 a&r--b&r<-->b^r-a^r
        lrai=nlg1
        lraj=nlg2
        call ar_br_tv_ext_br_ar(lrai,lraj)
      endif
      if(linelp.eq.8) then
!line=8 d&rr<-->b^r-a^r
        lra=nlg1
        call drr_tv_ext_br_ar(lra)
      endif
       return
      end

      subroutine sv_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)
      dsq2=1.414213562373095d0
      w0_d33=1.0d0
      w0_d37=-dsq2
      w0g36a=-1.d0
      w1g36a=0.d0
      w0g13a=-dsq2
      w1g13a=-dsq2

c      iltype =4
c      irtype =1
      logic_g36a=.true.
      logic_g13=.false.


      idisk_lp=idisk_array(10)

      do lpblock=1,lpblock_sv
        call read_lp()
        ipael=iml+17
        ipae=1
        if ( iml.eq.1)logic_g13=.true.
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
c        jmlr=mul_tab(jml,jmr)
        if(linelp.le.12)   then
          call sv_ext_head_in_act()
        else
          call sv_ext_head_in_dbl()
        endif
      enddo
      return
      end

      subroutine sv_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.true.
      isma=iml
      lpok=jpadlr
      jmlr=mul_tab(jml,jmr)
!      goto(10,10,10,10,10,106,10,10,10,110,10,10,
!     :     113,10,10,10,117,10,10,10,10,10,123,10,10,10),lpok
      goto(10,10,10,10,10,106,10,108,10,110,10,10,
     :     113,10,115,10,117,118,10,10,10,10,123,124,10,10),lpok
!=======================================================
!sd1(8) ar- act -br-
108   if(linelp.ne.18) return
      lra=nlg1
      call sdd_ar_act_br_sgt0(10,lra)
      return
!=======================================================
!t1d1(15) ar- act -br-
115   if(linelp.ne.18) return
      lra=nlg1
      call ttdd_ar_act_br_sgt1(10,lra)
      return
!=======================================================
!t1v(18) ar-br- act -c"-
118   if(linelp.ne.14) return
      call ttv_arbr_act_c_stv_sgt1(10)
      return
!=================================================
!d1v(24-1) ar- act -br-
124   if(linelp.ne.18) return
      lra=nlg1
      call d1v_ar_act_bl_ext_ab_sgt0(10,lra)
      return
!sd(6-1) ar(02)-    act: -b&r-  ext tv: -b^r-a^r
!sd(6-2) c(22)-ar(13)-
!sd(6-3) ar(13)-c'(22)-
!sd(6-4) ar(23)-c'(12)-
106   if(linelp.ne.18) return
      lra=nlg1
      if(jb_sys.gt.0) call sd_ar_act_br_sgt0(10,lra)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1=w0_sd(1)
        w0sd2=w0_sd(2)
        w0sd4=w0_sd(4)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0sd1=-w0sd1
        if(ni.eq.1) w0sd2=-w0sd2
        if(ni.eq.1) w0sd4=-w0sd4
!sd(6-1) ar(02)-         act: -br-  ext tv: -br-ar
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_sv_ext_br_ar(lri,lra)
        endif

!sd(6-2) c(22)-ar(13)-
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd2
        enddo
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_sv_ext_br_ar(lri,lra)
        enddo
!sd(6-4)   ar(23)-c'(12)-
        do mpl=1,mtype
          vplp_w0(mpl)=-vplpnew_w0(mpl)*w0sd4
          vplp_w1(mpl)=-vplpnew_w1(mpl)*w0sd4
        enddo
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)
          iwdr=jud(lrk)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_sv_ext_br_ar(lri,lra)
        enddo
      enddo
      goto 10
!td(13-1) (22)-ar(23)-         act: -b&r-  ext tv: -br-ar
!td(13-2) ar(23)-c'(22)-
113   if(linelp.ne.18) return
      lra=nlg1
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0td1=w0_td(1)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0td1=-w0td1
!td(13-1) (22)-ar(23)-        act: -br-  ext tv: -br-ar
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lrk,lri)    !
          iwdr=jud(lrk)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0td1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_sv_ext_br_ar(lri,lra)
        enddo
!td(13-1)   ar(23)-c'(22)-
        do lrk=lri+1,norb_dz
          lmk=lsm_inn(lrk)
          if(lmk.ne.jmr) cycle
          iwdl=just(lri,lrk)     !
          iwdr=jud(lrk)
          do mpl=1,mtype
            vplp_w0(mpl)=-vplpnew_w0(mpl)*w0td1
            vplp_w1(mpl)=-vplpnew_w1(mpl)*w0td1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_sv_ext_br_ar(lri,lra)
        enddo
      enddo
      goto 10
!=======================================================================
!dv(23-1)  ar(23)-    act: -b&r-  ext tv: -br-ar
123   if(linelp.ne.18) return
      lra=nlg1
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jml) cycle
        iwdl=jud(lri)
        iwdr=0
        ni=mod(norb_dz-lri,2)
        w0=w0_dv(1)
        if(ni.eq.1) w0=-w0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_br_sv_ext_br_ar(lri,lra)
      enddo
      goto 10
!=======================================================================
!sv(10-1) ar(13)br(23)  act -c"-  tv_ext -br-ar
!sv(10-2) ar(23)br(13)  act -c"-  tv_ext -br-ar
!sv(10-1) dr(03)        act -c"-  tv_ext -br-ar
110   if(linelp.ne.14.or.nlg2.ne.2) return
      if(jb_sys.gt.0) then
        call sv_arbr_act_c_ext_stv_sgt0(10)
      endif
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
         if(lmij.ne.jmlr) cycle
!-------------------------------------------------------------------
          w0sv2=w0_sv(2)
          w1sv2=w1_sv(2)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0sv2=-w0sv2
            w1sv2=-w1sv2
         endif
          iwdl=just(lri,lrj)
          iwdr=0
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          if(lri.ne.lrj) then
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sv2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sv2
            enddo
            call ar_br_sv_ext_br_ar(lri,lrj)
          else
!sv(10-1) dr(03)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_sv(3)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_sv(3)
            enddo
            call drr_sv_ext_br_ar(lri)
          endif
        enddo
      enddo
      goto 10
!=======================================================================
!tv(17) ar(23)br(23) act -c"- tv_ext -br-ar
117   if(linelp.ne.14.or.nlg2.ne.2) return
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jmlr) cycle
!-------------------------------------------------------------------
          iwdl=just(lri,lrj)     !
          iwdr=0
          ni=mod(lrj-lri,2)
          w1=w1_tv
          if(ni.eq.0) w1=-w1
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          call ar_br_sv_ext_br_ar(lri,lrj)
        enddo
      enddo
      goto 10
!=======================================================================
10    return
      end

      subroutine sv_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.false.
      lri=nlg1
      lrj=nlg2
      intpos=nlg1
      isma=iml

      if(linelp.eq.3) then
!line=3 a&r--b&r<-->b^r-a^r
        lrai=nlg1
        lraj=nlg2
        call ar_br_sv_ext_br_ar(lrai,lraj)
      endif
      if(linelp.eq.8) then
!line=8 d&rr<-->b^r-a^r
        lra=nlg1
        call drr_sv_ext_br_ar(lra)
      endif
       return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
MODULE fmm_scale_T_buffer

   USE fmm_stats
   USE fmm_global_paras

   IMPLICIT NONE
   PRIVATE
   ! public procedures
   PUBLIC :: fmm_init_scale_T_buffer,    &
             fmm_free_scale_T_buffer,    &
             fmm_scale_T_buffer_add

   INTEGER(INTK), PARAMETER :: BUFFER_SIZE = 500000
   ! module wide variables
   TYPE(T_pair_batch), SAVE :: T_pair_buffer

CONTAINS

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_init_scale_T_buffer

      IMPLICIT NONE

      NULLIFY (T_pair_buffer%items)
      ALLOCATE (T_pair_buffer%items(BUFFER_SIZE))
      T_pair_buffer%ndim = 0

   END SUBROUTINE fmm_init_scale_T_buffer

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_free_scale_T_buffer(T_contractor)

      IMPLICIT NONE
      EXTERNAL T_contractor

      IF (.NOT.ASSOCIATED(T_pair_buffer%items))  &
         CALL fmm_quit('T_pair_buffer not alloc.')
      IF ( T_pair_buffer%ndim /= 0 ) THEN
         CALL expunge_scale_buffer(T_contractor)
         T_pair_buffer%ndim = 0
      END IF
      DEALLOCATE (T_pair_buffer%items)
      NULLIFY (T_pair_buffer%items)

   END SUBROUTINE fmm_free_scale_T_buffer

!-------------------------------------------------------------------------------

   SUBROUTINE fmm_scale_T_buffer_add(T_contractor,T_pair)

      IMPLICIT NONE
      TYPE(T_pair_single), INTENT(IN) :: T_pair
      EXTERNAL T_contractor
      REAL(REALK) :: ratio

      stat_tpack_total = stat_tpack_total + one
      T_pair_buffer%ndim = T_pair_buffer%ndim +1
      T_pair_buffer%items(T_pair_buffer%ndim) = T_pair

      ! normalise T-vectors held in buffer for sorting purposes
      ratio = SQRT(SUM(T_pair%r_ab*T_pair%r_ab))
      ! we sort wrt x-axis first, and we want opposite vectors to be together
      IF (T_pair%r_ab(1) < zero) ratio = -ratio
      T_pair_buffer%items(T_pair_buffer%ndim)%paras%ratio = ratio
      T_pair_buffer%items(T_pair_buffer%ndim)%r_ab = T_pair%r_ab/ratio

      IF ( T_pair_buffer%ndim == BUFFER_SIZE ) THEN
         ! sort the buffer and pass all T-pairs to contractor
         CALL expunge_scale_buffer(T_contractor)
      END IF

   END SUBROUTINE fmm_scale_T_buffer_add

!-------------------------------------------------------------------------------

   SUBROUTINE expunge_scale_buffer(T_contractor)

      USE fmm_sort_T_pairs, ONLY: fmm_quicksort_wrt_vector,     &
                                  fmm_quicksort_wrt_ratio

      IMPLICIT NONE
      EXTERNAL T_contractor

      TYPE(T_pair_batch) :: ptr, ptr2
      INTEGER(INTK) :: i, lo, hi
      REAL(REALK)   :: q1,q2

      ptr%ndim = MIN(BUFFER_SIZE,T_pair_buffer%ndim)
      ptr%items => T_pair_buffer%items(1:ptr%ndim)

      ! recursively sort wrt T-vectors, starting with x-component
      CALL sort_wrt_axis(1_INTK,ptr%items)

      ! expunge in batches of the same T-vector direction
      lo = 1
      DO i = 2, ptr%ndim
         q1 = ptr%items(i)%r_ab(1)
         q2 = ptr%items(i-1)%r_ab(1)
         IF (q1 == q2) THEN
            q1 = ptr%items(i)%r_ab(2)
            q2 = ptr%items(i-1)%r_ab(2)
            IF (q1 == q2) THEN
               q1 = ptr%items(i)%r_ab(3)
               q2 = ptr%items(i-1)%r_ab(3)
               IF (q1 == q2) CYCLE
            END IF
         END IF
         hi = i-1
         ptr2%ndim = hi-lo+1
         ptr2%items => ptr%items(lo:hi)
         stat_tpack_unique = stat_tpack_unique + one
         CALL T_contractor(ptr2)
         lo = i
      END DO

      ! finally do last batch
      hi = ptr%ndim
      ptr2%ndim = hi-lo+1
      ptr2%items => ptr%items(lo:hi)
      stat_tpack_unique = stat_tpack_unique + one
      CALL T_contractor(ptr2)

      T_pair_buffer%ndim = 0
      stat_tpack_chunks = stat_tpack_chunks + one

   CONTAINS

!-------------------------------------------------------------------------------

      RECURSIVE SUBROUTINE sort_wrt_axis(xyz,items)

         IMPLICIT NONE
         INTEGER(INTK),       INTENT(IN)    :: xyz
         TYPE(T_pair_single), INTENT(INOUT) :: items(:)

         INTEGER(INTK) :: i, lo, hi
         REAL(REALK)   :: q1,q2

         IF (SIZE(items) == 1) RETURN

         ! sort only if needed
         q1 = items(1)%r_ab(xyz)
         DO i = 2, SIZE(items)
            q2 = items(i)%r_ab(xyz)
            IF ( q2 < q1 ) THEN
               CALL fmm_quicksort_wrt_vector(items,xyz)
               EXIT
            END IF
            q1 = q2
         END DO

         ! sub-sort next T-vector component
         lo = 1
         DO i = 2, SIZE(items)
            q1 = items(i-1)%r_ab(xyz)
            q2 = items(i)%r_ab(xyz)
            IF ( q2 /= q1 ) THEN
               hi = i-1
               IF (xyz == 3) THEN
                  CALL fmm_quicksort_wrt_ratio(items(lo:hi))
                  RETURN
               ELSE
                  CALL sort_wrt_axis(xyz+1_INTK,items(lo:hi))
               END IF
               lo = i
            END IF
         END DO

         ! do last batch
         hi = SIZE(items)
         IF (xyz == 3) THEN
            CALL fmm_quicksort_wrt_ratio(items(lo:hi))
            RETURN
         ELSE
            CALL sort_wrt_axis(xyz+1_INTK,items(lo:hi))
         END IF

      END SUBROUTINE sort_wrt_axis

!-------------------------------------------------------------------------------

   END SUBROUTINE expunge_scale_buffer

!-------------------------------------------------------------------------------

END MODULE fmm_scale_T_buffer

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Roland Lindh                                     *
!***********************************************************************

subroutine Cnthlf_mck(Coeff1,nCntr1,nPrm1,Coeff2,nCntr2,nPrm2,nZeta,lZeta,nVec,First,IncVec,A1,A2,A3,Indij)
!***********************************************************************
!                                                                      *
! Object: to do a half transformation. The loop over the two matrix-   *
!         matrix multiplications is segmented such that the end of the *
!         intermediate matrix will not push the start of the same out  *
!         from the cache.                                              *
!                                                                      *
! Author:     Roland Lindh, Dept. of Theoretical Chemistry, University *
!             of Lund, SWEDEN.                                         *
!***********************************************************************

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nCntr1, nPrm1, nCntr2, nPrm2, nZeta, lZeta, nVec, IncVec, Indij(nZeta)
real(kind=wp), intent(in) :: Coeff1(nPrm1,nCntr1), Coeff2(nPrm2,nCntr2), A1(lZeta,nVec)
logical(kind=iwp), intent(in) :: First
real(kind=wp), intent(out) :: A2(nPrm2,IncVec*nCntr1)
real(kind=wp), intent(inout) :: A3(nVec,nCntr1,nCntr2)
integer(kind=iwp) :: iCntr1, iCntr2, iiVec, ijVec, iPrm1, iPrm2, iZeta, jZeta, mVec
logical(kind=iwp) :: Seg1, Seg2

! Check if the basis set is segmented

Seg1 = .false.
loop1: do iPrm1=nPrm1,1,-1
  do iCntr1=nCntr1,1,-1
    if (Coeff1(iPrm1,iCntr1) == Zero) then
      Seg1 = .true.
      exit loop1
    end if
  end do
end do loop1

Seg2 = .false.
loop2: do iPrm2=nPrm2,1,-1
  do iCntr2=nCntr2,1,-1
    if (Coeff2(iPrm2,iCntr2) == Zero) then
      Seg2 = .true.
      exit loop2
    end if
  end do
end do loop2

! Set output matrix to zero

if (First) A3(:,:,:) = Zero

! Loop sectioning

do iiVec=1,nVec,IncVec
  mVec = min(IncVec,nVec-iiVec+1)
  ! Set intermediate matrix to zero
  A2(:,1:nCntr1*mVec) = Zero

  if (Seg1) then

    ! First quarter transformation

    do iPrm1=1,nPrm1
      do iCntr1=1,nCntr1
        ijVec = mVec*(iCntr1-1)+1
        ! Check for zero due to segmented basis
        if (abs(Coeff1(iPrm1,iCntr1)) > Zero) then
          do iPrm2=1,nPrm2
            iZeta = (iPrm2-1)*nPrm1+iPrm1
            jZeta = Indij(iZeta)
            ! Skip due to screening
            if (jZeta > 0) then
              A2(iPrm2,ijVec:ijVec+mVec-1) = A2(iPrm2,ijVec:ijVec+mVec-1)+Coeff1(iPrm1,iCntr1)*A1(jZeta,iiVec:iiVec+mVec-1)
            end if
          end do
        end if
      end do
    end do

  else

    ! First quarter transformation

    do iPrm1=1,nPrm1
      do iCntr1=1,nCntr1
        ijVec = mVec*(iCntr1-1)+1
        do iPrm2=1,nPrm2
          iZeta = (iPrm2-1)*nPrm1+iPrm1
          jZeta = Indij(iZeta)
          ! Skip due to screening
          if (jZeta > 0) then
            A2(iPrm2,ijVec:ijVec+mVec-1) = A2(iPrm2,ijVec:ijVec+mVec-1)+Coeff1(iPrm1,iCntr1)*A1(jZeta,iiVec:iiVec+mVec-1)
          end if
        end do
      end do
    end do

  end if

  if (Seg2) then

    ! Second quarter transformation

    do iPrm2=1,nPrm2
      do iCntr2=1,nCntr2
        ! Check for zero due to segmented basis
        if (abs(Coeff2(iPrm2,iCntr2)) > Zero) then
          do iCntr1=1,nCntr1
            ijVec = mVec*(iCntr1-1)+1
            A3(iiVec:iiVec+mVec-1,iCntr1,iCntr2) = A3(iiVec:iiVec+mVec-1,iCntr1,iCntr2)+ &
                                                   Coeff2(iPrm2,iCntr2)*A2(iPrm2,ijVec:ijVec+mVec-1)
          end do
        end if
      end do
    end do

  else

    ! Second quarter transformation

    do iPrm2=1,nPrm2
      do iCntr2=1,nCntr2
        do iCntr1=1,nCntr1
          ijVec = mVec*(iCntr1-1)+1
          A3(iiVec:iiVec+mVec-1,iCntr1,iCntr2) = A3(iiVec:iiVec+mVec-1,iCntr1,iCntr2)+ &
                                                 Coeff2(iPrm2,iCntr2)*A2(iPrm2,ijVec:ijVec+mVec-1)
        end do
      end do
    end do

  end if

  ! End of loop sectioning

end do

return

end subroutine Cnthlf_mck

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine dWBuf(Array,nArray)
      Use dEAF
      Use IOBUF
      Implicit Real*8 (a-h,o-z)
#include "SysDef.fh"
      Real*8 Array(nArray)
*
*     Write (6,*) 'Enter WBuf: iPos @',iPos,' iBuf,lBuf=',iBuf,lBuf
      If (InCore.and.iBuf.eq.2) Then
         Call WarningMessage(2,
     &               'Error in in-core semi-direct implementation')
         Call Abend()
      End If
      IODone=.True.
      iArray = 1
      mArray=nArray
10       Left = lBuf-iPos+1
         If (mArray.gt.Left) Then
            Call dCopy_(Left,Array(iArray),1,Buffer(iPos,iBuf),1)
            iArray=iArray+Left
            mArray=mArray-Left
            iPos=1
*
*---------- Wait for previous buffer to complete I/O.
*           Disk=32 after writing the control!
*
            If (Disk.ne.32.0D0.and.OnDisk) Then
*              Write (6,*) 'In dwbuf'
               Call EAFWait(LuTmp,id)
            End If
*
*---------- Put current buffer on disk and change buffer.
*
            temp=Disk+DBLE(lBuf*RtoB)
*           Write (6,*) 'temp=',temp
            If (temp.le.DiskMx_Byte) Then
               Disk_2 = Disk_1
               Disk_1 = Disk
c              Write (6,*) 'WBuf write on disk @',Disk,'iBuf=',iBuf
               If (OnDisk) Then
*                 Write (6,*) 'In dwbuf'
                  Call dEAFAWrite(LuTmp,Buffer(1,iBuf),
     &                            lBuf*RtoI,Disk,id)
               End If
               If (iBuf.eq.1) Then
                  iBuf = 2
               Else
                  iBuf = 1
               End If
            Else
               Call WarningMessage(2,'WBuf: Disc is full!!')
               Call Abend()
            End If
         Else
*           Write (6,*) ' Add ',mArray,'elements to buffer',iPos,ibuf
            Call dCopy_(mArray,Array(iArray),1,Buffer(iPos,iBuf),1)
            iPos=iPos+mArray
            mArray=0
         End If
      If(mArray.gt.0) goto 10
*
*     Write (6,*) 'Exit WBuf: iPos @',iPos,'iBuf=',iBuf
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine mkstrtgs_cvb(orbsao,irdorbs,cvb,recn,kbasis1)
      implicit real*8 (a-h,o-z)
      logical use_ao,ifmos_cvb
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
#include "mo_cvb.fh"
      dimension orbsao(nbas_mo,norb),irdorbs(norb),cvb(*)

      call rdheader_cvb(recn,norb1,nbas_mo1,nvb1,kbasiscvb,
     >  ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)
      use_ao=(ifmos_cvb().and.((.not.variat).or.(variat.and.
     >  nmcscf.eq.1)).and.nbas_mo.eq.nbas_mo1.and.ioffs_orbsao.gt.0)
      do 100 iorb=1,norb
      if(.not.use_ao)then
        irdorbs(iorb)=1
        call rdgspr_cvb(recn,orbsao(1,iorb),iorb,norb,1,ierr)
      else
        irdorbs(iorb)=2
        call rdgspr_cvb(recn,orbsao(1,iorb),iorb,nbas_mo,3,ierr)
      endif
      if(ierr.ne.0)then
        call prtfid_cvb(' Error in orbital read from ',recn)
        write(6,'(a)')     ' Orbital no :',iorb
        if(use_ao)then
          write(6,'(a)')     ' AO basis ? : Yes'
        else
          write(6,'(a)')     ' AO basis ? : No'
        endif
        call abend_cvb()
      endif
100   continue
      call rdgspr_cvb(recn,cvb,1,nvb,2,ierr)
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(kbasis1)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine T2d_div(T2,OE,dima,dimb,adda,addb,no,nv)
! this routine does:
! T2(a',b',i,j) = T2(a',b',i,j/(e(i)+e(j)-e(a)-e(b))
! for aGrp=beGrp, where only a'>=b',i,j are valid,
! and completed also cases a'<b',i,j
!
! division of T2n amplitides by denominator

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, adda, addb, no, nv
real(kind=wp), intent(inout) :: T2(dima,dimb,no,no)
real(kind=wp), intent(in) :: OE(no+nv)
integer(kind=iwp) :: a, av, b, bv, i, j

av = no+adda
bv = no+addb

!1 division by denominators

do j=1,no
  do i=1,no
    do a=1,dima
      T2(a,1:a,i,j) = T2(a,1:a,i,j)/(OE(i)+OE(j)-OE(av+a)-OE(bv+1:bv+a))
    end do
  end do
end do

!2 completing upper triangle

do j=1,no
  do i=1,no
    do b=2,dima
      T2(1:b-1,b,i,j) = T2(b,1:b-1,j,i)
    end do
  end do
end do

return

end subroutine T2d_div

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Per-Olof Widmark                                 *
*               1992, Markus P. Fuelscher                              *
*               1992, Piotr Borowski                                   *
*               2016,2017, Roland Lindh                                *
************************************************************************
      Subroutine R1IntB
************************************************************************
*                                                                      *
*     purpose: Read basis set informations and one electron integrals  *
*              were not needed so far.                                 *
*                                                                      *
*     called from: PrFin                                               *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     P.O. Widmark, M.P. Fuelscher and P. Borowski                     *
*     University of Lund, Sweden, 1992                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Use SCF_Arrays
      Implicit Real*8 (a-h,o-z)
#include "mxdm.fh"
#include "infscf.fh"
#include "stdalloc.fh"
*
*---- Define local variables
      Character*8 Label
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
*
*---- Allocate memory for kinetic energy, mass velocity and darvin
*     integrals
*
      Call mma_allocate(KntE,nBT+4,Label='KntE')
      Call mma_allocate(MssVlc,nBT+4,Label='MssVlc')
      Call mma_allocate(Darwin,nBT+4,Label='Darwin')
*
*---- Read kinetic energy integrals
      iRc=-1
      iOpt=6
      iComp=1
      iSyLbl=1
      Label='Kinetic '
      Call RdOne(iRc,iOpt,Label,iComp,KntE,iSyLbl)
      If (iRc.ne.0) Then
         Write (6,*) 'R1Intb: Error readin ONEINT'
         Write (6,'(A,A)') 'Label=',Label
         Call Abend()
      End If
*
*---- Read mass velocity integrals
      lRel=.False.
      iRc=-1
      iOpt=6
      iComp=1
      iSyLbl=1
      Label='MassVel '
      Call RdOne(iRc,iOpt,Label,iComp,MssVlc,iSyLbl)
      If (iRc.ne.0) Go To 777
*
*---- Read Darvin integrals
      iRc=-1
      iOpt=6
      iComp=1
      iSyLbl=1
      Label='Darwin  '
      Call RdOne(iRc,iOpt,Label,iComp,Darwin,iSyLbl)
      If ( iRc.ne.0 ) Go To 777
      lRel=.True.
*
 777  Continue
      If (.Not.lRel) Then
         Call mma_deallocate(MssVlc)
         Call mma_deallocate(Darwin)
         Call mma_allocate(MssVlc,0,Label='MssVlc')
         Call mma_allocate(Darwin,0,Label='Darwin')
      End If
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Thermo_Vib(nFreq,Freq,T,nTR,iter)

use Constants, only: Zero, One, Half, auTokcalmol, auTokJ, cal_to_j, kBoltzmann, rNAVO
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nFreq, nTR, iter
real(kind=wp), intent(in) :: Freq(nFreq), T
integer(kind=iwp) :: i
real(kind=wp) :: beta, DeltaG, DeltaS, DeltaU, eta, q_vib, q_vib_Tot, U_TR, U_vib, U_vib_Tot, ZPVE
integer(kind=iwp), parameter :: First = 1
real(kind=wp), parameter :: rk = kBoltzmann*1.0e-3_wp/auTokJ, rk_kcalmol = kBoltzmann*rNAVO/(1.0e3_wp*cal_to_J)

!r_k = 1.38065800e-23_wp
!r_J2au = 2.29371049e17_wp ! Convert joules to atomic units
! Bolzmann's constant in a.u./ K
!rk = kBoltzmann*r_J2au
!write(u6,*) "Bolzmann's constant=",rK
if (T == Zero) then
  beta = 1.0e99_wp
else
  beta = One/(rk*T)
end if
!***********************************************************************
!                                                                      *
!      The Canonical partition function Q for indistinguishable        *
!      molecules                                                       *
!                                                                      *
!      is Q = q^N /N!, where N is the number of indistinguishable      *
!                                                                      *
!      molecules and q is the function with                            *
!                                                                      *
!      q = q_e * q_v * q_t * q_r                                       *
!                                                                      *
!      N = n * N_A (N_A is Avogrado's number) and the molecular        *
!                                                                      *
!      partition function is defined as q_m=q/n.                       *
!                                                                      *
!      We approximate q as follows                                     *
!                                                                      *
!      electronic:                                                     *
!      q_e=g_e (g_e is the degeneracy factor, for a singlet            *
!               ground state g_e=1, for a triplet ground state         *
!               g_e to a good approximation is 3, etc).                *
!                                                                      *
!      vibrational:                                                    *
!      q_v=q_v(1)*q_v(2)*...                                           *
!                                                                      *
!            q_v(i)= exp(-e(i)*beta/2) / (1-exp(-e(i)*beta))           *
!                                                                      *
!      translational:                                                  *
!      q_t=V/L^3, where L=(h^2 beta/2 pi m)^(1/2)                      *
!                                                                      *
!      d lnq_t/d beta = - 3kT/2                                        *
!                                                                      *
!      rotational: (high temperature approximations!)                  *
!      for linear systems                                              *
!      q_r=1/(beta sigma hc B) sigma=symmetry number                   *
!                                                                      *
!      d lnq_r/d beta = - 2kT/2                                        *
!                                                                      *
!      for nonlinear systems                                           *
!      q_r=(1/sigma)(1/(beta hc))^(3/2) (pi/ABC)^(1/2)                 *
!                                                                      *
!      d lnq_r/d beta = - 3kT/2                                        *
!                                                                      *
!      Some useful relations!                                          *
!                                                                      *
!      The internal energy:                                            *
!      U-U(0)=-(d lnQ/d beta)_V=-N(d lnq/d beta)_V                     *
!                                                                      *
!      Gibbs free energy:                                              *
!      G-G(0)=-nRT ln(q_m/N_A)                                         *
!                                                                      *
!      The enthalpy:                                                   *
!      H-H(0)=G-G(0)+T(S-S(0))                                         *
!                                                                      *
!            =-(d lnQ/d beta)_V + kTV(d lnQ/d V)_T                     *
!                                                                      *
!            =-N(d lnq/d beta)_V + NkTV(d lnQ/d V)_T                   *
!                                                                      *
!            =U-U(0)+pV                                                *
!                                                                      *
!      p=(NkT/q)(dq/dV)_T                                              *
!                                                                      *
!      since the translational part is the only which depends on the   *
!      volume we have that                                             *
!                                                                      *
!      H-H(0)=U-U(0)+NkT                                               *
!                                                                      *
!***********************************************************************

write(u6,*)
write(u6,*)
write(u6,'(A,F6.2,A)') ' Temperature = ',T,' kelvin'
write(u6,'(A)') ' ---------------------------'
write(u6,*)

! Iterate over vibrations, and compute the molecular
! partition functions of the vibrations

q_vib_Tot = One
ZPVE = Zero
U_vib_Tot = Zero
do i=1,nFreq
  eta = Freq(i)
  if (iter == first) write(u6,*) ' Vibrational temperature =',eta/rk
  if (eta > Zero) then
    ZPVE = ZPVE+eta*Half
    if (T == Zero) then
      q_vib = Zero
      U_vib = eta*Half
    else
      ! Eq. (6-20)
      q_vib = exp(-eta*beta*Half)/(One-exp(-eta*beta))
      U_vib = (eta*Half)+(eta/(exp(eta*beta)-One))
    end if
    q_vib_Tot = q_vib_Tot*q_vib
    U_vib_Tot = U_vib_Tot+U_vib
  end if
end do

! Add translational and rotational energy, kT*nTR/2,
! the classiscal limit is used.
!
! U-U(0)=-(d lnQ/d beta)_V, U(0)=0
!
! lnQ = N lnq - lnN!
!
! U-U(0)=-N(d lnq/d beta)_V

!r_J2kcalmol = 1.43932522e20_wp ! conversion J to kcal/mol
U_TR = real(nTR,kind=wp)*(T*rk_kcalmol*Half)

! G-G(0)=-kT lnQ + kTV(d lnQ /dV)_T, G(0)=0

if (T == Zero) then
  DeltaG = Zero
else
  DeltaG = -log(q_vib_Tot)*rk*T
end if

!auTokcalmol = 6.27509541e2_wp ! Conversion au to kcal/mol
DeltaG = DeltaG*auTokcalmol

DeltaU = U_vib_Tot*auTokcalmol
ZPVE = ZPVE*auTokcalmol
write(u6,'(A,F6.2,A)') '         DeltaG =',DeltaG,' kcal/mol'
write(u6,'(A,F6.2,A)') '           ZPVE =',ZPVE,' kcal/mol'
write(u6,'(A,F6.2,A)') '      TotDeltaU =',DeltaU,' kcal/mol'
write(u6,'(A,F6.2,A)') ' TotDeltaU-ZPVE =',DeltaU-ZPVE,' kcal/mol'

if (T > Zero) then
  DeltaS = 1.0e3_wp*(DeltaU-DeltaG)/T
else
  DeltaS = Zero
end if
write(u6,'(A,F8.4,A)') '      Entropy S =',DeltaS,' cal/(mol*K)'
write(u6,'(A,F8.4,A)') '         U(T&R) =',U_TR,' kcal/mol'
write(u6,'(A,F8.4,A)') '       Tot(temp)=',U_TR+DeltaU-ZPVE,' kcal/mol'

return

end subroutine Thermo_Vib

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1995, Anders Bernhardsson                              *
!***********************************************************************

subroutine TwoDns(ianga,iCmp,shijij,ishll,ishell,iAO,nop,iBasi,jBasj,kBask,lBasl,Aux,nAux,Work2,nWork2,Work3,nWork3,Work4,nWork4, &
                  PSO,nPSO,Fact)

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: Shells
use Real_Spherical, only: ipSph, RSph
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iAnga(4), iCmp(4), iShll(4), iShell(4), iAO(4), nOp(4), iBasi, jBasj, kBask, lBasl, nAux, nWork2, &
                                 nWork3, nWork4, nPSO
logical(kind=iwp), intent(in) :: Shijij
real(kind=wp), intent(out) :: Aux(nAux), Work2(nWork2), Work3(nWork3), Work4(nWork4)
real(kind=wp), intent(in) :: PSO(nPSO), Fact
integer(kind=iwp) :: iCmpa, ijklab, iShlla, jCmpb, jShllb, kCmpc, kShllc, la, lb, lc, lCmpd, ld, lShlld, mab, mcd, n, nijkl

nijkl = iBasi*jBasj*kBask*lBasl
iShlla = iShll(1)
jShllb = iShll(2)
kShllc = iShll(3)
lShlld = iShll(4)
la = iAnga(1)
lb = iAnga(2)
lc = iAnga(3)
ld = iAnga(4)
iCmpa = iCmp(1)
jCmpb = iCmp(2)
kCmpc = iCmp(3)
lCmpd = iCmp(4)
mab = nTri_Elem1(la)*nTri_Elem1(lb)
mcd = nTri_Elem1(lc)*nTri_Elem1(ld)

!----------------------------------------------------------------------*
!
! Fix the second order density matrix
!
!----------------------------------------------------------------------*

! Desymmetrize the second order density matrix

! (faA fbR(B) | fcT(C) fdTS(D))ijkl
! PSO->Work2

call DesymP(iAnga,iCmp(1),iCmp(2),iCmp(3),iCmp(4),Shijij,iShll,iShell,iAO,nOp,nijkl,Aux,nAux,Work2,PSO,nPSO)

if (Fact /= One) then
  n = nijkl*iCmp(1)*iCmp(2)*iCmp(3)*iCmp(4)
  Work2(1:n) = Fact*Work2(1:n)
end if

! Backtransform 2nd order density matrix from spherical
! harmonic gaussians to cartesian gaussians.

ijklab = nijkl*iCmp(1)*iCmp(2)
! Work2->Work2  (Work3:Scratch)
call SphCr1(Work2,ijklab,Work3,nWork3,RSph(ipSph(lc)),nTri_Elem1(lc),kCmpc,Shells(kShllc)%Transf,Shells(kShllc)%Prjct, &
            RSph(ipSph(ld)),nTri_Elem1(ld),lCmpd,Shells(lShlld)%Transf,Shells(lShlld)%Prjct,Work2,mcd)
! Work2->Work4  (Work3:Scratch)
call SphCr2(Work2,nijkl,mcd,Work3,nWork3,RSph(ipSph(la)),nTri_Elem1(la),iCmpa,Shells(iShlla)%Transf,Shells(iShlla)%Prjct, &
            RSph(ipSph(lb)),nTri_Elem1(lb),jCmpb,Shells(jShllb)%Transf,Shells(jShllb)%Prjct,Work4,mab)

!----------------------------------------------------------------------*

! P is now in cartesian AO base

return

end subroutine TwoDns

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Start_MCLR()
!***********************************************************************
!                                                                      *
!     Precompute whatever can be before starting the response section  *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri
use transform_procedures, only: SetUp_CASPT2_Tra
use MCLR_Data, only: CMO, CMO_Inv, FnMotra, FnQDat, FnTri1, INT1, LuHlf2, LuHlf3, LuMotra, LuQDat, LuTri1, LuTri2, nDens, SA
use input_mclr, only: ERASSCF, kPrint, LuAChoVec, LuChoInt, LuIChoVec, nAsh, nBas, nDel, NewCho, nFro, nIsh, nOrb, nSym, PT2, &
                      StepType, TwoStep
use PCM_grad, only: do_RF, PCM_grad_init, PCM_mod_ERASSCF, PrepPCM
use rctfld_module, only: iCharge_Ref, NonEQ_Ref, PCM
!use DWSol, only: DWSCF_init
use ISRotation, only: InvEne, InvSCF, InvSol
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, iComp, Indx, iOff, iOff1, iOff2, iOpt, iRC, iSeed, iSym, iSymLbl, iType, j, lSqrDens, lTriDens, nOrbBas
real(kind=wp) :: BufFrac
character(len=8) :: Label
character(len=5) :: Fname
real(kind=wp), allocatable :: Smat(:), STmat(:)
integer(kind=iwp), external :: IsFreeUnit
logical(kind=iwp), external :: RF_On

!----------------------------------------------------------------------*
!     start                                                            *
!----------------------------------------------------------------------*

!                                                                      *
!***********************************************************************
!                                                                      *
call setup_MCLR(1)

if ((StepType /= 'RUN2') .and. btest(kPrint,2)) write(u6,'(6X,A)') 'Transformation of integrals'
! For the mp2-gradient calculations we want the transformation
! routine to produce all integrals of the occupied and virtual
! orbitals so we tell it that the whole space is inactive and
! that the active is empty

! Use the driver from the CASPT2 code (only none-squared).

! re-direct the transformed integrals to the MOTRA file
! which is preserved at the end of the calculation.
! LuTri1 is deleted.
if (TwoStep) then
  LuTri1 = LuMOTRA
  FnTri1 = FnMOTRA
  call DaName_MF_wa(LuQDAT,FnQDAT)
end if

call DaName_MF_wa(LuTri1,FnTri1)

if (newCho) then

  ! Compute inverse CMO

  lSqrDens = sum(nBas(1:nSym)**2)
  nOrbBas = sum(nOrb(1:nSym)*nBas(1:nSym))
  lTriDens = 0
  do iSym=1,nSym
    lTriDens = lTriDens+nTri_Elem(nBas(iSym))
  end do
  call mma_allocate(STmat,lTriDens,Label='STmat')
  call mma_allocate(Smat,lSqrDens,Label='Smat')

  iSymlbl = 1
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  Label = 'Mltpl  0'
  iComp = 1
  call RdOne(irc,iOpt,Label,iComp,STmat,iSymlbl)

  Indx = 1
  iOff = 0
  do iSym=1,nSym
    do i=1,nBas(iSym)
      do j=1,i-1
        Smat(j+nBas(iSym)*(i-1)+iOff) = STmat(Indx)
        Smat(i+nBas(iSym)*(j-1)+iOff) = STmat(Indx)
        Indx = Indx+1
      end do
      Smat(i+nBas(iSym)*(i-1)+iOff) = STmat(Indx)
      Indx = Indx+1
    end do
    ioff = ioff+nBas(iSym)**2
  end do
  call mma_deallocate(STmat)

  call mma_allocate(CMO_inv,nOrbBas,Label='CMO_Inv')
  iOff1 = 1
  iOff2 = 1
  do iSym=1,nSym
    call dGemm_('T','N',nOrb(iSym),nBas(iSym),nBas(iSym),One,CMO(iOff2),nBas(iSym),Smat(iOff1),nBas(iSym),Zero,CMO_Inv(iOff2), &
                nOrb(iSym))

    iOff1 = iOff1+nBas(iSym)**2
    iOff2 = iOff2+nOrb(iSym)*nBas(iSym)
  end do

  call mma_deallocate(Smat)
end if

call SetUp_CASPT2_Tra(nSym,nBas,nOrb,nIsh,nAsh,nFro,nDel,CMO,nDens,LuTri1,LuTri2,LuHlf2,LuHlf3)
iType = 3  ! Means that TraCtl is called by MCLR

if ((.not. newCho) .and. (StepType /= 'RUN2')) call TraCtl_Drv(iType,.true.,1)

! fetch some data from existing file LuTri1
! (from a previous MCLR run)
! and make it available to the module intgrl
! (LuTRI1=LuMOTRA)
if (TwoStep .and. (StepType == 'RUN2')) call put_temp_data_on_intgrl(LuMOTRA,nSym,nOrb)

! Init Cholesky informations
if (NewCho) then
  BufFrac = 0.3_wp
  call Cho_X_Init(irc,BufFrac)
  iSeed = 10
  do i=1,nsym
    LuAChoVec(i) = IsFreeUnit(iSeed)
    iseed = LuAChoVec(i)+1
    write(Fname,'(A4,I1)') 'CHTA',i
    call DANAME_MF_WA(LuAChoVec(i),Fname)
  end do
  do i=1,nsym
    LuIChoVec(i) = IsFreeUnit(iSeed)
    iSeed = LuIChoVec(i)+1
    write(Fname,'(A4,I1)') 'CHTI',i
    call DANAME_MF_WA(LuIChoVec(i),Fname)
  end do
  LuChoInt(1) = IsFreeUnit(iSeed)
  write(Fname,'(A4)') 'CHIN'
  call DANAME_MF_WA(LuChoInt(1),Fname)
  LuChoInt(2) = IsFreeUnit(iSeed)
  write(Fname,'(A4)') 'CHTU'
  call DANAME_MF_WA(LuChoInt(2),Fname)
end if

call DaClos(LuTri2)
call DaClos(LuHlf2)
call DaClos(LuHlf3)

! initialize non-invariance flags (just in case)

InvEne = .true.
InvSCF = .true.
InvSol = .true.

! For dynamically weighted MCSCF
! if (SA .or. PT2) call DWSCF_init(2,nRoots)

! MCSCF with PCM
if (RF_On()) then
  if (NonEq_Ref) then
    call WarningMessage(2,'Error in MCLR')
    write(u6,*) 'NonEq=.true., invalid option'
    call Abend()
  end if
  call Init_RctFld(.false.,iCharge_Ref)
  if ((.not. SA) .and. (.not. PT2)) then ! only for SA-CASSCF grad
    call WarningMessage(2,'Error in MCLR')
    write(u6,*) 'PCM can be combined with SA-CASSCF or CASPT2 gradient only'
    call Abend()
  end if
  if (.not. PCM) then
    call WarningMessage(2,'Error in MCLR')
    write(u6,*) 'PCM-model must be used in RF-Input'
    call Abend()
  end if
  call PCM_grad_init()
  !! Construct INT1 with the correct PCM contributions
  call mma_deallocate(Int1)
  call PrepPCM()
  call InpOne()
  !! Modify ERASSCF so that they are made eigenvalues
  if (do_RF) call PCM_mod_ERASSCF(ERASSCF)
end if

call FckMat()
call StPert()

! With Cholesky there is no other choice than computing some
! integrals used for the preconditioner

if (NewCho) call cho_prec_mclr(CMO,nIsh,nASh,LuAChoVec,LuChoInt)

!----------------------------------------------------------------------*
!     exit                                                             *
!----------------------------------------------------------------------*

end subroutine Start_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine OutCtl(CMO,OCCN,SMAT,lOPTO)
************************************************************************
*                                                                      *
*     Control section for the final output                             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
#ifdef _DMRG_
!     module dependencies
      use qcmaquis_interface_cfg
      use qcmaquis_interface_environment, only: print_dmrg_info
#endif

      Implicit Real*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='OUTCTL  ')
#include "ciinfo.fh"
#include "rctfld.fh"
#include "WrkSpc.fh"
#include "stdalloc.fh"
#include "SysDef.fh"
#include "input_ras.fh"

      Character*8  Fmt2, Label
      Character*3 lIrrep(8)
      Character*80 Note
      Character*120 Line
#ifdef _ENABLE_CHEMPS2_DMRG_
      Character*3 SNAC
#endif
      Logical FullMlk, get_BasisType
      Logical Do_ESPF,lSave, lOPTO, Do_DM
      DIMENSION CMO(*),OCCN(*),SMAT(*)
      Dimension Temp(2,mxRoot)
      Real*8, Allocatable:: DSave(:)

** (SVC) added for new supsym vector input
*      DIMENSION NXSYM(mxOrb),nUND(mxOrb)

      Integer  Cho_X_GetTol
      External Cho_X_GetTol
#ifndef _DMRG_
      logical :: doDMRG = .false.
#else
      character(len=100) :: dmrg_start_guess
#endif
      Dimension Dum(1),iDum(56)
*----------------------------------------------------------------------*
*     Start and define the paper width                                 *
*----------------------------------------------------------------------*
C Local print level (if any)
      IPRLEV=IPRLOC(6)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF

* Additional DFT correlation energy, if any
      CASDFT_Funct=0.0d0
      If (KSDFT.ne.'SCF'.and.KSDFT.ne.'PAM') Then
          Call Get_dScalar('CASDFT energy',CASDFT_Funct)
      End If
*----------------------------------------------------------------------*
*     Initialize blank and header lines                                *
*----------------------------------------------------------------------*
      left=6
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'

      IF (IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
* Start of long if-block A over IPRLEV
*----------------------------------------------------------------------*
*     Print orbital and wavefunction specifications                    *
*----------------------------------------------------------------------*
      Write(LF,*)
      Line=''
      Write(Line(left-2:),'(A)') 'Wave function specifications:'
      Call CollapseOutput(1,Line)
      Write(LF,Fmt2//'A)')'-----------------------------'
      Write(LF,*)
      Write(LF,Fmt2//'A,T45,I6)')'Number of closed shell electrons',
     &                           2*NIN
      Write(LF,Fmt2//'A,T45,I6)')'Number of electrons in active shells',
     &                           NACTEL
      If(.not.iDoGas) then
        Write(LF,Fmt2//'A,T45,I6)')'Max number of holes in RAS1 space',
     &                           NHOLE1
        Write(LF,Fmt2//'A,T45,I6)')'Max nr of electrons in RAS3 space',
     &                           NELEC3
      End If
      Write(LF,Fmt2//'A,T45,I6)')'Number of inactive orbitals',
     &                           NIN
      Write(LF,Fmt2//'A,T45,I6)')'Number of active orbitals',
     &                           NAC
      Write(LF,Fmt2//'A,T45,I6)')'Number of secondary orbitals',
     &                           NSEC
      Write(LF,Fmt2//'A,T45,F6.1)')'Spin quantum number',
     &                           (DBLE(ISPIN-1))/2.0d0
      Write(LF,Fmt2//'A,T45,I6)')'State symmetry',
     &                           LSYM
      Call CollapseOutput(0,'Wave function specifications:')
*
      Call Get_cArray('Irreps',lIrrep,24)
      Do iSym = 1, nSym
         Call RightAd(lIrrep(iSym))
      End Do
*
      Write(LF,*)
      Line=''
      Write(Line(left-2:),'(A)') 'Orbital specifications:'
      Call CollapseOutput(1,Line)
      Write(LF,Fmt2//'A)')'-----------------------'
      Write(LF,*)
      Write(LF,Fmt2//'A,T47,8I4)') 'Symmetry species',
     &                            (iSym,iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8(1X,A))') '                ',
     &                            (lIrrep(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Frozen orbitals',
     &                            (nFro(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Inactive orbitals',
     &                            (nIsh(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Active orbitals',
     &                            (nAsh(iSym),iSym=1,nSym)
      IF(.not.iDoGas)then
        Write(LF,Fmt2//'A,T47,8I4)') 'RAS1 orbitals',
     &                            (nRs1(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'RAS2 orbitals',
     &                            (nRs2(iSym),iSym=1,nSym)
        Write(LF,Fmt2//'A,T47,8I4)') 'RAS3 orbitals',
     &                            (nRs3(iSym),iSym=1,nSym)
      Else
        DO IGAS=1,NGAS
          Write(LF,Fmt2//'A,I1,A,T47,8I4)') 'GAS',IGAS,' orbitals',
     &                            (ngssh(igas,iSym),iSym=1,nSym)
        END DO
      End If

      Write(LF,Fmt2//'A,T47,8I4)') 'Secondary orbitals',
     &                            (nSsh(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Deleted orbitals',
     &                            (nDel(iSym),iSym=1,nSym)
      Write(LF,Fmt2//'A,T47,8I4)') 'Number of basis functions',
     &                            (nBas(iSym),iSym=1,nSym)
      If (kIVO) Then
        Write(LF,Fmt2//'A,T47)') 'Improved Virtual Orbitals '//
     &                           'option is used'
        Write(LF,Fmt2//'A,T47)') 'Molecular Orbitals are NOT '//
     &                           'suitable for CASPT2 & MRCI!'
      End If
      Call CollapseOutput(0,'Orbital specifications:')
      Write(LF,*)

#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_
      If(.Not.DoBlockDMRG) GoTo 113

      Line=''
      Write(Line(left-2:),'(A)') 'DMRG sweep specifications:'
      Call CollapseOutput(1,Line)
      Write(LF,Fmt2//'A)')'--------------------------'
      Write(LF,*)
      Write(LF,Fmt2//'A,T45,I6)')'Number of renormalized basis',
     &                           MxDMRG
      Write(LF,Fmt2//'A,T45,I6)')'Number of root(s) required',
     &                           NROOTS
#ifdef _ENABLE_CHEMPS2_DMRG_
      Write(LF,Fmt2//'A,T45,I6)')'Maximum number of sweeps',
     &                           max_sweep
      Write(LF,Fmt2//'A,T45,I6)')'Maximum number of sweeps in RDM',
     &                           max_canonical
      Write(LF,Fmt2//'A,T45,E10.3)')'Threshold for restarting',
     &                           chemps2_blb
      Write(LF,Fmt2//'A,T45,E10.3)')'Minimum Davidson tolerance',
     &                           davidson_tol
      Write(LF,Fmt2//'A,T45,E10.3)')'DMRG convergence threshold',
     &                           THRE/2.0
      Write(LF,Fmt2//'A,T45,E10.3)')'Noise prefactor',
     &                           chemps2_noise
      Write(LF,Fmt2//'A,T45,L6)')'Restart from previous calculation',
     &                           chemps2_restart
      Write(LF,Fmt2//'A,T45,L6)')'Calculate 3-RDM and F.4-RDM',
     &                           Do3RDM
      Write(LF,Fmt2//'A,T45,I6)')'Restart scheme in 3-RDM and F.4-RDM',
     &                           chemps2_lrestart
      write(SNAC, '(I3)') NAC
      Write(LF,Fmt2//'A,T45,'//trim(adjustl(SNAC))//'I2)')
     &                           'Occupation guess',
     &                           (HFOCC(ihfocc), ihfocc=1,NAC)
#endif

* NN.14 FIXME: haven't yet checked whether geometry opt. works correctly with DMRG
      Write(LF,Fmt2//'A,T45,I6)')'Root chosen for geometry opt.',
     &                           IRLXROOT
      Call CollapseOutput(0,'DMRG sweep specifications:')

*     Skip printing CI specifications in DMRG-CASSCF
      GoTo 114

 113  Continue
#endif

      Line=''
      if(doDMRG)then ! yingjin - dmrg output
        Write(Line(left-2:),'(A)') 'DMRG specifications:'
        Call CollapseOutput(1,Line)
        Write(LF,Fmt2//'A)')'----------------------------'
        Write(LF,*)
#ifdef _DMRG_
       if(dmrg_warmup%docideas .and. nsym > 1)then
          Write(LF,*) ' CI-DEAS decativated for point group symmetry'//
     &                ' other than C1'
          dmrg_warmup%docideas = .false.
       end if
       if(dmrg_orbital_space%initial_occ(1,1) > 0)then
         dmrg_start_guess = "Single determinant"
       else
         dmrg_start_guess = "Random numbers (default)"
       end if
       call print_dmrg_info(lf,fmt2,2,dmrg_start_guess,nroots,thre)
#endif
      else
        Write(Line(left-2:),'(A)') 'CI expansion specifications:'
        Call CollapseOutput(1,Line)
        Write(LF,Fmt2//'A)')'----------------------------'
        Write(LF,*)
        Write(LF,Fmt2//'A,T40,I11)')'Number of CSFs',
     &                           NCSASM(LSYM)
        Write(LF,Fmt2//'A,T40,I11)')'Number of determinants',
     &                           NDTASM(LSYM)
      end if
      Write(LF,Fmt2//'A,T45,I6)')'Number of root(s) required',
     &                           NROOTS
      If ( ICICH.eq.0 ) then
         If ( nRoots.eq.1 ) then
           if(doDMRG)then
            Write(LF,Fmt2//'A,(T45,10I6))')'DMRG root used',
     &                                  IROOT(1)
           else
            Write(LF,Fmt2//'A,(T45,10I6))')'CI root used',
     &                                  IROOT(1)
           end if
         Else
           if(doDMRG)then
            Write(LF,Fmt2//'A,(T45,10I6))')'DMRG roots used',
     &                                    (IROOT(i),i=1,nRoots)
           else
            Write(LF,Fmt2//'A,(T45,10I6))')'CI roots used',
     &                                    (IROOT(i),i=1,nRoots)
           end if
            Write(LF,Fmt2//'A,(T45,10F6.3))')'weights',
     &                                      (Weight(i),i=1,nRoots)
         End If
      Else
         Do i=1,nRoots
            Write(LF,Fmt2//'A,T45,I6)')'root',i
            Write(LF,Fmt2//'A,T45,10I6)')'Reference configuartions',
     &                                  (iCI(iRef,i),iRef=1,mxRef)
            Write(LF,Fmt2//'A,T45,10F6.3)')'CI-coeff',
     &                                    (cCI(iRef,i),iRef=1,mxRef)
          End Do
      End If
      if(doDMRG)then
        Write(LF,Fmt2//'A,T45,I6)')'highest root included in the DMRG',
     &                           LROOTS
      else
        Write(LF,Fmt2//'A,T45,I6)')'highest root included in the CI',
     &                           LROOTS
      end if
      If (irlxroot.ne.0)
     &Write(LF,Fmt2//'A,T45,I6)')'Root passed to geometry opt.',
     &                           iRlxRoot
      If ( lRF ) then
         Call GetMem('Ovrlp','Allo','Real',iTmp0,nTot1+4)
         iRc=-1
         iOpt=2
         iComp=1
         iSyLbl=1
         Label='Mltpl  0'
         Call RdOne(iRc,iOpt,Label,iComp,Work(iTmp0),iSyLbl)
         Tot_Nuc_Charge=Work(iTmp0+nTot1+3)
         If ( iRc.ne.0 ) then
            Write(LF,*) 'OutCtl: iRc from Call RdOne not 0'
            Write(LF,*) 'Label = ',Label
            Write(LF,*) 'iRc = ',iRc
            Call Abend
         Endif
         Call GetMem('Ovrlp','Free','Real',iTmp0,nTot1+4)
         Tot_El_Charge=0.0D0
         Do iSym=1,nSym
            Tot_El_Charge=Tot_El_Charge
     &                   -2.0D0*DBLE(nFro(iSym)+nIsh(iSym))
         End Do
         Tot_El_Charge=Tot_El_Charge-DBLE(nActEl)
         Tot_Charge=Tot_Nuc_Charge+Tot_El_Charge
         iCharge=Int(Tot_Charge)
         Call PrRF(.False.,NonEq,iCharge,2)
         Write(LF,Fmt2//'A,T45,I2)')' Reaction field from state:',
     &                              IPCMROOT
      End If
      If ( RFpert ) then
         Write(LF,*)
         Write(LF,*)
         Write(LF,Fmt2//'A)')'Reaction field specifications:'
         Write(LF,Fmt2//'A)')'------------------------------'
         Write(LF,*)
         Write(LF,'(6X,A)')'The Reaction field has been added as a '//
     &                    'perturbation and has been determined '//
     &                    'in a previous calculation'
         Write(LF,*)
      End If
      If (KSDFT.ne.'SCF'.and.KSDFT.ne.'PAM') Call Print_NQ_Info(iSpin)
      Call CollapseOutput(0,'CI expansion specifications:')

#if defined _ENABLE_BLOCK_DMRG_ || defined _ENABLE_CHEMPS2_DMRG_
 114  Continue
#endif

* End of long if-block A over IPRLEV
      END IF

      EAV = 0.0d0

      Do kRoot = 1,nRoots
        EAV=EAV+ENER(IROOT(KROOT),ITER)*WEIGHT(KROOT)
      End Do
      CASDFT_Funct=0.0d0
      If (KSDFT.ne.'SCF'.and.KSDFT.ne.'PAM') Then
         If(nConf.eq.1.and.nActEl.eq.nac) Then
           Call Get_dScalar('CASDFT energy',CASDFT_Funct)
           ECAS = ECAS + CASDFT_Funct
           EAV=ECAS
         Else
           Call Get_dScalar('CASDFT energy',CASDFT_Funct)
           EAV=EAV+CASDFT_Funct - VIA_DFT - HALFQ
           ECAS = ECAS + CASDFT_Funct
         End If
      End If

      IF(IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
* Start of long if-block B over IPRLEV

*----------------------------------------------------------------------*
*     Print final optimization conditions                              *
*----------------------------------------------------------------------*

      Write(LF,*)
      Line=''
      Write(Line(left-2:),'(A)') 'Final optimization conditions:'
      Call CollapseOutput(1,Line)
      Write(LF,Fmt2//'A)')'------------------------------'
      Write(LF,*)
      Write(LF,Fmt2//'A,T45,F20.8)')
     &     'Average CI energy',EAV


      If (KeyCION.and.doDMRG)then
*        write(*,*)"KeyCION.and.doDMRG",KeyCION,doDMRG -- yma
*        If DMRG, no 2'-DMs thus omit ECAS and other properties
      else
        If (irlxroot.eq.0) Then
          Write(LF,Fmt2//'A,T45,F20.8)')
     &         'RASSCF energy',ECAS
        Else
          Write(LF,Fmt2//'A,I2,T45,F20.8)')
     &       'RASSCF energy for state ',irlxroot,ECAS
        End If

        Write(LF,Fmt2//'A,T45,F20.8)')
     &     'Super-CI energy',ESX
        Write(LF,Fmt2//'A,T45,F20.8)')
     &     'RASSCF energy change',DE
        Write(LF,Fmt2//'A,T50,E10.3)')
     &     'Max change in MO coefficients',CMAX
        Write(LF,Fmt2//'A,T50,E10.3)')
     &     'Max non-diagonal density matrix element',ROTMAX
        Write(LF,Fmt2//'A,T50,E10.3)')
     &     'Maximum BLB matrix element',CBLBM
        Write(LF,Fmt2//'A,I4,A,I4,A,I4,A)')
     &     '(orbital pair',IBLBM,',',JBLBM,' in symmetry',ISYMBB,')'
        If (irlxRoot.ne.0)
     &  Write(LF,Fmt2//'A,T45,E10.3)')
     &     'Norm of electronic gradient',RLXGRD

      End if

      If ( ISUPSM.ne.0 ) then
         Write(LF,Fmt2//'A)')
     &   'Supersymmetry has been used to disable selected orbital'//
     &   ' rotations'
         iEnd=0
         Do iSym=1,nSym
            iStart=iEnd+1
            iEnd=iEnd+nBas(iSym)
            iTemp=0
            Do i=iStart,iEnd
               iTemp=iTemp+IXSYM(i)
            End Do
            If ( iTemp.gt.0 ) then
               Write(LF,Fmt2//'A,I3)')
     &         'Supersymmetry vector for symmetry species',iSym
               Write(LF,Fmt2//'30I3)') (IXSYM(i),i=iStart,iEnd)
            End If
         End Do

      End If

      If ( ICLEAN.ne.0 ) then
         Write(LF,Fmt2//'A)')
     &   'The cleanup option has been used to set MO-coefficients'//
     &   ' explicitly to zero'
      End If
      Call CollapseOutput(0,'Final optimization conditions:')

* End of long if-block B over IPRLEV
      END IF

      call dcopy_(2*mxRoot,[0.0d0],0,Temp,1)
      iRc1=0
      iRc2=0
      iOpt=1
      iComp=1
      iSyLbl=1
      nMVInt=0
      nDCInt=0
      Call iRdOne(iRc1,iOpt,'MassVel ',iComp,iDum,iSyLbl)
      If (iRc1.eq.0) nMVInt=iDum(1)
      Call iRdOne(iRc2,iOpt,'Darwin  ',iComp,iDum,iSyLbl)
      If (iRc2.eq.0) nDCInt=iDum(1)
      If ( (nMVInt+nDCInt).ne.0 ) Then
        IAD12=IADR15(12)
        CALL GETMEM('OPER','ALLO','REAL',LX1,NTOT1)
        CALL GETMEM('DEN1','ALLO','REAL',LX2,NTOT1)
        CALL GETMEM('OCCN','ALLO','REAL',LX3,NTOT )
        CALL GETMEM('CMON','ALLO','REAL',LX4,NTOT2)
        Do kRoot = 1,lRoots
          CALL DDAFILE(JOBIPH,2,work(LX4),NTOT2,IAD12)
          CALL DDAFILE(JOBIPH,2,work(LX3),NTOT,IAD12)
          Call RelEne(Temp(1,kRoot),Temp(2,kRoot),nSym,nBas,
     &                work(LX4),work(LX3),work(LX2),work(LX1))
        End Do
        CALL GETMEM('CMON','FREE','REAL',LX4,NTOT2)
        CALL GETMEM('OCCN','FREE','REAL',LX3,NTOT )
        CALL GETMEM('DEN1','FREE','REAL',LX2,NTOT1)
        CALL GETMEM('OPER','FREE','REAL',LX1,NTOT1)
      End If

      Call Allocate_Work(ipEneTmp,lRoots)
      If ( (nMVInt+nDCInt).ne.0) then
         Do i=1,lRoots
            Emv=Temp(1,i)
            Edc=Temp(2,i)
            Erel=ENER(I,ITER)+Emv+Edc
            Work(ipEneTmp+i-1) = eRel
         End Do
      Else
         Do i=1,lRoots
            Work(ipEneTmp+i-1) = ENER(I,ITER)+CASDFT_Funct-VIA_DFT-HALFQ
         End Do
      End If

      IF(IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
* Start of long if-block C over IPRLEV
*----------------------------------------------------------------------*
*     Print final state energies (including relativistic correction)   *
*----------------------------------------------------------------------*
       Write(LF,*)
       Write(LF,*)
       Write(LF,Fmt2//'A)')'Final state energy(ies):'
       Write(LF,Fmt2//'A)')'------------------------'
       Write(LF,*)
       If ( (nMVInt+nDCInt).ne.0) then
         Write(LF,Fmt2//'A)')
     &        'root     nonrelativistic        mass-velocity       '//
     &        'Darwin-contact         relativistic'
         Write(LF,Fmt2//'A)')
     &        '             energy                term             '//
     &        '     term                 energy'
         Do i=1,lRoots
            Emv=Temp(1,i)
            Edc=Temp(2,i)
            Erel=ENER(I,ITER)+Emv+Edc
            Write(LF,Fmt2//'I3,4(1X,F20.8))')
     &            I,ENER(I,ITER),Emv,Edc,Erel
         End Do
       Else
         Do i=1,lRoots
           Call PrintResult(LF,Fmt2//'A,I3,A,F16.8)',
     & 'RASSCF root number',I,' Total energy:',Work(ipEneTmp+i-1),1)
         End Do
       End If
      ELSE IF(IPRLEV.GE.TERSE .AND..NOT.lOPTO) THEN
        Do i=1,lRoots
           Call PrintResult(LF,Fmt2//'A,I3,A,F16.8)',
     & 'RASSCF root number',I,' Total energy:',Work(ipEneTmp+i-1),1)
        End Do
* End of long if-block C over IPRLEV
      END IF

      Call Store_Energies(lRoots,Work(ipEneTmp),irlxroot)
      Call Put_iScalar('NumGradRoot',irlxroot)
      Call Put_dScalar('Average energy',EAV)
      Call Free_Work(ipEneTmp)

      iTol = Cho_X_GetTol(8)
      if(doDMRG) iTol = 6
*
      Line(1:8)='E_RASSCF'
      j=8
      Do i=1, nRoots
         If (nRoots.gt.1) Then
            If (i-1.lt.10) Then
               j=11
               Write (Line(9:j),'(A,I1,A)') '[',i-1,']'
            Else If (i-1.lt.100) Then
               j=12
               Write (Line(9:j),'(A,I2,A)') '[',i-1,']'
            Else If (i-1.lt.1000) Then
               j=13
               Write (Line(9:j),'(A,I3,A)') '[',i-1,']'
            Else If (i-1.lt.10000) Then
               j=14
               Write (Line(9:j),'(A,I4,A)') '[',i-1,']'
            End If
         Else
            j=8
         End If
         Call Add_Info(Line(1:j),ENER(iRoot(i),ITER),1,iTol)
      End Do
*---------------------------------------------------------------
* New JOBIPH layout: Also write hamiltonian matrix at IADR15(17):
*---------------------------------------------------------------
      CALL GETMEM('HEFF','ALLO','REAL',LHEFF,LROOTS**2)
      DO J=1,LROOTS
       DO I=1,LROOTS
        WORK(LHEFF-1+I+LROOTS*(J-1))=0.0D0
       END DO
       WORK(LHEFF-1+J+LROOTS*(J-1))=ENER(J,ITER)
      END DO
      IAD15=IADR15(17)
      CALL DDAFILE(JOBIPH,1,WORK(LHEFF),LROOTS**2,IAD15)
      CALL GETMEM('HEFF','FREE','REAL',LHEFF,LROOTS**2)
*----------------------------------------------------------------------*
*     Print the multipole analysis of the solvation energy             *
*----------------------------------------------------------------------*
      Call RFMltp()
*----------------------------------------------------------------------*
*     Print the final orbitals                                         *
*----------------------------------------------------------------------*
      FullMlk=(OutFmt1.NE.'NOTHING ')
      IF (IPRLEV.GE.USUAL .AND..NOT.lOPTO) THEN
* Start of if-block D over IPRLEV
      If (OutFmt1.NE.'NOTHING ') then
        If(IPT2.EQ.0) THEN
          If(kIvo) Then
            Call ivogen_rasscf(nSym,nBas,nFro,nIsh,nAsh,nTot2,nTot,
     &                         CMO,FDIAG)
            CALL PRIMO_RASSCF('Pseudonatural active'//
     &       ' orbitals and approximate occupation numbers + IVO,'//
     &       ' not suitable for CASPT2',
     &                         FDIAG,OCCN,CMO)
          Else
            CALL PRIMO_RASSCF('Pseudonatural active'//
     &                  ' orbitals and approximate occupation numbers',
     &                         FDIAG,OCCN,CMO)
          End If
        Else
           CALL PRIMO_RASSCF('All orbitals are'//
     &                  ' eigenfunctions of the PT2 Fock matrix',
     &                         FDIAG,OCCN,CMO)
        EndIf
      EndIf
* End of if-block D over IPRLEV
      END IF
*----------------------------------------------------------------------*
*     Also put on RUNFILE (in the future...):
*----------------------------------------------------------------------*
      Call Put_dArray('RASSCF orbitals',CMO,NTOT2)
*----------------------------------------------------------------------*
*     compute properties and Mulliken's orbital populations            *
*----------------------------------------------------------------------*
      IAD12=IADR15(12)
      IAD03=IADR15(3)
      IAD14=IADR15(14)
*BOR0511
*     Save original orbitals for the spin density matrices
      Call GetMem('cmon','ALLO','REAL',icmon,nTot2)
      call dcopy_(ntot2,cmo,1,work(icmon),1)
*BOR0511
      FullMlk=(OutFmt1.NE.'NOTHING ')

*                                                                      *
************************************************************************
*                                                                      *
*     Here follows a very long loop over KROOT:
*
*     But first save the 1st order density for gradients
*
      Call mma_allocate(DSave,nTot1,Label='DSave')
      Call Get_D1AO(DSave,NTOT1)
*
*     The dipole moments will also be stored over all kroot states.
*
      Call GetMem('DIPM', 'Allo','Real',ipDM,3)
      Call GetMem('DIPMs','Allo','Real',ipDMs,3*LROOTS)
      CALL FZERO(Work(ipDMs),3*LROOTS)
      Do_DM=.False.
*
      DO KROOT=1,LROOTS
*
* Read natural orbitals
        If ( NAC.GT.0 ) then
          CALL DDAFILE(JOBIPH,2,CMO,NTOT2,IAD12)
          CALL DDAFILE(JOBIPH,2,OCCN,NTOT,IAD12)
        End If
*
* Put the density matrix of this state on the runfile for
*  LoProp utility
        Call GetMem('DState','ALLO','REAL',ipD,nTot1)
        call dcopy_(nTot1,[0.0D0],0,Work(ipD),1)
        Call DONE_RASSCF(CMO,OCCN,Work(ipD))
        Call Put_D1AO(Work(ipD),NTOT1)
        Call Free_Work(ipD)

        IF (IPRLEV.GE.USUAL) THEN
*
*       Start of if-block E over IPRLEV
*
        vNentropy=0.0d0
        Do i=1,NTOT ! very "inefficient" but the simplest
           xnu=OCCN(i)/2.0d0
           If (xnu.gt.0.0d0) vNentropy = vNentropy + xnu*log(xnu)
        End Do
        vNentropy = -vNentropy/log(2.0d0)
*
        Write(LF,'(6X,A,I2,A,F8.5)')
     *  'Von Neumann Entropy (Root ',KROOT,') = ',vNentropy
        Write(LF,*)
*
*       Compute Mulliken's population analysis
*
        Write(LF,'(/6X,A,I3)')
     *  'Mulliken population analysis for root number:',KROOT
        Write(LF,'(6X,A)')
     *  '-----------------------------------------------'
        Write(LF,*)
        lSave = KRoot.eq.iRlxRoot
        CALL CHARGE(nsym,nbas,name,CMO,OCCN,SMAT,2,FullMlk,lSave)
        Write(LF,*)
*
*       Compute properties
*
        Write(LF,'(/6X,2A,I3)')
     *  'Expectation values of various properties ',
     *  'for root number:',KROOT
        Write(LF,'(6X,2A)')
     *  '-----------------------------------------',
     *  '------------------'
        Write(LF,*)
        END IF
* End of if-block E over IPRLEV

*
*     Write out info on a temporary vector file. Prpt
*     will need to read this.
        Note='Temporary orbital file used by prpt3.'
        LuTmp=50
        LuTmp=IsFreeUnit(LuTmp)
        Call WrVec('TMPORB',LuTmp,'CO',nSym,nBas,nBas,
     &            CMO,OCCN,Dum,iDum,Note)
        CALL PRPT()
*                                                                      *
************************************************************************
*       Store away the dipole moment of this state                     *
*
        Call Qpg_dArray('Dipole Moment',Do_DM,iDum(1))
        If (Do_DM) Then
*          Write (6,*) 'iRoot=',kRoot
           Call Get_dArray('Dipole Moment',Work(ipDM),3)
*          Call RecPrt('Dipole Moment',' ',Work(ipDM),1,3)
           Call DCopy_(3,Work(ipDM),1,Work(ipDMs+(KROOT-1)*3),1)
        End If
*                                                                      *
************************************************************************
*                                                                      *
*
*       Compute spin orbitals and spin population
*       (Note: this section overwrites the pseudo natural orbitals
*              with the spin orbitals).
*
* PAM2008: Only for at most MAXORBOUT orbitals. Default 10, reset by
*       keyword.
        IF(KROOT.LE.MAXORBOUT) THEN

        CALL GETMEM('RHO1S','ALLO','REAL',LX6,NACPAR)
        CALL DDAFILE(JOBIPH,0,WORK(LX6),NACPAR,IAD03)
        CALL DDAFILE(JOBIPH,2,WORK(LX6),NACPAR,IAD03)
        CALL DDAFILE(JOBIPH,0,WORK(LX6),NACPR2,IAD03)
        CALL DDAFILE(JOBIPH,0,WORK(LX6),NACPR2,IAD03)
        CALL DBLOCK(WORK(LX6))

        IF (IPRLEV.GE.VERBOSE) THEN
* Start of long if-block F over IPRLEV
         IF(ISPDEN .EQ. 1) THEN
*         Print spin density matrix
          Write(LF,'(/6X,A,I3)')
     &    'Spin density matrix for root number:',KROOT
          Write(LF,'(6X,A)')
     &    '--------------------------------------'
          Write(LF,*)
          IND=0
          IDIMV=0
          IDIMO=0
          IDIMN=0
          DO ISYM=1,NSYM
            NAO=NASH(ISYM)
            IF(NAO .EQ. 0) GO TO 50
            NO=NBAS(ISYM)
            IDIMV=IDIMV+NAO*NAO
            IDIMO=IDIMO+NAO
            IDIMN=IDIMN+NO*NAO
            Write(LF,'(/6X,A,I2)') 'symmetry species',ISYM
            Write(LF,*)
            CALL TRIPRT(' ',' ',WORK(LX6+IND),NASH(ISYM))
            IND=IND+NASH(ISYM)*(NASH(ISYM)+1)/2
  50        CONTINUE
          END DO
         END IF
* End of long if-block F over IPRLEV
        END IF

*       Compute spin orbitals and spin population
        CALL DCOPY_(NTOT,[0.0D0],0,OCCN,1)
*SVC-11-01-2007 store original cmon in cmoso, which gets changed
        CALL GETMEM('CMOSO','ALLO','REAL',ICMOSO,NTOT2)
        CALL DCOPY_(NTOT2,WORK(ICMON),1,WORK(ICMOSO),1)

        if(.not.doDMRG)then
          CALL SPINORB(WORK(LX6),WORK(ICMOSO),OCCN,kroot)
        end if
        CALL GETMEM('RHO1S','FREE','REAL',LX6,NTOTSP)
        CALL DDAFILE(JOBIPH,1,WORK(ICMOSO),NTOT2,IAD14)
        CALL DDAFILE(JOBIPH,1,OCCN,NTOT,IAD14)

        IF (IPRLEV.GE.USUAL) THEN
* Start of long if-block G over IPRLEV
         IF(ISPDEN .EQ. 1) THEN
          Write(LF,'(/6X,A,I3)')
     &    'Mulliken spin population analysis for root number:',KROOT
          Write(LF,'(6X,A)')
     &    '---------------------------------------------------'
          Write(LF,*)
          CALL CHARGE(nsym,nbas,name,Work(icmoso),OCCN,SMAT,3,FullMlk,
     &                .False.)
          Write(LF,*)
         ENDIF

*BOR0511
*
*       Do LoProp Charge analysis
*
         If (get_BasisType('ANO')) Then
           Write(LF,'(/6X,A,I3)')
     *     'LoProp population analysis for root number:',KROOT
           Write(LF,'(6X,A)')
     *     '-----------------------------------------------'
           Write(LF,*)
           Write(LF,*)
           Line=''
           Write(Line(left-2:),'(A)') 'LoProp analysis:'
           Call CollapseOutput(1,Line)
           Write(LF,Fmt2//'A)') '----------------'
           Write(LF,*)
           Write(LF,*)
*
* Ugly trick: use IRC to pass some info to LoProp ...
*
           iRC = Min((Abs(KRoot-iRlxRoot)),1)
           Call LoProp(iRC)
           Write(LF,*)
           Write(LF,'(6X,A,I3)')
     &     'Natural Bond Order analysis for root number:',KROOT
           Call Nat_Bond_Order(nSym,nBas,Name,2)
           Call CollapseOutput(0,'LoProp analysis:')
           Write(6,*)
         End If
* End of long if-block G over IPRLEV
         END IF
         CALL GETMEM('CMOSO','FREE','REAL',ICMOSO,NTOT2)
cnf
*
*------- ESPF analysis
         Call DecideOnESPF(Do_ESPF)
         If (Do_ESPF) Call espf_analysis(lSave)
cnf

*PAM2008: End of restriction KROOT.LE.MAXORBOUT, see above.
        END IF
*
      END DO
*
*     Restore the correct 1st order density for gradient calculations.
*
      Call Put_D1AO(DSave,NTOT1)
      Call mma_deallocate(DSave)
*
*     Save the list of dipole moments on the run file.
*
      If (Do_DM)
     &   Call Put_dArray('Last Dipole Moments',Work(ipDMs),3*LROOTS)
*     Call RecPrt('Last Dipole Moments',' ',Work(ipDMs),3,LROOTS)
      Call GetMem('DipM', 'Free','Real',ipDM, 3)
      Call GetMem('DipMs','Free','Real',ipDMs,3*LROOTS)
*                                                                      *
************************************************************************
*                                                                      *
      CALL GETMEM('CMON','FREE','REAL',icmon,NTOT2)
*----------------------------------------------------------------------*

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2016, Sebastian Wouters                                *
*               2016, Quan Phung                                       *
************************************************************************
! CheMPS2-Molcas main interface
! Based on Block interface, written by N. Nakatani
! Written by Quan Phung and Sebastian Wouters, Leuven, Aug 2016
! Adapted for Molcas 8.1 by Quan Phung, Leuven, Oct 2016

      Subroutine Chemps2Ctl( LW1, TUVX, IFINAL, IRST )

#ifdef _MOLCAS_MPP_
      Use MPI
#endif

      Implicit Real*8 (A-H,O-Z)

      Dimension LW1(*), TUVX(*)

      Integer iChMolpro(8)
      Character*3 Label
      Integer LINSIZE, NUM_TEI, dtemp, nooctemp, labelpsi4
      Integer conversion(8)
      Integer activesize(8)
      Real*8  chemps2_totale_4d, revdiff, chemps2_conv
      Logical fiedler, mps0
      Integer chemroot, chemps2_info
      character(len=10) :: rootindex
      character(len=100) :: imp1, imp2
      Integer :: iOper(0:7), ihfocc

#ifdef _MOLCAS_MPP_
      Integer*4 IERROR4
      External King, Is_Real_Par
      Logical King
      Logical Is_Real_Par
#endif



#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='CHEMPS2CTL')

! Quan: FIXME: Do we need this?
* Load symmetry info from RunFile
      iOper = 0
      Call Get_iScalar('NSYM',nIrrep)
      Call Get_iArray('Symmetry operations',iOper,nIrrep)
      Call Get_iScalar('Rotational Symmetry Number',iSigma)

* Get character table to convert MOLPRO symmetry format
      Call MOLPRO_ChTab_BIS(nSym,Label,iChMolpro)

* Convert orbital symmetry into MOLPRO format
      Call Getmem('OrbSym','Allo','Inte',lOrbSym,NAC)
      iOrb=1
      Do iSym=1,nSym
        Do jOrb=1,NASH(iSym)
          iWork(lOrbSym+iOrb-1)=iChMolpro(iSym)
          iOrb=iOrb+1
        End Do
      End Do
      lSymMolpro=iChMolpro(lSym)

      NRDM_ORDER=2
      If (NACTEL.EQ.1) NRDM_ORDER=1


**********************
*  WRITEOUT FCIDUMP  *
**********************

      LINSIZE = ( NAC * ( NAC + 1 ) ) / 2
      NUM_TEI = ( LINSIZE * ( LINSIZE + 1 ) ) / 2
      Call FCIDUMP_OUTPUT( NAC, NACTEL, ISPIN-1,
     &                     lSymMolpro, iWork(lOrbSym),
     &                     0.0d0, LW1, TUVX,
     &                     LINSIZE, NUM_TEI )


      Call Getmem('OrbSym','Free','Inte',lOrbSym,NAC)

**************************
*  WRITEOUT ACTIVE FOCK  *
**************************

!      Write(6,*) "Currently the Fock matrix is printed in fckpt2.f"

*************************
*  WRITEOUT INPUT FILE  *
*************************

#ifdef _MOLCAS_MPP_
      if ( KING() .OR. .not.Is_Real_Par() ) then
#endif
      IF (IRST.EQ.0) THEN
! Cleanup chemps2.log.total
        call c_remove("chemps2.log.total")
! Check if checkpoint files exist
        if (chemps2_restart.EQV..TRUE.) then
           call f_inquire('CHEMNATFIE',fiedler)
           call f_inquire('CHEMNATMPS0',mps0)
           if (fiedler .and. mps0) then
             write(6,*) 'CHEMPS2> Found checkpoint files for DMRG-SCF'
! Copy CheMPS2_natorb_MPSxxx.h5 to CheMPS2_MPSxxx.h5
             call fcopy('CHEMNATFIE','CHEMFIE',iErr)
             do chemroot=1,lroots
              write (rootindex, "(I2)") chemroot-1
              imp1="CheMPS2_natorb_MPS"//trim(adjustl(rootindex))//".h5"
              imp2="CheMPS2_MPS"//trim(adjustl(rootindex))//".h5"
              call fcopy(imp1,imp2,iErr)
             enddo
           else
! Reset chemps2_restart = .false. if not checkpoint files
              write(6,*) 'CHEMPS2> No checkpoint files for DMRG-SCF'
              chemps2_restart=.false.
           endif
        endif
! Check if checkpoint files for 3RDM exist
        if (chemps2_lrestart.EQ.1.) then
           call f_inquire('CHEMCANFIE',fiedler)
           call f_inquire('CHEMCANMPS0',mps0)
           if (fiedler .and. mps0) then
             write(6,*) 'CHEMPS2> Found checkpoint files for n-RDM'
           else
             write(6,*) 'CHEMPS2> No checkpoint files for n-RDM'
             chemps2_lrestart=0
           endif
        endif

      ENDIF
#ifdef _MOLCAS_MPP_
      endif
#endif

      LUCHEMIN=isFreeUnit(29)
      call molcas_open(LUCHEMIN,'chemps2.input')
      write(LUCHEMIN,*) 'FCIDUMP = FCIDUMP_CHEMPS2'

      call group_psi4number(Label,Labelpsi4)
      write(LUCHEMIN,'(1X,A8,I1)') 'GROUP = ', Labelpsi4
      write(LUCHEMIN,*)

      write(LUCHEMIN,'(1X,A13,I2)') 'EXCITATION = ', lRoots-1
      write(LUCHEMIN,*)

      IF ((ABS(CBLBM)>chemps2_blb .AND. IFINAL.NE.2) .OR.
     &   (IRST.EQ.0 .AND. (chemps2_restart.EQV..FALSE.)) .OR.
     &   (IFINAL.EQ.2 .AND. (Do3RDM.EQV..TRUE.)
     &                .AND. (chemps2_lrestart.EQ.0)) .OR.
     &   (IFINAL.EQ.2 .AND. iOrbTyp.EQ.2
     &                .AND. (chemps2_lrestart.EQ.0))) THEN

            call c_remove("molcas_fiedler.txt")
!Quan: FIXME: how to remove CheMPS2_MPS0.h5, etc with c_remove
            call systemf("rm -f CheMPS2_MPS*.h5", iErr)
            write(LUCHEMIN,*) 'MOLCAS_MPS     = TRUE'
            write(6,*) 'CHEMPS2> Start DMRG from scratch'

        write(LUCHEMIN,'(1X,A21)',ADVANCE='NO') 'SWEEP_STATES       = '
        dtemp = 500
        do
          write(LUCHEMIN,('(I7,A2)'),ADVANCE='NO') dtemp, ','
          dtemp = dtemp + min(dtemp,1000)
          if (dtemp .GE. MxDMRG) then
            write(LUCHEMIN,'(I7,A2,I7)') MxDMRG, ',', MxDMRG
            exit
          endif
        enddo

        write(LUCHEMIN,'(1X,A21)',ADVANCE='NO') 'SWEEP_ENERGY_CONV  = '
        dtemp = 500
        do
          if (dtemp .EQ. 500) then
            write(LUCHEMIN,'(E12.5,A3)',ADVANCE='NO') THRE*1000.0, ','
         else
           write(LUCHEMIN,'(E12.5,A3)',ADVANCE='NO') THRE*100.0, ','
         endif

         dtemp = dtemp + min(dtemp,1000)
         if (dtemp .GE. MxDMRG) then
           write(LUCHEMIN,'(E12.5,A3,E12.5)') THRE*5.0, ',', THRE/2.0
           exit
         endif
        enddo

        write(LUCHEMIN,'(1X,A21)',ADVANCE='NO') 'SWEEP_MAX_SWEEPS   = '
        dtemp = 500
        do
          if (dtemp .EQ. 500) then
            write(LUCHEMIN,'(I7,A3)',ADVANCE='NO') max_sweep, ','
          else
            write(LUCHEMIN,'(I7,A3)',ADVANCE='NO') max_sweep/2, ','
          endif

          dtemp = dtemp + min(dtemp,1000)
          if (dtemp .GE. MxDMRG) then
           if (IFINAL.EQ.2) then
             if (Do3RDM .OR. (iOrbTyp.EQ.2)) THEN
              write(LUCHEMIN,'(I7,A3,I7)') max_sweep/2, ','
     &                                   , max_canonical
             else
              write(LUCHEMIN,'(I7,A3,I7)') max_sweep/2, ','
     &                                   , max_sweep*5
             endif
           else
            write(LUCHEMIN,'(I7,A3,I7)') max_sweep/2, ',', max_sweep
           endif
           exit
          endif
        enddo

        write(LUCHEMIN,'(1X,A21)',ADVANCE='NO') 'SWEEP_NOISE_PREFAC = '
        dtemp = 500
        do
         write(LUCHEMIN,'(E12.5,A3)',ADVANCE='NO') chemps2_noise, ','
         dtemp = dtemp + min(dtemp,1000)
         if (dtemp .GE. MxDMRG) then
           write(LUCHEMIN,'(E12.5,A10)') chemps2_noise, ' ,   0.00'
           exit
         endif
        enddo

        write(LUCHEMIN,'(1X,A21)',ADVANCE='NO') 'SWEEP_DVDSON_RTOL  = '
        dtemp = 500
        do
         if (dtemp .EQ. 500) then
           write(LUCHEMIN,'(A9)',ADVANCE='NO') '1.0e-3 ,'
         else
           write(LUCHEMIN,'(A9)',ADVANCE='NO') '1.0e-4 ,'
         endif

         dtemp = dtemp + min(dtemp,1000)
         if (dtemp .GE. MxDMRG) then
           write(LUCHEMIN,'(A9,E12.5)') '1.0e-4 ,', davidson_tol
           exit
         endif
        enddo
        write(LUCHEMIN,*)

      ELSE
! DMRG restart with fixed orbital order
        IF ((ABS(CBLBM)>chemps2_blb/10.0 .AND. IFINAL.NE.2) .OR.
     &   (IRST.EQ.0 .AND. (chemps2_restart.EQV..TRUE.))) THEN
          write(6,*) 'CHEMPS2> Partial restart DMRG ',
     &                  'from previous step'

          write(LUCHEMIN,*) 'MOLCAS_MPS     = TRUE'
          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_STATES       = '
          write(LUCHEMIN,'(I7,A2,I7)') MxDMRG, ',', MxDMRG

          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_ENERGY_CONV  = '
          write(LUCHEMIN,'(E12.5,A3,E12.5)') THRE*5.0, ',', THRE/2.0

          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_MAX_SWEEPS   = '
          if (IFINAL.EQ.2) then
             if (Do3RDM .OR. (iOrbTyp.EQ.2)) THEN
               write(LUCHEMIN,'(I7,A3,I7)') max_sweep/2, ','
     &                                    , max_canonical
             else
               write(LUCHEMIN,'(I7,A3,I7)') max_sweep/2, ','
     &                                    , max_sweep*5
             endif
          else
            write(LUCHEMIN,'(I7,A3,I7)') max_sweep/2, ',', max_sweep
          endif

          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_NOISE_PREFAC = '
          write(LUCHEMIN,'(E12.5,A10)') chemps2_noise, ' ,   0.00'

          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_DVDSON_RTOL  = '
          write(LUCHEMIN,'(A9,E12.5)') '1.0e-4 ,', davidson_tol
          write(LUCHEMIN,*)
        ELSE
!          write(6,*) 'Full Restart'
          write(6,*) 'CHEMPS2> Fully restart DMRG from previous step'
          write(LUCHEMIN,*) 'MOLCAS_MPS     = TRUE'
          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_STATES       = '
          write(LUCHEMIN,'(I7)') MxDMRG

          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_ENERGY_CONV  = '
          write(LUCHEMIN,'(E12.5)') THRE/2.0

          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_MAX_SWEEPS   = '
          if (IFINAL.EQ.2 .OR. (IFINAL.EQ.1 .AND. iCIonly.EQ.1)) then
            if (IFINAL.EQ.2 .AND. (Do3RDM .OR. (iOrbTyp.EQ.2))) THEN
              write(LUCHEMIN,'(I7)') max_canonical
            else
              write(LUCHEMIN,'(I7)') max_sweep*5
            endif
          else
            write(LUCHEMIN,'(I7)') max_sweep
          endif

          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_NOISE_PREFAC = '
          write(LUCHEMIN,'(A16)') '   0.00'

          write(LUCHEMIN,'(1X,A21)',ADVANCE='NO')
     &                                      'SWEEP_DVDSON_RTOL  = '
          write(LUCHEMIN,'(E12.5)') davidson_tol
          write(LUCHEMIN,*)
        ENDIF
      ENDIF


      write(LUCHEMIN,'(A8)',ADVANCE='NO') 'NOCC = '
      do nooctemp=1,NSYM-1
        write(LUCHEMIN,'(A5)',ADVANCE='NO') '0 ,'
      enddo
      write(LUCHEMIN,'(A3)') '0'

      write(LUCHEMIN,'(A8)',ADVANCE='NO') 'NACT = '
      call molpro2psi(Label,conversion)
      do iSym=1,nSym
        activesize( conversion( iChMolpro( iSym ) ) ) = NASH( iSym )
      end do
      do nooctemp=1,NSYM-1
        write(LUCHEMIN,'(I3,A2)',ADVANCE='NO')
     &                        activesize(nooctemp), ' ,'
      enddo
      write(LUCHEMIN,'(I3)')  activesize(NSYM)

      write(LUCHEMIN,'(A8)',ADVANCE='NO') 'NVIR = '
      do nooctemp=1,NSYM-1
        write(LUCHEMIN,'(A5)',ADVANCE='NO') '0 ,'
      enddo
      write(LUCHEMIN,'(A3)') '0'
      write(LUCHEMIN,*)

      write(LUCHEMIN,*) 'MOLCAS_FIEDLER = TRUE'
      write(LUCHEMIN,*) 'MOLCAS_STATE_AVG = TRUE'
      write(LUCHEMIN,*) 'MOLCAS_2RDM    = molcas_2rdm.h5'

      if (sum(hfocc) .EQ. NACTEL) then
        write(6,*)  'CHEMPS2> Using user-specified ROHF guess'
        write(LUCHEMIN,'(A13)',ADVANCE='NO') 'MOLCAS_OCC ='
        do ihfocc=1,NAC-1
          write(LUCHEMIN,'(I3,A2)', ADVANCE='NO') HFOCC(ihfocc), ', '
        enddo
        write(LUCHEMIN,'(I3)') HFOCC(NAC)
      else
        write(6,*)  'CHEMPS2> Using noise guess'
      endif

      If (IFINAL.EQ.2 .AND. Do3RDM .AND. NACTEL.GT.2) Then
         write(6,*)  'CHEMPS2> Running 3-RDM and F.4-RDM'
         write(LUCHEMIN,*) 'MOLCAS_3RDM    = molcas_3rdm.h5'
         write(LUCHEMIN,*) 'MOLCAS_F4RDM   = molcas_f4rdm.h5'
         write(LUCHEMIN,*) 'MOLCAS_FOCK    = FOCK_CHEMPS2'
      endif

      write(LUCHEMIN,*)

      write(LUCHEMIN,*) 'PRINT_CORR = TRUE'
      write(LUCHEMIN,*) 'TMP_FOLDER = ./'

      close(LUCHEMIN)

#ifdef _MOLCAS_MPP_
      write(6,'(1X,A21,I3)') 'CHEMPS2> ITERATION : ', ITER
      if ( KING() .OR. .not.Is_Real_Par() ) then
#endif

! Quan: overwrite CheMPS2_xxxorb_MPSX.h5 to CheMPS2_MPSX.h5
         if (
     &   (IFINAL.EQ.2 .AND. Do3RDM
     &                .AND. (chemps2_lrestart>0)) .OR.
     &   (IFINAL.EQ.2 .AND. iOrbTyp.EQ.2
     &                .AND. (chemps2_lrestart>0))) THEN
           if (chemps2_lrestart.EQ.1) then
             write(6,*) 'CHEMPS2> Using user-supplied checkpoint files'
             call fcopy('CHEMCANFIE','CHEMFIE',iErr)
             do chemroot=1,lroots
              write (rootindex, "(I2)") chemroot-1
              imp1="CheMPS2_canorb_MPS"//trim(adjustl(rootindex))//".h5"
              imp2="CheMPS2_MPS"//trim(adjustl(rootindex))//".h5"
              call fcopy(imp1,imp2,iErr)
             enddo
           endif

           if (chemps2_lrestart.EQ.2) then
             write(6,*) 'CHEMPS2> Using checkpoint files from',
     &                   ' previous step (not recommended)'
             call fcopy('CHEMNATFIE','CHEMFIE',iErr)
             do chemroot=1,lroots
              write (rootindex, "(I2)") chemroot-1
              imp1="CheMPS2_natorb_MPS"//trim(adjustl(rootindex))//".h5"
              imp2="CheMPS2_MPS"//trim(adjustl(rootindex))//".h5"
              call fcopy(imp1,imp2,iErr)
             enddo
           endif
         endif

! Quan: save CANORB before actually calculating
         if (
     &   (IFINAL.EQ.2 .AND. Do3RDM
     &                ) .OR.
     &   (IFINAL.EQ.2 .AND. iOrbTyp.EQ.2
     &                )) THEN
            write(6,*) 'CHEMPS2> Save CANORB'
! Quan: FIXME: Bug!
!            Call OrbFiles(JOBIPH,IPRLEV)
         endif

         call systemf("chemps2 --file=chemps2.input > chemps2.log",iErr)
         call systemf("cat chemps2.log >> chemps2.log.total",iErr)

! Quan: save natorb checkpoint file in all iteration
         if (IFINAL<2) then
           if (IFINAL.EQ.1) then
             write(6,*) 'CHEMPS2> Save natorb checkpoint files'
           endif
           call fcopy('CHEMFIE','CHEMNATFIE',iErr)
             do chemroot=1,lroots
              write (rootindex, "(I2)") chemroot-1
              imp1="CheMPS2_natorb_MPS"//trim(adjustl(rootindex))//".h5"
              imp2="CheMPS2_MPS"//trim(adjustl(rootindex))//".h5"
              call fcopy(imp2,imp1,iErr)
             enddo
         endif

! Quan: save canorb checkpoint file if possible
         if (
     &   (IFINAL.EQ.2 .AND. Do3RDM
     &                ) .OR.
     &   (IFINAL.EQ.2 .AND. iOrbTyp.EQ.2
     &                )) THEN

           write(6,*) 'CHEMPS2> Save canorb checkpoint files'
           call fcopy('CHEMFIE','CHEMCANFIE',iErr)
             do chemroot=1,lroots
              write (rootindex, "(I2)") chemroot-1
              imp1="CheMPS2_canorb_MPS"//trim(adjustl(rootindex))//".h5"
              imp2="CheMPS2_MPS"//trim(adjustl(rootindex))//".h5"
              call fcopy(imp2,imp1,iErr)
             enddo
         endif

! Quan: Cleanup checkpoint files
         if (IFINAL.EQ.2) then
            call c_remove("molcas_fiedler.txt")
!Quan: FIXME: how to remove CheMPS2_MPS0.h5, etc with c_remove
            call systemf("rm -f CheMPS2_MPS*.h5",iErr)
         endif

#ifdef _MOLCAS_MPP_
      end if


      if ( Is_Real_Par() ) then
          CALL MPI_Barrier(MPI_COMM_WORLD, IERROR4)
      end if

!Quan: FIXME: softlink all the n-RDM files
      if ( Is_Real_Par().AND.( KING().EQV..false. ) )
     &  then
        do chemroot=1,lroots
          write(rootindex,"(I2)") chemroot-1
          imp1="ln -sf ../molcas_2rdm.h5.r"//
     &           trim(adjustl(rootindex))//" ."
          call systemf(imp1,iErr)
          imp1="ln -sf ../molcas_3rdm.h5.r"//
     &           trim(adjustl(rootindex))//" ."
          call systemf(imp1,iErr)
          imp1="ln -sf ../molcas_f4rdm.h5.r"//
     &           trim(adjustl(rootindex))//" ."
          call systemf(imp1,iErr)
          imp1="ln -sf ../CheMPS2_natorb_MPS0.h5 ."
          call systemf(imp1,iErr)
          imp1="ln -sf ../CheMPS2_canorb_MPS0.h5 ."
          call systemf(imp1,iErr)
          imp1="ln -sf ../molcas_natorb_fiedler.txt ."
          call systemf(imp1,iErr)
          imp1="ln -sf ../molcas_canorb_fiedler.txt ."
          call systemf(imp1,iErr)
        enddo
        call systemf("ln -sf ../chemps2.log .",iErr)
      end if
#endif

!Quan: a very dirty way to extract the total energy
       call systemf(
     & 'grep "***  2-RDM" -B 5 chemps2.log | grep "all instructions" '//
     & '| cut -c 61- > chemps2_totale_4d', iErr)

!Quan: fix bug E(FCI) != E(CASSCF)
      call systemf(
     & 'grep "Econst" chemps2.log | cut -c 39- > chemps2_totale', iErr)

      LUTOTE = isFreeUnit(30)
      call molcas_open(LUTOTE,'chemps2_totale')

!Quan: write energy to ENER
      do chemroot=1,lroots
        read(LUTOTE,*) ENER(chemroot,ITER)
      enddo
      close(LUTOTE)

!Quan: check the difference between ener and ener_4d
      LUTOTE = isFreeUnit(30)
      call molcas_open(LUTOTE,'chemps2_totale_4d')
      do chemroot=1,lroots
        read(LUTOTE,*) chemps2_totale_4d
        revdiff = abs(chemps2_totale_4d -
     &                  ENER(chemroot,ITER))/chemps2_totale_4d
        if (revdiff > 1.0D-9) then
          write(6,*) 'CHEMPS2> large (E(4m) - E(m))/E(4m) = ',
     &      revdiff, 'for root', chemroot, ', consider increasing m!'
        endif
      enddo
      close(LUTOTE)


!Quan: check chemps2 convergence
      write (rootindex, "(I2)") lroots+9
      imp1=""
      imp1="grep ""***  2-RDM"" -B "//trim(adjustl(rootindex))//
     & " chemps2.log | grep ""Energy difference"""//
     & " | cut -c 69- > chemps2_conv"
      call systemf(imp1,iErr)

      LUCONV = isFreeUnit(30)
      call molcas_open(LUCONV,'chemps2_conv')
      do chemroot=1,lroots
         read(LUCONV,*) chemps2_conv
         write(6,'(1X,A14,I3,A30,E10.2)') 'CHEMPS2> Root ', chemroot,
     &              ' :: DMRG energy convergence : ', chemps2_conv
         if (abs(chemps2_conv) > THRE/2.0) then
            write(6,*) 'CHEMPS2> DMRG not converged, ',
     &                 'consider increasing MXSWeep'
         endif
      enddo
      close(LUCONV)

!Quan: check if CheMPS2 finished without error
      imp1="grep ""Info on DMRG"" chemps2.log | "//
     &       "cut -c 43- > chemps2_info"
      call systemf(imp1,iErr)

      LUCONV = isFreeUnit(30)
      call molcas_open(LUCONV,'chemps2_info')
      read(LUCONV,*) chemps2_info
      close(LUCONV)
      if ( chemps2_info .NE. 0 ) then
       write(6,*) 'CHEMPS2> CheMPS2 ends abnormally, check calculation'
      endif



      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!***********************************************************************

subroutine R1IBas()
!***********************************************************************
!                                                                      *
!     purpose: Read basis set informations.                            *
!                                                                      *
!***********************************************************************

use InfSCF, only: Atom, BName, BType, Header, nAtoms, nBas, nSym, PotNuc
use Molcas, only: LenIn
use stdalloc, only: mma_allocate
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: lthBas, nBas_Tot

!----------------------------------------------------------------------*
!     Start                                                            *
!----------------------------------------------------------------------*

! read file header
call Get_cArray('Seward Title',Header,144)
! read number of symm. species
call Get_iScalar('nSym',nSym)
! read number of basis functions per symmetry species
call Get_iArray('nBas',nBas,nSym)
! read basis function labels
nBas_tot = sum(nBas(1:nSym))
call mma_allocate(BName,nBas_tot,Label='BName')
call Get_cArray('Unique Basis Names',BName,(LenIn+8)*nBas_tot)
! read number of atoms
call Get_iScalar('Unique atoms',nAtoms)
! read nuclear potential
!call get_dScalar('PotNuc',PotNuc)
call Peek_dScalar('PotNuc',PotNuc)

! Compute lengths of matrices
lthBas = sum(nBas(1:nSym))
call mma_allocate(Atom,lthBas,Label='Atom')
call mma_allocate(BType,lthBas,Label='BType')

! Define atom and type
Atom(:) = BName(1:lthBas)(1:LenIn)
BType(:) = BName(1:lthBas)(LenIn+1:LenIn+8)

return

end subroutine R1IBas

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
* This routine put scalar integer data to the runfile.                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
* Author:  Per-Olof Widmark                                            *
*          Lund University                                             *
*          Sweden                                                      *
* Written: August 2003                                                 *
*                                                                      *
************************************************************************
*  Put_iScalar
*
*> @brief
*>   Add/update scalar data in runfile
*> @author Per-Olof Widmark
*>
*> @details
*> This routine is used to put scalar data of type
*> ``Integer`` into the runfile. The data items are
*> identified by the \p label. Below is a list of the
*> data items that are recognized. The labels are
*> case insensitive and significant to 16 characters.
*>
*> For development purposes you can use an unsupported
*> label. Whenever such a field is accessed a warning
*> message is printed in the output, to remind the
*> developer to update this routine.
*>
*> List of known labels:
*>
*> - '``Multiplicity``'               The spin multiplicity of the last SCF or RASSCF calculation.
*> - '``nMEP``'                       Number of points on the minimum energy path.
*> - '``No of Internal coordinates``' The number of internal coordinates for the molecule that is allowed within the given point group.
*> - '``nSym``'                       The number of irreducible representations of the molecule.
*> - '``PCM info length``'            Length of the block containing misc. info for the PCM model.
*> - '``Relax CASSCF root``'          Signals which root to perform geometry optimization for in a state average CASSCF geometry optimization.
*> - '``SA ready``'                   Signals that SA wavefunction is ready for gradient calculations.
*> - '``System BitSwitch``'           A bit switch controlling various functions. Will be replaced!
*> - '``Unique atoms``'
*> - '``nActel``'                     The number of active electrons in CASSCF calculation.
*> - '``MkNemo.nMole``'               The number of molecules as specified in the mknemo module.
*> - '``nLambda``'                    The number of constraints in the PCO.
*> - '``DNG``'                        Force numerical gradients.
*> - '``HessIter``'                   Last iteration where the analytical Hessian was computed.
*> - '``TS Search``'                  Flag to mark if a TS search has been activated.
*> - '``CHCCLarge``'                  Segmentation of VOs in CHCC.
*> - '``Seed``'                       The seed number for random number generator used in surface hoping.
*>
*> @param[in] Label Name of field
*> @param[in] Data  Data to put on runfile
************************************************************************
      Subroutine Put_iScalar(Label,Data)
      Implicit None
#include "pg_is_info.fh"
*----------------------------------------------------------------------*
* Arguments                                                            *
*----------------------------------------------------------------------*
      Character*(*) Label
      Integer       Data
*----------------------------------------------------------------------*
* Define local variables                                               *
*----------------------------------------------------------------------*
      Integer      RecVal(nTocIS)
      Character*16 RecLab(nTocIS)
      Integer      RecIdx(nTocIS)
      Save         RecVal
      Save         RecLab
      Save         RecIdx
*
      Character*16 CmpLab1
      Character*16 CmpLab2
      Integer      nData
      Integer      item
      Integer      iTmp
      Integer      i
*----------------------------------------------------------------------*
* Initialize local variables                                           *
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
* Do setup if this is the first call.                                  *
*----------------------------------------------------------------------*
      Call ffRun('iScalar labels',nData,iTmp)
      If(nData.eq.0) Then
         Do i=1,nTocIS
            RecLab(i)=' '
            RecVal(i)=0
            RecIdx(i)=sNotUsed
         End Do
*
*        Observe that label is at most 16 characters!
*
*                     1234567890123456
         RecLab(  1)='Multiplicity    '
         RecLab(  2)='nMEP            '
         RecLab(  3)='No of Internal c' !oordinates
         RecLab(  4)='nSym            '
         RecLab(  5)='PCM info length '
         RecLab(  6)='Relax CASSCF roo' !t
         RecLab(  7)='System BitSwitch'
         RecLab(  8)='Unique atoms    '
         RecLab(  9)='LP_nCenter      '
         RecLab( 10)='ChoIni          '
         RecLab( 11)='Unit Cell NAtoms'
         RecLab( 12)='Cholesky Reorder'
         RecLab( 13)='ChoVec Address  '
         RecLab( 14)='SA ready        '
         RecLab( 15)='NumGradRoot     '
         RecLab( 16)='Number of roots '
         RecLab( 17)='LoProp Restart  '
         RecLab( 18)='MpProp nOcOb    '
         RecLab( 19)='Highest Mltpl   '
         RecLab( 20)='nActel          '
         RecLab( 21)='Run_Mode        '
         RecLab( 22)='Grad ready      '
         RecLab( 23)='ISPIN           '
         RecLab( 24)='SCF mode        '
         RecLab( 25)='MkNemo.nMole    '
         RecLab( 26)='N ZMAT          '
         RecLab( 27)='Bfn Atoms       '
         RecLab( 28)='FMM             '
         RecLab( 29)='Pseudo atoms    '
         RecLab( 30)='nChDisp         '
         RecLab( 31)='iOff_Iter       '
         RecLab( 32)='Columbus        '
         RecLab( 33)='ColGradMode     '
         RecLab( 34)='IRC             '
         RecLab( 35)='MaxHops         '
         RecLab( 36)='nRasHole        '
         RecLab( 37)='nRasElec        '
         RecLab( 38)='Rotational Symme' !try Number
         RecLab( 39)='Saddle Iter     '
         RecLab( 40)='iMass           '
!        True(=1) if mbpt2 was run with prpt
         RecLab( 41)='mp2prpt         '
         RecLab( 42)='NJOB_SINGLE     '
         RecLab( 43)='MXJOB_SINGLE    '
         RecLab( 44)='NSS_SINGLE      '
         RecLab( 45)='NSTATE_SINGLE   '
         RecLab( 46)='LDF Status      ' ! Initialized or not
         RecLab( 47)='DF Mode         ' ! Local (1) or non-local (0) DF
         RecLab( 48)='agrad           ' ! Forces analytical gradients
         RecLab( 49)='LDF Constraint  ' ! Constraint type for LDF
         RecLab( 50)='OptimType       ' ! Optimization type in hyper
         RecLab( 51)='STSYM           ' ! symmetry of the CAS root(s)
         RecLab( 52)='RF CASSCF root  '
         RecLab( 53)='RF0CASSCF root  '
         RecLab( 54)='nCoordFiles     ' ! number of xyz-files in gateway
         RecLab( 55)='nLambda         '
         RecLab( 56)='DNG             '
         RecLab( 57)='HessIter        '
c         RecLab( 58)='GEO_nConnect    '
         RecLab( 58)='CHCCLarge       ' ! Segmentation of VOs in CHCC
         RecLab( 59)='TS Search       '
         RecLab( 60)='Number of Hops  '
         RecLab( 61)='hopped          '
         RecLab( 62)='Invert constrain' !ts
         RecLab( 63)='Keep old gradien' !t
!        Flag whether an embedding potential is present
         RecLab( 64)='embpot          '
         RecLab( 65)='nPrim           '
         RecLab( 66)='Seed            '
         RecLab( 67)='Track Done      '
         RecLab( 68)='MaxHopsTully    '
!        Flag Effective fragment potentials
         RecLab( 69)='EFP             '
         RecLab( 70)='nEFP_fragments  '
         RecLab( 71)='Coor_Type       ' ! EFP fragment coordinate format
!        Associated number of coordinates per fragment
         RecLab( 72)='nEFP_Coor       '
         RecLab( 73)='Relax Original r' !oot
         RecLab( 74)='Unique centers  '
         RecLab( 75)='nXF             '
         RecLab( 76)='CSPF            '
*        For MS-PDFT gradient
         RecLab( 77)='NCONF           '
         RecLab( 78)='SH RASSI run    '
*                     1234567890123456
*
*        Note, when the counter here exceeds 128 update this line
*        and the nTocIS parameter in pg_is_info.fh!
*
         Call cWrRun('iScalar labels',RecLab,16*nTocIS)
         Call iWrRun('iScalar values',RecVal,nTocIS)
         Call iWrRun('iScalar indices',RecIdx,nTocIS)
      Else
         Call cRdRun('iScalar labels',RecLab,16*nTocIS)
         Call iRdRun('iScalar values',RecVal,nTocIS)
         Call iRdRun('iScalar indices',RecIdx,nTocIS)
      End If
*----------------------------------------------------------------------*
* Locate item                                                          *
*----------------------------------------------------------------------*
      item=-1
      CmpLab1=Label
      Call UpCase(CmpLab1)
      Do i=1,nTocIS
         CmpLab2=RecLab(i)
         Call UpCase(CmpLab2)
         If(CmpLab1.eq.CmpLab2) item=i
      End Do
*
* Do we create a new temporary field?
*
      If(item.eq.-1) Then
         Do i=1,nTocIS
            If(RecLab(i).eq.' ') item=i
         End Do
         If(item.ne.-1) Then
            RecLab(item)=Label
            RecIdx(item)=sSpecialField
            Call cWrRun('iScalar labels',RecLab,16*nTocIS)
            Call iWrRun('iScalar indices',RecIdx,nTocIS)
         End If
      End If
*
* Is this a temporary field?
*
      If(item.ne.-1) Then
         If(Recidx(item).eq.sSpecialField) Then
            Write(6,*) '***'
            Write(6,*) '*** Warning, writing temporary iScalar field'
            Write(6,*) '***   Field: ',Label
            Write(6,*) '***'
#ifndef _DEVEL_
            Call AbEnd()
#endif
         End If
      End If
*----------------------------------------------------------------------*
* Write data to disk.                                                  *
*----------------------------------------------------------------------*
      If(item.eq.-1) Then
         Call SysAbendMsg('put_iScalar','Could not locate',Label)
      End If
      RecVal(item)=Data
      Call iWrRun('iScalar values',RecVal,nTocIS)
      If(RecIdx(item).eq.0) Then
         RecIdx(item)=sRegularField
         Call iWrRun('iScalar indices',RecIdx,nTocIS)
      End If
*----------------------------------------------------------------------*
*                                                                      *
*----------------------------------------------------------------------*
      Do i=1,num_IS_init
         If(iLbl_IS_inmem(i).eq.CmpLab1) Then
             i_IS_inmem(i)=Data
             IS_init(i)=1
             return
         End If
      End Do

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine FndTess(iPrint,ToAng,LcNAtm,Xs,Ys,Zs,Rs,pNs,nn)
      use PCM_arrays, only: PCMSph, PCMTess, Vert, Centr, SSph, PCMDM,
     &                      PCM_N, PCMiSph, NVert, IntSph, NewSph
      Implicit Real*8(A-H,O-Z)
#include "stdalloc.fh"
#include "WrkSpc.fh"
#include "rctfld.fh"
#include "status.fh"
      Real*8 Xs(nn), Ys(nn), Zs(nn), Rs(nn)
      Integer pNs(nn)
      Real*8, Allocatable:: Xt(:),Yt(:),Zt(:),At(:),
     &                      pVert(:),pCentr(:),pSSph(:),
     &                      CV(:)
      Integer, Allocatable:: pNewS(:), pIntS(:), pNVert(:), pISph(:),
     &                       JTR(:)
*
*     Definition of solute cavity and computation of vertices,
*     representative points and surfaces of the tesserae by the
*     Gauss-Bonnet Theorem.
*
*     Allocate space for X, Y, Z, Area, ISPHE (index of sphere to which
*     tessera belongs); then allocate space for IntSph (indices of spheres
*     cutting the tessera), NewSph (indices of spheres creating new smoothing
*     spheres), SSph (surface of each sphere exposed to the solvent),
*     Finally, allocate temporary space for NVert (number of vertices for
*     any tessera), Vert (coordinates of vertices), Centr (center of arcs).
*
      Call mma_allocate(Xt,MxTs,Label='Xt')
      Call mma_allocate(Yt,MxTs,Label='Yt')
      Call mma_allocate(Zt,MxTs,Label='Zt')
      Call mma_allocate(At,MxTs,Label='At')
      Call mma_allocate(pVert,3*MxVert*MxTs,Label='pVert')
      Call mma_allocate(pCentr,3*MxVert*MxTs,Label='pCentr')
      Call mma_allocate(pSSph,MxSph,Label='pSSph')
      Call mma_allocate(CV,3000,Label='CV')
*
      Call mma_allocate(JTR,3*MxTs,Label='JTR')
      Call mma_allocate(pISph,MxTs,Label='pIShp')
      Call mma_allocate(pNVert,MxTs,Label='pNVert')
      Call mma_allocate(pIntS,MxVert*MxTs,Label='pIntS')
      Call mma_allocate(pNewS,2*MxSph,Label='pNewS')
*
      Omega = RSlPar(2)
      Ret = RSlPar(3)
      Fro = RSlPar(4)
      TsAre = RSlPar(7)
      RSolv = RSlPar(19)
      ITsNum = ISlPar(11)
*
      Call FndTess_(iPrint,ToAng,LcNAtm,MxSph,MxTs,
     &             Xs,Ys,Zs,Rs,
     &             Ret,Omega,Fro,RSolv,NSinit,NS,ITsNum,TsAre,nTs,
     &             Xt,Yt,Zt,At,pISph,pNVert,pVert,
     &             pCentr,pIntS,pNewS,pSSph,JTR,CV)
*                                                                      *
************************************************************************
*     Re-allocate with actual dimensioning                             *
      If (RctFld_Status.ne.Active) Then
*
*--------Allocate PCM arrays
         Call mma_allocate(PCMSph,4,NS,Label='PCMSph')
         Call mma_allocate(PCMTess,4,nTs,Label='PCMTess')
         Call mma_allocate(Vert,3,MxVert,nTs,Label='Vert')
         Call mma_allocate(Centr,3,MxVert,nTs,Label='Centr')
         Call mma_allocate(SSph,NS,Label='SSph')
         Call mma_allocate(PCMDM,nTs,nTs,Label='PCMDM')
         Call mma_allocate(PCM_N,NS,Label='PCM_N')
         Call mma_allocate(PCMiSph,nTs,Label='PCMiSph')
         Call mma_allocate(NVert,nTs,Label='NVert')
         Call mma_allocate(IntSph,MxVert,nTs,Label='IntSph')
         Call mma_allocate(NewSph,2,NS,Label='NewSph')
*
         nPCM_info_r = 4*NS +  4*nTs + 3*MxVert*nTs + 3*MxVert*nTs
     &             + NS + nTs**2
         nPCM_info_i = NS +nTs + nTs + MxVert*nTs + 2*NS + nTs**2
         nPCM_info = nPCM_info_r + nPCM_info_i
*
      End If
*
      ! PCMSph
      Do iS = 1, NS
         PCMSph(1,iS)=Xs(iS)
         PCMSph(2,iS)=Ys(iS)
         PCMSph(3,iS)=Zs(iS)
         PCMSph(4,iS)=Rs(iS)
      End Do
*
      ! PCMTess
      Do iTs = 1, nTs
         PCMTess(1,iTs)=Xt(iTs)
         PCMTess(2,iTs)=Yt(iTs)
         PCMTess(3,iTs)=Zt(iTs)
         PCMTess(4,iTs)=At(iTs)
      End Do
*
      ! Vert
      call dcopy_(3*MxVert*nTs,pVert,1,Vert,1)
*
      ! Centr
      call dcopy_(3*MxVert*nTs,pCentr,1,Centr,1)
*
      ! SSph
      call dcopy_(nS,pSSph,1,SSph,1)
*
*
      ! nOrd
      Call ICopy(nS,pNs,1,PCM_N,1)
*
      ! ISph
      Call ICopy(nTs,pISph,1,PCMiSph,1)
*
      ! NVert
      Call ICopy(nTs,pNVert,1,NVert,1)
*
      ! IntSph
      Call ICopy(MxVert*nTs,pIntS,1,IntSph,1)
*
      ! NewSph
      Call ICopy(2*NS,pNewS,1,NewSph,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Deallocate temporary memory
*
      Call mma_deallocate(pNewS)
      Call mma_deallocate(pIntS)
      Call mma_deallocate(pNVert)
      Call mma_deallocate(pISph)
      Call mma_deallocate(JTR)
      Call mma_deallocate(CV)
      Call mma_deallocate(pSSPh)
      Call mma_deallocate(pCentr)
      Call mma_deallocate(pVert)
      Call mma_deallocate(At)
      Call mma_deallocate(Zt)
      Call mma_deallocate(Yt)
      Call mma_deallocate(Xt)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
      Subroutine FndTess_(IPrint,ToAng,NAT,MxSph,MxTs,XE,YE,ZE,RE,
     &                   RET,Omega,FRO,RSolv,NEsfP,NEsf,ITsNum,TSAre,
     &                   NTS,XCTs,YCTs,ZCTs,AS,ISphe,Nvert,Vert,
     &                   Centr,IntSph,NewSph,SSfe,JTR,CV)

      Implicit Real*8(A-H,O-Z)
      Parameter (MxVert=20)
C
C     Definition of solute cavity and computation of vertices,
C     representative points and surfaces of the tesserae by the
C     Gauss-Bonnet Theorem.
C
      Dimension XCTs(*),YCTs(*),ZCTs(*),AS(*)
      Dimension ISphe(*)
      Dimension XE(*),YE(*),ZE(*),RE(*)
      Dimension SSFE(*),IntSph(MxVert,*),NVert(*)
      Dimension NewSph(2,*)
      Dimension Vert(3,MxVert,*),Centr(3,MxVert,*)
      Dimension JTR(3,*),CV(3,*)
      Dimension PP(3),PTS(3,MxVert),CCC(3,MxVert)
      Save Zero,First
      DATA ZERO,FIRST/0.0D0,0.0174533D0/
C
C PEDRA works with Angstroms
      DO 2000 ISFE = 1, NESFP
        XE(ISFE) = XE(ISFE) * ToAng
        YE(ISFE) = YE(ISFE) * ToAng
        ZE(ISFE) = ZE(ISFE) * ToAng
 2000 continue
      NESF = NESFP
      IF(IPRINT.EQ.2) WRITE(6,800)
C
C                   creation of new spheres
C
      DO 2010 N = 1, NESF
      NEWSPH(1,N) = 0
      NEWSPH(2,N) = 0
 2010 continue
      ITYPC = 0
      OMEGA=OMEGA*FIRST
      SENOM=Sin(OMEGA)
      COSOM2=(cos(OMEGA))**2
      RTDD=RET+RSOLV
      RTDD2=RTDD*RTDD
      NET=NESF
      NN=2
      NE=NESF
      NEV=NESF
      GO TO 100
  110 NN=NE+1
      NE=NET
      IF(NE.GT.MxSph)THEN
      Write(6,1111)
1111  format(' Cavity: too many spheres; increase Omega')
      Call Abend()
      ENDIF
  100 DO 120 I=NN,NE
      NES=I-1
      DO 130 J=1,NES
      RIJ2=(XE(I)-XE(J))**2+
     $     (YE(I)-YE(J))**2+
     $     (ZE(I)-ZE(J))**2
      RIJ=sqrt(RIJ2)
      RJD=RE(J)+RSOLV
      TEST1=RE(I)+RJD+RSOLV
      IF(RIJ.GE.TEST1) GO TO 130
      REG=MAX(RE(I),RE(J))
      REP=MIN(RE(I),RE(J))
      REG2=REG*REG
      REP2=REP*REP
      TEST2=REP*SENOM+sqrt(REG2-REP2*COSOM2)
      IF(RIJ.LE.TEST2) GO TO 130
      REGD2=(REG+RSOLV)*(REG+RSOLV)
      TEST3=(REGD2+REG2-RTDD2)/REG
      IF(RIJ.GE.TEST3) GO TO 130
      DO 140 K=1,NEV
      IF(K.EQ.J .OR. K.EQ.I) GO TO 140
      RJK2=(XE(J)-XE(K))**2+
     $     (YE(J)-YE(K))**2+
     $     (ZE(J)-ZE(K))**2
      IF(RJK2.GE.RIJ2) GO TO 140
      RIK2=(XE(I)-XE(K))**2+
     $     (YE(I)-YE(K))**2+
     $     (ZE(I)-ZE(K))**2
      IF(RIK2.GE.RIJ2) GO TO 140
       RJK=sqrt(RJK2)
       RIK=sqrt(RIK2)
       SP=(RIJ+RJK+RIK)/2.0D0
       HH=4*(SP*(SP-RIJ)*(SP-RIK)*(SP-RJK))/RIJ2
       REO=RE(K)*FRO
      IF(K.GE.NE)REO=0.0002D0
      REO2=REO*REO
      IF(HH.LT.REO2) GO TO 130
  140 CONTINUE
      REPD2=(REP+RSOLV)**2
      TEST8=sqrt(REPD2-RTDD2)+sqrt(REGD2-RTDD2)
      IF(RIJ.LE.TEST8)GO TO 150
      REND2=REGD2+REG2-(REG/RIJ)*(REGD2+RIJ2-REPD2)
      IF(REND2.LE.RTDD2) GO TO 130
      REN=sqrt(REND2)-RSOLV
      FC=REG/(RIJ-REG)
      TEST7=REG-RE(I)
      KG=I
      KP=J
      IF(TEST7.LE.0.000000001D0) GO TO 160
      KG=J
      KP=I
  160 FC1=FC+1.0D0
      XEN=(XE(KG)+FC*XE(KP))/FC1
      YEN=(YE(KG)+FC*YE(KP))/FC1
      ZEN=(ZE(KG)+FC*ZE(KP))/FC1
      ITYPC = 1
      GO TO 170
  150 R2GN=RIJ-REP+REG
      RGN=R2GN/2.0D0
      FC=R2GN/(RIJ+REP-REG)
      FC1=FC+1.0D0
      TEST7=REG-RE(I)
      KG=I
      KP=J
      IF(TEST7.LE.0.000000001D0) GO TO 180
      KG=J
      KP=I
  180 XEN=(XE(KG)+FC*XE(KP))/FC1
      YEN=(YE(KG)+FC*YE(KP))/FC1
      ZEN=(ZE(KG)+FC*ZE(KP))/FC1
      REN=sqrt(REGD2+RGN*(RGN-(REGD2+RIJ2-REPD2)/RIJ))-RSOLV
  170 NET=NET+1
      XE(NET)=XEN
      YE(NET)=YEN
      ZE(NET)=ZEN
      RE(NET)=REN
C
C     Nella matrice NEWSPH(2,NESF) sono memorizzati i numeri delle
C     sfere "generatrici" della nuova sfera NET: se la nuova sfera e'
C     del tipo A o B entrambi i numeri sono positivi, se e' di tipo
C     C il numero della sfera "principale" e' negativo
C     (per la definizione del tipo si veda JCC 11, 1047 (1990))
C
      IF(ITYPC.EQ.0) THEN
        NEWSPH(1,NET) = KG
        NEWSPH(2,NET) = KP
      ELSEIF(ITYPC.EQ.1) THEN
      NEWSPH(1,NET) = - KG
      NEWSPH(2,NET) = KP
      ENDIF
C
  130 CONTINUE
      NEV=NET
  120 CONTINUE
      IF(NET.NE.NE) GO TO 110
      NESF=NET
C
C                    Division of the surface into tesserae
C
      VCav=ZERO
      Scav=ZERO
C
C     Controlla se ciascuna tessera e' scoperta o va tagliata
C
      NN1 = 0
      DO 300 NSFE = 1, NESF
      XEN = XE(NSFE)
      YEN = YE(NSFE)
      ZEN = ZE(NSFE)
      REN = RE(NSFE)
      If(ITsNum.eq.0.and.TsAre.eq.0.d0) then
        IPtype = 2
        IPFlag = 0
        ITsNum = 60
      ElseIf(ITsNum.gt.0.and.TsAre.eq.0.d0) Then
        IPFlag = 0
      ElseIf(TsAre.gt.0.d0) Then
        IPFlag = 1
      EndIf
      Call PolyGen(MxTs,IPtype,IPflag,TsAre,ITsNum,
     +             XEN,YEN,ZEN,REN,ITsEff,CV,JTR)
      DO 310 ITS = 1, ITsEff
      N1 = JTR(1,ITS)
      N2 = JTR(2,ITS)
      N3 = JTR(3,ITS)
      PTS(1,1)=CV(1,N1)
      PTS(2,1)=CV(2,N1)
      PTS(3,1)=CV(3,N1)
      PTS(1,2)=CV(1,N2)
      PTS(2,2)=CV(2,N2)
      PTS(3,2)=CV(3,N2)
      PTS(1,3)=CV(1,N3)
      PTS(2,3)=CV(2,N3)
      PTS(3,3)=CV(3,N3)
      NV=3
      DO 2020 JJ = 1, 3
      PP(JJ) = ZERO
 2020 continue
C
C     Per ciascuna tessera, trova la porzione scoperta e ne
C     calcola l'area con il teorema di Gauss-Bonnet; il punto
C     rappresentativo e' definito come media dei vertici della porzione
C     scoperta di tessera e passato in PP.
C     I vertici di ciascuna tessera sono conservati in
C     VERT(3,MxVert,MxTs), il numero di vertici di ciascuna tessera e'
C     in NVERT(MxTs), e i centri dei cerchi di ciascun lato sono in
C     CENTR(3,MxVert,MxTs). In INTSPH(MxVert,MxTs) sono registrate le
C     sfere a cui appartengono i lati delle tessere.

      CALL TESSERA(iPrint,MxTs,Nesf,NSFE,NV,XE,YE,ZE,RE,IntSph,
     &             PTS,CCC,PP,AREA)
      IF(AREA.EQ.0.D0) GOTO 310
      NN1 = NN1 + 1
      NN = Min(NN1,MxTs)
      XCTS(NN) = PP(1)
      YCTS(NN) = PP(2)
      ZCTS(NN) = PP(3)
      AS(NN) = AREA

      ISPHE(NN) = NSFE
      NVERT(NN) = NV
      DO 2030 IV = 1, NV
        DO 2040 JJ = 1, 3
          VERT(JJ,IV,NN) = PTS(JJ,IV)
          CENTR(JJ,IV,NN) = CCC(JJ,IV)
 2040 continue
 2030 continue
      DO 2050 IV = 1, NV
        INTSPH(IV,NN) = INTSPH(IV,MxTs)
 2050 continue
 310  CONTINUE
 300  CONTINUE
      NTS = NN
C
C     Verifica se due tessere sono troppo vicine
      TEST = 0.02D0
      TEST2 = TEST*TEST
      DO 400 I = 1, NTS-1
      IF(AS(I).EQ.ZERO) GOTO 400
      XI = XCTS(I)
      YI = YCTS(I)
      ZI = ZCTS(I)
      II = I + 1
      DO 410 J = II , NTS
      IF(ISPHE(I).EQ.ISPHE(J)) GOTO 410
      IF(AS(J).EQ.ZERO) GOTO 410
      XJ = XCTS(J)
      YJ = YCTS(J)
      ZJ = ZCTS(J)
      RIJ = (XI-XJ)**2 + (YI-YJ)**2 + (ZI-ZJ)**2
      IF(RIJ.GT.TEST2) GOTO 410
C
C     La routine originaria sostituiva le due tessere troppo vicine con una
C     sola tessera. Nel caso Gauss-Bonnet, anche i vertici delle tessere
C     e i centri degli archi vengono memorizzati ed e' impossibile sostituirli
C     nello stesso modo: percio' l'area della tessera piu' piccola verra'
C     trascurata per evitare problemi nella autopolarizzazione.
      IF(IPRINT.EQ.2) WRITE(6,1000)I,J,TEST2
      IF(AS(I).LT.AS(J)) AS(I) = ZERO
      IF(AS(I).GE.AS(J)) AS(J) = ZERO
 410  CONTINUE
 400  CONTINUE
C
C     E' preferibile eliminare del tutto le tessere che per
C     qualche motivo hanno AREA = 0, ridefinendo tutti gli
C     indici: l'errore numerico cosi' introdotto e' in genere
C     trascurabile e si evitano problemi di convergenza
C
C     Define here the number of tesserae in electrostatic calculations
C     to avoid problems in successive calcn.
      ITS = 0
450   ITS = ITS + 1
      IF (AS(ITS).LT.1.D-10) THEN
        DO 2060 I = ITS, NTS - 1
          AS(I) = AS(I+1)
          XCTS(I) = XCTS(I+1)
          YCTS(I) = YCTS(I+1)
          ZCTS(I) = ZCTS(I+1)
          ISPHE(I) = ISPHE(I+1)
          NVERT(I) = NVERT(I+1)
          DO 2070 IV = 1, MxVert
            INTSPH(IV,I) = INTSPH(IV,I+1)
            DO 2080 IC = 1, 3
              VERT(IC,IV,I) = VERT(IC,IV,I+1)
              CENTR(IC,IV,I) = CENTR(IC,IV,I+1)
 2080 continue
 2070 continue
 2060 continue
        NTS = NTS - 1
        ITS = ITS - 1
      ENDIF
      IF(ITS.LT.NTS) GOTO 450
C***********************************************************
C     Calcola il volume della cavita' con la formula (t. di Gauss):
C                V=SOMMAsulleTESSERE{A r*n}/3
C     dove r e' la distanza del punto rappresentativo dall'origine,
C     n e' il versore normale alla tessera, A l'area della tessera,
C     e * indica il prodotto scalare.
C***********************************************************
      VCav = ZERO
      DO 2090 ITS = 1, NTS
        NSFE = ISPHE(ITS)
C     Trova il versore normale
        XN = (XCTS(ITS) - XE(NSFE)) / RE(NSFE)
        YN = (YCTS(ITS) - YE(NSFE)) / RE(NSFE)
        ZN = (ZCTS(ITS) - ZE(NSFE)) / RE(NSFE)
C     Trova il prodotto scalare
        PROD = XCTS(ITS)*XN + YCTS(ITS)*YN + ZCTS(ITS)*ZN
        VCav = VCav + AS(ITS) * PROD / 3.D0
 2090 continue
C***********************************************************
C     Stampa la geometria della cavita'
      Scav=ZERO
      DO 500 I=1,NESF
      SSFE(I)=ZERO
 500  CONTINUE
      DO 510 I=1,NTS
      K=ISPHE(I)
      SSFE(K)=SSFE(K)+AS(I)
 510  CONTINUE
      OMEGA=OMEGA/FIRST
      IF(IPRINT.EQ.2) WRITE(6,1100)OMEGA,RSOLV,RET,FRO,NESF
      DO 520 I=1,NESF
      IF(IPRINT.EQ.2)WRITE(6,1200)I,XE(I),YE(I),ZE(I),
     * RE(I),SSFE(I)
      Scav=Scav+SSFE(I)
 520  CONTINUE
      IF(IPRINT.EQ.2)WRITE(6,1300)NTS,Scav,VCav
C
C     Trasforma i risultati in bohr
      DO 2170 I=1,NESF
        RE(I)=RE(I) / ToAng
        XE(I)=XE(I) / ToAng
        YE(I)=YE(I) / ToAng
        ZE(I)=ZE(I) / ToAng
 2170 continue
      DO 2180 I=1,NTS
        DO 2190 J=1,NVERT(I)
          DO 2200 L=1,3
            VERT(L,J,I) = VERT(L,J,I) / ToAng
            CENTR(L,J,I) = CENTR(L,J,I) / ToAng
 2200 continue
 2190 continue
 2180 continue
      DO 2210 I=1,NTS
        AS(I)=AS(I) / (ToAng*ToAng)
        XCTS(I)=XCTS(I) / ToAng
        YCTS(I)=YCTS(I) / ToAng
        ZCTS(I)=ZCTS(I) / ToAng
 2210 continue
      IF(IPRINT.EQ.3)THEN
      WRITE(6,1500)
      WRITE(6,1600)
      WRITE(6,1700)(I,ISPHE(I),AS(I),XCTS(I),YCTS(I),ZCTS(I),
     *              I = 1, NTS)
      ENDIF
      If(NN1.gt.MxTs) then
        Write(6,1240) NN1, MxTs
 1240   Format(' NN1=',I10,' but MxTs=',I10,'.')
        Write(6,1112)
 1112   format('Too many tesserae.')
        Call Abend
        endIf

      RETURN
 800  FORMAT(/,'**** POLARISABLE CONTINUUM MODEL - UNIVERSITIES',
     & ' OF NAPLES AND PISA *****')
1000  FORMAT(/,'ATTENZIONE: I CENTRI DELLE TESSERE ',I4,',',I4,
     *  ' DISTANO MENO DI',F8.6,' A',/)
1100  FORMAT(/,'** CHARACTERISTICS OF THE CAVITY **',
     * //, '  GEOMETRICAL PARAMETERS: OMEGA=',F8.3,' RSOLV=',F8.3,
     * ' RET=',F8.3,' FRO=',F8.3,
     * //,'  TOTAL NUMBER OF SPHERES',I5,//,'  CENTERS AND RADII :',//,
     *       '  SPHERE       CENTER  (X,Y,Z) (A)     RADIUS (A)',
     * '       AREA(A*A)')
c1200  FORMAT(I5,4F15.9,F18.9)
1200  FORMAT(I5,4F10.3,F18.3)
1300  FORMAT(/,' TOTAL NUMBER OF TESSERAE ',I8,//,
     *' SURFACE AREA',F14.8,'(A**2)',8X,'CAVITY VOLUME',
     * F14.8,' (A**3)')
*1400  FORMAT(/,'SFERA',I4,' COORD.',I4,'  DERIVATA   ',F10.6,/)
1500  FORMAT('1 *** SUDDIVISIONE DELLA SUPERFICIE  ***')
1600  FORMAT(' TESSERA  SFERA   AREA   X Y Z CENTRO TESSERA  ',
     * 'X Y Z PUNTO NORMALE')
1700  FORMAT(2I4,7F12.7)
*1800  FORMAT(/,'**** END OF CAVITY DEFINITION ****',/)
c Avoid unused argument warnings
      IF (.FALSE.) CALL Unused_integer(NAT)
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Integer Function iBion(M,N)
C
C     Compute binomial coefficients recursively
C
      Real*8 Temp1,Temp2,Temp3,Temp4
C
      If ( N.lt.0 .or. M.lt.N ) then
         write(6,*) 'Wrong params is iBion',M,N
         Call Abend
      End If
      If ( N.eq.0 .or. M.eq.0 ) then
         iBion=1
         Return
      Else If ( N.eq.1 ) then
         iBion=M
         Return
      Else If ( N.eq.2 ) then
         iBion=M*(M-1)/2
         Return
      End If
      K1=Max((M-N),N)
      K2=Min((M-N),N)
      Temp1=1.0D0
      Do K=1,K2
         Temp2=DBLE(K1+K)
         Temp3=DBLE(K)
         Temp4=Temp2/Temp3
         Temp1=Temp1*Temp4
      End Do
      iBion=nInt(Temp1)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module MCLR_Data

! MXINKA : Resolution of identity
! MXPORB : Maximum number of orbitals
! Note : MXPNGAS = MXPR4T+6 !!
! Required in order to handle GAS and RAS within /LUCINP/

! Stuff from Pointers.fh
!  ipCI, ipCM, ipMat, ipmatba, ipMatLT, ipMO, n1Dens, n2Dens, na, nacpar, nacpr2, nb, nCMO, nconf1, nDens, nDensC, nmba, nna

! Stuff from spin_mclr.fh
!  rbetaa, rbetas, rms

! Stuff from genop.fh
! Type of operator in action
!  I12    : 2:Both on and two electron integrals
!  IST    :
!  Square : Integrals square/triangular

! Stuff from machine.fh
!  nrec

! Stuff from csfsd.fh
!  i1, iAllo, iAnders, lconf, lldet

! Stuff from incdia.fh
!  ipdia

! Stuff from sa.fh
!  esterr, Fancy_Preconditioner, irlxroot, isMECIMSPD, isNAC, istate, NACstates, NSSA, override, SA

! Stuff from MCLR_Data.fh
!  ChDisp, dspvec, lDisp, Mxdccc, nhess, SwLbl

! Stuff from MCLR_Data.fh
!  iRefSm  : Reference symmetry
!  MS2     : 2*MS
!  IDC     : Ms combinations
!  PSSIGN  : Ms combination PS factor

! Stuff from Files_mclr.fh
!  FNCSF2SD, FnHlf2, FNHlf3, FnJob, FnMck, FnMOTRA, FnPT2, FnQDAT, FnTemp, FNTrI1, FNTrI2, FNTRi3, FNTRI4, FNTRI5, FnTwo
!  LUCSF2SD, LUHlf2, LUHlf3, LuJob, LuMck, LuMOTRA, LuPt2, LuQDAT, LuTemp, LUTrI1, LUTrI2, LUTRi3, LUTRI4, LUTRI5, LuTwo
!  Nofile

! Stuff from cicisp_mclr.fh
!  niCISp : Number of CI-spaces (1) *
!  iAStFI : Alpha string type for internal CI space *
!  iBStFI : Beta string type for internal CI space (iBZTP)*
!  iActi  : Active/Inactive space  (1)*
!  MnR1IC : Minimum number of electrons in RAS1*
!  MxR1IC : Maximum    -          "      - RAS1*
!  MnR3IC : Minimum    -          "      - RAS3*
!  MxR3IC : Maximum    -          "      - RAS3*
!  nElCI  : Number of electrons per CI space *
!  nAElCI : Number of alpha electrons per CI space *
!  nBElCI : Number of beta electrons per CI space *
!  xispsm : Number of det. for each (symmetry,CI space) **
!  MXSB   : Largest symmetry block **
!  MXSOOB : Largest block        **

! Stuff from crun_mclr.fh
!  iCIStr  : Storing mode for CI-vector
!  NoCSF   : Transform to CSF base
!  iDiag   : PICO
!  Maxi    : Max number of N str. treated simult.(not in use)y
!  MaxK    : Largest number of inner resolution strings simult
!  NoPart  : Partitioning of strings in alpha-alpha + beta-beta loops
!  NACOB   : Active orbiatls
!  NOCOB   : Occupied
!  NTOOB   : Total
!  NORB1   : RAS1
!  NORB2   : RAS2
!  NORB3   : RAS3
!  IREOTS  : Reordering array type     => symmetry
!  ISMFTO  : Symmetry array for type ordered orbitals
!  IBSO    : First orb of given symmetry (symmetry ordered)
!  NTSOB   : Number of active orb of give RAS type and SYM
!  IBTSOB  : Offset for active orb of given RAS type and SYM
!  ITSOB   : Orbitals of given RAS type and sym
!  NOBPTS  : Number of orbitals per subtype and symmetry
!  ITOBS   : "Increaser"
!  ITFSO   : Type array for symmetry ordered orbitals (not activated)

! Stuff from spinfo_mclr.fh
!  MULTSP : Spin multiplicity
!  MS2P   : 2*MS
!  MINOP  : Minum open orbitals
!  MAXOP  : Maximum open orbitals
!  NTYP   : Maxop-MinOp+1
!  NDPCNT : Number of det. / conf type
!  NCPCNT : Number of csf / conf type
!  NCNATS :
!  NDTASM : Combinations
!  NCSASM : CSF
!  NCNASM : i Configurations

! Stuff from CMSLag
!  ResQaaLag2

! Stuff from negpre
!  ERAS, luciv, MXSTATE, ngp, P1, P1INV, SS

! Stuff from PDFT_UTIL
!  Do_Hybrid, PDFT_Ratio, WF_Ratio

! Stuff from Arrays
!  F0SQMO, FAMO, FAMO_spinm, FAMO_spinp, FIMO, Fm, Fp, Hss, SFock
! Various one- and two-particle densities
!  G1m, G1p, G1t, G2mm, G2mp, G2pp, G2sq, G2t
! MO coefficients
!  CMO, CMO_Inv(:)
!
!  INT1  : 1-electron integrals
!  INT2  : 2-electron integrals
!  PINT1 : Offsets to symmetry blocks
!  PINT2 : Offsets to symmetry blocks
!  KAIN1
!  KINT2
!  KINT2A

! Stuff from Exp
!  H0F, H0S, NewPre, nexp, nexp_max, SBIDT

use Molcas, only: LenIn
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
private

integer(kind=iwp), parameter :: Mxdccc = 500, MXINKA = 200, MXPCSM = 8, MXPCTP = 30, MXPICI = 30, MXPNGAS = 3, MXPOBS = 20, &
                                MXPORB = 500, MXPR4T = 10, MXSTATE = 10

integer(kind=iwp) :: dspvec(mxdccc), i1, I12, IACTI(MXPICI), iAllo, iAnders, IASTFI(MXPICI), IBSO(MXPOBS), IBSTFI(MXPICI), &
                     IBTSOB(3,MXPOBS), ICISTR, IDC, IDIAG, ipCI, ipCM(8), ipdia, ipMat(8,8), ipmatba(8,8), ipMatLT(8,8), &
                     ipMO(8,8,8), IREFSM, IREOTS(MXPORB), irlxroot, ISMFTO(MXPORB), IST, istate, ITSOB(MXPORB), lconf, lDisp(8), &
                     lldet, luciv, LUCSF2SD, LUHlf2, LUHlf3, LuJob, LuMck, LuMOTRA, LuPt2, LuQDAT, LuTemp, LUTrI1, LUTrI2, LUTRi3, &
                     LUTRI4, LUTRI5, LuTwo, MAXI, MAXK, MAXOP, MINOP, MNR1IC(MXPICI), MNR3IC(MXPICI), MS2, MS2P, MULTSP, &
                     MXR1IC(MXPICI), MXR3IC(MXPICI), MXSB, MXSOOB, n1Dens, n2Dens, na(8), NACOB, nacpar, nacpr2, NACstates(2), &
                     NAELCI(MXPICI), nb(8), NBELCI(MXPICI), nCMO, NCNASM(MXPCSM), NCNATS(MXPCTP,MXPCSM), nconf1, NCPCNT(MXPCTP), &
                     NCSASM(MXPCSM), nDens, nDensC, NDPCNT(MXPCTP), NDTASM(MXPCSM), NELCI(MXPICI), nexp = 0, nexp_max = 100, &
                     nhess, NICISP, nmba, nna, NOBPT(MXPR4T+6), NOBPTS(MXPR4T+6,MXPOBS), NOCOB, NOCSF, NOPART, NORB1, NORB2, &
                     NORB3, nrec, NSSA(2), NTOOB, NTSOB(3,MXPOBS), NTYP
real(kind=wp) :: rms, ERAS(MXSTATE), P1(MXSTATE*(MXSTATE+1)/2), P1INV(MXSTATE*(MXSTATE+1)/2), PDFT_Ratio, PSSIGN, rbetaa, rbetas, &
                 ResQaaLag2, WF_Ratio, XISPSM(MXPCSM,MXPICI) = Zero
logical(kind=iwp) :: Do_Hybrid, esterr, Fancy_Preconditioner, isMECIMSPD, isNAC, NewPre = .true., ngp, Nofile, override, SA, square
character(len=LenIn+6) :: ChDisp(Mxdccc*3)
character(len=8) :: FNCSF2SD, FnHlf2, FNHlf3, FnJob, FnMck, FnMOTRA, FnPT2, FnQDAT, FnTemp, FNTrI1, FNTrI2, FNTRi3, FNTRI4, &
                    FNTRI5, FnTwo, SwLbl(Mxdccc)
integer(kind=iwp), allocatable :: H0F(:), pINT1(:), pINT2(:), SBIDT(:)
real(kind=wp), allocatable :: CMO_Inv(:), F0SQMO(:), FAMO(:), FAMO_spinm(:), FAMO_spinp(:), FIMO(:), Fm(:), Fp(:), G1m(:), G1p(:), &
                              G1t(:), G2mm(:), G2mp(:), G2pp(:), G2sq(:), G2t(:), H0S(:), Hss(:), INT2(:), SFock(:), SS(:,:)
real(kind=wp), allocatable, target :: CMO(:), INT1(:)
real(kind=wp), pointer :: KAIN1(:), KINT2(:), KINT2A(:)

public :: ChDisp, CMO, CMO_Inv, Do_Hybrid, dspvec, ERAS, esterr, F0SQMO, FAMO, FAMO_spinm, FAMO_spinp, Fancy_Preconditioner, FIMO, &
          Fm, FNCSF2SD, FnHlf2, FNHlf3, FnJob, FnMck, FnMOTRA, FnPT2, FnQDAT, FnTemp, FNTrI1, FNTrI2, FNTRi3, FNTRI4, FNTRI5, &
          FnTwo, Fp, G1m, G1p, G1t, G2mm, G2mp, G2pp, G2sq, G2t, H0F, H0S, Hss, i1, I12, IACTI, iAllo, iAnders, IASTFI, IBSO, &
          IBSTFI, IBTSOB, ICISTR, IDC, IDIAG, INT1, INT2, ipCI, ipCM, ipdia, ipMat, ipmatba, ipMatLT, ipMO, IREFSM, IREOTS, &
          irlxroot, isMECIMSPD, ISMFTO, isNAC, IST, istate, ITSOB, KAIN1, KINT2, KINT2A, lconf, lDisp, lldet, luciv, LUCSF2SD, &
          LUHlf2, LUHlf3, LuJob, LuMck, LuMOTRA, LuPt2, LuQDAT, LuTemp, LUTrI1, LUTrI2, LUTRi3, LUTRI4, LUTRI5, LuTwo, MAXI, MAXK, &
          MAXOP, MINOP, MNR1IC, MNR3IC, MS2, MS2P, MULTSP, MXINKA, MXPCSM, MXPNGAS, MXR1IC, MXR3IC, MXSB, MXSOOB, n1Dens, n2Dens, &
          na, NACOB, nacpar, nacpr2, NACstates, NAELCI, nb, NBELCI, nCMO, NCNASM, NCNATS, nconf1, NCPCNT, NCSASM, nDens, nDensC, &
          NDPCNT, NDTASM, NELCI, NewPre, nexp, nexp_max, ngp, nhess, NICISP, nmba, nna, NOBPT, NOBPTS, NOCOB, NOCSF, Nofile, &
          NOPART, NORB1, NORB2, NORB3, nrec, NSSA, NTOOB, NTSOB, NTYP, override, P1, P1INV, PDFT_Ratio, pINT1, pINT2, PSSIGN, &
          rbetaa, rbetas, ResQaaLag2, rms, SA, SBIDT, SFock, square, SS, SwLbl, WF_Ratio, XISPSM

end module MCLR_Data

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Roland Lindh                                     *
!***********************************************************************

subroutine M2MmG( &
#                define _CALLING_
#                include "mem_interface.fh"
                )
!***********************************************************************
!                                                                      *
!  Object: to compute the number of real*8 the kernel routine will     *
!          need for the computation of a matrix element between two    *
!          cartesian Gaussian functions with the total angular momentum*
!          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
!          lr is the order of the operator (this is only used when the *
!          integrals are computed with the Hermite-Gauss quadrature).  *
!                                                                      *
!  Called from: OneEl                                                  *
!                                                                      *
!***********************************************************************

use Definitions, only: iwp

implicit none
#include "mem_interface.fh"

#include "macros.fh"
unused_var(lr)

nHer = (la+lb+2+1)/2
Mem = 3*nHer*(la+2)+ &
      3*nHer*(lb+2)+ &
      3*nHer+ &
      3*(la+2)*(lb+2)+ &
      7

return

end subroutine M2MmG

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MakeWwHlp3(Ww,W1,W2,dima,dimb,dimbe,dimga,dimbega,key)
! this routine does:
! Make Ww(+,-)((ab)",(bega)") from W1(a",be",b",ga")
!                              and W2(b",be",a",ga")
! for the case a"/=b" , be"=ga"
! N.B. algoritmus nieje prilis vymakany, prva cast sa da
!      urobit pomodou dcopy
!
! parameter description
! Ww   - array for Ww+(-) (O)
! W1   - array for W1(a",be",b",ga") (I)
! W2   - array for W1(b",be",a",ga") (I)
! dimx - dimension of a",b",be",ga",be>(>=)ga" (I)
! key  - 1 - calc Ww+, 2 - calc Ww- (I)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimb, dimbe, dimga, dimbega, key
real(kind=wp), intent(out) :: Ww(dima,dimb,dimbega)
real(kind=wp), intent(in) :: W1(dima,dimbe,dimb,dimga), W2(dimb,dimbe,dima,dimga)
integer(kind=iwp) :: b, be, bega

if (key == 1) then
  bega = 0
  do be=1,dimbe
    do b=1,dimb
      Ww(:,b,bega+1:bega+be) = W1(:,be,b,1:be)+W2(b,be,:,1:be)
    end do
    bega = bega+be
  end do
else
  bega = 0
  do be=2,dimbe
    do b=1,dimb
      Ww(:,b,bega+1:bega+be-1) = W1(:,be,b,1:be-1)-W2(b,be,:,1:be-1)
    end do
    bega = bega+be-1
  end do
end if

! Cely clen ma Faktor 2, tu teda nevydelim 2
!Ww(:,:,:) = Half*W(:,:,:)

return

end subroutine MakeWwHlp3

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      Subroutine PrjMm1(nHer,MmPrjG,la,lb,lr)
************************************************************************
*                                                                      *
*  Object: to compute the number of real*8 the kernal routine will     *
*          need for the computation of a matrix element between two    *
*          cartesian Gaussin functions with the total angular momentum *
*          of la and lb (la=0 s-function, la=1 p-function, etc.)       *
*          lr is the order of the operator (this is only used when the *
*          integrals are computed with the Hermite-Gauss quadrature).  *
*                                                                      *
*  Called from: OneEl                                                  *
*                                                                      *
************************************************************************
*
      Use Basis_Info, only: dbsc, nCnttp, Shells
*
      nElem(i) = (i+1)*(i+2)/2
*
      nOrder = 0
      ld=1
      MmPrjG = 0
      Do 1960 iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%ECP) Go To 1960
         Do 1966 iAng = 0, dbsc(iCnttp)%nPrj-1
            iShll = dbsc(iCnttp)%iPrj + iAng
            nExpi=Shells(iShll)%nExp
            nBasisi=Shells(iShll)%nBasis
            If (nExpi.eq.0 .or. nBasisi.eq.0) Go To 1966
*
            ip = 0

            nac = nElem(la)*nElem(iAng)
            ncb = nElem(iAng)*nElem(lb)

            ip=ip+6*nelem(la)*nelem(lb) ! final
            ip=ip+4*nac*nExpi ! FA1
            ip=ip+4*ncb*nExpi !FB1
            ip=ip+nExpi* nExpi !Tmp

            nHer = (la+1+iAng+1+ld)/2
            nOrder = Max(nHer,nOrder)
            iacore=6+3*nHer*(la+1+ld)+3*nHer*(iAng+1)+
     &           3*nHer*(lr+1)+3*(la+1+ld)*(iAng+1)*(lr+1)+1

            nHer = (lb+1+iAng+1+ld)/2
            nOrder = Max(nHer,nOrder)
            icoreb=6+3*nHer*(lb+1+ld)+3*nHer*(iAng+1)+
     &           3*nHer*(lr+1)+3*(lb+1+ld)*(iAng+1)*(lr+1)+1

            icores = MAX(icoreb,iacore)*nExpi

            MmPrjG = Max(MmPrjG,ip+icores)
*
 1966    Continue
 1960 Continue
      nHer = nOrder
c      !write(*,*) 'mem',MmPrjG
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

subroutine Rys01(Arg,nArg,Weight,iPntr,nPntr,x0,nMax,W6,W5,W4,W3,W2,W1,W0,ddx,HerW,Tmax)
!***********************************************************************
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             September '90                                            *
!***********************************************************************

use Constants, only: One, Ten
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nArg, nPntr, iPntr(nPntr), nMax
real(kind=wp), intent(in) :: Arg(nArg), x0(nMax), W6(nMax), W5(nMax), W4(nMax), W3(nMax), W2(nMax), W1(nMax), W0(nMax), ddx, HerW, &
                             TMax
real(kind=wp), intent(out) :: Weight(nArg)
integer(kind=iwp) :: iArg, n
real(kind=wp) :: ai, dddx, xdInv, z

xdInv = One/ddx
dddx = ddx/Ten+ddx
do iArg=1,nArg
  if (Arg(iArg) < TMax) then
    n = iPntr(int((Arg(iArg)+dddx)*xdInv))
    z = Arg(iArg)-x0(n)
    Weight(iArg) = (((((W6(n)*z+W5(n))*z+W4(n))*z+W3(n))*z+W2(n))*z+W1(n))*z+w0(n)
  else
    ai = One/Arg(iArg)
    Weight(iArg) = HerW*sqrt(ai)
  end if
end do

return

end subroutine Rys01

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine zorder(ndimen,ldv,vecre,vecim,arrre,switch)
! Order the eigenvalues in increasing sequence:
! Note that special care is taken to define some order in case
! of degeneracy.
! switch controls whether we assume an array or vector
! of eigenvalues

use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDIMEN, LDV, switch
real(kind=wp), intent(inout) :: VECRE(LDV,*), VECIM(LDV,*), ARRRE(NDIMEN,*)
integer(kind=iwp) :: I, ISEL, J, K
real(kind=wp) :: EDIFF, ESEL, EVAL, O_i, O_j, VIKI, VIKJ, VRKI, VRKJ
real(kind=wp), parameter :: Thr_EDiff = 1.0e-10_wp

do I=1,NDIMEN-1
  ESEL = ARRRE(I,I**(switch))
  ISEL = I

  O_i = Zero
  do K=1,LDV
    O_i = O_i+real(K,kind=wp)*(VECRE(K,I)**2+VECIM(K,I)**2)
  end do

  ! Check against other eigenvalues

  do J=I+1,NDIMEN
    EVAL = ARRRE(J,J**switch)

    EDIFF = abs(EVAL-ESEL)
    if ((EVAL < ESEL) .and. (EDIFF > Thr_EDiff)) then
      ISEL = J
      ESEL = EVAL
    else if (EDIFF < Thr_EDiff) then
      O_j = Zero
      do K=1,LDV
        O_j = O_j+real(K,kind=wp)*(VECRE(K,J)**2+VECIM(K,J)**2)
      end do
      if (O_j > O_i) then
        ISEL = J
        ESEL = EVAL
      end if
    end if
  end do

  ! Swap here!

  if (ISEL /= I) then
    do K=1,LDV
      VRKI = VECRE(K,I)
      VRKJ = VECRE(K,ISEL)
      VIKI = VECIM(K,I)
      VIKJ = VECIM(K,ISEL)
      VECRE(K,I) = VRKJ
      VECRE(K,ISEL) = VRKI
      VECIM(K,I) = VIKJ
      VECIM(K,ISEL) = VIKI
    end do
    ARRRE(ISEL,ISEL**switch) = ARRRE(I,I**switch)
    ARRRE(I,I**switch) = ESEL
  end if
end do

end subroutine zorder

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Jie J. Bao                                       *
************************************************************************
      Subroutine XMSRot(CMO,FI,FA)
* ****************************************************************
* history:                                                       *
* Jie J. Bao, on May. 21, 2020, created this file.               *
* ****************************************************************
      use stdalloc, only : mma_allocate, mma_deallocate
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.fh"
#include "rasscf_lucia.fh"

******Input
      Real*8,DIMENSION(NTOT1):: FI,FA
      Real*8,Dimension(NTOT2)::CMO
******Auxillary quantities
      Real*8,DIMENSION(:,:),Allocatable::FckO
******FckO:  Fock matrix for MO
      Real*8,DIMENSION(:,:),Allocatable::FckS,EigVec
******FckS:  Fock matrix for states
      Real*8,DIMENSION(:,:,:),Allocatable::GDMat
******GDMat: density matrix or transition density matrix

C     Allocating Memory
      CALL mma_allocate(GDMat,lRoots*(lRoots+1)/2,NAC,NAC)
      CALL mma_allocate(FckO,NAC,NAC)
      CALL mma_allocate(FckS,lRoots,lRoots)
      CALL mma_allocate(EigVec,lRoots,lRoots)
C
      CALL CalcFckO(CMO,FI,FA,FckO)

      CALL GetGDMat(GDMAt)
C
      CALL CalcFckS(FckO,GDMat,FckS)
C
      CALL CalcEigVec(FckS,lRoots,EigVec)
C
      call printmat('ROT_VEC','XMS-PDFT',eigvec,lroots,lroots,7,8,'N')
C     Deallocating Memory
      CALL mma_deallocate(GDMat)
      CALL mma_deallocate(FckO)
      CALL mma_deallocate(FckS)
      CALL mma_deallocate(EigVec)

      RETURN
      End Subroutine

***********************************************************************

******************************************************
      Subroutine CalcFckO(CMO,FI,FA,FckO)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.fh"
#include "rasscf_lucia.fh"
******Input
      Real*8,DIMENSION(NTOT1)::FI,FA
      Real*8,Dimension(NTOT2)::CMO
******Output
      Real*8,DIMENSION(NAC,NAC)::FckO
******Auxillary quantities
      INTEGER LFIAAO,LScr,NB,NA,NI,IOff1,IOff2,IOff3,LFckOt
      INTEGER IBas,JBas,ISym,IOrb,JOrb

      DO IOrb=1,NAC
       Do JOrb=1,NAC
        FckO(JOrb,IOrb)=0.0d0
       End Do
      END DO

      IOff1=0
      IOff2=1
      IOff3=0
      DO ISym=1,NSym
        NB=NBas(ISym)
        NA=NASH(ISym)
        NI=NISH(ISym)+NFro(ISym)
       IF(NASH(ISym).gt.0) THEN
        Call GetMem('FIAAO','ALLO','REAL',LFIAAO,NB**2)
        Call GetMem('Scra' ,'ALLO','REAL',LScr,  NB*NA)
        Call GetMem('FckOt','ALLO','REAL',LFckOt,NA*NA)
        CALL FZero(WORK(LFckOt),NA**2)
C        write(6,*)'Print FI Matrix'
C        Do IBas=1,NB
C         write(6,*)(FI(IOff1+(IBas-1)*IBas/2+JBas),JBas=1,IBas)
C        End Do
C        write(6,*)'Print FA Matrix'
C        Do IBas=1,NB
C         write(6,*)(FA(IOff1+(IBas-1)*IBas/2+JBas),JBas=1,IBas)
C        End Do
C        write(6,*)'Active CMO mat for sym',ISym
C        CALL RecPrt(' ',' ',CMO(IOff2+NI*NB),NB,NA)
        Do IBas=1,NB
         do JBas=1,IBas
          WORK(LFIAAO+(IBas-1)*NB+JBas-1)=
     & FI(IOff1+(IBas-1)*IBas/2+JBas)+
     & FA(IOff1+(IBas-1)*IBas/2+JBas)
          WORK(LFIAAO+(JBas-1)*NB+IBas-1)=
     & WORK(LFIAAO+(IBas-1)*NB+JBas-1)
         end do
        End Do
C        write(6,*)'FIA mat for sym',ISym
C        CALL RecPrt(' ',' ',Work(LFIAAO),NB,NB)
        CALL DGEMM_('n','n',NB,NA,NB,1.0D0,Work(LFIAAO),
     &       NB,CMO(IOff2+NI*NB),NB,0.0D0,Work(LScr),NB)
        CALL DGEMM_('t','n',NA,NA,NB,1.0D0,CMO(IOff2+NI*NB),
     &       NB,Work(LScr),NB,0.0D0,Work(LFckOt),NA)
C        write(6,*)'FckO mat for sym',ISym
C        CALL RecPrt(' ',' ',Work(LFckOt),NA,NA)
        Do IOrb=1,NA
         do JOrb=1,NA
          FckO(IOrb+IOff3,JOrb+IOff3)=
     &Work(LFckOt+(IOrb-1)*NA+JOrb-1)
         end do
        End Do
        Call GetMem('FIAAO','FREE','REAL',LFIAAO,NB**2)
        Call GetMem('Scra' ,'FREE','REAL',LScr,  NB*NA)
        Call GetMem('FckOt','FREE','REAL',LFckOt,NA*NA)
       END IF
       IOff1=IOff1+NB*(NB+1)/2
       IOff2=IOff2+NB**2
       IOff3=IOff3+NA
      END DO

      RETURN
      END Subroutine

******************************************************

******************************************************
      Subroutine GetGDMat(GDMat)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.fh"
#include "rasscf_lucia.fh"
*     Output
      Real*8,DIMENSION(lRoots*(lRoots+1)/2,NAC,NAC)::GDMat
*     Auxillary qunatities
      INTEGER CIDisk1,CIDisk2,iVecL,iVecR,iDummy
      INTEGER tlw6,tlw7,ldtmp,lsdtmp,NIJ2
      Dimension Dummy(1)
      tlw6=lw6
      tlw7=lw7
      Call GetMem('LVEC','ALLO','REAL',iVecL,NConf)
      Call GetMem('RVEC','ALLO','REAL',iVecR,NConf)
      Call GetMem('Dtmp','ALLO','REAL',ldtmp,NAC**2)
      Call GetMem('SDtmp','ALLO','REAL',lsdtmp,NAC**2)
      lw6=ldtmp
      lw7=lsdtmp
      CIDisk1=IADR15(4)
      Do jRoot=1,lRoots
       Call DDafile(JOBIPH,2,Work(iVecL),nConf,CIDisk1)
       C_Pointer=iVecL
       CIDisk2=IADR15(4)
       Do kRoot=1,jRoot
        Call DDafile(JOBIPH,2,Work(iVecR),nConf,CIDisk2)
C        write(6,*) 'VecL and VecR for states',jRoot,kRoot
C        write(6,*)(WORK(iVecL+I),I=0,NConf-1)
C        write(6,*)(WORK(iVecR+I),I=0,NConf-1)
        Call Lucia_Util('Densi',iVecR,iDummy,Dummy)
C        Call Lucia_Util('Densi',0,iDummy,rdum)
C        write(6,*)'GDMat for states',jRoot,kRoot
         dO IOrb=1,NAC
          do JOrb=1,NAC
          NIJ2=jRoot*(jRoot-1)/2+kRoot
          GDMat(NIJ2,IOrb,JOrb)=WORK(LW6+JOrb-1+(IOrb-1)*NAC)
          end do
C          write(6,'(10(F8.4,2X))')(GDMat(NIJ2,IOrb,JOrb),JOrb=1,NAC)
         eND dO
       End Do
      End DO
      lw6=tlw6
      lw7=tlw7
      Call GetMem('LVEC','FREE','REAL',iVecL,NConf)
      Call GetMem('RVEC','FREE','REAL',iVecR,NConf)
      Call GetMem('Dtmp','FREE','REAL',ldtmp,NAC**2)
      Call GetMem('SDtmp','Free','REAL',lsdtmp,NAC**2)
      RETURN
      END Subroutine

******************************************************
      Subroutine CalcFckS(FckO,GDMat,FckS)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "WrkSpc.fh"
#include "SysDef.fh"
#include "input_ras.fh"
#include "warnings.fh"
#include "rasscf_lucia.fh"

******Input
      Real*8,DIMENSION(NAC,NAC)::FckO
      Real*8,DIMENSION(lRoots*(lRoots+1)/2,NAC,NAC)::GDMat
******Output
      Real*8,DIMENSION(lRoots,lRoots)::FckS
******Auxillary variables
      INTEGER IState,JState

      DO IState=1,lRoots
       Do JState=1,IState
        FckS(IState,JState)=0.0d0
       End Do
      END DO

      DO IState=1,lRoots
       Do JState=1,IState
        dO IOrb=1,NAC
         do JOrb=1,NAC
          FckS(IState,JState)=FckS(IState,JState)+FckO(IOrb,JOrb)*
     &GDMat(IState*(IState-1)/2+JState,IOrb,JOrb)
         end do
        eND DO
        FckS(JState,IState)=FckS(IState,JState)
        End Do
      END DO

C      CALL PrintMat('XMS_Mat','test',FckS,LRoots,LRoots,0,4,'N')


      RETURN
      END SUBROUTINE
******************************************************


******************************************************
      Subroutine CalcEigVec(Matrix,NDIM,EigVec)

#include "WrkSpc.fh"
******Input
      INTEGER NDim
******Input & Output
      Real*8,DIMENSION(NDIM,NDIM)::Matrix,EigVec
******Calculating rotation matrix
      INTEGER LMat,LVal,NScr,INFO
      Real*8,DIMENSION(2)::WGRONK
******Auxillary quantities
      INTEGER NElem ! NElem=NDim**2
      INTEGER IRow,ICol,IRIC
      LOGICAL UseJacob

      UseJacob=.true.

      DO ICol=1,NDIM
       Do IRow=1,NDIM
        EigVec(IRow,ICol)=0.0d0
       End Do
      END DO
      IF(UseJacob) THEN
       NElem=NDim*(NDim+1)/2
       Call GetMem('Mat','ALLO','REAL',LMat,NElem)
       Call GetMem('EVa','ALLO','REAL',LVal,NDIM**2)
       IRIC=0
       DO IRow=1,NDIM
        Do ICol=1,IRow
         WORK(LMat+IRIC)=Matrix(IRow,ICol)
         IRIC=IRIC+1
        End Do
       END DO
       CALL FZero(WORK(LVal),NDIM**2)
       IRIC=0
       DO NI=1,NDim
        WORK(LVal+IRIC)=1.0D0
        IRIC=IRIC+NDIM+1
       END DO
C       write(6,*)'eigenvector matrix before diag'
C       CALL RECPRT(' ',' ',WORK(LVal),NDIM,NDIM)
C       write(6,*)'matrix to be diagonalized'
C       CALL TriPrt(' ',' ',WORK(LMat),NDIM)
       CALL JACOB(WORK(LMat),WORK(LVal),NDim,NDim)
C       write(6,*)'eigenvector matrix'
C       CALL RECPRT(' ',' ',WORK(LVal),NDIM,NDIM)
C       DO IRow=1,NDIM
C         write(6,*) (EigVec(IRow,ICol), ICol=1,NDim)
C       END DO
       DO ICol=1,NDIM
        Do IRow=1,NDIM
         EigVec(IRow,ICol)=WORK(LVal+(ICol-1)*NDIM+IRow-1)
        End Do
       END DO
       Call GetMem('EVa','FREE','REAL',LVal,NElem)
       Call GetMem('Mat','FREE','REAL',LMat,NElem)

      ELSE
       NElem=NDim**2
       Call GetMem('Mat','ALLO','REAL',LMat,NElem)
       Call GetMem('EVa','ALLO','REAL',LVal,NDIM**2)
       DO ICol=1,NDIM
        Do IRow=1,NDIM
         WORK(LMat+(ICol-1)*NDIM+IRow-1)=Matrix(IRow,ICol)
        End Do
       END DO
       CALL FZERO(WORK(LVal),NElem)
       Call Dsyev_('V','U',NDIM,Work(LMat),NDIM,Work(LVal),
     &             WGRONK,-1,INFO)
       NScr=Int(WGRONK(1))
       Call GetMem('Scr','Allo','Real',LScr,NScr)
       Call Dsyev_('V','U',NDIM,Work(LMat),NDIM,Work(LVal),
     &                Work(LScr),NScr,INFO)
       DO ICol=1,NDIM
        Do IRow=1,NDIM
         EigVec(IRow,ICol)=WORK(LMat+(ICol-1)*NDIM+IRow-1)
        End Do
       END DO
       Call GetMem('Scr','Free','Real',LScr,NScr)
       Call GetMem('EVa','FREE','REAL',LVal,NElem)
       Call GetMem('Mat','FREE','REAL',LMat,NElem)
       END IF

      RETURN
      End Subroutine
******************************************************

******************************************************
      Subroutine PrintMat(FileName,MatInfo,Matrix,NRow,NCol,
     &LenName,LenInfo,Trans)

      INTEGER NRow,NCol,LenName
      CHARACTER(Len=LenName)::FileName
      CHARACTER(Len=LenInfo)::MatInfo
      CHARACTER(Len=1)::Trans
      Real*8,DIMENSION(NRow,NCol)::Matrix

      INTEGER LU,IsFreeUnit,IRow,ICol
      External IsFreeUnit

      IF(LenName.gt.0) THEN
      LU=100
      LU=IsFreeUnit(LU)
      CALL Molcas_Open(LU,FileName)
      ELSE
      LU=6
      END IF
      IF(Trans.eq.'N') THEN
       DO IRow=1,NRow
        write(LU,*) (Matrix(IRow,ICol),ICol=1,NCol)
       END DO
      ELSE
       DO ICol=1,NCol
        write(LU,*) (Matrix(IRow,ICol),IRow=1,NRow)
       END DO
      END IF
      WRITE(LU,*)MatInfo
      IF(LenName.gt.0) THEN
       Close(LU)
      END IF
      RETURN
      End Subroutine
******************************************************

******************************************************
      Subroutine ReadMat(FileName,MatInfo,Matrix,NRow,NCol,
     &LenName,LenInfo,Trans)

      INTEGER NRow,NCol,LenName
      CHARACTER(Len=LenName)::FileName
      CHARACTER(Len=LenInfo)::MatInfo
      CHARACTER(Len=1)::Trans
      Real*8,DIMENSION(NRow,NCol)::Matrix

      INTEGER LU,IsFreeUnit,IRow,ICol
      External IsFreeUnit

      IF(LenName.gt.0) THEN
      LU=100
      LU=IsFreeUnit(LU)
      CALL Molcas_Open(LU,FileName)
      ELSE
      LU=6
      END IF
      IF(Trans.eq.'N') THEN
       DO IRow=1,NRow
        Read(LU,*) (Matrix(IRow,ICol),ICol=1,NCol)
       END DO
      ELSE
       DO ICol=1,NCol
        Read(LU,*) (Matrix(IRow,ICol),IRow=1,NRow)
       END DO
      END IF
      Read(LU,*)MatInfo
      IF(LenName.gt.0) THEN
       Close(LU)
      END IF
      RETURN
      End Subroutine
******************************************************


******************************************************
       Subroutine MatToWork2DRR(Mat,L,M,LWork,Trans)
#include "WrkSpc.fh"
       INTEGER L, M, LWork
       Real*8,DIMENSION(L,M)::Mat
       INTEGER I,J
       CHARACTER(Len=1)::Trans
       IF(Trans.ne.'T') THEN
        DO I=1,L
         Do J=1,M
          WORK(LWork+J-1+(I-1)*M)=Mat(J,I)
         End Do
        END DO
       ELSE
        DO I=1,L
         Do J=1,M
          WORK(LWork+J-1+(I-1)*M)=Mat(I,J)
         End Do
        END DO
       END IF
       RETURN
       End Subroutine
******************************************************

******************************************************
       Subroutine WorkToMat2DRR(Mat,L,M,LWork,Trans)
#include "WrkSpc.fh"
       INTEGER L, M, LWork
       Real*8,DIMENSION(L,M)::Mat
       CHARACTER(Len=1)::Trans
       INTEGER I,J
       IF(Trans.ne.'T') THEN
        DO I=1,L
         Do J=1,M
          Mat(J,I)=WORK(LWork+J-1+(I-1)*M)
         End Do
        END DO
       ELSE
        DO I=1,L
         Do J=1,M
          Mat(I,J)=WORK(LWork+J-1+(I-1)*M)
         End Do
        END DO
       END IF
       RETURN
       End Subroutine
******************************************************

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

!ifdef _DEBUGPRINT_
subroutine exctdm(SIJ,TRAD,TDMAB,iRC,CMO1,CMO2,TDMZZ,TRASD,TSDMAB,TSDMZZ,istate,jstate)

use Index_Functions, only: iTri, nTri_Elem
use Basis_Info, only: nBas
use Data_structures, only: Allocate_DT, Deallocate_DT, DSBA_Type
use frenkel_global_vars, only: doexch, eNucB, iTyp, labb, VNucB
use Cntrl, only: MLTPLT, NSTATE
use Symmetry_Info, only: nIrrep
use rassi_data, only: CHFRACMEM, NASHT, NBASF, NCMO, NTDMAB, NTDMZZ
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
real(kind=wp), intent(in) :: SIJ, TRAD(NASHT,NASHT), CMO1(NCMO), CMO2(NCMO), TRASD(NASHT,NASHT)
real(kind=wp), intent(out) :: TDMAB(NTDMAB), TDMZZ(NTDMZZ), TSDMAB(NTDMAB), TSDMZZ(NTDMZZ)
integer(kind=iwp), intent(out) :: iRC
integer(kind=iwp), intent(in) :: istate, jstate
integer(kind=iwp) :: I, INTEG, IPNB, J, LuT, m(1), n(1), nbas_A(1), nbas_B(1), nbas_tot(1), NNLTD, run
type(DSBA_Type) :: DLT(1), Salpha(1), Sbeta(1), SDLT(1)
character(len=13) :: filnam
real(kind=wp), allocatable :: STDMZZ_mtx(:,:), STDMZZ_new(:), TDMZZ_mtx(:,:), TDMZZ_new(:)
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: a, K
#endif
integer(kind=iwp), external :: isFreeUnit
real(kind=wp), external :: DDot_

!write(u6,*) 'MLTPL', MLTPLT(1)
! Write number of states in files, since they can differ on monomers
write(filnam,'(A,I1)') 'states_',iTyp
LuT = isFreeUnit(10)
call molcas_open(LuT,filnam)
write(LuT,*) NSTATE
close(LuT)

! get number of basis functions for different monomers

if (LABB) then
  nbas_B = NBASF(1)
# ifdef _DEBUGPRINT_
  write(u6,*) 'basis functions of mon B',nbas_B
# endif
  call NameRun('AUXRFIL1')
  call get_iArray('nBas',nBas,nIrrep)
  nbas_tot = nBas(0)
  call NameRun('#Pop')    ! switch back to old RUNFILE
# ifdef _DEBUGPRINT_
  write(u6,*) 'total num of basis functions',nbas_tot
# endif
  nbas_A = nbas_tot-nbas_B
# ifdef _DEBUGPRINT_
  write(u6,*) 'basis functions of mon A',nbas_A
# endif
end if

if (.not. LABB) then
  nbas_A = NBASF(1)
# ifdef _DEBUGPRINT_
  write(u6,*) 'basis functions of mon A',nbas_A
# endif
  call NameRun('AUXRFIL1')
  call get_iArray('nBas',nBas,nIrrep)
  nbas_tot = nBas(0)
  call NameRun('#Pop')    ! switch back to old RUNFILE
# ifdef _DEBUGPRINT_
  write(u6,*) 'total num of basis functions',nbas_tot
# endif
  nbas_B = nbas_tot-nbas_A
# ifdef _DEBUGPRINT_
  write(u6,*) 'basis functions of mon B',nbas_B
# endif
end if
! get the dimensions of the packed lower triangular TDM
NNLTD = nTri_Elem(nbas_tot(1))
m = nbas_tot
n = nbas_tot

! regular-TDM
call MKTDAB(SIJ,TRAD,TDMAB,iRC)
! transform to AO basis
call MKTDZZ(CMO1,CMO2,TDMAB,TDMZZ,iRC)
call Allocate_DT(DLT(1),n,m,nIrrep,aCase='TRI')

if (doexch) then
  ! for the exchange part we need the spin density
  ! spin-TDM
  call MKTDAB(Zero,TRASD,TSDMAB,iRC)
  ! transform to AO basis
  call MKTDZZ(CMO1,CMO2,TSDMAB,TSDMZZ,iRC)
  ! alpha part of the spin density
  if (MLTPLT(1) == 1) then
    call Allocate_DT(Salpha(1),nbas_tot,nbas_tot,nIrrep)
  else
    call Allocate_DT(Salpha(1),nbas_tot,nbas_tot,nIrrep)
    call Allocate_DT(Sbeta(1),nbas_tot,nbas_tot,nIrrep)
    ! allocate matrix for the spin density difference
    call Allocate_DT(SDLT(1),nbas_tot,nbas_tot,nIrrep)
    SDLT(1)%A00(:) = Zero
  end if
end if

! case where MON B of the exciton calculation was calculated first
if (labb) then
  call mma_allocate(TDMZZ_mtx,nbas_tot(1),nbas_tot(1))
  call mma_allocate(TDMZZ_new,nbas_tot(1)*nbas_tot(1))
  TDMZZ_mtx(:,:) = Zero
  TDMZZ_new(:) = Zero
  ! fill a matrix in combined basis with the TDM of MON B
  ! here, one shifts the entries of row and column of the matrix
  ! by the number of basis functions of MON A
  ! the fast running index is the column, because TDMZZ is filled in
  ! column-major order
  run = 0
  do i=1,nbas_B(1)
    do j=1,nbas_B(1)
      run = run+1
      TDMZZ_mtx(j+nbas_A(1),i+nbas_A(1)) = TDMZZ(run)
    end do
  end do
  ! fill the TDM in common basis in an array
  ! in column-major order
  run = 0
  do i=1,nbas_tot(1)
    do j=1,nbas_tot(1)
      run = run+1
      TDMZZ_new(run) = TDMZZ_mtx(j,i)
    end do
  end do
  ! fill DLT (=TDM in common basis in packed, lower trangular storage)
  do i=1,nbas_tot(1)
    do j=1,i-1
      DLT(1)%A00(iTri(i,j)) = TDMZZ_new(nbas_tot(1)*(j-1)+i)+TDMZZ_new(nbas_tot(1)*(i-1)+j)
    end do
    DLT(1)%A00(nTri_Elem(j)) = TDMZZ_new(nbas_tot(1)*(j-1)+j)
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) 'TDMZZvector:'
  k = nbas_B(1)*nbas_B(1)
  do i=1,k
    write(u6,*) TDMZZ(i)
  end do

  write(u6,*) 'TDMZZ:'
  k = int(sqrt(real(nTDMZZ,kind=wp)),kind=iwp)
  do i=1,k
    write(u6,'(100ES18.8)') (TDMZZ(i+(j-1)*k),j=1,k)
  end do

  write(u6,*) 'TDMZZ_new vector:'
  k = nbas_tot(1)*nbas_tot(1)
  do i=1,k
    write(u6,*) TDMZZ_new(i)
  end do

  write(u6,*) 'TDMZZ_new:'
  k = nbas_tot(1)
  do i=1,k
    write(u6,'(1000ES18.8)') (TDMZZ_new(i+(j-1)*k),j=1,k)
  end do
  write(u6,*) 'TDMZZ_mtx:'
  do i=1,k
    write(u6,'(1000ES18.8)') (TDMZZ_mtx(i,j),j=1,k)
  end do

  write(u6,*) 'DLT:'
  write(u6,*) DLT(1)%A00(:)
  write(u6,*) 'DLT as mtx:'
  k = 0
  do i=1,nbas_tot(1)
    write(u6,'(1000ES18.8)') (DLT(1)%SB(1)%A1(j+k),j=1,i)
    k = k+i
  end do
# endif
  ! spin part if KCOUL is requested in excitonic section
  if (DoExch) then
    call mma_allocate(STDMZZ_mtx,nbas_tot(1),nbas_tot(1))
    call mma_allocate(STDMZZ_new,nbas_tot(1)*nbas_tot(1))
    STDMZZ_mtx(:,:) = Zero
    STDMZZ_new(:) = Zero
    run = 0
    do i=1,nbas_B(1)
      do j=1,nbas_B(1)
        run = run+1
        STDMZZ_mtx(j+nbas_A(1),i+nbas_A(1)) = TSDMZZ(run)
      end do
    end do
    run = 0
    do i=1,nbas_tot(1)
      do j=1,nbas_tot(1)
        run = run+1
        STDMZZ_new(run) = STDMZZ_mtx(j,i)
      end do
    end do
    ! fill SDLT (spin density difference)
    if (MLTPLT(1) > 1) then
      run = 0
      do i=1,nbas_tot(1)
        do j=1,nbas_tot(1)
          run = run+1
          SDLT(1)%SB(1)%A1(run) = STDMZZ_mtx(i,j)
        end do
      end do
    end if
    ! fill Salpha from matrix, due to the row major data type
    run = 0
    do i=1,nbas_tot(1)
      do j=1,nbas_tot(1)
        run = run+1
        Salpha(1)%SB(1)%A1(run) = TDMZZ_mtx(i,j)
      end do
    end do

    if (MLTPLT(1) > 1) then
      ! Salpha(1) = TM = GAA+GBB
      ! Salpha(1) becomes TM + SDLT = GAA+GBB+GAA-GBB=2GAA
      run = 0
      do i=1,nbas_tot(1)
        do j=1,nbas_tot(1)
          run = run+1
          Salpha(1)%SB(1)%A1(run) = Salpha(1)%SB(1)%A1(run)+SDLT(1)%SB(1)%A1(run)
        end do
      end do
      ! Salpha(1) becomes GAA
      integ = int(nbas_tot(1)*nbas_tot(1),kind=iwp)
      Salpha(1)%A00(1:integ) = Half*Salpha(1)%A00(1:integ)
      ! Sbeta(1) becomes GBB
      run = 0
      do i=1,nbas_tot(1)
        do j=1,nbas_tot(1)
          run = run+1
          Sbeta(1)%SB(1)%A1(run) = TDMZZ_new(run)-Salpha(1)%SB(1)%A1(run)
        end do
      end do
    end if

    call mma_deallocate(STDMZZ_new)
    call mma_deallocate(STDMZZ_mtx)
    ! end Exch statement
  end if

  call mma_deallocate(TDMZZ_new)
  call mma_deallocate(TDMZZ_mtx)
  ! end LABB statement
end if

! case where MON A was calculated first
if (.not. LABB) then
  call mma_allocate(TDMZZ_mtx,nbas_tot(1),nbas_tot(1))
  call mma_allocate(TDMZZ_new,nbas_tot(1)*nbas_tot(1))
  TDMZZ_mtx(:,:) = Zero
  TDMZZ_new(:) = Zero
  ! fill matrix with the TDM in common basis (column-major order)
  run = 0
  do i=1,nbas_A(1)
    do j=1,nbas_A(1)
      run = run+1
      TDMZZ_mtx(j,i) = TDMZZ(run)
    end do
  end do
  ! fill TDM back as array
  run = 0
  do i=1,nbas_tot(1)
    do j=1,nbas_tot(1)
      run = run+1
      TDMZZ_new(run) = TDMZZ_mtx(j,i)
    end do
  end do

  ! fill DLT in packed lower triangular storage
  do i=1,nbas_tot(1)
    do j=1,i-1
      DLT(1)%A00(iTri(i,j)) = TDMZZ_new(nbas_tot(1)*(j-1)+i)+TDMZZ_new(nbas_tot(1)*(i-1)+j)
    end do
    DLT(1)%A00(nTri_Elem(j)) = TDMZZ_new(nbas_tot(1)*(j-1)+j)
  end do

# ifdef _DEBUGPRINT_
  write(u6,*) 'TDMZZ vector:'
  a = nbas_A(1)*nbas_A(1)
  do i=1,a
    write(u6,*) TDMZZ(i)
  end do
  write(u6,*) 'TDMZZ:'
  a = int(sqrt(real(nTDMZZ,kind=wp)),kind=iwp)
  do i=1,a
    write(u6,'(100ES18.8)') (TDMZZ(i+(j-1)*a),j=1,a)
  end do

  write(u6,*) 'TDMZZ_new vector:'
  a = nbas_tot(1)*nbas_tot(1)
  do i=1,a
    write(u6,*) TDMZZ_new(i)
  end do

  write(u6,*) 'TDMZZ_new:'
  a = nbas_tot(1)
  do i=1,a
    write(u6,'(1000ES18.8)') (TDMZZ_new(i+(j-1)*a),j=1,a)
  end do

  write(u6,*) 'TDMZZ_mtx:'
  do i=1,a
    write(u6,'(1000ES18.8)') (TDMZZ_mtx(i,j),j=1,a)
  end do

  write(u6,*) 'DLT:'
  write(u6,*) DLT(1)%A00(:)
# endif

  ! spin part
  if (DoExch) then
    call mma_allocate(STDMZZ_mtx,nbas_tot(1),nbas_tot(1))
    call mma_allocate(STDMZZ_new,nbas_tot(1)*nbas_tot(1))
    STDMZZ_mtx(:,:) = Zero
    STDMZZ_new(:) = Zero
    run = 0
    do i=1,nbas_A(1)
      do j=1,nbas_A(1)
        run = run+1
        STDMZZ_mtx(i,j) = TSDMZZ(run)
      end do
    end do
    ! fill back as array
    run = 0
    do i=1,nbas_tot(1)
      do j=1,nbas_tot(1)
        run = run+1
        STDMZZ_new(run) = STDMZZ_mtx(i,j)
      end do
    end do
    ! fill SDLT (spin density difference)
    if (MLTPLT(1) > 1) then
      run = 0
      do i=1,nbas_tot(1)
        do j=1,nbas_tot(1)
          run = run+1
          SDLT(1)%SB(1)%A1(run) = STDMZZ_mtx(i,j)
        end do
      end do
    end if

    ! fill Salpha from matrix, since here the row major data type
    run = 0
    do i=1,nbas_tot(1)
      do j=1,nbas_tot(1)
        run = run+1
        Salpha(1)%SB(1)%A1(run) = TDMZZ_mtx(i,j)
      end do
    end do

    if (MLTPLT(1) > 1) then
      ! Salpha(1) = TM = GAA+GBB
      ! Salpha(1) becomes TM + SDLT = GAA+GBB+GAA-GBB=2GAA
      run = 0
      do i=1,nbas_tot(1)
        do j=1,nbas_tot(1)
          run = run+1
          Salpha(1)%SB(1)%A1(run) = Salpha(1)%SB(1)%A1(run)+SDLT(1)%SB(1)%A1(run)
        end do
      end do
      ! Salpha(1) becomes GAA
      integ = int(nbas_tot(1)*nbas_tot(1),kind=iwp)
      Salpha(1)%A00(1:integ) = Half*Salpha(1)%A00(1:integ)
      ! Sbeta(1) becomes GBB
      run = 0
      do i=1,nbas_tot(1)
        do j=1,nbas_tot(1)
          run = run+1
          Sbeta(1)%SB(1)%A1(run) = TDMZZ_new(run)-Salpha(1)%SB(1)%A1(run)
        end do
      end do
    end if
    !Salpha(1)%A00(1:integ) = Salpha(1)%A00(1:integ)+SDLT(1)%A00(1:integ)
    call mma_deallocate(STDMZZ_new)
    call mma_deallocate(STDMZZ_mtx)
    ! end EXCH
  end if

  call mma_deallocate(TDMZZ_new)
  call mma_deallocate(TDMZZ_mtx)
  ! end filling MON A
end if
ipNB = nTri_Elem(ISTATE-1)+JSTATE

! calculate rho-nuc interaction (TDM with core potential)
eNucB(ipNB) = ddot_(NNLTD,DLT(1)%A0,1,VNucB(1),1)

! change the RunFile to the one
! from bsse calculation to get the cholesky vectors
call NameRun('AUXRFIL1')
call CHO_X_INIT(irc,ChFracMem)
call CHO_TRDENS(irc,DLT,Salpha,istate,jstate,iTyp,DoExch,LABB)
call NameRun('#Pop')    ! switch back to old RUNFILE
call deallocate_DT(DLT(1))
if (DOEXCH) then
  if (MLTPLT(1) == 1) then
    call deallocate_DT(Salpha(1))
  else
    call deallocate_DT(Salpha(1))
    call deallocate_DT(Sbeta(1))
    call deallocate_DT(SDLT(1))
  end if
end if

end subroutine exctdm

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_WRRSTC(IPASS)
C
C     Purpose: write decomposition restart info for integral pass IPASS.
C
C     NB!!!  The restart files are assumed open on entry.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choorb.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      PARAMETER (LSCR = 10)
      REAL*8  DSCR(LSCR)
      INTEGER JSCR(LSCR)

C     Start address on file.
C     ----------------------

      IADR = 0

C     Write molecular and configuration info.
C     ---------------------------------------

      IOPT = 1
      NWR  = 4
      JSCR(1) = NSYM
      JSCR(2) = NSHELL
      JSCR(3) = NNSHL
      JSCR(4) = 0
      CALL IDAFILE(LURST,IOPT,JSCR,NWR,IADR)

      IOPT = 1
      NWR  = NSYM
      DO ISYM = 1,NSYM
         JSCR(ISYM) = NBAS(ISYM)
      END DO
      CALL IDAFILE(LURST,IOPT,JSCR,NWR,IADR)

      IOPT = 1
      NWR  = 2
      IF (SCDIAG) THEN
         JSCR(1) = 1
      ELSE
         JSCR(1) = 0
      END IF
      JSCR(2) = CHO_ADRVEC
      CALL IDAFILE(LURST,IOPT,JSCR,NWR,IADR)

      IOPT = 1
      NWR  = 8
      DSCR(1) = THRCOM
      DSCR(2) = THRDIAG
      DSCR(3) = DAMP(1)
      DSCR(4) = DAMP(2)
      DSCR(5) = SPAN
      DSCR(6) = THRNEG
      DSCR(7) = WARNEG
      DSCR(8) = TOONEG
      CALL DDAFILE(LURST,IOPT,DSCR,NWR,IADR)

C     Write vector info.
C     ------------------

      IOPT = 1
      NWR  = 1
      JSCR(1) = IPASS
      CALL IDAFILE(LURST,IOPT,JSCR,NWR,IADR)

      IOPT = 1
      CALL IDAFILE(LURST,IOPT,IWORK(ip_INFRED),IPASS,IADR)

      DO ISYM = 1,NSYM
         IOPT = 1
         NWR  = 1
         JSCR(1) = NUMCHO(ISYM)
         CALL IDAFILE(LURST,IOPT,JSCR,NWR,IADR)
         IF (NUMCHO(ISYM) .GT. 0) THEN
            DO J = 1,INFVEC_N2
               IOPT = 1
               NTOT = NUMCHO(ISYM)
               KOFF = ip_INFVEC + MAXVEC*INFVEC_N2*(ISYM-1)
     &              + MAXVEC*(J-1)
               CALL IDAFILE(LURST,IOPT,IWORK(KOFF),NTOT,IADR)
            END DO
         END IF
      END DO

C     Write integral shell pair map to disk.
C     --------------------------------------

      IOPT = 1
      NDIM = l_INTMAP
      IF (NDIM .GT. 0) THEN
         JADR = 0
         CALL IDAFILE(LUMAP,IOPT,IWORK(ip_INTMAP),NDIM,JADR)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine symtrizcvb2_cvb(vecstr,izeta,ipermzeta)

use casvb_global, only: ndetvb, norb, nsyme, nvb, nzeta
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: vecstr(nvb)
integer(kind=iwp), intent(in) :: izeta(nsyme), ipermzeta(norb,nzeta)
integer(kind=iwp) :: isyme, izeta1
real(kind=wp), allocatable :: dvbdet(:), vecstr2(:)

call mma_allocate(dvbdet,ndetvb,label='dvbdet')
call mma_allocate(vecstr2,nvb,label='vecstr2')
izeta1 = 0
do isyme=1,nsyme
  if (izeta(isyme) /= 0) then
    izeta1 = izeta1+1
    call str2vbc_cvb(vecstr,dvbdet)
    call permvb_cvb(dvbdet,ipermzeta(:,izeta1))
    call vb2strc_cvb(dvbdet,vecstr2)
    vecstr(:) = vecstr(:)+real(izeta(isyme),kind=wp)*vecstr2(:)
  end if
end do
call mma_deallocate(dvbdet)
call mma_deallocate(vecstr2)
if (izeta1 > 0) vecstr(:) = vecstr(:)/real(2**izeta1,kind=wp)

return

end subroutine symtrizcvb2_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Anders Bernhardsson                                    *
************************************************************************
      SubRoutine WfCtl_sp(iKapDisp,iSigDisp,iCIDisp,iCIsigDisp,
     &                    iRHSDisp,iRHSCIDISP)
************************************************************************
*                                                                      *
*                                                                      *
*     called from: MCLR                                                *
*                                                                      *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
#include "WrkSpc.fh"

#include "Input.fh"
#include "disp_mclr.fh"
#include "Pointers.fh"
#include "Files_mclr.fh"
#include "detdim.fh"
#include "cicisp_mclr.fh"
#include "incdia.fh"
#include "spinfo_mclr.fh"
#include "spin.fh"
#include "crun_mclr.fh"
      Character*8   Fmt2
      Integer iKapDisp(nDisp),isigDisp(nDisp)
      Integer iRHSDisp(nDisp),iRHSCIDisp(nDisp)
      Integer iCIDisp(nDisp),iCIsigDisp(nDisp)
      integer opout
      Logical lPrint
      Dimension rdum(1)
*
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
      one=1.0d0
*
*
      lPaper=132
      lLine =120
      left=(lPaper-lLine)/2
      Write(Fmt2,'(A,I3.3,A)') '(',left,'X,'

      fail=.false.
      idis=0
      lprint=.false.
      nconf1=0

      If (iAnd(kprint,2).eq.2) lprint=.true.
      If (iMethod.eq.2)
     &     Call InCSFSD(State_Sym,
     &                  State_sym,.false.)
*
        nconf1=ncsf(State_Sym)
        nConf2=nint(xispsm(State_SYM,1))
        nconf3=nint(xispsm(State_SYM,1))
        Call Setup_MCLR(1)
*
*                                    [2]
*         Calculate the diagonal of E    and store in core/disc
*
        If (imethod.gt.0) Then
        If (nconf1.gt.1)
     &       Call CIDia(State_Sym,rCHC)
            irc=ipout(ipdia)
*
*       Allocate disk/memory space
*
*
*       This areas should be addressed through ipin
*       ipout will page them out to disk and free the memory area
*       if page mode is used
*
*       opout will release the memory area without update the disk
*
        ips1 =ipget(nconf3)
        ips2 =ipget(nconf3)
        ipst =ipget(nconf3)
        ipcit=ipget(nconf1)
        ipcid=ipget(nconf1)

        End If
*
*
        idisp=1
*
*      OK START WORKING
*
*
*    Allocate areas for scratch and state variables
*
          Call GetMem('kappa ','Allo','Real',ipKap  ,nDens2)
          Call GetMem('SpinFock','Allo','Real',ipFS ,nDens2)
          Call GetMem('dkappa','Allo','Real',ipdKap ,nDens2)
          Call GetMem('sigma ','Allo','Real',ipSigma,nDens2)
          Call GetMem('Temp1 ','Allo','Real',ipTemp1,nDens2)
          Call GetMem('Temp2 ','Allo','Real',ipTemp2,nDens2)
          Call GetMem('Temp3 ','ALLO','Real',ipTemp3,nDens2)
          Call GetMem('Temp4 ','Allo','Real',ipTemp4,nDens2)
          Call Getmem('Scr1  ','ALLO','Real',ipSc1  ,nDens2)
          Call Getmem('Scr3  ','ALLO','Real',ipSc3  ,nDens2)
          Call Getmem('Scr2  ','ALLO','Real',ipSc2  ,nDens2)
          Call Getmem('PRE  ','ALLO','Real',ipPre2  ,nDensC)
          call dcopy_(nDens2,[0.0d0],0,Work(ipTemp1),1)
          call dcopy_(nDens2,[0.0d0],0,Work(ipKap),1)
          call dcopy_(nDens2,[0.0d0],0,Work(ipsigma),1)
          call dcopy_(nDens2,[0.0d0],0,Work(ipdKap),1)
          If (iMethod.eq.2) Then
             Call GetMem('1Dens','ALLO','Real',ipDe,n1dens)
             Call GetMem('2Dens','ALLO','Real',ipP,nna**4)
             Call GetMem('2Dens','ALLO','Real',iprmoaa,nna**4)
             Call GetMem('2Dens','ALLO','Real',iprmoaa2,nna**4)
          End If
*
*-----------------------------------------------------------------------------
*
*    Calculate RHS
*
*-----------------------------------------------------------------------------
*
          Call Pre_SP(work(ippre2),1)
          Call FockGen_sp(0.0d0,Work(ipG1m),Work(ipG2mp),
     &                   Work(ipFS),Work(ipTemp4),1)
          call dcopy_(nconf1,[0.0d0],0,Work(ipin(ipST)),1)
*
          If (lprint) Write(6,*)
     &      '       Iteration         Delta     Res(kappa) Res(CI)'
          iLen=nDensC
          iRHSDisp(iDisp)=iDis
          Call Compress(Work(ipTemp4),Work(ipSigma),1)
          Call DSCAL_(ndensc,-sqrt(1.5d0)*DBLE(ms2p),
     &               Work(ipSigma),1)
          Call UnCompress(Work(ipSigma),Work(ipTemp4),1)
          Call dDaFile(LuTemp,1,Work(ipSigma),iLen,iDis)
          If (iMethod.eq.2)
     &    call dcopy_(nConf1,[0.0d0],0,Work(ipin(ipCIT)),1)
          irc=ipout(ipcit)
          If (iMethod.eq.2) Then
            ilen=nconf1
            iRHSCIDisp(iDisp)=iDis
            Call dDaFile(LuTemp,1,Work(ipin(ipST)),iLen,iDis)
          End If
          Call DSCAL_(nConf1,-1.0d0,Work(ipin(ipST)),1)
          Call DSCAL_(nDensC,-1.0d0,Work(ipSigma),1)
*
          Call DMInvKap_sp(Work(ipPre2), Work(ipSigma),
     &                    Work(ipdKap),1)


          If (nconf1.gt.1) then
          Call DMinvCI(ipST,
     &                 Work(ipin(ipCId)),
     &                 rCHC,1)
          Else
            call dcopy_(nconf1,Work(ipin(ipST)),1,
     &              Work(ipin(ipCid)),1)
          End if

*
          If (iMethod.eq.2.and.nconf1.ne.0) Then
            deltaC=ddot_(nConf1,Work(ipin(ipST)),1,Work(ipin(ipCId)),1)
            irc=ipout(ipcid)
          Else
            deltac=0.0d0
          end if
          deltaK=ddot_(nDensC,Work(ipKap),1,Work(ipSigma),1)
          call dcopy_(nDens,[0.0d0],0,Work(ipKap),1)
          delta=deltac+deltaK
*         If (delta.eq.0) Goto 300
          delta0=delta
          ReCo=-1.0d0
          iter=1
*-----------------------------------------------------------------------------
*
*
***********************************************************
*          I   T   E   R   A   T   I   O   N   S          *
***********************************************************
*
*
200       Continue
             Read(5,*)  i1,j1
             If (i1.gt.0) Then
             call dcopy_(nDens2,[0.0d0],0,Work(ipdkap),1)
             Work(ipdKap+i1-1)
     &       =1.0d0
             Else
              call dcopy_(nCONF1,[0.0d0],0,Work(ipin(ipCID)),1)
              Work(ipin(ipCid)-i1-1)=1.0d0
              irc=ipout(ipcid)
             End If
*************************************************************
*

            Call RInt_SP(Work(ipDkap),
     &                   Work(iprmoaa),Work(iprmoaa2),
     &                   Work(ipTemp4),Work(ipSc2))

*
             If (i1.gt.0.and.j1.gt.0) Then
               Write(6,*) 'Kap_sig',Work(ipSc2-1+j1)
             End If
             If (nconf1.gt.1) Then
               irc=opout(-1)
               Call CISigma(1,State_Sym,state_sym,
     &                      ipTemp4,iprmoaa,iprmoaa2,
     &                      ipCI,ipS1,'N')
               irc=opout(-1)
               rGrad=ddot_(nconf1,Work(ipin(ipCI)),1,
     &                   Work(ipin(ips1)),1)
               call daxpy_(nConf1,-rgrad,
     &                    Work(ipin(ipCI)),1,Work(ipin(ipS1)),1)
               call dscal_(nconf1,-rms*sqrt(1.5d0)*2.0d0,
     &                    Work(ipin(ips1)),1)
*
             If (i1.gt.0.and.j1.lt.0) Then
               Write(6,*) 'CI_sig',Work(ipin(ips1)-1-j1)
             End If


               irc=opout(-1)
               If (nconf1.gt.1) Then
               Call CISigma(0,State_Sym,state_sym,
     &                    ipFIMO,k2int,idum,
     &                    ipCId,ipS2,'N')
               irc=opout(-1)
               EC=rin_ene+potnuc-ERASSCF(1)

               Call DaXpY_(nConf1,EC,Work(ipin(ipCId)),1,
     &                  Work(ipin(ipS2)),1)
               Call DSCAL_(nConf1,2.0d0,Work(ipin(ipS2)),1)
             If (i1.lt.0.and.j1.lt.0) Then
               Write(6,*) 'CI_sig',Work(ipin(ips2)-1-j1)
             End If
*

*
               Call SpinDens(Work(ipin(ipCI)),Work(ipin(ipCid)),
     &                   State_Sym,State_sym,
     &                   Work(ipp),rdum,rdum,rdum,rdum,
     &                   Work(ipDe),rdum,1)

              d_0=ddot_(nconf1,Work(ipin(ipCid)),1,Work(ipin(ipci)),1)
               Call FockGen_sp(d_0,Work(ipDe),Work(ipP),
     &                    Work(ipSc3),Work(ipSc1),1)
               Call DSCAL_(ndens2,-rms*sqrt(1.5d0),Work(ipSc1),1)

               Call Compress(Work(ipSc1),Work(ipSc3),1)
               If (i1.lt.0.and.j1.gt.0) Then
                Write(6,*) 'CI_sig',Work(ipsc3-1+j1)
               End If
               goto 200
           end if
*

           End If
*
**********************************************************************
*
*        Sc1  kappa-> kappa
*        Sc3  CI -> kappa
*        S1   kappa -> CI
*        S2   CI -> CI
*        dKap present step
*        Kap  kappaX
*        CIT  CIX
*        CId  present step
*
*        Add together
*
*
**********************************************************************
*
*          Call GetMem('AKKK','CHECK','REAL',idum,idum)
           if (nconf1.gt.1) then
            Call DZaXpY(nDens,One,Work(ipSc2),1,
     &            Work(ipSc3),1,Work(ipTemp4),1)
           Else
            call dcopy_(nDens,Work(ipSc2),1,Work(ipTemp4),1)
           End If
           call dcopy_(nDens,Work(ipdKap),1,Work(ipTemp2),1)
           If (nconf1.gt.1) Then
             Call DaXpY_(nConf1,1.0d0,
     &            Work(ipin1(ipS2,nconf1)),1,
     &           Work(ipin1(ipS1,nconf1)),1)
           Else
             call dcopy_(nconf1,[0.0d0],0,Work(ipin1(ipS1,nconf1)),1)
           End If

*-----------------------------------------------------------------------------
*
*                ######   #####   #####
*                #     # #     # #     #
*                #     # #       #
*                ######  #       #  ####
*                #       #       #     #
*                #       #     # #     #
*                #        #####   #####
*
*-----------------------------------------------------------------------------
**********************************************************************
*
*
*                     delta
*          rAlpha=------------
*                 dKappa:dSigma
*
*-----------------------------------------------------------------------------
           rAlphaC=0.0d0
           rAlphaK=0.0d0
           rAlphaK=ddot_(nDensC,Work(ipTemp4),1,Work(ipTemp2),1)
           If (nconf1.ne.0)
     &      rAlphaC=ddot_(nConf1,Work(ipin(ipS1)),1,
     &                   Work(ipin(ipCId)),1)
           rAlpha=delta/(rAlphaK+ralphaC)
*
*-------------------------------------------------------------------*
*
*          Kappa=Kappa+rAlpha*dKappa
*          Sigma=Sigma-rAlpha*dSigma       Sigma=RHS-Akappa
*
           Call DaxPy_(nDensC,ralpha,Work(ipTemp2),1,Work(ipKap),1)
           Call DaxPy_(nDensC,-ralpha,Work(ipTemp4),1,Work(ipSigma),1)
           resk=sqrt(ddot_(nDensC,Work(ipTemp4),1,Work(ipTemp4),1))
           resci=0.0d0
           If (nconf1.ne.0) Then
             Call DaXpY_(nConf1,ralpha,Work(ipin(ipCId)),1,
     &                  Work(ipin(ipCIT)),1)
             irc=ipout(ipcit)
             Call DaXpY_(nConf1,-ralpha,Work(ipin(ipS1)),1,
     &                   Work(ipin1(ipST,nconf1)),1)
             irc=opout(ipS1)
             ip=ipin(ipst)
             resci=sqrt(ddot_(nconf1,Work(ip),1,
     &                        Work(ip),1))
           End If
*
*          Precondition......
*             -1
*          S=M  Sigma
*
           irc=opout(ipcid)
           If (nconf1.gt.1) Then
           Call DMinvCI(ipST,
     &                  Work(ipin(ipS2)),
     &                  rCHC,1)
           Else
            call dcopy_(nconf1,Work(ipin(ipST)),1,
     &                  Work(ipin(ipS2)),1)
           end if


           irc=opout(ipci)
           irc=opout(ipdia)

           Call DMInvKap_sp(Work(ipPre2),work(ipSigma),
     &                      work(ipSC2),1)
*
*-------------------------------------------------------------------*
*               s:Sigma
*          Beta=-------
*                delta
*
*          delta=s:sigma
*
*          dKappa=s+Beta*dKappa
*
           If (iMethod.eq.2.and.nconf1.ne.0) Then
           deltaC=ddot_(nConf1,Work(ipin(ipST)),1,Work(ipin(ipS2)),1)
           irc=ipout(ipST)
           else
           deltaC=0.0d0
           end if
*
           deltaK=ddot_(nDensC,Work(ipSigma),1,Work(ipSc2),1)
           If (imethod.ne.2) Then
             rBeta=deltaK/delta
             delta=deltaK
             Call DScal_(nDensC,rBeta,Work(ipTemp2),1)
             Call DaXpY_(nDensC,1.0d0,Work(ipsc2),1,Work(ipTemp2),1)
           Else
             rbeta=(deltac+deltaK)/delta
             delta=deltac+deltaK
             Call DScal_(nConf1,rBeta,Work(ipin(ipCID)),1)
             Call DScal_(nDensC,rBeta,Work(ipTemp2),1)
             Call DaXpY_(nConf1,1.0d0,Work(ipin(ipS2)),1,
     &                             Work(ipin(ipCID)),1)
             Call DaXpY_(nDensC,1.0d0,Work(ipsc2),1,Work(ipTemp2),1)
             irc=opout(ipS2)
             irc=ipout(ipCID)
           End If
*

*    ######  #    #  #####        #####    ####    ####
*    #       ##   #  #    #       #    #  #    #  #    #
*    #####   # #  #  #    #       #    #  #       #
*    #       #  # #  #    #       #####   #       #  ###
*    #       #   ##  #    #       #       #    #  #    #
*    ######  #    #  #####        #        ####    ####
*


*
*-------------------------------------------------------------------*
*
           call dcopy_(ndensc,Work(ipTemp2),1,Work(ipdKap),1)
*
           res=0.0D0 ! dummu initialize
           If (iBreak.eq.1) Then
              If (abs(delta).lt.abs(Epsilon**2*delta0)) Goto 300
           Else If (ibreak.eq.2) Then
              res=sqrt(resk**2+resci**2)
              If (res.lt.abs(epsilon)) Goto 300
           Else
              If (abs(delta).lt.abs(Epsilon**2*delta0).and.
     &            res.lt.abs(epsilon))  Goto 300
           End If
           If (iter.ge.niter) goto 210
           If (lprint)
     &     Write(6,Fmt2//'A,i2,A,F12.7,F12.7,F12.7,F12.7,F12.7)')
     &            '     ',
     &            iter,'       ',delta/delta0,resk,resci,deltac,deltak

           iter=iter+1
*          Call GetMem(' LIST ','LIST','REAL',iDum,iDum)

          Goto 200
*
**********************************************************************
*
 210      Continue
          Write(6,Fmt2//'A,I4,A)')
     &    'No convergence for perturbation no: ',
     &                      idisp,'. Increase Iter.'
          fail=.true.
          Goto 310
 300      Write(6,Fmt2//'A,I4,A,I4,A)')
     &           'Perturbation no: ',idisp,' converged in ',
     &             iter-1,' steps.'
          irc=ipnout(-1)
 310      Continue
          Write(6,*)
          iLen=ndensC
          iKapDisp(iDisp)=iDis
          Call dDaFile(LuTemp,1,Work(ipKap),iLen,iDis)
          iSigDisp(iDisp)=iDis
          Call dDaFile(LuTemp,1,Work(ipSigma),iLen,iDis)
          If (iMethod.eq.2) Then
            ilen=nconf1
            iCIDisp(iDisp)=iDis
            Call dDaFile(LuTemp,1,Work(ipin(ipCIT)),iLen,iDis)
            iCISigDisp(iDisp)=iDis
            Call dDaFile(LuTemp,1,Work(ipin(ipST)),iLen,iDis)
          End If
*
          Call GetMem('Temp4  ','FREE','Real',ipTemp4,nDens)
          Call GetMem('Temp3  ','FREE','Real',ipTemp3,ndens)
          Call GetMem('Temp2  ','FREE','Real',ipTemp2,nDens)
          Call GetMem('Temp1  ','FREE','Real',ipTemp1,nDens)
          Call GetMem('sigma  ','FREE','Real',ipSigma,nDens)
          Call GetMem('dkappa ','FREE','Real',ipdKap ,nDens)
          Call GetMem('kappa  ','FREE','Real',ipKap  ,nDens)
          Call Getmem('Scr1   ','FREE','Real',ipSc1  ,nDens2)
          Call Getmem('Scr2   ','FREE','Real',ipSc2  ,nDens2)
          Call Getmem('Scr3   ','FREE','Real',ipSc3  ,nDens2)
          If (iMethod.eq.2) Then
             Call GetMem('2Dens','FREE','Real',iprmoaa,n2dens)
             Call GetMem('2Dens','FREE','Real',ipP,n1dens)
             Call GetMem('1Dens','FREE','Real',ipDe,n2dens)
          End If
*
*        Free all memory and remove from disk all data
*        related to this symmetry
*
         If (imethod.eq.2) irc=ipclose(ipci)
*
         If (iphx.ne.0) Then
          Call Getmem('EXPHS','FREE','REAL',iphx,idum)
          Call Getmem('EXPHF','FREE','INTE',ipvt,idum)
          Call Getmem('EXPLS','FREE','INTE',iplst,idum)
         End If

      If (debug) Then
      Write(6,*)  '****************************************',
     &            '****************************************'
      Write(6,*)
      End If
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2020, Jie J. Bao                                       *
************************************************************************
*       ***************************************************
*                          Calculating NTO
*       ****************************************************
*        Reference: J. Chem. Phys., 2014, 141, 024106
*        Notation used in the following of the code follows those in the
*        reference mentioned above, especially between equation 53 and
*        54 on page 024106-8.
*        NASHT is the number of active orbitals, originated from this
*        program.
*        Umat is the U matrix, which is the eigenvector  matrix
*        calculated by transition density matrix (TDM)
*        multiplied by its transpose. Vmat is the V matrix, the eigen-
*        vector matrix of a matrix calculated by the transpose
*        multiplied by the TDM.
*        LNTOUeig is the eigenvalen matrix for the U matrix, LNTOVeig is
*        that
*        for the V matrix.
*        ONTO is the hole NTO, calculated by multiplying MO matrix with
*        the eigenvector matrix for U matrix. Note that the eigenvector
*        matrix is still named as U. Similar condition is for the
*        particle matirx.
*
*        However, the sets of particle and hole orbitals are switched
*        when I examined the results. So I put the data stored in LONTO
*        as the particle NTO. (Because JOB1 is for the second JobIph
*        file in the input and JOB2 is for the first.)
*
*                                         -------Jie Bao
*                  in Depart. of Chemistry, University of Minnesota, USA
*                                             2018/08/09

      SUBROUTINE   NTOCalc(JOB1,JOB2,ISTATE,JSTATE,TRAD,TRASD,ISpin)
#include "rasdim.fh"
#include "rasdef.fh"
#include "symmul.fh"
#include "rassi.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "Files.fh"
#include "Struct.fh"
#include "rassiwfn.fh"

      Integer ISpin,JOB1,JOB2
      Real*8,DIMENSION(NASHT**2)::TRAD,TRASD
      Character,DIMENSION(2) :: Spin
      INTEGER Iprint,Jprint,I,J,isym
! Printing or looping control
      INTEGER IUseSym,NUseSym,NSupBas,icactorb
      INTEGER,DIMENSION(NBST)  :: OrbUsedSym
      INTEGER,DIMENSION(NASHT+NISHT) :: OrbAct
! CMO Symmetry Contrl
      INTEGER,DIMENSION(NSym) :: NUsedBF,NUseBF,UsetoReal,RealtoUse
! Nr. of basis functions used prior to this symmetry (NUsedBF)
! and used in this symmetry (NUseBF) NSym >= NusedSym
      INTEGER   IOrb
!IOrb is the index  of orbitals.
      INTEGER LSUPCMO1,LSUPCMO2,NSUPCMO
      INTEGER NDge,LNTOUmat,LNTOVmat,LNTOVeig
      INTEGER LTDM,LTDMT,LScrq,NScrq,LCMO1,LCMO2
      REAL*8 WGRONK(2)
      INTEGER LONTO, LUNTO,N_NTO,INFO, LNTOUeig,I_NTO
      INTEGER LSymfr,LIndfr,LSymto,LIndto
      REAL*8 Zero,Two,PrintThres,SumEigVal
!     re-organizing orbitals
!     This is to convert active MO sets in any symmetry into a C1 symmetry
      INTEGER NAISHT
      INTEGER, DIMENSION(NISHT+NASHT) :: OrbBas,OrbSym
      !OrbBas() is the number of basis function for IOrb
      !OrbSym() is the index of symmetry/irrep  for IOrb
      CHARACTER (len=128) FILENAME
      CHARACTER (len=8)  NTOType
      CHARACTER (len=5)  STATENAME,StateNameTmp
      Character*3 lIrrep(8)
      Logical DOTEST
      INTEGER LU,ISFREEUNIT
      COMMON SumEigVal
      EXTERNAL ISFREEUNIT, Molden_interface

      LU=233

      DoTest=.false.
      Zero=0.0D0
      Two=2.0D0
      PrintThres=1.0D-5
      CALL GETMEM('GTDMCMO1','ALLO','REAL',LCMO1,NCMO)
      CALL GETMEM('GTDMCMO2','ALLO','REAL',LCMO2,NCMO)
      CALL RDCMO_RASSI(JOB1,WORK(LCMO1))
      CALL RDCMO_RASSI(JOB2,WORK(LCMO2))

      if(dotest)then
C       write (6,*) 'LTRad ',LTRad,WORK(LTRAD)
C       write(6,*) 'Transition density matrix '
C       Do IPrint=1,NASHT
C       write (6,'(10(2X,F10.7))')
C     & (WORK(LTRAD+JPrint-1+NASHT*(IPrint-1)),JPrint=1,NASHT)
C       End Do
       write(6,*) 'LCMO1 '
       Do I=0,NCMO,5
       write(6,'(2X,5F10.6)')
     & (WORK(LCMO1+I+IPrint-1),IPrint=1,MIN(5,NCMO-I))
       End Do
       write(6,*) 'LCMO2 '
       Do I=0,NCMO,5
       write(6,'(2X,5F10.6)')
     & (WORK(LCMO2+I+IPrint-1),IPrint=1,MIN(5,NCMO-I))
       End Do
      endif

C     Analyzing the symmetry of the wave function
      IUseSym=0
      NSupBas=0
      IOrb=0
      Do ISym=1,NSym
       IF (NASH(ISym).GT.0) Then
        IUseSym=IUseSym+1
        RealtoUse(ISym)=IUseSym
        UsetoReal(IUseSym)=ISym
        NSupBas=NSupBas+NBASF(ISym)
        If (IUseSym.gt.1) THEN
         NUsedBF(IUseSym)=NBASF(UsetoReal(IUseSym-1))+NUsedBF(IUseSym-1)
        Else
         NUsedBF(IUseSym)=0
        END IF
        NUseBF(IUseSym)=NBASF(ISym)
        Do I=1,NOSH(ISym)
         IOrb=IOrb+1
         If (I.gt.NISH(ISym)) Then
          OrbAct(IOrb)=1
         Else
          OrbAct(IOrb)=0
         End If
         OrbBas(IOrb)=NBASF(ISym)
         OrbSym(IOrb)=ISym
         OrbUsedSym(IOrb)=IUseSym
        End Do
       Else
        RealtoUse(ISym)=0
       End If
      End Do
      NSUPCMO=NASHT*NSupBas
      NUseSym=IUseSym
      NAISHT=NASHT+NISHT
      IF (DoTest) Then
       write(6,*) 'Reprinting MO information'
       write(6,*) 'Size of Super-CMO matrix',NSupCMO
       write(6,'(6X,A20,4X,16I4)')
     & 'MO Index',(IOrb,IOrb=1,NAISHT)
       write(6,'(6X,A20,4X,16I4)')
     & 'Irrep Belong to',(OrbSym(IOrb),IOrb=1,NAISHT)
       write(6,'(6X,A20,4X,16I4)')
     & 'Nr. of Basis F',(OrbBas(IOrb),IOrb=1,NAISHT)
       write(6,'(6X,A20,4X,16I4)')
     & 'Act Orbital?',(OrbAct(IOrb),IOrb=1,NAISHT)
       write(6,'(6X,A20,4X,16I4)')
     & 'used basis f',(NUsedBF(OrbUsedSym(IOrb)),IOrb=1,NAISHT)
      End If
C     End of analyzing wave function

C     building up a super-CMO matrix (to be C1-like)
      CALL GETMEM ('SupCMO1','Allo','Real',LSUPCMO1,NSUPCMO)
      CALL GETMEM ('SupCMO2','Allo','Real',LSUPCMO2,NSUPCMO)
      CALL GETMEM ('ONTO','Allo','Real',LONTO,NSUPCMO)
      CALL GETMEM ('UNTO','Allo','Real',LUNTO,NSUPCMO)
      CALL DCOPY_(NSUPCMO,[Zero],0,WORK(LSUPCMO1),1)
      CALL DCOPY_(NSUPCMO,[Zero],0,WORK(LSUPCMO2),1)
      icactorb=0
      I=0
      Do IOrb=1,NAISHT
       IF (OrbAct(IOrb).eq.1) THEN
         icactorb=icactorb+1
         Do IPrint=1,(OrbBas(IOrb))
          JPrint=IPrint+NUsedBF(OrbUsedSym(IOrb))
          J=I+IPrint-1
C          write(6,'(4X,5I4,2F10.6)') IOrb,icactorb,
C     &    NUsedBF(OrbUsedSym(IOrb)),I,J,WORK(LCMO1+J),WORK(LCMO2+J)
          WORK(LSUPCMO1+icactorb-1+(JPRINT-1)*NASHT)=WORK(LCMO1+J)
          WORK(LSUPCMO2+icactorb-1+(JPRINT-1)*NASHT)=WORK(LCMO2+J)
        End DO
       End IF
       I=I+OrbBas(IOrb)
      End DO
      If (DoTest) Then
      write (6,*) 'LSupCMO1=',LSupCMO1
      write (6,*) 'LSupCMO2=',LSupCMO2
       write(6,*)'printing CMO1 in a C1-like format'
       Do I=1,NASHT
        Do J=1,NSupBas,10
         write(6,'(4X,10F10.6)')(WORK(LSUPCMO1+I-1+(JPrint-1)*NASHT),
     &   JPrint=J,MIN(J+9,NSupBas))
        End DO
       End Do


       write(6,*)'printing CMO2 in a C1-like format'
       Do I=1,NASHT
        Do J=1,NSupBas,10
         write(6,'(4X,10F10.6)')(WORK(LSUPCMO2+I-1+(JPrint-1)*NASHT),
     &   JPrint=J,MIN(J+9,NSupBas))
        End DO
       End Do
      End If
C     end of building up the super-CMO matrix
C     Start and initialize spaces
      write(StateName,'(I3)') ISTATE
      write(StateNameTmp,'(I3,a1,a)')
     & JSTATE,'_',trim(adjustl(STATENAME))
      write (STATENAME,'(a)') trim(adjustl(StateNameTmp))
      NDge=NASHT**2
      CALL GETMEM ('Umat','Allo','Real',LNTOUmat,NDge)
      CALL GETMEM ('Vmat','Allo','Real',LNTOVmat,NDge)
      CALL GETMEM ('Ueig','Allo','Real',LNTOUeig,NDge)
      CALL GETMEM ('Veig','Allo','Real',LNTOVeig,NDge)
      CALL GETMEM ('TDM' ,'Allo','Real',LTDM,NDge)
      CALL GETMEM ('TDMT','Allo','Real',LTDMT,NDge)
       write(6,*)
       WRITE(6,'(6X,100A1)') ('*',i=1,100)
       WRITE(6,'(6X,A,98X,A)') '*','*'
       WRITE(6,'(6X,A,34X,A31,33X,A)')
     &     '*','NATURAL TRANSITION ORBITALS','*'
       WRITE(6,'(6X,A,98X,A)') '*','*'
       WRITE(6,'(6X,A,38X,A14,I2,A12,I2 ,30X,A )')
     &'*','BETWEEN STATE ',JSTATE,' AND STATE ',ISTATE,'*'
       WRITE(6,'(6X,A,98X,A)') '*','*'
      WRITE(6,'(6X,100A1)') ('*',i=1,100)
       write(6,*)
       write(6,*)
      IF (ISpin.eq.1) Then
        N_NTO=1
        Spin(1)='a'
        write (6,'(10X,2a)')'NTO CALCULATION ONLY DONE FOR ALPHA SPIN ',
     &'BECAUSE THE WAVE FUNCTION IS A SINGLET,'
        write (6,'(10X,a)')'SO ALPHA NTOS ARE EQUAL TO BETA ONES'
       Else
        N_NTO=2
        Spin(1)='a'
        Spin(2)='b'
      End IF
      Do I_NTO=1,N_NTO
      CALL DCOPY_(Ndge,[Zero],0,WORK(LNTOUeig),1)
      CALL DCOPY_(Ndge,[Zero],0,WORK(LNTOVeig),1)
      CALL DCOPY_(NSupCMO,[Zero],0,WORK(LONTO),1)
      CALL DCOPY_(NSupCMO,[Zero],0,WORK(LUNTO),1)
!      CALL DCOPY_(Ndge,WORK(LTRAD),1,WORK(LTDM),1)
      If (Spin(I_NTO).eq.'a') Then
C       WORK(LTDM-1+I)=WORK(LTRAD-1+I)
      Do I=1,Ndge
       WORK(LTDM-1+I)=(TRAD(I)+TRASD(I))/Two
      End DO
      else
      Do I=1,Ndge
       WORK(LTDM-1+I)=(TRAD(I)-TRASD(I))/Two
      End DO
      End IF
      DO I=1,NASHT
       DO J=1,NASHT
        WORK(LTDMT+(I-1)+NASHT*(J-1))=WORK(LTDM+(J-1)+NASHT*(I-1))
       END DO
      END DO
C     Print out transition density matrix
      If(Spin(I_NTO).eq.'a') Then
      write (FILENAME,fmt='(a,a)')
     &"TDM",trim(adjustl(STATENAME))
      LU=ISFREEUNIT(LU)
      CALL Molcas_Open(LU,FILENAME)
      DO I=1,NASHT
        write (LU,'(5(2X,E10.4E2))')
     &    (TRAD(NASHT*(I-1)+J),J=1,NASHT)
      END DO
      write (LU,*)
      write (LU,*)
      write (LU,*)
      DO I=1,NASHT
        write (LU,'(5(2X,E10.4E2))')
     &    (TRASD(NASHT*(I-1)+J),J=1,NASHT)
      END DO
      close (LU)
      End If
C     Generalizing transpose of TDM, TDM_T

C     Calculating T_trans*T
      CALL DGEMM_('n','n',NASHT,NASHT,NASHT,1.0D0,WORK(LTDMT),NASHT,
     &             WORK(LTDM),NASHT,0.0D0,WORK(LNTOVmat),NASHT)
C     Writing Particle Matrix
      write (FILENAME,fmt='(a,a,a)')
     &"Dhole.",trim(adjustl(STATENAME)),Spin(I_NTO)
      LU=ISFREEUNIT(LU)
      CALL Molcas_Open(LU,FILENAME)
      DO I=1,NASHT
        write (LU,'(10(2X,E10.4E2))')
     &    (WORK(LNTOVmat-1+NASHT*(I-1)+J),J=1,NASHT)
      END DO
      close (LU)
C     Calculating T*T_transpose
      CALL DGEMM_('n','n',NASHT,NASHT,NASHT,1.0D0,WORK(LTDM),NASHT,
     &             WORK(LTDMT),NASHT,0.0D0,WORK(LNTOUmat),NASHT)
      write (FILENAME,fmt='(a,a,a)')
     &"Dpart.",trim(adjustl(STATENAME)),Spin(I_NTO)
      LU=ISFREEUNIT(LU)
      CALL Molcas_Open(LU,FILENAME)
      DO I=1,NASHT
        write (LU,'(10(2X,E10.4E2))')
     &    (WORK(LNTOUmat-1+NASHT*(I-1)+J),J=1,NASHT)
      END DO
      close (LU)
       CALL DSYEV_('V','U',NASHT,WORK(LNTOVmat),NASHT,WORK(LNTOVeig),
     &              WGRONK,-1,INFO)
       NScrq=INT(WGRONK(1))
       If(Nscrq.eq.0) Then
        Nscrq=MAX(NDge,100)
        if(DoTest) Then
         write(6,*)'Size of scratch space is increased to max(NDge,100)'
        end if
       End If
       CALL GETMEM ('Scrq','Allo','Real',LScrq,NScrq)
C       Diagonalizing matrices
       CALL DSYEV_('V','U',NASHT,WORK(LNTOUmat),NASHT,WORK(LNTOUeig),
     &              WORK(LScrq),NScrq,INFO)
       CALL DSYEV_('V','U',NASHT,WORK(LNTOVmat),NASHT,WORK(LNTOVeig),
     &              WORK(LScrq),NScrq,INFO)
       CALL GETMEM ('Scrq','Free','Real',LScrq,NScrq)
C     Printing some matrices
      If (DoTest) Then
       write (FILENAME,fmt='(a,a,a)')
     & "EigVecHole.",trim(adjustl(STATENAME)),Spin(I_NTO)
      LU=ISFREEUNIT(LU)
      CALL Molcas_Open(LU,FILENAME)
       DO I=1,NASHT
         write (LU,'(5(2X,E10.4E2))')
     &     (WORK(LNTOVmat-1+NASHT*(I-1)+J),J=1,NASHT)
       END DO
       close (LU)
       write (FILENAME,fmt='(a,a,a)')
     & "EigVecPart.",trim(adjustl(STATENAME)),Spin(I_NTO)
      LU=ISFREEUNIT(LU)
      CALL Molcas_Open(LU,FILENAME)
       DO I=1,NASHT
         write (LU,'(5(2X,E10.4E2))')
     &     (WORK(LNTOUmat-1+NASHT*(I-1)+J),J=1,NASHT)
       END DO
       close (LU)
      End IF
C     End of Diagonlazing the mataces

C     Constructing hole and particle orbitals

      CALL DGEMM_('t','n',NASHT,NSupBas,NASHT,1.0D0,WORK(LNTOUmat),
     &      NASHT,WORK(LSupCMO1),NASHT,0.0D0,WORK(LONTO),NASHT)
      CALL DGEMM_('t','n',NASHT,NSupBas,NASHT,1.0D0,WORK(LNTOVmat),
     &      NASHT,WORK(LSupCMO2),NASHT,0.0D0,WORK(LUNTO),NASHT)

      If (DoTest) Then
       write(6,*)'printing Particle NTO in a C1-like format'
       Do I=1,NASHT
        Do J=1,NSupBas,10
         write(6,'(4X,10F10.6)')(WORK(LONTO+I-1+(JPrint-1)*NASHT),
     &   JPrint=J,MIN(J+9,NSupBas))
        End DO
       End Do

       write(6,*)'printing Hole     NTO in a C1-like format'
       Do I=1,NASHT
        Do J=1,NSupBas,10
         write(6,'(4X,10F10.6)')(WORK(LUNTO+I-1+(JPrint-1)*NASHT),
     &   JPrint=J,MIN(J+9,NSupBas))
        End DO
       End Do
      End If

C     Printing NTOs
      CALL GETMEM ('PartNTOSyms','Allo','Inte',LSymto,NASHT)
      CALL GETMEM ('PartNTOIndx','Allo','Inte',LIndto,NASHT)
      CALL GETMEM ('PartNTOSyms','Allo','Inte',LSymfr,NASHT)
      CALL GETMEM ('PartNTOIndx','Allo','Inte',LIndfr,NASHT)
      NTOType='PART'
      CALL NTOSymAnalysis(NUseSym,NUseBF,NUsedBF,LONTO,NTOType,
     &STATENAME,LNTOUeig,UsetoReal,RealtoUse,Spin(I_NTO),LSymto,LIndto)
      NTOType='HOLE'
      CALL NTOSymAnalysis(NUseSym,NUseBF,NUsedBF,LUNTO,NTOType,
     &STATENAME,LNTOVeig,UsetoReal,RealtoUse,Spin(I_NTO),LSymfr,LIndfr)
C     End of Printing NTOs

      Call Get_cArray('Irreps',lIrrep,24)
      Do iSym = 1, nSym
         Call RightAd(lIrrep(iSym))
      End Do

C     Putting particle-hole pairs in the output
        write(6,*)
      IF(I_NTO.eq.1) THEN
      write(6,'(10X,a)')
     &'NATURAL TRANSITION ORBTIAL INFORMATION FOR ALPHA SPIN'
      ELSE
      write(6,'(10X,a)')
     &'NATURAL TRANSITION ORBTIAL INFORMATION FOR BETA  SPIN'
      END IF
      WRITE(6,'(6X,100A1)') ('=',i=1,100)
      write(6,'(10X,5A18)')'EXCITATION','EIGENVALUE',
     &'EXCITATION','HOLE NTO','PARTICLE NTO'
      write(6,'(10X,A18,18X,3A18)')'AMPLITUDE','CONTRIBUTION(%)',
     &'SYMMETRY INDEX','SYMMETRY INDEX'
      WRITE(6,'(6X,100A1)') ('-',i=1,100)
      Do IOrb=NASHT,1,-1
       IF(WORK(LNTOUeig-1+IOrb).lt.PrintThres)  EXIT
       write(6,'(10X,2(10X,F8.5),10X,F8.2,2(A9,I9))')
     & SQRT(WORK(LNTOUeig-1+IOrb)),WORK(LNTOUeig-1+IOrb),
     &WORK(LNTOUeig-1+IOrb)/SumEigVal*1.0D2,
     & lIrrep(INT(WORK(LSymfr-1+IOrb))),INT(WORK(LIndfr-1+IOrb)),
     & lIrrep(INT(WORK(LSymto-1+IOrb))),INT(WORK(LIndto-1+IOrb))
      End Do

      WRITE(6,'(6X,100A1)') ('-',i=1,100)
       write(6,'(6X,A,F8.5)')'SUM OF EIGENVALUES',SumEigVal
      WRITE(6,'(6X,100A1)') ('=',i=1,100)


      CALL GETMEM ('PartNTOSyms','Free','Inte',LSymto,NASHT)
      CALL GETMEM ('PartNTOIndx','Free','Inte',LIndto,NASHT)
      CALL GETMEM ('PartNTOSyms','Free','Inte',LSymfr,NASHT)
      CALL GETMEM ('PartNTOIndx','Free','Inte',LIndfr,NASHT)
      End DO
! End of loop over N_NTO (I_NTO=1 for alpha and 2 for beta)

       write(6,*)
       WRITE(6,'(6X,100A1)') ('*',i=1,100)
       WRITE(6,'(6X,A,33X,A34,31X,A)')
     &     '*','END OF NATURAL TRANSITION ORBITALS','*'
       WRITE(6,'(6X,A,33X,A14,I2,A12,I2 ,35X,A )')
     &'*','BETWEEN STATE ',JSTATE,' AND STATE ',ISTATE,'*'
      WRITE(6,'(6X,100A1)') ('*',i=1,100)

      CALL GETMEM ('Umat','Free','Real',LNTOUmat,NDge)
      CALL GETMEM ('Vmat','Free','Real',LNTOVmat,NDge)
      CALL GETMEM ('Ueig','Free','Real',LNTOUeig,NDge)
      CALL GETMEM ('Veig','Free','Real',LNTOVeig,NDge)
      CALL GETMEM ('TDM' ,'Free','Real',LTDM,NDge)
      CALL GETMEM ('TDMT','Free','Real',LTDMT,NDge)
      CALL GETMEM('GTDMCMO1','Free','REAL',LCMO1,NCMO)
      CALL GETMEM('GTDMCMO2','Free','REAL',LCMO2,NCMO)

      CALL GETMEM ('SupCMO1','Free','Real',LSUPCMO1,NSUPCMO)
      CALL GETMEM ('SupCMO2','Free','Real',LSUPCMO2,NSUPCMO)
      CALL GETMEM ('ONTO','Free','Real',LONTO,NSUPCMO)
      CALL GETMEM ('UNTO','Free','Real',LUNTO,NSUPCMO)
      RETURN
      END



      SUBROUTINE  NTOSymAnalysis(NUseSym,NUseBF,NUsedBF,LNTO,
     &NTOType,STATENAME,LEigVal,UsetoReal,RealtoUse,Spin,LSym,LInd)
#include "rasdim.fh"
#include "rasdef.fh"
#include "symmul.fh"
#include "rassi.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "Files.fh"
#include "Struct.fh"
#include "rassiwfn.fh"

C     input variables
      INTEGER NUseSym,LNTO,LEigVal
      INTEGER,DIMENSION(NSym) :: NUseBF,NUsedBF,UsetoReal,RealtoUse
      CHARACTER (len=8) NTOType
      CHARACTER (len=1) Spin
      CHARACTER (len=5)  STATENAME
      CHARACTER (len=128) FILENAME, molden_name
C     Loop control
      INTEGER I, J, ICount
C     Variables needed for judging the symmetry of a NTO
      INTEGER INTO,IUseSym,NNTO,ISym,IOrb
      REAL*8,DIMENSION(NUseSym) :: SquareSum
      REAL*8,DIMENSION(NBST) :: EigValArray
C     SquareSum=Sum over square of coefficients for certain symmetry
      INTEGER,DIMENSION(NUseSym) :: NOrbinSym
C     Total number of orbitals in IUseSym
      INTEGER,DIMENSION(NUseSym,NASHT) :: OrbSymIndex
C     OrbSymIndex gives the original orbital index for a orbital in iusesym
      REAL*8 Threshold,Zero,SumEigVal
C     If SquareSum(IUseSym) > Threshold, then print the coefficients in IUseSym symmetry
C     If there are more than one symmetry with SquareSum(IUseSym) > Threshold,
C     then give a warning message and print the one with the largest SquareSum
      COMMON SumEigVal
      INTEGER NPCMO,IPCMO
      Real*8,DIMENSION(:),allocatable::PCMO
C     Printing control
C
      INTEGER iPrintSym,OrbNum,IOrbinSym,LSym,LInd
      INTEGER LU,ISFREEUNIT
      Real*8,DIMENSION(2) :: vDum
      INTEGER,DIMENSION(7,8) :: v2Dum
      CHARACTER(len=72)Note
      Logical DoTest
      External ISFREEUNIT

      DoTest=.false.
      Threshold=0.0D-10
      Zero=0.0D0

      Do IUseSym=1,NUseSym
       NOrbinSym(IUseSym)=0
      End DO

      NPCMO=0
      Do ISym=1,NSym
       NPCMO=NPCMO+NBASF(ISym)**2
      End Do
      allocate(PCMO(NPCMO))


      Do INTO=1,NASHT
       iPrintSym=0
       Do IUseSym=1,NUseSym
        SquareSum(IUseSym)=Zero
        Do ICount=1,NUseBF(IUseSym)
         I=INTO
         J=ICount+NUsedBF(IUseSym)
         SquareSum(IUseSym)=SquareSum(IUseSym)
     &   +WORK(LNTO+I-1+(J-1)*NASHT)**2
        End DO
        If (SquareSum(IUseSym).gt.Threshold) THEN
         If (iPrintSym.eq.0) Then
          iPrintSym=IUseSym
         Else
          write(6,'(a,a)')'There are at least two symmetries that have',
     &    ' a sum of coefficient**2 larger than the threshold'
       write(6,'(5A10)')'Threshold','Sum1','Sum2','Sym1','Sym2'
       write(6,'(3E10.6E2,2I10)')Threshold,SquareSum(iPrintSym),
     & SquareSum(IUseSym),iPrintSym,IUseSym
          If (SquareSum(iPrintSym).lt.SquareSum(IUseSym)) THEN
           iPrintSym=IUseSym
          End If
         End IF
        End If
       End Do
       If(iPrintsym.eq.0) Then
        write(6,'(a,I2,a,a,a)') 'the symmetry of orbital ',INTO,
     & ' is not found. How is this possible?',
     & ' Change the value of DoTest in ntocalc.f to true ',
     & ' to print out the intermediate values'
       End If
        NOrbinSym(IPrintSym)=NOrbinSym(IPrintSym)+1
        OrbSymIndex(IPrintSym,NOrbinSym(IPrintSym))=INTO
      WORK(LSym-1+INTO)=UsetoReal(IPrintSym)
      WORK(LInd-1+INTO)=NOrbinSym(IPrintSym)+NISH(UsetoReal(IPrintSym))
      End Do

C     generating file in a similar way to other orbital files
      IOrb=0
      IPCMO=0
      SumEigVal=Zero
      Do ISym=1,NSym
       IUseSym=RealtoUse(ISym)
       If(IUseSym.ne.0) Then
C      If there are active orbitals in this symmetry
       NNTO=NOrbinSym(IUseSym)
C       write inactive part
       Do OrbNum=1,NISH(ISym)
        IOrb=IOrb+1
        EigValArray(IOrb)=Zero
       END DO
C Recording Printed NTO (PCMO)
       Do I=1,NISH(ISym)*NBASF(ISYM)
        IPCMO=IPCMO+1
        PCMO(IPCMO)=Zero
       End Do
C Recording Printed NTO (PCMO)
C       write active part
       Do IOrbinSym=1,NNTO
        OrbNum=IOrbinSym+NISH(ISym)
        IOrb=IOrb+1
        I=OrbSymIndex(IUseSym,IOrbinSym)
        EigValArray(IOrb)=WORK(LEigVal-1+I)
        SumEigVal=SumEigVal+WORK(LEigVal-1+I)
C Recording Printed NTO (PCMO)
        Do ICount=1,NUseBF(IUSeSym)
         IPCMO=IPCMO+1
         J=ICount+NUsedBF(IUseSym)
         PCMO(IPCMO)=WORK(LNTO+I-1+(J-1)*NASHT)
        End Do
C Recording Printed NTO (PCMO)
       End Do
C       write virtual part
       Do OrBNum=NISH(ISym)+NASH(ISym)+1,NBASF(ISym)
        IOrb=IOrb+1
        EigValArray(IOrb)=Zero
       END DO
C Recording Printed NTO (PCMO)
       Do I=1,NSSH(ISym)*NBASF(ISYM)
        IPCMO=IPCMO+1
        PCMO(IPCMO)=Zero
       End Do
C Recording Printed NTO (PCMO)
       Else
C      If there is no active orbitals in this symmetry
       Do OrbNum=1,NBASF(ISym)
        IOrb=IOrb+1
        EigValArray(IOrb)=Zero
       END DO
C Recording Printed NTO (PCMO)
       Do I=1,NBASF(ISYM)**2
        IPCMO=IPCMO+1
        PCMO(IPCMO)=Zero
       End Do
C Recording Printed NTO (PCMO)
       End If
      End Do


      Do I=1,NBST
       EigValArray(I)=EigValArray(I)/SumEigVal
      End Do

      LU=50
      LU=ISFREEUNIT(LU)
      Note='*  Natural Transition Orbitals'
      WRITE(FILENAME,'(6(a))')
     & 'NTORB.',trim(adjustl(STATENAME)),'.',Spin,'.',NTOType
      WRITE(molden_name,'(6(a))')
     & 'MD_NTO.',trim(adjustl(STATENAME)),'.',Spin,'.',NTOType
      CALL WRVEC_(FILENAME,LU,'CO',0,NSYM,NBASF,NBASF,PCMO,vDum,
     & EigValArray,vDum,vDum,vDum,v2Dum,Note,0)
      CALL Molden_interface(0,trim(FILENAME),trim(molden_name))

      deallocate(PCMO)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      integer function indget_cvb(iminor, idim, nel, ixmin)
      dimension ixmin(0:nel,0:idim),iminor(nel)
      indget_cvb=1
      iacc=0
      do 1100 i=1,nel
      if(iminor(i).eq.1)then
        iacc=iacc+1
        indget_cvb=indget_cvb+ixmin(i-1,iacc)
      endif
1100  continue
      return
      end
      integer function minind_cvb(iminor, idim, nel, ixmin)
      dimension ixmin(0:nel,0:idim),iminor(idim)
      minind_cvb=1
      do 1100 i=1,idim
      minind_cvb=minind_cvb+ixmin(iminor(i)-1,i)
1100  continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cct3_map11(a,b,dimp,nfact)
! mapping A(p) -> nfact*B(p)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dimp, nfact
real(kind=wp), intent(in) :: a(dimp)
real(kind=wp), intent(out) :: b(dimp)

if (nfact == 1) then

  b(:) = a

else

  b(:) = -a

end if

return

end subroutine cct3_map11

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine WR_RASSCF_Info(Lu,iOpt,iDisk,
     &                          NACTEL,ISPIN,NSYM,LSYM,
     &                          NFRO,NISH,NASH,NDEL,NBAS,mxSym,
     &                          NAME,nName,NCONF,HEADER,nHeader,
     &                          TITLE,nTitle,POTNUC,LROOTS,NROOTS,
     &                          IROOT,mxRoot,NRS1,NRS2,NRS3,
     &                          NHOLE1,NELEC3,IPT2,WEIGHT)
      Implicit Real*8 (a-h,o-z)
#include "SysDef.fh"
      Integer nFro(MxSym), nISh(MxSym), nASh(MxSym), nDel(MxSym),
     &        nBas(MxSym), iRoot(MxRoot),
     &        nRS1(MxSym), nRS2(MxSym), nRS3(MxSym)
      Character Name(nName)*1, Header(nHeader)*1, Title(nTitle)*1
      Real*8 Weight(MxRoot)
*
      Call s_iDaFile_rasscf(Lu,iOpt, nActEl, 1,      iDisk)
      Call s_iDaFile_rasscf(Lu,iOpt, iSpin,  1,      iDisk)
      Call s_iDaFile_rasscf(Lu,iOpt, nSym,   1,      iDisk)
      Call s_iDaFile_rasscf(Lu,iOpt, lSym,   1,      iDisk)
      Call iDaFile(Lu,iOpt, nFro,   MxSym,  iDisk)
      Call iDaFile(Lu,iOpt, nISh,   MxSym,  iDisk)
      Call iDaFile(Lu,iOpt, nASh,   MxSym,  iDisk)
      Call iDaFile(Lu,iOpt, nDel,   MxSym,  iDisk)
      Call iDaFile(Lu,iOpt, nBas,   MxSym,  iDisk)
      Call cDaFile(Lu,iOpt, Name,   nName,  iDisk)
      Call s_iDaFile_rasscf(Lu,iOpt, nConf,  1,      iDisk)
      Call cDaFile(Lu,iOpt, Header, nHeader,iDisk)
      Call cDaFile(Lu,iOpt, Title,  nTitle, iDisk)
      Call s_dDaFile_rasscf(Lu,iOpt, PotNuc, 1,      iDisk)
      Call s_iDaFile_rasscf(Lu,iOpt, lRoots, 1,      iDisk)
      Call s_iDaFile_rasscf(Lu,iOpt, nRoots, 1,      iDisk)
      Call iDaFile(Lu,iOpt, iRoot,  MxRoot, iDisk)
      Call iDaFile(Lu,iOpt, nRS1,   MxSym,  iDisk)
      Call iDaFile(Lu,iOpt, nRS2,   MxSym,  iDisk)
      Call iDaFile(Lu,iOpt, nRS3,   MxSym,  iDisk)
      Call s_iDaFile_rasscf(Lu,iOpt, nHole1, 1,      iDisk)
      Call s_iDaFile_rasscf(Lu,iOpt, nElec3, 1,      iDisk)
      Call s_iDaFile_rasscf(Lu,iOpt, iPT2,   1,      iDisk)
      Call dDaFile(Lu,iOpt, Weight, MxRoot, iDisk)
*
      Return
*
*     This is to allow type punning without an explicit interface
      Contains
      Subroutine s_iDaFile_rasscf(Lu,iOpt,Buf,lBuf_,iDisk_)
      Use Iso_C_Binding
      Integer Lu, iOpt, lBuf_, iDisk_
      Integer, Target :: Buf
      Integer, Pointer :: pBuf(:)
      Call C_F_Pointer(C_Loc(Buf),pBuf,[1])
      Call iDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
      Nullify(pBuf)
      End Subroutine s_iDaFile_rasscf
      Subroutine s_dDaFile_rasscf(Lu,iOpt,Buf,lBuf_,iDisk_)
      Use Iso_C_Binding
      Integer Lu, iOpt, lBuf_, iDisk_
      Real*8, Target :: Buf
      Real*8, Pointer :: pBuf(:)
      Call C_F_Pointer(C_Loc(Buf),pBuf,[1])
      Call dDaFile(Lu,iOpt,pBuf,lBuf_,iDisk_)
      Nullify(pBuf)
      End Subroutine s_dDaFile_rasscf
*
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      INTEGER FUNCTION IBION_LUCIA(M,N)
C PAM05:
C The following code does not always work.
C Replaced by call to my 'NOVERM' routine, renamed IBINOM.
C
C BIONOMIAL COEFFICIENT (M / N ) = IFAC(M)/(IFAC(M-N)*IFAC(N))
C
*      IB = 1
*      IF(M-N.GE.N) THEN
*         DO 100 K = (M-N+1), M
*           IB = IB * K
*  100    CONTINUE
*         IB = IB/IFAC(N)
*      ELSE
*         DO 200 K = N+1,M
*           IB = IB * K
*  200    CONTINUE
*         IB = IB/IFAC(M-N)
*      END IF
**
*      IBION_LUCIA = IB
*C
      IBION_LUCIA=IBINOM(M,N)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Sync_TH(TwoHam,nDens)
      Implicit Real*8 (a-h,o-z)
      Real*8 TwoHam(nDens)
*
#include "para_info.fh"
*
#ifdef _MOLCAS_MPP_
      If (.Not. Is_Real_Par()) Return
      If (nProcs.eq.1) Return
      Call BCTwoHam(TwoHam,nDens,TCPU,TWall)
      Call SavTim(10,TCPU,TWall)
#else
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(TwoHam)
#endif
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ExpT2(T2p,T2u,dima,dimab,no)
! this routine does:
! Make T2u(a',b',i,j) from T2p(a'b',i,j)
!
! N.B. Kvajt odflaknute, vypocet ab sa da dat zefektivnit

use Index_Functions, only: nTri_Elem
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: dima, dimab, no
real(kind=wp), intent(in) :: T2p(dimab,no,no)
real(kind=wp), intent(out) :: T2u(dima,dima,no,no)
integer(kind=iwp) :: a, ab, b, ba0, i, j

do j=1,no
  do i=1,no
    do b=1,dima
      ba0 = nTri_Elem(b-1)
      T2u(1:b,b,i,j) = T2p(ba0+1:ba0+b,j,i)
      do a=1+b,dima
        ab = nTri_Elem(a-1)+b
        T2u(a,b,i,j) = T2p(ab,i,j)
      end do
    end do
  end do
end do

return

end subroutine ExpT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1994, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1994  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE MLTMV (IMLTOP,LST1,X,F,Y)
#ifdef _MOLCAS_MPP_
      USE Para_Info, ONLY: MyRank, nProcs, Is_Real_Par
#endif
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(*),F(*),Y(*)
      DIMENSION LST1(4,NLST1)
#include "sigma.fh"

C Given a lists with entries LST1(4,ITEM), ITEM=1,NLST1, the
C four entries called L1,L2,L3,L4 for short, for a given
C item, and with V=VAL1(L4),
C compute, for IMLTOP=0 or 1, respectively.
C    X(L1,i) := Add V*F(L2,a)*Y(L3,i,a), i=1..LEN1, a=1..LEN2
C or Y(L3,i,a):= Add V*F(L2,a)*X(L1,i), i=1..LEN1, a=1..LEN2
C or for IMLTOP=2, compute
C     F(L2,a) := Add V*X(L1,i)*Y(L3,i,a)
C However, strides etc can vary from case to case: The indices
C may appear in 1st, 2nd or 3rd position, Fortran-address-wise,
C thus an independent stride is to be given for each of the
C indices in the above 'formal' index ordering, as follows:
C The formal X(p,q,r) is accessed as
C X(1+INCX1*(p-1)+INCX2*(q-1)+INCX3*(r-1)), etc.

CSVC: determine outer loop properties
#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        ILST1_IOFF=MYRANK+1
        ILST1_SKIP=NPROCS
      ELSE
        ILST1_IOFF=1
        ILST1_SKIP=1
      ENDIF
#else
      ILST1_IOFF=1
      ILST1_SKIP=1
#endif

      IF(IMLTOP.EQ.0) THEN
        DO ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
          L1=LST1(1,ILST1)
          L2=LST1(2,ILST1)
          L3=LST1(3,ILST1)
          L4=LST1(4,ILST1)
          V=VAL1(L4)
          IX=INCX1*(L1-1)+1
          IF=INCF1*(L2-1)+1
          IY=INCY1*(L3-1)+1
C    X(L1,i) := Add V*F(L2,a)*Y(L3,i,a), i=1..LEN1, a=1..LEN2
          DO I=1,LEN1
            X(IX)=X(IX)+V*DDOT_(LEN2,F(IF),INCF2,Y(IY),INCY3)
            IX=IX+INCX2
            IY=IY+INCY2
          END DO
        END DO
      ELSE IF(IMLTOP.EQ.1) THEN
        DO ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
          L1=LST1(1,ILST1)
          L2=LST1(2,ILST1)
          L3=LST1(3,ILST1)
          L4=LST1(4,ILST1)
          V=VAL1(L4)
          IX=INCX1*(L1-1)+1
          IF=INCF1*(L2-1)+1
          IY=INCY1*(L3-1)+1
C or Y(L3,i,a):= Add V*F(L2,a)*X(L1,i), i=1..LEN1, a=1..LEN2
          DO I=1,LEN2
            A=V*F(IF)
            CALL DAXPY_(LEN1,A,X(IX),INCX2,Y(IY),INCY2)
            IY=IY+INCY3
            IF=IF+INCF2
          END DO
        END DO
      ELSE
        DO ILST1=ILST1_IOFF,NLST1,ILST1_SKIP
          L1=LST1(1,ILST1)
          L2=LST1(2,ILST1)
          L3=LST1(3,ILST1)
          L4=LST1(4,ILST1)
          V=VAL1(L4)
          IX=INCX1*(L1-1)+1
          IF=INCF1*(L2-1)+1
          IY=INCY1*(L3-1)+1
C     F(L2,a) := Add V*X(L1,i)*Y(L3,i,a)
          DO I=1,LEN1
            A=V*X(IX)
            CALL DAXPY_(LEN2,A,Y(IY),INCY3,F(IF),INCF2)
            IX=IX+INCX2
            IY=IY+INCY2
          END DO
        END DO
      END IF

      NFMV =NFMV +2*NLST1*LEN1*LEN2

      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Markus P. Fuelscher                              *
!               1993, Per-Olof Widmark                                 *
!***********************************************************************

subroutine GetOrd(rc,Square,nSym,nBas,nSkip)
!***********************************************************************
!                                                                      *
!    Purpose: Read the table of content from the OrdInt file           *
!                                                                      *
!    Calling parameters:                                               *
!    nSym   : contains on return the number of irred. rep.             *
!    nBas   : contains on return the number of basis functions per     *
!             irred. rep.                                              *
!    nSkip  : contains on return the skipping flag per irred. rep.     *
!    rc     : return code                                              *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     M. P. Fuelscher and P.O. Widmark                                 *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use TwoDat, only: AuxTwo, isBas, isDAdr, isMxDa, isOrd, isPkPa, isPkTh, isSkip, isSym, nBatch, rcTwo, TocTwo
use Pack_mod, only: isPack, PkThrs
use Molcas, only: MxBas, MxOrb
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: rc, nSym, nBas(0:7), nSkip(0:7)
logical(kind=iwp), intent(out) :: Square
integer(kind=iwp) :: iBatch, ijPair, iPack, iSyBlk, iSym, iTab, jSym, klPair, kSym, lSym, mxDAdr, nPairs, ntBas
logical(kind=iwp) :: DoCholesky
character(len=*), parameter :: TheName = 'GetOrd'

!----------------------------------------------------------------------*
! Start the procedure                                                  *
!----------------------------------------------------------------------*
rc = rcTwo%good

!----------------------------------------------------------------------*
! Cholesky cheating: set output variables regardless of OrdInt file    *
! Note that all elements of nSkip are zero (no skipping)               *
! Square is set false (arbitrarily)                                    *
! Skip data relating to this file (Toc etc.) entirely....              *
!----------------------------------------------------------------------*
call decideoncholesky(DoCholesky)
if (DoCholesky) then
  call Get_iScalar('nSym',nSym)
  call Get_iArray('nBas',nBas,nSym)
  nSkip(:) = 0
  Square = .false.
  return
end if
!----------------------------------------------------------------------*
! Check the file status                                                *
!----------------------------------------------------------------------*
if (.not. AuxTwo%Opn) then
  rc = rcTwo%TC01
  call SysAbendMsg(TheName,'The ORDINT file has not been opened',' ')
end if
!----------------------------------------------------------------------*
! Check the ordering parameter                                         *
!----------------------------------------------------------------------*
if ((TocTwo(isOrd) < 0) .or. (TocTwo(isOrd) > 1)) then
  rc = rcTwo%TC02
  call SysWarnMsg(TheName,'The file carries an invalid ordering parameter',' ')
  call SysValueMsg('TocTwo(isOrd)',TocTwo(isOrd))
end if
Square = TocTwo(isOrd) == 1
!----------------------------------------------------------------------*
! Check the number of symmetry operations                              *
!----------------------------------------------------------------------*
nSym = TocTwo(isSym)
if ((nSym /= 1) .and. (nSym /= 2) .and. (nSym /= 4) .and. (nSym /= 8)) then
  rc = rcTwo%TC03
  call SysWarnMsg(TheName,'The file carries an invalid number of irreducible representations',' ')
  call SysValueMsg('nSym',nSym)
end if
nPairs = nTri_Elem(nSym)
iBatch = 0
do iSym=1,nSym
  do jSym=1,iSym
    do kSym=1,nSym
      do lSym=1,kSym
        if (Mul(iSym,jSym) == Mul(kSym,lSym)) then
          ijPair = jSym+nTri_Elem(iSym-1)
          klPair = lSym+nTri_Elem(kSym-1)
          iSyBlk = (ijPair-1)*nPairs+klPair
          iBatch = iBatch+1
          nBatch(iSyBlk) = iBatch
        end if
      end do
    end do
  end do
end do
!----------------------------------------------------------------------*
! Check number of basis function                                       *
!----------------------------------------------------------------------*
ntBas = 0
do iSym=0,(nSym-1)
  nBas(iSym) = TocTwo(isBas+iSym)
  ntBas = ntBas+nBas(iSym)
  if (nBas(iSym) < 0) then
    call SysWarnMsg(TheName,'Invalid number of basis functions',' ')
    call SysValueWarnMsg('iSym',iSym)
    call SysCondMsg('nBas(iSym) < 0',nBas(iSym),'<',0)
  end if

  if (nBas(iSym) > mxBas) then
    call SysWarnMsg(TheName,'Invalid number of basis functions',' ')
    call SysValueWarnMsg('iSym',iSym)
    call SysCondMsg('nBas(iSym) > mxBas',nBas(iSym),'>',mxBas)
  end if
end do
if (ntBas <= 0) then
  call SysWarnMsg(TheName,'Invalid number of basis functions',' ')
  call SysCondMsg('ntBas <= 0',ntBas,'<=',0)
end if
if (ntBas > mxOrb) then
  call SysWarnMsg(TheName,'Invalid number of basis functions',' ')
  call SysCondMsg('ntBas > mxOrb',ntBas,'>',mxOrb)
end if
!----------------------------------------------------------------------*
! Check the skip parameters                                            *
!----------------------------------------------------------------------*
do iSym=0,(nSym-1)
  nSkip(iSym) = TocTwo(isSkip+iSym)
  if (nSkip(iSym) < 0) call SysAbendMsg(TheName,'The table of skiping parameters is spoiled',' ')
end do
!----------------------------------------------------------------------*
! Check table of disk addresses                                         *
!----------------------------------------------------------------------*
mxDAdr = TocTwo(isMxDa)
if (mxDAdr < 0) then
  call SysWarnMsg(TheName,'The file carries an invalid disk address',' ')
  call SysCondMsg('mxDAdr < 0',mxDAdr,'<',0)
end if
do iTab=0,175
  if ((TocTwo(isDAdr+iTab) < 0) .or. (TocTwo(isDAdr+iTab) > mxDAdr)) then
    call SysWarnMsg(TheName,'The table of disk addresses is spoiled',' ')
    call SysValueWarnMsg('iTab',iTab)
    call SysCondMsg('TocTwo(isDAdr+iTab) > mxDAdr',TocTwo(isDAdr+iTab),'>',mxDAdr)
  end if
end do
!----------------------------------------------------------------------*
! Generate and check packing table                                     *
!----------------------------------------------------------------------*
call Int2Real(TocTwo(isPkTh),PkThrs)
if (PkThrs < 0) call SysAbendMsg(TheName,'The accuracy threshold for unpacking is spoiled',' ')
iPack = TocTwo(isPkPa)
if ((iPack < 0) .or. (iPack > 1)) then
  call SysWarnMsg(TheName,'The packing flag is spoiled',' ')
  call SysValueMsg('iPack',iPack)
end if
isPack = TocTwo(isPkPa) == 0

!----------------------------------------------------------------------*
! exit                                                                 *
!----------------------------------------------------------------------*
return

end subroutine GetOrd

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Angular_Prune(Radius,nR,iAngular_Grid,Crowding,Fade,R_BS,L_Quad,R_Min,lAng,nAngularGrids)

use nq_Structure, only: Info_Ang
use Constants, only: Half
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nR, L_Quad, lAng, nAngularGrids
real(kind=wp), intent(in) :: Radius(2,nR), Crowding, Fade, R_BS, R_Min(0:lAng)
integer(kind=iwp), intent(out) :: iAngular_Grid(nR)
integer(kind=iwp) :: iAng, iR, jAng, jSet, kSet
real(kind=wp) :: R_Test, R_Test2, R_Value

!                                                                      *
!***********************************************************************
!                                                                      *
!define _DEBUGPRINT_
!                                                                      *
!***********************************************************************
!                                                                      *
R_Test = R_BS/Crowding
#ifdef _DEBUGPRINT_
write(u6,*) 'lAng=',lAng
write(u6,*) 'Crowding=',Crowding
write(u6,*) 'R_BS=',R_BS
write(u6,*) 'L_Quad=',L_Quad
write(u6,*) 'LMax_NQ=',size(Info_Ang)
write(u6,*) 'nAngularGrids=',nAngularGrids
write(u6,*) 'R_Test=',R_Test
write(u6,'(A,10G10.3)') 'R_Min=',R_Min
write(u6,*) 'Info_Ang(*)%L_Eff=',(Info_Ang(i)%L_Eff,i=1,nAngularGrids)
#endif
do iR=1,nR

  R_Value = Radius(1,iR)
# ifdef _DEBUGPRINT_
  write(u6,'(A,G10.3)') 'R_Value=',R_Value
# endif

  ! Establish L_Eff according to the crowding factor.

  ! Avoid overflow by converting to Int at the end
  iAng = int(Half*min(L_Quad*R_Value/R_Test,real(L_Quad,kind=wp)))
# ifdef _DEBUGPRINT_
  write(u6,*) 'iAng=',iAng
# endif

  ! Close to the nuclei we can use the alternative formula
  ! given by the LMG radial grid.

  iAng = max(iAng,lAng)
  do jAng=lAng,1,-1
    if (R_Value < R_Min(jAng)) iAng = min(iAng,jAng-1)
  end do
# ifdef _DEBUGPRINT_
  write(u6,*) 'iAng=',iAng
# endif

  ! Fade the outer part

  R_Test2 = Fade*R_BS
  ! Avoid overflow by converting to Int at the end
  if (R_Value > R_Test2) iAng = int(Half*min(L_Quad*R_Test2/R_Value,real(L_Quad,kind=wp)))

  ! Since the Lebedev grid is not defined for any L_Eff
  ! value we have to find the closest one, i.e. of the same
  ! order or higher. Start loop from low order!

  kSet = 0
  do jSet=1,nAngularGrids
    if ((Info_Ang(jSet)%L_Eff >= 2*iAng+1) .and. (kSet == 0)) then
      kSet = jSet
      iAng = Info_Ang(kSet)%L_Eff/2
    end if
  end do
  if (kSet == 0) then
    kSet = nAngularGrids
    iAng = Info_Ang(kSet)%L_Eff/2
  end if

  iAngular_Grid(iR) = kSet

end do
#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) 'iAngular_Grid:'
write(u6,*) 'R_Min     R_Max    kSet  nR   nPoints'
RStart = Radius(1,1)
kSet = iAngular_Grid(1)
nTot = Info_Ang(1)%nPoints
mR = 1
do iR=2,nR
  nTot = nTot+Info_Ang(iAngular_Grid(iR))%nPoints
  if ((iAngular_Grid(iR) /= kSet) .or. (iR == nR)) then
    jR = iR-1
    if (iR == nR) then
      jR = nR
      mR = mR+1
    end if
    write(u6,'(2G10.3,I3,2I5)') RStart,Radius(1,jR),kSet,mR,Info_Ang(kSet)%nPoints
    RStart = Radius(1,iR)
    kSet = iAngular_Grid(iR)
    mR = 0
  end if
  mR = mR+1
end do
write(u6,*) 'Total grid size:',nTot
write(u6,*)
#endif

return

end subroutine Angular_Prune

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DrvXV(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq,
     &                 lRF,KSDFT,ExFac,iCharge,iSpin,
     &                 D1I,D1A,nD1,DFTFOCK,Do_DFT)
#ifdef _EFP_
      use EFP_Module
#endif
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "nq_info.fh"
#include "debug.fh"
      Real*8 h1(nh1), TwoHam(nh1), D(nh1,2)
      Real*8 D1I(nD1),D1A(nD1)
      Logical First, Dff, lRF, NonEq, Do_Grad, Do_DFT
      Dimension Grad(1),RN(1)
*
      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
      Character*16  OFE_KSDFT
      COMMON  / OFembed_C / OFE_KSDFT
*
      Logical Do_ESPF
#ifdef _EFP_
      Logical EFP_On
#endif
      Character*(*) KSDFT
      Character*4 DFTFOCK
      Character*8 Label
*
      Debug=.False.
*                                                                      *
************************************************************************
*                                                                      *
*---- If first iterations save original h1 and RepNuc, the reaction
*     field and/or the dft section might later modify these. Any static
*     contributions to these are updated internally in the subroutine
*     rctfld.
*
*     We also save one set which are not to be modified at all.
*
      If (First) Then
         Label='PotNuc00'
         Call Put_Temp(Label,[RepNuc],1)
         Label='h1_raw  '
         Call Put_Temp(Label,h1,nh1)
*
         Label='PotNucXX'
         Call Put_Temp(Label,[RepNuc],1)
         Label='h1    XX'
         Call Put_Temp(Label,h1,nh1)
      End If

*
*---- Start always with the original h1 and RepNuc! Observe that they
*     now might contain static updates from the RF or the Langevin
*     codes through the action of the subroutine rctfld.
*
      Label='PotNuc00'
      Call Get_Temp(Label,RN,1)
      RepNuc=RN(1)
      Label='h1_raw  '
      Call Get_Temp(Label,h1,nh1)
cnf
*                                                                      *
************************************************************************
*                                                                      *
*                        ESPF section                                  *
*                                                                      *
************************************************************************
*                                                                      *
      Call DecideOnESPF(Do_ESPF)
      If (Do_ESPF) Call h1_espf(h1,RepNuc,nh1,First,Do_DFT)
cnf
*                                                                      *
************************************************************************
*                                                                      *
*              Reaction Field section                                  *
*                                                                      *
************************************************************************
*                                                                      *
      If (lRF) Call DrvRF(h1,TwoHam,D,RepNuc,nh1,First,Dff,NonEq,
     &                    iCharge)
*
************************************************************************
*                                                                      *
*                         DFT section                                  *
*                                                                      *
************************************************************************
*                                                                      *
      Do_Grad=.False.
      Grad=Zero
      nGrad=1
      If (KSDFT.ne.'SCF'.and.Do_DFT)
     &   Call DrvDFT(h1,TwoHam,D,RepNuc,nh1,First,Dff,lRF,KSDFT,ExFac,
     &               Do_Grad,Grad,nGrad,iSpin,D1I,D1A,nD1,DFTFOCK)
*
************************************************************************
*                                                                      *
*                         Orbital-Free Embedding section               *
*                                                                      *
************************************************************************
*                                                                      *
      If (Do_OFemb)
     &   Call DrvEMB(h1,D,RepNuc,nh1,OFE_KSDFT,ExFac,
     &               Do_Grad,Grad,nGrad,D1I,D1A,nD1,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _EFP_
      If (EFP_On())
     &   Call DrvEFP(First)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine GSBBD2A_MCLR(RHO2,NACOB,ISCSM,ISCTP,ICCSM,ICCTP,IGRP,NROW,NGAS,ISEL,ICEL,SB,CB,MXPNGAS,NOBPTS,IOBPTS,MAXI,MAXK,SSCR, &
                        CSCR,I1,XI1S,X,NSM)
! Contributions to two-electron density matrix from column excitations
!
! GAS version, '96, Jeppe Olsen
!
! =====
! Input
! =====
! RHO2        : two body density matrix to be updated
! NACOB       : Number of active orbitals
! ISCSM,ISCTP : Symmetry and type of sigma columns
! ICCSM,ICCTP : Symmetry and type of C     columns
! IGRP        : String group of columns
! NROW        : Number of rows in S and C block
! NGAS        : Number of active spaces
! ISEL        : Number of electrons per AS for S block
! ICEL        : Number of electrons per AS for C block
! CB          : Input C block
! MXPNGAS     : Max number of AS spaces (program parameter)
! NOBPTS      : Number of orbitals per type and symmetry
! IOBPTS      : base for orbitals of given type and symmetry
! IBORB       : Orbitals of given type and symmetry
! NSM         : Number of symmetries of orbitals
! MAXI        : Largest Number of "spectator strings" treated simultaneously
! MAXK        : Largest number of inner resolution strings treated at simult.
!
! ======
! Output
! ======
! RHO2 : Updated density block
!
! =======
! Scratch
! =======
! SSCR, CSCR : at least MAXIJ*MAXI*MAXK, where MAXIJ is the largest
!              number of orbital pairs of given symmetries and types.
! I1, XI1S   : For holding creations/annihilations type and symmetry
!
! Jeppe Olsen, Fall of 96

use Index_Functions, only: nTri_Elem
use Symmetry_Info, only: Mul
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
real(kind=wp), intent(inout) :: RHO2(*)
integer(kind=iwp), intent(in) :: NACOB, ISCSM, ISCTP, ICCSM, ICCTP, IGRP, NROW, NGAS, ISEL(NGAS), ICEL(NGAS), MXPNGAS, &
                                 NOBPTS(MXPNGAS,*), IOBPTS(MXPNGAS,*), MAXI, MAXK, NSM
real(kind=wp), intent(in) :: SB(*), CB(*)
real(kind=wp), intent(_OUT_) :: SSCR(*), CSCR(*), XI1S(MAXK,*), X(*)
integer(kind=iwp), intent(_OUT_) :: I1(MAXK,*)
integer(kind=iwp) :: I, IBOT, IDXSM, IDXTP, IFIRST, IIK, IIKE, IJL, IJLE, IKBOFF, IKOBSM, IKOFF, IKSM, IOFF, IPART, ISM, ITOP, &
                     ITP(3*3), ITYP, J, JLBOFF, JLOBSM, JLOFF, JLSM, JOFF, JSM, JTP(3*3), JTYP, K, KBOT, KEND, KOFF, KSM, KTOP, &
                     KTP(3*3), KTYP, L, LDUMMY, LOFF, LSM, LTP(3*3), LTYP, NDXTP, NI, NIBTC, NIK, NJ, NJL, NK, NKBTC, nkStref, NL, &
                     NONEW, NPART
real(kind=wp) :: FACTOR

! Type of single excitations that connects the two column strings
call DXTYP_GAS(NDXTP,ITP,JTP,KTP,LTP,3,ISEL,ICEL)
! Symmetry of Double excitation that connects IBSM and JBSM
IDXSM = Mul(ISCSM,ICCSM)
if (IDXSM == 0) return
do IDXTP=1,NDXTP
  ITYP = ITP(IDXTP)
  JTYP = JTP(IDXTP)
  KTYP = KTP(IDXTP)
  LTYP = LTP(IDXTP)
  do IKOBSM=1,NSM
    JLOBSM = Mul(IKOBSM,IDXSM)
    if (JLOBSM == 0) cycle
    ! types + symmetries defined => K strings are defined
    !        KFRST = 1
    ! Loop over of symmetry of i orbitals
    do ISM=1,NSM
      KSM = Mul(ISM,IKOBSM)
      NI = NOBPTS(ITYP,ISM)
      NK = NOBPTS(KTYP,KSM)
      IOFF = IOBPTS(ITYP,ISM)
      KOFF = IOBPTS(KTYP,KSM)
      if ((NI == 0) .or. (NK == 0)) cycle
      ! Loop over batches of j orbitals
      outer: do JSM=1,NSM
        IFIRST = 1
        LSM = Mul(JSM,JLOBSM)
        NJ = NOBPTS(JTYP,JSM)
        NL = NOBPTS(LTYP,LSM)
        JOFF = IOBPTS(JTYP,JSM)
        LOFF = IOBPTS(LTYP,LSM)
        if (IOFF < KOFF) cycle
        if (JOFF < LOFF) cycle
        if ((NJ == 0) .or. (NL == 0)) cycle outer

        ! ==============================================================
        !         Use N-2 projection method
        ! ==============================================================

        ! Loop over batches of I strings
        NPART = NROW/MAXI
        if (NPART*MAXI /= NROW) NPART = NPART+1
#       ifdef _DEBUGPRINT_
        write(u6,*) ' NROW, MAXI NPART ',NROW,MAXI,NPART
#       endif
        do IPART=1,NPART
          IBOT = 1+(IPART-1)*MAXI
          ITOP = min(IBOT+MAXI-1,NROW)
          NIBTC = ITOP-IBOT+1
          ! Loop over batches of intermediate strings
          KBOT = 1-MAXK
          KTOP = 0
          do
            KBOT = KBOT+MAXK
            KTOP = KTOP+MAXK

            ! =======================================================
            !
            ! obtain cb(KB,IA,jl) = sum(JB)<KB!a lb a jb !IB>C(IA,JB)
            !
            ! =======================================================

            nkStref = maxk  ! ????????
            JLBOFF = 1
            if ((JSM == LSM) .and. (JTYP == LTYP)) then
              NJL = nTri_Elem(NJ)
              JLSM = 1
            else
              NJL = NJ*NL
              JLSM = 0
            end if
            ! Obtain all double excitations from this group of K strings
            lOFF = IOBPTS(lTYP,lSM)
            jOFF = IOBPTS(jTYP,jSM)
            call ADADST(JTYP,JSM,JOFF,NJ,LTYP,LSM,LOFF,NL,jlsm,ICCTP,ICCSM,IGRP,KBOT,KTOP,I1,XI1S,NKBTC,nkstref,KEND)

            if (NKBTC == 0) cycle outer
            ! Loop over jl in TS classes
            J = 0
            L = 1

            do IJL=1,NJL
              call NXTIJ(J,L,NJ,NL,JLSM,NONEW)
              !I1JL = (J-1)*NJ+L
              ! CB(IA,KB,jl) = +/-C(IA,a+la+jIA)
              ! JAN28
              if (JLSM /= 0) then
                IJLE = nTri_Elem(J-1)+L
              else
                IJLE = IJL
              end if

              JLOFF = (JLBOFF-1+IJLE-1)*NKBTC*NIBTC+1
              if ((JLSM == 1) .and. (J == L)) then
                ! a+j a+j gives trivially zero
                CSCR(JLOFF:JLOFF+NKBTC*NIBTC-1) = Zero
              else
                !EAW BEGIN 970407
                !call MATCG(CB,CSCR(JLOFF),NROW,NIBTC,IBOT,NKBTC,I1(1,I1JL),XI1S(1,I1JL))
                call MATCG(CB,CSCR(JLOFF),NROW,NIBTC,IBOT,NKBTC,I1(:,IJL),XI1S(:,IJL))
                !EAW END
              end if
            end do

            ! =======================================================
            !
            ! obtain sb(KB,IA,ik) = sum(IB)<KB!a kb a ib !IB>S(IA,IB)
            !
            ! =======================================================

            IKBOFF = 1
            if ((ISM == KSM) .and. (ITYP == KTYP)) then
              NIK = nTri_Elem(NI)
              IKSM = 1
            else
              NIK = NI*NK
              IKSM = 0
            end if
            ! Obtain all double excitations from this group of K strings
            KOFF = IOBPTS(KTYP,KSM)
            iOFF = IOBPTS(iTYP,iSM)
            !if (IFRST == 1) KFRST = 1
            call ADADST(ITYP,ISM,IOFF,NI,KTYP,KSM,KOFF,NK,IKSM,ISCTP,ISCSM,IGRP,KBOT,KTOP,I1,XI1S,NKBTC,NKSTREF,KEND)

            if (NKBTC == 0) cycle outer
            ! Loop over jl in TS classes
            I = 0
            K = 1

            do IIK=1,NIK
              call NXTIJ(I,K,NI,NK,IKSM,NONEW)
              !I1IK = (K-1)*NI+I
              ! JAN28
              if (IKSM /= 0) then
                IIKE = nTri_Elem(I-1)+K
              else
                IIKE = IIK
              end if
              ! JAN28
              ! SB(IA,KB,ik) = +/-S(IA,a+ka+iIA)
              IKOFF = (IKBOFF-1+IIKE-1)*NKBTC*NIBTC+1
              if ((IKSM == 1) .and. (I == K)) then
                ! a+j a+j gives trivially zero
                SSCR(IKOFF:IKOFF+NKBTC*NIBTC-1) = Zero
              else
                !EAW-BEGIN 970407
                !call MATCG(SB,SSCR(IKOFF),NROW,NIBTC,IBOT,NKBTC,I1(1,I1IK),XI1S(1,I1IK))
                call MATCG(SB,SSCR(IKOFF),NROW,NIBTC,IBOT,NKBTC,I1(:,IIK),XI1S(:,IIK))
                !EAW-END
              end if
            end do

            ! ==================================================================
            !
            ! RHO2C(ik,jl)  = RHO2C(ik,jl) - sum(Ia,Kb)SB(Ia,Kb,ik)*CB(Ia,Kb,jl)
            !
            ! ==================================================================

            ! The minus ??
            !
            ! Well, the density matrices are constructed as
            !
            ! <I!a+i a+k aj al!> = -sum(K) <I!a+ia+k!K><J!aj al!K>, and
            ! the latter matrices are the ones we are constructing

            LDUMMY = NKBTC*NIBTC

            if (IFIRST == 1) then
              FACTOR = Zero
            else
              FACTOR = One
            end if
            LDUMMY = NKBTC*NIBTC
            call DGEMM_('T','N',NIK,NJL,LDUMMY,-One,SSCR,max(1,LDUMMY),CSCR,max(1,LDUMMY),FACTOR,X,max(1,NIK))
            IFIRST = 0

            if (KEND /= 0) exit
          end do
          ! End of loop over partitionings of resolution strings
        end do
        ! Rho2(ik,jl) has been constructed for ik,jl belonging to
        ! Scatter out to density matrix
        IOFF = IOBPTS(ITYP,ISM)
        JOFF = IOBPTS(JTYP,JSM)
        KOFF = IOBPTS(KTYP,KSM)
        LOFF = IOBPTS(LTYP,LSM)
        call ADTOR2_MCLR(RHO2,X,1,NI,IOFF,NJ,JOFF,NK,KOFF,NL,LOFF,NACOB)
      end do outer
    end do
  end do
end do

end subroutine GSBBD2A_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine DrvN1_mck(Grad,nGrad)
************************************************************************
*                                                                      *
* Object: to compute the molecular gradient contribution due to the    *
*         nuclear repulsion energy.                                    *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October 1991                                             *
************************************************************************
      use Basis_Info
      use Center_Info
      use Symmetry_Info, only: nIrrep, iChBas
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "print.fh"
#include "real.fh"
#include "disp.fh"
#include "disp2.fh"
      Real*8 A(3), B(3), RB(3), Grad(nGrad)
      Integer iDCRR(0:7)
      Logical EQ, TstFnc
*
      iRout = 33
      iPrint = nPrint(iRout)
*
      iIrrep = 0
      mdc = 0
*-----Loop over centers with the same change
      Do 100 iCnttp = 1, nCnttp
         ZA = dbsc(iCnttp)%Charge
         If (ZA.eq.Zero) Go To 101
*--------Loop over all unique centers of this group
         Do 110 iCnt = 1, dbsc(iCnttp)%nCntr
            A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
*
            ndc = 0
            Do 200 jCnttp = 1, iCnttp
               ZAZB = ZA * dbsc(jCnttp)%Charge
               If (ZAZB.eq.Zero) Go To 201
               jCntMx = dbsc(jCnttp)%nCntr
               If (iCnttp.eq.jCnttp) jCntMx = iCnt
               Do 210 jCnt = 1, jCntMx
                  B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
                  Fact = One
*                 Factor due to resticted summation
                  If (EQ(A,B)) Fact = Half
*
*                 Find the DCR for the two centers
*
                  Call DCR(LmbdR,dc(mdc+iCnt)%iStab,dc(mdc+iCnt)%nStab,
     &                           dc(ndc+jCnt)%iStab,dc(ndc+jCnt)%nStab,
     &                           iDCRR,nDCRR)
*
                  PreFct = Fact*ZAZB*DBLE(nIrrep)/DBLE(LmbdR)
                  Do 300 iR = 0, nDCRR-1
                     Call OA(iDCRR(iR),B,RB)
                     nOp = NrOpr(iDCRR(iR))
                     If (EQ(A,RB)) Go To 300
                     r12 = Sqrt((A(1)-RB(1))**2 +
     &                          (A(2)-RB(2))**2 +
     &                          (A(3)-RB(3))**2 )
*
*                    The factor u/g will ensure that the value of the
*                    gradient in symmetry adapted and no symmetry basis
*                    will have the same value.
*
                     nDisp = IndDsp(mdc+iCnt,iIrrep)
                     igu=nIrrep/dc(mdc+iCnt)%nStab
                     Do 400 iCar = 0, 2
                        iComp = 2**iCar
                        If ( TstFnc(dc(mdc+iCnt)%iCoSet,
     &                            iIrrep,iComp,dc(mdc+iCnt)%nStab)
     &                     ) Then
                           nDisp = nDisp + 1
                           If (.true.) Grad(nDisp) =
     &                        Grad(nDisp) - One/DBLE(igu) *
     &                        PreFct*(A(iCar+1)-RB(iCar+1))/(r12**3)
                        End If
 400                 Continue
*
                     nDisp = IndDsp(ndc+jCnt,iIrrep)
                     igv=nIrrep/dc(ndc+jCnt)%nStab
                     Do 450 iCar = 0, 2
                        iComp = 2**iCar
                        If ( TstFnc(dc(ndc+jCnt)%iCoSet,
     &                            iIrrep,iComp,dc(ndc+jCnt)%nStab)
     &                     ) Then
                           nDisp = nDisp + 1
                           If (.true.) Then
                              ps = DBLE(iPrmt(nOp,iChBas(2+iCar)))
                              Grad(nDisp) = Grad(nDisp) + ps *
     &                           One/DBLE(igv) *
     &                           PreFct*(A(iCar+1)-RB(iCar+1))/(r12**3)
                           End If
                        End If
 450                 Continue
 300              Continue
*
 210           Continue
 201           Continue
               ndc = ndc + dbsc(jCnttp)%nCntr
 200        Continue
 110     Continue
 101     Continue
         mdc = mdc + dbsc(iCnttp)%nCntr
 100  Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! Print the value of (unnormalized) vibrational wave functions.
!PAM97 For MOLCAS-4
subroutine prwf_vibrot(ndim,R)

use Vibrot_globals, only: J1A, J2A, nvib1, Vibwvs, iad12
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: ndim
real(kind=wp), intent(in) :: R(*)
integer(kind=iwp) :: ne1, ndim1, nwork, J1, Jad1, ist, iadr1, i, nv, nvsta, nvend
real(kind=wp), allocatable :: vib(:)

write(u6,*)
call CollapseOutput(1,'PRINTOUT OF VIBRATIONAL WAVE FUNCTIONS')
write(u6,*)

ne1 = nvib1+1
ndim1 = ndim+1
nwork = ne1*ndim1

call mma_allocate(Vib,nwork,label='Vib')

! Loop over rotational quantum numbers
do J1=J1A,J2A
  Jad1 = J1-J1A+1
  write(u6,1001) ' Rotational quantum number J=',J1

  ! Read vibrational functions for this J-value.
  ist = 1
  iadr1 = iad12(Jad1)
  do nv=1,ne1
    call DDafile(Vibwvs,2,vib(ist),ndim1,iadr1)
    ist = ist+ndim1
  end do

  ! Write out the wave functions:
  do nvsta=0,ne1-1,5
    nvend = min(nvsta+4,ne1-1)
    write(u6,*)
    write(u6,1002) 'Radial dist.',(nv,nv=nvsta,nvend)
    do i=1,ndim
      write(u6,1003) r(i),(vib(i+ndim1*nv),nv=nvsta,nvend)
    end do
  end do

! End of loop over J1.
end do

call mma_deallocate(vib)

call CollapseOutput(0,'PRINTOUT OF VIBRATIONAL WAVE FUNCTIONS')
write(u6,*)

return

1001 format(1x,a,i3)
1002 format(5x,a12,8x,'v=',5(i2,13x))
1003 format(1x,f12.6,5x,5f15.8)

end subroutine prwf_vibrot

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Roland Lindh                                     *
!***********************************************************************

function iPD(iSO_,jSO_,iSOSym,nSOs)

use Index_Functions, only: nTri_Elem
use Basis_Info, only: nBas
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: iPD
integer(kind=iwp), intent(in) :: iSO_, jSO_, nSOs, iSOSym(2,nSOs)
integer(kind=iwp) :: ij, iSO, iSOr, iSym, jSO, jSOr, jSym

iPD = -999999

iSO = max(iSO_,jSO_)
jSO = min(iSO_,jSO_)
iSym = iSOSym(1,iSO)
iSOr = iSOSym(2,iSO)
jSym = iSOSym(1,jSO)
jSOr = iSOSym(2,jSO)
if (iSym == jSym) then
  ij = nTri_Elem(iSOr-1)+jSOr
else
  ij = (iSOr-1)*nBas(jSym)+jSOr
end if

iPD = ij

return

end function iPD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Roland Lindh                                     *
!***********************************************************************

subroutine EFMem( &
#                define _CALLING_
#                include "mem_interface.fh"
                )

use Index_Functions, only: nTri3_Elem1, nTri_Elem1
use Definitions, only: iwp

implicit none
#include "mem_interface.fh"
integer(kind=iwp) :: iAngV(4), kab, lab, labcd, labMax, labMin, lc, lcd, lcdMax, lcdMin, ld, Mem1, Mem2, nFlop, nMem

lc = lr
ld = 0
nHer = (la+lb+lc+ld+2)/2
labMin = nTri3_Elem1(max(la,lb)-1)
labMax = nTri3_Elem1(la+lb)-1
lcdMin = nTri3_Elem1(lr-1)
lcdMax = nTri3_Elem1(lr)-1
lab = (labMax-labMin+1)
kab = nTri_Elem1(la)*nTri_Elem1(lb)
lcd = (lcdMax-lcdMin+1)
labcd = lab*lcd

call mHRR(la,lb,nFlop,nMem)
Mem1 = max(lcd*nMem,labcd)

iAngV(1) = la
iAngV(2) = lb
iAngV(3) = lc
iAngV(4) = ld
call MemRys(iAngV,Mem2)
Mem2 = max(Mem2,kab*lcd)

Mem = Mem1+Mem2

return

end subroutine EFMem

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010,2012,2017, Francesco Aquilante                    *
*               2015,2017, Alexander Zech                              *
************************************************************************
      Subroutine DrvEMB(h1,D,RepNuc,nh1,
     &                  KSDFT,ExFac,Do_Grad,Grad,nGrad,
     &                  D1I,D1A,nD1,DFTFOCK)
************************************************************************
************************************************************************
*** Orbital-Free Embedding calculation                               ***
***                                                                  ***
*** Method:                                                          ***
***     T. A. Wesolowski, A. Warshel, J. Phys. Chem. 97 (1993) 8050. ***
***                                                                  ***
*** NDSD potential:                                                  ***
***     J.-M. Garcia Lastra, J. W. Kaminski, T. A. Wesolowski,       ***
***                               J. Chem. Phys.  129 (2008) 074107. ***
***                                                                  ***
*** Embedding multi-determinantal wfs:                               ***
***     T. A. Wesolowski, Phys. Rev.A. 77 (2008) 012504.             ***
***                                                                  ***
***                                                                  ***
*** Embedding Hartree-Fock wf:                                       ***
***     F. Aquilante, T. A. Wesolowski                               ***
***                       J. Chem. Phys. 135 (2011) 084120.          ***
***                                                                  ***
***                                                                  ***
*** Author: F. Aquilante, Geneva July 2010                           ***
***                                                                  ***
***                       (last update: Feb 2012)                    ***
***                                                                  ***
************************************************************************
************************************************************************
      Implicit Real*8 (a-h,o-z)
      External LSDA_emb, Checker
#include "real.fh"
#include "stdalloc.fh"
#include "debug.fh"
      Real*8 h1(nh1), D(nh1,2), Grad(nGrad)
      Real*8 D1I(nD1),D1A(nD1)
      Logical Do_Grad
      Character*(*) KSDFT
      Character*4 DFTFOCK
      Character*16 NamRfil
      Real*8 Vxc_ref(2)
      Logical Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_L / Do_OFemb,KEonly,OFE_first
      COMMON  / OFembed_R / Rep_EN,Func_AB,Func_A,Func_B,Energy_NAD,
     &                      V_Nuc_AB,V_Nuc_BA,V_emb
      COMMON  / OFembed_R1/ Xsigma
      COMMON  / OFembed_R2/ dFMD
      COMMON  / OFembed_I / ipFMaux, ip_NDSD, l_NDSD
*
*     Real*8 Func_A_TF, Func_B_TF, Func_AB_TF, TF_NAD
      Real*8 Func_A_TF, Func_B_TF
      Logical is_rhoA_on_file
      Real*8 Xlambda
      External Xlambda
*
      Real*8, Allocatable:: D_DS(:,:), F_DFT(:,:), Fcorr(:,:), TmpA(:)
*
      Debug=.False.
      is_rhoA_on_file = .False.
*                                                                      *
************************************************************************
*                                                                      *
      Call Setup_iSD()
      If (Do_Grad) Call FZero(Grad,nGrad)
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _NOT_USED_
*     --- Section to calculate Nonelectr. V_emb with current density
*     Temporarily turned off (clean output)
       If (.not.OFE_first) then
          Call mma_allocate(D1ao_y,nh1)
          Call Get_NameRun(NamRfil) ! save the old RUNFILE name
          Call NameRun('AUXRFIL')   ! switch RUNFILE name
          Call GetMem('Vemb_M','Allo','Real', ipVemb, nh1)
          Call Get_dArray('dExcdRa', Work(ipVemb), nh1)
          Call mma_allocate(TmpA,nh1,Label='TmpA')
          Call Get_dArray('Nuc Potential',TmpA,nh1)
*    Substract V_nuc_B
          Call daxpy_(nh1,-One,TmpA,1,Work(ipVemb),1)
*    Calculate nonelectr. V_emb with current Density
          Ynorm=dDot_(nh1,WD1ao_y,1,D1ao_y,1)
          V_emb_x=dDot_(nh1,Work(ipVemb),1,D1ao_y,1)
          Write (6,'(A,F19.10,4X,A,F10.5)')
     &          'Nonelectr. Vemb w. current density: ', V_emb_x,
     &          'Y_Norm = ', Ynorm
          Call mma_deallocate(D1ao_y)
*    Get rho_A_ref
          Call NameRun('PRERFIL')
          Call GetMem('Dens','Allo','Real',ipD1ao_x,nDens)
          Call get_dArray('D1ao',Work(ipD1ao_x),nDens)
          Xnorm=dDot_(nh1,Work(ipD1ao_x),1,Work(ipD1ao_x),1)
          V_emb_x_ref=dDot_(nh1,Work(ipVemb),1,Work(ipD1ao_x),1)
          Write (6,'(A,F19.10,4X,A,F10.5)')
     &          'Nonelectr. Vemb w.    ref. density: ', V_emb_x_ref,
     &          'X_Norm = ', Xnorm
          Call VEMB_Exc_states(Work(ipVemb),nh1,KSDFT,Func_B)
          Call mma_deallocate(TmpA)
          Call GetMem('Dens','Free','Real',ipD1ao_x,nDens)
          Call GetMem('Vemb_M','Free','Real', ipVemb, nh1)
          Call NameRun(NamRfil)     ! switch back to RUNFILE
      End If
*     --- Section End
#endif
      Call f_Inquire('PRERFIL',is_rhoA_on_file) ! rho_A from file
      If (is_rhoA_on_file .and. .not.OFE_first) Return ! Vemb on disk



************************************************************************
*                                                                      *
*     Setup of density matrices for subsys B (environment)             *
*                                                                      *
************************************************************************
      Call Get_NameRun(NamRfil) ! save the old RUNFILE name
      Call NameRun('AUXRFIL')   ! switch RUNFILE name
*                                                                      *
************************************************************************
*                                                                      *
      nD=4
      Call mma_allocate(F_DFT,nh1,nD,Label='F_DFT')
      Call mma_allocate(D_DS,nh1,nD,Label='D_DS')
      Vxc_ref(1)=Zero
      Vxc_ref(2)=Zero
*
*---- Get the density matrix of the environment (rho_B)
*
      Call Get_iScalar('Multiplicity',kSpin)
      Call Get_D1ao(D_DS(:,1),nh1)
*     Call RecPrt('D1ao',' ',D_DS(:,1),nh1,1)
*
*---- Get the spin density matrix of the environment
*
      If (kSpin.ne.1) Then
         Call Get_D1Sao(D_DS(:,2),nh1)
*        Call RecPrt('D1Sao',' ',D_DS(:,2),nh1,1)
      End If
*
*---- Compute alpha and beta density matrices of the environment
*
      nFckDim=2
      If (kSpin.eq.1) Then
         call dscal_(nh1,Half,D_DS(:,1),1)
         call dcopy_(nh1,D_DS(:,1),1,D_DS(:,2),1)
         nFckDim=1
      Else
         Do i = 1, nh1
            DTot=D_DS(i,1)
            DSpn=D_DS(i,2)
            d_Alpha=Half*(DTot+DSpn)
            d_Beta =Half*(DTot-DSpn)
            D_DS(i,1)=d_Alpha
            D_DS(i,2)=d_Beta
         End Do
*      Call RecPrt('Da',' ',D_DS(:,1),nh1,1)
*      Call RecPrt('Db',' ',D_DS(:,2),nh1,1)
      End If
*
*      If (OFE_first) Then
*---AZECH 10/2015
*   kinetic part of E_xct, Subsys B
      Func_B_TF = 0.0d0
      Call wrap_DrvNQ('TF_only',F_DFT(:,1:nFckDim),nFckDim,Func_B_TF,
     &                   D_DS(:,1:nFckDim),nh1,nFckDim,
     &                   Do_Grad,
     &                   Grad,nGrad,DFTFOCK)
*---
      If (OFE_first) Then

         Call wrap_DrvNQ(KSDFT,F_DFT(:,1:nFckDim),nFckDim,Func_B,
     &                   D_DS(:,1:nFckDim),nh1,nFckDim,
     &                   Do_Grad,
     &                   Grad,nGrad,DFTFOCK)

#ifdef _NOT_USED_
         If (KSDFT(1:4).eq.'NDSD') Then
            l_NDSD=nFckDim*nh1
            Call GetMem('NDSD','Allo','Real',ip_NDSD,l_NDSD)
            call dcopy_(l_NDSD,F_DFT(:,1:nFckDim),1,Work(ip_NDSD),1)
            KSDFT(1:4)='LDTF' !set to Thomas-Fermi for subsequent calls
         EndIf
#endif

      EndIf
*                                                                      *
************************************************************************
*                                                                      *
*     Setup of density matrices for subsys A                           *
*                                                                      *
************************************************************************
      Call NameRun(NamRfil)    ! switch back RUNFILE name
*
      If (is_rhoA_on_file) Call NameRun('PRERFIL')
*---- Get the density matrix for rho_A
*
      Call Get_D1ao(D_DS(:,3),nh1)
*     Call RecPrt('D1ao',' ',D_DS(:,3),nh1,1)
*
      Call Get_iScalar('Multiplicity',iSpin)
      If (iSpin.eq.1 .and. kSpin.ne.1 .and. OFE_first) Then
         Call WarningMessage(0,
     &     ' Non-singlet environment perturbation on singlet state!'//
     &     '  Spin-components of the OFE potential will be averaged. ' )
      EndIf
*
*---- Get the spin density matrix of A
*
      If (iSpin.ne.1) Then
         Call Get_D1Sao(D_DS(:,4),nh1)
*        Call RecPrt('D1Sao',' ',D_DS(:,4),nh1,1)
      End If
*
*---- Compute alpha and beta density matrices of subsystem A
*
      nFckDim=2
      If (iSpin.eq.1) Then
         call dscal_(nh1,Half,D_DS(:,3),1)
         call dcopy_(nh1,D_DS(:,3),1,D_DS(:,4),1)
         If (kSpin.eq.1) nFckDim=1
      Else
         Do i = 1, nh1
            DTot=D_DS(i,3)
            DSpn=D_DS(i,4)
            d_Alpha=Half*(DTot+DSpn)
            d_Beta =Half*(DTot-DSpn)
            D_DS(i,3)=d_Alpha
            D_DS(i,4)=d_Beta
         End Do
*      Call RecPrt('Da',' ',D_DS(:,3),nh1,1)
*      Call RecPrt('Db',' ',D_DS(:,4),nh1,1)
      End If
*
*---AZECH 10/2015
*   kinetic part of E_xct, Subsys A
      Call wrap_DrvNQ('TF_only',F_DFT(:,3:nFckDim+2),nFckDim,Func_A_TF,
     &                D_DS(:,3:nFckDim+2),nh1,nFckDim,
     &                Do_Grad,
     &                Grad,nGrad,DFTFOCK)
*   calculate v_T, Subsys A
      Xint_Ts_A=dDot_(nh1,F_DFT(:,3),1,D_DS(:,3),1)
*---
      Call wrap_DrvNQ(KSDFT,F_DFT(:,3:nFckDim+2),nFckDim,Func_A,
     &                D_DS(:,3:nFckDim+2),nh1,nFckDim,
     &                Do_Grad,
     &                Grad,nGrad,DFTFOCK)
*
*  Fraction of correlation potential from A (cases: HF or Trunc. CI)
*
      If (dFMD.gt.0.0d0) Then
*
         Call mma_Allocate(Fcorr,nh1,nFckDim,Label='Fcorr')
*
         Call cwrap_DrvNQ(KSDFT,F_DFT(:,3:nFckDim+2),nFckDim,Ec_A,
     &                    D_DS(:,3:nFckDim+2),nh1,nFckDim,
     &                    Do_Grad,
     &                    Grad,nGrad,DFTFOCK,Fcorr(:,1:nFckDim))
      End If
*
*
************************************************************************
*                                                                      *
*     Calculation on the supermolecule                                 *
*                                                                      *
************************************************************************
      nFckDim=2
      If (iSpin.eq.1 .and. kSpin.eq.1) Then
         nFckDim=1
         Call daxpy_(nh1,One,D_DS(:,3),1,D_DS(:,1),1)
      Else
         Call daxpy_(nh1,One,D_DS(:,3),1,D_DS(:,1),1)
         Call daxpy_(nh1,One,D_DS(:,4),1,D_DS(:,2),1)
      EndIf
#ifdef _NOT_USED_
*---AZECH 10/2015
*   kinetic part of E_xct, Subsys A+B
*   temporarily turned off to clean output
      If (.False.) Then
       Func_AB_TF = 0.0d0
       Call wrap_DrvNQ('TF_only',F_DFT(:,1:nFckDim),nFckDim,Func_AB_TF,
     &                D_DS(:,1:nFckDim),nh1,nFckDim,
     &                Do_Grad,
     &                Grad,nGrad,DFTFOCK)
       TF_NAD = Func_AB_TF - Func_A_TF - Func_B_TF
       Write(6,*) 'kinetic part of E_xc,T (Thomas-Fermi ONLY)'
       Write(6,'(A,F19.10)') 'Ts(A+B): ', Func_AB_TF
       Write(6,'(A,F19.10)') 'Ts(A):   ', Func_A_TF
       Write(6,'(A,F19.10)') 'Ts(B):   ', Func_B_TF
       Write(6,'(A,F19.10)') '-------------------'
       Write(6,'(A,F19.10)') 'Ts_NAD:  ', TF_NAD
*   calculate v_T, Subsys A+B
       Xint_Ts_AB=dDot_(nh1,F_DFT(:,1),1,D_DS(:,3),1)
       Xint_Ts_NAD = Xint_Ts_AB - Xint_Ts_A
*     scale by 2 because wrapper only handles spin-densities
       Xint_Ts_NAD = Two*Xint_Ts_NAD
       Write(6,*) 'integrated v_Ts_NAD (Thomas-Fermi) with rhoA current'
       Write(6,'(A,F19.10)') 'Ts(A+B)_integral: ', Xint_Ts_AB
       Write(6,'(A,F19.10)') 'Ts(A)_integral:   ', Xint_Ts_A
       Write(6,'(A,F19.10)') '-------------------'
       Write(6,'(A,F19.10)') 'Ts_NAD_integral:  ', Xint_Ts_NAD
      EndIf
#endif
*---
      Call wrap_DrvNQ(KSDFT,F_DFT(:,1:nFckDim),nFckDim,Func_AB,
     &                D_DS(:,1:nFckDim),nh1,nFckDim,
     &                Do_Grad,
     &                Grad,nGrad,DFTFOCK)

      Energy_NAD = Func_AB - Func_A - Func_B
*
*---AZECH 10/2015
*   exchange-correlation part of E_xct, Subsys A+B
*   temporarily turned off to clean output
c      Write(6,*) 'E_xc_NAD (determined with Thomas-Fermi)'
c      Func_xc_NAD = Energy_NAD - TF_NAD
c      Write(6,'(A,F19.10)') 'E_xc_NAD: ', Func_xc_NAD
*---
      If (dFMD.gt.0.0d0) Then
         Call Get_electrons(xElAB)
         Fakt_ = -1.0d0*Xlambda(abs(Energy_NAD)/xElAB,Xsigma)
         Call daxpy_(nh1*nFckDim,Fakt_,Fcorr(:,1:nFckDim),1,
     &                                 F_DFT(:,3:nFckDim+2),1)
         Call mma_deallocate(Fcorr)
#ifdef _DEBUGPRINT_
         write(6,*) ' lambda(E_nad) = ',dFMD*Fakt_
#endif
      EndIf

*                                                                      *
************************************************************************
*                                                                      *
*  Non Additive (NAD) potential: F(AB)-F(A)
      Do i=1,nFckDim
         Call daxpy_(nh1,-One,F_DFT(:,2+i),1,F_DFT(:,i),1)
      End Do
#ifdef _NOT_USED_
*
*  NDSD potential for T_nad: add the (B)-dependent term
      iFickB=ip_NDSD
      Do i=1,nFckDim*Min(1,l_NDSD)
         Call daxpy_(nh1,One,Work(iFickB),1,F_DFT(:,i),1)
         If (kSpin.ne.1) iFickB=iFickB+nh1
      End Do
#endif
*
*     Add the Nuc Attr potential (from subsystem B) and then
*     put out the DFT Fock matrices from the (NAD) embedding potential
*     on the runfile (AUXRFIL). Note that the classical Coulomb
*     interaction potential from subsystem B is computed in the std
*     Fock matrix builders
*
      Call NameRun('AUXRFIL')   ! switch RUNFILE name
*
      Call mma_allocate(TmpA,nh1,Label='TmpA')
      Call Get_dArray('Nuc Potential',TmpA,nh1)
*
      Fact = Two ! because Dmat has been scaled by half
      If (kSpin.ne.1) Fact=One
      Fact_=Fact
*
      V_emb=Fact*dDot_(nh1,F_DFT(:,1),1,D_DS(:,3),1)
      V_Nuc_AB=Fact*dDot_(nh1,TmpA,1,D_DS(:,3),1)
      If (kSpin.ne.1) Then
         V_emb=V_emb+Fact*dDot_(nh1,F_DFT(:,2),1,D_DS(:,4),1)
         V_Nuc_AB=V_Nuc_AB+Fact*dDot_(nh1,TmpA,1,D_DS(:,4),1)
      EndIf
*
*  Averaging the spin-components of F(AB) iff non-spol(A)//spol(B)
      If (iSpin.eq.1 .and. kSpin.ne.1) Then
         Do i=1,nh1
            tmp=Half*(F_DFT(i,1)+F_DFT(i,2))
            F_DFT(i,1)=tmp
         End Do
         nFckDim=1  ! reset stuff as if A+B had been spin compensated
         Fact=Two
      EndIf
*
      Do i=1,nFckDim
         Call daxpy_(nh1,1.0d0,TmpA,1,F_DFT(:,i),1)
         Vxc_ref(i)=Fact*dDot_(nh1,F_DFT(:,i),1,D_DS(:,i+2),1)
      End Do
*
      If(dFMD.gt.0.0d0) Call Put_dScalar('KSDFT energy',Ec_A)
      Call Put_dArray('Vxc_ref ',Vxc_ref,2)
*
      Call Put_dArray('dExcdRa',F_DFT(:,1:nFckDim),nh1*nFckDim)
      Call NameRun(NamRfil)   ! switch back RUNFILE name

      Call Get_dArray('Nuc Potential',TmpA,nh1)
      V_Nuc_BA= Fact_*( dDot_(nh1,TmpA,1,D_DS(:,1),1)
     &                 -dDot_(nh1,TmpA,1,D_DS(:,3),1))
      If (kSpin.ne.1) Then
         V_Nuc_BA=V_Nuc_BA+Fact_*( dDot_(nh1,TmpA,1,D_DS(:,2),1)
     &                            -dDot_(nh1,TmpA,1,D_DS(:,4),1) )
      EndIf
*
      Call mma_deallocate(TmpA)
*
#ifdef _DEBUGPRINT_
      If (nFckDim.eq.1) Then
         Do i=1,nh1
            Write(6,'(i4,f22.16)') i,F_DFT(i,1)
         End Do
      Else
         Do i=1,nh1
           Write(6,'(i4,3f22.16)') i,F_DFT(i,1),
     &                               F_DFT(i,2),
     &     (F_DFT(i,1)+F_DFT(i,2))/2.0d0
         End Do
      End If
      Write(6,'(a,f22.16)') ' NAD DFT Energy :',Energy_NAD
#endif
*
      Call mma_deallocate(F_DFT)
      Call mma_deallocate(D_DS)
      Call Free_iSD()
      Return
c Avoid unused argument warnings
      If (.False.) Then
         Call Unused_real_array(H1)
         Call Unused_real_array(D)
         Call Unused_real(RepNuc)
         Call Unused_real(ExFac)
         Call Unused_real_array(D1I)
         Call Unused_real_array(D1A)
      End If
      End
************************************************************************
*                                                                      *
************************************************************************
*                                                                      *
************************************************************************
      Subroutine Wrap_DrvNQ(KSDFT,F_DFT,nFckDim,Func,
     &                      D_DS,nh1,nD_DS,
     &                      Do_Grad,
     &                      Grad,nGrad,DFTFOCK)
      Implicit Real*8 (a-h,o-z)
      Character*(*) KSDFT
      Integer nh1, nFckDim, nD_DS
      Real*8 F_DFT(nh1,nFckDim), D_DS(nh1,nD_DS), Func
      Logical Do_Grad
      Real*8 Grad(nGrad)
      Character*4 DFTFOCK
#include "real.fh"
#include "nq_info.fh"
#include "debug.fh"
      External LSDA_emb,
     &         LSDA5_emb,
     &         BLYP_emb, BLYP_emb2,
     &         PBE_emb, PBE_emb2,
     &         Ts_only_emb, vW_hunter, nucatt_emb,
     &         Checker
      Logical  Do_MO,Do_TwoEl,F_nAsh

************************************************************************
*                                                                      *
*     DFT functionals, compute integrals over the potential
*
      Func            =Zero
      Dens_I          =Zero
      Grad_I          =Zero
      Tau_I           =Zero
      Do_MO           =.False.
      Do_TwoEl        =.False.
*
      Call Get_iScalar('nSym',mIrrep)
      Call Get_iArray('nBas',mBas(0),mIrrep)
      Call Get_iArray('nFro',nFro(0),mIrrep)
      Call Get_iArray('nIsh',nIsh(0),mIrrep)
      Call qpg_dArray('nAsh',F_nAsh,nOrbA)
      If(.not.F_nAsh .or. nOrbA.eq.0) Then
         Call Izero(nAsh(0),mIrrep)
      Else
         Call Get_iArray('nAsh',nAsh(0),mIrrep)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*      LDTF/LSDA (Thomas-Fermi for KE)                                 *
*                                                                      *
       If (KSDFT.eq.'LDTF/LSDA ' .or.
     &     KSDFT.eq.'LDTF/LDA  ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=LDA_type
         Call DrvNQ(LSDA_emb,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      LDTF/LSDA5 (Thomas-Fermi for KE)                                *
*                                                                      *
       Else If (KSDFT.eq.'LDTF/LSDA5' .or.
     &          KSDFT.eq.'LDTF/LDA5 ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=LDA_type
         Call DrvNQ(LSDA5_emb,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      LDTF/PBE   (Thomas-Fermi for KE)                                *
*                                                                      *
       Else If (KSDFT.eq.'LDTF/PBE  ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=GGA_type
         Call DrvNQ(PBE_emb,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      NDSD/PBE   (NDSD for KE)                                        *
*                                                                      *
       Else If (KSDFT.eq.'NDSD/PBE  ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=meta_GGA_type2
         Call DrvNQ(PBE_emb2,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      LDTF/BLYP  (Thomas-Fermi for KE)                                *
*                                                                      *
       Else If (KSDFT.eq.'LDTF/BLYP ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=GGA_type
         Call DrvNQ(BLYP_emb,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      NDSD/BLYP  (NDSD for KE)                                        *
*                                                                      *
       Else If (KSDFT.eq.'NDSD/BLYP ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=meta_GGA_type2
         Call DrvNQ(BLYP_emb2,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      Kinetic only  (Thomas-Fermi)                                    *
*                                                                      *
       Else If (KSDFT.eq.'TF_only') Then
         ExFac=Zero
         Functional_type=LDA_type
         Call DrvNQ(Ts_only_emb,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      HUNTER  (von Weizsacker KE, no calc of potential)               *
*                                                                      *
       Else If (KSDFT.eq.'HUNTER') Then
         ExFac=Zero
         Functional_type=GGA_type
         Call DrvNQ(vW_hunter,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      NUCATT                                                          *
*                                                                      *
       Else If (KSDFT.eq.'NUCATT_EMB') Then
         ExFac=Zero
         Functional_type=LDA_type
         Call DrvNQ(nucatt_emb,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     Checker
      Else If (KSDFT.eq.'CHECKER') Then
         ExFac=Zero
         Functional_type=meta_GGA_type2
         Call DrvNQ(Checker,F_DFT,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
      Else
         lKSDFT=LEN(KSDFT)
         Call WarningMessage(2,
     &               ' Wrap_DrvNQ: Undefined functional type!')
         Write (6,*) '         Functional=',KSDFT(1:lKSDFT)
         Call Quit_OnUserError()
      End If
*
      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine cWrap_DrvNQ(KSDFT,F_DFT,nFckDim,Func,
     &                       D_DS,nh1,nD_DS,
     &                       Do_Grad,
     &                       Grad,nGrad,DFTFOCK,F_corr)
      Implicit Real*8 (a-h,o-z)
      Character*(*) KSDFT
      Integer nh1, nFckDim, nD_DS
      Real*8 F_DFT(nh1,nFckDim), D_DS(nh1,nD_DS), Func
      Real*8 F_corr(nh1,nFckDim)
      Logical Do_Grad
      Real*8 Grad(nGrad)
      Character*4 DFTFOCK
#include "real.fh"
#include "nq_info.fh"
#include "debug.fh"
      External VWN_III_emb,
     &         VWN_V_emb,
     &         cBLYP_emb,
     &         cPBE_emb,
     &         Checker
      Logical  Do_MO,Do_TwoEl,F_nAsh

************************************************************************
*                                                                      *
      Func            =Zero
      Dens_I          =Zero
      Grad_I          =Zero
      Tau_I           =Zero
      Do_MO           =.False.
      Do_TwoEl        =.False.
*
      Call Get_iScalar('nSym',mIrrep)
      Call Get_iArray('nBas',mBas(0),mIrrep)
      Call Get_iArray('nFro',nFro(0),mIrrep)
      Call Get_iArray('nIsh',nIsh(0),mIrrep)
      Call qpg_dArray('nAsh',F_nAsh,nOrbA)
      If(.not.F_nAsh .or. nOrbA.eq.0) Then
         Call Izero(nAsh(0),mIrrep)
      Else
         Call Get_iArray('nAsh',nAsh(0),mIrrep)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*      LDTF/LSDA (Fractional) correlation potential only               *
*                                                                      *
       If (KSDFT.eq.'LDTF/LSDA ' .or.
     &     KSDFT.eq.'LDTF/LDA  ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=LDA_type
         Call DrvNQ(VWN_III_emb,F_corr,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      LDTF/LSDA5 (Fractional) correlation potential only              *
*                                                                      *
       Else If (KSDFT.eq.'LDTF/LSDA5' .or.
     &          KSDFT.eq.'LDTF/LDA5 ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=LDA_type
         Call DrvNQ(VWN_V_emb,F_corr,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      LDTF/PBE   (Fractional) correlation potential only              *
*                                                                      *
       Else If (KSDFT.eq.'LDTF/PBE  ' .or.
     &          KSDFT.eq.'NDSD/PBE  ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=GGA_type
         Call DrvNQ(cPBE_emb,F_corr,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*      LDTF/BLYP  (Fractional) correlation potential only              *
*                                                                      *
       Else If (KSDFT.eq.'LDTF/BLYP ' .or.
     &          KSDFT.eq.'NDSD/BLYP ') Then
         ExFac=Get_ExFac(KSDFT(6:10))
         Functional_type=GGA_type
         Call DrvNQ(cBLYP_emb,F_corr,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
*     Checker                                                          *
*                                                                      *
      Else If (KSDFT.eq.'CHECKER') Then
         ExFac=Zero
         Functional_type=meta_GGA_type2
         Call DrvNQ(Checker,F_corr,nFckDim,Func,
     &              D_DS,nh1,nD_DS,
     &              Do_Grad,
     &              Grad,nGrad,
     &              Do_MO,Do_TwoEl,DFTFOCK)
*                                                                      *
************************************************************************
*                                                                      *
      Else
         lKSDFT=LEN(KSDFT)
         Call WarningMessage(2,
     &               ' cWrap_DrvNQ: Undefined functional type!')
         Write (6,*) '         Functional=',KSDFT(1:lKSDFT)
         Call Quit_OnUserError()
      End If
*
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(F_DFT)
      End
************************************************************************
*                                                                      *
************************************************************************
*                                                                      *
************************************************************************
      Real*8 Function Xlambda(omega,sigma)
      Implicit Real*8 (a-h,o-z)
      Real*8 omega, sigma

      If (sigma*omega.gt.42d0) Then
         Xlambda = 1.0d0
      Else
         Xlambda = 1.0d0 - exp(-sigma*omega)
      EndIf

      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine Get_electrons(xnElect)
      Implicit Real*8 (a-h,o-z)
      Real*8 xnElect
#include "real.fh"
#include "nq_info.fh"

      xnElect = Dens_I

      Return
      End
************************************************************************
*                                                                      *
************************************************************************
      Subroutine VEMB_Exc_states(Vemb,nVemb,xKSDFT,Func_Bx)
      Implicit Real*8 (a-h,o-z)
      Real*8 Vemb(nVemb)
      Real*8 Func_Bx
      Character*(*) xKSDFT
      Character*16 MyNamRfil
#include <rasdim.fh>
#include "rasscf.fh"
#include "general.fh"
#include "gas.fh"
#include "ciinfo.fh"
#include "rctfld.fh"
#include "stdalloc.fh"
#include <SysDef.fh>
      Real*8, Allocatable:: D1ao_b(:), F_DFT(:)
      Real*8, Allocatable:: xxCMO(:), xxOCCN(:), DState(:)
      Real*8 :: Dummy(1)=[0.0D0]
      Integer :: nDummy=1


      IAD12=IADR15(12)

      Call mma_allocate(xxCMO,NTOT2,Label='xxCMO')
      Call mma_allocate(xxOCCN,NTOT,Label='xxOCCN')
      Call mma_allocate(DState,NTOT1,Label='DState')
      Call mma_allocate(F_DFT,nVemb,Label='F_DFT')
      Call mma_allocate(D1ao_b,nVemb,Label='D1ao_b')

      DO KROOT=1,LROOTS
*
* Read natural orbitals
        If ( NAC.GT.0 ) then
          CALL DDAFILE(JOBIPH,2,xxCMO,NTOT2,IAD12)
          CALL DDAFILE(JOBIPH,2,xxOCCN,NTOT,IAD12)
        End If
* Get GS and excited state densities:
* Fill allocated mem with zeroes.
        DSTATE(:)=0.0D0

        Call DONE_RASSCF(xxCMO,xxOCCN,DState) ! computes D=CnC'
* Nonelectr. Vemb with GS and excited state density
        Vemb_Xstate=ddot_(nVemb,Vemb,1,DState,1)
*        Write(6,*) 'Kroot, Vemb_K ', KROOT, Vemb_Xstate
        Write(6,'(A,F19.10,3X,A,I3)') 'Nonelectr. Vemb w. rhoA_emb =',
     &        Vemb_Xstate,'root = ', KROOT
* E_xc,T[rhoA]
        Func_A=0.0d0
        F_DFT(:)=0.0D0
        Call dscal_(nVemb,0.5d0,DState,1)
        Call wrap_DrvNQ(xKSDFT,F_DFT,1,Func_A,
     &                  DState,nVemb,1,
     &                  .false.,
     &                  Dummy,nDummy,'SCF ')
*        Write(6,*) 'Kroot, Func_A ', KROOT, Func_A
* E_xc,T[rhoA+rhoB]
        Call Get_NameRun(MyNamRfil) ! save current Runfile name
        Call NameRun('AUXRFIL')   ! switch RUNFILE name
        Call Get_D1ao(D1ao_b,nVemb)
        Call daxpy_(nVemb,0.5d0,D1ao_b,1,DState,1)
*
        Func_AB=0.0d0
        F_DFT(:)=0.0D0
        Call wrap_DrvNQ(xKSDFT,F_DFT,1,Func_AB,
     &                  DState,nVemb,1,
     &                  .false.,
     &                  Dummy,nDummy,'SCF ')
*        Write(6,*) 'Kroot, Func_AB', KROOT, Func_AB
*        Write(6,*) 'Kroot, Func_Bx', KROOT, Func_Bx
* Calculate DFT NAD for all densities:
        DFT_NAD = Func_AB - Func_A - Func_Bx
        Write(6,'(A,F19.10,3X,A,I3)') 'DFT energy (NAD) =           ',
     &        DFT_NAD, 'root = ', KROOT
        Call NameRun(MyNamRfil) ! go back to MyNamRfil
      End Do
      Call mma_deallocate(D1ao_b)
      Call mma_deallocate(F_DFT)
      Call mma_deallocate(DState)
      Call mma_deallocate(xxCMO)
      Call mma_deallocate(xxOCCN)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
c  *********************************************************************
c  *                                                                   *
c  *  CNFINI   := Set NVBR, NDETVB, NDETVB2, MNION, MXION,             *
c  *              NCONFION, and IFSC.                                  *
c  *                                                                   *
c  *********************************************************************
      subroutine cnfini_cvb(iconfs,nconf1,nel1,
     >  nS,i2s,nMs,nalf1,nbet1,
     >  nvbr1,ndetvb1,ndetvb21,mnion1,mxion1,nconfion,ifsc1)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


      dimension iconfs(noe,nconf1)
      dimension i2s(nS),nalf1(nMs),nbet1(nMs)
      dimension nconfion(0:*)

c  Main loop over configurations :
      mnion1=nel1/2
      mxion1=0
      call izero(nconfion,1+nel1/2)
      ndetvb1=0
      ndetvb21=0
      nvbr1=0
      do 100 iconf=1,nconf1
      ion=0
      do 200 iorb=1,norb
      if(iconfs(iorb,iconf).eq.2)ion=ion+1
200   continue
      if(ion.lt.mnion1)mnion1=ion
      if(ion.gt.mxion1)mxion1=ion
      nconfion(ion)=nconfion(ion)+1
      do 300 iS=1,nS
      call icomb_cvb(nel1-2*ion,(nel1-i2s(iS))/2-ion,iretval1)
      call icomb_cvb(nel1-2*ion,(nel1-i2s(iS))/2-ion-1,iretval2)
      nvbr1=nvbr1+iretval1-iretval2
300   continue
      do 400 iMs=1,nMs
      call icomb_cvb(nel1-2*ion,nalf1(iMs)-ion,iretval)
      ndetvb1=ndetvb1+iretval
      ndetvb21=ndetvb21+(iretval+1)/2
400   continue
100   continue
      if(norb.eq.nel1.and.nconf1.eq.1)then
        ifsc1=1
        do 500 i=1,nel1
        if(iconfs(i,nconf1).ne.1)ifsc1=0
500     continue
      else
        ifsc1=0
      endif
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer_array(nbet1)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!               Thomas Bondo Pedersen                                  *
!               Francesco Aquilante                                    *
!***********************************************************************

subroutine BasFun_Atom_Sym(nBas_per_Atom,nBas_Start,BName,jBas,nBas,nAtoms,DoPrint)
! Author: Y. Carissan / T. B. Pedersen
!         [adapted to cases with symmetry by F. Aquilante]

use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp, u6

implicit none
#include "Molcas.fh"
integer(kind=iwp), intent(in) :: nAtoms, jBas, nBas
integer(kind=iwp), intent(out) :: nBas_per_Atom(nAtoms), nBas_Start(nAtoms)
character(len=LenIn8), intent(in) :: BName(nBas)
logical(kind=iwp), intent(in) :: DoPrint
integer(kind=iwp) :: iAt, iCount, jCount, kBas
character(len=LenIn) :: Lbl
character(len=80) :: Txt, Formt
character(len=LenIn), allocatable :: AtName(:)
character(len=*), parameter :: SecNam = 'BasFun_Atom_Sym'

! Counters.
! ---------

! IFG: To count basis functions per atom, we need a list of atom names,
!      since there is no guarantee all atoms will be present in a give irrep
call mma_allocate(AtName,nAtoms,label='AtName')
call Get_cArray('Unique Atom Names',AtName,LenIn*nAtoms)

kBas = jBas
do iAt=1,nAtoms
  nBas_per_Atom(iAt) = 0
  Lbl = AtName(iAt)
  do while ((BName(kBas)(1:LenIn) == Lbl) .and. (kBas <= nBas))
    nBas_per_Atom(iAt) = nBas_per_Atom(iAt)+1
    kBas = kBas+1
  end do
end do
call mma_deallocate(AtName)

! Offsets.
! --------

iCount = 0
do iAt=1,nAtoms
  nBas_Start(iAt) = iCount+1
  iCount = iCount+nBas_per_Atom(iAt)
end do
jCount = iCount+jBas-1
if (jCount /= nBas) then
  write(Txt,'(A,I9,A,I9)') 'jCount =',jCount,'  nBas =',nBas
  call SysAbendMsg(SecNam,'jCount /= nBas',Txt)
end if

! Print.
! ------

if (DoPrint) then
  write(Formt,'(3(a6,i3,a5))') '(/,a6,',nAtoms,'i5,/,','   a6,',nAtoms,'i5,/,','   a6,',nAtoms,'i5)'
  write(u6,Formt) 'Atom  ',(iAt,iAt=1,nAtoms),'Start ',nBas_Start(:),'nBas  ',nBas_per_Atom(:)
end if

end subroutine BasFun_Atom_Sym

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Langevin(h1,TwoHam,D,RepNuc,nh1,First,Dff)
      Use Basis_Info
      use Center_Info
      Use Langevin_arrays
      use External_Centers
      use Phase_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      Real*8 h1(nh1), TwoHam(nh1), D(nh1)
#include "print.fh"
#include "real.fh"
#include "rctfld.fh"
#include "stdalloc.fh"
      Logical First, Dff, Exist
      Save nAnisopol,nPolComp
      Real*8, Allocatable:: D1ao(:)
      Real*8, Allocatable:: Cord(:,:), Chrg(:), Atom_R(:),
     &                      pField(:,:), tmpField(:,:)
*
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2

      iRout = 1
      iPrint = nPrint(iRout)
*                                                                      *
************************************************************************
*                                                                      *
*---- Generate list of all atoms
*
*     Cord: list of all atoms
*     Atom_R: associated effective atomic radius
*

      mdc = 0
      MaxAto=0
      Do iCnttp = 1, nCnttp
         nCnt = dbsc(iCnttp)%nCntr
         Do iCnt = 1, nCnt
            mdc = mdc + 1
            MaxAto = MaxAto + nIrrep/dc(mdc)%nStab
         End Do
      End Do
*
      Call mma_allocate(Cord,3,MaxAto,Label='Cord')
      Call mma_allocate(Chrg,MaxAto,Label='Chrg')
      Call mma_allocate(Atom_R,MaxAto,Label='Atom_R')
*
      ndc = 0
      nc = 0
      Do jCnttp = 1, nCnttp
         Z = dbsc(jCnttp)%Charge
         mCnt = dbsc(jCnttp)%nCntr
         If (dbsc(jCnttp)%AtmNr.ge.1) Then
*            Atod = CovRad (dbsc(jCnttp)%AtmNr)
             Atod = CovRadT(dbsc(jCnttp)%AtmNr)
         Else
             Atod = Zero
         End If
         Do jCnt = 1, mCnt
            ndc = ndc + 1
            Do i = 0, nIrrep/dc(ndc)%nStab - 1
               nc = nc + 1
               Call OA(dc(ndc)%iCoSet(i,0),dbsc(jCnttp)%Coor(1:3,jCnt),
     &                 Cord(:,nc))
               Atom_R(nc) = Atod
               Chrg(nc) = Z
*              Write (*,*) 'Z=',Z
            End Do
         End Do
      End Do
*
      If(LGridAverage) Then
         nAv=nGridAverage
         If(nGridSeed.eq.0) Then
            iSeed=0
         ElseIf(nGridSeed.eq.-1) Then
            iSeed=0
*     Use system_clock only for some systems
c            Call System_clock(iSeed,j,k)
         Else
            iSeed=nGridSeed
         EndIf
      Else
         nAv=1
      EndIf
      sumRepNuc=Zero
      sumRepNuc2=Zero

      Do iAv=1,nAv
         If(LGridAverage) Then
            cordsi(1,1)=Random_Molcas(iSeed)
            cordsi(2,1)=Random_Molcas(iSeed)
            cordsi(3,1)=Random_Molcas(iSeed)
            rotAlpha=Random_Molcas(iSeed)*180.0D0
            rotBeta=Random_Molcas(iSeed)*180.0D0
            rotGamma=Random_Molcas(iSeed)*180.0D0
            write(6,'(a,i4,a,6f10.4)')'GRID NR',iAv,': ',cordsi(1,1),
     &           cordsi(2,1),cordsi(3,1),rotAlpha,rotBeta,rotGamma
            Done_Lattice=.False.
            RepNuc = Zero
         EndIf

      If (.Not.Done_Lattice) Then
         lFirstIter=.True.
         Done_Lattice=.True.
         if(iXPolType.eq.2) Then
            nAnisopol = nXF
            nPolComp = 6
         Else
            nAnisopol = 0
            nPolComp = 1
         EndIf
*
*
*------- Compute Effective Polarizabilities on the Langevin grid,
*        flag also if points on the grid are excluded.
*        This information is computed once!
*
*        Grid : The Langevin grid
*        PolEf: Effective Polarizability on grid
*        DipEf: Effective Dipole moment on grid
*
         nGrid_Eff=0
*        Both these subroutines can increase nGrid_Eff
         If(iXPolType.gt.0) Then
            Call lattXPol(Grid,nGrid,nGrid_Eff,PolEf,DipEf,XF,
     &                    nXF,nOrd_XF,nPolComp)
         EndIf
         If(lLangevin) Then
*            Note: Gen_Grid is now a part of the lattcr subroutine
            Call lattcr(Grid,nGrid,nGrid_Eff,PolEf,DipEf,
     &                  Cord,maxato,Atom_R,nPolComp,
     &                  XF,nXF,nOrd_XF,XEle,iXPolType)
         EndIf
c        Write(6,*) 'nGrid,  nGrid_Eff', nGrid,  nGrid_Eff

*
      End If
*
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute Electric Field from the Quantum Chemical System on the
*     Langevin grid.
*
*     cavxyz: MM expansion of the total charge of the QM system
*     ravxyz: scratch
*     dField: EF on Langevin grid due to QM system
*
*     Get the total 1st order AO density matrix
*
      Call mma_allocate(D1ao,nh1,Label='D1ao')
      Call Get_D1ao(D1ao,nh1)
*
*     Save field from permanent multipoles for use in ener
      Call mma_allocate(pField,4,nGrid_Eff,Label='pField')
      Call mma_allocate(tmpField,4,nGrid_Eff,Label='tmpField')

      pField(:,:)=Zero

      Call eperm(D1ao,nh1,Ravxyz,Cavxyz,nCavxyz,
     &           dField,Grid,nGrid_Eff,Cord,MaxAto,Chrg,pField)

*                                                                      *
************************************************************************
*                                                                      *
*---- Save system info, to be used by visualisation program            *

      Lu=21
      Call OpnFl('LANGINFO',Lu,Exist)
      If(.not.Exist) Then
      Write(Lu,*) nc
      do i=1,nc
         Write(Lu,11)INT(Chrg(i)),Atom_R(i),(Cord(j,i),j=1,3)
 11      format(i3,f10.4,3f16.8)
      enddo
      Write(Lu,*)nXF
      Inc = 3
      Do iOrdOp = 0, nOrd_XF
         Inc = Inc + nElem(iOrdOp)
      End Do
      If(iXPolType.gt.0) Inc = Inc + 6
      Do iXF=1,nXF
         xa=XF(1,iXF)
         ya=XF(2,iXF)
         za=XF(3,iXF)
         If(XEle(iXF).le.0) Then
            atrad=-DBLE(XEle(iXF))/1000.0D0
            iele=0
         Else
            iele=XEle(iXF)
            atrad=CovRadT(iele)
         EndIf
         Write(Lu,11)iele,atrad,xa,ya,za
      EndDo
      Write(Lu,*)nGrid_eff,nAnisopol
      do i=0,nGrid_eff-1
         Write(Lu,12)(Grid(j,i+1),j=1,3),
     &        PolEf(:,i+1),
     &        DipEf(i+1),
     &        (dField(j,i+1),j=1,3),(pField(j,i),j=1,3)
 12      format(11f20.10)
      enddo
      Write(Lu,*)polsi,dipsi,scala,One/tK/3.1668D-6
      Write(Lu,*)(cordsi(k,1),k=1,3)
      Write(Lu,*)rotAlpha, rotBeta, rotGamma
      Write(Lu,*)radlat,nSparse,distSparse
      Write(Lu,*)lDamping, dipCutoff
      Endif
      Close(Lu)

      call dcopy_(nGrid_Eff*4,dField,1,tmpField,1)

      If(lDiprestart .or. lFirstIter) Then
         Field(:,:)=Zero
         Dip(:,:)=Zero
         Davxyz(:)=Zero
      EndIf

*---- Subtract the static MM from the previous iteration
*     from the static MM of this iteration, and save the
*     untouched static MM of this iteration into Davxyz
*     for use in the next iteration. Ravxyz is
*     just a temporary array

      call dcopy_(nCavxyz,Cavxyz,1,Ravxyz,1)
      Call DaXpY_(nCavxyz,-One,Davxyz,1,Cavxyz,1)
      call dcopy_(nCavxyz,Ravxyz,1,Davxyz,1)

*     Ravxyz(:)=Cavxyz(:)
*     Cavxyz(:)=Cavxyz(:)-Davxyz(:)
*     Davxyz(:)=Ravxyz(:)
*                                                                      *
************************************************************************
*                                                                      *
*---- Equation solver: compute the Langevin dipole moments and the
*                      counter charge on the boundary of the cavity.
*
*     Field : total EF of the Langevin grid
*     Dip   : dipole momement on the Langevin grid
*
      Call edip(Ravxyz,Cavxyz,lmax,
     &          Field,Dip,dField,
     &          PolEf,DipEf,
     &          Grid,nGrid_Eff,nPolComp,nAnisopol,
     &          nXF,iXPolType,nXMolnr,XMolnr)

*                                                                      *
************************************************************************
*                                                                      *
*---- Compute contributions to RepNuc, h1, and TwoHam
*
      Call Ener(h1,TwoHam,D,RepNuc,nh1,First,Dff,D1ao,Grid,
     &          nGrid_Eff,Dip, Field,DipEf,PolEf,Cord,MaxAto,
     &          Chrg,nPolComp,nAnisopol,pField,tmpField)


*     Subtract the static field from the self-consistent field
*     This gives the field from the induced dipoles (saved
*     in Field, to be used in the next iteration if
*     not DRES has been requested

      Call DaXpY_(nGrid*4,-One,tmpField,1,Field,1)
      lFirstIter=.False.


      Call mma_deallocate(pField)
      Call mma_deallocate(tmpField)
      If(LGridAverage) Then
         Write(6,'(a,i4,a,f18.10)')'Solvation energy (Grid nr. ',iAv,
     &        '):',RepNuc
         sumRepNuc = sumRepNuc + RepNuc
         sumRepNuc2 = sumRepNuc2 + RepNuc**2
      EndIf
      EndDo
      If(LGridAverage) Then
         Write(6,'(a,f18.10,f18.10)')
     &        'Average solvation energy and stdev: ',
     &        sumRepNuc/DBLE(nAv),
     &        sqrt(sumRepNuc2/DBLE(nAv)-(sumRepNuc/DBLE(nAv))**2)
      End If
      Call mma_deallocate(Atom_R)
      Call mma_deallocate(D1ao)
      Call mma_deallocate(Chrg)
      Call mma_deallocate(Cord)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021-2023, Vladislav Kochetov                          *
!***********************************************************************

subroutine get_vsoc()
!***********************************************************************
! Purpose:  transformation of V(SOC) matrix from the basis
!           of spin-free states as it is obtained from RASSI
!           to the basis of CSFs
!***********************************************************************
! V_SO    : SO-Hamiltonian matrix
! REV_SO  : Real part of V_SO
! IMV_SO  : Imaginary part of V_SO
! REV_CSF : U_CI*REV_SO*U_CI**T
! IMV_CSF : U_CI*IMV_SO*U_CI**T

use rhodyn_data, only: ipglob, lrootstot, nconftot, prep_vcsfi, prep_vcsfr, U_CI, V_CSF, V_SO, threshold
use rhodyn_utils, only: dashes, transform, check_hermicity
use mh5, only: mh5_put_dset
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, j
real(kind=wp), allocatable :: REV_SO(:,:), REV_CSF(:,:), IMV_SO(:,:), IMV_CSF(:,:)

call mma_allocate(REV_SO,lrootstot,lrootstot)
call mma_allocate(IMV_SO,lrootstot,lrootstot)
call mma_allocate(REV_CSF,nconftot,nconftot)
call mma_allocate(IMV_CSF,nconftot,nconftot)

REV_SO(:,:) = real(V_SO)
IMV_SO(:,:) = aimag(V_SO)

call check_hermicity(V_SO,lrootstot,'V_SO in SF basis',threshold)

if (ipglob > 3) then
  call dashes()
  write(u6,*) 'Printout the Spin-orbit Hamiltonian in SF basis'
  call dashes()
  do i=1,6
    write(u6,*) (V_SO(i,j),j=1,6)
  end do
end if

if (ipglob > 2) write(u6,*) 'Begin transform the SO-Hamiltonian'
! Transform the SO-Hamiltonian from SF states to CSFs
call transform(REV_SO,U_CI,REV_CSF,.false.)
call transform(IMV_SO,U_CI,IMV_CSF,.false.)

V_CSF(:,:) = cmplx(REV_CSF,IMV_CSF,kind=wp)

call check_hermicity(V_CSF,nconftot,'V_SO in CSF basis',threshold)

! Store pure SOC matrix in CSF basis to PREP file
call mh5_put_dset(prep_vcsfr,REV_CSF)
call mh5_put_dset(prep_vcsfi,IMV_CSF)

call mma_deallocate(REV_SO,safe='*')
call mma_deallocate(IMV_SO,safe='*')
call mma_deallocate(REV_CSF,safe='*')
call mma_deallocate(IMV_CSF,safe='*')

end subroutine get_vsoc

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine unpackab1(wrk,wrksize,n,r1,r2,r3,r4,ssn,key,aeqb)
! n    - map type corresponding to N (Input)
! r1   - map type corresponding to R1 (Input)
! r2   - map type corresponding to R2 (Input)
! r3   - map type corresponding to R3 (Input)
! r4   - map type corresponding to R4 (Input)
! ssn  - overall symmetry state of N (Input)
! key  - define state of _a,_b  key   a, b (Input)
!        1    S  S
!        2    V  S
!        3    S  V
!        4    V  V
! aqeb - aqeb=0 if a /= b; =1 if a == b (Input)
!
! this routine unpacks: N _a_b (p,q) = <ab|pq>             key  aeqb
! N _a_b (p,q) a>=b-bb  -> R1 _a,_b(ef)aaaa = <ab||ef>      4    0
!                       -> R2 _a,_b(ef)bbbb = <ab||ef>     1-4   0
!                       -> R3 _a,_b(e,f)abab = <ab||ef>    3,4   0,1
!                       -> R4 _b,_a(e,f)abab = <ba||fe>    2,4   0,1
!
! !N.B. mylim, ze pri II.3;II.4;III.3;III.4 maju byt posn +--+ a nie ++++
! ako su terazky

use ccsd_global, only: dimm, Map_Type, mmul, noa, nob, nsym, nva, nvb
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: wrksize, ssn, key, aeqb
real(kind=wp), intent(inout) :: wrk(wrksize)
type(Map_Type), intent(in) :: n, r1, r2, r3, r4
integer(kind=iwp) :: dime, dimef, dimf, dimp, dimq, in_, inm, inp, ir1, ir2, ir3, ir4, lengthn, posn, posnm, posnp, posr1, posr2, &
                     posr3, posr4, symp, symq

do symp=1,nsym
  symq = mmul(ssn,symp)

  in_ = n%i(symp,1,1)
  lengthn = n%d(in_,2)

  if (lengthn == 0) cycle

  if (symp == symq) then
    ! symp == symq

    posn = n%d(in_,1)
    dimp = dimm(5,symp)

    !I.1 def R1 - _a_b(ef)aaaa

    if ((key == 4) .and. (aeqb == 0)) then
      ir1 = r1%i(symp,1,1)
      posr1 = r1%d(ir1,1)
      dimef = r1%d(ir1,2)
      if (r1%d(ir1,2) > 0) call unpckhelp1(wrk(posn),wrk(posr1),dimp,dimef,noa(symp),nva(symp))
    end if

    !I.2 def R2 - _a_b(ef)bbbb

    if (aeqb == 0) then
      ir2 = r2%i(symp,1,1)
      posr2 = r2%d(ir2,1)
      dimef = r2%d(ir2,2)
      if (r2%d(ir2,2) > 0) call unpckhelp1(wrk(posn),wrk(posr2),dimp,dimef,nob(symp),nvb(symp))
    end if

    !I.3  def R3 - _a_b(e,f)abab

    if ((key == 2) .or. (key == 4)) then
      ir3 = r3%i(symp,1,1)
      posr3 = r3%d(ir3,1)
      dime = dimm(3,symp)
      dimf = dimm(4,symq)
      if (r3%d(ir3,2) > 0) call unpckhelp3(wrk(posn),wrk(posr3),dimp,dimp,dime,dimf,noa(symp),nva(symp),nob(symq),nvb(symq))
    end if

    !I.4 def R4 - _b_a(e,f)abab

    if (((key == 3) .or. (key == 4)) .and. (aeqb == 0)) then
      ir4 = r4%i(symp,1,1)
      posr4 = r4%d(ir4,1)
      dime = dimm(3,symp)
      dimf = dimm(4,symq)
      if (r4%d(ir4,2) > 0) call unpckhelp4(wrk(posn),wrk(posr4),dimp,dimp,dime,dimf,noa(symp),nva(symp),nob(symq),nvb(symq))
    end if

  else if (symp > symq) then
    ! symp > symq

    inp = n%i(symp,1,1)
    inm = n%i(symq,1,1)
    posnp = n%d(inp,1)
    posnm = n%d(inm,1)
    dimp = dimm(5,symp)
    dimq = dimm(5,symq)

    !II.1 def R1 - _a_b(ef)aaaa

    if (key == 4) then
      ir1 = r1%i(symp,1,1)
      posr1 = r1%d(ir1,1)
      dime = dimm(3,symp)
      dimf = dimm(3,symq)
      if (r1%d(ir1,2) > 0) &
        call unpckhelp2(wrk(posnp),wrk(posnm),wrk(posr1),dimp,dimq,dime,dimf,noa(symp),nva(symp),noa(symq),nva(symq))
    end if

    !II.2 def R2 - _a_b(ef)bbbb

    ir2 = r2%i(symp,1,1)
    posr2 = r2%d(ir2,1)
    dime = dimm(4,symp)
    dimf = dimm(4,symq)
    if (r2%d(ir2,2) > 0) &
      call unpckhelp2(wrk(posnp),wrk(posnm),wrk(posr2),dimp,dimq,dime,dimf,nob(symp),nvb(symp),nob(symq),nvb(symq))

    !II.3 def R3 - _a_b(e,f)abab

    if ((key == 2) .or. (key == 4)) then
      ir3 = r3%i(symp,1,1)
      posr3 = r3%d(ir3,1)
      dime = dimm(3,symp)
      dimf = dimm(4,symq)
      if (r3%d(ir3,2) > 0) call unpckhelp3(wrk(posnp),wrk(posr3),dimp,dimq,dime,dimf,noa(symp),nva(symp),nob(symq),nvb(symq))
    end if

    !II.4 def R4 - _b_a(e,f)abab

    if ((key == 3) .or. (key == 4)) then
      ir4 = r4%i(symq,1,1)
      posr4 = r4%d(ir4,1)
      dime = dimm(3,symq)
      dimf = dimm(4,symp)
      if (r4%d(ir4,2) > 0) call unpckhelp4(wrk(posnp),wrk(posr4),dimp,dimq,dime,dimf,noa(symq),nva(symq),nob(symp),nvb(symp))
    end if

  else
    ! symp < symq

    inp = n%i(symp,1,1)
    inm = n%i(symq,1,1)
    posnp = n%d(inp,1)
    posnm = n%d(inm,1)
    dimp = dimm(5,symp)
    dimq = dimm(5,symq)

    !III.1 def R1 - _a_b(ef)aaaa -no operation
    !III.2 def R2 - _a_b(ef)bbbb -no operation

    !III.3 def R3 - _a_b(e,f)abab

    if ((key == 2) .or. (key == 4)) then
      ir3 = r3%i(symp,1,1)
      posr3 = r3%d(ir3,1)
      dime = dimm(3,symp)
      dimf = dimm(4,symq)
      if (r3%d(ir3,2) > 0) call unpckhelp3(wrk(posnp),wrk(posr3),dimp,dimq,dime,dimf,noa(symp),nva(symp),nob(symq),nvb(symq))
    end if

    !III.4 def R4 - _b_a(e,f)abab

    if ((key == 3) .or. (key == 4)) then
      ir4 = r4%i(symq,1,1)
      posr4 = r4%d(ir4,1)
      dime = dimm(3,symq)
      dimf = dimm(4,symp)
      if (r4%d(ir4,2) > 0) call unpckhelp4(wrk(posnp),wrk(posr4),dimp,dimq,dime,dimf,noa(symq),nva(symq),nob(symp),nvb(symp))
    end if

  end if

end do

return

end subroutine unpackab1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Readin_vb()
************************************************************************
*                                                                      *
*     Read the input                                                   *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "rasdim.fh"
#include "warnings.fh"
#include "rasscf.fh"
#include "general.fh"
#include "jobiph_j.fh"
#include "gas.fh"
*
      Character*80       Blank
*---  set INVEC -> get MOs from JOBIPH file ----------------------------*
      INVEC=3
*---  Initialize -------------------------------------------------------*
      Do i=1,80
         Blank(i:i)=' '
      End Do
         Do j = 1, 18
            Title(j) = ' '
         End Do
*
*---  Read input from standard input ----------------------------------*
*---  process TITLE    command ----------------------------------------*
      ntit=0
      do ii=1,mxtit
        if(len_trim_cvb(title_j(ii)).gt.0)then
          ntit=ntit+1
          title(ntit)=title_j(ii)
        endif
      end do
*---  process NACT command --------------------------------------------*
      nactel=nactel_j
      nhole1=nhole1_j
      nelec3=nelec3_j
*---  process SPIN command --------------------------------------------*
      ispin=ispin_j
*---  process SYMM command --------------------------------------------*
      lsym=lsym_j
*---  process FROZ command --------------------------------------------*
      call imove_cvb(nfro_j,nfro,mxsym)
*---  process INAC command --------------------------------------------*
      call imove_cvb(nish_j,nish,mxsym)
*---  process RAS1 command --------------------------------------------*
      call imove_cvb(nrs1_j,nrs1,mxsym)
*---  process RAS2 command --------------------------------------------*
      call imove_cvb(nrs2_j,nrs2,mxsym)
*---  process RAS3 command --------------------------------------------*
      call imove_cvb(nrs3_j,nrs3,mxsym)
*---  process DELE command --------------------------------------------*
      call imove_cvb(ndel_j,ndel,mxsym)
*---
      If (nroots.gt.1.and.irlxroot.eq.0) iRlxRoot=iroot(nroots)
      If (nroots.eq.1) iRlxRoot=0
*---  complete orbital specifications ---------------------------------*
      Do iSym=1,mxsym
         NASH(ISYM)=NRS1(ISYM)+NRS2(ISYM)+NRS3(ISYM)
         NORB(ISYM)=NBAS(ISYM)-NFRO(ISYM)-NDEL(ISYM)
         NSSH(ISYM)=NORB(ISYM)-NISH(ISYM)-NASH(ISYM)
      End Do

* SVC: convert CAS/RAS to general GAS description here, then we only
* need to copy it for lucia later, which always uses GAS description.
      NGSSH(1,1:NSYM)=NRS1(1:NSYM)
      NGSSH(2,1:NSYM)=NRS2(1:NSYM)
      NGSSH(3,1:NSYM)=NRS3(1:NSYM)
      IGSOCCX(1,1) = MAX(2*SUM(NRS1(1:NSYM))-NHOLE1,0)
      IGSOCCX(1,2) = 2*SUM(NRS1(1:NSYM))
      IGSOCCX(2,1) = NACTEL - NELEC3
      IGSOCCX(2,2) = NACTEL
      IGSOCCX(3,1) = NACTEL
      IGSOCCX(3,2) = NACTEL
*
*---  Compute IZROT. IZROT is a matrix (lower triangular over the -----*
*     active space), which specifies which t,u rotations should be
*     avoided, since the orbitals belong to the same RAS space.
*     This is the only way the RAS concept is explicitly used in the
*     SX section of the program.
      ITU=0
      DO ISYM=1,mxsym
        NAO=NASH(ISYM)
        IF(NAO.GT.1) THEN
          NRAS1=NRS1(ISYM)
          NRS12=NRS2(ISYM)+NRAS1
          DO NT=2,NAO
            DO NU=1,NT-1
              ITU=ITU+1
              IZROT(ITU)=0
CSVC: check if NU<NT are included in the same gas space
              NGSSH_LO=0
              DO IGAS=1,NGAS
                NGSSH_HI=NGSSH_LO+NGSSH(IGAS,ISYM)
                IF (NU.GT.NGSSH_LO.AND.NT.LE.NGSSH_HI) THEN
                  IZROT(ITU)=1
                END IF
                NGSSH_LO=NGSSH_HI
              END DO
            END DO
          END DO
        END IF
      END DO
*---  complete the input processing -----------------------------------*
      NTOT=0
      NTOT1=0
      NTOT2=0
      NO2M=0
      NIN=0
      NAC=0
      NDELT=0
      NFROT=0
      NSEC=0
      NORBT=0
      NTOT3=0
      NTOTSP=0
      NTOT4=0
      NRS1T=0
      NRS2T=0
      NRS3T=0
      DO ISYM=1,NSYM
         NTOT=NTOT+NBAS(ISYM)
         NTOT1=NTOT1+(NBAS(ISYM)*(NBAS(ISYM)+1))/2
         NTOT2=NTOT2+NBAS(ISYM)**2
         NO2M=MAX(NO2M,NBAS(ISYM)**2)
         NRS1T=NRS1T+NRS1(ISYM)
         NRS2T=NRS2T+NRS2(ISYM)
         NRS3T=NRS3T+NRS3(ISYM)
         NFROT=NFROT+NFRO(ISYM)
         NIN=NIN+NISH(ISYM)
         NAC=NAC+NASH(ISYM)
         NDELT=NDELT+NDEL(ISYM)
         NSEC=NSEC+NSSH(ISYM)
         NORBT=NORBT+NORB(ISYM)
         NTOT3=NTOT3+(NORB(ISYM)+NORB(ISYM)**2)/2
         NTOTSP=NTOTSP+(NASH(ISYM)*(NASH(ISYM)+1)/2)
         NTOT4=NTOT4+NORB(ISYM)**2
      END DO
      NACPAR=(NAC+NAC**2)/2
      NACPR2=(NACPAR+NACPAR**2)/2
*
      Call Put_iArray('nIsh',nIsh,nSym)
      Call Put_iArray('nAsh',nAsh,nSym)

*---  Exit, end -------------------------------------------------------*
      Return
      End
      Subroutine RdPAM(Line,iNumber,rNumber)
      Implicit Real*8 (A-H,O-Z)
#include "output_ras.fh"
      Parameter (ROUTINE='RDPAM')
*
*     Subroutine read character line and
*     read one integer and later one real
      Character*72 Line

      iStart=1
      Do While ( Line(iStart:iStart).eq.' ')
         iStart=iStart+1
      End Do
      iEnd=iStart
      Do While ( Line(iEnd:iEnd)    .ne.' ')
         iEnd=iEnd+1
      End Do
c
      Read(Line(iStart:iEnd-1),*,err=10,end=20) iNumber
c
      iStart=iEnd
      Do While ( Line(iStart:iStart).eq.' ')
         iStart=iStart+1
      End Do
c
      Read(Line(iStart:72),*,err=10,end=20) rNumber
c
      Return
c
 10   continue
      Write(LF,*) 'RdPAM: I/O error while reading input file'
      call quit(_RC_INPUT_ERROR_)
 20   continue
      Write(LF,*) 'RdPAM: end of file while reading input file'
      call quit(_RC_INPUT_ERROR_)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1992, Roland Lindh                                     *
************************************************************************
      SubRoutine HrrCtl(Arr1,nArr1,Arr2,nArr2,
     &                  la,lb,lc,ld,nabMax,ncdMax,nTR,
     &                  A,B,C,D,IfGrad)
************************************************************************
*                                                                      *
* Object: to act as a shell towards the HRR subroutines.               *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Arr1(nTR,3*nArr1), Arr2(nTR,3*nArr2),
     &       A(3), B(3), C(3), D(3)
      Logical IfGrad(3,4)
*
      iRout = 233
      iPrint = nPrint(iRout)
*
      Call Hrr2Da(Arr1,nTR,nabMax,ncdMax,Arr2,A,B,la,lb,lc,ld,IfGrad)
*
      Call Hrr2Db(Arr2,nTR,       ncdMax,Arr1,C,D,la,lb,lc,ld,IfGrad)
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine o2v4(wrk,wrksize,NaGrp,NbeGrp,NaSGrp,NbeSgrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,LunAux)
! this routine does:
!
! t(u,v,bega) <- sum(a,b) [ b(a,b,be,ga) . Tau(u,v,a,b) ]
!
! b(a,b,be,ga) =             (a,be|b,ga)
!              - sum (i)   [ (a,be|b,i) . t(i,ga) ]
!              - sum (i)   [ (a,i|b,ga) . t(i,be) ]
!              + sum (i,j) [ (a,i|b,j) . t(i,be) . t(j,ga) ]
!
! Tau(u,v,ab) = t(u,v,ab) + t(i,a) . t(j,b) : stored for: i,j,a>=b
!
!
!A List of main arrays:
!
!* tau(i,j,(a,b)') - PosTau
!
!* t2n1(ij,(bega)")- PosT2n1
!  t2n2(ij,(bega)")- PosT2n2
!  t2w(ij,(ab)")   - PosT2w - work file for T(+-)
!
!* L21 (m,a',be')  - PosL21
!  L22 (m,a',ga')  - PosL22
!  L23 (m,b',be')  - PosL23
!  L24 (m,b',ga')  - PosL24
!  L2W (m,c',de')  - PosL2W - Used for Tmp file in GetCHV
!  some (or all) of L2s might be identical
!
!* M1(m,a",be")  - PosM1, used also for M(m,b'',be'')
!  M2(m,b",ga")  - PosM2, used also for M(m,a'',ga'')
!  Both Ms might be identical (mozno + M3 ako manipulacne)
!
!* W1(a",be",b",ga") - PosW1 - b(a",be"|b",ga")
!  W2(b",be",a",ga") - PosW2 - b(b",be"|a",ga")
!  Ww((ab)",(bega)") - PosWw - work file for b(+-)
!
!B list of additional arrays
!
!C list of used pre- and suffixes and assignements
!
!  _Grp         - Group
!  _SGrp        - SubGroup
!  Pos_         - Position
!  PsAc_        - Actual Position
!  (...)'       - Group, Block
!  (...)"       - SubGroup, SubBlock
!
!D list of most important variables

use Index_Functions, only: nTri_Elem
use chcc_global, only: ABID, DimGrpa, DimGrpbe, DimSGrpa, DimSGrpbe, GrpaLow, GrpbeLow, GrpaUp, GrpbeUp, intkey, L1Name, maxSGrp, &
                       nc, no, nv, PosFree, PosT1o, printkey, T2o2v4yes, Tmp3Name
use Para_Info, only: MyRank
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: wrksize, NaGrp, NbeGrp, NaSGrp, NbeSgrp, mdGrpa, mdGrpbe, mdSGrpa, mdSGrpbe, LunAux
real(kind=wp), intent(inout) :: wrk(wrksize)
integer(kind=iwp) :: adda, addb, addbe, addbepp, addga, addgapp, aGrp, aSGrp, beGrp, beSGrp, bGrp, bSGrp, bSGrpUp, choleskykey, &
                     dim_1, dim_2, dim_3, dima, dimb, dimbe, dimga, FirstT2n(maxSGrp,maxSGrp), gaGrp, gaSGrp, gaSGrpUp, i, &
                     L2Status(4,3), lent2n1, lent2n2, NL2, pL21, pL22, pL23, pL24, PosH1, PosH2, PosL11, PosL12, PosL21, PosL22, &
                     PosL23, PosL24, PosL2W, PosM1, PosM2, PosT, PosT2n1, PosT2n2, PosT2w, PosTau, PosW1, PosW2, PosWw, PosWx, &
                     PsAcL21, PsAcL22, PsAcL23, PsAcL24
character(len=6) :: LunName

if (intkey == 1) then
  choleskykey = 0
else
  choleskykey = 1
end if

! distribute memory

PosT = PosFree
call DistMemo2v4(NaGrp,NbeGrp,NaSGrp,NbeSgrp,mdGrpa,mdGrpbe,mdSGrpa,mdSGrpbe,PosTau,PosT2n1,PosT2n2,PosT2w,PosL11,PosL12,PosL21, &
                 PosL22,PosL23,PosL24,PosL2W,PosH1,PosH2,PosM1,PosM2,PosW1,PosW2,PosWw,PosWx,PosT,NL2)
if (printkey >= 10) write(u6,*) ' Last Value :',PosT,wrksize
if (PosT > wrksize) then
  !mp write(u6,*) ' Nieje dobre - o2v4, Dr. Ch. Kokotopuloss',
  write(u6,*) ' Not Enough memory in o2v4 step! Increase large and/or small segmentation ',real(PosT,kind=wp)/real(wrksize,kind=wp)
  call abend()
end if

!@@
! call Calc_Bc
!@@

! initialize L2Status

L2Status(1:NL2,:) = 0

if (NL2 == 1) then
  L2Status(1,3) = posL21
else if (NL2 == 2) then
  if (NbeGrp == 1) then
    L2Status(1,3) = posL21
    L2Status(2,3) = posL23
  else
    L2Status(1,3) = posL21
    L2Status(2,3) = posL22
  end if
else
  L2Status(1,3) = posL21
  L2Status(2,3) = posL22
  L2Status(3,3) = posL23
  L2Status(4,3) = posL24
end if

! initialize FirstT2n and Generate Tmp3Name s
!## initialize T2o2v4yes

do beGrp=1,nbeGrp
  do gaGrp=1,beGrp

    do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)
      if (beGrp == gaGrp) then
        gaSGrpUp = beSGrp
      else
        gaSGrpUp = GrpbeUp(gaGrp)
      end if
      do gaSGrp=GrpbeLow(gaGrp),gaSGrpUp

        FirstT2n(beSGrp,gaSGrp) = 1

        T2o2v4yes(beSGrp,gaSGrp) = 0

      end do
    end do

  end do
end do

! cycle over all groups of (a>=b)
adda = 0
do aGrp=1,NaGrp
  dima = DimGrpa(aGrp)

  !## test, if on this node at least one combination with this
  ! aGrp is scheduled. Skip if no
  i = sum(ABID(myRank,aGrp,1:NaGrp))

  if (i /= 0) then

    if (choleskykey == 1) then
      ! read L2W(m,i,a') <- L1(m,i,a')
      LunName = L1Name(aGrp)
      dim_1 = nc*dima*no
      call GetX(wrk(PosL2W),dim_1,LunAux,LunName,1,1)
      ! Map L11(m,a',i) <- L2W(m,i,a')
      call Map3_132(wrk(PosL2W),wrk(PosL11),nc,no,dima)
    end if

    addb = 0
    do bGrp=1,aGrp
      dimb = DimGrpa(bGrp)

      !## test, if this a'b' combination is planed to be run on this node
      if (ABID(myRank,aGrp,bGrp) /= 0) then
        if (printkey >= 10) write(u6,*) ' O2V4 MyRank, aGrp, bGrp',myRank,aGrp,bGrp

        if (choleskykey == 1) then
          ! read L12(m,b',i) <- L1(m,b',i)
          LunName = L1Name(bGrp)
          dim_1 = nc*dimb*no
          if (NaGrp > 1) then
            if (aGrp == bGrp) then
              wrk(PosL12:PosL12+dim_1-1) = wrk(PosL11:PosL11+dim_1-1)
            else
              call GetX(wrk(PosL2W),dim_1,LunAux,LunName,1,1)
              call Map3_132(wrk(PosL2W),wrk(PosL12),nc,no,dimb)
            end if
          end if
        end if

        ! read the block of  amplitudes T2((ab)',ij) for given aGrp,bGrp
        ! and make Tau from them
        call getTau(wrk(PosTau),wrk(PosT1o),aGrp,bGrp,dima,dimb,adda,addb,LunAux)

        ! cycle over all groups of (be>=ga)
        addbe = 0
        do beGrp=1,nbeGrp
          dimbe = DimGrpbe(beGrp)
          addga = 0
          do gaGrp=1,beGrp
            dimga = DimGrpbe(gaGrp)

            if (choleskykey == 1) then
              ! read Cholesky vectors
              !  L21 (m,a',be')
              !  L22 (m,a',ga')
              !  L23 (m,b',be')
              !  L24 (m,b',ga')
              call getChV(wrk,wrksize,aGrp,bGrp,beGrp,gaGrp,NL2,L2Status,pL21,pL22,pL23,pL24,PosL2W,PosL11,PosL12,LunAux)
              PsAcL21 = L2Status(pL21,3)
              PsAcL22 = L2Status(pL22,3)
              PsAcL23 = L2Status(pL23,3)
              PsAcL24 = L2Status(pL24,3)
            else
              PsAcL21 = 0
              PsAcL22 = 0
              PsAcL23 = 0
              PsAcL24 = 0
            end if

            ! cycle over all subgroups of (be>=ga)'
            addbepp = addbe
            do beSGrp=GrpbeLow(beGrp),GrpbeUp(beGrp)

              ! get H1(i,be") <- t1o(be,i)
              if (intkey == 1) call Mk_T1t(wrk(PosT1o),wrk(PosH1),DimSGrpbe(beSGrp),no,nv,addbepp)

              if (beGrp == gaGrp) then
                gaSGrpUp = beSGrp
              else
                gaSGrpUp = GrpbeUp(gaGrp)
              end if

              addgapp = addga
              do gaSGrp=GrpbeLow(gaGrp),gaSGrpUp

                ! get H2(i,ga") <- t1o(ga,i)
                if (intkey == 1) call Mk_T1t(wrk(PosT1o),wrk(PosH2),DimSGrpbe(gaSGrp),no,nv,addgapp)

                ! vanish arrays for new (final) amplitudes, if this is a
                !   first use, or read from Tmp3Name(be",ga") actual stage
                ! T2n1((bega)",ij)
                ! T2n2((bega)",ij)
                if (FirstT2n(beSGrp,gaSgrp) == 1) then
                  call VanishT2n(wrk(PosT2n1),wrk(PosT2n2),beSGrp,gaSGrp)
                  FirstT2n(beSGrp,gaSgrp) = 0
                else
                  call GetT2n(wrk(PosT2n1),wrk(PosT2n2),beSGrp,gaSGrp,LunAux)
                end if

                ! cycle over all subgroups of (a>=b)'
                do aSGrp=GrpaLow(aGrp),GrpaUp(aGrp)
                  if (aGrp == bGrp) then
                    bSGrpUp = aSGrp
                  else
                    bSGrpUp = GrpaUp(bGrp)
                  end if
                  do bSGrp=GrpaLow(bGrp),bSGrpUp
                    if (printkey >= 10) write(u6,99) aGrp,bGrp,beGrp,gaGrp,aSGrp,bSGrp,beSGrp,gaSGrp

                    if (choleskykey == 1) then

                      ! cholesky generation of (VV|VV) integrals

                      ! Extract M1(m,a",be") from L21(m,a',be')
                      call ExtractM(wrk(PosM1),wrk(PsAcL21),aGrp,beGrp,aSGrp,beSGrp)
                      ! Extract M2(m,b",ga") from L24(m,b',ga')
                      if ((aSGrp == bSGrp) .and. (beSGrp == gaSGrp)) then
                        if (PosM1 /= PosM2) then
                          dim_1 = nc*DimSGrpa(aSGrp)*DimSGrpbe(beSGrp)
                          wrk(PosM2:PosM2+dim_1-1) = wrk(PosM1:PosM1+dim_1-1)
                        end if
                      else
                        call ExtractM(wrk(PosM2),wrk(PsAcL24),bGrp,gaGrp,bSGrp,gaSGrp)
                      end if
                      ! Calc W1(a",be",b",ga")=M1(m,a",be")(T).M2(m,b",ga")
                      dim_1 = DimSGrpa(aSGrp)*DimSGrpbe(beSGrp)
                      dim_2 = DimSGrpa(bSGrp)*DimSGrpbe(gaSGrp)
                      wrk(PosW1:PosW1+dim_1*dim_2-1) = Zero
                      call mc0c1at3b(nc,dim_1,nc,dim_2,dim_1,dim_2,dim_1,nc,dim_2,wrk(posM1),wrk(posM2),wrk(posW1))

                      if (aSGrp /= bSGrp) then
                        ! Extract M1(m,b",be") from L23(m,b',be')
                        call ExtractM(wrk(PosM1),wrk(PsAcL23),bGrp,beGrp,bSGrp,beSGrp)
                        ! Extract M2(m,a",ga") from L22(m,a',ga')
                        call ExtractM(wrk(PosM2),wrk(PsAcL22),aGrp,gaGrp,aSGrp,gaSGrp)
                        ! Calc W2(b",be",a",ga")=M1(m,b",be")(T).M2(m,a",ga")
                        dim_1 = DimSGrpa(bSGrp)*DimSGrpbe(beSGrp)
                        dim_2 = DimSGrpa(aSGrp)*DimSGrpbe(gaSGrp)
                        wrk(posW2:posW2+dim_1*dim_2-1) = Zero
                        call mc0c1at3b(nc,dim_1,nc,dim_2,dim_1,dim_2,dim_1,nc,dim_2,wrk(posM1),wrk(posM2),wrk(posW2))
                      end if

                    else

                      ! clasical reading or generating of (VV|VV) integrals

                      ! term W1(a",be",b",ga") <- -(b"ga"|a"i) . T1(i,be")
                      ! Def:W1 destroy:Ww
                      ! Get Ww(b",ga",a",i) (Wx used as Aux)
                      call ReaW3(wrk(PosWw),wrk(PosWx),bSGrp,gaSGrp,aSGrp,LunAux)
                      ! Map V1(a",ga",b",i) <- Ww(b",ga",a",i)
                      call Map4_3214(wrk(PosWw),wrk(PosW1),DimSGrpa(bSGrp),DimSGrpbe(gaSGrp),DimSGrpa(aSGrp),no)
                      ! Calc Ww(a",ga",b",be") <- - W1(a",ga",b",i) . H1(i,be")
                      dim_1 = DimSGrpa(bSGrp)*DimSGrpa(aSGrp)*DimSGrpbe(gaSGrp)
                      dim_2 = DimSGrpbe(beSGrp)
                      wrk(PosWw:PosWw+dim_1*dim_2-1) = Zero
                      call mc0c2a3b(dim_1,no,no,dim_2,dim_1,dim_2,dim_1,no,dim_2,wrk(PosW1),wrk(PosH1),wrk(PosWw))
                      ! Map W1(a",be",b",ga") <<- Ww(a",ga",b",be")
                      call Map4_1432(wrk(PosWw),wrk(PosW1),DimSGrpa(aSGrp),DimSGrpbe(gaSGrp),DimSGrpa(bSGrp),DimSGrpbe(beSGrp))

                      ! term W1(a",be",b",ga") <<- -(a"be"|b"i) . T1(i,ga")
                      ! Upgrade: W1, destroy: Ww
                      ! Get Ww(a",be",b",i) (Wx used as Aux)
                      call ReaW3(wrk(PosWw),wrk(PosWx),aSGrp,beSGrp,bSGrp,LunAux)
                      ! Add W1(a",be",b",ga") <<- - Ww(a",be",b",i) . H2(i,ga")
                      dim_1 = DimSGrpa(aSGrp)*DimSGrpa(bSGrp)*DimSGrpbe(beSGrp)
                      dim_2 = DimSGrpbe(gaSGrp)
                      call mc0c2a3b(dim_1,no,no,dim_2,dim_1,dim_2,dim_1,no,dim_2,wrk(PosWw),wrk(PosH2),wrk(PosW1))

                      ! Upgrade W1(a",be",b",ga") <<- (a",be"|b",ga")
                      ! Upgrade:W1 destroy:Ww
                      call ReaW4(wrk(PosW1),wrk(PosWw),aSGrp,beSGrp,bSGrp,gaSGrp,LunAux)

                      if (aSGrp /= bSGrp) then

                        ! term W2(b",be",a",ga") <- -(a"ga"|b"i) . T1(i,ga")
                        ! Def:W2 destroy: Ww
                        ! Get Ww(a",ga",b",i) (Wx used as Aux)
                        call ReaW3(wrk(PosWw),wrk(PosWx),aSGrp,gaSGrp,bSGrp,LunAux)
                        ! Map W2(b",ga",a",i) <- Ww(a",ga",b",i) @@Nepreskusany
                        call Map4_3214(wrk(PosWw),wrk(PosW2),DimSGrpa(aSGrp),DimSGrpbe(gaSGrp),DimSGrpa(bSGrp),no)
                        ! Calc Ww(b",ga",a",be") <- -W2(b",ga",a",i) . H1(i,be")
                        dim_1 = DimSGrpa(aSGrp)*DimSGrpbe(gaSGrp)*DimSGrpa(bSGrp)
                        dim_2 = DimSGrpbe(beSGrp)
                        wrk(PosWw:PosWw+dim_1*dim_2-1) = Zero
                        call mc0c2a3b(dim_1,no,no,dim_2,dim_1,dim_2,dim_1,no,dim_2,wrk(PosW2),wrk(PosH1),wrk(PosWw))
                        ! Map W2 (b",be",a",ga") <- Ww(b",ga",a",be")
                        call Map4_1432(wrk(PosWw),wrk(PosW2),DimSGrpa(bSGrp),DimSGrpbe(gaSGrp),DimSGrpa(aSGrp),DimSGrpbe(beSGrp))

                        ! term W2(b",be",a",ga") <<- -(b"be"|a"i) . T1(i,ga")
                        ! Upgrade:W2 destroy: 0
                        ! Get Ww(b",be",a",i) (Wx used as Aux)
                        call ReaW3(wrk(PosWw),wrk(PosWx),bSGrp,beSGrp,aSGrp,LunAux)
                        ! Add W2(b",be",a",ga") <<- - Ww(b",be",a",i) .H2(i,ga")
                        dim_1 = DimSGrpa(aSGrp)*DimSGrpa(bSGrp)*DimSGrpbe(beSGrp)
                        dim_2 = DimSGrpbe(gaSGrp)
                        call mc0c2a3b(dim_1,no,no,dim_2,dim_1,dim_2,dim_1,no,dim_2,wrk(PosWw),wrk(PosH2),wrk(PosW2))

                        ! Add W2(b",be",a",ga") <<- (b",be"Ia",ga")
                        ! Upgrade:W2, destroy:Ww
                        call ReaW4(wrk(PosW2),wrk(PosWw),bSGrp,beSGrp,aSGrp,gaSGrp,LunAux)
                      end if

                    end if

                    ! Make t2w(+)((ab)",ij) from Tau((ab)',ij)
                    call MakeT2p(wrk(PosT2w),wrk(PosTau),aGrp,bGrp,aSGrp,bSGrp,1)
                    ! Make Ww(+)((ab)",(bega)") from W1(a",be",b",ga")
                    !                            and W2(b",be",a",ga")
                    !      N.B. for a"=b" we have only W1 defined (=W2)
                    !           but never mind (solved within MakeWw)
                    call MakeWw(wrk(PosWw),wrk(PosW1),wrk(PosW2),aSGrp,bSGrp,beSGrp,gaSGrp,1)
                    ! Add T2n1((bega)",ij) <<-
                    ! Ww(+)(T)((ab)",(bega)").t2w(+)((ab)",ij)
                    dim_1 = nTri_Elem(no)
                    if (aSGrp == bSGrp) then
                      dim_2 = DimSGrpa(aSGrp)*(DimSGrpa(bSGrp)-1)/2
                    else
                      dim_2 = DimSGrpa(aSGrp)*DimSGrpa(bSGrp)
                    end if
                    if (beSGrp == gaSGrp) then
                      dim_3 = DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/2
                    else
                      dim_3 = DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
                    end if
                    call mc0c1at3b(dim_2,dim_3,dim_2,dim_1,dim_3,dim_1,dim_3,dim_2,dim_1,wrk(posWw),wrk(posT2w),wrk(posT2n1))

                    if (aSGrp == bSGrp) then
                      ! Make t2w(+)((aa)",ij) from Tau((ab)',ij)
                      call MakeT2pd(wrk(PosT2w),wrk(PosTau),aGrp,aSGrp)
                      ! Make  Ww(+)((aa)",(bega)") from W1(a",be",a",ga")
                      call MakeWwd(wrk(PosWw),wrk(PosW1),aSGrp,beSGrp,gaSGrp)
                      ! Add T2n1((bega)",ij) <<-
                      ! Ww(+)(T)((aa)",(bega)").t2w(+)((aa)",ij)
                      dim_1 = nTri_Elem(no)
                      dim_2 = DimSGrpa(aSGrp)
                      if (beSGrp == gaSGrp) then
                        dim_3 = DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/2
                      else
                        dim_3 = DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
                      end if
                      call mc0c1at3b(dim_2,dim_3,dim_2,dim_1,dim_3,dim_1,dim_3,dim_2,dim_1,wrk(posWw),wrk(posT2w),wrk(posT2n1))
                    end if

                    ! Make t2w(-)((ab)",ij) from Tau((ab)',ij)
                    call MakeT2m(wrk(PosT2w),wrk(PosTau),aGrp,bGrp,aSGrp,bSGrp,1)
                    ! Make Ww(-)((ab)",(bega)") from W1(a",be",b",ga")
                    !                            and W2(b",be",a",ga")
                    !           but never mind (solved within MakeWw)
                    call MakeWw(wrk(PosWw),wrk(PosW1),wrk(PosW2),aSGrp,bSGrp,beSGrp,gaSGrp,2)
                    !write(u6,*) 'V'
                    ! Add T2n2((bega)",ij) <<-
                    ! Ww(-)(T)((ab)",(bega)").t2w(-)((ab)",ij)
                    dim_1 = nTri_Elem(no-1)
                    if (aSGrp == bSGrp) then
                      dim_2 = DimSGrpa(aSGrp)*(DimSGrpa(bSGrp)-1)/2
                    else
                      dim_2 = DimSGrpa(aSGrp)*DimSGrpa(bSGrp)
                    end if
                    if (beSGrp == gaSGrp) then
                      dim_3 = DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)-1)/2
                    else
                      dim_3 = DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
                    end if
                    call mc0c1at3b(dim_2,dim_3,dim_2,dim_1,dim_3,dim_1,dim_3,dim_2,dim_1,wrk(posWw),wrk(posT2w),wrk(posT2n2))

                    ! end cycle over all subgroups of (a>=b)'
                  end do
                end do

                ! Save T2n1(bega)",ij) and T2n2((bega)",ij)
                !      in recreated form, corresponding to standard
                !      storage in T2 amplitudes
                LunName = Tmp3Name(beSGrp,gaSGrp)
                if (beSGrp == gaSGrp) then
                  lent2n1 = nTri_Elem(no)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)+1)/2
                  lent2n2 = nTri_Elem(no-1)*DimSGrpbe(beSGrp)*(DimSGrpbe(gaSGrp)-1)/2
                else
                  lent2n1 = nTri_Elem(no)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
                  lent2n2 = nTri_Elem(no-1)*DimSGrpbe(beSGrp)*DimSGrpbe(gaSGrp)
                end if
                T2o2v4yes(beSGrp,gaSGrp) = 1
                call SaveX(wrk(PosT2n1),lent2n1,LunAux,LunName,1,0)
                call SaveX(wrk(PosT2n2),lent2n2,LunAux,LunName,0,1)

                ! end cycle over all subgroups of (be>=ga)'
                addgapp = addgapp+DimSGrpbe(gaSGrp)
              end do
              addbepp = addbepp+DimSGrpbe(beSGrp)
            end do

            ! end cycle over all groups of (be>=ga)
            addga = addga+dimga
          end do
          addbe = addbe+dimbe
        end do

      end if
      ! end cycle over all groups of (a>=b)
      addb = addb+dimb
    end do
  end if
  adda = adda+dima
end do

return

99 format(8(i3,1x))

end subroutine o2v4

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine findamx_cvb(vec,n,vmx,imx)
      implicit real*8 (a-h,o-z)
      dimension vec(n)

      if(n.gt.0)then
      imx=1
      vmx=abs(vec(1))
      do 100 i=2,n
      if(abs(vec(i)).gt.vmx)then
        imx=i
        vmx=abs(vec(i))
      endif
100   continue
      else
        imx=0
        vmx=0d0
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine m1kernel(rFinal,Hess,nHess,DAO,nDAO,iAng,nRys,nZeta,Alpha,Beta,Zeta,rKappa,P,TC,Coor,CoorAc,Array,nArray,ifgrd,indgrd, &
                    ifhss,indhss,ifg,tr,nop,iuvwx,kCnttp,fact,loper,idcar)

use Index_Functions, only: nTri_Elem1
use Basis_Info, only: dbsc
use Symmetry_Info, only: nIrrep
use Constants, only: One, Two, Pi
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nHess, nDAO, iAng(4), nRys, nZeta, nArray, indgrd(3,4,0:7), indhss(3,4,3,4,0:7), nop(4), &
                                 iuvwx(4), kCnttp, loper, idcar
real(kind=wp), intent(inout) :: rFinal(*), Hess(nHess)
real(kind=wp), intent(in) :: DAO(nZeta,nDAO), Alpha(nZeta), Beta(nZeta), Zeta(nZeta), rKappa(nZeta), P(nZeta,3), TC(3), Coor(3,4), &
                             CoorAC(3,2), fact
real(kind=wp), intent(out) :: Array(nArray)
logical(kind=iwp), intent(in) :: ifgrd(3,4), ifhss(3,4,3,4), ifg(4)
logical(kind=iwp), intent(inout) :: tr(4)
integer(kind=iwp) :: iDAO, iElem, iM1xp, indi, Indx(3,4), ip, ipDAO, ipDAOt, ipK, ipPx, ipPy, ipPz, ipZ, ipZI, iZeta, &
                     jndgrd(3,4,0:7), jndhss(3,4,3,4,0:7), nb, nGr
real(kind=wp) :: coori(3,4), FactECP, Gmma, PTC2, Tmp0, Tmp1
logical(kind=iwp) :: jfg(4), jfgrd(3,4), jfhss(3,4,3,4), lGrad, lHess
logical(kind=iwp), external :: EQ
external :: Cff2D, Fake, TNAI1

lGrad = idcar /= 0
lHess = nHess /= 0
coori(:,:) = coor
if ((.not. EQ(coor(1,1),coor(1,2))) .or. (.not. EQ(coor(1,1),coor(1,3)))) then
  Coori(1,1) = Coori(1,1)+One
end if

ip = 1
ipK = ip
ip = ip+nZeta
ipZ = ip
ip = ip+nZeta
ipZI = ip
ip = ip+nZeta
ipPx = ip
ip = ip+nZeta
ipPy = ip
ip = ip+nZeta
ipPz = ip
ip = ip+nZeta
ipDAO = ip
ip = ip+nDAO*nZeta
if (ip >= narray) then
  write(u6,*) 'Out of memory in m1kernel (',narray,',',ip,')'
  call Abend()
end if

#ifdef _DEBUGPRINT_
write(u6,*) 'nM1=',dbsc(kCnttp)%nM1,'kCnttp=',kCnttp
#endif

do iM1xp=1,dbsc(kCnttp)%nM1
  Gmma = dbsc(kCnttp)%M1xp(iM1xp)
  FactECP = dbsc(kCnttp)%M1cf(iM1xp)*Fact

# ifdef _DEBUGPRINT_
  write(u6,*) 'Fact=',FactECP,Fact
  write(u6,*) 'im1xp=',iM1xp
  write(u6,*) 'Gamma=',Gmma
# endif

  ! Modify the original basis. Observe that
  ! simplification due to A=B are not valid for the
  ! exponent index, eq. P-A=/=0.

  do iZeta=1,nZeta
    PTC2 = (P(iZeta,1)-TC(1))**2+(P(iZeta,2)-TC(2))**2+(P(iZeta,3)-TC(3))**2
    Tmp0 = Zeta(iZeta)+Gmma
    Tmp1 = exp(-Zeta(iZeta)*Gmma*PTC2/Tmp0)
    Array(ipK+iZeta-1) = rKappa(iZeta)*Tmp1
    Array(ipZ+iZeta-1) = Tmp0
    Array(ipZI+iZeta-1) = One/Tmp0
    Array(ipPx+iZeta-1) = (Zeta(iZeta)*P(iZeta,1)+Gmma*TC(1))/Tmp0
    Array(ipPy+iZeta-1) = (Zeta(iZeta)*P(iZeta,2)+Gmma*TC(2))/Tmp0
    Array(ipPz+iZeta-1) = (Zeta(iZeta)*P(iZeta,3)+Gmma*TC(3))/Tmp0
  end do

  do iDAO=1,nDAO
    ipDAOt = ipDAO+nZeta*(iDAO-1)
    Array(ipDAOt:ipDAOt+nZeta-1) = FactECP*Array(ipK:ipK+nZeta-1)*Array(ipZI:ipZI+nZeta-1)*Two*Pi*DAO(:,iDAO)
  end do

  ! Compute integrals with the Rys quadrature.

  jfg(:) = ifg

  jfgrd(:,:) = ifgrd
  jfhss(:,:,:,:) = ifhss

  jndgrd(:,:,0:nirrep-1) = indgrd(:,:,0:nirrep-1)
  jndhss(:,:,:,:,0:nirrep-1) = indhss(:,:,:,:,0:nirrep-1)

  call Rysg2(iAng,nRys,nZeta,Alpha,Beta,[One],[One],Array(ipZ),Array(ipZI),nZeta,[One],[One],1,Array(ipPx),nZeta,TC,1,Coori,Coor, &
             CoorAC,Array(ip),nArray-ip+1,TNAI1,Fake,Cff2D,Array(ipDAO),nDAO,Hess,nHess,jfGrd,jndGrd,jfHss,jndHss,nOp,iuvwx,jfg, &
             nGr,Indx,lgrad,lhess,tr)
  if (lGrad) then
    nb = nzeta*nTri_Elem1(iAng(1))*nTri_Elem1(iAng(2))
    do iElem=1,nTri_Elem1(iAng(1))*nTri_Elem1(iAng(2))*ngr
      indi = ip+(iElem-1)*nZeta
      Array(indi:indi+nZeta-1) = FactECP*Two*PI*Array(ipK:ipK+nZeta-1)*Array(ipZI:ipZI+nZeta-1)*Array(indi:indi+nZeta-1)
    end do

    call SmAdNa(Array(ip),nb,rFinal,nop(1:3),loper,jndGrd,iuvwx(1:3),Indx,idcar,One,tr)
  end if

end do

return

end subroutine m1kernel

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine read_rassisd()
!***********************************************************************
! Purpose :  In case of charge migration read in the complex
!            hamiltonian from the MOLCAS output rassisd file (SO)
!***********************************************************************

use rhodyn_data, only: dipole, dysamp, E_SF, E_SO, flag_dyson, flag_so, HSOCX, ipglob, lrootstot, Nstate, runmode, SO_CI, V_SO
use rhodyn_utils, only: dashes
use mh5, only: mh5_close_file, mh5_exists_dset, mh5_fetch_dset, mh5_open_file_r
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, fileid
real(kind=wp), allocatable :: DIPI(:,:,:), DIPR(:,:,:), tmpe(:), tmpi(:,:), tmpr(:,:)

if (ipglob > 3) then
  call dashes()
  write(u6,*) 'Reading RASSI file'
  call dashes()
end if

fileid = mh5_open_file_r('RASSISD')

if (runmode == 4) then
  if (flag_so) then
    ! reading complex Hamiltonian (already with SOC included)
    ! so far needed only for charge migration case
    ! take care of dimensions!
    call mma_allocate(tmpr,Nstate,Nstate)
    call mma_allocate(tmpi,Nstate,Nstate)
    if (mh5_exists_dset(fileid,'CH_SO_REAL') .and. mh5_exists_dset(fileid,'CH_SO_IMAG')) then
      call mh5_fetch_dset(fileid,'CH_SO_REAL',tmpr)
      call mh5_fetch_dset(fileid,'CH_SO_IMAG',tmpi)
    else if (mh5_exists_dset(fileid,'HSO_MATRIX_REAL') .and. mh5_exists_dset(fileid,'HSO_MATRIX_IMAG')) then
      ! if using standard rassi dsets in rassi.h5
      call mh5_fetch_dset(fileid,'HSO_MATRIX_REAL',tmpr)
      call mh5_fetch_dset(fileid,'HSO_MATRIX_IMAG',tmpi)
    else
      write(u6,*) 'Error in reading RASSI file, no CH_SO_REAL matrix,'
      write(u6,*) 'nor HSO_MATRIX_REAL/IMAG datasets'
      call abend()
    end if
    HSOCX(:,:) = cmplx(tmpr,tmpi,kind=wp)
    if (allocated(tmpr)) call mma_deallocate(tmpr)
    if (allocated(tmpi)) call mma_deallocate(tmpi)
    ! filling in energies
    do i=1,Nstate
      E_SO(i) = HSOCX(i,i)
    end do
  else ! if flag_so is off
    write(u6,*) 'Reading SF energies SFS_ENERGIES and construct H'
    if (mh5_exists_dset(fileid,'SFS_ENERGIES')) then
      call mma_allocate(tmpe,Nstate)
      call mh5_fetch_dset(fileid,'SFS_ENERGIES',tmpe)
      E_SF(:) = tmpe
      call mma_deallocate(tmpe)
    else
      write(u6,*) 'Error in reading RASSI file, no SFS_ENERGIES'
      call abend()
    end if
    do i=1,Nstate
      HSOCX(i,i) = E_SF(i)
    end do
  end if
end if

! reading pure SOC matrix in SF basis
if ((runmode /= 4) .and. flag_so) then
  call mma_allocate(tmpr,lrootstot,lrootstot)
  call mma_allocate(tmpi,lrootstot,lrootstot)
  if (mh5_exists_dset(fileid,'V_SO_REAL') .and. mh5_exists_dset(fileid,'V_SO_IMAG')) then
    call mh5_fetch_dset(fileid,'V_SO_REAL',tmpr)
    call mh5_fetch_dset(fileid,'V_SO_IMAG',tmpi)
  else
    write(u6,*) 'Error in reading RASSISD file, no V_SO matrix'
    call abend()
  end if
  V_SO(:,:) = cmplx(tmpr,tmpi,kind=wp)
  if (allocated(tmpr)) call mma_deallocate(tmpr)
  if (allocated(tmpi)) call mma_deallocate(tmpi)
end if

! reading SOC coefficients
if (flag_so) then
  call mma_allocate(tmpr,lrootstot,lrootstot)
  call mma_allocate(tmpi,lrootstot,lrootstot)
  if (mh5_exists_dset(fileid,'SOCOEFF_REAL') .and. mh5_exists_dset(fileid,'SOCOEFF_IMAG')) then
    call mh5_fetch_dset(fileid,'SOCOEFF_REAL',tmpr)
    call mh5_fetch_dset(fileid,'SOCOEFF_IMAG',tmpi)
  else if (mh5_exists_dset(fileid,'SOS_COEFFICIENTS_REAL') .and. mh5_exists_dset(fileid,'SOS_COEFFICIENTS_IMAG')) then
    ! if using standard rassi dsets of rassi.h5
    call mh5_fetch_dset(fileid,'SOS_COEFFICIENTS_REAL',tmpr)
    call mh5_fetch_dset(fileid,'SOS_COEFFICIENTS_IMAG',tmpi)
  else
    write(u6,*) 'Error in reading RASSI file, no SOCOEFF matrix'
    call abend()
  end if
  SO_CI(:,:) = cmplx(tmpr,tmpi,kind=wp)
  if (allocated(tmpr)) call mma_deallocate(tmpr)
  if (allocated(tmpi)) call mma_deallocate(tmpi)
end if

! matrices of dipole moments
call mma_allocate(DIPR,lrootstot,lrootstot,3)
call mma_allocate(DIPI,lrootstot,lrootstot,3)
if (flag_so) then
  if (mh5_exists_dset(fileid,'SOS_EDIPMOM_REAL') .and. mh5_exists_dset(fileid,'SOS_EDIPMOM_IMAG')) then
    call mh5_fetch_dset(fileid,'SOS_EDIPMOM_REAL',DIPR)
    call mh5_fetch_dset(fileid,'SOS_EDIPMOM_IMAG',DIPI)
  else
    write(u6,*) 'Error in reading RASSISD file, no dipole matrix in SO basis'
    call abend()
  end if
else ! to read SFS_EDIPMOM (flag_so = off)
  if (mh5_exists_dset(fileid,'SFS_EDIPMOM')) then
    call mh5_fetch_dset(fileid,'SFS_EDIPMOM',DIPR)
    DIPI = Zero
  else
    write(u6,*) 'Error in reading RASSISD file, no dipole matrix in SF basis'
    call abend()
  end if
end if
!write(u6,*) 'dysorb read'
if (mh5_exists_dset(fileid,'DYSORB') .and. flag_dyson) then
  call mh5_fetch_dset(fileid,'DYSORB',dysamp)
else if (mh5_exists_dset(fileid,'DYSAMP') .and. flag_dyson) then
  call mh5_fetch_dset(fileid,'DYSAMP',dysamp)
else
  if (ipglob > 2) then
    write(u6,*) 'Ionization is not taken into account (set flag DYSO)'
    write(u6,*) ' and/or RASSI file does not contain Dyson amplitudes'
    flag_dyson = .false.
  end if
end if
!write(u6,*) 'dysorb has been read'
dipole(:,:,:) = cmplx(DIPR,DIPI,kind=wp)
if (allocated(DIPR)) call mma_deallocate(DIPR)
if (allocated(DIPI)) call mma_deallocate(DIPI)

call mh5_close_file(fileid)

end subroutine read_rassisd

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2001-2016, Valera Veryazov                             *
************************************************************************
c
c     program test
c         integer strnln
c         character out*256
c         call prgminit("seward  ")
cc         call prgmreport
c         call prgmtranslate("ORDINT7",out)
c         l=strnln(out)
c         print *,'>',out(1:l),'<'
c         call prgmfree
c         end
         subroutine prgminit(module)
#ifndef _HAVE_EXTRA_
         Use Prgm
#endif
         character*(*) module
         l=len(module)
c         print *,l
         call prgminitc(module,l)
         return
         end
         subroutine prgmtranslate(in,out,lout)
         character*(*) in, out
#ifdef _DEBUGPRINT_IO_
         character LL*128
#endif
         Integer Strnln
         External Strnln
         lin=Strnln(in)
         out=' '
         if(index(in,'/').ne.0) then
c just in case if we processing translated name!
         out=in
         lout=lin
         else
         call prgmtranslatec(in,lin,out,lout,1)
         endif
         out=out(1:lout)
#ifdef _DEBUGPRINT_IO_
         LL='QWERTYUIOPASDFGHJKLZXCVBNM1234567890'//
     *           'qwertyuiopasdfghjklzxcvbnm /.-_*'

c         print *, 'Translate: >', in(1:lin),'< to >',out(1:lout),'<'
          do i=1,lin
            if(index(LL,in(i:i)).eq.0) then
         write(6,*) 'Translate: >', in(1:lin),'< to >',out(1:lout),'<'
         write(6,*) 'invalid in:',in(i:i),'<'
             call abend
             endif
          enddo
          do i=1,lout
            if(index(LL,out(i:i)).eq.0) then
         write(6,*) 'Translate: >', in(1:lin),'< to >',out(1:lout),'<'
         write(6,*) 'invalid out:',out(i:i),'<'
             call abend
            endif
          enddo
#endif
         return
         end
         subroutine prgmtranslate_master(in,out,lout)
         character*(*) in, out
         Integer Strnln
         External Strnln
         lin=Strnln(in)
         out=' '
         if(index(in,'/').ne.0) then
c just in case if we processing translated name!
         out=in
         lout=lin
         else
         call prgmtranslatec(in,lin,out,lout,0)
         endif
         out=out(1:lout)
         return
         end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_SETDAMP()
!
! Purpose: set screening damping, unless user-defined.

use Cholesky, only: Damp, ThrCom
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: I

do I=1,2
  if (DAMP(I) < Zero) then
    if (THRCOM > 9.99e-3_wp) then ! >= 1.0e-2
      DAMP(I) = 1.0e7_wp
    else if (THRCOM > 9.99e-4_wp) then ! >= 1.0e-3
      DAMP(I) = 1.0e6_wp
    else if (THRCOM > 9.99e-5_wp) then ! >= 1.0e-4
      DAMP(I) = 1.0e5_wp
    else if (THRCOM > 9.99e-6_wp) then ! >= 1.0e-5
      DAMP(I) = 1.0e4_wp
    else if (THRCOM > 9.99e-7_wp) then ! >= 1.0e-6
      DAMP(I) = 1.0e3_wp
    else if (THRCOM > 9.99e-8_wp) then ! >= 1.0e-7
      DAMP(I) = 1.0e2_wp
    else if (THRCOM > 9.99e-9_wp) then ! >= 1.0e-8
      DAMP(I) = 1.0e1_wp
    else
      DAMP(I) = One
    end if
  end if
end do

end subroutine CHO_SETDAMP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Steven Vancoillie                                      *
!***********************************************************************

subroutine RHSOD_C(IVEC)

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use SUPERINDEX, only: KTUV, MTREL, MTUV
use CHOVEC_IO, only: ChoVec_Read, ChoVec_Size, NVTOT_CHOSYM
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use GA_Wrapper, only: DBL_MB
#else
use fake_GA, only: GA_Arrays
#endif
use caspt2_global, only: FIMO, iPrGlb
use caspt2_module, only: NACTEL, NAES, NASH, NASHT, NASUP, NISH, NISUP, NORB, NSSH, NSYM, NTUVES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IVEC
integer(kind=iwp) :: IA, IAEND, IASTA, IAT, IATOT, ICASE, IDX, IIEND, IISTA, IOBRA(8,8), IOFFAT, IOFFVX, IOKET(8,8), ISYA, ISYM, &
                     ISYT, ISYV, ISYX, IT, ITABS, ITTOT, ITVV, ITVX, ITVXTOT, IUABS, IUUT, IV, IVABS, IVX, IX, IXABS, lg_W, MW, &
                     NAS, NBRA, NFIMOES, NIS, NKET, NV, NW
real(kind=wp) :: ADDONE, ATVX, FAT, SUMU
real(kind=wp), allocatable :: BRA(:), KET(:)
real(kind=wp), external :: DDot_

if (iPrGlb >= DEBUG) write(u6,*) 'RHS on demand: case C'

!***********************************************************************
! Case C:
!   RHS(tvx,a)=(at,vx)+(FIMO(a,t)-Sum_u(au,ut))*delta(v,x)/NACTEL
!***********************************************************************

!***********************************************************************
!SVC: read in all the cholesky vectors (need all symmetries)
!***********************************************************************
call CHOVEC_SIZE(3,NBRA,IOBRA)
call CHOVEC_SIZE(2,NKET,IOKET)

call mma_allocate(BRA,NBRA,LABEL='BRA')
call mma_allocate(KET,NKET,LABEL='KET')

call CHOVEC_READ(3,BRA,NBRA)
call CHOVEC_READ(2,KET,NKET)

ICASE = 4
!***********************************************************************
! outer loop over symmetry blocks in the RHS
!***********************************************************************
NFIMOES = 0
do ISYM=1,NSYM

  NAS = NASUP(ISYM,ICASE) !NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE) !NISUP(ISYM,ICASE)
  NW = NAS*NIS

  if (NW == 0) then
    NFIMOES = NFIMOES+nTri_Elem(NORB(ISYM))
    cycle
  end if

  call RHS_ALLO(NAS,NIS,lg_W)
  call RHS_ACCESS(NAS,NIS,lg_W,IASTA,IAEND,IISTA,IIEND,MW)

  !*********************************************************************
  ! inner loop over RHS elements in symmetry ISYM
  !*********************************************************************
  do IA=IISTA,IIEND
    ISYA = ISYM
    do ITVX=IASTA,IAEND ! these are always all elements
      ITVXTOT = ITVX+NTUVES(ISYM)
      ITABS = MTUV(1,ITVXTOT)
      IVABS = MTUV(2,ITVXTOT)
      IXABS = MTUV(3,ITVXTOT)
      IT = MTREL(1,ITABS)
      ISYT = MTREL(2,ITABS)
      IV = MTREL(1,IVABS)
      ISYV = MTREL(2,IVABS)
      IX = MTREL(1,IXABS)
      ISYX = MTREL(2,IXABS)
      ! compute integrals (at,vx)
      NV = NVTOT_CHOSYM(Mul(ISYA,ISYT)) ! JSYM=ISYT*ISYI=ISYU*ISYV
      IAT = IA-1+NSSH(ISYA)*(IT-1)
      IVX = IV-1+NASH(ISYV)*(IX-1)
      IOFFAT = 1+IOBRA(ISYA,ISYT)+NV*IAT
      IOFFVX = 1+IOKET(ISYV,ISYX)+NV*IVX
      ATVX = DDOT_(NV,BRA(IOFFAT),1,KET(IOFFVX),1)

      ! W(tvx,a) = (at,vx) + (FIMO(a,t)-Sum_u(au,ut))*delta(v,x)/NACTEL
      ! write element W(tvx,j), only the (at,vx) part
      IDX = ITVX+NAS*(IA-IISTA)
#     ifdef _MOLCAS_MPP_
      DBL_MB(MW+IDX-1) = ATVX
#     else
      GA_arrays(lg_w)%A(IDX) = ATVX
#     endif
    end do
    ! now, add in the part with corrections to the integrals
    IATOT = IA+NISH(ISYM)+NASH(ISYM)
    do IT=1,NASH(ISYM)
      ITTOT = IT+NISH(ISYM)
      FAT = FIMO(NFIMOES+iTri(IATOT,ITTOT))
      SUMU = Zero
      ITABS = NAES(ISYM)+IT
      do IUABS=1,NASHT
        IUUT = KTUV(IUABS,IUABS,ITABS)-NTUVES(ISYM)
        IDX = IUUT+NAS*(IA-IISTA)
#       ifdef _MOLCAS_MPP_
        SUMU = SUMU+DBL_MB(MW+IDX-1)
#       else
        SUMU = SUMU+GA_Arrays(lg_W)%A(IDX)
#       endif
      end do
      ADDONE = (FAT-SUMU)/real(max(1,NACTEL),kind=wp)
      do IVABS=1,NASHT
        ITVV = KTUV(ITABS,IVABS,IVABS)-NTUVES(ISYM)
        IDX = ITVV+NAS*(IA-IISTA)
#       ifdef _MOLCAS_MPP_
        DBL_MB(MW+IDX-1) = DBL_MB(MW+IDX-1)+ADDONE
#       else
        GA_Arrays(lg_w)%A(IDX) = GA_Arrays(lg_w)%A(IDX)+ADDONE
#       endif
      end do
    end do
  end do
  !*********************************************************************

  call RHS_RELEASE_UPDATE(lg_W,IASTA,IAEND,IISTA,IIEND)
  call RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
  call RHS_FREE(lg_W)

  NFIMOES = NFIMOES+nTri_Elem(NORB(ISYM))

end do
!***********************************************************************

call mma_deallocate(BRA)
call mma_deallocate(KET)

end subroutine RHSOD_C

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
************************************************************************
      Subroutine Rd2Int_MCPDFT
************************************************************************
*                                                                      *
*     Read header of the two-electron integral file                    *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M.P. Fuelscher                                                   *
*     University of Lund, Sweden, 1993                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Integer nSymX,nBasX(8)
*----------------------------------------------------------------------*
*     Start                                                            *
*----------------------------------------------------------------------*
      iRc=-1
      Call GetOrd(iRc,lSquare,nSymX,nBasX,nSkipX)
      If (iRc.ne.0) Then
        Write(LF,*)'RD2INT Error: Failed to read from ORDINT file.'
        Write(LF,*)'RASSCF tried to read two-electron integrals from'
        Write(LF,*)'the ORDINT file, but failed. Something is wrong'
        Write(LF,*)'with the file. Perhaps it is missing?'
*        Call Quit(20)
        Call Quit_OnUserError()
      End If
      If ( nSymX.ne.nSym ) Then
        Write(LF,*)'RD2INT Error: Wrong size of symmetry group.'
        Write(LF,*)'RASSCF tried to use two-electron integrals from'
        Write(LF,*)'a file that was evidently created for some other'
        Write(LF,*)'program run.'
        Write(LF,'(1x,a,2i8)')'nSymX,nSym:',nSymX,nSym
*        Call Quit(20)
        Call Quit_OnUserError()
      End If
      IERR=0
      Do iSym=1,nSym
         If ( nBas(iSym).ne.nBasX(iSym) ) IERR=1
      End Do
      If ( IERR.eq.1 ) Then
        Write(LF,*)'RD2INT Error: Wrong nr of basis functions.'
        Write(LF,*)'RASSCF tried to use two-electron integrals from'
        Write(LF,*)'a file that was evidently created for some other'
        Write(LF,*)'program run.'
        Write(LF,'(1x,a,8i8)')'nBas :',(nBas(i),i=1,nSym)
        Write(LF,'(1x,a,8i8)')'nBasX:',(nBasX(i),i=1,nSym)
*        Call Quit(20)
        Call Quit_OnUserError()
      End If
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Bernd Artur Hess                                 *
!***********************************************************************

subroutine RELOP()
! SUBROUTINE RELOP INITIALIZES THE COMMON BLOCK USED BY
! THE RELOP PACKAGE
! V 1.0 - 12.3.86 - BERND HESS

use crelop, only: GA, IMAX
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp) :: N
real(kind=wp), external :: GAM

IMAX = size(GA)
do N=1,IMAX
  GA(N) = GAM(N-1)
end do

return

end subroutine RELOP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine INT7(I,K,L,IDIAG,BUFOUT,INDOUT,ICAD,IBUFL,KBUF,NTPB)
! I < L  I == K  J == L

use guga_global, only: COUP, IADD11, ICOUP, ICOUP1, ILIM, IJ, IRC, IV0, IVF0, IWAY, IX, J1, J2, JM, JM1, JNDX, LNP, Lu_11, MXVERT
use Constants, only: Half
use Definitions, only: wp, iwp, RtoI

implicit none
integer(kind=iwp), intent(in) :: I, K, L, IDIAG, ICAD(*), KBUF, NTPB
real(kind=wp), intent(inout) :: BUFOUT(*)
integer(kind=iwp), intent(inout) :: INDOUT(*), IBUFL(*)
integer(kind=iwp) :: IAD110, ICP, ICPP, ICQ, IDIV, IJJ, IN_, IPOS, ISTOP, ISU, ISUM, IT1, IT2, ITAIL, ITT, ITURN, ITYP, IVL, JND1, &
                     KBUF0, KBUF1, KBUF2, KM, LJ, LJM, LJS, NBN
logical(kind=iwp) :: first

IJJ = 0 ! dummy initialize
KBUF0 = RtoI*KBUF
KBUF1 = KBUF0+KBUF+1
KBUF2 = KBUF1+1
IDIV = RtoI
ITYP = 0
if (IDIAG == 1) IJJ = L*(L-1)/2+K
LJS = IJ(L+1)+1
LJM = IJ(L)
do ITT=1,ILIM
  IT1 = (ITT-1)*MXVERT
  IT2 = IT1
  do LJ=LJS,LJM
    ITURN = 0
    if (IDIAG == 1) ITURN = 1
    IWAY(L) = 1
    loop_1: do
      KM = L
      J2(KM+1) = LJ
      J1(KM+1) = LJ
      JM(KM) = IVF0+1
      JM1(KM) = IVF0+1
      if (ITURN == 0) then
        call LOOP7(KM,ISTOP,IT1,IT2)
      else if (ITURN == 1) then
        call LOOP8(KM,ISTOP,IT1,IT2)
      end if
      if (ISTOP /= 1) then
        if ((IDIAG == 1) .and. (J1(KM) /= J2(KM))) cycle loop_1
      else
        if (ITURN == 1) exit loop_1
        ITURN = 1
        IWAY(L) = 1
        cycle loop_1
      end if
      loop_2: do
        KM = KM-1
        IWAY(KM) = 1
        first = KM == I
        loop_3: do
          if (first) then
            KM = I
            if (ITURN == 0) then
              call LOOP14(KM,ISTOP,IT1,IT2)
            else if (ITURN == 1) then
              call LOOP18(KM,ISTOP,IT1,IT2)
            end if
            if (ISTOP == 1) then
              KM = KM+1
              if (KM == L) cycle loop_1
              first = .false.
              cycle loop_3
            end if
            if (abs(COUP(I)) < 1.0e-6_wp) cycle loop_3
            if (IDIAG /= 0) then
              if (ICOUP1(I) /= ICOUP(I)) cycle loop_3
            else if ((ITURN /= 0) .and. (IWAY(L) /= 5)) then
              if (ICOUP1(I) <= ICOUP(I)) cycle loop_3
            end if
            if (ITURN == 0) COUP(I) = Half*COUP(I)
            if (IDIAG /= 1) then
              call COMP(I,LJ,ITYP,I,IT1,IT2)
              cycle loop_3
            end if
            loop_4: do
              KM = KM-1
              if (KM /= 0) IWAY(KM) = 1
              do
                if (KM == 0) then
                  IVL = J2(1)
                  ITAIL = IX(IT1+LJ)
                  ISUM = IV0-IVL
                  ISU = 0
                  if (ISUM /= 0) ISU = IRC(ISUM)
                  do IN_=1,ITAIL
                    JND1 = JNDX(ISU+ICOUP(1)+IN_)
                    if (JND1 == 0) cycle
                    IPOS = (JND1-1)*LNP+IJJ
                    NBN = (IPOS-1)/NTPB+1
                    IBUFL(NBN) = IBUFL(NBN)+1
                    ICQ = ICAD(NBN)
                    ICP = ICQ/IDIV+IBUFL(NBN)
                    BUFOUT(ICP) = COUP(I)
                    ICPP = ICQ+KBUF0+IBUFL(NBN)
                    INDOUT(ICPP) = IPOS
                    if (IBUFL(NBN) < KBUF) cycle
                    INDOUT(ICQ+KBUF1) = KBUF
                    IAD110 = IADD11
                    call iDAFILE(Lu_11,1,INDOUT(ICQ+1),KBUF2,IADD11)
                    INDOUT(ICQ+KBUF2) = IAD110
                    IBUFL(NBN) = 0
                  end do
                  if (I == 1) cycle loop_3
                  KM = 1
                else
                  call PATH(KM,ISTOP,IT1,IT2)
                  if (ISTOP == 0) cycle loop_4
                  KM = KM+1
                  if (KM == I) cycle loop_3
                end if
              end do
              if (.true.) exit loop_4
            end do loop_4
            exit loop_3
          else
            JM(KM) = IVF0+1
            JM1(KM) = IVF0+1
            if (ITURN == 0) then
              call LOOP17(KM,ISTOP,IT1,IT2)
            else if (ITURN == 1) then
              call LOOP21(KM,ISTOP,IT1,IT2)
            end if
            if (ISTOP /= 1) then
              if ((IDIAG == 1) .and. (J1(KM) /= J2(KM))) cycle loop_3
              cycle loop_2
            end if
            KM = KM+1
            if (KM == L) cycle loop_1
          end if
        end do loop_3
        if (.true.) exit loop_2
      end do loop_2
      if (.true.) exit loop_1
    end do loop_1
  end do
end do

return

end subroutine INT7

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine asonc12e_cvb(c,axc,sxc,nvec,nprm)
c  Applies S and H on c vector(s).
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
      dimension c(nprm,nvec),axc(nprm,nvec),sxc(nprm,nvec)

      i1 = mstackr_cvb(nvb+nprorb)
      call asonc12e2_cvb(c,axc,sxc,nvec,nprm,
     >  w(lc(3)),w(lc(4)),w(lc(2)),
     >  w(lv(1)),w(lw(4)),w(lw(5)),w(lw(6)),w(lw(9)),
     >  w(lv(2)),
     >  w(i1))
      call mfreer_cvb(i1)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine FSBOP(IMODE,ISORB,IORBTAB,ISSTAB,IFSBTAB,ICASE)

use rassi_global_arrays, only: FSBANN1, FSBANN2, FSBANN3, FSBANN4
use stdalloc, only: mma_allocate
use Definitions, only: iwp, u6

implicit none
integer(kind=iwp), intent(in) :: IMODE, ISORB, IORBTAB(*), ISSTAB(*), IFSBTAB(*), ICASE
integer(kind=iwp) :: IDET2, IERR, IFSB1, IFSB2, INSBPT, ISPART, ISST1, ISST2, ITYPE, KHSH2, KOINFO, KPOS1, KPOS2, KSSTAN, KSSTCR, &
                     KSSTOP, KSSTTB, KSTARR1, KSTARR2, LHSH2, LPOS, LSSTARR2, MORSBITS, NASPRT, NASPRT1, NASPRT2, NDET1, NDET2, &
                     NDETS2, NFSB1, NFSB2, NHEAD, NHSH2, NSBS1, NSBS2, NSSTARR2, NTAB2, NTAB2NEW, NULLV
integer(kind=iwp), pointer :: FSBANN(:)

! The orbital table:
NASPRT = IORBTAB(9)
KOINFO = 19
! Needed properties of spin-orbital ISORB
ISPART = IORBTAB(KOINFO+6+8*(ISORB-1))
INSBPT = IORBTAB(KOINFO+7+8*(ISORB-1))
! The substring table:
MORSBITS = ISSTAB(6)
KSSTTB = 15
KSSTAN = ISSTAB(9)
KSSTCR = ISSTAB(10)
if (IMODE == 1) then
  KSSTOP = KSSTCR
else
  KSSTOP = KSSTAN
end if

! The FS blocks of the PSI wave function:
ITYPE = IFSBTAB(2)
NFSB1 = IFSBTAB(3)
NASPRT1 = IFSBTAB(4)
KSTARR1 = 8
! Count how big the new table will be:
NASPRT2 = NASPRT1
KSTARR2 = KSTARR1
IFSB2 = 0
IDET2 = 0
do IFSB1=1,NFSB1
  KPOS1 = KSTARR1+(NASPRT1+2)*(IFSB1-1)
  NDET1 = IFSBTAB(KPOS1+NASPRT)
  ! The substring type to be annihilated from or created in:
  ISST1 = IFSBTAB(KPOS1-1+ISPART)
  ! The resulting substring type:
  ISST2 = ISSTAB(KSSTOP-1+INSBPT+MORSBITS*(ISST1-1))
  if (ISST2 == 0) cycle
  IFSB2 = IFSB2+1
  KPOS2 = KSTARR2+(NASPRT2+2)*(IFSB2-1)
  ! Replace substring type:
  ! Old vs. new nr of substrings:
  NSBS1 = ISSTAB(KSSTTB+5*(ISST1-1))
  NSBS2 = ISSTAB(KSSTTB+5*(ISST2-1))
  NDET2 = (NDET1*NSBS2)/NSBS1
  IDET2 = IDET2+NDET2
end do
NFSB2 = IFSB2
NDETS2 = IDET2
NHEAD = 7
!LSSTARR2 = 1+NHEAD
NSSTARR2 = (NASPRT2+2)*NFSB2
!LHSH2 = LSSTARR2+NSSTARR2
NHSH2 = 997+2*NFSB2
NTAB2 = NHEAD+NSSTARR2+2*NHSH2
! NTAB2 is now known. Make a new FSB table:
select case (ICASE)
  case (1)
    call mma_allocate(FSBANN1,NTAB2,Label='FSBANN1')
    FSBANN => FSBANN1(:)
  case (2)
    call mma_allocate(FSBANN2,NTAB2,Label='FSBANN2')
    FSBANN => FSBANN2(:)
  case (3)
    call mma_allocate(FSBANN3,NTAB2,Label='FSBANN3')
    FSBANN => FSBANN3(:)
  case (4)
    call mma_allocate(FSBANN4,NTAB2,Label='FSBANN4')
    FSBANN => FSBANN4(:)
  case DEFAULT
    write(u6,*) 'FSBOP: Illegal iCase value.'
    write(u6,*) 'ICASE=',ICASE
    call ABEND()
    FSBANN => FSBANN1(:) !dummy
end select

FSBANN(1) = NTAB2
FSBANN(2) = ITYPE
FSBANN(4) = NASPRT2
KSTARR2 = KSTARR1
IFSB2 = 0
IDET2 = 0
do IFSB1=1,NFSB1
  KPOS1 = KSTARR1+(NASPRT1+2)*(IFSB1-1)
  NDET1 = IFSBTAB(KPOS1+NASPRT)
  ! The substring type to be annihilated from or created in:
  ISST1 = IFSBTAB(KPOS1-1+ISPART)
  ! The resulting substring type:
  ISST2 = ISSTAB(KSSTOP-1+INSBPT+MORSBITS*(ISST1-1))
  if (ISST2 == 0) cycle
  IFSB2 = IFSB2+1
  KPOS2 = KSTARR2+(NASPRT2+2)*(IFSB2-1)
  FSBANN(KPOS2:KPOS2+NASPRT1-1) = IFSBTAB(KPOS1:KPOS1+NASPRT1-1)
  ! Replace substring type:
  FSBANN(KPOS2-1+ISPART) = ISST2
  ! Old vs. new nr of substrings:
  NSBS1 = ISSTAB(KSSTTB+5*(ISST1-1))
  NSBS2 = ISSTAB(KSSTTB+5*(ISST2-1))
  NDET2 = (NDET1*NSBS2)/NSBS1
  FSBANN(KPOS2+NASPRT) = NDET2
  FSBANN(KPOS2+NASPRT+1) = IDET2+1
  IDET2 = IDET2+NDET2
end do
! Store this block in the PSI2 hash structure.
NHEAD = 7
LSSTARR2 = 1+NHEAD
NSSTARR2 = (NASPRT2+2)*NFSB2
LHSH2 = LSSTARR2+NSSTARR2
NHSH2 = 997+2*NFSB2
NTAB2NEW = NHEAD+NSSTARR2+2*NHSH2
if (NTAB2 /= NTAB2NEW) then
  write(u6,*) ' FSBOP Error: NTAB2 /= NTAB2NEW!'
  write(u6,*) ' (This should be impossible!)'
  write(u6,*) ' Program RASSI is forced to stop, sorry!'
  call ABEND()
end if
! Make the hash map: NULLV is a null marker. Suggested value=-1.
NULLV = -1
call HSHINI(NHSH2,FSBANN(LHSH2:),NULLV)
KHSH2 = 1+NHEAD+NSSTARR2
! Header data:
FSBANN(1) = NTAB2
FSBANN(2) = ITYPE
FSBANN(3) = NFSB2
FSBANN(4) = NASPRT2
FSBANN(5) = NDETS2
FSBANN(6) = NHSH2
FSBANN(7) = KHSH2
! Store values in the map:
do IFSB2=1,NFSB2
  call HSHPUT(NASPRT2,NASPRT2+2,FSBANN(LSSTARR2:),NHSH2,FSBANN(LHSH2:),IFSB2)
end do

IERR = 0
do IFSB2=1,NFSB2
  LPOS = LSSTARR2+(NASPRT+2)*(IFSB2-1)
  do ISPART=1,NASPRT
    ISST2 = FSBANN(LPOS-1+ISPART)
    if (ISST2 < 1) IERR = IERR+1
  end do
end do
if (IERR > 0) then
  write(u6,*) ' Bad substrings in FSBOP!'
  write(u6,*) ' IERR=',IERR
  call PRFSBTAB(FSBANN(:))
  call ABEND()
end if

nullify(FSBANN)

end subroutine FSBOP

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

!************************************
!** Print and save final VB energy **
!************************************
subroutine finalresult_cvb()

use casvb_global, only: evb, svb, variat
use Definitions, only: iwp

implicit none
logical(kind=iwp), external :: up2date_cvb ! ... Make: up to date? ...

if ((.not. variat) .and. up2date_cvb('SVB')) call add_info('SVB',[abs(svb)],1,7)
if ((.not. variat) .and. up2date_cvb('EVB')) call add_info('EVB',[evb],1,7)

return

end subroutine finalresult_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Ignacio Fdez. Galvan                             *
************************************************************************

#ifndef _HAVE_EXTRA_

* Broadcast a file from the master to the slaves

      Subroutine PFGet_ASCII(FName)
#ifdef _MOLCAS_MPP_
      Use Para_Info, Only: mpp_rootid, King
#endif
      Implicit None
      Character (Len=*), Intent(In) :: FName
#ifdef _MOLCAS_MPP_
#include "SysDef.fh"
#include "mafdecls.fh"
      Integer, Parameter :: LBuf=4096
      Character (Len=LBuf) :: Buf
      Integer :: LU, Err, FLen, Pos, Num
      Logical :: Found, Failed
      Integer, External :: IsFreeUnit
      Interface
        Subroutine GA_Brdcst(type,buf,lenbuf,root)
          Integer type,lenbuf,root
          Type(*) buf
        End Subroutine GA_Brdcst
      End Interface

      ! Note that each process opens only one file, so there is a single
      ! unit number LU
      LU=10
      LU=IsFreeUnit(LU)
      ! Check file existence and read size on the master
      If (King()) Then
        Call f_Inquire(FName, Found)
        If (Found) Then
          Call Molcas_Open_Ext2(LU, FName, "stream", "unformatted", Err,
     &                          .False., 0, "old", Failed)
          If (Failed .or. (Err .ne. 0)) Then
            Write(6,*) "Failed to open file ", Trim(FName)
            Call AbEnd()
          End If
          Inquire(LU, Size=FLen)
        Else
          FLen=0
        End If
      End If
      ! Broadcast the file size
      Err=0
      Call GA_Brdcst(MT_INT, FLen, 1*ItoB, mpp_rootid)
      If (FLen .le. 0) Return
      ! Open file for writing in the slaves
      If (.not.King()) Then
        Call Molcas_Open_Ext2(LU, FName, "stream", "unformatted", Err,
     &                        .False., 0, "replace", Failed)
        If (Failed .or. (Err .ne. 0)) Then
          Write(6,*) "Failed to open file ", Trim(FName)
          Call AbEnd()
        End If
      End If
      ! Pass the file content in chunks
      Pos=0
      Do While (Pos .lt. FLen)
        ! Length of this chunk
        Num = Min(LBuf, FLen-Pos)
        ! The master reads the file
        If (King()) Then
          Read(LU, IOStat=Err) Buf(1:Num)
          If (Err .ne. 0) Then
            Write(6,*) "Error reading the file ", Trim(FName)
            Call AbEnd()
          End If
        End If
        Call GA_Brdcst(MT_BYTE, Buf(1:Num), Num, mpp_rootid)
        ! The slaves write the file
        If (.not. King()) Then
          Write(LU, IOStat=Err) Buf(1:Num)
          If (Err .ne. 0) Then
            Write(6,*) "Error writing the file ", Trim(FName)
            Call AbEnd()
          End If
        End If
        Pos = Pos + LBuf
      End Do
      Close(LU)
      Return
#else
      ! Avoid unused argument warnings
      If (.False.) Call Unused_Character(FName)
#endif

      End Subroutine PFGet_ASCII

#elif defined (NAGFOR)
c Some compilers do not like empty files
      Subroutine Empty_PFGet_ASCII
      End Subroutine Empty_PFGet_ASCII
#endif

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine espf_energy (nBas0,natom,nGrdPt,ipExt,ipGrid,ipB,h1,
     &                        nh1,RepNuc,EnergyCl,DoTinker,DoGromacs,
     &                        DynExtPot)
      Implicit Real*8 (A-H,O-Z)
*
*      Compute the integrals <mu|B/R_grid|nu>, where B weights every
*      point of the grid and R_grid is the distance to one grid point.
*
#include "espf.fh"
*
      Character*180 Line,Get_Ln
      External Get_Ln
      Character*8 Label
      Logical DoTinker,DoGromacs,DynExtPot
      Real*8 h1(nh1)
      Dimension opnuc(1),idum(1)
*
      iPL = iPL_espf()
*
* Read the MM contribution to the total energy and add it
* to the Nuclear Repulsion term
*
      If (DoTinker) Then
         ITkQMMM = IsFreeUnit(30)
         Call Molcas_Open (ITkQMMM,'QMMM')
         Line = ' '
         Do While (Index(Line,'TheEnd ') .eq. 0)
            Line=Get_Ln(ITkQMMM)
            If (Index(Line,'MMEnergy ').ne.0) Call Get_F1(2,TkE)
         End Do
         Close (ITkQMMM)
         TkE = TkE * ToHartree
         RepNuc_old = RepNuc
         RepNuc = RepNuc + TkE
         If (iPL.ge.3) Write(6,3000) RepNuc_old,TkE,RepNuc
      Else If (DoGromacs) Then
         RepNuc_old = RepNuc
         RepNuc = RepNuc + EnergyCl
         If (iPL.ge.3) Write(6,3000) RepNuc_old,EnergyCl,RepNuc
      End If
*
 3000 Format(/,' RepNuc + MM = ',F13.8,' + ',F13.8,' = ',F13.8)
*
*     Call to DrvPot to compute the integrals
*     Here we don't care about opnuc (nuclear potential)
*
      nSize = nBas0*(nBas0+1)/2 + 4
      If (nSize .ne. (nh1+4)) Then
         Write(6,*) 'In espf_energy, nSize ne nh1',nSize,nh1+4
         Call Abend()
      End If
      opnuc = Dum
*
      ncmp = 1
      iAddPot = 1
      If (iPL.ge.4) Then
         Do i = 1, NGrdPt
            Write(6,1234) i,(Work(ipGrid+(i-1)*3+j),j=0,2),
     &                       Work(ipB+(i-1))
 1234       Format('Grid point ',I4,/,4F12.6)
         End Do
      End If
      Call DrvPot(Work(ipGrid),opnuc,ncmp,Work(ipB),nGrdPt,iAddPot)
      Label = 'Pot     '
      iComp = 1
      iSyLbl = 1
      iRc = -1
      Call iRdOne(iRc,1,Label,iComp,idum,iSyLbl)
      nInts=idum(1)
      If (iRc.ne.0) Then
         Write (6,'(A)')' ESPF: Error reading ONEINT'
         Write (6,'(A,A8)')' Label = ',Label
         Call Abend()
      End If
      If (nInts+4.ne.nSize) Then
         Write (6,'(A,2I5)')' ESPF: nInts+4.ne.nSize',nInts+4,nSize
         Call Abend()
      End If
      Call GetMem('IntOnGrid','Allo','Real',ipInt,nSize)
      Call RdOne(iRc,0,Label,iComp,Work(ipInt),iSyLbl)
      If(iPL .ge. 4) Call TriPrt(Label,' ',Work(ipInt),nBas0)
*
*     The core Hamiltonian must be updated
*
      call daxpy_(nInts,One,Work(ipInt),1,h1,1)
      If (DynExtPot) Then
         iSyLbl=1
         iRc=-1
         iOpt=0
         iComp=1
         Label='OneHamRF'
         Call WrOne(iRc,iOpt,Label,iComp,Work(ipInt),iSyLbl)
      End If
      Call GetMem('IntOnGrid','Free','Real',ipInt,nSize)
*
*     The electrostatic energy between the external potential
*     and the nuclei is added to the nuclear energy
*
      EQC = ExtNuc(ipExt,natom)
      RepNuc = RepNuc + EQC
      If (IsStructure().eq.1) Then
        Call Add_Info('PotNuc',[RepNuc],1,6)
      Else
        Call Add_Info('PotNuc',[RepNuc],1,12)
      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Ignacio Fdez. Galvan                             *
************************************************************************
*  Fix_Symmetry
*
*> @brief
*>   Fix the symmetry of a structure by removing off-zero values
*> @author Ignacio Fdez. Galv&aacute;n
*>
*> @details
*> Fix the symmetry of a structure, by making sure that the coordinates that
*> should be zero remain there, removing numerical inaccuracies.
*>
*> @param[in,out] Coord Cartesian coordinates of the structure to fix (unique atoms)
*> @param[in]     nAt   Number of atoms in the structure
*> @param[in]     Stab  Stabilizers for each atom
************************************************************************
      SUBROUTINE Fix_Symmetry(Coord,nAt,Stab)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER nAt,Stab(nAt)
      REAL*8 Coord(3,nAt),thr
      PARAMETER ( thr = 1.0D-12 )
#include "real.fh"
#include "WrkSpc.fh"
*
      DO iAt=1,nAt
        DO j=0,2
          IF (IAND(Stab(iAt),2**j).GT.0) THEN
            IF (ABS(Coord(j+1,iAt)).GT.thr) THEN
              CALL WarningMessage(1,
     &             'Significant deviation from symmetry axis.')
            END IF
            Coord(j+1,iAt)=Zero
          END IF
        END DO
      END DO
*
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2024, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Exp_SVD
!
!> @brief Compute the exponential of a single-block antisymmetric matrix
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Computes the exponential of an antisymmetric real matrix \f$ A \f$ through its singular value decomposition.
!> The exponential of \f$ A \f$ is an orthogonal matrix.
!> This is specialized for the case where there is a single nonzero off-diagonal block in \f$ A \f$
!>
!> @see ::exp_series, ::exp_series2, ::exp_schur, ::exp_eig
!>
!> @param[in]     N        Size of the square matrix
!> @param[in]     no       Size of the first diagonal zero block (number of occupied orbitals)
!> @param[in,out] A        Antisymmetric real matrix, it is replaced by its exponential
!> @param[out]    maxtheta Maximum rotation angle (singular values)
!***********************************************************************

subroutine Exp_SVD(N,no,A,maxtheta)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: N, no
real(kind=wp), intent(inout) :: A(N,N)
real(kind=wp), intent(out) :: maxtheta
integer(kind=iwp) :: i, j, k, nv
real(kind=wp), allocatable :: Q(:,:), R(:,:), s(:), sx(:), tmp(:), X(:,:)

maxtheta = Zero
if (N < 1) return
nv = N-no
if (no*nv == 0) then
  call unitmat(A,N)
  return
end if

! Pick up the nonzero block
!     ( 0  -X^T )
! A = ( X    0  )
call mma_allocate(X,nv,no,label='X')
X(:,:) = A(no+1:,1:no)

k = min(no,nv)
call mma_allocate(Q,nv,k,label='Q')
call mma_allocate(R,k,no,label='R')
call mma_allocate(s,k,label='s')

! Do the SVD, note the R matrix is already transposed
call large_svd(nv,no,X,Q,R,s)
call mma_deallocate(X)
maxtheta = s(1)

call mma_allocate(sx,k,label='sx')
call mma_allocate(tmp,no*nv,label='tmp')

! Build the rotation matrix
! Based on J. Chem. Phys. 101 (1994) 3862 doi:10.1063/1.467504
! but using SVD of X (or, actually, of -X^T in the paper) instead of EVD of X X^T

sx(:) = cos(s(:))
! Choose the option with smaller matrix multiplications
if (no <= nv) then
  ! OO block: R cos(s) R^T
  j = 0
  do i=1,no
    tmp(j+1:j+k) = sx(:)*R(:,i)
    j = j+k
  end do
  call dgemm_('T','N',no,no,k,One,tmp,k,R,k,Zero,A(1,1),N)
  ! VV block: I + Q (cos(s)-I) Q^T
  sx(:) = sx(:)-One
  j = 0
  do i=1,k
    tmp(j+1:j+nv) = sx(i)*Q(:,i)
    j = j+nv
  end do
  call dgemm_('N','T',nv,nv,k,One,tmp,nv,Q,nv,Zero,A(no+1,no+1),N)
  do i=1,nv
    A(no+i,no+i) = A(no+i,no+i)+One
  end do
else
  ! VV block: Q cos(s) Q^T
  j = 0
  do i=1,k
    tmp(j+1:j+nv) = sx(i)*Q(:,i)
    j = j+nv
  end do
  call dgemm_('N','T',nv,nv,k,One,tmp,nv,Q,k,Zero,A(no+1,no+1),N)
  ! OO block: I + R (cos(s)-I) R^T
  sx(:) = sx(:)-One
  j = 0
  do i=1,no
    tmp(j+1:j+k) = sx(:)*R(:,i)
    j = j+k
  end do
  call dgemm_('T','N',no,no,k,One,tmp,k,R,k,Zero,A(1,1),N)
  do i=1,no
    A(i,i) = A(i,i)+One
  end do
end if
! VO block: Q sin(s) R^T
j = 0
do i=1,k
  tmp(j+1:j+nv) = sin(s(i))*Q(:,i)
  j = j+nv
end do
call dgemm_('N','N',nv,no,k,One,tmp,nv,R,k,Zero,A(no+1,1),N)
! OV block: -VO^T
A(1:no,no+1:) = -transpose(A(no+1:,1:no))

call mma_deallocate(R)
call mma_deallocate(Q)
call mma_deallocate(s)
call mma_deallocate(sx)
call mma_deallocate(tmp)

end subroutine Exp_SVD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,1991, Roland Lindh                                *
*               1990, IBM                                              *
*               1995, Anders Bernhardsson                              *
************************************************************************
      SubRoutine Rysg2(iAnga,nRys,nT,
     &                 Alpha,Beta,Gamma,Delta,
     &                 Zeta,ZInv,nZeta,Eta,EInv,nEta,
     &                 P,lP,Q,lQ,Coori,Coora,CoorAC,
     &                 Array,nArray,
     &                 Tvalue,ModU2,Cff2D,
     &                 PAO,nPAO,Hess,nHess,IfGrd,IndGrd,
     &                 IfHss,IndHss,nOp,iuvwx,IfG,
     &                 mvec,Index_Out,lGrad,lHess,Tr)
************************************************************************
*                                                                      *
* Object: to compute the gradient of the two-electron integrals.       *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
*                                                                      *
*             Modified to 1st order derivatives October '91            *
*             Modified to 2nd order derviatives Mars '95 by            *
*             Anders Bernhardsson Theoretical Chemistry,               *
*             University of Lund                                       *
************************************************************************
*   @parameter iAnga Angular momenta for each center
*   @parameter nRys  Order of rys polynomia
*   @parameter nT    Number of alpha-beta-gamma-delta multiplies
*   @parameter Alpha Explonents on 1st center
*   @parameter Beta Explonents on 2nd center
*   @parameter Gamma Explonents on 3rd center
*   @parameter Delta Explonents on 4ht center
*   @parameter Zeta  Alpha*Beta
*   @parameter Zeta  Zeta invers
*   @parameter nZeta Alpha Beta multiplies
*   @parameter Eta  Gamma*Delta
*   @parameter Eta  Eta invers
*   @parameter nEta gamma delta multiplies
*   @parameter P
*   @parameter lP  Length of p
*   @parameter Q
*   @parameter lQ  Length of Q
*   @parameter Coori Coordinates of center just used to check AeqB CeqD etc
*   @parameter Coora Coordinates of center used in hor. recursion
*   @parameter CoorAC Coordinates of center <max(la,lb),max(lc,ld)>
*   @parameter Array Scratch and output area for 1st derivatives
*   @parameter nArray Size of scratch area
*   @parameter PAO Density
*   @parameter nPAO lenth of density
*   @parameter Hess Output area for hessian (added)
*   @parameter nHess Size of hessian
*   @parameter ifgrad true for all 1st derivatives that are needed
*   @parameter indgrad  index in gradient on which integrals should be added
*   @parameter ifhss true for all 2nd derivatives that are needed
*   @parameter indhss  index in hess on which contracted integrals should be added
*   @parameter nop oerator number for the operator that generates center
*   @parameter iuvwx number of stabilazors
*   @parameter ifg true for all centers on which derivatives should be calculated
*   @parameter index_out  index where first derivatives are stored (out)
*   @parameter lhess true if 2nd derivatives should be calculated
*   @parameter lgrad true if 1st derivatives should be calculated
*   @parameter tr  true for all centers on which should be calculated via translation invarians
      use vRys_RW
      use Symmetry_Info, only: nIrrep, iOper
      use Real_Info, only: ChiI2
      use Temporary_Parameters, only: IsChi
      Implicit Real*8 (A-H,O-Z)
      External Tvalue, ModU2, Cff2D
      External Exp_1, Exp_2
#include "notab.fh"
#include "real.fh"
      Real*8 Zeta(nZeta), ZInv(nZeta), P(lP,3),
     &       Eta(nEta),   EInv(nEta),  Q(lQ,3),
     &       Alpha(nZeta), Beta(nZeta), Gamma(nEta), Delta(nEta),
     &       CoorAC(3,2), Coora(3,4), Coori(3,4), Array(nArray),
     &       PAO(nT,nPAO), Hess(nHess)
*    &       rkab(nZeta),rdcd(neta)
      Integer iAnga(4), IndGrd(3,4,0:7), Index1(3,4),
     &          nOp(4), iuvwx(4),   JndGrd(3,4,0:7), lOp(4),
     &          IndHss(4,3,4,3,0:7),Index2(3,4,4),
     &          Index3(3,3),Index4(2,6,3),ng(3),nh(3),Index_Out(3,4)
      Logical AeqB, CeqD, AeqC, EQ, IfGrd(3,4),
     &          JfGrd(3,4),IfG(4),KfGrd(3,4),
     &          ifhss(4,3,4,3),lgrad,lhess,Tr(4)
      nElem(i) = (i+1)*(i+2)/2
*

      Call LCopy(12,[.false.],0,JfGrd,1)
      Call LCopy(12,[.false.],0,KfGrd,1)
      lOp(1) = iOper(nOp(1))
      lOp(2) = iOper(nOp(2))
      lOp(3) = iOper(nOp(3))
      lOp(4) = iOper(nOp(4))
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      AeqB = EQ(Coora(1,1),Coora(1,2))
      CeqD = EQ(Coora(1,3),Coora(1,4))
      AeqC = EQ(Coora(1,1),Coora(1,3))
      lla = 0
      llb = 0
      llc = 0
      lld = 0
      Do 10 i = 1, 3
         If (IfHss(1,i,1,i)) lla=2
         If (IfGrd(i,1)) lla=max(lla,1)
         If (IfHss(2,i,2,i)) llb=2
         If (IfGrd(i,2)) llb=max(llb,1)
         If (IfHss(3,i,3,i)) llc=2
         If (IfGrd(i,3)) llc=max(llc,1)
         If (IfHss(4,i,4,i)) lld=2
         If (IfGrd(i,4)) lld=max(lld,1)
 10   Continue
      lab = Max(lla,llb)
      lcd = Max(llc,lld)
      nabMax = la + lb + lab
      ncdMax = lc + ld + lcd
*
*     Allocate memory for the integral gradients.
*
*
      ip = 1

      ipFinal=ip
      MemFinal=9*nt*nElem(la)*nElem(lb)*nElem(lc)*nElem(ld)
      ip=ip+MemFinal
*
*     Allocate memory for the 2D-integrals.
*
      ip2D0 = ip
      n2D0 = Max( (nabMax+1)*(ncdMax+1),
     &            (la+3)*(lb+3)*(ncdMax+1),
     &            (la+3)*(lb+3)*(lc+3)*(ld+3))
      ip = ip + n2D0*3*nT*nRys
*
*     Allocate memory for the 2nd order derivatives of the 2D-integrals.
*
      ip2D1 = ip
      n2D1 = Max( (nabMax+1)*(ncdMax+1),
     &            (la+3)*(lb+3)*(ncdMax+1),
     &            (la+1)*(lb+1)*(lc+1)*(ld+1)*3)
      ip = ip + n2D1*3*nT*nRys

*
*     Allocate memory for the coefficients in the recurrence relation
*     of the 2D-integrals.
*
      nTR=nT*nRys
      ipPAQP = ip
      ip = ip + nTR*3
      ipQCPQ = ip
      ip = ip + nTR*3
      ipB10 = ip
      lB10=Max(Min(nabMax-1,1),0)
      ip = ip + nTR*3*lB10
      labMax = Min(nabMax,ncdMax)
      ipB00 = ip
      lB00=Max(Min(labMax,1),0)
      ip = ip + nTR*3*lB00
      ipB01 = ip
      lB01=Max(Min(ncdMax-1,1),0)
      ip = ip + nTR*3*lB01
*     Allocate memory for the roots.
      ipU2 = ip
      ip = ip + nT*nRys
*     Allocate memory for Zeta, ZInv, Eta, EInv
      ipZeta = ip
      ip = ip + nT
      ipEta  = ip
      ip = ip + nT
      ipZInv = ip
      ip = ip + nT
      ipEInv = ip
      ip = ip + nT
*     Allocate memory for P and Q
      ipP = ip
      ip = ip + 3*nT
      ipQ = ip
      ip = ip + 3*nT
*     Allocate memory for the inverse.
      ipDiv = ip
      ip = ip + nT
*     Allocate memory for the arguments.
      ipTv = ip
      ip = ip + nT
      If (ip-1.gt.nArray) Then
         Call WarningMessage(2,'Rysg2: ip-1.gt.nArray (pos. 1)')
         Write (6,*) 'ip,nArray=',ip,nArray
         Call Abend()
      End If
*
*     Expand Zeta, ZInv, Eta ,EInv, P, and Q
*
      Do iEta = 1, nEta
         iOff = (iEta-1)*nZeta
         call dcopy_(nZeta,Zeta,  1,Array(iOff+ipZeta  ),1)
         call dcopy_(nZeta,ZInv,  1,Array(iOff+ipZInv  ),1)
         call dcopy_(nZeta,P(1,1),1,Array(iOff+ipP     ),1)
         iOff = iOff + nZeta*nEta
         call dcopy_(nZeta,P(1,2),1,Array(iOff+ipP     ),1)
         iOff = iOff + nZeta*nEta
         call dcopy_(nZeta,P(1,3),1,Array(iOff+ipP     ),1)
      End Do
      Do iZeta = 1, nZeta
         iOff = iZeta-1
         call dcopy_(nEta, Eta,  1,Array(iOff+ipEta) ,nZeta)
         call dcopy_(nEta,EInv,  1,Array(iOff+ipEInv),nZeta)
         call dcopy_(nEta,Q(1,1),1,Array(iOff+ipQ     ),nZeta)
         iOff = iOff + nZeta*nEta
         call dcopy_(nEta,Q(1,2),1,Array(iOff+ipQ     ),nZeta)
         iOff = iOff + nZeta*nEta
         call dcopy_(nEta,Q(1,3),1,Array(iOff+ipQ     ),nZeta)
      End Do
*
*     Compute tha arguments for which we will compute the roots and
*     the weights.
*
      Call Tvalue(Array(ipZeta),Array(ipEta),Array(ipP),Array(ipQ),nT,
     &            Array(ipTv),Array(ipDiv),IsChi,ChiI2)
*
*
*     Compute roots and weights. Make sure that the weights ends up in
*     the array where the z component of the 2D integrals will be.
*     Call vRysRW if roots and weights are tabulated in various Taylor
*     expansions. If not tabulated call RtsWgh.
*
*     Pointer to z-component of 2D-integrals where the weights will be
*     put directly. This corresponds to xyz2D(1,1,3,0,0).
      ipWgh = ip2D0 + 2*nT*nRys
      If (nRys.gt.nMxRys .or. NoTab) Then
         If (ip-1.gt.nArray) Then
            Call WarningMessage(2,'Rysg2: ip-1.gt.nArray (pos. 2)')
            Write (6,*) 'ip,nArray=',ip,nArray
            Call Abend()
         End If
*
         Call RtsWgh(Array(ipTv),nT,Array(ipU2),Array(ipWgh),nRys)
      Else
         If (ip-1.gt.nArray) Then
            Call WarningMessage(2,'Rysg2: ip-1.gt.nArray (pos. 3)')
            Write (6,*) 'ip,nArray=',ip,nArray
            Call Abend()
         End If

*        Make sure rys11/her11 is called  (la+1)
         Call vRysRW(la+1,lb,lc,ld,Array(ipTv),Array(ipU2),Array(ipWgh),
     &               nT,nRys)
      End If
*-----Drop ipTv
      ip = ip - nT
*
*     Modify the roots.
*
      Call ModU2(Array(ipU2),nT,nRys,Array(ipDiv))

*-----Drop ipDiv
      ip = ip - nT
*
*     Compute coefficients for the recurrence relations of the
*     2D-integrals
*
      Call Cff2D(Max(nabMax-1,0),Max(ncdMax-1,0),nRys,
     &           Array(ipZeta),Array(ipZInv),Array(ipEta),Array(ipEInv),
     &           nT,Coori,CoorAC,Array(ipP),Array(ipQ),
     &           la+lab,lb,lc+lcd,ld,
     &        Array(ipU2),Array(ipPAQP),Array(ipQCPQ),
     &        Array(ipB10),Array(ipB00),labMax,Array(ipB01))
*-----Drop ipU2
      ip = ip - nT*nRys
*     Let go of Zeta, ZInv, Eta, and EInv
      ip = ip - nT*4
*     Let go of P and Q
      ip = ip - 6*nT
*
*     -------------------------------
*     Compute the intermediate 2D-integrals from the roots and weights.
*
      Call Rs2Dmm(Array(ip2D0),nT,nRys,nabMax,
     &            ncdMax,Array(ipPAQP),Array(ipQCPQ),
     &            Array(ipB10),Max(nabMax-1,0),
     &            Array(ipB00),labMax,
     &            Array(ipB01),Max(ncdMax-1,0),
     &            la,lb,lc,ld,IfHss,IfGrd)
*
*-----Drop ipB01
      ip = ip - nTR*3*lB01
*-----Drop ipB00
      ip = ip - nTR*3*lB00
*-----Drop ipB10
      ip = ip - nTR*3*lB10
*-----Drop ipQCPQ
      ip = ip - nTR*3
*-----Drop ipPAQP
      ip = ip - nTR*3
*
*-----Apply the transfer equation to the intermediate 2D-integrals.
*
      Call HrrCtl_mck(Array(ip2D0),n2D0,Array(ip2D1),n2D1,
     &            la,lb,lc,ld,nabmax,ncdmax,
     &            nTR,Coora(1,1),Coora(1,2),Coora(1,3),Coora(1,4),
     &            IfHss,IfGrd,nt,nrys)
*
*     Compute the gradients of the 2D-integrals. Copy some information
*     which will be modified. This has to be done in order to facilitate
*     partioning.
*
      ip2D2= ip
      n2D2 =  (la+1)*(lb+1)*(lc+1)*(ld+1)*18
      ip = ip + n2D2*nT*nRys
      ipScr = ip
      ip = ip + nT*nRys
      ipTmp = ip
      ip = ip + nrys*nT
      ipScr2=ip
      ip=ip+nT*nRys
      If (ip-1.gt.nArray) Then
         Call WarningMessage(2,'Rysg2: ip-1.gt.nArray (pos. 4)')
         Write (6,*) 'ip,nArray=',ip,nArray
         Call Abend()
      End If
      Call ICopy(12*nirrep,IndGrd,1,JndGrd,1)
      Do 8877 i = 1, 3
         Do 7788 j = 1, 4
            JfGrd(i,j) = IfGrd(i,j)
 7788    Continue
 8877 Continue
      Do iCent=1,4
       Do jCar=1,3
        Do kCent=1,i
         If (iCent.eq.kCent) then
           iStop=3
         Else
          iStop=jCar-1
         End If
         Do lCar=1,istop
          if (jCar.ne.lCar) Then
             if (ifhss(iCent,jCar,kCent,lCar)) Then
                kfgrd(jCar,iCent)=.true.
                kfgrd(lCar,kCent)=.true.
             End If
          End If
         End Do
        End Do
       End Do
      End Do
      Do jCent=1,4
       Do iCar=1,3
        if (kfgrd(iCar,jCent).or.Ifgrd(iCar,jCent)) Then
         kfgrd(iCar,jCent)=.true.
        End If
       End Do
      End Do
*
      Call Rs2Dgh(Array(ip2D0),nT,nRys,la,lb,lc,ld,
     &            Array(ip2D1),Array(ip2D2),
     &            IfHss,IndHss,KfGrd,JndGrd,IfG,
     &            Coora,Alpha,Beta,Gamma,Delta,nZeta,nEta,
     &            Array(ipScr),Array(ipScr2),Array(ipTmp),
     &            Index1,Index2,Index3,Index4,ng,nh,
     &            Exp_1,Exp_2,nZeta,nEta,nIrrep,Tr)
*-----Drop ipScr
      ip = ip - nTR
*-----Drop ipScr2
      ip = ip - nTR
*-----Drop ipTmp
      ip = ip - nTR
*
*     G2
*
      ipg2 = ip
      ip = ip + 78
      If (ip-1.gt.nArray) Then
         Call WarningMessage(2,'Rysg2: ip-1.gt.nArray (pos. 5)')
         Write (6,*) 'ip,nArray=',ip,nArray
         Call Abend()
      End If
*
      If (lGrad) Then
       Do iCe=1,4
        Do iCa=1,3
         kfGrd(iCa,iCe)=(kfgrd(iCa,iCe).and.ifgrd(iCa,iCe))
        End Do
       End Do
       Call Assg1_mck(Array,nT,nRys,la,lb,lc,ld,Array(ip2D0),
     &                Array(ip2D1),kfGrd,Index1,mVec_,Index_out)
       mVec = mVec_

      End If
*
      If (lHess) Then
         Call Assg2(Array(ipg2),nT,nRys,la,lb,lc,ld,Array(ip2D0),
     &              Array(ip2D1),Array(ip2D2),IfHss,
     &              Index3,Index4,ng,nh,PAO)
*
*        Distribute the contributions to the molecular static hessian
*
         Call Distg2(Array(ipg2),Hess,nHess,JndGrd,
     &            IfHss,IndHss,iuvwx,lOp,nop,Tr,IfG)
      End If
*
*-----Drop ipg2
      ip = ip - 78
*-----Drop ip2D1
      ip = ip - nTR*3*n2D1
*-----Drop ip2D0
      ip = ip - nTR*3*n2D0
*-----Drop ip2D2
      ip=ip-n2D2*nT*nRys
*
      If (ip.ne.1+MemFinal) Then
         Call WarningMessage(2,'Rysg2: ip.ne.1+MemFinal (pos. 5)')
         Write (6,*) 'ip,MemFinal=',ip,MemFinal
         Call Abend()
      End If
      Call lCopy(12,kfgrd,1,ifgrd,1)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
        subroutine MkOE (OE)
c
c        OEo(i) <- OE(i)
c        OEv(a) <- OE(a)
c
        implicit none
#include "chcc1.fh"
        real*8 OE(1:(nv+no))
c
c        help variables
        integer a,i
c
        do i=1,no
          OEo(i)=OE(i)
        end do
c
        do a=1,nv
          OEv(a)=OE(no+a)
        end do
c
        return
        end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine o123a_cvb( &
#                    define _CALLING_
#                    include "opta_interface.fh"
                    )

use casvb_global, only: eigval, eigvec, ip, ograd, ogradp
use Definitions, only: iwp, u6

implicit none
#include "opta_interface.fh"

call gethess_cvb(eigvec)
call mxdiag_cvb(eigvec,eigval,nparam)
call mxatb_cvb(ograd,eigvec,1,nparam,nparam,ogradp)
if (ip >= 2) then
  write(u6,'(a)') ' Gradient in basis of Hessian eigenvectors :'
  call vecprint_cvb(ogradp,nparam)
end if

return

end subroutine o123a_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE MOTRAC(CMO,F,X1,X2)
C
C     RASSCF PROGRAM IBM-3090 VERSION: CI SECTION
C     PURPOSE: TRANSFORMS A MATRIX F WITH THE TRANSFORMATION MATRIX CMO
C              NORMALLY FROM AO TO MO BASIS. THE RESULT OVERWRITES THE
C              INITIAL MATRIX. SYMMETRY BLOCKED.
C              THE MATRIX F IS TRANSFORMED FROM FULL AO BASIS TO
C              ACTIVE ORBITAL MO BASIS.
C              INPUT AND OUTPUT MATRICES IN LOWER TRIANGULAR FORM.
C              CALLED FROM FCIN
C
C     ********** IBM-3090 RELEASE 86 12 05 **********
C
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
      DIMENSION CMO(*),F(*),X1(*),X2(*)
C
      LMOP=1
      ISTFA=1
      ISTFP=1
      DO 100 ISYM=1,NSYM
      NB=NBAS(ISYM)
      NA=NASH(ISYM)
      LMOP1=LMOP+NB*(NISH(ISYM)+NFRO(ISYM))
      IF(NA.EQ.0) GO TO 99
C
      CALL SQUARE(F(ISTFP),X1,1,NB,NB)
C      CALL MXMA(X1,1,NB,CMO(LMOP1),1,NB,X2,1,NB,NB,NB,NA)
      CALL DGEMM_('N','N',NB,NA,NB,
     &             1.0d0,X1,NB,
     &             CMO(LMOP1),NB,
     &             0.0d0,X2,NB)
      CALL MXMT(X2,NB,1,CMO(LMOP1),1,NB,F(ISTFA),NA,NB)
C
      ISTFA=ISTFA+ITRI(NA+1)
99    LMOP=LMOP+NB**2
      ISTFP=ISTFP+ITRI(NB+1)
100   CONTINUE
C
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2001, Jeppe Olsen                                      *
!***********************************************************************

subroutine BLKFO_MIN(ISM,NBLK,LEN_BLK)
! Number of blocks and length of each block for CI expansion
!
! Jeppe Olsen, June 2001
!
! Input
! =====
!
! ISM : Symmetry of CI expansion
!
! Output
! ======
!
! NBLK : Number of blocks in expansion
! LEN_BLK(IBLK) : Length of block IBLK

use CandS, only: ISSPC
use lucia_data, only: Allocate_Local_Arrays, CBLTP, CI1BT, CIBT, CLBT, CLEBT, Deallocate_Local_Arrays, IDC, MXNTTS, NIRREP, &
                      NOCTYP, NSTSO
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ISM
integer(kind=iwp), intent(out) :: NBLK, LEN_BLK(MXNTTS)
integer(kind=iwp) :: I_DUMMY(1), IATP, IBTP, NBATCH, NOCTPA, NOCTPB
integer(kind=iwp), allocatable :: CIOIO(:)

I_DUMMY(1) = 0 ! jwk-cleanup
IATP = 1
IBTP = 2

NOCTPA = NOCTYP(IATP)
NOCTPB = NOCTYP(IBTP)
! Pointers to local arrays
call Allocate_Local_Arrays(MXNTTS,NIRREP)
! Info needed for generation of block info
call mma_allocate(CIOIO,NOCTPA*NOCTPB,Label='CIOIO')
call IAIBCM(ISSPC,CIOIO) ! Jesper
call ZBLTP(ISM,NIRREP,IDC,CBLTP,I_DUMMY)
! Allowed length of each batch (not important for final output)
!LBLOCK = max(MXSOOB,LCSBLK)
! Batches  of C vector
call PART_CIV2(IDC,NSTSO(IATP)%A,NSTSO(IBTP)%A,NOCTPA,NOCTPB,NIRREP,CIOIO,ISM,NBATCH,CLBT,CLEBT,CI1BT,CIBT,0)
! Number of BLOCKS
NBLK = CI1BT(NBATCH)+CLBT(NBATCH)-1
! Length of each block
call EXTRROW(CIBT,8,8,NBLK,LEN_BLK)

call Deallocate_Local_Arrays()
call mma_deallocate(CIOIO)

end subroutine BLKFO_MIN

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine JKQPar_Naoya(N1,N2,HEXCH,Jpar)

use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: cZero
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: N1, N2
complex(kind=wp), intent(in) :: HEXCH(N1,N1,N2,N2)
complex(kind=wp), intent(out) :: Jpar(N1-1,(-N1+1):N1-1,N2-1,(-N2+1):N2-1)
integer(kind=iwp) :: is1, is2, j1, j2, js1, js2, k1, k2, ms1, ms2, ns1, ns2, q1, q2
real(kind=wp) :: FACT, OPER
complex(kind=wp) :: trace
complex(kind=wp), allocatable :: QMAT(:,:,:,:)
real(kind=wp), external :: WCG

call mma_allocate(QMAT,N1,N1,N2,N2,label='QMAT')

! we need to project now the HEXCH: in products of ITOs
!  HEXCH = SUM(rank1,proj1,rank2,proj2) = { B(rank1,proj1,rank2,proj2)* O1(rank1,proj1) * O2(rank2,proj2) }
! Naoya definition
! eq.40 in Doi:10.1103/PhysRevB.91.174438
Jpar(:,:,:,:) = cZero
J1 = N1-1 ! i.e. double of the dimension of the spin on site 1
J2 = N2-1 ! i.e. double of the dimension of the spin on site 2
do k1=0,J1
  do q1=-k1,k1
    do k2=0,J2
      do q2=-k2,k2
        ! the rank of individual spins must be even
        if (mod(k1,2) /= 1) cycle
        ! the rank of individual spins must be even
        if (mod(k2,2) /= 1) cycle
        ! If the total rank is odd, Then it is a local ZFS contribution; ==> to be Done later
        ! compute the qmat:
        ! projections q and q' are with opposite sign:
        !  -is1 and  -is2
        do is1=1,N1
          ms1 = 2*is1-N1-1 ! spin projection on site 1
          do js1=1,N1
            ns1 = 2*js1-N1-1 ! spin projection on site 1
            do is2=1,N2
              ms2 = 2*is2-N2-1 ! spin projection on site 2
              do js2=1,N2
                ns2 = 2*js2-N2-1 ! spin projection on site 2
                if (WCG(J1,J1,2*k1,0,J1,J1) == 0) cycle
                if (WCG(J2,J2,2*k2,0,J2,J2) == 0) cycle

                QMAT(is1,js1,is2,js2) = WCG(J1,ns1,2*k1,-2*q1,J1,ms1)*WCG(J2,ns2,2*k2,-2*q2,J2,ms2)/WCG(J1,J1,2*k1,0,J1,J1)/ &
                                        WCG(J2,J2,2*k2,0,J2,J2)

#               ifdef _DEBUGPRINT_
                if (abs(QMAT(is1,js1,is2,js2)) > 1.0e-12_wp) &
                  write(u6,'(8(A,i3),A,2F20.14)') ' QMAT(',k1,',',q1,',',k2,',',q2,'|||',is1,',',js1,',',is2,',',js2,') = ', &
                                                  QMAT(is1,js1,is2,js2)
#               endif

              end do
            end do
          end do
        end do
        ! compute the trace Tr[QMAT * HEXCH]
        trace = cZero
        do is1=1,N1
          do js1=1,N1
            do is2=1,N2
              do js2=1,N2
                trace = trace+QMAT(is1,js1,is2,js2)*HEXCH(js1,is1,js2,is2)
              end do
            end do
          end do
        end do

#       ifdef _DEBUGPRINT_
        if (abs(trace) > 1.0e-12_wp) write(u6,'(4(A,i3),A,2F20.14)') 'trace(',k1,',',q1,',',k2,',',q2,') = ',trace
#       endif

        OPER = WCG(J1,J1,2*k1,0,J1,J1)*WCG(J1,J1,2*k1,0,J1,J1)*WCG(J2,J2,2*k2,0,J2,J2)*WCG(J2,J2,2*k2,0,J2,J2)
        FACT = real(((-1)**(q1+q2))*((2*k1+1)*(2*k2+1)),kind=wp)/real(N1*N2,kind=wp)

        Jpar(k1,q1,k2,q2) = FACT*OPER*trace

#       ifdef _DEBUGPRINT_
        if (abs(Jpar(k1,q1,k2,q2)) > 0.5e-13_wp) &
          write(u6,'(4(A,i3),A,2F20.14)') '    J(',k1,',',q1,',',k2,',',q2,') = ',Jpar(k1,q1,k2,q2)
#       endif

      end do
    end do
  end do
end do

call mma_deallocate(QMAT)

return

end subroutine JKQPar_Naoya

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine OneEl_Integrals(Kernel,KrnlMm,Label,ip,lOper,nComp,
     &                           CCoor,nOrdOp,rHrmt,iChO,Integrals)
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External Kernel, KrnlMm
#include "stdalloc.fh"
#include "real.fh"
      Character Label*8
      Real*8 CCoor(3,nComp)
      Integer ip(nComp), lOper(nComp), iChO(nComp), iStabO(0:7)
      Integer iTwoj(0:7)
      Data iTwoj/1,2,4,8,16,32,64,128/
      Dimension dum(1),idum(1)
      Real*8, Allocatable:: Integrals(:)
*                                                                      *
************************************************************************
*                                                                      *
*#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Write (6,*) ' In OneEl: Label', Label
      Write (6,*) ' In OneEl: nComp'
      Write (6,'(1X,8I5)') nComp
      Write (6,*) ' In OneEl: lOper'
      Write (6,'(1X,8I5)') lOper
      Write (6,*) ' In OneEl: n2Tri'
      Do iComp = 1, nComp
         ip(iComp) = n2Tri(lOper(iComp))
      End Do
      Write (6,'(1X,8I5)') (ip(iComp),iComp=1,nComp)
      Call RecPrt(' CCoor',' ',CCoor,3,nComp)
#endif
*                                                                      *
************************************************************************
*                                                                      *
*-----Compute the number of blocks from each component of the operator
*     and the irreps it will span.
*
      nIC = 0
      llOper = 0
      Do iComp = 1, nComp
         llOper = iOr(llOper,lOper(iComp))
         Do iIrrep = 0, nIrrep-1
            If (iAnd(lOper(iComp),iTwoj(iIrrep)).ne.0) nIC = nIC + 1
         End Do
      End Do
#ifdef _DEBUGPRINT_
      Write (6,*) ' nIC =',nIC
#endif
      If (nIC.eq.0) Then
         Call WarningMessage(2,'OneEl_Integrals: nIC.eq.0')
         Call Abend()
      End If
      Call SOS(iStabO,nStabO,llOper)
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate memory for symmetry adapted one electron integrals.
*     Will just store the unique elements, i.e. low triangular blocks
*     and lower triangular elements in the diagonal blocks.
*
      ip(:)=-1
      LenTot=0
      Do iComp = 1, nComp
         ip(iComp)=1+LenTot
         LenInt=n2Tri(lOper(iComp))
         LenTot=LenTot+LenInt+4
      End Do
      call mma_allocate(Integrals,LenTot,Label='Integrals')
      Integrals(:)=Zero
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute all SO integrals for all components of the operator.
*
      Call OneEl_Internal
     &           (Kernel,KrnlMm,Label,ip,lOper,nComp,CCoor,
     &            nOrdOp,rHrmt,iChO,
     &            dum,dum,1,idum,0,0,
     &            iStabO,nStabO,nIC,
     &            Dum,1,0,Integrals,LenTot)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine moscow_cvb()
      write(6,*)' Casvb dummy routine called : MOSCOW'
      return
      entry service_cvb()
      write(6,*)' Casvb dummy routine called : SERV'
      return
      entry rtransf_plc()
      write(6,*)' Molint dummy routine called : rtransf_plc'
      return
      entry perfloc_plc()
      write(6,*)' Molint dummy routine called : perfloc_plc'
      return
      entry plcconst_plc()
      write(6,*)' Molint dummy routine called : plcconst_plc'
      return
      entry rconstr_plc()
      write(6,*)' Molint dummy routine called : rconstr_plc'
      return
      entry getr_plc()
      write(6,*)' Molint dummy routine called : getr_plc'
      return
      entry qget_plc()
      write(6,*)' Molint dummy routine called : qget_plc'
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine t3reaccsd (wrk,wrksize,
     & eccsd)
c
c     this routine read CCSD results, it T1 and T2 amplitudes
c     and CCSD energy from saverst file
c
c     eccsd - Converged CCSD energy (O)
c
#include "t31.fh"
#include "t32.fh"
#include "wrk.fh"
c
       real*8 eccsd,dum(1)
c
c     help parameters
c
       integer lunrst,rc1
c
c
c1    open file savename
       lunrst=1
c
       if (iokey.eq.1) then
c      Fortran IO
c       open (unit=lunrst,file=filerst,form='unformatted')
        call molcas_binaryopen_vanilla(lunrst,filerst)
c
       else
c      MOLCAS IO
       call daname (lunrst,filerst)
       daddr(lunrst)=0
       end if
c
c2    get T1aa
       call cct3_getmediate (wrk,wrksize,
     & lunrst,posst110,mapdt11,mapit11,rc1)
c
c3    get T1bb
       call cct3_getmediate (wrk,wrksize,
     & lunrst,posst120,mapdt12,mapit12,rc1)
c
c4    get T2aaaa
       call cct3_getmediate (wrk,wrksize,
     & lunrst,posst210,mapdt21,mapit21,rc1)
c
c5    get T2bbbb
       call cct3_getmediate (wrk,wrksize,
     & lunrst,posst220,mapdt22,mapit22,rc1)
c
c6    get T2abab
       call cct3_getmediate (wrk,wrksize,
     & lunrst,posst230,mapdt23,mapit23,rc1)
c
c7    get energy,niter
       if (iokey.eq.1) then
c      Fortran IO
       read (lunrst,end=1) eccsd,rc1
       else
c
c      MOLCAS IO
       call ddafile (lunrst,2,dum,1,daddr(lunrst))
       eccsd=dum(1)
       end if
c
       goto 999
c
 1      write(6,*) ' ENERGY AND NIT WAS NOT IN SAVE FILE, CHANGED TO 0'
       write(6,*) ' USE CCSD ENERGY FROM CCSD OUTPUT FILE'
       eccsd=0.0d0
c
 999   if (iokey.eq.1) then
c      Fortran IO
       close (lunrst)
c
       else
c      MOLCAS IO
       call daclos (lunrst)
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE full2red(XLT,Xab)
      use definitions, only: iwp, wp
      use Cholesky, only: iBas, iiBstR, IndRed, iRS2F, nBas, nnBstR,
     &                    nSym
      Implicit None
      real(kind=wp), intent(in):: XLT(*)
      real(kind=wp), intent(out):: Xab(*)

      Integer(kind=iwp) ISLT(8)
      Integer(kind=iwp), External:: cho_isao
      Integer(kind=iwp) iLoc,jSym,IS,ISYM,NB
      Integer(kind=iwp) jRab,kRab,iRab,iag,ibg,iSyma,ias,ibs,iab,kfrom

* Select table column for use with caspt2:
      iLoc=3
* jSym=1 always: Used for density matrices.
      jSym = 1
c Offsets to symmetry block in the LT matrix
      IS=0
      DO ISYM=1,NSYM
       ISLT(ISYM)=IS
       NB=NBAS(ISYM)
       IS=IS+(NB*(NB+1))/2
      END DO


      Do jRab=1,nnBstR(jSym,iLoc)
         kRab = iiBstr(jSym,iLoc) + jRab
         iRab = IndRed(kRab,iLoc)
         iag   = iRS2F(1,iRab)
         ibg   = iRS2F(2,iRab)
         iSyma = cho_isao(iag)
         ias   = iag - ibas(iSyma)
         ibs   = ibg - ibas(iSyma)
         if(ias.ge.ibs) then
          iab=(ias*(ias-1))/2+ibs
         else
          iab=(ibs*(ibs-1))/2+ias
         end if
         kfrom = isLT(iSyma) + iab
         Xab(jRab) = Xab(jRab)+XLT(kfrom)
      End Do

      End SUBROUTINE full2red

      SUBROUTINE red2full(XLT,Xab)
      use definitions, only: iwp, wp
      use Cholesky, only: iBas, iiBstR, IndRed, iRS2F, nBas, nnBstR,
     &                    nSym
      Implicit None
      real(kind=wp), intent(out):: XLT(*)
      real(kind=wp), intent(in):: Xab(*)

      Integer(kind=iwp) ISLT(8)
      Integer(kind=iwp), External:: cho_isao
      Integer(kind=iwp) iLoc,jSym,IS,ISYM,NB
      Integer(kind=iwp) jRab,kRab,iRab,iag,ibg,iSyma,ias,ibs,iab,kto

* Select table column for use with caspt2:
      iLoc=3
* jSym=1 always: Used for density matrices.
      jSym = 1
c Offsets to symmetry block in the LT matrix
      IS=0
      DO ISYM=1,NSYM
       ISLT(ISYM)=IS
       NB=NBAS(ISYM)
       IS=IS+(NB*(NB+1))/2
      END DO

      Do jRab=1,nnBstR(jSym,iLoc)
         kRab = iiBstr(jSym,iLoc) + jRab
         iRab = IndRed(kRab,iLoc)
         iag   = iRS2F(1,iRab)
         ibg   = iRS2F(2,iRab)
         iSyma = cho_isao(iag)
         ias   = iag - ibas(iSyma)
         ibs   = ibg - ibas(iSyma)
         if(ias.ge.ibs) then
          iab=(ias*(ias-1))/2+ibs
         else
          iab=(ibs*(ibs-1))/2+ias
         end if
         kto = isLT(iSyma) + iab
         XLT(kto) = XLT(kto)+Xab(jRab)
      End Do

      End SUBROUTINE red2full

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 22, 2021, created this file.               *
! ****************************************************************
subroutine PDFTFock_Inner(Fock,Kern,MO1,MO2,mGrid)

use nq_Info, only: mIrrep, mOrb, nOrbt, nPot1, OffOrb, OffOrb2
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: One
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Fock(nPot1)
integer(kind=iwp), intent(in) :: mGrid
real(kind=wp), intent(in) :: Kern(mGrid), MO1(mGrid,nOrbt), MO2(mGrid,nOrbt)
integer(kind=iwp) :: iGrid, iIrrep, iOff1, iOff2
real(kind=wp), allocatable :: KernMO(:,:)

call mma_allocate(KernMO,mGrid,nOrbt,label='KernMO')

do iGrid=1,mGrid
  KernMO(iGrid,:) = MO1(iGrid,:)*Kern(iGrid)
end do

do iIrrep=0,mIrrep-1
  IOff1 = OffOrb(iIrrep)+1
  IOff2 = OffOrb2(iIrrep)+1
  call DGEMM_('T','N',mOrb(iIrrep),mOrb(iIrrep),mGrid,One,KernMO(:,IOff1:),mGrid,MO2(:,IOff1:),mGrid,One,Fock(iOff2),mOrb(iIrrep))
end do

call mma_deallocate(KernMO)

return

end subroutine PDFTFock_Inner

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Roland Lindh                                     *
************************************************************************
      SubRoutine SOGthr(SOInt,iBas,jBas,nSOInt,PrpInt,nPrp,lOper,
     &                  iCmp,jCmp,iShell,jShell,AeqB,iAO,jAO)
************************************************************************
*                                                                      *
* Object: to gather elements, from the Fock or 1st order density matrix*
*         in SO-basis, which are associated with a shell pair.         *
*         OBSERVE that the matrix is folded to triangular form, i.e.   *
*         the off diagonal elements has twice there value. This in     *
*         order to reduce the summation to i>=j. However, this will    *
*         not be used for the diagonal blocks. Hence, these elements   *
*         will only be assigned half the value from the original       *
*         matrix.                                                      *
*                                                                      *
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
*             October '91                                              *
************************************************************************
      use SOAO_Info, only: iAOtSO
      use Basis_Info, only: nBas
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 SOInt(iBas*jBas,nSOInt), PrpInt(nPrp)
      Logical AeqB
*                                                                      *
************************************************************************
*                                                                      *
*     Statement function
*
      iTri(i,j) = Max(i,j)*(Max(i,j)-1)/2+Min(i,j)
*                                                                      *
************************************************************************
*                                                                      *
*
      iRout = 130
      iPrint = nPrint(iRout)
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In SOGthr: PrpInt',' ',PrpInt,1,nPrp)
         Write (6,*) ' iAO, jAO=',iAO, jAO
         Write (6,*) ' iShell, jShell=',iShell, jShell
      End If
      lSO = 0
      Do 100 j1 = 0, nIrrep-1
       Do 200 i1 = 1, iCmp
        If (iAOtSO(iAO+i1,j1)<0) Cycle
*
*       Gather the SO's from lower rectangular blocks and triangular
*       diagonal blocks.
*
        Do 300 j2 = 0, j1
         j12 = iEor(j1,j2)
         If (iAnd(lOper,2**j12).eq.0) Go To 300
         jjMx = jCmp
         If (iShell.eq.jShell .and. j1.eq.j2) jjMx = i1
         Do 400 i2 = 1, jjMx
          If (iAOtSO(jAO+i2,j2)<0) Cycle
          lSO = lSO + 1
          iSO1=iAOtSO(iAO+i1,j1)
          iSO2=iAOtSO(jAO+i2,j2)
*
          iPnt = iPntSO(j1,j2,lOper,nbas)
*         Write (*,*)  iSO1, iSO2, iPnt, i1, j1, i2, j2
          Do 500 indAO1 = 0, iBas-1
*         Diagonal block (only unique elements).
           Do 600 indAO2 = 0, jBas - 1
            ipij = indAO2*iBas + indAO1 + 1
            Indi = iSO1+indAO1
            Indj = iSO2+indAO2
*
*           Move one element and unfold.
*
            Fact=Half
            If (Indi.eq.Indj) Fact=One
*
            If (j1.eq.j2) Then
               SOInt(ipij,lSO)=Fact*PrpInt(iPnt + iTri(Indi,Indj))
            Else
               nRow = nBas(j1)
               SOInt(ipij,lSO)=Fact*PrpInt(iPnt + nRow*(Indj-1)+Indi)
            End If
*
 600       Continue
 500      Continue
*
 400     Continue
 300    Continue
*
 200   Continue
 100  Continue
*
      If (iPrint.ge.99) Then
         Call RecPrt(' In SOGthr: SOInt',' ',SOInt,iBas*jBas,nSOInt)
      End If
      If (iPrint.ge.99) Call GetMem(' Exit SOGthr','CHECK','REAL',
     &                              iDum,iDum)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_logical(AeqB)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine defvhlp21 (r1,v,dimr1a,dimr1c,
     & dimvab,dimva,dimvc,adda,addc)
c
c     this routine do
c     V(ab,c)xxx = R1(a,b,c)-R1(b,a,c) x=a,b
c     for syma=symb>symc
c
c     r1        - r1 matrix (I)
c     v        - v matrix (O)
c     dimr1a         - dimension of a (b) in R1 (I)
c     dimr1c         - dimension of c in R1 (I)
c     dimvab        - dimension of ab in V (I)
c     dimva        - dimension of a (b) in V (I)
c     dimvc        - dimension of c in V (I)
c     adda    - additional constat to a (b) (I)
c     addc    - additional constat to c (I)
c
#include "t31.fh"
       integer dimr1a,dimr1c,dimvab,dimva,dimvc,adda,addc
       real*8 r1(1:dimr1a,1:dimr1a,1:dimr1c)
       real*8 v(1:dimvab,1:dimvc)
c
c     help variables
c
       integer a,b,c,ab,ab0,ar1,cr1

c
       do 100 c=1,dimvc
       cr1=c+addc
       do 101 a=2,dimva
       ar1=a+adda
       ab0=nshf(a)
       do 102 b=1,a-1
       v(ab0+b,c)=r1(ar1,b+adda,cr1)
 102    continue
 101    continue
 100    continue
c
       do 200 c=1,dimvc
       cr1=c+addc
       do 201 a=2,dimva
       ar1=a+adda
       ab0=nshf(a)
       do 202 b=1,a-1
       ab=ab0+b
       v(ab,c)=v(ab,c)-r1(b+adda,ar1,cr1)
 202    continue
 201    continue
 200    continue
c
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

subroutine MKSD(DREF,NDREF,PREF,NPREF)
! Set up the matrix SD(tuP,xyQ),P and Q are 1 or 2,
! Formulae used:
!    SD(tu1,xy1)=2*(Gutxy + dxt Duy)
!    SD(tu2,xy1)= -(Gutxy + dxt Duy)
!    SD(tu2,xy2)= -Gxtuy +2*dxt Duy

use Index_Functions, only: iTri, nTri_Elem
use SUPERINDEX, only: MTU
use EQSOLV, only: IDSMAT
use caspt2_global, only: LUSBT
use caspt2_module, only: NASHT, NINDEP, NSYM, NTU, NTUES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Two, Half
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF
real(kind=wp), intent(in) :: DREF(NDREF), PREF(NPREF)
integer(kind=iwp) :: ID, IDISK, IP, IS11, IS12, IS21, IS22, ISYM, ITABS, ITU, ITU2, ITUABS, IUABS, IUTP, IUYP, IXABS, IXTP, IXY, &
                     IXY2, IXYABS, IXYP, IYABS, NAS, NIN, NSD
real(kind=wp) :: DUY, GUTXY, GXTUY, S11, S22
real(kind=wp), allocatable :: SD(:)

! Loop over superindex symmetry.
do ISYM=1,NSYM
  NIN = NINDEP(ISYM,5)
  if (NIN == 0) cycle
  NAS = NTU(ISYM)
  NSD = nTri_Elem(2*NAS)
  if (NSD > 0) call mma_allocate(SD,NSD,LABEL='SD')
  do ITU=1,NAS
    ITU2 = ITU+NAS
    ITUABS = ITU+NTUES(ISYM)
    ITABS = MTU(1,ITUABS)
    IUABS = MTU(2,ITUABS)
    do IXY=1,ITU
      IXY2 = IXY+NAS
      IXYABS = IXY+NTUES(ISYM)
      IXABS = MTU(1,IXYABS)
      IYABS = MTU(2,IXYABS)
      IS11 = iTri(ITU,IXY)
      IS21 = iTri(ITU2,IXY)
      IS12 = iTri(IXY2,ITU)
      IS22 = iTri(ITU2,IXY2)
      IUTP = IUABS+NASHT*(ITABS-1)
      IXYP = IXABS+NASHT*(IYABS-1)
      IP = iTri(IUTP,IXYP)
      GUTXY = Two*PREF(IP)
      IXTP = IXABS+NASHT*(ITABS-1)
      IUYP = IUABS+NASHT*(IYABS-1)
      IP = iTri(IXTP,IUYP)
      GXTUY = Two*PREF(IP)
      S11 = Two*GUTXY
      S22 = -GXTUY
      if (IXABS == ITABS) then
        ID = iTri(IUABS,IYABS)
        DUY = DREF(ID)
        S11 = S11+Two*DUY
        S22 = S22+Two*DUY
      end if
      ! SD(tu1,xy1)=2*(Gutxy + dtx Duy)
      SD(IS11) = S11
      ! SD(tu2,xy1)= -(Gutxy + dtx Duy)
      SD(IS21) = -Half*S11
      SD(IS12) = -Half*S11
      ! SD(tu2,xy2)= -Gxtuy +2*dtx Duy
      SD(IS22) = S22
    end do
  end do

  ! Write to disk
  if (NSD > 0) then
    if (NINDEP(ISYM,5) > 0) then
      IDISK = IDSMAT(ISYM,5)
      call DDAFILE(LUSBT,1,SD,NSD,IDISK)
    end if
    call mma_deallocate(SD)
  end if
end do

end subroutine MKSD

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Cho_MaxDX(Diag,Dmax)
!
! Purpose: get max. diagonal elements in each sym. block,
!          qualified diagonals excluded.

use Cholesky, only: iiBstR, IndRed, iQuAB, nnBstR, nQual, nSym
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: Diag(*)
real(kind=wp), intent(out) :: Dmax(nSym)
integer(kind=iwp) :: iab, iQ, iRab, jRab, jRab1, jRab2, jSym, MxQ
real(kind=wp), allocatable :: ExQ(:)

MxQ = nQual(1)
do jSym=2,nSym
  MxQ = max(MxQ,nQual(jSym))
end do
call mma_allocate(ExQ,MxQ,Label='ExQ')

do jSym=1,nSym

  Dmax(jSym) = Zero
  if (nQual(jSym) < 1) cycle  ! next symm

  do iQ=1,nQual(jSym)
    iab = IndRed(iQuAB(iQ,jSym),2) ! addr in 1st red set
    ExQ(iQ) = Diag(iab)
    Diag(iab) = Zero
  end do

  jRab1 = iiBstr(jSym,2)+1
  jRab2 = jRab1+nnBstR(jSym,2)-1
  do jRab=jRab1,jRab2
    iRab = IndRed(jRab,2) ! addr in 1st red set
    Dmax(jSym) = max(Dmax(jSym),Diag(iRab))
  end do

  ! Restore the qualified
  do iQ=1,nQual(jSym)
    iab = IndRed(iQuAB(iQ,jSym),2) ! addr in 1st red set
    Diag(iab) = ExQ(iQ)
  end do

end do

call mma_deallocate(ExQ)

end subroutine Cho_MaxDX

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!
Module RICD_Info
Private
Public :: iRI_Type, LDF, Do_RI, Cholesky, Do_acCD_Basis, Skip_High_AC, &
           Cho_OneCenter,  DiagCheck, LocalDF, Do_nacCD_Basis, Thrshld_CD, &
          RICD_Info_Dmp, RICD_Info_Get
Integer :: iRI_Type=-1
Logical :: LDF=.False.
Logical :: Do_RI=.False.
Logical :: Cholesky=.False.
Logical :: Do_acCD_Basis=.True.
Logical :: Skip_High_AC=.False.
Logical :: Cho_OneCenter=.False.
Logical :: DiagCheck=.False.
Logical :: LocalDF=.False.
Logical :: Do_nacCD_Basis=.False.
Real*8  :: Thrshld_CD=1.0D-4
#include "stdalloc.fh"

Contains

Subroutine RICD_Info_Dmp()
  Real*8, Allocatable:: rDmp(:)
  Integer i
  Integer:: Len=11

  Call mma_allocate(rDmp,Len,Label='rDmp:RICD')

  rDmp(1) = DBLE(iRI_Type)
  i = 0
  If (LDF) i = 1
  rDmp(2) = DBLE(i)
  i = 0
  If (Do_RI) i = 1
  rDmp(3) = DBLE(i)
  i = 0
  If (Cholesky) i = 1
  rDmp(4) = DBLE(i)
  i = 0
  If (Do_acCD_Basis) i = 1
  rDmp(5) = DBLE(i)
  i = 0
  If (Skip_High_AC) i = 1
  rDmp(6) = DBLE(i)
  i = 0
  If (Cho_OneCenter) i = 1
  rDmp(7) = DBLE(i)
  i = 0
  If (DiagCheck) i = 1
  rDmp(8) = DBLE(i)
  i = 0
  If (LocalDF) i = 1
  rDmp(9) = DBLE(i)
  i = 0
  If (Do_nacCD_Basis) i = 1
  rDmp(10) = DBLE(i)
  rDmp(11) = Thrshld_CD


  Call Put_dArray('RICD_Info',rDmp,Len)
  Call mma_deallocate(rDmp)
End Subroutine RICD_Info_Dmp


Subroutine RICD_Info_Get()
  Real*8, Allocatable:: rDmp(:)
  Integer:: Len=11

  Call mma_allocate(rDmp,Len,Label='rDmp:RICD')
  Call Get_dArray('RICD_Info',rDmp,Len)

  iRI_Type=NINT(rDmp(1))
  LDF = NINT(rDmp(2)).eq.1
  Do_RI = NINT(rDmp(3)).eq.1
  Cholesky = NINT(rDmp(4)).eq.1
  Do_acCD_Basis = NINT(rDmp(5)).eq.1
  Skip_High_AC = NINT(rDmp(6)).eq.1
  Cho_OneCenter = NINT(rDmp(7)).eq.1
  DiagCheck = NINT(rDmp(8)).eq.1
  LocalDF = NINT(rDmp(9)).eq.1
  Do_nacCD_Basis = NINT(rDmp(10)).eq.1
  Thrshld_CD = rDmp(11)

  Call mma_deallocate(rDmp)
End Subroutine RICD_Info_Get

End Module RICD_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine grad_cvb(grad)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "fx_cvb.fh"
#include "WrkSpc.fh"

      dimension grad(*)

      call touch_cvb('OOHESS')
      if(dxmove.and.memplenty)then
        call cicopy_cvb(work(lc(6)),work(lc(2)))
        call cicopy_cvb(work(lc(7)),work(lc(3)))
        call cicopy_cvb(work(lc(8)),work(lc(4)))
      elseif(dxmove)then
        call cird_cvb(work(lc(2)),61006.2d0)
        call cird_cvb(work(lc(3)),61007.2d0)
        call cird_cvb(work(lc(4)),61008.2d0)
      endif
      ovraa=ovraa_try
      ovrab=ovrab_try
      ww=ww_try
      if(icrit.eq.1)then
        call gr_svb1_cvb(work(lc(2)),work(lc(3)),work(lc(4)),
     >    work(lw(10)),
     >    grad,work(lq(7)),work(lq(8)),work(lq(9)),work(lq(10)))
      elseif(icrit.eq.2)then
        call gr_evb1_cvb(work(lc(2)),work(lc(3)),work(lc(4)),
     >    work(lw(10)),
     >    grad,work(lq(7)),work(lq(8)),work(lq(9)),work(lq(10)))
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine cidenmat()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "grad_h.fh"
#include "files_gugaci.fh"
      common /scratch/ tmpdir,len_str
      character*256 tmpdir
c     character*256 filename
      common /lgrn/ xlgrn(max_orb,max_orb)
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      common /grad_xyz/dxyz(3,max_atom),numat
      common /ncprhf/ nrot,nxyz,ndbl,next,nsolv,nres,n_frz,n_all
      parameter (htoklm=627.50956d+00,zero=0.0d+00)
c     dimension x1e(50000)
      logical logic_mulroot
c================================================
c    the main subroutine for ci gradient calculations.
c    ican_a and ican_b save canonical order.
c    e(*) save the scf orbital energies.
c    xlgrn(*) save the lagrangian matrix.

      sc0=c_time()
c-----------------------------------------------------
c     initialize the integral index nxo by canonical order
      call init_canonical

c     calculate the frozen mo contribution to density matrix
!      call density_scf_frz
c-----------------------------------------------------
c     calculate the ci reduced one and two electron density matrix
      ncount1=ican_a(norb_all)+norb_all
      ncount2=ican_b(ncount1)+ncount1

      logic_mulroot=.false.
      ndim=mroot*nci_dim
      if(ndim.le.max_vector) logic_mulroot=.true.

      neigen=mroot
      vector1(1:nci_dim)=zero
      norb2=norb_all*(norb_all+1)/2

! calculated ci density matrix
! need debug here, density matrix is saved in vector2, it is too large t
! keep it.
! read ci vector
!      if(logic_mulroot) then
!        call read_ml(lucivec,1,vector1,neigen*nci_dim,1)
!      endif
!      write(6,*) "density matrix",neigen,ncount2
c should we calculated two-electronic density matrix ?
      do i=1,neigen
        call read_ml(lucivec,1,vector1,nci_dim,i)
        vector2=zero
        dm1tmp=0.d0
        call memcidiag_alloc()
        call diagonal_loop_wyb_g()
        call memcidiag_dealloc()
        call matrix_vector_multi_parellel_drt_g(sechc)
        call ci_density_label_sm(i,ncount2)
!        call ci_dentest(i)
      enddo

      return
      end

      subroutine ci_dentest(iroot)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "files_gugaci.fh"
#include "grad_h.fh"
      dimension lsmorb(max_orb),noidx(8),idisk_array(max_root+1)
      REAL*8, pointer :: x(:)
!      dimension x(1024*1024)
      dimension xfock(max_orb*(max_orb+1)/2)
      dimension norb(8),itratoc(ntratoc)
      dimension buff(ntrabuf)
      kbuf=ntrabuf

#ifdef MOLPRO
#else
      norb=nlsm_all
      nintone=0
      nmob=0
      nidx=0
      ni=0
      do i=1,ng_sm
        nism   = nlsm_all(i)
        nsmint = nism*(nism+1)/2
        itratoc(i)=nism*nism
        nmob=nmob+nlsm_bas(i)*nlsm_bas(i)
        noidx(i)=nidx
        nidx=nidx+nism
        nintone=nintone+nsmint
        lsmorb(ni+1:nidx)=i
        ni=nidx
      enddo

      allocate(x(nmob))
      call daname(luonemo,fnonemo)
c      call copen_molcas(nft,filename,lenstr)
      call readtraonehead(luonemo,ecor,idisk)
      vnuc=ecor

c  read mo coeff, need debug, if frozen and delete orbitals are not zero
c      call ddatard(nft,x,nmob,idisk)
      call ddafile(luonemo,2,x,nmob,idisk)

      deallocate(x)

c  read one electron fock matrix
      call ddafile(luonemo,2,xfock,nintone,idisk)
c      call ddatard(nft,xfock,nintone,idisk)
      call daclos(luonemo)
c  read one elctron kenetic intergrals
c      call ddatard(nft,x1e,nintone,idisk)
c      call cclose_molcas(nft)
c write one electron fock matrix into voint
      cienergy=0.d0
      nidx=0
      nc=0
      do i=1,ng_sm
        nism  = nlsm_all(i)
        idx   = noidx(i)
        nsmint = nism*(nism+1)/2
        do lri=1,nism
          do lrj=1,lri
            nc=nc+1
            val=xfock(nc)*denm1(nc)
            if(lri.ne.lrj) val=2.d0*val
            cienergy=cienergy+val
            write(6,'(1x,i3,1x,i3,2(1x,f18.9))')
     *        lri+idx,lrj+idx,xfock(nc),denm1(nc)
          enddo
        enddo
        nidx=nidx+nsmint
      enddo

      idisk0=0
      call idafile(luciden,2,idisk_array,max_root+1,idisk0)
      idisk0=idisk_array(iroot)
      call ddafile(luciden,2,denm1,nc,idisk0)

      call daname(lutwomo,fntwomo)

      denm2=0.d0
      idisk=0
      lenrd=ntratoc*lenintegral
      write(6,*) lenrd
      call idafile(lutwomo,2,itratoc,ntratoc,idisk)
      write(6,2000)
2000  format(/7x,'symmetry',6x,' orbitals',8x,'integrals')
      do nsp=1,ng_sm
        nop=norb(nsp)
        do nsq=1,nsp
          noq=norb(nsq)
          nspq=mul_tab(nsp,nsq)
          do nsr=1,nsp
            nor=norb(nsr)
            nspqr=mul_tab(nspq,nsr)
            nssm=nsr
            if(nsr.eq.nsp) nssm=nsq
            do nss=1,nssm
              if(nspqr.ne.nss) cycle
              nos=norb(nss)

              ityp=0
              if(nsr.eq.nss) then
                nbpq=(nop+nop**2)/2
                nbrs=(nos+nos**2)/2
                if(nsp.eq.nsr) then
c  (ii|ii) type 1 int
                  nintb=(nbpq+nbpq**2)/2
                  ityp=1
                else
c  (ii|jj) type 3 int
                  nintb=nbpq*nbrs
                  ityp=3
                endif
              else
                nbpq=nop*noq
                nbrs=nor*nos
                if(nsp.eq.nsr) then
c (ij|ij) type 2 int
                  nintb=(nbpq+nbpq**2)/2
                  ityp=2
                else
c (ij|kl) type 4 int
                  nintb=nbpq*nbrs
                  ityp=4
                endif
              endif

              if(nintb.eq.0) goto 10
!              write(6,2100) nsp,nsq,nsr,nss,nop,noq,nor,nos,
!     *                      nintb
c2100          format(7x,4i2,1x,4i4,2x,3x,i9)

              iout=0
              call ddafile(lutwomo,2,buff,kbuf,idisk)
              call ddafile(luciden,2,denm2,nintb,idisk0)
              idx=0

              do li=1,nor
                ntj=nos
                if(nsr.eq.nss) ntj=li
                do lj=1,ntj
                  ntk=1
                  if(nsp.eq.nsr) ntk=li
                  do lk=ntk,nop
                    numin=1
                    if(nsp.eq.nsr.and.lk.eq.li)numin=lj
                    numax=noq
                    if(nsp.eq.nsq) numax=lk
                    do ll=numin,numax
                      iout=iout+1
                      if(iout.gt.kbuf) then
c                        call ddatard(nft,buff,kbuf,idisk)
                         call ddafile(lutwomo,2,buff,kbuf,idisk)
                         iout=1
                      endif
                      idx=idx+1
                      val=0.5d0*buff(iout)*denm2(idx)
                      if(li.ne.lj) val=2.d0*val
                      if(lk.ne.ll) val=2.d0*val
                      nc1=ipair(li,lj)
                      nc2=ipair(lk,ll)
                      if(nc1.ne.nc2) val=2.d0*val
                      cienergy=cienergy+val
!                      write(6,"(5(1x,i4),2(1x,f18.9))") li,lj,lk,ll,
!     *                                      iout,buff(iout),denm2(idx)
                    enddo
                  enddo
                enddo
              enddo
              if(idx.ne.nintb) then
                write(6,*) "in ci_dentest,count error"
      call abend()
#ifdef _XIANEST_
#endif
!               call abend
!                stop 1999
              endif
10          continue
            enddo
          enddo
        enddo
      enddo

      call daclos(lutwomo)
      write(6,"(a11,3(2x,f18.9))") "ci energy=",
     *                  cienergy,vnuc,cienergy+vnuc

#endif
      return
      end

      subroutine init_canonical
#include "drt_h.fh"
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
c========================================
c  calculate the canonical order for index transform

      l1=max_orb
      l2=max_orb*(max_orb+1)/2
      do i = 1,l1
         ican_a(i) = (i*i-i)/2
      enddo
      do i = 1,l2
         ican_b(i) = (i*i-i)/2
      enddo

      end

      subroutine density_scf_frz
#include "drt_h.fh"
      common /vect/ e(max_orb),cf(max_orb,max_orb),naorbs
      common /density/ p(max_orb,max_orb)
      parameter (zero=0.0d+00,one=1.0d+00,two=2.0d+00,four=4.0d+00)

      do i=1,naorbs
         do j=1,naorbs
            val=zero
            do k=1,norb_frz
               val=val+cf(i,k)*cf(j,k)
            enddo
            p(i,j)=val
c            write(2,'(2i8,f18.10)') i,j,p(i,j)
         enddo
      enddo

      end
      subroutine matrix_vector_multi_parellel_drt_g(sechc)
#include "drt_h.fh"

      write(6,*)
      sc1=c_time()
      call ext_space_loop_g()
      call inner_space_loop_g()
      call vd_drt_ci_new()
      call dv_drt_ci_new()
      call dd_drt_ci_new()
      call dt_drt_ci_new()
      call ds_drt_ci_new()
      call tv_drt_ci_new()
      call td_drt_ci_new()
      call tt_drt_ci_new()
      call ts_drt_ci_new()
      call sv_drt_ci_new()
      call sd_drt_ci_new_den()
      call st_drt_ci_new()
      call ss_drt_ci_new()
      sc2=c_time()
      sechc=sc2-sc1
!      write(6,'(a42,2x,f10.2,2x,a1)')'End of calculating density',
!     *      ' matrix, takes',sechc,'s'

      return
      end


      subroutine matrix_vector_multi_parellel_prt_g(sechc)
#include "drt_h.fh"

      write(6,*)
      sc1=c_time()
      call ext_space_loop_g()
      sc2=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of ext, takes',sc2-sc1,'s'
      call inner_space_loop_g()
      sc3=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of inn, takes',sc3-sc2,'s'
      call vd_drt_ci_new()
      sc4=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of vd , takes',sc4-sc3,'s'
      call dv_drt_ci_new()
      sc5=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of dv , takes',sc5-sc4,'s'
      call dd_drt_ci_new()
      sc6=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of dd , takes',sc6-sc5,'s'
      call dt_drt_ci_new()
      sc7=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of dt , takes',sc7-sc6,'s'
      call ds_drt_ci_new()
      sc8=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of ds , takes',sc8-sc7,'s'
      call tv_drt_ci_new()
      sc9=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of tv , takes',sc9-sc8,'s'
      call td_drt_ci_new()
      sc10=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of td , takes',sc10-sc9,'s'
      call tt_drt_ci_new()
      sc11=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of tt , takes',sc11-sc10,'s'
      call ts_drt_ci_new()
      sc12=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of ts , takes',sc12-sc11,'s'
      call sv_drt_ci_new()
      sc13=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of sv , takes',sc13-sc12,'s'
      call sd_drt_ci_new_den()
      sc14=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of sd , takes',sc14-sc13,'s'
      call st_drt_ci_new()
      sc15=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of st , takes',sc15-sc14,'s'
      call ss_drt_ci_new()
      sc16=c_time()
      write(6,'(a16,2x,f10.2,2x,a1)')'end of ss , takes',sc16-sc15,'s'
      sc2=c_time()
      sechc=sc2-sc1
      write(6,'(a16,2x,f10.2,2x,a1)')'end of run, takes',sechc,'s'

      return
      end

      subroutine ci_density_label_sm(iroot,ncount2)
#include "drt_h.fh"
#include "grad_h.fh"
#include "files_gugaci.fh"
      common /iaib/ ican_a(max_orb),ican_b(mtmp+max_orb)
      dimension indx_m(maxgdm),idisk_array(max_root+1)
      parameter (zero=0.0d+00, half=0.5d+00, two=2.0d+00)
c=============================================================
!    transfer the ci density matrices (dm1 and dm2)
!    based on the gamess save rule.
!      vector1(1:ncount2)=zero
!      vector1(1:ncount2)=vector2(1:ncount2)
!      vector2(1:ncount2)=zero

      denm1=0.0d0
      nc0=1
      nc1=0
      do im=1,ng_sm
        if(nlsm_all(im).eq.0) cycle
        do i=1,nlsm_all(im)
          do j=1,i
            ii=map_orb_order(i+nc1)
            jj=map_orb_order(j+nc1)
            ij=ipair(ii,jj)
            denm1(nc0)=dm1tmp(ij)
            nc0=nc0+1
          enddo
        enddo
        indx_m(im)=nc1
        nc1=nc1+nlsm_all(im)
      enddo
      idisk=0
      if(iroot.eq.1) then
        idisk_array=0
        call idafile(luciden,1,idisk_array,max_root+1,idisk)
        idisk_array(1)=idisk
      else
        idisk=0
        call idafile(luciden,2,idisk_array,max_root+1,idisk)
        idisk=idisk_array(iroot)
      endif
      call ddafile(luciden,1,denm1,nc0,idisk)

      denm2=0.d0
!label 2-elc den matrix
c cycle on symmetry
      do im=1,ng_sm
        if(nlsm_all(im).eq.0) cycle
        do jm=1,im
          if(nlsm_all(jm).eq.0) cycle
          ijm=mul_tab(im,jm)
          do km=1,im
            if(nlsm_all(km).eq.0) cycle
            le=km
            if(km.eq.im) le=jm
            do lm=1,le
              if(nlsm_all(lm).eq.0) cycle
              klm=mul_tab(km,lm)
              if(ijm.ne.klm) cycle
! ityp 1 (ii|jj) 2 (ii|jj) 3 (ij|ij) 4 (ij|kl)

c---------- cycle on on mo index
c i>=j, k>=l, ij>=kl
              nc0=0
              do k=1,nlsm_all(km)
                kk=map_orb_order(k+indx_m(km))
                lc=nlsm_all(lm)
                if(km.eq.lm) lc=k
                do l=1,lc
                  ll=map_orb_order(l+indx_m(lm))
                  kl=ipair(kk,ll)
                  ic=1
                  if(im.eq.km) ic=k
                  do i=ic,nlsm_all(im)
                    ii=map_orb_order(i+indx_m(im))
                    jc=1
                    if(im.eq.km.and.i.eq.k) jc=l
                    je=nlsm_all(jm)
                    if(im.eq.jm) je=i
                    do j=jc,je
                      jj=map_orb_order(j+indx_m(jm))
                      nc0=nc0+1
                      ij=ipair(ii,jj)
                      nc1=ipair(ij,kl)

                      val=vector2(nc1)*half
                      if(ii.ne.jj.and.kk.ne.ll) then
                        val=val*half
                      elseif(ii.eq.jj.and.kk.eq.ll.and.ii.eq.kk) then
                        val=val*two
                      endif
                      denm2(nc0)=val
                    enddo
                  enddo
                enddo
              enddo
              call ddafile(luciden,1,denm2,nc0,idisk)
c----------- end cycle on mo index
            enddo
          enddo
        enddo
      enddo

      idisk_array(iroot+1)=idisk
      idisk=0
      call idafile(luciden,1,idisk_array,max_root+1,idisk)
!      stop 1999

      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(ncount2)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
!----------------------------------------------------------------------*
!                                                                      *
!     Information pertinent to the generation of integral adresses     *
!                                                                      *
!     Square : flag which indicates the desired ordering scheme        *
!     nSyOp  : number of irreducible representations                   *
!     mxSyP  : max number of pairs of symmetry indices                 *
!     nBs    : number of atomic orbitals per irred. rep.               *
!     nSkip  : flag to exclude symmetry combinations                   *
!     DimSyB : dimension of a symmetry block                           *
!     TriSyB : symmetry block number of pairs of symmetry indices      *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     Information pertinent to translation from symmetry block         *
!     to bin numbers.                                                  *
!                                                                      *
!     Parameter definitions:                                           *
!     mSyBlk : highest possible symmetry block number                  *
!                                                                      *
!     Entries to common SRT1:                                          *
!     nBin   : total number of Bins                                    *
!     nSln   : number of submatrices (slices) per symmetry block       *
!     lSll   : length of each slice                                    *
!     IstBin : offset for bin number per symmetry block                *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     Information pertinent to the bin sort algorithm                  *
!                                                                      *
!     *--------------------------------------------------------*       *
!     *                                                        *       *
!     *  Note:                                                 *       *
!     *  These definitions depend on the record structure of   *       *
!     *       2el integral file which are given in the         *       *
!     *         common /TWODEF/ of the RDORD utility           *       *
!     *                                                        *       *
!     *--------------------------------------------------------*       *
!                                                                      *
!     Parameter definitions:                                           *
!     lBin   : buffer length of a bin                                  *
!              Note: if lBin is not a multiple of 4*lDaRec             *
!              the buffers used for intermediate storing of            *
!              labels on LuTmp are used very inefficiently             *
!                                                                      *
!     Entries to common SRT2:                                          *
!     lwIBin : array used to store index Bins                          *
!     lwVBin : array used to store value Bins                          *
!     nRec   : number of records per slice                             *
!     iDIBin : disk addresses of index bins                            *
!     iDVBin : disk addresses of value bins                            *
!     n_Int  : number of integrals in a bin                            *
!     mInt   : number of integrals and bytes in a slice                *
!     nOff1  : memory allocation offset for index bins                 *
!     nOff2  : memory allocation offset for value bins                 *
!     LuTwo  : logical unit number of ordered 2el file                 *
!     LuTmp  : logical unit number of temporary file                   *
!     iDaTw0 : first disk address after header of ordered 2el file     *
!     iDaTwo : current disk position of LuTwo                          *
!     iDaTmp : current disk position of LuTmp                          *
!     mDaTwo : highest accessed disk position of LuTwo                 *
!     mDaTwo : highest accessed disk position of LuTmp                 *
!     MxOrd  : total number of records on LuTwo                        *
!                                                                      *
!----------------------------------------------------------------------*

module Sort_data

use Definitions, only: wp, iwp

implicit none
private

#include "TwoDef.fh"

!integer(kind=iwp), parameter :: mSyBlk = 36*36 ! where 36 = 8*(8+1)/2
integer(kind=iwp) :: mSyBlk

integer(kind=iwp) :: DimSyB(8,8), iDaTmp, iDaTw0, iDaTwo,                 lBin,               LuTmp, LuTwo, mDaTmp, mDaTwo, MxOrd, &
                     mxSyP, nBin, nBs(8), nSkip(8),               nSyOp, TriSyB(8,8)
logical(kind=iwp) :: Square

integer(kind=iwp), allocatable :: iStBin(:), lSll(:), nSln(:)

integer(kind=iwp), allocatable :: iDIBin(:,:), iDVBin(:,:), IndBin(:), lIndx(:), lInts(:), lwIBin(:,:), mInt(:,:), n_Int(:), nRec(:)
real(kind=wp), allocatable :: lwVBin(:,:), ValBin(:)

public :: DimSyB, iDaTmp, iDaTw0, iDaTwo, iDIBin, iDVBin, IndBin, iStBin, lBin, lDaRec, lIndx, lInts, lSll, lStRec, lTop, LuTmp, &
          LuTwo, lwIBin, lwVBin, mDaTmp, mDaTwo, mInt, mSyBlk, MxOrd, mxSyP, n_Int, nBin, nBs, nRec, nSect, nSkip, nSln, nSyOp, &
          Square, TriSyB, ValBin

end module Sort_data

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine cart2tensor(Jc,Jt)
! this subroutine computed tensorial parameters for Hexch= S1.Jcart.S2

use Constants, only: Half, cOne, Onei
use Definitions, only: wp

implicit none
real(kind=wp), intent(in) :: Jc(3,3)
complex(kind=wp), intent(out) :: Jt(-1:1,-1:1)
complex(kind=wp) :: xx, xy, xz, yx, yy, yz, zx, zy, zz
complex(kind=wp), parameter :: c2 = Half*cOne, cx2 = sqrt(Half)*cOne

xx = jc(1,1)*cOne
xy = jc(1,2)*cOne
xz = jc(1,3)*cOne
yx = jc(2,1)*cOne
yy = jc(2,2)*cOne
yz = jc(2,3)*cOne
zx = jc(3,1)*cOne
zy = jc(3,2)*cOne
zz = jc(3,3)*cOne

jt(1,1) = c2*(xx-Onei*xy-Onei*yx-yy)
jt(-1,-1) = c2*(xx+Onei*xy+Onei*yx-yy)
jt(1,-1) = c2*(-xx-Onei*xy+Onei*yx-yy)
jt(-1,1) = c2*(-xx+Onei*xy-Onei*yx-yy)

jt(1,0) = cx2*(-xz+Onei*yz)
jt(-1,0) = cx2*(xz+Onei*yz)

jt(0,1) = cx2*(-zx+Onei*zy)
jt(0,-1) = cx2*(zx+Onei*zy)

jt(0,0) = zz

return

end subroutine cart2tensor

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Steven Vancoillie                                *
************************************************************************
************************************************************************
* Written by Steven Vancoillie, May 2011
* A set of subroutines that can handle RHS arrays in either a serial or
* parallel environment, depending on the situation.
************************************************************************
* --> when running serially, the RHS arrays are stored on LUSOLV and are
* loaded into the WORK array when needed.
* --> when running in parallel, the RHS arrays are stored on disk as
* disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
* number referring to the case, symmetry, and RHS vector respectively,
* and are loaded onto a global array when needed.
************************************************************************

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_INIT
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
      DIMENSION DUMMY(1)

C-SVC: loop over symmetry/cases, get local patch of RHS, write, and then
C update the disk address in IOFFRHS
      IDISK=0
      DO ICASE=1,13
        DO ISYM=1,NSYM
          IOFFRHS(ISYM,ICASE)=IDISK

          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          NW=NAS*NIS

          IF (NW.EQ.0) CYCLE

          CALL RHS_DISTRIBUTION(NAS,NIS,iLo,iHi,jLo,jHi)
          NRHS=NAS*(jHi-jLo+1)
          CALL DDAFILE(LURHS(1),0,DUMMY,NRHS,IDISK)

        END DO
      END DO

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_FPRINT(CTYPE,IVEC)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"

      REAL*8 :: FP(8)
      CHARACTER(LEN=*) :: CTYPE

C-SVC: print out DNRM2 of the all RHS components
      IDISK=0
      NROW=0 ! dummy initialize
      DO ICASE=1,13
        DO ISYM=1,NSYM

          NAS=NASUP(ISYM,ICASE)
          NIN=NINDEP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)

          IF (CTYPE.EQ.'C') THEN
            NROW=NAS
          ELSE IF (CTYPE.EQ.'SR') THEN
            NROW=NIN
          ELSE
            WRITE(6,'(1X,A)') 'RHS_FPRINT: invalid type: '//CTYPE
            CALL ABEND()
          END IF

          IF (NAS.NE.0 .AND. NIN.NE.0 .AND. NIS.NE.0) THEN
            CALL RHS_ALLO(NROW,NIS,lg_W)
            CALL RHS_READ(NROW,NIS,lg_W,iCASE,iSYM,iVEC)
            FP(ISYM)=SQRT(RHS_DDOT(NROW,NIS,lg_W,lg_W))
            CALL RHS_FREE(NROW,NIS,lg_W)
          ELSE
            FP(ISYM)=0.0D0
          END IF
        END DO
        WRITE(6,'(1X,I2,1X,8F21.14)') ICASE, FP(1:NSYM)
      END DO

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_ZERO(IVEC)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"

C-SVC: zero out the entire RHS vector on IVEC
      IDISK=0
      DO ICASE=1,13
        DO ISYM=1,NSYM

          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          NW=NAS*NIS

          IF (NW.NE.0) THEN
            CALL RHS_ALLO(NAS,NIS,lg_W)
            CALL RHS_SCAL(NAS,NIS,lg_W,0.0D0)
            CALL RHS_SAVE(NAS,NIS,lg_W,iCASE,iSYM,iVEC)
            CALL RHS_FREE(NAS,NIS,lg_W)
          END IF
        END DO
      END DO

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_ALLO (NAS,NIS,lg_W)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        CALL GA_CREATE_STRIPED ('V',NAS,NIS,'RHS',LG_W)
      ELSE
        NW=NAS*NIS
        CALL GETMEM('RHS','ALLO','REAL',lg_W,NW)
      END IF
#else
      NW=NAS*NIS
      CALL GETMEM('RHS','ALLO','REAL',lg_W,NW)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_FREE (NAS,NIS,lg_W)
CSVC: this routine writes the RHS array to disk
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
      LOGICAL bStat
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
CSVC: Destroy the global array
        bStat=GA_Destroy(lg_W)
      ELSE
        NW=NAS*NIS
        CALL GETMEM('RHS','FREE','REAL',lg_W,NW)
      END IF
#else
      NW=NAS*NIS
      CALL GETMEM('RHS','FREE','REAL',lg_W,NW)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_DISTRIBUTION (NAS,NIS,iLo,iHi,jLo,jHi)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

      iLo=1
      iHi=NAS

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        MYRANK=GA_NODEID()
        NPROCS=GA_NNODES()
        NBASE=NIS/NPROCS
        NREST=NIS-NBASE*NPROCS
        IF (MYRANK.LT.NREST) THEN
          jLo=MYRANK*(NBASE+1)+1
          jHi=jLo+NBASE
        ELSE
          jLo=NREST*(NBASE+1)+(MYRANK-NREST)*NBASE+1
          jHi=jLo+NBASE-1
        END IF
      ELSE
        jLo=1
        jHi=NIS
      END IF
#else
      jLo=1
      jHi=NIS
#endif
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_ACCESS (NAS,NIS,lg_W,iLo,iHi,jLo,jHi,MW)
CSVC: this routine gives a pointer to the process-local part of the RHS
C     If there is no valid local block, then the routine returns 0 for
C     iLo and jLo, and -1 for iHi and jHi. This way, loops from lower
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
* get the superindex ranges of this process's block
        myRank = GA_NodeID()
        CALL GA_Distribution (lg_W,myRank,iLo,iHi,jLo,jHi)

        IF (iLo.NE.0 .AND. (iHi-iLo+1).NE.NAS) THEN
          WRITE(6,*) 'RHS_ACCESS: mismatch in range of the superindices'
          CALL AbEnd()
        END IF

* if the block is non-empty, get access to the block
        IF (iLo.GT.0 .AND. jLo.GT.0) THEN
          IF (iHi-iLo+1.NE.NAS) THEN
            WRITE(6,*) 'RHS_ACCESS: Error: NAS mismatch, abort...'
            CALL ABEND()
          END IF
          CALL GA_Access (lg_W,iLo,iHi,jLo,jHi,MW,LDW)
          IF (LDW.NE.NAS) THEN
            WRITE(6,*) 'RHS_ACCESS: assert NAS=LDW failed, abort'
            CALL AbEnd()
          END IF
        END IF
      ELSE
        iLo=1
        iHi=NAS
        jLo=1
        jHi=NIS
        MW=lg_W
      END IF
#else
      iLo=1
      iHi=NAS
      jLo=1
      jHi=NIS
      MW=lg_W
#endif

      END
*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_RELEASE (lg_W,iLo,iHi,jLo,jHi)
CSVC: this routine releases a local block back to the global array
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        IF (iLo.GT.0 .AND. jLo.GT.0) THEN
          CALL GA_Release (lg_W,iLo,iHi,jLo,jHi)
        END IF
      END IF
#else
C Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(lg_W)
        CALL Unused_integer(iLo)
        CALL Unused_integer(iHi)
        CALL Unused_integer(jLo)
        CALL Unused_integer(jHi)
      END IF
#endif

      END
*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_RELEASE_UPDATE (lg_W,iLo,iHi,jLo,jHi)
CSVC: this routine releases a local block that was written to back to
C the global array
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        IF (iLo.GT.0 .AND. jLo.GT.0) THEN
          CALL GA_Release_Update (lg_W,iLo,iHi,jLo,jHi)
        END IF
      END IF
#else
C Avoid unused argument warnings
      IF (.FALSE.) THEN
        CALL Unused_integer(lg_W)
        CALL Unused_integer(iLo)
        CALL Unused_integer(iHi)
        CALL Unused_integer(jLo)
        CALL Unused_integer(jHi)
      END IF
#endif

      END
*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_GET (NAS,NIS,lg_W,W)
CSVC: this routine copies a global array to a local buffer
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output.fh"
#include "WrkSpc.fh"
      DIMENSION W(NAS*NIS)
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
C SVC: when the _total_ size of a message exceeds 2**31-1 _bytes_,
C some implementations (e.g. MPICH, and thus also Intel MPI) fail.
C If this is the case, chop up the largest dimension and perform the
C GA_Get in batches smaller than 2**31-1 bytes (I took 2**30).
        MAX_MESG_SIZE = 2**27
        IF (NAS*NIS.GT.MAX_MESG_SIZE) THEN
          NIS_BATCH = MAX_MESG_SIZE / NAS
          IF (NIS_BATCH.EQ.0) THEN
            WRITE(6,'(1X,A)') 'RHS_GET: NAS exceeds MAX_MESG_SIZE:'
            WRITE(6,'(1X,I12,A,I12)') NAS, ' > ', MAX_MESG_SIZE
            CALL AbEnd
          END IF
          DO NIS_STA=1,NIS,NIS_BATCH
            NIS_END=MIN(NIS_STA+NIS_BATCH-1,NIS)
            IOFF=NAS*(NIS_STA-1)+1
            CALL GA_Get (lg_W,1,NAS,NIS_STA,NIS_END,W(IOFF),NAS)
          END DO
        ELSE
          CALL GA_Get (lg_W,1,NAS,1,NIS,W,NAS)
        END IF
      ELSE
        CALL DCOPY_(NAS*NIS,WORK(lg_W),1,W,1)
      END IF
#else
      CALL DCOPY_(NAS*NIS,WORK(lg_W),1,W,1)
#endif

      END
*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_PUT (NAS,NIS,lg_W,W)
CSVC: this routine copies a local buffer to a global array
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output.fh"
#include "WrkSpc.fh"
      DIMENSION W(NAS*NIS)
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        IF (KING()) THEN
C SVC: when the _total_ size of a message exceeds 2**31-1 _bytes_,
C some implementations (e.g. MPICH, and thus also Intel MPI) fail.
C If this is the case, chop up the largest dimension and perform the
C GA_Put in batches smaller than 2**31-1 bytes (I took 2**27 elements
C which is 2**30 bytes).
          MAX_MESG_SIZE = 2**27
          IF (NAS*NIS.GT.MAX_MESG_SIZE) THEN
            NIS_BATCH = MAX_MESG_SIZE / NAS
            IF (NIS_BATCH.EQ.0) THEN
              WRITE(6,'(1X,A)') 'RHS_GET: NAS exceeds MAX_MESG_SIZE:'
              WRITE(6,'(1X,I12,A,I12)') NAS, ' > ', MAX_MESG_SIZE
              CALL AbEnd
            END IF
            DO NIS_STA=1,NIS,NIS_BATCH
              NIS_END=MIN(NIS_STA+NIS_BATCH-1,NIS)
              IOFF=NAS*(NIS_STA-1)+1
              CALL GA_Put (lg_W,1,NAS,NIS_STA,NIS_END,W(IOFF),NAS)
            END DO
          ELSE
            CALL GA_Put (lg_W,1,NAS,1,NIS,W,NAS)
          END IF
        END IF
      ELSE
        CALL DCOPY_(NAS*NIS,W,1,WORK(lg_W),1)
      END IF
#else
      CALL DCOPY_(NAS*NIS,W,1,WORK(lg_W),1)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_ADD (NAS,NIS,lg_W,W)
CSVC: this routine adds to the local part of a global RHS array the
Cmatching part of a replicate array.
      IMPLICIT REAL*8 (A-H,O-Z)
#include "output.fh"
#include "WrkSpc.fh"
      DIMENSION W(NAS,*)
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        myRank = GA_NodeID()
        CALL GA_Distribution (lg_W,myRank,iLo,iHi,jLo,jHi)
        IF (iLo.NE.0.AND.jLo.NE.0) THEN
          NW=(iHi-iLo+1)*(jHi-jLo+1)
          CALL GA_Access (lg_W,iLo,iHi,jLo,jHi,mW,LDW)
          CALL DAXPY_(NW,1.0D0,W(iLo,jLo),1,DBL_MB(mW),1)
          CALL GA_Release_Update (lg_W,iLo,iHi,jLo,jHi)
        END IF
      ELSE
        CALL DAXPY_(NAS*NIS,1.0D0,W,1,WORK(lg_W),1)
      END IF
#else
      CALL DAXPY_(NAS*NIS,1.0D0,W,1,WORK(lg_W),1)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_READ_C (lg_W,iCASE,iSYM,iVEC)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
      NAS=NASUP(ISYM,ICASE)
      NIS=NISUP(ISYM,ICASE)
      CALL RHS_READ (NAS,NIS,lg_W,ICASE,ISYM,IVEC)
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_READ_SR (lg_W,iCASE,iSYM,iVEC)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
      NIN=NINDEP(ISYM,ICASE)
      NIS=NISUP(ISYM,ICASE)
      CALL RHS_READ (NIN,NIS,lg_W,ICASE,ISYM,IVEC)
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_READ (NIN,NIS,lg_W,iCASE,iSYM,iVEC)
CSVC: this routine reads an RHS array in SR format from disk
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        CALL GA_Sync()
        myRank = GA_NodeID()
        CALL GA_Distribution (lg_W,myRank,ISTA,IEND,JSTA,JEND)
        IF (IEND-ISTA+1.EQ.NIN .AND. ISTA.GT.0) THEN
          CALL GA_Access (lg_W,ISTA,IEND,JSTA,JEND,mpt_W,LDW)
          IF (LDW.NE.NIN) THEN
            WRITE(6,*) 'RHS_READ: Assumption NIN==LDW wrong'
            CALL AbEnd()
          END IF
          NWPROC=NIN*(JEND-JSTA+1)
          IDISK=IOFFRHS(ISYM,ICASE)
          CALL DDAFILE(LURHS(IVEC),2,DBL_MB(mpt_W),NWPROC,IDISK)
          CALL GA_Release_Update (lg_W,ISTA,IEND,JSTA,JEND)
        END IF
        CALL GA_Sync()
      ELSE
        NW=NIN*NIS
        IDISK=IOFFRHS(ISYM,ICASE)
        CALL DDAFILE(LURHS(IVEC),2,WORK(lg_W),NW,IDISK)
      END IF
#else
      NW=NIN*NIS
      IDISK=IOFFRHS(ISYM,ICASE)
      CALL DDAFILE(LURHS(IVEC),2,WORK(lg_W),NW,IDISK)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_SAVE_C (lg_W,iCASE,iSYM,iVEC)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
      NAS=NASUP(ISYM,ICASE)
      NIS=NISUP(ISYM,ICASE)
      CALL RHS_SAVE (NAS,NIS,lg_W,ICASE,ISYM,IVEC)
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_SAVE_SR (lg_W,iCASE,iSYM,iVEC)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
      NIN=NINDEP(ISYM,ICASE)
      NIS=NISUP(ISYM,ICASE)
      CALL RHS_SAVE (NIN,NIS,lg_W,ICASE,ISYM,IVEC)
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_SAVE (NIN,NIS,lg_W,iCASE,iSYM,iVEC)
CSVC: this routine reads an RHS array in SR format from disk
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        CALL GA_Sync()
        myRank = GA_NodeID()
        CALL GA_Distribution (lg_W,myRank,ISTA,IEND,JSTA,JEND)
        IF (IEND-ISTA+1.EQ.NIN .AND. ISTA.GT.0) THEN
          CALL GA_Access (lg_W,ISTA,IEND,JSTA,JEND,mpt_W,LDW)
          IF (LDW.NE.NIN) THEN
            WRITE(6,*) 'RHS_SAVE: Assumption NIN==LDW wrong'
            CALL AbEnd()
          END IF
          NWPROC=NIN*(JEND-JSTA+1)
          IDISK=IOFFRHS(ISYM,ICASE)
          CALL DDAFILE(LURHS(IVEC),1,DBL_MB(mpt_W),NWPROC,IDISK)
          CALL GA_Release (lg_W,ISTA,IEND,JSTA,JEND)
        END IF
        CALL GA_Sync()
      ELSE
        NW=NIN*NIS
        IDISK=IOFFRHS(ISYM,ICASE)
        CALL DDAFILE(LURHS(IVEC),1,WORK(lg_W),NW,IDISK)
      END IF
#else
      NW=NIN*NIS
      IDISK=IOFFRHS(ISYM,ICASE)
      CALL DDAFILE(LURHS(IVEC),1,WORK(lg_W),NW,IDISK)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_SCATTER (LDW,lg_W,Buff,idxW,nBuff)
CSVC: this routine scatters + adds values of a buffer array into the RHS
C     array at positions given by the buffer index array.
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
      DIMENSION Buff(nBuff),idxW(nBuff)
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
CSVC: global array RHS matrix expects 2 index buffers
        CALL GETMEM('TMPW1','ALLO','INTE',LTMPW1,nBuff)
        CALL GETMEM('TMPW2','ALLO','INTE',LTMPW2,nBuff)
        DO I=1,nBuff
          IWORK(LTMPW2+I-1)=(idxW(I)-1)/LDW+1
          IWORK(LTMPW1+I-1)=idxW(I)-LDW*(IWORK(LTMPW2+I-1)-1)
        END DO
#ifdef _GA_
        CALL GA_Scatter_Acc (lg_W,Buff,
     &     IWORK(LTMPW1),IWORK(LTMPW2),nBuff,1.0D0)
#else
        WRITE(6,'(1X,A)') 'RHS_SCATTER: Fatal Error: no GA support!'
        WRITE(6,'(1X,A)') 'Either build Molcas with Global Arrays or'
        WRITE(6,'(1X,A)') 'use the RHSD keyword to enable on-demand.'
        WRITE(6,'(1X,A)') 'Aborting...'
        CALL AbEnd()
#endif
        CALL GETMEM('TMPW1','FREE','INTE',LTMPW1,nBuff)
        CALL GETMEM('TMPW2','FREE','INTE',LTMPW2,nBuff)
      ELSE
        DO I=1,nBuff
          WORK(lg_W+idxW(I)-1)=WORK(lg_W+idxW(I)-1)+Buff(I)
        END DO
      END IF
#else
      DO I=1,nBuff
        WORK(lg_W+idxW(I)-1)=WORK(lg_W+idxW(I)-1)+Buff(I)
      END DO
C Avoid unused argument warnings
      IF (.FALSE.) Call Unused_integer(LDW)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE DRA2SOLV (NAS,NIS,iCASE,iSYM,iVEC)
CSVC: FIXME: this temporary routine copies the RHS arrays from DRAs to
C     LUSOLV and should be removed once the full paralellization is in
C     place and transition is no longer needed.
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "output.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
*     LOGICAL bStat
#endif

CSVC: Read the global array from disk
      CALL RHS_ALLO (NAS,NIS,lg_W)
      CALL RHS_READ (NAS,NIS,lg_W,ICASE,ISYM,IVEC)

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
CSVC: Only the master process writes to LUSOLV!!
CSVC: be careful to only call one-sided operations
        IF (KING()) THEN
CSVC: write the global array to LUSOLV
C     when all routines have been adapted, this can go into SYNRHS and
C     later it should be completely removed when VCUTIL and SGM are
C     adapted for handling global + disk resident arrays then, also
C     remove iCASE,iSYM,iVEC from the call, as they are no longer needed
C     in that case.
          CALL GETMEM('MAXMEM','MAX','REAL',iDummy,iMax)
C-SVC: GA_Get does not like large buffer sizes, put upper limit at 1GB
          iMax=MIN(NINT(0.95D0*iMax),134217728)
          NCOL=MIN(iMAX,NAS*NIS)/NAS
          IF (NCOL.LE.0) THEN
            WRITE(6,*) 'Not enough memory in DRA2SOLV, aborting...'
            CALL AbEnd()
          END IF
          NW=NAS*NCOL
          CALL GETMEM('TMPW','ALLO','REAL',LTMPW,NW)
CSVC: Write local array to LUSOLV
          IDISK=IWORK(LIDSCT+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1))))
          DO ISTA=1,NIS,NCOL
            IEND=MIN(ISTA+NCOL-1,NIS)
            CALL GA_Get (lg_W,1,NAS,ISTA,IEND,WORK(LTMPW),NAS)
            CALL DDAFILE(LUSOLV,1,WORK(LTMPW),NAS*(IEND-ISTA+1),IDISK)
          END DO
          CALL GETMEM('TMPW','FREE','REAL',LTMPW,NW)
        END IF
        CALL GASync
CSVC: Destroy the global array
*       bStat=GA_Destroy(lg_W)
      ELSE
      IDISK=IWORK(LIDSCT+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1))))
      CALL DDAFILE(LUSOLV,1,WORK(lg_W),NAS*NIS,IDISK)
      END IF
#else
      IDISK=IWORK(LIDSCT+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1))))
      CALL DDAFILE(LUSOLV,1,WORK(lg_W),NAS*NIS,IDISK)
#endif

      CALL RHS_FREE (NAS,NIS,lg_W)

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE SOLV2DRA (NAS,NIS,iCASE,iSYM,iVEC)
CSVC: FIXME: this temporary routine copies the RHS arrays from DRAs to
C     LUSOLV and should be removed once the full paralellization is in
C     place and transition is no longer needed.
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "output.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
*     LOGICAL bStat
#endif

      CALL RHS_ALLO (NAS,NIS,lg_W)

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
CSVC: Read the global array from disk
CSVC: Only the master process writes to LUSOLV!!
CSVC: be careful to only call one-sided operations
        IF (KING()) THEN
CSVC: write the LUSOLV array to global RHS array
C     later it should be completely removed when everything is parallel
          CALL GETMEM('MAXMEM','MAX','REAL',iDummy,iMax)
C-SVC: GA_Get does not like large buffer sizes, put upper limit at 1GB
          iMax=MIN(NINT(0.95D0*iMax),134217728)
          NCOL=MIN(iMAX,NAS*NIS)/NAS
          IF (NCOL.LE.0) THEN
            WRITE(6,*) 'Not enough memory in SOLV2DRA, aborting...'
            CALL AbEnd()
          END IF
          NW=NAS*NCOL
          CALL GETMEM('TMPW','ALLO','REAL',LTMPW,NW)
CSVC: Read local array from LUSOLV
          IDISK=IWORK(LIDSCT+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1))))
          DO ISTA=1,NIS,NCOL
            IEND=MIN(ISTA+NCOL-1,NIS)
            CALL DDAFILE(LUSOLV,2,WORK(LTMPW),NAS*(IEND-ISTA+1),IDISK)
            CALL GA_Put (lg_W,1,NAS,ISTA,IEND,WORK(LTMPW),NAS)
          END DO
          CALL GETMEM('TMPW','FREE','REAL',LTMPW,NW)
        END IF
        CALL GASync
CSVC: Destroy the global array
*       bStat=GA_Destroy(lg_W)
      ELSE
        NW=NAS*NIS
        IDISK=IWORK(LIDSCT+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1))))
        CALL DDAFILE(LUSOLV,2,WORK(lg_W),NW,IDISK)
      END IF
#else
      NW=NAS*NIS
      IDISK=IWORK(LIDSCT+MXSCT*(ISYM-1+8*(ICASE-1+MXCASE*(IVEC-1))))
      CALL DDAFILE(LUSOLV,2,WORK(lg_W),NW,IDISK)
#endif

      CALL RHS_SAVE (NAS,NIS,lg_W,ICASE,ISYM,IVEC)
      CALL RHS_FREE (NAS,NIS,lg_W)

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_SCAL (NAS,NIS,lg_W,FACT)
CSVC: this routine multiplies the RHS array with FACT
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        IF (FACT.EQ.0.0D0) THEN
C          CALL GA_Fill (lg_W,0.0D0)
           CALL GA_Zero (lg_W)
        ELSE
          IF (FACT.NE.1.0D0) THEN
            CALL GA_Scale (lg_W,FACT)
          END IF
        END IF
      ELSE
        IF(FACT.EQ.0.0D0) THEN
            CALL DCOPY_(NAS*NIS,[0.0D0],0,WORK(lg_W),1)
        ELSE
          IF(FACT.NE.1.0D00) THEN
            CALL DSCAL_(NAS*NIS,FACT,WORK(lg_W),1)
          END IF
        END IF
      END IF
#else
      IF(FACT.EQ.0.0D0) THEN
          CALL DCOPY_(NAS*NIS,[0.0D0],0,WORK(lg_W),1)
      ELSE
        IF(FACT.NE.1.0D00) THEN
          CALL DSCAL_(NAS*NIS,FACT,WORK(lg_W),1)
        END IF
      END IF
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_SR2C (ITYP,IREV,NAS,NIS,NIN,lg_V1,lg_V2,ICASE,ISYM)
CSVC: this routine transforms the RHS arrays from SR format (V1) to C
C     format (V2) (IREV=0) and back (IREV=1), with ITYP specifying if
C     only the T matrix is used (ITYP=0) or the product of S and T
C     (ITYP=1).
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "output.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
      LOGICAL bStat
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        IF (ICASE.EQ.1 .OR. ICASE.EQ.4) THEN
C-SVC: if case is A or C, the S/ST matrices are loaded as global arrays,
C      then use the dgemm from GA to operate.
          CALL GA_CREATE_STRIPED ('H',NAS,NIN,'TMAT',lg_T)
          IF (ITYP.EQ.0) THEN
            CALL PSBMAT_READ ('T',iCase,iSym,lg_T,NAS*NIN)
          ELSE IF (ITYP.EQ.1) THEN
            CALL PSBMAT_READ ('M',iCase,iSym,lg_T,NAS*NIN)
          ELSE
            WRITE(6,*) 'RHS_SR2C: invalid type = ', ITYP
            CALL AbEnd()
          END IF

#ifdef _GA_
          IF (IREV.EQ.0) THEN
            CALL GA_DGEMM ('N','N',NAS,NIS,NIN,
     &                     1.0D0,lg_T,lg_V1,0.0D0,lg_V2)
          ELSE
            CALL GA_DGEMM ('T','N',NIN,NIS,NAS,
     &                     1.0D0,lg_T,lg_V2,0.0D0,lg_V1)
          END IF
#else
          MYRANK=GA_NODEID()
          NPROCS=GA_NNODES()
          ! zero the receiving array to be able to perform the matrix
          ! multiplication in a block-wise fashion, adding contributions
          IF (IREV.EQ.0) THEN
            CALL GA_Zero (lg_V2)
          ELSE
            CALL GA_Zero (lg_V1)
          END IF
          ! get local stripes of RHS vectors
          CALL GA_Distribution (lg_V1,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
          CALL GA_Distribution (lg_V2,myRank,iLoV2,iHiV2,jLoV2,jHiV2)
          IF (jLoV1.NE.0.AND.jLoV2.NE.0) THEN
            NROW1=iHiV1-iLoV1+1
            NROW2=iHiV2-iLoV2+1
            NCOL1=jHiV1-jLoV1+1
            NCOL2=jHiV2-jLoV2+1
            IF (NCOL1.NE.NCOL2 .OR. NROW1.NE.NIN .OR. NROW2.NE.NAS) THEN
              WRITE(6,*) 'RHS_SR2C: inconsistent stripe size'
              WRITE(6,'(A,I3)') 'ICASE = ', ICASE
              WRITE(6,'(A,I3)') 'ISYM  = ', ISYM
              WRITE(6,'(A,2I6)') 'NCOL1, NCOL2 = ', NCOL1, NCOL2
              WRITE(6,'(A,2I6)') 'NROW1, NIN   = ', NROW1, NIN
              WRITE(6,'(A,2I6)') 'NROW2, NAS   = ', NROW2, NAS
              CALL AbEnd()
            END IF
            CALL GA_Access (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)
            CALL GA_Access (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2,mV2,LDV2)
            ! loop over processes and obtain blocks of the T matrix
            DO IRANK=0,NPROCS-1
              CALL GA_Distribution (lg_T,IRANK,iLoT,iHiT,jLoT,jHiT)
              IF (iLoT.NE.0 .AND. jLoT.NE.0) THEN
                NROWT=iHiT-iLoT+1
                NCOLT=jHiT-jLoT+1
                CALL GETMEM('LT','ALLO','REAL',LT,NROWT*NCOLT)
                CALL GA_Get (lg_T,iLoT,iHiT,jLoT,jHiT,WORK(LT),NROWT)
                IF (IREV.EQ.0) THEN
                  CALL DGEMM_('N','N',NROWT,NCOL1,NCOLT,
     &                    1.0d0,WORK(LT),NROWT,DBL_MB(mV1+jLoT-1),LDV1,
     &                    1.0d0,DBL_MB(mV2+iLoT-1),LDV2)
                ELSE
                  CALL DGEMM_('T','N',NCOLT,NCOL1,NROWT,
     &                    1.0d0,WORK(LT),NROWT,DBL_MB(mV2+iLoT-1),LDV2,
     &                    1.0d0,DBL_MB(mV1+jLoT-1),LDV1)
                END IF
                CALL GETMEM('LT','FREE','REAL',LT,NROWT*NCOLT)
              END IF
            END DO
            CALL GA_Release_Update (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1)
            CALL GA_Release_Update (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2)
          END IF
#endif
          bStat = GA_Destroy(lg_T)
        ELSE
C-SVC: if case is not A or C, the S/ST matrices are stored in replicate
C      fashion, and the RHS are stored as vertical stripes, so use dgemm
C      on local memory, after accessing the local patch of the vector.
          CALL GETMEM('LT','ALLO','REAL',LT,NAS*NIN)
          IF (ITYP.EQ.0) THEN
            IDT=IDTMAT(ISYM,ICASE)
          ELSE IF (ITYP.EQ.1) THEN
            IDT=IDSTMAT(ISYM,ICASE)
          ELSE
            WRITE(6,*) 'RHS_SR2C: invalid type = ', ITYP
            CALL AbEnd()
          END IF
          CALL DDAFILE(LUSBT,2,WORK(LT),NAS*NIN,IDT)
C-SVC: get the local vertical stripes of the V1 and V2 vectors
          CALL GA_Sync()
          myRank = GA_NodeID()
          CALL GA_Distribution (lg_V1,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
          CALL GA_Distribution (lg_V2,myRank,iLoV2,iHiV2,jLoV2,jHiV2)
          IF (jLoV1.NE.0.AND.jLoV2.NE.0) THEN
            NROW1=iHiV1-iLoV1+1
            NROW2=iHiV2-iLoV2+1
            NCOL1=jHiV1-jLoV1+1
            NCOL2=jHiV2-jLoV2+1
            IF (NCOL1.NE.NCOL2 .OR. NROW1.NE.NIN .OR. NROW2.NE.NAS) THEN
              WRITE(6,*) 'RHS_SR2C: inconsistent stripe size'
              WRITE(6,'(A,I3)') 'ICASE = ', ICASE
              WRITE(6,'(A,I3)') 'ISYM  = ', ISYM
              WRITE(6,'(A,2I6)') 'NCOL1, NCOL2 = ', NCOL1, NCOL2
              WRITE(6,'(A,2I6)') 'NROW1, NIN   = ', NROW1, NIN
              WRITE(6,'(A,2I6)') 'NROW2, NAS   = ', NROW2, NAS
              CALL AbEnd()
            END IF
            CALL GA_Access (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)
            CALL GA_Access (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2,mV2,LDV2)
            IF (IREV.EQ.0) THEN
              CALL DGEMM_('N','N',NAS,NCOL1,NIN,
     &                    1.0d0,WORK(LT),NAS,DBL_MB(mV1),LDV1,
     &                    0.0d0,DBL_MB(mV2),LDV2)
            ELSE
              CALL DGEMM_('T','N',NIN,NCOL1,NAS,
     &                    1.0d0,WORK(LT),NAS,DBL_MB(mV2),LDV2,
     &                    0.0d0,DBL_MB(mV1),LDV1)
*             WRITE(6,*) 'Fingerprint =', RHS_DDOT(NAS,NIN,lg_V1,lg_V1)
            END IF
            CALL GA_Release_Update (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1)
            CALL GA_Release_Update (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2)
          END IF
          CALL GETMEM('LT','FREE','REAL',LT,NAS*NIN)
          CALL GA_Sync()
        END IF
      ELSE
        CALL GETMEM('LT','ALLO','REAL',LT,NAS*NIN)
        IF (ITYP.EQ.0) THEN
          IDT=IDTMAT(ISYM,ICASE)
        ELSE IF (ITYP.EQ.1) THEN
          IDT=IDSTMAT(ISYM,ICASE)
        ELSE
          WRITE(6,*) 'RHS_SR2C: invalid type = ', ITYP
          CALL AbEnd()
        END IF
        CALL DDAFILE(LUSBT,2,WORK(LT),NAS*NIN,IDT)
        IF (IREV.EQ.0) THEN
          CALL DGEMM_('N','N',NAS,NIS,NIN,
     &                1.0d0,WORK(LT),NAS,WORK(lg_V1),NIN,
     &                0.0d0,WORK(lg_V2),NAS)
        ELSE
          CALL DGEMM_('T','N',NIN,NIS,NAS,
     &                1.0d0,WORK(LT),NAS,WORK(lg_V2),NAS,
     &                0.0d0,WORK(lg_V1),NIN)
        END IF
        CALL GETMEM('LT','FREE','REAL',LT,NAS*NIN)
      END IF
#else
      CALL GETMEM('LT','ALLO','REAL',LT,NAS*NIN)
      IF (ITYP.EQ.0) THEN
        IDT=IDTMAT(ISYM,ICASE)
      ELSE IF (ITYP.EQ.1) THEN
        IDT=IDSTMAT(ISYM,ICASE)
      ELSE
        WRITE(6,*) 'RHS_SR2C: invalid type = ', ITYP
        CALL AbEnd()
      END IF
      CALL DDAFILE(LUSBT,2,WORK(LT),NAS*NIN,IDT)
      IF (IREV.EQ.0) THEN
        CALL DGEMM_('N','N',NAS,NIS,NIN,
     &              1.0d0,WORK(LT),NAS,WORK(lg_V1),NIN,
     &              0.0d0,WORK(lg_V2),NAS)
      ELSE
        CALL DGEMM_('T','N',NIN,NIS,NAS,
     &              1.0d0,WORK(LT),NAS,WORK(lg_V2),NAS,
     &              0.0d0,WORK(lg_V1),NIN)
      END IF
      CALL GETMEM('LT','FREE','REAL',LT,NAS*NIN)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_STRANS (NAS,NIS,ALPHA,lg_V1,lg_V2,ICASE,ISYM)
CSVC: this routine transforms RHS array V1 by multiplying on the left
C     with the S matrix and adds the result in V2: V2 <- V2 + alpha S*V1
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "caspt2.fh"
#include "eqsolv.fh"
#include "WrkSpc.fh"
#include "output.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
      LOGICAL bStat
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        IF (ICASE.EQ.1 .OR. ICASE.EQ.4) THEN
C-SVC: if case is A or C, the S/ST matrices are loaded as global arrays,
C      then use the dgemm from GA to operate.
          CALL PSBMAT_GETMEM('S',lg_S,NAS)
          CALL PSBMAT_READ('S',iCase,iSym,lg_S,NAS)
#ifdef _GA_
          CALL GA_DGEMM ('N','N',NAS,NIS,NAS,
     &                   ALPHA,lg_S,lg_V1,1.0D0,lg_V2)
#else
          MYRANK=GA_NODEID()
          NPROCS=GA_NNODES()
          ! get local stripes of RHS vectors
          CALL GA_Distribution (lg_V1,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
          CALL GA_Distribution (lg_V2,myRank,iLoV2,iHiV2,jLoV2,jHiV2)
          IF (jLoV1.NE.0.AND.jLoV2.NE.0) THEN
            NROW1=iHiV1-iLoV1+1
            NROW2=iHiV2-iLoV2+1
            NCOL1=jHiV1-jLoV1+1
            NCOL2=jHiV2-jLoV2+1
            IF (NCOL1.NE.NCOL2 .OR. NROW1.NE.NAS .OR. NROW2.NE.NAS) THEN
              WRITE(6,*) 'RHS_STRANS: inconsistent stripe size'
              WRITE(6,'(A,I3)') 'ICASE = ', ICASE
              WRITE(6,'(A,I3)') 'ISYM  = ', ISYM
              WRITE(6,'(A,2I6)') 'NCOL1, NCOL2 = ', NCOL1, NCOL2
              WRITE(6,'(A,2I6)') 'NROW1, NAS   = ', NROW1, NIN
              WRITE(6,'(A,2I6)') 'NROW2, NAS   = ', NROW2, NAS
              CALL AbEnd()
            END IF
            CALL GA_Access (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)
            CALL GA_Access (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2,mV2,LDV2)
            ! loop over processes and obtain blocks of the T matrix
            DO IRANK=0,NPROCS-1
              CALL GA_Distribution (lg_S,IRANK,iLoS,iHiS,jLoS,jHiS)
              IF (iLoS.NE.0 .AND. jLoS.NE.0) THEN
                NROWS=iHiS-iLoS+1
                NCOLS=jHiS-jLoS+1
                CALL GETMEM('LS','ALLO','REAL',LS,NROWS*NCOLS)
                CALL GA_Get (lg_S,iLoS,iHiS,jLoS,jHiS,WORK(LS),NROWS)
                CALL DGEMM_('N','N',NROWS,NCOL1,NCOLS,
     &                    ALPHA,WORK(LS),NROWS,DBL_MB(mV1+jLoS-1),LDV1,
     &                    1.0d0,DBL_MB(mV2+iLoS-1),LDV2)
                CALL GETMEM('LS','FREE','REAL',LS,NROWS*NCOLS)
              END IF
            END DO
            CALL GA_Release (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1)
            CALL GA_Release_Update (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2)
          END IF
#endif
          bStat = GA_Destroy(lg_S)
        ELSE
C-SVC: if case is not A or C, the S/ST matrices are stored in replicate
C      fashion, and the RHS are stored as vertical stripes, so use
C      trimul on local memory, after accessing the local patch of the
C      vector.
          NS=(NAS*(NAS+1))/2
          CALL GETMEM('LS','ALLO','REAL',LS,NS)
          IDS=IDSMAT(ISYM,ICASE)
          CALL DDAFILE(LUSBT,2,WORK(LS),NS,IDS)
C-SVC: get the local vertical stripes of the V1 and V2 vectors
          CALL GA_Sync()
          myRank = GA_NodeID()
          CALL GA_Distribution (lg_V1,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
          CALL GA_Distribution (lg_V2,myRank,iLoV2,iHiV2,jLoV2,jHiV2)
          IF (jLoV1.NE.0.AND.jLoV2.NE.0) THEN
            NROW1=iHiV1-iLoV1+1
            NROW2=iHiV2-iLoV2+1
            NCOL1=jHiV1-jLoV1+1
            NCOL2=jHiV2-jLoV2+1
            IF (NCOL1.NE.NCOL2 .OR. NROW1.NE.NROW2 .OR.
     &          NROW1.NE.NAS) THEN
              WRITE(6,*) 'RHS_STRANS: inconsistent stripe size'
              WRITE(6,'(A,I3)') 'ICASE = ', ICASE
              WRITE(6,'(A,I3)') 'ISYM  = ', ISYM
              WRITE(6,'(A,2I6)') 'NCOL1, NCOL2 = ', NCOL1, NCOL2
              WRITE(6,'(A,2I6)') 'NROW1, NROW2 = ', NROW1, NROW2
              CALL AbEnd()
            END IF
            CALL GA_Access (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)
            CALL GA_Access (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2,mV2,LDV2)
            CALL TRIMUL(NAS,NCOL1,ALPHA,WORK(LS),
     &                  DBL_MB(mV1),LDV1,DBL_MB(mV2),LDV2)
            CALL GA_Release_Update (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1)
            CALL GA_Release_Update (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2)
          END IF
          CALL GA_Sync()
          CALL GETMEM('LS','FREE','REAL',LS,NS)
        END IF
      ELSE
        NS=(NAS*(NAS+1))/2
        CALL GETMEM('LS','ALLO','REAL',LS,NS)
        IDS=IDSMAT(ISYM,ICASE)
        CALL DDAFILE(LUSBT,2,WORK(LS),NS,IDS)
        CALL TRIMUL(NAS,NIS,ALPHA,WORK(LS),
     &              WORK(lg_V1),NAS,WORK(lg_V2),NAS)
        CALL GETMEM('LS','FREE','REAL',LS,NS)
      END IF
#else
      NS=(NAS*(NAS+1))/2
      CALL GETMEM('LS','ALLO','REAL',LS,NS)
      IDS=IDSMAT(ISYM,ICASE)
      CALL DDAFILE(LUSBT,2,WORK(LS),NS,IDS)
      CALL TRIMUL(NAS,NIS,ALPHA,WORK(LS),
     &            WORK(lg_V1),NAS,WORK(lg_V2),NAS)
      CALL GETMEM('LS','FREE','REAL',LS,NS)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      REAL*8 FUNCTION RHS_DDOT(NAS,NIS,lg_V1,lg_V2)
CSVC: this routine computes the DDOT of the RHS arrays V1 and V2
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
#ifdef _GA_
        RHS_DDOT = GA_DDOT(lg_V1,lg_V2)
#else
        RHS_DDOT=0.0D0
        MYRANK=GA_NODEID()
        NPROCS=GA_NNODES()
        IF (lg_V1.NE.lg_V2) THEN
          CALL GA_Distribution (lg_V1,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
          CALL GA_Distribution (lg_V2,myRank,iLoV2,iHiV2,jLoV2,jHiV2)
          IF (jLoV1.NE.0.AND.jLoV2.NE.0) THEN
            NROW1=iHiV1-iLoV1+1
            NROW2=iHiV2-iLoV2+1
            NCOL1=jHiV1-jLoV1+1
            NCOL2=jHiV2-jLoV2+1
            IF (NCOL1.NE.NCOL2 .OR. NROW1.NE.NROW2) THEN
              WRITE(6,*) 'RHS_DDOT: inconsistent stripe size'
              WRITE(6,'(A,2I6)') 'NCOL1, NCOL2 = ', NCOL1, NCOL2
              WRITE(6,'(A,2I6)') 'NROW1, NROW2 = ', NROW1, NROW2
              CALL AbEnd()
            END IF
            CALL GA_Access (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)
            CALL GA_Access (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2,mV2,LDV2)
            RHS_DDOT=DDOT_(NROW1*NCOL1,DBL_MB(mV1),1,DBL_MB(mV2),1)
            CALL GA_Release (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1)
            CALL GA_Release (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2)
          END IF
        ELSE
          CALL GA_Distribution (lg_V1,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
          IF (jLoV1.NE.0) THEN
            NROW1=iHiV1-iLoV1+1
            NCOL1=jHiV1-jLoV1+1
            CALL GA_Access (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)
            RHS_DDOT=DDOT_(NROW1*NCOL1,DBL_MB(mV1),1,DBL_MB(mV1),1)
            CALL GA_Release (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1)
          END IF
        END IF
        CALL GADSUM_SCAL(RHS_DDOT)
#endif
      ELSE
        RHS_DDOT = DDOT_(NAS*NIS,WORK(lg_V1),1,WORK(lg_V2),1)
      END IF
#else
      RHS_DDOT = DDOT_(NAS*NIS,WORK(lg_V1),1,WORK(lg_V2),1)
#endif

      RETURN
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_DAXPY (NAS,NIS,ALPHA,lg_V1,lg_V2)
CSVC: this routine computes product ALPHA * V1 and adds to V2
      IMPLICIT REAL*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        myRank = GA_NodeID()
        CALL GA_Distribution (lg_V1,myRank,iLoV1,iHiV1,jLoV1,jHiV1)
        CALL GA_Distribution (lg_V2,myRank,iLoV2,iHiV2,jLoV2,jHiV2)
        IF (iLoV1.NE.0.AND.iLoV2.NE.0) THEN
          NV1=(iHiV1-iLoV1+1)*(jHiV1-jLoV1+1)
          NV2=(iHiV2-iLoV2+1)*(jHiV2-jLoV2+1)
          IF (NV1.NE.NV2) CALL AbEnd()
          CALL GA_Access (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1,mV1,LDV1)
          CALL GA_Access (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2,mV2,LDV2)
          ! V2 <- alpha*V1 + V2
          CALL DAXPY_(NV1,ALPHA,DBL_MB(mV1),1,DBL_MB(mV2),1)
          CALL GA_Release_Update (lg_V2,iLoV2,iHiV2,jLoV2,jHiV2)
          CALL GA_Release (lg_V1,iLoV1,iHiV1,jLoV1,jHiV1)
        END IF
      ELSE
        CALL DAXPY_(NAS*NIS,ALPHA,WORK(lg_V1),1,WORK(lg_V2),1)
      END IF
#else
      CALL DAXPY_(NAS*NIS,ALPHA,WORK(lg_V1),1,WORK(lg_V2),1)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_RESDIA(NIN,NIS,lg_W,DIN,DIS,DOVL)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION DIN(*),DIS(*)

C Apply the resolvent of the diagonal part of H0 to an RHS array

#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        DOVL=0.0D0
        CALL GA_Sync()
        myRank = GA_NodeID()
C-SVC: get the local vertical stripes of the lg_W vector
        CALL GA_Distribution (lg_W,myRank,iLo,iHi,jLo,jHi)
        IF (iLo.NE.0.AND.jLo.NE.0) THEN
          NROW=iHi-iLo+1
          NCOL=jHi-jLo+1
          CALL GA_Access (lg_W,iLo,iHi,jLo,jHi,mW,LDW)
          CALL RESDIA(NROW,NCOL,DBL_MB(mW),LDW,DIN(iLo),
     &                DIS(jLo),SHIFT,SHIFTI,DOVL)
          CALL GA_Release_Update (lg_W,iLo,iHi,jLo,jHi)
        END IF
        CALL GA_Sync()
        CALL GAdSUM_SCAL(DOVL)
      ELSE
        CALL RESDIA(NIN,NIS,WORK(lg_W),NIN,DIN,DIS,
     &                   SHIFT,SHIFTI,DOVL)
      END IF
#else
      CALL RESDIA(NIN,NIS,WORK(lg_W),NIN,DIN,DIS,
     &                 SHIFT,SHIFTI,DOVL)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RHS_SGMDIA(NIN,NIS,lg_W,DIN,DIS)
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
      DIMENSION DIN(*),DIS(*)

C Apply the resolvent of the diagonal part of H0 to an RHS array

#include "para_info.fh"
#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#ifdef _MOLCAS_MPP_
      IF (Is_Real_Par()) THEN
        CALL GA_Sync()
        myRank = GA_NodeID()
C-SVC: get the local vertical stripes of the lg_W vector
        CALL GA_Distribution (lg_W,myRank,iLo,iHi,jLo,jHi)
        IF (iLo.NE.0.AND.jLo.NE.0) THEN
          NROW=iHi-iLo+1
          NCOL=jHi-jLo+1
          CALL GA_Access (lg_W,iLo,iHi,jLo,jHi,mW,LDW)
          CALL SGMDIA(NROW,NCOL,DBL_MB(mW),LDW,
     &                DIN(iLo),DIS(jLo),SHIFT,SHIFTI)
          CALL GA_Release_Update (lg_W,iLo,iHi,jLo,jHi)
        END IF
        CALL GA_Sync()
      ELSE
        CALL SGMDIA(NIN,NIS,WORK(lg_W),NIN,DIN,DIS,SHIFT,SHIFTI)
      END IF
#else
      CALL SGMDIA(NIN,NIS,WORK(lg_W),NIN,DIN,DIS,SHIFT,SHIFTI)
#endif

      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE RESDIA(NROW,NCOL,W,LDW,DIN,DIS,
     &                  SHIFT,SHIFTI,DOVL)
      IMPLICIT REAL*8 (A-H,O-Z)

      DIMENSION W(LDW,*),DIN(*),DIS(*)

      DOVL=0.0D0
      DO J=1,NCOL
        DO I=1,NROW
        DELTA=SHIFT+DIN(I)+DIS(J)
        DELINV=DELTA/(DELTA**2+SHIFTI**2)
        TMP=DELINV*W(I,J)
        DOVL=DOVL+TMP*W(I,J)
        W(I,J)=TMP
        END DO
      END DO
      END

*||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*
      SUBROUTINE SGMDIA(NROW,NCOL,W,LDW,DIN,DIS,SHIFT,SHIFTI)
      IMPLICIT REAL*8 (A-H,O-Z)

      DIMENSION W(LDW,*),DIN(*),DIS(*)

      DO J=1,NCOL
        DO I=1,NROW
        DELTA=SHIFT+DIN(I)+DIS(J)
        DELINV=DELTA+SHIFTI**2/DELTA
        W(I,J)=DELINV*W(I,J)
        END DO
      END DO
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine SXHAM(D,P,PA,FP,SXN,F1,F2,DIA,G,H,HDIAG,DF,DDIAG)
! RASSCF VERSION IBM-3090: SX-SECTION
!
! Objective: Compute the auxiliary matrices G,H,F1,F2,and SXN
! defined as:
!
! G(pq)=sum(r,s)(2*P(pqrs)-D(pq)*D(rs))*FP(rs)
! H(pq)=G(pq)+DF(pq)+DF(qp)  where
! DF(pq)=sum(r)D(pr)*FP(rq)
! F1 is the occupied part of the SX Fock matrix FP
! F2 is the active-external part of the same matrix
! DIA is the occupied part of the density matrix(squared)
! SXN contains normalization factors for the SX states
! HDIAG is the diagonal of the SX Hamiltonian
! All matrices are blocked according to symmetry
! Each block having the dimension
! G, DIA, AND F1:     (NIO+NAO)**2
! F2:                 (NAO+NEO)**2
! H:                  NAO*NAE
! SXN:                (NIO+NAO)*(NAO+NEO)
! HDIAG:              NROOT+(NIO+NAO)*(NAO+NEO)
!
! These matrices are used to simplify the calculation
! of the sigma vector (see SIGVEC for further details).
!
! Called from SXCTL
!
! Subroutine calls: none
!
! ********** IBM-3090 RELEASE 89 01 23 **********

use Index_Functions, only: iTri, nTri_Elem
use rasscf_global, only: Ener, ExFac, ICICP, IROOT, ISCF, ITER, IXSYM, IZROT, LVSHFT, NROOT, NSXS, SXSHFT
use PrintLevel, only: DEBUG
use output_ras, only: IPRLOC
use general_data, only: NASH, NBAS, NFRO, NISH, NORB, NSSH, NSYM
use Constants, only: Zero, One, Two, Four
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(in) :: D(*), PA(*), FP(*)
real(kind=wp), intent(_OUT_) :: P(*), SXN(*), F1(*), F2(*), DIA(*), G(*), H(*), HDIAG(*), DF(*), DDIAG(*)
integer(kind=iwp) :: I, IASHI, IASHJ, IPQ, IPRLEV, IQP, IROOT1, ISTAE, ISTBM, ISTD, ISTFP, ISTFPJ, ISTH, ISTIA, ISTZ, ISYM, IX, &
                     IX1, JSYM, JUSTONE, NAE, NAO, NAOJ, NEO, NIA, NIO, NIOJ, NO, NP, nP2Act, NPR, NQ, NR, NRR, NT, NTT, NTU, &
                     NTUT, NTUTU, NTUVX, NU, NUT, NV, NVT, NVX, NVXF, NVXT, NX, NXT
real(kind=wp) :: DPP, DRR, DTU, FAC, FACD, FPP, GTU, HDMIN, HPP, P2Act(1), PRPR, SXNRM2, XLEV
real(kind=wp), parameter :: Large = 1.0e32_wp, THRA = 1.0e-6_wp
#include "warnings.h"

! -- THRA: THRESHOLD FOR WARNING, ACTIVE OCC NO CLOSE TO 0 OR 2.

! Local print level (if any)
IPRLEV = IPRLOC(4)
if (IPRLEV >= DEBUG) write(u6,*) ' Entering SXHAM'

! Loop over all symmetry blocks

ISTBM = 0
ISTD = 0
ISTFP = 0
ISTIA = 0
ISTAE = 0
ISTH = 0
IASHI = 0
ISTZ = 0
IX1 = 0
do ISYM=1,NSYM
  IX = IX1+NFRO(ISYM)
  NIO = NISH(ISYM)
  NAO = NASH(ISYM)
  !NR1O = NRS1(ISYM)
  !NR2O = NRS2(ISYM)
  !NR3O = NRS3(ISYM)
  !NAO = NR1O+NR2O+NR3O
  NIA = NIO+NAO
  NEO = NSSH(ISYM)
  NAE = NAO+NEO
  NO = NORB(ISYM)
  if ((NIA /= 0) .and. (NAE /= 0)) then

    ! Form the diagonal of the density matrix for all orbitals

    justone = 0
    do NP=1,NO
      if (NP <= NIO) then
        DDIAG(NP) = Two
      else if (NP > NIA) then
        DDIAG(NP) = Zero
      else
        DDIAG(NP) = D(ISTD+nTri_Elem(NP-NIO))
        if ((DDIAG(NP) < THRA) .and. (ISCF == 0)) then
          if (JustOne == 0) then
            call WarningMessage(1,'Problems in orbital optimization.')
            JustOne = JustOne+1
          end if
          write(u6,'(1x,a,i2,a,i4,a,es14.6)') ' Warning: In symmetry ',ISYM,', orbital p=',NP, &
                                              ' has diagonal density matrix element D(p,p) close to zero. D(p,p)=',DDIAG(NP)
        end if
        if ((Two-DDIAG(NP) < THRA) .and. (ISCF == 0)) then
          if (JustOne == 0) then
            call WarningMessage(1,'Problems in orbital optimization.')
            JustOne = JustOne+1
          end if
          write(u6,'(1x,a,i2,a,i4,a,es14.6)') ' Warning: In symmetry ',ISYM,', orbital p=',NP, &
                                              ' has diagonal density matrix element D(p,p) close to two. (2 - D(p,p))=', &
                                              Two-DDIAG(NP)
        end if
      end if
    end do

    ! Compute the normalization constants:
    ! SXN(pq)=4*(P(prrp)-P(prpr))+D(rr)+D(pp)

    NPR = ISTBM
    ! NP loops over active and secondary indices.
    do NP=NIO+1,NO
      ! NR loops over inactive and active indices.
      do NR=1,NIA
        NPR = NPR+1
        SXN(NPR) = One
        if (NR >= NP) cycle
        DRR = DDIAG(NR)
        DPP = DDIAG(NP)
        PRPR = -Two*DPP
        if (NP > NIA) PRPR = Zero
        if ((NR > NIO) .and. (NP <= NIA)) then
          NT = NP-NIO+IASHI
          NU = NR-NIO+IASHI
          NTU = iTri(NT,NU)
          NTUTU = nTri_Elem(NTU)
          PRPR = -Four*PA(NTUTU)
        end if
        SXNRM2 = PRPR+DRR+DPP
        if (SXNRM2 < -1.0e-12_wp) then
          call WarningMessage(1,'Negative norm occured in SXHAM.')
          write(u6,*) 'SXHAM Error: Negative SXNRM2.'
          write(u6,*) ' Symmetry block ISYM:',ISYM
          write(u6,*) '      Orbitals NP,NR:',NP,NR
          write(u6,*) '                PRPR:',PRPR
          write(u6,*) '                 DRR:',DRR
          write(u6,*) '                 DPP:',DPP
          write(u6,*) '      Norm**2 SXNRM2:',SXNRM2
          write(u6,*)
          write(u6,*) ' The squared norm of a trial vector has been'
          write(u6,*) ' computed to be negative.'
          write(u6,*) ' This is possible only for some severe malfunction'
          write(u6,*) ' of the rasscf program. Please issue a bug report.'
          write(u6,*)
          call Quit(_RC_GENERAL_ERROR_)
        end if

        if (SXNRM2 < 1.0e-12_wp) then
          SXN(NPR) = Zero
        else
          SXN(NPR) = One/sqrt(SXNRM2)
        end if
      end do
    end do

    ! Form the occupied (F1) and active-external (F2) part of FP
    ! and the occupied part DIA of the density matrix D

    IPQ = ISTFP
    DIA(ISTIA+1:ISTIA+NIA**2) = Zero
    do NP=1,NO
      do NQ=1,NP
        IPQ = IPQ+1
        if ((NP <= NIA) .and. (NQ <= NIA)) then
          F1(ISTIA+NIA*(NP-1)+NQ) = FP(IPQ)
          F1(ISTIA+NIA*(NQ-1)+NP) = FP(IPQ)
        end if
        if ((NP > NIO) .and. (NQ > NIO)) then
          F2(NAE*(NP-NIO-1)+NQ-NIO+ISTAE) = FP(IPQ)
          F2(NAE*(NQ-NIO-1)+NP-NIO+ISTAE) = FP(IPQ)
        end if
        if ((NP <= NIO) .and. (NP == NQ)) DIA(ISTIA+NIA*(NP-1)+NP) = Two
        if (((NP > NIO) .and. (NP <= NIA)) .and. NQ > NIO) then
          NT = NP-NIO
          NU = NQ-NIO
          NTU = iTri(NT,NU)+ISTD
          DIA(ISTIA+NIA*(NP-1)+NQ) = D(NTU)
          DIA(ISTIA+NIA*(NQ-1)+NP) = D(NTU)
        end if
      end do
    end do
    if (IPRLEV >= DEBUG) then
      write(u6,*) 'DIA in SXHAM:'
      write(u6,*) (DIA(ISTIA+i),i=1,NIA**2)
    end if

    ! Form the matrix DF (row index active, column index all orbitals)

    if (NAO /= 0) then
      call DGEMM_('N','N',NAO,NAE,NAO,One,DIA(ISTIA+NIO*NIA+NIO+1),NIA,F2(ISTAE+1),NAE,Zero,DF(NAO*NIO+1),NAO)
      if (NIO /= 0) call DGEMM_('N','N',NAO,NIO,NAO,One,DIA(ISTIA+NIO*NIA+NIO+1),NIA,F1(ISTIA+NIO+1),NIA,Zero,DF,NAO)
    end if

    ! compute the G matrix:
    ! G(ij)=-2*FP(ij)
    ! G(ti)=G(it)=-DF(ti)
    ! G(tu)=sum(vx)(2P(tuvx)-D(tu)D(vx))F(vx)

    if (ExFac /= One) then
      call Get_Temp('nP2Act  ',P2Act,1)
      nP2Act = int(P2Act(1))
      call Get_Temp('P2_RAW  ',P,nP2Act)
    end if
    do NP=1,NIA
      do NQ=1,NP
        IPQ = ISTIA+NIA*(NP-1)+NQ
        IQP = ISTIA+NIA*(NQ-1)+NP
        if (NP <= NIO) then
          G(IPQ) = -Two*F1(IPQ)
          G(IQP) = G(IPQ)
        else if ((NP > NIO) .and. (NQ <= NIO)) then
          G(IPQ) = -DF(NAO*(NQ-1)+NP-NIO)
          G(IQP) = G(IPQ)
        else if (NQ > NIO) then
          DTU = DIA(ISTIA+NIA*(NP-1)+NQ)
          GTU = Zero
          NTT = NP-NIO+IASHI
          NUT = NQ-NIO+IASHI
          NTUT = iTri(NTT,NUT)

          IASHJ = 0
          ISTFPJ = 0
          NVX = 0
          do JSYM=1,NSYM
            NAOJ = NASH(JSYM)
            NIOJ = NISH(JSYM)
            if (NAOJ /= 0) then
              do NV=1,NAOJ
                NVT = NV+IASHJ
                do NX=1,NV
                  NXT = NX+IASHJ
                  NVX = NVX+1
                  NVXT = iTri(NVT,NXT)
                  NTUVX = iTri(NTUT,NVXT)
                  FAC = Two
                  FACD = Two
                  if (NV == NX) FACD = One
                  if (NTUT < NVXT) then
                    if ((NVT /= NXT) .and. (NTT == NUT)) FAC = Four
                    if ((NVT == NXT) .and. (NTT /= NUT)) FAC = One
                  end if
                  NVXF = ISTFPJ+iTri(NV+NIOJ,NX+NIOJ)
                  GTU = GTU+FP(NVXF)*(FAC*P(NTUVX)-FACD*DTU*D(NVX))
                end do
              end do
              IASHJ = IASHJ+NAOJ
            end if
            ISTFPJ = ISTFPJ+nTri_Elem(NORB(JSYM))
          end do
          G(IPQ) = GTU
          G(IQP) = GTU
        end if
      end do
    end do
    if (ExFac /= One) call Get_Temp('P2_KS   ',P,nP2Act)

    ! FORM THE H MATRIX (only the nae*nao block is needed)
    ! H(tu)=G(tu)+DF(tu)+DF(ut)
    ! H(at)=DF(ta)
    ! H(ab) and H(ta) are not included.

    if (NAO /= 0) then
      IPQ = ISTH
      do NP=1,NAO
        do NQ=1,NAE
          IPQ = IPQ+1
          if (NQ <= NAO) then
            H(IPQ) = G(ISTIA+NIA*(NP+NIO-1)+NQ+NIO)+DF(NAO*(NP+NIO-1)+NQ)+DF(NAO*(NQ+NIO-1)+NP)
          else
            H(IPQ) = DF(NAO*(NQ+NIO-1)+NP)
          end if
        end do
      end do
    end if

    ! Diagonal elements of the SX Hamiltonian

    NPR = ISTBM
    do NP=1,NAE
      FPP = F2(ISTAE+NAE*(NP-1)+NP)
      HPP = Zero
      DPP = Zero
      if (NP <= NAO) then
        HPP = H(ISTH+NAE*(NP-1)+NP)
        DPP = DIA(ISTIA+NIA*(NP+NIO-1)+NP+NIO)
      end if
      NRR = ISTIA+1
      do NR=1,NIA
        NPR = NPR+1
        HDIAG(NPR+NROOT) = (G(NRR)-HPP+DIA(NRR)*FPP+DPP*F1(NRR))*SXN(NPR)**2
        NRR = NRR+NIA+1

        ! Make this matrix element large for forbidden rotations

        if ((NP <= NAO) .and. (NR > NIO)) then
          NT = NP
          NU = NR-NIO
          if (NT <= NU) then
            HDIAG(NPR+NROOT) = Large
            SXN(NPR) = Zero
          else
            NTU = ISTZ+nTri_Elem(NT-2)+NU
            if (IZROT(NTU) /= 0) then
              HDIAG(NPR+NROOT) = Large
              SXN(NPR) = Zero
              !write(u6,*) 'SXHAM. IZROT == 1 for NP,NR=',NP,NR
            end if
          end if
        end if

        ! Make HDIAG large for rotations forbidden by IXSYM input

        if (IXSYM(NR+IX) /= IXSYM(NP+NIO+IX)) then
          !write(u6,*) 'SXHAM. IXSYM forbids NP,NR=',NP,NR
          HDIAG(NPR+NROOT) = Large
          SXN(NPR) = Zero
        end if

      end do
    end do
    !write(u6,*) 'SXHAM: The IXSYM array='
    !write(u6,'(1x,40i2)') (ixsym(i),i=1,ntot)

    ! Test print of all matrices

    if (IPRLEV >= DEBUG) then
      write(u6,1000) ISYM
      write(u6,1100) (DDIAG(I),I=1,NO)
      write(u6,1200) (SXN(I),I=ISTBM+1,ISTBM+NIA*NAE)
      write(u6,1300) (DF(I),I=1,NAO*NO)
      write(u6,1400) (F1(I),I=ISTIA+1,ISTIA+NIA**2)
      write(u6,1500) (F2(I),I=ISTAE+1,ISTAE+NAE**2)
      write(u6,1600) (G(I),I=ISTIA+1,ISTIA+NIA**2)
      write(u6,1700) (H(I),I=ISTH+1,ISTH+NAO*NAE)
      write(u6,1800) (HDIAG(I),I=ISTBM+1+NROOT,ISTBM+NAE*NIA+NROOT)
    end if

    IASHI = IASHI+NAO
    ISTD = ISTD+nTri_Elem(NAO)
  end if
  ISTIA = ISTIA+NIA**2
  ISTAE = ISTAE+NAE**2
  ISTFP = ISTFP+nTri_Elem(NO)
  ISTBM = ISTBM+NIA*NAE
  ISTH = ISTH+NAO*NAE
  ISTZ = ISTZ+nTri_Elem(NAO-1)
  IX1 = IX1+NBAS(ISYM)

end do

! Level shift section

XLEV = LVSHFT
SXSHFT = Zero
HDMIN = Large
do I=NROOT+1,NROOT+NSXS
  if (HDIAG(I) < HDMIN) HDMIN = HDIAG(I)
end do
SXSHFT = max(XLEV-HDMIN,Zero)

! no level shift if input (alpha) is zero

if (LVSHFT == Zero) SXSHFT = Zero
HDIAG(NROOT+1:NROOT+NSXS) = HDIAG(NROOT+1:NROOT+NSXS)+SXSHFT
if (IPRLEV >= DEBUG) write(u6,1900) HDMIN,SXSHFT

! Add diagonal elements for the reference space (CI-states)

HDIAG(1) = Zero
if (ICICP /= 0) then
  IROOT1 = IROOT(1)
  HDIAG(1:NROOT) = ENER(1:NROOT,ITER)-ENER(IROOT1,ITER)
end if

return

1000 format(/1X,'Matrices in SXHAM for symmetry block',I2)
1100 format(/1X,'Diagonal of the full density matrix'/(1X,5G18.6))
1200 format(/1X,'Normalization constants for SX-states'/(1X,5G18.6))
1300 format(/1X,'The matrix sum(D(pr)F(rq)) -DF'/(1X,5G18.6))
1400 format(/1X,'The occupied part of the Fock matrix'/(1X,5G18.6))
1500 format(/1X,'The act-ext part of the Fock matrix'/(1X,5G18.6))
1600 format(/1X,'The G-matrix'/(1X,5G18.6))
1700 format(/1X,'The H-matrix'/(1X,5G18.6))
1800 format(/1X,'Diagonal of the SX Hamiltonian'/(1X,5G18.6))
1900 format(1X,'Lowest diagonal element has the value',F12.6,' A level shift of',F12.6,' has been used')

end subroutine SXHAM

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990, Roland Lindh                                     *
*               1990, IBM                                              *
************************************************************************
      SubRoutine PSOAO0_h(nSO,nMemab,nMemcd,MemPrm,MemMax,
     &                            iAnga, iCmpa,
     &                            iBas,  iBsInc, jBas,  jBsInc,
     &                            kBas,  kBsInc, lBas,  lBsInc,
     &                            iPrim, iPrInc, jPrim, jPrInc,
     &                            kPrim, kPrInc, lPrim, lPrInc,
     &                            ipMem1,ipMem2,ipMem3,ipMem4, ipMend,
     &                              Mem1,  Mem2,  Mem3,  Mem4,   Mend)
************************************************************************
*                                                                      *
*  Object: to partion the SO and AO block. It will go to some length   *
*          before it will start and break up the SO block. This will   *
*          reduce the total flop count. However, as we are breaking up *
*          the AO block this will affect the vectorization. Hence, at  *
*          some point it will actually be better to recompute the      *
*          primitives.                                                 *
*          Current stratergy:                                          *
*          1. Start reducing the length of the primitives in the order *
*             lPrim,jPrim.                                             *
*          2. Reduce the size of the SO block by reducing the number of*
*             basis functions in the order lBas, jBas.                 *
*          3. Terminate run telling job max and min of additional      *
*             memory needed to perform the calculation.                *
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             March '90                                                *
************************************************************************
      use Integral_Parameters, only: iWROpt
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "WrkSpc.fh"
#include "real.fh"
#include "print.fh"
#include "lCache.fh"
#include "pstat.fh"
#include "warnings.fh"
      Integer iAnga(4), iCmpa(4)
      Logical QiBas, QjBas, QkBas, QlBas, QjPrim, QlPrim, Fail
#include "SysDef.fh"
*
*     Statement function to compute canonical index
*
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
      iRout = 10
      iPrint = nPrint(iRout)
*     iQ = 1
      la = iAnga(1)
      lb = iAnga(2)
      lc = iAnga(3)
      ld = iAnga(4)
      iCmp = iCmpa(1)
      jCmp = iCmpa(2)
      kCmp = iCmpa(3)
      lCmp = iCmpa(4)
      iTotal = iTotal + 1
      mabMin=nabSz(Max(la,lb)-1)+1
      mabMax=nabSz(la+lb)
      mcdMin=nabSz(Max(lc,ld)-1)+1
      mcdMax=nabSz(lc+ld)
      mabcd=(mabMax-mabMin+1)*(mcdMax-mcdMin+1)
      nabcd=iCmp*jCmp*kCmp*lCmp
*
      iBsInc = iBas
      jBsInc = jBas
      kBsInc = kBas
      lBsInc = lBas
      iPrInc = iPrim
      jPrInc = jPrim
      kPrInc = kPrim
      lPrInc = lPrim
      iFact = 1
      If (iWropt.eq.0) iFact = 4/RtoI+3
*
 999  Continue
      QjPrim = .False.
      QlPrim = .True.
      QiBas  = .False.
      QjBas  = .False.
      QkBas  = .False.
      QlBas  = .False.
      Mem0 = MemMax
*
*-----Work1
*     Memory for SO block. If petite list format is used there
*     will be no SO block.
*
      kSOInt = nSO*iBsInc*jBsInc*kBsInc*lBsInc
      Mem1 = iFact*kSOInt
      If (Mem1.eq.0) Mem1 = 1
      If (nIrrep==1) Mem1 = 1 + (iFact-1) *
     &                   iCmp*  jCmp*  kCmp*  lCmp*
     &                   iBsInc*jBsInc*kBsInc*lBsInc
      If (Mem1+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem1+1-Mem0)
         QjPrim = .False.
         QlPrim = .False.
         QiBas  = .False.
         QjBas  = .False.
         QkBas  = .False.
         QlBas  = .True.
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) ' Allocation failed for Work1'
            Write (6,*) Mem0,Mem1
            Write (6,*) iPrInc,iBsInc,kPrInc,kBsInc,
     &                  jPrInc,jBsInc,lPrInc,lBsInc
            Call Quit(_RC_MEMORY_ERROR_)
         End If
         Go To 999
      End If
*     Write (*,*) ' After Mem1', iPrInc,iBsInc,kPrInc,kBsInc,
*    &                           jPrInc,jBsInc,lPrInc,lBsInc
      Mem0 = Mem0 - Mem1 - 1
*
*-----Work2
*     MemPr  : Scratch for Rys
*     MemCon : Scratch for the contraction step
*     MemTr1 : Scratch for the 1st application of the transfer eqn.
*     MemTr2 : Scratch for the 2nd application of the transfer eqn.
*-----Work4 (this is overlayed with Work2 and is placed at the top)
*     MemAux : Auxiliary memory for partial contraction.
*-----Work5 (this is overlayed with Work2 and is placed at the top)
*
      MemPr = MemPrm*iPrInc*jPrInc*kPrInc*lPrInc
      MemCon= mabcd*Max(iPrInc*jPrInc*kPrInc*lPrInc,
     &                  iBsInc*jBsInc*kBsInc*lBsInc)
      If (jPrInc.ne.jPrim.or.lPrInc.ne.lPrim) Then
         MemAux = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
      Else
         MemAux = 0
      End If
      MemTr1= (mabMax-mabMin+1)*nMemcd*iBsInc*jBsInc*kBsInc*lBsInc
      MemTr2= kCmp*lCmp*nMemab*iBsInc*jBsInc*kBsInc*lBsInc
      Mem2  = Max(MemPr+MemAux,MemCon+MemAux,MemTr1,MemTr2)
      If (Mem2+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem2+1-Mem0)
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) ' Allocation failed for Work2'
            Write (6,*) Mem0,Mem2,MemPr+MemAux,MemCon+MemAux,
     &                  MemTr1,MemTr2
            Write (6,*) iPrInc,iBsInc,kPrInc,kBsInc,
     &                  jPrInc,jBsInc,lPrInc,lBsInc
            Call Quit(_RC_MEMORY_ERROR_)
         End If
         Go To 999
      End If
      If (jPrInc.ne.jPrim.or.lPrInc.ne.lPrim) Then
         Mem4 = MemAux
      Else
         Mem4 = Mem2
      End If
*     Write (*,*) ' After Mem2', jPrInc,jBsInc,lPrInc,lBsInc
      Mem0 = Mem0 - Mem2 - 1
*
*-----Work3
*     MemCon : Scratch for the contraction step, and transpose after the
*              contraction step
*     MemSp1 : Scratch for the 1st transformation from cartesian to
*              spherical harmonics.
*     MemSp2 : Scratch for the 2nd transformation from cartesian to
*              spherical harmonics.
*     MemTr3 : Scratch for transpose in tnsctl
*
      nCache_ = (3*lCache)/4 - iPrim*iBas - jPrim*jBas
      lSize = iPrInc*jPrInc + Max(jPrInc*iBsInc,iPrInc*jBsInc)
      nVec1 = kPrInc*lPrInc * mabcd
      IncVec = Min(Max(1,nCache_/lSize),nVec1)
      nA2 = Max(jPrInc*iBsInc,iPrInc*jBsInc)*IncVec
      nA3 = iBsInc*jBsInc*nVec1
      MemCon = Max(mabcd*iBsInc*jBsInc*kBsInc*lBsInc,nA2+nA3)
*
      nCache_ = (3*lCache)/4 - kPrim*kBas - lPrim*lBas
      lSize = kPrInc*lPrInc + Max(lPrInc*kBsInc,kPrInc*lBsInc)
      nVec2 = iBsInc*jBsInc * mabcd
      IncVec = Min(Max(1,nCache_/lSize),nVec2)
      nA2 = Max(lPrInc*kBsInc,kPrInc*lBsInc)*IncVec
*     nA3 = kBsInc*lBsInc*nVec2
      MemCon = Max(MemCon,nA3+nA2)
*
************************************************************************
*
      nCache_ = (3*lCache)/4 - kPrim*kBas - lPrim*lBas
      lSize = kPrInc*lPrInc + Max(lPrInc*kBsInc,kPrInc*lBsInc)
      nVec1 = iPrInc*jPrInc * mabcd
      IncVec = Min(Max(1,nCache_/lSize),nVec1)
      nA2 = IncVec*Max(lPrInc*kBsInc,kPrInc*lBsInc)
      nA3 = kBsInc*lBsInc*nVec1
      MemCon = Max(MemCon,nA3+nA2)
*
      nCache_ = (3*lCache)/4 - iPrim*iBas - jPrim*jBas
      lSize = iPrInc*jPrInc + Max(jPrInc*iBsInc,iPrInc*jBsInc)
      nVec2 = kBsInc*lBsInc * mabcd
      IncVec = Min(Max(1,nCache_/lSize),nVec2)
      nA2 = IncVec*Max(jPrInc*iBsInc,iPrInc*jBsInc)
*     nA3 = iBsInc*jBsInc*nVec2
      MemCon = Max(MemCon,nA3+nA2)
*
      MemSp1 = (mabMax-mabMin+1)*lCmp*(lc+1)*(lc+2)/2 *
     &       iBsInc*jBsInc*kBsInc*lBsInc
      MemSp2= lCmp*kCmp*jCmp*(la+1)*(la+2)/2 *
     &       iBsInc*jBsInc*kBsInc*lBsInc
      MemTr3 = mabcd*iBsInc*jBsInc*kBsInc*lBsInc
      Mem3 = Max(MemCon,MemSp1,MemSp2,MemTr3)
      If (Mem3+1.gt.Mem0) Then
         MaxReq=Max(MaxReq,Mem3+1-Mem0)
         Call Change(iBas, iBsInc,QiBas, kBas, kBsInc,QkBas,
     &               jBas, jBsInc,QjBas, lBas, lBsInc,QlBas,
     &               jPrim,jPrInc,QjPrim,lPrim,lPrInc,QlPrim,MaxReq,
     &               Fail)
         If (Fail) Then
            Write (6,*) ' Allocation failed for Work3'
            Write (6,*) Mem0,Mem3,MemCon,MemSp1,MemSp2
            Write (6,*) iPrInc,iBsInc,kPrInc,kBsInc,
     &                  jPrInc,jBsInc,lPrInc,lBsInc
            Call Quit(_RC_MEMORY_ERROR_)
         End If
         Go To 999
      End If
      Mem0 = Mem0 - Mem3 - 1
      MinXtr = Min(MinXtr,Mem0)
*
      ipMem2 = ipMem1 + Mem1
      ipMem3 = ipMem2 + Mem2
      ipMem4 = ipMem2 + Mem2 - Mem4
      Mend=0
*
      MemSum=Mem1+Mem2+Mem3
*
      r1 = r1 + DBLE(iBsInc)/DBLE(iBas)
      r2 = r2 + DBLE(jBsInc)/DBLE(jBas)
      r3 = r3 + DBLE(kBsInc)/DBLE(kBas)
      r4 = r4 + DBLE(lBsInc)/DBLE(lBas)
      q1 = q1 + DBLE(iPrInc)/DBLE(iPrim)
      q2 = q2 + DBLE(jPrInc)/DBLE(jPrim)
      q3 = q3 + DBLE(kPrInc)/DBLE(kPrim)
      q4 = q4 + DBLE(lPrInc)/DBLE(lPrim)
      Return
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(ipMend)
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1993, Per-Olof Widmark                                 *
!***********************************************************************
!***********************************************************************
!                                                                      *
!   This file contains Fortran front-ends for the C timing routines:   *
!                                                                      *
!   (void)timingcinit()    : initialization                            *
!   (void)timingc(double elapse,double usercpu,double syscpu)          *
!                          : returns elapse, user cpu                  *
!                            and system cpu times                      *
!                                                                      *
!   (INT)iclock()          : returns (user) cpu clock ticks            *
!   (INT)inc_clock         : returns number of clock ticks per second  *
!                                                                      *
!***********************************************************************

subroutine Timing(CPUA,CPUE,TIOA,TIOE)
!***********************************************************************
!                                                                      *
!     This subroutine has two entry points. The first, called          *
!     SetTim is used to start a global timer. The second, called       *
!     Timing, returns the cpu time used since the timer has been set   *
!     and, in addition the cpu time used since the timer has been      *
!     called the previous time.                                        *
!                                                                      *
!     calling arguments:                                               *
!     CPUA     : Type double precision real, output                    *
!                Cpu time since start of the timer                     *
!     CPUE     : Type double precision real, output                    *
!                CPU time since last call to Timing                    *
!     TIOA     : Type double precision real, output                    *
!                Wall clock time since start of timer                  *
!     TIOE     : Type double precision real, output                    *
!                Wall clock time since last call to timing             *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     written by:                                                      *
!     P.O. Widmark                                                     *
!     University of Lund, Sweden, 1993                                 *
!                                                                      *
!----------------------------------------------------------------------*
!                                                                      *
!     history: none                                                    *
!                                                                      *
!***********************************************************************

use Definitions, only: wp

implicit none
real(kind=wp), intent(out) :: CPUA, CPUE, TIOA, TIOE
real(kind=wp) :: elapse, usercpu, syscpu
#include "SysCtl.fh"

call timingc(elapse,usercpu,syscpu)
! times relative to values in Common /$SysBuf/
CPUA = usercpu-Heuer(1)
CPUE = usercpu-Heuer(2)
TIOA = elapse-Heuer(3)
TIOE = elapse-Heuer(4)
! save current times in the Common /$SysBuf/
Heuer(2) = usercpu
Heuer(4) = elapse
return

end subroutine Timing

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991-1994,1996,1997,2000, Jeppe Olsen                  *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RSBB2BN(IASM,IATP,IBSM,IBTP,NIA,NIB,JASM,JATP,JBSM,JBTP,NJA,NJB,IAGRP,IBGRP,NGAS,IAOC,IBOC,JAOC,JBOC,SB,CB,NOBPTS,MAXK, &
                   I1,XI1S,I2,XI2S,I3,XI3S,I4,XI4S,XINT,NSMOB,IUSEAB,CJRES,SIRES,SCLFAC,IPHGAS)
! SUBROUTINE RSBB2BN --> 52
!
! Combined alpha-beta double excitation
! contribution from given C block to given S block
! If IUSAB only half the terms are constructed
!
! =====
! Input
! =====
!
! IASM,IATP : Symmetry and type of alpha  strings in sigma
! IBSM,IBTP : Symmetry and type of beta   strings in sigma
! JASM,JATP : Symmetry and type of alpha  strings in C
! JBSM,JBTP : Symmetry and type of beta   strings in C
! NIA,NIB : Number of alpha-(beta-) strings in sigma
! NJA,NJB : Number of alpha-(beta-) strings in C
! IAGRP : String group of alpha strings
! IBGRP : String group of beta strings
! IAEL1(3) : Number of electrons in RAS1(3) for alpha strings in sigma
! IBEL1(3) : Number of electrons in RAS1(3) for beta  strings in sigma
! JAEL1(3) : Number of electrons in RAS1(3) for alpha strings in C
! JBEL1(3) : Number of electrons in RAS1(3) for beta  strings in C
! CB   : Input C block
! NTSOB  : Number of orbitals per type and symmetry
! IBTSOB : base for orbitals of given type and symmetry
! IBORB  : Orbitals of given type and symmetry
! NSMOB  : Number of symmetries of orbitals
! MAXK   : Largest number of inner resolution strings treated at simult.
!
! ======
! Output
! ======
! SB : updated sigma block
!
! =======
! Scratch
! =======
!
! I1, XI1S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! I2, XI2S   : at least MXSTSO : Largest number of strings of given
!              type and symmetry
! XINT  : Space for two electron integrals
!
! Jeppe Olsen, Winter of 1991
!
! Feb 92 : Loops restructured ; Generation of I2,XI2S moved outside
! October 1993 : IUSEAB added
! January 1994 : Loop restructured + CJKAIB introduced
! February 1994 : Fetching and adding to transposed blocks
! October 96 : New routines for accessing annihilation information
!             Cleaned and shaved, only IROUTE = 3 option active
! October 97 : allowing for N-1/N+1 switch
!
! Last change : Aug 2000

use Symmetry_Info, only: Mul
use Para_Info, only: MyRank, nProcs
use lucia_data, only: MXPNGAS, TSIGMA
use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: IASM, IATP, IBSM, IBTP, NIA, NIB, JASM, JATP, JBSM, JBTP, NJA, NJB, IAGRP, IBGRP, NGAS, IAOC(*), &
                                 IBOC(*), JAOC(*), JBOC(*), NOBPTS(MXPNGAS,*), MAXK, NSMOB, IUSEAB, IPHGAS(*)
real(kind=wp), intent(inout) :: SB(*), XI1S(*), XI2S(*), XI3S(*), XI4S(*)
real(kind=wp), intent(in) :: CB(*), SCLFAC
integer(kind=iwp), intent(inout) :: I1(*), I2(*), I3(*), I4(*)
real(kind=wp), intent(_OUT_) :: XINT(*), CJRES(*), SIRES(*)
integer(kind=iwp) :: IASPGP(20), IBSPGP(20), ICOUL, IDOCOMP, II, IJ_DIM(2), IJ_REO(2), IJ_SYM(2), IJ_TYP(2), IJAC, IJSM, IJTYP, &
                     IKABTC, IKORD, IROUTE, ISM, ITP(20), ITYP, IXCHNG, JASPGP(20), JBSPGP(20), JJ, JSM, JTP(20), JTYP, KABOT, &
                     KACT, KATOP, KL_DIM(2), KL_REO(2), KL_SYM(2), KL_TYP(2), KLAC, KLSM, KLTYP, KSM, KTP(20), KTYP, LKABTC, LSM, &
                     LTP(20), LTYP, NI, NIJTYP, NJ, NK, NKABTC, NKABTCSZ, NKAEFF, NKASTR, NKBSTR, NKLTYP, NL
real(kind=wp) :: CPU, CPU0, CPU1, FACS, SIGNIJ2, SIGNKL, WALL, WALL0, WALL1

#ifdef _DEBUGPRINT_
write(u6,*) ' ================'
write(u6,*) ' RSBB2BN speaking'
write(u6,*) ' ================'
#endif
!  Groups defining each supergroup
call GET_SPGP_INF(IATP,IAGRP,IASPGP)
call GET_SPGP_INF(JATP,IAGRP,JASPGP)
call GET_SPGP_INF(IBTP,IBGRP,IBSPGP)
call GET_SPGP_INF(JBTP,IBGRP,JBSPGP)

! Symmetry of allowed excitations
IJSM = Mul(IASM,JASM)
KLSM = Mul(IBSM,JBSM)
if ((IJSM == 0) .or. (KLSM == 0)) return
#ifdef _DEBUGPRINT_
write(u6,*) ' IASM JASM IJSM ',IASM,JASM,IJSM
write(u6,*) ' IBSM JBSM KLSM ',IBSM,JBSM,KLSM
#endif
! Types of SX that connects the two strings
call SXTYP2_GAS(NKLTYP,KTP,LTP,NGAS,IBOC,JBOC,IPHGAS)
call SXTYP2_GAS(NIJTYP,ITP,JTP,NGAS,IAOC,JAOC,IPHGAS)
if ((NIJTYP == 0) .or. (NKLTYP == 0)) return

do IJTYP=1,NIJTYP

  ITYP = ITP(IJTYP)
  JTYP = JTP(IJTYP)
  do ISM=1,NSMOB
    JSM = Mul(ISM,IJSM)
    if (JSM == 0) cycle
    NI = NOBPTS(ITYP,ISM)
    NJ = NOBPTS(JTYP,JSM)
    if ((NI == 0) .or. (NJ == 0)) cycle
    ! Should N-1 or N+1 projection be used for alpha strings
    IJ_TYP(1) = ITYP
    IJ_TYP(2) = JTYP
    !IJ_AC(1) = 2
    !IJ_AC(2) = 1
    !NOP = 2
    !if (IUSE_PH == 1) then
    !  call ALG_ROUTERX(IAOC,JAOC,NOP,IJ_TYP,IJ_AC,IJ_REO,SIGNIJ)
    !else
    ! Enforced a+ a
    IJ_REO(1) = 1
    IJ_REO(2) = 2
    !end if
    ! Two choices here :
    !  1 : <Ia!a+ ia!Ka><Ja!a+ ja!Ka> (good old creation mapping)
    !  2 :-<Ia!a  ja!Ka><Ja!a  ia!Ka> + delta(i,j)
    !write(u6,*) ' RSBB2BN : IOP_REO : ',(IOP_REO(II),II=1,2)
    if ((IJ_REO(1) == 1) .and. (IJ_REO(2) == 2)) then
      ! Business as usual i.e. creation map
      IJAC = 2
      SIGNIJ2 = SCLFAC

      IJ_DIM(1) = NI
      IJ_DIM(2) = NJ
      IJ_SYM(1) = ISM
      IJ_SYM(2) = JSM
      IJ_TYP(1) = ITYP
      IJ_TYP(2) = JTYP
    else
      ! Terra Nova, annihilation map
      IJAC = 1
      SIGNIJ2 = -SCLFAC

      IJ_DIM(1) = NJ
      IJ_DIM(2) = NI
      IJ_SYM(1) = JSM
      IJ_SYM(2) = ISM
      IJ_TYP(1) = JTYP
      IJ_TYP(2) = ITYP
    end if

    ! Generate creation- or annihilation- mappings for all Ka strings

    ! For operator connecting to |Ka> and |Ja> i.e. operator 2
    call ADAST_GAS(IJ_SYM(2),IJ_TYP(2),NGAS,JASPGP,JASM,I1,XI1S,NKASTR,KACT,SIGNIJ2,IJAC)
    !call ADAST_GAS(JSM,JTYP,JATP,JASM,IAGRP,I1,XI1S,NKASTR,KACT,SCLFACS,IJ_AC)
    ! For operator connecting |Ka> and |Ia>, i.e. operator 1
    call ADAST_GAS(IJ_SYM(1),IJ_TYP(1),NGAS,IASPGP,IASM,I3,XI3S,NKASTR,KACT,One,IJAC)
    !call ADAST_GAS(ISM,ITYP,NGAS,IASPGP,IASM,I3,XI3S,NKASTR,KACT,One,IJ_AC)
    ! Compress list to common nonvanishing elements
    IDOCOMP = 0
    if (IDOCOMP == 1) then
      call COMPRS2LST(I1,XI1S,IJ_DIM(2),I3,XI3S,IJ_DIM(1),NKASTR,NKAEFF)
    else
      NKAEFF = NKASTR
    end if

    ! Loop over batches of KA strings
    NKABTC = 0
    do
      NKABTC = NKABTC+NPROCS
      NKABTCSZ = max(NKAEFF-1,0)/NKABTC+1
      if (NKABTCSZ <= MAXK) exit
    end do

    do IKABTC=1+MYRANK,NKABTC,NPROCS
      KABOT = (IKABTC-1)*NKABTCSZ+1
      KATOP = min(KABOT+NKABTCSZ-1,NKAEFF)
      LKABTC = KATOP-KABOT+1
      if (LKABTC <= 0) exit
      ! Obtain C(ka,J,JB) for Ka in batch
      call TIMING(CPU0,CPU,WALL0,WALL)
      do JJ=1,IJ_DIM(2)
        call GET_CKAJJB(CB,IJ_DIM(2),NJA,CJRES,LKABTC,NJB,JJ,I1(KABOT+(JJ-1)*NKASTR),XI1S(KABOT+(JJ-1)*NKASTR))
      end do
      call TIMING(CPU1,CPU,WALL1,WALL)
      TSIGMA(4) = TSIGMA(4)+(WALL1-WALL0)
#     ifdef _DEBUGPRINT_
      write(u6,*) ' Updated CJRES as C(Kaj,Jb)'
      call WRTMAT(CJRES,NKASTR*NJ,NJB,NKASTR*NJ,NJB)
#     endif

      !MXACJ = MAX(MXACJ,NIB*LKABTC*IJ_DIM(1),NJB*LKABTC*IJ_DIM(2))
      SIRES(1:NIB*LKABTC*IJ_DIM(1)) = Zero
      FACS = One

      do KLTYP=1,NKLTYP
        KTYP = KTP(KLTYP)
        LTYP = LTP(KLTYP)
        ! Allowed double excitation ?
        !IJKL_ACT = 1
        !if (IJKL_ACT == 0) cycle
#       ifdef _DEBUGPRINT_
        write(u6,*) ' KTYP, LTYP',KTYP,LTYP
#       endif
        ! Should this group of excitations be included
        !if (NSEL2E /= 0) then
        !  IAMOKAY = 0
        !  if ((ITYP == JTYP) .and. (ITYP == KTYP) .and. (ITYP == LTYP)) then
        !    do JSEL2E=1,NSEL2E
        !      if (ISEL2E(JSEL2E) == ITYP) IAMOKAY = 1
        !    end do
        !  end if
        !  if (IAMOKAY == 0) cycle
        !end if

        KL_TYP(1) = KTYP
        KL_TYP(2) = LTYP
        !KL_AC(1) = 2
        !KL_AC(2) = 1
        !NOP = 2
        !if (IUSE_PH == 1) then
        !  call ALG_ROUTERX(IBOC,JBOC,NOP,KL_TYP,KL_AC,KL_REO,SIGNKL)
        !else
        ! Enforced a+ a
        KL_REO(1) = 1
        KL_REO(2) = 2
        SIGNKL = One
        !end if

        do KSM=1,NSMOB
          LSM = Mul(KSM,KLSM)
#         ifdef _DEBUGPRINT_
          write(u6,*) ' KSM, LSM',KSM,LSM
#         endif
          if (LSM == 0) cycle
          NK = NOBPTS(KTYP,KSM)
          NL = NOBPTS(LTYP,LSM)

          if ((KL_REO(1) == 1) .and. (KL_REO(2) == 2)) then
            ! Business as usual i.e. creation map
            KLAC = 2
            KL_DIM(1) = NK
            KL_DIM(2) = NL
            KL_SYM(1) = KSM
            KL_SYM(2) = LSM
            KL_TYP(1) = KTYP
            KL_TYP(2) = LTYP
          else
            ! Terra Nova, annihilation map
            KLAC = 1
            KL_DIM(1) = NL
            KL_DIM(2) = NK
            KL_SYM(1) = LSM
            KL_SYM(2) = KSM
            KL_TYP(1) = LTYP
            KL_TYP(2) = KTYP
          end if
          ! If IUSEAB is used, only terms with i >= k will be generated so
          IKORD = 0
          if ((IUSEAB == 1) .and. (ISM > KSM)) cycle
          if ((IUSEAB == 1) .and. (ISM == KSM) .and. (ITYP < KTYP)) cycle
          if ((IUSEAB == 1) .and. (ISM == KSM) .and. (ITYP == KTYP)) IKORD = 1

          if ((NK == 0) .or. (NL == 0)) cycle
          ! Obtain all connections a+l!Kb> = +/-/0!Jb>
          ! currently we are using creation mappings for kl
          call ADAST_GAS(KL_SYM(2),KL_TYP(2),NGAS,JBSPGP,JBSM,I2,XI2S,NKBSTR,KACT,SIGNKL,KLAC)
          if (NKBSTR == 0) cycle
          ! Obtain all connections a+k!Kb> = +/-/0!Ib>
          call ADAST_GAS(KL_SYM(1),KL_TYP(1),NGAS,IBSPGP,IBSM,I4,XI4S,NKBSTR,KACT,One,KLAC)
          if (NKBSTR == 0) cycle

          ! Fetch Integrals as (iop2 iop1 | k l)

          IXCHNG = 0
          ICOUL = 1
          ! Normal integrals with conjugation symmetry
          call GETINT(XINT,IJ_TYP(2),IJ_SYM(2),IJ_TYP(1),IJ_SYM(1),KL_TYP(1),KL_SYM(1),KL_TYP(2),KL_SYM(2),IXCHNG,0,0,ICOUL)

          ! S(Ka,i,Ib) = sum(j,k,l,Jb)<Ib!a+kba lb!Jb>C(Ka,j,Jb)*(ji!kl)

          IROUTE = 3
          call TIMING(CPU0,CPU,WALL0,WALL)
          call SKICKJ(SIRES,CJRES,LKABTC,NKBSTR,XINT,IJ_DIM(1),IJ_DIM(2),KL_DIM(1),KL_DIM(2),NKBSTR,I4,XI4S,I2,XI2S,IKORD,FACS, &
                      IROUTE)
          call TIMING(CPU1,CPU,WALL1,WALL)
          TSIGMA(5) = TSIGMA(5)+(WALL1-WALL0)

#         ifdef _DEBUGPRINT_
          write(u6,*) ' Updated Sires as S(Kai,Ib)'
          call WRTMAT(SIRES,LKABTC*NI,NIB,LKABTC*NI,NIB)
#         endif

        end do
        ! End of loop over KSM
      end do
      ! End of loop over KLTYP

      ! Scatter out from s(Ka,Ib,i)

#     ifdef _DEBUGPRINT_
      write(u6,*) ' S(Ka,Ib,i) as S(Ka,Ibi)'
      call WRTMAT(SIRES,LKABTC,NIB*IJ_DIM(1),LKABTC,IJ_DIM(1))
#     endif

      call TIMING(CPU0,CPU,WALL0,WALL)
      do II=1,IJ_DIM(1)
        call ADD_SKAIIB(SB,IJ_DIM(1),NIA,SIRES,LKABTC,NIB,II,I3(KABOT+(II-1)*NKASTR),XI3S(KABOT+(II-1)*NKASTR))
      end do
      call TIMING(CPU1,CPU,WALL1,WALL)
      TSIGMA(6) = TSIGMA(6)+(WALL1-WALL0)
    end do
    ! End of loop over partitioning of alpha strings
  end do
  ! End of loop over ISM
end do
! End of loop over IJTYP

end subroutine RSBB2BN

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE H0SPCT
#ifdef _MOLCAS_MPP_
      use allgather_wrapper, only : allgather
#endif
      IMPLICIT REAL*8 (A-H,O-Z)

#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"
#include "WrkSpc.fh"
#include "eqsolv.fh"
#include "para_info.fh"

#ifdef _MOLCAS_MPP_
#include "global.fh"
#include "mafdecls.fh"
#endif

#include "SysDef.fh"
      CHARACTER(LEN=80) LINE

C Write pertinent warnings and statistics for the energy
C denominators, i.e. the spectrum of (H0(diag)-E0).


      WRITE(6,*)
      Call CollapseOutput(1,'Denominators, etc.')
      WRITE(6,'(10A11)')('-----------',i=1,10)
      WRITE(6,'(A)')' Report on small energy denominators, large'//
     &   ' coefficients, and large energy contributions.'

      IF (IPRGLB.GE.VERBOSE) THEN
        WRITE(6,'(A)')
     &   '  The ACTIVE-MIX index denotes linear combinations'//
     &   ' which gives ON expansion functions'
        WRITE(6,'(A)')'  and makes H0 diagonal within type.'
        WRITE(6,'(A)')
     &   '  DENOMINATOR: The (H0_ii - E0) value from the above-'//
     &   'mentioned diagonal approximation.'
        WRITE(6,'(A)')'  RHS VALUE  : Right-Hand Side of CASPT2 Eqs.'
        WRITE(6,'(A)')
     &   '  COEFFICIENT: Multiplies each of the above ON terms'//
     &   ' in the first-order wave function.'
        WRITE(6,'(A)')' Thresholds used:'
        WRITE(6,'(a,f7.4)')'         Denominators:',DNMTHR
        WRITE(6,'(a,f7.4)')'         Coefficients:',CMPTHR
        WRITE(6,'(a,f7.4)')' Energy contributions:',CNTTHR
        WRITE(6,*)
      END IF

      WRITE(6,'(A)')'CASE  SYMM ACTIVE-MIX  NON-ACTIVE'
     &            //' INDICES          DENOMINATOR'
     &            //'     RHS VALUE       COEFFICIENT'
     &            //'     CONTRIBUTION'

CSVC: initial buffer size, will be reallocated on the fly
      MAXBUF=1024
      CALL GETMEM('IDXBUF','ALLO','INTE',LIDXBUF,2*MAXBUF)
      CALL GETMEM('VALBUF','ALLO','REAL',LVALBUF,4*MAXBUF)

C Very long loop over symmetry and case:
      DO ICASE=1,13
        DO ISYM=1,NSYM
          NAS=NASUP(ISYM,ICASE)
          NIS=NISUP(ISYM,ICASE)
          IF(NIS.EQ.0) GOTO 100
          NIN=NINDEP(ISYM,ICASE)
          IF(NIN.EQ.0) GOTO 100
          LINE(1:12)=CASES(ICASE)//'    '
          WRITE(LINE(10:10),'(i1)') ISYM

C Remember: NIN values in BDIAG, but must read NAS for correct
C positioning.
          CALL GETMEM('LBD','ALLO','REAL',LBD,NAS)
          CALL GETMEM('LID','ALLO','REAL',LID,NIS)
          ID=IDBMAT(ISYM,ICASE)
          CALL DDAFILE(LUSBT,2,WORK(LBD),NAS,ID)
          CALL DDAFILE(LUSBT,2,WORK(LID),NIS,ID)

          CALL RHS_ALLO(NIN,NIS,lg_RHS)
          CALL RHS_ALLO(NIN,NIS,lg_VEC)
          CALL RHS_READ_SR(lg_RHS,ICASE,ISYM,IRHS)
          CALL RHS_READ_SR(lg_VEC,ICASE,ISYM,IVECX)

          IBUF=0
#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
* Get the superindex ranges of this process's block. If no elements are
* owned by a process, then ilo=0 and ihi=-1 such that the loop further
* down will just be skipped.
            CALL GA_Sync
            myRank = GA_NodeID()
            CALL GA_Distribution (lg_RHS,myRank,IASTA,IAEND,IISTA,IIEND)
            IF (IASTA.NE.0 .AND. IAEND-IASTA+1.NE.NIN) THEN
              WRITE(6,*) 'RHSOD: mismatch in range of the superindices'
              CALL AbEnd()
            END IF
* if the block is non-empty, loop over its elements
            IF (IASTA.GT.0 .AND. IISTA.GT.0) THEN
              CALL GA_Access (lg_RHS,IASTA,IAEND,IISTA,IIEND,mRHS,LD)
              CALL GA_Access (lg_VEC,IASTA,IAEND,IISTA,IIEND,mVEC,LD)
              IF (LD.NE.NIN) THEN
                WRITE(6,*) 'RHSOD: assumption NAS=LDW wrong, abort'
                CALL AbEnd()
              END IF
              NA=NAS*(IIEND-IISTA+1)
            END IF
          ELSE
            IASTA=1
            IAEND=NIN
            IISTA=1
            IIEND=NIS
          END IF
#else
          IASTA=1
          IAEND=NIN
          IISTA=1
          IIEND=NIS
#endif

************************************************************************
* inner loop over RHS elements in symmetry ISYM
************************************************************************
          DO IIS=IISTA,IIEND
            DO IAS=IASTA,IAEND
              DNOM=WORK(LBD-1+IAS)+WORK(LID-1+IIS)
#ifdef _MOLCAS_MPP_
              IF (Is_Real_Par()) THEN
                RHS =DBL_MB(mRHS+IAS-1+NIN*(IIS-IISTA))
                COEF=DBL_MB(mVEC+IAS-1+NIN*(IIS-IISTA))
              ELSE
                RHS =WORK(lg_RHS+IAS-1+NIN*(IIS-IISTA))
                COEF=WORK(lg_VEC+IAS-1+NIN*(IIS-IISTA))
              END IF
#else
              RHS =WORK(lg_RHS+IAS-1+NIN*(IIS-IISTA))
              COEF=WORK(lg_VEC+IAS-1+NIN*(IIS-IISTA))
#endif
              ECNT=COEF*RHS
              IF (ABS(DNOM).LT.DNMTHR .OR.
     &            ABS(COEF).GT.CMPTHR .OR.
     &            ABS(ECNT).GT.CNTTHR )
     &        THEN
                IF (IBUF.LT.MAXBUF) THEN
                  IBUF=IBUF+1
                  IWORK(LIDXBUF+0+2*(IBUF-1))=IAS
                  IWORK(LIDXBUF+1+2*(IBUF-1))=IIS
                  WORK(LVALBUF+0+4*(IBUF-1))=DNOM
                  WORK(LVALBUF+1+4*(IBUF-1))=RHS
                  WORK(LVALBUF+2+4*(IBUF-1))=COEF
                  WORK(LVALBUF+3+4*(IBUF-1))=ECNT
                END IF
              END IF
            END DO
          END DO

#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            IF (IASTA.GT.0 .AND. IISTA.GT.0) THEN
              CALL GA_Release (lg_RHS,IASTA,IAEND,IISTA,IIEND)
              CALL GA_Release (lg_VEC,IASTA,IAEND,IISTA,IIEND)
            END IF
          END IF
#endif
          NBUF=IBUF
#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            CALL GAIGOP_SCAL(NBUF,'+')
            CALL GETMEM('IDX','ALLO','INTE',LIDX,2*NBUF)
            CALL GETMEM('VAL','ALLO','REAL',LVAL,4*NBUF)
            CALL allgather(IWORK(LIDXBUF:),2*IBUF,
     &                         IWORK(LIDX:),2*NBUF)
            CALL allgather(WORK(LVALBUF: ),4*IBUF,
     &                         WORK(LVAL: ),4*NBUF)
          ELSE
            LIDX=LIDXBUF
            LVAL=LVALBUF
          END IF
#else
          LIDX=LIDXBUF
          LVAL=LVALBUF
#endif

          DO IBUF=1,NBUF
            IAS  = IWORK(LIDX+0+2*(IBUF-1))
            IIS  = IWORK(LIDX+1+2*(IBUF-1))
            DNOM = WORK(LVAL+0+4*(IBUF-1))
            RHS  = WORK(LVAL+1+4*(IBUF-1))
            COEF = WORK(LVAL+2+4*(IBUF-1))
            ECNT = WORK(LVAL+3+4*(IBUF-1))
            IF(ICASE.EQ.12.OR.ICASE.EQ.13) THEN
              CALL EXCIND(IAS,IIS,ISYM,ICASE,IP,IQ,IR,IS)
              LINE(13:20)=ORBNAM(IP)
              LINE(21:28)=ORBNAM(IQ)
              LINE(29:36)=ORBNAM(IR)
              LINE(37:44)=ORBNAM(IS)
              LINE(45:46)='  '
            ELSE
              WRITE(LINE(13:22),'(A2,I1,A1,I4.4)')
     &                               'Mu',ISYM,'.',IAS
              CALL NSIND(IIS,ISYM,ICASE,IP,IQ,IR)
              LINE(23:30)=ORBNAM(IP)
              LINE(31:46)='                '
              IF(IQ.GT.0) LINE(31:38)=ORBNAM(IQ)
              IF(IR.GT.0) LINE(39:46)=ORBNAM(IR)
            END IF
            WRITE(6,'(A,4F16.8)') LINE(1:46),DNOM,RHS,COEF,ECNT
          END DO

#ifdef _MOLCAS_MPP_
          IF (Is_Real_Par()) THEN
            CALL GETMEM('IDX','FREE','INTE',LIDX,2*NBUF)
            CALL GETMEM('VAL','FREE','REAL',LVAL,4*NBUF)
          END IF
#endif

          CALL RHS_FREE(NIN,NIS,lg_RHS)
          CALL RHS_FREE(NIN,NIS,lg_VEC)

          CALL GETMEM('LBD','FREE','REAL',LBD,NAS)
          CALL GETMEM('LID','FREE','REAL',LID,NIS)

 100      CONTINUE

C End of very long loop over symmetry and case:
        END DO
      END DO

      CALL GETMEM('IDXBUF','FREE','INTE',LIDXBUF,2*MAXBUF)
      CALL GETMEM('VALBUF','FREE','REAL',LVALBUF,4*MAXBUF)

      Call CollapseOutput(0,'Denominators, etc.')


      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine calcrh1 (wrk,wrksize,
     & mapd1,mapd2)
c
c     this routine calc V1 = V1-V2
c
c     mapd1 - direct map of vecotr 1 (I)
c     mapd2 - direct map of vecotr 2 (I)
c
c     N.B. it is assumed, that V1 and V2 are of the same type
c
#include "wrk.fh"
c
       integer mapd1(0:512,1:6)
       integer mapd2(0:512,1:6)
c
c     help variables
c
       integer poss1,poss2,length,ii
c
c1    calc length
       ii=mapd1(0,5)
       length=mapd1(ii,1)+mapd1(ii,2)-mapd1(1,1)
c
c2    realize substract
       if (length.gt.0) then
       poss1=mapd1(1,1)
       poss2=mapd2(1,1)
       do 10 ii=0,length-1
       wrk(poss1+ii)=wrk(poss1+ii)-wrk(poss2+ii)
 10     continue
       end if
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Acore(iang,la,ishll,nordop,TC,A,Array,narr,
     &                 Alpha,nalpha,fa1,fa2,jfgrad,jfhess,
     &                 ld,debug)
*
*
*  Calculates <A'|core> and <A"|core>
*
* @parameter iang  Angular momenta for core
* @parameter la    Angular momenta for bra
* @parameter ishll identification for core shell
* @parameter nordop order for operator
* @parameter TC   Cartesian coordinates for core
* @parameter  A Cartesian coordinates for bra
* @parameter Array Scratch
* @parameter narr size for scratch
* @parameter Alpha Bra exponents
* @parameter nalpha number of exponents
* @parameter FA1 First derivatives (out)
* @parameter FA2 2nd derivatives (out)
* @parameter jfgrad true for all 1-deriavtives that are needed
* @parameter jfhess true for all 2-deriavtives that are needed
* @parameter ld Order of derivatives
* @parameter debug guess
      Use Basis_Info
      use Her_RW
      use Real_Spherical
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "disp.fh"
      Logical ABeq(3),jfgrad(3),jfhess(4,3,4,3),
     &        debug
      Real*8 TC(3),A(3),Array(*),fa1(*),fa2(*),alpha(*)
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*
      nExpi=Shells(iShll)%nExp
      ip = 1
      ipP1 = ip
      ip = ip + 3 * nAlpha*nExpi
      ipZ1 = ip
      ip = ip + nAlpha*nExpi
      ipK1 = ip
      ip = ip + nAlpha*nExpi
      ipZI1 = ip
      ip = ip + nAlpha*nExpi
      If (ip-1.gt.nArr) Then
         Write (6,*) ' ip-1.gt.nArr in acore  (',ip,
     &   ',',narr,')'
         Call Abend
      End If

C------Calculate Effective center and exponent for <A|core>

      Call ZXia(Array(ipZ1),Array(ipZI1),nAlpha,nExpi,
     &          Alpha,Shells(iShll)%Exp)
      Call SetUp1(Alpha,nAlpha,Shells(iShll)%Exp,nExpi,
     &            A,TC,Array(ipK1),Array(ipP1),Array(ipZI1))
*
*--------------Calculate Overlap <A|core> and derivative <A'|core>
*
      nHer = (la+1+iAng+1+ld)/2
      ipAxyz = ip
      ip = ip + nAlpha*nExpi*3*nHer*(la+1+ld)
      ipCxyz = ip
      ip = ip + nAlpha*nExpi*3*nHer*(iAng+1)
      ipRxyz = ip
      ip = ip + nAlpha*nExpi*3*nHer*(nOrdOp+1)
      ipQ1 = ip
      ip = ip +
     &      nAlpha*nExpi*3*(la+1+ld)*(iAng+1)*(nOrdOp+1)
      ipA = ip
      ip = ip + nAlpha*nExpi
      If (ip-1.gt.nArr) Then
         Write (6,*) '  ip-1.gt.nArr (1b) in acore (',
     &    ip,',',narr,')','Order',ld,Shells(ishll)%nExp,nalpha
         Call Abend
      End If
      ABeq(1) = A(1).eq.TC(1)
      ABeq(2) = A(2).eq.TC(2)
      ABeq(3) = A(3).eq.TC(3)
      Call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,
     &            A,Array(ipAxyz),la+ld,HerR(iHerR(nHer)),
     &            nHer,ABeq)
      Call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,
     &            TC,Array(ipCxyz),iAng,HerR(iHerR(nHer)),
     &            nHer,ABeq)
      ABeq(1) = .False.
      ABeq(2) = .False.
      ABeq(3) = .False.
      Call CrtCmp(Array(ipZ1),Array(ipP1),nAlpha*nExpi,
     &            A,Array(ipRxyz),nOrdOp,HerR(iHerR(nHer)),
     &            nHer,ABeq)
      If (debug) Then
        Write (6,*) ' nAlpha = ',nAlpha,' nExp(',ishll,')=',
     &              nExpi,' nHer=',nHer,' la=',la,' iAng=',
     &              iAng,' nOrdOp=',nOrdOp

        Write (6,*) ' Array(ipAxyz)=',
     &             DNrm2_(nAlpha*nExpi*3*nHer*(la+ld+1),
     &             Array(ipAxyz),1)
        Write (6,*) ' Array(ipCxyz)=',
     &             DNrm2_(nAlpha*nExpi*3*nHer*(iAng+1),
     &             Array(ipCxyz),1)
        Write (6,*) ' Array(ipRxyz)=',
     &             DNrm2_(nAlpha*nExpi*3*nHer*(nOrdOp+1),
     &             Array(ipRxyz),1)
      End If

      Call Assmbl(Array(ipQ1),
     &            Array(ipAxyz),la+ld,
     &            Array(ipRxyz),nOrdOp,
     &            Array(ipCxyz),iAng,
     &            nAlpha*nExpi,HerW(iHerW(nHer)),nHer)
      iStrt = ipA
      Do 20 iGamma = 1, nExpi
         call dcopy_(nAlpha,Alpha,1,Array(iStrt),1)
         iStrt = iStrt + nAlpha
 20   Continue
      If (debug) Then
                  Write (6,*) ' Array(ipA)=',
     &            DNrm2_(nAlpha*nExpi,Array(ipA),1)
      End If

      Call rKappa_Zeta(Array(ipK1),Array(ipZ1),nExpi*nAlpha)
      Call CmbnAC(Array(ipQ1),nAlpha*nExpi,la,iAng,
     &            Array(ipK1),FA1,
     &            Array(ipA),JfGrad,ld,nVecAC)
      If (debug) Then
      write(6,*) 'nVecAC',nvecac
                  Write (6,*) ' Array(ipQ1)=',
     &            DNrm2_(
     &            nAlpha*nExpi*3*(la+ld+1)*(iAng+1)*(nOrdOp+1),
     &            Array(ipQ1),1)
                  Write (6,*) ' Array(ipA)=',
     &            DNrm2_(nAlpha*nExpi,Array(ipA),1)
      Do i=1,nvecac
        ipV=1
        n=nAlpha*nExpi*nElem(la)*nElem(iAng)
        Write(6,*) 'Cmbn(',i,')=',DNrm2_(n,FA1(ipV),1)
        ipV=ipV+n
      End do
      End If

      If (ld.ge.2) Then
        Call CmbnS2a(Array(ipQ1),nAlpha*nExpi,la,iAng,
     &              Array(ipK1),FA2,
     &              Array(ipA),jfHess,ld)
        If (debug) Then
          Do i=1,6
            ipV=1
            n=nAlpha*nExpi*nElem(la)*nElem(iAng)
            Write(6,*) 'Cmbn2(',i,')=',DNrm2_(n,FA2(ipV),1)
            ipV=ipV+n
          End do
        End If
      End If


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Hess_Vec(nAtoms,Hess,EVec,mAtoms,nDim)
      Implicit Real*8 (a-h,o-z)
#include "real.fh"
#include "WrkSpc.fh"
      Real*8 Hess(3*nAtoms*(3*nAtoms+1)/2),EVec((3*mAtoms)**2)
*                                                                      *
************************************************************************
*                                                                      *
*---- Compute the eigenvalues and the eigenvectors of the Hessian
*
*define _DEBUGPRINT_
*
*---- Set up a unit matrix
*
      nQ = nDim
      call dcopy_(nQ*nQ,[Zero],0,EVec,1)
      call dcopy_(nQ,[One],0,EVec,nQ+1)
*
*---- Compute eigenvalues and eigenvectors
*
      Call NIDiag_new(Hess,EVec,nQ,nQ,0)
      Call JacOrd(Hess,EVec,nQ,nQ)
*
      ThrD=1.0D-10
      Do iQ = 1, nQ
*        Fix standard direction.
         rZ = 0.0D0
         Do iElem = 1, nQ
            ij=(iQ-1)*nQ + iElem
            If (Abs(EVec(ij)).gt.Abs(rZ)+ThrD)
     &         rZ = EVec(ij)
         End Do
         ij=(iQ-1)*nQ + 1
         If (rZ.lt.0.0D0) Call DScal_(nQ,-One,EVec(ij),1)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
#ifdef _DEBUGPRINT_
      Call RecPrt(' Eigenvectors','(12f6.2)',EVec,nDim,nDim)
      Call TriPrt(' Eigenvalues','(12E8.2)',Hess,nDim)
#endif
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GEN_INT_DCCD(rc,ipq1,Xint)

use Index_Functions, only: nTri_Elem
use GetInt_mod, only: nRS, Vec2, NumV
use GetInt_mod, only: lists, I, hash_table
use TwoDat, only: rcTwo
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp), intent(in) :: ipq1
real(kind=wp), intent(_OUT_) :: Xint(*)
integer(kind=iwp) :: iR, iR_, iRS, iS, iS_, J
real(kind=wp) :: Temp

Xint(1:nRS) = Zero

do iR_=lists(3,I),lists(4,I)
  iR = hash_table(iR_)
  do iS_=lists(3,I),iR_
    iS = hash_table(iS_)
    iRS = nTri_Elem(iR-1)+iS
    Temp = Zero
    do J=1,NumV
      Temp = Temp+Vec2(iRS,J)*Vec2(ipq1,J)
    end do
    XInt(iRS) = XInt(iRS)+Temp
  end do
end do

rc = rcTwo%good

return

end subroutine GEN_INT_DCCD

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine DecideOnDirect(CanDoDirect,FoundTwoEls,DoDirect,
     &                          DoCholesky)
      Implicit Integer (a-z)
      Logical CanDoDirect,FoundTwoEls,DoDirect,DoCholesky
      Logical Direct,Expert,NeverDirect,AlwaysDirect
c----------------------------------------------------------------------
c                                                                     -
c  All modules using two-electron integrals should call this routine  -
c  to decide whether to do the calculation integral-direct.           -
c                                                                     -
c  On input:     CanDoDirect : Direct capability of module (T/F).     -
c                FoundTwoEls : Two-electron integral file available.  -
c                                                                     -
c  On exit:      DoDirect:     Do calculation integral-direct.        -
c                DoCholesky:   Do Cholesky calculation                -
c                                                                     -
c----------------------------------------------------------------------

c  Read option variable set in Seward
*
*     Call Get_iOption(iOptSeward)

      Call DecideOnCholesky(DoCholesky)
      If (DoCholesky) then
         DoDirect=.false.
         return
      Endif

      Call Get_iScalar('System BitSwitch',iOptSeward)
*
      Direct=Iand(iOptSeward,1).Eq.1
      Expert=Iand(iOptSeward,2).Eq.2
      AlwaysDirect=Direct.And..Not.Expert
      NeverDirect=(.Not.Direct).And..Not.Expert

      If (AlwaysDirect) Then
        If (.Not.CanDoDirect) Then
          Write(6,'(A)')' Error, cannot do integral-direct calculation!'
          Write(6,'(A)')' Turn off DIRECT option in SEWARD input.'
          Call Abend()
        Else
          DoDirect=.True.
        Endif
      ElseIf ((.Not.FoundTwoEls) .And.
     &        (NeverDirect.Or..Not.CanDoDirect)) Then
*------ No integrals, no direct calculation (allowed) - we have to crash!
        Write(6,'(2A)')' Two-electron integral file was not found!'
        If(CanDoDirect) Write(6,'(A)')' Try keyword DIRECT in SEWARD.'
        Call Abend()
      Else If (.Not. FoundTwoEls) Then
        DoDirect = .True.
      Else
        DoDirect = .False.
      Endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per-Olof Widmark                                       *
************************************************************************
************************************************************************
*                                                                      *
* This program generates generally contracted basis sets from multiple *
* atomic densities. The densities are averaged with weights and the    *
* resulting eigenvectors, Natural Orbitals (NO), are used as basis     *
* functions where the corresponding eigenvalues, occupation numbers,   *
* are used as measure of importance.                                   *
* It is also possible to project out the contributions of vectors      *
* from the averaged density before generating the NO's.                *
*                                                                      *
*======================================================================*
*                                                                      *
* Author: Per-Olof Widmark                                             *
*         IBM Sweden                                                   *
*                                                                      *
************************************************************************
      Subroutine GenAno(ireturn)
      Implicit Real*8 (a-h,o-z)
#include "parm.fh"
#include "common.fh"
#include "symlab.fh"
      Call MkType
      Call InpCtl_GENANO()
      Do 100 i=1,nSets
         Call RdCmo
         Call UpDens
         If(isUHF.eq.1) Then
            Call RdCmo()
            Call UpDens()
            isUHF=0
         End If
100   Continue
      Call SphAve()
      If(iProj.eq.1) Call Proj1()
      If(iProj.eq.2) Call Proj2()
      Call MkAno()
*
      ireturn=0
      return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine CHO_MCA_INT_1(IJ,KL,XINT,LINT,LOCPRT)
!
! Purpose: calculate shell-quadruple (IJ|KL) and return
!          them in XINT.
!
! Notes:
!    LOCPRT: flag for printing the shell quadruple to output;
!            output format differs depending on IFCSEW.

use Index_Functions, only: iTri, nTri_Elem
use Integral_Interfaces, only: Int_PostProcess, int_wrout
use Cholesky, only: IFCSew, iSP2F, LuPri, nBstSh, ShA, ShAB, ShB, ShC, ShCD, ShD
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IJ, KL, LINT
real(kind=wp), intent(inout) :: XINT(LINT)
logical(kind=iwp), intent(in) :: LOCPRT
integer(kind=iwp) :: I, II, IIJJ, J, JJ, K, KK, KKLL, KOFF, L, LL, NUMI, NUMIJ, NUMJ, NUMK, NUML
procedure(int_wrout) :: Integral_WrOut_Cho
character(len=*), parameter :: SECNAM = 'CHO_MCA_INT_1'

! Initializations.
! ----------------

call CHO_INVPCK(ISP2F(IJ),I,J,.true.)
call CHO_INVPCK(ISP2F(KL),K,L,.true.)

SHCD = IJ
SHAB = KL
SHC = I
SHD = J
SHA = K
SHB = L

! Calculate integrals.
! --------------------

Int_PostProcess => Integral_WrOut_Cho
call EVAL_IJKL(I,J,K,L,XINT,LINT)
nullify(Int_PostProcess)

! Print integrals.
! ----------------

if (LOCPRT) then

  if (IFCSEW == 1) then

    write(LUPRI,'(//,5X,A,A,4I5,A)') SECNAM,': shell quadruple ',I,J,K,L,':'

    NUMI = NBSTSH(I)
    NUMJ = NBSTSH(J)
    NUMK = NBSTSH(K)
    NUML = NBSTSH(L)
    if (I == J) then
      NUMIJ = nTri_Elem(NUMI)
    else
      NUMIJ = NUMI*NUMJ
    end if

    if (K == L) then
      do LL=1,NUML
        do KK=1,LL
          KKLL = ITRI(KK,LL)
          if (I == J) then
            do JJ=1,NUMJ
              do II=1,JJ
                IIJJ = ITRI(II,JJ)
                KOFF = NUMIJ*(KKLL-1)+IIJJ
                write(LUPRI,*) '(',I,J,K,L,') [',II,JJ,KK,LL,'] = ',XINT(KOFF)
              end do
            end do
          else
            do JJ=1,NUMJ
              do II=1,NUMI
                IIJJ = NUMI*(JJ-1)+II
                KOFF = NUMIJ*(KKLL-1)+IIJJ
                write(LUPRI,*) '(',I,J,K,L,') [',II,JJ,KK,LL,'] = ',XINT(KOFF)
              end do
            end do
          end if
        end do
      end do
    else
      do LL=1,NUML
        do KK=1,NUMK
          KKLL = NUMK*(LL-1)+KK
          if (I == J) then
            do JJ=1,NUMJ
              do II=1,JJ
                IIJJ = ITRI(II,JJ)
                KOFF = NUMIJ*(KKLL-1)+IIJJ
                write(LUPRI,*) '(',I,J,K,L,') [',II,JJ,KK,LL,'] = ',XINT(KOFF)
              end do
            end do
          else
            do JJ=1,NUMJ
              do II=1,NUMI
                IIJJ = NUMI*(JJ-1)+II
                KOFF = NUMIJ*(KKLL-1)+IIJJ
                write(LUPRI,*) '(',I,J,K,L,') [',II,JJ,KK,LL,'] = ',XINT(KOFF)
              end do
            end do
          end if
        end do
      end do
    end if

  else if ((IFCSEW == 2) .or. (IFCSEW == 3)) then

    call CHO_PRTINT(IJ,KL,XINT,LINT)

  else

    write(LUPRI,*) SECNAM,': IFCSEW=',IFCSEW
    call CHO_QUIT(SECNAM//': IFCSEW out of bounds!',103)

  end if

end if

end subroutine CHO_MCA_INT_1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
#ifdef _MOLCAS_MPP_

      module allgather_wrapper
      private
      public :: allgather

      interface allgather
        module procedure allgather_R, allgather_I
      end interface

      contains
      SUBROUTINE ALLGATHER_R(SEND,NSEND,RECV,NRECV)
      use mpi
      implicit none
************************************************************************
* allgather: gathers local buffers SEND of size NSEND on
*            each process into a buffer RECV of size NRECV.
*            The receiving buffer is allocated by this subroutine.
************************************************************************
#include "warnings.fh"
#include "WrkSpc.fh"

#include "global.fh"
#include "mafdecls.fh"

      real*8, intent(in) :: SEND(nSend)
      integer, intent(in) :: nSend
      real*8, intent(out) :: RECV(nRecv)
      integer, intent(in) :: nRecv

      integer*4 :: NSEND4(1), ITYPE4, IERROR4, nRecv4Tot
      INTEGER*4, ALLOCATABLE :: NRECV4(:),IDISP4(:)
      INTEGER*4, PARAMETER :: ONE4 = 1
      integer :: nBytes, myrank, nProcs, i

      ITYPE4 = MPI_REAL8
      NBYTES = 8 * NRECV

      IF (NBYTES.GT.2147483647) THEN
        WRITE(6,'(1X,A)') 'WARNING: ALLGATHER: receive buffer > 2GB'
        WRITE(6,'(1X,A)') 'some MPI implementations cannot handle this'
        WRITE(6,'(1X,A)') 'I will continue, but it might crash...'
        CALL XFLUSH(6)
      END IF

      MYRANK = GA_NODEID()
      NPROCS = GA_NNODES()

      ALLOCATE(NRECV4(0:NPROCS-1))
      ALLOCATE(IDISP4(0:NPROCS-1))

! first, gather the sendbuffer size of each process in NRECV4
      NSEND4(1)=INT(NSEND,KIND(NSEND4))
      CALL MPI_ALLGATHER(NSEND4,ONE4,MPI_INTEGER4,
     &                   NRECV4,ONE4,MPI_INTEGER4,
     &                   MPI_COMM_WORLD, IERROR4)
      IF (IERROR4.NE.0) THEN
        WRITE(6,'(1X,A,I4)') 'ERROR: ALLGATHER: MPI_Allgather ',IERROR4
        CALL ABEND()
      END IF

! check sum of send buffers against size of the receive buffer
      NRECV4TOT=0
      DO I=0,NPROCS-1
        NRECV4TOT=NRECV4TOT+NRECV4(I)
      END DO
      IF (NRECV4TOT.NE.NRECV) THEN
        WRITE(6,'(1X,A)') 'ERROR: ALLGATHER: buffer sizes do not match'
        CALL ABEND()
      END IF

! compute the displacments from the different sizes in IDISP
      IDISP4(0)=0
      DO I=1,NPROCS-1
        IDISP4(I)=IDISP4(I-1)+NRECV4(I-1)
      END DO

! gather the local send buffers into the receive buffer
      CALL MPI_ALLGATHERV(SEND,NSEND4(1),ITYPE4,
     &                    RECV,NRECV4,IDISP4,ITYPE4,
     &                    MPI_COMM_WORLD,IERROR4)
      IF (IERROR4.NE.0) THEN
        WRITE(6,'(1X,A,I4)') 'ERROR: ALLGATHER: MPI_Allgatherv ',IERROR4
        CALL ABEND()
      END IF
      end subroutine  allgather_R

      SUBROUTINE ALLGATHER_I(SEND,NSEND,RECV,NRECV)
      use mpi
      implicit none
************************************************************************
* allgather: gathers local buffers SEND of size NSEND on
*            each process into a buffer RECV of size NRECV.
*            The receiving buffer is allocated by this subroutine.
************************************************************************
#include "warnings.fh"
#include "WrkSpc.fh"

#include "global.fh"
#include "mafdecls.fh"

      integer, intent(in) :: SEND(nSend)
      integer, intent(in) :: nSend
      integer, intent(out) :: RECV(nRecv)
      integer, intent(in) :: nRecv

      integer*4 :: NSEND4(1), ITYPE4, IERROR4, nRecv4Tot
      INTEGER*4, ALLOCATABLE :: NRECV4(:),IDISP4(:)
      INTEGER*4, PARAMETER :: ONE4 = 1
      integer :: nBytes, myrank, nProcs, i

#ifdef _I8_
        ITYPE4=MPI_INTEGER8
        NBYTES=8*NRECV
#else
        ITYPE4=MPI_INTEGER4
        NBYTES=4*NRECV
#endif

      IF (NBYTES.GT.2147483647) THEN
        WRITE(6,'(1X,A)') 'WARNING: ALLGATHER: receive buffer > 2GB'
        WRITE(6,'(1X,A)') 'some MPI implementations cannot handle this'
        WRITE(6,'(1X,A)') 'I will continue, but it might crash...'
        CALL XFLUSH(6)
      END IF

      MYRANK = GA_NODEID()
      NPROCS = GA_NNODES()

      ALLOCATE(NRECV4(0:NPROCS-1))
      ALLOCATE(IDISP4(0:NPROCS-1))

! first, gather the sendbuffer size of each process in NRECV4
      NSEND4(1)=INT(NSEND,KIND(NSEND4))
      CALL MPI_ALLGATHER(NSEND4,ONE4,MPI_INTEGER4,
     &                   NRECV4,ONE4,MPI_INTEGER4,
     &                   MPI_COMM_WORLD, IERROR4)
      IF (IERROR4.NE.0) THEN
        WRITE(6,'(1X,A,I4)') 'ERROR: ALLGATHER: MPI_Allgather ',IERROR4
        CALL ABEND()
      END IF

! check sum of send buffers against size of the receive buffer
      NRECV4TOT=0
      DO I=0,NPROCS-1
        NRECV4TOT=NRECV4TOT+NRECV4(I)
      END DO
      IF (NRECV4TOT.NE.NRECV) THEN
        WRITE(6,'(1X,A)') 'ERROR: ALLGATHER: buffer sizes do not match'
        CALL ABEND()
      END IF

! compute the displacments from the different sizes in IDISP
      IDISP4(0)=0
      DO I=1,NPROCS-1
        IDISP4(I)=IDISP4(I-1)+NRECV4(I-1)
      END DO

! gather the local send buffers into the receive buffer
      CALL MPI_ALLGATHERV(SEND,NSEND4(1),ITYPE4,
     &                    RECV,NRECV4,IDISP4,ITYPE4,
     &                    MPI_COMM_WORLD,IERROR4)
      IF (IERROR4.NE.0) THEN
        WRITE(6,'(1X,A,I4)') 'ERROR: ALLGATHER: MPI_Allgatherv ',IERROR4
        CALL ABEND()
      END IF
      end subroutine allgather_I
      end module allgather_wrapper

#elif defined (NAGFOR)
c Some compilers do not like empty files
      SUBROUTINE EMPTY_ALLGATHER()
      END
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996,1997, Anders Bernhardsson                         *
!***********************************************************************

subroutine Prec_dig(rpre,ipre,idsym)
!***********************************************************************
!                                                                      *
!     idsym, symmetry of orbital hessian of interest                   *
!     CMtx preconditioner                                              *
!                                                                      *
!     The orbital hessian is dominated of elements that couples        *
!                                                                      *
!     kappa  -> kappa      where i is occupied and p,q is general.     *
!          ip        iq                                                *
!                                                                      *
!     we therefore approximate the hessian with those diagonal         *
!     terms in the preconditioner                                      *
!                                                                      *
!     Anders Bernhardsson 96                                           *
!                                                                      *
!     active; active,general is needed for rasscf calculation          *
!     and is not coded yet (ugly bastard) (970109, AB)                 *
!***********************************************************************

use Symmetry_Info, only: Mul
use MCLR_Data, only: F0SQMO, FAMO, FIMO, ipCM, nrec
use input_mclr, only: iMethod, nAsh, nBas, nIsh, nRS1, nRS2, nRS3, nSym, TimeDep
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: rpre(*)
integer(kind=iwp), intent(_OUT_) :: ipre(*)
integer(kind=iwp), intent(in) :: idsym
integer(kind=iwp) :: iB, iBB, ip, ipi, iRC, iS, jS, n2, nD, ni, nmm, nmmm, nTemp
real(kind=wp) :: Sgn
real(kind=wp), allocatable :: JInt(:), KInt(:), Scr(:), Temp1(:,:), Temp2(:), Temp3(:), Temp4(:)

!                                                                      *
!***********************************************************************
!                                                                      *
nmm = max(0,maxval(nAsh(1:nSym)+nIsh(1:nSym)))
nmmm = max(0,maxval(nBas(1:nSym)))
n2 = nMMM**2
nmmm = ((nmmm-1)/nRec+1)*nRec
nmm = nmm*nMMM
nmm = nmm**2

call mma_allocate(JInt,n2,Label='JInt')
call mma_allocate(KInt,n2,Label='KInt')
call mma_allocate(Scr,n2,Label='Scr')

ip = 1
ipi = 1
Sgn = One
do iS=1,nSym
  jS = Mul(is,iDSym)
  nD = nBas(js)-nIsh(jS)
  ni = nBas(js)**2
  call mma_allocate(Temp2,ni,Label='Temp2')
  call mma_allocate(Temp3,ni,Label='Temp3')
  call mma_allocate(Temp4,ni,Label='Temp4')
  Temp4(:) = Zero
  call mma_MaxDBLE(nTemp)
  nTemp = min(nmm,nTemp/2)
  call mma_allocate(Temp1,nTemp,2,Label='Temp1')

  if (nD /= 0) then
    do iB=1,nIsh(iS)
      Temp3(1:nD**2) = Zero
      ibb = nBas(is)*(ib-1)+ib-2

      if (iMethod == 2) then

        ! G
        !  iaib

        if (nash(js) > 0) &
          call Preciaa(ib,is,js,nd,Temp3,nbas(js),FIMO(1+ipCM(is)+ibb),FAMO(1+ipCM(is)+ibb),FIMO(ipCM(js)),FAMO(ipCM(js)), &
                       F0sqMO(ipCM(js)),Sgn,JInt,KInt,Scr,n2) ! OK

        ! G
        !  ipia

        if ((nbas(js)-nish(js)-nash(js))*nash(js) > 0) &
          call Preciba(ib,is,js,nd,Temp3,nbas(js),FIMO(ipCM(js)),FAMO(ipCM(js)),F0sqMO(ipCM(js)),Sgn,JInt,KInt,Scr,n2) ! OK
      end if

      ! G
      !  ipiq

      if ((nbas(js)-nish(js)-nash(js)) > 0) &
        call Precibb_td(ib,is,js,nd,Temp3,nBas(js),Temp1(:,1),Temp1(:,2),Temp2,FiMo(1+ipCM(is)+ibb),FAMO(1+ipcm(is)+ibb), &
                        FiMo(ipCM(js)),FAMO(ipcm(js)),Sgn)  ! OK

      ! Factorize G:
      !
      !     T
      ! G=LL

      if (.not. timedep) then
        call SQM(Temp3,rpre(ip),nd)
        irc = 0
        call dgetrf_(nd,nd,rpre(ip),nd,ipre(ipi),irc)
        if (irc /= 0) then
          write(u6,*) 'Error in DGETRF called from prec_dig'
          call Abend()
        end if
      else
        call SQM(Temp3,Temp4,nD)
        rpre(ip:ip+nd-1) = Temp4(1:nd**2:nd+1)
      end if
      if (TimeDep) then
        ip = ip+nD
      else
        ip = ip+nD**2
        ipi = ipi+nD
      end if

    end do   ! iB, inactive
  end if

  Temp4(1:ni) = Zero
  do iB=1,nAsh(iS)
    ibb = nBas(is)*(nish(is)+ib-1)+nish(is)+ib-2
    if (ib <= nRS1(iS)) then
      nD = nBas(js)-nRs1(js)
    else if (ib <= nRs1(iS)+nRs2(iS)) then
      nD = nBas(js)-nRs2(js)
    else
      nD = nBas(js)-nRs3(js)
    end if
    if (nD /= 0) then
      Temp3(1:nD**2) = Zero
      if (nish(js) > 0) &
        call Precaii(ib,is,js,nd,Temp3,nbas(js),FIMO(1+ipCM(is)+ibb),FAMO(1+ipCM(is)+ibb),F0SqMO(1+ipCM(is)+ibb),FIMO(ipCM(js)), &
                     FAMO(ipCM(js)),Sgn,JInt,KInt,Scr,n2) ! OK
      !call Precaai(ib,nd,ir,rpre(ip))
      !call Precaaa(ib,nd,ir,rpre(ip))
      if (nish(js)*nBas(js) > 0) &
        call Precabi(ib,is,js,nd,Temp3,nBas(js),FIMO(ipCM(js)),FAMO(ipCM(js)),Sgn,JInt,KInt,Scr,n2) !+/-?

      !call Precaba(ib,nd,ir,rpre(ip))
      if (nBas(js) > 0) &
        call Precabb(ib,is,js,nd,nbas(js),Temp3,Temp1(:,1),ntemp,Temp1(:,2),Temp2,F0SQMO(1+ipCM(is)+ibb),FiMo(ipCM(js)),Sgn)
      if (.not. timedep) then
        call SQM(Temp3,rpre(ip),nD)
        irc = 0
        call dgetrf_(nd,nd,rpre(ip),nd,ipre(ipi),irc)
        if (irc /= 0) then
          write(u6,*) 'Error in DGETRF called from prec_dig'
          call Abend()
        end if
      else
        ! From Triang mat
        call SQM(Temp3,Temp4,nD)
        rpre(ip:ip+nd-1) = Temp4(1:nd**2:nd+1)
      end if
      if (timedep) then
        ip = ip+nd
      else
        ip = ip+nD**2
        ipi = ipi+nD
      end if
    end if
  end do ! iB
  call mma_deallocate(Temp1)
  call mma_deallocate(Temp2)
  call mma_deallocate(Temp3)
  call mma_deallocate(Temp4)
end do ! End loop over symmetries
!                                                                      *
!***********************************************************************
!                                                                      *
call mma_deallocate(Scr)
call mma_deallocate(KInt)
call mma_deallocate(JInt)
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Prec_dig

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     this file contains following routines:
c     action
c     mkmapampq
c     mkmappqij
c     addpqij
c     mkintsta
c     expandfok
c     addinta
c     deflenght
c     fokupdate1
c     fokupdate2
c     unpackk
c     getpp
c     initintabc1
c     addintabc1
c     initwrk
c
c
c     -------------------------------------
c
       subroutine action (foka, fokb, fi,eps)
c
       implicit real*8 (a-h,o-z)
c
c      work file declaration
       integer wrksize
#include "WrkSpc.fh"
c
#include "ccsort.fh"
#include "reorg.fh"
#include "files_ccsd.fh"
       real*8 fi(*)
       real*8 eps(mbas)
c
c     help variables
c
       integer symp,symq,symr,syms,sympq,sympqr
       integer ndimv1,ndimv2,ndimv3,ndimvi
       integer p,a,posst,rc
       integer keyred,vsize,freespace,ickey,iOff_Vic,iOff
       integer t3help1,t3help2,t3help3,t3help4
       integer ipAMMAP,ipABMAP,ipJN,ipKN,ipLN,iOff_valn
       real*8 foka((mbas**2+mbas)/2)
       real*8 fokb((mbas**2+mbas)/2)


c
c*    distribute memory
c
c*.1   calc. work space requirements
       call initwrk (wrksize)
c
c*.2   test if allocation of required memory is possible
c
c*.2.1 allocate work space
c
       Call GetMem('CCSORT','Max','Real',maxspace,maxspace)
       maxspace=maxspace-4
       if (maxspace.lt.wrksize) then
         write(6,*) ' Allocation of work space failed!'
         write(6,*) ' Increase the size of the variable MOLCAS_MEM'
         Call Abend
       end if
       Call GetMem('CCSORT','Allo','Real',iOff,wrksize)
c
c*.3   set wrk = 0
       call ccsort_mv0zero (wrksize,wrksize,Work(iOff))
c
c
c*    def foka,fokb
c
       ndimv1=0
       do 100 symp=1,nsym
       ndimv1=ndimv1+(norb(symp)+1)*norb(symp)/2
 100    continue
c
       do 200 ndimv2=1,ndimv1
       foka(ndimv2)=fi(ndimv2)
       fokb(ndimv2)=fi(ndimv2)
 200    continue
c
c*    make names
c
       call mktempanam
c
c*    if T3 are requited, define T3IntPoss and calc T3Off
       if (t3key.eq.1) then
         call DefT3par (noa,nsym)
         do symp=1,4
         end do
       end if
c
c*    open files INTA1,INTA2,INTA3,INTA4 and INTAB
c
       if (iokey.eq.1) then
c      Fortran IO
       call molcas_binaryopen_vanilla(luna1,'INTA1')
       call molcas_binaryopen_vanilla(luna2,'INTA2')
       call molcas_binaryopen_vanilla(luna3,'INTA3')
       call molcas_binaryopen_vanilla(luna4,'INTA4')
       call molcas_binaryopen_vanilla(lunab,'INTAB')
c       open (unit=luna1,file='INTA1',form='unformatted')
c       open (unit=luna2,file='INTA2',form='unformatted')
c       open (unit=luna3,file='INTA3',form='unformatted')
c       open (unit=luna4,file='INTA4',form='unformatted')
c       open (unit=lunab,file='INTAB',form='unformatted')
c
       else
c      MOLCAS IO
       call daname (luna1,'INTA1')
       call daname (luna2,'INTA2')
       call daname (luna3,'INTA3')
       call daname (luna4,'INTA4')
       call daname (lunab,'INTAB')
       daddr(luna1)=0
       daddr(luna2)=0
       daddr(luna3)=0
       daddr(luna4)=0
       daddr(lunab)=0
       end if
c
c*    define #V1 (for <p,q,i,j>
       call mkmappqij
c
c*    make head of INTAB file for nonsymmetrical (C1) case
       if (nsym.eq.1) then
       call initintabc1
       end if
c
c     allocate space for ammap,abmap
       Call GetMem('AMMAP','ALLO','INTE',ipAMMAP,mbas*64)
       Call GetMem('ABMAP','ALLO','INTE',ipABMAP,mbas*mbas*8)
c
       do 1000 symp=1,nsym
c
       if (fullprint.gt.0) then
       write(6,'(6X,A,2X,I2)') 'Symmetry of the pivot index',symp
       end if
c
c*    define #V2 (for <_a,m,p,q>)
       call mkmapampq (symp)
c
c*    if T3 are required, make maps for R_i
       if ((t3key.eq.1).and.(noa(symp).gt.0)) then
c*            get mapd and mapi for  R_i(a,bc)
        call ccsort_t3grc0(3,8,4,4,4,0,symp,possri0,posst,mapdri,mapiri)
       end if
c
c*    open TEMPDA2 fils for <am|rs> integrals, if there are some virtiuals
c     in symp symmetry
       if (nvb(symp).gt.0) then
       call mkampqmap (iWork(ipAMMAP),symp,rc)
       call daopen ('TEMPDA2 ',lunda2,recl,1)
       end if
c
       do 900 symq=1,nsym
       sympq=mul(symp,symq)
c
       if ((nsym.gt.1).and.(symp.ge.symq)) then
c*    open direct acces file here, to enable exact specification of
c     the number of records (only for symmetrical cases; syma>=symb)
c     N.B. nrec is not needed now
       call daopen ('TEMPDA1 ',lunda1,recl,1)
       end if
c
c*    make abmap for syma>=symb
       if (symp.ge.symq) then
       call mkabpqmap (iWork(ipABMAP),symp,symq,rc)
       end if
c
       do 800 symr=1,nsym
       sympqr=mul(sympq,symr)
       syms=sympqr
c
c*     calc size of the integral file
       if (symp.eq.symr) then
         if (symp.eq.symq) then
          vsize=(norb(symp)*(norb(symp)+1))/2
          vsize=vsize*(vsize+1)/2
          ickey=3
         else
          vsize=(norb(symp)*(norb(symp)+1)*norb(symq)*(norb(symq)+1))/4
          ickey=2
         end if
       else
       vsize=norb(symp)*norb(symq)*norb(symr)*norb(syms)
       ickey=1
       end if
c
       if (vsize.eq.0) goto 800
c
       if (fullprint.gt.1) then
         write(6,'(6X,A,I4,4X,4I2)') 'Block',typ(symp,symq,symr),
     &                                symp,symq,symr,syms
       end if
c
c*     test for incore expansion
       freespace=0
       Call GetMem('CCSORT','Max','Real',freespace,freespace)
       freespace=freespace-4
       if (fullprint.ge.2) then
       write(6,*)
       Write(6,'(6X,A,I10)') 'Available freespace   ',freespace
       Write(6,'(6X,A,I10)') 'Available freespace/MB',freespace/131072
       write(6,'(6X,A,I10)') 'Incore expansion      ',vsize+mbas*mbas
       write(6,'(6X,A,I10)') 'Out of core expansion ',4*nsize*mbas
       endif
c
       if (freespace.ge.(vsize+mbas*mbas)) then
c      INCORE EXPANSION
         if (fullprint.ge.1) then
         write(6,*)
         write(6,'(6X,A)') 'Incore expansion      '
         end if
         Call GetMem('CCSORT','Allo','Real',iOff_Vic,vsize)
c
         if (ickey.eq.1) then
c:         case V(p,q,r,s)
           call esb_ic_1 (symp,symq,symr,syms,
     &     Work(iOff_Vic),norb(symp),norb(symq),norb(symr),norb(syms))
c
         else if (ickey.eq.2) then
c:       case V(pr,qs)
         Call GetMem('PQIND','ALLO','INTE',ipPQIND,mbas*mbas)
           call  esb_ic_2 (symp,symq,Work(iOff_Vic),
     &     norb(symp),norb(symq),iWork(ipPQIND))
         Call GetMem('PQIND','FREE','INTE',ipPQIND,mbas*mbas)
c
         else
c:       case V(prqs)
         Call GetMem('PQIND','ALLO','INTE',ipPQIND,mbas*mbas)
           call  esb_ic_3 (symp,Work(iOff_Vic),norb(symp),
     &                     iWork(ipPQIND))
         Call GetMem('PQIND','FREE','INTE',ipPQIND,mbas*mbas)
c
         end if
c
       else
c      OUT OF CORE EXPANSION
c*     init temp files and realize expansion of this block
         ickey=0
         if (fullprint.ge.1) then
         write(6,'(6X,A)') 'Out of core expansion '
         end if
       call inittemp (norb(symp))
       if (freespace.lt.(4*nsize*mbas)) then
         write(6,*) ' Allocation of work space for Out-of-core failed!'
         write(6,*) ' Increase the size of the variable MOLCAS_MEM'
         Call Abend
       endif
c
c     allocate space for valn,jn,kn,ln
       Call GetMem('VALN','ALLO','REAL',iOff_valn,nsize*mbas)
       Call GetMem('JN','ALLO','INTE',ipJN,nsize*mbas)
       Call GetMem('KN','ALLO','INTE',ipKN,nsize*mbas)
       Call GetMem('LN','ALLO','INTE',ipLN,nsize*mbas)
c
       call exppsb (symp,symq,symr,syms,Work(iOff_valn),
     &              iWork(ipJN),iWork(ipKN),iWork(ipLN))
c
c     relese space for valn,jn,kn,ln
       Call GetMem('VALN','FREE','REAL',iOff_valn,nsize*mbas)
       Call GetMem('JN','FREE','INTE',ipJN,nsize*mbas)
       Call GetMem('KN','FREE','INTE',ipKN,nsize*mbas)
       Call GetMem('LN','FREE','INTE',ipLN,nsize*mbas)
c
       end if
c
c
c*    run over all pivot indexes
c
       do 500 p=1,norb(symp)
c
c**   def dimensions of vint and read this block of integrals into vint
       ndimvi=norb(symp)
       ndimv1=norb(symq)
       ndimv2=norb(symr)
       ndimv3=norb(syms)
c
       if (ickey.eq.0) then
c      Out of core expansion
c
       if (symq.eq.syms) then
       keyred=1
       else
       keyred=0
       end if
       call unpackk (p,Work(iOff),ndimv1,ndimv2,ndimv3,keyred)
c
       else if (ickey.eq.1) then
c      else Incore expansions
c
c      case V(p,q,r,s)
         call unpackk_ic_1 (p,Work(iOff),ndimv1,ndimv2,ndimv3,
     c                      Work(iOff_Vic),ndimvi)
       else if (ickey.eq.2) then
c      case V(pr,qs)
         call unpackk_ic_2 (p,Work(iOff),ndimvi,ndimv1,Work(iOff_Vic))
       else
c      case V(prqs)
         call unpackk_ic_3 (p,Work(iOff),ndimvi,Work(iOff_Vic))
       end if
c
c
c        goto 500
c
c
c**   add integrals to T3nam if needed (v nacechranej forme)
c
       if (t3key.eq.1) then
       if (p.le.noa(symp)) then
       if (symq.gt.syms) then
c
c***  calc proper address in t3nam file
       t3help4=0
       do t3help1=1,symp-1
       t3help4=t3help4+noa(t3help1)
       end do
       t3help4=t3help4+p
       t3help1=mapiri(symr,symq,1)
       daddr(lunt3)=T3IntPoss(t3help4)+T3Off(t3help1,symp)
c
c***  def required parameters
       t3help1=nvb(symr)
       t3help2=nvb(symq)
       t3help3=nvb(syms)
c
c***  do packing
       call t3intpck2(Work(iOff),Work(iOff+possri0-1),ndimv1,ndimv2,
     & ndimv3,t3help1,t3help2,t3help3,
     & symq,symr,syms,nob,nvb)
c
       else if (symq.eq.syms) then
c
c***  calc proper address in t3nam file
       t3help4=0
       do t3help1=1,symp-1
       t3help4=t3help4+noa(t3help1)
       end do
       t3help4=t3help4+p
       t3help1=mapiri(symr,symq,1)
       daddr(lunt3)=T3IntPoss(t3help4)+T3Off(t3help1,symp)
c
c***  def required parameters
       t3help1=nvb(symr)
       t3help2=nvb(symq)*(nvb(symq)+1)/2
c
c***  do packing
       call t3intpck1(Work(iOff),Work(iOff+possri0-1),ndimv1,ndimv2,
     & ndimv3,t3help1,t3help2,
     & symq,symr,syms,nob,nvb)
c
       end if
       end if
       end if
c
c**   add integrals to #1 <pq|ij> if needed
c
       if (symr.ge.syms) then
c     contributions only for symi(r)>=symj(s)
       call addpqij (Work(iOff),wrksize,
     & symp,symq,symr,syms,p,Work(iOff),ndimv1,ndimv2,ndimv3)
       end if
c
c**   updete fok if neccesarry (only for open shell case)
c
       if (clopkey.eq.1) then
c
       if ((symp.eq.symr).and.(symq.eq.syms)
     & .and.(p.gt.nob(symp)).and.(p.le.(noa(symp)))) then
       call fokupdate1 (foka,fokb,symq,p,Work(iOff),
     &                  ndimv1,ndimv2,ndimv3)
       end if
c
       if ((symp.eq.syms).and.(symq.eq.symr)
     & .and.(p.gt.nob(symp)).and.(p.le.(noa(symp)))) then
       call fokupdate2 (foka,symq,p,Work(iOff),
     &                  ndimv1,ndimv2,ndimv3)
       end if
c
       end if
c
c**   add corresponding <am|pq> interals to TEMPDA2
c     and pack _a_brs to direct acces file TEMPDA1 if need and symm in not C1
       if (p.gt.nob(symp)) then
       a=p-nob(symp)
       call ampack (Work(iOff),wrksize,
     & symp,symq,symr,syms,a,Work(iOff),ndimv1,ndimv2,ndimv3,
     & iWork(ipAMMAP))
       if ((nsym.gt.1).and.(symp.ge.symq)) then
       call abpack (Work(iOff),wrksize,
     & symp,symq,symr,syms,a,Work(iOff),ndimv1,ndimv2,ndimv3,
     & iWork(ipABMAP))
       end if
       end if
c
c**   add INTAB file (for nonsymmetrycal (C1) state)
c
       if ((nsym.eq.1).and.(p.gt.nob(1))) then
       call addintabc1 (Work(iOff),wrksize,
     & p-nob(1),Work(iOff),ndimv1)
       end if
c
 500    continue
c
c        goto 800
c
c
c*    close temp files
c    call closetemp (norb(symp))
c
       if (ickey.ge.1) then
       Call GetMem('CCSORT','Free','Real',iOff_Vic,vsize)
       end if
c
 800    continue
c
c        goto 900
c
c
       if ((nsym.gt.1).and.(symp.ge.symq)) then
c*    add contributions to INTAB comming from symp,sumq and close TEMPDA1 file
c     only for symmetrical cases; only for syma>=symb
       call addintab (Work(iOff),wrksize,
     & symp,symq,iWork(ipABMAP))
       close (lunda1)
       call vf ('TEMPDA1 ',lunda1)
       end if
c
 900    continue
c
c        goto 1000
c
c
c*    add contributions to INTA1-4 if there are some virtuals in symp symmetry
c     and close TEMPDA2 files
c
c     if (nvb(symp).gt.0) then
       call addinta (Work(iOff),wrksize,
     & symp,iWork(ipAMMAP))
       close (lunda2)
       call vf ('TEMPDA2 ',lunda2)
c     end if
c
 1000   continue
c
c*    if T3 are required, reorganize T3nam file
       if (t3key.eq.1) then
       call t3reorg (Work(iOff),wrksize,
     &               noa,nsym)
         do symp=1,4
         end do
       end if
c
c        relese space for ammap,abmap
        Call GetMem('AMMAP','FREE','INTE',ipAMMAP,mbas*64)
        Call GetMem('ABMAP','FREE','INTE',ipABMAP,mbas*mbas*8)
c
c
c*    close files INTA1,INTA2,INTA3 and INTA4, INTAB1
c
       if (iokey.eq.1) then
c      Fortran IO
       close (luna1)
       close (luna2)
       close (luna3)
       close (luna4)
       close (lunab)
c
       else
c      MOLCAS IO
       call daclos (luna1)
       call daclos (luna2)
       call daclos (luna3)
       call daclos (luna4)
       call daclos (lunab)
       end if
c
c        return
c
c
c*    def static integrals (file INTSTA)
c
       call mkintsta (Work(iOff),wrksize,
     & foka,fokb)
c
c*    write general informations to INPDAT
c
       call molcas_binaryopen_vanilla(1,'INPDAT')
c       open (unit=1,file='INPDAT',form='unformatted')
       write (1) NACTEL,ISPIN,NSYM,LSYM,mul,
     &           noa,nob,nva,nvb,norb,eps,Escf
       close (1)
c
c      Release the memory
       Call GetMem('CCSORT','Free','Real',iOff,wrksize)

       return
       end
c
c     ----------------------
c
       subroutine mkmapampq (syma)
c
c     this routine prepair mapd,mapi
c     for <am|pq> for given syma, m, p,q to mapd2,mapi2
c
#include "ccsort.fh"
#include "reorg.fh"
       integer syma
c
c     help variables
c
       integer symm,symp,symq,symmp
       integer nhelp,possition,lenght
c
c*    set mapi1 to zero
c
       do 1 symq=1,nsym
       do 2 symp=1,nsym
       do 3 symm=1,nsym
       mapi2(symm,symp,symq)=0
 3      continue
 2      continue
 1      continue
c
c     def zero-th row
c
       mapd2(0,1)=1
       mapd2(0,2)=5
       mapd2(0,3)=5
       mapd2(0,4)=0
       mapd2(0,6)=0

       nhelp=0
       possition=poss20
       do 100 symm=1,nsym
       do 101 symp=1,nsym
       symmp=mul(symm,symp)
       symq=mul(syma,symmp)
       nhelp=nhelp+1
c
c     calc. lenght
       lenght=noa(symm)*NORB(symp)*NORB(symq)
c
       mapd2(nhelp,1)=possition
       mapd2(nhelp,2)=lenght
       mapd2(nhelp,3)=symm
       mapd2(nhelp,4)=symp
       mapd2(nhelp,5)=symq
       mapd2(nhelp,6)=1
       possition=possition+lenght
c
       mapi2(symm,symp,1)=nhelp
c
 101    continue
 100    continue
c
       mapd2(0,5)=nhelp
c
       return
       end
c
c     ----------------------
c
       subroutine mkmappqij
c
c     this routine prepair mapd,mapi
c     for <pq|ij> for p,q, i>=j to mapd1,mapi1
c
#include "ccsort.fh"
#include "reorg.fh"
c
c     help variables
c
       integer symi,symj,symp,symq,sympq,sympqi
       integer nhelp,possition,lenght
c
c*    set mapi1 to zero
c
       do 1 symi=1,nsym
       do 2 symq=1,nsym
       do 3 symp=1,nsym
       mapi1(symp,symq,symi)=0
 3      continue
 2      continue
 1      continue
c
c     def zero-th row
c
       mapd1(0,1)=5
       mapd1(0,2)=5
       mapd1(0,3)=1
       mapd1(0,4)=1
       mapd1(0,6)=3

       nhelp=0
       possition=poss10
       do 100 symp=1,nsym
       do 101 symq=1,nsym
       sympq=mul(symp,symq)
       do 102 symi=1,nsym
       sympqi=mul(sympq,symi)
       symj=sympqi
       if (symj.gt.symi) goto 102
       nhelp=nhelp+1
c
c     calc. lenght
       lenght=noa(symi)*noa(symj)*NORB(symp)*NORB(symq)
c
       mapd1(nhelp,1)=possition
       mapd1(nhelp,2)=lenght
       mapd1(nhelp,3)=symp
       mapd1(nhelp,4)=symq
       mapd1(nhelp,5)=symi
       mapd1(nhelp,6)=symj
       possition=possition+lenght
c
       mapi1(symp,symq,symi)=nhelp
c
 102    continue
 101    continue
 100    continue
c
       mapd1(0,5)=nhelp
c
       return
       end
c
c     ----------------------
c
       subroutine addpqij (wrk,wrksize,
     & symp,symq,symi,symj,p,vint,ndimv1,ndimv2,
     &                     ndimv3)
c
c     this routine add corresponding part to <pq|ij> record (#1)
c     comming from readed integrals with pivot index p vint_p(q,i,j)
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       integer symi,symj,symp,symq,p,ndimv1,ndimv2,ndimv3
       real*8 vint(1:ndimv1,1:ndimv2,1:ndimv3)
c
c     help variables
c
       integer ii,ij,i,j,poss0,possij0,q,pqij
c
c*    find number of this symmetry combination
c     and initial possition of this symmetry block in (1)
c
       ii=mapi1(symp,symq,symi)
       poss0=mapd1(ii,1)
c
cT0   if symi<symj return
       if (symi.lt.symj) then
       return
       end if
c
cT1   return, if lenght is 0
       if (mapd1(ii,2).eq.0) then
       return
       end if
c
       do 1000 j=1,noa(symj)
       do 1001 i=1,noa(symi)
c
c*    def ij index and initial possition for <p,q,i,j> integral
c
       ij=(j-1)*noa(symi)+i
       possij0=poss0+(norb(symp)*norb(symq))*(ij-1)
c
       do 200 q=1,norb(symq)
       pqij=possij0-1+norb(symp)*(q-1)+p
       wrk(pqij)=vint(q,i,j)
 200    continue
c
 1001   continue
 1000   continue
c
       return
       end
c
c     -----------------------------------------------
c     -----------------------------------------------
c
       subroutine mkintsta (wrk,wrksize,
     & foka,fokb)
c
c     this routine produces integral file INTSTA, which contains
c     following integrals: foka,fokb,
c     <kl||ij>aaaa,<kl||ij>bbbb,<kl||ij>abab
c     <ka||ij>aaaa,<ka||ij>bbbb,<ka||ij>abab,<ka||ij>baab
c     <ab||ij>aaaa,<ab||ij>bbbb,<ab||ij>abab
c
c     N.B. 1. work file #1 is used for <ij|pq> integrals, #2,3,4
c     must be free. possb0 must be defined
c     N.B. 2. this routine can be used only after definition of <ij|pq>
c     N.B. 3. this routine use followuing help routuines:
c     expandfok
c     wrtmediate (from SYMM)
c
c
#include "wrk.fh"
#include "reorg.fh"
#include "files_ccsd.fh"
       real*8 foka(*)
       real*8 fokb(*)
c
c     help variables
c
       integer rc
c
c*    open INTSTA file
       if (iokey.eq.1) then
c      Fortarn IO
       call molcas_binaryopen_vanilla(lunsta,'INTSTA')
c       open (unit=lunsta,file='INTSTA',form='unformatted')
c
       else
c      MOLCAS IO
       call daname (lunsta,'INTSTA')
       daddr(lunsta)=0
       end if
c
c*    expand foka into work #2 and write to INTSTA
       call expandfok (wrk,wrksize,
     & foka)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c*    expand fokb into work #2 and write to INTSTA
       call expandfok (wrk,wrksize,
     & fokb)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c
c*    get #2 <kl||ij>aaaa from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 4,1,1,1,1,1,1)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c*    get #2 <kl||ij>bbbb from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 4,2,2,2,2,1,1)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c*    get #2 <kl| ij>abab from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 0,1,2,1,2,1,0)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c
c*    get #2 <ka||ij>aaaa from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 3,1,3,1,1,1,1)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c*    get #2 <ka||ij>bbbb from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 3,2,4,2,2,1,1)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c*    get #2 <ka| ij>abab from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 0,1,4,1,2,1,0)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c*    get #2 <ka||ij>baab from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 0,2,3,1,2,0,1)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c
c*    get #2 <ab||ij>aaaa from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 4,3,3,1,1,1,1)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c*    get #2 <ab||ij>bbbb from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 4,4,4,2,2,1,1)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c*    get #2 <ab| ij>abab from #1 <p,q|i,j> and write to INTSTA
       call exppqij (wrk,wrksize,
     & 0,3,4,1,2,1,0)
       call dawrtmediate (wrk,wrksize,
     & lunsta,mapd2,mapi2,rc)
c
c*    close INTSTA file
c
       if (iokey.eq.1) then
c      Fortran IO
       close (lunsta)
c
       else
c      MOLCAS IO
       call daclos (lunsta)
       end if
c
       return
       end
c
c     ---------
c
       subroutine expandfok (wrk,wrksize,
     & fok)
c
c     This routine expand fok operator to #2
c     it also defines new mapd2,mapi2
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       real*8 fok(*)
c
c     help variables
c
       integer symp,symq,symr,posstemp,pqwrk,qpwrk,pqfok,p,q
c
c*    set mapi zero
c
       do 1 symr=1,nsym
       do 2 symq=1,nsym
       do 3 symp=1,nsym
       mapi2(symp,symq,symr)=0
 3      continue
 2      continue
 1      continue

c
c*    def zeroth row of mapd
c
       mapd2(0,1)=5
       mapd2(0,2)=5
       mapd2(0,3)=0
       mapd2(0,4)=0
       mapd2(0,5)=nsym
       mapd2(0,6)=0
c
       posstemp=poss20
       pqfok=0
       do 1000 symp=1,nsym
c
c*    def mapd,mapi
c
       mapd2(symp,1)=posstemp
       mapd2(symp,2)=norb(symp)*norb(symp)
       mapd2(symp,3)=symp
       mapd2(symp,4)=symp
       mapd2(symp,5)=1
       mapd2(symp,6)=1
       mapi2(symp,1,1)=symp
c
c*    expand
c
       do 100 p=1,norb(symp)
       do 101 q=1,p
c
c*    calc pq and qp possition in work and fok
c     and write integrals to this possitions
c
       pqwrk=posstemp+(norb(symp)*(p-1)+q)-1
       qpwrk=posstemp+(norb(symp)*(q-1)+p)-1
       pqfok=pqfok+1
       wrk(pqwrk)=fok(pqfok)
       wrk(qpwrk)=fok(pqfok)
c
 101    continue
 100    continue
c
       posstemp=posstemp+mapd2(symp,2)
c
 1000   continue
c
       return
       end
c
c     -----------------------------------------------
c     -----------------------------------------------
c
       subroutine addinta (wrk,wrksize,
     & syma,ammap)
c
c     this routine do for all a in syma
c     1- reconstruct #2 <_a,m,p,q> from TEMPDA2 file
c     2- prepair corresponding <_am p q> (like <amef>aaaa) to #3
c     and wrirte it to opened INTA1-4
c     N.B.  this routine use followuing foreign routuines:
c     wrtmap
c     wri
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       integer syma
       integer ammap(1:mbas,1:8,1:8)
c
c     help variables
c
       integer lenefaaaa,lenefbaab,lenefbbbb,lenefabab
       integer lenejaaaa,lenejbaab,lenejbaba,lenejbbbb,lenejabab,
     & lenejabba
       integer posst,rc,a
c
c*    mapd2 and mapi2 of #2 <_a,m|p,q> are prepaired
c
c*    make required mapd3 and mapi3 and write them to INTA1-4
c     define lenghts of this mediates
c
c*1   to INTA1 <m,_a||ef>aaaa, <m,_a||ef>baab
       call ccsort_grc0(3,2,1,3,3,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenefaaaa)
       call dawrtmap (luna1,mapd3,mapi3,rc)
       call ccsort_grc0(3,0,2,3,4,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenefbaab)
       call dawrtmap (luna1,mapd3,mapi3,rc)
c
c*2   to INTA2 <m,_a||ef>bbbb, <m,_a||ef>abab
       call ccsort_grc0(3,2,2,4,4,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenefbbbb)
       call dawrtmap (luna2,mapd3,mapi3,rc)
       call ccsort_grc0(3,0,1,3,4,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenefabab)
       call dawrtmap (luna2,mapd3,mapi3,rc)
c
c*3   to INTA3 <m,_a||ej>aaaa, <m,_a||ej>baab, <m,_a||ej>baba
       call ccsort_grc0(3,0,1,3,1,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenejaaaa)
       call dawrtmap (luna3,mapd3,mapi3,rc)
       call ccsort_grc0(3,0,2,3,2,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenejbaab)
       call dawrtmap (luna3,mapd3,mapi3,rc)
       call ccsort_grc0(3,0,2,4,1,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenejbaba)
       call dawrtmap (luna3,mapd3,mapi3,rc)
c
c*4   to INTA4 <m,_a||ej>bbbb, <m,_a||ej>abba, <m,_a||ej>abab
       call ccsort_grc0(3,0,2,4,2,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenejbbbb)
       call dawrtmap (luna4,mapd3,mapi3,rc)
       call ccsort_grc0(3,0,1,4,1,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenejabba)
       call dawrtmap (luna4,mapd3,mapi3,rc)
       call ccsort_grc0(3,0,1,3,2,0,syma,poss30,posst,mapd3,mapi3)
       call deflenght (mapd3,lenejabab)
       call dawrtmap (luna4,mapd3,mapi3,rc)
c
c
c*    cycle over a
c
       do 1000 a=1,nvb(syma)
c
c*    reconstruct #2 <_a,m,p,q> for given _a
       call mkampq (wrk,wrksize,
     & a,syma,ammap)
c
c*    get contributions to INTA2 <m,_a||ef>bbbb, <m,_a||ef>abab
c     and wtite it there
c
       if (lenefbbbb.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,2,2,4,4,1,1)
       call dawri (luna2,lenefbbbb,wrk(mapd3(1,1)))
       end if
c
       if (lenefabab.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,0,1,3,4,1,0)
       call dawri (luna2,lenefabab,wrk(mapd3(1,1)))
       end if
c
c*    get contributions to INTA4 <m,_a||ej>bbbb, <m,_a||ej>abba, <m,_a||ej>abab
c     and wtite it there
c
       if (lenejbbbb.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,0,2,4,2,1,1)
       call dawri (luna4,lenejbbbb,wrk(mapd3(1,1)))
       end if
c
       if (lenejabba.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,0,1,4,1,0,1)
       call dawri (luna4,lenejabba,wrk(mapd3(1,1)))
       end if
c
       if (lenejabab.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,0,1,3,2,1,0)
       call dawri (luna4,lenejabab,wrk(mapd3(1,1)))
       end if
c
       if (a.gt.(nvb(syma)-nva(syma))) then
c     contributions to INTA1 and INTA3 only for a-alfa
c
c*    get contributions to INTA1 <m,_a||ef>aaaa, <m,_a||ef>baab if any
c     and wtite it there
c
       if (lenefaaaa.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,2,1,3,3,1,1)
       call dawri (luna1,lenefaaaa,wrk(mapd3(1,1)))
       end if
c
       if (lenefbaab.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,0,2,3,4,0,1)
       call dawri (luna1,lenefbaab,wrk(mapd3(1,1)))
       end if
c
c*    get contributions to INTA3 <m,_a||ej>aaaa, <m,_a||ej>baab, <m,_a||ej>baba
c     and wtite it there
c
       if (lenejaaaa.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,0,1,3,1,1,1)
       call dawri (luna3,lenejaaaa,wrk(mapd3(1,1)))
       end if
c
       if (lenejbaab.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,0,2,3,2,0,1)
       call dawri (luna3,lenejbaab,wrk(mapd3(1,1)))
       end if
c
       if (lenejbaba.gt.0) then
       call expmpq (wrk,wrksize,
     & syma,0,2,4,1,1,0)
       call dawri (luna3,lenejbaba,wrk(mapd3(1,1)))
       end if
c
       end if
c
 1000   continue
c
       return
       end
c
c     -------------------------
c
       subroutine deflenght (mapd,lenght)
c
c     this routine defines lenght of mediate, described by mapd
c
       integer mapd(0:512,1:6)
       integer lenght
c
c     help variable
c
       integer ii
c
       ii=mapd(0,5)
       lenght=mapd(ii,1)+mapd(ii,2)-mapd(1,1)
c
       return
       end
c
c     -------------------------------------------------
c
       subroutine fokupdate1 (foka,fokb,symp,i,vint,ndimv1,ndimv2,
     &                        ndimv3)
c
c     this routine realize update
c     foka(p,q) = foka(p,q) + <ip|iq>
c     fokb(p,q) = fokb(p,q) + <ip|iq>
c
c     N.B. integrals are of type <symi, symp| symi,symp>
c
c     foka    - packed Fokaa matrix (I,O)
c     fokb    - packed Fokbb matrix (I,O)
c     symp    - irrep or p (and also q) index (I)
c     i       - value of i, (I)
c     vint    - array of integrals <ip|iq> for given i (I)
c     ndimv1  - first dimension (norb(symp)) (I)
c     ndimv2  - second dimension (norb(symi)) (I)
c     ndimv3  - third dimension (norb(symp)) (I)
c
#include "ccsort.fh"
       real*8 foka(*)
       real*8 fokb(*)
       real*8 vint(1:ndimv1,1:ndimv2,1:ndimv3)
       integer symp,i,ndimv1,ndimv2,ndimv3
c
c     help variables
c
       integer nhelp1,nhelp2,p,q,pq
c
c*    calculate shift
c
       nhelp1=0
       if (symp.gt.1) then
       do 100 nhelp2=1,symp-1
       nhelp1=nhelp1+(norb(nhelp2)**2+norb(nhelp2))/2
 100    continue
       end if
c
c*    add integral
c
       pq=nhelp1
       do 200 p=1,norb(symp)
       do 201 q=1,p
       pq=pq+1
       foka(pq)=foka(pq)+vint(p,i,q)
       fokb(pq)=fokb(pq)+vint(p,i,q)
 201    continue
 200    continue
c
       return
       end
c
c     -------------------------------------------------
c
       subroutine fokupdate2 (foka,symp,i,vint,ndimv1,ndimv2,ndimv3)
c
c     this routine realize update
c     foka(p,q) = foka(p,q) - <ip|qi>
c
c     N.B. integrals are of type <symi, symp| symp, symi>
c
c     foka    - packed Fokaa matrix (I,O)
c     symp    - irrep or p (and also q) index (I)
c     i       - value of i, (I)
c     vint    - array of integrals <ip|iq> for given i (I)
c     ndimv1  - first dimension (norb(symp)) (I)
c     ndimv2  - second dimension (norb(symi)) (I)
c     ndimv3  - third dimension (norb(symp)) (I)
c
#include "ccsort.fh"
       real*8 foka(*)
       real*8 vint(1:ndimv1,1:ndimv2,1:ndimv3)
       integer symp,i,ndimv1,ndimv2,ndimv3
c
c     help variables
c
       integer nhelp1,nhelp2,p,q,pq
c
c*    calculate shift
c
       nhelp1=0
       if (symp.gt.1) then
       do 100 nhelp2=1,symp-1
       nhelp1=nhelp1+(norb(nhelp2)**2+norb(nhelp2))/2
 100    continue
       end if
c
c*    add integral
c
       pq=nhelp1
       do 200 p=1,norb(symp)
       do 201 q=1,p
       pq=pq+1
       foka(pq)=foka(pq)-vint(p,q,i)
 201    continue
 200    continue
c
       return
       end
c
c     -------------------------------------------------
c
       subroutine unpackk_ic_3 (i,vint,ndimvi,Vic)
c
c     this routine vint(j,k,l) = <i,j|k,l>
c     for given i from incore (reduced) expanded block Vic
c     ie. symp=symq=symr=syms
c
c     i      - value of pivot index (I)
c     vint   - array of integrals (O)
c     ndimvi - (norb(symi)) (I)
c     Vic    - incore expanded block of integrals (I)
c
#include "reorg.fh"

#include "SysDef.fh"
       integer i,ndimvi
       real*8 vint(1:ndimvi,1:ndimvi,1:ndimvi)
       real*8 Vic(1:(ndimvi*(ndimvi+1)/2)*(1+ndimvi*(ndimvi+1)/2)/2)
c
c     help variables
c
      integer j,k,l,ik,jl,ikjl
c
c
        do k=1,ndimvi
c
c        def ik
        if (i.ge.k) then
          ik=i*(i-1)/2+k
        else
          ik=k*(k-1)/2+i
        end if
c
          jl=0
        do j=1,ndimvi
          do l=1,j
c
c         def jl
          jl=jl+1
c
c           def ikjl
            if (ik.ge.jl) then
            ikjl=ik*(ik-1)/2+jl
            else
            ikjl=jl*(jl-1)/2+ik
            end if
c
            vint(j,k,l)=Vic(ikjl)
            vint(l,k,j)=Vic(ikjl)
c
          end do
        end do
        end do
c
       return
       end
c
c     -------------------------------------------------
c
       subroutine unpackk_ic_2 (i,vint,ndimvi,ndimvj,Vic)
c
c     this routine vint(j,k,l) = <i,j|k,l>
c     for given i from incore (reduced) expanded block Vic
c     ie. symp=symr,symq=syms
c
c     i      - value of pivot index (I)
c     vint   - array of integrals (O)
c     ndimvi - (norb(symi)) (I)
c     ndimvj - (norb(symj)) (I)
c     Vic    - incore expanded block of integrals (I)
c
#include "reorg.fh"

#include "SysDef.fh"
       integer i,ndimvi,ndimvj
       real*8 vint(1:ndimvj,1:ndimvi,1:ndimvj)
       real*8 Vic(1:(ndimvi*(ndimvi+1)/2),1:(ndimvj*(ndimvj+1)/2))
c
c     help variables
c
      integer j,k,l,ik,jl
c
c
        do k=1,ndimvi
        if (i.ge.k) then
          ik=i*(i-1)/2+k
        else
          ik=k*(k-1)/2+i
        end if
          jl=0
          do j=1,ndimvj
          do l=1,j
            jl=jl+1
            vint(j,k,l)=Vic(ik,jl)
            vint(l,k,j)=Vic(ik,jl)
          end do
          end do
        end do
c
       return
       end
c
c     -------------------------------------------------
c
       subroutine unpackk_ic_1 (i,vint,ndimv1,ndimv2,ndimv3,
     c                       Vic,ndimvi)
c
c     this routine vint(j,k,l) = <i,j|k,l>
c     for given i from incore (nonreduced) expanded block Vic
c
c     i      - value of pivot index (I)
c     vint   - array of integrals (O)
c     ndimv1 - first dimension of vint (norb(symj)) (I)
c     ndimv2 - second dimension of vint (norb(symk)) (I)
c     ndimv3 - third dimension of vint (norb(syml)) (I)
c     Vic    - incore expanded block of integrals (I)
c     ndimvi - first dimension of Vic norb(symi) (I)
c
#include "reorg.fh"

#include "SysDef.fh"
       integer i,ndimv1,ndimv2,ndimv3,ndimvi
       real*8 vint(1:ndimv1*ndimv2*ndimv3)
       real*8 Vic(1:ndimvi,1:ndimv1*ndimv2*ndimv3)
c
c     help variables
c
      integer jkl
c
c
        do jkl=1,ndimv1*ndimv2*ndimv3
        vint(jkl)=Vic(i,jkl)
        end do
c
       return
       end
c
c     -------------------------------------------------
c
       subroutine unpackk (i,vint,ndimv1,ndimv2,ndimv3,key)
c
c      unpackk process control routine
c
c     i      - value of pivot index (I)
c     vint   - array of integrals (O)
c     ndimv1 - first dimension of vint (norb(symj)) (I)
c     ndimv2 - second dimension of vint (norb(symk)) (I)
c     ndimv3 - third dimension of vint (norb(syml)) (I)
c     key    - reduced storing key (I)
c     = 0 if symj is not syml
c     = 1 if symj = syml
c
#include "reorg.fh"
       integer i,ndimv1,ndimv2,ndimv3,key
       real*8 vint(1:ndimv1,1:ndimv2,1:ndimv3)
c
       if (zrkey.eq.1) then
         call unpackk_zr (i,vint,ndimv1,ndimv2,ndimv3,key)
       else
         call unpackk_pck (i,vint,ndimv1,ndimv2,ndimv3,key)
       end if
c
       return
       end
c
c     -------------------------------------------------
c
       subroutine unpackk_zr (i,vint,ndimv1,ndimv2,ndimv3,key)
c
c     this routine expand integrals packed in i-th TEMP file
c     to vint(j,k,l) = <i,j|k,l>
c
c     i      - value of pivot index (I)
c     vint   - array of integrals (O)
c     ndimv1 - first dimension of vint (norb(symj)) (I)
c     ndimv2 - second dimension of vint (norb(symk)) (I)
c     ndimv3 - third dimension of vint (norb(syml)) (I)
c     key    - reduced storing key (I)
c     = 0 if symj is not syml
c     = 1 if symj = syml
c
#include "reorg.fh"

#include "SysDef.fh"
       integer i,ndimv1,ndimv2,ndimv3,key
       real*8 vint(1:ndimv1,1:ndimv2,1:ndimv3)
c
c     help variables
c
       integer nhelp,lenght,daddr,nrec
c
       integer constj
       parameter (constj=1048576)
       integer constk
       parameter (constk=1024)
c
       integer ihelp,ires
       Integer iBuf(1:nsize)
c
c*    set vint=0
c
       nhelp=ndimv1*ndimv2*ndimv3
       call ccsort_mv0zero (nhelp,nhelp,vint)
c
c*     open corresponding TEMP file
c
       if (iokey.eq.1) then
c      Fortran IO
       call molcas_binaryopen_vanilla(lunpublic,tmpnam(i))
c       open (unit=lunpublic,file=tmpnam(i),form='unformatted')
       else
c      MOLCAS IO
       call daname (lunpublic,tmpnam(i))
       daddr=0
       end if
c
      do nrec=1,nrectemp(i)
c
        if (nrec.ne.nrectemp(i)) then
        lenght=nsize
        else
        lenght=lrectemp(i)
        end if
c
      if (iokey.eq.1) then
c     Fortran IO
      call getpp_zr (lunpublic,valh,iBuf,lenght)
      else
c     MOLCAS IO
      call ddafile (lunpublic,2,valh,lenght,daddr)
      call idafile (lunpublic,2,iBuf,lenght,daddr)
      end if
c
c*     get indexes jh,kh,lh and value valh from packed form
c
      do nhelp=1,lenght
         ihelp=iBuf(nhelp)
         jh(nhelp)=int(ihelp/constj)
         ires=ihelp-constj*jh(nhelp)
         kh(nhelp)=int(ires/constk)
         lh(nhelp)=ires-constk*kh(nhelp)
      end do
c
      if (key.eq.0) then
      do 100 nhelp=1,lenght
      vint(jh(nhelp),kh(nhelp),lh(nhelp))=valh(nhelp)
 100  continue
      else
      do 200 nhelp=1,lenght
      vint(jh(nhelp),kh(nhelp),lh(nhelp))=valh(nhelp)
      vint(lh(nhelp),kh(nhelp),jh(nhelp))=valh(nhelp)
 200  continue
      end if
c
       end do
c
      if (iokey.eq.1) then
c     Fortran IO
       close (lunpublic)
      else
c     Molcas IO
       call daclos (lunpublic)
      end if
c
       return
       end
c
c     -------------------------------------------------
c
       subroutine unpackk_pck (i,vint,ndimv1,ndimv2,ndimv3,key)
c
c     this routine expand integrals packed in i-th TEMP file
c     to vint(j,k,l) = <i,j|k,l>
c
c     i      - value of pivot index (I)
c     vint   - array of integrals (O)
c     ndimv1 - first dimension of vint (norb(symj)) (I)
c     ndimv2 - second dimension of vint (norb(symk)) (I)
c     ndimv3 - third dimension of vint (norb(syml)) (I)
c     key    - reduced storing key (I)
c     = 0 if symj is not syml
c     = 1 if symj = syml
c
#include "reorg.fh"

#include "SysDef.fh"
       integer i,ndimv1,ndimv2,ndimv3,key
       real*8 vint(1:ndimv1,1:ndimv2,1:ndimv3)
c
c     help variables
c
       integer nhelp,lenght,daddr,nrec
c
       integer constj
       parameter (constj=1048576)
       integer constk
       parameter (constk=1024)
c
       character*(RtoB+ItoB) pp(1:nsize),pphelp
       character*1 p1help(1:(RtoB+ItoB))
       real*8 rhelp
       integer ihelp,ires
       equivalence (p1help(1),pphelp)
       equivalence (p1help(1),rhelp)
       equivalence (p1help(1+RtoB),ihelp)
c
c*    set vint=0
c
       nhelp=ndimv1*ndimv2*ndimv3
       call ccsort_mv0zero (nhelp,nhelp,vint)
c
c*     open corresponding TEMP file
c
       if (iokey.eq.1) then
c      Fortran IO
       call molcas_binaryopen_vanilla(lunpublic,tmpnam(i))
c       open (unit=lunpublic,file=tmpnam(i),form='unformatted')
       else
c      MOLCAS IO
       call daname (lunpublic,tmpnam(i))
       daddr=0
       end if
c
      do nrec=1,nrectemp(i)
c
        if (nrec.ne.nrectemp(i)) then
        lenght=nsize
        else
        lenght=lrectemp(i)
        end if
c
      if (iokey.eq.1) then
c     Fortran IO
      call getpp_pck (lunpublic,pp,lenght)
      else
c     MOLCAS IO
      call cdafile (lunpublic,2,pp,(RtoB+ItoB)*lenght,daddr)
      end if

c
c*     get indexes jh,kh,lh and value valh from packed form
c
      do nhelp=1,lenght
      pphelp=pp(nhelp)
      valh(nhelp)=rhelp
      jh(nhelp)=int(ihelp/constj)
      ires=ihelp-constj*jh(nhelp)
      kh(nhelp)=int(ires/constk)
      lh(nhelp)=ires-constk*kh(nhelp)
      end do
c
      if (key.eq.0) then
      do 100 nhelp=1,lenght
      vint(jh(nhelp),kh(nhelp),lh(nhelp))=valh(nhelp)
 100  continue
      else
      do 200 nhelp=1,lenght
      vint(jh(nhelp),kh(nhelp),lh(nhelp))=valh(nhelp)
      vint(lh(nhelp),kh(nhelp),jh(nhelp))=valh(nhelp)
 200  continue
      end if
c
       end do
c
      if (iokey.eq.1) then
c     Fortran IO
       close (lunpublic)
      else
c     Molcas IO
       call daclos (lunpublic)
      end if
c
       return
       end
c
c     ----------------------
c
       subroutine getpp_zr (lunpublic,pp,ipp,lenght)
c
#include "SysDef.fh"
       integer lunpublic,lenght
       Real*8 pp(1:lenght)
       Integer ipp(1:lenght)
c
       read (lunpublic) pp,ipp
c
       return
       end
c
c     ----------------------
c
       subroutine getpp_pck (lunpublic,pp,lenght)
c

#include "SysDef.fh"
       integer lunpublic,lenght
       character*(RtoB+ItoB) pp(1:lenght)
c
       read (lunpublic) pp
c
       return
       end
c
c     -------------------------------------------------
c
       subroutine initintabc1
c     this routine write corresponding mapd and mapi to INTAB
c     for nonsymetrical (C1) case
c
#include "reorg.fh"
#include "ccsort.fh"
c
c     help variables
c
       integer nhelp,lenght,symp,symq,symab
       integer poss,ii,syma,symb,rc
c
c*    def symab
       syma=1
       symb=1
       symab=mul(syma,symb)
c
c*    make mapd3,mapi3 for <_a_b|pq>
c
c**   set mapi3=0 (partly)
c
       do 100 nhelp=1,nsym
       do 101 symq=1,nsym
       do 102 symp=1,nsym
       mapi3(symp,symq,nhelp)=0
 102    continue
 101    continue
 100    continue
c
c**   def 0-th row
c
       mapd3(0,1)=5
       mapd3(0,2)=5
       mapd3(0,3)=0
       mapd3(0,4)=0
       mapd3(0,5)=nsym
       mapd3(0,6)=0
c
c**   def other rows
c
       poss=poss30
       do 200 ii=1,nsym
c
       symp=ii
       symq=mul(symab,symp)
       lenght=norb(symp)*norb(symq)
       mapd3(ii,1)=poss
       mapd3(ii,2)=lenght
       mapd3(ii,3)=symp
       mapd3(ii,4)=symq
       mapd3(ii,5)=1
       mapd3(ii,6)=1
       mapi3(symp,1,1)=ii
       poss=poss+lenght
c
 200    continue
c
c*    write mapd,mapi to INTAB
       call dawrtmap (lunab,mapd3,mapi3,rc)
c
c
       return
       end
c
c     ------------------------------------
c
       subroutine addintabc1 (wrk,wrksize,
     & a,vint,ndimv)
c
c     this routine add integrals <_a,_b|p,q> for given a
c     for nonsymmetrical (C1) case
c     from integrals vv _a(u,p,q)
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       integer a,ndimv
       real*8 vint(1:ndimv,1:ndimv,1:ndimv)
c
c     help variables
c
       integer poss,b,bvint,p,q,lenght
c
c
cT    if there are no _a_b,pq integrals in this symab,
c     skip sumation over ab
c
       if (nvb(1).eq.0) then
       return
       end if
c
c*    loop over b
c
       do 1000 b=1,a
       bvint=b+nob(1)
c
c     map <_a,b|p,q> to wrk in #3
       poss=poss30
       do 1010 q=1,norb(1)
       do 1011 p=1,norb(1)
       wrk(poss)=vint(bvint,p,q)
       poss=poss+1
 1011   continue
 1010   continue
c
c
c**   since there must be some integrals, write them to TEMPAB
c
       lenght=poss-poss30
       call dawri (lunab,lenght,wrk(poss30))
c
 1000   continue
c
       return
       end
c
c     -------------------------
c
       subroutine initwrk (lenght)
c
c      this routine calculate required size of work space and
c      definie initial possitions of work vectors
c
#include "ccsort.fh"
#include "reorg.fh"
c
c     help variables
c
       integer n
       integer sizevint,sizev1,sizev2,sizempq,lenght,norbmax,sizeri
       integer symp,symq,symi,symj,sympq,sympqi,symm,symmp,syma
c
c1*   def maxzie of vint
c
       norbmax=norb(1)
       do 10 n=1,nsym
       if (norb(n).gt.norbmax) then
       norbmax=norb(n)
       end if
 10     continue
c
       sizevint=norbmax*norbmax*norbmax
c
c2*   def size of <pq|i>=j>, <pq|i,j>
c
       sizev1=0
       sizev2=0
       do 20 symp=1,nsym
       do 21 symq=1,nsym
       sympq=mul(symp,symq)
       do 22 symi=1,nsym
       sympqi=mul(sympq,symi)
       symj=sympqi
c      calc. lenght
       if (symj.gt.symi) then
         sizev2=sizev2+noa(symi)*noa(symj)*NORB(symp)*NORB(symq)
       else
         sizev1=sizev1+noa(symi)*noa(symj)*NORB(symp)*NORB(symq)
         sizev2=sizev2+noa(symi)*noa(symj)*NORB(symp)*NORB(symq)
       end if
22     continue
21     continue
20     continue
c
c3*   def maxsize of <_am|pq>
c

       sizempq=0
       do 50 syma=1,nsym
c
       lenght=0
       do 30 symm=1,nsym
       do 31 symp=1,nsym
       symmp=mul(symm,symp)
       symq=mul(syma,symmp)
c     calc. lenght
       lenght=lenght+noa(symm)*NORB(symp)*NORB(symq)
 31     continue
 30     continue
c
       if (sizempq.lt.lenght) then
       sizempq=lenght
       end if
c
 50     continue
c
c4*   def maxsize of R_i if needed
c
       sizeri=0
c
       if (t3key.eq.1) then
       do 60 symi=1,nsym
       call ccsort_t3grc0 (3,8,4,4,4,0,symi,1,lenght,mapdri,mapiri)
       lenght=lenght-1
       if (lenght.gt.sizeri) then
       sizeri=lenght
       end if
 60     continue
       end if

c     ******* distribution of memory ******
c
       poss10=1+sizevint
       poss20=poss10+sizev1
       poss30=poss20+sizev2
       possri0=poss30+sizempq
       lenght=possri0+sizeri-1
c
       if (fullprint.gt.1) then
       write(6,*)
       write(6,'(6X,A)') 'size of help (work) vectors:'
       write(6,'(6X,A)') '----------------------------'
       write(6,*)
       write(6,'(6X,A,I8)') 'Vints     V0 required : ',sizevint
       write(6,'(6X,A,I8)') 'PQIJ ints V1 required : ',sizev1
       write(6,'(6X,A,I8)') '          V2 required : ',sizev2
       write(6,'(6X,A,I8)') 'AMIJ ints V3 required : ',sizempq
       write(6,'(6X,A,I8)') 'R_i mtx   Ri required : ',sizeri
       end if
c
       if (fullprint.ge.0)
     &     write(6,'(6X,A,I20)') 'Required WRK size-sum : ',lenght
c
       return
       end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine ss_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      w0ss1=0.d0
      w1ss1=0.d0
      w0ss2=0.d0
      w1ss2=0.d0
      w0ss3=0.d0
      w1ss3=0.d0
      w0ss4=0.d0
      w1ss4=0.d0
      w0ss5=0.d0
      w1ss5=0.d0
      w0ss6=0.d0
      w1ss6=0.d0
      w0ss7=0.d0
      w1ss7=0.d0
      w0ss8=0.d0
      w1ss8=0.d0
      w0ss9=0.d0
      w1ss9=0.d0
      w0ss10=0.d0
      w1ss10=0.d0
      w0ss11=0.d0
      w1ss11=0.d0
      w0ss12=0.d0
      w1ss12=0.d0
      w0ss13=0.d0
      w1ss13=0.d0
      w0ss14=0.d0
      w1ss14=0.d0
      w0ss15=0.d0
      w1ss15=0.d0
      w0ss16=0.d0
      w1ss16=0.d0
      w0ss18=0.d0
      w1ss18=0.d0

!ss(1-1)  ar(01)-bl(32)-
!ss(1-2)  ar(02)-bl(31)-
!ss(1-3)  ar(13)-bl(20)-
!ss(1-4)  ar(23)-bl(10)-
!ss(1-5)  (22)-ar(13)-bl(31)-
!ss(1-6)  (11)-ar(23)-bl(32)-
!ss(1-7)  ar(13)-c'(21)-bl(32)-
!ss(1-8)  ar(13)-c'(22)-bl(31)-
!ss(1-9)  ar(23)-c'(11)-bl(32)-
!ss(1-10) ar(23)-c'(12)-bl(31)-
!ss(1-11) ar(13)-bl(31)-c"(22)-
!ss(1-12) ar(13)-bl(32)-c"(21)-
!ss(1-13) ar(23)-bl(31)-c"(12)-
!ss(1-14) ar(23)-bl(32)-c"(11)-
!ss(1-15) (22)-drl(11)-
!ss(1-16) (11)-drl(22)-
!ss(1-17) drl(22)-c"(11)-
!ss(1-18) drl(11)-c"(22)-
!ss(1-19) drl(12)-c"(21)-
!ss(1-20) drl(33)-c"(00)-
!ss(1-20) drl(33)-c"(11)-c"(22)-
!ss(1-20) (11)drl(33)-c"(22)-
!ss(1-20) (11)(22)drl(33)-
!ss(1-20) drl(33)-c"(22)-c"(11)-
!ss(1-20) (22)drl(33)-c"(11)-
!ss(1-20) (22)(11)drl(33)-
!ss(1-20) (21)(12)drl(33)-
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          jmlr=mul_tab(jml,jmr)
          if(lmij.ne.jmlr) cycle
          w0ss2=w0_ss(2)
          w1ss2=w1_ss(2)
          w0ss4=w0_ss(4)
          w1ss4=w1_ss(4)
          w0ss5=w0_ss(5)
          w1ss5=w1_ss(5)
          w0ss10=-w0_ss(10)
          w1ss10=-w1_ss(10)
          w0ss14=w0_ss(14)
          w1ss14=w1_ss(14)
          if(jb_sys.gt.0) then
            w0ss1=w0_ss(1)
            w1ss1=w1_ss(1)
            w0ss3=w0_ss(3)
            w1ss3=w1_ss(3)
            w0ss6=w0_ss(6)
            w1ss6=w1_ss(6)
            w0ss7=w0_ss(7)
            w1ss7=w1_ss(7)
            w0ss8=w0_ss(8)
            w1ss8=w1_ss(8)
            w0ss9=w0_ss(9)
            w1ss9=w1_ss(9)
            w0ss11=w0_ss(11)
            w1ss11=w1_ss(11)
            w0ss12=w0_ss(12)
            w1ss12=w1_ss(12)
            w0ss13=w0_ss(13)
            w1ss13=w1_ss(13)
          endif
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0ss2=-w0ss2
            w1ss2=-w1ss2
            w0ss4=-w0ss4
            w1ss4=-w1ss4
            w0ss5=-w0ss5
            w1ss5=-w1ss5
            w0ss10=-w0ss10
            w1ss10=-w1ss10
            w0ss14=-w0ss14
            w1ss14=-w1ss14
            if(jb_sys.gt.0) then
              w0ss1=-w0ss1
              w1ss1=-w1ss1
            w0ss3=-w0ss3
            w1ss3=-w1ss3
              w0ss6=-w0ss6
              w1ss6=-w1ss6
             w0ss7=-w0ss7
             w1ss7=-w1ss7
             w0ss8=-w0ss8
             w1ss8=-w1ss8
              w0ss9=-w0ss9
              w1ss9=-w1ss9
             w0ss11=-w0ss11
             w1ss11=-w1ss11
             w0ss12=-w0ss12
             w1ss12=-w1ss12
             w0ss13=-w0ss13
             w1ss13=-w1ss13
            endif
          endif

          if(jml.eq.1.and.lmij.eq.jmr) then
            iwdl=just(lri,lri)
!ss(1-1)   ar(01)-bl(32)-
            if(jb_sys.gt.0) then
              iwdr=just(lrj,lri)
              vlop0=w0*w0ss1
              vlop1=w1*w1ss1
      if(line.eq.26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
      if(line.eq.28) then     !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
      if(line.eq.29) then     !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            endif
!ss(1-2)  ar(02)-bl(31)-
            iwdr=just(lri,lrj)
            vlop0=w0*w0ss2
            vlop1=w1*w1ss2
      if(line.eq.26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
      if(line.eq.28) then     !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
      if(line.eq.29) then     !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
         endif

          if(jmr.eq.1.and.lmij.eq.jml) then
            iwdr=just(lrj,lrj)
!ss(1-3)  ar(13)-bl(20)-
            if(jb_sys.gt.0) then
              iwdl=just(lrj,lri)
              vlop0=w0*w0ss3
              vlop1=w1*w1ss3
      if(line.eq.26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
      if(line.eq.28) then     !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
      if(line.eq.29) then     !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            endif
!ss(1-4)  ar(23)-bl(10)-        act -c"-                         ! iprad
            iwdl=just(lri,lrj)
            vlop0=w0*w0ss4
            vlop1=w1*w1ss4
      if(line.eq.26) then    !lri,lrj,lra
        call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
      if(line.eq.28) then     !lri,lrj,lrs,lra
        call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
      if(line.eq.29) then     !lri,lrj,lrs,lra
        call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
      endif
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
         endif

          vlop0=w0*w0ss5
          vlop1=w1*w1ss5
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
        if(jb_sys.gt.0) then
          vlop0=w0*w0ss6
          vlop1=w1*w1ss6
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
        endif
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
!ss(1-5)  (22)-ar(13)-bl(31)-
              iwdl=just(lrk,lri)
              iwdr=just(lrk,lrj)
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
              if(jb_sys.gt.0) then
!ss(1-6)  (11)-ar(23)-bl(32)-
                iwdl=just(lri,lrk)
                iwdr=just(lrj,lrk)
                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper)
              endif
            endif
          enddo

       if(jb_sys.gt.0) then
          vlop0=w0*w0ss7
          vlop1=w1*w1ss7
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          vlop0=w0*w0ss8
          vlop1=w1*w1ss8
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
          endif
          vlop0=w0*w0ss9
          vlop1=w1*w1ss9
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
          endif
        endif
          vlop0=w0*w0ss10
          vlop1=w1*w1ss10
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
          endif

          do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              if(jb_sys.gt.0) then
!ss(1-7)  ar(13)-c'(21)-bl(32)-
                iwdl=just(lrk,lri)
                iwdr=just(lrj,lrk)
                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl1,jper)
!ss(1-8)  ar(13)-c'(22)-bl(31)-
                iwdl=just(lrk,lri)
                iwdr=just(lrk,lrj)
                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl2,jper)
!ss(1-9)  ar(23)-c'(11)-bl(32)-
                iwdl=just(lri,lrk)
                iwdr=just(lrj,lrk)
!               wl=(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl3,jper)
              endif
!ss(1-10) ar(23)-c'(12)-bl(31)-
              iwdl=just(lri,lrk)
              iwdr=just(lrk,lrj)
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl4,jper)
            endif
          enddo

        if(jb_sys.gt.0) then
          vlop0=w0*w0ss11
          vlop1=w1*w1ss11
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          vlop0=w0*w0ss12
          vlop1=w1*w1ss12
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl2)
          endif
          vlop0=w0*w0ss13
          vlop1=w1*w1ss13
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl3)
          endif
        endif
          vlop0=w0*w0ss14
          vlop1=w1*w1ss14
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl4)
          endif

          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              if(jb_sys.gt.0) then
!ss(1-11) ar(13)-bl(31)-c"(22)-
                iwdl=just(lrk,lri)
                iwdr=just(lrk,lrj)
                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl1,jper)
!ss(1-12) ar(13)-bl(32)-c"(21)-
                iwdl=just(lrk,lri)
                iwdr=just(lrj,lrk)
                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl2,jper)
!ss(1-13) ar(23)-bl(31)-c"(12)-
                iwdl=just(lri,lrk)
                iwdr=just(lrk,lrj)
                call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl3,jper)
              endif
!ss(1-14) ar(23)-bl(32)-c"(11)- act -c"-
              iwdl=just(lri,lrk)
              iwdr=just(lrj,lrk)
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl4,jper)
            endif
          enddo
        enddo
      enddo

      if(jpad.ne.jpadl) return

!      if(jb_sys.gt.0.or.jwl.ge.jwr) then
      if(jb_sys.gt.0) then
      if(jpad.gt.17.and.jpad.lt.25) then
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml.or.jml.ne.jmr) cycle
            iwdl=just(lrj,lri)
            iwdr=just(lri,lrj)
!ss(1-19) drl(12)-c"(21)-
            vlop0=w0*w0_ss(19)
            vlop1=w1*w1_ss(19)
            if(line.eq.26) then    !lri,lra
              call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.28) then    !lri,lrs,lra
              call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.29) then    !lri,lrs,lra
              call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
            endif
!         wl=(vlop0-vlop1)*voint(lri,lrb)
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo
      endif
      endif
      if(jwl.ge.jwr) return

      w0ss15=w0_ss(15)
      w1ss15=w1_ss(15)
      w0ss17=w0_ss(17)
      w1ss17=w1_ss(17)
      w0ss20=w0_ss(20)
      if(jb_sys.gt.0) then
        w0ss16=w0_ss(16)
        w1ss16=w1_ss(16)
        w0ss18=w0_ss(18)
        w1ss18=w1_ss(18)
      endif

      if(jml.eq.1.and.jmr.eq.1) then
!ss(1-20) drl(33)-c"(00)-                            ! ipl(r)ad=1 or =ns
        do lr0=norb_frz+1,norb_dz
          iwdl=just(lr0,lr0)
          iwdr=iwdl
          vlop0=w0*w0_ss(20)
          vlop1=0.d0
          wl=0.d0
          do lrk=1,norb_dz
            if(lrk.eq.lr0) cycle
            if(line.eq.26) then    !lrk,lra
              call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.28) then    !lrk,lrs,lra    lrs,lra,lrk
c             call comp_loop(12,lrk,lrs,lra,lra,vlop0,vlop1,wl1)
              call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.29) then    !lrk,lrs,lra
              call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wl1)
c              call comp_loop(11,lrk,lrs,lra,lra,vlop0,vlop1,wl1)
            endif
            wl=wl+wl1
          enddo
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      endif
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml.or.jml.ne.jmr) cycle
          if(jwl.ge.jwr.and.jb_sys.eq.0) cycle
          wl=0.d0
          iwdl=just(lri,lrj)
          iwdr=iwdl
!ss(1-15) (22)-drl(11)-
          vlop0=w0*w0ss15
          vlop1=w1*w1ss15
          wl=0.d0
          if(line.eq.26) then    !lrj,lra
            call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.28) then    !lrj,lrs,lra
            call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.29) then    !lrj,lrs,lra
            call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl1)
          endif
          wl=wl+wl1
!         wl=wl+(vlop0-vlop1)*voint(lrj,lrb)
!ss(1-17) drl(22)-c"(11)-
          vlop0=w0*w0ss17
         vlop1=w1*w1ss17
          if(line.eq.26) then    !lri,lra
            call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.28) then    !lri,lrs,lra
            call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.29) then    !lri,lrs,lra
            call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl1)
          endif
          wl=wl+wl1
!         wl=wl+(vlop0-vlop1)*voint(lri,lrb)
!ss(1-20) (22)(11)drl(33)-
!ss(1-20) (22)drl(33)-c"(11)-
!ss(1-20) drl(33)-c"(22)-c"(11)-
          vlop0=w0*w0ss20
          vlop1=0.d0
         do lrk=1,norb_dz
            if(lrk.eq.lri) cycle
            if(lrk.eq.lrj) cycle
            if(line.eq.26) then    !lrk,lra
              call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.28) then    !lrk,lrs,lra
              call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.29) then    !lrk,lrs,lra
              call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wl1)
            endif
            wl=wl+wl1
!           wl=wl+vlop0*voint(lrk,lrb)
          enddo
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          if(jb_sys.gt.0) then
            iwdl=just(lrj,lri)
            iwdr=iwdl
!ss(1-16) (11)-drl(22)-
            vlop0=w0*w0ss16
           vlop1=w1*w1ss16
           wl=0.d0
            if(line.eq.26) then    !lrj,lra
              call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.28) then    !lrj,lrs,lra
              call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.29) then    !lrj,lrs,lra
              call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl1)
            endif
            wl=wl+wl1
!            wl=(vlop0-vlop1)*voint(lrj,lrb)
!ss(1-18) drl(11)-c"(22)-
            vlop0=w0*w0ss18
            vlop1=w1*w1ss18
            if(line.eq.26) then    !lri,lra
              call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.28) then    !lri,lrs,lra
              call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.29) then    !lri,lrs,lra
              call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl1)
            endif
            wl=wl+wl1
!            wl=wl+(vlop0-vlop1)*voint(lri,lrb)
!ss(1-20) drl(33)-c"(11)-c"(22)-
!ss(1-20) (11)drl(33)-c"(22)-
!ss(1-20) (11)(22)drl(33)-
            vlop0=w0*w0ss20
            vlop1=0.d0
            do lrk=1,norb_dz
              if(lrk.eq.lri) cycle
              if(lrk.eq.lrj) cycle
              if(line.eq.26) then    !lrk,lra
                call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wl1)
              endif
              if(line.eq.28) then    !lrk,lrs,lra
                call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wl1)
              endif
              if(line.eq.29) then    !lrk,lrs,lra
                call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wl1)
              endif
              wl=wl+wl1
!              wl=wl+vlop0*voint(lrk,lrb)
            enddo
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
           endif
        enddo
      enddo
      return

      end

      subroutine st_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!st(2-1) ar(02)-bl(32)-
!st(2-2) (22)ar(13)-bl(32)-
!st(2-4) ar(23)-c'(12)-bl(32)-
!st(2-4) ar(23)-bl(32)-c'(12)-
!st(2-5) (22)drl(12)-
!st(2-6) drl(22)-c"(12)-
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          lmij=mul_tab(lmij,1)
          if(jml.eq.jmr.and.lmij.eq.jml) then
            iwds=just(lri,lrj)
            iwdt=iwds              !
!st(2-5) (22)drl(12)-
            vlop1=w1*w1_st(5)             !d2-5
            vlop0=0.d0
            if(line.eq.26) then    !lrj,lra
              call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.28) then    !lrj,lrs,lra
              call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.29) then    !lrj,lrs,lra
              call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl)
            endif
!st(2-6) drl(22)-c"(12)-
            vlop1=w1*w1_st(6)             !d2-6
            vlop0=0.d0
            if(line.eq.26) then    !lri,lra
              call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.28) then    !lri,lrs,lra
              call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl1)
            endif
            if(line.eq.29) then    !lri,lrs,lra
              call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl1)
            endif
            wl=wl+wl1
!            list=list3(lra,lrb,lri)
!            wl=wl-vlop1*vint_ci(list)    !4.3 vlop0=0        !!!!!
            call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
!st(2-7) drl(12)-c"(22)-
            if(jb_sys.gt.0) then
              iwds=just(lrj,lri)
              iwdt=just(lri,lrj)
            vlop1=w1*w1_st(7)
            vlop0=0.d0             !d2-6
!              list=list3(lra,lrb,lri)
!              wl=wl-vlop1*vint_ci(list)    !4.3 vlop0=0        !!!!!
              if(line.eq.26) then    !lri,lra
                call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
              endif
              if(line.eq.28) then    !lri,lrs,lra
                call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
              endif
              if(line.eq.29) then    !lri,lrs,lra
                call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
              endif
              call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
            endif
          endif

          jmlr=mul_tab(jml,jmr)
         if(lmij.ne.jmlr) cycle
          w1st1=w1_st(1)
          w1st2=w1_st(2)
          w1st3=w1_st(3)
          w1st4=w1_st(4)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w1st1=-w1st1
            w1st2=-w1st2
            w1st3=-w1st3
            w1st4=-w1st4
          endif
          if(jml.eq.1)then
!st(2-1) ar(02)-bl(32)-
            iwds=just(lri,lri)
            iwdt=just(lri,lrj)      !
            vlop1=w1*w1st1
           vlop0=0.d0
!          list=list4(lri,lrj,lra,lrb)
            if(line.eq.26) then    !lri,lrj,lra
              call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.28) then     !lri,lrj,lrs,lra
               call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.29) then     !lri,lrj,lrs,lra
              call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
!          wl=-vlop1*vint_ci(list)    !1.1 vlop0=0        !!!!!
            call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
          endif

!st(2-2) (22)ar(13)-bl(32)-
          vlop1=w1*w1st2
 !       wl=-vlop1*vint_ci(list)    !1.1
          vlop0=0.d0
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
         do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            if(mul_tab(lmk,lmi).ne.jml) cycle
            if(mul_tab(lmk,lmj).ne.jmr) cycle
            iwds=just(lrk,lri)
            iwdt=just(lrk,lrj)      !
            call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
          enddo
!st(2-3) ar(13)-bl(32)-c'(22)-
!st(2-4) ar(23)-bl(32)-c'(12)-
          vlop1=w1*w1st4
         vlop0=0.d0
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
!        wl=-vlop1*vint_ci(list)    !1.1 vlop0=0
        if(jb_sys.gt.0) then
          vlop1=w1*w1st3
          vlop0=0.d0
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl1)
          endif
        endif
!         wl1=-vlop1*vint_ci(list)
         do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            if(mul_tab(lmk,lmi).ne.jml) cycle
            if(mul_tab(lmk,lmj).ne.jmr) cycle
            iwds=just(lri,lrk)
            iwdt=just(lrj,lrk)     !
            call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl,jper)
            if(jb_sys.gt.0) then
              iwds=just(lrk,lri)
              call prodab(3,jpel,iwds,iwdt,jwl,jwr,wl1,jper)
            endif
          enddo
!st(2-4) ar(23)-c'(12)-bl(32)-
         do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            if(mul_tab(lmk,lmi).ne.jml) cycle
            if(mul_tab(lmk,lmj).ne.jmr) cycle
            iwds=just(lri,lrk)
            iwdt=just(lrk,lrj)    !
            call prodab(3,jpel,iwds,iwdt,jwl,jwr,-wl,jper)
!st(2-3) ar(13)-c'(22)-bl(32)-
            if(jb_sys.gt.0) then
              iwds=just(lrk,lri)
              call prodab(3,jpel,iwds,iwdt,jwl,jwr,-wl1,jper)
           endif
          enddo
        enddo
      enddo
      return

      end

      subroutine ts_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!ts(3-1) ar(23)-bl(20)-
!ts(3-2) (22)ar(23)-bl(31)-
!ts(3-2) ar(23)-c'(22)-bl(31)-
!ts(3-3) ar(23)-bl(31)-c"(22)-
!ts(3-4) ar(23)-bl(32)-c"(21)-
      lmas=mul_tab(lsm_inn(lra),lsm_inn(lrs))
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmas.ne.lmij) cycle
          w1ts1=w1_ts(1)
          w1ts2=w1_ts(2)
          w1ts3=w1_ts(3)
          w1ts4=w1_ts(4)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w1ts1=-w1ts1
            w1ts2=-w1ts2
            w1ts3=-w1ts3
            w1ts4=-w1ts4
          endif
!        list=list3(lri,lrj,lrb)
!-------------------------------------------------------------------
!ts(3-1) ar(23)-bl(20)-
          if(jmr.eq.1.and.lmij.eq.jml) then
            iwdt=just(lri,lrj)    !
            iwds=just(lrj,lrj)
            vlop1=w1*w1ts1             !d3-1
            vlop0=0.d0
            if(line.eq.26) then    !lri,lrj,lra
              call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.28) then     !lri,lrj,lrs,lra
              call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.29) then     !lri,lrj,lrs,lra
              call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
!           wl=-vlop1*(vint_ci(list))    !2.2 vlop0=0
            call prodab(3,jpel,iwdt,iwds,jwl,jwr,wl,jper)
          endif
!-------------------------------------------------------------------
          vlop1=w1*w1ts2             !d3-2
          vlop0=0.d0
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
!          wl=-vlop1*(vint_ci(list))    !2.2 vlop0=0
!ts(3-2) (22)ar(23)-bl(31)-
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            if(mul_tab(lmk,lmi).ne.jml.or.mul_tab(lmk,lmj).ne.jmr) cycle
            iwdt=just(lrk,lri)   !
            iwds=just(lrk,lrj)
            call prodab(3,jpel,iwdt,iwds,jwl,jwr,wl,jper)
          enddo
!ts(3-2) ar(23)-c'(22)-bl(31)-
         do lrk=lri+1,lrj-1
            lmk=lsm_inn(lrk)
            if(mul_tab(lmk,lmi).ne.jml.or.mul_tab(lmk,lmj).ne.jmr) cycle
            iwdt=just(lri,lrk)   !
            iwds=just(lrk,lrj)
            call prodab(3,jpel,iwdt,iwds,jwl,jwr,-wl,jper)
          enddo
!-------------------------------------------------------------------
!ts(3-4) ar(23)-bl(32)-c"(21)-
          vlop1=w1*w1ts4             !d3-4
          vlop0=0.d0
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            if(mul_tab(lmk,lmi).ne.jml.or.mul_tab(lmk,lmj).ne.jmr) cycle
            iwdt=just(lri,lrk)   !
            iwds=just(lrj,lrk)
            call prodab(3,jpel,iwdt,iwds,jwl,jwr,wl,jper)
          enddo
!-------------------------------------------------------------------
!ts(3-3) ar(23)-bl(31)-c"(22)-
          if(jb_sys.gt.0) then
            vlop1=w1*w1ts3             !d3-4
            vlop0=0.d0
            if(line.eq.26) then    !lri,lrj,lra
              call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.28) then     !lri,lrj,lrs,lra
              call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.29) then     !lri,lrj,lrs,lra
              call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
!            wl=-vlop1*vint_ci(list)    !2.2 vlop0=0
            do lrk=lrj+1,norb_dz
              lmk=lsm_inn(lrk)
       if(mul_tab(lmk,lmi).ne.jml.or.mul_tab(lmk,lmj).ne.jmr) cycle
              iwdt=just(lri,lrk)   !
              iwds=just(lrk,lrj)
              call prodab(3,jpel,iwdt,iwds,jwl,jwr,wl,jper)
            enddo
          endif
        enddo
      enddo
      return

      end

      subroutine stt_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!st1(4-1) ar(01)-bl(31)-
!st1(4-2) (11)ar(23)-bl(31)-
!st1(4-3) ar(13)-c'(21)-bl(31)-
!st1(4-3) ar(13)-bl(31)-c"(21)-
!st1(4-4) ar(23)-c'(11)-bl(31)-
!st1(4-4) ar(23)-bl(31)-c"(11)-
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          w1st1=w1_st1(1)
          w1st2=w1_st1(2)
          w1st3=w1_st1(3)
          w1st4=w1_st1(4)
          ni=mod(lrj-lri,2)
         if(ni.eq.0) then
            w1st1=-w1st1
            w1st2=-w1st2
            w1st3=-w1st3
            w1st4=-w1st4
          endif
!          list=list3(lri,lrj,lrb)
         if(jml.eq.1.and.lmij.eq.jmr) then
!st1(4-1) ar(01)-bl(31)-
             iwdl=just(lri,lri)
             iwdr=just(lri,lrj)
            vlop1=w1*w1st1
             vlop0=0.d0
             if(line.eq.26) then    !lri,lrj,lra
               call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
             endif
             if(line.eq.28) then     !lri,lrj,lrs,lra
               call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
             endif
             if(line.eq.29) then     !lri,lrj,lrs,lra
               call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
             endif
!             wl=-vlop1*(vint_ci(list))    !2.2 vlop0=0
             call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
           endif
!st1(4-2) (11)ar(23)-bl(31)-
           vlop1=w1*w1st2
           vlop0=0.d0
           if(line.eq.26) then    !lri,lrj,lra
             call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
           endif
           if(line.eq.28) then     !lri,lrj,lrs,lra
             call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
           endif
           if(line.eq.29) then     !lri,lrj,lrs,lra
             call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
           endif
           do lrk=norb_frz+1,lri-1
             lmk=lsm_inn(lrk)
             if(mul_tab(lmk,lmi).ne.jml.or.
     :            mul_tab(lmk,lmj).ne.jmr) cycle
!            wl=-vlop1*vint_ci(list)
             iwdl=just(lri,lrk)
             iwdr=just(lrk,lrj)
             call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          enddo
           vlop1=w1*w1st4
           vlop0=0.d0
           if(line.eq.26) then    !lri,lrj,lra
              call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
           endif
           if(line.eq.28) then     !lri,lrj,lrs,lra
             call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
           endif
           if(line.eq.29) then     !lri,lrj,lrs,lra
             call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
           endif
!st1(4-4) ar(23)-c'(11)-bl(31)-
           do lrk=lri+1,lrj-1
             lmk=lsm_inn(lrk)
             if(mul_tab(lmi,lmk).ne.jml.or.
     :             mul_tab(lmk,lmj).ne.jmr) cycle
             iwdl=just(lri,lrk)
             iwdr=just(lrk,lrj)
             call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
          enddo
!st1(4-4) ar(23)-bl(31)-c"(11)-
           do lrk=lrj+1,norb_dz
             lmk=lsm_inn(lrk)
            if(mul_tab(lmi,lmk).ne.jml.or.
     :          mul_tab(lmj,lmk).ne.jmr) cycle
             iwdl=just(lri,lrk)
             iwdr=just(lrj,lrk)
             call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          enddo

           vlop1=w1*w1st3
           vlop0=0.d0
           if(line.eq.26) then    !lri,lrj,lra
             call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
           endif
           if(line.eq.28) then     !lri,lrj,lrs,lra
             call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
           endif
           if(line.eq.29) then     !lri,lrj,lrs,lra
             call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
           endif
!st1(4-3) ar(13)-c'(21)-bl(31)-
           do lrk=lri+1,lrj-1
             lmk=lsm_inn(lrk)
             if(mul_tab(lmi,lmk).ne.jml.or.
     :         mul_tab(lmk,lmj).ne.jmr) cycle
             iwdl=just(lrk,lri)
             iwdr=just(lrk,lrj)
             call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
          enddo
!st1(4-3) ar(13)-bl(31)-c"(21)-
           do lrk=lrj+1,norb_dz
             lmk=lsm_inn(lrk)
             if(mul_tab(lmi,lmk).ne.jml.or.
     :            mul_tab(lmj,lmk).ne.jmr) cycle
             iwdl=just(lrk,lri)
             iwdr=just(lrj,lrk)
             call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          enddo
        enddo
      enddo

      return
      end

      subroutine tts_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!t1s(5-1)   ar(13)-bl(10)-
!t1s(5-2)   ar(13)-bl(32)-
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
!t1s(5-5)   drl(12)-
!t1s(5-6)   drl(12)-c"(12)-
!t1s(5-7)   drl(12)-c"(11)-
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        w1t1s1=w1_t1s(1)
        w1t1s2=w1_t1s(2)
        w1t1s3=w1_t1s(3)
        w1t1s4=w1_t1s(4)
        w1t1s5=w1_t1s(5)
        w1t1s6=w1_t1s(6)
        w1t1s7=w1_t1s(7)
        ni=mod(lrj-lri,2)
        if(ni.eq.0) then
          w1t1s1=-w1t1s1
          w1t1s2=-w1t1s2
          w1t1s3=-w1t1s3
          w1t1s4=-w1t1s4
!         w1t1s5=-w1t1s5
!         w1t1s6=-w1t1s6
!         w1t1s7=-w1t1s7
        endif
!       list=list3(lri,lrj,lrb)
        if(jml.eq.lmij.and.jmr.eq.1) then
!t1s(5-1)   ar(13)-bl(10)-
          vlop1=w1*w1t1s1
          vlop0=0.d0
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
!         wl=-vlop1*vint_ci(list)
         iwdl=just(lri,lrj)
          iwdr=just(lrj,lrj)
         call  prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        endif
        vlop1=w1*w1t1s2
        vlop0=0.d0
        if(line.eq.26) then    !lri,lrj,lra
          call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.28) then     !lri,lrj,lrs,lra
          call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.29) then     !lri,lrj,lrs,lra
          call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
!         wl=-vlop1*vint_ci(list)
        do lrk=norb_frz+1,lri-1
          lmk=lsm_inn(lrk)
!t1s(5-2)   (11)ar(13)-bl(32)-
          if(jml.ne.mul_tab(lmk,lmi).or.jmr.ne.
     :        mul_tab(lmk,lmj)) cycle
!          vlop1=w1*w1t1s2
!          wl=-vlop1*vint_ci(list)
           iwdl=just(lrk,lri)
           iwdr=just(lrj,lrk)
          call  prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
        do lrk=lri+1,lrj-1
          lmk=lsm_inn(lrk)
!t1s(5-2)   ar(13)-c'(11)-bl(32)-
          if(jml.ne.mul_tab(lmi,lmk).or.jmr.ne.
     :        mul_tab(lmk,lmj)) cycle
!          vlop1=w1*w1t1s2
!          wl=-vlop1*vint_ci(list)
           iwdl=just(lri,lrk)
           iwdr=just(lrj,lrk)
          call  prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
        enddo
        vlop1=w1*w1t1s3
        vlop0=0.d0
        if(line.eq.26) then    !lri,lrj,lra
          call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.28) then     !lri,lrj,lrs,lra
          call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.29) then     !lri,lrj,lrs,lra
          call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        do lrk=lrj+1,norb_dz
          lmk=lsm_inn(lrk)
!t1s(5-3)   ar(13)-bl(31)-c"(12)-
          if(jml.ne.mul_tab(lmi,lmk).or.jmr.ne.
     :        mul_tab(lmj,lmk)) cycle
!          vlop1=w1*w1t1s3
!          wl=-vlop1*vint_ci(list)
           iwdl=just(lri,lrk)
           iwdr=just(lrk,lrj)
          call  prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
        vlop1=w1*w1t1s4
        vlop0=0.d0
        if(line.eq.26) then    !lri,lrj,lra
          call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.28) then     !lri,lrk,lrs,lra
          call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.29) then     !lri,lrk,lrs,lra
          call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
!       wl=-vlop1*vint_ci(list)
        do lrk=lrj+1,norb_dz
          lmk=lsm_inn(lrk)
!t1s(5-4)   ar(13)-bl(32)-c"(11)-
          if(jml.ne.mul_tab(lmi,lmk).or.jmr.ne.
     :        mul_tab(lmj,lmk)) cycle
           iwdl=just(lri,lrk)
           iwdr=just(lrj,lrk)
          call  prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
        if(lmij.eq.jml.and.lmij.eq.jmr) then
!t1s(5-5)   (11)drl(12)-
          vlop1=w1*w1t1s5
          vlop0=0.d0
          if(line.eq.26) then    !lrj,lra
            call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then    !lrj,lrs,lra
            call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then    !lrj,lrs,lra
            call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl)
          endif
!         wl=-vlop1*voint(lrb,lrj)
          iwdl=just(lri,lrj)
          iwdr=just(lrj,lri)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!t1s(5-6)   drl(11)-c"(12)-
          vlop1=w1*w1t1s6
          vlop0=0.d0
          if(line.eq.26) then    !lri,lra
            call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then    !lri,lrs,lra
            call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then    !lri,lrs,lra
            call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
          endif
!         wl=-vlop1*voint(lrb,lri)
          iwdl=just(lri,lrj)
          iwdr=just(lrj,lri)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!t1s(5-7)   drl(12)-c"(11)-
          vlop1=w1*w1t1s7
          vlop0=0.d0
          if(line.eq.26) then    !lri,lra
            call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then    !lri,lrs,lra
            call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then    !lri,lrs,lra
            call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
          endif
!         wl=-vlop1*voint(lrb,lri)
          iwdl=just(lri,lrj)
          iwdr=iwdl
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        endif
      enddo
      enddo

      return
      end

      subroutine tt_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!tt(11-1) (22)ar(23)-bl(32)-
!tt(11-1) ar(23)-c'(22)-bl(32)-
!tt(11-1) ar(23)-bl(32)-c"(22)-
!tt(11-2) (22)drl(22)-
!tt(11-2) drl(22)-c"(22)-
!tt(11-3) (22)drl(33)-
!tt(11-3) drl(33)-c"(22)-
!tt(11-3) drl(33)-c"(22)-c"(22)-
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          jmlr=mul_tab(jml,jmr)
          if(lmij.ne.jmlr) cycle
          w0tt1=w0_tt(1)
          w1tt1=w1_tt(1)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0tt1=-w0tt1
            w1tt1=-w1tt1
          endif
!          list=list3(lri,lrj,lrb)
          vlop0=w0*w0tt1
          vlop1=w1*w1tt1
          if(line.eq.26) then    !lri,lrj,lra
            call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then     !lri,lrj,lrs,lra
            call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then     !lri,lrj,lrs,lra
            call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
!          wl=(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
!tt(11-1) (22)ar(23)-bl(32)-
          do lrk=norb_frz+1,lri-1
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lrk,lri)     !
              iwdr=just(lrk,lrj)     !
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
             endif
          enddo
!tt(11-1) ar(23)-bl(32)-c"(22)-    act -c"-
          do lrk=lrj+1,norb_dz
            lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)     !
              iwdr=just(lrj,lrk)     !
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
            endif
          enddo
!tt(11-1) ar(23)-c'(22)-bl(32)-    act -c"-
          do lrk=lri+1,lrj-1
           lmk=lsm_inn(lrk)
            lmki=mul_tab(lmk,lmi)
            lmkj=mul_tab(lmk,lmj)
            if(lmki.eq.jml.and.lmkj.eq.jmr) then
              iwdl=just(lri,lrk)      !
              iwdr=just(lrk,lrj)      !
              call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
            endif
          enddo
        enddo
      enddo

      if(jpad.ne.jpadl) return
      if(jwl .ge. jwr ) return

      w0tt2=w0_tt(2)
      w1tt2=w1_tt(2)
      w0tt3=w0_tt(3)

      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml.or.lmij.ne.jmr) cycle
          if(jwl.ge.jwr) cycle
!tt(11-2) (22)drl(22)-
!tt(11-2) drl(22)-c"(22)-
          iwdl=just(lri,lrj)     !
          iwdr=iwdl
          vlop0=w0*w0tt2
          vlop1=w1*w1tt2
          if(line.eq.26) then    !lrj,lra
            call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.28) then    !lrj,lrs,lra
            call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.29) then    !lrj,lrs,lra
            call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.26) then    !lri,lra
            call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wltmp)
          endif
          if(line.eq.28) then    !lri,lrs,lra
            call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wltmp)
          endif
          if(line.eq.29) then    !lri,lrs,lra
            call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wltmp)
          endif
          wl=wl+wltmp
!          wl=(vlop0-vlop1)*(voint(lrb,lri)+voint(lrb,lrj))
          vlop0=w0*w0tt3
          vlop1=0.d0
          do lrk=1,norb_dz
            if(lrk.eq.lri) cycle
            if(lrk.eq.lrj) cycle
!tt(11-3) drl(33)-c"(22)-c"(22)-
!tt(11-3) (22)drl(33)-c"(22)-
!tt(11-3) (22)(22)drl(33)-
            if(line.eq.26) then    !lrk,lra
              call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wltmp)
            endif
            if(line.eq.28) then    !lrk,lrs,lra
              call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
            endif
            if(line.eq.29) then    !lrk,lrs,lra
              call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
            endif
            wl=wl+wltmp
          enddo
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo

      return
      end

      subroutine tttt_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!t1t1(12-1)  ar(13)-bl(31)-
!t1t1(12-1)  ar(13)-c'(11)-bl(31)-
!t1t1(12-1)  ar(13)-bl(31)-c"(11)-
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        w0tt1=w0_t1t1(1)
        w1tt1=w1_t1t1(1)
        ni=mod(lrj-lri,2)
        if(ni.eq.0) then
          w0tt1=-w0tt1
          w1tt1=-w1tt1
        endif
!        list=list4(lri,lrj,lra,lrb)
        vlop0=w0*w0tt1
        vlop1=w1*w1tt1
        if(line.eq.26) then    !lri,lrj,lra
          call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.28) then     !lri,lrj,lrs,lra
          call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.29) then     !lri,lrj,lrs,lra
          call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
!       wl=(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
!t1t1(12-1)  (11)ar(13)-bl(31)-
        do lrm=norb_frz+1,lri-1
          lmm=lsm_inn(lrm)
          if(jml.ne.mul_tab(lmi,lmm).or.jmr.ne.mul_tab(lmm,lmj)) cycle
          iwdl=just(lrm,lri)
          iwdr=just(lrm,lrj)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
!t1t1(12-1)  ar(13)-bl(31)-c"(11)-
        do lrm=lrj+1,norb_dz
          lmm=lsm_inn(lrm)
          if(jml.ne.mul_tab(lmi,lmm).or.jmr.ne.mul_tab(lmm,lmj)) cycle
          iwdl=just(lri,lrm)
          iwdr=just(lrj,lrm)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
!t1t1(12-1)  ar(13)-c'(11)-bl(31)-
        do lrm=lri+1,lrj-1
          lmm=lsm_inn(lrm)
          if(jml.ne.mul_tab(lmi,lmm).or.jmr.ne.mul_tab(lmm,lmj)) cycle
          iwdl=just(lri,lrm)
          iwdr=just(lrm,lrj)
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,-wl,jper)
        enddo
      enddo
      enddo

      if(jpad.ne.jpadl) return
      if(jwl.ge.jwr) return

      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz               !bbs_tmp
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(jml.ne.lmij) cycle
        vlop0=w0*w0_t1t1(2)
        vlop1=w1*w1_t1t1(2)
!t1t1(12-2)  (11)drl(11)-
        if(line.eq.26) then    !lri,lra
           call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.28) then    !lrk,lrs,lra
          call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.29) then    !lrk,lrs,lra
          call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
        endif
!t1t1(12-2)  drl(11)-c"(11)-
        if(line.eq.26) then    !lrj,lra
           call comp_loop(9,lrj,0,0,lra,vlop0,vlop1,wltmp)
        endif
        if(line.eq.28) then    !lrj,lrs,lra
          call comp_loop(12,lrj,0,lrs,lra,vlop0,vlop1,wltmp)
        endif
        if(line.eq.29) then    !lrj,lrs,lra
          call comp_loop(11,lrj,0,lrs,lra,vlop0,vlop1,wltmp)
        endif
        wl=wl+wltmp
!t1t1(12-3)  (11)(11)drl(33)-
!t1t1(12-3)  (11)drl(33)-c"(11)-
!t1t1(12-3)  drl(33)-c"(11)-c"(11)-
        do lrk=1,norb_dz
          if(lrk.eq.lri) cycle
          if(lrk.eq.lrj) cycle
          vlop0=w0*w0_t1t1(3)
          vlop1=0.d0
          if(line.eq.26) then    !lrk,lra
            call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wltmp)
          endif
          if(line.eq.28) then    !lrk,lrs,lra
            call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
          endif
          if(line.eq.29) then    !lrk,lrs,lra
            call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
          endif
          wl=wl+wltmp
        enddo
        iwdl=just(lri,lrj)
        iwdr=iwdl
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      enddo
      enddo

      return
      end

      subroutine dd_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!dd(19-1) ar(23)-bl(32)-
!dd(19-2) drl(22)-
!dd(19-3) drl(33)-
!dd(19-3) drl(33)-c"(22)-
      do lril=norb_frz+1,norb_dz
        imil=lsm_inn(lril)
        if(imil.ne.jml) cycle
        iwdl=jud(lril)
        do lrir=lril,norb_dz
          imir=lsm_inn(lrir)
          if(imir.ne.jmr) cycle
          iwdr=jud(lrir)

         w0dd1=w0_dd(1)
          w1dd1=w1_dd(1)
          ni=mod(lrir-lril,2)
          if(ni.eq.0) then
            w0dd1=-w0dd1
            w1dd1=-w1dd1
         endif

         if(lril.eq.lrir.and.jwl.lt.jwr) then
!dd(19-2) drl(22)-
            vlop0=w0*w0_dd(2)
            vlop1=w1*w1_dd(2)
            if(line.eq.26) then    !lril,lra
              call comp_loop(9,lril,0,0,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.28) then    !lril,lrs,lra
              call comp_loop(12,lril,0,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.29) then    !lril,lrs,lra
              call comp_loop(11,lril,0,lrs,lra,vlop0,vlop1,wl)
            endif
!            wl=(vlop0-vlop1)*voint(lra,lril)
!            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!dd(19-3) drl(33)-
            vlop0=w0*w0_dd(3)
           vlop1=0.d0
            do lrk=1,norb_dz
             if(lrk.eq.lril) cycle
!             list=list3(lrs,lra,lrk)
             if(line.eq.26) then    !lrk,lra
               call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wltmp)     !wyb
             endif
             if(line.eq.28) then    !lrk,lrs,lra
               call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wltmp)   !wyb
             endif
             if(line.eq.29) then    !lrk,lrs,lra
               call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wltmp)   !wyb
             endif
!              wl=wl+vlop0*voint(lrk,lra)
             wl=wltmp+wl
            enddo
             call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          endif
          if(lril.ne.lrir)then
!dd(19-1) ar(23)-bl(32)-
            vlop0=w0*w0dd1
            vlop1=w1*w1dd1
            if(line.eq.26) then   !lril,lrir,lra
              call comp_loop(5,lril,lrir,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.28) then   !lril,lrir,lrs,lra
              call comp_loop(7,lril,lrir,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.29) then   !lril,lrir,lrs,lra
              call comp_loop(6,lril,lrir,lrs,lra,vlop0,vlop1,wl)
            endif
!            list=list4(lril,lrir,lrs,lra)
!            wl=vlop0*(vint_ci(list)-2*vint_ci(list+1)) !1.1       !!!!!
!     :       -vlop1*vint_ci(list)
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          endif
        enddo
      enddo

      return
      end

      subroutine dddd_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!d1d1(20-1) ar(13)-bl(31)-
!d1d1(20-1) drl(11)-
!d1d1(20-1) drl(33)-
!d1d1(20-1) drl(33)-c"(11)-
      do lril=norb_frz+1,norb_dz
        imil=lsm_inn(lril)
        if(imil.ne.jml) cycle
        iwdl=jud(lril)
        do lrir=lril,norb_dz
          imir=lsm_inn(lrir)
          if(imir.ne.jmr) cycle
          w0dd1=w0_d1d1(1)
         w1dd1=w1_d1d1(1)
         ni=mod(lrir-lril,2)
         if(ni.eq.0) then
            w0dd1=-w0dd1
            w1dd1=-w1dd1
         endif
         iwdr=jud(lrir)
          if(lril.eq.lrir.and.jwl.lt.jwr)then
!d1d1(20-1) drl(11)-
           vlop0=w0*w0_d1d1(2)
            vlop1=w1*w1_d1d1(2)
            if(line.eq.26) then    !lril,lra
              call comp_loop(9,lril,0,0,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.28) then    !lril,lrs,lra
              call comp_loop(12,lril,0,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.29) then    !lril,lrs,lra
              call comp_loop(11,lril,0,lrs,lra,vlop0,vlop1,wl)
            endif
!d1d1(20-1) drl(33)-
!d1d1(20-1) drl(33)-c"(11)-
            vlop0=w0*w0_d1d1(3)
           vlop1=0.d0
           do lrk=1,norb_dz
              if(lrk.eq.lril) cycle
              if(line.eq.26) then    !lrk,lra
                call comp_loop(9,lrk,0,0,lra,vlop0,vlop1,wltmp)
              endif
              if(line.eq.28) then    !lrk,lrs,lra
                call comp_loop(12,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
              endif
              if(line.eq.29) then    !lrk,lrs,lra
                call comp_loop(11,lrk,0,lrs,lra,vlop0,vlop1,wltmp)
              endif
              wl=wl+wltmp
            enddo
           call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          endif
          if(lril.ne.lrir)then
!d1d1(20-1) ar(13)-bl(31)-
            vlop0=w0*w0dd1
            vlop1=w1*w1dd1
            if(line.eq.26) then   !lril,lrir,lra
              call comp_loop(5,lril,lrir,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.28) then   !lril,lrir,lrs,lra
              call comp_loop(7,lril,lrir,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.29) then   !lril,lrir,lrs,lra
              call comp_loop(6,lril,lrir,lrs,lra,vlop0,vlop1,wl)
            endif
!            list=list3(lril,lrir,lra)
!            wl=(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)   !2
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
         endif
        enddo
      enddo

      return
      end

      subroutine dd1_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        iwdl=jud(lri)
      do lrj=lri+1,norb_dz
!dd1(21) ar(23)-bl(31)-
        lmj=lsm_inn(lrj)
        if(jml.ne.lmi.or.jmr.ne.lmj) cycle
        vlop1=w1*w1_dd1
        vlop0=0.d0
        ni=mod(lrj-lri,2)
        if(ni.eq.0) then
          vlop1=-vlop1
        endif

        if(line.eq.26) then   !lri,lrj,lra
          call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.28) then   !lril,lrj,lrs,lra
          call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.29) then   !lri,lrj,lrs,lra
          call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
!       list=list3(lri,lrj,lra)
!       wl=-vlop1*vint_ci(list)
        iwdr=jud(lrj)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      enddo
      enddo

      return
      end

      subroutine d1d_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!d1d(22-1)   ar(13)-bl(32)-
!d1d(22-2)   drl(12)-
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        iwdl=jud(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        if(jml.ne.lmi.or.jmr.ne.lmj) cycle
        vlop1=w1*w1_d1d(1)
        vlop0=0.d0
        if(mod(lrj-lri,2).eq.0) then
          vlop1=-vlop1
        endif
        if(line.eq.26) then   !lri,lrj,lra
          call comp_loop(5,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.28) then   !lril,lrj,lrs,lra
          call comp_loop(7,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.29) then   !lri,lrj,lrs,lra
          call comp_loop(6,lri,lrj,lrs,lra,vlop0,vlop1,wl)
        endif
!       list=list3(lri,lrj,lra)
!       wl=-vlop1*vint_ci(list)
        iwdr=jud(lrj)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      enddo
      enddo
      vlop1=w1*w1_d1d(2)
      vlop0=0.d0
      do lri=norb_frz+1,norb_dz
 !d1d(22-2)   drl(12)-
        lmi=lsm_inn(lri)
        if(jml.ne.lmi.or.jmr.ne.lmi) cycle
        if(line.eq.26) then    !lri,lra
          call comp_loop(9,lri,0,0,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.28) then    !lri,lrs,lra
          call comp_loop(12,lri,0,lrs,lra,vlop0,vlop1,wl)
        endif
        if(line.eq.29) then    !lri,lrs,lra
          call comp_loop(11,lri,0,lrs,lra,vlop0,vlop1,wl)
        endif
!       vlop1=w1*w1_d1d(2)
!       wl=-vlop1*voint(lri,lra)
        iwdl=jud(lri)
        iwdr=iwdl
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
      enddo

      return
      end

      subroutine sv_head_dbl_tail_act(lra)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
!sv(10-1) ar(13)-br(23)-
!sv(10-2) ar(23)-br(13)-
!sv(10-3) drr(03)-
      iwdr=0
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
      do lrj=lri,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(lmij.ne.jml) cycle
        w0sv1=w0_sv(1)
        w1sv1=w1_sv(1)
        w0sv2=w0_sv(2)
        w1sv2=w1_sv(2)
        ni=mod(lrj-lri,2)
        if(ni.eq.0) then
          w0sv1=-w0sv1
          w1sv1=-w1sv1
          w0sv2=-w0sv2
          w1sv2=-w1sv2
        endif
        iwdl=just(lri,lrj)
        if(lri.eq.lrj) then
          vlop0=w0*w0_sv(3)            !d10-3
          vlop1=0.d0
!         wl=vlop0*voint(lra,lri)/2
          if(line.eq.25) then    !lri,lra
cwyb         call comp_loop(8,lri,lrg,lrs,lra,vlop0,vlop1,wl)
             call comp_loop(8,lri,0,0,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.27) then    !lri,lrs,lra
cwyb         call comp_loop(10,lri,lrs,lra,lra,vlop0,vlop1,wl)
            call comp_loop(10,lri,0,lrs,lra,vlop0,vlop1,wl)
          endif
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        else
          vlop0=w0*w0sv2             !d10-2
          vlop1=w1*w1sv2
!         list=list3(lri,lrj,lra)
!          wl=(vlop0+vlop1)*vint_ci(list)        !2.1          !!!!!
          if(line.eq.25) then    !lri,lrj,lra
            call comp_loop(3,lri,lrj,lrs,lra,vlop0,vlop1,wl)
          endif
          if(line.eq.27) then      !lri,lrj,lrs,lra
            call comp_loop(4,lri,lrj,lrs,lra,vlop0,vlop1,wl)
         endif
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          if(jb_sys.gt.0) then
            iwdl=just(lrj,lri)
            vlop0=w0*w0sv1
            vlop1=w1*w1sv1
!           list=list3(lri,lrj,lra)
!            wl=(vlop0+vlop1)*vint_ci(list)        !2.1          !!!!!
            if(line.eq.25) then    !lri,lrj,lra
              call comp_loop(3,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
            if(line.eq.27) then      !lri,lrj,lrs,lra
              call comp_loop(4,lri,lrj,lrs,lra,vlop0,vlop1,wl)
            endif
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          endif
        endif
      enddo
      enddo
      return

      end

      subroutine sd_head_dbl_tail_act(lra,lpcoe)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      jmlr=mul_tab(jml,jmr)
!sd(6-1) a&r(02)-
!sd(6-2) c(22)a&r(13)-
!sd(6-4) a&r(23)c'(12)-
!sd(6-5) a&r(23)b&r(13)b^r(32)
!sd(6-8) a&r(23)b&l(32)b^l(13)
!sd(6-9) d&r&r(03)b^r(32)
!sd(6-11) d&r&l(22)b^l(13)
!sd(6-12) d&r&l(33)b^l(02)
!sd(6-13) (22)d&r&l(33)b^l(13)
!sd(6-14) d&r&l(33)c"(22)b^l(13)
!sd(6-16) d&r&l(33)b^l(23)c'(12)

!sd(6-3) a&r(13)c'(22)-
!sd(6-6) a&r(13)b&r(23)b^r(32)
!sd(6-7) a&r(13)b&l(32)b^l(23)
!sd(6-10) d&r&l(12)b^l(23)
!sd(6-15) d&r&l(33)b^l(13)c'(22)

      if(jml.ne.1) goto 207

!sd(6-1) a&r(02)-
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        iwdl=just(lri,lri)
        w0sd1 =w0_sd(1)
        w0sd12=w0_sd(12)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd12=-w0sd12
        endif
        if(lmi.eq.jmlr) then
          iwdr=jud(lri)
          vlop0=w0*w0sd1
          wl=vlop0*voint(lri,lra)             !310,act_coe,610,710
          do lr=lri+1,norb_dz
            list =list3(lri,lra,lr)
            wl=wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2,
          enddo
          do lrk=norb_dz+1,lra
            list=list3(lri,lra,lrk)
            kcoe=lpcoe(lrk)
            call neoc(kcoe,nocc,tcoe)
            wl=wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
          enddo
c          wl=wl*vlop0
!sd(6-12) d&rl(33)b^l(02)
          vlop0=w0*w0sd12
         do lrk=1,lri-1
            list=list3(lri,lra,lrk)
            wl=wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))
          enddo
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        endif

!sd(6-9) d&r&r(03)b^r(32)
        do lrd=lri+1,norb_dz
         lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
          w0sd9=w0_sd(9)
          ni=mod(norb_dz-lrd,2)
          if(ni.eq.1)   w0sd9=-w0sd9
          iwdr=jud(lrd)
          vlop0=w0*w0sd9
          list=list3(lrd,lra,lri)
          wl=vint_ci(list)*vlop0
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo

207   do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          w0sd2 =w0_sd(2)
          w1sd2 =w1_sd(2)
          w0sd11=w0_sd(11)
          w1sd11=w1_sd(11)
          w0sd14=w0_sd(14)
          w1sd14=0.d0
          ni=mod(norb_dz-lrj,2)
          if(ni.eq.1) then
            w0sd2 =-w0sd2
            w1sd2 =-w1sd2
            w0sd11=-w0sd11
            w1sd11=-w1sd11
            w0sd14=-w0sd14
          endif
          iwdl=just(lri,lrj)
          iwdl1=just(lrj,lri)
c**********************************************************
!sd(6-2) c(22)-a&r(13)-
          if(lmi.eq.jmr) then
            iwdr=jud(lri)
            vlop0=w0*w0sd2
            list=list3(lrj,lra,lrj)
            wl=vlop0*(voint(lrj,lra)+vint_ci(list))          !310,act_co
            do lr=lrj+1,norb_dz
              list =list3(lrj,lra,lr)
              wl=wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=
            enddo
            do lrk=norb_dz+1,lra
              list=list3(lrj,lra,lrk)
              kcoe=lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              wl=wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            enddo
c            wl=wl*vlop0
!sd(6-11) d&r&l(22)b^l(13)
            vlop0=w0*w0sd11
            vlop1=w1*w1sd11
            list=list3(lrj,lra,lri)
           wl=wl+(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
!sd(6-13) (22)d&r&l(33)b^l(13)
!sd(6-14) d&r&l(33)c"(22)b^l(13)
            vlop0=w0*w0sd14
            do lrk=1,lrj-1
              if(lrk.eq.lri) cycle
              list=list3(lrj,lra,lrk)
              wl=wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))
            enddo
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          endif
        if(jb_sys.gt.0) then
          if(lmj.eq.jmr) then
            iwdr=jud(lrj)
            w0sd3=w0_sd(3)
            w0sd15=w0_sd(15)
            w1sd10=w1_sd(10)
           ni=mod(norb_dz-lri,2)
            if(ni.eq.0) then
             w0sd3=-w0sd3
             w0sd15=-w0sd15
              w1sd10=-w1sd10
            endif
!sd(6-3) a&r(13)-c'(22)-
           vlop0=w0*w0sd3
            list=list3(lri,lra,lri)
            wl=voint(lri,lra)+vint_ci(list)            !310,act_coe,610
            list=list3(lri,lra,lrj)
            wl=wl+vint_ci(list+1)-vint_ci(list)  !310 c(22)neoc=1,coe=
            do lr=lri+1,norb_dz
              if(lr.eq.lrj) cycle
            list =list3(lri,lra,lr)
              wl=wl+2*vint_ci(list+1)-vint_ci(list)     !310:neoc=2,co
            enddo
            do lrk=norb_dz+1,lra
              list=list3(lri,lra,lrk)
              kcoe=lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              wl=wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            enddo
            wl=wl*vlop0
!sd(6-15) d&r&l(33)b^l(13)c'(22)
            vlop0=w0*w0sd15
            do lrk=1,lri-1
              list=list3(lri,lra,lrk)
              wl=wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
            enddo
            call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
          endif
         if(lmij.eq.jml.and.lmi.eq.jmr) then
            iwdr=jud(lri)
            iwdl1=just(lrj,lri)
            w1sd10=w1_sd(10)
            if(mod(norb_dz-lrj,2).eq.1) then
              w1sd10=-w1sd10
            endif
!sd(6-10) d&r&l(12)b^l(23)
            vlop1=w1*w1sd10
            list=list3(lrj,lra,lri)
           wl=-vlop1*vint_ci(list)      !4.3
            call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
          endif
        endif
!sd(6-4) a&r(23)-c'(12)-
          if(lmj.eq.jmr) then
            iwdr=jud(lrj)
            w0sd4=w0_sd(4)
            w0sd16=w0_sd(16)
           ni=mod(norb_dz-lri,2)
            if(ni.eq.0) w0sd4=-w0sd4
            if(ni.eq.0) w0sd16=-w0sd16
            vlop0=w0*w0sd4
            list=list3(lri,lra,lri)
            wl=voint(lri,lra)+vint_ci(list)             !310,act_coe,610
            list=list3(lri,lra,lrj)
            wl=wl+vint_ci(list+1)-(jb_sys+2)*1.d0*vint_ci(list)
            do lr=lri+1,norb_dz
              if(lr.eq.lrj) cycle
            list =list3(lri,lra,lr)
              wl=wl+2*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,co
            enddo
            do lrk=norb_dz+1,lra
              list=list3(lri,lra,lrk)
              kcoe=lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              wl=wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            enddo
            wl=wl*vlop0
!sd(6-16) d&r&l(33)b^l(23)c'(12)
            vlop0=w0*w0sd16
            do lrk=1,lri-1
              list=list3(lri,lra,lrk)
              wl=wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
            enddo
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          endif

!sd(6-5) a&r(23)b&r(13)b^r(32)
          do lrd=lrj+1,norb_dz
           lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
           iwdr=jud(lrd)
            w0sd5=w0_sd(5)
            w1sd5=w1_sd(5)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0)   w0sd5=-w0sd5
            if(ni.eq.0)   w1sd5=-w1sd5
            vlop0=w0*w0sd5
            vlop1=w1*w1sd5
            list=list4(lri,lrj,lrd,lra)
            wl=(vlop0-vlop1)*vint_ci(list+2)+
     :         (vlop0+vlop1)*vint_ci(list)             !1.3
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
         enddo
        if(jb_sys.gt.0) then
!sd(6-6) a&r(13)b&r(23)b^r(32)
          do lrd=lrj+1,norb_dz
           lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
           iwdr=jud(lrd)
            w0sd6=w0_sd(6)
            w1sd6=w1_sd(6)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0)   w0sd6=-w0sd6
            if(ni.eq.0)   w1sd6=-w1sd6
            vlop0=w0*w0sd6
            vlop1=w1*w1sd6
            list=list4(lri,lrj,lrd,lra)
            wl=(vlop0-vlop1)*vint_ci(list+2)+
     :         (vlop0+vlop1)*vint_ci(list)             !1.3
          call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
         enddo
!sd(6-7) a&r(13)b&l(32)b^l(23)
         do lrd=lri+1,lrj-1
           lmd=lsm_inn(lrd)
           if(lmd.ne.jmr) cycle
           iwdr=jud(lrd)
           w0sd7=w0_sd(7)
           w1sd7=w1_sd(7)
           ni=mod(lrd-lri+norb_dz-lrj,2)
           if(ni.eq.0)   w0sd7=-w0sd7
           if(ni.eq.0)   w1sd7=-w1sd7
           vlop0=w0*w0sd7
           vlop1=w1*w1sd7
           list=list4(lri,lrd,lrj,lra)
           wl=(vlop0-vlop1)*vint_ci(list+2)-
     :             2*vlop0*vint_ci(list+1)      !1.2
           call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
         enddo
        endif
!sd(6-8) a&r(23)b&l(32)b^l(13)
         do lrd=lri+1,lrj-1
           lmd=lsm_inn(lrd)
           if(lmd.ne.jmr) cycle
           iwdr=jud(lrd)
           w0sd8=w0_sd(8)
           w1sd8=w1_sd(8)
           ni=mod(lrd-lri+norb_dz-lrj,2)
           if(ni.eq.0)   w0sd8=-w0sd8
           if(ni.eq.0)   w1sd8=-w1sd8
           vlop0=w0*w0sd8
           vlop1=w1*w1sd8
           list=list4(lri,lrd,lrj,lra)
           wl=(vlop0-vlop1)*vint_ci(list+2)-
     :             2*vlop0*vint_ci(list+1)      !1.2
         call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo
      enddo

      return
      end

      subroutine sdd_head_dbl_tail_act(lra,lpcoe)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      jmlr=mul_tab(jml,jmr)
!sd1(8-1) a&r(01)-
!sd1(8-2) c(11)a&r(23)-
!sd1(8-3) a&r(13)c'(21)-
!sd1(8-4) a&r(23)c'(11)-
!sd1(8-5) a&r(13)b&r(23)b^r(31)
!sd1(8-6) a&r(23)b&r(13)b^r(31)
!sd1(8-7) a&r(13)b&l(31)b^l(23)
!sd1(8-8) a&r(23)b&l(31)b^l(13)
!sd1(8-9) d&r&r(03)b^r(31)
!sd1(8-10) d&r&l(11)b^l(23)
!sd1(8-11) d&r&l(33)b^l(01)
!sd1(8-12) d&r&l(33)b^l(23)
!sd1(8-13) d&r&l(33)c"(13)b^l(23)
!sd1(8-14) d&r&l(33)b^l(11)c'(23)
!sd1(8-15) d&r&l(33)b^l(23)c'(11)
      if(jml.ne.1) goto 209
      do lri=norb_frz+1,norb_dz
!sd1(8-1) a&r(01)-
        lmi=lsm_inn(lri)
        iwdl=just(lri,lri)
        w0sd1=w0_sd1(1)
        w0sd11=w0_sd1(9)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0sd1 =-w0sd1
          w0sd11=-w0sd11
        endif
        if(lmi.eq.jmlr) then
          iwdr=jud(lri)
          vlop0=w0*w0sd1
          wl=vlop0*voint(lri,lra)             !310,act_coe,610,710
          do lr=lri+1,norb_dz
            list =list3(lri,lra,lr)
            wl=wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2,
          enddo
          do lrk=norb_dz+1,lra
            list=list3(lri,lra,lrk)
            kcoe=lpcoe(lrk)
            call neoc(kcoe,nocc,tcoe)
            wl=wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
          enddo
c          wl=wl*vlop0
!sd1(8-11) d&rl(33)b^l(01)
          vlop0=w0*w0sd11
         do lrk=1,lri-1
            list=list3(lri,lra,lrk)
            wl=wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))
          enddo
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        endif
!sd1(8-9) d&r&r(03)b^r(31)
        do lrd=lri+1,norb_dz
         lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
          w0sd9=w0_sd1(9)
          ni=mod(norb_dz-lrd,2)
          if(ni.eq.1)   w0sd9=-w0sd9
          iwdr=jud(lrd)
          vlop0=w0*w0sd9
          list=list3(lrd,lra,lri)
          wl=vint_ci(list)*vlop0
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo

209   do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          if(lri.eq.lrj) cycle
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          w0sd2 =w0_sd1(2)
          w1sd2 =w1_sd1(2)
          w0sd3 =w0_sd1(3)
          w1sd3 =w1_sd1(3)
          w0sd4 =w0_sd1(4)
          w1sd4 =w1_sd1(4)
          w0sd10=w0_sd1(10)
          w1sd10=w1_sd1(10)
          w0sd11=w0_sd1(11)
          w1sd11=0.d0
          w0sd12=w0_sd1(12)
          w0sd13=w0_sd1(13)
          ni=mod(norb_dz-lrj,2)
          if(ni.eq.1) then
            w0sd2 =-w0sd2
            w1sd2 =-w1sd2
            w0sd10=-w0sd10
            w1sd10=-w1sd10
            w0sd11=-w0sd11
          endif
          if(mod(norb_dz-lri,2).eq.1) then
            w0sd3 =-w0sd3
            w1sd3 =-w1sd3
            w0sd4 =-w0sd4
            w1sd4 =-w1sd4
            w0sd12=-w0sd12
            w0sd13=-w0sd13
          endif
          iwdl=just(lrj,lri)
          iwdl1=just(lri,lrj)
c**********************************************************
!sd1(8-2) c(11)-a&r(23)-
          if(lmi.eq.jmr) then
            iwdl=just(lrj,lri)
            iwdr=jud(lri)
            vlop0=w0*w0sd2
            list=list3(lrj,lra,lrj)
            wl=vlop0*(voint(lrj,lra)+vint_ci(list))          !310,act_co
            do lr=lrj+1,norb_dz
              list =list3(lrj,lra,lr)
              wl=wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=
            enddo
            do lrk=norb_dz+1,lra
              list=list3(lrj,lra,lrk)
              kcoe=lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              wl=wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            enddo
c            wl=wl*vlop0
!sd1(8-10) d&r&l(11)b^l(23)
            vlop0=w0*w0sd10
            vlop1=w1*w1sd10
            list=list3(lrj,lra,lri)
           wl=wl+(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
!sd1(8-11) (11)d&r&l(33)b^l(23)
!sd1(8-11) d&r&l(33)c"(11)b^l(23)
            vlop0=w0*w0sd11
            do lrk=1,lrj-1
              if(lrk.eq.lri) cycle
              list=list3(lrj,lra,lrk)
              wl=wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))
            enddo
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          endif

!sd1(8-3) a&r(13)-c'(21)-
          if(lmj.eq.jmr) then
            vlop0=-w0*w0sd3
            list=list3(lri,lra,lri)
            wl=voint(lri,lra)+vint_ci(list)             !310,act_coe,610
            list=list3(lri,lra,lrj)
            wl=wl+vint_ci(list+1)+jb_sys*1.d0*vint_ci(list)         !310
            do lr=lri+1,norb_dz
              if(lr.eq.lrj) cycle
            list =list3(lri,lra,lr)
              wl=wl+2*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,co
            enddo
            do lrk=norb_dz+1,lra
              list=list3(lri,lra,lrk)
              kcoe=lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              wl=wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            enddo
            wl=wl*vlop0
!sd1(8-12) drl(33)-bl(13)-c'(21)-
            iwdl=just(lrj,lri)
            iwdr=jud(lrj)
            vlop0=-w0*w0sd12
            do lrk=1,lri-1
              list=list3(lri,lra,lrk)
              wl=wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
            enddo
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          endif
!sd1(8-4) a&r(23)-c'(11)-
          if(lmj.eq.jmr) then
            vlop0=-w0*w0sd4
            list=list3(lri,lra,lri)
            wl=voint(lri,lra)+vint_ci(list)           !310,act_coe,610
            list=list3(lri,lra,lrj)
            wl=wl+vint_ci(list+1)-vint_ci(list)       !310 c(11)neoc=
            do lr=lri+1,norb_dz
              if(lr.eq.lrj) cycle
            list =list3(lri,lra,lr)
              wl=wl+2*vint_ci(list+1)-vint_ci(list)   !310:neoc=2,co
            enddo
            do lrk=norb_dz+1,lra
              list=list3(lri,lra,lrk)
              kcoe=lpcoe(lrk)
              call neoc(kcoe,nocc,tcoe)
              wl=wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
            enddo
            wl=wl*vlop0
!sd1(8-13) drl(33)-bl(23)-c'(11)-
            iwdl=just(lri,lrj)
           iwdr=jud(lrj)
            vlop0=-w0*w0sd13
            do lrk=1,lri-1
              list=list3(lri,lra,lrk)
              wl=wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
            enddo
            call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
          endif
!sd1(8-5) a&r(13)b&r(23)b^r(31)
          do lrd=lrj+1,norb_dz
           lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdl=just(lrj,lri)
           iwdr=jud(lrd)
            w0sd5=w0_sd1(5)
            w1sd5=w1_sd1(5)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0)   w0sd5=-w0sd5
            if(ni.eq.0)   w1sd5=-w1sd5
            vlop0=w0*w0sd5
            vlop1=w1*w1sd5
            list=list4(lri,lrj,lrd,lra)
            wl=(vlop0-vlop1)*vint_ci(list+2)+
     :         (vlop0+vlop1)*vint_ci(list)             !1.3
           call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!sd1(8-6) a&r(23)b&r(13)b^r(31)
            iwdl=just(lri,lrj)
            w0sd6=w0_sd1(6)
            w1sd6=w1_sd1(6)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0)   w0sd6=-w0sd6
            if(ni.eq.0)   w1sd6=-w1sd6
            vlop0=w0*w0sd6
            vlop1=w1*w1sd6
            list=list4(lri,lrj,lrd,lra)
            wl=(vlop0-vlop1)*vint_ci(list+2)+
     :         (vlop0+vlop1)*vint_ci(list)             !1.3
          call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
         enddo
!sd1(8-7) a&r(13)b&l(31)b^l(23)
         do lrd=lri+1,lrj-1
           lmd=lsm_inn(lrd)
           if(lmd.ne.jmr) cycle
           iwdr=jud(lrd)
           iwdl=just(lrj,lri)
           w0sd7=w0_sd1(7)
           w1sd7=w1_sd1(7)
           ni=mod(lrd-lri+norb_dz-lrj,2)
           if(ni.eq.0)   w0sd7=-w0sd7
           if(ni.eq.0)   w1sd7=-w1sd7
           vlop0=w0*w0sd7
           vlop1=w1*w1sd7
           list=list4(lri,lrd,lrj,lra)
           wl=(vlop0-vlop1)*vint_ci(list+2)-
     :             2*vlop0*vint_ci(list+1)      !1.2
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
!sd1(8-8) a&r(23)b&l(31)b^l(13)
           iwdl=just(lri,lrj)
           w0sd8=w0_sd1(8)
           w1sd8=w1_sd1(8)
           ni=mod(lrd-lri+norb_dz-lrj,2)
           if(ni.eq.0)   w0sd8=-w0sd8
           if(ni.eq.0)   w1sd8=-w1sd8
           vlop0=w0*w0sd8
           vlop1=w1*w1sd8
           list=list4(lri,lrd,lrj,lra)
           wl=(vlop0-vlop1)*vint_ci(list+2)-
     :             2*vlop0*vint_ci(list+1)      !1.2
          call prodab(3,jpel,iwdl1,iwdr,jwl,jwr,wl,jper)
         enddo
       enddo
      enddo

      return
      end

      subroutine td_head_dbl_tail_act(lra,lpcoe)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      jmlr=mul_tab(jml,jmr)
!td(13-1) (22)a&(23)
!td(13-1) a&(23)c'(22)
!td(13-5) (22)d&&l(33)b^l(23)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        isma=lmi
        if(lmi.ne.jmlr) cycle
        w0td1=w0_td(1)
        w0td4=w0_td(4)
        w0td5=w0_td(5)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1)w0td1=-w0td1
        if(ni.eq.1)w0td4=-w0td4
        if(ni.eq.1)w0td5=-w0td5

!td(13-1) a&(23)c'(22)
        do lrd=lri+1,norb_dz
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
         iwdl=just(lri,lrd)      !
          iwdr=jud(lrd)
          vlop0=-w0*w0td1
          list=list3(lri,lra,lri)
          wl=voint(lri,lra)+vint_ci(list)        !310,act_coe,610,7
          list=list3(lri,lra,lrd)
          wl=wl+vint_ci(list+1)                  !310 c(22) coe
         do lr=lri+1,norb_dz
            if(lr.eq.lrd) cycle
           list =list3(lri,lra,lr)
            wl=wl+2*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,coe=
          enddo
          do lrk=norb_dz+1,lra
            list=list3(lri,lra,lrk)
            kcoe=lpcoe(lrk)
            call neoc(kcoe,nocc,tcoe)
            wl=wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
          enddo
          wl=wl*vlop0
!td(13-5) d&rl(33)b^l(23)c'(22)          !cc (22)d&rl(33)b^l(23)???
          vlop0=-w0*w0td5
          do lrk=1,lri-1
            list=list3(lri,lra,lrk)
            wl=wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
          enddo
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
!-------------------------------------------------------------------
        do lrd=norb_frz+1,lri-1
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
         iwdl=just(lrd,lri)      !
          iwdr=jud(lrd)
!td(13-1) (22)a&(23)
          vlop0=w0*w0td1
          list=list3(lri,lra,lri)
          wl=vlop0*(voint(lri,lra)+vint_ci(list))             !310,act_c
          do lr=lri+1,norb_dz
            list =list3(lri,lra,lr)
            wl=wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2,
          enddo
          do lrk=norb_dz+1,lra
            list=list3(lri,lra,lrk)
            kcoe=lpcoe(lrk)
            call neoc(kcoe,nocc,tcoe)
            wl=wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
          enddo
c            wl=wl*vlop0
!td(13-4) d&r&l(22)b^l(23)
          vlop0=w0*w0td4
          vlop1=w1*w0td4
          list=list3(lri,lra,lrd)
          wl=wl+(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
!td(13-5) d&rl(33)c"(22)b^l(23)
          vlop0=w0*w0td5
          do lrk=1,lri-1
            if(lrk.eq.lrd) cycle
           list=list3(lri,lra,lrk)
            wl=wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))      !4.3
          enddo
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(lmij.ne.jml) cycle
        iwdl=just(lri,lrj)     !

!td(13-2) a&(23)b&r(23)b^r(32)
        do lrd=lrj+1,norb_dz
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
          w0td2=w0_td(2)
          w1td2=w1_td(2)
          ni=mod(lrj-lri+norb_dz-lrd,2)
        if(ni.eq.0) w0td2=-w0td2
        if(ni.eq.0) w1td2=-w1td2

          iwdr=jud(lrd)
          vlop0=w0*w0td2
          vlop1=w1*w1td2
          list=list4(lri,lrj,lrd,lra)
          wl=vlop0*(vint_ci(list+2)+vint_ci(list))  !1.3
     :       -vlop1*(vint_ci(list+2)-vint_ci(list))
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
!td(13-3) a&(23)b&l(32)b^l(23)
        do lrd=lri+1,lrj-1
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
          iwdr=jud(lrd)
          w0td3=w0_td(3)
          w1td3=w1_td(3)
          ni=mod(lrd-lri+norb_dz-lrj,2)
          if(ni.eq.0)   w0td3=-w0td3
          if(ni.eq.0)   w1td3=-w1td3
          vlop0=w0*w0td3                !d6-8
          vlop1=w1*w1td3
          list=list4(lri,lrd,lrj,lra)
        wl=vlop0*(vint_ci(list+2)-2*vint_ci(list+1))      !1.2
     :       -vlop1*vint_ci(list+2)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo
      enddo

      return
      end

      subroutine ttdd_head_dbl_tail_act(lra,lpcoe)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
      dimension lpcoe(norb_dz+1:norb_inn)
      common/onepl/line,jph,jpel,jper,lrg,lrs,jwl,jwr,w0,w1
      jmlr=mul_tab(jml,jmr)
!t1d1(15-1) (11)a&(13)
!t1d1(15-1) a&(13)c'(11)
!t1d1(15-5) (11)d&&l(33)b^l(13)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        isma=lmi
        if(lmi.ne.jmlr) cycle
        w0td1=w0_t1d1(1)
        w0td4=w0_t1d1(4)
        w0td5=w0_t1d1(5)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) then
          w0td1=-w0td1
          w0td4=-w0td4
          w0td5=-w0td5
        endif
!t1d1(15-2) a&(13)c'(11)
        do lrd=lri+1,norb_dz
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
         iwdl=just(lri,lrd)      !
          iwdr=jud(lrd)
          vlop0=-w0*w0td1
          list=list3(lri,lra,lri)
          wl=voint(lri,lra)+vint_ci(list)           !310,act_coe,610,7
          list=list3(lri,lra,lrd)
          wl=wl+vint_ci(list+1)
          do lr=lri+1,norb_dz
            if(lr.eq.lrd) cycle
           list =list3(lri,lra,lr)
            wl=wl+2*vint_ci(list+1)-vint_ci(list)       !310:neoc=2,coe=
          enddo
          do lrk=norb_dz+1,lra
            list=list3(lri,lra,lrk)
            kcoe=lpcoe(lrk)
            call neoc(kcoe,nocc,tcoe)
            wl=wl+nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
          enddo
          wl=wl*vlop0
!t1d1(15-5) d&rl(33)b^l(13)c'(11)
          vlop0=-w0*w0td5
          do lrk=1,lri-1
            list=list3(lri,lra,lrk)
            wl=wl-vlop0*(2*vint_ci(list+1)-vint_ci(list))
          enddo
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
!-------------------------------------------------------------------
        do lrd=norb_frz+1,lri-1
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
         iwdl=just(lrd,lri)      !
          iwdr=jud(lrd)
!t1d1(15-1) (11)a&(13)
          vlop0=w0*w0td1
          list=list3(lri,lra,lri)
          wl=vlop0*(voint(lri,lra)+vint_ci(list))             !310,act_c
          do lr=lri+1,norb_dz
            list =list3(lri,lra,lr)
            wl=wl+vlop0*(2*vint_ci(list+1)-vint_ci(list)) !  310:neoc=2,
          enddo
          do lrk=norb_dz+1,lra
            list=list3(lri,lra,lrk)
            kcoe=lpcoe(lrk)
            call neoc(kcoe,nocc,tcoe)
            wl=wl+vlop0*nocc*(vint_ci(list+1)+tcoe*vint_ci(list))
          enddo
c            wl=wl*vlop0
!t1d1(15-4) d&r&l(11)b^l(13)
          vlop0=w0*w0td4
          vlop1=w1*w0td4
          list=list3(lri,lra,lrd)
          wl=wl+(vlop0-vlop1)*vint_ci(list)-2*vlop0*vint_ci(list+1)
!t1d1(15-5) d&rl(33)c"(11)b^l(13)
          vlop0=w0*w0td5
          do lrk=1,lri-1
            if(lrk.eq.lrd) cycle
           list=list3(lri,lra,lrk)
            wl=wl+vlop0*(vint_ci(list)-2*vint_ci(list+1))      !4.3
          enddo
          call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
      do lrj=lri+1,norb_dz
        lmj=lsm_inn(lrj)
        lmij=mul_tab(lmi,lmj)
        if(lmij.ne.jml) cycle
        iwdl=just(lri,lrj)     !

!t1d1(15-2) a&(13)b&r(13)b^r(31)
        do lrd=lrj+1,norb_dz
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
          w0td2=w0_t1d1(2)
          w1td2=w1_t1d1(2)
          ni=mod(lrj-lri+norb_dz-lrd,2)
        if(ni.eq.0) w0td2=-w0td2
        if(ni.eq.0) w1td2=-w1td2

          iwdr=jud(lrd)
          vlop0=w0*w0td2
          vlop1=w1*w1td2
          list=list4(lri,lrj,lrd,lra)
          wl=vlop0*(vint_ci(list+2)+vint_ci(list))  !1.3
     :       -vlop1*(vint_ci(list+2)-vint_ci(list))
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
!t1d1(15-3) a&(13)b&l(31)b^l(13)
        do lrd=lri+1,lrj-1
          lmd=lsm_inn(lrd)
          if(lmd.ne.jmr) cycle
          iwdr=jud(lrd)
          w0td3=w0_t1d1(3)
          w1td3=w1_t1d1(3)
          ni=mod(lrd-lri+norb_dz-lrj,2)
          if(ni.eq.0)   w0td3=-w0td3
          if(ni.eq.0)   w1td3=-w1td3
          vlop0=w0*w0td3                !d6-8
          vlop1=w1*w1td3
          list=list4(lri,lrd,lrj,lra)
        wl=vlop0*(vint_ci(list+2)-2*vint_ci(list+1))      !1.2
     :       -vlop1*vint_ci(list+2)
        call prodab(3,jpel,iwdl,iwdr,jwl,jwr,wl,jper)
        enddo
      enddo
      enddo

      return
      end

      subroutine sv_arbr_act_c_ext_stv_sgt0(lin)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
!sv(10-1) ar(13)br(23)  act -c"-  tv_ext -br-ar
      jmlr=mul_tab(jml,jmr)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
         if(lmij.ne.jmlr) cycle
!-------------------------------------------------------------------
          w0sv1=w0_sv(1)
          w1sv1=w1_sv(1)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0sv1=-w0sv1
            w1sv1=-w1sv1
         endif
          iwdl=just(lrj,lri)
          iwdr=0
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sv1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1sv1
          enddo
          if(lin.eq.10) then
            call ar_br_sv_ext_br_ar(lri,lrj)
          endif
          if(lin.eq.17) then
            call ar_br_tv_ext_br_ar(lri,lrj)
          endif
        enddo
      enddo

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DAVCRE(C,HC,HH,CC,E,HD,SC,Q,QQ,S,
     *                  SXSEL,NROOT,ITMAX,NDIM,ITERSX,NSXS)
C
C RASSCF program: version IBM-3090: SX section
C
C Using the Davidson method, in the multiple root version suggested
C by B.LIU. This routine finds the NROOT lowest eigenvalues and
C eigenvectors of a secular problem of dimension NDIM.
C This is a vectorized version adapted to run optimally on IBM 3090
C It is completely CPU bound (except maybe for the construction of
C the sigma vector). Multiple calls to this subroutine may therefore
C be necessary for cases where more iterations are needed than
C is allowed by the core space requirements to store all C and
C sigma vectors.
C
C Externals: HMAT (set up the Davidson H-matrix HH)
C            COVLP (calculate the overlap between two CI vectors)
C            Jacob (full diagonalization routine)
C            DGEMM and other ESSL routines for matrix operations
C Parameters: C  SuperCI-vectors
C             HC SuperCI Sigma vectors
C             HH Davidson's H-matrix
C             CC      "     eigenvectors
C             E       "     eigenvalues
C             HD diagonal elements of SuperCI
C             Q  the Davidson update vectors
C             QQ the norm of all Q-vectors
C             SC scratch area
C
C ********** IBM-3090 Release 88 09 08 *****
C
      use fciqmc, only : DoNECI
      IMPLICIT REAL*8 (A-H,O-Z)
#include "rasdim.fh"
#include "warnings.h"
#include "rasrc.fh"
#include "WrkSpc.fh"
#include "wadr.fh"
#include "output_ras.fh"
      Character*16 ROUTINE
      Parameter (ROUTINE='DAVCRE  ')
      CHARACTER*4 IOUTW,IOUTX
      DIMENSION C((NROOT+NSXS)*NROOT*(ITMAX+1))
      DIMENSION HC((NROOT+NSXS)*NROOT*ITMAX)
      DIMENSION HH((ITMAX*NROOT)*(ITMAX*NROOT+1))
      DIMENSION CC((ITMAX*NROOT)**2)
      DIMENSION E((ITMAX*NROOT))
      DIMENSION HD(NROOT+NSXS)
      DIMENSION SC((NROOT+NSXS))
      DIMENSION Q((NROOT+NSXS)*(NROOT+1))
      DIMENSION QQ(NROOT)
      DIMENSION S(ITMAX*NROOT**2)
      CHARACTER*(*) SXSEL
cvv   DATA THRA/1.D-13/,THRLD2/1.D-15/,THRQ/1.D-07/,THRZ/1.D-06/,
cvv   Thrld2 changed to 1.D-14 to avoid numerial unstabillity
      DATA THRA/1.D-13/,THRLD2/5.D-14/,THRQ/1.D-07/,THRZ/1.D-06/,
     &     THRLD1/1.D-08/
C
C Local print level (if any)
      IPRLEV=IPRLOC(1)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
C
      IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,*) 'Super-CI diagonalization. Max iterations: ',ITMAX
      END IF
C
C Set values at loop head and starting guess of the vectors C
C
      Rc_SX = 0
      NTRIAL=NROOT
      NCR=NROOT*NDIM
      CALL FZERO(C,NCR)
      II=0
      DO I=1,NROOT
        C(II+I)=1.0D0
        II=II+NDIM
      END DO
C
C  memory allocation for COVLP
C
       CALL GETMEM('SXC1','ALLO','REAL',LC1,NSXS)
       CALL GETMEM('SXC2','ALLO','REAL',LC2,NSXS)
       CALL GETMEM('SXX2','ALLO','REAL',LX,NSXS)
C
C Begin Davidson iterations
C Start by setting up the Davidson HH-matrix
C The dimension of this matrix, NDIMH, is updated in HMAT
C
      NDIMH=0
      ITERSX=0

**************************************************************
*               Head of Super-CI iteration loop:
**************************************************************
100   CONTINUE
      ITERSX=ITERSX+1
      CALL HMAT(C,HC,HH,HD,NDIM,NDIMH,NTRIAL)
      KDIMH=(NDIMH+NDIMH**2)/2
C
C Echo the HH-matrix before diagonalizing it.
C
      CALL DCOPY_(KDIMH,HH,1,HH(KDIMH+1),1)
C
      IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,*)' Davidson H-matrix in iteration ',ITERSX
        Write(LF,*)' Davidson H-matrix triangular of size =  ', NDIMH
        Write(LF,'(1x,8F14.6)') (HH(I),I=1,KDIMH)
      END IF
      E(1)=HH(1)
      CC(1)=1.d0
      IF(NDIMH.GT.1) THEN
C
C set eigenvector array to identity before JACO call
C
       NDIMH2=NDIMH**2
       CALL FZERO(CC,NDIMH2)
       II=-NDIMH
       DO I=1,NDIMH
        II=II+NDIMH+1
        CC(II)=1.0d0
       END DO
C
       CALL Jacob(HH(KDIMH+1),CC,NDIMH,NDIMH)
       IF(SXSEL.eq.'LOWEST  ') THEN
C Root selection here assumes picking the lowest root(s).
         CALL JACORD(HH(KDIMH+1),CC,NDIMH,NDIMH)
         II=0
         DO I=1,NROOT
          II=II+I
          E(I)=HH(II+KDIMH)
         END DO
       ELSE
C Root selection by maximum overlap.
         ISEL=1
         XMX=ABS(CC(1))
         DO I=2,NDIMH
          X=ABS(CC(1+NDIMH*(I-1)))
          IF(X.GT.XMX) THEN
            ISEL=I
            XMX=X
          END IF
         END DO
         IF(ISEL.NE.I) THEN
           DO I=1,NDIMH
             SWAP=CC(I+NDIMH*(ISEL-1))
             CC(I+NDIMH*(ISEL-1))=CC(I)
             CC(I)=-SWAP
           END DO
           SWAP=HH(KDIMH+(ISEL*(ISEL+1))/2)
           HH(KDIMH+(ISEL*(ISEL+1))/2)=HH(KDIMH+1)
           HH(KDIMH+1)=SWAP
         END IF
       END IF
C
       IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,*)' Eigenvalues:'
        Write(LF,'(1X,8F14.6)') (E(I),I=1,NROOT)
        Write(LF,*)' Eigenvectors:'
        NST=0
        DO I=1,NROOT
         Write(LF,'(1X,10F11.6)') (CC(J+NST),J=1,NDIMH)
         NST=NST+NDIMH
        END DO
       ENDIF
      ENDIF
C
C Now perform the Davidson update
C First form for each root I, a vector Q(I), where
C Q(I,K)=sum(J,M) CC(I,J,M)*(HC(M,J,K)-E(I)*C(M,J,K))
C here J runs over iterations and M over the number of trial
C vectors in each iterations E(I) is the current estimate of the
C energy of the I:th root, C(M,J) is the M:th trial vector used in
C the J:th iteration, HC being the corresponding sigma vector. CC
C is the matrix of eigenvectors of the Davidson Hamiltonian.
C
C STEP 1: form the matrix CCE=-CC*E (CCE in array SC)
      JI=0
      DO I=1,NROOT
       EI=E(I)
       DO J=1,NDIMH
        JI=JI+1
        S(JI)=-CC(JI)*EI
       END DO
      END DO
C
C Step 2: form the matrix Q=HC*CC
      CALL DGEMM_('N','N',
     &            NDIM,NROOT,NDIMH,
     &            1.0d0,HC,NDIM,
     &            CC,NDIMH,
     &            0.0d0,Q(NDIM+1),NDIM)
C Step 3: add the contribution C*CCE
      CALL DGEMM_('N','N',NDIM,NROOT,NDIMH,
     & 1.D0,C,NDIM,S,NDIMH,1.D0,Q(NDIM+1),NDIM)
C
C Note that the NDIM first positions in Q are untouched so far
C the vector will be moved later
      IF(IPRLEV.GE.INSANE) THEN
        Write(LF,*)' The residual vectors Q of size:', NDIM
        Write(LF,'(1x,8F14.10)')(Q(NDIM+I),I=1,NDIM)
      END IF
C
C Check the norms of the Q-vectors for convergence, and obtain
C bounds to the eigenvalues. E(I) is an upper bound to the I:th
C eigenvalue, from McDonald's theorem, while E(I)-NORM(Q(I))
C is a lower bound to the eigenvalue. This is the Weinstein lower
C bound formula in a multiple root form.
C
      ICONVQ=0
      IST=1+NDIM
      DO I=1,NROOT
       CALL COVLP(Q(IST),Q(IST),WORK(LDIA),WORK(LPA),WORK(LSXN),
     &            WORK(LC1),WORK(LC2),WORK(LX),QQ(I))
       IST=IST+NDIM
      END DO
C
      DO I=1,NROOT
          QNORM=SQRT(QQ(I))
          IF(QNORM.LT.THRQ)ICONVQ = ICONVQ + 1
          EI = E(I)
          ENO = EI - QNORM
          IF(NROOT.GT.1) THEN
            IF(I.GT.1) THEN
              IF(IPRLEV.GE.DEBUG) THEN
                Write(LF,'(20X,F16.8,A,I2,A,F16.8)') ENO,
     &                   ' <  SX energy ',I,'  < ',EI
              END IF
            ELSE
              IF(IPRLEV.GE.DEBUG) THEN
                Write(LF,'(1X,I2,A,4X,F16.8,A,I2,A,F16.8)')ITERSX,
     &               ' SX iteration ',ENO,' <  SX energy ',I,'  < ',EI
              END IF
            END IF
          ELSE
            IF(IPRLEV.GE.DEBUG) THEN
                Write(LF,'(1X,I2,A,4X,F16.8,A,I2,A,F16.8)')ITERSX,
     &               ' SX iteration ',ENO,' <  SX energy ',I,'  < ',EI
            END IF
          END IF
          IF(IPRLEV.GE.DEBUG) THEN
            Write(LF,*)'  Norm of Q:',QNORM
          END IF
          IST = IST + NDIM
      END DO
CPAM00 End of replacement.
C
C    Reset ICONVQ unless all roots are converged
C
      IF(ICONVQ.LT.NROOT) ICONVQ = 0
C
C    Check the expansion vectors for convergence. This is done
C    by computing the sum of the squares of CC(I,J), for each
C    root I, and for the J trial vectors of the current iteration
C
      NST = NDIMH - NTRIAL + 1
      ICONVA = 0
      DO I = 1,NROOT
          ASQ=DDOT_(NTRIAL,CC(NST),1,CC(NST),1)
          IF(ASQ.LT.THRA) ICONVA = ICONVA + 1
          NST = NST + NDIMH
      END DO
C
C    Reset ICONVA unless all roots are converged.
C
      IF(ICONVA.LT.NROOT) ICONVA = 0
C
C    Branch out of iteration loop if convergence has been
C....    achieved on either the energy or the Davidson expansion
C....    vectors.
C
      IF(ICONVQ.NE.0.OR.ICONVA.NE.0) GO TO 35
C
C Calculate the D-vectors as D(I,K)=Q(I,K)/(E(I)-HD(K,K))
C
      IST=1
      DO I=1,NROOT
       EI=E(I)
       DO K=1,NDIM
        SC(K)=EI-HD(K)
        IF(ABS(SC(K)).LT.THRZ) SC(K)=1.0d0
       END DO
       Q(IST:IST+NDIM-1) = Q(IST+NDIM:IST+2*NDIM-1)/SC(1:NDIM)
       IST=IST+NDIM
      END DO
C Remove any unwanted components. These are signalled by
C huge elements of SX hamiltonian diagonal (set in SXHAM).
      DO I=1,NDIM
       IF(HD(I).GT.1.0D20) THEN
         DO J=1,NROOT
           Q(I+NDIM*(J-1))=0.0D0
         END DO
       END IF
      END DO
      IF(IPRLEV.GE.INSANE) THEN
        Write(LF,*)' The correction vectors D(stored in Q):'
        Write(LF,'(1x,8F14.10)')(Q(I),I=1,NDIM)
      END IF
C
C Q now contains the Davidson correction vectors. These will now
C be orthogonalized to all old vectors and then to each other.
CPAM01 The ON is done in two passes. A vector smaller than THRLD
C after the first ON pass is considered to contribute nothing worthwhile
C to the Davidson procedure, and is discarded. Else, it is normalized.
C If it is not still normalized to within an accuracy THRLD after the
C second pass, then again it is discarded: it means that the rescaling
C after pass 1, together with numerical noise amplification in
C COVLP, is beginning to be noticable. The latter will of course happen
C when some orbital rotation(s) are almost redundant.
C
      IPASS=0
      ICONVL=0
      NTOTDC=NROOT

 23   CONTINUE

C First form the overlap matrix
      IJ=0
      ISTQ=1
      DO I=1,NTOTDC
       ISTC=1
       DO J=1,NDIMH
        IJ=IJ+1
        CALL COVLP(Q(ISTQ),C(ISTC),WORK(LDIA),WORK(LPA),WORK(LSXN),
     &  WORK(LC1),WORK(LC2),WORK(LX),OVL)
        S(IJ)=-OVL
        ISTC=ISTC+NDIM
       END DO
       ISTQ=ISTQ+NDIM
      END DO
      CALL DGEMM_('N','N',NDIM,NTOTDC,NDIMH,
     &           1.D0,C,NDIM,S,NDIMH,
     &           1.D0,Q,NDIM)
C
C The Q-vectors are now orthogonal to all C-vectors.
      IF(IPRLEV.GE.INSANE) THEN
        Write(LF,*)'  D vector orthogonal to all C vectors:'
        Write(LF,'(1x,8F14.10)')(Q(I),I=1,NDIM)
      END IF
C Now orthogonalize them to one another, rejecting those which
C appear with too small a norm
C
      IST=1
      NTRIAL=0

* Long loop over NTOTDC vectors:
      DO I=1,NTOTDC
       IF(I.NE.1.AND.NTRIAL.NE.0) THEN
C
C  Orthogonalize this vector to the preceeding Q's of this iteration
C
        JST=1
        DO J=1,NTRIAL
         CALL COVLP(Q(IST),Q(JST),WORK(LDIA),WORK(LPA),WORK(LSXN),
     *              WORK(LC1),WORK(LC2),WORK(LX),OVL)
         S(J)=-OVL
         JST=JST+NDIM
        END DO
*        CALL DGEMX(NDIM,NTRIAL,1.D0,Q,NDIM,S,1,Q(IST),1)
        CALL DGEMV_('N',NDIM,NTRIAL,1.D0,Q,NDIM,S,1,1.0D0,Q(IST),1)
       IF(IPRLEV.GE.INSANE) THEN
          Write(LF,*)'  Q vector orthogonal to preceeding Q vectors:'
          Write(LF,'(1x,8F14.10)')(Q(k),k=1,NDIM)
       END IF
       ENDIF
C
C  Normalize this vector and move to trial set if norm large enough
C
       CALL COVLP(Q(IST),Q(IST),WORK(LDIA),WORK(LPA),WORK(LSXN),
     *            WORK(LC1),WORK(LC2),WORK(LX),XNORM)
C Due to large noise amplification in COVLP, the squared-norm
C can actually come out as a negative number.
C Acceptable, only if it is very close to zero. Else, quit.
       IF(XNORM.LT.-1.0D-09)  then
         Write(LF,*)
         Write(LF,*)'      *** Error in subroutine DAVCRE ***'
         Write(LF,*)' The squared norm of a trial vector has been'
         Write(LF,*)' computed to be negative:'
         Write(LF,*)'      XNORM=',XNORM
         Write(LF,*)' This is possible only for some severe malfunction'
         Write(LF,*)' of the rasscf program. Please issue a bug report.'
         Write(LF,*)
         if (.not. DoNECI) then
           Call Quit(_RC_GENERAL_ERROR_)
         else
           Write(LF,*)' non positive-semi definite matrix occurred.'
           Write(LF,*)' Calculation will continue. '
           Write(LF,*)' Divergent results might occur'
           Write(LF,*)' Tests for possible solution on the way...'
         end if
       End iF
       XNORM=sqrt(MAX(0.0D0,XNORM))
       IF(IPRLEV.GE.INSANE) THEN
         Write(LF,'(1X,A,I3,A,I3,A,E16.8)') 'Pass ',IPASS,
     &                 ' New orthogonal vector ',I,' has norm ',XNORM
       END IF

CPAM01 Two different treatments, depending on if this is first or
C second orthonormalization pass:
       IF(IPASS.EQ.0) THEN
C First pass:
         IF(ITERSX.EQ.1 .or. XNORM.GT.THRLD1) THEN
          ISTQ=NTRIAL*NDIM+1
          NTRIAL=NTRIAL+1
          XNORM=1.0D00/(XNORM+1.0D-24)
CPAM01 Note that ISTQ can be (and is!) the same as IST:
          IF(ISTQ.EQ.IST) THEN
           CALL DSCAL_(NDIM,XNORM,Q(IST),1)
          ELSE
           CALL DYAX(NDIM,XNORM,Q(IST),1,Q(ISTQ),1)
          ENDIF
         ENDIF
       ELSE
C Second pass: Demand accurate normalization, else we know that
C poor independence, maybe with strong rounding-error amplification
C in COVLP, has began to erode the orthonormalization of the
C basis vectors, hence the integrity of the Davidson procedure.
         IF(ITERSX.EQ.1 .or. ABS(XNORM-1.0D0).LT.THRLD2) THEN
          ISTQ=NTRIAL*NDIM+1
          NTRIAL=NTRIAL+1
          XNORM=1.0D00/(XNORM+1.0D-24)
CPAM01 Note that ISTQ can be (and is!) the same as IST:
          IF(ISTQ.EQ.IST) THEN
           CALL DSCAL_(NDIM,XNORM,Q(IST),1)
          ELSE
           CALL DYAX(NDIM,XNORM,Q(IST),1,Q(ISTQ),1)
          ENDIF
         ENDIF
       END IF
       IST=IST+NDIM

* End over long loop over NTOTDC vectors I=1..NTOTDC
      END DO
C
C NTRIAL new orthogonal vectors have now been formed. if NTRIAL
C equals zero there are no new linearly independent trial vectors
C and we branch out. If NTRIAL does not equal zero make a second
C orthonormalization pass
C
      IF(NTRIAL.EQ.0) ICONVL=1
      NTOTDC=NTRIAL
      IPASS=IPASS+1
      IF(IPASS.NE.2.AND.NTOTDC.NE.0) GO TO 23
      IF(IPRLEV.GE.INSANE) THEN
        Write(LF,*)' The correction vectors, after ON:'
        Write(LF,'(1x,8F14.10)')(Q(I),I=1,NDIM*NTRIAL)
      END IF
C
C Check if the set of vectors has become linearly dependent
C
      IF(ICONVL.EQ.1) GO TO 36
C
C Move the new orthogonal vectors to C
C
      NST=1+NDIMH*NDIM
      LENGTH=NTRIAL*NDIM
      CALL DCOPY_(LENGTH,Q,1,C(NST),1)
C
      IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,'(1X,A,I2,A)') ' Adding ',NTRIAL,' new vectors.'
      END IF
      IF(IPRLEV.GE.INSANE) THEN
       IST = NDIMH*NDIM
       DO I = 1,NTRIAL
          Write(LF,'(1X,A,I2,A)') ' New vector ',I,' is:'
          Write(LF,'(1X,10F11.6)') (C(IST+K),K = 1,NDIM)
          IST = IST + NDIM
       END DO
      ENDIF
C
C    At this point, the calculation has neither converged, nor
C    produced linearly dependent trial vectors. Branch back to
C    the head of the iteration loop unless more than ITMAX
C    iterations have been performed.
C
      IF(ITERSX.LT.ITMAX) GO TO 100
C
C Here after ITMAX iterations, and no convergence
C
      IF(IPRLEV.GE.DEBUG) THEN
       IF(ITMAX.LT.MXSXIT) THEN
        Write(LF,*)' Super-CI not converged. Max SX iter increased.'
       ELSE
        Write(LF,*)' Super-CI not converged.'
       END IF
      END IF
      ITMAX=min(ITMAX+2,MXSXIT)
      Rc_SX = 16
      GO TO 34
C
C Here as calculation has converged.
C
35    CONTINUE
      IOUTW = 'y   '
      IF(NROOT.GT.1) IOUTW = 'ies '
      IOUTX = '    '
      IF(NROOT.GT.1) IOUTX = 's   '
      IF(ICONVQ.NE.0.AND.IPRLEV.GE.DEBUG) THEN
         Write(LF,*) ' Convergence on CI energ'//IOUTW
      END IF
      IF(ICONVA.NE.0.AND.IPRLEV.GE.DEBUG) THEN
         Write(LF,*) ' Convergence on Davidson expansion vector'//IOUTX
        Write(LF,*) IOUTX
      END IF
      GO TO 34
C
C Here as trial vectors have become linearly dependent
C
36    CONTINUE
      IF(IPRLEV.GE.DEBUG) THEN
        Write(LF,*)' Trial vector set has become linearly dependent'
      END IF
34    CONTINUE
C
C Compute CI vectors for all roots
C
C CI NEW (K) =  sum(J,M)CC(I,J M)*C M J (K)
C
C Here J runs over the iterations, and M over the
C number of trial vectors used in each iteration J
C
      CALL DGEMM_('N','N',
     &            NDIM,NROOT,NDIMH,
     &            1.0d0,C,NDIM,
     &            CC,NDIMH,
     &            0.0d0,Q,NDIM)
      IF(IPRLEV.GE.INSANE) THEN
        Write(LF,*)' Unnormalized final CI vectors (in Q):'
        Write(LF,'(1x,8F14.10)')(Q(I),I=1,NDIM)
      END IF
C
C Normalize the final CI vectors
C
      IST=1
      DO I=1,NROOT
       CALL COVLP(Q(IST),Q(IST),WORK(LDIA),WORK(LPA),WORK(LSXN),
     * WORK(LC1),WORK(LC2),WORK(LX),XNORM)
       XNORM=1.0D00/XNORM
       CALL DYAX(NDIM,XNORM,Q(IST),1,C(IST),1)
       IST=IST+NDIM
      END DO
C
C Print vector if desired
C
      IF(IPRLEV.GE.INSANE) THEN
       IST = 0
       DO I = 1,NROOT
          Write(LF,*) ' SX-CI vector for root ',I
          Write(LF,'(1X,8F8.4)') (C(IST+K),K = 1,NDIM)
          IST = IST + NDIM
       END DO
      ENDIF
C
C End of diagonalization
C Free memory for COVLP
C
      CALL GETMEM('XXXX','FREE','REAL',LC1,NSXS)
      CALL GETMEM('XXXX','FREE','REAL',LC2,NSXS)
      CALL GETMEM('XXXX','FREE','REAL',LX,NSXS)
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
************************************************************************
*                                                                      *
*  Subroutine Shell_MxSchwz:  gets max integral estimates for each     *
*                             shell pair...                            *
*                                                                      *
************************************************************************
      SubRoutine Shell_MxSchwz(nSkal,Schwz_Shl)
c----------------------------------------------------------------------
      use k2_setup
      use k2_arrays
      use iSD_data
      use Basis_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      Integer nSkal
      Real*8 Schwz_Shl(nSkal,nSkal)
*
#include "ndarray.fh"
#include "real.fh"
#include "nsd.fh"
#include "setup.fh"
*
      nElem(i)=(i+1)*(i+2)/2
      nabSz(ixyz) = (ixyz+1)*(ixyz+2)*(ixyz+3)/6  - 1
*
c     Call GetMem('_scf','List','Real',iDum,iDum)
*     loop over shell pair...
      call dcopy_(nSkal*nSkal,[Zero],0,Schwz_Shl,1)
      Do iS = 1, nSkal
        iShll= iSD( 0,iS)
        If (Shells(iShll)%Aux .and. iS.ne.nSkal) Go To 100
        iShell=iSD(11,iS)
        iPrimi=iSD( 5,iS)
        iCmp=iSD(2,iS)
        iAng=iSD(1,iS)
        iCnttp=iSD(13,iS)
        Do jS = 1, iS
          jShll= iSD( 0,jS)
          If (Shells(iShll)%Aux.and..Not.Shells(jShll)%Aux) Go To 200
          If (Shells(jShll)%Aux .and. jS.eq.nSkal) Go To 200
C         Write (*,*) 'Shell_..:iS,jS=',iS,jS
          jShell=iSD(11,jS)
          jPrimj=iSD( 5,jS)
          jCmp=iSD(2,jS)
          jAng=iSD(1,jS)
          jCnttp=iSD(13,jS)
          nZeta=iPrimi*jPrimj
          If (iShell.ge.jShell) Then
            ijS = iShell*(iShell-1)/2 + jShell
          Else
            ijS = jShell*(jShell-1)/2 + iShell
          End If
          k2ij  = Indk2(1,ijS)
          nDCRR = Indk2(2,ijS)
C         Write (*,*) 'nDCRR=',nDCRR
          ijCmp=nElem(iAng)*nElem(jAng)
          If (.Not.DoGrad_) ijCmp=0
          nHm=iCmp*jCmp*(nabSz(iAng+jAng)-nabSz(Max(iAng,jAng)-1))
          nHm=nHm*nIrrep
          If (DoHess_) nHm=0
*         i9    = ip_abMax(nZeta)-1
          i9    = ip_EstI(nZeta)-1
          i10   = nZeta*(nDArray+2*ijCmp)+nDScalar+nHm
*         now loop over  R operator...
          If (dbsc(iCnttp)%fMass.eq.dbsc(jCnttp)%fMass) Then
             Schwz_tmp=Data_k2(k2ij+i9)
             Do lDCRR = 1, nDCRR-1
                Schwz_tmp=Max(Schwz_tmp,Data_k2(k2ij+i10*lDCRR+i9))
             End Do
          Else
             Schwz_tmp=0.0D0
          End If
          Schwz_Shl(jS,iS)=Schwz_tmp
          Schwz_Shl(iS,jS)=Schwz_tmp
 200      Continue
        End Do
 100    Continue
      End Do
*     Call RecPrt('Schwz_shl',' ',Schwz_Shl,nSkal,nSkal)
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

module Trnsfrm

use Definitions, only: iwp

implicit none
private

integer(kind=iwp) :: IAPR(8), ISP, ISQ, ISR, ISS, LMOP1, LMOQ1, LMOR1, LMOS1, NAP, NAQ, NAR, NAS, NAVX, NBP, NBPQ, NBQ, NBR, NBRS, &
                     NBS, NVXPQ, NX1MX, NX2MX, NX3MX

public :: IAPR, ISP, ISQ, ISR, ISS, LMOP1, LMOQ1, LMOR1, LMOS1, NAP, NAQ, NAR, NAS, NAVX, NBP, NBPQ, NBQ, NBR, NBRS, NBS, NVXPQ, &
          NX1MX, NX2MX, NX3MX

end module Trnsfrm

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine RelEne(ErelMV,ErelDC,nSym,nBas,CMO,OCC,D,OP)
!***********************************************************************
!                                                                      *
!     Purpose: Compute relativistic correction to energy for a given   *
!              set of natural orbitals and occupation numbers          *
!                                                                      *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use OneDat, only: sNoNuc, sNoOri, sOpSiz
use Constants, only: Zero, Two
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(out) :: ErelMV, ErelDC
integer(kind=iwp), intent(in) :: nSym, nBas(*)
real(kind=wp), intent(in) :: CMO(*), OCC(*)
real(kind=wp), intent(_OUT_) :: D(*), OP(*)
integer(kind=iwp) :: iBas, iComp, ij, iOff1, iOff2, iOff3, iOpt, iOrb, iRc, iSyLbl, iSym, jBas, lOp, nBs
character(len=8) :: Label
real(kind=wp), external :: DDOT_

!----------------------------------------------------------------------*
! Compute 1-particle density matrix in AO basis                        *
!----------------------------------------------------------------------*
ij = 0
iOff1 = 0
iOff2 = 0
do iSym=1,nSym
  nBs = nBas(iSym)
  if (nBs == 0) cycle
  do iBas=1,nBs
    do jBas=1,iBas
      ij = ij+1
      D(ij) = Zero
      do iOrb=1,nBs
        iOff3 = iOff1+(iOrb-1)*nBs
        D(ij) = D(ij)+OCC(iOff2+iOrb)*CMO(iBas+iOff3)*CMO(jBas+iOff3)
      end do
      if (iBas /= jBas) D(ij) = Two*D(ij)
    end do
  end do
  iOff1 = iOff1+nBs*nBs
  iOff2 = iOff2+nBs
end do
!----------------------------------------------------------------------*
! Compute energy contributions                                         *
!----------------------------------------------------------------------*
lOp = 0
do iSym=1,nSym
  nBs = nBas(iSym)
  lOp = lOp+nTri_Elem(nBs)
end do
ErelMV = Zero
iRc = -1
iOpt = ibset(0,sOpSiz)
iComp = 1
Label = 'MassVel'
call RdOne(iRc,iOpt,Label,iComp,OP,iSyLbl)
if (iRc == 0) then
  iRc = -1
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  iComp = 1
  call RdOne(iRc,iOpt,Label,iComp,OP,iSyLbl)
  ErelMV = DDOT_(lOP,D,1,OP,1)
end if
ErelDC = Zero
iRc = -1
iOpt = ibset(0,sOpSiz)
iComp = 1
Label = 'Darwin'
call RdOne(iRc,iOpt,Label,iComp,OP,iSyLbl)
if (iRc == 0) then
  iRc = -1
  iOpt = ibset(ibset(0,sNoOri),sNoNuc)
  iComp = 1
  call RdOne(iRc,iOpt,Label,iComp,OP,iSyLbl)
  ErelDC = DDOT_(lOP,D,1,OP,1)
end if

!----------------------------------------------------------------------*
! Exit                                                                 *
!----------------------------------------------------------------------*
return

end subroutine RelEne

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996, Martin Schuetz                                   *
************************************************************************
      SubRoutine ChkTrD(nSym,nBas,nOrb,Occ,Dlt,Ovl)
************************************************************************
*                                                                      *
*     purpose: Compute trace of density matrix and compare with sum    *
*              over occupation numbers...                              *
*                                                                      *
*     input:                                                           *
*       nSym    : number of symmetries                                 *
*       nBas(i) : number of basis functions (i = 1, nSym)              *
*       Occ     : occupation numbers                                   *
*       Dlt     : density matrix in triangular storrage                *
*       Ovl     : overlap matrix                                       *
*                                                                      *
*     called from: ??????                                              *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1996                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history: none                                                    *
*                                                                      *
************************************************************************
*
      Implicit Real*8 (a-h,o-z)
*
*     declaration of subroutine parameters...
      Real*8 Occ(*),Dlt(*),Ovl(*)
      Integer nBas(nSym),nOrb(nSym)
*
*     declaration of some local variables...
      Real*8 ThrDif
      Data ThrDif /1.0d-7/
*
#include "real.fh"
*
      ipDlt = 1
      ipOvl = 1
      ipOcc = 0
      Scale= One
      Do iSym = 1, nSym
        nBs = nBas(iSym)
        nOr = nOrb(iSym)
        lth = nBs*(nBs + 1)/2
*       count occupation number...
        SumOcc=Zero
        Do iOr = 1, nOr
          SumOcc=SumOcc+Occ(ipOcc+iOr)*Scale
        End Do
*       do trace of PS for symmetry block...
        TrDns=DDOT_(lth,Dlt(ipDlt),1,Ovl(ipOvl),1)
        ipDlt = ipDlt+lth
        ipOvl = ipOvl+lth
        ipOcc = ipOcc+nOr
        If (Abs(SumOcc-TrDns).gt.ThrDif) Then
*         print Warning...
          Call WarningMessage(1,
     &   'WARNING: trace of density is inconsistent with occupation !')
          Write(6,'(A,I1,A,3F12.7)') 'SymBlock: ',iSym,' deviation: ',
     &     SumOcc-TrDns,SumOcc,TrDns
        End If
      End Do
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine MKWWOPC(IVEC,JVEC,OP1,NOP2,OP2,NOP3,OP3)
! Presently symmetry blocking is disregarded, but index pair
! permutation symmetry is used.
! NOP2=(NASHT**2+1 over 2)  (Binomial coefficient)
! NOP3=(NASHT**2+2 over 3)  (Binomial coefficient)

! Given the coefficients for two excitation operators of the
! type ATVX = Case C, available in vectors numbered IVEC and
! JVEC on file, construct the zero-, one-, two-, and three-body
! expansions of the product (Op in IVEC conjugated)(Op in JVEC)
! as operating on the CASSCF space.
! Formula used:
!  W1(tuv,a)(conj)*W2(xyz,b) = dab * ( Evutxyz +dyu Evztx
!                       + dyx Evutz + dtu Evxyz + dtu dyx Evz )

use Index_Functions, only: iTri, nTri_Elem, nTri3_Elem
use SUPERINDEX, only: MTUV
use EQSOLV, only: MODVEC
use caspt2_module, only: NASHT, NASUP, NINDEP, NISUP, NSYM, NTUVES
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: IVEC, JVEC, NOP2, NOP3
real(kind=wp), intent(inout) :: OP1(NASHT,NASHT), OP2(NOP2), OP3(NOP3)
integer(kind=iwp) :: ICASE, IIEND, IISTA, ISCT, ISYM, ITABS, ITUV, ITUVABS, ITUVEND, ITUVSTA, ITX, ITZ, IUABS, IVABS, IVU, IVX, &
                     IVZ, IW1, IW2, IWPROD, IXABS, IXYZ, IXYZABS, IXYZEND, IXYZSTA, IYABS, IYZ, IZABS, JTX, JVU, JVUTXYZ, JVUTZ, &
                     JVXYZ, JVZTX, JYZ, LW1A, LW2A, MDVEC, MWS1, MWS2, NAS, NCOL, NIS, NWPROD, NWSCT
real(kind=wp) :: W_PROD
real(kind=wp), allocatable :: W1(:), W2(:), WPROD(:)

ICASE = 4
! Loop over symmetry ISYM
do ISYM=1,NSYM
  NAS = NASUP(ISYM,ICASE)
  NIS = NISUP(ISYM,ICASE)
  if (NINDEP(ISYM,ICASE) == 0) cycle
  ! Allocate space for one section of excitation amplitudes:
  MDVEC = MODVEC(ISYM,ICASE)
  call mma_allocate(W1,NAS*MDVEC,Label='W1')
  call mma_allocate(W2,NAS*MDVEC,Label='W2')
  NWSCT = min(NAS,1000)
  NWPROD = NWSCT**2
  ! Allocate space for the contraction:
  call mma_allocate(WPROD,NWPROD,Label='WPROD')
  ! Sectioning loop added:
  ISCT = 0
  do IISTA=1,NIS,MDVEC
    ISCT = ISCT+1
    IIEND = min(IISTA-1+MDVEC,NIS)
    NCOL = 1+IIEND-IISTA
    call RDSCTC(ISCT,ISYM,ICASE,IVEC,W1,NAS*MDVEC)
    call RDSCTC(ISCT,ISYM,ICASE,JVEC,W2,NAS*MDVEC)
    ! Loop over sections of WW1 and WW2:
    do ITUVSTA=1,NAS,NWSCT
      LW1A = ITUVSTA
      ITUVEND = min(ITUVSTA-1+NWSCT,NAS)
      MWS1 = ITUVEND+1-ITUVSTA
      do IXYZSTA=1,NAS,NWSCT
        IXYZEND = min(IXYZSTA-1+NWSCT,NAS)
        LW2A = IXYZSTA
        MWS2 = IXYZEND+1-IXYZSTA
        ! Multiply WProd = (W1 sect )*(W2 sect transpose)
        WPROD(:) = Zero
        call DGEMM_('N','T',MWS1,MWS2,NCOL,One,W1(LW1A),NAS,W2(LW2A),NAS,One,WPROD,NWSCT)

        ! Loop over (TUV) in its section
        do ITUV=ITUVSTA,ITUVEND
          IW1 = ITUV+1-ITUVSTA
          ITUVABS = ITUV+NTUVES(ISYM)
          ITABS = MTUV(1,ITUVABS)
          IUABS = MTUV(2,ITUVABS)
          IVABS = MTUV(3,ITUVABS)
          IVU = IVABS+NASHT*(IUABS-1)
          ! Loop over (XYZ) in its section
          do IXYZ=IXYZSTA,IXYZEND
            IW2 = IXYZ+1-IXYZSTA
            IXYZABS = IXYZ+NTUVES(ISYM)
            IXABS = MTUV(1,IXYZABS)
            IYABS = MTUV(2,IXYZABS)
            IZABS = MTUV(3,IXYZABS)
            ITX = ITABS+NASHT*(IXABS-1)
            IYZ = IYABS+NASHT*(IZABS-1)
            IWPROD = IW1+NWSCT*(IW2-1)
            W_PROD = WPROD(IWPROD)
            ! Remember:
            !  W1(tuv,a)(conj)*W2(xyz,b) = dab * ( Evutxyz + dyu Evztx + dyx Evutz + dtu Evxyz + dtu dyx Evz )
            ! Contrib to 3-particle operator:
            if (IVU < ITX) then
              if (IVU >= IYZ) then
                JVU = ITX
                JTX = IVU
                JYZ = IYZ
              else if (ITX < IYZ) then
                JVU = IYZ
                JTX = ITX
                JYZ = IVU
              else
                JVU = ITX
                JTX = IYZ
                JYZ = IVU
              end if
            else
              if (IVU < IYZ) then
                JVU = IYZ
                JTX = IVU
                JYZ = ITX
              else if (ITX >= IYZ) then
                JVU = IVU
                JTX = ITX
                JYZ = IYZ
              else
                JVU = IVU
                JTX = IYZ
                JYZ = ITX
              end if
            end if
            JVUTXYZ = nTri3_Elem(JVU-1)+nTri_Elem(JTX-1)+JYZ
            OP3(JVUTXYZ) = OP3(JVUTXYZ)+WPROD(IWPROD)
            ! Contrib to 2-particle operator, from  dyu Evztx:
            if (IYABS == IUABS) then
              IVZ = IVABS+NASHT*(IZABS-1)
              ITX = ITABS+NASHT*(IXABS-1)
              JVZTX = iTri(IVZ,ITX)
              OP2(JVZTX) = OP2(JVZTX)+W_PROD
            end if
            ! Contrib to 2-particle operator, from  dyx Evutz:
            if (IYABS == IXABS) then
              IVU = IVABS+NASHT*(IUABS-1)
              ITZ = ITABS+NASHT*(IZABS-1)
              JVUTZ = iTri(IVU,ITZ)
              OP2(JVUTZ) = OP2(JVUTZ)+W_PROD
            end if
            ! Contrib to 2-particle operator, from  dtu Evxyz:
            if (ITABS == IUABS) then
              IVX = IVABS+NASHT*(IXABS-1)
              IYZ = IYABS+NASHT*(IZABS-1)
              JVXYZ = iTri(IVX,IYZ)
              OP2(JVXYZ) = OP2(JVXYZ)+W_PROD
              ! Contrib to 1-particle operator, from  dtu dyx Evz:
              if (IYABS == IXABS) OP1(IVABS,IZABS) = OP1(IVABS,IZABS)+W_PROD
            end if
          end do
        end do
      end do
    end do
    ! Extra sectioning loop added...
  end do
  ! Deallocate temporary space:
  call mma_deallocate(W1)
  call mma_deallocate(W2)
  call mma_deallocate(WPROD)
end do

end subroutine MKWWOPC

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Bingbing Suo                                     *
************************************************************************
c 11 feb 2007 -bsuo- added by suo bing
c                    this file contains subroutines which depend on plat
      subroutine version_info
#include "drt_h.fh"

      write(6,'(10x,a42)')'*****************************************'
      write(6,'(10x,a42)')'*      Xian-ci mrci program             *'
      write(6,'(10x,a42)')'*     Institute of Modern Physics       *'
      write(6,'(10x,a42)')'*        Northwest University           *'
      write(6,'(10x,a42)')'*        xian, shaanxi, china           *'
      write(6,'(10x,a42)')'*                                       *'
      write(6,'(10x,a42)')'*        report bugs and errors         *'
      write(6,'(10x,a42)')'*           wzy@nwu.edu.cn              *'
      write(6,'(10x,a42)')'*        yubin_wang@hotmail.com         *'
      write(6,'(10x,a42)')'*       bingbing_suo@hotmail.com        *'
      write(6,'(10x,a42)')'*                                       *'
      write(6,'(10x,a42)')'*****************************************'
      write(6,*)
      write(6,*)

      call get_date()

      return
      end

      subroutine get_date()
#ifdef _XIANEST_
      character*64 date
      call fdate(date)
#endif
#ifdef MOLPRO
#else
      call datimm()
#endif
      return
      end

c************************************************
      subroutine allocate_int_memory()
c************************************************
#include "drt_h.fh"
c     this subroutine is used to allocate the dynamic memory
c     for integrals
c vint_ci(:) pointer to the base address of the memory of integrals
c maxintseg  maximum length of the integral segment
c
      allocate(vint_ci(0:maxintseg+1))
      vint_ci=0.d0
      return
c...end of allocate_int_memory
      end

c************************************************
      subroutine deallocate_int_memory()
c************************************************
#include "drt_h.fh"

      deallocate(vint_ci)
      return
c...end of deallocate_int_memory
      end


      subroutine read_ml(nf,i,bv,n,m)
      implicit REAL*8 (a-h,o-z)
      dimension bv(n)
      dimension irec(64)

      idisk=0
      call idafile(nf,2,irec,64,idisk)
      idisk=irec(m)
      call ddafile(nf,2,bv,n,idisk)

c      select case (nf)
c        case(34)
c          call ddafile(nf,2,bv,n,idisk)
c        case(35)
c          call ddafile(nf,2,bv,n,idisk)
c        case default

c      end select

      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(i)
      end

      subroutine write_ml(nf,i,bv,n,m)
      implicit REAL*8 (a-h,o-z)
      dimension bv(n)
      dimension irec(64)

      idisk=0
      if(m.eq.1) then
        irec=0
        call idafile(nf,1,irec,64,idisk)
        irec(1)=idisk
      else
        call idafile(nf,2,irec,64,idisk)
      endif

      idisk=irec(m)
      call ddafile(nf,1,bv,n,idisk)
c
c      select case (nf)
c        case(34)
c          call ddafile(nf,1,bv,n,idisk)
c        case(35)
c          call ddafile(nf,1,bv,n,idisk)
c        case default

c      end select
      irec(m+1)=idisk
      idisk=0
      call idafile(nf,1,irec,64,idisk)
c      print*,"idisk",m,idisk
      return
c Avoid unused argument warnings
      if (.false.) call Unused_integer(i)
      end

      subroutine write_bv(nf,i,bv,n)
      implicit REAL*8 (a-h,o-z)
      dimension bv(n)

      call write_ml(nf,1,bv,n,i)

      return
      end

      subroutine read_bv(nf,i,bv,n)
      implicit REAL*8 (a-h,o-z)
      dimension bv(n)

      call read_ml(nf,1,bv,n,i)

      return
      end

c***************************************
      subroutine readint(ntyp,vintrd)
c***************************************
      implicit REAL*8 (a-h,o-z)
c
c     subroutine used to read divided integrals into
c     main memeroy
c on entry:
c -----------------
c ntyp   - integral type need to be readed
c   1 internal space integrals
c   2 integrals which have one or three indexs in external space
c   3 integrals which have two indexs in external space
c   4 external space integrals
c on out:
c -------------------
c vintrd(*) - integrals used in hamitonian matrix calculation
c
#include "files_gugaci.fh"
      dimension vintrd(*)
      dimension idx(4)
      dimension idum(1)

      idx=0
      idisk=0
      call idafile(luciint,2,idx,4,idisk)
      select case (ntyp)
        case (1)
          idisk=idx(1)
          call idafile(luciint,2,idum,1,idisk)
          lenint=idum(1)
          call ddafile(luciint,2,vintrd(2),lenint,idisk)
        case (2)
c internal external space 1 and 3 index integrals
          idisk=idx(2)
          call idafile(luciint,2,idum,1,idisk)
          lenint=idum(1)
          call ddafile(luciint,2,vintrd(2),lenint,idisk)
          !write(6,*) vintrd(1:lenint)
        case (3)
c interner external space 2 index integrals
          idisk=idx(3)
          call idafile(luciint,2,idum,1,idisk)
          lenint=idum(1)
          call ddafile(luciint,2,vintrd(2),lenint,idisk)
        case (4)
c external space intergrals
          idisk=idx(4)
          call idafile(luciint,2,idum,1,idisk)
          lenint=idum(1)
          call ddafile(luciint,2,vintrd(2),lenint,idisk)
      endselect

      !  do i=1,lenint+1
      !    write(12,"(i8,1x,f15.8)") i,vintrd(i)
      !  enddo
      return
c...end of readint
      end

      subroutine gugaciinit
      !include "comfile.fh"
#ifdef MOLPRO
      use file_qininit
      use molegeom
      use groupinfo
      use orbinfo
#endif
#include "drt_h.fh"
#include "files_gugaci.fh"
#ifdef MOLPRO
      integer :: noffset(maxrecord)
#endif

#ifdef MOLPRO
#else
      fnonemo="traone"
#endif
      fntwomo="traint"
      fndrt="cidrt"
      fnciint="ciint"
      fnloop="ciloop"
      fncidia="cidia"
      fncivec="civec"
      fncitv1="citv1"
      fncitv2="citv2"
      fnciden="ciden"
      fncimo="cimo"

      luonemo=30
      lutwomo=50
      ludrt=31
      luciint=32
      luloop=33
      lucidia=34
      lucivec=35
      lucitv1=36
      lucitv2=37
      luciden=38
      lucimo=39
#ifdef MOLPRO
#else
      call daname(ludrt,fndrt)
      call daname(luciint,fnciint)
      call daname(luloop,fnloop)
      call daname(lucidia,fncidia)
      call daname(lucivec,fncivec)
      call daname(lucitv1,fncitv1)
      call daname(lucitv2,fncitv2)
      call daname(luciden,fnciden)
      call daname(lucimo,fncimo)
#endif
#ifdef _XIANEST_
!open chkfile and drt file
      call fileopen(nfchk,anchk,11)
      call chkfil_taskctrl(2)  ! read task information

      nreps=0
!read infomation from checkfile and moint file
      call chkfil_ciorbinf(2)
      nlsm_bas(1:8)=nsbas(1:8)
      nlsm_all(1:8)=nsorb(1:8)
      ng_sm=nreps

      call fileopen(ludrt,fndrt,12)
      call fileopen(luciint,fnciint,12)
      call fileopen(luloop,fnloop,12)
      call fileopen(lucidia,fncidia,12)
      call fileopen(lucivec,fncivec,12)
      call fileopen(lucitv1,fncitv1,12)
      call fileopen(lucitv2,fncitv2,12)
      call fileopen(luciden,fnciden,12)
      call fileopen(lucimo,fncimo,12)
      call fileopen(lutwomo,fntwomo,12)
#endif

      return
      end

      subroutine gugafinalize
      implicit REAL*8 (a-h,o-z)
#include "files_gugaci.fh"
#ifdef MOLPRO
      call fileclos(ludrt,12)
      call fileclos(luciint,12)
      call fileclos(luloop,12)
      call fileclos(lucidia,12)
      call fileclos(lucivec,12)
      call fileclos(lucitv1,12)
      call fileclos(lucitv2,12)
      call fileclos(luciden,12)
      call fileclos(lucimo,12)
      call fileclos(lutwomo,12)
#else
      call daclos(ludrt)
      call daclos(luciint)
      call daclos(luloop)
      call daclos(lucidia)
      call daclos(lucivec)
      call daclos(lucitv1)
      call daclos(lucitv2)
      call daclos(luciden)
      call daclos(lucimo)
#endif
      return
      end

      subroutine memdengrad_alloc()
#include "drt_h.fh"
#include "grad_h.fh"

      ndim=norb_all*(norb_all+1)/2
      allocate(denm1(ndim))
      nc=ndim*(ndim+1)/2
      allocate(denm2(nc))

      end

      subroutine memdengrad_free()
#include "drt_h.fh"
#include "grad_h.fh"

      deallocate(denm1)
      deallocate(denm2)

      end

      subroutine memcidiag_alloc()
#include "drt_h.fh"
      integer, pointer :: jph(:),jeh(:),jwh(:)
      REAL*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh

      allocate(jph(maxpl))
      allocate(jeh(maxpl))
      allocate(jwh(maxpl))
      allocate(th(maxpl))
      allocate(thh(maxpl))
      jph=0
      jeh=0
      jwh=0
      th=0
      thh=0

      return
      end

      subroutine memcidiag_dealloc()
#include "drt_h.fh"
      integer, pointer :: jph(:),jeh(:),jwh(:)
      REAL*8, pointer :: th(:),thh(:)
      common/ptlph/jph,jeh,jwh
      common/ptlphv/th,thh

      deallocate(jph)
      deallocate(jeh)
      deallocate(jwh)
      deallocate(th)
      deallocate(thh)

      return
      end

      subroutine mem_intinnindex_alloc()
#include "drt_h.fh"
#include "intsort_h.fh"

      allocate(loij(50000))
      allocate(loijk(1384150))
      allocate(loij_all(50000))
      allocate(loijk_all(1384150))
      loij(1:50000)=0
      loijk(1:1384150)=0
      loijk_all(1:50000)=0
      loijk_all(1:1384150)=0

      allocate(intind_iaqq(50000))
      allocate(intind_abkk(50000))
      lent=norb_inn*nabc+norb_all
     *    +ngw2(norb_all)+ngw3(norb_all) !2*norb_ext*norb_ext*norb_ext
      allocate(intind_iabc(lent))
      allocate(intind_ijka(50000))
      allocate(intind_ijcc(50000))
      allocate(intind_ijab(50000))
      intind_iaqq(1:50000)=0
      intind_abkk(1:50000)=0
      intind_iabc(1:lent)=0
      intind_ijka(1:50000)=0
      intind_ijcc(1:50000)=0
      intind_ijab(1:50000)=0

      allocate(intspace_iaqq(50000))
      allocate(intspace_abkk(50000))
      allocate(intspace_iabc(50000))
      allocate(intspace_ijka(50000))
      allocate(intspace_ijcc(50000))
      allocate(intspace_ijab(50000))
      intspace_iaqq(1:50000)=0
      intspace_abkk(1:50000)=0
      intspace_iabc(1:50000)=0
      intspace_ijka(1:50000)=0
      intspace_ijcc(1:50000)=0
      intspace_ijab(1:50000)=0

      voint=0.d0
      vdint=0.d0

      return
      end

      subroutine mem_intinnindex_dealloc()
#include "drt_h.fh"
#include "intsort_h.fh"

      deallocate(loij)
      deallocate(loijk)
      deallocate(loij_all)
      deallocate(loijk_all)

      deallocate(intind_iaqq)
      deallocate(intind_abkk)
      deallocate(intind_iabc)
      deallocate(intind_ijka)
      deallocate(intind_ijcc)
      deallocate(intind_ijab)

      deallocate(intspace_iaqq)
      deallocate(intspace_abkk)
      deallocate(intspace_iabc)
      deallocate(intspace_ijka)
      deallocate(intspace_ijcc)
      deallocate(intspace_ijab)

      return
      end

      subroutine allocate_casrst()
#include "drt_h.fh"
#include "pl_structure_h.fh"

      allocate(ja(max_node),jb(max_node),jm(0:max_node))
      allocate(jj(1:4,0:max_node))
      allocate(kk(0:max_node))
      ja=0; jb=0; jm=0
      jj=0
      kk=0
      return
      end

      subroutine deallocate_casrst()
#include "drt_h.fh"
#include "pl_structure_h.fh"

      deallocate(ja,jb,jm)
      deallocate(jj)
      deallocate(kk)
      return
      end

      subroutine allocate_subdrt(icase,lent)
#include "drt_h.fh"
#include "pl_structure_h.fh"

      allocate(ihy(max_wei),jj_sub(1:4,0:max_node))
      allocate(iy(1:4,0:max_node))
      if(icase.eq.1) then
        allocate(jphy(max_node))
      else
        allocate(jphy(lent))
      endif
      end

      subroutine allocate_subdrtl(icase,lent)
#include "drt_h.fh"
#include "pl_structure_h.fh"

      allocate(ihyl(max_wei),jjl_sub(1:4,0:max_node))
      allocate(iyl(1:4,0:max_node))
      if(icase.eq.1) then
        allocate(jphyl(max_node))
      else
        allocate(jphyl(lent))
      endif
      end

      subroutine deallocate_subdrt()
#include "drt_h.fh"
#include "pl_structure_h.fh"

      deallocate(ihy,jj_sub)
      deallocate(iy)
      deallocate(jphy)
      end

      subroutine deallocate_subdrtl()
#include "drt_h.fh"
#include "pl_structure_h.fh"

      deallocate(ihyl,jjl_sub)
      deallocate(iyl)
      deallocate(jphyl)
      end

#ifdef MOLPRO
#else
      real*8 function c_time()
      c_time=seconds()

      end function c_time

      integer function ipair(i,j)
      implicit none
      integer :: i,j
      if(i.ge.j) then
        ipair=i*(i-1)/2+j
      else
        ipair=j*(j-1)/2+i
      endif
      end function ipair

      subroutine trimstr(string)
! delete space character in the head and tail of the string
      implicit none
      character*(*),intent(out) :: string
      character*128  :: line
      integer :: i,j,k,mylen
      k=mylen(string)
      line(1:k)=string(1:k)
      do i=1,k
        if(string(i:i).ne." ") exit
      enddo
      string=" "
      j=k-i+1
      string(1:j)=line(i:k)

      return
      end
#endif

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

! This subroutine should be in a module, to avoid explicit interfaces
#ifndef _IN_MODULE_
#error "This file must be compiled inside a module"
#endif

subroutine Build_Mp2Dens(TriDens,nTriDens,MP2X_e,CMO,mSym,nOrbAll,Diagonalize)

use Index_Functions, only: iTri, nTri_Elem
use Data_Structures, only: V2
use cOrbInf, only: nDel, nFro, nOcc, nOrb
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nTriDens, mSym, nOrbAll(8)
real(kind=wp), intent(inout) :: TriDens(nTriDens)
type(V2), intent(in) :: MP2X_e(8)
real(kind=wp), intent(in) :: CMO(*)
logical(kind=iwp), intent(in) :: Diagonalize
integer(kind=iwp) :: i, iLen, indx, ipSymLin(8), ipSymRec(8), ipSymTri(8), iSym, iUHF, lRecTot, LuMP2, nOrbAllMax, nOrbAllTot
character(len=30) :: Note
real(kind=wp), allocatable :: AORecBlock(:), AOTriBlock(:), EigenValBlock(:), EigenValTot(:), EigenVecBlock(:), EigenVecTot(:), &
                              Energies(:), MOTriBlock(:), TmpRecBlock(:)
integer(kind=iwp), allocatable :: IndT(:,:)
integer(kind=iwp), external :: IsFreeUnit

!                                                                      *
!***********************************************************************
!                                                                      *
nOrbAllTot = nOrbAll(1)
nOrbAllMax = nOrbAll(1)
lRecTot = nOrbAll(1)*nOrbAll(1)
do iSym=2,mSym
  nOrbAllTot = nOrbAllTot+nOrbAll(iSym)
  nOrbAllMax = max(nOrbAllMax,nOrbAll(iSym))
  lRecTot = lRecTot+nOrbAll(iSym)*nOrbAll(iSym)
end do

! A blockmatrix of the size Orb(iSym) X Orb(iSym) is
! allocated and set to zero
call mma_allocate(AORecBlock,nOrbAllMax**2,Label='AORecBlock')
call mma_allocate(TmpRecBlock,nOrbAllMax**2,Label='TmpRecBlock')
call mma_allocate(AOTriBlock,nTri_Elem(nOrbAllMax),Label='AOTriBlock')

if (Diagonalize) then
  call mma_allocate(MOTriBlock,nTri_Elem(nOrbAllMax),Label='MOTriBlock')
  call mma_allocate(EigenVecBlock,nOrbAllMax**2,Label='EigenVecBlock')
  call mma_allocate(EigenValBlock,nOrbAllMax,Label='EigenValBlock')
  call mma_allocate(EigenVecTot,lRecTot,Label='EigenVecTot')
  call mma_allocate(EigenValTot,nOrbAllTot,Label='EigenValTot')
  call mma_allocate(Energies,nOrbAllTot,Label='Energies')
  call mma_allocate(IndT,7,mSym,Label='IndT')
  Energies(:) = Zero
end if

AORecBlock(:) = Zero
TmpRecBlock(:) = Zero
AOTriBlock(:) = Zero

! Setup a pointer to a symmetryblock in rect or tri representation.
ipSymRec(1) = 0
ipSymTri(1) = 0
ipSymLin(1) = 0
do iSym=2,8
  ipSymTri(iSym) = ipSymTri(iSym-1)+nTri_Elem(nOrbAll(iSym-1))
  ipSymRec(iSym) = ipSymRec(iSym-1)+(nOrbAll(iSym-1))**2
  ipSymLin(iSym) = ipSymLin(iSym-1)+(nOrbAll(iSym-1))
end do

do iSym=1,mSym

  if (nOrbAll(iSym) /= 0) then

    ! Set initial values for the eigenvectors to the CMO-matrix.
    ! If we transform the CMO-matrix in the same way as the MO-matrix
    ! needs to be treated to be diagonal we get a transformation from
    ! AO to canonical basis. Also sets the energies to zero since they
    ! have no physical relevance in this basis.
    if (Diagonalize) then
      EigenVecBlock(1:nOrbAll(iSym)**2) = CMO(ipSymRec(iSym)+1:ipSymRec(iSym)+nOrbAll(iSym)**2)
    end if
    ! Transform the symmetryblock to AO-density
    call DGEMM_('N','N',nOrbAll(iSym),nOrbAll(iSym),nOrbAll(iSym),One,CMO(ipSymRec(iSym)+1),nOrbAll(iSym),MP2X_e(iSym)%A, &
                nOrbAll(iSym),Zero,TmpRecBlock,nOrbAll(iSym))
    call DGEMM_('N','T',nOrbAll(iSym),nOrbAll(iSym),nOrbAll(iSym),One,TmpRecBlock,nOrbAll(iSym),CMO(ipSymRec(iSym)+1), &
                nOrbAll(iSym),Zero,AORecBlock,nOrbAll(iSym))
    !call RecPrt('AODens:','(20F8.5)',AORecBlock,nOrb(iSym),nOrb(iSym))
    call Fold_Mat(1,nOrbAll(iSym),AORecBlock,AOTriBlock)
    iLen = nTri_Elem(nOrbAll(iSym))
    TriDens(ipSymTri(iSym)+1:ipSymTri(iSym)+iLen) = AOTriBlock(1:iLen)

    if (Diagonalize) then
      ! Make a normal folded matrix

      indx = 0
      do i=1,nOrbAll(iSym)
        MOTriBlock(indx+1:indx+i) = MP2X_e(iSym)%A(1:i,i)
        indx = indx+i
      end do

      call NIDiag(MOTriBlock,EigenVecBlock,nOrbAll(iSym),nOrbAll(iSym))

      do i=1,nOrbAll(iSym)
        EigenValBlock(i) = MOTriBlock(iTri(i,i))
      end do

      call SortEig(EigenValBlock,EigenVecBlock,nOrbAll(iSym),nOrbAll(iSym),-1,.false.)

#     ifdef _DEBUGPRINT_
      write(u6,*) 'The sorted eigenvalues are'
      do i=1,nOrbAll(iSym)
        write(u6,*) EigenValBlock(i)
      end do
      write(u6,*) 'Eigenvectors sorted'
      do i=1,nOrbAll(iSym)**2
        write(u6,*) EigenVecBlock(i)
      end do
#     endif

      iLen = nOrbAll(iSym)**2
      EigenVecTot(ipSymRec(iSym)+1:ipSymRec(iSym)+iLen) = EigenVecBlock(1:iLen)
      iLen = nOrbAll(iSym)
      EigenValTot(ipSymLin(iSym)+1:ipSymLin(iSym)+iLen) = EigenValBlock(1:iLen)

    end if

  end if
end do

! Put the MP2 natural orbitals we just produced on disk to the file MP2ORB.

if (Diagonalize) then
  LuMP2 = 50
  LuMP2 = IsFreeUnit(LuMP2)
  ! Build the TypeIndex array
  IndT(1,1:mSym) = nFro(1:mSym)
  IndT(2,1:mSym) = nOcc(1:mSym)
  IndT(3,1:mSym) = 0
  IndT(4,1:mSym) = 0
  IndT(5,1:mSym) = 0
  IndT(6,1:mSym) = nOrb(1:mSym)-nFro(1:mSym)-nOcc(1:mSym)-nDel(1:mSym)
  IndT(7,1:mSym) = nDel(1:mSym)
  Note = '*  Natural MP2 orbitals'
  call WrVec('MP2ORB',LuMP2,'COEI',mSym,nOrbAll,nOrbAll,EigenVecTot,EigenValTot,Energies,IndT,Note)
  ! Create a molden-file
  iUHF = 0
  call Molden_Interface(iUHF,'MP2ORB','MD_MP2')

end if

call mma_deallocate(AORecBlock)
call mma_deallocate(TmpRecBlock)
call mma_deallocate(AOTriBlock)

if (Diagonalize) then
  call mma_deallocate(MOTriBlock)
  call mma_deallocate(EigenVecBlock)
  call mma_deallocate(EigenValBlock)
  call mma_deallocate(EigenVecTot)
  call mma_deallocate(EigenValTot)
  call mma_deallocate(Energies)
  call mma_deallocate(IndT)
end if

return

end subroutine Build_Mp2Dens

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Jeppe Olsen                                      *
!***********************************************************************

subroutine INTPNT(IPNT1,ISL1,IPNT2,ISL2)
! Pointers to symmetry blocks of integrals
! IPNT1 : Pointer to given one-electron block, total symmetric
! ISL1  : Symmetry of last index for given first index, 1 e-
! IPNT2 : Pointer to given two-electron block
! ISL1  : Symmetry of last index for given first index, 1 e-
!
! In addition pointers to one-electron integrals with general
! symmetry is generated in PGINT1(ISM)%A
!
! Pointers for similarity transformed Hamiltonian may also be
! generated
!
! Jeppe Olsen, Last Update : August 2000

use lucia_data, only: I1234S, I12S, I34S, NSMOB, NTOOBS, PGINT1, PGINT1A
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(out) :: IPNT1(NSMOB), ISL1(NSMOB), IPNT2(NSMOB,NSMOB,NSMOB), ISL2(NSMOB,NSMOB,NSMOB)
integer(kind=iwp) :: ISM

! 0 : Pointers to one-integrals, all symmetries, Lower half matrices
do ISM=1,NSMOB
  call PNT2DM(1,NSMOB,NTOOBS,NTOOBS,ISM,ISL1,PGINT1(ISM)%A)
end do
! 0.5 : Pointers to one-electron integrals, all symmetries, complete form
do ISM=1,NSMOB
  call PNT2DM(0,NSMOB,NTOOBS,NTOOBS,ISM,ISL1,PGINT1A(ISM)%A)
end do
! 1 : Number of one-electron integrals
call PNT2DM(1,NSMOB,NTOOBS,NTOOBS,1,ISL1,IPNT1)
! 2 : two-electron integrals
call PNT4DM(NSMOB,NTOOBS,NTOOBS,NTOOBS,NTOOBS,1,I12S,I34S,I1234S,IPNT2,ISL2)

end subroutine INTPNT

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine ChkVec(OrbFileName,iVer,NSYM_L,NBAS_L,NORB_L,InfoLbl,iRc)
! Purpose: To check if OrbFileName is a valid orbital file, and which
! information it contains.

use InpOrbFmt, only: Magic, mxVer
use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: OrbFileName
integer(kind=iwp), intent(out) :: iVer, NSYM_L, NBAS_L(8), NORB_L(8), iRc
character(len=8), intent(out) :: InfoLbl
integer(kind=iwp) :: I, iIND, iOCC, iONE, iORB, ip, istatus, IUHF, jVer, LU
logical(kind=iwp) :: lExists
character(len=80) :: line
integer(kind=iwp), external :: isFreeUnit
#include "warnings.h"

call f_Inquire(OrbFileName,lExists)
if (.not. lExists) then
  iRC = _RC_IO_ERROR_READ_
  return
end if
LU = 99
LU = IsFreeUnit(LU)
call Molcas_Open(LU,OrbFileName)
! Check version!
read(LU,'(A80)',iostat=istatus) Line
if (istatus /= 0) then
  call Error()
  return
end if
iVer = 0
do jVer=1,mxVer
  if (Magic(jVer) == Line(1:len(Magic(jVer)))) iVer = jVer
end do
iRc = _RC_IO_ERROR_READ_
if (iVer == 0) return

! Find and read information section:
do
  read(LU,'(A80)',iostat=istatus) LINE
  if (istatus > 0) then
    call Error()
    return
  end if
  if (LINE == '#INFO') exit
end do
do
  read(LU,'(A80)',iostat=istatus) LINE
  if (istatus > 0) then
    call Error()
    return
  end if
  if (LINE(1:1) /= '*') exit
end do
read(LINE,*) IUHF,NSYM_L
do
  read(LU,'(A80)',iostat=istatus) LINE
  if (istatus > 0) then
    call Error()
    return
  end if
  if (LINE(1:1) /= '*') exit
end do
read(LINE,*) (NBAS_L(I),I=1,NSYM_L)
do
  read(LU,'(A80)',iostat=istatus) LINE
  if (istatus > 0) then
    call Error()
    return
  end if
  if (LINE(1:1) /= '*') exit
end do
read(LINE,*) (NORB_L(I),I=1,NSYM_L)

! Create a InfoLbl telling what data sets are available:
iORB = 0
iOCC = 0
iONE = 0
iIND = 0
! Find section InfoLbls:
if (IUHF == 0) then
  do
    read(LU,'(A80)',iostat=istatus) LINE
    if (istatus /= 0) exit
    if (LINE(1:4) == '#ORB') iORB = 1
    if (LINE(1:4) == '#OCC') iOCC = 1
    if (LINE(1:4) == '#ONE') iONE = 1
    if (LINE(1:4) == '#IND') iIND = 1
  end do
else
  do
    read(LU,'(A80)',iostat=istatus) LINE
    if (istatus /= 0) exit
    if (LINE(1:5) == '#UORB') iORB = 1
    if (LINE(1:5) == '#UOCC') iOCC = 1
    if (LINE(1:5) == '#UONE') iONE = 1
    if (LINE(1:4) == '#IND') iIND = 1
  end do
end if

! Intentionally reached end of file:
InfoLbl = ' '
ip = 0
ip = ip+iorb
if (iorb == 1) InfoLbl(ip:ip) = 'C'
ip = ip+iocc
if (iocc == 1) InfoLbl(ip:ip) = 'O'
ip = ip+ione
if (ione == 1) InfoLbl(ip:ip) = 'E'
ip = ip+iind
if (iind == 1) InfoLbl(ip:ip) = 'I'

close(LU)
iRC = _RC_ALL_IS_WELL_

return

contains

subroutine Error()
  close(LU)
  iRC = _RC_IO_ERROR_READ_
end subroutine Error

end subroutine ChkVec

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1990,2020, Roland Lindh                                *
*               1990, IBM                                              *
************************************************************************
      SubRoutine ZXia(Zeta,ZInv,N,M,Alpha,Beta)
************************************************************************
*                                                                      *
*     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
*             January 1990                                             *
************************************************************************
      Implicit None
#include "real.fh"
      Integer, Intent(In):: N,M
      Real*8, Intent(In):: Alpha(N), Beta(M)
      Real*8, Intent(InOut):: Zeta(N,M), ZInv(N,M)
      Integer j
*
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
      Call RecPrt(' In ZXia: Alpha',' ',Alpha,N,1)
      Call RecPrt(' In ZXia: Beta ',' ',Beta ,M,1)
#endif
*
      Do j = 1, M
         Zeta(:,j) = (Alpha(:)+Beta(j))
         ZInv(:,j) = One/Zeta(:,j)
      End Do
#ifdef _DEBUGPRINT_
      Call RecPrt( ' In ZXia: Zeta',' ',Zeta,N,M)
#endif
*
      Return
      End SubRoutine ZXia

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Function AtNear(IAt,IAn,NBond,IBond,DH,DId,DAr,Chg)
      Implicit Real*8 (A-H,O-Z)
C     Logical AddH
      Parameter (MxBond=12)
      Dimension IAn(*),NBond(*),IBond(MxBond,*),Chg(*)
      AtNear= 0.0D+00
      NearAt= 0
      NH    = 0
      NNit  = 0
      NF    = 0
      NX    = 0
      NId   = 0
      NCSP3 = 0
      NCSP2 = 0
      NCSP  = 0
      DX    = 0.0D+00
      IAnI  = IAn(IAt)
      NbI   = NBond(IAt)
      Do 2000 j=1,NbI
        Jat = ibond(j,IAt)
        IAnJ= Ian(JAt)
        NbJ= NBond(JAt)
        ChgJ=Chg(JAt)
C Hydrogen
        If(IAnJ.eq.1) NH = NH + 1
C Carbon
        If(IAnJ.eq.6) then
          If(nbj.eq.4) NCSP3 = NCSP3 + 1
          If(nbj.eq.3) NCSP2 = NCSP2 + 1
          If(nbj.eq.2) NCSP  = NCSP  + 1
        EndIf
C Nitrogen
        If(IAnJ.eq.7) then
          IF(NBJ.lt.4) then
            If(IAnI.eq.IAnJ) NId = NId + 1
            NX=NX+1
            NNit=NNit+1
          else
            NX=NX+1
          endif
        endif
C Oxygen
        If(IAnJ.eq.8) then
          NOX = 1
          If(IAnI.eq.IAnJ.and.abs(ChgJ).lt.1.0D-01) NId = NId + 1
          If(CHGJ.gt.4.0D-01) then
            NOX = 0
            DX  = 5.0D-01
          EndIf
          If(CHGJ.lt.-4.0D-01) NOX = 3
          NX = NX + NOX
        EndIf
C Fluorine
        If(IAnJ.eq.9) then
          If(IAnI.eq.IAnJ) NId = NId + 1
          NF = NF + 1
        EndIf
C Positive Phosphorous
        If(IAnJ.eq.15.and.NBJ.eq.4) DX = DX - 1.5D0
C Positive Sulfur
        If(IAnJ.eq.16.and.NBJ.eq.3) DX = DX - 2.7D0
 2000 continue
      NearAt = NH
      NAr = 0
      If(IAn(IAt).eq.6.and.abs(Chg(IAt)).lt.4.0D-01)
     $  NearAt = NearAt + NH
      If(IAn(IAt).eq.6.and.NBond(IAt).eq.3.and.NCSP2.ge.1) then
        If((NH+NCSP3).ne.2)
     $    NAR = NAlpAr(IAt,IAn,NBond,IBond,Chg)
      EndIf
      If(IAn(IAt).eq.6.and.NBond(IAt).eq.4)
     $    NearAt =  NearAt - NX - NCSP2 - NNit + NF
     $                + NCAlph(IAt,NH,NCSP3,IAn,NBond,IBond,Chg)
      If(NH.gt.3) NearAt = NearAt - 1
      AtNear = DBLE(NearAt) - DX
      DH = DBLE(NH)
      DAr = 5.0D-01*DBLE(NAr)
      DId = 5.0D-01*DBLE(NId)
      Return
      End

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Function Hybnew(OKUAH,OKCHG,IAt,IAn,NBond,IBond,IBType,PBO,Chg)
      Implicit Real*8 (A-H,O-Z)
      Logical PIAT,OKUAH,OKChg
      Parameter (MxBond=12)
      Dimension NBond(*),IBond(MxBond,*),IBtype(MxBond,*),IAn(*)
      Dimension PBO(MxBond,*)
C
      NumatI=IAn(IAt)
      HybNew = 3.0D+00
C     Chg    = 0.0D+00
      IQQ    = 0
      If(.not.OKUAH) then
        HybNew=0.0D+00
        return
      endif
C
C Hydrogen
C
      If(IAn(IAt).eq.1) then
        HybNew=0.0D+00
        If(NBond(IAT).eq.0.and..not.OKCHG) Chg = 1.0D+00
      EndIf
C
C Carbon
C
      If(IAN(IAt).eq.6) then
        NBTot=0
        PBtot=0.0D+00
        Do 2000 jj=1,NBond(IAt)
         NBtot=NBTot+IBType(jj,IAt)
         PBTot=PBTot+PBO(jj,IAt)
 2000 continue
        If(NBond(IAt).eq.3.and.NBTot.ge.4) HybNew= 2.0D+00
        If(NBond(IAt).eq.3.and.PBtot.gt.3.7d+0) Hybnew= 2.0d+00
        If(NBond(IAt).eq.2) HybNew = 1.0D+00
      EndIf
C
C Nitrogen, Phosphorous, Arsenicum, Antimonium
C
      If(IColAt(NumAtI).eq.5) then
        NBIA=NBond(IAt)
        goto(10,20,30,40)NBIA
  10    HybNew  = 1.0D+00
          ICC=IBond(1,IAt)
          ICN=IAn(IBond(1,IAt))
          If(ICN.eq.6.and.NBond(ICC).eq.1.and..not.OKCHG)
     $       Chg = -1.0D+00
          goto 50
  20    if(PIAT(IAt,IAn,NBond,IBond)) then
            HybNew = 2.0D+00
          else
            If(.not.OKCHG) Chg = -1.0D+00
          endif
          goto 50
  30    continue
          If(PIAT(IAt,IAn,NBond,IBond)) HybNew = 2.0D+00
          goto 50
  40    NBII=0
         Do 2010 ii=1,NBIA
         NumII=IAn(IBond(II,IAt))
         If(NumII.eq.6.or.NumII.eq.1) NBII=NBII+1
 2010 continue
        IF(NBII.gt.3.and..not.OKCHG) Chg = 1.0D+00
  50    continue
      EndIf
C
C Oxygen, Sulfur, Selenium, Tellurium
C
      If(IColAt(NumAtI).eq.6) then
C
C tricoordinated (positively charged only if bonded to C and/or H only)
C
        If(NBond(IAt).eq.3) then
         NBII=0
         do 2020 ii=1,3
           NumII=IAn(IBond(II,IAt))
           If(NumII.eq.1.or.NumII.eq.6) NBII=NBII+1
 2020 continue
         If(NBII.eq.3) then
           If(.not.OKCHG) Chg = 1.0D+00
           HybNew = 3.0D+00
         EndIf
        EndIf
C
C bicoordinated
C
        If(NBond(IAt).eq.2) then
          If(.not.OKCHG) Chg = 0.0D+00
          HybNew = 3.0D+00
C
C test for protonated aldehydes,ketones and similar for S
C
          Do 2030 jj=1,2
           JAt=IBond(JJ,IAt)
           NumJ=IAn(JAt)
           NBJ=NBond(JAt)
           If(NumJ.eq.6.and.NBJ.eq.3) then
             IQQ = 0
             do 2040 kk=1,3
                KAt = IBond(kk,JAt)
                NumK = IAn(KAt)
                NBK=NBond(KAt)
                If(NumK.eq.6.and.NBK.eq.4) IQQ=IQQ+1
 2040 continue
           endif
 2030 continue
          If(IQQ.ge.2) then
           If(.not.OKCHG) Chg = 1.0D+00
           HybNew = 2.0D+00
          EndIf
        EndIf
        If(NBond(IAt).eq.1) then
         HybNew = 2.0D+00
         Jat=IBond(1,IAt)
         icc=IAn(JAt)
         if(icc.eq.1) then
           HybNew = 3.0D+00
           If(.not.OKCHG) Chg = -1.0D+00
         EndIf
         if(icc.eq.6) then
           if(NBond(JAt).eq.4) then
             If(.not.OKCHG) CHg = -1.0D+00
             HybNew = 3.0D+00
           EndIf
           ISP2=0
           JSP2=0
           ICARB=0
           if(NBond(JAt).eq.3) JSP2=1
           do 2050 K=1,NBond(JAt)
             KAT=IBond(K,JAt)
             If(IAN(KAT).eq.6.and.NBond(KAT).eq.3) ISP2=ISP2+1
             IF(IAN(KAT).eq.8.and.NBond(KAt).eq.1) ICARB=ICARB+1
 2050 continue
           If(ISP2.gt.1) then
             If(.not.OKCHG) Chg = -1.0D+00
             HybNew = 3.0D+00
           EndIf
           If(JSp2.eq.1.and.ICARB.eq.2) then
             If(.not.OKCHG) Chg = -5.0D-01
             HybNew = 3.0D+00
           EndIf
         EndIf
        EndIf
      EndIf
C
C Halogens
C
      If(IColAt(NumAtI).eq.7.and.NBond(IAt).eq.0) then
        If(.not.OKCHG) Chg = -1.0D+00
      EndIf
C
C     Write(IOut,'(I3,2F3.1)') IAn(IAt),HybNew,Chg
      Return
      End

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Integer Function NCAlph(IAt,NHI,NCSP3I,IAn,NBond,IBond,Chg)
      Implicit Real*8 (A-H,O-Z)
      Parameter (MxBond=12)
      Dimension NBond(*),IBond(MxBond,*),IAn(*),chg(*)
      NHetI=4-NHI-NCSP3I
      NCP1=0
      NCM1=0
C     write(IOut,'(''Atom'',I2,'' NHet='',I1)') IAt,NHetI
      Do 2000 jj=1,4
        jat=IBond(jj,iat)
        ianj=ian(jat)
        nbj=nbond(jat)
        nhj=0
        ncsp3j=0
        nhetj=0
        iplj=0
        if(ianj.eq.6.and.nbj.eq.4) then
          do 2010 kk=1,4
            kat=IBond(kk,JAt)
            iank=ian(KAt)
            nbk=nbond(kat)
            if(iank.eq.1) NHJ=NHJ+1
            if(iank.eq.6.and.nbk.eq.4) NCSP3J=NCSP3J+1
            if(chg(kat).gt.4.0d-01) iplj=1
 2010 continue
          NHETJ=4-NHJ-NCSP3J
          If(NHetI.ge.0.and.NHetJ.eq.0) NCP1=NCP1+1
          If(NHetI.eq.0.and.NHetJ.gt.0.and.iplj.eq.0) NCM1=NCM1+1
        endif
C       write(IOut,*) JAt,NHetJ,NCP1,NCM1
 2000 continue
      NCAlph = NCP1 - NCM1
      return
      end

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Integer Function NAlpAr(IAt,IAn,NBond,IBond,Chg)
      Implicit Real*8 (A-H,O-Z)
      Parameter (MxBond=12)
      Dimension NBond(*),IBond(MxBond,*),IAn(*),Chg(*)
      NAlPar = -1
      NArI = 0
      Do 2000 jj=1,3
        NCSP2J=0
        NHetJ=0
        jat=IBond(jj,iat)
        ianj=ian(jat)
        nbj=nbond(jat)
        if(ianj.eq.7.and.nbj.ge.3) NCSP2J=2
        if(ianj.eq.6.and.nbj.eq.3) then
          do 2010 kk=1,3
            kat=IBond(kk,JAt)
            iank=ian(KAt)
            nbk=nbond(Kat)
            chgk=chg(KAt)
            if(chgk.lt.4.0D-01) then
             if(iank.eq.6.and.nbk.eq.3) NCSP2J=NCSP2J+1
             if(iank.eq.8.or.iank.eq.9) NHetJ=NHetJ+1
             if(iank.eq.17.or.iank.eq.35.or.iank.eq.53) NHetJ=NHetJ+1
             if(iank.eq.7) then
                if(nbk.le.2) NHetJ=NHetJ+1
                if(nbk.ge.3) NCSP2J=NCSP2J+1
             endif
            endif
 2010 continue
        endif
        if(NCSP2J.ge.2.and.NHetJ.eq.0) NarI = NArI + 1
 2000 continue
      If(NArI.ge.2) NAlPar = 1
      return
      end

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Function IPBO(ToAng,IA,JA,RIJ,BondOr)
      Implicit Real*8(A-H,O-Z)
C
C     Return the order of the bond between atoms of atomic numbers IA
C     and JA, separated by RIJ, or 0 if there is no bond.
C
C     Generate connectivity based on bond distances alone.  The criteria
C     is whether the distances is no more than 30% longer than the sum of
C     covalent radii of involved atoms. For the moment all bond types are
C     determined using Pauling bond orders.
C     Note that RIJ is multiplied by ToAng, i.e. if it is already in Ang.
C     ToAng must be set = 1
C
      IPBO = 0
      R1IJ = RIJ*ToAng
      R0IJ = RCov97(IA,JA)
C     If(R1IJ.gt.R0IJ*1.3d0) return
      BondOr = Exp((R0IJ-R1IJ)/0.3d0)
      If(BondOr.lt.2.0D-01) return
      IBondO = Int(Sngl(BondOr+0.5d0))
      IBondO = Max(IBondO,1)
      IBondO = Min(IBondO,3)
      IPBO = IBondO
      Return
      End

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Integer Function IColAt(NumAt)
      Dimension ICol(0:108)
      Save ICol
      Data ICol/0,1,2,
     $          1,2,3,4,5,6,7,8,
     $          1,2,3,4,5,6,7,8,
     $          1,2,9,9,9,9,9,9,9,9,9,9,3,4,5,6,7,8,
     $          1,2,9,9,9,9,9,9,9,9,9,9,3,4,5,6,7,8,
     $          1,2,30*9,
     $          22*9/
      IcolAt=ICol(NumAt)
      Return
      End

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Logical Function PiAt(IAt,IAn,NBond,IBond)
      Parameter(MxBond=12)
      Dimension IAn(*),NBond(*),IBond(MxBond,*)
      PiAt=.False.
      ISPI=-1
      Do 2000 J=1,NBond(IAT)
        JAt=IBond(J,IAt)
        IAnJ=IAn(JAt)
        ITpJ=IColAt(IAnJ)
        NBnJ=NBond(JAT)
        NPiJ=0
        Do 2010 K=1,NBnJ
          KAt=IBond(K,JAt)
          If(IAn(KAt).eq.6.and.NBond(KAt).eq.3)NPiJ=NPiJ+1
 2010 continue
        If(IAnJ.eq.6.and.NBnJ.eq.3) then
          If(NPiJ.ge.2) then
            ISPI=ISPI+2
          Else
            ISPI=ISPI+1
          EndIf
        EndIf
        If(ITpJ.eq.5.and.NBnJ.eq.2) ISPI=ISPI+1
        If(ITpJ.eq.5.and.NPiJ.ge.2) ISPI=ISPI+1
 2000 continue
      If(ISPI.gt.0) PiAt=.True.
      Return
      End

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Integer Function IRowAt(NumAt)
      Dimension IRow(0:108)
      Save IRow
      Data IROW /0,2*1,8*2,8*3,18*4,18*5,32*6,22*7/
      IRowAt=IRow(NumAt)
      Return
      End

C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Function AtSymb(I)
C                                    (I)
C     ATSYMB(I) is the Atomic Symbol corresponding to the Atomic number I
C     if I=0  Atsymb=Bq
C     if I=-1 Atsymb=X
      Character*2 AtSymb
#include "periodic_table.fh"
C
      If(I.gt.0) then
       AtSymb = PTab(i)
       Return
      EndIf
      If(I.eq.-1) AtSymb=' X'
      If(I.eq.0)  AtSymb='Bq'
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1990, Roland Lindh                                     *
!               1990, IBM                                              *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine Setup1(ExpA,nPrim,ExpB,mPrim,A,B,rKappa,Pcoor,ZInv)
!***********************************************************************
!                                                                      *
!     Object : to compute some data which is needed for the one-       *
!              electron integrals.                                     *
!                                                                      *
!     Author: Roland Lindh, IBM Almaden Research Center, San Jose, CA  *
!             January '90                                              *
!***********************************************************************

use Constants, only: Zero, One
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nPrim, mPrim
real(kind=wp), intent(in) :: ExpA(nPrim), ExpB(mPrim), A(3), B(3), ZInv(nPrim,mPrim)
real(kind=wp), intent(out) :: rKappa(nPrim,mPrim), Pcoor(nPrim,mPrim,3)
integer(kind=iwp) :: jPrim
real(kind=wp) :: ab

#ifdef _DEBUGPRINT_
call RecPrt(' *** ExpA ***',' ',ExpA,1,nPrim)
call RecPrt(' *** ExpB ***',' ',ExpB,1,mPrim)
call RecPrt(' *** ZInv ***',' ',ZInv,nPrim,mPrim)
write(u6,*) 'A(:)=',A(:)
write(u6,*) 'B(:)=',B(:)
#endif
ab = (A(1)-B(1))**2+(A(2)-B(2))**2+(A(3)-B(3))**2

if (ab /= Zero) then
  do jPrim=1,mPrim
    rKappa(:,jPrim) = exp(-ExpA(:)*ExpB(jPrim)*ab*ZInv(:,jPrim))
    Pcoor(:,jPrim,1) = (ExpA(:)*A(1)+ExpB(jPrim)*B(1))*ZInv(:,jPrim)
    Pcoor(:,jPrim,2) = (ExpA(:)*A(2)+ExpB(jPrim)*B(2))*ZInv(:,jPrim)
    Pcoor(:,jPrim,3) = (ExpA(:)*A(3)+ExpB(jPrim)*B(3))*ZInv(:,jPrim)
  end do
else
  rKappa(:,:) = One
  PCoor(:,:,1) = A(1)
  PCoor(:,:,2) = A(2)
  PCoor(:,:,3) = A(3)
end if
#ifdef _DEBUGPRINT_
call RecPrt(' *** Kappa ***',' ',rKappa,nPrim,mPrim)
call RecPrt(' ***   Px  ***',' ',Pcoor(1,1,1),nPrim,mPrim)
call RecPrt(' ***   Py  ***',' ',Pcoor(1,1,2),nPrim,mPrim)
call RecPrt(' ***   Pz  ***',' ',Pcoor(1,1,3),nPrim,mPrim)
#endif

end subroutine Setup1

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine PrDiOp(Text,nSym,nBas,XInt)
!***********************************************************************
!                                                                      *
!     Object: Print a diagonal block matrix                            *
!                                                                      *
!***********************************************************************

use Definitions, only: wp, iwp, u6

implicit none
character(len=*), intent(in) :: Text
integer(kind=iwp), intent(in) :: nSym, nBas(nSym)
real(kind=wp), intent(in) :: XInt(*)
integer(kind=iwp) :: iOff, iSym, lText, nBs

!----------------------------------------------------------------------*
!                                                                      *
!     Start procedure                                                  *
!     Loop over pairs of symmetry labels. Skip all offdiagonal         *
!     blocks.                                                          *
!                                                                      *
!----------------------------------------------------------------------*

lText = min(120,len(Text))
write(u6,'(6X,A)') Text(1:lText)
iOff = 1
do iSym=1,nSym
  nBs = nBas(iSym)
  if (nBs /= 0) then
    write(u6,'(6X,A,I2)') 'Symmetry species',iSym
    call TriPrt(' ',' ',XInt(iOff),nBs)
  end if
  iOff = iOff+nBs*(nBs+1)/2
end do

!----------------------------------------------------------------------*
!     Terminate procedure                                              *
!----------------------------------------------------------------------*

return

end subroutine PrDiOp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Thomas Bondo Pedersen                            *
************************************************************************
      SubRoutine CD_Diag(CD_Vec,
     &                   Restart,Converged,Thr,
     &                   ThrNeg,ThrFail,
     &                   DiaInp,Diag,Buf,
     &                   nDim,lBuf,
     &                   ErrStat,NumCho,
     &                   irc)
C
C     Thomas Bondo Pedersen, October 2004.
C
C     Purpose: set up diagonal for general Cholesky decomposition.
C
C     NB!! ThrNeg and ThrFail are supposed to be negative with
C          ThrFail < ThrNeg. Diagonals less than ThrNeg are zeroed,
C          while diagonals less than ThrFail is taken as a sign of
C          a non-positive definite matrix (i.e., decomposition will
C          fail).
C
C     Error codes, irc:
C        0 : all OK
C      201 : inconsistent input: Restart but NumCho < 0.
C            (NumCho >= 0 is allowed with Restart.)
C      202 : insufficient buffer size, lBuf.
C      203 : too negative diagonal element found (i.e., matrix
C            is non-positive definit).
C
      Implicit Real*8 (a-h,o-z)
      External  CD_Vec ! external routine for vectors
      Logical   Restart, Converged
      Dimension DiaInp(nDim), Diag(nDim), Buf(lBuf)
      Dimension ErrStat(3)

      Character*7 SecNam
      Parameter (SecNam = 'CD_Diag')


C     Set variables.
C     --------------

      irc = 0
      If (nDim .lt. 1) Then
         Converged = .true. ! in a sense, at least
         Go To 1 ! exit (nothing to do)
      Else
         Converged = .false.
      End If

C     Set up diagonal.
C     ----------------

      Call dCopy_(nDim,DiaInp,1,Diag,1)

      If (Restart) Then ! subtract previous vectors
         If (NumCho .gt. 0) Then

            nVec = min(NumCho,lBuf/nDim)
            If (nVec .lt. 1) Then
               irc = 202
               Go To 1 ! exit (insufficient buffer size)
            Else
               nBatch = (NumCho - 1)/nVec + 1
            End If

            Do iBatch = 1,nBatch

               If (iBatch .eq. nBatch) Then
                  NumV = NumCho - nVec*(nBatch - 1)
               Else
                  NumV = nVec
               End If

               iVec1 = nVec*(iBatch - 1) + 1
               iOpt  = 2
               Call CD_Vec(iVec1,NumV,Buf,lBuf,nDim,iOpt)

               Do jVec = 1,NumV
                  kOff = nDim*(jVec - 1)
                  Do i = 1,nDim
                     ij = kOff + i
                     Diag(i) = Diag(i) - Buf(ij)*Buf(ij)
                  End Do
               End Do

            End Do

         Else If (NumCho .lt. 0) Then

            irc = 201
            Go To 1 ! exit (inconsistent input)

         End If
      End If

C     Zero negative diagonals (fail if too negative),
C     get error statistics (min, max, and rms error),
C     check convergence based on max diagonal.
C     -----------------------------------------------

      If (Diag(1) .lt. ThrNeg) Then
         If (Diag(1) .lt. ThrFail) Then
            irc = 203
            Go To 1 ! exit (too negative diagonal)
         Else
            Diag(1) = 0.0d0
         End If
      End If
      ErrStat(1) = Diag(1)
      ErrStat(2) = Diag(1)
      ErrStat(3) = Diag(1)*Diag(1)
      Do i = 2,nDim
         If (Diag(1) .lt. ThrNeg) Then
            If (Diag(1) .lt. ThrFail) Then
               irc = 203
               Go To 1 ! exit (too negative diagonal)
            Else
               Diag(1) = 0.0d0
            End If
         End If
         ErrStat(1) = min(ErrStat(1),Diag(i))
         ErrStat(2) = max(ErrStat(2),Diag(i))
         ErrStat(3) = ErrStat(3) + Diag(i)*Diag(i)
      End Do
      xDim = dble(nDim)
      ErrStat(3) = sqrt(ErrStat(3))/xDim

      Converged = ErrStat(2) .le. Thr

    1   Continue
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2011, Steven Vancoillie                                *
!***********************************************************************
!***********************************************************************
! Written by Steven Vancoillie, May 2011
! A set of subroutines that can handle RHS arrays in either a serial or
! parallel environment, depending on the situation.
!***********************************************************************
! --> when running serially, the RHS arrays are stored on LUSOLV and are
! loaded into the WORK array when needed.
! --> when running in parallel, the RHS arrays are stored on disk as
! disk resident arrays (DRAs) with filename RHS_XX_XX_XX, where XX is a
! number referring to the case, symmetry, and RHS vector respectively,
! and are loaded onto a global array when needed.
!***********************************************************************

subroutine resdia(nRow,nCol,W,LDW,dIn,dIs,dOvl)

use caspt2_global, only: imag_shift, real_shift, sigma_p_epsilon, sigma_p_exponent
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nRow, nCol, LDW
real(kind=wp), intent(inout) :: W(LDW,nCol), dOvl
real(kind=wp), intent(in) :: dIn(nRow), dIs(nCol)
integer(kind=iwp) :: i, j, p
real(kind=wp) :: delta, delta_inv, eps, sigma, tmp

dOvl = Zero
do j=1,nCol
  do i=1,nRow
    ! energy denominator plus real shift
    delta = dIn(i)+dIs(j)+real_shift
    ! inverse denominator plus imaginary shift
    delta_inv = delta/(delta**2+imag_shift**2)
    ! multiply by (inverse) sigma-p regularizer
    eps = sigma_p_epsilon
    p = sigma_p_exponent
    if (eps > Zero) then
      sigma = One/eps**p
      delta_inv = delta_inv*(One-exp(-sigma*abs(delta)**p))
    end if
    tmp = delta_inv*W(i,j)
    dOvl = dOvl+tmp*W(i,j)
    W(i,j) = tmp
  end do
end do

end subroutine resdia

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2000, Roland Lindh                                     *
!***********************************************************************

subroutine OpnFl(FName,Lu,Exists)
!***********************************************************************
!                                                                      *
! Object:                                                              *
!                                                                      *
! Called from:                                                         *
!                                                                      *
! Calling    : f_Inquire                                               *
!              isFreeUnit                                              *
!              Open                                                    *
!                                                                      *
!     Author: Roland Lindh, Dept. of Chemical Physics,                 *
!             University of Lund, SWEDEN                               *
!             February 2000                                            *
!***********************************************************************

use Definitions, only: iwp

implicit none
character(len=*), intent(in) :: FName
integer(kind=iwp), intent(inout) :: Lu
logical(kind=iwp), intent(out) :: Exists
integer(kind=iwp), external :: isFreeUnit

! Find an unused unit number

lu = isFreeUnit(lu)
Exists = .false.

! Check that file exists

!open(unit=Lu,file=FName,status='UNKNOWN',form='FORMATTED')
call F_Inquire(FName,Exists)
call Molcas_Open(Lu,FName)

return

end subroutine OpnFl

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine dv_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)

      call external_space_plpmode_value_dv()

      idisk_lp=idisk_array(2)
      do lpblock=1,lpblock_dv
        call read_lp()
        ipael=iml+1
        ipae=1
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
c        jmlr=mul_tab(jml,jmr)
        call gsd_determine_extarmode_paras(iml,imr,.false.)
        if(linelp.le.12)   then
          call dv_ext_head_in_act()
        else
          call dv_ext_head_in_dbl()
        endif
      enddo

      return
      end

      subroutine dv_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.true.
      isma=iml
      lpok=jpadlr
      jmlr=mul_tab(jml,jmr)
      goto(101,102,103,104,105,106,10,108,109,110,111,112,    ! 107???
     :     113,10,115,10,117,118,119,120,121,122,123,124,125,10),lpok
!====================================================================
!sd(6-1) a&r(02)-
!sd(6-2) c(22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
!sd(6-5) a&r(23)b&r(13)b^r(32)
!sd(6-6) a&r(13)b&r(23)b^r(32)
!sd(6-7) a&r(13)b&l(32)b^l(23)
!sd(6-8) a&r(23)b&l(32)b^l(13)
!sd(6-9) d&r&r(03)b^r(32)
!sd(6-10) d&r&l(12)b^l(23)
!sd(6-11) d&r&l(22)b^l(13)
!sd(6-12) d&r&l(33)b^l(02)
!sd(6-13) (22)d&r&l(33)b^l(13)
!sd(6-14) d&r&l(33)c"(22)b^l(13)
!sd(6-15) d&r&l(33)b^l(13)c'(22)
!sd(6-16) d&r&l(33)b^l(23)c'(12)
106   if(linelp.ne.13) goto 107
      if(jb_sys.gt.0) call sd_adb_act_c_ext_ar(23)
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1=w0_sd(1)
        w0sd9=w0_sd(9)
        w1sd9=w1_sd(9)
        w0sd12=w0_sd(12)
        w1sd12=w1_sd(12)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0sd1=-w0sd1
        if(ni.eq.1) w0sd9=-w0sd9
        if(ni.eq.1) w1sd9=-w1sd9
        if(ni.eq.1) w0sd12=-w0sd12
        if(ni.eq.1) w1sd12=-w1sd12
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo

!sd(6-1) a&r(02)-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          call ar_dv_ext_ar(26,isma,lri,lrj)   !ar_dv

!sd(6-12) d&r&l(33)b^l(02)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd12
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd12
          enddo
          do lrk=1,lri-1
            call drl_bl_ext_ar_new(23,lrk,lri)
          enddo

!sd(6-9) d&r&r(03)b^r(32)
          do lrk=norb_frz+1,lri-1
            iwdl=just(lrk,lrk)
            iwdr=jud(lri)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd9
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd9
            enddo
            call drr_br_ext_ar(23,lrk,lri)
          enddo
        endif
      enddo

      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle

         if(lmi.eq.jmr) then
            iwdl=just(lri,lrj)
            iwdr=jud(lri)
            w0sd2=w0_sd(2)
            w0sd11=w0_sd(11)
            w1sd11=w1_sd(11)
            w0sd14=w0_sd(14)
            ni=mod(norb_dz-lrj,2)
            if(ni.eq.1) then
              w0sd2=-w0sd2
              w0sd11=-w0sd11
              w1sd11=-w1sd11
              w0sd14=-w0sd14
            endif
!sd(6-2) c(22)-a&r(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_dv_ext_ar(25,isma,lrj,lri) !ar_dv
!sd(6-11) d&r&l(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd11
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd11
            enddo
            call drl_bl_ext_ar_new(23,lri,lrj)
!sd(6-14) (22)d&r&l(33)b^l(13)
!sd(6-14) d&r&l(33)c"(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd14
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lrj-1
              if(lrk.eq.lri) cycle
              call drl_bl_ext_ar_new(23,lrk,lrj)
            enddo
          endif
!sd(6-4) a&r(23)-c'(12)-
          w0sd4=w0_sd(4)
          w0sd16=w0_sd(16)
          ni=mod(norb_dz-lri,2)
          if(ni.eq.0) then
            w0sd4=-w0sd4
            w0sd16=-w0sd16
          endif
          if(lmj.eq.jmr) then
            iwdl=just(lri,lrj)
            iwdr=jud(lrj)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd4
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_dv_ext_ar(28,isma,lri,lrj)   !ar_dv
!sd(6-16) d&r&l(33)b^l(23)c'(12)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd16
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(23,lrk,lri)
            enddo
          endif
!sd(6-5) a&r(23)b&r(13)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd=lsm_inn(lrd)
           if(lmd.ne.jmr) cycle

            w0sd5=w0_sd(5)
            w1sd5=w1_sd(5)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0sd5=-w0sd5
              w1sd5=-w1sd5
            endif
            iwdl=just(lri,lrj)
            iwdr=jud(lrd)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd5
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd5
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos=intind_ijka(ijk)
            call ar_br_br_ext_ar_new(23,intpos,isma)
          enddo
!sd(6-8) a&r(23)b&l(32)b^l(13)
          do lrd=lri+1,lrj-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdl=just(lri,lrj)
            iwdr=jud(lrd)
            w0sd8=w0_sd(8)
            w1sd8=w1_sd(8)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0sd8=-w0sd8
              w1sd8=-w1sd8
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd8
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd8
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            ijk=lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
            call ar_bl_bl_ext_ar_new(23,intpos,isma,1)
          enddo
        enddo
      enddo
!====================================================================
!sd(6)    act -br-br-
107   if(linelp.eq.20) then
        jk=nlg1
        call sd_ar_act_brbr(23,jk)
        if(jb_sys.gt.0) call sd_ar_act_brbr_sgt0(23,jk)
      endif
!sd(6)  act -bl-bl-
      if(linelp.eq.22) then
        jk=nlg1
        call sd_ar_act_blbl(23,jk)
        if(jb_sys.gt.0) call sd_ar_act_blbl_sgt0(23,jk)
      endif
      return
!=======================================================================
!td(13)                                  act -c'-
!td(13-1) (22)a&(23)
!td(13-1) a&(23)c'(22)
!td(13-2) a&(23)b&r(23)b^r(32)
!td(13-3) a&(23)b&l(32)b^l(23)
!td(13-4) d&r&l(22)b^l(23)
!td(13-5) (22)d&&l(33)b^l(23)
!td(13-5) d&rl(33)c"(22)b^l(23)
!td(13-5) d&rl(33)b^l(23)c'(22)
113   if(linelp.ne.13) goto 132
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          w0td1=w0_td(1)
          w0td4=w0_td(4)
          w1td4=w1_td(4)
          w0td5=w0_td(5)
          ni=mod(norb_dz-lrj,2)
          if(ni.eq.1) then
            w0td1=-w0td1
            w0td4=-w0td4
            w1td4=-w1td4
            w0td5=-w0td5
          endif
          iwdl=just(lri,lrj)     !
!-------------------------------------------------------------------
!td(13-1) (22)a&(23)
          if(lmi.eq.jmr) then
            iwdr=jud(lri)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_dv_ext_ar(43,isma,lrj,lri)
!td(13-4) d&r&l(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td4
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1td4
            enddo
            call drl_bl_ext_ar_new(23,lri,lrj)
!td(13-5) (22)d&rl(33)b^l(23)
!td(13-5) d&rl(33)c"(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td5
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lrj-1
              if(lrk.eq.lri) cycle
              call drl_bl_ext_ar_new(23,lrk,lrj)
            enddo
          endif
!-------------------------------------------------------------------
!td(13-1) a&(23)c'(22)
          if(lmj.eq.jmr) then
            iwdr=jud(lrj)
            w0td1=w0_td(1)
            w0td5=w0_td(5)
            ni=mod(norb_dz-lri,2)
            if(ni.eq.0) then
              w0td1=-w0td1
              w0td5=-w0td5
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_dv_ext_ar(46,isma,lri,lrj) !ar_dv
!td(13-5) d&rl(33)b^l(23)c'(22)
              do mpl=1,mtype
                vplp_w0(mpl)=vplpnew_w0(mpl)*w0td5
                vplp_w1(mpl)=0.d0
              enddo
              do lrk=1,lri-1
                call drl_bl_ext_ar_new(23,lrk,lri)
              enddo
            endif
!-------------------------------------------------------------------
!td(13-2) a&(23)b&r(23)b^r(32)
         do lrd=lrj+1,norb_dz
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdr=jud(lrd)
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos=intind_ijka(ijk)
            w0td2=w0_td(2)
            w1td2=w1_td(2)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0td2=-w0td2
              w1td2=-w1td2
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1td2
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_br_br_ext_ar_new(23,intpos,isma)
          enddo
!-------------------------------------------------------------------
!td(13-3) a&(23)b&l(32)b^l(23)
          do lrd=lri+1,lrj-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdr=jud(lrd)
            w0td3=w0_td(3)
            w1td3=w1_td(3)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0td3=-w0td3
              w1td3=-w1td3
            endif
            ijk=lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
              do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td3
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1td3
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_bl_bl_ext_ar_new(23,intpos,isma,1)
          enddo
!-------------------------------------------------------------------
        enddo
      enddo
!=======================================================================
!td(13) act -br-br-
132   if(linelp.eq.20) then
        jk=nlg1
        call td_ar_act_brbr(23,jk)
      endif
!td(13)  act -bl-bl-
      if(linelp.eq.22) then
        jk=nlg1
        call td_ar_act_blbl(23,jk)
      endif
      return
!=======================================================================
!dv(23) act -c'-..................................................
!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
123   if(linelp.ne.13) goto 232
      imap_1=0
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)

!dv(23-1) ar(23)-
        w0=w0_dv(1)
        if(ni.eq.1)w0=-w0_dv(1)
          iwdl=jud(lrd)
          iwdr=0
          imap_1=imap_1+1
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_dv_ext_ar(51,isma,lrd,0)   !ar_dv
!dv(23-2) drl(33)-bl(23)-
        w0=w0_dv(2)
        if(ni.eq.1)w0=-w0_dv(2)
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=0.d0
        enddo
        do lrk=1,lrd-1
          call drl_bl_ext_ar_new(23,lrk,lrd)
        enddo
      enddo
!=======================================================================
!dv(23) act -br-br-..................................................
232   if(linelp.ne.20) goto 233
      jk=nlg1
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)
        w0=w0_dv(1)
        if(ni.eq.1)w0=-w0_dv(1)
!..............................................................
!dv(23-1) ar(23)-
        iwdl=jud(lrd)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        ijk=lrd-norb_frz+jk
        intpos=intind_ijka(ijk)
        call ar_br_br_ext_ar_new(23,intpos,isma)
      enddo
!dv(23) act -bl-bl-.....................................................
233   if(linelp.ne.22) return
      jk=nlg1
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)
        w0=w0_dv(1)
        if(ni.eq.1)w0=-w0_dv(1)
!dv(23-1) ar(23)-
        iwdl=jud(lrd)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        ijk=lrd-norb_frz+jk
        intpos=intind_ijka(ijk)
        call ar_bl_bl_ext_ar_new(23,intpos,isma,1)
      enddo
      return
!=======================================================================
!ss(1)     act -b^l-
101   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call ss_drl_act_bl(23,lra)
        if(jb_sys.gt.0) then
           call ss_drl_act_bl_sgt0(23,lra)
        endif
      else
        call ss_arbl_act_bl(23,lra)
        if(jb_sys.gt.0) then
          call ss_arbl_act_bl_sgt0(23,lra)
          call ss_s_drl_act_bl_sgt0(23,lra)
        endif
      endif
      return
!=======================================================================
!st(2)      act -b^l
102   if(linelp.ne.15.or.nlg2.ne.2) return
      lra=nlg1
      call st_arbl_act_bl(23,lra)
      if(jb_sys.gt.0) call st_arbl_act_bl_sgt0(23,lra)
      if(jml.ne.jmr) return
      call st_drl_act_bl(23,lra)
      if(jb_sys.gt.0) call st_drl_act_bl_sgt0(23,lra)
      return
!=======================================================================
!ts(3)   act -b^l ............................................
103   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.ne.2) return
      call ts_arbl_act_bl(23,lra)
      if(jb_sys.gt.0) call ts_arbl_act_bl_sgt0(23,lra)
      return
!=======================================================================
!=======================================================================
!stt(4) act-b^l ..............................................
104   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) return
      call stt_arbl_act_bl_sgt1(23,lra)
      return
!=======================================================================
!tts(5) act-b^l ..............................................
105   if(linelp.ne.15.or.nlg2.ne.2) return
      lra=nlg1
      call tts_arbl_act_bl_sgt1(23,lra)
      call tts_drl_act_bl_sgt1(23,lra)
      return
!=======================================================================
!sdd(8) act-b^l -c'- -c"-..............................................

108   if(linelp.eq.13) then
        lra=nlg1
         call sdd_drlbl_act_c_sgt0(23)
         call sdd_drrbr_act_c_sgt0(23)
         call sdd_abb_act_c_sgt0(23)
         call sdd_ar_act_c_sd_ext_sgt0(23)
      else
        lra=nlg1
        if(linelp.eq.20) call sdd_ar_act_brbr_sgt0(23,lra)
        if(linelp.eq.22) call sdd_ar_act_blbl_sgt0(23,lra)
      endif
      return
!=======================================================================
!dds(9) act -c'- ..............................................
109   if(linelp.eq.13) then
        lra=nlg1
        call dds_abb_act_c_sgt0(23)
      endif
      return
!=======================================================================
!tt(11)   act -b^l
111   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call tt_drl_act_bl(23,lra)
      else
        call tt_arbl_act_bl(23,lra)
      endif
      return
!=======================================================================
!tttt(12)   act -b^l
112   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call tttt_drl_act_bl_sgt1(23,lra)
      else
        call tttt_arbl_act_bl_sgt1(23,lra)
      endif
      return
!=======================================================================
!ttv(19) act -b^r- ....................................................
118   if(linelp.ne.16.or.nlg2.ne.2) return
      lra=nlg1
      call ttv_arbr_act_c_sgt1(23,lra)
      return
!=======================================================================
!dd(19) act -b^l- ....................................................
119   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call dd_drl_act_bl(23,lra)
      else
        call dd_arbl_act_bl(23,lra)
      endif
      return
!=======================================================================
!dddd(19) act -b^l- -br- ...............................................
120   lra=nlg1
      if(linelp.eq.15) then
        if(nlg2.eq.2) then
          call  dddd_arbl_act_bl_sgt0(23,lra)
        else
          call dddd_drl_act_bl_sgt0(23,lra)
        endif
      endif
      return
!=======================================================================
!dd1(21) act -b^l-  ....................................................
121   if(linelp.ne.15.or.nlg2.ne.2) return
      lra=nlg1
      call dd1_arbl_act_bl_sgt0(23,lra)
      return
!=======================================================================
!d1d(21) act -b^l-  ....................................................
122   lra=nlg1
      if(linelp.eq.15.and.nlg2.eq.2) then
        call  d1d_arbl_act_bl_sgt0(23,lra)
        call d1d_drl_act_bl_sgt0(23,lra)
      endif
      return
!=======================================================================
!d1v(24) act -bl-bl -br-br- -c'- .......................................
124   lra=nlg1
      if(linelp.eq.13) then
        call d1v_drl_bl_act_c_sgt0(23)    ! drl-bl- ar-
      endif
      if(linelp.eq.22) then
        call d1v_ar_act_blbl_sgt0(23,lra)
      endif
      if(linelp.eq.20) then
        call d1v_ar_act_brbr_sgt0(23,lra)
      endif
      return
!=======================================================================
!vv(25) act -b^l- ....................................................
125   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        iwdl=0
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0_vv
          vplp_w1(mpl)=0.d0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call drl_bl_sum_ar_new(23,0,0,lra)
c        do lrk=1,norb_dz
c          call drl_bl_ext_ar_new(23,lrk,lra)
c        enddo
       endif
      return
!=======================================================================
!sv(10)     act -b^r-
!sv(10-1) ar(13)-br(23)-
!sv(10-2) ar(23)-br(13)-
!sv(10-3) drr(03)-
110   if(linelp.ne.16.or.nlg2.ne.2) return
      lra=nlg1
      if(jb_sys.gt.0) then
        call sv_arbr_act_br_sgt0(23,lra)
      endif
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          w0sv2=w0_sv(2)
          w1sv2=w1_sv(2)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0sv2=-w0sv2
            w1sv2=-w1sv2
          endif
!-------------------------------------------------------------------
          iwdl=just(lri,lrj)
          iwdr=0
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
         if(lri.ne.lrj) then
!sv(10-2) ar(23)-br(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sv2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sv2
            enddo
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
           intpos=intind_ijka(ijk)
            call ar_br_br_ext_ar_new(23,intpos,isma)
          else
!sv(10-3) drr(03)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_sv(3)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_sv(3)
            enddo
            call drr_br_ext_ar(23,lri,lra)
          endif
        enddo
      enddo
      return
!=======================================================================
!ttdd(15)    act -c'-   -br-br- -bl-bl
115   lra=nlg1
      if(linelp.eq.13) then
          call  ttdd_drlbl_act_c_sgt1(23)
          call ttdd_abb_act_c_sgt1(23)             ! ????
          call ttdd_ar_act_c_ttdd_ext_sgt1(23)
      endif
      if(linelp.eq.20) then
        call ttdd_ar_act_brbr_sgt0(23,lra)
      endif
      if(linelp.eq.22) then
        call ttdd_ar_act_blbl_sgt0(23,lra)
      endif
      return
!=======================================================================
!tv(17)    act -b^r-
117   if(linelp.ne.16.or.nlg2.ne.2) return
      lra=nlg1
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle

          w1tv=w1_tv
          ni=mod(lrj-lri,2)
          if(ni.eq.0)  w1tv=-w1tv

!-------------------------------------------------------------------
!tv(17) ar(23)-br(23)-
          iwdl=just(lri,lrj)     !
          iwdr=0
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1tv
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos=intind_ijka(ijk)
          call ar_br_br_ext_ar_new(23,intpos,isma)
        enddo
      enddo
      return
!=======================================================================
10    return
      end

      subroutine dv_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"

      logic_dh=.false.
      lri=nlg1
      lrj=nlg2
      intpos=nlg1
      isma=iml

      goto (1,2,3,4,5,6,7,8,9,10,11,12),linelp
!line=1 a&r<-->a^r
1     call ar_dv_ext_ar(51,isma,lri,lrj)      ! ar_dv_ext_ar(100_???
      goto 100
!line=4 a&r--b&r--b^r<-->a^r
4     call ar_br_br_ext_ar_new(23,intpos,isma)
      goto 100
!line=7 a&r--b&l--b^l<-->a^r
7     call ar_bl_bl_ext_ar_new(23,intpos,isma,1)
      goto 100
!line=10 d&rr--b^r<-->a^r
10    call drr_br_ext_ar(23,lri,lrj)
      goto 100
!line=12 d&rl--b^l<-->a^r
12    call drl_bl_ext_ar_new(23,lri,lrj)
      goto 100
2     goto 100
3     goto 100
5     goto 100
6     goto 100
8     goto 100
9     goto 100
11    goto 100
100   return
      end

      subroutine sd_drt_ci_new_den()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)
      data dsq2/1.414213562373d0/vsq2/0.7071067811865d0/
c      data dsq3/ 1.732050807569d0/
c      write(6,*)'  sd_wyb'
      w0_d25=vsq2
      w0_d26=-1.0d0
      w0_d27d=-vsq2
      w0_d27v=-vsq2/2
      w1_d27v=1.5d0*vsq2
      w0_d28=-vsq2
      w0_d29=-dsq2
      w0_d30=-1.0d0
      w0_d31=vsq2
      w0_d32sd=vsq2/2
      w1_d32sd=1.5d0*vsq2
      w0_d32ds=-0.5d0
      w1_d32ds=-1.5d0

!      logic_sd=.true.
      call external_space_plpmode_value_sd()

      idisk_lp=idisk_array(11)

      do lpblock=1,lpblock_sd
        call read_lp()
        ipael=iml+17
        ipae =imr+1
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
c        jmlr=mul_tab(jml,jmr)
        call gsd_determine_extarmode_paras(iml,imr,.true.)
        if(linelp.le.12)   then
          call sd_ext_head_in_act()
        else
          call sd_ext_head_in_dbl()
        endif
      enddo
      return
      end


      subroutine sd_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)
      data dsq2/1.414213562373d0/vsq2/0.7071067811865d0/
c      data dsq3/ 1.732050807569d0/
c      write(6,*)'  sd_wyb'
      w0_d25=vsq2
      w0_d26=-1.0d0
      w0_d27d=-vsq2
      w0_d27v=-vsq2/2
      w1_d27v=1.5d0*vsq2
      w0_d28=-vsq2
      w0_d29=-dsq2
      w0_d30=-1.0d0
      w0_d31=vsq2
      w0_d32sd=vsq2/2
      w1_d32sd=1.5d0*vsq2
      w0_d32ds=-0.5d0
      w1_d32ds=-1.5d0

!      logic_sd=.true.
      call external_space_plpmode_value_sd()

      idisk_lp=idisk_array(11)

      do lpblock=1,lpblock_sd
        call read_lp()
        ipael=iml+17
        ipae =imr+1
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
c        jmlr=mul_tab(jml,jmr)
        call gsd_determine_extarmode_paras(iml,imr,.true.)
        if(linelp.le.12)   then
          call sd_ext_head_in_act()
        else
          call sd_ext_head_in_dbl()
        endif
      enddo
      return
      end

      subroutine sd_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.true.
      isma=mul_tab(iml,imr)
      jmlr=mul_tab(jml,jmr)
      lpok=jpadlr
      goto(101,102,103,104,105,106,10,108,10,110,111,112, ! 109???
     :     113,10,115,10,117,118,119,120,121,122,123,124,125,10),lpok
!====================================================================
!sd(6-1) a&r(02)-
!sd(6-2) c(22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
!sd(6-5) a&r(23)b&r(13)b^r(32)
!sd(6-6) a&r(13)b&r(23)b^r(32)
!sd(6-7) a&r(13)b&l(32)b^l(23)
!sd(6-8) a&r(23)b&l(32)b^l(13)
!sd(6-9) d&r&r(03)b^r(32)
!sd(6-10) d&r&l(12)b^l(23)
!sd(6-11) d&r&l(22)b^l(13)
!sd(6-12) d&r&l(33)b^l(02)
!sd(6-13) (22)d&r&l(33)b^l(13)
!sd(6-14) d&r&l(33)c"(22)b^l(13)
!sd(6-15) d&r&l(33)b^l(13)c'(22)
!sd(6-16) d&r&l(33)b^l(23)c'(12)
106   if(linelp.ne.13) goto 107
      if(jb_sys.gt.0) then
        call sd_adb_act_c_ext_ar(6)
      endif
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1=w0_sd(1)
        w0sd9=w0_sd(9)
        w1sd9=w1_sd(9)
        w0sd12=w0_sd(12)
        w1sd12=w1_sd(12)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0sd1=-w0sd1
        if(ni.eq.1) w0sd9=-w0sd9
        if(ni.eq.1) w1sd9=-w1sd9
        if(ni.eq.1) w0sd12=-w0sd12
        if(ni.eq.1) w1sd12=-w1sd12
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo

!sd(6-1) a&r(02)-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          call ar_sd_ext_ar(26,lri,lrj,isma)
          call ar_sd_ext_rest(lri)

!sd(6-12) d&r&l(33)b^l(02)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd12
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd12
          enddo
          do lrk=1,lri-1
            call drl_bl_ext_ar_new(6,lrk,lri)
          enddo
!sd(6-9) d&r&r(03)b^r(32)
          do lrk=norb_frz+1,lri-1
            iwdl=just(lrk,lrk)
            iwdr=jud(lri)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd9
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd9
            enddo
            call drr_br_ext_ar(6,lrk,lri)
          enddo
        endif
      enddo

      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle

         if(lmi.eq.jmr) then
            iwdl=just(lri,lrj)
            iwdr=jud(lri)
            w0sd2=w0_sd(2)
            w0sd11=w0_sd(11)
            w1sd11=w1_sd(11)
            w0sd14=w0_sd(14)
            ni=mod(norb_dz-lrj,2)
            if(ni.eq.1) then
              w0sd2=-w0sd2
              w0sd11=-w0sd11
              w1sd11=-w1sd11
              w0sd14=-w0sd14
            endif
!sd(6-2) c(22)-a&r(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_sd_ext_ar(25,lrj,lri,isma)
            call ar_sd_ext_rest(lrj)
!sd(6-11) d&r&l(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd11
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd11
            enddo
            call drl_bl_ext_ar_new(6,lri,lrj)
!sd(6-14) (22)d&r&l(33)b^l(13)
!sd(6-14) d&r&l(33)c"(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd14
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lrj-1
              if(lrk.eq.lri) cycle
              call drl_bl_ext_ar_new(6,lrk,lrj)
            enddo
          endif
!sd(6-4) a&r(23)-c'(12)-
          w0sd4=w0_sd(4)
          w0sd16=w0_sd(16)
          ni=mod(norb_dz-lri,2)
          if(ni.eq.0) then
            w0sd4=-w0sd4
            w0sd16=-w0sd16
          endif
          if(lmj.eq.jmr) then
            iwdl=just(lri,lrj)
            iwdr=jud(lrj)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd4
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_sd_ext_ar(28,lri,lrj,isma)
            call ar_sd_ext_rest(lri)
!sd(6-16) d&r&l(33)b^l(23)c'(12)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd16
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(6,lrk,lri)
            enddo
          endif
!sd(6-5) a&r(23)b&r(13)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd=lsm_inn(lrd)
           if(lmd.ne.jmr) cycle

            w0sd5=w0_sd(5)
            w1sd5=w1_sd(5)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0sd5=-w0sd5
              w1sd5=-w1sd5
            endif
            iwdl=just(lri,lrj)
            iwdr=jud(lrd)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd5
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd5
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos=intind_ijka(ijk)
            call ar_br_br_ext_ar_new(6,intpos,isma)
          enddo
!sd(6-8) a&r(23)b&l(32)b^l(13)
          do lrd=lri+1,lrj-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdl=just(lri,lrj)
            iwdr=jud(lrd)
            w0sd8=w0_sd(8)
            w1sd8=w1_sd(8)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0sd8=-w0sd8
              w1sd8=-w1sd8
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd8
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd8
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            ijk=lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
            call ar_bl_bl_ext_ar_new(6,intpos,isma,1)
          enddo
        enddo
      enddo
!====================================================================
!sd(6)    act -br-br-
107   if(linelp.eq.20) then
        jk=nlg1
        call sd_ar_act_brbr(6,jk)
        if(jb_sys.gt.0) call sd_ar_act_brbr_sgt0(6,jk)
      endif
!sd(6)  act -bl-bl-
      if(linelp.eq.22) then
        jk=nlg1
        call sd_ar_act_blbl(6,jk)
        if(jb_sys.gt.0) call sd_ar_act_blbl_sgt0(6,jk)
      endif
      return
!=======================================================================
!td(13)                                  act -c'-
!td(13-1) (22)a&(23)
!td(13-1) a&(23)c'(22)
!td(13-2) a&(23)b&r(23)b^r(32)
!td(13-3) a&(23)b&l(32)b^l(23)
!td(13-4) d&r&l(22)b^l(23)
!td(13-5) (22)d&&l(33)b^l(23)
!td(13-5) d&rl(33)c"(22)b^l(23)
!td(13-5) d&rl(33)b^l(23)c'(22)
113   if(linelp.ne.13) goto 132
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          w0td1=w0_td(1)
          w0td4=w0_td(4)
          w1td4=w1_td(4)
          w0td5=w0_td(5)
          ni=mod(norb_dz-lrj,2)
          if(ni.eq.1) then
            w0td1=-w0td1
            w0td4=-w0td4
            w1td4=-w1td4
            w0td5=-w0td5
          endif
          iwdl=just(lri,lrj)       !
!-------------------------------------------------------------------
!td(13-1) (22)a&(23)
          if(lmi.eq.jmr) then
            iwdr=jud(lri)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_sd_ext_ar(43,lrj,lri,isma)
            call ar_sd_ext_rest(lrj)
!td(13-4) d&r&l(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td4
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1td4
            enddo
            call drl_bl_ext_ar_new(6,lri,lrj)
!td(13-5) (22)d&rl(33)b^l(23)
!td(13-5) d&rl(33)c"(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td5
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lrj-1
              if(lrk.eq.lri) cycle
              call drl_bl_ext_ar_new(6,lrk,lrj)
            enddo
          endif
!-------------------------------------------------------------------
!td(13-1) a&(23)c'(22)
          if(lmj.eq.jmr) then
            iwdr=jud(lrj)
            w0td1=w0_td(1)
            w0td5=w0_td(5)
            ni=mod(norb_dz-lri,2)
            if(ni.eq.0) then
              w0td1=-w0td1
              w0td5=-w0td5
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_sd_ext_ar(46,lri,lrj,isma)
            call ar_sd_ext_rest(lri)
!td(13-5) d&rl(33)b^l(23)c'(22)
              do mpl=1,mtype
                vplp_w0(mpl)=vplpnew_w0(mpl)*w0td5
                vplp_w1(mpl)=0.d0
              enddo
              do lrk=1,lri-1
                call drl_bl_ext_ar_new(6,lrk,lri)
              enddo
            endif
!-------------------------------------------------------------------
!td(13-2) a&(23)b&r(23)b^r(32)
         do lrd=lrj+1,norb_dz
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdr=jud(lrd)
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos=intind_ijka(ijk)
            w0td2=w0_td(2)
            w1td2=w1_td(2)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0td2=-w0td2
              w1td2=-w1td2
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1td2
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_br_br_ext_ar_new(6,intpos,isma)
          enddo
!-------------------------------------------------------------------
!td(13-3) a&(23)b&l(32)b^l(23)
          do lrd=lri+1,lrj-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdr=jud(lrd)
            w0td3=w0_td(3)
            w1td3=w1_td(3)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0td3=-w0td3
              w1td3=-w1td3
            endif
            ijk=lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
              do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td3
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1td3
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_bl_bl_ext_ar_new(6,intpos,isma,1)
          enddo
!-------------------------------------------------------------------
        enddo
      enddo
!=======================================================================
!td(13) act -br-br-
132   if(linelp.eq.20) then
        jk=nlg1
        call td_ar_act_brbr(6,jk)
      endif
!td(13)  act -bl-bl-
      if(linelp.eq.22) then
        jk=nlg1
        call td_ar_act_blbl(6,jk)
      endif
      return
!=======================================================================
!dv(23) act -c'-..................................................
!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
123   if(linelp.ne.13) goto 232
      imap_1=0
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)

!dv(23-1) ar(23)-
        w0=w0_dv(1)
        if(ni.eq.1)w0=-w0_dv(1)
          iwdl=jud(lrd)
          iwdr=0
          imap_1=imap_1+1
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_sd_ext_ar(51,lrd,0,isma)
        call ar_sd_ext_rest(lrd)
!dv(23-2) drl(33)-bl(23)-
        w0=w0_dv(2)
        if(ni.eq.1)w0=-w0_dv(2)
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=0.d0
        enddo
        do lrk=1,lrd-1
          call drl_bl_ext_ar_new(6,lrk,lrd)
        enddo
      enddo
!=======================================================================
!dv(23) act -br-br-..................................................
232   if(linelp.ne.20) goto 233
      jk=nlg1
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)
        w0=w0_dv(1)
        if(ni.eq.1)w0=-w0_dv(1)
!..............................................................
!dv(23-1) ar(23)-
        iwdl=jud(lrd)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        ijk=lrd-norb_frz+jk
        intpos=intind_ijka(ijk)
        call ar_br_br_ext_ar_new(6,intpos,isma)
      enddo
!dv(23) act -bl-bl-.....................................................
233   if(linelp.ne.22) return
      jk=nlg1
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)
        w0=w0_dv(1)
        if(ni.eq.1)w0=-w0_dv(1)
!dv(23-1) ar(23)-
        iwdl=jud(lrd)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        ijk=lrd-norb_frz+jk
        intpos=intind_ijka(ijk)
        call ar_bl_bl_ext_ar_new(6,intpos,isma,1)
      enddo
      return
!=======================================================================
!d1v(24) act -c'-..................................................
!d1v(24-1) ar(13)-
!d1v(24-2) drl(33)-bl(13)-
124   if(linelp.eq.13) then
        call d1v_ar_act_c_ext(6)
      endif
      if(linelp.eq.20) then
        jk=nlg1
        call d1v_ar_act_brbr_ext(6,jk)
      endif
      if(linelp.eq.22) then
        jk=nlg1
        call d1v_ar_act_blbl_ext(6,jk)
      endif
      return
!=======================================================================
!ss(1)     act -b^l-
101   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call ss_drl_act_bl(6,lra)
        if(jb_sys.gt.0) call ss_drl_act_bl_sgt0(6,lra)
      else
        call ss_arbl_act_bl(6,lra)
        if(jb_sys.gt.0) then
          call ss_arbl_act_bl_sgt0(6,lra)
          call ss_s_drl_act_bl_sgt0(6,lra)
        endif
      endif
      return
!=======================================================================
!st(2)      act -b^l
102   if(linelp.ne.15.or.nlg2.ne.2) return
      lra=nlg1
      call st_arbl_act_bl(6,lra)
      if(jml.eq.jmr) then
        call st_drl_act_bl(6,lra)
      endif
      if(jb_sys.gt.0) then
        call st_arbl_act_bl_sgt0(6,lra)
        if(jml.eq.jmr) then
          call st_drl_act_bl_sgt0(6,lra)
        endif
      endif
      return
!=======================================================================
!ts(3)   act -b^l ............................................
103   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.2) then
        call ts_arbl_act_bl(6,lra)
      endif
      return
!=======================================================================
!stt(4) act-b^l ..............................................
104   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) return
      call stt_arbl_act_bl_sgt1(6,lra)
      return
!=======================================================================
!tts(5) act-b^l ..............................................
105   if(linelp.ne.15.or.nlg2.ne.2) return
      lra=nlg1
      call tts_arbl_act_bl_sgt1(6,lra)
      call tts_drl_act_bl_sgt1(6,lra)
      return
!=======================================================================
!sdd(8) act-b^l -c'- -c"-..............................................
108   lra=nlg1
      if(linelp.eq.13) then
        call sdd_drlbl_act_c_sgt0(6)
        call sdd_drrbr_act_c_sgt0(6)
        call sdd_abb_act_c_sgt0(6)
        call sdd_ar_act_c_sd_ext_sgt0(6)
      else
        lra=nlg1
        if(linelp.eq.20) call sdd_ar_act_brbr_sgt0(6,lra)
        if(linelp.eq.22) call sdd_ar_act_blbl_sgt0(6,lra)
      endif
      return
!=======================================================================
!dds(9) act -c'- ..............................................
c109   if(linelp.eq.13) then
c        lra=nlg1
c        call dds_abb_act_c_sgt0(6)
c      endif
c      return
!=======================================================================
!tt(11)   act -b^l
111   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call tt_drl_act_bl(6,lra)
      else
        call tt_arbl_act_bl(6,lra)
      endif
      return
!=======================================================================
!tttt(12)   act -b^l
112   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call tttt_drl_act_bl_sgt1(6,lra)
      else
        call tttt_arbl_act_bl_sgt1(6,lra)
      endif
      return
!=======================================================================
!ttdd(15)    act -c'-   -br-br- -bl-bl
115   lra=nlg1
      if(linelp.eq.13) then                  ! no complete ar-
!        if(nlg2.eq.1) then
          call  ttdd_drlbl_act_c_sgt1(6)
          call ttdd_abb_act_c_sgt1(6)             ! ????
          call ttdd_ar_act_c_ttdd_ext_sgt1(6)
!        endif
      endif
      if(linelp.eq.20) then
        call ttdd_ar_act_brbr_sgt0(6,lra)
      endif
      if(linelp.eq.22) then
        call ttdd_ar_act_blbl_sgt0(6,lra)
      endif
      return
!=======================================================================
!ttv(19) act -b^r- ....................................................
118   if(linelp.ne.16.or.nlg2.ne.2) return
      lra=nlg1
      call ttv_arbr_act_c_sgt1(6,lra)
      return
!=======================================================================
!dd(19) act -b^l- ....................................................
119   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call dd_drl_act_bl(6,lra)
      else
        call dd_arbl_act_bl(6,lra)
      endif
      return
!=======================================================================
!dddd(19) act -b^l- -br- ...............................................
120   lra=nlg1
      if(linelp.eq.15) then
        if(nlg2.eq.2) then
          call  dddd_arbl_act_bl_sgt0(6,lra)
        else
          call dddd_drl_act_bl_sgt0(6,lra)
        endif
      endif
      return
!=======================================================================
!dd1(21) act -b^l-  ....................................................
121   if(linelp.ne.15.or.nlg2.ne.2) return
      lra=nlg1
      call dd1_arbl_act_bl_sgt0(6,lra)
      return
!=======================================================================
!d1d(22) act -b^l-  ....................................................
122   lra=nlg1
      if(linelp.eq.15.and.nlg2.eq.2) then
        call d1d_arbl_act_bl_sgt0(6,lra)
        call d1d_drl_act_bl_sgt0(6,lra)
      endif
      return
!=======================================================================
!vv(25) act -b^l- ....................................................
125   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        iwdl=0
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0_vv
          vplp_w1(mpl)=0.d0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call drl_bl_sum_ar_new(6,0,0,lra)
c        do lrk=1,norb_dz
c          call drl_bl_ext_ar_new(6,lrk,lra)
c        enddo
      endif
      return
!=======================================================================
!sv(10)     act -b^r-
!sv(10-1) ar(13)-br(23)-
!sv(10-2) ar(23)-br(13)-
!sv(10-3) drr(03)-
110   if(linelp.ne.16.or.nlg2.ne.2) return
      lra=nlg1
      if(jb_sys.gt.0) then
        call sv_arbr_act_br_sgt0(6,lra)
      endif
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          w0sv2=w0_sv(2)
          w1sv2=w1_sv(2)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0sv2=-w0sv2
            w1sv2=-w1sv2
          endif
!-------------------------------------------------------------------
          iwdl=just(lri,lrj)
          iwdr=0
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
         if(lri.ne.lrj) then
!sv(10-2) ar(23)-br(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sv2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sv2
            enddo
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
           intpos=intind_ijka(ijk)
            call ar_br_br_ext_ar_new(6,intpos,isma)
          else
!sv(10-3) drr(03)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_sv(3)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_sv(3)
            enddo
            call drr_br_ext_ar(6,lri,lra)
          endif
        enddo
      enddo
      return
!=======================================================================
!tv(17)    act -b^r-
117   if(linelp.ne.16.or.nlg2.ne.2) return
      lra=nlg1
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle

          w1tv=w1_tv
          ni=mod(lrj-lri,2)
          if(ni.eq.0)  w1tv=-w1tv

!-------------------------------------------------------------------
!tv(17) ar(23)-br(23)-
          iwdl=just(lri,lrj)     !
          iwdr=0
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1tv
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos=intind_ijka(ijk)
          call ar_br_br_ext_ar_new(6,intpos,isma)
        enddo
      enddo
      return
!=======================================================================
10    return
      end


      subroutine sd_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.false.
      lri=nlg1
      lrj=nlg2
      intpos=nlg1
      isma=mul_tab(iml,imr)

      goto (1,2,3,4,5,6,7,8,9,10,11,12),linelp
!line=1 a&r<-->a^r
1     call ar_sd_ext_ar(100,lri,lrj,isma)
      call ar_sd_ext_rest(lri)
      goto 100
!line=4 a&r--b&r--b^r<-->a^r
4     call ar_br_br_ext_ar_new(6,intpos,isma)
      goto 100
!line=7 a&r--b&l--b^l<-->a^r
7     call ar_bl_bl_ext_ar_new(6,intpos,isma,1)
      goto 100
!line=10 d&rr--b^r<-->a^r
10    call drr_br_ext_ar(6,lri,lrj)
      goto 100
!line=12 d&rl--b^l<-->a^r
12    call drl_bl_ext_ar_new(6,lri,lrj)
      goto 100
2     goto 100
3     goto 100
5     goto 100
6     goto 100
8     goto 100
9     goto 100
11    goto 100
100   return
      end

      subroutine sd_ext_space_w01plp_value()
#include "drt_h.fh"
#include "lpextmode_h.fh"
      w0plp25=w0_sdplp*w0g25a
      w0plp26=w0_sdplp*w0g26a
      w0plp27=w0_sdplp*w0g27
      w1plp27=w0_sdplp*w1g27
      w0plp28=w0_sdplp*w0g28a
      w0plp29=w0_sdplp*w0g29
      w0plp30=w0_sdplp*w0g30
      w0plp31=w0_sdplp*w0g31
      w1plp31=w0_sdplp*w1g31
      w0plp32=w0_sdplp*w0g32
      w1plp32=w0_sdplp*w1g32

      end

      subroutine gsd_samesym_aaa(lri,isma)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ia0=(lri-1)*norb_ext
      iabc0=(lri-1)*nabc

      ic=m_jd
        lrc=norb_number(ic)
      jcoffset=lrc*2-2

      iasta=ibsm_ext(isma)
      ibend=iesm_ext(isma)
      ibsta=iasta+1

      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)
      do ib=ibsta,ic-1
        do ia=iasta,ib-1
!     g31   type_12 arbrb^ra^r
          iabc=iabc0+ia+ngw2(ib)+ngw3(ic)
          iposint=intind_iabc(iabc)
          value_lpext(ilwei)=vint_ci(iposint+1)*w0plp31
     *               +vint_ci(iposint+2)*w1plp31
         ilwei=ilwei+1
      enddo
      enddo

      ib=ic
      ilwei=icnt_base+iwt_orb_ext(iasta,ib)
      do ia=iasta,ib-1
!        g28     cw-ar                    330
         iaqq=ia0+ia
         intpos=intind_iaqq(iaqq)
         iposint=intpos+jcoffset
          value_lpext(ilwei)=(vint_ci(iposint)/w0g28a
     :             +vint_ci(iposint+1))*w0plp28
         ilwei=ilwei+1
      enddo

      ia=ic
      do ib=ic+1,ibend
!        g25,g27: bl(20)-drl(11)         220
         iaqq=ia0+ib
         intpos=intind_iaqq(iaqq)
         iposint=intpos+jcoffset
         ilwei=icnt_base+iwt_orb_ext(ic,ib)
         value_lpext(ilwei)=vint_ci(iposint)*w0plp27
     :                    -vint_ci(iposint+1)*w1plp27
      enddo

      do ib=ic+1,ibend
        ilwei=icnt_base+iwt_orb_ext(iasta,ib)
        do ia=iasta,ic-1
!     g32a   type g12
          iabc=iabc0+ia+ngw2(ic)+ngw3(ib)
          iposint=intind_iabc(iabc)
          value_lpext(ilwei)=vint_ci(iposint+2)*w0plp32   !severe_new_er
     *                  -vint_ci(iposint)*w1plp32
          ilwei=ilwei+1
        enddo
      enddo

      do ib=ic+2,ibend
        ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
        do ia=ic+1,ib-1
          iabc=iabc0+ic+ngw2(ia)+ngw3(ib)
          iposint=intind_iabc(iabc)
!     g32b  type 11
         value_lpext(ilwei)=vint_ci(iposint+1)*w0plp32      !severe_new_
     *                  -vint_ci(iposint)*w1plp32
         ilwei=ilwei+1
        enddo
      enddo
      end

      subroutine gsd_diffsamesym_abb(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ia0=(lri-1)*norb_ext
      iabc0=(lri-1)*nabc

      ic=m_jd
        lrc=norb_number(ic)
      jcoffset=lrc*2-2

      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)
      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)

      ilwei=icnt_base+iwt_orb_ext(iasta,ibsta)
      do ib=ibsta,ic-1
        do ia=iasta,iaend
         !g31
!     g31   type_12 arbrb^ra^r
          iabc=iabc0+ia+ngw2(ib)+ngw3(ic)
          iposint=intind_iabc(iabc)
         value_lpext(ilwei)=vint_ci(iposint+1)*w0plp31      !severe_new_
     *               +vint_ci(iposint+2)*w1plp31
         ilwei=ilwei+1
        enddo
      enddo

      ilwei=icnt_base+iwt_orb_ext(iasta,ic+1)
      jb=m_jc
      do ib=ic+1,ibend
         jb=jb+1
        do ia=iasta,iaend
         !g32a
          iabc=iabc0+ia+ngw2(ic)+ngw3(ib)
          iposint=intind_iabc(iabc)
         value_lpext(ilwei)=vint_ci(iposint+2)*w0plp32   !severe_new_err
     *               -vint_ci(iposint)*w1plp32
         ilwei=ilwei+1
        enddo
      enddo

      ib=ic
      ilwei=icnt_base+iwt_orb_ext(iasta,ib)
      do ia=iasta,iaend      !ib-1      !severe_error_1020
!        g28
         iaqq=ia0+ia
         intpos=intind_iaqq(iaqq)
         iposint=intpos+jcoffset
c        value_lpext(ilwei)=(vint_ci(iposint2)+
         value_lpext(ilwei)=w0plp28*(vint_ci(iposint)/w0g28a+
     *                              vint_ci(iposint+1))
         ilwei=ilwei+1
      enddo
      end

      subroutine gsd_diffsamesym_aab(lri,isma,ismb)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ia0=(lri-1)*norb_ext
      iabc0=(lri-1)*nabc

      ic=m_jd
        lrc=norb_number(ic)
      jcoffset=lrc*2-2

      ibsta=ibsm_ext(ismb)
      ibend=iesm_ext(ismb)
      iasta=ibsm_ext(isma)
      iaend=iesm_ext(isma)

      !   if ( ic-1.gt.iasta) then
      do ib=ibsta,ibend
         ilwei=icnt_base+iwt_orb_ext(iasta,ib)
        do ia=iasta,ic-1
         !g32a
          iabc=iabc0+ia+ngw2(ic)+ngw3(ib)
          iposint=intind_iabc(iabc)
         value_lpext(ilwei)=vint_ci(iposint+2)*w0plp32      !severe_new_
     *                  -vint_ci(iposint)*w1plp32
         ilwei=ilwei+1
        enddo
      enddo

      do ib=ibsta,ibend
         ilwei=icnt_base+iwt_orb_ext(ic+1,ib)
        do ia=ic+1,iaend      !ib-1      !severe_error_1020
          iabc=iabc0+ic+ngw2(ia)+ngw3(ib)
          iposint=intind_iabc(iabc)
         !g32b
         value_lpext(ilwei)=vint_ci(iposint+1)*w0plp32   !severe_new_err
     *                  -vint_ci(iposint)*w1plp32
         ilwei=ilwei+1
        enddo
      enddo

      ia=ic
      do ib=ibsta,ibend
!        g25
         iaqq=ia0+ib
         intpos=intind_iaqq(iaqq)
         iposint=intpos+jcoffset
         ilwei=icnt_base+iwt_orb_ext(ic,ib)
         value_lpext(ilwei)=vint_ci(iposint)*w0plp27
     :                    -vint_ci(iposint+1)*w1plp27
      enddo
      end

      subroutine gsd_arlp_s1(lri)
#include "drt_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *   m_jc,m_jd, isegsta,isegupwei,isegdownwei

      ia0=(lri-1)*norb_ext
      ic=m_jd

      iaqq=ia0+ic
      intpos=intind_iaqq(iaqq)

      ilwei=icnt_base+isegdownwei-norb_ext+1
      do is1orb=1,ic-1
!g30 -b^rd^rr
         lrk=norb_number(is1orb)
         intoffset=(lrk-1)*2
         iposint=intpos+intoffset
         value_lpext(ilwei)=vint_ci(iposint)*w0plp30
         ilwei=ilwei+1
      enddo

!g26 -a^r     610
      lrk=norb_number(ic)
      intoffset=(lrk-1)*2
      iposint=intpos+intoffset
      value_lpext(ilwei)=vint_ci(iposint)*w0plp26
      ilwei=ilwei+1

!g29 -dl^ra^l
      do is1orb=ic+1,norb_ext
      lrk=norb_number(is1orb)
      intoffset=(lrk-1)*2
      iposint=intpos+intoffset
        value_lpext(ilwei)=vint_ci(iposint)*w0plp29
        ilwei=ilwei+1
      enddo
      end

      subroutine td_drt_ci_new()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      common/lpdisk/idisk_lp,idisk_array(13)
      data dzero/0.d0/dsq2/1.414213562373d0/
      data dsq3/ 1.732050807569d0/
      data dsq3vsq2/1.224744871392d0/
c      write(6,*)'  td_wyb'
      w0_d43=dsq3vsq2
      w0_d44d=-dsq3vsq2
      w1_d44d=dzero
      w0_d44v=-dsq3/(2*dsq2)
      w1_d44v=w0_d44v
      w0_d45=dzero
!     w1_d45=dsq3/dsq2
!      w0_d46=dsq3/dsq2
      w1_d45=dsq3vsq2
      w0_d46=dsq3vsq2
      w0_d47td=-dsq3/(dsq2*2)
      w1_d47td=-w0_d47td
      w0_d47dt=-0.5d0
      w1_d47dt=-w0_d47dt

!      logic_sd=.true.
      call external_space_plpmode_value_td()
      w0_sdplp=1.0d0
      call sd_ext_space_w01plp_value()

      idisk_lp=idisk_array(7)
      do lpblock=1,lpblock_td
        call read_lp()
        ipael=iml+9
        ipae =imr+1
        call get_jpty(jpadlr,jptyl,jptyr)
        call get_jp(jptyl,jml,jpadl,1)
        call get_jp(jptyr,jmr,jpad,1)
c        jmlr=mul_tab(jml,jmr)
        call gsd_determine_extarmode_paras(iml,imr,.false.)
        if(linelp.le.12)   then
          call td_ext_head_in_act()
        else
          call td_ext_head_in_dbl()
        endif
      enddo
      return
      end

      subroutine td_ext_head_in_dbl()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.true.
      isma=mul_tab(iml,imr)
      jmlr=mul_tab(jml,jmr)
      lpok=jpadlr
!      goto(101,102,103,104,105,106,10,108,109,110,111,112,
!     :     113,10,115,10,117,118,119,120,121,122,123,124,125,10),lpok
      goto(101,102,103,104,105,106,10,108,109,110,111,112,
     :     113,10,115,10,117,118,119,120,121,122,123,124,125,10),lpok
!====================================================================
!sd(6-1) a&r(02)-
!sd(6-2) c(22)a&(13)-
!sd(6-3) a&r(13)c'(22)-
!sd(6-4) a&r(23)c'(12)-
!sd(6-5) a&r(23)b&r(13)b^r(32)
!sd(6-6) a&r(13)b&r(23)b^r(32)
!sd(6-7) a&r(13)b&l(32)b^l(23)
!sd(6-8) a&r(23)b&l(32)b^l(13)
!sd(6-9) d&r&r(03)b^r(32)
!sd(6-10) d&r&l(12)b^l(23)
!sd(6-11) d&r&l(22)b^l(13)
!sd(6-12) d&r&l(33)b^l(02)
!sd(6-13) (22)d&r&l(33)b^l(13)
!sd(6-14) d&r&l(33)c"(22)b^l(13)
!sd(6-15) d&r&l(33)b^l(13)c'(22)
!sd(6-16) d&r&l(33)b^l(23)c'(12)
106   if(linelp.ne.13) goto 107
      if(jb_sys.gt.0) then
        call sd_adb_act_c_ext_ar(13)
      endif
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        if(lmi.ne.jmlr) cycle
        w0sd1=w0_sd(1)
        w0sd9=w0_sd(9)
        w1sd9=w1_sd(9)
        w0sd12=w0_sd(12)
        w1sd12=w1_sd(12)
        ni=mod(norb_dz-lri,2)
        if(ni.eq.1) w0sd1=-w0sd1
        if(ni.eq.1) w0sd9=-w0sd9
        if(ni.eq.1) w1sd9=-w1sd9
        if(ni.eq.1) w0sd12=-w0sd12
        if(ni.eq.1) w1sd12=-w1sd12
        if(jml.eq.1.and.lmi.eq.jmr) then
          iwdl=just(lri,lri)
          iwdr=jud(lri)
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo

!sd(6-1) a&r(02)-
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd1
            vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd1
          enddo
          call ar_td_ext_ar(26,lri,lrj,isma)
          call ar_td_ext_rest(lri)

!sd(6-12) d&r&l(33)b^l(02)
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd12
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd12
          enddo
          do lrk=1,lri-1
            call drl_bl_ext_ar_new(13,lrk,lri)
          enddo

!sd(6-9) d&r&r(03)b^r(32)
          do lrk=norb_frz+1,lri-1
            iwdl=just(lrk,lrk)
            iwdr=jud(lri)
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd9
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd9
            enddo
            call drr_br_ext_ar(13,lrk,lri)
          enddo
        endif
      enddo

      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle

         if(lmi.eq.jmr) then
            iwdl=just(lri,lrj)
            iwdr=jud(lri)
            w0sd2=w0_sd(2)
            w0sd11=w0_sd(11)
            w1sd11=w1_sd(11)
            w0sd14=w0_sd(14)
            ni=mod(norb_dz-lrj,2)
            if(ni.eq.1) then
              w0sd2=-w0sd2
              w0sd11=-w0sd11
              w1sd11=-w1sd11
              w0sd14=-w0sd14
            endif
!sd(6-2) c(22)-a&r(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd2
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_td_ext_ar(25,lrj,lri,isma)
            call ar_td_ext_rest(lrj)
!sd(6-11) d&r&l(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd11
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd11
            enddo
            call drl_bl_ext_ar_new(13,lri,lrj)
!sd(6-14) (22)d&r&l(33)b^l(13)
!sd(6-14) d&r&l(33)c"(22)b^l(13)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd14
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lrj-1
              if(lrk.eq.lri) cycle
              call drl_bl_ext_ar_new(13,lrk,lrj)
            enddo
          endif
!sd(6-4) a&r(23)-c'(12)-
          w0sd4=w0_sd(4)
          w0sd16=w0_sd(16)
          ni=mod(norb_dz-lri,2)
          if(ni.eq.0) then
            w0sd4=-w0sd4
            w0sd16=-w0sd16
          endif
          if(lmj.eq.jmr) then
            iwdl=just(lri,lrj)
            iwdr=jud(lrj)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd4
 !             vplp_w1(mpl)=vplpnew_w1(mpl)*w0sd4
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_td_ext_ar(28,lri,lrj,isma)
            call ar_td_ext_rest(lri)
!sd(6-16) d&r&l(33)b^l(23)c'(12)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd16
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lri-1
              call drl_bl_ext_ar_new(13,lrk,lri)
            enddo
          endif
!sd(6-5) a&r(23)b&r(13)b^r(32)
          do lrd=lrj+1,norb_dz
            lmd=lsm_inn(lrd)
           if(lmd.ne.jmr) cycle

            w0sd5=w0_sd(5)
            w1sd5=w1_sd(5)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0sd5=-w0sd5
              w1sd5=-w1sd5
            endif
            iwdl=just(lri,lrj)
            iwdr=jud(lrd)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd5
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd5
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos=intind_ijka(ijk)
            call ar_br_br_ext_ar_new(13,intpos,isma)
          enddo
!sd(6-8) a&r(23)b&l(32)b^l(13)
          do lrd=lri+1,lrj-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdl=just(lri,lrj)
            iwdr=jud(lrd)
            w0sd8=w0_sd(8)
            w1sd8=w1_sd(8)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0sd8=-w0sd8
              w1sd8=-w1sd8
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sd8
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sd8
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            ijk=lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
            call ar_bl_bl_ext_ar_new(13,intpos,isma,1)
          enddo
        enddo
      enddo
!====================================================================
!sd(6)    act -br-br-
107   if(linelp.eq.20) then
        jk=nlg1
        call sd_ar_act_brbr(13,jk)
        if(jb_sys.gt.0) call sd_ar_act_brbr_sgt0(13,jk)
      endif
!sd(6)  act -bl-bl-
      if(linelp.eq.22) then
        jk=nlg1
        call sd_ar_act_blbl(13,jk)
        if(jb_sys.gt.0) call sd_ar_act_blbl_sgt0(13,jk)
      endif
      return
!=======================================================================
!td(13)                                  act -c'-
!td(13-1) (22)a&(23)
!td(13-1) a&(23)c'(22)
!td(13-2) a&(23)b&r(23)b^r(32)
!td(13-3) a&(23)b&l(32)b^l(23)
!td(13-4) d&r&l(22)b^l(23)
!td(13-5) (22)d&&l(33)b^l(23)
!td(13-5) d&rl(33)c"(22)b^l(23)
!td(13-5) d&rl(33)b^l(23)c'(22)
113   if(linelp.ne.13) goto 132
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          w0td1=w0_td(1)
          w0td4=w0_td(4)
          w1td4=w1_td(4)
          w0td5=w0_td(5)
          ni=mod(norb_dz-lrj,2)
          if(ni.eq.1) then
            w0td1=-w0td1
            w0td4=-w0td4
            w1td4=-w1td4
            w0td5=-w0td5
          endif
          iwdl=just(lri,lrj)      !
!-------------------------------------------------------------------
!td(13-1) (22)a&(23)
          if(lmi.eq.jmr) then
            iwdr=jud(lri)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_td_ext_ar(43,lrj,lri,isma)
            call ar_td_ext_rest(lrj)
!td(13-4) d&r&l(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td4
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1td4
            enddo
            call drl_bl_ext_ar_new(13,lri,lrj)
!td(13-5) (22)d&rl(33)b^l(23)
!td(13-5) d&rl(33)c"(22)b^l(23)
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td5
              vplp_w1(mpl)=0.d0
            enddo
            do lrk=1,lrj-1
              if(lrk.eq.lri) cycle
              call drl_bl_ext_ar_new(13,lrk,lrj)
            enddo
          endif
!-------------------------------------------------------------------
!td(13-1) a&(23)c'(22)
          if(lmj.eq.jmr) then
            iwdr=jud(lrj)
            w0td1=w0_td(1)
            w0td5=w0_td(5)
            ni=mod(norb_dz-lri,2)
            if(ni.eq.0) then
              w0td1=-w0td1
              w0td5=-w0td5
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td1
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_td_ext_ar(46,lri,lrj,isma)
            call ar_td_ext_rest(lri)
!td(13-5) d&rl(33)b^l(23)c'(22)
              do mpl=1,mtype
                vplp_w0(mpl)=vplpnew_w0(mpl)*w0td5
                vplp_w1(mpl)=0.d0
              enddo
              do lrk=1,lri-1
                call drl_bl_ext_ar_new(13,lrk,lri)
              enddo
            endif
!-------------------------------------------------------------------
!td(13-2) a&(23)b&r(23)b^r(32)
         do lrd=lrj+1,norb_dz
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdr=jud(lrd)
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lrd-norb_frz)
            intpos=intind_ijka(ijk)
            w0td2=w0_td(2)
            w1td2=w1_td(2)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0td2=-w0td2
              w1td2=-w1td2
            endif
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1td2
            enddo
            do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_br_br_ext_ar_new(13,intpos,isma)
          enddo
!-------------------------------------------------------------------
!td(13-3) a&(23)b&l(32)b^l(23)
          do lrd=lri+1,lrj-1
            lmd=lsm_inn(lrd)
            if(lmd.ne.jmr) cycle
            iwdr=jud(lrd)
            w0td3=w0_td(3)
            w1td3=w1_td(3)
            ni=mod(lrj-lri+norb_dz-lrd,2)
            if(ni.eq.0) then
              w0td3=-w0td3
              w1td3=-w1td3
            endif
            ijk=lri-norb_frz+ngw2(lrd-norb_frz)+ngw3(lrj-norb_frz)
            intpos=intind_ijka(ijk)
              do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0td3
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1td3
            enddo
              do mpl=1,mhlp
              iwal=lpnew_lwei(mpl)
              iwar=lpnew_rwei(mpl)
              lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
              lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
            enddo
            call ar_bl_bl_ext_ar_new(13,intpos,isma,1)
          enddo
!-------------------------------------------------------------------
        enddo
      enddo
!=======================================================================
!td(13) act -br-br-
132   if(linelp.eq.20) then
        jk=nlg1
        call td_ar_act_brbr(13,jk)
      endif
!td(13)  act -bl-bl-
      if(linelp.eq.22) then
        jk=nlg1
        call td_ar_act_blbl(13,jk)
      endif
      return
!=======================================================================
!dv(23) act -c'-..................................................
!dv(23-1) ar(23)-
!dv(23-2) drl(33)-bl(23)-
123   if(linelp.ne.13) goto 232
      imap_1=0
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)

!dv(23-1) ar(23)-
        w0=w0_dv(1)
        if(ni.eq.1)w0=-w0_dv(1)
          iwdl=jud(lrd)
          iwdr=0
          imap_1=imap_1+1
          do mpl=1,mtype
            vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call ar_td_ext_ar(51,lrd,0,isma)
        call ar_td_ext_rest(lrd)
!dv(23-2) drl(33)-bl(23)-
        w0=w0_dv(2)
        if(ni.eq.1)w0=-w0_dv(2)
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=0.d0
        enddo
        do lrk=1,lrd-1
          call drl_bl_ext_ar_new(13,lrk,lrd)
        enddo
      enddo
!=======================================================================
!dv(23) act -br-br-..................................................
232   if(linelp.ne.20) goto 233
      jk=nlg1
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)
        w0=w0_dv(1)
        if(ni.eq.1)w0=-w0_dv(1)
!..............................................................
!dv(23-1) ar(23)-
        iwdl=jud(lrd)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        ijk=lrd-norb_frz+jk
        intpos=intind_ijka(ijk)
        call ar_br_br_ext_ar_new(13,intpos,isma)
      enddo
!dv(23) act -bl-bl-.....................................................
233   if(linelp.ne.22) return
      jk=nlg1
      do lrd=norb_frz+1,norb_dz
        lmd=lsm_inn(lrd)
        if(lmd.ne.jml) cycle
        ni=mod(norb_dz-lrd,2)
        w0=w0_dv(1)
        if(ni.eq.1)w0=-w0_dv(1)
!dv(23-1) ar(23)-
        iwdl=jud(lrd)
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0
          vplp_w1(mpl)=vplpnew_w1(mpl)*w0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        ijk=lrd-norb_frz+jk
        intpos=intind_ijka(ijk)
        call ar_bl_bl_ext_ar_new(13,intpos,isma,1)
      enddo
      return
!=======================================================================
!ss(1)     act -b^l-
101   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call ss_drl_act_bl(13,lra)
        if(jb_sys.gt.0) call ss_drl_act_bl_sgt0(13,lra)
      else
        call ss_arbl_act_bl(13,lra)
        if(jb_sys.gt.0) then
          call ss_arbl_act_bl_sgt0(13,lra)
          call ss_s_drl_act_bl_sgt0(13,lra)
        endif
      endif
      return
!=======================================================================
!st(2)      act -b^l
102   if(linelp.ne.15.or.nlg2.ne.2) return
      lra=nlg1
      call st_arbl_act_bl(13,lra)
      if(jb_sys.gt.0) call st_arbl_act_bl_sgt0(13,lra)
      if(jml.eq.jmr) then
        call st_drl_act_bl(13,lra)
        if(jb_sys.gt.0) call st_drl_act_bl_sgt0(13,lra)
      endif
      return
!=======================================================================
!ts(3)   act -b^l ............................................
103   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.2) then
        call ts_arbl_act_bl(13,lra)
        if(jb_sys.gt.0) call ts_arbl_act_bl_sgt0(13,lra)
      endif
      return
!=======================================================================
!stt(4) act-b^l ..............................................
104   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) return
      call stt_arbl_act_bl_sgt1(13,lra)
      return
!=======================================================================
!tts(5) act-b^l ..............................................
105   if(linelp.ne.15.or.nlg2.ne.2) return
      lra=nlg1
      call tts_arbl_act_bl_sgt1(13,lra)
      call tts_drl_act_bl_sgt1(13,lra)
      return
!=======================================================================
!sdd(8) act-b^l -c'- -c"-..............................................
108   if(linelp.eq.13) then
        lra=nlg1
        call sdd_drlbl_act_c_sgt0(13)
        call sdd_drrbr_act_c_sgt0(13)
        call sdd_abb_act_c_sgt0(13)
        call sdd_ar_act_c_sd_ext_sgt0(13)
      else
        lra=nlg1
        if(linelp.eq.20) call sdd_ar_act_brbr_sgt0(13,lra)
        if(linelp.eq.22) call sdd_ar_act_blbl_sgt0(13,lra)
      endif
      return
!=======================================================================
!dds(9) act -c'- ..............................................
109   if(linelp.eq.13) then
        lra=nlg1
        call dds_abb_act_c_sgt0(13)
      endif
      return
!=======================================================================
!tt(11)   act -b^l
111   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call tt_drl_act_bl(13,lra)
      else
        call tt_arbl_act_bl(13,lra)
      endif
      return
!=======================================================================
!tttt(12)   act -b^l
112   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call tttt_drl_act_bl_sgt1(13,lra)
      else
        call tttt_arbl_act_bl_sgt1(13,lra)
      endif
      return
!=======================================================================
!ttdd(15)    act -c'-   -br-br- -bl-bl
115   lra=nlg1
      if(linelp.eq.13) then                  ! no complete ar-
!        if(nlg2.eq.1) then
          call ttdd_drlbl_act_c_sgt1(13)
          call ttdd_abb_act_c_sgt1(13)             ! ????
          call ttdd_ar_act_c_ttdd_ext_sgt1(13)
!        endif
      endif
      if(linelp.eq.20) then
        call ttdd_ar_act_brbr_sgt0(13,lra)
      endif
      if(linelp.eq.22) then
        call ttdd_ar_act_blbl_sgt0(13,lra)
      endif
      return
!======================================================
!t1v(18) arbr act -c"- ext -br-ar -ar  ! no complete
118   if(nlg2.ne.2.or.linelp.ne.16) return
      lra=nlg1
      call ttv_arbr_act_c_sgt1(13,lra)
      return
!=======================================================================
!dd(19) act -b^l- ....................................................
119   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call dd_drl_act_bl(13,lra)
      else
        call dd_arbl_act_bl(13,lra)
      endif
      return
!=======================================================================
!dddd(20) act -b^l-  ...................................................
120   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        call dddd_drl_act_bl_sgt0(13,lra)
      else
        call  dddd_arbl_act_bl_sgt0(13,lra)
      endif
      return
!=======================================================================
!dd1(21) act -b^l-  ....................................................
121   if(linelp.ne.15.or.nlg2.ne.2) return
      lra=nlg1
      call dd1_arbl_act_bl_sgt0(13,lra)
      return
!=======================================================================
!d1d(22) act -b^l-  ....................................................
122   lra=nlg1
      if(linelp.eq.15.and.nlg2.eq.2) then
        call d1d_arbl_act_bl_sgt0(13,lra)
        call d1d_drl_act_bl_sgt0(13,lra)
      endif
      return
!=======================================================================
!d1v(24) act -c'-..................................................
!d1v(24-1) ar(13)-
!d1v(24-2) drl(33)-bl(13)-
124   if(linelp.eq.13) then
        call d1v_ar_act_c_ext(13)
      endif
      if(linelp.eq.20) then
        jk=nlg1
        call d1v_ar_act_brbr_ext(13,jk)
      endif
      if(linelp.eq.22) then
        jk=nlg1
        call d1v_ar_act_blbl_ext(13,jk)
      endif
      return
!=======================================================================
!vv(25) act -b^l- ....................................................
125   if(linelp.ne.15) return
      lra=nlg1
      if(nlg2.eq.1) then
        iwdl=0
        iwdr=0
        do mpl=1,mtype
          vplp_w0(mpl)=vplpnew_w0(mpl)*w0_vv
          vplp_w1(mpl)=0.d0
        enddo
        do mpl=1,mhlp
          iwal=lpnew_lwei(mpl)
          iwar=lpnew_rwei(mpl)
          lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
          lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
        enddo
        call drl_bl_sum_ar_new(13,0,0,lra)
c        do lrk=1,norb_dz
c          call drl_bl_ext_ar_new(13,lrk,lra)
c        enddo
      endif
      return
!=======================================================================
!sv(10)     act -b^r-
!sv(10-1) ar(13)-br(23)-
!sv(10-2) ar(23)-br(13)-
!sv(10-3) drr(03)-
110   if(linelp.ne.16.or.nlg2.ne.2) return
      lra=nlg1
      if(jb_sys.gt.0) then
        call sv_arbr_act_br_sgt0(13,lra)
      endif
      do lri=norb_frz+1,norb_dz
        lmi=lsm_inn(lri)
        do lrj=lri,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle
          w0sv2=w0_sv(2)
          w1sv2=w1_sv(2)
          ni=mod(lrj-lri,2)
          if(ni.eq.0) then
            w0sv2=-w0sv2
            w1sv2=-w1sv2
          endif
!-------------------------------------------------------------------
          iwdl=just(lri,lrj)
          iwdr=0
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
         if(lri.ne.lrj) then
!sv(10-2) ar(23)-br(13)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0sv2
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1sv2
            enddo
            ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
           intpos=intind_ijka(ijk)
            call ar_br_br_ext_ar_new(13,intpos,isma)
          else
!sv(10-3) drr(03)-
            do mpl=1,mtype
              vplp_w0(mpl)=vplpnew_w0(mpl)*w0_sv(3)
              vplp_w1(mpl)=vplpnew_w1(mpl)*w1_sv(3)
            enddo
            call drr_br_ext_ar(13,lri,lra)
          endif
        enddo
      enddo
      return
!=======================================================================
!tv(17)    act -b^r-
117   if(linelp.ne.16.or.nlg2.ne.2) return
      lra=nlg1
      do lri=norb_frz+1,norb_dz-1
        lmi=lsm_inn(lri)
        do lrj=lri+1,norb_dz
          lmj=lsm_inn(lrj)
          lmij=mul_tab(lmi,lmj)
          if(lmij.ne.jml) cycle

          w1tv=w1_tv
          ni=mod(lrj-lri,2)
          if(ni.eq.0)  w1tv=-w1tv

!-------------------------------------------------------------------
!tv(17) ar(23)-br(23)-
          iwdl=just(lri,lrj)      !
          iwdr=0
          do mpl=1,mtype
            vplp_w0(mpl)=0.d0
            vplp_w1(mpl)=vplpnew_w1(mpl)*w1tv
          enddo
          do mpl=1,mhlp
            iwal=lpnew_lwei(mpl)
            iwar=lpnew_rwei(mpl)
            lp_lwei(mpl)=iwalk_ad(jpadl,ipael,iwal,iwdl)
            lp_rwei(mpl)=iwalk_ad(jpad,ipae,iwar,iwdr)
          enddo
          ijk=lri-norb_frz+ngw2(lrj-norb_frz)+ngw3(lra-norb_frz)
          intpos=intind_ijka(ijk)
          call ar_br_br_ext_ar_new(13,intpos,isma)
        enddo
      enddo
      return
!=======================================================================
10    return
      end


      subroutine td_ext_head_in_act()
#include "drt_h.fh"
#include "intsort_h.fh"
#include "pl_structure_h.fh"
#include "lpextmode_h.fh"
      logic_dh=.false.
      lri=nlg1
      lrj=nlg2
      intpos=nlg1
      isma=mul_tab(iml,imr)

      goto (1,2,3,4,5,6,7,8,9,10,11,12),linelp
!line=1 a&r<-->a^r
1     call ar_td_ext_ar(100,lri,lrj,isma)
      call ar_td_ext_rest(lri)
      goto 100
!line=4 a&r--b&r--b^r<-->a^r
4     call ar_br_br_ext_ar_new(13,intpos,isma)
      goto 100
!line=7 a&r--b&l--b^l<-->a^r
7     call ar_bl_bl_ext_ar_new(13,intpos,isma,1)
      goto 100
!line=10 d&rr--b^r<-->a^r
10    call drr_br_ext_ar(13,lri,lrj)
      goto 100
!line=12 d&rl--b^l<-->a^r
12    call drl_bl_ext_ar_new(13,lri,lrj)
      goto 100
2     goto 100
3     goto 100
5     goto 100
6     goto 100
8     goto 100
9     goto 100
11    goto 100
100   return
      end


      subroutine gsd_ext_sequence(iltype,ilsm,irsm,lri)
#include "drt_h.fh"
#include "intsort_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *      m_jc,m_jd, isegsta,isegupwei,isegdownwei
      ismnodes=ilsm
      ismnoded=irsm
      ismsd=mul_tab(ismnodes,ismnoded)
      indl=0 !?
      if(iltype.eq.2)indl= 1+ismnodes
      if(iltype.eq.3)indl= 9+ismnodes
      if(iltype.eq.4)indl=17+ismnodes
      ilnodedownwei=iseg_downwei(indl)
      isegdownwei  =ilnodedownwei
      icano_nnsta=1
      icnt_base=0
      icsta=ibsm_ext(ismnoded)
      icend=iesm_ext(ismnoded)
      m_jc=0

      do ic=icsta,icend
            m_jd=ic
            m_jc=ic-icsta+1
            icano_nn=m_jc
            icano_nnend=icano_nn
            do ismb=1,ismnoded-1
                  isma=mul_tab(ismnodes,ismb)
                  if ( isma .gt. ismb ) cycle
                  call g31_diffsym(lri,isma,ismb)
            enddo

            ismb=ismnoded
            isma=mul_tab(ismnodes,ismb)
            if ( isma .eq. ismb ) then
               call gsd_samesym_aaa(lri,isma)
            elseif ( isma .lt. ismb ) then
               call gsd_diffsamesym_abb(lri,isma,ismb)
            endif

            do ismb=ismnoded+1,ng_sm
                  isma=mul_tab(ismnodes,ismb)
                  if ( isma .gt. ismb ) cycle
                  if ( ismnoded .gt. isma ) then
                     call g32a_diffsym(lri,isma,ismb)
                  elseif ( ismnoded .eq. isma ) then
                    call gsd_diffsamesym_aab(lri,isma,ismb)
                  else
                     call g32b_diffsym(lri,isma,ismb)
                  endif
            enddo

            if ( ismnodes.eq.1 .and. iltype.eq.4 ) then
                  call gsd_arlp_s1(lri)
            endif
            icnt_base=icnt_base+ilnodedownwei

      enddo
      end

      subroutine ar_sd_ext_rest(lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *      m_jc,m_jd, isegsta,isegupwei,isegdownwei

      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)

      if(logic_grad) then
        call gsd_ext_sequence_g(4,iml,imr,lri)

        w0_old=1.0d0
        do iw0=1,mtype
          w0_sdplp=vplpnew_w0(iw0)
          if(logic_dh) w0_sdplp=vplp_w0(iw0)
          w0multi=w0_sdplp/w0_old
          w0_old=w0_sdplp
          do iiext=1,icnt_base
            value_lpext(iiext)=value_lpext(iiext)*w0multi
            value_lpext1(iiext)=value_lpext1(iiext)*w0multi
          enddo
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then              !lp_head is in dbl_space
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              call complete_sd_ar_ext_loop_g(ilw,irw,ilsegdownwei)
            else
              ihypos=jphy(iplp)
              ndim =ihy(ihypos)
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihypos+in)
                iwar=iwar0+ihy(ihypos+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
                  call complete_sd_ar_ext_loop_g(ilw,irw,ilsegdownwei)
                enddo
              enddo
            endif
          enddo
        enddo

      else
        call gsd_ext_sequence(4,iml,imr,lri)

        w0_old=1.0d0
        do iw0=1,mtype
          w0_sdplp=vplpnew_w0(iw0)
          if(logic_dh) w0_sdplp=vplp_w0(iw0)
          w0multi=w0_sdplp/w0_old
          w0_old=w0_sdplp
          do iiext=1,icnt_base
            value_lpext(iiext)=value_lpext(iiext)*w0multi
          enddo
          ilpsta=nstaval(iw0)+1
          ilpend=nstaval(iw0)+nvalue(iw0)
          do iplp=ilpsta,ilpend
            if(logic_dh) then              !lp_head is in dbl_space
              ilw=lp_lwei(iplp)
              irw=lp_rwei(iplp)
              call complete_sd_ar_ext_loop(ilw,irw,ilsegdownwei)
            else                                    !lp_head is in act_s
              ihypos=jphy(iplp)
              ndim =ihy(ihypos)
              iwal0=lpnew_lwei(iplp)
              iwar0=lpnew_rwei(iplp)
              do in=1,ndim
                iwal=iwal0+ihyl(ihypos+in)
                iwar=iwar0+ihy(ihypos+in)
                do iwd=0,iwuplwei-1
                  ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                  irw=iwalk_ad(jpad,ipae,iwar,iwd)
                  call complete_sd_ar_ext_loop(ilw,irw,ilsegdownwei)
                enddo
              enddo
            endif
          enddo
        enddo
      endif
      return
      end

      subroutine ar_td_ext_rest(lri)
#include "drt_h.fh"
#include "pl_structure_h.fh"
#include "intsort_h.fh"
#include "lpextmode_h.fh"
      common /gext_sequence/icnt_base,icano_nnsta,icano_nnend,
     *      m_jc,m_jd, isegsta,isegupwei,isegdownwei

      iwuplwei=jpad_upwei(jpadl)
      iwuprwei=jpad_upwei(jpad)
      ilsegdownwei=iseg_downwei(ipael)
      irsegdownwei=iseg_downwei(ipae)

      if(logic_grad) then
      call gsd_ext_sequence_g(3,iml,imr,lri)

      w0_old=1.0d0
      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        w0multi=w0_sdplp/w0_old
        w0_old=w0_sdplp
        do iiext=1,icnt_base
          value_lpext(iiext)=value_lpext(iiext)*w0multi
          value_lpext1(iiext)=value_lpext1(iiext)*w0multi
        enddo
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then              !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call complete_sd_ar_ext_loop_g(ilw,irw,ilsegdownwei)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
            call complete_sd_ar_ext_loop_g(ilw,irw,ilsegdownwei)
              enddo
            enddo
          endif
        enddo
      enddo

      else

      call gsd_ext_sequence(3,iml,imr,lri)

      w0_old=1.0d0
      do iw0=1,mtype
        w0_sdplp=vplpnew_w0(iw0)
        if(logic_dh) w0_sdplp=vplp_w0(iw0)
        w0multi=w0_sdplp/w0_old
        w0_old=w0_sdplp
        do iiext=1,icnt_base
          value_lpext(iiext)=value_lpext(iiext)*w0multi
        enddo
        ilpsta=nstaval(iw0)+1
        ilpend=nstaval(iw0)+nvalue(iw0)
        do iplp=ilpsta,ilpend
          if(logic_dh) then              !lp_head is in dbl_space
            ilw=lp_lwei(iplp)
            irw=lp_rwei(iplp)
            call complete_sd_ar_ext_loop(ilw,irw,ilsegdownwei)
          else                                    !lp_head is in act_spa
            ihypos=jphy(iplp)
            ndim =ihy(ihypos)
            iwal0=lpnew_lwei(iplp)
            iwar0=lpnew_rwei(iplp)
            do in=1,ndim
              iwal=iwal0+ihyl(ihypos+in)
              iwar=iwar0+ihy(ihypos+in)
              do iwd=0,iwuplwei-1
                ilw=iwalk_ad(jpadl,ipael,iwal,iwd)
                irw=iwalk_ad(jpad,ipae,iwar,iwd)
                call complete_sd_ar_ext_loop(ilw,irw,ilsegdownwei)
              enddo
            enddo
          endif
        enddo
      enddo
      endif
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Per Ake Malmqvist                                *
!***********************************************************************
!--------------------------------------------*
! 1998  PER-AAKE MALMQUIST                   *
! DEPARTMENT OF THEORETICAL CHEMISTRY        *
! UNIVERSITY OF LUND                         *
! SWEDEN                                     *
!--------------------------------------------*

!***********************************************************************
! Case A (ICASE=1)
!***********************************************************************
subroutine MKBA(DREF,NDREF,PREF,NPREF,FD,FP,NG3,F3,idxG3)

use Index_Functions, only: nTri_Elem
use PrintLevel, only: DEBUG
#ifdef _MOLCAS_MPP_
use Para_Info, only: Is_Real_Par
use GA_Wrapper, only: DBL_MB, GA_NodeId
#endif
use fake_GA, only: GA_Arrays
use caspt2_global, only: iPrGlb
use caspt2_module, only: NSYM, NINDEP, NTUV
use Definitions, only: wp, iwp, u6, byte

implicit none
integer(kind=iwp), intent(in) :: NDREF, NPREF, NG3
real(kind=wp), intent(in) :: DREF(NDREF), PREF(NPREF), FD(NDREF), FP(NPREF), F3(NG3)
integer(kind=byte), intent(in) :: idxG3(6,NG3)
integer(kind=iwp) :: ICASE, IHI, ILO, ISYM, JHI, JLO, LDA, lg_BA, MBA, NAS, NBA, NIN
real(kind=wp) :: DBA
real(kind=wp), external :: PSBMAT_FPRINT
#ifdef _MOLCAS_MPP_
integer(kind=iwp) :: MYRANK, MA
real(kind=wp) :: Dummy(1)
#endif

ICASE = 1
! LONG loop over superindex symmetry.
do ISYM=1,NSYM
  NIN = NINDEP(ISYM,ICASE)
  if (NIN == 0) cycle
  NAS = NTUV(ISYM)
  NBA = nTri_Elem(NAS)
  if (NBA <= 0) cycle

  ! Set up the matrix BA(tuv,xyz) defined by the expression
  ! <ituv|H0-E0|kxyz> = dik ( alpha(a) SA(tuv,xyz) + BA(tuv,xyz) )
  ! Formula used:
  ! BA(tuv,xyz) = (Ey+Eu+Ex+Et-EASUM)*SA(tuv,xyz) - Fvuxtyz
  ! - dyu ( Fvzxt - Eu Gvzxt ) - dyt ( Fvuxz - Et Gvuxz )
  ! - dxu ( Fvtyz - Eu Gvtyz ) - dxu dyt ( Fvz - (Et+Eu) Gvz )
  ! + 2dxt ( Fvuyz - Et Gvuyz ) + 2dxt dyu ( Fvz - (Et+Eu) Gvz )

  ! where dyu = Kronecker(y,u) etc. Gvutxyz=<Evutxyz>, etc.
  ! Similarly, Fvutxyz= Sum(w)(EPSA(w)<Evutxyzww>, etc.

  call PSBMAT_GETMEM('BA',lg_BA,NAS)
  call PSBMAT_READ('S',iCase,iSym,lg_BA,NAS)

  ! fill in the 3-el parts
# ifdef _MOLCAS_MPP_
  if (IS_REAL_PAR()) then
    MYRANK = GA_NODEID()
    call GA_DISTRIBUTION(LG_BA,MYRANK,ILO,IHI,JLO,JHI)
    if ((JLO /= 0) .and. (JHI-JLO+1 /= NAS)) then
      write(u6,*) 'MKBA: MISMATCH IN RANGE OF THE SUPERINDICES'
      call ABEND()
    end if
    if ((ILO > 0) .and. (JLO > 0)) then
      call GA_ACCESS(LG_BA,ILO,IHI,JLO,JHI,MA,LDA)
      MBA = LDA*(JHI-JLO+1)
      call MKBA_DP(DREF,NDREF,PREF,NPREF,FD,FP,iSYM,DBL_MB(MA),MBA,ILO,IHI,JLO,JHI,LDA)
      call MKBA_F3_MPP(ISYM,DBL_MB(MA),ILO,NAS,LDA,NG3,F3,IDXG3)
      call GA_RELEASE_UPDATE(LG_BA,ILO,IHI,JLO,JHI)
    else
      call MKBA_F3_MPP(ISYM,DUMMY,ILO,NAS,LDA,NG3,F3,IDXG3)
    end if
  else
# endif
    LDA = 0
    ILO = 1
    IHI = NAS
    JLO = 1
    JHI = NAS
    MBA = nTri_Elem(NAS)
    call MKBA_DP(DREF,NDREF,PREF,NPREF,FD,FP,ISYM,GA_Arrays(lg_BA)%A(:),MBA,ILO,IHI,JLO,JHI,LDA)
    call MKBA_F3(ISYM,GA_Arrays(lg_BA)%A(:),MBA,NG3,F3,IDXG3)
# ifdef _MOLCAS_MPP_
  end if
# endif

  call PSBMAT_WRITE('B',iCase,iSYM,lg_BA,NAS)

  if (IPRGLB >= DEBUG) then
    DBA = PSBMAT_FPRINT(lg_BA,NAS)
    write(u6,'("DEBUG> ",A4,1X,I3,1X,ES21.14)') 'A',ISYM,DBA
  end if

  call PSBMAT_FREEMEM(lg_BA)
end do

end subroutine MKBA

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2011, Thomas Bondo Pedersen                            *
*               2011, Roland Lindh                                     *
************************************************************************
      Subroutine OneEl_IJ(iS,jS,iPrint,Do_PGamma,
     &                    xZeta,xZI,xKappa,xPCoor,
     &                    Kernel,KrnlMm,Label,lOper,nComp,CCoor,
     &                    nOrdOp,iChO,
     &                    iStabO,nStabO,nIC,
     &                    PtChrg,nGrid,iAddPot,SOInt,l_SOInt,
     &                    Final,nFinal,Scrtch,nScrtch,
     &                    ScrSph,nScrSph,Kern,nKern)
*
*     Thomas Bondo Pedersen and Roland Lindh, February 2011.
*
*     Purpose: compute symmetry adapted one-electron integrals for
*              shell doublet iS, jS.
*
      use Real_Spherical
      use iSD_data
      use Basis_Info
      use Center_Info
      use Sizes_of_Seward, only:S
      use Gateway_Info, only: FNMC
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (a-h,o-z)
*     External Kernel, KrnlMm
      External KrnlMm
#include "angtp.fh"
#include "Molcas.fh"
#include "real.fh"
#include "rmat_option.fh"
#include "nsd.fh"
#include "setup.fh"
#include "property_label.fh"
      Real*8 Final(nFinal), Scrtch(nScrtch), ScrSph(nScrSph),
     &       Kern(nKern), Coord(3*MxAtom)
      Real*8 xZeta(*),xZI(*),xKappa(*),xPCoor(*)
      Real*8 A(3), B(3), RB(3), CCoor(3,nComp), PtChrg(nGrid)
      Character ChOper(0:7)*3, Label*8, dbas*(LENIN)
      Integer nOp(2), lOper(nComp), iChO(nComp),
     &        iDCRR(0:7), iDCRT(0:7), iStabM(0:7), iStabO(0:7)
      Logical Do_PGamma
#ifdef _GEN1INT_
      Logical NATEST, DO_TRAN
#endif
      Real*8  SOInt(l_SOInt)
      Integer iTwoj(0:7), i
      Data iTwoj/1,2,4,8,16,32,64,128/
      Data ChOper/'E  ','x  ','y  ','xy ','z  ','xz ','yz ','xyz'/
*
*     Statement functions
      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2
*                                                                      *
************************************************************************
*                                                                      *
      If (Label(1:3).eq.'MAG') Then
      iCmp   = iSD( 2,iS)
      iBas   = iSD( 3,iS)
      iAO    = iSD( 7,iS)
      iShell = iSD(11,iS)
      jCmp   = iSD( 2,jS)
      jBas   = iSD( 3,jS)
      jAO    = iSD( 7,jS)
      jShell = iSD(11,jS)
      nSO=0
      B(:)=Zero
      Do iComp = 1, nComp
         iSmLbl=lOper(iComp)
         nSO=nSO+MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
      End Do
      If (iPrint.ge.29) Write (6,*) ' nSO=',nSO
      If (nSO.lt.1) Return
      If (l_SOInt.lt.nSO*iBas*jBas) Then
         Call WarningMessage(2,
     &                        'OneEl_IJ: insufficient SOInt dimension!')
         Call Abend()
      End If
      Call dCopy_(nSO*iBas*jBas,[Zero],0,SOInt,1)
      iShll  = iSD( 0,iS)
      iAng   = iSD( 1,iS)
      iPrim  = iSD( 5,iS)
      mdci   = iSD(10,iS)
      iCnttp = iSD(13,iS)
      iCnt   = iSD(14,iS)
      A(1:3) = dbsc(iCnttp)%Coor(1:3,iCnt)
      dbas= dc(mdci)%LblCnt(1:LENIN)
      Call UpCase(dbas)
      jShll  = iSD( 0,jS)
      jAng   = iSD( 1,jS)
      jPrim  = iSD( 5,jS)
      mdcj   = iSD(10,jS)
      jCnttp = iSD(13,jS)
      jCnt   = iSD(14,jS)
      B(1:3) = dbsc(jCnttp)%Coor(1:3,jCnt)
       if (iPrint.ge.19) Then
        write(6,*) "interacted Ato.Fun "
          Write (6,'(A,A,A,A,A)')
     &   ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
       endif
      lFinal = nIC*S%MaxPrm(iAng)*S%MaxPrm(jAng)*nElem(iAng)*nElem(jAng)
      If (lFinal.gt.nFinal) Then
         Call WarningMessage(2,'lFinal.gt.nFinal')
         Call Abend()
      End If
      Call dCopy_(lFinal,[Zero],0,Final,1)
      Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &               dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
      Call Inter(dc(mdci)%iStab,dc(mdci)%nStab,
     &           dc(mdcj)%iStab,dc(mdcj)%nStab,
     &           iStabM,nStabM)
      Call DCR(LambdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
      If (iPrint.ge.19) Then
         Write (6,*)
         Write (6,*) ' g      =',nIrrep
         Write (6,*) ' u      =',dc(mdci)%nStab
         Write (6,'(9A)') '(U)=',(ChOper(dc(mdci)%iStab(ii)),
     &         ii = 0, dc(mdci)%nStab-1)
         Write (6,*) ' v      =',dc(mdcj)%nStab
         Write (6,'(9A)') '(V)=',(ChOper(dc(mdcj)%iStab(ii)),
     &         ii = 0, dc(mdcj)%nStab-1)
         Write (6,*) ' LambdaR=**',LmbdR
         Write (6,*) ' r      =',nDCRR
         Write (6,'(9A)') '(R)=',(ChOper(iDCRR(ii)),
     &         ii = 0, nDCRR-1)
         Write (6,*) ' m      =',nStabM
         Write (6,'(9A)') '(M)=',(ChOper(iStabM(ii)),
     &         ii = 0, nStabM-1)
      End If
       nOp(1) = NrOpr(0)
      If (nDCRR.ge.1) Then
         Do lDCRR = 0, nDCRR-1
            Call OA(iDCRR(lDCRR),B,RB)
            nOp(2) = NrOpr(iDCRR(lDCRR))
               If (iPrint.ge.49) Then
               Write (6,'(A,3F6.2,2X,3F6.2)') '*',
     &                                        (A(i),i=1,3),(RB(i),i=1,3)
               Endif

        Call Get_nAtoms_All(nAtoms)
        l_Coord=3*nAtoms
        Call Get_dArray('Bfn Coordinates',Coord,l_Coord)
        if (nAtoms.eq.2) then
         nAtoms=nAtoms+1
        endif
#ifdef _GEN1INT_
        NATEST=(nAtoms.eq.2)
        If (label(4:5).eq.'PX') Then
            Do_Tran = .TRUE.
        Else
            Do_Tran = .FALSE.
        End If
        read(Label(6:),'(I3)') iatom
        call test_f90mod_sgto_mag(iShell,jShell,iCmp,jCmp,
     &                            iPrim,jPrim,iAng,jAng,
     &                            iPrim,jPrim,mdci,mdcj,
     &                            Shells(iShll)%Exp,Shells(jShll)%Exp,
     &                            Shells(iShll)%Cff_p(1,1,2),
     &                            Shells(jShll)%Cff_p(1,1,2),
     &                            nAtoms,
     &                            Coord,nComp,Final,.TRUE.,
     &                            iatom,Do_Tran)
#else
         Call WarningMessage(2,
     &   'OneEl_IJ: NO Gen1int interface available!')
         Call Abend()
#endif

            iSOBlk = 1
            iIC = 1
            Do iComp = 1, nComp
               iSmLbl=lOper(iComp)
               mSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
               If (mSO.eq.0) Then
                  Do iIrrep = 0, nIrrep-1
                     If (iAnd(lOper(iComp),iTwoj(iIrrep)).ne.0)
     &                   iIC = iIC + 1
                  End Do
               Else
                 !write(6,*) "Symmetry adapt component"
                  Call SymAd1(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                        iShell,jShell,iShll,jShll,
     &                        iAO,jAO,Final,
     &                        iBas,jBas,nIC,iIC,SOInt(iSOBlk),mSO,nOp)
                  iSOBlk = iSOBlk + mSO*iBas*jBas
               End If
            End Do
         End Do
      End If

         else  !  MAG Integrals

*                                                                      *
************************************************************************
*                                                                      *
*     Check memory for SO integrals that will be generated by
*     this batch of AO integrals. Init SOInt.
*
      iCmp   = iSD( 2,iS)
      iBas   = iSD( 3,iS)
      iAO    = iSD( 7,iS)
      iShell = iSD(11,iS)
      jCmp   = iSD( 2,jS)
      jBas   = iSD( 3,jS)
      jAO    = iSD( 7,jS)
      jShell = iSD(11,jS)
      nSO=0
      Do iComp = 1, nComp
         iSmLbl=lOper(iComp)
         nSO=nSO+MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
      End Do
      If (iPrint.ge.29) Write (6,*) ' nSO=',nSO
      If (nSO.lt.1) Return
      If (l_SOInt.lt.nSO*iBas*jBas) Then
         Call WarningMessage(2,
     &                        'OneEl_IJ: insufficient SOInt dimension!')
         Call Abend()
      End If
      Call dCopy_(nSO*iBas*jBas,[Zero],0,SOInt,1)
*
*---- Shell info
*
      iShll  = iSD( 0,iS)
      iAng   = iSD( 1,iS)
      iPrim  = iSD( 5,iS)
      mdci   = iSD(10,iS)
      iCnttp = iSD(13,iS)
      iCnt   = iSD(14,iS)
      A(1:3)=dbsc(iCnttp)%Coor(1:3,iCnt)
      dbas= dc(mdci)%LblCnt(1:LENIN)
      Call UpCase(dbas)

      jShll  = iSD( 0,jS)
      jAng   = iSD( 1,jS)
      jPrim  = iSD( 5,jS)
      mdcj   = iSD(10,jS)
      jCnttp = iSD(13,jS)
      jCnt   = iSD(14,jS)
      B(1:3)=dbsc(jCnttp)%Coor(1:3,jCnt)
*
*---- Identify if shell doublet should be computed with special
*     R-Matrix code.
*
      If (iCnttp.eq.jCnttp .and.
     &    mdcj.eq.mdci     .and.
     &    dbas.eq.'DBAS' ) Then
         RMat_type_integrals=.True.
         If (Do_PGamma) Then
            Call PGamma
            Do_PGamma=.False.
         End If
      Else
         RMat_type_integrals=.False.
      End If
*                                                                      *
************************************************************************
*                                                                      *
      If (iPrint.ge.19) Then
      write(6,*) "interacted Ato.Fun "
         Write (6,'(A,A,A,A,A)')
     &   ' ***** (',AngTp(iAng),',',AngTp(jAng),') *****'
      End If
*                                                                      *
************************************************************************
*                                                                      *
*---- Call kernel routine to get memory requirement.
*
      Call KrnlMm(nOrder,MemKer,iAng,jAng,nOrdOp)
*
*     Special additional allocation for PCC integrals
*
      If (PLabel.ne.' ') Then
         la0=iAng
         lb0=jAng
         MemAux= 1 + 3*nElem(la0)*nElem(lb0+1)*nIC
         la1=la0
         lb1=lb0+1
         MemBux= 1 + 3*nElem(la1+1)*nElem(lb1)*nIC
         If (la1.ne.0) MemBux=MemBux+3*nElem(la1-1)*nElem(lb1)*nIC
         If (lb0.ne.0) Then
            lb1=lb0-1
            MemAux=MemAux+3*nElem(la0)*nElem(lb0-1)*nIC
            MemCux=1+3*nElem(la1+1)*nElem(lb1)*nIC
            If (la1.ne.0) MemCux=MemCux+3*nElem(la1-1)*nElem(lb1)*nIC
         Else
            MemCux=0
         End If
         MemAux = MemAux + Max(MemBux,MemCux)
         MemKer = MemKer + MemAux
      End If
*
      MemKrn=MemKer*iPrim*jPrim
      If (MemKrn.gt.nKern) Then
         Call WarningMessage(2,'MemKrn.gt.nKern')
         Write (6,*)'nOrdOp,iAng,jAng=',nOrdOp,iAng,jAng
         Write (6,*) 'MemKrn=',MemKrn
         Write (6,*) 'nKern=',nKern
         Call Abend()
      End If
      Call dCopy_(MemKrn,[Zero],0,Kern,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Allocate memory for the final integrals all in the
*     primitive basis.
*
      lFinal = nIC*iPrim*jPrim*nElem(iAng)*nElem(jAng)
      If (lFinal.gt.nFinal) Then
         Call WarningMessage(2,'lFinal.gt.nFinal')
         Call Abend()
      End If
      Call dCopy_(lFinal,[Zero],0,Final,1)
*                                                                      *
************************************************************************
*                                                                      *
*     Scratch area for contraction step
*
      lScrtch =  Max(iPrim,jPrim) * Max(iBas,jBas) *
     &         nIC*nElem(iAng)*nElem(jAng)
      If (lScrtch.gt.nScrtch) Then
         Call WarningMessage(2,'lScrtch.gt.nScrtch')
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Scratch area for the transformation to spherical gaussians
*
      lScrSph=nIC*iBas*jBas*nElem(iAng)*nElem(jAng)
      If (lScrSph.gt.nScrSph) Then
         Call WarningMessage(2,'lScrSph.gt.nScrSph')
         Call Abend()
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     At this point we can compute Zeta.
*     This is now computed in the ij or ji order.
*
      Call ZXia(xZeta,xZI,iPrim,jPrim,Shells(iShll)%Exp,
     &                                Shells(jShll)%Exp)
*                                                                      *
************************************************************************
*                                                                      *
*     Find the DCR for A and B
*
      Call DCR(LmbdR,dc(mdci)%iStab,dc(mdci)%nStab,
     &               dc(mdcj)%iStab,dc(mdcj)%nStab,iDCRR,nDCRR)
*
*     Find the stabilizer for A and B
*
      Call Inter(dc(mdci)%iStab,dc(mdci)%nStab,
     &           dc(mdcj)%iStab,dc(mdcj)%nStab,
     &           iStabM,nStabM)
*
      Call DCR(LambdT,iStabM,nStabM,iStabO,nStabO,iDCRT,nDCRT)
*
#ifdef _DEBUGPRINT_
      If (iPrint.ge.19) Then
         Write (6,*)
         Write (6,*) ' g      =',nIrrep
         Write (6,*) ' u      =',dc(mdci)%nStab
         Write (6,'(9A)') '(U)=',(ChOper(dc(mdci)%iStab(ii)),
     &         ii = 0, dc(mdci)%nStab-1)
         Write (6,*) ' v      =',dc(mdcj)%nStab
         Write (6,'(9A)') '(V)=',(ChOper(dc(mdcj)%iStab(ii)),
     &         ii = 0, dc(mdcj)%nStab-1)
         Write (6,*) ' LambdaR=**',LmbdR
         Write (6,*) ' r      =',nDCRR
         Write (6,'(9A)') '(R)=',(ChOper(iDCRR(ii)),
     &         ii = 0, nDCRR-1)
         Write (6,*) ' m      =',nStabM
         Write (6,'(9A)') '(M)=',(ChOper(iStabM(ii)),
     &         ii = 0, nStabM-1)
      End If
#endif
*                                                                      *
************************************************************************
*                                                                      *
*     Compute normalization factor
*
      iuv = dc(mdci)%nStab*dc(mdcj)%nStab
      If (MolWgh.eq.1) Then
         Fact = DBLE(nStabO) / DBLE(LambdT)
      Else If (MolWgh.eq.0) Then
         Fact = DBLE(iuv*nStabO) / DBLE(nIrrep**2 * LambdT)
      Else
         Fact = Sqrt(DBLE(iuv))*DBLE(nStabO)/
     &          DBLE(nirrep*LambdT)
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Loops over symmetry operations acting on the basis.
*
       nOp(1) = NrOpr(0)
      If (nDCRR.ge.1) Then
         Do lDCRR = 0, nDCRR-1
            Call OA(iDCRR(lDCRR),B,RB)
            nOp(2) = NrOpr(iDCRR(lDCRR))
             If (iPrint.ge.49) Then
               Write (6,'(A,3F6.2,2X,3F6.2)') '*',
     &                                        (A(i),i=1,3),(RB(i),i=1,3)
            End If
*
*           Compute kappa and P.
*
            Call Setup1(Shells(iShll)%Exp,iPrim,
     &                  Shells(jShll)%Exp,jPrim,
     &                  A,RB,xKappa,xPCoor,xZI)
*
*           Compute primitive integrals. Result is ordered ij,ab.
*
            Call Kernel(Shells(iShll)%Exp,iPrim,
     &                  Shells(jShll)%Exp,jPrim,
     &                  xZeta,xZI,
     &                  xKappa,xPCoor,
     &                  Final,iPrim*jPrim,nIC,nComp,
     &                  iAng,jAng,A,RB,nOrder,Kern,
     &                  MemKer,Ccoor,nOrdOp,lOper,iChO,iStabM,
     &                  nStabM,
     &                  PtChrg,nGrid,iAddPot)
              If (iPrint.ge.49) Then
                   Call RecPrt(' Primitive Integrals',' ',
     &                     Final,iPrim*jPrim,
     &                     nElem(iAng)*nElem(jAng)*nIC)
            End If
*
*           Transform from primitive to contracted basis functions.
*
           If (iPrint.ge.99) Then
                Call RecPrt(' Left side contraction',' ',
     &                        Shells(iShll)%pCff,iPrim,iBas)
                Call RecPrt(' Right side contraction',' ',
     &                        Shells(jShll)%pCff,jPrim,jBas)
*
            End If
*
*           Transform i,jabx to jabx,I
            kk=nElem(iAng)*nElem(jAng)
            Call DGEMM_('T','N',
     &                  jPrim*kk*nIC,iBas,iPrim,
     &                  1.0d0,Final,iPrim,
     &                        Shells(iShll)%pCff,iPrim,
     &                  0.0d0,Scrtch,jPrim*kk*nIC)
*           Transform j,abxI to abxI,J
            Call DGEMM_('T','N',
     &                  kk*nIC*iBas,jBas,jPrim,
     &                  1.0d0,Scrtch,jPrim,
     &                        Shells(jShll)%pCff,jPrim,
     &                  0.0d0,ScrSph,kk*nIC*iBas)
*
            If (iPrint.ge.99) Then
               Call RecPrt(' Contracted integrals in cartesians',' ',
     &                     ScrSph,kk*nIC,iBas*jBas)
            End If
*
*           Transform to spherical gaussians if needed.
*

            If (Shells(iShll)%Transf.or.Shells(jShll)%Transf) Then
*              Result comes back as xIJAB or xIJAb
               Call CarSph(ScrSph,kk,iBas*jBas*nIC,
     &                     Final,lScrSph,
     &                     RSph(ipSph(iAng)),
     &                     iAng,Shells(iShll)%Transf,
     &                          Shells(iShll)%Prjct,
     &                     RSph(ipSph(jAng)),
     &                     jAng,Shells(jShll)%Transf,
     &                          Shells(jShll)%Prjct,
     &                     Scrtch,iCmp*jCmp)
               Call DGeTmO(Scrtch,nIC,nIC,iBas*jBas*iCmp*jCmp,
     &                     Final,iBas*jBas*iCmp*jCmp)
            Else
*              Transpose abx,IJ back to IJ,abx
              Call DGeTmO(ScrSph,kk*nIC,kk*nIC,iBas*jBas,
     &                    Final,iBas*jBas)
            End If
            If (iPrint.ge.99) Then
             Call RecPrt(' Contracted integrals in Sphericals',' ',
     &                     Final,iBas*jBas,iCmp*jCmp*nIC)
            End If

*---------- Tweak here for special cases
*
            ipFnl=1
            If (Label.eq.'P_matrix') Then
               nij=iBas*jBas
               nijab=nij*iCmp*jCmp
               Do iab = 1, iCmp*jCmp
                  ipx = ipFnl+(iab-1)*nij
                  ipy = ipx + nijab
                  ipz = ipy + nijab
                  call dcopy_(nij,xPCoor(1     ),1,Final(ipx),1)
                  call dcopy_(nij,xPCoor(1+nij ),1,Final(ipy),1)
                  call dcopy_(nij,xPCoor(1+2*nij),1,Final(ipz),1)
               End Do
            Else If (Label.eq.'FMMCnX') Then
               Do jj = 1, iBas*jBas*iCmp*jCmp*nIC
                  Final(ipFnl+jj-1) = (A(1) + RB(1))/2.0d0
               End do
            Else If (Label.eq.'FMMCnY') Then
               Do jj = 1, iBas*jBas*iCmp*jCmp*nIC
                  Final(ipFnl+jj-1) = (A(2) + RB(2))/2.0d0
               End do
            Else If (Label.eq.'FMMCnZ') Then
               Do jj = 1, iBas*jBas*iCmp*jCmp*nIC
                  Final(ipFnl+jj-1) = (A(3) + RB(3))/2.0d0
               End do
            Else If (Label.eq.'Kinetic') Then
*
*              multiply with 1/m, where m is the mass of an electron
*              or muon.
*
               xfactor=One/dbsc(iCnttp)%fMass
*
*              Add the Finite Nuclear Mass Correction if activated
*
               If (FNMC .AND. (
     &             A(1).eq.RB(1) .AND.
     &             A(2).eq.RB(2) .AND.
     &             A(3).eq.RB(3)) .AND.
     &             dbsc(iCnttp)%Charge.ne.Zero) Then
                     iAtom=dbsc(iCnttp)%AtmNr
*                    Get the atom mass in au (me=1)
                     xMass=dbsc(iCnttp)%CntMass
*                    Substract the electron mass to get the nuclear
*                    mass.
                     xMass=xMass-DBLE(iAtom)
*                    Write (*,*) 'xMass=',xMass
                     xfactor=xfactor+One/xMass
               End If
*              Write (*,*) 'xfactor=',xfactor
               Call DScal_(iBas*jBas*iCmp*jCmp,xfactor,Final,1)
            End If
*
*           At this point accumulate the batch of integrals onto the
*           final symmetry adapted integrals.
*
             If (iPrint.ge.99) Then
               Call RecPrt (' Accumulated SO integrals, so far...',
     &                      ' ',SOInt,iBas*jBas,nSO)
             End If

*---------- Symmetry adapt component by component
*
            iSOBlk = 1
            iIC = 1
            Do iComp = 1, nComp
               iSmLbl=lOper(iComp)
               mSO=MemSO1(iSmLbl,iCmp,jCmp,iShell,jShell,iAO,jAO)
               If (mSO.eq.0) Then
                  Do iIrrep = 0, nIrrep-1
                     If (iAnd(lOper(iComp),iTwoj(iIrrep)).ne.0)
     &                   iIC = iIC + 1
                  End Do
               Else
                  Call SymAd1(iSmLbl,iAng,jAng,iCmp,jCmp,
     &                        iShell,jShell,iShll,jShll,
     &                        iAO,jAO,Final,
     &                        iBas,jBas,nIC,iIC,SOInt(iSOBlk),mSO,nOp)
                  iSOBlk = iSOBlk + mSO*iBas*jBas
               End If
            End Do
         End Do
      End If
*                                                                      *
************************************************************************
*                                                                      *
*     Multiply with factors due to projection operators
*
      If (Fact.ne.One) Call dScal_(nSO*iBas*jBas,Fact,SOInt,1)
      If (iPrint.ge.99) Then
         Write (6,*) ' Scaling SO''s', Fact
         Call RecPrt(' Accumulated SO integrals',' ',
     &               SOInt,iBas*jBas,nSO)
      End If
*                                                                      *
************************************************************************
*                                                                      *

      End If
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Markus P. Fuelscher                              *
*               1991, Per Ake Malmqvist                                *
************************************************************************
      Subroutine MkSrt2
************************************************************************
*                                                                      *
*     Purpose: Inizialize counters and offsets required                *
*              for bin sorting algorithm                               *
*                                                                      *
*     Called from: Sort1                                               *
*                                                                      *
*     Calls to : none                                                  *
*                                                                      *
*     Calling parameters: none                                         *
*                                                                      *
*     Global data declarations (Include files) :                       *
*     TwoDef  : definitions of the record structure                    *
*     Srt0    : common block containing information pertinent to       *
*               the calculation of 2el integral sequence numbers       *
*     Srt1    : common block containing information the number of      *
*               bins and partitioning of symmetry blocks               *
*     Srt2    : common block containing information pertinent to       *
*               the bin sorting algorithm                              *
*                                                                      *
*     Local data declarations: none                                    *
*                                                                      *
**** M. Fuelscher and P.-Aa. Malmqvist, Univ. of Lund, Sweden, 1991 ****
*
      use srt2
      Implicit Integer (A-Z)
*
#include "srt0.fh"
#include "srt1.fh"
#include "print.fh"
*
      iRout = 80
      iPrint = nPrint(iRout)
      If ( iPrint.gt.10) Write(6,*) ' >>> Enter MKSRT2 <<<'
*
*----------------------------------------------------------------------*
*     initialize various pointers, counters and disk adresses          *
*----------------------------------------------------------------------*
*
      iBin=0
      Do 30 iSyBlk=1,mSyBlk
         nSlice=nSln(iSyBlk)
         If ( nSlice.ne.0 ) then
            Do 40 iSlice=1,nSlice
               iBin=iBin+1
               iDIBin(2,iBin)=-1
               iDVBin(2,iBin)=-1
               iDVBin(3,iBin)=-1
               iDVBin(4,iBin)=-1
               nInt(iBin)=0
               nRec(iBin)=0
40          Continue
         End If
30    Continue
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2025, Yoshio Nishimoto                                 *
!***********************************************************************

subroutine DWder_MCLR(mode,idsym,der1,nder1,der2,nder2,DWOut)

use Index_Functions, only: iTri, nTri_Elem
use Symmetry_Info, only: Mul
use input_mclr, only: ERASSCF, iToc, nAsh, nBas, nIsh, nRoots, nSym, ntAsh, weight
use DWSol, only: DWSol_der
use MCLR_Data, only: ipCM, LUJOB
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two, Half
use Definitions, only: wp, iwp

implicit none

integer(kind=iwp), intent(in) :: mode, idSym, nder1, nder2
real(kind=wp), intent(in) :: der1(nder1), der2(nder2)
real(kind=wp), intent(inout) :: DWOut(nRoots,nRoots)
integer(kind=iwp) :: i, iA, ij1, ip1, iS, j, jA, jS, jDisk, kA, kl1, lA, ng1, ng2
real(kind=wp) :: OMGDER, rdum(1), Scal
real(kind=wp), allocatable :: G1q(:), G2q(:), DERHII(:), DEROMG(:)

if (nRoots == 1) return

! derivative of the dynamical weight
! I think this implementation uses the following constraint condition
! w_I^Z * (<I|H|I> - E_I)
! where E is used as a parameter, and w_I^Z is the undetermined multiplier (not weight itself)
!
! For DW-MCSCF, partial derivative of the Lagrangian wrt H_{IJ} can be evaluated with either orbital or CI rotations.
! At present, it is evaluated in ISR_TimesE2.
! For DW solvation, it is only with orbital rotations (here)?

ng1 = nTri_Elem(ntash)
ng2 = nTri_Elem(ng1)
call mma_allocate(G1q,ng1,Label='G1q')
call mma_allocate(G2q,ng2,Label='G2q')
call mma_allocate(DEROMG,nRoots,Label='DEROMG')
DEROMG = Zero

jdisk = itoc(3)
do j=1,nRoots
  call dDaFile(LUJOB,2,G1q,ng1,jDisk)
  call dDaFile(LUJOB,0,rdum,ng1,jDisk)
  call dDaFile(LUJOB,2,G2q,Ng2,jDisk)
  call dDaFile(LUJOB,0,rdum,Ng2,jDisk)

  OMGDER = Zero
  do iS=1,nSym
    if (nAsh(iS) > 0) then
      jS = Mul(iS,idSym)
      do iA=1,nAsh(is)
        do jA=1,nAsh(js)
          ij1 = iTri(ia,ja)
          ip1 = nIsh(iS)+iA-1+nBas(jS)*(nIsh(js)+jA-1)+ipCM(is)
          OMGDER = OMGDER+der1(ip1)*G1q(ij1)
          if (mode == 1) then
            !! DW-MCSCF
            do kA=1,nAsh(is)
              do lA=1,nAsh(js)
                kl1 = iTri(ka,la)
                !! dimension of rmoaa is itri(nnA**2,nnA**2), but the actual array is similar to G2q
                !! dimension of G2q  : itri(itri(nnA,nnA),itri(nnA,nnA))
                scal = One
                if ((ij1 >= kl1) .and. (kA == lA)) then
                  scal = Two
                else if ((ij1 < kl1) .and. (iA == jA)) then
                  scal = Two
                end if
                OMGDER = OMGDER+scal*der2(itri(ij1,kl1))*G2q(itri(ij1,kl1))*Half
              end do
            end do
          end if
        end do
      end do
    end if
  end do
  DEROMG(j) = OMGDER
end do

call mma_allocate(DERHII,nRoots,Label='DERHII')
DERHII(:) = Zero

!! weight is optional
call DWSol_Der(mode,DEROMG,DERHII,ERASSCF,weight)

!! this contributions should not be treated as multipliers, I guess
do i=1,nRoots
  DWOut(i,i) = DWOut(i,i)+DERHII(i)*Half
end do
!write(u6,*) 'dwout'
!call sqprt(dwout,nroots)

call mma_deallocate(G1q)
call mma_deallocate(G2q)
call mma_deallocate(DERHII)
call mma_deallocate(DEROMG)

return

end subroutine DWder_MCLR

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2014, Ignacio Fdez. Galvan                             *
!***********************************************************************
!  Davidson
!
!> @brief
!>   Compute the lowest \p k eigenvalues of a symmetric matrix.
!> @author Ignacio Fdez. Galv&aacute;n
!>
!> @details
!> Simple application of the Davidson procedure to obtain the lowest \p k eigenvalues
!> and corresponding eigenvectors of a symmetric matrix.
!> On input, \p Vec can contain an initial guess for the eigenvectors (from a previous
!> run with smaller \p k, for example), only the non-zero vectors are used.
!>
!> @param[in]     A   Symmetric matrix, in upper triangular packed format
!> @param[in]     n   Size of the matrix
!> @param[in]     k   Number of lowest eigenvalues to compute
!> @param[out]    Eig Lowest eigenvalues
!> @param[in,out] Vec Lowest eigenvectors
!> @param[out]    iRC Return code (0 if converged)
!***********************************************************************

subroutine Davidson(A,n,k,Eig,Vec,iRC)

use Index_Functions, only: nTri_Elem
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Ten
use Definitions, only: wp, iwp
!#define _DEBUGPRINT_
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: n, k
real(kind=wp), intent(in) :: A(nTri_Elem(n))
real(kind=wp), intent(out) :: Eig(k)
real(kind=wp), intent(inout) :: Vec(n,k)
integer(kind=iwp), intent(out) :: iRC
integer(kind=iwp) :: i, ig, ii, info, iter, j, jj, maxk, mink, mk, nTmp, old_mk
real(kind=wp) :: Alpha, Aux, Conv, rDum(1)
logical(kind=iwp) :: Augmented, Last, Reduced
integer(kind=iwp), allocatable :: Indx(:)
real(kind=wp), allocatable :: Ab(:), Diag(:), Eig_old(:), EVal(:), EVec(:), Proj(:), Sub(:), TAV(:), Tmp(:), TRes(:), TVec(:), &
                              Val(:), Vec2(:)
integer(kind=iwp), parameter :: maxiter = 300
real(kind=wp), parameter :: Thr = 1.0e-7_wp, Thr2 = 1.0e-16_wp, Thr3 = 1.0e-16_wp
real(kind=wp), external :: ddot_

! Diagonal preconditioned residue (Davidson)
#define DAV_DPR 1
! Inverse-iteration generalized Davidson (Olsen et al.)
#define DAV_IIGD 2

#ifdef _DEBUGPRINT_
call TriPrt('Initial matrix','',A,n)
#endif

! Initialize some parameters
! mk   = subspace size (initially k)
! maxk = maximum subspace size (25 if k=1)
! mink = subspace size to reduce to when the maximum is exceeded (5 if k=1)

if (k > n) call SysAbendMsg('Davidson','Wrong k value.','')
mink = min(max(k+2,5),n)
maxk = min(5*mink,n)
mk = k
iRC = 0

! If all the eigenvalues are wanted, better solve the system directly
! and return

if (mk >= n) then
  call mma_allocate(Val,n,Label='Val')
  call mma_allocate(Vec2,n*n,Label='Vec2')
  do j=1,n
    jj = (j-1)*n
    Vec2(jj+1:jj+j) = A(nTri_Elem(j-1)+1:nTri_Elem(j))
  end do
  call dsyev_('V','U',n,Vec2,n,Val,rDum,-1,info)
  nTmp = int(rDum(1))

  call mma_allocate(Tmp,nTmp,Label='Tmp')
  call dsyev_('V','U',n,Vec2,n,Val,Tmp,nTmp,info)
  call SortEig(Val,Vec2,n,n,1,.false.)
  call mma_deallocate(Tmp)

  Eig(:) = Val(1:k)
  Vec(:,:) = reshape(Vec2(1:n*k),[n,k])

  call mma_deallocate(Val)
  call mma_deallocate(Vec2)
# ifdef _DEBUGPRINT_
  call RecPrt('Eigenvalues',' ',Eig,1,n)
  write(u6,*)
  write(u6,'(A)') 'Complete system solved'
# endif
  return
end if

! Allocate matrices
! Sub  = Vectors (columns) defining the subspace (maximum maxk vectors)
! Ab   = A*b vectors (A * Sub)
! EVal  = Set of computed eigenvalues (maximum maxk elements)
! EVec  = Set of computed eigenvectors, in the subspace (maximum maxk*maxk)

call mma_allocate(Eig_old,k,label='Eig_old')
call mma_allocate(Sub,n*maxk,Label='Sub')
call mma_allocate(Ab,n*maxk,Label='Ab ')
call mma_allocate(Proj,maxk*maxk,Label='Proj')
call mma_allocate(EVal,maxk,Label='EVal')
call mma_allocate(EVec,maxk*maxk,Label='EVec')
AB(:) = Zero
EVal(:) = Zero
EVec(:) = Zero

! Build an index of sorted diagonal elements in A

call mma_allocate(Indx,n,Label='Indx')
do i=1,n
  Indx(i) = i
end do
do i=1,n
  ii = Indx(i)
  Aux = A(nTri_Elem(ii))
  ii = i
  do j=i,n
    jj = Indx(j)
    if (A(nTri_Elem(jj)) < Aux) then
      Aux = A(nTri_Elem(jj))
      ii = j
    end if
  end do
  if (ii /= i) then
    jj = Indx(ii)
    Indx(ii) = Indx(i)
    Indx(i) = jj
  end if
end do

! Setup the initial subspace
! Read the non-linear-dependent columns from the initial eigenvector matrix
! Fill up to mk with selected base vectors from the initial matrix
!  (those corresponding to the lowest diagonal elements)
! The rest is set to zero, just in case

nTmp = 0
call mma_allocate(Tmp,n,Label='Tmp')
do i=1,k
  Tmp(:) = Vec(:,i)
  call Add_Vector(n,nTmp,Sub,Tmp,Thr3)
end do

ii = 0
Tmp(:) = Zero
do while ((nTmp < mk) .and. (ii < n))
  ii = ii+1
  jj = Indx(ii)
  Tmp(jj) = One
  call Add_Vector(n,nTmp,Sub,Tmp,Thr3)
  Tmp(jj) = Zero
end do
! ig will be a global counter to loop across all n base vectors
ig = ii
call mma_deallocate(Tmp)
Sub(n*mk+1:) = Zero

! Iterative procedure starts here
! mk     = subspace size at each iteration
! old_mk = value of mk at the previous iteration

Augmented = .false.
Reduced = .false.
Last = .false.
old_mk = 0
iter = 0
call mma_allocate(Diag,n,Label='Diag')
call mma_allocate(TVec,n,Label='TVec')
call mma_allocate(TAV,n,Label='TAV')
call mma_allocate(TRes,n,Label='TRes')
do while (.not. Last)
  iter = iter+1
  if (iter > 1) Eig_old(:) = Eig(:)
# ifdef _DEBUGPRINT_
  if (.not. Reduced) then
    write(u6,'(A)') '---------------'
    write(u6,'(A,1X,I5)') 'Iteration',iter
  end if
  call RecPrt('Orthonormalized subspace',' ',Sub,n,mk)
# endif

  ! Compute the matrix product
  ! Ab = A * Sub
  ! Only the new vectors since the last iterations need to be calculated

  call mma_allocate(Tmp,n,Label='Tmp')
  do i=1,n
    ! Reconstruct a row (or column) of the matrix A
    Tmp(1:i) = A(nTri_Elem(i-1)+1:nTri_Elem(i))
    do j=i+1,n
      Tmp(j) = A(nTri_Elem(j-1)+i)
    end do
    ! Compute the i-th element of each new column
    do j=old_mk,mk-1
      Ab(j*n+i) = DDot_(n,Tmp,1,Sub(1+j*n),1)
    end do
  end do
  call mma_deallocate(Tmp)

  ! Compute the matrix to diagonalize (symmetric)
  ! Proj = Sub^t * Ab
  ! Again, only the new rows/columns are needed

  if (old_mk == 0) then
    call DGeMM_('T','N',mk,mk,n,One,Sub,n,Ab,n,Zero,Proj,maxk)
  else
    do i=0,mk-1
      do j=max(old_mk,i),mk-1
        Proj(1+i*maxk+j) = DDot_(n,Sub(1+j*n),1,Ab(1+i*n),1)
      end do
    end do
  end if

  ! Compute the eigenvalues of the projected matrix
  ! Make sure the eigenpairs are sorted
  ! If the subspace has been reduced, no need to compute new eigenpairs

  if (.not. Reduced) then
#   ifdef _DEBUGPRINT_
    write(u6,'(2X,A,1X,I5)') 'Solving for subspace size:',mk
#   endif
    EVec(:) = Proj(:)
    call dsyev_('V','L',mk,EVec,maxk,EVal,rDum,-1,info)
    nTmp = int(rDum(1))
    call mma_allocate(Tmp,nTmp,Label='Tmp')
    call dsyev_('V','L',mk,EVec,maxk,EVal,Tmp,nTmp,info)
    call mma_deallocate(Tmp)
    call SortEig(EVal,EVec,mk,maxk,1,.false.)
    Eig(:) = EVal(1:k)
#   ifdef _DEBUGPRINT_
    call RecPrt('Current guess',' ',Eig,1,k)
#   endif
  end if
# ifdef _DEBUGPRINT_
  call RecPrt('Eigenvalues',' ',EVal,1,mk)
  call SubRecPrt('Subspace Eigenvectors',' ',EVec,maxk,mk,mk)
  write(u6,*)
# endif

  ! Check for convergence
  ! Converge if the change in the eigenvalues is small
  !  (but if a mink size has been reached)
  ! Converge if the full system has been solved
  ! Stop if the number of iterations exceeds the maximum
  ! Stop if no new vectors to add are found

  if (iter > 1) then
    Conv = Zero
    do i=1,k
      if (abs(Eig(i)) > Thr2) then
        Conv = max(Conv,abs((Eig(i)-Eig_old(i))/Eig(i)))
      else
        Conv = max(Conv,abs(Eig(i)-Eig_old(i)))
      end if
    end do
#   ifdef _DEBUGPRINT_
    if (Augmented) write(u6,'(2X,A,1X,G12.6)') 'Maximum relative eigenvalue change:',Conv
#   endif
  else
    Conv = Ten*Thr
  end if
  old_mk = mk
  if (Augmented .and. (Conv <= Thr) .and. (mk >= mink)) then
#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'Converged due to small change'
#   endif
    Last = .true.
  else if (mk == n) then
#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'Complete system solved'
#   endif
    Last = .true.
  else if (iter >= maxiter) then
#   ifdef _DEBUGPRINT_
    write(u6,'(A)') 'Not converged'
#   endif
    Last = .true.
    iRC = 1

    ! Reduce the subspace size if it exceeds the maximum (maxk)
    ! Sub' = Sub * Vec(1:mink)
    ! Sub' should be orthonormal if Sub is orthonormal
    ! (A reduction does not consume an iteration)
    ! There is also a reduction if the process is stagnated

  else if ((min(mk+k,n) > maxk) .or. (iRC == 2)) then
    if (iRC == 2) iRC = 0
#   ifdef _DEBUGPRINT_
    write(u6,'(2X,A,1X,I5)') 'Reducing search space to',mink
#   endif
    call mma_allocate(Tmp,mink*n,Label='Tmp')
    call DGeMM_('N','N',n,mink,mk,One,Sub,n,EVec,maxk,Zero,Tmp,n)
    Sub(1:mink*n) = Tmp(:)
    call mma_deallocate(Tmp)

    ! To make sure Sub' is orthonormal, add the vectors one by one

    j = 0
    i = 0
    do while ((j < mink) .and. (i < mk))
      i = i+1
      call Add_Vector(n,j,Sub,Sub(1+(i-1)*n),Thr3)
    end do

    ! j should be mink, but who knows...

#   ifdef _DEBUGPRINT_
    if (j < mink) write(u6,'(2X,A,1X,I5)') 'Fewer vectors found:',j
#   endif
    Sub(j*n+1:) = Zero
    Ab(j*n+1:) = Zero
    call unitmat(EVec,maxk)
    mk = j
    old_mk = 0
    Augmented = .false.
    Reduced = .true.
    iter = iter-1

    ! Expand the subspace
    ! For each eigenpair i of the first k,
    ! check convergence for the residuals r:
    !  r = Ab * Vec(i) - Val(i) * Sub * Vec(i)
    ! Add a new vector, orthonormalized with the previous vectors,
    ! computed from r and the eigenpair
    ! (different possible variants)

  else
    call mma_allocate(Tmp,n,Label='Tmp')
    Conv = Zero
    jj = 0
    do i=0,k-1
      ! Vector in full space: Sub*Vec(i)
      call dGeMV_('N',n,mk,One,Sub,n,EVec(1+i*maxk),1,Zero,TVec,1)
      ! Product of matrix and vector: Ab*Vec(i)
      call dGeMV_('N',n,mk,One,Ab,n,EVec(1+i*maxk),1,Zero,TAV,1)
      ! Residual: (A-Val(i))*Vec(i) = Ab*Vec(i) - Val(i)*Sub*Vec(i)
      TRes(:) = TAV(:)-EVal(i+1)*TVec(:)
      Conv = max(Conv,DDot_(n,TRes,1,TRes,1))

      ! Scale vector, orthonormalize, and add to subspace

#     define DAV_METH DAV_IIGD
#     if DAV_METH == DAV_DPR
      ! Diagonal matrix to scale the vectors: 1/(A(j,j)-Val(i))
      do j=1,n
        Aux = A(nTri_Elem(j))-Eval(1+i)
        Diag(j) = One/sign(max(abs(Aux),Thr2),Aux)
      end do
      ! scale
      Tmp(:) = TRes(:)*Diag(:)
#     elif DAV_METH == DAV_IIGD
      ! Diagonal matrix to scale the vectors: 1/(A(j,j)-Val(i))
      do j=1,n
        Aux = A(nTri_Elem(j))-EVal(1+i)
        Diag(j) = One/sign(max(abs(Aux),Thr2),Aux)
      end do
      ! scale
      Tmp(:) = TRes(:)*Diag(:)
      Alpha = Zero
      do j=1,n
        Alpha = Alpha+Diag(j)*TVec(j)**2
      end do
      Alpha = DDot_(n,TVec,1,Tmp,1)/Alpha
      ! subtract
      Tmp(:) = Tmp(:)-Alpha*TVec(:)*Diag(:)
#     endif
      if (mk+jj <= n-1) then
        jj = mk+jj
        call Add_Vector(n,jj,Sub,Tmp,Thr3)
        jj = jj-mk
      end if
    end do
#   ifdef _DEBUGPRINT_
    write(u6,'(2X,A,1X,G12.6)') 'Maximum residual:',Conv
#   endif
    if ((Conv < Thr3) .and. (mk >= mink)) then
#     ifdef _DEBUGPRINT_
      write(u6,'(A)') 'Converged due to small residual'
#     endif
      Last = .true.
    else
      mk = min(mk+jj,n)

      ! If no new vector is found to add to the subspace, we are in trouble
      ! -Try to find a non-linear-dependent base vector in the original matrix

      if (jj == 0) then
#       ifdef _DEBUGPRINT_
        write(u6,'(A)') 'Process stagnated'
#       endif
        if (mk < maxk) then
          Tmp(:) = Zero
          i = 0
          do while ((jj < 1) .and. (i < n))
            i = i+1
            ig = mod(ig,n)+1
            ii = Indx(ig)
            Tmp(ii) = One
            jj = mk+jj
            call Add_Vector(n,jj,Sub,Tmp,Thr3)
            Tmp(ii) = Zero
            jj = jj-mk
          end do
          mk = min(mk+jj,n)
          if (jj > 0) Augmented = .true.
        end if
        if (jj == 0) then
          Augmented = .false.
          iRC = 2
        end if
      else
        Augmented = .true.
      end if
    end if
    call mma_deallocate(Tmp)
    Reduced = .false.
  end if
end do
call mma_deallocate(Diag)
call mma_deallocate(TVec)
call mma_deallocate(TAV)
call mma_deallocate(TRes)
call mma_deallocate(Indx)

! Store the current lowest k eigenvectors (in the full space)
! Vec' = Sub * Vec(1:k)

call DGeMM_('N','N',n,k,mk,One,Sub,n,EVec,maxk,Zero,Vec,n)

call mma_deallocate(Sub)
call mma_deallocate(Ab)
call mma_deallocate(Proj)
call mma_deallocate(EVal)
call mma_deallocate(EVec)
call mma_deallocate(Eig_old)

end subroutine Davidson

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine rhodyn_init()
!***********************************************************************
! input parameters set by default. Later they can be overwritten
! when reading input file
!***********************************************************************

use rhodyn_data, only: alpha, amp, basis, DM_basis, errorthreshold, finaltime, flag_acorrection, flag_decay, flag_dipole, &
                       flag_diss, flag_dyson, flag_emiss, flag_fdm, flag_pulse, flag_so, flag_test, cgamma, HRSO, initialtime, &
                       ion_diss, kext, linear_chirp, method, N_L2, N_L3, N_Populated, N_pulse, Nmode, Nval, omega, p_style, phi, &
                       pulse_type, pulse_vector, runmode, safety, sigma, T, tau_L2, tau_L3, taushift, time_fdm, timestep, tout
use stdalloc, only: mma_allocate
use Constants, only: Zero, One, Three, Ten, cZero, cOne, auToFs, auToCm, auToeV
use Definitions, only: wp

implicit none

! runmode 1 means standard program workflow (see rhodyn_data)
runmode = 1
flag_test = .false.
p_style = 'SF'
N_Populated = 1
! temperature T needed if p_style includes 'thermal'
T = 300
Nmode = 0
! be default propagation basis is spin free states
basis = 'SF'
DM_basis = 'SF_SO'
tout = 0.05_wp/auToFs
initialtime = Zero/auToFs
finaltime = Ten/auToFs
timestep = 0.0005_wp/auToFs
method = 'CLASSIC_RK4'
errorthreshold = 1.0e-06_wp
! safety parameter for adaptive-size methods can be set to 0.95
! for acceleration of calculations
safety = 0.9_wp
!deltaE = 50.0_wp/auToCm
!V = 100.0_wp/auToCm
Nval = 160
N_L3 = 175
tau_L3 = 0.4_wp/autoev ! Auger decay rate for Fe L3
N_L2 = 585
tau_L2 = 1.04_wp/autoev ! Auger decay rate for Fe L2
flag_dyson = .false.
alpha = 1.0e-3_wp
ion_diss = Zero
flag_diss = .false.
cgamma = 300.0_wp/auToCm
HRSO = .false.
kext = .false.
! full density matrix saving time step
time_fdm = One/auToFs
! general idea is that additional features are disabled by default
! except for pulse flag
flag_so = .false.
flag_decay = .false.
flag_fdm = .false.
flag_dipole = .false.
flag_emiss = .false.
! number of incoming pulses N_pulse supposed to be 1 by default
! later when reading input it can be changed with
! reallocation of all corresponding arrays
flag_pulse = .true.
flag_acorrection = .false.
pulse_type = 'GAUSS'
N_pulse = 1
call mma_allocate(amp,N_pulse)
call mma_allocate(taushift,N_pulse)
call mma_allocate(pulse_vector,N_pulse,3)
call mma_allocate(sigma,N_pulse)
call mma_allocate(omega,N_pulse)
call mma_allocate(phi,N_pulse)
amp(1) = 2.5_wp
taushift(1) = Three/auToFs
pulse_vector(1,1) = cOne
pulse_vector(1,2) = cZero
pulse_vector(1,3) = cZero
sigma(1) = One/auToFs
omega(1) = Ten/autoev
phi(1) = Zero
linear_chirp = Zero

end subroutine rhodyn_init

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
  Subroutine plot_MH_with_Exp( nH, H, nTempMagn, TempMagn, MHcalc, MHexp, zJ )

  IMPLICIT NONE

  Integer, parameter    :: wp=SELECTED_REAL_KIND(p=15,r=307)
  INTEGER, INTENT(in)   :: nH, nTempMagn
  REAL (wp), INTENT(in) :: H(nH), TempMagn(nTempMagn)
  REAL (wp), INTENT(in) :: MHexp(nH,nTempMagn)
  REAL (wp), INTENT(in) :: MHcalc(nH,nTempMagn)
  REAL (wp), INTENT(in) :: zJ
  ! local variables
  REAL (wp) :: hmin, hmax, MHmin_exp, MHmax_exp, MHmin_calc, MHmax_calc, MHmin, MHmax
  REAL (wp) :: gnuplot_version
  INTEGER           :: file_number, istat, iH, iTempMagn, LuPlt, LuData, file_size, StdOut, iErr
  LOGICAL           :: file_exist, is_file_open, execute_gnuplot_cmd, dbg
  CHARACTER(LEN=100):: line1, line2, lineOut, cdummy
  CHARACTER(LEN=100):: gnuplot_CMD, filedat, fileplt
  CHARACTER(LEN=7) :: color(111)
  INTEGER, EXTERNAL:: AixRm

  color(  1)="#ffffff"; color(  2)="#000000"; color(  3)="#a0a0a0"; color(  4)="#ff0000"; color(  5)="#00c000"
  color(  6)="#0080ff"; color(  7)="#c000ff"; color(  8)="#00eeee"; color(  9)="#c04000"; color( 10)="#c8c800"
  color( 11)="#4169e1"; color( 12)="#ffc020"; color( 13)="#008040"; color( 14)="#c080ff"; color( 15)="#306080"
  color( 16)="#8b0000"; color( 17)="#408000"; color( 18)="#ff80ff"; color( 19)="#7fffd4"; color( 20)="#a52a2a"
  color( 21)="#ffff00"; color( 22)="#40e0d0"; color( 23)="#000000"; color( 24)="#1a1a1a"; color( 25)="#333333"
  color( 26)="#4d4d4d"; color( 27)="#666666"; color( 28)="#7f7f7f"; color( 29)="#999999"; color( 30)="#b3b3b3"
  color( 31)="#c0c0c0"; color( 32)="#cccccc"; color( 33)="#e5e5e5"; color( 34)="#ffffff"; color( 35)="#f03232"
  color( 36)="#90ee90"; color( 37)="#add8e6"; color( 38)="#f055f0"; color( 39)="#e0ffff"; color( 40)="#eedd82"
  color( 41)="#ffb6c1"; color( 42)="#afeeee"; color( 43)="#ffd700"; color( 44)="#00ff00"; color( 45)="#006400"
  color( 46)="#00ff7f"; color( 47)="#228b22"; color( 48)="#2e8b57"; color( 49)="#0000ff"; color( 50)="#00008b"
  color( 51)="#191970"; color( 52)="#000080"; color( 53)="#0000cd"; color( 54)="#87ceeb"; color( 55)="#00ffff"
  color( 56)="#ff00ff"; color( 57)="#00ced1"; color( 58)="#ff1493"; color( 59)="#ff7f50"; color( 60)="#f08080"
  color( 61)="#ff4500"; color( 62)="#fa8072"; color( 63)="#e9967a"; color( 64)="#f0e68c"; color( 65)="#bdb76b"
  color( 66)="#b8860b"; color( 67)="#f5f5dc"; color( 68)="#a08020"; color( 69)="#ffa500"; color( 70)="#ee82ee"
  color( 71)="#9400d3"; color( 72)="#dda0dd"; color( 73)="#905040"; color( 74)="#556b2f"; color( 75)="#801400"
  color( 76)="#801414"; color( 77)="#804014"; color( 78)="#804080"; color( 79)="#8060c0"; color( 80)="#8060ff"
  color( 81)="#808000"; color( 82)="#ff8040"; color( 83)="#ffa040"; color( 84)="#ffa060"; color( 85)="#ffa070"
  color( 86)="#ffc0c0"; color( 87)="#ffff80"; color( 88)="#ffffc0"; color( 89)="#cdb79e"; color( 90)="#f0fff0"
  color( 91)="#a0b6cd"; color( 92)="#c1ffc1"; color( 93)="#cdc0b0"; color( 94)="#7cff40"; color( 95)="#a0ff20"
  color( 96)="#bebebe"; color( 97)="#d3d3d3"; color( 98)="#d3d3d3"; color( 99)="#a0a0a0"; color(100)="#a0b6cd"
  color(101)="#000000"; color(102)="#1a1a1a"; color(103)="#333333"; color(104)="#4d4d4d"; color(105)="#666666"
  color(106)="#7f7f7f"; color(107)="#999999"; color(108)="#b3b3b3"; color(109)="#cccccc"; color(110)="#e5e5e5"
  color(111)="#ffffff"

  dbg=.false.
  iErr=0
  StdOut=6
  hmin=0.0_wp
  hmax=0.0_wp
  MHmin_exp=0.0_wp
  MHmax_exp=0.0_wp
  MHmin_calc=0.0_wp
  MHmax_calc=0.0_wp
  MHmin=0.0_wp
  MHmax=0.0_wp
  hmin=MINVAL(H)-0.05_wp*MAXVAL(H)
  hmax=MAXVAL(H)+0.05_wp*MAXVAL(H)
  MHmin_exp=MINVAL(MHexp)
  MHmax_exp=MAXVAL(MHexp)
  MHmin_calc=MINVAL(MHcalc)
  MHmax_calc=MAXVAL(MHcalc)
  MHmin=MIN(MHmin_exp,MHmin_calc)-0.08_wp*MAX(MHmax_exp,MHmax_calc)
  MHmax=MAX(MHmax_exp,MHmax_calc)+0.08_wp*MAX(MHmax_exp,MHmax_calc)


  IF (dbg) WRITE (StdOut,*) 'nH        = ',nH
  IF (dbg) WRITE (StdOut,*) 'hmin      = ',hmin
  IF (dbg) WRITE (StdOut,*) 'hmax      = ',hmax
  IF (dbg) WRITE (StdOut,*) 'MHmin_exp = ',MHmin_exp
  IF (dbg) WRITE (StdOut,*) 'MHmax_exp = ',MHmax_exp
  IF (dbg) WRITE (StdOut,*) 'MHmin_calc= ',MHmin_calc
  IF (dbg) WRITE (StdOut,*) 'MHmax_calc= ',MHmax_calc
  IF (dbg) WRITE (StdOut,*) 'MHmin     = ',MHmin
  IF (dbg) WRITE (StdOut,*) 'MHmax     = ',MHmax
  IF (dbg) WRITE (StdOut,*) 'zJ        = ',zJ
  IF (dbg) THEN
    DO iH=1,nH
      WRITE(StdOut,*) H(iH), ( MHcalc(iH,iTempMagn), MHexp(iH,iTempMagn), iTempMagn=1,nTempMagn)
    END DO
  END IF

  ! generate the GNUPLOT script in the $WorkDir
  lineOut=' '
  line1=' '
  line2=' '
  gnuplot_CMD=' '
  istat=0
  file_exist=.false.
  is_file_open=.false.
  file_size=0
  execute_gnuplot_cmd =.false.
  gnuplot_version=0.0_wp

  ! check if the file lineOUT exists
  INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open, NUMBER=file_number)

  IF (file_exist) then
     IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" exists in WorkDir'
     IF (is_file_open) then
       IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" is opened'
       ! close the file:
       CLOSE (UNIT=file_number,STATUS='DELETE')
     END IF
     ! delete the file
     IF (dbg) WRITE (StdOut,'(A)') 'deleting the file...'
     iErr=AixRm("lineOUT")
  ELSE
     IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" does not exist in WorkDir'
  END IF


  ! find the gnuplot
  IF (dbg) WRITE (StdOut,'(A)') 'inquire which GNUPLOT'

  CALL systemf ( "which gnuplot >> lineOUT", iErr )

  INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number,SIZE=file_size)

  IF (dbg) WRITE (StdOut,*) 'File_number =',file_number
  IF (dbg) WRITE (StdOut,*) 'Is_file_open=',is_file_open
  IF (dbg) WRITE (StdOut,*) 'File_exist  =',file_exist
  IF (dbg) WRITE (StdOut,*) 'File_size   =',file_size

  IF (file_exist) then
    IF (file_size>0) then
      IF (dbg) WRITE (StdOut,'(A)') 'new file  "lineOUT"  exists in WorkDir'

      file_number=453
      Call molcas_open(file_number,'lineOUT')

      READ (file_number,'(A)') line1

      IF (dbg) WRITE (StdOut,*) 'line1=',line1
      IF (dbg) WRITE (StdOut,*) trim(line1)
      line2=trim(line1)
      IF (dbg) WRITE (StdOut,*) 'line2=',line2

      CLOSE(file_number)
      IF (dbg) WRITE (StdOut,*) 'Closing lineOUT file'
      execute_gnuplot_cmd =.true.
    ELSE
      ! file_size =0
      WRITE (StdOut,'(A)') 'file  "lineOUT" has a size=0. gnuplot was not found on the system.'
      WRITE (StdOut,'(A)') 'plots will not be created.'
    END IF
  ELSE
      WRITE (StdOut,'(A)') 'file  "lineOUT" does not exist in WorkDir'
  END IF
  ! remove file "lineOUT"
  iErr=AixRm("lineOUT")
!--------------------------------------------------------------------------------------------


! check the version of the gnuplot:
  IF ( execute_gnuplot_cmd ) Then
    IF (dbg) WRITE (StdOut,'(A)') 'inquire which version of GNUPLOT is installed'
    ! attempt to execute the script
    WRITE (gnuplot_CMD,'(2A)') trim(line2),' --version > lineOUT'
    IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
    CALL systemf ( gnuplot_CMD, iErr )
    file_number=452
    Call molcas_open(file_number,'lineOUT')
    READ (file_number,*) cdummy, gnuplot_version
    IF (dbg) WRITE (StdOut,'(A,F4.1)') 'gnuplot_version = ', gnuplot_version
    IF (abs(gnuplot_version)<0.1_wp) execute_gnuplot_cmd =.false.
    CLOSE (file_number)
    ! remove file "lineOUT"
    iErr=AixRm("lineOUT")
  END IF
!--------------------------------------------------------------------------------------------




  DO iTempMagn=1,nTempMagn
     ! generate the file "MH.dat":
     WRITE(filedat,'(A,I0,A)') 'MH_T_',iTempMagn,'.dat'
     INQUIRE(FILE=filedat,EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
     IF(file_exist)  iErr=AixRm(trim(filedat))
     LuData=554+iTempMagn
     Call molcas_open(LuData,filedat)
     IF (dbg) WRITE (StdOut,*) 'Opening'//trim(filedat)//' file'
     DO iH=1,nH
        WRITE (LuData,'(3ES24.14)') H(iH), MHexp(iH,iTempMagn), MHcalc(iH,iTempMagn)
     END DO
     IF (dbg) WRITE (StdOut,*) 'Writing into the '//trim(filedat)//' file. iTempMagn=',iTempMagn
     CLOSE (LuData)
     IF (dbg) WRITE (StdOut,*) 'Closing the '//trim(filedat)//' file. iTempMagn=',iTempMagn
     FLUSH (StdOut)



     ! generate the GNUPLOT script in the $WorkDir
     Write(fileplt,'(A,I0,A)') 'MH_T_',iTempMagn,'.plt'
     INQUIRE(FILE=fileplt,EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
     IF(file_exist)  iErr=AixRm(trim(fileplt))
     LuPlt=455+iTempMagn
     Call molcas_open(LuPlt,fileplt)
     IF (dbg) WRITE (StdOut,*) 'Opening '//trim(fileplt)//' file'


     IF ( gnuplot_version < 5.0_wp ) Then
     !===  GNUPLOT VERSION 4 and below ==>>  generate EPS
        WRITE (LuPlt,'(A)') 'set terminal postscript eps enhanced color  size 3.0, 2.0 font "arial, 10"'
        WRITE (LuPlt,'(A,i0,A)') 'set output "MH_T_',iTempMagn,'.eps"'
        WRITE (LuPlt,'(A)') 'set grid'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# Axes'
        WRITE (LuPlt,'(A)') '  set xlabel "Magnetic Field / Tesla" font "Arial,14"'
        WRITE (LuPlt,'(A)') '  set ylabel "M / {/Symbol m}_{B}" font "Arial,14"'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[', hmin,':', hmax,']'
        WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',MHmin,':',MHmax,']'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# Tics for axes'
        WRITE (LuPlt,'(A)') '  set xtics nomirror'
        WRITE (LuPlt,'(A)') '  set ytics nomirror'
        WRITE (LuPlt,'(A)') '  set mxtics'
        WRITE (LuPlt,'(A)') '  set mytics'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# Margins'
        WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
        WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# legend'
        WRITE (LuPlt,'(A)') '  set key right bottom'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# actual plotting'

        WRITE (LuPlt,'(A,F7.3,A)') 'plot "'//trim(filedat)//'" using 1:2 with points  lt 1  lw 3 lc rgb "black"  title "Exp. T=',&
                                    TempMagn(iTempMagn),' K.", \'
        WRITE (LuPlt,'(A,F7.3,A)') '     "'//trim(filedat)//'" using 1:3 with lines   lt 1  lw 8 lc rgb "red"    title "Calc.T=',&
                                    TempMagn(iTempMagn),' K."'
        WRITE (LuPlt,'(A)')

     ELSE IF ( (gnuplot_version >= 5.0_wp) .AND.(gnuplot_version < 6.0_wp) ) Then
     !===  GNUPLOT VERSION 5 and above ==>>  generate PNG
        WRITE (LuPlt,'(A)') 'set terminal pngcairo transparent enhanced font "arial,10" fontscale 4.0 size 1800, 1200'
        WRITE (LuPlt,'(A,i0,A)') 'set output "MH_T_',iTempMagn,'.png"'
        WRITE (LuPlt,'(A)') 'set grid'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# Axes'
        WRITE (LuPlt,'(A)') '  set xlabel "Magnetic Field / Tesla" font "Arial,14"'
        WRITE (LuPlt,'(A)') '  set ylabel "M / {/Symbol m}_{B}" font "Arial,14"'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[', hmin,':', hmax,']'
        WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',MHmin,':',MHmax,']'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# Tics for axes'
        WRITE (LuPlt,'(A)') '  set xtics nomirror'
        WRITE (LuPlt,'(A)') '  set ytics nomirror'
        WRITE (LuPlt,'(A)') '  set mxtics'
        WRITE (LuPlt,'(A)') '  set mytics'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# Margins'
        WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
        WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# legend'
        WRITE (LuPlt,'(A)') '  set key right bottom'
        WRITE (LuPlt,'(A)')
        WRITE (LuPlt,'(A)') '# actual plotting'

        WRITE (LuPlt,'(A,F7.3,A)') 'plot "'//trim(filedat)//'" using 1:2 with circles lt 1  lw 3 lc rgb "black"  title "Exp. T=',&
                                    TempMagn(iTempMagn),' K.", \'
        WRITE (LuPlt,'(A,F7.3,A)') '     "'//trim(filedat)//'" using 1:3 with lines   lt 1  lw 8 lc rgb "red"    title "Calc.T=',&
                                    TempMagn(iTempMagn),' K."'
        WRITE (LuPlt,'(A)')
     ELSE
       WRITE (StdOut,*) 'GNUPLOT has version: ', gnuplot_version
       WRITE (StdOut,*) 'This version of GNUPLOT is not known and thus, unsupported.'
       execute_gnuplot_cmd=.false.
     END IF
     CLOSE (LuPlt)

     IF (execute_gnuplot_cmd) Then
       ! attempt to execute the script
       WRITE (gnuplot_CMD,'(5A)') trim(line2),'  ',trim(fileplt)
       IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
       CALL systemf ( gnuplot_CMD, iErr )
       IF ( gnuplot_version < 5.0_wp ) Then
         WRITE (StdOut,'(A,i0,A)') 'File "MH_T_',iTempMagn,'.eps" was created in Working directory.'
       ELSE
         WRITE (StdOut,'(A,i0,A)') 'File "MH_T_',iTempMagn,'.png" was created in Working directory.'
       END IF
     END IF
  END DO ! iTempMagn

  RETURN
  END SUBROUTINE plot_MH_with_Exp





  Subroutine plot_MH_no_Exp( nH, H, nTempMagn, TempMagn, MHcalc, zJ )

  IMPLICIT NONE

  Integer, parameter    :: wp=SELECTED_REAL_KIND(p=15,r=307)
  INTEGER, INTENT(in)   :: nH, nTempMagn
  REAL (wp), INTENT(in) :: H(nH), TempMagn(nTempMagn)
  REAL (wp), INTENT(in) :: MHcalc(nH,nTempMagn)
  REAL (wp), INTENT(in) :: zJ
  ! local variables
  REAL (wp) :: hmin, hmax, MHmin_calc, MHmax_calc, MHmin, MHmax, r
  REAL (wp) :: gnuplot_version
  INTEGER           :: file_number, istat, iH, iTempMagn, LuPlt, LuData, ik, ic, file_size, StdOut, iErr
  LOGICAL           :: file_exist, is_file_open, execute_gnuplot_cmd, dbg
  CHARACTER(LEN=100):: line1, line2, lineOut, fmtline, cdummy
  CHARACTER(LEN=100):: gnuplot_CMD
  CHARACTER(LEN=7) :: color(111)
  INTEGER, EXTERNAL:: AixRm

  color(  1)="#ffffff"; color(  2)="#000000"; color(  3)="#a0a0a0"; color(  4)="#ff0000"; color(  5)="#00c000"
  color(  6)="#0080ff"; color(  7)="#c000ff"; color(  8)="#00eeee"; color(  9)="#c04000"; color( 10)="#c8c800"
  color( 11)="#4169e1"; color( 12)="#ffc020"; color( 13)="#008040"; color( 14)="#c080ff"; color( 15)="#306080"
  color( 16)="#8b0000"; color( 17)="#408000"; color( 18)="#ff80ff"; color( 19)="#7fffd4"; color( 20)="#a52a2a"
  color( 21)="#ffff00"; color( 22)="#40e0d0"; color( 23)="#000000"; color( 24)="#1a1a1a"; color( 25)="#333333"
  color( 26)="#4d4d4d"; color( 27)="#666666"; color( 28)="#7f7f7f"; color( 29)="#999999"; color( 30)="#b3b3b3"
  color( 31)="#c0c0c0"; color( 32)="#cccccc"; color( 33)="#e5e5e5"; color( 34)="#ffffff"; color( 35)="#f03232"
  color( 36)="#90ee90"; color( 37)="#add8e6"; color( 38)="#f055f0"; color( 39)="#e0ffff"; color( 40)="#eedd82"
  color( 41)="#ffb6c1"; color( 42)="#afeeee"; color( 43)="#ffd700"; color( 44)="#00ff00"; color( 45)="#006400"
  color( 46)="#00ff7f"; color( 47)="#228b22"; color( 48)="#2e8b57"; color( 49)="#0000ff"; color( 50)="#00008b"
  color( 51)="#191970"; color( 52)="#000080"; color( 53)="#0000cd"; color( 54)="#87ceeb"; color( 55)="#00ffff"
  color( 56)="#ff00ff"; color( 57)="#00ced1"; color( 58)="#ff1493"; color( 59)="#ff7f50"; color( 60)="#f08080"
  color( 61)="#ff4500"; color( 62)="#fa8072"; color( 63)="#e9967a"; color( 64)="#f0e68c"; color( 65)="#bdb76b"
  color( 66)="#b8860b"; color( 67)="#f5f5dc"; color( 68)="#a08020"; color( 69)="#ffa500"; color( 70)="#ee82ee"
  color( 71)="#9400d3"; color( 72)="#dda0dd"; color( 73)="#905040"; color( 74)="#556b2f"; color( 75)="#801400"
  color( 76)="#801414"; color( 77)="#804014"; color( 78)="#804080"; color( 79)="#8060c0"; color( 80)="#8060ff"
  color( 81)="#808000"; color( 82)="#ff8040"; color( 83)="#ffa040"; color( 84)="#ffa060"; color( 85)="#ffa070"
  color( 86)="#ffc0c0"; color( 87)="#ffff80"; color( 88)="#ffffc0"; color( 89)="#cdb79e"; color( 90)="#f0fff0"
  color( 91)="#a0b6cd"; color( 92)="#c1ffc1"; color( 93)="#cdc0b0"; color( 94)="#7cff40"; color( 95)="#a0ff20"
  color( 96)="#bebebe"; color( 97)="#d3d3d3"; color( 98)="#d3d3d3"; color( 99)="#a0a0a0"; color(100)="#a0b6cd"
  color(101)="#000000"; color(102)="#1a1a1a"; color(103)="#333333"; color(104)="#4d4d4d"; color(105)="#666666"
  color(106)="#7f7f7f"; color(107)="#999999"; color(108)="#b3b3b3"; color(109)="#cccccc"; color(110)="#e5e5e5"
  color(111)="#ffffff"

  dbg=.false.
  StdOut=6
  iErr=0
  hmin=0.0_wp
  hmax=0.0_wp
  MHmin_calc=0.0_wp
  MHmax_calc=0.0_wp
  MHmin=0.0_wp
  MHmax=0.0_wp
  hmin=MINVAL(H)-0.02_wp*MAXVAL(H)
  hmax=MAXVAL(H)+0.02_wp*MAXVAL(H)
  MHmin_calc=MINVAL(MHcalc)
  MHmax_calc=MAXVAL(MHcalc)
  MHmin=MHmin_calc-0.01_wp*MHmax_calc
  MHmax=MHmax_calc+0.01_wp*MHmax_calc


  IF (dbg) WRITE (StdOut,*) 'nH        = ',nH
  IF (dbg) WRITE (StdOut,*) 'hmin      = ',hmin
  IF (dbg) WRITE (StdOut,*) 'hmax      = ',hmax
  IF (dbg) WRITE (StdOut,*) 'MHmin_calc= ',MHmin_calc
  IF (dbg) WRITE (StdOut,*) 'MHmax_calc= ',MHmax_calc
  IF (dbg) WRITE (StdOut,*) 'MHmin     = ',MHmin
  IF (dbg) WRITE (StdOut,*) 'MHmax     = ',MHmax
  IF (dbg) WRITE (StdOut,*) 'zJ        = ',zJ
  IF (dbg) THEN
    DO iH=1,nH
      WRITE(StdOut,*) H(iH), (MHcalc(iH,iTempMagn),iTempMagn=1,nTempMagn)
    END DO
  END IF

  ! generate the GNUPLOT script in the $WorkDir
  lineOut=' '
  line1=' '
  line2=' '
  gnuplot_CMD=' '
  istat=0
  file_exist=.false.
  is_file_open=.false.
  file_size=0
  execute_gnuplot_cmd =.false.
  gnuplot_version=0.0_wp

  ! check if the file lineOUT exists
  INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open, NUMBER=file_number)

  IF (file_exist) then
     IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" exists in WorkDir'
     IF (is_file_open) then
       IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" is opened'
       ! close the file:
       CLOSE (UNIT=file_number,STATUS='DELETE')
     END IF
     ! delete the file
     IF (dbg) WRITE (StdOut,'(A)') 'deleting the file...'
     iErr=AixRm("lineOUT")
  ELSE
     IF (dbg) WRITE (StdOut,'(A)') 'file  "lineOUT" does not exist in WorkDir'
  END IF


  ! find the gnuplot
  IF (dbg) WRITE (StdOut,'(A)') 'inquire which GNUPLOT'

  CALL systemf ( "which gnuplot >> lineOUT", iErr )
  INQUIRE(FILE="lineOUT",EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number,SIZE=file_size)

  IF (dbg) WRITE (StdOut,*) 'File_number =',file_number
  IF (dbg) WRITE (StdOut,*) 'Is_file_open=',is_file_open
  IF (dbg) WRITE (StdOut,*) 'File_exist  =',file_exist
  IF (dbg) WRITE (StdOut,*) 'File_size   =',file_size

  IF (file_exist) then
    IF (file_size>0) then
      IF (dbg) WRITE (StdOut,'(A)') 'new file  "lineOUT"  exists in WorkDir'

      file_number=453
      Call molcas_open(file_number,"lineOUT")

      READ (file_number,'(A)') line1

      IF (dbg) WRITE (StdOut,*) 'line1=',line1
      IF (dbg) WRITE (StdOut,*) trim(line1)
      line2=trim(line1)
      IF (dbg) WRITE (StdOut,*) 'line2=',line2

      CLOSE(file_number)
      IF (dbg) WRITE (StdOut,*) 'Closing lineOUT file'
      FLUSH (StdOut)
      execute_gnuplot_cmd=.true.
    ELSE
      ! file_size =0
      WRITE (StdOut,'(A)') 'file  "lineOUT" has a size=0. gnuplot was not found on the system.'
      WRITE (StdOut,'(A)') 'plots will not be created.'
    END IF
  ELSE
     WRITE (StdOut,'(A)') 'file  "lineOUT" does not exist in WorkDir'
  END IF
  ! remove file "lineOUT"
  iErr=AixRm("lineOUT")
!--------------------------------------------------------------------------------------------


! check the version of the gnuplot:
  IF ( execute_gnuplot_cmd ) Then
    IF (dbg) WRITE (StdOut,'(A)') 'inquire which version of GNUPLOT is installed'
    ! attempt to execute the script
    WRITE (gnuplot_CMD,'(2A)') trim(line2),' --version > lineOUT'
    IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
    CALL systemf ( gnuplot_CMD, iErr )
    file_number=452
    Call molcas_open(file_number,"lineOUT")
    READ (file_number,*) cdummy, gnuplot_version
    IF (dbg) WRITE (StdOut,'(A,F4.1)') 'gnuplot_version = ', gnuplot_version
    IF (abs(gnuplot_version)<0.1_wp) execute_gnuplot_cmd =.false.
    CLOSE (file_number)
    ! remove file "lineOUT"
    iErr=AixRm("lineOUT")
  END IF


!----------------------------------------------------------------------------------------
! create the file "MH.dat"
  INQUIRE(FILE="MH.dat",EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
  IF(file_exist)  iErr=AixRm("MH.dat")
  LuData=454
  Call molcas_open(LuData,"MH.dat")
  IF (dbg) WRITE (StdOut,*) 'Opening "MH.dat" file'
  write(fmtline,'(A,i0,A)') '(',nTempMagn+1,'ES24.14)'
  DO iH=1,nH
     WRITE (LuData,fmtline) H(iH), ( MHcalc(iH,iTempMagn), iTempMagn=1,nTempMagn )
  END DO
  IF (dbg) WRITE (StdOut,*) 'Writing into the "MH.dat" file'
  CLOSE (LuData)
  IF (dbg) WRITE (StdOut,*) 'Closing the "MH.dat" file'
  FLUSH (StdOut)

  ! generate the GNUPLOT script in the $WorkDir
  INQUIRE(FILE="MH.plt",EXIST=file_exist,OPENED=is_file_open,NUMBER=file_number)
  IF(file_exist) iErr=AixRm("MH.plt")
  LuPlt=455
  Call molcas_open(LuPlt,"MH.plt")
  IF (dbg) WRITE (StdOut,*) 'Opening "MH.plt" file'


  IF ( gnuplot_version < 5.0_wp ) Then
  !===  GNUPLOT VERSION 4 and below ==>>  generate EPS
     WRITE (LuPlt,'(A)') 'set terminal postscript eps enhanced color  size 3.0, 2.0 font "arial, 10"'
     WRITE (LuPlt,'(A)') 'set output "MH.eps"'
     WRITE (LuPlt,'(A)') 'set grid'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Axes'
     WRITE (LuPlt,'(A)') '  set xlabel "Magnetic Field / Tesla" font "Arial,14"'
     WRITE (LuPlt,'(A)') '  set ylabel "M / {/Symbol m}_{B}" font "Arial,14"'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[', hmin,':', hmax,']'
     WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',MHmin,':',MHmax,']'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Tics for axes'
     WRITE (LuPlt,'(A)') '  set xtics nomirror'
     WRITE (LuPlt,'(A)') '  set ytics nomirror'
     WRITE (LuPlt,'(A)') '  set mxtics'
     WRITE (LuPlt,'(A)') '  set mytics'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Margins'
     WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
     WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# legend'
     WRITE (LuPlt,'(A)') '  set key right bottom'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# actual plotting'
     DO iTempMagn=1,nTempMagn
       ik=iTempMagn+1
       Call RANDOM_NUMBER(r)
       ic=INT(111.0_wp*r)
       IF((iTempMagn.eq.1).AND.(nTempMagn.gt.1)) THEN
         WRITE (LuPlt,'(A,i0,A,F7.3,A)') 'plot "MH.dat" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)//&
                                          '"  title "Calc. M at T=',TempMagn(iTempMagn),'K.", \'
       ELSE IF ((iTempMagn.eq.1).AND.(nTempMagn.eq.1)) THEN
         WRITE (LuPlt,'(A,i0,A,F7.3,A)') 'plot "MH.dat" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)//&
                                         '"  title "Calc. M at T=',TempMagn(iTempMagn),'K."'
       END IF
       IF ( (iTempMagn.lt.nTempMagn).AND.(iTempMagn.ne.1) ) THEN
         WRITE (LuPlt,'(A,i0,A,F7.3,A)') '     "MH.dat" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)//&
                                         '"  title "Calc. M at T=',TempMagn(iTempMagn),'K.", \'
       END IF
       IF ( (iTempMagn.eq.nTempMagn).AND.(nTempMagn.gt.1) ) THEN
         WRITE (LuPlt,'(A,i0,A,F7.3,A)') '     "MH.dat" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)//&
                                         '"  title "Calc. M at T=',TempMagn(iTempMagn),'K."'
       END IF
     END DO


  ELSE IF ( (gnuplot_version >= 5.0_wp) .AND.(gnuplot_version < 6.0_wp) ) Then
  !===  GNUPLOT VERSION 5 and above ==>>  generate PNG
     WRITE (LuPlt,'(A)') 'set terminal pngcairo transparent enhanced font "arial,10" fontscale 4.0 size 1800, 1200'
     WRITE (LuPlt,'(A)') 'set output "MH.png"'
     WRITE (LuPlt,'(A)') 'set grid'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Axes'
     WRITE (LuPlt,'(A)') '  set xlabel "Magnetic Field / Tesla" font "Arial,14"'
     WRITE (LuPlt,'(A)') '  set ylabel "M / {/Symbol m}_{B}" font "Arial,14"'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set xrange[', hmin,':', hmax,']'
     WRITE (LuPlt,'(A,F8.4,A,F10.4,A)') '  set yrange[',MHmin,':',MHmax,']'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Tics for axes'
     WRITE (LuPlt,'(A)') '  set xtics nomirror'
     WRITE (LuPlt,'(A)') '  set ytics nomirror'
     WRITE (LuPlt,'(A)') '  set mxtics'
     WRITE (LuPlt,'(A)') '  set mytics'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# Margins'
     WRITE (LuPlt,'(A)') '  set bmargin at screen 0.20'
     WRITE (LuPlt,'(A)') '  set lmargin at screen 0.15'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# legend'
     WRITE (LuPlt,'(A)') '  set key right bottom'
     WRITE (LuPlt,'(A)')
     WRITE (LuPlt,'(A)') '# actual plotting'
     DO iTempMagn=1,nTempMagn
       ik=iTempMagn+1
       Call RANDOM_NUMBER(r)
       ic=INT(110.0_wp*r)
       IF((iTempMagn.eq.1).AND.(nTempMagn.gt.1)) THEN
         WRITE (LuPlt,'(A,i0,A,F7.3,A)') 'plot "MH.dat" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)//&
                                          '"  title "Calc. M at T=',TempMagn(iTempMagn),'K.", \'
       ELSE IF ((iTempMagn.eq.1).AND.(nTempMagn.eq.1)) THEN
         WRITE (LuPlt,'(A,i0,A,F7.3,A)') 'plot "MH.dat" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)//&
                                         '"  title "Calc. M at T=',TempMagn(iTempMagn),'K."'
       END IF
       IF ( (iTempMagn.lt.nTempMagn).AND.(iTempMagn.ne.1) ) THEN
         WRITE (LuPlt,'(A,i0,A,F7.3,A)') '     "MH.dat" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)//&
                                         '"  title "Calc. M at T=',TempMagn(iTempMagn),'K.", \'
       END IF
       IF ( (iTempMagn.eq.nTempMagn).AND.(nTempMagn.gt.1) ) THEN
         WRITE (LuPlt,'(A,i0,A,F7.3,A)') '     "MH.dat" using 1:',ik,' with lines lt 1  lw  8 lc rgb "'//color(ic)//&
                                         '"  title "Calc. M at T=',TempMagn(iTempMagn),'K."'
       END IF
     END DO
  ELSE
    WRITE (StdOut,*) 'GNUPLOT has version: ', gnuplot_version
    WRITE (StdOut,*) 'This version of GNUPLOT is not known and thus, unsupported.'
    execute_gnuplot_cmd=.false.
  END IF
  WRITE (LuPlt,'(A)')
  CLOSE (LuPlt)


  WRITE (StdOut,'(A)') 'File "MH.png" was created in Working directory.'

  IF (execute_gnuplot_cmd) Then
    ! attempt to execute the script
    WRITE (gnuplot_CMD,'(A,A)') trim(line2),'  MH.plt'
    IF (dbg) WRITE (StdOut,'(A,A)') 'gnuplot_CMD=',gnuplot_CMD
    CALL systemf ( gnuplot_CMD, iErr )
    IF ( gnuplot_version < 5.0_wp ) Then
      WRITE (StdOut,'(A,i0,A)') 'File "MH.eps" was created in Working directory.'
    ELSE
      WRITE (StdOut,'(A,i0,A)') 'File "MH.png" was created in Working directory.'
    END IF
  END IF

  RETURN
  END SUBROUTINE plot_MH_no_Exp

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine wrgspr_cvb(recn,c,i,n,ic,ierr)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

#include "malloc_cvb.fh"
#include "mo_cvb.fh"
      dimension c(n)

c  Read header :
      call rdheader_cvb(recn,norb1,nbas_mo1,nvb1,kbasiscvb1,
     >  ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)

      if(ic.eq.1)then
c  >>> Orbital write, I is orbital number :
        if(i.gt.norb1)then
          ierr=1
          return
        endif
        ioffs=(i-1)*norb1+ioffs_orbs
        call wrr_cvb(c,min(norb1,n),recn,ioffs)
      elseif(ic.eq.2)then
c  >>> Structure write, I is starting structure coefficient :
        if(i.gt.nvb1)then
          ierr=1
          return
        endif
        ioffs=i-1+ioffs_cvb
        call wrr_cvb(c,min(nvb1,n),recn,ioffs)
      elseif(ic.eq.3)then
c  >>> Write of orbital in AO basis, I is orbital number :
        if(i.gt.norb1)then
          ierr=1
          return
        endif
        if(nbas_mo1.eq.0)then
          nbas_mo1=nbas_mo
          call wrheader_cvb(recn,norb1,nbas_mo1,nvb1,kbasiscvb1,
     >      ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)
        endif
c  Error return if AO bases are not identical :
        if(nbas_mo1.ne.n)then
          ierr=1
          return
        endif
        ioffs=(i-1)*nbas_mo1+ioffs_orbsao
        call wrr_cvb(c,min(nbas_mo1,n),recn,ioffs)
      elseif(ic.eq.4)then
c  >>> Write of localized orbital in AO basis, I is orbital number :
        if(i.gt.norb1)then
          ierr=1
          return
        endif
        if(nbas_mo1.eq.0)then
          nbas_mo1=nbas_mo
          call wrheader_cvb(recn,norb1,nbas_mo1,nvb1,kbasiscvb1,
     >      ioffs_orbs,ioffs_cvb,ioffs_orbsao,ioffs_orbslao)
        endif
c  Error return if AO bases are not identical :
        if(nbas_mo1.ne.n)then
          ierr=1
          return
        endif
        ioffs=(i-1)*nbas_mo1+ioffs_orbslao
        call wrr_cvb(c,min(nbas_mo1,n),recn,ioffs)
      endif
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1998, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 1998  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE W1TW2(IVEC,JVEC,CI,SGM)
      use definitions, only: iwp, wp
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: nAshT, STSym
      implicit none


      integer(kind=iwp), intent(in):: IVEC, JVEC
      Real(kind=wp), intent(in):: ci(*)
      Real(kind=wp), intent(inout)::  sgm(*)

      integer(kind=iwp) :: nOp1, nOp2, nOp3
      Real(kind=wp), Allocatable:: OP1(:), OP2(:), OP3(:)
      Real(kind=wp):: OP0

C Given contravariant indices of two wave operators W1 and W2,
C in the vectors numbered IVEC and JVEC on file (unit LUSOLV),
C compute the vector in CAS space
C   | SGM > := | SGM > + (W1 conj)*(W2)*| CI >


C (1): Compute a representation of the operator PCAS*W1T*W2
      NOP1=NASHT**2
      NOP2=(NOP1*(NOP1+1))/2
      NOP3=(NOP2*(NOP1+2))/3
      CALL mma_allocate(OP1,NOP1,Label='OP1')
      CALL mma_allocate(OP2,NOP2,Label='OP2')
      CALL mma_allocate(OP3,NOP3,Label='OP3')

      CALL MKWWOP(IVEC,JVEC,OP0,OP1,NOP2,OP2,NOP3,OP3)

C Modify the coefficients, see subroutine MODOP.

      CALL MODOP(OP1,NOP2,OP2,NOP3,OP3)

C (2) Apply the operators:
      CALL HAM3(OP0,OP1,NOP2,OP2,NOP3,OP3,STSYM,CI,SGM)

      CALL mma_deallocate(OP1)
      CALL mma_deallocate(OP2)
      CALL mma_deallocate(OP3)

      END SUBROUTINE W1TW2

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

! ****************************************************************
! history:                                                       *
! Jie J. Bao, on Dec. 08, 2021, created this file.               *
! ****************************************************************
subroutine PackPot1(Packed,Full,nPack,Factor)

use nq_Info, only: mIrrep, mOrb, OffOrb2, OffOrbTri, nPot1
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nPack
real(kind=wp), intent(out) :: Packed(nPack)
real(kind=wp), intent(in) :: Full(nPot1), Factor
integer(kind=iwp) :: iIrrep, iOff1, IOff2, nOrbs, p, q

do iIrrep=0,mIrrep-1
  nOrbs = mOrb(iIrrep)
  IOff1 = OffOrbTri(iIrrep)
  IOff2 = OffOrb2(iIrrep)
  do P=1,nOrbs
    do Q=1,P
      Packed(IOff1+(P-1)*P/2+Q) = Factor*(Full(IOff2+(P-1)*nOrbs+Q)+Full(IOff2+(Q-1)*nOrbs+P))
    end do
  end do
end do

return

end subroutine PackPot1

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_INTCHK_ID_OF(LABEL,ID,IOPT)
C
C     Purpose: for minimal integral checking,
C              IOPT=-1 : return label corresponding to id ID.
C              else    : return index of shell quadruple corresponding
C                        to check label LABEL.
C
      IMPLICIT NONE
      CHARACTER*8 LABEL
      INTEGER ID, IOPT
#include "cholesky.fh"

      INTEGER  CHO_TABIND
      EXTERNAL CHO_TABIND

      INTEGER     NTABLE
      PARAMETER   (NTABLE = 12)
      CHARACTER*8 TABLE(NTABLE)
      DATA TABLE  /'EXCL RS1','MAX|XRS1','MIN|XRS1',
     &             'NEG DIAG','MAX|NEG ','MIN|NEG ',
     &             'NEG->ZER','MAX|NEGZ','MIN|NEGZ',
     &             'MAX DIAG','MIN DIAG','MAX|MIN '/

      IF (IOPT .EQ. -1) THEN
         IF (ID.LT.1 .OR. ID.GT.NTABLE) THEN
            LABEL = 'UNKNOWN '
         ELSE
            LABEL = TABLE(ID)
         END IF
      ELSE
         ID = CHO_TABIND(TABLE,8,NTABLE,' ',0,0,LABEL)
      END IF

      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE DO_SONATORB(NSS, USOR, USOI)
      use rassi_global_arrays, only: JBNUM, EIGVEC
      IMPLICIT REAL*8 (A-H,O-Z)
#include "Molcas.fh"
#include "cntrl.fh"
#include "WrkSpc.fh"
#include "rassi.fh"
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='DO_SONATORB')
      Real*8 USOR(NSS,NSS), USOI(NSS,NSS)
      Real*8 IDENTMAT(3,3)

c Calculates natural orbitals, including spinorbit effects
      WRITE(6,*)
      WRITE(6,*)
      WRITE(6,*) '*****************************************'
      WRITE(6,*) '* RUNNING SONATORB CODE *****************'
      WRITE(6,*) '*****************************************'
      WRITE(6,*)

      IDENTMAT(:,:)=0.0D0
      FOR ALL (I=1:3) IDENTMAT(I,I)=1.0D0

      CALL GETMEM('UMATR2','ALLO','REAL',LUMATR,NSS**2)
      CALL GETMEM('UMATI2','ALLO','REAL',LUMATI,NSS**2)
      CALL GETMEM('EIGVEC2','ALLO','REAL',LVMAT,NSS**2)

      CALL DCOPY_(NSS**2,[0.0d0],0,WORK(LVMAT),1)

c transform V matrix in SF basis to spin basis
c This was taken from smmat.f and modified slightly
      ISS=0
      DO ISTATE=1,NSTATE
       JOB1=JBNUM(ISTATE)
       MPLET1=MLTPLT(JOB1)
       S1=0.5D0*DBLE(MPLET1-1)

       DO MSPROJ1=-MPLET1+1,MPLET1-1,2
        SM1=0.5D0*DBLE(MSPROJ1)
        ISS=ISS+1
        JSS=0

        DO JSTATE=1,NSTATE
         JOB2=JBNUM(JSTATE)
         MPLET2=MLTPLT(JOB2)
         S2=0.5D0*DBLE(MPLET2-1)

         DO MSPROJ2=-MPLET2+1,MPLET2-1,2
          SM2=0.5D0*DBLE(MSPROJ2)
          JSS=JSS+1

          IF (MPLET1.EQ.MPLET2 .AND. MSPROJ1.EQ.MSPROJ2) THEN
           IJ=(JSS-1)*NSS+ISS
           WORK(LVMAT-1+IJ)=EIGVEC(JSTATE,ISTATE)
          END IF ! IF (MPLET1.EQ.MPLET2 .AND. MSPROJ1.EQ.MSPROJ2)
         END DO ! DO MSPROJ2=-MPLET2+1,MPLET2-1,2
        END DO ! end DO JSTATE=1,NSTATE
       END DO ! DO MSPROJ1=-MPLET1+1,MPLET1-1,2
      END DO ! DO ISTATE=1,NSTATE



c combine this matrix with the SO eigenvector matrices
      IF(.not.NOSO) THEN
        CALL DGEMM_('N','N',NSS,NSS,NSS,
     &      1.0d0,WORK(LVMAT),NSS,USOR,NSS,0.0d0,
     &      WORK(LUMATR),NSS)
        CALL DGEMM_('N','N',NSS,NSS,NSS,
     &      1.0d0,WORK(LVMAT),NSS,USOI,NSS,0.0d0,
     &      WORK(LUMATI),NSS)
      ELSE
c Spinorbit contributions to this are disabled
        CALL DCOPY_(NSS,WORK(LVMAT),1,WORK(LUMATR),1)
        CALL DCOPY_(NSS,[0.0d0],0,WORK(LUMATI),1)
      END IF

c Holds the density matrices for all three directions
      CALL GETMEM('DMATTMP','ALLO','REAL',LDMATTMP,6*NBTRI)

c SONATNSTATE = number of states to calculate.
c These states are stored beginning in IWORK(LSONAT)
      DO I=1,SONATNSTATE
        INATSTATE=IWORK(LSONAT-1+I)

        WRITE(6,*)
        WRITE(6,*) "CALCULATING NAT ORBITALS FOR SSTATE: ",INATSTATE
        IF(INATSTATE.GT.NSS.OR.INATSTATE.LE.0) THEN
          WRITE(6,*) "...WHICH DOES NOT EXIST!"
          CALL ABEND()
        END IF
        WRITE(6,*)

C Calculate overall density, store in WORK(LDMATTMP)
        iOpt=0
        CALL SONATORBM('HERMSING',WORK(LUMATR),WORK(LUMATI),
     &                 INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,
     &                 WORK(LDMATTMP))


C Integrate for the expectation value
        IF(IPGLOB.ge.VERBOSE) THEN
          IC=1
          iOpt=0
          CALL SONATORBM_INT(WORK(LDMATTMP),'MLTPL  0',IC,'HERMSING',
     &                      INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,
     &                      DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)

C          CALL ADD_INFO('MLTPL0SING_INT3',DUM3,1,6)
C          CALL ADD_INFO('MLTPL0SING_INT6',DUM6,1,6)
        END IF

C Create SONATTDENS total density orbital file for this (I,I) state
        CALL SONATORB_PLOT(WORK(LDMATTMP),'SONATTDENS','HERMSING',
     &                     INATSTATE,INATSTATE)

        IF(IPGLOB.ge.DEBUG) THEN
          CALL SONATORB_CPLOT(WORK(LDMATTMP),'TDENSTESTX','HERMSING',
     &                       INATSTATE,INATSTATE)
        END IF




C Calculate spin density, store in LDMATTMP
        iOpt=0
        CALL SONATORBM('HERMTRIP',WORK(LUMATR),WORK(LUMATI),
     &                 INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,
     &                 WORK(LDMATTMP))


C Integrate for the expectation value
        IF(IPGLOB.ge.VERBOSE) THEN
          IC=1
          iOpt=0
          CALL SONATORBM_INT(WORK(LDMATTMP),'MLTPL  0',IC,'HERMTRIP',
     &                      INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,
     &                      DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)
C          CALL ADD_INFO('MLTPL0TRIP_INT3',DUM3,1,6)
C          CALL ADD_INFO('MLTPL0TRIP_INT6',DUM6,1,6)
        END IF


C Create SONATSDENS spin density orbital file for this (I,I) state
        CALL SONATORB_PLOT(WORK(LDMATTMP),'SONATSDENS','HERMTRIP',
     &                     INATSTATE,INATSTATE)

        IF(IPGLOB.ge.DEBUG) THEN
          CALL SONATORB_CPLOT(WORK(LDMATTMP),'SDENSTESTX','HERMTRIP',
     &                       INATSTATE,INATSTATE)
        END IF


c Type 2 - current density
        IF(IFCURD) THEN
          iOpt=0
          CALL SONATORBM('ANTISING',WORK(LUMATR),WORK(LUMATI),
     &                   INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,
     &                   WORK(LDMATTMP))


          IF(IPGLOB.ge.VERBOSE) THEN
            IC=1
            iOpt=0
            CALL SONATORBM_INT(WORK(LDMATTMP),'ANGMOM  ',IC,'ANTISING',
     &                        INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,
     &                        DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)
C            CALL ADD_INFO('CURD1_INT3',DUM3,1,6)
C            CALL ADD_INFO('CURD1_INT6',DUM6,1,6)

            IC=2
            iOpt=0
            CALL SONATORBM_INT(WORK(LDMATTMP),'ANGMOM  ',IC,'ANTISING',
     &                        INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,
     &                        DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)

C            CALL ADD_INFO('CURD2_INT3',DUM3,1,6)
C            CALL ADD_INFO('CURD2_INT6',DUM6,1,6)

            IC=3
            iOpt=0
            CALL SONATORBM_INT(WORK(LDMATTMP),'ANGMOM  ',IC,'ANTISING',
     &                        INATSTATE,INATSTATE,NSS,iOpt,IDENTMAT,
     &                        DUM1,DUM2,DUM3,DUM4,DUM5,DUM6)
C            CALL ADD_INFO('CURD3_INT3',DUM3,1,6)
C            CALL ADD_INFO('CURD3_INT6',DUM6,1,6)

          END IF


          CALL SONATORB_CPLOT(WORK(LDMATTMP),'SONATLDENS','ANTISING',
     &                        INATSTATE,INATSTATE)
        END IF


      END DO

      CALL GETMEM('DMATTMP','FREE','REAL',LDMATTMP,6*NBTRI)
      CALL GETMEM('SONATS','FREE','INTE',LSONAT,SONATNSTATE)


c perform the state diagonalization similar to
c what is done in single_aniso
      IF(SODIAGNSTATE.GT.0) THEN

!       Triangular part of a matrix
        LSOSIZ=SODIAGNSTATE*(SODIAGNSTATE+1)

c This actually does all the work
        CALL SODIAG(WORK(LUMATR), WORK(LUMATI), NSS)

c This is only allocated if SODIAGNSTATE.GT.0
        CALL GETMEM('SODIAG','FREE','INTE',LSODIAG,SODIAGNSTATE)
      END IF

      CALL GETMEM('UMATR2','FREE','REAL',LUMATR,NSS**2)
      CALL GETMEM('UMATI2','FREE','REAL',LUMATI,NSS**2)
      CALL GETMEM('EIGVEC2','FREE','REAL',LVMAT,NSS**2)

      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine angular(Lhigh,keep,keepcart,makemean,bonn,
     *                   breit,sameorb,ifinite,
     *                   onecartx,onecarty,onecartz,powexp,coulovlp,
     *                   preXZ,preY,icheckxy,icheckz,interxyz,isgnprod)

c
cbs   COMBINES THE RADIAL INTEGRALS WITH THE ANGULAR FACTORS
c
cbs   if keep=.true. then
cbs   all the integrals will be kept in memory.
cbs   Perhaps, there will be the option to make the
cbs   transformation to the cartesian basis-sets
cbs   everytime, they are required.
cbs   Therefore, the integrals are kept in memory and
cbs   can be further transformed, whenever required.
cbs   in order not to waste to much memory, the atomic
cbs   integrals are thrown away after each l,l,l,l-block
      implicit real*8(a-h,o-z)
#include "para.fh"
#include "param.fh"
#include "Molcas.fh"
#include "stdalloc.fh"
      Real*8, Allocatable:: ConOO(:), ConSO(:), CartOO(:), CartSO(:),
     &                      AngOO(:), AngSO(:)
      logical keep,keepcart,makemean,bonn,
     *        breiT,sameorb,cleaner,NFINI
cbs   NFINI means not finite nucleus
      dimension l2block(0:Lmax,0:Lmax,0:Lmax,0:Lmax),
     *          onecartX(mxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax),
     *          onecartY(mxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax),
     *          onecartZ(mxcontL,MxcontL,(Lmax+Lmax+1)*(Lmax+1),Lmax),
     *powexp(MxprimL,MxprimL,0:Lmax,0:Lmax,0:(Lmax+Lmax+5)),coulovlp(*),
     *preXZ(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax),
     *preY(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax),
     *icheckxy(0:Lmax,0:Lmax,0:Lmax,0:Lmax),
     *icheckz(0:Lmax,0:Lmax,0:Lmax,0:Lmax),
     *interxyz(16,0:Lmax,0:Lmax,0:Lmax,0:Lmax),
     *isgnprod(-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax,-Lmax:Lmax)
cbs ####################################################################
cbs   some preparation of factors needed later on..                    #
cbs ####################################################################
      ipnt(i,j)=(max(i,j)*max(i,j)-max(i,j))/2+min(i,j)
      roottwo=sqrt(2d0)
cbs   calculate some prefactors that will be needed quite often
      call prefac(Lmax,preroots,clebsch)
      if (ifinite.ne.2) then
cbs      clean array for one electron integrals
         onecartX(:,:,:,:)=0.0D0
         onecartY(:,:,:,:)=0.0D0
         onecartZ(:,:,:,:)=0.0D0
         NFINI=.true.
      else
         NFINI=.false.
      endif
*
cbs   generate an array with sign for (even/odd) m-values
      isignM(0)=1
      do I=2,Lmax,2
      isignM(I)=1
      isignM(-I)=1
      enddo
      do I=1,Lmax,2
      isignM(I)=-1
      isignM(-I)=-1
      enddo
      call genprexyz(preXZ)
      call genprexyz2(preXZ)
      call genprexyz3(preXZ)
      call genprexyz4(preXZ)
      call genprexyz5(preXZ)
      call genprexyz6(preY,preXZ)
      call genprexyz7(preXZ)
      call genprexyz8(preXZ)
      call genprexyz9(preXZ)
      call genprexyz10(preXZ)
      call genprexyz11(preY)
      call genprexyz12(preY)
      call genprexyz13(icheckxy)
      call genprexyz14(icheckz,interxyz)
      call genprexyz15a(icheckxy,icheckz,interxyz)
cbs #####################################################################
cbs   isgnprod gives the sign due to powers (-1)**M  this are again
cbs   angular m-values
cbs #####################################################################
      do M4=-Lmax,Lmax
         if (M4.gt.0) then
            inter4=isignM(M4)
         else
            inter4=1
         endif
         do M3=-Lmax,Lmax
            if (M3.gt.0) then
               inter3=inter4*isignM(M3)
            else
               inter3=inter4
            endif
            do M2=-Lmax,Lmax
               if (M2.gt.0) then
                  inter2=inter3*isignM(M2)
               else
                  inter2=inter3
               endif
               do M1=-Lmax,Lmax
                  if (M1.gt.0) then
                     isgnprod(m1,m2,m3,m4)=inter2*isignM(M1)
                  else
                     isgnprod(m1,m2,m3,m4)=inter2
                  endif
               enddo
            enddo
         enddo
      enddo
cbs ####################################################################
cbs   some preparation of factors needed later on..  finished          #
cbs ####################################################################
c
!     set some counters
cbs   counter for total number of cartesian integrals
      numbcart=0
cbs   same orbit integrals integrals  on carteXSO carteYSO and carteSO
cbs   other orbit integrals  on carteXOO carteYOO and carteOO
      iangfirst=0 ! first block of angular integrals
cbs ####################################################################
cbs   loop over all (l,l,l,l) blocks generated in the radial part      #
cbs ####################################################################
      do lrun4=0,Lmax
      do lrun3=0,Lmax
      do lrun2=0,Lmax
      do lrun1=0,Lmax
      l2block(lrun1,lrun2,lrun3,lrun4)=0
      enddo
      enddo
      enddo
      enddo
cbs   loop over all possible < l1 l2, l3 l4 > blocks
CBS   write(6,'(A)') '   L1   L2   L3   L4'
      do l1=0,Lhigh   ! improving is probably possible...
      do l2=0,Lhigh
      do l3=0,l1
      do l4=0,l2
cbs   check parity
      if (mod(l1+l2+l3+l4,2).eq.0) then
cbs   check that Lleft and Lright do not always differ by more than one
cbs   a difference of two means two spin flips and is therefore not
cbs   allowed
      Lleftmax=l1+l2
      Lrightmax=l3+l4
      Lleftmin=iabs(l1-l2)
      Lrightmin=iabs(l3-l4)
      if ((Lrightmin-Lleftmax.le.1.and.Lrightmax-Lleftmin.gt.-1).or.
     *(Lleftmin-Lrightmax.le.1.and.Lleftmax-Lrightmin.gt.-1)) then
cbs   additional check for mean-field
      if ((l1.eq.l3.and.l2.eq.l4).or.(l1.eq.l2.and.l3.eq.l4)) then
      if (l1+l3.ne.0) then
CBS   write(6,'(4I5)') l1,l2,l3,l4
CBS   now I determine the size of the angular integral arrays
        jblock=0
        do m1=-l1,l1
        do m2=-l2,l2
        do m3=-l3,l3
        m4=m1+m2-m3+1
        if (iabs(m4).le.l4) then
        if ((.not.makemean).or.
     *  (l1.eq.l3.and.l2.eq.l4.and.iabs(m2).eq.iabs(m4)).or.
     *  (l1.eq.l2.and.l3.eq.l4.and.
     *  (iabs(m1).eq.iabs(m2).or.iabs(m3).eq.iabs(m4)))) then
        jblock=jblock+1
        endif
        endif
        enddo
        enddo
        enddo
        do m1=  0,l1
        do m2=-l2,l2
        do m3=-l3,l3
        m4=m1+m2-m3
        if ((.not.makemean).or.
     *  (l1.eq.l3.and.l2.eq.l4.and.iabs(m2).eq.iabs(m4)).or.
     *  (l1.eq.l2.and.l3.eq.l4.and.
     *  (iabs(m1).eq.iabs(m2).or.iabs(m3).eq.iabs(m4)))) then
        if (m1.ne.0.or.m2.ne.0.or.m3.ne.0) then !  all m=0 make no sense
        if (iabs(m4).le.l4)  then
        jblock=jblock+1
        endif
        endif
        endif
        enddo
        enddo
        enddo
CBS   done !!
cbs     number of contracted integrals for each block
        ncont=ncontrac(l1)*ncontrac(l2)*
     *  ncontrac(l3)*ncontrac(l4)
      mxangint=jblock*ncont
cbs   determine the size icont4 for the radial integrals
      call gencoulDIM(l1,l2,l3,l4,makemean,bonn,breit,sameorb,icont4)
*
      Call mma_allocate(ANGSO,mxangint,Label='AngSO')
      Call mma_allocate(ANGOO,mxangint,Label='AngOO')
      Call mma_allocate(CartSO,nCont,Label='CartSO')
      Call mma_allocate(CartOO,nCont,Label='CartOO')
      Call mma_allocate(ConSO,iCont4,Label='ConSO')
      Call mma_allocate(ConOO,iCont4,Label='ConOO')
*
      call gencoul(l1,l2,l3,l4,makemean,bonn,breit,
     *             sameorb,conSO,conOO,icont4,powexp,coulovlp)
!gen and trans integrals
        l2block(l1,l2,l3,l4)=1  ! can be used for getting the
cbs   local counter for integral adresses
        mblock=0 ! counter of (m,m,m,m)-blocks for (l1,l2,l3,l4)
cbs     if keep is set to false, the angular integrals are
cbs     thrown away after each block of l-values
cbs     which means integrals start at address 0
        if (.not.keep) iangfirst=0
        locstar=iangfirst ! local starting adress counter
        do m1=-l1,l1
        do m2=-l2,l2
        do m3=-l3,l3
        do m4=-l4,l4
        mcombina(1,m1,m2,m3,m4)=0  ! will hold type of integrals (1,2,3)
        mcombina(2,m1,m2,m3,m4)=0  ! will hold number of block
        enddo
        enddo
        enddo
        enddo
        do m1=-l1,l1
        do m2=-l2,l2
        do m3=-l3,l3
cbs     m4 is more or less fixed by m1-3
c#######################################################################
c#######################################################################
c########## the L- -type block to be combined with sigma+ ##############
c#######################################################################
c#######################################################################
        m4=m1+m2-m3+1
        if (iabs(m4).le.l4) then !the L- -block to  combine with sigma+
cbs     not all m-combinations are needed for the mean-field
        if ((.not.makemean).or.
     *  (l1.eq.l3.and.l2.eq.l4.and.iabs(m2).eq.iabs(m4)).or.
     *  (l1.eq.l2.and.l3.eq.l4.and.
     *  (iabs(m1).eq.iabs(m2).or.iabs(m3).eq.iabs(m4)))) then
        mcombina(1,m1,m2,m3,m4)=1
        mblock=mblock+1
        if (locstar+ncont.gt.mxangint) then
        write(6,*) 'not enough space allocated for angular integrals'
        write(6,*) 'increase mxangint to at least ',
     *  locstar+ncont
        Call Abend()
        endif
cbs mkangLmin = make_angular_integrals_for_L- type operator
cbs really generates  the angular prefactors and combines them with
cbs the radial integrals
        call mkangLmin(Lmax,l1,l2,l3,l4,m1,m2,m3,m4,
     *       AngSO(1+locstar),
     *       AngOO(1+locstar),
     *       Lfirst(1),Llast(1),Lblocks(1),
     *       ncontrac(l1),ncontrac(l2),ncontrac(l3),ncontrac(l4),
     *       ConSO(Lstarter(1)),
     *       ConSO(Lstarter(2)),
     *       ConSO(Lstarter(3)),
     *       ConSO(Lstarter(4)),
     *       ConOO(Lstarter(1)),
     *       ConOO(Lstarter(2)),
     *       ConOO(Lstarter(3)),
     *       ConOO(Lstarter(4)),
     *       preroots,clebsch,scratch4,bonn,breit,
     *       sameorb)
        locstar=locstar+ncont ! increase starting address
        mcombina(2,m1,m2,m3,m4)=mblock  ! set the block number
c#######################################################################
c#######################################################################
c########## the L+ -type block to be combined with sigma- ##############
c#######################################################################
c#######################################################################
c
c   these integrals are obtained by changing the signs of the m-values.
c   As the integrals are the same, the pointer points to the same
c   integrals...
c
c
        mcombina(1,-m1,-m2,-m3,-m4)=3
        mcombina(2,-m1,-m2,-m3,-m4)=mblock
        endif
        Endif
        enddo
        enddo
        enddo
c#######################################################################
c#######################################################################
c########## the L0 -type block to be combined with sigma0 ##############
c#######################################################################
c#######################################################################
        do m1=  0,l1
        do m2=-l2,l2
        do m3=-l3,l3
cbs     m4 is more or less fixed by m1-3
        m4=m1+m2-m3 ! the L0-block to be combined with sigma0
cbs     not all m-combinations are needed for the mean-field
        if ((.not.makemean).or.
     *  (l1.eq.l3.and.l2.eq.l4.and.iabs(m2).eq.iabs(m4)).or.
     *  (l1.eq.l2.and.l3.eq.l4.and.
     *  (iabs(m1).eq.iabs(m2).or.iabs(m3).eq.iabs(m4)))) then
c
        if (m1.ne.0.or.m2.ne.0.or.m3.ne.0) then !all m=0 make no sense
        if (iabs(m4).le.l4)  then
        mcombina(1,m1,m2,m3,m4)=2
        mblock=mblock+1
        if (locstar+ncont.gt.mxangint) then
        write(6,*) 'not enough space allocated for angular integrals'
        write(6,*) 'increase mxangint to at least ',
     *  locstar+ncont
        Call Abend()
        endif
        call mkangL0(Lmax,l1,l2,l3,l4,m1,m2,m3,m4,
     *       angSO(1+locstar),
     *       AngOO(1+locstar),
     *       Lfirst(1),Llast(1),Lblocks(1),
     *       ncontrac(l1),ncontrac(l2),ncontrac(l3),ncontrac(l4),
     *       ConSO(Lstarter(1)),
     *       ConSO(Lstarter(2)),
     *       ConSO(Lstarter(3)),
     *       ConSO(Lstarter(4)),
     *       ConOO(Lstarter(1)),
     *       ConOO(Lstarter(2)),
     *       ConOO(Lstarter(3)),
     *       ConOO(Lstarter(4)),
     *       preroots,clebsch,scratch4,bonn,breit,
     *       sameorb)
        locstar=locstar+ncont
        mcombina(2,m1,m2,m3,m4)=mblock
        endif
        endif
        endif
        enddo
        enddo
        enddo
cbs  ###################################################################
cbs  ###################################################################
cbs     transformation to l,m dependent integrals is finished
cbs  ###################################################################
c
cbs  ###################################################################
cbs     begin transformation to cartesian integrals
cbs  ###################################################################
cbs  ###################################################################
cbs     check out, which combinations of m-values will
cbs     contribute to cartesian integrals
        do m1=-l1,l1       !
        do m2=-l2,l2  ! these indices now run over the real harmonics
        do m3=-l3,l3  !
        do m4=-l4,l4  !
        mcombcart(1,m1,m2,m3,m4)=0     ! will hold the type  x=1 y=2 z=3
        mcombcart(2,m1,m2,m3,m4)=0     ! will hold the block number
        enddo
        enddo
        enddo
        enddo
        mblockx=0
        mblocky=0
        mblockz=0
        do m3=-l3,l3
        do m4=-l4,l4
cbs     if the l-values are the same : triangular matrix over m-values
cbs     is sufficient
        if (l1.eq.l3) then
        m1upper=m3
        else
        m1upper=l1
        endif
        if (makemean) m1upper=l1
cbs     if the l-values are the same : triangular matrix over m-values
cbs     is sufficient
        if (l2.eq.l4) then
        m2upper=m4
        else
        m2upper=l2
        endif
        if (makemean) m2upper=l2
        do m1=-l1,m1upper
        If (l1.eq.l3.and.m1.eq.m3) then ! clean real zeros by symmetry
cbs     this a problem of the spin-other-orbit integrals, as they are by
cbs     formula not antisymmetric in the indices for particle 1.
        cleaner=.true.
        else
        cleaner=.false.
        endif
        do m2=-l2,m2upper
cbs     not all m-combinations are needed for the mean-field
        if ((.not.makemean).or.
     *  (l1.eq.l3.and.l2.eq.l4.and.m2.eq.m4).or.
     *  (l1.eq.l2.and.l3.eq.l4.and.(m1.eq.m2.or.m3.eq.m4))) then
C
        indx=ipowxyz(1,m1,l1)+ipowxyz(1,m2,l2)+
     *  ipowxyz(1,m3,l3)+ipowxyz(1,m4,l4)
        indy=ipowxyz(2,m1,l1)+ipowxyz(2,m2,l2)+
     *  ipowxyz(2,m3,l3)+ipowxyz(2,m4,l4)
        indz=ipowxyz(3,m1,l1)+ipowxyz(3,m2,l2)+
     *  ipowxyz(3,m3,l3)+ipowxyz(3,m4,l4)
        indx=mod(indx,2)
        indy=mod(indy,2)
        indz=mod(indz,2)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C++++++++++++++++      SIGMA X      ++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        if (indx.eq.0.and.indy.eq.1.and.indz.eq.1.and.
     *  icheckxy(iabs(m1),iabs(m2),iabs(m3),iabs(m4)).gt.0) then
! Y*Z ->  transforms like  L_x (B1)
cbs     integrals for sigma_x
        mblockx=mblockx+1
        mcombcart(1,m1,m2,m3,m4)=1
        mcombcart(2,m1,m2,m3,m4)=mblockx
        call tosigX(m1,m2,m3,m4,AngSO(1+iangfirst),
     *              mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3),
     *              ncontrac(l4),CartSO,preXZ,
     *              interxyz(1,iabs(m1),iabs(m2),iabs(m3),iabs(m4)),
     *              isgnprod,cleaner)
c
        if (.not.bonn.and.(.not.breiT))
     *  call tosigX(m1,m2,m3,m4,AngOO(1+iangfirst),
     *              mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3),
     *              ncontrac(l4),cartOO,preXZ,
     *              interxyz(1,iabs(m1),iabs(m2),iabs(m3),iabs(m4)),
     *              isgnprod,cleaner)
        if (makemean) then ! generate mean-field-contributions
c#######################################################################
c############  mean-field-part #########################################
c#######################################################################
             if (l1.eq.l3.and.l2.eq.l4) then
             if (m2.eq.m4.and.m1.lt.m3.and.
     *       iabs(m1+m3).eq.1.and.l1.ne.0) then
             call two2mean13(CartSO,occup(1,l2),AOcoeffs(1,1,l2),
     *                       onecartx(1,1,ipnt(m1+l1+1,m3+l3+1),l1),
     *                       ncontrac(l1),ncontrac(l2),noccorb(l2))
             endif
             endif
*
             if (NFINI) Then
             if (l1.eq.l2.and.l3.eq.l4) then
             if (m1.eq.m2.and.l3.ne.0.and.l3.ne.l1) then
             if (m3.lt.m4.and.iabs(m4+m3).eq.1) then
cbs   for the "Bonn-approach"   exchange cartexOO by cartexSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean34a(cartSO,cartSO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartx(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             else
             if(NFINI) call two2mean34a(cartSO,cartOO,
     *                                  occup(1,l1),AOcoeffs(1,1,l1),
     *                           onecartx(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *                                  ncontrac(l3),ncontrac(l1),
     *                                  noccorb(l2),sameorb)
             endif
             endif
             if (m3.gt.m4.and.iabs(m4+m3).eq.1) then
cbs   for the "Bonn-approach"   exchange cartexOO by cartexSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean34b(CartSO,CartSO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartx(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             else
             if (NFINI) call two2mean34b(CartSO,CartOO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartx(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             endif
             endif
             elseif(m3.eq.m4.and.l1.ne.0) then
             if (m1.lt.m2.and.iabs(m1+m2).eq.1) then
cbs   for the "Bonn-approach"   exchange cartexOO by cartexSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean12a(CartSO,CartSO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartx(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             else
             if (NFINI) call two2mean12a(CartSO,cartOO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartx(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             endif
             endif
             if (m1.gt.m2.and.iabs(m1+m2).eq.1) then
cbs   for the "Bonn-approach"   exchange cartexOO by cartexSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean12b(cartSO,CartSO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartx(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             else
             if (NFINI) call two2mean12b(CartSO,CartOO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartx(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             endif
             endif
             endif
             endif
             endif ! If (NFINI) Then
c#######################################################################
c############  mean-field-part #########################################
c#######################################################################
        endif
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C++++++++++++++++      SIGMA Y      ++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        elseif (indx.eq.1.and.indy.eq.0.and.indz.eq.1.and.
     *  icheckxy(iabs(m1),iabs(m2),iabs(m3),iabs(m4)).gt.0) then
! X*Z transforms like L_y  (B2)
cbs     integrals for sigma_y
        mblocky=mblocky+1
        mcombcart(1,m1,m2,m3,m4)=2
        mcombcart(2,m1,m2,m3,m4)=mblocky
        call tosigY(m1,m2,m3,m4,AngSO(1+iangfirst),
     *              mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3),
     *              ncontrac(l4),CartSO,preY,
     *              interxyz(1,iabs(m1),iabs(m2),iabs(m3),iabs(m4)),
     *              isgnprod,cleaner)
c
        if (.not.bonn.and.(.not.breit))
     *  call tosigY(m1,m2,m3,m4,AngOO(1+iangfirst),
     *              mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3),
     *              ncontrac(l4),cartOO,preY,
     *  interxyz(1,iabs(m1),iabs(m2),iabs(m3),iabs(m4)),isgnprod,
     *  cleaner)
        if (makemean) then ! generate mean-field-contributions
c#######################################################################
c############  mean-field-part #########################################
c#######################################################################
             if (l1.eq.l3.and.l2.eq.l4) then
             if (m2.eq.m4.and.m1.lt.m3.
     *       and.iabs(m3-m1).eq.1.and.l1.ne.0) then
             call two2mean13(CartSO,occup(1,l2),
     *       AOcoeffs(1,1,l2),onecartY(1,1,ipnt(m1+l1+1,m3+l3+1),l1),
     *       ncontrac(l1),ncontrac(l2),noccorb(l2))
             endif
             endif
*
             If (NFINI) Then
             if (l1.eq.l2.and.l3.eq.l4) then
             if (m1.eq.m2.and.l3.ne.0.and.l3.ne.l1) then
             if (m3.lt.m4.and.iabs(m3-m4).eq.1) then
cbs   for the "Bonn-approach"   exchange carteYOO by carteYSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean34a(CartSO,CartSO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartY(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             else
             if (NFINI) call two2mean34a(CartSO,CartOO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartY(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             endif
             endif
             if (m3.gt.m4.and.iabs(m3-m4).eq.1) then
cbs   for the "Bonn-approach"   exchange carteYOO by carteYSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean34b(CartSO,CartSO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartY(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             else
             if (NFINI) call two2mean34b(CartSO,CartOO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartY(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             endif
             endif
             elseif(m3.eq.m4.and.l1.ne.0) then
             if (m1.lt.m2.and.iabs(m1-m2).eq.1) then
cbs   for the "Bonn-approach"   exchange carteOO by carteSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean12a(CartSO,CartSO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartY(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             else
             if (NFINI) call two2mean12a(CartSO,CartOO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartY(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             endif
             endif
             if (m1.gt.m2.anD.Iabs(m1-m2).eq.1) then
cbs   for the "Bonn-approach"   exchange carteYOO by carteYSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean12b(CartSO,CartSO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartY(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             else
             if (NFINI) call two2mean12b(CartSO,CartOO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartY(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             endif
             endif
             endif
             endif
             endif ! If (NFINI) Then
c#######################################################################
c############  mean-field-part #########################################
c#######################################################################
        endif
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C++++++++++++++++      SIGMA Z      ++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        elseif (indx.eq.1.and.indy.eq.1.and.indz.eq.0.and.
     *  icheckz(iabs(m1),iabs(m2),iabs(m3),iabs(m4)).gt.0) then
! X*Y transforms like L_z  (A2)
cbs     integrals for sigma_z
        mblockz=mblockz+1
        mcombcart(1,m1,m2,m3,m4)=3
        mcombcart(2,m1,m2,m3,m4)=mblockz
        call tosigZ(m1,m2,m3,m4,angSO(1+iangfirst),
     *              mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3),
     *              ncontrac(l4),CartSO,preXZ,
     *              interxyz(1,iabs(m1),iabs(m2),iabs(m3),iabs(m4)),
     *              isgnprod,cleaner)
c
        if (.not.bonn.and.(.not.breit))
     *  call tosigZ(m1,m2,m3,m4,AngOO(1+iangfirst),
     *              mcombina,ncontrac(l1),ncontrac(l2),ncontrac(l3),
     *              ncontrac(l4),CartOO,preXZ,
     *              interxyz(1,iabs(m1),iabs(m2),iabs(m3),iabs(m4)),
     *              isgnprod,cleaner)
        if (makemean) then ! generate mean-field-contributions
c#######################################################################
c############  mean-field-part #########################################
c#######################################################################
             if (l1.eq.l3.and.l2.eq.l4) then
             if (m2.eq.m4.and.m1.lt.m3.
     *       and.m1.eq.-m3.and.l1.ne.0) then
             call two2mean13(CartSO,occup(1,l2),
     *       AOcoeffs(1,1,l2),onecartz(1,1,ipnt(m1+l1+1,m3+l3+1),l1),
     *       ncontrac(l1),ncontrac(l2),noccorb(l2))
             endif
             endif
*
             If (NFINI) Then
             if (l1.eq.l2.and.l3.eq.l4) then
             if (m1.eq.m2.and.l3.ne.0.and.l3.ne.l1) then
             if (m3.lt.m4.and.m3.eq.-m4) then
cbs   for the "Bonn-approach"   exchange carteOO by carteSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean34a(CartSO,CartSO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartz(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             else
             if (NFINI) call two2mean34a(CartSO,CartOO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartz(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             endif
             endif
             if (m3.gt.m4.and.m3.eq.-m4) then
cbs   for the "Bonn-approach"   exchange carteOO by carteSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean34b(CartSO,CartSO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartz(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             else
             if (NFINI) call two2mean34b(CartSO,CartOO,occup(1,l1),
     *       AOcoeffs(1,1,l1),onecartz(1,1,ipnt(m3+l3+1,m4+l4+1),l3),
     *       ncontrac(l3),ncontrac(l1),noccorb(l2),sameorb)
             endif
             endif
             elseif(m3.eq.m4.and.l1.ne.0) then
             if (m1.lt.m2.and.m1.eq.-m2) then
cbs   for the "Bonn-approach"   exchange carteOO by carteSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean12a(CartSO,CartSO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartz(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             else
             if (NFINI) call two2mean12a(CartSO,CartOO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartz(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             endif
             endif
             if (m1.gt.m2.and.m1.eq.-m2) then
cbs   for the "Bonn-approach"   exchange carteOO by carteSO
             if (bonn.or.breiT) then
             if (NFINI) call two2mean12b(cartSO,CartSO,
     *       occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartz(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             else
             if (NFINI) call two2mean12b(cartSO,cartOO,occup(1,l3),
     *       AOcoeffs(1,1,l3),onecartz(1,1,ipnt(m1+l1+1,m2+l2+1),l1),
     *       ncontrac(l1),ncontrac(l3),noccorb(l3),sameorb)
             endif
             endif
             endif
             endif
             endif ! If (NFINI) Then
c#######################################################################
c############  mean-field-part #########################################
c#######################################################################
        endif
        endif
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        endif ! for check of significance for meanfield.
        enddo
        enddo
        enddo
        enddo
        numbcart=numbcart+(mblockx+mblocky+mblockz)*ncont
cbs   just controlling if x and y integrals have the same number of
cbs   blocks
      if (mblockx.ne.mblocky) then
      write(6,*)
     *'numbers of integrals for sigma_x and sigma_y not equal!'
      write(6,'(A12,4I3,2(A3,I5))')
     *'l1,l2,l3,l4 ',l1,l2,l3,l4,' X:',mblockx,' Y:',mblocky
      write(6,*) ' check the ipowxyz-array'
      Call Abend()
      endif
cbs   start adresses for the next <ll|ll> block of integrals
      Call mma_deallocate(AngSO)
      Call mma_deallocate(AngOO)
      Call mma_deallocate(CartSO)
      Call mma_deallocate(CartOO)
      Call mma_deallocate(ConSO)
      Call mma_deallocate(ConOO)
      endif
      endif
      endif
      endif
      enddo
      enddo
      enddo
      enddo
      return
c Avoid unused argument warnings
      if (.false.) call Unused_logical(keepcart)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

subroutine CMSRHSGDMat(GDMat)

use Index_Functions, only: iTri, nTri_Elem
use ipPage, only: W
use MCLR_Data, only: ipCI, n1Dens, n2Dens, nNA, XISPSM
use input_mclr, only: nCSF, nRoots, State_Sym
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(out) :: GDMat(nTri_Elem(nRoots),nnA,nnA)
integer(kind=iwp) :: I, iL, iR, J, nConfL, nConfR, NIJ
real(kind=wp), allocatable :: CIL(:), CIR(:), GDArray(:,:), rdum(:)

! I:state index, "excited state" of state J when I /= J

! (D^IJ)_pq = <I|E_pq|J>, setting I>=J
!  <I|E_pq|J>=<J|E_qp|I>
call mma_allocate(GDArray,nnA,nnA)
call mma_allocate(rdum,n2Dens)
iL = state_sym
iR = state_sym
nConfR = max(ncsf(iR),nint(xispsm(iR,1)))
nConfL = max(ncsf(iL),nint(xispsm(iL,1)))
call mma_allocate(CIR,nConfR)
call mma_allocate(CIL,nConfL)
do I=1,nRoots
  call CSF2SD(W(ipCI)%A(1+(I-1)*ncsf(iL)),CIL,iL)
  do J=1,I
    call CSF2SD(W(ipCI)%A(1+(J-1)*ncsf(iR)),CIR,iR)
    call Densi2_mclr(1,GDArray,rdum,CIL,CIR,0,0,0,n1Dens,n2Dens)
    NIJ = iTri(I,J)
    GDMat(NIJ,:,:) = GDArray(:,:)
  end do
end do
call mma_deallocate(GDArray)
call mma_deallocate(rdum)
call mma_deallocate(CIL)
call mma_deallocate(CIR)

end subroutine CMSRHSGDMat

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1991, Jeppe Olsen                                      *
************************************************************************
      SUBROUTINE SYMCOM_MCLR(ITASK,IOBJ,I1,I2,I12)
*
* Symmetries I1,I2,I12 are related as
* I1 I2 = 12
* IF(ITASK = 1 ) I2 and I12 are known, find I1
* IF(ITASK = 2 ) I1 and I12 are known, find I1
* IF(ITASK = 3 ) I1 and I2 are known , find I12
*
* IOBJ = 1 : I1,I2 are strings I12 determinant
* ( Other things can follow )
* IOBJ = 2 : I1,I2,I3 are externals
* IOBJ = 3 : I1 is an external, I2,I3 are dets
* IOBJ = 4 : I1 is orbital, I2 is string,l, I12 is string
*
* If obtained symmetry I1 or I2 is outside bounds,
* zero is returned.
*
* Jeppe Olsen , Spring of 1991
*
* ================
*. Driver routine
* ================
      Implicit Real*8 (a-h,o-z)
#include "detdim.fh"

#include "Input.fh"
*
      IF(PNTGRP.EQ.1) THEN
        CALL SYMCM1(ITASK,IOBJ,I1,I2,I12)
      ELSE IF(PNTGRP.GE.2.AND.PNTGRP.LE.4) THEN
        CALL SYMCM2(ITASK,IOBJ,I1,I2,I12)
      ELSE
        WRITE(6,*) ' PNTGRP parameter out of bounds ', PNTGRP
        WRITE(6,*) ' Enforced stop in SYMCOM '
        Call Abend()
      END IF
*
      RETURN
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
c
c     ----------------------------------
c
       subroutine expmpq (wrk,wrksize,
     & syma,typv3,typm,typp,typq,directyes,
     &                    inverseyes)
c
c     this routine realize reorganization to
c     #3 <m,a p q> with given typv3 and typm,p,q  <-  #2 <a,m|pp,qq>
c     #2 is in shape <a,m|pp,qq> for symm,sympp,symqq with types
c     _a  m,pp,qq - 1,5,5
c     #3 <m a p q> may be antisymetrized or not, two parameters (directyes,
c     inverseyes) can be deduced trom typv3 and typm,p,q and syma
c     but for simplicity these are as input parameters
c     this routine allow to use typv3=0 and 2
c
c     syma      - irrep of a
c     typv3     - typ of final #2 (I)
c     typm,p,q  - types of ind. m,p,q (I)
c     directyes - 1 if direct <pqij> integrals are included (I)
c     inverseyes- 1 if inverse <qpij> integrals are included (I)
c
c     foreingh routines used: grc0
c     ccsort_mv0zero
c
c     it also defines new mapd2,mapi2 corresponding to #2
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       integer typv3,typp,typq,typm,syma,directyes,inverseyes
c
c     help variables
c
       integer symp,symq,symm,possv3,lenght
       integer ii,iiv2d,iiv2i,possv2d,possv2i
       integer posst
c
c*    get mapd mapi of <m,a|p,q> as _a(m,p q) into mapd3,mapi3
c
       call ccsort_grc0 (3,typv3,typm,typp,typq,0,syma,
     & poss30,posst,mapd3,mapi3)
c
c*    realize reorganization psb
c
       do 100 ii=1,mapd3(0,5)
c
c*    def parameters of #3
       possv3=mapd3(ii,1)
       lenght=mapd3(ii,2)
       symm=mapd3(ii,3)
       symp=mapd3(ii,4)
       symq=mapd3(ii,5)
c
c*    vanish #3
       call ccsort_mv0zero (lenght,lenght,wrk(possv3))
c
       if (directyes.eq.1) then
c
c**   def possition #2 direct (i.e.
       iiv2d=mapi2(symm,symq,1)
       possv2d=mapd2(iiv2d,1)
c
c**   do #3 <m a p q> <- #2 <a m q p> (i.e. direct)
       call  mreorg (wrk,wrksize,
     & symm,symp,symq,typm,typp,typq,
     & 1,3,2,1,5,5,
     & typv3,possv2d,possv3,1.0d0)
c
       end if
c
       if (inverseyes.eq.1) then
c
c**   def possition #2 inverse (i.e. #2 <symq,symp| symi,symj>)
       iiv2i=mapi2(symm,symp,1)
       possv2i=mapd2(iiv2i,1)
c
c**   do #3 <m a q p> <- - #2 <a m p q> (i.e. inverse)
       call  mreorg (wrk,wrksize,
     & symm,symp,symq,typm,typp,typq,
     & 1,2,3,1,5,5,
     & typv3,possv2i,possv3,-1.0d0)
c
       end if
c
 100    continue
c
       return
       end
c
c     -------------------------------------
c
       subroutine mreorg (wrk,wrksize,
     & symp,symq,symr,typp,typq,typr,
     & posspv2,possqv2,possrv2,typpv2,typqv2,typrv2,
     & typv3,possv20,possv30,fact)
c
c     this routine is up level routine for mreorg1 (also more detailed
c     description can be found there).
c     #2 must be of type 0, #3 can be 0, and 2
c     this routine only prepair some constants, required by ireorg1,
c     that can be deduced form input data - dimp,dimqr,dimt-dimv
c
c     symp-r     - symetries of p-r (I)
c     typp-r     - types of indexes p-r in V2 (I)
c     possp-rv2  - possitions of p-r ind. in V2 (I)
c     typp-rv2   - types of indices, corresponding to p-r in V2 (I)
c     typv3      - type of V3 (0,2) (I)
c     possv20,30 - initial possitions of V2 and V3 in wrk (I)
c     fact       - multiplication factors (usually +-1.0d0) (I)
c
#include "wrk.fh"
#include "reorg.fh"
#include "ccsort.fh"
       integer symp,symq,symr,typp,typq,typr
       integer posspv2,possqv2,possrv2,typpv2,typqv2,typrv2
       integer typv3,possv20,possv30
       real*8 fact
c
c     help variables
c
       integer ind(1:4)
       integer nhelp,mhelp,rc,dimp,dimqr
c
c*    define dimensions of V2
c
       call ireorg2 (symp,typpv2,nhelp,rc)
       ind(posspv2)=nhelp
       call ireorg2 (symq,typqv2,nhelp,rc)
       ind(possqv2)=nhelp
       call ireorg2 (symr,typrv2,nhelp,rc)
       ind(possrv2)=nhelp
c
c*    def dimp,dimqr
c
       call ireorg2 (symp,typp,dimp,rc)
c
       call ireorg2 (symq,typq,nhelp,rc)
       call ireorg2 (symr,typr,mhelp,rc)
c
       if ((typv3.eq.2).and.(symq.eq.symr)) then
       dimqr=(nhelp*(nhelp-1))/2
       else
       dimqr=nhelp*mhelp
       end if
c
c*    use mreorg1
c
       call mreorg1 (symp,symq,symr,typp,typq,typr,
     & posspv2,possqv2,possrv2,typpv2,typqv2,typrv2,
     & typv3,wrk(possv20),wrk(possv30),fact,dimp,dimqr,
     & ind(1),ind(2),ind(3))
c
       return
       end
c
c     ---------
c
       subroutine mreorg1 (symp,symq,symr,typp,typq,typr,
     & posspv1,possqv1,possrv1,typpv1,typqv1,typrv1,
     & typv2,v1,v2,fact,dimp,dimqr,dimt,dimu,dimv)
c
c     this routine map v2(p,qr) <+ fact . v1 (t,u,v)
c     v2 may be of type 0,2 (typv2) while type v1 is always 0
c     symp-symr and typp-typr are symmetries and types of p-r indexex
c     posspv1-possrv1 are corresponding possitions of p-r indexes in v1
c     N.B. v1 and v2 have no direct relation to #1 or #2, since here there
c     is no reorg.fh included, v1,v2 corresponds to arbitrary matrices
c
c     symp-r     - symetries of p-r (I)
c     typp-r     - types of indexes p-r in V2 (I)
c     possp-rv1  - possitions of p-r ind. in v1 (I)
c     typp-rv1   - types of indices, corresponding to p-r in V1 (I)
c     typv2      - type of V2 (0,1,2,4) (I)
c     v1,v2      - arrays V1 and V2  (I,O)
c     fact       - multiplication factors (usually +-1.0d0) (I)
c     dimp,qr   - dimensions of V2 (I)
c     dimt-s     - dimensions of V1 (I)
c
c
c     reorg.fh may not be included
#include "ccsort.fh"
       integer symp,symq,symr,typp,typq,typr
       integer posspv1,possqv1,possrv1
       integer typpv1,typqv1,typrv1,typv2
       integer dimp,dimqr,dimt,dimu,dimv
       real*8 v2(1:dimp,1:dimqr)
       real*8 v1(1:dimt,1:dimu,1:dimv)
       real*8 fact
c
c     help variables
c
       integer p,q,r,qr,pup,qup,rup,rc,qryes
       integer paddv1,qaddv1,raddv1
       integer ind(1:4)
c
c*    def additional constants
c
       call ireorg3 (symp,typp,typpv1,paddv1,rc)
       call ireorg3 (symq,typq,typqv1,qaddv1,rc)
       call ireorg3 (symr,typr,typrv1,raddv1,rc)
c
c*    def sumation limits
c
       call ireorg2 (symp,typp,pup,rc)
       call ireorg2 (symq,typq,qup,rc)
       call ireorg2 (symr,typr,rup,rc)
c
c*    def qryes, rsyes (i.e. if there is a reduced sumations)
c
       if (typv2.eq.2) then
       if (symq.eq.symr) then
       qryes=1
       else
       qryes=0
       end if
       else
       qryes=0
       end if
c
c
       if (qryes.eq.1) then
c
c*    case p, q>s
c
       qr=0
       do 100 q=2,qup
       ind(possqv1)=qaddv1+q
       do 101 r=1,q-1
       ind(possrv1)=raddv1+r
       qr=qr+1
c
       do 102 p=1,pup
       ind(posspv1)=paddv1+p
c
       v2(p,qr)=v2(p,qr)+fact*v1(ind(1),ind(2),ind(3))
c
 102    continue
 101    continue
 100    continue
c
       else
c
c*    case p q,r
c
       qr=0
       do 200 r=1,rup
       ind(possrv1)=raddv1+r
       do 201 q=1,qup
       ind(possqv1)=qaddv1+q
       qr=qr+1
c
       do 202 p=1,pup
       ind(posspv1)=paddv1+p
c
       v2(p,qr)=v2(p,qr)+fact*v1(ind(1),ind(2),ind(3))
c
 202    continue
 201    continue
 200    continue
c
       end if
c
       return
       end
c

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************
! Compute F3 using cumulant reconstruction except for G3-dependent terms

function CU4F3H(NAC,E,ES,G1,G2,F1,F2,iP,iQ,jP,jQ,kP,kQ)

use Constants, only: Zero, Two, Three, Six, Half, OneHalf
use Definitions, only: wp, iwp

implicit none
real(kind=wp) :: CU4F3H
integer(kind=iwp), intent(in) :: NAC, iP, iQ, jP, jQ, kP, kQ
real(kind=wp), intent(in) :: E(NAC), ES, G1(NAC,NAC), G2(NAC,NAC,NAC,NAC), F1(NAC,NAC), F2(NAC,NAC,NAC,NAC)
integer(kind=iwp) :: lT

CU4F3H = Zero

! Compute these 3PDM contributions in other place
!
!      // G(I,i)G(JKL,jkl)[4]
!CU4F3H = CU4F3H &
!         + G1(lT,lT)*G3(iP,iQ,jP,jQ,kP,kQ)
!      // G(I,j)G(JKL,ikl)[12]
!CU4F3H = CU4F3H &
!         -Half*G1(iP,lT)*G3(lT,iQ,jP,jQ,kP,kQ) &
!         -Half*G1(jP,lT)*G3(lT,jQ,iP,iQ,kP,kQ) &
!         -Half*G1(kP,lT)*G3(lT,kQ,iP,iQ,jP,jQ) &
!         -Half*G1(lT,iQ)*G3(iP,lT,jP,jQ,kP,kQ) &
!         -Half*G1(lT,jQ)*G3(jP,lT,iP,iQ,kP,kQ) &
!         -Half*G1(lT,kQ)*G3(kP,lT,iP,iQ,jP,jQ)

!     // G(I,i)G(JKL,jkl)[4]
CU4F3H = CU4F3H &
         +G1(iP,iQ)*F2(jP,jQ,kP,kQ) &
         +G1(jP,jQ)*F2(iP,iQ,kP,kQ) &
         +G1(kP,kQ)*F2(iP,iQ,jP,jQ)
!     // G(I,j)G(JKL,ikl)[12]
CU4F3H = CU4F3H &
         -Half*G1(iP,jQ)*F2(jP,iQ,kP,kQ) &
         -Half*G1(iP,kQ)*F2(kP,iQ,jP,jQ) &
         -Half*G1(jP,iQ)*F2(iP,jQ,kP,kQ) &
         -Half*G1(jP,kQ)*F2(kP,jQ,iP,iQ) &
         -Half*G1(kP,iQ)*F2(iP,kQ,jP,jQ) &
         -Half*G1(kP,jQ)*F2(jP,kQ,iP,iQ)
!     // G(IJ,ij)G(KL,kl)[3]
CU4F3H = CU4F3H &
         +G2(iP,iQ,jP,jQ)*F1(kP,kQ) &
         +G2(iP,iQ,kP,kQ)*F1(jP,jQ) &
         +F1(iP,iQ)*G2(jP,jQ,kP,kQ)
!     // G(IJ,ik)G(KL,jl)[12]
CU4F3H = CU4F3H &
         -Half*G2(iP,iQ,jP,kQ)*F1(kP,jQ) &
         -Half*G2(jP,jQ,iP,kQ)*F1(kP,iQ) &
         -Half*G2(kP,kQ,iP,jQ)*F1(jP,iQ) &
         -Half*F1(iP,jQ)*G2(jP,iQ,kP,kQ) &
         -Half*F1(iP,kQ)*G2(kP,iQ,jP,jQ) &
         -Half*F1(jP,kQ)*G2(kP,jQ,iP,iQ)
!     // G(I,i)G(J,j)G(KL,kl)[6]
CU4F3H = CU4F3H &
         -Two*G1(iP,iQ)*G1(jP,jQ)*F1(kP,kQ) &
         -Two*G1(iP,iQ)*G1(kP,kQ)*F1(jP,jQ) &
         -Two*G1(jP,jQ)*G1(kP,kQ)*F1(iP,iQ) &
         -Two*G1(iP,iQ)*ES*G2(jP,jQ,kP,kQ) &
         -Two*G1(jP,jQ)*ES*G2(iP,iQ,kP,kQ) &
         -Two*G1(kP,kQ)*ES*G2(iP,iQ,jP,jQ)
!     // G(I,j)G(J,i)G(KL,kl)[6]
CU4F3H = CU4F3H &
         +G1(iP,jQ)*G1(jP,iQ)*F1(kP,kQ) &
         +G1(iP,kQ)*G1(kP,iQ)*F1(jP,jQ) &
         +G1(jP,kQ)*G1(kP,jQ)*F1(iP,iQ)
!     // G(I,i)G(J,k)G(KL,jl)[24]
CU4F3H = CU4F3H &
         +G1(iP,iQ)*G1(jP,kQ)*F1(kP,jQ) &
         +G1(iP,iQ)*G1(kP,jQ)*F1(jP,kQ) &
         +G1(jP,jQ)*G1(iP,kQ)*F1(kP,iQ) &
         +G1(jP,jQ)*G1(kP,iQ)*F1(iP,kQ) &
         +G1(kP,kQ)*G1(iP,jQ)*F1(jP,iQ) &
         +G1(kP,kQ)*G1(jP,iQ)*F1(iP,jQ) &
         +ES*G1(iP,jQ)*G2(jP,iQ,kP,kQ) &
         +ES*G1(jP,iQ)*G2(iP,jQ,kP,kQ) &
         +ES*G1(iP,kQ)*G2(kP,iQ,jP,jQ) &
         +ES*G1(kP,iQ)*G2(iP,kQ,jP,jQ) &
         +ES*G1(jP,kQ)*G2(kP,jQ,iP,iQ) &
         +ES*G1(kP,jQ)*G2(jP,kQ,iP,iQ)
!     // G(I,j)G(J,k)G(KL,il)[24]
CU4F3H = CU4F3H &
         -Half*G1(iP,jQ)*G1(jP,kQ)*F1(kP,iQ) &
         -Half*G1(iP,kQ)*G1(kP,jQ)*F1(jP,iQ) &
         -Half*G1(jP,iQ)*G1(iP,kQ)*F1(kP,jQ) &
         -Half*G1(jP,kQ)*G1(kP,iQ)*F1(iP,jQ) &
         -Half*G1(kP,iQ)*G1(iP,jQ)*F1(jP,kQ) &
         -Half*G1(kP,jQ)*G1(jP,iQ)*F1(iP,kQ)
!     // G(I,i)G(J,j)G(K,k)G(L,l)[1]
CU4F3H = CU4F3H &
         +Six*G1(iP,iQ)*G1(jP,jQ)*G1(kP,kQ)*ES
!     // G(I,j)G(J,i)G(K,k)G(L,l)[6]
CU4F3H = CU4F3H &
         -Three*G1(iP,jQ)*G1(jP,iQ)*G1(kP,kQ)*ES &
         -Three*G1(iP,kQ)*G1(kP,iQ)*G1(jP,jQ)*ES &
         -Three*G1(jP,kQ)*G1(kP,jQ)*G1(iP,iQ)*ES
!     // G(I,j)G(J,k)G(K,i)G(L,l)[8]
CU4F3H = CU4F3H &
         +OneHalf*G1(iP,jQ)*G1(jP,kQ)*G1(kP,iQ)*ES &
         +OneHalf*G1(iP,kQ)*G1(kP,jQ)*G1(jP,iQ)*ES

! Loop over lT
do lT=1,NAC
  !     // G(IJ,ik)G(KL,jl)[12]
  CU4F3H = CU4F3H &
           -Half*G2(iP,iQ,jP,lT)*G2(lT,jQ,kP,kQ)*E(lT) &
           -Half*G2(iP,iQ,kP,lT)*G2(lT,kQ,jP,jQ)*E(lT) &
           -Half*G2(jP,jQ,iP,lT)*G2(lT,iQ,kP,kQ)*E(lT) &
           -Half*G2(jP,jQ,kP,lT)*G2(lT,kQ,iP,iQ)*E(lT) &
           -Half*G2(kP,kQ,iP,lT)*G2(lT,iQ,jP,jQ)*E(lT) &
           -Half*G2(kP,kQ,jP,lT)*G2(lT,jQ,iP,iQ)*E(lT)
  !     // G(IJ,kl)G(KL,ij)[3], G(IJ,lk)G(KL,ji)[3]
  !     // G(IJ,kl)G(KL,ji)[3], G(IJ,lk)G(KL,ij)[3]
  CU4F3H = CU4F3H &
           +( &
             +Two*G2(iP,kQ,jP,lT)*G2(kP,iQ,lT,jQ)*E(lT) &
             +Two*G2(iP,jQ,kP,lT)*G2(jP,iQ,lT,kQ)*E(lT) &
             +Two*G2(iP,jQ,lT,kQ)*G2(jP,iQ,kP,lT)*E(lT) &
             +Two*G2(iP,lT,jP,kQ)*G2(kP,jQ,lT,iQ)*E(lT) &
             +Two*G2(iP,lT,kP,jQ)*G2(jP,kQ,lT,iQ)*E(lT) &
             +Two*G2(iP,kQ,lT,jQ)*G2(jP,lT,kP,iQ)*E(lT) &
             +G2(iP,kQ,jP,lT)*G2(kP,jQ,lT,iQ)*E(lT) &
             +G2(iP,jQ,kP,lT)*G2(jP,kQ,lT,iQ)*E(lT) &
             +G2(iP,jQ,lT,kQ)*G2(jP,lT,kP,iQ)*E(lT) &
             +G2(iP,lT,jP,kQ)*G2(kP,iQ,lT,jQ)*E(lT) &
             +G2(iP,lT,kP,jQ)*G2(jP,iQ,lT,kQ)*E(lT) &
             +G2(iP,kQ,lT,jQ)*G2(jP,iQ,kP,lT)*E(lT) &
           )/Six
  !     // G(I,j)G(J,i)G(KL,kl)[6]
  CU4F3H = CU4F3H &
           +G1(iP,lT)*G1(lT,iQ)*G2(jP,jQ,kP,kQ)*E(lT) &
           +G1(jP,lT)*G1(lT,jQ)*G2(iP,iQ,kP,kQ)*E(lT) &
           +G1(kP,lT)*G1(lT,kQ)*G2(iP,iQ,jP,jQ)*E(lT)
  !     // G(I,i)G(J,k)G(KL,jl)[24]
  CU4F3H = CU4F3H &
           +G1(iP,iQ)*G1(jP,lT)*G2(lT,jQ,kP,kQ)*E(lT) &
           +G1(iP,iQ)*G1(kP,lT)*G2(lT,kQ,jP,jQ)*E(lT) &
           +G1(jP,jQ)*G1(iP,lT)*G2(lT,iQ,kP,kQ)*E(lT) &
           +G1(jP,jQ)*G1(kP,lT)*G2(lT,kQ,iP,iQ)*E(lT) &
           +G1(kP,kQ)*G1(iP,lT)*G2(lT,iQ,jP,jQ)*E(lT) &
           +G1(kP,kQ)*G1(jP,lT)*G2(lT,jQ,iP,iQ)*E(lT) &
           +G1(iP,iQ)*G1(lT,jQ)*G2(jP,lT,kP,kQ)*E(lT) &
           +G1(iP,iQ)*G1(lT,kQ)*G2(kP,lT,jP,jQ)*E(lT) &
           +G1(jP,jQ)*G1(lT,iQ)*G2(iP,lT,kP,kQ)*E(lT) &
           +G1(jP,jQ)*G1(lT,kQ)*G2(kP,lT,iP,iQ)*E(lT) &
           +G1(kP,kQ)*G1(lT,iQ)*G2(iP,lT,jP,jQ)*E(lT) &
           +G1(kP,kQ)*G1(lT,jQ)*G2(jP,lT,iP,iQ)*E(lT)
  !     // G(I,j)G(J,k)G(KL,il)[24]
  CU4F3H = CU4F3H &
           -Half*G1(iP,jQ)*G1(jP,lT)*G2(lT,iQ,kP,kQ)*E(lT) &
           -Half*G1(iP,kQ)*G1(kP,lT)*G2(lT,iQ,jP,jQ)*E(lT) &
           -Half*G1(jP,iQ)*G1(iP,lT)*G2(lT,jQ,kP,kQ)*E(lT) &
           -Half*G1(jP,kQ)*G1(kP,lT)*G2(lT,jQ,iP,iQ)*E(lT) &
           -Half*G1(kP,iQ)*G1(iP,lT)*G2(lT,kQ,jP,jQ)*E(lT) &
           -Half*G1(kP,jQ)*G1(jP,lT)*G2(lT,kQ,iP,iQ)*E(lT) &
           -Half*G1(iP,lT)*G1(lT,jQ)*G2(jP,iQ,kP,kQ)*E(lT) &
           -Half*G1(iP,lT)*G1(lT,kQ)*G2(kP,iQ,jP,jQ)*E(lT) &
           -Half*G1(jP,lT)*G1(lT,iQ)*G2(iP,jQ,kP,kQ)*E(lT) &
           -Half*G1(jP,lT)*G1(lT,kQ)*G2(kP,jQ,iP,iQ)*E(lT) &
           -Half*G1(kP,lT)*G1(lT,iQ)*G2(iP,kQ,jP,jQ)*E(lT) &
           -Half*G1(kP,lT)*G1(lT,jQ)*G2(jP,kQ,iP,iQ)*E(lT) &
           -Half*G1(lT,iQ)*G1(iP,jQ)*G2(jP,lT,kP,kQ)*E(lT) &
           -Half*G1(lT,iQ)*G1(iP,kQ)*G2(kP,lT,jP,jQ)*E(lT) &
           -Half*G1(lT,jQ)*G1(jP,iQ)*G2(iP,lT,kP,kQ)*E(lT) &
           -Half*G1(lT,jQ)*G1(jP,kQ)*G2(kP,lT,iP,iQ)*E(lT) &
           -Half*G1(lT,kQ)*G1(kP,iQ)*G2(iP,lT,jP,jQ)*E(lT) &
           -Half*G1(lT,kQ)*G1(kP,jQ)*G2(jP,lT,iP,iQ)*E(lT)
  !     // G(I,k)G(J,l)G(KL,ij)[12]
  CU4F3H = CU4F3H &
           -Half*G1(iP,kQ)*G1(jP,lT)*G2(kP,iQ,lT,jQ)*E(lT) &
           -Half*G1(iP,jQ)*G1(kP,lT)*G2(jP,iQ,lT,kQ)*E(lT) &
           -Half*G1(jP,iQ)*G1(kP,lT)*G2(iP,jQ,lT,kQ)*E(lT) &
           -Half*G1(iP,lT)*G1(jP,kQ)*G2(lT,iQ,kP,jQ)*E(lT) &
           -Half*G1(iP,lT)*G1(kP,jQ)*G2(lT,iQ,jP,kQ)*E(lT) &
           -Half*G1(jP,lT)*G1(kP,iQ)*G2(lT,jQ,iP,kQ)*E(lT) &
           -Half*G1(iP,jQ)*G1(lT,kQ)*G2(jP,iQ,kP,lT)*E(lT) &
           -Half*G1(iP,kQ)*G1(lT,jQ)*G2(kP,iQ,jP,lT)*E(lT) &
           -Half*G1(jP,iQ)*G1(lT,kQ)*G2(iP,jQ,kP,lT)*E(lT) &
           -Half*G1(jP,kQ)*G1(lT,iQ)*G2(kP,jQ,iP,lT)*E(lT) &
           -Half*G1(kP,iQ)*G1(lT,jQ)*G2(iP,kQ,jP,lT)*E(lT) &
           -Half*G1(kP,jQ)*G1(lT,iQ)*G2(jP,kQ,iP,lT)*E(lT)
  !     // G(I,j)G(J,i)G(K,k)G(L,l)[6]
  CU4F3H = CU4F3H &
           -Three*G1(iP,lT)*G1(lT,iQ)*G1(jP,jQ)*G1(kP,kQ)*E(lT) &
           -Three*G1(jP,lT)*G1(lT,jQ)*G1(iP,iQ)*G1(kP,kQ)*E(lT) &
           -Three*G1(kP,lT)*G1(lT,kQ)*G1(iP,iQ)*G1(jP,jQ)*E(lT)
  !     // G(I,j)G(J,k)G(K,i)G(L,l)[8]
  CU4F3H = CU4F3H &
           +OneHalf*G1(iP,jQ)*G1(jP,lT)*G1(lT,iQ)*G1(kP,kQ)*E(lT) &
           +OneHalf*G1(iP,kQ)*G1(kP,lT)*G1(lT,iQ)*G1(jP,jQ)*E(lT) &
           +OneHalf*G1(jP,kQ)*G1(kP,lT)*G1(lT,jQ)*G1(iP,iQ)*E(lT) &
           +OneHalf*G1(iP,lT)*G1(lT,jQ)*G1(jP,iQ)*G1(kP,kQ)*E(lT) &
           +OneHalf*G1(iP,lT)*G1(lT,kQ)*G1(kP,iQ)*G1(jP,jQ)*E(lT) &
           +OneHalf*G1(jP,lT)*G1(lT,kQ)*G1(kP,jQ)*G1(iP,iQ)*E(lT)
  !     // G(I,k)G(J,l)G(K,i)G(L,j)[3]
  CU4F3H = CU4F3H &
           +OneHalf*G1(iP,kQ)*G1(jP,lT)*G1(kP,iQ)*G1(lT,jQ)*E(lT) &
           +OneHalf*G1(iP,jQ)*G1(kP,lT)*G1(jP,iQ)*G1(lT,kQ)*E(lT) &
           +OneHalf*G1(iP,lT)*G1(jP,kQ)*G1(lT,iQ)*G1(kP,jQ)*E(lT)
  !     // G(I,j)G(J,k)G(K,l)G(L,i)[6]
  CU4F3H = CU4F3H &
           -0.75_wp*G1(iP,jQ)*G1(jP,kQ)*G1(kP,lT)*G1(lT,iQ)*E(lT) &
           -0.75_wp*G1(iP,kQ)*G1(kP,jQ)*G1(jP,lT)*G1(lT,iQ)*E(lT) &
           -0.75_wp*G1(iP,jQ)*G1(jP,lT)*G1(lT,kQ)*G1(kP,iQ)*E(lT) &
           -0.75_wp*G1(iP,kQ)*G1(kP,lT)*G1(lT,jQ)*G1(jP,iQ)*E(lT) &
           -0.75_wp*G1(iP,lT)*G1(lT,jQ)*G1(jP,kQ)*G1(kP,iQ)*E(lT) &
           -0.75_wp*G1(iP,lT)*G1(lT,kQ)*G1(kP,jQ)*G1(jP,iQ)*E(lT)
end do

return

end function CU4F3H

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine asonc12_cvb(c,sxc,nvec,
     >   citmp,orbs,gjorb,gjorb2,gjorb3,cvbdet)
      implicit real*8 (a-h,o-z)
#include "ext_cvb.fh"
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"

      dimension c(nvb,nvec),sxc(nvb,nvec)
      dimension citmp(ndet),orbs(norb,norb)
      dimension gjorb(*),gjorb2(*),gjorb3(*),cvbdet(ndetvb)

      do 100 ivec=1,nvec
      call str2vbf_cvb(c(1,ivec),cvbdet)
      call vb2cif_cvb(cvbdet,citmp)
      call applyts_cvb(citmp,orbs,gjorb,gjorb2,gjorb3)
      call ci2vbg_cvb(citmp,cvbdet)
      call vb2strg_cvb(cvbdet,sxc(1,ivec))
100   continue
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1994, Martin Schuetz                                   *
!               2017, Roland Lindh                                     *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine RotMOs(Delta,nDelta)
!***********************************************************************
!                                                                      *
!     purpose: rotates MOs according to last displacement vector       *
!              delta after QNR step and DIIS extrapolation.            *
!              only called during second order update (QNR) opt.       *
!                                                                      *
!     input:                                                           *
!       Delta   : displacement vectors used to construct unitary       *
!                 rotation matrix via expKap                           *
!       CMO_ref : orthonormal vectors from reference iteration of      *
!                 length nCMO                                          *
!                                                                      *
!     output:                                                          *
!       CMO     : orthonormal vectors, rotated by U=exp(delta)         *
!                                                                      *
!                                                                      *
!***********************************************************************

use InfSCF, only: CMO, CMO_ref, kOV, nBas, nD, nFro, nOcc, nOFS, nOrb, nSym, TimFld
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nDelta
real(kind=wp), intent(in) :: Delta(nDelta)
integer(kind=iwp) :: iCMOpt, iD, iEnd, iSt, iSyBlpt, iSym, nOccmF(8), nOF, nOfNBA, nSize, nVrt
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: nCMO
#endif
real(kind=wp) :: Cpu1, CPU2, Tim1, Tim2, Tim3, WhatEver
real(kind=wp), allocatable :: RoM(:), Scratch(:)

call Timing(Cpu1,Tim1,Tim2,Tim3)

call mma_allocate(RoM,nOFS,Label='RoM')
nSize = 0
do iSym=1,nSym
  nOF = nOrb(iSym)-nFro(iSym)
  nOFnBa = nOF*nBas(iSym)
  nSize = max(nSize,nOFnBa)
end do
call mma_allocate(Scratch,nSize,Label='Scratch')

iEnd = 0
do iD=1,nD
  if (kOV(iD) < 1) cycle
  iSt = iEnd+1
  iEnd = iEnd+kOV(iD)
  ! compute rotation matrix via expkap
  nOccmF(:) = nOcc(:,iD)-nFro(:)
  call ExpKap(Delta(iSt:iEnd),kOV(id),RoM,nOccmF)
  iSyBlpt = 1
  iCMOpt = 1

  ! loop over all symmetry blocks

  do iSym=1,nSym

    nOF = nOrb(iSym)-nFro(iSym)
    nVrt = nOrb(iSym)-nOcc(iSym,iD)
    nOFnBa = nOF*nBas(iSym)
    iCMOpt = iCMOpt+nBas(iSym)*nFro(iSym)

    ! skip, if no orbitals within this irrep
    if ((nVrt > 0) .and. (nOccmF(iSym) > 0)) then
      Scratch(1:nOFnBA) = CMO_ref(iCMOpt:iCMOpt+nOFnBa-1,iD)
      call DGEMM_('N','N',nBas(iSym),nOF,nOF, &
                  One,Scratch,nBas(iSym), &
                  RoM(iSyBlpt),nOF, &
                  Zero,CMO(iCMOpt,iD),nBas(iSym))
#     ifdef _DEBUGPRINT_
      call NrmClc(Scratch,nBas(iSym)*nOrb(iSym),'RotMOs','Old CMOs')
      call NrmClc(CMO(iCMOpt,iD),nBas(iSym)*nOrb(iSym),'RotMOs','New CMOs')
      call RecPrt('RoM',' ',RoM(iSyBlpt),nOF,nOF)
      !call RecPrt('RotMOs: Old CMOs',' ',Scratch,nBas(iSym),nOrb(iSym))
      !call RecPrt('RotMOs: New CMOs',' ',CMO(iCMOpt,iD),nBas(iSym),nOrb(iSym))
#     endif
      iSyBlpt = iSyBlpt+nOF*nOF
    end if
    iCMOpt = iCMOpt+nOF*nBas(iSym)
  end do

  ! Check orthogonality

  call ChkOrt(iD,Whatever)

end do ! iD

call mma_deallocate(Scratch)
call mma_deallocate(RoM)

#ifdef _DEBUGPRINT_
nCMO = size(CMO,1)
call NrmClc(Delta,nDelta,'RotMos','Delta')
call NrmClc(CMO,nCMO*nD,'RotMos','CMO')
call RecPrt('RotMOs: Delta',' ',Delta,1,nDelta)
call RecPrt('RotMOs: CMO',' ',CMO,nCMO,nD)
#endif
call Timing(Cpu2,Tim1,Tim2,Tim3)
TimFld(9) = TimFld(9)+(Cpu2-Cpu1)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*
return

end subroutine RotMOs

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine GenBMp_Loc(X,nRow,nCol,FilNam,Color)

use Constants, only: One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nRow, nCol
real(kind=wp), intent(in) :: X(nRow,nCol)
character(len=*), intent(in) :: FilNam
character, intent(in) :: Color
integer(kind=iwp) :: irc, Lunit, nStp
real(kind=wp) :: StpSiz
character(len=80) :: Txt
character(len=*), parameter :: SecNam = 'GenBMp_Loc'
integer(kind=iwp), external :: isFreeUnit

Lunit = isFreeUnit(11)
call Molcas_Open(Lunit,FilNam)
irc = 0
nStp = -1
StpSiz = -One
call GenBMp(irc,X,nRow,nCol,Lunit,nStp,StpSiz,Color)
if (irc /= 0) then
  write(Txt,'(A,I4)') 'GenBMp returned',irc
  call SysAbendMsg(SecNam,'GenBMp failed!',Txt)
end if
close(Lunit,Status='Keep')

end subroutine GenBMp_Loc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE Compute_Shanks(E1,E2,EOrb,lthEOrb,
     &                          nBas,nFro,nOcc,nSym,E0,Shanks1_E)

      Implicit Real*8 (a-h,o-z)
      Real*8 E1, E2, EOrb(lthEOrb), E0, Shanks1_E
      Integer nSym, nBas(nSym), nFro(nSym), nOcc(nSym)

      E0=0.0d0
      ioff=0
      Do iSym=1,nSym
         nOrb=nFro(iSym)+nOcc(iSym)
         Do iorb=1,nOrb
            jorb=ioff+iorb
            E0=E0+EOrb(jorb)
         End Do
         ioff=ioff+nBas(iSym)
      End Do
      E0=2.0d0*E0
*
      Call Peek_dScalar('PotNuc',PotNuc)
      E0 = E0 + PotNuc

*   Shanks formula

      Shanks1_E = (E2*E0 - E1**2) / (E2 - 2.0d0*E1 + E0)

      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1995, Martin Schuetz                                   *
************************************************************************
      SubRoutine SOFSh1(nSkal,nSym,nSOs)
************************************************************************
* This Module contains subroutines which are used to compute info on   *
* the size of the SO integral symmetry blocks for direct integral      *
* transformation                                                       *
*                                                                      *
* SubRoutine SOFSh1                                                    *
*  -> compute (1) # SO functions in irrep for all shells iShell        *
*             (2) position of 1st component of shell in irrep for      *
*                 all shells in all irreps                             *
*             (3) map vector between shells and psedoshells for each   *
*                 irrep (not any shell contributes to all irreps)      *
*             (4) map vector between SO indices and shells             *
* relevant data is declared and passed in common "inftra.fh"           *
*----------------------------------------------------------------------*
*     written by:                                                      *
*     M. Schuetz                                                       *
*     University of Lund, Sweden, 1995                                 *
************************************************************************
*#define _CHECK_
      use SOAO_Info, only: iAOtSO
      use iSD_data
      use Index_arrays
      use Basis_Info, only: nBas, nBas_Aux
      Implicit Real*8 (A-H,O-Z)
*
#include "stdalloc.fh"
#include "Basis_Mode_Parameters.fh"
#include "Basis_Mode.fh"
      Integer nSkal, nSym, nSOs, nShOff(0:7)
      Dimension iTmp(1 )
*
*     Allocate all memory
*
      Call mma_allocate(nShBF,[0,nSym-1],[1,nSkal],Label='nShBF')
      Call mma_allocate(iShOff,[0,nSym-1],[1,nSkal],Label='iShOff')
      Call mma_allocate(iSh2Sh,[0,nSym-1],[1,nSkal],Label='iSh2Sh')
      Call mma_allocate(iSO2Sh,nSOs,Label='iSO2Sh')
      Call mma_allocate(iCntr,nSkal,Label='iCntr')
*
*     Initialize
      nShBF(:,:)=0
      iShOff(:,:)=9999999
      nShOff(:)=1
*
      Do iSkal = 1, nSkal
         iAO         = iSD( 7,iSkal)
         iCmp        = iSD( 2,iSkal)
         icntr(iSkal)= iSD(10,iSkal)
*
*        loop over components of shell...
*
         Do i=1, iCmp
*           loop over irreps...
            Do irp=0, nSym-1
               If (iAOtSO(iAO+i,irp)>0) Then
                  nShBF(irp,iSkal) = nShBF(irp,iSkal)+ iSD(3,iSkal)
#ifdef _CHECK_
                  If (Basis_Mode.eq.Auxiliary_Mode) Then
                     iShOff(irp,iSkal)=Min(iShOff(irp,iSkal),
     &                                     iAOtSO(iAO+i,irp)-nBas(irp))
                  Else
                     iShOff(irp,iSkal)=Min(iShOff(irp,iSkal),
     &                                     iAOtSO(iAO+i,irp))
                  End If
#endif
               End If
            End Do
         End Do
         Do irp=0,nSym-1
#ifdef _CHECK_
            If(nShBF(irp,iskal).ne.0   .and.
     >         nShOff(irp).ne.iShOff(irp,iSkal)) Then
               Call WarningMessage(2,'PROGRAMMING ERROR IN SHELL_SIZES')
               Write (6,*) nShBF(irp,iskal)
               Write (6,*) nShOff(irp)
               Write (6,*) iShOff(irp,iSkal)
               write(6,*) 'PROGRAMMING ERROR IN SHELL_SIZES: ',
     >                    'SHELLS NOT CONTIGUOUS. IRP=',irp,
     >                    '  ISKAL=',iskal
               Call Abend()
            End if
#endif
            iShOff(irp,iSkal)=nShOff(irp)
            nShOff(irp)=nShOff(irp)+nShBF(irp,iSkal)
         End Do
#ifdef _DEBUGPRINT_
         Write(6,'(A)') 'nShBF'
         Write(6,'(8I4)') iSkal,(nShBF(irp,iSkal),irp=0,nSym-1)
         Write(6,'(A)') 'iShOff'
         Write(6,'(8I4)') iSkal,(iShOff(irp,iSkal),irp=0,nSym-1)
#endif
      End Do
*
*     and now set up SO-Shell and Shell-Psudoshell index vectors...
*
      iTmp=0 ! Use iTmp to get round compiler bug on some machines
      Call ICopy(nSym,iTmp,0,nShIrp,1)
*
      iTmp=-9999999
      Call ICopy(nSOs,iTmp,0,iSO2Sh,1)
      Call ICopy(nSkal*nSym,iTmp,0,iSh2Sh,1)
*
*     Loop over irreps...
*
      iptr=0
      nShBFMx=0
      Do irp=0, nSym-1
         Do iSkal=1, nSkal
*
            nShBFi=nShBF(irp,iSkal)
            nShBFMx=Max(nShBFMx,nShBFi)
            iSOb=iShOff(irp,iSkal)
            Do iSO=iSOb, iSOb+nShBFi-1
               If (iSO.gt.nSOs) Then
                  Call WarningMessage(2,' Fucked again!')
                  Call Quit_OnUserError()
               End If
               iSO2Sh(iptr+iSO)=iSkal
            End Do
*
            If (nShBFi.gt.0) Then
              nShIrp(irp)=nShIrp(irp)+1
              iSh2Sh(irp,iSkal)=nShIrp(irp)
            End If
         End Do
         If (Basis_Mode.eq.Auxiliary_Mode) Then
            iptr=iptr+nBas_Aux(irp)
         Else
            iptr=iptr+nBas(irp)
         End If
      End Do
#ifdef _DEBUGPRINT_
      Write(6,'(A,I4)') 'max shell size:',nShBFMx
      Write(6,'(A)') '# of shells contributing to each irrep:'
      Write(6,'(8I4)') (nShIrp(irp),irp=0,nSym-1)
      Write(6,'(A)') '# shell-psudoshell map vector:'
      Do irp=0, nSym-1
        Write(6,'(A4,2X,I4,2X,A4,2X,8I4)') 'irp=',irp,'map:',
     &             (iSh2Sh(irp,iSkal),iSkal=1,nSkal)
      End Do
      Write(6,'(A)') 'SO-index to shell map vector:'
      Write(6,'(50I4)') (iSO2Sh(iSO),iSO=1,nSOs)
#endif
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine vb2mol_cvb(vecvb,vecmol,isyml)

use casvb_global, only: nalf, nbet, ndet, norb
use Constants, only: Zero
use Definitions, only: wp, iwp

implicit none
real(kind=wp), intent(inout) :: vecvb(ndet), vecmol(*)
integer(kind=iwp), intent(in) :: isyml
integer(kind=iwp) :: iwr, nsa, nsb

iwr = 0
call icomb_cvb(norb,nalf,nsa)
call icomb_cvb(norb,nbet,nsb)
call mol2vb2_cvb(vecvb,vecmol,isyml,Zero,iwr,nsa,nsb)

return

end subroutine vb2mol_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_PreScr(Thr1,Thr2)
      use Gateway_Info, only: ThrInt, CutInt
C
C     Purpose: read integral prescreening thresholds from common block.
C
      Real*8 Thr1, Thr2
      Thr1 = CutInt
      Thr2 = ThrInt

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       subroutine init_run_use
#include "run_use_common.fh"
       do i=1,nTocCA
         i_run_CA_used(i)=0
       enddo
       do i=1,nTocDA
         i_run_DA_used(i)=0
       enddo
       do i=1,nTocDS
         i_run_DS_used(i)=0
       enddo
       do i=1,nTocIA
         i_run_IA_used(i)=0
       enddo
       do i=1,nTocIS
         i_run_IS_used(i)=0
       enddo
       return
       end

       subroutine fin_run_use
       use Definitions, only: iwp
#include "run_use_common.fh"
       parameter (MakeWarn=40)
c       parameter (MakeErr=100)
       Character*16 Label
       Character*60 Line
       logical(kind=iwp), external :: Reduce_Prt
#ifdef _HAVE_EXTRA_
c FIXME: This include file should be created,
c        as it contains a shared common block
c#include "lfalcon.fh"
#else
       Logical isFalcon
       isFalcon = .false.
#endif

       if (Reduce_Prt()) return
c       need_abend=0
       do i=1,nTocCA
         if(i_run_CA_used(i).gt.MakeWarn.and..not.isFalcon) then
c           write(6,*) 'cArray label ',i,' used ',
c     &                       i_run_CA_used(i),' times'
           call lookup_label(i,'cArray labels',Label)
           write(Line,'(A,A,A,I8,A)') 'RunFile label ',Label,
     &       ';was used ',i_run_CA_used(i),' times'
           Call WarningMessage(1, Line)
         endif
       enddo
       do i=1,nTocDA
         if(i_run_DA_used(i).gt.MakeWarn.and..not.isFalcon) then
c           write(6,*) 'dArray label ',i,' used ',
c     &                      i_run_DA_used(i),' times'
           call lookup_label(i,'dArray labels',Label)
           write(Line,'(A,A,A,I8,A)') 'RunFile label ',Label,
     &       ';was used ',i_run_DA_used(i),' times'
           Call WarningMessage(1,Line)
         endif
       enddo
       do i=1,nTocDS
         if(i_run_DS_used(i).gt.MakeWarn.and..not.isFalcon) then
c           write(6,*) 'dScalar label ',i,' used ',
c     &                      i_run_DS_used(i),' times'
           call lookup_label(i,'dScalar labels',Label)
           write(Line,'(A,A,A,I8,A)') 'RunFile label ',Label,
     &       ';was used ',i_run_DS_used(i),' times'
           Call WarningMessage(1,Line)
         endif
       enddo
       do i=1,nTocIA
         if(i_run_IA_used(i).gt.MakeWarn.and..not.isFalcon) then
c           write(6,*) 'iArray label ',i,' used ',
c     &                       i_run_IA_used(i),' times'
           call lookup_label(i,'iArray labels',Label)
           write(Line,'(A,A,A,I8,A)') 'RunFile label ',Label,
     &       ';was used ',i_run_IA_used(i),' times'
           Call WarningMessage(1,Line)
         endif
       enddo
       do i=1,nTocIS
         if(i_run_IS_used(i).gt.MakeWarn.and..not.isFalcon) then
c           write(6,*) 'iScalar label ',i,' used ',
c     &                       i_run_IS_used(i), ' times'
           call lookup_label(i,'iScalar labels',Label)
           write(Line,'(A,A,A,I8,A)') 'RunFile label ',Label,
     &       ';was used ',i_run_IS_used(i),' times'
           Call WarningMessage(1,Line)
         endif
       enddo
c       if(need_abend.eq.1) call abend()
       return
       end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1992, Per-Olof Widmark                                 *
!               1992, Markus P. Fuelscher                              *
!               1992, Piotr Borowski                                   *
!               2017,2022, Roland Lindh                                *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine EGrad(O,S,nOTSD,C,nC,G,nG,nD,iOpt)
!***********************************************************************
!                                                                      *
!     purpose: This routine calculates the gradient of the SCF energy  *
!              with respect to the rotation parameters.                *
!              Grad(E) = C(t)(FDS-SDF)C                                *
!                                                                      *
!                                                                      *
!     input:                                                           *
!       O       : one-electron hamiltonian of length nOTSD             *
!       S       : overlap in AO basis of length nOTSD                  *
!       C       : matrix transforming to the set of orthonormal        *
!                 (and spherical, if needed) functions of length nC    *
!                                                                      *
!     output:                                                          *
!       G       : gradient of the SCF energy with respect to the       *
!                 rotation parameters of length nG                     *
!***********************************************************************

use Index_Functions, only: nTri_Elem
use InfSCF, only: Dens, iDisk, MapDns, MaxBas, nBas, nBO, nBT, nFro, nnFr, nOcc, nOrb, nSym, OrbType, TwoHam, Vxc
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, Two
use Definitions, only: wp, iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: nOTSD, nC, nG, nD, iOpt
real(kind=wp), intent(in) :: O(nOTSD), S(nOTSD), C(nC,nD)
real(kind=wp), intent(inout) :: G(nG,nD)
integer(kind=iwp) :: i, iD, ig, ih, ij, iOff, iSym, it, j, jDT, k, l, nBs, nOr, nOrbmF
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: i_Max, j_Max
real(kind=wp) :: GMax
#endif
real(kind=wp), allocatable :: Aux1(:), Aux2(:), Aux3(:), FckM(:,:)
real(kind=wp), allocatable, target :: AuxD(:,:), AuxT(:,:), AuxV(:,:)
real(kind=wp), pointer :: D(:,:), T(:,:), V(:,:)

!----------------------------------------------------------------------*
! Start
jDT = MapDns(iOpt)
if (jDT < 0) then
  call mma_allocate(AuxD,nOTSD,nD,Label='AuxD')
  call mma_allocate(AuxT,nOTSD,nD,Label='AuxT')
  call mma_allocate(AuxV,nOTSD,nD,Label='AuxV')

  call RWDTG(-jDT,AuxD,nOTSD*nD,'R','DENS  ',iDisk,size(iDisk,1))
  call RWDTG(-jDT,AuxT,nOTSD*nD,'R','TWOHAM',iDisk,size(iDisk,1))
  call RWDTG(-jDT,AuxV,nOTSD*nD,'R','dVxcdR',iDisk,size(iDisk,1))

  D(1:nOTSD,1:nD) => AuxD(:,:)
  T(1:nOTSD,1:nD) => AuxT(:,:)
  V(1:nOTSD,1:nD) => AuxV(:,:)
else
  D(1:nOTSD,1:nD) => Dens(:,:,jDT)
  T(1:nOTSD,1:nD) => TwoHam(:,:,jDT)
  V(1:nOTSD,1:nD) => Vxc(:,:,jDT)
end if
#ifdef _DEBUGPRINT_
write(u6,*) 'EGrad: input arrays'
write(u6,*) '==================================================='
call NrmClc(O,nOTSD,'EGrad','O')
call NrmClc(S,nOTSD,'EGrad','S')
call NrmClc(D,nOTSD*nD,'EGrad','D')
call NrmClc(T,nOTSD*nD,'EGrad','T')
call NrmClc(V,nOTSD*nD,'EGrad','V')
call NrmClc(C,nC*nD,'EGrad','C')
!do iD=1,nD
!  write(u6,*) 'OrbType(:,iD)',OrbType(:,iD)
!end do ! iD
write(u6,*) '==================================================='
write(u6,*)
#endif
!----------------------------------------------------------------------*

! Allocate memory for modified fock matrix
call mma_allocate(FckM,nBT,nD,Label='FckM')
FckM(:,:) = Zero
G(:,:) = Zero

! Allocate memory for auxiliary matrices
call mma_allocate(Aux1,MaxBas**2,Label='Aux1')
call mma_allocate(Aux2,MaxBas**2,Label='Aux2')
call mma_allocate(Aux3,MaxBas**2,Label='Aux3')

do iD=1,nD

  FckM(:,iD) = O(:)+T(:,iD)
# ifdef _DEBUGPRINT_
  write(u6,*) 'iD=',iD
  call NrmClc(FckM(1,iD),nBT,'EGrad','FckM')
# endif
  if (nnFr > 0) call ModFck(FckM(:,iD),S,nBT,C(:,iD),nBO,nOcc(:,iD))

  FckM(:,iD) = FckM(:,iD)+V(:,iD)
# ifdef _DEBUGPRINT_
  call NrmClc(FckM(1,iD),nBT,'EGrad','FckM')
# endif

  iOff = 0
  ij = 1
  it = 1
  ig = 1
  do iSym=1,nSym
    nBs = nBas(iSym)
    nOr = nOrb(iSym)
    nOrbmF = nOrb(iSym)-nFro(iSym)

    if (nOr > 0) then

      ! Square Fock matrix and perform C(T)F
      Aux2(:) = Zero
      call Square(FckM(ij:,iD),Aux2,1,nBs,nBs)
#     ifdef _DEBUGPRINT_
      write(u6,*) 'iSym=',iSym
      call NrmClc(Aux2,nBs*nBs,'EGrad','Aux2')
#     endif
      Aux1(:) = Zero
      call DGEMM_('T','N',nOr,nBs,nBs, &
                  One,C(it,iD),nBs, &
                  Aux2,nBs, &
                  Zero,Aux1,nOr)
#     ifdef _DEBUGPRINT_
      call NrmClc(Aux1,nOr*nBs,'EGrad','Aux1')
#     endif

      ! Square density matrix and perform C(T)FD
      Aux2(:) = Zero
      call DSq(D(ij:,iD),Aux2,1,nBs,nBs)
#     ifdef _DEBUGPRINT_
      call NrmClc(Aux2,nBs*nBs,'EGrad','Aux2')
#     endif
      Aux3(:) = Zero
      call DGEMM_('N','N',nOr,nBs,nBs, &
                  One,Aux1,nOr, &
                  Aux2,nBs, &
                  Zero,Aux3,nOr)
#     ifdef _DEBUGPRINT_
      call NrmClc(Aux3,nOr*nBs,'EGrad','Aux3')
#     endif

      ! Square overlap matrix and perform C(T)FDS
      Aux2(:) = Zero
      call Square(S(ij:),Aux2,1,nBs,nBs)
#     ifdef _DEBUGPRINT_
      call NrmClc(Aux2,nBs*nBs,'EGrad','Aux2')
#     endif
      Aux1(:) = Zero
      call DGEMM_('N','N',nOr,nBs,nBs, &
                  One,Aux3,nOr, &
                  Aux2,nBs, &
                  Zero,Aux1,nOr)
#     ifdef _DEBUGPRINT_
      call NrmClc(Aux1,nOr*nBs,'EGrad','Aux1')
#     endif
      ! C(T)FDSC
      Aux2(:) = Zero
      call DGEMM_('N','N',nOr,nOr,nBs, &
                  One,Aux1,nOr, &
                  C(it,iD),nBs, &
                  Zero,Aux2,nOr)
#     ifdef _DEBUGPRINT_
      call NrmClc(Aux2,nOr*nOr,'EGrad','Aux2')
#     endif

      call Asym(Aux2,G(ig:ig+nOr**2-1,iD),nOr)
#     ifdef _DEBUGPRINT_
      write(u6,*)
      call NrmClc(G,nG*nD,'EGrad','G')
      write(u6,*)
#     endif

      ! At this point enforce that the gradient is exactly zero
      ! for elements corresponding to orbitals of different
      ! fermion types.

      do i=1,nOr
        if (i <= nFro(iSym)) then
          k = -1
        else
          k = OrbType(iOff+i-nFro(iSym),iD)
        end if

        do j=1,nOr
          if (j <= nFro(iSym)) then
            l = -1
          else
            l = OrbType(iOff+j-nFro(iSym),iD)
          end if

          ih = ig+(i-1)*nOr+j-1
          if (k /= l) G(ih,iD) = Zero

        end do
      end do

    end if
    ij = ij+nTri_Elem(nBs)
    it = it+nBs*nOr
    ig = ig+nOr**2
    iOff = iOff+nOrbmF

  end do ! iSym

end do ! iD

! Deallocate memory
call mma_deallocate(Aux3)
call mma_deallocate(Aux2)
call mma_deallocate(Aux1)
call mma_deallocate(FckM)

G(:,:) = Two*G(:,:)

#ifdef _DEBUGPRINT_
i_Max = 0
j_Max = 0
GMax = Zero
do i=1,nD
  do j=1,nG
    if (GMax < abs(G(j,i))) then
      GMax = abs(G(j,i))
      i_Max = i
      j_Max = j
    end if
  end do
end do
write(u6,*) 'GMax,i_Max,j_Max=',GMax,i_Max,j_Max
call NrmClc(G,nG*nD,'EGrad','G')
#endif
if (jDT < 0) then
  call mma_deallocate(AuxD)
  call mma_deallocate(AuxT)
  call mma_deallocate(AuxV)
end if
nullify(D,T,V)

!----------------------------------------------------------------------*
!     Exit                                                             *
!----------------------------------------------------------------------*

contains

subroutine Asym(H,A,n)

  integer(kind=iwp), intent(in) :: n
  real(kind=wp), intent(in) :: H(n,n)
  real(kind=wp), intent(inout) :: A(n,n)
  integer(kind=iwp) :: i

  do i=1,n
    A(i,1:i-1) = H(i,1:i-1)-H(1:i-1,i)
    A(i,i) = Zero
  end do

end subroutine ASym

end subroutine EGrad

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Mult_Vk_Qv_s(V_k,nV_k,Qv,nQv,V_kQ,nV_kQ,nBas_Aux,
     &                        nVec,nIrrep,QMode)
      Implicit Real*8 (a-h,o-z)
      Real*8 Qv(nQv), V_k(nV_k), V_kQ(nV_kQ)
      Integer nBas_Aux(0:nIrrep-1), nVec(0:nIrrep-1)
      Logical Out_of_Core
      Character QMode*1, Name_Q*6
*                                                                      *
************************************************************************
*                                                                      *
      nMuNu=1
      kp_V_k=1
      lstepA=0
      lstepB=1
      If (Qmode.eq.'T') Then
         Call FZero(V_kQ,nV_kQ)
         lstepA=1
         lstepB=0
      End If

      Do iIrrep = 0, 0  ! loop is wisely restricted to tot. symm. irrep
         iSeed=55+iIrrep
         Lu_Q=IsFreeUnit(iSeed)
         Write(Name_Q,'(A4,I2.2)') 'QVEC',iIrrep
         Call DaName_MF_WA(Lu_Q,Name_Q)
         iAddr=0
*
         nI=nBas_Aux(iIrrep)
         If (iIrrep.eq.0) nI=nI-1
         nJ=nVec(iIrrep)
         mQv=nI*nJ
         Out_of_Core = mQv .gt. nQv
*                                                                      *
************************************************************************
*                                                                      *
         If (.Not.Out_of_Core) Then
*
*           in-core case
*
            Call dDaFile(Lu_Q,2,Qv,mQv,iAddr)
*
            Call A_3C_Qv_s(V_k(kp_V_k),
     &                     Qv,
     &                     V_kQ,nMuNu,nI,nJ,QMode)
*
         Else
*
*           Out-of-core case
*
            iOffA=kp_V_k
            iOffB=iOffA
            Do While (mQv.ge.nI)
*
               nK=Min(mQv,nQv)/nI
               lQv=nI*nK
               Call dDaFile(Lu_Q,2,Qv,lQv,iAddr)
*
               Call A_3C_Qv_s(V_k(iOffA),
     &                        Qv,
     &                        V_kQ(iOffB),nMuNu,nI,nK,QMode)
               mQv = mQv - lQv
               iOffA = iOffA + lstepA*nK
               iOffB = iOffB + lstepB*nK
            End Do
*
         End If
*                                                                      *
************************************************************************
*                                                                      *
         Call DaClos(Lu_Q)
*
         kp_V_k = kp_V_k + nBas_Aux(iIrrep)
      End Do
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine H0MAT_MCLR(H0,ISBDET,ISBCNF,MXP1,MXP2,MXQ,NOCOB,NPRCIV,IREFSM,IDC,PSSIGN,VEC1,VEC2,H0SCR,ieaw)
! Obtain preconditioner space corresponding to internal space INTSPC
! Obtain Hamiltonian matrices corresponding to this subspace
!
! Construct Preconditioner blocks of Hamiltonian matrix
!
! ======
!.Output
! ======
!
! CSF : NP1CSF,NP2CSF,NQCSF : Number of CSFs in the 3 primary subspaces
!
! NPRCIV : Number of parameters in preconditioner space

use Str_Info, only: CNSM, DFTP, DTOC
use MCLR_Data, only: NAELCI, NBELCI, NCNASM
use Constants, only: Zero
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
real(kind=wp), intent(_OUT_) :: H0(*), vec2(*), h0scr(*)
integer(kind=iwp), intent(_OUT_) :: ISBDET(*), ISBCNF(*)
integer(kind=iwp), intent(in) :: MXP1, MXP2, MXQ, NOCOB, IREFSM, IDC, ieaw
integer(kind=iwp), intent(out) :: NPRCIV
real(kind=wp), intent(in) :: PSSIGN, vec1(*)
integer(kind=iwp) :: ICOMBI, intspc, IPWAY, NAEL, NBEL, NP1CNF, NP1CSF, NP2CNF, NP2CSF, NPCNF, NQCNF, NQCSF
real(kind=wp) :: PSIGN

! Info on actual internal subspace
intspc = 1
!luhdia = 0
!IATP = IASTFI(INTSPC)
!IBTP = IBSTFI(INTSPC)
!MNR1 = MNR1IC(INTSPC)
!MXR1 = MXR1IC(INTSPC)
!MNR3 = MNR3IC(INTSPC)
!MXR3 = MXR3IC(INTSPC)
NAEL = NAELCI(INTSPC)
NBEL = NBELCI(INTSPC)

!NOCTPA = NOCTYP(IATP)
!NOCTPB = NOCTYP(IBTP)
! Allowed combination of alpha and beta strings
!call mma_allocate(IOCOC,NOCTPA*NOCTPB,Label='IOCOC')
!call IAIBCM_MCLR(MNR1,MXR3,NOCTPA,NOCTPB,Str(IATP)%EL1,Str(IATP)%EL3,Str(IBTP)%EL1,Str(IBTP)%EL3,IOCOC)

if (IDC == 1) then
  ICOMBI = 0
  PSIGN = Zero
else
  PSIGN = PSSIGN
  ICOMBI = 1
end if

!if (NOCSF /= 0) then
!  ! Combinations expansion, PQ preconditioner
!
!  IHAMSM = 1
!  IWAY = 1
!  ! strings are unsigned
!  ISTSGN = 0
!  call H0SD(LUHDIA,LBLK,VEC1,IWAY,NSBDET,NAEL,NBEL,IREFSM,IOCOC,IHAMSM,H0,NOCOB,0,ECORE,ICOMBI,PSIGN,NPRCIV,SBEVC,SBEVL,1,NCIVAR, &
!            ISBDET,ISBIA,ISBIB,MXP1,MXP2,MXQ,MP1CSF,MP2CSF,MQCSF,Str(IATP)%OCSTR, Str(IBTP)%OCSTR,ISTSGN,IDUMMY,IDUMMY,INTSPC)
!else
!  CSF basis,PQ preconditioner
IPWAY = 2
call H0CSF(H0,ISBDET,ISBCNF,MXP1,MXP2,MXQ,DTOC,DFTP,CNSM(ieaw)%ICONF,IREFSM,NOCOB,H0SCR,NCNASM(IREFSM),NAEL+NBEL,NAEL,NBEL,IPWAY, &
           NP1CSF,NP1CNF,NP2CSF,NP2CNF,NQCSF,NQCNF,NPRCIV,NPCNF,VEC1,VEC2,INTSPC,ICOMBI,PSIGN)
!end if

!call mma_deallocate(IOCOC)

end subroutine H0MAT_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Markus P. Fuelscher                              *
*               1993, Per Ake Malmqvist                                *
************************************************************************
      Subroutine OpnFls_CASPT2
************************************************************************
C  purpose:
C  - initialize logical unit numbers
C  - open files
*----------------------------------------------------------------------*
C  written by:
C  M.P. Fuelscher and P. AA. Malmqvist
C  University of Lund, Sweden, 1993
************************************************************************
      Implicit Real*8 (A-H,O-Z)
      CHARACTER(LEN=2) CVEC,CMAT
*---------------------------------------------------------------------*
C  Start
*---------------------------------------------------------------------*
#include "rasdim.fh"
#include "caspt2.fh"
#include "output.fh"

*---  define logical unit numbers ------------------------------------*
C  AO two-electron integrals
      LUINTA=20
C  AO one-electron integrals
      LUONEA=9
*
C  Used during solution of the caspt2 eqs
      LUSOLV=40
C  Used to hold S, B, and T matrices
      LUSBT =45
      CALL DANAME_MF_wa(LUSOLV,'LUSOLV')
      CALL DANAME_MF_wa(LUSBT ,'LUSBT ')
C  Half transformed integrals (uv|rs)
      LUHLF1=50
C  Half transformed integrals (uq|xs)
      LUHLF2=60
C  Half transformed integrals (uq|rt)
      LUHLF3=70
*
      CALL DANAME_MF_wa(LUHLF1,'LUHLF1')
      CALL DANAME_MF_wa(LUHLF2,'LUHLF2')
      CALL DANAME_MF_wa(LUHLF3,'LUHLF3')

* Disk-resident arrays for equation solving:
      LUDRA=30
      CALL DANAME_MF_wa(LUDRA,'DRARR')
      LUDRATOT=31
      CALL DANAME_MF_wa(LUDRATOT,'DRARRT')
*
C-SVC: assign logical units for RHS arrays and open files for writing
      DO IVEC=1,6
        LURHS(IVEC)=50+IVEC
        write(unit=CVEC, fmt='(I2.2)') IVEC
        CALL DANAME_MF_WA(LURHS(IVEC),'RHS_'//CVEC)
      END DO
C-SVC: assign logical units for SBT arrays and open files for writing
      DO IMAT=1,4
        LUH0T(IMAT)=60+IMAT
        write(unit=CMAT, fmt='(I2.2)') IMAT
        CALL DANAME_MF_WA(LUH0T(IMAT),'H0T_'//CMAT)
      END DO
C  Temporary unit with density matrices
      LUDMAT=90
      CALL DANAME_MF_wa(LUDMAT,'LUDMAT')

*---  open the files -------------------------------------------------*
C  Job interface
C      JOBIPH=15
C      CALL DANAME(JOBIPH,'JOBIPH')
C  A new JOBIPH file
C      JOBMIX=11
C      CALL DANAME(JOBMIX,'JOBMIX')
C  Temporary unit with excited CI expansions
      LUCIEX=10
      CALL DANAME_wa(LUCIEX,'LUCIEX')
C  Temporary unit with MO one-electron integrals
      LUONEM=16
      CALL DANAME_wa(LUONEM,'MOLONE')
C  Temporary unit with MO two-electron integrals (uv|xt)
      LUINTM=80
      CALL DANAME_MF_wa(LUINTM,'MOLINT')
C  AO one-electron integrals
      Call f_Inquire('ORDINT',Found2)
      Call DecideOnDirect(.False.,Found2,IfDirect,IfChol)
      If (IfChol) then
*        IF(IPRGLB.GE.USUAL) WRITE(6,*) 'This is a Cholesky CASPT2'
      else
*        IF(IPRGLB.GE.USUAL) WRITE(6,*) 'This is a conventional CASPT2'
        iRc=-1
        iOpt=0
        Call OpnOrd(iRc,iOpt,'ORDINT',LUINTA)
        If ( iRc.ne.0 ) Then
          WRITE(6,*)'OPNFLS Error: Failed to open the ORDINT file.'
          CALL ABEND()
        End If
      End If
*----------------------------------------------------------------------*
C  Exit
*----------------------------------------------------------------------*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Thomas Bondo Pedersen                            *
!***********************************************************************

subroutine RPA_Setup_Add_Info()

! Thomas Bondo Pedersen (CTCC,UiO), July 2013.
!
! Data for RPA tests, checking the setup.
! Testing these data is as much a test of the preceding SCF run as
! a test of the RPA setup.

use RPA_globals, only: nDel, nFro, nOcc, nSym, NuclearRepulsionEnergy, nVir, OccEn, Reference, VirEn
use Constants, only: Zero
use Definitions, only: wp, iwp, r8, u6

implicit none
integer(kind=iwp) :: Tol, iUHF, l_orbitals, iSpin, iSym, ipO, ipV, i
real(kind=wp) :: Tst(8)
character(len=13) :: orbitals
character(len=*), parameter :: SecNam = 'RPA_Setup_Add_Info'
integer(kind=iwp), external :: RPA_iUHF, Cho_X_GetTol
real(kind=r8), external :: Cho_dSumElm, dDot_

! Check that molecular geometry is the expected one:
! nuclear repulsion energy
Tol = 12
call Add_Info('PotNuc',NuclearRepulsionEnergy,1,Tol)

! Check orbital spaces: sums and norms of orbital energies.
Tol = min(Cho_X_GetTol(2),2)
iUHF = RPA_iUHF()
if (iUHF == 1) then
  orbitals = ' orbital'
  l_orbitals = 8
else if (iUHF == 2) then
  orbitals = ' spin-orbital'
  l_orbitals = 13
else
  write(u6,'(A,I6)') 'iUHF=',iUHF
  call RPA_Warn(3,SecNam//': iUHF error')
  orbitals = ' '
  l_orbitals = 1
end if
Tst(:) = Zero
do iSpin=1,iUHF
  ipO = 1
  ipV = 1
  do iSym=1,nSym
    Tst(1) = Tst(1)+Cho_dSumElm(OccEn(ipO,iSpin),nFro(iSym,iSpin))
    Tst(2) = Tst(2)+dDot_(nFro(iSym,iSpin),OccEn(ipO,iSpin),1,OccEn(ipO,iSpin),1)
    ipO = ipO+nFro(iSym,iSpin)
    Tst(3) = Tst(3)+Cho_dSumElm(OccEn(ipO,iSpin),nOcc(iSym,iSpin))
    Tst(4) = Tst(4)+dDot_(nOcc(iSym,iSpin),OccEn(ipO,iSpin),1,OccEn(ipO,iSpin),1)
    ipO = ipO+nOcc(iSym,iSpin)
    Tst(5) = Tst(5)+Cho_dSumElm(VirEn(ipV,iSpin),nVir(iSym,iSpin))
    Tst(6) = Tst(6)+dDot_(nVir(iSym,iSpin),VirEn(ipV,iSpin),1,VirEN(ipV,iSpin),1)
    ipV = ipV+nVir(iSym,iSpin)
    Tst(7) = Tst(7)+Cho_dSumElm(VirEn(ipV,iSpin),nDel(iSym,iSpin))
    Tst(8) = Tst(8)+dDot_(nDel(iSym,iSpin),VirEn(ipV,iSpin),1,VirEn(ipV,iSpin),1)
    ipV = ipV+nDel(iSym,iSpin)
  end do
end do
do i=2,8,2
  Tst(i) = sqrt(Tst(i))
end do
call Add_Info(Reference//orbitals(1:l_orbitals)//' energy',Tst,8,Tol)

end subroutine RPA_Setup_Add_Info

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Bjorn O. Roos                                    *
*               1989, Per Ake Malmqvist                                *
*               1991,1993,1996, Markus P. Fuelscher                    *
************************************************************************
      Subroutine Fmat_m(CMO,PUVX,D,D1A,FI,FA)
************************************************************************
*                                                                      *
*     purpose:                                                         *
*     Update the Fock matrix for the active orbitals and transform     *
*     it to MO basis as well as the matrix FI (Fock matrix) for        *
*     frozen and inactive orbitals).                                   *
*                                                                      *
*     calling arguments:                                               *
*     CMO     : array of real*8                                        *
*               MO-coefficients                                        *
*     PUVX    : array of real*8                                        *
*               two-electron integrals (pu!vx)                         *
*     D       : array of real*8                                        *
*               averaged one-body density matrix                       *
*     D1A     : array of real*8                                        *
*               active one body density matrix in AO-basis             *
*     FI      : array of real*8                                        *
*               inactive Fock matrix                                   *
*     FA      : array of real*8                                        *
*               active Fock matrix                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     written by:                                                      *
*     B.O. Roos and P.Aa. Malmqvist                                    *
*     University of Lund, Sweden, 1989                                 *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     history:                                                         *
*     - updated for MOLCAS version 2                                   *
*       M.P. Fuelscher, University of Lund, Sweden, 1991               *
*     - updated for MOLCAS version 3                                   *
*       M.P. Fuelscher, University of Lund, Sweden, 1993               *
*     - updated for integral direct and reaction field calculations    *
*       M.P. Fuelscher, University of Lund, Sweden, 1996               *
*                                                                      *
************************************************************************

      Implicit Real*8 (A-H,O-Z)

#include "rasdim.fh"
#include "rasscf.fh"
#include "general.fh"
#include "output_ras.fh"
      Parameter (ROUTINE='FMAT    ')
#include "WrkSpc.fh"

      Dimension CMO(*) , PUVX(*) , D(*) , D1A(*) , FI(*) , FA(*)

C Local print level (if any)
      IPRLEV=IPRLOC(4)
      !iPrLev=DEBUG-1
      If ( iPrLev.ge.DEBUG ) then
        write(6,*) ('*',i=1,65)
        write(6,*) 'Entering FMAT routine called by MSCTL!'
        write(6,*) ('*',i=1,65)
        write(6,*) 'printing input matrices :'
        write(6,*) ('*',i=1,65)
        Write(LF,*)
        Write(LF,*) ' CMOs in FMAT'
        Write(LF,*) ' ---------------------'
        Write(LF,*)
         iOff=1
         Do iSym = 1,nSym
           iBas = nBas(iSym)
           call wrtmat(CMO(ioff),iBas,iBas, iBas, iBas)
           iOff = iOff + iBas*iBas
         End Do

         Write(LF,*)
         Write(LF,*) ' PUVX in FMAT'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         call wrtmat(PUVX,1,nFint, 1, nFint)

         Write(LF,*)
         Write(LF,*) ' ---------------------'
        CALL TRIPRT('Averaged one-body density matrix D, in MO in FMAT',
     &              ' ',D,NAC)

         Write(LF,*)
         Write(LF,*) ' D1A in AO basis in FMAT'
         Write(LF,*) ' ---------------------'
         Write(LF,*)
         iOff = 1
         Do iSym = 1,nSym
          iBas = nBas(iSym)
          call wrtmat(D1A(iOff),iBas,iBas, iBas, iBas)
          iOff = iOff + iBas*iBas
         End DO

         Write(LF,*)
         Write(LF,*) ' FI in AO-basis in FMAT'
         Write(LF,*) ' --------------'
         Write(LF,*)
         iOff = 1
         Do iSym = 1,nSym
           iOrb = nOrb(iSym)
           Call TriPrt(' ',' ',FI(iOff),iOrb)
           iOff = iOff + (iOrb*iOrb+iOrb)/2
         End Do

         Write(LF,*)
         Write(LF,*) ' FA in AO-basis in FMAT'
         Write(LF,*) ' --------------'
         Write(LF,*)
         iOff = 1
         Do iSym = 1,nSym
           iOrb = nOrb(iSym)
           Call TriPrt(' ',' ',FA(iOff),iOrb)
           iOff = iOff + (iOrb*iOrb+iOrb)/2
         End Do
       End If

*************************************************************
* Here we should start the real work!
*************************************************************
C Local print level (if any)
      IF(IPRLEV.ge.DEBUG) THEN
        WRITE(LF,*)' Entering ',ROUTINE
      END IF
*     create FA in AO basis
      Call GetMem('Scr1','Allo','Real',iTmp1,nTot1)
      Call Fold(nSym,nBas,D1A,Work(iTmp1))
      If(KSDFT.ne.'SCF'
     & .and. KSDFT.ne.'TLSDA'
     & .and. KSDFT.ne.'FTLSDA'
     & .and. KSDFT.ne.'TPBE'
     & .and. KSDFT.ne.'FTPBE'
     & .and. KSDFT.ne.'TOPBE'
     & .and. KSDFT.ne.'FTOPBE'
     & .and. KSDFT.ne.'TBLYP'
     & .and. KSDFT.ne.'FTBLYP'
     & .and. KSDFT.ne.'TREVPBE'
     & .and. KSDFT.ne.'FTREVPBE') NewFock=0

c     If (NewFock.eq.0) Then
c        nBMX=0
c        Do iSym=1,nSym
c           nBMX=Max(nBMX,nBas(iSym))
c        End Do
c        Call FZero(FA,nTot1)
c        Call FTwo_Drv(nSym,nBas,nAsh,nSkipX,
c    &                    Work(iTmp1),D1A,FA,nTot1,
c    &                    ExFac,nTot2,nBMX,CMO)
c     End If

*     Inactive-active contribution to ECAS
      VIA=dDot_(nTot1,FI,1,Work(iTmp1),1)
      ECAS=EMY+VIA
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,'(A,E20.10)') ' Total core energy:            ',EMY
        Write(LF,'(A,E20.10)') ' inactive-active interaction:  ',VIA
        Write(LF,'(A,E20.10)') ' CAS energy (core+interaction):',ECAS
      End If
      Call GetMem('Scr1','Free','Real',iTmp1,nTot1)

*     print FI and FA
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' FI in AO-basis in fmat'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FI(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
        Write(LF,*)
        Write(LF,*) ' FA in AO-basis in fmat'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FA(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
      End If

*     transform FI from AO to MO basis
      iOff1 = 1
      iOff2 = 1
      iOff3 = 1
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        iOrb = nOrb(iSym)
        iFro = nFro(iSym)
        Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
        Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
        Call Square(FI(iOff1),Work(iTmp1),1,iBas,iBas)
C        Call MXMA(Work(iTmp1),1,iBas,
C     &            CMO(iOff2+(iFro*iBas)),1,iBas,
C     &            Work(iTmp2),1,iBas,
C     &            iBas,iBas,iOrb)
        Call DGEMM_('N','N',iBas,iOrb,iBas,
     &               1.0d0,Work(iTmp1),iBas,
     &               CMO(iOff2+(iFro*iBas)),iBas,
     &               0.0d0,Work(iTmp2),iBas)
        Call MXMT(Work(iTmp2),iBas,1,
     &            CMO(iOff2+(iFro*iBas)),1,iBas,
     &            FI(iOff3),
     &            iOrb,iBas)
        Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
        Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
        iOff1 = iOff1 + (iBas*iBas+iBas)/2
        iOff2 = iOff2 + iBas*iBas
        iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
      End Do

*     transform FA from AO to MO basis
      iOff1 = 1
      iOff2 = 1
      iOff3 = 1
      Do iSym = 1,nSym
        iBas = nBas(iSym)
        iOrb = nOrb(iSym)
        iFro = nFro(iSym)
        Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
        Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
        Call Square(FA(iOff1),Work(iTmp1),1,iBas,iBas)
C        Call MXMA(Work(iTmp1),1,iBas,
C     &            CMO(iOff2+(iFro*iBas)),1,iBas,
C     &            Work(iTmp2),1,iBas,
C     &            iBas,iBas,iOrb)
        Call DGEMM_('N','N',iBas,iOrb,iBas,
     &               1.0d0,Work(iTmp1),iBas,
     &               CMO(iOff2+(iFro*iBas)),iBas,
     &               0.0d0,Work(iTmp2),iBas)
        Call MXMT(Work(iTmp2),iBas,1,
     &            CMO(iOff2+(iFro*iBas)),1,iBas,
     &            FA(iOff3),
     &            iOrb,iBas)
        Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
        Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
        iOff1 = iOff1 + (iBas*iBas+iBas)/2
        iOff2 = iOff2 + iBas*iBas
        iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
      End Do

c**************************************************************************
c              Add DFT part to Fock matrix:                               *
c**************************************************************************
      If(KSDFT(1:3).ne.'SCF'.and.KSDFT(1:3).ne.'PAM'.and.
     & (KSDFT(1:5).ne.'TLSDA'.and. !GLM
     &  KSDFT(1:5).ne.'TBLYP'.and.
     &  KSDFT(1:6).ne.'FTLSDA'.and.
     &  KSDFT(1:5).ne.'FTPBE'.and.
     &  KSDFT(1:6).ne.'FTOPBE'.and.
     &  KSDFT(1:5).ne.'TOPBE'.and.
     &  KSDFT(1:7).ne.'TREVPBE'.and.
     &  KSDFT(1:8).ne.'FTREVPBE'.and.
     &  KSDFT(1:6).ne.'FTBLYP'.and.
     &  KSDFT(1:4).ne.'TPBE')) Then
        ipTmpFckI=-99999
        ipTmpFckA=-99999
        Call Get_dExcdRa(ipTmpFck,nTmpFck)
        If(nTmpFck.eq.NTOT1) Then
           ipTmpFckI=ipTmpFck
        Else If(nTmpFck.eq.2*NTOT1) Then
           ipTmpFckI=ipTmpFck
           ipTmpFckA=ipTmpFck+nTot1
        Else
           Write(LF,*) ' Somethings wrong in dim. DFT',nTmpFck
           Call Abend()
        End If
        Call GetMem('ScrD1a','Allo','Real',iTmpD1A,nTot1)
        Call Fold(nSym,nBas,D1A,Work(iTmpD1A))
        VIA_DFT=dDot_(nTot1,Work(ipTmpFckI),1,Work(iTmpD1A),1)
        Call GetMem('ScrD1a','Free','Real',iTmpD1A,nTot1)
*
*          Transform alpha density from AO to MO
*
        iOff1 = 1
        iOff2 = 1
        iOff3 = 1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          iOrb = nOrb(iSym)
          iFro = nFro(iSym)
          Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
          Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
          Call Square(Work(ipTmpFckI+iOff1-1),
     &                Work(iTmp1),1,iBas,iBas)
C          Call MXMA(Work(iTmp1),1,iBas,
C     &              CMO(iOff2+(iFro*iBas)),1,iBas,
C     &              Work(iTmp2),1,iBas,
C     &              iBas,iBas,iOrb)
          Call DGEMM_('N','N',iBas,iOrb,iBas,
     &               1.0d0,Work(iTmp1),iBas,
     &               CMO(iOff2+(iFro*iBas)),iBas,
     &               0.0d0,Work(iTmp2),iBas)
          Call MXMT(Work(iTmp2),iBas,1,
     &              CMO(iOff2+(iFro*iBas)),1,iBas,
     &              Work(ipTmpFckI+iOff3-1),
     &              iOrb,iBas)
          Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
          Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
          iOff1 = iOff1 + (iBas*iBas+iBas)/2
          iOff2 = iOff2 + iBas*iBas
          iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
        End Do
*
*          Transform Active DFT Fock from AO to MO
*
        If(ipTmpFckA.ne.-99999) Then
        iOff1 = 1
        iOff2 = 1
        iOff3 = 1
        Do iSym = 1,nSym
          iBas = nBas(iSym)
          iOrb = nOrb(iSym)
          iFro = nFro(iSym)
          Call GetMem('Scr1','Allo','Real',iTmp1,iBas*iBas)
          Call GetMem('Scr2','Allo','Real',iTmp2,iOrb*iBas)
          Call Square(Work(ipTmpFckA+iOff1-1),
     &                Work(iTmp1),1,iBas,iBas)
C          Call MXMA(Work(iTmp1),1,iBas,
C     &              CMO(iOff2+(iFro*iBas)),1,iBas,
C     &              Work(iTmp2),1,iBas,
C     &              iBas,iBas,iOrb)
          Call DGEMM_('N','N',iBas,iOrb,iBas,
     &               1.0d0,Work(iTmp1),iBas,
     &               CMO(iOff2+(iFro*iBas)),iBas,
     &               0.0d0,Work(iTmp2),iBas)
          Call MXMT(Work(iTmp2),iBas,1,
     &              CMO(iOff2+(iFro*iBas)),1,iBas,
     &              Work(ipTmpFckA+iOff3-1),
     &              iOrb,iBas)
          Call GetMem('Scr2','Free','Real',iTmp2,iOrb*iBas)
          Call GetMem('Scr1','Free','Real',iTmp1,iBas*iBas)
          iOff1 = iOff1 + (iBas*iBas+iBas)/2
          iOff2 = iOff2 + iBas*iBas
          iOff3 = iOff3 + (iOrb*iOrb+iOrb)/2
        End Do
        End If
*
c        If(DFTFOCK(1:4).ne.'ROKS') Then
c          Write(LF,*) ' Just add a,b to FA,FI',DFTFOCK(1:4)
c        Else
c          Write(LF,*) ' ROKS formula',DFTFOCK(1:4)
c        End If
*
        If(DFTFOCK(1:4).ne.'ROKS') Then
          call daxpy_(NTOT1,1.0D0,Work(ipTmpFckI),1,FI,1)
          If(ipTmpFckA.ne.-99999)
     &    call daxpy_(NTOT1,1.0D0,Work(ipTmpFckA),1,FA,1)
        Else If (DFTFOCK(1:4).eq.'ROKS') Then
           iOff1 = 0
           Do iSym = 1,nSym
              Do iOrb=1,nOrb(iSym)
                 Do jOrb=1,iOrb
                    ij=iOff1+iOrb*(iOrb-1)/2+jOrb
                    If(iOrb.le.nIsh(iSym)) Then
                      FI(ij)=FI(ij)+0.5d0*
     &                  (Work(ipTmpFckI+ij-1)+Work(ipTmpFckA+ij-1))
                    End If
                    If (iOrb.gt.nIsh(iSym).and.
     &                  iOrb.le.nIsh(iSym)+nAsh(iSym)) Then
                       If (jOrb.le.nIsh(iSym)) Then
                          FI(ij)=FI(ij)+Work(ipTmpFckA+ij-1)
                       Else
                          FI(ij)=FI(ij)+0.5d0*(Work(ipTmpFckI+ij-1)+
     &                                         Work(ipTmpFckA+ij-1))
                       End If
                    End If
                    If (iOrb.gt.nIsh(iSym)+nAsh(iSym)) Then
                       If(jOrb.gt.nIsh(iSym).and.
     &                    jOrb.le.nIsh(iSym)+nAsh(iSym)) Then
                          FI(ij)=FI(ij)+Work(ipTmpFckI+ij-1)
                       Else
                          FI(ij)=FI(ij)+0.5d0*(Work(ipTmpFckI+ij-1)+
     &                                         Work(ipTmpFckA+ij-1))
                       End If

                    End If
                 End Do
              End Do
              iOff1 = iOff1 + (nOrb(iSym)*nOrb(iSym)+nOrb(iSym))/2
           End Do
        Else
           Write(LF,*) " Not implemented yet"
        End If
        Call Free_Work(ipTmpFck)
      End If
***************************************************************************
*     update Fock matrix
      If (NewFock.eq.1) Call Upd_FA_m(PUVX,FA,D,ExFac)

*     print FI and FA
      If ( iPrLev.ge.DEBUG ) then
        Write(LF,*)
        Write(LF,*) ' FI in MO-basis in fmat'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FI(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
        Write(LF,*)
        Write(LF,*) ' FA in MO-basis in fmat'
        Write(LF,*) ' --------------'
        Write(LF,*)
        iOff = 1
        Do iSym = 1,nSym
          iOrb = nOrb(iSym)
          Call TriPrt(' ',' ',FA(iOff),iOrb)
          iOff = iOff + (iOrb*iOrb+iOrb)/2
        End Do
      End If


      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine LDF_PrintAuxBasInfo(iAtomPair)
C
C     Thomas Bondo Pedersen, July 2010.
C
C     Print auxiliary basis info for atom pair iAtomPair.
C
      Implicit None
      Integer iAtomPair
#include "ldf_atom_pair_info.fh"
#include "WrkSpc.fh"

#if defined (_DEBUGPRINT_)
      Logical  LDF_AtomPairInfoIsSet
      External LDF_AtomPairInfoIsSet
#endif
      Integer  LDF_nBasAux_Pair
      Integer  LDF_nBas_Atom, LDF_nBasAux_Atom
      External LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Atom

      Integer iAtom, jAtom
      Integer n,nProducts

      Integer i, j
      Integer AP_Atoms, AP_1CLinDep, AP_2CFunctions
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)
      AP_1CLinDep(i,j)=iWork(ip_AP_1CLinDep-1+2*(j-1)+i)
      AP_2CFunctions(i,j)=iWork(ip_AP_2CFunctions-1+2*(j-1)+i)

#if defined (_DEBUGPRINT_)
      If (.not.LDF_AtomPairInfoIsSet()) Then
         Call WarningMessage(2,
     &                   'LDF_PrintAuxBasInfo: Atom Pair Info not set!')
         Call LDF_Quit(1)
      End If
      If (iAtomPair.lt.1 .or. iAtomPair.gt.NumberOfAtomPairs) Then
         Call WarningMessage(2,
     &                  'LDF_PrintAuxBasInfo: iAtomPair out of bounds!')
         Call LDF_Quit(1)
      End If
#endif

      iAtom=AP_Atoms(1,iAtomPair)
      jAtom=AP_Atoms(2,iAtomPair)
      n=LDF_nBas_Atom(iAtom)
      If (iAtom.eq.jAtom) Then
         nProducts=n*(n+1)/2
      Else
         nProducts=n*LDF_nBas_Atom(jAtom)
      End If

      Write(6,'(/,A,1X,I9)')
     & 'Atom pair....................................',iAtomPair
      Write(6,'(A,2(1X,I9))')
     & 'Atoms........................................',iAtom,jAtom
      Write(6,'(A,1X,I9)')
     & 'Number of product functions to fit...........',nProducts
      Write(6,'(A,1X,I9)')
     & 'Total number of auxiliary basis functions....',
     & LDF_nBasAux_Pair(iAtomPair)
      If (iAtom.eq.jAtom) Then
         Write(6,'(A,1X,I9)')
     &   'Total number of one-center aux functions.....',
     &   LDF_nBasAux_Atom(iAtom)
      Else
         Write(6,'(A,2(1X,I9))')
     &   'Total number of one-center aux functions.....',
     &   LDF_nBasAux_Atom(iAtom)+LDF_nBasAux_Atom(jAtom)
      End If
      Write(6,'(A,1X,I9)')
     & 'Linearly dependent one-center aux functions..',
     & AP_1CLinDep(1,iAtomPair)
      Write(6,'(A,1X,I9)')
     & 'Number of two-center auxiliary functions.....',
     & AP_2CFunctions(1,iAtomPair)

      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SubRoutine Cho_X_GenVec(irc,Diag)

      Implicit None
      Integer irc
      Real*8  Diag(*)
#include "cholesky.fh"
#include "choptr.fh"
#include "WrkSpc.fh"

      Character*12 SecNam
      Parameter (SecNam = 'Cho_X_GenVec')

      Integer MaxQual_SAVE, ip_iQuAB_SAVE, l_iQuAB_SAVE
      Integer iSym


C     Set return code.
C     ----------------

      irc = 0

C     Re-allocate the iQuAB index array, save old allocation.
C     This is used to trick the integral extraction from Seward so as to
C     reduce the number of re-calculations of shell pairs.
C     ------------------------------------------------------------------

      ip_iQuAB_SAVE = ip_iQuAB
      l_iQuAB_SAVE  = l_iQuAB
      MaxQual_SAVE  = MaxQual

      MaxQual = NumCho(1)
      Do iSym = 2,nSym
         MaxQual = Max(MaxQual,NumCho(iSym))
      End Do

      l_iQuAB = MaxQual*nSym
      Call Cho_Mem('iQuAB_2','Allo','Inte',ip_iQuAB,l_iQuAB)

C     Read initial diagonal.
C     ----------------------

      Call Cho_IODiag(Diag,2)

C     Reinitialize the number of zeroed negative diagonals.
C     Turn on damped screening for second step.
C     -----------------------------------------------------

      nNZTot = 0
      MODE_SCREEN = 1

C     Generate vectors.
C     -----------------

      Call Cho_GnVc_Drv(irc,Diag)
      If (irc .ne. 0) Then
         Write(Lupri,*) SecNam,': Cho_GnVc_Drv returned ',irc
         Go To 100 ! exit
      End If

C     De-allocations.
C     Restore original iQuAB array.
C     -----------------------------

  100 Continue
      Call Cho_Mem('iQuAB_2','Free','Inte',ip_iQuAB,l_iQuAB)
      ip_iQuAB = ip_iQuAB_SAVE
      l_iQuAB  = l_iQuAB_SAVE
      MaxQual  = MaxQual_SAVE


      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

function nvb_cvb(kbasis_loc)

use casvb_global, only: absym, ndetvb, ndetvb_fr, ndetvb2_fr, nfrag, nvb_fr, nvbr_fr
use Definitions, only: iwp

implicit none
integer(kind=iwp) :: nvb_cvb
integer(kind=iwp), intent(in) :: kbasis_loc
integer(kind=iwp) :: ifrag, ndetvb2, nvb_loc, nvbr

ndetvb = 0
ndetvb2 = 0
nvbr = 0
do ifrag=1,nfrag
  if (kbasis_loc /= 6) then
    nvb_fr(ifrag) = nvbr_fr(ifrag)
  else
    if (absym(1)) then
      nvb_fr(ifrag) = ndetvb2_fr(ifrag)
    else
      nvb_fr(ifrag) = ndetvb_fr(ifrag)
    end if
  end if
  ndetvb = ndetvb+ndetvb_fr(ifrag)
  ndetvb2 = ndetvb2+ndetvb2_fr(ifrag)
  nvbr = nvbr+nvbr_fr(ifrag)
end do

if (kbasis_loc /= 6) then
  nvb_loc = nvbr
else
  if (absym(1)) then
    nvb_loc = ndetvb2
  else
    nvb_loc = ndetvb
  end if
end if
nvb_cvb = nvb_loc

return

end function nvb_cvb

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2007, Bjorn O. Roos                                    *
************************************************************************
      SUBROUTINE AFREEZ(NSYM,NBAS,NFRO,NISH,NASH,NSSH,NDEL,NAME,
     &           NAMFRO,LNFRO,DPQ,THRFR,THRDE,IFQCAN,CMO,NCMO)
*****************************************************************************
*                                                                           *
* Purpose: to select orbitals, which will be frozen in the CASPT2           *
* calculations based on a selection of atoms controlled by the input        *
* keyword AFREeze.                                                          *
* Each inactive orbital is checked for the fraction of electrons located    *
* on the selected atoms. If smaller than a given threshold, the orbital     *
* will be frozen.                                                           *
* Called by READIN_CASPT2                                                   *
* Author: B. O. Roos in July 2007 for MOLCAS-7                              *
*     Calling parameters:                                                   *
*     NSYM   : Number of symmetries                                         *
*     NFRO   : Number of frozen orbitals (modified by the program)          *
*     NISH   : Number of inactive orbitals                                  *
*     Name   : Center and function type label per basis function            *
*     Namfro : names of atoms to be selected (length lnfro)                 *
*     Labfro : labels for orbitals to be frozen                             *
*     CMO    : Orbital coefficients                                         *
*     OccN   : Orbital occupations                                          *
*     SMat   : Overlap matrix                                               *
*     DPQ    : The charge matrix for a given orbital                        *
*     THRFR : Threshold for freezing orbitals                               *
*     THRDE : Threshold for deleting orbitals                               *
*                                                                           *
*****************************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
#include "itmax.fh"
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
*
      CHARACTER(LEN=LENIN8) NAME(*)
      CHARACTER(LEN=4) NAMFRO(*)
      DIMENSION NBAS(NSYM),NFRO(NSYM),NISH(NSYM),NASH(NSYM),NSSH(NSYM),
     &          NDEL(NSYM)
      DIMENSION LABFRO(mxbas),DPQ(*)
      REAL*8, ALLOCATABLE :: SMAT(:)
      REAL*8 CMO(*)
*
*
*----------------------------------------------------------------------*
*     GET THE TOTAL NUMBER OF BASIS FUNCTIONS, etc. AND CHECK LIMITS   *
*----------------------------------------------------------------------*
*
*      Write(6,*) 'Entering AFreez'
      NBAST=0
      ntri=0
      Do I=1,NSYM
        NBAST=NBAST+NBAS(I)
        ntri=(nbas(i)+nbas(i)**2)/2+ntri
      End Do
      IF(NBAST.GT.MXBAS) then
       Write(6,'(/6X,A)')
     & 'The number of basis functions exceeds the present limit'
       Call Abend
      Endif
*
*----------------------------------------------------------------------*
*     Read the overlap matrix                                          *
*----------------------------------------------------------------------*
      NSMAT=NTRI+6
      CALL MMA_ALLOCATE(SMAT,NSMAT)
      isymlbl=1
      Call RdOne(irc,6,'Mltpl  0',1,SMAT,isymlbl)
*
*----------------------------------------------------------------------*
*      write(6,*)'molecular orbitals before localization'
*      imo=0
*      do isym=1,nsym
*       nbi=nbas(isym)
*       do ib=1,nbi
*        write(6,*) 'orbital', isym, ib
*        write(6,'(4E18.12)') (CMO(imo+i),i=1,nbi)
*       imo=imo+nbi
*       enddo
*      enddo
*----------------------------------------------------------------------*
*     Localize the inactive and virtual orbitals                       *
*----------------------------------------------------------------------*
      Thrs=1.d-06
      Call Cho_x_Loc(irc,Thrs,nSym,nBas,nFro,nIsh,nAsh,nSsh,CMO)
      If(irc.ne.0) then
       write(6,*) 'Localization failed. The AFRE option cannot be used'
       Call Abend
      Endif
*      write(6,*)'molecular orbitals after localization'
*      imo=0
*      do isym=1,nsym
*       nbi=nbas(isym)
*       do ib=1,nbi
*        write(6,*) 'orbital', isym, ib
*        write(6,'(4E18.12)') (CMO(imo+i),i=1,nbi)
*       imo=imo+nbi
*       enddo
*      enddo
*----------------------------------------------------------------------*
*     Compute Mulliken atomic charges for each center and              *
*     each orbital.                                                    *
*----------------------------------------------------------------------*
*
      nb2=0
      Do isym=1,nsym
       nb2=nb2+nbas(isym)*(nbas(isym)+1)/2
      Enddo
*      write(6,*) 'Starting the calculation',nb2
      Do i=1,nb2
       DPQ(i)=0.0d0
      Enddo
      ib=0
      imo0=0
      ipq0=0
      Do isym=1,nsym
       nbi=nbas(isym)
       nfi=nfro(isym)
       nin=nish(isym)
       imo=imo0+nbi*nfi
       If(nin.ne.0) then
        Do i=1,nin
         labfro(i)=0
        Enddo
         Do ni=1,nin
*         write(6,*) 'loop over sym and inactive orbitals',isym,ni
          ipq=ipq0
          ipq1=0
          Do np=1,nbi
           Do nq=1,np
            ipq=ipq+1
            ipq1=ipq1+1
            DPQ(ipq1)=
     &      CMO(imo+np)*CMO(imo+nq)*SMAT(ipq)
           Enddo
          Enddo
*         DPQ is the charge matrix for orbital ni in symmetry isym
*         Now add non-diagonal elements to the diagonal
          ipq1=0
          ipp=0
          Do np=1,nbi
           ipp=ipp+np
           iqq=0
           Do nq=1,np
            iqq=iqq+nq
            ipq1=ipq1+1
            If(np.ne.nq) then
             DPQ(ipp)=DPQ(ipp)+DPQ(ipq1)
             DPQ(iqq)=DPQ(iqq)+DPQ(ipq1)
            Endif
           Enddo
          Enddo
          ipp=0
          Do np=1,nbi
           ipp=ipp+np
*          write(6,*) 'diagonal element',ipp,DPQ(ipp)
          Enddo

*         The diagonal now contains the charges for each basis function
*         Add charges for basis functions centered on the selected atoms
*         First check that the sum is equal to one
          chksum=0.0d0
          ipp=0
          Do np=1,nbi
           ipp=ipp+np
           chksum=chksum+DPQ(ipp)
          Enddo
          If(abs(chksum-1.d0).gt.1.d-08) then
           Write(6,*) 'Error on Checksum in Afreez.',
     &     'Value is not equal to 1:', isym, ni, chksum
           Write(6,*) 'Freezing extra orbitals in CASPT2 stops.'
           Call Abend
          Endif
*         Add diagonal elements that belong to selected atoms
          selch=zero
          ipp=0
          Do np=1,nbi
           ipp=ipp+np
           Do iname=1,lnfro
            if(name(ib+np)(1:4).eq.namfro(iname)) selch=selch+DPQ(ipp)
           Enddo
          Enddo
          If(abs(selch).lt.thrfr) labfro(ni)=1
*         write(6,*) selch
          imo=imo+nbi
         Enddo
*        Sort the inactive CMO's such that frozen orbitals are first.
         nfro1=nfro(isym)
         Do  ni=1,nin
          If(labfro(ni).eq.1) then
*          Exchange this orbital with the first inactive orbital
           ist1=nfro(isym)*nbi+imo0
           ist2=(nfro1+ni-1)*nbi+imo0
*          write(6,*)'nfro,nish',nfro(isym),nish(isym),ist1,ist2
           Do np=1,nbi
            Swap=CMO(ist1+np)
            CMO(ist1+np)=CMO(ist2+np)
            CMO(ist2+np)=Swap
           Enddo
           nfro(isym)=nfro(isym)+1
           nish(isym)=nish(isym)-1
          Endif
         Enddo
        Endif
        ipq0=ipq0+nbi*(nbi+1)/2
        imo0=imo0+nbi**2
        ib=ib+nbi
      Enddo
*     Now sort virtual orbitals
*     Orbitals with too low population on selected atoms will be deleted
      Do i=1,nb2
       DPQ(i)=zero
      Enddo
      ib=0
      imo0=0
      ipq0=0
      Do isym=1,nsym
       nbi=nbas(isym)
       ndi=ndel(isym)
       nsi=nssh(isym)
       nssh(isym)=0
       ndel(isym)=ndi+nsi
       imo=imo0+nbi*(nfro(isym)+nish(isym)+nash(isym))
       If(nsi.ne.0) then
        Do i=1,nsi
         labfro(i)=0
        Enddo
         Do ni=1,nsi
*         write(6,*) 'loop over sym and secondary orbitals',isym,ni
          ipq=ipq0
          ipq1=0
          Do np=1,nbi
           Do nq=1,np
            ipq=ipq+1
            ipq1=ipq1+1
            DPQ(ipq1)=
     &      CMO(imo+np)*CMO(imo+nq)*SMAT(ipq)
           Enddo
          Enddo
*         DPQ is the charge matrix for orbital ni in symmetry isym
*         Now add non-diagonal elements to the diagonal
          ipq1=0
          ipp=0
          Do np=1,nbi
           ipp=ipp+np
           iqq=0
           Do nq=1,np
            iqq=iqq+nq
            ipq1=ipq1+1
            If(np.ne.nq) then
             DPQ(ipp)=DPQ(ipp)+DPQ(ipq1)
             DPQ(iqq)=DPQ(iqq)+DPQ(ipq1)
            Endif
           Enddo
          Enddo
          ipp=0
          Do np=1,nbi
           ipp=ipp+np
*          write(6,*) 'diagonal element',ipp,DPQ(ipp)
          Enddo

*         The diagonal now contains the charges for each basis function
*         Add charges for basis functions centered on the selected atoms
*         First check that the sum is equal to one
          chksum=0.0d0
          ipp=0
          Do np=1,nbi
           ipp=ipp+np
           chksum=chksum+DPQ(ipp)
          Enddo
          If(abs(chksum-1.d0).gt.1.d-08) then
           Write(6,*) 'Error on Checksum in Afreez.',
     &     'Value is not equal to 1:', isym, ni, chksum
           Write(6,*) 'Deleting extra orbitals in CASPT2 stops.'
           Call Abend
          Endif
*         Write(6,*) 'Checksum', isym, ni, chksum
*         Add diagonal elements that belong to selected atoms
          selch=zero
          ipp=0
          Do np=1,nbi
           ipp=ipp+np
           Do iname=1,lnfro
            if(name(ib+np)(1:4).eq.namfro(iname)) selch=selch+DPQ(ipp)
           Enddo
          Enddo
          If(abs(selch).gt.thrde) labfro(ni)=1
*         write(6,*) selch
          imo=imo+nbi
         Enddo
*        Sort the CMO's such that secondary orbitals are first.
         Do  ni=1,nsi
          If(labfro(ni).eq.1) then
*          Exchange this orbital with the first deleted orbital
           ist1=(nfro(isym)+nish(isym)+nash(isym)+nssh(isym))*nbi+imo0
           ist2=(nfro(isym)+nish(isym)+nash(isym)+ni-1)*nbi+imo0
           Do np=1,nbi
            Swap=CMO(ist1+np)
            CMO(ist1+np)=CMO(ist2+np)
            CMO(ist2+np)=Swap
           Enddo
*          write(6,*)'Orbital number',ni,ist1,ist2
*           write(6,'(4E18.12)') (CMO(ist1+np),np=1,nbi)
*           write(6,'(4E18.12)') (CMO(ist2+np),np=1,nbi)
           ndel(isym)=ndel(isym)-1
           nssh(isym)=nssh(isym)+1
          Endif
         Enddo
        Endif
        ipq0=ipq0+nbi*(nbi+1)/2
        imo0=imo0+nbi**2
        ib=ib+nbi
      Enddo

*      imo=0
*      do isym=1,nsym
*       nbi=nbas(isym)
*       do ib=1,nbi
*        write(6,*) 'orbital', isym, ib
*        write(6,'(4E18.12)') (CMO(imo+i),i=1,nbi)
*       imo=imo+nbi
*       enddo
*      enddo
*     Write the resorted MO's back to JobIph
*
      IF (IFQCAN.NE.0) IFQCAN=0 ! MOs to be recanonicalized on exit

      CALL MMA_DEALLOCATE(SMAT)
      Return
*
c Avoid unused argument warnings
      If (.False.) Call Unused_integer(NCMO)
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2012, Thomas Bondo Pedersen                            *
************************************************************************
      Subroutine SetMltplCenters()
C
C     Thomas Bondo Pedersen, July 2012.
C
C     Set multipole centers.
C
      use MpmC
      use Sizes_of_Seward, only: S
      use Real_Info, only: CoM
      Implicit Real*8 (a-h,o-z)
#include "stdalloc.fh"

      ! Check
      If (S%nMltpl.lt.0) Then
         Call WarningMessage(2,'SetMltplCenters: illegal input')
         Write(6,'(A,I10)') 'S%nMltpl=',S%nMltpl
         Call Abend()
      End If

      ! Allocate center array
      Call mma_allocate(Coor_MPM,3,S%nMltpl+1,label='Coor_MPM')

      ! Set origin as center for overlap (0th order)
      Call fZero(Coor_MPM(1,1),3)

      ! Set origin as center for dipole (1st order) and
      ! center of mass as center for higher-order multipoles
      If (S%nMltpl.gt.0) Then
         Call fZero(Coor_MPM(1,2),3)
         Do i=2,S%nMltpl
            Call dCopy_(3,CoM,1,Coor_MPM(1,i+1),1)
         End Do
      End If

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1986, Per E. M. Siegbahn                               *
!               2021, Ignacio Fdez. Galvan                             *
!***********************************************************************
! 2021: Remove GOTOs

subroutine AIBJ(L0,L1,L2,L3,ITAI)

use guga_global, only: IADD10, BS3, BS4, COUP, COUP1, IA, IB, ICASE, ICH, ICOUP, ICOUP1, IJ, IOUT, IRC, IVF0, IWAY, IX, J1, J2, &
                       JM, JM1, JNDX, JRC, LN, Lu_10, MXVERT, NBUF, NMAT
use guga_util_global, only: COP, ICOP1, nCOP
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: L0(*), L1(*), L2(*), L3(*)
integer(kind=iwp), intent(_OUT_) :: ITAI(*)
integer(kind=iwp) :: I, IABIJ, IC1, IC11, IC2, IC22, ICP1, ICP2, IDIF, IFAB, IFAI, II, IID, IJJ, IJM, IJS, IN_, IN2, IND1, IND2, &
                     IND3, ISTOP, IT1, IT2, ITAIL, ITT1, ITT2, ITURN, ITYP, J, JJ, JJ1, JJD, JND1, JND2, JOJ, JTURN, KM, KM1, &
                     LTYP, NI, NJ, NUMM(7)
real(kind=wp) :: COPL, COPLA, COPLA0
logical(kind=iwp) :: first1, first2, skip1, skip2
integer(kind=iwp), external :: ICUNP

IC1 = 0      ! dummy initialize
IC2 = 0      ! dummy initialize
COPLA = Zero ! dummy initialize
do I=1,7
  NUMM(I) = 0
end do
IOUT = 0
NMAT = 0
do NI=1,LN
  do NJ=1,NI
    I = ICH(NI)
    J = ICH(NJ)
    if (I <= J) then
      I = ICH(NJ)
      J = ICH(NI)
    end if
    LTYP = 0
    IOUT = IOUT+1
    ICOP1(IOUT) = 0
    if (IOUT >= NBUF) then
      ICOP1(nCOP+1) = NBUF
      call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT = NMAT+NBUF
      IOUT = 0
    end if
    IOUT = IOUT+1
    !PAM96 ICOP1(IOUT) = ior(I,ishft(J,10))
    !ICOP1(IOUT) = I+2**10*J
    ICOP1(IOUT) = ior(I,ishft(J,10))
    if (IOUT >= NBUF) then
      ICOP1(nCOP+1) = NBUF
      call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
      call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
      NMAT = NMAT+NBUF
      IOUT = 0
    end if
    IJS = IJ(I+1)+1
    IJM = IJ(I)
    ! FIRST ORDER INTERACTION
    ! TRIPLET-VALENCE INTERACTIONS
    JTURN = 1
    ITURN = 0
    ITT1 = 2
    ITT2 = 0
    do
      IT1 = ITT1*MXVERT
      !ulf IT2 = ITT2*300
      IT2 = ITT2*MXVERT
      if (ITT2 == 0) then
        II = 0
        IID = 0
      else
        II = IRC(ITT2)
        IID = JRC(ITT2)
      end if
      JJ = IRC(ITT1)
      JJD = JRC(ITT1)
      ITYP = JTURN
      if (ITURN /= 0) ITYP = JTURN-2
      do IJJ=IJS,IJM
        ITAIL = IX(IT2+IJJ)
        if (IT1 /= IT2) call TAIL(I,IJJ,ITAI,ITAIL,L0,L1,L2,L3,IT1,IT2)
        IWAY(I) = 1
        loop_1: do
          KM = I
          J2(KM+1) = IJJ
          J1(KM+1) = IJJ
          first1 = .true.
          if (I == J) then
            skip1 = .true.
          else
            skip1 = .false.
            call LOOP1(KM,ISTOP,IT1,IT2)
            if (ISTOP == 1) exit loop_1
          end if
          loop_2: do
            if (first1 .and. (.not. skip1)) then
              KM = KM-1
              IWAY(KM) = 1
              if (KM == J) skip1 = .true.
            end if
            first1 = .false.
            if (.not. skip1) then
              call LOOP5(KM,ISTOP,IT1,IT2)
              if (ISTOP == 0) then
                first1 = .true.
                cycle loop_2
              end if
              KM = KM+1
              if (KM == I) cycle loop_1
              cycle loop_2
            end if
            skip1 = .false.
            IWAY(J) = 1
            do
              KM = J
              JM(KM) = IVF0+1
              JM1(KM) = IVF0+1
              IABIJ = 0
              if (I /= J) then
                if (ITURN == 0) call LOOP10(KM,ISTOP,IT1,IT2)
                IFAI = 1
                if (ITURN == 1) call LOOP13(KM,ISTOP,IFAI,IT1,IT2)
                if (ISTOP == 1) then
                  if (I == J) exit
                  KM = KM+1
                  if (KM == I) cycle loop_1
                  cycle loop_2
                else if (J1(KM) == J2(KM)) then
                  IABIJ = 1
                  IC1 = ICOUP(KM)
                  IC2 = ICOUP1(KM)
                  KM1 = KM+1
                  IDIF = IA(J1(KM1))-IA(J2(KM1))
                  if (IWAY(J) == 2) COPLA = COUP(J+1)
                  if ((IDIF == 0) .and. (IWAY(J) == 5)) COPLA = COUP(J+1)*BS4(IB(J2(J+1))+1)
                  if ((IDIF == 1) .and. (IWAY(J) == 4)) COPLA = COUP(J+1)*BS3(IB(J2(J+1))+1)
                end if
              else
                if (ITURN == 0) call LOOP7(KM,ISTOP,IT1,IT2)
                IFAI = 1
                if (ITURN == 1) call LOOP26(KM,ISTOP,IFAI,IT1,IT2)
                LTYP = 1
                if (IWAY(I) == 5) LTYP = 0
                if (ISTOP == 1) then
                  if (I == J) exit
                  KM = KM+1
                  if (KM == I) cycle loop_1
                  cycle loop_2
                end if
              end if
              first2 = .true.
              do
                if (first2) then
                  KM = KM-1
                  if (KM /= 0) IWAY(KM) = 1
                end if
                first2 = .false.
                if (KM /= 0) then
                  JM(KM) = IVF0+1
                  JM1(KM) = IVF0+1
                  if (ITURN == 0) call LOOP17(KM,ISTOP,IT1,IT2)
                  IFAI = 0
                  if (J1(KM+1) == J2(KM+1)) then
                    if (I == J) then
                      if (ICOUP(KM+1) == ICOUP1(KM+1)) IFAI = 1
                    else if (IABIJ /= 0) then
                      IC11 = ICOUP(KM+1)-IC1
                      IC22 = ICOUP1(KM+1)-IC2
                      if (IC11 == IC22) IFAI = 1
                    end if
                  end if
                  if (ITURN == 1) call LOOP23(KM,ISTOP,IFAI,IT1,IT2)
                  if (ISTOP == 0) then
                    first2 = .true.
                    cycle
                  end if
                else
                  COPL = COUP(1)
                  if ((JTURN >= 6) .or. (JTURN == 3)) COPL = COUP1(1)
                  IFAB = 0
                  skip2 = .false.
                  if (JTURN == 5) then
                    if ((I == J) .and. (LTYP == 1)) skip2 = .true.
                  end if
                  if ((.not. skip2) .and. (ITT1 == ITT2)) then
                    if (I == J) then
                      if ((LTYP == 1) .and. (ICOUP(1) > ICOUP1(1))) skip2 = .true.
                    else if (IABIJ /= 0) then
                      IC11 = ICOUP(1)-IC1
                      IC22 = ICOUP1(1)-IC2
                      if (IC11 == IC22) IFAB = 1
                    end if
                  end if
                  if (.not. skip2) then
                    COPLA0 = COPLA
                    if (IFAB == 0) COPLA0 = Zero
                    do IN_=1,ITAIL
                      ICP1 = ICOUP(1)+IN_
                      JND1 = JNDX(II+ICP1)
                      if (JND1 == 0) cycle
                      ICP1 = JND1-IID
                      if (ITT1 == ITT2) then
                        IN2 = IN_
                      else
                        IN2 = ITAI(IN_)
                        if (IN2 == 0) cycle
                      end if
                      ICP2 = ICOUP1(1)+IN2
                      JND2 = JNDX(JJ+ICP2)
                      if (JND2 == 0) cycle
                      ICP2 = JND2-JJD
                      if ((ITT1 == ITT2) .and. (ICP1 == ICP2)) then
                        JJ1 = (JJD+ICP1-1)*LN+I
                        JOJ = ICUNP(ICASE,JJ1)
                        if (JOJ > 1) JOJ = JOJ-1
                        COPLA0 = JOJ-2
                        IFAB = 1
                      end if
                      IOUT = IOUT+1
                      NUMM(JTURN) = NUMM(JTURN)+1
                      COP(IOUT) = COPL
                      !PAM96 IND1 = ior(IFAB,ishft(ITURN,1))
                      !PAM96 IND2 = ior(IND1,ishft(ITYP,2))
                      !PAM96 IND3 = ior(IND2,ishft(ICP1,5))
                      !PAM96 ICOP1(IOUT) = ior(IND3,ishft(ICP2,18))
                      !IND1 = IFAB+2**1*ITURN
                      !IND2 = IND1+2**2*ITYP
                      !IND3 = IND2+2**5*ICP1
                      !ICOP1(IOUT) = IND3+2**18*ICP2
                      IND1 = ior(IFAB,ishft(ITURN,1))
                      IND2 = ior(IND1,ishft(ITYP,2))
                      IND3 = ior(IND2,ishft(ICP1,5))
                      ICOP1(IOUT) = ior(IND3,ishft(ICP2,18))
                      if (IOUT >= NBUF) then
                        ICOP1(nCOP+1) = NBUF
                        call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
                        call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
                        NMAT = NMAT+NBUF
                        IOUT = 0
                      end if
                      if (IFAB == 0) cycle
                      IOUT = IOUT+1
                      NUMM(JTURN) = NUMM(JTURN)+1
                      COP(IOUT) = COPLA0
                      ICOP1(IOUT) = 1
                      if (IOUT < NBUF) cycle
                      ICOP1(nCOP+1) = NBUF
                      call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
                      call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
                      NMAT = NMAT+NBUF
                      IOUT = 0
                    end do
                  end if
                end if
                KM = KM+1
                if (KM == J) exit
              end do
            end do
            if (.true.) exit loop_2
          end do loop_2
          if (.true.) exit loop_1
        end do loop_1
      end do
      select case (JTURN)
        case default !(1)
          ! SINGLET-VALENCE INTERACTIONS
          JTURN = 2
          ITT1 = 3
        case (2)
          ! TRIPLET-TRIPLET INTERACTIONS
          JTURN = 3
          ITURN = 1
          ITT1 = 2
          ITT2 = 2
        case (3)
          ! SINGLET-SINGLET INTERACTIONS
          JTURN = 4
          ITT1 = 3
          ITT2 = 3
        case (4)
          ! TRIPLET-SINGLET INTERACTIONS
          JTURN = 5
          ITT1 = 2
          ITT2 = 3
        case (5)
          ! SINGLET-TRIPLET INTERACTIONS
          JTURN = 6
          ITT1 = 3
          ITT2 = 2
        case (6)
          ! DOUBLET-DOUBLET INTERACTIONS
          JTURN = 7
          ITT1 = 1
          ITT2 = 1
        case (7)
          exit
      end select
    end do
  end do
end do
ICOP1(nCOP+1) = IOUT
call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
NMAT = NMAT+IOUT
ICOP1(nCOP+1) = -1
call dDAFILE(Lu_10,1,COP,NCOP,IADD10)
call iDAFILE(Lu_10,1,iCOP1,NCOP+1,IADD10)
write(u6,600) NMAT
write(u6,610) (NUMM(I),I=1,7)

return

600 format(/,6X,'COEFFICIENTS FOR AIBJ',I9)
610 format(6X,'DIFFERENT TYPES',7I9)

end subroutine AIBJ

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
       SubRoutine CISigma_sa(iispin,iCsym,iSSym,ipInt1,ipint2s,
     &                    ipint2a,ipCI1,ipCI2,NT)
       Implicit Real*8(a-h,o-z)
*
#include "Pointers.fh"

#include "Input.fh"
#include "WrkSpc.fh"
#include "genop.fh"
#include "glbbas_mclr.fh"
#include "lbbas1.fh"
#include "cands.fh"
#include "detdim.fh"
#include "cstate_mclr.fh"

#include "cicisp_mclr.fh"
       Character NT
       integer kic(2),opout,nbb(8)
*
*      Interface Anders to Jeppe
*      This interface initiates Jeppes common block
*      and will make it easier to use Anders modifications
*      of the CI routines
*
*      OK first tell Jeppe where the integrals are.

       !> yma: notice the nconf1 if DMRG
*
       If (nconf1.eq.0) return
*
*      One electron integrals
*
       KAIN1=ipInt1
*
*      Two electron integrals
*      symmetric in perticle one and two
       if (ipint1.eq.ipfimo) then
        Call icopy(nsym,nbas,1,nbb,1)
       Else
         Call icopy(nsym,norb,1,nbb,1)
       End if
*
       KINT2=ipint2s
*
*      Two electron integrals
*      anti symmetric in perticle one and two
*
       KINT2a=ipint2a
*
       irefsm=iCSym
*
*      Do we have any twoelectron integrals?
*
       If (ipInt2s.eq.0) Then
         i12=1
       Else
         i12=2
       End If
*
*      Symmetry of Sigma vector
*
       iSSM=iSSym
       kic(2)=2
       if (issm.eq.State_sym) kic(2)=1
*
*      Symmetry of CI vector
*
       iCSM=iCSym
       kic(1)=2
       if (icsm.eq.State_sym) kic(1)=1
*
*      Symmetry properties of operator
*
       ndet=nint(max(xispsm(iSSym,1),xispsm(iCSym,1)))
       ndet=Max(ndet,ncsf(icsym),ncsf(issym))

       If (ndet.eq.0) Return
       iOP=iEOr(iCSM-1,iSSm-1)+1
       If (iOp.eq.1) Then
         Call iCopy(nSym,ipCM,1,iWork(kapin1),1)
       Else
         Do iS=1,nSym
          jS=iEor(iS-1,iOp-1)+1
          iWork(kapin1+is-1)=ipMat(is,jS)
         End Do
       End If
*
*      Triplet/Singlet operator
*
       ist=iispin+1
       square=.false.
*
       If (.not.page) Then
       Call GetMem('CIDET','ALLO','REAL',ipCIDET,nDet)
       Do i=0,nroots-1
       call dcopy_(nCSF(iCSM),Work(ipin(ipCI1)+i*ncsf(icsm)),1,
     &            Work(ipCIDET),1)
       Call SigmaVec(Work(ipCIDET),Work(ipin(ipci2)+i*ncsf(issm)),kic)
       Call DSCAL_(nCSF(iCSM),
     &            weight(i+1),Work(ipin(ipci2)+i*ncsf(issm)),1)
       End Do
       Call GetMem('CIDET','FREE','REAL',ipCIDET,nDet)

       Else
        irc=ipnout(ipci2)
        Call SigmaVec(Work(ipin1(ipCI1,ndet)),Work(ipin(ipci2)),kic)
        irc=opout(ipci1)
       End If
*
       Return
c Avoid unused argument warnings
      If (.False.) Call Unused_character(NT)
       End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
*----------------------------------------------------------------------*
*----------------------------------------------------------------------*
      Subroutine Oldge(iAcc,Etot,Eold,Ract,Rold)
      Implicit Real*8 (a-h,o-z)

#include "maxi.fh"
#include "qminp.fh"

      iAcc=iAcc-1
      Etot=Eold
      Ract=Rold
      icCom=0
      Do 100, i=1,nPart
        Do 101, j=1,nCent
          icCom=icCom+1
          Do 102, k=1,3
            Cordst(icCom,k)=OldGeo(icCom,k)
102       Continue
101     Continue
100   Continue
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2010,2012, Thomas Bondo Pedersen                       *
************************************************************************
      Subroutine LDF_ComputeApproximateIntegrals(Mode,Add,AB,CD,
     &                                           l_xInt_,xInt)
C
C=======================================================================
C          WARNING: THIS ROUTINE MAY REQUIRE A LOT OF MEMORY !!!
C=======================================================================
C
C     Thomas Bondo Pedersen, October 2010, January 2012
C
C     Purpose: compute integrals using local DF coefficients.
C
C     Input:
C       Mode   --- 1: robust, 2: nonrobust, 3: half-and-half
C       Add    --- .True. if result should be added to xInt
C       AB, CD --- atom pairs for which the integrals are to be computed
C
C     LDF info must be properly set up before calling this routine.
C
C     Robust representation:
C
C     (u_A v_B | k_C l_D) = sum_K_CD (u_A v_A | K_CD) * C[k_C l_D,K_CD]
C                         + sum_J_AB C[u_A v_B,J_AB] *
C                           { (k_C l_D | J_AB)
C                           - sum_K_CD (J_AB | K_CD) * C[k_C l_D,K_CD] }
C
C     Non-robust representation:
C
C     (u_A v_B | k_C l_D) = sum_J_AB C[u_A v_B,J_AB] *
C                           sum_K_CD (J_AB | K_CD) * C[k_C l_D,K_CD]
C
C     Half-and-half representation:
C
C     (u_A v_B | k_C l_D) ={sum_K_CD (u_A v_A | K_CD) * C[k_C l_D,K_CD]
C                          +sum_J_AB C[u_A v_B,J_AB] * (k_C l_D | J_AB)}
C                         *1/2
C
C     Although the three representations are equivalent when AB=CD, the
C     robust and half-and-half representation is always used if
C     requested.
C
      Implicit None
      Integer Mode
      Logical Add
      Integer AB
      Integer CD
      Integer l_xInt_
      Real*8  xInt(l_xInt_)
#include "WrkSpc.fh"
#include "ldf_atom_pair_info.fh"
#if defined (_DEBUGPRINT_)
#include "localdf_bas.fh"
#endif

      Character*31 SecNam
      Parameter (SecNam='LDF_ComputeApproximateIntegrals')

      Integer  LDF_nBas_Atom, LDF_nBasAux_Pair
      External LDF_nBas_Atom, LDF_nBasAux_Pair
#if defined (_DEBUGPRINT_)
      Logical  isSymmetric
      External isSymmetric
      Integer  LDF_nShell_Atom, LDF_lShell_Atom
      External LDF_nShell_Atom, LDF_lShell_Atom
#endif

      Integer A, B, C, D
      Integer nAB, MAB
      Integer nCD, MCD
      Integer l_xInt
      Integer ip_3Int, l_3Int
      Integer ip_2Int, l_2Int
      Integer ip_C, l_C, l_C_CD, l_C_AB
      Integer ip, l
#if defined (_DEBUGPRINT_)
      Integer ip_iAB, l_iAB
      Integer ip_iCD, l_iCD
      Integer ipA, ipB, ipC, ipD
      Integer k
      Integer ij, ji, kl, lk
      Integer iS, jS, kS, lS
      Integer iShell, jShell, kShell, lShell
      Integer nShell_A, nShell_B, nShell_C, nShell_D
      Integer n
#endif

      Integer i, j
      Integer AP_Atoms
#if defined (_DEBUGPRINT_)
      Integer nBasSh, iAB, iCD
      nBasSh(i)=iWork(ip_nBasSh-1+i)
      iAB(i,j)=iWork(ip_iAB-1+nShell_A*(j-1)+i)
      iCD(i,j)=iWork(ip_iCD-1+nShell_C*(j-1)+i)
#endif
      AP_Atoms(i,j)=iWork(ip_AP_Atoms-1+2*(j-1)+i)

      ! Get atoms of pairs
      A=AP_Atoms(1,AB)
      B=AP_Atoms(2,AB)
      C=AP_Atoms(1,CD)
      D=AP_Atoms(2,CD)

      ! Get dimensions
      nAB=LDF_nBas_Atom(A)*LDF_nBas_Atom(B)
      MAB=LDF_nBasAux_Pair(AB)
      nCD=LDF_nBas_Atom(C)*LDF_nBas_Atom(D)
      MCD=LDF_nBasAux_Pair(CD)

      ! Return if nothing to do
      If (nAB.lt.1 .or. nCD.lt.1 .or. MAB.lt.1 .or. MCD.lt.1) Return

      ! Check dimension of integral array
      l_xInt=nAB*nCD
      If (l_xInt.gt.l_xInt_) Then
         Call WarningMessage(2,
     &                SecNam//': insufficient integral array dimension')
         Call LDF_Quit(1)
      End If

      ! If integrals are not to be updated, initialize
      If (.not.Add) Call FZero(xInt,l_xInt)

      ! Separate codes for different integral representations
      If (Mode.eq.1 .or. Mode.eq.3) Then
         ! Allocate 3-index integrals
         l_3Int=max(nAB*MCD,nCD*MAB)
         Call GetMem('CAI3Int','Allo','Real',ip_3Int,l_3Int)
         ! Compute (u_A v_B | K_CD)
         Call LDF_ComputeIntegrals_uvJ_2P(AB,CD,l_3Int,Work(ip_3Int))
         ! Allocate coefficients
         l_C_AB=nAB*MAB
         l_C_CD=nCD*MCD
         l_C=max(l_C_AB,l_C_CD)
         Call GetMem('CAIC','Allo','Real',ip_C,l_C)
         ! Read coefficients for CD
         Call LDF_CIO_ReadC(CD,Work(ip_C),l_C_CD)
         ! Compute integral contribution
         ! (u_A v_B | k_C l_D) +=
         ! sum_K_CD (u_A v_B | K_CD)*C[k_C l_D,K_CD]
         Call dGeMM_('N','T',nAB,nCD,MCD,
     &               1.0d0,Work(ip_3Int),nAB,Work(ip_C),nCD,
     &               1.0d0,xInt,nAB)
         ! Compute (k_C l_D | J_AB), if needed
         If (CD.ne.AB) Then
            Call LDF_ComputeIntegrals_uvJ_2P(CD,AB,l_3Int,Work(ip_3Int))
         End If
         If (Mode.eq.1) Then ! robust, 2-index integrals needed
            ! Allocate (J_AB | K_CD)
            l_2Int=MAB*MCD
            Call GetMem('CAI2Int','Allo','Real',ip_2Int,l_2Int)
            ! Compute (J_AB | K_CD)
            Call LDF_ComputeIntegrals_JK_2P(AB,CD,l_2Int,Work(ip_2Int))
            ! Update:
            ! (k_C l_D | J_AB) -= sum_K_CD C[k_C l_D,K_CD]*(J_AB | K_CD)
            Call dGeMM_('N','T',nCD,MAB,MCD,
     &                  -1.0d0,Work(ip_C),nCD,Work(ip_2Int),MAB,
     &                  1.0d0,Work(ip_3Int),nCD)
            ! Deallocate (J_AB | K_CD)
            Call GetMem('CAI2Int','Allo','Real',ip_2Int,l_2Int)
         End If
         ! Read coefficients for AB, if different from CD
         If (CD.ne.AB) Then
            Call LDF_CIO_ReadC(AB,Work(ip_C),l_C_AB)
         End If
         ! Compute integral contribution
         ! (u_A v_B | k_C l_D) +=
         ! sum_J_AB C[u_A v_B,J_AB]*(k_C l_D | J_AB)
         Call dGeMM_('N','T',nAB,nCD,MAB,
     &               1.0d0,Work(ip_C),nAB,Work(ip_3Int),nCD,
     &               1.0d0,xInt,nAB)
         If (Mode.eq.3) Then ! half-and-half, scale by 1/2
            Call dScal_(nAB*nCD,0.5d0,xInt,1)
         End If
         ! Deallocate coefficients
         Call GetMem('CAIC','Free','Real',ip_C,l_C)
         ! Deallocate 3-index integrals
         Call GetMem('CAI3Int','Free','Real',ip_3Int,l_3Int)
      Else If (Mode.eq.2) Then ! non-robust representation
         ! Allocate (J_AB | K_CD)
         l_2Int=MAB*MCD
         Call GetMem('CAI2Int','Allo','Real',ip_2Int,l_2Int)
         ! Compute (J_AB | K_CD)
         Call LDF_ComputeIntegrals_JK_2P(AB,CD,l_2Int,Work(ip_2Int))
         ! Allocate intermediate
         l=MAB*nCD
         Call GetMem('CAIM','Allo','Real',ip,l)
         ! Allocate coefficients
         l_C_AB=nAB*MAB
         l_C_CD=nCD*MCD
         l_C=max(l_C_AB,l_C_CD)
         Call GetMem('CAIC','Allo','Real',ip_C,l_C)
         ! Read coefficients for CD
         Call LDF_CIO_ReadC(CD,Work(ip_C),l_C_CD)
         ! Compute intermediate
         ! M[[J_AB,k_C l_D] = sum_K_CD (J_AB | K_CD)*C[k_C l_D,K_CD]
         Call dGeMM_('N','T',MAB,nCD,MCD,
     &               1.0d0,Work(ip_2Int),MAB,Work(ip_C),nCD,
     &               0.0d0,Work(ip),MAB)
         ! Read coefficients for AB (if different from CD)
         If (AB.ne.CD) Then
            Call LDF_CIO_ReadC(AB,Work(ip_C),l_C_AB)
         End If
         ! Compute integrals: sum_J_AB C[u_A v_B,J_AB]*M[J_AB,k_C l_D]
         Call dGeMM_('N','N',nAB,nCD,MAB,
     &               1.0d0,Work(ip_C),nAB,Work(ip),MAB,
     &               1.0d0,xInt,nAB)
         ! Deallocate coefficients
         Call GetMem('CAIC','Free','Real',ip_C,l_C)
         ! Deallocate intermediate
         Call GetMem('CAIM','Free','Real',ip,l)
         ! Deallocate 2-index integrals
         Call GetMem('CAI2Int','Free','Real',ip_2Int,l_2Int)
      Else
         Call WarningMessage(2,SecNam//': illegal Mode')
         Call LDF_Quit(1)
      End If

#if defined (_DEBUGPRINT_)
      If (AB.eq.CD) Then
         If (.not. isSymmetric(xInt,nAB,1.0d-14)) Then
            Call WarningMessage(2,SecNam//': (AB|CD) != (CD|AB)')
            Call LDF_Quit(1)
         End If
      End If
      If (A.eq.B) Then
         nShell_A=LDF_nShell_Atom(A)
         nShell_B=nShell_A
         ipA=LDF_lShell_Atom(A)-1
         ipB=ipA
         l_iAB=nShell_A*nShell_B
         Call GetMem('DBGiAB','Allo','Inte',ip_iAB,l_iAB)
         n=0
         Do jS=1,nShell_B
            jShell=iWork(ipB+jS)
            Do iS=1,nShell_A
               iShell=iWork(ipA+iS)
               iWork(ip_iAB-1+nShell_A*(jS-1)+iS)=n
               n=n+nBasSh(iShell)*nBasSh(jShell)
            End Do
         End Do
         Do kl=1,nCD
            Do jS=1,nShell_B
               jShell=iWork(ipB+jS)
               iS=jS
               iShell=jShell
               Do j=1,nBasSh(jShell)
                  Do i=j+1,nBasSh(iShell)
                     ij=nAB*(kl-1)+iAB(iS,jS)+nBasSh(iShell)*(j-1)+i
                     ji=nAB*(kl-1)+iAB(jS,iS)+nBasSh(jShell)*(i-1)+j
                     If (abs(xInt(ij)-xInt(ji)).gt.1.0d-14) Then
                        Call WarningMessage(2,
     &                               SecNam//': [1] (AB|CD) != (BA|CD)')
                        Call LDF_Quit(1)
                     End If
                  End Do
               End Do
               Do iS=jS+1,nShell_A
                  iShell=iWork(ipA+iS)
                  Do j=1,nBasSh(jShell)
                     Do i=1,nBasSh(iShell)
                        ij=nAB*(kl-1)+iAB(iS,jS)+nBasSh(iShell)*(j-1)+i
                        ji=nAB*(kl-1)+iAB(jS,iS)+nBasSh(jShell)*(i-1)+j
                        If (abs(xint(ij)-xint(ji)).gt.1.0d-14) Then
                           Call WarningMessage(2,
     &                               SecNam//': [2] (AB|CD) != (BA|CD)')
                           Call LDF_Quit(1)
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
         Call GetMem('DBGiAB','Free','Inte',ip_iAB,l_iAB)
      End If
      If (C.eq.D) Then
         nShell_C=LDF_nShell_Atom(C)
         nShell_D=nShell_C
         ipC=LDF_lShell_Atom(C)-1
         ipD=ipC
         l_iCD=nShell_C*nShell_D
         Call GetMem('DBGiCD','Allo','Inte',ip_iCD,l_iCD)
         n=0
         Do jS=1,nShell_D
            jShell=iWork(ipD+jS)
            Do iS=1,nShell_C
               iShell=iWork(ipC+iS)
               iWork(ip_iCD-1+nShell_C*(jS-1)+iS)=n
               n=n+nBasSh(iShell)*nBasSh(jShell)
            End Do
         End Do
         Do ij=1,nAB
            Do lS=1,nShell_D
               lShell=iWork(ipD+lS)
               kS=lS
               kShell=lShell
               Do l=1,nBasSh(lShell)
                  do k=l+1,nBasSh(kShell)
                     kl=iCD(kS,lS)+nBasSh(kShell)*(l-1)+k
                     lk=iCD(lS,kS)+nBasSh(lShell)*(k-1)+l
                     kl=nAB*(kl-1)+ij
                     lk=nAB*(lk-1)+ij
                     If (abs(xInt(kl)-xInt(lk)).gt.1.0d-14) Then
                        Call WarningMessage(2,
     &                               SecNam//': [1] (AB|CD) != (AB|DC)')
                        Call LDF_Quit(1)
                     End If
                  End Do
               End Do
               Do kS=lS+1,nShell_C
                  kShell=iWork(ipC+kS)
                  Do l=1,nBasSh(lShell)
                     Do k=1,nBasSh(kShell)
                        kl=iCD(kS,lS)+nBasSh(kShell)*(l-1)+k
                        lk=iCD(lS,kS)+nBasSh(lShell)*(k-1)+l
                        kl=nAB*(kl-1)+ij
                        lk=nAB*(lk-1)+ij
                        If (abs(xInt(kl)-xInt(lk)).gt.1.0d-14) Then
                           Call WarningMessage(2,
     &                               SecNam//': [2] (AB|CD) != (AB|DC)')
                           Call LDF_Quit(1)
                        End If
                     End Do
                  End Do
               End Do
            End Do
         End Do
         Call GetMem('DBGiCD','Free','Inte',ip_iCD,l_iCD)
      End If
#endif

      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine wrtmediate(wrk,wrksize,lun,map,rc)
! this routine writes required mediate to opened unformatted file
! with number lun
! it also stores %d and %i of the given mediate
!
! lun - Logical unit number of file, where mediate will be stored (Input)
! map - given mediate (Input)
! rc  - return (error) code (Output)
!
! N.B.
! all mediates are stored as follows
! 1 - Map_Type
! 2 - one record with complete mediate

use ccsd_global, only: Map_Type
use Definitions, only: wp, iwp

#include "intent.fh"

implicit none
integer(kind=iwp), intent(in) :: wrksize, lun
real(kind=wp), intent(_IN_) :: wrk(wrksize)
type(Map_Type), intent(_IN_) :: map
integer(kind=iwp), intent(out) :: rc
integer(kind=iwp) :: length, pos0, rc1

rc = 0

!1 write map

call wrtmap(lun,map,rc1)

!2 calculate overall length

length = sum(map%d(1:map%d(0,5),2))

! write mediate in one block

if (length == 0) then
  ! RC=1 : there is nothing to write, length of mediate is 0
  rc = 1
  return
end if

pos0 = map%d(1,1)
call wri(lun,length,wrk(pos0))

return

end subroutine wrtmediate

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Giovanni Ghigo                                         *
************************************************************************
      Subroutine RowHessian(nIter,nInter,Delta)
************************************************************************
*                                                                      *
* Object: Numerical estimation of single rows and columns of Hessian   *
* Called from: RlxCtl when lRowH=.True. & iter.EQ.NmIter               *
* Author: Giovanni Ghigo, University of Torino, Italy                  *
*                                                                      *
************************************************************************
      use Slapaf_Info, only: dqInt, mRowH
      Implicit Real*8 (A-H,O-Z)
      Real*8, Allocatable:: H(:,:)
#include "stdalloc.fh"
#include "real.fh"
      Real*8 rDum(1)
*
      If (.NOT.Allocated(mRowH)) Then
         Write (6,*) 'RowHessian: .NOT.Allocated(mRowH)'
         Call Abend()
      End If

      Call mma_allocate(H,nInter,nInter,Label='H')
      Call Get_dArray('Hss_Q',H,nInter**2)
      Call Put_dArray('Hss_upd',rDum,0)
*
#ifdef _DEBUGPRINT_
      Write(6,*) 'RowHessian:'
      Call RecPrt('Initial Hessian',' ',H,nInter,nInter)
      Call RecPrt('Gradient  dqInt:','(10F9.6)', dqInt,nInter,nIter)
#endif
*
* --- Evaluate the Hessian
*
      Do iRowH = 1, SIZE(mRowH)
         iInter = mRowH(iRowH)
         If (iInter>nIter) Then
            Write (6,*) 'RowHessian: iIter>nIter'
            Call Abend()
         End If
         Do jInter = 1, nInter
            H(iInter,jInter) =
     &         (dqInt(jInter,1) -dqInt(jInter,iRowH+1)) / Delta
            H(jInter,iInter) = H(iInter,jInter)
         End Do
      EndDo
*
* --- Symmetrize
*
      Do iInter = 1, nInter
         Do jInter = 1, nInter
            dElement = (H(iInter,jInter)+H(jInter,iInter))/Two
            H(iInter,jInter) = dElement
            H(jInter,iInter) = dElement
         EndDo
      EndDo
#ifdef _DEBUGPRINT_
      Call RecPrt('Final Hessian',' ',H,nInter,nInter)
#endif
      Call Put_dArray('Hss_Q',H,nInter**2)
      Call mma_deallocate(H)
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine kotani_cvb(bikcof,ndet,ifns)
      implicit real*8 (a-h,o-z)
      dimension bikcof(ndet,ifns)
      dimension dum(1)

c
c Kotani spin functions (generated by Gram-Schmidt orthonormalization
c                        of the Rumer functions)
      call schmidtn_cvb(bikcof,ifns,dum,ndet,0)
      do 4000 k=1,ifns/2
      call dswap_(ndet,bikcof(1,k),1,bikcof(1,ifns+1-k),1)
4000  continue
      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2009, Roland Lindh                                     *
*               2010, Mickael G. Delcey                                *
*               2020, Ignacio Fdez. Galvan                             *
************************************************************************
      SubRoutine Saddle()
************************************************************************
*                                                                      *
* Object: to set up for a TS optimization with the SADDLE approach.    *
*                                                                      *
*     Author: Roland Lindh, Dep. of Theoretical Chemistry,             *
*             University of Lund, SWEDEN                               *
*             January 2009                                             *
************************************************************************
      use Basis_Info
      use Center_Info
      use external_centers
      use Sizes_of_Seward, only: S
      use Real_Info, only: E1, E2, SadStep, Shake
      use Logical_Info, only: Align_Only, Do_Align, lRP, lRP_Post
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "stdalloc.fh"
#include "SysDef.fh"
      Character*1 Mode
      Character*16 StdIn
      Logical Not_First_Iter, FindTS,Found,quadratic,Invar
#include "angstr.fh"
#include "warnings.fh"
      Character*2, Dimension(:), Allocatable :: Elm
      Real*8, Dimension(:), Allocatable :: TanVec, TmpA, W
      Real*8, Dimension(:,:), Allocatable :: Vec, MEP
      Integer, Dimension(:), Allocatable :: iStab
      Integer ipX2, ipX3
      Integer ipRef,ipOpt
      Real*8, Dimension(:,:), Allocatable :: XYZ
      Real*8 RandVect(3)
#include "periodic_table.fh"
************************************************************************
*                                                                      *
*                            Prologue                                  *
*                                                                      *
************************************************************************
*
      nSaddle_Max=100
      Delta_Max=0.10D0
      ratio=Zero
      quadratic=.false.
*
**    Avoid warnings
*
      R11=Zero
      R22=Zero
      R1R2=Zero
      iX0=-1
      iX1=-1
*
**    If lRP true in Info and Saddle block active but set to zero then
**    this is after the Saddle procedure is terminated and lRP should
**    be ignored.
*
      If (lRP) Then
         Call qpg_dArray('Saddle',Not_First_Iter,nData)
         If (Not_First_Iter.and.nData.eq.0) lRP=.False.
      End If
      lRP_Post=lRP
*                                                                      *
************************************************************************
*                                                                      *
*     Get informations about Saddle in RunFile
*
      If (lRP) Then
*
**       Find out whether the energy is assumed invariant to trans. & rot.
*
         Call Get_iScalar('System BitSwitch',iSBS)
         Invar=(iAnd(iSBS,2**7).eq.0).and.(iAnd(iSBS,2**8).eq.0)
*
         nAt = nRP / 3
         Call qpg_dArray('Saddle',Not_First_Iter,nData)
         nSaddle=2*nRP+5
         Call mma_allocate(TmpA,nSaddle,label='TmpA')
         If (Not_First_Iter) Then
            Call Get_dArray('Saddle',TmpA,nSaddle)
            Update=TmpA(2*nRP+5)
*
            If (Update.ne.One) Then
               HSR=TmpA(2*nRP+4)
               Call mma_deallocate(TmpA)
               lRP_Post=.False.
               Go To 100
            End If
            Update=Zero
*
            call dcopy_(3*nAt,TmpA(1      ),1,RP_Centers(1,1,1),1)
            call dcopy_(3*nAt,TmpA(1+3*nAt),1,RP_Centers(1,1,2),1)
            E1    =TmpA(6*nAt+1)
            E2    =TmpA(6*nAt+2)
            HSR0  =TmpA(6*nAt+3)
         Else
            dHSR=Zero ! Dummy initialize
            Update=Zero
            HSR0  = Zero ! Dummy initialize
            iOff_Iter=0
            Call Put_iScalar('iOff_Iter',iOff_Iter)
*                                                                      *
************************************************************************
*                                                                      *
*           Get the symmetry stabilizers for each center
*
            Call mma_allocate(iStab,nAt,label='iStab')
            iAt=1
            nsc=0
            Do i=1,nCnttp
               Do iCnt=1,dbsc(i)%nCntr
                  nsc=nsc+1
                  If (.Not.
     &                (dbsc(i)%pChrg.Or.dbsc(i)%Frag.Or.dbsc(i)%Aux)
     &               ) Then
                     jTmp=0
                     Do j = 1, dc(nsc)%nStab-1
                        jTmp=iOr(jTmp,dc(nsc)%iStab(j))
                     End Do
                     iStab(iAt)=jTmp
                     iAt=iAt+1
                  End If
               End Do
            End Do
*
*           Shake initial structures
*
            If (Shake.gt.Zero) Then
               Do iAt=1,nAt
                  S%nDim=0
                  Do j=0,2
                     If (iAnd(iStab(iAt),2**j).eq.0) S%nDim=S%nDim+1
                  End Do
                  If (S%nDim.gt.0) Then
                     Do iRP=1,2
                        Call Random_Vector(S%nDim,
     &                                     RandVect(1:S%nDim),.False.)
                        jDim=0
                        Do j=0,2
                           If (iAnd(iStab(iAt),2**j).eq.0) Then
                              jDim=jDim+1
                              RP_Centers(jDim,iAt,iRP)=
     &                           RP_Centers(jDim,iAt,iRP)+
     &                           Shake*RandVect(jDim)
                           End If
                        End Do
                     End Do
                  End If
               End Do
            End If
*
*           Retrieve the weights even if the structures are not
*           going to be aligned explicitly
*
            Call mma_Allocate(XYZ,3*nAt*8,2,label='XYZ')
            iReac=1
            iProd=2
            Call Expand_Coor(RP_Centers(1,1,1),nAt,XYZ(1,iReac),mAt)
            Call Expand_Coor(RP_Centers(1,1,2),nAt,XYZ(1,iProd),mAt)
            Call Qpg_dArray('Weights',Found,nData)
            If (Found.And.(nData.ge.mAt)) Then
              Call mma_allocate(W,nData,label='W')
              Call Get_dArray('Weights',W,nData)
            Else
              Call SysAbendMsg('Saddle',
     &             'No or wrong weights were found in the RUNFILE.','')
            End If
*
*           Align the reactant and product structures the first time.
*           Only if energy is invariant
*
            If (Do_Align .and. Invar) Then
* Note: this might break symmetry
               Call Superpose_w(XYZ(1,iReac),XYZ(1,iProd),W,mAt,
     &                          RMS,RMSMax)
               Call Fix_Symmetry(XYZ(1,iReac),nAt,iStab)
               Call Add_Info('RMSD',[RMS],1,6)
               Call Add_Info('RMSMax',[RMSMax],1,6)
               call dcopy_(3*nAt,XYZ(1,iReac),1,RP_Centers(1,1,1),1)
               call dcopy_(3*nAt,XYZ(1,iProd),1,RP_Centers(1,1,2),1)
*
               If (Align_Only) Then
*
**           Get the atomic symbols with symmetry unfolded
*
                  Call mma_allocate(Elm,nAt)
                  iAt=0
                  iAtSym=nAt
                  ndc=0
                  Do iCnttp=1,nCnttp
                    Do iCnt=1,dbsc(iCnttp)%nCntr
                      ndc=ndc+1
                      If (.Not.(dbsc(iCnttp)%pChrg.Or.
     &                          dbsc(iCnttp)%Frag.Or.
     &                          dbsc(iCnttp)%Aux)) Then
                        iAt=iAt+1
                        Elm(iAt)=PTab(dbsc(iCnttp)%AtmNr)
                        Do i=1,nIrrep/dc(ndc)%nStab-1
                          iAtSym=iAtSym+1
                          Elm(iAtSym)=Elm(iAt)
                        End Do
                      End If
                    End Do
                  End Do
*
                  Write (6,*)
                  Write (6,*) 'Aligned Reactants and Products'
                  Write (6,*) '=============================='
                  Write (6,*)
                  Write (6,*)
                  Write (6,*) ' Reactants / Angstrom'
                  Write (6,*) '====================='
                  Write (6,*)
                  Do iAt = 1, mAt
                     Write (6,'(A,1X,3F15.8)') Elm(iAt),
     &                     (XYZ((iAt-1)*3+jAt,iReac)*Angstr,jAt=1,3)
                  End Do
                  Write (6,*)
                  Write (6,*)
                  Write (6,*) ' Products / Angstrom'
                  Write (6,*) '===================='
                  Write (6,*)
                  Do iAt = 1, mAt
                     Write (6,'(A,1X,3F15.8)') Elm(iAt),
     &                     (XYZ((iAt-1)*3+jAt,iProd)*Angstr,jAt=1,3)
                  End Do
                  Write (6,*)
                  Write (6,*)
                  Call WarningMessage(2,'Molecular alignment completed')
                  Write (6,*)
                  iReturn=_RC_ALL_IS_WELL_
                  Call mma_deallocate(XYZ)
                  Call mma_deallocate(iStab)
                  Call mma_deallocate(W)
                  Call mma_deallocate(Elm)
                  Call ClsSew()
                  Call xQuit(iReturn)
               End If
            End If
*
            Call mma_deallocate(XYZ)
            Call mma_deallocate(iStab)
            Call mma_deallocate(W)
         End If
*                                                                      *
************************************************************************
*                                                                      *
*        Determine the distance between the two structures
*
         Call mma_allocate(iStab,nAt,label='iStab')
         iAt=1
         nsc=0
         Do i=1,nCnttp
            Do iCnt=1,dbsc(i)%nCntr
               nsc=nsc+1
               If (.Not.
     &             (dbsc(i)%pChrg.Or.dbsc(i)%Frag.Or.dbsc(i)%Aux)
     &            ) Then
                  jTmp=0
                  Do j = 1, dc(nsc)%nStab-1
                     jTmp=iOr(jTmp,dc(nsc)%iStab(j))
                  End Do
                  iStab(iAt)=jTmp
                  iAt=iAt+1
               End If
            End Do
         End Do
*
         Call mma_allocate(XYZ,3*nAt*8,2,label='XYZ')
         iRA1=1
         iRA2=2
         Call Expand_Coor(RP_Centers(1,1,1),nAt,XYZ(1,iRA1),mAt)
         Call Expand_Coor(RP_Centers(1,1,2),nAt,XYZ(1,iRA2),mAt)
         Call Qpg_dArray('Weights',Found,nData)
         If (Found.And.(nData.ge.mAt)) Then
           Call mma_allocate(W,nData,label='W')
           Call Get_dArray('Weights',W,nData)
         Else
           Call SysAbendMsg('Saddle',
     &          'No or wrong weights were found in the RUNFILE.','')
         End If
         If (.Not.Invar) Then
*
**         If the energy is not trans/rot invariant, compute the weighted
**         RMS with the current structures
*
           HSR = Zero
           wTot = Zero
           iOff = 1
           Do i = 1, mAt
             Do ixyz = 1, 3
               diff = XYZ(iOff,iRA2)-XYZ(iOff,iRA1)
               HSR = HSR + W(i)*diff**2
               iOff = iOff+1
             End Do
             wTot = wTot + W(i)
           End Do
           HSR = Sqrt( HSR/wTot )
         Else
           Call Get_RMSD_w(XYZ(1,iRA2),XYZ(1,iRA1),W,mAt,HSR)
         End If
         Call mma_deallocate(XYZ)
*
         If (E1.le.E2) Then
            Mode='R'
         Else
            Mode='P'
         End If
*
************************************************************************
*                                                                      *
*                   Determine the desired HSR                          *
*                                                                      *
************************************************************************
         If (Not_First_Iter) Then
*
**   FindTS
*
            FindTS=HSR.le.(1.5d0*SadStep)
            If (FindTS) Then
               Write (6,*) '**************************'
               Write (6,*) '* Enable TS optimization *'
               Write (6,*) '**************************'
               Update=2.0d0
               Delta=0.5D0 - 6.25D0 * (E2-E1)
               Delta=Min(Delta,0.75D0)
               Delta=Max(Delta,0.25D0)
               If (Mode.eq.'R') Then
                  HSR=(One-Delta)*HSR
               Else
                  HSR=Delta*HSR
               End If
*
**        Calculate tangent vector
*
               Call mma_allocate(TanVec,3*nAt,label='TanVec')
               If (Mode.eq.'R') Then
                 Call Calc_LSTvec(3*nAt,RP_Centers(1,1,2),
     &                                  RP_Centers(1,1,1),TanVec,Invar)
               Else
                 Call Calc_LSTvec(3*nAt,RP_Centers(1,1,1),
     &                                  RP_Centers(1,1,2),TanVec,Invar)
               End If
               Call Put_dArray('TanVec',TanVec,3*nAt)
               Call mma_deallocate(TanVec)
            Else
*
**         Try to be smart:
**         be slow the first iterations and the last ones
**         and also if large reorganisation the previous iteration
*
               Call Qpg_iScalar('nMEP',Found)
               If (Found) Then
                  quadratic=.true.
                  Call Get_iScalar('nMEP',iSaddle)
*
**        Compute some distances, used for quadratic interpolation
*
                  Call mma_Allocate(MEP,nRP,nSaddle_Max,label='MEP')
                  Call Get_dArray('MEP-Coor    ',MEP,nRP*nSaddle_Max)
                  call mma_allocate(Vec,nRP,2,label='Vec')
                  iX0=iSaddle-2
                  iX1=iSaddle-1
                  if (Mode.eq.'R') Then
                     ipX2 = 1
                     ipX3 = 2
                  Else
                     ipX2 = 2
                     ipX3 = 1
                  End If
                  If (iSaddle.lt.3) iX0=iX1
*
**        Align everything with the current structure (X2)
*
                  Call mma_Allocate(XYZ,3*nAt*8,4)
                  iXA0=1
                  iXA1=2
                  iXA2=3
                  iXA3=4
                  Call Expand_Coor(MEP(1,iX0),nAt,XYZ(1,iXA0),mAt)
                  Call Expand_Coor(MEP(1,iX1),nAt,XYZ(1,iXA1),mAt)
                  Call Expand_Coor(RP_Centers(1,1,ipX2),nAt,
     &                             XYZ(1,iXA2),mAt)
                  Call Expand_Coor(RP_Centers(1,1,ipX3),nAt,
     &                             XYZ(1,iXA3),mAt)
                  If (Invar) Then
                    Call Superpose_w(XYZ(1,iXA0),XYZ(1,iXA2),W,
     &                               mAt,RMSD,RMax)
                    Call Fix_Symmetry(XYZ(1,iXA0),nAt,iStab)
                    Call Superpose_w(XYZ(1,iXA1),XYZ(1,iXA2),W,
     &                               mAt,RMSD,RMax)
                    Call Fix_Symmetry(XYZ(1,iXA1),nAt,iStab)
                    Call Superpose_w(XYZ(1,iXA3),XYZ(1,iXA2),W,
     &                               mAt,RMSD,RMax)
                    Call Fix_Symmetry(XYZ(1,iXA3),nAt,iStab)
                  End If
                  iX0=iXA0
                  iX1=iXA1
                  iX3=iXA3
*
**       Compute deviation=(X1-X0)*(X2-X1).
**       If it is lower than 0.8, slow down and do linear interpolation
**       (the direction is probably broken)
*
                  If (iSaddle.gt.2) Then
                   call dcopy_(nRP,XYZ(1,iX1),1,Vec(1,1),1)
                   Call daxpy_(nRP,-One,XYZ(1,iX0),1,Vec(1,1),1)
                   call dcopy_(nRP,RP_Centers(1,1,ipX2),1,Vec(1,2),1)
                   Call daxpy_(nRP,-One,XYZ(1,iX1),1,Vec(1,2),1)
                   deviation=dmwdot(nAt,mAt,Vec(1,1),Vec(1,2))
                   R11=dmwdot(nAt,mAt,Vec(1,2),Vec(1,2))
                   R22=dmwdot(nAt,mAt,Vec(1,1),Vec(1,1))
                   deviation=deviation/Sqrt(R11*R22)
                   If (deviation.lt.0.85d0) Then
                     quadratic=.false.
                     dHSR=SadStep*0.8d0
                     Go To 35
                   EndIf
                  EndIf
*
**       Compute R11=(X3-X1)**2 and R22=(X2-X1)**2
*
                  call dcopy_(nRP,XYZ(1,iX3),1,Vec(1,1),1)
                  Call daxpy_(nRP,-One,XYZ(1,iX1),1,Vec(1,1),1)
                  R11 = dmwdot(nAt,mAt,Vec(1,1),Vec(1,1))
                  call dcopy_(nRP,RP_Centers(1,1,ipX2),1,Vec(1,2),1)
                  Call daxpy_(nRP,-One,XYZ(1,iX1),1,Vec(1,2),1)
                  R22 = dmwdot(nAt,mAt,Vec(1,2),Vec(1,2))
                  R1R2= dmwdot(nAt,mAt,Vec(1,2),Vec(1,1))
*
**       The direction of the previous iteration is far from the R-P direction
*
                  tmp=R1R2/(Sqrt(R11)*Sqrt(R22))
                  If (tmp.lt.0.3D0) Then
                     quadratic=.false.
                     dHSR=SadStep*0.8d0
                  ElseIf (tmp.lt.Zero) Then
                     quadratic=.false.
                     dHSR=SadStep*0.6
                  Else
                     dHSR=SadStep*1.0d0
                     If (isaddle.gt.1) Then
                        dHSR=SadStep*1.3d0
                     EndIf
                  EndIf
  35              Continue
                  Call mma_deallocate(XYZ)
                  Call mma_deallocate(MEP)
                  If (.not.quadratic) Call mma_deallocate(Vec)
*
**      Slow down close to the TS or in the first iteration
*
                  If (HSR.le.2.5d0*SadStep) Then
                     dHSR=SadStep*0.55d0
                  ElseIf (quadratic.and.(HSR.le.4.0d0*SadStep)) Then
                     dHSR=SadStep*0.75d0
                  EndIf
               Else
                  dHSR=SadStep*0.7d0
               EndIf
               Delta=dHSR/HSR
               If (Mode.eq.'P') Delta=One-Delta
               HSR=HSR-dHSR
            End If
            TmpA(6*nAt+5)=Update
            TmpA(6*nAt+4)=HSR
         Else
*                                                                      *
************************************************************************
*                                                                      *
*           This is written here only the first time around
*
            FindTS=.False.
            HSR0=HSR
*
**          Already findTS!
*
            FindTS=HSR.le.(1.5d0*SadStep)
            If (FindTS) Then
               Write (6,*) '**************************'
               Write (6,*) '* Enable TS optimization *'
               Write (6,*) '**************************'
               Update=2.0d0
               Delta=0.5D0 - 6.25D0 * (E2-E1)
               Delta=Min(Delta,0.75D0)
               Delta=Max(Delta,0.25D0)
               If (Mode.eq.'R') Then
                  HSR=(One-Delta)*HSR
               Else
                  HSR=Delta*HSR
               End If
               ratio=1.0d0
*
**        Calculate tangent vector
*
               Call mma_allocate(TanVec,3*nAt,label='TanVec')
               If (Mode.eq.'R') Then
                 Call Calc_LSTvec(3*nAt,RP_Centers(1,1,2),
     &                                  RP_Centers(1,1,1),TanVec,Invar)
               Else
                 Call Calc_LSTvec(3*nAt,RP_Centers(1,1,1),
     &                                  RP_Centers(1,1,2),TanVec,Invar)
               End If
               Call Put_dArray('TanVec',TanVec,3*nAt)
               Call mma_deallocate(TanVec)
            Else
*
**          Do not go too fast the first time
*
               dHSR=SadStep*0.7d0
               Delta=dHSR/HSR
               HSR=HSR-dHSR
               If (Mode.eq.'P') Delta=One-Delta
            End If
            call dcopy_(3*nAt,RP_Centers(1,1,1),1,TmpA(1      ),1)
            call dcopy_(3*nAt,RP_Centers(1,1,2),1,TmpA(1+3*nAt),1)
            TmpA(6*nAt+1)=E1
            TmpA(6*nAt+2)=E2
            TmpA(6*nAt+3)=HSR0
            TmpA(6*nAt+4)=HSR
            TmpA(6*nAt+5)=Update
         End If
*
         Call Put_dArray('Saddle',TmpA,nSaddle)
         Call mma_deallocate(TmpA)
*
************************************************************************
*                                                                      *
*                      Some paper work                                 *
*                                                                      *
************************************************************************
*        Set the point with the highest energy as the reference
*        structure. Put the reference structure on the runfile.
*
         Write (6,*)
         Write (6,'(A)') ' -- TS optimization a la the Saddle approach'
         If (FindTS) Then
            Write (6,'(A)') '   Last Macro iteration'
            Call Merge_Lists(Mode,nAt)
         End If
         If (Mode.eq.'R') Then
             ipRef=2
             ipOpt=1
            Write (6,'(A)') '     Reference structure: product side'
            Write (6,'(A,F15.8)') '       Associated Energy: ',E2
            Write (6,'(A)') '     Optimized structure: reactant side'
            Write (6,'(A,F15.8)') '       Associated Energy: ',E1
         Else
             ipRef=1
             ipOpt=2
            Write (6,'(A)') '     Reference structure: reactant side'
            Write (6,'(A,F15.8)') '       Associated Energy: ',E1
            Write (6,'(A)') '     Optimized structure: product side'
            Write (6,'(A,F15.8)') '       Associated Energy: ',E2
         End If
         Write (6,*)
*
*        Align the reference structure with the current structure
*
         Call mma_allocate(XYZ,3*nAt*8,2,label='XYZ')
         iRefAlign=1
         iOptExp  =2
         Call Expand_Coor(RP_Centers(1,1,ipRef),nAt,
     &                    XYZ(1,iRefAlign),mAt)
         Call Expand_Coor(RP_Centers(1,1,ipOpt),nAt,XYZ(1,iOptExp),mAt)
         If (Invar) Then
           Call Superpose_w(XYZ(1,iRefAlign),XYZ(1,iOptExp),W,
     &                      mAt,RMSD,RMax)
           Call Fix_Symmetry(XYZ(1,iRefAlign),nAt,iStab)
         End If
         Call Put_dArray('Ref_Geom',XYZ(1,iRefAlign),3*nAt)
         Call mma_deallocate(XYZ)
*                                                                      *
************************************************************************
*                                                                      *
*        Fix so that two copies of runfile, vector files, jobiph, etc.
*        are maintained correctly. This is only done the very first
*        iteration.
*
         If (.Not.Not_First_Iter) Then
            LuInput=11
            LuInput=IsFreeUnit(LuInput)
            Call StdIn_Name(StdIn)
            Call Molcas_Open(LuInput,StdIn)
*
*           Make two copies of the virgin runfile
*
            Write (LuInput,'(A)')
     &            '> CLONE $Project.RunFile $Project.Reac.RunFile'
            Write (LuInput,'(A)')
     &            '> CLONE $Project.RunFile $Project.Prod.RunFile'
            Write (LuInput,'(A)') '> RM $Project.RunFile'
*
*           Make the appropriate links for the other files.
*
            If (Mode.eq.'R') Then
               Write (LuInput,'(A)') '> EXPORT SubProject=.Reac'
            Else
               Write (LuInput,'(A)') '> EXPORT SubProject=.Prod'
            End If
            Write (LuInput,'(A)')
     &            '> CLONE $Project.GssOrb $Project$SubProject.GssOrb'
            Write (LuInput,'(A)') '> RM -FORCE $Project.GssOrb'
*
*           Signal that this is a saddle run, and the first iteration in a branch
*
            Write (LuInput,'(A)') '> EXPORT MOLCAS_SADDLE=1'
            Write (LuInput,'(A)') '> EXPORT SADDLE_FIRST=1'
            Close(LuInput)
         Else
            lRP_Post=.False.
         End If
*
************************************************************************
*                                                                      *
*       Compute the starting structure and put it into the runfile     *
*                                                                      *
************************************************************************
 30      Continue
         If (quadratic) Then
*
**       Quadratic interpolation:
**       Find the solutions of the system
*
            R1_2=R11-Two*R1R2+R22
            Delta=HSR**2*(R11*R22*R1_2+HSR**2*(R1R2**2-R11*R22))
            If (Delta.lt.Zero) Then
               Write(6,*) 'Delta is negative!!!'
               quadratic=.false.
               Go To 30
            End If
            C=(HSR**2*(Two*R1R2**2-(R11+R1R2)*R22)+
     &                  (-Two*R1R2+R22)*Sqrt(Delta))/(R11*R22*R1_2)
            D=(HSR**2*(R22-R1R2)+Sqrt(Delta))/(R22*R1_2)
*
**      Compute the next structure
*
            Call daxpy_(nRP,(C-One),Vec(1,1),1,Vec(1,1),1)
            Call daxpy_(nRP,D,Vec(1,2),1,Vec(1,1),1)
            Call mma_allocate(XYZ,3*nAt*8,2,label='XYZ')
            iRA1=1
            iRA2=2
            Call Expand_Coor(RP_Centers(1,1,1),nAt,XYZ(1,iRA1),mAt)
            Call Expand_Coor(RP_Centers(1,1,2),nAt,XYZ(1,iRA2),mAt)
            If (Mode.eq.'R') Then
              If (Invar) Then
                Call Superpose_w(XYZ(1,iRA2),XYZ(1,iRA1),W,mAt,
     &                           RMSD,RMax)
                Call Fix_Symmetry(XYZ(1,iRA2),nAt,iStab)
              End If
              Call daxpy_(nRP,One,XYZ(1,iRA2),1,Vec(1,1),1)
            Else
              If (Invar) Then
                Call Superpose_w(XYZ(1,iRA1),XYZ(1,iRA2),W,mAt,
     &                           RMSD,RMax)
                Call Fix_Symmetry(XYZ(1,iRA1),nAt,iStab)
              End If
              Call daxpy_(nRP,One,XYZ(1,iRA1),1,Vec(1,1),1)
            End If
            Call mma_deallocate(XYZ)
            j=1
            Do iCnttp=1,nCnttp
              If (.Not.dbsc(iCnttp)%pChrg.and.
     &            .Not.dbsc(iCnttp)%Frag .and.
     &            .Not.dbsc(iCnttp)%Aux) Then
                Do iCnt=1,dbsc(iCnttp)%nCntr
                  Do i=1,3
                    dbsc(iCnttp)%Coor(i,iCnt)=Vec(j,1)
                    j=j+1
                  End Do
                End Do
              End If
            End Do
            If (Not_First_Iter) Call Put_Coord_New(Vec(1,1),nAt)
            Call mma_deallocate(Vec)
         Else
*                                                                      *
************************************************************************
*                                                                      *
*        Linear interpolation
*
            Call mma_allocate(TmpA,nRP,label='TmpA')
            Call DZero(TmpA,nRP)
            Call mma_allocate(XYZ,3*nAt*8,2,label='XYZ')
            iRA1=1
            iRA2=2
            Call Expand_Coor(RP_Centers(1,1,1),nAt,XYZ(1,iRA1),mAt)
            Call Expand_Coor(RP_Centers(1,1,2),nAt,XYZ(1,iRA2),mAt)
            If (Invar) Then
              If (Mode.eq.'R') Then
                Call Superpose_w(XYZ(1,iRA2),XYZ(1,iRA1),W,mAt,
     &                           RMSD,RMax)
                Call Fix_Symmetry(XYZ(1,iRA2),nAt,iStab)
              Else
                Call Superpose_w(XYZ(1,iRA1),XYZ(1,iRA2),W,mAt,
     &                           RMSD,RMax)
                Call Fix_Symmetry(XYZ(1,iRA1),nAt,iStab)
              End If
            End If
            Call daxpy_(nRP,(One-Delta),XYZ(1,iRA1),1,TmpA,1)
            Call daxpy_(nRP,(    Delta),XYZ(1,iRA2),1,TmpA,1)
            Call mma_deallocate(XYZ)
            j=1
            Do iCnttp=1,nCnttp
              If (.Not.dbsc(iCnttp)%pChrg.and.
     &            .Not.dbsc(iCnttp)%Frag .and.
     &            .Not.dbsc(iCnttp)%Aux) Then
                Do iCnt=1,dbsc(iCnttp)%nCntr
                  Do i=1,3
                    dbsc(iCnttp)%Coor(i,iCnt)=TmpA(j)
                    j=j+1
                  End Do
                End Do
              End If
            End Do
            If (Not_First_Iter) Call Put_Coord_New(TmpA,nAt)
            Call mma_deallocate(TmpA)
         End If
*
         Call mma_deallocate(iStab)
         Call mma_deallocate(W)
*                                                                      *
************************************************************************
*                                                                      *
*        Write constraint on the runfile for slapaf to pick up later.
*
 100     Continue
         Lu_UDC=97
         Lu_UDC = IsFreeUnit(Lu_UDC)
         Call Molcas_Open(Lu_UDC,'UDC.Saddle')
         Write (Lu_UDC,*) 'R = Sphere'
         Write (Lu_UDC,*) 'Value'
         Write (Lu_UDC,*) 'R = ', HSR, ' soft'
         Write (Lu_UDC,*) 'END'
         Close(Lu_UDC)
      End If
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End
************************************************************************
************************************************************************
************************************************************************
      Real*8 function dmwdot(nAt,mAt,A,B)
      use Basis_Info
      Implicit Real*8 (a-h,o-z)
      Integer nAt,mAt
      Real*8 A(3,nAt),B(3,nAt)
      Logical Found
#include "real.fh"
#include "stdalloc.fh"
      Real*8 TMass
      Real*8, Dimension(:), Allocatable :: W
************************************************************************
*                                                                      *
*      Object : compute the weighted dot product of two vectors        *
*                                                                      *
************************************************************************
      tmp=Zero
      TMass=Zero
      Call Qpg_dArray('Weights',Found,nData)
      If (Found.And.(nData.ge.mAt)) Then
        Call mma_allocate(W,nData,label='W')
        Call Get_dArray('Weights',W,nData)
      Else
        Call SysAbendMsg('dmwdot',
     &       'No or wrong weights were found in the RUNFILE.','')
      End If
      iAt=0
      Do iCnttp = 1, nCnttp
         If (.Not.dbsc(iCnttp)%pChrg.and.
     &       .Not.dbsc(iCnttp)%Frag .and.
     &       .Not.dbsc(iCnttp)%Aux) Then
             Do iCnt = 1, dbsc(iCnttp)%nCntr
                iAt = iAt + 1
                Fact=DBLE(iDeg(A(1,iAt)))
                xMass=Fact*W(iAt)
                TMass=TMass+xMass
                Do i = 1, 3
                   tmp=tmp + xMass*A(i,iAt)*B(i,iAt)
                End Do
             End Do
         End If
      End Do
      Call mma_deallocate(W)
      dmwdot=tmp/TMass
      return
      end
************************************************************************
************************************************************************
************************************************************************
      subroutine calc_LSTvec(mynRP,Reac,Prod,TanVec,Invar)
      use Basis_Info
      use Center_Info
      Implicit Real*8 (a-h,o-z)
      Real*8 Reac(mynRP),Prod(mynRP),TanVec(mynRP),norm
      Logical Found,Invar
#include "real.fh"
#include "stdalloc.fh"
      Integer, Dimension(:), Allocatable :: iStab
      Real*8, Dimension(:), Allocatable :: W
      Real*8, Dimension(:,:), Allocatable :: XYZ
************************************************************************
*                                                                      *
*      Object : compute the LST vector, that is Reac-Prod              *
*      Of course it is not that simple, because of metric problems     *
*                                                                      *
*      M.G. Delcey     June 2010                                       *
*      Lund University                                                 *
*                                                                      *
************************************************************************
*
*     Get the symmetry stabilizers for each center
*
      nAt=mynRP/3
      Call mma_Allocate(iStab,nAt,label='iStab')
      iAt=1
      nsc=0
      Do i=1,nCnttp
         Do iCnt=1,dbsc(i)%nCntr
            nsc=nsc+1
            If (.Not.(dbsc(i)%pChrg.Or.
     &                dbsc(i)%Frag .Or.
     &                dbsc(i)%Aux)) Then
               jTmp=0
               Do j = 1, dc(nsc)%nStab-1
                  jTmp=iOr(jTmp,dc(nsc)%iStab(j))
               End Do
               iStab(iAt)=jTmp
               iAt=iAt+1
            End If
         End Do
      End Do
*
**    Align the structures and compute the vector (un-weighted)
*
      Call mma_allocate(XYZ,3*nAt*8,2)
      iReacA=1
      iProdA=2
      Call Expand_Coor(Reac,nAt,XYZ(1,iReacA),mAt)
      Call Expand_Coor(Prod,nAt,XYZ(1,iProdA),mAt)
      Call Qpg_dArray('Weights',Found,nData)
      If (Found.And.(nData.ge.mAt)) Then
        Call mma_allocate(W,nData,label='W')
        Call Get_dArray('Weights',W,nData)
      Else
        Call SysAbendMsg('calc_LSTvec',
     &       'No or wrong weights were found in the RUNFILE.','')
      End If
      If (Invar) Then
        Call Superpose_w(XYZ(1,iReacA),XYZ(1,iProdA),W,mAt,RMSD,RMax)
        Call Fix_Symmetry(XYZ(1,iReacA),nAt,iStab)
      End If
      call dcopy_(mynRP,XYZ(1,iReacA),1,TanVec,1)
      Call daxpy_(mynRP,-One,XYZ(1,iProdA),1,TanVec,1)
      Call mma_deallocate(XYZ)
      Call mma_deallocate(iStab)
      Call mma_deallocate(W)
*
**    And normalize it
*
      norm=DDot_(mynRP,TanVec,1,TanVec,1)
      Call dScal_(mynRP,One/Sqrt(norm),TanVec,1)
*     Call RecPrt('TanVec',' ',TanVec,3,nAt)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2013, Steven Vancoillie                                *
!***********************************************************************
MODULE SECOND_QUANTIZATION
  ! Implements determinants of k electrons in n (spin)orbitals as combinations
  ! (k,n) represented as bitstrings, using 32-bit integers.  Combinations are
  ! represented in lexicographic ordering, and their rank can be computed using
  ! a binomial table. The 32st bit is used for to indicate sign. All-one-bits
  ! are used to indicate annihilation (destroyed state). Excitation operators
  ! can be applied to the determinants and return the resulting determinant.

  ! Additionally, a wavefunction is represtented by a structure (derived type)
  ! consisting of determinant coefficients resulting from the direct product of
  ! separate alpha and beta determinants.

  ! Steven Vancoillie, November 2013, Lund

  USE ISO_FORTRAN_ENV, ONLY: INT64
  IMPLICIT NONE
  INTEGER, SAVE :: ONEBITS(0:255), RANKTBL(0:255,64)

CONTAINS

  RECURSIVE INTEGER FUNCTION GCD(I,J) RESULT (K)
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: I, J
    IF (J.EQ.0) THEN
      K = I
    ELSE
      K = GCD(J,MOD(I,J))
    END IF
  END FUNCTION GCD

  INTEGER FUNCTION BINOM_COEF(K,N)
    ! COMPUTE BINOMIAL COEFFICIENT
    ! RETURNS #K-SUBSETS OUT OF N CHOICES
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: K, N
    INTEGER :: I, FRAC(2), DIV
    IF (K .GT. N) THEN
      BINOM_COEF = 0_INT64
    ELSE
      FRAC = 1_INT64
      DO I=1,K
        FRAC(1) = FRAC(1) * (N-K+I)
        FRAC(2) = FRAC(2) * I
        DIV = GCD(FRAC(1),FRAC(2))
        IF (DIV.GT.1) THEN
          FRAC = FRAC / DIV
        END IF
      END DO
      BINOM_COEF = FRAC(1)/FRAC(2)
    END IF
  END FUNCTION BINOM_COEF

  INTEGER FUNCTION LEX_INIT(K,N) RESULT(C)
    ! INITIALIZE THE FIRST COMBINATION
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: K, N
    IF (K .GT. N) THEN
      C = 0
    ELSE
      C = 2_INT64**K - 1
    END IF
  END FUNCTION LEX_INIT

  INTEGER FUNCTION LEX_NEXT(C) RESULT(D)
    ! GENERATE THE NEXT LEXICOGRAPHIC BIT COMBINATION
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: C
    INTEGER :: T, S
    T = IOR(C,C-1)+1
    S = IAND(NOT(T-1),T)-1
    D = IOR(T,ISHFT(S,-(TRAILZ(C)+1)))
  END FUNCTION LEX_NEXT

  SUBROUTINE RANK_INIT
    ! INITIALIZES A RANK TABLE INDEXED AS:
    ! 1 2   3    4        8
    !         1 1-8 1-16 1-24 ... 1-56
    !  0
    !  1
    !  ...
    !  255
    ! THE ROW INDEX IS A HASH TABLE USING THE
    ! BIT REPRESENTATION OF A BYTE SECTION.
    ! THE COLUMNS REFER TO THE POSITION OF
    ! A BYTE SECTION AND THE NUMBER OF POSSIBLE
    ! PRECEDING ONE-BITS
    INTEGER :: IROW, ICOL, IBYTE, IOFFSET
    INTEGER :: IBIT, IPOS
    INTEGER :: RANK

    DO IROW = 0, 255
      ONEBITS(IROW) = 0
      DO IBIT = 0, 7
        IF (BTEST(IROW,IBIT)) THEN
          ONEBITS(IROW) = ONEBITS(IROW) + 1
        END IF
      END DO
    END DO

    DO IROW = 0, 255
      ! COMPUTE RANK FOR FIRST BYTE
      RANK = 0
      IPOS = 0
      DO IBIT = 0, 7
        IF (BTEST(IROW,IBIT)) THEN
          IPOS = IPOS + 1
          RANK = RANK + BINOM_COEF(IPOS,IBIT)
        END IF
      END DO
      ICOL = 1
      RANKTBL(IROW,ICOL) = RANK
      ! COMPUTE RANK FOR SUBSEQUENT BYTES
      ! DEPENDING ON THE NUMBER OF PRECEDING
      ! ONE-BITS IN THE PREVIOUS BYTES
      DO IBYTE = 2, 4
        DO IOFFSET = 0, 8*(IBYTE-1)
          ICOL = ICOL + 1
          ! COMPUTE RANK
          RANK = 0
          IPOS = IOFFSET
          DO IBIT = 0, 7
            IF (BTEST(IROW,IBIT)) THEN
              IPOS = IPOS + 1
              RANK = RANK + BINOM_COEF(IPOS,IBIT+8*(IBYTE-1))
            END IF
          END DO
          RANKTBL(IROW,ICOL) = RANK
        END DO
      END DO
    END DO
  END SUBROUTINE RANK_INIT

  INTEGER FUNCTION RANK_(C)
    INTEGER, INTENT(IN) :: C
    INTEGER :: BYTE(4), ONES(4)
    RANK_ = 0
    IF (C.EQ.-1) RETURN
    BYTE(1) = IBITS(C, 0,8)
    BYTE(2) = IBITS(C, 8,8)
    BYTE(3) = IBITS(C,16,8)
    BYTE(4) = IBITS(C,24,6)
    ONES(1) = ONEBITS(BYTE(1))
    ONES(2) = ONEBITS(BYTE(2)) + ONES(1)
    ONES(3) = ONEBITS(BYTE(3)) + ONES(2)
    RANK_ = 1 + RANKTBL(BYTE(1), 1)     &
          & + RANKTBL(BYTE(2), 2+ONES(1)) &
          & + RANKTBL(BYTE(3),11+ONES(2)) &
          & + RANKTBL(BYTE(4),28+ONES(3))
  END FUNCTION RANK_

  INTEGER FUNCTION EX1(P,Q,C) RESULT(D)
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: P, Q, C
    INTEGER :: T
    D = C
    IF (.NOT.BTEST(D,Q-1)) THEN
      D = -1
      RETURN
    END IF
    D = IBCLR(D,Q-1)
    IF (BTEST(D,P-1)) THEN
      D = -1
      RETURN
    END IF
    D = IBSET(D,P-1)
    IF(P.GT.Q) THEN
      T=IBITS(D,Q,P-Q-1)
    ELSE IF (P.LT.Q) THEN
      T=IBITS(D,P,Q-P-1)
    ELSE
      RETURN
    END IF
    DO WHILE (T.NE.0)
      D = IEOR(ISHFT(IAND(T,1),31),D)
      T = ISHFT(T,-1)
    END DO
  END FUNCTION EX1

  INTEGER FUNCTION ANN(P,C) RESULT(D)
    ! operates on determinant C with (â_p)
    ! and returns the resulting determinant with
    ! the sign in the highest bit (1 = negative)
    INTEGER, INTENT(IN) :: P, C
    INTEGER :: T
    IF (.NOT.BTEST(C,P-1)) THEN
      D = -1
      RETURN
    END IF
    D = IBCLR(C,P-1)
    T = IBITS(D,0,P-1)
    T = IEOR(T,ISHFT(T,-16))
    T = IEOR(T,ISHFT(T,-8))
    T = IEOR(T,ISHFT(T,-4))
    T = IAND(T,INT(B'1111'))
    T = IAND(ISHFT(INT(Z'6996'),-T),1)
    D = IEOR(ISHFT(T,31),D)
  END FUNCTION ANN

  INTEGER FUNCTION CRE(P,C) RESULT(D)
    ! operates on determinant C with (â†_p)
    ! and returns the resulting determinant with
    ! the sign in the highest bit (1 = negative)
    INTEGER, INTENT(IN) :: P, C
    INTEGER :: T
    IF (BTEST(C,P-1)) THEN
      D = -1
      RETURN
    END IF
    D = IBSET(C,P-1)
    T = IBITS(D,0,P-1)
    T = IEOR(T,ISHFT(T,-16))
    T = IEOR(T,ISHFT(T,-8))
    T = IEOR(T,ISHFT(T,-4))
    T = IAND(T,INT(B'1111'))
    T = IAND(ISHFT(INT(Z'6996'),-T),1)
    D = IEOR(ISHFT(T,31),D)
  END FUNCTION CRE

  INTEGER FUNCTION ANN2(P,Q,C) RESULT(D)
    ! operates on determinant C with (â_p â_q)
    ! and returns the resulting determinant with
    ! the sign in the highest bit (1 = negative)
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: P, Q, C
    INTEGER :: T
    IF (.NOT.(BTEST(C,Q-1).AND.BTEST(C,P-1))) THEN
      D = -1
      RETURN
    END IF
    D = IBCLR(C,Q-1)
    D = IBCLR(D,P-1)
    IF(Q.LT.P) THEN
      T=IBITS(D,Q,P-Q-1)
    ELSE IF (P.LT.Q) THEN
      T=IBITS(D,P,Q-P-1)
      D=IEOR(ISHFT(1,31),D)
    ELSE
      D = -1
      RETURN
    END IF
    T = IEOR(T,ISHFT(T,-16))
    T = IEOR(T,ISHFT(T,-8))
    T = IEOR(T,ISHFT(T,-4))
    T = IAND(T,INT(B'1111'))
    T = IAND(ISHFT(INT(Z'6996'),-T),1)
    D = IEOR(ISHFT(T,31),D)
  END FUNCTION ANN2

  INTEGER FUNCTION CRE2(P,Q,C) RESULT(D)
    ! operates on determinant C with (â†_p â†_q)
    ! and returns the resulting determinant with
    ! the sign in the highest bit (1 = negative)
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: P, Q, C
    INTEGER :: T
    IF ((BTEST(C,Q-1).OR.BTEST(C,P-1))) THEN
      D = -1
      RETURN
    END IF
    D = IBSET(C,Q-1)
    D = IBSET(D,P-1)
    IF(Q.LT.P) THEN
      T=IBITS(D,Q,P-Q-1)
      D=IEOR(ISHFT(1,31),D)
    ELSE IF (P.LT.Q) THEN
      T=IBITS(D,P,Q-P-1)
    ELSE
      D = -1
      RETURN
    END IF
    T = IEOR(T,ISHFT(T,-16))
    T = IEOR(T,ISHFT(T,-8))
    T = IEOR(T,ISHFT(T,-4))
    T = IAND(T,INT(B'1111'))
    T = IAND(ISHFT(INT(Z'6996'),-T),1)
    D = IEOR(ISHFT(T,31),D)
  END FUNCTION CRE2

  SUBROUTINE TEST_OPERATORS
    ! test routine for evaluation the creation and annihilation operators
    INTEGER :: NEL, NORB
    INTEGER :: NDET, IDET, DET, TMP
    INTEGER :: P

    ! test on 3in5
    NEL=3
    NORB=5

    NDET=BINOM_COEF(NEL,NORB)

    WRITE(*,*) 'Annihilation'
    DET=LEX_INIT(NEL,NORB)
    DO IDET=1,NDET
      WRITE(*,'(1X,B5.5)') IBITS(DET,0,5)
      DO P=1,NORB
        TMP=ANN(P,DET)
        IF (TMP.NE.-1) THEN
          WRITE (*,'(1X,2I3,1X,B5.5)') P, SIGN(1,TMP), IBITS(TMP,0,5)
        END IF
      END DO
      DET=LEX_NEXT(DET)
    END DO
    WRITE(*,*) 'Creation'
    DET=LEX_INIT(NEL,NORB)
    DO IDET=1,NDET
      WRITE(*,'(1X,B5.5)') IBITS(DET,0,5)
      DO P=1,NORB
        TMP=CRE(P,DET)
        IF (TMP.NE.-1) THEN
          WRITE (*,'(1X,2I3,1X,B5.5)') P, SIGN(1,TMP), IBITS(TMP,0,5)
        END IF
      END DO
      DET=LEX_NEXT(DET)
    END DO

  END SUBROUTINE TEST_OPERATORS

END MODULE SECOND_QUANTIZATION

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE CHO_OPFVEC(ISYM,IOPT)
C
C     Purpose: open/close files for full storage vectors, sym. ISYM.
C
#include "implicit.fh"
#include "cholesky.fh"
#include "choreo.fh"

      CHARACTER*10 SECNAM
      PARAMETER (SECNAM = 'CHO_OPFVEC')

      CHARACTER*6 FNAME

      MULD2H(I,J)=IEOR(I-1,J-1)+1

      IF (IOPT .EQ. 0) THEN
         DO ISYMA = 1,NSYM
            DO ISYMB = 1,ISYMA
               LUFV(ISYMA,ISYMB) = -1
               LUFV(ISYMB,ISYMA) = -1
            END DO
         END DO
      ELSE IF (IOPT .EQ. 1) THEN
         DO ISYMB = 1,NSYM
            ISYMA = MULD2H(ISYMB,ISYM)
            IF (ISYMA .GE. ISYMB) THEN
               WRITE(FNAME,'(A4,I1,I1)') REONAM,ISYMA,ISYMB
               LUNIT = 7
               CALL DANAME_MF_WA(LUNIT,FNAME)
               LUFV(ISYMA,ISYMB) = LUNIT
               LUFV(ISYMB,ISYMA) = LUNIT
            END IF
         END DO
      ELSE IF (IOPT .EQ. 2) THEN
         DO ISYMB = 1,NSYM
            ISYMA = MULD2H(ISYMB,ISYM)
            IF (ISYMA .GE. ISYMB) THEN
               LUNIT = LUFV(ISYMA,ISYMB)
               CALL DACLOS(LUNIT)
               LUFV(ISYMA,ISYMB) = -1
               LUFV(ISYMB,ISYMA) = -1
            END IF
         END DO
      ELSE
         CALL CHO_QUIT('IOPT error in '//SECNAM,104)
      END IF

      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Yannick Carissan                                       *
!***********************************************************************

subroutine ComputeFunc(nAtoms,nOrb2Loc,PA,Functional,Debug)
! Author: Y. Carissan

use Constants, only: Zero
use Definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp), intent(in) :: nAtoms, nOrb2Loc
real(kind=wp), intent(in) :: PA(nOrb2Loc,nOrb2Loc,nAtoms)
real(kind=wp), intent(out) :: Functional
logical(kind=iwp), intent(in) :: Debug
integer(kind=iwp) :: iAt, iMO_s

Functional = Zero
do iAt=1,nAtoms
  do iMO_s=1,nOrb2Loc
    Functional = Functional+PA(iMO_s,iMO_s,iAt)**2
  end do
end do

if (Debug) then
  write(u6,*) 'ComputeFunc: Functional: ',Functional
end if

return

end subroutine ComputeFunc

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1993, Roland Lindh                                     *
************************************************************************
      SubRoutine Picky(Din,n,m,nijPrm,nijCmp,nDCR,nSt,nEnd,mSt,mEnd,
     &                 Dout)
************************************************************************
*     Author: Roland Lindh, Dept. of Theoretical Chemistry,            *
*             University of Lund, SWEDEN                               *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "print.fh"
#include "real.fh"
      Real*8 Din(((n*m+1)*nijCmp)+nijPrm+1,nDCR),
     &       Dout((((nEnd-nSt+1)*(mEnd-mSt+1)+1)*nijCmp)+nijPrm+1, nDCR)
*
*-----Statement function
*
      ij1(i,j,k) = (k-1)*(n*m+1) + (j-1)*n + i
      ij2(i,j,k) = (k-1)*((nEnd-nSt+1)*(mEnd-mSt+1)+1) +
     &             (j-1)*(nEnd-nSt+1) + i
*
      iRout = 236
      iPrint = nPrint(iRout)
*     Call GetMem('Enter Picky','Check','Real',iDum,iDum)
*
      If (nSt.eq.1.and.nEnd.eq.n .and.
     &    mSt.eq.1.and.mEnd.eq.m) Then
*--------Copy the whole block
         call dcopy_((((n*m+1)*nijCmp)+nijPrm+1)*nDCR,Din,1,Dout,1)
      Else
         iIn = (n*m+1)*nijCmp
         iOut = (((nEnd-nSt+1)*(mEnd-mSt+1)+1)*nijCmp)
*--------Loop over desymmetrized density blocks
         Do 1 iDCR = 1, nDCR
*-----------Loop over angular combinations
            Do 10 ijCmp= 1, nijCmp
               jm = 0
*--------------Loop over subset of contracted basis
               Do 20 im = mSt, mEnd
                  jm = jm + 1
                  jn = 0
*-----------------Loop over subset of contracted basis
                  Do 30 in = nSt, nEnd
                     jn = jn + 1
                     Dout(ij2(jn,jm,ijCmp),iDCR) =
     &                   Din(ij1(in,im,ijCmp),iDCR)
 30               Continue
 20            Continue
*--------------Move the largest density matrix element for
*              this angular combination
c              jIn = nijCmp*(n*m+1)
c              jOut= nijCmp*((nEnd-nSt+1)*(mEnd-mSt+1)+1)
               jIn = ij1(n,m,ijCmp)+1
               jOut= ij2(nEnd-nSt+1,mEnd-mSt+1,ijCmp)+1
               Dout(jOut,iDCR) = Din(jIn,iDCR)
 10         Continue
*-----------Move the largest density matrix element for
*           each pair plus the overall largest element
            call dcopy_(nijPrm+1,Din(iIn+1,iDCR),1,
     &                         Dout(iOut+1,iDCR),1)
 1       Continue
      End If
*
*     Call GetMem('Exit Picky','Check','Real',iDum,iDum)
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004, Alexander Wolf                                   *
*               2004,2007, Markus Reiher                               *
************************************************************************
      subroutine setup_matrices (nbas,isize,vv,nn,dd,yy,ff,gg,pp,xx,
     *                           ii,jj,kk,ll,mm,aa,rr,e,scrno2,
     *                           scr8,no_prop,nbasp,nbaso,dkhadr,
     *                           adrmem,dkh_48,adrnext)
c
************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2).
c     It completes what has been started in calc_E1().
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.2.0
c
c   last modified: 13.03.2007 (M. Reiher, ETH Zurich)
c          * only tiny changes but one may optimize this routine
c            by replacing all hand-made matrix routines by library routines
c          * no_prop and nbasp introduced
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c************************************************************************
c
      implicit none
#include "dkhparameters.fh"
#include "WrkSpc.fh"
c
      integer nbas,isize,scrno2,nbasp,nbaso,iscr
      REAL*8 vv(nbaso,nbaso),nn(nbaso,nbaso),dd(nbaso,nbaso),
     *                 yy(nbaso,nbaso),ff(nbaso,nbaso),gg(nbaso,nbaso),
     *                 xx(nbasp,nbasp),
     *                 ii(nbasp,nbasp),jj(nbasp,nbasp),kk(nbasp,nbasp),
     *                 ll(nbasp,nbasp),mm(nbasp,nbasp),aa(nbas),
     *                 rr(nbas),pp(nbas),e(nbas),scr8(isize,scrno2)
      logical no_prop
c
      integer dkh_48,adrmem
      integer one,two,dkhadr(adrmem),adr,adrnext
      parameter(one=1,two=2)
c
c-----------------------------------------------------------------------
c
c    V    vv(nbas,nbas)  :  external electron--nucleus potential
c    N    nn(nbas,nbas)  :  damped potential V~ = vv(i,j)/(e(i)+e(j))
c    D    dd(nbas,nbas)  :  PVP
c    Y    yy(nbas,nbas)  :  [PVP] = PVP(i,j)/(e(i)+e(j))
c    F    ff(nbas,nbas)  :  E01 = E_1 = even term of first order
c    G    gg(nbas,nbas)  :  PE01P = P*E_1*P
c
c    X    xx(nbas,nbas)  :  nr property matrix X
c    I    ii(nbas,nbas)  :  damped property X~ = xx(i,j)/(e(i)+e(j))
c    J    jj(nbas,nbas)  :  PXP
c    K    kk(nbas,nbas)  :  [PXP] = PXP(i,j)/(e(i)+e(j))
c    L    ll(nbas,nbas)  :  CEO=Xeven(0)
c    M    mm(nbas,nbas)  :  P(CE0)P
c    ... if existing, otherwise nbasp=1
c
c  Note: store vv=V, dd=pVp, xx=X, jj=pXp  for set up of tilde terms
c
      if (Out_Of_Core) then
CMR
CMR     allocation can be skipped if aa() or rr(), which are no longer
CMR     needed in this revised routine, are destroyed
CMR
        call GetMem('SetMat1 ','ALLO','REAL',iscr,isize+4)
        adr=dkhadr(1)
        call ddafile(dkh_48,two,work(iscr),isize,adr)
        call mat_1_over_h_tri (work(iscr),nbas,e)
        dkhadr(5)=adrnext
        adr=dkhadr(5)
        call ddafile(dkh_48,one,work(iscr),isize,adr)
        dkhadr(6)=adr
c
        adr=dkhadr(2)
        call ddafile(dkh_48,two,work(iscr),isize,adr)
        call mat_1_over_h_tri (work(iscr),nbas,e)
        adr=dkhadr(6)
        call ddafile(dkh_48,one,work(iscr),isize,adr)
c
        dkhadr(7)=adr
        call ddafile(dkh_48,one,scr8(1,1),isize,adr)
        dkhadr(8)=adr
        call ddafile(dkh_48,one,scr8(1,2),isize,adr)
        adrnext=adr
      else
        call mat_copy (nn,nbas,nbas,vv)
        call mat_copy (yy,nbas,nbas,dd)
        call mat_1_over_h (nn,nbas,e)
        call mat_1_over_h (yy,nbas,e)
        call mat_sq_from_t (ff,nbas,scr8(1,1))
        call mat_sq_from_t (gg,nbas,scr8(1,2))
      end if
c
      if (.not.no_prop) then
        if (Out_Of_Core) then
          adr=dkhadr(3)
          call ddafile(dkh_48,two,work(iscr),isize,adr)
          call mat_1_over_h_tri (work(iscr),nbas,e)
          dkhadr(9)=adrnext
          adr=dkhadr(9)
          call ddafile(dkh_48,one,work(iscr),isize,adr)
          dkhadr(10)=adr
c
          adr=dkhadr(4)
          call ddafile(dkh_48,two,work(iscr),isize,adr)
          call mat_1_over_h_tri (work(iscr),nbas,e)
          adr=dkhadr(10)
          call ddafile(dkh_48,one,work(iscr),isize,adr)
          dkhadr(11)=adr
c
          call ddafile(dkh_48,one,scr8(1,3),isize,adr)
          dkhadr(12)=adr
          call ddafile(dkh_48,one,scr8(1,4),isize,adr)
          adrnext=adr
c
        else
          call mat_copy (ii,nbasp,nbasp,xx)
          call mat_copy (kk,nbasp,nbasp,jj)
          call mat_1_over_h (ii,nbasp,e)
          call mat_1_over_h (kk,nbasp,e)
          call mat_sq_from_t (ll,nbasp,scr8(1,3))
          call mat_sq_from_t (mm,nbasp,scr8(1,4))
        end if
      end if
c
      if (Out_Of_Core)
     *  call GetMem('SetMat1 ','FREE','REAL',iscr,isize+4)
c
      return
c Avoid unused argument warnings
      if (.false.) then
        call Unused_real_array(pp)
        call Unused_real_array(aa)
        call Unused_real_array(rr)
      end if
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Jeppe Olsen                                            *
!***********************************************************************

subroutine GTSTTP_2(ICLS,IEL1,IEL3,ITYPE)
! Relation between number of electrons in RAS1, RAS3 and string type
!
! GET IEL1,IEL3 : Number of electrons of class ICLS of type ITYPE
!
! Jeppe Olsen, Another lonely night in Lund

use Str_Info, only: ITYP_Dummy, Str
use Definitions, only: iwp

implicit none
integer(kind=iwp), intent(in) :: ICLS, ITYPE
integer(kind=iwp), intent(out) :: IEL1, IEL3

call GTSTTPS_2(IEL1,IEL3,Str(min(ICLS,ITYP_Dummy))%EL1,Str(min(ICLS,ITYP_Dummy))%EL3,ITYPE)

end subroutine GTSTTP_2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      subroutine m1kernel(Final,Hess,nHess,DAO,nDAO,
     &                    iAng,nRys,nZeta,
     &                    Alpha,Beta,Zeta,ZInv,
     &                    rKappa,P,TC,Coor,CoorAc,
     &                    Array,nArray,
     &                    ifgrd,indgrd,ifhss,indhss,
     &                    ifg,tr,nop,iuvwx,
     &                    kCnttp,fact,loper,idcar)

      use Real_Spherical
      use Basis_Info
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
      External TNAI1, Fake, Cff2D
#include "Molcas.fh"
#include "real.fh"
#include "WrkSpc.fh"
#include "print.fh"
#include "disp.fh"

      Integer iAng(4),nop(4),iuvwx(4)
      Real*8 Alpha(nZeta),Beta(nZeta),Zeta(nZeta),
     &        ZInv(nZeta),rKappa(nZeta),P(nZeta,*),
     &        TC(3),Coor(3,4),Array(nArray),Final(*),
     &        CoorAC(3,2), coori(3,4),Hess(*),DAO(nzeta,*)
      Logical ifg(4),tr(4),ifgrd(3,4),ifhss(3,4,3,4),eq,
     &         jfgrd(3,4),jfg(4),lGrad,lHess,jfhss(3,4,3,4)
      Integer indgrd(3,4,0:7),index(3,4),indhss(3,4,3,4,8),
     &        jndgrd(3,4,0:7),jndhss(3,4,3,4,8)

      nElem(ixyz) = (ixyz+1)*(ixyz+2)/2

      iprint = 0
      lGrad = idcar.ne.0
      lHess = nHess.ne.0
      call dcopy_(12,coor,1,coori,1)
      If (.Not.EQ(coor(1,1),coor(1,2)) .or.
     &    .Not.EQ(coor(1,1),coor(1,3))) Then
         Coori(1,1) = Coori(1,1)+One
      End If

      ip=1
      ipK = ip
      ip = ip + nZeta
      ipZ = ip
      ip = ip + nZeta
      ipZI = ip
      ip = ip + nZeta
      ipPx = ip
      ip = ip + nZeta
      ipPy = ip
      ip = ip + nZeta
      ipPz = ip
      ip = ip + nZeta
      ipDAO = ip
      ip = ip + nDAO*nZeta
      if (ip.ge.narray) then
        write(6,*) 'Out of memory in m1kernel (',narray,',',ip,')'
        Call Abend()
      endif



      if (iprint.ge.49)
     &  Write(6,*)'nM1=',dbsc(kCnttp)%nM1,'kCnttp=',kCnttp

      Do 1011 iM1xp=1, dbsc(kCnttp)%nM1
           Gamma =   dbsc(kCnttp)%M1xp(iM1xp)
           FactECP = dbsc(kCnttp)%M1cf(iM1xp)* Fact


           if (iprint.ge.49) then
              write(6,*) 'Fact=',FactECP,Fact
              write(6,*) 'im1xp=',iM1xp
              write(6,*) 'Gamma=',Gamma
           endif
*
*-----------Modify the original basis. Observe that
*           simplification due to A=B are not valid for the
*           exponent index, eq. P-A=/=0.
*
            Do 1012 iZeta = 1, nZeta
                PTC2 = (P(iZeta,1)-TC(1))**2
     &               + (P(iZeta,2)-TC(2))**2
     &               + (P(iZeta,3)-TC(3))**2
                Tmp0 = Zeta(iZeta)+Gamma
                Tmp1 = Exp(-Zeta(iZeta)*Gamma*PTC2/Tmp0)
                Array(ipK +iZeta-1) = rKappa(iZeta) * Tmp1
                Array(ipZ +iZeta-1) = Tmp0
                Array(ipZI+iZeta-1) = One/Tmp0
                Array(ipPx+iZeta-1) =
     &               (Zeta(iZeta)*P(iZeta,1)+Gamma*TC(1))/Tmp0
                Array(ipPy+iZeta-1) =
     &              (Zeta(iZeta)*P(iZeta,2)+Gamma*TC(2))/Tmp0
                Array(ipPz+iZeta-1) =
     &                  (Zeta(iZeta)*P(iZeta,3)+Gamma*TC(3))/Tmp0
 1012       Continue

            Do iDAO = 1, nDAO
              Do iZeta = 1, nZeta
                 Fac = FactECP * Array(ipK+iZeta-1) *
     &                        Array(ipZI+iZeta-1)*  Two * Pi
                 ipDAOt = nZeta*(iDAO-1) + iZeta-1 + ipDAO
                 Array(ipDAOt)= Fac * DAO(iZeta,iDAO)
              End Do
            End Do

*
*-----------Compute integrals with the Rys quadrature.
*
            call lcopy(4,ifg,1,jfg,1)

            call lcopy(12,ifgrd,1,jfgrd,1)
            call lcopy(12*12,ifhss,1,jfhss,1)

            call icopy(12*nirrep,indgrd,1,jndgrd,1)
            call icopy(12*12*nirrep,indhss,1,jndhss,1)

            Call Rysg2(iAng,nRys,nZeta,
     &                 Alpha,Beta,[One],[One],
     &                 Array(ipZ),Array(ipZI),nZeta,[One],[One],1,
     &                 Array(ipPx),nZeta,TC,1,Coori,Coor,CoorAC,
     &                 Array(ip),nArray-ip+1,
     &                 TNAI1,Fake,Cff2D,
     &                 Array(ipDAO),nDAO,Hess,nhess,jfGrd,jndGrd,
     &                 jfHss,jndHss,nOp,iuvwx,jfg,
     &                 nGr,Index,lgrad,lhess,tr)
          if (lGrad)  Then
            nb = nzeta*nElem(iAng(1))*nElem(iAng(2))
            Do iElem = 1, nElem(iAng(1))*nElem(iAng(2))*ngr
              Do iZeta = 1, nZeta
                tfac = Two*PI*Array(ipK+iZeta-1)*Array(ipZI-1+iZeta)
                indi=(iElem-1)*nZeta+iZeta
                Array(ip+indi-1) = FactECP*tfac * Array(ip+indi-1)
              End Do
            End Do


            Call SmAdNa(Array(ip),nb,Final,
     &            nop(1:3),loper,jndGrd,iuvwx(1:3),jfGrd,Index,
     &            idcar,One,jFG,tr)
      End if

 1011 Continue
      return
c Avoid unused argument warnings
      If (.False.) Call Unused_real_array(ZInv)
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!***********************************************************************

subroutine Compute_d2Odx2(ZA,nAtoms,O,EVal,Rot_Corr,iAtom,iCar,dTdRAi,dMdx,Px,jAtom,jCar,dMdy,Py,d2Odx2)

use Constants, only: Zero, One
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: nAtoms, iAtom, iCar, jAtom, jCar
real(kind=wp), intent(in) :: ZA(nAtoms), O(3,3), EVal(3), dTdRAi, dMdx(3,3), Px(3,3), dMdy(3,3), Py(3,3)
logical(kind=iwp), intent(in) :: Rot_Corr
real(kind=wp), intent(out) :: d2Odx2(3,3)
real(kind=wp) :: Alpha1, Alpha2, Beta1, Beta2, c12, c13, c23, d2Mdx2(3,3), Gamma1, Gamma2, Pxy(3,3), RHS(3,3), Scr1(3,3), &
                 Scr2(3,3), Scr3(3,3)

!                                                                      *
!***********************************************************************
!                                                                      *
if (.not. Rot_Corr) then
  d2Odx2(:,:) = Zero
  return
end if
!                                                                      *
!***********************************************************************
!                                                                      *
!
!     Compute d2M/dxdy
!
call Compute_d2Mdx2(ZA,nAtoms,iAtom,iCar,dTdRAi,jAtom,jCar,d2Mdx2)

!                                                                      *
!***********************************************************************
!                                                                      *
!     Form diagonal elements of Pxy directly from Px and Py
!
Gamma1 = Px(1,2)
Beta1 = Px(3,1)
Alpha1 = Px(2,3)
Gamma2 = Py(1,2)
Beta2 = Py(3,1)
Alpha2 = Py(2,3)
Pxy(1,1) = -Gamma1*Gamma2-Beta1*Beta2
Pxy(2,2) = -Gamma1*Gamma2-Alpha1*Alpha2
Pxy(3,3) = -Beta1*Beta2-Alpha1*Alpha2
!                                                                      *
!***********************************************************************
!                                                                      *
! Compute additional constraints for off-diagonals
!
c12 = Beta1*Alpha2+Beta2*Alpha1   ! Pxy(2,1)+Pxy(1,2)
c13 = Gamma1*Alpha2+Gamma2*Alpha1 ! Pxy(3,1)+Pxy(1,3)
c23 = Beta1*Gamma2+Beta2*Gamma1   ! Pxy(2,3)+Pxy(3,2)
!                                                                      *
!***********************************************************************
!                                                                      *
! Assemble the right hand side of eq. 26 except for Lambda^(xy).
! This will generate all off-diagonal elements of the RHS!

! - O^T M^(xy) O

call DGEMM_('T','N',3,3,3,One,O,3,d2Mdx2,3,Zero,Scr1,3)
call DGEMM_('N','N',3,3,3,One,Scr1,3,O,3,Zero,Scr2,3)
RHS(:,:) = -Scr2

Scr3(:,:) = Zero
Scr3(1,1) = Eval(1)
Scr3(2,2) = Eval(2)
Scr3(3,3) = Eval(3)

! + P^x Lambda P^y

call DGEMM_('N','N',3,3,3,One,Px,3,Scr3,3,Zero,Scr1,3)
call DGEMM_('N','N',3,3,3,One,Scr1,3,Py,3,Zero,Scr2,3)
RHS(:,:) = RHS+Scr2

! + P^y Lambda P^x

call DGEMM_('N','N',3,3,3,One,Py,3,Scr3,3,Zero,Scr1,3)
call DGEMM_('N','N',3,3,3,One,Scr1,3,Px,3,Zero,Scr2,3)
RHS(:,:) = RHS+Scr2

! + P^x O^T M^y O

call DGEMM_('N','T',3,3,3,One,Px,3,O,3,Zero,Scr1,3)
call DGEMM_('N','N',3,3,3,One,Scr1,3,dMdy,3,Zero,Scr2,3)
call DGEMM_('N','N',3,3,3,One,Scr2,3,O,3,Zero,Scr1,3)
RHS(:,:) = RHS+Scr1

! + P^y O^T M^x O

call DGEMM_('N','T',3,3,3,One,Py,3,O,3,Zero,Scr1,3)
call DGEMM_('N','N',3,3,3,One,Scr1,3,dMdx,3,Zero,Scr2,3)
call DGEMM_('N','N',3,3,3,One,Scr2,3,O,3,Zero,Scr1,3)
RHS(:,:) = RHS+Scr1

! - O^T M^x O P^y

call DGEMM_('T','N',3,3,3,One,O,3,dMdx,3,Zero,Scr1,3)
call DGEMM_('N','N',3,3,3,One,Scr1,3,O,3,Zero,Scr2,3)
call DGEMM_('N','N',3,3,3,One,Scr2,3,Py,3,Zero,Scr1,3)
RHS(:,:) = RHS-Scr1

! - O^T M^y O P^x

call DGEMM_('T','N',3,3,3,One,O,3,dMdy,3,Zero,Scr1,3)
call DGEMM_('N','N',3,3,3,One,Scr1,3,O,3,Zero,Scr2,3)
call DGEMM_('N','N',3,3,3,One,Scr2,3,Px,3,Zero,Scr1,3)
RHS(:,:) = RHS-Scr1
#ifdef _DEBUGPRINT_
call RecPrt('RHS',' ',RHS,3,3)
#endif

!                                                                      *
!***********************************************************************
!                                                                      *
! Compute the off-diagonal elements.

! We will need some more elaborate code if the denominator is
! degenerate! Will be developed later...

Pxy(2,1) = (RHS(1,2)-EVal(1)*c12)/(EVal(2)-EVal(1))
Pxy(1,2) = c12-Pxy(2,1)
Pxy(3,1) = (RHS(1,3)-EVal(1)*c13)/(EVal(3)-EVal(1))
Pxy(1,3) = c13-Pxy(3,1)
Pxy(3,2) = (RHS(2,3)-EVal(2)*c23)/(EVal(3)-EVal(2))
Pxy(2,3) = c23-Pxy(3,2)
!                                                                      *
!***********************************************************************
!                                                                      *
! Finally for O^(xy) from O P^(xyz)

call DGEMM_('N','N',3,3,3,One,O,3,Pxy,3,Zero,d2Odx2,3)
!                                                                      *
!***********************************************************************
!                                                                      *

return

end subroutine Compute_d2Odx2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Per Ake Malmqvist                                *
************************************************************************
*--------------------------------------------*
* 2006  PER-AAKE MALMQUIST                   *
* DEPARTMENT OF THEORETICAL CHEMISTRY        *
* UNIVERSITY OF LUND                         *
* SWEDEN                                     *
*--------------------------------------------*
      SUBROUTINE FOCK_RPT2()
      use definitions, only: iwp, wp, u6
      use constants, only: Zero
      use caspt2_global, only: FIMO, FAMO, FIFA, HONE, DREF
      use stdalloc, only: mma_allocate, mma_deallocate
      use caspt2_module, only: NSYM, NASHT, NISHT, NOMX, NORBT, notri,
     &                         NSSHT,NORB,NISH,NASH,EPS,EPSI,EPSA,EPSE
      IMPLICIT None

      real(kind=wp), Allocatable:: BUF(:)
      integer(kind=iwp) IFTEST,NBUF,ISTLT,ISYM,NO,I,IEPS,IEPSA,IEPSE,
     &                  IEPSI,NA,NI
      real(kind=wp) E

c Purpose: Compute the standard Fock matrix which defines
c the PT2 orbitals and the standard H0 hamiltonian.
c Available input data are: Effective one-electron hamiltonian
c for non-frozen space, in MO basis, at HONE.
c Two-electron integrals in MO basis, second-order transformed,
c as the three integral sets on LUINTM.
c To be called from ORBCTL section, after second order two-el
c transformation, and TRAONE, are finished, or from H0CTL.

#ifdef _DEBUGPRINT_
      IFTEST=1
#else
      IFTEST=0
#endif

c notri=Size of an array with symmetry-blocked triangular
c submatrices, using non-frozen, non-deleted MO indices.
c NBUF=Max size of a LUINTM buffer.
      NBUF=MAX(NOMX**2,notri)
      CALL mma_allocate(BUF,NBUF,Label='BUF')

c One-electron Hamiltonian is in HONE

      IF ( IFTEST.NE.0 ) THEN
        WRITE(u6,*)'      TEST PRINTS FROM FOCK_RPT2.'
        WRITE(u6,*)'      ONE-ELECTRON HAMILTONIAN IN MO BASIS'
        ISTLT=1
        DO ISYM=1,NSYM
          NO=NORB(ISYM)
          IF ( NO.GT.0 ) THEN
            WRITE(u6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
            CALL TRIPRT(' ',' ',HONE(ISTLT),NO)
            ISTLT=ISTLT+(NO*(NO+1))/2
          END IF
        END DO
      END IF

c Inactive and active Fock matrices:
      FIMO(:)=HONE(:)
      FAMO(:)=Zero
      CALL FMAT_CASPT2(FIMO,SIZE(FIMO),FAMO,SIZE(FAMO),DREF,SIZE(DREF),
     &                 NBUF,BUF)

* both FIMO and FAMO refer to the active space part only. FIMO comes
* from contractions over inactive orbitals, while FAMO from contractions
* over active orbitals and therefore are summed up together here
      FIFA(1:notri) = FIMO(1:notri)+FAMO(1:notri)

c   Orbital energies, EPS, EPSI,EPSA,EPSE:
      IEPS=0
      IEPSI=0
      IEPSA=0
      IEPSE=0
      ISTLT=0
      DO ISYM=1,NSYM
        NI=NISH(ISYM)
        NA=NASH(ISYM)
        NO=NORB(ISYM)
        DO I=1,NI
          E=FIFA(ISTLT+(I*(I+1))/2)
          IEPS=IEPS+1
          EPS(IEPS)=E
          IEPSI=IEPSI+1
          EPSI(IEPSI)=E
        END DO
        DO I=NI+1,NI+NA
          E=FIFA(ISTLT+(I*(I+1))/2)
          IEPS=IEPS+1
          EPS(IEPS)=E
          IEPSA=IEPSA+1
          EPSA(IEPSA)=E
        END DO
        DO I=NI+NA+1,NO
          E=FIFA(ISTLT+(I*(I+1))/2)
          IEPS=IEPS+1
          EPS(IEPS)=E
          IEPSE=IEPSE+1
          EPSE(IEPSE)=E
        END DO
        ISTLT=ISTLT+(NO*(NO+1))/2
      END DO

C EASUM=CONTRACT EPSA WITH DIAGONAL OF ACTIVE DENS
C This is never used anywhere, and it is actually
C wrong in XMS, since the DREF used is not the average
C density.
      ! EASUM=0.0D0
      ! DO ISYM=1,NSYM
      !   NA=NASH(ISYM)
      !   DO I=1,NA
      !     ITOT=NAES(ISYM)+I
      !     ID=(ITOT*(ITOT+1))/2
      !     EASUM=EASUM+EPSA(ITOT)*DREF(ID)
      !   END DO
      ! END DO

      IF ( IFTEST.NE.0 ) THEN
        WRITE(u6,*)'      INACTIVE FOCK MATRIX IN MO BASIS'
        ISTLT=1
        DO ISYM=1,NSYM
          NO=NORB(ISYM)
          IF ( NO.GT.0 ) THEN
            WRITE(u6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
            CALL TRIPRT(' ',' ',FIMO(ISTLT),NO)
            ISTLT=ISTLT+(NO*(NO+1))/2
          END IF
        END DO

        WRITE(u6,*)'        ACTIVE FOCK MATRIX IN MO BASIS'
        ISTLT=1
        DO ISYM=1,NSYM
          NO=NORB(ISYM)
          IF ( NO.GT.0 ) THEN
            WRITE(u6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
            CALL TRIPRT(' ',' ',FAMO(ISTLT),NO)
            ISTLT=ISTLT+(NO*(NO+1))/2
          END IF
        END DO

        WRITE(6,*)'      TOTAL FOCK MATRIX IN MO BASIS'
        ISTLT=1
        DO ISYM=1,NSYM
          IF ( NORB(ISYM).GT.0 ) THEN
            WRITE(u6,'(6X,A,I2)')' SYMMETRY SPECIES:',ISYM
            CALL TRIPRT(' ',' ',FIFA(ISTLT),NORB(ISYM))
            ISTLT=ISTLT+NORB(ISYM)*(NORB(ISYM)+1)/2
          END IF
        END DO

        WRITE(u6,*)
        WRITE(u6,*)' FOCK_RPT2: ORBITAL ENERGIES, EPS:'
        WRITE(u6,'(1X,5F12.6)')(EPS(I),I=1,NORBT)
        WRITE(u6,*)'      INACTIVE ORBITAL ENERGIES, EPSI:'
        WRITE(u6,'(1X,5F12.6)')(EPSI(I),I=1,NISHT)
        ! these active orbital energies are not the ones used in
        ! MKFG3. Depending on whether the OUTO=canonical flag was set
        ! in &RASSCF, it will differ from the EPSA array in mkfg3.f
        WRITE(u6,*)'        ACTIVE ORBITAL ENERGIES, EPSA:'
        WRITE(u6,'(1X,5F12.6)')(EPSA(I),I=1,NASHT)
        WRITE(u6,*)'      EXTERNAL ORBITAL ENERGIES, EPSE:'
        WRITE(u6,'(1X,5F12.6)')(EPSE(I),I=1,NSSHT)
      END IF

      CALL mma_deallocate(BUF)

      END SUBROUTINE FOCK_RPT2

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine Do_GGL(L_Eff,mPt,ipR)
************************************************************************
*                                                                      *
*     Computes datas useful for the angular quadrature.                *
*                                                                      *
************************************************************************
      Implicit Real*8 (a-h,o-z)
#include "nq_info.fh"
#include "real.fh"
#include "WrkSpc.fh"
*                                                                      *
************************************************************************
*                                                                      *
*     Statement Function
*
      Pax(i) = Work(ip_O-1+i)
*                                                                      *
************************************************************************
*                                                                      *
*     Generate angular grid from Gauss and Gauss-Legendre quadrature
*
*---- Theta (polar angle): 0 =< theta =< pi
*     Gauss-Legendre Quadrature (L_Quad+1)/2 points
*---- Phi (azimuthal angle): 0=< phi =< 2*pi
*     Gauss-Quadrature (L_Quad+1) points
*
      nTheta = (L_Eff+1)/2
      nPhi   = L_Eff+1
*
      mPt    = nTheta*nPhi
      Call GetMem('AngRW','Allo','Real',ipR,4*mPt)
*
      Call GetMem('Theta','Allo','Real',ipTh,2*nTheta)
*
      Call GauLeg(-One,One,Work(ipTh),nTheta)
*
      iOff = ipR
      Do iTheta = 1, nTheta
         Cos_Theta = Work(ipTh+(iTheta-1)*2  )
         w_Theta   = Work(ipTh+(iTheta-1)*2+1)
         Sin_Theta = Sqrt(One-Cos_Theta**2)
*
         Do iPhi = 1, nPhi
            Call Phi_point(iPhi,nPhi,Cos_Phi,Sin_Phi,w_Phi)
*
            x = Sin_Theta*Cos_Phi
            y = Sin_Theta*Sin_Phi
            z = Cos_Theta
            Work(iOff  )=Pax(1)*x+Pax(4)*y+Pax(7)*z
            Work(iOff+1)=Pax(2)*x+Pax(5)*y+Pax(8)*z
            Work(iOff+2)=Pax(3)*x+Pax(6)*y+Pax(9)*z
            Work(iOff+3)=w_Theta*w_Phi
            iOff = iOff + 4
*
         End Do    ! iPhi
*
      End Do       ! iTheta
*
      Call GetMem('Theta','Free','Real',ipTh,2*nTheta)
*                                                                      *
************************************************************************
*                                                                      *
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      Subroutine dRBuf(Array,nArray,Copy)
      Use dEAF
      use IOBUF
      Implicit Real*8 (a-h,o-z)
      Logical Copy
#include "SysDef.fh"
      Real*8 Array(nArray)
*
*     Write (6,*) 'Enter RBuf: iPos @',iPos,'iBuf=,lBuf',iBuf,lBuf
      If (InCore.and.iBuf.eq.2) Then
         Call WarningMessage(2,
     &                    'Error in in-core semi-direct implementation')
         Call Abend()
      End If
      iArray = 1
      mArray=nArray
chjw  Do While (mArray.ge.1)
10       If (iPos.eq.1) Then
*
*---------- Wait for pending buffer.
*
            If (OnDisk) Then
*              Write (6,*) 'In drbuf.'
               Call EAFWait(LuTmp,id)
            End If
*
*---------- Get the next buffer, make sure that request is not beyond
*           the disc limitation.
*
            temp=Disk+DBLE(lBuf*RtoB)
*           Write (6,*) 'temp=',temp
            If (temp.le.DiskMx_Byte) Then
               If (iBuf.eq.1) Then
                  jBuf=2
               Else
                  jBuf=1
               End If
               Disk_2 = Disk_1
               Disk_1 = Disk
c              Write (6,*) 'RBuf aread on disk @',Disk,'jBuf=',jBuf
               If (OnDisk) Then
*                 Write (6,*) 'In drbuf.'
                  Call dEAFARead(LuTmp,Buffer(1,jBuf),lBuf*RtoI,Disk,id)
               End If
            End If
         End If
         Left = lBuf-iPos+1
         If (mArray.gt.Left) Then
            If (Copy) Call dCopy_(Left,Buffer(iPos,iBuf),1,
     &                            Array(iArray),1)
            iArray=iArray+Left
            mArray=mArray-Left
            iPos=1
*           Write (6,*) 'LuTmp,Disk=',LuTmp,Disk
*---------- Swap buffer
            If (iBuf.eq.1) Then
               iBuf=2
            Else
               iBuf=1
            End If
         Else
*           Write (6,*) ' Copy ',mArray,'elements from buffer',iPos
            If (Copy) Call dCopy_(mArray,Buffer(iPos,iBuf),1,
     &                            Array(iArray),1)
            iPos=iPos+mArray
            mArray=0
         End If
      If(mArray.gt.0) goto 10
chjw  End Do
*
C     Write (6,*) 'Exit RBuf: iPos @',iPos,'iBuf=',iBuf
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2004,2005, Alexander Wolf                              *
*               2004,2005, Markus Reiher                               *
************************************************************************
      subroutine ordertest (dkhorder,paramtype,scrtxt,ctrflg)
c
c*************************************************************************
c
c   This SR belongs to dkhparser_numeric (dkhparser2)
c
c   written by:  Alexander Wolf and Markus Reiher  (Univ. Jena)
c
c   version:  2.0.1
c
c   last modified: 25.07.2005
c
c   first version: 10.04.2004  (Theoretical Chemistry, Univ. Bonn)
c
c*************************************************************************
c
      implicit none
#include "dkhparameters.fh"
c
      integer dkhorder,ctrflg,idum,dkh_char2int
      character*(3) paramtype
      character*(maxlength) scrtxt
c
      idum=0
      if (scrtxt(14:14).eq.' ') then
        idum=dkh_char2int(1,scrtxt(15:15))
      else
        idum=dkh_char2int(2,scrtxt(14:15))
      endif
      if (ctrflg.eq.1) then
        if (dkhorder.gt.idum) then
          write (stdout,1010) dkhorder,idum,idum
1010      format ('SR ordertest (1): The desired dkhorder = ',I2,
     *            ' is larger than dkhorder = ',I2,/,'stored in ',
     *            'dkhops.13.',/,'--> Reduce dkhorder:',
     *            ' dkhorder = ',I2,'.',/2X)
          dkhorder=idum
        endif
      else
        if (dkhorder.gt.idum) then
          write (stdout,1014) dkhorder,idum,idum
1014      format ('SR ordertest (2): The desired xorder = ',I2,
     *            ' is larger than xorder = ',I2,/,'stored in ',
     *            'dkhops.13.',/,'--> Reduce xorder:',
     *            ' xorder = ',I2,'.',/2X)
          dkhorder=idum
        endif
      endif
c
      if (ctrflg.eq.1) paramtype(1:3)=scrtxt(26:28)
c
      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1998, Roland Lindh                                     *
!               2004,2012, Thomas Bondo Pedersen                       *
!               2007, Francesco Aquilante                              *
!***********************************************************************

subroutine MP2_Driver(ireturn)
!***********************************************************************
!     New MP2 driver for Molcas                                        *
!                                                                      *
!    Author: R. Lindh                                                  *
!            Dept. of Chemical Physics                                 *
!            University of Lund, Sweden                                *
!            November 7, 1998                                          *
!                                                                      *
!    Modified:                                                         *
!                                                                      *
!       - code using Cholesky vectors directly                         *
!         October 2004, T. B. Pedersen                                 *
!         Dept. of Theoretical Chemistry                               *
!         University of Lund, Sweden                                   *
!                                                                      *
!       - code for the "Scaled Opposite-Spin" (SOS) MP2                *
!         May 2007, F. Aquilante                                       *
!         Dept. of Theoretical Chemistry                               *
!         University of Lund, Sweden                                   *
!                                                                      *
!       - code for Laplace-SOS-MP2 for Cholesky/DF and LDF             *
!         November-December 2012, T. B. Pedersen                       *
!         Centre for Theoretical and Computational Chemistry           *
!         Dept. of Chemistry                                           *
!         University of Oslo, Norway                                   *
!***********************************************************************

use MBPT2_Global, only: CMO, DoCholesky, DoDF, DoLDF, EOcc, EOrb, EVir, FnIntA, FnIntM, iPL, LuHLF1, LuHLF2, LuHLF3, LuIntA, &
                        LuIntM, MBPT2_Clean, NamAct, nBas
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One
use Definitions, only: wp, iwp, u6, r8

implicit none
integer(kind=iwp), intent(out) :: ireturn
integer(kind=iwp) :: i, iOpt, iPrc, irc, iSym, iTol, iTst, iType, lthCMO, lthEOr, nAsh(8), nDel_tra(8), nFro_tra(8), nIsh(8), nOccT
real(kind=wp) :: E0, E2BJAI, ESCF, ESSMP2, Etot, REFC, Shanks1_E, t1dg, t1nrm, TCPE(4), TCPT, TIOE(4), TIOT
logical(kind=iwp) :: Conventional, IsDirect, Exists, Ready
character(len=8) :: Method, Method1
real(kind=wp), allocatable :: T1amp(:)
logical(kind=iwp), parameter :: Debug = .false.
integer(kind=iwp), external :: Cho_X_GetTol, ip_of_Work
real(kind=r8), external :: ddot_, Seconds
#include "Molcas.fh"
#include "trafo.fh"
#include "corbinf.fh"
#include "chomp2_cfg.fh"

!                                                                      *
!***********************************************************************
!                                                                      *
TCPT = seconds()

!***********************************************************************
! Check so it is a RHF-SCF reference that is being used.
! TBP, November 2012: do not quit, just issue a warning!
call Get_cArray('Relax Method',Method1,8)
if ((Method1(1:7) /= 'RHF-SCF') .and. (Method1(1:5) /= 'MBPT2')) then
  write(u6,*)
  call WarningMessage(1,'MP2 implementation intended for RHF references only')
  write(u6,'(A,A)') 'MBPT2 WARNING: Reference function according to RunFile:',Method1
  write(u6,'(A)') 'I''ll assume you know what you''re doing and continue'
  write(u6,*)
  call xFlush(u6)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Figure out if it's a cholesky run, DF run, LDF run
DoCholesky = .false.
DoDF = .false.
DoLDF = .false.
call DecideOnCholesky(DoCholesky)
call DecideOnDF(DoDF)
call DecideOnLocalDF(DoLDF)
!                                                                      *
!***********************************************************************
!                                                                      *
! read COMFILE Interface file from SCF and allocate memory...

call TIMING(TCPE(1),TCPT,TIOE(1),TIOT)
call RdMBPT()
lthCMO = size(CMO)
lthEOr = size(EOrb)

call mma_allocate(EOcc,lthEOr,label='EOcc')
call mma_allocate(EVir,lthEOr,label='EVir')
EOcc(:) = Zero
EVir(:) = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! read Program Input Cards...

call RdInp(CMO,EOrb,EOcc,EVir,iTst,ESCF)
!                                                                      *
!***********************************************************************
!                                                                      *
call DelGHOST_MBPT()
!                                                                      *
!***********************************************************************
!                                                                      *
E2BJAI = Zero
REFC = Zero

Wref = Zero
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out input parameters

call PrInp_MBPT2(EOcc,EVir,iTst)
!                                                                      *
!***********************************************************************
!                                                                      *
! Copy pointers to orbital energies to chomp2_dec.fh
! Needed for amplitude Cholesky decomposition.

if (DoCholesky) then
  call ChoMP2_SetPtsOen(EOcc,EVir)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Check, if there is an ORDINT file...

call f_Inquire(FNINTA,Exists)
call DecideOnDirect(.true.,Exists,IsDirect,DoCholesky)
call TIMING(TCPE(2),TCPT,TIOE(2),TIOT)
call TIMING(TCPE(3),TCPT,TIOE(3),TIOT)

if (DoT1amp) then
  l_T1 = nOcc(1)*nExt(1)
  nOccT = nOcc(1)
  do iSym=2,nSym
    l_T1 = l_T1+nOcc(iSym)*nExt(iSym)
    nOccT = nOccT+nOcc(iSym)
  end do
  call mma_allocate(T1amp,l_T1,label='T1amp')
  call Thouless_T1(CMO,nSym,nBas,nFro,nOcc,nExt,T1amp)
  t1nrm = ddot_(l_T1,T1amp,1,T1amp,1)
  t1dg = sqrt(t1nrm/nOccT)
  write(u6,'(A,F8.4)') '       T1 diagnostic : ',t1dg
  write(u6,*)
  iOffT1(1) = ip_of_Work(T1amp(1))-1
  do i=2,nSym
    iOffT1(i) = iOffT1(i-1)+nOcc(i-1)*nExt(i-1)
  end do
end if
!                                                                      *
!***********************************************************************
!***********************************************************************
!                                                                      *
if (DoLDF) then ! LDF
  Conventional = .false.
  Ready = .false.
  if (Laplace .and. SOS_MP2) then
    call WarningMessage(2,'LDF-Laplace-SOS-MP2 not implemented yet!')
    call SysHalt('mp2_driver')
  else
    call WarningMessage(2,'Only LDF-Laplace-SOS-MP2 implemented!')
    call SysHalt('mp2_driver')
  end if
else if (DoCholesky .and. (ChoAlg > 0) .and. (.not. SOS_mp2) .and. (.not. FNOMP2) .and. (.not. LovMP2)) then
  Conventional = .false.
  Ready = .false.
  call ChoMP2_Drv(irc,E2BJAI,CMO,EOcc,EVir)
  if (irc /= 0) then
    write(u6,*) 'MP2_Driver: ChoMP2_Drv returned ',irc
    call SysAbendMsg('MP2_Driver','Non-zero return code from ChoMP2_Drv',' ')
  else
    Ready = .true.
  end if
else if (DoCholesky .and. SOS_mp2) then ! CD/DF SOS-MP2
  Conventional = .false.
  Ready = .false.
  if (Laplace) then
    call ChoMP2_Drv(irc,E2BJAI,CMO,EOcc,EVir)
    if (irc /= 0) then
      write(u6,*) 'MP2_Driver: ChoMP2_Drv returned ',irc
      call SysAbendMsg('MP2_Driver','Non-zero return code from ChoMP2_Drv',' ')
    else
      Ready = .true.
    end if
  else
    call Cho_SOSmp2_Drv(irc,E2BJAI,CMO,EOcc,EVir)
    if (irc /= 0) then
      write(u6,*) 'SOS-MP2_Driver: Cho_SOSmp2_Drv returned ',irc
      call SysAbendMsg('SOS-MP2_Driver','Non-zero return code from Cho_SOSmp2_Drv',' ')
    else
      Ready = .true.
    end if
  end if
! CD/DF Frozen Natural Orbital MP2
else if (DoCholesky .and. FNOMP2) then
  Conventional = .false.
  Ready = .false.
  write(u6,'(A)') '-------------------------------------------------------'
  write(u6,'(A)') ' Start FNO-MP2 section '
  write(u6,'(A)') '-------------------------------------------------------'
  write(u6,'(A,8I4)')
  write(u6,'(A,I3,A)') ' NOs specified: ',int(vkept*100),'% of the total virtual space'
  call FNOMP2_Drv(irc,E2BJAI,CMO,EOcc,EVir)
  if (irc /= 0) then
    write(u6,*) 'MP2 driver: FNOMP2_Drv returned ',irc
    call SysAbendMsg('MP2 driver','Non-zero return code from FNOMP2_Drv',' ')
  else
    Ready = .true.
  end if
  write(u6,'(A)') '-------------------------------------------------------'
  write(u6,'(A)') ' End FNO-MP2 section '
  write(u6,'(A)') '-------------------------------------------------------'
  write(u6,'(A,8I4)')
  write(u6,'(A,8I4)')
else if (DoCholesky .and. LovMP2) then ! CD/DF Localized O-V MP2
  Conventional = .false.
  Ready = .false.
  write(u6,'(A)') '-------------------------------------------------------'
  write(u6,'(A)') ' Start LovMP2 section '
  write(u6,'(A)') '-------------------------------------------------------'
  write(u6,'(A,8I4)')
  call LovMP2_Drv(irc,E2BJAI,CMO,EOcc,EVir,NamAct,nActa,ThrLov,DoMP2,all_Vir)
  if (irc /= 0) then
    write(u6,*) 'MP2 driver: LovMP2_Drv returned ',irc
    call SysAbendMsg('MP2 driver','Non-zero return code from LovMP2_Drv',' ')
  else
    Ready = .true.
  end if
  write(u6,'(A)') '-------------------------------------------------------'
  write(u6,'(A)') ' End LovMP2 section '
  write(u6,'(A)') '-------------------------------------------------------'
  write(u6,'(A,8I4)')
  write(u6,'(A,8I4)')
else ! conventional (possibly with Cholesky)
  Conventional = .true.
  if (DoCholesky) then
    if ((ChoAlg == 0) .and. (iPL >= 2)) then
      write(u6,*) 'Conventional algorithm used.'
      write(u6,*)
      write(u6,*) 'Integrals generated from Cholesky vectors (Algorithm 0):'
    else
      call SysHalt('mp2_driver')
    end if
  else
    if (iPL >= 2) write(u6,*) 'Conventional algorithm used...'
  end if
  if (iTst /= 0) then
    call finalize()
    return
  end if

  ! Use the driver from the CASPT2 code.

  call DaName_MF_wa(LuIntM,FnIntM)

  if (DoDens) then

    ! Same as just above but keeping frozen and deleted orbitals in the
    ! transformation
    do i=1,8
      nIsh(i) = nOrb(i)+nDel(i)
    end do
    nFro_tra(:) = 0
    nDel_tra(:) = 0
  else
    nIsh(:) = nOcc
  end if

  nAsh(:) = 0
  if (.not. DoDens) then
    ! PAM Jan 2013: Set correct nOrb:
    do i=1,8
      norb(i) = norb(i)-nfro(i)
    end do
    call SetUp_CASPT2_Tra(nSym,nBas,nOrb,nIsh,nAsh,nFro,nDel,CMO,lthCMO,LuIntM,LuHlf1,LuHlf2,LuHlf3)
    ! End of patch
  else
    call SetUp_CASPT2_Tra(nSym,nBas,nIsh,nIsh,nAsh,nFro_tra,nDel_tra,CMO,lthCMO,LuIntM,LuHlf1,LuHlf2,LuHlf3)
  end if
  if (.not. DoCholesky) then
    iRC = -1
    iOpt = 0
    call OpnOrd(iRC,iOpt,FnIntA,LuIntA)
    if (iRC /= 0) then
      write(u6,*) 'mp2_driver: error opening MOLINT'
      call Abend()
    end if
  end if

  iType = 1 ! Means that TraCtl_Drv is called by MP2
  call TraCtl_Drv(iType,.true.,8)

  call DaClos(LuHlf1)
  call DaClos(LuHlf2)
  call DaClos(LuHlf3)

  call TIMING(TCPE(3),TCPT,TIOE(3),TIOT)
  ! PRINT TRANSFORMED INTEGRALS (USED ONLY FOR DEBUGGING PURPOSES)
  if (Debug) then
    iPrc = 0
    call RDInt2_MP2(iPrc)
  end if
  !                                                                    *
  !*********************************************************************
  !                                                                    *
  if (DoDens) then

    ! Obtain variational density if requested by user

    call Mp2Dens_drv(E2BJAI,REFC)
  else

    ! COMPUTE CORRELATION ENERGY CONTRIBUTION

    call BJAI(IADOUT,EOcc,EVir,E2BJAI,REFC)
  end if
  call TIMING(TCPE(4),TCPT,TIOE(4),TIOT)

  Ready = .true.

  ! Close files (for Cholesky, OrdInt was never opened)
  if (.not. DoCholesky) then
    iRc = -1
    iOpt = 0
    call ClsOrd(iRc,iOpt)
    if (iRc /= 0) then
      write(u6,*) 'MP2_Driver: Error closing ORDINT'
      call Abend()
    end if
  end if
  call DaClos(LuIntM)
  !                                                                    *
  !*********************************************************************
  !                                                                    *
end if
!                                                                      *
!***********************************************************************
!                                                                      *
! Write out resulting energy, etc.

if (Ready) then

  Wref = One/(One+Wref)   ! Note: this is Cref**2

  if (DoLDF) then
    call WarningMessage(2,'LDF should not be implemented....')
    call SysHalt('mp2_driver')
  else if (DoCholesky .and. (ChoAlg > 0) .and. (.not. SOS_mp2) .and. (.not. LovMP2) .and. (.not. FNOMP2)) then
    if (iPL >= 2) write(u6,'(3(/6X,A,F20.10,A)//6X,A,F20.10,A//6X,A,F15.5)') &
      ' SCF energy                           =',ESCF,' a.u.', &
      ' Second-order correlation energy      =',E2BJAI,' a.u.', &
      ' ( Opposite-Spin contribution         =',-EOSMP2,' )', &
      ' Total energy                         =',E2BJAI+ESCF,' a.u.', &
      ' Reference weight ( Cref**2 )         =',Wref
  else if (DoCholesky .and. LovMP2) then
    ESSMP2 = E2BJAI+EOSMP2
    if (iPL >= 2) write(u6,'(4(/6X,A,F20.10,A)//6X,A,F20.10,A//6X,A,F15.5)') &
      ' SCF energy                           =',ESCF,' a.u.', &
      ' Second-order correlation energy      =',E2BJAI,' a.u.', &
      ' ( Opposite-Spin contribution         =',-EOSMP2,' )', &
      ' ( Same-Spin contribution             =',ESSMP2,' )', &
      ' Total energy                         =',E2BJAI+ESCF,' a.u.', &
      ' Reference weight ( Cref**2 )         =',Wref
  else if (DoCholesky .and. FNOMP2) then
    ESSMP2 = E2BJAI+EOSMP2-XEMP2
    if (iPL >= 2) write(u6,'(5(/6X,A,F20.10,A)//6X,A,F20.10,A//6X,A,F15.5)') &
      ' SCF energy                           =',ESCF,' a.u.', &
      ' Second-order correlation energy      =',E2BJAI,' a.u.', &
      ' ( Opposite-Spin contribution         =',-EOSMP2,' )', &
      ' ( Same-Spin contribution             =',ESSMP2,' )', &
      ' ( Truncation error estimate          =',XEMP2,' )', &
      ' Total energy                         =',E2BJAI+ESCF,' a.u.', &
      ' Reference weight ( Cref**2 )         =',Wref
  else if (DoCholesky .and. SOS_mp2) then ! CD/DF SOS-MP2 energy
    E2BJAI = C_os*E2BJAI
    if (iPL >= 2) then
      if (Laplace) then
        write(u6,'(/,6X,A,I4)') ' Number of Laplace grid points:',Laplace_nGridPoints
        write(u6,'(3(/6X,A,F20.10,A)//6X,A,F20.10,A)') ' Opposite-Spin (OS) scaling factor    =',C_os,'     ', &
                                                       ' SCF energy                           =',ESCF,' a.u.', &
                                                       ' L-SOS 2nd-order correlation energy   =',E2BJAI,' a.u.', &
                                                       ' Total L-SOS-MP2 energy               =',E2BJAI+ESCF,' a.u.'
      else
        write(u6,'(3(/6X,A,F20.10,A)//6X,A,F20.10,A)') ' Opposite-Spin (OS) scaling factor    =',C_os,'     ', &
                                                       ' SCF energy                           =',ESCF,' a.u.', &
                                                       ' SOS 2nd-order correlation energy     =',E2BJAI,' a.u.', &
                                                       ' Total SOS-MP2 energy                 =',E2BJAI+ESCF,' a.u.'
      end if
    end if
  else
    WRef = REFC**2
    if (iPL >= 2) write(u6,'(2(/6X,A,F20.10,A)//6X,A,F20.10,A/6X,A,F15.5)') &
      ' SCF energy                           =',ESCF,' a.u.', &
      ' Second-order correlation energy      =',E2BJAI,' a.u.', &
      ' Total energy                         =',E2BJAI+ESCF,' a.u.', &
      ' Reference weight ( Cref**2 )         =',Wref
  end if
  if (iPL >= 2) then
    ETot = E2BJAI+ESCF
    write(u6,*)
    call PrintResult(u6,'(6X,A,T50,F19.10)','Total MBPT2 energy',0,'',[ETot],1)
  end if
  call xFlush(u6)
  if (iPL >= 2) write(u6,*)
  call Store_Energies(1,E2BJAI+ESCF,1)
  Method = 'MBPT2   '
  call Put_cArray('Relax Method',Method,8)
  if (DoDens) call Prpt()
  if (iPL >= 2) write(u6,*)
else
  write(u6,*) ' Energy evaluation not completed.'
end if

! Shanks-type series convergence acceleration

call Compute_Shanks(ESCF,E2BJAI+ESCF,EOrb,lthEOr,nBas,nFro,nOcc,nSym,E0,Shanks1_E)

if (iPL >= 2) then
  write(u6,'(6X,A,A,(F20.10),A)') ' Zeroth-order energy (E0)   ','          =',E0,' a.u.'
  write(u6,*)

  write(u6,'(6X,A,A,(F20.10),A)') ' Shanks-type energy S1(E)   ','          =',Shanks1_E,' a.u.'
  write(u6,*)
  write(u6,*)
end if

! PRINT PROCESSING AND TIMING INFORMATION

if (Conventional .and. (iPL >= 2)) then
  write(u6,'(//6X,A//6X,A/6X,A/)') ' Data processing and timing information:', &
                                   ' Section                                              time(sec)', &
                                   '                                                    CPU  Elapsed'
  write(u6,'(6X,A,2(2X,F8.2))') 'Input data processing                        ',TCPE(2)-TCPE(1),TIOE(2)-TIOE(1)
  write(u6,'(6X,A,2(2X,F8.2))') 'Transformation of integrals                  ',TCPE(3)-TCPE(2),TIOE(3)-TIOE(2)
  write(u6,'(6X,A,2(2X,F8.2))') 'MBPT2 calculations (BJAI)                    ',TCPE(4)-TCPE(3),TIOE(4)-TIOE(3)
  write(u6,'(6X,A,2(2X,F8.2))') 'Total MBPT2 calculations                     ',TCPE(4)-TCPE(1),TIOE(4)-TIOE(1)
  write(u6,*)
  write(u6,*)
end if
!                                                                      *
!***********************************************************************
!                                                                      *
iTol = Cho_X_GetTol(8)
call Add_Info('E_MP2',[E2BJAI+ESCF],1,iTol)
call Add_Info('HF ref weight',[WREF],1,iTol)
!                                                                      *
!***********************************************************************
!                                                                      *

! Close up calculation
call finalize()

return

contains

subroutine finalize()
  call MBPT2_Clean()
  if (DoT1amp) call mma_deallocate(T1amp)
  ireturn = 0
end subroutine finalize

end subroutine MP2_Driver

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) Francesco Aquilante                                    *
!               Thomas Bondo Pedersen                                  *
!***********************************************************************
!  Cho_X_CalcChoDiag
!
!> @brief
!>   Calculate integral diagonal from Cholesky vectors
!> @author Francesco Aquilante
!> @modified_by Thomas Bondo Pedersen
!>
!> @details
!> This routine calculates the integral diagonal from Cholesky
!> vectors,
!>
!> \f[ (ab|ab) = \sum_J L_{ab,J}^2 \quad (a,b: \text{AO-indices}) \f]
!>
!> The diagonal calculation is parallelized.
!> The diagonal is returned in first reduced set storage and must
!> be allocated before calling this routine.
!> Return code is ``0`` if successful execution.
!>
!> @param[out] rc   Return code
!> @param[out] Diag Array containing diagonal on exit
!***********************************************************************

subroutine Cho_X_CalcChoDiag(rc,Diag)

use Cholesky, only: iiBstR, IndRed, InfVec, IndRed, nDimRS, nnBstRT, nSym, NumCho
use stdalloc, only: mma_allocate, mma_deallocate, mma_maxDBLE
use Constants, only: Zero
use Definitions, only: wp, iwp, u6

#include "intent.fh"

implicit none
integer(kind=iwp), intent(out) :: rc
real(kind=wp), intent(_OUT_) :: Diag(*)
integer(kind=iwp) :: iBatch, iLoc, irc, IREDC, IVEC2, iVrs, JNUM, JRED, JRED1, JRED2, jrs, jSym, JVEC, krs, LWORK, mrs, MUSED, &
                     nBatch, nRS, NUMV, nVec, nVrs
real(kind=wp), allocatable :: Lrs(:,:)
character(len=*), parameter :: SECNAM = 'Cho_X_CalcChoDiag'

Diag(1:nnBstRT(1)) = Zero

IREDC = -1  ! unknown reduced set

iLoc = 3 ! use scratch location in reduced index arrays

! *************** BIG LOOP OVER VECTORS SYMMETRY *******************
do jSym=1,nSym

  if (NumCho(jSym) < 1) cycle

  JRED1 = InfVec(1,2,jSym)  ! red set of the 1st vec
  JRED2 = InfVec(NumCho(jSym),2,jSym) !red set of the last vec
  do JRED=JRED1,JRED2

    call Cho_X_nVecRS(JRED,JSYM,iVrs,nVrs)

    if (nVrs == 0) cycle  ! no vectors in that (jred,jsym)

    if (nVrs < 0) then
      write(u6,*) SECNAM//': Cho_X_nVecRS returned nVrs<0. STOP!'
      rc = 77
      return
    end if

    call Cho_X_SetRed(irc,iLoc,JRED) !set index arrays at iLoc
    if (irc /= 0) then
      write(u6,*) SECNAM//'cho_X_setred non-zero return code.  rc= ',irc
      rc = irc
      return
    end if

    IREDC = JRED

    nRS = nDimRS(JSYM,JRED)

    call mma_maxDBLE(LWORK)

    nVec = min(LWORK/max(nRS,1),nVrs)

    if (nVec < 1) then
      write(u6,*) SECNAM//': Insufficient memory for batch'
      write(u6,*) ' LWORK= ',LWORK
      write(u6,*) ' jsym= ',jsym
      write(u6,*) ' min. mem. need for reading= ',nRS
      rc = 33
      return
      nBatch = -9999  ! dummy assignment
    end if

    call mma_allocate(Lrs,nRS,nVec,Label='Lrs')

    ! BATCH over the vectors ----------------------------

    nBatch = (nVrs-1)/nVec+1

    do iBatch=1,nBatch

      if (iBatch == nBatch) then
        JNUM = nVrs-nVec*(nBatch-1)
      else
        JNUM = nVec
      end if

      JVEC = nVec*(iBatch-1)+iVrs
      IVEC2 = JVEC-1+JNUM

      call CHO_VECRD(Lrs,size(Lrs),JVEC,IVEC2,JSYM,NUMV,IREDC,MUSED)

      if ((NUMV <= 0) .or. (NUMV /= JNUM)) then
        call mma_deallocate(Lrs)
        rc = 77
        return
      end if

      ! ----------------------------------------------------------------
      ! Compute the diagonals :   D(ab) = D(ab) + sum_J (Lab,J)^2
      !
      ! Stored in the 1st reduced set

      do krs=1,nRS

        mrs = iiBstR(JSYM,iLoc)+krs
        jrs = IndRed(mrs,iLoc) ! address in 1st red set

        Diag(jrs) = Diag(jrs)+sum(Lrs(krs,1:JNUM)**2)

      end do

      ! ----------------------------------------------------------------
      ! ----------------------------------------------------------------

    end do  ! end batch loop

    ! free memory
    call mma_deallocate(Lrs)

  end do   ! loop over red sets

end do   !loop over JSYM

call Cho_GAdGOp(Diag(1),NNBSTRT(1),'+')

rc = 0

end subroutine Cho_X_CalcChoDiag

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2020, Oskar Weser                                      *
!***********************************************************************

#include "compiler_features.h"
#include "macros.fh"

module linalg_mod
    use stdalloc, only: mma_allocate, mma_deallocate
    use definitions, only: wp, r8
    use sorting, only: sort, argsort
    use sorting_funcs, only : leq_i, leq_r, geq_r
    implicit none
    private
    public :: mult, sym_diagonalize, isclose, operator(.isclose.), &
        dot_product_, norm, canonicalize, Gram_Schmidt, Canonical, Lowdin, &
        symmetric

    ! TODO Move to different module
    public :: abort_, verify_

    type, abstract :: ParentCanonicalize_t
    contains
        procedure :: canonicalize => base_canonicalize
        procedure(get_projections_t), deferred :: get_projections
    end type

    abstract interface
        subroutine get_projections_t(self, M, P)
            import :: wp, ParentCanonicalize_t
            class(ParentCanonicalize_t), intent(in) :: self
            real(wp), intent(in) :: M(:, :)
            real(wp), intent(out) :: P(:, :)
        end subroutine
    end interface

    type, extends(ParentCanonicalize_t) :: CanonicalBasisCanonicalize_t
    contains
        procedure :: get_projections => project_canonical_unit_vectors
    end type

    type, extends(ParentCanonicalize_t) :: GeneralBasisCanonicalize_t
        real(wp), pointer :: ref(:, :) => null()
    contains
        procedure :: get_projections => project_general_unit_vectors
    end type


!>  @brief
!>    Wrapper around dgemm.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  This is an overloaded wrapper around DGEMM which
!>  uses assumed shape arrays to deduce as much information
!>  as possible about the DGEMM calls automatically.
!>  The preferred way is to use arrays of actual rank 2
!>  instead of rank 1 arrays which are interpreted to be rank 2
!>  just by convention.
!>
!>  There are some run time checks to test for matching shapes.
    interface mult
        module procedure mult_2D, mult_2D_1D, mult_2d_raw
    end interface

!>  @brief
!>  Canonicalize Eigenvectors and Eigenvalues
!>
!>  @details
!>  This procedure can be used to make diagonalizations deterministic,
!>  by forcing the Eigenvectors to be as similar as possible to proj_B.
!>  The algorithm is as following:
!>
!>  1. Sort the Eigenvalues (and the Eigenvectors accordingly).
!>  2. Find degenerate Eigenvalues (up to float equality) and put
!>      corresponding Eigenvectors into separate Eigenspaces.
!>  For each Eigenspace
!>      1. Let $b_i$ be the basis vectors in `proj_B` and $E$ your Eigenspace of dimension $d$.
!>      2. Calculate all projections of $b_i$ onto $E$. Let's call them $p_i$
!>      3. Stable-sort the $p_i$ by their norm.
!>      4. Take the first $d$ projections and normalize them. These are your canonical Eigenvectors.
!>
!>  @param[inout] V 2D matrix which contains the Eigenvectors.
!>      The j-th column corresponds to the j-th Eigenvalue.
!>  @param[inout] lambda 1D vector of Eigenvalues.
!>  @param[in] proj_B Optional and overloaded argument.
!>      If it is ommited, the canonical unit vector basis is assumed.
!>      Otherwise it can be 2D orthogonal matrix that represents the reference basis for
!>      the canonicalization or a function pointer of type `get_matrix_t`
!>      that returns matrix elements (trading speed for memory).
!>  @param[out] info Optional error code. If calling code does not check the error
!>      code, then this routine crashes upon errors.
    interface canonicalize
        module procedure canonicalize_canonical_basis, canonicalize_general
    end interface

    interface operator(.isclose.)
        module procedure isclose_for_operator
    end interface

contains

!>  @brief
!>    Wrapper around dgemm for matrix-matrix multiplication.
!>
!>  @author Oskar Weser
!>
!>  @details
!>
!>  @paramin[in] A
!>  @paramin[in] B
!>  @paramin[out] C The shape of the output array is usually
!>      [size(A, 1), size(B, 2)] which changes of course, if
!>      A or B are transposed.
!>  @paramin[in] transpA, Optional argument to specify that A
!>      should be transposed.
!>  @paramin[in] transpB, Optional argument to specify that B
!>      should be transposed.
    subroutine mult_2D(A, B, C, transpA, transpB)
        real(wp), intent(in) :: A(:, :), B(:, :)
        real(wp), intent(out) :: C(:, :)
        logical, intent(in), optional :: transpA, transpB
        logical :: transpA_, transpB_
        debug_function_name("mult_2D")

        integer :: M, N, K_1, K_2, K

        if (present(transpA)) then
            transpA_ = transpA
        else
            transpA_ = .false.
        end if
        if (present(transpB)) then
            transpB_ = transpB
        else
            transpB_ = .false.
        end if

        M = size(A, merge(1, 2, .not. transpA_))
        ASSERT(M == size(C, 1))
        N = size(B, merge(2, 1, .not. transpB_))
        ASSERT(N == size(C, 2))
        K_1 = size(A, merge(2, 1, .not. transpA_))
        K_2 = size(B, merge(1, 2, .not. transpB_))
        ASSERT(K_1 == K_2)
        K = K_1

        ASSERT(wp == r8)
        call dgemm_(merge('T', 'N', transpA_), merge('T', 'N',transpB_), &
                    M, N, K, 1._wp, A, size(A, 1), B, size(B, 1), &
                    0._wp, C, size(C, 1))
    end subroutine

!>  @brief
!>    Wrapper around dgemm for matrix-vector multiplication.
!>
!>  @author Oskar Weser
!>
!>  @details
!>
!>  @paramin[in] A
!>  @paramin[in] x
!>  @paramin[out] y The shape of the output array is size(x)
!>  @paramin[in] transpA, Optional argument to specify that A
!>      should be transposed.
    subroutine mult_2D_1D(A, x, y, transpA)
        real(wp), intent(in) :: A(:, :), x(:)
        real(wp), intent(out) :: y(:)
        logical, intent(in), optional :: transpA
        logical :: transpA_

        integer :: M, N, K

        if (present(transpA)) then
          transpA_ = transpA
        else
          transpA_ = .false.
        end if

        M = size(A, merge(1, 2, .not. transpA_))
        ASSERT(M == size(y, 1))
        N = 1
        K = size(A, merge(2, 1, .not. transpA_))
        ASSERT(M == size(x, 1))

        ASSERT(wp == r8)
        call dgemm_(merge('T', 'N', transpA_), 'N', &
                    M, N, K, 1._wp, A, size(A, 1), x, size(x, 1), &
                    0._wp, y, size(y, 1))
    end subroutine


!>  @brief
!>    Wrapper around dgemm for matrix-matrix multiplication with raw memory.
!>
!>  @author Oskar Weser
!>
!>  @details
!>  It is important to note, that it is expected to pass in the
!>  actual vectors and not just the first element.
!>  So if `A_ptr` is the pointer to A in the work array
!>  it is necessary to call it with `Work(A_ptr : )`.
!>
!>  @paramin[in] A
!>  @paramin[in] shapeA The shape of A.
!>  @paramin[in] B
!>  @paramin[in] shapeB The shape of B.
!>  @paramin[in] C
!>  @paramin[out] C The shape of the output array is usually
!>      (shapeA(1) * shapeB(2)) which changes of course, if
!>      A or B are transposed.
!>  @paramin[in] transpA, Optional argument to specify that A
!>      should be transposed.
!>  @paramin[in] transpB, Optional argument to specify that B
!>      should be transposed.
    subroutine mult_2D_raw(A, shapeA, B, shapeB, C, transpA, transpB)
        real(wp), intent(in), target :: A(*)
        integer, intent(in) :: shapeA(2)
        real(wp), intent(in), target :: B(*)
        integer, intent(in) :: shapeB(2)
        real(wp), intent(out), target :: C(*)
        logical, intent(in), optional :: transpA, transpB
        logical :: transpA_, transpB_

        integer :: shapeC(2)

#ifdef POINTER_BOUNDS_REMAPPING
        real(wp), pointer :: ptr_A(:, :), ptr_B(:, :), ptr_C(:, :)
#else
        real(wp), allocatable :: ptr_A(:, :), ptr_B(:, :), ptr_C(:, :)
        integer, save :: n = 0
#endif

        if (present(transpA)) then
            transpA_ = transpA
        else
            transpA_ = .false.
        end if
        if (present(transpB)) then
            transpB_ = transpB
        else
            transpB_ = .false.
        end if

        shapeC = [merge(shapeA(1), shapeA(2), .not. transpA_), merge(shapeB(2), shapeB(1), .not. transpB_)]

#ifdef POINTER_BOUNDS_REMAPPING
        ptr_A(1 : shapeA(1), 1 : shapeA(2)) => A(1 : product(shapeA))
        ptr_B(1 : shapeB(1), 1 : shapeB(2)) => B(1 : product(shapeB))
        ptr_C(1 : shapeC(1), 1 : shapeC(2)) => C(1 : product(shapeC))

        call mult(ptr_A, ptr_B, ptr_C, transpA_, transpB_)
#else
        ! Print a warning every 1000th call
        if (mod(n, 10**3) == 0) then
            call WarningMessage(1, 'The compiler does not support &
             &pointer bounds remapping so an inefficient implementation is chosen.')
            ! Avoid overflow when there are a lot of calls and reset to 1.
            n = 1
        end if
        n = n + 1

        call mma_allocate(ptr_A, shapeA(1), shapeA(2))
        call mma_allocate(ptr_B, shapeB(1), shapeB(2))
        call mma_allocate(ptr_C, shapeC(1), shapeC(2))

        ! How ugly :-(
        ptr_A(:, :) = reshape(A(1 : product(shapeA)), shapeA)
        ptr_B(:, :) = reshape(B(1 : product(shapeB)), shapeB)
        call mult(ptr_A, ptr_B, ptr_C, transpA_, transpB_)
        C(1 : product(shapeC))  = pack(ptr_C, .true.)

        call mma_deallocate(ptr_A)
        call mma_deallocate(ptr_B)
        call mma_deallocate(ptr_C)
#endif
    end subroutine

!>  @brief
!>  Diagonalize symmetric A.
!>
!>  @details
!>  Diagonalize A to fullfill `A V(:, j) = lambda(j) V(:, j)`.
!>  Wrapper around BLAS DSYEV.
!>
!>  @param[in] A Symmetric 2D matrix to be diagonalized.
!>  @param[out] V 2D matrix which contains the Eigenvectors.
!>      The j-th column corresponds to the j-th Eigenvalue.
!>  @param[out] lambda 1D vector of Eigenvalues.
!>  @param[in] info Error code. If calling code does not check the error
!>      code, then this routine crashes upon errors.
    subroutine sym_diagonalize(A, V, lambda, info)
        real(wp), intent(in) :: A(:, :)
        real(wp), intent(out) :: V(:, :), lambda(:)
        integer, optional, intent(out) :: info

        integer, parameter :: do_worksize_query = -1
        integer :: info_
        real(wp), allocatable :: work(:)
        real(wp) :: dummy(2), query_result(2)

        ASSERT(symmetric(A))

        V(:, :) = A(:, :)
        call dsyev_('V', 'L', size(V, 2), dummy, size(V, 1), dummy, &
                    query_result, do_worksize_query, info_)

        if (info_ /= 0) then
            if (present(info)) then
                info = info_
            else
                call abort_('Error in diagonalize')
            end if
        end if

        call mma_allocate(work, int(query_result(1)))
        call dsyev_('V', 'L', size(V, 2), V, size(V, 1), lambda, &
                    work, size(work), info_)
        call mma_deallocate(work)

        if (info_ /= 0) then
            if (present(info)) then
                info = info_
            else
                call abort_('Error in diagonalize')
            end if
        end if
    end subroutine sym_diagonalize

!>  @brief
!>  Order Eigenvectors by ascending eigenvalues.
    subroutine order_eigenvectors(V, lambda)
        real(wp), intent(inout) :: V(:, :), lambda(:)
        integer, allocatable :: idx(:)
        call mma_allocate(idx, size(lambda))
        idx(:) = argsort(lambda, leq_r)
        V(:, :) = V(:, idx)
        lambda(:) = lambda(idx)
        call mma_deallocate(idx)
    end subroutine

!>  @brief
!>  Determine the Eigenspaces.
!>
!>  @details
!>  Sort the eigenvalues and collect "equal" eigenvalues together.
!>  Equality of eigenvalues considers floating point error and is determined
!>  by `operator(.isclose.)`.
!>  For this reason all Eigenvalues of the same Eigenspace are replaced
!>  with their mean.
!>
!>  @param[inout] lambda Eigenvalues are sorted ascendingly and
!>      Eigenvalues of the same Eigenspace (up to floating point error)
!>      are replaced with their mean.
!>  @param[out] dimensions The dimension of each Eigenspace.
!>      size(dimensions) is the number of Eigenspaces, i.e. the number
!>      of distinct Eigenvalues and sum(dimensions) is the number of Eigenvalues.
    subroutine determine_eigenspaces(lambda, dimensions)
        real(wp), intent(inout) :: lambda(:)
        integer, allocatable, intent(out) :: dimensions(:)

        integer, allocatable :: d_buffer(:)

        integer :: i, low
        integer :: n_spaces

#ifdef _ADDITIONAL_RUNTIME_CHECK_
        if (any(lambda(2 :) < lambda(: size(lambda) - 1))) then
            call abort_('Eigenvalues not sorted in'//__FILE__)
        end if
#endif

        call mma_allocate(d_buffer, size(lambda))
        d_buffer(:) = 0

        low = 1
        n_spaces = 1
        do i = 1, size(lambda)
            d_buffer(n_spaces) = d_buffer(n_spaces) + 1
            if (i + 1 <= size(lambda)) then
                if (.not. isclose(lambda(i), lambda(i + 1), epsilon(lambda) * 1e3_wp, 1e-8_wp)) then
                    n_spaces = n_spaces + 1
                    lambda(low : i) = mean(lambda(low : i))
                    low = i + 1
                end if
            else
                lambda(low : i) = mean(lambda(low : i))
            end if
        end do

        call mma_allocate(dimensions, n_spaces)
        dimensions(:) = d_buffer(: n_spaces)
        call mma_deallocate(d_buffer)

        contains
            real(wp) pure function mean(X)
                real(wp), intent(in) :: X(:)
                mean = sum(X) / size(X)
            end function
    end subroutine


    subroutine base_canonicalize(self, V, lambda)
        class(ParentCanonicalize_t), intent(in) :: self
        real(wp), intent(inout) :: V(:, :), lambda(:)
        !> The norms of the projections
        real(wp), allocatable :: norms_projections(:)
        character(len=*), parameter :: this_routine = 'canonicalize_factory'


        integer :: low, i, j, d, n_new
        integer, allocatable :: idx(:), dimensions(:)
        real(wp), allocatable :: projections(:, :), ONB(:, :)

        ASSERT(size(V, 1) == size(V, 2))
        call mma_allocate(projections, size(V, 1), size(V, 2))
        call mma_allocate(norms_projections, size(projections, 2))
        call mma_allocate(idx, size(V, 1))

        call order_eigenvectors(V, lambda)
        do j = 1, size(V, 2)
            V(:, j) = V(:, j) / norm(V(:, j))
        end do

        call determine_eigenspaces(lambda, dimensions)

        call mma_allocate(ONB, size(lambda), maxval(dimensions))

        low = 1
        do j = 1, size(dimensions)
            d = dimensions(j)
            ! `self` "knows" which vectors are to be projected
            !  into V(:, low : low + d - 1)
            call self%get_projections(V(:, low : low + d - 1), projections)

            do i = 1, size(norms_projections)
                norms_projections(i) = norm(projections(:, i))
            end do
            idx(:) = argsort(norms_projections, geq_r)
            call sort(idx( : d), leq_i)

            ! Get the first d projections with the largest overlap.
            do i = 1, d
                V(:, low + i - 1) = projections(:, idx(i)) / norms_projections(idx(i))
            end do

            ! reorthogonalize
            call Gram_Schmidt(V(:, low : low + d - 1), d, ONB(:, : d), n_new)
            ASSERT(d == n_new)
            V(:, low : low + d - 1) = ONB(:, : d)

            low = low + d
        end do

        call mma_deallocate(norms_projections)
        call mma_deallocate(idx)
        call mma_deallocate(ONB)
        call mma_deallocate(projections)
        call mma_deallocate(dimensions)
    end subroutine


    subroutine project_canonical_unit_vectors(self, M, P)
        class(CanonicalBasisCanonicalize_t), intent(in) :: self
        real(wp), intent(in) :: M(:, :)
        real(wp), intent(out) :: P(:, :)
        integer :: i, j

        ! avoid unused dummy warning
        select type(self)
        end select

        P(:, :) = 0._wp
        ! calculate projections of basis b_j into eigenvectors v_i:
        ! p_j = sum_i < b_j | v_i > v_i
        ! if b_j are canonical unit vectors, the dot product is the j-th
        ! component of v_i
        do j = 1, size(P, 2)
            do i = 1, size(M, 2)
                P(:, j) = P(:, j) + M(j, i) * M(:, i)
            end do
        end do
    end subroutine


    subroutine project_general_unit_vectors(self, M, P)
        class(GeneralBasisCanonicalize_t), intent(in) :: self
        real(wp), intent(in) :: M(:, :)
        real(wp), intent(out) :: P(:, :)
        integer :: i, j

        P(:, :) = 0._wp
        ! calculate projections of basis b_j into eigenvectors v_i:
        ! p_j = sum_i < b_j | M_i > M_i
        do j = 1, size(P, 2)
            do i = 1, size(M, 2)
                P(:, j) = P(:, j) + dot_product_(self%ref(:, j), M(:, i)) * M(:, i)
            end do
        end do
    end subroutine

    subroutine canonicalize_canonical_basis(V, lambda)
        real(wp), intent(inout) :: V(:, :), lambda(:)
        type(CanonicalBasisCanonicalize_t) :: canonicalizer

        call canonicalizer%canonicalize(V, lambda)
    end subroutine

    subroutine canonicalize_general(V, lambda, ref)
        real(wp), intent(inout) :: V(:, :), lambda(:)
        real(wp), intent(in), target :: ref(:, :)
        type(GeneralBasisCanonicalize_t) :: canonicalizer

        canonicalizer%ref => ref
        call canonicalizer%canonicalize(V, lambda)
    end subroutine


!>  @brief
!>  Check for floating point equality.
!>
!>  @details
!>  Checks if \f[ | a - b | \leq max(rtol * max(|a|, |b|), atol)  \f].
!>
!>  @param[in] a A real number.
!>  @param[in] b A real number.
!>  @param[in] atol Absolute tolerance.
!>  @param[in] rtol Relative tolerance.
!>
!>  @author
!>    Oskar Weser
    elemental function isclose(a, b, atol, rtol) result(res)
        real(wp), intent(in) :: a, b
        real(wp), intent(in) :: atol, rtol
        logical :: res
        res = abs(a - b) <= max(rtol * max(abs(a), abs(b)), atol)
    end function

! Operator functions may only have two arguments.
    elemental function isclose_for_operator(a, b) result(res)
        real(wp), intent(in) :: a, b
        logical :: res

        ! For real64, the epsilon is 2.3e-16 so that atol becomes roughly 2.3e-14 which is very tight.
        res = isclose(a, b, atol=epsilon(a) * 1e2_wp, rtol=1e-9_wp)
    end function


!>  @brief
!>    Calculates v1^T S v2.
!>
!>  @details
!>  Calculates \f[ v1^T S v2 \f]
!>  S has to be a symmetric positive definite matrix, which is not
!>  tested.
!>  If S is ommited, it defaults to the unit matrix,
!>  i.e. the Euclidean dot-product.
!>
!>  @param[in] v1 A vector.
!>  @param[in] v2 A vector.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
!>
!>  @author
!>    Oskar Weser
    function dot_product_(v1, v2, S) result(dot)
        real(wp), intent(in) :: v1(:), v2(:)
        real(wp), intent(in), optional :: S(:, :)
        real(wp), allocatable :: tmp(:)
        real(wp) :: dot

        if (present(S)) then
            call mma_allocate(tmp, size(v2))
            call mult(S, v2, tmp)
            dot = dot_product(v1, tmp)
            call mma_deallocate(tmp)
        else
            dot = dot_product(v1, v2)
        end if
      end function

!>  @brief
!>    The induced norm from the dot product given by S.
!>
!>  @details
!>    It is assumed, that S is symmetric and positive definite.
!>
!>  @param[in] v A vector.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
!>
!>  @author
!>    Oskar Weser
    function norm(v, S) result(L)
        real(wp), intent(in) :: v(:)
        real(wp), intent(in), optional :: S(:, :)
        real(wp) :: L
        if (present(S)) then
          L = sqrt(dot_product_(v, v, S))
        else
! One could use norm2 here, but Sun and PGI compilers don't know this.
          L = sqrt(sum(v**2))
        end if
    end function


!>  @brief
!>  Check if matrix is symmetric.
!>
!>  @param[in] M A matrix.
    logical pure function symmetric(M)
        real(wp), intent(in) :: M(:, :)
        integer :: i, j

        symmetric = .true.
        do j = 1, size(M, 2)
            do i = j, size(M, 1)
                if (.not. (M(i, j) .isclose. M(j, i))) then
                    symmetric = .false.
                    return
                end if
            end do
        end do
    end function

!>  @brief
!>  Loewdin-orthonormalize basis to get ONB using the overlap matrix S.
!>
!>  @details
!>  If the given basis is linear dependent, then this routine will abort.
!>    For a detailed explanation see \cite szabo_ostlund (p. 143).
!>
!>  @author
!>    Oskar Weser
!>
!>  @param[in] basis A matrix of full rank.
!>  @param[out] ONB The orthonormalized version of basis.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
    subroutine Lowdin(basis, ONB, S)
        real(wp), intent(in) :: basis(:, :)
        real(wp), intent(out) :: ONB(:, :)
        real(wp), intent(in), optional :: S(:, :)

        integer :: i
        real(wp), allocatable :: U(:, :), s_diag(:), X(:, :), &
              S_transf(:, :), tmp(:, :)

        call mma_allocate(S_transf, size(S, 1), size(S, 2))
        call mma_allocate(U, size(S, 1), size(S, 2))
        call mma_allocate(X, size(S, 1), size(S, 2))
        call mma_allocate(tmp, size(S, 1), size(S, 2))
        call mma_allocate(s_diag, size(S, 2))

! Transform AO-overlap matrix S to the overlap matrix of basis.
! S_transf = basis^T S basis
! We search X that diagonalizes S_transf
        if (present(S)) then
            call mult(S, basis, tmp)
            call mult(basis, tmp, S_transf, transpA=.true.)
        else
            call mult(basis, basis, S_transf, transpA=.true.)
        end if

        call sym_diagonalize(S_transf, U, s_diag)
        call canonicalize(U, s_diag)

        call verify_(all(s_diag > 1.0d-10), &
           "Linear dependency detected. "// &
           "Lowdin can't cure it. Please use  "// &
           "Gram_Schmidt or Canonical orthonormalization.")

! X = U s_diag^{-1/2} U^T
        do i = 1, size(tmp, 2)
          tmp(:, i) = U(:, i) / sqrt(s_diag(i))
        end do
        call mult(tmp, U, X, transpB=.true.)
! With this X the overlap matrix S_transf has diagonal form.
! X^T basis^T S basis X = 1
! We finally have to convert to get the form:
! ONB^T S ONB = 1
        call mult(basis, X, ONB)

        call mma_deallocate(tmp)
        call mma_deallocate(s_diag)
        call mma_deallocate(X)
        call mma_deallocate(U)
        call mma_deallocate(S_transf)
    end subroutine Lowdin

!>  @brief
!>  Canonical-orthonormalize basis to get ONB using the overlap matrix S.
!>
!>  @details
!>  If the given basis is linear dependent, then this routine will still
!>  work. The out parameter `n_new` returns the number of valid
!>  column vectors. A valid orthonormalized basis is given by ONB(:, : n_new).
!>
!>  For a detailed explanation see \cite szabo_ostlund (p. 143).
!>
!>  @author
!>    Oskar Weser
!>
!>  @param[in] basis A matrix of full rank.
!>  @param[in] n_to_ON Number of columns that should be orthonormalized.
!>  @param[out] ONB The orthonormalized version of basis.
!>  @param[out] n_new The number of columns that could be orthonormalized.
!>     Note that `n_new <= n_to_ON`.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
    subroutine Canonical(basis, n_to_ON, ONB, n_new, S)
        real(wp), intent(in) :: basis(:, :)
        integer, intent(in) :: n_to_ON
        real(wp), intent(out) :: ONB(:, :)
        integer, intent(out) :: n_new
        real(wp), intent(in), optional :: S(:, :)

        logical :: lin_dep_detected
        integer :: i
        integer, allocatable :: idx(:)
        real(wp), allocatable :: &
            U(:, :), s_diag(:), S_transf(:, :), X(:, :), tmp(:, :)

        call mma_allocate(S_transf, size(S, 1), size(S, 2))
        call mma_allocate(U, size(S, 1), size(S, 2))
        call mma_allocate(s_diag, size(S, 2))
        call mma_allocate(X, size(S, 1), size(S, 2))
        call mma_allocate(idx, size(S, 1))
        call mma_allocate(tmp, size(S, 1), size(S, 2))

! Transform AO-overlap matrix S to the overlap matrix of basis.
! We search X that diagonalizes basis^T S basis
        if (present(S)) then
            call mult(S, basis, tmp)
            call mult(basis, tmp, S_transf, transpA=.true.)
        else
            call mult(basis, basis, S_transf, transpA=.true.)
        end if

        call sym_diagonalize(S_transf, U, s_diag)
        call canonicalize(U, s_diag)

        idx(:) = argsort(s_diag, geq_r)
        U(:, :) = U(:, idx)
        s_diag(:) = s_diag(idx)

        i = 0
        lin_dep_detected = .false.
        do while(.not. lin_dep_detected .and. i < n_to_ON)
          if (s_diag(i + 1) < 1.0d-10) then
            n_new = i
            lin_dep_detected = .true.
          end if
          i = i + 1
        end do
        if (.not. lin_dep_detected) n_new = n_to_ON

! X = U s_diag^{-1/2}
        do i = 1, n_new
          X(:, i) = U(:, i) / sqrt(s_diag(i))
        end do
! With this X the overlap matrix S_transf has diagonal form.
! X^T basis^T S basis X = 1
! We finally have to convert to get the form:
! ONB^T S ONB = 1
        ONB(:, n_new + 1:) = basis(:, n_new + 1 :)
        call mult(basis, X(:, :n_new), ONB(:, :n_new))

        call mma_deallocate(tmp)
        call mma_deallocate(X)
        call mma_deallocate(idx)
        call mma_deallocate(s_diag)
        call mma_deallocate(U)
        call mma_deallocate(S_transf)
    end subroutine Canonical

!>  @brief
!>  Gram-Schmidt-orthonormalize basis to get ONB using the overlap matrix S.
!>
!>  @details
!>  If the given basis is linear dependent, then this routine will still
!>  work. The out parameter `n_new` returns the number of valid
!>  column vectors. A valid orthonormalized basis is given by ONB(:, : n_new).
!>
!>  For a detailed explanation see \cite szabo_ostlund (p. 143).
!>
!>  @author
!>    Oskar Weser
!>
!>  @param[in] basis A matrix of full rank.
!>  @param[in] n_to_ON Number of columns that should be orthonormalized.
!>  @param[out] ONB The orthonormalized version of basis.
!>  @param[out] n_new The number of columns that could be orthonormalized.
!>     Note that `n_new <= n_to_ON`.
!>  @param[in] S Optional positive definite overlap matrix. If ommited
!>      it is assumed to be the unit matrix.
    subroutine Gram_Schmidt(basis, n_to_ON, ONB, n_new, S)
        real(wp), intent(in) :: basis(:, :)
        integer, intent(in) :: n_to_ON
        real(wp), target, intent(out) :: ONB(:, :)
        integer, intent(out) :: n_new
        real(wp), intent(in), optional :: S(:, :)

        real(wp) :: L
        integer :: i, j
        logical :: lin_dep_detected, improve_solution

        real(wp), allocatable :: previous(:), correction(:), v(:)
        real(wp), pointer :: curr(:)

        call mma_allocate(previous, size(basis, 1))
        call mma_allocate(correction, size(basis, 1))
        call mma_allocate(v, size(basis, 1))

        n_new = 0
        ONB(:, n_to_ON + 1 :) = basis(:, n_to_ON + 1 :)
        do i = 1, n_to_ON
          curr => ONB(:, n_new + 1)
          curr = basis(:, i)

          improve_solution = .true.
          lin_dep_detected = .false.
          do while (improve_solution .and. .not. lin_dep_detected)
            correction = 0._wp
            if (present(S)) then
                call mult(S, curr, v)
            else
                v(:) = curr(:)
            end if

            do j = 1, n_new
              correction(:) = &
                    correction(:) + ONB(:, j) * dot_product(ONB(:, j), v)
            end do
            curr = curr - correction
            improve_solution = norm(correction, S=S) > 0.1_wp
            L = norm(curr, S=S)
            lin_dep_detected = L < 1.0e-10_wp
            if (.not. lin_dep_detected) then
              curr = curr / L
            end if
            if (.not. (improve_solution .or. lin_dep_detected)) then
              n_new = n_new + 1
            end if
          end do
        end do
        ONB(:, n_new + 1 : n_to_ON) = basis(:, n_new + 1 : n_to_ON)

        call mma_deallocate(v)
        call mma_deallocate(correction)
        call mma_deallocate(previous)
    end subroutine Gram_Schmidt


    !> @brief
    !>    Print error message and abort.
    subroutine abort_(message)
        character(len=*), intent(in) :: message
        call WarningMessage(2, message)
        call pure_abort()
    end subroutine

    !> @brief
    !>    Abort.
    pure subroutine pure_abort()
        ! I know, that these functions are not pure,
        ! but we are aborting anyway.
        interface
            pure subroutine Abend()
            end subroutine
        end interface
        call Abend()
    end subroutine

    !> @brief
    !>    Runtime check, that is not switched off in Debug mode
    subroutine verify_(test_expression, message)
        logical, intent(in) :: test_expression
        character(len=*), intent(in) :: message
        if (.not. test_expression) then
            call abort_(message)
        end if
    end subroutine

end module

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2013, Thomas Bondo Pedersen                            *
************************************************************************
C#define _DEBUGPRINT_
      Real*8 Function Cho_LK_ScreeningThreshold(delta)
C
C     Thomas Bondo Pedersen, May 2013.
C
C     Return the basic LK screening threshold. Input is a damping
C     parameter, f.ex. the max. Fock matrix element in the previous
C     iteration. Use delta<0.0d0 or delta>1.0d0 to avoid damping.
C
C     The Cholesky environment must have been set up prior to calling
C     this function [by calling Cho_X_Init(..)]
C
      Implicit None
      Real*8 delta
#include "cholesky.fh"
      Real*8 thr0
      Parameter (thr0=1.0d-6)
      Real*8 thr
      thr=min(ThrCom,thr0)
      If (delta.ge.0.0d0 .and. delta.le.1.0d0) Then
         thr=thr*delta
      End If
      Cho_LK_ScreeningThreshold=max(thr,1.0d-15)
#if defined (_DEBUGPRINT_)
      Write(6,'(1P,4(A,D15.6))')
     & 'ThrCom=',ThrCom,' thr0=',thr0,' delta=',delta,
     & ' Cho_LK_ScreeningThreshold=',Cho_LK_ScreeningThreshold
#endif
      End
      Integer Function Cho_LK_MaxVecPerBatch()
C
C     Thomas Bondo Pedersen, May 2013.
C
C     Return the max number of vectors to be handled in core in the LK
C     algorithm.
C
C     Implemented as a function to make all LK flavors (SCF, RASSCF,
C     RASSI) behave the same way. The value 25 has been chosen to mimic
C     the approximate number of vectors in each reduced set of full CD
C     with the one-step algorithm. This should make the LK algorithm
C     (nearly) independent of available memory.
C
      Implicit None
      Cho_LK_MaxVecPerBatch=25
#if defined (_DEBUGPRINT_)
      Write(6,'(A,I10)')
     & 'Cho_LK_MaxVecPerBatch=',Cho_LK_MaxVecPerBatch
#endif
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Markus P. Fuelscher                                    *
*               1992, Per Ake Malmqvist                                *
*               2002, Roland Lindh                                     *
************************************************************************
      SUBROUTINE FOCKTWO_scf(NSYM,NBAS,NFRO,KEEP,
     &                   DLT,DSQ,FLT,nFlt,FSQ,LBUF,X1,X2,ExFac,iUHF,
     &                   DLT_ab,DSQ_ab,FLT_ab,FSQ_ab)
      IMPLICIT REAL*8 (A-H,O-Z)
      Real*8 FSQ(*),FLT(nFlt),DSQ(*),DLT(*),X1(*),X2(*)
      Real*8 DLT_ab(*),DSQ_ab(*),FLT_ab(*),FSQ_ab(*)
      Integer ISTLT(8),ISTSQ(8),KEEP(8),NBAS(8),NFRO(8)
      Logical Debug,myDebug
c
c This routine has been nicked from the MOTRA package. It was
c originally written by Marcus Fuelscher, and has been slightly
c modified by P-A Malmqvist 1992-12-04.
c Further modifications by RL 2002-8-30.
c Purpose: Return FLT, which is the effective one-electron
c Hamiltonian when frozen orbitals are removed. It is the
c same as a closed-shell Fock matrix computed using the
c two-electron contribution only from frozen orbitals.
c FLT is returned as symmetry-blocked lower triangles. FSQ
c contains the same matrix, as symmetry-blocked square matrices.
c DSQ and DLT are computed in the calling routine.
c It is assumed that the SEWARD integral file was opened before
c call to this routine.
c ISTSQ, ISTLT: Offsets to symmetry blocks of FSQ, FLT etc.
c
************************************************************************
*                                                                      *
      MUL(I,J)=IEOR(I-1,J-1)+1
*                                                                      *
************************************************************************
       myDebug=.false.
       Factor=0.5D0
        if(iUHF.eq.1) Factor=1.0D0
#ifdef _DEBUGPRINT_
      Debug=.true.
c      myDebug=.true. ! very extensive print out
#else
      Debug=.false.
#endif
      ISTSQ(1)=0
      ISTLT(1)=0
      DO 20 ISYM=2,NSYM
        NB=NBAS(ISYM-1)
        NB2=NB*NB
        NB3=(NB2+NB)/2
        ISTSQ(ISYM)=ISTSQ(ISYM-1)+NB2
        ISTLT(ISYM)=ISTLT(ISYM-1)+NB3
20    CONTINUE

      DO 110 IS=1,NSYM
        IB=NBAS(IS)
        IK=KEEP(IS)
        NFI=NFRO(IS)
        DO 120 JS=1,IS
          JB=NBAS(JS)
          JK=KEEP(JS)
          NFJ=NFRO(JS)
          IJS=MUL(IS,JS)
          IJB=IB*JB
          IF( IS.EQ.JS ) IJB=(IB*(IB+1))/2
          DO 130 KS=1,IS
            KB=NBAS(KS)
            KK=KEEP(KS)
            NFK=NFRO(KS)
            LSMAX=KS
            IF ( KS.EQ.IS ) LSMAX=JS
            LS=MUL(IJS,KS)
            IF(LS.GT.LSMAX) GOTO 130
            LB=NBAS(LS)
            LK=KEEP(LS)
            NFL=NFRO(LS)
            KLB=KB*LB
            IF( KS.EQ.LS ) KLB=(KB*(KB+1))/2
C INTEGRAL BLOCK EXCLUDED BY SETTING KEEP PARAMETERS?
            IF((IK+JK+KK+LK).NE.0) GOTO 130
C NO FROZEN ORBITALS?
            IF((NFI+NFJ+NFK+NFL).EQ.0) GOTO 130
C NO BASIS FUNCTIONS?
            IF((IJB*KLB).EQ.0 ) GOTO 130

            IF ( IS.EQ.JS .AND. IS.EQ.KS ) THEN
c CASE 1: Integrals are of symmetry type (II/II)
c Coulomb and exchange terms need to be accumulated
c Option code 1: Begin reading at first integral.
c NPQ: Nr of submatrices in buffer X1.
                IOPT=1
                LPQ=0
                IPQ=0
                NPQ=0
                DO 200 IP=1,IB
                  DO 201 JQ=1,IP
                    IPQ=IPQ+1
                    LPQ=LPQ+1
                    IF ( IPQ.GT.NPQ ) THEN
                      CALL RDORD(IRC,IOPT,IS,JS,KS,LS,X1,LBUF,NPQ)
                      IF(IRC.GT.1) GOTO 999
c Option code 2: Continue reading at next integral.
                      IOPT=2
                      IPQ=1
                    ENDIF
                    ISX=(IPQ-1)*KLB+1
                    ISF=ISTLT(IS)+LPQ
                    ISD=ISTLT(IS)+1
                    TEMP=DDOT_(KLB,X1(ISX),1,DLT(ISD),1)
                    FLT(ISF)=FLT(ISF)+TEMP
                    if(iUHF.eq.1) then
                     TEMP_ab=DDOT_(KLB,X1(ISX),1,DLT_ab(ISD),1)
                     FLT(ISF)=FLT(ISF)+TEMP_ab
                     FLT_ab(ISF)=FLT(ISF)
                    endif
        if(myDebug) then
          write (6,'(a,i5,a,f12.6)') '00 Flt(',isf,')=',FLT(ISF)
          if(iUHF.eq.1) then
          write (6,'(a,i5,a,f12.6)') '00 Flt_ab(',isf,')=',FLT_ab(ISF)
          endif
        endif
                    CALL SQUARE (X1(ISX),X2(1),1,KB,LB)
                    ISF=ISTSQ(IS)+(JQ-1)*JB+1
                    ISD=ISTSQ(IS)+(IP-1)*IB+1
c
                 if(iUHF.eq.0) then
*                    CALL DGEMX  (KB,LB,-Factor*ExFac,X2(1),KB,
*     &                           DSQ(ISD),1,FSQ(ISF),1)
                    CALL DGEMV_('N',KB,LB,-Factor*ExFac,X2(1),KB,
     &                           DSQ(ISD),1,1.0D0,FSQ(ISF),1)
                 else
*                    CALL DGEMX  (KB,LB,-Factor*ExFac,X2(1),KB,
*     &                           DSQ(ISD),1,FSQ(ISF),1)
*
*                    CALL DGEMX  (KB,LB,-Factor*ExFac,X2(1),KB,
*     &                           DSQ_ab(ISD),1,FSQ_ab(ISF),1)
                    CALL DGEMV_('N',KB,LB,-Factor*ExFac,X2(1),KB,
     &                           DSQ(ISD),1,1.0D0,FSQ(ISF),1)

                    CALL DGEMV_('N',KB,LB,-Factor*ExFac,X2(1),KB,
     &                           DSQ_ab(ISD),1,1.0D0,FSQ_ab(ISF),1)
                 endif
                    IF ( IP.NE.JQ ) THEN
                      ISF=ISTSQ(IS)+(IP-1)*IB+1
                      ISD=ISTSQ(IS)+(JQ-1)*JB+1
c
                 if(iUHF.eq.0) then
*                      CALL DGEMX  (KB,LB,-Factor*ExFac,X2(1),KB,
*     &                             DSQ(ISD),1,FSQ(ISF),1)
                      CALL DGEMV_('N',KB,LB,-Factor*ExFac,X2(1),KB,
     &                             DSQ(ISD),1,1.0D0,FSQ(ISF),1)
                 else
*                      CALL DGEMX  (KB,LB,-Factor*ExFac,X2(1),KB,
*     &                             DSQ(ISD),1,FSQ(ISF),1)
*                      CALL DGEMX  (KB,LB,-Factor*ExFac,X2(1),KB,
*     &                             DSQ_ab(ISD),1,FSQ_ab(ISF),1)
                      CALL DGEMV_('N',KB,LB,-Factor*ExFac,X2(1),KB,
     &                             DSQ(ISD),1,1.0D0,FSQ(ISF),1)
                      CALL DGEMV_('N',KB,LB,-Factor*ExFac,X2(1),KB,
     &                             DSQ_ab(ISD),1,1.0D0,FSQ_ab(ISF),1)
                 endif
                    ENDIF
        if(myDebug) then
          write (6,'(a,i5,a,f12.6)')
     &          ('01 Fsq(',isf+ivv-1,')=',FSQ(ISF+ivv-1),ivv=1,kb)
          if(iUHF.eq.1) then
          write (6,'(a,i5,a,f12.6)')
     &          ('01 Fsq_ab(',isf+ivv-1,')=',FSQ_ab(ISF+ivv-1),ivv=1,kb)
          endif
        endif

201               CONTINUE
200             CONTINUE

              ELSE IF ( IS.EQ.JS .AND. IS.NE.KS ) THEN
c CASE 2: Integrals are of symmetry type (II/JJ)
c Coulomb terms need to be accumulated only
                IOPT=1
                LPQ=0
                IPQ=0
                NPQ=0
                DO 210 IP=1,IB
                  DO 211 JQ=1,IP
                    IPQ=IPQ+1
                    LPQ=LPQ+1
                    IF ( IPQ.GT.NPQ ) THEN
                      CALL RDORD(IRC,IOPT,IS,JS,KS,LS,X1,LBUF,NPQ)
                      IF(IRC.GT.1) GOTO 999
                      IOPT=2
                      IPQ=1
                    ENDIF
                    ISX=(IPQ-1)*KLB+1
                    IF ( NFI.NE.0 ) THEN
                      ISF=ISTLT(KS)+1
                      ISD=ISTLT(IS)+LPQ
                      TEMP=DLT(ISD)
                    if(iUHF.eq.1) then
                      TEMP=DLT(ISD)+DLT_ab(ISD)
                    endif
                      CALL DAXPY_(KLB,TEMP,X1(ISX),1,FLT(ISF),1)
                    if(iUHF.eq.1) then
                      CALL DAXPY_(KLB,TEMP,X1(ISX),1,FLT_ab(ISF),1)
                    endif
                    ENDIF
                    IF ( NFK.NE.0 ) THEN
                      ISF=ISTLT(IS)+LPQ
                      ISD=ISTLT(KS)+1
                      TEMP=DDOT_(KLB,X1(ISX),1,DLT(ISD),1)
                      FLT(ISF)=FLT(ISF)+TEMP
                if(iUHF.eq.1) then
                      TEMP_ab=DDOT_(KLB,X1(ISX),1,DLT_ab(ISD),1)
                      FLT(ISF)=FLT(ISF)+TEMP_ab
                      FLT_ab(ISF)=FLT(ISF)
                endif
        if(myDebug) then
          write (6,'(a,i5,a,f12.6)') '02 Flt(',isf,')=',FLT(ISF)
        endif

                    ENDIF
211               CONTINUE
210             CONTINUE
              ELSE IF ( IS.EQ.KS .AND. JS.EQ.LS ) THEN
c CASE 3: Integrals are of symmetry type (IJ/IJ)
c Exchange terms need to be accumulated only
                IOPT=1
                LPQ=0
                IPQ=0
                NPQ=0
                DO 220 IP=1,IB
                  DO 221 JQ=1,JB
                    IPQ=IPQ+1
                    LPQ=LPQ+1
                    IF ( IPQ.GT.NPQ ) THEN
                      CALL RDORD(IRC,IOPT,IS,JS,KS,LS,X1,LBUF,NPQ)
                      IF(IRC.GT.1) GOTO 999
                      IOPT=2
                      IPQ=1
                    ENDIF
                    ISX=(IPQ-1)*KLB+1
                    IF ( NFI.NE.0 ) THEN
                      ISD=ISTSQ(IS)+(IP-1)*IB+1
                      ISF=ISTSQ(JS)+(JQ-1)*JB+1
                      if(iUHF.eq.0) then
*                      CALL DGEMX  (LB,KB,-Factor*ExFac,X1(ISX),LB,
*     &                             DSQ(ISD),1,FSQ(ISF),1)
                      CALL DGEMV_('N',LB,KB,-Factor*ExFac,X1(ISX),LB,
     &                             DSQ(ISD),1,1.0D0,FSQ(ISF),1)
                      else
*                      CALL DGEMX  (LB,KB,-Factor*ExFac,X1(ISX),LB,
*     &                             DSQ(ISD),1,FSQ(ISF),1)
*                      CALL DGEMX  (LB,KB,-Factor*ExFac,X1(ISX),LB,
*     &                             DSQ_ab(ISD),1,FSQ_ab(ISF),1)
                      CALL DGEMV_('N',LB,KB,-Factor*ExFac,X1(ISX),LB,
     &                             DSQ(ISD),1,1.0D0,FSQ(ISF),1)
                      CALL DGEMV_('N',LB,KB,-Factor*ExFac,X1(ISX),LB,
     &                             DSQ_ab(ISD),1,1.0D0,FSQ_ab(ISF),1)
                      endif
                    ENDIF
                    IF ( NFJ.NE.0 ) THEN
                      ISD=ISTSQ(JS)+(JQ-1)*JB+1
                      ISF=ISTSQ(IS)+(IP-1)*IB+1
                      if(iUHF.eq.0) then
*                      CALL DGEMTX (LB,KB,-Factor*ExFac,X1(ISX),LB,
*     &                             DSQ(ISD),1,FSQ(ISF),1)
                      CALL DGEMV_('T',LB,KB,-Factor*ExFac,X1(ISX),LB,
     &                             DSQ(ISD),1,1.0D0,FSQ(ISF),1)
                      else
*                      CALL DGEMTX (LB,KB,-Factor*ExFac,X1(ISX),LB,
*     &                             DSQ(ISD),1,FSQ(ISF),1)
*                      CALL DGEMTX (LB,KB,-factor*ExFac,X1(ISX),LB,
*     &                             DSQ_ab(ISD),1,FSQ_ab(ISF),1)
                      CALL DGEMV_('T',LB,KB,-Factor*ExFac,X1(ISX),LB,
     &                             DSQ(ISD),1,1.0D0,FSQ(ISF),1)
                      CALL DGEMV_('T',LB,KB,-factor*ExFac,X1(ISX),LB,
     &                             DSQ_ab(ISD),1,1.0D0,FSQ_ab(ISF),1)

                      endif
                    ENDIF
        if(myDebug) then
          write (6,'(a,i5,a,f20.6)')
     &          ('03 Fsq(',isf+ivv-1,')=',FSQ(ISF+ivv-1),ivv=1,kb)
          if(iUHF.eq.1) then
          write (6,'(a,i5,a,f20.6)')
     &          ('03 Fsq_ab(',isf+ivv-1,')=',FSQ_ab(ISF+ivv-1),ivv=1,kb)
          endif
        endif

221               CONTINUE
220             CONTINUE
            ENDIF
130       CONTINUE
120     CONTINUE
110   CONTINUE

c Accumulate the contributions
      DO 300 ISYM=1,NSYM
        NB=NBAS(ISYM)
        K1=ISTLT(ISYM)
        K2=ISTSQ(ISYM)
        DO 310 IB=1,NB
          DO 315 JB=1,IB
c         write (6,'(a,i5,a,f12.6)') ' >> Flt(',K1+JB,')=',FLT(K1+JB)
c         write (6,'(a,i5,a,f12.6)') ' >> Fsq(',K2+JB,')=',FSQ(K2+JB)

            FLT(K1+JB)=FLT(K1+JB)+FSQ(K2+JB)
            if(iUHF.eq.1) then
             FLT_ab(K1+JB)=FLT_ab(K1+JB)+FSQ_ab(K2+JB)
            endif
        if(myDebug) then
         if(iUHF.eq.0)then
          write (6,'(a,i5,a,f12.6)') 'Flt(',K1+JB,')=',FLT(K1+JB)
          else
          write (6,'(a,i5,a,2f12.6)') 'Flt_ab(',K1+JB,')=',
     &               FLT(K1+JB),FLT_ab(K1+JB)
          endif
        endif

315       CONTINUE
          K1=K1+IB
          K2=K2+NB
310     CONTINUE
300   CONTINUE
*
      Call GADSum(Flt,nFlt)
      If (iUHF.eq.1) Call GADSum(Flt_ab,nFlt)
*
c Print the Fock-matrix
#ifdef _DEBUGPRINT_
      WRITE(6,'(6X,A)')'TEST PRINT FROM FTWOI.'
      WRITE(6,'(6X,A)')'FROZEN FOCK MATRIX IN AO BASIS:'
      ISTLTT=1
      DO ISYM=1,NSYM
        NB=NBAS(ISYM)
        IF ( NB.GT.0 ) THEN
          WRITE(6,'(6X,A,I2)')'SYMMETRY SPECIES:',ISYM
          CALL TRIPRT(' ',' ',FLT(ISTLTT),NB)
          if(iUHF.eq.1) then
          CALL TRIPRT(' ',' ',FLT_ab(ISTLTT),NB)
          endif
          ISTLTT=ISTLTT+NB*(NB+1)/2
        END IF
      END DO
      WRITE(6,'(6X,A)')'----------------------------'
#endif

      RETURN
 999  CONTINUE
      WRITE(6,*)' Error return code IRC=',IRC
      WRITE(6,*)' from RDORD call, in FTWOI.'
      CALL Abend
      END

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
*               1996-2006, David L. Cooper                             *
************************************************************************
      subroutine ppgs2_cvb(cvb,cvbdet,ifnss)
      implicit real*8 (a-h,o-z)
#include "main_cvb.fh"
#include "optze_cvb.fh"
#include "files_cvb.fh"
#include "print_cvb.fh"


#include "frag_cvb.fh"
#include "WrkSpc.fh"
      dimension cvb(nvb),cvbdet(ndetvb),ifnss(0:nel,0:nel)

c  First applicable configuration with first possible spin in
c  each fragment is set to perfect-pairing:
      call dcopy_(nvb,[1d-2],0,cvb,1)
      ioffs_cvb=0
      icoffs_nconf=0
      do 100 ifrag=1,nfrag
      nelsing=nel_fr(ifrag)-2*mnion_fr(ifrag)
      do 200 iS=1,nS_fr(ifrag)
      if(i2s_fr(iS,ifrag).le.nelsing)then
        cvb(ifnss(nelsing,i2s_fr(iS,ifrag))+ioffs_cvb)=1d0
        goto 300
      endif
200   continue
300   ioffs_cvb=ioffs_cvb+nvb_fr(ifrag)
      icoffs_nconf=icoffs_nconf+nconf_fr(ifrag)
100   continue
      kbasiscvb_kp=kbasiscvb
      kbasiscvb=1
      call str2vbc_cvb(cvb,cvbdet)
      kbasiscvb=kbasiscvb_kp
      call vb2strc_cvb(cvbdet,cvb)
      return
      end
c  Changes phases between alpha-beta separated determinants, and
c  determinants with increasing orbital numbers:

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine wri_cvb(ivec,n,file_id,ioffset)
      implicit real*8 (a-h,o-z)
#include "idbl_cvb.fh"
      dimension ivec(n)
      save ibuf
      dimension ibuf(8)
      data ibuf/8*0/

      call wri_cvb_internal(ivec,ibuf)
*
*     This is to allow type punning without an explicit interface
      contains
      subroutine wri_cvb_internal(ivec,ibuf)
      use iso_c_binding
      integer, target :: ivec(*),ibuf(*)
      real*8, pointer :: vec(:),buf(:)
      nreals=n/idbl
      nrem=n-nreals*idbl
      if(nreals.gt.0) then
        call c_f_pointer(c_loc(ivec(1)),vec,[nreals])
        call wrlow_cvb(vec,nreals,file_id,ioffset)
        nullify(vec)
      end if
      if(nrem.gt.0)then
        len=0
        call lendat_cvb(file_id,len)
        if(len.ge.1+nreals+ioffset) then
          call c_f_pointer(c_loc(ibuf(1)),buf,[1])
          call rdlow_cvb(buf,1,file_id,nreals+ioffset)
          nullify(buf)
        end if
        call imove_cvb(ivec(1+nreals*idbl),ibuf,nrem)
c  Trying for a "clean" write (unwritten integers written as zeros),
c  but explicit zeroing of ibuf is not necessary as long as idbl <= 2.
c        call izero(ibuf(nrem+1),idbl-nrem)
        call c_f_pointer(c_loc(ibuf(1)),buf,[1])
        call wrlow_cvb(buf,1,file_id,nreals+ioffset)
        nullify(buf)
      endif
      return
      end subroutine wri_cvb_internal
*
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) Per Ake Malmqvist                                      *
*               Ajitha Devarajan                                       *
************************************************************************
      Subroutine LYPPI(Rho,nRho,mGrid,dF_dRho,ndF_dRho,
     &                 Coeff,iSpin,F_xc,T_X)
************************************************************************
*                                                                      *
* Object:  Lyp Functional(Formula taken from Molpro Manual)            *
*                                                                      *
*      Author: Per-AAke Malmquist,Department of Theoretical Chemistry  *
*              University of LUnd, SWEDEN                              *
*              D. Ajitha , Department of Theoretical Chemistry         *
*              University of Lund, SWEDEN                              *
*              Modify Per-AAke's code for open shell case              *
*              and adopt for closed shell case                         *
************************************************************************
      Implicit Real*8 (A-H,O-Z)
#include "real.fh"
#include "nq_index.fh"
      Real*8 dF_dRho(ndF_dRho,mGrid),Rho(nRho,mGrid),F_xc(mGrid)
*
      dimension ec(0:4)
      data Cfconst / 2.8712340001881918D0 /
      data aconst,bconst,cconst,dconst
     &        /0.04918d0,0.132d0,0.2533d0,0.349d0/
* Constants aconst,..,dconst are from ???
* Cfconst is = (3/10)*(3*Pi**2)**(2/3)
      Cfconst2=Cfconst*2.0D0**(11.0D0/3)
      Rho_min=T_X*1.0D-2
*                                                                      *
************************************************************************
*                                                                      *
*     Some constants which we need...
*
      qCS = 2.29d0
      SqrtPi = sqrt(Pi)
      Pi32 = sqrt(Pi)*Pi
      Pi2  = Pi*Pi
      Pi52 = sqrt(Pi)*Pi2
      SqrtTwo = sqrt(Two)
      aConst=0.049180d0
      bConst=0.1320d0
      dConst=0.3490d0
      cConst=0.25330d0
      Cf=2.8712340001881918D0
*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=1
*
************************************************************************
      Call dScal_(nRho*iSpin*mGrid,2.0d0,Rho,1)
      If (iSpin.eq.1) Then
*                                                                      *
************************************************************************
*                                                                      *
      Do iGrid = 1, mGrid
*
      Dns = Rho(ipR,iGrid)
      if(Dns.lt.T_X) Go To 100
      gradRho2=ddot_(3,Rho(ipdRx,iGrid),1,Rho(ipdRx,iGrid),1)
      gradRho=sqrt(gradRho2)
      grad2Rho = Rho(ipL,iGrid)

      t1 = aConst*bConst
      t2 = Dns**(1.D0/3.D0)
      t3 = 1/t2
      t5 = exp(-cConst*t3)
      t7 = 1+dConst*t3
      t8 = 1/t7
      t9 = t5*t8
      t10 = t2**2
      t13 = t9/t10/Dns
      t16 = Dns**2
      t17 = 1/t16
      t18 = t1*t17
      t19 = cConst*t5
      t23 = t7**2
      t24 = 1/t23
      t25 = t5*t24
      t29 = 7.D0/36.D0*t1*t13-7.D0/72.D0*t18*t19*t8-7.D0/72.D0*t18*t25*d
     &Const
      t30 = gradRho2
      t34 = t10*t16
      t38 = t1*(Cf*t34-17.D0/72.D0*t30)
      Fxc = -t29*t30-aConst*Dns*t8-t38*t13
      t40 = t1*cConst
      t41 = t16*Dns
      t42 = 1/t41
      t47 = t1*t5
      t52 = 1/t34
      t53 = t9*t52
      t58 = t1/t2/t41
      t59 = cConst**2
      t64 = t24*dConst
      t71 = dConst**2
      t76 = (7.D0/27.D0*t40*t42*t5*t8+7.D0/27.D0*t47*t24*t42*dConst-35.D
     &0/108.D0*t1*t53-7.D0/216.D0*t58*t59*t5*t8-7.D0/108.D0*t58*t19*t64-
     &7.D0/108.D0*t58*t5/t23/t7*t71)*t30
      dFdDns = -t76-aConst*t8-aConst*t3*t64/3-8.D0/3.D0*t1*Cf*t5*t8-t38*
     &cConst*t42*t9/3-t38*t25*t42*dConst/3+5.D0/3.D0*t38*t53
      t100 = t2+dConst
      t101 = 1/t100
      t117 = t100**2
      Grad = 2*t29*grad2Rho+2*t76-17.D0/36.D0*t47/t2/Dns*t101*grad2Rho-2
     &*(17.D0/216.D0*t40*t52*t5*t101-17.D0/54.D0*t1*t5/t2/t16*t101-17.D0
     &/216.D0*t1*t5*t17/t117)*t30

*
      F_xc(iGrid) = Fxc
      dF_dRho(ipR,iGrid)= dFdDns + Grad
*
100   Continue
      End Do

*                                                                      *
************************************************************************
*                                                                      *
*     iSpin=/= 1
      Else
*                                                                      *
************************************************************************
*                                                                      *
*
      Do iGrid = 1, mGrid
      rhoa=Max(Rho_min,Rho(ipRa,iGrid))
      rhob=Max(Rho_min,Rho(ipRb,iGrid))
      rho_tot=rhoa+rhob
      if(rho_tot.lt.T_X) Go To 200
      gxa=Rho(ipdRxa,iGrid)
      gya=Rho(ipdRya,iGrid)
      gza=Rho(ipdRza,iGrid)
      gxb=Rho(ipdRxb,iGrid)
      gyb=Rho(ipdRyb,iGrid)
      gzb=Rho(ipdRzb,iGrid)

      gx=gxa+gxb
      gy=gya+gyb
      gz=gza+gzb

      rho3=rho_tot**(-1.0D0/3)
      crho3=cconst*rho3
      R=1/(1+dconst*rho3)
      if(crho3.lt.709.0d0) then
        expcr=exp(-crho3)
      else
        expcr=0.0D0
      end if
      omega=expcr*R*rho_tot**(-11.0D0/3)
      delta=crho3+1-R
      dlogodr=(delta-11)/(3*rho_tot)
      ddeltadr=-(crho3+R*(1-R))/(3*rho_tot)
      p=aconst*bconst*omega

      ec1=-(4*aconst*R)*rhoa*(rhob/rho_tot)

      dec1dra=(ec1*(1-R)/(3*rho_tot))-(4*aconst*R)*(rhob/rho_tot)**2
      dec1drb=(ec1*(1-R)/(3*rho_tot))-(4*aconst*R)*(rhoa/rho_tot)**2

      tmp1=-Cfconst2*p*rhoa**(11.0D0/3)*rhob
      tmp2=-Cfconst2*p*rhob**(11.0D0/3)*rhoa
      ec2=tmp1+tmp2
      dec2dra=(ec2*dlogodr)+(11*tmp1+3*tmp2)/(3*rhoa)
      dec2drb=(ec2*dlogodr)+(3*tmp1+11*tmp2)/(3*rhob)

      sa=gxa**2+gya**2+gza**2
      sb=gxb**2+gyb**2+gzb**2
      s =gx**2+gy**2+gz**2
      pp=-p*rhoa*rhob/(18*rho_tot)
      dppdra=((dlogodr-1/rho_tot)+1/rhoa)*pp
      dppdrb=((dlogodr-1/rho_tot)+1/rhob)*pp
      dqq1ds =47*rho_tot
      dqq1dsa=22*rhoa-45*rho_tot
      dqq1dsb=22*rhob-45*rho_tot
      dqq2ds =-7*rho_tot
      dqq2dsa= rhob-rhoa
      dqq2dsb= rhoa-rhob
      dqqds =dqq1ds +delta*dqq2ds
      dqqdsa=dqq1dsa+delta*dqq2dsa
      dqqdsb=dqq1dsb+delta*dqq2dsb
      dqq1dra=47*s-23*sa-45*sb
      dqq1drb=47*s-45*sa-23*sb
      qq1=dqq1dra*rhoa+dqq1drb*rhob
      dqq2dra=-7*s -sa +sb
      dqq2drb=-7*s +sa -sb
      qq2=dqq2dra*rhoa+dqq2drb*rhob
      dqqdra=dqq1dra+dqq2dra*delta+qq2*ddeltadr
      dqqdrb=dqq1drb+dqq2drb*delta+qq2*ddeltadr
      qq=qq1+qq2*delta
      ec3=pp*qq
      dec3dra=dppdra*qq+pp*dqqdra
      dec3drb=dppdrb*qq+pp*dqqdrb
      dec3ds =pp*dqqds
      dec3dsa=pp*dqqdsa
      dec3dsb=pp*dqqdsb

      dqdra=((4.0D0/3)*rho_tot*(s-sa-sb))+2*rhoa*sb
      dqdrb=((4.0D0/3)*rho_tot*(s-sa-sb))+2*rhob*sa
      q=(dqdra*rhoa+dqdrb*rhob)/2
      ec4=p*q
      dec4dra=dlogodr*ec4+p*dqdra
      dec4drb=dlogodr*ec4+p*dqdrb
      dec4ds =p*(2.0D0/3)*(rho_tot**2)
      dec4dsa=p*(rhob**2)-dec4ds
      dec4dsb=p*(rhoa**2)-dec4ds

      dec34ds =dec3ds +dec4ds
      dec34dsa=dec3dsa+dec4dsa
      dec34dsb=dec3dsb+dec4dsb

      ec(0)=ec1+ec2+ec3+ec4
      ec(1)=ec1
      ec(2)=ec2
      ec(3)=ec3
      ec(4)=ec4

      Functional= ec1+ec2+ec3+ec4
      F_xc(iGrid)=F_xc(iGrid)+Coeff*functional
*                                                                      *
************************************************************************
*                                                                      *
*
      dF_dRho(ipRa,iGrid)=dF_dRho(ipRa,iGrid)
     &                   +Coeff*(dec1dra+dec2dra+dec3dra+dec4dra)
      dF_dRho(ipRb,iGrid)=dF_dRho(ipRb,iGrid)
     &                   +Coeff*(dec1drb+dec2drb+dec3drb+dec4drb)

      dF_dRho(ipdRxa,iGrid)=dF_dRho(ipdRxa,iGrid)
     &                   +2*Coeff*(dec34ds*gx+dec34dsa*gxa)
      dF_dRho(ipdRya,iGrid)=dF_dRho(ipdRy,iGrid)
     &                   +2*Coeff*(dec34ds*gy+dec34dsa*gya)
      dF_dRho(ipdRza,iGrid)=dF_dRho(ipdRza,iGrid)
     &                   +2*Coeff*(dec34ds*gz+dec34dsa*gza)
      dF_dRho(ipdRxb,iGrid)=dF_dRho(ipdRxb,iGrid)
     &                   +2*Coeff*(dec34ds*gx+dec34dsb*gxb)
      dF_dRho(ipdRyb,iGrid)=dF_dRho(ipdRyb,iGrid)
     &                   +2*Coeff*(dec34ds*gy+dec34dsb*gyb)
      dF_dRho(ipdRzb,iGrid)=dF_dRho(ipdRzb,iGrid)
     &                   +2*Coeff*(dec34ds*gz+dec34dsb*gzb)

200   Continue
      End Do
      Endif
*
      Return
      End

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1989, Per Ake Malmqvist                                *
************************************************************************
*****************************************************************
*  PROGRAM RASSI        PER-AAKE MALMQVIST
*  SUBROUTINE TRACR     IBM-3090 RELEASE 89 01 30
*  TRANSFORM ONE SPECIFIC SYMMETRY BLOCK OF TWO-ELECTRON
*  INTEGRALS. THIS ROUTINE IS CALLED FROM TRAINT.
*****************************************************************
      SUBROUTINE TRACR(LBUF,CMO1,CMO2,NGAM2,TUVX,X1,X2,X3,VXPQ)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X1(NX1MX),X2(NX2MX),X3(NX3MX),VXPQ(NVXPQ)
      DIMENSION CMO1(NCMO),CMO2(NCMO),TUVX(NGAM2)
#include "rassi.fh"
#include "trnsfrm.fh"
C START LOOP OVER ORDERED AO-INTEGRALS: NPQ PQ-PAIRS IN EACH BUFFER.
C FOR EACH PQ PAIR, THERE IS A MATRIX CONTAINING THE (PQ,RS)
C INTEGRALS. INDEX S RUNS FASTEST, SO BY FORTRAN RULES, IF REGARDED
C AS A MATRIX JPQ(R,S), THEN THE MATRIX IS TRANSPOSED. IF ISR=ISS,
C THE MATRIX IS STORED IN ROW-MAJOR UNDERTRIANGULAR FORMAT.
C IN THE COMMENTS, NOTE THAT T,U, ETC DENOTES ACTUAL ORBITAL
C INDICES, WHILE IT,IU ETC ARE COUNTERS WITHIN THE SYMMETRY BLOCKS.
      IRC=0
      IOPT=1
      IPQ=0
      LPQ=0
      NPQ=0
      IRSST=1-NBRS
      DO 10 NP=1,NBP
       NQM=NBQ
       IF(ISP.EQ.ISQ) NQM=NP
       DO 9 NQ=1,NQM
        IPQ=IPQ+1
C IF NECESSARY, READ IN A FRESH INTEGRAL BUFFER OF NPQ MATRICES:
        IF(LPQ.EQ.NPQ) THEN
          CALL RDORD(IRC,IOPT,ISP,ISQ,ISR,ISS,X1,LBUF,NPQ)
          IOPT=2
          LPQ=0
          IRSST=1-NBRS
        ENDIF
        LPQ=LPQ+1
        IRSST=IRSST+NBRS
C START TRANSFORMATION OF THIS PQ=PAIR
        IF(ISR.EQ.ISS) THEN
          CALL SQUARE(X1(IRSST),X2,1,NBR,NBR)
        ELSE
          CALL DCOPY_(NBR*NBS,X1(IRSST),1,X2,1)
        ENDIF
C X2 CONTAINS THE MATRIX JPQ TRANSPOSED, X2(IS,IR)=JPQ(R,S)=(PQ/RS).
         CALL DGEMM_('T','N',NBR,NAS,NBS,1.0D0,
     &              X2,NBS,CMO2(LMOS1),NBS,
     &        0.0D0,X3,NBR)
         CALL DGEMM_('T','N',NAS,NAR,NBR,1.0D0,
     &              X3,NBR,CMO1(LMOR1),NBR,
     &        0.0D0,X2,NAS)
C X2 IS TRANSFORMED JPQ MATRIX, TRANSPOSED: X2(IX,IV)=(PQ/VX).
C SORT THE MATRIX X2 INTO VXPQ (SORT AFTER PQ INSTEAD OF VX).
        CALL DCOPY_(NAVX,X2,1,VXPQ(IPQ),NBPQ)
9      CONTINUE
10    CONTINUE
C FIRST HALF TRANSFORMATION IS NOW DONE.VXPQ CONTAINS HALF TRANS-
C FORMED INTEGRALS FOR THIS SYMMETRY BLOCK: VXPQ(IPQ,IX,IV)=(PQ/VX).
C NOTE: V IS FIRST ORBITAL SET, X SECOND
C NOW TRANSFORM INDICES PQ TO TU FOR ALL (TU).GE.(VX)
C FORTRAN ORDER IMPLIES THEN THAT U>=X AND, IF U=X, THEN T>=V.
      IPQST=1-NBPQ
      DO 20 IV=1,NAR
        IVF=IV+IAPR(ISR)
        DO 21 IX=1,NAS
          IXF=IX+IAPR(ISS)
          IVX=IVF+NASHT*(IXF-1)
          IPQST=IPQST+NBPQ
          IF(ISP.EQ.ISQ) THEN
            CALL SQUARE(VXPQ(IPQST),X3,1,NBP,NBP)
          ELSE
            CALL DCOPY_(NBPQ,VXPQ(IPQST),1,X3,1)
          ENDIF
C X3 IS HALF-TRANSFORMED JVX MATRIX, TRANSPOSED. X3(IQ,IP)=(PQ/VX).
C WHEN TRANSFORMING, SKIP INDICES U=1..IUM.
          IUM=0
          IF(ISQ.EQ.ISS) IUM=IX-1
         CALL DGEMM_('T','N',NBP,NAQ-IUM,NBQ,1.0D0,
     &              X3,NBQ,CMO2(LMOQ1+IUM*NBQ),NBQ,
     &        0.0D0,X1,NBP)
C X1(IU,IP) = (PU/VX) FOR THE GIVEN VX, ALL P, AND U>=X, WHERE P
C IS BASIS FUNCTIONS IN SYMMETRY ISP, U AND X ARE ACTIVE ORBITALS
C OF STATE 2 IN SYMMETRIES ISQ AND ISS, RESP., AND V IS ACTIVE ORB
C OF STATE 1 AND HAS SYMMETRY ISR.
         CALL DGEMM_('T','N',NAQ-IUM,NAP,NBP,1.0D0,
     &              X1,NBP,CMO1(LMOP1),NBP,
     &        0.0D0,X2,NAQ-IUM)
C X2 NOW CONTAINS THE TRANSFORMED JVX MATRIX TRANSPOSED, I.E.,
C X2(IU-IUM,IT)=JVX(T,U)=(TU/VX), IU=IUM+1,..,NAQ,  IT=1,..,NAP.
          II=0
          DO 14 IT=1,NAP
            ITF=IT+IAPR(ISP)
            DO 15 IU=IUM+1,NAQ
              IUF=IU+IAPR(ISQ)
              II=II+1
              ITU=ITF+NASHT*(IUF-1)
              IF(ITU.LT.IVX) THEN
                ITUVX=(IVX*(IVX-1))/2+ITU
              ELSE
                ITUVX=(ITU*(ITU-1))/2+IVX
              END IF
              TUVX(ITUVX)=X2(II)
15          CONTINUE
14        CONTINUE
      IF(ISP.EQ.ISQ) GOTO 21
C X3 STILL CONTAINS THE JVX MATRIX, TRANSPOSED. X3(IQ,IP)=(PQ/VX).
C PERM SYMMETRY OF P AND Q MEANS WE CAN LET THEM SWITCH IDENTITY.
C FOR REMAINDER OF LOOP 21, IF ISP.NE.ISQ, THEN REGARD X3 AS
C CONTAINING X3(IQ,IP)=(QP/VX) AND TRANSFORM AS BEFORE.
C WHEN TRANSFORMING, SKIP INDICES U=1..IUM.
          IUM=0
          IF(ISP.EQ.ISS) IUM=IX-1
         CALL DGEMM_('N','N',NBQ,NAP-IUM,NBP,1.0D0,
     &              X3,NBQ,CMO2(LMOP1+IUM*NBP),NBP,
     &        0.0D0,X1,NBQ)
C X1(IQ,IU) = (QU/VX) FOR THE GIVEN VX, ALL Q, AND U>=X, WHERE Q
C IS BASIS FUNCTIONS IN SYMMETRY ISQ, U AND X ARE ACTIVE ORBITALS
C OF STATE 2 IN SYMMETRIES ISP AND ISS, RESP., AND V IS ACTIVE ORB
C OF STATE 1 AND HAS SYMMETRY ISR.
         CALL DGEMM_('T','N',NAP-IUM,NAQ,NBQ,1.0D0,
     &              X1,NBQ,CMO1(LMOQ1),NBQ,
     &        0.0D0,X2,NAP-IUM)
C X2 NOW CONTAINS THE TRANSFORMED JVX MATRIX TRANSPOSED, I.E.,
C X2(IU-IUM,IT)=JVX(T,U)=(TU/VX), IU=IUM+1,..,NAP,  IT=1,..,NAQ.
          II=0
          DO 16 IT=1,NAQ
            ITF=IT+IAPR(ISQ)
            DO 17 IU=IUM+1,NAP
              IUF=IU+IAPR(ISP)
              II=II+1
              ITU=ITF+NASHT*(IUF-1)
              IF(ITU.LT.IVX) THEN
                ITUVX=(IVX*(IVX-1))/2+ITU
              ELSE
                ITUVX=(ITU*(ITU-1))/2+IVX
              END IF
              TUVX(ITUVX)=X2(II)
17          CONTINUE
16        CONTINUE
21      CONTINUE
20    CONTINUE
      IF(ISR.EQ.ISS) GOTO 100
C NOW REPEAT IT ALL OVER AGAIN. THIS TIME, USE PERMUTATION
C SYMMETRY TO SWITCH IDENTITY OF BASIS INDICES R AND S.
      IRC=0
      IOPT=1
      IPQ=0
      LPQ=0
      NPQ=0
      IRSST=1-NBRS
      DO 30 NP=1,NBP
       NQM=NBQ
       IF(ISP.EQ.ISQ) NQM=NP
       DO 29 NQ=1,NQM
        IPQ=IPQ+1
C IF NECESSARY, READ IN A FRESH INTEGRAL BUFFER OF NPQ MATRICES:
        IF(LPQ.EQ.NPQ) THEN
          CALL RDORD(IRC,IOPT,ISP,ISQ,ISR,ISS,X1,LBUF,NPQ)
          IOPT=2
          LPQ=0
          IRSST=1-NBRS
        ENDIF
        LPQ=LPQ+1
        IRSST=IRSST+NBRS
        CALL DCOPY_(NBR*NBS,X1(IRSST),1,X2,1)
C X2 CONTAINS THE MATRIX JPQ , X2(IS,IR)=JPQ(S,R)=(PQ/SR).
C NOTE THAT SYMMETRY OF R IS ISS AND SYMMETRY OF S IS ISR NOW.
         CALL DGEMM_('N','N',NBS,NAR,NBR,1.0D0,
     &              X2,NBS,CMO2(LMOR1),NBR,
     &        0.0D0,X3,NBS)
         CALL DGEMM_('T','N',NAR,NAS,NBS,1.0D0,
     &              X3,NBS,CMO1(LMOS1),NBS,
     &        0.0D0,X2,NAR)
C X2 IS TRANSFORMED JPQ MATRIX, TRANSPOSED: X2(IX,IV)=(PQ/VX).
C SORT THE MATRIX X2 INTO VXPQ (SORT AFTER PQ INSTEAD OF VX).
        CALL DCOPY_(NAVX,X2,1,VXPQ(IPQ),NBPQ)
29     CONTINUE
30    CONTINUE
C AS BEFORE, EXCEPT THAT SYMMETRY OF V IS ISS, SYMMETRY OF X IS ISR.
C NOW TRANSFORM INDICES PQ TO TU FOR ALL (TU).GE.(VX)
C FORTRAN ORDER IMPLIES THEN THAT U>=X AND, IF U=X, THEN T>=V.
      IPQST=1-NBPQ
      DO 40 IV=1,NAS
        IVF=IV+IAPR(ISS)
        DO 41 IX=1,NAR
          IXF=IX+IAPR(ISR)
          IVX=IVF+NASHT*(IXF-1)
          IPQST=IPQST+NBPQ
          IF(ISP.EQ.ISQ) THEN
            CALL SQUARE(VXPQ(IPQST),X3,1,NBP,NBP)
          ELSE
            CALL DCOPY_(NBPQ,VXPQ(IPQST),1,X3,1)
          ENDIF
C X3 IS HALF-TRANSFORMED JVX MATRIX, TRANSPOSED. X3(IQ,IP)=(PQ/VX).
C WHEN TRANSFORMING, SKIP INDICES U=1..IUM.
          IUM=0
          IF(ISQ.EQ.ISR) IUM=IX-1
          CALL DGEMM_('T','N',NBP,NAQ-IUM,NBQ,1.0D0,
     &               X3,NBQ,CMO2(LMOQ1+IUM*NBQ),NBQ,
     &        0.0D0, X1,NBP)
C X1(IU,IP) = (PU/VX) FOR THE GIVEN VX, ALL P, AND U>=X, WHERE P
C IS BASIS FUNCTIONS IN SYMMETRY ISP, U AND X ARE ACTIVE ORBITALS
C OF STATE 2 IN SYMMETRIES ISQ AND ISR, RESP., AND V IS ACTIVE ORB
C OF STATE 1 AND HAS SYMMETRY ISS.
          CALL DGEMM_('T','N',NAQ-IUM,NAP,NBP,1.0D0,
     &               X1,NBP,CMO1(LMOP1),NBP,
     &        0.0D0, X2,NAQ-IUM)
C X2 NOW CONTAINS THE TRANSFORMED JVX MATRIX TRANSPOSED, I.E.,
C X2(IU,IT)=JVX(T,U)=(TU/VX), IU=IUM+1,..,NAQ,  IT=1,..,NAP.
          II=0
          DO 34 IT=1,NAP
            ITF=IT+IAPR(ISP)
            DO 35 IU=IUM+1,NAQ
              IUF=IU+IAPR(ISQ)
              II=II+1
              ITU=ITF+NASHT*(IUF-1)
              IF(ITU.LT.IVX) THEN
                ITUVX=(IVX*(IVX-1))/2+ITU
              ELSE
                ITUVX=(ITU*(ITU-1))/2+IVX
              END IF
              TUVX(ITUVX)=X2(II)
35          CONTINUE
34        CONTINUE
      IF(ISP.EQ.ISQ) GOTO 41
C X3 STILL CONTAINS THE JVX MATRIX, TRANSPOSED. X3(IQ,IP)=(PQ/VX).
C PERM SYMMETRY OF P AND Q MEANS WE CAN LET THEM SWITCH IDENTITY.
C FOR REMAINDER OF LOOP 41, IF ISP.NE.ISQ, THEN REGARD X3 AS
C CONTAINING X3(IQ,IP)=(QP/VX) AND TRANSFORM AS BEFORE.
C WHEN TRANSFORMING, SKIP INDICES U=1..IUM.
          IUM=0
          IF(ISP.EQ.ISR) IUM=IX-1
          CALL DGEMM_('N','N',NBQ,NAP-IUM,NBP,1.0D0,
     &               X3,NBQ,CMO2(LMOP1+IUM*NBP),NBP,
     &        0.0D0, X1,NBQ)
C X1(IQ,IU) = (QU/VX) FOR THE GIVEN VX, ALL Q, AND U>=X, WHERE Q
C IS BASIS FUNCTIONS IN SYMMETRY ISQ, U AND X ARE ACTIVE ORBITALS
C OF STATE 2 IN SYMMETRIES ISP AND ISR, RESP., AND V IS ACTIVE ORB
C OF STATE 1 AND HAS SYMMETRY ISS.
          CALL DGEMM_('T','N',NAP-IUM,NAQ,NBQ,1.0D0,
     &               X1,NBQ,CMO1(LMOQ1),NBQ,
     &        0.0D0, X2,NAP-IUM)
C X2 NOW CONTAINS THE TRANSFORMED JVX MATRIX TRANSPOSED, I.E.,
C X2(IU,IT)=JVX(T,U)=(TU/VX), IU=IUM+1,..,NAP,  IT=1,..,NAQ.
          II=0
          DO 36 IT=1,NAQ
            ITF=IT+IAPR(ISQ)
            DO 37 IU=IUM+1,NAP
              IUF=IU+IAPR(ISP)
              II=II+1
              ITU=ITF+NASHT*(IUF-1)
              IF(ITU.LT.IVX) THEN
                ITUVX=(IVX*(IVX-1))/2+ITU
              ELSE
                ITUVX=(ITU*(ITU-1))/2+IVX
              END IF
              TUVX(ITUVX)=X2(II)
37          CONTINUE
36        CONTINUE
41      CONTINUE
40    CONTINUE
100   CONTINUE
*
      RETURN
      END

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1991, Jeppe Olsen                                      *
!***********************************************************************

!#define _DEBUGPRINT_
subroutine ORBINF_MCLR(NIRREP,NRAS1,NRAS2,NRAS3,MXR4tp)
! Obtain information about orbitals from shell information
!
! =====
! input
! =====
! Shell and symmetry information in /LUCINP/
!
! ======
! Output
! ======
! Orbital information in /ORBINP/

use MCLR_Data, only: IBSO, IBTSOB, IREOTS, ISMFTO, ITSOB, NACOB, NOBPT, NOBPTS, NOCOB, NORB1, NORB2, NORB3, NTOOB, NTSOB
use stdalloc, only: mma_allocate, mma_deallocate
use Definitions, only: iwp
#ifdef _DEBUGPRINT_
use Definitions, only: u6
#endif

implicit none
integer(kind=iwp), intent(in) :: NIRREP, NRAS1(NIRREP), NRAS2(NIRREP), NRAS3(NIRREP), MXR4tp
integer(kind=iwp) :: NNOBPT
#ifdef _DEBUGPRINT_
integer(kind=iwp) :: I
#endif
integer(kind=iwp), allocatable :: NRSOBS(:,:), NTOOBS(:)

!***********************************************
!                                              *
! Part 1 : From shell format to orbital format *
!                                              *
!***********************************************

! 2 : Shell information to orbital information for each group of orbital

call mma_allocate(NTOOBS,NIRREP,Label='NTOOBS')
call mma_allocate(NRSOBS,NIRREP,3,Label='NRSOBS')

! RAS1, RAS2, RAS3
NRSOBS(:,1) = NRAS1(1:NIRREP)
NRSOBS(:,2) = NRAS2(1:NIRREP)
NRSOBS(:,3) = NRAS3(1:NIRREP)
NORB1 = sum(NRSOBS(:,1))
NORB2 = sum(NRSOBS(:,2))
NORB3 = sum(NRSOBS(:,3))

! Active, occupied  and total number of orbitals
NACOB = NORB1+NORB2+NORB3
NOCOB = NACOB
NTOOBS(:) = NRSOBS(:,1)+NRSOBS(:,2)+NRSOBS(:,3)
NTOOB = sum(NTOOBS)

#ifdef _DEBUGPRINT_
write(u6,*)
write(u6,*) ' ORBINF_MCLR speaking'
write(u6,*) ' ===================='
write(u6,*) ' Number of orbitals per symmetry + total'
write(u6,'(1X,A,10I4,8X,I3)') '     Ras1             ',(NRSOBS(I,1),I=1,NIRREP),NORB1
write(u6,'(1X,A,10I4,8X,I3)') '     Ras2             ',(NRSOBS(I,2),I=1,NIRREP),NORB2
write(u6,'(1X,A,10I4,8X,I3)') '     Ras3             ',(NRSOBS(I,3),I=1,NIRREP),NORB3
write(u6,'(1X,A,10I4,8X,I3)') '     Total            ',(NTOOBS(I),I=1,NIRREP),NTOOB
#endif

!*******************************************
!                                          *
! Part 2 : Reordering arrays for orbitals  *
!                                          *
!*******************************************
NNOBPT = size(NOBPT)
call ORBORD(NIRREP,MXR4TP,NRSOBS,NTOOBS,IREOTS,ISMFTO,IBSO,NTSOB,IBTSOB,ITSOB,NOBPTS,NNOBPT,NOBPT)

call mma_deallocate(NTOOBS)
call mma_deallocate(NRSOBS)

end subroutine ORBINF_MCLR

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2017, Roland Lindh                                     *
************************************************************************
      SubRoutine PrFin2(Ovlp,nDT,OccNo,nEO,CMO,nCMO,note)
      Implicit Real*8 (a-h,o-z)
*
      Real*8 Ovlp(nDT),OccNo(nEO),CMO(nBB)
* PAM 2007: Changed dimension of CMO array from nCMO to NBB:
* The larger size is needed here, and the allocated size is nBB.
      Character*80 Note
*
#include "real.fh"
#include "mxdm.fh"
#include "infscf.fh"
#include "file.fh"
#include "stdalloc.fh"
#include "rctfld.fh"
#include "oneswi.fh"
*
*---- Define local variables
      Real*8, Dimension(:), Allocatable:: Scr2

#include "SysDef.fh"
*
*---- Write orbitals on the file (the case InVec=3 and nIter=0
*     is set up in RdInp)
      If (jVOut.ge.2) Then
*
*------- Allocate memory for expanded CMO's and occupation numbers
         Call mma_allocate(Scr2,nBB,Label='Scr2')
*
*------- Prepare CMO in symmetry blocks nBas x nBas
         iVec  = 0
         iCMO  = 0
*         iseed = 153759
         Do iSym = 1, nSym
            Do i = 1, nBas(iSym)*nOrb(iSym)
               Scr2(iVec + i) = CMO(iCMO + i)
            End Do
            iVec = iVec + nBas(iSym)*nOrb(iSym)
            Do i = 1, nBas(iSym)*(nBas(iSym) - nOrb(iSym))
*              Scr2(iVec + i) = Random(iseed) - Half
               Scr2(iVec + i) = Zero
            End Do
            iVec = iVec + nBas(iSym)*(nBas(iSym) - nOrb(iSym))
            iCMO = iCMO + nOrb(iSym)*nBas(iSym)
         End Do
         Do i = 1, nBB
            CMO(i)=Scr2(i)
         End Do
*
*------- Prepare occupation numbers
         iOr = 0
         iBs = 0
         Do iSym = 1, nSym
            Do j = 1, nOrb(iSym)
               Scr2(iBs + j) = OccNo(iOr + j)
            End Do
            Do j = nOrb(iSym) + 1, nBas(iSym)
               Scr2(iBs + j) = Zero
            End Do
            iOr = iOr + nOrb(iSym)
            iBs = iBs + nBas(iSym)
         End Do
         Do i = 1, nnB
            OccNo(i) = Scr2(i)
         End Do
*
         Do iSym = 1, nSym
            nOrb(iSym) = nBas(iSym)
         End Do
         Call SetUp()
*
*------- Orthogonalize vectors
         Call Ortho(CMO,nCMO,Ovlp,nBT)
*
*------- Write on the file
         If (KSDFT.eq.'SCF') Then
            If(iUHF.eq.0) Then
               Note='* SCF orbitals'
               If (kIVO.ne.0 ) Note='* SCF orbitals + IVO'
               If (iCoCo.ne.0)
     &            Note='* SCF orbitals + arbitrary occupations'
            Else
               Note='* UHF orbitals'
               If (kIVO.ne.0 ) Note='* UHF orbitals + IVO'
               If (iCoCo.ne.0)
     &            Note='* UHF orbitals + arbitrary occupations'
            End If
         Else
            If(iUHF.eq.0) Then
               Note='* RKS-DFT orbitals'
               If (kIVO.ne.0 ) Note='* RKS-DFT orbitals + IVO'
               If (iCoCo.ne.0)
     &            Note='* RKS-DFT orbitals + arbitrary occupations'
            Else
               Note='* UKS-DFT orbitals'
               If (kIVO.ne.0 ) Note='* UKS-DFT orbitals + IVO'
               If (iCoCo.ne.0)
     &            Note='* UKS-DFT orbitals + arbitrary occupations'
            End If
         End If
*
*------- Deallocate memory for expanded CMO's and occupation numbers
         Call mma_deallocate(Scr2)
      End If
*
*----------------------------------------------------------------------*
*     Exit                                                             *
*----------------------------------------------------------------------*
*
      Return
      End

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Vladislav Kochetov                               *
!***********************************************************************

subroutine read_input()
! Purpose: process input file and print summary at the end

use rhodyn_data, only: alpha, amp, basis, dm_basis, errorthreshold, finaltime, flag_acorrection, flag_decay, flag_dipole, &
                       flag_diss, flag_dyson, flag_emiss, flag_fdm, flag_pulse, flag_so, cgamma, HRSO, initialtime, ion_diss, &
                       ipglob, ispin, istates, kext, linear_chirp, lroots, method, N, N_L2, N_L3, N_Populated, N_pulse, nconf, &
                       ndet, Nmode, Nstate, Nval, omega, p_style, phi, power_shape, pulse_type, pulse_vector, runmode, safety, &
                       scha, scmp, sdbl, sigma, sint, slog, T, tau_L2, tau_L3, taushift, time_fdm, timestep, tout
use rhodyn_utils, only: dashes
use stdalloc, only: mma_allocate, mma_deallocate
use Constants, only: Zero, One, cZero, cOne, auToFs, auToCm, auToeV, pi
use definitions, only: wp, iwp, u6

implicit none
integer(kind=iwp) :: i, istatus, j, luin
character(len=256) :: line
character(len=32) :: tryname
character(len=*), parameter :: input_id = '&RHODYN'

call SpoolInp(luin)
! Find beginning of input:
do
  read(luin,'(A72)') line
  call normal(line)
  if (line(1:8) == input_id) exit
end do

do
  read(luin,'(A72)',iostat=istatus) line
  if (istatus < 0) exit
  call normal(line)
  if (line(1:1) == '*') cycle
  if (line == ' ') cycle
  select case (line(1:4))
    case ('NRSM')
      read(luin,*) N
      call mma_allocate(ndet,N)
      call mma_allocate(nconf,N)
      call mma_allocate(lroots,N)
      call mma_allocate(ispin,N)
    case ('NRDE')
      do i=1,N
        read(luin,*) ndet(i),nconf(i),lroots(i),ispin(i)
      end do
    case ('POPU')
      read(luin,'(A)') p_style
      call upCase(p_style)
      if ((p_style /= 'DET') .and. (p_style /= 'CSF') .and. (p_style /= 'SF') .and. (p_style /= 'SO') .and. &
          (p_style /= 'SO_THERMAL') .and. (p_style /= 'SF_THERMAL') .and. (p_style /= 'FROMFILE')) then
        call WarningMessage(2,'Unknown option for POPUlation style')
        call abend()
      end if
    case ('NRPO')
      read(luin,*) N_Populated
    case ('TEMP')
      read(luin,*) T
    case ('IFSO')
      flag_so = .true.
    case ('NMOD')
      read(luin,'(I8)') Nmode
    case ('PROP')
      read(luin,'(A)') basis
      call upCase(basis)
      if ((basis /= 'DET') .and. (basis /= 'CSF') .and. (basis /= 'SF') .and. (basis /= 'SO')) then
        call WarningMessage(2,'Unknown option for PROPagation basis')
        call abend()
      end if
    case ('NSTA')
      read(luin,*) Nstate,tryname
      call mma_allocate(istates,Nstate)
      call UpCase(tryname)
      if (tryname == 'ALL') then
        istates(:) = [(i,i=1,Nstate)]
      else
        backspace(luin)
        read(luin,*) Nstate,(istates(i),i=1,Nstate)
      end if
    case ('RUNM')
      read(luin,'(I8)') runmode
    case ('TOUT')
      read(luin,*) tout
      tout = tout/auToFs
    case ('INIT')
      read(luin,*) initialtime
      initialtime = initialtime/auToFs
    case ('FINA')
      read(luin,*) finaltime
      finaltime = finaltime/auToFs
    case ('TSTE')
      read(luin,*) timestep
      timestep = timestep/auToFs
    case ('METH')
      read(luin,*) method
      call upCase(method)
      if ((method /= 'RKCK') .and. (method /= 'RK45') .and. (method /= 'RK4') .and. (method /= 'RK5') .and. &
          (method /= 'CLASSIC_RK4')) then
        call WarningMessage(2,'Unknown option for METHod')
        call abend()
      end if
    case ('RK45')
      read(luin,*) errorthreshold
    case ('RKSA')
      read(luin,*) safety
    !case ('DELT')
    !  read(luin,*) deltaE
    !  deltaE = deltaE/auToCm
    !case ('VCOU')
    !  read(luin,*) V
    !  V = V/auToCm
    case ('AUGE')
      flag_decay = .true.
    case ('NVAL')
      read(luin,'(I8)') Nval
    case ('DECA')
      read(luin,*) N_L3,tau_L3
      read(luin,*) N_L2,tau_L2
      tau_L3 = tau_L3/autoev
      tau_L2 = tau_L2/autoev
      !tau_L3 = tau_L3/auToFs
      !tau_L2 = tau_L2/auToFs
    case ('DYSO')
      flag_dyson = .true.
    case ('ALPH')
      read(luin,*) alpha
    case ('IFDI')
      flag_diss = .true.
    case ('IOND')
      read(luin,*) ion_diss
    case ('GAMM')
      read(luin,*) cgamma
      cgamma = cgamma/auToCm
    case ('HRSO')
      HRSO = .true.
    case ('KEXT')
      kext = .true.
    case ('TFDM')
      read(luin,*) time_fdm
      time_fdm = time_fdm/auToFs
      flag_fdm = .true.
    case ('DMBA')
      read(luin,'(A)') dm_basis
      call upCase(dm_basis)
      if ((dm_basis /= 'CSF') .and. (dm_basis /= 'SF') .and. (dm_basis /= 'SO') .and. (dm_basis /= 'CSF_SF') .and. &
          (dm_basis /= 'SF_SO') .and. (dm_basis /= 'CSF_SO') .and. (dm_basis /= 'ALL')) then
        call WarningMessage(2,'Unknown option for DMBAsis')
        call abend()
      end if
    case ('DIPO')
      flag_dipole = .true.
    case ('EMIS')
      flag_emiss = .true.
    case ('NPUL')
      ! reading pulse characteristic.
      ! take care that NPULses keyword should be first one in input file
      ! otherwise further arrays for pulse are not allocated correctly
      read(luin,'(I8)') N_pulse
      if (N_pulse > 1) then
        call mma_deallocate(amp)
        call mma_deallocate(taushift)
        call mma_deallocate(pulse_vector)
        call mma_deallocate(sigma)
        call mma_deallocate(omega)
        call mma_deallocate(phi)
        call mma_allocate(taushift,N_pulse)
        call mma_allocate(amp,N_pulse)
        call mma_allocate(pulse_vector,N_pulse,3)
        call mma_allocate(sigma,N_pulse)
        call mma_allocate(omega,N_pulse)
        call mma_allocate(phi,N_pulse)
        do i=1,N_pulse
          amp(i) = Zero
          taushift(i) = Zero
          pulse_vector(i,1) = cOne
          pulse_vector(i,2) = cZero
          pulse_vector(i,3) = cZero
          sigma(i) = One/auToFs
          omega(i) = 710.0_wp/autoev
          phi(i) = Zero
        end do
      else if (N_pulse == 0) then
        flag_pulse = .false.
      end if
    case ('PTYP')
      read(luin,'(A)') pulse_type
      call upCase(pulse_type)
      if ((pulse_type(1:3) /= 'COS') .and. (pulse_type(1:3) /= 'SIN') .and. (pulse_type /= 'GAUSS') .and. (pulse_type /= 'MONO') &
          .and. (pulse_type /= 'MONO_R_CIRCLE') .and. (pulse_type /= 'GAUSS_L_CIRCLE') .and. (pulse_type /= 'GAUSS_R_CIRCLE') &
          .and. (pulse_type /= 'MONO_L_CIRCLE')) then
        call WarningMessage(2,'Unknown option for PTYPe')
        call abend()
      end if
      ! check which power has the shape in case of SIN^N or COS^N
      if ((pulse_type(1:3) == 'COS') .or. (pulse_type(1:3) == 'SIN')) then
        read(pulse_type(4:),*) power_shape
      end if
    case ('TAUS')
      read(luin,*) (taushift(i),i=1,N_pulse)
      taushift(:) = taushift/auToFs
    case ('AMPL')
      read(luin,*) (amp(i),i=1,N_pulse)
    case ('POLA')
      do i=1,N_pulse
        read(luin,*) (pulse_vector(i,j),j=1,3)
      end do
    case ('SIGM')
      read(luin,*) (sigma(i),i=1,N_pulse)
      sigma(:) = sigma/auToFs
      ! old value of sigma was underestimated by factor of pi/2
    case ('OMEG')
      read(luin,*) (omega(i),i=1,N_pulse)
      omega(:) = omega/autoev
    case ('PHAS')
      read(luin,*) (phi(i),i=1,N_pulse)
      phi(:) = phi*pi
    case ('CHIR')
      read(luin,*) linear_chirp
    case ('ACOR')
      flag_acorrection = .true.
    case ('END ')
      exit
    case default
      write(u6,*) 'The corresponding keyword: ',line,' is unknown!'
      call abend()
  end select
end do

if (ipglob > 1) then
  call dashes()
  write(u6,*) 'Input variables '
  call dashes()
  write(u6,sint) 'Number of spin manifolds:',N
  call dashes()
  write(u6,*) '      N       DET      CSF     STATES     SPIN'
  do i=1,N
    write(u6,'(5(i8,1x))') i,ndet(i),nconf(i),lroots(i),ispin(i)
  end do
  call dashes()
  write(u6,scha) 'State basis to be populated:',trim(p_style)
  write(u6,sint) 'Number of populated states:',n_populated
  if ((p_style == 'SO_THERMAL') .or. (p_style == 'SF_THERMAL')) then
    write(u6,sdbl) 'Temperature:',T
  end if
  write(u6,scha) 'Basis for propagation:',trim(basis)
  write(u6,sint) 'Number of states:',Nstate
  write(u6,sdbl) 'Initial time:',initialtime*auToFs
  write(u6,sdbl) 'Final time:',finaltime*auToFs
  write(u6,slog) 'SO coupling:',flag_so
  write(u6,slog) 'Auger Decay:',flag_decay
  write(u6,slog) 'Dissipation:',flag_diss
  write(u6,slog) 'Ionization: ',flag_dyson
  write(u6,slog) 'Pulse:',flag_pulse
  if (flag_diss) then
    !write(u6,sdbl) 'DeltaE:',         deltaE
    !write(u6,sdbl) 'Coupling (cm-1):',V
    write(u6,sdbl) 'Gamma (Hartree):',cgamma
  end if
  call dashes()
  write(u6,*) 'Pulse characteristics:'
  write(u6,sint) 'Number of pulses:',N_pulse
  call dashes()
  if (flag_pulse .and. (amp(1) /= Zero)) then
    do i=1,N_pulse
      write(u6,scha) 'Pulse type:',trim(pulse_type)
      write(u6,sint) 'Pulse # ',i
      write(u6,sdbl) 'Amp:',amp(i)
      write(u6,sdbl) 'Center:',taushift(i)*auToFs
      write(u6,scmp) 'Polarization x:',pulse_vector(i,1)
      write(u6,scmp) 'Polarization y:',pulse_vector(i,2)
      write(u6,scmp) 'Polarization z:',pulse_vector(i,3)
    end do
  end if
  call dashes()
end if
call close_luSpool(luin)

return

end subroutine read_input

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 1996-2006, T. Thorsteinsson and D. L. Cooper           *
************************************************************************
      subroutine o123b2_cvb(nparm,
     >  dx,eigvec,eigval,dxp,gradp,wrk,
     >  dxnrm)
      implicit real*8 (a-h,o-z)
#include "opt_cvb.fh"
#include "locopt1_cvb.fh"
#include "locopt2_cvb.fh"
#include "trst_cvb.fh"
#include "tune_cvb.fh"

      dimension dx(nparm)
      dimension eigvec(nparm,nparm),eigval(nparm)
      dimension dxp(nparm),gradp(nparm),wrk(nparm)
      save zero,one
      data zero/0.d0/,one/1d0/

      if(maxize)then
        nposeig=min(isaddle,nparm)
      else
        nposeig=max(nparm-isaddle,nparm)
      endif
      nnegeig=nparm-nposeig

      eigmx=-one
      eigmn=one
      if(nnegeig.gt.0)eigmx=eigval(nnegeig)
      if(nposeig.gt.0)eigmn=eigval(nnegeig+1)
      safety_use=safety
c200   continue
      if(eigmx.lt.-signtol.and.eigmn.gt.signtol)then
        alfastart=zero
      else
        alfastart=max(eigmx,-eigmn,zero)+safety_use
      endif
      call getdxp_cvb(dxp,gradp,eigval,nnegeig,nparm,alfastart)
      cnrm=dnrm2_(nparm,dxp,1)
c  Increased level shift not necessary when full Hessian is calculated :
c      if(alfastart.ne.zero)then
c        gnrm=dnrm2_(nparm,gradp,1)
c        if(cnrm.gt.1d-15.and.gnrm.gt.1d-15.and.safety_use.ne.1d-4)then
c          ovr_dx_grad=ddot_(nparm,dxp,1,gradp,1)/(cnrm*gnrm)
c          if(ovr_dx_grad.lt..3d0)then
c            safety_use=1d-4
c            goto 200
c          endif
c        endif
c      endif

      call makedx_cvb(dx,nparm,0,
     >  eigvec,eigval,dxp,gradp,wrk,
     >  .false.,.false.,nposeig,.false.,
     >  .false.,nnegeig,.false.,alfastart,eig)
      dxnrm=dnrm2_(nparm,dx,1)

      return
      end

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
************************************************************************
      SUBROUTINE SGMONE(ISGSTRUCT,ICISTRUCT,IXSTRUCT,
     &                  IP,IQ,CPQ,ISYCI,CI,SGM)
      IMPLICIT REAL*8 (A-H,O-Z)
#include "prgm.fh"
      CHARACTER*16 ROUTINE
      PARAMETER (ROUTINE='SGMONE')
      DIMENSION CI(*),SGM(*)
#include "Struct.fh"
      Dimension iSGStruct(nSGSize)
      Dimension iCIStruct(nCISize)
      Dimension iXStruct (nXSize)
#include "WrkSpc.fh"

      lISm  =iSGStruct(3)
      lNOCSF=iCIStruct(6)
      lIOCSF=iCIStruct(7)
      lNOW  =iCIStruct(3)
      lIOW  =iCIStruct(4)
      lNOCP =iXStruct(2)
      lIOCP =iXStruct(3)
      lICoup=iXStruct(5)
      lVTab =iXStruct(7)
      lMVL  =iXStruct(8)
      lMVR  =iXStruct(9)
      nMidV =iCIStruct(1)
      MxEO  =iXStruct(1)
      nVTab =iXStruct(6)
      nICoup=iXStruct(4)
      CALL SIGMA_1(ISGSTRUCT,ICISTRUCT,IXSTRUCT,
     &             NMIDV,MXEO,NVTAB,NICOUP,IWORK(LISM),
     &             IP,IQ,CPQ,ISYCI,CI,SGM,IWORK(LNOCSF),
     &             IWORK(LIOCSF),IWORK(LNOW),IWORK(LIOW),
     &             IWORK(LNOCP),IWORK(LIOCP),IWORK(LICOUP),
     &             WORK(LVTAB),IWORK(LMVL),IWORK(LMVR))

      return
      end

!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996, Anders Bernhardsson                              *
!***********************************************************************

subroutine Preciba(iB,iS,jS,nd,rOut,nba,focki,focka,fock,Sgn,A_J,A_K,Scr,nScr)
!***********************************************************************
!                                          [2]                         *
!     Calculates the diagonal submatrix of E    that couple            *
!                                                                      *
!     kappa           with   kappa                for a                *
!          kinactive,virtual        kinactive,active                   *
!                                                                      *
!     single inactive index.                                           *
!     Used for preconditioner.                                         *
!                                                                      *
!     See Olsen,Yeager, Joergensen:                                    *
!      "Optimization and characterization of an MCSCF state"           *
!                                                                      *
!     Called by prec                                                   *
!                                                                      *
!     ib,is       :       inactive index for the submatrix             *
!     js          :       symmetry of virtual,active                   *
!     rOut        :       Submatrix                                    *
!                                                                      *
!***********************************************************************

use Index_Functions, only: iTri, nTri_Elem
use MCLR_Data, only: G1t, nA
use input_mclr, only: nAsh, nBas, nIsh, nOrb
use Constants, only: Two, Four, Six
use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: iB, iS, jS, nd, nba, nScr
real(kind=wp), intent(inout) :: rOut(*)
real(kind=wp), intent(in) :: Focki(nba,nba), FockA(nba,nba), Fock(nba,nba), Sgn
real(kind=wp), intent(out) :: A_J(nScr), A_K(nScr), Scr(nScr)
integer(kind=iwp) :: ip, iVB, jA, jB, jBB, jVert, nO, nTri
real(kind=wp) :: rDens

!                                                                      *
!***********************************************************************
!                                                                      *
nTri = nTri_Elem(nd)
jVert = nOrb(jS)-nAsh(jS)-nIsh(jS)
nO = nAsh(jS)+nIsh(jS)
!                                                                      *
!***********************************************************************
!                                                                      *
! Get block J^(iB,iB)
call Coul(jS,jS,iS,iS,iB,iB,A_J,Scr)
! Get block K^(iB,iB)
call Exch(jS,iS,jS,iS,iB,iB,A_K,Scr)

do jA=1,nAsh(jS)
  ip = nTri-iTri(nd-ja+1,jVert)
  do jB=1,nAsh(jS)
    jBB = jB+nIsh(jS)
    ! Get D_(ja,jb)
    rDens = -Sgn*G1t((iTri(jA+nA(jS),jB+nA(jS))))
    if (jA == jB) rDens = rdens+Sgn*Two

    ivB = (jBB-1)*nBas(jS)+nO
    rOut(ip+1:ip+jVert) = rOut(ip+1:ip+jVert)+rDens*(Six*A_K(ivB+1:ivB+jVert)-Two*A_J(ivB+1:ivB+jVert))
  end do
end do
!                                                                      *
!***********************************************************************
!                                                                      *
do jA=1,nAsh(js)
  ip = nTri-iTri(nd-ja+1,nd-nAsh(js))
  rout(ip+1:ip+jVert) = rout(ip+1:ip+jVert)+Sgn*(Four*(FockI(nO+1:nO+jVert,ja+nIsh(js))+FockA(nO+1:nO+jVert,ja+nIsh(js)))- &
                                                 Fock(nO+1:nO+jVert,ja+nIsh(js)))
end do
!                                                                      *
!***********************************************************************
!                                                                      *

end subroutine Preciba

************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2006, Roland Lindh                                     *
************************************************************************
      SubRoutine Print_Geometry(iOpt)
************************************************************************
*                                                                      *
* Object: to print the molecular coordinates, bonds, angles and        *
*         torsional angles.                                            *
*                                                                      *
*     Author: Roland Lindh, Dept Chem. Phys., Lund University, Sweden  *
*             September 2006                                           *
************************************************************************
      use Basis_Info
      use Center_Info
      use Period
      use Temporary_Parameters, only: Expert
      use Sizes_of_Seward, only: S
      use Real_Info, only: Rtrnc
      use Symmetry_Info, only: nIrrep
      Implicit Real*8 (A-H,O-Z)
#include "Molcas.fh"
#include "real.fh"
#include "stdalloc.fh"
#include "print.fh"
      Character(LEN=1) help_c*1
      Character(LEN=16) FMT
      Character(LEN=LENIN), Allocatable:: Lblxxx(:)
      Real*8, Dimension (:,:), Allocatable :: Centr
#include "angstr.fh"
*                                                                      *
************************************************************************
*                                                                      *
      iRout=2
      iPrint = nPrint(iRout)
      If (iPrint.eq.0) Return
      LuWr=6
*                                                                      *
************************************************************************
*                                                                      *
      Call mma_allocate(Centr,3,S%mCentr,Label='Centr')
      Call mma_allocate(Lblxxx,S%mCentr,Label='Lblxxx')
*                                                                      *
************************************************************************
*                                                                      *

      Write (LuWr,*)
      Call CollapseOutput(1,'   Molecular structure info:')
      Write (LuWr,'(3X,A)') '   -------------------------'
      Write (LuWr,*)
      if(iOpt.eq.0) FMT='(19X,A)'
      if(iOpt.eq.1) FMT='(11X,A)'
*
      Write (LuWr,FMT)
     &       ' ************************************************ '
      if(iOpt.eq.0) then
      Write (LuWr,FMT)
     &       ' **** Cartesian Coordinates / Bohr, Angstrom **** '
      else
      Write (LuWr,FMT)
     &       ' **** Cartesian Coordinates / Angstrom       **** '
            endif
      Write (LuWr,FMT)
     &       ' ************************************************ '
      Write (LuWr,*)
      if(iOpt.eq.0) then
      Write (LuWr,'(A,A,A)')  '     Center  Label ',
     &             '               x              y              z',
     &  '                     x              y              z'
      else
      Write (LuWr,'(A,A,A)')  '     Center  Label ',
     &             '               x              y              z'
      endif
*                                                                      *
************************************************************************
*                                                                      *
      ndc = 0
      nc = 1
      Do jCnttp = 1, nCnttp
         mCnt = dbsc(jCnttp)%nCntr
         If (dbsc(jCnttp)%Aux.or.dbsc(jCnttp)%Frag)Then
            ndc = ndc + mCnt
            Go To 32
         End If
         Do jCnt = 1, mCnt
            ndc = ndc + 1
            x1 = dbsc(jCnttp)%Coor(1,jCnt)
            y1 = dbsc(jCnttp)%Coor(2,jCnt)
            z1 = dbsc(jCnttp)%Coor(3,jCnt)
            Do i = 0, nIrrep/dc(ndc)%nStab - 1
               Call OA(dc(ndc)%iCoSet(i,0),dbsc(jCnttp)%Coor(1:3,jCnt),
     &                 Centr(1:3,nc))
               If (Show) Then
                  help_c = ' '
                  If(Cell_l) Then
                     Do j=1,lthCell
                         If(AdCell(j).EQ.ndc) help_c = '*'
                     End Do
                  End If
                  if(iOpt.eq.0) then
                     Write (LuWr,
     &                   '(6X,I3,A1,5X,A,3F15.6,7X,3F15.6)')
     &                    nc, help_c, dc(ndc)%LblCnt,
     &                    Centr(1:3,nc),
     &                    Centr(1:3,nc)*angstr
                  else
                     Write (LuWr,
     &                   '(6X,I3,A1,5X,A,3F15.6)')
     &                    nc, help_c, dc(ndc)%LblCnt,
     &                    Centr(1:3,nc)*angstr
                  endif
               End If
               nchr=dbsc(jCnttp)%AtmNr
               if (nc.gt.8*MxAtom) Then
                  Call WarningMessage(2,'lblxxx too small')
                  Call Abend()
               End If
               lblxxx(nc)=dc(ndc)%LblCnt(1:LENIN)
               nc = nc + 1
            End Do
         End Do
32       Continue
      End Do
      nc=nc-1
*                                                                      *
************************************************************************
*                                                                      *
*     Compute distances
*
      If (S%mCentr.le.2) Go To 55
      Call Dstncs(lblxxx,Centr,nc,angstr,S%Max_Center,6)
      If (.Not.Expert) Call DstChk(Centr,lblxxx,nc)
*
*     Compute valence bond angels
*
      If (iPrint.lt.5.or.S%mCentr.lt.3.or.iOpt.eq.1) Go To 55
      Call Angles(lblxxx,Centr,nc,rtrnc,S%Max_Center)
*
*     Compute dihedral angles
*
      If (iPrint.lt.5.or.S%mCentr.lt.4) Go To 55
      Call Dihedr(lblxxx,Centr,nc,rtrnc,S%Max_Center)
*                                                                      *
************************************************************************
*                                                                      *
 55   Continue
*
      Call mma_deallocate(Lblxxx)
      Call mma_deallocate(Centr)
*                                                                      *
************************************************************************
*                                                                      *
      Call CollapseOutput(0,'   Molecular structure info:')
      Write (LuWr,*)
      Return
      End

#!/bin/bash

tmpdir="$(mktemp -d)"
cd "${tmpdir}"

cleanup () {
    rm -rf "${tmpdir}"
}

trap cleanup EXIT

pymolcas verify standard:000-002,004-006,009-012,014-016,019,023,025,026,028,029 hdf5:601 --status

if [ $? != 0 ]; then
    for i in $(cat failed/list | sed s/.input//); do
        i=$(basename $i)
        echo "----> $i.err:"
        cat failed/*_$i.err
        echo "----> $i.out:"
        tail -50 failed/*_$i.out
    done
    exit 1
fi

#!/bin/bash

cd .. && pymolcas verify standard:000-002,004-006,009-012,014-016,019,023,025,026,028,029 --status
if [ $? != 0 ]; then
    for i in $(basename `cat failed/list` | sed s/.input//); do
        echo "----> $i.err:"
        cat failed/*_$i.err
        echo "----> $i.out:"
        tail -50 failed/*_$i.out
    done
    exit 1
fi

#!/bin/bash

tmpdir="$(mktemp -d)"
cd "${tmpdir}"

cleanup () {
    rm -rf "${tmpdir}"
}

trap cleanup EXIT

pymolcas verify standard:000-002,004-006,009-012,014-015,019,023,025,026,028,029 hdf5:601 --status

if [ $? != 0 ]; then
    for i in $(cat failed/list | sed s/.input//); do
        i=$(basename $i)
        echo "----> $i.err:"
        cat failed/*_$i.err
        echo "----> $i.out:"
        tail -50 failed/*_$i.out
    done
    exit 1
fi

#!/bin/bash
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2020-2022, Bruno Tenorio                               *
#***********************************************************************
# Get the spectrum from the processed Auger_OCA.* files. 
# inputs: OCA outputs in a folder
# output: spectrum.out file

# How to use:

#$ bash oca.spectrum.sh auger_outputs/ &

# where 'auger_outputs' is the directory containing the OCA output files Auger_OCA.*
# alternatively, simply use "--spec" option >> auger_main.py --spec
ORIG_DIR=$PWD
OUTDIR=$1

# Collect BE & Intensities into -> spectrum.out
for f in $(ls $OUTDIR/Auger_OCA.*); do grep "Spectrum: BE(eV) and Intensity" $f >> tmp.spectrum.out; done
cat tmp.spectrum.out | cut -b 1-42 --complement >> spectrum.out
rm tmp.spectrum.out

#!/bin/sh
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

# This compiles pymolcas into an executable file that can be copied around. It
# still needs a python installation to run, but it's not possible to recover the
# original files (as far as I know). Thus, this may be a way to obfuscate the
# code into something that's not so easily modifiable.

nuitka --python-version=3.4 --remove-output \
       --recurse-to=abstract_flow \
       --recurse-to=emil_grammar \
       --recurse-to=emil_parse \
       --recurse-to=molcas_aux \
       --recurse-to=molcas_wrapper \
       --recurse-to=python_parse \
       --recurse-to=simpleeval \
       --recurse-to=tee \
       --recurse-to=check_test \
       --recurse-to=validate \
       --recurse-to=write_molcasrc \
       pymolcas.py

rm -rf __pycache__

#!/bin/sh
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

# current driver version
if [ -z "$1" ] ; then
  driver_file="sbin/molcas.driver"
else
  driver_file="$1"
fi
if [ -f $driver_file ] ; then
  current_version=`sed -ne 's/\.// ; s/.*Molcas driver shell script version // p' $driver_file`
else
  echo "*** $driver_file does not exist"
  exit 1
fi

MOLCASDRIVER=""

# check location of driver script in your PATH
installed=0

orig_IFS=$IFS
IFS=':'
for x in $PATH; do
  if [ -f "$x/molcas" ]; then
    l=`sed -ne 's/\.// ; s/.*Molcas driver shell script version // p' "$x/molcas"`
    if [ "$l" -lt "$current_version" ]; then
      echo "*** Warning! An old version of the molcas driver script was found at: $x"
    else
      echo "Molcas driver has been found at: $x"
      installed=1
    fi
    MOLCASDRIVER="$x"
    break
  fi
done

# latest version already installed, exit
if [ $installed = 1 ] ; then
  exit 0
fi

# try to find proper location for molcas driver
if [ -z "$MOLCASDRIVER" ]; then
  # no existing version found, use default PATH
  if [ -z "$PATH" ]; then
    E_PATH="$HOME/bin"
  else
    E_PATH="$HOME/bin:$PATH"
  fi
else
  # a previous version was found, create it there
  E_PATH="$MOLCASDRIVER"
fi

# find first writable directory
dir_found=0
for x in $E_PATH ; do
  if [ "$x" = "." ] ; then continue ; fi
  # detect if directory is writable (-w would not work, since it does not handle mount permissions)
  cp "$driver_file" "$x/this_is_not_molcas" > /dev/null 2>&1
  if [ "$?" = 0 ] ; then
    rm -f "$x/this_is_not_molcas" > /dev/null 2>&1
    MOLCASDRIVER="$x"
    dir_found=1
    break
  fi
done
IFS=$orig_IFS

# are we in interactive mode?
if [ "$CMAKE_SESSION" = "OpenMolcas" ] ; then
  INTERACTIVE=0
elif ( ! tty -s ) ; then
  INTERACTIVE=0
else
  INTERACTIVE=1
fi

# function to read with timeout in POSIX sh
read_timeout() {
  old=$(stty -g)
  stty -icanon min 0 time 255
  read $1
  stty $old
}

# create a default molcas driver
if [ $dir_found = 0 ] ; then
  echo "*** Warning! Could not find a proper directory to install the molcas driver"
  echo ""
  echo "*** Check that there is a directory in your PATH with write access"
  echo "*** (for example $HOME/bin) and restart the installation"
  echo ""
  echo "*** You have to put the molcas driver in any directory in your PATH"
  if [ "$INTERACTIVE" = "0" ] ; then
    exit 1
  fi
else
  echo "molcas driver will be installed in $MOLCASDRIVER"
  echo "Is this OK? [Y/n] (will assume \"Yes\" in 25 seconds)"
  while true; do
    if [ "$INTERACTIVE" = "0" ] ; then
      echo "Running in non-interactive mode, assuming \"Yes\""
      answer="Yes"
    else
      read_timeout answer
    fi
    case "${answer}_" in
      [Yy]*|_ )
        cp "$driver_file" "$MOLCASDRIVER/molcas"
        chmod +x "$MOLCASDRIVER/molcas"
        # check again the driver was installed
        l=`sed -ne 's/\.// ; s/.*Molcas driver shell script version // p' "$x/molcas"`
        if [ "$l" -eq "$current_version" -a -x "$MOLCASDRIVER/molcas" ] ; then
          echo "Driver installation successful"
        else
          echo "*** Driver installation failed!"
          echo ""
          echo "*** You have to put the molcas driver in any directory in your PATH"
          if [ "$INTERACTIVE" = "0" ] ; then
            exit 2
          fi
        fi
        break ;;
      [Nn]* )
        echo "*** Driver installation canceled!"
        echo ""
        echo "*** You have to put the molcas driver in any directory in your PATH"
        if [ "$INTERACTIVE" = "0" ] ; then
          exit 3
        fi
        break ;;
      * ) echo "Please answer yes or no"
    esac
  done
fi

exit 0

#!/bin/bash

export MOLCAS_MAXITER=50
export MOLCAS_OUTPUT=NAME

export BASIS="STO-3G"
export OPTS=""
export SCFTYPE=""

for mol in {01..33}*.xyz ; do
  export Project=$(basename ${mol} .xyz)
  echo Running ${Project} ...
  export XYZ=${mol}
  export SCF=${SCFTYPE}

  case "${Project}" in
    *histamine_H+)
      export SCF="${SCF}"$'\n'"Charge = 1"
      ;;
  esac

  pymolcas opt.input -oe ${Project}.output -b 1
done

#!/bin/bash

export MOLCAS_MAXITER=50
export MOLCAS_OUTPUT=NAME

export BASIS="3-21G"
export OPTS=""
export SCFTYPE=""
export SLAPAF_OPT="FindTS"

for mol in {01..25}*.xyz ; do
  export Project=$(basename ${mol} .xyz)
  echo Running ${Project} ...
  export XYZ=${mol}
  export SCF=${SCFTYPE}
  export SLAPAF=${SLAPAF_OPT}

  case "${Project}" in
    *CH3O_CH2OH)
      export SCF="${SCF}"$'\n'"UHF"
      ;;
    *cyclopropyl)
      export SCF="${SCF}"$'\n'"UHF"
      ;;
    *beta-formyloxy_ethyl)
      export SCF="${SCF}"$'\n'"UHF"
      ;;
    *H2O_PO3-_H2PO4-)
      export SCF="${SCF}"$'\n'"Charge = -1"
      ;;
    *HCONH3+_NH4+_CO)
      export SCF="${SCF}"$'\n'"Charge = +1"
      ;;
  esac

  case "${Project}" in
    *CH3O_CH2OH)
      export SLAPAF="${SLAPAF}"$'\n'"Gnrm = 0.1"
      ;;
    *beta-formyloxy_ethyl)
      export SLAPAF="${SLAPAF}"$'\n'"Cartesian"
      ;;
    *s-tetrazine_2HCN_N2)
      export SLAPAF="${SLAPAF}"$'\n'"Cartesian"
      ;;
    *HCOCl_HCl_CO)
      export SLAPAF="${SLAPAF}"$'\n'"Gnrm = 0.3"
      ;;
    *H2O_PO3-_H2PO4-)
      export SLAPAF="${SLAPAF}"$'\n'"Gnrm = 0.3"$'\n'"MaxStep = 0.15"
      ;;
    *HCONHOH_HCOHNOH)
      export SLAPAF="${SLAPAF}"$'\n'"Gnrm = 0.1"$'\n'"MaxStep = 0.1"
      ;;
  esac

  if [ -f ${Project}.cons ] ; then
    export SLAPAF="${SLAPAF}"$'\n'"$(< ${Project}.cons)"
  fi

  pymolcas opt.input -oe ${Project}.output -b 1
done

#!/bin/sh
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#                                                                      *
# Copyright (C) 2020, Ignacio Fdez. Galván                             *
#***********************************************************************

# Script to ...
#

if [ -z "$MOLCAS" ] ; then
  MOLCAS=$PWD
fi

export MOLCAS

DEST=$1
if [ -d "$DEST" ] && [ -w "$DEST" ] ; then
  true
else
  echo "$DEST is not writable directory"
  exit 1
fi

for dir in `$MOLCAS/sbin/verify --group | awk -F "= " '/^Physical/,/^Special/ {print $2}'` ; do
  echo "Copying tests from $dir"
  cp -a "$dir" "$DEST"
done

#!/bin/bash

#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

# Preprocess file
cat $1 | \
  # Fix case of automatic links
  ./fix_links.py | \
  # Disable #include directives (using "C" to avoid mis-detection as free format)
  sed -e 's/^#include/Cinclude/' -e 's/^[*cC!]/C/' | \
  # Preprocess with cpp
  #cpp -undef -w -fdirectives-only -dU -P -nostdinc
  # Preprocess with gpp
  gpp -n -U "" "" "(" "," ")" "(" ")" "#" "" -M "\n#\w" "\n" " " " " "\n" "" ""

#!/bin/bash
#***********************************************************************
# This file is part of OpenMolcas.                                     *
#                                                                      *
# OpenMolcas is free software; you can redistribute it and/or modify   *
# it under the terms of the GNU Lesser General Public License, v. 2.1. *
# OpenMolcas is distributed in the hope that it will be useful, but it *
# is provided "as is" and without any express or implied warranties.   *
# For more details see the full text of the license in the file        *
# LICENSE or in <http://www.gnu.org/licenses/>.                        *
#***********************************************************************

# This is a small script to download QCMaquis and its components from the SCINE website
# with curl, i.e., without a graphical browser.

url=$1 # should be: https://scine.ethz.ch/download/ under normal circumstances (note the trailing slash!)
package=$2 # choose from: dmrg dmrg_interface_utils hdf5_qcm nevpt2
first_name="$3" # Your first name
last_name="$4" # Your last name
email="$5" # Your e-mail address

# Visit the download page in order to retrive a correct CSRF token
curl -s -L -X GET -c cookies.txt $url > /dev/null
csrf_token=`grep 'csrftoken' cookies.txt | awk '{print $7}'`

# Send a valid post request; note that is is also necessary to set the correct referer with "-e"
curl -s -L -X POST -b cookies.txt -e "$url" -F "first_name=${first_name}" -F "last_name=${last_name}" -F "email=${email}" -F 'eula_accepted=on' -F "package=qcmaquis_${package}" -F "csrfmiddlewaretoken=${csrf_token}" ${url} -o ${package}.tar.bz2 > /dev/null

if [ -f cookies.txt ]; then
  rm cookies.txt
fi

# Check the download integrity
bzip2 -t ${package}.tar.bz2
if [ $? -ne 0 ]; then
  echo "Download of ${package} failed." 1>&2
  exit 1
fi

Attribution
===========

If you add a new file, please include the OpenMolcas header and copyright
information, for example:

```
************************************************************************
* This file is part of OpenMolcas.                                     *
*                                                                      *
* OpenMolcas is free software; you can redistribute it and/or modify   *
* it under the terms of the GNU Lesser General Public License, v. 2.1. *
* OpenMolcas is distributed in the hope that it will be useful, but it *
* is provided "as is" and without any express or implied warranties.   *
* For more details see the full text of the license in the file        *
* LICENSE or in <http://www.gnu.org/licenses/>.                        *
*                                                                      *
* Copyright (C) 2014,2016, John Doe                                    *
*               2017, Jane Doe                                         *
************************************************************************
```

* Use full names when possible
* Use a single line for each author, and a single author on each line
* Include all years where modifications were done, use ranges only if there
  were modifications in all the intermediate years.

If you modify an existing file, and the modification is significant enough, add
your name to the header in the same format, or the year if your name is already
there. What exactly is "significant enough" is rather subjective; changing a
format to print more decimal figures is probably not, rearranging the loop
structure can be. It is up to you to decide whether or not your modifications
are significant enough.

If you copy a file, copy the header too, and then do as above if you modify it.
Do not remove any name unless you are absolutely sure that all contributions by
that person have been removed from the file.

You can include more detailed information about yourself, the origin of any
external code, the nature of the modifications, etc. below the header.

Finally, add any new names to the list in `CONTRIBUTORS.md`. Note that in order
to maintain the formatting with online tools (see
[here](https://gitlab.com/Molcas/OpenMolcas/blob/master/CONTRIBUTORS.md)), each
name is a separate line that *ends with two spaces*. The list is sorted
alphabetically by last name (using "international" sorting order, where Á = A,
Ö = O etc.).


Commit messages
===============

When writing commit messages with `git`, try to be informative but brief. The
best is to follow a simple format (see
[here](https://chris.beams.io/posts/git-commit/)):

1. One line with a short title.
2. A blank line.
3. Some explanation of what was modified and why it was needed or useful.

For example:

```
Start work on new_shiny_feature

The old_dull_feature has some limitations, this new_shiny_feature
will solve them. For the moment just add a dummy keyword.
```

In many tools and on the [online
viewer](https://gitlab.com/Molcas/OpenMolcas/commits/master) only the first
line is displayed by default and the rest of the message is available if
desired.

OpenMolcas
==========

OpenMolcas is free software: you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, version 2.1.

OpenMolcas is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with OpenMolcas. If not, see <http://www.gnu.org/licenses/>.

Copyright (C) 1989-2020, The OpenMolcas Authors


NOTE: Some of the files distributed with OpenMolcas may be subject to a more
permissive or otherwise compatible license. Some of the files from external
sources may be subject to a more restrictive or otherwise incompatible license.


General citations
=================

* **OpenMolcas**:
  *J. Chem. Theory Comput.* **15** (2019) 5925-5964. [doi:10.1021/acs.jctc.9b00532](https://doi.org/10.1021/acs.jctc.9b00532)

* **Molcas 8**:
  *J. Comput. Chem.* **37** (2016) 506-541. [doi:10.1002/jcc.24221](https://doi.org/10.1002/jcc.24221)

* **Molcas 7**:
  *J. Comput. Chem.* **31** (2010) 224-247. [doi:10.1002/jcc.21318](https://doi.org/10.1002/jcc.21318)

* **Molcas 6**:
  *Comput. Mat. Sci.* **28** (2003) 222-239. [doi:10.1016/S0927-0256(03)00109-5](https://doi.org/10.1016/S0927-0256(03)00109-5)

* **Code development**:
  *Wiley Interdiscip. Rev. Comput. Mol. Sci.* **3** (2013) 143-149. [doi:10.1002/wcms.1117](https://doi.org/10.1002/wcms.1117);
  *Int. J. Quantum Chem.* **100** (2004) 626-635. [doi:10.1002/qua.20166](https://doi.org/10.1002/qua.20166)


Contributors
============

The following is a list of people who have contributed at some point to the
code of OpenMolcas. They are hereby acknowledged and collectively identified as
"The OpenMolcas Authors".

Christian Ander  
Kerstin Andersson  
János G. Ángyán  
Imaad Ansari  
Francesco Aquilante  
Jochen Autschbach  
Jie J. Bao  
Maria Barysz  
Stefano Battaglia  
Eugeniusz Bednarz  
Nelson H. F. Beebe  
Anders Bernhardsson  
Margareta R. A. Blomberg  
Piotr Borowski  
Jonas Boström  
Per Boussard  
John Burkardt  
Yannick Carissan  
Liviu Chibotaru  
Christophe Chipot  
Aron Cohen  
David L. Cooper  
Maurizio Cossi  
Joel Creutzberg  
Oleh Danyliv  
Mickaël G. Delcey  
Ajitha Devarajan  
Luca De Vico  
Michael Diedenhofen  
Sijia S. Dong  
Thomas Dresselhaus  
Daniel Fairhead  
Ignacio Fdez. Galván  
Nicolas Ferré  
Timo Fleig  
Leon Freitag  
Luis Manuel Frutos  
Markus P. Fülscher  
Alexander Gaenko  
Laura Gagliardi  
Walter Gautschi  
Giovanni Ghigo  
Coen de Graaf  
Gene H. Golub  
Sergey Gusarov  
Daniel Hagberg  
Jun-ya Hasegawa  
Matthew R. Hermes  
José Manuel Hermida-Ramón  
Bernd Artur Heß  
Asbjørn Holt  
Chad E. Hoyer  
Denis Jelovina  
Marcus Johansson  
Erik Källman  
Gunnar Karlström  
Stefan Knecht  
Jesper Wisborg Krogh  
Teodoro Laino  
Giovanni Li Manni  
Roland Lindh  
Johan Lorentzon  
Dongxia Ma  
Yingjin Ma  
Per Åke Malmqvist  
Neil Martinsen-Burrell  
Andy May  
Manuela Merchán  
Samuel Mikes  
Abdul Rehaman Moughal Shahi  
Thomas Müller  
Takahito Nakajima  
Naoki Nakatani  
Pavel Neogrády  
Jesper Norell  
Anders Öhrn  
Jeppe Olsen  
Markus Oppel  
Thomas Bondo Pedersen  
Daoling Peng  
Kurt Pfingst  
Quan Phung  
Michal Pitoňák  
Felix Plasser  
Christian Pomelli  
Ben Pritchard  
Juraj Raab  
Gerardo Raggi  
Markus Reiher  
H. Rieger  
Björn O. Roos  
Ulf Ryde  
Pawel Salek  
Andrew M. Sand  
Michael A. Saunders  
Igor Schapiro  
Bernd Schimmelpfennig  
Martin Schütz  
Thais Scott  
Luis Seijo  
Luis Serrano-Andrés  
Kamal Sharkas  
Grigory A. Shamov  
Prachi Sharma  
Per E. M. Siegbahn  
Pär Söderhjelm  
Lasse Kragh Sørensen  
Jonna Stålring  
Hermann Stoll  
Bingbing Suo  
Ben Swerts  
Akio Takatsuka  
Thorstein Thorsteinsson  
Takashi Tsuchiya  
Liviu Ungur  
Morgane Vacher  
Alessio Valentini  
Valérie Vallet  
Steven Vancoillie  
Valera Veryazov  
Victor P. Vysotskiy  
Ulf Wahlgren  
Yubin Wang  
Mark A. Watson  
Hans-Joachim Werner  
Oskar Weser  
Per-Olof Widmark  
Małgorzata Wierzbowska  
Alexander Wolf  
Sebastian Wouters  
Felipe Zapata  
Alexander Zech  
Yan Zhao  
J. Patrick Zobel  
